#!/usr/bin/env node
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/error.js
var require_error = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/error.js"(exports) {
    var CommanderError = class extends Error {
      constructor(exitCode, code, message) {
        super(message);
        Error.captureStackTrace(this, this.constructor);
        this.name = this.constructor.name;
        this.code = code;
        this.exitCode = exitCode;
        this.nestedError = void 0;
      }
    };
    var InvalidArgumentError = class extends CommanderError {
      constructor(message) {
        super(1, "commander.invalidArgument", message);
        Error.captureStackTrace(this, this.constructor);
        this.name = this.constructor.name;
      }
    };
    exports.CommanderError = CommanderError;
    exports.InvalidArgumentError = InvalidArgumentError;
  }
});

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/argument.js
var require_argument = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/argument.js"(exports) {
    var { InvalidArgumentError } = require_error();
    var Argument = class {
      constructor(name, description) {
        this.description = description || "";
        this.variadic = false;
        this.parseArg = void 0;
        this.defaultValue = void 0;
        this.defaultValueDescription = void 0;
        this.argChoices = void 0;
        switch (name[0]) {
          case "<":
            this.required = true;
            this._name = name.slice(1, -1);
            break;
          case "[":
            this.required = false;
            this._name = name.slice(1, -1);
            break;
          default:
            this.required = true;
            this._name = name;
            break;
        }
        if (this._name.length > 3 && this._name.slice(-3) === "...") {
          this.variadic = true;
          this._name = this._name.slice(0, -3);
        }
      }
      name() {
        return this._name;
      }
      _concatValue(value, previous) {
        if (previous === this.defaultValue || !Array.isArray(previous)) {
          return [value];
        }
        return previous.concat(value);
      }
      default(value, description) {
        this.defaultValue = value;
        this.defaultValueDescription = description;
        return this;
      }
      argParser(fn) {
        this.parseArg = fn;
        return this;
      }
      choices(values) {
        this.argChoices = values;
        this.parseArg = (arg, previous) => {
          if (!values.includes(arg)) {
            throw new InvalidArgumentError(`Allowed choices are ${values.join(", ")}.`);
          }
          if (this.variadic) {
            return this._concatValue(arg, previous);
          }
          return arg;
        };
        return this;
      }
      argRequired() {
        this.required = true;
        return this;
      }
      argOptional() {
        this.required = false;
        return this;
      }
    };
    function humanReadableArgName(arg) {
      const nameOutput = arg.name() + (arg.variadic === true ? "..." : "");
      return arg.required ? "<" + nameOutput + ">" : "[" + nameOutput + "]";
    }
    exports.Argument = Argument;
    exports.humanReadableArgName = humanReadableArgName;
  }
});

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/help.js
var require_help = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/help.js"(exports) {
    var { humanReadableArgName } = require_argument();
    var Help = class {
      constructor() {
        this.helpWidth = void 0;
        this.sortSubcommands = false;
        this.sortOptions = false;
      }
      visibleCommands(cmd) {
        const visibleCommands = cmd.commands.filter((cmd2) => !cmd2._hidden);
        if (cmd._hasImplicitHelpCommand()) {
          const [, helpName, helpArgs] = cmd._helpCommandnameAndArgs.match(/([^ ]+) *(.*)/);
          const helpCommand = cmd.createCommand(helpName).helpOption(false);
          helpCommand.description(cmd._helpCommandDescription);
          if (helpArgs)
            helpCommand.arguments(helpArgs);
          visibleCommands.push(helpCommand);
        }
        if (this.sortSubcommands) {
          visibleCommands.sort((a, b) => {
            return a.name().localeCompare(b.name());
          });
        }
        return visibleCommands;
      }
      visibleOptions(cmd) {
        const visibleOptions = cmd.options.filter((option) => !option.hidden);
        const showShortHelpFlag = cmd._hasHelpOption && cmd._helpShortFlag && !cmd._findOption(cmd._helpShortFlag);
        const showLongHelpFlag = cmd._hasHelpOption && !cmd._findOption(cmd._helpLongFlag);
        if (showShortHelpFlag || showLongHelpFlag) {
          let helpOption;
          if (!showShortHelpFlag) {
            helpOption = cmd.createOption(cmd._helpLongFlag, cmd._helpDescription);
          } else if (!showLongHelpFlag) {
            helpOption = cmd.createOption(cmd._helpShortFlag, cmd._helpDescription);
          } else {
            helpOption = cmd.createOption(cmd._helpFlags, cmd._helpDescription);
          }
          visibleOptions.push(helpOption);
        }
        if (this.sortOptions) {
          const getSortKey = (option) => {
            return option.short ? option.short.replace(/^-/, "") : option.long.replace(/^--/, "");
          };
          visibleOptions.sort((a, b) => {
            return getSortKey(a).localeCompare(getSortKey(b));
          });
        }
        return visibleOptions;
      }
      visibleArguments(cmd) {
        if (cmd._argsDescription) {
          cmd._args.forEach((argument) => {
            argument.description = argument.description || cmd._argsDescription[argument.name()] || "";
          });
        }
        if (cmd._args.find((argument) => argument.description)) {
          return cmd._args;
        }
        ;
        return [];
      }
      subcommandTerm(cmd) {
        const args = cmd._args.map((arg) => humanReadableArgName(arg)).join(" ");
        return cmd._name + (cmd._aliases[0] ? "|" + cmd._aliases[0] : "") + (cmd.options.length ? " [options]" : "") + (args ? " " + args : "");
      }
      optionTerm(option) {
        return option.flags;
      }
      argumentTerm(argument) {
        return argument.name();
      }
      longestSubcommandTermLength(cmd, helper) {
        return helper.visibleCommands(cmd).reduce((max, command) => {
          return Math.max(max, helper.subcommandTerm(command).length);
        }, 0);
      }
      longestOptionTermLength(cmd, helper) {
        return helper.visibleOptions(cmd).reduce((max, option) => {
          return Math.max(max, helper.optionTerm(option).length);
        }, 0);
      }
      longestArgumentTermLength(cmd, helper) {
        return helper.visibleArguments(cmd).reduce((max, argument) => {
          return Math.max(max, helper.argumentTerm(argument).length);
        }, 0);
      }
      commandUsage(cmd) {
        let cmdName = cmd._name;
        if (cmd._aliases[0]) {
          cmdName = cmdName + "|" + cmd._aliases[0];
        }
        let parentCmdNames = "";
        for (let parentCmd = cmd.parent; parentCmd; parentCmd = parentCmd.parent) {
          parentCmdNames = parentCmd.name() + " " + parentCmdNames;
        }
        return parentCmdNames + cmdName + " " + cmd.usage();
      }
      commandDescription(cmd) {
        return cmd.description();
      }
      subcommandDescription(cmd) {
        return cmd.description();
      }
      optionDescription(option) {
        const extraInfo = [];
        if (option.argChoices && !option.negate) {
          extraInfo.push(`choices: ${option.argChoices.map((choice) => JSON.stringify(choice)).join(", ")}`);
        }
        if (option.defaultValue !== void 0 && !option.negate) {
          extraInfo.push(`default: ${option.defaultValueDescription || JSON.stringify(option.defaultValue)}`);
        }
        if (option.envVar !== void 0) {
          extraInfo.push(`env: ${option.envVar}`);
        }
        if (extraInfo.length > 0) {
          return `${option.description} (${extraInfo.join(", ")})`;
        }
        return option.description;
      }
      argumentDescription(argument) {
        const extraInfo = [];
        if (argument.argChoices) {
          extraInfo.push(`choices: ${argument.argChoices.map((choice) => JSON.stringify(choice)).join(", ")}`);
        }
        if (argument.defaultValue !== void 0) {
          extraInfo.push(`default: ${argument.defaultValueDescription || JSON.stringify(argument.defaultValue)}`);
        }
        if (extraInfo.length > 0) {
          const extraDescripton = `(${extraInfo.join(", ")})`;
          if (argument.description) {
            return `${argument.description} ${extraDescripton}`;
          }
          return extraDescripton;
        }
        return argument.description;
      }
      formatHelp(cmd, helper) {
        const termWidth = helper.padWidth(cmd, helper);
        const helpWidth = helper.helpWidth || 80;
        const itemIndentWidth = 2;
        const itemSeparatorWidth = 2;
        function formatItem(term, description) {
          if (description) {
            const fullText = `${term.padEnd(termWidth + itemSeparatorWidth)}${description}`;
            return helper.wrap(fullText, helpWidth - itemIndentWidth, termWidth + itemSeparatorWidth);
          }
          return term;
        }
        ;
        function formatList(textArray) {
          return textArray.join("\n").replace(/^/gm, " ".repeat(itemIndentWidth));
        }
        let output = [`Usage: ${helper.commandUsage(cmd)}`, ""];
        const commandDescription = helper.commandDescription(cmd);
        if (commandDescription.length > 0) {
          output = output.concat([commandDescription, ""]);
        }
        const argumentList = helper.visibleArguments(cmd).map((argument) => {
          return formatItem(helper.argumentTerm(argument), helper.argumentDescription(argument));
        });
        if (argumentList.length > 0) {
          output = output.concat(["Arguments:", formatList(argumentList), ""]);
        }
        const optionList = helper.visibleOptions(cmd).map((option) => {
          return formatItem(helper.optionTerm(option), helper.optionDescription(option));
        });
        if (optionList.length > 0) {
          output = output.concat(["Options:", formatList(optionList), ""]);
        }
        const commandList = helper.visibleCommands(cmd).map((cmd2) => {
          return formatItem(helper.subcommandTerm(cmd2), helper.subcommandDescription(cmd2));
        });
        if (commandList.length > 0) {
          output = output.concat(["Commands:", formatList(commandList), ""]);
        }
        return output.join("\n");
      }
      padWidth(cmd, helper) {
        return Math.max(helper.longestOptionTermLength(cmd, helper), helper.longestSubcommandTermLength(cmd, helper), helper.longestArgumentTermLength(cmd, helper));
      }
      wrap(str2, width, indent, minColumnWidth = 40) {
        if (str2.match(/[\n]\s+/))
          return str2;
        const columnWidth = width - indent;
        if (columnWidth < minColumnWidth)
          return str2;
        const leadingStr = str2.substr(0, indent);
        const columnText = str2.substr(indent);
        const indentString2 = " ".repeat(indent);
        const regex = new RegExp(".{1," + (columnWidth - 1) + "}([\\s\u200B]|$)|[^\\s\u200B]+?([\\s\u200B]|$)", "g");
        const lines = columnText.match(regex) || [];
        return leadingStr + lines.map((line, i) => {
          if (line.slice(-1) === "\n") {
            line = line.slice(0, line.length - 1);
          }
          return (i > 0 ? indentString2 : "") + line.trimRight();
        }).join("\n");
      }
    };
    exports.Help = Help;
  }
});

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/option.js
var require_option = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/option.js"(exports) {
    var { InvalidArgumentError } = require_error();
    var Option = class {
      constructor(flags, description) {
        this.flags = flags;
        this.description = description || "";
        this.required = flags.includes("<");
        this.optional = flags.includes("[");
        this.variadic = /\w\.\.\.[>\]]$/.test(flags);
        this.mandatory = false;
        const optionFlags = splitOptionFlags(flags);
        this.short = optionFlags.shortFlag;
        this.long = optionFlags.longFlag;
        this.negate = false;
        if (this.long) {
          this.negate = this.long.startsWith("--no-");
        }
        this.defaultValue = void 0;
        this.defaultValueDescription = void 0;
        this.envVar = void 0;
        this.parseArg = void 0;
        this.hidden = false;
        this.argChoices = void 0;
      }
      default(value, description) {
        this.defaultValue = value;
        this.defaultValueDescription = description;
        return this;
      }
      env(name) {
        this.envVar = name;
        return this;
      }
      argParser(fn) {
        this.parseArg = fn;
        return this;
      }
      makeOptionMandatory(mandatory = true) {
        this.mandatory = !!mandatory;
        return this;
      }
      hideHelp(hide = true) {
        this.hidden = !!hide;
        return this;
      }
      _concatValue(value, previous) {
        if (previous === this.defaultValue || !Array.isArray(previous)) {
          return [value];
        }
        return previous.concat(value);
      }
      choices(values) {
        this.argChoices = values;
        this.parseArg = (arg, previous) => {
          if (!values.includes(arg)) {
            throw new InvalidArgumentError(`Allowed choices are ${values.join(", ")}.`);
          }
          if (this.variadic) {
            return this._concatValue(arg, previous);
          }
          return arg;
        };
        return this;
      }
      name() {
        if (this.long) {
          return this.long.replace(/^--/, "");
        }
        return this.short.replace(/^-/, "");
      }
      attributeName() {
        return camelcase(this.name().replace(/^no-/, ""));
      }
      is(arg) {
        return this.short === arg || this.long === arg;
      }
    };
    function camelcase(str2) {
      return str2.split("-").reduce((str3, word) => {
        return str3 + word[0].toUpperCase() + word.slice(1);
      });
    }
    function splitOptionFlags(flags) {
      let shortFlag;
      let longFlag;
      const flagParts = flags.split(/[ |,]+/);
      if (flagParts.length > 1 && !/^[[<]/.test(flagParts[1]))
        shortFlag = flagParts.shift();
      longFlag = flagParts.shift();
      if (!shortFlag && /^-[^-]$/.test(longFlag)) {
        shortFlag = longFlag;
        longFlag = void 0;
      }
      return { shortFlag, longFlag };
    }
    exports.Option = Option;
    exports.splitOptionFlags = splitOptionFlags;
  }
});

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/suggestSimilar.js
var require_suggestSimilar = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/suggestSimilar.js"(exports) {
    var maxDistance = 3;
    function editDistance(a, b) {
      if (Math.abs(a.length - b.length) > maxDistance)
        return Math.max(a.length, b.length);
      const d = [];
      for (let i = 0; i <= a.length; i++) {
        d[i] = [i];
      }
      for (let j = 0; j <= b.length; j++) {
        d[0][j] = j;
      }
      for (let j = 1; j <= b.length; j++) {
        for (let i = 1; i <= a.length; i++) {
          let cost = 1;
          if (a[i - 1] === b[j - 1]) {
            cost = 0;
          } else {
            cost = 1;
          }
          d[i][j] = Math.min(d[i - 1][j] + 1, d[i][j - 1] + 1, d[i - 1][j - 1] + cost);
          if (i > 1 && j > 1 && a[i - 1] === b[j - 2] && a[i - 2] === b[j - 1]) {
            d[i][j] = Math.min(d[i][j], d[i - 2][j - 2] + 1);
          }
        }
      }
      return d[a.length][b.length];
    }
    function suggestSimilar(word, candidates) {
      if (!candidates || candidates.length === 0)
        return "";
      candidates = Array.from(new Set(candidates));
      const searchingOptions = word.startsWith("--");
      if (searchingOptions) {
        word = word.slice(2);
        candidates = candidates.map((candidate) => candidate.slice(2));
      }
      let similar = [];
      let bestDistance = maxDistance;
      const minSimilarity = 0.4;
      candidates.forEach((candidate) => {
        if (candidate.length <= 1)
          return;
        const distance = editDistance(word, candidate);
        const length = Math.max(word.length, candidate.length);
        const similarity = (length - distance) / length;
        if (similarity > minSimilarity) {
          if (distance < bestDistance) {
            bestDistance = distance;
            similar = [candidate];
          } else if (distance === bestDistance) {
            similar.push(candidate);
          }
        }
      });
      similar.sort((a, b) => a.localeCompare(b));
      if (searchingOptions) {
        similar = similar.map((candidate) => `--${candidate}`);
      }
      if (similar.length > 1) {
        return `
(Did you mean one of ${similar.join(", ")}?)`;
      }
      if (similar.length === 1) {
        return `
(Did you mean ${similar[0]}?)`;
      }
      return "";
    }
    exports.suggestSimilar = suggestSimilar;
  }
});

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/command.js
var require_command = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/lib/command.js"(exports) {
    var EventEmitter = require("events").EventEmitter;
    var childProcess = require("child_process");
    var path2 = require("path");
    var fs4 = require("fs");
    var { Argument, humanReadableArgName } = require_argument();
    var { CommanderError } = require_error();
    var { Help } = require_help();
    var { Option, splitOptionFlags } = require_option();
    var { suggestSimilar } = require_suggestSimilar();
    var Command2 = class extends EventEmitter {
      constructor(name) {
        super();
        this.commands = [];
        this.options = [];
        this.parent = null;
        this._allowUnknownOption = false;
        this._allowExcessArguments = true;
        this._args = [];
        this.args = [];
        this.rawArgs = [];
        this.processedArgs = [];
        this._scriptPath = null;
        this._name = name || "";
        this._optionValues = {};
        this._optionValueSources = {};
        this._storeOptionsAsProperties = false;
        this._actionHandler = null;
        this._executableHandler = false;
        this._executableFile = null;
        this._defaultCommandName = null;
        this._exitCallback = null;
        this._aliases = [];
        this._combineFlagAndOptionalValue = true;
        this._description = "";
        this._argsDescription = void 0;
        this._enablePositionalOptions = false;
        this._passThroughOptions = false;
        this._lifeCycleHooks = {};
        this._showHelpAfterError = false;
        this._showSuggestionAfterError = false;
        this._outputConfiguration = {
          writeOut: (str2) => process.stdout.write(str2),
          writeErr: (str2) => process.stderr.write(str2),
          getOutHelpWidth: () => process.stdout.isTTY ? process.stdout.columns : void 0,
          getErrHelpWidth: () => process.stderr.isTTY ? process.stderr.columns : void 0,
          outputError: (str2, write) => write(str2)
        };
        this._hidden = false;
        this._hasHelpOption = true;
        this._helpFlags = "-h, --help";
        this._helpDescription = "display help for command";
        this._helpShortFlag = "-h";
        this._helpLongFlag = "--help";
        this._addImplicitHelpCommand = void 0;
        this._helpCommandName = "help";
        this._helpCommandnameAndArgs = "help [command]";
        this._helpCommandDescription = "display help for command";
        this._helpConfiguration = {};
      }
      copyInheritedSettings(sourceCommand) {
        this._outputConfiguration = sourceCommand._outputConfiguration;
        this._hasHelpOption = sourceCommand._hasHelpOption;
        this._helpFlags = sourceCommand._helpFlags;
        this._helpDescription = sourceCommand._helpDescription;
        this._helpShortFlag = sourceCommand._helpShortFlag;
        this._helpLongFlag = sourceCommand._helpLongFlag;
        this._helpCommandName = sourceCommand._helpCommandName;
        this._helpCommandnameAndArgs = sourceCommand._helpCommandnameAndArgs;
        this._helpCommandDescription = sourceCommand._helpCommandDescription;
        this._helpConfiguration = sourceCommand._helpConfiguration;
        this._exitCallback = sourceCommand._exitCallback;
        this._storeOptionsAsProperties = sourceCommand._storeOptionsAsProperties;
        this._combineFlagAndOptionalValue = sourceCommand._combineFlagAndOptionalValue;
        this._allowExcessArguments = sourceCommand._allowExcessArguments;
        this._enablePositionalOptions = sourceCommand._enablePositionalOptions;
        this._showHelpAfterError = sourceCommand._showHelpAfterError;
        this._showSuggestionAfterError = sourceCommand._showSuggestionAfterError;
        return this;
      }
      command(nameAndArgs, actionOptsOrExecDesc, execOpts) {
        let desc = actionOptsOrExecDesc;
        let opts = execOpts;
        if (typeof desc === "object" && desc !== null) {
          opts = desc;
          desc = null;
        }
        opts = opts || {};
        const [, name, args] = nameAndArgs.match(/([^ ]+) *(.*)/);
        const cmd = this.createCommand(name);
        if (desc) {
          cmd.description(desc);
          cmd._executableHandler = true;
        }
        if (opts.isDefault)
          this._defaultCommandName = cmd._name;
        cmd._hidden = !!(opts.noHelp || opts.hidden);
        cmd._executableFile = opts.executableFile || null;
        if (args)
          cmd.arguments(args);
        this.commands.push(cmd);
        cmd.parent = this;
        cmd.copyInheritedSettings(this);
        if (desc)
          return this;
        return cmd;
      }
      createCommand(name) {
        return new Command2(name);
      }
      createHelp() {
        return Object.assign(new Help(), this.configureHelp());
      }
      configureHelp(configuration) {
        if (configuration === void 0)
          return this._helpConfiguration;
        this._helpConfiguration = configuration;
        return this;
      }
      configureOutput(configuration) {
        if (configuration === void 0)
          return this._outputConfiguration;
        Object.assign(this._outputConfiguration, configuration);
        return this;
      }
      showHelpAfterError(displayHelp = true) {
        if (typeof displayHelp !== "string")
          displayHelp = !!displayHelp;
        this._showHelpAfterError = displayHelp;
        return this;
      }
      showSuggestionAfterError(displaySuggestion = true) {
        this._showSuggestionAfterError = !!displaySuggestion;
        return this;
      }
      addCommand(cmd, opts) {
        if (!cmd._name)
          throw new Error("Command passed to .addCommand() must have a name");
        function checkExplicitNames(commandArray) {
          commandArray.forEach((cmd2) => {
            if (cmd2._executableHandler && !cmd2._executableFile) {
              throw new Error(`Must specify executableFile for deeply nested executable: ${cmd2.name()}`);
            }
            checkExplicitNames(cmd2.commands);
          });
        }
        checkExplicitNames(cmd.commands);
        opts = opts || {};
        if (opts.isDefault)
          this._defaultCommandName = cmd._name;
        if (opts.noHelp || opts.hidden)
          cmd._hidden = true;
        this.commands.push(cmd);
        cmd.parent = this;
        return this;
      }
      createArgument(name, description) {
        return new Argument(name, description);
      }
      argument(name, description, fn, defaultValue) {
        const argument = this.createArgument(name, description);
        if (typeof fn === "function") {
          argument.default(defaultValue).argParser(fn);
        } else {
          argument.default(fn);
        }
        this.addArgument(argument);
        return this;
      }
      arguments(names) {
        names.split(/ +/).forEach((detail) => {
          this.argument(detail);
        });
        return this;
      }
      addArgument(argument) {
        const previousArgument = this._args.slice(-1)[0];
        if (previousArgument && previousArgument.variadic) {
          throw new Error(`only the last argument can be variadic '${previousArgument.name()}'`);
        }
        if (argument.required && argument.defaultValue !== void 0 && argument.parseArg === void 0) {
          throw new Error(`a default value for a required argument is never used: '${argument.name()}'`);
        }
        this._args.push(argument);
        return this;
      }
      addHelpCommand(enableOrNameAndArgs, description) {
        if (enableOrNameAndArgs === false) {
          this._addImplicitHelpCommand = false;
        } else {
          this._addImplicitHelpCommand = true;
          if (typeof enableOrNameAndArgs === "string") {
            this._helpCommandName = enableOrNameAndArgs.split(" ")[0];
            this._helpCommandnameAndArgs = enableOrNameAndArgs;
          }
          this._helpCommandDescription = description || this._helpCommandDescription;
        }
        return this;
      }
      _hasImplicitHelpCommand() {
        if (this._addImplicitHelpCommand === void 0) {
          return this.commands.length && !this._actionHandler && !this._findCommand("help");
        }
        return this._addImplicitHelpCommand;
      }
      hook(event2, listener) {
        const allowedValues = ["preAction", "postAction"];
        if (!allowedValues.includes(event2)) {
          throw new Error(`Unexpected value for event passed to hook : '${event2}'.
Expecting one of '${allowedValues.join("', '")}'`);
        }
        if (this._lifeCycleHooks[event2]) {
          this._lifeCycleHooks[event2].push(listener);
        } else {
          this._lifeCycleHooks[event2] = [listener];
        }
        return this;
      }
      exitOverride(fn) {
        if (fn) {
          this._exitCallback = fn;
        } else {
          this._exitCallback = (err) => {
            if (err.code !== "commander.executeSubCommandAsync") {
              throw err;
            } else {
            }
          };
        }
        return this;
      }
      _exit(exitCode, code, message) {
        if (this._exitCallback) {
          this._exitCallback(new CommanderError(exitCode, code, message));
        }
        process.exit(exitCode);
      }
      action(fn) {
        const listener = (args) => {
          const expectedArgsCount = this._args.length;
          const actionArgs = args.slice(0, expectedArgsCount);
          if (this._storeOptionsAsProperties) {
            actionArgs[expectedArgsCount] = this;
          } else {
            actionArgs[expectedArgsCount] = this.opts();
          }
          actionArgs.push(this);
          return fn.apply(this, actionArgs);
        };
        this._actionHandler = listener;
        return this;
      }
      createOption(flags, description) {
        return new Option(flags, description);
      }
      addOption(option) {
        const oname = option.name();
        const name = option.attributeName();
        let defaultValue = option.defaultValue;
        if (option.negate || option.optional || option.required || typeof defaultValue === "boolean") {
          if (option.negate) {
            const positiveLongFlag = option.long.replace(/^--no-/, "--");
            defaultValue = this._findOption(positiveLongFlag) ? this.getOptionValue(name) : true;
          }
          if (defaultValue !== void 0) {
            this.setOptionValueWithSource(name, defaultValue, "default");
          }
        }
        this.options.push(option);
        const handleOptionValue = (val, invalidValueMessage, valueSource) => {
          const oldValue = this.getOptionValue(name);
          if (val !== null && option.parseArg) {
            try {
              val = option.parseArg(val, oldValue === void 0 ? defaultValue : oldValue);
            } catch (err) {
              if (err.code === "commander.invalidArgument") {
                const message = `${invalidValueMessage} ${err.message}`;
                this._displayError(err.exitCode, err.code, message);
              }
              throw err;
            }
          } else if (val !== null && option.variadic) {
            val = option._concatValue(val, oldValue);
          }
          if (typeof oldValue === "boolean" || typeof oldValue === "undefined") {
            if (val == null) {
              this.setOptionValueWithSource(name, option.negate ? false : defaultValue || true, valueSource);
            } else {
              this.setOptionValueWithSource(name, val, valueSource);
            }
          } else if (val !== null) {
            this.setOptionValueWithSource(name, option.negate ? false : val, valueSource);
          }
        };
        this.on("option:" + oname, (val) => {
          const invalidValueMessage = `error: option '${option.flags}' argument '${val}' is invalid.`;
          handleOptionValue(val, invalidValueMessage, "cli");
        });
        if (option.envVar) {
          this.on("optionEnv:" + oname, (val) => {
            const invalidValueMessage = `error: option '${option.flags}' value '${val}' from env '${option.envVar}' is invalid.`;
            handleOptionValue(val, invalidValueMessage, "env");
          });
        }
        return this;
      }
      _optionEx(config, flags, description, fn, defaultValue) {
        const option = this.createOption(flags, description);
        option.makeOptionMandatory(!!config.mandatory);
        if (typeof fn === "function") {
          option.default(defaultValue).argParser(fn);
        } else if (fn instanceof RegExp) {
          const regex = fn;
          fn = (val, def) => {
            const m = regex.exec(val);
            return m ? m[0] : def;
          };
          option.default(defaultValue).argParser(fn);
        } else {
          option.default(fn);
        }
        return this.addOption(option);
      }
      option(flags, description, fn, defaultValue) {
        return this._optionEx({}, flags, description, fn, defaultValue);
      }
      requiredOption(flags, description, fn, defaultValue) {
        return this._optionEx({ mandatory: true }, flags, description, fn, defaultValue);
      }
      combineFlagAndOptionalValue(combine = true) {
        this._combineFlagAndOptionalValue = !!combine;
        return this;
      }
      allowUnknownOption(allowUnknown = true) {
        this._allowUnknownOption = !!allowUnknown;
        return this;
      }
      allowExcessArguments(allowExcess = true) {
        this._allowExcessArguments = !!allowExcess;
        return this;
      }
      enablePositionalOptions(positional = true) {
        this._enablePositionalOptions = !!positional;
        return this;
      }
      passThroughOptions(passThrough = true) {
        this._passThroughOptions = !!passThrough;
        if (!!this.parent && passThrough && !this.parent._enablePositionalOptions) {
          throw new Error("passThroughOptions can not be used without turning on enablePositionalOptions for parent command(s)");
        }
        return this;
      }
      storeOptionsAsProperties(storeAsProperties = true) {
        this._storeOptionsAsProperties = !!storeAsProperties;
        if (this.options.length) {
          throw new Error("call .storeOptionsAsProperties() before adding options");
        }
        return this;
      }
      getOptionValue(key) {
        if (this._storeOptionsAsProperties) {
          return this[key];
        }
        return this._optionValues[key];
      }
      setOptionValue(key, value) {
        if (this._storeOptionsAsProperties) {
          this[key] = value;
        } else {
          this._optionValues[key] = value;
        }
        return this;
      }
      setOptionValueWithSource(key, value, source) {
        this.setOptionValue(key, value);
        this._optionValueSources[key] = source;
        return this;
      }
      getOptionValueSource(key) {
        return this._optionValueSources[key];
      }
      _prepareUserArgs(argv, parseOptions) {
        if (argv !== void 0 && !Array.isArray(argv)) {
          throw new Error("first parameter to parse must be array or undefined");
        }
        parseOptions = parseOptions || {};
        if (argv === void 0) {
          argv = process.argv;
          if (process.versions && process.versions.electron) {
            parseOptions.from = "electron";
          }
        }
        this.rawArgs = argv.slice();
        let userArgs;
        switch (parseOptions.from) {
          case void 0:
          case "node":
            this._scriptPath = argv[1];
            userArgs = argv.slice(2);
            break;
          case "electron":
            if (process.defaultApp) {
              this._scriptPath = argv[1];
              userArgs = argv.slice(2);
            } else {
              userArgs = argv.slice(1);
            }
            break;
          case "user":
            userArgs = argv.slice(0);
            break;
          default:
            throw new Error(`unexpected parse option { from: '${parseOptions.from}' }`);
        }
        if (!this._scriptPath && require.main) {
          this._scriptPath = require.main.filename;
        }
        this._name = this._name || this._scriptPath && path2.basename(this._scriptPath, path2.extname(this._scriptPath));
        return userArgs;
      }
      parse(argv, parseOptions) {
        const userArgs = this._prepareUserArgs(argv, parseOptions);
        this._parseCommand([], userArgs);
        return this;
      }
      async parseAsync(argv, parseOptions) {
        const userArgs = this._prepareUserArgs(argv, parseOptions);
        await this._parseCommand([], userArgs);
        return this;
      }
      _executeSubCommand(subcommand, args) {
        args = args.slice();
        let launchWithNode = false;
        const sourceExt = [".js", ".ts", ".tsx", ".mjs", ".cjs"];
        this._checkForMissingMandatoryOptions();
        let scriptPath = this._scriptPath;
        if (!scriptPath && require.main) {
          scriptPath = require.main.filename;
        }
        let baseDir;
        try {
          const resolvedLink = fs4.realpathSync(scriptPath);
          baseDir = path2.dirname(resolvedLink);
        } catch (e) {
          baseDir = ".";
        }
        let bin = path2.basename(scriptPath, path2.extname(scriptPath)) + "-" + subcommand._name;
        if (subcommand._executableFile) {
          bin = subcommand._executableFile;
        }
        const localBin = path2.join(baseDir, bin);
        if (fs4.existsSync(localBin)) {
          bin = localBin;
        } else {
          sourceExt.forEach((ext) => {
            if (fs4.existsSync(`${localBin}${ext}`)) {
              bin = `${localBin}${ext}`;
            }
          });
        }
        launchWithNode = sourceExt.includes(path2.extname(bin));
        let proc;
        if (process.platform !== "win32") {
          if (launchWithNode) {
            args.unshift(bin);
            args = incrementNodeInspectorPort(process.execArgv).concat(args);
            proc = childProcess.spawn(process.argv[0], args, { stdio: "inherit" });
          } else {
            proc = childProcess.spawn(bin, args, { stdio: "inherit" });
          }
        } else {
          args.unshift(bin);
          args = incrementNodeInspectorPort(process.execArgv).concat(args);
          proc = childProcess.spawn(process.execPath, args, { stdio: "inherit" });
        }
        const signals = ["SIGUSR1", "SIGUSR2", "SIGTERM", "SIGINT", "SIGHUP"];
        signals.forEach((signal) => {
          process.on(signal, () => {
            if (proc.killed === false && proc.exitCode === null) {
              proc.kill(signal);
            }
          });
        });
        const exitCallback = this._exitCallback;
        if (!exitCallback) {
          proc.on("close", process.exit.bind(process));
        } else {
          proc.on("close", () => {
            exitCallback(new CommanderError(process.exitCode || 0, "commander.executeSubCommandAsync", "(close)"));
          });
        }
        proc.on("error", (err) => {
          if (err.code === "ENOENT") {
            const executableMissing = `'${bin}' does not exist
 - if '${subcommand._name}' is not meant to be an executable command, remove description parameter from '.command()' and use '.description()' instead
 - if the default executable name is not suitable, use the executableFile option to supply a custom name`;
            throw new Error(executableMissing);
          } else if (err.code === "EACCES") {
            throw new Error(`'${bin}' not executable`);
          }
          if (!exitCallback) {
            process.exit(1);
          } else {
            const wrappedError = new CommanderError(1, "commander.executeSubCommandAsync", "(error)");
            wrappedError.nestedError = err;
            exitCallback(wrappedError);
          }
        });
        this.runningCommand = proc;
      }
      _dispatchSubcommand(commandName, operands, unknown) {
        const subCommand = this._findCommand(commandName);
        if (!subCommand)
          this.help({ error: true });
        if (subCommand._executableHandler) {
          this._executeSubCommand(subCommand, operands.concat(unknown));
        } else {
          return subCommand._parseCommand(operands, unknown);
        }
      }
      _checkNumberOfArguments() {
        this._args.forEach((arg, i) => {
          if (arg.required && this.args[i] == null) {
            this.missingArgument(arg.name());
          }
        });
        if (this._args.length > 0 && this._args[this._args.length - 1].variadic) {
          return;
        }
        if (this.args.length > this._args.length) {
          this._excessArguments(this.args);
        }
      }
      _processArguments() {
        const myParseArg = (argument, value, previous) => {
          let parsedValue = value;
          if (value !== null && argument.parseArg) {
            try {
              parsedValue = argument.parseArg(value, previous);
            } catch (err) {
              if (err.code === "commander.invalidArgument") {
                const message = `error: command-argument value '${value}' is invalid for argument '${argument.name()}'. ${err.message}`;
                this._displayError(err.exitCode, err.code, message);
              }
              throw err;
            }
          }
          return parsedValue;
        };
        this._checkNumberOfArguments();
        const processedArgs = [];
        this._args.forEach((declaredArg, index) => {
          let value = declaredArg.defaultValue;
          if (declaredArg.variadic) {
            if (index < this.args.length) {
              value = this.args.slice(index);
              if (declaredArg.parseArg) {
                value = value.reduce((processed, v) => {
                  return myParseArg(declaredArg, v, processed);
                }, declaredArg.defaultValue);
              }
            } else if (value === void 0) {
              value = [];
            }
          } else if (index < this.args.length) {
            value = this.args[index];
            if (declaredArg.parseArg) {
              value = myParseArg(declaredArg, value, declaredArg.defaultValue);
            }
          }
          processedArgs[index] = value;
        });
        this.processedArgs = processedArgs;
      }
      _chainOrCall(promise, fn) {
        if (promise && promise.then && typeof promise.then === "function") {
          return promise.then(() => fn());
        }
        return fn();
      }
      _chainOrCallHooks(promise, event2) {
        let result2 = promise;
        const hooks = [];
        getCommandAndParents(this).reverse().filter((cmd) => cmd._lifeCycleHooks[event2] !== void 0).forEach((hookedCommand) => {
          hookedCommand._lifeCycleHooks[event2].forEach((callback) => {
            hooks.push({ hookedCommand, callback });
          });
        });
        if (event2 === "postAction") {
          hooks.reverse();
        }
        hooks.forEach((hookDetail) => {
          result2 = this._chainOrCall(result2, () => {
            return hookDetail.callback(hookDetail.hookedCommand, this);
          });
        });
        return result2;
      }
      _parseCommand(operands, unknown) {
        const parsed = this.parseOptions(unknown);
        this._parseOptionsEnv();
        operands = operands.concat(parsed.operands);
        unknown = parsed.unknown;
        this.args = operands.concat(unknown);
        if (operands && this._findCommand(operands[0])) {
          return this._dispatchSubcommand(operands[0], operands.slice(1), unknown);
        }
        if (this._hasImplicitHelpCommand() && operands[0] === this._helpCommandName) {
          if (operands.length === 1) {
            this.help();
          }
          return this._dispatchSubcommand(operands[1], [], [this._helpLongFlag]);
        }
        if (this._defaultCommandName) {
          outputHelpIfRequested(this, unknown);
          return this._dispatchSubcommand(this._defaultCommandName, operands, unknown);
        }
        if (this.commands.length && this.args.length === 0 && !this._actionHandler && !this._defaultCommandName) {
          this.help({ error: true });
        }
        outputHelpIfRequested(this, parsed.unknown);
        this._checkForMissingMandatoryOptions();
        const checkForUnknownOptions = () => {
          if (parsed.unknown.length > 0) {
            this.unknownOption(parsed.unknown[0]);
          }
        };
        const commandEvent = `command:${this.name()}`;
        if (this._actionHandler) {
          checkForUnknownOptions();
          this._processArguments();
          let actionResult;
          actionResult = this._chainOrCallHooks(actionResult, "preAction");
          actionResult = this._chainOrCall(actionResult, () => this._actionHandler(this.processedArgs));
          if (this.parent)
            this.parent.emit(commandEvent, operands, unknown);
          actionResult = this._chainOrCallHooks(actionResult, "postAction");
          return actionResult;
        }
        if (this.parent && this.parent.listenerCount(commandEvent)) {
          checkForUnknownOptions();
          this._processArguments();
          this.parent.emit(commandEvent, operands, unknown);
        } else if (operands.length) {
          if (this._findCommand("*")) {
            return this._dispatchSubcommand("*", operands, unknown);
          }
          if (this.listenerCount("command:*")) {
            this.emit("command:*", operands, unknown);
          } else if (this.commands.length) {
            this.unknownCommand();
          } else {
            checkForUnknownOptions();
            this._processArguments();
          }
        } else if (this.commands.length) {
          checkForUnknownOptions();
          this.help({ error: true });
        } else {
          checkForUnknownOptions();
          this._processArguments();
        }
      }
      _findCommand(name) {
        if (!name)
          return void 0;
        return this.commands.find((cmd) => cmd._name === name || cmd._aliases.includes(name));
      }
      _findOption(arg) {
        return this.options.find((option) => option.is(arg));
      }
      _checkForMissingMandatoryOptions() {
        for (let cmd = this; cmd; cmd = cmd.parent) {
          cmd.options.forEach((anOption) => {
            if (anOption.mandatory && cmd.getOptionValue(anOption.attributeName()) === void 0) {
              cmd.missingMandatoryOptionValue(anOption);
            }
          });
        }
      }
      parseOptions(argv) {
        const operands = [];
        const unknown = [];
        let dest = operands;
        const args = argv.slice();
        function maybeOption(arg) {
          return arg.length > 1 && arg[0] === "-";
        }
        let activeVariadicOption = null;
        while (args.length) {
          const arg = args.shift();
          if (arg === "--") {
            if (dest === unknown)
              dest.push(arg);
            dest.push(...args);
            break;
          }
          if (activeVariadicOption && !maybeOption(arg)) {
            this.emit(`option:${activeVariadicOption.name()}`, arg);
            continue;
          }
          activeVariadicOption = null;
          if (maybeOption(arg)) {
            const option = this._findOption(arg);
            if (option) {
              if (option.required) {
                const value = args.shift();
                if (value === void 0)
                  this.optionMissingArgument(option);
                this.emit(`option:${option.name()}`, value);
              } else if (option.optional) {
                let value = null;
                if (args.length > 0 && !maybeOption(args[0])) {
                  value = args.shift();
                }
                this.emit(`option:${option.name()}`, value);
              } else {
                this.emit(`option:${option.name()}`);
              }
              activeVariadicOption = option.variadic ? option : null;
              continue;
            }
          }
          if (arg.length > 2 && arg[0] === "-" && arg[1] !== "-") {
            const option = this._findOption(`-${arg[1]}`);
            if (option) {
              if (option.required || option.optional && this._combineFlagAndOptionalValue) {
                this.emit(`option:${option.name()}`, arg.slice(2));
              } else {
                this.emit(`option:${option.name()}`);
                args.unshift(`-${arg.slice(2)}`);
              }
              continue;
            }
          }
          if (/^--[^=]+=/.test(arg)) {
            const index = arg.indexOf("=");
            const option = this._findOption(arg.slice(0, index));
            if (option && (option.required || option.optional)) {
              this.emit(`option:${option.name()}`, arg.slice(index + 1));
              continue;
            }
          }
          if (maybeOption(arg)) {
            dest = unknown;
          }
          if ((this._enablePositionalOptions || this._passThroughOptions) && operands.length === 0 && unknown.length === 0) {
            if (this._findCommand(arg)) {
              operands.push(arg);
              if (args.length > 0)
                unknown.push(...args);
              break;
            } else if (arg === this._helpCommandName && this._hasImplicitHelpCommand()) {
              operands.push(arg);
              if (args.length > 0)
                operands.push(...args);
              break;
            } else if (this._defaultCommandName) {
              unknown.push(arg);
              if (args.length > 0)
                unknown.push(...args);
              break;
            }
          }
          if (this._passThroughOptions) {
            dest.push(arg);
            if (args.length > 0)
              dest.push(...args);
            break;
          }
          dest.push(arg);
        }
        return { operands, unknown };
      }
      opts() {
        if (this._storeOptionsAsProperties) {
          const result2 = {};
          const len = this.options.length;
          for (let i = 0; i < len; i++) {
            const key = this.options[i].attributeName();
            result2[key] = key === this._versionOptionName ? this._version : this[key];
          }
          return result2;
        }
        return this._optionValues;
      }
      _displayError(exitCode, code, message) {
        this._outputConfiguration.outputError(`${message}
`, this._outputConfiguration.writeErr);
        if (typeof this._showHelpAfterError === "string") {
          this._outputConfiguration.writeErr(`${this._showHelpAfterError}
`);
        } else if (this._showHelpAfterError) {
          this._outputConfiguration.writeErr("\n");
          this.outputHelp({ error: true });
        }
        this._exit(exitCode, code, message);
      }
      _parseOptionsEnv() {
        this.options.forEach((option) => {
          if (option.envVar && option.envVar in process.env) {
            const optionKey = option.attributeName();
            if (this.getOptionValue(optionKey) === void 0 || ["default", "config", "env"].includes(this.getOptionValueSource(optionKey))) {
              if (option.required || option.optional) {
                this.emit(`optionEnv:${option.name()}`, process.env[option.envVar]);
              } else {
                this.emit(`optionEnv:${option.name()}`);
              }
            }
          }
        });
      }
      missingArgument(name) {
        const message = `error: missing required argument '${name}'`;
        this._displayError(1, "commander.missingArgument", message);
      }
      optionMissingArgument(option) {
        const message = `error: option '${option.flags}' argument missing`;
        this._displayError(1, "commander.optionMissingArgument", message);
      }
      missingMandatoryOptionValue(option) {
        const message = `error: required option '${option.flags}' not specified`;
        this._displayError(1, "commander.missingMandatoryOptionValue", message);
      }
      unknownOption(flag) {
        if (this._allowUnknownOption)
          return;
        let suggestion = "";
        if (flag.startsWith("--") && this._showSuggestionAfterError) {
          let candidateFlags = [];
          let command = this;
          do {
            const moreFlags = command.createHelp().visibleOptions(command).filter((option) => option.long).map((option) => option.long);
            candidateFlags = candidateFlags.concat(moreFlags);
            command = command.parent;
          } while (command && !command._enablePositionalOptions);
          suggestion = suggestSimilar(flag, candidateFlags);
        }
        const message = `error: unknown option '${flag}'${suggestion}`;
        this._displayError(1, "commander.unknownOption", message);
      }
      _excessArguments(receivedArgs) {
        if (this._allowExcessArguments)
          return;
        const expected = this._args.length;
        const s = expected === 1 ? "" : "s";
        const forSubcommand = this.parent ? ` for '${this.name()}'` : "";
        const message = `error: too many arguments${forSubcommand}. Expected ${expected} argument${s} but got ${receivedArgs.length}.`;
        this._displayError(1, "commander.excessArguments", message);
      }
      unknownCommand() {
        const unknownName = this.args[0];
        let suggestion = "";
        if (this._showSuggestionAfterError) {
          const candidateNames = [];
          this.createHelp().visibleCommands(this).forEach((command) => {
            candidateNames.push(command.name());
            if (command.alias())
              candidateNames.push(command.alias());
          });
          suggestion = suggestSimilar(unknownName, candidateNames);
        }
        const message = `error: unknown command '${unknownName}'${suggestion}`;
        this._displayError(1, "commander.unknownCommand", message);
      }
      version(str2, flags, description) {
        if (str2 === void 0)
          return this._version;
        this._version = str2;
        flags = flags || "-V, --version";
        description = description || "output the version number";
        const versionOption = this.createOption(flags, description);
        this._versionOptionName = versionOption.attributeName();
        this.options.push(versionOption);
        this.on("option:" + versionOption.name(), () => {
          this._outputConfiguration.writeOut(`${str2}
`);
          this._exit(0, "commander.version", str2);
        });
        return this;
      }
      description(str2, argsDescription) {
        if (str2 === void 0 && argsDescription === void 0)
          return this._description;
        this._description = str2;
        if (argsDescription) {
          this._argsDescription = argsDescription;
        }
        return this;
      }
      alias(alias) {
        if (alias === void 0)
          return this._aliases[0];
        let command = this;
        if (this.commands.length !== 0 && this.commands[this.commands.length - 1]._executableHandler) {
          command = this.commands[this.commands.length - 1];
        }
        if (alias === command._name)
          throw new Error("Command alias can't be the same as its name");
        command._aliases.push(alias);
        return this;
      }
      aliases(aliases) {
        if (aliases === void 0)
          return this._aliases;
        aliases.forEach((alias) => this.alias(alias));
        return this;
      }
      usage(str2) {
        if (str2 === void 0) {
          if (this._usage)
            return this._usage;
          const args = this._args.map((arg) => {
            return humanReadableArgName(arg);
          });
          return [].concat(this.options.length || this._hasHelpOption ? "[options]" : [], this.commands.length ? "[command]" : [], this._args.length ? args : []).join(" ");
        }
        this._usage = str2;
        return this;
      }
      name(str2) {
        if (str2 === void 0)
          return this._name;
        this._name = str2;
        return this;
      }
      helpInformation(contextOptions) {
        const helper = this.createHelp();
        if (helper.helpWidth === void 0) {
          helper.helpWidth = contextOptions && contextOptions.error ? this._outputConfiguration.getErrHelpWidth() : this._outputConfiguration.getOutHelpWidth();
        }
        return helper.formatHelp(this, helper);
      }
      _getHelpContext(contextOptions) {
        contextOptions = contextOptions || {};
        const context = { error: !!contextOptions.error };
        let write;
        if (context.error) {
          write = (arg) => this._outputConfiguration.writeErr(arg);
        } else {
          write = (arg) => this._outputConfiguration.writeOut(arg);
        }
        context.write = contextOptions.write || write;
        context.command = this;
        return context;
      }
      outputHelp(contextOptions) {
        let deprecatedCallback;
        if (typeof contextOptions === "function") {
          deprecatedCallback = contextOptions;
          contextOptions = void 0;
        }
        const context = this._getHelpContext(contextOptions);
        getCommandAndParents(this).reverse().forEach((command) => command.emit("beforeAllHelp", context));
        this.emit("beforeHelp", context);
        let helpInformation = this.helpInformation(context);
        if (deprecatedCallback) {
          helpInformation = deprecatedCallback(helpInformation);
          if (typeof helpInformation !== "string" && !Buffer.isBuffer(helpInformation)) {
            throw new Error("outputHelp callback must return a string or a Buffer");
          }
        }
        context.write(helpInformation);
        this.emit(this._helpLongFlag);
        this.emit("afterHelp", context);
        getCommandAndParents(this).forEach((command) => command.emit("afterAllHelp", context));
      }
      helpOption(flags, description) {
        if (typeof flags === "boolean") {
          this._hasHelpOption = flags;
          return this;
        }
        this._helpFlags = flags || this._helpFlags;
        this._helpDescription = description || this._helpDescription;
        const helpFlags = splitOptionFlags(this._helpFlags);
        this._helpShortFlag = helpFlags.shortFlag;
        this._helpLongFlag = helpFlags.longFlag;
        return this;
      }
      help(contextOptions) {
        this.outputHelp(contextOptions);
        let exitCode = process.exitCode || 0;
        if (exitCode === 0 && contextOptions && typeof contextOptions !== "function" && contextOptions.error) {
          exitCode = 1;
        }
        this._exit(exitCode, "commander.help", "(outputHelp)");
      }
      addHelpText(position, text) {
        const allowedValues = ["beforeAll", "before", "after", "afterAll"];
        if (!allowedValues.includes(position)) {
          throw new Error(`Unexpected value for position to addHelpText.
Expecting one of '${allowedValues.join("', '")}'`);
        }
        const helpEvent = `${position}Help`;
        this.on(helpEvent, (context) => {
          let helpStr;
          if (typeof text === "function") {
            helpStr = text({ error: context.error, command: context.command });
          } else {
            helpStr = text;
          }
          if (helpStr) {
            context.write(`${helpStr}
`);
          }
        });
        return this;
      }
    };
    function outputHelpIfRequested(cmd, args) {
      const helpOption = cmd._hasHelpOption && args.find((arg) => arg === cmd._helpLongFlag || arg === cmd._helpShortFlag);
      if (helpOption) {
        cmd.outputHelp();
        cmd._exit(0, "commander.helpDisplayed", "(outputHelp)");
      }
    }
    function incrementNodeInspectorPort(args) {
      return args.map((arg) => {
        if (!arg.startsWith("--inspect")) {
          return arg;
        }
        let debugOption;
        let debugHost = "127.0.0.1";
        let debugPort = "9229";
        let match;
        if ((match = arg.match(/^(--inspect(-brk)?)$/)) !== null) {
          debugOption = match[1];
        } else if ((match = arg.match(/^(--inspect(-brk|-port)?)=([^:]+)$/)) !== null) {
          debugOption = match[1];
          if (/^\d+$/.test(match[3])) {
            debugPort = match[3];
          } else {
            debugHost = match[3];
          }
        } else if ((match = arg.match(/^(--inspect(-brk|-port)?)=([^:]+):(\d+)$/)) !== null) {
          debugOption = match[1];
          debugHost = match[3];
          debugPort = match[4];
        }
        if (debugOption && debugPort !== "0") {
          return `${debugOption}=${debugHost}:${parseInt(debugPort) + 1}`;
        }
        return arg;
      });
    }
    function getCommandAndParents(startCommand) {
      const result2 = [];
      for (let command = startCommand; command; command = command.parent) {
        result2.push(command);
      }
      return result2;
    }
    exports.Command = Command2;
  }
});

// node_modules/.pnpm/commander@8.3.0/node_modules/commander/index.js
var require_commander = __commonJS({
  "node_modules/.pnpm/commander@8.3.0/node_modules/commander/index.js"(exports, module2) {
    var { Argument } = require_argument();
    var { Command: Command2 } = require_command();
    var { CommanderError, InvalidArgumentError } = require_error();
    var { Help } = require_help();
    var { Option } = require_option();
    exports = module2.exports = new Command2();
    exports.program = exports;
    exports.Argument = Argument;
    exports.Command = Command2;
    exports.CommanderError = CommanderError;
    exports.Help = Help;
    exports.InvalidArgumentError = InvalidArgumentError;
    exports.InvalidOptionArgumentError = InvalidArgumentError;
    exports.Option = Option;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/_virtual/_tslib.js
var require_tslib = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/_virtual/_tslib.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.__assign = function() {
      exports.__assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p))
              t[p] = s[p];
        }
        return t;
      };
      return exports.__assign.apply(this, arguments);
    };
    function __rest(s, e) {
      var t = {};
      for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
          t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    }
    function __values(o) {
      var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
      if (m)
        return m.call(o);
      if (o && typeof o.length === "number")
        return {
          next: function() {
            if (o && i >= o.length)
              o = void 0;
            return { value: o && o[i++], done: !o };
          }
        };
      throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
      var m = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m)
        return o;
      var i = m.call(o), r, ar = [], e;
      try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
          ar.push(r.value);
      } catch (error) {
        e = { error };
      } finally {
        try {
          if (r && !r.done && (m = i["return"]))
            m.call(i);
        } finally {
          if (e)
            throw e.error;
        }
      }
      return ar;
    }
    function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2)
        for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
            if (!ar)
              ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
          }
        }
      return to.concat(ar || Array.prototype.slice.call(from));
    }
    exports.__read = __read;
    exports.__rest = __rest;
    exports.__spreadArray = __spreadArray;
    exports.__values = __values;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/types.js
var require_types = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/types.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ActionTypes = void 0;
    (function(ActionTypes) {
      ActionTypes["Start"] = "xstate.start";
      ActionTypes["Stop"] = "xstate.stop";
      ActionTypes["Raise"] = "xstate.raise";
      ActionTypes["Send"] = "xstate.send";
      ActionTypes["Cancel"] = "xstate.cancel";
      ActionTypes["NullEvent"] = "";
      ActionTypes["Assign"] = "xstate.assign";
      ActionTypes["After"] = "xstate.after";
      ActionTypes["DoneState"] = "done.state";
      ActionTypes["DoneInvoke"] = "done.invoke";
      ActionTypes["Log"] = "xstate.log";
      ActionTypes["Init"] = "xstate.init";
      ActionTypes["Invoke"] = "xstate.invoke";
      ActionTypes["ErrorExecution"] = "error.execution";
      ActionTypes["ErrorCommunication"] = "error.communication";
      ActionTypes["ErrorPlatform"] = "error.platform";
      ActionTypes["ErrorCustom"] = "xstate.error";
      ActionTypes["Update"] = "xstate.update";
      ActionTypes["Pure"] = "xstate.pure";
      ActionTypes["Choose"] = "xstate.choose";
    })(exports.ActionTypes || (exports.ActionTypes = {}));
    exports.SpecialTargets = void 0;
    (function(SpecialTargets) {
      SpecialTargets["Parent"] = "#_parent";
      SpecialTargets["Internal"] = "#_internal";
    })(exports.SpecialTargets || (exports.SpecialTargets = {}));
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/actionTypes.js
var require_actionTypes = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/actionTypes.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var types2 = require_types();
    var start = types2.ActionTypes.Start;
    var stop = types2.ActionTypes.Stop;
    var raise = types2.ActionTypes.Raise;
    var send3 = types2.ActionTypes.Send;
    var cancel = types2.ActionTypes.Cancel;
    var nullEvent = types2.ActionTypes.NullEvent;
    var assign3 = types2.ActionTypes.Assign;
    var after = types2.ActionTypes.After;
    var doneState = types2.ActionTypes.DoneState;
    var log = types2.ActionTypes.Log;
    var init = types2.ActionTypes.Init;
    var invoke = types2.ActionTypes.Invoke;
    var errorExecution = types2.ActionTypes.ErrorExecution;
    var errorPlatform = types2.ActionTypes.ErrorPlatform;
    var error = types2.ActionTypes.ErrorCustom;
    var update = types2.ActionTypes.Update;
    var choose = types2.ActionTypes.Choose;
    var pure = types2.ActionTypes.Pure;
    exports.after = after;
    exports.assign = assign3;
    exports.cancel = cancel;
    exports.choose = choose;
    exports.doneState = doneState;
    exports.error = error;
    exports.errorExecution = errorExecution;
    exports.errorPlatform = errorPlatform;
    exports.init = init;
    exports.invoke = invoke;
    exports.log = log;
    exports.nullEvent = nullEvent;
    exports.pure = pure;
    exports.raise = raise;
    exports.send = send3;
    exports.start = start;
    exports.stop = stop;
    exports.update = update;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/constants.js
var require_constants = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/constants.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var STATE_DELIMITER = ".";
    var EMPTY_ACTIVITY_MAP = {};
    var DEFAULT_GUARD_TYPE = "xstate.guard";
    var TARGETLESS_KEY = "";
    exports.DEFAULT_GUARD_TYPE = DEFAULT_GUARD_TYPE;
    exports.EMPTY_ACTIVITY_MAP = EMPTY_ACTIVITY_MAP;
    exports.STATE_DELIMITER = STATE_DELIMITER;
    exports.TARGETLESS_KEY = TARGETLESS_KEY;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/environment.js
var require_environment = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/environment.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var IS_PRODUCTION = process.env.NODE_ENV === "production";
    exports.IS_PRODUCTION = IS_PRODUCTION;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/utils.js
var require_utils = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/utils.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var constants = require_constants();
    var environment = require_environment();
    var _a;
    function keys(value) {
      return Object.keys(value);
    }
    function matchesState(parentStateId, childStateId, delimiter) {
      if (delimiter === void 0) {
        delimiter = constants.STATE_DELIMITER;
      }
      var parentStateValue = toStateValue(parentStateId, delimiter);
      var childStateValue = toStateValue(childStateId, delimiter);
      if (isString(childStateValue)) {
        if (isString(parentStateValue)) {
          return childStateValue === parentStateValue;
        }
        return false;
      }
      if (isString(parentStateValue)) {
        return parentStateValue in childStateValue;
      }
      return Object.keys(parentStateValue).every(function(key) {
        if (!(key in childStateValue)) {
          return false;
        }
        return matchesState(parentStateValue[key], childStateValue[key]);
      });
    }
    function getEventType(event2) {
      try {
        return isString(event2) || typeof event2 === "number" ? "".concat(event2) : event2.type;
      } catch (e) {
        throw new Error("Events must be strings or objects with a string event.type property.");
      }
    }
    function getActionType(action) {
      try {
        return isString(action) || typeof action === "number" ? "".concat(action) : isFunction(action) ? action.name : action.type;
      } catch (e) {
        throw new Error("Actions must be strings or objects with a string action.type property.");
      }
    }
    function toStatePath(stateId, delimiter) {
      try {
        if (isArray(stateId)) {
          return stateId;
        }
        return stateId.toString().split(delimiter);
      } catch (e) {
        throw new Error("'".concat(stateId, "' is not a valid state path."));
      }
    }
    function isStateLike(state) {
      return typeof state === "object" && "value" in state && "context" in state && "event" in state && "_event" in state;
    }
    function toStateValue(stateValue, delimiter) {
      if (isStateLike(stateValue)) {
        return stateValue.value;
      }
      if (isArray(stateValue)) {
        return pathToStateValue(stateValue);
      }
      if (typeof stateValue !== "string") {
        return stateValue;
      }
      var statePath = toStatePath(stateValue, delimiter);
      return pathToStateValue(statePath);
    }
    function pathToStateValue(statePath) {
      if (statePath.length === 1) {
        return statePath[0];
      }
      var value = {};
      var marker = value;
      for (var i = 0; i < statePath.length - 1; i++) {
        if (i === statePath.length - 2) {
          marker[statePath[i]] = statePath[i + 1];
        } else {
          marker[statePath[i]] = {};
          marker = marker[statePath[i]];
        }
      }
      return value;
    }
    function mapValues(collection, iteratee) {
      var result2 = {};
      var collectionKeys = Object.keys(collection);
      for (var i = 0; i < collectionKeys.length; i++) {
        var key = collectionKeys[i];
        result2[key] = iteratee(collection[key], key, collection, i);
      }
      return result2;
    }
    function mapFilterValues(collection, iteratee, predicate) {
      var e_1, _a2;
      var result2 = {};
      try {
        for (var _b = _tslib.__values(Object.keys(collection)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          var item = collection[key];
          if (!predicate(item)) {
            continue;
          }
          result2[key] = iteratee(item, key, collection);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a2 = _b.return))
            _a2.call(_b);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return result2;
    }
    var path2 = function(props) {
      return function(object2) {
        var e_2, _a2;
        var result2 = object2;
        try {
          for (var props_1 = _tslib.__values(props), props_1_1 = props_1.next(); !props_1_1.done; props_1_1 = props_1.next()) {
            var prop = props_1_1.value;
            result2 = result2[prop];
          }
        } catch (e_2_1) {
          e_2 = {
            error: e_2_1
          };
        } finally {
          try {
            if (props_1_1 && !props_1_1.done && (_a2 = props_1.return))
              _a2.call(props_1);
          } finally {
            if (e_2)
              throw e_2.error;
          }
        }
        return result2;
      };
    };
    function nestedPath(props, accessorProp) {
      return function(object2) {
        var e_3, _a2;
        var result2 = object2;
        try {
          for (var props_2 = _tslib.__values(props), props_2_1 = props_2.next(); !props_2_1.done; props_2_1 = props_2.next()) {
            var prop = props_2_1.value;
            result2 = result2[accessorProp][prop];
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (props_2_1 && !props_2_1.done && (_a2 = props_2.return))
              _a2.call(props_2);
          } finally {
            if (e_3)
              throw e_3.error;
          }
        }
        return result2;
      };
    }
    function toStatePaths(stateValue) {
      if (!stateValue) {
        return [[]];
      }
      if (isString(stateValue)) {
        return [[stateValue]];
      }
      var result2 = flatten(Object.keys(stateValue).map(function(key) {
        var subStateValue = stateValue[key];
        if (typeof subStateValue !== "string" && (!subStateValue || !Object.keys(subStateValue).length)) {
          return [[key]];
        }
        return toStatePaths(stateValue[key]).map(function(subPath) {
          return [key].concat(subPath);
        });
      }));
      return result2;
    }
    function pathsToStateValue(paths) {
      var e_4, _a2;
      var result2 = {};
      if (paths && paths.length === 1 && paths[0].length === 1) {
        return paths[0][0];
      }
      try {
        for (var paths_1 = _tslib.__values(paths), paths_1_1 = paths_1.next(); !paths_1_1.done; paths_1_1 = paths_1.next()) {
          var currentPath = paths_1_1.value;
          var marker = result2;
          for (var i = 0; i < currentPath.length; i++) {
            var subPath = currentPath[i];
            if (i === currentPath.length - 2) {
              marker[subPath] = currentPath[i + 1];
              break;
            }
            marker[subPath] = marker[subPath] || {};
            marker = marker[subPath];
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (paths_1_1 && !paths_1_1.done && (_a2 = paths_1.return))
            _a2.call(paths_1);
        } finally {
          if (e_4)
            throw e_4.error;
        }
      }
      return result2;
    }
    function flatten(array) {
      var _a2;
      return (_a2 = []).concat.apply(_a2, _tslib.__spreadArray([], _tslib.__read(array), false));
    }
    function toArrayStrict(value) {
      if (isArray(value)) {
        return value;
      }
      return [value];
    }
    function toArray2(value) {
      if (value === void 0) {
        return [];
      }
      return toArrayStrict(value);
    }
    function mapContext(mapper, context, _event) {
      var e_5, _a2;
      if (isFunction(mapper)) {
        return mapper(context, _event.data);
      }
      var result2 = {};
      try {
        for (var _b = _tslib.__values(Object.keys(mapper)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          var subMapper = mapper[key];
          if (isFunction(subMapper)) {
            result2[key] = subMapper(context, _event.data);
          } else {
            result2[key] = subMapper;
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a2 = _b.return))
            _a2.call(_b);
        } finally {
          if (e_5)
            throw e_5.error;
        }
      }
      return result2;
    }
    function isBuiltInEvent(eventType) {
      return /^(done|error)\./.test(eventType);
    }
    function isPromiseLike(value) {
      if (value instanceof Promise) {
        return true;
      }
      if (value !== null && (isFunction(value) || typeof value === "object") && isFunction(value.then)) {
        return true;
      }
      return false;
    }
    function isBehavior(value) {
      return value !== null && typeof value === "object" && "transition" in value && typeof value.transition === "function";
    }
    function partition(items, predicate) {
      var e_6, _a2;
      var _b = _tslib.__read([[], []], 2), truthy = _b[0], falsy = _b[1];
      try {
        for (var items_1 = _tslib.__values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
          var item = items_1_1.value;
          if (predicate(item)) {
            truthy.push(item);
          } else {
            falsy.push(item);
          }
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (items_1_1 && !items_1_1.done && (_a2 = items_1.return))
            _a2.call(items_1);
        } finally {
          if (e_6)
            throw e_6.error;
        }
      }
      return [truthy, falsy];
    }
    function updateHistoryStates(hist, stateValue) {
      return mapValues(hist.states, function(subHist, key) {
        if (!subHist) {
          return void 0;
        }
        var subStateValue = (isString(stateValue) ? void 0 : stateValue[key]) || (subHist ? subHist.current : void 0);
        if (!subStateValue) {
          return void 0;
        }
        return {
          current: subStateValue,
          states: updateHistoryStates(subHist, subStateValue)
        };
      });
    }
    function updateHistoryValue(hist, stateValue) {
      return {
        current: stateValue,
        states: updateHistoryStates(hist, stateValue)
      };
    }
    function updateContext(context, _event, assignActions, state) {
      if (!environment.IS_PRODUCTION) {
        exports.warn(!!context, "Attempting to update undefined context");
      }
      var updatedContext = context ? assignActions.reduce(function(acc, assignAction) {
        var e_7, _a2;
        var assignment = assignAction.assignment;
        var meta = {
          state,
          action: assignAction,
          _event
        };
        var partialUpdate = {};
        if (isFunction(assignment)) {
          partialUpdate = assignment(acc, _event.data, meta);
        } else {
          try {
            for (var _b = _tslib.__values(Object.keys(assignment)), _c = _b.next(); !_c.done; _c = _b.next()) {
              var key = _c.value;
              var propAssignment = assignment[key];
              partialUpdate[key] = isFunction(propAssignment) ? propAssignment(acc, _event.data, meta) : propAssignment;
            }
          } catch (e_7_1) {
            e_7 = {
              error: e_7_1
            };
          } finally {
            try {
              if (_c && !_c.done && (_a2 = _b.return))
                _a2.call(_b);
            } finally {
              if (e_7)
                throw e_7.error;
            }
          }
        }
        return Object.assign({}, acc, partialUpdate);
      }, context) : context;
      return updatedContext;
    }
    exports.warn = function() {
    };
    if (!environment.IS_PRODUCTION) {
      exports.warn = function(condition, message) {
        var error = condition instanceof Error ? condition : void 0;
        if (!error && condition) {
          return;
        }
        if (console !== void 0) {
          var args = ["Warning: ".concat(message)];
          if (error) {
            args.push(error);
          }
          console.warn.apply(console, args);
        }
      };
    }
    function isArray(value) {
      return Array.isArray(value);
    }
    function isFunction(value) {
      return typeof value === "function";
    }
    function isString(value) {
      return typeof value === "string";
    }
    function toGuard(condition, guardMap) {
      if (!condition) {
        return void 0;
      }
      if (isString(condition)) {
        return {
          type: constants.DEFAULT_GUARD_TYPE,
          name: condition,
          predicate: guardMap ? guardMap[condition] : void 0
        };
      }
      if (isFunction(condition)) {
        return {
          type: constants.DEFAULT_GUARD_TYPE,
          name: condition.name,
          predicate: condition
        };
      }
      return condition;
    }
    function isObservable(value) {
      try {
        return "subscribe" in value && isFunction(value.subscribe);
      } catch (e) {
        return false;
      }
    }
    var symbolObservable = /* @__PURE__ */ function() {
      return typeof Symbol === "function" && Symbol.observable || "@@observable";
    }();
    var interopSymbols = (_a = {}, _a[symbolObservable] = function() {
      return this;
    }, _a[Symbol.observable] = function() {
      return this;
    }, _a);
    function isMachine(value) {
      return !!value && "__xstatenode" in value;
    }
    function isActor(value) {
      return !!value && typeof value.send === "function";
    }
    var uniqueId = /* @__PURE__ */ function() {
      var currentId = 0;
      return function() {
        currentId++;
        return currentId.toString(16);
      };
    }();
    function toEventObject(event2, payload) {
      if (isString(event2) || typeof event2 === "number") {
        return _tslib.__assign({
          type: event2
        }, payload);
      }
      return event2;
    }
    function toSCXMLEvent(event2, scxmlEvent) {
      if (!isString(event2) && "$$type" in event2 && event2.$$type === "scxml") {
        return event2;
      }
      var eventObject = toEventObject(event2);
      return _tslib.__assign({
        name: eventObject.type,
        data: eventObject,
        $$type: "scxml",
        type: "external"
      }, scxmlEvent);
    }
    function toTransitionConfigArray(event2, configLike) {
      var transitions = toArrayStrict(configLike).map(function(transitionLike) {
        if (typeof transitionLike === "undefined" || typeof transitionLike === "string" || isMachine(transitionLike)) {
          return {
            target: transitionLike,
            event: event2
          };
        }
        return _tslib.__assign(_tslib.__assign({}, transitionLike), {
          event: event2
        });
      });
      return transitions;
    }
    function normalizeTarget(target) {
      if (target === void 0 || target === constants.TARGETLESS_KEY) {
        return void 0;
      }
      return toArray2(target);
    }
    function reportUnhandledExceptionOnInvocation(originalError, currentError, id) {
      if (!environment.IS_PRODUCTION) {
        var originalStackTrace = originalError.stack ? " Stacktrace was '".concat(originalError.stack, "'") : "";
        if (originalError === currentError) {
          console.error("Missing onError handler for invocation '".concat(id, "', error was '").concat(originalError, "'.").concat(originalStackTrace));
        } else {
          var stackTrace = currentError.stack ? " Stacktrace was '".concat(currentError.stack, "'") : "";
          console.error("Missing onError handler and/or unhandled exception/promise rejection for invocation '".concat(id, "'. ") + "Original error: '".concat(originalError, "'. ").concat(originalStackTrace, " Current error is '").concat(currentError, "'.").concat(stackTrace));
        }
      }
    }
    function evaluateGuard(machine, guard, context, _event, state) {
      var guards = machine.options.guards;
      var guardMeta = {
        state,
        cond: guard,
        _event
      };
      if (guard.type === constants.DEFAULT_GUARD_TYPE) {
        return ((guards === null || guards === void 0 ? void 0 : guards[guard.name]) || guard.predicate)(context, _event.data, guardMeta);
      }
      var condFn = guards === null || guards === void 0 ? void 0 : guards[guard.type];
      if (!condFn) {
        throw new Error("Guard '".concat(guard.type, "' is not implemented on machine '").concat(machine.id, "'."));
      }
      return condFn(context, _event.data, guardMeta);
    }
    function toInvokeSource(src) {
      if (typeof src === "string") {
        return {
          type: src
        };
      }
      return src;
    }
    function toObserver(nextHandler, errorHandler, completionHandler) {
      if (typeof nextHandler === "object") {
        return nextHandler;
      }
      var noop = function() {
        return void 0;
      };
      return {
        next: nextHandler,
        error: errorHandler || noop,
        complete: completionHandler || noop
      };
    }
    function createInvokeId(stateNodeId, index) {
      return "".concat(stateNodeId, ":invocation[").concat(index, "]");
    }
    exports.createInvokeId = createInvokeId;
    exports.evaluateGuard = evaluateGuard;
    exports.flatten = flatten;
    exports.getActionType = getActionType;
    exports.getEventType = getEventType;
    exports.interopSymbols = interopSymbols;
    exports.isActor = isActor;
    exports.isArray = isArray;
    exports.isBehavior = isBehavior;
    exports.isBuiltInEvent = isBuiltInEvent;
    exports.isFunction = isFunction;
    exports.isMachine = isMachine;
    exports.isObservable = isObservable;
    exports.isPromiseLike = isPromiseLike;
    exports.isStateLike = isStateLike;
    exports.isString = isString;
    exports.keys = keys;
    exports.mapContext = mapContext;
    exports.mapFilterValues = mapFilterValues;
    exports.mapValues = mapValues;
    exports.matchesState = matchesState;
    exports.nestedPath = nestedPath;
    exports.normalizeTarget = normalizeTarget;
    exports.partition = partition;
    exports.path = path2;
    exports.pathToStateValue = pathToStateValue;
    exports.pathsToStateValue = pathsToStateValue;
    exports.reportUnhandledExceptionOnInvocation = reportUnhandledExceptionOnInvocation;
    exports.symbolObservable = symbolObservable;
    exports.toArray = toArray2;
    exports.toArrayStrict = toArrayStrict;
    exports.toEventObject = toEventObject;
    exports.toGuard = toGuard;
    exports.toInvokeSource = toInvokeSource;
    exports.toObserver = toObserver;
    exports.toSCXMLEvent = toSCXMLEvent;
    exports.toStatePath = toStatePath;
    exports.toStatePaths = toStatePaths;
    exports.toStateValue = toStateValue;
    exports.toTransitionConfigArray = toTransitionConfigArray;
    exports.uniqueId = uniqueId;
    exports.updateContext = updateContext;
    exports.updateHistoryStates = updateHistoryStates;
    exports.updateHistoryValue = updateHistoryValue;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/actions.js
var require_actions = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/actions.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var types2 = require_types();
    var actionTypes = require_actionTypes();
    var utils = require_utils();
    var environment = require_environment();
    var initEvent = /* @__PURE__ */ utils.toSCXMLEvent({
      type: actionTypes.init
    });
    function getActionFunction(actionType, actionFunctionMap) {
      return actionFunctionMap ? actionFunctionMap[actionType] || void 0 : void 0;
    }
    function toActionObject(action, actionFunctionMap) {
      var actionObject;
      if (utils.isString(action) || typeof action === "number") {
        var exec = getActionFunction(action, actionFunctionMap);
        if (utils.isFunction(exec)) {
          actionObject = {
            type: action,
            exec
          };
        } else if (exec) {
          actionObject = exec;
        } else {
          actionObject = {
            type: action,
            exec: void 0
          };
        }
      } else if (utils.isFunction(action)) {
        actionObject = {
          type: action.name || action.toString(),
          exec: action
        };
      } else {
        var exec = getActionFunction(action.type, actionFunctionMap);
        if (utils.isFunction(exec)) {
          actionObject = _tslib.__assign(_tslib.__assign({}, action), {
            exec
          });
        } else if (exec) {
          var actionType = exec.type || action.type;
          actionObject = _tslib.__assign(_tslib.__assign(_tslib.__assign({}, exec), action), {
            type: actionType
          });
        } else {
          actionObject = action;
        }
      }
      return actionObject;
    }
    var toActionObjects = function(action, actionFunctionMap) {
      if (!action) {
        return [];
      }
      var actions2 = utils.isArray(action) ? action : [action];
      return actions2.map(function(subAction) {
        return toActionObject(subAction, actionFunctionMap);
      });
    };
    function toActivityDefinition(action) {
      var actionObject = toActionObject(action);
      return _tslib.__assign(_tslib.__assign({
        id: utils.isString(action) ? action : actionObject.id
      }, actionObject), {
        type: actionObject.type
      });
    }
    function raise(event2) {
      if (!utils.isString(event2)) {
        return send3(event2, {
          to: types2.SpecialTargets.Internal
        });
      }
      return {
        type: actionTypes.raise,
        event: event2
      };
    }
    function resolveRaise(action) {
      return {
        type: actionTypes.raise,
        _event: utils.toSCXMLEvent(action.event)
      };
    }
    function send3(event2, options) {
      return {
        to: options ? options.to : void 0,
        type: actionTypes.send,
        event: utils.isFunction(event2) ? event2 : utils.toEventObject(event2),
        delay: options ? options.delay : void 0,
        id: options && options.id !== void 0 ? options.id : utils.isFunction(event2) ? event2.name : utils.getEventType(event2)
      };
    }
    function resolveSend(action, ctx, _event, delaysMap) {
      var meta = {
        _event
      };
      var resolvedEvent = utils.toSCXMLEvent(utils.isFunction(action.event) ? action.event(ctx, _event.data, meta) : action.event);
      var resolvedDelay;
      if (utils.isString(action.delay)) {
        var configDelay = delaysMap && delaysMap[action.delay];
        resolvedDelay = utils.isFunction(configDelay) ? configDelay(ctx, _event.data, meta) : configDelay;
      } else {
        resolvedDelay = utils.isFunction(action.delay) ? action.delay(ctx, _event.data, meta) : action.delay;
      }
      var resolvedTarget = utils.isFunction(action.to) ? action.to(ctx, _event.data, meta) : action.to;
      return _tslib.__assign(_tslib.__assign({}, action), {
        to: resolvedTarget,
        _event: resolvedEvent,
        event: resolvedEvent.data,
        delay: resolvedDelay
      });
    }
    function sendParent(event2, options) {
      return send3(event2, _tslib.__assign(_tslib.__assign({}, options), {
        to: types2.SpecialTargets.Parent
      }));
    }
    function sendTo(actor, event2, options) {
      return send3(event2, _tslib.__assign(_tslib.__assign({}, options), {
        to: actor
      }));
    }
    function sendUpdate() {
      return sendParent(actionTypes.update);
    }
    function respond(event2, options) {
      return send3(event2, _tslib.__assign(_tslib.__assign({}, options), {
        to: function(_, __, _a) {
          var _event = _a._event;
          return _event.origin;
        }
      }));
    }
    var defaultLogExpr = function(context, event2) {
      return {
        context,
        event: event2
      };
    };
    function log(expr, label) {
      if (expr === void 0) {
        expr = defaultLogExpr;
      }
      return {
        type: actionTypes.log,
        label,
        expr
      };
    }
    var resolveLog = function(action, ctx, _event) {
      return _tslib.__assign(_tslib.__assign({}, action), {
        value: utils.isString(action.expr) ? action.expr : action.expr(ctx, _event.data, {
          _event
        })
      });
    };
    var cancel = function(sendId) {
      return {
        type: actionTypes.cancel,
        sendId
      };
    };
    function start(activity) {
      var activityDef = toActivityDefinition(activity);
      return {
        type: types2.ActionTypes.Start,
        activity: activityDef,
        exec: void 0
      };
    }
    function stop(actorRef) {
      var activity = utils.isFunction(actorRef) ? actorRef : toActivityDefinition(actorRef);
      return {
        type: types2.ActionTypes.Stop,
        activity,
        exec: void 0
      };
    }
    function resolveStop(action, context, _event) {
      var actorRefOrString = utils.isFunction(action.activity) ? action.activity(context, _event.data) : action.activity;
      var resolvedActorRef = typeof actorRefOrString === "string" ? {
        id: actorRefOrString
      } : actorRefOrString;
      var actionObject = {
        type: types2.ActionTypes.Stop,
        activity: resolvedActorRef
      };
      return actionObject;
    }
    var assign3 = function(assignment) {
      return {
        type: actionTypes.assign,
        assignment
      };
    };
    function isActionObject(action) {
      return typeof action === "object" && "type" in action;
    }
    function after(delayRef, id) {
      var idSuffix = id ? "#".concat(id) : "";
      return "".concat(types2.ActionTypes.After, "(").concat(delayRef, ")").concat(idSuffix);
    }
    function done(id, data) {
      var type2 = "".concat(types2.ActionTypes.DoneState, ".").concat(id);
      var eventObject = {
        type: type2,
        data
      };
      eventObject.toString = function() {
        return type2;
      };
      return eventObject;
    }
    function doneInvoke(id, data) {
      var type2 = "".concat(types2.ActionTypes.DoneInvoke, ".").concat(id);
      var eventObject = {
        type: type2,
        data
      };
      eventObject.toString = function() {
        return type2;
      };
      return eventObject;
    }
    function error(id, data) {
      var type2 = "".concat(types2.ActionTypes.ErrorPlatform, ".").concat(id);
      var eventObject = {
        type: type2,
        data
      };
      eventObject.toString = function() {
        return type2;
      };
      return eventObject;
    }
    function pure(getActions) {
      return {
        type: types2.ActionTypes.Pure,
        get: getActions
      };
    }
    function forwardTo(target, options) {
      return send3(function(_, event2) {
        return event2;
      }, _tslib.__assign(_tslib.__assign({}, options), {
        to: target
      }));
    }
    function escalate(errorData, options) {
      return sendParent(function(context, event2, meta) {
        return {
          type: actionTypes.error,
          data: utils.isFunction(errorData) ? errorData(context, event2, meta) : errorData
        };
      }, _tslib.__assign(_tslib.__assign({}, options), {
        to: types2.SpecialTargets.Parent
      }));
    }
    function choose(conds) {
      return {
        type: types2.ActionTypes.Choose,
        conds
      };
    }
    function resolveActions(machine, currentState, currentContext, _event, actions2, preserveActionOrder) {
      if (preserveActionOrder === void 0) {
        preserveActionOrder = false;
      }
      var _a = _tslib.__read(preserveActionOrder ? [[], actions2] : utils.partition(actions2, function(action) {
        return action.type === actionTypes.assign;
      }), 2), assignActions = _a[0], otherActions = _a[1];
      var updatedContext = assignActions.length ? utils.updateContext(currentContext, _event, assignActions, currentState) : currentContext;
      var preservedContexts = preserveActionOrder ? [currentContext] : void 0;
      var resolvedActions = utils.flatten(otherActions.map(function(actionObject) {
        var _a2;
        switch (actionObject.type) {
          case actionTypes.raise:
            return resolveRaise(actionObject);
          case actionTypes.send:
            var sendAction = resolveSend(actionObject, updatedContext, _event, machine.options.delays);
            if (!environment.IS_PRODUCTION) {
              utils.warn(!utils.isString(actionObject.delay) || typeof sendAction.delay === "number", "No delay reference for delay expression '".concat(actionObject.delay, "' was found on machine '").concat(machine.id, "'"));
            }
            return sendAction;
          case actionTypes.log:
            return resolveLog(actionObject, updatedContext, _event);
          case actionTypes.choose: {
            var chooseAction = actionObject;
            var matchedActions = (_a2 = chooseAction.conds.find(function(condition) {
              var guard = utils.toGuard(condition.cond, machine.options.guards);
              return !guard || utils.evaluateGuard(machine, guard, updatedContext, _event, currentState);
            })) === null || _a2 === void 0 ? void 0 : _a2.actions;
            if (!matchedActions) {
              return [];
            }
            var _b = _tslib.__read(resolveActions(machine, currentState, updatedContext, _event, toActionObjects(utils.toArray(matchedActions), machine.options.actions), preserveActionOrder), 2), resolvedActionsFromChoose = _b[0], resolvedContextFromChoose = _b[1];
            updatedContext = resolvedContextFromChoose;
            preservedContexts === null || preservedContexts === void 0 ? void 0 : preservedContexts.push(updatedContext);
            return resolvedActionsFromChoose;
          }
          case actionTypes.pure: {
            var matchedActions = actionObject.get(updatedContext, _event.data);
            if (!matchedActions) {
              return [];
            }
            var _c = _tslib.__read(resolveActions(machine, currentState, updatedContext, _event, toActionObjects(utils.toArray(matchedActions), machine.options.actions), preserveActionOrder), 2), resolvedActionsFromPure = _c[0], resolvedContext = _c[1];
            updatedContext = resolvedContext;
            preservedContexts === null || preservedContexts === void 0 ? void 0 : preservedContexts.push(updatedContext);
            return resolvedActionsFromPure;
          }
          case actionTypes.stop: {
            return resolveStop(actionObject, updatedContext, _event);
          }
          case actionTypes.assign: {
            updatedContext = utils.updateContext(updatedContext, _event, [actionObject], currentState);
            preservedContexts === null || preservedContexts === void 0 ? void 0 : preservedContexts.push(updatedContext);
            break;
          }
          default:
            var resolvedActionObject = toActionObject(actionObject, machine.options.actions);
            var exec_1 = resolvedActionObject.exec;
            if (exec_1 && preservedContexts) {
              var contextIndex_1 = preservedContexts.length - 1;
              resolvedActionObject = _tslib.__assign(_tslib.__assign({}, resolvedActionObject), {
                exec: function(_ctx) {
                  var args = [];
                  for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                  }
                  exec_1.apply(void 0, _tslib.__spreadArray([preservedContexts[contextIndex_1]], _tslib.__read(args), false));
                }
              });
            }
            return resolvedActionObject;
        }
      }).filter(function(a) {
        return !!a;
      }));
      return [resolvedActions, updatedContext];
    }
    exports.actionTypes = actionTypes;
    exports.after = after;
    exports.assign = assign3;
    exports.cancel = cancel;
    exports.choose = choose;
    exports.done = done;
    exports.doneInvoke = doneInvoke;
    exports.error = error;
    exports.escalate = escalate;
    exports.forwardTo = forwardTo;
    exports.getActionFunction = getActionFunction;
    exports.initEvent = initEvent;
    exports.isActionObject = isActionObject;
    exports.log = log;
    exports.pure = pure;
    exports.raise = raise;
    exports.resolveActions = resolveActions;
    exports.resolveLog = resolveLog;
    exports.resolveRaise = resolveRaise;
    exports.resolveSend = resolveSend;
    exports.resolveStop = resolveStop;
    exports.respond = respond;
    exports.send = send3;
    exports.sendParent = sendParent;
    exports.sendTo = sendTo;
    exports.sendUpdate = sendUpdate;
    exports.start = start;
    exports.stop = stop;
    exports.toActionObject = toActionObject;
    exports.toActionObjects = toActionObjects;
    exports.toActivityDefinition = toActivityDefinition;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/serviceScope.js
var require_serviceScope = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/serviceScope.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var serviceStack = [];
    var provide = function(service, fn) {
      serviceStack.push(service);
      var result2 = fn(service);
      serviceStack.pop();
      return result2;
    };
    var consume = function(fn) {
      return fn(serviceStack[serviceStack.length - 1]);
    };
    exports.consume = consume;
    exports.provide = provide;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/Actor.js
var require_Actor = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/Actor.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    var serviceScope = require_serviceScope();
    function createNullActor(id) {
      var _a;
      return _a = {
        id,
        send: function() {
          return void 0;
        },
        subscribe: function() {
          return {
            unsubscribe: function() {
              return void 0;
            }
          };
        },
        getSnapshot: function() {
          return void 0;
        },
        toJSON: function() {
          return {
            id
          };
        }
      }, _a[utils.symbolObservable] = function() {
        return this;
      }, _a;
    }
    function createInvocableActor(invokeDefinition, machine, context, _event) {
      var _a;
      var invokeSrc = utils.toInvokeSource(invokeDefinition.src);
      var serviceCreator = (_a = machine === null || machine === void 0 ? void 0 : machine.options.services) === null || _a === void 0 ? void 0 : _a[invokeSrc.type];
      var resolvedData = invokeDefinition.data ? utils.mapContext(invokeDefinition.data, context, _event) : void 0;
      var tempActor = serviceCreator ? createDeferredActor(serviceCreator, invokeDefinition.id, resolvedData) : createNullActor(invokeDefinition.id);
      tempActor.meta = invokeDefinition;
      return tempActor;
    }
    function createDeferredActor(entity, id, data) {
      var tempActor = createNullActor(id);
      tempActor.deferred = true;
      if (utils.isMachine(entity)) {
        var initialState_1 = tempActor.state = serviceScope.provide(void 0, function() {
          return (data ? entity.withContext(data) : entity).initialState;
        });
        tempActor.getSnapshot = function() {
          return initialState_1;
        };
      }
      return tempActor;
    }
    function isActor(item) {
      try {
        return typeof item.send === "function";
      } catch (e) {
        return false;
      }
    }
    function isSpawnedActor(item) {
      return isActor(item) && "id" in item;
    }
    function toActorRef(actorRefLike) {
      var _a;
      return _tslib.__assign((_a = {
        subscribe: function() {
          return {
            unsubscribe: function() {
              return void 0;
            }
          };
        },
        id: "anonymous",
        getSnapshot: function() {
          return void 0;
        }
      }, _a[utils.symbolObservable] = function() {
        return this;
      }, _a), actorRefLike);
    }
    exports.createDeferredActor = createDeferredActor;
    exports.createInvocableActor = createInvocableActor;
    exports.createNullActor = createNullActor;
    exports.isActor = isActor;
    exports.isSpawnedActor = isSpawnedActor;
    exports.toActorRef = toActorRef;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/stateUtils.js
var require_stateUtils = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/stateUtils.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    var isLeafNode = function(stateNode) {
      return stateNode.type === "atomic" || stateNode.type === "final";
    };
    function getChildren(stateNode) {
      return Object.keys(stateNode.states).map(function(key) {
        return stateNode.states[key];
      }).filter(function(sn) {
        return sn.type !== "history";
      });
    }
    function getAllStateNodes(stateNode) {
      var stateNodes = [stateNode];
      if (isLeafNode(stateNode)) {
        return stateNodes;
      }
      return stateNodes.concat(utils.flatten(getChildren(stateNode).map(getAllStateNodes)));
    }
    function getConfiguration(prevStateNodes, stateNodes) {
      var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
      var prevConfiguration = new Set(prevStateNodes);
      var prevAdjList = getAdjList(prevConfiguration);
      var configuration = new Set(stateNodes);
      try {
        for (var configuration_1 = _tslib.__values(configuration), configuration_1_1 = configuration_1.next(); !configuration_1_1.done; configuration_1_1 = configuration_1.next()) {
          var s = configuration_1_1.value;
          var m = s.parent;
          while (m && !configuration.has(m)) {
            configuration.add(m);
            m = m.parent;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (configuration_1_1 && !configuration_1_1.done && (_a = configuration_1.return))
            _a.call(configuration_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      var adjList = getAdjList(configuration);
      try {
        for (var configuration_2 = _tslib.__values(configuration), configuration_2_1 = configuration_2.next(); !configuration_2_1.done; configuration_2_1 = configuration_2.next()) {
          var s = configuration_2_1.value;
          if (s.type === "compound" && (!adjList.get(s) || !adjList.get(s).length)) {
            if (prevAdjList.get(s)) {
              prevAdjList.get(s).forEach(function(sn) {
                return configuration.add(sn);
              });
            } else {
              s.initialStateNodes.forEach(function(sn) {
                return configuration.add(sn);
              });
            }
          } else {
            if (s.type === "parallel") {
              try {
                for (var _e = (e_3 = void 0, _tslib.__values(getChildren(s))), _f = _e.next(); !_f.done; _f = _e.next()) {
                  var child = _f.value;
                  if (!configuration.has(child)) {
                    configuration.add(child);
                    if (prevAdjList.get(child)) {
                      prevAdjList.get(child).forEach(function(sn) {
                        return configuration.add(sn);
                      });
                    } else {
                      child.initialStateNodes.forEach(function(sn) {
                        return configuration.add(sn);
                      });
                    }
                  }
                }
              } catch (e_3_1) {
                e_3 = {
                  error: e_3_1
                };
              } finally {
                try {
                  if (_f && !_f.done && (_c = _e.return))
                    _c.call(_e);
                } finally {
                  if (e_3)
                    throw e_3.error;
                }
              }
            }
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (configuration_2_1 && !configuration_2_1.done && (_b = configuration_2.return))
            _b.call(configuration_2);
        } finally {
          if (e_2)
            throw e_2.error;
        }
      }
      try {
        for (var configuration_3 = _tslib.__values(configuration), configuration_3_1 = configuration_3.next(); !configuration_3_1.done; configuration_3_1 = configuration_3.next()) {
          var s = configuration_3_1.value;
          var m = s.parent;
          while (m && !configuration.has(m)) {
            configuration.add(m);
            m = m.parent;
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (configuration_3_1 && !configuration_3_1.done && (_d = configuration_3.return))
            _d.call(configuration_3);
        } finally {
          if (e_4)
            throw e_4.error;
        }
      }
      return configuration;
    }
    function getValueFromAdj(baseNode, adjList) {
      var childStateNodes = adjList.get(baseNode);
      if (!childStateNodes) {
        return {};
      }
      if (baseNode.type === "compound") {
        var childStateNode = childStateNodes[0];
        if (childStateNode) {
          if (isLeafNode(childStateNode)) {
            return childStateNode.key;
          }
        } else {
          return {};
        }
      }
      var stateValue = {};
      childStateNodes.forEach(function(csn) {
        stateValue[csn.key] = getValueFromAdj(csn, adjList);
      });
      return stateValue;
    }
    function getAdjList(configuration) {
      var e_5, _a;
      var adjList = /* @__PURE__ */ new Map();
      try {
        for (var configuration_4 = _tslib.__values(configuration), configuration_4_1 = configuration_4.next(); !configuration_4_1.done; configuration_4_1 = configuration_4.next()) {
          var s = configuration_4_1.value;
          if (!adjList.has(s)) {
            adjList.set(s, []);
          }
          if (s.parent) {
            if (!adjList.has(s.parent)) {
              adjList.set(s.parent, []);
            }
            adjList.get(s.parent).push(s);
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (configuration_4_1 && !configuration_4_1.done && (_a = configuration_4.return))
            _a.call(configuration_4);
        } finally {
          if (e_5)
            throw e_5.error;
        }
      }
      return adjList;
    }
    function getValue(rootNode, configuration) {
      var config = getConfiguration([rootNode], configuration);
      return getValueFromAdj(rootNode, getAdjList(config));
    }
    function has(iterable, item) {
      if (Array.isArray(iterable)) {
        return iterable.some(function(member) {
          return member === item;
        });
      }
      if (iterable instanceof Set) {
        return iterable.has(item);
      }
      return false;
    }
    function nextEvents(configuration) {
      return _tslib.__spreadArray([], _tslib.__read(new Set(utils.flatten(_tslib.__spreadArray([], _tslib.__read(configuration.map(function(sn) {
        return sn.ownEvents;
      })), false)))), false);
    }
    function isInFinalState(configuration, stateNode) {
      if (stateNode.type === "compound") {
        return getChildren(stateNode).some(function(s) {
          return s.type === "final" && has(configuration, s);
        });
      }
      if (stateNode.type === "parallel") {
        return getChildren(stateNode).every(function(sn) {
          return isInFinalState(configuration, sn);
        });
      }
      return false;
    }
    function getMeta(configuration) {
      if (configuration === void 0) {
        configuration = [];
      }
      return configuration.reduce(function(acc, stateNode) {
        if (stateNode.meta !== void 0) {
          acc[stateNode.id] = stateNode.meta;
        }
        return acc;
      }, {});
    }
    function getTagsFromConfiguration(configuration) {
      return new Set(utils.flatten(configuration.map(function(sn) {
        return sn.tags;
      })));
    }
    exports.getAdjList = getAdjList;
    exports.getAllStateNodes = getAllStateNodes;
    exports.getChildren = getChildren;
    exports.getConfiguration = getConfiguration;
    exports.getMeta = getMeta;
    exports.getTagsFromConfiguration = getTagsFromConfiguration;
    exports.getValue = getValue;
    exports.has = has;
    exports.isInFinalState = isInFinalState;
    exports.isLeafNode = isLeafNode;
    exports.nextEvents = nextEvents;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/State.js
var require_State = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/State.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var constants = require_constants();
    var utils = require_utils();
    var stateUtils = require_stateUtils();
    var actions2 = require_actions();
    var environment = require_environment();
    function stateValuesEqual(a, b) {
      if (a === b) {
        return true;
      }
      if (a === void 0 || b === void 0) {
        return false;
      }
      if (utils.isString(a) || utils.isString(b)) {
        return a === b;
      }
      var aKeys = Object.keys(a);
      var bKeys = Object.keys(b);
      return aKeys.length === bKeys.length && aKeys.every(function(key) {
        return stateValuesEqual(a[key], b[key]);
      });
    }
    function isStateConfig(state) {
      if (typeof state !== "object" || state === null) {
        return false;
      }
      return "value" in state && "_event" in state;
    }
    var isState = isStateConfig;
    function bindActionToState(action, state) {
      var exec = action.exec;
      var boundAction = _tslib.__assign(_tslib.__assign({}, action), {
        exec: exec !== void 0 ? function() {
          return exec(state.context, state.event, {
            action,
            state,
            _event: state._event
          });
        } : void 0
      });
      return boundAction;
    }
    var State2 = /* @__PURE__ */ function() {
      function State3(config) {
        var _this = this;
        var _a;
        this.actions = [];
        this.activities = constants.EMPTY_ACTIVITY_MAP;
        this.meta = {};
        this.events = [];
        this.value = config.value;
        this.context = config.context;
        this._event = config._event;
        this._sessionid = config._sessionid;
        this.event = this._event.data;
        this.historyValue = config.historyValue;
        this.history = config.history;
        this.actions = config.actions || [];
        this.activities = config.activities || constants.EMPTY_ACTIVITY_MAP;
        this.meta = stateUtils.getMeta(config.configuration);
        this.events = config.events || [];
        this.matches = this.matches.bind(this);
        this.toStrings = this.toStrings.bind(this);
        this.configuration = config.configuration;
        this.transitions = config.transitions;
        this.children = config.children;
        this.done = !!config.done;
        this.tags = (_a = Array.isArray(config.tags) ? new Set(config.tags) : config.tags) !== null && _a !== void 0 ? _a : /* @__PURE__ */ new Set();
        this.machine = config.machine;
        Object.defineProperty(this, "nextEvents", {
          get: function() {
            return stateUtils.nextEvents(_this.configuration);
          }
        });
      }
      State3.from = function(stateValue, context) {
        if (stateValue instanceof State3) {
          if (stateValue.context !== context) {
            return new State3({
              value: stateValue.value,
              context,
              _event: stateValue._event,
              _sessionid: null,
              historyValue: stateValue.historyValue,
              history: stateValue.history,
              actions: [],
              activities: stateValue.activities,
              meta: {},
              events: [],
              configuration: [],
              transitions: [],
              children: {}
            });
          }
          return stateValue;
        }
        var _event = actions2.initEvent;
        return new State3({
          value: stateValue,
          context,
          _event,
          _sessionid: null,
          historyValue: void 0,
          history: void 0,
          actions: [],
          activities: void 0,
          meta: void 0,
          events: [],
          configuration: [],
          transitions: [],
          children: {}
        });
      };
      State3.create = function(config) {
        return new State3(config);
      };
      State3.inert = function(stateValue, context) {
        if (stateValue instanceof State3) {
          if (!stateValue.actions.length) {
            return stateValue;
          }
          var _event = actions2.initEvent;
          return new State3({
            value: stateValue.value,
            context,
            _event,
            _sessionid: null,
            historyValue: stateValue.historyValue,
            history: stateValue.history,
            activities: stateValue.activities,
            configuration: stateValue.configuration,
            transitions: [],
            children: {}
          });
        }
        return State3.from(stateValue, context);
      };
      State3.prototype.toStrings = function(stateValue, delimiter) {
        var _this = this;
        if (stateValue === void 0) {
          stateValue = this.value;
        }
        if (delimiter === void 0) {
          delimiter = ".";
        }
        if (utils.isString(stateValue)) {
          return [stateValue];
        }
        var valueKeys = Object.keys(stateValue);
        return valueKeys.concat.apply(valueKeys, _tslib.__spreadArray([], _tslib.__read(valueKeys.map(function(key) {
          return _this.toStrings(stateValue[key], delimiter).map(function(s) {
            return key + delimiter + s;
          });
        })), false));
      };
      State3.prototype.toJSON = function() {
        var _a = this;
        _a.configuration;
        _a.transitions;
        var tags = _a.tags;
        _a.machine;
        var jsonValues = _tslib.__rest(_a, ["configuration", "transitions", "tags", "machine"]);
        return _tslib.__assign(_tslib.__assign({}, jsonValues), {
          tags: Array.from(tags)
        });
      };
      State3.prototype.matches = function(parentStateValue) {
        return utils.matchesState(parentStateValue, this.value);
      };
      State3.prototype.hasTag = function(tag) {
        return this.tags.has(tag);
      };
      State3.prototype.can = function(event2) {
        var _a;
        if (environment.IS_PRODUCTION) {
          utils.warn(!!this.machine, "state.can(...) used outside of a machine-created State object; this will always return false.");
        }
        var transitionData = (_a = this.machine) === null || _a === void 0 ? void 0 : _a.getTransitionData(this, event2);
        return !!(transitionData === null || transitionData === void 0 ? void 0 : transitionData.transitions.length) && transitionData.transitions.some(function(t) {
          return t.target !== void 0 || t.actions.length;
        });
      };
      return State3;
    }();
    exports.State = State2;
    exports.bindActionToState = bindActionToState;
    exports.isState = isState;
    exports.isStateConfig = isStateConfig;
    exports.stateValuesEqual = stateValuesEqual;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/scheduler.js
var require_scheduler = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/scheduler.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var defaultOptions = {
      deferEvents: false
    };
    var Scheduler = /* @__PURE__ */ function() {
      function Scheduler2(options) {
        this.processingEvent = false;
        this.queue = [];
        this.initialized = false;
        this.options = _tslib.__assign(_tslib.__assign({}, defaultOptions), options);
      }
      Scheduler2.prototype.initialize = function(callback) {
        this.initialized = true;
        if (callback) {
          if (!this.options.deferEvents) {
            this.schedule(callback);
            return;
          }
          this.process(callback);
        }
        this.flushEvents();
      };
      Scheduler2.prototype.schedule = function(task2) {
        if (!this.initialized || this.processingEvent) {
          this.queue.push(task2);
          return;
        }
        if (this.queue.length !== 0) {
          throw new Error("Event queue should be empty when it is not processing events");
        }
        this.process(task2);
        this.flushEvents();
      };
      Scheduler2.prototype.clear = function() {
        this.queue = [];
      };
      Scheduler2.prototype.flushEvents = function() {
        var nextCallback = this.queue.shift();
        while (nextCallback) {
          this.process(nextCallback);
          nextCallback = this.queue.shift();
        }
      };
      Scheduler2.prototype.process = function(callback) {
        this.processingEvent = true;
        try {
          callback();
        } catch (e) {
          this.clear();
          throw e;
        } finally {
          this.processingEvent = false;
        }
      };
      return Scheduler2;
    }();
    exports.Scheduler = Scheduler;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/registry.js
var require_registry = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/registry.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var children = /* @__PURE__ */ new Map();
    var sessionIdIndex = 0;
    var registry = {
      bookId: function() {
        return "x:".concat(sessionIdIndex++);
      },
      register: function(id, actor) {
        children.set(id, actor);
        return id;
      },
      get: function(id) {
        return children.get(id);
      },
      free: function(id) {
        children.delete(id);
      }
    };
    exports.registry = registry;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/devTools.js
var require_devTools = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/devTools.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var environment = require_environment();
    function getGlobal() {
      if (typeof globalThis !== "undefined") {
        return globalThis;
      }
      if (typeof self !== "undefined") {
        return self;
      }
      if (typeof window !== "undefined") {
        return window;
      }
      if (typeof global !== "undefined") {
        return global;
      }
      if (!environment.IS_PRODUCTION) {
        console.warn("XState could not find a global object in this environment. Please let the maintainers know and raise an issue here: https://github.com/statelyai/xstate/issues");
      }
    }
    function getDevTools() {
      var global2 = getGlobal();
      if (global2 && "__xstate__" in global2) {
        return global2.__xstate__;
      }
      return void 0;
    }
    function registerService(service) {
      if (!getGlobal()) {
        return;
      }
      var devTools = getDevTools();
      if (devTools) {
        devTools.register(service);
      }
    }
    exports.getGlobal = getGlobal;
    exports.registerService = registerService;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/behaviors.js
var require_behaviors = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/behaviors.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var actions2 = require_actions();
    var Actor = require_Actor();
    var utils = require_utils();
    function fromReducer(transition, initialState) {
      return {
        transition,
        initialState
      };
    }
    function fromPromise(promiseFn) {
      var initialState = {
        error: void 0,
        data: void 0,
        status: "pending"
      };
      return {
        transition: function(state, event2, _a) {
          var parent = _a.parent, id = _a.id, observers = _a.observers;
          switch (event2.type) {
            case "fulfill":
              parent === null || parent === void 0 ? void 0 : parent.send(actions2.doneInvoke(id, event2.data));
              return {
                error: void 0,
                data: event2.data,
                status: "fulfilled"
              };
            case "reject":
              parent === null || parent === void 0 ? void 0 : parent.send(actions2.error(id, event2.error));
              observers.forEach(function(observer) {
                observer.error(event2.error);
              });
              return {
                error: event2.error,
                data: void 0,
                status: "rejected"
              };
            default:
              return state;
          }
        },
        initialState,
        start: function(_a) {
          var self2 = _a.self;
          promiseFn().then(function(data) {
            self2.send({
              type: "fulfill",
              data
            });
          }, function(reason) {
            self2.send({
              type: "reject",
              error: reason
            });
          });
          return initialState;
        }
      };
    }
    function spawnBehavior(behavior, options) {
      if (options === void 0) {
        options = {};
      }
      var state = behavior.initialState;
      var observers = /* @__PURE__ */ new Set();
      var mailbox = [];
      var flushing = false;
      var flush = function() {
        if (flushing) {
          return;
        }
        flushing = true;
        while (mailbox.length > 0) {
          var event_1 = mailbox.shift();
          state = behavior.transition(state, event_1, actorCtx);
          observers.forEach(function(observer) {
            return observer.next(state);
          });
        }
        flushing = false;
      };
      var actor = Actor.toActorRef({
        id: options.id,
        send: function(event2) {
          mailbox.push(event2);
          flush();
        },
        getSnapshot: function() {
          return state;
        },
        subscribe: function(next, handleError, complete) {
          var observer = utils.toObserver(next, handleError, complete);
          observers.add(observer);
          observer.next(state);
          return {
            unsubscribe: function() {
              observers.delete(observer);
            }
          };
        }
      });
      var actorCtx = {
        parent: options.parent,
        self: actor,
        id: options.id || "anonymous",
        observers
      };
      state = behavior.start ? behavior.start(actorCtx) : state;
      return actor;
    }
    exports.fromPromise = fromPromise;
    exports.fromReducer = fromReducer;
    exports.spawnBehavior = spawnBehavior;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/interpreter.js
var require_interpreter = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/interpreter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var types2 = require_types();
    var State2 = require_State();
    var actionTypes = require_actionTypes();
    var actions2 = require_actions();
    var environment = require_environment();
    var utils = require_utils();
    var scheduler = require_scheduler();
    var Actor = require_Actor();
    var stateUtils = require_stateUtils();
    var registry = require_registry();
    var devTools = require_devTools();
    var serviceScope = require_serviceScope();
    var behaviors = require_behaviors();
    var DEFAULT_SPAWN_OPTIONS = {
      sync: false,
      autoForward: false
    };
    exports.InterpreterStatus = void 0;
    (function(InterpreterStatus) {
      InterpreterStatus[InterpreterStatus["NotStarted"] = 0] = "NotStarted";
      InterpreterStatus[InterpreterStatus["Running"] = 1] = "Running";
      InterpreterStatus[InterpreterStatus["Stopped"] = 2] = "Stopped";
    })(exports.InterpreterStatus || (exports.InterpreterStatus = {}));
    var Interpreter = /* @__PURE__ */ function() {
      function Interpreter2(machine, options) {
        var _this = this;
        if (options === void 0) {
          options = Interpreter2.defaultOptions;
        }
        this.machine = machine;
        this.delayedEventsMap = {};
        this.listeners = /* @__PURE__ */ new Set();
        this.contextListeners = /* @__PURE__ */ new Set();
        this.stopListeners = /* @__PURE__ */ new Set();
        this.doneListeners = /* @__PURE__ */ new Set();
        this.eventListeners = /* @__PURE__ */ new Set();
        this.sendListeners = /* @__PURE__ */ new Set();
        this.initialized = false;
        this.status = exports.InterpreterStatus.NotStarted;
        this.children = /* @__PURE__ */ new Map();
        this.forwardTo = /* @__PURE__ */ new Set();
        this.init = this.start;
        this.send = function(event2, payload) {
          if (utils.isArray(event2)) {
            _this.batch(event2);
            return _this.state;
          }
          var _event = utils.toSCXMLEvent(utils.toEventObject(event2, payload));
          if (_this.status === exports.InterpreterStatus.Stopped) {
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, 'Event "'.concat(_event.name, '" was sent to stopped service "').concat(_this.machine.id, '". This service has already reached its final state, and will not transition.\nEvent: ').concat(JSON.stringify(_event.data)));
            }
            return _this.state;
          }
          if (_this.status !== exports.InterpreterStatus.Running && !_this.options.deferEvents) {
            throw new Error('Event "'.concat(_event.name, '" was sent to uninitialized service "').concat(_this.machine.id, '". Make sure .start() is called for this service, or set { deferEvents: true } in the service options.\nEvent: ').concat(JSON.stringify(_event.data)));
          }
          _this.scheduler.schedule(function() {
            _this.forward(_event);
            var nextState = _this.nextState(_event);
            _this.update(nextState, _event);
          });
          return _this._state;
        };
        this.sendTo = function(event2, to) {
          var isParent = _this.parent && (to === types2.SpecialTargets.Parent || _this.parent.id === to);
          var target = isParent ? _this.parent : utils.isString(to) ? _this.children.get(to) || registry.registry.get(to) : utils.isActor(to) ? to : void 0;
          if (!target) {
            if (!isParent) {
              throw new Error("Unable to send event to child '".concat(to, "' from service '").concat(_this.id, "'."));
            }
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, "Service '".concat(_this.id, "' has no parent: unable to send event ").concat(event2.type));
            }
            return;
          }
          if ("machine" in target) {
            target.send(_tslib.__assign(_tslib.__assign({}, event2), {
              name: event2.name === actionTypes.error ? "".concat(actions2.error(_this.id)) : event2.name,
              origin: _this.sessionId
            }));
          } else {
            target.send(event2.data);
          }
        };
        var resolvedOptions = _tslib.__assign(_tslib.__assign({}, Interpreter2.defaultOptions), options);
        var clock = resolvedOptions.clock, logger = resolvedOptions.logger, parent = resolvedOptions.parent, id = resolvedOptions.id;
        var resolvedId = id !== void 0 ? id : machine.id;
        this.id = resolvedId;
        this.logger = logger;
        this.clock = clock;
        this.parent = parent;
        this.options = resolvedOptions;
        this.scheduler = new scheduler.Scheduler({
          deferEvents: this.options.deferEvents
        });
        this.sessionId = registry.registry.bookId();
      }
      Object.defineProperty(Interpreter2.prototype, "initialState", {
        get: function() {
          var _this = this;
          if (this._initialState) {
            return this._initialState;
          }
          return serviceScope.provide(this, function() {
            _this._initialState = _this.machine.initialState;
            return _this._initialState;
          });
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Interpreter2.prototype, "state", {
        get: function() {
          if (!environment.IS_PRODUCTION) {
            utils.warn(this.status !== exports.InterpreterStatus.NotStarted, "Attempted to read state from uninitialized service '".concat(this.id, "'. Make sure the service is started first."));
          }
          return this._state;
        },
        enumerable: false,
        configurable: true
      });
      Interpreter2.prototype.execute = function(state, actionsConfig) {
        var e_1, _a;
        try {
          for (var _b = _tslib.__values(state.actions), _c = _b.next(); !_c.done; _c = _b.next()) {
            var action = _c.value;
            this.exec(action, state, actionsConfig);
          }
        } catch (e_1_1) {
          e_1 = {
            error: e_1_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return))
              _a.call(_b);
          } finally {
            if (e_1)
              throw e_1.error;
          }
        }
      };
      Interpreter2.prototype.update = function(state, _event) {
        var e_2, _a, e_3, _b, e_4, _c, e_5, _d;
        var _this = this;
        state._sessionid = this.sessionId;
        this._state = state;
        if (this.options.execute) {
          this.execute(this.state);
        }
        this.children.forEach(function(child) {
          _this.state.children[child.id] = child;
        });
        if (this.devTools) {
          this.devTools.send(_event.data, state);
        }
        if (state.event) {
          try {
            for (var _e = _tslib.__values(this.eventListeners), _f = _e.next(); !_f.done; _f = _e.next()) {
              var listener = _f.value;
              listener(state.event);
            }
          } catch (e_2_1) {
            e_2 = {
              error: e_2_1
            };
          } finally {
            try {
              if (_f && !_f.done && (_a = _e.return))
                _a.call(_e);
            } finally {
              if (e_2)
                throw e_2.error;
            }
          }
        }
        try {
          for (var _g = _tslib.__values(this.listeners), _h = _g.next(); !_h.done; _h = _g.next()) {
            var listener = _h.value;
            listener(state, state.event);
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_h && !_h.done && (_b = _g.return))
              _b.call(_g);
          } finally {
            if (e_3)
              throw e_3.error;
          }
        }
        try {
          for (var _j = _tslib.__values(this.contextListeners), _k = _j.next(); !_k.done; _k = _j.next()) {
            var contextListener = _k.value;
            contextListener(this.state.context, this.state.history ? this.state.history.context : void 0);
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (_k && !_k.done && (_c = _j.return))
              _c.call(_j);
          } finally {
            if (e_4)
              throw e_4.error;
          }
        }
        var isDone = stateUtils.isInFinalState(state.configuration || [], this.machine);
        if (this.state.configuration && isDone) {
          var finalChildStateNode = state.configuration.find(function(sn) {
            return sn.type === "final" && sn.parent === _this.machine;
          });
          var doneData = finalChildStateNode && finalChildStateNode.doneData ? utils.mapContext(finalChildStateNode.doneData, state.context, _event) : void 0;
          try {
            for (var _l = _tslib.__values(this.doneListeners), _m = _l.next(); !_m.done; _m = _l.next()) {
              var listener = _m.value;
              listener(actions2.doneInvoke(this.id, doneData));
            }
          } catch (e_5_1) {
            e_5 = {
              error: e_5_1
            };
          } finally {
            try {
              if (_m && !_m.done && (_d = _l.return))
                _d.call(_l);
            } finally {
              if (e_5)
                throw e_5.error;
            }
          }
          this.stop();
        }
      };
      Interpreter2.prototype.onTransition = function(listener) {
        this.listeners.add(listener);
        if (this.status === exports.InterpreterStatus.Running) {
          listener(this.state, this.state.event);
        }
        return this;
      };
      Interpreter2.prototype.subscribe = function(nextListenerOrObserver, _, completeListener) {
        var _this = this;
        if (!nextListenerOrObserver) {
          return {
            unsubscribe: function() {
              return void 0;
            }
          };
        }
        var listener;
        var resolvedCompleteListener = completeListener;
        if (typeof nextListenerOrObserver === "function") {
          listener = nextListenerOrObserver;
        } else {
          listener = nextListenerOrObserver.next.bind(nextListenerOrObserver);
          resolvedCompleteListener = nextListenerOrObserver.complete.bind(nextListenerOrObserver);
        }
        this.listeners.add(listener);
        if (this.status !== exports.InterpreterStatus.NotStarted) {
          listener(this.state);
        }
        if (resolvedCompleteListener) {
          if (this.status === exports.InterpreterStatus.Stopped) {
            resolvedCompleteListener();
          } else {
            this.onDone(resolvedCompleteListener);
          }
        }
        return {
          unsubscribe: function() {
            listener && _this.listeners.delete(listener);
            resolvedCompleteListener && _this.doneListeners.delete(resolvedCompleteListener);
          }
        };
      };
      Interpreter2.prototype.onEvent = function(listener) {
        this.eventListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onSend = function(listener) {
        this.sendListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onChange = function(listener) {
        this.contextListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onStop = function(listener) {
        this.stopListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onDone = function(listener) {
        this.doneListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.off = function(listener) {
        this.listeners.delete(listener);
        this.eventListeners.delete(listener);
        this.sendListeners.delete(listener);
        this.stopListeners.delete(listener);
        this.doneListeners.delete(listener);
        this.contextListeners.delete(listener);
        return this;
      };
      Interpreter2.prototype.start = function(initialState) {
        var _this = this;
        if (this.status === exports.InterpreterStatus.Running) {
          return this;
        }
        this.machine._init();
        registry.registry.register(this.sessionId, this);
        this.initialized = true;
        this.status = exports.InterpreterStatus.Running;
        var resolvedState = initialState === void 0 ? this.initialState : serviceScope.provide(this, function() {
          return State2.isStateConfig(initialState) ? _this.machine.resolveState(initialState) : _this.machine.resolveState(State2.State.from(initialState, _this.machine.context));
        });
        if (this.options.devTools) {
          this.attachDev();
        }
        this.scheduler.initialize(function() {
          _this.update(resolvedState, actions2.initEvent);
        });
        return this;
      };
      Interpreter2.prototype.stop = function() {
        var e_6, _a, e_7, _b, e_8, _c, e_9, _d, e_10, _e;
        var _this = this;
        try {
          for (var _f = _tslib.__values(this.listeners), _g = _f.next(); !_g.done; _g = _f.next()) {
            var listener = _g.value;
            this.listeners.delete(listener);
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (_g && !_g.done && (_a = _f.return))
              _a.call(_f);
          } finally {
            if (e_6)
              throw e_6.error;
          }
        }
        try {
          for (var _h = _tslib.__values(this.stopListeners), _j = _h.next(); !_j.done; _j = _h.next()) {
            var listener = _j.value;
            listener();
            this.stopListeners.delete(listener);
          }
        } catch (e_7_1) {
          e_7 = {
            error: e_7_1
          };
        } finally {
          try {
            if (_j && !_j.done && (_b = _h.return))
              _b.call(_h);
          } finally {
            if (e_7)
              throw e_7.error;
          }
        }
        try {
          for (var _k = _tslib.__values(this.contextListeners), _l = _k.next(); !_l.done; _l = _k.next()) {
            var listener = _l.value;
            this.contextListeners.delete(listener);
          }
        } catch (e_8_1) {
          e_8 = {
            error: e_8_1
          };
        } finally {
          try {
            if (_l && !_l.done && (_c = _k.return))
              _c.call(_k);
          } finally {
            if (e_8)
              throw e_8.error;
          }
        }
        try {
          for (var _m = _tslib.__values(this.doneListeners), _o = _m.next(); !_o.done; _o = _m.next()) {
            var listener = _o.value;
            this.doneListeners.delete(listener);
          }
        } catch (e_9_1) {
          e_9 = {
            error: e_9_1
          };
        } finally {
          try {
            if (_o && !_o.done && (_d = _m.return))
              _d.call(_m);
          } finally {
            if (e_9)
              throw e_9.error;
          }
        }
        if (!this.initialized) {
          return this;
        }
        _tslib.__spreadArray([], _tslib.__read(this.state.configuration), false).sort(function(a, b) {
          return b.order - a.order;
        }).forEach(function(stateNode) {
          var e_11, _a2;
          try {
            for (var _b2 = _tslib.__values(stateNode.definition.exit), _c2 = _b2.next(); !_c2.done; _c2 = _b2.next()) {
              var action = _c2.value;
              _this.exec(action, _this.state);
            }
          } catch (e_11_1) {
            e_11 = {
              error: e_11_1
            };
          } finally {
            try {
              if (_c2 && !_c2.done && (_a2 = _b2.return))
                _a2.call(_b2);
            } finally {
              if (e_11)
                throw e_11.error;
            }
          }
        });
        this.children.forEach(function(child) {
          if (utils.isFunction(child.stop)) {
            child.stop();
          }
        });
        this.children.clear();
        try {
          for (var _p = _tslib.__values(Object.keys(this.delayedEventsMap)), _q = _p.next(); !_q.done; _q = _p.next()) {
            var key = _q.value;
            this.clock.clearTimeout(this.delayedEventsMap[key]);
          }
        } catch (e_10_1) {
          e_10 = {
            error: e_10_1
          };
        } finally {
          try {
            if (_q && !_q.done && (_e = _p.return))
              _e.call(_p);
          } finally {
            if (e_10)
              throw e_10.error;
          }
        }
        this.scheduler.clear();
        this.scheduler = new scheduler.Scheduler({
          deferEvents: this.options.deferEvents
        });
        this.initialized = false;
        this.status = exports.InterpreterStatus.Stopped;
        this._initialState = void 0;
        registry.registry.free(this.sessionId);
        return this;
      };
      Interpreter2.prototype.batch = function(events) {
        var _this = this;
        if (this.status === exports.InterpreterStatus.NotStarted && this.options.deferEvents) {
          if (!environment.IS_PRODUCTION) {
            utils.warn(false, "".concat(events.length, ' event(s) were sent to uninitialized service "').concat(this.machine.id, '" and are deferred. Make sure .start() is called for this service.\nEvent: ').concat(JSON.stringify(event)));
          }
        } else if (this.status !== exports.InterpreterStatus.Running) {
          throw new Error("".concat(events.length, ' event(s) were sent to uninitialized service "').concat(this.machine.id, '". Make sure .start() is called for this service, or set { deferEvents: true } in the service options.'));
        }
        this.scheduler.schedule(function() {
          var e_12, _a;
          var nextState = _this.state;
          var batchChanged = false;
          var batchedActions = [];
          var _loop_1 = function(event_12) {
            var _event = utils.toSCXMLEvent(event_12);
            _this.forward(_event);
            nextState = serviceScope.provide(_this, function() {
              return _this.machine.transition(nextState, _event);
            });
            batchedActions.push.apply(batchedActions, _tslib.__spreadArray([], _tslib.__read(nextState.actions.map(function(a) {
              return State2.bindActionToState(a, nextState);
            })), false));
            batchChanged = batchChanged || !!nextState.changed;
          };
          try {
            for (var events_1 = _tslib.__values(events), events_1_1 = events_1.next(); !events_1_1.done; events_1_1 = events_1.next()) {
              var event_1 = events_1_1.value;
              _loop_1(event_1);
            }
          } catch (e_12_1) {
            e_12 = {
              error: e_12_1
            };
          } finally {
            try {
              if (events_1_1 && !events_1_1.done && (_a = events_1.return))
                _a.call(events_1);
            } finally {
              if (e_12)
                throw e_12.error;
            }
          }
          nextState.changed = batchChanged;
          nextState.actions = batchedActions;
          _this.update(nextState, utils.toSCXMLEvent(events[events.length - 1]));
        });
      };
      Interpreter2.prototype.sender = function(event2) {
        return this.send.bind(this, event2);
      };
      Interpreter2.prototype.nextState = function(event2) {
        var _this = this;
        var _event = utils.toSCXMLEvent(event2);
        if (_event.name.indexOf(actionTypes.errorPlatform) === 0 && !this.state.nextEvents.some(function(nextEvent) {
          return nextEvent.indexOf(actionTypes.errorPlatform) === 0;
        })) {
          throw _event.data.data;
        }
        var nextState = serviceScope.provide(this, function() {
          return _this.machine.transition(_this.state, _event);
        });
        return nextState;
      };
      Interpreter2.prototype.forward = function(event2) {
        var e_13, _a;
        try {
          for (var _b = _tslib.__values(this.forwardTo), _c = _b.next(); !_c.done; _c = _b.next()) {
            var id = _c.value;
            var child = this.children.get(id);
            if (!child) {
              throw new Error("Unable to forward event '".concat(event2, "' from interpreter '").concat(this.id, "' to nonexistant child '").concat(id, "'."));
            }
            child.send(event2);
          }
        } catch (e_13_1) {
          e_13 = {
            error: e_13_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return))
              _a.call(_b);
          } finally {
            if (e_13)
              throw e_13.error;
          }
        }
      };
      Interpreter2.prototype.defer = function(sendAction) {
        var _this = this;
        this.delayedEventsMap[sendAction.id] = this.clock.setTimeout(function() {
          if (sendAction.to) {
            _this.sendTo(sendAction._event, sendAction.to);
          } else {
            _this.send(sendAction._event);
          }
        }, sendAction.delay);
      };
      Interpreter2.prototype.cancel = function(sendId) {
        this.clock.clearTimeout(this.delayedEventsMap[sendId]);
        delete this.delayedEventsMap[sendId];
      };
      Interpreter2.prototype.exec = function(action, state, actionFunctionMap) {
        if (actionFunctionMap === void 0) {
          actionFunctionMap = this.machine.options.actions;
        }
        var context = state.context, _event = state._event;
        var actionOrExec = action.exec || actions2.getActionFunction(action.type, actionFunctionMap);
        var exec = utils.isFunction(actionOrExec) ? actionOrExec : actionOrExec ? actionOrExec.exec : action.exec;
        if (exec) {
          try {
            return exec(context, _event.data, {
              action,
              state: this.state,
              _event
            });
          } catch (err) {
            if (this.parent) {
              this.parent.send({
                type: "xstate.error",
                data: err
              });
            }
            throw err;
          }
        }
        switch (action.type) {
          case actionTypes.send:
            var sendAction = action;
            if (typeof sendAction.delay === "number") {
              this.defer(sendAction);
              return;
            } else {
              if (sendAction.to) {
                this.sendTo(sendAction._event, sendAction.to);
              } else {
                this.send(sendAction._event);
              }
            }
            break;
          case actionTypes.cancel:
            this.cancel(action.sendId);
            break;
          case actionTypes.start: {
            if (this.status !== exports.InterpreterStatus.Running) {
              return;
            }
            var activity = action.activity;
            if (!this.state.activities[activity.id || activity.type]) {
              break;
            }
            if (activity.type === types2.ActionTypes.Invoke) {
              var invokeSource = utils.toInvokeSource(activity.src);
              var serviceCreator = this.machine.options.services ? this.machine.options.services[invokeSource.type] : void 0;
              var id = activity.id, data = activity.data;
              if (!environment.IS_PRODUCTION) {
                utils.warn(!("forward" in activity), "`forward` property is deprecated (found in invocation of '".concat(activity.src, "' in in machine '").concat(this.machine.id, "'). ") + "Please use `autoForward` instead.");
              }
              var autoForward = "autoForward" in activity ? activity.autoForward : !!activity.forward;
              if (!serviceCreator) {
                if (!environment.IS_PRODUCTION) {
                  utils.warn(false, "No service found for invocation '".concat(activity.src, "' in machine '").concat(this.machine.id, "'."));
                }
                return;
              }
              var resolvedData = data ? utils.mapContext(data, context, _event) : void 0;
              if (typeof serviceCreator === "string") {
                return;
              }
              var source = utils.isFunction(serviceCreator) ? serviceCreator(context, _event.data, {
                data: resolvedData,
                src: invokeSource,
                meta: activity.meta
              }) : serviceCreator;
              if (!source) {
                return;
              }
              var options = void 0;
              if (utils.isMachine(source)) {
                source = resolvedData ? source.withContext(resolvedData) : source;
                options = {
                  autoForward
                };
              }
              this.spawn(source, id, options);
            } else {
              this.spawnActivity(activity);
            }
            break;
          }
          case actionTypes.stop: {
            this.stopChild(action.activity.id);
            break;
          }
          case actionTypes.log:
            var label = action.label, value = action.value;
            if (label) {
              this.logger(label, value);
            } else {
              this.logger(value);
            }
            break;
          default:
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, "No implementation found for action type '".concat(action.type, "'"));
            }
            break;
        }
        return void 0;
      };
      Interpreter2.prototype.removeChild = function(childId) {
        var _a;
        this.children.delete(childId);
        this.forwardTo.delete(childId);
        (_a = this.state) === null || _a === void 0 ? true : delete _a.children[childId];
      };
      Interpreter2.prototype.stopChild = function(childId) {
        var child = this.children.get(childId);
        if (!child) {
          return;
        }
        this.removeChild(childId);
        if (utils.isFunction(child.stop)) {
          child.stop();
        }
      };
      Interpreter2.prototype.spawn = function(entity, name, options) {
        if (utils.isPromiseLike(entity)) {
          return this.spawnPromise(Promise.resolve(entity), name);
        } else if (utils.isFunction(entity)) {
          return this.spawnCallback(entity, name);
        } else if (Actor.isSpawnedActor(entity)) {
          return this.spawnActor(entity, name);
        } else if (utils.isObservable(entity)) {
          return this.spawnObservable(entity, name);
        } else if (utils.isMachine(entity)) {
          return this.spawnMachine(entity, _tslib.__assign(_tslib.__assign({}, options), {
            id: name
          }));
        } else if (utils.isBehavior(entity)) {
          return this.spawnBehavior(entity, name);
        } else {
          throw new Error('Unable to spawn entity "'.concat(name, '" of type "').concat(typeof entity, '".'));
        }
      };
      Interpreter2.prototype.spawnMachine = function(machine, options) {
        var _this = this;
        if (options === void 0) {
          options = {};
        }
        var childService = new Interpreter2(machine, _tslib.__assign(_tslib.__assign({}, this.options), {
          parent: this,
          id: options.id || machine.id
        }));
        var resolvedOptions = _tslib.__assign(_tslib.__assign({}, DEFAULT_SPAWN_OPTIONS), options);
        if (resolvedOptions.sync) {
          childService.onTransition(function(state) {
            _this.send(actionTypes.update, {
              state,
              id: childService.id
            });
          });
        }
        var actor = childService;
        this.children.set(childService.id, actor);
        if (resolvedOptions.autoForward) {
          this.forwardTo.add(childService.id);
        }
        childService.onDone(function(doneEvent) {
          _this.removeChild(childService.id);
          _this.send(utils.toSCXMLEvent(doneEvent, {
            origin: childService.id
          }));
        }).start();
        return actor;
      };
      Interpreter2.prototype.spawnBehavior = function(behavior, id) {
        var actorRef = behaviors.spawnBehavior(behavior, {
          id,
          parent: this
        });
        this.children.set(id, actorRef);
        return actorRef;
      };
      Interpreter2.prototype.spawnPromise = function(promise, id) {
        var _a;
        var _this = this;
        var canceled = false;
        var resolvedData;
        promise.then(function(response) {
          if (!canceled) {
            resolvedData = response;
            _this.removeChild(id);
            _this.send(utils.toSCXMLEvent(actions2.doneInvoke(id, response), {
              origin: id
            }));
          }
        }, function(errorData) {
          if (!canceled) {
            _this.removeChild(id);
            var errorEvent = actions2.error(id, errorData);
            try {
              _this.send(utils.toSCXMLEvent(errorEvent, {
                origin: id
              }));
            } catch (error) {
              utils.reportUnhandledExceptionOnInvocation(errorData, error, id);
              if (_this.devTools) {
                _this.devTools.send(errorEvent, _this.state);
              }
              if (_this.machine.strict) {
                _this.stop();
              }
            }
          }
        });
        var actor = (_a = {
          id,
          send: function() {
            return void 0;
          },
          subscribe: function(next, handleError, complete) {
            var observer = utils.toObserver(next, handleError, complete);
            var unsubscribed = false;
            promise.then(function(response) {
              if (unsubscribed) {
                return;
              }
              observer.next(response);
              if (unsubscribed) {
                return;
              }
              observer.complete();
            }, function(err) {
              if (unsubscribed) {
                return;
              }
              observer.error(err);
            });
            return {
              unsubscribe: function() {
                return unsubscribed = true;
              }
            };
          },
          stop: function() {
            canceled = true;
          },
          toJSON: function() {
            return {
              id
            };
          },
          getSnapshot: function() {
            return resolvedData;
          }
        }, _a[utils.symbolObservable] = function() {
          return this;
        }, _a);
        this.children.set(id, actor);
        return actor;
      };
      Interpreter2.prototype.spawnCallback = function(callback, id) {
        var _a;
        var _this = this;
        var canceled = false;
        var receivers = /* @__PURE__ */ new Set();
        var listeners = /* @__PURE__ */ new Set();
        var emitted;
        var receive = function(e) {
          emitted = e;
          listeners.forEach(function(listener) {
            return listener(e);
          });
          if (canceled) {
            return;
          }
          _this.send(utils.toSCXMLEvent(e, {
            origin: id
          }));
        };
        var callbackStop;
        try {
          callbackStop = callback(receive, function(newListener) {
            receivers.add(newListener);
          });
        } catch (err) {
          this.send(actions2.error(id, err));
        }
        if (utils.isPromiseLike(callbackStop)) {
          return this.spawnPromise(callbackStop, id);
        }
        var actor = (_a = {
          id,
          send: function(event2) {
            return receivers.forEach(function(receiver) {
              return receiver(event2);
            });
          },
          subscribe: function(next) {
            var observer = utils.toObserver(next);
            listeners.add(observer.next);
            return {
              unsubscribe: function() {
                listeners.delete(observer.next);
              }
            };
          },
          stop: function() {
            canceled = true;
            if (utils.isFunction(callbackStop)) {
              callbackStop();
            }
          },
          toJSON: function() {
            return {
              id
            };
          },
          getSnapshot: function() {
            return emitted;
          }
        }, _a[utils.symbolObservable] = function() {
          return this;
        }, _a);
        this.children.set(id, actor);
        return actor;
      };
      Interpreter2.prototype.spawnObservable = function(source, id) {
        var _a;
        var _this = this;
        var emitted;
        var subscription = source.subscribe(function(value) {
          emitted = value;
          _this.send(utils.toSCXMLEvent(value, {
            origin: id
          }));
        }, function(err) {
          _this.removeChild(id);
          _this.send(utils.toSCXMLEvent(actions2.error(id, err), {
            origin: id
          }));
        }, function() {
          _this.removeChild(id);
          _this.send(utils.toSCXMLEvent(actions2.doneInvoke(id), {
            origin: id
          }));
        });
        var actor = (_a = {
          id,
          send: function() {
            return void 0;
          },
          subscribe: function(next, handleError, complete) {
            return source.subscribe(next, handleError, complete);
          },
          stop: function() {
            return subscription.unsubscribe();
          },
          getSnapshot: function() {
            return emitted;
          },
          toJSON: function() {
            return {
              id
            };
          }
        }, _a[utils.symbolObservable] = function() {
          return this;
        }, _a);
        this.children.set(id, actor);
        return actor;
      };
      Interpreter2.prototype.spawnActor = function(actor, name) {
        this.children.set(name, actor);
        return actor;
      };
      Interpreter2.prototype.spawnActivity = function(activity) {
        var implementation = this.machine.options && this.machine.options.activities ? this.machine.options.activities[activity.type] : void 0;
        if (!implementation) {
          if (!environment.IS_PRODUCTION) {
            utils.warn(false, "No implementation found for activity '".concat(activity.type, "'"));
          }
          return;
        }
        var dispose = implementation(this.state.context, activity);
        this.spawnEffect(activity.id, dispose);
      };
      Interpreter2.prototype.spawnEffect = function(id, dispose) {
        var _a;
        this.children.set(id, (_a = {
          id,
          send: function() {
            return void 0;
          },
          subscribe: function() {
            return {
              unsubscribe: function() {
                return void 0;
              }
            };
          },
          stop: dispose || void 0,
          getSnapshot: function() {
            return void 0;
          },
          toJSON: function() {
            return {
              id
            };
          }
        }, _a[utils.symbolObservable] = function() {
          return this;
        }, _a));
      };
      Interpreter2.prototype.attachDev = function() {
        var global2 = devTools.getGlobal();
        if (this.options.devTools && global2) {
          if (global2.__REDUX_DEVTOOLS_EXTENSION__) {
            var devToolsOptions = typeof this.options.devTools === "object" ? this.options.devTools : void 0;
            this.devTools = global2.__REDUX_DEVTOOLS_EXTENSION__.connect(_tslib.__assign(_tslib.__assign({
              name: this.id,
              autoPause: true,
              stateSanitizer: function(state) {
                return {
                  value: state.value,
                  context: state.context,
                  actions: state.actions
                };
              }
            }, devToolsOptions), {
              features: _tslib.__assign({
                jump: false,
                skip: false
              }, devToolsOptions ? devToolsOptions.features : void 0)
            }), this.machine);
            this.devTools.init(this.state);
          }
          devTools.registerService(this);
        }
      };
      Interpreter2.prototype.toJSON = function() {
        return {
          id: this.id
        };
      };
      Interpreter2.prototype[utils.symbolObservable] = function() {
        return this;
      };
      Interpreter2.prototype.getSnapshot = function() {
        if (this.status === exports.InterpreterStatus.NotStarted) {
          return this.initialState;
        }
        return this._state;
      };
      Interpreter2.defaultOptions = {
        execute: true,
        deferEvents: true,
        clock: {
          setTimeout: function(fn, ms) {
            return setTimeout(fn, ms);
          },
          clearTimeout: function(id) {
            return clearTimeout(id);
          }
        },
        logger: /* @__PURE__ */ console.log.bind(console),
        devTools: false
      };
      Interpreter2.interpret = interpret2;
      return Interpreter2;
    }();
    var resolveSpawnOptions = function(nameOrOptions) {
      if (utils.isString(nameOrOptions)) {
        return _tslib.__assign(_tslib.__assign({}, DEFAULT_SPAWN_OPTIONS), {
          name: nameOrOptions
        });
      }
      return _tslib.__assign(_tslib.__assign(_tslib.__assign({}, DEFAULT_SPAWN_OPTIONS), {
        name: utils.uniqueId()
      }), nameOrOptions);
    };
    function spawn(entity, nameOrOptions) {
      var resolvedOptions = resolveSpawnOptions(nameOrOptions);
      return serviceScope.consume(function(service) {
        if (!environment.IS_PRODUCTION) {
          var isLazyEntity = utils.isMachine(entity) || utils.isFunction(entity);
          utils.warn(!!service || isLazyEntity, 'Attempted to spawn an Actor (ID: "'.concat(utils.isMachine(entity) ? entity.id : "undefined", '") outside of a service. This will have no effect.'));
        }
        if (service) {
          return service.spawn(entity, resolvedOptions.name, resolvedOptions);
        } else {
          return Actor.createDeferredActor(entity, resolvedOptions.name);
        }
      });
    }
    function interpret2(machine, options) {
      var interpreter = new Interpreter(machine, options);
      return interpreter;
    }
    exports.Interpreter = Interpreter;
    exports.interpret = interpret2;
    exports.spawn = spawn;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/invokeUtils.js
var require_invokeUtils = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/invokeUtils.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    require_types();
    var actionTypes = require_actionTypes();
    require_utils();
    require_environment();
    function toInvokeSource(src) {
      if (typeof src === "string") {
        var simpleSrc = {
          type: src
        };
        simpleSrc.toString = function() {
          return src;
        };
        return simpleSrc;
      }
      return src;
    }
    function toInvokeDefinition(invokeConfig) {
      return _tslib.__assign(_tslib.__assign({
        type: actionTypes.invoke
      }, invokeConfig), {
        toJSON: function() {
          invokeConfig.onDone;
          invokeConfig.onError;
          var invokeDef = _tslib.__rest(invokeConfig, ["onDone", "onError"]);
          return _tslib.__assign(_tslib.__assign({}, invokeDef), {
            type: actionTypes.invoke,
            src: toInvokeSource(invokeConfig.src)
          });
        }
      });
    }
    exports.toInvokeDefinition = toInvokeDefinition;
    exports.toInvokeSource = toInvokeSource;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/StateNode.js
var require_StateNode = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/StateNode.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    var types2 = require_types();
    var State2 = require_State();
    var actionTypes = require_actionTypes();
    var actions2 = require_actions();
    var environment = require_environment();
    var constants = require_constants();
    var stateUtils = require_stateUtils();
    var Actor = require_Actor();
    var invokeUtils = require_invokeUtils();
    var NULL_EVENT = "";
    var STATE_IDENTIFIER = "#";
    var WILDCARD = "*";
    var EMPTY_OBJECT = {};
    var isStateId = function(str2) {
      return str2[0] === STATE_IDENTIFIER;
    };
    var createDefaultOptions = function() {
      return {
        actions: {},
        guards: {},
        services: {},
        activities: {},
        delays: {}
      };
    };
    var validateArrayifiedTransitions = function(stateNode, event2, transitions) {
      var hasNonLastUnguardedTarget = transitions.slice(0, -1).some(function(transition) {
        return !("cond" in transition) && !("in" in transition) && (utils.isString(transition.target) || utils.isMachine(transition.target));
      });
      var eventText = event2 === NULL_EVENT ? "the transient event" : "event '".concat(event2, "'");
      utils.warn(!hasNonLastUnguardedTarget, "One or more transitions for ".concat(eventText, " on state '").concat(stateNode.id, "' are unreachable. ") + "Make sure that the default transition is the last one defined.");
    };
    var StateNode = /* @__PURE__ */ function() {
      function StateNode2(config, options, _context, _stateInfo) {
        var _this = this;
        if (_context === void 0) {
          _context = "context" in config ? config.context : void 0;
        }
        var _a;
        this.config = config;
        this._context = _context;
        this.order = -1;
        this.__xstatenode = true;
        this.__cache = {
          events: void 0,
          relativeValue: /* @__PURE__ */ new Map(),
          initialStateValue: void 0,
          initialState: void 0,
          on: void 0,
          transitions: void 0,
          candidates: {},
          delayedTransitions: void 0
        };
        this.idMap = {};
        this.tags = [];
        this.options = Object.assign(createDefaultOptions(), options);
        this.parent = _stateInfo === null || _stateInfo === void 0 ? void 0 : _stateInfo.parent;
        this.key = this.config.key || (_stateInfo === null || _stateInfo === void 0 ? void 0 : _stateInfo.key) || this.config.id || "(machine)";
        this.machine = this.parent ? this.parent.machine : this;
        this.path = this.parent ? this.parent.path.concat(this.key) : [];
        this.delimiter = this.config.delimiter || (this.parent ? this.parent.delimiter : constants.STATE_DELIMITER);
        this.id = this.config.id || _tslib.__spreadArray([this.machine.key], _tslib.__read(this.path), false).join(this.delimiter);
        this.version = this.parent ? this.parent.version : this.config.version;
        this.type = this.config.type || (this.config.parallel ? "parallel" : this.config.states && Object.keys(this.config.states).length ? "compound" : this.config.history ? "history" : "atomic");
        this.schema = this.parent ? this.machine.schema : (_a = this.config.schema) !== null && _a !== void 0 ? _a : {};
        this.description = this.config.description;
        if (!environment.IS_PRODUCTION) {
          utils.warn(!("parallel" in this.config), 'The "parallel" property is deprecated and will be removed in version 4.1. '.concat(this.config.parallel ? "Replace with `type: 'parallel'`" : "Use `type: '".concat(this.type, "'`"), " in the config for state node '").concat(this.id, "' instead."));
        }
        this.initial = this.config.initial;
        this.states = this.config.states ? utils.mapValues(this.config.states, function(stateConfig, key) {
          var _a2;
          var stateNode = new StateNode2(stateConfig, {}, void 0, {
            parent: _this,
            key
          });
          Object.assign(_this.idMap, _tslib.__assign((_a2 = {}, _a2[stateNode.id] = stateNode, _a2), stateNode.idMap));
          return stateNode;
        }) : EMPTY_OBJECT;
        var order = 0;
        function dfs(stateNode) {
          var e_1, _a2;
          stateNode.order = order++;
          try {
            for (var _b = _tslib.__values(stateUtils.getChildren(stateNode)), _c = _b.next(); !_c.done; _c = _b.next()) {
              var child = _c.value;
              dfs(child);
            }
          } catch (e_1_1) {
            e_1 = {
              error: e_1_1
            };
          } finally {
            try {
              if (_c && !_c.done && (_a2 = _b.return))
                _a2.call(_b);
            } finally {
              if (e_1)
                throw e_1.error;
            }
          }
        }
        dfs(this);
        this.history = this.config.history === true ? "shallow" : this.config.history || false;
        this._transient = !!this.config.always || (!this.config.on ? false : Array.isArray(this.config.on) ? this.config.on.some(function(_a2) {
          var event2 = _a2.event;
          return event2 === NULL_EVENT;
        }) : NULL_EVENT in this.config.on);
        this.strict = !!this.config.strict;
        this.onEntry = utils.toArray(this.config.entry || this.config.onEntry).map(function(action) {
          return actions2.toActionObject(action);
        });
        this.onExit = utils.toArray(this.config.exit || this.config.onExit).map(function(action) {
          return actions2.toActionObject(action);
        });
        this.meta = this.config.meta;
        this.doneData = this.type === "final" ? this.config.data : void 0;
        this.invoke = utils.toArray(this.config.invoke).map(function(invokeConfig, i) {
          var _a2, _b;
          if (utils.isMachine(invokeConfig)) {
            var invokeId = utils.createInvokeId(_this.id, i);
            _this.machine.options.services = _tslib.__assign((_a2 = {}, _a2[invokeId] = invokeConfig, _a2), _this.machine.options.services);
            return invokeUtils.toInvokeDefinition({
              src: invokeId,
              id: invokeId
            });
          } else if (utils.isString(invokeConfig.src)) {
            var invokeId = invokeConfig.id || utils.createInvokeId(_this.id, i);
            return invokeUtils.toInvokeDefinition(_tslib.__assign(_tslib.__assign({}, invokeConfig), {
              id: invokeId,
              src: invokeConfig.src
            }));
          } else if (utils.isMachine(invokeConfig.src) || utils.isFunction(invokeConfig.src)) {
            var invokeId = invokeConfig.id || utils.createInvokeId(_this.id, i);
            _this.machine.options.services = _tslib.__assign((_b = {}, _b[invokeId] = invokeConfig.src, _b), _this.machine.options.services);
            return invokeUtils.toInvokeDefinition(_tslib.__assign(_tslib.__assign({
              id: invokeId
            }, invokeConfig), {
              src: invokeId
            }));
          } else {
            var invokeSource = invokeConfig.src;
            return invokeUtils.toInvokeDefinition(_tslib.__assign(_tslib.__assign({
              id: utils.createInvokeId(_this.id, i)
            }, invokeConfig), {
              src: invokeSource
            }));
          }
        });
        this.activities = utils.toArray(this.config.activities).concat(this.invoke).map(function(activity) {
          return actions2.toActivityDefinition(activity);
        });
        this.transition = this.transition.bind(this);
        this.tags = utils.toArray(this.config.tags);
      }
      StateNode2.prototype._init = function() {
        if (this.__cache.transitions) {
          return;
        }
        stateUtils.getAllStateNodes(this).forEach(function(stateNode) {
          return stateNode.on;
        });
      };
      StateNode2.prototype.withConfig = function(options, context) {
        var _a = this.options, actions3 = _a.actions, activities = _a.activities, guards = _a.guards, services = _a.services, delays = _a.delays;
        return new StateNode2(this.config, {
          actions: _tslib.__assign(_tslib.__assign({}, actions3), options.actions),
          activities: _tslib.__assign(_tslib.__assign({}, activities), options.activities),
          guards: _tslib.__assign(_tslib.__assign({}, guards), options.guards),
          services: _tslib.__assign(_tslib.__assign({}, services), options.services),
          delays: _tslib.__assign(_tslib.__assign({}, delays), options.delays)
        }, context !== null && context !== void 0 ? context : this.context);
      };
      StateNode2.prototype.withContext = function(context) {
        return new StateNode2(this.config, this.options, context);
      };
      Object.defineProperty(StateNode2.prototype, "context", {
        get: function() {
          return utils.isFunction(this._context) ? this._context() : this._context;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "definition", {
        get: function() {
          return {
            id: this.id,
            key: this.key,
            version: this.version,
            context: this.context,
            type: this.type,
            initial: this.initial,
            history: this.history,
            states: utils.mapValues(this.states, function(state) {
              return state.definition;
            }),
            on: this.on,
            transitions: this.transitions,
            entry: this.onEntry,
            exit: this.onExit,
            activities: this.activities || [],
            meta: this.meta,
            order: this.order || -1,
            data: this.doneData,
            invoke: this.invoke,
            description: this.description,
            tags: this.tags
          };
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.toJSON = function() {
        return this.definition;
      };
      Object.defineProperty(StateNode2.prototype, "on", {
        get: function() {
          if (this.__cache.on) {
            return this.__cache.on;
          }
          var transitions = this.transitions;
          return this.__cache.on = transitions.reduce(function(map2, transition) {
            map2[transition.eventType] = map2[transition.eventType] || [];
            map2[transition.eventType].push(transition);
            return map2;
          }, {});
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "after", {
        get: function() {
          return this.__cache.delayedTransitions || (this.__cache.delayedTransitions = this.getDelayedTransitions(), this.__cache.delayedTransitions);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "transitions", {
        get: function() {
          return this.__cache.transitions || (this.__cache.transitions = this.formatTransitions(), this.__cache.transitions);
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getCandidates = function(eventName) {
        if (this.__cache.candidates[eventName]) {
          return this.__cache.candidates[eventName];
        }
        var transient = eventName === NULL_EVENT;
        var candidates = this.transitions.filter(function(transition) {
          var sameEventType = transition.eventType === eventName;
          return transient ? sameEventType : sameEventType || transition.eventType === WILDCARD;
        });
        this.__cache.candidates[eventName] = candidates;
        return candidates;
      };
      StateNode2.prototype.getDelayedTransitions = function() {
        var _this = this;
        var afterConfig = this.config.after;
        if (!afterConfig) {
          return [];
        }
        var mutateEntryExit = function(delay, i) {
          var delayRef = utils.isFunction(delay) ? "".concat(_this.id, ":delay[").concat(i, "]") : delay;
          var eventType = actions2.after(delayRef, _this.id);
          _this.onEntry.push(actions2.send(eventType, {
            delay
          }));
          _this.onExit.push(actions2.cancel(eventType));
          return eventType;
        };
        var delayedTransitions = utils.isArray(afterConfig) ? afterConfig.map(function(transition, i) {
          var eventType = mutateEntryExit(transition.delay, i);
          return _tslib.__assign(_tslib.__assign({}, transition), {
            event: eventType
          });
        }) : utils.flatten(Object.keys(afterConfig).map(function(delay, i) {
          var configTransition = afterConfig[delay];
          var resolvedTransition = utils.isString(configTransition) ? {
            target: configTransition
          } : configTransition;
          var resolvedDelay = !isNaN(+delay) ? +delay : delay;
          var eventType = mutateEntryExit(resolvedDelay, i);
          return utils.toArray(resolvedTransition).map(function(transition) {
            return _tslib.__assign(_tslib.__assign({}, transition), {
              event: eventType,
              delay: resolvedDelay
            });
          });
        }));
        return delayedTransitions.map(function(delayedTransition) {
          var delay = delayedTransition.delay;
          return _tslib.__assign(_tslib.__assign({}, _this.formatTransition(delayedTransition)), {
            delay
          });
        });
      };
      StateNode2.prototype.getStateNodes = function(state) {
        var _a;
        var _this = this;
        if (!state) {
          return [];
        }
        var stateValue = state instanceof State2.State ? state.value : utils.toStateValue(state, this.delimiter);
        if (utils.isString(stateValue)) {
          var initialStateValue = this.getStateNode(stateValue).initial;
          return initialStateValue !== void 0 ? this.getStateNodes((_a = {}, _a[stateValue] = initialStateValue, _a)) : [this, this.states[stateValue]];
        }
        var subStateKeys = Object.keys(stateValue);
        var subStateNodes = [this];
        subStateNodes.push.apply(subStateNodes, _tslib.__spreadArray([], _tslib.__read(utils.flatten(subStateKeys.map(function(subStateKey) {
          return _this.getStateNode(subStateKey).getStateNodes(stateValue[subStateKey]);
        }))), false));
        return subStateNodes;
      };
      StateNode2.prototype.handles = function(event2) {
        var eventType = utils.getEventType(event2);
        return this.events.includes(eventType);
      };
      StateNode2.prototype.resolveState = function(state) {
        var stateFromConfig = state instanceof State2.State ? state : State2.State.create(state);
        var configuration = Array.from(stateUtils.getConfiguration([], this.getStateNodes(stateFromConfig.value)));
        return new State2.State(_tslib.__assign(_tslib.__assign({}, stateFromConfig), {
          value: this.resolve(stateFromConfig.value),
          configuration,
          done: stateUtils.isInFinalState(configuration, this),
          tags: stateUtils.getTagsFromConfiguration(configuration),
          machine: this.machine
        }));
      };
      StateNode2.prototype.transitionLeafNode = function(stateValue, state, _event) {
        var stateNode = this.getStateNode(stateValue);
        var next = stateNode.next(state, _event);
        if (!next || !next.transitions.length) {
          return this.next(state, _event);
        }
        return next;
      };
      StateNode2.prototype.transitionCompoundNode = function(stateValue, state, _event) {
        var subStateKeys = Object.keys(stateValue);
        var stateNode = this.getStateNode(subStateKeys[0]);
        var next = stateNode._transition(stateValue[subStateKeys[0]], state, _event);
        if (!next || !next.transitions.length) {
          return this.next(state, _event);
        }
        return next;
      };
      StateNode2.prototype.transitionParallelNode = function(stateValue, state, _event) {
        var e_2, _a;
        var transitionMap = {};
        try {
          for (var _b = _tslib.__values(Object.keys(stateValue)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var subStateKey = _c.value;
            var subStateValue = stateValue[subStateKey];
            if (!subStateValue) {
              continue;
            }
            var subStateNode = this.getStateNode(subStateKey);
            var next = subStateNode._transition(subStateValue, state, _event);
            if (next) {
              transitionMap[subStateKey] = next;
            }
          }
        } catch (e_2_1) {
          e_2 = {
            error: e_2_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return))
              _a.call(_b);
          } finally {
            if (e_2)
              throw e_2.error;
          }
        }
        var stateTransitions = Object.keys(transitionMap).map(function(key) {
          return transitionMap[key];
        });
        var enabledTransitions = utils.flatten(stateTransitions.map(function(st) {
          return st.transitions;
        }));
        var willTransition = stateTransitions.some(function(st) {
          return st.transitions.length > 0;
        });
        if (!willTransition) {
          return this.next(state, _event);
        }
        var entryNodes = utils.flatten(stateTransitions.map(function(t) {
          return t.entrySet;
        }));
        var configuration = utils.flatten(Object.keys(transitionMap).map(function(key) {
          return transitionMap[key].configuration;
        }));
        return {
          transitions: enabledTransitions,
          entrySet: entryNodes,
          exitSet: utils.flatten(stateTransitions.map(function(t) {
            return t.exitSet;
          })),
          configuration,
          source: state,
          actions: utils.flatten(Object.keys(transitionMap).map(function(key) {
            return transitionMap[key].actions;
          }))
        };
      };
      StateNode2.prototype._transition = function(stateValue, state, _event) {
        if (utils.isString(stateValue)) {
          return this.transitionLeafNode(stateValue, state, _event);
        }
        if (Object.keys(stateValue).length === 1) {
          return this.transitionCompoundNode(stateValue, state, _event);
        }
        return this.transitionParallelNode(stateValue, state, _event);
      };
      StateNode2.prototype.getTransitionData = function(state, event2) {
        return this._transition(state.value, state, utils.toSCXMLEvent(event2));
      };
      StateNode2.prototype.next = function(state, _event) {
        var e_3, _a;
        var _this = this;
        var eventName = _event.name;
        var actions3 = [];
        var nextStateNodes = [];
        var selectedTransition;
        try {
          for (var _b = _tslib.__values(this.getCandidates(eventName)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var candidate = _c.value;
            var cond = candidate.cond, stateIn = candidate.in;
            var resolvedContext = state.context;
            var isInState = stateIn ? utils.isString(stateIn) && isStateId(stateIn) ? state.matches(utils.toStateValue(this.getStateNodeById(stateIn).path, this.delimiter)) : utils.matchesState(utils.toStateValue(stateIn, this.delimiter), utils.path(this.path.slice(0, -2))(state.value)) : true;
            var guardPassed = false;
            try {
              guardPassed = !cond || utils.evaluateGuard(this.machine, cond, resolvedContext, _event, state);
            } catch (err) {
              throw new Error("Unable to evaluate guard '".concat(cond.name || cond.type, "' in transition for event '").concat(eventName, "' in state node '").concat(this.id, "':\n").concat(err.message));
            }
            if (guardPassed && isInState) {
              if (candidate.target !== void 0) {
                nextStateNodes = candidate.target;
              }
              actions3.push.apply(actions3, _tslib.__spreadArray([], _tslib.__read(candidate.actions), false));
              selectedTransition = candidate;
              break;
            }
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return))
              _a.call(_b);
          } finally {
            if (e_3)
              throw e_3.error;
          }
        }
        if (!selectedTransition) {
          return void 0;
        }
        if (!nextStateNodes.length) {
          return {
            transitions: [selectedTransition],
            entrySet: [],
            exitSet: [],
            configuration: state.value ? [this] : [],
            source: state,
            actions: actions3
          };
        }
        var allNextStateNodes = utils.flatten(nextStateNodes.map(function(stateNode) {
          return _this.getRelativeStateNodes(stateNode, state.historyValue);
        }));
        var isInternal = !!selectedTransition.internal;
        var reentryNodes = isInternal ? [] : utils.flatten(allNextStateNodes.map(function(n) {
          return _this.nodesFromChild(n);
        }));
        return {
          transitions: [selectedTransition],
          entrySet: reentryNodes,
          exitSet: isInternal ? [] : [this],
          configuration: allNextStateNodes,
          source: state,
          actions: actions3
        };
      };
      StateNode2.prototype.nodesFromChild = function(childStateNode) {
        if (childStateNode.escapes(this)) {
          return [];
        }
        var nodes = [];
        var marker = childStateNode;
        while (marker && marker !== this) {
          nodes.push(marker);
          marker = marker.parent;
        }
        nodes.push(this);
        return nodes;
      };
      StateNode2.prototype.escapes = function(stateNode) {
        if (this === stateNode) {
          return false;
        }
        var parent = this.parent;
        while (parent) {
          if (parent === stateNode) {
            return false;
          }
          parent = parent.parent;
        }
        return true;
      };
      StateNode2.prototype.getActions = function(transition, currentContext, _event, prevState) {
        var e_4, _a, e_5, _b;
        var prevConfig = stateUtils.getConfiguration([], prevState ? this.getStateNodes(prevState.value) : [this]);
        var resolvedConfig = transition.configuration.length ? stateUtils.getConfiguration(prevConfig, transition.configuration) : prevConfig;
        try {
          for (var resolvedConfig_1 = _tslib.__values(resolvedConfig), resolvedConfig_1_1 = resolvedConfig_1.next(); !resolvedConfig_1_1.done; resolvedConfig_1_1 = resolvedConfig_1.next()) {
            var sn = resolvedConfig_1_1.value;
            if (!stateUtils.has(prevConfig, sn)) {
              transition.entrySet.push(sn);
            }
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (resolvedConfig_1_1 && !resolvedConfig_1_1.done && (_a = resolvedConfig_1.return))
              _a.call(resolvedConfig_1);
          } finally {
            if (e_4)
              throw e_4.error;
          }
        }
        try {
          for (var prevConfig_1 = _tslib.__values(prevConfig), prevConfig_1_1 = prevConfig_1.next(); !prevConfig_1_1.done; prevConfig_1_1 = prevConfig_1.next()) {
            var sn = prevConfig_1_1.value;
            if (!stateUtils.has(resolvedConfig, sn) || stateUtils.has(transition.exitSet, sn.parent)) {
              transition.exitSet.push(sn);
            }
          }
        } catch (e_5_1) {
          e_5 = {
            error: e_5_1
          };
        } finally {
          try {
            if (prevConfig_1_1 && !prevConfig_1_1.done && (_b = prevConfig_1.return))
              _b.call(prevConfig_1);
          } finally {
            if (e_5)
              throw e_5.error;
          }
        }
        var doneEvents = utils.flatten(transition.entrySet.map(function(sn2) {
          var events = [];
          if (sn2.type !== "final") {
            return events;
          }
          var parent = sn2.parent;
          if (!parent.parent) {
            return events;
          }
          events.push(actions2.done(sn2.id, sn2.doneData), actions2.done(parent.id, sn2.doneData ? utils.mapContext(sn2.doneData, currentContext, _event) : void 0));
          var grandparent = parent.parent;
          if (grandparent.type === "parallel") {
            if (stateUtils.getChildren(grandparent).every(function(parentNode) {
              return stateUtils.isInFinalState(transition.configuration, parentNode);
            })) {
              events.push(actions2.done(grandparent.id));
            }
          }
          return events;
        }));
        transition.exitSet.sort(function(a, b) {
          return b.order - a.order;
        });
        transition.entrySet.sort(function(a, b) {
          return a.order - b.order;
        });
        var entryStates = new Set(transition.entrySet);
        var exitStates = new Set(transition.exitSet);
        var _c = _tslib.__read([utils.flatten(Array.from(entryStates).map(function(stateNode) {
          return _tslib.__spreadArray(_tslib.__spreadArray([], _tslib.__read(stateNode.activities.map(function(activity) {
            return actions2.start(activity);
          })), false), _tslib.__read(stateNode.onEntry), false);
        })).concat(doneEvents.map(actions2.raise)), utils.flatten(Array.from(exitStates).map(function(stateNode) {
          return _tslib.__spreadArray(_tslib.__spreadArray([], _tslib.__read(stateNode.onExit), false), _tslib.__read(stateNode.activities.map(function(activity) {
            return actions2.stop(activity);
          })), false);
        }))], 2), entryActions = _c[0], exitActions = _c[1];
        var actions$1 = actions2.toActionObjects(exitActions.concat(transition.actions).concat(entryActions), this.machine.options.actions);
        return actions$1;
      };
      StateNode2.prototype.transition = function(state, event2, context) {
        if (state === void 0) {
          state = this.initialState;
        }
        var _event = utils.toSCXMLEvent(event2);
        var currentState;
        if (state instanceof State2.State) {
          currentState = context === void 0 ? state : this.resolveState(State2.State.from(state, context));
        } else {
          var resolvedStateValue = utils.isString(state) ? this.resolve(utils.pathToStateValue(this.getResolvedPath(state))) : this.resolve(state);
          var resolvedContext = context !== null && context !== void 0 ? context : this.machine.context;
          currentState = this.resolveState(State2.State.from(resolvedStateValue, resolvedContext));
        }
        if (!environment.IS_PRODUCTION && _event.name === WILDCARD) {
          throw new Error("An event cannot have the wildcard type ('".concat(WILDCARD, "')"));
        }
        if (this.strict) {
          if (!this.events.includes(_event.name) && !utils.isBuiltInEvent(_event.name)) {
            throw new Error("Machine '".concat(this.id, "' does not accept event '").concat(_event.name, "'"));
          }
        }
        var stateTransition = this._transition(currentState.value, currentState, _event) || {
          transitions: [],
          configuration: [],
          entrySet: [],
          exitSet: [],
          source: currentState,
          actions: []
        };
        var prevConfig = stateUtils.getConfiguration([], this.getStateNodes(currentState.value));
        var resolvedConfig = stateTransition.configuration.length ? stateUtils.getConfiguration(prevConfig, stateTransition.configuration) : prevConfig;
        stateTransition.configuration = _tslib.__spreadArray([], _tslib.__read(resolvedConfig), false);
        return this.resolveTransition(stateTransition, currentState, currentState.context, _event);
      };
      StateNode2.prototype.resolveRaisedTransition = function(state, _event, originalEvent) {
        var _a;
        var currentActions = state.actions;
        state = this.transition(state, _event);
        state._event = originalEvent;
        state.event = originalEvent.data;
        (_a = state.actions).unshift.apply(_a, _tslib.__spreadArray([], _tslib.__read(currentActions), false));
        return state;
      };
      StateNode2.prototype.resolveTransition = function(stateTransition, currentState, context, _event) {
        var e_6, _a;
        var _this = this;
        if (_event === void 0) {
          _event = actions2.initEvent;
        }
        var configuration = stateTransition.configuration;
        var willTransition = !currentState || stateTransition.transitions.length > 0;
        var resolvedStateValue = willTransition ? stateUtils.getValue(this.machine, configuration) : void 0;
        var historyValue = currentState ? currentState.historyValue ? currentState.historyValue : stateTransition.source ? this.machine.historyValue(currentState.value) : void 0 : void 0;
        var actions$1 = this.getActions(stateTransition, context, _event, currentState);
        var activities = currentState ? _tslib.__assign({}, currentState.activities) : {};
        try {
          for (var actions_1 = _tslib.__values(actions$1), actions_1_1 = actions_1.next(); !actions_1_1.done; actions_1_1 = actions_1.next()) {
            var action = actions_1_1.value;
            if (action.type === actionTypes.start) {
              activities[action.activity.id || action.activity.type] = action;
            } else if (action.type === actionTypes.stop) {
              activities[action.activity.id || action.activity.type] = false;
            }
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (actions_1_1 && !actions_1_1.done && (_a = actions_1.return))
              _a.call(actions_1);
          } finally {
            if (e_6)
              throw e_6.error;
          }
        }
        var _b = _tslib.__read(actions2.resolveActions(this, currentState, context, _event, actions$1, this.machine.config.preserveActionOrder), 2), resolvedActions = _b[0], updatedContext = _b[1];
        var _c = _tslib.__read(utils.partition(resolvedActions, function(action2) {
          return action2.type === actionTypes.raise || action2.type === actionTypes.send && action2.to === types2.SpecialTargets.Internal;
        }), 2), raisedEvents = _c[0], nonRaisedActions = _c[1];
        var invokeActions = resolvedActions.filter(function(action2) {
          var _a2;
          return action2.type === actionTypes.start && ((_a2 = action2.activity) === null || _a2 === void 0 ? void 0 : _a2.type) === actionTypes.invoke;
        });
        var children = invokeActions.reduce(function(acc, action2) {
          acc[action2.activity.id] = Actor.createInvocableActor(action2.activity, _this.machine, updatedContext, _event);
          return acc;
        }, currentState ? _tslib.__assign({}, currentState.children) : {});
        var resolvedConfiguration = willTransition ? stateTransition.configuration : currentState ? currentState.configuration : [];
        var isDone = stateUtils.isInFinalState(resolvedConfiguration, this);
        var nextState = new State2.State({
          value: resolvedStateValue || currentState.value,
          context: updatedContext,
          _event,
          _sessionid: currentState ? currentState._sessionid : null,
          historyValue: resolvedStateValue ? historyValue ? utils.updateHistoryValue(historyValue, resolvedStateValue) : void 0 : currentState ? currentState.historyValue : void 0,
          history: !resolvedStateValue || stateTransition.source ? currentState : void 0,
          actions: resolvedStateValue ? nonRaisedActions : [],
          activities: resolvedStateValue ? activities : currentState ? currentState.activities : {},
          events: [],
          configuration: resolvedConfiguration,
          transitions: stateTransition.transitions,
          children,
          done: isDone,
          tags: stateUtils.getTagsFromConfiguration(resolvedConfiguration),
          machine: this
        });
        var didUpdateContext = context !== updatedContext;
        nextState.changed = _event.name === actionTypes.update || didUpdateContext;
        var history = nextState.history;
        if (history) {
          delete history.history;
        }
        var isTransient = !isDone && (this._transient || configuration.some(function(stateNode) {
          return stateNode._transient;
        }));
        if (!willTransition && (!isTransient || _event.name === NULL_EVENT)) {
          return nextState;
        }
        var maybeNextState = nextState;
        if (!isDone) {
          if (isTransient) {
            maybeNextState = this.resolveRaisedTransition(maybeNextState, {
              type: actionTypes.nullEvent
            }, _event);
          }
          while (raisedEvents.length) {
            var raisedEvent = raisedEvents.shift();
            maybeNextState = this.resolveRaisedTransition(maybeNextState, raisedEvent._event, _event);
          }
        }
        var changed = maybeNextState.changed || (history ? !!maybeNextState.actions.length || didUpdateContext || typeof history.value !== typeof maybeNextState.value || !State2.stateValuesEqual(maybeNextState.value, history.value) : void 0);
        maybeNextState.changed = changed;
        maybeNextState.history = history;
        return maybeNextState;
      };
      StateNode2.prototype.getStateNode = function(stateKey) {
        if (isStateId(stateKey)) {
          return this.machine.getStateNodeById(stateKey);
        }
        if (!this.states) {
          throw new Error("Unable to retrieve child state '".concat(stateKey, "' from '").concat(this.id, "'; no child states exist."));
        }
        var result2 = this.states[stateKey];
        if (!result2) {
          throw new Error("Child state '".concat(stateKey, "' does not exist on '").concat(this.id, "'"));
        }
        return result2;
      };
      StateNode2.prototype.getStateNodeById = function(stateId) {
        var resolvedStateId = isStateId(stateId) ? stateId.slice(STATE_IDENTIFIER.length) : stateId;
        if (resolvedStateId === this.id) {
          return this;
        }
        var stateNode = this.machine.idMap[resolvedStateId];
        if (!stateNode) {
          throw new Error("Child state node '#".concat(resolvedStateId, "' does not exist on machine '").concat(this.id, "'"));
        }
        return stateNode;
      };
      StateNode2.prototype.getStateNodeByPath = function(statePath) {
        if (typeof statePath === "string" && isStateId(statePath)) {
          try {
            return this.getStateNodeById(statePath.slice(1));
          } catch (e) {
          }
        }
        var arrayStatePath = utils.toStatePath(statePath, this.delimiter).slice();
        var currentStateNode = this;
        while (arrayStatePath.length) {
          var key = arrayStatePath.shift();
          if (!key.length) {
            break;
          }
          currentStateNode = currentStateNode.getStateNode(key);
        }
        return currentStateNode;
      };
      StateNode2.prototype.resolve = function(stateValue) {
        var _a;
        var _this = this;
        if (!stateValue) {
          return this.initialStateValue || EMPTY_OBJECT;
        }
        switch (this.type) {
          case "parallel":
            return utils.mapValues(this.initialStateValue, function(subStateValue, subStateKey) {
              return subStateValue ? _this.getStateNode(subStateKey).resolve(stateValue[subStateKey] || subStateValue) : EMPTY_OBJECT;
            });
          case "compound":
            if (utils.isString(stateValue)) {
              var subStateNode = this.getStateNode(stateValue);
              if (subStateNode.type === "parallel" || subStateNode.type === "compound") {
                return _a = {}, _a[stateValue] = subStateNode.initialStateValue, _a;
              }
              return stateValue;
            }
            if (!Object.keys(stateValue).length) {
              return this.initialStateValue || {};
            }
            return utils.mapValues(stateValue, function(subStateValue, subStateKey) {
              return subStateValue ? _this.getStateNode(subStateKey).resolve(subStateValue) : EMPTY_OBJECT;
            });
          default:
            return stateValue || EMPTY_OBJECT;
        }
      };
      StateNode2.prototype.getResolvedPath = function(stateIdentifier) {
        if (isStateId(stateIdentifier)) {
          var stateNode = this.machine.idMap[stateIdentifier.slice(STATE_IDENTIFIER.length)];
          if (!stateNode) {
            throw new Error("Unable to find state node '".concat(stateIdentifier, "'"));
          }
          return stateNode.path;
        }
        return utils.toStatePath(stateIdentifier, this.delimiter);
      };
      Object.defineProperty(StateNode2.prototype, "initialStateValue", {
        get: function() {
          var _a;
          if (this.__cache.initialStateValue) {
            return this.__cache.initialStateValue;
          }
          var initialStateValue;
          if (this.type === "parallel") {
            initialStateValue = utils.mapFilterValues(this.states, function(state) {
              return state.initialStateValue || EMPTY_OBJECT;
            }, function(stateNode) {
              return !(stateNode.type === "history");
            });
          } else if (this.initial !== void 0) {
            if (!this.states[this.initial]) {
              throw new Error("Initial state '".concat(this.initial, "' not found on '").concat(this.key, "'"));
            }
            initialStateValue = stateUtils.isLeafNode(this.states[this.initial]) ? this.initial : (_a = {}, _a[this.initial] = this.states[this.initial].initialStateValue, _a);
          } else {
            initialStateValue = {};
          }
          this.__cache.initialStateValue = initialStateValue;
          return this.__cache.initialStateValue;
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getInitialState = function(stateValue, context) {
        this._init();
        var configuration = this.getStateNodes(stateValue);
        return this.resolveTransition({
          configuration,
          entrySet: configuration,
          exitSet: [],
          transitions: [],
          source: void 0,
          actions: []
        }, void 0, context !== null && context !== void 0 ? context : this.machine.context, void 0);
      };
      Object.defineProperty(StateNode2.prototype, "initialState", {
        get: function() {
          var initialStateValue = this.initialStateValue;
          if (!initialStateValue) {
            throw new Error("Cannot retrieve initial state from simple state '".concat(this.id, "'."));
          }
          return this.getInitialState(initialStateValue);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "target", {
        get: function() {
          var target;
          if (this.type === "history") {
            var historyConfig = this.config;
            if (utils.isString(historyConfig.target)) {
              target = isStateId(historyConfig.target) ? utils.pathToStateValue(this.machine.getStateNodeById(historyConfig.target).path.slice(this.path.length - 1)) : historyConfig.target;
            } else {
              target = historyConfig.target;
            }
          }
          return target;
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getRelativeStateNodes = function(relativeStateId, historyValue, resolve) {
        if (resolve === void 0) {
          resolve = true;
        }
        return resolve ? relativeStateId.type === "history" ? relativeStateId.resolveHistory(historyValue) : relativeStateId.initialStateNodes : [relativeStateId];
      };
      Object.defineProperty(StateNode2.prototype, "initialStateNodes", {
        get: function() {
          var _this = this;
          if (stateUtils.isLeafNode(this)) {
            return [this];
          }
          if (this.type === "compound" && !this.initial) {
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, "Compound state node '".concat(this.id, "' has no initial state."));
            }
            return [this];
          }
          var initialStateNodePaths = utils.toStatePaths(this.initialStateValue);
          return utils.flatten(initialStateNodePaths.map(function(initialPath) {
            return _this.getFromRelativePath(initialPath);
          }));
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getFromRelativePath = function(relativePath) {
        if (!relativePath.length) {
          return [this];
        }
        var _a = _tslib.__read(relativePath), stateKey = _a[0], childStatePath = _a.slice(1);
        if (!this.states) {
          throw new Error("Cannot retrieve subPath '".concat(stateKey, "' from node with no states"));
        }
        var childStateNode = this.getStateNode(stateKey);
        if (childStateNode.type === "history") {
          return childStateNode.resolveHistory();
        }
        if (!this.states[stateKey]) {
          throw new Error("Child state '".concat(stateKey, "' does not exist on '").concat(this.id, "'"));
        }
        return this.states[stateKey].getFromRelativePath(childStatePath);
      };
      StateNode2.prototype.historyValue = function(relativeStateValue) {
        if (!Object.keys(this.states).length) {
          return void 0;
        }
        return {
          current: relativeStateValue || this.initialStateValue,
          states: utils.mapFilterValues(this.states, function(stateNode, key) {
            if (!relativeStateValue) {
              return stateNode.historyValue();
            }
            var subStateValue = utils.isString(relativeStateValue) ? void 0 : relativeStateValue[key];
            return stateNode.historyValue(subStateValue || stateNode.initialStateValue);
          }, function(stateNode) {
            return !stateNode.history;
          })
        };
      };
      StateNode2.prototype.resolveHistory = function(historyValue) {
        var _this = this;
        if (this.type !== "history") {
          return [this];
        }
        var parent = this.parent;
        if (!historyValue) {
          var historyTarget = this.target;
          return historyTarget ? utils.flatten(utils.toStatePaths(historyTarget).map(function(relativeChildPath) {
            return parent.getFromRelativePath(relativeChildPath);
          })) : parent.initialStateNodes;
        }
        var subHistoryValue = utils.nestedPath(parent.path, "states")(historyValue).current;
        if (utils.isString(subHistoryValue)) {
          return [parent.getStateNode(subHistoryValue)];
        }
        return utils.flatten(utils.toStatePaths(subHistoryValue).map(function(subStatePath) {
          return _this.history === "deep" ? parent.getFromRelativePath(subStatePath) : [parent.states[subStatePath[0]]];
        }));
      };
      Object.defineProperty(StateNode2.prototype, "stateIds", {
        get: function() {
          var _this = this;
          var childStateIds = utils.flatten(Object.keys(this.states).map(function(stateKey) {
            return _this.states[stateKey].stateIds;
          }));
          return [this.id].concat(childStateIds);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "events", {
        get: function() {
          var e_7, _a, e_8, _b;
          if (this.__cache.events) {
            return this.__cache.events;
          }
          var states = this.states;
          var events = new Set(this.ownEvents);
          if (states) {
            try {
              for (var _c = _tslib.__values(Object.keys(states)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var stateId = _d.value;
                var state = states[stateId];
                if (state.states) {
                  try {
                    for (var _e = (e_8 = void 0, _tslib.__values(state.events)), _f = _e.next(); !_f.done; _f = _e.next()) {
                      var event_1 = _f.value;
                      events.add("".concat(event_1));
                    }
                  } catch (e_8_1) {
                    e_8 = {
                      error: e_8_1
                    };
                  } finally {
                    try {
                      if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                    } finally {
                      if (e_8)
                        throw e_8.error;
                    }
                  }
                }
              }
            } catch (e_7_1) {
              e_7 = {
                error: e_7_1
              };
            } finally {
              try {
                if (_d && !_d.done && (_a = _c.return))
                  _a.call(_c);
              } finally {
                if (e_7)
                  throw e_7.error;
              }
            }
          }
          return this.__cache.events = Array.from(events);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "ownEvents", {
        get: function() {
          var events = new Set(this.transitions.filter(function(transition) {
            return !(!transition.target && !transition.actions.length && transition.internal);
          }).map(function(transition) {
            return transition.eventType;
          }));
          return Array.from(events);
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.resolveTarget = function(_target) {
        var _this = this;
        if (_target === void 0) {
          return void 0;
        }
        return _target.map(function(target) {
          if (!utils.isString(target)) {
            return target;
          }
          var isInternalTarget = target[0] === _this.delimiter;
          if (isInternalTarget && !_this.parent) {
            return _this.getStateNodeByPath(target.slice(1));
          }
          var resolvedTarget = isInternalTarget ? _this.key + target : target;
          if (_this.parent) {
            try {
              var targetStateNode = _this.parent.getStateNodeByPath(resolvedTarget);
              return targetStateNode;
            } catch (err) {
              throw new Error("Invalid transition definition for state node '".concat(_this.id, "':\n").concat(err.message));
            }
          } else {
            return _this.getStateNodeByPath(resolvedTarget);
          }
        });
      };
      StateNode2.prototype.formatTransition = function(transitionConfig) {
        var _this = this;
        var normalizedTarget = utils.normalizeTarget(transitionConfig.target);
        var internal = "internal" in transitionConfig ? transitionConfig.internal : normalizedTarget ? normalizedTarget.some(function(_target) {
          return utils.isString(_target) && _target[0] === _this.delimiter;
        }) : true;
        var guards = this.machine.options.guards;
        var target = this.resolveTarget(normalizedTarget);
        var transition = _tslib.__assign(_tslib.__assign({}, transitionConfig), {
          actions: actions2.toActionObjects(utils.toArray(transitionConfig.actions)),
          cond: utils.toGuard(transitionConfig.cond, guards),
          target,
          source: this,
          internal,
          eventType: transitionConfig.event,
          toJSON: function() {
            return _tslib.__assign(_tslib.__assign({}, transition), {
              target: transition.target ? transition.target.map(function(t) {
                return "#".concat(t.id);
              }) : void 0,
              source: "#".concat(_this.id)
            });
          }
        });
        return transition;
      };
      StateNode2.prototype.formatTransitions = function() {
        var e_9, _a;
        var _this = this;
        var onConfig;
        if (!this.config.on) {
          onConfig = [];
        } else if (Array.isArray(this.config.on)) {
          onConfig = this.config.on;
        } else {
          var _b = this.config.on, _c = WILDCARD, _d = _b[_c], wildcardConfigs = _d === void 0 ? [] : _d, strictTransitionConfigs_1 = _tslib.__rest(_b, [typeof _c === "symbol" ? _c : _c + ""]);
          onConfig = utils.flatten(Object.keys(strictTransitionConfigs_1).map(function(key) {
            if (!environment.IS_PRODUCTION && key === NULL_EVENT) {
              utils.warn(false, "Empty string transition configs (e.g., `{ on: { '': ... }}`) for transient transitions are deprecated. Specify the transition in the `{ always: ... }` property instead. " + 'Please check the `on` configuration for "#'.concat(_this.id, '".'));
            }
            var transitionConfigArray = utils.toTransitionConfigArray(key, strictTransitionConfigs_1[key]);
            if (!environment.IS_PRODUCTION) {
              validateArrayifiedTransitions(_this, key, transitionConfigArray);
            }
            return transitionConfigArray;
          }).concat(utils.toTransitionConfigArray(WILDCARD, wildcardConfigs)));
        }
        var eventlessConfig = this.config.always ? utils.toTransitionConfigArray("", this.config.always) : [];
        var doneConfig = this.config.onDone ? utils.toTransitionConfigArray(String(actions2.done(this.id)), this.config.onDone) : [];
        if (!environment.IS_PRODUCTION) {
          utils.warn(!(this.config.onDone && !this.parent), 'Root nodes cannot have an ".onDone" transition. Please check the config of "'.concat(this.id, '".'));
        }
        var invokeConfig = utils.flatten(this.invoke.map(function(invokeDef) {
          var settleTransitions = [];
          if (invokeDef.onDone) {
            settleTransitions.push.apply(settleTransitions, _tslib.__spreadArray([], _tslib.__read(utils.toTransitionConfigArray(String(actions2.doneInvoke(invokeDef.id)), invokeDef.onDone)), false));
          }
          if (invokeDef.onError) {
            settleTransitions.push.apply(settleTransitions, _tslib.__spreadArray([], _tslib.__read(utils.toTransitionConfigArray(String(actions2.error(invokeDef.id)), invokeDef.onError)), false));
          }
          return settleTransitions;
        }));
        var delayedTransitions = this.after;
        var formattedTransitions = utils.flatten(_tslib.__spreadArray(_tslib.__spreadArray(_tslib.__spreadArray(_tslib.__spreadArray([], _tslib.__read(doneConfig), false), _tslib.__read(invokeConfig), false), _tslib.__read(onConfig), false), _tslib.__read(eventlessConfig), false).map(function(transitionConfig) {
          return utils.toArray(transitionConfig).map(function(transition) {
            return _this.formatTransition(transition);
          });
        }));
        try {
          for (var delayedTransitions_1 = _tslib.__values(delayedTransitions), delayedTransitions_1_1 = delayedTransitions_1.next(); !delayedTransitions_1_1.done; delayedTransitions_1_1 = delayedTransitions_1.next()) {
            var delayedTransition = delayedTransitions_1_1.value;
            formattedTransitions.push(delayedTransition);
          }
        } catch (e_9_1) {
          e_9 = {
            error: e_9_1
          };
        } finally {
          try {
            if (delayedTransitions_1_1 && !delayedTransitions_1_1.done && (_a = delayedTransitions_1.return))
              _a.call(delayedTransitions_1);
          } finally {
            if (e_9)
              throw e_9.error;
          }
        }
        return formattedTransitions;
      };
      return StateNode2;
    }();
    exports.StateNode = StateNode;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/Machine.js
var require_Machine = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/Machine.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var StateNode = require_StateNode();
    function Machine(config, options, initialContext) {
      if (initialContext === void 0) {
        initialContext = config.context;
      }
      return new StateNode.StateNode(config, options, initialContext);
    }
    function createMachine3(config, options) {
      return new StateNode.StateNode(config, options);
    }
    exports.Machine = Machine;
    exports.createMachine = createMachine3;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/mapState.js
var require_mapState = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/mapState.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    function mapState(stateMap, stateId) {
      var e_1, _a;
      var foundStateId;
      try {
        for (var _b = _tslib.__values(Object.keys(stateMap)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var mappedStateId = _c.value;
          if (utils.matchesState(mappedStateId, stateId) && (!foundStateId || stateId.length > foundStateId.length)) {
            foundStateId = mappedStateId;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return))
            _a.call(_b);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return stateMap[foundStateId];
    }
    exports.mapState = mapState;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/match.js
var require_match = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/match.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _tslib = require_tslib();
    var State2 = require_State();
    function matchState(state, patterns, defaultValue) {
      var e_1, _a;
      var resolvedState = State2.State.from(state, state instanceof State2.State ? state.context : void 0);
      try {
        for (var patterns_1 = _tslib.__values(patterns), patterns_1_1 = patterns_1.next(); !patterns_1_1.done; patterns_1_1 = patterns_1.next()) {
          var _b = _tslib.__read(patterns_1_1.value, 2), stateValue = _b[0], getValue = _b[1];
          if (resolvedState.matches(stateValue)) {
            return getValue(resolvedState);
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (patterns_1_1 && !patterns_1_1.done && (_a = patterns_1.return))
            _a.call(patterns_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return defaultValue(resolvedState);
    }
    exports.matchState = matchState;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/schema.js
var require_schema = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/schema.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function createSchema(schema2) {
      return schema2;
    }
    var t = createSchema;
    exports.createSchema = createSchema;
    exports.t = t;
  }
});

// node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/index.js
var require_lib = __commonJS({
  "node_modules/.pnpm/xstate@4.32.1/node_modules/xstate/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var actions2 = require_actions();
    var Actor = require_Actor();
    var interpreter = require_interpreter();
    var Machine = require_Machine();
    var mapState = require_mapState();
    var match = require_match();
    var schema2 = require_schema();
    var State2 = require_State();
    var StateNode = require_StateNode();
    var behaviors = require_behaviors();
    var types2 = require_types();
    var utils = require_utils();
    var assign3 = actions2.assign;
    var send3 = actions2.send;
    var sendParent = actions2.sendParent;
    var sendUpdate = actions2.sendUpdate;
    var forwardTo = actions2.forwardTo;
    var doneInvoke = actions2.doneInvoke;
    exports.actions = actions2;
    exports.toActorRef = Actor.toActorRef;
    exports.Interpreter = interpreter.Interpreter;
    Object.defineProperty(exports, "InterpreterStatus", {
      enumerable: true,
      get: function() {
        return interpreter.InterpreterStatus;
      }
    });
    exports.interpret = interpreter.interpret;
    exports.spawn = interpreter.spawn;
    exports.Machine = Machine.Machine;
    exports.createMachine = Machine.createMachine;
    exports.mapState = mapState.mapState;
    exports.matchState = match.matchState;
    exports.createSchema = schema2.createSchema;
    exports.t = schema2.t;
    exports.State = State2.State;
    exports.StateNode = StateNode.StateNode;
    exports.spawnBehavior = behaviors.spawnBehavior;
    Object.defineProperty(exports, "ActionTypes", {
      enumerable: true,
      get: function() {
        return types2.ActionTypes;
      }
    });
    Object.defineProperty(exports, "SpecialTargets", {
      enumerable: true,
      get: function() {
        return types2.SpecialTargets;
      }
    });
    exports.matchesState = utils.matchesState;
    exports.toEventObject = utils.toEventObject;
    exports.toObserver = utils.toObserver;
    exports.toSCXMLEvent = utils.toSCXMLEvent;
    exports.assign = assign3;
    exports.doneInvoke = doneInvoke;
    exports.forwardTo = forwardTo;
    exports.send = send3;
    exports.sendParent = sendParent;
    exports.sendUpdate = sendUpdate;
  }
});

// node_modules/.pnpm/loading-cli@1.1.0/node_modules/loading-cli/lib/utilities.js
var require_utilities = __commonJS({
  "node_modules/.pnpm/loading-cli@1.1.0/node_modules/loading-cli/lib/utilities.js"(exports, module2) {
    module2.exports = {
      extend: extend3
    };
    function extend3(des, src, override) {
      if (src instanceof Array) {
        for (var i = 0, len = src.length; i < len; i++)
          extend3(des, src[i], override);
      }
      for (var i in src) {
        if (override || !(i in des)) {
          des[i] = src[i];
        }
      }
      return des;
    }
  }
});

// node_modules/.pnpm/loading-cli@1.1.0/node_modules/loading-cli/lib/cursor.js
var require_cursor = __commonJS({
  "node_modules/.pnpm/loading-cli@1.1.0/node_modules/loading-cli/lib/cursor.js"(exports) {
    var hidden = false;
    exports.show = function(stream) {
      const s = stream || process.stderr;
      if (!s.isTTY) {
        return;
      }
      hidden = false;
      s.write("\x1B[?25h");
    };
    exports.hide = function(stream) {
      var s = stream || process.stderr;
      if (!s.isTTY) {
        return;
      }
      hidden = true;
      s.write("\x1B[?25l");
    };
    exports.toggle = function(force) {
      if (force !== void 0) {
        hidden = force;
      }
      if (hidden) {
        exports.show();
      } else {
        exports.hide();
      }
    };
  }
});

// node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/styles-name.js
var require_styles_name = __commonJS({
  "node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/styles-name.js"(exports, module2) {
    module2.exports = {
      colors: [
        "black",
        "red",
        "green",
        "yellow",
        "blue",
        "magenta",
        "cyan",
        "white"
      ],
      styles: [
        "bold",
        "faint",
        "italic",
        "underline",
        "blink",
        "overline",
        "inverse",
        "conceal",
        "strike"
      ]
    };
  }
});

// node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/supports-colors.js
var require_supports_colors = __commonJS({
  "node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/supports-colors.js"(exports, module2) {
    var argv = process.argv;
    module2.exports = function() {
      if (argv.indexOf("--no-color") !== -1 || argv.indexOf("--color=false") !== -1) {
        return false;
      }
      if (argv.indexOf("--color") !== -1 || argv.indexOf("--color=true") !== -1 || argv.indexOf("--color=always") !== -1) {
        return true;
      }
      if (process.stdout && !process.stdout.isTTY) {
        return false;
      }
      if (process.platform === "win32") {
        return true;
      }
      if ("COLORTERM" in process.env) {
        return true;
      }
      if (process.env.TERM === "dumb") {
        return false;
      }
      if (/^screen|^xterm|^vt100|color|ansi|cygwin|linux/i.test(process.env.TERM)) {
        return true;
      }
      return false;
    }();
  }
});

// node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/color.js
var require_color = __commonJS({
  "node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/color.js"(exports) {
    var _styles = require_styles_name();
    var isSupported = require_supports_colors();
    var colors = _styles.colors;
    var styles = _styles.styles;
    exports.color = {};
    function Colors(str2) {
      this.string = str2;
      this.styles = [];
      this.fgcolor = null;
      this.bgcolor = null;
      this.fgcolor_bt = null;
      this.bgcolor_bt = null;
      this.fgcolor_x = null;
      this.bgcolor_x = null;
    }
    for (i = 0; i < colors.length; i++) {
      (function(i2) {
        var name = colors[i2];
        Object.defineProperty(Colors.prototype, name, {
          get: function() {
            this.fgcolor = i2;
            return this;
          }
        });
        Object.defineProperty(Colors.prototype, name + "_b", {
          get: function() {
            this.bgcolor = i2;
            return this;
          }
        });
        Object.defineProperty(Colors.prototype, name + "_bt", {
          get: function() {
            this.fgcolor_bt = i2;
            return this;
          }
        });
        Object.defineProperty(Colors.prototype, name + "_bbt", {
          get: function() {
            this.bgcolor_bt = i2;
            return this;
          }
        });
        exports.color[name] = exports[name] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[" + (30 + i2) + "m" + text + "\x1B[0m";
        };
        exports.color[name + "_b"] = exports[name + "_b"] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[" + (40 + i2) + "m" + text + "\x1B[0m";
        };
        exports.color[name + "_bt"] = exports[name + "_bt"] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[" + (90 + i2) + "m" + text + "\x1B[0m";
        };
        exports.color[name + "_bbt"] = exports[name + "_bbt"] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[" + (100 + i2) + "m" + text + "\x1B[0m";
        };
      })(i);
    }
    var i;
    for (i = 0; i < 256; i++) {
      (function(i2) {
        Object.defineProperty(Colors.prototype, "x" + i2, {
          get: function() {
            this.fgcolor_x = i2;
            return this;
          }
        });
        Object.defineProperty(Colors.prototype, "xb" + i2, {
          get: function() {
            this.bgcolor_x = i2;
            return this;
          }
        });
        exports.color["x" + i2] = exports["x" + i2] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[38;5;" + i2 + "m" + text + "\x1B[0m";
        };
        exports.color["xb" + i2] = exports["xb" + i2] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[48;5;" + i2 + "m" + text + "\x1B[0m";
        };
      })(i);
    }
    var i;
    for (i = 0; i < styles.length; i++) {
      (function(i2) {
        var name = styles[i2];
        Object.defineProperty(Colors.prototype, name, {
          get: function() {
            if (this.styles.indexOf(i2) === -1) {
              this.styles = this.styles.concat(i2 + 1);
            }
            return this;
          }
        });
        exports.color[name] = exports[name] = function(text) {
          if (!isSupported)
            return text;
          return "\x1B[" + (i2 + 1) + "m" + text + "\x1B[0m";
        };
      })(i);
    }
    var i;
    Colors.prototype.colored = function(text) {
      var reset2 = "\x1B[0m";
      var is256 = isSupported;
      if (this.fgcolor_x && this.fgcolor_x !== null && is256) {
        text = "\x1B[38;5;" + this.fgcolor_x + "m" + text + reset2;
      }
      if (this.bgcolor_x && this.bgcolor_x !== null && is256) {
        text = "\x1B[48;5;" + this.bgcolor_x + "m" + text + reset2;
      }
      if (this.fgcolor !== null && this.fgcolor < 8) {
        text = "\x1B[" + (30 + this.fgcolor) + "m" + text + reset2;
      }
      if (this.fgcolor_bt !== null && this.fgcolor_bt < 8) {
        text = "\x1B[" + (90 + this.fgcolor_bt) + "m" + text + reset2;
      }
      if (this.bgcolor !== null && this.bgcolor < 8) {
        text = "\x1B[" + (40 + this.bgcolor) + "m" + text + reset2;
      }
      if (this.bgcolor_bt !== null && this.bgcolor_bt < 8) {
        text = "\x1B[" + (100 + this.bgcolor_bt) + "m" + text + reset2;
      }
      if (this.styles && this.styles.length) {
        text = "\x1B[" + this.styles.join(";") + "m" + text + reset2;
      }
      return text;
    };
    Colors.prototype.valueOf = function(type2) {
      var text = this.string;
      text = this.colored(text);
      return text;
    };
    exports.Colors = Colors;
  }
});

// node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/.pnpm/colors-cli@1.0.28/node_modules/colors-cli/lib/index.js"(exports, module2) {
    var color = require_color();
    exports = module2.exports = color;
  }
});

// node_modules/.pnpm/loading-cli@1.1.0/node_modules/loading-cli/lib/index.js
var require_lib3 = __commonJS({
  "node_modules/.pnpm/loading-cli@1.1.0/node_modules/loading-cli/lib/index.js"(exports, module2) {
    var ut = require_utilities();
    var cursor = require_cursor();
    var color = require_lib2();
    function loading2(options) {
      if (!(this instanceof loading2)) {
        return new loading2(options);
      }
      if (typeof options === "string") {
        options = {
          text: options
        };
      }
      this.options = ut.extend(options, {
        text: "",
        color: "cyan",
        stream: process.stderr,
        frames: ["\u25DC", "\u25E0", "\u25DD", "\u25DE", "\u25E1", "\u25DF"]
      });
      this.text = this.options.text;
      this.color = this.options.color;
      this.interval = this.options.interval || 60;
      this.stream = this.options.stream;
      this.frames = this.options.frames;
      this.id = null;
      this.enabled = this.options.enabled || this.stream && this.stream.isTTY && !process.env.CI;
      this.frameIndex = 0;
    }
    loading2.prototype.frame = function(frame) {
      if (frame)
        this.options.frames = frame;
      var frames = this.options.frames;
      var frame = frames[this.frameIndex];
      if (this.color) {
        frame = color[this.color](frame);
      }
      this.frameIndex = ++this.frameIndex % frames.length;
      return frame + " " + this.text;
    };
    loading2.prototype.clear = function() {
      if (!this.enabled) {
        return this;
      }
      this.stream.clearLine();
      this.stream.cursorTo(0);
      return this;
    };
    loading2.prototype.render = function() {
      this.clear();
      this.stream.write(this.frame());
      return this;
    };
    loading2.prototype.start = function(text) {
      if (text)
        this.text = text;
      if (!this.enabled || this.id)
        return this;
      this.clear();
      cursor.hide(this.stream);
      this.id = setInterval(this.render.bind(this), this.interval);
      return this;
    };
    loading2.prototype.stop = function() {
      if (!this.enabled)
        return this;
      clearInterval(this.id);
      this.id = null;
      this.clear();
      cursor.show(this.stream);
      return this;
    };
    loading2.prototype.succeed = function(text) {
      return this.stopAndPersist(color.green("\u2714"), text);
    };
    loading2.prototype.fail = function(text) {
      return this.stopAndPersist(color.red("\u2716"), text);
    };
    loading2.prototype.warn = function(text) {
      return this.stopAndPersist(color.yellow("\u26A0"), text);
    };
    loading2.prototype.info = function(text) {
      return this.stopAndPersist(color.blue("\u2139"), text);
    };
    loading2.prototype.stopAndPersist = function(symbol, text) {
      text = text || this.text;
      this.stop();
      this.stream.write((symbol ? symbol + " " : " ") + text + "\n");
      return this;
    };
    module2.exports = loading2;
  }
});

// node_modules/.pnpm/ansi-colors@4.1.3/node_modules/ansi-colors/symbols.js
var require_symbols = __commonJS({
  "node_modules/.pnpm/ansi-colors@4.1.3/node_modules/ansi-colors/symbols.js"(exports, module2) {
    "use strict";
    var isHyper = typeof process !== "undefined" && process.env.TERM_PROGRAM === "Hyper";
    var isWindows = typeof process !== "undefined" && process.platform === "win32";
    var isLinux = typeof process !== "undefined" && process.platform === "linux";
    var common2 = {
      ballotDisabled: "\u2612",
      ballotOff: "\u2610",
      ballotOn: "\u2611",
      bullet: "\u2022",
      bulletWhite: "\u25E6",
      fullBlock: "\u2588",
      heart: "\u2764",
      identicalTo: "\u2261",
      line: "\u2500",
      mark: "\u203B",
      middot: "\xB7",
      minus: "\uFF0D",
      multiplication: "\xD7",
      obelus: "\xF7",
      pencilDownRight: "\u270E",
      pencilRight: "\u270F",
      pencilUpRight: "\u2710",
      percent: "%",
      pilcrow2: "\u2761",
      pilcrow: "\xB6",
      plusMinus: "\xB1",
      question: "?",
      section: "\xA7",
      starsOff: "\u2606",
      starsOn: "\u2605",
      upDownArrow: "\u2195"
    };
    var windows = Object.assign({}, common2, {
      check: "\u221A",
      cross: "\xD7",
      ellipsisLarge: "...",
      ellipsis: "...",
      info: "i",
      questionSmall: "?",
      pointer: ">",
      pointerSmall: "\xBB",
      radioOff: "( )",
      radioOn: "(*)",
      warning: "\u203C"
    });
    var other = Object.assign({}, common2, {
      ballotCross: "\u2718",
      check: "\u2714",
      cross: "\u2716",
      ellipsisLarge: "\u22EF",
      ellipsis: "\u2026",
      info: "\u2139",
      questionFull: "\uFF1F",
      questionSmall: "\uFE56",
      pointer: isLinux ? "\u25B8" : "\u276F",
      pointerSmall: isLinux ? "\u2023" : "\u203A",
      radioOff: "\u25EF",
      radioOn: "\u25C9",
      warning: "\u26A0"
    });
    module2.exports = isWindows && !isHyper ? windows : other;
    Reflect.defineProperty(module2.exports, "common", { enumerable: false, value: common2 });
    Reflect.defineProperty(module2.exports, "windows", { enumerable: false, value: windows });
    Reflect.defineProperty(module2.exports, "other", { enumerable: false, value: other });
  }
});

// node_modules/.pnpm/ansi-colors@4.1.3/node_modules/ansi-colors/index.js
var require_ansi_colors = __commonJS({
  "node_modules/.pnpm/ansi-colors@4.1.3/node_modules/ansi-colors/index.js"(exports, module2) {
    "use strict";
    var isObject2 = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
    var ANSI_REGEX = /[\u001b\u009b][[\]#;?()]*(?:(?:(?:[^\W_]*;?[^\W_]*)\u0007)|(?:(?:[0-9]{1,4}(;[0-9]{0,4})*)?[~0-9=<>cf-nqrtyA-PRZ]))/g;
    var hasColor = () => {
      if (typeof process !== "undefined") {
        return process.env.FORCE_COLOR !== "0";
      }
      return false;
    };
    var create = () => {
      const colors = {
        enabled: hasColor(),
        visible: true,
        styles: {},
        keys: {}
      };
      const ansi = (style2) => {
        let open = style2.open = `\x1B[${style2.codes[0]}m`;
        let close = style2.close = `\x1B[${style2.codes[1]}m`;
        let regex = style2.regex = new RegExp(`\\u001b\\[${style2.codes[1]}m`, "g");
        style2.wrap = (input, newline) => {
          if (input.includes(close))
            input = input.replace(regex, close + open);
          let output = open + input + close;
          return newline ? output.replace(/\r*\n/g, `${close}$&${open}`) : output;
        };
        return style2;
      };
      const wrap = (style2, input, newline) => {
        return typeof style2 === "function" ? style2(input) : style2.wrap(input, newline);
      };
      const style = (input, stack) => {
        if (input === "" || input == null)
          return "";
        if (colors.enabled === false)
          return input;
        if (colors.visible === false)
          return "";
        let str2 = "" + input;
        let nl = str2.includes("\n");
        let n = stack.length;
        if (n > 0 && stack.includes("unstyle")) {
          stack = [.../* @__PURE__ */ new Set(["unstyle", ...stack])].reverse();
        }
        while (n-- > 0)
          str2 = wrap(colors.styles[stack[n]], str2, nl);
        return str2;
      };
      const define2 = (name, codes, type2) => {
        colors.styles[name] = ansi({ name, codes });
        let keys = colors.keys[type2] || (colors.keys[type2] = []);
        keys.push(name);
        Reflect.defineProperty(colors, name, {
          configurable: true,
          enumerable: true,
          set(value) {
            colors.alias(name, value);
          },
          get() {
            let color = (input) => style(input, color.stack);
            Reflect.setPrototypeOf(color, colors);
            color.stack = this.stack ? this.stack.concat(name) : [name];
            return color;
          }
        });
      };
      define2("reset", [0, 0], "modifier");
      define2("bold", [1, 22], "modifier");
      define2("dim", [2, 22], "modifier");
      define2("italic", [3, 23], "modifier");
      define2("underline", [4, 24], "modifier");
      define2("inverse", [7, 27], "modifier");
      define2("hidden", [8, 28], "modifier");
      define2("strikethrough", [9, 29], "modifier");
      define2("black", [30, 39], "color");
      define2("red", [31, 39], "color");
      define2("green", [32, 39], "color");
      define2("yellow", [33, 39], "color");
      define2("blue", [34, 39], "color");
      define2("magenta", [35, 39], "color");
      define2("cyan", [36, 39], "color");
      define2("white", [37, 39], "color");
      define2("gray", [90, 39], "color");
      define2("grey", [90, 39], "color");
      define2("bgBlack", [40, 49], "bg");
      define2("bgRed", [41, 49], "bg");
      define2("bgGreen", [42, 49], "bg");
      define2("bgYellow", [43, 49], "bg");
      define2("bgBlue", [44, 49], "bg");
      define2("bgMagenta", [45, 49], "bg");
      define2("bgCyan", [46, 49], "bg");
      define2("bgWhite", [47, 49], "bg");
      define2("blackBright", [90, 39], "bright");
      define2("redBright", [91, 39], "bright");
      define2("greenBright", [92, 39], "bright");
      define2("yellowBright", [93, 39], "bright");
      define2("blueBright", [94, 39], "bright");
      define2("magentaBright", [95, 39], "bright");
      define2("cyanBright", [96, 39], "bright");
      define2("whiteBright", [97, 39], "bright");
      define2("bgBlackBright", [100, 49], "bgBright");
      define2("bgRedBright", [101, 49], "bgBright");
      define2("bgGreenBright", [102, 49], "bgBright");
      define2("bgYellowBright", [103, 49], "bgBright");
      define2("bgBlueBright", [104, 49], "bgBright");
      define2("bgMagentaBright", [105, 49], "bgBright");
      define2("bgCyanBright", [106, 49], "bgBright");
      define2("bgWhiteBright", [107, 49], "bgBright");
      colors.ansiRegex = ANSI_REGEX;
      colors.hasColor = colors.hasAnsi = (str2) => {
        colors.ansiRegex.lastIndex = 0;
        return typeof str2 === "string" && str2 !== "" && colors.ansiRegex.test(str2);
      };
      colors.alias = (name, color) => {
        let fn = typeof color === "string" ? colors[color] : color;
        if (typeof fn !== "function") {
          throw new TypeError("Expected alias to be the name of an existing color (string) or a function");
        }
        if (!fn.stack) {
          Reflect.defineProperty(fn, "name", { value: name });
          colors.styles[name] = fn;
          fn.stack = [name];
        }
        Reflect.defineProperty(colors, name, {
          configurable: true,
          enumerable: true,
          set(value) {
            colors.alias(name, value);
          },
          get() {
            let color2 = (input) => style(input, color2.stack);
            Reflect.setPrototypeOf(color2, colors);
            color2.stack = this.stack ? this.stack.concat(fn.stack) : fn.stack;
            return color2;
          }
        });
      };
      colors.theme = (custom) => {
        if (!isObject2(custom))
          throw new TypeError("Expected theme to be an object");
        for (let name of Object.keys(custom)) {
          colors.alias(name, custom[name]);
        }
        return colors;
      };
      colors.alias("unstyle", (str2) => {
        if (typeof str2 === "string" && str2 !== "") {
          colors.ansiRegex.lastIndex = 0;
          return str2.replace(colors.ansiRegex, "");
        }
        return "";
      });
      colors.alias("noop", (str2) => str2);
      colors.none = colors.clear = colors.noop;
      colors.stripColor = colors.unstyle;
      colors.symbols = require_symbols();
      colors.define = define2;
      return colors;
    };
    module2.exports = create();
    module2.exports.create = create;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/utils.js
var require_utils2 = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/utils.js"(exports) {
    "use strict";
    var toString2 = Object.prototype.toString;
    var colors = require_ansi_colors();
    var called = false;
    var fns = [];
    var complements = {
      "yellow": "blue",
      "cyan": "red",
      "green": "magenta",
      "black": "white",
      "blue": "yellow",
      "red": "cyan",
      "magenta": "green",
      "white": "black"
    };
    exports.longest = (arr, prop) => {
      return arr.reduce((a, v) => Math.max(a, prop ? v[prop].length : v.length), 0);
    };
    exports.hasColor = (str2) => !!str2 && colors.hasColor(str2);
    var isObject2 = exports.isObject = (val) => {
      return val !== null && typeof val === "object" && !Array.isArray(val);
    };
    exports.nativeType = (val) => {
      return toString2.call(val).slice(8, -1).toLowerCase().replace(/\s/g, "");
    };
    exports.isAsyncFn = (val) => {
      return exports.nativeType(val) === "asyncfunction";
    };
    exports.isPrimitive = (val) => {
      return val != null && typeof val !== "object" && typeof val !== "function";
    };
    exports.resolve = (context, value, ...rest) => {
      if (typeof value === "function") {
        return value.call(context, ...rest);
      }
      return value;
    };
    exports.scrollDown = (choices = []) => [...choices.slice(1), choices[0]];
    exports.scrollUp = (choices = []) => [choices.pop(), ...choices];
    exports.reorder = (arr = []) => {
      let res = arr.slice();
      res.sort((a, b) => {
        if (a.index > b.index)
          return 1;
        if (a.index < b.index)
          return -1;
        return 0;
      });
      return res;
    };
    exports.swap = (arr, index, pos) => {
      let len = arr.length;
      let idx2 = pos === len ? 0 : pos < 0 ? len - 1 : pos;
      let choice = arr[index];
      arr[index] = arr[idx2];
      arr[idx2] = choice;
    };
    exports.width = (stream, fallback = 80) => {
      let columns = stream && stream.columns ? stream.columns : fallback;
      if (stream && typeof stream.getWindowSize === "function") {
        columns = stream.getWindowSize()[0];
      }
      if (process.platform === "win32") {
        return columns - 1;
      }
      return columns;
    };
    exports.height = (stream, fallback = 20) => {
      let rows = stream && stream.rows ? stream.rows : fallback;
      if (stream && typeof stream.getWindowSize === "function") {
        rows = stream.getWindowSize()[1];
      }
      return rows;
    };
    exports.wordWrap = (str2, options = {}) => {
      if (!str2)
        return str2;
      if (typeof options === "number") {
        options = { width: options };
      }
      let { indent = "", newline = "\n" + indent, width = 80 } = options;
      let spaces = (newline + indent).match(/[^\S\n]/g) || [];
      width -= spaces.length;
      let source = `.{1,${width}}([\\s\\u200B]+|$)|[^\\s\\u200B]+?([\\s\\u200B]+|$)`;
      let output = str2.trim();
      let regex = new RegExp(source, "g");
      let lines = output.match(regex) || [];
      lines = lines.map((line) => line.replace(/\n$/, ""));
      if (options.padEnd)
        lines = lines.map((line) => line.padEnd(width, " "));
      if (options.padStart)
        lines = lines.map((line) => line.padStart(width, " "));
      return indent + lines.join(newline);
    };
    exports.unmute = (color) => {
      let name = color.stack.find((n) => colors.keys.color.includes(n));
      if (name) {
        return colors[name];
      }
      let bg = color.stack.find((n) => n.slice(2) === "bg");
      if (bg) {
        return colors[name.slice(2)];
      }
      return (str2) => str2;
    };
    exports.pascal = (str2) => str2 ? str2[0].toUpperCase() + str2.slice(1) : "";
    exports.inverse = (color) => {
      if (!color || !color.stack)
        return color;
      let name = color.stack.find((n) => colors.keys.color.includes(n));
      if (name) {
        let col = colors["bg" + exports.pascal(name)];
        return col ? col.black : color;
      }
      let bg = color.stack.find((n) => n.slice(0, 2) === "bg");
      if (bg) {
        return colors[bg.slice(2).toLowerCase()] || color;
      }
      return colors.none;
    };
    exports.complement = (color) => {
      if (!color || !color.stack)
        return color;
      let name = color.stack.find((n) => colors.keys.color.includes(n));
      let bg = color.stack.find((n) => n.slice(0, 2) === "bg");
      if (name && !bg) {
        return colors[complements[name] || name];
      }
      if (bg) {
        let lower = bg.slice(2).toLowerCase();
        let comp = complements[lower];
        if (!comp)
          return color;
        return colors["bg" + exports.pascal(comp)] || color;
      }
      return colors.none;
    };
    exports.meridiem = (date) => {
      let hours = date.getHours();
      let minutes = date.getMinutes();
      let ampm = hours >= 12 ? "pm" : "am";
      hours = hours % 12;
      let hrs = hours === 0 ? 12 : hours;
      let min = minutes < 10 ? "0" + minutes : minutes;
      return hrs + ":" + min + " " + ampm;
    };
    exports.set = (obj = {}, prop = "", val) => {
      return prop.split(".").reduce((acc, k, i, arr) => {
        let value = arr.length - 1 > i ? acc[k] || {} : val;
        if (!exports.isObject(value) && i < arr.length - 1)
          value = {};
        return acc[k] = value;
      }, obj);
    };
    exports.get = (obj = {}, prop = "", fallback) => {
      let value = obj[prop] == null ? prop.split(".").reduce((acc, k) => acc && acc[k], obj) : obj[prop];
      return value == null ? fallback : value;
    };
    exports.mixin = (target, b) => {
      if (!isObject2(target))
        return b;
      if (!isObject2(b))
        return target;
      for (let key of Object.keys(b)) {
        let desc = Object.getOwnPropertyDescriptor(b, key);
        if (desc.hasOwnProperty("value")) {
          if (target.hasOwnProperty(key) && isObject2(desc.value)) {
            let existing = Object.getOwnPropertyDescriptor(target, key);
            if (isObject2(existing.value)) {
              target[key] = exports.merge({}, target[key], b[key]);
            } else {
              Reflect.defineProperty(target, key, desc);
            }
          } else {
            Reflect.defineProperty(target, key, desc);
          }
        } else {
          Reflect.defineProperty(target, key, desc);
        }
      }
      return target;
    };
    exports.merge = (...args) => {
      let target = {};
      for (let ele of args)
        exports.mixin(target, ele);
      return target;
    };
    exports.mixinEmitter = (obj, emitter) => {
      let proto = emitter.constructor.prototype;
      for (let key of Object.keys(proto)) {
        let val = proto[key];
        if (typeof val === "function") {
          exports.define(obj, key, val.bind(emitter));
        } else {
          exports.define(obj, key, val);
        }
      }
    };
    exports.onExit = (callback) => {
      const onExit = (quit, code) => {
        if (called)
          return;
        called = true;
        fns.forEach((fn) => fn());
        if (quit === true) {
          process.exit(128 + code);
        }
      };
      if (fns.length === 0) {
        process.once("SIGTERM", onExit.bind(null, true, 15));
        process.once("SIGINT", onExit.bind(null, true, 2));
        process.once("exit", onExit);
      }
      fns.push(callback);
    };
    exports.define = (obj, key, value) => {
      Reflect.defineProperty(obj, key, { value });
    };
    exports.defineExport = (obj, key, fn) => {
      let custom;
      Reflect.defineProperty(obj, key, {
        enumerable: true,
        configurable: true,
        set(val) {
          custom = val;
        },
        get() {
          return custom ? custom() : fn();
        }
      });
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/combos.js
var require_combos = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/combos.js"(exports) {
    "use strict";
    exports.ctrl = {
      a: "first",
      b: "backward",
      c: "cancel",
      d: "deleteForward",
      e: "last",
      f: "forward",
      g: "reset",
      i: "tab",
      k: "cutForward",
      l: "reset",
      n: "newItem",
      m: "cancel",
      j: "submit",
      p: "search",
      r: "remove",
      s: "save",
      u: "undo",
      w: "cutLeft",
      x: "toggleCursor",
      v: "paste"
    };
    exports.shift = {
      up: "shiftUp",
      down: "shiftDown",
      left: "shiftLeft",
      right: "shiftRight",
      tab: "prev"
    };
    exports.fn = {
      up: "pageUp",
      down: "pageDown",
      left: "pageLeft",
      right: "pageRight",
      delete: "deleteForward"
    };
    exports.option = {
      b: "backward",
      f: "forward",
      d: "cutRight",
      left: "cutLeft",
      up: "altUp",
      down: "altDown"
    };
    exports.keys = {
      pageup: "pageUp",
      pagedown: "pageDown",
      home: "home",
      end: "end",
      cancel: "cancel",
      delete: "deleteForward",
      backspace: "delete",
      down: "down",
      enter: "submit",
      escape: "cancel",
      left: "left",
      space: "space",
      number: "number",
      return: "submit",
      right: "right",
      tab: "next",
      up: "up"
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/keypress.js
var require_keypress = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/keypress.js"(exports, module2) {
    "use strict";
    var readline = require("readline");
    var combos = require_combos();
    var metaKeyCodeRe = /^(?:\x1b)([a-zA-Z0-9])$/;
    var fnKeyRe = /^(?:\x1b+)(O|N|\[|\[\[)(?:(\d+)(?:;(\d+))?([~^$])|(?:1;)?(\d+)?([a-zA-Z]))/;
    var keyName = {
      "OP": "f1",
      "OQ": "f2",
      "OR": "f3",
      "OS": "f4",
      "[11~": "f1",
      "[12~": "f2",
      "[13~": "f3",
      "[14~": "f4",
      "[[A": "f1",
      "[[B": "f2",
      "[[C": "f3",
      "[[D": "f4",
      "[[E": "f5",
      "[15~": "f5",
      "[17~": "f6",
      "[18~": "f7",
      "[19~": "f8",
      "[20~": "f9",
      "[21~": "f10",
      "[23~": "f11",
      "[24~": "f12",
      "[A": "up",
      "[B": "down",
      "[C": "right",
      "[D": "left",
      "[E": "clear",
      "[F": "end",
      "[H": "home",
      "OA": "up",
      "OB": "down",
      "OC": "right",
      "OD": "left",
      "OE": "clear",
      "OF": "end",
      "OH": "home",
      "[1~": "home",
      "[2~": "insert",
      "[3~": "delete",
      "[4~": "end",
      "[5~": "pageup",
      "[6~": "pagedown",
      "[[5~": "pageup",
      "[[6~": "pagedown",
      "[7~": "home",
      "[8~": "end",
      "[a": "up",
      "[b": "down",
      "[c": "right",
      "[d": "left",
      "[e": "clear",
      "[2$": "insert",
      "[3$": "delete",
      "[5$": "pageup",
      "[6$": "pagedown",
      "[7$": "home",
      "[8$": "end",
      "Oa": "up",
      "Ob": "down",
      "Oc": "right",
      "Od": "left",
      "Oe": "clear",
      "[2^": "insert",
      "[3^": "delete",
      "[5^": "pageup",
      "[6^": "pagedown",
      "[7^": "home",
      "[8^": "end",
      "[Z": "tab"
    };
    function isShiftKey(code) {
      return ["[a", "[b", "[c", "[d", "[e", "[2$", "[3$", "[5$", "[6$", "[7$", "[8$", "[Z"].includes(code);
    }
    function isCtrlKey(code) {
      return ["Oa", "Ob", "Oc", "Od", "Oe", "[2^", "[3^", "[5^", "[6^", "[7^", "[8^"].includes(code);
    }
    var keypress = (s = "", event2 = {}) => {
      let parts;
      let key = {
        name: event2.name,
        ctrl: false,
        meta: false,
        shift: false,
        option: false,
        sequence: s,
        raw: s,
        ...event2
      };
      if (Buffer.isBuffer(s)) {
        if (s[0] > 127 && s[1] === void 0) {
          s[0] -= 128;
          s = "\x1B" + String(s);
        } else {
          s = String(s);
        }
      } else if (s !== void 0 && typeof s !== "string") {
        s = String(s);
      } else if (!s) {
        s = key.sequence || "";
      }
      key.sequence = key.sequence || s || key.name;
      if (s === "\r") {
        key.raw = void 0;
        key.name = "return";
      } else if (s === "\n") {
        key.name = "enter";
      } else if (s === "	") {
        key.name = "tab";
      } else if (s === "\b" || s === "\x7F" || s === "\x1B\x7F" || s === "\x1B\b") {
        key.name = "backspace";
        key.meta = s.charAt(0) === "\x1B";
      } else if (s === "\x1B" || s === "\x1B\x1B") {
        key.name = "escape";
        key.meta = s.length === 2;
      } else if (s === " " || s === "\x1B ") {
        key.name = "space";
        key.meta = s.length === 2;
      } else if (s <= "") {
        key.name = String.fromCharCode(s.charCodeAt(0) + "a".charCodeAt(0) - 1);
        key.ctrl = true;
      } else if (s.length === 1 && s >= "0" && s <= "9") {
        key.name = "number";
      } else if (s.length === 1 && s >= "a" && s <= "z") {
        key.name = s;
      } else if (s.length === 1 && s >= "A" && s <= "Z") {
        key.name = s.toLowerCase();
        key.shift = true;
      } else if (parts = metaKeyCodeRe.exec(s)) {
        key.meta = true;
        key.shift = /^[A-Z]$/.test(parts[1]);
      } else if (parts = fnKeyRe.exec(s)) {
        let segs = [...s];
        if (segs[0] === "\x1B" && segs[1] === "\x1B") {
          key.option = true;
        }
        let code = [parts[1], parts[2], parts[4], parts[6]].filter(Boolean).join("");
        let modifier = (parts[3] || parts[5] || 1) - 1;
        key.ctrl = !!(modifier & 4);
        key.meta = !!(modifier & 10);
        key.shift = !!(modifier & 1);
        key.code = code;
        key.name = keyName[code];
        key.shift = isShiftKey(code) || key.shift;
        key.ctrl = isCtrlKey(code) || key.ctrl;
      }
      return key;
    };
    keypress.listen = (options = {}, onKeypress) => {
      let { stdin } = options;
      if (!stdin || stdin !== process.stdin && !stdin.isTTY) {
        throw new Error("Invalid stream passed");
      }
      let rl = readline.createInterface({ terminal: true, input: stdin });
      readline.emitKeypressEvents(stdin, rl);
      let on = (buf, key) => onKeypress(buf, keypress(buf, key), rl);
      let isRaw = stdin.isRaw;
      if (stdin.isTTY)
        stdin.setRawMode(true);
      stdin.on("keypress", on);
      rl.resume();
      let off = () => {
        if (stdin.isTTY)
          stdin.setRawMode(isRaw);
        stdin.removeListener("keypress", on);
        rl.pause();
        rl.close();
      };
      return off;
    };
    keypress.action = (buf, key, customActions) => {
      let obj = { ...combos, ...customActions };
      if (key.ctrl) {
        key.action = obj.ctrl[key.name];
        return key;
      }
      if (key.option && obj.option) {
        key.action = obj.option[key.name];
        return key;
      }
      if (key.shift) {
        key.action = obj.shift[key.name];
        return key;
      }
      key.action = obj.keys[key.name];
      return key;
    };
    module2.exports = keypress;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/timer.js
var require_timer = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/timer.js"(exports, module2) {
    "use strict";
    module2.exports = (prompt) => {
      prompt.timers = prompt.timers || {};
      let timers = prompt.options.timers;
      if (!timers)
        return;
      for (let key of Object.keys(timers)) {
        let opts = timers[key];
        if (typeof opts === "number") {
          opts = { interval: opts };
        }
        create(prompt, key, opts);
      }
    };
    function create(prompt, name, options = {}) {
      let timer = prompt.timers[name] = { name, start: Date.now(), ms: 0, tick: 0 };
      let ms = options.interval || 120;
      timer.frames = options.frames || [];
      timer.loading = true;
      let interval = setInterval(() => {
        timer.ms = Date.now() - timer.start;
        timer.tick++;
        prompt.render();
      }, ms);
      timer.stop = () => {
        timer.loading = false;
        clearInterval(interval);
      };
      Reflect.defineProperty(timer, "interval", { value: interval });
      prompt.once("close", () => timer.stop());
      return timer.stop;
    }
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/state.js
var require_state = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/state.js"(exports, module2) {
    "use strict";
    var { define: define2, width } = require_utils2();
    var State2 = class {
      constructor(prompt) {
        let options = prompt.options;
        define2(this, "_prompt", prompt);
        this.type = prompt.type;
        this.name = prompt.name;
        this.message = "";
        this.header = "";
        this.footer = "";
        this.error = "";
        this.hint = "";
        this.input = "";
        this.cursor = 0;
        this.index = 0;
        this.lines = 0;
        this.tick = 0;
        this.prompt = "";
        this.buffer = "";
        this.width = width(options.stdout || process.stdout);
        Object.assign(this, options);
        this.name = this.name || this.message;
        this.message = this.message || this.name;
        this.symbols = prompt.symbols;
        this.styles = prompt.styles;
        this.required = /* @__PURE__ */ new Set();
        this.cancelled = false;
        this.submitted = false;
      }
      clone() {
        let state = { ...this };
        state.status = this.status;
        state.buffer = Buffer.from(state.buffer);
        delete state.clone;
        return state;
      }
      set color(val) {
        this._color = val;
      }
      get color() {
        let styles = this.prompt.styles;
        if (this.cancelled)
          return styles.cancelled;
        if (this.submitted)
          return styles.submitted;
        let color = this._color || styles[this.status];
        return typeof color === "function" ? color : styles.pending;
      }
      set loading(value) {
        this._loading = value;
      }
      get loading() {
        if (typeof this._loading === "boolean")
          return this._loading;
        if (this.loadingChoices)
          return "choices";
        return false;
      }
      get status() {
        if (this.cancelled)
          return "cancelled";
        if (this.submitted)
          return "submitted";
        return "pending";
      }
    };
    module2.exports = State2;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/styles.js
var require_styles = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/styles.js"(exports, module2) {
    "use strict";
    var utils = require_utils2();
    var colors = require_ansi_colors();
    var styles = {
      default: colors.noop,
      noop: colors.noop,
      set inverse(custom) {
        this._inverse = custom;
      },
      get inverse() {
        return this._inverse || utils.inverse(this.primary);
      },
      set complement(custom) {
        this._complement = custom;
      },
      get complement() {
        return this._complement || utils.complement(this.primary);
      },
      primary: colors.cyan,
      success: colors.green,
      danger: colors.magenta,
      strong: colors.bold,
      warning: colors.yellow,
      muted: colors.dim,
      disabled: colors.gray,
      dark: colors.dim.gray,
      underline: colors.underline,
      set info(custom) {
        this._info = custom;
      },
      get info() {
        return this._info || this.primary;
      },
      set em(custom) {
        this._em = custom;
      },
      get em() {
        return this._em || this.primary.underline;
      },
      set heading(custom) {
        this._heading = custom;
      },
      get heading() {
        return this._heading || this.muted.underline;
      },
      set pending(custom) {
        this._pending = custom;
      },
      get pending() {
        return this._pending || this.primary;
      },
      set submitted(custom) {
        this._submitted = custom;
      },
      get submitted() {
        return this._submitted || this.success;
      },
      set cancelled(custom) {
        this._cancelled = custom;
      },
      get cancelled() {
        return this._cancelled || this.danger;
      },
      set typing(custom) {
        this._typing = custom;
      },
      get typing() {
        return this._typing || this.dim;
      },
      set placeholder(custom) {
        this._placeholder = custom;
      },
      get placeholder() {
        return this._placeholder || this.primary.dim;
      },
      set highlight(custom) {
        this._highlight = custom;
      },
      get highlight() {
        return this._highlight || this.inverse;
      }
    };
    styles.merge = (options = {}) => {
      if (options.styles && typeof options.styles.enabled === "boolean") {
        colors.enabled = options.styles.enabled;
      }
      if (options.styles && typeof options.styles.visible === "boolean") {
        colors.visible = options.styles.visible;
      }
      let result2 = utils.merge({}, styles, options.styles);
      delete result2.merge;
      for (let key of Object.keys(colors)) {
        if (!result2.hasOwnProperty(key)) {
          Reflect.defineProperty(result2, key, { get: () => colors[key] });
        }
      }
      for (let key of Object.keys(colors.styles)) {
        if (!result2.hasOwnProperty(key)) {
          Reflect.defineProperty(result2, key, { get: () => colors[key] });
        }
      }
      return result2;
    };
    module2.exports = styles;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/symbols.js
var require_symbols2 = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/symbols.js"(exports, module2) {
    "use strict";
    var isWindows = process.platform === "win32";
    var colors = require_ansi_colors();
    var utils = require_utils2();
    var symbols = {
      ...colors.symbols,
      upDownDoubleArrow: "\u21D5",
      upDownDoubleArrow2: "\u2B0D",
      upDownArrow: "\u2195",
      asterisk: "*",
      asterism: "\u2042",
      bulletWhite: "\u25E6",
      electricArrow: "\u2301",
      ellipsisLarge: "\u22EF",
      ellipsisSmall: "\u2026",
      fullBlock: "\u2588",
      identicalTo: "\u2261",
      indicator: colors.symbols.check,
      leftAngle: "\u2039",
      mark: "\u203B",
      minus: "\u2212",
      multiplication: "\xD7",
      obelus: "\xF7",
      percent: "%",
      pilcrow: "\xB6",
      pilcrow2: "\u2761",
      pencilUpRight: "\u2710",
      pencilDownRight: "\u270E",
      pencilRight: "\u270F",
      plus: "+",
      plusMinus: "\xB1",
      pointRight: "\u261E",
      rightAngle: "\u203A",
      section: "\xA7",
      hexagon: { off: "\u2B21", on: "\u2B22", disabled: "\u2B22" },
      ballot: { on: "\u2611", off: "\u2610", disabled: "\u2612" },
      stars: { on: "\u2605", off: "\u2606", disabled: "\u2606" },
      folder: { on: "\u25BC", off: "\u25B6", disabled: "\u25B6" },
      prefix: {
        pending: colors.symbols.question,
        submitted: colors.symbols.check,
        cancelled: colors.symbols.cross
      },
      separator: {
        pending: colors.symbols.pointerSmall,
        submitted: colors.symbols.middot,
        cancelled: colors.symbols.middot
      },
      radio: {
        off: isWindows ? "( )" : "\u25EF",
        on: isWindows ? "(*)" : "\u25C9",
        disabled: isWindows ? "(|)" : "\u24BE"
      },
      numbers: ["\u24EA", "\u2460", "\u2461", "\u2462", "\u2463", "\u2464", "\u2465", "\u2466", "\u2467", "\u2468", "\u2469", "\u246A", "\u246B", "\u246C", "\u246D", "\u246E", "\u246F", "\u2470", "\u2471", "\u2472", "\u2473", "\u3251", "\u3252", "\u3253", "\u3254", "\u3255", "\u3256", "\u3257", "\u3258", "\u3259", "\u325A", "\u325B", "\u325C", "\u325D", "\u325E", "\u325F", "\u32B1", "\u32B2", "\u32B3", "\u32B4", "\u32B5", "\u32B6", "\u32B7", "\u32B8", "\u32B9", "\u32BA", "\u32BB", "\u32BC", "\u32BD", "\u32BE", "\u32BF"]
    };
    symbols.merge = (options) => {
      let result2 = utils.merge({}, colors.symbols, symbols, options.symbols);
      delete result2.merge;
      return result2;
    };
    module2.exports = symbols;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/theme.js
var require_theme = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/theme.js"(exports, module2) {
    "use strict";
    var styles = require_styles();
    var symbols = require_symbols2();
    var utils = require_utils2();
    module2.exports = (prompt) => {
      prompt.options = utils.merge({}, prompt.options.theme, prompt.options);
      prompt.symbols = symbols.merge(prompt.options);
      prompt.styles = styles.merge(prompt.options);
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/ansi.js
var require_ansi = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/ansi.js"(exports, module2) {
    "use strict";
    var isTerm = process.env.TERM_PROGRAM === "Apple_Terminal";
    var colors = require_ansi_colors();
    var utils = require_utils2();
    var ansi = module2.exports = exports;
    var ESC = "\x1B[";
    var BEL = "\x07";
    var hidden = false;
    var code = ansi.code = {
      bell: BEL,
      beep: BEL,
      beginning: `${ESC}G`,
      down: `${ESC}J`,
      esc: ESC,
      getPosition: `${ESC}6n`,
      hide: `${ESC}?25l`,
      line: `${ESC}2K`,
      lineEnd: `${ESC}K`,
      lineStart: `${ESC}1K`,
      restorePosition: ESC + (isTerm ? "8" : "u"),
      savePosition: ESC + (isTerm ? "7" : "s"),
      screen: `${ESC}2J`,
      show: `${ESC}?25h`,
      up: `${ESC}1J`
    };
    var cursor = ansi.cursor = {
      get hidden() {
        return hidden;
      },
      hide() {
        hidden = true;
        return code.hide;
      },
      show() {
        hidden = false;
        return code.show;
      },
      forward: (count = 1) => `${ESC}${count}C`,
      backward: (count = 1) => `${ESC}${count}D`,
      nextLine: (count = 1) => `${ESC}E`.repeat(count),
      prevLine: (count = 1) => `${ESC}F`.repeat(count),
      up: (count = 1) => count ? `${ESC}${count}A` : "",
      down: (count = 1) => count ? `${ESC}${count}B` : "",
      right: (count = 1) => count ? `${ESC}${count}C` : "",
      left: (count = 1) => count ? `${ESC}${count}D` : "",
      to(x, y) {
        return y ? `${ESC}${y + 1};${x + 1}H` : `${ESC}${x + 1}G`;
      },
      move(x = 0, y = 0) {
        let res = "";
        res += x < 0 ? cursor.left(-x) : x > 0 ? cursor.right(x) : "";
        res += y < 0 ? cursor.up(-y) : y > 0 ? cursor.down(y) : "";
        return res;
      },
      restore(state = {}) {
        let { after, cursor: cursor2, initial, input, prompt, size, value } = state;
        initial = utils.isPrimitive(initial) ? String(initial) : "";
        input = utils.isPrimitive(input) ? String(input) : "";
        value = utils.isPrimitive(value) ? String(value) : "";
        if (size) {
          let codes = ansi.cursor.up(size) + ansi.cursor.to(prompt.length);
          let diff2 = input.length - cursor2;
          if (diff2 > 0) {
            codes += ansi.cursor.left(diff2);
          }
          return codes;
        }
        if (value || after) {
          let pos = !input && !!initial ? -initial.length : -input.length + cursor2;
          if (after)
            pos -= after.length;
          if (input === "" && initial && !prompt.includes(initial)) {
            pos += initial.length;
          }
          return ansi.cursor.move(pos);
        }
      }
    };
    var erase = ansi.erase = {
      screen: code.screen,
      up: code.up,
      down: code.down,
      line: code.line,
      lineEnd: code.lineEnd,
      lineStart: code.lineStart,
      lines(n) {
        let str2 = "";
        for (let i = 0; i < n; i++) {
          str2 += ansi.erase.line + (i < n - 1 ? ansi.cursor.up(1) : "");
        }
        if (n)
          str2 += ansi.code.beginning;
        return str2;
      }
    };
    ansi.clear = (input = "", columns = process.stdout.columns) => {
      if (!columns)
        return erase.line + cursor.to(0);
      let width = (str2) => [...colors.unstyle(str2)].length;
      let lines = input.split(/\r?\n/);
      let rows = 0;
      for (let line of lines) {
        rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / columns);
      }
      return (erase.line + cursor.prevLine()).repeat(rows - 1) + erase.line + cursor.to(0);
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompt.js
var require_prompt = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompt.js"(exports, module2) {
    "use strict";
    var Events = require("events");
    var colors = require_ansi_colors();
    var keypress = require_keypress();
    var timer = require_timer();
    var State2 = require_state();
    var theme = require_theme();
    var utils = require_utils2();
    var ansi = require_ansi();
    var Prompt = class extends Events {
      constructor(options = {}) {
        super();
        this.name = options.name;
        this.type = options.type;
        this.options = options;
        theme(this);
        timer(this);
        this.state = new State2(this);
        this.initial = [options.initial, options.default].find((v) => v != null);
        this.stdout = options.stdout || process.stdout;
        this.stdin = options.stdin || process.stdin;
        this.scale = options.scale || 1;
        this.term = this.options.term || process.env.TERM_PROGRAM;
        this.margin = margin(this.options.margin);
        this.setMaxListeners(0);
        setOptions(this);
      }
      async keypress(input, event2 = {}) {
        this.keypressed = true;
        let key = keypress.action(input, keypress(input, event2), this.options.actions);
        this.state.keypress = key;
        this.emit("keypress", input, key);
        this.emit("state", this.state.clone());
        let fn = this.options[key.action] || this[key.action] || this.dispatch;
        if (typeof fn === "function") {
          return await fn.call(this, input, key);
        }
        this.alert();
      }
      alert() {
        delete this.state.alert;
        if (this.options.show === false) {
          this.emit("alert");
        } else {
          this.stdout.write(ansi.code.beep);
        }
      }
      cursorHide() {
        this.stdout.write(ansi.cursor.hide());
        utils.onExit(() => this.cursorShow());
      }
      cursorShow() {
        this.stdout.write(ansi.cursor.show());
      }
      write(str2) {
        if (!str2)
          return;
        if (this.stdout && this.state.show !== false) {
          this.stdout.write(str2);
        }
        this.state.buffer += str2;
      }
      clear(lines = 0) {
        let buffer = this.state.buffer;
        this.state.buffer = "";
        if (!buffer && !lines || this.options.show === false)
          return;
        this.stdout.write(ansi.cursor.down(lines) + ansi.clear(buffer, this.width));
      }
      restore() {
        if (this.state.closed || this.options.show === false)
          return;
        let { prompt, after, rest } = this.sections();
        let { cursor, initial = "", input = "", value = "" } = this;
        let size = this.state.size = rest.length;
        let state = { after, cursor, initial, input, prompt, size, value };
        let codes = ansi.cursor.restore(state);
        if (codes) {
          this.stdout.write(codes);
        }
      }
      sections() {
        let { buffer, input, prompt } = this.state;
        prompt = colors.unstyle(prompt);
        let buf = colors.unstyle(buffer);
        let idx2 = buf.indexOf(prompt);
        let header = buf.slice(0, idx2);
        let rest = buf.slice(idx2);
        let lines = rest.split("\n");
        let first = lines[0];
        let last = lines[lines.length - 1];
        let promptLine = prompt + (input ? " " + input : "");
        let len = promptLine.length;
        let after = len < first.length ? first.slice(len + 1) : "";
        return { header, prompt: first, after, rest: lines.slice(1), last };
      }
      async submit() {
        this.state.submitted = true;
        this.state.validating = true;
        if (this.options.onSubmit) {
          await this.options.onSubmit.call(this, this.name, this.value, this);
        }
        let result2 = this.state.error || await this.validate(this.value, this.state);
        if (result2 !== true) {
          let error = "\n" + this.symbols.pointer + " ";
          if (typeof result2 === "string") {
            error += result2.trim();
          } else {
            error += "Invalid input";
          }
          this.state.error = "\n" + this.styles.danger(error);
          this.state.submitted = false;
          await this.render();
          await this.alert();
          this.state.validating = false;
          this.state.error = void 0;
          return;
        }
        this.state.validating = false;
        await this.render();
        await this.close();
        this.value = await this.result(this.value);
        this.emit("submit", this.value);
      }
      async cancel(err) {
        this.state.cancelled = this.state.submitted = true;
        await this.render();
        await this.close();
        if (typeof this.options.onCancel === "function") {
          await this.options.onCancel.call(this, this.name, this.value, this);
        }
        this.emit("cancel", await this.error(err));
      }
      async close() {
        this.state.closed = true;
        try {
          let sections = this.sections();
          let lines = Math.ceil(sections.prompt.length / this.width);
          if (sections.rest) {
            this.write(ansi.cursor.down(sections.rest.length));
          }
          this.write("\n".repeat(lines));
        } catch (err) {
        }
        this.emit("close");
      }
      start() {
        if (!this.stop && this.options.show !== false) {
          this.stop = keypress.listen(this, this.keypress.bind(this));
          this.once("close", this.stop);
        }
      }
      async skip() {
        this.skipped = this.options.skip === true;
        if (typeof this.options.skip === "function") {
          this.skipped = await this.options.skip.call(this, this.name, this.value);
        }
        return this.skipped;
      }
      async initialize() {
        let { format, options, result: result2 } = this;
        this.format = () => format.call(this, this.value);
        this.result = () => result2.call(this, this.value);
        if (typeof options.initial === "function") {
          this.initial = await options.initial.call(this, this);
        }
        if (typeof options.onRun === "function") {
          await options.onRun.call(this, this);
        }
        if (typeof options.onSubmit === "function") {
          let onSubmit = options.onSubmit.bind(this);
          let submit = this.submit.bind(this);
          delete this.options.onSubmit;
          this.submit = async () => {
            await onSubmit(this.name, this.value, this);
            return submit();
          };
        }
        await this.start();
        await this.render();
      }
      render() {
        throw new Error("expected prompt to have a custom render method");
      }
      run() {
        return new Promise(async (resolve, reject) => {
          this.once("submit", resolve);
          this.once("cancel", reject);
          if (await this.skip()) {
            this.render = () => {
            };
            return this.submit();
          }
          await this.initialize();
          this.emit("run");
        });
      }
      async element(name, choice, i) {
        let { options, state, symbols, timers } = this;
        let timer2 = timers && timers[name];
        state.timer = timer2;
        let value = options[name] || state[name] || symbols[name];
        let val = choice && choice[name] != null ? choice[name] : await value;
        if (val === "")
          return val;
        let res = await this.resolve(val, state, choice, i);
        if (!res && choice && choice[name]) {
          return this.resolve(value, state, choice, i);
        }
        return res;
      }
      async prefix() {
        let element = await this.element("prefix") || this.symbols;
        let timer2 = this.timers && this.timers.prefix;
        let state = this.state;
        state.timer = timer2;
        if (utils.isObject(element))
          element = element[state.status] || element.pending;
        if (!utils.hasColor(element)) {
          let style = this.styles[state.status] || this.styles.pending;
          return style(element);
        }
        return element;
      }
      async message() {
        let message = await this.element("message");
        if (!utils.hasColor(message)) {
          return this.styles.strong(message);
        }
        return message;
      }
      async separator() {
        let element = await this.element("separator") || this.symbols;
        let timer2 = this.timers && this.timers.separator;
        let state = this.state;
        state.timer = timer2;
        let value = element[state.status] || element.pending || state.separator;
        let ele = await this.resolve(value, state);
        if (utils.isObject(ele))
          ele = ele[state.status] || ele.pending;
        if (!utils.hasColor(ele)) {
          return this.styles.muted(ele);
        }
        return ele;
      }
      async pointer(choice, i) {
        let val = await this.element("pointer", choice, i);
        if (typeof val === "string" && utils.hasColor(val)) {
          return val;
        }
        if (val) {
          let styles = this.styles;
          let focused = this.index === i;
          let style = focused ? styles.primary : (val2) => val2;
          let ele = await this.resolve(val[focused ? "on" : "off"] || val, this.state);
          let styled = !utils.hasColor(ele) ? style(ele) : ele;
          return focused ? styled : " ".repeat(ele.length);
        }
      }
      async indicator(choice, i) {
        let val = await this.element("indicator", choice, i);
        if (typeof val === "string" && utils.hasColor(val)) {
          return val;
        }
        if (val) {
          let styles = this.styles;
          let enabled = choice.enabled === true;
          let style = enabled ? styles.success : styles.dark;
          let ele = val[enabled ? "on" : "off"] || val;
          return !utils.hasColor(ele) ? style(ele) : ele;
        }
        return "";
      }
      body() {
        return null;
      }
      footer() {
        if (this.state.status === "pending") {
          return this.element("footer");
        }
      }
      header() {
        if (this.state.status === "pending") {
          return this.element("header");
        }
      }
      async hint() {
        if (this.state.status === "pending" && !this.isValue(this.state.input)) {
          let hint = await this.element("hint");
          if (!utils.hasColor(hint)) {
            return this.styles.muted(hint);
          }
          return hint;
        }
      }
      error(err) {
        return !this.state.submitted ? err || this.state.error : "";
      }
      format(value) {
        return value;
      }
      result(value) {
        return value;
      }
      validate(value) {
        if (this.options.required === true) {
          return this.isValue(value);
        }
        return true;
      }
      isValue(value) {
        return value != null && value !== "";
      }
      resolve(value, ...args) {
        return utils.resolve(this, value, ...args);
      }
      get base() {
        return Prompt.prototype;
      }
      get style() {
        return this.styles[this.state.status];
      }
      get height() {
        return this.options.rows || utils.height(this.stdout, 25);
      }
      get width() {
        return this.options.columns || utils.width(this.stdout, 80);
      }
      get size() {
        return { width: this.width, height: this.height };
      }
      set cursor(value) {
        this.state.cursor = value;
      }
      get cursor() {
        return this.state.cursor;
      }
      set input(value) {
        this.state.input = value;
      }
      get input() {
        return this.state.input;
      }
      set value(value) {
        this.state.value = value;
      }
      get value() {
        let { input, value } = this.state;
        let result2 = [value, input].find(this.isValue.bind(this));
        return this.isValue(result2) ? result2 : this.initial;
      }
      static get prompt() {
        return (options) => new this(options).run();
      }
    };
    function setOptions(prompt) {
      let isValidKey = (key) => {
        return prompt[key] === void 0 || typeof prompt[key] === "function";
      };
      let ignore = [
        "actions",
        "choices",
        "initial",
        "margin",
        "roles",
        "styles",
        "symbols",
        "theme",
        "timers",
        "value"
      ];
      let ignoreFn = [
        "body",
        "footer",
        "error",
        "header",
        "hint",
        "indicator",
        "message",
        "prefix",
        "separator",
        "skip"
      ];
      for (let key of Object.keys(prompt.options)) {
        if (ignore.includes(key))
          continue;
        if (/^on[A-Z]/.test(key))
          continue;
        let option = prompt.options[key];
        if (typeof option === "function" && isValidKey(key)) {
          if (!ignoreFn.includes(key)) {
            prompt[key] = option.bind(prompt);
          }
        } else if (typeof prompt[key] !== "function") {
          prompt[key] = option;
        }
      }
    }
    function margin(value) {
      if (typeof value === "number") {
        value = [value, value, value, value];
      }
      let arr = [].concat(value || []);
      let pad = (i) => i % 2 === 0 ? "\n" : " ";
      let res = [];
      for (let i = 0; i < 4; i++) {
        let char = pad(i);
        if (arr[i]) {
          res.push(char.repeat(arr[i]));
        } else {
          res.push("");
        }
      }
      return res;
    }
    module2.exports = Prompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/roles.js
var require_roles = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/roles.js"(exports, module2) {
    "use strict";
    var utils = require_utils2();
    var roles = {
      default(prompt, choice) {
        return choice;
      },
      checkbox(prompt, choice) {
        throw new Error("checkbox role is not implemented yet");
      },
      editable(prompt, choice) {
        throw new Error("editable role is not implemented yet");
      },
      expandable(prompt, choice) {
        throw new Error("expandable role is not implemented yet");
      },
      heading(prompt, choice) {
        choice.disabled = "";
        choice.indicator = [choice.indicator, " "].find((v) => v != null);
        choice.message = choice.message || "";
        return choice;
      },
      input(prompt, choice) {
        throw new Error("input role is not implemented yet");
      },
      option(prompt, choice) {
        return roles.default(prompt, choice);
      },
      radio(prompt, choice) {
        throw new Error("radio role is not implemented yet");
      },
      separator(prompt, choice) {
        choice.disabled = "";
        choice.indicator = [choice.indicator, " "].find((v) => v != null);
        choice.message = choice.message || prompt.symbols.line.repeat(5);
        return choice;
      },
      spacer(prompt, choice) {
        return choice;
      }
    };
    module2.exports = (name, options = {}) => {
      let role = utils.merge({}, roles, options.roles);
      return role[name] || role.default;
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/array.js
var require_array = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/array.js"(exports, module2) {
    "use strict";
    var colors = require_ansi_colors();
    var Prompt = require_prompt();
    var roles = require_roles();
    var utils = require_utils2();
    var { reorder, scrollUp, scrollDown, isObject: isObject2, swap } = utils;
    var ArrayPrompt = class extends Prompt {
      constructor(options) {
        super(options);
        this.cursorHide();
        this.maxSelected = options.maxSelected || Infinity;
        this.multiple = options.multiple || false;
        this.initial = options.initial || 0;
        this.delay = options.delay || 0;
        this.longest = 0;
        this.num = "";
      }
      async initialize() {
        if (typeof this.options.initial === "function") {
          this.initial = await this.options.initial.call(this);
        }
        await this.reset(true);
        await super.initialize();
      }
      async reset() {
        let { choices, initial, autofocus, suggest } = this.options;
        this.state._choices = [];
        this.state.choices = [];
        this.choices = await Promise.all(await this.toChoices(choices));
        this.choices.forEach((ch) => ch.enabled = false);
        if (typeof suggest !== "function" && this.selectable.length === 0) {
          throw new Error("At least one choice must be selectable");
        }
        if (isObject2(initial))
          initial = Object.keys(initial);
        if (Array.isArray(initial)) {
          if (autofocus != null)
            this.index = this.findIndex(autofocus);
          initial.forEach((v) => this.enable(this.find(v)));
          await this.render();
        } else {
          if (autofocus != null)
            initial = autofocus;
          if (typeof initial === "string")
            initial = this.findIndex(initial);
          if (typeof initial === "number" && initial > -1) {
            this.index = Math.max(0, Math.min(initial, this.choices.length));
            this.enable(this.find(this.index));
          }
        }
        if (this.isDisabled(this.focused)) {
          await this.down();
        }
      }
      async toChoices(value, parent) {
        this.state.loadingChoices = true;
        let choices = [];
        let index = 0;
        let toChoices = async (items, parent2) => {
          if (typeof items === "function")
            items = await items.call(this);
          if (items instanceof Promise)
            items = await items;
          for (let i = 0; i < items.length; i++) {
            let choice = items[i] = await this.toChoice(items[i], index++, parent2);
            choices.push(choice);
            if (choice.choices) {
              await toChoices(choice.choices, choice);
            }
          }
          return choices;
        };
        return toChoices(value, parent).then((choices2) => {
          this.state.loadingChoices = false;
          return choices2;
        });
      }
      async toChoice(ele, i, parent) {
        if (typeof ele === "function")
          ele = await ele.call(this, this);
        if (ele instanceof Promise)
          ele = await ele;
        if (typeof ele === "string")
          ele = { name: ele };
        if (ele.normalized)
          return ele;
        ele.normalized = true;
        let origVal = ele.value;
        let role = roles(ele.role, this.options);
        ele = role(this, ele);
        if (typeof ele.disabled === "string" && !ele.hint) {
          ele.hint = ele.disabled;
          ele.disabled = true;
        }
        if (ele.disabled === true && ele.hint == null) {
          ele.hint = "(disabled)";
        }
        if (ele.index != null)
          return ele;
        ele.name = ele.name || ele.key || ele.title || ele.value || ele.message;
        ele.message = ele.message || ele.name || "";
        ele.value = [ele.value, ele.name].find(this.isValue.bind(this));
        ele.input = "";
        ele.index = i;
        ele.cursor = 0;
        utils.define(ele, "parent", parent);
        ele.level = parent ? parent.level + 1 : 1;
        if (ele.indent == null) {
          ele.indent = parent ? parent.indent + "  " : ele.indent || "";
        }
        ele.path = parent ? parent.path + "." + ele.name : ele.name;
        ele.enabled = !!(this.multiple && !this.isDisabled(ele) && (ele.enabled || this.isSelected(ele)));
        if (!this.isDisabled(ele)) {
          this.longest = Math.max(this.longest, colors.unstyle(ele.message).length);
        }
        let choice = { ...ele };
        ele.reset = (input = choice.input, value = choice.value) => {
          for (let key of Object.keys(choice))
            ele[key] = choice[key];
          ele.input = input;
          ele.value = value;
        };
        if (origVal == null && typeof ele.initial === "function") {
          ele.input = await ele.initial.call(this, this.state, ele, i);
        }
        return ele;
      }
      async onChoice(choice, i) {
        this.emit("choice", choice, i, this);
        if (typeof choice.onChoice === "function") {
          await choice.onChoice.call(this, this.state, choice, i);
        }
      }
      async addChoice(ele, i, parent) {
        let choice = await this.toChoice(ele, i, parent);
        this.choices.push(choice);
        this.index = this.choices.length - 1;
        this.limit = this.choices.length;
        return choice;
      }
      async newItem(item, i, parent) {
        let ele = { name: "New choice name?", editable: true, newChoice: true, ...item };
        let choice = await this.addChoice(ele, i, parent);
        choice.updateChoice = () => {
          delete choice.newChoice;
          choice.name = choice.message = choice.input;
          choice.input = "";
          choice.cursor = 0;
        };
        return this.render();
      }
      indent(choice) {
        if (choice.indent == null) {
          return choice.level > 1 ? "  ".repeat(choice.level - 1) : "";
        }
        return choice.indent;
      }
      dispatch(s, key) {
        if (this.multiple && this[key.name])
          return this[key.name]();
        this.alert();
      }
      focus(choice, enabled) {
        if (typeof enabled !== "boolean")
          enabled = choice.enabled;
        if (enabled && !choice.enabled && this.selected.length >= this.maxSelected) {
          return this.alert();
        }
        this.index = choice.index;
        choice.enabled = enabled && !this.isDisabled(choice);
        return choice;
      }
      space() {
        if (!this.multiple)
          return this.alert();
        this.toggle(this.focused);
        return this.render();
      }
      a() {
        if (this.maxSelected < this.choices.length)
          return this.alert();
        let enabled = this.selectable.every((ch) => ch.enabled);
        this.choices.forEach((ch) => ch.enabled = !enabled);
        return this.render();
      }
      i() {
        if (this.choices.length - this.selected.length > this.maxSelected) {
          return this.alert();
        }
        this.choices.forEach((ch) => ch.enabled = !ch.enabled);
        return this.render();
      }
      g(choice = this.focused) {
        if (!this.choices.some((ch) => !!ch.parent))
          return this.a();
        this.toggle(choice.parent && !choice.choices ? choice.parent : choice);
        return this.render();
      }
      toggle(choice, enabled) {
        if (!choice.enabled && this.selected.length >= this.maxSelected) {
          return this.alert();
        }
        if (typeof enabled !== "boolean")
          enabled = !choice.enabled;
        choice.enabled = enabled;
        if (choice.choices) {
          choice.choices.forEach((ch) => this.toggle(ch, enabled));
        }
        let parent = choice.parent;
        while (parent) {
          let choices = parent.choices.filter((ch) => this.isDisabled(ch));
          parent.enabled = choices.every((ch) => ch.enabled === true);
          parent = parent.parent;
        }
        reset2(this, this.choices);
        this.emit("toggle", choice, this);
        return choice;
      }
      enable(choice) {
        if (this.selected.length >= this.maxSelected)
          return this.alert();
        choice.enabled = !this.isDisabled(choice);
        choice.choices && choice.choices.forEach(this.enable.bind(this));
        return choice;
      }
      disable(choice) {
        choice.enabled = false;
        choice.choices && choice.choices.forEach(this.disable.bind(this));
        return choice;
      }
      number(n) {
        this.num += n;
        let number = (num) => {
          let i = Number(num);
          if (i > this.choices.length - 1)
            return this.alert();
          let focused = this.focused;
          let choice = this.choices.find((ch) => i === ch.index);
          if (!choice.enabled && this.selected.length >= this.maxSelected) {
            return this.alert();
          }
          if (this.visible.indexOf(choice) === -1) {
            let choices = reorder(this.choices);
            let actualIdx = choices.indexOf(choice);
            if (focused.index > actualIdx) {
              let start = choices.slice(actualIdx, actualIdx + this.limit);
              let end = choices.filter((ch) => !start.includes(ch));
              this.choices = start.concat(end);
            } else {
              let pos = actualIdx - this.limit + 1;
              this.choices = choices.slice(pos).concat(choices.slice(0, pos));
            }
          }
          this.index = this.choices.indexOf(choice);
          this.toggle(this.focused);
          return this.render();
        };
        clearTimeout(this.numberTimeout);
        return new Promise((resolve) => {
          let len = this.choices.length;
          let num = this.num;
          let handle = (val = false, res) => {
            clearTimeout(this.numberTimeout);
            if (val)
              res = number(num);
            this.num = "";
            resolve(res);
          };
          if (num === "0" || num.length === 1 && Number(num + "0") > len) {
            return handle(true);
          }
          if (Number(num) > len) {
            return handle(false, this.alert());
          }
          this.numberTimeout = setTimeout(() => handle(true), this.delay);
        });
      }
      home() {
        this.choices = reorder(this.choices);
        this.index = 0;
        return this.render();
      }
      end() {
        let pos = this.choices.length - this.limit;
        let choices = reorder(this.choices);
        this.choices = choices.slice(pos).concat(choices.slice(0, pos));
        this.index = this.limit - 1;
        return this.render();
      }
      first() {
        this.index = 0;
        return this.render();
      }
      last() {
        this.index = this.visible.length - 1;
        return this.render();
      }
      prev() {
        if (this.visible.length <= 1)
          return this.alert();
        return this.up();
      }
      next() {
        if (this.visible.length <= 1)
          return this.alert();
        return this.down();
      }
      right() {
        if (this.cursor >= this.input.length)
          return this.alert();
        this.cursor++;
        return this.render();
      }
      left() {
        if (this.cursor <= 0)
          return this.alert();
        this.cursor--;
        return this.render();
      }
      up() {
        let len = this.choices.length;
        let vis = this.visible.length;
        let idx2 = this.index;
        if (this.options.scroll === false && idx2 === 0) {
          return this.alert();
        }
        if (len > vis && idx2 === 0) {
          return this.scrollUp();
        }
        this.index = (idx2 - 1 % len + len) % len;
        if (this.isDisabled()) {
          return this.up();
        }
        return this.render();
      }
      down() {
        let len = this.choices.length;
        let vis = this.visible.length;
        let idx2 = this.index;
        if (this.options.scroll === false && idx2 === vis - 1) {
          return this.alert();
        }
        if (len > vis && idx2 === vis - 1) {
          return this.scrollDown();
        }
        this.index = (idx2 + 1) % len;
        if (this.isDisabled()) {
          return this.down();
        }
        return this.render();
      }
      scrollUp(i = 0) {
        this.choices = scrollUp(this.choices);
        this.index = i;
        if (this.isDisabled()) {
          return this.up();
        }
        return this.render();
      }
      scrollDown(i = this.visible.length - 1) {
        this.choices = scrollDown(this.choices);
        this.index = i;
        if (this.isDisabled()) {
          return this.down();
        }
        return this.render();
      }
      async shiftUp() {
        if (this.options.sort === true) {
          this.sorting = true;
          this.swap(this.index - 1);
          await this.up();
          this.sorting = false;
          return;
        }
        return this.scrollUp(this.index);
      }
      async shiftDown() {
        if (this.options.sort === true) {
          this.sorting = true;
          this.swap(this.index + 1);
          await this.down();
          this.sorting = false;
          return;
        }
        return this.scrollDown(this.index);
      }
      pageUp() {
        if (this.visible.length <= 1)
          return this.alert();
        this.limit = Math.max(this.limit - 1, 0);
        this.index = Math.min(this.limit - 1, this.index);
        this._limit = this.limit;
        if (this.isDisabled()) {
          return this.up();
        }
        return this.render();
      }
      pageDown() {
        if (this.visible.length >= this.choices.length)
          return this.alert();
        this.index = Math.max(0, this.index);
        this.limit = Math.min(this.limit + 1, this.choices.length);
        this._limit = this.limit;
        if (this.isDisabled()) {
          return this.down();
        }
        return this.render();
      }
      swap(pos) {
        swap(this.choices, this.index, pos);
      }
      isDisabled(choice = this.focused) {
        let keys = ["disabled", "collapsed", "hidden", "completing", "readonly"];
        if (choice && keys.some((key) => choice[key] === true)) {
          return true;
        }
        return choice && choice.role === "heading";
      }
      isEnabled(choice = this.focused) {
        if (Array.isArray(choice))
          return choice.every((ch) => this.isEnabled(ch));
        if (choice.choices) {
          let choices = choice.choices.filter((ch) => !this.isDisabled(ch));
          return choice.enabled && choices.every((ch) => this.isEnabled(ch));
        }
        return choice.enabled && !this.isDisabled(choice);
      }
      isChoice(choice, value) {
        return choice.name === value || choice.index === Number(value);
      }
      isSelected(choice) {
        if (Array.isArray(this.initial)) {
          return this.initial.some((value) => this.isChoice(choice, value));
        }
        return this.isChoice(choice, this.initial);
      }
      map(names = [], prop = "value") {
        return [].concat(names || []).reduce((acc, name) => {
          acc[name] = this.find(name, prop);
          return acc;
        }, {});
      }
      filter(value, prop) {
        let isChoice = (ele, i) => [ele.name, i].includes(value);
        let fn = typeof value === "function" ? value : isChoice;
        let choices = this.options.multiple ? this.state._choices : this.choices;
        let result2 = choices.filter(fn);
        if (prop) {
          return result2.map((ch) => ch[prop]);
        }
        return result2;
      }
      find(value, prop) {
        if (isObject2(value))
          return prop ? value[prop] : value;
        let isChoice = (ele, i) => [ele.name, i].includes(value);
        let fn = typeof value === "function" ? value : isChoice;
        let choice = this.choices.find(fn);
        if (choice) {
          return prop ? choice[prop] : choice;
        }
      }
      findIndex(value) {
        return this.choices.indexOf(this.find(value));
      }
      async submit() {
        let choice = this.focused;
        if (!choice)
          return this.alert();
        if (choice.newChoice) {
          if (!choice.input)
            return this.alert();
          choice.updateChoice();
          return this.render();
        }
        if (this.choices.some((ch) => ch.newChoice)) {
          return this.alert();
        }
        let { reorder: reorder2, sort } = this.options;
        let multi = this.multiple === true;
        let value = this.selected;
        if (value === void 0) {
          return this.alert();
        }
        if (Array.isArray(value) && reorder2 !== false && sort !== true) {
          value = utils.reorder(value);
        }
        this.value = multi ? value.map((ch) => ch.name) : value.name;
        return super.submit();
      }
      set choices(choices = []) {
        this.state._choices = this.state._choices || [];
        this.state.choices = choices;
        for (let choice of choices) {
          if (!this.state._choices.some((ch) => ch.name === choice.name)) {
            this.state._choices.push(choice);
          }
        }
        if (!this._initial && this.options.initial) {
          this._initial = true;
          let init = this.initial;
          if (typeof init === "string" || typeof init === "number") {
            let choice = this.find(init);
            if (choice) {
              this.initial = choice.index;
              this.focus(choice, true);
            }
          }
        }
      }
      get choices() {
        return reset2(this, this.state.choices || []);
      }
      set visible(visible) {
        this.state.visible = visible;
      }
      get visible() {
        return (this.state.visible || this.choices).slice(0, this.limit);
      }
      set limit(num) {
        this.state.limit = num;
      }
      get limit() {
        let { state, options, choices } = this;
        let limit = state.limit || this._limit || options.limit || choices.length;
        return Math.min(limit, this.height);
      }
      set value(value) {
        super.value = value;
      }
      get value() {
        if (typeof super.value !== "string" && super.value === this.initial) {
          return this.input;
        }
        return super.value;
      }
      set index(i) {
        this.state.index = i;
      }
      get index() {
        return Math.max(0, this.state ? this.state.index : 0);
      }
      get enabled() {
        return this.filter(this.isEnabled.bind(this));
      }
      get focused() {
        let choice = this.choices[this.index];
        if (choice && this.state.submitted && this.multiple !== true) {
          choice.enabled = true;
        }
        return choice;
      }
      get selectable() {
        return this.choices.filter((choice) => !this.isDisabled(choice));
      }
      get selected() {
        return this.multiple ? this.enabled : this.focused;
      }
    };
    function reset2(prompt, choices) {
      if (choices instanceof Promise)
        return choices;
      if (typeof choices === "function") {
        if (utils.isAsyncFn(choices))
          return choices;
        choices = choices.call(prompt, prompt);
      }
      for (let choice of choices) {
        if (Array.isArray(choice.choices)) {
          let items = choice.choices.filter((ch) => !prompt.isDisabled(ch));
          choice.enabled = items.every((ch) => ch.enabled === true);
        }
        if (prompt.isDisabled(choice) === true) {
          delete choice.enabled;
        }
      }
      return choices;
    }
    module2.exports = ArrayPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/select.js
var require_select = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/select.js"(exports, module2) {
    "use strict";
    var ArrayPrompt = require_array();
    var utils = require_utils2();
    var SelectPrompt = class extends ArrayPrompt {
      constructor(options) {
        super(options);
        this.emptyError = this.options.emptyError || "No items were selected";
      }
      async dispatch(s, key) {
        if (this.multiple) {
          return this[key.name] ? await this[key.name](s, key) : await super.dispatch(s, key);
        }
        this.alert();
      }
      separator() {
        if (this.options.separator)
          return super.separator();
        let sep = this.styles.muted(this.symbols.ellipsis);
        return this.state.submitted ? super.separator() : sep;
      }
      pointer(choice, i) {
        return !this.multiple || this.options.pointer ? super.pointer(choice, i) : "";
      }
      indicator(choice, i) {
        return this.multiple ? super.indicator(choice, i) : "";
      }
      choiceMessage(choice, i) {
        let message = this.resolve(choice.message, this.state, choice, i);
        if (choice.role === "heading" && !utils.hasColor(message)) {
          message = this.styles.strong(message);
        }
        return this.resolve(message, this.state, choice, i);
      }
      choiceSeparator() {
        return ":";
      }
      async renderChoice(choice, i) {
        await this.onChoice(choice, i);
        let focused = this.index === i;
        let pointer = await this.pointer(choice, i);
        let check = await this.indicator(choice, i) + (choice.pad || "");
        let hint = await this.resolve(choice.hint, this.state, choice, i);
        if (hint && !utils.hasColor(hint)) {
          hint = this.styles.muted(hint);
        }
        let ind = this.indent(choice);
        let msg = await this.choiceMessage(choice, i);
        let line = () => [this.margin[3], ind + pointer + check, msg, this.margin[1], hint].filter(Boolean).join(" ");
        if (choice.role === "heading") {
          return line();
        }
        if (choice.disabled) {
          if (!utils.hasColor(msg)) {
            msg = this.styles.disabled(msg);
          }
          return line();
        }
        if (focused) {
          msg = this.styles.em(msg);
        }
        return line();
      }
      async renderChoices() {
        if (this.state.loading === "choices") {
          return this.styles.warning("Loading choices");
        }
        if (this.state.submitted)
          return "";
        let choices = this.visible.map(async (ch, i) => await this.renderChoice(ch, i));
        let visible = await Promise.all(choices);
        if (!visible.length)
          visible.push(this.styles.danger("No matching choices"));
        let result2 = this.margin[0] + visible.join("\n");
        let header;
        if (this.options.choicesHeader) {
          header = await this.resolve(this.options.choicesHeader, this.state);
        }
        return [header, result2].filter(Boolean).join("\n");
      }
      format() {
        if (!this.state.submitted || this.state.cancelled)
          return "";
        if (Array.isArray(this.selected)) {
          return this.selected.map((choice) => this.styles.primary(choice.name)).join(", ");
        }
        return this.styles.primary(this.selected.name);
      }
      async render() {
        let { submitted, size } = this.state;
        let prompt = "";
        let header = await this.header();
        let prefix = await this.prefix();
        let separator = await this.separator();
        let message = await this.message();
        if (this.options.promptLine !== false) {
          prompt = [prefix, message, separator, ""].join(" ");
          this.state.prompt = prompt;
        }
        let output = await this.format();
        let help = await this.error() || await this.hint();
        let body = await this.renderChoices();
        let footer = await this.footer();
        if (output)
          prompt += output;
        if (help && !prompt.includes(help))
          prompt += " " + help;
        if (submitted && !output && !body.trim() && this.multiple && this.emptyError != null) {
          prompt += this.styles.danger(this.emptyError);
        }
        this.clear(size);
        this.write([header, prompt, body, footer].filter(Boolean).join("\n"));
        this.write(this.margin[2]);
        this.restore();
      }
    };
    module2.exports = SelectPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/autocomplete.js
var require_autocomplete = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/autocomplete.js"(exports, module2) {
    "use strict";
    var Select2 = require_select();
    var highlight = (input, color) => {
      let val = input.toLowerCase();
      return (str2) => {
        let s = str2.toLowerCase();
        let i = s.indexOf(val);
        let colored = color(str2.slice(i, i + val.length));
        return i >= 0 ? str2.slice(0, i) + colored + str2.slice(i + val.length) : str2;
      };
    };
    var AutoComplete = class extends Select2 {
      constructor(options) {
        super(options);
        this.cursorShow();
      }
      moveCursor(n) {
        this.state.cursor += n;
      }
      dispatch(ch) {
        return this.append(ch);
      }
      space(ch) {
        return this.options.multiple ? super.space(ch) : this.append(ch);
      }
      append(ch) {
        let { cursor, input } = this.state;
        this.input = input.slice(0, cursor) + ch + input.slice(cursor);
        this.moveCursor(1);
        return this.complete();
      }
      delete() {
        let { cursor, input } = this.state;
        if (!input)
          return this.alert();
        this.input = input.slice(0, cursor - 1) + input.slice(cursor);
        this.moveCursor(-1);
        return this.complete();
      }
      deleteForward() {
        let { cursor, input } = this.state;
        if (input[cursor] === void 0)
          return this.alert();
        this.input = `${input}`.slice(0, cursor) + `${input}`.slice(cursor + 1);
        return this.complete();
      }
      number(ch) {
        return this.append(ch);
      }
      async complete() {
        this.completing = true;
        this.choices = await this.suggest(this.input, this.state._choices);
        this.state.limit = void 0;
        this.index = Math.min(Math.max(this.visible.length - 1, 0), this.index);
        await this.render();
        this.completing = false;
      }
      suggest(input = this.input, choices = this.state._choices) {
        if (typeof this.options.suggest === "function") {
          return this.options.suggest.call(this, input, choices);
        }
        let str2 = input.toLowerCase();
        return choices.filter((ch) => ch.message.toLowerCase().includes(str2));
      }
      pointer() {
        return "";
      }
      format() {
        if (!this.focused)
          return this.input;
        if (this.options.multiple && this.state.submitted) {
          return this.selected.map((ch) => this.styles.primary(ch.message)).join(", ");
        }
        if (this.state.submitted) {
          let value = this.value = this.input = this.focused.value;
          return this.styles.primary(value);
        }
        return this.input;
      }
      async render() {
        if (this.state.status !== "pending")
          return super.render();
        let style = this.options.highlight ? this.options.highlight.bind(this) : this.styles.placeholder;
        let color = highlight(this.input, style);
        let choices = this.choices;
        this.choices = choices.map((ch) => ({ ...ch, message: color(ch.message) }));
        await super.render();
        this.choices = choices;
      }
      submit() {
        if (this.options.multiple) {
          this.value = this.selected.map((ch) => ch.name);
        }
        return super.submit();
      }
    };
    module2.exports = AutoComplete;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/placeholder.js
var require_placeholder = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/placeholder.js"(exports, module2) {
    "use strict";
    var utils = require_utils2();
    module2.exports = (prompt, options = {}) => {
      prompt.cursorHide();
      let { input = "", initial = "", pos, showCursor = true, color } = options;
      let style = color || prompt.styles.placeholder;
      let inverse = utils.inverse(prompt.styles.primary);
      let blinker = (str2) => inverse(prompt.styles.black(str2));
      let output = input;
      let char = " ";
      let reverse = blinker(char);
      if (prompt.blink && prompt.blink.off === true) {
        blinker = (str2) => str2;
        reverse = "";
      }
      if (showCursor && pos === 0 && initial === "" && input === "") {
        return blinker(char);
      }
      if (showCursor && pos === 0 && (input === initial || input === "")) {
        return blinker(initial[0]) + style(initial.slice(1));
      }
      initial = utils.isPrimitive(initial) ? `${initial}` : "";
      input = utils.isPrimitive(input) ? `${input}` : "";
      let placeholder = initial && initial.startsWith(input) && initial !== input;
      let cursor = placeholder ? blinker(initial[input.length]) : reverse;
      if (pos !== input.length && showCursor === true) {
        output = input.slice(0, pos) + blinker(input[pos]) + input.slice(pos + 1);
        cursor = "";
      }
      if (showCursor === false) {
        cursor = "";
      }
      if (placeholder) {
        let raw = prompt.styles.unstyle(output + cursor);
        return output + cursor + style(initial.slice(raw.length));
      }
      return output + cursor;
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/form.js
var require_form = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/form.js"(exports, module2) {
    "use strict";
    var colors = require_ansi_colors();
    var SelectPrompt = require_select();
    var placeholder = require_placeholder();
    var FormPrompt = class extends SelectPrompt {
      constructor(options) {
        super({ ...options, multiple: true });
        this.type = "form";
        this.initial = this.options.initial;
        this.align = [this.options.align, "right"].find((v) => v != null);
        this.emptyError = "";
        this.values = {};
      }
      async reset(first) {
        await super.reset();
        if (first === true)
          this._index = this.index;
        this.index = this._index;
        this.values = {};
        this.choices.forEach((choice) => choice.reset && choice.reset());
        return this.render();
      }
      dispatch(char) {
        return !!char && this.append(char);
      }
      append(char) {
        let choice = this.focused;
        if (!choice)
          return this.alert();
        let { cursor, input } = choice;
        choice.value = choice.input = input.slice(0, cursor) + char + input.slice(cursor);
        choice.cursor++;
        return this.render();
      }
      delete() {
        let choice = this.focused;
        if (!choice || choice.cursor <= 0)
          return this.alert();
        let { cursor, input } = choice;
        choice.value = choice.input = input.slice(0, cursor - 1) + input.slice(cursor);
        choice.cursor--;
        return this.render();
      }
      deleteForward() {
        let choice = this.focused;
        if (!choice)
          return this.alert();
        let { cursor, input } = choice;
        if (input[cursor] === void 0)
          return this.alert();
        let str2 = `${input}`.slice(0, cursor) + `${input}`.slice(cursor + 1);
        choice.value = choice.input = str2;
        return this.render();
      }
      right() {
        let choice = this.focused;
        if (!choice)
          return this.alert();
        if (choice.cursor >= choice.input.length)
          return this.alert();
        choice.cursor++;
        return this.render();
      }
      left() {
        let choice = this.focused;
        if (!choice)
          return this.alert();
        if (choice.cursor <= 0)
          return this.alert();
        choice.cursor--;
        return this.render();
      }
      space(ch, key) {
        return this.dispatch(ch, key);
      }
      number(ch, key) {
        return this.dispatch(ch, key);
      }
      next() {
        let ch = this.focused;
        if (!ch)
          return this.alert();
        let { initial, input } = ch;
        if (initial && initial.startsWith(input) && input !== initial) {
          ch.value = ch.input = initial;
          ch.cursor = ch.value.length;
          return this.render();
        }
        return super.next();
      }
      prev() {
        let ch = this.focused;
        if (!ch)
          return this.alert();
        if (ch.cursor === 0)
          return super.prev();
        ch.value = ch.input = "";
        ch.cursor = 0;
        return this.render();
      }
      separator() {
        return "";
      }
      format(value) {
        return !this.state.submitted ? super.format(value) : "";
      }
      pointer() {
        return "";
      }
      indicator(choice) {
        return choice.input ? "\u29BF" : "\u2299";
      }
      async choiceSeparator(choice, i) {
        let sep = await this.resolve(choice.separator, this.state, choice, i) || ":";
        return sep ? " " + this.styles.disabled(sep) : "";
      }
      async renderChoice(choice, i) {
        await this.onChoice(choice, i);
        let { state, styles } = this;
        let { cursor, initial = "", name, hint, input = "" } = choice;
        let { muted, submitted, primary, danger } = styles;
        let help = hint;
        let focused = this.index === i;
        let validate = choice.validate || (() => true);
        let sep = await this.choiceSeparator(choice, i);
        let msg = choice.message;
        if (this.align === "right")
          msg = msg.padStart(this.longest + 1, " ");
        if (this.align === "left")
          msg = msg.padEnd(this.longest + 1, " ");
        let value = this.values[name] = input || initial;
        let color = input ? "success" : "dark";
        if (await validate.call(choice, value, this.state) !== true) {
          color = "danger";
        }
        let style = styles[color];
        let indicator = style(await this.indicator(choice, i)) + (choice.pad || "");
        let indent = this.indent(choice);
        let line = () => [indent, indicator, msg + sep, input, help].filter(Boolean).join(" ");
        if (state.submitted) {
          msg = colors.unstyle(msg);
          input = submitted(input);
          help = "";
          return line();
        }
        if (choice.format) {
          input = await choice.format.call(this, input, choice, i);
        } else {
          let color2 = this.styles.muted;
          let options = { input, initial, pos: cursor, showCursor: focused, color: color2 };
          input = placeholder(this, options);
        }
        if (!this.isValue(input)) {
          input = this.styles.muted(this.symbols.ellipsis);
        }
        if (choice.result) {
          this.values[name] = await choice.result.call(this, value, choice, i);
        }
        if (focused) {
          msg = primary(msg);
        }
        if (choice.error) {
          input += (input ? " " : "") + danger(choice.error.trim());
        } else if (choice.hint) {
          input += (input ? " " : "") + muted(choice.hint.trim());
        }
        return line();
      }
      async submit() {
        this.value = this.values;
        return super.base.submit.call(this);
      }
    };
    module2.exports = FormPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/auth.js
var require_auth = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/auth.js"(exports, module2) {
    "use strict";
    var FormPrompt = require_form();
    var defaultAuthenticate = () => {
      throw new Error("expected prompt to have a custom authenticate method");
    };
    var factory = (authenticate = defaultAuthenticate) => {
      class AuthPrompt extends FormPrompt {
        constructor(options) {
          super(options);
        }
        async submit() {
          this.value = await authenticate.call(this, this.values, this.state);
          super.base.submit.call(this);
        }
        static create(authenticate2) {
          return factory(authenticate2);
        }
      }
      return AuthPrompt;
    };
    module2.exports = factory();
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/basicauth.js
var require_basicauth = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/basicauth.js"(exports, module2) {
    "use strict";
    var AuthPrompt = require_auth();
    function defaultAuthenticate(value, state) {
      if (value.username === this.options.username && value.password === this.options.password) {
        return true;
      }
      return false;
    }
    var factory = (authenticate = defaultAuthenticate) => {
      const choices = [
        { name: "username", message: "username" },
        {
          name: "password",
          message: "password",
          format(input) {
            if (this.options.showPassword) {
              return input;
            }
            let color = this.state.submitted ? this.styles.primary : this.styles.muted;
            return color(this.symbols.asterisk.repeat(input.length));
          }
        }
      ];
      class BasicAuthPrompt extends AuthPrompt.create(authenticate) {
        constructor(options) {
          super({ ...options, choices });
        }
        static create(authenticate2) {
          return factory(authenticate2);
        }
      }
      return BasicAuthPrompt;
    };
    module2.exports = factory();
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/boolean.js
var require_boolean = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/boolean.js"(exports, module2) {
    "use strict";
    var Prompt = require_prompt();
    var { isPrimitive, hasColor } = require_utils2();
    var BooleanPrompt = class extends Prompt {
      constructor(options) {
        super(options);
        this.cursorHide();
      }
      async initialize() {
        let initial = await this.resolve(this.initial, this.state);
        this.input = await this.cast(initial);
        await super.initialize();
      }
      dispatch(ch) {
        if (!this.isValue(ch))
          return this.alert();
        this.input = ch;
        return this.submit();
      }
      format(value) {
        let { styles, state } = this;
        return !state.submitted ? styles.primary(value) : styles.success(value);
      }
      cast(input) {
        return this.isTrue(input);
      }
      isTrue(input) {
        return /^[ty1]/i.test(input);
      }
      isFalse(input) {
        return /^[fn0]/i.test(input);
      }
      isValue(value) {
        return isPrimitive(value) && (this.isTrue(value) || this.isFalse(value));
      }
      async hint() {
        if (this.state.status === "pending") {
          let hint = await this.element("hint");
          if (!hasColor(hint)) {
            return this.styles.muted(hint);
          }
          return hint;
        }
      }
      async render() {
        let { input, size } = this.state;
        let prefix = await this.prefix();
        let sep = await this.separator();
        let msg = await this.message();
        let hint = this.styles.muted(this.default);
        let promptLine = [prefix, msg, hint, sep].filter(Boolean).join(" ");
        this.state.prompt = promptLine;
        let header = await this.header();
        let value = this.value = this.cast(input);
        let output = await this.format(value);
        let help = await this.error() || await this.hint();
        let footer = await this.footer();
        if (help && !promptLine.includes(help))
          output += " " + help;
        promptLine += " " + output;
        this.clear(size);
        this.write([header, promptLine, footer].filter(Boolean).join("\n"));
        this.restore();
      }
      set value(value) {
        super.value = value;
      }
      get value() {
        return this.cast(super.value);
      }
    };
    module2.exports = BooleanPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/confirm.js
var require_confirm = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/confirm.js"(exports, module2) {
    "use strict";
    var BooleanPrompt = require_boolean();
    var ConfirmPrompt = class extends BooleanPrompt {
      constructor(options) {
        super(options);
        this.default = this.options.default || (this.initial ? "(Y/n)" : "(y/N)");
      }
    };
    module2.exports = ConfirmPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/editable.js
var require_editable = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/editable.js"(exports, module2) {
    "use strict";
    var Select2 = require_select();
    var Form = require_form();
    var form = Form.prototype;
    var Editable = class extends Select2 {
      constructor(options) {
        super({ ...options, multiple: true });
        this.align = [this.options.align, "left"].find((v) => v != null);
        this.emptyError = "";
        this.values = {};
      }
      dispatch(char, key) {
        let choice = this.focused;
        let parent = choice.parent || {};
        if (!choice.editable && !parent.editable) {
          if (char === "a" || char === "i")
            return super[char]();
        }
        return form.dispatch.call(this, char, key);
      }
      append(char, key) {
        return form.append.call(this, char, key);
      }
      delete(char, key) {
        return form.delete.call(this, char, key);
      }
      space(char) {
        return this.focused.editable ? this.append(char) : super.space();
      }
      number(char) {
        return this.focused.editable ? this.append(char) : super.number(char);
      }
      next() {
        return this.focused.editable ? form.next.call(this) : super.next();
      }
      prev() {
        return this.focused.editable ? form.prev.call(this) : super.prev();
      }
      async indicator(choice, i) {
        let symbol = choice.indicator || "";
        let value = choice.editable ? symbol : super.indicator(choice, i);
        return await this.resolve(value, this.state, choice, i) || "";
      }
      indent(choice) {
        return choice.role === "heading" ? "" : choice.editable ? " " : "  ";
      }
      async renderChoice(choice, i) {
        choice.indent = "";
        if (choice.editable)
          return form.renderChoice.call(this, choice, i);
        return super.renderChoice(choice, i);
      }
      error() {
        return "";
      }
      footer() {
        return this.state.error;
      }
      async validate() {
        let result2 = true;
        for (let choice of this.choices) {
          if (typeof choice.validate !== "function") {
            continue;
          }
          if (choice.role === "heading") {
            continue;
          }
          let val = choice.parent ? this.value[choice.parent.name] : this.value;
          if (choice.editable) {
            val = choice.value === choice.name ? choice.initial || "" : choice.value;
          } else if (!this.isDisabled(choice)) {
            val = choice.enabled === true;
          }
          result2 = await choice.validate(val, this.state);
          if (result2 !== true) {
            break;
          }
        }
        if (result2 !== true) {
          this.state.error = typeof result2 === "string" ? result2 : "Invalid Input";
        }
        return result2;
      }
      submit() {
        if (this.focused.newChoice === true)
          return super.submit();
        if (this.choices.some((ch) => ch.newChoice)) {
          return this.alert();
        }
        this.value = {};
        for (let choice of this.choices) {
          let val = choice.parent ? this.value[choice.parent.name] : this.value;
          if (choice.role === "heading") {
            this.value[choice.name] = {};
            continue;
          }
          if (choice.editable) {
            val[choice.name] = choice.value === choice.name ? choice.initial || "" : choice.value;
          } else if (!this.isDisabled(choice)) {
            val[choice.name] = choice.enabled === true;
          }
        }
        return this.base.submit.call(this);
      }
    };
    module2.exports = Editable;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/string.js
var require_string = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/string.js"(exports, module2) {
    "use strict";
    var Prompt = require_prompt();
    var placeholder = require_placeholder();
    var { isPrimitive } = require_utils2();
    var StringPrompt = class extends Prompt {
      constructor(options) {
        super(options);
        this.initial = isPrimitive(this.initial) ? String(this.initial) : "";
        if (this.initial)
          this.cursorHide();
        this.state.prevCursor = 0;
        this.state.clipboard = [];
      }
      async keypress(input, key = {}) {
        let prev = this.state.prevKeypress;
        this.state.prevKeypress = key;
        if (this.options.multiline === true && key.name === "return") {
          if (!prev || prev.name !== "return") {
            return this.append("\n", key);
          }
        }
        return super.keypress(input, key);
      }
      moveCursor(n) {
        this.cursor += n;
      }
      reset() {
        this.input = this.value = "";
        this.cursor = 0;
        return this.render();
      }
      dispatch(ch, key) {
        if (!ch || key.ctrl || key.code)
          return this.alert();
        this.append(ch);
      }
      append(ch) {
        let { cursor, input } = this.state;
        this.input = `${input}`.slice(0, cursor) + ch + `${input}`.slice(cursor);
        this.moveCursor(String(ch).length);
        this.render();
      }
      insert(str2) {
        this.append(str2);
      }
      delete() {
        let { cursor, input } = this.state;
        if (cursor <= 0)
          return this.alert();
        this.input = `${input}`.slice(0, cursor - 1) + `${input}`.slice(cursor);
        this.moveCursor(-1);
        this.render();
      }
      deleteForward() {
        let { cursor, input } = this.state;
        if (input[cursor] === void 0)
          return this.alert();
        this.input = `${input}`.slice(0, cursor) + `${input}`.slice(cursor + 1);
        this.render();
      }
      cutForward() {
        let pos = this.cursor;
        if (this.input.length <= pos)
          return this.alert();
        this.state.clipboard.push(this.input.slice(pos));
        this.input = this.input.slice(0, pos);
        this.render();
      }
      cutLeft() {
        let pos = this.cursor;
        if (pos === 0)
          return this.alert();
        let before = this.input.slice(0, pos);
        let after = this.input.slice(pos);
        let words = before.split(" ");
        this.state.clipboard.push(words.pop());
        this.input = words.join(" ");
        this.cursor = this.input.length;
        this.input += after;
        this.render();
      }
      paste() {
        if (!this.state.clipboard.length)
          return this.alert();
        this.insert(this.state.clipboard.pop());
        this.render();
      }
      toggleCursor() {
        if (this.state.prevCursor) {
          this.cursor = this.state.prevCursor;
          this.state.prevCursor = 0;
        } else {
          this.state.prevCursor = this.cursor;
          this.cursor = 0;
        }
        this.render();
      }
      first() {
        this.cursor = 0;
        this.render();
      }
      last() {
        this.cursor = this.input.length - 1;
        this.render();
      }
      next() {
        let init = this.initial != null ? String(this.initial) : "";
        if (!init || !init.startsWith(this.input))
          return this.alert();
        this.input = this.initial;
        this.cursor = this.initial.length;
        this.render();
      }
      prev() {
        if (!this.input)
          return this.alert();
        this.reset();
      }
      backward() {
        return this.left();
      }
      forward() {
        return this.right();
      }
      right() {
        if (this.cursor >= this.input.length)
          return this.alert();
        this.moveCursor(1);
        return this.render();
      }
      left() {
        if (this.cursor <= 0)
          return this.alert();
        this.moveCursor(-1);
        return this.render();
      }
      isValue(value) {
        return !!value;
      }
      async format(input = this.value) {
        let initial = await this.resolve(this.initial, this.state);
        if (!this.state.submitted) {
          return placeholder(this, { input, initial, pos: this.cursor });
        }
        return this.styles.submitted(input || initial);
      }
      async render() {
        let size = this.state.size;
        let prefix = await this.prefix();
        let separator = await this.separator();
        let message = await this.message();
        let prompt = [prefix, message, separator].filter(Boolean).join(" ");
        this.state.prompt = prompt;
        let header = await this.header();
        let output = await this.format();
        let help = await this.error() || await this.hint();
        let footer = await this.footer();
        if (help && !output.includes(help))
          output += " " + help;
        prompt += " " + output;
        this.clear(size);
        this.write([header, prompt, footer].filter(Boolean).join("\n"));
        this.restore();
      }
    };
    module2.exports = StringPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/completer.js
var require_completer = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/completer.js"(exports, module2) {
    "use strict";
    var unique = (arr) => arr.filter((v, i) => arr.lastIndexOf(v) === i);
    var compact = (arr) => unique(arr).filter(Boolean);
    module2.exports = (action, data = {}, value = "") => {
      let { past = [], present = "" } = data;
      let rest, prev;
      switch (action) {
        case "prev":
        case "undo":
          rest = past.slice(0, past.length - 1);
          prev = past[past.length - 1] || "";
          return {
            past: compact([value, ...rest]),
            present: prev
          };
        case "next":
        case "redo":
          rest = past.slice(1);
          prev = past[0] || "";
          return {
            past: compact([...rest, value]),
            present: prev
          };
        case "save":
          return {
            past: compact([...past, value]),
            present: ""
          };
        case "remove":
          prev = compact(past.filter((v) => v !== value));
          present = "";
          if (prev.length) {
            present = prev.pop();
          }
          return {
            past: prev,
            present
          };
        default: {
          throw new Error(`Invalid action: "${action}"`);
        }
      }
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/input.js
var require_input = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/input.js"(exports, module2) {
    "use strict";
    var Prompt = require_string();
    var completer = require_completer();
    var Input = class extends Prompt {
      constructor(options) {
        super(options);
        let history = this.options.history;
        if (history && history.store) {
          let initial = history.values || this.initial;
          this.autosave = !!history.autosave;
          this.store = history.store;
          this.data = this.store.get("values") || { past: [], present: initial };
          this.initial = this.data.present || this.data.past[this.data.past.length - 1];
        }
      }
      completion(action) {
        if (!this.store)
          return this.alert();
        this.data = completer(action, this.data, this.input);
        if (!this.data.present)
          return this.alert();
        this.input = this.data.present;
        this.cursor = this.input.length;
        return this.render();
      }
      altUp() {
        return this.completion("prev");
      }
      altDown() {
        return this.completion("next");
      }
      prev() {
        this.save();
        return super.prev();
      }
      save() {
        if (!this.store)
          return;
        this.data = completer("save", this.data, this.input);
        this.store.set("values", this.data);
      }
      submit() {
        if (this.store && this.autosave === true) {
          this.save();
        }
        return super.submit();
      }
    };
    module2.exports = Input;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/invisible.js
var require_invisible = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/invisible.js"(exports, module2) {
    "use strict";
    var StringPrompt = require_string();
    var InvisiblePrompt = class extends StringPrompt {
      format() {
        return "";
      }
    };
    module2.exports = InvisiblePrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/list.js
var require_list = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/list.js"(exports, module2) {
    "use strict";
    var StringPrompt = require_string();
    var ListPrompt = class extends StringPrompt {
      constructor(options = {}) {
        super(options);
        this.sep = this.options.separator || /, */;
        this.initial = options.initial || "";
      }
      split(input = this.value) {
        return input ? String(input).split(this.sep) : [];
      }
      format() {
        let style = this.state.submitted ? this.styles.primary : (val) => val;
        return this.list.map(style).join(", ");
      }
      async submit(value) {
        let result2 = this.state.error || await this.validate(this.list, this.state);
        if (result2 !== true) {
          this.state.error = result2;
          return super.submit();
        }
        this.value = this.list;
        return super.submit();
      }
      get list() {
        return this.split();
      }
    };
    module2.exports = ListPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/multiselect.js
var require_multiselect = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/multiselect.js"(exports, module2) {
    "use strict";
    var Select2 = require_select();
    var MultiSelect = class extends Select2 {
      constructor(options) {
        super({ ...options, multiple: true });
      }
    };
    module2.exports = MultiSelect;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/number.js
var require_number = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/number.js"(exports, module2) {
    "use strict";
    var StringPrompt = require_string();
    var NumberPrompt = class extends StringPrompt {
      constructor(options = {}) {
        super({ style: "number", ...options });
        this.min = this.isValue(options.min) ? this.toNumber(options.min) : -Infinity;
        this.max = this.isValue(options.max) ? this.toNumber(options.max) : Infinity;
        this.delay = options.delay != null ? options.delay : 1e3;
        this.float = options.float !== false;
        this.round = options.round === true || options.float === false;
        this.major = options.major || 10;
        this.minor = options.minor || 1;
        this.initial = options.initial != null ? options.initial : "";
        this.input = String(this.initial);
        this.cursor = this.input.length;
        this.cursorShow();
      }
      append(ch) {
        if (!/[-+.]/.test(ch) || ch === "." && this.input.includes(".")) {
          return this.alert("invalid number");
        }
        return super.append(ch);
      }
      number(ch) {
        return super.append(ch);
      }
      next() {
        if (this.input && this.input !== this.initial)
          return this.alert();
        if (!this.isValue(this.initial))
          return this.alert();
        this.input = this.initial;
        this.cursor = String(this.initial).length;
        return this.render();
      }
      up(number) {
        let step = number || this.minor;
        let num = this.toNumber(this.input);
        if (num > this.max + step)
          return this.alert();
        this.input = `${num + step}`;
        return this.render();
      }
      down(number) {
        let step = number || this.minor;
        let num = this.toNumber(this.input);
        if (num < this.min - step)
          return this.alert();
        this.input = `${num - step}`;
        return this.render();
      }
      shiftDown() {
        return this.down(this.major);
      }
      shiftUp() {
        return this.up(this.major);
      }
      format(input = this.input) {
        if (typeof this.options.format === "function") {
          return this.options.format.call(this, input);
        }
        return this.styles.info(input);
      }
      toNumber(value = "") {
        return this.float ? +value : Math.round(+value);
      }
      isValue(value) {
        return /^[-+]?[0-9]+((\.)|(\.[0-9]+))?$/.test(value);
      }
      submit() {
        let value = [this.input, this.initial].find((v) => this.isValue(v));
        this.value = this.toNumber(value || 0);
        return super.submit();
      }
    };
    module2.exports = NumberPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/numeral.js
var require_numeral = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/numeral.js"(exports, module2) {
    module2.exports = require_number();
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/password.js
var require_password = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/password.js"(exports, module2) {
    "use strict";
    var StringPrompt = require_string();
    var PasswordPrompt = class extends StringPrompt {
      constructor(options) {
        super(options);
        this.cursorShow();
      }
      format(input = this.input) {
        if (!this.keypressed)
          return "";
        let color = this.state.submitted ? this.styles.primary : this.styles.muted;
        return color(this.symbols.asterisk.repeat(input.length));
      }
    };
    module2.exports = PasswordPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/scale.js
var require_scale = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/scale.js"(exports, module2) {
    "use strict";
    var colors = require_ansi_colors();
    var ArrayPrompt = require_array();
    var utils = require_utils2();
    var LikertScale = class extends ArrayPrompt {
      constructor(options = {}) {
        super(options);
        this.widths = [].concat(options.messageWidth || 50);
        this.align = [].concat(options.align || "left");
        this.linebreak = options.linebreak || false;
        this.edgeLength = options.edgeLength || 3;
        this.newline = options.newline || "\n   ";
        let start = options.startNumber || 1;
        if (typeof this.scale === "number") {
          this.scaleKey = false;
          this.scale = Array(this.scale).fill(0).map((v, i) => ({ name: i + start }));
        }
      }
      async reset() {
        this.tableized = false;
        await super.reset();
        return this.render();
      }
      tableize() {
        if (this.tableized === true)
          return;
        this.tableized = true;
        let longest = 0;
        for (let ch of this.choices) {
          longest = Math.max(longest, ch.message.length);
          ch.scaleIndex = ch.initial || 2;
          ch.scale = [];
          for (let i = 0; i < this.scale.length; i++) {
            ch.scale.push({ index: i });
          }
        }
        this.widths[0] = Math.min(this.widths[0], longest + 3);
      }
      async dispatch(s, key) {
        if (this.multiple) {
          return this[key.name] ? await this[key.name](s, key) : await super.dispatch(s, key);
        }
        this.alert();
      }
      heading(msg, item, i) {
        return this.styles.strong(msg);
      }
      separator() {
        return this.styles.muted(this.symbols.ellipsis);
      }
      right() {
        let choice = this.focused;
        if (choice.scaleIndex >= this.scale.length - 1)
          return this.alert();
        choice.scaleIndex++;
        return this.render();
      }
      left() {
        let choice = this.focused;
        if (choice.scaleIndex <= 0)
          return this.alert();
        choice.scaleIndex--;
        return this.render();
      }
      indent() {
        return "";
      }
      format() {
        if (this.state.submitted) {
          let values = this.choices.map((ch) => this.styles.info(ch.index));
          return values.join(", ");
        }
        return "";
      }
      pointer() {
        return "";
      }
      renderScaleKey() {
        if (this.scaleKey === false)
          return "";
        if (this.state.submitted)
          return "";
        let scale = this.scale.map((item) => `   ${item.name} - ${item.message}`);
        let key = ["", ...scale].map((item) => this.styles.muted(item));
        return key.join("\n");
      }
      renderScaleHeading(max) {
        let keys = this.scale.map((ele) => ele.name);
        if (typeof this.options.renderScaleHeading === "function") {
          keys = this.options.renderScaleHeading.call(this, max);
        }
        let diff2 = this.scaleLength - keys.join("").length;
        let spacing = Math.round(diff2 / (keys.length - 1));
        let names = keys.map((key) => this.styles.strong(key));
        let headings = names.join(" ".repeat(spacing));
        let padding = " ".repeat(this.widths[0]);
        return this.margin[3] + padding + this.margin[1] + headings;
      }
      scaleIndicator(choice, item, i) {
        if (typeof this.options.scaleIndicator === "function") {
          return this.options.scaleIndicator.call(this, choice, item, i);
        }
        let enabled = choice.scaleIndex === item.index;
        if (item.disabled)
          return this.styles.hint(this.symbols.radio.disabled);
        if (enabled)
          return this.styles.success(this.symbols.radio.on);
        return this.symbols.radio.off;
      }
      renderScale(choice, i) {
        let scale = choice.scale.map((item) => this.scaleIndicator(choice, item, i));
        let padding = this.term === "Hyper" ? "" : " ";
        return scale.join(padding + this.symbols.line.repeat(this.edgeLength));
      }
      async renderChoice(choice, i) {
        await this.onChoice(choice, i);
        let focused = this.index === i;
        let pointer = await this.pointer(choice, i);
        let hint = await choice.hint;
        if (hint && !utils.hasColor(hint)) {
          hint = this.styles.muted(hint);
        }
        let pad = (str2) => this.margin[3] + str2.replace(/\s+$/, "").padEnd(this.widths[0], " ");
        let newline = this.newline;
        let ind = this.indent(choice);
        let message = await this.resolve(choice.message, this.state, choice, i);
        let scale = await this.renderScale(choice, i);
        let margin = this.margin[1] + this.margin[3];
        this.scaleLength = colors.unstyle(scale).length;
        this.widths[0] = Math.min(this.widths[0], this.width - this.scaleLength - margin.length);
        let msg = utils.wordWrap(message, { width: this.widths[0], newline });
        let lines = msg.split("\n").map((line) => pad(line) + this.margin[1]);
        if (focused) {
          scale = this.styles.info(scale);
          lines = lines.map((line) => this.styles.info(line));
        }
        lines[0] += scale;
        if (this.linebreak)
          lines.push("");
        return [ind + pointer, lines.join("\n")].filter(Boolean);
      }
      async renderChoices() {
        if (this.state.submitted)
          return "";
        this.tableize();
        let choices = this.visible.map(async (ch, i) => await this.renderChoice(ch, i));
        let visible = await Promise.all(choices);
        let heading = await this.renderScaleHeading();
        return this.margin[0] + [heading, ...visible.map((v) => v.join(" "))].join("\n");
      }
      async render() {
        let { submitted, size } = this.state;
        let prefix = await this.prefix();
        let separator = await this.separator();
        let message = await this.message();
        let prompt = "";
        if (this.options.promptLine !== false) {
          prompt = [prefix, message, separator, ""].join(" ");
          this.state.prompt = prompt;
        }
        let header = await this.header();
        let output = await this.format();
        let key = await this.renderScaleKey();
        let help = await this.error() || await this.hint();
        let body = await this.renderChoices();
        let footer = await this.footer();
        let err = this.emptyError;
        if (output)
          prompt += output;
        if (help && !prompt.includes(help))
          prompt += " " + help;
        if (submitted && !output && !body.trim() && this.multiple && err != null) {
          prompt += this.styles.danger(err);
        }
        this.clear(size);
        this.write([header, prompt, key, body, footer].filter(Boolean).join("\n"));
        if (!this.state.submitted) {
          this.write(this.margin[2]);
        }
        this.restore();
      }
      submit() {
        this.value = {};
        for (let choice of this.choices) {
          this.value[choice.name] = choice.scaleIndex;
        }
        return this.base.submit.call(this);
      }
    };
    module2.exports = LikertScale;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/interpolate.js
var require_interpolate = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/interpolate.js"(exports, module2) {
    "use strict";
    var colors = require_ansi_colors();
    var clean = (str2 = "") => {
      return typeof str2 === "string" ? str2.replace(/^['"]|['"]$/g, "") : "";
    };
    var Item = class {
      constructor(token) {
        this.name = token.key;
        this.field = token.field || {};
        this.value = clean(token.initial || this.field.initial || "");
        this.message = token.message || this.name;
        this.cursor = 0;
        this.input = "";
        this.lines = [];
      }
    };
    var tokenize = async (options = {}, defaults = {}, fn = (token) => token) => {
      let unique = /* @__PURE__ */ new Set();
      let fields = options.fields || [];
      let input = options.template;
      let tabstops = [];
      let items = [];
      let keys = [];
      let line = 1;
      if (typeof input === "function") {
        input = await input();
      }
      let i = -1;
      let next = () => input[++i];
      let peek = () => input[i + 1];
      let push = (token) => {
        token.line = line;
        tabstops.push(token);
      };
      push({ type: "bos", value: "" });
      while (i < input.length - 1) {
        let value = next();
        if (/^[^\S\n ]$/.test(value)) {
          push({ type: "text", value });
          continue;
        }
        if (value === "\n") {
          push({ type: "newline", value });
          line++;
          continue;
        }
        if (value === "\\") {
          value += next();
          push({ type: "text", value });
          continue;
        }
        if ((value === "$" || value === "#" || value === "{") && peek() === "{") {
          let n = next();
          value += n;
          let token = { type: "template", open: value, inner: "", close: "", value };
          let ch;
          while (ch = next()) {
            if (ch === "}") {
              if (peek() === "}")
                ch += next();
              token.value += ch;
              token.close = ch;
              break;
            }
            if (ch === ":") {
              token.initial = "";
              token.key = token.inner;
            } else if (token.initial !== void 0) {
              token.initial += ch;
            }
            token.value += ch;
            token.inner += ch;
          }
          token.template = token.open + (token.initial || token.inner) + token.close;
          token.key = token.key || token.inner;
          if (defaults.hasOwnProperty(token.key)) {
            token.initial = defaults[token.key];
          }
          token = fn(token);
          push(token);
          keys.push(token.key);
          unique.add(token.key);
          let item = items.find((item2) => item2.name === token.key);
          token.field = fields.find((ch2) => ch2.name === token.key);
          if (!item) {
            item = new Item(token);
            items.push(item);
          }
          item.lines.push(token.line - 1);
          continue;
        }
        let last = tabstops[tabstops.length - 1];
        if (last.type === "text" && last.line === line) {
          last.value += value;
        } else {
          push({ type: "text", value });
        }
      }
      push({ type: "eos", value: "" });
      return { input, tabstops, unique, keys, items };
    };
    module2.exports = async (prompt) => {
      let options = prompt.options;
      let required = new Set(options.required === true ? [] : options.required || []);
      let defaults = { ...options.values, ...options.initial };
      let { tabstops, items, keys } = await tokenize(options, defaults);
      let result2 = createFn("result", prompt, options);
      let format = createFn("format", prompt, options);
      let isValid = createFn("validate", prompt, options, true);
      let isVal = prompt.isValue.bind(prompt);
      return async (state = {}, submitted = false) => {
        let index = 0;
        state.required = required;
        state.items = items;
        state.keys = keys;
        state.output = "";
        let validate = async (value, state2, item, index2) => {
          let error = await isValid(value, state2, item, index2);
          if (error === false) {
            return "Invalid field " + item.name;
          }
          return error;
        };
        for (let token of tabstops) {
          let value = token.value;
          let key = token.key;
          if (token.type !== "template") {
            if (value)
              state.output += value;
            continue;
          }
          if (token.type === "template") {
            let item = items.find((ch) => ch.name === key);
            if (options.required === true) {
              state.required.add(item.name);
            }
            let val = [item.input, state.values[item.value], item.value, value].find(isVal);
            let field = item.field || {};
            let message = field.message || token.inner;
            if (submitted) {
              let error = await validate(state.values[key], state, item, index);
              if (error && typeof error === "string" || error === false) {
                state.invalid.set(key, error);
                continue;
              }
              state.invalid.delete(key);
              let res = await result2(state.values[key], state, item, index);
              state.output += colors.unstyle(res);
              continue;
            }
            item.placeholder = false;
            let before = value;
            value = await format(value, state, item, index);
            if (val !== value) {
              state.values[key] = val;
              value = prompt.styles.typing(val);
              state.missing.delete(message);
            } else {
              state.values[key] = void 0;
              val = `<${message}>`;
              value = prompt.styles.primary(val);
              item.placeholder = true;
              if (state.required.has(key)) {
                state.missing.add(message);
              }
            }
            if (state.missing.has(message) && state.validating) {
              value = prompt.styles.warning(val);
            }
            if (state.invalid.has(key) && state.validating) {
              value = prompt.styles.danger(val);
            }
            if (index === state.index) {
              if (before !== value) {
                value = prompt.styles.underline(value);
              } else {
                value = prompt.styles.heading(colors.unstyle(value));
              }
            }
            index++;
          }
          if (value) {
            state.output += value;
          }
        }
        let lines = state.output.split("\n").map((l) => " " + l);
        let len = items.length;
        let done = 0;
        for (let item of items) {
          if (state.invalid.has(item.name)) {
            item.lines.forEach((i) => {
              if (lines[i][0] !== " ")
                return;
              lines[i] = state.styles.danger(state.symbols.bullet) + lines[i].slice(1);
            });
          }
          if (prompt.isValue(state.values[item.name])) {
            done++;
          }
        }
        state.completed = (done / len * 100).toFixed(0);
        state.output = lines.join("\n");
        return state.output;
      };
    };
    function createFn(prop, prompt, options, fallback) {
      return (value, state, item, index) => {
        if (typeof item.field[prop] === "function") {
          return item.field[prop].call(prompt, value, state, item, index);
        }
        return [fallback, value].find((v) => prompt.isValue(v));
      };
    }
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/snippet.js
var require_snippet = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/snippet.js"(exports, module2) {
    "use strict";
    var colors = require_ansi_colors();
    var interpolate = require_interpolate();
    var Prompt = require_prompt();
    var SnippetPrompt = class extends Prompt {
      constructor(options) {
        super(options);
        this.cursorHide();
        this.reset(true);
      }
      async initialize() {
        this.interpolate = await interpolate(this);
        await super.initialize();
      }
      async reset(first) {
        this.state.keys = [];
        this.state.invalid = /* @__PURE__ */ new Map();
        this.state.missing = /* @__PURE__ */ new Set();
        this.state.completed = 0;
        this.state.values = {};
        if (first !== true) {
          await this.initialize();
          await this.render();
        }
      }
      moveCursor(n) {
        let item = this.getItem();
        this.cursor += n;
        item.cursor += n;
      }
      dispatch(ch, key) {
        if (!key.code && !key.ctrl && ch != null && this.getItem()) {
          this.append(ch, key);
          return;
        }
        this.alert();
      }
      append(ch, key) {
        let item = this.getItem();
        let prefix = item.input.slice(0, this.cursor);
        let suffix = item.input.slice(this.cursor);
        this.input = item.input = `${prefix}${ch}${suffix}`;
        this.moveCursor(1);
        this.render();
      }
      delete() {
        let item = this.getItem();
        if (this.cursor <= 0 || !item.input)
          return this.alert();
        let suffix = item.input.slice(this.cursor);
        let prefix = item.input.slice(0, this.cursor - 1);
        this.input = item.input = `${prefix}${suffix}`;
        this.moveCursor(-1);
        this.render();
      }
      increment(i) {
        return i >= this.state.keys.length - 1 ? 0 : i + 1;
      }
      decrement(i) {
        return i <= 0 ? this.state.keys.length - 1 : i - 1;
      }
      first() {
        this.state.index = 0;
        this.render();
      }
      last() {
        this.state.index = this.state.keys.length - 1;
        this.render();
      }
      right() {
        if (this.cursor >= this.input.length)
          return this.alert();
        this.moveCursor(1);
        this.render();
      }
      left() {
        if (this.cursor <= 0)
          return this.alert();
        this.moveCursor(-1);
        this.render();
      }
      prev() {
        this.state.index = this.decrement(this.state.index);
        this.getItem();
        this.render();
      }
      next() {
        this.state.index = this.increment(this.state.index);
        this.getItem();
        this.render();
      }
      up() {
        this.prev();
      }
      down() {
        this.next();
      }
      format(value) {
        let color = this.state.completed < 100 ? this.styles.warning : this.styles.success;
        if (this.state.submitted === true && this.state.completed !== 100) {
          color = this.styles.danger;
        }
        return color(`${this.state.completed}% completed`);
      }
      async render() {
        let { index, keys = [], submitted, size } = this.state;
        let newline = [this.options.newline, "\n"].find((v) => v != null);
        let prefix = await this.prefix();
        let separator = await this.separator();
        let message = await this.message();
        let prompt = [prefix, message, separator].filter(Boolean).join(" ");
        this.state.prompt = prompt;
        let header = await this.header();
        let error = await this.error() || "";
        let hint = await this.hint() || "";
        let body = submitted ? "" : await this.interpolate(this.state);
        let key = this.state.key = keys[index] || "";
        let input = await this.format(key);
        let footer = await this.footer();
        if (input)
          prompt += " " + input;
        if (hint && !input && this.state.completed === 0)
          prompt += " " + hint;
        this.clear(size);
        let lines = [header, prompt, body, footer, error.trim()];
        this.write(lines.filter(Boolean).join(newline));
        this.restore();
      }
      getItem(name) {
        let { items, keys, index } = this.state;
        let item = items.find((ch) => ch.name === keys[index]);
        if (item && item.input != null) {
          this.input = item.input;
          this.cursor = item.cursor;
        }
        return item;
      }
      async submit() {
        if (typeof this.interpolate !== "function")
          await this.initialize();
        await this.interpolate(this.state, true);
        let { invalid, missing, output, values } = this.state;
        if (invalid.size) {
          let err = "";
          for (let [key, value] of invalid)
            err += `Invalid ${key}: ${value}
`;
          this.state.error = err;
          return super.submit();
        }
        if (missing.size) {
          this.state.error = "Required: " + [...missing.keys()].join(", ");
          return super.submit();
        }
        let lines = colors.unstyle(output).split("\n");
        let result2 = lines.map((v) => v.slice(1)).join("\n");
        this.value = { values, result: result2 };
        return super.submit();
      }
    };
    module2.exports = SnippetPrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/sort.js
var require_sort = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/sort.js"(exports, module2) {
    "use strict";
    var hint = "(Use <shift>+<up/down> to sort)";
    var Prompt = require_select();
    var Sort = class extends Prompt {
      constructor(options) {
        super({ ...options, reorder: false, sort: true, multiple: true });
        this.state.hint = [this.options.hint, hint].find(this.isValue.bind(this));
      }
      indicator() {
        return "";
      }
      async renderChoice(choice, i) {
        let str2 = await super.renderChoice(choice, i);
        let sym = this.symbols.identicalTo + " ";
        let pre = this.index === i && this.sorting ? this.styles.muted(sym) : "  ";
        if (this.options.drag === false)
          pre = "";
        if (this.options.numbered === true) {
          return pre + `${i + 1} - ` + str2;
        }
        return pre + str2;
      }
      get selected() {
        return this.choices;
      }
      submit() {
        this.value = this.choices.map((choice) => choice.value);
        return super.submit();
      }
    };
    module2.exports = Sort;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/survey.js
var require_survey = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/survey.js"(exports, module2) {
    "use strict";
    var ArrayPrompt = require_array();
    var Survey = class extends ArrayPrompt {
      constructor(options = {}) {
        super(options);
        this.emptyError = options.emptyError || "No items were selected";
        this.term = process.env.TERM_PROGRAM;
        if (!this.options.header) {
          let header = ["", "4 - Strongly Agree", "3 - Agree", "2 - Neutral", "1 - Disagree", "0 - Strongly Disagree", ""];
          header = header.map((ele) => this.styles.muted(ele));
          this.state.header = header.join("\n   ");
        }
      }
      async toChoices(...args) {
        if (this.createdScales)
          return false;
        this.createdScales = true;
        let choices = await super.toChoices(...args);
        for (let choice of choices) {
          choice.scale = createScale(5, this.options);
          choice.scaleIdx = 2;
        }
        return choices;
      }
      dispatch() {
        this.alert();
      }
      space() {
        let choice = this.focused;
        let ele = choice.scale[choice.scaleIdx];
        let selected = ele.selected;
        choice.scale.forEach((e) => e.selected = false);
        ele.selected = !selected;
        return this.render();
      }
      indicator() {
        return "";
      }
      pointer() {
        return "";
      }
      separator() {
        return this.styles.muted(this.symbols.ellipsis);
      }
      right() {
        let choice = this.focused;
        if (choice.scaleIdx >= choice.scale.length - 1)
          return this.alert();
        choice.scaleIdx++;
        return this.render();
      }
      left() {
        let choice = this.focused;
        if (choice.scaleIdx <= 0)
          return this.alert();
        choice.scaleIdx--;
        return this.render();
      }
      indent() {
        return "   ";
      }
      async renderChoice(item, i) {
        await this.onChoice(item, i);
        let focused = this.index === i;
        let isHyper = this.term === "Hyper";
        let n = !isHyper ? 8 : 9;
        let s = !isHyper ? " " : "";
        let ln = this.symbols.line.repeat(n);
        let sp = " ".repeat(n + (isHyper ? 0 : 1));
        let dot = (enabled) => (enabled ? this.styles.success("\u25C9") : "\u25EF") + s;
        let num = i + 1 + ".";
        let color = focused ? this.styles.heading : this.styles.noop;
        let msg = await this.resolve(item.message, this.state, item, i);
        let indent = this.indent(item);
        let scale = indent + item.scale.map((e, i2) => dot(i2 === item.scaleIdx)).join(ln);
        let val = (i2) => i2 === item.scaleIdx ? color(i2) : i2;
        let next = indent + item.scale.map((e, i2) => val(i2)).join(sp);
        let line = () => [num, msg].filter(Boolean).join(" ");
        let lines = () => [line(), scale, next, " "].filter(Boolean).join("\n");
        if (focused) {
          scale = this.styles.cyan(scale);
          next = this.styles.cyan(next);
        }
        return lines();
      }
      async renderChoices() {
        if (this.state.submitted)
          return "";
        let choices = this.visible.map(async (ch, i) => await this.renderChoice(ch, i));
        let visible = await Promise.all(choices);
        if (!visible.length)
          visible.push(this.styles.danger("No matching choices"));
        return visible.join("\n");
      }
      format() {
        if (this.state.submitted) {
          let values = this.choices.map((ch) => this.styles.info(ch.scaleIdx));
          return values.join(", ");
        }
        return "";
      }
      async render() {
        let { submitted, size } = this.state;
        let prefix = await this.prefix();
        let separator = await this.separator();
        let message = await this.message();
        let prompt = [prefix, message, separator].filter(Boolean).join(" ");
        this.state.prompt = prompt;
        let header = await this.header();
        let output = await this.format();
        let help = await this.error() || await this.hint();
        let body = await this.renderChoices();
        let footer = await this.footer();
        if (output || !help)
          prompt += " " + output;
        if (help && !prompt.includes(help))
          prompt += " " + help;
        if (submitted && !output && !body && this.multiple && this.type !== "form") {
          prompt += this.styles.danger(this.emptyError);
        }
        this.clear(size);
        this.write([prompt, header, body, footer].filter(Boolean).join("\n"));
        this.restore();
      }
      submit() {
        this.value = {};
        for (let choice of this.choices) {
          this.value[choice.name] = choice.scaleIdx;
        }
        return this.base.submit.call(this);
      }
    };
    function createScale(n, options = {}) {
      if (Array.isArray(options.scale)) {
        return options.scale.map((ele) => ({ ...ele }));
      }
      let scale = [];
      for (let i = 1; i < n + 1; i++)
        scale.push({ i, selected: false });
      return scale;
    }
    module2.exports = Survey;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/text.js
var require_text = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/text.js"(exports, module2) {
    module2.exports = require_input();
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/toggle.js
var require_toggle = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/toggle.js"(exports, module2) {
    "use strict";
    var BooleanPrompt = require_boolean();
    var TogglePrompt = class extends BooleanPrompt {
      async initialize() {
        await super.initialize();
        this.value = this.initial = !!this.options.initial;
        this.disabled = this.options.disabled || "no";
        this.enabled = this.options.enabled || "yes";
        await this.render();
      }
      reset() {
        this.value = this.initial;
        this.render();
      }
      delete() {
        this.alert();
      }
      toggle() {
        this.value = !this.value;
        this.render();
      }
      enable() {
        if (this.value === true)
          return this.alert();
        this.value = true;
        this.render();
      }
      disable() {
        if (this.value === false)
          return this.alert();
        this.value = false;
        this.render();
      }
      up() {
        this.toggle();
      }
      down() {
        this.toggle();
      }
      right() {
        this.toggle();
      }
      left() {
        this.toggle();
      }
      next() {
        this.toggle();
      }
      prev() {
        this.toggle();
      }
      dispatch(ch = "", key) {
        switch (ch.toLowerCase()) {
          case " ":
            return this.toggle();
          case "1":
          case "y":
          case "t":
            return this.enable();
          case "0":
          case "n":
          case "f":
            return this.disable();
          default: {
            return this.alert();
          }
        }
      }
      format() {
        let active = (str2) => this.styles.primary.underline(str2);
        let value = [
          this.value ? this.disabled : active(this.disabled),
          this.value ? active(this.enabled) : this.enabled
        ];
        return value.join(this.styles.muted(" / "));
      }
      async render() {
        let { size } = this.state;
        let header = await this.header();
        let prefix = await this.prefix();
        let separator = await this.separator();
        let message = await this.message();
        let output = await this.format();
        let help = await this.error() || await this.hint();
        let footer = await this.footer();
        let prompt = [prefix, message, separator, output].join(" ");
        this.state.prompt = prompt;
        if (help && !prompt.includes(help))
          prompt += " " + help;
        this.clear(size);
        this.write([header, prompt, footer].filter(Boolean).join("\n"));
        this.write(this.margin[2]);
        this.restore();
      }
    };
    module2.exports = TogglePrompt;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/quiz.js
var require_quiz = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/quiz.js"(exports, module2) {
    "use strict";
    var SelectPrompt = require_select();
    var Quiz = class extends SelectPrompt {
      constructor(options) {
        super(options);
        if (typeof this.options.correctChoice !== "number" || this.options.correctChoice < 0) {
          throw new Error("Please specify the index of the correct answer from the list of choices");
        }
      }
      async toChoices(value, parent) {
        let choices = await super.toChoices(value, parent);
        if (choices.length < 2) {
          throw new Error("Please give at least two choices to the user");
        }
        if (this.options.correctChoice > choices.length) {
          throw new Error("Please specify the index of the correct answer from the list of choices");
        }
        return choices;
      }
      check(state) {
        return state.index === this.options.correctChoice;
      }
      async result(selected) {
        return {
          selectedAnswer: selected,
          correctAnswer: this.options.choices[this.options.correctChoice].value,
          correct: await this.check(this.state)
        };
      }
    };
    module2.exports = Quiz;
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/index.js
var require_prompts = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/prompts/index.js"(exports) {
    "use strict";
    var utils = require_utils2();
    var define2 = (key, fn) => {
      utils.defineExport(exports, key, fn);
      utils.defineExport(exports, key.toLowerCase(), fn);
    };
    define2("AutoComplete", () => require_autocomplete());
    define2("BasicAuth", () => require_basicauth());
    define2("Confirm", () => require_confirm());
    define2("Editable", () => require_editable());
    define2("Form", () => require_form());
    define2("Input", () => require_input());
    define2("Invisible", () => require_invisible());
    define2("List", () => require_list());
    define2("MultiSelect", () => require_multiselect());
    define2("Numeral", () => require_numeral());
    define2("Password", () => require_password());
    define2("Scale", () => require_scale());
    define2("Select", () => require_select());
    define2("Snippet", () => require_snippet());
    define2("Sort", () => require_sort());
    define2("Survey", () => require_survey());
    define2("Text", () => require_text());
    define2("Toggle", () => require_toggle());
    define2("Quiz", () => require_quiz());
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/index.js
var require_types2 = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/lib/types/index.js"(exports, module2) {
    module2.exports = {
      ArrayPrompt: require_array(),
      AuthPrompt: require_auth(),
      BooleanPrompt: require_boolean(),
      NumberPrompt: require_number(),
      StringPrompt: require_string()
    };
  }
});

// node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/index.js
var require_enquirer = __commonJS({
  "node_modules/.pnpm/enquirer@2.3.6/node_modules/enquirer/index.js"(exports, module2) {
    "use strict";
    var assert = require("assert");
    var Events = require("events");
    var utils = require_utils2();
    var Enquirer = class extends Events {
      constructor(options, answers) {
        super();
        this.options = utils.merge({}, options);
        this.answers = { ...answers };
      }
      register(type2, fn) {
        if (utils.isObject(type2)) {
          for (let key of Object.keys(type2))
            this.register(key, type2[key]);
          return this;
        }
        assert.equal(typeof fn, "function", "expected a function");
        let name = type2.toLowerCase();
        if (fn.prototype instanceof this.Prompt) {
          this.prompts[name] = fn;
        } else {
          this.prompts[name] = fn(this.Prompt, this);
        }
        return this;
      }
      async prompt(questions = []) {
        for (let question of [].concat(questions)) {
          try {
            if (typeof question === "function")
              question = await question.call(this);
            await this.ask(utils.merge({}, this.options, question));
          } catch (err) {
            return Promise.reject(err);
          }
        }
        return this.answers;
      }
      async ask(question) {
        if (typeof question === "function") {
          question = await question.call(this);
        }
        let opts = utils.merge({}, this.options, question);
        let { type: type2, name } = question;
        let { set: set2, get } = utils;
        if (typeof type2 === "function") {
          type2 = await type2.call(this, question, this.answers);
        }
        if (!type2)
          return this.answers[name];
        assert(this.prompts[type2], `Prompt "${type2}" is not registered`);
        let prompt = new this.prompts[type2](opts);
        let value = get(this.answers, name);
        prompt.state.answers = this.answers;
        prompt.enquirer = this;
        if (name) {
          prompt.on("submit", (value2) => {
            this.emit("answer", name, value2, prompt);
            set2(this.answers, name, value2);
          });
        }
        let emit = prompt.emit.bind(prompt);
        prompt.emit = (...args) => {
          this.emit.call(this, ...args);
          return emit(...args);
        };
        this.emit("prompt", prompt, this);
        if (opts.autofill && value != null) {
          prompt.value = prompt.input = value;
          if (opts.autofill === "show") {
            await prompt.submit();
          }
        } else {
          value = prompt.value = await prompt.run();
        }
        return value;
      }
      use(plugin) {
        plugin.call(this, this);
        return this;
      }
      set Prompt(value) {
        this._Prompt = value;
      }
      get Prompt() {
        return this._Prompt || this.constructor.Prompt;
      }
      get prompts() {
        return this.constructor.prompts;
      }
      static set Prompt(value) {
        this._Prompt = value;
      }
      static get Prompt() {
        return this._Prompt || require_prompt();
      }
      static get prompts() {
        return require_prompts();
      }
      static get types() {
        return require_types2();
      }
      static get prompt() {
        const fn = (questions, ...rest) => {
          let enquirer = new this(...rest);
          let emit = enquirer.emit.bind(enquirer);
          enquirer.emit = (...args) => {
            fn.emit(...args);
            return emit(...args);
          };
          return enquirer.prompt(questions);
        };
        utils.mixinEmitter(fn, new Events());
        return fn;
      }
    };
    utils.mixinEmitter(Enquirer, new Events());
    var prompts = Enquirer.prompts;
    for (let name of Object.keys(prompts)) {
      let key = name.toLowerCase();
      let run = (options) => new prompts[name](options).run();
      Enquirer.prompt[key] = run;
      Enquirer[key] = run;
      if (!Enquirer[name]) {
        Reflect.defineProperty(Enquirer, name, { get: () => prompts[name] });
      }
    }
    var exp = (name) => {
      utils.defineExport(Enquirer, name, () => Enquirer.types[name]);
    };
    exp("ArrayPrompt");
    exp("AuthPrompt");
    exp("BooleanPrompt");
    exp("NumberPrompt");
    exp("StringPrompt");
    module2.exports = Enquirer;
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/styles.js
var require_styles2 = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/styles.js"(exports, module2) {
    var styles = {};
    module2["exports"] = styles;
    var codes = {
      reset: [0, 0],
      bold: [1, 22],
      dim: [2, 22],
      italic: [3, 23],
      underline: [4, 24],
      inverse: [7, 27],
      hidden: [8, 28],
      strikethrough: [9, 29],
      black: [30, 39],
      red: [31, 39],
      green: [32, 39],
      yellow: [33, 39],
      blue: [34, 39],
      magenta: [35, 39],
      cyan: [36, 39],
      white: [37, 39],
      gray: [90, 39],
      grey: [90, 39],
      bgBlack: [40, 49],
      bgRed: [41, 49],
      bgGreen: [42, 49],
      bgYellow: [43, 49],
      bgBlue: [44, 49],
      bgMagenta: [45, 49],
      bgCyan: [46, 49],
      bgWhite: [47, 49],
      blackBG: [40, 49],
      redBG: [41, 49],
      greenBG: [42, 49],
      yellowBG: [43, 49],
      blueBG: [44, 49],
      magentaBG: [45, 49],
      cyanBG: [46, 49],
      whiteBG: [47, 49]
    };
    Object.keys(codes).forEach(function(key) {
      var val = codes[key];
      var style = styles[key] = [];
      style.open = "\x1B[" + val[0] + "m";
      style.close = "\x1B[" + val[1] + "m";
    });
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/system/supports-colors.js
var require_supports_colors2 = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/system/supports-colors.js"(exports, module2) {
    var argv = process.argv;
    module2.exports = function() {
      if (argv.indexOf("--no-color") !== -1 || argv.indexOf("--color=false") !== -1) {
        return false;
      }
      if (argv.indexOf("--color") !== -1 || argv.indexOf("--color=true") !== -1 || argv.indexOf("--color=always") !== -1) {
        return true;
      }
      if (process.stdout && !process.stdout.isTTY) {
        return false;
      }
      if (process.platform === "win32") {
        return true;
      }
      if ("COLORTERM" in process.env) {
        return true;
      }
      if (process.env.TERM === "dumb") {
        return false;
      }
      if (/^screen|^xterm|^vt100|color|ansi|cygwin|linux/i.test(process.env.TERM)) {
        return true;
      }
      return false;
    }();
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/custom/trap.js
var require_trap = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/custom/trap.js"(exports, module2) {
    module2["exports"] = function runTheTrap(text, options) {
      var result2 = "";
      text = text || "Run the trap, drop the bass";
      text = text.split("");
      var trap = {
        a: ["@", "\u0104", "\u023A", "\u0245", "\u0394", "\u039B", "\u0414"],
        b: ["\xDF", "\u0181", "\u0243", "\u026E", "\u03B2", "\u0E3F"],
        c: ["\xA9", "\u023B", "\u03FE"],
        d: ["\xD0", "\u018A", "\u0500", "\u0501", "\u0502", "\u0503"],
        e: ["\xCB", "\u0115", "\u018E", "\u0258", "\u03A3", "\u03BE", "\u04BC", "\u0A6C"],
        f: ["\u04FA"],
        g: ["\u0262"],
        h: ["\u0126", "\u0195", "\u04A2", "\u04BA", "\u04C7", "\u050A"],
        i: ["\u0F0F"],
        j: ["\u0134"],
        k: ["\u0138", "\u04A0", "\u04C3", "\u051E"],
        l: ["\u0139"],
        m: ["\u028D", "\u04CD", "\u04CE", "\u0520", "\u0521", "\u0D69"],
        n: ["\xD1", "\u014B", "\u019D", "\u0376", "\u03A0", "\u048A"],
        o: ["\xD8", "\xF5", "\xF8", "\u01FE", "\u0298", "\u047A", "\u05DD", "\u06DD", "\u0E4F"],
        p: ["\u01F7", "\u048E"],
        q: ["\u09CD"],
        r: ["\xAE", "\u01A6", "\u0210", "\u024C", "\u0280", "\u042F"],
        s: ["\xA7", "\u03DE", "\u03DF", "\u03E8"],
        t: ["\u0141", "\u0166", "\u0373"],
        u: ["\u01B1", "\u054D"],
        v: ["\u05D8"],
        w: ["\u0428", "\u0460", "\u047C", "\u0D70"],
        x: ["\u04B2", "\u04FE", "\u04FC", "\u04FD"],
        y: ["\xA5", "\u04B0", "\u04CB"],
        z: ["\u01B5", "\u0240"]
      };
      text.forEach(function(c) {
        c = c.toLowerCase();
        var chars = trap[c] || [" "];
        var rand = Math.floor(Math.random() * chars.length);
        if (typeof trap[c] !== "undefined") {
          result2 += trap[c][rand];
        } else {
          result2 += c;
        }
      });
      return result2;
    };
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/custom/zalgo.js
var require_zalgo = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/custom/zalgo.js"(exports, module2) {
    module2["exports"] = function zalgo(text, options) {
      text = text || "   he is here   ";
      var soul = {
        "up": [
          "\u030D",
          "\u030E",
          "\u0304",
          "\u0305",
          "\u033F",
          "\u0311",
          "\u0306",
          "\u0310",
          "\u0352",
          "\u0357",
          "\u0351",
          "\u0307",
          "\u0308",
          "\u030A",
          "\u0342",
          "\u0313",
          "\u0308",
          "\u034A",
          "\u034B",
          "\u034C",
          "\u0303",
          "\u0302",
          "\u030C",
          "\u0350",
          "\u0300",
          "\u0301",
          "\u030B",
          "\u030F",
          "\u0312",
          "\u0313",
          "\u0314",
          "\u033D",
          "\u0309",
          "\u0363",
          "\u0364",
          "\u0365",
          "\u0366",
          "\u0367",
          "\u0368",
          "\u0369",
          "\u036A",
          "\u036B",
          "\u036C",
          "\u036D",
          "\u036E",
          "\u036F",
          "\u033E",
          "\u035B",
          "\u0346",
          "\u031A"
        ],
        "down": [
          "\u0316",
          "\u0317",
          "\u0318",
          "\u0319",
          "\u031C",
          "\u031D",
          "\u031E",
          "\u031F",
          "\u0320",
          "\u0324",
          "\u0325",
          "\u0326",
          "\u0329",
          "\u032A",
          "\u032B",
          "\u032C",
          "\u032D",
          "\u032E",
          "\u032F",
          "\u0330",
          "\u0331",
          "\u0332",
          "\u0333",
          "\u0339",
          "\u033A",
          "\u033B",
          "\u033C",
          "\u0345",
          "\u0347",
          "\u0348",
          "\u0349",
          "\u034D",
          "\u034E",
          "\u0353",
          "\u0354",
          "\u0355",
          "\u0356",
          "\u0359",
          "\u035A",
          "\u0323"
        ],
        "mid": [
          "\u0315",
          "\u031B",
          "\u0300",
          "\u0301",
          "\u0358",
          "\u0321",
          "\u0322",
          "\u0327",
          "\u0328",
          "\u0334",
          "\u0335",
          "\u0336",
          "\u035C",
          "\u035D",
          "\u035E",
          "\u035F",
          "\u0360",
          "\u0362",
          "\u0338",
          "\u0337",
          "\u0361",
          " \u0489"
        ]
      }, all = [].concat(soul.up, soul.down, soul.mid), zalgo2 = {};
      function randomNumber(range) {
        var r = Math.floor(Math.random() * range);
        return r;
      }
      function is_char(character) {
        var bool2 = false;
        all.filter(function(i) {
          bool2 = i === character;
        });
        return bool2;
      }
      function heComes(text2, options2) {
        var result2 = "", counts, l;
        options2 = options2 || {};
        options2["up"] = options2["up"] || true;
        options2["mid"] = options2["mid"] || true;
        options2["down"] = options2["down"] || true;
        options2["size"] = options2["size"] || "maxi";
        text2 = text2.split("");
        for (l in text2) {
          if (is_char(l)) {
            continue;
          }
          result2 = result2 + text2[l];
          counts = { "up": 0, "down": 0, "mid": 0 };
          switch (options2.size) {
            case "mini":
              counts.up = randomNumber(8);
              counts.min = randomNumber(2);
              counts.down = randomNumber(8);
              break;
            case "maxi":
              counts.up = randomNumber(16) + 3;
              counts.min = randomNumber(4) + 1;
              counts.down = randomNumber(64) + 3;
              break;
            default:
              counts.up = randomNumber(8) + 1;
              counts.mid = randomNumber(6) / 2;
              counts.down = randomNumber(8) + 1;
              break;
          }
          var arr = ["up", "mid", "down"];
          for (var d in arr) {
            var index = arr[d];
            for (var i = 0; i <= counts[index]; i++) {
              if (options2[index]) {
                result2 = result2 + soul[index][randomNumber(soul[index].length)];
              }
            }
          }
        }
        return result2;
      }
      return heComes(text);
    };
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/america.js
var require_america = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/america.js"(exports, module2) {
    var colors = require_colors();
    module2["exports"] = function() {
      return function(letter, i, exploded) {
        if (letter === " ")
          return letter;
        switch (i % 3) {
          case 0:
            return colors.red(letter);
          case 1:
            return colors.white(letter);
          case 2:
            return colors.blue(letter);
        }
      };
    }();
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/zebra.js
var require_zebra = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/zebra.js"(exports, module2) {
    var colors = require_colors();
    module2["exports"] = function(letter, i, exploded) {
      return i % 2 === 0 ? letter : colors.inverse(letter);
    };
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/rainbow.js
var require_rainbow = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/rainbow.js"(exports, module2) {
    var colors = require_colors();
    module2["exports"] = function() {
      var rainbowColors = ["red", "yellow", "green", "blue", "magenta"];
      return function(letter, i, exploded) {
        if (letter === " ") {
          return letter;
        } else {
          return colors[rainbowColors[i++ % rainbowColors.length]](letter);
        }
      };
    }();
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/random.js
var require_random = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/maps/random.js"(exports, module2) {
    var colors = require_colors();
    module2["exports"] = function() {
      var available = ["underline", "inverse", "grey", "yellow", "red", "green", "blue", "white", "cyan", "magenta"];
      return function(letter, i, exploded) {
        return letter === " " ? letter : colors[available[Math.round(Math.random() * (available.length - 1))]](letter);
      };
    }();
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/colors.js
var require_colors = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/lib/colors.js"(exports, module2) {
    var colors = {};
    module2["exports"] = colors;
    colors.themes = {};
    var ansiStyles = colors.styles = require_styles2();
    var defineProps = Object.defineProperties;
    colors.supportsColor = require_supports_colors2();
    if (typeof colors.enabled === "undefined") {
      colors.enabled = colors.supportsColor;
    }
    colors.stripColors = colors.strip = function(str2) {
      return ("" + str2).replace(/\x1B\[\d+m/g, "");
    };
    var stylize = colors.stylize = function stylize2(str2, style) {
      return ansiStyles[style].open + str2 + ansiStyles[style].close;
    };
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    var escapeStringRegexp = function(str2) {
      if (typeof str2 !== "string") {
        throw new TypeError("Expected a string");
      }
      return str2.replace(matchOperatorsRe, "\\$&");
    };
    function build(_styles) {
      var builder = function builder2() {
        return applyStyle.apply(builder2, arguments);
      };
      builder._styles = _styles;
      builder.__proto__ = proto;
      return builder;
    }
    var styles = function() {
      var ret = {};
      ansiStyles.grey = ansiStyles.gray;
      Object.keys(ansiStyles).forEach(function(key) {
        ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
        ret[key] = {
          get: function() {
            return build(this._styles.concat(key));
          }
        };
      });
      return ret;
    }();
    var proto = defineProps(function colors2() {
    }, styles);
    function applyStyle() {
      var args = arguments;
      var argsLen = args.length;
      var str2 = argsLen !== 0 && String(arguments[0]);
      if (argsLen > 1) {
        for (var a = 1; a < argsLen; a++) {
          str2 += " " + args[a];
        }
      }
      if (!colors.enabled || !str2) {
        return str2;
      }
      var nestedStyles = this._styles;
      var i = nestedStyles.length;
      while (i--) {
        var code = ansiStyles[nestedStyles[i]];
        str2 = code.open + str2.replace(code.closeRe, code.open) + code.close;
      }
      return str2;
    }
    function applyTheme(theme) {
      for (var style in theme) {
        (function(style2) {
          colors[style2] = function(str2) {
            return colors[theme[style2]](str2);
          };
        })(style);
      }
    }
    colors.setTheme = function(theme) {
      if (typeof theme === "string") {
        try {
          colors.themes[theme] = require(theme);
          applyTheme(colors.themes[theme]);
          return colors.themes[theme];
        } catch (err) {
          console.log(err);
          return err;
        }
      } else {
        applyTheme(theme);
      }
    };
    function init() {
      var ret = {};
      Object.keys(styles).forEach(function(name) {
        ret[name] = {
          get: function() {
            return build([name]);
          }
        };
      });
      return ret;
    }
    var sequencer = function sequencer2(map3, str2) {
      var exploded = str2.split(""), i = 0;
      exploded = exploded.map(map3);
      return exploded.join("");
    };
    colors.trap = require_trap();
    colors.zalgo = require_zalgo();
    colors.maps = {};
    colors.maps.america = require_america();
    colors.maps.zebra = require_zebra();
    colors.maps.rainbow = require_rainbow();
    colors.maps.random = require_random();
    for (map2 in colors.maps) {
      (function(map3) {
        colors[map3] = function(str2) {
          return sequencer(colors.maps[map3], str2);
        };
      })(map2);
    }
    var map2;
    defineProps(colors, init());
  }
});

// node_modules/.pnpm/colors@1.0.3/node_modules/colors/safe.js
var require_safe = __commonJS({
  "node_modules/.pnpm/colors@1.0.3/node_modules/colors/safe.js"(exports, module2) {
    var colors = require_colors();
    module2["exports"] = colors;
  }
});

// node_modules/.pnpm/cli-table@0.3.11/node_modules/cli-table/lib/utils.js
var require_utils3 = __commonJS({
  "node_modules/.pnpm/cli-table@0.3.11/node_modules/cli-table/lib/utils.js"(exports) {
    exports.repeat = function(str2, times) {
      return Array(times + 1).join(str2);
    };
    exports.pad = function(str2, len, pad, dir) {
      if (len + 1 >= str2.length)
        switch (dir) {
          case "left":
            str2 = Array(len + 1 - str2.length).join(pad) + str2;
            break;
          case "both":
            var right = Math.ceil((padlen = len - str2.length) / 2);
            var left = padlen - right;
            str2 = Array(left + 1).join(pad) + str2 + Array(right + 1).join(pad);
            break;
          default:
            str2 = str2 + Array(len + 1 - str2.length).join(pad);
        }
      ;
      return str2;
    };
    exports.truncate = function(str2, length, chr) {
      chr = chr || "\u2026";
      return str2.length >= length ? str2.substr(0, length - chr.length) + chr : str2;
    };
    function options(defaults, opts) {
      for (var p in opts) {
        if (p === "__proto__" || p === "constructor" || p === "prototype") {
          continue;
        }
        if (opts[p] && opts[p].constructor && opts[p].constructor === Object) {
          defaults[p] = defaults[p] || {};
          options(defaults[p], opts[p]);
        } else {
          defaults[p] = opts[p];
        }
      }
      return defaults;
    }
    exports.options = options;
    exports.strlen = function(str2) {
      var code = /\u001b\[(?:\d*;){0,5}\d*m/g;
      var stripped = ("" + str2).replace(code, "");
      var split = stripped.split("\n");
      return split.reduce(function(memo, s) {
        return s.length > memo ? s.length : memo;
      }, 0);
    };
  }
});

// node_modules/.pnpm/cli-table@0.3.11/node_modules/cli-table/lib/index.js
var require_lib4 = __commonJS({
  "node_modules/.pnpm/cli-table@0.3.11/node_modules/cli-table/lib/index.js"(exports, module2) {
    var colors = require_safe();
    var utils = require_utils3();
    var repeat2 = utils.repeat;
    var truncate = utils.truncate;
    var pad = utils.pad;
    function Table3(options) {
      this.options = utils.options({
        chars: {
          "top": "\u2500",
          "top-mid": "\u252C",
          "top-left": "\u250C",
          "top-right": "\u2510",
          "bottom": "\u2500",
          "bottom-mid": "\u2534",
          "bottom-left": "\u2514",
          "bottom-right": "\u2518",
          "left": "\u2502",
          "left-mid": "\u251C",
          "mid": "\u2500",
          "mid-mid": "\u253C",
          "right": "\u2502",
          "right-mid": "\u2524",
          "middle": "\u2502"
        },
        truncate: "\u2026",
        colWidths: [],
        colAligns: [],
        style: {
          "padding-left": 1,
          "padding-right": 1,
          head: ["red"],
          border: ["grey"],
          compact: false
        },
        head: []
      }, options);
      if (options && options.rows) {
        for (var i = 0; i < options.rows.length; i++) {
          this.push(options.rows[i]);
        }
      }
    }
    Table3.prototype.__proto__ = Array.prototype;
    Table3.prototype.__defineGetter__("width", function() {
      var str2 = this.toString().split("\n");
      if (str2.length)
        return str2[0].length;
      return 0;
    });
    Table3.prototype.render;
    Table3.prototype.toString = function() {
      var ret = "", options = this.options, style = options.style, head = options.head, chars = options.chars, truncater = options.truncate, colWidths = options.colWidths || new Array(this.head.length), totalWidth = 0;
      if (!head.length && !this.length)
        return "";
      if (!colWidths.length) {
        var all_rows = this.slice(0);
        if (head.length) {
          all_rows = all_rows.concat([head]);
        }
        ;
        all_rows.forEach(function(cells) {
          if (typeof cells === "object" && cells.length) {
            extractColumnWidths(cells);
          } else {
            var header_cell = Object.keys(cells)[0], value_cell = cells[header_cell];
            colWidths[0] = Math.max(colWidths[0] || 0, get_width(header_cell) || 0);
            if (typeof value_cell === "object" && value_cell.length) {
              extractColumnWidths(value_cell, 1);
            } else {
              colWidths[1] = Math.max(colWidths[1] || 0, get_width(value_cell) || 0);
            }
          }
        });
      }
      ;
      totalWidth = (colWidths.length == 1 ? colWidths[0] : colWidths.reduce(function(a, b) {
        return a + b;
      })) + colWidths.length + 1;
      function extractColumnWidths(arr, offset) {
        var offset = offset || 0;
        arr.forEach(function(cell, i) {
          colWidths[i + offset] = Math.max(colWidths[i + offset] || 0, get_width(cell) || 0);
        });
      }
      ;
      function get_width(obj) {
        return typeof obj == "object" && obj.width != void 0 ? obj.width : (typeof obj == "object" ? utils.strlen(obj.text) : utils.strlen(obj)) + (style["padding-left"] || 0) + (style["padding-right"] || 0);
      }
      function line(line2, left, right, intersection) {
        var width = 0, line2 = left + repeat2(line2, totalWidth - 2) + right;
        colWidths.forEach(function(w, i) {
          if (i == colWidths.length - 1)
            return;
          width += w + 1;
          line2 = line2.substr(0, width) + intersection + line2.substr(width + 1);
        });
        return applyStyles(options.style.border, line2);
      }
      ;
      function lineTop() {
        var l2 = line(chars.top, chars["top-left"] || chars.top, chars["top-right"] || chars.top, chars["top-mid"]);
        if (l2)
          ret += l2 + "\n";
      }
      ;
      function generateRow(items, style2) {
        var cells = [], max_height = 0;
        if (!Array.isArray(items) && typeof items === "object") {
          var key = Object.keys(items)[0], value = items[key], first_cell_head = true;
          if (Array.isArray(value)) {
            items = value;
            items.unshift(key);
          } else {
            items = [key, value];
          }
        }
        items.forEach(function(item, i) {
          var contents = item.toString().split("\n").reduce(function(memo, l2) {
            memo.push(string2(l2, i));
            return memo;
          }, []);
          var height = contents.length;
          if (height > max_height) {
            max_height = height;
          }
          ;
          cells.push({ contents, height });
        });
        var lines = new Array(max_height);
        cells.forEach(function(cell, i) {
          cell.contents.forEach(function(line2, j2) {
            if (!lines[j2]) {
              lines[j2] = [];
            }
            ;
            if (style2 || first_cell_head && i === 0 && options.style.head) {
              line2 = applyStyles(options.style.head, line2);
            }
            lines[j2].push(line2);
          });
          for (var j = cell.height, l2 = max_height; j < l2; j++) {
            if (!lines[j]) {
              lines[j] = [];
            }
            ;
            lines[j].push(string2("", i));
          }
        });
        var ret2 = "";
        lines.forEach(function(line2, index) {
          if (ret2.length > 0) {
            ret2 += "\n" + applyStyles(options.style.border, chars.left);
          }
          ret2 += line2.join(applyStyles(options.style.border, chars.middle)) + applyStyles(options.style.border, chars.right);
        });
        return applyStyles(options.style.border, chars.left) + ret2;
      }
      ;
      function applyStyles(styles, subject) {
        if (!subject)
          return "";
        styles.forEach(function(style2) {
          subject = colors[style2](subject);
        });
        return subject;
      }
      ;
      function string2(str2, index) {
        var str2 = String(typeof str2 == "object" && str2.text ? str2.text : str2), length = utils.strlen(str2), width = colWidths[index] - (style["padding-left"] || 0) - (style["padding-right"] || 0), align = options.colAligns[index] || "left";
        return repeat2(" ", style["padding-left"] || 0) + (length == width ? str2 : length < width ? pad(str2, width + (str2.length - length), " ", align == "left" ? "right" : align == "middle" ? "both" : "left") : truncater ? truncate(str2, width, truncater) : str2) + repeat2(" ", style["padding-right"] || 0);
      }
      ;
      if (head.length) {
        lineTop();
        ret += generateRow(head, style.head) + "\n";
      }
      if (this.length)
        this.forEach(function(cells, i) {
          if (!head.length && i == 0)
            lineTop();
          else {
            if (!style.compact || i < !!head.length ? 1 : cells.length == 0) {
              var l2 = line(chars.mid, chars["left-mid"], chars["right-mid"], chars["mid-mid"]);
              if (l2)
                ret += l2 + "\n";
            }
          }
          if (cells.hasOwnProperty("length") && !cells.length) {
            return;
          } else {
            ret += generateRow(cells) + "\n";
          }
          ;
        });
      var l = line(chars.bottom, chars["bottom-left"] || chars.bottom, chars["bottom-right"] || chars.bottom, chars["bottom-mid"]);
      if (l)
        ret += l;
      else
        ret = ret.slice(0, -1);
      return ret;
    };
    module2.exports = Table3;
    module2.exports.version = "0.0.1";
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/base64.js
var require_base64 = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/base64.js"(exports) {
    var intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
    exports.encode = function(number) {
      if (0 <= number && number < intToCharMap.length) {
        return intToCharMap[number];
      }
      throw new TypeError("Must be between 0 and 63: " + number);
    };
    exports.decode = function(charCode) {
      var bigA = 65;
      var bigZ = 90;
      var littleA = 97;
      var littleZ = 122;
      var zero = 48;
      var nine = 57;
      var plus = 43;
      var slash = 47;
      var littleOffset = 26;
      var numberOffset = 52;
      if (bigA <= charCode && charCode <= bigZ) {
        return charCode - bigA;
      }
      if (littleA <= charCode && charCode <= littleZ) {
        return charCode - littleA + littleOffset;
      }
      if (zero <= charCode && charCode <= nine) {
        return charCode - zero + numberOffset;
      }
      if (charCode == plus) {
        return 62;
      }
      if (charCode == slash) {
        return 63;
      }
      return -1;
    };
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/base64-vlq.js
var require_base64_vlq = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/base64-vlq.js"(exports) {
    var base64 = require_base64();
    var VLQ_BASE_SHIFT = 5;
    var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
    var VLQ_BASE_MASK = VLQ_BASE - 1;
    var VLQ_CONTINUATION_BIT = VLQ_BASE;
    function toVLQSigned(aValue) {
      return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
    }
    function fromVLQSigned(aValue) {
      var isNegative = (aValue & 1) === 1;
      var shifted = aValue >> 1;
      return isNegative ? -shifted : shifted;
    }
    exports.encode = function base64VLQ_encode(aValue) {
      var encoded = "";
      var digit;
      var vlq = toVLQSigned(aValue);
      do {
        digit = vlq & VLQ_BASE_MASK;
        vlq >>>= VLQ_BASE_SHIFT;
        if (vlq > 0) {
          digit |= VLQ_CONTINUATION_BIT;
        }
        encoded += base64.encode(digit);
      } while (vlq > 0);
      return encoded;
    };
    exports.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
      var strLen = aStr.length;
      var result2 = 0;
      var shift = 0;
      var continuation, digit;
      do {
        if (aIndex >= strLen) {
          throw new Error("Expected more digits in base 64 VLQ value.");
        }
        digit = base64.decode(aStr.charCodeAt(aIndex++));
        if (digit === -1) {
          throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
        }
        continuation = !!(digit & VLQ_CONTINUATION_BIT);
        digit &= VLQ_BASE_MASK;
        result2 = result2 + (digit << shift);
        shift += VLQ_BASE_SHIFT;
      } while (continuation);
      aOutParam.value = fromVLQSigned(result2);
      aOutParam.rest = aIndex;
    };
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/util.js
var require_util = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/util.js"(exports) {
    function getArg(aArgs, aName, aDefaultValue) {
      if (aName in aArgs) {
        return aArgs[aName];
      } else if (arguments.length === 3) {
        return aDefaultValue;
      } else {
        throw new Error('"' + aName + '" is a required argument.');
      }
    }
    exports.getArg = getArg;
    var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/;
    var dataUrlRegexp = /^data:.+\,.+$/;
    function urlParse(aUrl) {
      var match = aUrl.match(urlRegexp);
      if (!match) {
        return null;
      }
      return {
        scheme: match[1],
        auth: match[2],
        host: match[3],
        port: match[4],
        path: match[5]
      };
    }
    exports.urlParse = urlParse;
    function urlGenerate(aParsedUrl) {
      var url = "";
      if (aParsedUrl.scheme) {
        url += aParsedUrl.scheme + ":";
      }
      url += "//";
      if (aParsedUrl.auth) {
        url += aParsedUrl.auth + "@";
      }
      if (aParsedUrl.host) {
        url += aParsedUrl.host;
      }
      if (aParsedUrl.port) {
        url += ":" + aParsedUrl.port;
      }
      if (aParsedUrl.path) {
        url += aParsedUrl.path;
      }
      return url;
    }
    exports.urlGenerate = urlGenerate;
    function normalize(aPath) {
      var path2 = aPath;
      var url = urlParse(aPath);
      if (url) {
        if (!url.path) {
          return aPath;
        }
        path2 = url.path;
      }
      var isAbsolute = exports.isAbsolute(path2);
      var parts = path2.split(/\/+/);
      for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
        part = parts[i];
        if (part === ".") {
          parts.splice(i, 1);
        } else if (part === "..") {
          up++;
        } else if (up > 0) {
          if (part === "") {
            parts.splice(i + 1, up);
            up = 0;
          } else {
            parts.splice(i, 2);
            up--;
          }
        }
      }
      path2 = parts.join("/");
      if (path2 === "") {
        path2 = isAbsolute ? "/" : ".";
      }
      if (url) {
        url.path = path2;
        return urlGenerate(url);
      }
      return path2;
    }
    exports.normalize = normalize;
    function join(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      if (aPath === "") {
        aPath = ".";
      }
      var aPathUrl = urlParse(aPath);
      var aRootUrl = urlParse(aRoot);
      if (aRootUrl) {
        aRoot = aRootUrl.path || "/";
      }
      if (aPathUrl && !aPathUrl.scheme) {
        if (aRootUrl) {
          aPathUrl.scheme = aRootUrl.scheme;
        }
        return urlGenerate(aPathUrl);
      }
      if (aPathUrl || aPath.match(dataUrlRegexp)) {
        return aPath;
      }
      if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
        aRootUrl.host = aPath;
        return urlGenerate(aRootUrl);
      }
      var joined = aPath.charAt(0) === "/" ? aPath : normalize(aRoot.replace(/\/+$/, "") + "/" + aPath);
      if (aRootUrl) {
        aRootUrl.path = joined;
        return urlGenerate(aRootUrl);
      }
      return joined;
    }
    exports.join = join;
    exports.isAbsolute = function(aPath) {
      return aPath.charAt(0) === "/" || urlRegexp.test(aPath);
    };
    function relative(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      aRoot = aRoot.replace(/\/$/, "");
      var level = 0;
      while (aPath.indexOf(aRoot + "/") !== 0) {
        var index = aRoot.lastIndexOf("/");
        if (index < 0) {
          return aPath;
        }
        aRoot = aRoot.slice(0, index);
        if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
          return aPath;
        }
        ++level;
      }
      return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
    }
    exports.relative = relative;
    var supportsNullProto = function() {
      var obj = /* @__PURE__ */ Object.create(null);
      return !("__proto__" in obj);
    }();
    function identity(s) {
      return s;
    }
    function toSetString(aStr) {
      if (isProtoString(aStr)) {
        return "$" + aStr;
      }
      return aStr;
    }
    exports.toSetString = supportsNullProto ? identity : toSetString;
    function fromSetString(aStr) {
      if (isProtoString(aStr)) {
        return aStr.slice(1);
      }
      return aStr;
    }
    exports.fromSetString = supportsNullProto ? identity : fromSetString;
    function isProtoString(s) {
      if (!s) {
        return false;
      }
      var length = s.length;
      if (length < 9) {
        return false;
      }
      if (s.charCodeAt(length - 1) !== 95 || s.charCodeAt(length - 2) !== 95 || s.charCodeAt(length - 3) !== 111 || s.charCodeAt(length - 4) !== 116 || s.charCodeAt(length - 5) !== 111 || s.charCodeAt(length - 6) !== 114 || s.charCodeAt(length - 7) !== 112 || s.charCodeAt(length - 8) !== 95 || s.charCodeAt(length - 9) !== 95) {
        return false;
      }
      for (var i = length - 10; i >= 0; i--) {
        if (s.charCodeAt(i) !== 36) {
          return false;
        }
      }
      return true;
    }
    function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
      var cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0 || onlyCompareOriginal) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByOriginalPositions = compareByOriginalPositions;
    function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0 || onlyCompareGenerated) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;
    function strcmp(aStr1, aStr2) {
      if (aStr1 === aStr2) {
        return 0;
      }
      if (aStr1 === null) {
        return 1;
      }
      if (aStr2 === null) {
        return -1;
      }
      if (aStr1 > aStr2) {
        return 1;
      }
      return -1;
    }
    function compareByGeneratedPositionsInflated(mappingA, mappingB) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
    function parseSourceMapInput(str2) {
      return JSON.parse(str2.replace(/^\)]}'[^\n]*\n/, ""));
    }
    exports.parseSourceMapInput = parseSourceMapInput;
    function computeSourceURL(sourceRoot, sourceURL, sourceMapURL) {
      sourceURL = sourceURL || "";
      if (sourceRoot) {
        if (sourceRoot[sourceRoot.length - 1] !== "/" && sourceURL[0] !== "/") {
          sourceRoot += "/";
        }
        sourceURL = sourceRoot + sourceURL;
      }
      if (sourceMapURL) {
        var parsed = urlParse(sourceMapURL);
        if (!parsed) {
          throw new Error("sourceMapURL could not be parsed");
        }
        if (parsed.path) {
          var index = parsed.path.lastIndexOf("/");
          if (index >= 0) {
            parsed.path = parsed.path.substring(0, index + 1);
          }
        }
        sourceURL = join(urlGenerate(parsed), sourceURL);
      }
      return normalize(sourceURL);
    }
    exports.computeSourceURL = computeSourceURL;
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/array-set.js
var require_array_set = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/array-set.js"(exports) {
    var util = require_util();
    var has = Object.prototype.hasOwnProperty;
    var hasNativeMap = typeof Map !== "undefined";
    function ArraySet() {
      this._array = [];
      this._set = hasNativeMap ? /* @__PURE__ */ new Map() : /* @__PURE__ */ Object.create(null);
    }
    ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
      var set2 = new ArraySet();
      for (var i = 0, len = aArray.length; i < len; i++) {
        set2.add(aArray[i], aAllowDuplicates);
      }
      return set2;
    };
    ArraySet.prototype.size = function ArraySet_size() {
      return hasNativeMap ? this._set.size : Object.getOwnPropertyNames(this._set).length;
    };
    ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
      var sStr = hasNativeMap ? aStr : util.toSetString(aStr);
      var isDuplicate = hasNativeMap ? this.has(aStr) : has.call(this._set, sStr);
      var idx2 = this._array.length;
      if (!isDuplicate || aAllowDuplicates) {
        this._array.push(aStr);
      }
      if (!isDuplicate) {
        if (hasNativeMap) {
          this._set.set(aStr, idx2);
        } else {
          this._set[sStr] = idx2;
        }
      }
    };
    ArraySet.prototype.has = function ArraySet_has(aStr) {
      if (hasNativeMap) {
        return this._set.has(aStr);
      } else {
        var sStr = util.toSetString(aStr);
        return has.call(this._set, sStr);
      }
    };
    ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
      if (hasNativeMap) {
        var idx2 = this._set.get(aStr);
        if (idx2 >= 0) {
          return idx2;
        }
      } else {
        var sStr = util.toSetString(aStr);
        if (has.call(this._set, sStr)) {
          return this._set[sStr];
        }
      }
      throw new Error('"' + aStr + '" is not in the set.');
    };
    ArraySet.prototype.at = function ArraySet_at(aIdx) {
      if (aIdx >= 0 && aIdx < this._array.length) {
        return this._array[aIdx];
      }
      throw new Error("No element indexed by " + aIdx);
    };
    ArraySet.prototype.toArray = function ArraySet_toArray() {
      return this._array.slice();
    };
    exports.ArraySet = ArraySet;
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/mapping-list.js
var require_mapping_list = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/mapping-list.js"(exports) {
    var util = require_util();
    function generatedPositionAfter(mappingA, mappingB) {
      var lineA = mappingA.generatedLine;
      var lineB = mappingB.generatedLine;
      var columnA = mappingA.generatedColumn;
      var columnB = mappingB.generatedColumn;
      return lineB > lineA || lineB == lineA && columnB >= columnA || util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
    }
    function MappingList() {
      this._array = [];
      this._sorted = true;
      this._last = { generatedLine: -1, generatedColumn: 0 };
    }
    MappingList.prototype.unsortedForEach = function MappingList_forEach(aCallback, aThisArg) {
      this._array.forEach(aCallback, aThisArg);
    };
    MappingList.prototype.add = function MappingList_add(aMapping) {
      if (generatedPositionAfter(this._last, aMapping)) {
        this._last = aMapping;
        this._array.push(aMapping);
      } else {
        this._sorted = false;
        this._array.push(aMapping);
      }
    };
    MappingList.prototype.toArray = function MappingList_toArray() {
      if (!this._sorted) {
        this._array.sort(util.compareByGeneratedPositionsInflated);
        this._sorted = true;
      }
      return this._array;
    };
    exports.MappingList = MappingList;
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/source-map-generator.js
var require_source_map_generator = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/source-map-generator.js"(exports) {
    var base64VLQ = require_base64_vlq();
    var util = require_util();
    var ArraySet = require_array_set().ArraySet;
    var MappingList = require_mapping_list().MappingList;
    function SourceMapGenerator(aArgs) {
      if (!aArgs) {
        aArgs = {};
      }
      this._file = util.getArg(aArgs, "file", null);
      this._sourceRoot = util.getArg(aArgs, "sourceRoot", null);
      this._skipValidation = util.getArg(aArgs, "skipValidation", false);
      this._sources = new ArraySet();
      this._names = new ArraySet();
      this._mappings = new MappingList();
      this._sourcesContents = null;
    }
    SourceMapGenerator.prototype._version = 3;
    SourceMapGenerator.fromSourceMap = function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
      var sourceRoot = aSourceMapConsumer.sourceRoot;
      var generator = new SourceMapGenerator({
        file: aSourceMapConsumer.file,
        sourceRoot
      });
      aSourceMapConsumer.eachMapping(function(mapping) {
        var newMapping = {
          generated: {
            line: mapping.generatedLine,
            column: mapping.generatedColumn
          }
        };
        if (mapping.source != null) {
          newMapping.source = mapping.source;
          if (sourceRoot != null) {
            newMapping.source = util.relative(sourceRoot, newMapping.source);
          }
          newMapping.original = {
            line: mapping.originalLine,
            column: mapping.originalColumn
          };
          if (mapping.name != null) {
            newMapping.name = mapping.name;
          }
        }
        generator.addMapping(newMapping);
      });
      aSourceMapConsumer.sources.forEach(function(sourceFile) {
        var sourceRelative = sourceFile;
        if (sourceRoot !== null) {
          sourceRelative = util.relative(sourceRoot, sourceFile);
        }
        if (!generator._sources.has(sourceRelative)) {
          generator._sources.add(sourceRelative);
        }
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          generator.setSourceContent(sourceFile, content);
        }
      });
      return generator;
    };
    SourceMapGenerator.prototype.addMapping = function SourceMapGenerator_addMapping(aArgs) {
      var generated = util.getArg(aArgs, "generated");
      var original = util.getArg(aArgs, "original", null);
      var source = util.getArg(aArgs, "source", null);
      var name = util.getArg(aArgs, "name", null);
      if (!this._skipValidation) {
        this._validateMapping(generated, original, source, name);
      }
      if (source != null) {
        source = String(source);
        if (!this._sources.has(source)) {
          this._sources.add(source);
        }
      }
      if (name != null) {
        name = String(name);
        if (!this._names.has(name)) {
          this._names.add(name);
        }
      }
      this._mappings.add({
        generatedLine: generated.line,
        generatedColumn: generated.column,
        originalLine: original != null && original.line,
        originalColumn: original != null && original.column,
        source,
        name
      });
    };
    SourceMapGenerator.prototype.setSourceContent = function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
      var source = aSourceFile;
      if (this._sourceRoot != null) {
        source = util.relative(this._sourceRoot, source);
      }
      if (aSourceContent != null) {
        if (!this._sourcesContents) {
          this._sourcesContents = /* @__PURE__ */ Object.create(null);
        }
        this._sourcesContents[util.toSetString(source)] = aSourceContent;
      } else if (this._sourcesContents) {
        delete this._sourcesContents[util.toSetString(source)];
        if (Object.keys(this._sourcesContents).length === 0) {
          this._sourcesContents = null;
        }
      }
    };
    SourceMapGenerator.prototype.applySourceMap = function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
      var sourceFile = aSourceFile;
      if (aSourceFile == null) {
        if (aSourceMapConsumer.file == null) {
          throw new Error(`SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's "file" property. Both were omitted.`);
        }
        sourceFile = aSourceMapConsumer.file;
      }
      var sourceRoot = this._sourceRoot;
      if (sourceRoot != null) {
        sourceFile = util.relative(sourceRoot, sourceFile);
      }
      var newSources = new ArraySet();
      var newNames = new ArraySet();
      this._mappings.unsortedForEach(function(mapping) {
        if (mapping.source === sourceFile && mapping.originalLine != null) {
          var original = aSourceMapConsumer.originalPositionFor({
            line: mapping.originalLine,
            column: mapping.originalColumn
          });
          if (original.source != null) {
            mapping.source = original.source;
            if (aSourceMapPath != null) {
              mapping.source = util.join(aSourceMapPath, mapping.source);
            }
            if (sourceRoot != null) {
              mapping.source = util.relative(sourceRoot, mapping.source);
            }
            mapping.originalLine = original.line;
            mapping.originalColumn = original.column;
            if (original.name != null) {
              mapping.name = original.name;
            }
          }
        }
        var source = mapping.source;
        if (source != null && !newSources.has(source)) {
          newSources.add(source);
        }
        var name = mapping.name;
        if (name != null && !newNames.has(name)) {
          newNames.add(name);
        }
      }, this);
      this._sources = newSources;
      this._names = newNames;
      aSourceMapConsumer.sources.forEach(function(sourceFile2) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile2);
        if (content != null) {
          if (aSourceMapPath != null) {
            sourceFile2 = util.join(aSourceMapPath, sourceFile2);
          }
          if (sourceRoot != null) {
            sourceFile2 = util.relative(sourceRoot, sourceFile2);
          }
          this.setSourceContent(sourceFile2, content);
        }
      }, this);
    };
    SourceMapGenerator.prototype._validateMapping = function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource, aName) {
      if (aOriginal && typeof aOriginal.line !== "number" && typeof aOriginal.column !== "number") {
        throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");
      }
      if (aGenerated && "line" in aGenerated && "column" in aGenerated && aGenerated.line > 0 && aGenerated.column >= 0 && !aOriginal && !aSource && !aName) {
        return;
      } else if (aGenerated && "line" in aGenerated && "column" in aGenerated && aOriginal && "line" in aOriginal && "column" in aOriginal && aGenerated.line > 0 && aGenerated.column >= 0 && aOriginal.line > 0 && aOriginal.column >= 0 && aSource) {
        return;
      } else {
        throw new Error("Invalid mapping: " + JSON.stringify({
          generated: aGenerated,
          source: aSource,
          original: aOriginal,
          name: aName
        }));
      }
    };
    SourceMapGenerator.prototype._serializeMappings = function SourceMapGenerator_serializeMappings() {
      var previousGeneratedColumn = 0;
      var previousGeneratedLine = 1;
      var previousOriginalColumn = 0;
      var previousOriginalLine = 0;
      var previousName = 0;
      var previousSource = 0;
      var result2 = "";
      var next;
      var mapping;
      var nameIdx;
      var sourceIdx;
      var mappings = this._mappings.toArray();
      for (var i = 0, len = mappings.length; i < len; i++) {
        mapping = mappings[i];
        next = "";
        if (mapping.generatedLine !== previousGeneratedLine) {
          previousGeneratedColumn = 0;
          while (mapping.generatedLine !== previousGeneratedLine) {
            next += ";";
            previousGeneratedLine++;
          }
        } else {
          if (i > 0) {
            if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
              continue;
            }
            next += ",";
          }
        }
        next += base64VLQ.encode(mapping.generatedColumn - previousGeneratedColumn);
        previousGeneratedColumn = mapping.generatedColumn;
        if (mapping.source != null) {
          sourceIdx = this._sources.indexOf(mapping.source);
          next += base64VLQ.encode(sourceIdx - previousSource);
          previousSource = sourceIdx;
          next += base64VLQ.encode(mapping.originalLine - 1 - previousOriginalLine);
          previousOriginalLine = mapping.originalLine - 1;
          next += base64VLQ.encode(mapping.originalColumn - previousOriginalColumn);
          previousOriginalColumn = mapping.originalColumn;
          if (mapping.name != null) {
            nameIdx = this._names.indexOf(mapping.name);
            next += base64VLQ.encode(nameIdx - previousName);
            previousName = nameIdx;
          }
        }
        result2 += next;
      }
      return result2;
    };
    SourceMapGenerator.prototype._generateSourcesContent = function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
      return aSources.map(function(source) {
        if (!this._sourcesContents) {
          return null;
        }
        if (aSourceRoot != null) {
          source = util.relative(aSourceRoot, source);
        }
        var key = util.toSetString(source);
        return Object.prototype.hasOwnProperty.call(this._sourcesContents, key) ? this._sourcesContents[key] : null;
      }, this);
    };
    SourceMapGenerator.prototype.toJSON = function SourceMapGenerator_toJSON() {
      var map2 = {
        version: this._version,
        sources: this._sources.toArray(),
        names: this._names.toArray(),
        mappings: this._serializeMappings()
      };
      if (this._file != null) {
        map2.file = this._file;
      }
      if (this._sourceRoot != null) {
        map2.sourceRoot = this._sourceRoot;
      }
      if (this._sourcesContents) {
        map2.sourcesContent = this._generateSourcesContent(map2.sources, map2.sourceRoot);
      }
      return map2;
    };
    SourceMapGenerator.prototype.toString = function SourceMapGenerator_toString() {
      return JSON.stringify(this.toJSON());
    };
    exports.SourceMapGenerator = SourceMapGenerator;
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/binary-search.js
var require_binary_search = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/binary-search.js"(exports) {
    exports.GREATEST_LOWER_BOUND = 1;
    exports.LEAST_UPPER_BOUND = 2;
    function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
      var mid = Math.floor((aHigh - aLow) / 2) + aLow;
      var cmp = aCompare(aNeedle, aHaystack[mid], true);
      if (cmp === 0) {
        return mid;
      } else if (cmp > 0) {
        if (aHigh - mid > 1) {
          return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return aHigh < aHaystack.length ? aHigh : -1;
        } else {
          return mid;
        }
      } else {
        if (mid - aLow > 1) {
          return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return mid;
        } else {
          return aLow < 0 ? -1 : aLow;
        }
      }
    }
    exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
      if (aHaystack.length === 0) {
        return -1;
      }
      var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack, aCompare, aBias || exports.GREATEST_LOWER_BOUND);
      if (index < 0) {
        return -1;
      }
      while (index - 1 >= 0) {
        if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
          break;
        }
        --index;
      }
      return index;
    };
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/quick-sort.js
var require_quick_sort = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/quick-sort.js"(exports) {
    function swap(ary, x, y) {
      var temp = ary[x];
      ary[x] = ary[y];
      ary[y] = temp;
    }
    function randomIntInRange(low, high) {
      return Math.round(low + Math.random() * (high - low));
    }
    function doQuickSort(ary, comparator, p, r) {
      if (p < r) {
        var pivotIndex = randomIntInRange(p, r);
        var i = p - 1;
        swap(ary, pivotIndex, r);
        var pivot = ary[r];
        for (var j = p; j < r; j++) {
          if (comparator(ary[j], pivot) <= 0) {
            i += 1;
            swap(ary, i, j);
          }
        }
        swap(ary, i + 1, j);
        var q = i + 1;
        doQuickSort(ary, comparator, p, q - 1);
        doQuickSort(ary, comparator, q + 1, r);
      }
    }
    exports.quickSort = function(ary, comparator) {
      doQuickSort(ary, comparator, 0, ary.length - 1);
    };
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/source-map-consumer.js
var require_source_map_consumer = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/source-map-consumer.js"(exports) {
    var util = require_util();
    var binarySearch = require_binary_search();
    var ArraySet = require_array_set().ArraySet;
    var base64VLQ = require_base64_vlq();
    var quickSort = require_quick_sort().quickSort;
    function SourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      return sourceMap.sections != null ? new IndexedSourceMapConsumer(sourceMap, aSourceMapURL) : new BasicSourceMapConsumer(sourceMap, aSourceMapURL);
    }
    SourceMapConsumer.fromSourceMap = function(aSourceMap, aSourceMapURL) {
      return BasicSourceMapConsumer.fromSourceMap(aSourceMap, aSourceMapURL);
    };
    SourceMapConsumer.prototype._version = 3;
    SourceMapConsumer.prototype.__generatedMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_generatedMappings", {
      configurable: true,
      enumerable: true,
      get: function() {
        if (!this.__generatedMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__generatedMappings;
      }
    });
    SourceMapConsumer.prototype.__originalMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_originalMappings", {
      configurable: true,
      enumerable: true,
      get: function() {
        if (!this.__originalMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__originalMappings;
      }
    });
    SourceMapConsumer.prototype._charIsMappingSeparator = function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
      var c = aStr.charAt(index);
      return c === ";" || c === ",";
    };
    SourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      throw new Error("Subclasses must implement _parseMappings");
    };
    SourceMapConsumer.GENERATED_ORDER = 1;
    SourceMapConsumer.ORIGINAL_ORDER = 2;
    SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
    SourceMapConsumer.LEAST_UPPER_BOUND = 2;
    SourceMapConsumer.prototype.eachMapping = function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
      var context = aContext || null;
      var order = aOrder || SourceMapConsumer.GENERATED_ORDER;
      var mappings;
      switch (order) {
        case SourceMapConsumer.GENERATED_ORDER:
          mappings = this._generatedMappings;
          break;
        case SourceMapConsumer.ORIGINAL_ORDER:
          mappings = this._originalMappings;
          break;
        default:
          throw new Error("Unknown order of iteration.");
      }
      var sourceRoot = this.sourceRoot;
      mappings.map(function(mapping) {
        var source = mapping.source === null ? null : this._sources.at(mapping.source);
        source = util.computeSourceURL(sourceRoot, source, this._sourceMapURL);
        return {
          source,
          generatedLine: mapping.generatedLine,
          generatedColumn: mapping.generatedColumn,
          originalLine: mapping.originalLine,
          originalColumn: mapping.originalColumn,
          name: mapping.name === null ? null : this._names.at(mapping.name)
        };
      }, this).forEach(aCallback, context);
    };
    SourceMapConsumer.prototype.allGeneratedPositionsFor = function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
      var line = util.getArg(aArgs, "line");
      var needle = {
        source: util.getArg(aArgs, "source"),
        originalLine: line,
        originalColumn: util.getArg(aArgs, "column", 0)
      };
      needle.source = this._findSourceIndex(needle.source);
      if (needle.source < 0) {
        return [];
      }
      var mappings = [];
      var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util.compareByOriginalPositions, binarySearch.LEAST_UPPER_BOUND);
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (aArgs.column === void 0) {
          var originalLine = mapping.originalLine;
          while (mapping && mapping.originalLine === originalLine) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        } else {
          var originalColumn = mapping.originalColumn;
          while (mapping && mapping.originalLine === line && mapping.originalColumn == originalColumn) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        }
      }
      return mappings;
    };
    exports.SourceMapConsumer = SourceMapConsumer;
    function BasicSourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      var version = util.getArg(sourceMap, "version");
      var sources = util.getArg(sourceMap, "sources");
      var names = util.getArg(sourceMap, "names", []);
      var sourceRoot = util.getArg(sourceMap, "sourceRoot", null);
      var sourcesContent = util.getArg(sourceMap, "sourcesContent", null);
      var mappings = util.getArg(sourceMap, "mappings");
      var file = util.getArg(sourceMap, "file", null);
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      if (sourceRoot) {
        sourceRoot = util.normalize(sourceRoot);
      }
      sources = sources.map(String).map(util.normalize).map(function(source) {
        return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source) ? util.relative(sourceRoot, source) : source;
      });
      this._names = ArraySet.fromArray(names.map(String), true);
      this._sources = ArraySet.fromArray(sources, true);
      this._absoluteSources = this._sources.toArray().map(function(s) {
        return util.computeSourceURL(sourceRoot, s, aSourceMapURL);
      });
      this.sourceRoot = sourceRoot;
      this.sourcesContent = sourcesContent;
      this._mappings = mappings;
      this._sourceMapURL = aSourceMapURL;
      this.file = file;
    }
    BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
    BasicSourceMapConsumer.prototype._findSourceIndex = function(aSource) {
      var relativeSource = aSource;
      if (this.sourceRoot != null) {
        relativeSource = util.relative(this.sourceRoot, relativeSource);
      }
      if (this._sources.has(relativeSource)) {
        return this._sources.indexOf(relativeSource);
      }
      var i;
      for (i = 0; i < this._absoluteSources.length; ++i) {
        if (this._absoluteSources[i] == aSource) {
          return i;
        }
      }
      return -1;
    };
    BasicSourceMapConsumer.fromSourceMap = function SourceMapConsumer_fromSourceMap(aSourceMap, aSourceMapURL) {
      var smc = Object.create(BasicSourceMapConsumer.prototype);
      var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
      var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
      smc.sourceRoot = aSourceMap._sourceRoot;
      smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(), smc.sourceRoot);
      smc.file = aSourceMap._file;
      smc._sourceMapURL = aSourceMapURL;
      smc._absoluteSources = smc._sources.toArray().map(function(s) {
        return util.computeSourceURL(smc.sourceRoot, s, aSourceMapURL);
      });
      var generatedMappings = aSourceMap._mappings.toArray().slice();
      var destGeneratedMappings = smc.__generatedMappings = [];
      var destOriginalMappings = smc.__originalMappings = [];
      for (var i = 0, length = generatedMappings.length; i < length; i++) {
        var srcMapping = generatedMappings[i];
        var destMapping = new Mapping();
        destMapping.generatedLine = srcMapping.generatedLine;
        destMapping.generatedColumn = srcMapping.generatedColumn;
        if (srcMapping.source) {
          destMapping.source = sources.indexOf(srcMapping.source);
          destMapping.originalLine = srcMapping.originalLine;
          destMapping.originalColumn = srcMapping.originalColumn;
          if (srcMapping.name) {
            destMapping.name = names.indexOf(srcMapping.name);
          }
          destOriginalMappings.push(destMapping);
        }
        destGeneratedMappings.push(destMapping);
      }
      quickSort(smc.__originalMappings, util.compareByOriginalPositions);
      return smc;
    };
    BasicSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(BasicSourceMapConsumer.prototype, "sources", {
      get: function() {
        return this._absoluteSources.slice();
      }
    });
    function Mapping() {
      this.generatedLine = 0;
      this.generatedColumn = 0;
      this.source = null;
      this.originalLine = null;
      this.originalColumn = null;
      this.name = null;
    }
    BasicSourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      var generatedLine = 1;
      var previousGeneratedColumn = 0;
      var previousOriginalLine = 0;
      var previousOriginalColumn = 0;
      var previousSource = 0;
      var previousName = 0;
      var length = aStr.length;
      var index = 0;
      var cachedSegments = {};
      var temp = {};
      var originalMappings = [];
      var generatedMappings = [];
      var mapping, str2, segment, end, value;
      while (index < length) {
        if (aStr.charAt(index) === ";") {
          generatedLine++;
          index++;
          previousGeneratedColumn = 0;
        } else if (aStr.charAt(index) === ",") {
          index++;
        } else {
          mapping = new Mapping();
          mapping.generatedLine = generatedLine;
          for (end = index; end < length; end++) {
            if (this._charIsMappingSeparator(aStr, end)) {
              break;
            }
          }
          str2 = aStr.slice(index, end);
          segment = cachedSegments[str2];
          if (segment) {
            index += str2.length;
          } else {
            segment = [];
            while (index < end) {
              base64VLQ.decode(aStr, index, temp);
              value = temp.value;
              index = temp.rest;
              segment.push(value);
            }
            if (segment.length === 2) {
              throw new Error("Found a source, but no line and column");
            }
            if (segment.length === 3) {
              throw new Error("Found a source and line, but no column");
            }
            cachedSegments[str2] = segment;
          }
          mapping.generatedColumn = previousGeneratedColumn + segment[0];
          previousGeneratedColumn = mapping.generatedColumn;
          if (segment.length > 1) {
            mapping.source = previousSource + segment[1];
            previousSource += segment[1];
            mapping.originalLine = previousOriginalLine + segment[2];
            previousOriginalLine = mapping.originalLine;
            mapping.originalLine += 1;
            mapping.originalColumn = previousOriginalColumn + segment[3];
            previousOriginalColumn = mapping.originalColumn;
            if (segment.length > 4) {
              mapping.name = previousName + segment[4];
              previousName += segment[4];
            }
          }
          generatedMappings.push(mapping);
          if (typeof mapping.originalLine === "number") {
            originalMappings.push(mapping);
          }
        }
      }
      quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
      this.__generatedMappings = generatedMappings;
      quickSort(originalMappings, util.compareByOriginalPositions);
      this.__originalMappings = originalMappings;
    };
    BasicSourceMapConsumer.prototype._findMapping = function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName, aColumnName, aComparator, aBias) {
      if (aNeedle[aLineName] <= 0) {
        throw new TypeError("Line must be greater than or equal to 1, got " + aNeedle[aLineName]);
      }
      if (aNeedle[aColumnName] < 0) {
        throw new TypeError("Column must be greater than or equal to 0, got " + aNeedle[aColumnName]);
      }
      return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
    };
    BasicSourceMapConsumer.prototype.computeColumnSpans = function SourceMapConsumer_computeColumnSpans() {
      for (var index = 0; index < this._generatedMappings.length; ++index) {
        var mapping = this._generatedMappings[index];
        if (index + 1 < this._generatedMappings.length) {
          var nextMapping = this._generatedMappings[index + 1];
          if (mapping.generatedLine === nextMapping.generatedLine) {
            mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
            continue;
          }
        }
        mapping.lastGeneratedColumn = Infinity;
      }
    };
    BasicSourceMapConsumer.prototype.originalPositionFor = function SourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(needle, this._generatedMappings, "generatedLine", "generatedColumn", util.compareByGeneratedPositionsDeflated, util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
      if (index >= 0) {
        var mapping = this._generatedMappings[index];
        if (mapping.generatedLine === needle.generatedLine) {
          var source = util.getArg(mapping, "source", null);
          if (source !== null) {
            source = this._sources.at(source);
            source = util.computeSourceURL(this.sourceRoot, source, this._sourceMapURL);
          }
          var name = util.getArg(mapping, "name", null);
          if (name !== null) {
            name = this._names.at(name);
          }
          return {
            source,
            line: util.getArg(mapping, "originalLine", null),
            column: util.getArg(mapping, "originalColumn", null),
            name
          };
        }
      }
      return {
        source: null,
        line: null,
        column: null,
        name: null
      };
    };
    BasicSourceMapConsumer.prototype.hasContentsOfAllSources = function BasicSourceMapConsumer_hasContentsOfAllSources() {
      if (!this.sourcesContent) {
        return false;
      }
      return this.sourcesContent.length >= this._sources.size() && !this.sourcesContent.some(function(sc) {
        return sc == null;
      });
    };
    BasicSourceMapConsumer.prototype.sourceContentFor = function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      if (!this.sourcesContent) {
        return null;
      }
      var index = this._findSourceIndex(aSource);
      if (index >= 0) {
        return this.sourcesContent[index];
      }
      var relativeSource = aSource;
      if (this.sourceRoot != null) {
        relativeSource = util.relative(this.sourceRoot, relativeSource);
      }
      var url;
      if (this.sourceRoot != null && (url = util.urlParse(this.sourceRoot))) {
        var fileUriAbsPath = relativeSource.replace(/^file:\/\//, "");
        if (url.scheme == "file" && this._sources.has(fileUriAbsPath)) {
          return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
        }
        if ((!url.path || url.path == "/") && this._sources.has("/" + relativeSource)) {
          return this.sourcesContent[this._sources.indexOf("/" + relativeSource)];
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + relativeSource + '" is not in the SourceMap.');
      }
    };
    BasicSourceMapConsumer.prototype.generatedPositionFor = function SourceMapConsumer_generatedPositionFor(aArgs) {
      var source = util.getArg(aArgs, "source");
      source = this._findSourceIndex(source);
      if (source < 0) {
        return {
          line: null,
          column: null,
          lastColumn: null
        };
      }
      var needle = {
        source,
        originalLine: util.getArg(aArgs, "line"),
        originalColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util.compareByOriginalPositions, util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (mapping.source === needle.source) {
          return {
            line: util.getArg(mapping, "generatedLine", null),
            column: util.getArg(mapping, "generatedColumn", null),
            lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
          };
        }
      }
      return {
        line: null,
        column: null,
        lastColumn: null
      };
    };
    exports.BasicSourceMapConsumer = BasicSourceMapConsumer;
    function IndexedSourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      var version = util.getArg(sourceMap, "version");
      var sections = util.getArg(sourceMap, "sections");
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      this._sources = new ArraySet();
      this._names = new ArraySet();
      var lastOffset = {
        line: -1,
        column: 0
      };
      this._sections = sections.map(function(s) {
        if (s.url) {
          throw new Error("Support for url field in sections not implemented.");
        }
        var offset = util.getArg(s, "offset");
        var offsetLine = util.getArg(offset, "line");
        var offsetColumn = util.getArg(offset, "column");
        if (offsetLine < lastOffset.line || offsetLine === lastOffset.line && offsetColumn < lastOffset.column) {
          throw new Error("Section offsets must be ordered and non-overlapping.");
        }
        lastOffset = offset;
        return {
          generatedOffset: {
            generatedLine: offsetLine + 1,
            generatedColumn: offsetColumn + 1
          },
          consumer: new SourceMapConsumer(util.getArg(s, "map"), aSourceMapURL)
        };
      });
    }
    IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;
    IndexedSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(IndexedSourceMapConsumer.prototype, "sources", {
      get: function() {
        var sources = [];
        for (var i = 0; i < this._sections.length; i++) {
          for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
            sources.push(this._sections[i].consumer.sources[j]);
          }
        }
        return sources;
      }
    });
    IndexedSourceMapConsumer.prototype.originalPositionFor = function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var sectionIndex = binarySearch.search(needle, this._sections, function(needle2, section2) {
        var cmp = needle2.generatedLine - section2.generatedOffset.generatedLine;
        if (cmp) {
          return cmp;
        }
        return needle2.generatedColumn - section2.generatedOffset.generatedColumn;
      });
      var section = this._sections[sectionIndex];
      if (!section) {
        return {
          source: null,
          line: null,
          column: null,
          name: null
        };
      }
      return section.consumer.originalPositionFor({
        line: needle.generatedLine - (section.generatedOffset.generatedLine - 1),
        column: needle.generatedColumn - (section.generatedOffset.generatedLine === needle.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
        bias: aArgs.bias
      });
    };
    IndexedSourceMapConsumer.prototype.hasContentsOfAllSources = function IndexedSourceMapConsumer_hasContentsOfAllSources() {
      return this._sections.every(function(s) {
        return s.consumer.hasContentsOfAllSources();
      });
    };
    IndexedSourceMapConsumer.prototype.sourceContentFor = function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var content = section.consumer.sourceContentFor(aSource, true);
        if (content) {
          return content;
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
    IndexedSourceMapConsumer.prototype.generatedPositionFor = function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        if (section.consumer._findSourceIndex(util.getArg(aArgs, "source")) === -1) {
          continue;
        }
        var generatedPosition = section.consumer.generatedPositionFor(aArgs);
        if (generatedPosition) {
          var ret = {
            line: generatedPosition.line + (section.generatedOffset.generatedLine - 1),
            column: generatedPosition.column + (section.generatedOffset.generatedLine === generatedPosition.line ? section.generatedOffset.generatedColumn - 1 : 0)
          };
          return ret;
        }
      }
      return {
        line: null,
        column: null
      };
    };
    IndexedSourceMapConsumer.prototype._parseMappings = function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      this.__generatedMappings = [];
      this.__originalMappings = [];
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var sectionMappings = section.consumer._generatedMappings;
        for (var j = 0; j < sectionMappings.length; j++) {
          var mapping = sectionMappings[j];
          var source = section.consumer._sources.at(mapping.source);
          source = util.computeSourceURL(section.consumer.sourceRoot, source, this._sourceMapURL);
          this._sources.add(source);
          source = this._sources.indexOf(source);
          var name = null;
          if (mapping.name) {
            name = section.consumer._names.at(mapping.name);
            this._names.add(name);
            name = this._names.indexOf(name);
          }
          var adjustedMapping = {
            source,
            generatedLine: mapping.generatedLine + (section.generatedOffset.generatedLine - 1),
            generatedColumn: mapping.generatedColumn + (section.generatedOffset.generatedLine === mapping.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
            originalLine: mapping.originalLine,
            originalColumn: mapping.originalColumn,
            name
          };
          this.__generatedMappings.push(adjustedMapping);
          if (typeof adjustedMapping.originalLine === "number") {
            this.__originalMappings.push(adjustedMapping);
          }
        }
      }
      quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
      quickSort(this.__originalMappings, util.compareByOriginalPositions);
    };
    exports.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/source-node.js
var require_source_node = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/lib/source-node.js"(exports) {
    var SourceMapGenerator = require_source_map_generator().SourceMapGenerator;
    var util = require_util();
    var REGEX_NEWLINE = /(\r?\n)/;
    var NEWLINE_CODE = 10;
    var isSourceNode = "$$$isSourceNode$$$";
    function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
      this.children = [];
      this.sourceContents = {};
      this.line = aLine == null ? null : aLine;
      this.column = aColumn == null ? null : aColumn;
      this.source = aSource == null ? null : aSource;
      this.name = aName == null ? null : aName;
      this[isSourceNode] = true;
      if (aChunks != null)
        this.add(aChunks);
    }
    SourceNode.fromStringWithSourceMap = function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
      var node = new SourceNode();
      var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
      var remainingLinesIndex = 0;
      var shiftNextLine = function() {
        var lineContents = getNextLine();
        var newLine = getNextLine() || "";
        return lineContents + newLine;
        function getNextLine() {
          return remainingLinesIndex < remainingLines.length ? remainingLines[remainingLinesIndex++] : void 0;
        }
      };
      var lastGeneratedLine = 1, lastGeneratedColumn = 0;
      var lastMapping = null;
      aSourceMapConsumer.eachMapping(function(mapping) {
        if (lastMapping !== null) {
          if (lastGeneratedLine < mapping.generatedLine) {
            addMappingWithCode(lastMapping, shiftNextLine());
            lastGeneratedLine++;
            lastGeneratedColumn = 0;
          } else {
            var nextLine = remainingLines[remainingLinesIndex] || "";
            var code = nextLine.substr(0, mapping.generatedColumn - lastGeneratedColumn);
            remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn - lastGeneratedColumn);
            lastGeneratedColumn = mapping.generatedColumn;
            addMappingWithCode(lastMapping, code);
            lastMapping = mapping;
            return;
          }
        }
        while (lastGeneratedLine < mapping.generatedLine) {
          node.add(shiftNextLine());
          lastGeneratedLine++;
        }
        if (lastGeneratedColumn < mapping.generatedColumn) {
          var nextLine = remainingLines[remainingLinesIndex] || "";
          node.add(nextLine.substr(0, mapping.generatedColumn));
          remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
          lastGeneratedColumn = mapping.generatedColumn;
        }
        lastMapping = mapping;
      }, this);
      if (remainingLinesIndex < remainingLines.length) {
        if (lastMapping) {
          addMappingWithCode(lastMapping, shiftNextLine());
        }
        node.add(remainingLines.splice(remainingLinesIndex).join(""));
      }
      aSourceMapConsumer.sources.forEach(function(sourceFile) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          if (aRelativePath != null) {
            sourceFile = util.join(aRelativePath, sourceFile);
          }
          node.setSourceContent(sourceFile, content);
        }
      });
      return node;
      function addMappingWithCode(mapping, code) {
        if (mapping === null || mapping.source === void 0) {
          node.add(code);
        } else {
          var source = aRelativePath ? util.join(aRelativePath, mapping.source) : mapping.source;
          node.add(new SourceNode(mapping.originalLine, mapping.originalColumn, source, code, mapping.name));
        }
      }
    };
    SourceNode.prototype.add = function SourceNode_add(aChunk) {
      if (Array.isArray(aChunk)) {
        aChunk.forEach(function(chunk) {
          this.add(chunk);
        }, this);
      } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
        if (aChunk) {
          this.children.push(aChunk);
        }
      } else {
        throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
      }
      return this;
    };
    SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
      if (Array.isArray(aChunk)) {
        for (var i = aChunk.length - 1; i >= 0; i--) {
          this.prepend(aChunk[i]);
        }
      } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
        this.children.unshift(aChunk);
      } else {
        throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
      }
      return this;
    };
    SourceNode.prototype.walk = function SourceNode_walk(aFn) {
      var chunk;
      for (var i = 0, len = this.children.length; i < len; i++) {
        chunk = this.children[i];
        if (chunk[isSourceNode]) {
          chunk.walk(aFn);
        } else {
          if (chunk !== "") {
            aFn(chunk, {
              source: this.source,
              line: this.line,
              column: this.column,
              name: this.name
            });
          }
        }
      }
    };
    SourceNode.prototype.join = function SourceNode_join(aSep) {
      var newChildren;
      var i;
      var len = this.children.length;
      if (len > 0) {
        newChildren = [];
        for (i = 0; i < len - 1; i++) {
          newChildren.push(this.children[i]);
          newChildren.push(aSep);
        }
        newChildren.push(this.children[i]);
        this.children = newChildren;
      }
      return this;
    };
    SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
      var lastChild = this.children[this.children.length - 1];
      if (lastChild[isSourceNode]) {
        lastChild.replaceRight(aPattern, aReplacement);
      } else if (typeof lastChild === "string") {
        this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
      } else {
        this.children.push("".replace(aPattern, aReplacement));
      }
      return this;
    };
    SourceNode.prototype.setSourceContent = function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
      this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
    };
    SourceNode.prototype.walkSourceContents = function SourceNode_walkSourceContents(aFn) {
      for (var i = 0, len = this.children.length; i < len; i++) {
        if (this.children[i][isSourceNode]) {
          this.children[i].walkSourceContents(aFn);
        }
      }
      var sources = Object.keys(this.sourceContents);
      for (var i = 0, len = sources.length; i < len; i++) {
        aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
      }
    };
    SourceNode.prototype.toString = function SourceNode_toString() {
      var str2 = "";
      this.walk(function(chunk) {
        str2 += chunk;
      });
      return str2;
    };
    SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
      var generated = {
        code: "",
        line: 1,
        column: 0
      };
      var map2 = new SourceMapGenerator(aArgs);
      var sourceMappingActive = false;
      var lastOriginalSource = null;
      var lastOriginalLine = null;
      var lastOriginalColumn = null;
      var lastOriginalName = null;
      this.walk(function(chunk, original) {
        generated.code += chunk;
        if (original.source !== null && original.line !== null && original.column !== null) {
          if (lastOriginalSource !== original.source || lastOriginalLine !== original.line || lastOriginalColumn !== original.column || lastOriginalName !== original.name) {
            map2.addMapping({
              source: original.source,
              original: {
                line: original.line,
                column: original.column
              },
              generated: {
                line: generated.line,
                column: generated.column
              },
              name: original.name
            });
          }
          lastOriginalSource = original.source;
          lastOriginalLine = original.line;
          lastOriginalColumn = original.column;
          lastOriginalName = original.name;
          sourceMappingActive = true;
        } else if (sourceMappingActive) {
          map2.addMapping({
            generated: {
              line: generated.line,
              column: generated.column
            }
          });
          lastOriginalSource = null;
          sourceMappingActive = false;
        }
        for (var idx2 = 0, length = chunk.length; idx2 < length; idx2++) {
          if (chunk.charCodeAt(idx2) === NEWLINE_CODE) {
            generated.line++;
            generated.column = 0;
            if (idx2 + 1 === length) {
              lastOriginalSource = null;
              sourceMappingActive = false;
            } else if (sourceMappingActive) {
              map2.addMapping({
                source: original.source,
                original: {
                  line: original.line,
                  column: original.column
                },
                generated: {
                  line: generated.line,
                  column: generated.column
                },
                name: original.name
              });
            }
          } else {
            generated.column++;
          }
        }
      });
      this.walkSourceContents(function(sourceFile, sourceContent) {
        map2.setSourceContent(sourceFile, sourceContent);
      });
      return { code: generated.code, map: map2 };
    };
    exports.SourceNode = SourceNode;
  }
});

// node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/source-map.js
var require_source_map = __commonJS({
  "node_modules/.pnpm/source-map@0.6.1/node_modules/source-map/source-map.js"(exports) {
    exports.SourceMapGenerator = require_source_map_generator().SourceMapGenerator;
    exports.SourceMapConsumer = require_source_map_consumer().SourceMapConsumer;
    exports.SourceNode = require_source_node().SourceNode;
  }
});

// node_modules/.pnpm/buffer-from@1.1.2/node_modules/buffer-from/index.js
var require_buffer_from = __commonJS({
  "node_modules/.pnpm/buffer-from@1.1.2/node_modules/buffer-from/index.js"(exports, module2) {
    var toString2 = Object.prototype.toString;
    var isModern = typeof Buffer !== "undefined" && typeof Buffer.alloc === "function" && typeof Buffer.allocUnsafe === "function" && typeof Buffer.from === "function";
    function isArrayBuffer(input) {
      return toString2.call(input).slice(8, -1) === "ArrayBuffer";
    }
    function fromArrayBuffer(obj, byteOffset, length) {
      byteOffset >>>= 0;
      var maxLength = obj.byteLength - byteOffset;
      if (maxLength < 0) {
        throw new RangeError("'offset' is out of bounds");
      }
      if (length === void 0) {
        length = maxLength;
      } else {
        length >>>= 0;
        if (length > maxLength) {
          throw new RangeError("'length' is out of bounds");
        }
      }
      return isModern ? Buffer.from(obj.slice(byteOffset, byteOffset + length)) : new Buffer(new Uint8Array(obj.slice(byteOffset, byteOffset + length)));
    }
    function fromString(string2, encoding) {
      if (typeof encoding !== "string" || encoding === "") {
        encoding = "utf8";
      }
      if (!Buffer.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding');
      }
      return isModern ? Buffer.from(string2, encoding) : new Buffer(string2, encoding);
    }
    function bufferFrom(value, encodingOrOffset, length) {
      if (typeof value === "number") {
        throw new TypeError('"value" argument must not be a number');
      }
      if (isArrayBuffer(value)) {
        return fromArrayBuffer(value, encodingOrOffset, length);
      }
      if (typeof value === "string") {
        return fromString(value, encodingOrOffset);
      }
      return isModern ? Buffer.from(value) : new Buffer(value);
    }
    module2.exports = bufferFrom;
  }
});

// node_modules/.pnpm/source-map-support@0.5.21/node_modules/source-map-support/source-map-support.js
var require_source_map_support = __commonJS({
  "node_modules/.pnpm/source-map-support@0.5.21/node_modules/source-map-support/source-map-support.js"(exports, module2) {
    var SourceMapConsumer = require_source_map().SourceMapConsumer;
    var path2 = require("path");
    var fs4;
    try {
      fs4 = require("fs");
      if (!fs4.existsSync || !fs4.readFileSync) {
        fs4 = null;
      }
    } catch (err) {
    }
    var bufferFrom = require_buffer_from();
    function dynamicRequire(mod, request) {
      return mod.require(request);
    }
    var errorFormatterInstalled = false;
    var uncaughtShimInstalled = false;
    var emptyCacheBetweenOperations = false;
    var environment = "auto";
    var fileContentsCache = {};
    var sourceMapCache = {};
    var reSourceMap = /^data:application\/json[^,]+base64,/;
    var retrieveFileHandlers = [];
    var retrieveMapHandlers = [];
    function isInBrowser() {
      if (environment === "browser")
        return true;
      if (environment === "node")
        return false;
      return typeof window !== "undefined" && typeof XMLHttpRequest === "function" && !(window.require && window.module && window.process && window.process.type === "renderer");
    }
    function hasGlobalProcessEventEmitter() {
      return typeof process === "object" && process !== null && typeof process.on === "function";
    }
    function globalProcessVersion() {
      if (typeof process === "object" && process !== null) {
        return process.version;
      } else {
        return "";
      }
    }
    function globalProcessStderr() {
      if (typeof process === "object" && process !== null) {
        return process.stderr;
      }
    }
    function globalProcessExit(code) {
      if (typeof process === "object" && process !== null && typeof process.exit === "function") {
        return process.exit(code);
      }
    }
    function handlerExec(list) {
      return function(arg) {
        for (var i = 0; i < list.length; i++) {
          var ret = list[i](arg);
          if (ret) {
            return ret;
          }
        }
        return null;
      };
    }
    var retrieveFile = handlerExec(retrieveFileHandlers);
    retrieveFileHandlers.push(function(path3) {
      path3 = path3.trim();
      if (/^file:/.test(path3)) {
        path3 = path3.replace(/file:\/\/\/(\w:)?/, function(protocol, drive) {
          return drive ? "" : "/";
        });
      }
      if (path3 in fileContentsCache) {
        return fileContentsCache[path3];
      }
      var contents = "";
      try {
        if (!fs4) {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", path3, false);
          xhr.send(null);
          if (xhr.readyState === 4 && xhr.status === 200) {
            contents = xhr.responseText;
          }
        } else if (fs4.existsSync(path3)) {
          contents = fs4.readFileSync(path3, "utf8");
        }
      } catch (er) {
      }
      return fileContentsCache[path3] = contents;
    });
    function supportRelativeURL(file, url) {
      if (!file)
        return url;
      var dir = path2.dirname(file);
      var match = /^\w+:\/\/[^\/]*/.exec(dir);
      var protocol = match ? match[0] : "";
      var startPath = dir.slice(protocol.length);
      if (protocol && /^\/\w\:/.test(startPath)) {
        protocol += "/";
        return protocol + path2.resolve(dir.slice(protocol.length), url).replace(/\\/g, "/");
      }
      return protocol + path2.resolve(dir.slice(protocol.length), url);
    }
    function retrieveSourceMapURL(source) {
      var fileData;
      if (isInBrowser()) {
        try {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", source, false);
          xhr.send(null);
          fileData = xhr.readyState === 4 ? xhr.responseText : null;
          var sourceMapHeader = xhr.getResponseHeader("SourceMap") || xhr.getResponseHeader("X-SourceMap");
          if (sourceMapHeader) {
            return sourceMapHeader;
          }
        } catch (e) {
        }
      }
      fileData = retrieveFile(source);
      var re = /(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/mg;
      var lastMatch, match;
      while (match = re.exec(fileData))
        lastMatch = match;
      if (!lastMatch)
        return null;
      return lastMatch[1];
    }
    var retrieveSourceMap = handlerExec(retrieveMapHandlers);
    retrieveMapHandlers.push(function(source) {
      var sourceMappingURL = retrieveSourceMapURL(source);
      if (!sourceMappingURL)
        return null;
      var sourceMapData;
      if (reSourceMap.test(sourceMappingURL)) {
        var rawData = sourceMappingURL.slice(sourceMappingURL.indexOf(",") + 1);
        sourceMapData = bufferFrom(rawData, "base64").toString();
        sourceMappingURL = source;
      } else {
        sourceMappingURL = supportRelativeURL(source, sourceMappingURL);
        sourceMapData = retrieveFile(sourceMappingURL);
      }
      if (!sourceMapData) {
        return null;
      }
      return {
        url: sourceMappingURL,
        map: sourceMapData
      };
    });
    function mapSourcePosition(position) {
      var sourceMap = sourceMapCache[position.source];
      if (!sourceMap) {
        var urlAndMap = retrieveSourceMap(position.source);
        if (urlAndMap) {
          sourceMap = sourceMapCache[position.source] = {
            url: urlAndMap.url,
            map: new SourceMapConsumer(urlAndMap.map)
          };
          if (sourceMap.map.sourcesContent) {
            sourceMap.map.sources.forEach(function(source, i) {
              var contents = sourceMap.map.sourcesContent[i];
              if (contents) {
                var url = supportRelativeURL(sourceMap.url, source);
                fileContentsCache[url] = contents;
              }
            });
          }
        } else {
          sourceMap = sourceMapCache[position.source] = {
            url: null,
            map: null
          };
        }
      }
      if (sourceMap && sourceMap.map && typeof sourceMap.map.originalPositionFor === "function") {
        var originalPosition = sourceMap.map.originalPositionFor(position);
        if (originalPosition.source !== null) {
          originalPosition.source = supportRelativeURL(sourceMap.url, originalPosition.source);
          return originalPosition;
        }
      }
      return position;
    }
    function mapEvalOrigin(origin) {
      var match = /^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(origin);
      if (match) {
        var position = mapSourcePosition({
          source: match[2],
          line: +match[3],
          column: match[4] - 1
        });
        return "eval at " + match[1] + " (" + position.source + ":" + position.line + ":" + (position.column + 1) + ")";
      }
      match = /^eval at ([^(]+) \((.+)\)$/.exec(origin);
      if (match) {
        return "eval at " + match[1] + " (" + mapEvalOrigin(match[2]) + ")";
      }
      return origin;
    }
    function CallSiteToString() {
      var fileName2;
      var fileLocation = "";
      if (this.isNative()) {
        fileLocation = "native";
      } else {
        fileName2 = this.getScriptNameOrSourceURL();
        if (!fileName2 && this.isEval()) {
          fileLocation = this.getEvalOrigin();
          fileLocation += ", ";
        }
        if (fileName2) {
          fileLocation += fileName2;
        } else {
          fileLocation += "<anonymous>";
        }
        var lineNumber = this.getLineNumber();
        if (lineNumber != null) {
          fileLocation += ":" + lineNumber;
          var columnNumber = this.getColumnNumber();
          if (columnNumber) {
            fileLocation += ":" + columnNumber;
          }
        }
      }
      var line = "";
      var functionName = this.getFunctionName();
      var addSuffix = true;
      var isConstructor = this.isConstructor();
      var isMethodCall = !(this.isToplevel() || isConstructor);
      if (isMethodCall) {
        var typeName = this.getTypeName();
        if (typeName === "[object Object]") {
          typeName = "null";
        }
        var methodName = this.getMethodName();
        if (functionName) {
          if (typeName && functionName.indexOf(typeName) != 0) {
            line += typeName + ".";
          }
          line += functionName;
          if (methodName && functionName.indexOf("." + methodName) != functionName.length - methodName.length - 1) {
            line += " [as " + methodName + "]";
          }
        } else {
          line += typeName + "." + (methodName || "<anonymous>");
        }
      } else if (isConstructor) {
        line += "new " + (functionName || "<anonymous>");
      } else if (functionName) {
        line += functionName;
      } else {
        line += fileLocation;
        addSuffix = false;
      }
      if (addSuffix) {
        line += " (" + fileLocation + ")";
      }
      return line;
    }
    function cloneCallSite(frame) {
      var object2 = {};
      Object.getOwnPropertyNames(Object.getPrototypeOf(frame)).forEach(function(name) {
        object2[name] = /^(?:is|get)/.test(name) ? function() {
          return frame[name].call(frame);
        } : frame[name];
      });
      object2.toString = CallSiteToString;
      return object2;
    }
    function wrapCallSite(frame, state) {
      if (state === void 0) {
        state = { nextPosition: null, curPosition: null };
      }
      if (frame.isNative()) {
        state.curPosition = null;
        return frame;
      }
      var source = frame.getFileName() || frame.getScriptNameOrSourceURL();
      if (source) {
        var line = frame.getLineNumber();
        var column = frame.getColumnNumber() - 1;
        var noHeader = /^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/;
        var headerLength = noHeader.test(globalProcessVersion()) ? 0 : 62;
        if (line === 1 && column > headerLength && !isInBrowser() && !frame.isEval()) {
          column -= headerLength;
        }
        var position = mapSourcePosition({
          source,
          line,
          column
        });
        state.curPosition = position;
        frame = cloneCallSite(frame);
        var originalFunctionName = frame.getFunctionName;
        frame.getFunctionName = function() {
          if (state.nextPosition == null) {
            return originalFunctionName();
          }
          return state.nextPosition.name || originalFunctionName();
        };
        frame.getFileName = function() {
          return position.source;
        };
        frame.getLineNumber = function() {
          return position.line;
        };
        frame.getColumnNumber = function() {
          return position.column + 1;
        };
        frame.getScriptNameOrSourceURL = function() {
          return position.source;
        };
        return frame;
      }
      var origin = frame.isEval() && frame.getEvalOrigin();
      if (origin) {
        origin = mapEvalOrigin(origin);
        frame = cloneCallSite(frame);
        frame.getEvalOrigin = function() {
          return origin;
        };
        return frame;
      }
      return frame;
    }
    function prepareStackTrace(error, stack) {
      if (emptyCacheBetweenOperations) {
        fileContentsCache = {};
        sourceMapCache = {};
      }
      var name = error.name || "Error";
      var message = error.message || "";
      var errorString = name + ": " + message;
      var state = { nextPosition: null, curPosition: null };
      var processedStack = [];
      for (var i = stack.length - 1; i >= 0; i--) {
        processedStack.push("\n    at " + wrapCallSite(stack[i], state));
        state.nextPosition = state.curPosition;
      }
      state.curPosition = state.nextPosition = null;
      return errorString + processedStack.reverse().join("");
    }
    function getErrorSource(error) {
      var match = /\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(error.stack);
      if (match) {
        var source = match[1];
        var line = +match[2];
        var column = +match[3];
        var contents = fileContentsCache[source];
        if (!contents && fs4 && fs4.existsSync(source)) {
          try {
            contents = fs4.readFileSync(source, "utf8");
          } catch (er) {
            contents = "";
          }
        }
        if (contents) {
          var code = contents.split(/(?:\r\n|\r|\n)/)[line - 1];
          if (code) {
            return source + ":" + line + "\n" + code + "\n" + new Array(column).join(" ") + "^";
          }
        }
      }
      return null;
    }
    function printErrorAndExit(error) {
      var source = getErrorSource(error);
      var stderr = globalProcessStderr();
      if (stderr && stderr._handle && stderr._handle.setBlocking) {
        stderr._handle.setBlocking(true);
      }
      if (source) {
        console.error();
        console.error(source);
      }
      console.error(error.stack);
      globalProcessExit(1);
    }
    function shimEmitUncaughtException() {
      var origEmit = process.emit;
      process.emit = function(type2) {
        if (type2 === "uncaughtException") {
          var hasStack = arguments[1] && arguments[1].stack;
          var hasListeners = this.listeners(type2).length > 0;
          if (hasStack && !hasListeners) {
            return printErrorAndExit(arguments[1]);
          }
        }
        return origEmit.apply(this, arguments);
      };
    }
    var originalRetrieveFileHandlers = retrieveFileHandlers.slice(0);
    var originalRetrieveMapHandlers = retrieveMapHandlers.slice(0);
    exports.wrapCallSite = wrapCallSite;
    exports.getErrorSource = getErrorSource;
    exports.mapSourcePosition = mapSourcePosition;
    exports.retrieveSourceMap = retrieveSourceMap;
    exports.install = function(options) {
      options = options || {};
      if (options.environment) {
        environment = options.environment;
        if (["node", "browser", "auto"].indexOf(environment) === -1) {
          throw new Error("environment " + environment + " was unknown. Available options are {auto, browser, node}");
        }
      }
      if (options.retrieveFile) {
        if (options.overrideRetrieveFile) {
          retrieveFileHandlers.length = 0;
        }
        retrieveFileHandlers.unshift(options.retrieveFile);
      }
      if (options.retrieveSourceMap) {
        if (options.overrideRetrieveSourceMap) {
          retrieveMapHandlers.length = 0;
        }
        retrieveMapHandlers.unshift(options.retrieveSourceMap);
      }
      if (options.hookRequire && !isInBrowser()) {
        var Module = dynamicRequire(module2, "module");
        var $compile = Module.prototype._compile;
        if (!$compile.__sourceMapSupport) {
          Module.prototype._compile = function(content, filename) {
            fileContentsCache[filename] = content;
            sourceMapCache[filename] = void 0;
            return $compile.call(this, content, filename);
          };
          Module.prototype._compile.__sourceMapSupport = true;
        }
      }
      if (!emptyCacheBetweenOperations) {
        emptyCacheBetweenOperations = "emptyCacheBetweenOperations" in options ? options.emptyCacheBetweenOperations : false;
      }
      if (!errorFormatterInstalled) {
        errorFormatterInstalled = true;
        Error.prepareStackTrace = prepareStackTrace;
      }
      if (!uncaughtShimInstalled) {
        var installHandler = "handleUncaughtExceptions" in options ? options.handleUncaughtExceptions : true;
        try {
          var worker_threads = dynamicRequire(module2, "worker_threads");
          if (worker_threads.isMainThread === false) {
            installHandler = false;
          }
        } catch (e) {
        }
        if (installHandler && hasGlobalProcessEventEmitter()) {
          uncaughtShimInstalled = true;
          shimEmitUncaughtException();
        }
      }
    };
    exports.resetRetrieveHandlers = function() {
      retrieveFileHandlers.length = 0;
      retrieveMapHandlers.length = 0;
      retrieveFileHandlers = originalRetrieveFileHandlers.slice(0);
      retrieveMapHandlers = originalRetrieveMapHandlers.slice(0);
      retrieveSourceMap = handlerExec(retrieveMapHandlers);
      retrieveFile = handlerExec(retrieveFileHandlers);
    };
  }
});

// node_modules/.pnpm/typescript@4.7.4/node_modules/typescript/lib/typescript.js
var require_typescript = __commonJS({
  "node_modules/.pnpm/typescript@4.7.4/node_modules/typescript/lib/typescript.js"(exports, module2) {
    "use strict";
    var __spreadArray = exports && exports.__spreadArray || function(to, from, pack) {
      if (pack || arguments.length === 2)
        for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
            if (!ar)
              ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
          }
        }
      return to.concat(ar || Array.prototype.slice.call(from));
    };
    var __assign = exports && exports.__assign || function() {
      __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p))
              t[p] = s[p];
        }
        return t;
      };
      return __assign.apply(this, arguments);
    };
    var __makeTemplateObject = exports && exports.__makeTemplateObject || function(cooked, raw) {
      if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
      } else {
        cooked.raw = raw;
      }
      return cooked;
    };
    var __generator = exports && exports.__generator || function(thisArg, body) {
      var _ = { label: 0, sent: function() {
        if (t[0] & 1)
          throw t[1];
        return t[1];
      }, trys: [], ops: [] }, f, y, t, g;
      return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
      }), g;
      function verb(n) {
        return function(v) {
          return step([n, v]);
        };
      }
      function step(op) {
        if (f)
          throw new TypeError("Generator is already executing.");
        while (_)
          try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
              return t;
            if (y = 0, t)
              op = [op[0] & 2, t.value];
            switch (op[0]) {
              case 0:
              case 1:
                t = op;
                break;
              case 4:
                _.label++;
                return { value: op[1], done: false };
              case 5:
                _.label++;
                y = op[1];
                op = [0];
                continue;
              case 7:
                op = _.ops.pop();
                _.trys.pop();
                continue;
              default:
                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                  _ = 0;
                  continue;
                }
                if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                  _.label = op[1];
                  break;
                }
                if (op[0] === 6 && _.label < t[1]) {
                  _.label = t[1];
                  t = op;
                  break;
                }
                if (t && _.label < t[2]) {
                  _.label = t[2];
                  _.ops.push(op);
                  break;
                }
                if (t[2])
                  _.ops.pop();
                _.trys.pop();
                continue;
            }
            op = body.call(thisArg, _);
          } catch (e) {
            op = [6, e];
            y = 0;
          } finally {
            f = t = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
      }
    };
    var __rest = exports && exports.__rest || function(s, e) {
      var t = {};
      for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
          t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    var __extends = exports && exports.__extends || function() {
      var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
          d2.__proto__ = b2;
        } || function(d2, b2) {
          for (var p in b2)
            if (Object.prototype.hasOwnProperty.call(b2, p))
              d2[p] = b2[p];
        };
        return extendStatics(d, b);
      };
      return function(d, b) {
        if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() {
          this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
      };
    }();
    var ts2;
    (function(ts3) {
      function createMapData() {
        var sentinel = {};
        sentinel.prev = sentinel;
        return { head: sentinel, tail: sentinel, size: 0 };
      }
      function createMapEntry(key, value) {
        return { key, value, next: void 0, prev: void 0 };
      }
      function sameValueZero(x, y) {
        return x === y || x !== x && y !== y;
      }
      function getPrev(entry) {
        var prev = entry.prev;
        if (!prev || prev === entry)
          throw new Error("Illegal state");
        return prev;
      }
      function getNext(entry) {
        while (entry) {
          var skipNext = !entry.prev;
          entry = entry.next;
          if (skipNext) {
            continue;
          }
          return entry;
        }
      }
      function getEntry(data, key) {
        for (var entry = data.tail; entry !== data.head; entry = getPrev(entry)) {
          if (sameValueZero(entry.key, key)) {
            return entry;
          }
        }
      }
      function addOrUpdateEntry(data, key, value) {
        var existing = getEntry(data, key);
        if (existing) {
          existing.value = value;
          return;
        }
        var entry = createMapEntry(key, value);
        entry.prev = data.tail;
        data.tail.next = entry;
        data.tail = entry;
        data.size++;
        return entry;
      }
      function deleteEntry(data, key) {
        for (var entry = data.tail; entry !== data.head; entry = getPrev(entry)) {
          if (entry.prev === void 0)
            throw new Error("Illegal state");
          if (sameValueZero(entry.key, key)) {
            if (entry.next) {
              entry.next.prev = entry.prev;
            } else {
              if (data.tail !== entry)
                throw new Error("Illegal state");
              data.tail = entry.prev;
            }
            entry.prev.next = entry.next;
            entry.next = entry.prev;
            entry.prev = void 0;
            data.size--;
            return entry;
          }
        }
      }
      function clearEntries(data) {
        var node = data.tail;
        while (node !== data.head) {
          var prev = getPrev(node);
          node.next = data.head;
          node.prev = void 0;
          node = prev;
        }
        data.head.next = void 0;
        data.tail = data.head;
        data.size = 0;
      }
      function forEachEntry(data, action) {
        var entry = data.head;
        while (entry) {
          entry = getNext(entry);
          if (entry) {
            action(entry.value, entry.key);
          }
        }
      }
      function forEachIteration(iterator, action) {
        if (iterator) {
          for (var step = iterator.next(); !step.done; step = iterator.next()) {
            action(step.value);
          }
        }
      }
      function createIteratorData(data, selector) {
        return { current: data.head, selector };
      }
      function iteratorNext(data) {
        data.current = getNext(data.current);
        if (data.current) {
          return { value: data.selector(data.current.key, data.current.value), done: false };
        } else {
          return { value: void 0, done: true };
        }
      }
      var ShimCollections;
      (function(ShimCollections2) {
        function createMapShim(getIterator) {
          var MapIterator = function() {
            function MapIterator2(data, selector) {
              this._data = createIteratorData(data, selector);
            }
            MapIterator2.prototype.next = function() {
              return iteratorNext(this._data);
            };
            return MapIterator2;
          }();
          return function() {
            function Map2(iterable) {
              var _this = this;
              this._mapData = createMapData();
              forEachIteration(getIterator(iterable), function(_a) {
                var key = _a[0], value = _a[1];
                return _this.set(key, value);
              });
            }
            Object.defineProperty(Map2.prototype, "size", {
              get: function() {
                return this._mapData.size;
              },
              enumerable: false,
              configurable: true
            });
            Map2.prototype.get = function(key) {
              var _a;
              return (_a = getEntry(this._mapData, key)) === null || _a === void 0 ? void 0 : _a.value;
            };
            Map2.prototype.set = function(key, value) {
              return addOrUpdateEntry(this._mapData, key, value), this;
            };
            Map2.prototype.has = function(key) {
              return !!getEntry(this._mapData, key);
            };
            Map2.prototype.delete = function(key) {
              return !!deleteEntry(this._mapData, key);
            };
            Map2.prototype.clear = function() {
              clearEntries(this._mapData);
            };
            Map2.prototype.keys = function() {
              return new MapIterator(this._mapData, function(key, _value) {
                return key;
              });
            };
            Map2.prototype.values = function() {
              return new MapIterator(this._mapData, function(_key, value) {
                return value;
              });
            };
            Map2.prototype.entries = function() {
              return new MapIterator(this._mapData, function(key, value) {
                return [key, value];
              });
            };
            Map2.prototype.forEach = function(action) {
              forEachEntry(this._mapData, action);
            };
            return Map2;
          }();
        }
        ShimCollections2.createMapShim = createMapShim;
        function createSetShim(getIterator) {
          var SetIterator = function() {
            function SetIterator2(data, selector) {
              this._data = createIteratorData(data, selector);
            }
            SetIterator2.prototype.next = function() {
              return iteratorNext(this._data);
            };
            return SetIterator2;
          }();
          return function() {
            function Set2(iterable) {
              var _this = this;
              this._mapData = createMapData();
              forEachIteration(getIterator(iterable), function(value) {
                return _this.add(value);
              });
            }
            Object.defineProperty(Set2.prototype, "size", {
              get: function() {
                return this._mapData.size;
              },
              enumerable: false,
              configurable: true
            });
            Set2.prototype.add = function(value) {
              return addOrUpdateEntry(this._mapData, value, value), this;
            };
            Set2.prototype.has = function(value) {
              return !!getEntry(this._mapData, value);
            };
            Set2.prototype.delete = function(value) {
              return !!deleteEntry(this._mapData, value);
            };
            Set2.prototype.clear = function() {
              clearEntries(this._mapData);
            };
            Set2.prototype.keys = function() {
              return new SetIterator(this._mapData, function(key, _value) {
                return key;
              });
            };
            Set2.prototype.values = function() {
              return new SetIterator(this._mapData, function(_key, value) {
                return value;
              });
            };
            Set2.prototype.entries = function() {
              return new SetIterator(this._mapData, function(key, value) {
                return [key, value];
              });
            };
            Set2.prototype.forEach = function(action) {
              forEachEntry(this._mapData, action);
            };
            return Set2;
          }();
        }
        ShimCollections2.createSetShim = createSetShim;
      })(ShimCollections = ts3.ShimCollections || (ts3.ShimCollections = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.versionMajorMinor = "4.7";
      ts3.version = "4.7.4";
      var Comparison;
      (function(Comparison2) {
        Comparison2[Comparison2["LessThan"] = -1] = "LessThan";
        Comparison2[Comparison2["EqualTo"] = 0] = "EqualTo";
        Comparison2[Comparison2["GreaterThan"] = 1] = "GreaterThan";
      })(Comparison = ts3.Comparison || (ts3.Comparison = {}));
      var NativeCollections;
      (function(NativeCollections2) {
        var globals = typeof globalThis !== "undefined" ? globalThis : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : void 0;
        function tryGetNativeMap() {
          var gMap = globals === null || globals === void 0 ? void 0 : globals.Map;
          return typeof gMap !== "undefined" && "entries" in gMap.prototype && new gMap([[0, 0]]).size === 1 ? gMap : void 0;
        }
        NativeCollections2.tryGetNativeMap = tryGetNativeMap;
        function tryGetNativeSet() {
          var gSet = globals === null || globals === void 0 ? void 0 : globals.Set;
          return typeof gSet !== "undefined" && "entries" in gSet.prototype && new gSet([0]).size === 1 ? gSet : void 0;
        }
        NativeCollections2.tryGetNativeSet = tryGetNativeSet;
      })(NativeCollections || (NativeCollections = {}));
      ts3.Map = getCollectionImplementation("Map", "tryGetNativeMap", "createMapShim");
      ts3.Set = getCollectionImplementation("Set", "tryGetNativeSet", "createSetShim");
      function getCollectionImplementation(name, nativeFactory, shimFactory) {
        var _a;
        var constructor = (_a = NativeCollections[nativeFactory]()) !== null && _a !== void 0 ? _a : ts3.ShimCollections === null || ts3.ShimCollections === void 0 ? void 0 : ts3.ShimCollections[shimFactory](ts3.getIterator);
        if (constructor)
          return constructor;
        throw new Error("TypeScript requires an environment that provides a compatible native ".concat(name, " implementation."));
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getIterator(iterable) {
        if (iterable) {
          if (isArray(iterable))
            return arrayIterator(iterable);
          if (iterable instanceof ts3.Map)
            return iterable.entries();
          if (iterable instanceof ts3.Set)
            return iterable.values();
          throw new Error("Iteration not supported.");
        }
      }
      ts3.getIterator = getIterator;
      ts3.emptyArray = [];
      ts3.emptyMap = new ts3.Map();
      ts3.emptySet = new ts3.Set();
      function length(array) {
        return array ? array.length : 0;
      }
      ts3.length = length;
      function forEach(array, callback) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var result2 = callback(array[i], i);
            if (result2) {
              return result2;
            }
          }
        }
        return void 0;
      }
      ts3.forEach = forEach;
      function forEachRight(array, callback) {
        if (array) {
          for (var i = array.length - 1; i >= 0; i--) {
            var result2 = callback(array[i], i);
            if (result2) {
              return result2;
            }
          }
        }
        return void 0;
      }
      ts3.forEachRight = forEachRight;
      function firstDefined(array, callback) {
        if (array === void 0) {
          return void 0;
        }
        for (var i = 0; i < array.length; i++) {
          var result2 = callback(array[i], i);
          if (result2 !== void 0) {
            return result2;
          }
        }
        return void 0;
      }
      ts3.firstDefined = firstDefined;
      function firstDefinedIterator(iter, callback) {
        while (true) {
          var iterResult = iter.next();
          if (iterResult.done) {
            return void 0;
          }
          var result2 = callback(iterResult.value);
          if (result2 !== void 0) {
            return result2;
          }
        }
      }
      ts3.firstDefinedIterator = firstDefinedIterator;
      function reduceLeftIterator(iterator, f, initial) {
        var result2 = initial;
        if (iterator) {
          for (var step = iterator.next(), pos = 0; !step.done; step = iterator.next(), pos++) {
            result2 = f(result2, step.value, pos);
          }
        }
        return result2;
      }
      ts3.reduceLeftIterator = reduceLeftIterator;
      function zipWith(arrayA, arrayB, callback) {
        var result2 = [];
        ts3.Debug.assertEqual(arrayA.length, arrayB.length);
        for (var i = 0; i < arrayA.length; i++) {
          result2.push(callback(arrayA[i], arrayB[i], i));
        }
        return result2;
      }
      ts3.zipWith = zipWith;
      function zipToIterator(arrayA, arrayB) {
        ts3.Debug.assertEqual(arrayA.length, arrayB.length);
        var i = 0;
        return {
          next: function() {
            if (i === arrayA.length) {
              return { value: void 0, done: true };
            }
            i++;
            return { value: [arrayA[i - 1], arrayB[i - 1]], done: false };
          }
        };
      }
      ts3.zipToIterator = zipToIterator;
      function zipToMap(keys, values) {
        ts3.Debug.assert(keys.length === values.length);
        var map3 = new ts3.Map();
        for (var i = 0; i < keys.length; ++i) {
          map3.set(keys[i], values[i]);
        }
        return map3;
      }
      ts3.zipToMap = zipToMap;
      function intersperse(input, element) {
        if (input.length <= 1) {
          return input;
        }
        var result2 = [];
        for (var i = 0, n = input.length; i < n; i++) {
          if (i)
            result2.push(element);
          result2.push(input[i]);
        }
        return result2;
      }
      ts3.intersperse = intersperse;
      function every(array, callback) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            if (!callback(array[i], i)) {
              return false;
            }
          }
        }
        return true;
      }
      ts3.every = every;
      function find(array, predicate) {
        for (var i = 0; i < array.length; i++) {
          var value = array[i];
          if (predicate(value, i)) {
            return value;
          }
        }
        return void 0;
      }
      ts3.find = find;
      function findLast(array, predicate) {
        for (var i = array.length - 1; i >= 0; i--) {
          var value = array[i];
          if (predicate(value, i)) {
            return value;
          }
        }
        return void 0;
      }
      ts3.findLast = findLast;
      function findIndex(array, predicate, startIndex) {
        for (var i = startIndex || 0; i < array.length; i++) {
          if (predicate(array[i], i)) {
            return i;
          }
        }
        return -1;
      }
      ts3.findIndex = findIndex;
      function findLastIndex(array, predicate, startIndex) {
        for (var i = startIndex === void 0 ? array.length - 1 : startIndex; i >= 0; i--) {
          if (predicate(array[i], i)) {
            return i;
          }
        }
        return -1;
      }
      ts3.findLastIndex = findLastIndex;
      function findMap(array, callback) {
        for (var i = 0; i < array.length; i++) {
          var result2 = callback(array[i], i);
          if (result2) {
            return result2;
          }
        }
        return ts3.Debug.fail();
      }
      ts3.findMap = findMap;
      function contains(array, value, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (array) {
          for (var _i = 0, array_1 = array; _i < array_1.length; _i++) {
            var v = array_1[_i];
            if (equalityComparer(v, value)) {
              return true;
            }
          }
        }
        return false;
      }
      ts3.contains = contains;
      function arraysEqual(a, b, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        return a.length === b.length && a.every(function(x, i) {
          return equalityComparer(x, b[i]);
        });
      }
      ts3.arraysEqual = arraysEqual;
      function indexOfAnyCharCode(text, charCodes, start) {
        for (var i = start || 0; i < text.length; i++) {
          if (contains(charCodes, text.charCodeAt(i))) {
            return i;
          }
        }
        return -1;
      }
      ts3.indexOfAnyCharCode = indexOfAnyCharCode;
      function countWhere(array, predicate) {
        var count = 0;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = array[i];
            if (predicate(v, i)) {
              count++;
            }
          }
        }
        return count;
      }
      ts3.countWhere = countWhere;
      function filter(array, f) {
        if (array) {
          var len = array.length;
          var i = 0;
          while (i < len && f(array[i]))
            i++;
          if (i < len) {
            var result2 = array.slice(0, i);
            i++;
            while (i < len) {
              var item = array[i];
              if (f(item)) {
                result2.push(item);
              }
              i++;
            }
            return result2;
          }
        }
        return array;
      }
      ts3.filter = filter;
      function filterMutate(array, f) {
        var outIndex = 0;
        for (var i = 0; i < array.length; i++) {
          if (f(array[i], i, array)) {
            array[outIndex] = array[i];
            outIndex++;
          }
        }
        array.length = outIndex;
      }
      ts3.filterMutate = filterMutate;
      function clear(array) {
        array.length = 0;
      }
      ts3.clear = clear;
      function map2(array, f) {
        var result2;
        if (array) {
          result2 = [];
          for (var i = 0; i < array.length; i++) {
            result2.push(f(array[i], i));
          }
        }
        return result2;
      }
      ts3.map = map2;
      function mapIterator(iter, mapFn) {
        return {
          next: function() {
            var iterRes = iter.next();
            return iterRes.done ? iterRes : { value: mapFn(iterRes.value), done: false };
          }
        };
      }
      ts3.mapIterator = mapIterator;
      function sameMap(array, f) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var item = array[i];
            var mapped = f(item, i);
            if (item !== mapped) {
              var result2 = array.slice(0, i);
              result2.push(mapped);
              for (i++; i < array.length; i++) {
                result2.push(f(array[i], i));
              }
              return result2;
            }
          }
        }
        return array;
      }
      ts3.sameMap = sameMap;
      function flatten(array) {
        var result2 = [];
        for (var _i = 0, array_2 = array; _i < array_2.length; _i++) {
          var v = array_2[_i];
          if (v) {
            if (isArray(v)) {
              addRange(result2, v);
            } else {
              result2.push(v);
            }
          }
        }
        return result2;
      }
      ts3.flatten = flatten;
      function flatMap(array, mapfn) {
        var result2;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = mapfn(array[i], i);
            if (v) {
              if (isArray(v)) {
                result2 = addRange(result2, v);
              } else {
                result2 = append(result2, v);
              }
            }
          }
        }
        return result2 || ts3.emptyArray;
      }
      ts3.flatMap = flatMap;
      function flatMapToMutable(array, mapfn) {
        var result2 = [];
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = mapfn(array[i], i);
            if (v) {
              if (isArray(v)) {
                addRange(result2, v);
              } else {
                result2.push(v);
              }
            }
          }
        }
        return result2;
      }
      ts3.flatMapToMutable = flatMapToMutable;
      function flatMapIterator(iter, mapfn) {
        var first2 = iter.next();
        if (first2.done) {
          return ts3.emptyIterator;
        }
        var currentIter = getIterator2(first2.value);
        return {
          next: function() {
            while (true) {
              var currentRes = currentIter.next();
              if (!currentRes.done) {
                return currentRes;
              }
              var iterRes = iter.next();
              if (iterRes.done) {
                return iterRes;
              }
              currentIter = getIterator2(iterRes.value);
            }
          }
        };
        function getIterator2(x) {
          var res = mapfn(x);
          return res === void 0 ? ts3.emptyIterator : isArray(res) ? arrayIterator(res) : res;
        }
      }
      ts3.flatMapIterator = flatMapIterator;
      function sameFlatMap(array, mapfn) {
        var result2;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var item = array[i];
            var mapped = mapfn(item, i);
            if (result2 || item !== mapped || isArray(mapped)) {
              if (!result2) {
                result2 = array.slice(0, i);
              }
              if (isArray(mapped)) {
                addRange(result2, mapped);
              } else {
                result2.push(mapped);
              }
            }
          }
        }
        return result2 || array;
      }
      ts3.sameFlatMap = sameFlatMap;
      function mapAllOrFail(array, mapFn) {
        var result2 = [];
        for (var i = 0; i < array.length; i++) {
          var mapped = mapFn(array[i], i);
          if (mapped === void 0) {
            return void 0;
          }
          result2.push(mapped);
        }
        return result2;
      }
      ts3.mapAllOrFail = mapAllOrFail;
      function mapDefined(array, mapFn) {
        var result2 = [];
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var mapped = mapFn(array[i], i);
            if (mapped !== void 0) {
              result2.push(mapped);
            }
          }
        }
        return result2;
      }
      ts3.mapDefined = mapDefined;
      function mapDefinedIterator(iter, mapFn) {
        return {
          next: function() {
            while (true) {
              var res = iter.next();
              if (res.done) {
                return res;
              }
              var value = mapFn(res.value);
              if (value !== void 0) {
                return { value, done: false };
              }
            }
          }
        };
      }
      ts3.mapDefinedIterator = mapDefinedIterator;
      function mapDefinedEntries(map3, f) {
        if (!map3) {
          return void 0;
        }
        var result2 = new ts3.Map();
        map3.forEach(function(value, key) {
          var entry = f(key, value);
          if (entry !== void 0) {
            var newKey = entry[0], newValue = entry[1];
            if (newKey !== void 0 && newValue !== void 0) {
              result2.set(newKey, newValue);
            }
          }
        });
        return result2;
      }
      ts3.mapDefinedEntries = mapDefinedEntries;
      function mapDefinedValues(set2, f) {
        if (set2) {
          var result_1 = new ts3.Set();
          set2.forEach(function(value) {
            var newValue = f(value);
            if (newValue !== void 0) {
              result_1.add(newValue);
            }
          });
          return result_1;
        }
      }
      ts3.mapDefinedValues = mapDefinedValues;
      function getOrUpdate(map3, key, callback) {
        if (map3.has(key)) {
          return map3.get(key);
        }
        var value = callback();
        map3.set(key, value);
        return value;
      }
      ts3.getOrUpdate = getOrUpdate;
      function tryAddToSet(set2, value) {
        if (!set2.has(value)) {
          set2.add(value);
          return true;
        }
        return false;
      }
      ts3.tryAddToSet = tryAddToSet;
      ts3.emptyIterator = { next: function() {
        return { value: void 0, done: true };
      } };
      function singleIterator(value) {
        var done = false;
        return {
          next: function() {
            var wasDone = done;
            done = true;
            return wasDone ? { value: void 0, done: true } : { value, done: false };
          }
        };
      }
      ts3.singleIterator = singleIterator;
      function spanMap(array, keyfn, mapfn) {
        var result2;
        if (array) {
          result2 = [];
          var len = array.length;
          var previousKey = void 0;
          var key = void 0;
          var start = 0;
          var pos = 0;
          while (start < len) {
            while (pos < len) {
              var value = array[pos];
              key = keyfn(value, pos);
              if (pos === 0) {
                previousKey = key;
              } else if (key !== previousKey) {
                break;
              }
              pos++;
            }
            if (start < pos) {
              var v = mapfn(array.slice(start, pos), previousKey, start, pos);
              if (v) {
                result2.push(v);
              }
              start = pos;
            }
            previousKey = key;
            pos++;
          }
        }
        return result2;
      }
      ts3.spanMap = spanMap;
      function mapEntries(map3, f) {
        if (!map3) {
          return void 0;
        }
        var result2 = new ts3.Map();
        map3.forEach(function(value, key) {
          var _a = f(key, value), newKey = _a[0], newValue = _a[1];
          result2.set(newKey, newValue);
        });
        return result2;
      }
      ts3.mapEntries = mapEntries;
      function some(array, predicate) {
        if (array) {
          if (predicate) {
            for (var _i = 0, array_3 = array; _i < array_3.length; _i++) {
              var v = array_3[_i];
              if (predicate(v)) {
                return true;
              }
            }
          } else {
            return array.length > 0;
          }
        }
        return false;
      }
      ts3.some = some;
      function getRangesWhere(arr, pred, cb) {
        var start;
        for (var i = 0; i < arr.length; i++) {
          if (pred(arr[i])) {
            start = start === void 0 ? i : start;
          } else {
            if (start !== void 0) {
              cb(start, i);
              start = void 0;
            }
          }
        }
        if (start !== void 0)
          cb(start, arr.length);
      }
      ts3.getRangesWhere = getRangesWhere;
      function concatenate(array1, array2) {
        if (!some(array2))
          return array1;
        if (!some(array1))
          return array2;
        return __spreadArray(__spreadArray([], array1, true), array2, true);
      }
      ts3.concatenate = concatenate;
      function selectIndex(_, i) {
        return i;
      }
      function indicesOf(array) {
        return array.map(selectIndex);
      }
      ts3.indicesOf = indicesOf;
      function deduplicateRelational(array, equalityComparer, comparer) {
        var indices = indicesOf(array);
        stableSortIndices(array, indices, comparer);
        var last2 = array[indices[0]];
        var deduplicated = [indices[0]];
        for (var i = 1; i < indices.length; i++) {
          var index = indices[i];
          var item = array[index];
          if (!equalityComparer(last2, item)) {
            deduplicated.push(index);
            last2 = item;
          }
        }
        deduplicated.sort();
        return deduplicated.map(function(i2) {
          return array[i2];
        });
      }
      function deduplicateEquality(array, equalityComparer) {
        var result2 = [];
        for (var _i = 0, array_4 = array; _i < array_4.length; _i++) {
          var item = array_4[_i];
          pushIfUnique(result2, item, equalityComparer);
        }
        return result2;
      }
      function deduplicate(array, equalityComparer, comparer) {
        return array.length === 0 ? [] : array.length === 1 ? array.slice() : comparer ? deduplicateRelational(array, equalityComparer, comparer) : deduplicateEquality(array, equalityComparer);
      }
      ts3.deduplicate = deduplicate;
      function deduplicateSorted(array, comparer) {
        if (array.length === 0)
          return ts3.emptyArray;
        var last2 = array[0];
        var deduplicated = [last2];
        for (var i = 1; i < array.length; i++) {
          var next = array[i];
          switch (comparer(next, last2)) {
            case true:
            case 0:
              continue;
            case -1:
              return ts3.Debug.fail("Array is unsorted.");
          }
          deduplicated.push(last2 = next);
        }
        return deduplicated;
      }
      function createSortedArray() {
        return [];
      }
      ts3.createSortedArray = createSortedArray;
      function insertSorted(array, insert, compare, allowDuplicates) {
        if (array.length === 0) {
          array.push(insert);
          return;
        }
        var insertIndex = binarySearch(array, insert, identity, compare);
        if (insertIndex < 0) {
          array.splice(~insertIndex, 0, insert);
        } else if (allowDuplicates) {
          array.splice(insertIndex, 0, insert);
        }
      }
      ts3.insertSorted = insertSorted;
      function sortAndDeduplicate(array, comparer, equalityComparer) {
        return deduplicateSorted(sort(array, comparer), equalityComparer || comparer || compareStringsCaseSensitive);
      }
      ts3.sortAndDeduplicate = sortAndDeduplicate;
      function arrayIsSorted(array, comparer) {
        if (array.length < 2)
          return true;
        var prevElement = array[0];
        for (var _i = 0, _a = array.slice(1); _i < _a.length; _i++) {
          var element = _a[_i];
          if (comparer(prevElement, element) === 1) {
            return false;
          }
          prevElement = element;
        }
        return true;
      }
      ts3.arrayIsSorted = arrayIsSorted;
      function arrayIsEqualTo(array1, array2, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (!array1 || !array2) {
          return array1 === array2;
        }
        if (array1.length !== array2.length) {
          return false;
        }
        for (var i = 0; i < array1.length; i++) {
          if (!equalityComparer(array1[i], array2[i], i)) {
            return false;
          }
        }
        return true;
      }
      ts3.arrayIsEqualTo = arrayIsEqualTo;
      function compact(array) {
        var result2;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = array[i];
            if (result2 || !v) {
              if (!result2) {
                result2 = array.slice(0, i);
              }
              if (v) {
                result2.push(v);
              }
            }
          }
        }
        return result2 || array;
      }
      ts3.compact = compact;
      function relativeComplement(arrayA, arrayB, comparer) {
        if (!arrayB || !arrayA || arrayB.length === 0 || arrayA.length === 0)
          return arrayB;
        var result2 = [];
        loopB:
          for (var offsetA = 0, offsetB = 0; offsetB < arrayB.length; offsetB++) {
            if (offsetB > 0) {
              ts3.Debug.assertGreaterThanOrEqual(comparer(arrayB[offsetB], arrayB[offsetB - 1]), 0);
            }
            loopA:
              for (var startA = offsetA; offsetA < arrayA.length; offsetA++) {
                if (offsetA > startA) {
                  ts3.Debug.assertGreaterThanOrEqual(comparer(arrayA[offsetA], arrayA[offsetA - 1]), 0);
                }
                switch (comparer(arrayB[offsetB], arrayA[offsetA])) {
                  case -1:
                    result2.push(arrayB[offsetB]);
                    continue loopB;
                  case 0:
                    continue loopB;
                  case 1:
                    continue loopA;
                }
              }
          }
        return result2;
      }
      ts3.relativeComplement = relativeComplement;
      function sum(array, prop) {
        var result2 = 0;
        for (var _i = 0, array_5 = array; _i < array_5.length; _i++) {
          var v = array_5[_i];
          result2 += v[prop];
        }
        return result2;
      }
      ts3.sum = sum;
      function append(to, value) {
        if (value === void 0)
          return to;
        if (to === void 0)
          return [value];
        to.push(value);
        return to;
      }
      ts3.append = append;
      function combine(xs, ys) {
        if (xs === void 0)
          return ys;
        if (ys === void 0)
          return xs;
        if (isArray(xs))
          return isArray(ys) ? concatenate(xs, ys) : append(xs, ys);
        if (isArray(ys))
          return append(ys, xs);
        return [xs, ys];
      }
      ts3.combine = combine;
      function toOffset(array, offset) {
        return offset < 0 ? array.length + offset : offset;
      }
      function addRange(to, from, start, end) {
        if (from === void 0 || from.length === 0)
          return to;
        if (to === void 0)
          return from.slice(start, end);
        start = start === void 0 ? 0 : toOffset(from, start);
        end = end === void 0 ? from.length : toOffset(from, end);
        for (var i = start; i < end && i < from.length; i++) {
          if (from[i] !== void 0) {
            to.push(from[i]);
          }
        }
        return to;
      }
      ts3.addRange = addRange;
      function pushIfUnique(array, toAdd, equalityComparer) {
        if (contains(array, toAdd, equalityComparer)) {
          return false;
        } else {
          array.push(toAdd);
          return true;
        }
      }
      ts3.pushIfUnique = pushIfUnique;
      function appendIfUnique(array, toAdd, equalityComparer) {
        if (array) {
          pushIfUnique(array, toAdd, equalityComparer);
          return array;
        } else {
          return [toAdd];
        }
      }
      ts3.appendIfUnique = appendIfUnique;
      function stableSortIndices(array, indices, comparer) {
        indices.sort(function(x, y) {
          return comparer(array[x], array[y]) || compareValues(x, y);
        });
      }
      function sort(array, comparer) {
        return array.length === 0 ? array : array.slice().sort(comparer);
      }
      ts3.sort = sort;
      function arrayIterator(array) {
        var i = 0;
        return { next: function() {
          if (i === array.length) {
            return { value: void 0, done: true };
          } else {
            i++;
            return { value: array[i - 1], done: false };
          }
        } };
      }
      ts3.arrayIterator = arrayIterator;
      function arrayReverseIterator(array) {
        var i = array.length;
        return {
          next: function() {
            if (i === 0) {
              return { value: void 0, done: true };
            } else {
              i--;
              return { value: array[i], done: false };
            }
          }
        };
      }
      ts3.arrayReverseIterator = arrayReverseIterator;
      function stableSort(array, comparer) {
        var indices = indicesOf(array);
        stableSortIndices(array, indices, comparer);
        return indices.map(function(i) {
          return array[i];
        });
      }
      ts3.stableSort = stableSort;
      function rangeEquals(array1, array2, pos, end) {
        while (pos < end) {
          if (array1[pos] !== array2[pos]) {
            return false;
          }
          pos++;
        }
        return true;
      }
      ts3.rangeEquals = rangeEquals;
      function elementAt(array, offset) {
        if (array) {
          offset = toOffset(array, offset);
          if (offset < array.length) {
            return array[offset];
          }
        }
        return void 0;
      }
      ts3.elementAt = elementAt;
      function firstOrUndefined(array) {
        return array.length === 0 ? void 0 : array[0];
      }
      ts3.firstOrUndefined = firstOrUndefined;
      function first(array) {
        ts3.Debug.assert(array.length !== 0);
        return array[0];
      }
      ts3.first = first;
      function lastOrUndefined(array) {
        return array.length === 0 ? void 0 : array[array.length - 1];
      }
      ts3.lastOrUndefined = lastOrUndefined;
      function last(array) {
        ts3.Debug.assert(array.length !== 0);
        return array[array.length - 1];
      }
      ts3.last = last;
      function singleOrUndefined(array) {
        return array && array.length === 1 ? array[0] : void 0;
      }
      ts3.singleOrUndefined = singleOrUndefined;
      function singleOrMany(array) {
        return array && array.length === 1 ? array[0] : array;
      }
      ts3.singleOrMany = singleOrMany;
      function replaceElement(array, index, value) {
        var result2 = array.slice(0);
        result2[index] = value;
        return result2;
      }
      ts3.replaceElement = replaceElement;
      function binarySearch(array, value, keySelector, keyComparer, offset) {
        return binarySearchKey(array, keySelector(value), keySelector, keyComparer, offset);
      }
      ts3.binarySearch = binarySearch;
      function binarySearchKey(array, key, keySelector, keyComparer, offset) {
        if (!some(array)) {
          return -1;
        }
        var low = offset || 0;
        var high = array.length - 1;
        while (low <= high) {
          var middle = low + (high - low >> 1);
          var midKey = keySelector(array[middle], middle);
          switch (keyComparer(midKey, key)) {
            case -1:
              low = middle + 1;
              break;
            case 0:
              return middle;
            case 1:
              high = middle - 1;
              break;
          }
        }
        return ~low;
      }
      ts3.binarySearchKey = binarySearchKey;
      function reduceLeft(array, f, initial, start, count) {
        if (array && array.length > 0) {
          var size = array.length;
          if (size > 0) {
            var pos = start === void 0 || start < 0 ? 0 : start;
            var end = count === void 0 || pos + count > size - 1 ? size - 1 : pos + count;
            var result2 = void 0;
            if (arguments.length <= 2) {
              result2 = array[pos];
              pos++;
            } else {
              result2 = initial;
            }
            while (pos <= end) {
              result2 = f(result2, array[pos], pos);
              pos++;
            }
            return result2;
          }
        }
        return initial;
      }
      ts3.reduceLeft = reduceLeft;
      var hasOwnProperty2 = Object.prototype.hasOwnProperty;
      function hasProperty(map3, key) {
        return hasOwnProperty2.call(map3, key);
      }
      ts3.hasProperty = hasProperty;
      function getProperty(map3, key) {
        return hasOwnProperty2.call(map3, key) ? map3[key] : void 0;
      }
      ts3.getProperty = getProperty;
      function getOwnKeys(map3) {
        var keys = [];
        for (var key in map3) {
          if (hasOwnProperty2.call(map3, key)) {
            keys.push(key);
          }
        }
        return keys;
      }
      ts3.getOwnKeys = getOwnKeys;
      function getAllKeys(obj) {
        var result2 = [];
        do {
          var names = Object.getOwnPropertyNames(obj);
          for (var _i = 0, names_1 = names; _i < names_1.length; _i++) {
            var name = names_1[_i];
            pushIfUnique(result2, name);
          }
        } while (obj = Object.getPrototypeOf(obj));
        return result2;
      }
      ts3.getAllKeys = getAllKeys;
      function getOwnValues(collection) {
        var values = [];
        for (var key in collection) {
          if (hasOwnProperty2.call(collection, key)) {
            values.push(collection[key]);
          }
        }
        return values;
      }
      ts3.getOwnValues = getOwnValues;
      var _entries = Object.entries || function(obj) {
        var keys = getOwnKeys(obj);
        var result2 = Array(keys.length);
        for (var i = 0; i < keys.length; i++) {
          result2[i] = [keys[i], obj[keys[i]]];
        }
        return result2;
      };
      function getEntries(obj) {
        return obj ? _entries(obj) : [];
      }
      ts3.getEntries = getEntries;
      function arrayOf(count, f) {
        var result2 = new Array(count);
        for (var i = 0; i < count; i++) {
          result2[i] = f(i);
        }
        return result2;
      }
      ts3.arrayOf = arrayOf;
      function arrayFrom(iterator, map3) {
        var result2 = [];
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          result2.push(map3 ? map3(iterResult.value) : iterResult.value);
        }
        return result2;
      }
      ts3.arrayFrom = arrayFrom;
      function assign3(t) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          args[_i - 1] = arguments[_i];
        }
        for (var _a = 0, args_1 = args; _a < args_1.length; _a++) {
          var arg = args_1[_a];
          if (arg === void 0)
            continue;
          for (var p in arg) {
            if (hasProperty(arg, p)) {
              t[p] = arg[p];
            }
          }
        }
        return t;
      }
      ts3.assign = assign3;
      function equalOwnProperties(left, right, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (left === right)
          return true;
        if (!left || !right)
          return false;
        for (var key in left) {
          if (hasOwnProperty2.call(left, key)) {
            if (!hasOwnProperty2.call(right, key))
              return false;
            if (!equalityComparer(left[key], right[key]))
              return false;
          }
        }
        for (var key in right) {
          if (hasOwnProperty2.call(right, key)) {
            if (!hasOwnProperty2.call(left, key))
              return false;
          }
        }
        return true;
      }
      ts3.equalOwnProperties = equalOwnProperties;
      function arrayToMap(array, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result2 = new ts3.Map();
        for (var _i = 0, array_6 = array; _i < array_6.length; _i++) {
          var value = array_6[_i];
          var key = makeKey(value);
          if (key !== void 0)
            result2.set(key, makeValue(value));
        }
        return result2;
      }
      ts3.arrayToMap = arrayToMap;
      function arrayToNumericMap(array, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result2 = [];
        for (var _i = 0, array_7 = array; _i < array_7.length; _i++) {
          var value = array_7[_i];
          result2[makeKey(value)] = makeValue(value);
        }
        return result2;
      }
      ts3.arrayToNumericMap = arrayToNumericMap;
      function arrayToMultiMap(values, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result2 = createMultiMap();
        for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
          var value = values_1[_i];
          result2.add(makeKey(value), makeValue(value));
        }
        return result2;
      }
      ts3.arrayToMultiMap = arrayToMultiMap;
      function group(values, getGroupId, resultSelector) {
        if (resultSelector === void 0) {
          resultSelector = identity;
        }
        return arrayFrom(arrayToMultiMap(values, getGroupId).values(), resultSelector);
      }
      ts3.group = group;
      function clone(object2) {
        var result2 = {};
        for (var id in object2) {
          if (hasOwnProperty2.call(object2, id)) {
            result2[id] = object2[id];
          }
        }
        return result2;
      }
      ts3.clone = clone;
      function extend3(first2, second) {
        var result2 = {};
        for (var id in second) {
          if (hasOwnProperty2.call(second, id)) {
            result2[id] = second[id];
          }
        }
        for (var id in first2) {
          if (hasOwnProperty2.call(first2, id)) {
            result2[id] = first2[id];
          }
        }
        return result2;
      }
      ts3.extend = extend3;
      function copyProperties(first2, second) {
        for (var id in second) {
          if (hasOwnProperty2.call(second, id)) {
            first2[id] = second[id];
          }
        }
      }
      ts3.copyProperties = copyProperties;
      function maybeBind(obj, fn) {
        return fn ? fn.bind(obj) : void 0;
      }
      ts3.maybeBind = maybeBind;
      function createMultiMap() {
        var map3 = new ts3.Map();
        map3.add = multiMapAdd;
        map3.remove = multiMapRemove;
        return map3;
      }
      ts3.createMultiMap = createMultiMap;
      function multiMapAdd(key, value) {
        var values = this.get(key);
        if (values) {
          values.push(value);
        } else {
          this.set(key, values = [value]);
        }
        return values;
      }
      function multiMapRemove(key, value) {
        var values = this.get(key);
        if (values) {
          unorderedRemoveItem(values, value);
          if (!values.length) {
            this.delete(key);
          }
        }
      }
      function createUnderscoreEscapedMultiMap() {
        return createMultiMap();
      }
      ts3.createUnderscoreEscapedMultiMap = createUnderscoreEscapedMultiMap;
      function createSet(getHashCode, equals) {
        var multiMap = new ts3.Map();
        var size = 0;
        function getElementIterator() {
          var valueIt = multiMap.values();
          var arrayIt;
          return {
            next: function() {
              while (true) {
                if (arrayIt) {
                  var n = arrayIt.next();
                  if (!n.done) {
                    return { value: n.value };
                  }
                  arrayIt = void 0;
                } else {
                  var n = valueIt.next();
                  if (n.done) {
                    return { value: void 0, done: true };
                  }
                  if (!isArray(n.value)) {
                    return { value: n.value };
                  }
                  arrayIt = arrayIterator(n.value);
                }
              }
            }
          };
        }
        var set2 = {
          has: function(element) {
            var hash = getHashCode(element);
            if (!multiMap.has(hash))
              return false;
            var candidates = multiMap.get(hash);
            if (!isArray(candidates))
              return equals(candidates, element);
            for (var _i = 0, candidates_1 = candidates; _i < candidates_1.length; _i++) {
              var candidate = candidates_1[_i];
              if (equals(candidate, element)) {
                return true;
              }
            }
            return false;
          },
          add: function(element) {
            var hash = getHashCode(element);
            if (multiMap.has(hash)) {
              var values = multiMap.get(hash);
              if (isArray(values)) {
                if (!contains(values, element, equals)) {
                  values.push(element);
                  size++;
                }
              } else {
                var value = values;
                if (!equals(value, element)) {
                  multiMap.set(hash, [value, element]);
                  size++;
                }
              }
            } else {
              multiMap.set(hash, element);
              size++;
            }
            return this;
          },
          delete: function(element) {
            var hash = getHashCode(element);
            if (!multiMap.has(hash))
              return false;
            var candidates = multiMap.get(hash);
            if (isArray(candidates)) {
              for (var i = 0; i < candidates.length; i++) {
                if (equals(candidates[i], element)) {
                  if (candidates.length === 1) {
                    multiMap.delete(hash);
                  } else if (candidates.length === 2) {
                    multiMap.set(hash, candidates[1 - i]);
                  } else {
                    unorderedRemoveItemAt(candidates, i);
                  }
                  size--;
                  return true;
                }
              }
            } else {
              var candidate = candidates;
              if (equals(candidate, element)) {
                multiMap.delete(hash);
                size--;
                return true;
              }
            }
            return false;
          },
          clear: function() {
            multiMap.clear();
            size = 0;
          },
          get size() {
            return size;
          },
          forEach: function(action) {
            for (var _i = 0, _a = arrayFrom(multiMap.values()); _i < _a.length; _i++) {
              var elements = _a[_i];
              if (isArray(elements)) {
                for (var _b = 0, elements_1 = elements; _b < elements_1.length; _b++) {
                  var element = elements_1[_b];
                  action(element, element);
                }
              } else {
                var element = elements;
                action(element, element);
              }
            }
          },
          keys: function() {
            return getElementIterator();
          },
          values: function() {
            return getElementIterator();
          },
          entries: function() {
            var it = getElementIterator();
            return {
              next: function() {
                var n = it.next();
                return n.done ? n : { value: [n.value, n.value] };
              }
            };
          }
        };
        return set2;
      }
      ts3.createSet = createSet;
      function isArray(value) {
        return Array.isArray ? Array.isArray(value) : value instanceof Array;
      }
      ts3.isArray = isArray;
      function toArray2(value) {
        return isArray(value) ? value : [value];
      }
      ts3.toArray = toArray2;
      function isString(text) {
        return typeof text === "string";
      }
      ts3.isString = isString;
      function isNumber(x) {
        return typeof x === "number";
      }
      ts3.isNumber = isNumber;
      function tryCast(value, test) {
        return value !== void 0 && test(value) ? value : void 0;
      }
      ts3.tryCast = tryCast;
      function cast(value, test) {
        if (value !== void 0 && test(value))
          return value;
        return ts3.Debug.fail("Invalid cast. The supplied value ".concat(value, " did not pass the test '").concat(ts3.Debug.getFunctionName(test), "'."));
      }
      ts3.cast = cast;
      function noop(_) {
      }
      ts3.noop = noop;
      function returnFalse() {
        return false;
      }
      ts3.returnFalse = returnFalse;
      function returnTrue() {
        return true;
      }
      ts3.returnTrue = returnTrue;
      function returnUndefined() {
        return void 0;
      }
      ts3.returnUndefined = returnUndefined;
      function identity(x) {
        return x;
      }
      ts3.identity = identity;
      function toLowerCase(x) {
        return x.toLowerCase();
      }
      ts3.toLowerCase = toLowerCase;
      var fileNameLowerCaseRegExp = /[^\u0130\u0131\u00DFa-z0-9\\/:\-_\. ]+/g;
      function toFileNameLowerCase(x) {
        return fileNameLowerCaseRegExp.test(x) ? x.replace(fileNameLowerCaseRegExp, toLowerCase) : x;
      }
      ts3.toFileNameLowerCase = toFileNameLowerCase;
      function notImplemented() {
        throw new Error("Not implemented");
      }
      ts3.notImplemented = notImplemented;
      function memoize(callback) {
        var value;
        return function() {
          if (callback) {
            value = callback();
            callback = void 0;
          }
          return value;
        };
      }
      ts3.memoize = memoize;
      function memoizeOne(callback) {
        var map3 = new ts3.Map();
        return function(arg) {
          var key = "".concat(typeof arg, ":").concat(arg);
          var value = map3.get(key);
          if (value === void 0 && !map3.has(key)) {
            value = callback(arg);
            map3.set(key, value);
          }
          return value;
        };
      }
      ts3.memoizeOne = memoizeOne;
      function compose(a, b, c, d, e) {
        if (!!e) {
          var args_2 = [];
          for (var i = 0; i < arguments.length; i++) {
            args_2[i] = arguments[i];
          }
          return function(t) {
            return reduceLeft(args_2, function(u, f) {
              return f(u);
            }, t);
          };
        } else if (d) {
          return function(t) {
            return d(c(b(a(t))));
          };
        } else if (c) {
          return function(t) {
            return c(b(a(t)));
          };
        } else if (b) {
          return function(t) {
            return b(a(t));
          };
        } else if (a) {
          return function(t) {
            return a(t);
          };
        } else {
          return function(t) {
            return t;
          };
        }
      }
      ts3.compose = compose;
      var AssertionLevel;
      (function(AssertionLevel2) {
        AssertionLevel2[AssertionLevel2["None"] = 0] = "None";
        AssertionLevel2[AssertionLevel2["Normal"] = 1] = "Normal";
        AssertionLevel2[AssertionLevel2["Aggressive"] = 2] = "Aggressive";
        AssertionLevel2[AssertionLevel2["VeryAggressive"] = 3] = "VeryAggressive";
      })(AssertionLevel = ts3.AssertionLevel || (ts3.AssertionLevel = {}));
      function equateValues(a, b) {
        return a === b;
      }
      ts3.equateValues = equateValues;
      function equateStringsCaseInsensitive(a, b) {
        return a === b || a !== void 0 && b !== void 0 && a.toUpperCase() === b.toUpperCase();
      }
      ts3.equateStringsCaseInsensitive = equateStringsCaseInsensitive;
      function equateStringsCaseSensitive(a, b) {
        return equateValues(a, b);
      }
      ts3.equateStringsCaseSensitive = equateStringsCaseSensitive;
      function compareComparableValues(a, b) {
        return a === b ? 0 : a === void 0 ? -1 : b === void 0 ? 1 : a < b ? -1 : 1;
      }
      function compareValues(a, b) {
        return compareComparableValues(a, b);
      }
      ts3.compareValues = compareValues;
      function compareTextSpans(a, b) {
        return compareValues(a === null || a === void 0 ? void 0 : a.start, b === null || b === void 0 ? void 0 : b.start) || compareValues(a === null || a === void 0 ? void 0 : a.length, b === null || b === void 0 ? void 0 : b.length);
      }
      ts3.compareTextSpans = compareTextSpans;
      function min(a, b, compare) {
        return compare(a, b) === -1 ? a : b;
      }
      ts3.min = min;
      function compareStringsCaseInsensitive(a, b) {
        if (a === b)
          return 0;
        if (a === void 0)
          return -1;
        if (b === void 0)
          return 1;
        a = a.toUpperCase();
        b = b.toUpperCase();
        return a < b ? -1 : a > b ? 1 : 0;
      }
      ts3.compareStringsCaseInsensitive = compareStringsCaseInsensitive;
      function compareStringsCaseSensitive(a, b) {
        return compareComparableValues(a, b);
      }
      ts3.compareStringsCaseSensitive = compareStringsCaseSensitive;
      function getStringComparer(ignoreCase) {
        return ignoreCase ? compareStringsCaseInsensitive : compareStringsCaseSensitive;
      }
      ts3.getStringComparer = getStringComparer;
      var createUIStringComparer = function() {
        var defaultComparer;
        var enUSComparer;
        var stringComparerFactory = getStringComparerFactory();
        return createStringComparer;
        function compareWithCallback(a, b, comparer) {
          if (a === b)
            return 0;
          if (a === void 0)
            return -1;
          if (b === void 0)
            return 1;
          var value = comparer(a, b);
          return value < 0 ? -1 : value > 0 ? 1 : 0;
        }
        function createIntlCollatorStringComparer(locale) {
          var comparer = new Intl.Collator(locale, { usage: "sort", sensitivity: "variant" }).compare;
          return function(a, b) {
            return compareWithCallback(a, b, comparer);
          };
        }
        function createLocaleCompareStringComparer(locale) {
          if (locale !== void 0)
            return createFallbackStringComparer();
          return function(a, b) {
            return compareWithCallback(a, b, compareStrings);
          };
          function compareStrings(a, b) {
            return a.localeCompare(b);
          }
        }
        function createFallbackStringComparer() {
          return function(a, b) {
            return compareWithCallback(a, b, compareDictionaryOrder);
          };
          function compareDictionaryOrder(a, b) {
            return compareStrings(a.toUpperCase(), b.toUpperCase()) || compareStrings(a, b);
          }
          function compareStrings(a, b) {
            return a < b ? -1 : a > b ? 1 : 0;
          }
        }
        function getStringComparerFactory() {
          if (typeof Intl === "object" && typeof Intl.Collator === "function") {
            return createIntlCollatorStringComparer;
          }
          if (typeof String.prototype.localeCompare === "function" && typeof String.prototype.toLocaleUpperCase === "function" && "a".localeCompare("B") < 0) {
            return createLocaleCompareStringComparer;
          }
          return createFallbackStringComparer;
        }
        function createStringComparer(locale) {
          if (locale === void 0) {
            return defaultComparer || (defaultComparer = stringComparerFactory(locale));
          } else if (locale === "en-US") {
            return enUSComparer || (enUSComparer = stringComparerFactory(locale));
          } else {
            return stringComparerFactory(locale);
          }
        }
      }();
      var uiComparerCaseSensitive;
      var uiLocale;
      function getUILocale() {
        return uiLocale;
      }
      ts3.getUILocale = getUILocale;
      function setUILocale(value) {
        if (uiLocale !== value) {
          uiLocale = value;
          uiComparerCaseSensitive = void 0;
        }
      }
      ts3.setUILocale = setUILocale;
      function compareStringsCaseSensitiveUI(a, b) {
        var comparer = uiComparerCaseSensitive || (uiComparerCaseSensitive = createUIStringComparer(uiLocale));
        return comparer(a, b);
      }
      ts3.compareStringsCaseSensitiveUI = compareStringsCaseSensitiveUI;
      function compareProperties(a, b, key, comparer) {
        return a === b ? 0 : a === void 0 ? -1 : b === void 0 ? 1 : comparer(a[key], b[key]);
      }
      ts3.compareProperties = compareProperties;
      function compareBooleans(a, b) {
        return compareValues(a ? 1 : 0, b ? 1 : 0);
      }
      ts3.compareBooleans = compareBooleans;
      function getSpellingSuggestion(name, candidates, getName) {
        var maximumLengthDifference = Math.min(2, Math.floor(name.length * 0.34));
        var bestDistance = Math.floor(name.length * 0.4) + 1;
        var bestCandidate;
        for (var _i = 0, candidates_2 = candidates; _i < candidates_2.length; _i++) {
          var candidate = candidates_2[_i];
          var candidateName = getName(candidate);
          if (candidateName !== void 0 && Math.abs(candidateName.length - name.length) <= maximumLengthDifference) {
            if (candidateName === name) {
              continue;
            }
            if (candidateName.length < 3 && candidateName.toLowerCase() !== name.toLowerCase()) {
              continue;
            }
            var distance = levenshteinWithMax(name, candidateName, bestDistance - 0.1);
            if (distance === void 0) {
              continue;
            }
            ts3.Debug.assert(distance < bestDistance);
            bestDistance = distance;
            bestCandidate = candidate;
          }
        }
        return bestCandidate;
      }
      ts3.getSpellingSuggestion = getSpellingSuggestion;
      function levenshteinWithMax(s1, s2, max) {
        var previous = new Array(s2.length + 1);
        var current = new Array(s2.length + 1);
        var big = max + 0.01;
        for (var i = 0; i <= s2.length; i++) {
          previous[i] = i;
        }
        for (var i = 1; i <= s1.length; i++) {
          var c1 = s1.charCodeAt(i - 1);
          var minJ = Math.ceil(i > max ? i - max : 1);
          var maxJ = Math.floor(s2.length > max + i ? max + i : s2.length);
          current[0] = i;
          var colMin = i;
          for (var j = 1; j < minJ; j++) {
            current[j] = big;
          }
          for (var j = minJ; j <= maxJ; j++) {
            var substitutionDistance = s1[i - 1].toLowerCase() === s2[j - 1].toLowerCase() ? previous[j - 1] + 0.1 : previous[j - 1] + 2;
            var dist = c1 === s2.charCodeAt(j - 1) ? previous[j - 1] : Math.min(previous[j] + 1, current[j - 1] + 1, substitutionDistance);
            current[j] = dist;
            colMin = Math.min(colMin, dist);
          }
          for (var j = maxJ + 1; j <= s2.length; j++) {
            current[j] = big;
          }
          if (colMin > max) {
            return void 0;
          }
          var temp = previous;
          previous = current;
          current = temp;
        }
        var res = previous[s2.length];
        return res > max ? void 0 : res;
      }
      function endsWith(str2, suffix) {
        var expectedPos = str2.length - suffix.length;
        return expectedPos >= 0 && str2.indexOf(suffix, expectedPos) === expectedPos;
      }
      ts3.endsWith = endsWith;
      function removeSuffix(str2, suffix) {
        return endsWith(str2, suffix) ? str2.slice(0, str2.length - suffix.length) : str2;
      }
      ts3.removeSuffix = removeSuffix;
      function tryRemoveSuffix(str2, suffix) {
        return endsWith(str2, suffix) ? str2.slice(0, str2.length - suffix.length) : void 0;
      }
      ts3.tryRemoveSuffix = tryRemoveSuffix;
      function stringContains(str2, substring) {
        return str2.indexOf(substring) !== -1;
      }
      ts3.stringContains = stringContains;
      function removeMinAndVersionNumbers(fileName2) {
        var end = fileName2.length;
        for (var pos = end - 1; pos > 0; pos--) {
          var ch = fileName2.charCodeAt(pos);
          if (ch >= 48 && ch <= 57) {
            do {
              --pos;
              ch = fileName2.charCodeAt(pos);
            } while (pos > 0 && ch >= 48 && ch <= 57);
          } else if (pos > 4 && (ch === 110 || ch === 78)) {
            --pos;
            ch = fileName2.charCodeAt(pos);
            if (ch !== 105 && ch !== 73) {
              break;
            }
            --pos;
            ch = fileName2.charCodeAt(pos);
            if (ch !== 109 && ch !== 77) {
              break;
            }
            --pos;
            ch = fileName2.charCodeAt(pos);
          } else {
            break;
          }
          if (ch !== 45 && ch !== 46) {
            break;
          }
          end = pos;
        }
        return end === fileName2.length ? fileName2 : fileName2.slice(0, end);
      }
      ts3.removeMinAndVersionNumbers = removeMinAndVersionNumbers;
      function orderedRemoveItem(array, item) {
        for (var i = 0; i < array.length; i++) {
          if (array[i] === item) {
            orderedRemoveItemAt(array, i);
            return true;
          }
        }
        return false;
      }
      ts3.orderedRemoveItem = orderedRemoveItem;
      function orderedRemoveItemAt(array, index) {
        for (var i = index; i < array.length - 1; i++) {
          array[i] = array[i + 1];
        }
        array.pop();
      }
      ts3.orderedRemoveItemAt = orderedRemoveItemAt;
      function unorderedRemoveItemAt(array, index) {
        array[index] = array[array.length - 1];
        array.pop();
      }
      ts3.unorderedRemoveItemAt = unorderedRemoveItemAt;
      function unorderedRemoveItem(array, item) {
        return unorderedRemoveFirstItemWhere(array, function(element) {
          return element === item;
        });
      }
      ts3.unorderedRemoveItem = unorderedRemoveItem;
      function unorderedRemoveFirstItemWhere(array, predicate) {
        for (var i = 0; i < array.length; i++) {
          if (predicate(array[i])) {
            unorderedRemoveItemAt(array, i);
            return true;
          }
        }
        return false;
      }
      function createGetCanonicalFileName(useCaseSensitiveFileNames) {
        return useCaseSensitiveFileNames ? identity : toFileNameLowerCase;
      }
      ts3.createGetCanonicalFileName = createGetCanonicalFileName;
      function patternText(_a) {
        var prefix = _a.prefix, suffix = _a.suffix;
        return "".concat(prefix, "*").concat(suffix);
      }
      ts3.patternText = patternText;
      function matchedText(pattern, candidate) {
        ts3.Debug.assert(isPatternMatch(pattern, candidate));
        return candidate.substring(pattern.prefix.length, candidate.length - pattern.suffix.length);
      }
      ts3.matchedText = matchedText;
      function findBestPatternMatch(values, getPattern, candidate) {
        var matchedValue;
        var longestMatchPrefixLength = -1;
        for (var _i = 0, values_2 = values; _i < values_2.length; _i++) {
          var v = values_2[_i];
          var pattern = getPattern(v);
          if (isPatternMatch(pattern, candidate) && pattern.prefix.length > longestMatchPrefixLength) {
            longestMatchPrefixLength = pattern.prefix.length;
            matchedValue = v;
          }
        }
        return matchedValue;
      }
      ts3.findBestPatternMatch = findBestPatternMatch;
      function startsWith(str2, prefix) {
        return str2.lastIndexOf(prefix, 0) === 0;
      }
      ts3.startsWith = startsWith;
      function removePrefix(str2, prefix) {
        return startsWith(str2, prefix) ? str2.substr(prefix.length) : str2;
      }
      ts3.removePrefix = removePrefix;
      function tryRemovePrefix(str2, prefix, getCanonicalFileName) {
        if (getCanonicalFileName === void 0) {
          getCanonicalFileName = identity;
        }
        return startsWith(getCanonicalFileName(str2), getCanonicalFileName(prefix)) ? str2.substring(prefix.length) : void 0;
      }
      ts3.tryRemovePrefix = tryRemovePrefix;
      function isPatternMatch(_a, candidate) {
        var prefix = _a.prefix, suffix = _a.suffix;
        return candidate.length >= prefix.length + suffix.length && startsWith(candidate, prefix) && endsWith(candidate, suffix);
      }
      function and(f, g) {
        return function(arg) {
          return f(arg) && g(arg);
        };
      }
      ts3.and = and;
      function or() {
        var fs4 = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          fs4[_i] = arguments[_i];
        }
        return function() {
          var args = [];
          for (var _i2 = 0; _i2 < arguments.length; _i2++) {
            args[_i2] = arguments[_i2];
          }
          var lastResult;
          for (var _a = 0, fs_1 = fs4; _a < fs_1.length; _a++) {
            var f = fs_1[_a];
            lastResult = f.apply(void 0, args);
            if (lastResult) {
              return lastResult;
            }
          }
          return lastResult;
        };
      }
      ts3.or = or;
      function not(fn) {
        return function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return !fn.apply(void 0, args);
        };
      }
      ts3.not = not;
      function assertType(_) {
      }
      ts3.assertType = assertType;
      function singleElementArray(t) {
        return t === void 0 ? void 0 : [t];
      }
      ts3.singleElementArray = singleElementArray;
      function enumerateInsertsAndDeletes(newItems, oldItems, comparer, inserted, deleted, unchanged) {
        unchanged = unchanged || noop;
        var newIndex = 0;
        var oldIndex = 0;
        var newLen = newItems.length;
        var oldLen = oldItems.length;
        var hasChanges = false;
        while (newIndex < newLen && oldIndex < oldLen) {
          var newItem = newItems[newIndex];
          var oldItem = oldItems[oldIndex];
          var compareResult = comparer(newItem, oldItem);
          if (compareResult === -1) {
            inserted(newItem);
            newIndex++;
            hasChanges = true;
          } else if (compareResult === 1) {
            deleted(oldItem);
            oldIndex++;
            hasChanges = true;
          } else {
            unchanged(oldItem, newItem);
            newIndex++;
            oldIndex++;
          }
        }
        while (newIndex < newLen) {
          inserted(newItems[newIndex++]);
          hasChanges = true;
        }
        while (oldIndex < oldLen) {
          deleted(oldItems[oldIndex++]);
          hasChanges = true;
        }
        return hasChanges;
      }
      ts3.enumerateInsertsAndDeletes = enumerateInsertsAndDeletes;
      function fill(length2, cb) {
        var result2 = Array(length2);
        for (var i = 0; i < length2; i++) {
          result2[i] = cb(i);
        }
        return result2;
      }
      ts3.fill = fill;
      function cartesianProduct(arrays) {
        var result2 = [];
        cartesianProductWorker(arrays, result2, void 0, 0);
        return result2;
      }
      ts3.cartesianProduct = cartesianProduct;
      function cartesianProductWorker(arrays, result2, outer, index) {
        for (var _i = 0, _a = arrays[index]; _i < _a.length; _i++) {
          var element = _a[_i];
          var inner = void 0;
          if (outer) {
            inner = outer.slice();
            inner.push(element);
          } else {
            inner = [element];
          }
          if (index === arrays.length - 1) {
            result2.push(inner);
          } else {
            cartesianProductWorker(arrays, result2, inner, index + 1);
          }
        }
      }
      function padLeft(s, length2, padString) {
        if (padString === void 0) {
          padString = " ";
        }
        return length2 <= s.length ? s : padString.repeat(length2 - s.length) + s;
      }
      ts3.padLeft = padLeft;
      function padRight(s, length2, padString) {
        if (padString === void 0) {
          padString = " ";
        }
        return length2 <= s.length ? s : s + padString.repeat(length2 - s.length);
      }
      ts3.padRight = padRight;
      function takeWhile(array, predicate) {
        var len = array.length;
        var index = 0;
        while (index < len && predicate(array[index])) {
          index++;
        }
        return array.slice(0, index);
      }
      ts3.takeWhile = takeWhile;
      ts3.trimString = !!String.prototype.trim ? function(s) {
        return s.trim();
      } : function(s) {
        return ts3.trimStringEnd(ts3.trimStringStart(s));
      };
      ts3.trimStringEnd = !!String.prototype.trimEnd ? function(s) {
        return s.trimEnd();
      } : trimEndImpl;
      ts3.trimStringStart = !!String.prototype.trimStart ? function(s) {
        return s.trimStart();
      } : function(s) {
        return s.replace(/^\s+/g, "");
      };
      function trimEndImpl(s) {
        var end = s.length - 1;
        while (end >= 0) {
          if (!ts3.isWhiteSpaceLike(s.charCodeAt(end)))
            break;
          end--;
        }
        return s.slice(0, end + 1);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var LogLevel;
      (function(LogLevel2) {
        LogLevel2[LogLevel2["Off"] = 0] = "Off";
        LogLevel2[LogLevel2["Error"] = 1] = "Error";
        LogLevel2[LogLevel2["Warning"] = 2] = "Warning";
        LogLevel2[LogLevel2["Info"] = 3] = "Info";
        LogLevel2[LogLevel2["Verbose"] = 4] = "Verbose";
      })(LogLevel = ts3.LogLevel || (ts3.LogLevel = {}));
      var Debug;
      (function(Debug2) {
        var typeScriptVersion;
        var currentAssertionLevel = 0;
        Debug2.currentLogLevel = LogLevel.Warning;
        Debug2.isDebugging = false;
        function getTypeScriptVersion() {
          return typeScriptVersion !== null && typeScriptVersion !== void 0 ? typeScriptVersion : typeScriptVersion = new ts3.Version(ts3.version);
        }
        Debug2.getTypeScriptVersion = getTypeScriptVersion;
        function shouldLog(level) {
          return Debug2.currentLogLevel <= level;
        }
        Debug2.shouldLog = shouldLog;
        function logMessage(level, s) {
          if (Debug2.loggingHost && shouldLog(level)) {
            Debug2.loggingHost.log(level, s);
          }
        }
        function log(s) {
          logMessage(LogLevel.Info, s);
        }
        Debug2.log = log;
        (function(log_1) {
          function error(s) {
            logMessage(LogLevel.Error, s);
          }
          log_1.error = error;
          function warn(s) {
            logMessage(LogLevel.Warning, s);
          }
          log_1.warn = warn;
          function log2(s) {
            logMessage(LogLevel.Info, s);
          }
          log_1.log = log2;
          function trace(s) {
            logMessage(LogLevel.Verbose, s);
          }
          log_1.trace = trace;
        })(log = Debug2.log || (Debug2.log = {}));
        var assertionCache = {};
        function getAssertionLevel() {
          return currentAssertionLevel;
        }
        Debug2.getAssertionLevel = getAssertionLevel;
        function setAssertionLevel(level) {
          var prevAssertionLevel = currentAssertionLevel;
          currentAssertionLevel = level;
          if (level > prevAssertionLevel) {
            for (var _i = 0, _a = ts3.getOwnKeys(assertionCache); _i < _a.length; _i++) {
              var key = _a[_i];
              var cachedFunc = assertionCache[key];
              if (cachedFunc !== void 0 && Debug2[key] !== cachedFunc.assertion && level >= cachedFunc.level) {
                Debug2[key] = cachedFunc;
                assertionCache[key] = void 0;
              }
            }
          }
        }
        Debug2.setAssertionLevel = setAssertionLevel;
        function shouldAssert(level) {
          return currentAssertionLevel >= level;
        }
        Debug2.shouldAssert = shouldAssert;
        function shouldAssertFunction(level, name) {
          if (!shouldAssert(level)) {
            assertionCache[name] = { level, assertion: Debug2[name] };
            Debug2[name] = ts3.noop;
            return false;
          }
          return true;
        }
        function fail(message, stackCrawlMark) {
          debugger;
          var e = new Error(message ? "Debug Failure. ".concat(message) : "Debug Failure.");
          if (Error.captureStackTrace) {
            Error.captureStackTrace(e, stackCrawlMark || fail);
          }
          throw e;
        }
        Debug2.fail = fail;
        function failBadSyntaxKind(node, message, stackCrawlMark) {
          return fail("".concat(message || "Unexpected node.", "\r\nNode ").concat(formatSyntaxKind(node.kind), " was unexpected."), stackCrawlMark || failBadSyntaxKind);
        }
        Debug2.failBadSyntaxKind = failBadSyntaxKind;
        function assert(expression, message, verboseDebugInfo, stackCrawlMark) {
          if (!expression) {
            message = message ? "False expression: ".concat(message) : "False expression.";
            if (verboseDebugInfo) {
              message += "\r\nVerbose Debug Information: " + (typeof verboseDebugInfo === "string" ? verboseDebugInfo : verboseDebugInfo());
            }
            fail(message, stackCrawlMark || assert);
          }
        }
        Debug2.assert = assert;
        function assertEqual(a, b, msg, msg2, stackCrawlMark) {
          if (a !== b) {
            var message = msg ? msg2 ? "".concat(msg, " ").concat(msg2) : msg : "";
            fail("Expected ".concat(a, " === ").concat(b, ". ").concat(message), stackCrawlMark || assertEqual);
          }
        }
        Debug2.assertEqual = assertEqual;
        function assertLessThan(a, b, msg, stackCrawlMark) {
          if (a >= b) {
            fail("Expected ".concat(a, " < ").concat(b, ". ").concat(msg || ""), stackCrawlMark || assertLessThan);
          }
        }
        Debug2.assertLessThan = assertLessThan;
        function assertLessThanOrEqual(a, b, stackCrawlMark) {
          if (a > b) {
            fail("Expected ".concat(a, " <= ").concat(b), stackCrawlMark || assertLessThanOrEqual);
          }
        }
        Debug2.assertLessThanOrEqual = assertLessThanOrEqual;
        function assertGreaterThanOrEqual(a, b, stackCrawlMark) {
          if (a < b) {
            fail("Expected ".concat(a, " >= ").concat(b), stackCrawlMark || assertGreaterThanOrEqual);
          }
        }
        Debug2.assertGreaterThanOrEqual = assertGreaterThanOrEqual;
        function assertIsDefined(value, message, stackCrawlMark) {
          if (value === void 0 || value === null) {
            fail(message, stackCrawlMark || assertIsDefined);
          }
        }
        Debug2.assertIsDefined = assertIsDefined;
        function checkDefined(value, message, stackCrawlMark) {
          assertIsDefined(value, message, stackCrawlMark || checkDefined);
          return value;
        }
        Debug2.checkDefined = checkDefined;
        function assertEachIsDefined(value, message, stackCrawlMark) {
          for (var _i = 0, value_1 = value; _i < value_1.length; _i++) {
            var v = value_1[_i];
            assertIsDefined(v, message, stackCrawlMark || assertEachIsDefined);
          }
        }
        Debug2.assertEachIsDefined = assertEachIsDefined;
        function checkEachDefined(value, message, stackCrawlMark) {
          assertEachIsDefined(value, message, stackCrawlMark || checkEachDefined);
          return value;
        }
        Debug2.checkEachDefined = checkEachDefined;
        function assertNever(member, message, stackCrawlMark) {
          if (message === void 0) {
            message = "Illegal value:";
          }
          var detail = typeof member === "object" && ts3.hasProperty(member, "kind") && ts3.hasProperty(member, "pos") ? "SyntaxKind: " + formatSyntaxKind(member.kind) : JSON.stringify(member);
          return fail("".concat(message, " ").concat(detail), stackCrawlMark || assertNever);
        }
        Debug2.assertNever = assertNever;
        function assertEachNode(nodes, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertEachNode")) {
            assert(test === void 0 || ts3.every(nodes, test), message || "Unexpected node.", function() {
              return "Node array did not pass test '".concat(getFunctionName(test), "'.");
            }, stackCrawlMark || assertEachNode);
          }
        }
        Debug2.assertEachNode = assertEachNode;
        function assertNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertNode")) {
            assert(node !== void 0 && (test === void 0 || test(node)), message || "Unexpected node.", function() {
              return "Node ".concat(formatSyntaxKind(node === null || node === void 0 ? void 0 : node.kind), " did not pass test '").concat(getFunctionName(test), "'.");
            }, stackCrawlMark || assertNode);
          }
        }
        Debug2.assertNode = assertNode;
        function assertNotNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertNotNode")) {
            assert(node === void 0 || test === void 0 || !test(node), message || "Unexpected node.", function() {
              return "Node ".concat(formatSyntaxKind(node.kind), " should not have passed test '").concat(getFunctionName(test), "'.");
            }, stackCrawlMark || assertNotNode);
          }
        }
        Debug2.assertNotNode = assertNotNode;
        function assertOptionalNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertOptionalNode")) {
            assert(test === void 0 || node === void 0 || test(node), message || "Unexpected node.", function() {
              return "Node ".concat(formatSyntaxKind(node === null || node === void 0 ? void 0 : node.kind), " did not pass test '").concat(getFunctionName(test), "'.");
            }, stackCrawlMark || assertOptionalNode);
          }
        }
        Debug2.assertOptionalNode = assertOptionalNode;
        function assertOptionalToken(node, kind, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertOptionalToken")) {
            assert(kind === void 0 || node === void 0 || node.kind === kind, message || "Unexpected node.", function() {
              return "Node ".concat(formatSyntaxKind(node === null || node === void 0 ? void 0 : node.kind), " was not a '").concat(formatSyntaxKind(kind), "' token.");
            }, stackCrawlMark || assertOptionalToken);
          }
        }
        Debug2.assertOptionalToken = assertOptionalToken;
        function assertMissingNode(node, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertMissingNode")) {
            assert(node === void 0, message || "Unexpected node.", function() {
              return "Node ".concat(formatSyntaxKind(node.kind), " was unexpected'.");
            }, stackCrawlMark || assertMissingNode);
          }
        }
        Debug2.assertMissingNode = assertMissingNode;
        function type2(_value) {
        }
        Debug2.type = type2;
        function getFunctionName(func) {
          if (typeof func !== "function") {
            return "";
          } else if (func.hasOwnProperty("name")) {
            return func.name;
          } else {
            var text = Function.prototype.toString.call(func);
            var match = /^function\s+([\w\$]+)\s*\(/.exec(text);
            return match ? match[1] : "";
          }
        }
        Debug2.getFunctionName = getFunctionName;
        function formatSymbol(symbol) {
          return "{ name: ".concat(ts3.unescapeLeadingUnderscores(symbol.escapedName), "; flags: ").concat(formatSymbolFlags(symbol.flags), "; declarations: ").concat(ts3.map(symbol.declarations, function(node) {
            return formatSyntaxKind(node.kind);
          }), " }");
        }
        Debug2.formatSymbol = formatSymbol;
        function formatEnum(value, enumObject, isFlags) {
          if (value === void 0) {
            value = 0;
          }
          var members = getEnumMembers(enumObject);
          if (value === 0) {
            return members.length > 0 && members[0][0] === 0 ? members[0][1] : "0";
          }
          if (isFlags) {
            var result2 = "";
            var remainingFlags = value;
            for (var _i = 0, members_1 = members; _i < members_1.length; _i++) {
              var _a = members_1[_i], enumValue = _a[0], enumName = _a[1];
              if (enumValue > value) {
                break;
              }
              if (enumValue !== 0 && enumValue & value) {
                result2 = "".concat(result2).concat(result2 ? "|" : "").concat(enumName);
                remainingFlags &= ~enumValue;
              }
            }
            if (remainingFlags === 0) {
              return result2;
            }
          } else {
            for (var _b = 0, members_2 = members; _b < members_2.length; _b++) {
              var _c = members_2[_b], enumValue = _c[0], enumName = _c[1];
              if (enumValue === value) {
                return enumName;
              }
            }
          }
          return value.toString();
        }
        Debug2.formatEnum = formatEnum;
        function getEnumMembers(enumObject) {
          var result2 = [];
          for (var name in enumObject) {
            var value = enumObject[name];
            if (typeof value === "number") {
              result2.push([value, name]);
            }
          }
          return ts3.stableSort(result2, function(x, y) {
            return ts3.compareValues(x[0], y[0]);
          });
        }
        function formatSyntaxKind(kind) {
          return formatEnum(kind, ts3.SyntaxKind, false);
        }
        Debug2.formatSyntaxKind = formatSyntaxKind;
        function formatSnippetKind(kind) {
          return formatEnum(kind, ts3.SnippetKind, false);
        }
        Debug2.formatSnippetKind = formatSnippetKind;
        function formatNodeFlags(flags) {
          return formatEnum(flags, ts3.NodeFlags, true);
        }
        Debug2.formatNodeFlags = formatNodeFlags;
        function formatModifierFlags(flags) {
          return formatEnum(flags, ts3.ModifierFlags, true);
        }
        Debug2.formatModifierFlags = formatModifierFlags;
        function formatTransformFlags(flags) {
          return formatEnum(flags, ts3.TransformFlags, true);
        }
        Debug2.formatTransformFlags = formatTransformFlags;
        function formatEmitFlags(flags) {
          return formatEnum(flags, ts3.EmitFlags, true);
        }
        Debug2.formatEmitFlags = formatEmitFlags;
        function formatSymbolFlags(flags) {
          return formatEnum(flags, ts3.SymbolFlags, true);
        }
        Debug2.formatSymbolFlags = formatSymbolFlags;
        function formatTypeFlags(flags) {
          return formatEnum(flags, ts3.TypeFlags, true);
        }
        Debug2.formatTypeFlags = formatTypeFlags;
        function formatSignatureFlags(flags) {
          return formatEnum(flags, ts3.SignatureFlags, true);
        }
        Debug2.formatSignatureFlags = formatSignatureFlags;
        function formatObjectFlags(flags) {
          return formatEnum(flags, ts3.ObjectFlags, true);
        }
        Debug2.formatObjectFlags = formatObjectFlags;
        function formatFlowFlags(flags) {
          return formatEnum(flags, ts3.FlowFlags, true);
        }
        Debug2.formatFlowFlags = formatFlowFlags;
        var isDebugInfoEnabled = false;
        var extendedDebugModule;
        function extendedDebug() {
          enableDebugInfo();
          if (!extendedDebugModule) {
            throw new Error("Debugging helpers could not be loaded.");
          }
          return extendedDebugModule;
        }
        function printControlFlowGraph(flowNode) {
          return console.log(formatControlFlowGraph(flowNode));
        }
        Debug2.printControlFlowGraph = printControlFlowGraph;
        function formatControlFlowGraph(flowNode) {
          return extendedDebug().formatControlFlowGraph(flowNode);
        }
        Debug2.formatControlFlowGraph = formatControlFlowGraph;
        var flowNodeProto;
        function attachFlowNodeDebugInfoWorker(flowNode) {
          if (!("__debugFlowFlags" in flowNode)) {
            Object.defineProperties(flowNode, {
              __tsDebuggerDisplay: {
                value: function() {
                  var flowHeader = this.flags & 2 ? "FlowStart" : this.flags & 4 ? "FlowBranchLabel" : this.flags & 8 ? "FlowLoopLabel" : this.flags & 16 ? "FlowAssignment" : this.flags & 32 ? "FlowTrueCondition" : this.flags & 64 ? "FlowFalseCondition" : this.flags & 128 ? "FlowSwitchClause" : this.flags & 256 ? "FlowArrayMutation" : this.flags & 512 ? "FlowCall" : this.flags & 1024 ? "FlowReduceLabel" : this.flags & 1 ? "FlowUnreachable" : "UnknownFlow";
                  var remainingFlags = this.flags & ~(2048 - 1);
                  return "".concat(flowHeader).concat(remainingFlags ? " (".concat(formatFlowFlags(remainingFlags), ")") : "");
                }
              },
              __debugFlowFlags: { get: function() {
                return formatEnum(this.flags, ts3.FlowFlags, true);
              } },
              __debugToString: { value: function() {
                return formatControlFlowGraph(this);
              } }
            });
          }
        }
        function attachFlowNodeDebugInfo(flowNode) {
          if (isDebugInfoEnabled) {
            if (typeof Object.setPrototypeOf === "function") {
              if (!flowNodeProto) {
                flowNodeProto = Object.create(Object.prototype);
                attachFlowNodeDebugInfoWorker(flowNodeProto);
              }
              Object.setPrototypeOf(flowNode, flowNodeProto);
            } else {
              attachFlowNodeDebugInfoWorker(flowNode);
            }
          }
        }
        Debug2.attachFlowNodeDebugInfo = attachFlowNodeDebugInfo;
        var nodeArrayProto;
        function attachNodeArrayDebugInfoWorker(array) {
          if (!("__tsDebuggerDisplay" in array)) {
            Object.defineProperties(array, {
              __tsDebuggerDisplay: {
                value: function(defaultValue) {
                  defaultValue = String(defaultValue).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/, "]");
                  return "NodeArray ".concat(defaultValue);
                }
              }
            });
          }
        }
        function attachNodeArrayDebugInfo(array) {
          if (isDebugInfoEnabled) {
            if (typeof Object.setPrototypeOf === "function") {
              if (!nodeArrayProto) {
                nodeArrayProto = Object.create(Array.prototype);
                attachNodeArrayDebugInfoWorker(nodeArrayProto);
              }
              Object.setPrototypeOf(array, nodeArrayProto);
            } else {
              attachNodeArrayDebugInfoWorker(array);
            }
          }
        }
        Debug2.attachNodeArrayDebugInfo = attachNodeArrayDebugInfo;
        function enableDebugInfo() {
          if (isDebugInfoEnabled)
            return;
          var weakTypeTextMap;
          var weakNodeTextMap;
          function getWeakTypeTextMap() {
            if (weakTypeTextMap === void 0) {
              if (typeof WeakMap === "function")
                weakTypeTextMap = /* @__PURE__ */ new WeakMap();
            }
            return weakTypeTextMap;
          }
          function getWeakNodeTextMap() {
            if (weakNodeTextMap === void 0) {
              if (typeof WeakMap === "function")
                weakNodeTextMap = /* @__PURE__ */ new WeakMap();
            }
            return weakNodeTextMap;
          }
          Object.defineProperties(ts3.objectAllocator.getSymbolConstructor().prototype, {
            __tsDebuggerDisplay: {
              value: function() {
                var symbolHeader = this.flags & 33554432 ? "TransientSymbol" : "Symbol";
                var remainingSymbolFlags = this.flags & ~33554432;
                return "".concat(symbolHeader, " '").concat(ts3.symbolName(this), "'").concat(remainingSymbolFlags ? " (".concat(formatSymbolFlags(remainingSymbolFlags), ")") : "");
              }
            },
            __debugFlags: { get: function() {
              return formatSymbolFlags(this.flags);
            } }
          });
          Object.defineProperties(ts3.objectAllocator.getTypeConstructor().prototype, {
            __tsDebuggerDisplay: {
              value: function() {
                var typeHeader = this.flags & 98304 ? "NullableType" : this.flags & 384 ? "LiteralType ".concat(JSON.stringify(this.value)) : this.flags & 2048 ? "LiteralType ".concat(this.value.negative ? "-" : "").concat(this.value.base10Value, "n") : this.flags & 8192 ? "UniqueESSymbolType" : this.flags & 32 ? "EnumType" : this.flags & 67359327 ? "IntrinsicType ".concat(this.intrinsicName) : this.flags & 1048576 ? "UnionType" : this.flags & 2097152 ? "IntersectionType" : this.flags & 4194304 ? "IndexType" : this.flags & 8388608 ? "IndexedAccessType" : this.flags & 16777216 ? "ConditionalType" : this.flags & 33554432 ? "SubstitutionType" : this.flags & 262144 ? "TypeParameter" : this.flags & 524288 ? this.objectFlags & 3 ? "InterfaceType" : this.objectFlags & 4 ? "TypeReference" : this.objectFlags & 8 ? "TupleType" : this.objectFlags & 16 ? "AnonymousType" : this.objectFlags & 32 ? "MappedType" : this.objectFlags & 1024 ? "ReverseMappedType" : this.objectFlags & 256 ? "EvolvingArrayType" : "ObjectType" : "Type";
                var remainingObjectFlags = this.flags & 524288 ? this.objectFlags & ~1343 : 0;
                return "".concat(typeHeader).concat(this.symbol ? " '".concat(ts3.symbolName(this.symbol), "'") : "").concat(remainingObjectFlags ? " (".concat(formatObjectFlags(remainingObjectFlags), ")") : "");
              }
            },
            __debugFlags: { get: function() {
              return formatTypeFlags(this.flags);
            } },
            __debugObjectFlags: { get: function() {
              return this.flags & 524288 ? formatObjectFlags(this.objectFlags) : "";
            } },
            __debugTypeToString: {
              value: function() {
                var map2 = getWeakTypeTextMap();
                var text = map2 === null || map2 === void 0 ? void 0 : map2.get(this);
                if (text === void 0) {
                  text = this.checker.typeToString(this);
                  map2 === null || map2 === void 0 ? void 0 : map2.set(this, text);
                }
                return text;
              }
            }
          });
          Object.defineProperties(ts3.objectAllocator.getSignatureConstructor().prototype, {
            __debugFlags: { get: function() {
              return formatSignatureFlags(this.flags);
            } },
            __debugSignatureToString: { value: function() {
              var _a;
              return (_a = this.checker) === null || _a === void 0 ? void 0 : _a.signatureToString(this);
            } }
          });
          var nodeConstructors = [
            ts3.objectAllocator.getNodeConstructor(),
            ts3.objectAllocator.getIdentifierConstructor(),
            ts3.objectAllocator.getTokenConstructor(),
            ts3.objectAllocator.getSourceFileConstructor()
          ];
          for (var _i = 0, nodeConstructors_1 = nodeConstructors; _i < nodeConstructors_1.length; _i++) {
            var ctor = nodeConstructors_1[_i];
            if (!ctor.prototype.hasOwnProperty("__debugKind")) {
              Object.defineProperties(ctor.prototype, {
                __tsDebuggerDisplay: {
                  value: function() {
                    var nodeHeader = ts3.isGeneratedIdentifier(this) ? "GeneratedIdentifier" : ts3.isIdentifier(this) ? "Identifier '".concat(ts3.idText(this), "'") : ts3.isPrivateIdentifier(this) ? "PrivateIdentifier '".concat(ts3.idText(this), "'") : ts3.isStringLiteral(this) ? "StringLiteral ".concat(JSON.stringify(this.text.length < 10 ? this.text : this.text.slice(10) + "...")) : ts3.isNumericLiteral(this) ? "NumericLiteral ".concat(this.text) : ts3.isBigIntLiteral(this) ? "BigIntLiteral ".concat(this.text, "n") : ts3.isTypeParameterDeclaration(this) ? "TypeParameterDeclaration" : ts3.isParameter(this) ? "ParameterDeclaration" : ts3.isConstructorDeclaration(this) ? "ConstructorDeclaration" : ts3.isGetAccessorDeclaration(this) ? "GetAccessorDeclaration" : ts3.isSetAccessorDeclaration(this) ? "SetAccessorDeclaration" : ts3.isCallSignatureDeclaration(this) ? "CallSignatureDeclaration" : ts3.isConstructSignatureDeclaration(this) ? "ConstructSignatureDeclaration" : ts3.isIndexSignatureDeclaration(this) ? "IndexSignatureDeclaration" : ts3.isTypePredicateNode(this) ? "TypePredicateNode" : ts3.isTypeReferenceNode(this) ? "TypeReferenceNode" : ts3.isFunctionTypeNode(this) ? "FunctionTypeNode" : ts3.isConstructorTypeNode(this) ? "ConstructorTypeNode" : ts3.isTypeQueryNode(this) ? "TypeQueryNode" : ts3.isTypeLiteralNode(this) ? "TypeLiteralNode" : ts3.isArrayTypeNode(this) ? "ArrayTypeNode" : ts3.isTupleTypeNode(this) ? "TupleTypeNode" : ts3.isOptionalTypeNode(this) ? "OptionalTypeNode" : ts3.isRestTypeNode(this) ? "RestTypeNode" : ts3.isUnionTypeNode(this) ? "UnionTypeNode" : ts3.isIntersectionTypeNode(this) ? "IntersectionTypeNode" : ts3.isConditionalTypeNode(this) ? "ConditionalTypeNode" : ts3.isInferTypeNode(this) ? "InferTypeNode" : ts3.isParenthesizedTypeNode(this) ? "ParenthesizedTypeNode" : ts3.isThisTypeNode(this) ? "ThisTypeNode" : ts3.isTypeOperatorNode(this) ? "TypeOperatorNode" : ts3.isIndexedAccessTypeNode(this) ? "IndexedAccessTypeNode" : ts3.isMappedTypeNode(this) ? "MappedTypeNode" : ts3.isLiteralTypeNode(this) ? "LiteralTypeNode" : ts3.isNamedTupleMember(this) ? "NamedTupleMember" : ts3.isImportTypeNode(this) ? "ImportTypeNode" : formatSyntaxKind(this.kind);
                    return "".concat(nodeHeader).concat(this.flags ? " (".concat(formatNodeFlags(this.flags), ")") : "");
                  }
                },
                __debugKind: { get: function() {
                  return formatSyntaxKind(this.kind);
                } },
                __debugNodeFlags: { get: function() {
                  return formatNodeFlags(this.flags);
                } },
                __debugModifierFlags: { get: function() {
                  return formatModifierFlags(ts3.getEffectiveModifierFlagsNoCache(this));
                } },
                __debugTransformFlags: { get: function() {
                  return formatTransformFlags(this.transformFlags);
                } },
                __debugIsParseTreeNode: { get: function() {
                  return ts3.isParseTreeNode(this);
                } },
                __debugEmitFlags: { get: function() {
                  return formatEmitFlags(ts3.getEmitFlags(this));
                } },
                __debugGetText: {
                  value: function(includeTrivia) {
                    if (ts3.nodeIsSynthesized(this))
                      return "";
                    var map2 = getWeakNodeTextMap();
                    var text = map2 === null || map2 === void 0 ? void 0 : map2.get(this);
                    if (text === void 0) {
                      var parseNode = ts3.getParseTreeNode(this);
                      var sourceFile = parseNode && ts3.getSourceFileOfNode(parseNode);
                      text = sourceFile ? ts3.getSourceTextOfNodeFromSourceFile(sourceFile, parseNode, includeTrivia) : "";
                      map2 === null || map2 === void 0 ? void 0 : map2.set(this, text);
                    }
                    return text;
                  }
                }
              });
            }
          }
          try {
            if (ts3.sys && ts3.sys.require) {
              var basePath = ts3.getDirectoryPath(ts3.resolvePath(ts3.sys.getExecutingFilePath()));
              var result2 = ts3.sys.require(basePath, "./compiler-debug");
              if (!result2.error) {
                result2.module.init(ts3);
                extendedDebugModule = result2.module;
              }
            }
          } catch (_a) {
          }
          isDebugInfoEnabled = true;
        }
        Debug2.enableDebugInfo = enableDebugInfo;
        function formatDeprecationMessage(name, error, errorAfter, since, message) {
          var deprecationMessage = error ? "DeprecationError: " : "DeprecationWarning: ";
          deprecationMessage += "'".concat(name, "' ");
          deprecationMessage += since ? "has been deprecated since v".concat(since) : "is deprecated";
          deprecationMessage += error ? " and can no longer be used." : errorAfter ? " and will no longer be usable after v".concat(errorAfter, ".") : ".";
          deprecationMessage += message ? " ".concat(ts3.formatStringFromArgs(message, [name], 0)) : "";
          return deprecationMessage;
        }
        function createErrorDeprecation(name, errorAfter, since, message) {
          var deprecationMessage = formatDeprecationMessage(name, true, errorAfter, since, message);
          return function() {
            throw new TypeError(deprecationMessage);
          };
        }
        function createWarningDeprecation(name, errorAfter, since, message) {
          var hasWrittenDeprecation = false;
          return function() {
            if (!hasWrittenDeprecation) {
              log.warn(formatDeprecationMessage(name, false, errorAfter, since, message));
              hasWrittenDeprecation = true;
            }
          };
        }
        function createDeprecation(name, options) {
          var _a, _b;
          if (options === void 0) {
            options = {};
          }
          var version = typeof options.typeScriptVersion === "string" ? new ts3.Version(options.typeScriptVersion) : (_a = options.typeScriptVersion) !== null && _a !== void 0 ? _a : getTypeScriptVersion();
          var errorAfter = typeof options.errorAfter === "string" ? new ts3.Version(options.errorAfter) : options.errorAfter;
          var warnAfter = typeof options.warnAfter === "string" ? new ts3.Version(options.warnAfter) : options.warnAfter;
          var since = typeof options.since === "string" ? new ts3.Version(options.since) : (_b = options.since) !== null && _b !== void 0 ? _b : warnAfter;
          var error = options.error || errorAfter && version.compareTo(errorAfter) <= 0;
          var warn = !warnAfter || version.compareTo(warnAfter) >= 0;
          return error ? createErrorDeprecation(name, errorAfter, since, options.message) : warn ? createWarningDeprecation(name, errorAfter, since, options.message) : ts3.noop;
        }
        function wrapFunction(deprecation, func) {
          return function() {
            deprecation();
            return func.apply(this, arguments);
          };
        }
        function deprecate(func, options) {
          var deprecation = createDeprecation(getFunctionName(func), options);
          return wrapFunction(deprecation, func);
        }
        Debug2.deprecate = deprecate;
      })(Debug = ts3.Debug || (ts3.Debug = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var versionRegExp = /^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
      var prereleaseRegExp = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i;
      var buildRegExp = /^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i;
      var numericIdentifierRegExp = /^(0|[1-9]\d*)$/;
      var Version = function() {
        function Version2(major, minor, patch, prerelease, build) {
          if (minor === void 0) {
            minor = 0;
          }
          if (patch === void 0) {
            patch = 0;
          }
          if (prerelease === void 0) {
            prerelease = "";
          }
          if (build === void 0) {
            build = "";
          }
          if (typeof major === "string") {
            var result2 = ts3.Debug.checkDefined(tryParseComponents(major), "Invalid version");
            major = result2.major, minor = result2.minor, patch = result2.patch, prerelease = result2.prerelease, build = result2.build;
          }
          ts3.Debug.assert(major >= 0, "Invalid argument: major");
          ts3.Debug.assert(minor >= 0, "Invalid argument: minor");
          ts3.Debug.assert(patch >= 0, "Invalid argument: patch");
          ts3.Debug.assert(!prerelease || prereleaseRegExp.test(prerelease), "Invalid argument: prerelease");
          ts3.Debug.assert(!build || buildRegExp.test(build), "Invalid argument: build");
          this.major = major;
          this.minor = minor;
          this.patch = patch;
          this.prerelease = prerelease ? prerelease.split(".") : ts3.emptyArray;
          this.build = build ? build.split(".") : ts3.emptyArray;
        }
        Version2.tryParse = function(text) {
          var result2 = tryParseComponents(text);
          if (!result2)
            return void 0;
          var major = result2.major, minor = result2.minor, patch = result2.patch, prerelease = result2.prerelease, build = result2.build;
          return new Version2(major, minor, patch, prerelease, build);
        };
        Version2.prototype.compareTo = function(other) {
          if (this === other)
            return 0;
          if (other === void 0)
            return 1;
          return ts3.compareValues(this.major, other.major) || ts3.compareValues(this.minor, other.minor) || ts3.compareValues(this.patch, other.patch) || comparePrereleaseIdentifiers(this.prerelease, other.prerelease);
        };
        Version2.prototype.increment = function(field) {
          switch (field) {
            case "major":
              return new Version2(this.major + 1, 0, 0);
            case "minor":
              return new Version2(this.major, this.minor + 1, 0);
            case "patch":
              return new Version2(this.major, this.minor, this.patch + 1);
            default:
              return ts3.Debug.assertNever(field);
          }
        };
        Version2.prototype.toString = function() {
          var result2 = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch);
          if (ts3.some(this.prerelease))
            result2 += "-".concat(this.prerelease.join("."));
          if (ts3.some(this.build))
            result2 += "+".concat(this.build.join("."));
          return result2;
        };
        Version2.zero = new Version2(0, 0, 0);
        return Version2;
      }();
      ts3.Version = Version;
      function tryParseComponents(text) {
        var match = versionRegExp.exec(text);
        if (!match)
          return void 0;
        var major = match[1], _a = match[2], minor = _a === void 0 ? "0" : _a, _b = match[3], patch = _b === void 0 ? "0" : _b, _c = match[4], prerelease = _c === void 0 ? "" : _c, _d = match[5], build = _d === void 0 ? "" : _d;
        if (prerelease && !prereleaseRegExp.test(prerelease))
          return void 0;
        if (build && !buildRegExp.test(build))
          return void 0;
        return {
          major: parseInt(major, 10),
          minor: parseInt(minor, 10),
          patch: parseInt(patch, 10),
          prerelease,
          build
        };
      }
      function comparePrereleaseIdentifiers(left, right) {
        if (left === right)
          return 0;
        if (left.length === 0)
          return right.length === 0 ? 0 : 1;
        if (right.length === 0)
          return -1;
        var length = Math.min(left.length, right.length);
        for (var i = 0; i < length; i++) {
          var leftIdentifier = left[i];
          var rightIdentifier = right[i];
          if (leftIdentifier === rightIdentifier)
            continue;
          var leftIsNumeric = numericIdentifierRegExp.test(leftIdentifier);
          var rightIsNumeric = numericIdentifierRegExp.test(rightIdentifier);
          if (leftIsNumeric || rightIsNumeric) {
            if (leftIsNumeric !== rightIsNumeric)
              return leftIsNumeric ? -1 : 1;
            var result2 = ts3.compareValues(+leftIdentifier, +rightIdentifier);
            if (result2)
              return result2;
          } else {
            var result2 = ts3.compareStringsCaseSensitive(leftIdentifier, rightIdentifier);
            if (result2)
              return result2;
          }
        }
        return ts3.compareValues(left.length, right.length);
      }
      var VersionRange = function() {
        function VersionRange2(spec) {
          this._alternatives = spec ? ts3.Debug.checkDefined(parseRange(spec), "Invalid range spec.") : ts3.emptyArray;
        }
        VersionRange2.tryParse = function(text) {
          var sets = parseRange(text);
          if (sets) {
            var range = new VersionRange2("");
            range._alternatives = sets;
            return range;
          }
          return void 0;
        };
        VersionRange2.prototype.test = function(version) {
          if (typeof version === "string")
            version = new Version(version);
          return testDisjunction(version, this._alternatives);
        };
        VersionRange2.prototype.toString = function() {
          return formatDisjunction(this._alternatives);
        };
        return VersionRange2;
      }();
      ts3.VersionRange = VersionRange;
      var logicalOrRegExp = /\|\|/g;
      var whitespaceRegExp = /\s+/g;
      var partialRegExp = /^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
      var hyphenRegExp = /^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i;
      var rangeRegExp = /^(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;
      function parseRange(text) {
        var alternatives = [];
        for (var _i = 0, _a = ts3.trimString(text).split(logicalOrRegExp); _i < _a.length; _i++) {
          var range = _a[_i];
          if (!range)
            continue;
          var comparators = [];
          range = ts3.trimString(range);
          var match = hyphenRegExp.exec(range);
          if (match) {
            if (!parseHyphen(match[1], match[2], comparators))
              return void 0;
          } else {
            for (var _b = 0, _c = range.split(whitespaceRegExp); _b < _c.length; _b++) {
              var simple = _c[_b];
              var match_1 = rangeRegExp.exec(ts3.trimString(simple));
              if (!match_1 || !parseComparator(match_1[1], match_1[2], comparators))
                return void 0;
            }
          }
          alternatives.push(comparators);
        }
        return alternatives;
      }
      function parsePartial(text) {
        var match = partialRegExp.exec(text);
        if (!match)
          return void 0;
        var major = match[1], _a = match[2], minor = _a === void 0 ? "*" : _a, _b = match[3], patch = _b === void 0 ? "*" : _b, prerelease = match[4], build = match[5];
        var version = new Version(isWildcard(major) ? 0 : parseInt(major, 10), isWildcard(major) || isWildcard(minor) ? 0 : parseInt(minor, 10), isWildcard(major) || isWildcard(minor) || isWildcard(patch) ? 0 : parseInt(patch, 10), prerelease, build);
        return { version, major, minor, patch };
      }
      function parseHyphen(left, right, comparators) {
        var leftResult = parsePartial(left);
        if (!leftResult)
          return false;
        var rightResult = parsePartial(right);
        if (!rightResult)
          return false;
        if (!isWildcard(leftResult.major)) {
          comparators.push(createComparator(">=", leftResult.version));
        }
        if (!isWildcard(rightResult.major)) {
          comparators.push(isWildcard(rightResult.minor) ? createComparator("<", rightResult.version.increment("major")) : isWildcard(rightResult.patch) ? createComparator("<", rightResult.version.increment("minor")) : createComparator("<=", rightResult.version));
        }
        return true;
      }
      function parseComparator(operator, text, comparators) {
        var result2 = parsePartial(text);
        if (!result2)
          return false;
        var version = result2.version, major = result2.major, minor = result2.minor, patch = result2.patch;
        if (!isWildcard(major)) {
          switch (operator) {
            case "~":
              comparators.push(createComparator(">=", version));
              comparators.push(createComparator("<", version.increment(isWildcard(minor) ? "major" : "minor")));
              break;
            case "^":
              comparators.push(createComparator(">=", version));
              comparators.push(createComparator("<", version.increment(version.major > 0 || isWildcard(minor) ? "major" : version.minor > 0 || isWildcard(patch) ? "minor" : "patch")));
              break;
            case "<":
            case ">=":
              comparators.push(createComparator(operator, version));
              break;
            case "<=":
            case ">":
              comparators.push(isWildcard(minor) ? createComparator(operator === "<=" ? "<" : ">=", version.increment("major")) : isWildcard(patch) ? createComparator(operator === "<=" ? "<" : ">=", version.increment("minor")) : createComparator(operator, version));
              break;
            case "=":
            case void 0:
              if (isWildcard(minor) || isWildcard(patch)) {
                comparators.push(createComparator(">=", version));
                comparators.push(createComparator("<", version.increment(isWildcard(minor) ? "major" : "minor")));
              } else {
                comparators.push(createComparator("=", version));
              }
              break;
            default:
              return false;
          }
        } else if (operator === "<" || operator === ">") {
          comparators.push(createComparator("<", Version.zero));
        }
        return true;
      }
      function isWildcard(part) {
        return part === "*" || part === "x" || part === "X";
      }
      function createComparator(operator, operand) {
        return { operator, operand };
      }
      function testDisjunction(version, alternatives) {
        if (alternatives.length === 0)
          return true;
        for (var _i = 0, alternatives_1 = alternatives; _i < alternatives_1.length; _i++) {
          var alternative = alternatives_1[_i];
          if (testAlternative(version, alternative))
            return true;
        }
        return false;
      }
      function testAlternative(version, comparators) {
        for (var _i = 0, comparators_1 = comparators; _i < comparators_1.length; _i++) {
          var comparator = comparators_1[_i];
          if (!testComparator(version, comparator.operator, comparator.operand))
            return false;
        }
        return true;
      }
      function testComparator(version, operator, operand) {
        var cmp = version.compareTo(operand);
        switch (operator) {
          case "<":
            return cmp < 0;
          case "<=":
            return cmp <= 0;
          case ">":
            return cmp > 0;
          case ">=":
            return cmp >= 0;
          case "=":
            return cmp === 0;
          default:
            return ts3.Debug.assertNever(operator);
        }
      }
      function formatDisjunction(alternatives) {
        return ts3.map(alternatives, formatAlternative).join(" || ") || "*";
      }
      function formatAlternative(comparators) {
        return ts3.map(comparators, formatComparator).join(" ");
      }
      function formatComparator(comparator) {
        return "".concat(comparator.operator).concat(comparator.operand);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function hasRequiredAPI(performance2, PerformanceObserver2) {
        return typeof performance2 === "object" && typeof performance2.timeOrigin === "number" && typeof performance2.mark === "function" && typeof performance2.measure === "function" && typeof performance2.now === "function" && typeof PerformanceObserver2 === "function";
      }
      function tryGetWebPerformanceHooks() {
        if (typeof performance === "object" && typeof PerformanceObserver === "function" && hasRequiredAPI(performance, PerformanceObserver)) {
          return {
            shouldWriteNativeEvents: true,
            performance,
            PerformanceObserver
          };
        }
      }
      function tryGetNodePerformanceHooks() {
        if (typeof process !== "undefined" && process.nextTick && !process.browser && typeof module2 === "object" && typeof require === "function") {
          try {
            var performance_1;
            var _a = require("perf_hooks"), nodePerformance_1 = _a.performance, PerformanceObserver_1 = _a.PerformanceObserver;
            if (hasRequiredAPI(nodePerformance_1, PerformanceObserver_1)) {
              performance_1 = nodePerformance_1;
              var version_1 = new ts3.Version(process.versions.node);
              var range = new ts3.VersionRange("<12.16.3 || 13 <13.13");
              if (range.test(version_1)) {
                performance_1 = {
                  get timeOrigin() {
                    return nodePerformance_1.timeOrigin;
                  },
                  now: function() {
                    return nodePerformance_1.now();
                  },
                  mark: function(name) {
                    return nodePerformance_1.mark(name);
                  },
                  measure: function(name, start, end) {
                    if (start === void 0) {
                      start = "nodeStart";
                    }
                    if (end === void 0) {
                      end = "__performance.measure-fix__";
                      nodePerformance_1.mark(end);
                    }
                    nodePerformance_1.measure(name, start, end);
                    if (end === "__performance.measure-fix__") {
                      nodePerformance_1.clearMarks("__performance.measure-fix__");
                    }
                  }
                };
              }
              return {
                shouldWriteNativeEvents: false,
                performance: performance_1,
                PerformanceObserver: PerformanceObserver_1
              };
            }
          } catch (_b) {
          }
        }
      }
      var nativePerformanceHooks = tryGetWebPerformanceHooks() || tryGetNodePerformanceHooks();
      var nativePerformance = nativePerformanceHooks === null || nativePerformanceHooks === void 0 ? void 0 : nativePerformanceHooks.performance;
      function tryGetNativePerformanceHooks() {
        return nativePerformanceHooks;
      }
      ts3.tryGetNativePerformanceHooks = tryGetNativePerformanceHooks;
      ts3.timestamp = nativePerformance ? function() {
        return nativePerformance.now();
      } : Date.now ? Date.now : function() {
        return +new Date();
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var performance2;
      (function(performance3) {
        var perfHooks;
        var performanceImpl;
        function createTimerIf(condition, measureName, startMarkName, endMarkName) {
          return condition ? createTimer(measureName, startMarkName, endMarkName) : performance3.nullTimer;
        }
        performance3.createTimerIf = createTimerIf;
        function createTimer(measureName, startMarkName, endMarkName) {
          var enterCount = 0;
          return {
            enter,
            exit
          };
          function enter() {
            if (++enterCount === 1) {
              mark(startMarkName);
            }
          }
          function exit() {
            if (--enterCount === 0) {
              mark(endMarkName);
              measure(measureName, startMarkName, endMarkName);
            } else if (enterCount < 0) {
              ts3.Debug.fail("enter/exit count does not match.");
            }
          }
        }
        performance3.createTimer = createTimer;
        performance3.nullTimer = { enter: ts3.noop, exit: ts3.noop };
        var enabled = false;
        var timeorigin = ts3.timestamp();
        var marks = new ts3.Map();
        var counts = new ts3.Map();
        var durations = new ts3.Map();
        function mark(markName) {
          var _a;
          if (enabled) {
            var count = (_a = counts.get(markName)) !== null && _a !== void 0 ? _a : 0;
            counts.set(markName, count + 1);
            marks.set(markName, ts3.timestamp());
            performanceImpl === null || performanceImpl === void 0 ? void 0 : performanceImpl.mark(markName);
          }
        }
        performance3.mark = mark;
        function measure(measureName, startMarkName, endMarkName) {
          var _a, _b;
          if (enabled) {
            var end = (_a = endMarkName !== void 0 ? marks.get(endMarkName) : void 0) !== null && _a !== void 0 ? _a : ts3.timestamp();
            var start = (_b = startMarkName !== void 0 ? marks.get(startMarkName) : void 0) !== null && _b !== void 0 ? _b : timeorigin;
            var previousDuration = durations.get(measureName) || 0;
            durations.set(measureName, previousDuration + (end - start));
            performanceImpl === null || performanceImpl === void 0 ? void 0 : performanceImpl.measure(measureName, startMarkName, endMarkName);
          }
        }
        performance3.measure = measure;
        function getCount(markName) {
          return counts.get(markName) || 0;
        }
        performance3.getCount = getCount;
        function getDuration(measureName) {
          return durations.get(measureName) || 0;
        }
        performance3.getDuration = getDuration;
        function forEachMeasure(cb) {
          durations.forEach(function(duration, measureName) {
            return cb(measureName, duration);
          });
        }
        performance3.forEachMeasure = forEachMeasure;
        function isEnabled() {
          return enabled;
        }
        performance3.isEnabled = isEnabled;
        function enable(system) {
          var _a;
          if (system === void 0) {
            system = ts3.sys;
          }
          if (!enabled) {
            enabled = true;
            perfHooks || (perfHooks = ts3.tryGetNativePerformanceHooks());
            if (perfHooks) {
              timeorigin = perfHooks.performance.timeOrigin;
              if (perfHooks.shouldWriteNativeEvents || ((_a = system === null || system === void 0 ? void 0 : system.cpuProfilingEnabled) === null || _a === void 0 ? void 0 : _a.call(system)) || (system === null || system === void 0 ? void 0 : system.debugMode)) {
                performanceImpl = perfHooks.performance;
              }
            }
          }
          return true;
        }
        performance3.enable = enable;
        function disable() {
          if (enabled) {
            marks.clear();
            counts.clear();
            durations.clear();
            performanceImpl = void 0;
            enabled = false;
          }
        }
        performance3.disable = disable;
      })(performance2 = ts3.performance || (ts3.performance = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var _a;
      var nullLogger = {
        logEvent: ts3.noop,
        logErrEvent: ts3.noop,
        logPerfEvent: ts3.noop,
        logInfoEvent: ts3.noop,
        logStartCommand: ts3.noop,
        logStopCommand: ts3.noop,
        logStartUpdateProgram: ts3.noop,
        logStopUpdateProgram: ts3.noop,
        logStartUpdateGraph: ts3.noop,
        logStopUpdateGraph: ts3.noop,
        logStartResolveModule: ts3.noop,
        logStopResolveModule: ts3.noop,
        logStartParseSourceFile: ts3.noop,
        logStopParseSourceFile: ts3.noop,
        logStartReadFile: ts3.noop,
        logStopReadFile: ts3.noop,
        logStartBindFile: ts3.noop,
        logStopBindFile: ts3.noop,
        logStartScheduledOperation: ts3.noop,
        logStopScheduledOperation: ts3.noop
      };
      var etwModule;
      try {
        var etwModulePath = (_a = process.env.TS_ETW_MODULE_PATH) !== null && _a !== void 0 ? _a : "./node_modules/@microsoft/typescript-etw";
        etwModule = require(etwModulePath);
      } catch (e) {
        etwModule = void 0;
      }
      ts3.perfLogger = etwModule && etwModule.logEvent ? etwModule : nullLogger;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var tracingEnabled;
      (function(tracingEnabled2) {
        var fs4;
        var traceCount = 0;
        var traceFd = 0;
        var mode;
        var typeCatalog = [];
        var legendPath;
        var legend = [];
        ;
        function startTracing(tracingMode, traceDir, configFilePath) {
          ts3.Debug.assert(!ts3.tracing, "Tracing already started");
          if (fs4 === void 0) {
            try {
              fs4 = require("fs");
            } catch (e) {
              throw new Error("tracing requires having fs\n(original error: ".concat(e.message || e, ")"));
            }
          }
          mode = tracingMode;
          typeCatalog.length = 0;
          if (legendPath === void 0) {
            legendPath = ts3.combinePaths(traceDir, "legend.json");
          }
          if (!fs4.existsSync(traceDir)) {
            fs4.mkdirSync(traceDir, { recursive: true });
          }
          var countPart = mode === "build" ? ".".concat(process.pid, "-").concat(++traceCount) : mode === "server" ? ".".concat(process.pid) : "";
          var tracePath = ts3.combinePaths(traceDir, "trace".concat(countPart, ".json"));
          var typesPath = ts3.combinePaths(traceDir, "types".concat(countPart, ".json"));
          legend.push({
            configFilePath,
            tracePath,
            typesPath
          });
          traceFd = fs4.openSync(tracePath, "w");
          ts3.tracing = tracingEnabled2;
          var meta = { cat: "__metadata", ph: "M", ts: 1e3 * ts3.timestamp(), pid: 1, tid: 1 };
          fs4.writeSync(traceFd, "[\n" + [__assign({ name: "process_name", args: { name: "tsc" } }, meta), __assign({ name: "thread_name", args: { name: "Main" } }, meta), __assign(__assign({ name: "TracingStartedInBrowser" }, meta), { cat: "disabled-by-default-devtools.timeline" })].map(function(v) {
            return JSON.stringify(v);
          }).join(",\n"));
        }
        tracingEnabled2.startTracing = startTracing;
        function stopTracing() {
          ts3.Debug.assert(ts3.tracing, "Tracing is not in progress");
          ts3.Debug.assert(!!typeCatalog.length === (mode !== "server"));
          fs4.writeSync(traceFd, "\n]\n");
          fs4.closeSync(traceFd);
          ts3.tracing = void 0;
          if (typeCatalog.length) {
            dumpTypes(typeCatalog);
          } else {
            legend[legend.length - 1].typesPath = void 0;
          }
        }
        tracingEnabled2.stopTracing = stopTracing;
        function recordType(type2) {
          if (mode !== "server") {
            typeCatalog.push(type2);
          }
        }
        tracingEnabled2.recordType = recordType;
        var Phase;
        (function(Phase2) {
          Phase2["Parse"] = "parse";
          Phase2["Program"] = "program";
          Phase2["Bind"] = "bind";
          Phase2["Check"] = "check";
          Phase2["CheckTypes"] = "checkTypes";
          Phase2["Emit"] = "emit";
          Phase2["Session"] = "session";
        })(Phase = tracingEnabled2.Phase || (tracingEnabled2.Phase = {}));
        function instant(phase, name, args) {
          writeEvent("I", phase, name, args, '"s":"g"');
        }
        tracingEnabled2.instant = instant;
        var eventStack = [];
        function push(phase, name, args, separateBeginAndEnd) {
          if (separateBeginAndEnd === void 0) {
            separateBeginAndEnd = false;
          }
          if (separateBeginAndEnd) {
            writeEvent("B", phase, name, args);
          }
          eventStack.push({ phase, name, args, time: 1e3 * ts3.timestamp(), separateBeginAndEnd });
        }
        tracingEnabled2.push = push;
        function pop() {
          ts3.Debug.assert(eventStack.length > 0);
          writeStackEvent(eventStack.length - 1, 1e3 * ts3.timestamp());
          eventStack.length--;
        }
        tracingEnabled2.pop = pop;
        function popAll() {
          var endTime = 1e3 * ts3.timestamp();
          for (var i = eventStack.length - 1; i >= 0; i--) {
            writeStackEvent(i, endTime);
          }
          eventStack.length = 0;
        }
        tracingEnabled2.popAll = popAll;
        var sampleInterval = 1e3 * 10;
        function writeStackEvent(index, endTime) {
          var _a = eventStack[index], phase = _a.phase, name = _a.name, args = _a.args, time = _a.time, separateBeginAndEnd = _a.separateBeginAndEnd;
          if (separateBeginAndEnd) {
            writeEvent("E", phase, name, args, void 0, endTime);
          } else if (sampleInterval - time % sampleInterval <= endTime - time) {
            writeEvent("X", phase, name, args, '"dur":'.concat(endTime - time), time);
          }
        }
        function writeEvent(eventType, phase, name, args, extras, time) {
          if (time === void 0) {
            time = 1e3 * ts3.timestamp();
          }
          if (mode === "server" && phase === "checkTypes")
            return;
          ts3.performance.mark("beginTracing");
          fs4.writeSync(traceFd, ',\n{"pid":1,"tid":1,"ph":"'.concat(eventType, '","cat":"').concat(phase, '","ts":').concat(time, ',"name":"').concat(name, '"'));
          if (extras)
            fs4.writeSync(traceFd, ",".concat(extras));
          if (args)
            fs4.writeSync(traceFd, ',"args":'.concat(JSON.stringify(args)));
          fs4.writeSync(traceFd, "}");
          ts3.performance.mark("endTracing");
          ts3.performance.measure("Tracing", "beginTracing", "endTracing");
        }
        function getLocation(node) {
          var file = ts3.getSourceFileOfNode(node);
          return !file ? void 0 : {
            path: file.path,
            start: indexFromOne(ts3.getLineAndCharacterOfPosition(file, node.pos)),
            end: indexFromOne(ts3.getLineAndCharacterOfPosition(file, node.end))
          };
          function indexFromOne(lc) {
            return {
              line: lc.line + 1,
              character: lc.character + 1
            };
          }
        }
        function dumpTypes(types2) {
          var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
          ts3.performance.mark("beginDumpTypes");
          var typesPath = legend[legend.length - 1].typesPath;
          var typesFd = fs4.openSync(typesPath, "w");
          var recursionIdentityMap = new ts3.Map();
          fs4.writeSync(typesFd, "[");
          var numTypes = types2.length;
          for (var i = 0; i < numTypes; i++) {
            var type2 = types2[i];
            var objectFlags = type2.objectFlags;
            var symbol = (_a = type2.aliasSymbol) !== null && _a !== void 0 ? _a : type2.symbol;
            var display = void 0;
            if (objectFlags & 16 | type2.flags & 2944) {
              try {
                display = (_b = type2.checker) === null || _b === void 0 ? void 0 : _b.typeToString(type2);
              } catch (_y) {
                display = void 0;
              }
            }
            var indexedAccessProperties = {};
            if (type2.flags & 8388608) {
              var indexedAccessType = type2;
              indexedAccessProperties = {
                indexedAccessObjectType: (_c = indexedAccessType.objectType) === null || _c === void 0 ? void 0 : _c.id,
                indexedAccessIndexType: (_d = indexedAccessType.indexType) === null || _d === void 0 ? void 0 : _d.id
              };
            }
            var referenceProperties = {};
            if (objectFlags & 4) {
              var referenceType = type2;
              referenceProperties = {
                instantiatedType: (_e = referenceType.target) === null || _e === void 0 ? void 0 : _e.id,
                typeArguments: (_f = referenceType.resolvedTypeArguments) === null || _f === void 0 ? void 0 : _f.map(function(t) {
                  return t.id;
                }),
                referenceLocation: getLocation(referenceType.node)
              };
            }
            var conditionalProperties = {};
            if (type2.flags & 16777216) {
              var conditionalType = type2;
              conditionalProperties = {
                conditionalCheckType: (_g = conditionalType.checkType) === null || _g === void 0 ? void 0 : _g.id,
                conditionalExtendsType: (_h = conditionalType.extendsType) === null || _h === void 0 ? void 0 : _h.id,
                conditionalTrueType: (_k = (_j = conditionalType.resolvedTrueType) === null || _j === void 0 ? void 0 : _j.id) !== null && _k !== void 0 ? _k : -1,
                conditionalFalseType: (_m = (_l = conditionalType.resolvedFalseType) === null || _l === void 0 ? void 0 : _l.id) !== null && _m !== void 0 ? _m : -1
              };
            }
            var substitutionProperties = {};
            if (type2.flags & 33554432) {
              var substitutionType = type2;
              substitutionProperties = {
                substitutionBaseType: (_o = substitutionType.baseType) === null || _o === void 0 ? void 0 : _o.id,
                substituteType: (_p = substitutionType.substitute) === null || _p === void 0 ? void 0 : _p.id
              };
            }
            var reverseMappedProperties = {};
            if (objectFlags & 1024) {
              var reverseMappedType = type2;
              reverseMappedProperties = {
                reverseMappedSourceType: (_q = reverseMappedType.source) === null || _q === void 0 ? void 0 : _q.id,
                reverseMappedMappedType: (_r = reverseMappedType.mappedType) === null || _r === void 0 ? void 0 : _r.id,
                reverseMappedConstraintType: (_s = reverseMappedType.constraintType) === null || _s === void 0 ? void 0 : _s.id
              };
            }
            var evolvingArrayProperties = {};
            if (objectFlags & 256) {
              var evolvingArrayType = type2;
              evolvingArrayProperties = {
                evolvingArrayElementType: evolvingArrayType.elementType.id,
                evolvingArrayFinalType: (_t = evolvingArrayType.finalArrayType) === null || _t === void 0 ? void 0 : _t.id
              };
            }
            var recursionToken = void 0;
            var recursionIdentity = type2.checker.getRecursionIdentity(type2);
            if (recursionIdentity) {
              recursionToken = recursionIdentityMap.get(recursionIdentity);
              if (!recursionToken) {
                recursionToken = recursionIdentityMap.size;
                recursionIdentityMap.set(recursionIdentity, recursionToken);
              }
            }
            var descriptor = __assign(__assign(__assign(__assign(__assign(__assign(__assign({ id: type2.id, intrinsicName: type2.intrinsicName, symbolName: (symbol === null || symbol === void 0 ? void 0 : symbol.escapedName) && ts3.unescapeLeadingUnderscores(symbol.escapedName), recursionId: recursionToken, isTuple: objectFlags & 8 ? true : void 0, unionTypes: type2.flags & 1048576 ? (_u = type2.types) === null || _u === void 0 ? void 0 : _u.map(function(t) {
              return t.id;
            }) : void 0, intersectionTypes: type2.flags & 2097152 ? type2.types.map(function(t) {
              return t.id;
            }) : void 0, aliasTypeArguments: (_v = type2.aliasTypeArguments) === null || _v === void 0 ? void 0 : _v.map(function(t) {
              return t.id;
            }), keyofType: type2.flags & 4194304 ? (_w = type2.type) === null || _w === void 0 ? void 0 : _w.id : void 0 }, indexedAccessProperties), referenceProperties), conditionalProperties), substitutionProperties), reverseMappedProperties), evolvingArrayProperties), { destructuringPattern: getLocation(type2.pattern), firstDeclaration: getLocation((_x = symbol === null || symbol === void 0 ? void 0 : symbol.declarations) === null || _x === void 0 ? void 0 : _x[0]), flags: ts3.Debug.formatTypeFlags(type2.flags).split("|"), display });
            fs4.writeSync(typesFd, JSON.stringify(descriptor));
            if (i < numTypes - 1) {
              fs4.writeSync(typesFd, ",\n");
            }
          }
          fs4.writeSync(typesFd, "]\n");
          fs4.closeSync(typesFd);
          ts3.performance.mark("endDumpTypes");
          ts3.performance.measure("Dump types", "beginDumpTypes", "endDumpTypes");
        }
        function dumpLegend() {
          if (!legendPath) {
            return;
          }
          fs4.writeFileSync(legendPath, JSON.stringify(legend));
        }
        tracingEnabled2.dumpLegend = dumpLegend;
      })(tracingEnabled || (tracingEnabled = {}));
      ts3.startTracing = tracingEnabled.startTracing;
      ts3.dumpTracingLegend = tracingEnabled.dumpLegend;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SyntaxKind;
      (function(SyntaxKind2) {
        SyntaxKind2[SyntaxKind2["Unknown"] = 0] = "Unknown";
        SyntaxKind2[SyntaxKind2["EndOfFileToken"] = 1] = "EndOfFileToken";
        SyntaxKind2[SyntaxKind2["SingleLineCommentTrivia"] = 2] = "SingleLineCommentTrivia";
        SyntaxKind2[SyntaxKind2["MultiLineCommentTrivia"] = 3] = "MultiLineCommentTrivia";
        SyntaxKind2[SyntaxKind2["NewLineTrivia"] = 4] = "NewLineTrivia";
        SyntaxKind2[SyntaxKind2["WhitespaceTrivia"] = 5] = "WhitespaceTrivia";
        SyntaxKind2[SyntaxKind2["ShebangTrivia"] = 6] = "ShebangTrivia";
        SyntaxKind2[SyntaxKind2["ConflictMarkerTrivia"] = 7] = "ConflictMarkerTrivia";
        SyntaxKind2[SyntaxKind2["NumericLiteral"] = 8] = "NumericLiteral";
        SyntaxKind2[SyntaxKind2["BigIntLiteral"] = 9] = "BigIntLiteral";
        SyntaxKind2[SyntaxKind2["StringLiteral"] = 10] = "StringLiteral";
        SyntaxKind2[SyntaxKind2["JsxText"] = 11] = "JsxText";
        SyntaxKind2[SyntaxKind2["JsxTextAllWhiteSpaces"] = 12] = "JsxTextAllWhiteSpaces";
        SyntaxKind2[SyntaxKind2["RegularExpressionLiteral"] = 13] = "RegularExpressionLiteral";
        SyntaxKind2[SyntaxKind2["NoSubstitutionTemplateLiteral"] = 14] = "NoSubstitutionTemplateLiteral";
        SyntaxKind2[SyntaxKind2["TemplateHead"] = 15] = "TemplateHead";
        SyntaxKind2[SyntaxKind2["TemplateMiddle"] = 16] = "TemplateMiddle";
        SyntaxKind2[SyntaxKind2["TemplateTail"] = 17] = "TemplateTail";
        SyntaxKind2[SyntaxKind2["OpenBraceToken"] = 18] = "OpenBraceToken";
        SyntaxKind2[SyntaxKind2["CloseBraceToken"] = 19] = "CloseBraceToken";
        SyntaxKind2[SyntaxKind2["OpenParenToken"] = 20] = "OpenParenToken";
        SyntaxKind2[SyntaxKind2["CloseParenToken"] = 21] = "CloseParenToken";
        SyntaxKind2[SyntaxKind2["OpenBracketToken"] = 22] = "OpenBracketToken";
        SyntaxKind2[SyntaxKind2["CloseBracketToken"] = 23] = "CloseBracketToken";
        SyntaxKind2[SyntaxKind2["DotToken"] = 24] = "DotToken";
        SyntaxKind2[SyntaxKind2["DotDotDotToken"] = 25] = "DotDotDotToken";
        SyntaxKind2[SyntaxKind2["SemicolonToken"] = 26] = "SemicolonToken";
        SyntaxKind2[SyntaxKind2["CommaToken"] = 27] = "CommaToken";
        SyntaxKind2[SyntaxKind2["QuestionDotToken"] = 28] = "QuestionDotToken";
        SyntaxKind2[SyntaxKind2["LessThanToken"] = 29] = "LessThanToken";
        SyntaxKind2[SyntaxKind2["LessThanSlashToken"] = 30] = "LessThanSlashToken";
        SyntaxKind2[SyntaxKind2["GreaterThanToken"] = 31] = "GreaterThanToken";
        SyntaxKind2[SyntaxKind2["LessThanEqualsToken"] = 32] = "LessThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanEqualsToken"] = 33] = "GreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsEqualsToken"] = 34] = "EqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["ExclamationEqualsToken"] = 35] = "ExclamationEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsEqualsEqualsToken"] = 36] = "EqualsEqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["ExclamationEqualsEqualsToken"] = 37] = "ExclamationEqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsGreaterThanToken"] = 38] = "EqualsGreaterThanToken";
        SyntaxKind2[SyntaxKind2["PlusToken"] = 39] = "PlusToken";
        SyntaxKind2[SyntaxKind2["MinusToken"] = 40] = "MinusToken";
        SyntaxKind2[SyntaxKind2["AsteriskToken"] = 41] = "AsteriskToken";
        SyntaxKind2[SyntaxKind2["AsteriskAsteriskToken"] = 42] = "AsteriskAsteriskToken";
        SyntaxKind2[SyntaxKind2["SlashToken"] = 43] = "SlashToken";
        SyntaxKind2[SyntaxKind2["PercentToken"] = 44] = "PercentToken";
        SyntaxKind2[SyntaxKind2["PlusPlusToken"] = 45] = "PlusPlusToken";
        SyntaxKind2[SyntaxKind2["MinusMinusToken"] = 46] = "MinusMinusToken";
        SyntaxKind2[SyntaxKind2["LessThanLessThanToken"] = 47] = "LessThanLessThanToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanToken"] = 48] = "GreaterThanGreaterThanToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanGreaterThanToken"] = 49] = "GreaterThanGreaterThanGreaterThanToken";
        SyntaxKind2[SyntaxKind2["AmpersandToken"] = 50] = "AmpersandToken";
        SyntaxKind2[SyntaxKind2["BarToken"] = 51] = "BarToken";
        SyntaxKind2[SyntaxKind2["CaretToken"] = 52] = "CaretToken";
        SyntaxKind2[SyntaxKind2["ExclamationToken"] = 53] = "ExclamationToken";
        SyntaxKind2[SyntaxKind2["TildeToken"] = 54] = "TildeToken";
        SyntaxKind2[SyntaxKind2["AmpersandAmpersandToken"] = 55] = "AmpersandAmpersandToken";
        SyntaxKind2[SyntaxKind2["BarBarToken"] = 56] = "BarBarToken";
        SyntaxKind2[SyntaxKind2["QuestionToken"] = 57] = "QuestionToken";
        SyntaxKind2[SyntaxKind2["ColonToken"] = 58] = "ColonToken";
        SyntaxKind2[SyntaxKind2["AtToken"] = 59] = "AtToken";
        SyntaxKind2[SyntaxKind2["QuestionQuestionToken"] = 60] = "QuestionQuestionToken";
        SyntaxKind2[SyntaxKind2["BacktickToken"] = 61] = "BacktickToken";
        SyntaxKind2[SyntaxKind2["HashToken"] = 62] = "HashToken";
        SyntaxKind2[SyntaxKind2["EqualsToken"] = 63] = "EqualsToken";
        SyntaxKind2[SyntaxKind2["PlusEqualsToken"] = 64] = "PlusEqualsToken";
        SyntaxKind2[SyntaxKind2["MinusEqualsToken"] = 65] = "MinusEqualsToken";
        SyntaxKind2[SyntaxKind2["AsteriskEqualsToken"] = 66] = "AsteriskEqualsToken";
        SyntaxKind2[SyntaxKind2["AsteriskAsteriskEqualsToken"] = 67] = "AsteriskAsteriskEqualsToken";
        SyntaxKind2[SyntaxKind2["SlashEqualsToken"] = 68] = "SlashEqualsToken";
        SyntaxKind2[SyntaxKind2["PercentEqualsToken"] = 69] = "PercentEqualsToken";
        SyntaxKind2[SyntaxKind2["LessThanLessThanEqualsToken"] = 70] = "LessThanLessThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanEqualsToken"] = 71] = "GreaterThanGreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanGreaterThanEqualsToken"] = 72] = "GreaterThanGreaterThanGreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["AmpersandEqualsToken"] = 73] = "AmpersandEqualsToken";
        SyntaxKind2[SyntaxKind2["BarEqualsToken"] = 74] = "BarEqualsToken";
        SyntaxKind2[SyntaxKind2["BarBarEqualsToken"] = 75] = "BarBarEqualsToken";
        SyntaxKind2[SyntaxKind2["AmpersandAmpersandEqualsToken"] = 76] = "AmpersandAmpersandEqualsToken";
        SyntaxKind2[SyntaxKind2["QuestionQuestionEqualsToken"] = 77] = "QuestionQuestionEqualsToken";
        SyntaxKind2[SyntaxKind2["CaretEqualsToken"] = 78] = "CaretEqualsToken";
        SyntaxKind2[SyntaxKind2["Identifier"] = 79] = "Identifier";
        SyntaxKind2[SyntaxKind2["PrivateIdentifier"] = 80] = "PrivateIdentifier";
        SyntaxKind2[SyntaxKind2["BreakKeyword"] = 81] = "BreakKeyword";
        SyntaxKind2[SyntaxKind2["CaseKeyword"] = 82] = "CaseKeyword";
        SyntaxKind2[SyntaxKind2["CatchKeyword"] = 83] = "CatchKeyword";
        SyntaxKind2[SyntaxKind2["ClassKeyword"] = 84] = "ClassKeyword";
        SyntaxKind2[SyntaxKind2["ConstKeyword"] = 85] = "ConstKeyword";
        SyntaxKind2[SyntaxKind2["ContinueKeyword"] = 86] = "ContinueKeyword";
        SyntaxKind2[SyntaxKind2["DebuggerKeyword"] = 87] = "DebuggerKeyword";
        SyntaxKind2[SyntaxKind2["DefaultKeyword"] = 88] = "DefaultKeyword";
        SyntaxKind2[SyntaxKind2["DeleteKeyword"] = 89] = "DeleteKeyword";
        SyntaxKind2[SyntaxKind2["DoKeyword"] = 90] = "DoKeyword";
        SyntaxKind2[SyntaxKind2["ElseKeyword"] = 91] = "ElseKeyword";
        SyntaxKind2[SyntaxKind2["EnumKeyword"] = 92] = "EnumKeyword";
        SyntaxKind2[SyntaxKind2["ExportKeyword"] = 93] = "ExportKeyword";
        SyntaxKind2[SyntaxKind2["ExtendsKeyword"] = 94] = "ExtendsKeyword";
        SyntaxKind2[SyntaxKind2["FalseKeyword"] = 95] = "FalseKeyword";
        SyntaxKind2[SyntaxKind2["FinallyKeyword"] = 96] = "FinallyKeyword";
        SyntaxKind2[SyntaxKind2["ForKeyword"] = 97] = "ForKeyword";
        SyntaxKind2[SyntaxKind2["FunctionKeyword"] = 98] = "FunctionKeyword";
        SyntaxKind2[SyntaxKind2["IfKeyword"] = 99] = "IfKeyword";
        SyntaxKind2[SyntaxKind2["ImportKeyword"] = 100] = "ImportKeyword";
        SyntaxKind2[SyntaxKind2["InKeyword"] = 101] = "InKeyword";
        SyntaxKind2[SyntaxKind2["InstanceOfKeyword"] = 102] = "InstanceOfKeyword";
        SyntaxKind2[SyntaxKind2["NewKeyword"] = 103] = "NewKeyword";
        SyntaxKind2[SyntaxKind2["NullKeyword"] = 104] = "NullKeyword";
        SyntaxKind2[SyntaxKind2["ReturnKeyword"] = 105] = "ReturnKeyword";
        SyntaxKind2[SyntaxKind2["SuperKeyword"] = 106] = "SuperKeyword";
        SyntaxKind2[SyntaxKind2["SwitchKeyword"] = 107] = "SwitchKeyword";
        SyntaxKind2[SyntaxKind2["ThisKeyword"] = 108] = "ThisKeyword";
        SyntaxKind2[SyntaxKind2["ThrowKeyword"] = 109] = "ThrowKeyword";
        SyntaxKind2[SyntaxKind2["TrueKeyword"] = 110] = "TrueKeyword";
        SyntaxKind2[SyntaxKind2["TryKeyword"] = 111] = "TryKeyword";
        SyntaxKind2[SyntaxKind2["TypeOfKeyword"] = 112] = "TypeOfKeyword";
        SyntaxKind2[SyntaxKind2["VarKeyword"] = 113] = "VarKeyword";
        SyntaxKind2[SyntaxKind2["VoidKeyword"] = 114] = "VoidKeyword";
        SyntaxKind2[SyntaxKind2["WhileKeyword"] = 115] = "WhileKeyword";
        SyntaxKind2[SyntaxKind2["WithKeyword"] = 116] = "WithKeyword";
        SyntaxKind2[SyntaxKind2["ImplementsKeyword"] = 117] = "ImplementsKeyword";
        SyntaxKind2[SyntaxKind2["InterfaceKeyword"] = 118] = "InterfaceKeyword";
        SyntaxKind2[SyntaxKind2["LetKeyword"] = 119] = "LetKeyword";
        SyntaxKind2[SyntaxKind2["PackageKeyword"] = 120] = "PackageKeyword";
        SyntaxKind2[SyntaxKind2["PrivateKeyword"] = 121] = "PrivateKeyword";
        SyntaxKind2[SyntaxKind2["ProtectedKeyword"] = 122] = "ProtectedKeyword";
        SyntaxKind2[SyntaxKind2["PublicKeyword"] = 123] = "PublicKeyword";
        SyntaxKind2[SyntaxKind2["StaticKeyword"] = 124] = "StaticKeyword";
        SyntaxKind2[SyntaxKind2["YieldKeyword"] = 125] = "YieldKeyword";
        SyntaxKind2[SyntaxKind2["AbstractKeyword"] = 126] = "AbstractKeyword";
        SyntaxKind2[SyntaxKind2["AsKeyword"] = 127] = "AsKeyword";
        SyntaxKind2[SyntaxKind2["AssertsKeyword"] = 128] = "AssertsKeyword";
        SyntaxKind2[SyntaxKind2["AssertKeyword"] = 129] = "AssertKeyword";
        SyntaxKind2[SyntaxKind2["AnyKeyword"] = 130] = "AnyKeyword";
        SyntaxKind2[SyntaxKind2["AsyncKeyword"] = 131] = "AsyncKeyword";
        SyntaxKind2[SyntaxKind2["AwaitKeyword"] = 132] = "AwaitKeyword";
        SyntaxKind2[SyntaxKind2["BooleanKeyword"] = 133] = "BooleanKeyword";
        SyntaxKind2[SyntaxKind2["ConstructorKeyword"] = 134] = "ConstructorKeyword";
        SyntaxKind2[SyntaxKind2["DeclareKeyword"] = 135] = "DeclareKeyword";
        SyntaxKind2[SyntaxKind2["GetKeyword"] = 136] = "GetKeyword";
        SyntaxKind2[SyntaxKind2["InferKeyword"] = 137] = "InferKeyword";
        SyntaxKind2[SyntaxKind2["IntrinsicKeyword"] = 138] = "IntrinsicKeyword";
        SyntaxKind2[SyntaxKind2["IsKeyword"] = 139] = "IsKeyword";
        SyntaxKind2[SyntaxKind2["KeyOfKeyword"] = 140] = "KeyOfKeyword";
        SyntaxKind2[SyntaxKind2["ModuleKeyword"] = 141] = "ModuleKeyword";
        SyntaxKind2[SyntaxKind2["NamespaceKeyword"] = 142] = "NamespaceKeyword";
        SyntaxKind2[SyntaxKind2["NeverKeyword"] = 143] = "NeverKeyword";
        SyntaxKind2[SyntaxKind2["OutKeyword"] = 144] = "OutKeyword";
        SyntaxKind2[SyntaxKind2["ReadonlyKeyword"] = 145] = "ReadonlyKeyword";
        SyntaxKind2[SyntaxKind2["RequireKeyword"] = 146] = "RequireKeyword";
        SyntaxKind2[SyntaxKind2["NumberKeyword"] = 147] = "NumberKeyword";
        SyntaxKind2[SyntaxKind2["ObjectKeyword"] = 148] = "ObjectKeyword";
        SyntaxKind2[SyntaxKind2["SetKeyword"] = 149] = "SetKeyword";
        SyntaxKind2[SyntaxKind2["StringKeyword"] = 150] = "StringKeyword";
        SyntaxKind2[SyntaxKind2["SymbolKeyword"] = 151] = "SymbolKeyword";
        SyntaxKind2[SyntaxKind2["TypeKeyword"] = 152] = "TypeKeyword";
        SyntaxKind2[SyntaxKind2["UndefinedKeyword"] = 153] = "UndefinedKeyword";
        SyntaxKind2[SyntaxKind2["UniqueKeyword"] = 154] = "UniqueKeyword";
        SyntaxKind2[SyntaxKind2["UnknownKeyword"] = 155] = "UnknownKeyword";
        SyntaxKind2[SyntaxKind2["FromKeyword"] = 156] = "FromKeyword";
        SyntaxKind2[SyntaxKind2["GlobalKeyword"] = 157] = "GlobalKeyword";
        SyntaxKind2[SyntaxKind2["BigIntKeyword"] = 158] = "BigIntKeyword";
        SyntaxKind2[SyntaxKind2["OverrideKeyword"] = 159] = "OverrideKeyword";
        SyntaxKind2[SyntaxKind2["OfKeyword"] = 160] = "OfKeyword";
        SyntaxKind2[SyntaxKind2["QualifiedName"] = 161] = "QualifiedName";
        SyntaxKind2[SyntaxKind2["ComputedPropertyName"] = 162] = "ComputedPropertyName";
        SyntaxKind2[SyntaxKind2["TypeParameter"] = 163] = "TypeParameter";
        SyntaxKind2[SyntaxKind2["Parameter"] = 164] = "Parameter";
        SyntaxKind2[SyntaxKind2["Decorator"] = 165] = "Decorator";
        SyntaxKind2[SyntaxKind2["PropertySignature"] = 166] = "PropertySignature";
        SyntaxKind2[SyntaxKind2["PropertyDeclaration"] = 167] = "PropertyDeclaration";
        SyntaxKind2[SyntaxKind2["MethodSignature"] = 168] = "MethodSignature";
        SyntaxKind2[SyntaxKind2["MethodDeclaration"] = 169] = "MethodDeclaration";
        SyntaxKind2[SyntaxKind2["ClassStaticBlockDeclaration"] = 170] = "ClassStaticBlockDeclaration";
        SyntaxKind2[SyntaxKind2["Constructor"] = 171] = "Constructor";
        SyntaxKind2[SyntaxKind2["GetAccessor"] = 172] = "GetAccessor";
        SyntaxKind2[SyntaxKind2["SetAccessor"] = 173] = "SetAccessor";
        SyntaxKind2[SyntaxKind2["CallSignature"] = 174] = "CallSignature";
        SyntaxKind2[SyntaxKind2["ConstructSignature"] = 175] = "ConstructSignature";
        SyntaxKind2[SyntaxKind2["IndexSignature"] = 176] = "IndexSignature";
        SyntaxKind2[SyntaxKind2["TypePredicate"] = 177] = "TypePredicate";
        SyntaxKind2[SyntaxKind2["TypeReference"] = 178] = "TypeReference";
        SyntaxKind2[SyntaxKind2["FunctionType"] = 179] = "FunctionType";
        SyntaxKind2[SyntaxKind2["ConstructorType"] = 180] = "ConstructorType";
        SyntaxKind2[SyntaxKind2["TypeQuery"] = 181] = "TypeQuery";
        SyntaxKind2[SyntaxKind2["TypeLiteral"] = 182] = "TypeLiteral";
        SyntaxKind2[SyntaxKind2["ArrayType"] = 183] = "ArrayType";
        SyntaxKind2[SyntaxKind2["TupleType"] = 184] = "TupleType";
        SyntaxKind2[SyntaxKind2["OptionalType"] = 185] = "OptionalType";
        SyntaxKind2[SyntaxKind2["RestType"] = 186] = "RestType";
        SyntaxKind2[SyntaxKind2["UnionType"] = 187] = "UnionType";
        SyntaxKind2[SyntaxKind2["IntersectionType"] = 188] = "IntersectionType";
        SyntaxKind2[SyntaxKind2["ConditionalType"] = 189] = "ConditionalType";
        SyntaxKind2[SyntaxKind2["InferType"] = 190] = "InferType";
        SyntaxKind2[SyntaxKind2["ParenthesizedType"] = 191] = "ParenthesizedType";
        SyntaxKind2[SyntaxKind2["ThisType"] = 192] = "ThisType";
        SyntaxKind2[SyntaxKind2["TypeOperator"] = 193] = "TypeOperator";
        SyntaxKind2[SyntaxKind2["IndexedAccessType"] = 194] = "IndexedAccessType";
        SyntaxKind2[SyntaxKind2["MappedType"] = 195] = "MappedType";
        SyntaxKind2[SyntaxKind2["LiteralType"] = 196] = "LiteralType";
        SyntaxKind2[SyntaxKind2["NamedTupleMember"] = 197] = "NamedTupleMember";
        SyntaxKind2[SyntaxKind2["TemplateLiteralType"] = 198] = "TemplateLiteralType";
        SyntaxKind2[SyntaxKind2["TemplateLiteralTypeSpan"] = 199] = "TemplateLiteralTypeSpan";
        SyntaxKind2[SyntaxKind2["ImportType"] = 200] = "ImportType";
        SyntaxKind2[SyntaxKind2["ObjectBindingPattern"] = 201] = "ObjectBindingPattern";
        SyntaxKind2[SyntaxKind2["ArrayBindingPattern"] = 202] = "ArrayBindingPattern";
        SyntaxKind2[SyntaxKind2["BindingElement"] = 203] = "BindingElement";
        SyntaxKind2[SyntaxKind2["ArrayLiteralExpression"] = 204] = "ArrayLiteralExpression";
        SyntaxKind2[SyntaxKind2["ObjectLiteralExpression"] = 205] = "ObjectLiteralExpression";
        SyntaxKind2[SyntaxKind2["PropertyAccessExpression"] = 206] = "PropertyAccessExpression";
        SyntaxKind2[SyntaxKind2["ElementAccessExpression"] = 207] = "ElementAccessExpression";
        SyntaxKind2[SyntaxKind2["CallExpression"] = 208] = "CallExpression";
        SyntaxKind2[SyntaxKind2["NewExpression"] = 209] = "NewExpression";
        SyntaxKind2[SyntaxKind2["TaggedTemplateExpression"] = 210] = "TaggedTemplateExpression";
        SyntaxKind2[SyntaxKind2["TypeAssertionExpression"] = 211] = "TypeAssertionExpression";
        SyntaxKind2[SyntaxKind2["ParenthesizedExpression"] = 212] = "ParenthesizedExpression";
        SyntaxKind2[SyntaxKind2["FunctionExpression"] = 213] = "FunctionExpression";
        SyntaxKind2[SyntaxKind2["ArrowFunction"] = 214] = "ArrowFunction";
        SyntaxKind2[SyntaxKind2["DeleteExpression"] = 215] = "DeleteExpression";
        SyntaxKind2[SyntaxKind2["TypeOfExpression"] = 216] = "TypeOfExpression";
        SyntaxKind2[SyntaxKind2["VoidExpression"] = 217] = "VoidExpression";
        SyntaxKind2[SyntaxKind2["AwaitExpression"] = 218] = "AwaitExpression";
        SyntaxKind2[SyntaxKind2["PrefixUnaryExpression"] = 219] = "PrefixUnaryExpression";
        SyntaxKind2[SyntaxKind2["PostfixUnaryExpression"] = 220] = "PostfixUnaryExpression";
        SyntaxKind2[SyntaxKind2["BinaryExpression"] = 221] = "BinaryExpression";
        SyntaxKind2[SyntaxKind2["ConditionalExpression"] = 222] = "ConditionalExpression";
        SyntaxKind2[SyntaxKind2["TemplateExpression"] = 223] = "TemplateExpression";
        SyntaxKind2[SyntaxKind2["YieldExpression"] = 224] = "YieldExpression";
        SyntaxKind2[SyntaxKind2["SpreadElement"] = 225] = "SpreadElement";
        SyntaxKind2[SyntaxKind2["ClassExpression"] = 226] = "ClassExpression";
        SyntaxKind2[SyntaxKind2["OmittedExpression"] = 227] = "OmittedExpression";
        SyntaxKind2[SyntaxKind2["ExpressionWithTypeArguments"] = 228] = "ExpressionWithTypeArguments";
        SyntaxKind2[SyntaxKind2["AsExpression"] = 229] = "AsExpression";
        SyntaxKind2[SyntaxKind2["NonNullExpression"] = 230] = "NonNullExpression";
        SyntaxKind2[SyntaxKind2["MetaProperty"] = 231] = "MetaProperty";
        SyntaxKind2[SyntaxKind2["SyntheticExpression"] = 232] = "SyntheticExpression";
        SyntaxKind2[SyntaxKind2["TemplateSpan"] = 233] = "TemplateSpan";
        SyntaxKind2[SyntaxKind2["SemicolonClassElement"] = 234] = "SemicolonClassElement";
        SyntaxKind2[SyntaxKind2["Block"] = 235] = "Block";
        SyntaxKind2[SyntaxKind2["EmptyStatement"] = 236] = "EmptyStatement";
        SyntaxKind2[SyntaxKind2["VariableStatement"] = 237] = "VariableStatement";
        SyntaxKind2[SyntaxKind2["ExpressionStatement"] = 238] = "ExpressionStatement";
        SyntaxKind2[SyntaxKind2["IfStatement"] = 239] = "IfStatement";
        SyntaxKind2[SyntaxKind2["DoStatement"] = 240] = "DoStatement";
        SyntaxKind2[SyntaxKind2["WhileStatement"] = 241] = "WhileStatement";
        SyntaxKind2[SyntaxKind2["ForStatement"] = 242] = "ForStatement";
        SyntaxKind2[SyntaxKind2["ForInStatement"] = 243] = "ForInStatement";
        SyntaxKind2[SyntaxKind2["ForOfStatement"] = 244] = "ForOfStatement";
        SyntaxKind2[SyntaxKind2["ContinueStatement"] = 245] = "ContinueStatement";
        SyntaxKind2[SyntaxKind2["BreakStatement"] = 246] = "BreakStatement";
        SyntaxKind2[SyntaxKind2["ReturnStatement"] = 247] = "ReturnStatement";
        SyntaxKind2[SyntaxKind2["WithStatement"] = 248] = "WithStatement";
        SyntaxKind2[SyntaxKind2["SwitchStatement"] = 249] = "SwitchStatement";
        SyntaxKind2[SyntaxKind2["LabeledStatement"] = 250] = "LabeledStatement";
        SyntaxKind2[SyntaxKind2["ThrowStatement"] = 251] = "ThrowStatement";
        SyntaxKind2[SyntaxKind2["TryStatement"] = 252] = "TryStatement";
        SyntaxKind2[SyntaxKind2["DebuggerStatement"] = 253] = "DebuggerStatement";
        SyntaxKind2[SyntaxKind2["VariableDeclaration"] = 254] = "VariableDeclaration";
        SyntaxKind2[SyntaxKind2["VariableDeclarationList"] = 255] = "VariableDeclarationList";
        SyntaxKind2[SyntaxKind2["FunctionDeclaration"] = 256] = "FunctionDeclaration";
        SyntaxKind2[SyntaxKind2["ClassDeclaration"] = 257] = "ClassDeclaration";
        SyntaxKind2[SyntaxKind2["InterfaceDeclaration"] = 258] = "InterfaceDeclaration";
        SyntaxKind2[SyntaxKind2["TypeAliasDeclaration"] = 259] = "TypeAliasDeclaration";
        SyntaxKind2[SyntaxKind2["EnumDeclaration"] = 260] = "EnumDeclaration";
        SyntaxKind2[SyntaxKind2["ModuleDeclaration"] = 261] = "ModuleDeclaration";
        SyntaxKind2[SyntaxKind2["ModuleBlock"] = 262] = "ModuleBlock";
        SyntaxKind2[SyntaxKind2["CaseBlock"] = 263] = "CaseBlock";
        SyntaxKind2[SyntaxKind2["NamespaceExportDeclaration"] = 264] = "NamespaceExportDeclaration";
        SyntaxKind2[SyntaxKind2["ImportEqualsDeclaration"] = 265] = "ImportEqualsDeclaration";
        SyntaxKind2[SyntaxKind2["ImportDeclaration"] = 266] = "ImportDeclaration";
        SyntaxKind2[SyntaxKind2["ImportClause"] = 267] = "ImportClause";
        SyntaxKind2[SyntaxKind2["NamespaceImport"] = 268] = "NamespaceImport";
        SyntaxKind2[SyntaxKind2["NamedImports"] = 269] = "NamedImports";
        SyntaxKind2[SyntaxKind2["ImportSpecifier"] = 270] = "ImportSpecifier";
        SyntaxKind2[SyntaxKind2["ExportAssignment"] = 271] = "ExportAssignment";
        SyntaxKind2[SyntaxKind2["ExportDeclaration"] = 272] = "ExportDeclaration";
        SyntaxKind2[SyntaxKind2["NamedExports"] = 273] = "NamedExports";
        SyntaxKind2[SyntaxKind2["NamespaceExport"] = 274] = "NamespaceExport";
        SyntaxKind2[SyntaxKind2["ExportSpecifier"] = 275] = "ExportSpecifier";
        SyntaxKind2[SyntaxKind2["MissingDeclaration"] = 276] = "MissingDeclaration";
        SyntaxKind2[SyntaxKind2["ExternalModuleReference"] = 277] = "ExternalModuleReference";
        SyntaxKind2[SyntaxKind2["JsxElement"] = 278] = "JsxElement";
        SyntaxKind2[SyntaxKind2["JsxSelfClosingElement"] = 279] = "JsxSelfClosingElement";
        SyntaxKind2[SyntaxKind2["JsxOpeningElement"] = 280] = "JsxOpeningElement";
        SyntaxKind2[SyntaxKind2["JsxClosingElement"] = 281] = "JsxClosingElement";
        SyntaxKind2[SyntaxKind2["JsxFragment"] = 282] = "JsxFragment";
        SyntaxKind2[SyntaxKind2["JsxOpeningFragment"] = 283] = "JsxOpeningFragment";
        SyntaxKind2[SyntaxKind2["JsxClosingFragment"] = 284] = "JsxClosingFragment";
        SyntaxKind2[SyntaxKind2["JsxAttribute"] = 285] = "JsxAttribute";
        SyntaxKind2[SyntaxKind2["JsxAttributes"] = 286] = "JsxAttributes";
        SyntaxKind2[SyntaxKind2["JsxSpreadAttribute"] = 287] = "JsxSpreadAttribute";
        SyntaxKind2[SyntaxKind2["JsxExpression"] = 288] = "JsxExpression";
        SyntaxKind2[SyntaxKind2["CaseClause"] = 289] = "CaseClause";
        SyntaxKind2[SyntaxKind2["DefaultClause"] = 290] = "DefaultClause";
        SyntaxKind2[SyntaxKind2["HeritageClause"] = 291] = "HeritageClause";
        SyntaxKind2[SyntaxKind2["CatchClause"] = 292] = "CatchClause";
        SyntaxKind2[SyntaxKind2["AssertClause"] = 293] = "AssertClause";
        SyntaxKind2[SyntaxKind2["AssertEntry"] = 294] = "AssertEntry";
        SyntaxKind2[SyntaxKind2["ImportTypeAssertionContainer"] = 295] = "ImportTypeAssertionContainer";
        SyntaxKind2[SyntaxKind2["PropertyAssignment"] = 296] = "PropertyAssignment";
        SyntaxKind2[SyntaxKind2["ShorthandPropertyAssignment"] = 297] = "ShorthandPropertyAssignment";
        SyntaxKind2[SyntaxKind2["SpreadAssignment"] = 298] = "SpreadAssignment";
        SyntaxKind2[SyntaxKind2["EnumMember"] = 299] = "EnumMember";
        SyntaxKind2[SyntaxKind2["UnparsedPrologue"] = 300] = "UnparsedPrologue";
        SyntaxKind2[SyntaxKind2["UnparsedPrepend"] = 301] = "UnparsedPrepend";
        SyntaxKind2[SyntaxKind2["UnparsedText"] = 302] = "UnparsedText";
        SyntaxKind2[SyntaxKind2["UnparsedInternalText"] = 303] = "UnparsedInternalText";
        SyntaxKind2[SyntaxKind2["UnparsedSyntheticReference"] = 304] = "UnparsedSyntheticReference";
        SyntaxKind2[SyntaxKind2["SourceFile"] = 305] = "SourceFile";
        SyntaxKind2[SyntaxKind2["Bundle"] = 306] = "Bundle";
        SyntaxKind2[SyntaxKind2["UnparsedSource"] = 307] = "UnparsedSource";
        SyntaxKind2[SyntaxKind2["InputFiles"] = 308] = "InputFiles";
        SyntaxKind2[SyntaxKind2["JSDocTypeExpression"] = 309] = "JSDocTypeExpression";
        SyntaxKind2[SyntaxKind2["JSDocNameReference"] = 310] = "JSDocNameReference";
        SyntaxKind2[SyntaxKind2["JSDocMemberName"] = 311] = "JSDocMemberName";
        SyntaxKind2[SyntaxKind2["JSDocAllType"] = 312] = "JSDocAllType";
        SyntaxKind2[SyntaxKind2["JSDocUnknownType"] = 313] = "JSDocUnknownType";
        SyntaxKind2[SyntaxKind2["JSDocNullableType"] = 314] = "JSDocNullableType";
        SyntaxKind2[SyntaxKind2["JSDocNonNullableType"] = 315] = "JSDocNonNullableType";
        SyntaxKind2[SyntaxKind2["JSDocOptionalType"] = 316] = "JSDocOptionalType";
        SyntaxKind2[SyntaxKind2["JSDocFunctionType"] = 317] = "JSDocFunctionType";
        SyntaxKind2[SyntaxKind2["JSDocVariadicType"] = 318] = "JSDocVariadicType";
        SyntaxKind2[SyntaxKind2["JSDocNamepathType"] = 319] = "JSDocNamepathType";
        SyntaxKind2[SyntaxKind2["JSDocComment"] = 320] = "JSDocComment";
        SyntaxKind2[SyntaxKind2["JSDocText"] = 321] = "JSDocText";
        SyntaxKind2[SyntaxKind2["JSDocTypeLiteral"] = 322] = "JSDocTypeLiteral";
        SyntaxKind2[SyntaxKind2["JSDocSignature"] = 323] = "JSDocSignature";
        SyntaxKind2[SyntaxKind2["JSDocLink"] = 324] = "JSDocLink";
        SyntaxKind2[SyntaxKind2["JSDocLinkCode"] = 325] = "JSDocLinkCode";
        SyntaxKind2[SyntaxKind2["JSDocLinkPlain"] = 326] = "JSDocLinkPlain";
        SyntaxKind2[SyntaxKind2["JSDocTag"] = 327] = "JSDocTag";
        SyntaxKind2[SyntaxKind2["JSDocAugmentsTag"] = 328] = "JSDocAugmentsTag";
        SyntaxKind2[SyntaxKind2["JSDocImplementsTag"] = 329] = "JSDocImplementsTag";
        SyntaxKind2[SyntaxKind2["JSDocAuthorTag"] = 330] = "JSDocAuthorTag";
        SyntaxKind2[SyntaxKind2["JSDocDeprecatedTag"] = 331] = "JSDocDeprecatedTag";
        SyntaxKind2[SyntaxKind2["JSDocClassTag"] = 332] = "JSDocClassTag";
        SyntaxKind2[SyntaxKind2["JSDocPublicTag"] = 333] = "JSDocPublicTag";
        SyntaxKind2[SyntaxKind2["JSDocPrivateTag"] = 334] = "JSDocPrivateTag";
        SyntaxKind2[SyntaxKind2["JSDocProtectedTag"] = 335] = "JSDocProtectedTag";
        SyntaxKind2[SyntaxKind2["JSDocReadonlyTag"] = 336] = "JSDocReadonlyTag";
        SyntaxKind2[SyntaxKind2["JSDocOverrideTag"] = 337] = "JSDocOverrideTag";
        SyntaxKind2[SyntaxKind2["JSDocCallbackTag"] = 338] = "JSDocCallbackTag";
        SyntaxKind2[SyntaxKind2["JSDocEnumTag"] = 339] = "JSDocEnumTag";
        SyntaxKind2[SyntaxKind2["JSDocParameterTag"] = 340] = "JSDocParameterTag";
        SyntaxKind2[SyntaxKind2["JSDocReturnTag"] = 341] = "JSDocReturnTag";
        SyntaxKind2[SyntaxKind2["JSDocThisTag"] = 342] = "JSDocThisTag";
        SyntaxKind2[SyntaxKind2["JSDocTypeTag"] = 343] = "JSDocTypeTag";
        SyntaxKind2[SyntaxKind2["JSDocTemplateTag"] = 344] = "JSDocTemplateTag";
        SyntaxKind2[SyntaxKind2["JSDocTypedefTag"] = 345] = "JSDocTypedefTag";
        SyntaxKind2[SyntaxKind2["JSDocSeeTag"] = 346] = "JSDocSeeTag";
        SyntaxKind2[SyntaxKind2["JSDocPropertyTag"] = 347] = "JSDocPropertyTag";
        SyntaxKind2[SyntaxKind2["SyntaxList"] = 348] = "SyntaxList";
        SyntaxKind2[SyntaxKind2["NotEmittedStatement"] = 349] = "NotEmittedStatement";
        SyntaxKind2[SyntaxKind2["PartiallyEmittedExpression"] = 350] = "PartiallyEmittedExpression";
        SyntaxKind2[SyntaxKind2["CommaListExpression"] = 351] = "CommaListExpression";
        SyntaxKind2[SyntaxKind2["MergeDeclarationMarker"] = 352] = "MergeDeclarationMarker";
        SyntaxKind2[SyntaxKind2["EndOfDeclarationMarker"] = 353] = "EndOfDeclarationMarker";
        SyntaxKind2[SyntaxKind2["SyntheticReferenceExpression"] = 354] = "SyntheticReferenceExpression";
        SyntaxKind2[SyntaxKind2["Count"] = 355] = "Count";
        SyntaxKind2[SyntaxKind2["FirstAssignment"] = 63] = "FirstAssignment";
        SyntaxKind2[SyntaxKind2["LastAssignment"] = 78] = "LastAssignment";
        SyntaxKind2[SyntaxKind2["FirstCompoundAssignment"] = 64] = "FirstCompoundAssignment";
        SyntaxKind2[SyntaxKind2["LastCompoundAssignment"] = 78] = "LastCompoundAssignment";
        SyntaxKind2[SyntaxKind2["FirstReservedWord"] = 81] = "FirstReservedWord";
        SyntaxKind2[SyntaxKind2["LastReservedWord"] = 116] = "LastReservedWord";
        SyntaxKind2[SyntaxKind2["FirstKeyword"] = 81] = "FirstKeyword";
        SyntaxKind2[SyntaxKind2["LastKeyword"] = 160] = "LastKeyword";
        SyntaxKind2[SyntaxKind2["FirstFutureReservedWord"] = 117] = "FirstFutureReservedWord";
        SyntaxKind2[SyntaxKind2["LastFutureReservedWord"] = 125] = "LastFutureReservedWord";
        SyntaxKind2[SyntaxKind2["FirstTypeNode"] = 177] = "FirstTypeNode";
        SyntaxKind2[SyntaxKind2["LastTypeNode"] = 200] = "LastTypeNode";
        SyntaxKind2[SyntaxKind2["FirstPunctuation"] = 18] = "FirstPunctuation";
        SyntaxKind2[SyntaxKind2["LastPunctuation"] = 78] = "LastPunctuation";
        SyntaxKind2[SyntaxKind2["FirstToken"] = 0] = "FirstToken";
        SyntaxKind2[SyntaxKind2["LastToken"] = 160] = "LastToken";
        SyntaxKind2[SyntaxKind2["FirstTriviaToken"] = 2] = "FirstTriviaToken";
        SyntaxKind2[SyntaxKind2["LastTriviaToken"] = 7] = "LastTriviaToken";
        SyntaxKind2[SyntaxKind2["FirstLiteralToken"] = 8] = "FirstLiteralToken";
        SyntaxKind2[SyntaxKind2["LastLiteralToken"] = 14] = "LastLiteralToken";
        SyntaxKind2[SyntaxKind2["FirstTemplateToken"] = 14] = "FirstTemplateToken";
        SyntaxKind2[SyntaxKind2["LastTemplateToken"] = 17] = "LastTemplateToken";
        SyntaxKind2[SyntaxKind2["FirstBinaryOperator"] = 29] = "FirstBinaryOperator";
        SyntaxKind2[SyntaxKind2["LastBinaryOperator"] = 78] = "LastBinaryOperator";
        SyntaxKind2[SyntaxKind2["FirstStatement"] = 237] = "FirstStatement";
        SyntaxKind2[SyntaxKind2["LastStatement"] = 253] = "LastStatement";
        SyntaxKind2[SyntaxKind2["FirstNode"] = 161] = "FirstNode";
        SyntaxKind2[SyntaxKind2["FirstJSDocNode"] = 309] = "FirstJSDocNode";
        SyntaxKind2[SyntaxKind2["LastJSDocNode"] = 347] = "LastJSDocNode";
        SyntaxKind2[SyntaxKind2["FirstJSDocTagNode"] = 327] = "FirstJSDocTagNode";
        SyntaxKind2[SyntaxKind2["LastJSDocTagNode"] = 347] = "LastJSDocTagNode";
        SyntaxKind2[SyntaxKind2["FirstContextualKeyword"] = 126] = "FirstContextualKeyword";
        SyntaxKind2[SyntaxKind2["LastContextualKeyword"] = 160] = "LastContextualKeyword";
        SyntaxKind2[SyntaxKind2["JSDoc"] = 320] = "JSDoc";
      })(SyntaxKind = ts3.SyntaxKind || (ts3.SyntaxKind = {}));
      var NodeFlags;
      (function(NodeFlags2) {
        NodeFlags2[NodeFlags2["None"] = 0] = "None";
        NodeFlags2[NodeFlags2["Let"] = 1] = "Let";
        NodeFlags2[NodeFlags2["Const"] = 2] = "Const";
        NodeFlags2[NodeFlags2["NestedNamespace"] = 4] = "NestedNamespace";
        NodeFlags2[NodeFlags2["Synthesized"] = 8] = "Synthesized";
        NodeFlags2[NodeFlags2["Namespace"] = 16] = "Namespace";
        NodeFlags2[NodeFlags2["OptionalChain"] = 32] = "OptionalChain";
        NodeFlags2[NodeFlags2["ExportContext"] = 64] = "ExportContext";
        NodeFlags2[NodeFlags2["ContainsThis"] = 128] = "ContainsThis";
        NodeFlags2[NodeFlags2["HasImplicitReturn"] = 256] = "HasImplicitReturn";
        NodeFlags2[NodeFlags2["HasExplicitReturn"] = 512] = "HasExplicitReturn";
        NodeFlags2[NodeFlags2["GlobalAugmentation"] = 1024] = "GlobalAugmentation";
        NodeFlags2[NodeFlags2["HasAsyncFunctions"] = 2048] = "HasAsyncFunctions";
        NodeFlags2[NodeFlags2["DisallowInContext"] = 4096] = "DisallowInContext";
        NodeFlags2[NodeFlags2["YieldContext"] = 8192] = "YieldContext";
        NodeFlags2[NodeFlags2["DecoratorContext"] = 16384] = "DecoratorContext";
        NodeFlags2[NodeFlags2["AwaitContext"] = 32768] = "AwaitContext";
        NodeFlags2[NodeFlags2["DisallowConditionalTypesContext"] = 65536] = "DisallowConditionalTypesContext";
        NodeFlags2[NodeFlags2["ThisNodeHasError"] = 131072] = "ThisNodeHasError";
        NodeFlags2[NodeFlags2["JavaScriptFile"] = 262144] = "JavaScriptFile";
        NodeFlags2[NodeFlags2["ThisNodeOrAnySubNodesHasError"] = 524288] = "ThisNodeOrAnySubNodesHasError";
        NodeFlags2[NodeFlags2["HasAggregatedChildData"] = 1048576] = "HasAggregatedChildData";
        NodeFlags2[NodeFlags2["PossiblyContainsDynamicImport"] = 2097152] = "PossiblyContainsDynamicImport";
        NodeFlags2[NodeFlags2["PossiblyContainsImportMeta"] = 4194304] = "PossiblyContainsImportMeta";
        NodeFlags2[NodeFlags2["JSDoc"] = 8388608] = "JSDoc";
        NodeFlags2[NodeFlags2["Ambient"] = 16777216] = "Ambient";
        NodeFlags2[NodeFlags2["InWithStatement"] = 33554432] = "InWithStatement";
        NodeFlags2[NodeFlags2["JsonFile"] = 67108864] = "JsonFile";
        NodeFlags2[NodeFlags2["TypeCached"] = 134217728] = "TypeCached";
        NodeFlags2[NodeFlags2["Deprecated"] = 268435456] = "Deprecated";
        NodeFlags2[NodeFlags2["BlockScoped"] = 3] = "BlockScoped";
        NodeFlags2[NodeFlags2["ReachabilityCheckFlags"] = 768] = "ReachabilityCheckFlags";
        NodeFlags2[NodeFlags2["ReachabilityAndEmitFlags"] = 2816] = "ReachabilityAndEmitFlags";
        NodeFlags2[NodeFlags2["ContextFlags"] = 50720768] = "ContextFlags";
        NodeFlags2[NodeFlags2["TypeExcludesFlags"] = 40960] = "TypeExcludesFlags";
        NodeFlags2[NodeFlags2["PermanentlySetIncrementalFlags"] = 6291456] = "PermanentlySetIncrementalFlags";
      })(NodeFlags = ts3.NodeFlags || (ts3.NodeFlags = {}));
      var ModifierFlags;
      (function(ModifierFlags2) {
        ModifierFlags2[ModifierFlags2["None"] = 0] = "None";
        ModifierFlags2[ModifierFlags2["Export"] = 1] = "Export";
        ModifierFlags2[ModifierFlags2["Ambient"] = 2] = "Ambient";
        ModifierFlags2[ModifierFlags2["Public"] = 4] = "Public";
        ModifierFlags2[ModifierFlags2["Private"] = 8] = "Private";
        ModifierFlags2[ModifierFlags2["Protected"] = 16] = "Protected";
        ModifierFlags2[ModifierFlags2["Static"] = 32] = "Static";
        ModifierFlags2[ModifierFlags2["Readonly"] = 64] = "Readonly";
        ModifierFlags2[ModifierFlags2["Abstract"] = 128] = "Abstract";
        ModifierFlags2[ModifierFlags2["Async"] = 256] = "Async";
        ModifierFlags2[ModifierFlags2["Default"] = 512] = "Default";
        ModifierFlags2[ModifierFlags2["Const"] = 2048] = "Const";
        ModifierFlags2[ModifierFlags2["HasComputedJSDocModifiers"] = 4096] = "HasComputedJSDocModifiers";
        ModifierFlags2[ModifierFlags2["Deprecated"] = 8192] = "Deprecated";
        ModifierFlags2[ModifierFlags2["Override"] = 16384] = "Override";
        ModifierFlags2[ModifierFlags2["In"] = 32768] = "In";
        ModifierFlags2[ModifierFlags2["Out"] = 65536] = "Out";
        ModifierFlags2[ModifierFlags2["HasComputedFlags"] = 536870912] = "HasComputedFlags";
        ModifierFlags2[ModifierFlags2["AccessibilityModifier"] = 28] = "AccessibilityModifier";
        ModifierFlags2[ModifierFlags2["ParameterPropertyModifier"] = 16476] = "ParameterPropertyModifier";
        ModifierFlags2[ModifierFlags2["NonPublicAccessibilityModifier"] = 24] = "NonPublicAccessibilityModifier";
        ModifierFlags2[ModifierFlags2["TypeScriptModifier"] = 116958] = "TypeScriptModifier";
        ModifierFlags2[ModifierFlags2["ExportDefault"] = 513] = "ExportDefault";
        ModifierFlags2[ModifierFlags2["All"] = 125951] = "All";
      })(ModifierFlags = ts3.ModifierFlags || (ts3.ModifierFlags = {}));
      var JsxFlags;
      (function(JsxFlags2) {
        JsxFlags2[JsxFlags2["None"] = 0] = "None";
        JsxFlags2[JsxFlags2["IntrinsicNamedElement"] = 1] = "IntrinsicNamedElement";
        JsxFlags2[JsxFlags2["IntrinsicIndexedElement"] = 2] = "IntrinsicIndexedElement";
        JsxFlags2[JsxFlags2["IntrinsicElement"] = 3] = "IntrinsicElement";
      })(JsxFlags = ts3.JsxFlags || (ts3.JsxFlags = {}));
      var RelationComparisonResult;
      (function(RelationComparisonResult2) {
        RelationComparisonResult2[RelationComparisonResult2["Succeeded"] = 1] = "Succeeded";
        RelationComparisonResult2[RelationComparisonResult2["Failed"] = 2] = "Failed";
        RelationComparisonResult2[RelationComparisonResult2["Reported"] = 4] = "Reported";
        RelationComparisonResult2[RelationComparisonResult2["ReportsUnmeasurable"] = 8] = "ReportsUnmeasurable";
        RelationComparisonResult2[RelationComparisonResult2["ReportsUnreliable"] = 16] = "ReportsUnreliable";
        RelationComparisonResult2[RelationComparisonResult2["ReportsMask"] = 24] = "ReportsMask";
      })(RelationComparisonResult = ts3.RelationComparisonResult || (ts3.RelationComparisonResult = {}));
      var GeneratedIdentifierFlags;
      (function(GeneratedIdentifierFlags2) {
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["None"] = 0] = "None";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Auto"] = 1] = "Auto";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Loop"] = 2] = "Loop";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Unique"] = 3] = "Unique";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Node"] = 4] = "Node";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["KindMask"] = 7] = "KindMask";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["ReservedInNestedScopes"] = 8] = "ReservedInNestedScopes";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Optimistic"] = 16] = "Optimistic";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["FileLevel"] = 32] = "FileLevel";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["AllowNameSubstitution"] = 64] = "AllowNameSubstitution";
      })(GeneratedIdentifierFlags = ts3.GeneratedIdentifierFlags || (ts3.GeneratedIdentifierFlags = {}));
      var TokenFlags;
      (function(TokenFlags2) {
        TokenFlags2[TokenFlags2["None"] = 0] = "None";
        TokenFlags2[TokenFlags2["PrecedingLineBreak"] = 1] = "PrecedingLineBreak";
        TokenFlags2[TokenFlags2["PrecedingJSDocComment"] = 2] = "PrecedingJSDocComment";
        TokenFlags2[TokenFlags2["Unterminated"] = 4] = "Unterminated";
        TokenFlags2[TokenFlags2["ExtendedUnicodeEscape"] = 8] = "ExtendedUnicodeEscape";
        TokenFlags2[TokenFlags2["Scientific"] = 16] = "Scientific";
        TokenFlags2[TokenFlags2["Octal"] = 32] = "Octal";
        TokenFlags2[TokenFlags2["HexSpecifier"] = 64] = "HexSpecifier";
        TokenFlags2[TokenFlags2["BinarySpecifier"] = 128] = "BinarySpecifier";
        TokenFlags2[TokenFlags2["OctalSpecifier"] = 256] = "OctalSpecifier";
        TokenFlags2[TokenFlags2["ContainsSeparator"] = 512] = "ContainsSeparator";
        TokenFlags2[TokenFlags2["UnicodeEscape"] = 1024] = "UnicodeEscape";
        TokenFlags2[TokenFlags2["ContainsInvalidEscape"] = 2048] = "ContainsInvalidEscape";
        TokenFlags2[TokenFlags2["BinaryOrOctalSpecifier"] = 384] = "BinaryOrOctalSpecifier";
        TokenFlags2[TokenFlags2["NumericLiteralFlags"] = 1008] = "NumericLiteralFlags";
        TokenFlags2[TokenFlags2["TemplateLiteralLikeFlags"] = 2048] = "TemplateLiteralLikeFlags";
      })(TokenFlags = ts3.TokenFlags || (ts3.TokenFlags = {}));
      var FlowFlags;
      (function(FlowFlags2) {
        FlowFlags2[FlowFlags2["Unreachable"] = 1] = "Unreachable";
        FlowFlags2[FlowFlags2["Start"] = 2] = "Start";
        FlowFlags2[FlowFlags2["BranchLabel"] = 4] = "BranchLabel";
        FlowFlags2[FlowFlags2["LoopLabel"] = 8] = "LoopLabel";
        FlowFlags2[FlowFlags2["Assignment"] = 16] = "Assignment";
        FlowFlags2[FlowFlags2["TrueCondition"] = 32] = "TrueCondition";
        FlowFlags2[FlowFlags2["FalseCondition"] = 64] = "FalseCondition";
        FlowFlags2[FlowFlags2["SwitchClause"] = 128] = "SwitchClause";
        FlowFlags2[FlowFlags2["ArrayMutation"] = 256] = "ArrayMutation";
        FlowFlags2[FlowFlags2["Call"] = 512] = "Call";
        FlowFlags2[FlowFlags2["ReduceLabel"] = 1024] = "ReduceLabel";
        FlowFlags2[FlowFlags2["Referenced"] = 2048] = "Referenced";
        FlowFlags2[FlowFlags2["Shared"] = 4096] = "Shared";
        FlowFlags2[FlowFlags2["Label"] = 12] = "Label";
        FlowFlags2[FlowFlags2["Condition"] = 96] = "Condition";
      })(FlowFlags = ts3.FlowFlags || (ts3.FlowFlags = {}));
      var CommentDirectiveType;
      (function(CommentDirectiveType2) {
        CommentDirectiveType2[CommentDirectiveType2["ExpectError"] = 0] = "ExpectError";
        CommentDirectiveType2[CommentDirectiveType2["Ignore"] = 1] = "Ignore";
      })(CommentDirectiveType = ts3.CommentDirectiveType || (ts3.CommentDirectiveType = {}));
      var OperationCanceledException = function() {
        function OperationCanceledException2() {
        }
        return OperationCanceledException2;
      }();
      ts3.OperationCanceledException = OperationCanceledException;
      var FileIncludeKind;
      (function(FileIncludeKind2) {
        FileIncludeKind2[FileIncludeKind2["RootFile"] = 0] = "RootFile";
        FileIncludeKind2[FileIncludeKind2["SourceFromProjectReference"] = 1] = "SourceFromProjectReference";
        FileIncludeKind2[FileIncludeKind2["OutputFromProjectReference"] = 2] = "OutputFromProjectReference";
        FileIncludeKind2[FileIncludeKind2["Import"] = 3] = "Import";
        FileIncludeKind2[FileIncludeKind2["ReferenceFile"] = 4] = "ReferenceFile";
        FileIncludeKind2[FileIncludeKind2["TypeReferenceDirective"] = 5] = "TypeReferenceDirective";
        FileIncludeKind2[FileIncludeKind2["LibFile"] = 6] = "LibFile";
        FileIncludeKind2[FileIncludeKind2["LibReferenceDirective"] = 7] = "LibReferenceDirective";
        FileIncludeKind2[FileIncludeKind2["AutomaticTypeDirectiveFile"] = 8] = "AutomaticTypeDirectiveFile";
      })(FileIncludeKind = ts3.FileIncludeKind || (ts3.FileIncludeKind = {}));
      var FilePreprocessingDiagnosticsKind;
      (function(FilePreprocessingDiagnosticsKind2) {
        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["FilePreprocessingReferencedDiagnostic"] = 0] = "FilePreprocessingReferencedDiagnostic";
        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["FilePreprocessingFileExplainingDiagnostic"] = 1] = "FilePreprocessingFileExplainingDiagnostic";
      })(FilePreprocessingDiagnosticsKind = ts3.FilePreprocessingDiagnosticsKind || (ts3.FilePreprocessingDiagnosticsKind = {}));
      var StructureIsReused;
      (function(StructureIsReused2) {
        StructureIsReused2[StructureIsReused2["Not"] = 0] = "Not";
        StructureIsReused2[StructureIsReused2["SafeModules"] = 1] = "SafeModules";
        StructureIsReused2[StructureIsReused2["Completely"] = 2] = "Completely";
      })(StructureIsReused = ts3.StructureIsReused || (ts3.StructureIsReused = {}));
      var ExitStatus;
      (function(ExitStatus2) {
        ExitStatus2[ExitStatus2["Success"] = 0] = "Success";
        ExitStatus2[ExitStatus2["DiagnosticsPresent_OutputsSkipped"] = 1] = "DiagnosticsPresent_OutputsSkipped";
        ExitStatus2[ExitStatus2["DiagnosticsPresent_OutputsGenerated"] = 2] = "DiagnosticsPresent_OutputsGenerated";
        ExitStatus2[ExitStatus2["InvalidProject_OutputsSkipped"] = 3] = "InvalidProject_OutputsSkipped";
        ExitStatus2[ExitStatus2["ProjectReferenceCycle_OutputsSkipped"] = 4] = "ProjectReferenceCycle_OutputsSkipped";
        ExitStatus2[ExitStatus2["ProjectReferenceCycle_OutputsSkupped"] = 4] = "ProjectReferenceCycle_OutputsSkupped";
      })(ExitStatus = ts3.ExitStatus || (ts3.ExitStatus = {}));
      var MemberOverrideStatus;
      (function(MemberOverrideStatus2) {
        MemberOverrideStatus2[MemberOverrideStatus2["Ok"] = 0] = "Ok";
        MemberOverrideStatus2[MemberOverrideStatus2["NeedsOverride"] = 1] = "NeedsOverride";
        MemberOverrideStatus2[MemberOverrideStatus2["HasInvalidOverride"] = 2] = "HasInvalidOverride";
      })(MemberOverrideStatus = ts3.MemberOverrideStatus || (ts3.MemberOverrideStatus = {}));
      var UnionReduction;
      (function(UnionReduction2) {
        UnionReduction2[UnionReduction2["None"] = 0] = "None";
        UnionReduction2[UnionReduction2["Literal"] = 1] = "Literal";
        UnionReduction2[UnionReduction2["Subtype"] = 2] = "Subtype";
      })(UnionReduction = ts3.UnionReduction || (ts3.UnionReduction = {}));
      var ContextFlags;
      (function(ContextFlags2) {
        ContextFlags2[ContextFlags2["None"] = 0] = "None";
        ContextFlags2[ContextFlags2["Signature"] = 1] = "Signature";
        ContextFlags2[ContextFlags2["NoConstraints"] = 2] = "NoConstraints";
        ContextFlags2[ContextFlags2["Completions"] = 4] = "Completions";
        ContextFlags2[ContextFlags2["SkipBindingPatterns"] = 8] = "SkipBindingPatterns";
      })(ContextFlags = ts3.ContextFlags || (ts3.ContextFlags = {}));
      var NodeBuilderFlags;
      (function(NodeBuilderFlags2) {
        NodeBuilderFlags2[NodeBuilderFlags2["None"] = 0] = "None";
        NodeBuilderFlags2[NodeBuilderFlags2["NoTruncation"] = 1] = "NoTruncation";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
        NodeBuilderFlags2[NodeBuilderFlags2["GenerateNamesForShadowedTypeParams"] = 4] = "GenerateNamesForShadowedTypeParams";
        NodeBuilderFlags2[NodeBuilderFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
        NodeBuilderFlags2[NodeBuilderFlags2["ForbidIndexedAccessSymbolReferences"] = 16] = "ForbidIndexedAccessSymbolReferences";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
        NodeBuilderFlags2[NodeBuilderFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
        NodeBuilderFlags2[NodeBuilderFlags2["UseOnlyExternalAliasing"] = 128] = "UseOnlyExternalAliasing";
        NodeBuilderFlags2[NodeBuilderFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeParametersInQualifiedName"] = 512] = "WriteTypeParametersInQualifiedName";
        NodeBuilderFlags2[NodeBuilderFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
        NodeBuilderFlags2[NodeBuilderFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
        NodeBuilderFlags2[NodeBuilderFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
        NodeBuilderFlags2[NodeBuilderFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
        NodeBuilderFlags2[NodeBuilderFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowThisInObjectLiteral"] = 32768] = "AllowThisInObjectLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowQualifiedNameInPlaceOfIdentifier"] = 65536] = "AllowQualifiedNameInPlaceOfIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowQualifedNameInPlaceOfIdentifier"] = 65536] = "AllowQualifedNameInPlaceOfIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowAnonymousIdentifier"] = 131072] = "AllowAnonymousIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyUnionOrIntersection"] = 262144] = "AllowEmptyUnionOrIntersection";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyTuple"] = 524288] = "AllowEmptyTuple";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyIndexInfoType"] = 2097152] = "AllowEmptyIndexInfoType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowNodeModulesRelativePaths"] = 67108864] = "AllowNodeModulesRelativePaths";
        NodeBuilderFlags2[NodeBuilderFlags2["DoNotIncludeSymbolChain"] = 134217728] = "DoNotIncludeSymbolChain";
        NodeBuilderFlags2[NodeBuilderFlags2["IgnoreErrors"] = 70221824] = "IgnoreErrors";
        NodeBuilderFlags2[NodeBuilderFlags2["InObjectTypeLiteral"] = 4194304] = "InObjectTypeLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
        NodeBuilderFlags2[NodeBuilderFlags2["InInitialEntityName"] = 16777216] = "InInitialEntityName";
      })(NodeBuilderFlags = ts3.NodeBuilderFlags || (ts3.NodeBuilderFlags = {}));
      var TypeFormatFlags;
      (function(TypeFormatFlags2) {
        TypeFormatFlags2[TypeFormatFlags2["None"] = 0] = "None";
        TypeFormatFlags2[TypeFormatFlags2["NoTruncation"] = 1] = "NoTruncation";
        TypeFormatFlags2[TypeFormatFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
        TypeFormatFlags2[TypeFormatFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
        TypeFormatFlags2[TypeFormatFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
        TypeFormatFlags2[TypeFormatFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
        TypeFormatFlags2[TypeFormatFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
        TypeFormatFlags2[TypeFormatFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
        TypeFormatFlags2[TypeFormatFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
        TypeFormatFlags2[TypeFormatFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
        TypeFormatFlags2[TypeFormatFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
        TypeFormatFlags2[TypeFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
        TypeFormatFlags2[TypeFormatFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
        TypeFormatFlags2[TypeFormatFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
        TypeFormatFlags2[TypeFormatFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
        TypeFormatFlags2[TypeFormatFlags2["AddUndefined"] = 131072] = "AddUndefined";
        TypeFormatFlags2[TypeFormatFlags2["WriteArrowStyleSignature"] = 262144] = "WriteArrowStyleSignature";
        TypeFormatFlags2[TypeFormatFlags2["InArrayType"] = 524288] = "InArrayType";
        TypeFormatFlags2[TypeFormatFlags2["InElementType"] = 2097152] = "InElementType";
        TypeFormatFlags2[TypeFormatFlags2["InFirstTypeArgument"] = 4194304] = "InFirstTypeArgument";
        TypeFormatFlags2[TypeFormatFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
        TypeFormatFlags2[TypeFormatFlags2["WriteOwnNameForAnyLike"] = 0] = "WriteOwnNameForAnyLike";
        TypeFormatFlags2[TypeFormatFlags2["NodeBuilderFlagsMask"] = 814775659] = "NodeBuilderFlagsMask";
      })(TypeFormatFlags = ts3.TypeFormatFlags || (ts3.TypeFormatFlags = {}));
      var SymbolFormatFlags;
      (function(SymbolFormatFlags2) {
        SymbolFormatFlags2[SymbolFormatFlags2["None"] = 0] = "None";
        SymbolFormatFlags2[SymbolFormatFlags2["WriteTypeParametersOrArguments"] = 1] = "WriteTypeParametersOrArguments";
        SymbolFormatFlags2[SymbolFormatFlags2["UseOnlyExternalAliasing"] = 2] = "UseOnlyExternalAliasing";
        SymbolFormatFlags2[SymbolFormatFlags2["AllowAnyNodeKind"] = 4] = "AllowAnyNodeKind";
        SymbolFormatFlags2[SymbolFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 8] = "UseAliasDefinedOutsideCurrentScope";
        SymbolFormatFlags2[SymbolFormatFlags2["DoNotIncludeSymbolChain"] = 16] = "DoNotIncludeSymbolChain";
      })(SymbolFormatFlags = ts3.SymbolFormatFlags || (ts3.SymbolFormatFlags = {}));
      var SymbolAccessibility;
      (function(SymbolAccessibility2) {
        SymbolAccessibility2[SymbolAccessibility2["Accessible"] = 0] = "Accessible";
        SymbolAccessibility2[SymbolAccessibility2["NotAccessible"] = 1] = "NotAccessible";
        SymbolAccessibility2[SymbolAccessibility2["CannotBeNamed"] = 2] = "CannotBeNamed";
      })(SymbolAccessibility = ts3.SymbolAccessibility || (ts3.SymbolAccessibility = {}));
      var SyntheticSymbolKind;
      (function(SyntheticSymbolKind2) {
        SyntheticSymbolKind2[SyntheticSymbolKind2["UnionOrIntersection"] = 0] = "UnionOrIntersection";
        SyntheticSymbolKind2[SyntheticSymbolKind2["Spread"] = 1] = "Spread";
      })(SyntheticSymbolKind = ts3.SyntheticSymbolKind || (ts3.SyntheticSymbolKind = {}));
      var TypePredicateKind;
      (function(TypePredicateKind2) {
        TypePredicateKind2[TypePredicateKind2["This"] = 0] = "This";
        TypePredicateKind2[TypePredicateKind2["Identifier"] = 1] = "Identifier";
        TypePredicateKind2[TypePredicateKind2["AssertsThis"] = 2] = "AssertsThis";
        TypePredicateKind2[TypePredicateKind2["AssertsIdentifier"] = 3] = "AssertsIdentifier";
      })(TypePredicateKind = ts3.TypePredicateKind || (ts3.TypePredicateKind = {}));
      var TypeReferenceSerializationKind;
      (function(TypeReferenceSerializationKind2) {
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Unknown"] = 0] = "Unknown";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithConstructSignatureAndValue"] = 1] = "TypeWithConstructSignatureAndValue";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["VoidNullableOrNeverType"] = 2] = "VoidNullableOrNeverType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["NumberLikeType"] = 3] = "NumberLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BigIntLikeType"] = 4] = "BigIntLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["StringLikeType"] = 5] = "StringLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BooleanType"] = 6] = "BooleanType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ArrayLikeType"] = 7] = "ArrayLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ESSymbolType"] = 8] = "ESSymbolType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Promise"] = 9] = "Promise";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithCallSignature"] = 10] = "TypeWithCallSignature";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ObjectType"] = 11] = "ObjectType";
      })(TypeReferenceSerializationKind = ts3.TypeReferenceSerializationKind || (ts3.TypeReferenceSerializationKind = {}));
      var SymbolFlags;
      (function(SymbolFlags2) {
        SymbolFlags2[SymbolFlags2["None"] = 0] = "None";
        SymbolFlags2[SymbolFlags2["FunctionScopedVariable"] = 1] = "FunctionScopedVariable";
        SymbolFlags2[SymbolFlags2["BlockScopedVariable"] = 2] = "BlockScopedVariable";
        SymbolFlags2[SymbolFlags2["Property"] = 4] = "Property";
        SymbolFlags2[SymbolFlags2["EnumMember"] = 8] = "EnumMember";
        SymbolFlags2[SymbolFlags2["Function"] = 16] = "Function";
        SymbolFlags2[SymbolFlags2["Class"] = 32] = "Class";
        SymbolFlags2[SymbolFlags2["Interface"] = 64] = "Interface";
        SymbolFlags2[SymbolFlags2["ConstEnum"] = 128] = "ConstEnum";
        SymbolFlags2[SymbolFlags2["RegularEnum"] = 256] = "RegularEnum";
        SymbolFlags2[SymbolFlags2["ValueModule"] = 512] = "ValueModule";
        SymbolFlags2[SymbolFlags2["NamespaceModule"] = 1024] = "NamespaceModule";
        SymbolFlags2[SymbolFlags2["TypeLiteral"] = 2048] = "TypeLiteral";
        SymbolFlags2[SymbolFlags2["ObjectLiteral"] = 4096] = "ObjectLiteral";
        SymbolFlags2[SymbolFlags2["Method"] = 8192] = "Method";
        SymbolFlags2[SymbolFlags2["Constructor"] = 16384] = "Constructor";
        SymbolFlags2[SymbolFlags2["GetAccessor"] = 32768] = "GetAccessor";
        SymbolFlags2[SymbolFlags2["SetAccessor"] = 65536] = "SetAccessor";
        SymbolFlags2[SymbolFlags2["Signature"] = 131072] = "Signature";
        SymbolFlags2[SymbolFlags2["TypeParameter"] = 262144] = "TypeParameter";
        SymbolFlags2[SymbolFlags2["TypeAlias"] = 524288] = "TypeAlias";
        SymbolFlags2[SymbolFlags2["ExportValue"] = 1048576] = "ExportValue";
        SymbolFlags2[SymbolFlags2["Alias"] = 2097152] = "Alias";
        SymbolFlags2[SymbolFlags2["Prototype"] = 4194304] = "Prototype";
        SymbolFlags2[SymbolFlags2["ExportStar"] = 8388608] = "ExportStar";
        SymbolFlags2[SymbolFlags2["Optional"] = 16777216] = "Optional";
        SymbolFlags2[SymbolFlags2["Transient"] = 33554432] = "Transient";
        SymbolFlags2[SymbolFlags2["Assignment"] = 67108864] = "Assignment";
        SymbolFlags2[SymbolFlags2["ModuleExports"] = 134217728] = "ModuleExports";
        SymbolFlags2[SymbolFlags2["All"] = 67108863] = "All";
        SymbolFlags2[SymbolFlags2["Enum"] = 384] = "Enum";
        SymbolFlags2[SymbolFlags2["Variable"] = 3] = "Variable";
        SymbolFlags2[SymbolFlags2["Value"] = 111551] = "Value";
        SymbolFlags2[SymbolFlags2["Type"] = 788968] = "Type";
        SymbolFlags2[SymbolFlags2["Namespace"] = 1920] = "Namespace";
        SymbolFlags2[SymbolFlags2["Module"] = 1536] = "Module";
        SymbolFlags2[SymbolFlags2["Accessor"] = 98304] = "Accessor";
        SymbolFlags2[SymbolFlags2["FunctionScopedVariableExcludes"] = 111550] = "FunctionScopedVariableExcludes";
        SymbolFlags2[SymbolFlags2["BlockScopedVariableExcludes"] = 111551] = "BlockScopedVariableExcludes";
        SymbolFlags2[SymbolFlags2["ParameterExcludes"] = 111551] = "ParameterExcludes";
        SymbolFlags2[SymbolFlags2["PropertyExcludes"] = 0] = "PropertyExcludes";
        SymbolFlags2[SymbolFlags2["EnumMemberExcludes"] = 900095] = "EnumMemberExcludes";
        SymbolFlags2[SymbolFlags2["FunctionExcludes"] = 110991] = "FunctionExcludes";
        SymbolFlags2[SymbolFlags2["ClassExcludes"] = 899503] = "ClassExcludes";
        SymbolFlags2[SymbolFlags2["InterfaceExcludes"] = 788872] = "InterfaceExcludes";
        SymbolFlags2[SymbolFlags2["RegularEnumExcludes"] = 899327] = "RegularEnumExcludes";
        SymbolFlags2[SymbolFlags2["ConstEnumExcludes"] = 899967] = "ConstEnumExcludes";
        SymbolFlags2[SymbolFlags2["ValueModuleExcludes"] = 110735] = "ValueModuleExcludes";
        SymbolFlags2[SymbolFlags2["NamespaceModuleExcludes"] = 0] = "NamespaceModuleExcludes";
        SymbolFlags2[SymbolFlags2["MethodExcludes"] = 103359] = "MethodExcludes";
        SymbolFlags2[SymbolFlags2["GetAccessorExcludes"] = 46015] = "GetAccessorExcludes";
        SymbolFlags2[SymbolFlags2["SetAccessorExcludes"] = 78783] = "SetAccessorExcludes";
        SymbolFlags2[SymbolFlags2["TypeParameterExcludes"] = 526824] = "TypeParameterExcludes";
        SymbolFlags2[SymbolFlags2["TypeAliasExcludes"] = 788968] = "TypeAliasExcludes";
        SymbolFlags2[SymbolFlags2["AliasExcludes"] = 2097152] = "AliasExcludes";
        SymbolFlags2[SymbolFlags2["ModuleMember"] = 2623475] = "ModuleMember";
        SymbolFlags2[SymbolFlags2["ExportHasLocal"] = 944] = "ExportHasLocal";
        SymbolFlags2[SymbolFlags2["BlockScoped"] = 418] = "BlockScoped";
        SymbolFlags2[SymbolFlags2["PropertyOrAccessor"] = 98308] = "PropertyOrAccessor";
        SymbolFlags2[SymbolFlags2["ClassMember"] = 106500] = "ClassMember";
        SymbolFlags2[SymbolFlags2["ExportSupportsDefaultModifier"] = 112] = "ExportSupportsDefaultModifier";
        SymbolFlags2[SymbolFlags2["ExportDoesNotSupportDefaultModifier"] = -113] = "ExportDoesNotSupportDefaultModifier";
        SymbolFlags2[SymbolFlags2["Classifiable"] = 2885600] = "Classifiable";
        SymbolFlags2[SymbolFlags2["LateBindingContainer"] = 6256] = "LateBindingContainer";
      })(SymbolFlags = ts3.SymbolFlags || (ts3.SymbolFlags = {}));
      var EnumKind;
      (function(EnumKind2) {
        EnumKind2[EnumKind2["Numeric"] = 0] = "Numeric";
        EnumKind2[EnumKind2["Literal"] = 1] = "Literal";
      })(EnumKind = ts3.EnumKind || (ts3.EnumKind = {}));
      var CheckFlags;
      (function(CheckFlags2) {
        CheckFlags2[CheckFlags2["Instantiated"] = 1] = "Instantiated";
        CheckFlags2[CheckFlags2["SyntheticProperty"] = 2] = "SyntheticProperty";
        CheckFlags2[CheckFlags2["SyntheticMethod"] = 4] = "SyntheticMethod";
        CheckFlags2[CheckFlags2["Readonly"] = 8] = "Readonly";
        CheckFlags2[CheckFlags2["ReadPartial"] = 16] = "ReadPartial";
        CheckFlags2[CheckFlags2["WritePartial"] = 32] = "WritePartial";
        CheckFlags2[CheckFlags2["HasNonUniformType"] = 64] = "HasNonUniformType";
        CheckFlags2[CheckFlags2["HasLiteralType"] = 128] = "HasLiteralType";
        CheckFlags2[CheckFlags2["ContainsPublic"] = 256] = "ContainsPublic";
        CheckFlags2[CheckFlags2["ContainsProtected"] = 512] = "ContainsProtected";
        CheckFlags2[CheckFlags2["ContainsPrivate"] = 1024] = "ContainsPrivate";
        CheckFlags2[CheckFlags2["ContainsStatic"] = 2048] = "ContainsStatic";
        CheckFlags2[CheckFlags2["Late"] = 4096] = "Late";
        CheckFlags2[CheckFlags2["ReverseMapped"] = 8192] = "ReverseMapped";
        CheckFlags2[CheckFlags2["OptionalParameter"] = 16384] = "OptionalParameter";
        CheckFlags2[CheckFlags2["RestParameter"] = 32768] = "RestParameter";
        CheckFlags2[CheckFlags2["DeferredType"] = 65536] = "DeferredType";
        CheckFlags2[CheckFlags2["HasNeverType"] = 131072] = "HasNeverType";
        CheckFlags2[CheckFlags2["Mapped"] = 262144] = "Mapped";
        CheckFlags2[CheckFlags2["StripOptional"] = 524288] = "StripOptional";
        CheckFlags2[CheckFlags2["Unresolved"] = 1048576] = "Unresolved";
        CheckFlags2[CheckFlags2["Synthetic"] = 6] = "Synthetic";
        CheckFlags2[CheckFlags2["Discriminant"] = 192] = "Discriminant";
        CheckFlags2[CheckFlags2["Partial"] = 48] = "Partial";
      })(CheckFlags = ts3.CheckFlags || (ts3.CheckFlags = {}));
      var InternalSymbolName;
      (function(InternalSymbolName2) {
        InternalSymbolName2["Call"] = "__call";
        InternalSymbolName2["Constructor"] = "__constructor";
        InternalSymbolName2["New"] = "__new";
        InternalSymbolName2["Index"] = "__index";
        InternalSymbolName2["ExportStar"] = "__export";
        InternalSymbolName2["Global"] = "__global";
        InternalSymbolName2["Missing"] = "__missing";
        InternalSymbolName2["Type"] = "__type";
        InternalSymbolName2["Object"] = "__object";
        InternalSymbolName2["JSXAttributes"] = "__jsxAttributes";
        InternalSymbolName2["Class"] = "__class";
        InternalSymbolName2["Function"] = "__function";
        InternalSymbolName2["Computed"] = "__computed";
        InternalSymbolName2["Resolving"] = "__resolving__";
        InternalSymbolName2["ExportEquals"] = "export=";
        InternalSymbolName2["Default"] = "default";
        InternalSymbolName2["This"] = "this";
      })(InternalSymbolName = ts3.InternalSymbolName || (ts3.InternalSymbolName = {}));
      var NodeCheckFlags;
      (function(NodeCheckFlags2) {
        NodeCheckFlags2[NodeCheckFlags2["TypeChecked"] = 1] = "TypeChecked";
        NodeCheckFlags2[NodeCheckFlags2["LexicalThis"] = 2] = "LexicalThis";
        NodeCheckFlags2[NodeCheckFlags2["CaptureThis"] = 4] = "CaptureThis";
        NodeCheckFlags2[NodeCheckFlags2["CaptureNewTarget"] = 8] = "CaptureNewTarget";
        NodeCheckFlags2[NodeCheckFlags2["SuperInstance"] = 256] = "SuperInstance";
        NodeCheckFlags2[NodeCheckFlags2["SuperStatic"] = 512] = "SuperStatic";
        NodeCheckFlags2[NodeCheckFlags2["ContextChecked"] = 1024] = "ContextChecked";
        NodeCheckFlags2[NodeCheckFlags2["AsyncMethodWithSuper"] = 2048] = "AsyncMethodWithSuper";
        NodeCheckFlags2[NodeCheckFlags2["AsyncMethodWithSuperBinding"] = 4096] = "AsyncMethodWithSuperBinding";
        NodeCheckFlags2[NodeCheckFlags2["CaptureArguments"] = 8192] = "CaptureArguments";
        NodeCheckFlags2[NodeCheckFlags2["EnumValuesComputed"] = 16384] = "EnumValuesComputed";
        NodeCheckFlags2[NodeCheckFlags2["LexicalModuleMergesWithClass"] = 32768] = "LexicalModuleMergesWithClass";
        NodeCheckFlags2[NodeCheckFlags2["LoopWithCapturedBlockScopedBinding"] = 65536] = "LoopWithCapturedBlockScopedBinding";
        NodeCheckFlags2[NodeCheckFlags2["ContainsCapturedBlockScopeBinding"] = 131072] = "ContainsCapturedBlockScopeBinding";
        NodeCheckFlags2[NodeCheckFlags2["CapturedBlockScopedBinding"] = 262144] = "CapturedBlockScopedBinding";
        NodeCheckFlags2[NodeCheckFlags2["BlockScopedBindingInLoop"] = 524288] = "BlockScopedBindingInLoop";
        NodeCheckFlags2[NodeCheckFlags2["ClassWithBodyScopedClassBinding"] = 1048576] = "ClassWithBodyScopedClassBinding";
        NodeCheckFlags2[NodeCheckFlags2["BodyScopedClassBinding"] = 2097152] = "BodyScopedClassBinding";
        NodeCheckFlags2[NodeCheckFlags2["NeedsLoopOutParameter"] = 4194304] = "NeedsLoopOutParameter";
        NodeCheckFlags2[NodeCheckFlags2["AssignmentsMarked"] = 8388608] = "AssignmentsMarked";
        NodeCheckFlags2[NodeCheckFlags2["ClassWithConstructorReference"] = 16777216] = "ClassWithConstructorReference";
        NodeCheckFlags2[NodeCheckFlags2["ConstructorReferenceInClass"] = 33554432] = "ConstructorReferenceInClass";
        NodeCheckFlags2[NodeCheckFlags2["ContainsClassWithPrivateIdentifiers"] = 67108864] = "ContainsClassWithPrivateIdentifiers";
        NodeCheckFlags2[NodeCheckFlags2["ContainsSuperPropertyInStaticInitializer"] = 134217728] = "ContainsSuperPropertyInStaticInitializer";
        NodeCheckFlags2[NodeCheckFlags2["InCheckIdentifier"] = 268435456] = "InCheckIdentifier";
      })(NodeCheckFlags = ts3.NodeCheckFlags || (ts3.NodeCheckFlags = {}));
      var TypeFlags;
      (function(TypeFlags2) {
        TypeFlags2[TypeFlags2["Any"] = 1] = "Any";
        TypeFlags2[TypeFlags2["Unknown"] = 2] = "Unknown";
        TypeFlags2[TypeFlags2["String"] = 4] = "String";
        TypeFlags2[TypeFlags2["Number"] = 8] = "Number";
        TypeFlags2[TypeFlags2["Boolean"] = 16] = "Boolean";
        TypeFlags2[TypeFlags2["Enum"] = 32] = "Enum";
        TypeFlags2[TypeFlags2["BigInt"] = 64] = "BigInt";
        TypeFlags2[TypeFlags2["StringLiteral"] = 128] = "StringLiteral";
        TypeFlags2[TypeFlags2["NumberLiteral"] = 256] = "NumberLiteral";
        TypeFlags2[TypeFlags2["BooleanLiteral"] = 512] = "BooleanLiteral";
        TypeFlags2[TypeFlags2["EnumLiteral"] = 1024] = "EnumLiteral";
        TypeFlags2[TypeFlags2["BigIntLiteral"] = 2048] = "BigIntLiteral";
        TypeFlags2[TypeFlags2["ESSymbol"] = 4096] = "ESSymbol";
        TypeFlags2[TypeFlags2["UniqueESSymbol"] = 8192] = "UniqueESSymbol";
        TypeFlags2[TypeFlags2["Void"] = 16384] = "Void";
        TypeFlags2[TypeFlags2["Undefined"] = 32768] = "Undefined";
        TypeFlags2[TypeFlags2["Null"] = 65536] = "Null";
        TypeFlags2[TypeFlags2["Never"] = 131072] = "Never";
        TypeFlags2[TypeFlags2["TypeParameter"] = 262144] = "TypeParameter";
        TypeFlags2[TypeFlags2["Object"] = 524288] = "Object";
        TypeFlags2[TypeFlags2["Union"] = 1048576] = "Union";
        TypeFlags2[TypeFlags2["Intersection"] = 2097152] = "Intersection";
        TypeFlags2[TypeFlags2["Index"] = 4194304] = "Index";
        TypeFlags2[TypeFlags2["IndexedAccess"] = 8388608] = "IndexedAccess";
        TypeFlags2[TypeFlags2["Conditional"] = 16777216] = "Conditional";
        TypeFlags2[TypeFlags2["Substitution"] = 33554432] = "Substitution";
        TypeFlags2[TypeFlags2["NonPrimitive"] = 67108864] = "NonPrimitive";
        TypeFlags2[TypeFlags2["TemplateLiteral"] = 134217728] = "TemplateLiteral";
        TypeFlags2[TypeFlags2["StringMapping"] = 268435456] = "StringMapping";
        TypeFlags2[TypeFlags2["AnyOrUnknown"] = 3] = "AnyOrUnknown";
        TypeFlags2[TypeFlags2["Nullable"] = 98304] = "Nullable";
        TypeFlags2[TypeFlags2["Literal"] = 2944] = "Literal";
        TypeFlags2[TypeFlags2["Unit"] = 109440] = "Unit";
        TypeFlags2[TypeFlags2["StringOrNumberLiteral"] = 384] = "StringOrNumberLiteral";
        TypeFlags2[TypeFlags2["StringOrNumberLiteralOrUnique"] = 8576] = "StringOrNumberLiteralOrUnique";
        TypeFlags2[TypeFlags2["DefinitelyFalsy"] = 117632] = "DefinitelyFalsy";
        TypeFlags2[TypeFlags2["PossiblyFalsy"] = 117724] = "PossiblyFalsy";
        TypeFlags2[TypeFlags2["Intrinsic"] = 67359327] = "Intrinsic";
        TypeFlags2[TypeFlags2["Primitive"] = 131068] = "Primitive";
        TypeFlags2[TypeFlags2["StringLike"] = 402653316] = "StringLike";
        TypeFlags2[TypeFlags2["NumberLike"] = 296] = "NumberLike";
        TypeFlags2[TypeFlags2["BigIntLike"] = 2112] = "BigIntLike";
        TypeFlags2[TypeFlags2["BooleanLike"] = 528] = "BooleanLike";
        TypeFlags2[TypeFlags2["EnumLike"] = 1056] = "EnumLike";
        TypeFlags2[TypeFlags2["ESSymbolLike"] = 12288] = "ESSymbolLike";
        TypeFlags2[TypeFlags2["VoidLike"] = 49152] = "VoidLike";
        TypeFlags2[TypeFlags2["DefinitelyNonNullable"] = 470302716] = "DefinitelyNonNullable";
        TypeFlags2[TypeFlags2["DisjointDomains"] = 469892092] = "DisjointDomains";
        TypeFlags2[TypeFlags2["UnionOrIntersection"] = 3145728] = "UnionOrIntersection";
        TypeFlags2[TypeFlags2["StructuredType"] = 3670016] = "StructuredType";
        TypeFlags2[TypeFlags2["TypeVariable"] = 8650752] = "TypeVariable";
        TypeFlags2[TypeFlags2["InstantiableNonPrimitive"] = 58982400] = "InstantiableNonPrimitive";
        TypeFlags2[TypeFlags2["InstantiablePrimitive"] = 406847488] = "InstantiablePrimitive";
        TypeFlags2[TypeFlags2["Instantiable"] = 465829888] = "Instantiable";
        TypeFlags2[TypeFlags2["StructuredOrInstantiable"] = 469499904] = "StructuredOrInstantiable";
        TypeFlags2[TypeFlags2["ObjectFlagsType"] = 3899393] = "ObjectFlagsType";
        TypeFlags2[TypeFlags2["Simplifiable"] = 25165824] = "Simplifiable";
        TypeFlags2[TypeFlags2["Singleton"] = 67358815] = "Singleton";
        TypeFlags2[TypeFlags2["Narrowable"] = 536624127] = "Narrowable";
        TypeFlags2[TypeFlags2["IncludesMask"] = 205258751] = "IncludesMask";
        TypeFlags2[TypeFlags2["IncludesMissingType"] = 262144] = "IncludesMissingType";
        TypeFlags2[TypeFlags2["IncludesNonWideningType"] = 4194304] = "IncludesNonWideningType";
        TypeFlags2[TypeFlags2["IncludesWildcard"] = 8388608] = "IncludesWildcard";
        TypeFlags2[TypeFlags2["IncludesEmptyObject"] = 16777216] = "IncludesEmptyObject";
        TypeFlags2[TypeFlags2["IncludesInstantiable"] = 33554432] = "IncludesInstantiable";
        TypeFlags2[TypeFlags2["NotPrimitiveUnion"] = 36323363] = "NotPrimitiveUnion";
      })(TypeFlags = ts3.TypeFlags || (ts3.TypeFlags = {}));
      var ObjectFlags;
      (function(ObjectFlags2) {
        ObjectFlags2[ObjectFlags2["Class"] = 1] = "Class";
        ObjectFlags2[ObjectFlags2["Interface"] = 2] = "Interface";
        ObjectFlags2[ObjectFlags2["Reference"] = 4] = "Reference";
        ObjectFlags2[ObjectFlags2["Tuple"] = 8] = "Tuple";
        ObjectFlags2[ObjectFlags2["Anonymous"] = 16] = "Anonymous";
        ObjectFlags2[ObjectFlags2["Mapped"] = 32] = "Mapped";
        ObjectFlags2[ObjectFlags2["Instantiated"] = 64] = "Instantiated";
        ObjectFlags2[ObjectFlags2["ObjectLiteral"] = 128] = "ObjectLiteral";
        ObjectFlags2[ObjectFlags2["EvolvingArray"] = 256] = "EvolvingArray";
        ObjectFlags2[ObjectFlags2["ObjectLiteralPatternWithComputedProperties"] = 512] = "ObjectLiteralPatternWithComputedProperties";
        ObjectFlags2[ObjectFlags2["ReverseMapped"] = 1024] = "ReverseMapped";
        ObjectFlags2[ObjectFlags2["JsxAttributes"] = 2048] = "JsxAttributes";
        ObjectFlags2[ObjectFlags2["JSLiteral"] = 4096] = "JSLiteral";
        ObjectFlags2[ObjectFlags2["FreshLiteral"] = 8192] = "FreshLiteral";
        ObjectFlags2[ObjectFlags2["ArrayLiteral"] = 16384] = "ArrayLiteral";
        ObjectFlags2[ObjectFlags2["PrimitiveUnion"] = 32768] = "PrimitiveUnion";
        ObjectFlags2[ObjectFlags2["ContainsWideningType"] = 65536] = "ContainsWideningType";
        ObjectFlags2[ObjectFlags2["ContainsObjectOrArrayLiteral"] = 131072] = "ContainsObjectOrArrayLiteral";
        ObjectFlags2[ObjectFlags2["NonInferrableType"] = 262144] = "NonInferrableType";
        ObjectFlags2[ObjectFlags2["CouldContainTypeVariablesComputed"] = 524288] = "CouldContainTypeVariablesComputed";
        ObjectFlags2[ObjectFlags2["CouldContainTypeVariables"] = 1048576] = "CouldContainTypeVariables";
        ObjectFlags2[ObjectFlags2["ClassOrInterface"] = 3] = "ClassOrInterface";
        ObjectFlags2[ObjectFlags2["RequiresWidening"] = 196608] = "RequiresWidening";
        ObjectFlags2[ObjectFlags2["PropagatingFlags"] = 458752] = "PropagatingFlags";
        ObjectFlags2[ObjectFlags2["ObjectTypeKindMask"] = 1343] = "ObjectTypeKindMask";
        ObjectFlags2[ObjectFlags2["ContainsSpread"] = 2097152] = "ContainsSpread";
        ObjectFlags2[ObjectFlags2["ObjectRestType"] = 4194304] = "ObjectRestType";
        ObjectFlags2[ObjectFlags2["InstantiationExpressionType"] = 8388608] = "InstantiationExpressionType";
        ObjectFlags2[ObjectFlags2["IsClassInstanceClone"] = 16777216] = "IsClassInstanceClone";
        ObjectFlags2[ObjectFlags2["IdenticalBaseTypeCalculated"] = 33554432] = "IdenticalBaseTypeCalculated";
        ObjectFlags2[ObjectFlags2["IdenticalBaseTypeExists"] = 67108864] = "IdenticalBaseTypeExists";
        ObjectFlags2[ObjectFlags2["IsGenericTypeComputed"] = 2097152] = "IsGenericTypeComputed";
        ObjectFlags2[ObjectFlags2["IsGenericObjectType"] = 4194304] = "IsGenericObjectType";
        ObjectFlags2[ObjectFlags2["IsGenericIndexType"] = 8388608] = "IsGenericIndexType";
        ObjectFlags2[ObjectFlags2["IsGenericType"] = 12582912] = "IsGenericType";
        ObjectFlags2[ObjectFlags2["ContainsIntersections"] = 16777216] = "ContainsIntersections";
        ObjectFlags2[ObjectFlags2["IsNeverIntersectionComputed"] = 16777216] = "IsNeverIntersectionComputed";
        ObjectFlags2[ObjectFlags2["IsNeverIntersection"] = 33554432] = "IsNeverIntersection";
      })(ObjectFlags = ts3.ObjectFlags || (ts3.ObjectFlags = {}));
      var VarianceFlags;
      (function(VarianceFlags2) {
        VarianceFlags2[VarianceFlags2["Invariant"] = 0] = "Invariant";
        VarianceFlags2[VarianceFlags2["Covariant"] = 1] = "Covariant";
        VarianceFlags2[VarianceFlags2["Contravariant"] = 2] = "Contravariant";
        VarianceFlags2[VarianceFlags2["Bivariant"] = 3] = "Bivariant";
        VarianceFlags2[VarianceFlags2["Independent"] = 4] = "Independent";
        VarianceFlags2[VarianceFlags2["VarianceMask"] = 7] = "VarianceMask";
        VarianceFlags2[VarianceFlags2["Unmeasurable"] = 8] = "Unmeasurable";
        VarianceFlags2[VarianceFlags2["Unreliable"] = 16] = "Unreliable";
        VarianceFlags2[VarianceFlags2["AllowsStructuralFallback"] = 24] = "AllowsStructuralFallback";
      })(VarianceFlags = ts3.VarianceFlags || (ts3.VarianceFlags = {}));
      var ElementFlags;
      (function(ElementFlags2) {
        ElementFlags2[ElementFlags2["Required"] = 1] = "Required";
        ElementFlags2[ElementFlags2["Optional"] = 2] = "Optional";
        ElementFlags2[ElementFlags2["Rest"] = 4] = "Rest";
        ElementFlags2[ElementFlags2["Variadic"] = 8] = "Variadic";
        ElementFlags2[ElementFlags2["Fixed"] = 3] = "Fixed";
        ElementFlags2[ElementFlags2["Variable"] = 12] = "Variable";
        ElementFlags2[ElementFlags2["NonRequired"] = 14] = "NonRequired";
        ElementFlags2[ElementFlags2["NonRest"] = 11] = "NonRest";
      })(ElementFlags = ts3.ElementFlags || (ts3.ElementFlags = {}));
      var AccessFlags;
      (function(AccessFlags2) {
        AccessFlags2[AccessFlags2["None"] = 0] = "None";
        AccessFlags2[AccessFlags2["IncludeUndefined"] = 1] = "IncludeUndefined";
        AccessFlags2[AccessFlags2["NoIndexSignatures"] = 2] = "NoIndexSignatures";
        AccessFlags2[AccessFlags2["Writing"] = 4] = "Writing";
        AccessFlags2[AccessFlags2["CacheSymbol"] = 8] = "CacheSymbol";
        AccessFlags2[AccessFlags2["NoTupleBoundsCheck"] = 16] = "NoTupleBoundsCheck";
        AccessFlags2[AccessFlags2["ExpressionPosition"] = 32] = "ExpressionPosition";
        AccessFlags2[AccessFlags2["ReportDeprecated"] = 64] = "ReportDeprecated";
        AccessFlags2[AccessFlags2["SuppressNoImplicitAnyError"] = 128] = "SuppressNoImplicitAnyError";
        AccessFlags2[AccessFlags2["Contextual"] = 256] = "Contextual";
        AccessFlags2[AccessFlags2["Persistent"] = 1] = "Persistent";
      })(AccessFlags = ts3.AccessFlags || (ts3.AccessFlags = {}));
      var JsxReferenceKind;
      (function(JsxReferenceKind2) {
        JsxReferenceKind2[JsxReferenceKind2["Component"] = 0] = "Component";
        JsxReferenceKind2[JsxReferenceKind2["Function"] = 1] = "Function";
        JsxReferenceKind2[JsxReferenceKind2["Mixed"] = 2] = "Mixed";
      })(JsxReferenceKind = ts3.JsxReferenceKind || (ts3.JsxReferenceKind = {}));
      var SignatureKind;
      (function(SignatureKind2) {
        SignatureKind2[SignatureKind2["Call"] = 0] = "Call";
        SignatureKind2[SignatureKind2["Construct"] = 1] = "Construct";
      })(SignatureKind = ts3.SignatureKind || (ts3.SignatureKind = {}));
      var SignatureFlags;
      (function(SignatureFlags2) {
        SignatureFlags2[SignatureFlags2["None"] = 0] = "None";
        SignatureFlags2[SignatureFlags2["HasRestParameter"] = 1] = "HasRestParameter";
        SignatureFlags2[SignatureFlags2["HasLiteralTypes"] = 2] = "HasLiteralTypes";
        SignatureFlags2[SignatureFlags2["Abstract"] = 4] = "Abstract";
        SignatureFlags2[SignatureFlags2["IsInnerCallChain"] = 8] = "IsInnerCallChain";
        SignatureFlags2[SignatureFlags2["IsOuterCallChain"] = 16] = "IsOuterCallChain";
        SignatureFlags2[SignatureFlags2["IsUntypedSignatureInJSFile"] = 32] = "IsUntypedSignatureInJSFile";
        SignatureFlags2[SignatureFlags2["PropagatingFlags"] = 39] = "PropagatingFlags";
        SignatureFlags2[SignatureFlags2["CallChainFlags"] = 24] = "CallChainFlags";
      })(SignatureFlags = ts3.SignatureFlags || (ts3.SignatureFlags = {}));
      var IndexKind;
      (function(IndexKind2) {
        IndexKind2[IndexKind2["String"] = 0] = "String";
        IndexKind2[IndexKind2["Number"] = 1] = "Number";
      })(IndexKind = ts3.IndexKind || (ts3.IndexKind = {}));
      var TypeMapKind;
      (function(TypeMapKind2) {
        TypeMapKind2[TypeMapKind2["Simple"] = 0] = "Simple";
        TypeMapKind2[TypeMapKind2["Array"] = 1] = "Array";
        TypeMapKind2[TypeMapKind2["Function"] = 2] = "Function";
        TypeMapKind2[TypeMapKind2["Composite"] = 3] = "Composite";
        TypeMapKind2[TypeMapKind2["Merged"] = 4] = "Merged";
      })(TypeMapKind = ts3.TypeMapKind || (ts3.TypeMapKind = {}));
      var InferencePriority;
      (function(InferencePriority2) {
        InferencePriority2[InferencePriority2["NakedTypeVariable"] = 1] = "NakedTypeVariable";
        InferencePriority2[InferencePriority2["SpeculativeTuple"] = 2] = "SpeculativeTuple";
        InferencePriority2[InferencePriority2["SubstituteSource"] = 4] = "SubstituteSource";
        InferencePriority2[InferencePriority2["HomomorphicMappedType"] = 8] = "HomomorphicMappedType";
        InferencePriority2[InferencePriority2["PartialHomomorphicMappedType"] = 16] = "PartialHomomorphicMappedType";
        InferencePriority2[InferencePriority2["MappedTypeConstraint"] = 32] = "MappedTypeConstraint";
        InferencePriority2[InferencePriority2["ContravariantConditional"] = 64] = "ContravariantConditional";
        InferencePriority2[InferencePriority2["ReturnType"] = 128] = "ReturnType";
        InferencePriority2[InferencePriority2["LiteralKeyof"] = 256] = "LiteralKeyof";
        InferencePriority2[InferencePriority2["NoConstraints"] = 512] = "NoConstraints";
        InferencePriority2[InferencePriority2["AlwaysStrict"] = 1024] = "AlwaysStrict";
        InferencePriority2[InferencePriority2["MaxValue"] = 2048] = "MaxValue";
        InferencePriority2[InferencePriority2["PriorityImpliesCombination"] = 416] = "PriorityImpliesCombination";
        InferencePriority2[InferencePriority2["Circularity"] = -1] = "Circularity";
      })(InferencePriority = ts3.InferencePriority || (ts3.InferencePriority = {}));
      var InferenceFlags;
      (function(InferenceFlags2) {
        InferenceFlags2[InferenceFlags2["None"] = 0] = "None";
        InferenceFlags2[InferenceFlags2["NoDefault"] = 1] = "NoDefault";
        InferenceFlags2[InferenceFlags2["AnyDefault"] = 2] = "AnyDefault";
        InferenceFlags2[InferenceFlags2["SkippedGenericFunction"] = 4] = "SkippedGenericFunction";
      })(InferenceFlags = ts3.InferenceFlags || (ts3.InferenceFlags = {}));
      var Ternary;
      (function(Ternary2) {
        Ternary2[Ternary2["False"] = 0] = "False";
        Ternary2[Ternary2["Unknown"] = 1] = "Unknown";
        Ternary2[Ternary2["Maybe"] = 3] = "Maybe";
        Ternary2[Ternary2["True"] = -1] = "True";
      })(Ternary = ts3.Ternary || (ts3.Ternary = {}));
      var AssignmentDeclarationKind;
      (function(AssignmentDeclarationKind2) {
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["None"] = 0] = "None";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ExportsProperty"] = 1] = "ExportsProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ModuleExports"] = 2] = "ModuleExports";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["PrototypeProperty"] = 3] = "PrototypeProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ThisProperty"] = 4] = "ThisProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Property"] = 5] = "Property";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Prototype"] = 6] = "Prototype";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyValue"] = 7] = "ObjectDefinePropertyValue";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyExports"] = 8] = "ObjectDefinePropertyExports";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePrototypeProperty"] = 9] = "ObjectDefinePrototypeProperty";
      })(AssignmentDeclarationKind = ts3.AssignmentDeclarationKind || (ts3.AssignmentDeclarationKind = {}));
      var DiagnosticCategory;
      (function(DiagnosticCategory2) {
        DiagnosticCategory2[DiagnosticCategory2["Warning"] = 0] = "Warning";
        DiagnosticCategory2[DiagnosticCategory2["Error"] = 1] = "Error";
        DiagnosticCategory2[DiagnosticCategory2["Suggestion"] = 2] = "Suggestion";
        DiagnosticCategory2[DiagnosticCategory2["Message"] = 3] = "Message";
      })(DiagnosticCategory = ts3.DiagnosticCategory || (ts3.DiagnosticCategory = {}));
      function diagnosticCategoryName(d, lowerCase) {
        if (lowerCase === void 0) {
          lowerCase = true;
        }
        var name = DiagnosticCategory[d.category];
        return lowerCase ? name.toLowerCase() : name;
      }
      ts3.diagnosticCategoryName = diagnosticCategoryName;
      var ModuleResolutionKind;
      (function(ModuleResolutionKind2) {
        ModuleResolutionKind2[ModuleResolutionKind2["Classic"] = 1] = "Classic";
        ModuleResolutionKind2[ModuleResolutionKind2["NodeJs"] = 2] = "NodeJs";
        ModuleResolutionKind2[ModuleResolutionKind2["Node16"] = 3] = "Node16";
        ModuleResolutionKind2[ModuleResolutionKind2["NodeNext"] = 99] = "NodeNext";
      })(ModuleResolutionKind = ts3.ModuleResolutionKind || (ts3.ModuleResolutionKind = {}));
      var ModuleDetectionKind;
      (function(ModuleDetectionKind2) {
        ModuleDetectionKind2[ModuleDetectionKind2["Legacy"] = 1] = "Legacy";
        ModuleDetectionKind2[ModuleDetectionKind2["Auto"] = 2] = "Auto";
        ModuleDetectionKind2[ModuleDetectionKind2["Force"] = 3] = "Force";
      })(ModuleDetectionKind = ts3.ModuleDetectionKind || (ts3.ModuleDetectionKind = {}));
      var WatchFileKind;
      (function(WatchFileKind2) {
        WatchFileKind2[WatchFileKind2["FixedPollingInterval"] = 0] = "FixedPollingInterval";
        WatchFileKind2[WatchFileKind2["PriorityPollingInterval"] = 1] = "PriorityPollingInterval";
        WatchFileKind2[WatchFileKind2["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
        WatchFileKind2[WatchFileKind2["FixedChunkSizePolling"] = 3] = "FixedChunkSizePolling";
        WatchFileKind2[WatchFileKind2["UseFsEvents"] = 4] = "UseFsEvents";
        WatchFileKind2[WatchFileKind2["UseFsEventsOnParentDirectory"] = 5] = "UseFsEventsOnParentDirectory";
      })(WatchFileKind = ts3.WatchFileKind || (ts3.WatchFileKind = {}));
      var WatchDirectoryKind;
      (function(WatchDirectoryKind2) {
        WatchDirectoryKind2[WatchDirectoryKind2["UseFsEvents"] = 0] = "UseFsEvents";
        WatchDirectoryKind2[WatchDirectoryKind2["FixedPollingInterval"] = 1] = "FixedPollingInterval";
        WatchDirectoryKind2[WatchDirectoryKind2["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
        WatchDirectoryKind2[WatchDirectoryKind2["FixedChunkSizePolling"] = 3] = "FixedChunkSizePolling";
      })(WatchDirectoryKind = ts3.WatchDirectoryKind || (ts3.WatchDirectoryKind = {}));
      var PollingWatchKind;
      (function(PollingWatchKind2) {
        PollingWatchKind2[PollingWatchKind2["FixedInterval"] = 0] = "FixedInterval";
        PollingWatchKind2[PollingWatchKind2["PriorityInterval"] = 1] = "PriorityInterval";
        PollingWatchKind2[PollingWatchKind2["DynamicPriority"] = 2] = "DynamicPriority";
        PollingWatchKind2[PollingWatchKind2["FixedChunkSize"] = 3] = "FixedChunkSize";
      })(PollingWatchKind = ts3.PollingWatchKind || (ts3.PollingWatchKind = {}));
      var ModuleKind;
      (function(ModuleKind2) {
        ModuleKind2[ModuleKind2["None"] = 0] = "None";
        ModuleKind2[ModuleKind2["CommonJS"] = 1] = "CommonJS";
        ModuleKind2[ModuleKind2["AMD"] = 2] = "AMD";
        ModuleKind2[ModuleKind2["UMD"] = 3] = "UMD";
        ModuleKind2[ModuleKind2["System"] = 4] = "System";
        ModuleKind2[ModuleKind2["ES2015"] = 5] = "ES2015";
        ModuleKind2[ModuleKind2["ES2020"] = 6] = "ES2020";
        ModuleKind2[ModuleKind2["ES2022"] = 7] = "ES2022";
        ModuleKind2[ModuleKind2["ESNext"] = 99] = "ESNext";
        ModuleKind2[ModuleKind2["Node16"] = 100] = "Node16";
        ModuleKind2[ModuleKind2["NodeNext"] = 199] = "NodeNext";
      })(ModuleKind = ts3.ModuleKind || (ts3.ModuleKind = {}));
      var JsxEmit;
      (function(JsxEmit2) {
        JsxEmit2[JsxEmit2["None"] = 0] = "None";
        JsxEmit2[JsxEmit2["Preserve"] = 1] = "Preserve";
        JsxEmit2[JsxEmit2["React"] = 2] = "React";
        JsxEmit2[JsxEmit2["ReactNative"] = 3] = "ReactNative";
        JsxEmit2[JsxEmit2["ReactJSX"] = 4] = "ReactJSX";
        JsxEmit2[JsxEmit2["ReactJSXDev"] = 5] = "ReactJSXDev";
      })(JsxEmit = ts3.JsxEmit || (ts3.JsxEmit = {}));
      var ImportsNotUsedAsValues;
      (function(ImportsNotUsedAsValues2) {
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Remove"] = 0] = "Remove";
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Preserve"] = 1] = "Preserve";
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Error"] = 2] = "Error";
      })(ImportsNotUsedAsValues = ts3.ImportsNotUsedAsValues || (ts3.ImportsNotUsedAsValues = {}));
      var NewLineKind;
      (function(NewLineKind2) {
        NewLineKind2[NewLineKind2["CarriageReturnLineFeed"] = 0] = "CarriageReturnLineFeed";
        NewLineKind2[NewLineKind2["LineFeed"] = 1] = "LineFeed";
      })(NewLineKind = ts3.NewLineKind || (ts3.NewLineKind = {}));
      var ScriptKind;
      (function(ScriptKind2) {
        ScriptKind2[ScriptKind2["Unknown"] = 0] = "Unknown";
        ScriptKind2[ScriptKind2["JS"] = 1] = "JS";
        ScriptKind2[ScriptKind2["JSX"] = 2] = "JSX";
        ScriptKind2[ScriptKind2["TS"] = 3] = "TS";
        ScriptKind2[ScriptKind2["TSX"] = 4] = "TSX";
        ScriptKind2[ScriptKind2["External"] = 5] = "External";
        ScriptKind2[ScriptKind2["JSON"] = 6] = "JSON";
        ScriptKind2[ScriptKind2["Deferred"] = 7] = "Deferred";
      })(ScriptKind = ts3.ScriptKind || (ts3.ScriptKind = {}));
      var ScriptTarget;
      (function(ScriptTarget2) {
        ScriptTarget2[ScriptTarget2["ES3"] = 0] = "ES3";
        ScriptTarget2[ScriptTarget2["ES5"] = 1] = "ES5";
        ScriptTarget2[ScriptTarget2["ES2015"] = 2] = "ES2015";
        ScriptTarget2[ScriptTarget2["ES2016"] = 3] = "ES2016";
        ScriptTarget2[ScriptTarget2["ES2017"] = 4] = "ES2017";
        ScriptTarget2[ScriptTarget2["ES2018"] = 5] = "ES2018";
        ScriptTarget2[ScriptTarget2["ES2019"] = 6] = "ES2019";
        ScriptTarget2[ScriptTarget2["ES2020"] = 7] = "ES2020";
        ScriptTarget2[ScriptTarget2["ES2021"] = 8] = "ES2021";
        ScriptTarget2[ScriptTarget2["ES2022"] = 9] = "ES2022";
        ScriptTarget2[ScriptTarget2["ESNext"] = 99] = "ESNext";
        ScriptTarget2[ScriptTarget2["JSON"] = 100] = "JSON";
        ScriptTarget2[ScriptTarget2["Latest"] = 99] = "Latest";
      })(ScriptTarget = ts3.ScriptTarget || (ts3.ScriptTarget = {}));
      var LanguageVariant;
      (function(LanguageVariant2) {
        LanguageVariant2[LanguageVariant2["Standard"] = 0] = "Standard";
        LanguageVariant2[LanguageVariant2["JSX"] = 1] = "JSX";
      })(LanguageVariant = ts3.LanguageVariant || (ts3.LanguageVariant = {}));
      var WatchDirectoryFlags;
      (function(WatchDirectoryFlags2) {
        WatchDirectoryFlags2[WatchDirectoryFlags2["None"] = 0] = "None";
        WatchDirectoryFlags2[WatchDirectoryFlags2["Recursive"] = 1] = "Recursive";
      })(WatchDirectoryFlags = ts3.WatchDirectoryFlags || (ts3.WatchDirectoryFlags = {}));
      var CharacterCodes;
      (function(CharacterCodes2) {
        CharacterCodes2[CharacterCodes2["nullCharacter"] = 0] = "nullCharacter";
        CharacterCodes2[CharacterCodes2["maxAsciiCharacter"] = 127] = "maxAsciiCharacter";
        CharacterCodes2[CharacterCodes2["lineFeed"] = 10] = "lineFeed";
        CharacterCodes2[CharacterCodes2["carriageReturn"] = 13] = "carriageReturn";
        CharacterCodes2[CharacterCodes2["lineSeparator"] = 8232] = "lineSeparator";
        CharacterCodes2[CharacterCodes2["paragraphSeparator"] = 8233] = "paragraphSeparator";
        CharacterCodes2[CharacterCodes2["nextLine"] = 133] = "nextLine";
        CharacterCodes2[CharacterCodes2["space"] = 32] = "space";
        CharacterCodes2[CharacterCodes2["nonBreakingSpace"] = 160] = "nonBreakingSpace";
        CharacterCodes2[CharacterCodes2["enQuad"] = 8192] = "enQuad";
        CharacterCodes2[CharacterCodes2["emQuad"] = 8193] = "emQuad";
        CharacterCodes2[CharacterCodes2["enSpace"] = 8194] = "enSpace";
        CharacterCodes2[CharacterCodes2["emSpace"] = 8195] = "emSpace";
        CharacterCodes2[CharacterCodes2["threePerEmSpace"] = 8196] = "threePerEmSpace";
        CharacterCodes2[CharacterCodes2["fourPerEmSpace"] = 8197] = "fourPerEmSpace";
        CharacterCodes2[CharacterCodes2["sixPerEmSpace"] = 8198] = "sixPerEmSpace";
        CharacterCodes2[CharacterCodes2["figureSpace"] = 8199] = "figureSpace";
        CharacterCodes2[CharacterCodes2["punctuationSpace"] = 8200] = "punctuationSpace";
        CharacterCodes2[CharacterCodes2["thinSpace"] = 8201] = "thinSpace";
        CharacterCodes2[CharacterCodes2["hairSpace"] = 8202] = "hairSpace";
        CharacterCodes2[CharacterCodes2["zeroWidthSpace"] = 8203] = "zeroWidthSpace";
        CharacterCodes2[CharacterCodes2["narrowNoBreakSpace"] = 8239] = "narrowNoBreakSpace";
        CharacterCodes2[CharacterCodes2["ideographicSpace"] = 12288] = "ideographicSpace";
        CharacterCodes2[CharacterCodes2["mathematicalSpace"] = 8287] = "mathematicalSpace";
        CharacterCodes2[CharacterCodes2["ogham"] = 5760] = "ogham";
        CharacterCodes2[CharacterCodes2["_"] = 95] = "_";
        CharacterCodes2[CharacterCodes2["$"] = 36] = "$";
        CharacterCodes2[CharacterCodes2["_0"] = 48] = "_0";
        CharacterCodes2[CharacterCodes2["_1"] = 49] = "_1";
        CharacterCodes2[CharacterCodes2["_2"] = 50] = "_2";
        CharacterCodes2[CharacterCodes2["_3"] = 51] = "_3";
        CharacterCodes2[CharacterCodes2["_4"] = 52] = "_4";
        CharacterCodes2[CharacterCodes2["_5"] = 53] = "_5";
        CharacterCodes2[CharacterCodes2["_6"] = 54] = "_6";
        CharacterCodes2[CharacterCodes2["_7"] = 55] = "_7";
        CharacterCodes2[CharacterCodes2["_8"] = 56] = "_8";
        CharacterCodes2[CharacterCodes2["_9"] = 57] = "_9";
        CharacterCodes2[CharacterCodes2["a"] = 97] = "a";
        CharacterCodes2[CharacterCodes2["b"] = 98] = "b";
        CharacterCodes2[CharacterCodes2["c"] = 99] = "c";
        CharacterCodes2[CharacterCodes2["d"] = 100] = "d";
        CharacterCodes2[CharacterCodes2["e"] = 101] = "e";
        CharacterCodes2[CharacterCodes2["f"] = 102] = "f";
        CharacterCodes2[CharacterCodes2["g"] = 103] = "g";
        CharacterCodes2[CharacterCodes2["h"] = 104] = "h";
        CharacterCodes2[CharacterCodes2["i"] = 105] = "i";
        CharacterCodes2[CharacterCodes2["j"] = 106] = "j";
        CharacterCodes2[CharacterCodes2["k"] = 107] = "k";
        CharacterCodes2[CharacterCodes2["l"] = 108] = "l";
        CharacterCodes2[CharacterCodes2["m"] = 109] = "m";
        CharacterCodes2[CharacterCodes2["n"] = 110] = "n";
        CharacterCodes2[CharacterCodes2["o"] = 111] = "o";
        CharacterCodes2[CharacterCodes2["p"] = 112] = "p";
        CharacterCodes2[CharacterCodes2["q"] = 113] = "q";
        CharacterCodes2[CharacterCodes2["r"] = 114] = "r";
        CharacterCodes2[CharacterCodes2["s"] = 115] = "s";
        CharacterCodes2[CharacterCodes2["t"] = 116] = "t";
        CharacterCodes2[CharacterCodes2["u"] = 117] = "u";
        CharacterCodes2[CharacterCodes2["v"] = 118] = "v";
        CharacterCodes2[CharacterCodes2["w"] = 119] = "w";
        CharacterCodes2[CharacterCodes2["x"] = 120] = "x";
        CharacterCodes2[CharacterCodes2["y"] = 121] = "y";
        CharacterCodes2[CharacterCodes2["z"] = 122] = "z";
        CharacterCodes2[CharacterCodes2["A"] = 65] = "A";
        CharacterCodes2[CharacterCodes2["B"] = 66] = "B";
        CharacterCodes2[CharacterCodes2["C"] = 67] = "C";
        CharacterCodes2[CharacterCodes2["D"] = 68] = "D";
        CharacterCodes2[CharacterCodes2["E"] = 69] = "E";
        CharacterCodes2[CharacterCodes2["F"] = 70] = "F";
        CharacterCodes2[CharacterCodes2["G"] = 71] = "G";
        CharacterCodes2[CharacterCodes2["H"] = 72] = "H";
        CharacterCodes2[CharacterCodes2["I"] = 73] = "I";
        CharacterCodes2[CharacterCodes2["J"] = 74] = "J";
        CharacterCodes2[CharacterCodes2["K"] = 75] = "K";
        CharacterCodes2[CharacterCodes2["L"] = 76] = "L";
        CharacterCodes2[CharacterCodes2["M"] = 77] = "M";
        CharacterCodes2[CharacterCodes2["N"] = 78] = "N";
        CharacterCodes2[CharacterCodes2["O"] = 79] = "O";
        CharacterCodes2[CharacterCodes2["P"] = 80] = "P";
        CharacterCodes2[CharacterCodes2["Q"] = 81] = "Q";
        CharacterCodes2[CharacterCodes2["R"] = 82] = "R";
        CharacterCodes2[CharacterCodes2["S"] = 83] = "S";
        CharacterCodes2[CharacterCodes2["T"] = 84] = "T";
        CharacterCodes2[CharacterCodes2["U"] = 85] = "U";
        CharacterCodes2[CharacterCodes2["V"] = 86] = "V";
        CharacterCodes2[CharacterCodes2["W"] = 87] = "W";
        CharacterCodes2[CharacterCodes2["X"] = 88] = "X";
        CharacterCodes2[CharacterCodes2["Y"] = 89] = "Y";
        CharacterCodes2[CharacterCodes2["Z"] = 90] = "Z";
        CharacterCodes2[CharacterCodes2["ampersand"] = 38] = "ampersand";
        CharacterCodes2[CharacterCodes2["asterisk"] = 42] = "asterisk";
        CharacterCodes2[CharacterCodes2["at"] = 64] = "at";
        CharacterCodes2[CharacterCodes2["backslash"] = 92] = "backslash";
        CharacterCodes2[CharacterCodes2["backtick"] = 96] = "backtick";
        CharacterCodes2[CharacterCodes2["bar"] = 124] = "bar";
        CharacterCodes2[CharacterCodes2["caret"] = 94] = "caret";
        CharacterCodes2[CharacterCodes2["closeBrace"] = 125] = "closeBrace";
        CharacterCodes2[CharacterCodes2["closeBracket"] = 93] = "closeBracket";
        CharacterCodes2[CharacterCodes2["closeParen"] = 41] = "closeParen";
        CharacterCodes2[CharacterCodes2["colon"] = 58] = "colon";
        CharacterCodes2[CharacterCodes2["comma"] = 44] = "comma";
        CharacterCodes2[CharacterCodes2["dot"] = 46] = "dot";
        CharacterCodes2[CharacterCodes2["doubleQuote"] = 34] = "doubleQuote";
        CharacterCodes2[CharacterCodes2["equals"] = 61] = "equals";
        CharacterCodes2[CharacterCodes2["exclamation"] = 33] = "exclamation";
        CharacterCodes2[CharacterCodes2["greaterThan"] = 62] = "greaterThan";
        CharacterCodes2[CharacterCodes2["hash"] = 35] = "hash";
        CharacterCodes2[CharacterCodes2["lessThan"] = 60] = "lessThan";
        CharacterCodes2[CharacterCodes2["minus"] = 45] = "minus";
        CharacterCodes2[CharacterCodes2["openBrace"] = 123] = "openBrace";
        CharacterCodes2[CharacterCodes2["openBracket"] = 91] = "openBracket";
        CharacterCodes2[CharacterCodes2["openParen"] = 40] = "openParen";
        CharacterCodes2[CharacterCodes2["percent"] = 37] = "percent";
        CharacterCodes2[CharacterCodes2["plus"] = 43] = "plus";
        CharacterCodes2[CharacterCodes2["question"] = 63] = "question";
        CharacterCodes2[CharacterCodes2["semicolon"] = 59] = "semicolon";
        CharacterCodes2[CharacterCodes2["singleQuote"] = 39] = "singleQuote";
        CharacterCodes2[CharacterCodes2["slash"] = 47] = "slash";
        CharacterCodes2[CharacterCodes2["tilde"] = 126] = "tilde";
        CharacterCodes2[CharacterCodes2["backspace"] = 8] = "backspace";
        CharacterCodes2[CharacterCodes2["formFeed"] = 12] = "formFeed";
        CharacterCodes2[CharacterCodes2["byteOrderMark"] = 65279] = "byteOrderMark";
        CharacterCodes2[CharacterCodes2["tab"] = 9] = "tab";
        CharacterCodes2[CharacterCodes2["verticalTab"] = 11] = "verticalTab";
      })(CharacterCodes = ts3.CharacterCodes || (ts3.CharacterCodes = {}));
      var Extension;
      (function(Extension2) {
        Extension2["Ts"] = ".ts";
        Extension2["Tsx"] = ".tsx";
        Extension2["Dts"] = ".d.ts";
        Extension2["Js"] = ".js";
        Extension2["Jsx"] = ".jsx";
        Extension2["Json"] = ".json";
        Extension2["TsBuildInfo"] = ".tsbuildinfo";
        Extension2["Mjs"] = ".mjs";
        Extension2["Mts"] = ".mts";
        Extension2["Dmts"] = ".d.mts";
        Extension2["Cjs"] = ".cjs";
        Extension2["Cts"] = ".cts";
        Extension2["Dcts"] = ".d.cts";
      })(Extension = ts3.Extension || (ts3.Extension = {}));
      var TransformFlags;
      (function(TransformFlags2) {
        TransformFlags2[TransformFlags2["None"] = 0] = "None";
        TransformFlags2[TransformFlags2["ContainsTypeScript"] = 1] = "ContainsTypeScript";
        TransformFlags2[TransformFlags2["ContainsJsx"] = 2] = "ContainsJsx";
        TransformFlags2[TransformFlags2["ContainsESNext"] = 4] = "ContainsESNext";
        TransformFlags2[TransformFlags2["ContainsES2022"] = 8] = "ContainsES2022";
        TransformFlags2[TransformFlags2["ContainsES2021"] = 16] = "ContainsES2021";
        TransformFlags2[TransformFlags2["ContainsES2020"] = 32] = "ContainsES2020";
        TransformFlags2[TransformFlags2["ContainsES2019"] = 64] = "ContainsES2019";
        TransformFlags2[TransformFlags2["ContainsES2018"] = 128] = "ContainsES2018";
        TransformFlags2[TransformFlags2["ContainsES2017"] = 256] = "ContainsES2017";
        TransformFlags2[TransformFlags2["ContainsES2016"] = 512] = "ContainsES2016";
        TransformFlags2[TransformFlags2["ContainsES2015"] = 1024] = "ContainsES2015";
        TransformFlags2[TransformFlags2["ContainsGenerator"] = 2048] = "ContainsGenerator";
        TransformFlags2[TransformFlags2["ContainsDestructuringAssignment"] = 4096] = "ContainsDestructuringAssignment";
        TransformFlags2[TransformFlags2["ContainsTypeScriptClassSyntax"] = 4096] = "ContainsTypeScriptClassSyntax";
        TransformFlags2[TransformFlags2["ContainsLexicalThis"] = 8192] = "ContainsLexicalThis";
        TransformFlags2[TransformFlags2["ContainsRestOrSpread"] = 16384] = "ContainsRestOrSpread";
        TransformFlags2[TransformFlags2["ContainsObjectRestOrSpread"] = 32768] = "ContainsObjectRestOrSpread";
        TransformFlags2[TransformFlags2["ContainsComputedPropertyName"] = 65536] = "ContainsComputedPropertyName";
        TransformFlags2[TransformFlags2["ContainsBlockScopedBinding"] = 131072] = "ContainsBlockScopedBinding";
        TransformFlags2[TransformFlags2["ContainsBindingPattern"] = 262144] = "ContainsBindingPattern";
        TransformFlags2[TransformFlags2["ContainsYield"] = 524288] = "ContainsYield";
        TransformFlags2[TransformFlags2["ContainsAwait"] = 1048576] = "ContainsAwait";
        TransformFlags2[TransformFlags2["ContainsHoistedDeclarationOrCompletion"] = 2097152] = "ContainsHoistedDeclarationOrCompletion";
        TransformFlags2[TransformFlags2["ContainsDynamicImport"] = 4194304] = "ContainsDynamicImport";
        TransformFlags2[TransformFlags2["ContainsClassFields"] = 8388608] = "ContainsClassFields";
        TransformFlags2[TransformFlags2["ContainsPossibleTopLevelAwait"] = 16777216] = "ContainsPossibleTopLevelAwait";
        TransformFlags2[TransformFlags2["ContainsLexicalSuper"] = 33554432] = "ContainsLexicalSuper";
        TransformFlags2[TransformFlags2["ContainsUpdateExpressionForIdentifier"] = 67108864] = "ContainsUpdateExpressionForIdentifier";
        TransformFlags2[TransformFlags2["HasComputedFlags"] = 536870912] = "HasComputedFlags";
        TransformFlags2[TransformFlags2["AssertTypeScript"] = 1] = "AssertTypeScript";
        TransformFlags2[TransformFlags2["AssertJsx"] = 2] = "AssertJsx";
        TransformFlags2[TransformFlags2["AssertESNext"] = 4] = "AssertESNext";
        TransformFlags2[TransformFlags2["AssertES2022"] = 8] = "AssertES2022";
        TransformFlags2[TransformFlags2["AssertES2021"] = 16] = "AssertES2021";
        TransformFlags2[TransformFlags2["AssertES2020"] = 32] = "AssertES2020";
        TransformFlags2[TransformFlags2["AssertES2019"] = 64] = "AssertES2019";
        TransformFlags2[TransformFlags2["AssertES2018"] = 128] = "AssertES2018";
        TransformFlags2[TransformFlags2["AssertES2017"] = 256] = "AssertES2017";
        TransformFlags2[TransformFlags2["AssertES2016"] = 512] = "AssertES2016";
        TransformFlags2[TransformFlags2["AssertES2015"] = 1024] = "AssertES2015";
        TransformFlags2[TransformFlags2["AssertGenerator"] = 2048] = "AssertGenerator";
        TransformFlags2[TransformFlags2["AssertDestructuringAssignment"] = 4096] = "AssertDestructuringAssignment";
        TransformFlags2[TransformFlags2["OuterExpressionExcludes"] = 536870912] = "OuterExpressionExcludes";
        TransformFlags2[TransformFlags2["PropertyAccessExcludes"] = 536870912] = "PropertyAccessExcludes";
        TransformFlags2[TransformFlags2["NodeExcludes"] = 536870912] = "NodeExcludes";
        TransformFlags2[TransformFlags2["ArrowFunctionExcludes"] = 557748224] = "ArrowFunctionExcludes";
        TransformFlags2[TransformFlags2["FunctionExcludes"] = 591310848] = "FunctionExcludes";
        TransformFlags2[TransformFlags2["ConstructorExcludes"] = 591306752] = "ConstructorExcludes";
        TransformFlags2[TransformFlags2["MethodOrAccessorExcludes"] = 574529536] = "MethodOrAccessorExcludes";
        TransformFlags2[TransformFlags2["PropertyExcludes"] = 570433536] = "PropertyExcludes";
        TransformFlags2[TransformFlags2["ClassExcludes"] = 536940544] = "ClassExcludes";
        TransformFlags2[TransformFlags2["ModuleExcludes"] = 589443072] = "ModuleExcludes";
        TransformFlags2[TransformFlags2["TypeExcludes"] = -2] = "TypeExcludes";
        TransformFlags2[TransformFlags2["ObjectLiteralExcludes"] = 536973312] = "ObjectLiteralExcludes";
        TransformFlags2[TransformFlags2["ArrayLiteralOrCallOrNewExcludes"] = 536887296] = "ArrayLiteralOrCallOrNewExcludes";
        TransformFlags2[TransformFlags2["VariableDeclarationListExcludes"] = 537165824] = "VariableDeclarationListExcludes";
        TransformFlags2[TransformFlags2["ParameterExcludes"] = 536870912] = "ParameterExcludes";
        TransformFlags2[TransformFlags2["CatchClauseExcludes"] = 536903680] = "CatchClauseExcludes";
        TransformFlags2[TransformFlags2["BindingPatternExcludes"] = 536887296] = "BindingPatternExcludes";
        TransformFlags2[TransformFlags2["ContainsLexicalThisOrSuper"] = 33562624] = "ContainsLexicalThisOrSuper";
        TransformFlags2[TransformFlags2["PropertyNamePropagatingFlags"] = 33562624] = "PropertyNamePropagatingFlags";
      })(TransformFlags = ts3.TransformFlags || (ts3.TransformFlags = {}));
      var SnippetKind;
      (function(SnippetKind2) {
        SnippetKind2[SnippetKind2["TabStop"] = 0] = "TabStop";
        SnippetKind2[SnippetKind2["Placeholder"] = 1] = "Placeholder";
        SnippetKind2[SnippetKind2["Choice"] = 2] = "Choice";
        SnippetKind2[SnippetKind2["Variable"] = 3] = "Variable";
      })(SnippetKind = ts3.SnippetKind || (ts3.SnippetKind = {}));
      var EmitFlags;
      (function(EmitFlags2) {
        EmitFlags2[EmitFlags2["None"] = 0] = "None";
        EmitFlags2[EmitFlags2["SingleLine"] = 1] = "SingleLine";
        EmitFlags2[EmitFlags2["AdviseOnEmitNode"] = 2] = "AdviseOnEmitNode";
        EmitFlags2[EmitFlags2["NoSubstitution"] = 4] = "NoSubstitution";
        EmitFlags2[EmitFlags2["CapturesThis"] = 8] = "CapturesThis";
        EmitFlags2[EmitFlags2["NoLeadingSourceMap"] = 16] = "NoLeadingSourceMap";
        EmitFlags2[EmitFlags2["NoTrailingSourceMap"] = 32] = "NoTrailingSourceMap";
        EmitFlags2[EmitFlags2["NoSourceMap"] = 48] = "NoSourceMap";
        EmitFlags2[EmitFlags2["NoNestedSourceMaps"] = 64] = "NoNestedSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenLeadingSourceMaps"] = 128] = "NoTokenLeadingSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenTrailingSourceMaps"] = 256] = "NoTokenTrailingSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenSourceMaps"] = 384] = "NoTokenSourceMaps";
        EmitFlags2[EmitFlags2["NoLeadingComments"] = 512] = "NoLeadingComments";
        EmitFlags2[EmitFlags2["NoTrailingComments"] = 1024] = "NoTrailingComments";
        EmitFlags2[EmitFlags2["NoComments"] = 1536] = "NoComments";
        EmitFlags2[EmitFlags2["NoNestedComments"] = 2048] = "NoNestedComments";
        EmitFlags2[EmitFlags2["HelperName"] = 4096] = "HelperName";
        EmitFlags2[EmitFlags2["ExportName"] = 8192] = "ExportName";
        EmitFlags2[EmitFlags2["LocalName"] = 16384] = "LocalName";
        EmitFlags2[EmitFlags2["InternalName"] = 32768] = "InternalName";
        EmitFlags2[EmitFlags2["Indented"] = 65536] = "Indented";
        EmitFlags2[EmitFlags2["NoIndentation"] = 131072] = "NoIndentation";
        EmitFlags2[EmitFlags2["AsyncFunctionBody"] = 262144] = "AsyncFunctionBody";
        EmitFlags2[EmitFlags2["ReuseTempVariableScope"] = 524288] = "ReuseTempVariableScope";
        EmitFlags2[EmitFlags2["CustomPrologue"] = 1048576] = "CustomPrologue";
        EmitFlags2[EmitFlags2["NoHoisting"] = 2097152] = "NoHoisting";
        EmitFlags2[EmitFlags2["HasEndOfDeclarationMarker"] = 4194304] = "HasEndOfDeclarationMarker";
        EmitFlags2[EmitFlags2["Iterator"] = 8388608] = "Iterator";
        EmitFlags2[EmitFlags2["NoAsciiEscaping"] = 16777216] = "NoAsciiEscaping";
        EmitFlags2[EmitFlags2["TypeScriptClassWrapper"] = 33554432] = "TypeScriptClassWrapper";
        EmitFlags2[EmitFlags2["NeverApplyImportHelper"] = 67108864] = "NeverApplyImportHelper";
        EmitFlags2[EmitFlags2["IgnoreSourceNewlines"] = 134217728] = "IgnoreSourceNewlines";
        EmitFlags2[EmitFlags2["Immutable"] = 268435456] = "Immutable";
        EmitFlags2[EmitFlags2["IndirectCall"] = 536870912] = "IndirectCall";
      })(EmitFlags = ts3.EmitFlags || (ts3.EmitFlags = {}));
      var ExternalEmitHelpers;
      (function(ExternalEmitHelpers2) {
        ExternalEmitHelpers2[ExternalEmitHelpers2["Extends"] = 1] = "Extends";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Assign"] = 2] = "Assign";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Rest"] = 4] = "Rest";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Decorate"] = 8] = "Decorate";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Metadata"] = 16] = "Metadata";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Param"] = 32] = "Param";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Awaiter"] = 64] = "Awaiter";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Generator"] = 128] = "Generator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Values"] = 256] = "Values";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Read"] = 512] = "Read";
        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadArray"] = 1024] = "SpreadArray";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Await"] = 2048] = "Await";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGenerator"] = 4096] = "AsyncGenerator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegator"] = 8192] = "AsyncDelegator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncValues"] = 16384] = "AsyncValues";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ExportStar"] = 32768] = "ExportStar";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ImportStar"] = 65536] = "ImportStar";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ImportDefault"] = 131072] = "ImportDefault";
        ExternalEmitHelpers2[ExternalEmitHelpers2["MakeTemplateObject"] = 262144] = "MakeTemplateObject";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldGet"] = 524288] = "ClassPrivateFieldGet";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldSet"] = 1048576] = "ClassPrivateFieldSet";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldIn"] = 2097152] = "ClassPrivateFieldIn";
        ExternalEmitHelpers2[ExternalEmitHelpers2["CreateBinding"] = 4194304] = "CreateBinding";
        ExternalEmitHelpers2[ExternalEmitHelpers2["FirstEmitHelper"] = 1] = "FirstEmitHelper";
        ExternalEmitHelpers2[ExternalEmitHelpers2["LastEmitHelper"] = 4194304] = "LastEmitHelper";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ForOfIncludes"] = 256] = "ForOfIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ForAwaitOfIncludes"] = 16384] = "ForAwaitOfIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGeneratorIncludes"] = 6144] = "AsyncGeneratorIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegatorIncludes"] = 26624] = "AsyncDelegatorIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadIncludes"] = 1536] = "SpreadIncludes";
      })(ExternalEmitHelpers = ts3.ExternalEmitHelpers || (ts3.ExternalEmitHelpers = {}));
      var EmitHint;
      (function(EmitHint2) {
        EmitHint2[EmitHint2["SourceFile"] = 0] = "SourceFile";
        EmitHint2[EmitHint2["Expression"] = 1] = "Expression";
        EmitHint2[EmitHint2["IdentifierName"] = 2] = "IdentifierName";
        EmitHint2[EmitHint2["MappedTypeParameter"] = 3] = "MappedTypeParameter";
        EmitHint2[EmitHint2["Unspecified"] = 4] = "Unspecified";
        EmitHint2[EmitHint2["EmbeddedStatement"] = 5] = "EmbeddedStatement";
        EmitHint2[EmitHint2["JsxAttributeValue"] = 6] = "JsxAttributeValue";
      })(EmitHint = ts3.EmitHint || (ts3.EmitHint = {}));
      var OuterExpressionKinds;
      (function(OuterExpressionKinds2) {
        OuterExpressionKinds2[OuterExpressionKinds2["Parentheses"] = 1] = "Parentheses";
        OuterExpressionKinds2[OuterExpressionKinds2["TypeAssertions"] = 2] = "TypeAssertions";
        OuterExpressionKinds2[OuterExpressionKinds2["NonNullAssertions"] = 4] = "NonNullAssertions";
        OuterExpressionKinds2[OuterExpressionKinds2["PartiallyEmittedExpressions"] = 8] = "PartiallyEmittedExpressions";
        OuterExpressionKinds2[OuterExpressionKinds2["Assertions"] = 6] = "Assertions";
        OuterExpressionKinds2[OuterExpressionKinds2["All"] = 15] = "All";
        OuterExpressionKinds2[OuterExpressionKinds2["ExcludeJSDocTypeAssertion"] = 16] = "ExcludeJSDocTypeAssertion";
      })(OuterExpressionKinds = ts3.OuterExpressionKinds || (ts3.OuterExpressionKinds = {}));
      var LexicalEnvironmentFlags;
      (function(LexicalEnvironmentFlags2) {
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["None"] = 0] = "None";
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["InParameters"] = 1] = "InParameters";
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["VariablesHoistedInParameters"] = 2] = "VariablesHoistedInParameters";
      })(LexicalEnvironmentFlags = ts3.LexicalEnvironmentFlags || (ts3.LexicalEnvironmentFlags = {}));
      var BundleFileSectionKind;
      (function(BundleFileSectionKind2) {
        BundleFileSectionKind2["Prologue"] = "prologue";
        BundleFileSectionKind2["EmitHelpers"] = "emitHelpers";
        BundleFileSectionKind2["NoDefaultLib"] = "no-default-lib";
        BundleFileSectionKind2["Reference"] = "reference";
        BundleFileSectionKind2["Type"] = "type";
        BundleFileSectionKind2["TypeResolutionModeRequire"] = "type-require";
        BundleFileSectionKind2["TypeResolutionModeImport"] = "type-import";
        BundleFileSectionKind2["Lib"] = "lib";
        BundleFileSectionKind2["Prepend"] = "prepend";
        BundleFileSectionKind2["Text"] = "text";
        BundleFileSectionKind2["Internal"] = "internal";
      })(BundleFileSectionKind = ts3.BundleFileSectionKind || (ts3.BundleFileSectionKind = {}));
      var ListFormat;
      (function(ListFormat2) {
        ListFormat2[ListFormat2["None"] = 0] = "None";
        ListFormat2[ListFormat2["SingleLine"] = 0] = "SingleLine";
        ListFormat2[ListFormat2["MultiLine"] = 1] = "MultiLine";
        ListFormat2[ListFormat2["PreserveLines"] = 2] = "PreserveLines";
        ListFormat2[ListFormat2["LinesMask"] = 3] = "LinesMask";
        ListFormat2[ListFormat2["NotDelimited"] = 0] = "NotDelimited";
        ListFormat2[ListFormat2["BarDelimited"] = 4] = "BarDelimited";
        ListFormat2[ListFormat2["AmpersandDelimited"] = 8] = "AmpersandDelimited";
        ListFormat2[ListFormat2["CommaDelimited"] = 16] = "CommaDelimited";
        ListFormat2[ListFormat2["AsteriskDelimited"] = 32] = "AsteriskDelimited";
        ListFormat2[ListFormat2["DelimitersMask"] = 60] = "DelimitersMask";
        ListFormat2[ListFormat2["AllowTrailingComma"] = 64] = "AllowTrailingComma";
        ListFormat2[ListFormat2["Indented"] = 128] = "Indented";
        ListFormat2[ListFormat2["SpaceBetweenBraces"] = 256] = "SpaceBetweenBraces";
        ListFormat2[ListFormat2["SpaceBetweenSiblings"] = 512] = "SpaceBetweenSiblings";
        ListFormat2[ListFormat2["Braces"] = 1024] = "Braces";
        ListFormat2[ListFormat2["Parenthesis"] = 2048] = "Parenthesis";
        ListFormat2[ListFormat2["AngleBrackets"] = 4096] = "AngleBrackets";
        ListFormat2[ListFormat2["SquareBrackets"] = 8192] = "SquareBrackets";
        ListFormat2[ListFormat2["BracketsMask"] = 15360] = "BracketsMask";
        ListFormat2[ListFormat2["OptionalIfUndefined"] = 16384] = "OptionalIfUndefined";
        ListFormat2[ListFormat2["OptionalIfEmpty"] = 32768] = "OptionalIfEmpty";
        ListFormat2[ListFormat2["Optional"] = 49152] = "Optional";
        ListFormat2[ListFormat2["PreferNewLine"] = 65536] = "PreferNewLine";
        ListFormat2[ListFormat2["NoTrailingNewLine"] = 131072] = "NoTrailingNewLine";
        ListFormat2[ListFormat2["NoInterveningComments"] = 262144] = "NoInterveningComments";
        ListFormat2[ListFormat2["NoSpaceIfEmpty"] = 524288] = "NoSpaceIfEmpty";
        ListFormat2[ListFormat2["SingleElement"] = 1048576] = "SingleElement";
        ListFormat2[ListFormat2["SpaceAfterList"] = 2097152] = "SpaceAfterList";
        ListFormat2[ListFormat2["Modifiers"] = 262656] = "Modifiers";
        ListFormat2[ListFormat2["HeritageClauses"] = 512] = "HeritageClauses";
        ListFormat2[ListFormat2["SingleLineTypeLiteralMembers"] = 768] = "SingleLineTypeLiteralMembers";
        ListFormat2[ListFormat2["MultiLineTypeLiteralMembers"] = 32897] = "MultiLineTypeLiteralMembers";
        ListFormat2[ListFormat2["SingleLineTupleTypeElements"] = 528] = "SingleLineTupleTypeElements";
        ListFormat2[ListFormat2["MultiLineTupleTypeElements"] = 657] = "MultiLineTupleTypeElements";
        ListFormat2[ListFormat2["UnionTypeConstituents"] = 516] = "UnionTypeConstituents";
        ListFormat2[ListFormat2["IntersectionTypeConstituents"] = 520] = "IntersectionTypeConstituents";
        ListFormat2[ListFormat2["ObjectBindingPatternElements"] = 525136] = "ObjectBindingPatternElements";
        ListFormat2[ListFormat2["ArrayBindingPatternElements"] = 524880] = "ArrayBindingPatternElements";
        ListFormat2[ListFormat2["ObjectLiteralExpressionProperties"] = 526226] = "ObjectLiteralExpressionProperties";
        ListFormat2[ListFormat2["ImportClauseEntries"] = 526226] = "ImportClauseEntries";
        ListFormat2[ListFormat2["ArrayLiteralExpressionElements"] = 8914] = "ArrayLiteralExpressionElements";
        ListFormat2[ListFormat2["CommaListElements"] = 528] = "CommaListElements";
        ListFormat2[ListFormat2["CallExpressionArguments"] = 2576] = "CallExpressionArguments";
        ListFormat2[ListFormat2["NewExpressionArguments"] = 18960] = "NewExpressionArguments";
        ListFormat2[ListFormat2["TemplateExpressionSpans"] = 262144] = "TemplateExpressionSpans";
        ListFormat2[ListFormat2["SingleLineBlockStatements"] = 768] = "SingleLineBlockStatements";
        ListFormat2[ListFormat2["MultiLineBlockStatements"] = 129] = "MultiLineBlockStatements";
        ListFormat2[ListFormat2["VariableDeclarationList"] = 528] = "VariableDeclarationList";
        ListFormat2[ListFormat2["SingleLineFunctionBodyStatements"] = 768] = "SingleLineFunctionBodyStatements";
        ListFormat2[ListFormat2["MultiLineFunctionBodyStatements"] = 1] = "MultiLineFunctionBodyStatements";
        ListFormat2[ListFormat2["ClassHeritageClauses"] = 0] = "ClassHeritageClauses";
        ListFormat2[ListFormat2["ClassMembers"] = 129] = "ClassMembers";
        ListFormat2[ListFormat2["InterfaceMembers"] = 129] = "InterfaceMembers";
        ListFormat2[ListFormat2["EnumMembers"] = 145] = "EnumMembers";
        ListFormat2[ListFormat2["CaseBlockClauses"] = 129] = "CaseBlockClauses";
        ListFormat2[ListFormat2["NamedImportsOrExportsElements"] = 525136] = "NamedImportsOrExportsElements";
        ListFormat2[ListFormat2["JsxElementOrFragmentChildren"] = 262144] = "JsxElementOrFragmentChildren";
        ListFormat2[ListFormat2["JsxElementAttributes"] = 262656] = "JsxElementAttributes";
        ListFormat2[ListFormat2["CaseOrDefaultClauseStatements"] = 163969] = "CaseOrDefaultClauseStatements";
        ListFormat2[ListFormat2["HeritageClauseTypes"] = 528] = "HeritageClauseTypes";
        ListFormat2[ListFormat2["SourceFileStatements"] = 131073] = "SourceFileStatements";
        ListFormat2[ListFormat2["Decorators"] = 2146305] = "Decorators";
        ListFormat2[ListFormat2["TypeArguments"] = 53776] = "TypeArguments";
        ListFormat2[ListFormat2["TypeParameters"] = 53776] = "TypeParameters";
        ListFormat2[ListFormat2["Parameters"] = 2576] = "Parameters";
        ListFormat2[ListFormat2["IndexSignatureParameters"] = 8848] = "IndexSignatureParameters";
        ListFormat2[ListFormat2["JSDocComment"] = 33] = "JSDocComment";
      })(ListFormat = ts3.ListFormat || (ts3.ListFormat = {}));
      var PragmaKindFlags;
      (function(PragmaKindFlags2) {
        PragmaKindFlags2[PragmaKindFlags2["None"] = 0] = "None";
        PragmaKindFlags2[PragmaKindFlags2["TripleSlashXML"] = 1] = "TripleSlashXML";
        PragmaKindFlags2[PragmaKindFlags2["SingleLine"] = 2] = "SingleLine";
        PragmaKindFlags2[PragmaKindFlags2["MultiLine"] = 4] = "MultiLine";
        PragmaKindFlags2[PragmaKindFlags2["All"] = 7] = "All";
        PragmaKindFlags2[PragmaKindFlags2["Default"] = 7] = "Default";
      })(PragmaKindFlags = ts3.PragmaKindFlags || (ts3.PragmaKindFlags = {}));
      ts3.commentPragmas = {
        "reference": {
          args: [
            { name: "types", optional: true, captureSpan: true },
            { name: "lib", optional: true, captureSpan: true },
            { name: "path", optional: true, captureSpan: true },
            { name: "no-default-lib", optional: true },
            { name: "resolution-mode", optional: true }
          ],
          kind: 1
        },
        "amd-dependency": {
          args: [{ name: "path" }, { name: "name", optional: true }],
          kind: 1
        },
        "amd-module": {
          args: [{ name: "name" }],
          kind: 1
        },
        "ts-check": {
          kind: 2
        },
        "ts-nocheck": {
          kind: 2
        },
        "jsx": {
          args: [{ name: "factory" }],
          kind: 4
        },
        "jsxfrag": {
          args: [{ name: "factory" }],
          kind: 4
        },
        "jsximportsource": {
          args: [{ name: "factory" }],
          kind: 4
        },
        "jsxruntime": {
          args: [{ name: "factory" }],
          kind: 4
        }
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function generateDjb2Hash(data) {
        var acc = 5381;
        for (var i = 0; i < data.length; i++) {
          acc = (acc << 5) + acc + data.charCodeAt(i);
        }
        return acc.toString();
      }
      ts3.generateDjb2Hash = generateDjb2Hash;
      function setStackTraceLimit() {
        if (Error.stackTraceLimit < 100) {
          Error.stackTraceLimit = 100;
        }
      }
      ts3.setStackTraceLimit = setStackTraceLimit;
      var FileWatcherEventKind;
      (function(FileWatcherEventKind2) {
        FileWatcherEventKind2[FileWatcherEventKind2["Created"] = 0] = "Created";
        FileWatcherEventKind2[FileWatcherEventKind2["Changed"] = 1] = "Changed";
        FileWatcherEventKind2[FileWatcherEventKind2["Deleted"] = 2] = "Deleted";
      })(FileWatcherEventKind = ts3.FileWatcherEventKind || (ts3.FileWatcherEventKind = {}));
      var PollingInterval;
      (function(PollingInterval2) {
        PollingInterval2[PollingInterval2["High"] = 2e3] = "High";
        PollingInterval2[PollingInterval2["Medium"] = 500] = "Medium";
        PollingInterval2[PollingInterval2["Low"] = 250] = "Low";
      })(PollingInterval = ts3.PollingInterval || (ts3.PollingInterval = {}));
      ts3.missingFileModifiedTime = new Date(0);
      function getModifiedTime(host, fileName2) {
        return host.getModifiedTime(fileName2) || ts3.missingFileModifiedTime;
      }
      ts3.getModifiedTime = getModifiedTime;
      function createPollingIntervalBasedLevels(levels) {
        var _a;
        return _a = {}, _a[PollingInterval.Low] = levels.Low, _a[PollingInterval.Medium] = levels.Medium, _a[PollingInterval.High] = levels.High, _a;
      }
      var defaultChunkLevels = { Low: 32, Medium: 64, High: 256 };
      var pollingChunkSize = createPollingIntervalBasedLevels(defaultChunkLevels);
      ts3.unchangedPollThresholds = createPollingIntervalBasedLevels(defaultChunkLevels);
      function setCustomPollingValues(system) {
        if (!system.getEnvironmentVariable) {
          return;
        }
        var pollingIntervalChanged = setCustomLevels("TSC_WATCH_POLLINGINTERVAL", PollingInterval);
        pollingChunkSize = getCustomPollingBasedLevels("TSC_WATCH_POLLINGCHUNKSIZE", defaultChunkLevels) || pollingChunkSize;
        ts3.unchangedPollThresholds = getCustomPollingBasedLevels("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS", defaultChunkLevels) || ts3.unchangedPollThresholds;
        function getLevel(envVar, level) {
          return system.getEnvironmentVariable("".concat(envVar, "_").concat(level.toUpperCase()));
        }
        function getCustomLevels(baseVariable) {
          var customLevels;
          setCustomLevel("Low");
          setCustomLevel("Medium");
          setCustomLevel("High");
          return customLevels;
          function setCustomLevel(level) {
            var customLevel = getLevel(baseVariable, level);
            if (customLevel) {
              (customLevels || (customLevels = {}))[level] = Number(customLevel);
            }
          }
        }
        function setCustomLevels(baseVariable, levels) {
          var customLevels = getCustomLevels(baseVariable);
          if (customLevels) {
            setLevel("Low");
            setLevel("Medium");
            setLevel("High");
            return true;
          }
          return false;
          function setLevel(level) {
            levels[level] = customLevels[level] || levels[level];
          }
        }
        function getCustomPollingBasedLevels(baseVariable, defaultLevels) {
          var customLevels = getCustomLevels(baseVariable);
          return (pollingIntervalChanged || customLevels) && createPollingIntervalBasedLevels(customLevels ? __assign(__assign({}, defaultLevels), customLevels) : defaultLevels);
        }
      }
      ts3.setCustomPollingValues = setCustomPollingValues;
      function pollWatchedFileQueue(host, queue, pollIndex, chunkSize, callbackOnWatchFileStat) {
        var definedValueCopyToIndex = pollIndex;
        for (var canVisit = queue.length; chunkSize && canVisit; nextPollIndex(), canVisit--) {
          var watchedFile = queue[pollIndex];
          if (!watchedFile) {
            continue;
          } else if (watchedFile.isClosed) {
            queue[pollIndex] = void 0;
            continue;
          }
          chunkSize--;
          var fileChanged = onWatchedFileStat(watchedFile, getModifiedTime(host, watchedFile.fileName));
          if (watchedFile.isClosed) {
            queue[pollIndex] = void 0;
            continue;
          }
          callbackOnWatchFileStat === null || callbackOnWatchFileStat === void 0 ? void 0 : callbackOnWatchFileStat(watchedFile, pollIndex, fileChanged);
          if (queue[pollIndex]) {
            if (definedValueCopyToIndex < pollIndex) {
              queue[definedValueCopyToIndex] = watchedFile;
              queue[pollIndex] = void 0;
            }
            definedValueCopyToIndex++;
          }
        }
        return pollIndex;
        function nextPollIndex() {
          pollIndex++;
          if (pollIndex === queue.length) {
            if (definedValueCopyToIndex < pollIndex) {
              queue.length = definedValueCopyToIndex;
            }
            pollIndex = 0;
            definedValueCopyToIndex = 0;
          }
        }
      }
      function createDynamicPriorityPollingWatchFile(host) {
        var watchedFiles = [];
        var changedFilesInLastPoll = [];
        var lowPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.Low);
        var mediumPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.Medium);
        var highPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.High);
        return watchFile;
        function watchFile(fileName2, callback, defaultPollingInterval) {
          var file = {
            fileName: fileName2,
            callback,
            unchangedPolls: 0,
            mtime: getModifiedTime(host, fileName2)
          };
          watchedFiles.push(file);
          addToPollingIntervalQueue(file, defaultPollingInterval);
          return {
            close: function() {
              file.isClosed = true;
              ts3.unorderedRemoveItem(watchedFiles, file);
            }
          };
        }
        function createPollingIntervalQueue(pollingInterval) {
          var queue = [];
          queue.pollingInterval = pollingInterval;
          queue.pollIndex = 0;
          queue.pollScheduled = false;
          return queue;
        }
        function pollPollingIntervalQueue(queue) {
          queue.pollIndex = pollQueue(queue, queue.pollingInterval, queue.pollIndex, pollingChunkSize[queue.pollingInterval]);
          if (queue.length) {
            scheduleNextPoll(queue.pollingInterval);
          } else {
            ts3.Debug.assert(queue.pollIndex === 0);
            queue.pollScheduled = false;
          }
        }
        function pollLowPollingIntervalQueue(queue) {
          pollQueue(changedFilesInLastPoll, PollingInterval.Low, 0, changedFilesInLastPoll.length);
          pollPollingIntervalQueue(queue);
          if (!queue.pollScheduled && changedFilesInLastPoll.length) {
            scheduleNextPoll(PollingInterval.Low);
          }
        }
        function pollQueue(queue, pollingInterval, pollIndex, chunkSize) {
          return pollWatchedFileQueue(host, queue, pollIndex, chunkSize, onWatchFileStat);
          function onWatchFileStat(watchedFile, pollIndex2, fileChanged) {
            if (fileChanged) {
              watchedFile.unchangedPolls = 0;
              if (queue !== changedFilesInLastPoll) {
                queue[pollIndex2] = void 0;
                addChangedFileToLowPollingIntervalQueue(watchedFile);
              }
            } else if (watchedFile.unchangedPolls !== ts3.unchangedPollThresholds[pollingInterval]) {
              watchedFile.unchangedPolls++;
            } else if (queue === changedFilesInLastPoll) {
              watchedFile.unchangedPolls = 1;
              queue[pollIndex2] = void 0;
              addToPollingIntervalQueue(watchedFile, PollingInterval.Low);
            } else if (pollingInterval !== PollingInterval.High) {
              watchedFile.unchangedPolls++;
              queue[pollIndex2] = void 0;
              addToPollingIntervalQueue(watchedFile, pollingInterval === PollingInterval.Low ? PollingInterval.Medium : PollingInterval.High);
            }
          }
        }
        function pollingIntervalQueue(pollingInterval) {
          switch (pollingInterval) {
            case PollingInterval.Low:
              return lowPollingIntervalQueue;
            case PollingInterval.Medium:
              return mediumPollingIntervalQueue;
            case PollingInterval.High:
              return highPollingIntervalQueue;
          }
        }
        function addToPollingIntervalQueue(file, pollingInterval) {
          pollingIntervalQueue(pollingInterval).push(file);
          scheduleNextPollIfNotAlreadyScheduled(pollingInterval);
        }
        function addChangedFileToLowPollingIntervalQueue(file) {
          changedFilesInLastPoll.push(file);
          scheduleNextPollIfNotAlreadyScheduled(PollingInterval.Low);
        }
        function scheduleNextPollIfNotAlreadyScheduled(pollingInterval) {
          if (!pollingIntervalQueue(pollingInterval).pollScheduled) {
            scheduleNextPoll(pollingInterval);
          }
        }
        function scheduleNextPoll(pollingInterval) {
          pollingIntervalQueue(pollingInterval).pollScheduled = host.setTimeout(pollingInterval === PollingInterval.Low ? pollLowPollingIntervalQueue : pollPollingIntervalQueue, pollingInterval, pollingIntervalQueue(pollingInterval));
        }
      }
      ts3.createDynamicPriorityPollingWatchFile = createDynamicPriorityPollingWatchFile;
      function createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames) {
        var fileWatcherCallbacks = ts3.createMultiMap();
        var dirWatchers = new ts3.Map();
        var toCanonicalName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return nonPollingWatchFile;
        function nonPollingWatchFile(fileName2, callback, _pollingInterval, fallbackOptions) {
          var filePath = toCanonicalName(fileName2);
          fileWatcherCallbacks.add(filePath, callback);
          var dirPath = ts3.getDirectoryPath(filePath) || ".";
          var watcher = dirWatchers.get(dirPath) || createDirectoryWatcher(ts3.getDirectoryPath(fileName2) || ".", dirPath, fallbackOptions);
          watcher.referenceCount++;
          return {
            close: function() {
              if (watcher.referenceCount === 1) {
                watcher.close();
                dirWatchers.delete(dirPath);
              } else {
                watcher.referenceCount--;
              }
              fileWatcherCallbacks.remove(filePath, callback);
            }
          };
        }
        function createDirectoryWatcher(dirName, dirPath, fallbackOptions) {
          var watcher = fsWatch(dirName, 1, function(_eventName, relativeFileName) {
            if (!ts3.isString(relativeFileName))
              return;
            var fileName2 = ts3.getNormalizedAbsolutePath(relativeFileName, dirName);
            var callbacks = fileName2 && fileWatcherCallbacks.get(toCanonicalName(fileName2));
            if (callbacks) {
              for (var _i = 0, callbacks_1 = callbacks; _i < callbacks_1.length; _i++) {
                var fileCallback = callbacks_1[_i];
                fileCallback(fileName2, FileWatcherEventKind.Changed);
              }
            }
          }, false, PollingInterval.Medium, fallbackOptions);
          watcher.referenceCount = 0;
          dirWatchers.set(dirPath, watcher);
          return watcher;
        }
      }
      function createFixedChunkSizePollingWatchFile(host) {
        var watchedFiles = [];
        var pollIndex = 0;
        var pollScheduled;
        return watchFile;
        function watchFile(fileName2, callback) {
          var file = {
            fileName: fileName2,
            callback,
            mtime: getModifiedTime(host, fileName2)
          };
          watchedFiles.push(file);
          scheduleNextPoll();
          return {
            close: function() {
              file.isClosed = true;
              ts3.unorderedRemoveItem(watchedFiles, file);
            }
          };
        }
        function pollQueue() {
          pollScheduled = void 0;
          pollIndex = pollWatchedFileQueue(host, watchedFiles, pollIndex, pollingChunkSize[PollingInterval.Low]);
          scheduleNextPoll();
        }
        function scheduleNextPoll() {
          if (!watchedFiles.length || pollScheduled)
            return;
          pollScheduled = host.setTimeout(pollQueue, PollingInterval.High);
        }
      }
      function createSingleFileWatcherPerName(watchFile, useCaseSensitiveFileNames) {
        var cache = new ts3.Map();
        var callbacksCache = ts3.createMultiMap();
        var toCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return function(fileName2, callback, pollingInterval, options) {
          var path2 = toCanonicalFileName(fileName2);
          var existing = cache.get(path2);
          if (existing) {
            existing.refCount++;
          } else {
            cache.set(path2, {
              watcher: watchFile(fileName2, function(fileName3, eventKind) {
                return ts3.forEach(callbacksCache.get(path2), function(cb) {
                  return cb(fileName3, eventKind);
                });
              }, pollingInterval, options),
              refCount: 1
            });
          }
          callbacksCache.add(path2, callback);
          return {
            close: function() {
              var watcher = ts3.Debug.checkDefined(cache.get(path2));
              callbacksCache.remove(path2, callback);
              watcher.refCount--;
              if (watcher.refCount)
                return;
              cache.delete(path2);
              ts3.closeFileWatcherOf(watcher);
            }
          };
        };
      }
      ts3.createSingleFileWatcherPerName = createSingleFileWatcherPerName;
      function onWatchedFileStat(watchedFile, modifiedTime) {
        var oldTime = watchedFile.mtime.getTime();
        var newTime = modifiedTime.getTime();
        if (oldTime !== newTime) {
          watchedFile.mtime = modifiedTime;
          watchedFile.callback(watchedFile.fileName, getFileWatcherEventKind(oldTime, newTime));
          return true;
        }
        return false;
      }
      ts3.onWatchedFileStat = onWatchedFileStat;
      function getFileWatcherEventKind(oldTime, newTime) {
        return oldTime === 0 ? FileWatcherEventKind.Created : newTime === 0 ? FileWatcherEventKind.Deleted : FileWatcherEventKind.Changed;
      }
      ts3.getFileWatcherEventKind = getFileWatcherEventKind;
      ts3.ignoredPaths = ["/node_modules/.", "/.git", "/.#"];
      var curSysLog = ts3.noop;
      function sysLog(s) {
        return curSysLog(s);
      }
      ts3.sysLog = sysLog;
      function setSysLog(logger) {
        curSysLog = logger;
      }
      ts3.setSysLog = setSysLog;
      function createDirectoryWatcherSupportingRecursive(_a) {
        var watchDirectory = _a.watchDirectory, useCaseSensitiveFileNames = _a.useCaseSensitiveFileNames, getCurrentDirectory = _a.getCurrentDirectory, getAccessibleSortedChildDirectories = _a.getAccessibleSortedChildDirectories, directoryExists = _a.directoryExists, realpath = _a.realpath, setTimeout2 = _a.setTimeout, clearTimeout2 = _a.clearTimeout;
        var cache = new ts3.Map();
        var callbackCache = ts3.createMultiMap();
        var cacheToUpdateChildWatches = new ts3.Map();
        var timerToUpdateChildWatches;
        var filePathComparer = ts3.getStringComparer(!useCaseSensitiveFileNames);
        var toCanonicalFilePath = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return function(dirName, callback, recursive, options) {
          return recursive ? createDirectoryWatcher(dirName, options, callback) : watchDirectory(dirName, callback, recursive, options);
        };
        function createDirectoryWatcher(dirName, options, callback) {
          var dirPath = toCanonicalFilePath(dirName);
          var directoryWatcher = cache.get(dirPath);
          if (directoryWatcher) {
            directoryWatcher.refCount++;
          } else {
            directoryWatcher = {
              watcher: watchDirectory(dirName, function(fileName2) {
                if (isIgnoredPath(fileName2, options))
                  return;
                if (options === null || options === void 0 ? void 0 : options.synchronousWatchDirectory) {
                  invokeCallbacks(dirPath, fileName2);
                  updateChildWatches(dirName, dirPath, options);
                } else {
                  nonSyncUpdateChildWatches(dirName, dirPath, fileName2, options);
                }
              }, false, options),
              refCount: 1,
              childWatches: ts3.emptyArray
            };
            cache.set(dirPath, directoryWatcher);
            updateChildWatches(dirName, dirPath, options);
          }
          var callbackToAdd = callback && { dirName, callback };
          if (callbackToAdd) {
            callbackCache.add(dirPath, callbackToAdd);
          }
          return {
            dirName,
            close: function() {
              var directoryWatcher2 = ts3.Debug.checkDefined(cache.get(dirPath));
              if (callbackToAdd)
                callbackCache.remove(dirPath, callbackToAdd);
              directoryWatcher2.refCount--;
              if (directoryWatcher2.refCount)
                return;
              cache.delete(dirPath);
              ts3.closeFileWatcherOf(directoryWatcher2);
              directoryWatcher2.childWatches.forEach(ts3.closeFileWatcher);
            }
          };
        }
        function invokeCallbacks(dirPath, fileNameOrInvokeMap, fileNames) {
          var fileName2;
          var invokeMap;
          if (ts3.isString(fileNameOrInvokeMap)) {
            fileName2 = fileNameOrInvokeMap;
          } else {
            invokeMap = fileNameOrInvokeMap;
          }
          callbackCache.forEach(function(callbacks, rootDirName) {
            var _a2;
            if (invokeMap && invokeMap.get(rootDirName) === true)
              return;
            if (rootDirName === dirPath || ts3.startsWith(dirPath, rootDirName) && dirPath[rootDirName.length] === ts3.directorySeparator) {
              if (invokeMap) {
                if (fileNames) {
                  var existing = invokeMap.get(rootDirName);
                  if (existing) {
                    (_a2 = existing).push.apply(_a2, fileNames);
                  } else {
                    invokeMap.set(rootDirName, fileNames.slice());
                  }
                } else {
                  invokeMap.set(rootDirName, true);
                }
              } else {
                callbacks.forEach(function(_a3) {
                  var callback = _a3.callback;
                  return callback(fileName2);
                });
              }
            }
          });
        }
        function nonSyncUpdateChildWatches(dirName, dirPath, fileName2, options) {
          var parentWatcher = cache.get(dirPath);
          if (parentWatcher && directoryExists(dirName)) {
            scheduleUpdateChildWatches(dirName, dirPath, fileName2, options);
            return;
          }
          invokeCallbacks(dirPath, fileName2);
          removeChildWatches(parentWatcher);
        }
        function scheduleUpdateChildWatches(dirName, dirPath, fileName2, options) {
          var existing = cacheToUpdateChildWatches.get(dirPath);
          if (existing) {
            existing.fileNames.push(fileName2);
          } else {
            cacheToUpdateChildWatches.set(dirPath, { dirName, options, fileNames: [fileName2] });
          }
          if (timerToUpdateChildWatches) {
            clearTimeout2(timerToUpdateChildWatches);
            timerToUpdateChildWatches = void 0;
          }
          timerToUpdateChildWatches = setTimeout2(onTimerToUpdateChildWatches, 1e3);
        }
        function onTimerToUpdateChildWatches() {
          timerToUpdateChildWatches = void 0;
          sysLog("sysLog:: onTimerToUpdateChildWatches:: ".concat(cacheToUpdateChildWatches.size));
          var start = ts3.timestamp();
          var invokeMap = new ts3.Map();
          while (!timerToUpdateChildWatches && cacheToUpdateChildWatches.size) {
            var result2 = cacheToUpdateChildWatches.entries().next();
            ts3.Debug.assert(!result2.done);
            var _a2 = result2.value, dirPath = _a2[0], _b = _a2[1], dirName = _b.dirName, options = _b.options, fileNames = _b.fileNames;
            cacheToUpdateChildWatches.delete(dirPath);
            var hasChanges = updateChildWatches(dirName, dirPath, options);
            invokeCallbacks(dirPath, invokeMap, hasChanges ? void 0 : fileNames);
          }
          sysLog("sysLog:: invokingWatchers:: Elapsed:: ".concat(ts3.timestamp() - start, "ms:: ").concat(cacheToUpdateChildWatches.size));
          callbackCache.forEach(function(callbacks, rootDirName) {
            var existing = invokeMap.get(rootDirName);
            if (existing) {
              callbacks.forEach(function(_a3) {
                var callback = _a3.callback, dirName2 = _a3.dirName;
                if (ts3.isArray(existing)) {
                  existing.forEach(callback);
                } else {
                  callback(dirName2);
                }
              });
            }
          });
          var elapsed = ts3.timestamp() - start;
          sysLog("sysLog:: Elapsed:: ".concat(elapsed, "ms:: onTimerToUpdateChildWatches:: ").concat(cacheToUpdateChildWatches.size, " ").concat(timerToUpdateChildWatches));
        }
        function removeChildWatches(parentWatcher) {
          if (!parentWatcher)
            return;
          var existingChildWatches = parentWatcher.childWatches;
          parentWatcher.childWatches = ts3.emptyArray;
          for (var _i = 0, existingChildWatches_1 = existingChildWatches; _i < existingChildWatches_1.length; _i++) {
            var childWatcher = existingChildWatches_1[_i];
            childWatcher.close();
            removeChildWatches(cache.get(toCanonicalFilePath(childWatcher.dirName)));
          }
        }
        function updateChildWatches(parentDir, parentDirPath, options) {
          var parentWatcher = cache.get(parentDirPath);
          if (!parentWatcher)
            return false;
          var newChildWatches;
          var hasChanges = ts3.enumerateInsertsAndDeletes(directoryExists(parentDir) ? ts3.mapDefined(getAccessibleSortedChildDirectories(parentDir), function(child) {
            var childFullName = ts3.getNormalizedAbsolutePath(child, parentDir);
            return !isIgnoredPath(childFullName, options) && filePathComparer(childFullName, ts3.normalizePath(realpath(childFullName))) === 0 ? childFullName : void 0;
          }) : ts3.emptyArray, parentWatcher.childWatches, function(child, childWatcher) {
            return filePathComparer(child, childWatcher.dirName);
          }, createAndAddChildDirectoryWatcher, ts3.closeFileWatcher, addChildDirectoryWatcher);
          parentWatcher.childWatches = newChildWatches || ts3.emptyArray;
          return hasChanges;
          function createAndAddChildDirectoryWatcher(childName) {
            var result2 = createDirectoryWatcher(childName, options);
            addChildDirectoryWatcher(result2);
          }
          function addChildDirectoryWatcher(childWatcher) {
            (newChildWatches || (newChildWatches = [])).push(childWatcher);
          }
        }
        function isIgnoredPath(path2, options) {
          return ts3.some(ts3.ignoredPaths, function(searchPath) {
            return isInPath(path2, searchPath);
          }) || isIgnoredByWatchOptions(path2, options, useCaseSensitiveFileNames, getCurrentDirectory);
        }
        function isInPath(path2, searchPath) {
          if (ts3.stringContains(path2, searchPath))
            return true;
          if (useCaseSensitiveFileNames)
            return false;
          return ts3.stringContains(toCanonicalFilePath(path2), searchPath);
        }
      }
      ts3.createDirectoryWatcherSupportingRecursive = createDirectoryWatcherSupportingRecursive;
      var FileSystemEntryKind;
      (function(FileSystemEntryKind2) {
        FileSystemEntryKind2[FileSystemEntryKind2["File"] = 0] = "File";
        FileSystemEntryKind2[FileSystemEntryKind2["Directory"] = 1] = "Directory";
      })(FileSystemEntryKind = ts3.FileSystemEntryKind || (ts3.FileSystemEntryKind = {}));
      function createFileWatcherCallback(callback) {
        return function(_fileName, eventKind) {
          return callback(eventKind === FileWatcherEventKind.Changed ? "change" : "rename", "");
        };
      }
      ts3.createFileWatcherCallback = createFileWatcherCallback;
      function createFsWatchCallbackForFileWatcherCallback(fileName2, callback, fileExists) {
        return function(eventName) {
          if (eventName === "rename") {
            callback(fileName2, fileExists(fileName2) ? FileWatcherEventKind.Created : FileWatcherEventKind.Deleted);
          } else {
            callback(fileName2, FileWatcherEventKind.Changed);
          }
        };
      }
      function isIgnoredByWatchOptions(pathToCheck, options, useCaseSensitiveFileNames, getCurrentDirectory) {
        return ((options === null || options === void 0 ? void 0 : options.excludeDirectories) || (options === null || options === void 0 ? void 0 : options.excludeFiles)) && (ts3.matchesExclude(pathToCheck, options === null || options === void 0 ? void 0 : options.excludeFiles, useCaseSensitiveFileNames, getCurrentDirectory()) || ts3.matchesExclude(pathToCheck, options === null || options === void 0 ? void 0 : options.excludeDirectories, useCaseSensitiveFileNames, getCurrentDirectory()));
      }
      function createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames, getCurrentDirectory) {
        return function(eventName, relativeFileName) {
          if (eventName === "rename") {
            var fileName2 = !relativeFileName ? directoryName : ts3.normalizePath(ts3.combinePaths(directoryName, relativeFileName));
            if (!relativeFileName || !isIgnoredByWatchOptions(fileName2, options, useCaseSensitiveFileNames, getCurrentDirectory)) {
              callback(fileName2);
            }
          }
        };
      }
      function createSystemWatchFunctions(_a) {
        var pollingWatchFile = _a.pollingWatchFile, getModifiedTime2 = _a.getModifiedTime, setTimeout2 = _a.setTimeout, clearTimeout2 = _a.clearTimeout, fsWatch = _a.fsWatch, fileExists = _a.fileExists, useCaseSensitiveFileNames = _a.useCaseSensitiveFileNames, getCurrentDirectory = _a.getCurrentDirectory, fsSupportsRecursiveFsWatch = _a.fsSupportsRecursiveFsWatch, directoryExists = _a.directoryExists, getAccessibleSortedChildDirectories = _a.getAccessibleSortedChildDirectories, realpath = _a.realpath, tscWatchFile = _a.tscWatchFile, useNonPollingWatchers = _a.useNonPollingWatchers, tscWatchDirectory = _a.tscWatchDirectory, defaultWatchFileKind = _a.defaultWatchFileKind;
        var dynamicPollingWatchFile;
        var fixedChunkSizePollingWatchFile;
        var nonPollingWatchFile;
        var hostRecursiveDirectoryWatcher;
        return {
          watchFile,
          watchDirectory
        };
        function watchFile(fileName2, callback, pollingInterval, options) {
          options = updateOptionsForWatchFile(options, useNonPollingWatchers);
          var watchFileKind = ts3.Debug.checkDefined(options.watchFile);
          switch (watchFileKind) {
            case ts3.WatchFileKind.FixedPollingInterval:
              return pollingWatchFile(fileName2, callback, PollingInterval.Low, void 0);
            case ts3.WatchFileKind.PriorityPollingInterval:
              return pollingWatchFile(fileName2, callback, pollingInterval, void 0);
            case ts3.WatchFileKind.DynamicPriorityPolling:
              return ensureDynamicPollingWatchFile()(fileName2, callback, pollingInterval, void 0);
            case ts3.WatchFileKind.FixedChunkSizePolling:
              return ensureFixedChunkSizePollingWatchFile()(fileName2, callback, void 0, void 0);
            case ts3.WatchFileKind.UseFsEvents:
              return fsWatch(fileName2, 0, createFsWatchCallbackForFileWatcherCallback(fileName2, callback, fileExists), false, pollingInterval, ts3.getFallbackOptions(options));
            case ts3.WatchFileKind.UseFsEventsOnParentDirectory:
              if (!nonPollingWatchFile) {
                nonPollingWatchFile = createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames);
              }
              return nonPollingWatchFile(fileName2, callback, pollingInterval, ts3.getFallbackOptions(options));
            default:
              ts3.Debug.assertNever(watchFileKind);
          }
        }
        function ensureDynamicPollingWatchFile() {
          return dynamicPollingWatchFile || (dynamicPollingWatchFile = createDynamicPriorityPollingWatchFile({ getModifiedTime: getModifiedTime2, setTimeout: setTimeout2 }));
        }
        function ensureFixedChunkSizePollingWatchFile() {
          return fixedChunkSizePollingWatchFile || (fixedChunkSizePollingWatchFile = createFixedChunkSizePollingWatchFile({ getModifiedTime: getModifiedTime2, setTimeout: setTimeout2 }));
        }
        function updateOptionsForWatchFile(options, useNonPollingWatchers2) {
          if (options && options.watchFile !== void 0)
            return options;
          switch (tscWatchFile) {
            case "PriorityPollingInterval":
              return { watchFile: ts3.WatchFileKind.PriorityPollingInterval };
            case "DynamicPriorityPolling":
              return { watchFile: ts3.WatchFileKind.DynamicPriorityPolling };
            case "UseFsEvents":
              return generateWatchFileOptions(ts3.WatchFileKind.UseFsEvents, ts3.PollingWatchKind.PriorityInterval, options);
            case "UseFsEventsWithFallbackDynamicPolling":
              return generateWatchFileOptions(ts3.WatchFileKind.UseFsEvents, ts3.PollingWatchKind.DynamicPriority, options);
            case "UseFsEventsOnParentDirectory":
              useNonPollingWatchers2 = true;
            default:
              return useNonPollingWatchers2 ? generateWatchFileOptions(ts3.WatchFileKind.UseFsEventsOnParentDirectory, ts3.PollingWatchKind.PriorityInterval, options) : { watchFile: (defaultWatchFileKind === null || defaultWatchFileKind === void 0 ? void 0 : defaultWatchFileKind()) || ts3.WatchFileKind.FixedPollingInterval };
          }
        }
        function generateWatchFileOptions(watchFile2, fallbackPolling, options) {
          var defaultFallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
          return {
            watchFile: watchFile2,
            fallbackPolling: defaultFallbackPolling === void 0 ? fallbackPolling : defaultFallbackPolling
          };
        }
        function watchDirectory(directoryName, callback, recursive, options) {
          if (fsSupportsRecursiveFsWatch) {
            return fsWatch(directoryName, 1, createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames, getCurrentDirectory), recursive, PollingInterval.Medium, ts3.getFallbackOptions(options));
          }
          if (!hostRecursiveDirectoryWatcher) {
            hostRecursiveDirectoryWatcher = createDirectoryWatcherSupportingRecursive({
              useCaseSensitiveFileNames,
              getCurrentDirectory,
              directoryExists,
              getAccessibleSortedChildDirectories,
              watchDirectory: nonRecursiveWatchDirectory,
              realpath,
              setTimeout: setTimeout2,
              clearTimeout: clearTimeout2
            });
          }
          return hostRecursiveDirectoryWatcher(directoryName, callback, recursive, options);
        }
        function nonRecursiveWatchDirectory(directoryName, callback, recursive, options) {
          ts3.Debug.assert(!recursive);
          var watchDirectoryOptions = updateOptionsForWatchDirectory(options);
          var watchDirectoryKind = ts3.Debug.checkDefined(watchDirectoryOptions.watchDirectory);
          switch (watchDirectoryKind) {
            case ts3.WatchDirectoryKind.FixedPollingInterval:
              return pollingWatchFile(directoryName, function() {
                return callback(directoryName);
              }, PollingInterval.Medium, void 0);
            case ts3.WatchDirectoryKind.DynamicPriorityPolling:
              return ensureDynamicPollingWatchFile()(directoryName, function() {
                return callback(directoryName);
              }, PollingInterval.Medium, void 0);
            case ts3.WatchDirectoryKind.FixedChunkSizePolling:
              return ensureFixedChunkSizePollingWatchFile()(directoryName, function() {
                return callback(directoryName);
              }, void 0, void 0);
            case ts3.WatchDirectoryKind.UseFsEvents:
              return fsWatch(directoryName, 1, createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames, getCurrentDirectory), recursive, PollingInterval.Medium, ts3.getFallbackOptions(watchDirectoryOptions));
            default:
              ts3.Debug.assertNever(watchDirectoryKind);
          }
        }
        function updateOptionsForWatchDirectory(options) {
          if (options && options.watchDirectory !== void 0)
            return options;
          switch (tscWatchDirectory) {
            case "RecursiveDirectoryUsingFsWatchFile":
              return { watchDirectory: ts3.WatchDirectoryKind.FixedPollingInterval };
            case "RecursiveDirectoryUsingDynamicPriorityPolling":
              return { watchDirectory: ts3.WatchDirectoryKind.DynamicPriorityPolling };
            default:
              var defaultFallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
              return {
                watchDirectory: ts3.WatchDirectoryKind.UseFsEvents,
                fallbackPolling: defaultFallbackPolling !== void 0 ? defaultFallbackPolling : void 0
              };
          }
        }
      }
      ts3.createSystemWatchFunctions = createSystemWatchFunctions;
      function patchWriteFileEnsuringDirectory(sys) {
        var originalWriteFile = sys.writeFile;
        sys.writeFile = function(path2, data, writeBom) {
          return ts3.writeFileEnsuringDirectories(path2, data, !!writeBom, function(path3, data2, writeByteOrderMark) {
            return originalWriteFile.call(sys, path3, data2, writeByteOrderMark);
          }, function(path3) {
            return sys.createDirectory(path3);
          }, function(path3) {
            return sys.directoryExists(path3);
          });
        };
      }
      ts3.patchWriteFileEnsuringDirectory = patchWriteFileEnsuringDirectory;
      function getNodeMajorVersion() {
        if (typeof process === "undefined") {
          return void 0;
        }
        var version = process.version;
        if (!version) {
          return void 0;
        }
        var dot = version.indexOf(".");
        if (dot === -1) {
          return void 0;
        }
        return parseInt(version.substring(1, dot));
      }
      ts3.getNodeMajorVersion = getNodeMajorVersion;
      ts3.sys = function() {
        var byteOrderMarkIndicator = "\uFEFF";
        function getNodeSystem() {
          var _a;
          var nativePattern = /^native |^\([^)]+\)$|^(internal[\\/]|[a-zA-Z0-9_\s]+(\.js)?$)/;
          var _fs = require("fs");
          var _path = require("path");
          var _os = require("os");
          var _crypto;
          try {
            _crypto = require("crypto");
          } catch (_b) {
            _crypto = void 0;
          }
          var activeSession;
          var profilePath = "./profile.cpuprofile";
          var hitSystemWatcherLimit = false;
          var Buffer2 = require("buffer").Buffer;
          var nodeVersion = getNodeMajorVersion();
          var isNode4OrLater = nodeVersion >= 4;
          var isLinuxOrMacOs = process.platform === "linux" || process.platform === "darwin";
          var platform = _os.platform();
          var useCaseSensitiveFileNames = isFileSystemCaseSensitive();
          var realpathSync = (_a = _fs.realpathSync.native) !== null && _a !== void 0 ? _a : _fs.realpathSync;
          var fsSupportsRecursiveFsWatch = isNode4OrLater && (process.platform === "win32" || process.platform === "darwin");
          var getCurrentDirectory = ts3.memoize(function() {
            return process.cwd();
          });
          var _c = createSystemWatchFunctions({
            pollingWatchFile: createSingleFileWatcherPerName(fsWatchFileWorker, useCaseSensitiveFileNames),
            getModifiedTime: getModifiedTime2,
            setTimeout,
            clearTimeout,
            fsWatch,
            useCaseSensitiveFileNames,
            getCurrentDirectory,
            fileExists,
            fsSupportsRecursiveFsWatch,
            directoryExists,
            getAccessibleSortedChildDirectories: function(path2) {
              return getAccessibleFileSystemEntries(path2).directories;
            },
            realpath,
            tscWatchFile: process.env.TSC_WATCHFILE,
            useNonPollingWatchers: process.env.TSC_NONPOLLING_WATCHER,
            tscWatchDirectory: process.env.TSC_WATCHDIRECTORY,
            defaultWatchFileKind: function() {
              var _a2, _b;
              return (_b = (_a2 = sys).defaultWatchFileKind) === null || _b === void 0 ? void 0 : _b.call(_a2);
            }
          }), watchFile = _c.watchFile, watchDirectory = _c.watchDirectory;
          var nodeSystem = {
            args: process.argv.slice(2),
            newLine: _os.EOL,
            useCaseSensitiveFileNames,
            write: function(s) {
              process.stdout.write(s);
            },
            getWidthOfTerminal: function() {
              return process.stdout.columns;
            },
            writeOutputIsTTY: function() {
              return process.stdout.isTTY;
            },
            readFile,
            writeFile,
            watchFile,
            watchDirectory,
            resolvePath: function(path2) {
              return _path.resolve(path2);
            },
            fileExists,
            directoryExists,
            createDirectory: function(directoryName) {
              if (!nodeSystem.directoryExists(directoryName)) {
                try {
                  _fs.mkdirSync(directoryName);
                } catch (e) {
                  if (e.code !== "EEXIST") {
                    throw e;
                  }
                }
              }
            },
            getExecutingFilePath: function() {
              return __filename;
            },
            getCurrentDirectory,
            getDirectories,
            getEnvironmentVariable: function(name) {
              return process.env[name] || "";
            },
            readDirectory,
            getModifiedTime: getModifiedTime2,
            setModifiedTime,
            deleteFile,
            createHash: _crypto ? createSHA256Hash : generateDjb2Hash,
            createSHA256Hash: _crypto ? createSHA256Hash : void 0,
            getMemoryUsage: function() {
              if (global.gc) {
                global.gc();
              }
              return process.memoryUsage().heapUsed;
            },
            getFileSize: function(path2) {
              try {
                var stat = statSync(path2);
                if (stat === null || stat === void 0 ? void 0 : stat.isFile()) {
                  return stat.size;
                }
              } catch (_a2) {
              }
              return 0;
            },
            exit: function(exitCode) {
              disableCPUProfiler(function() {
                return process.exit(exitCode);
              });
            },
            enableCPUProfiler,
            disableCPUProfiler,
            cpuProfilingEnabled: function() {
              return !!activeSession || ts3.contains(process.execArgv, "--cpu-prof") || ts3.contains(process.execArgv, "--prof");
            },
            realpath,
            debugMode: !!process.env.NODE_INSPECTOR_IPC || !!process.env.VSCODE_INSPECTOR_OPTIONS || ts3.some(process.execArgv, function(arg) {
              return /^--(inspect|debug)(-brk)?(=\d+)?$/i.test(arg);
            }),
            tryEnableSourceMapsForHost: function() {
              try {
                require_source_map_support().install();
              } catch (_a2) {
              }
            },
            setTimeout,
            clearTimeout,
            clearScreen: function() {
              process.stdout.write("\x1Bc");
            },
            setBlocking: function() {
              if (process.stdout && process.stdout._handle && process.stdout._handle.setBlocking) {
                process.stdout._handle.setBlocking(true);
              }
            },
            bufferFrom,
            base64decode: function(input) {
              return bufferFrom(input, "base64").toString("utf8");
            },
            base64encode: function(input) {
              return bufferFrom(input).toString("base64");
            },
            require: function(baseDir, moduleName) {
              try {
                var modulePath = ts3.resolveJSModule(moduleName, baseDir, nodeSystem);
                return { module: require(modulePath), modulePath, error: void 0 };
              } catch (error) {
                return { module: void 0, modulePath: void 0, error };
              }
            }
          };
          return nodeSystem;
          function statSync(path2) {
            return _fs.statSync(path2, { throwIfNoEntry: false });
          }
          function enableCPUProfiler(path2, cb) {
            if (activeSession) {
              cb();
              return false;
            }
            var inspector = require("inspector");
            if (!inspector || !inspector.Session) {
              cb();
              return false;
            }
            var session = new inspector.Session();
            session.connect();
            session.post("Profiler.enable", function() {
              session.post("Profiler.start", function() {
                activeSession = session;
                profilePath = path2;
                cb();
              });
            });
            return true;
          }
          function cleanupPaths(profile) {
            var externalFileCounter = 0;
            var remappedPaths = new ts3.Map();
            var normalizedDir = ts3.normalizeSlashes(__dirname);
            var fileUrlRoot = "file://".concat(ts3.getRootLength(normalizedDir) === 1 ? "" : "/").concat(normalizedDir);
            for (var _i = 0, _a2 = profile.nodes; _i < _a2.length; _i++) {
              var node = _a2[_i];
              if (node.callFrame.url) {
                var url = ts3.normalizeSlashes(node.callFrame.url);
                if (ts3.containsPath(fileUrlRoot, url, useCaseSensitiveFileNames)) {
                  node.callFrame.url = ts3.getRelativePathToDirectoryOrUrl(fileUrlRoot, url, fileUrlRoot, ts3.createGetCanonicalFileName(useCaseSensitiveFileNames), true);
                } else if (!nativePattern.test(url)) {
                  node.callFrame.url = (remappedPaths.has(url) ? remappedPaths : remappedPaths.set(url, "external".concat(externalFileCounter, ".js"))).get(url);
                  externalFileCounter++;
                }
              }
            }
            return profile;
          }
          function disableCPUProfiler(cb) {
            if (activeSession && activeSession !== "stopping") {
              var s_1 = activeSession;
              activeSession.post("Profiler.stop", function(err, _a2) {
                var _b;
                var profile = _a2.profile;
                if (!err) {
                  try {
                    if ((_b = statSync(profilePath)) === null || _b === void 0 ? void 0 : _b.isDirectory()) {
                      profilePath = _path.join(profilePath, "".concat(new Date().toISOString().replace(/:/g, "-"), "+P").concat(process.pid, ".cpuprofile"));
                    }
                  } catch (_c2) {
                  }
                  try {
                    _fs.mkdirSync(_path.dirname(profilePath), { recursive: true });
                  } catch (_d) {
                  }
                  _fs.writeFileSync(profilePath, JSON.stringify(cleanupPaths(profile)));
                }
                activeSession = void 0;
                s_1.disconnect();
                cb();
              });
              activeSession = "stopping";
              return true;
            } else {
              cb();
              return false;
            }
          }
          function bufferFrom(input, encoding) {
            return Buffer2.from && Buffer2.from !== Int8Array.from ? Buffer2.from(input, encoding) : new Buffer2(input, encoding);
          }
          function isFileSystemCaseSensitive() {
            if (platform === "win32" || platform === "win64") {
              return false;
            }
            return !fileExists(swapCase(__filename));
          }
          function swapCase(s) {
            return s.replace(/\w/g, function(ch) {
              var up = ch.toUpperCase();
              return ch === up ? ch.toLowerCase() : up;
            });
          }
          function fsWatchFileWorker(fileName2, callback, pollingInterval) {
            _fs.watchFile(fileName2, { persistent: true, interval: pollingInterval }, fileChanged);
            var eventKind;
            return {
              close: function() {
                return _fs.unwatchFile(fileName2, fileChanged);
              }
            };
            function fileChanged(curr, prev) {
              var isPreviouslyDeleted = +prev.mtime === 0 || eventKind === FileWatcherEventKind.Deleted;
              if (+curr.mtime === 0) {
                if (isPreviouslyDeleted) {
                  return;
                }
                eventKind = FileWatcherEventKind.Deleted;
              } else if (isPreviouslyDeleted) {
                eventKind = FileWatcherEventKind.Created;
              } else if (+curr.mtime === +prev.mtime) {
                return;
              } else {
                eventKind = FileWatcherEventKind.Changed;
              }
              callback(fileName2, eventKind);
            }
          }
          function fsWatch(fileOrDirectory, entryKind, callback, recursive, fallbackPollingInterval, fallbackOptions) {
            var options;
            var lastDirectoryPartWithDirectorySeparator;
            var lastDirectoryPart;
            if (isLinuxOrMacOs) {
              lastDirectoryPartWithDirectorySeparator = fileOrDirectory.substr(fileOrDirectory.lastIndexOf(ts3.directorySeparator));
              lastDirectoryPart = lastDirectoryPartWithDirectorySeparator.slice(ts3.directorySeparator.length);
            }
            var watcher = !fileSystemEntryExists(fileOrDirectory, entryKind) ? watchMissingFileSystemEntry() : watchPresentFileSystemEntry();
            return {
              close: function() {
                watcher.close();
                watcher = void 0;
              }
            };
            function invokeCallbackAndUpdateWatcher(createWatcher) {
              sysLog("sysLog:: ".concat(fileOrDirectory, ":: Changing watcher to ").concat(createWatcher === watchPresentFileSystemEntry ? "Present" : "Missing", "FileSystemEntryWatcher"));
              callback("rename", "");
              if (watcher) {
                watcher.close();
                watcher = createWatcher();
              }
            }
            function watchPresentFileSystemEntry() {
              if (options === void 0) {
                if (fsSupportsRecursiveFsWatch) {
                  options = { persistent: true, recursive: !!recursive };
                } else {
                  options = { persistent: true };
                }
              }
              if (hitSystemWatcherLimit) {
                sysLog("sysLog:: ".concat(fileOrDirectory, ":: Defaulting to fsWatchFile"));
                return watchPresentFileSystemEntryWithFsWatchFile();
              }
              try {
                var presentWatcher = _fs.watch(fileOrDirectory, options, isLinuxOrMacOs ? callbackChangingToMissingFileSystemEntry : callback);
                presentWatcher.on("error", function() {
                  return invokeCallbackAndUpdateWatcher(watchMissingFileSystemEntry);
                });
                return presentWatcher;
              } catch (e) {
                hitSystemWatcherLimit || (hitSystemWatcherLimit = e.code === "ENOSPC");
                sysLog("sysLog:: ".concat(fileOrDirectory, ":: Changing to fsWatchFile"));
                return watchPresentFileSystemEntryWithFsWatchFile();
              }
            }
            function callbackChangingToMissingFileSystemEntry(event2, relativeName) {
              return event2 === "rename" && (!relativeName || relativeName === lastDirectoryPart || relativeName.lastIndexOf(lastDirectoryPartWithDirectorySeparator) !== -1 && relativeName.lastIndexOf(lastDirectoryPartWithDirectorySeparator) === relativeName.length - lastDirectoryPartWithDirectorySeparator.length) && !fileSystemEntryExists(fileOrDirectory, entryKind) ? invokeCallbackAndUpdateWatcher(watchMissingFileSystemEntry) : callback(event2, relativeName);
            }
            function watchPresentFileSystemEntryWithFsWatchFile() {
              return watchFile(fileOrDirectory, createFileWatcherCallback(callback), fallbackPollingInterval, fallbackOptions);
            }
            function watchMissingFileSystemEntry() {
              return watchFile(fileOrDirectory, function(_fileName, eventKind) {
                if (eventKind === FileWatcherEventKind.Created && fileSystemEntryExists(fileOrDirectory, entryKind)) {
                  invokeCallbackAndUpdateWatcher(watchPresentFileSystemEntry);
                }
              }, fallbackPollingInterval, fallbackOptions);
            }
          }
          function readFileWorker(fileName2, _encoding) {
            var buffer;
            try {
              buffer = _fs.readFileSync(fileName2);
            } catch (e) {
              return void 0;
            }
            var len = buffer.length;
            if (len >= 2 && buffer[0] === 254 && buffer[1] === 255) {
              len &= ~1;
              for (var i = 0; i < len; i += 2) {
                var temp = buffer[i];
                buffer[i] = buffer[i + 1];
                buffer[i + 1] = temp;
              }
              return buffer.toString("utf16le", 2);
            }
            if (len >= 2 && buffer[0] === 255 && buffer[1] === 254) {
              return buffer.toString("utf16le", 2);
            }
            if (len >= 3 && buffer[0] === 239 && buffer[1] === 187 && buffer[2] === 191) {
              return buffer.toString("utf8", 3);
            }
            return buffer.toString("utf8");
          }
          function readFile(fileName2, _encoding) {
            ts3.perfLogger.logStartReadFile(fileName2);
            var file = readFileWorker(fileName2, _encoding);
            ts3.perfLogger.logStopReadFile();
            return file;
          }
          function writeFile(fileName2, data, writeByteOrderMark) {
            ts3.perfLogger.logEvent("WriteFile: " + fileName2);
            if (writeByteOrderMark) {
              data = byteOrderMarkIndicator + data;
            }
            var fd;
            try {
              fd = _fs.openSync(fileName2, "w");
              _fs.writeSync(fd, data, void 0, "utf8");
            } finally {
              if (fd !== void 0) {
                _fs.closeSync(fd);
              }
            }
          }
          function getAccessibleFileSystemEntries(path2) {
            ts3.perfLogger.logEvent("ReadDir: " + (path2 || "."));
            try {
              var entries = _fs.readdirSync(path2 || ".", { withFileTypes: true });
              var files = [];
              var directories = [];
              for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
                var dirent = entries_1[_i];
                var entry = typeof dirent === "string" ? dirent : dirent.name;
                if (entry === "." || entry === "..") {
                  continue;
                }
                var stat = void 0;
                if (typeof dirent === "string" || dirent.isSymbolicLink()) {
                  var name = ts3.combinePaths(path2, entry);
                  try {
                    stat = statSync(name);
                    if (!stat) {
                      continue;
                    }
                  } catch (e) {
                    continue;
                  }
                } else {
                  stat = dirent;
                }
                if (stat.isFile()) {
                  files.push(entry);
                } else if (stat.isDirectory()) {
                  directories.push(entry);
                }
              }
              files.sort();
              directories.sort();
              return { files, directories };
            } catch (e) {
              return ts3.emptyFileSystemEntries;
            }
          }
          function readDirectory(path2, extensions, excludes, includes, depth) {
            return ts3.matchFiles(path2, extensions, excludes, includes, useCaseSensitiveFileNames, process.cwd(), depth, getAccessibleFileSystemEntries, realpath);
          }
          function fileSystemEntryExists(path2, entryKind) {
            var originalStackTraceLimit = Error.stackTraceLimit;
            Error.stackTraceLimit = 0;
            try {
              var stat = statSync(path2);
              if (!stat) {
                return false;
              }
              switch (entryKind) {
                case 0:
                  return stat.isFile();
                case 1:
                  return stat.isDirectory();
                default:
                  return false;
              }
            } catch (e) {
              return false;
            } finally {
              Error.stackTraceLimit = originalStackTraceLimit;
            }
          }
          function fileExists(path2) {
            return fileSystemEntryExists(path2, 0);
          }
          function directoryExists(path2) {
            return fileSystemEntryExists(path2, 1);
          }
          function getDirectories(path2) {
            return getAccessibleFileSystemEntries(path2).directories.slice();
          }
          function realpath(path2) {
            try {
              return realpathSync(path2);
            } catch (_a2) {
              return path2;
            }
          }
          function getModifiedTime2(path2) {
            var _a2;
            try {
              return (_a2 = statSync(path2)) === null || _a2 === void 0 ? void 0 : _a2.mtime;
            } catch (e) {
              return void 0;
            }
          }
          function setModifiedTime(path2, time) {
            try {
              _fs.utimesSync(path2, time, time);
            } catch (e) {
              return;
            }
          }
          function deleteFile(path2) {
            try {
              return _fs.unlinkSync(path2);
            } catch (e) {
              return;
            }
          }
          function createSHA256Hash(data) {
            var hash = _crypto.createHash("sha256");
            hash.update(data);
            return hash.digest("hex");
          }
        }
        var sys;
        if (typeof process !== "undefined" && process.nextTick && !process.browser && typeof require !== "undefined") {
          sys = getNodeSystem();
        }
        if (sys) {
          patchWriteFileEnsuringDirectory(sys);
        }
        return sys;
      }();
      function setSys(s) {
        ts3.sys = s;
      }
      ts3.setSys = setSys;
      if (ts3.sys && ts3.sys.getEnvironmentVariable) {
        setCustomPollingValues(ts3.sys);
        ts3.Debug.setAssertionLevel(/^development$/i.test(ts3.sys.getEnvironmentVariable("NODE_ENV")) ? 1 : 0);
      }
      if (ts3.sys && ts3.sys.debugMode) {
        ts3.Debug.isDebugging = true;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.directorySeparator = "/";
      ts3.altDirectorySeparator = "\\";
      var urlSchemeSeparator = "://";
      var backslashRegExp = /\\/g;
      function isAnyDirectorySeparator(charCode) {
        return charCode === 47 || charCode === 92;
      }
      ts3.isAnyDirectorySeparator = isAnyDirectorySeparator;
      function isUrl(path2) {
        return getEncodedRootLength(path2) < 0;
      }
      ts3.isUrl = isUrl;
      function isRootedDiskPath(path2) {
        return getEncodedRootLength(path2) > 0;
      }
      ts3.isRootedDiskPath = isRootedDiskPath;
      function isDiskPathRoot(path2) {
        var rootLength = getEncodedRootLength(path2);
        return rootLength > 0 && rootLength === path2.length;
      }
      ts3.isDiskPathRoot = isDiskPathRoot;
      function pathIsAbsolute(path2) {
        return getEncodedRootLength(path2) !== 0;
      }
      ts3.pathIsAbsolute = pathIsAbsolute;
      function pathIsRelative(path2) {
        return /^\.\.?($|[\\/])/.test(path2);
      }
      ts3.pathIsRelative = pathIsRelative;
      function pathIsBareSpecifier(path2) {
        return !pathIsAbsolute(path2) && !pathIsRelative(path2);
      }
      ts3.pathIsBareSpecifier = pathIsBareSpecifier;
      function hasExtension(fileName2) {
        return ts3.stringContains(getBaseFileName(fileName2), ".");
      }
      ts3.hasExtension = hasExtension;
      function fileExtensionIs(path2, extension) {
        return path2.length > extension.length && ts3.endsWith(path2, extension);
      }
      ts3.fileExtensionIs = fileExtensionIs;
      function fileExtensionIsOneOf(path2, extensions) {
        for (var _i = 0, extensions_1 = extensions; _i < extensions_1.length; _i++) {
          var extension = extensions_1[_i];
          if (fileExtensionIs(path2, extension)) {
            return true;
          }
        }
        return false;
      }
      ts3.fileExtensionIsOneOf = fileExtensionIsOneOf;
      function hasTrailingDirectorySeparator(path2) {
        return path2.length > 0 && isAnyDirectorySeparator(path2.charCodeAt(path2.length - 1));
      }
      ts3.hasTrailingDirectorySeparator = hasTrailingDirectorySeparator;
      function isVolumeCharacter(charCode) {
        return charCode >= 97 && charCode <= 122 || charCode >= 65 && charCode <= 90;
      }
      function getFileUrlVolumeSeparatorEnd(url, start) {
        var ch0 = url.charCodeAt(start);
        if (ch0 === 58)
          return start + 1;
        if (ch0 === 37 && url.charCodeAt(start + 1) === 51) {
          var ch2 = url.charCodeAt(start + 2);
          if (ch2 === 97 || ch2 === 65)
            return start + 3;
        }
        return -1;
      }
      function getEncodedRootLength(path2) {
        if (!path2)
          return 0;
        var ch0 = path2.charCodeAt(0);
        if (ch0 === 47 || ch0 === 92) {
          if (path2.charCodeAt(1) !== ch0)
            return 1;
          var p1 = path2.indexOf(ch0 === 47 ? ts3.directorySeparator : ts3.altDirectorySeparator, 2);
          if (p1 < 0)
            return path2.length;
          return p1 + 1;
        }
        if (isVolumeCharacter(ch0) && path2.charCodeAt(1) === 58) {
          var ch2 = path2.charCodeAt(2);
          if (ch2 === 47 || ch2 === 92)
            return 3;
          if (path2.length === 2)
            return 2;
        }
        var schemeEnd = path2.indexOf(urlSchemeSeparator);
        if (schemeEnd !== -1) {
          var authorityStart = schemeEnd + urlSchemeSeparator.length;
          var authorityEnd = path2.indexOf(ts3.directorySeparator, authorityStart);
          if (authorityEnd !== -1) {
            var scheme = path2.slice(0, schemeEnd);
            var authority = path2.slice(authorityStart, authorityEnd);
            if (scheme === "file" && (authority === "" || authority === "localhost") && isVolumeCharacter(path2.charCodeAt(authorityEnd + 1))) {
              var volumeSeparatorEnd = getFileUrlVolumeSeparatorEnd(path2, authorityEnd + 2);
              if (volumeSeparatorEnd !== -1) {
                if (path2.charCodeAt(volumeSeparatorEnd) === 47) {
                  return ~(volumeSeparatorEnd + 1);
                }
                if (volumeSeparatorEnd === path2.length) {
                  return ~volumeSeparatorEnd;
                }
              }
            }
            return ~(authorityEnd + 1);
          }
          return ~path2.length;
        }
        return 0;
      }
      function getRootLength(path2) {
        var rootLength = getEncodedRootLength(path2);
        return rootLength < 0 ? ~rootLength : rootLength;
      }
      ts3.getRootLength = getRootLength;
      function getDirectoryPath(path2) {
        path2 = normalizeSlashes(path2);
        var rootLength = getRootLength(path2);
        if (rootLength === path2.length)
          return path2;
        path2 = removeTrailingDirectorySeparator(path2);
        return path2.slice(0, Math.max(rootLength, path2.lastIndexOf(ts3.directorySeparator)));
      }
      ts3.getDirectoryPath = getDirectoryPath;
      function getBaseFileName(path2, extensions, ignoreCase) {
        path2 = normalizeSlashes(path2);
        var rootLength = getRootLength(path2);
        if (rootLength === path2.length)
          return "";
        path2 = removeTrailingDirectorySeparator(path2);
        var name = path2.slice(Math.max(getRootLength(path2), path2.lastIndexOf(ts3.directorySeparator) + 1));
        var extension = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(name, extensions, ignoreCase) : void 0;
        return extension ? name.slice(0, name.length - extension.length) : name;
      }
      ts3.getBaseFileName = getBaseFileName;
      function tryGetExtensionFromPath(path2, extension, stringEqualityComparer) {
        if (!ts3.startsWith(extension, "."))
          extension = "." + extension;
        if (path2.length >= extension.length && path2.charCodeAt(path2.length - extension.length) === 46) {
          var pathExtension = path2.slice(path2.length - extension.length);
          if (stringEqualityComparer(pathExtension, extension)) {
            return pathExtension;
          }
        }
      }
      function getAnyExtensionFromPathWorker(path2, extensions, stringEqualityComparer) {
        if (typeof extensions === "string") {
          return tryGetExtensionFromPath(path2, extensions, stringEqualityComparer) || "";
        }
        for (var _i = 0, extensions_2 = extensions; _i < extensions_2.length; _i++) {
          var extension = extensions_2[_i];
          var result2 = tryGetExtensionFromPath(path2, extension, stringEqualityComparer);
          if (result2)
            return result2;
        }
        return "";
      }
      function getAnyExtensionFromPath(path2, extensions, ignoreCase) {
        if (extensions) {
          return getAnyExtensionFromPathWorker(removeTrailingDirectorySeparator(path2), extensions, ignoreCase ? ts3.equateStringsCaseInsensitive : ts3.equateStringsCaseSensitive);
        }
        var baseFileName = getBaseFileName(path2);
        var extensionIndex = baseFileName.lastIndexOf(".");
        if (extensionIndex >= 0) {
          return baseFileName.substring(extensionIndex);
        }
        return "";
      }
      ts3.getAnyExtensionFromPath = getAnyExtensionFromPath;
      function pathComponents(path2, rootLength) {
        var root = path2.substring(0, rootLength);
        var rest = path2.substring(rootLength).split(ts3.directorySeparator);
        if (rest.length && !ts3.lastOrUndefined(rest))
          rest.pop();
        return __spreadArray([root], rest, true);
      }
      function getPathComponents(path2, currentDirectory) {
        if (currentDirectory === void 0) {
          currentDirectory = "";
        }
        path2 = combinePaths(currentDirectory, path2);
        return pathComponents(path2, getRootLength(path2));
      }
      ts3.getPathComponents = getPathComponents;
      function getPathFromPathComponents(pathComponents2) {
        if (pathComponents2.length === 0)
          return "";
        var root = pathComponents2[0] && ensureTrailingDirectorySeparator(pathComponents2[0]);
        return root + pathComponents2.slice(1).join(ts3.directorySeparator);
      }
      ts3.getPathFromPathComponents = getPathFromPathComponents;
      function normalizeSlashes(path2) {
        var index = path2.indexOf("\\");
        if (index === -1) {
          return path2;
        }
        backslashRegExp.lastIndex = index;
        return path2.replace(backslashRegExp, ts3.directorySeparator);
      }
      ts3.normalizeSlashes = normalizeSlashes;
      function reducePathComponents(components) {
        if (!ts3.some(components))
          return [];
        var reduced = [components[0]];
        for (var i = 1; i < components.length; i++) {
          var component = components[i];
          if (!component)
            continue;
          if (component === ".")
            continue;
          if (component === "..") {
            if (reduced.length > 1) {
              if (reduced[reduced.length - 1] !== "..") {
                reduced.pop();
                continue;
              }
            } else if (reduced[0])
              continue;
          }
          reduced.push(component);
        }
        return reduced;
      }
      ts3.reducePathComponents = reducePathComponents;
      function combinePaths(path2) {
        var paths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          paths[_i - 1] = arguments[_i];
        }
        if (path2)
          path2 = normalizeSlashes(path2);
        for (var _a = 0, paths_1 = paths; _a < paths_1.length; _a++) {
          var relativePath = paths_1[_a];
          if (!relativePath)
            continue;
          relativePath = normalizeSlashes(relativePath);
          if (!path2 || getRootLength(relativePath) !== 0) {
            path2 = relativePath;
          } else {
            path2 = ensureTrailingDirectorySeparator(path2) + relativePath;
          }
        }
        return path2;
      }
      ts3.combinePaths = combinePaths;
      function resolvePath(path2) {
        var paths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          paths[_i - 1] = arguments[_i];
        }
        return normalizePath(ts3.some(paths) ? combinePaths.apply(void 0, __spreadArray([path2], paths, false)) : normalizeSlashes(path2));
      }
      ts3.resolvePath = resolvePath;
      function getNormalizedPathComponents(path2, currentDirectory) {
        return reducePathComponents(getPathComponents(path2, currentDirectory));
      }
      ts3.getNormalizedPathComponents = getNormalizedPathComponents;
      function getNormalizedAbsolutePath(fileName2, currentDirectory) {
        return getPathFromPathComponents(getNormalizedPathComponents(fileName2, currentDirectory));
      }
      ts3.getNormalizedAbsolutePath = getNormalizedAbsolutePath;
      function normalizePath(path2) {
        path2 = normalizeSlashes(path2);
        if (!relativePathSegmentRegExp.test(path2)) {
          return path2;
        }
        var simplified = path2.replace(/\/\.\//g, "/").replace(/^\.\//, "");
        if (simplified !== path2) {
          path2 = simplified;
          if (!relativePathSegmentRegExp.test(path2)) {
            return path2;
          }
        }
        var normalized = getPathFromPathComponents(reducePathComponents(getPathComponents(path2)));
        return normalized && hasTrailingDirectorySeparator(path2) ? ensureTrailingDirectorySeparator(normalized) : normalized;
      }
      ts3.normalizePath = normalizePath;
      function getPathWithoutRoot(pathComponents2) {
        if (pathComponents2.length === 0)
          return "";
        return pathComponents2.slice(1).join(ts3.directorySeparator);
      }
      function getNormalizedAbsolutePathWithoutRoot(fileName2, currentDirectory) {
        return getPathWithoutRoot(getNormalizedPathComponents(fileName2, currentDirectory));
      }
      ts3.getNormalizedAbsolutePathWithoutRoot = getNormalizedAbsolutePathWithoutRoot;
      function toPath(fileName2, basePath, getCanonicalFileName) {
        var nonCanonicalizedPath = isRootedDiskPath(fileName2) ? normalizePath(fileName2) : getNormalizedAbsolutePath(fileName2, basePath);
        return getCanonicalFileName(nonCanonicalizedPath);
      }
      ts3.toPath = toPath;
      function removeTrailingDirectorySeparator(path2) {
        if (hasTrailingDirectorySeparator(path2)) {
          return path2.substr(0, path2.length - 1);
        }
        return path2;
      }
      ts3.removeTrailingDirectorySeparator = removeTrailingDirectorySeparator;
      function ensureTrailingDirectorySeparator(path2) {
        if (!hasTrailingDirectorySeparator(path2)) {
          return path2 + ts3.directorySeparator;
        }
        return path2;
      }
      ts3.ensureTrailingDirectorySeparator = ensureTrailingDirectorySeparator;
      function ensurePathIsNonModuleName(path2) {
        return !pathIsAbsolute(path2) && !pathIsRelative(path2) ? "./" + path2 : path2;
      }
      ts3.ensurePathIsNonModuleName = ensurePathIsNonModuleName;
      function changeAnyExtension(path2, ext, extensions, ignoreCase) {
        var pathext = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(path2, extensions, ignoreCase) : getAnyExtensionFromPath(path2);
        return pathext ? path2.slice(0, path2.length - pathext.length) + (ts3.startsWith(ext, ".") ? ext : "." + ext) : path2;
      }
      ts3.changeAnyExtension = changeAnyExtension;
      var relativePathSegmentRegExp = /(?:\/\/)|(?:^|\/)\.\.?(?:$|\/)/;
      function comparePathsWorker(a, b, componentComparer) {
        if (a === b)
          return 0;
        if (a === void 0)
          return -1;
        if (b === void 0)
          return 1;
        var aRoot = a.substring(0, getRootLength(a));
        var bRoot = b.substring(0, getRootLength(b));
        var result2 = ts3.compareStringsCaseInsensitive(aRoot, bRoot);
        if (result2 !== 0) {
          return result2;
        }
        var aRest = a.substring(aRoot.length);
        var bRest = b.substring(bRoot.length);
        if (!relativePathSegmentRegExp.test(aRest) && !relativePathSegmentRegExp.test(bRest)) {
          return componentComparer(aRest, bRest);
        }
        var aComponents = reducePathComponents(getPathComponents(a));
        var bComponents = reducePathComponents(getPathComponents(b));
        var sharedLength = Math.min(aComponents.length, bComponents.length);
        for (var i = 1; i < sharedLength; i++) {
          var result_2 = componentComparer(aComponents[i], bComponents[i]);
          if (result_2 !== 0) {
            return result_2;
          }
        }
        return ts3.compareValues(aComponents.length, bComponents.length);
      }
      function comparePathsCaseSensitive(a, b) {
        return comparePathsWorker(a, b, ts3.compareStringsCaseSensitive);
      }
      ts3.comparePathsCaseSensitive = comparePathsCaseSensitive;
      function comparePathsCaseInsensitive(a, b) {
        return comparePathsWorker(a, b, ts3.compareStringsCaseInsensitive);
      }
      ts3.comparePathsCaseInsensitive = comparePathsCaseInsensitive;
      function comparePaths(a, b, currentDirectory, ignoreCase) {
        if (typeof currentDirectory === "string") {
          a = combinePaths(currentDirectory, a);
          b = combinePaths(currentDirectory, b);
        } else if (typeof currentDirectory === "boolean") {
          ignoreCase = currentDirectory;
        }
        return comparePathsWorker(a, b, ts3.getStringComparer(ignoreCase));
      }
      ts3.comparePaths = comparePaths;
      function containsPath(parent, child, currentDirectory, ignoreCase) {
        if (typeof currentDirectory === "string") {
          parent = combinePaths(currentDirectory, parent);
          child = combinePaths(currentDirectory, child);
        } else if (typeof currentDirectory === "boolean") {
          ignoreCase = currentDirectory;
        }
        if (parent === void 0 || child === void 0)
          return false;
        if (parent === child)
          return true;
        var parentComponents = reducePathComponents(getPathComponents(parent));
        var childComponents = reducePathComponents(getPathComponents(child));
        if (childComponents.length < parentComponents.length) {
          return false;
        }
        var componentEqualityComparer = ignoreCase ? ts3.equateStringsCaseInsensitive : ts3.equateStringsCaseSensitive;
        for (var i = 0; i < parentComponents.length; i++) {
          var equalityComparer = i === 0 ? ts3.equateStringsCaseInsensitive : componentEqualityComparer;
          if (!equalityComparer(parentComponents[i], childComponents[i])) {
            return false;
          }
        }
        return true;
      }
      ts3.containsPath = containsPath;
      function startsWithDirectory(fileName2, directoryName, getCanonicalFileName) {
        var canonicalFileName = getCanonicalFileName(fileName2);
        var canonicalDirectoryName = getCanonicalFileName(directoryName);
        return ts3.startsWith(canonicalFileName, canonicalDirectoryName + "/") || ts3.startsWith(canonicalFileName, canonicalDirectoryName + "\\");
      }
      ts3.startsWithDirectory = startsWithDirectory;
      function getPathComponentsRelativeTo(from, to, stringEqualityComparer, getCanonicalFileName) {
        var fromComponents = reducePathComponents(getPathComponents(from));
        var toComponents = reducePathComponents(getPathComponents(to));
        var start;
        for (start = 0; start < fromComponents.length && start < toComponents.length; start++) {
          var fromComponent = getCanonicalFileName(fromComponents[start]);
          var toComponent = getCanonicalFileName(toComponents[start]);
          var comparer = start === 0 ? ts3.equateStringsCaseInsensitive : stringEqualityComparer;
          if (!comparer(fromComponent, toComponent))
            break;
        }
        if (start === 0) {
          return toComponents;
        }
        var components = toComponents.slice(start);
        var relative = [];
        for (; start < fromComponents.length; start++) {
          relative.push("..");
        }
        return __spreadArray(__spreadArray([""], relative, true), components, true);
      }
      ts3.getPathComponentsRelativeTo = getPathComponentsRelativeTo;
      function getRelativePathFromDirectory(fromDirectory, to, getCanonicalFileNameOrIgnoreCase) {
        ts3.Debug.assert(getRootLength(fromDirectory) > 0 === getRootLength(to) > 0, "Paths must either both be absolute or both be relative");
        var getCanonicalFileName = typeof getCanonicalFileNameOrIgnoreCase === "function" ? getCanonicalFileNameOrIgnoreCase : ts3.identity;
        var ignoreCase = typeof getCanonicalFileNameOrIgnoreCase === "boolean" ? getCanonicalFileNameOrIgnoreCase : false;
        var pathComponents2 = getPathComponentsRelativeTo(fromDirectory, to, ignoreCase ? ts3.equateStringsCaseInsensitive : ts3.equateStringsCaseSensitive, getCanonicalFileName);
        return getPathFromPathComponents(pathComponents2);
      }
      ts3.getRelativePathFromDirectory = getRelativePathFromDirectory;
      function convertToRelativePath(absoluteOrRelativePath, basePath, getCanonicalFileName) {
        return !isRootedDiskPath(absoluteOrRelativePath) ? absoluteOrRelativePath : getRelativePathToDirectoryOrUrl(basePath, absoluteOrRelativePath, basePath, getCanonicalFileName, false);
      }
      ts3.convertToRelativePath = convertToRelativePath;
      function getRelativePathFromFile(from, to, getCanonicalFileName) {
        return ensurePathIsNonModuleName(getRelativePathFromDirectory(getDirectoryPath(from), to, getCanonicalFileName));
      }
      ts3.getRelativePathFromFile = getRelativePathFromFile;
      function getRelativePathToDirectoryOrUrl(directoryPathOrUrl, relativeOrAbsolutePath, currentDirectory, getCanonicalFileName, isAbsolutePathAnUrl) {
        var pathComponents2 = getPathComponentsRelativeTo(resolvePath(currentDirectory, directoryPathOrUrl), resolvePath(currentDirectory, relativeOrAbsolutePath), ts3.equateStringsCaseSensitive, getCanonicalFileName);
        var firstComponent = pathComponents2[0];
        if (isAbsolutePathAnUrl && isRootedDiskPath(firstComponent)) {
          var prefix = firstComponent.charAt(0) === ts3.directorySeparator ? "file://" : "file:///";
          pathComponents2[0] = prefix + firstComponent;
        }
        return getPathFromPathComponents(pathComponents2);
      }
      ts3.getRelativePathToDirectoryOrUrl = getRelativePathToDirectoryOrUrl;
      function forEachAncestorDirectory(directory, callback) {
        while (true) {
          var result2 = callback(directory);
          if (result2 !== void 0) {
            return result2;
          }
          var parentPath = getDirectoryPath(directory);
          if (parentPath === directory) {
            return void 0;
          }
          directory = parentPath;
        }
      }
      ts3.forEachAncestorDirectory = forEachAncestorDirectory;
      function isNodeModulesDirectory(dirPath) {
        return ts3.endsWith(dirPath, "/node_modules");
      }
      ts3.isNodeModulesDirectory = isNodeModulesDirectory;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function diag(code, category, key, message, reportsUnnecessary, elidedInCompatabilityPyramid, reportsDeprecated) {
        return { code, category, key, message, reportsUnnecessary, elidedInCompatabilityPyramid, reportsDeprecated };
      }
      ts3.Diagnostics = {
        Unterminated_string_literal: diag(1002, ts3.DiagnosticCategory.Error, "Unterminated_string_literal_1002", "Unterminated string literal."),
        Identifier_expected: diag(1003, ts3.DiagnosticCategory.Error, "Identifier_expected_1003", "Identifier expected."),
        _0_expected: diag(1005, ts3.DiagnosticCategory.Error, "_0_expected_1005", "'{0}' expected."),
        A_file_cannot_have_a_reference_to_itself: diag(1006, ts3.DiagnosticCategory.Error, "A_file_cannot_have_a_reference_to_itself_1006", "A file cannot have a reference to itself."),
        The_parser_expected_to_find_a_1_to_match_the_0_token_here: diag(1007, ts3.DiagnosticCategory.Error, "The_parser_expected_to_find_a_1_to_match_the_0_token_here_1007", "The parser expected to find a '{1}' to match the '{0}' token here."),
        Trailing_comma_not_allowed: diag(1009, ts3.DiagnosticCategory.Error, "Trailing_comma_not_allowed_1009", "Trailing comma not allowed."),
        Asterisk_Slash_expected: diag(1010, ts3.DiagnosticCategory.Error, "Asterisk_Slash_expected_1010", "'*/' expected."),
        An_element_access_expression_should_take_an_argument: diag(1011, ts3.DiagnosticCategory.Error, "An_element_access_expression_should_take_an_argument_1011", "An element access expression should take an argument."),
        Unexpected_token: diag(1012, ts3.DiagnosticCategory.Error, "Unexpected_token_1012", "Unexpected token."),
        A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma: diag(1013, ts3.DiagnosticCategory.Error, "A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013", "A rest parameter or binding pattern may not have a trailing comma."),
        A_rest_parameter_must_be_last_in_a_parameter_list: diag(1014, ts3.DiagnosticCategory.Error, "A_rest_parameter_must_be_last_in_a_parameter_list_1014", "A rest parameter must be last in a parameter list."),
        Parameter_cannot_have_question_mark_and_initializer: diag(1015, ts3.DiagnosticCategory.Error, "Parameter_cannot_have_question_mark_and_initializer_1015", "Parameter cannot have question mark and initializer."),
        A_required_parameter_cannot_follow_an_optional_parameter: diag(1016, ts3.DiagnosticCategory.Error, "A_required_parameter_cannot_follow_an_optional_parameter_1016", "A required parameter cannot follow an optional parameter."),
        An_index_signature_cannot_have_a_rest_parameter: diag(1017, ts3.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_rest_parameter_1017", "An index signature cannot have a rest parameter."),
        An_index_signature_parameter_cannot_have_an_accessibility_modifier: diag(1018, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018", "An index signature parameter cannot have an accessibility modifier."),
        An_index_signature_parameter_cannot_have_a_question_mark: diag(1019, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_a_question_mark_1019", "An index signature parameter cannot have a question mark."),
        An_index_signature_parameter_cannot_have_an_initializer: diag(1020, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_initializer_1020", "An index signature parameter cannot have an initializer."),
        An_index_signature_must_have_a_type_annotation: diag(1021, ts3.DiagnosticCategory.Error, "An_index_signature_must_have_a_type_annotation_1021", "An index signature must have a type annotation."),
        An_index_signature_parameter_must_have_a_type_annotation: diag(1022, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_must_have_a_type_annotation_1022", "An index signature parameter must have a type annotation."),
        readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature: diag(1024, ts3.DiagnosticCategory.Error, "readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024", "'readonly' modifier can only appear on a property declaration or index signature."),
        An_index_signature_cannot_have_a_trailing_comma: diag(1025, ts3.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_trailing_comma_1025", "An index signature cannot have a trailing comma."),
        Accessibility_modifier_already_seen: diag(1028, ts3.DiagnosticCategory.Error, "Accessibility_modifier_already_seen_1028", "Accessibility modifier already seen."),
        _0_modifier_must_precede_1_modifier: diag(1029, ts3.DiagnosticCategory.Error, "_0_modifier_must_precede_1_modifier_1029", "'{0}' modifier must precede '{1}' modifier."),
        _0_modifier_already_seen: diag(1030, ts3.DiagnosticCategory.Error, "_0_modifier_already_seen_1030", "'{0}' modifier already seen."),
        _0_modifier_cannot_appear_on_class_elements_of_this_kind: diag(1031, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031", "'{0}' modifier cannot appear on class elements of this kind."),
        super_must_be_followed_by_an_argument_list_or_member_access: diag(1034, ts3.DiagnosticCategory.Error, "super_must_be_followed_by_an_argument_list_or_member_access_1034", "'super' must be followed by an argument list or member access."),
        Only_ambient_modules_can_use_quoted_names: diag(1035, ts3.DiagnosticCategory.Error, "Only_ambient_modules_can_use_quoted_names_1035", "Only ambient modules can use quoted names."),
        Statements_are_not_allowed_in_ambient_contexts: diag(1036, ts3.DiagnosticCategory.Error, "Statements_are_not_allowed_in_ambient_contexts_1036", "Statements are not allowed in ambient contexts."),
        A_declare_modifier_cannot_be_used_in_an_already_ambient_context: diag(1038, ts3.DiagnosticCategory.Error, "A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038", "A 'declare' modifier cannot be used in an already ambient context."),
        Initializers_are_not_allowed_in_ambient_contexts: diag(1039, ts3.DiagnosticCategory.Error, "Initializers_are_not_allowed_in_ambient_contexts_1039", "Initializers are not allowed in ambient contexts."),
        _0_modifier_cannot_be_used_in_an_ambient_context: diag(1040, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_in_an_ambient_context_1040", "'{0}' modifier cannot be used in an ambient context."),
        _0_modifier_cannot_be_used_here: diag(1042, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_here_1042", "'{0}' modifier cannot be used here."),
        _0_modifier_cannot_appear_on_a_module_or_namespace_element: diag(1044, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044", "'{0}' modifier cannot appear on a module or namespace element."),
        Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier: diag(1046, ts3.DiagnosticCategory.Error, "Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046", "Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),
        A_rest_parameter_cannot_be_optional: diag(1047, ts3.DiagnosticCategory.Error, "A_rest_parameter_cannot_be_optional_1047", "A rest parameter cannot be optional."),
        A_rest_parameter_cannot_have_an_initializer: diag(1048, ts3.DiagnosticCategory.Error, "A_rest_parameter_cannot_have_an_initializer_1048", "A rest parameter cannot have an initializer."),
        A_set_accessor_must_have_exactly_one_parameter: diag(1049, ts3.DiagnosticCategory.Error, "A_set_accessor_must_have_exactly_one_parameter_1049", "A 'set' accessor must have exactly one parameter."),
        A_set_accessor_cannot_have_an_optional_parameter: diag(1051, ts3.DiagnosticCategory.Error, "A_set_accessor_cannot_have_an_optional_parameter_1051", "A 'set' accessor cannot have an optional parameter."),
        A_set_accessor_parameter_cannot_have_an_initializer: diag(1052, ts3.DiagnosticCategory.Error, "A_set_accessor_parameter_cannot_have_an_initializer_1052", "A 'set' accessor parameter cannot have an initializer."),
        A_set_accessor_cannot_have_rest_parameter: diag(1053, ts3.DiagnosticCategory.Error, "A_set_accessor_cannot_have_rest_parameter_1053", "A 'set' accessor cannot have rest parameter."),
        A_get_accessor_cannot_have_parameters: diag(1054, ts3.DiagnosticCategory.Error, "A_get_accessor_cannot_have_parameters_1054", "A 'get' accessor cannot have parameters."),
        Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value: diag(1055, ts3.DiagnosticCategory.Error, "Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055", "Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),
        Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher: diag(1056, ts3.DiagnosticCategory.Error, "Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056", "Accessors are only available when targeting ECMAScript 5 and higher."),
        The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1058, ts3.DiagnosticCategory.Error, "The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058", "The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),
        A_promise_must_have_a_then_method: diag(1059, ts3.DiagnosticCategory.Error, "A_promise_must_have_a_then_method_1059", "A promise must have a 'then' method."),
        The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback: diag(1060, ts3.DiagnosticCategory.Error, "The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060", "The first parameter of the 'then' method of a promise must be a callback."),
        Enum_member_must_have_initializer: diag(1061, ts3.DiagnosticCategory.Error, "Enum_member_must_have_initializer_1061", "Enum member must have initializer."),
        Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method: diag(1062, ts3.DiagnosticCategory.Error, "Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062", "Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),
        An_export_assignment_cannot_be_used_in_a_namespace: diag(1063, ts3.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_namespace_1063", "An export assignment cannot be used in a namespace."),
        The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0: diag(1064, ts3.DiagnosticCategory.Error, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064", "The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"),
        In_ambient_enum_declarations_member_initializer_must_be_constant_expression: diag(1066, ts3.DiagnosticCategory.Error, "In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066", "In ambient enum declarations member initializer must be constant expression."),
        Unexpected_token_A_constructor_method_accessor_or_property_was_expected: diag(1068, ts3.DiagnosticCategory.Error, "Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068", "Unexpected token. A constructor, method, accessor, or property was expected."),
        Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces: diag(1069, ts3.DiagnosticCategory.Error, "Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069", "Unexpected token. A type parameter name was expected without curly braces."),
        _0_modifier_cannot_appear_on_a_type_member: diag(1070, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_member_1070", "'{0}' modifier cannot appear on a type member."),
        _0_modifier_cannot_appear_on_an_index_signature: diag(1071, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_an_index_signature_1071", "'{0}' modifier cannot appear on an index signature."),
        A_0_modifier_cannot_be_used_with_an_import_declaration: diag(1079, ts3.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_import_declaration_1079", "A '{0}' modifier cannot be used with an import declaration."),
        Invalid_reference_directive_syntax: diag(1084, ts3.DiagnosticCategory.Error, "Invalid_reference_directive_syntax_1084", "Invalid 'reference' directive syntax."),
        Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0: diag(1085, ts3.DiagnosticCategory.Error, "Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085", "Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."),
        _0_modifier_cannot_appear_on_a_constructor_declaration: diag(1089, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_constructor_declaration_1089", "'{0}' modifier cannot appear on a constructor declaration."),
        _0_modifier_cannot_appear_on_a_parameter: diag(1090, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_parameter_1090", "'{0}' modifier cannot appear on a parameter."),
        Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement: diag(1091, ts3.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091", "Only a single variable declaration is allowed in a 'for...in' statement."),
        Type_parameters_cannot_appear_on_a_constructor_declaration: diag(1092, ts3.DiagnosticCategory.Error, "Type_parameters_cannot_appear_on_a_constructor_declaration_1092", "Type parameters cannot appear on a constructor declaration."),
        Type_annotation_cannot_appear_on_a_constructor_declaration: diag(1093, ts3.DiagnosticCategory.Error, "Type_annotation_cannot_appear_on_a_constructor_declaration_1093", "Type annotation cannot appear on a constructor declaration."),
        An_accessor_cannot_have_type_parameters: diag(1094, ts3.DiagnosticCategory.Error, "An_accessor_cannot_have_type_parameters_1094", "An accessor cannot have type parameters."),
        A_set_accessor_cannot_have_a_return_type_annotation: diag(1095, ts3.DiagnosticCategory.Error, "A_set_accessor_cannot_have_a_return_type_annotation_1095", "A 'set' accessor cannot have a return type annotation."),
        An_index_signature_must_have_exactly_one_parameter: diag(1096, ts3.DiagnosticCategory.Error, "An_index_signature_must_have_exactly_one_parameter_1096", "An index signature must have exactly one parameter."),
        _0_list_cannot_be_empty: diag(1097, ts3.DiagnosticCategory.Error, "_0_list_cannot_be_empty_1097", "'{0}' list cannot be empty."),
        Type_parameter_list_cannot_be_empty: diag(1098, ts3.DiagnosticCategory.Error, "Type_parameter_list_cannot_be_empty_1098", "Type parameter list cannot be empty."),
        Type_argument_list_cannot_be_empty: diag(1099, ts3.DiagnosticCategory.Error, "Type_argument_list_cannot_be_empty_1099", "Type argument list cannot be empty."),
        Invalid_use_of_0_in_strict_mode: diag(1100, ts3.DiagnosticCategory.Error, "Invalid_use_of_0_in_strict_mode_1100", "Invalid use of '{0}' in strict mode."),
        with_statements_are_not_allowed_in_strict_mode: diag(1101, ts3.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_strict_mode_1101", "'with' statements are not allowed in strict mode."),
        delete_cannot_be_called_on_an_identifier_in_strict_mode: diag(1102, ts3.DiagnosticCategory.Error, "delete_cannot_be_called_on_an_identifier_in_strict_mode_1102", "'delete' cannot be called on an identifier in strict mode."),
        for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1103, ts3.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103", "'for await' loops are only allowed within async functions and at the top levels of modules."),
        A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement: diag(1104, ts3.DiagnosticCategory.Error, "A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104", "A 'continue' statement can only be used within an enclosing iteration statement."),
        A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement: diag(1105, ts3.DiagnosticCategory.Error, "A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105", "A 'break' statement can only be used within an enclosing iteration or switch statement."),
        The_left_hand_side_of_a_for_of_statement_may_not_be_async: diag(1106, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_async_1106", "The left-hand side of a 'for...of' statement may not be 'async'."),
        Jump_target_cannot_cross_function_boundary: diag(1107, ts3.DiagnosticCategory.Error, "Jump_target_cannot_cross_function_boundary_1107", "Jump target cannot cross function boundary."),
        A_return_statement_can_only_be_used_within_a_function_body: diag(1108, ts3.DiagnosticCategory.Error, "A_return_statement_can_only_be_used_within_a_function_body_1108", "A 'return' statement can only be used within a function body."),
        Expression_expected: diag(1109, ts3.DiagnosticCategory.Error, "Expression_expected_1109", "Expression expected."),
        Type_expected: diag(1110, ts3.DiagnosticCategory.Error, "Type_expected_1110", "Type expected."),
        A_default_clause_cannot_appear_more_than_once_in_a_switch_statement: diag(1113, ts3.DiagnosticCategory.Error, "A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113", "A 'default' clause cannot appear more than once in a 'switch' statement."),
        Duplicate_label_0: diag(1114, ts3.DiagnosticCategory.Error, "Duplicate_label_0_1114", "Duplicate label '{0}'."),
        A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement: diag(1115, ts3.DiagnosticCategory.Error, "A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115", "A 'continue' statement can only jump to a label of an enclosing iteration statement."),
        A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement: diag(1116, ts3.DiagnosticCategory.Error, "A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116", "A 'break' statement can only jump to a label of an enclosing statement."),
        An_object_literal_cannot_have_multiple_properties_with_the_same_name: diag(1117, ts3.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_properties_with_the_same_name_1117", "An object literal cannot have multiple properties with the same name."),
        An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name: diag(1118, ts3.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118", "An object literal cannot have multiple get/set accessors with the same name."),
        An_object_literal_cannot_have_property_and_accessor_with_the_same_name: diag(1119, ts3.DiagnosticCategory.Error, "An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119", "An object literal cannot have property and accessor with the same name."),
        An_export_assignment_cannot_have_modifiers: diag(1120, ts3.DiagnosticCategory.Error, "An_export_assignment_cannot_have_modifiers_1120", "An export assignment cannot have modifiers."),
        Octal_literals_are_not_allowed_in_strict_mode: diag(1121, ts3.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_strict_mode_1121", "Octal literals are not allowed in strict mode."),
        Variable_declaration_list_cannot_be_empty: diag(1123, ts3.DiagnosticCategory.Error, "Variable_declaration_list_cannot_be_empty_1123", "Variable declaration list cannot be empty."),
        Digit_expected: diag(1124, ts3.DiagnosticCategory.Error, "Digit_expected_1124", "Digit expected."),
        Hexadecimal_digit_expected: diag(1125, ts3.DiagnosticCategory.Error, "Hexadecimal_digit_expected_1125", "Hexadecimal digit expected."),
        Unexpected_end_of_text: diag(1126, ts3.DiagnosticCategory.Error, "Unexpected_end_of_text_1126", "Unexpected end of text."),
        Invalid_character: diag(1127, ts3.DiagnosticCategory.Error, "Invalid_character_1127", "Invalid character."),
        Declaration_or_statement_expected: diag(1128, ts3.DiagnosticCategory.Error, "Declaration_or_statement_expected_1128", "Declaration or statement expected."),
        Statement_expected: diag(1129, ts3.DiagnosticCategory.Error, "Statement_expected_1129", "Statement expected."),
        case_or_default_expected: diag(1130, ts3.DiagnosticCategory.Error, "case_or_default_expected_1130", "'case' or 'default' expected."),
        Property_or_signature_expected: diag(1131, ts3.DiagnosticCategory.Error, "Property_or_signature_expected_1131", "Property or signature expected."),
        Enum_member_expected: diag(1132, ts3.DiagnosticCategory.Error, "Enum_member_expected_1132", "Enum member expected."),
        Variable_declaration_expected: diag(1134, ts3.DiagnosticCategory.Error, "Variable_declaration_expected_1134", "Variable declaration expected."),
        Argument_expression_expected: diag(1135, ts3.DiagnosticCategory.Error, "Argument_expression_expected_1135", "Argument expression expected."),
        Property_assignment_expected: diag(1136, ts3.DiagnosticCategory.Error, "Property_assignment_expected_1136", "Property assignment expected."),
        Expression_or_comma_expected: diag(1137, ts3.DiagnosticCategory.Error, "Expression_or_comma_expected_1137", "Expression or comma expected."),
        Parameter_declaration_expected: diag(1138, ts3.DiagnosticCategory.Error, "Parameter_declaration_expected_1138", "Parameter declaration expected."),
        Type_parameter_declaration_expected: diag(1139, ts3.DiagnosticCategory.Error, "Type_parameter_declaration_expected_1139", "Type parameter declaration expected."),
        Type_argument_expected: diag(1140, ts3.DiagnosticCategory.Error, "Type_argument_expected_1140", "Type argument expected."),
        String_literal_expected: diag(1141, ts3.DiagnosticCategory.Error, "String_literal_expected_1141", "String literal expected."),
        Line_break_not_permitted_here: diag(1142, ts3.DiagnosticCategory.Error, "Line_break_not_permitted_here_1142", "Line break not permitted here."),
        or_expected: diag(1144, ts3.DiagnosticCategory.Error, "or_expected_1144", "'{' or ';' expected."),
        Declaration_expected: diag(1146, ts3.DiagnosticCategory.Error, "Declaration_expected_1146", "Declaration expected."),
        Import_declarations_in_a_namespace_cannot_reference_a_module: diag(1147, ts3.DiagnosticCategory.Error, "Import_declarations_in_a_namespace_cannot_reference_a_module_1147", "Import declarations in a namespace cannot reference a module."),
        Cannot_use_imports_exports_or_module_augmentations_when_module_is_none: diag(1148, ts3.DiagnosticCategory.Error, "Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148", "Cannot use imports, exports, or module augmentations when '--module' is 'none'."),
        File_name_0_differs_from_already_included_file_name_1_only_in_casing: diag(1149, ts3.DiagnosticCategory.Error, "File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149", "File name '{0}' differs from already included file name '{1}' only in casing."),
        const_declarations_must_be_initialized: diag(1155, ts3.DiagnosticCategory.Error, "const_declarations_must_be_initialized_1155", "'const' declarations must be initialized."),
        const_declarations_can_only_be_declared_inside_a_block: diag(1156, ts3.DiagnosticCategory.Error, "const_declarations_can_only_be_declared_inside_a_block_1156", "'const' declarations can only be declared inside a block."),
        let_declarations_can_only_be_declared_inside_a_block: diag(1157, ts3.DiagnosticCategory.Error, "let_declarations_can_only_be_declared_inside_a_block_1157", "'let' declarations can only be declared inside a block."),
        Unterminated_template_literal: diag(1160, ts3.DiagnosticCategory.Error, "Unterminated_template_literal_1160", "Unterminated template literal."),
        Unterminated_regular_expression_literal: diag(1161, ts3.DiagnosticCategory.Error, "Unterminated_regular_expression_literal_1161", "Unterminated regular expression literal."),
        An_object_member_cannot_be_declared_optional: diag(1162, ts3.DiagnosticCategory.Error, "An_object_member_cannot_be_declared_optional_1162", "An object member cannot be declared optional."),
        A_yield_expression_is_only_allowed_in_a_generator_body: diag(1163, ts3.DiagnosticCategory.Error, "A_yield_expression_is_only_allowed_in_a_generator_body_1163", "A 'yield' expression is only allowed in a generator body."),
        Computed_property_names_are_not_allowed_in_enums: diag(1164, ts3.DiagnosticCategory.Error, "Computed_property_names_are_not_allowed_in_enums_1164", "Computed property names are not allowed in enums."),
        A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1165, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165", "A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type: diag(1166, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166", "A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1168, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168", "A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1169, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169", "A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1170, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170", "A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_comma_expression_is_not_allowed_in_a_computed_property_name: diag(1171, ts3.DiagnosticCategory.Error, "A_comma_expression_is_not_allowed_in_a_computed_property_name_1171", "A comma expression is not allowed in a computed property name."),
        extends_clause_already_seen: diag(1172, ts3.DiagnosticCategory.Error, "extends_clause_already_seen_1172", "'extends' clause already seen."),
        extends_clause_must_precede_implements_clause: diag(1173, ts3.DiagnosticCategory.Error, "extends_clause_must_precede_implements_clause_1173", "'extends' clause must precede 'implements' clause."),
        Classes_can_only_extend_a_single_class: diag(1174, ts3.DiagnosticCategory.Error, "Classes_can_only_extend_a_single_class_1174", "Classes can only extend a single class."),
        implements_clause_already_seen: diag(1175, ts3.DiagnosticCategory.Error, "implements_clause_already_seen_1175", "'implements' clause already seen."),
        Interface_declaration_cannot_have_implements_clause: diag(1176, ts3.DiagnosticCategory.Error, "Interface_declaration_cannot_have_implements_clause_1176", "Interface declaration cannot have 'implements' clause."),
        Binary_digit_expected: diag(1177, ts3.DiagnosticCategory.Error, "Binary_digit_expected_1177", "Binary digit expected."),
        Octal_digit_expected: diag(1178, ts3.DiagnosticCategory.Error, "Octal_digit_expected_1178", "Octal digit expected."),
        Unexpected_token_expected: diag(1179, ts3.DiagnosticCategory.Error, "Unexpected_token_expected_1179", "Unexpected token. '{' expected."),
        Property_destructuring_pattern_expected: diag(1180, ts3.DiagnosticCategory.Error, "Property_destructuring_pattern_expected_1180", "Property destructuring pattern expected."),
        Array_element_destructuring_pattern_expected: diag(1181, ts3.DiagnosticCategory.Error, "Array_element_destructuring_pattern_expected_1181", "Array element destructuring pattern expected."),
        A_destructuring_declaration_must_have_an_initializer: diag(1182, ts3.DiagnosticCategory.Error, "A_destructuring_declaration_must_have_an_initializer_1182", "A destructuring declaration must have an initializer."),
        An_implementation_cannot_be_declared_in_ambient_contexts: diag(1183, ts3.DiagnosticCategory.Error, "An_implementation_cannot_be_declared_in_ambient_contexts_1183", "An implementation cannot be declared in ambient contexts."),
        Modifiers_cannot_appear_here: diag(1184, ts3.DiagnosticCategory.Error, "Modifiers_cannot_appear_here_1184", "Modifiers cannot appear here."),
        Merge_conflict_marker_encountered: diag(1185, ts3.DiagnosticCategory.Error, "Merge_conflict_marker_encountered_1185", "Merge conflict marker encountered."),
        A_rest_element_cannot_have_an_initializer: diag(1186, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_have_an_initializer_1186", "A rest element cannot have an initializer."),
        A_parameter_property_may_not_be_declared_using_a_binding_pattern: diag(1187, ts3.DiagnosticCategory.Error, "A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187", "A parameter property may not be declared using a binding pattern."),
        Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement: diag(1188, ts3.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188", "Only a single variable declaration is allowed in a 'for...of' statement."),
        The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer: diag(1189, ts3.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189", "The variable declaration of a 'for...in' statement cannot have an initializer."),
        The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer: diag(1190, ts3.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190", "The variable declaration of a 'for...of' statement cannot have an initializer."),
        An_import_declaration_cannot_have_modifiers: diag(1191, ts3.DiagnosticCategory.Error, "An_import_declaration_cannot_have_modifiers_1191", "An import declaration cannot have modifiers."),
        Module_0_has_no_default_export: diag(1192, ts3.DiagnosticCategory.Error, "Module_0_has_no_default_export_1192", "Module '{0}' has no default export."),
        An_export_declaration_cannot_have_modifiers: diag(1193, ts3.DiagnosticCategory.Error, "An_export_declaration_cannot_have_modifiers_1193", "An export declaration cannot have modifiers."),
        Export_declarations_are_not_permitted_in_a_namespace: diag(1194, ts3.DiagnosticCategory.Error, "Export_declarations_are_not_permitted_in_a_namespace_1194", "Export declarations are not permitted in a namespace."),
        export_Asterisk_does_not_re_export_a_default: diag(1195, ts3.DiagnosticCategory.Error, "export_Asterisk_does_not_re_export_a_default_1195", "'export *' does not re-export a default."),
        Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified: diag(1196, ts3.DiagnosticCategory.Error, "Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196", "Catch clause variable type annotation must be 'any' or 'unknown' if specified."),
        Catch_clause_variable_cannot_have_an_initializer: diag(1197, ts3.DiagnosticCategory.Error, "Catch_clause_variable_cannot_have_an_initializer_1197", "Catch clause variable cannot have an initializer."),
        An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive: diag(1198, ts3.DiagnosticCategory.Error, "An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198", "An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),
        Unterminated_Unicode_escape_sequence: diag(1199, ts3.DiagnosticCategory.Error, "Unterminated_Unicode_escape_sequence_1199", "Unterminated Unicode escape sequence."),
        Line_terminator_not_permitted_before_arrow: diag(1200, ts3.DiagnosticCategory.Error, "Line_terminator_not_permitted_before_arrow_1200", "Line terminator not permitted before arrow."),
        Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead: diag(1202, ts3.DiagnosticCategory.Error, "Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202", `Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`),
        Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead: diag(1203, ts3.DiagnosticCategory.Error, "Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203", "Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),
        Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type: diag(1205, ts3.DiagnosticCategory.Error, "Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type_1205", "Re-exporting a type when the '--isolatedModules' flag is provided requires using 'export type'."),
        Decorators_are_not_valid_here: diag(1206, ts3.DiagnosticCategory.Error, "Decorators_are_not_valid_here_1206", "Decorators are not valid here."),
        Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name: diag(1207, ts3.DiagnosticCategory.Error, "Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207", "Decorators cannot be applied to multiple get/set accessors of the same name."),
        _0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module: diag(1208, ts3.DiagnosticCategory.Error, "_0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_imp_1208", "'{0}' cannot be compiled under '--isolatedModules' because it is considered a global script file. Add an import, export, or an empty 'export {}' statement to make it a module."),
        Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode: diag(1210, ts3.DiagnosticCategory.Error, "Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of__1210", "Code contained in a class is evaluated in JavaScript's strict mode which does not allow this use of '{0}'. For more information, see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Strict_mode."),
        A_class_declaration_without_the_default_modifier_must_have_a_name: diag(1211, ts3.DiagnosticCategory.Error, "A_class_declaration_without_the_default_modifier_must_have_a_name_1211", "A class declaration without the 'default' modifier must have a name."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode: diag(1212, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212", "Identifier expected. '{0}' is a reserved word in strict mode."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode: diag(1213, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213", "Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode: diag(1214, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214", "Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),
        Invalid_use_of_0_Modules_are_automatically_in_strict_mode: diag(1215, ts3.DiagnosticCategory.Error, "Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215", "Invalid use of '{0}'. Modules are automatically in strict mode."),
        Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules: diag(1216, ts3.DiagnosticCategory.Error, "Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216", "Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),
        Export_assignment_is_not_supported_when_module_flag_is_system: diag(1218, ts3.DiagnosticCategory.Error, "Export_assignment_is_not_supported_when_module_flag_is_system_1218", "Export assignment is not supported when '--module' flag is 'system'."),
        Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning: diag(1219, ts3.DiagnosticCategory.Error, "Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219", "Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option in your 'tsconfig' or 'jsconfig' to remove this warning."),
        Generators_are_not_allowed_in_an_ambient_context: diag(1221, ts3.DiagnosticCategory.Error, "Generators_are_not_allowed_in_an_ambient_context_1221", "Generators are not allowed in an ambient context."),
        An_overload_signature_cannot_be_declared_as_a_generator: diag(1222, ts3.DiagnosticCategory.Error, "An_overload_signature_cannot_be_declared_as_a_generator_1222", "An overload signature cannot be declared as a generator."),
        _0_tag_already_specified: diag(1223, ts3.DiagnosticCategory.Error, "_0_tag_already_specified_1223", "'{0}' tag already specified."),
        Signature_0_must_be_a_type_predicate: diag(1224, ts3.DiagnosticCategory.Error, "Signature_0_must_be_a_type_predicate_1224", "Signature '{0}' must be a type predicate."),
        Cannot_find_parameter_0: diag(1225, ts3.DiagnosticCategory.Error, "Cannot_find_parameter_0_1225", "Cannot find parameter '{0}'."),
        Type_predicate_0_is_not_assignable_to_1: diag(1226, ts3.DiagnosticCategory.Error, "Type_predicate_0_is_not_assignable_to_1_1226", "Type predicate '{0}' is not assignable to '{1}'."),
        Parameter_0_is_not_in_the_same_position_as_parameter_1: diag(1227, ts3.DiagnosticCategory.Error, "Parameter_0_is_not_in_the_same_position_as_parameter_1_1227", "Parameter '{0}' is not in the same position as parameter '{1}'."),
        A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods: diag(1228, ts3.DiagnosticCategory.Error, "A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228", "A type predicate is only allowed in return type position for functions and methods."),
        A_type_predicate_cannot_reference_a_rest_parameter: diag(1229, ts3.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_a_rest_parameter_1229", "A type predicate cannot reference a rest parameter."),
        A_type_predicate_cannot_reference_element_0_in_a_binding_pattern: diag(1230, ts3.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230", "A type predicate cannot reference element '{0}' in a binding pattern."),
        An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration: diag(1231, ts3.DiagnosticCategory.Error, "An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231", "An export assignment must be at the top level of a file or module declaration."),
        An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: diag(1232, ts3.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1232", "An import declaration can only be used at the top level of a namespace or module."),
        An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: diag(1233, ts3.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1233", "An export declaration can only be used at the top level of a namespace or module."),
        An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file: diag(1234, ts3.DiagnosticCategory.Error, "An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234", "An ambient module declaration is only allowed at the top level in a file."),
        A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module: diag(1235, ts3.DiagnosticCategory.Error, "A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module_1235", "A namespace declaration is only allowed at the top level of a namespace or module."),
        The_return_type_of_a_property_decorator_function_must_be_either_void_or_any: diag(1236, ts3.DiagnosticCategory.Error, "The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236", "The return type of a property decorator function must be either 'void' or 'any'."),
        The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any: diag(1237, ts3.DiagnosticCategory.Error, "The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237", "The return type of a parameter decorator function must be either 'void' or 'any'."),
        Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression: diag(1238, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238", "Unable to resolve signature of class decorator when called as an expression."),
        Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression: diag(1239, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239", "Unable to resolve signature of parameter decorator when called as an expression."),
        Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression: diag(1240, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240", "Unable to resolve signature of property decorator when called as an expression."),
        Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression: diag(1241, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241", "Unable to resolve signature of method decorator when called as an expression."),
        abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration: diag(1242, ts3.DiagnosticCategory.Error, "abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242", "'abstract' modifier can only appear on a class, method, or property declaration."),
        _0_modifier_cannot_be_used_with_1_modifier: diag(1243, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_1_modifier_1243", "'{0}' modifier cannot be used with '{1}' modifier."),
        Abstract_methods_can_only_appear_within_an_abstract_class: diag(1244, ts3.DiagnosticCategory.Error, "Abstract_methods_can_only_appear_within_an_abstract_class_1244", "Abstract methods can only appear within an abstract class."),
        Method_0_cannot_have_an_implementation_because_it_is_marked_abstract: diag(1245, ts3.DiagnosticCategory.Error, "Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245", "Method '{0}' cannot have an implementation because it is marked abstract."),
        An_interface_property_cannot_have_an_initializer: diag(1246, ts3.DiagnosticCategory.Error, "An_interface_property_cannot_have_an_initializer_1246", "An interface property cannot have an initializer."),
        A_type_literal_property_cannot_have_an_initializer: diag(1247, ts3.DiagnosticCategory.Error, "A_type_literal_property_cannot_have_an_initializer_1247", "A type literal property cannot have an initializer."),
        A_class_member_cannot_have_the_0_keyword: diag(1248, ts3.DiagnosticCategory.Error, "A_class_member_cannot_have_the_0_keyword_1248", "A class member cannot have the '{0}' keyword."),
        A_decorator_can_only_decorate_a_method_implementation_not_an_overload: diag(1249, ts3.DiagnosticCategory.Error, "A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249", "A decorator can only decorate a method implementation, not an overload."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5: diag(1250, ts3.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode: diag(1251, ts3.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode: diag(1252, ts3.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),
        A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference: diag(1254, ts3.DiagnosticCategory.Error, "A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254", "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),
        A_definite_assignment_assertion_is_not_permitted_in_this_context: diag(1255, ts3.DiagnosticCategory.Error, "A_definite_assignment_assertion_is_not_permitted_in_this_context_1255", "A definite assignment assertion '!' is not permitted in this context."),
        A_required_element_cannot_follow_an_optional_element: diag(1257, ts3.DiagnosticCategory.Error, "A_required_element_cannot_follow_an_optional_element_1257", "A required element cannot follow an optional element."),
        A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration: diag(1258, ts3.DiagnosticCategory.Error, "A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258", "A default export must be at the top level of a file or module declaration."),
        Module_0_can_only_be_default_imported_using_the_1_flag: diag(1259, ts3.DiagnosticCategory.Error, "Module_0_can_only_be_default_imported_using_the_1_flag_1259", "Module '{0}' can only be default-imported using the '{1}' flag"),
        Keywords_cannot_contain_escape_characters: diag(1260, ts3.DiagnosticCategory.Error, "Keywords_cannot_contain_escape_characters_1260", "Keywords cannot contain escape characters."),
        Already_included_file_name_0_differs_from_file_name_1_only_in_casing: diag(1261, ts3.DiagnosticCategory.Error, "Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261", "Already included file name '{0}' differs from file name '{1}' only in casing."),
        Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module: diag(1262, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262", "Identifier expected. '{0}' is a reserved word at the top-level of a module."),
        Declarations_with_initializers_cannot_also_have_definite_assignment_assertions: diag(1263, ts3.DiagnosticCategory.Error, "Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263", "Declarations with initializers cannot also have definite assignment assertions."),
        Declarations_with_definite_assignment_assertions_must_also_have_type_annotations: diag(1264, ts3.DiagnosticCategory.Error, "Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264", "Declarations with definite assignment assertions must also have type annotations."),
        A_rest_element_cannot_follow_another_rest_element: diag(1265, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_follow_another_rest_element_1265", "A rest element cannot follow another rest element."),
        An_optional_element_cannot_follow_a_rest_element: diag(1266, ts3.DiagnosticCategory.Error, "An_optional_element_cannot_follow_a_rest_element_1266", "An optional element cannot follow a rest element."),
        Property_0_cannot_have_an_initializer_because_it_is_marked_abstract: diag(1267, ts3.DiagnosticCategory.Error, "Property_0_cannot_have_an_initializer_because_it_is_marked_abstract_1267", "Property '{0}' cannot have an initializer because it is marked abstract."),
        An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type: diag(1268, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type_1268", "An index signature parameter type must be 'string', 'number', 'symbol', or a template literal type."),
        Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided: diag(1269, ts3.DiagnosticCategory.Error, "Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided_1269", "Cannot use 'export import' on a type or type-only namespace when the '--isolatedModules' flag is provided."),
        Decorator_function_return_type_0_is_not_assignable_to_type_1: diag(1270, ts3.DiagnosticCategory.Error, "Decorator_function_return_type_0_is_not_assignable_to_type_1_1270", "Decorator function return type '{0}' is not assignable to type '{1}'."),
        Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any: diag(1271, ts3.DiagnosticCategory.Error, "Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any_1271", "Decorator function return type is '{0}' but is expected to be 'void' or 'any'."),
        A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled: diag(1272, ts3.DiagnosticCategory.Error, "A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_w_1272", "A type referenced in a decorated signature must be imported with 'import type' or a namespace import when 'isolatedModules' and 'emitDecoratorMetadata' are enabled."),
        _0_modifier_cannot_appear_on_a_type_parameter: diag(1273, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_parameter_1273", "'{0}' modifier cannot appear on a type parameter"),
        _0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias: diag(1274, ts3.DiagnosticCategory.Error, "_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias_1274", "'{0}' modifier can only appear on a type parameter of a class, interface or type alias"),
        with_statements_are_not_allowed_in_an_async_function_block: diag(1300, ts3.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_an_async_function_block_1300", "'with' statements are not allowed in an async function block."),
        await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1308, ts3.DiagnosticCategory.Error, "await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308", "'await' expressions are only allowed within async functions and at the top levels of modules."),
        The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level: diag(1309, ts3.DiagnosticCategory.Error, "The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level_1309", "The current file is a CommonJS module and cannot use 'await' at the top level."),
        Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern: diag(1312, ts3.DiagnosticCategory.Error, "Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312", "Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."),
        The_body_of_an_if_statement_cannot_be_the_empty_statement: diag(1313, ts3.DiagnosticCategory.Error, "The_body_of_an_if_statement_cannot_be_the_empty_statement_1313", "The body of an 'if' statement cannot be the empty statement."),
        Global_module_exports_may_only_appear_in_module_files: diag(1314, ts3.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_module_files_1314", "Global module exports may only appear in module files."),
        Global_module_exports_may_only_appear_in_declaration_files: diag(1315, ts3.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_declaration_files_1315", "Global module exports may only appear in declaration files."),
        Global_module_exports_may_only_appear_at_top_level: diag(1316, ts3.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_at_top_level_1316", "Global module exports may only appear at top level."),
        A_parameter_property_cannot_be_declared_using_a_rest_parameter: diag(1317, ts3.DiagnosticCategory.Error, "A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317", "A parameter property cannot be declared using a rest parameter."),
        An_abstract_accessor_cannot_have_an_implementation: diag(1318, ts3.DiagnosticCategory.Error, "An_abstract_accessor_cannot_have_an_implementation_1318", "An abstract accessor cannot have an implementation."),
        A_default_export_can_only_be_used_in_an_ECMAScript_style_module: diag(1319, ts3.DiagnosticCategory.Error, "A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319", "A default export can only be used in an ECMAScript-style module."),
        Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1320, ts3.DiagnosticCategory.Error, "Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320", "Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),
        Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1321, ts3.DiagnosticCategory.Error, "Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321", "Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),
        Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1322, ts3.DiagnosticCategory.Error, "Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322", "Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),
        Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext: diag(1323, ts3.DiagnosticCategory.Error, "Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd__1323", "Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'es2022', 'esnext', 'commonjs', 'amd', 'system', 'umd', 'node16', or 'nodenext'."),
        Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext: diag(1324, ts3.DiagnosticCategory.Error, "Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nod_1324", "Dynamic imports only support a second argument when the '--module' option is set to 'esnext', 'node16', or 'nodenext'."),
        Argument_of_dynamic_import_cannot_be_spread_element: diag(1325, ts3.DiagnosticCategory.Error, "Argument_of_dynamic_import_cannot_be_spread_element_1325", "Argument of dynamic import cannot be spread element."),
        This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments: diag(1326, ts3.DiagnosticCategory.Error, "This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot__1326", "This use of 'import' is invalid. 'import()' calls can be written, but they must have parentheses and cannot have type arguments."),
        String_literal_with_double_quotes_expected: diag(1327, ts3.DiagnosticCategory.Error, "String_literal_with_double_quotes_expected_1327", "String literal with double quotes expected."),
        Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal: diag(1328, ts3.DiagnosticCategory.Error, "Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328", "Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),
        _0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0: diag(1329, ts3.DiagnosticCategory.Error, "_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329", "'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),
        A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly: diag(1330, ts3.DiagnosticCategory.Error, "A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330", "A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),
        A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly: diag(1331, ts3.DiagnosticCategory.Error, "A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331", "A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),
        A_variable_whose_type_is_a_unique_symbol_type_must_be_const: diag(1332, ts3.DiagnosticCategory.Error, "A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332", "A variable whose type is a 'unique symbol' type must be 'const'."),
        unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name: diag(1333, ts3.DiagnosticCategory.Error, "unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333", "'unique symbol' types may not be used on a variable declaration with a binding name."),
        unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement: diag(1334, ts3.DiagnosticCategory.Error, "unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334", "'unique symbol' types are only allowed on variables in a variable statement."),
        unique_symbol_types_are_not_allowed_here: diag(1335, ts3.DiagnosticCategory.Error, "unique_symbol_types_are_not_allowed_here_1335", "'unique symbol' types are not allowed here."),
        An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead: diag(1337, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_o_1337", "An index signature parameter type cannot be a literal type or generic type. Consider using a mapped object type instead."),
        infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type: diag(1338, ts3.DiagnosticCategory.Error, "infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338", "'infer' declarations are only permitted in the 'extends' clause of a conditional type."),
        Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here: diag(1339, ts3.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339", "Module '{0}' does not refer to a value, but is used as a value here."),
        Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0: diag(1340, ts3.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340", "Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),
        Type_arguments_cannot_be_used_here: diag(1342, ts3.DiagnosticCategory.Error, "Type_arguments_cannot_be_used_here_1342", "Type arguments cannot be used here."),
        The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext: diag(1343, ts3.DiagnosticCategory.Error, "The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system__1343", "The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'es2022', 'esnext', 'system', 'node16', or 'nodenext'."),
        A_label_is_not_allowed_here: diag(1344, ts3.DiagnosticCategory.Error, "A_label_is_not_allowed_here_1344", "'A label is not allowed here."),
        An_expression_of_type_void_cannot_be_tested_for_truthiness: diag(1345, ts3.DiagnosticCategory.Error, "An_expression_of_type_void_cannot_be_tested_for_truthiness_1345", "An expression of type 'void' cannot be tested for truthiness."),
        This_parameter_is_not_allowed_with_use_strict_directive: diag(1346, ts3.DiagnosticCategory.Error, "This_parameter_is_not_allowed_with_use_strict_directive_1346", "This parameter is not allowed with 'use strict' directive."),
        use_strict_directive_cannot_be_used_with_non_simple_parameter_list: diag(1347, ts3.DiagnosticCategory.Error, "use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347", "'use strict' directive cannot be used with non-simple parameter list."),
        Non_simple_parameter_declared_here: diag(1348, ts3.DiagnosticCategory.Error, "Non_simple_parameter_declared_here_1348", "Non-simple parameter declared here."),
        use_strict_directive_used_here: diag(1349, ts3.DiagnosticCategory.Error, "use_strict_directive_used_here_1349", "'use strict' directive used here."),
        Print_the_final_configuration_instead_of_building: diag(1350, ts3.DiagnosticCategory.Message, "Print_the_final_configuration_instead_of_building_1350", "Print the final configuration instead of building."),
        An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal: diag(1351, ts3.DiagnosticCategory.Error, "An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351", "An identifier or keyword cannot immediately follow a numeric literal."),
        A_bigint_literal_cannot_use_exponential_notation: diag(1352, ts3.DiagnosticCategory.Error, "A_bigint_literal_cannot_use_exponential_notation_1352", "A bigint literal cannot use exponential notation."),
        A_bigint_literal_must_be_an_integer: diag(1353, ts3.DiagnosticCategory.Error, "A_bigint_literal_must_be_an_integer_1353", "A bigint literal must be an integer."),
        readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types: diag(1354, ts3.DiagnosticCategory.Error, "readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354", "'readonly' type modifier is only permitted on array and tuple literal types."),
        A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals: diag(1355, ts3.DiagnosticCategory.Error, "A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355", "A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),
        Did_you_mean_to_mark_this_function_as_async: diag(1356, ts3.DiagnosticCategory.Error, "Did_you_mean_to_mark_this_function_as_async_1356", "Did you mean to mark this function as 'async'?"),
        An_enum_member_name_must_be_followed_by_a_or: diag(1357, ts3.DiagnosticCategory.Error, "An_enum_member_name_must_be_followed_by_a_or_1357", "An enum member name must be followed by a ',', '=', or '}'."),
        Tagged_template_expressions_are_not_permitted_in_an_optional_chain: diag(1358, ts3.DiagnosticCategory.Error, "Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358", "Tagged template expressions are not permitted in an optional chain."),
        Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here: diag(1359, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359", "Identifier expected. '{0}' is a reserved word that cannot be used here."),
        _0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type: diag(1361, ts3.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361", "'{0}' cannot be used as a value because it was imported using 'import type'."),
        _0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type: diag(1362, ts3.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362", "'{0}' cannot be used as a value because it was exported using 'export type'."),
        A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both: diag(1363, ts3.DiagnosticCategory.Error, "A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363", "A type-only import can specify a default import or named bindings, but not both."),
        Convert_to_type_only_export: diag(1364, ts3.DiagnosticCategory.Message, "Convert_to_type_only_export_1364", "Convert to type-only export"),
        Convert_all_re_exported_types_to_type_only_exports: diag(1365, ts3.DiagnosticCategory.Message, "Convert_all_re_exported_types_to_type_only_exports_1365", "Convert all re-exported types to type-only exports"),
        Split_into_two_separate_import_declarations: diag(1366, ts3.DiagnosticCategory.Message, "Split_into_two_separate_import_declarations_1366", "Split into two separate import declarations"),
        Split_all_invalid_type_only_imports: diag(1367, ts3.DiagnosticCategory.Message, "Split_all_invalid_type_only_imports_1367", "Split all invalid type-only imports"),
        Did_you_mean_0: diag(1369, ts3.DiagnosticCategory.Message, "Did_you_mean_0_1369", "Did you mean '{0}'?"),
        This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error: diag(1371, ts3.DiagnosticCategory.Error, "This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set__1371", "This import is never used as a value and must use 'import type' because 'importsNotUsedAsValues' is set to 'error'."),
        Convert_to_type_only_import: diag(1373, ts3.DiagnosticCategory.Message, "Convert_to_type_only_import_1373", "Convert to type-only import"),
        Convert_all_imports_not_used_as_a_value_to_type_only_imports: diag(1374, ts3.DiagnosticCategory.Message, "Convert_all_imports_not_used_as_a_value_to_type_only_imports_1374", "Convert all imports not used as a value to type-only imports"),
        await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1375, ts3.DiagnosticCategory.Error, "await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375", "'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
        _0_was_imported_here: diag(1376, ts3.DiagnosticCategory.Message, "_0_was_imported_here_1376", "'{0}' was imported here."),
        _0_was_exported_here: diag(1377, ts3.DiagnosticCategory.Message, "_0_was_exported_here_1377", "'{0}' was exported here."),
        Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher: diag(1378, ts3.DiagnosticCategory.Error, "Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_n_1378", "Top-level 'await' expressions are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', or 'nodenext', and the 'target' option is set to 'es2017' or higher."),
        An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type: diag(1379, ts3.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379", "An import alias cannot reference a declaration that was exported using 'export type'."),
        An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type: diag(1380, ts3.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380", "An import alias cannot reference a declaration that was imported using 'import type'."),
        Unexpected_token_Did_you_mean_or_rbrace: diag(1381, ts3.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_rbrace_1381", "Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"),
        Unexpected_token_Did_you_mean_or_gt: diag(1382, ts3.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_gt_1382", "Unexpected token. Did you mean `{'>'}` or `&gt;`?"),
        Only_named_exports_may_use_export_type: diag(1383, ts3.DiagnosticCategory.Error, "Only_named_exports_may_use_export_type_1383", "Only named exports may use 'export type'."),
        Function_type_notation_must_be_parenthesized_when_used_in_a_union_type: diag(1385, ts3.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385", "Function type notation must be parenthesized when used in a union type."),
        Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type: diag(1386, ts3.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386", "Constructor type notation must be parenthesized when used in a union type."),
        Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: diag(1387, ts3.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387", "Function type notation must be parenthesized when used in an intersection type."),
        Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: diag(1388, ts3.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388", "Constructor type notation must be parenthesized when used in an intersection type."),
        _0_is_not_allowed_as_a_variable_declaration_name: diag(1389, ts3.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_variable_declaration_name_1389", "'{0}' is not allowed as a variable declaration name."),
        _0_is_not_allowed_as_a_parameter_name: diag(1390, ts3.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_parameter_name_1390", "'{0}' is not allowed as a parameter name."),
        An_import_alias_cannot_use_import_type: diag(1392, ts3.DiagnosticCategory.Error, "An_import_alias_cannot_use_import_type_1392", "An import alias cannot use 'import type'"),
        Imported_via_0_from_file_1: diag(1393, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_1393", "Imported via {0} from file '{1}'"),
        Imported_via_0_from_file_1_with_packageId_2: diag(1394, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_1394", "Imported via {0} from file '{1}' with packageId '{2}'"),
        Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions: diag(1395, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395", "Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"),
        Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions: diag(1396, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396", "Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"),
        Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions: diag(1397, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397", "Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"),
        Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions: diag(1398, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398", "Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"),
        File_is_included_via_import_here: diag(1399, ts3.DiagnosticCategory.Message, "File_is_included_via_import_here_1399", "File is included via import here."),
        Referenced_via_0_from_file_1: diag(1400, ts3.DiagnosticCategory.Message, "Referenced_via_0_from_file_1_1400", "Referenced via '{0}' from file '{1}'"),
        File_is_included_via_reference_here: diag(1401, ts3.DiagnosticCategory.Message, "File_is_included_via_reference_here_1401", "File is included via reference here."),
        Type_library_referenced_via_0_from_file_1: diag(1402, ts3.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_1402", "Type library referenced via '{0}' from file '{1}'"),
        Type_library_referenced_via_0_from_file_1_with_packageId_2: diag(1403, ts3.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_with_packageId_2_1403", "Type library referenced via '{0}' from file '{1}' with packageId '{2}'"),
        File_is_included_via_type_library_reference_here: diag(1404, ts3.DiagnosticCategory.Message, "File_is_included_via_type_library_reference_here_1404", "File is included via type library reference here."),
        Library_referenced_via_0_from_file_1: diag(1405, ts3.DiagnosticCategory.Message, "Library_referenced_via_0_from_file_1_1405", "Library referenced via '{0}' from file '{1}'"),
        File_is_included_via_library_reference_here: diag(1406, ts3.DiagnosticCategory.Message, "File_is_included_via_library_reference_here_1406", "File is included via library reference here."),
        Matched_by_include_pattern_0_in_1: diag(1407, ts3.DiagnosticCategory.Message, "Matched_by_include_pattern_0_in_1_1407", "Matched by include pattern '{0}' in '{1}'"),
        File_is_matched_by_include_pattern_specified_here: diag(1408, ts3.DiagnosticCategory.Message, "File_is_matched_by_include_pattern_specified_here_1408", "File is matched by include pattern specified here."),
        Part_of_files_list_in_tsconfig_json: diag(1409, ts3.DiagnosticCategory.Message, "Part_of_files_list_in_tsconfig_json_1409", "Part of 'files' list in tsconfig.json"),
        File_is_matched_by_files_list_specified_here: diag(1410, ts3.DiagnosticCategory.Message, "File_is_matched_by_files_list_specified_here_1410", "File is matched by 'files' list specified here."),
        Output_from_referenced_project_0_included_because_1_specified: diag(1411, ts3.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_1_specified_1411", "Output from referenced project '{0}' included because '{1}' specified"),
        Output_from_referenced_project_0_included_because_module_is_specified_as_none: diag(1412, ts3.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412", "Output from referenced project '{0}' included because '--module' is specified as 'none'"),
        File_is_output_from_referenced_project_specified_here: diag(1413, ts3.DiagnosticCategory.Message, "File_is_output_from_referenced_project_specified_here_1413", "File is output from referenced project specified here."),
        Source_from_referenced_project_0_included_because_1_specified: diag(1414, ts3.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_1_specified_1414", "Source from referenced project '{0}' included because '{1}' specified"),
        Source_from_referenced_project_0_included_because_module_is_specified_as_none: diag(1415, ts3.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415", "Source from referenced project '{0}' included because '--module' is specified as 'none'"),
        File_is_source_from_referenced_project_specified_here: diag(1416, ts3.DiagnosticCategory.Message, "File_is_source_from_referenced_project_specified_here_1416", "File is source from referenced project specified here."),
        Entry_point_of_type_library_0_specified_in_compilerOptions: diag(1417, ts3.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_1417", "Entry point of type library '{0}' specified in compilerOptions"),
        Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1: diag(1418, ts3.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418", "Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"),
        File_is_entry_point_of_type_library_specified_here: diag(1419, ts3.DiagnosticCategory.Message, "File_is_entry_point_of_type_library_specified_here_1419", "File is entry point of type library specified here."),
        Entry_point_for_implicit_type_library_0: diag(1420, ts3.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_1420", "Entry point for implicit type library '{0}'"),
        Entry_point_for_implicit_type_library_0_with_packageId_1: diag(1421, ts3.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_with_packageId_1_1421", "Entry point for implicit type library '{0}' with packageId '{1}'"),
        Library_0_specified_in_compilerOptions: diag(1422, ts3.DiagnosticCategory.Message, "Library_0_specified_in_compilerOptions_1422", "Library '{0}' specified in compilerOptions"),
        File_is_library_specified_here: diag(1423, ts3.DiagnosticCategory.Message, "File_is_library_specified_here_1423", "File is library specified here."),
        Default_library: diag(1424, ts3.DiagnosticCategory.Message, "Default_library_1424", "Default library"),
        Default_library_for_target_0: diag(1425, ts3.DiagnosticCategory.Message, "Default_library_for_target_0_1425", "Default library for target '{0}'"),
        File_is_default_library_for_target_specified_here: diag(1426, ts3.DiagnosticCategory.Message, "File_is_default_library_for_target_specified_here_1426", "File is default library for target specified here."),
        Root_file_specified_for_compilation: diag(1427, ts3.DiagnosticCategory.Message, "Root_file_specified_for_compilation_1427", "Root file specified for compilation"),
        File_is_output_of_project_reference_source_0: diag(1428, ts3.DiagnosticCategory.Message, "File_is_output_of_project_reference_source_0_1428", "File is output of project reference source '{0}'"),
        File_redirects_to_file_0: diag(1429, ts3.DiagnosticCategory.Message, "File_redirects_to_file_0_1429", "File redirects to file '{0}'"),
        The_file_is_in_the_program_because_Colon: diag(1430, ts3.DiagnosticCategory.Message, "The_file_is_in_the_program_because_Colon_1430", "The file is in the program because:"),
        for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1431, ts3.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431", "'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
        Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher: diag(1432, ts3.DiagnosticCategory.Error, "Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_nod_1432", "Top-level 'for await' loops are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', or 'nodenext', and the 'target' option is set to 'es2017' or higher."),
        Decorators_may_not_be_applied_to_this_parameters: diag(1433, ts3.DiagnosticCategory.Error, "Decorators_may_not_be_applied_to_this_parameters_1433", "Decorators may not be applied to 'this' parameters."),
        Unexpected_keyword_or_identifier: diag(1434, ts3.DiagnosticCategory.Error, "Unexpected_keyword_or_identifier_1434", "Unexpected keyword or identifier."),
        Unknown_keyword_or_identifier_Did_you_mean_0: diag(1435, ts3.DiagnosticCategory.Error, "Unknown_keyword_or_identifier_Did_you_mean_0_1435", "Unknown keyword or identifier. Did you mean '{0}'?"),
        Decorators_must_precede_the_name_and_all_keywords_of_property_declarations: diag(1436, ts3.DiagnosticCategory.Error, "Decorators_must_precede_the_name_and_all_keywords_of_property_declarations_1436", "Decorators must precede the name and all keywords of property declarations."),
        Namespace_must_be_given_a_name: diag(1437, ts3.DiagnosticCategory.Error, "Namespace_must_be_given_a_name_1437", "Namespace must be given a name."),
        Interface_must_be_given_a_name: diag(1438, ts3.DiagnosticCategory.Error, "Interface_must_be_given_a_name_1438", "Interface must be given a name."),
        Type_alias_must_be_given_a_name: diag(1439, ts3.DiagnosticCategory.Error, "Type_alias_must_be_given_a_name_1439", "Type alias must be given a name."),
        Variable_declaration_not_allowed_at_this_location: diag(1440, ts3.DiagnosticCategory.Error, "Variable_declaration_not_allowed_at_this_location_1440", "Variable declaration not allowed at this location."),
        Cannot_start_a_function_call_in_a_type_annotation: diag(1441, ts3.DiagnosticCategory.Error, "Cannot_start_a_function_call_in_a_type_annotation_1441", "Cannot start a function call in a type annotation."),
        Expected_for_property_initializer: diag(1442, ts3.DiagnosticCategory.Error, "Expected_for_property_initializer_1442", "Expected '=' for property initializer."),
        Module_declaration_names_may_only_use_or_quoted_strings: diag(1443, ts3.DiagnosticCategory.Error, "Module_declaration_names_may_only_use_or_quoted_strings_1443", `Module declaration names may only use ' or " quoted strings.`),
        _0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: diag(1444, ts3.DiagnosticCategory.Error, "_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedMod_1444", "'{0}' is a type and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."),
        _0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: diag(1446, ts3.DiagnosticCategory.Error, "_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveVa_1446", "'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."),
        _0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isolatedModules_is_enabled: diag(1448, ts3.DiagnosticCategory.Error, "_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isol_1448", "'{0}' resolves to a type-only declaration and must be re-exported using a type-only re-export when 'isolatedModules' is enabled."),
        Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed: diag(1449, ts3.DiagnosticCategory.Message, "Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed_1449", "Preserve unused imported values in the JavaScript output that would otherwise be removed."),
        Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments: diag(1450, ts3.DiagnosticCategory.Message, "Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments_1450", "Dynamic imports can only accept a module specifier and an optional assertion as arguments"),
        Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression: diag(1451, ts3.DiagnosticCategory.Error, "Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member__1451", "Private identifiers are only allowed in class bodies and may only be used as part of a class member declaration, property access, or on the left-hand-side of an 'in' expression"),
        resolution_mode_assertions_are_only_supported_when_moduleResolution_is_node16_or_nodenext: diag(1452, ts3.DiagnosticCategory.Error, "resolution_mode_assertions_are_only_supported_when_moduleResolution_is_node16_or_nodenext_1452", "'resolution-mode' assertions are only supported when `moduleResolution` is `node16` or `nodenext`."),
        resolution_mode_should_be_either_require_or_import: diag(1453, ts3.DiagnosticCategory.Error, "resolution_mode_should_be_either_require_or_import_1453", "`resolution-mode` should be either `require` or `import`."),
        resolution_mode_can_only_be_set_for_type_only_imports: diag(1454, ts3.DiagnosticCategory.Error, "resolution_mode_can_only_be_set_for_type_only_imports_1454", "`resolution-mode` can only be set for type-only imports."),
        resolution_mode_is_the_only_valid_key_for_type_import_assertions: diag(1455, ts3.DiagnosticCategory.Error, "resolution_mode_is_the_only_valid_key_for_type_import_assertions_1455", "`resolution-mode` is the only valid key for type import assertions."),
        Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require: diag(1456, ts3.DiagnosticCategory.Error, "Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1456", "Type import assertions should have exactly one key - `resolution-mode` - with value `import` or `require`."),
        The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output: diag(1470, ts3.DiagnosticCategory.Error, "The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output_1470", "The 'import.meta' meta-property is not allowed in files which will build into CommonJS output."),
        Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_synchronously_Use_dynamic_import_instead: diag(1471, ts3.DiagnosticCategory.Error, "Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_c_1471", "Module '{0}' cannot be imported using this construct. The specifier only resolves to an ES module, which cannot be imported synchronously. Use dynamic import instead."),
        catch_or_finally_expected: diag(1472, ts3.DiagnosticCategory.Error, "catch_or_finally_expected_1472", "'catch' or 'finally' expected."),
        An_import_declaration_can_only_be_used_at_the_top_level_of_a_module: diag(1473, ts3.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_module_1473", "An import declaration can only be used at the top level of a module."),
        An_export_declaration_can_only_be_used_at_the_top_level_of_a_module: diag(1474, ts3.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_module_1474", "An export declaration can only be used at the top level of a module."),
        Control_what_method_is_used_to_detect_module_format_JS_files: diag(1475, ts3.DiagnosticCategory.Message, "Control_what_method_is_used_to_detect_module_format_JS_files_1475", "Control what method is used to detect module-format JS files."),
        auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules: diag(1476, ts3.DiagnosticCategory.Message, "auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_w_1476", '"auto": Treat files with imports, exports, import.meta, jsx (with jsx: react-jsx), or esm format (with module: node16+) as modules.'),
        The_types_of_0_are_incompatible_between_these_types: diag(2200, ts3.DiagnosticCategory.Error, "The_types_of_0_are_incompatible_between_these_types_2200", "The types of '{0}' are incompatible between these types."),
        The_types_returned_by_0_are_incompatible_between_these_types: diag(2201, ts3.DiagnosticCategory.Error, "The_types_returned_by_0_are_incompatible_between_these_types_2201", "The types returned by '{0}' are incompatible between these types."),
        Call_signature_return_types_0_and_1_are_incompatible: diag(2202, ts3.DiagnosticCategory.Error, "Call_signature_return_types_0_and_1_are_incompatible_2202", "Call signature return types '{0}' and '{1}' are incompatible.", void 0, true),
        Construct_signature_return_types_0_and_1_are_incompatible: diag(2203, ts3.DiagnosticCategory.Error, "Construct_signature_return_types_0_and_1_are_incompatible_2203", "Construct signature return types '{0}' and '{1}' are incompatible.", void 0, true),
        Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(2204, ts3.DiagnosticCategory.Error, "Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204", "Call signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true),
        Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(2205, ts3.DiagnosticCategory.Error, "Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205", "Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true),
        The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement: diag(2206, ts3.DiagnosticCategory.Error, "The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement_2206", "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."),
        The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement: diag(2207, ts3.DiagnosticCategory.Error, "The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement_2207", "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."),
        The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: diag(2209, ts3.DiagnosticCategory.Error, "The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_roo_2209", "The project root is ambiguous, but is required to resolve export map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),
        The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: diag(2210, ts3.DiagnosticCategory.Error, "The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_roo_2210", "The project root is ambiguous, but is required to resolve import map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),
        Duplicate_identifier_0: diag(2300, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_2300", "Duplicate identifier '{0}'."),
        Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: diag(2301, ts3.DiagnosticCategory.Error, "Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301", "Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),
        Static_members_cannot_reference_class_type_parameters: diag(2302, ts3.DiagnosticCategory.Error, "Static_members_cannot_reference_class_type_parameters_2302", "Static members cannot reference class type parameters."),
        Circular_definition_of_import_alias_0: diag(2303, ts3.DiagnosticCategory.Error, "Circular_definition_of_import_alias_0_2303", "Circular definition of import alias '{0}'."),
        Cannot_find_name_0: diag(2304, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_2304", "Cannot find name '{0}'."),
        Module_0_has_no_exported_member_1: diag(2305, ts3.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_2305", "Module '{0}' has no exported member '{1}'."),
        File_0_is_not_a_module: diag(2306, ts3.DiagnosticCategory.Error, "File_0_is_not_a_module_2306", "File '{0}' is not a module."),
        Cannot_find_module_0_or_its_corresponding_type_declarations: diag(2307, ts3.DiagnosticCategory.Error, "Cannot_find_module_0_or_its_corresponding_type_declarations_2307", "Cannot find module '{0}' or its corresponding type declarations."),
        Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity: diag(2308, ts3.DiagnosticCategory.Error, "Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308", "Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),
        An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements: diag(2309, ts3.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309", "An export assignment cannot be used in a module with other exported elements."),
        Type_0_recursively_references_itself_as_a_base_type: diag(2310, ts3.DiagnosticCategory.Error, "Type_0_recursively_references_itself_as_a_base_type_2310", "Type '{0}' recursively references itself as a base type."),
        Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function: diag(2311, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function_2311", "Cannot find name '{0}'. Did you mean to write this in an async function?"),
        An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2312, ts3.DiagnosticCategory.Error, "An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312", "An interface can only extend an object type or intersection of object types with statically known members."),
        Type_parameter_0_has_a_circular_constraint: diag(2313, ts3.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_constraint_2313", "Type parameter '{0}' has a circular constraint."),
        Generic_type_0_requires_1_type_argument_s: diag(2314, ts3.DiagnosticCategory.Error, "Generic_type_0_requires_1_type_argument_s_2314", "Generic type '{0}' requires {1} type argument(s)."),
        Type_0_is_not_generic: diag(2315, ts3.DiagnosticCategory.Error, "Type_0_is_not_generic_2315", "Type '{0}' is not generic."),
        Global_type_0_must_be_a_class_or_interface_type: diag(2316, ts3.DiagnosticCategory.Error, "Global_type_0_must_be_a_class_or_interface_type_2316", "Global type '{0}' must be a class or interface type."),
        Global_type_0_must_have_1_type_parameter_s: diag(2317, ts3.DiagnosticCategory.Error, "Global_type_0_must_have_1_type_parameter_s_2317", "Global type '{0}' must have {1} type parameter(s)."),
        Cannot_find_global_type_0: diag(2318, ts3.DiagnosticCategory.Error, "Cannot_find_global_type_0_2318", "Cannot find global type '{0}'."),
        Named_property_0_of_types_1_and_2_are_not_identical: diag(2319, ts3.DiagnosticCategory.Error, "Named_property_0_of_types_1_and_2_are_not_identical_2319", "Named property '{0}' of types '{1}' and '{2}' are not identical."),
        Interface_0_cannot_simultaneously_extend_types_1_and_2: diag(2320, ts3.DiagnosticCategory.Error, "Interface_0_cannot_simultaneously_extend_types_1_and_2_2320", "Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),
        Excessive_stack_depth_comparing_types_0_and_1: diag(2321, ts3.DiagnosticCategory.Error, "Excessive_stack_depth_comparing_types_0_and_1_2321", "Excessive stack depth comparing types '{0}' and '{1}'."),
        Type_0_is_not_assignable_to_type_1: diag(2322, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_2322", "Type '{0}' is not assignable to type '{1}'."),
        Cannot_redeclare_exported_variable_0: diag(2323, ts3.DiagnosticCategory.Error, "Cannot_redeclare_exported_variable_0_2323", "Cannot redeclare exported variable '{0}'."),
        Property_0_is_missing_in_type_1: diag(2324, ts3.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_2324", "Property '{0}' is missing in type '{1}'."),
        Property_0_is_private_in_type_1_but_not_in_type_2: diag(2325, ts3.DiagnosticCategory.Error, "Property_0_is_private_in_type_1_but_not_in_type_2_2325", "Property '{0}' is private in type '{1}' but not in type '{2}'."),
        Types_of_property_0_are_incompatible: diag(2326, ts3.DiagnosticCategory.Error, "Types_of_property_0_are_incompatible_2326", "Types of property '{0}' are incompatible."),
        Property_0_is_optional_in_type_1_but_required_in_type_2: diag(2327, ts3.DiagnosticCategory.Error, "Property_0_is_optional_in_type_1_but_required_in_type_2_2327", "Property '{0}' is optional in type '{1}' but required in type '{2}'."),
        Types_of_parameters_0_and_1_are_incompatible: diag(2328, ts3.DiagnosticCategory.Error, "Types_of_parameters_0_and_1_are_incompatible_2328", "Types of parameters '{0}' and '{1}' are incompatible."),
        Index_signature_for_type_0_is_missing_in_type_1: diag(2329, ts3.DiagnosticCategory.Error, "Index_signature_for_type_0_is_missing_in_type_1_2329", "Index signature for type '{0}' is missing in type '{1}'."),
        _0_and_1_index_signatures_are_incompatible: diag(2330, ts3.DiagnosticCategory.Error, "_0_and_1_index_signatures_are_incompatible_2330", "'{0}' and '{1}' index signatures are incompatible."),
        this_cannot_be_referenced_in_a_module_or_namespace_body: diag(2331, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_module_or_namespace_body_2331", "'this' cannot be referenced in a module or namespace body."),
        this_cannot_be_referenced_in_current_location: diag(2332, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_current_location_2332", "'this' cannot be referenced in current location."),
        this_cannot_be_referenced_in_constructor_arguments: diag(2333, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_constructor_arguments_2333", "'this' cannot be referenced in constructor arguments."),
        this_cannot_be_referenced_in_a_static_property_initializer: diag(2334, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_static_property_initializer_2334", "'this' cannot be referenced in a static property initializer."),
        super_can_only_be_referenced_in_a_derived_class: diag(2335, ts3.DiagnosticCategory.Error, "super_can_only_be_referenced_in_a_derived_class_2335", "'super' can only be referenced in a derived class."),
        super_cannot_be_referenced_in_constructor_arguments: diag(2336, ts3.DiagnosticCategory.Error, "super_cannot_be_referenced_in_constructor_arguments_2336", "'super' cannot be referenced in constructor arguments."),
        Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors: diag(2337, ts3.DiagnosticCategory.Error, "Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337", "Super calls are not permitted outside constructors or in nested functions inside constructors."),
        super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class: diag(2338, ts3.DiagnosticCategory.Error, "super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338", "'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),
        Property_0_does_not_exist_on_type_1: diag(2339, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_2339", "Property '{0}' does not exist on type '{1}'."),
        Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword: diag(2340, ts3.DiagnosticCategory.Error, "Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340", "Only public and protected methods of the base class are accessible via the 'super' keyword."),
        Property_0_is_private_and_only_accessible_within_class_1: diag(2341, ts3.DiagnosticCategory.Error, "Property_0_is_private_and_only_accessible_within_class_1_2341", "Property '{0}' is private and only accessible within class '{1}'."),
        This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0: diag(2343, ts3.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343", "This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."),
        Type_0_does_not_satisfy_the_constraint_1: diag(2344, ts3.DiagnosticCategory.Error, "Type_0_does_not_satisfy_the_constraint_1_2344", "Type '{0}' does not satisfy the constraint '{1}'."),
        Argument_of_type_0_is_not_assignable_to_parameter_of_type_1: diag(2345, ts3.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345", "Argument of type '{0}' is not assignable to parameter of type '{1}'."),
        Call_target_does_not_contain_any_signatures: diag(2346, ts3.DiagnosticCategory.Error, "Call_target_does_not_contain_any_signatures_2346", "Call target does not contain any signatures."),
        Untyped_function_calls_may_not_accept_type_arguments: diag(2347, ts3.DiagnosticCategory.Error, "Untyped_function_calls_may_not_accept_type_arguments_2347", "Untyped function calls may not accept type arguments."),
        Value_of_type_0_is_not_callable_Did_you_mean_to_include_new: diag(2348, ts3.DiagnosticCategory.Error, "Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348", "Value of type '{0}' is not callable. Did you mean to include 'new'?"),
        This_expression_is_not_callable: diag(2349, ts3.DiagnosticCategory.Error, "This_expression_is_not_callable_2349", "This expression is not callable."),
        Only_a_void_function_can_be_called_with_the_new_keyword: diag(2350, ts3.DiagnosticCategory.Error, "Only_a_void_function_can_be_called_with_the_new_keyword_2350", "Only a void function can be called with the 'new' keyword."),
        This_expression_is_not_constructable: diag(2351, ts3.DiagnosticCategory.Error, "This_expression_is_not_constructable_2351", "This expression is not constructable."),
        Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first: diag(2352, ts3.DiagnosticCategory.Error, "Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352", "Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),
        Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1: diag(2353, ts3.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353", "Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),
        This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found: diag(2354, ts3.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354", "This syntax requires an imported helper but module '{0}' cannot be found."),
        A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value: diag(2355, ts3.DiagnosticCategory.Error, "A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355", "A function whose declared type is neither 'void' nor 'any' must return a value."),
        An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2356, ts3.DiagnosticCategory.Error, "An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356", "An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),
        The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access: diag(2357, ts3.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357", "The operand of an increment or decrement operator must be a variable or a property access."),
        The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: diag(2358, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358", "The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),
        The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type: diag(2359, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359", "The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."),
        The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or_symbol: diag(2360, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or__2360", "The left-hand side of an 'in' expression must be a private identifier or of type 'any', 'string', 'number', or 'symbol'."),
        The_right_hand_side_of_an_in_expression_must_not_be_a_primitive: diag(2361, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_an_in_expression_must_not_be_a_primitive_2361", "The right-hand side of an 'in' expression must not be a primitive."),
        The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2362, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362", "The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
        The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2363, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363", "The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
        The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access: diag(2364, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364", "The left-hand side of an assignment expression must be a variable or a property access."),
        Operator_0_cannot_be_applied_to_types_1_and_2: diag(2365, ts3.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_types_1_and_2_2365", "Operator '{0}' cannot be applied to types '{1}' and '{2}'."),
        Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined: diag(2366, ts3.DiagnosticCategory.Error, "Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366", "Function lacks ending return statement and return type does not include 'undefined'."),
        This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap: diag(2367, ts3.DiagnosticCategory.Error, "This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap_2367", "This condition will always return '{0}' since the types '{1}' and '{2}' have no overlap."),
        Type_parameter_name_cannot_be_0: diag(2368, ts3.DiagnosticCategory.Error, "Type_parameter_name_cannot_be_0_2368", "Type parameter name cannot be '{0}'."),
        A_parameter_property_is_only_allowed_in_a_constructor_implementation: diag(2369, ts3.DiagnosticCategory.Error, "A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369", "A parameter property is only allowed in a constructor implementation."),
        A_rest_parameter_must_be_of_an_array_type: diag(2370, ts3.DiagnosticCategory.Error, "A_rest_parameter_must_be_of_an_array_type_2370", "A rest parameter must be of an array type."),
        A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation: diag(2371, ts3.DiagnosticCategory.Error, "A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371", "A parameter initializer is only allowed in a function or constructor implementation."),
        Parameter_0_cannot_reference_itself: diag(2372, ts3.DiagnosticCategory.Error, "Parameter_0_cannot_reference_itself_2372", "Parameter '{0}' cannot reference itself."),
        Parameter_0_cannot_reference_identifier_1_declared_after_it: diag(2373, ts3.DiagnosticCategory.Error, "Parameter_0_cannot_reference_identifier_1_declared_after_it_2373", "Parameter '{0}' cannot reference identifier '{1}' declared after it."),
        Duplicate_index_signature_for_type_0: diag(2374, ts3.DiagnosticCategory.Error, "Duplicate_index_signature_for_type_0_2374", "Duplicate index signature for type '{0}'."),
        Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: diag(2375, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2375", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),
        A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers: diag(2376, ts3.DiagnosticCategory.Error, "A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_2376", "A 'super' call must be the first statement in the constructor to refer to 'super' or 'this' when a derived class contains initialized properties, parameter properties, or private identifiers."),
        Constructors_for_derived_classes_must_contain_a_super_call: diag(2377, ts3.DiagnosticCategory.Error, "Constructors_for_derived_classes_must_contain_a_super_call_2377", "Constructors for derived classes must contain a 'super' call."),
        A_get_accessor_must_return_a_value: diag(2378, ts3.DiagnosticCategory.Error, "A_get_accessor_must_return_a_value_2378", "A 'get' accessor must return a value."),
        Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: diag(2379, ts3.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_tr_2379", "Argument of type '{0}' is not assignable to parameter of type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),
        The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type: diag(2380, ts3.DiagnosticCategory.Error, "The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type_2380", "The return type of a 'get' accessor must be assignable to its 'set' accessor type"),
        Overload_signatures_must_all_be_exported_or_non_exported: diag(2383, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_exported_or_non_exported_2383", "Overload signatures must all be exported or non-exported."),
        Overload_signatures_must_all_be_ambient_or_non_ambient: diag(2384, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_ambient_or_non_ambient_2384", "Overload signatures must all be ambient or non-ambient."),
        Overload_signatures_must_all_be_public_private_or_protected: diag(2385, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_public_private_or_protected_2385", "Overload signatures must all be public, private or protected."),
        Overload_signatures_must_all_be_optional_or_required: diag(2386, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_optional_or_required_2386", "Overload signatures must all be optional or required."),
        Function_overload_must_be_static: diag(2387, ts3.DiagnosticCategory.Error, "Function_overload_must_be_static_2387", "Function overload must be static."),
        Function_overload_must_not_be_static: diag(2388, ts3.DiagnosticCategory.Error, "Function_overload_must_not_be_static_2388", "Function overload must not be static."),
        Function_implementation_name_must_be_0: diag(2389, ts3.DiagnosticCategory.Error, "Function_implementation_name_must_be_0_2389", "Function implementation name must be '{0}'."),
        Constructor_implementation_is_missing: diag(2390, ts3.DiagnosticCategory.Error, "Constructor_implementation_is_missing_2390", "Constructor implementation is missing."),
        Function_implementation_is_missing_or_not_immediately_following_the_declaration: diag(2391, ts3.DiagnosticCategory.Error, "Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391", "Function implementation is missing or not immediately following the declaration."),
        Multiple_constructor_implementations_are_not_allowed: diag(2392, ts3.DiagnosticCategory.Error, "Multiple_constructor_implementations_are_not_allowed_2392", "Multiple constructor implementations are not allowed."),
        Duplicate_function_implementation: diag(2393, ts3.DiagnosticCategory.Error, "Duplicate_function_implementation_2393", "Duplicate function implementation."),
        This_overload_signature_is_not_compatible_with_its_implementation_signature: diag(2394, ts3.DiagnosticCategory.Error, "This_overload_signature_is_not_compatible_with_its_implementation_signature_2394", "This overload signature is not compatible with its implementation signature."),
        Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local: diag(2395, ts3.DiagnosticCategory.Error, "Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395", "Individual declarations in merged declaration '{0}' must be all exported or all local."),
        Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters: diag(2396, ts3.DiagnosticCategory.Error, "Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396", "Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),
        Declaration_name_conflicts_with_built_in_global_identifier_0: diag(2397, ts3.DiagnosticCategory.Error, "Declaration_name_conflicts_with_built_in_global_identifier_0_2397", "Declaration name conflicts with built-in global identifier '{0}'."),
        constructor_cannot_be_used_as_a_parameter_property_name: diag(2398, ts3.DiagnosticCategory.Error, "constructor_cannot_be_used_as_a_parameter_property_name_2398", "'constructor' cannot be used as a parameter property name."),
        Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference: diag(2399, ts3.DiagnosticCategory.Error, "Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399", "Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),
        Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference: diag(2400, ts3.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400", "Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),
        A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers: diag(2401, ts3.DiagnosticCategory.Error, "A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_in_2401", "A 'super' call must be a root-level statement within a constructor of a derived class that contains initialized properties, parameter properties, or private identifiers."),
        Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference: diag(2402, ts3.DiagnosticCategory.Error, "Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402", "Expression resolves to '_super' that compiler uses to capture base class reference."),
        Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2: diag(2403, ts3.DiagnosticCategory.Error, "Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403", "Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),
        The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation: diag(2404, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404", "The left-hand side of a 'for...in' statement cannot use a type annotation."),
        The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any: diag(2405, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405", "The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),
        The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access: diag(2406, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406", "The left-hand side of a 'for...in' statement must be a variable or a property access."),
        The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0: diag(2407, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407", "The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),
        Setters_cannot_return_a_value: diag(2408, ts3.DiagnosticCategory.Error, "Setters_cannot_return_a_value_2408", "Setters cannot return a value."),
        Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class: diag(2409, ts3.DiagnosticCategory.Error, "Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409", "Return type of constructor signature must be assignable to the instance type of the class."),
        The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any: diag(2410, ts3.DiagnosticCategory.Error, "The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410", "The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),
        Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target: diag(2412, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2412", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the type of the target."),
        Property_0_of_type_1_is_not_assignable_to_2_index_type_3: diag(2411, ts3.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_2_index_type_3_2411", "Property '{0}' of type '{1}' is not assignable to '{2}' index type '{3}'."),
        _0_index_type_1_is_not_assignable_to_2_index_type_3: diag(2413, ts3.DiagnosticCategory.Error, "_0_index_type_1_is_not_assignable_to_2_index_type_3_2413", "'{0}' index type '{1}' is not assignable to '{2}' index type '{3}'."),
        Class_name_cannot_be_0: diag(2414, ts3.DiagnosticCategory.Error, "Class_name_cannot_be_0_2414", "Class name cannot be '{0}'."),
        Class_0_incorrectly_extends_base_class_1: diag(2415, ts3.DiagnosticCategory.Error, "Class_0_incorrectly_extends_base_class_1_2415", "Class '{0}' incorrectly extends base class '{1}'."),
        Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2: diag(2416, ts3.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416", "Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),
        Class_static_side_0_incorrectly_extends_base_class_static_side_1: diag(2417, ts3.DiagnosticCategory.Error, "Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417", "Class static side '{0}' incorrectly extends base class static side '{1}'."),
        Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1: diag(2418, ts3.DiagnosticCategory.Error, "Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418", "Type of computed property's value is '{0}', which is not assignable to type '{1}'."),
        Types_of_construct_signatures_are_incompatible: diag(2419, ts3.DiagnosticCategory.Error, "Types_of_construct_signatures_are_incompatible_2419", "Types of construct signatures are incompatible."),
        Class_0_incorrectly_implements_interface_1: diag(2420, ts3.DiagnosticCategory.Error, "Class_0_incorrectly_implements_interface_1_2420", "Class '{0}' incorrectly implements interface '{1}'."),
        A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2422, ts3.DiagnosticCategory.Error, "A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422", "A class can only implement an object type or intersection of object types with statically known members."),
        Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor: diag(2423, ts3.DiagnosticCategory.Error, "Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423", "Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),
        Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2425, ts3.DiagnosticCategory.Error, "Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425", "Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),
        Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2426, ts3.DiagnosticCategory.Error, "Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426", "Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),
        Interface_name_cannot_be_0: diag(2427, ts3.DiagnosticCategory.Error, "Interface_name_cannot_be_0_2427", "Interface name cannot be '{0}'."),
        All_declarations_of_0_must_have_identical_type_parameters: diag(2428, ts3.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_type_parameters_2428", "All declarations of '{0}' must have identical type parameters."),
        Interface_0_incorrectly_extends_interface_1: diag(2430, ts3.DiagnosticCategory.Error, "Interface_0_incorrectly_extends_interface_1_2430", "Interface '{0}' incorrectly extends interface '{1}'."),
        Enum_name_cannot_be_0: diag(2431, ts3.DiagnosticCategory.Error, "Enum_name_cannot_be_0_2431", "Enum name cannot be '{0}'."),
        In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element: diag(2432, ts3.DiagnosticCategory.Error, "In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432", "In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),
        A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged: diag(2433, ts3.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433", "A namespace declaration cannot be in a different file from a class or function with which it is merged."),
        A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged: diag(2434, ts3.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434", "A namespace declaration cannot be located prior to a class or function with which it is merged."),
        Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces: diag(2435, ts3.DiagnosticCategory.Error, "Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435", "Ambient modules cannot be nested in other modules or namespaces."),
        Ambient_module_declaration_cannot_specify_relative_module_name: diag(2436, ts3.DiagnosticCategory.Error, "Ambient_module_declaration_cannot_specify_relative_module_name_2436", "Ambient module declaration cannot specify relative module name."),
        Module_0_is_hidden_by_a_local_declaration_with_the_same_name: diag(2437, ts3.DiagnosticCategory.Error, "Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437", "Module '{0}' is hidden by a local declaration with the same name."),
        Import_name_cannot_be_0: diag(2438, ts3.DiagnosticCategory.Error, "Import_name_cannot_be_0_2438", "Import name cannot be '{0}'."),
        Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name: diag(2439, ts3.DiagnosticCategory.Error, "Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439", "Import or export declaration in an ambient module declaration cannot reference module through relative module name."),
        Import_declaration_conflicts_with_local_declaration_of_0: diag(2440, ts3.DiagnosticCategory.Error, "Import_declaration_conflicts_with_local_declaration_of_0_2440", "Import declaration conflicts with local declaration of '{0}'."),
        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module: diag(2441, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),
        Types_have_separate_declarations_of_a_private_property_0: diag(2442, ts3.DiagnosticCategory.Error, "Types_have_separate_declarations_of_a_private_property_0_2442", "Types have separate declarations of a private property '{0}'."),
        Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2: diag(2443, ts3.DiagnosticCategory.Error, "Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443", "Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),
        Property_0_is_protected_in_type_1_but_public_in_type_2: diag(2444, ts3.DiagnosticCategory.Error, "Property_0_is_protected_in_type_1_but_public_in_type_2_2444", "Property '{0}' is protected in type '{1}' but public in type '{2}'."),
        Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses: diag(2445, ts3.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445", "Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),
        Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2: diag(2446, ts3.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446", "Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."),
        The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead: diag(2447, ts3.DiagnosticCategory.Error, "The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447", "The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),
        Block_scoped_variable_0_used_before_its_declaration: diag(2448, ts3.DiagnosticCategory.Error, "Block_scoped_variable_0_used_before_its_declaration_2448", "Block-scoped variable '{0}' used before its declaration."),
        Class_0_used_before_its_declaration: diag(2449, ts3.DiagnosticCategory.Error, "Class_0_used_before_its_declaration_2449", "Class '{0}' used before its declaration."),
        Enum_0_used_before_its_declaration: diag(2450, ts3.DiagnosticCategory.Error, "Enum_0_used_before_its_declaration_2450", "Enum '{0}' used before its declaration."),
        Cannot_redeclare_block_scoped_variable_0: diag(2451, ts3.DiagnosticCategory.Error, "Cannot_redeclare_block_scoped_variable_0_2451", "Cannot redeclare block-scoped variable '{0}'."),
        An_enum_member_cannot_have_a_numeric_name: diag(2452, ts3.DiagnosticCategory.Error, "An_enum_member_cannot_have_a_numeric_name_2452", "An enum member cannot have a numeric name."),
        Variable_0_is_used_before_being_assigned: diag(2454, ts3.DiagnosticCategory.Error, "Variable_0_is_used_before_being_assigned_2454", "Variable '{0}' is used before being assigned."),
        Type_alias_0_circularly_references_itself: diag(2456, ts3.DiagnosticCategory.Error, "Type_alias_0_circularly_references_itself_2456", "Type alias '{0}' circularly references itself."),
        Type_alias_name_cannot_be_0: diag(2457, ts3.DiagnosticCategory.Error, "Type_alias_name_cannot_be_0_2457", "Type alias name cannot be '{0}'."),
        An_AMD_module_cannot_have_multiple_name_assignments: diag(2458, ts3.DiagnosticCategory.Error, "An_AMD_module_cannot_have_multiple_name_assignments_2458", "An AMD module cannot have multiple name assignments."),
        Module_0_declares_1_locally_but_it_is_not_exported: diag(2459, ts3.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_not_exported_2459", "Module '{0}' declares '{1}' locally, but it is not exported."),
        Module_0_declares_1_locally_but_it_is_exported_as_2: diag(2460, ts3.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_exported_as_2_2460", "Module '{0}' declares '{1}' locally, but it is exported as '{2}'."),
        Type_0_is_not_an_array_type: diag(2461, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_2461", "Type '{0}' is not an array type."),
        A_rest_element_must_be_last_in_a_destructuring_pattern: diag(2462, ts3.DiagnosticCategory.Error, "A_rest_element_must_be_last_in_a_destructuring_pattern_2462", "A rest element must be last in a destructuring pattern."),
        A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature: diag(2463, ts3.DiagnosticCategory.Error, "A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463", "A binding pattern parameter cannot be optional in an implementation signature."),
        A_computed_property_name_must_be_of_type_string_number_symbol_or_any: diag(2464, ts3.DiagnosticCategory.Error, "A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464", "A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),
        this_cannot_be_referenced_in_a_computed_property_name: diag(2465, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_computed_property_name_2465", "'this' cannot be referenced in a computed property name."),
        super_cannot_be_referenced_in_a_computed_property_name: diag(2466, ts3.DiagnosticCategory.Error, "super_cannot_be_referenced_in_a_computed_property_name_2466", "'super' cannot be referenced in a computed property name."),
        A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type: diag(2467, ts3.DiagnosticCategory.Error, "A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467", "A computed property name cannot reference a type parameter from its containing type."),
        Cannot_find_global_value_0: diag(2468, ts3.DiagnosticCategory.Error, "Cannot_find_global_value_0_2468", "Cannot find global value '{0}'."),
        The_0_operator_cannot_be_applied_to_type_symbol: diag(2469, ts3.DiagnosticCategory.Error, "The_0_operator_cannot_be_applied_to_type_symbol_2469", "The '{0}' operator cannot be applied to type 'symbol'."),
        Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher: diag(2472, ts3.DiagnosticCategory.Error, "Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472", "Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),
        Enum_declarations_must_all_be_const_or_non_const: diag(2473, ts3.DiagnosticCategory.Error, "Enum_declarations_must_all_be_const_or_non_const_2473", "Enum declarations must all be const or non-const."),
        const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values: diag(2474, ts3.DiagnosticCategory.Error, "const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values_2474", "const enum member initializers can only contain literal values and other computed enum values."),
        const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query: diag(2475, ts3.DiagnosticCategory.Error, "const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475", "'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),
        A_const_enum_member_can_only_be_accessed_using_a_string_literal: diag(2476, ts3.DiagnosticCategory.Error, "A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476", "A const enum member can only be accessed using a string literal."),
        const_enum_member_initializer_was_evaluated_to_a_non_finite_value: diag(2477, ts3.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477", "'const' enum member initializer was evaluated to a non-finite value."),
        const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN: diag(2478, ts3.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478", "'const' enum member initializer was evaluated to disallowed value 'NaN'."),
        let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations: diag(2480, ts3.DiagnosticCategory.Error, "let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480", "'let' is not allowed to be used as a name in 'let' or 'const' declarations."),
        Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1: diag(2481, ts3.DiagnosticCategory.Error, "Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481", "Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),
        The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation: diag(2483, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483", "The left-hand side of a 'for...of' statement cannot use a type annotation."),
        Export_declaration_conflicts_with_exported_declaration_of_0: diag(2484, ts3.DiagnosticCategory.Error, "Export_declaration_conflicts_with_exported_declaration_of_0_2484", "Export declaration conflicts with exported declaration of '{0}'."),
        The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access: diag(2487, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487", "The left-hand side of a 'for...of' statement must be a variable or a property access."),
        Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2488, ts3.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488", "Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),
        An_iterator_must_have_a_next_method: diag(2489, ts3.DiagnosticCategory.Error, "An_iterator_must_have_a_next_method_2489", "An iterator must have a 'next()' method."),
        The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property: diag(2490, ts3.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490", "The type returned by the '{0}()' method of an iterator must have a 'value' property."),
        The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern: diag(2491, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491", "The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),
        Cannot_redeclare_identifier_0_in_catch_clause: diag(2492, ts3.DiagnosticCategory.Error, "Cannot_redeclare_identifier_0_in_catch_clause_2492", "Cannot redeclare identifier '{0}' in catch clause."),
        Tuple_type_0_of_length_1_has_no_element_at_index_2: diag(2493, ts3.DiagnosticCategory.Error, "Tuple_type_0_of_length_1_has_no_element_at_index_2_2493", "Tuple type '{0}' of length '{1}' has no element at index '{2}'."),
        Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher: diag(2494, ts3.DiagnosticCategory.Error, "Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494", "Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),
        Type_0_is_not_an_array_type_or_a_string_type: diag(2495, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_2495", "Type '{0}' is not an array type or a string type."),
        The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression: diag(2496, ts3.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496", "The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),
        This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export: diag(2497, ts3.DiagnosticCategory.Error, "This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497", "This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),
        Module_0_uses_export_and_cannot_be_used_with_export_Asterisk: diag(2498, ts3.DiagnosticCategory.Error, "Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498", "Module '{0}' uses 'export =' and cannot be used with 'export *'."),
        An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2499, ts3.DiagnosticCategory.Error, "An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499", "An interface can only extend an identifier/qualified-name with optional type arguments."),
        A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2500, ts3.DiagnosticCategory.Error, "A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500", "A class can only implement an identifier/qualified-name with optional type arguments."),
        A_rest_element_cannot_contain_a_binding_pattern: diag(2501, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_contain_a_binding_pattern_2501", "A rest element cannot contain a binding pattern."),
        _0_is_referenced_directly_or_indirectly_in_its_own_type_annotation: diag(2502, ts3.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502", "'{0}' is referenced directly or indirectly in its own type annotation."),
        Cannot_find_namespace_0: diag(2503, ts3.DiagnosticCategory.Error, "Cannot_find_namespace_0_2503", "Cannot find namespace '{0}'."),
        Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator: diag(2504, ts3.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504", "Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),
        A_generator_cannot_have_a_void_type_annotation: diag(2505, ts3.DiagnosticCategory.Error, "A_generator_cannot_have_a_void_type_annotation_2505", "A generator cannot have a 'void' type annotation."),
        _0_is_referenced_directly_or_indirectly_in_its_own_base_expression: diag(2506, ts3.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506", "'{0}' is referenced directly or indirectly in its own base expression."),
        Type_0_is_not_a_constructor_function_type: diag(2507, ts3.DiagnosticCategory.Error, "Type_0_is_not_a_constructor_function_type_2507", "Type '{0}' is not a constructor function type."),
        No_base_constructor_has_the_specified_number_of_type_arguments: diag(2508, ts3.DiagnosticCategory.Error, "No_base_constructor_has_the_specified_number_of_type_arguments_2508", "No base constructor has the specified number of type arguments."),
        Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2509, ts3.DiagnosticCategory.Error, "Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509", "Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),
        Base_constructors_must_all_have_the_same_return_type: diag(2510, ts3.DiagnosticCategory.Error, "Base_constructors_must_all_have_the_same_return_type_2510", "Base constructors must all have the same return type."),
        Cannot_create_an_instance_of_an_abstract_class: diag(2511, ts3.DiagnosticCategory.Error, "Cannot_create_an_instance_of_an_abstract_class_2511", "Cannot create an instance of an abstract class."),
        Overload_signatures_must_all_be_abstract_or_non_abstract: diag(2512, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_abstract_or_non_abstract_2512", "Overload signatures must all be abstract or non-abstract."),
        Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression: diag(2513, ts3.DiagnosticCategory.Error, "Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513", "Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),
        Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2: diag(2515, ts3.DiagnosticCategory.Error, "Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515", "Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),
        All_declarations_of_an_abstract_method_must_be_consecutive: diag(2516, ts3.DiagnosticCategory.Error, "All_declarations_of_an_abstract_method_must_be_consecutive_2516", "All declarations of an abstract method must be consecutive."),
        Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type: diag(2517, ts3.DiagnosticCategory.Error, "Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517", "Cannot assign an abstract constructor type to a non-abstract constructor type."),
        A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard: diag(2518, ts3.DiagnosticCategory.Error, "A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518", "A 'this'-based type guard is not compatible with a parameter-based type guard."),
        An_async_iterator_must_have_a_next_method: diag(2519, ts3.DiagnosticCategory.Error, "An_async_iterator_must_have_a_next_method_2519", "An async iterator must have a 'next()' method."),
        Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions: diag(2520, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520", "Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),
        The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method: diag(2522, ts3.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522", "The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),
        yield_expressions_cannot_be_used_in_a_parameter_initializer: diag(2523, ts3.DiagnosticCategory.Error, "yield_expressions_cannot_be_used_in_a_parameter_initializer_2523", "'yield' expressions cannot be used in a parameter initializer."),
        await_expressions_cannot_be_used_in_a_parameter_initializer: diag(2524, ts3.DiagnosticCategory.Error, "await_expressions_cannot_be_used_in_a_parameter_initializer_2524", "'await' expressions cannot be used in a parameter initializer."),
        Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value: diag(2525, ts3.DiagnosticCategory.Error, "Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525", "Initializer provides no value for this binding element and the binding element has no default value."),
        A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface: diag(2526, ts3.DiagnosticCategory.Error, "A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526", "A 'this' type is available only in a non-static member of a class or interface."),
        The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary: diag(2527, ts3.DiagnosticCategory.Error, "The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527", "The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),
        A_module_cannot_have_multiple_default_exports: diag(2528, ts3.DiagnosticCategory.Error, "A_module_cannot_have_multiple_default_exports_2528", "A module cannot have multiple default exports."),
        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions: diag(2529, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),
        Property_0_is_incompatible_with_index_signature: diag(2530, ts3.DiagnosticCategory.Error, "Property_0_is_incompatible_with_index_signature_2530", "Property '{0}' is incompatible with index signature."),
        Object_is_possibly_null: diag(2531, ts3.DiagnosticCategory.Error, "Object_is_possibly_null_2531", "Object is possibly 'null'."),
        Object_is_possibly_undefined: diag(2532, ts3.DiagnosticCategory.Error, "Object_is_possibly_undefined_2532", "Object is possibly 'undefined'."),
        Object_is_possibly_null_or_undefined: diag(2533, ts3.DiagnosticCategory.Error, "Object_is_possibly_null_or_undefined_2533", "Object is possibly 'null' or 'undefined'."),
        A_function_returning_never_cannot_have_a_reachable_end_point: diag(2534, ts3.DiagnosticCategory.Error, "A_function_returning_never_cannot_have_a_reachable_end_point_2534", "A function returning 'never' cannot have a reachable end point."),
        Enum_type_0_has_members_with_initializers_that_are_not_literals: diag(2535, ts3.DiagnosticCategory.Error, "Enum_type_0_has_members_with_initializers_that_are_not_literals_2535", "Enum type '{0}' has members with initializers that are not literals."),
        Type_0_cannot_be_used_to_index_type_1: diag(2536, ts3.DiagnosticCategory.Error, "Type_0_cannot_be_used_to_index_type_1_2536", "Type '{0}' cannot be used to index type '{1}'."),
        Type_0_has_no_matching_index_signature_for_type_1: diag(2537, ts3.DiagnosticCategory.Error, "Type_0_has_no_matching_index_signature_for_type_1_2537", "Type '{0}' has no matching index signature for type '{1}'."),
        Type_0_cannot_be_used_as_an_index_type: diag(2538, ts3.DiagnosticCategory.Error, "Type_0_cannot_be_used_as_an_index_type_2538", "Type '{0}' cannot be used as an index type."),
        Cannot_assign_to_0_because_it_is_not_a_variable: diag(2539, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_not_a_variable_2539", "Cannot assign to '{0}' because it is not a variable."),
        Cannot_assign_to_0_because_it_is_a_read_only_property: diag(2540, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_read_only_property_2540", "Cannot assign to '{0}' because it is a read-only property."),
        Index_signature_in_type_0_only_permits_reading: diag(2542, ts3.DiagnosticCategory.Error, "Index_signature_in_type_0_only_permits_reading_2542", "Index signature in type '{0}' only permits reading."),
        Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference: diag(2543, ts3.DiagnosticCategory.Error, "Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543", "Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),
        Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference: diag(2544, ts3.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544", "Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),
        A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any: diag(2545, ts3.DiagnosticCategory.Error, "A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545", "A mixin class must have a constructor with a single rest parameter of type 'any[]'."),
        The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property: diag(2547, ts3.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547", "The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."),
        Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2548, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548", "Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
        Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2549, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549", "Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
        Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later: diag(2550, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550", "Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."),
        Property_0_does_not_exist_on_type_1_Did_you_mean_2: diag(2551, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551", "Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),
        Cannot_find_name_0_Did_you_mean_1: diag(2552, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_1_2552", "Cannot find name '{0}'. Did you mean '{1}'?"),
        Computed_values_are_not_permitted_in_an_enum_with_string_valued_members: diag(2553, ts3.DiagnosticCategory.Error, "Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553", "Computed values are not permitted in an enum with string valued members."),
        Expected_0_arguments_but_got_1: diag(2554, ts3.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_2554", "Expected {0} arguments, but got {1}."),
        Expected_at_least_0_arguments_but_got_1: diag(2555, ts3.DiagnosticCategory.Error, "Expected_at_least_0_arguments_but_got_1_2555", "Expected at least {0} arguments, but got {1}."),
        A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter: diag(2556, ts3.DiagnosticCategory.Error, "A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556", "A spread argument must either have a tuple type or be passed to a rest parameter."),
        Expected_0_type_arguments_but_got_1: diag(2558, ts3.DiagnosticCategory.Error, "Expected_0_type_arguments_but_got_1_2558", "Expected {0} type arguments, but got {1}."),
        Type_0_has_no_properties_in_common_with_type_1: diag(2559, ts3.DiagnosticCategory.Error, "Type_0_has_no_properties_in_common_with_type_1_2559", "Type '{0}' has no properties in common with type '{1}'."),
        Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it: diag(2560, ts3.DiagnosticCategory.Error, "Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560", "Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),
        Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2: diag(2561, ts3.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561", "Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),
        Base_class_expressions_cannot_reference_class_type_parameters: diag(2562, ts3.DiagnosticCategory.Error, "Base_class_expressions_cannot_reference_class_type_parameters_2562", "Base class expressions cannot reference class type parameters."),
        The_containing_function_or_module_body_is_too_large_for_control_flow_analysis: diag(2563, ts3.DiagnosticCategory.Error, "The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563", "The containing function or module body is too large for control flow analysis."),
        Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor: diag(2564, ts3.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564", "Property '{0}' has no initializer and is not definitely assigned in the constructor."),
        Property_0_is_used_before_being_assigned: diag(2565, ts3.DiagnosticCategory.Error, "Property_0_is_used_before_being_assigned_2565", "Property '{0}' is used before being assigned."),
        A_rest_element_cannot_have_a_property_name: diag(2566, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_have_a_property_name_2566", "A rest element cannot have a property name."),
        Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations: diag(2567, ts3.DiagnosticCategory.Error, "Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567", "Enum declarations can only merge with namespace or other enum declarations."),
        Property_0_may_not_exist_on_type_1_Did_you_mean_2: diag(2568, ts3.DiagnosticCategory.Error, "Property_0_may_not_exist_on_type_1_Did_you_mean_2_2568", "Property '{0}' may not exist on type '{1}'. Did you mean '{2}'?"),
        Could_not_find_name_0_Did_you_mean_1: diag(2570, ts3.DiagnosticCategory.Error, "Could_not_find_name_0_Did_you_mean_1_2570", "Could not find name '{0}'. Did you mean '{1}'?"),
        Object_is_of_type_unknown: diag(2571, ts3.DiagnosticCategory.Error, "Object_is_of_type_unknown_2571", "Object is of type 'unknown'."),
        A_rest_element_type_must_be_an_array_type: diag(2574, ts3.DiagnosticCategory.Error, "A_rest_element_type_must_be_an_array_type_2574", "A rest element type must be an array type."),
        No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments: diag(2575, ts3.DiagnosticCategory.Error, "No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575", "No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),
        Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead: diag(2576, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576", "Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"),
        Return_type_annotation_circularly_references_itself: diag(2577, ts3.DiagnosticCategory.Error, "Return_type_annotation_circularly_references_itself_2577", "Return type annotation circularly references itself."),
        Unused_ts_expect_error_directive: diag(2578, ts3.DiagnosticCategory.Error, "Unused_ts_expect_error_directive_2578", "Unused '@ts-expect-error' directive."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode: diag(2580, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery: diag(2581, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha: diag(2582, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."),
        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later: diag(2583, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."),
        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom: diag(2584, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: diag(2585, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585", "'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."),
        Cannot_assign_to_0_because_it_is_a_constant: diag(2588, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_constant_2588", "Cannot assign to '{0}' because it is a constant."),
        Type_instantiation_is_excessively_deep_and_possibly_infinite: diag(2589, ts3.DiagnosticCategory.Error, "Type_instantiation_is_excessively_deep_and_possibly_infinite_2589", "Type instantiation is excessively deep and possibly infinite."),
        Expression_produces_a_union_type_that_is_too_complex_to_represent: diag(2590, ts3.DiagnosticCategory.Error, "Expression_produces_a_union_type_that_is_too_complex_to_represent_2590", "Expression produces a union type that is too complex to represent."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig: diag(2591, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig: diag(2592, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig: diag(2593, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."),
        This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag: diag(2594, ts3.DiagnosticCategory.Error, "This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the__2594", "This module is declared with using 'export =', and can only be used with a default import when using the '{0}' flag."),
        _0_can_only_be_imported_by_using_a_default_import: diag(2595, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_default_import_2595", "'{0}' can only be imported by using a default import."),
        _0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2596, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596", "'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."),
        _0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import: diag(2597, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597", "'{0}' can only be imported by using a 'require' call or by using a default import."),
        _0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2598, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598", "'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."),
        JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist: diag(2602, ts3.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602", "JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),
        Property_0_in_type_1_is_not_assignable_to_type_2: diag(2603, ts3.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_type_2_2603", "Property '{0}' in type '{1}' is not assignable to type '{2}'."),
        JSX_element_type_0_does_not_have_any_construct_or_call_signatures: diag(2604, ts3.DiagnosticCategory.Error, "JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604", "JSX element type '{0}' does not have any construct or call signatures."),
        Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property: diag(2606, ts3.DiagnosticCategory.Error, "Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606", "Property '{0}' of JSX spread attribute is not assignable to target property."),
        JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property: diag(2607, ts3.DiagnosticCategory.Error, "JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607", "JSX element class does not support attributes because it does not have a '{0}' property."),
        The_global_type_JSX_0_may_not_have_more_than_one_property: diag(2608, ts3.DiagnosticCategory.Error, "The_global_type_JSX_0_may_not_have_more_than_one_property_2608", "The global type 'JSX.{0}' may not have more than one property."),
        JSX_spread_child_must_be_an_array_type: diag(2609, ts3.DiagnosticCategory.Error, "JSX_spread_child_must_be_an_array_type_2609", "JSX spread child must be an array type."),
        _0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property: diag(2610, ts3.DiagnosticCategory.Error, "_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610", "'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."),
        _0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor: diag(2611, ts3.DiagnosticCategory.Error, "_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611", "'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."),
        Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration: diag(2612, ts3.DiagnosticCategory.Error, "Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612", "Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."),
        Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead: diag(2613, ts3.DiagnosticCategory.Error, "Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613", "Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"),
        Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead: diag(2614, ts3.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614", "Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"),
        Type_of_property_0_circularly_references_itself_in_mapped_type_1: diag(2615, ts3.DiagnosticCategory.Error, "Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615", "Type of property '{0}' circularly references itself in mapped type '{1}'."),
        _0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import: diag(2616, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616", "'{0}' can only be imported by using 'import {1} = require({2})' or a default import."),
        _0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2617, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617", "'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."),
        Source_has_0_element_s_but_target_requires_1: diag(2618, ts3.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_requires_1_2618", "Source has {0} element(s) but target requires {1}."),
        Source_has_0_element_s_but_target_allows_only_1: diag(2619, ts3.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_allows_only_1_2619", "Source has {0} element(s) but target allows only {1}."),
        Target_requires_0_element_s_but_source_may_have_fewer: diag(2620, ts3.DiagnosticCategory.Error, "Target_requires_0_element_s_but_source_may_have_fewer_2620", "Target requires {0} element(s) but source may have fewer."),
        Target_allows_only_0_element_s_but_source_may_have_more: diag(2621, ts3.DiagnosticCategory.Error, "Target_allows_only_0_element_s_but_source_may_have_more_2621", "Target allows only {0} element(s) but source may have more."),
        Source_provides_no_match_for_required_element_at_position_0_in_target: diag(2623, ts3.DiagnosticCategory.Error, "Source_provides_no_match_for_required_element_at_position_0_in_target_2623", "Source provides no match for required element at position {0} in target."),
        Source_provides_no_match_for_variadic_element_at_position_0_in_target: diag(2624, ts3.DiagnosticCategory.Error, "Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624", "Source provides no match for variadic element at position {0} in target."),
        Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target: diag(2625, ts3.DiagnosticCategory.Error, "Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625", "Variadic element at position {0} in source does not match element at position {1} in target."),
        Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target: diag(2626, ts3.DiagnosticCategory.Error, "Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626", "Type at position {0} in source is not compatible with type at position {1} in target."),
        Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target: diag(2627, ts3.DiagnosticCategory.Error, "Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627", "Type at positions {0} through {1} in source is not compatible with type at position {2} in target."),
        Cannot_assign_to_0_because_it_is_an_enum: diag(2628, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_enum_2628", "Cannot assign to '{0}' because it is an enum."),
        Cannot_assign_to_0_because_it_is_a_class: diag(2629, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_class_2629", "Cannot assign to '{0}' because it is a class."),
        Cannot_assign_to_0_because_it_is_a_function: diag(2630, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_function_2630", "Cannot assign to '{0}' because it is a function."),
        Cannot_assign_to_0_because_it_is_a_namespace: diag(2631, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_namespace_2631", "Cannot assign to '{0}' because it is a namespace."),
        Cannot_assign_to_0_because_it_is_an_import: diag(2632, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_import_2632", "Cannot assign to '{0}' because it is an import."),
        JSX_property_access_expressions_cannot_include_JSX_namespace_names: diag(2633, ts3.DiagnosticCategory.Error, "JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633", "JSX property access expressions cannot include JSX namespace names"),
        _0_index_signatures_are_incompatible: diag(2634, ts3.DiagnosticCategory.Error, "_0_index_signatures_are_incompatible_2634", "'{0}' index signatures are incompatible."),
        Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable: diag(2635, ts3.DiagnosticCategory.Error, "Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable_2635", "Type '{0}' has no signatures for which the type argument list is applicable."),
        Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation: diag(2636, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation_2636", "Type '{0}' is not assignable to type '{1}' as implied by variance annotation."),
        Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types: diag(2637, ts3.DiagnosticCategory.Error, "Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_t_2637", "Variance annotations are only supported in type aliases for object, function, constructor, and mapped types."),
        Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity: diag(2649, ts3.DiagnosticCategory.Error, "Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649", "Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),
        A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums: diag(2651, ts3.DiagnosticCategory.Error, "A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651", "A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),
        Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead: diag(2652, ts3.DiagnosticCategory.Error, "Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652", "Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),
        Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1: diag(2653, ts3.DiagnosticCategory.Error, "Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653", "Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),
        JSX_expressions_must_have_one_parent_element: diag(2657, ts3.DiagnosticCategory.Error, "JSX_expressions_must_have_one_parent_element_2657", "JSX expressions must have one parent element."),
        Type_0_provides_no_match_for_the_signature_1: diag(2658, ts3.DiagnosticCategory.Error, "Type_0_provides_no_match_for_the_signature_1_2658", "Type '{0}' provides no match for the signature '{1}'."),
        super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher: diag(2659, ts3.DiagnosticCategory.Error, "super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659", "'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),
        super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions: diag(2660, ts3.DiagnosticCategory.Error, "super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660", "'super' can only be referenced in members of derived classes or object literal expressions."),
        Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module: diag(2661, ts3.DiagnosticCategory.Error, "Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661", "Cannot export '{0}'. Only local declarations can be exported from a module."),
        Cannot_find_name_0_Did_you_mean_the_static_member_1_0: diag(2662, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662", "Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),
        Cannot_find_name_0_Did_you_mean_the_instance_member_this_0: diag(2663, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663", "Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),
        Invalid_module_name_in_augmentation_module_0_cannot_be_found: diag(2664, ts3.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664", "Invalid module name in augmentation, module '{0}' cannot be found."),
        Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented: diag(2665, ts3.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665", "Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),
        Exports_and_export_assignments_are_not_permitted_in_module_augmentations: diag(2666, ts3.DiagnosticCategory.Error, "Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666", "Exports and export assignments are not permitted in module augmentations."),
        Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module: diag(2667, ts3.DiagnosticCategory.Error, "Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667", "Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),
        export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible: diag(2668, ts3.DiagnosticCategory.Error, "export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668", "'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),
        Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations: diag(2669, ts3.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669", "Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),
        Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context: diag(2670, ts3.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670", "Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),
        Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity: diag(2671, ts3.DiagnosticCategory.Error, "Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671", "Cannot augment module '{0}' because it resolves to a non-module entity."),
        Cannot_assign_a_0_constructor_type_to_a_1_constructor_type: diag(2672, ts3.DiagnosticCategory.Error, "Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672", "Cannot assign a '{0}' constructor type to a '{1}' constructor type."),
        Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration: diag(2673, ts3.DiagnosticCategory.Error, "Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673", "Constructor of class '{0}' is private and only accessible within the class declaration."),
        Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration: diag(2674, ts3.DiagnosticCategory.Error, "Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674", "Constructor of class '{0}' is protected and only accessible within the class declaration."),
        Cannot_extend_a_class_0_Class_constructor_is_marked_as_private: diag(2675, ts3.DiagnosticCategory.Error, "Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675", "Cannot extend a class '{0}'. Class constructor is marked as private."),
        Accessors_must_both_be_abstract_or_non_abstract: diag(2676, ts3.DiagnosticCategory.Error, "Accessors_must_both_be_abstract_or_non_abstract_2676", "Accessors must both be abstract or non-abstract."),
        A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type: diag(2677, ts3.DiagnosticCategory.Error, "A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677", "A type predicate's type must be assignable to its parameter's type."),
        Type_0_is_not_comparable_to_type_1: diag(2678, ts3.DiagnosticCategory.Error, "Type_0_is_not_comparable_to_type_1_2678", "Type '{0}' is not comparable to type '{1}'."),
        A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void: diag(2679, ts3.DiagnosticCategory.Error, "A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679", "A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),
        A_0_parameter_must_be_the_first_parameter: diag(2680, ts3.DiagnosticCategory.Error, "A_0_parameter_must_be_the_first_parameter_2680", "A '{0}' parameter must be the first parameter."),
        A_constructor_cannot_have_a_this_parameter: diag(2681, ts3.DiagnosticCategory.Error, "A_constructor_cannot_have_a_this_parameter_2681", "A constructor cannot have a 'this' parameter."),
        this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation: diag(2683, ts3.DiagnosticCategory.Error, "this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683", "'this' implicitly has type 'any' because it does not have a type annotation."),
        The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1: diag(2684, ts3.DiagnosticCategory.Error, "The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684", "The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),
        The_this_types_of_each_signature_are_incompatible: diag(2685, ts3.DiagnosticCategory.Error, "The_this_types_of_each_signature_are_incompatible_2685", "The 'this' types of each signature are incompatible."),
        _0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead: diag(2686, ts3.DiagnosticCategory.Error, "_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686", "'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),
        All_declarations_of_0_must_have_identical_modifiers: diag(2687, ts3.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_modifiers_2687", "All declarations of '{0}' must have identical modifiers."),
        Cannot_find_type_definition_file_for_0: diag(2688, ts3.DiagnosticCategory.Error, "Cannot_find_type_definition_file_for_0_2688", "Cannot find type definition file for '{0}'."),
        Cannot_extend_an_interface_0_Did_you_mean_implements: diag(2689, ts3.DiagnosticCategory.Error, "Cannot_extend_an_interface_0_Did_you_mean_implements_2689", "Cannot extend an interface '{0}'. Did you mean 'implements'?"),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0: diag(2690, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690", "'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"),
        An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead: diag(2691, ts3.DiagnosticCategory.Error, "An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691", "An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."),
        _0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible: diag(2692, ts3.DiagnosticCategory.Error, "_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692", "'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here: diag(2693, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693", "'{0}' only refers to a type, but is being used as a value here."),
        Namespace_0_has_no_exported_member_1: diag(2694, ts3.DiagnosticCategory.Error, "Namespace_0_has_no_exported_member_1_2694", "Namespace '{0}' has no exported member '{1}'."),
        Left_side_of_comma_operator_is_unused_and_has_no_side_effects: diag(2695, ts3.DiagnosticCategory.Error, "Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695", "Left side of comma operator is unused and has no side effects.", true),
        The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead: diag(2696, ts3.DiagnosticCategory.Error, "The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696", "The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),
        An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2697, ts3.DiagnosticCategory.Error, "An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697", "An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),
        Spread_types_may_only_be_created_from_object_types: diag(2698, ts3.DiagnosticCategory.Error, "Spread_types_may_only_be_created_from_object_types_2698", "Spread types may only be created from object types."),
        Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1: diag(2699, ts3.DiagnosticCategory.Error, "Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699", "Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),
        Rest_types_may_only_be_created_from_object_types: diag(2700, ts3.DiagnosticCategory.Error, "Rest_types_may_only_be_created_from_object_types_2700", "Rest types may only be created from object types."),
        The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access: diag(2701, ts3.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701", "The target of an object rest assignment must be a variable or a property access."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here: diag(2702, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702", "'{0}' only refers to a type, but is being used as a namespace here."),
        The_operand_of_a_delete_operator_must_be_a_property_reference: diag(2703, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_a_property_reference_2703", "The operand of a 'delete' operator must be a property reference."),
        The_operand_of_a_delete_operator_cannot_be_a_read_only_property: diag(2704, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704", "The operand of a 'delete' operator cannot be a read-only property."),
        An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2705, ts3.DiagnosticCategory.Error, "An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705", "An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),
        Required_type_parameters_may_not_follow_optional_type_parameters: diag(2706, ts3.DiagnosticCategory.Error, "Required_type_parameters_may_not_follow_optional_type_parameters_2706", "Required type parameters may not follow optional type parameters."),
        Generic_type_0_requires_between_1_and_2_type_arguments: diag(2707, ts3.DiagnosticCategory.Error, "Generic_type_0_requires_between_1_and_2_type_arguments_2707", "Generic type '{0}' requires between {1} and {2} type arguments."),
        Cannot_use_namespace_0_as_a_value: diag(2708, ts3.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_value_2708", "Cannot use namespace '{0}' as a value."),
        Cannot_use_namespace_0_as_a_type: diag(2709, ts3.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_type_2709", "Cannot use namespace '{0}' as a type."),
        _0_are_specified_twice_The_attribute_named_0_will_be_overwritten: diag(2710, ts3.DiagnosticCategory.Error, "_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710", "'{0}' are specified twice. The attribute named '{0}' will be overwritten."),
        A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2711, ts3.DiagnosticCategory.Error, "A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711", "A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),
        A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2712, ts3.DiagnosticCategory.Error, "A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712", "A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),
        Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1: diag(2713, ts3.DiagnosticCategory.Error, "Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713", `Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`),
        The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context: diag(2714, ts3.DiagnosticCategory.Error, "The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714", "The expression of an export assignment must be an identifier or qualified name in an ambient context."),
        Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor: diag(2715, ts3.DiagnosticCategory.Error, "Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715", "Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),
        Type_parameter_0_has_a_circular_default: diag(2716, ts3.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_default_2716", "Type parameter '{0}' has a circular default."),
        Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2: diag(2717, ts3.DiagnosticCategory.Error, "Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717", "Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),
        Duplicate_property_0: diag(2718, ts3.DiagnosticCategory.Error, "Duplicate_property_0_2718", "Duplicate property '{0}'."),
        Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated: diag(2719, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719", "Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),
        Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass: diag(2720, ts3.DiagnosticCategory.Error, "Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720", "Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),
        Cannot_invoke_an_object_which_is_possibly_null: diag(2721, ts3.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_2721", "Cannot invoke an object which is possibly 'null'."),
        Cannot_invoke_an_object_which_is_possibly_undefined: diag(2722, ts3.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_undefined_2722", "Cannot invoke an object which is possibly 'undefined'."),
        Cannot_invoke_an_object_which_is_possibly_null_or_undefined: diag(2723, ts3.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723", "Cannot invoke an object which is possibly 'null' or 'undefined'."),
        _0_has_no_exported_member_named_1_Did_you_mean_2: diag(2724, ts3.DiagnosticCategory.Error, "_0_has_no_exported_member_named_1_Did_you_mean_2_2724", "'{0}' has no exported member named '{1}'. Did you mean '{2}'?"),
        Class_name_cannot_be_Object_when_targeting_ES5_with_module_0: diag(2725, ts3.DiagnosticCategory.Error, "Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725", "Class name cannot be 'Object' when targeting ES5 with module {0}."),
        Cannot_find_lib_definition_for_0: diag(2726, ts3.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_2726", "Cannot find lib definition for '{0}'."),
        Cannot_find_lib_definition_for_0_Did_you_mean_1: diag(2727, ts3.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_Did_you_mean_1_2727", "Cannot find lib definition for '{0}'. Did you mean '{1}'?"),
        _0_is_declared_here: diag(2728, ts3.DiagnosticCategory.Message, "_0_is_declared_here_2728", "'{0}' is declared here."),
        Property_0_is_used_before_its_initialization: diag(2729, ts3.DiagnosticCategory.Error, "Property_0_is_used_before_its_initialization_2729", "Property '{0}' is used before its initialization."),
        An_arrow_function_cannot_have_a_this_parameter: diag(2730, ts3.DiagnosticCategory.Error, "An_arrow_function_cannot_have_a_this_parameter_2730", "An arrow function cannot have a 'this' parameter."),
        Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String: diag(2731, ts3.DiagnosticCategory.Error, "Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731", "Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),
        Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension: diag(2732, ts3.DiagnosticCategory.Error, "Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732", "Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."),
        Property_0_was_also_declared_here: diag(2733, ts3.DiagnosticCategory.Error, "Property_0_was_also_declared_here_2733", "Property '{0}' was also declared here."),
        Are_you_missing_a_semicolon: diag(2734, ts3.DiagnosticCategory.Error, "Are_you_missing_a_semicolon_2734", "Are you missing a semicolon?"),
        Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1: diag(2735, ts3.DiagnosticCategory.Error, "Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735", "Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),
        Operator_0_cannot_be_applied_to_type_1: diag(2736, ts3.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_type_1_2736", "Operator '{0}' cannot be applied to type '{1}'."),
        BigInt_literals_are_not_available_when_targeting_lower_than_ES2020: diag(2737, ts3.DiagnosticCategory.Error, "BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737", "BigInt literals are not available when targeting lower than ES2020."),
        An_outer_value_of_this_is_shadowed_by_this_container: diag(2738, ts3.DiagnosticCategory.Message, "An_outer_value_of_this_is_shadowed_by_this_container_2738", "An outer value of 'this' is shadowed by this container."),
        Type_0_is_missing_the_following_properties_from_type_1_Colon_2: diag(2739, ts3.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739", "Type '{0}' is missing the following properties from type '{1}': {2}"),
        Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more: diag(2740, ts3.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740", "Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),
        Property_0_is_missing_in_type_1_but_required_in_type_2: diag(2741, ts3.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_but_required_in_type_2_2741", "Property '{0}' is missing in type '{1}' but required in type '{2}'."),
        The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary: diag(2742, ts3.DiagnosticCategory.Error, "The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742", "The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),
        No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments: diag(2743, ts3.DiagnosticCategory.Error, "No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743", "No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),
        Type_parameter_defaults_can_only_reference_previously_declared_type_parameters: diag(2744, ts3.DiagnosticCategory.Error, "Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744", "Type parameter defaults can only reference previously declared type parameters."),
        This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided: diag(2745, ts3.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745", "This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),
        This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided: diag(2746, ts3.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746", "This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),
        _0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2: diag(2747, ts3.DiagnosticCategory.Error, "_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747", "'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),
        Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided: diag(2748, ts3.DiagnosticCategory.Error, "Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided_2748", "Cannot access ambient const enums when the '--isolatedModules' flag is provided."),
        _0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0: diag(2749, ts3.DiagnosticCategory.Error, "_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749", "'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"),
        The_implementation_signature_is_declared_here: diag(2750, ts3.DiagnosticCategory.Error, "The_implementation_signature_is_declared_here_2750", "The implementation signature is declared here."),
        Circularity_originates_in_type_at_this_location: diag(2751, ts3.DiagnosticCategory.Error, "Circularity_originates_in_type_at_this_location_2751", "Circularity originates in type at this location."),
        The_first_export_default_is_here: diag(2752, ts3.DiagnosticCategory.Error, "The_first_export_default_is_here_2752", "The first export default is here."),
        Another_export_default_is_here: diag(2753, ts3.DiagnosticCategory.Error, "Another_export_default_is_here_2753", "Another export default is here."),
        super_may_not_use_type_arguments: diag(2754, ts3.DiagnosticCategory.Error, "super_may_not_use_type_arguments_2754", "'super' may not use type arguments."),
        No_constituent_of_type_0_is_callable: diag(2755, ts3.DiagnosticCategory.Error, "No_constituent_of_type_0_is_callable_2755", "No constituent of type '{0}' is callable."),
        Not_all_constituents_of_type_0_are_callable: diag(2756, ts3.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_callable_2756", "Not all constituents of type '{0}' are callable."),
        Type_0_has_no_call_signatures: diag(2757, ts3.DiagnosticCategory.Error, "Type_0_has_no_call_signatures_2757", "Type '{0}' has no call signatures."),
        Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2758, ts3.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758", "Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."),
        No_constituent_of_type_0_is_constructable: diag(2759, ts3.DiagnosticCategory.Error, "No_constituent_of_type_0_is_constructable_2759", "No constituent of type '{0}' is constructable."),
        Not_all_constituents_of_type_0_are_constructable: diag(2760, ts3.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_constructable_2760", "Not all constituents of type '{0}' are constructable."),
        Type_0_has_no_construct_signatures: diag(2761, ts3.DiagnosticCategory.Error, "Type_0_has_no_construct_signatures_2761", "Type '{0}' has no construct signatures."),
        Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2762, ts3.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762", "Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0: diag(2763, ts3.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0: diag(2764, ts3.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0: diag(2765, ts3.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."),
        Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0: diag(2766, ts3.DiagnosticCategory.Error, "Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766", "Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."),
        The_0_property_of_an_iterator_must_be_a_method: diag(2767, ts3.DiagnosticCategory.Error, "The_0_property_of_an_iterator_must_be_a_method_2767", "The '{0}' property of an iterator must be a method."),
        The_0_property_of_an_async_iterator_must_be_a_method: diag(2768, ts3.DiagnosticCategory.Error, "The_0_property_of_an_async_iterator_must_be_a_method_2768", "The '{0}' property of an async iterator must be a method."),
        No_overload_matches_this_call: diag(2769, ts3.DiagnosticCategory.Error, "No_overload_matches_this_call_2769", "No overload matches this call."),
        The_last_overload_gave_the_following_error: diag(2770, ts3.DiagnosticCategory.Error, "The_last_overload_gave_the_following_error_2770", "The last overload gave the following error."),
        The_last_overload_is_declared_here: diag(2771, ts3.DiagnosticCategory.Error, "The_last_overload_is_declared_here_2771", "The last overload is declared here."),
        Overload_0_of_1_2_gave_the_following_error: diag(2772, ts3.DiagnosticCategory.Error, "Overload_0_of_1_2_gave_the_following_error_2772", "Overload {0} of {1}, '{2}', gave the following error."),
        Did_you_forget_to_use_await: diag(2773, ts3.DiagnosticCategory.Error, "Did_you_forget_to_use_await_2773", "Did you forget to use 'await'?"),
        This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead: diag(2774, ts3.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774", "This condition will always return true since this function is always defined. Did you mean to call it instead?"),
        Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation: diag(2775, ts3.DiagnosticCategory.Error, "Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775", "Assertions require every name in the call target to be declared with an explicit type annotation."),
        Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name: diag(2776, ts3.DiagnosticCategory.Error, "Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776", "Assertions require the call target to be an identifier or qualified name."),
        The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access: diag(2777, ts3.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777", "The operand of an increment or decrement operator may not be an optional property access."),
        The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access: diag(2778, ts3.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778", "The target of an object rest assignment may not be an optional property access."),
        The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access: diag(2779, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779", "The left-hand side of an assignment expression may not be an optional property access."),
        The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access: diag(2780, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780", "The left-hand side of a 'for...in' statement may not be an optional property access."),
        The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access: diag(2781, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781", "The left-hand side of a 'for...of' statement may not be an optional property access."),
        _0_needs_an_explicit_type_annotation: diag(2782, ts3.DiagnosticCategory.Message, "_0_needs_an_explicit_type_annotation_2782", "'{0}' needs an explicit type annotation."),
        _0_is_specified_more_than_once_so_this_usage_will_be_overwritten: diag(2783, ts3.DiagnosticCategory.Error, "_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783", "'{0}' is specified more than once, so this usage will be overwritten."),
        get_and_set_accessors_cannot_declare_this_parameters: diag(2784, ts3.DiagnosticCategory.Error, "get_and_set_accessors_cannot_declare_this_parameters_2784", "'get' and 'set' accessors cannot declare 'this' parameters."),
        This_spread_always_overwrites_this_property: diag(2785, ts3.DiagnosticCategory.Error, "This_spread_always_overwrites_this_property_2785", "This spread always overwrites this property."),
        _0_cannot_be_used_as_a_JSX_component: diag(2786, ts3.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_JSX_component_2786", "'{0}' cannot be used as a JSX component."),
        Its_return_type_0_is_not_a_valid_JSX_element: diag(2787, ts3.DiagnosticCategory.Error, "Its_return_type_0_is_not_a_valid_JSX_element_2787", "Its return type '{0}' is not a valid JSX element."),
        Its_instance_type_0_is_not_a_valid_JSX_element: diag(2788, ts3.DiagnosticCategory.Error, "Its_instance_type_0_is_not_a_valid_JSX_element_2788", "Its instance type '{0}' is not a valid JSX element."),
        Its_element_type_0_is_not_a_valid_JSX_element: diag(2789, ts3.DiagnosticCategory.Error, "Its_element_type_0_is_not_a_valid_JSX_element_2789", "Its element type '{0}' is not a valid JSX element."),
        The_operand_of_a_delete_operator_must_be_optional: diag(2790, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_optional_2790", "The operand of a 'delete' operator must be optional."),
        Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later: diag(2791, ts3.DiagnosticCategory.Error, "Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791", "Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."),
        Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option: diag(2792, ts3.DiagnosticCategory.Error, "Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_th_2792", "Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'node', or to add aliases to the 'paths' option?"),
        The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible: diag(2793, ts3.DiagnosticCategory.Error, "The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793", "The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."),
        Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise: diag(2794, ts3.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794", "Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"),
        The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types: diag(2795, ts3.DiagnosticCategory.Error, "The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795", "The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."),
        It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked: diag(2796, ts3.DiagnosticCategory.Error, "It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796", "It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."),
        A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract: diag(2797, ts3.DiagnosticCategory.Error, "A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797", "A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."),
        The_declaration_was_marked_as_deprecated_here: diag(2798, ts3.DiagnosticCategory.Error, "The_declaration_was_marked_as_deprecated_here_2798", "The declaration was marked as deprecated here."),
        Type_produces_a_tuple_type_that_is_too_large_to_represent: diag(2799, ts3.DiagnosticCategory.Error, "Type_produces_a_tuple_type_that_is_too_large_to_represent_2799", "Type produces a tuple type that is too large to represent."),
        Expression_produces_a_tuple_type_that_is_too_large_to_represent: diag(2800, ts3.DiagnosticCategory.Error, "Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800", "Expression produces a tuple type that is too large to represent."),
        This_condition_will_always_return_true_since_this_0_is_always_defined: diag(2801, ts3.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_0_is_always_defined_2801", "This condition will always return true since this '{0}' is always defined."),
        Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher: diag(2802, ts3.DiagnosticCategory.Error, "Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802", "Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."),
        Cannot_assign_to_private_method_0_Private_methods_are_not_writable: diag(2803, ts3.DiagnosticCategory.Error, "Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803", "Cannot assign to private method '{0}'. Private methods are not writable."),
        Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name: diag(2804, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804", "Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."),
        Private_accessor_was_defined_without_a_getter: diag(2806, ts3.DiagnosticCategory.Error, "Private_accessor_was_defined_without_a_getter_2806", "Private accessor was defined without a getter."),
        This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0: diag(2807, ts3.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807", "This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."),
        A_get_accessor_must_be_at_least_as_accessible_as_the_setter: diag(2808, ts3.DiagnosticCategory.Error, "A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808", "A get accessor must be at least as accessible as the setter"),
        Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses: diag(2809, ts3.DiagnosticCategory.Error, "Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809", "Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the the whole assignment in parentheses."),
        Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments: diag(2810, ts3.DiagnosticCategory.Error, "Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_2810", "Expected 1 argument, but got 0. 'new Promise()' needs a JSDoc hint to produce a 'resolve' that can be called without arguments."),
        Initializer_for_property_0: diag(2811, ts3.DiagnosticCategory.Error, "Initializer_for_property_0_2811", "Initializer for property '{0}'"),
        Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom: diag(2812, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812", "Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."),
        Class_declaration_cannot_implement_overload_list_for_0: diag(2813, ts3.DiagnosticCategory.Error, "Class_declaration_cannot_implement_overload_list_for_0_2813", "Class declaration cannot implement overload list for '{0}'."),
        Function_with_bodies_can_only_merge_with_classes_that_are_ambient: diag(2814, ts3.DiagnosticCategory.Error, "Function_with_bodies_can_only_merge_with_classes_that_are_ambient_2814", "Function with bodies can only merge with classes that are ambient."),
        arguments_cannot_be_referenced_in_property_initializers: diag(2815, ts3.DiagnosticCategory.Error, "arguments_cannot_be_referenced_in_property_initializers_2815", "'arguments' cannot be referenced in property initializers."),
        Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class: diag(2816, ts3.DiagnosticCategory.Error, "Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class_2816", "Cannot use 'this' in a static property initializer of a decorated class."),
        Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block: diag(2817, ts3.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block_2817", "Property '{0}' has no initializer and is not definitely assigned in a class static block."),
        Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers: diag(2818, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializer_2818", "Duplicate identifier '{0}'. Compiler reserves name '{1}' when emitting 'super' references in static initializers."),
        Namespace_name_cannot_be_0: diag(2819, ts3.DiagnosticCategory.Error, "Namespace_name_cannot_be_0_2819", "Namespace name cannot be '{0}'."),
        Type_0_is_not_assignable_to_type_1_Did_you_mean_2: diag(2820, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Did_you_mean_2_2820", "Type '{0}' is not assignable to type '{1}'. Did you mean '{2}'?"),
        Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext: diag(2821, ts3.DiagnosticCategory.Error, "Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext_2821", "Import assertions are only supported when the '--module' option is set to 'esnext' or 'nodenext'."),
        Import_assertions_cannot_be_used_with_type_only_imports_or_exports: diag(2822, ts3.DiagnosticCategory.Error, "Import_assertions_cannot_be_used_with_type_only_imports_or_exports_2822", "Import assertions cannot be used with type-only imports or exports."),
        Cannot_find_namespace_0_Did_you_mean_1: diag(2833, ts3.DiagnosticCategory.Error, "Cannot_find_namespace_0_Did_you_mean_1_2833", "Cannot find namespace '{0}'. Did you mean '{1}'?"),
        Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path: diag(2834, ts3.DiagnosticCategory.Error, "Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_n_2834", "Relative import paths need explicit file extensions in EcmaScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Consider adding an extension to the import path."),
        Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0: diag(2835, ts3.DiagnosticCategory.Error, "Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_n_2835", "Relative import paths need explicit file extensions in EcmaScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Did you mean '{0}'?"),
        Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls: diag(2836, ts3.DiagnosticCategory.Error, "Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls_2836", "Import assertions are not allowed on statements that transpile to commonjs 'require' calls."),
        Import_assertion_values_must_be_string_literal_expressions: diag(2837, ts3.DiagnosticCategory.Error, "Import_assertion_values_must_be_string_literal_expressions_2837", "Import assertion values must be string literal expressions."),
        All_declarations_of_0_must_have_identical_constraints: diag(2838, ts3.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_constraints_2838", "All declarations of '{0}' must have identical constraints."),
        The_type_of_this_expression_cannot_be_named_without_a_resolution_mode_assertion_which_is_an_unstable_feature_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: diag(2841, ts3.DiagnosticCategory.Error, "The_type_of_this_expression_cannot_be_named_without_a_resolution_mode_assertion_which_is_an_unstable_2841", "The type of this expression cannot be named without a 'resolution-mode' assertion, which is an unstable feature. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."),
        Import_declaration_0_is_using_private_name_1: diag(4e3, ts3.DiagnosticCategory.Error, "Import_declaration_0_is_using_private_name_1_4000", "Import declaration '{0}' is using private name '{1}'."),
        Type_parameter_0_of_exported_class_has_or_is_using_private_name_1: diag(4002, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002", "Type parameter '{0}' of exported class has or is using private name '{1}'."),
        Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1: diag(4004, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004", "Type parameter '{0}' of exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4006, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006", "Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4008, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008", "Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4010, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010", "Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
        Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4012, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012", "Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),
        Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4014, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014", "Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4016, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016", "Type parameter '{0}' of exported function has or is using private name '{1}'."),
        Implements_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4019, ts3.DiagnosticCategory.Error, "Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019", "Implements clause of exported class '{0}' has or is using private name '{1}'."),
        extends_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4020, ts3.DiagnosticCategory.Error, "extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020", "'extends' clause of exported class '{0}' has or is using private name '{1}'."),
        extends_clause_of_exported_class_has_or_is_using_private_name_0: diag(4021, ts3.DiagnosticCategory.Error, "extends_clause_of_exported_class_has_or_is_using_private_name_0_4021", "'extends' clause of exported class has or is using private name '{0}'."),
        extends_clause_of_exported_interface_0_has_or_is_using_private_name_1: diag(4022, ts3.DiagnosticCategory.Error, "extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022", "'extends' clause of exported interface '{0}' has or is using private name '{1}'."),
        Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4023, ts3.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023", "Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),
        Exported_variable_0_has_or_is_using_name_1_from_private_module_2: diag(4024, ts3.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024", "Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),
        Exported_variable_0_has_or_is_using_private_name_1: diag(4025, ts3.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_private_name_1_4025", "Exported variable '{0}' has or is using private name '{1}'."),
        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4026, ts3.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026", "Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4027, ts3.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027", "Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_static_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4028, ts3.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028", "Public static property '{0}' of exported class has or is using private name '{1}'."),
        Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4029, ts3.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029", "Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4030, ts3.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030", "Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4031, ts3.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031", "Public property '{0}' of exported class has or is using private name '{1}'."),
        Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4032, ts3.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032", "Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
        Property_0_of_exported_interface_has_or_is_using_private_name_1: diag(4033, ts3.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_private_name_1_4033", "Property '{0}' of exported interface has or is using private name '{1}'."),
        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4034, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034", "Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4035, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035", "Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),
        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4036, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036", "Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4037, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037", "Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4038, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4039, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4040, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040", "Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4041, ts3.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041", "Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4042, ts3.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042", "Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4043, ts3.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043", "Return type of public getter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4044, ts3.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044", "Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4045, ts3.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045", "Return type of constructor signature from exported interface has or is using private name '{0}'."),
        Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4046, ts3.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046", "Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4047, ts3.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047", "Return type of call signature from exported interface has or is using private name '{0}'."),
        Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4048, ts3.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048", "Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4049, ts3.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049", "Return type of index signature from exported interface has or is using private name '{0}'."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4050, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050", "Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4051, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051", "Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0: diag(4052, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052", "Return type of public static method from exported class has or is using private name '{0}'."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4053, ts3.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053", "Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4054, ts3.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054", "Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0: diag(4055, ts3.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055", "Return type of public method from exported class has or is using private name '{0}'."),
        Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4056, ts3.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056", "Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0: diag(4057, ts3.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057", "Return type of method from exported interface has or is using private name '{0}'."),
        Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4058, ts3.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058", "Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1: diag(4059, ts3.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059", "Return type of exported function has or is using name '{0}' from private module '{1}'."),
        Return_type_of_exported_function_has_or_is_using_private_name_0: diag(4060, ts3.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_private_name_0_4060", "Return type of exported function has or is using private name '{0}'."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4061, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4062, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1: diag(4063, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063", "Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),
        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4064, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064", "Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4065, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065", "Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4066, ts3.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066", "Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4067, ts3.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067", "Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4068, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4069, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4070, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070", "Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4071, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071", "Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4072, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072", "Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4073, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073", "Parameter '{0}' of public method from exported class has or is using private name '{1}'."),
        Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4074, ts3.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074", "Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4075, ts3.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075", "Parameter '{0}' of method from exported interface has or is using private name '{1}'."),
        Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4076, ts3.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076", "Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2: diag(4077, ts3.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077", "Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4078, ts3.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078", "Parameter '{0}' of exported function has or is using private name '{1}'."),
        Exported_type_alias_0_has_or_is_using_private_name_1: diag(4081, ts3.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_4081", "Exported type alias '{0}' has or is using private name '{1}'."),
        Default_export_of_the_module_has_or_is_using_private_name_0: diag(4082, ts3.DiagnosticCategory.Error, "Default_export_of_the_module_has_or_is_using_private_name_0_4082", "Default export of the module has or is using private name '{0}'."),
        Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1: diag(4083, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083", "Type parameter '{0}' of exported type alias has or is using private name '{1}'."),
        Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2: diag(4084, ts3.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084", "Exported type alias '{0}' has or is using private name '{1}' from module {2}."),
        Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict: diag(4090, ts3.DiagnosticCategory.Error, "Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090", "Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),
        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4091, ts3.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091", "Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4092, ts3.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092", "Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),
        Property_0_of_exported_class_expression_may_not_be_private_or_protected: diag(4094, ts3.DiagnosticCategory.Error, "Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094", "Property '{0}' of exported class expression may not be private or protected."),
        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4095, ts3.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095", "Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4096, ts3.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096", "Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_static_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4097, ts3.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097", "Public static method '{0}' of exported class has or is using private name '{1}'."),
        Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4098, ts3.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098", "Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4099, ts3.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099", "Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4100, ts3.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100", "Public method '{0}' of exported class has or is using private name '{1}'."),
        Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4101, ts3.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101", "Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
        Method_0_of_exported_interface_has_or_is_using_private_name_1: diag(4102, ts3.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_private_name_1_4102", "Method '{0}' of exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1: diag(4103, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103", "Type parameter '{0}' of exported mapped object type is using private name '{1}'."),
        The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1: diag(4104, ts3.DiagnosticCategory.Error, "The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104", "The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),
        Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter: diag(4105, ts3.DiagnosticCategory.Error, "Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105", "Private or protected member '{0}' cannot be accessed on a type parameter."),
        Parameter_0_of_accessor_has_or_is_using_private_name_1: diag(4106, ts3.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_private_name_1_4106", "Parameter '{0}' of accessor has or is using private name '{1}'."),
        Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2: diag(4107, ts3.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107", "Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4108, ts3.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108", "Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."),
        Type_arguments_for_0_circularly_reference_themselves: diag(4109, ts3.DiagnosticCategory.Error, "Type_arguments_for_0_circularly_reference_themselves_4109", "Type arguments for '{0}' circularly reference themselves."),
        Tuple_type_arguments_circularly_reference_themselves: diag(4110, ts3.DiagnosticCategory.Error, "Tuple_type_arguments_circularly_reference_themselves_4110", "Tuple type arguments circularly reference themselves."),
        Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0: diag(4111, ts3.DiagnosticCategory.Error, "Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111", "Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."),
        This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class: diag(4112, ts3.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112", "This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."),
        This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0: diag(4113, ts3.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."),
        This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0: diag(4114, ts3.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114", "This member must have an 'override' modifier because it overrides a member in the base class '{0}'."),
        This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0: diag(4115, ts3.DiagnosticCategory.Error, "This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115", "This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."),
        This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0: diag(4116, ts3.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116", "This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."),
        This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: diag(4117, ts3.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you__4117", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'. Did you mean '{1}'?"),
        The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized: diag(4118, ts3.DiagnosticCategory.Error, "The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized_4118", "The type of this node cannot be serialized because its property '{0}' cannot be serialized."),
        This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: diag(4119, ts3.DiagnosticCategory.Error, "This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_4119", "This member must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),
        This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: diag(4120, ts3.DiagnosticCategory.Error, "This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_4120", "This parameter property must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),
        This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class: diag(4121, ts3.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_4121", "This member cannot have a JSDoc comment with an '@override' tag because its containing class '{0}' does not extend another class."),
        This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0: diag(4122, ts3.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4122", "This member cannot have a JSDoc comment with an '@override' tag because it is not declared in the base class '{0}'."),
        This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: diag(4123, ts3.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4123", "This member cannot have a JSDoc comment with an 'override' tag because it is not declared in the base class '{0}'. Did you mean '{1}'?"),
        Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: diag(4124, ts3.DiagnosticCategory.Error, "Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_w_4124", "Compiler option '{0}' of value '{1}' is unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."),
        resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: diag(4125, ts3.DiagnosticCategory.Error, "resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_wi_4125", "'resolution-mode' assertions are unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."),
        The_current_host_does_not_support_the_0_option: diag(5001, ts3.DiagnosticCategory.Error, "The_current_host_does_not_support_the_0_option_5001", "The current host does not support the '{0}' option."),
        Cannot_find_the_common_subdirectory_path_for_the_input_files: diag(5009, ts3.DiagnosticCategory.Error, "Cannot_find_the_common_subdirectory_path_for_the_input_files_5009", "Cannot find the common subdirectory path for the input files."),
        File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5010, ts3.DiagnosticCategory.Error, "File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010", "File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),
        Cannot_read_file_0_Colon_1: diag(5012, ts3.DiagnosticCategory.Error, "Cannot_read_file_0_Colon_1_5012", "Cannot read file '{0}': {1}."),
        Failed_to_parse_file_0_Colon_1: diag(5014, ts3.DiagnosticCategory.Error, "Failed_to_parse_file_0_Colon_1_5014", "Failed to parse file '{0}': {1}."),
        Unknown_compiler_option_0: diag(5023, ts3.DiagnosticCategory.Error, "Unknown_compiler_option_0_5023", "Unknown compiler option '{0}'."),
        Compiler_option_0_requires_a_value_of_type_1: diag(5024, ts3.DiagnosticCategory.Error, "Compiler_option_0_requires_a_value_of_type_1_5024", "Compiler option '{0}' requires a value of type {1}."),
        Unknown_compiler_option_0_Did_you_mean_1: diag(5025, ts3.DiagnosticCategory.Error, "Unknown_compiler_option_0_Did_you_mean_1_5025", "Unknown compiler option '{0}'. Did you mean '{1}'?"),
        Could_not_write_file_0_Colon_1: diag(5033, ts3.DiagnosticCategory.Error, "Could_not_write_file_0_Colon_1_5033", "Could not write file '{0}': {1}."),
        Option_project_cannot_be_mixed_with_source_files_on_a_command_line: diag(5042, ts3.DiagnosticCategory.Error, "Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042", "Option 'project' cannot be mixed with source files on a command line."),
        Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher: diag(5047, ts3.DiagnosticCategory.Error, "Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047", "Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),
        Option_0_cannot_be_specified_when_option_target_is_ES3: diag(5048, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_target_is_ES3_5048", "Option '{0}' cannot be specified when option 'target' is 'ES3'."),
        Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided: diag(5051, ts3.DiagnosticCategory.Error, "Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051", "Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),
        Option_0_cannot_be_specified_without_specifying_option_1: diag(5052, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_5052", "Option '{0}' cannot be specified without specifying option '{1}'."),
        Option_0_cannot_be_specified_with_option_1: diag(5053, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_with_option_1_5053", "Option '{0}' cannot be specified with option '{1}'."),
        A_tsconfig_json_file_is_already_defined_at_Colon_0: diag(5054, ts3.DiagnosticCategory.Error, "A_tsconfig_json_file_is_already_defined_at_Colon_0_5054", "A 'tsconfig.json' file is already defined at: '{0}'."),
        Cannot_write_file_0_because_it_would_overwrite_input_file: diag(5055, ts3.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_overwrite_input_file_5055", "Cannot write file '{0}' because it would overwrite input file."),
        Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files: diag(5056, ts3.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056", "Cannot write file '{0}' because it would be overwritten by multiple input files."),
        Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0: diag(5057, ts3.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057", "Cannot find a tsconfig.json file at the specified directory: '{0}'."),
        The_specified_path_does_not_exist_Colon_0: diag(5058, ts3.DiagnosticCategory.Error, "The_specified_path_does_not_exist_Colon_0_5058", "The specified path does not exist: '{0}'."),
        Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier: diag(5059, ts3.DiagnosticCategory.Error, "Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059", "Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),
        Pattern_0_can_have_at_most_one_Asterisk_character: diag(5061, ts3.DiagnosticCategory.Error, "Pattern_0_can_have_at_most_one_Asterisk_character_5061", "Pattern '{0}' can have at most one '*' character."),
        Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character: diag(5062, ts3.DiagnosticCategory.Error, "Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062", "Substitution '{0}' in pattern '{1}' can have at most one '*' character."),
        Substitutions_for_pattern_0_should_be_an_array: diag(5063, ts3.DiagnosticCategory.Error, "Substitutions_for_pattern_0_should_be_an_array_5063", "Substitutions for pattern '{0}' should be an array."),
        Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2: diag(5064, ts3.DiagnosticCategory.Error, "Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064", "Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),
        File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5065, ts3.DiagnosticCategory.Error, "File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065", "File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),
        Substitutions_for_pattern_0_shouldn_t_be_an_empty_array: diag(5066, ts3.DiagnosticCategory.Error, "Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066", "Substitutions for pattern '{0}' shouldn't be an empty array."),
        Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(5067, ts3.DiagnosticCategory.Error, "Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067", "Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),
        Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig: diag(5068, ts3.DiagnosticCategory.Error, "Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068", "Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),
        Option_0_cannot_be_specified_without_specifying_option_1_or_option_2: diag(5069, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069", "Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),
        Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy: diag(5070, ts3.DiagnosticCategory.Error, "Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy_5070", "Option '--resolveJsonModule' cannot be specified without 'node' module resolution strategy."),
        Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext: diag(5071, ts3.DiagnosticCategory.Error, "Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_5071", "Option '--resolveJsonModule' can only be specified when module code generation is 'commonjs', 'amd', 'es2015' or 'esNext'."),
        Unknown_build_option_0: diag(5072, ts3.DiagnosticCategory.Error, "Unknown_build_option_0_5072", "Unknown build option '{0}'."),
        Build_option_0_requires_a_value_of_type_1: diag(5073, ts3.DiagnosticCategory.Error, "Build_option_0_requires_a_value_of_type_1_5073", "Build option '{0}' requires a value of type {1}."),
        Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified: diag(5074, ts3.DiagnosticCategory.Error, "Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074", "Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."),
        _0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2: diag(5075, ts3.DiagnosticCategory.Error, "_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075", "'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),
        _0_and_1_operations_cannot_be_mixed_without_parentheses: diag(5076, ts3.DiagnosticCategory.Error, "_0_and_1_operations_cannot_be_mixed_without_parentheses_5076", "'{0}' and '{1}' operations cannot be mixed without parentheses."),
        Unknown_build_option_0_Did_you_mean_1: diag(5077, ts3.DiagnosticCategory.Error, "Unknown_build_option_0_Did_you_mean_1_5077", "Unknown build option '{0}'. Did you mean '{1}'?"),
        Unknown_watch_option_0: diag(5078, ts3.DiagnosticCategory.Error, "Unknown_watch_option_0_5078", "Unknown watch option '{0}'."),
        Unknown_watch_option_0_Did_you_mean_1: diag(5079, ts3.DiagnosticCategory.Error, "Unknown_watch_option_0_Did_you_mean_1_5079", "Unknown watch option '{0}'. Did you mean '{1}'?"),
        Watch_option_0_requires_a_value_of_type_1: diag(5080, ts3.DiagnosticCategory.Error, "Watch_option_0_requires_a_value_of_type_1_5080", "Watch option '{0}' requires a value of type {1}."),
        Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0: diag(5081, ts3.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081", "Cannot find a tsconfig.json file at the current directory: {0}."),
        _0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1: diag(5082, ts3.DiagnosticCategory.Error, "_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082", "'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."),
        Cannot_read_file_0: diag(5083, ts3.DiagnosticCategory.Error, "Cannot_read_file_0_5083", "Cannot read file '{0}'."),
        Tuple_members_must_all_have_names_or_all_not_have_names: diag(5084, ts3.DiagnosticCategory.Error, "Tuple_members_must_all_have_names_or_all_not_have_names_5084", "Tuple members must all have names or all not have names."),
        A_tuple_member_cannot_be_both_optional_and_rest: diag(5085, ts3.DiagnosticCategory.Error, "A_tuple_member_cannot_be_both_optional_and_rest_5085", "A tuple member cannot be both optional and rest."),
        A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type: diag(5086, ts3.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086", "A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."),
        A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type: diag(5087, ts3.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087", "A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."),
        The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary: diag(5088, ts3.DiagnosticCategory.Error, "The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088", "The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."),
        Option_0_cannot_be_specified_when_option_jsx_is_1: diag(5089, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_jsx_is_1_5089", "Option '{0}' cannot be specified when option 'jsx' is '{1}'."),
        Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash: diag(5090, ts3.DiagnosticCategory.Error, "Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090", "Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"),
        Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled: diag(5091, ts3.DiagnosticCategory.Error, "Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled_5091", "Option 'preserveConstEnums' cannot be disabled when 'isolatedModules' is enabled."),
        The_root_value_of_a_0_file_must_be_an_object: diag(5092, ts3.DiagnosticCategory.Error, "The_root_value_of_a_0_file_must_be_an_object_5092", "The root value of a '{0}' file must be an object."),
        Compiler_option_0_may_only_be_used_with_build: diag(5093, ts3.DiagnosticCategory.Error, "Compiler_option_0_may_only_be_used_with_build_5093", "Compiler option '--{0}' may only be used with '--build'."),
        Compiler_option_0_may_not_be_used_with_build: diag(5094, ts3.DiagnosticCategory.Error, "Compiler_option_0_may_not_be_used_with_build_5094", "Compiler option '--{0}' may not be used with '--build'."),
        Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later: diag(5095, ts3.DiagnosticCategory.Error, "Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later_5095", "Option 'preserveValueImports' can only be used when 'module' is set to 'es2015' or later."),
        Generates_a_sourcemap_for_each_corresponding_d_ts_file: diag(6e3, ts3.DiagnosticCategory.Message, "Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000", "Generates a sourcemap for each corresponding '.d.ts' file."),
        Concatenate_and_emit_output_to_single_file: diag(6001, ts3.DiagnosticCategory.Message, "Concatenate_and_emit_output_to_single_file_6001", "Concatenate and emit output to single file."),
        Generates_corresponding_d_ts_file: diag(6002, ts3.DiagnosticCategory.Message, "Generates_corresponding_d_ts_file_6002", "Generates corresponding '.d.ts' file."),
        Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations: diag(6004, ts3.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004", "Specify the location where debugger should locate TypeScript files instead of source locations."),
        Watch_input_files: diag(6005, ts3.DiagnosticCategory.Message, "Watch_input_files_6005", "Watch input files."),
        Redirect_output_structure_to_the_directory: diag(6006, ts3.DiagnosticCategory.Message, "Redirect_output_structure_to_the_directory_6006", "Redirect output structure to the directory."),
        Do_not_erase_const_enum_declarations_in_generated_code: diag(6007, ts3.DiagnosticCategory.Message, "Do_not_erase_const_enum_declarations_in_generated_code_6007", "Do not erase const enum declarations in generated code."),
        Do_not_emit_outputs_if_any_errors_were_reported: diag(6008, ts3.DiagnosticCategory.Message, "Do_not_emit_outputs_if_any_errors_were_reported_6008", "Do not emit outputs if any errors were reported."),
        Do_not_emit_comments_to_output: diag(6009, ts3.DiagnosticCategory.Message, "Do_not_emit_comments_to_output_6009", "Do not emit comments to output."),
        Do_not_emit_outputs: diag(6010, ts3.DiagnosticCategory.Message, "Do_not_emit_outputs_6010", "Do not emit outputs."),
        Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking: diag(6011, ts3.DiagnosticCategory.Message, "Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011", "Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),
        Skip_type_checking_of_declaration_files: diag(6012, ts3.DiagnosticCategory.Message, "Skip_type_checking_of_declaration_files_6012", "Skip type checking of declaration files."),
        Do_not_resolve_the_real_path_of_symlinks: diag(6013, ts3.DiagnosticCategory.Message, "Do_not_resolve_the_real_path_of_symlinks_6013", "Do not resolve the real path of symlinks."),
        Only_emit_d_ts_declaration_files: diag(6014, ts3.DiagnosticCategory.Message, "Only_emit_d_ts_declaration_files_6014", "Only emit '.d.ts' declaration files."),
        Specify_ECMAScript_target_version: diag(6015, ts3.DiagnosticCategory.Message, "Specify_ECMAScript_target_version_6015", "Specify ECMAScript target version."),
        Specify_module_code_generation: diag(6016, ts3.DiagnosticCategory.Message, "Specify_module_code_generation_6016", "Specify module code generation."),
        Print_this_message: diag(6017, ts3.DiagnosticCategory.Message, "Print_this_message_6017", "Print this message."),
        Print_the_compiler_s_version: diag(6019, ts3.DiagnosticCategory.Message, "Print_the_compiler_s_version_6019", "Print the compiler's version."),
        Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json: diag(6020, ts3.DiagnosticCategory.Message, "Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020", "Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),
        Syntax_Colon_0: diag(6023, ts3.DiagnosticCategory.Message, "Syntax_Colon_0_6023", "Syntax: {0}"),
        options: diag(6024, ts3.DiagnosticCategory.Message, "options_6024", "options"),
        file: diag(6025, ts3.DiagnosticCategory.Message, "file_6025", "file"),
        Examples_Colon_0: diag(6026, ts3.DiagnosticCategory.Message, "Examples_Colon_0_6026", "Examples: {0}"),
        Options_Colon: diag(6027, ts3.DiagnosticCategory.Message, "Options_Colon_6027", "Options:"),
        Version_0: diag(6029, ts3.DiagnosticCategory.Message, "Version_0_6029", "Version {0}"),
        Insert_command_line_options_and_files_from_a_file: diag(6030, ts3.DiagnosticCategory.Message, "Insert_command_line_options_and_files_from_a_file_6030", "Insert command line options and files from a file."),
        Starting_compilation_in_watch_mode: diag(6031, ts3.DiagnosticCategory.Message, "Starting_compilation_in_watch_mode_6031", "Starting compilation in watch mode..."),
        File_change_detected_Starting_incremental_compilation: diag(6032, ts3.DiagnosticCategory.Message, "File_change_detected_Starting_incremental_compilation_6032", "File change detected. Starting incremental compilation..."),
        KIND: diag(6034, ts3.DiagnosticCategory.Message, "KIND_6034", "KIND"),
        FILE: diag(6035, ts3.DiagnosticCategory.Message, "FILE_6035", "FILE"),
        VERSION: diag(6036, ts3.DiagnosticCategory.Message, "VERSION_6036", "VERSION"),
        LOCATION: diag(6037, ts3.DiagnosticCategory.Message, "LOCATION_6037", "LOCATION"),
        DIRECTORY: diag(6038, ts3.DiagnosticCategory.Message, "DIRECTORY_6038", "DIRECTORY"),
        STRATEGY: diag(6039, ts3.DiagnosticCategory.Message, "STRATEGY_6039", "STRATEGY"),
        FILE_OR_DIRECTORY: diag(6040, ts3.DiagnosticCategory.Message, "FILE_OR_DIRECTORY_6040", "FILE OR DIRECTORY"),
        Errors_Files: diag(6041, ts3.DiagnosticCategory.Message, "Errors_Files_6041", "Errors  Files"),
        Generates_corresponding_map_file: diag(6043, ts3.DiagnosticCategory.Message, "Generates_corresponding_map_file_6043", "Generates corresponding '.map' file."),
        Compiler_option_0_expects_an_argument: diag(6044, ts3.DiagnosticCategory.Error, "Compiler_option_0_expects_an_argument_6044", "Compiler option '{0}' expects an argument."),
        Unterminated_quoted_string_in_response_file_0: diag(6045, ts3.DiagnosticCategory.Error, "Unterminated_quoted_string_in_response_file_0_6045", "Unterminated quoted string in response file '{0}'."),
        Argument_for_0_option_must_be_Colon_1: diag(6046, ts3.DiagnosticCategory.Error, "Argument_for_0_option_must_be_Colon_1_6046", "Argument for '{0}' option must be: {1}."),
        Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1: diag(6048, ts3.DiagnosticCategory.Error, "Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048", "Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),
        Unable_to_open_file_0: diag(6050, ts3.DiagnosticCategory.Error, "Unable_to_open_file_0_6050", "Unable to open file '{0}'."),
        Corrupted_locale_file_0: diag(6051, ts3.DiagnosticCategory.Error, "Corrupted_locale_file_0_6051", "Corrupted locale file {0}."),
        Raise_error_on_expressions_and_declarations_with_an_implied_any_type: diag(6052, ts3.DiagnosticCategory.Message, "Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052", "Raise error on expressions and declarations with an implied 'any' type."),
        File_0_not_found: diag(6053, ts3.DiagnosticCategory.Error, "File_0_not_found_6053", "File '{0}' not found."),
        File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1: diag(6054, ts3.DiagnosticCategory.Error, "File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054", "File '{0}' has an unsupported extension. The only supported extensions are {1}."),
        Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures: diag(6055, ts3.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055", "Suppress noImplicitAny errors for indexing objects lacking index signatures."),
        Do_not_emit_declarations_for_code_that_has_an_internal_annotation: diag(6056, ts3.DiagnosticCategory.Message, "Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056", "Do not emit declarations for code that has an '@internal' annotation."),
        Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir: diag(6058, ts3.DiagnosticCategory.Message, "Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058", "Specify the root directory of input files. Use to control the output directory structure with --outDir."),
        File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files: diag(6059, ts3.DiagnosticCategory.Error, "File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059", "File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),
        Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix: diag(6060, ts3.DiagnosticCategory.Message, "Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060", "Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),
        NEWLINE: diag(6061, ts3.DiagnosticCategory.Message, "NEWLINE_6061", "NEWLINE"),
        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line: diag(6064, ts3.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."),
        Enables_experimental_support_for_ES7_decorators: diag(6065, ts3.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_decorators_6065", "Enables experimental support for ES7 decorators."),
        Enables_experimental_support_for_emitting_type_metadata_for_decorators: diag(6066, ts3.DiagnosticCategory.Message, "Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066", "Enables experimental support for emitting type metadata for decorators."),
        Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6: diag(6069, ts3.DiagnosticCategory.Message, "Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069", "Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."),
        Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file: diag(6070, ts3.DiagnosticCategory.Message, "Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070", "Initializes a TypeScript project and creates a tsconfig.json file."),
        Successfully_created_a_tsconfig_json_file: diag(6071, ts3.DiagnosticCategory.Message, "Successfully_created_a_tsconfig_json_file_6071", "Successfully created a tsconfig.json file."),
        Suppress_excess_property_checks_for_object_literals: diag(6072, ts3.DiagnosticCategory.Message, "Suppress_excess_property_checks_for_object_literals_6072", "Suppress excess property checks for object literals."),
        Stylize_errors_and_messages_using_color_and_context_experimental: diag(6073, ts3.DiagnosticCategory.Message, "Stylize_errors_and_messages_using_color_and_context_experimental_6073", "Stylize errors and messages using color and context (experimental)."),
        Do_not_report_errors_on_unused_labels: diag(6074, ts3.DiagnosticCategory.Message, "Do_not_report_errors_on_unused_labels_6074", "Do not report errors on unused labels."),
        Report_error_when_not_all_code_paths_in_function_return_a_value: diag(6075, ts3.DiagnosticCategory.Message, "Report_error_when_not_all_code_paths_in_function_return_a_value_6075", "Report error when not all code paths in function return a value."),
        Report_errors_for_fallthrough_cases_in_switch_statement: diag(6076, ts3.DiagnosticCategory.Message, "Report_errors_for_fallthrough_cases_in_switch_statement_6076", "Report errors for fallthrough cases in switch statement."),
        Do_not_report_errors_on_unreachable_code: diag(6077, ts3.DiagnosticCategory.Message, "Do_not_report_errors_on_unreachable_code_6077", "Do not report errors on unreachable code."),
        Disallow_inconsistently_cased_references_to_the_same_file: diag(6078, ts3.DiagnosticCategory.Message, "Disallow_inconsistently_cased_references_to_the_same_file_6078", "Disallow inconsistently-cased references to the same file."),
        Specify_library_files_to_be_included_in_the_compilation: diag(6079, ts3.DiagnosticCategory.Message, "Specify_library_files_to_be_included_in_the_compilation_6079", "Specify library files to be included in the compilation."),
        Specify_JSX_code_generation: diag(6080, ts3.DiagnosticCategory.Message, "Specify_JSX_code_generation_6080", "Specify JSX code generation."),
        File_0_has_an_unsupported_extension_so_skipping_it: diag(6081, ts3.DiagnosticCategory.Message, "File_0_has_an_unsupported_extension_so_skipping_it_6081", "File '{0}' has an unsupported extension, so skipping it."),
        Only_amd_and_system_modules_are_supported_alongside_0: diag(6082, ts3.DiagnosticCategory.Error, "Only_amd_and_system_modules_are_supported_alongside_0_6082", "Only 'amd' and 'system' modules are supported alongside --{0}."),
        Base_directory_to_resolve_non_absolute_module_names: diag(6083, ts3.DiagnosticCategory.Message, "Base_directory_to_resolve_non_absolute_module_names_6083", "Base directory to resolve non-absolute module names."),
        Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit: diag(6084, ts3.DiagnosticCategory.Message, "Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084", "[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),
        Enable_tracing_of_the_name_resolution_process: diag(6085, ts3.DiagnosticCategory.Message, "Enable_tracing_of_the_name_resolution_process_6085", "Enable tracing of the name resolution process."),
        Resolving_module_0_from_1: diag(6086, ts3.DiagnosticCategory.Message, "Resolving_module_0_from_1_6086", "======== Resolving module '{0}' from '{1}'. ========"),
        Explicitly_specified_module_resolution_kind_Colon_0: diag(6087, ts3.DiagnosticCategory.Message, "Explicitly_specified_module_resolution_kind_Colon_0_6087", "Explicitly specified module resolution kind: '{0}'."),
        Module_resolution_kind_is_not_specified_using_0: diag(6088, ts3.DiagnosticCategory.Message, "Module_resolution_kind_is_not_specified_using_0_6088", "Module resolution kind is not specified, using '{0}'."),
        Module_name_0_was_successfully_resolved_to_1: diag(6089, ts3.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_6089", "======== Module name '{0}' was successfully resolved to '{1}'. ========"),
        Module_name_0_was_not_resolved: diag(6090, ts3.DiagnosticCategory.Message, "Module_name_0_was_not_resolved_6090", "======== Module name '{0}' was not resolved. ========"),
        paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0: diag(6091, ts3.DiagnosticCategory.Message, "paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091", "'paths' option is specified, looking for a pattern to match module name '{0}'."),
        Module_name_0_matched_pattern_1: diag(6092, ts3.DiagnosticCategory.Message, "Module_name_0_matched_pattern_1_6092", "Module name '{0}', matched pattern '{1}'."),
        Trying_substitution_0_candidate_module_location_Colon_1: diag(6093, ts3.DiagnosticCategory.Message, "Trying_substitution_0_candidate_module_location_Colon_1_6093", "Trying substitution '{0}', candidate module location: '{1}'."),
        Resolving_module_name_0_relative_to_base_url_1_2: diag(6094, ts3.DiagnosticCategory.Message, "Resolving_module_name_0_relative_to_base_url_1_2_6094", "Resolving module name '{0}' relative to base url '{1}' - '{2}'."),
        Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1: diag(6095, ts3.DiagnosticCategory.Message, "Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095", "Loading module as file / folder, candidate module location '{0}', target file type '{1}'."),
        File_0_does_not_exist: diag(6096, ts3.DiagnosticCategory.Message, "File_0_does_not_exist_6096", "File '{0}' does not exist."),
        File_0_exist_use_it_as_a_name_resolution_result: diag(6097, ts3.DiagnosticCategory.Message, "File_0_exist_use_it_as_a_name_resolution_result_6097", "File '{0}' exist - use it as a name resolution result."),
        Loading_module_0_from_node_modules_folder_target_file_type_1: diag(6098, ts3.DiagnosticCategory.Message, "Loading_module_0_from_node_modules_folder_target_file_type_1_6098", "Loading module '{0}' from 'node_modules' folder, target file type '{1}'."),
        Found_package_json_at_0: diag(6099, ts3.DiagnosticCategory.Message, "Found_package_json_at_0_6099", "Found 'package.json' at '{0}'."),
        package_json_does_not_have_a_0_field: diag(6100, ts3.DiagnosticCategory.Message, "package_json_does_not_have_a_0_field_6100", "'package.json' does not have a '{0}' field."),
        package_json_has_0_field_1_that_references_2: diag(6101, ts3.DiagnosticCategory.Message, "package_json_has_0_field_1_that_references_2_6101", "'package.json' has '{0}' field '{1}' that references '{2}'."),
        Allow_javascript_files_to_be_compiled: diag(6102, ts3.DiagnosticCategory.Message, "Allow_javascript_files_to_be_compiled_6102", "Allow javascript files to be compiled."),
        Checking_if_0_is_the_longest_matching_prefix_for_1_2: diag(6104, ts3.DiagnosticCategory.Message, "Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104", "Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),
        Expected_type_of_0_field_in_package_json_to_be_1_got_2: diag(6105, ts3.DiagnosticCategory.Message, "Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105", "Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),
        baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1: diag(6106, ts3.DiagnosticCategory.Message, "baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106", "'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),
        rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0: diag(6107, ts3.DiagnosticCategory.Message, "rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107", "'rootDirs' option is set, using it to resolve relative module name '{0}'."),
        Longest_matching_prefix_for_0_is_1: diag(6108, ts3.DiagnosticCategory.Message, "Longest_matching_prefix_for_0_is_1_6108", "Longest matching prefix for '{0}' is '{1}'."),
        Loading_0_from_the_root_dir_1_candidate_location_2: diag(6109, ts3.DiagnosticCategory.Message, "Loading_0_from_the_root_dir_1_candidate_location_2_6109", "Loading '{0}' from the root dir '{1}', candidate location '{2}'."),
        Trying_other_entries_in_rootDirs: diag(6110, ts3.DiagnosticCategory.Message, "Trying_other_entries_in_rootDirs_6110", "Trying other entries in 'rootDirs'."),
        Module_resolution_using_rootDirs_has_failed: diag(6111, ts3.DiagnosticCategory.Message, "Module_resolution_using_rootDirs_has_failed_6111", "Module resolution using 'rootDirs' has failed."),
        Do_not_emit_use_strict_directives_in_module_output: diag(6112, ts3.DiagnosticCategory.Message, "Do_not_emit_use_strict_directives_in_module_output_6112", "Do not emit 'use strict' directives in module output."),
        Enable_strict_null_checks: diag(6113, ts3.DiagnosticCategory.Message, "Enable_strict_null_checks_6113", "Enable strict null checks."),
        Unknown_option_excludes_Did_you_mean_exclude: diag(6114, ts3.DiagnosticCategory.Error, "Unknown_option_excludes_Did_you_mean_exclude_6114", "Unknown option 'excludes'. Did you mean 'exclude'?"),
        Raise_error_on_this_expressions_with_an_implied_any_type: diag(6115, ts3.DiagnosticCategory.Message, "Raise_error_on_this_expressions_with_an_implied_any_type_6115", "Raise error on 'this' expressions with an implied 'any' type."),
        Resolving_type_reference_directive_0_containing_file_1_root_directory_2: diag(6116, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116", "======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),
        Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2: diag(6119, ts3.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119", "======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),
        Type_reference_directive_0_was_not_resolved: diag(6120, ts3.DiagnosticCategory.Message, "Type_reference_directive_0_was_not_resolved_6120", "======== Type reference directive '{0}' was not resolved. ========"),
        Resolving_with_primary_search_path_0: diag(6121, ts3.DiagnosticCategory.Message, "Resolving_with_primary_search_path_0_6121", "Resolving with primary search path '{0}'."),
        Root_directory_cannot_be_determined_skipping_primary_search_paths: diag(6122, ts3.DiagnosticCategory.Message, "Root_directory_cannot_be_determined_skipping_primary_search_paths_6122", "Root directory cannot be determined, skipping primary search paths."),
        Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set: diag(6123, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123", "======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),
        Type_declaration_files_to_be_included_in_compilation: diag(6124, ts3.DiagnosticCategory.Message, "Type_declaration_files_to_be_included_in_compilation_6124", "Type declaration files to be included in compilation."),
        Looking_up_in_node_modules_folder_initial_location_0: diag(6125, ts3.DiagnosticCategory.Message, "Looking_up_in_node_modules_folder_initial_location_0_6125", "Looking up in 'node_modules' folder, initial location '{0}'."),
        Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder: diag(6126, ts3.DiagnosticCategory.Message, "Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126", "Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),
        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1: diag(6127, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127", "======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),
        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set: diag(6128, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128", "======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),
        Resolving_real_path_for_0_result_1: diag(6130, ts3.DiagnosticCategory.Message, "Resolving_real_path_for_0_result_1_6130", "Resolving real path for '{0}', result '{1}'."),
        Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system: diag(6131, ts3.DiagnosticCategory.Error, "Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131", "Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),
        File_name_0_has_a_1_extension_stripping_it: diag(6132, ts3.DiagnosticCategory.Message, "File_name_0_has_a_1_extension_stripping_it_6132", "File name '{0}' has a '{1}' extension - stripping it."),
        _0_is_declared_but_its_value_is_never_read: diag(6133, ts3.DiagnosticCategory.Error, "_0_is_declared_but_its_value_is_never_read_6133", "'{0}' is declared but its value is never read.", true),
        Report_errors_on_unused_locals: diag(6134, ts3.DiagnosticCategory.Message, "Report_errors_on_unused_locals_6134", "Report errors on unused locals."),
        Report_errors_on_unused_parameters: diag(6135, ts3.DiagnosticCategory.Message, "Report_errors_on_unused_parameters_6135", "Report errors on unused parameters."),
        The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files: diag(6136, ts3.DiagnosticCategory.Message, "The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136", "The maximum dependency depth to search under node_modules and load JavaScript files."),
        Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1: diag(6137, ts3.DiagnosticCategory.Error, "Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137", "Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),
        Property_0_is_declared_but_its_value_is_never_read: diag(6138, ts3.DiagnosticCategory.Error, "Property_0_is_declared_but_its_value_is_never_read_6138", "Property '{0}' is declared but its value is never read.", true),
        Import_emit_helpers_from_tslib: diag(6139, ts3.DiagnosticCategory.Message, "Import_emit_helpers_from_tslib_6139", "Import emit helpers from 'tslib'."),
        Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2: diag(6140, ts3.DiagnosticCategory.Error, "Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140", "Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),
        Parse_in_strict_mode_and_emit_use_strict_for_each_source_file: diag(6141, ts3.DiagnosticCategory.Message, "Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141", 'Parse in strict mode and emit "use strict" for each source file.'),
        Module_0_was_resolved_to_1_but_jsx_is_not_set: diag(6142, ts3.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_jsx_is_not_set_6142", "Module '{0}' was resolved to '{1}', but '--jsx' is not set."),
        Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1: diag(6144, ts3.DiagnosticCategory.Message, "Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144", "Module '{0}' was resolved as locally declared ambient module in file '{1}'."),
        Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified: diag(6145, ts3.DiagnosticCategory.Message, "Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145", "Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),
        Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h: diag(6146, ts3.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146", "Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),
        Resolution_for_module_0_was_found_in_cache_from_location_1: diag(6147, ts3.DiagnosticCategory.Message, "Resolution_for_module_0_was_found_in_cache_from_location_1_6147", "Resolution for module '{0}' was found in cache from location '{1}'."),
        Directory_0_does_not_exist_skipping_all_lookups_in_it: diag(6148, ts3.DiagnosticCategory.Message, "Directory_0_does_not_exist_skipping_all_lookups_in_it_6148", "Directory '{0}' does not exist, skipping all lookups in it."),
        Show_diagnostic_information: diag(6149, ts3.DiagnosticCategory.Message, "Show_diagnostic_information_6149", "Show diagnostic information."),
        Show_verbose_diagnostic_information: diag(6150, ts3.DiagnosticCategory.Message, "Show_verbose_diagnostic_information_6150", "Show verbose diagnostic information."),
        Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file: diag(6151, ts3.DiagnosticCategory.Message, "Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151", "Emit a single file with source maps instead of having a separate file."),
        Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set: diag(6152, ts3.DiagnosticCategory.Message, "Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152", "Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),
        Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule: diag(6153, ts3.DiagnosticCategory.Message, "Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153", "Transpile each file as a separate module (similar to 'ts.transpileModule')."),
        Print_names_of_generated_files_part_of_the_compilation: diag(6154, ts3.DiagnosticCategory.Message, "Print_names_of_generated_files_part_of_the_compilation_6154", "Print names of generated files part of the compilation."),
        Print_names_of_files_part_of_the_compilation: diag(6155, ts3.DiagnosticCategory.Message, "Print_names_of_files_part_of_the_compilation_6155", "Print names of files part of the compilation."),
        The_locale_used_when_displaying_messages_to_the_user_e_g_en_us: diag(6156, ts3.DiagnosticCategory.Message, "The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156", "The locale used when displaying messages to the user (e.g. 'en-us')"),
        Do_not_generate_custom_helper_functions_like_extends_in_compiled_output: diag(6157, ts3.DiagnosticCategory.Message, "Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157", "Do not generate custom helper functions like '__extends' in compiled output."),
        Do_not_include_the_default_library_file_lib_d_ts: diag(6158, ts3.DiagnosticCategory.Message, "Do_not_include_the_default_library_file_lib_d_ts_6158", "Do not include the default library file (lib.d.ts)."),
        Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files: diag(6159, ts3.DiagnosticCategory.Message, "Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159", "Do not add triple-slash references or imported modules to the list of compiled files."),
        Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files: diag(6160, ts3.DiagnosticCategory.Message, "Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160", "[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),
        List_of_folders_to_include_type_definitions_from: diag(6161, ts3.DiagnosticCategory.Message, "List_of_folders_to_include_type_definitions_from_6161", "List of folders to include type definitions from."),
        Disable_size_limitations_on_JavaScript_projects: diag(6162, ts3.DiagnosticCategory.Message, "Disable_size_limitations_on_JavaScript_projects_6162", "Disable size limitations on JavaScript projects."),
        The_character_set_of_the_input_files: diag(6163, ts3.DiagnosticCategory.Message, "The_character_set_of_the_input_files_6163", "The character set of the input files."),
        Do_not_truncate_error_messages: diag(6165, ts3.DiagnosticCategory.Message, "Do_not_truncate_error_messages_6165", "Do not truncate error messages."),
        Output_directory_for_generated_declaration_files: diag(6166, ts3.DiagnosticCategory.Message, "Output_directory_for_generated_declaration_files_6166", "Output directory for generated declaration files."),
        A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl: diag(6167, ts3.DiagnosticCategory.Message, "A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167", "A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),
        List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime: diag(6168, ts3.DiagnosticCategory.Message, "List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168", "List of root folders whose combined content represents the structure of the project at runtime."),
        Show_all_compiler_options: diag(6169, ts3.DiagnosticCategory.Message, "Show_all_compiler_options_6169", "Show all compiler options."),
        Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file: diag(6170, ts3.DiagnosticCategory.Message, "Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170", "[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),
        Command_line_Options: diag(6171, ts3.DiagnosticCategory.Message, "Command_line_Options_6171", "Command-line Options"),
        Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3: diag(6179, ts3.DiagnosticCategory.Message, "Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179", "Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),
        Enable_all_strict_type_checking_options: diag(6180, ts3.DiagnosticCategory.Message, "Enable_all_strict_type_checking_options_6180", "Enable all strict type-checking options."),
        Scoped_package_detected_looking_in_0: diag(6182, ts3.DiagnosticCategory.Message, "Scoped_package_detected_looking_in_0_6182", "Scoped package detected, looking in '{0}'"),
        Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2: diag(6183, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_6183", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),
        Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: diag(6184, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package__6184", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),
        Enable_strict_checking_of_function_types: diag(6186, ts3.DiagnosticCategory.Message, "Enable_strict_checking_of_function_types_6186", "Enable strict checking of function types."),
        Enable_strict_checking_of_property_initialization_in_classes: diag(6187, ts3.DiagnosticCategory.Message, "Enable_strict_checking_of_property_initialization_in_classes_6187", "Enable strict checking of property initialization in classes."),
        Numeric_separators_are_not_allowed_here: diag(6188, ts3.DiagnosticCategory.Error, "Numeric_separators_are_not_allowed_here_6188", "Numeric separators are not allowed here."),
        Multiple_consecutive_numeric_separators_are_not_permitted: diag(6189, ts3.DiagnosticCategory.Error, "Multiple_consecutive_numeric_separators_are_not_permitted_6189", "Multiple consecutive numeric separators are not permitted."),
        Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen: diag(6191, ts3.DiagnosticCategory.Message, "Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191", "Whether to keep outdated console output in watch mode instead of clearing the screen."),
        All_imports_in_import_declaration_are_unused: diag(6192, ts3.DiagnosticCategory.Error, "All_imports_in_import_declaration_are_unused_6192", "All imports in import declaration are unused.", true),
        Found_1_error_Watching_for_file_changes: diag(6193, ts3.DiagnosticCategory.Message, "Found_1_error_Watching_for_file_changes_6193", "Found 1 error. Watching for file changes."),
        Found_0_errors_Watching_for_file_changes: diag(6194, ts3.DiagnosticCategory.Message, "Found_0_errors_Watching_for_file_changes_6194", "Found {0} errors. Watching for file changes."),
        Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols: diag(6195, ts3.DiagnosticCategory.Message, "Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195", "Resolve 'keyof' to string valued property names only (no numbers or symbols)."),
        _0_is_declared_but_never_used: diag(6196, ts3.DiagnosticCategory.Error, "_0_is_declared_but_never_used_6196", "'{0}' is declared but never used.", true),
        Include_modules_imported_with_json_extension: diag(6197, ts3.DiagnosticCategory.Message, "Include_modules_imported_with_json_extension_6197", "Include modules imported with '.json' extension"),
        All_destructured_elements_are_unused: diag(6198, ts3.DiagnosticCategory.Error, "All_destructured_elements_are_unused_6198", "All destructured elements are unused.", true),
        All_variables_are_unused: diag(6199, ts3.DiagnosticCategory.Error, "All_variables_are_unused_6199", "All variables are unused.", true),
        Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0: diag(6200, ts3.DiagnosticCategory.Error, "Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200", "Definitions of the following identifiers conflict with those in another file: {0}"),
        Conflicts_are_in_this_file: diag(6201, ts3.DiagnosticCategory.Message, "Conflicts_are_in_this_file_6201", "Conflicts are in this file."),
        Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0: diag(6202, ts3.DiagnosticCategory.Error, "Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202", "Project references may not form a circular graph. Cycle detected: {0}"),
        _0_was_also_declared_here: diag(6203, ts3.DiagnosticCategory.Message, "_0_was_also_declared_here_6203", "'{0}' was also declared here."),
        and_here: diag(6204, ts3.DiagnosticCategory.Message, "and_here_6204", "and here."),
        All_type_parameters_are_unused: diag(6205, ts3.DiagnosticCategory.Error, "All_type_parameters_are_unused_6205", "All type parameters are unused."),
        package_json_has_a_typesVersions_field_with_version_specific_path_mappings: diag(6206, ts3.DiagnosticCategory.Message, "package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206", "'package.json' has a 'typesVersions' field with version-specific path mappings."),
        package_json_does_not_have_a_typesVersions_entry_that_matches_version_0: diag(6207, ts3.DiagnosticCategory.Message, "package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207", "'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),
        package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2: diag(6208, ts3.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208", "'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),
        package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range: diag(6209, ts3.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209", "'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),
        An_argument_for_0_was_not_provided: diag(6210, ts3.DiagnosticCategory.Message, "An_argument_for_0_was_not_provided_6210", "An argument for '{0}' was not provided."),
        An_argument_matching_this_binding_pattern_was_not_provided: diag(6211, ts3.DiagnosticCategory.Message, "An_argument_matching_this_binding_pattern_was_not_provided_6211", "An argument matching this binding pattern was not provided."),
        Did_you_mean_to_call_this_expression: diag(6212, ts3.DiagnosticCategory.Message, "Did_you_mean_to_call_this_expression_6212", "Did you mean to call this expression?"),
        Did_you_mean_to_use_new_with_this_expression: diag(6213, ts3.DiagnosticCategory.Message, "Did_you_mean_to_use_new_with_this_expression_6213", "Did you mean to use 'new' with this expression?"),
        Enable_strict_bind_call_and_apply_methods_on_functions: diag(6214, ts3.DiagnosticCategory.Message, "Enable_strict_bind_call_and_apply_methods_on_functions_6214", "Enable strict 'bind', 'call', and 'apply' methods on functions."),
        Using_compiler_options_of_project_reference_redirect_0: diag(6215, ts3.DiagnosticCategory.Message, "Using_compiler_options_of_project_reference_redirect_0_6215", "Using compiler options of project reference redirect '{0}'."),
        Found_1_error: diag(6216, ts3.DiagnosticCategory.Message, "Found_1_error_6216", "Found 1 error."),
        Found_0_errors: diag(6217, ts3.DiagnosticCategory.Message, "Found_0_errors_6217", "Found {0} errors."),
        Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2: diag(6218, ts3.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218", "======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),
        Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3: diag(6219, ts3.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219", "======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),
        package_json_had_a_falsy_0_field: diag(6220, ts3.DiagnosticCategory.Message, "package_json_had_a_falsy_0_field_6220", "'package.json' had a falsy '{0}' field."),
        Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects: diag(6221, ts3.DiagnosticCategory.Message, "Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221", "Disable use of source files instead of declaration files from referenced projects."),
        Emit_class_fields_with_Define_instead_of_Set: diag(6222, ts3.DiagnosticCategory.Message, "Emit_class_fields_with_Define_instead_of_Set_6222", "Emit class fields with Define instead of Set."),
        Generates_a_CPU_profile: diag(6223, ts3.DiagnosticCategory.Message, "Generates_a_CPU_profile_6223", "Generates a CPU profile."),
        Disable_solution_searching_for_this_project: diag(6224, ts3.DiagnosticCategory.Message, "Disable_solution_searching_for_this_project_6224", "Disable solution searching for this project."),
        Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory: diag(6225, ts3.DiagnosticCategory.Message, "Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225", "Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."),
        Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling: diag(6226, ts3.DiagnosticCategory.Message, "Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226", "Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."),
        Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize: diag(6227, ts3.DiagnosticCategory.Message, "Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227", "Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."),
        Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3: diag(6229, ts3.DiagnosticCategory.Error, "Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229", "Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."),
        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line: diag(6230, ts3.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."),
        Could_not_resolve_the_path_0_with_the_extensions_Colon_1: diag(6231, ts3.DiagnosticCategory.Error, "Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231", "Could not resolve the path '{0}' with the extensions: {1}."),
        Declaration_augments_declaration_in_another_file_This_cannot_be_serialized: diag(6232, ts3.DiagnosticCategory.Error, "Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232", "Declaration augments declaration in another file. This cannot be serialized."),
        This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file: diag(6233, ts3.DiagnosticCategory.Error, "This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233", "This is the declaration being augmented. Consider moving the augmenting declaration into the same file."),
        This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without: diag(6234, ts3.DiagnosticCategory.Error, "This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234", "This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"),
        Disable_loading_referenced_projects: diag(6235, ts3.DiagnosticCategory.Message, "Disable_loading_referenced_projects_6235", "Disable loading referenced projects."),
        Arguments_for_the_rest_parameter_0_were_not_provided: diag(6236, ts3.DiagnosticCategory.Error, "Arguments_for_the_rest_parameter_0_were_not_provided_6236", "Arguments for the rest parameter '{0}' were not provided."),
        Generates_an_event_trace_and_a_list_of_types: diag(6237, ts3.DiagnosticCategory.Message, "Generates_an_event_trace_and_a_list_of_types_6237", "Generates an event trace and a list of types."),
        Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react: diag(6238, ts3.DiagnosticCategory.Error, "Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238", "Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"),
        File_0_exists_according_to_earlier_cached_lookups: diag(6239, ts3.DiagnosticCategory.Message, "File_0_exists_according_to_earlier_cached_lookups_6239", "File '{0}' exists according to earlier cached lookups."),
        File_0_does_not_exist_according_to_earlier_cached_lookups: diag(6240, ts3.DiagnosticCategory.Message, "File_0_does_not_exist_according_to_earlier_cached_lookups_6240", "File '{0}' does not exist according to earlier cached lookups."),
        Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1: diag(6241, ts3.DiagnosticCategory.Message, "Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241", "Resolution for type reference directive '{0}' was found in cache from location '{1}'."),
        Resolving_type_reference_directive_0_containing_file_1: diag(6242, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_6242", "======== Resolving type reference directive '{0}', containing file '{1}'. ========"),
        Interpret_optional_property_types_as_written_rather_than_adding_undefined: diag(6243, ts3.DiagnosticCategory.Message, "Interpret_optional_property_types_as_written_rather_than_adding_undefined_6243", "Interpret optional property types as written, rather than adding 'undefined'."),
        Modules: diag(6244, ts3.DiagnosticCategory.Message, "Modules_6244", "Modules"),
        File_Management: diag(6245, ts3.DiagnosticCategory.Message, "File_Management_6245", "File Management"),
        Emit: diag(6246, ts3.DiagnosticCategory.Message, "Emit_6246", "Emit"),
        JavaScript_Support: diag(6247, ts3.DiagnosticCategory.Message, "JavaScript_Support_6247", "JavaScript Support"),
        Type_Checking: diag(6248, ts3.DiagnosticCategory.Message, "Type_Checking_6248", "Type Checking"),
        Editor_Support: diag(6249, ts3.DiagnosticCategory.Message, "Editor_Support_6249", "Editor Support"),
        Watch_and_Build_Modes: diag(6250, ts3.DiagnosticCategory.Message, "Watch_and_Build_Modes_6250", "Watch and Build Modes"),
        Compiler_Diagnostics: diag(6251, ts3.DiagnosticCategory.Message, "Compiler_Diagnostics_6251", "Compiler Diagnostics"),
        Interop_Constraints: diag(6252, ts3.DiagnosticCategory.Message, "Interop_Constraints_6252", "Interop Constraints"),
        Backwards_Compatibility: diag(6253, ts3.DiagnosticCategory.Message, "Backwards_Compatibility_6253", "Backwards Compatibility"),
        Language_and_Environment: diag(6254, ts3.DiagnosticCategory.Message, "Language_and_Environment_6254", "Language and Environment"),
        Projects: diag(6255, ts3.DiagnosticCategory.Message, "Projects_6255", "Projects"),
        Output_Formatting: diag(6256, ts3.DiagnosticCategory.Message, "Output_Formatting_6256", "Output Formatting"),
        Completeness: diag(6257, ts3.DiagnosticCategory.Message, "Completeness_6257", "Completeness"),
        _0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file: diag(6258, ts3.DiagnosticCategory.Error, "_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file_6258", "'{0}' should be set inside the 'compilerOptions' object of the config json file"),
        Found_1_error_in_1: diag(6259, ts3.DiagnosticCategory.Message, "Found_1_error_in_1_6259", "Found 1 error in {1}"),
        Found_0_errors_in_the_same_file_starting_at_Colon_1: diag(6260, ts3.DiagnosticCategory.Message, "Found_0_errors_in_the_same_file_starting_at_Colon_1_6260", "Found {0} errors in the same file, starting at: {1}"),
        Found_0_errors_in_1_files: diag(6261, ts3.DiagnosticCategory.Message, "Found_0_errors_in_1_files_6261", "Found {0} errors in {1} files."),
        Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve: diag(6270, ts3.DiagnosticCategory.Message, "Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve_6270", "Directory '{0}' has no containing package.json scope. Imports will not resolve."),
        Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1: diag(6271, ts3.DiagnosticCategory.Message, "Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6271", "Import specifier '{0}' does not exist in package.json scope at path '{1}'."),
        Invalid_import_specifier_0_has_no_possible_resolutions: diag(6272, ts3.DiagnosticCategory.Message, "Invalid_import_specifier_0_has_no_possible_resolutions_6272", "Invalid import specifier '{0}' has no possible resolutions."),
        package_json_scope_0_has_no_imports_defined: diag(6273, ts3.DiagnosticCategory.Message, "package_json_scope_0_has_no_imports_defined_6273", "package.json scope '{0}' has no imports defined."),
        package_json_scope_0_explicitly_maps_specifier_1_to_null: diag(6274, ts3.DiagnosticCategory.Message, "package_json_scope_0_explicitly_maps_specifier_1_to_null_6274", "package.json scope '{0}' explicitly maps specifier '{1}' to null."),
        package_json_scope_0_has_invalid_type_for_target_of_specifier_1: diag(6275, ts3.DiagnosticCategory.Message, "package_json_scope_0_has_invalid_type_for_target_of_specifier_1_6275", "package.json scope '{0}' has invalid type for target of specifier '{1}'"),
        Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1: diag(6276, ts3.DiagnosticCategory.Message, "Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6276", "Export specifier '{0}' does not exist in package.json scope at path '{1}'."),
        Enable_project_compilation: diag(6302, ts3.DiagnosticCategory.Message, "Enable_project_compilation_6302", "Enable project compilation"),
        Composite_projects_may_not_disable_declaration_emit: diag(6304, ts3.DiagnosticCategory.Error, "Composite_projects_may_not_disable_declaration_emit_6304", "Composite projects may not disable declaration emit."),
        Output_file_0_has_not_been_built_from_source_file_1: diag(6305, ts3.DiagnosticCategory.Error, "Output_file_0_has_not_been_built_from_source_file_1_6305", "Output file '{0}' has not been built from source file '{1}'."),
        Referenced_project_0_must_have_setting_composite_Colon_true: diag(6306, ts3.DiagnosticCategory.Error, "Referenced_project_0_must_have_setting_composite_Colon_true_6306", `Referenced project '{0}' must have setting "composite": true.`),
        File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern: diag(6307, ts3.DiagnosticCategory.Error, "File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307", "File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."),
        Cannot_prepend_project_0_because_it_does_not_have_outFile_set: diag(6308, ts3.DiagnosticCategory.Error, "Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308", "Cannot prepend project '{0}' because it does not have 'outFile' set"),
        Output_file_0_from_project_1_does_not_exist: diag(6309, ts3.DiagnosticCategory.Error, "Output_file_0_from_project_1_does_not_exist_6309", "Output file '{0}' from project '{1}' does not exist"),
        Referenced_project_0_may_not_disable_emit: diag(6310, ts3.DiagnosticCategory.Error, "Referenced_project_0_may_not_disable_emit_6310", "Referenced project '{0}' may not disable emit."),
        Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2: diag(6350, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2_6350", "Project '{0}' is out of date because oldest output '{1}' is older than newest input '{2}'"),
        Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2: diag(6351, ts3.DiagnosticCategory.Message, "Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2_6351", "Project '{0}' is up to date because newest input '{1}' is older than oldest output '{2}'"),
        Project_0_is_out_of_date_because_output_file_1_does_not_exist: diag(6352, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352", "Project '{0}' is out of date because output file '{1}' does not exist"),
        Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date: diag(6353, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353", "Project '{0}' is out of date because its dependency '{1}' is out of date"),
        Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies: diag(6354, ts3.DiagnosticCategory.Message, "Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354", "Project '{0}' is up to date with .d.ts files from its dependencies"),
        Projects_in_this_build_Colon_0: diag(6355, ts3.DiagnosticCategory.Message, "Projects_in_this_build_Colon_0_6355", "Projects in this build: {0}"),
        A_non_dry_build_would_delete_the_following_files_Colon_0: diag(6356, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_delete_the_following_files_Colon_0_6356", "A non-dry build would delete the following files: {0}"),
        A_non_dry_build_would_build_project_0: diag(6357, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_build_project_0_6357", "A non-dry build would build project '{0}'"),
        Building_project_0: diag(6358, ts3.DiagnosticCategory.Message, "Building_project_0_6358", "Building project '{0}'..."),
        Updating_output_timestamps_of_project_0: diag(6359, ts3.DiagnosticCategory.Message, "Updating_output_timestamps_of_project_0_6359", "Updating output timestamps of project '{0}'..."),
        Project_0_is_up_to_date: diag(6361, ts3.DiagnosticCategory.Message, "Project_0_is_up_to_date_6361", "Project '{0}' is up to date"),
        Skipping_build_of_project_0_because_its_dependency_1_has_errors: diag(6362, ts3.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362", "Skipping build of project '{0}' because its dependency '{1}' has errors"),
        Project_0_can_t_be_built_because_its_dependency_1_has_errors: diag(6363, ts3.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363", "Project '{0}' can't be built because its dependency '{1}' has errors"),
        Build_one_or_more_projects_and_their_dependencies_if_out_of_date: diag(6364, ts3.DiagnosticCategory.Message, "Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364", "Build one or more projects and their dependencies, if out of date"),
        Delete_the_outputs_of_all_projects: diag(6365, ts3.DiagnosticCategory.Message, "Delete_the_outputs_of_all_projects_6365", "Delete the outputs of all projects."),
        Show_what_would_be_built_or_deleted_if_specified_with_clean: diag(6367, ts3.DiagnosticCategory.Message, "Show_what_would_be_built_or_deleted_if_specified_with_clean_6367", "Show what would be built (or deleted, if specified with '--clean')"),
        Option_build_must_be_the_first_command_line_argument: diag(6369, ts3.DiagnosticCategory.Error, "Option_build_must_be_the_first_command_line_argument_6369", "Option '--build' must be the first command line argument."),
        Options_0_and_1_cannot_be_combined: diag(6370, ts3.DiagnosticCategory.Error, "Options_0_and_1_cannot_be_combined_6370", "Options '{0}' and '{1}' cannot be combined."),
        Updating_unchanged_output_timestamps_of_project_0: diag(6371, ts3.DiagnosticCategory.Message, "Updating_unchanged_output_timestamps_of_project_0_6371", "Updating unchanged output timestamps of project '{0}'..."),
        Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed: diag(6372, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372", "Project '{0}' is out of date because output of its dependency '{1}' has changed"),
        Updating_output_of_project_0: diag(6373, ts3.DiagnosticCategory.Message, "Updating_output_of_project_0_6373", "Updating output of project '{0}'..."),
        A_non_dry_build_would_update_timestamps_for_output_of_project_0: diag(6374, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374", "A non-dry build would update timestamps for output of project '{0}'"),
        A_non_dry_build_would_update_output_of_project_0: diag(6375, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_update_output_of_project_0_6375", "A non-dry build would update output of project '{0}'"),
        Cannot_update_output_of_project_0_because_there_was_error_reading_file_1: diag(6376, ts3.DiagnosticCategory.Message, "Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376", "Cannot update output of project '{0}' because there was error reading file '{1}'"),
        Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1: diag(6377, ts3.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377", "Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),
        Composite_projects_may_not_disable_incremental_compilation: diag(6379, ts3.DiagnosticCategory.Error, "Composite_projects_may_not_disable_incremental_compilation_6379", "Composite projects may not disable incremental compilation."),
        Specify_file_to_store_incremental_compilation_information: diag(6380, ts3.DiagnosticCategory.Message, "Specify_file_to_store_incremental_compilation_information_6380", "Specify file to store incremental compilation information"),
        Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2: diag(6381, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381", "Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),
        Skipping_build_of_project_0_because_its_dependency_1_was_not_built: diag(6382, ts3.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382", "Skipping build of project '{0}' because its dependency '{1}' was not built"),
        Project_0_can_t_be_built_because_its_dependency_1_was_not_built: diag(6383, ts3.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383", "Project '{0}' can't be built because its dependency '{1}' was not built"),
        Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: diag(6384, ts3.DiagnosticCategory.Message, "Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384", "Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."),
        _0_is_deprecated: diag(6385, ts3.DiagnosticCategory.Suggestion, "_0_is_deprecated_6385", "'{0}' is deprecated.", void 0, void 0, true),
        Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found: diag(6386, ts3.DiagnosticCategory.Message, "Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386", "Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."),
        The_signature_0_of_1_is_deprecated: diag(6387, ts3.DiagnosticCategory.Suggestion, "The_signature_0_of_1_is_deprecated_6387", "The signature '{0}' of '{1}' is deprecated.", void 0, void 0, true),
        Project_0_is_being_forcibly_rebuilt: diag(6388, ts3.DiagnosticCategory.Message, "Project_0_is_being_forcibly_rebuilt_6388", "Project '{0}' is being forcibly rebuilt"),
        Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved: diag(6389, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved_6389", "Reusing resolution of module '{0}' from '{1}' of old program, it was not resolved."),
        Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2: diag(6390, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6390", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),
        Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: diag(6391, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6391", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),
        Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved: diag(6392, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved_6392", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was not resolved."),
        Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: diag(6393, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6393", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),
        Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: diag(6394, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6394", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),
        Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: diag(6395, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved_6395", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),
        Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: diag(6396, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6396", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),
        Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: diag(6397, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6397", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),
        Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: diag(6398, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_re_6398", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),
        The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1: diag(6500, ts3.DiagnosticCategory.Message, "The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500", "The expected type comes from property '{0}' which is declared here on type '{1}'"),
        The_expected_type_comes_from_this_index_signature: diag(6501, ts3.DiagnosticCategory.Message, "The_expected_type_comes_from_this_index_signature_6501", "The expected type comes from this index signature."),
        The_expected_type_comes_from_the_return_type_of_this_signature: diag(6502, ts3.DiagnosticCategory.Message, "The_expected_type_comes_from_the_return_type_of_this_signature_6502", "The expected type comes from the return type of this signature."),
        Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing: diag(6503, ts3.DiagnosticCategory.Message, "Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503", "Print names of files that are part of the compilation and then stop processing."),
        File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option: diag(6504, ts3.DiagnosticCategory.Error, "File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504", "File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"),
        Print_names_of_files_and_the_reason_they_are_part_of_the_compilation: diag(6505, ts3.DiagnosticCategory.Message, "Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505", "Print names of files and the reason they are part of the compilation."),
        Consider_adding_a_declare_modifier_to_this_class: diag(6506, ts3.DiagnosticCategory.Message, "Consider_adding_a_declare_modifier_to_this_class_6506", "Consider adding a 'declare' modifier to this class."),
        Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files: diag(6600, ts3.DiagnosticCategory.Message, "Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these__6600", "Allow JavaScript files to be a part of your program. Use the 'checkJS' option to get errors from these files."),
        Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export: diag(6601, ts3.DiagnosticCategory.Message, "Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export_6601", "Allow 'import x from y' when a module doesn't have a default export."),
        Allow_accessing_UMD_globals_from_modules: diag(6602, ts3.DiagnosticCategory.Message, "Allow_accessing_UMD_globals_from_modules_6602", "Allow accessing UMD globals from modules."),
        Disable_error_reporting_for_unreachable_code: diag(6603, ts3.DiagnosticCategory.Message, "Disable_error_reporting_for_unreachable_code_6603", "Disable error reporting for unreachable code."),
        Disable_error_reporting_for_unused_labels: diag(6604, ts3.DiagnosticCategory.Message, "Disable_error_reporting_for_unused_labels_6604", "Disable error reporting for unused labels."),
        Ensure_use_strict_is_always_emitted: diag(6605, ts3.DiagnosticCategory.Message, "Ensure_use_strict_is_always_emitted_6605", "Ensure 'use strict' is always emitted."),
        Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: diag(6606, ts3.DiagnosticCategory.Message, "Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_wi_6606", "Have recompiles in projects that use 'incremental' and 'watch' mode assume that changes within a file will only affect files directly depending on it."),
        Specify_the_base_directory_to_resolve_non_relative_module_names: diag(6607, ts3.DiagnosticCategory.Message, "Specify_the_base_directory_to_resolve_non_relative_module_names_6607", "Specify the base directory to resolve non-relative module names."),
        No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files: diag(6608, ts3.DiagnosticCategory.Message, "No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files_6608", "No longer supported. In early versions, manually set the text encoding for reading files."),
        Enable_error_reporting_in_type_checked_JavaScript_files: diag(6609, ts3.DiagnosticCategory.Message, "Enable_error_reporting_in_type_checked_JavaScript_files_6609", "Enable error reporting in type-checked JavaScript files."),
        Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references: diag(6611, ts3.DiagnosticCategory.Message, "Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references_6611", "Enable constraints that allow a TypeScript project to be used with project references."),
        Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project: diag(6612, ts3.DiagnosticCategory.Message, "Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project_6612", "Generate .d.ts files from TypeScript and JavaScript files in your project."),
        Specify_the_output_directory_for_generated_declaration_files: diag(6613, ts3.DiagnosticCategory.Message, "Specify_the_output_directory_for_generated_declaration_files_6613", "Specify the output directory for generated declaration files."),
        Create_sourcemaps_for_d_ts_files: diag(6614, ts3.DiagnosticCategory.Message, "Create_sourcemaps_for_d_ts_files_6614", "Create sourcemaps for d.ts files."),
        Output_compiler_performance_information_after_building: diag(6615, ts3.DiagnosticCategory.Message, "Output_compiler_performance_information_after_building_6615", "Output compiler performance information after building."),
        Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project: diag(6616, ts3.DiagnosticCategory.Message, "Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project_6616", "Disables inference for type acquisition by looking at filenames in a project."),
        Reduce_the_number_of_projects_loaded_automatically_by_TypeScript: diag(6617, ts3.DiagnosticCategory.Message, "Reduce_the_number_of_projects_loaded_automatically_by_TypeScript_6617", "Reduce the number of projects loaded automatically by TypeScript."),
        Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server: diag(6618, ts3.DiagnosticCategory.Message, "Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server_6618", "Remove the 20mb cap on total source code size for JavaScript files in the TypeScript language server."),
        Opt_a_project_out_of_multi_project_reference_checking_when_editing: diag(6619, ts3.DiagnosticCategory.Message, "Opt_a_project_out_of_multi_project_reference_checking_when_editing_6619", "Opt a project out of multi-project reference checking when editing."),
        Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects: diag(6620, ts3.DiagnosticCategory.Message, "Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects_6620", "Disable preferring source files instead of declaration files when referencing composite projects."),
        Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration: diag(6621, ts3.DiagnosticCategory.Message, "Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration_6621", "Emit more compliant, but verbose and less performant JavaScript for iteration."),
        Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files: diag(6622, ts3.DiagnosticCategory.Message, "Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6622", "Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),
        Only_output_d_ts_files_and_not_JavaScript_files: diag(6623, ts3.DiagnosticCategory.Message, "Only_output_d_ts_files_and_not_JavaScript_files_6623", "Only output d.ts files and not JavaScript files."),
        Emit_design_type_metadata_for_decorated_declarations_in_source_files: diag(6624, ts3.DiagnosticCategory.Message, "Emit_design_type_metadata_for_decorated_declarations_in_source_files_6624", "Emit design-type metadata for decorated declarations in source files."),
        Disable_the_type_acquisition_for_JavaScript_projects: diag(6625, ts3.DiagnosticCategory.Message, "Disable_the_type_acquisition_for_JavaScript_projects_6625", "Disable the type acquisition for JavaScript projects"),
        Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility: diag(6626, ts3.DiagnosticCategory.Message, "Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheti_6626", "Emit additional JavaScript to ease support for importing CommonJS modules. This enables 'allowSyntheticDefaultImports' for type compatibility."),
        Filters_results_from_the_include_option: diag(6627, ts3.DiagnosticCategory.Message, "Filters_results_from_the_include_option_6627", "Filters results from the `include` option."),
        Remove_a_list_of_directories_from_the_watch_process: diag(6628, ts3.DiagnosticCategory.Message, "Remove_a_list_of_directories_from_the_watch_process_6628", "Remove a list of directories from the watch process."),
        Remove_a_list_of_files_from_the_watch_mode_s_processing: diag(6629, ts3.DiagnosticCategory.Message, "Remove_a_list_of_files_from_the_watch_mode_s_processing_6629", "Remove a list of files from the watch mode's processing."),
        Enable_experimental_support_for_TC39_stage_2_draft_decorators: diag(6630, ts3.DiagnosticCategory.Message, "Enable_experimental_support_for_TC39_stage_2_draft_decorators_6630", "Enable experimental support for TC39 stage 2 draft decorators."),
        Print_files_read_during_the_compilation_including_why_it_was_included: diag(6631, ts3.DiagnosticCategory.Message, "Print_files_read_during_the_compilation_including_why_it_was_included_6631", "Print files read during the compilation including why it was included."),
        Output_more_detailed_compiler_performance_information_after_building: diag(6632, ts3.DiagnosticCategory.Message, "Output_more_detailed_compiler_performance_information_after_building_6632", "Output more detailed compiler performance information after building."),
        Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_are_inherited: diag(6633, ts3.DiagnosticCategory.Message, "Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_a_6633", "Specify one or more path or node module references to base configuration files from which settings are inherited."),
        Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers: diag(6634, ts3.DiagnosticCategory.Message, "Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers_6634", "Specify what approach the watcher should use if the system runs out of native file watchers."),
        Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include: diag(6635, ts3.DiagnosticCategory.Message, "Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include_6635", "Include a list of files. This does not support glob patterns, as opposed to `include`."),
        Build_all_projects_including_those_that_appear_to_be_up_to_date: diag(6636, ts3.DiagnosticCategory.Message, "Build_all_projects_including_those_that_appear_to_be_up_to_date_6636", "Build all projects, including those that appear to be up to date."),
        Ensure_that_casing_is_correct_in_imports: diag(6637, ts3.DiagnosticCategory.Message, "Ensure_that_casing_is_correct_in_imports_6637", "Ensure that casing is correct in imports."),
        Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging: diag(6638, ts3.DiagnosticCategory.Message, "Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging_6638", "Emit a v8 CPU profile of the compiler run for debugging."),
        Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file: diag(6639, ts3.DiagnosticCategory.Message, "Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file_6639", "Allow importing helper functions from tslib once per project, instead of including them per-file."),
        Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation: diag(6641, ts3.DiagnosticCategory.Message, "Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation_6641", "Specify a list of glob patterns that match files to be included in compilation."),
        Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects: diag(6642, ts3.DiagnosticCategory.Message, "Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects_6642", "Save .tsbuildinfo files to allow for incremental compilation of projects."),
        Include_sourcemap_files_inside_the_emitted_JavaScript: diag(6643, ts3.DiagnosticCategory.Message, "Include_sourcemap_files_inside_the_emitted_JavaScript_6643", "Include sourcemap files inside the emitted JavaScript."),
        Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript: diag(6644, ts3.DiagnosticCategory.Message, "Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript_6644", "Include source code in the sourcemaps inside the emitted JavaScript."),
        Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports: diag(6645, ts3.DiagnosticCategory.Message, "Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports_6645", "Ensure that each file can be safely transpiled without relying on other imports."),
        Specify_what_JSX_code_is_generated: diag(6646, ts3.DiagnosticCategory.Message, "Specify_what_JSX_code_is_generated_6646", "Specify what JSX code is generated."),
        Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h: diag(6647, ts3.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h_6647", "Specify the JSX factory function used when targeting React JSX emit, e.g. 'React.createElement' or 'h'."),
        Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment: diag(6648, ts3.DiagnosticCategory.Message, "Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragme_6648", "Specify the JSX Fragment reference used for fragments when targeting React JSX emit e.g. 'React.Fragment' or 'Fragment'."),
        Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk: diag(6649, ts3.DiagnosticCategory.Message, "Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Ast_6649", "Specify module specifier used to import the JSX factory functions when using 'jsx: react-jsx*'."),
        Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option: diag(6650, ts3.DiagnosticCategory.Message, "Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option_6650", "Make keyof only return strings instead of string, numbers or symbols. Legacy option."),
        Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment: diag(6651, ts3.DiagnosticCategory.Message, "Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment_6651", "Specify a set of bundled library declaration files that describe the target runtime environment."),
        Print_the_names_of_emitted_files_after_a_compilation: diag(6652, ts3.DiagnosticCategory.Message, "Print_the_names_of_emitted_files_after_a_compilation_6652", "Print the names of emitted files after a compilation."),
        Print_all_of_the_files_read_during_the_compilation: diag(6653, ts3.DiagnosticCategory.Message, "Print_all_of_the_files_read_during_the_compilation_6653", "Print all of the files read during the compilation."),
        Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit: diag(6654, ts3.DiagnosticCategory.Message, "Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit_6654", "Set the language of the messaging from TypeScript. This does not affect emit."),
        Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations: diag(6655, ts3.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6655", "Specify the location where debugger should locate map files instead of generated locations."),
        Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs: diag(6656, ts3.DiagnosticCategory.Message, "Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicabl_6656", "Specify the maximum folder depth used for checking JavaScript files from 'node_modules'. Only applicable with 'allowJs'."),
        Specify_what_module_code_is_generated: diag(6657, ts3.DiagnosticCategory.Message, "Specify_what_module_code_is_generated_6657", "Specify what module code is generated."),
        Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier: diag(6658, ts3.DiagnosticCategory.Message, "Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier_6658", "Specify how TypeScript looks up a file from a given module specifier."),
        Set_the_newline_character_for_emitting_files: diag(6659, ts3.DiagnosticCategory.Message, "Set_the_newline_character_for_emitting_files_6659", "Set the newline character for emitting files."),
        Disable_emitting_files_from_a_compilation: diag(6660, ts3.DiagnosticCategory.Message, "Disable_emitting_files_from_a_compilation_6660", "Disable emitting files from a compilation."),
        Disable_generating_custom_helper_functions_like_extends_in_compiled_output: diag(6661, ts3.DiagnosticCategory.Message, "Disable_generating_custom_helper_functions_like_extends_in_compiled_output_6661", "Disable generating custom helper functions like '__extends' in compiled output."),
        Disable_emitting_files_if_any_type_checking_errors_are_reported: diag(6662, ts3.DiagnosticCategory.Message, "Disable_emitting_files_if_any_type_checking_errors_are_reported_6662", "Disable emitting files if any type checking errors are reported."),
        Disable_truncating_types_in_error_messages: diag(6663, ts3.DiagnosticCategory.Message, "Disable_truncating_types_in_error_messages_6663", "Disable truncating types in error messages."),
        Enable_error_reporting_for_fallthrough_cases_in_switch_statements: diag(6664, ts3.DiagnosticCategory.Message, "Enable_error_reporting_for_fallthrough_cases_in_switch_statements_6664", "Enable error reporting for fallthrough cases in switch statements."),
        Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type: diag(6665, ts3.DiagnosticCategory.Message, "Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type_6665", "Enable error reporting for expressions and declarations with an implied 'any' type."),
        Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier: diag(6666, ts3.DiagnosticCategory.Message, "Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6666", "Ensure overriding members in derived classes are marked with an override modifier."),
        Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function: diag(6667, ts3.DiagnosticCategory.Message, "Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function_6667", "Enable error reporting for codepaths that do not explicitly return in a function."),
        Enable_error_reporting_when_this_is_given_the_type_any: diag(6668, ts3.DiagnosticCategory.Message, "Enable_error_reporting_when_this_is_given_the_type_any_6668", "Enable error reporting when 'this' is given the type 'any'."),
        Disable_adding_use_strict_directives_in_emitted_JavaScript_files: diag(6669, ts3.DiagnosticCategory.Message, "Disable_adding_use_strict_directives_in_emitted_JavaScript_files_6669", "Disable adding 'use strict' directives in emitted JavaScript files."),
        Disable_including_any_library_files_including_the_default_lib_d_ts: diag(6670, ts3.DiagnosticCategory.Message, "Disable_including_any_library_files_including_the_default_lib_d_ts_6670", "Disable including any library files, including the default lib.d.ts."),
        Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type: diag(6671, ts3.DiagnosticCategory.Message, "Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type_6671", "Enforces using indexed accessors for keys declared using an indexed type."),
        Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project: diag(6672, ts3.DiagnosticCategory.Message, "Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add__6672", "Disallow 'import's, 'require's or '<reference>'s from expanding the number of files TypeScript should add to a project."),
        Disable_strict_checking_of_generic_signatures_in_function_types: diag(6673, ts3.DiagnosticCategory.Message, "Disable_strict_checking_of_generic_signatures_in_function_types_6673", "Disable strict checking of generic signatures in function types."),
        Add_undefined_to_a_type_when_accessed_using_an_index: diag(6674, ts3.DiagnosticCategory.Message, "Add_undefined_to_a_type_when_accessed_using_an_index_6674", "Add 'undefined' to a type when accessed using an index."),
        Enable_error_reporting_when_local_variables_aren_t_read: diag(6675, ts3.DiagnosticCategory.Message, "Enable_error_reporting_when_local_variables_aren_t_read_6675", "Enable error reporting when local variables aren't read."),
        Raise_an_error_when_a_function_parameter_isn_t_read: diag(6676, ts3.DiagnosticCategory.Message, "Raise_an_error_when_a_function_parameter_isn_t_read_6676", "Raise an error when a function parameter isn't read."),
        Deprecated_setting_Use_outFile_instead: diag(6677, ts3.DiagnosticCategory.Message, "Deprecated_setting_Use_outFile_instead_6677", "Deprecated setting. Use 'outFile' instead."),
        Specify_an_output_folder_for_all_emitted_files: diag(6678, ts3.DiagnosticCategory.Message, "Specify_an_output_folder_for_all_emitted_files_6678", "Specify an output folder for all emitted files."),
        Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output: diag(6679, ts3.DiagnosticCategory.Message, "Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designa_6679", "Specify a file that bundles all outputs into one JavaScript file. If 'declaration' is true, also designates a file that bundles all .d.ts output."),
        Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations: diag(6680, ts3.DiagnosticCategory.Message, "Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations_6680", "Specify a set of entries that re-map imports to additional lookup locations."),
        Specify_a_list_of_language_service_plugins_to_include: diag(6681, ts3.DiagnosticCategory.Message, "Specify_a_list_of_language_service_plugins_to_include_6681", "Specify a list of language service plugins to include."),
        Disable_erasing_const_enum_declarations_in_generated_code: diag(6682, ts3.DiagnosticCategory.Message, "Disable_erasing_const_enum_declarations_in_generated_code_6682", "Disable erasing 'const enum' declarations in generated code."),
        Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node: diag(6683, ts3.DiagnosticCategory.Message, "Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node_6683", "Disable resolving symlinks to their realpath. This correlates to the same flag in node."),
        Disable_wiping_the_console_in_watch_mode: diag(6684, ts3.DiagnosticCategory.Message, "Disable_wiping_the_console_in_watch_mode_6684", "Disable wiping the console in watch mode."),
        Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read: diag(6685, ts3.DiagnosticCategory.Message, "Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read_6685", "Enable color and formatting in TypeScript's output to make compiler errors easier to read."),
        Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit: diag(6686, ts3.DiagnosticCategory.Message, "Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit_6686", "Specify the object invoked for 'createElement'. This only applies when targeting 'react' JSX emit."),
        Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references: diag(6687, ts3.DiagnosticCategory.Message, "Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references_6687", "Specify an array of objects that specify paths for projects. Used in project references."),
        Disable_emitting_comments: diag(6688, ts3.DiagnosticCategory.Message, "Disable_emitting_comments_6688", "Disable emitting comments."),
        Enable_importing_json_files: diag(6689, ts3.DiagnosticCategory.Message, "Enable_importing_json_files_6689", "Enable importing .json files."),
        Specify_the_root_folder_within_your_source_files: diag(6690, ts3.DiagnosticCategory.Message, "Specify_the_root_folder_within_your_source_files_6690", "Specify the root folder within your source files."),
        Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules: diag(6691, ts3.DiagnosticCategory.Message, "Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules_6691", "Allow multiple folders to be treated as one when resolving modules."),
        Skip_type_checking_d_ts_files_that_are_included_with_TypeScript: diag(6692, ts3.DiagnosticCategory.Message, "Skip_type_checking_d_ts_files_that_are_included_with_TypeScript_6692", "Skip type checking .d.ts files that are included with TypeScript."),
        Skip_type_checking_all_d_ts_files: diag(6693, ts3.DiagnosticCategory.Message, "Skip_type_checking_all_d_ts_files_6693", "Skip type checking all .d.ts files."),
        Create_source_map_files_for_emitted_JavaScript_files: diag(6694, ts3.DiagnosticCategory.Message, "Create_source_map_files_for_emitted_JavaScript_files_6694", "Create source map files for emitted JavaScript files."),
        Specify_the_root_path_for_debuggers_to_find_the_reference_source_code: diag(6695, ts3.DiagnosticCategory.Message, "Specify_the_root_path_for_debuggers_to_find_the_reference_source_code_6695", "Specify the root path for debuggers to find the reference source code."),
        Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function: diag(6697, ts3.DiagnosticCategory.Message, "Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function_6697", "Check that the arguments for 'bind', 'call', and 'apply' methods match the original function."),
        When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible: diag(6698, ts3.DiagnosticCategory.Message, "When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible_6698", "When assigning functions, check to ensure parameters and the return values are subtype-compatible."),
        When_type_checking_take_into_account_null_and_undefined: diag(6699, ts3.DiagnosticCategory.Message, "When_type_checking_take_into_account_null_and_undefined_6699", "When type checking, take into account 'null' and 'undefined'."),
        Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor: diag(6700, ts3.DiagnosticCategory.Message, "Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor_6700", "Check for class properties that are declared but not set in the constructor."),
        Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments: diag(6701, ts3.DiagnosticCategory.Message, "Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments_6701", "Disable emitting declarations that have '@internal' in their JSDoc comments."),
        Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals: diag(6702, ts3.DiagnosticCategory.Message, "Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals_6702", "Disable reporting of excess property errors during the creation of object literals."),
        Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures: diag(6703, ts3.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures_6703", "Suppress 'noImplicitAny' errors when indexing objects that lack index signatures."),
        Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively: diag(6704, ts3.DiagnosticCategory.Message, "Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6704", "Synchronously call callbacks and update the state of directory watchers on platforms that don`t support recursive watching natively."),
        Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations: diag(6705, ts3.DiagnosticCategory.Message, "Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declaratio_6705", "Set the JavaScript language version for emitted JavaScript and include compatible library declarations."),
        Log_paths_used_during_the_moduleResolution_process: diag(6706, ts3.DiagnosticCategory.Message, "Log_paths_used_during_the_moduleResolution_process_6706", "Log paths used during the 'moduleResolution' process."),
        Specify_the_path_to_tsbuildinfo_incremental_compilation_file: diag(6707, ts3.DiagnosticCategory.Message, "Specify_the_path_to_tsbuildinfo_incremental_compilation_file_6707", "Specify the path to .tsbuildinfo incremental compilation file."),
        Specify_options_for_automatic_acquisition_of_declaration_files: diag(6709, ts3.DiagnosticCategory.Message, "Specify_options_for_automatic_acquisition_of_declaration_files_6709", "Specify options for automatic acquisition of declaration files."),
        Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types: diag(6710, ts3.DiagnosticCategory.Message, "Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types_6710", "Specify multiple folders that act like './node_modules/@types'."),
        Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file: diag(6711, ts3.DiagnosticCategory.Message, "Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file_6711", "Specify type package names to be included without being referenced in a source file."),
        Emit_ECMAScript_standard_compliant_class_fields: diag(6712, ts3.DiagnosticCategory.Message, "Emit_ECMAScript_standard_compliant_class_fields_6712", "Emit ECMAScript-standard-compliant class fields."),
        Enable_verbose_logging: diag(6713, ts3.DiagnosticCategory.Message, "Enable_verbose_logging_6713", "Enable verbose logging."),
        Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality: diag(6714, ts3.DiagnosticCategory.Message, "Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality_6714", "Specify how directories are watched on systems that lack recursive file-watching functionality."),
        Specify_how_the_TypeScript_watch_mode_works: diag(6715, ts3.DiagnosticCategory.Message, "Specify_how_the_TypeScript_watch_mode_works_6715", "Specify how the TypeScript watch mode works."),
        Require_undeclared_properties_from_index_signatures_to_use_element_accesses: diag(6717, ts3.DiagnosticCategory.Message, "Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6717", "Require undeclared properties from index signatures to use element accesses."),
        Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types: diag(6718, ts3.DiagnosticCategory.Message, "Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_6718", "Specify emit/checking behavior for imports that are only used for types."),
        Default_catch_clause_variables_as_unknown_instead_of_any: diag(6803, ts3.DiagnosticCategory.Message, "Default_catch_clause_variables_as_unknown_instead_of_any_6803", "Default catch clause variables as 'unknown' instead of 'any'."),
        one_of_Colon: diag(6900, ts3.DiagnosticCategory.Message, "one_of_Colon_6900", "one of:"),
        one_or_more_Colon: diag(6901, ts3.DiagnosticCategory.Message, "one_or_more_Colon_6901", "one or more:"),
        type_Colon: diag(6902, ts3.DiagnosticCategory.Message, "type_Colon_6902", "type:"),
        default_Colon: diag(6903, ts3.DiagnosticCategory.Message, "default_Colon_6903", "default:"),
        module_system_or_esModuleInterop: diag(6904, ts3.DiagnosticCategory.Message, "module_system_or_esModuleInterop_6904", 'module === "system" or esModuleInterop'),
        false_unless_strict_is_set: diag(6905, ts3.DiagnosticCategory.Message, "false_unless_strict_is_set_6905", "`false`, unless `strict` is set"),
        false_unless_composite_is_set: diag(6906, ts3.DiagnosticCategory.Message, "false_unless_composite_is_set_6906", "`false`, unless `composite` is set"),
        node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified: diag(6907, ts3.DiagnosticCategory.Message, "node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified_6907", '`["node_modules", "bower_components", "jspm_packages"]`, plus the value of `outDir` if one is specified.'),
        if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk: diag(6908, ts3.DiagnosticCategory.Message, "if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk_6908", '`[]` if `files` is specified, otherwise `["**/*"]`'),
        true_if_composite_false_otherwise: diag(6909, ts3.DiagnosticCategory.Message, "true_if_composite_false_otherwise_6909", "`true` if `composite`, `false` otherwise"),
        module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node: diag(69010, ts3.DiagnosticCategory.Message, "module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node_69010", "module === `AMD` or `UMD` or `System` or `ES6`, then `Classic`, Otherwise `Node`"),
        Computed_from_the_list_of_input_files: diag(6911, ts3.DiagnosticCategory.Message, "Computed_from_the_list_of_input_files_6911", "Computed from the list of input files"),
        Platform_specific: diag(6912, ts3.DiagnosticCategory.Message, "Platform_specific_6912", "Platform specific"),
        You_can_learn_about_all_of_the_compiler_options_at_0: diag(6913, ts3.DiagnosticCategory.Message, "You_can_learn_about_all_of_the_compiler_options_at_0_6913", "You can learn about all of the compiler options at {0}"),
        Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon: diag(6914, ts3.DiagnosticCategory.Message, "Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_conf_6914", "Including --watch, -w will start watching the current project for the file changes. Once set, you can config watch mode with:"),
        Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0: diag(6915, ts3.DiagnosticCategory.Message, "Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_tr_6915", "Using --build, -b will make tsc behave more like a build orchestrator than a compiler. This is used to trigger building composite projects which you can learn more about at {0}"),
        COMMON_COMMANDS: diag(6916, ts3.DiagnosticCategory.Message, "COMMON_COMMANDS_6916", "COMMON COMMANDS"),
        ALL_COMPILER_OPTIONS: diag(6917, ts3.DiagnosticCategory.Message, "ALL_COMPILER_OPTIONS_6917", "ALL COMPILER OPTIONS"),
        WATCH_OPTIONS: diag(6918, ts3.DiagnosticCategory.Message, "WATCH_OPTIONS_6918", "WATCH OPTIONS"),
        BUILD_OPTIONS: diag(6919, ts3.DiagnosticCategory.Message, "BUILD_OPTIONS_6919", "BUILD OPTIONS"),
        COMMON_COMPILER_OPTIONS: diag(6920, ts3.DiagnosticCategory.Message, "COMMON_COMPILER_OPTIONS_6920", "COMMON COMPILER OPTIONS"),
        COMMAND_LINE_FLAGS: diag(6921, ts3.DiagnosticCategory.Message, "COMMAND_LINE_FLAGS_6921", "COMMAND LINE FLAGS"),
        tsc_Colon_The_TypeScript_Compiler: diag(6922, ts3.DiagnosticCategory.Message, "tsc_Colon_The_TypeScript_Compiler_6922", "tsc: The TypeScript Compiler"),
        Compiles_the_current_project_tsconfig_json_in_the_working_directory: diag(6923, ts3.DiagnosticCategory.Message, "Compiles_the_current_project_tsconfig_json_in_the_working_directory_6923", "Compiles the current project (tsconfig.json in the working directory.)"),
        Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options: diag(6924, ts3.DiagnosticCategory.Message, "Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options_6924", "Ignoring tsconfig.json, compiles the specified files with default compiler options."),
        Build_a_composite_project_in_the_working_directory: diag(6925, ts3.DiagnosticCategory.Message, "Build_a_composite_project_in_the_working_directory_6925", "Build a composite project in the working directory."),
        Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory: diag(6926, ts3.DiagnosticCategory.Message, "Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory_6926", "Creates a tsconfig.json with the recommended settings in the working directory."),
        Compiles_the_TypeScript_project_located_at_the_specified_path: diag(6927, ts3.DiagnosticCategory.Message, "Compiles_the_TypeScript_project_located_at_the_specified_path_6927", "Compiles the TypeScript project located at the specified path."),
        An_expanded_version_of_this_information_showing_all_possible_compiler_options: diag(6928, ts3.DiagnosticCategory.Message, "An_expanded_version_of_this_information_showing_all_possible_compiler_options_6928", "An expanded version of this information, showing all possible compiler options"),
        Compiles_the_current_project_with_additional_settings: diag(6929, ts3.DiagnosticCategory.Message, "Compiles_the_current_project_with_additional_settings_6929", "Compiles the current project, with additional settings."),
        true_for_ES2022_and_above_including_ESNext: diag(6930, ts3.DiagnosticCategory.Message, "true_for_ES2022_and_above_including_ESNext_6930", "`true` for ES2022 and above, including ESNext."),
        List_of_file_name_suffixes_to_search_when_resolving_a_module: diag(6931, ts3.DiagnosticCategory.Error, "List_of_file_name_suffixes_to_search_when_resolving_a_module_6931", "List of file name suffixes to search when resolving a module."),
        Variable_0_implicitly_has_an_1_type: diag(7005, ts3.DiagnosticCategory.Error, "Variable_0_implicitly_has_an_1_type_7005", "Variable '{0}' implicitly has an '{1}' type."),
        Parameter_0_implicitly_has_an_1_type: diag(7006, ts3.DiagnosticCategory.Error, "Parameter_0_implicitly_has_an_1_type_7006", "Parameter '{0}' implicitly has an '{1}' type."),
        Member_0_implicitly_has_an_1_type: diag(7008, ts3.DiagnosticCategory.Error, "Member_0_implicitly_has_an_1_type_7008", "Member '{0}' implicitly has an '{1}' type."),
        new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type: diag(7009, ts3.DiagnosticCategory.Error, "new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009", "'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),
        _0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type: diag(7010, ts3.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010", "'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),
        Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7011, ts3.DiagnosticCategory.Error, "Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011", "Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),
        Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7013, ts3.DiagnosticCategory.Error, "Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013", "Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),
        Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7014, ts3.DiagnosticCategory.Error, "Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014", "Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),
        Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number: diag(7015, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015", "Element implicitly has an 'any' type because index expression is not of type 'number'."),
        Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type: diag(7016, ts3.DiagnosticCategory.Error, "Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016", "Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),
        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature: diag(7017, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017", "Element implicitly has an 'any' type because type '{0}' has no index signature."),
        Object_literal_s_property_0_implicitly_has_an_1_type: diag(7018, ts3.DiagnosticCategory.Error, "Object_literal_s_property_0_implicitly_has_an_1_type_7018", "Object literal's property '{0}' implicitly has an '{1}' type."),
        Rest_parameter_0_implicitly_has_an_any_type: diag(7019, ts3.DiagnosticCategory.Error, "Rest_parameter_0_implicitly_has_an_any_type_7019", "Rest parameter '{0}' implicitly has an 'any[]' type."),
        Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7020, ts3.DiagnosticCategory.Error, "Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020", "Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),
        _0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer: diag(7022, ts3.DiagnosticCategory.Error, "_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022", "'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),
        _0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7023, ts3.DiagnosticCategory.Error, "_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023", "'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
        Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7024, ts3.DiagnosticCategory.Error, "Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024", "Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
        Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation: diag(7025, ts3.DiagnosticCategory.Error, "Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025", "Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."),
        JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists: diag(7026, ts3.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026", "JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),
        Unreachable_code_detected: diag(7027, ts3.DiagnosticCategory.Error, "Unreachable_code_detected_7027", "Unreachable code detected.", true),
        Unused_label: diag(7028, ts3.DiagnosticCategory.Error, "Unused_label_7028", "Unused label.", true),
        Fallthrough_case_in_switch: diag(7029, ts3.DiagnosticCategory.Error, "Fallthrough_case_in_switch_7029", "Fallthrough case in switch."),
        Not_all_code_paths_return_a_value: diag(7030, ts3.DiagnosticCategory.Error, "Not_all_code_paths_return_a_value_7030", "Not all code paths return a value."),
        Binding_element_0_implicitly_has_an_1_type: diag(7031, ts3.DiagnosticCategory.Error, "Binding_element_0_implicitly_has_an_1_type_7031", "Binding element '{0}' implicitly has an '{1}' type."),
        Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation: diag(7032, ts3.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032", "Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),
        Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation: diag(7033, ts3.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033", "Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),
        Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined: diag(7034, ts3.DiagnosticCategory.Error, "Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034", "Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),
        Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0: diag(7035, ts3.DiagnosticCategory.Error, "Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035", "Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),
        Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0: diag(7036, ts3.DiagnosticCategory.Error, "Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036", "Dynamic import's specifier must be of type 'string', but here has type '{0}'."),
        Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports: diag(7037, ts3.DiagnosticCategory.Message, "Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037", "Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),
        Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead: diag(7038, ts3.DiagnosticCategory.Message, "Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038", "Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),
        Mapped_object_type_implicitly_has_an_any_template_type: diag(7039, ts3.DiagnosticCategory.Error, "Mapped_object_type_implicitly_has_an_any_template_type_7039", "Mapped object type implicitly has an 'any' template type."),
        If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1: diag(7040, ts3.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040", "If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"),
        The_containing_arrow_function_captures_the_global_value_of_this: diag(7041, ts3.DiagnosticCategory.Error, "The_containing_arrow_function_captures_the_global_value_of_this_7041", "The containing arrow function captures the global value of 'this'."),
        Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used: diag(7042, ts3.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042", "Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),
        Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7043, ts3.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043", "Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7044, ts3.DiagnosticCategory.Suggestion, "Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044", "Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7045, ts3.DiagnosticCategory.Suggestion, "Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045", "Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage: diag(7046, ts3.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046", "Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),
        Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage: diag(7047, ts3.DiagnosticCategory.Suggestion, "Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047", "Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),
        Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage: diag(7048, ts3.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048", "Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),
        Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage: diag(7049, ts3.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049", "Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),
        _0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage: diag(7050, ts3.DiagnosticCategory.Suggestion, "_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050", "'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),
        Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1: diag(7051, ts3.DiagnosticCategory.Error, "Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051", "Parameter has a name but no type. Did you mean '{0}: {1}'?"),
        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1: diag(7052, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052", "Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"),
        Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1: diag(7053, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053", "Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),
        No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1: diag(7054, ts3.DiagnosticCategory.Error, "No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054", "No index signature with a parameter of type '{0}' was found on type '{1}'."),
        _0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type: diag(7055, ts3.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055", "'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."),
        The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed: diag(7056, ts3.DiagnosticCategory.Error, "The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056", "The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."),
        yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation: diag(7057, ts3.DiagnosticCategory.Error, "yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057", "'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."),
        If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1: diag(7058, ts3.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_decl_7058", "If the '{0}' package actually exposes this module, try adding a new declaration (.d.ts) file containing `declare module '{1}';`"),
        This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead: diag(7059, ts3.DiagnosticCategory.Error, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead_7059", "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."),
        This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint: diag(7060, ts3.DiagnosticCategory.Error, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_cons_7060", "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma or explicit constraint."),
        A_mapped_type_may_not_declare_properties_or_methods: diag(7061, ts3.DiagnosticCategory.Error, "A_mapped_type_may_not_declare_properties_or_methods_7061", "A mapped type may not declare properties or methods."),
        You_cannot_rename_this_element: diag(8e3, ts3.DiagnosticCategory.Error, "You_cannot_rename_this_element_8000", "You cannot rename this element."),
        You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library: diag(8001, ts3.DiagnosticCategory.Error, "You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001", "You cannot rename elements that are defined in the standard TypeScript library."),
        import_can_only_be_used_in_TypeScript_files: diag(8002, ts3.DiagnosticCategory.Error, "import_can_only_be_used_in_TypeScript_files_8002", "'import ... =' can only be used in TypeScript files."),
        export_can_only_be_used_in_TypeScript_files: diag(8003, ts3.DiagnosticCategory.Error, "export_can_only_be_used_in_TypeScript_files_8003", "'export =' can only be used in TypeScript files."),
        Type_parameter_declarations_can_only_be_used_in_TypeScript_files: diag(8004, ts3.DiagnosticCategory.Error, "Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004", "Type parameter declarations can only be used in TypeScript files."),
        implements_clauses_can_only_be_used_in_TypeScript_files: diag(8005, ts3.DiagnosticCategory.Error, "implements_clauses_can_only_be_used_in_TypeScript_files_8005", "'implements' clauses can only be used in TypeScript files."),
        _0_declarations_can_only_be_used_in_TypeScript_files: diag(8006, ts3.DiagnosticCategory.Error, "_0_declarations_can_only_be_used_in_TypeScript_files_8006", "'{0}' declarations can only be used in TypeScript files."),
        Type_aliases_can_only_be_used_in_TypeScript_files: diag(8008, ts3.DiagnosticCategory.Error, "Type_aliases_can_only_be_used_in_TypeScript_files_8008", "Type aliases can only be used in TypeScript files."),
        The_0_modifier_can_only_be_used_in_TypeScript_files: diag(8009, ts3.DiagnosticCategory.Error, "The_0_modifier_can_only_be_used_in_TypeScript_files_8009", "The '{0}' modifier can only be used in TypeScript files."),
        Type_annotations_can_only_be_used_in_TypeScript_files: diag(8010, ts3.DiagnosticCategory.Error, "Type_annotations_can_only_be_used_in_TypeScript_files_8010", "Type annotations can only be used in TypeScript files."),
        Type_arguments_can_only_be_used_in_TypeScript_files: diag(8011, ts3.DiagnosticCategory.Error, "Type_arguments_can_only_be_used_in_TypeScript_files_8011", "Type arguments can only be used in TypeScript files."),
        Parameter_modifiers_can_only_be_used_in_TypeScript_files: diag(8012, ts3.DiagnosticCategory.Error, "Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012", "Parameter modifiers can only be used in TypeScript files."),
        Non_null_assertions_can_only_be_used_in_TypeScript_files: diag(8013, ts3.DiagnosticCategory.Error, "Non_null_assertions_can_only_be_used_in_TypeScript_files_8013", "Non-null assertions can only be used in TypeScript files."),
        Type_assertion_expressions_can_only_be_used_in_TypeScript_files: diag(8016, ts3.DiagnosticCategory.Error, "Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016", "Type assertion expressions can only be used in TypeScript files."),
        Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0: diag(8017, ts3.DiagnosticCategory.Error, "Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017", "Octal literal types must use ES2015 syntax. Use the syntax '{0}'."),
        Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0: diag(8018, ts3.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018", "Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."),
        Report_errors_in_js_files: diag(8019, ts3.DiagnosticCategory.Message, "Report_errors_in_js_files_8019", "Report errors in .js files."),
        JSDoc_types_can_only_be_used_inside_documentation_comments: diag(8020, ts3.DiagnosticCategory.Error, "JSDoc_types_can_only_be_used_inside_documentation_comments_8020", "JSDoc types can only be used inside documentation comments."),
        JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags: diag(8021, ts3.DiagnosticCategory.Error, "JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021", "JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),
        JSDoc_0_is_not_attached_to_a_class: diag(8022, ts3.DiagnosticCategory.Error, "JSDoc_0_is_not_attached_to_a_class_8022", "JSDoc '@{0}' is not attached to a class."),
        JSDoc_0_1_does_not_match_the_extends_2_clause: diag(8023, ts3.DiagnosticCategory.Error, "JSDoc_0_1_does_not_match_the_extends_2_clause_8023", "JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),
        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name: diag(8024, ts3.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),
        Class_declarations_cannot_have_more_than_one_augments_or_extends_tag: diag(8025, ts3.DiagnosticCategory.Error, "Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025", "Class declarations cannot have more than one '@augments' or '@extends' tag."),
        Expected_0_type_arguments_provide_these_with_an_extends_tag: diag(8026, ts3.DiagnosticCategory.Error, "Expected_0_type_arguments_provide_these_with_an_extends_tag_8026", "Expected {0} type arguments; provide these with an '@extends' tag."),
        Expected_0_1_type_arguments_provide_these_with_an_extends_tag: diag(8027, ts3.DiagnosticCategory.Error, "Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027", "Expected {0}-{1} type arguments; provide these with an '@extends' tag."),
        JSDoc_may_only_appear_in_the_last_parameter_of_a_signature: diag(8028, ts3.DiagnosticCategory.Error, "JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028", "JSDoc '...' may only appear in the last parameter of a signature."),
        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type: diag(8029, ts3.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),
        The_type_of_a_function_declaration_must_match_the_function_s_signature: diag(8030, ts3.DiagnosticCategory.Error, "The_type_of_a_function_declaration_must_match_the_function_s_signature_8030", "The type of a function declaration must match the function's signature."),
        You_cannot_rename_a_module_via_a_global_import: diag(8031, ts3.DiagnosticCategory.Error, "You_cannot_rename_a_module_via_a_global_import_8031", "You cannot rename a module via a global import."),
        Qualified_name_0_is_not_allowed_without_a_leading_param_object_1: diag(8032, ts3.DiagnosticCategory.Error, "Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032", "Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),
        A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags: diag(8033, ts3.DiagnosticCategory.Error, "A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033", "A JSDoc '@typedef' comment may not contain multiple '@type' tags."),
        The_tag_was_first_specified_here: diag(8034, ts3.DiagnosticCategory.Error, "The_tag_was_first_specified_here_8034", "The tag was first specified here."),
        Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9005, ts3.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005", "Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."),
        Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9006, ts3.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006", "Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."),
        JSX_attributes_must_only_be_assigned_a_non_empty_expression: diag(17e3, ts3.DiagnosticCategory.Error, "JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000", "JSX attributes must only be assigned a non-empty 'expression'."),
        JSX_elements_cannot_have_multiple_attributes_with_the_same_name: diag(17001, ts3.DiagnosticCategory.Error, "JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001", "JSX elements cannot have multiple attributes with the same name."),
        Expected_corresponding_JSX_closing_tag_for_0: diag(17002, ts3.DiagnosticCategory.Error, "Expected_corresponding_JSX_closing_tag_for_0_17002", "Expected corresponding JSX closing tag for '{0}'."),
        Cannot_use_JSX_unless_the_jsx_flag_is_provided: diag(17004, ts3.DiagnosticCategory.Error, "Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004", "Cannot use JSX unless the '--jsx' flag is provided."),
        A_constructor_cannot_contain_a_super_call_when_its_class_extends_null: diag(17005, ts3.DiagnosticCategory.Error, "A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005", "A constructor cannot contain a 'super' call when its class extends 'null'."),
        An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17006, ts3.DiagnosticCategory.Error, "An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006", "An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
        A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17007, ts3.DiagnosticCategory.Error, "A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007", "A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
        JSX_element_0_has_no_corresponding_closing_tag: diag(17008, ts3.DiagnosticCategory.Error, "JSX_element_0_has_no_corresponding_closing_tag_17008", "JSX element '{0}' has no corresponding closing tag."),
        super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class: diag(17009, ts3.DiagnosticCategory.Error, "super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009", "'super' must be called before accessing 'this' in the constructor of a derived class."),
        Unknown_type_acquisition_option_0: diag(17010, ts3.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_17010", "Unknown type acquisition option '{0}'."),
        super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class: diag(17011, ts3.DiagnosticCategory.Error, "super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011", "'super' must be called before accessing a property of 'super' in the constructor of a derived class."),
        _0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2: diag(17012, ts3.DiagnosticCategory.Error, "_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012", "'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),
        Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor: diag(17013, ts3.DiagnosticCategory.Error, "Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013", "Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),
        JSX_fragment_has_no_corresponding_closing_tag: diag(17014, ts3.DiagnosticCategory.Error, "JSX_fragment_has_no_corresponding_closing_tag_17014", "JSX fragment has no corresponding closing tag."),
        Expected_corresponding_closing_tag_for_JSX_fragment: diag(17015, ts3.DiagnosticCategory.Error, "Expected_corresponding_closing_tag_for_JSX_fragment_17015", "Expected corresponding closing tag for JSX fragment."),
        The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option: diag(17016, ts3.DiagnosticCategory.Error, "The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016", "The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."),
        An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments: diag(17017, ts3.DiagnosticCategory.Error, "An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017", "An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."),
        Unknown_type_acquisition_option_0_Did_you_mean_1: diag(17018, ts3.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_Did_you_mean_1_17018", "Unknown type acquisition option '{0}'. Did you mean '{1}'?"),
        Circularity_detected_while_resolving_configuration_Colon_0: diag(18e3, ts3.DiagnosticCategory.Error, "Circularity_detected_while_resolving_configuration_Colon_0_18000", "Circularity detected while resolving configuration: {0}"),
        The_files_list_in_config_file_0_is_empty: diag(18002, ts3.DiagnosticCategory.Error, "The_files_list_in_config_file_0_is_empty_18002", "The 'files' list in config file '{0}' is empty."),
        No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2: diag(18003, ts3.DiagnosticCategory.Error, "No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003", "No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),
        File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module: diag(80001, ts3.DiagnosticCategory.Suggestion, "File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module_80001", "File is a CommonJS module; it may be converted to an ES module."),
        This_constructor_function_may_be_converted_to_a_class_declaration: diag(80002, ts3.DiagnosticCategory.Suggestion, "This_constructor_function_may_be_converted_to_a_class_declaration_80002", "This constructor function may be converted to a class declaration."),
        Import_may_be_converted_to_a_default_import: diag(80003, ts3.DiagnosticCategory.Suggestion, "Import_may_be_converted_to_a_default_import_80003", "Import may be converted to a default import."),
        JSDoc_types_may_be_moved_to_TypeScript_types: diag(80004, ts3.DiagnosticCategory.Suggestion, "JSDoc_types_may_be_moved_to_TypeScript_types_80004", "JSDoc types may be moved to TypeScript types."),
        require_call_may_be_converted_to_an_import: diag(80005, ts3.DiagnosticCategory.Suggestion, "require_call_may_be_converted_to_an_import_80005", "'require' call may be converted to an import."),
        This_may_be_converted_to_an_async_function: diag(80006, ts3.DiagnosticCategory.Suggestion, "This_may_be_converted_to_an_async_function_80006", "This may be converted to an async function."),
        await_has_no_effect_on_the_type_of_this_expression: diag(80007, ts3.DiagnosticCategory.Suggestion, "await_has_no_effect_on_the_type_of_this_expression_80007", "'await' has no effect on the type of this expression."),
        Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers: diag(80008, ts3.DiagnosticCategory.Suggestion, "Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008", "Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."),
        Add_missing_super_call: diag(90001, ts3.DiagnosticCategory.Message, "Add_missing_super_call_90001", "Add missing 'super()' call"),
        Make_super_call_the_first_statement_in_the_constructor: diag(90002, ts3.DiagnosticCategory.Message, "Make_super_call_the_first_statement_in_the_constructor_90002", "Make 'super()' call the first statement in the constructor"),
        Change_extends_to_implements: diag(90003, ts3.DiagnosticCategory.Message, "Change_extends_to_implements_90003", "Change 'extends' to 'implements'"),
        Remove_unused_declaration_for_Colon_0: diag(90004, ts3.DiagnosticCategory.Message, "Remove_unused_declaration_for_Colon_0_90004", "Remove unused declaration for: '{0}'"),
        Remove_import_from_0: diag(90005, ts3.DiagnosticCategory.Message, "Remove_import_from_0_90005", "Remove import from '{0}'"),
        Implement_interface_0: diag(90006, ts3.DiagnosticCategory.Message, "Implement_interface_0_90006", "Implement interface '{0}'"),
        Implement_inherited_abstract_class: diag(90007, ts3.DiagnosticCategory.Message, "Implement_inherited_abstract_class_90007", "Implement inherited abstract class"),
        Add_0_to_unresolved_variable: diag(90008, ts3.DiagnosticCategory.Message, "Add_0_to_unresolved_variable_90008", "Add '{0}.' to unresolved variable"),
        Remove_variable_statement: diag(90010, ts3.DiagnosticCategory.Message, "Remove_variable_statement_90010", "Remove variable statement"),
        Remove_template_tag: diag(90011, ts3.DiagnosticCategory.Message, "Remove_template_tag_90011", "Remove template tag"),
        Remove_type_parameters: diag(90012, ts3.DiagnosticCategory.Message, "Remove_type_parameters_90012", "Remove type parameters"),
        Import_0_from_1: diag(90013, ts3.DiagnosticCategory.Message, "Import_0_from_1_90013", `Import '{0}' from "{1}"`),
        Change_0_to_1: diag(90014, ts3.DiagnosticCategory.Message, "Change_0_to_1_90014", "Change '{0}' to '{1}'"),
        Declare_property_0: diag(90016, ts3.DiagnosticCategory.Message, "Declare_property_0_90016", "Declare property '{0}'"),
        Add_index_signature_for_property_0: diag(90017, ts3.DiagnosticCategory.Message, "Add_index_signature_for_property_0_90017", "Add index signature for property '{0}'"),
        Disable_checking_for_this_file: diag(90018, ts3.DiagnosticCategory.Message, "Disable_checking_for_this_file_90018", "Disable checking for this file"),
        Ignore_this_error_message: diag(90019, ts3.DiagnosticCategory.Message, "Ignore_this_error_message_90019", "Ignore this error message"),
        Initialize_property_0_in_the_constructor: diag(90020, ts3.DiagnosticCategory.Message, "Initialize_property_0_in_the_constructor_90020", "Initialize property '{0}' in the constructor"),
        Initialize_static_property_0: diag(90021, ts3.DiagnosticCategory.Message, "Initialize_static_property_0_90021", "Initialize static property '{0}'"),
        Change_spelling_to_0: diag(90022, ts3.DiagnosticCategory.Message, "Change_spelling_to_0_90022", "Change spelling to '{0}'"),
        Declare_method_0: diag(90023, ts3.DiagnosticCategory.Message, "Declare_method_0_90023", "Declare method '{0}'"),
        Declare_static_method_0: diag(90024, ts3.DiagnosticCategory.Message, "Declare_static_method_0_90024", "Declare static method '{0}'"),
        Prefix_0_with_an_underscore: diag(90025, ts3.DiagnosticCategory.Message, "Prefix_0_with_an_underscore_90025", "Prefix '{0}' with an underscore"),
        Rewrite_as_the_indexed_access_type_0: diag(90026, ts3.DiagnosticCategory.Message, "Rewrite_as_the_indexed_access_type_0_90026", "Rewrite as the indexed access type '{0}'"),
        Declare_static_property_0: diag(90027, ts3.DiagnosticCategory.Message, "Declare_static_property_0_90027", "Declare static property '{0}'"),
        Call_decorator_expression: diag(90028, ts3.DiagnosticCategory.Message, "Call_decorator_expression_90028", "Call decorator expression"),
        Add_async_modifier_to_containing_function: diag(90029, ts3.DiagnosticCategory.Message, "Add_async_modifier_to_containing_function_90029", "Add async modifier to containing function"),
        Replace_infer_0_with_unknown: diag(90030, ts3.DiagnosticCategory.Message, "Replace_infer_0_with_unknown_90030", "Replace 'infer {0}' with 'unknown'"),
        Replace_all_unused_infer_with_unknown: diag(90031, ts3.DiagnosticCategory.Message, "Replace_all_unused_infer_with_unknown_90031", "Replace all unused 'infer' with 'unknown'"),
        Add_parameter_name: diag(90034, ts3.DiagnosticCategory.Message, "Add_parameter_name_90034", "Add parameter name"),
        Declare_private_property_0: diag(90035, ts3.DiagnosticCategory.Message, "Declare_private_property_0_90035", "Declare private property '{0}'"),
        Replace_0_with_Promise_1: diag(90036, ts3.DiagnosticCategory.Message, "Replace_0_with_Promise_1_90036", "Replace '{0}' with 'Promise<{1}>'"),
        Fix_all_incorrect_return_type_of_an_async_functions: diag(90037, ts3.DiagnosticCategory.Message, "Fix_all_incorrect_return_type_of_an_async_functions_90037", "Fix all incorrect return type of an async functions"),
        Declare_private_method_0: diag(90038, ts3.DiagnosticCategory.Message, "Declare_private_method_0_90038", "Declare private method '{0}'"),
        Remove_unused_destructuring_declaration: diag(90039, ts3.DiagnosticCategory.Message, "Remove_unused_destructuring_declaration_90039", "Remove unused destructuring declaration"),
        Remove_unused_declarations_for_Colon_0: diag(90041, ts3.DiagnosticCategory.Message, "Remove_unused_declarations_for_Colon_0_90041", "Remove unused declarations for: '{0}'"),
        Declare_a_private_field_named_0: diag(90053, ts3.DiagnosticCategory.Message, "Declare_a_private_field_named_0_90053", "Declare a private field named '{0}'."),
        Includes_imports_of_types_referenced_by_0: diag(90054, ts3.DiagnosticCategory.Message, "Includes_imports_of_types_referenced_by_0_90054", "Includes imports of types referenced by '{0}'"),
        Remove_type_from_import_declaration_from_0: diag(90055, ts3.DiagnosticCategory.Message, "Remove_type_from_import_declaration_from_0_90055", `Remove 'type' from import declaration from "{0}"`),
        Remove_type_from_import_of_0_from_1: diag(90056, ts3.DiagnosticCategory.Message, "Remove_type_from_import_of_0_from_1_90056", `Remove 'type' from import of '{0}' from "{1}"`),
        Add_import_from_0: diag(90057, ts3.DiagnosticCategory.Message, "Add_import_from_0_90057", 'Add import from "{0}"'),
        Update_import_from_0: diag(90058, ts3.DiagnosticCategory.Message, "Update_import_from_0_90058", 'Update import from "{0}"'),
        Convert_function_to_an_ES2015_class: diag(95001, ts3.DiagnosticCategory.Message, "Convert_function_to_an_ES2015_class_95001", "Convert function to an ES2015 class"),
        Convert_0_to_1_in_0: diag(95003, ts3.DiagnosticCategory.Message, "Convert_0_to_1_in_0_95003", "Convert '{0}' to '{1} in {0}'"),
        Extract_to_0_in_1: diag(95004, ts3.DiagnosticCategory.Message, "Extract_to_0_in_1_95004", "Extract to {0} in {1}"),
        Extract_function: diag(95005, ts3.DiagnosticCategory.Message, "Extract_function_95005", "Extract function"),
        Extract_constant: diag(95006, ts3.DiagnosticCategory.Message, "Extract_constant_95006", "Extract constant"),
        Extract_to_0_in_enclosing_scope: diag(95007, ts3.DiagnosticCategory.Message, "Extract_to_0_in_enclosing_scope_95007", "Extract to {0} in enclosing scope"),
        Extract_to_0_in_1_scope: diag(95008, ts3.DiagnosticCategory.Message, "Extract_to_0_in_1_scope_95008", "Extract to {0} in {1} scope"),
        Annotate_with_type_from_JSDoc: diag(95009, ts3.DiagnosticCategory.Message, "Annotate_with_type_from_JSDoc_95009", "Annotate with type from JSDoc"),
        Infer_type_of_0_from_usage: diag(95011, ts3.DiagnosticCategory.Message, "Infer_type_of_0_from_usage_95011", "Infer type of '{0}' from usage"),
        Infer_parameter_types_from_usage: diag(95012, ts3.DiagnosticCategory.Message, "Infer_parameter_types_from_usage_95012", "Infer parameter types from usage"),
        Convert_to_default_import: diag(95013, ts3.DiagnosticCategory.Message, "Convert_to_default_import_95013", "Convert to default import"),
        Install_0: diag(95014, ts3.DiagnosticCategory.Message, "Install_0_95014", "Install '{0}'"),
        Replace_import_with_0: diag(95015, ts3.DiagnosticCategory.Message, "Replace_import_with_0_95015", "Replace import with '{0}'."),
        Use_synthetic_default_member: diag(95016, ts3.DiagnosticCategory.Message, "Use_synthetic_default_member_95016", "Use synthetic 'default' member."),
        Convert_to_ES_module: diag(95017, ts3.DiagnosticCategory.Message, "Convert_to_ES_module_95017", "Convert to ES module"),
        Add_undefined_type_to_property_0: diag(95018, ts3.DiagnosticCategory.Message, "Add_undefined_type_to_property_0_95018", "Add 'undefined' type to property '{0}'"),
        Add_initializer_to_property_0: diag(95019, ts3.DiagnosticCategory.Message, "Add_initializer_to_property_0_95019", "Add initializer to property '{0}'"),
        Add_definite_assignment_assertion_to_property_0: diag(95020, ts3.DiagnosticCategory.Message, "Add_definite_assignment_assertion_to_property_0_95020", "Add definite assignment assertion to property '{0}'"),
        Convert_all_type_literals_to_mapped_type: diag(95021, ts3.DiagnosticCategory.Message, "Convert_all_type_literals_to_mapped_type_95021", "Convert all type literals to mapped type"),
        Add_all_missing_members: diag(95022, ts3.DiagnosticCategory.Message, "Add_all_missing_members_95022", "Add all missing members"),
        Infer_all_types_from_usage: diag(95023, ts3.DiagnosticCategory.Message, "Infer_all_types_from_usage_95023", "Infer all types from usage"),
        Delete_all_unused_declarations: diag(95024, ts3.DiagnosticCategory.Message, "Delete_all_unused_declarations_95024", "Delete all unused declarations"),
        Prefix_all_unused_declarations_with_where_possible: diag(95025, ts3.DiagnosticCategory.Message, "Prefix_all_unused_declarations_with_where_possible_95025", "Prefix all unused declarations with '_' where possible"),
        Fix_all_detected_spelling_errors: diag(95026, ts3.DiagnosticCategory.Message, "Fix_all_detected_spelling_errors_95026", "Fix all detected spelling errors"),
        Add_initializers_to_all_uninitialized_properties: diag(95027, ts3.DiagnosticCategory.Message, "Add_initializers_to_all_uninitialized_properties_95027", "Add initializers to all uninitialized properties"),
        Add_definite_assignment_assertions_to_all_uninitialized_properties: diag(95028, ts3.DiagnosticCategory.Message, "Add_definite_assignment_assertions_to_all_uninitialized_properties_95028", "Add definite assignment assertions to all uninitialized properties"),
        Add_undefined_type_to_all_uninitialized_properties: diag(95029, ts3.DiagnosticCategory.Message, "Add_undefined_type_to_all_uninitialized_properties_95029", "Add undefined type to all uninitialized properties"),
        Change_all_jsdoc_style_types_to_TypeScript: diag(95030, ts3.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_95030", "Change all jsdoc-style types to TypeScript"),
        Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types: diag(95031, ts3.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031", "Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),
        Implement_all_unimplemented_interfaces: diag(95032, ts3.DiagnosticCategory.Message, "Implement_all_unimplemented_interfaces_95032", "Implement all unimplemented interfaces"),
        Install_all_missing_types_packages: diag(95033, ts3.DiagnosticCategory.Message, "Install_all_missing_types_packages_95033", "Install all missing types packages"),
        Rewrite_all_as_indexed_access_types: diag(95034, ts3.DiagnosticCategory.Message, "Rewrite_all_as_indexed_access_types_95034", "Rewrite all as indexed access types"),
        Convert_all_to_default_imports: diag(95035, ts3.DiagnosticCategory.Message, "Convert_all_to_default_imports_95035", "Convert all to default imports"),
        Make_all_super_calls_the_first_statement_in_their_constructor: diag(95036, ts3.DiagnosticCategory.Message, "Make_all_super_calls_the_first_statement_in_their_constructor_95036", "Make all 'super()' calls the first statement in their constructor"),
        Add_qualifier_to_all_unresolved_variables_matching_a_member_name: diag(95037, ts3.DiagnosticCategory.Message, "Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037", "Add qualifier to all unresolved variables matching a member name"),
        Change_all_extended_interfaces_to_implements: diag(95038, ts3.DiagnosticCategory.Message, "Change_all_extended_interfaces_to_implements_95038", "Change all extended interfaces to 'implements'"),
        Add_all_missing_super_calls: diag(95039, ts3.DiagnosticCategory.Message, "Add_all_missing_super_calls_95039", "Add all missing super calls"),
        Implement_all_inherited_abstract_classes: diag(95040, ts3.DiagnosticCategory.Message, "Implement_all_inherited_abstract_classes_95040", "Implement all inherited abstract classes"),
        Add_all_missing_async_modifiers: diag(95041, ts3.DiagnosticCategory.Message, "Add_all_missing_async_modifiers_95041", "Add all missing 'async' modifiers"),
        Add_ts_ignore_to_all_error_messages: diag(95042, ts3.DiagnosticCategory.Message, "Add_ts_ignore_to_all_error_messages_95042", "Add '@ts-ignore' to all error messages"),
        Annotate_everything_with_types_from_JSDoc: diag(95043, ts3.DiagnosticCategory.Message, "Annotate_everything_with_types_from_JSDoc_95043", "Annotate everything with types from JSDoc"),
        Add_to_all_uncalled_decorators: diag(95044, ts3.DiagnosticCategory.Message, "Add_to_all_uncalled_decorators_95044", "Add '()' to all uncalled decorators"),
        Convert_all_constructor_functions_to_classes: diag(95045, ts3.DiagnosticCategory.Message, "Convert_all_constructor_functions_to_classes_95045", "Convert all constructor functions to classes"),
        Generate_get_and_set_accessors: diag(95046, ts3.DiagnosticCategory.Message, "Generate_get_and_set_accessors_95046", "Generate 'get' and 'set' accessors"),
        Convert_require_to_import: diag(95047, ts3.DiagnosticCategory.Message, "Convert_require_to_import_95047", "Convert 'require' to 'import'"),
        Convert_all_require_to_import: diag(95048, ts3.DiagnosticCategory.Message, "Convert_all_require_to_import_95048", "Convert all 'require' to 'import'"),
        Move_to_a_new_file: diag(95049, ts3.DiagnosticCategory.Message, "Move_to_a_new_file_95049", "Move to a new file"),
        Remove_unreachable_code: diag(95050, ts3.DiagnosticCategory.Message, "Remove_unreachable_code_95050", "Remove unreachable code"),
        Remove_all_unreachable_code: diag(95051, ts3.DiagnosticCategory.Message, "Remove_all_unreachable_code_95051", "Remove all unreachable code"),
        Add_missing_typeof: diag(95052, ts3.DiagnosticCategory.Message, "Add_missing_typeof_95052", "Add missing 'typeof'"),
        Remove_unused_label: diag(95053, ts3.DiagnosticCategory.Message, "Remove_unused_label_95053", "Remove unused label"),
        Remove_all_unused_labels: diag(95054, ts3.DiagnosticCategory.Message, "Remove_all_unused_labels_95054", "Remove all unused labels"),
        Convert_0_to_mapped_object_type: diag(95055, ts3.DiagnosticCategory.Message, "Convert_0_to_mapped_object_type_95055", "Convert '{0}' to mapped object type"),
        Convert_namespace_import_to_named_imports: diag(95056, ts3.DiagnosticCategory.Message, "Convert_namespace_import_to_named_imports_95056", "Convert namespace import to named imports"),
        Convert_named_imports_to_namespace_import: diag(95057, ts3.DiagnosticCategory.Message, "Convert_named_imports_to_namespace_import_95057", "Convert named imports to namespace import"),
        Add_or_remove_braces_in_an_arrow_function: diag(95058, ts3.DiagnosticCategory.Message, "Add_or_remove_braces_in_an_arrow_function_95058", "Add or remove braces in an arrow function"),
        Add_braces_to_arrow_function: diag(95059, ts3.DiagnosticCategory.Message, "Add_braces_to_arrow_function_95059", "Add braces to arrow function"),
        Remove_braces_from_arrow_function: diag(95060, ts3.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_95060", "Remove braces from arrow function"),
        Convert_default_export_to_named_export: diag(95061, ts3.DiagnosticCategory.Message, "Convert_default_export_to_named_export_95061", "Convert default export to named export"),
        Convert_named_export_to_default_export: diag(95062, ts3.DiagnosticCategory.Message, "Convert_named_export_to_default_export_95062", "Convert named export to default export"),
        Add_missing_enum_member_0: diag(95063, ts3.DiagnosticCategory.Message, "Add_missing_enum_member_0_95063", "Add missing enum member '{0}'"),
        Add_all_missing_imports: diag(95064, ts3.DiagnosticCategory.Message, "Add_all_missing_imports_95064", "Add all missing imports"),
        Convert_to_async_function: diag(95065, ts3.DiagnosticCategory.Message, "Convert_to_async_function_95065", "Convert to async function"),
        Convert_all_to_async_functions: diag(95066, ts3.DiagnosticCategory.Message, "Convert_all_to_async_functions_95066", "Convert all to async functions"),
        Add_missing_call_parentheses: diag(95067, ts3.DiagnosticCategory.Message, "Add_missing_call_parentheses_95067", "Add missing call parentheses"),
        Add_all_missing_call_parentheses: diag(95068, ts3.DiagnosticCategory.Message, "Add_all_missing_call_parentheses_95068", "Add all missing call parentheses"),
        Add_unknown_conversion_for_non_overlapping_types: diag(95069, ts3.DiagnosticCategory.Message, "Add_unknown_conversion_for_non_overlapping_types_95069", "Add 'unknown' conversion for non-overlapping types"),
        Add_unknown_to_all_conversions_of_non_overlapping_types: diag(95070, ts3.DiagnosticCategory.Message, "Add_unknown_to_all_conversions_of_non_overlapping_types_95070", "Add 'unknown' to all conversions of non-overlapping types"),
        Add_missing_new_operator_to_call: diag(95071, ts3.DiagnosticCategory.Message, "Add_missing_new_operator_to_call_95071", "Add missing 'new' operator to call"),
        Add_missing_new_operator_to_all_calls: diag(95072, ts3.DiagnosticCategory.Message, "Add_missing_new_operator_to_all_calls_95072", "Add missing 'new' operator to all calls"),
        Add_names_to_all_parameters_without_names: diag(95073, ts3.DiagnosticCategory.Message, "Add_names_to_all_parameters_without_names_95073", "Add names to all parameters without names"),
        Enable_the_experimentalDecorators_option_in_your_configuration_file: diag(95074, ts3.DiagnosticCategory.Message, "Enable_the_experimentalDecorators_option_in_your_configuration_file_95074", "Enable the 'experimentalDecorators' option in your configuration file"),
        Convert_parameters_to_destructured_object: diag(95075, ts3.DiagnosticCategory.Message, "Convert_parameters_to_destructured_object_95075", "Convert parameters to destructured object"),
        Extract_type: diag(95077, ts3.DiagnosticCategory.Message, "Extract_type_95077", "Extract type"),
        Extract_to_type_alias: diag(95078, ts3.DiagnosticCategory.Message, "Extract_to_type_alias_95078", "Extract to type alias"),
        Extract_to_typedef: diag(95079, ts3.DiagnosticCategory.Message, "Extract_to_typedef_95079", "Extract to typedef"),
        Infer_this_type_of_0_from_usage: diag(95080, ts3.DiagnosticCategory.Message, "Infer_this_type_of_0_from_usage_95080", "Infer 'this' type of '{0}' from usage"),
        Add_const_to_unresolved_variable: diag(95081, ts3.DiagnosticCategory.Message, "Add_const_to_unresolved_variable_95081", "Add 'const' to unresolved variable"),
        Add_const_to_all_unresolved_variables: diag(95082, ts3.DiagnosticCategory.Message, "Add_const_to_all_unresolved_variables_95082", "Add 'const' to all unresolved variables"),
        Add_await: diag(95083, ts3.DiagnosticCategory.Message, "Add_await_95083", "Add 'await'"),
        Add_await_to_initializer_for_0: diag(95084, ts3.DiagnosticCategory.Message, "Add_await_to_initializer_for_0_95084", "Add 'await' to initializer for '{0}'"),
        Fix_all_expressions_possibly_missing_await: diag(95085, ts3.DiagnosticCategory.Message, "Fix_all_expressions_possibly_missing_await_95085", "Fix all expressions possibly missing 'await'"),
        Remove_unnecessary_await: diag(95086, ts3.DiagnosticCategory.Message, "Remove_unnecessary_await_95086", "Remove unnecessary 'await'"),
        Remove_all_unnecessary_uses_of_await: diag(95087, ts3.DiagnosticCategory.Message, "Remove_all_unnecessary_uses_of_await_95087", "Remove all unnecessary uses of 'await'"),
        Enable_the_jsx_flag_in_your_configuration_file: diag(95088, ts3.DiagnosticCategory.Message, "Enable_the_jsx_flag_in_your_configuration_file_95088", "Enable the '--jsx' flag in your configuration file"),
        Add_await_to_initializers: diag(95089, ts3.DiagnosticCategory.Message, "Add_await_to_initializers_95089", "Add 'await' to initializers"),
        Extract_to_interface: diag(95090, ts3.DiagnosticCategory.Message, "Extract_to_interface_95090", "Extract to interface"),
        Convert_to_a_bigint_numeric_literal: diag(95091, ts3.DiagnosticCategory.Message, "Convert_to_a_bigint_numeric_literal_95091", "Convert to a bigint numeric literal"),
        Convert_all_to_bigint_numeric_literals: diag(95092, ts3.DiagnosticCategory.Message, "Convert_all_to_bigint_numeric_literals_95092", "Convert all to bigint numeric literals"),
        Convert_const_to_let: diag(95093, ts3.DiagnosticCategory.Message, "Convert_const_to_let_95093", "Convert 'const' to 'let'"),
        Prefix_with_declare: diag(95094, ts3.DiagnosticCategory.Message, "Prefix_with_declare_95094", "Prefix with 'declare'"),
        Prefix_all_incorrect_property_declarations_with_declare: diag(95095, ts3.DiagnosticCategory.Message, "Prefix_all_incorrect_property_declarations_with_declare_95095", "Prefix all incorrect property declarations with 'declare'"),
        Convert_to_template_string: diag(95096, ts3.DiagnosticCategory.Message, "Convert_to_template_string_95096", "Convert to template string"),
        Add_export_to_make_this_file_into_a_module: diag(95097, ts3.DiagnosticCategory.Message, "Add_export_to_make_this_file_into_a_module_95097", "Add 'export {}' to make this file into a module"),
        Set_the_target_option_in_your_configuration_file_to_0: diag(95098, ts3.DiagnosticCategory.Message, "Set_the_target_option_in_your_configuration_file_to_0_95098", "Set the 'target' option in your configuration file to '{0}'"),
        Set_the_module_option_in_your_configuration_file_to_0: diag(95099, ts3.DiagnosticCategory.Message, "Set_the_module_option_in_your_configuration_file_to_0_95099", "Set the 'module' option in your configuration file to '{0}'"),
        Convert_invalid_character_to_its_html_entity_code: diag(95100, ts3.DiagnosticCategory.Message, "Convert_invalid_character_to_its_html_entity_code_95100", "Convert invalid character to its html entity code"),
        Convert_all_invalid_characters_to_HTML_entity_code: diag(95101, ts3.DiagnosticCategory.Message, "Convert_all_invalid_characters_to_HTML_entity_code_95101", "Convert all invalid characters to HTML entity code"),
        Convert_function_expression_0_to_arrow_function: diag(95105, ts3.DiagnosticCategory.Message, "Convert_function_expression_0_to_arrow_function_95105", "Convert function expression '{0}' to arrow function"),
        Convert_function_declaration_0_to_arrow_function: diag(95106, ts3.DiagnosticCategory.Message, "Convert_function_declaration_0_to_arrow_function_95106", "Convert function declaration '{0}' to arrow function"),
        Fix_all_implicit_this_errors: diag(95107, ts3.DiagnosticCategory.Message, "Fix_all_implicit_this_errors_95107", "Fix all implicit-'this' errors"),
        Wrap_invalid_character_in_an_expression_container: diag(95108, ts3.DiagnosticCategory.Message, "Wrap_invalid_character_in_an_expression_container_95108", "Wrap invalid character in an expression container"),
        Wrap_all_invalid_characters_in_an_expression_container: diag(95109, ts3.DiagnosticCategory.Message, "Wrap_all_invalid_characters_in_an_expression_container_95109", "Wrap all invalid characters in an expression container"),
        Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file: diag(95110, ts3.DiagnosticCategory.Message, "Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file_95110", "Visit https://aka.ms/tsconfig to read more about this file"),
        Add_a_return_statement: diag(95111, ts3.DiagnosticCategory.Message, "Add_a_return_statement_95111", "Add a return statement"),
        Remove_braces_from_arrow_function_body: diag(95112, ts3.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_body_95112", "Remove braces from arrow function body"),
        Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal: diag(95113, ts3.DiagnosticCategory.Message, "Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113", "Wrap the following body with parentheses which should be an object literal"),
        Add_all_missing_return_statement: diag(95114, ts3.DiagnosticCategory.Message, "Add_all_missing_return_statement_95114", "Add all missing return statement"),
        Remove_braces_from_all_arrow_function_bodies_with_relevant_issues: diag(95115, ts3.DiagnosticCategory.Message, "Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115", "Remove braces from all arrow function bodies with relevant issues"),
        Wrap_all_object_literal_with_parentheses: diag(95116, ts3.DiagnosticCategory.Message, "Wrap_all_object_literal_with_parentheses_95116", "Wrap all object literal with parentheses"),
        Move_labeled_tuple_element_modifiers_to_labels: diag(95117, ts3.DiagnosticCategory.Message, "Move_labeled_tuple_element_modifiers_to_labels_95117", "Move labeled tuple element modifiers to labels"),
        Convert_overload_list_to_single_signature: diag(95118, ts3.DiagnosticCategory.Message, "Convert_overload_list_to_single_signature_95118", "Convert overload list to single signature"),
        Generate_get_and_set_accessors_for_all_overriding_properties: diag(95119, ts3.DiagnosticCategory.Message, "Generate_get_and_set_accessors_for_all_overriding_properties_95119", "Generate 'get' and 'set' accessors for all overriding properties"),
        Wrap_in_JSX_fragment: diag(95120, ts3.DiagnosticCategory.Message, "Wrap_in_JSX_fragment_95120", "Wrap in JSX fragment"),
        Wrap_all_unparented_JSX_in_JSX_fragment: diag(95121, ts3.DiagnosticCategory.Message, "Wrap_all_unparented_JSX_in_JSX_fragment_95121", "Wrap all unparented JSX in JSX fragment"),
        Convert_arrow_function_or_function_expression: diag(95122, ts3.DiagnosticCategory.Message, "Convert_arrow_function_or_function_expression_95122", "Convert arrow function or function expression"),
        Convert_to_anonymous_function: diag(95123, ts3.DiagnosticCategory.Message, "Convert_to_anonymous_function_95123", "Convert to anonymous function"),
        Convert_to_named_function: diag(95124, ts3.DiagnosticCategory.Message, "Convert_to_named_function_95124", "Convert to named function"),
        Convert_to_arrow_function: diag(95125, ts3.DiagnosticCategory.Message, "Convert_to_arrow_function_95125", "Convert to arrow function"),
        Remove_parentheses: diag(95126, ts3.DiagnosticCategory.Message, "Remove_parentheses_95126", "Remove parentheses"),
        Could_not_find_a_containing_arrow_function: diag(95127, ts3.DiagnosticCategory.Message, "Could_not_find_a_containing_arrow_function_95127", "Could not find a containing arrow function"),
        Containing_function_is_not_an_arrow_function: diag(95128, ts3.DiagnosticCategory.Message, "Containing_function_is_not_an_arrow_function_95128", "Containing function is not an arrow function"),
        Could_not_find_export_statement: diag(95129, ts3.DiagnosticCategory.Message, "Could_not_find_export_statement_95129", "Could not find export statement"),
        This_file_already_has_a_default_export: diag(95130, ts3.DiagnosticCategory.Message, "This_file_already_has_a_default_export_95130", "This file already has a default export"),
        Could_not_find_import_clause: diag(95131, ts3.DiagnosticCategory.Message, "Could_not_find_import_clause_95131", "Could not find import clause"),
        Could_not_find_namespace_import_or_named_imports: diag(95132, ts3.DiagnosticCategory.Message, "Could_not_find_namespace_import_or_named_imports_95132", "Could not find namespace import or named imports"),
        Selection_is_not_a_valid_type_node: diag(95133, ts3.DiagnosticCategory.Message, "Selection_is_not_a_valid_type_node_95133", "Selection is not a valid type node"),
        No_type_could_be_extracted_from_this_type_node: diag(95134, ts3.DiagnosticCategory.Message, "No_type_could_be_extracted_from_this_type_node_95134", "No type could be extracted from this type node"),
        Could_not_find_property_for_which_to_generate_accessor: diag(95135, ts3.DiagnosticCategory.Message, "Could_not_find_property_for_which_to_generate_accessor_95135", "Could not find property for which to generate accessor"),
        Name_is_not_valid: diag(95136, ts3.DiagnosticCategory.Message, "Name_is_not_valid_95136", "Name is not valid"),
        Can_only_convert_property_with_modifier: diag(95137, ts3.DiagnosticCategory.Message, "Can_only_convert_property_with_modifier_95137", "Can only convert property with modifier"),
        Switch_each_misused_0_to_1: diag(95138, ts3.DiagnosticCategory.Message, "Switch_each_misused_0_to_1_95138", "Switch each misused '{0}' to '{1}'"),
        Convert_to_optional_chain_expression: diag(95139, ts3.DiagnosticCategory.Message, "Convert_to_optional_chain_expression_95139", "Convert to optional chain expression"),
        Could_not_find_convertible_access_expression: diag(95140, ts3.DiagnosticCategory.Message, "Could_not_find_convertible_access_expression_95140", "Could not find convertible access expression"),
        Could_not_find_matching_access_expressions: diag(95141, ts3.DiagnosticCategory.Message, "Could_not_find_matching_access_expressions_95141", "Could not find matching access expressions"),
        Can_only_convert_logical_AND_access_chains: diag(95142, ts3.DiagnosticCategory.Message, "Can_only_convert_logical_AND_access_chains_95142", "Can only convert logical AND access chains"),
        Add_void_to_Promise_resolved_without_a_value: diag(95143, ts3.DiagnosticCategory.Message, "Add_void_to_Promise_resolved_without_a_value_95143", "Add 'void' to Promise resolved without a value"),
        Add_void_to_all_Promises_resolved_without_a_value: diag(95144, ts3.DiagnosticCategory.Message, "Add_void_to_all_Promises_resolved_without_a_value_95144", "Add 'void' to all Promises resolved without a value"),
        Use_element_access_for_0: diag(95145, ts3.DiagnosticCategory.Message, "Use_element_access_for_0_95145", "Use element access for '{0}'"),
        Use_element_access_for_all_undeclared_properties: diag(95146, ts3.DiagnosticCategory.Message, "Use_element_access_for_all_undeclared_properties_95146", "Use element access for all undeclared properties."),
        Delete_all_unused_imports: diag(95147, ts3.DiagnosticCategory.Message, "Delete_all_unused_imports_95147", "Delete all unused imports"),
        Infer_function_return_type: diag(95148, ts3.DiagnosticCategory.Message, "Infer_function_return_type_95148", "Infer function return type"),
        Return_type_must_be_inferred_from_a_function: diag(95149, ts3.DiagnosticCategory.Message, "Return_type_must_be_inferred_from_a_function_95149", "Return type must be inferred from a function"),
        Could_not_determine_function_return_type: diag(95150, ts3.DiagnosticCategory.Message, "Could_not_determine_function_return_type_95150", "Could not determine function return type"),
        Could_not_convert_to_arrow_function: diag(95151, ts3.DiagnosticCategory.Message, "Could_not_convert_to_arrow_function_95151", "Could not convert to arrow function"),
        Could_not_convert_to_named_function: diag(95152, ts3.DiagnosticCategory.Message, "Could_not_convert_to_named_function_95152", "Could not convert to named function"),
        Could_not_convert_to_anonymous_function: diag(95153, ts3.DiagnosticCategory.Message, "Could_not_convert_to_anonymous_function_95153", "Could not convert to anonymous function"),
        Can_only_convert_string_concatenation: diag(95154, ts3.DiagnosticCategory.Message, "Can_only_convert_string_concatenation_95154", "Can only convert string concatenation"),
        Selection_is_not_a_valid_statement_or_statements: diag(95155, ts3.DiagnosticCategory.Message, "Selection_is_not_a_valid_statement_or_statements_95155", "Selection is not a valid statement or statements"),
        Add_missing_function_declaration_0: diag(95156, ts3.DiagnosticCategory.Message, "Add_missing_function_declaration_0_95156", "Add missing function declaration '{0}'"),
        Add_all_missing_function_declarations: diag(95157, ts3.DiagnosticCategory.Message, "Add_all_missing_function_declarations_95157", "Add all missing function declarations"),
        Method_not_implemented: diag(95158, ts3.DiagnosticCategory.Message, "Method_not_implemented_95158", "Method not implemented."),
        Function_not_implemented: diag(95159, ts3.DiagnosticCategory.Message, "Function_not_implemented_95159", "Function not implemented."),
        Add_override_modifier: diag(95160, ts3.DiagnosticCategory.Message, "Add_override_modifier_95160", "Add 'override' modifier"),
        Remove_override_modifier: diag(95161, ts3.DiagnosticCategory.Message, "Remove_override_modifier_95161", "Remove 'override' modifier"),
        Add_all_missing_override_modifiers: diag(95162, ts3.DiagnosticCategory.Message, "Add_all_missing_override_modifiers_95162", "Add all missing 'override' modifiers"),
        Remove_all_unnecessary_override_modifiers: diag(95163, ts3.DiagnosticCategory.Message, "Remove_all_unnecessary_override_modifiers_95163", "Remove all unnecessary 'override' modifiers"),
        Can_only_convert_named_export: diag(95164, ts3.DiagnosticCategory.Message, "Can_only_convert_named_export_95164", "Can only convert named export"),
        Add_missing_properties: diag(95165, ts3.DiagnosticCategory.Message, "Add_missing_properties_95165", "Add missing properties"),
        Add_all_missing_properties: diag(95166, ts3.DiagnosticCategory.Message, "Add_all_missing_properties_95166", "Add all missing properties"),
        Add_missing_attributes: diag(95167, ts3.DiagnosticCategory.Message, "Add_missing_attributes_95167", "Add missing attributes"),
        Add_all_missing_attributes: diag(95168, ts3.DiagnosticCategory.Message, "Add_all_missing_attributes_95168", "Add all missing attributes"),
        Add_undefined_to_optional_property_type: diag(95169, ts3.DiagnosticCategory.Message, "Add_undefined_to_optional_property_type_95169", "Add 'undefined' to optional property type"),
        Convert_named_imports_to_default_import: diag(95170, ts3.DiagnosticCategory.Message, "Convert_named_imports_to_default_import_95170", "Convert named imports to default import"),
        Delete_unused_param_tag_0: diag(95171, ts3.DiagnosticCategory.Message, "Delete_unused_param_tag_0_95171", "Delete unused '@param' tag '{0}'"),
        Delete_all_unused_param_tags: diag(95172, ts3.DiagnosticCategory.Message, "Delete_all_unused_param_tags_95172", "Delete all unused '@param' tags"),
        Rename_param_tag_name_0_to_1: diag(95173, ts3.DiagnosticCategory.Message, "Rename_param_tag_name_0_to_1_95173", "Rename '@param' tag name '{0}' to '{1}'"),
        No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer: diag(18004, ts3.DiagnosticCategory.Error, "No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004", "No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),
        Classes_may_not_have_a_field_named_constructor: diag(18006, ts3.DiagnosticCategory.Error, "Classes_may_not_have_a_field_named_constructor_18006", "Classes may not have a field named 'constructor'."),
        JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array: diag(18007, ts3.DiagnosticCategory.Error, "JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007", "JSX expressions may not use the comma operator. Did you mean to write an array?"),
        Private_identifiers_cannot_be_used_as_parameters: diag(18009, ts3.DiagnosticCategory.Error, "Private_identifiers_cannot_be_used_as_parameters_18009", "Private identifiers cannot be used as parameters."),
        An_accessibility_modifier_cannot_be_used_with_a_private_identifier: diag(18010, ts3.DiagnosticCategory.Error, "An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010", "An accessibility modifier cannot be used with a private identifier."),
        The_operand_of_a_delete_operator_cannot_be_a_private_identifier: diag(18011, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011", "The operand of a 'delete' operator cannot be a private identifier."),
        constructor_is_a_reserved_word: diag(18012, ts3.DiagnosticCategory.Error, "constructor_is_a_reserved_word_18012", "'#constructor' is a reserved word."),
        Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier: diag(18013, ts3.DiagnosticCategory.Error, "Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013", "Property '{0}' is not accessible outside class '{1}' because it has a private identifier."),
        The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling: diag(18014, ts3.DiagnosticCategory.Error, "The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014", "The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."),
        Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2: diag(18015, ts3.DiagnosticCategory.Error, "Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015", "Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."),
        Private_identifiers_are_not_allowed_outside_class_bodies: diag(18016, ts3.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_outside_class_bodies_18016", "Private identifiers are not allowed outside class bodies."),
        The_shadowing_declaration_of_0_is_defined_here: diag(18017, ts3.DiagnosticCategory.Error, "The_shadowing_declaration_of_0_is_defined_here_18017", "The shadowing declaration of '{0}' is defined here"),
        The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here: diag(18018, ts3.DiagnosticCategory.Error, "The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018", "The declaration of '{0}' that you probably intended to use is defined here"),
        _0_modifier_cannot_be_used_with_a_private_identifier: diag(18019, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_private_identifier_18019", "'{0}' modifier cannot be used with a private identifier."),
        An_enum_member_cannot_be_named_with_a_private_identifier: diag(18024, ts3.DiagnosticCategory.Error, "An_enum_member_cannot_be_named_with_a_private_identifier_18024", "An enum member cannot be named with a private identifier."),
        can_only_be_used_at_the_start_of_a_file: diag(18026, ts3.DiagnosticCategory.Error, "can_only_be_used_at_the_start_of_a_file_18026", "'#!' can only be used at the start of a file."),
        Compiler_reserves_name_0_when_emitting_private_identifier_downlevel: diag(18027, ts3.DiagnosticCategory.Error, "Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027", "Compiler reserves name '{0}' when emitting private identifier downlevel."),
        Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher: diag(18028, ts3.DiagnosticCategory.Error, "Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028", "Private identifiers are only available when targeting ECMAScript 2015 and higher."),
        Private_identifiers_are_not_allowed_in_variable_declarations: diag(18029, ts3.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_in_variable_declarations_18029", "Private identifiers are not allowed in variable declarations."),
        An_optional_chain_cannot_contain_private_identifiers: diag(18030, ts3.DiagnosticCategory.Error, "An_optional_chain_cannot_contain_private_identifiers_18030", "An optional chain cannot contain private identifiers."),
        The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents: diag(18031, ts3.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031", "The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."),
        The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some: diag(18032, ts3.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032", "The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."),
        Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead: diag(18033, ts3.DiagnosticCategory.Error, "Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhau_18033", "Only numeric enums can have computed members, but this expression has type '{0}'. If you do not need exhaustiveness checks, consider using an object literal instead."),
        Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment: diag(18034, ts3.DiagnosticCategory.Message, "Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034", "Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."),
        Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(18035, ts3.DiagnosticCategory.Error, "Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035", "Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."),
        Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator: diag(18036, ts3.DiagnosticCategory.Error, "Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036", "Class decorators can't be used with static private identifier. Consider removing the experimental decorator."),
        Await_expression_cannot_be_used_inside_a_class_static_block: diag(18037, ts3.DiagnosticCategory.Error, "Await_expression_cannot_be_used_inside_a_class_static_block_18037", "Await expression cannot be used inside a class static block."),
        For_await_loops_cannot_be_used_inside_a_class_static_block: diag(18038, ts3.DiagnosticCategory.Error, "For_await_loops_cannot_be_used_inside_a_class_static_block_18038", "'For await' loops cannot be used inside a class static block."),
        Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block: diag(18039, ts3.DiagnosticCategory.Error, "Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block_18039", "Invalid use of '{0}'. It cannot be used inside a class static block."),
        A_return_statement_cannot_be_used_inside_a_class_static_block: diag(18041, ts3.DiagnosticCategory.Error, "A_return_statement_cannot_be_used_inside_a_class_static_block_18041", "A 'return' statement cannot be used inside a class static block.")
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var _a;
      function tokenIsIdentifierOrKeyword(token) {
        return token >= 79;
      }
      ts3.tokenIsIdentifierOrKeyword = tokenIsIdentifierOrKeyword;
      function tokenIsIdentifierOrKeywordOrGreaterThan(token) {
        return token === 31 || tokenIsIdentifierOrKeyword(token);
      }
      ts3.tokenIsIdentifierOrKeywordOrGreaterThan = tokenIsIdentifierOrKeywordOrGreaterThan;
      ts3.textToKeywordObj = (_a = {
        abstract: 126,
        any: 130,
        as: 127,
        asserts: 128,
        assert: 129,
        bigint: 158,
        boolean: 133,
        break: 81,
        case: 82,
        catch: 83,
        class: 84,
        continue: 86,
        const: 85
      }, _a["constructor"] = 134, _a.debugger = 87, _a.declare = 135, _a.default = 88, _a.delete = 89, _a.do = 90, _a.else = 91, _a.enum = 92, _a.export = 93, _a.extends = 94, _a.false = 95, _a.finally = 96, _a.for = 97, _a.from = 156, _a.function = 98, _a.get = 136, _a.if = 99, _a.implements = 117, _a.import = 100, _a.in = 101, _a.infer = 137, _a.instanceof = 102, _a.interface = 118, _a.intrinsic = 138, _a.is = 139, _a.keyof = 140, _a.let = 119, _a.module = 141, _a.namespace = 142, _a.never = 143, _a.new = 103, _a.null = 104, _a.number = 147, _a.object = 148, _a.package = 120, _a.private = 121, _a.protected = 122, _a.public = 123, _a.override = 159, _a.out = 144, _a.readonly = 145, _a.require = 146, _a.global = 157, _a.return = 105, _a.set = 149, _a.static = 124, _a.string = 150, _a.super = 106, _a.switch = 107, _a.symbol = 151, _a.this = 108, _a.throw = 109, _a.true = 110, _a.try = 111, _a.type = 152, _a.typeof = 112, _a.undefined = 153, _a.unique = 154, _a.unknown = 155, _a.var = 113, _a.void = 114, _a.while = 115, _a.with = 116, _a.yield = 125, _a.async = 131, _a.await = 132, _a.of = 160, _a);
      var textToKeyword = new ts3.Map(ts3.getEntries(ts3.textToKeywordObj));
      var textToToken = new ts3.Map(ts3.getEntries(__assign(__assign({}, ts3.textToKeywordObj), { "{": 18, "}": 19, "(": 20, ")": 21, "[": 22, "]": 23, ".": 24, "...": 25, ";": 26, ",": 27, "<": 29, ">": 31, "<=": 32, ">=": 33, "==": 34, "!=": 35, "===": 36, "!==": 37, "=>": 38, "+": 39, "-": 40, "**": 42, "*": 41, "/": 43, "%": 44, "++": 45, "--": 46, "<<": 47, "</": 30, ">>": 48, ">>>": 49, "&": 50, "|": 51, "^": 52, "!": 53, "~": 54, "&&": 55, "||": 56, "?": 57, "??": 60, "?.": 28, ":": 58, "=": 63, "+=": 64, "-=": 65, "*=": 66, "**=": 67, "/=": 68, "%=": 69, "<<=": 70, ">>=": 71, ">>>=": 72, "&=": 73, "|=": 74, "^=": 78, "||=": 75, "&&=": 76, "??=": 77, "@": 59, "#": 62, "`": 61 })));
      var unicodeES3IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1610, 1649, 1747, 1749, 1749, 1765, 1766, 1786, 1788, 1808, 1808, 1810, 1836, 1920, 1957, 2309, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2784, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3294, 3294, 3296, 3297, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3424, 3425, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3805, 3840, 3840, 3904, 3911, 3913, 3946, 3976, 3979, 4096, 4129, 4131, 4135, 4137, 4138, 4176, 4181, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6067, 6176, 6263, 6272, 6312, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8319, 8319, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12346, 12353, 12436, 12445, 12446, 12449, 12538, 12540, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65138, 65140, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES3IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 768, 846, 864, 866, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1155, 1158, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1441, 1443, 1465, 1467, 1469, 1471, 1471, 1473, 1474, 1476, 1476, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1621, 1632, 1641, 1648, 1747, 1749, 1756, 1759, 1768, 1770, 1773, 1776, 1788, 1808, 1836, 1840, 1866, 1920, 1968, 2305, 2307, 2309, 2361, 2364, 2381, 2384, 2388, 2392, 2403, 2406, 2415, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2492, 2494, 2500, 2503, 2504, 2507, 2509, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2562, 2562, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2649, 2652, 2654, 2654, 2662, 2676, 2689, 2691, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2784, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2876, 2883, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2913, 2918, 2927, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3031, 3031, 3047, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3134, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3168, 3169, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3262, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3297, 3302, 3311, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3390, 3395, 3398, 3400, 3402, 3405, 3415, 3415, 3424, 3425, 3430, 3439, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3805, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3946, 3953, 3972, 3974, 3979, 3984, 3991, 3993, 4028, 4038, 4038, 4096, 4129, 4131, 4135, 4137, 4138, 4140, 4146, 4150, 4153, 4160, 4169, 4176, 4185, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 4969, 4977, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6099, 6112, 6121, 6160, 6169, 6176, 6263, 6272, 6313, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8319, 8319, 8400, 8412, 8417, 8417, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12346, 12353, 12436, 12441, 12442, 12445, 12446, 12449, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65056, 65059, 65075, 65076, 65101, 65103, 65136, 65138, 65140, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65381, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES5IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2208, 2208, 2210, 2220, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2423, 2425, 2431, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3133, 3160, 3161, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3424, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6263, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6428, 6480, 6509, 6512, 6516, 6528, 6571, 6593, 6599, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7401, 7404, 7406, 7409, 7413, 7414, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11823, 11823, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42647, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43648, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES5IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1520, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2048, 2093, 2112, 2139, 2208, 2208, 2210, 2220, 2276, 2302, 2304, 2403, 2406, 2415, 2417, 2423, 2425, 2431, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3161, 3168, 3171, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3396, 3398, 3400, 3402, 3406, 3415, 3415, 3424, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6263, 6272, 6314, 6320, 6389, 6400, 6428, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6617, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7376, 7378, 7380, 7414, 7424, 7654, 7676, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8204, 8205, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 11823, 11823, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12442, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42647, 42655, 42737, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43047, 43072, 43123, 43136, 43204, 43216, 43225, 43232, 43255, 43259, 43259, 43264, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43643, 43648, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65062, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeESNextIdentifierStart = [65, 90, 97, 122, 170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 895, 895, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1488, 1514, 1519, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2144, 2154, 2208, 2228, 2230, 2237, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2432, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2556, 2556, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2809, 2809, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3133, 3160, 3162, 3168, 3169, 3200, 3200, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3412, 3414, 3423, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6264, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6430, 6480, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7401, 7404, 7406, 7411, 7413, 7414, 7418, 7418, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12443, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42653, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43261, 43262, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43488, 43492, 43494, 43503, 43514, 43518, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43646, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66176, 66204, 66208, 66256, 66304, 66335, 66349, 66378, 66384, 66421, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68096, 68112, 68115, 68117, 68119, 68121, 68149, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68324, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68899, 69376, 69404, 69415, 69415, 69424, 69445, 69600, 69622, 69635, 69687, 69763, 69807, 69840, 69864, 69891, 69926, 69956, 69956, 69968, 70002, 70006, 70006, 70019, 70066, 70081, 70084, 70106, 70106, 70108, 70108, 70144, 70161, 70163, 70187, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70366, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70461, 70461, 70480, 70480, 70493, 70497, 70656, 70708, 70727, 70730, 70751, 70751, 70784, 70831, 70852, 70853, 70855, 70855, 71040, 71086, 71128, 71131, 71168, 71215, 71236, 71236, 71296, 71338, 71352, 71352, 71424, 71450, 71680, 71723, 71840, 71903, 71935, 71935, 72096, 72103, 72106, 72144, 72161, 72161, 72163, 72163, 72192, 72192, 72203, 72242, 72250, 72250, 72272, 72272, 72284, 72329, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72750, 72768, 72768, 72818, 72847, 72960, 72966, 72968, 72969, 72971, 73008, 73030, 73030, 73056, 73061, 73063, 73064, 73066, 73097, 73112, 73112, 73440, 73458, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92880, 92909, 92928, 92975, 92992, 92995, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94032, 94032, 94099, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 123136, 123180, 123191, 123197, 123214, 123214, 123584, 123627, 124928, 125124, 125184, 125251, 125259, 125259, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101];
      var unicodeESNextIdentifierPart = [48, 57, 65, 90, 95, 95, 97, 122, 170, 170, 181, 181, 183, 183, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 895, 895, 902, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1519, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2045, 2045, 2048, 2093, 2112, 2139, 2144, 2154, 2208, 2228, 2230, 2237, 2259, 2273, 2275, 2403, 2406, 2415, 2417, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2556, 2556, 2558, 2558, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2809, 2815, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3072, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3162, 3168, 3171, 3174, 3183, 3200, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3328, 3331, 3333, 3340, 3342, 3344, 3346, 3396, 3398, 3400, 3402, 3406, 3412, 3415, 3423, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3558, 3567, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4969, 4977, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6264, 6272, 6314, 6320, 6389, 6400, 6430, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6618, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6832, 6845, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7376, 7378, 7380, 7418, 7424, 7673, 7675, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42737, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43047, 43072, 43123, 43136, 43205, 43216, 43225, 43232, 43255, 43259, 43259, 43261, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43488, 43518, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65071, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66045, 66045, 66176, 66204, 66208, 66256, 66272, 66272, 66304, 66335, 66349, 66378, 66384, 66426, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66720, 66729, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68099, 68101, 68102, 68108, 68115, 68117, 68119, 68121, 68149, 68152, 68154, 68159, 68159, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68326, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68903, 68912, 68921, 69376, 69404, 69415, 69415, 69424, 69456, 69600, 69622, 69632, 69702, 69734, 69743, 69759, 69818, 69840, 69864, 69872, 69881, 69888, 69940, 69942, 69951, 69956, 69958, 69968, 70003, 70006, 70006, 70016, 70084, 70089, 70092, 70096, 70106, 70108, 70108, 70144, 70161, 70163, 70199, 70206, 70206, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70378, 70384, 70393, 70400, 70403, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70459, 70468, 70471, 70472, 70475, 70477, 70480, 70480, 70487, 70487, 70493, 70499, 70502, 70508, 70512, 70516, 70656, 70730, 70736, 70745, 70750, 70751, 70784, 70853, 70855, 70855, 70864, 70873, 71040, 71093, 71096, 71104, 71128, 71133, 71168, 71232, 71236, 71236, 71248, 71257, 71296, 71352, 71360, 71369, 71424, 71450, 71453, 71467, 71472, 71481, 71680, 71738, 71840, 71913, 71935, 71935, 72096, 72103, 72106, 72151, 72154, 72161, 72163, 72164, 72192, 72254, 72263, 72263, 72272, 72345, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72758, 72760, 72768, 72784, 72793, 72818, 72847, 72850, 72871, 72873, 72886, 72960, 72966, 72968, 72969, 72971, 73014, 73018, 73018, 73020, 73021, 73023, 73031, 73040, 73049, 73056, 73061, 73063, 73064, 73066, 73102, 73104, 73105, 73107, 73112, 73120, 73129, 73440, 73462, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92768, 92777, 92880, 92909, 92912, 92916, 92928, 92982, 92992, 92995, 93008, 93017, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94031, 94087, 94095, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 113821, 113822, 119141, 119145, 119149, 119154, 119163, 119170, 119173, 119179, 119210, 119213, 119362, 119364, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 120782, 120831, 121344, 121398, 121403, 121452, 121461, 121461, 121476, 121476, 121499, 121503, 121505, 121519, 122880, 122886, 122888, 122904, 122907, 122913, 122915, 122916, 122918, 122922, 123136, 123180, 123184, 123197, 123200, 123209, 123214, 123214, 123584, 123641, 124928, 125124, 125136, 125142, 125184, 125259, 125264, 125273, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101, 917760, 917999];
      var commentDirectiveRegExSingleLine = /^\/\/\/?\s*@(ts-expect-error|ts-ignore)/;
      var commentDirectiveRegExMultiLine = /^(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/;
      function lookupInUnicodeMap(code, map2) {
        if (code < map2[0]) {
          return false;
        }
        var lo = 0;
        var hi = map2.length;
        var mid;
        while (lo + 1 < hi) {
          mid = lo + (hi - lo) / 2;
          mid -= mid % 2;
          if (map2[mid] <= code && code <= map2[mid + 1]) {
            return true;
          }
          if (code < map2[mid]) {
            hi = mid;
          } else {
            lo = mid + 2;
          }
        }
        return false;
      }
      function isUnicodeIdentifierStart(code, languageVersion) {
        return languageVersion >= 2 ? lookupInUnicodeMap(code, unicodeESNextIdentifierStart) : languageVersion === 1 ? lookupInUnicodeMap(code, unicodeES5IdentifierStart) : lookupInUnicodeMap(code, unicodeES3IdentifierStart);
      }
      ts3.isUnicodeIdentifierStart = isUnicodeIdentifierStart;
      function isUnicodeIdentifierPart(code, languageVersion) {
        return languageVersion >= 2 ? lookupInUnicodeMap(code, unicodeESNextIdentifierPart) : languageVersion === 1 ? lookupInUnicodeMap(code, unicodeES5IdentifierPart) : lookupInUnicodeMap(code, unicodeES3IdentifierPart);
      }
      function makeReverseMap(source) {
        var result2 = [];
        source.forEach(function(value, name) {
          result2[value] = name;
        });
        return result2;
      }
      var tokenStrings = makeReverseMap(textToToken);
      function tokenToString(t) {
        return tokenStrings[t];
      }
      ts3.tokenToString = tokenToString;
      function stringToToken(s) {
        return textToToken.get(s);
      }
      ts3.stringToToken = stringToToken;
      function computeLineStarts(text) {
        var result2 = new Array();
        var pos = 0;
        var lineStart = 0;
        while (pos < text.length) {
          var ch = text.charCodeAt(pos);
          pos++;
          switch (ch) {
            case 13:
              if (text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
              result2.push(lineStart);
              lineStart = pos;
              break;
            default:
              if (ch > 127 && isLineBreak(ch)) {
                result2.push(lineStart);
                lineStart = pos;
              }
              break;
          }
        }
        result2.push(lineStart);
        return result2;
      }
      ts3.computeLineStarts = computeLineStarts;
      function getPositionOfLineAndCharacter(sourceFile, line, character, allowEdits) {
        return sourceFile.getPositionOfLineAndCharacter ? sourceFile.getPositionOfLineAndCharacter(line, character, allowEdits) : computePositionOfLineAndCharacter(getLineStarts(sourceFile), line, character, sourceFile.text, allowEdits);
      }
      ts3.getPositionOfLineAndCharacter = getPositionOfLineAndCharacter;
      function computePositionOfLineAndCharacter(lineStarts, line, character, debugText, allowEdits) {
        if (line < 0 || line >= lineStarts.length) {
          if (allowEdits) {
            line = line < 0 ? 0 : line >= lineStarts.length ? lineStarts.length - 1 : line;
          } else {
            ts3.Debug.fail("Bad line number. Line: ".concat(line, ", lineStarts.length: ").concat(lineStarts.length, " , line map is correct? ").concat(debugText !== void 0 ? ts3.arraysEqual(lineStarts, computeLineStarts(debugText)) : "unknown"));
          }
        }
        var res = lineStarts[line] + character;
        if (allowEdits) {
          return res > lineStarts[line + 1] ? lineStarts[line + 1] : typeof debugText === "string" && res > debugText.length ? debugText.length : res;
        }
        if (line < lineStarts.length - 1) {
          ts3.Debug.assert(res < lineStarts[line + 1]);
        } else if (debugText !== void 0) {
          ts3.Debug.assert(res <= debugText.length);
        }
        return res;
      }
      ts3.computePositionOfLineAndCharacter = computePositionOfLineAndCharacter;
      function getLineStarts(sourceFile) {
        return sourceFile.lineMap || (sourceFile.lineMap = computeLineStarts(sourceFile.text));
      }
      ts3.getLineStarts = getLineStarts;
      function computeLineAndCharacterOfPosition(lineStarts, position) {
        var lineNumber = computeLineOfPosition(lineStarts, position);
        return {
          line: lineNumber,
          character: position - lineStarts[lineNumber]
        };
      }
      ts3.computeLineAndCharacterOfPosition = computeLineAndCharacterOfPosition;
      function computeLineOfPosition(lineStarts, position, lowerBound) {
        var lineNumber = ts3.binarySearch(lineStarts, position, ts3.identity, ts3.compareValues, lowerBound);
        if (lineNumber < 0) {
          lineNumber = ~lineNumber - 1;
          ts3.Debug.assert(lineNumber !== -1, "position cannot precede the beginning of the file");
        }
        return lineNumber;
      }
      ts3.computeLineOfPosition = computeLineOfPosition;
      function getLinesBetweenPositions(sourceFile, pos1, pos2) {
        if (pos1 === pos2)
          return 0;
        var lineStarts = getLineStarts(sourceFile);
        var lower = Math.min(pos1, pos2);
        var isNegative = lower === pos2;
        var upper = isNegative ? pos1 : pos2;
        var lowerLine = computeLineOfPosition(lineStarts, lower);
        var upperLine = computeLineOfPosition(lineStarts, upper, lowerLine);
        return isNegative ? lowerLine - upperLine : upperLine - lowerLine;
      }
      ts3.getLinesBetweenPositions = getLinesBetweenPositions;
      function getLineAndCharacterOfPosition(sourceFile, position) {
        return computeLineAndCharacterOfPosition(getLineStarts(sourceFile), position);
      }
      ts3.getLineAndCharacterOfPosition = getLineAndCharacterOfPosition;
      function isWhiteSpaceLike(ch) {
        return isWhiteSpaceSingleLine(ch) || isLineBreak(ch);
      }
      ts3.isWhiteSpaceLike = isWhiteSpaceLike;
      function isWhiteSpaceSingleLine(ch) {
        return ch === 32 || ch === 9 || ch === 11 || ch === 12 || ch === 160 || ch === 133 || ch === 5760 || ch >= 8192 && ch <= 8203 || ch === 8239 || ch === 8287 || ch === 12288 || ch === 65279;
      }
      ts3.isWhiteSpaceSingleLine = isWhiteSpaceSingleLine;
      function isLineBreak(ch) {
        return ch === 10 || ch === 13 || ch === 8232 || ch === 8233;
      }
      ts3.isLineBreak = isLineBreak;
      function isDigit(ch) {
        return ch >= 48 && ch <= 57;
      }
      function isHexDigit(ch) {
        return isDigit(ch) || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
      }
      function isCodePoint(code) {
        return code <= 1114111;
      }
      function isOctalDigit(ch) {
        return ch >= 48 && ch <= 55;
      }
      ts3.isOctalDigit = isOctalDigit;
      function couldStartTrivia(text, pos) {
        var ch = text.charCodeAt(pos);
        switch (ch) {
          case 13:
          case 10:
          case 9:
          case 11:
          case 12:
          case 32:
          case 47:
          case 60:
          case 124:
          case 61:
          case 62:
            return true;
          case 35:
            return pos === 0;
          default:
            return ch > 127;
        }
      }
      ts3.couldStartTrivia = couldStartTrivia;
      function skipTrivia(text, pos, stopAfterLineBreak, stopAtComments, inJSDoc) {
        if (ts3.positionIsSynthesized(pos)) {
          return pos;
        }
        var canConsumeStar = false;
        while (true) {
          var ch = text.charCodeAt(pos);
          switch (ch) {
            case 13:
              if (text.charCodeAt(pos + 1) === 10) {
                pos++;
              }
            case 10:
              pos++;
              if (stopAfterLineBreak) {
                return pos;
              }
              canConsumeStar = !!inJSDoc;
              continue;
            case 9:
            case 11:
            case 12:
            case 32:
              pos++;
              continue;
            case 47:
              if (stopAtComments) {
                break;
              }
              if (text.charCodeAt(pos + 1) === 47) {
                pos += 2;
                while (pos < text.length) {
                  if (isLineBreak(text.charCodeAt(pos))) {
                    break;
                  }
                  pos++;
                }
                canConsumeStar = false;
                continue;
              }
              if (text.charCodeAt(pos + 1) === 42) {
                pos += 2;
                while (pos < text.length) {
                  if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) === 47) {
                    pos += 2;
                    break;
                  }
                  pos++;
                }
                canConsumeStar = false;
                continue;
              }
              break;
            case 60:
            case 124:
            case 61:
            case 62:
              if (isConflictMarkerTrivia(text, pos)) {
                pos = scanConflictMarkerTrivia(text, pos);
                canConsumeStar = false;
                continue;
              }
              break;
            case 35:
              if (pos === 0 && isShebangTrivia(text, pos)) {
                pos = scanShebangTrivia(text, pos);
                canConsumeStar = false;
                continue;
              }
              break;
            case 42:
              if (canConsumeStar) {
                pos++;
                canConsumeStar = false;
                continue;
              }
              break;
            default:
              if (ch > 127 && isWhiteSpaceLike(ch)) {
                pos++;
                continue;
              }
              break;
          }
          return pos;
        }
      }
      ts3.skipTrivia = skipTrivia;
      var mergeConflictMarkerLength = "<<<<<<<".length;
      function isConflictMarkerTrivia(text, pos) {
        ts3.Debug.assert(pos >= 0);
        if (pos === 0 || isLineBreak(text.charCodeAt(pos - 1))) {
          var ch = text.charCodeAt(pos);
          if (pos + mergeConflictMarkerLength < text.length) {
            for (var i = 0; i < mergeConflictMarkerLength; i++) {
              if (text.charCodeAt(pos + i) !== ch) {
                return false;
              }
            }
            return ch === 61 || text.charCodeAt(pos + mergeConflictMarkerLength) === 32;
          }
        }
        return false;
      }
      function scanConflictMarkerTrivia(text, pos, error) {
        if (error) {
          error(ts3.Diagnostics.Merge_conflict_marker_encountered, pos, mergeConflictMarkerLength);
        }
        var ch = text.charCodeAt(pos);
        var len = text.length;
        if (ch === 60 || ch === 62) {
          while (pos < len && !isLineBreak(text.charCodeAt(pos))) {
            pos++;
          }
        } else {
          ts3.Debug.assert(ch === 124 || ch === 61);
          while (pos < len) {
            var currentChar = text.charCodeAt(pos);
            if ((currentChar === 61 || currentChar === 62) && currentChar !== ch && isConflictMarkerTrivia(text, pos)) {
              break;
            }
            pos++;
          }
        }
        return pos;
      }
      var shebangTriviaRegex = /^#!.*/;
      function isShebangTrivia(text, pos) {
        ts3.Debug.assert(pos === 0);
        return shebangTriviaRegex.test(text);
      }
      ts3.isShebangTrivia = isShebangTrivia;
      function scanShebangTrivia(text, pos) {
        var shebang = shebangTriviaRegex.exec(text)[0];
        pos = pos + shebang.length;
        return pos;
      }
      ts3.scanShebangTrivia = scanShebangTrivia;
      function iterateCommentRanges(reduce, text, pos, trailing, cb, state, initial) {
        var pendingPos;
        var pendingEnd;
        var pendingKind;
        var pendingHasTrailingNewLine;
        var hasPendingCommentRange = false;
        var collecting = trailing;
        var accumulator = initial;
        if (pos === 0) {
          collecting = true;
          var shebang = getShebang(text);
          if (shebang) {
            pos = shebang.length;
          }
        }
        scan:
          while (pos >= 0 && pos < text.length) {
            var ch = text.charCodeAt(pos);
            switch (ch) {
              case 13:
                if (text.charCodeAt(pos + 1) === 10) {
                  pos++;
                }
              case 10:
                pos++;
                if (trailing) {
                  break scan;
                }
                collecting = true;
                if (hasPendingCommentRange) {
                  pendingHasTrailingNewLine = true;
                }
                continue;
              case 9:
              case 11:
              case 12:
              case 32:
                pos++;
                continue;
              case 47:
                var nextChar = text.charCodeAt(pos + 1);
                var hasTrailingNewLine = false;
                if (nextChar === 47 || nextChar === 42) {
                  var kind = nextChar === 47 ? 2 : 3;
                  var startPos = pos;
                  pos += 2;
                  if (nextChar === 47) {
                    while (pos < text.length) {
                      if (isLineBreak(text.charCodeAt(pos))) {
                        hasTrailingNewLine = true;
                        break;
                      }
                      pos++;
                    }
                  } else {
                    while (pos < text.length) {
                      if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) === 47) {
                        pos += 2;
                        break;
                      }
                      pos++;
                    }
                  }
                  if (collecting) {
                    if (hasPendingCommentRange) {
                      accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
                      if (!reduce && accumulator) {
                        return accumulator;
                      }
                    }
                    pendingPos = startPos;
                    pendingEnd = pos;
                    pendingKind = kind;
                    pendingHasTrailingNewLine = hasTrailingNewLine;
                    hasPendingCommentRange = true;
                  }
                  continue;
                }
                break scan;
              default:
                if (ch > 127 && isWhiteSpaceLike(ch)) {
                  if (hasPendingCommentRange && isLineBreak(ch)) {
                    pendingHasTrailingNewLine = true;
                  }
                  pos++;
                  continue;
                }
                break scan;
            }
          }
        if (hasPendingCommentRange) {
          accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
        }
        return accumulator;
      }
      function forEachLeadingCommentRange(text, pos, cb, state) {
        return iterateCommentRanges(false, text, pos, false, cb, state);
      }
      ts3.forEachLeadingCommentRange = forEachLeadingCommentRange;
      function forEachTrailingCommentRange(text, pos, cb, state) {
        return iterateCommentRanges(false, text, pos, true, cb, state);
      }
      ts3.forEachTrailingCommentRange = forEachTrailingCommentRange;
      function reduceEachLeadingCommentRange(text, pos, cb, state, initial) {
        return iterateCommentRanges(true, text, pos, false, cb, state, initial);
      }
      ts3.reduceEachLeadingCommentRange = reduceEachLeadingCommentRange;
      function reduceEachTrailingCommentRange(text, pos, cb, state, initial) {
        return iterateCommentRanges(true, text, pos, true, cb, state, initial);
      }
      ts3.reduceEachTrailingCommentRange = reduceEachTrailingCommentRange;
      function appendCommentRange(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
          comments = [];
        }
        comments.push({ kind, pos, end, hasTrailingNewLine });
        return comments;
      }
      function getLeadingCommentRanges(text, pos) {
        return reduceEachLeadingCommentRange(text, pos, appendCommentRange, void 0, void 0);
      }
      ts3.getLeadingCommentRanges = getLeadingCommentRanges;
      function getTrailingCommentRanges(text, pos) {
        return reduceEachTrailingCommentRange(text, pos, appendCommentRange, void 0, void 0);
      }
      ts3.getTrailingCommentRanges = getTrailingCommentRanges;
      function getShebang(text) {
        var match = shebangTriviaRegex.exec(text);
        if (match) {
          return match[0];
        }
      }
      ts3.getShebang = getShebang;
      function isIdentifierStart(ch, languageVersion) {
        return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch === 36 || ch === 95 || ch > 127 && isUnicodeIdentifierStart(ch, languageVersion);
      }
      ts3.isIdentifierStart = isIdentifierStart;
      function isIdentifierPart(ch, languageVersion, identifierVariant) {
        return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch >= 48 && ch <= 57 || ch === 36 || ch === 95 || (identifierVariant === 1 ? ch === 45 || ch === 58 : false) || ch > 127 && isUnicodeIdentifierPart(ch, languageVersion);
      }
      ts3.isIdentifierPart = isIdentifierPart;
      function isIdentifierText(name, languageVersion, identifierVariant) {
        var ch = codePointAt2(name, 0);
        if (!isIdentifierStart(ch, languageVersion)) {
          return false;
        }
        for (var i = charSize(ch); i < name.length; i += charSize(ch)) {
          if (!isIdentifierPart(ch = codePointAt2(name, i), languageVersion, identifierVariant)) {
            return false;
          }
        }
        return true;
      }
      ts3.isIdentifierText = isIdentifierText;
      function createScanner(languageVersion, skipTrivia2, languageVariant, textInitial, onError, start, length) {
        if (languageVariant === void 0) {
          languageVariant = 0;
        }
        var text = textInitial;
        var pos;
        var end;
        var startPos;
        var tokenPos;
        var token;
        var tokenValue;
        var tokenFlags;
        var commentDirectives;
        var inJSDocType = 0;
        setText(text, start, length);
        var scanner = {
          getStartPos: function() {
            return startPos;
          },
          getTextPos: function() {
            return pos;
          },
          getToken: function() {
            return token;
          },
          getTokenPos: function() {
            return tokenPos;
          },
          getTokenText: function() {
            return text.substring(tokenPos, pos);
          },
          getTokenValue: function() {
            return tokenValue;
          },
          hasUnicodeEscape: function() {
            return (tokenFlags & 1024) !== 0;
          },
          hasExtendedUnicodeEscape: function() {
            return (tokenFlags & 8) !== 0;
          },
          hasPrecedingLineBreak: function() {
            return (tokenFlags & 1) !== 0;
          },
          hasPrecedingJSDocComment: function() {
            return (tokenFlags & 2) !== 0;
          },
          isIdentifier: function() {
            return token === 79 || token > 116;
          },
          isReservedWord: function() {
            return token >= 81 && token <= 116;
          },
          isUnterminated: function() {
            return (tokenFlags & 4) !== 0;
          },
          getCommentDirectives: function() {
            return commentDirectives;
          },
          getNumericLiteralFlags: function() {
            return tokenFlags & 1008;
          },
          getTokenFlags: function() {
            return tokenFlags;
          },
          reScanGreaterToken,
          reScanAsteriskEqualsToken,
          reScanSlashToken,
          reScanTemplateToken,
          reScanTemplateHeadOrNoSubstitutionTemplate,
          scanJsxIdentifier,
          scanJsxAttributeValue,
          reScanJsxAttributeValue,
          reScanJsxToken,
          reScanLessThanToken,
          reScanHashToken,
          reScanQuestionToken,
          reScanInvalidIdentifier,
          scanJsxToken,
          scanJsDocToken,
          scan,
          getText,
          clearCommentDirectives,
          setText,
          setScriptTarget,
          setLanguageVariant,
          setOnError,
          setTextPos,
          setInJSDocType,
          tryScan,
          lookAhead,
          scanRange
        };
        if (ts3.Debug.isDebugging) {
          Object.defineProperty(scanner, "__debugShowCurrentPositionInText", {
            get: function() {
              var text2 = scanner.getText();
              return text2.slice(0, scanner.getStartPos()) + "\u2551" + text2.slice(scanner.getStartPos());
            }
          });
        }
        return scanner;
        function error(message, errPos, length2) {
          if (errPos === void 0) {
            errPos = pos;
          }
          if (onError) {
            var oldPos = pos;
            pos = errPos;
            onError(message, length2 || 0);
            pos = oldPos;
          }
        }
        function scanNumberFragment() {
          var start2 = pos;
          var allowSeparator = false;
          var isPreviousTokenSeparator = false;
          var result2 = "";
          while (true) {
            var ch = text.charCodeAt(pos);
            if (ch === 95) {
              tokenFlags |= 512;
              if (allowSeparator) {
                allowSeparator = false;
                isPreviousTokenSeparator = true;
                result2 += text.substring(start2, pos);
              } else if (isPreviousTokenSeparator) {
                error(ts3.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              start2 = pos;
              continue;
            }
            if (isDigit(ch)) {
              allowSeparator = true;
              isPreviousTokenSeparator = false;
              pos++;
              continue;
            }
            break;
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return result2 + text.substring(start2, pos);
        }
        function scanNumber() {
          var start2 = pos;
          var mainFragment = scanNumberFragment();
          var decimalFragment;
          var scientificFragment;
          if (text.charCodeAt(pos) === 46) {
            pos++;
            decimalFragment = scanNumberFragment();
          }
          var end2 = pos;
          if (text.charCodeAt(pos) === 69 || text.charCodeAt(pos) === 101) {
            pos++;
            tokenFlags |= 16;
            if (text.charCodeAt(pos) === 43 || text.charCodeAt(pos) === 45)
              pos++;
            var preNumericPart = pos;
            var finalFragment = scanNumberFragment();
            if (!finalFragment) {
              error(ts3.Diagnostics.Digit_expected);
            } else {
              scientificFragment = text.substring(end2, preNumericPart) + finalFragment;
              end2 = pos;
            }
          }
          var result2;
          if (tokenFlags & 512) {
            result2 = mainFragment;
            if (decimalFragment) {
              result2 += "." + decimalFragment;
            }
            if (scientificFragment) {
              result2 += scientificFragment;
            }
          } else {
            result2 = text.substring(start2, end2);
          }
          if (decimalFragment !== void 0 || tokenFlags & 16) {
            checkForIdentifierStartAfterNumericLiteral(start2, decimalFragment === void 0 && !!(tokenFlags & 16));
            return {
              type: 8,
              value: "" + +result2
            };
          } else {
            tokenValue = result2;
            var type2 = checkBigIntSuffix();
            checkForIdentifierStartAfterNumericLiteral(start2);
            return { type: type2, value: tokenValue };
          }
        }
        function checkForIdentifierStartAfterNumericLiteral(numericStart, isScientific) {
          if (!isIdentifierStart(codePointAt2(text, pos), languageVersion)) {
            return;
          }
          var identifierStart = pos;
          var length2 = scanIdentifierParts().length;
          if (length2 === 1 && text[identifierStart] === "n") {
            if (isScientific) {
              error(ts3.Diagnostics.A_bigint_literal_cannot_use_exponential_notation, numericStart, identifierStart - numericStart + 1);
            } else {
              error(ts3.Diagnostics.A_bigint_literal_must_be_an_integer, numericStart, identifierStart - numericStart + 1);
            }
          } else {
            error(ts3.Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal, identifierStart, length2);
            pos = identifierStart;
          }
        }
        function scanOctalDigits() {
          var start2 = pos;
          while (isOctalDigit(text.charCodeAt(pos))) {
            pos++;
          }
          return +text.substring(start2, pos);
        }
        function scanExactNumberOfHexDigits(count, canHaveSeparators) {
          var valueString = scanHexDigits(count, false, canHaveSeparators);
          return valueString ? parseInt(valueString, 16) : -1;
        }
        function scanMinimumNumberOfHexDigits(count, canHaveSeparators) {
          return scanHexDigits(count, true, canHaveSeparators);
        }
        function scanHexDigits(minCount, scanAsManyAsPossible, canHaveSeparators) {
          var valueChars = [];
          var allowSeparator = false;
          var isPreviousTokenSeparator = false;
          while (valueChars.length < minCount || scanAsManyAsPossible) {
            var ch = text.charCodeAt(pos);
            if (canHaveSeparators && ch === 95) {
              tokenFlags |= 512;
              if (allowSeparator) {
                allowSeparator = false;
                isPreviousTokenSeparator = true;
              } else if (isPreviousTokenSeparator) {
                error(ts3.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              continue;
            }
            allowSeparator = canHaveSeparators;
            if (ch >= 65 && ch <= 70) {
              ch += 97 - 65;
            } else if (!(ch >= 48 && ch <= 57 || ch >= 97 && ch <= 102)) {
              break;
            }
            valueChars.push(ch);
            pos++;
            isPreviousTokenSeparator = false;
          }
          if (valueChars.length < minCount) {
            valueChars = [];
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return String.fromCharCode.apply(String, valueChars);
        }
        function scanString(jsxAttributeString) {
          if (jsxAttributeString === void 0) {
            jsxAttributeString = false;
          }
          var quote = text.charCodeAt(pos);
          pos++;
          var result2 = "";
          var start2 = pos;
          while (true) {
            if (pos >= end) {
              result2 += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts3.Diagnostics.Unterminated_string_literal);
              break;
            }
            var ch = text.charCodeAt(pos);
            if (ch === quote) {
              result2 += text.substring(start2, pos);
              pos++;
              break;
            }
            if (ch === 92 && !jsxAttributeString) {
              result2 += text.substring(start2, pos);
              result2 += scanEscapeSequence();
              start2 = pos;
              continue;
            }
            if (isLineBreak(ch) && !jsxAttributeString) {
              result2 += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts3.Diagnostics.Unterminated_string_literal);
              break;
            }
            pos++;
          }
          return result2;
        }
        function scanTemplateAndSetTokenValue(isTaggedTemplate) {
          var startedWithBacktick = text.charCodeAt(pos) === 96;
          pos++;
          var start2 = pos;
          var contents = "";
          var resultingToken;
          while (true) {
            if (pos >= end) {
              contents += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts3.Diagnostics.Unterminated_template_literal);
              resultingToken = startedWithBacktick ? 14 : 17;
              break;
            }
            var currChar = text.charCodeAt(pos);
            if (currChar === 96) {
              contents += text.substring(start2, pos);
              pos++;
              resultingToken = startedWithBacktick ? 14 : 17;
              break;
            }
            if (currChar === 36 && pos + 1 < end && text.charCodeAt(pos + 1) === 123) {
              contents += text.substring(start2, pos);
              pos += 2;
              resultingToken = startedWithBacktick ? 15 : 16;
              break;
            }
            if (currChar === 92) {
              contents += text.substring(start2, pos);
              contents += scanEscapeSequence(isTaggedTemplate);
              start2 = pos;
              continue;
            }
            if (currChar === 13) {
              contents += text.substring(start2, pos);
              pos++;
              if (pos < end && text.charCodeAt(pos) === 10) {
                pos++;
              }
              contents += "\n";
              start2 = pos;
              continue;
            }
            pos++;
          }
          ts3.Debug.assert(resultingToken !== void 0);
          tokenValue = contents;
          return resultingToken;
        }
        function scanEscapeSequence(isTaggedTemplate) {
          var start2 = pos;
          pos++;
          if (pos >= end) {
            error(ts3.Diagnostics.Unexpected_end_of_text);
            return "";
          }
          var ch = text.charCodeAt(pos);
          pos++;
          switch (ch) {
            case 48:
              if (isTaggedTemplate && pos < end && isDigit(text.charCodeAt(pos))) {
                pos++;
                tokenFlags |= 2048;
                return text.substring(start2, pos);
              }
              return "\0";
            case 98:
              return "\b";
            case 116:
              return "	";
            case 110:
              return "\n";
            case 118:
              return "\v";
            case 102:
              return "\f";
            case 114:
              return "\r";
            case 39:
              return "'";
            case 34:
              return '"';
            case 117:
              if (isTaggedTemplate) {
                for (var escapePos = pos; escapePos < pos + 4; escapePos++) {
                  if (escapePos < end && !isHexDigit(text.charCodeAt(escapePos)) && text.charCodeAt(escapePos) !== 123) {
                    pos = escapePos;
                    tokenFlags |= 2048;
                    return text.substring(start2, pos);
                  }
                }
              }
              if (pos < end && text.charCodeAt(pos) === 123) {
                pos++;
                if (isTaggedTemplate && !isHexDigit(text.charCodeAt(pos))) {
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                }
                if (isTaggedTemplate) {
                  var savePos = pos;
                  var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
                  var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
                  if (!isCodePoint(escapedValue) || text.charCodeAt(pos) !== 125) {
                    tokenFlags |= 2048;
                    return text.substring(start2, pos);
                  } else {
                    pos = savePos;
                  }
                }
                tokenFlags |= 8;
                return scanExtendedUnicodeEscape();
              }
              tokenFlags |= 1024;
              return scanHexadecimalEscape(4);
            case 120:
              if (isTaggedTemplate) {
                if (!isHexDigit(text.charCodeAt(pos))) {
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                } else if (!isHexDigit(text.charCodeAt(pos + 1))) {
                  pos++;
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                }
              }
              return scanHexadecimalEscape(2);
            case 13:
              if (pos < end && text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
            case 8232:
            case 8233:
              return "";
            default:
              return String.fromCharCode(ch);
          }
        }
        function scanHexadecimalEscape(numDigits) {
          var escapedValue = scanExactNumberOfHexDigits(numDigits, false);
          if (escapedValue >= 0) {
            return String.fromCharCode(escapedValue);
          } else {
            error(ts3.Diagnostics.Hexadecimal_digit_expected);
            return "";
          }
        }
        function scanExtendedUnicodeEscape() {
          var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
          var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
          var isInvalidExtendedEscape = false;
          if (escapedValue < 0) {
            error(ts3.Diagnostics.Hexadecimal_digit_expected);
            isInvalidExtendedEscape = true;
          } else if (escapedValue > 1114111) {
            error(ts3.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive);
            isInvalidExtendedEscape = true;
          }
          if (pos >= end) {
            error(ts3.Diagnostics.Unexpected_end_of_text);
            isInvalidExtendedEscape = true;
          } else if (text.charCodeAt(pos) === 125) {
            pos++;
          } else {
            error(ts3.Diagnostics.Unterminated_Unicode_escape_sequence);
            isInvalidExtendedEscape = true;
          }
          if (isInvalidExtendedEscape) {
            return "";
          }
          return utf16EncodeAsString(escapedValue);
        }
        function peekUnicodeEscape() {
          if (pos + 5 < end && text.charCodeAt(pos + 1) === 117) {
            var start_1 = pos;
            pos += 2;
            var value = scanExactNumberOfHexDigits(4, false);
            pos = start_1;
            return value;
          }
          return -1;
        }
        function peekExtendedUnicodeEscape() {
          if (languageVersion >= 2 && codePointAt2(text, pos + 1) === 117 && codePointAt2(text, pos + 2) === 123) {
            var start_2 = pos;
            pos += 3;
            var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
            var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
            pos = start_2;
            return escapedValue;
          }
          return -1;
        }
        function scanIdentifierParts() {
          var result2 = "";
          var start2 = pos;
          while (pos < end) {
            var ch = codePointAt2(text, pos);
            if (isIdentifierPart(ch, languageVersion)) {
              pos += charSize(ch);
            } else if (ch === 92) {
              ch = peekExtendedUnicodeEscape();
              if (ch >= 0 && isIdentifierPart(ch, languageVersion)) {
                pos += 3;
                tokenFlags |= 8;
                result2 += scanExtendedUnicodeEscape();
                start2 = pos;
                continue;
              }
              ch = peekUnicodeEscape();
              if (!(ch >= 0 && isIdentifierPart(ch, languageVersion))) {
                break;
              }
              tokenFlags |= 1024;
              result2 += text.substring(start2, pos);
              result2 += utf16EncodeAsString(ch);
              pos += 6;
              start2 = pos;
            } else {
              break;
            }
          }
          result2 += text.substring(start2, pos);
          return result2;
        }
        function getIdentifierToken() {
          var len = tokenValue.length;
          if (len >= 2 && len <= 12) {
            var ch = tokenValue.charCodeAt(0);
            if (ch >= 97 && ch <= 122) {
              var keyword = textToKeyword.get(tokenValue);
              if (keyword !== void 0) {
                return token = keyword;
              }
            }
          }
          return token = 79;
        }
        function scanBinaryOrOctalDigits(base) {
          var value = "";
          var separatorAllowed = false;
          var isPreviousTokenSeparator = false;
          while (true) {
            var ch = text.charCodeAt(pos);
            if (ch === 95) {
              tokenFlags |= 512;
              if (separatorAllowed) {
                separatorAllowed = false;
                isPreviousTokenSeparator = true;
              } else if (isPreviousTokenSeparator) {
                error(ts3.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              continue;
            }
            separatorAllowed = true;
            if (!isDigit(ch) || ch - 48 >= base) {
              break;
            }
            value += text[pos];
            pos++;
            isPreviousTokenSeparator = false;
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return value;
        }
        function checkBigIntSuffix() {
          if (text.charCodeAt(pos) === 110) {
            tokenValue += "n";
            if (tokenFlags & 384) {
              tokenValue = ts3.parsePseudoBigInt(tokenValue) + "n";
            }
            pos++;
            return 9;
          } else {
            var numericValue = tokenFlags & 128 ? parseInt(tokenValue.slice(2), 2) : tokenFlags & 256 ? parseInt(tokenValue.slice(2), 8) : +tokenValue;
            tokenValue = "" + numericValue;
            return 8;
          }
        }
        function scan() {
          var _a2;
          startPos = pos;
          tokenFlags = 0;
          var asteriskSeen = false;
          while (true) {
            tokenPos = pos;
            if (pos >= end) {
              return token = 1;
            }
            var ch = codePointAt2(text, pos);
            if (ch === 35 && pos === 0 && isShebangTrivia(text, pos)) {
              pos = scanShebangTrivia(text, pos);
              if (skipTrivia2) {
                continue;
              } else {
                return token = 6;
              }
            }
            switch (ch) {
              case 10:
              case 13:
                tokenFlags |= 1;
                if (skipTrivia2) {
                  pos++;
                  continue;
                } else {
                  if (ch === 13 && pos + 1 < end && text.charCodeAt(pos + 1) === 10) {
                    pos += 2;
                  } else {
                    pos++;
                  }
                  return token = 4;
                }
              case 9:
              case 11:
              case 12:
              case 32:
              case 160:
              case 5760:
              case 8192:
              case 8193:
              case 8194:
              case 8195:
              case 8196:
              case 8197:
              case 8198:
              case 8199:
              case 8200:
              case 8201:
              case 8202:
              case 8203:
              case 8239:
              case 8287:
              case 12288:
              case 65279:
                if (skipTrivia2) {
                  pos++;
                  continue;
                } else {
                  while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                    pos++;
                  }
                  return token = 5;
                }
              case 33:
                if (text.charCodeAt(pos + 1) === 61) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 37;
                  }
                  return pos += 2, token = 35;
                }
                pos++;
                return token = 53;
              case 34:
              case 39:
                tokenValue = scanString();
                return token = 10;
              case 96:
                return token = scanTemplateAndSetTokenValue(false);
              case 37:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 69;
                }
                pos++;
                return token = 44;
              case 38:
                if (text.charCodeAt(pos + 1) === 38) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 76;
                  }
                  return pos += 2, token = 55;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 73;
                }
                pos++;
                return token = 50;
              case 40:
                pos++;
                return token = 20;
              case 41:
                pos++;
                return token = 21;
              case 42:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 66;
                }
                if (text.charCodeAt(pos + 1) === 42) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 67;
                  }
                  return pos += 2, token = 42;
                }
                pos++;
                if (inJSDocType && !asteriskSeen && tokenFlags & 1) {
                  asteriskSeen = true;
                  continue;
                }
                return token = 41;
              case 43:
                if (text.charCodeAt(pos + 1) === 43) {
                  return pos += 2, token = 45;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 64;
                }
                pos++;
                return token = 39;
              case 44:
                pos++;
                return token = 27;
              case 45:
                if (text.charCodeAt(pos + 1) === 45) {
                  return pos += 2, token = 46;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 65;
                }
                pos++;
                return token = 40;
              case 46:
                if (isDigit(text.charCodeAt(pos + 1))) {
                  tokenValue = scanNumber().value;
                  return token = 8;
                }
                if (text.charCodeAt(pos + 1) === 46 && text.charCodeAt(pos + 2) === 46) {
                  return pos += 3, token = 25;
                }
                pos++;
                return token = 24;
              case 47:
                if (text.charCodeAt(pos + 1) === 47) {
                  pos += 2;
                  while (pos < end) {
                    if (isLineBreak(text.charCodeAt(pos))) {
                      break;
                    }
                    pos++;
                  }
                  commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(tokenPos, pos), commentDirectiveRegExSingleLine, tokenPos);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 2;
                  }
                }
                if (text.charCodeAt(pos + 1) === 42) {
                  pos += 2;
                  if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) !== 47) {
                    tokenFlags |= 2;
                  }
                  var commentClosed = false;
                  var lastLineStart = tokenPos;
                  while (pos < end) {
                    var ch_1 = text.charCodeAt(pos);
                    if (ch_1 === 42 && text.charCodeAt(pos + 1) === 47) {
                      pos += 2;
                      commentClosed = true;
                      break;
                    }
                    pos++;
                    if (isLineBreak(ch_1)) {
                      lastLineStart = pos;
                      tokenFlags |= 1;
                    }
                  }
                  commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(lastLineStart, pos), commentDirectiveRegExMultiLine, lastLineStart);
                  if (!commentClosed) {
                    error(ts3.Diagnostics.Asterisk_Slash_expected);
                  }
                  if (skipTrivia2) {
                    continue;
                  } else {
                    if (!commentClosed) {
                      tokenFlags |= 4;
                    }
                    return token = 3;
                  }
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 68;
                }
                pos++;
                return token = 43;
              case 48:
                if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 || text.charCodeAt(pos + 1) === 120)) {
                  pos += 2;
                  tokenValue = scanMinimumNumberOfHexDigits(1, true);
                  if (!tokenValue) {
                    error(ts3.Diagnostics.Hexadecimal_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0x" + tokenValue;
                  tokenFlags |= 64;
                  return token = checkBigIntSuffix();
                } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 || text.charCodeAt(pos + 1) === 98)) {
                  pos += 2;
                  tokenValue = scanBinaryOrOctalDigits(2);
                  if (!tokenValue) {
                    error(ts3.Diagnostics.Binary_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0b" + tokenValue;
                  tokenFlags |= 128;
                  return token = checkBigIntSuffix();
                } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 || text.charCodeAt(pos + 1) === 111)) {
                  pos += 2;
                  tokenValue = scanBinaryOrOctalDigits(8);
                  if (!tokenValue) {
                    error(ts3.Diagnostics.Octal_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0o" + tokenValue;
                  tokenFlags |= 256;
                  return token = checkBigIntSuffix();
                }
                if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                  tokenValue = "" + scanOctalDigits();
                  tokenFlags |= 32;
                  return token = 8;
                }
              case 49:
              case 50:
              case 51:
              case 52:
              case 53:
              case 54:
              case 55:
              case 56:
              case 57:
                _a2 = scanNumber(), token = _a2.type, tokenValue = _a2.value;
                return token;
              case 58:
                pos++;
                return token = 58;
              case 59:
                pos++;
                return token = 26;
              case 60:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 60) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 70;
                  }
                  return pos += 2, token = 47;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 32;
                }
                if (languageVariant === 1 && text.charCodeAt(pos + 1) === 47 && text.charCodeAt(pos + 2) !== 42) {
                  return pos += 2, token = 30;
                }
                pos++;
                return token = 29;
              case 61:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 36;
                  }
                  return pos += 2, token = 34;
                }
                if (text.charCodeAt(pos + 1) === 62) {
                  return pos += 2, token = 38;
                }
                pos++;
                return token = 63;
              case 62:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                pos++;
                return token = 31;
              case 63:
                if (text.charCodeAt(pos + 1) === 46 && !isDigit(text.charCodeAt(pos + 2))) {
                  return pos += 2, token = 28;
                }
                if (text.charCodeAt(pos + 1) === 63) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 77;
                  }
                  return pos += 2, token = 60;
                }
                pos++;
                return token = 57;
              case 91:
                pos++;
                return token = 22;
              case 93:
                pos++;
                return token = 23;
              case 94:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 78;
                }
                pos++;
                return token = 52;
              case 123:
                pos++;
                return token = 18;
              case 124:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 124) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 75;
                  }
                  return pos += 2, token = 56;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 74;
                }
                pos++;
                return token = 51;
              case 125:
                pos++;
                return token = 19;
              case 126:
                pos++;
                return token = 54;
              case 64:
                pos++;
                return token = 59;
              case 92:
                var extendedCookedChar = peekExtendedUnicodeEscape();
                if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
                  pos += 3;
                  tokenFlags |= 8;
                  tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
                  return token = getIdentifierToken();
                }
                var cookedChar = peekUnicodeEscape();
                if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                  pos += 6;
                  tokenFlags |= 1024;
                  tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                  return token = getIdentifierToken();
                }
                error(ts3.Diagnostics.Invalid_character);
                pos++;
                return token = 0;
              case 35:
                if (pos !== 0 && text[pos + 1] === "!") {
                  error(ts3.Diagnostics.can_only_be_used_at_the_start_of_a_file);
                  pos++;
                  return token = 0;
                }
                if (isIdentifierStart(codePointAt2(text, pos + 1), languageVersion)) {
                  pos++;
                  scanIdentifier(codePointAt2(text, pos), languageVersion);
                } else {
                  tokenValue = String.fromCharCode(codePointAt2(text, pos));
                  error(ts3.Diagnostics.Invalid_character, pos++, charSize(ch));
                }
                return token = 80;
              default:
                var identifierKind = scanIdentifier(ch, languageVersion);
                if (identifierKind) {
                  return token = identifierKind;
                } else if (isWhiteSpaceSingleLine(ch)) {
                  pos += charSize(ch);
                  continue;
                } else if (isLineBreak(ch)) {
                  tokenFlags |= 1;
                  pos += charSize(ch);
                  continue;
                }
                var size = charSize(ch);
                error(ts3.Diagnostics.Invalid_character, pos, size);
                pos += size;
                return token = 0;
            }
          }
        }
        function reScanInvalidIdentifier() {
          ts3.Debug.assert(token === 0, "'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'.");
          pos = tokenPos = startPos;
          tokenFlags = 0;
          var ch = codePointAt2(text, pos);
          var identifierKind = scanIdentifier(ch, 99);
          if (identifierKind) {
            return token = identifierKind;
          }
          pos += charSize(ch);
          return token;
        }
        function scanIdentifier(startCharacter, languageVersion2) {
          var ch = startCharacter;
          if (isIdentifierStart(ch, languageVersion2)) {
            pos += charSize(ch);
            while (pos < end && isIdentifierPart(ch = codePointAt2(text, pos), languageVersion2))
              pos += charSize(ch);
            tokenValue = text.substring(tokenPos, pos);
            if (ch === 92) {
              tokenValue += scanIdentifierParts();
            }
            return getIdentifierToken();
          }
        }
        function reScanGreaterToken() {
          if (token === 31) {
            if (text.charCodeAt(pos) === 62) {
              if (text.charCodeAt(pos + 1) === 62) {
                if (text.charCodeAt(pos + 2) === 61) {
                  return pos += 3, token = 72;
                }
                return pos += 2, token = 49;
              }
              if (text.charCodeAt(pos + 1) === 61) {
                return pos += 2, token = 71;
              }
              pos++;
              return token = 48;
            }
            if (text.charCodeAt(pos) === 61) {
              pos++;
              return token = 33;
            }
          }
          return token;
        }
        function reScanAsteriskEqualsToken() {
          ts3.Debug.assert(token === 66, "'reScanAsteriskEqualsToken' should only be called on a '*='");
          pos = tokenPos + 1;
          return token = 63;
        }
        function reScanSlashToken() {
          if (token === 43 || token === 68) {
            var p = tokenPos + 1;
            var inEscape = false;
            var inCharacterClass = false;
            while (true) {
              if (p >= end) {
                tokenFlags |= 4;
                error(ts3.Diagnostics.Unterminated_regular_expression_literal);
                break;
              }
              var ch = text.charCodeAt(p);
              if (isLineBreak(ch)) {
                tokenFlags |= 4;
                error(ts3.Diagnostics.Unterminated_regular_expression_literal);
                break;
              }
              if (inEscape) {
                inEscape = false;
              } else if (ch === 47 && !inCharacterClass) {
                p++;
                break;
              } else if (ch === 91) {
                inCharacterClass = true;
              } else if (ch === 92) {
                inEscape = true;
              } else if (ch === 93) {
                inCharacterClass = false;
              }
              p++;
            }
            while (p < end && isIdentifierPart(text.charCodeAt(p), languageVersion)) {
              p++;
            }
            pos = p;
            tokenValue = text.substring(tokenPos, pos);
            token = 13;
          }
          return token;
        }
        function appendIfCommentDirective(commentDirectives2, text2, commentDirectiveRegEx, lineStart) {
          var type2 = getDirectiveFromComment(ts3.trimStringStart(text2), commentDirectiveRegEx);
          if (type2 === void 0) {
            return commentDirectives2;
          }
          return ts3.append(commentDirectives2, {
            range: { pos: lineStart, end: pos },
            type: type2
          });
        }
        function getDirectiveFromComment(text2, commentDirectiveRegEx) {
          var match = commentDirectiveRegEx.exec(text2);
          if (!match) {
            return void 0;
          }
          switch (match[1]) {
            case "ts-expect-error":
              return 0;
            case "ts-ignore":
              return 1;
          }
          return void 0;
        }
        function reScanTemplateToken(isTaggedTemplate) {
          ts3.Debug.assert(token === 19, "'reScanTemplateToken' should only be called on a '}'");
          pos = tokenPos;
          return token = scanTemplateAndSetTokenValue(isTaggedTemplate);
        }
        function reScanTemplateHeadOrNoSubstitutionTemplate() {
          pos = tokenPos;
          return token = scanTemplateAndSetTokenValue(true);
        }
        function reScanJsxToken(allowMultilineJsxText) {
          if (allowMultilineJsxText === void 0) {
            allowMultilineJsxText = true;
          }
          pos = tokenPos = startPos;
          return token = scanJsxToken(allowMultilineJsxText);
        }
        function reScanLessThanToken() {
          if (token === 47) {
            pos = tokenPos + 1;
            return token = 29;
          }
          return token;
        }
        function reScanHashToken() {
          if (token === 80) {
            pos = tokenPos + 1;
            return token = 62;
          }
          return token;
        }
        function reScanQuestionToken() {
          ts3.Debug.assert(token === 60, "'reScanQuestionToken' should only be called on a '??'");
          pos = tokenPos + 1;
          return token = 57;
        }
        function scanJsxToken(allowMultilineJsxText) {
          if (allowMultilineJsxText === void 0) {
            allowMultilineJsxText = true;
          }
          startPos = tokenPos = pos;
          if (pos >= end) {
            return token = 1;
          }
          var char = text.charCodeAt(pos);
          if (char === 60) {
            if (text.charCodeAt(pos + 1) === 47) {
              pos += 2;
              return token = 30;
            }
            pos++;
            return token = 29;
          }
          if (char === 123) {
            pos++;
            return token = 18;
          }
          var firstNonWhitespace = 0;
          while (pos < end) {
            char = text.charCodeAt(pos);
            if (char === 123) {
              break;
            }
            if (char === 60) {
              if (isConflictMarkerTrivia(text, pos)) {
                pos = scanConflictMarkerTrivia(text, pos, error);
                return token = 7;
              }
              break;
            }
            if (char === 62) {
              error(ts3.Diagnostics.Unexpected_token_Did_you_mean_or_gt, pos, 1);
            }
            if (char === 125) {
              error(ts3.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace, pos, 1);
            }
            if (isLineBreak(char) && firstNonWhitespace === 0) {
              firstNonWhitespace = -1;
            } else if (!allowMultilineJsxText && isLineBreak(char) && firstNonWhitespace > 0) {
              break;
            } else if (!isWhiteSpaceLike(char)) {
              firstNonWhitespace = pos;
            }
            pos++;
          }
          tokenValue = text.substring(startPos, pos);
          return firstNonWhitespace === -1 ? 12 : 11;
        }
        function scanJsxIdentifier() {
          if (tokenIsIdentifierOrKeyword(token)) {
            var namespaceSeparator = false;
            while (pos < end) {
              var ch = text.charCodeAt(pos);
              if (ch === 45) {
                tokenValue += "-";
                pos++;
                continue;
              } else if (ch === 58 && !namespaceSeparator) {
                tokenValue += ":";
                pos++;
                namespaceSeparator = true;
                token = 79;
                continue;
              }
              var oldPos = pos;
              tokenValue += scanIdentifierParts();
              if (pos === oldPos) {
                break;
              }
            }
            if (tokenValue.slice(-1) === ":") {
              tokenValue = tokenValue.slice(0, -1);
              pos--;
            }
            return getIdentifierToken();
          }
          return token;
        }
        function scanJsxAttributeValue() {
          startPos = pos;
          switch (text.charCodeAt(pos)) {
            case 34:
            case 39:
              tokenValue = scanString(true);
              return token = 10;
            default:
              return scan();
          }
        }
        function reScanJsxAttributeValue() {
          pos = tokenPos = startPos;
          return scanJsxAttributeValue();
        }
        function scanJsDocToken() {
          startPos = tokenPos = pos;
          tokenFlags = 0;
          if (pos >= end) {
            return token = 1;
          }
          var ch = codePointAt2(text, pos);
          pos += charSize(ch);
          switch (ch) {
            case 9:
            case 11:
            case 12:
            case 32:
              while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                pos++;
              }
              return token = 5;
            case 64:
              return token = 59;
            case 13:
              if (text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
              tokenFlags |= 1;
              return token = 4;
            case 42:
              return token = 41;
            case 123:
              return token = 18;
            case 125:
              return token = 19;
            case 91:
              return token = 22;
            case 93:
              return token = 23;
            case 60:
              return token = 29;
            case 62:
              return token = 31;
            case 61:
              return token = 63;
            case 44:
              return token = 27;
            case 46:
              return token = 24;
            case 96:
              return token = 61;
            case 35:
              return token = 62;
            case 92:
              pos--;
              var extendedCookedChar = peekExtendedUnicodeEscape();
              if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
                pos += 3;
                tokenFlags |= 8;
                tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
                return token = getIdentifierToken();
              }
              var cookedChar = peekUnicodeEscape();
              if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                pos += 6;
                tokenFlags |= 1024;
                tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                return token = getIdentifierToken();
              }
              pos++;
              return token = 0;
          }
          if (isIdentifierStart(ch, languageVersion)) {
            var char = ch;
            while (pos < end && isIdentifierPart(char = codePointAt2(text, pos), languageVersion) || text.charCodeAt(pos) === 45)
              pos += charSize(char);
            tokenValue = text.substring(tokenPos, pos);
            if (char === 92) {
              tokenValue += scanIdentifierParts();
            }
            return token = getIdentifierToken();
          } else {
            return token = 0;
          }
        }
        function speculationHelper(callback, isLookahead) {
          var savePos = pos;
          var saveStartPos = startPos;
          var saveTokenPos = tokenPos;
          var saveToken = token;
          var saveTokenValue = tokenValue;
          var saveTokenFlags = tokenFlags;
          var result2 = callback();
          if (!result2 || isLookahead) {
            pos = savePos;
            startPos = saveStartPos;
            tokenPos = saveTokenPos;
            token = saveToken;
            tokenValue = saveTokenValue;
            tokenFlags = saveTokenFlags;
          }
          return result2;
        }
        function scanRange(start2, length2, callback) {
          var saveEnd = end;
          var savePos = pos;
          var saveStartPos = startPos;
          var saveTokenPos = tokenPos;
          var saveToken = token;
          var saveTokenValue = tokenValue;
          var saveTokenFlags = tokenFlags;
          var saveErrorExpectations = commentDirectives;
          setText(text, start2, length2);
          var result2 = callback();
          end = saveEnd;
          pos = savePos;
          startPos = saveStartPos;
          tokenPos = saveTokenPos;
          token = saveToken;
          tokenValue = saveTokenValue;
          tokenFlags = saveTokenFlags;
          commentDirectives = saveErrorExpectations;
          return result2;
        }
        function lookAhead(callback) {
          return speculationHelper(callback, true);
        }
        function tryScan(callback) {
          return speculationHelper(callback, false);
        }
        function getText() {
          return text;
        }
        function clearCommentDirectives() {
          commentDirectives = void 0;
        }
        function setText(newText, start2, length2) {
          text = newText || "";
          end = length2 === void 0 ? text.length : start2 + length2;
          setTextPos(start2 || 0);
        }
        function setOnError(errorCallback) {
          onError = errorCallback;
        }
        function setScriptTarget(scriptTarget) {
          languageVersion = scriptTarget;
        }
        function setLanguageVariant(variant) {
          languageVariant = variant;
        }
        function setTextPos(textPos) {
          ts3.Debug.assert(textPos >= 0);
          pos = textPos;
          startPos = textPos;
          tokenPos = textPos;
          token = 0;
          tokenValue = void 0;
          tokenFlags = 0;
        }
        function setInJSDocType(inType) {
          inJSDocType += inType ? 1 : -1;
        }
      }
      ts3.createScanner = createScanner;
      var codePointAt2 = String.prototype.codePointAt ? function(s, i) {
        return s.codePointAt(i);
      } : function codePointAt3(str2, i) {
        var size = str2.length;
        if (i < 0 || i >= size) {
          return void 0;
        }
        var first = str2.charCodeAt(i);
        if (first >= 55296 && first <= 56319 && size > i + 1) {
          var second = str2.charCodeAt(i + 1);
          if (second >= 56320 && second <= 57343) {
            return (first - 55296) * 1024 + second - 56320 + 65536;
          }
        }
        return first;
      };
      function charSize(ch) {
        if (ch >= 65536) {
          return 2;
        }
        return 1;
      }
      function utf16EncodeAsStringFallback(codePoint) {
        ts3.Debug.assert(0 <= codePoint && codePoint <= 1114111);
        if (codePoint <= 65535) {
          return String.fromCharCode(codePoint);
        }
        var codeUnit1 = Math.floor((codePoint - 65536) / 1024) + 55296;
        var codeUnit2 = (codePoint - 65536) % 1024 + 56320;
        return String.fromCharCode(codeUnit1, codeUnit2);
      }
      var utf16EncodeAsStringWorker = String.fromCodePoint ? function(codePoint) {
        return String.fromCodePoint(codePoint);
      } : utf16EncodeAsStringFallback;
      function utf16EncodeAsString(codePoint) {
        return utf16EncodeAsStringWorker(codePoint);
      }
      ts3.utf16EncodeAsString = utf16EncodeAsString;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function isExternalModuleNameRelative(moduleName) {
        return ts3.pathIsRelative(moduleName) || ts3.isRootedDiskPath(moduleName);
      }
      ts3.isExternalModuleNameRelative = isExternalModuleNameRelative;
      function sortAndDeduplicateDiagnostics(diagnostics) {
        return ts3.sortAndDeduplicate(diagnostics, ts3.compareDiagnostics);
      }
      ts3.sortAndDeduplicateDiagnostics = sortAndDeduplicateDiagnostics;
      function getDefaultLibFileName(options) {
        switch (ts3.getEmitScriptTarget(options)) {
          case 99:
            return "lib.esnext.full.d.ts";
          case 9:
            return "lib.es2022.full.d.ts";
          case 8:
            return "lib.es2021.full.d.ts";
          case 7:
            return "lib.es2020.full.d.ts";
          case 6:
            return "lib.es2019.full.d.ts";
          case 5:
            return "lib.es2018.full.d.ts";
          case 4:
            return "lib.es2017.full.d.ts";
          case 3:
            return "lib.es2016.full.d.ts";
          case 2:
            return "lib.es6.d.ts";
          default:
            return "lib.d.ts";
        }
      }
      ts3.getDefaultLibFileName = getDefaultLibFileName;
      function textSpanEnd(span) {
        return span.start + span.length;
      }
      ts3.textSpanEnd = textSpanEnd;
      function textSpanIsEmpty(span) {
        return span.length === 0;
      }
      ts3.textSpanIsEmpty = textSpanIsEmpty;
      function textSpanContainsPosition(span, position) {
        return position >= span.start && position < textSpanEnd(span);
      }
      ts3.textSpanContainsPosition = textSpanContainsPosition;
      function textRangeContainsPositionInclusive(span, position) {
        return position >= span.pos && position <= span.end;
      }
      ts3.textRangeContainsPositionInclusive = textRangeContainsPositionInclusive;
      function textSpanContainsTextSpan(span, other) {
        return other.start >= span.start && textSpanEnd(other) <= textSpanEnd(span);
      }
      ts3.textSpanContainsTextSpan = textSpanContainsTextSpan;
      function textSpanOverlapsWith(span, other) {
        return textSpanOverlap(span, other) !== void 0;
      }
      ts3.textSpanOverlapsWith = textSpanOverlapsWith;
      function textSpanOverlap(span1, span2) {
        var overlap = textSpanIntersection(span1, span2);
        return overlap && overlap.length === 0 ? void 0 : overlap;
      }
      ts3.textSpanOverlap = textSpanOverlap;
      function textSpanIntersectsWithTextSpan(span, other) {
        return decodedTextSpanIntersectsWith(span.start, span.length, other.start, other.length);
      }
      ts3.textSpanIntersectsWithTextSpan = textSpanIntersectsWithTextSpan;
      function textSpanIntersectsWith(span, start, length) {
        return decodedTextSpanIntersectsWith(span.start, span.length, start, length);
      }
      ts3.textSpanIntersectsWith = textSpanIntersectsWith;
      function decodedTextSpanIntersectsWith(start1, length1, start2, length2) {
        var end1 = start1 + length1;
        var end2 = start2 + length2;
        return start2 <= end1 && end2 >= start1;
      }
      ts3.decodedTextSpanIntersectsWith = decodedTextSpanIntersectsWith;
      function textSpanIntersectsWithPosition(span, position) {
        return position <= textSpanEnd(span) && position >= span.start;
      }
      ts3.textSpanIntersectsWithPosition = textSpanIntersectsWithPosition;
      function textSpanIntersection(span1, span2) {
        var start = Math.max(span1.start, span2.start);
        var end = Math.min(textSpanEnd(span1), textSpanEnd(span2));
        return start <= end ? createTextSpanFromBounds(start, end) : void 0;
      }
      ts3.textSpanIntersection = textSpanIntersection;
      function createTextSpan(start, length) {
        if (start < 0) {
          throw new Error("start < 0");
        }
        if (length < 0) {
          throw new Error("length < 0");
        }
        return { start, length };
      }
      ts3.createTextSpan = createTextSpan;
      function createTextSpanFromBounds(start, end) {
        return createTextSpan(start, end - start);
      }
      ts3.createTextSpanFromBounds = createTextSpanFromBounds;
      function textChangeRangeNewSpan(range) {
        return createTextSpan(range.span.start, range.newLength);
      }
      ts3.textChangeRangeNewSpan = textChangeRangeNewSpan;
      function textChangeRangeIsUnchanged(range) {
        return textSpanIsEmpty(range.span) && range.newLength === 0;
      }
      ts3.textChangeRangeIsUnchanged = textChangeRangeIsUnchanged;
      function createTextChangeRange(span, newLength) {
        if (newLength < 0) {
          throw new Error("newLength < 0");
        }
        return { span, newLength };
      }
      ts3.createTextChangeRange = createTextChangeRange;
      ts3.unchangedTextChangeRange = createTextChangeRange(createTextSpan(0, 0), 0);
      function collapseTextChangeRangesAcrossMultipleVersions(changes) {
        if (changes.length === 0) {
          return ts3.unchangedTextChangeRange;
        }
        if (changes.length === 1) {
          return changes[0];
        }
        var change0 = changes[0];
        var oldStartN = change0.span.start;
        var oldEndN = textSpanEnd(change0.span);
        var newEndN = oldStartN + change0.newLength;
        for (var i = 1; i < changes.length; i++) {
          var nextChange = changes[i];
          var oldStart1 = oldStartN;
          var oldEnd1 = oldEndN;
          var newEnd1 = newEndN;
          var oldStart2 = nextChange.span.start;
          var oldEnd2 = textSpanEnd(nextChange.span);
          var newEnd2 = oldStart2 + nextChange.newLength;
          oldStartN = Math.min(oldStart1, oldStart2);
          oldEndN = Math.max(oldEnd1, oldEnd1 + (oldEnd2 - newEnd1));
          newEndN = Math.max(newEnd2, newEnd2 + (newEnd1 - oldEnd2));
        }
        return createTextChangeRange(createTextSpanFromBounds(oldStartN, oldEndN), newEndN - oldStartN);
      }
      ts3.collapseTextChangeRangesAcrossMultipleVersions = collapseTextChangeRangesAcrossMultipleVersions;
      function getTypeParameterOwner(d) {
        if (d && d.kind === 163) {
          for (var current = d; current; current = current.parent) {
            if (isFunctionLike(current) || isClassLike(current) || current.kind === 258) {
              return current;
            }
          }
        }
      }
      ts3.getTypeParameterOwner = getTypeParameterOwner;
      function isParameterPropertyDeclaration(node, parent) {
        return ts3.hasSyntacticModifier(node, 16476) && parent.kind === 171;
      }
      ts3.isParameterPropertyDeclaration = isParameterPropertyDeclaration;
      function isEmptyBindingPattern(node) {
        if (isBindingPattern(node)) {
          return ts3.every(node.elements, isEmptyBindingElement);
        }
        return false;
      }
      ts3.isEmptyBindingPattern = isEmptyBindingPattern;
      function isEmptyBindingElement(node) {
        if (ts3.isOmittedExpression(node)) {
          return true;
        }
        return isEmptyBindingPattern(node.name);
      }
      ts3.isEmptyBindingElement = isEmptyBindingElement;
      function walkUpBindingElementsAndPatterns(binding) {
        var node = binding.parent;
        while (ts3.isBindingElement(node.parent)) {
          node = node.parent.parent;
        }
        return node.parent;
      }
      ts3.walkUpBindingElementsAndPatterns = walkUpBindingElementsAndPatterns;
      function getCombinedFlags(node, getFlags) {
        if (ts3.isBindingElement(node)) {
          node = walkUpBindingElementsAndPatterns(node);
        }
        var flags = getFlags(node);
        if (node.kind === 254) {
          node = node.parent;
        }
        if (node && node.kind === 255) {
          flags |= getFlags(node);
          node = node.parent;
        }
        if (node && node.kind === 237) {
          flags |= getFlags(node);
        }
        return flags;
      }
      function getCombinedModifierFlags(node) {
        return getCombinedFlags(node, ts3.getEffectiveModifierFlags);
      }
      ts3.getCombinedModifierFlags = getCombinedModifierFlags;
      function getCombinedNodeFlagsAlwaysIncludeJSDoc(node) {
        return getCombinedFlags(node, ts3.getEffectiveModifierFlagsAlwaysIncludeJSDoc);
      }
      ts3.getCombinedNodeFlagsAlwaysIncludeJSDoc = getCombinedNodeFlagsAlwaysIncludeJSDoc;
      function getCombinedNodeFlags(node) {
        return getCombinedFlags(node, function(n) {
          return n.flags;
        });
      }
      ts3.getCombinedNodeFlags = getCombinedNodeFlags;
      ts3.supportedLocaleDirectories = ["cs", "de", "es", "fr", "it", "ja", "ko", "pl", "pt-br", "ru", "tr", "zh-cn", "zh-tw"];
      function validateLocaleAndSetLanguage(locale, sys, errors) {
        var lowerCaseLocale = locale.toLowerCase();
        var matchResult = /^([a-z]+)([_\-]([a-z]+))?$/.exec(lowerCaseLocale);
        if (!matchResult) {
          if (errors) {
            errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1, "en", "ja-jp"));
          }
          return;
        }
        var language = matchResult[1];
        var territory = matchResult[3];
        if (ts3.contains(ts3.supportedLocaleDirectories, lowerCaseLocale) && !trySetLanguageAndTerritory(language, territory, errors)) {
          trySetLanguageAndTerritory(language, void 0, errors);
        }
        ts3.setUILocale(locale);
        function trySetLanguageAndTerritory(language2, territory2, errors2) {
          var compilerFilePath = ts3.normalizePath(sys.getExecutingFilePath());
          var containingDirectoryPath = ts3.getDirectoryPath(compilerFilePath);
          var filePath = ts3.combinePaths(containingDirectoryPath, language2);
          if (territory2) {
            filePath = filePath + "-" + territory2;
          }
          filePath = sys.resolvePath(ts3.combinePaths(filePath, "diagnosticMessages.generated.json"));
          if (!sys.fileExists(filePath)) {
            return false;
          }
          var fileContents = "";
          try {
            fileContents = sys.readFile(filePath);
          } catch (e) {
            if (errors2) {
              errors2.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Unable_to_open_file_0, filePath));
            }
            return false;
          }
          try {
            ts3.setLocalizedDiagnosticMessages(JSON.parse(fileContents));
          } catch (_a) {
            if (errors2) {
              errors2.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Corrupted_locale_file_0, filePath));
            }
            return false;
          }
          return true;
        }
      }
      ts3.validateLocaleAndSetLanguage = validateLocaleAndSetLanguage;
      function getOriginalNode(node, nodeTest) {
        if (node) {
          while (node.original !== void 0) {
            node = node.original;
          }
        }
        return !nodeTest || nodeTest(node) ? node : void 0;
      }
      ts3.getOriginalNode = getOriginalNode;
      function findAncestor(node, callback) {
        while (node) {
          var result2 = callback(node);
          if (result2 === "quit") {
            return void 0;
          } else if (result2) {
            return node;
          }
          node = node.parent;
        }
        return void 0;
      }
      ts3.findAncestor = findAncestor;
      function isParseTreeNode(node) {
        return (node.flags & 8) === 0;
      }
      ts3.isParseTreeNode = isParseTreeNode;
      function getParseTreeNode(node, nodeTest) {
        if (node === void 0 || isParseTreeNode(node)) {
          return node;
        }
        node = node.original;
        while (node) {
          if (isParseTreeNode(node)) {
            return !nodeTest || nodeTest(node) ? node : void 0;
          }
          node = node.original;
        }
      }
      ts3.getParseTreeNode = getParseTreeNode;
      function escapeLeadingUnderscores(identifier) {
        return identifier.length >= 2 && identifier.charCodeAt(0) === 95 && identifier.charCodeAt(1) === 95 ? "_" + identifier : identifier;
      }
      ts3.escapeLeadingUnderscores = escapeLeadingUnderscores;
      function unescapeLeadingUnderscores(identifier) {
        var id = identifier;
        return id.length >= 3 && id.charCodeAt(0) === 95 && id.charCodeAt(1) === 95 && id.charCodeAt(2) === 95 ? id.substr(1) : id;
      }
      ts3.unescapeLeadingUnderscores = unescapeLeadingUnderscores;
      function idText(identifierOrPrivateName) {
        return unescapeLeadingUnderscores(identifierOrPrivateName.escapedText);
      }
      ts3.idText = idText;
      function symbolName(symbol) {
        if (symbol.valueDeclaration && isPrivateIdentifierClassElementDeclaration(symbol.valueDeclaration)) {
          return idText(symbol.valueDeclaration.name);
        }
        return unescapeLeadingUnderscores(symbol.escapedName);
      }
      ts3.symbolName = symbolName;
      function nameForNamelessJSDocTypedef(declaration) {
        var hostNode = declaration.parent.parent;
        if (!hostNode) {
          return void 0;
        }
        if (isDeclaration(hostNode)) {
          return getDeclarationIdentifier(hostNode);
        }
        switch (hostNode.kind) {
          case 237:
            if (hostNode.declarationList && hostNode.declarationList.declarations[0]) {
              return getDeclarationIdentifier(hostNode.declarationList.declarations[0]);
            }
            break;
          case 238:
            var expr = hostNode.expression;
            if (expr.kind === 221 && expr.operatorToken.kind === 63) {
              expr = expr.left;
            }
            switch (expr.kind) {
              case 206:
                return expr.name;
              case 207:
                var arg = expr.argumentExpression;
                if (ts3.isIdentifier(arg)) {
                  return arg;
                }
            }
            break;
          case 212: {
            return getDeclarationIdentifier(hostNode.expression);
          }
          case 250: {
            if (isDeclaration(hostNode.statement) || isExpression(hostNode.statement)) {
              return getDeclarationIdentifier(hostNode.statement);
            }
            break;
          }
        }
      }
      function getDeclarationIdentifier(node) {
        var name = getNameOfDeclaration(node);
        return name && ts3.isIdentifier(name) ? name : void 0;
      }
      function nodeHasName(statement, name) {
        if (isNamedDeclaration(statement) && ts3.isIdentifier(statement.name) && idText(statement.name) === idText(name)) {
          return true;
        }
        if (ts3.isVariableStatement(statement) && ts3.some(statement.declarationList.declarations, function(d) {
          return nodeHasName(d, name);
        })) {
          return true;
        }
        return false;
      }
      ts3.nodeHasName = nodeHasName;
      function getNameOfJSDocTypedef(declaration) {
        return declaration.name || nameForNamelessJSDocTypedef(declaration);
      }
      ts3.getNameOfJSDocTypedef = getNameOfJSDocTypedef;
      function isNamedDeclaration(node) {
        return !!node.name;
      }
      ts3.isNamedDeclaration = isNamedDeclaration;
      function getNonAssignedNameOfDeclaration(declaration) {
        switch (declaration.kind) {
          case 79:
            return declaration;
          case 347:
          case 340: {
            var name = declaration.name;
            if (name.kind === 161) {
              return name.right;
            }
            break;
          }
          case 208:
          case 221: {
            var expr_1 = declaration;
            switch (ts3.getAssignmentDeclarationKind(expr_1)) {
              case 1:
              case 4:
              case 5:
              case 3:
                return ts3.getElementOrPropertyAccessArgumentExpressionOrName(expr_1.left);
              case 7:
              case 8:
              case 9:
                return expr_1.arguments[1];
              default:
                return void 0;
            }
          }
          case 345:
            return getNameOfJSDocTypedef(declaration);
          case 339:
            return nameForNamelessJSDocTypedef(declaration);
          case 271: {
            var expression = declaration.expression;
            return ts3.isIdentifier(expression) ? expression : void 0;
          }
          case 207:
            var expr = declaration;
            if (ts3.isBindableStaticElementAccessExpression(expr)) {
              return expr.argumentExpression;
            }
        }
        return declaration.name;
      }
      ts3.getNonAssignedNameOfDeclaration = getNonAssignedNameOfDeclaration;
      function getNameOfDeclaration(declaration) {
        if (declaration === void 0)
          return void 0;
        return getNonAssignedNameOfDeclaration(declaration) || (ts3.isFunctionExpression(declaration) || ts3.isArrowFunction(declaration) || ts3.isClassExpression(declaration) ? getAssignedName(declaration) : void 0);
      }
      ts3.getNameOfDeclaration = getNameOfDeclaration;
      function getAssignedName(node) {
        if (!node.parent) {
          return void 0;
        } else if (ts3.isPropertyAssignment(node.parent) || ts3.isBindingElement(node.parent)) {
          return node.parent.name;
        } else if (ts3.isBinaryExpression(node.parent) && node === node.parent.right) {
          if (ts3.isIdentifier(node.parent.left)) {
            return node.parent.left;
          } else if (ts3.isAccessExpression(node.parent.left)) {
            return ts3.getElementOrPropertyAccessArgumentExpressionOrName(node.parent.left);
          }
        } else if (ts3.isVariableDeclaration(node.parent) && ts3.isIdentifier(node.parent.name)) {
          return node.parent.name;
        }
      }
      ts3.getAssignedName = getAssignedName;
      function getJSDocParameterTagsWorker(param, noCache) {
        if (param.name) {
          if (ts3.isIdentifier(param.name)) {
            var name_1 = param.name.escapedText;
            return getJSDocTagsWorker(param.parent, noCache).filter(function(tag) {
              return ts3.isJSDocParameterTag(tag) && ts3.isIdentifier(tag.name) && tag.name.escapedText === name_1;
            });
          } else {
            var i = param.parent.parameters.indexOf(param);
            ts3.Debug.assert(i > -1, "Parameters should always be in their parents' parameter list");
            var paramTags = getJSDocTagsWorker(param.parent, noCache).filter(ts3.isJSDocParameterTag);
            if (i < paramTags.length) {
              return [paramTags[i]];
            }
          }
        }
        return ts3.emptyArray;
      }
      function getJSDocParameterTags(param) {
        return getJSDocParameterTagsWorker(param, false);
      }
      ts3.getJSDocParameterTags = getJSDocParameterTags;
      function getJSDocParameterTagsNoCache(param) {
        return getJSDocParameterTagsWorker(param, true);
      }
      ts3.getJSDocParameterTagsNoCache = getJSDocParameterTagsNoCache;
      function getJSDocTypeParameterTagsWorker(param, noCache) {
        var name = param.name.escapedText;
        return getJSDocTagsWorker(param.parent, noCache).filter(function(tag) {
          return ts3.isJSDocTemplateTag(tag) && tag.typeParameters.some(function(tp) {
            return tp.name.escapedText === name;
          });
        });
      }
      function getJSDocTypeParameterTags(param) {
        return getJSDocTypeParameterTagsWorker(param, false);
      }
      ts3.getJSDocTypeParameterTags = getJSDocTypeParameterTags;
      function getJSDocTypeParameterTagsNoCache(param) {
        return getJSDocTypeParameterTagsWorker(param, true);
      }
      ts3.getJSDocTypeParameterTagsNoCache = getJSDocTypeParameterTagsNoCache;
      function hasJSDocParameterTags(node) {
        return !!getFirstJSDocTag(node, ts3.isJSDocParameterTag);
      }
      ts3.hasJSDocParameterTags = hasJSDocParameterTags;
      function getJSDocAugmentsTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocAugmentsTag);
      }
      ts3.getJSDocAugmentsTag = getJSDocAugmentsTag;
      function getJSDocImplementsTags(node) {
        return getAllJSDocTags(node, ts3.isJSDocImplementsTag);
      }
      ts3.getJSDocImplementsTags = getJSDocImplementsTags;
      function getJSDocClassTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocClassTag);
      }
      ts3.getJSDocClassTag = getJSDocClassTag;
      function getJSDocPublicTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPublicTag);
      }
      ts3.getJSDocPublicTag = getJSDocPublicTag;
      function getJSDocPublicTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPublicTag, true);
      }
      ts3.getJSDocPublicTagNoCache = getJSDocPublicTagNoCache;
      function getJSDocPrivateTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPrivateTag);
      }
      ts3.getJSDocPrivateTag = getJSDocPrivateTag;
      function getJSDocPrivateTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPrivateTag, true);
      }
      ts3.getJSDocPrivateTagNoCache = getJSDocPrivateTagNoCache;
      function getJSDocProtectedTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocProtectedTag);
      }
      ts3.getJSDocProtectedTag = getJSDocProtectedTag;
      function getJSDocProtectedTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocProtectedTag, true);
      }
      ts3.getJSDocProtectedTagNoCache = getJSDocProtectedTagNoCache;
      function getJSDocReadonlyTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocReadonlyTag);
      }
      ts3.getJSDocReadonlyTag = getJSDocReadonlyTag;
      function getJSDocReadonlyTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocReadonlyTag, true);
      }
      ts3.getJSDocReadonlyTagNoCache = getJSDocReadonlyTagNoCache;
      function getJSDocOverrideTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocOverrideTag, true);
      }
      ts3.getJSDocOverrideTagNoCache = getJSDocOverrideTagNoCache;
      function getJSDocDeprecatedTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocDeprecatedTag);
      }
      ts3.getJSDocDeprecatedTag = getJSDocDeprecatedTag;
      function getJSDocDeprecatedTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocDeprecatedTag, true);
      }
      ts3.getJSDocDeprecatedTagNoCache = getJSDocDeprecatedTagNoCache;
      function getJSDocEnumTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocEnumTag);
      }
      ts3.getJSDocEnumTag = getJSDocEnumTag;
      function getJSDocThisTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocThisTag);
      }
      ts3.getJSDocThisTag = getJSDocThisTag;
      function getJSDocReturnTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocReturnTag);
      }
      ts3.getJSDocReturnTag = getJSDocReturnTag;
      function getJSDocTemplateTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocTemplateTag);
      }
      ts3.getJSDocTemplateTag = getJSDocTemplateTag;
      function getJSDocTypeTag(node) {
        var tag = getFirstJSDocTag(node, ts3.isJSDocTypeTag);
        if (tag && tag.typeExpression && tag.typeExpression.type) {
          return tag;
        }
        return void 0;
      }
      ts3.getJSDocTypeTag = getJSDocTypeTag;
      function getJSDocType(node) {
        var tag = getFirstJSDocTag(node, ts3.isJSDocTypeTag);
        if (!tag && ts3.isParameter(node)) {
          tag = ts3.find(getJSDocParameterTags(node), function(tag2) {
            return !!tag2.typeExpression;
          });
        }
        return tag && tag.typeExpression && tag.typeExpression.type;
      }
      ts3.getJSDocType = getJSDocType;
      function getJSDocReturnType(node) {
        var returnTag = getJSDocReturnTag(node);
        if (returnTag && returnTag.typeExpression) {
          return returnTag.typeExpression.type;
        }
        var typeTag = getJSDocTypeTag(node);
        if (typeTag && typeTag.typeExpression) {
          var type2 = typeTag.typeExpression.type;
          if (ts3.isTypeLiteralNode(type2)) {
            var sig = ts3.find(type2.members, ts3.isCallSignatureDeclaration);
            return sig && sig.type;
          }
          if (ts3.isFunctionTypeNode(type2) || ts3.isJSDocFunctionType(type2)) {
            return type2.type;
          }
        }
      }
      ts3.getJSDocReturnType = getJSDocReturnType;
      function getJSDocTagsWorker(node, noCache) {
        var tags = node.jsDocCache;
        if (tags === void 0 || noCache) {
          var comments = ts3.getJSDocCommentsAndTags(node, noCache);
          ts3.Debug.assert(comments.length < 2 || comments[0] !== comments[1]);
          tags = ts3.flatMap(comments, function(j) {
            return ts3.isJSDoc(j) ? j.tags : j;
          });
          if (!noCache) {
            node.jsDocCache = tags;
          }
        }
        return tags;
      }
      function getJSDocTags(node) {
        return getJSDocTagsWorker(node, false);
      }
      ts3.getJSDocTags = getJSDocTags;
      function getJSDocTagsNoCache(node) {
        return getJSDocTagsWorker(node, true);
      }
      ts3.getJSDocTagsNoCache = getJSDocTagsNoCache;
      function getFirstJSDocTag(node, predicate, noCache) {
        return ts3.find(getJSDocTagsWorker(node, noCache), predicate);
      }
      function getAllJSDocTags(node, predicate) {
        return getJSDocTags(node).filter(predicate);
      }
      ts3.getAllJSDocTags = getAllJSDocTags;
      function getAllJSDocTagsOfKind(node, kind) {
        return getJSDocTags(node).filter(function(doc) {
          return doc.kind === kind;
        });
      }
      ts3.getAllJSDocTagsOfKind = getAllJSDocTagsOfKind;
      function getTextOfJSDocComment(comment) {
        return typeof comment === "string" ? comment : comment === null || comment === void 0 ? void 0 : comment.map(function(c) {
          return c.kind === 321 ? c.text : formatJSDocLink(c);
        }).join("");
      }
      ts3.getTextOfJSDocComment = getTextOfJSDocComment;
      function formatJSDocLink(link) {
        var kind = link.kind === 324 ? "link" : link.kind === 325 ? "linkcode" : "linkplain";
        var name = link.name ? ts3.entityNameToString(link.name) : "";
        var space = link.name && link.text.startsWith("://") ? "" : " ";
        return "{@".concat(kind, " ").concat(name).concat(space).concat(link.text, "}");
      }
      function getEffectiveTypeParameterDeclarations(node) {
        if (ts3.isJSDocSignature(node)) {
          return ts3.emptyArray;
        }
        if (ts3.isJSDocTypeAlias(node)) {
          ts3.Debug.assert(node.parent.kind === 320);
          return ts3.flatMap(node.parent.tags, function(tag) {
            return ts3.isJSDocTemplateTag(tag) ? tag.typeParameters : void 0;
          });
        }
        if (node.typeParameters) {
          return node.typeParameters;
        }
        if (ts3.isInJSFile(node)) {
          var decls = ts3.getJSDocTypeParameterDeclarations(node);
          if (decls.length) {
            return decls;
          }
          var typeTag = getJSDocType(node);
          if (typeTag && ts3.isFunctionTypeNode(typeTag) && typeTag.typeParameters) {
            return typeTag.typeParameters;
          }
        }
        return ts3.emptyArray;
      }
      ts3.getEffectiveTypeParameterDeclarations = getEffectiveTypeParameterDeclarations;
      function getEffectiveConstraintOfTypeParameter(node) {
        return node.constraint ? node.constraint : ts3.isJSDocTemplateTag(node.parent) && node === node.parent.typeParameters[0] ? node.parent.constraint : void 0;
      }
      ts3.getEffectiveConstraintOfTypeParameter = getEffectiveConstraintOfTypeParameter;
      function isMemberName(node) {
        return node.kind === 79 || node.kind === 80;
      }
      ts3.isMemberName = isMemberName;
      function isGetOrSetAccessorDeclaration(node) {
        return node.kind === 173 || node.kind === 172;
      }
      ts3.isGetOrSetAccessorDeclaration = isGetOrSetAccessorDeclaration;
      function isPropertyAccessChain(node) {
        return ts3.isPropertyAccessExpression(node) && !!(node.flags & 32);
      }
      ts3.isPropertyAccessChain = isPropertyAccessChain;
      function isElementAccessChain(node) {
        return ts3.isElementAccessExpression(node) && !!(node.flags & 32);
      }
      ts3.isElementAccessChain = isElementAccessChain;
      function isCallChain(node) {
        return ts3.isCallExpression(node) && !!(node.flags & 32);
      }
      ts3.isCallChain = isCallChain;
      function isOptionalChain(node) {
        var kind = node.kind;
        return !!(node.flags & 32) && (kind === 206 || kind === 207 || kind === 208 || kind === 230);
      }
      ts3.isOptionalChain = isOptionalChain;
      function isOptionalChainRoot(node) {
        return isOptionalChain(node) && !ts3.isNonNullExpression(node) && !!node.questionDotToken;
      }
      ts3.isOptionalChainRoot = isOptionalChainRoot;
      function isExpressionOfOptionalChainRoot(node) {
        return isOptionalChainRoot(node.parent) && node.parent.expression === node;
      }
      ts3.isExpressionOfOptionalChainRoot = isExpressionOfOptionalChainRoot;
      function isOutermostOptionalChain(node) {
        return !isOptionalChain(node.parent) || isOptionalChainRoot(node.parent) || node !== node.parent.expression;
      }
      ts3.isOutermostOptionalChain = isOutermostOptionalChain;
      function isNullishCoalesce(node) {
        return node.kind === 221 && node.operatorToken.kind === 60;
      }
      ts3.isNullishCoalesce = isNullishCoalesce;
      function isConstTypeReference(node) {
        return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "const" && !node.typeArguments;
      }
      ts3.isConstTypeReference = isConstTypeReference;
      function skipPartiallyEmittedExpressions(node) {
        return ts3.skipOuterExpressions(node, 8);
      }
      ts3.skipPartiallyEmittedExpressions = skipPartiallyEmittedExpressions;
      function isNonNullChain(node) {
        return ts3.isNonNullExpression(node) && !!(node.flags & 32);
      }
      ts3.isNonNullChain = isNonNullChain;
      function isBreakOrContinueStatement(node) {
        return node.kind === 246 || node.kind === 245;
      }
      ts3.isBreakOrContinueStatement = isBreakOrContinueStatement;
      function isNamedExportBindings(node) {
        return node.kind === 274 || node.kind === 273;
      }
      ts3.isNamedExportBindings = isNamedExportBindings;
      function isUnparsedTextLike(node) {
        switch (node.kind) {
          case 302:
          case 303:
            return true;
          default:
            return false;
        }
      }
      ts3.isUnparsedTextLike = isUnparsedTextLike;
      function isUnparsedNode(node) {
        return isUnparsedTextLike(node) || node.kind === 300 || node.kind === 304;
      }
      ts3.isUnparsedNode = isUnparsedNode;
      function isJSDocPropertyLikeTag(node) {
        return node.kind === 347 || node.kind === 340;
      }
      ts3.isJSDocPropertyLikeTag = isJSDocPropertyLikeTag;
      function isNode(node) {
        return isNodeKind(node.kind);
      }
      ts3.isNode = isNode;
      function isNodeKind(kind) {
        return kind >= 161;
      }
      ts3.isNodeKind = isNodeKind;
      function isTokenKind(kind) {
        return kind >= 0 && kind <= 160;
      }
      ts3.isTokenKind = isTokenKind;
      function isToken(n) {
        return isTokenKind(n.kind);
      }
      ts3.isToken = isToken;
      function isNodeArray(array) {
        return array.hasOwnProperty("pos") && array.hasOwnProperty("end");
      }
      ts3.isNodeArray = isNodeArray;
      function isLiteralKind(kind) {
        return 8 <= kind && kind <= 14;
      }
      ts3.isLiteralKind = isLiteralKind;
      function isLiteralExpression(node) {
        return isLiteralKind(node.kind);
      }
      ts3.isLiteralExpression = isLiteralExpression;
      function isTemplateLiteralKind(kind) {
        return 14 <= kind && kind <= 17;
      }
      ts3.isTemplateLiteralKind = isTemplateLiteralKind;
      function isTemplateLiteralToken(node) {
        return isTemplateLiteralKind(node.kind);
      }
      ts3.isTemplateLiteralToken = isTemplateLiteralToken;
      function isTemplateMiddleOrTemplateTail(node) {
        var kind = node.kind;
        return kind === 16 || kind === 17;
      }
      ts3.isTemplateMiddleOrTemplateTail = isTemplateMiddleOrTemplateTail;
      function isImportOrExportSpecifier(node) {
        return ts3.isImportSpecifier(node) || ts3.isExportSpecifier(node);
      }
      ts3.isImportOrExportSpecifier = isImportOrExportSpecifier;
      function isTypeOnlyImportOrExportDeclaration(node) {
        switch (node.kind) {
          case 270:
          case 275:
            return node.isTypeOnly || node.parent.parent.isTypeOnly;
          case 268:
            return node.parent.isTypeOnly;
          case 267:
          case 265:
            return node.isTypeOnly;
          default:
            return false;
        }
      }
      ts3.isTypeOnlyImportOrExportDeclaration = isTypeOnlyImportOrExportDeclaration;
      function isAssertionKey(node) {
        return ts3.isStringLiteral(node) || ts3.isIdentifier(node);
      }
      ts3.isAssertionKey = isAssertionKey;
      function isStringTextContainingNode(node) {
        return node.kind === 10 || isTemplateLiteralKind(node.kind);
      }
      ts3.isStringTextContainingNode = isStringTextContainingNode;
      function isGeneratedIdentifier(node) {
        return ts3.isIdentifier(node) && (node.autoGenerateFlags & 7) > 0;
      }
      ts3.isGeneratedIdentifier = isGeneratedIdentifier;
      function isPrivateIdentifierClassElementDeclaration(node) {
        return (ts3.isPropertyDeclaration(node) || isMethodOrAccessor(node)) && ts3.isPrivateIdentifier(node.name);
      }
      ts3.isPrivateIdentifierClassElementDeclaration = isPrivateIdentifierClassElementDeclaration;
      function isPrivateIdentifierPropertyAccessExpression(node) {
        return ts3.isPropertyAccessExpression(node) && ts3.isPrivateIdentifier(node.name);
      }
      ts3.isPrivateIdentifierPropertyAccessExpression = isPrivateIdentifierPropertyAccessExpression;
      function isModifierKind(token) {
        switch (token) {
          case 126:
          case 131:
          case 85:
          case 135:
          case 88:
          case 93:
          case 101:
          case 123:
          case 121:
          case 122:
          case 145:
          case 124:
          case 144:
          case 159:
            return true;
        }
        return false;
      }
      ts3.isModifierKind = isModifierKind;
      function isParameterPropertyModifier(kind) {
        return !!(ts3.modifierToFlag(kind) & 16476);
      }
      ts3.isParameterPropertyModifier = isParameterPropertyModifier;
      function isClassMemberModifier(idToken) {
        return isParameterPropertyModifier(idToken) || idToken === 124 || idToken === 159;
      }
      ts3.isClassMemberModifier = isClassMemberModifier;
      function isModifier(node) {
        return isModifierKind(node.kind);
      }
      ts3.isModifier = isModifier;
      function isEntityName(node) {
        var kind = node.kind;
        return kind === 161 || kind === 79;
      }
      ts3.isEntityName = isEntityName;
      function isPropertyName(node) {
        var kind = node.kind;
        return kind === 79 || kind === 80 || kind === 10 || kind === 8 || kind === 162;
      }
      ts3.isPropertyName = isPropertyName;
      function isBindingName(node) {
        var kind = node.kind;
        return kind === 79 || kind === 201 || kind === 202;
      }
      ts3.isBindingName = isBindingName;
      function isFunctionLike(node) {
        return !!node && isFunctionLikeKind(node.kind);
      }
      ts3.isFunctionLike = isFunctionLike;
      function isFunctionLikeOrClassStaticBlockDeclaration(node) {
        return !!node && (isFunctionLikeKind(node.kind) || ts3.isClassStaticBlockDeclaration(node));
      }
      ts3.isFunctionLikeOrClassStaticBlockDeclaration = isFunctionLikeOrClassStaticBlockDeclaration;
      function isFunctionLikeDeclaration(node) {
        return node && isFunctionLikeDeclarationKind(node.kind);
      }
      ts3.isFunctionLikeDeclaration = isFunctionLikeDeclaration;
      function isBooleanLiteral(node) {
        return node.kind === 110 || node.kind === 95;
      }
      ts3.isBooleanLiteral = isBooleanLiteral;
      function isFunctionLikeDeclarationKind(kind) {
        switch (kind) {
          case 256:
          case 169:
          case 171:
          case 172:
          case 173:
          case 213:
          case 214:
            return true;
          default:
            return false;
        }
      }
      function isFunctionLikeKind(kind) {
        switch (kind) {
          case 168:
          case 174:
          case 323:
          case 175:
          case 176:
          case 179:
          case 317:
          case 180:
            return true;
          default:
            return isFunctionLikeDeclarationKind(kind);
        }
      }
      ts3.isFunctionLikeKind = isFunctionLikeKind;
      function isFunctionOrModuleBlock(node) {
        return ts3.isSourceFile(node) || ts3.isModuleBlock(node) || ts3.isBlock(node) && isFunctionLike(node.parent);
      }
      ts3.isFunctionOrModuleBlock = isFunctionOrModuleBlock;
      function isClassElement(node) {
        var kind = node.kind;
        return kind === 171 || kind === 167 || kind === 169 || kind === 172 || kind === 173 || kind === 176 || kind === 170 || kind === 234;
      }
      ts3.isClassElement = isClassElement;
      function isClassLike(node) {
        return node && (node.kind === 257 || node.kind === 226);
      }
      ts3.isClassLike = isClassLike;
      function isAccessor(node) {
        return node && (node.kind === 172 || node.kind === 173);
      }
      ts3.isAccessor = isAccessor;
      function isMethodOrAccessor(node) {
        switch (node.kind) {
          case 169:
          case 172:
          case 173:
            return true;
          default:
            return false;
        }
      }
      ts3.isMethodOrAccessor = isMethodOrAccessor;
      function isTypeElement(node) {
        var kind = node.kind;
        return kind === 175 || kind === 174 || kind === 166 || kind === 168 || kind === 176 || kind === 172 || kind === 173;
      }
      ts3.isTypeElement = isTypeElement;
      function isClassOrTypeElement(node) {
        return isTypeElement(node) || isClassElement(node);
      }
      ts3.isClassOrTypeElement = isClassOrTypeElement;
      function isObjectLiteralElementLike(node) {
        var kind = node.kind;
        return kind === 296 || kind === 297 || kind === 298 || kind === 169 || kind === 172 || kind === 173;
      }
      ts3.isObjectLiteralElementLike = isObjectLiteralElementLike;
      function isTypeNode(node) {
        return ts3.isTypeNodeKind(node.kind);
      }
      ts3.isTypeNode = isTypeNode;
      function isFunctionOrConstructorTypeNode(node) {
        switch (node.kind) {
          case 179:
          case 180:
            return true;
        }
        return false;
      }
      ts3.isFunctionOrConstructorTypeNode = isFunctionOrConstructorTypeNode;
      function isBindingPattern(node) {
        if (node) {
          var kind = node.kind;
          return kind === 202 || kind === 201;
        }
        return false;
      }
      ts3.isBindingPattern = isBindingPattern;
      function isAssignmentPattern(node) {
        var kind = node.kind;
        return kind === 204 || kind === 205;
      }
      ts3.isAssignmentPattern = isAssignmentPattern;
      function isArrayBindingElement(node) {
        var kind = node.kind;
        return kind === 203 || kind === 227;
      }
      ts3.isArrayBindingElement = isArrayBindingElement;
      function isDeclarationBindingElement(bindingElement) {
        switch (bindingElement.kind) {
          case 254:
          case 164:
          case 203:
            return true;
        }
        return false;
      }
      ts3.isDeclarationBindingElement = isDeclarationBindingElement;
      function isBindingOrAssignmentPattern(node) {
        return isObjectBindingOrAssignmentPattern(node) || isArrayBindingOrAssignmentPattern(node);
      }
      ts3.isBindingOrAssignmentPattern = isBindingOrAssignmentPattern;
      function isObjectBindingOrAssignmentPattern(node) {
        switch (node.kind) {
          case 201:
          case 205:
            return true;
        }
        return false;
      }
      ts3.isObjectBindingOrAssignmentPattern = isObjectBindingOrAssignmentPattern;
      function isObjectBindingOrAssignmentElement(node) {
        switch (node.kind) {
          case 203:
          case 296:
          case 297:
          case 298:
            return true;
        }
        return false;
      }
      ts3.isObjectBindingOrAssignmentElement = isObjectBindingOrAssignmentElement;
      function isArrayBindingOrAssignmentPattern(node) {
        switch (node.kind) {
          case 202:
          case 204:
            return true;
        }
        return false;
      }
      ts3.isArrayBindingOrAssignmentPattern = isArrayBindingOrAssignmentPattern;
      function isPropertyAccessOrQualifiedNameOrImportTypeNode(node) {
        var kind = node.kind;
        return kind === 206 || kind === 161 || kind === 200;
      }
      ts3.isPropertyAccessOrQualifiedNameOrImportTypeNode = isPropertyAccessOrQualifiedNameOrImportTypeNode;
      function isPropertyAccessOrQualifiedName(node) {
        var kind = node.kind;
        return kind === 206 || kind === 161;
      }
      ts3.isPropertyAccessOrQualifiedName = isPropertyAccessOrQualifiedName;
      function isCallLikeExpression(node) {
        switch (node.kind) {
          case 280:
          case 279:
          case 208:
          case 209:
          case 210:
          case 165:
            return true;
          default:
            return false;
        }
      }
      ts3.isCallLikeExpression = isCallLikeExpression;
      function isCallOrNewExpression(node) {
        return node.kind === 208 || node.kind === 209;
      }
      ts3.isCallOrNewExpression = isCallOrNewExpression;
      function isTemplateLiteral(node) {
        var kind = node.kind;
        return kind === 223 || kind === 14;
      }
      ts3.isTemplateLiteral = isTemplateLiteral;
      function isLeftHandSideExpression(node) {
        return isLeftHandSideExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts3.isLeftHandSideExpression = isLeftHandSideExpression;
      function isLeftHandSideExpressionKind(kind) {
        switch (kind) {
          case 206:
          case 207:
          case 209:
          case 208:
          case 278:
          case 279:
          case 282:
          case 210:
          case 204:
          case 212:
          case 205:
          case 226:
          case 213:
          case 79:
          case 80:
          case 13:
          case 8:
          case 9:
          case 10:
          case 14:
          case 223:
          case 95:
          case 104:
          case 108:
          case 110:
          case 106:
          case 230:
          case 228:
          case 231:
          case 100:
            return true;
          default:
            return false;
        }
      }
      function isUnaryExpression(node) {
        return isUnaryExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts3.isUnaryExpression = isUnaryExpression;
      function isUnaryExpressionKind(kind) {
        switch (kind) {
          case 219:
          case 220:
          case 215:
          case 216:
          case 217:
          case 218:
          case 211:
            return true;
          default:
            return isLeftHandSideExpressionKind(kind);
        }
      }
      function isUnaryExpressionWithWrite(expr) {
        switch (expr.kind) {
          case 220:
            return true;
          case 219:
            return expr.operator === 45 || expr.operator === 46;
          default:
            return false;
        }
      }
      ts3.isUnaryExpressionWithWrite = isUnaryExpressionWithWrite;
      function isExpression(node) {
        return isExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts3.isExpression = isExpression;
      function isExpressionKind(kind) {
        switch (kind) {
          case 222:
          case 224:
          case 214:
          case 221:
          case 225:
          case 229:
          case 227:
          case 351:
          case 350:
            return true;
          default:
            return isUnaryExpressionKind(kind);
        }
      }
      function isAssertionExpression(node) {
        var kind = node.kind;
        return kind === 211 || kind === 229;
      }
      ts3.isAssertionExpression = isAssertionExpression;
      function isNotEmittedOrPartiallyEmittedNode(node) {
        return ts3.isNotEmittedStatement(node) || ts3.isPartiallyEmittedExpression(node);
      }
      ts3.isNotEmittedOrPartiallyEmittedNode = isNotEmittedOrPartiallyEmittedNode;
      function isIterationStatement(node, lookInLabeledStatements) {
        switch (node.kind) {
          case 242:
          case 243:
          case 244:
          case 240:
          case 241:
            return true;
          case 250:
            return lookInLabeledStatements && isIterationStatement(node.statement, lookInLabeledStatements);
        }
        return false;
      }
      ts3.isIterationStatement = isIterationStatement;
      function isScopeMarker(node) {
        return ts3.isExportAssignment(node) || ts3.isExportDeclaration(node);
      }
      ts3.isScopeMarker = isScopeMarker;
      function hasScopeMarker(statements) {
        return ts3.some(statements, isScopeMarker);
      }
      ts3.hasScopeMarker = hasScopeMarker;
      function needsScopeMarker(result2) {
        return !ts3.isAnyImportOrReExport(result2) && !ts3.isExportAssignment(result2) && !ts3.hasSyntacticModifier(result2, 1) && !ts3.isAmbientModule(result2);
      }
      ts3.needsScopeMarker = needsScopeMarker;
      function isExternalModuleIndicator(result2) {
        return ts3.isAnyImportOrReExport(result2) || ts3.isExportAssignment(result2) || ts3.hasSyntacticModifier(result2, 1);
      }
      ts3.isExternalModuleIndicator = isExternalModuleIndicator;
      function isForInOrOfStatement(node) {
        return node.kind === 243 || node.kind === 244;
      }
      ts3.isForInOrOfStatement = isForInOrOfStatement;
      function isConciseBody(node) {
        return ts3.isBlock(node) || isExpression(node);
      }
      ts3.isConciseBody = isConciseBody;
      function isFunctionBody(node) {
        return ts3.isBlock(node);
      }
      ts3.isFunctionBody = isFunctionBody;
      function isForInitializer(node) {
        return ts3.isVariableDeclarationList(node) || isExpression(node);
      }
      ts3.isForInitializer = isForInitializer;
      function isModuleBody(node) {
        var kind = node.kind;
        return kind === 262 || kind === 261 || kind === 79;
      }
      ts3.isModuleBody = isModuleBody;
      function isNamespaceBody(node) {
        var kind = node.kind;
        return kind === 262 || kind === 261;
      }
      ts3.isNamespaceBody = isNamespaceBody;
      function isJSDocNamespaceBody(node) {
        var kind = node.kind;
        return kind === 79 || kind === 261;
      }
      ts3.isJSDocNamespaceBody = isJSDocNamespaceBody;
      function isNamedImportBindings(node) {
        var kind = node.kind;
        return kind === 269 || kind === 268;
      }
      ts3.isNamedImportBindings = isNamedImportBindings;
      function isModuleOrEnumDeclaration(node) {
        return node.kind === 261 || node.kind === 260;
      }
      ts3.isModuleOrEnumDeclaration = isModuleOrEnumDeclaration;
      function isDeclarationKind(kind) {
        return kind === 214 || kind === 203 || kind === 257 || kind === 226 || kind === 170 || kind === 171 || kind === 260 || kind === 299 || kind === 275 || kind === 256 || kind === 213 || kind === 172 || kind === 267 || kind === 265 || kind === 270 || kind === 258 || kind === 285 || kind === 169 || kind === 168 || kind === 261 || kind === 264 || kind === 268 || kind === 274 || kind === 164 || kind === 296 || kind === 167 || kind === 166 || kind === 173 || kind === 297 || kind === 259 || kind === 163 || kind === 254 || kind === 345 || kind === 338 || kind === 347;
      }
      function isDeclarationStatementKind(kind) {
        return kind === 256 || kind === 276 || kind === 257 || kind === 258 || kind === 259 || kind === 260 || kind === 261 || kind === 266 || kind === 265 || kind === 272 || kind === 271 || kind === 264;
      }
      function isStatementKindButNotDeclarationKind(kind) {
        return kind === 246 || kind === 245 || kind === 253 || kind === 240 || kind === 238 || kind === 236 || kind === 243 || kind === 244 || kind === 242 || kind === 239 || kind === 250 || kind === 247 || kind === 249 || kind === 251 || kind === 252 || kind === 237 || kind === 241 || kind === 248 || kind === 349 || kind === 353 || kind === 352;
      }
      function isDeclaration(node) {
        if (node.kind === 163) {
          return node.parent && node.parent.kind !== 344 || ts3.isInJSFile(node);
        }
        return isDeclarationKind(node.kind);
      }
      ts3.isDeclaration = isDeclaration;
      function isDeclarationStatement(node) {
        return isDeclarationStatementKind(node.kind);
      }
      ts3.isDeclarationStatement = isDeclarationStatement;
      function isStatementButNotDeclaration(node) {
        return isStatementKindButNotDeclarationKind(node.kind);
      }
      ts3.isStatementButNotDeclaration = isStatementButNotDeclaration;
      function isStatement(node) {
        var kind = node.kind;
        return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || isBlockStatement(node);
      }
      ts3.isStatement = isStatement;
      function isBlockStatement(node) {
        if (node.kind !== 235)
          return false;
        if (node.parent !== void 0) {
          if (node.parent.kind === 252 || node.parent.kind === 292) {
            return false;
          }
        }
        return !ts3.isFunctionBlock(node);
      }
      function isStatementOrBlock(node) {
        var kind = node.kind;
        return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || kind === 235;
      }
      ts3.isStatementOrBlock = isStatementOrBlock;
      function isModuleReference(node) {
        var kind = node.kind;
        return kind === 277 || kind === 161 || kind === 79;
      }
      ts3.isModuleReference = isModuleReference;
      function isJsxTagNameExpression(node) {
        var kind = node.kind;
        return kind === 108 || kind === 79 || kind === 206;
      }
      ts3.isJsxTagNameExpression = isJsxTagNameExpression;
      function isJsxChild(node) {
        var kind = node.kind;
        return kind === 278 || kind === 288 || kind === 279 || kind === 11 || kind === 282;
      }
      ts3.isJsxChild = isJsxChild;
      function isJsxAttributeLike(node) {
        var kind = node.kind;
        return kind === 285 || kind === 287;
      }
      ts3.isJsxAttributeLike = isJsxAttributeLike;
      function isStringLiteralOrJsxExpression(node) {
        var kind = node.kind;
        return kind === 10 || kind === 288;
      }
      ts3.isStringLiteralOrJsxExpression = isStringLiteralOrJsxExpression;
      function isJsxOpeningLikeElement(node) {
        var kind = node.kind;
        return kind === 280 || kind === 279;
      }
      ts3.isJsxOpeningLikeElement = isJsxOpeningLikeElement;
      function isCaseOrDefaultClause(node) {
        var kind = node.kind;
        return kind === 289 || kind === 290;
      }
      ts3.isCaseOrDefaultClause = isCaseOrDefaultClause;
      function isJSDocNode(node) {
        return node.kind >= 309 && node.kind <= 347;
      }
      ts3.isJSDocNode = isJSDocNode;
      function isJSDocCommentContainingNode(node) {
        return node.kind === 320 || node.kind === 319 || node.kind === 321 || isJSDocLinkLike(node) || isJSDocTag(node) || ts3.isJSDocTypeLiteral(node) || ts3.isJSDocSignature(node);
      }
      ts3.isJSDocCommentContainingNode = isJSDocCommentContainingNode;
      function isJSDocTag(node) {
        return node.kind >= 327 && node.kind <= 347;
      }
      ts3.isJSDocTag = isJSDocTag;
      function isSetAccessor(node) {
        return node.kind === 173;
      }
      ts3.isSetAccessor = isSetAccessor;
      function isGetAccessor(node) {
        return node.kind === 172;
      }
      ts3.isGetAccessor = isGetAccessor;
      function hasJSDocNodes(node) {
        var jsDoc = node.jsDoc;
        return !!jsDoc && jsDoc.length > 0;
      }
      ts3.hasJSDocNodes = hasJSDocNodes;
      function hasType(node) {
        return !!node.type;
      }
      ts3.hasType = hasType;
      function hasInitializer(node) {
        return !!node.initializer;
      }
      ts3.hasInitializer = hasInitializer;
      function hasOnlyExpressionInitializer(node) {
        switch (node.kind) {
          case 254:
          case 164:
          case 203:
          case 166:
          case 167:
          case 296:
          case 299:
            return true;
          default:
            return false;
        }
      }
      ts3.hasOnlyExpressionInitializer = hasOnlyExpressionInitializer;
      function isObjectLiteralElement(node) {
        return node.kind === 285 || node.kind === 287 || isObjectLiteralElementLike(node);
      }
      ts3.isObjectLiteralElement = isObjectLiteralElement;
      function isTypeReferenceType(node) {
        return node.kind === 178 || node.kind === 228;
      }
      ts3.isTypeReferenceType = isTypeReferenceType;
      var MAX_SMI_X86 = 1073741823;
      function guessIndentation(lines) {
        var indentation = MAX_SMI_X86;
        for (var _i = 0, lines_1 = lines; _i < lines_1.length; _i++) {
          var line = lines_1[_i];
          if (!line.length) {
            continue;
          }
          var i = 0;
          for (; i < line.length && i < indentation; i++) {
            if (!ts3.isWhiteSpaceLike(line.charCodeAt(i))) {
              break;
            }
          }
          if (i < indentation) {
            indentation = i;
          }
          if (indentation === 0) {
            return 0;
          }
        }
        return indentation === MAX_SMI_X86 ? void 0 : indentation;
      }
      ts3.guessIndentation = guessIndentation;
      function isStringLiteralLike(node) {
        return node.kind === 10 || node.kind === 14;
      }
      ts3.isStringLiteralLike = isStringLiteralLike;
      function isJSDocLinkLike(node) {
        return node.kind === 324 || node.kind === 325 || node.kind === 326;
      }
      ts3.isJSDocLinkLike = isJSDocLinkLike;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.resolvingEmptyArray = [];
      ts3.externalHelpersModuleNameText = "tslib";
      ts3.defaultMaximumTruncationLength = 160;
      ts3.noTruncationMaximumTruncationLength = 1e6;
      function getDeclarationOfKind(symbol, kind) {
        var declarations = symbol.declarations;
        if (declarations) {
          for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
            var declaration = declarations_1[_i];
            if (declaration.kind === kind) {
              return declaration;
            }
          }
        }
        return void 0;
      }
      ts3.getDeclarationOfKind = getDeclarationOfKind;
      function getDeclarationsOfKind(symbol, kind) {
        return ts3.filter(symbol.declarations || ts3.emptyArray, function(d) {
          return d.kind === kind;
        });
      }
      ts3.getDeclarationsOfKind = getDeclarationsOfKind;
      function createSymbolTable(symbols) {
        var result2 = new ts3.Map();
        if (symbols) {
          for (var _i = 0, symbols_1 = symbols; _i < symbols_1.length; _i++) {
            var symbol = symbols_1[_i];
            result2.set(symbol.escapedName, symbol);
          }
        }
        return result2;
      }
      ts3.createSymbolTable = createSymbolTable;
      function isTransientSymbol(symbol) {
        return (symbol.flags & 33554432) !== 0;
      }
      ts3.isTransientSymbol = isTransientSymbol;
      var stringWriter = createSingleLineStringWriter();
      function createSingleLineStringWriter() {
        var str2 = "";
        var writeText = function(text) {
          return str2 += text;
        };
        return {
          getText: function() {
            return str2;
          },
          write: writeText,
          rawWrite: writeText,
          writeKeyword: writeText,
          writeOperator: writeText,
          writePunctuation: writeText,
          writeSpace: writeText,
          writeStringLiteral: writeText,
          writeLiteral: writeText,
          writeParameter: writeText,
          writeProperty: writeText,
          writeSymbol: function(s, _) {
            return writeText(s);
          },
          writeTrailingSemicolon: writeText,
          writeComment: writeText,
          getTextPos: function() {
            return str2.length;
          },
          getLine: function() {
            return 0;
          },
          getColumn: function() {
            return 0;
          },
          getIndent: function() {
            return 0;
          },
          isAtStartOfLine: function() {
            return false;
          },
          hasTrailingComment: function() {
            return false;
          },
          hasTrailingWhitespace: function() {
            return !!str2.length && ts3.isWhiteSpaceLike(str2.charCodeAt(str2.length - 1));
          },
          writeLine: function() {
            return str2 += " ";
          },
          increaseIndent: ts3.noop,
          decreaseIndent: ts3.noop,
          clear: function() {
            return str2 = "";
          },
          trackSymbol: function() {
            return false;
          },
          reportInaccessibleThisError: ts3.noop,
          reportInaccessibleUniqueSymbolError: ts3.noop,
          reportPrivateInBaseOfClassExpression: ts3.noop
        };
      }
      function changesAffectModuleResolution(oldOptions, newOptions) {
        return oldOptions.configFilePath !== newOptions.configFilePath || optionsHaveModuleResolutionChanges(oldOptions, newOptions);
      }
      ts3.changesAffectModuleResolution = changesAffectModuleResolution;
      function optionsHaveModuleResolutionChanges(oldOptions, newOptions) {
        return optionsHaveChanges(oldOptions, newOptions, ts3.moduleResolutionOptionDeclarations);
      }
      ts3.optionsHaveModuleResolutionChanges = optionsHaveModuleResolutionChanges;
      function changesAffectingProgramStructure(oldOptions, newOptions) {
        return optionsHaveChanges(oldOptions, newOptions, ts3.optionsAffectingProgramStructure);
      }
      ts3.changesAffectingProgramStructure = changesAffectingProgramStructure;
      function optionsHaveChanges(oldOptions, newOptions, optionDeclarations) {
        return oldOptions !== newOptions && optionDeclarations.some(function(o) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, o), getCompilerOptionValue(newOptions, o));
        });
      }
      ts3.optionsHaveChanges = optionsHaveChanges;
      function forEachAncestor(node, callback) {
        while (true) {
          var res = callback(node);
          if (res === "quit")
            return void 0;
          if (res !== void 0)
            return res;
          if (ts3.isSourceFile(node))
            return void 0;
          node = node.parent;
        }
      }
      ts3.forEachAncestor = forEachAncestor;
      function forEachEntry(map2, callback) {
        var iterator = map2.entries();
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          var _a = iterResult.value, key = _a[0], value = _a[1];
          var result2 = callback(value, key);
          if (result2) {
            return result2;
          }
        }
        return void 0;
      }
      ts3.forEachEntry = forEachEntry;
      function forEachKey(map2, callback) {
        var iterator = map2.keys();
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          var result2 = callback(iterResult.value);
          if (result2) {
            return result2;
          }
        }
        return void 0;
      }
      ts3.forEachKey = forEachKey;
      function copyEntries(source, target) {
        source.forEach(function(value, key) {
          target.set(key, value);
        });
      }
      ts3.copyEntries = copyEntries;
      function usingSingleLineStringWriter(action) {
        var oldString = stringWriter.getText();
        try {
          action(stringWriter);
          return stringWriter.getText();
        } finally {
          stringWriter.clear();
          stringWriter.writeKeyword(oldString);
        }
      }
      ts3.usingSingleLineStringWriter = usingSingleLineStringWriter;
      function getFullWidth(node) {
        return node.end - node.pos;
      }
      ts3.getFullWidth = getFullWidth;
      function getResolvedModule(sourceFile, moduleNameText, mode) {
        return sourceFile && sourceFile.resolvedModules && sourceFile.resolvedModules.get(moduleNameText, mode);
      }
      ts3.getResolvedModule = getResolvedModule;
      function setResolvedModule(sourceFile, moduleNameText, resolvedModule, mode) {
        if (!sourceFile.resolvedModules) {
          sourceFile.resolvedModules = ts3.createModeAwareCache();
        }
        sourceFile.resolvedModules.set(moduleNameText, mode, resolvedModule);
      }
      ts3.setResolvedModule = setResolvedModule;
      function setResolvedTypeReferenceDirective(sourceFile, typeReferenceDirectiveName, resolvedTypeReferenceDirective) {
        if (!sourceFile.resolvedTypeReferenceDirectiveNames) {
          sourceFile.resolvedTypeReferenceDirectiveNames = ts3.createModeAwareCache();
        }
        sourceFile.resolvedTypeReferenceDirectiveNames.set(typeReferenceDirectiveName, void 0, resolvedTypeReferenceDirective);
      }
      ts3.setResolvedTypeReferenceDirective = setResolvedTypeReferenceDirective;
      function projectReferenceIsEqualTo(oldRef, newRef) {
        return oldRef.path === newRef.path && !oldRef.prepend === !newRef.prepend && !oldRef.circular === !newRef.circular;
      }
      ts3.projectReferenceIsEqualTo = projectReferenceIsEqualTo;
      function moduleResolutionIsEqualTo(oldResolution, newResolution) {
        return oldResolution.isExternalLibraryImport === newResolution.isExternalLibraryImport && oldResolution.extension === newResolution.extension && oldResolution.resolvedFileName === newResolution.resolvedFileName && oldResolution.originalPath === newResolution.originalPath && packageIdIsEqual(oldResolution.packageId, newResolution.packageId);
      }
      ts3.moduleResolutionIsEqualTo = moduleResolutionIsEqualTo;
      function packageIdIsEqual(a, b) {
        return a === b || !!a && !!b && a.name === b.name && a.subModuleName === b.subModuleName && a.version === b.version;
      }
      function packageIdToPackageName(_a) {
        var name = _a.name, subModuleName = _a.subModuleName;
        return subModuleName ? "".concat(name, "/").concat(subModuleName) : name;
      }
      ts3.packageIdToPackageName = packageIdToPackageName;
      function packageIdToString(packageId) {
        return "".concat(packageIdToPackageName(packageId), "@").concat(packageId.version);
      }
      ts3.packageIdToString = packageIdToString;
      function typeDirectiveIsEqualTo(oldResolution, newResolution) {
        return oldResolution.resolvedFileName === newResolution.resolvedFileName && oldResolution.primary === newResolution.primary && oldResolution.originalPath === newResolution.originalPath;
      }
      ts3.typeDirectiveIsEqualTo = typeDirectiveIsEqualTo;
      function hasChangesInResolutions(names, newResolutions, oldResolutions, oldSourceFile, comparer) {
        ts3.Debug.assert(names.length === newResolutions.length);
        for (var i = 0; i < names.length; i++) {
          var newResolution = newResolutions[i];
          var entry = names[i];
          var name = !ts3.isString(entry) ? entry.fileName.toLowerCase() : entry;
          var mode = !ts3.isString(entry) ? ts3.getModeForFileReference(entry, oldSourceFile === null || oldSourceFile === void 0 ? void 0 : oldSourceFile.impliedNodeFormat) : oldSourceFile && ts3.getModeForResolutionAtIndex(oldSourceFile, i);
          var oldResolution = oldResolutions && oldResolutions.get(name, mode);
          var changed = oldResolution ? !newResolution || !comparer(oldResolution, newResolution) : newResolution;
          if (changed) {
            return true;
          }
        }
        return false;
      }
      ts3.hasChangesInResolutions = hasChangesInResolutions;
      function containsParseError(node) {
        aggregateChildData(node);
        return (node.flags & 524288) !== 0;
      }
      ts3.containsParseError = containsParseError;
      function aggregateChildData(node) {
        if (!(node.flags & 1048576)) {
          var thisNodeOrAnySubNodesHasError = (node.flags & 131072) !== 0 || ts3.forEachChild(node, containsParseError);
          if (thisNodeOrAnySubNodesHasError) {
            node.flags |= 524288;
          }
          node.flags |= 1048576;
        }
      }
      function getSourceFileOfNode(node) {
        while (node && node.kind !== 305) {
          node = node.parent;
        }
        return node;
      }
      ts3.getSourceFileOfNode = getSourceFileOfNode;
      function getSourceFileOfModule(module3) {
        return getSourceFileOfNode(module3.valueDeclaration || getNonAugmentationDeclaration(module3));
      }
      ts3.getSourceFileOfModule = getSourceFileOfModule;
      function isPlainJsFile(file, checkJs) {
        return !!file && (file.scriptKind === 1 || file.scriptKind === 2) && !file.checkJsDirective && checkJs === void 0;
      }
      ts3.isPlainJsFile = isPlainJsFile;
      function isStatementWithLocals(node) {
        switch (node.kind) {
          case 235:
          case 263:
          case 242:
          case 243:
          case 244:
            return true;
        }
        return false;
      }
      ts3.isStatementWithLocals = isStatementWithLocals;
      function getStartPositionOfLine(line, sourceFile) {
        ts3.Debug.assert(line >= 0);
        return ts3.getLineStarts(sourceFile)[line];
      }
      ts3.getStartPositionOfLine = getStartPositionOfLine;
      function nodePosToString(node) {
        var file = getSourceFileOfNode(node);
        var loc = ts3.getLineAndCharacterOfPosition(file, node.pos);
        return "".concat(file.fileName, "(").concat(loc.line + 1, ",").concat(loc.character + 1, ")");
      }
      ts3.nodePosToString = nodePosToString;
      function getEndLinePosition(line, sourceFile) {
        ts3.Debug.assert(line >= 0);
        var lineStarts = ts3.getLineStarts(sourceFile);
        var lineIndex = line;
        var sourceText = sourceFile.text;
        if (lineIndex + 1 === lineStarts.length) {
          return sourceText.length - 1;
        } else {
          var start = lineStarts[lineIndex];
          var pos = lineStarts[lineIndex + 1] - 1;
          ts3.Debug.assert(ts3.isLineBreak(sourceText.charCodeAt(pos)));
          while (start <= pos && ts3.isLineBreak(sourceText.charCodeAt(pos))) {
            pos--;
          }
          return pos;
        }
      }
      ts3.getEndLinePosition = getEndLinePosition;
      function isFileLevelUniqueName(sourceFile, name, hasGlobalName) {
        return !(hasGlobalName && hasGlobalName(name)) && !sourceFile.identifiers.has(name);
      }
      ts3.isFileLevelUniqueName = isFileLevelUniqueName;
      function nodeIsMissing(node) {
        if (node === void 0) {
          return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1;
      }
      ts3.nodeIsMissing = nodeIsMissing;
      function nodeIsPresent(node) {
        return !nodeIsMissing(node);
      }
      ts3.nodeIsPresent = nodeIsPresent;
      function insertStatementsAfterPrologue(to, from, isPrologueDirective2) {
        if (from === void 0 || from.length === 0)
          return to;
        var statementIndex = 0;
        for (; statementIndex < to.length; ++statementIndex) {
          if (!isPrologueDirective2(to[statementIndex])) {
            break;
          }
        }
        to.splice.apply(to, __spreadArray([statementIndex, 0], from, false));
        return to;
      }
      function insertStatementAfterPrologue(to, statement, isPrologueDirective2) {
        if (statement === void 0)
          return to;
        var statementIndex = 0;
        for (; statementIndex < to.length; ++statementIndex) {
          if (!isPrologueDirective2(to[statementIndex])) {
            break;
          }
        }
        to.splice(statementIndex, 0, statement);
        return to;
      }
      function isAnyPrologueDirective(node) {
        return isPrologueDirective(node) || !!(getEmitFlags(node) & 1048576);
      }
      function insertStatementsAfterStandardPrologue(to, from) {
        return insertStatementsAfterPrologue(to, from, isPrologueDirective);
      }
      ts3.insertStatementsAfterStandardPrologue = insertStatementsAfterStandardPrologue;
      function insertStatementsAfterCustomPrologue(to, from) {
        return insertStatementsAfterPrologue(to, from, isAnyPrologueDirective);
      }
      ts3.insertStatementsAfterCustomPrologue = insertStatementsAfterCustomPrologue;
      function insertStatementAfterStandardPrologue(to, statement) {
        return insertStatementAfterPrologue(to, statement, isPrologueDirective);
      }
      ts3.insertStatementAfterStandardPrologue = insertStatementAfterStandardPrologue;
      function insertStatementAfterCustomPrologue(to, statement) {
        return insertStatementAfterPrologue(to, statement, isAnyPrologueDirective);
      }
      ts3.insertStatementAfterCustomPrologue = insertStatementAfterCustomPrologue;
      function isRecognizedTripleSlashComment(text, commentPos, commentEnd) {
        if (text.charCodeAt(commentPos + 1) === 47 && commentPos + 2 < commentEnd && text.charCodeAt(commentPos + 2) === 47) {
          var textSubStr = text.substring(commentPos, commentEnd);
          return ts3.fullTripleSlashReferencePathRegEx.test(textSubStr) || ts3.fullTripleSlashAMDReferencePathRegEx.test(textSubStr) || fullTripleSlashReferenceTypeReferenceDirectiveRegEx.test(textSubStr) || defaultLibReferenceRegEx.test(textSubStr) ? true : false;
        }
        return false;
      }
      ts3.isRecognizedTripleSlashComment = isRecognizedTripleSlashComment;
      function isPinnedComment(text, start) {
        return text.charCodeAt(start + 1) === 42 && text.charCodeAt(start + 2) === 33;
      }
      ts3.isPinnedComment = isPinnedComment;
      function createCommentDirectivesMap(sourceFile, commentDirectives) {
        var directivesByLine = new ts3.Map(commentDirectives.map(function(commentDirective) {
          return [
            "".concat(ts3.getLineAndCharacterOfPosition(sourceFile, commentDirective.range.end).line),
            commentDirective
          ];
        }));
        var usedLines = new ts3.Map();
        return { getUnusedExpectations, markUsed };
        function getUnusedExpectations() {
          return ts3.arrayFrom(directivesByLine.entries()).filter(function(_a) {
            var line = _a[0], directive = _a[1];
            return directive.type === 0 && !usedLines.get(line);
          }).map(function(_a) {
            var _ = _a[0], directive = _a[1];
            return directive;
          });
        }
        function markUsed(line) {
          if (!directivesByLine.has("".concat(line))) {
            return false;
          }
          usedLines.set("".concat(line), true);
          return true;
        }
      }
      ts3.createCommentDirectivesMap = createCommentDirectivesMap;
      function getTokenPosOfNode(node, sourceFile, includeJsDoc) {
        if (nodeIsMissing(node)) {
          return node.pos;
        }
        if (ts3.isJSDocNode(node) || node.kind === 11) {
          return ts3.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.pos, false, true);
        }
        if (includeJsDoc && ts3.hasJSDocNodes(node)) {
          return getTokenPosOfNode(node.jsDoc[0], sourceFile);
        }
        if (node.kind === 348 && node._children.length > 0) {
          return getTokenPosOfNode(node._children[0], sourceFile, includeJsDoc);
        }
        return ts3.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.pos, false, false, isInJSDoc(node));
      }
      ts3.getTokenPosOfNode = getTokenPosOfNode;
      function getNonDecoratorTokenPosOfNode(node, sourceFile) {
        if (nodeIsMissing(node) || !node.decorators) {
          return getTokenPosOfNode(node, sourceFile);
        }
        return ts3.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.decorators.end);
      }
      ts3.getNonDecoratorTokenPosOfNode = getNonDecoratorTokenPosOfNode;
      function getSourceTextOfNodeFromSourceFile(sourceFile, node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        return getTextOfNodeFromSourceText(sourceFile.text, node, includeTrivia);
      }
      ts3.getSourceTextOfNodeFromSourceFile = getSourceTextOfNodeFromSourceFile;
      function isJSDocTypeExpressionOrChild(node) {
        return !!ts3.findAncestor(node, ts3.isJSDocTypeExpression);
      }
      function isExportNamespaceAsDefaultDeclaration(node) {
        return !!(ts3.isExportDeclaration(node) && node.exportClause && ts3.isNamespaceExport(node.exportClause) && node.exportClause.name.escapedText === "default");
      }
      ts3.isExportNamespaceAsDefaultDeclaration = isExportNamespaceAsDefaultDeclaration;
      function getTextOfNodeFromSourceText(sourceText, node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        if (nodeIsMissing(node)) {
          return "";
        }
        var text = sourceText.substring(includeTrivia ? node.pos : ts3.skipTrivia(sourceText, node.pos), node.end);
        if (isJSDocTypeExpressionOrChild(node)) {
          text = text.split(/\r\n|\n|\r/).map(function(line) {
            return ts3.trimStringStart(line.replace(/^\s*\*/, ""));
          }).join("\n");
        }
        return text;
      }
      ts3.getTextOfNodeFromSourceText = getTextOfNodeFromSourceText;
      function getTextOfNode(node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        return getSourceTextOfNodeFromSourceFile(getSourceFileOfNode(node), node, includeTrivia);
      }
      ts3.getTextOfNode = getTextOfNode;
      function getPos(range) {
        return range.pos;
      }
      function indexOfNode(nodeArray, node) {
        return ts3.binarySearch(nodeArray, node, getPos, ts3.compareValues);
      }
      ts3.indexOfNode = indexOfNode;
      function getEmitFlags(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.flags || 0;
      }
      ts3.getEmitFlags = getEmitFlags;
      ;
      function getScriptTargetFeatures() {
        return {
          es2015: {
            Array: ["find", "findIndex", "fill", "copyWithin", "entries", "keys", "values"],
            RegExp: ["flags", "sticky", "unicode"],
            Reflect: ["apply", "construct", "defineProperty", "deleteProperty", "get", " getOwnPropertyDescriptor", "getPrototypeOf", "has", "isExtensible", "ownKeys", "preventExtensions", "set", "setPrototypeOf"],
            ArrayConstructor: ["from", "of"],
            ObjectConstructor: ["assign", "getOwnPropertySymbols", "keys", "is", "setPrototypeOf"],
            NumberConstructor: ["isFinite", "isInteger", "isNaN", "isSafeInteger", "parseFloat", "parseInt"],
            Math: ["clz32", "imul", "sign", "log10", "log2", "log1p", "expm1", "cosh", "sinh", "tanh", "acosh", "asinh", "atanh", "hypot", "trunc", "fround", "cbrt"],
            Map: ["entries", "keys", "values"],
            Set: ["entries", "keys", "values"],
            Promise: ts3.emptyArray,
            PromiseConstructor: ["all", "race", "reject", "resolve"],
            Symbol: ["for", "keyFor"],
            WeakMap: ["entries", "keys", "values"],
            WeakSet: ["entries", "keys", "values"],
            Iterator: ts3.emptyArray,
            AsyncIterator: ts3.emptyArray,
            String: ["codePointAt", "includes", "endsWith", "normalize", "repeat", "startsWith", "anchor", "big", "blink", "bold", "fixed", "fontcolor", "fontsize", "italics", "link", "small", "strike", "sub", "sup"],
            StringConstructor: ["fromCodePoint", "raw"]
          },
          es2016: {
            Array: ["includes"]
          },
          es2017: {
            Atomics: ts3.emptyArray,
            SharedArrayBuffer: ts3.emptyArray,
            String: ["padStart", "padEnd"],
            ObjectConstructor: ["values", "entries", "getOwnPropertyDescriptors"],
            DateTimeFormat: ["formatToParts"]
          },
          es2018: {
            Promise: ["finally"],
            RegExpMatchArray: ["groups"],
            RegExpExecArray: ["groups"],
            RegExp: ["dotAll"],
            Intl: ["PluralRules"],
            AsyncIterable: ts3.emptyArray,
            AsyncIterableIterator: ts3.emptyArray,
            AsyncGenerator: ts3.emptyArray,
            AsyncGeneratorFunction: ts3.emptyArray,
            NumberFormat: ["formatToParts"]
          },
          es2019: {
            Array: ["flat", "flatMap"],
            ObjectConstructor: ["fromEntries"],
            String: ["trimStart", "trimEnd", "trimLeft", "trimRight"],
            Symbol: ["description"]
          },
          es2020: {
            BigInt: ts3.emptyArray,
            BigInt64Array: ts3.emptyArray,
            BigUint64Array: ts3.emptyArray,
            PromiseConstructor: ["allSettled"],
            SymbolConstructor: ["matchAll"],
            String: ["matchAll"],
            DataView: ["setBigInt64", "setBigUint64", "getBigInt64", "getBigUint64"],
            RelativeTimeFormat: ["format", "formatToParts", "resolvedOptions"]
          },
          es2021: {
            PromiseConstructor: ["any"],
            String: ["replaceAll"]
          },
          es2022: {
            Array: ["at"],
            String: ["at"],
            Int8Array: ["at"],
            Uint8Array: ["at"],
            Uint8ClampedArray: ["at"],
            Int16Array: ["at"],
            Uint16Array: ["at"],
            Int32Array: ["at"],
            Uint32Array: ["at"],
            Float32Array: ["at"],
            Float64Array: ["at"],
            BigInt64Array: ["at"],
            BigUint64Array: ["at"],
            ObjectConstructor: ["hasOwn"],
            Error: ["cause"]
          }
        };
      }
      ts3.getScriptTargetFeatures = getScriptTargetFeatures;
      var GetLiteralTextFlags;
      (function(GetLiteralTextFlags2) {
        GetLiteralTextFlags2[GetLiteralTextFlags2["None"] = 0] = "None";
        GetLiteralTextFlags2[GetLiteralTextFlags2["NeverAsciiEscape"] = 1] = "NeverAsciiEscape";
        GetLiteralTextFlags2[GetLiteralTextFlags2["JsxAttributeEscape"] = 2] = "JsxAttributeEscape";
        GetLiteralTextFlags2[GetLiteralTextFlags2["TerminateUnterminatedLiterals"] = 4] = "TerminateUnterminatedLiterals";
        GetLiteralTextFlags2[GetLiteralTextFlags2["AllowNumericSeparator"] = 8] = "AllowNumericSeparator";
      })(GetLiteralTextFlags = ts3.GetLiteralTextFlags || (ts3.GetLiteralTextFlags = {}));
      function getLiteralText(node, sourceFile, flags) {
        var _a;
        if (sourceFile && canUseOriginalText(node, flags)) {
          return getSourceTextOfNodeFromSourceFile(sourceFile, node);
        }
        switch (node.kind) {
          case 10: {
            var escapeText = flags & 2 ? escapeJsxAttributeString : flags & 1 || getEmitFlags(node) & 16777216 ? escapeString2 : escapeNonAsciiString;
            if (node.singleQuote) {
              return "'" + escapeText(node.text, 39) + "'";
            } else {
              return '"' + escapeText(node.text, 34) + '"';
            }
          }
          case 14:
          case 15:
          case 16:
          case 17: {
            var escapeText = flags & 1 || getEmitFlags(node) & 16777216 ? escapeString2 : escapeNonAsciiString;
            var rawText = (_a = node.rawText) !== null && _a !== void 0 ? _a : escapeTemplateSubstitution(escapeText(node.text, 96));
            switch (node.kind) {
              case 14:
                return "`" + rawText + "`";
              case 15:
                return "`" + rawText + "${";
              case 16:
                return "}" + rawText + "${";
              case 17:
                return "}" + rawText + "`";
            }
            break;
          }
          case 8:
          case 9:
            return node.text;
          case 13:
            if (flags & 4 && node.isUnterminated) {
              return node.text + (node.text.charCodeAt(node.text.length - 1) === 92 ? " /" : "/");
            }
            return node.text;
        }
        return ts3.Debug.fail("Literal kind '".concat(node.kind, "' not accounted for."));
      }
      ts3.getLiteralText = getLiteralText;
      function canUseOriginalText(node, flags) {
        if (nodeIsSynthesized(node) || !node.parent || flags & 4 && node.isUnterminated) {
          return false;
        }
        if (ts3.isNumericLiteral(node) && node.numericLiteralFlags & 512) {
          return !!(flags & 8);
        }
        return !ts3.isBigIntLiteral(node);
      }
      function getTextOfConstantValue(value) {
        return ts3.isString(value) ? '"' + escapeNonAsciiString(value) + '"' : "" + value;
      }
      ts3.getTextOfConstantValue = getTextOfConstantValue;
      function makeIdentifierFromModuleName(moduleName) {
        return ts3.getBaseFileName(moduleName).replace(/^(\d)/, "_$1").replace(/\W/g, "_");
      }
      ts3.makeIdentifierFromModuleName = makeIdentifierFromModuleName;
      function isBlockOrCatchScoped(declaration) {
        return (ts3.getCombinedNodeFlags(declaration) & 3) !== 0 || isCatchClauseVariableDeclarationOrBindingElement(declaration);
      }
      ts3.isBlockOrCatchScoped = isBlockOrCatchScoped;
      function isCatchClauseVariableDeclarationOrBindingElement(declaration) {
        var node = getRootDeclaration(declaration);
        return node.kind === 254 && node.parent.kind === 292;
      }
      ts3.isCatchClauseVariableDeclarationOrBindingElement = isCatchClauseVariableDeclarationOrBindingElement;
      function isAmbientModule(node) {
        return ts3.isModuleDeclaration(node) && (node.name.kind === 10 || isGlobalScopeAugmentation(node));
      }
      ts3.isAmbientModule = isAmbientModule;
      function isModuleWithStringLiteralName(node) {
        return ts3.isModuleDeclaration(node) && node.name.kind === 10;
      }
      ts3.isModuleWithStringLiteralName = isModuleWithStringLiteralName;
      function isNonGlobalAmbientModule(node) {
        return ts3.isModuleDeclaration(node) && ts3.isStringLiteral(node.name);
      }
      ts3.isNonGlobalAmbientModule = isNonGlobalAmbientModule;
      function isEffectiveModuleDeclaration(node) {
        return ts3.isModuleDeclaration(node) || ts3.isIdentifier(node);
      }
      ts3.isEffectiveModuleDeclaration = isEffectiveModuleDeclaration;
      function isShorthandAmbientModuleSymbol(moduleSymbol) {
        return isShorthandAmbientModule(moduleSymbol.valueDeclaration);
      }
      ts3.isShorthandAmbientModuleSymbol = isShorthandAmbientModuleSymbol;
      function isShorthandAmbientModule(node) {
        return !!node && node.kind === 261 && !node.body;
      }
      function isBlockScopedContainerTopLevel(node) {
        return node.kind === 305 || node.kind === 261 || ts3.isFunctionLikeOrClassStaticBlockDeclaration(node);
      }
      ts3.isBlockScopedContainerTopLevel = isBlockScopedContainerTopLevel;
      function isGlobalScopeAugmentation(module3) {
        return !!(module3.flags & 1024);
      }
      ts3.isGlobalScopeAugmentation = isGlobalScopeAugmentation;
      function isExternalModuleAugmentation(node) {
        return isAmbientModule(node) && isModuleAugmentationExternal(node);
      }
      ts3.isExternalModuleAugmentation = isExternalModuleAugmentation;
      function isModuleAugmentationExternal(node) {
        switch (node.parent.kind) {
          case 305:
            return ts3.isExternalModule(node.parent);
          case 262:
            return isAmbientModule(node.parent.parent) && ts3.isSourceFile(node.parent.parent.parent) && !ts3.isExternalModule(node.parent.parent.parent);
        }
        return false;
      }
      ts3.isModuleAugmentationExternal = isModuleAugmentationExternal;
      function getNonAugmentationDeclaration(symbol) {
        var _a;
        return (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.find(function(d) {
          return !isExternalModuleAugmentation(d) && !(ts3.isModuleDeclaration(d) && isGlobalScopeAugmentation(d));
        });
      }
      ts3.getNonAugmentationDeclaration = getNonAugmentationDeclaration;
      function isCommonJSContainingModuleKind(kind) {
        return kind === ts3.ModuleKind.CommonJS || kind === ts3.ModuleKind.Node16 || kind === ts3.ModuleKind.NodeNext;
      }
      function isEffectiveExternalModule(node, compilerOptions) {
        return ts3.isExternalModule(node) || compilerOptions.isolatedModules || isCommonJSContainingModuleKind(getEmitModuleKind(compilerOptions)) && !!node.commonJsModuleIndicator;
      }
      ts3.isEffectiveExternalModule = isEffectiveExternalModule;
      function isEffectiveStrictModeSourceFile(node, compilerOptions) {
        switch (node.scriptKind) {
          case 1:
          case 3:
          case 2:
          case 4:
            break;
          default:
            return false;
        }
        if (node.isDeclarationFile) {
          return false;
        }
        if (getStrictOptionValue(compilerOptions, "alwaysStrict")) {
          return true;
        }
        if (ts3.startsWithUseStrict(node.statements)) {
          return true;
        }
        if (ts3.isExternalModule(node) || compilerOptions.isolatedModules) {
          if (getEmitModuleKind(compilerOptions) >= ts3.ModuleKind.ES2015) {
            return true;
          }
          return !compilerOptions.noImplicitUseStrict;
        }
        return false;
      }
      ts3.isEffectiveStrictModeSourceFile = isEffectiveStrictModeSourceFile;
      function isBlockScope(node, parentNode) {
        switch (node.kind) {
          case 305:
          case 263:
          case 292:
          case 261:
          case 242:
          case 243:
          case 244:
          case 171:
          case 169:
          case 172:
          case 173:
          case 256:
          case 213:
          case 214:
          case 167:
          case 170:
            return true;
          case 235:
            return !ts3.isFunctionLikeOrClassStaticBlockDeclaration(parentNode);
        }
        return false;
      }
      ts3.isBlockScope = isBlockScope;
      function isDeclarationWithTypeParameters(node) {
        switch (node.kind) {
          case 338:
          case 345:
          case 323:
            return true;
          default:
            ts3.assertType(node);
            return isDeclarationWithTypeParameterChildren(node);
        }
      }
      ts3.isDeclarationWithTypeParameters = isDeclarationWithTypeParameters;
      function isDeclarationWithTypeParameterChildren(node) {
        switch (node.kind) {
          case 174:
          case 175:
          case 168:
          case 176:
          case 179:
          case 180:
          case 317:
          case 257:
          case 226:
          case 258:
          case 259:
          case 344:
          case 256:
          case 169:
          case 171:
          case 172:
          case 173:
          case 213:
          case 214:
            return true;
          default:
            ts3.assertType(node);
            return false;
        }
      }
      ts3.isDeclarationWithTypeParameterChildren = isDeclarationWithTypeParameterChildren;
      function isAnyImportSyntax(node) {
        switch (node.kind) {
          case 266:
          case 265:
            return true;
          default:
            return false;
        }
      }
      ts3.isAnyImportSyntax = isAnyImportSyntax;
      function isAnyImportOrBareOrAccessedRequire(node) {
        return isAnyImportSyntax(node) || isVariableDeclarationInitializedToBareOrAccessedRequire(node);
      }
      ts3.isAnyImportOrBareOrAccessedRequire = isAnyImportOrBareOrAccessedRequire;
      function isLateVisibilityPaintedStatement(node) {
        switch (node.kind) {
          case 266:
          case 265:
          case 237:
          case 257:
          case 256:
          case 261:
          case 259:
          case 258:
          case 260:
            return true;
          default:
            return false;
        }
      }
      ts3.isLateVisibilityPaintedStatement = isLateVisibilityPaintedStatement;
      function hasPossibleExternalModuleReference(node) {
        return isAnyImportOrReExport(node) || ts3.isModuleDeclaration(node) || ts3.isImportTypeNode(node) || isImportCall(node);
      }
      ts3.hasPossibleExternalModuleReference = hasPossibleExternalModuleReference;
      function isAnyImportOrReExport(node) {
        return isAnyImportSyntax(node) || ts3.isExportDeclaration(node);
      }
      ts3.isAnyImportOrReExport = isAnyImportOrReExport;
      function getEnclosingBlockScopeContainer(node) {
        return ts3.findAncestor(node.parent, function(current) {
          return isBlockScope(current, current.parent);
        });
      }
      ts3.getEnclosingBlockScopeContainer = getEnclosingBlockScopeContainer;
      function forEachEnclosingBlockScopeContainer(node, cb) {
        var container = getEnclosingBlockScopeContainer(node);
        while (container) {
          cb(container);
          container = getEnclosingBlockScopeContainer(container);
        }
      }
      ts3.forEachEnclosingBlockScopeContainer = forEachEnclosingBlockScopeContainer;
      function declarationNameToString(name) {
        return !name || getFullWidth(name) === 0 ? "(Missing)" : getTextOfNode(name);
      }
      ts3.declarationNameToString = declarationNameToString;
      function getNameFromIndexInfo(info) {
        return info.declaration ? declarationNameToString(info.declaration.parameters[0].name) : void 0;
      }
      ts3.getNameFromIndexInfo = getNameFromIndexInfo;
      function isComputedNonLiteralName(name) {
        return name.kind === 162 && !isStringOrNumericLiteralLike(name.expression);
      }
      ts3.isComputedNonLiteralName = isComputedNonLiteralName;
      function tryGetTextOfPropertyName(name) {
        switch (name.kind) {
          case 79:
          case 80:
            return name.escapedText;
          case 10:
          case 8:
          case 14:
            return ts3.escapeLeadingUnderscores(name.text);
          case 162:
            if (isStringOrNumericLiteralLike(name.expression))
              return ts3.escapeLeadingUnderscores(name.expression.text);
            return void 0;
          default:
            return ts3.Debug.assertNever(name);
        }
      }
      ts3.tryGetTextOfPropertyName = tryGetTextOfPropertyName;
      function getTextOfPropertyName(name) {
        return ts3.Debug.checkDefined(tryGetTextOfPropertyName(name));
      }
      ts3.getTextOfPropertyName = getTextOfPropertyName;
      function entityNameToString(name) {
        switch (name.kind) {
          case 108:
            return "this";
          case 80:
          case 79:
            return getFullWidth(name) === 0 ? ts3.idText(name) : getTextOfNode(name);
          case 161:
            return entityNameToString(name.left) + "." + entityNameToString(name.right);
          case 206:
            if (ts3.isIdentifier(name.name) || ts3.isPrivateIdentifier(name.name)) {
              return entityNameToString(name.expression) + "." + entityNameToString(name.name);
            } else {
              return ts3.Debug.assertNever(name.name);
            }
          case 311:
            return entityNameToString(name.left) + entityNameToString(name.right);
          default:
            return ts3.Debug.assertNever(name);
        }
      }
      ts3.entityNameToString = entityNameToString;
      function createDiagnosticForNode(node, message, arg0, arg1, arg2, arg3) {
        var sourceFile = getSourceFileOfNode(node);
        return createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2, arg3);
      }
      ts3.createDiagnosticForNode = createDiagnosticForNode;
      function createDiagnosticForNodeArray(sourceFile, nodes, message, arg0, arg1, arg2, arg3) {
        var start = ts3.skipTrivia(sourceFile.text, nodes.pos);
        return createFileDiagnostic(sourceFile, start, nodes.end - start, message, arg0, arg1, arg2, arg3);
      }
      ts3.createDiagnosticForNodeArray = createDiagnosticForNodeArray;
      function createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2, arg3) {
        var span = getErrorSpanForNode(sourceFile, node);
        return createFileDiagnostic(sourceFile, span.start, span.length, message, arg0, arg1, arg2, arg3);
      }
      ts3.createDiagnosticForNodeInSourceFile = createDiagnosticForNodeInSourceFile;
      function createDiagnosticForNodeFromMessageChain(node, messageChain, relatedInformation) {
        var sourceFile = getSourceFileOfNode(node);
        var span = getErrorSpanForNode(sourceFile, node);
        return createFileDiagnosticFromMessageChain(sourceFile, span.start, span.length, messageChain, relatedInformation);
      }
      ts3.createDiagnosticForNodeFromMessageChain = createDiagnosticForNodeFromMessageChain;
      function assertDiagnosticLocation(file, start, length) {
        ts3.Debug.assertGreaterThanOrEqual(start, 0);
        ts3.Debug.assertGreaterThanOrEqual(length, 0);
        if (file) {
          ts3.Debug.assertLessThanOrEqual(start, file.text.length);
          ts3.Debug.assertLessThanOrEqual(start + length, file.text.length);
        }
      }
      function createFileDiagnosticFromMessageChain(file, start, length, messageChain, relatedInformation) {
        assertDiagnosticLocation(file, start, length);
        return {
          file,
          start,
          length,
          code: messageChain.code,
          category: messageChain.category,
          messageText: messageChain.next ? messageChain : messageChain.messageText,
          relatedInformation
        };
      }
      ts3.createFileDiagnosticFromMessageChain = createFileDiagnosticFromMessageChain;
      function createDiagnosticForFileFromMessageChain(sourceFile, messageChain, relatedInformation) {
        return {
          file: sourceFile,
          start: 0,
          length: 0,
          code: messageChain.code,
          category: messageChain.category,
          messageText: messageChain.next ? messageChain : messageChain.messageText,
          relatedInformation
        };
      }
      ts3.createDiagnosticForFileFromMessageChain = createDiagnosticForFileFromMessageChain;
      function createDiagnosticMessageChainFromDiagnostic(diagnostic) {
        return typeof diagnostic.messageText === "string" ? {
          code: diagnostic.code,
          category: diagnostic.category,
          messageText: diagnostic.messageText,
          next: diagnostic.next
        } : diagnostic.messageText;
      }
      ts3.createDiagnosticMessageChainFromDiagnostic = createDiagnosticMessageChainFromDiagnostic;
      function createDiagnosticForRange(sourceFile, range, message) {
        return {
          file: sourceFile,
          start: range.pos,
          length: range.end - range.pos,
          code: message.code,
          category: message.category,
          messageText: message.message
        };
      }
      ts3.createDiagnosticForRange = createDiagnosticForRange;
      function getSpanOfTokenAtPosition(sourceFile, pos) {
        var scanner = ts3.createScanner(sourceFile.languageVersion, true, sourceFile.languageVariant, sourceFile.text, void 0, pos);
        scanner.scan();
        var start = scanner.getTokenPos();
        return ts3.createTextSpanFromBounds(start, scanner.getTextPos());
      }
      ts3.getSpanOfTokenAtPosition = getSpanOfTokenAtPosition;
      function getErrorSpanForArrowFunction(sourceFile, node) {
        var pos = ts3.skipTrivia(sourceFile.text, node.pos);
        if (node.body && node.body.kind === 235) {
          var startLine = ts3.getLineAndCharacterOfPosition(sourceFile, node.body.pos).line;
          var endLine = ts3.getLineAndCharacterOfPosition(sourceFile, node.body.end).line;
          if (startLine < endLine) {
            return ts3.createTextSpan(pos, getEndLinePosition(startLine, sourceFile) - pos + 1);
          }
        }
        return ts3.createTextSpanFromBounds(pos, node.end);
      }
      function getErrorSpanForNode(sourceFile, node) {
        var errorNode = node;
        switch (node.kind) {
          case 305:
            var pos_1 = ts3.skipTrivia(sourceFile.text, 0, false);
            if (pos_1 === sourceFile.text.length) {
              return ts3.createTextSpan(0, 0);
            }
            return getSpanOfTokenAtPosition(sourceFile, pos_1);
          case 254:
          case 203:
          case 257:
          case 226:
          case 258:
          case 261:
          case 260:
          case 299:
          case 256:
          case 213:
          case 169:
          case 172:
          case 173:
          case 259:
          case 167:
          case 166:
          case 268:
            errorNode = node.name;
            break;
          case 214:
            return getErrorSpanForArrowFunction(sourceFile, node);
          case 289:
          case 290:
            var start = ts3.skipTrivia(sourceFile.text, node.pos);
            var end = node.statements.length > 0 ? node.statements[0].pos : node.end;
            return ts3.createTextSpanFromBounds(start, end);
        }
        if (errorNode === void 0) {
          return getSpanOfTokenAtPosition(sourceFile, node.pos);
        }
        ts3.Debug.assert(!ts3.isJSDoc(errorNode));
        var isMissing = nodeIsMissing(errorNode);
        var pos = isMissing || ts3.isJsxText(node) ? errorNode.pos : ts3.skipTrivia(sourceFile.text, errorNode.pos);
        if (isMissing) {
          ts3.Debug.assert(pos === errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
          ts3.Debug.assert(pos === errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
        } else {
          ts3.Debug.assert(pos >= errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
          ts3.Debug.assert(pos <= errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
        }
        return ts3.createTextSpanFromBounds(pos, errorNode.end);
      }
      ts3.getErrorSpanForNode = getErrorSpanForNode;
      function isExternalOrCommonJsModule(file) {
        return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== void 0;
      }
      ts3.isExternalOrCommonJsModule = isExternalOrCommonJsModule;
      function isJsonSourceFile(file) {
        return file.scriptKind === 6;
      }
      ts3.isJsonSourceFile = isJsonSourceFile;
      function isEnumConst(node) {
        return !!(ts3.getCombinedModifierFlags(node) & 2048);
      }
      ts3.isEnumConst = isEnumConst;
      function isDeclarationReadonly(declaration) {
        return !!(ts3.getCombinedModifierFlags(declaration) & 64 && !ts3.isParameterPropertyDeclaration(declaration, declaration.parent));
      }
      ts3.isDeclarationReadonly = isDeclarationReadonly;
      function isVarConst(node) {
        return !!(ts3.getCombinedNodeFlags(node) & 2);
      }
      ts3.isVarConst = isVarConst;
      function isLet(node) {
        return !!(ts3.getCombinedNodeFlags(node) & 1);
      }
      ts3.isLet = isLet;
      function isSuperCall(n) {
        return n.kind === 208 && n.expression.kind === 106;
      }
      ts3.isSuperCall = isSuperCall;
      function isImportCall(n) {
        return n.kind === 208 && n.expression.kind === 100;
      }
      ts3.isImportCall = isImportCall;
      function isImportMeta(n) {
        return ts3.isMetaProperty(n) && n.keywordToken === 100 && n.name.escapedText === "meta";
      }
      ts3.isImportMeta = isImportMeta;
      function isLiteralImportTypeNode(n) {
        return ts3.isImportTypeNode(n) && ts3.isLiteralTypeNode(n.argument) && ts3.isStringLiteral(n.argument.literal);
      }
      ts3.isLiteralImportTypeNode = isLiteralImportTypeNode;
      function isPrologueDirective(node) {
        return node.kind === 238 && node.expression.kind === 10;
      }
      ts3.isPrologueDirective = isPrologueDirective;
      function isCustomPrologue(node) {
        return !!(getEmitFlags(node) & 1048576);
      }
      ts3.isCustomPrologue = isCustomPrologue;
      function isHoistedFunction(node) {
        return isCustomPrologue(node) && ts3.isFunctionDeclaration(node);
      }
      ts3.isHoistedFunction = isHoistedFunction;
      function isHoistedVariable(node) {
        return ts3.isIdentifier(node.name) && !node.initializer;
      }
      function isHoistedVariableStatement(node) {
        return isCustomPrologue(node) && ts3.isVariableStatement(node) && ts3.every(node.declarationList.declarations, isHoistedVariable);
      }
      ts3.isHoistedVariableStatement = isHoistedVariableStatement;
      function getLeadingCommentRangesOfNode(node, sourceFileOfNode) {
        return node.kind !== 11 ? ts3.getLeadingCommentRanges(sourceFileOfNode.text, node.pos) : void 0;
      }
      ts3.getLeadingCommentRangesOfNode = getLeadingCommentRangesOfNode;
      function getJSDocCommentRanges(node, text) {
        var commentRanges = node.kind === 164 || node.kind === 163 || node.kind === 213 || node.kind === 214 || node.kind === 212 || node.kind === 254 || node.kind === 275 ? ts3.concatenate(ts3.getTrailingCommentRanges(text, node.pos), ts3.getLeadingCommentRanges(text, node.pos)) : ts3.getLeadingCommentRanges(text, node.pos);
        return ts3.filter(commentRanges, function(comment) {
          return text.charCodeAt(comment.pos + 1) === 42 && text.charCodeAt(comment.pos + 2) === 42 && text.charCodeAt(comment.pos + 3) !== 47;
        });
      }
      ts3.getJSDocCommentRanges = getJSDocCommentRanges;
      ts3.fullTripleSlashReferencePathRegEx = /^(\/\/\/\s*<reference\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
      var fullTripleSlashReferenceTypeReferenceDirectiveRegEx = /^(\/\/\/\s*<reference\s+types\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
      ts3.fullTripleSlashAMDReferencePathRegEx = /^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
      var defaultLibReferenceRegEx = /^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)(('[^']*')|("[^"]*"))\s*\/>/;
      function isPartOfTypeNode(node) {
        if (177 <= node.kind && node.kind <= 200) {
          return true;
        }
        switch (node.kind) {
          case 130:
          case 155:
          case 147:
          case 158:
          case 150:
          case 133:
          case 151:
          case 148:
          case 153:
          case 143:
            return true;
          case 114:
            return node.parent.kind !== 217;
          case 228:
            return ts3.isHeritageClause(node.parent) && !isExpressionWithTypeArgumentsInClassExtendsClause(node);
          case 163:
            return node.parent.kind === 195 || node.parent.kind === 190;
          case 79:
            if (node.parent.kind === 161 && node.parent.right === node) {
              node = node.parent;
            } else if (node.parent.kind === 206 && node.parent.name === node) {
              node = node.parent;
            }
            ts3.Debug.assert(node.kind === 79 || node.kind === 161 || node.kind === 206, "'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");
          case 161:
          case 206:
          case 108: {
            var parent = node.parent;
            if (parent.kind === 181) {
              return false;
            }
            if (parent.kind === 200) {
              return !parent.isTypeOf;
            }
            if (177 <= parent.kind && parent.kind <= 200) {
              return true;
            }
            switch (parent.kind) {
              case 228:
                return ts3.isHeritageClause(parent.parent) && !isExpressionWithTypeArgumentsInClassExtendsClause(parent);
              case 163:
                return node === parent.constraint;
              case 344:
                return node === parent.constraint;
              case 167:
              case 166:
              case 164:
              case 254:
                return node === parent.type;
              case 256:
              case 213:
              case 214:
              case 171:
              case 169:
              case 168:
              case 172:
              case 173:
                return node === parent.type;
              case 174:
              case 175:
              case 176:
                return node === parent.type;
              case 211:
                return node === parent.type;
              case 208:
              case 209:
                return ts3.contains(parent.typeArguments, node);
              case 210:
                return false;
            }
          }
        }
        return false;
      }
      ts3.isPartOfTypeNode = isPartOfTypeNode;
      function isChildOfNodeWithKind(node, kind) {
        while (node) {
          if (node.kind === kind) {
            return true;
          }
          node = node.parent;
        }
        return false;
      }
      ts3.isChildOfNodeWithKind = isChildOfNodeWithKind;
      function forEachReturnStatement(body, visitor) {
        return traverse(body);
        function traverse(node) {
          switch (node.kind) {
            case 247:
              return visitor(node);
            case 263:
            case 235:
            case 239:
            case 240:
            case 241:
            case 242:
            case 243:
            case 244:
            case 248:
            case 249:
            case 289:
            case 290:
            case 250:
            case 252:
            case 292:
              return ts3.forEachChild(node, traverse);
          }
        }
      }
      ts3.forEachReturnStatement = forEachReturnStatement;
      function forEachYieldExpression(body, visitor) {
        return traverse(body);
        function traverse(node) {
          switch (node.kind) {
            case 224:
              visitor(node);
              var operand = node.expression;
              if (operand) {
                traverse(operand);
              }
              return;
            case 260:
            case 258:
            case 261:
            case 259:
              return;
            default:
              if (ts3.isFunctionLike(node)) {
                if (node.name && node.name.kind === 162) {
                  traverse(node.name.expression);
                  return;
                }
              } else if (!isPartOfTypeNode(node)) {
                ts3.forEachChild(node, traverse);
              }
          }
        }
      }
      ts3.forEachYieldExpression = forEachYieldExpression;
      function getRestParameterElementType(node) {
        if (node && node.kind === 183) {
          return node.elementType;
        } else if (node && node.kind === 178) {
          return ts3.singleOrUndefined(node.typeArguments);
        } else {
          return void 0;
        }
      }
      ts3.getRestParameterElementType = getRestParameterElementType;
      function getMembersOfDeclaration(node) {
        switch (node.kind) {
          case 258:
          case 257:
          case 226:
          case 182:
            return node.members;
          case 205:
            return node.properties;
        }
      }
      ts3.getMembersOfDeclaration = getMembersOfDeclaration;
      function isVariableLike(node) {
        if (node) {
          switch (node.kind) {
            case 203:
            case 299:
            case 164:
            case 296:
            case 167:
            case 166:
            case 297:
            case 254:
              return true;
          }
        }
        return false;
      }
      ts3.isVariableLike = isVariableLike;
      function isVariableLikeOrAccessor(node) {
        return isVariableLike(node) || ts3.isAccessor(node);
      }
      ts3.isVariableLikeOrAccessor = isVariableLikeOrAccessor;
      function isVariableDeclarationInVariableStatement(node) {
        return node.parent.kind === 255 && node.parent.parent.kind === 237;
      }
      ts3.isVariableDeclarationInVariableStatement = isVariableDeclarationInVariableStatement;
      function isCommonJsExportedExpression(node) {
        if (!isInJSFile(node))
          return false;
        return ts3.isObjectLiteralExpression(node.parent) && ts3.isBinaryExpression(node.parent.parent) && getAssignmentDeclarationKind(node.parent.parent) === 2 || isCommonJsExportPropertyAssignment(node.parent);
      }
      ts3.isCommonJsExportedExpression = isCommonJsExportedExpression;
      function isCommonJsExportPropertyAssignment(node) {
        if (!isInJSFile(node))
          return false;
        return ts3.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 1;
      }
      ts3.isCommonJsExportPropertyAssignment = isCommonJsExportPropertyAssignment;
      function isValidESSymbolDeclaration(node) {
        return (ts3.isVariableDeclaration(node) ? isVarConst(node) && ts3.isIdentifier(node.name) && isVariableDeclarationInVariableStatement(node) : ts3.isPropertyDeclaration(node) ? hasEffectiveReadonlyModifier(node) && hasStaticModifier(node) : ts3.isPropertySignature(node) && hasEffectiveReadonlyModifier(node)) || isCommonJsExportPropertyAssignment(node);
      }
      ts3.isValidESSymbolDeclaration = isValidESSymbolDeclaration;
      function introducesArgumentsExoticObject(node) {
        switch (node.kind) {
          case 169:
          case 168:
          case 171:
          case 172:
          case 173:
          case 256:
          case 213:
            return true;
        }
        return false;
      }
      ts3.introducesArgumentsExoticObject = introducesArgumentsExoticObject;
      function unwrapInnermostStatementOfLabel(node, beforeUnwrapLabelCallback) {
        while (true) {
          if (beforeUnwrapLabelCallback) {
            beforeUnwrapLabelCallback(node);
          }
          if (node.statement.kind !== 250) {
            return node.statement;
          }
          node = node.statement;
        }
      }
      ts3.unwrapInnermostStatementOfLabel = unwrapInnermostStatementOfLabel;
      function isFunctionBlock(node) {
        return node && node.kind === 235 && ts3.isFunctionLike(node.parent);
      }
      ts3.isFunctionBlock = isFunctionBlock;
      function isObjectLiteralMethod(node) {
        return node && node.kind === 169 && node.parent.kind === 205;
      }
      ts3.isObjectLiteralMethod = isObjectLiteralMethod;
      function isObjectLiteralOrClassExpressionMethodOrAccessor(node) {
        return (node.kind === 169 || node.kind === 172 || node.kind === 173) && (node.parent.kind === 205 || node.parent.kind === 226);
      }
      ts3.isObjectLiteralOrClassExpressionMethodOrAccessor = isObjectLiteralOrClassExpressionMethodOrAccessor;
      function isIdentifierTypePredicate(predicate) {
        return predicate && predicate.kind === 1;
      }
      ts3.isIdentifierTypePredicate = isIdentifierTypePredicate;
      function isThisTypePredicate(predicate) {
        return predicate && predicate.kind === 0;
      }
      ts3.isThisTypePredicate = isThisTypePredicate;
      function getPropertyAssignment(objectLiteral, key, key2) {
        return objectLiteral.properties.filter(function(property) {
          if (property.kind === 296) {
            var propName = tryGetTextOfPropertyName(property.name);
            return key === propName || !!key2 && key2 === propName;
          }
          return false;
        });
      }
      ts3.getPropertyAssignment = getPropertyAssignment;
      function getPropertyArrayElementValue(objectLiteral, propKey, elementValue) {
        return ts3.firstDefined(getPropertyAssignment(objectLiteral, propKey), function(property) {
          return ts3.isArrayLiteralExpression(property.initializer) ? ts3.find(property.initializer.elements, function(element) {
            return ts3.isStringLiteral(element) && element.text === elementValue;
          }) : void 0;
        });
      }
      ts3.getPropertyArrayElementValue = getPropertyArrayElementValue;
      function getTsConfigObjectLiteralExpression(tsConfigSourceFile) {
        if (tsConfigSourceFile && tsConfigSourceFile.statements.length) {
          var expression = tsConfigSourceFile.statements[0].expression;
          return ts3.tryCast(expression, ts3.isObjectLiteralExpression);
        }
      }
      ts3.getTsConfigObjectLiteralExpression = getTsConfigObjectLiteralExpression;
      function getTsConfigPropArrayElementValue(tsConfigSourceFile, propKey, elementValue) {
        return ts3.firstDefined(getTsConfigPropArray(tsConfigSourceFile, propKey), function(property) {
          return ts3.isArrayLiteralExpression(property.initializer) ? ts3.find(property.initializer.elements, function(element) {
            return ts3.isStringLiteral(element) && element.text === elementValue;
          }) : void 0;
        });
      }
      ts3.getTsConfigPropArrayElementValue = getTsConfigPropArrayElementValue;
      function getTsConfigPropArray(tsConfigSourceFile, propKey) {
        var jsonObjectLiteral = getTsConfigObjectLiteralExpression(tsConfigSourceFile);
        return jsonObjectLiteral ? getPropertyAssignment(jsonObjectLiteral, propKey) : ts3.emptyArray;
      }
      ts3.getTsConfigPropArray = getTsConfigPropArray;
      function getContainingFunction(node) {
        return ts3.findAncestor(node.parent, ts3.isFunctionLike);
      }
      ts3.getContainingFunction = getContainingFunction;
      function getContainingFunctionDeclaration(node) {
        return ts3.findAncestor(node.parent, ts3.isFunctionLikeDeclaration);
      }
      ts3.getContainingFunctionDeclaration = getContainingFunctionDeclaration;
      function getContainingClass(node) {
        return ts3.findAncestor(node.parent, ts3.isClassLike);
      }
      ts3.getContainingClass = getContainingClass;
      function getContainingClassStaticBlock(node) {
        return ts3.findAncestor(node.parent, function(n) {
          if (ts3.isClassLike(n) || ts3.isFunctionLike(n)) {
            return "quit";
          }
          return ts3.isClassStaticBlockDeclaration(n);
        });
      }
      ts3.getContainingClassStaticBlock = getContainingClassStaticBlock;
      function getContainingFunctionOrClassStaticBlock(node) {
        return ts3.findAncestor(node.parent, ts3.isFunctionLikeOrClassStaticBlockDeclaration);
      }
      ts3.getContainingFunctionOrClassStaticBlock = getContainingFunctionOrClassStaticBlock;
      function getThisContainer(node, includeArrowFunctions) {
        ts3.Debug.assert(node.kind !== 305);
        while (true) {
          node = node.parent;
          if (!node) {
            return ts3.Debug.fail();
          }
          switch (node.kind) {
            case 162:
              if (ts3.isClassLike(node.parent.parent)) {
                return node;
              }
              node = node.parent;
              break;
            case 165:
              if (node.parent.kind === 164 && ts3.isClassElement(node.parent.parent)) {
                node = node.parent.parent;
              } else if (ts3.isClassElement(node.parent)) {
                node = node.parent;
              }
              break;
            case 214:
              if (!includeArrowFunctions) {
                continue;
              }
            case 256:
            case 213:
            case 261:
            case 170:
            case 167:
            case 166:
            case 169:
            case 168:
            case 171:
            case 172:
            case 173:
            case 174:
            case 175:
            case 176:
            case 260:
            case 305:
              return node;
          }
        }
      }
      ts3.getThisContainer = getThisContainer;
      function isThisContainerOrFunctionBlock(node) {
        switch (node.kind) {
          case 214:
          case 256:
          case 213:
          case 167:
            return true;
          case 235:
            switch (node.parent.kind) {
              case 171:
              case 169:
              case 172:
              case 173:
                return true;
              default:
                return false;
            }
          default:
            return false;
        }
      }
      ts3.isThisContainerOrFunctionBlock = isThisContainerOrFunctionBlock;
      function isInTopLevelContext(node) {
        if (ts3.isIdentifier(node) && (ts3.isClassDeclaration(node.parent) || ts3.isFunctionDeclaration(node.parent)) && node.parent.name === node) {
          node = node.parent;
        }
        var container = getThisContainer(node, true);
        return ts3.isSourceFile(container);
      }
      ts3.isInTopLevelContext = isInTopLevelContext;
      function getNewTargetContainer(node) {
        var container = getThisContainer(node, false);
        if (container) {
          switch (container.kind) {
            case 171:
            case 256:
            case 213:
              return container;
          }
        }
        return void 0;
      }
      ts3.getNewTargetContainer = getNewTargetContainer;
      function getSuperContainer(node, stopOnFunctions) {
        while (true) {
          node = node.parent;
          if (!node) {
            return node;
          }
          switch (node.kind) {
            case 162:
              node = node.parent;
              break;
            case 256:
            case 213:
            case 214:
              if (!stopOnFunctions) {
                continue;
              }
            case 167:
            case 166:
            case 169:
            case 168:
            case 171:
            case 172:
            case 173:
            case 170:
              return node;
            case 165:
              if (node.parent.kind === 164 && ts3.isClassElement(node.parent.parent)) {
                node = node.parent.parent;
              } else if (ts3.isClassElement(node.parent)) {
                node = node.parent;
              }
              break;
          }
        }
      }
      ts3.getSuperContainer = getSuperContainer;
      function getImmediatelyInvokedFunctionExpression(func) {
        if (func.kind === 213 || func.kind === 214) {
          var prev = func;
          var parent = func.parent;
          while (parent.kind === 212) {
            prev = parent;
            parent = parent.parent;
          }
          if (parent.kind === 208 && parent.expression === prev) {
            return parent;
          }
        }
      }
      ts3.getImmediatelyInvokedFunctionExpression = getImmediatelyInvokedFunctionExpression;
      function isSuperOrSuperProperty(node) {
        return node.kind === 106 || isSuperProperty(node);
      }
      ts3.isSuperOrSuperProperty = isSuperOrSuperProperty;
      function isSuperProperty(node) {
        var kind = node.kind;
        return (kind === 206 || kind === 207) && node.expression.kind === 106;
      }
      ts3.isSuperProperty = isSuperProperty;
      function isThisProperty(node) {
        var kind = node.kind;
        return (kind === 206 || kind === 207) && node.expression.kind === 108;
      }
      ts3.isThisProperty = isThisProperty;
      function isThisInitializedDeclaration(node) {
        var _a;
        return !!node && ts3.isVariableDeclaration(node) && ((_a = node.initializer) === null || _a === void 0 ? void 0 : _a.kind) === 108;
      }
      ts3.isThisInitializedDeclaration = isThisInitializedDeclaration;
      function isThisInitializedObjectBindingExpression(node) {
        return !!node && (ts3.isShorthandPropertyAssignment(node) || ts3.isPropertyAssignment(node)) && ts3.isBinaryExpression(node.parent.parent) && node.parent.parent.operatorToken.kind === 63 && node.parent.parent.right.kind === 108;
      }
      ts3.isThisInitializedObjectBindingExpression = isThisInitializedObjectBindingExpression;
      function getEntityNameFromTypeNode(node) {
        switch (node.kind) {
          case 178:
            return node.typeName;
          case 228:
            return isEntityNameExpression(node.expression) ? node.expression : void 0;
          case 79:
          case 161:
            return node;
        }
        return void 0;
      }
      ts3.getEntityNameFromTypeNode = getEntityNameFromTypeNode;
      function getInvokedExpression(node) {
        switch (node.kind) {
          case 210:
            return node.tag;
          case 280:
          case 279:
            return node.tagName;
          default:
            return node.expression;
        }
      }
      ts3.getInvokedExpression = getInvokedExpression;
      function nodeCanBeDecorated(node, parent, grandparent) {
        if (ts3.isNamedDeclaration(node) && ts3.isPrivateIdentifier(node.name)) {
          return false;
        }
        switch (node.kind) {
          case 257:
            return true;
          case 167:
            return parent.kind === 257;
          case 172:
          case 173:
          case 169:
            return node.body !== void 0 && parent.kind === 257;
          case 164:
            return parent.body !== void 0 && (parent.kind === 171 || parent.kind === 169 || parent.kind === 173) && grandparent.kind === 257;
        }
        return false;
      }
      ts3.nodeCanBeDecorated = nodeCanBeDecorated;
      function nodeIsDecorated(node, parent, grandparent) {
        return node.decorators !== void 0 && nodeCanBeDecorated(node, parent, grandparent);
      }
      ts3.nodeIsDecorated = nodeIsDecorated;
      function nodeOrChildIsDecorated(node, parent, grandparent) {
        return nodeIsDecorated(node, parent, grandparent) || childIsDecorated(node, parent);
      }
      ts3.nodeOrChildIsDecorated = nodeOrChildIsDecorated;
      function childIsDecorated(node, parent) {
        switch (node.kind) {
          case 257:
            return ts3.some(node.members, function(m) {
              return nodeOrChildIsDecorated(m, node, parent);
            });
          case 169:
          case 173:
          case 171:
            return ts3.some(node.parameters, function(p) {
              return nodeIsDecorated(p, node, parent);
            });
          default:
            return false;
        }
      }
      ts3.childIsDecorated = childIsDecorated;
      function classOrConstructorParameterIsDecorated(node) {
        if (nodeIsDecorated(node))
          return true;
        var constructor = getFirstConstructorWithBody(node);
        return !!constructor && childIsDecorated(constructor, node);
      }
      ts3.classOrConstructorParameterIsDecorated = classOrConstructorParameterIsDecorated;
      function isJSXTagName(node) {
        var parent = node.parent;
        if (parent.kind === 280 || parent.kind === 279 || parent.kind === 281) {
          return parent.tagName === node;
        }
        return false;
      }
      ts3.isJSXTagName = isJSXTagName;
      function isExpressionNode(node) {
        switch (node.kind) {
          case 106:
          case 104:
          case 110:
          case 95:
          case 13:
          case 204:
          case 205:
          case 206:
          case 207:
          case 208:
          case 209:
          case 210:
          case 229:
          case 211:
          case 230:
          case 212:
          case 213:
          case 226:
          case 214:
          case 217:
          case 215:
          case 216:
          case 219:
          case 220:
          case 221:
          case 222:
          case 225:
          case 223:
          case 227:
          case 278:
          case 279:
          case 282:
          case 224:
          case 218:
          case 231:
            return true;
          case 228:
            return !ts3.isHeritageClause(node.parent);
          case 161:
            while (node.parent.kind === 161) {
              node = node.parent;
            }
            return node.parent.kind === 181 || ts3.isJSDocLinkLike(node.parent) || ts3.isJSDocNameReference(node.parent) || ts3.isJSDocMemberName(node.parent) || isJSXTagName(node);
          case 311:
            while (ts3.isJSDocMemberName(node.parent)) {
              node = node.parent;
            }
            return node.parent.kind === 181 || ts3.isJSDocLinkLike(node.parent) || ts3.isJSDocNameReference(node.parent) || ts3.isJSDocMemberName(node.parent) || isJSXTagName(node);
          case 80:
            return ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 101;
          case 79:
            if (node.parent.kind === 181 || ts3.isJSDocLinkLike(node.parent) || ts3.isJSDocNameReference(node.parent) || ts3.isJSDocMemberName(node.parent) || isJSXTagName(node)) {
              return true;
            }
          case 8:
          case 9:
          case 10:
          case 14:
          case 108:
            return isInExpressionContext(node);
          default:
            return false;
        }
      }
      ts3.isExpressionNode = isExpressionNode;
      function isInExpressionContext(node) {
        var parent = node.parent;
        switch (parent.kind) {
          case 254:
          case 164:
          case 167:
          case 166:
          case 299:
          case 296:
          case 203:
            return parent.initializer === node;
          case 238:
          case 239:
          case 240:
          case 241:
          case 247:
          case 248:
          case 249:
          case 289:
          case 251:
            return parent.expression === node;
          case 242:
            var forStatement = parent;
            return forStatement.initializer === node && forStatement.initializer.kind !== 255 || forStatement.condition === node || forStatement.incrementor === node;
          case 243:
          case 244:
            var forInStatement = parent;
            return forInStatement.initializer === node && forInStatement.initializer.kind !== 255 || forInStatement.expression === node;
          case 211:
          case 229:
            return node === parent.expression;
          case 233:
            return node === parent.expression;
          case 162:
            return node === parent.expression;
          case 165:
          case 288:
          case 287:
          case 298:
            return true;
          case 228:
            return parent.expression === node && !isPartOfTypeNode(parent);
          case 297:
            return parent.objectAssignmentInitializer === node;
          default:
            return isExpressionNode(parent);
        }
      }
      ts3.isInExpressionContext = isInExpressionContext;
      function isPartOfTypeQuery(node) {
        while (node.kind === 161 || node.kind === 79) {
          node = node.parent;
        }
        return node.kind === 181;
      }
      ts3.isPartOfTypeQuery = isPartOfTypeQuery;
      function isNamespaceReexportDeclaration(node) {
        return ts3.isNamespaceExport(node) && !!node.parent.moduleSpecifier;
      }
      ts3.isNamespaceReexportDeclaration = isNamespaceReexportDeclaration;
      function isExternalModuleImportEqualsDeclaration(node) {
        return node.kind === 265 && node.moduleReference.kind === 277;
      }
      ts3.isExternalModuleImportEqualsDeclaration = isExternalModuleImportEqualsDeclaration;
      function getExternalModuleImportEqualsDeclarationExpression(node) {
        ts3.Debug.assert(isExternalModuleImportEqualsDeclaration(node));
        return node.moduleReference.expression;
      }
      ts3.getExternalModuleImportEqualsDeclarationExpression = getExternalModuleImportEqualsDeclarationExpression;
      function getExternalModuleRequireArgument(node) {
        return isVariableDeclarationInitializedToBareOrAccessedRequire(node) && getLeftmostAccessExpression(node.initializer).arguments[0];
      }
      ts3.getExternalModuleRequireArgument = getExternalModuleRequireArgument;
      function isInternalModuleImportEqualsDeclaration(node) {
        return node.kind === 265 && node.moduleReference.kind !== 277;
      }
      ts3.isInternalModuleImportEqualsDeclaration = isInternalModuleImportEqualsDeclaration;
      function isSourceFileJS(file) {
        return isInJSFile(file);
      }
      ts3.isSourceFileJS = isSourceFileJS;
      function isSourceFileNotJS(file) {
        return !isInJSFile(file);
      }
      ts3.isSourceFileNotJS = isSourceFileNotJS;
      function isInJSFile(node) {
        return !!node && !!(node.flags & 262144);
      }
      ts3.isInJSFile = isInJSFile;
      function isInJsonFile(node) {
        return !!node && !!(node.flags & 67108864);
      }
      ts3.isInJsonFile = isInJsonFile;
      function isSourceFileNotJson(file) {
        return !isJsonSourceFile(file);
      }
      ts3.isSourceFileNotJson = isSourceFileNotJson;
      function isInJSDoc(node) {
        return !!node && !!(node.flags & 8388608);
      }
      ts3.isInJSDoc = isInJSDoc;
      function isJSDocIndexSignature(node) {
        return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && node.typeArguments && node.typeArguments.length === 2 && (node.typeArguments[0].kind === 150 || node.typeArguments[0].kind === 147);
      }
      ts3.isJSDocIndexSignature = isJSDocIndexSignature;
      function isRequireCall(callExpression, requireStringLiteralLikeArgument) {
        if (callExpression.kind !== 208) {
          return false;
        }
        var _a = callExpression, expression = _a.expression, args = _a.arguments;
        if (expression.kind !== 79 || expression.escapedText !== "require") {
          return false;
        }
        if (args.length !== 1) {
          return false;
        }
        var arg = args[0];
        return !requireStringLiteralLikeArgument || ts3.isStringLiteralLike(arg);
      }
      ts3.isRequireCall = isRequireCall;
      function isVariableDeclarationInitializedToRequire(node) {
        return isVariableDeclarationInitializedWithRequireHelper(node, false);
      }
      ts3.isVariableDeclarationInitializedToRequire = isVariableDeclarationInitializedToRequire;
      function isVariableDeclarationInitializedToBareOrAccessedRequire(node) {
        return isVariableDeclarationInitializedWithRequireHelper(node, true);
      }
      ts3.isVariableDeclarationInitializedToBareOrAccessedRequire = isVariableDeclarationInitializedToBareOrAccessedRequire;
      function isVariableDeclarationInitializedWithRequireHelper(node, allowAccessedRequire) {
        return ts3.isVariableDeclaration(node) && !!node.initializer && isRequireCall(allowAccessedRequire ? getLeftmostAccessExpression(node.initializer) : node.initializer, true);
      }
      function isRequireVariableStatement(node) {
        return ts3.isVariableStatement(node) && node.declarationList.declarations.length > 0 && ts3.every(node.declarationList.declarations, function(decl) {
          return isVariableDeclarationInitializedToRequire(decl);
        });
      }
      ts3.isRequireVariableStatement = isRequireVariableStatement;
      function isSingleOrDoubleQuote(charCode) {
        return charCode === 39 || charCode === 34;
      }
      ts3.isSingleOrDoubleQuote = isSingleOrDoubleQuote;
      function isStringDoubleQuoted(str2, sourceFile) {
        return getSourceTextOfNodeFromSourceFile(sourceFile, str2).charCodeAt(0) === 34;
      }
      ts3.isStringDoubleQuoted = isStringDoubleQuoted;
      function isAssignmentDeclaration(decl) {
        return ts3.isBinaryExpression(decl) || isAccessExpression(decl) || ts3.isIdentifier(decl) || ts3.isCallExpression(decl);
      }
      ts3.isAssignmentDeclaration = isAssignmentDeclaration;
      function getEffectiveInitializer(node) {
        if (isInJSFile(node) && node.initializer && ts3.isBinaryExpression(node.initializer) && (node.initializer.operatorToken.kind === 56 || node.initializer.operatorToken.kind === 60) && node.name && isEntityNameExpression(node.name) && isSameEntityName(node.name, node.initializer.left)) {
          return node.initializer.right;
        }
        return node.initializer;
      }
      ts3.getEffectiveInitializer = getEffectiveInitializer;
      function getDeclaredExpandoInitializer(node) {
        var init = getEffectiveInitializer(node);
        return init && getExpandoInitializer(init, isPrototypeAccess(node.name));
      }
      ts3.getDeclaredExpandoInitializer = getDeclaredExpandoInitializer;
      function hasExpandoValueProperty(node, isPrototypeAssignment) {
        return ts3.forEach(node.properties, function(p) {
          return ts3.isPropertyAssignment(p) && ts3.isIdentifier(p.name) && p.name.escapedText === "value" && p.initializer && getExpandoInitializer(p.initializer, isPrototypeAssignment);
        });
      }
      function getAssignedExpandoInitializer(node) {
        if (node && node.parent && ts3.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 63) {
          var isPrototypeAssignment = isPrototypeAccess(node.parent.left);
          return getExpandoInitializer(node.parent.right, isPrototypeAssignment) || getDefaultedExpandoInitializer(node.parent.left, node.parent.right, isPrototypeAssignment);
        }
        if (node && ts3.isCallExpression(node) && isBindableObjectDefinePropertyCall(node)) {
          var result2 = hasExpandoValueProperty(node.arguments[2], node.arguments[1].text === "prototype");
          if (result2) {
            return result2;
          }
        }
      }
      ts3.getAssignedExpandoInitializer = getAssignedExpandoInitializer;
      function getExpandoInitializer(initializer, isPrototypeAssignment) {
        if (ts3.isCallExpression(initializer)) {
          var e = skipParentheses(initializer.expression);
          return e.kind === 213 || e.kind === 214 ? initializer : void 0;
        }
        if (initializer.kind === 213 || initializer.kind === 226 || initializer.kind === 214) {
          return initializer;
        }
        if (ts3.isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || isPrototypeAssignment)) {
          return initializer;
        }
      }
      ts3.getExpandoInitializer = getExpandoInitializer;
      function getDefaultedExpandoInitializer(name, initializer, isPrototypeAssignment) {
        var e = ts3.isBinaryExpression(initializer) && (initializer.operatorToken.kind === 56 || initializer.operatorToken.kind === 60) && getExpandoInitializer(initializer.right, isPrototypeAssignment);
        if (e && isSameEntityName(name, initializer.left)) {
          return e;
        }
      }
      function isDefaultedExpandoInitializer(node) {
        var name = ts3.isVariableDeclaration(node.parent) ? node.parent.name : ts3.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 63 ? node.parent.left : void 0;
        return name && getExpandoInitializer(node.right, isPrototypeAccess(name)) && isEntityNameExpression(name) && isSameEntityName(name, node.left);
      }
      ts3.isDefaultedExpandoInitializer = isDefaultedExpandoInitializer;
      function getNameOfExpando(node) {
        if (ts3.isBinaryExpression(node.parent)) {
          var parent = (node.parent.operatorToken.kind === 56 || node.parent.operatorToken.kind === 60) && ts3.isBinaryExpression(node.parent.parent) ? node.parent.parent : node.parent;
          if (parent.operatorToken.kind === 63 && ts3.isIdentifier(parent.left)) {
            return parent.left;
          }
        } else if (ts3.isVariableDeclaration(node.parent)) {
          return node.parent.name;
        }
      }
      ts3.getNameOfExpando = getNameOfExpando;
      function isSameEntityName(name, initializer) {
        if (isPropertyNameLiteral(name) && isPropertyNameLiteral(initializer)) {
          return getTextOfIdentifierOrLiteral(name) === getTextOfIdentifierOrLiteral(initializer);
        }
        if (ts3.isMemberName(name) && isLiteralLikeAccess(initializer) && (initializer.expression.kind === 108 || ts3.isIdentifier(initializer.expression) && (initializer.expression.escapedText === "window" || initializer.expression.escapedText === "self" || initializer.expression.escapedText === "global"))) {
          return isSameEntityName(name, getNameOrArgument(initializer));
        }
        if (isLiteralLikeAccess(name) && isLiteralLikeAccess(initializer)) {
          return getElementOrPropertyAccessName(name) === getElementOrPropertyAccessName(initializer) && isSameEntityName(name.expression, initializer.expression);
        }
        return false;
      }
      ts3.isSameEntityName = isSameEntityName;
      function getRightMostAssignedExpression(node) {
        while (isAssignmentExpression(node, true)) {
          node = node.right;
        }
        return node;
      }
      ts3.getRightMostAssignedExpression = getRightMostAssignedExpression;
      function isExportsIdentifier(node) {
        return ts3.isIdentifier(node) && node.escapedText === "exports";
      }
      ts3.isExportsIdentifier = isExportsIdentifier;
      function isModuleIdentifier(node) {
        return ts3.isIdentifier(node) && node.escapedText === "module";
      }
      ts3.isModuleIdentifier = isModuleIdentifier;
      function isModuleExportsAccessExpression(node) {
        return (ts3.isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node)) && isModuleIdentifier(node.expression) && getElementOrPropertyAccessName(node) === "exports";
      }
      ts3.isModuleExportsAccessExpression = isModuleExportsAccessExpression;
      function getAssignmentDeclarationKind(expr) {
        var special = getAssignmentDeclarationKindWorker(expr);
        return special === 5 || isInJSFile(expr) ? special : 0;
      }
      ts3.getAssignmentDeclarationKind = getAssignmentDeclarationKind;
      function isBindableObjectDefinePropertyCall(expr) {
        return ts3.length(expr.arguments) === 3 && ts3.isPropertyAccessExpression(expr.expression) && ts3.isIdentifier(expr.expression.expression) && ts3.idText(expr.expression.expression) === "Object" && ts3.idText(expr.expression.name) === "defineProperty" && isStringOrNumericLiteralLike(expr.arguments[1]) && isBindableStaticNameExpression(expr.arguments[0], true);
      }
      ts3.isBindableObjectDefinePropertyCall = isBindableObjectDefinePropertyCall;
      function isLiteralLikeAccess(node) {
        return ts3.isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node);
      }
      ts3.isLiteralLikeAccess = isLiteralLikeAccess;
      function isLiteralLikeElementAccess(node) {
        return ts3.isElementAccessExpression(node) && isStringOrNumericLiteralLike(node.argumentExpression);
      }
      ts3.isLiteralLikeElementAccess = isLiteralLikeElementAccess;
      function isBindableStaticAccessExpression(node, excludeThisKeyword) {
        return ts3.isPropertyAccessExpression(node) && (!excludeThisKeyword && node.expression.kind === 108 || ts3.isIdentifier(node.name) && isBindableStaticNameExpression(node.expression, true)) || isBindableStaticElementAccessExpression(node, excludeThisKeyword);
      }
      ts3.isBindableStaticAccessExpression = isBindableStaticAccessExpression;
      function isBindableStaticElementAccessExpression(node, excludeThisKeyword) {
        return isLiteralLikeElementAccess(node) && (!excludeThisKeyword && node.expression.kind === 108 || isEntityNameExpression(node.expression) || isBindableStaticAccessExpression(node.expression, true));
      }
      ts3.isBindableStaticElementAccessExpression = isBindableStaticElementAccessExpression;
      function isBindableStaticNameExpression(node, excludeThisKeyword) {
        return isEntityNameExpression(node) || isBindableStaticAccessExpression(node, excludeThisKeyword);
      }
      ts3.isBindableStaticNameExpression = isBindableStaticNameExpression;
      function getNameOrArgument(expr) {
        if (ts3.isPropertyAccessExpression(expr)) {
          return expr.name;
        }
        return expr.argumentExpression;
      }
      ts3.getNameOrArgument = getNameOrArgument;
      function getAssignmentDeclarationKindWorker(expr) {
        if (ts3.isCallExpression(expr)) {
          if (!isBindableObjectDefinePropertyCall(expr)) {
            return 0;
          }
          var entityName = expr.arguments[0];
          if (isExportsIdentifier(entityName) || isModuleExportsAccessExpression(entityName)) {
            return 8;
          }
          if (isBindableStaticAccessExpression(entityName) && getElementOrPropertyAccessName(entityName) === "prototype") {
            return 9;
          }
          return 7;
        }
        if (expr.operatorToken.kind !== 63 || !isAccessExpression(expr.left) || isVoidZero(getRightMostAssignedExpression(expr))) {
          return 0;
        }
        if (isBindableStaticNameExpression(expr.left.expression, true) && getElementOrPropertyAccessName(expr.left) === "prototype" && ts3.isObjectLiteralExpression(getInitializerOfBinaryExpression(expr))) {
          return 6;
        }
        return getAssignmentDeclarationPropertyAccessKind(expr.left);
      }
      function isVoidZero(node) {
        return ts3.isVoidExpression(node) && ts3.isNumericLiteral(node.expression) && node.expression.text === "0";
      }
      function getElementOrPropertyAccessArgumentExpressionOrName(node) {
        if (ts3.isPropertyAccessExpression(node)) {
          return node.name;
        }
        var arg = skipParentheses(node.argumentExpression);
        if (ts3.isNumericLiteral(arg) || ts3.isStringLiteralLike(arg)) {
          return arg;
        }
        return node;
      }
      ts3.getElementOrPropertyAccessArgumentExpressionOrName = getElementOrPropertyAccessArgumentExpressionOrName;
      function getElementOrPropertyAccessName(node) {
        var name = getElementOrPropertyAccessArgumentExpressionOrName(node);
        if (name) {
          if (ts3.isIdentifier(name)) {
            return name.escapedText;
          }
          if (ts3.isStringLiteralLike(name) || ts3.isNumericLiteral(name)) {
            return ts3.escapeLeadingUnderscores(name.text);
          }
        }
        return void 0;
      }
      ts3.getElementOrPropertyAccessName = getElementOrPropertyAccessName;
      function getAssignmentDeclarationPropertyAccessKind(lhs) {
        if (lhs.expression.kind === 108) {
          return 4;
        } else if (isModuleExportsAccessExpression(lhs)) {
          return 2;
        } else if (isBindableStaticNameExpression(lhs.expression, true)) {
          if (isPrototypeAccess(lhs.expression)) {
            return 3;
          }
          var nextToLast = lhs;
          while (!ts3.isIdentifier(nextToLast.expression)) {
            nextToLast = nextToLast.expression;
          }
          var id = nextToLast.expression;
          if ((id.escapedText === "exports" || id.escapedText === "module" && getElementOrPropertyAccessName(nextToLast) === "exports") && isBindableStaticAccessExpression(lhs)) {
            return 1;
          }
          if (isBindableStaticNameExpression(lhs, true) || ts3.isElementAccessExpression(lhs) && isDynamicName(lhs)) {
            return 5;
          }
        }
        return 0;
      }
      ts3.getAssignmentDeclarationPropertyAccessKind = getAssignmentDeclarationPropertyAccessKind;
      function getInitializerOfBinaryExpression(expr) {
        while (ts3.isBinaryExpression(expr.right)) {
          expr = expr.right;
        }
        return expr.right;
      }
      ts3.getInitializerOfBinaryExpression = getInitializerOfBinaryExpression;
      function isPrototypePropertyAssignment(node) {
        return ts3.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 3;
      }
      ts3.isPrototypePropertyAssignment = isPrototypePropertyAssignment;
      function isSpecialPropertyDeclaration(expr) {
        return isInJSFile(expr) && expr.parent && expr.parent.kind === 238 && (!ts3.isElementAccessExpression(expr) || isLiteralLikeElementAccess(expr)) && !!ts3.getJSDocTypeTag(expr.parent);
      }
      ts3.isSpecialPropertyDeclaration = isSpecialPropertyDeclaration;
      function setValueDeclaration(symbol, node) {
        var valueDeclaration = symbol.valueDeclaration;
        if (!valueDeclaration || !(node.flags & 16777216 && !(valueDeclaration.flags & 16777216)) && (isAssignmentDeclaration(valueDeclaration) && !isAssignmentDeclaration(node)) || valueDeclaration.kind !== node.kind && isEffectiveModuleDeclaration(valueDeclaration)) {
          symbol.valueDeclaration = node;
        }
      }
      ts3.setValueDeclaration = setValueDeclaration;
      function isFunctionSymbol(symbol) {
        if (!symbol || !symbol.valueDeclaration) {
          return false;
        }
        var decl = symbol.valueDeclaration;
        return decl.kind === 256 || ts3.isVariableDeclaration(decl) && decl.initializer && ts3.isFunctionLike(decl.initializer);
      }
      ts3.isFunctionSymbol = isFunctionSymbol;
      function tryGetModuleSpecifierFromDeclaration(node) {
        var _a, _b;
        switch (node.kind) {
          case 254:
            return (_a = ts3.findAncestor(node.initializer, function(node2) {
              return isRequireCall(node2, true);
            })) === null || _a === void 0 ? void 0 : _a.arguments[0];
          case 266:
            return ts3.tryCast(node.moduleSpecifier, ts3.isStringLiteralLike);
          case 265:
            return ts3.tryCast((_b = ts3.tryCast(node.moduleReference, ts3.isExternalModuleReference)) === null || _b === void 0 ? void 0 : _b.expression, ts3.isStringLiteralLike);
          default:
            ts3.Debug.assertNever(node);
        }
      }
      ts3.tryGetModuleSpecifierFromDeclaration = tryGetModuleSpecifierFromDeclaration;
      function importFromModuleSpecifier(node) {
        return tryGetImportFromModuleSpecifier(node) || ts3.Debug.failBadSyntaxKind(node.parent);
      }
      ts3.importFromModuleSpecifier = importFromModuleSpecifier;
      function tryGetImportFromModuleSpecifier(node) {
        switch (node.parent.kind) {
          case 266:
          case 272:
            return node.parent;
          case 277:
            return node.parent.parent;
          case 208:
            return isImportCall(node.parent) || isRequireCall(node.parent, false) ? node.parent : void 0;
          case 196:
            ts3.Debug.assert(ts3.isStringLiteral(node));
            return ts3.tryCast(node.parent.parent, ts3.isImportTypeNode);
          default:
            return void 0;
        }
      }
      ts3.tryGetImportFromModuleSpecifier = tryGetImportFromModuleSpecifier;
      function getExternalModuleName(node) {
        switch (node.kind) {
          case 266:
          case 272:
            return node.moduleSpecifier;
          case 265:
            return node.moduleReference.kind === 277 ? node.moduleReference.expression : void 0;
          case 200:
            return isLiteralImportTypeNode(node) ? node.argument.literal : void 0;
          case 208:
            return node.arguments[0];
          case 261:
            return node.name.kind === 10 ? node.name : void 0;
          default:
            return ts3.Debug.assertNever(node);
        }
      }
      ts3.getExternalModuleName = getExternalModuleName;
      function getNamespaceDeclarationNode(node) {
        switch (node.kind) {
          case 266:
            return node.importClause && ts3.tryCast(node.importClause.namedBindings, ts3.isNamespaceImport);
          case 265:
            return node;
          case 272:
            return node.exportClause && ts3.tryCast(node.exportClause, ts3.isNamespaceExport);
          default:
            return ts3.Debug.assertNever(node);
        }
      }
      ts3.getNamespaceDeclarationNode = getNamespaceDeclarationNode;
      function isDefaultImport(node) {
        return node.kind === 266 && !!node.importClause && !!node.importClause.name;
      }
      ts3.isDefaultImport = isDefaultImport;
      function forEachImportClauseDeclaration(node, action) {
        if (node.name) {
          var result2 = action(node);
          if (result2)
            return result2;
        }
        if (node.namedBindings) {
          var result2 = ts3.isNamespaceImport(node.namedBindings) ? action(node.namedBindings) : ts3.forEach(node.namedBindings.elements, action);
          if (result2)
            return result2;
        }
      }
      ts3.forEachImportClauseDeclaration = forEachImportClauseDeclaration;
      function hasQuestionToken(node) {
        if (node) {
          switch (node.kind) {
            case 164:
            case 169:
            case 168:
            case 297:
            case 296:
            case 167:
            case 166:
              return node.questionToken !== void 0;
          }
        }
        return false;
      }
      ts3.hasQuestionToken = hasQuestionToken;
      function isJSDocConstructSignature(node) {
        var param = ts3.isJSDocFunctionType(node) ? ts3.firstOrUndefined(node.parameters) : void 0;
        var name = ts3.tryCast(param && param.name, ts3.isIdentifier);
        return !!name && name.escapedText === "new";
      }
      ts3.isJSDocConstructSignature = isJSDocConstructSignature;
      function isJSDocTypeAlias(node) {
        return node.kind === 345 || node.kind === 338 || node.kind === 339;
      }
      ts3.isJSDocTypeAlias = isJSDocTypeAlias;
      function isTypeAlias(node) {
        return isJSDocTypeAlias(node) || ts3.isTypeAliasDeclaration(node);
      }
      ts3.isTypeAlias = isTypeAlias;
      function getSourceOfAssignment(node) {
        return ts3.isExpressionStatement(node) && ts3.isBinaryExpression(node.expression) && node.expression.operatorToken.kind === 63 ? getRightMostAssignedExpression(node.expression) : void 0;
      }
      function getSourceOfDefaultedAssignment(node) {
        return ts3.isExpressionStatement(node) && ts3.isBinaryExpression(node.expression) && getAssignmentDeclarationKind(node.expression) !== 0 && ts3.isBinaryExpression(node.expression.right) && (node.expression.right.operatorToken.kind === 56 || node.expression.right.operatorToken.kind === 60) ? node.expression.right.right : void 0;
      }
      function getSingleInitializerOfVariableStatementOrPropertyDeclaration(node) {
        switch (node.kind) {
          case 237:
            var v = getSingleVariableOfVariableStatement(node);
            return v && v.initializer;
          case 167:
            return node.initializer;
          case 296:
            return node.initializer;
        }
      }
      ts3.getSingleInitializerOfVariableStatementOrPropertyDeclaration = getSingleInitializerOfVariableStatementOrPropertyDeclaration;
      function getSingleVariableOfVariableStatement(node) {
        return ts3.isVariableStatement(node) ? ts3.firstOrUndefined(node.declarationList.declarations) : void 0;
      }
      ts3.getSingleVariableOfVariableStatement = getSingleVariableOfVariableStatement;
      function getNestedModuleDeclaration(node) {
        return ts3.isModuleDeclaration(node) && node.body && node.body.kind === 261 ? node.body : void 0;
      }
      function getJSDocCommentsAndTags(hostNode, noCache) {
        var result2;
        if (isVariableLike(hostNode) && ts3.hasInitializer(hostNode) && ts3.hasJSDocNodes(hostNode.initializer)) {
          result2 = ts3.addRange(result2, filterOwnedJSDocTags(hostNode, ts3.last(hostNode.initializer.jsDoc)));
        }
        var node = hostNode;
        while (node && node.parent) {
          if (ts3.hasJSDocNodes(node)) {
            result2 = ts3.addRange(result2, filterOwnedJSDocTags(hostNode, ts3.last(node.jsDoc)));
          }
          if (node.kind === 164) {
            result2 = ts3.addRange(result2, (noCache ? ts3.getJSDocParameterTagsNoCache : ts3.getJSDocParameterTags)(node));
            break;
          }
          if (node.kind === 163) {
            result2 = ts3.addRange(result2, (noCache ? ts3.getJSDocTypeParameterTagsNoCache : ts3.getJSDocTypeParameterTags)(node));
            break;
          }
          node = getNextJSDocCommentLocation(node);
        }
        return result2 || ts3.emptyArray;
      }
      ts3.getJSDocCommentsAndTags = getJSDocCommentsAndTags;
      function filterOwnedJSDocTags(hostNode, jsDoc) {
        if (ts3.isJSDoc(jsDoc)) {
          var ownedTags = ts3.filter(jsDoc.tags, function(tag) {
            return ownsJSDocTag(hostNode, tag);
          });
          return jsDoc.tags === ownedTags ? [jsDoc] : ownedTags;
        }
        return ownsJSDocTag(hostNode, jsDoc) ? [jsDoc] : void 0;
      }
      function ownsJSDocTag(hostNode, tag) {
        return !ts3.isJSDocTypeTag(tag) || !tag.parent || !ts3.isJSDoc(tag.parent) || !ts3.isParenthesizedExpression(tag.parent.parent) || tag.parent.parent === hostNode;
      }
      function getNextJSDocCommentLocation(node) {
        var parent = node.parent;
        if (parent.kind === 296 || parent.kind === 271 || parent.kind === 167 || parent.kind === 238 && node.kind === 206 || parent.kind === 247 || getNestedModuleDeclaration(parent) || ts3.isBinaryExpression(node) && node.operatorToken.kind === 63) {
          return parent;
        } else if (parent.parent && (getSingleVariableOfVariableStatement(parent.parent) === node || ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 63)) {
          return parent.parent;
        } else if (parent.parent && parent.parent.parent && (getSingleVariableOfVariableStatement(parent.parent.parent) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(parent.parent.parent) === node || getSourceOfDefaultedAssignment(parent.parent.parent))) {
          return parent.parent.parent;
        }
      }
      ts3.getNextJSDocCommentLocation = getNextJSDocCommentLocation;
      function getParameterSymbolFromJSDoc(node) {
        if (node.symbol) {
          return node.symbol;
        }
        if (!ts3.isIdentifier(node.name)) {
          return void 0;
        }
        var name = node.name.escapedText;
        var decl = getHostSignatureFromJSDoc(node);
        if (!decl) {
          return void 0;
        }
        var parameter = ts3.find(decl.parameters, function(p) {
          return p.name.kind === 79 && p.name.escapedText === name;
        });
        return parameter && parameter.symbol;
      }
      ts3.getParameterSymbolFromJSDoc = getParameterSymbolFromJSDoc;
      function getEffectiveContainerForJSDocTemplateTag(node) {
        if (ts3.isJSDoc(node.parent) && node.parent.tags) {
          var typeAlias = ts3.find(node.parent.tags, isJSDocTypeAlias);
          if (typeAlias) {
            return typeAlias;
          }
        }
        return getHostSignatureFromJSDoc(node);
      }
      ts3.getEffectiveContainerForJSDocTemplateTag = getEffectiveContainerForJSDocTemplateTag;
      function getHostSignatureFromJSDoc(node) {
        var host = getEffectiveJSDocHost(node);
        if (host) {
          return ts3.isPropertySignature(host) && host.type && ts3.isFunctionLike(host.type) ? host.type : ts3.isFunctionLike(host) ? host : void 0;
        }
        return void 0;
      }
      ts3.getHostSignatureFromJSDoc = getHostSignatureFromJSDoc;
      function getEffectiveJSDocHost(node) {
        var host = getJSDocHost(node);
        if (host) {
          return getSourceOfDefaultedAssignment(host) || getSourceOfAssignment(host) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(host) || getSingleVariableOfVariableStatement(host) || getNestedModuleDeclaration(host) || host;
        }
      }
      ts3.getEffectiveJSDocHost = getEffectiveJSDocHost;
      function getJSDocHost(node) {
        var jsDoc = getJSDocRoot(node);
        if (!jsDoc) {
          return void 0;
        }
        var host = jsDoc.parent;
        if (host && host.jsDoc && jsDoc === ts3.lastOrUndefined(host.jsDoc)) {
          return host;
        }
      }
      ts3.getJSDocHost = getJSDocHost;
      function getJSDocRoot(node) {
        return ts3.findAncestor(node.parent, ts3.isJSDoc);
      }
      ts3.getJSDocRoot = getJSDocRoot;
      function getTypeParameterFromJsDoc(node) {
        var name = node.name.escapedText;
        var typeParameters = node.parent.parent.parent.typeParameters;
        return typeParameters && ts3.find(typeParameters, function(p) {
          return p.name.escapedText === name;
        });
      }
      ts3.getTypeParameterFromJsDoc = getTypeParameterFromJsDoc;
      function hasRestParameter(s) {
        var last = ts3.lastOrUndefined(s.parameters);
        return !!last && isRestParameter(last);
      }
      ts3.hasRestParameter = hasRestParameter;
      function isRestParameter(node) {
        var type2 = ts3.isJSDocParameterTag(node) ? node.typeExpression && node.typeExpression.type : node.type;
        return node.dotDotDotToken !== void 0 || !!type2 && type2.kind === 318;
      }
      ts3.isRestParameter = isRestParameter;
      function hasTypeArguments(node) {
        return !!node.typeArguments;
      }
      ts3.hasTypeArguments = hasTypeArguments;
      var AssignmentKind;
      (function(AssignmentKind2) {
        AssignmentKind2[AssignmentKind2["None"] = 0] = "None";
        AssignmentKind2[AssignmentKind2["Definite"] = 1] = "Definite";
        AssignmentKind2[AssignmentKind2["Compound"] = 2] = "Compound";
      })(AssignmentKind = ts3.AssignmentKind || (ts3.AssignmentKind = {}));
      function getAssignmentTargetKind(node) {
        var parent = node.parent;
        while (true) {
          switch (parent.kind) {
            case 221:
              var binaryOperator = parent.operatorToken.kind;
              return isAssignmentOperator(binaryOperator) && parent.left === node ? binaryOperator === 63 || isLogicalOrCoalescingAssignmentOperator(binaryOperator) ? 1 : 2 : 0;
            case 219:
            case 220:
              var unaryOperator = parent.operator;
              return unaryOperator === 45 || unaryOperator === 46 ? 2 : 0;
            case 243:
            case 244:
              return parent.initializer === node ? 1 : 0;
            case 212:
            case 204:
            case 225:
            case 230:
              node = parent;
              break;
            case 298:
              node = parent.parent;
              break;
            case 297:
              if (parent.name !== node) {
                return 0;
              }
              node = parent.parent;
              break;
            case 296:
              if (parent.name === node) {
                return 0;
              }
              node = parent.parent;
              break;
            default:
              return 0;
          }
          parent = node.parent;
        }
      }
      ts3.getAssignmentTargetKind = getAssignmentTargetKind;
      function isAssignmentTarget(node) {
        return getAssignmentTargetKind(node) !== 0;
      }
      ts3.isAssignmentTarget = isAssignmentTarget;
      function isNodeWithPossibleHoistedDeclaration(node) {
        switch (node.kind) {
          case 235:
          case 237:
          case 248:
          case 239:
          case 249:
          case 263:
          case 289:
          case 290:
          case 250:
          case 242:
          case 243:
          case 244:
          case 240:
          case 241:
          case 252:
          case 292:
            return true;
        }
        return false;
      }
      ts3.isNodeWithPossibleHoistedDeclaration = isNodeWithPossibleHoistedDeclaration;
      function isValueSignatureDeclaration(node) {
        return ts3.isFunctionExpression(node) || ts3.isArrowFunction(node) || ts3.isMethodOrAccessor(node) || ts3.isFunctionDeclaration(node) || ts3.isConstructorDeclaration(node);
      }
      ts3.isValueSignatureDeclaration = isValueSignatureDeclaration;
      function walkUp(node, kind) {
        while (node && node.kind === kind) {
          node = node.parent;
        }
        return node;
      }
      function walkUpParenthesizedTypes(node) {
        return walkUp(node, 191);
      }
      ts3.walkUpParenthesizedTypes = walkUpParenthesizedTypes;
      function walkUpParenthesizedExpressions(node) {
        return walkUp(node, 212);
      }
      ts3.walkUpParenthesizedExpressions = walkUpParenthesizedExpressions;
      function walkUpParenthesizedTypesAndGetParentAndChild(node) {
        var child;
        while (node && node.kind === 191) {
          child = node;
          node = node.parent;
        }
        return [child, node];
      }
      ts3.walkUpParenthesizedTypesAndGetParentAndChild = walkUpParenthesizedTypesAndGetParentAndChild;
      function skipParentheses(node, excludeJSDocTypeAssertions) {
        var flags = excludeJSDocTypeAssertions ? 1 | 16 : 1;
        return ts3.skipOuterExpressions(node, flags);
      }
      ts3.skipParentheses = skipParentheses;
      function isDeleteTarget(node) {
        if (node.kind !== 206 && node.kind !== 207) {
          return false;
        }
        node = walkUpParenthesizedExpressions(node.parent);
        return node && node.kind === 215;
      }
      ts3.isDeleteTarget = isDeleteTarget;
      function isNodeDescendantOf(node, ancestor) {
        while (node) {
          if (node === ancestor)
            return true;
          node = node.parent;
        }
        return false;
      }
      ts3.isNodeDescendantOf = isNodeDescendantOf;
      function isDeclarationName(name) {
        return !ts3.isSourceFile(name) && !ts3.isBindingPattern(name) && ts3.isDeclaration(name.parent) && name.parent.name === name;
      }
      ts3.isDeclarationName = isDeclarationName;
      function getDeclarationFromName(name) {
        var parent = name.parent;
        switch (name.kind) {
          case 10:
          case 14:
          case 8:
            if (ts3.isComputedPropertyName(parent))
              return parent.parent;
          case 79:
            if (ts3.isDeclaration(parent)) {
              return parent.name === name ? parent : void 0;
            } else if (ts3.isQualifiedName(parent)) {
              var tag = parent.parent;
              return ts3.isJSDocParameterTag(tag) && tag.name === parent ? tag : void 0;
            } else {
              var binExp = parent.parent;
              return ts3.isBinaryExpression(binExp) && getAssignmentDeclarationKind(binExp) !== 0 && (binExp.left.symbol || binExp.symbol) && ts3.getNameOfDeclaration(binExp) === name ? binExp : void 0;
            }
          case 80:
            return ts3.isDeclaration(parent) && parent.name === name ? parent : void 0;
          default:
            return void 0;
        }
      }
      ts3.getDeclarationFromName = getDeclarationFromName;
      function isLiteralComputedPropertyDeclarationName(node) {
        return isStringOrNumericLiteralLike(node) && node.parent.kind === 162 && ts3.isDeclaration(node.parent.parent);
      }
      ts3.isLiteralComputedPropertyDeclarationName = isLiteralComputedPropertyDeclarationName;
      function isIdentifierName(node) {
        var parent = node.parent;
        switch (parent.kind) {
          case 167:
          case 166:
          case 169:
          case 168:
          case 172:
          case 173:
          case 299:
          case 296:
          case 206:
            return parent.name === node;
          case 161:
            return parent.right === node;
          case 203:
          case 270:
            return parent.propertyName === node;
          case 275:
          case 285:
          case 279:
          case 280:
          case 281:
            return true;
        }
        return false;
      }
      ts3.isIdentifierName = isIdentifierName;
      function isAliasSymbolDeclaration(node) {
        if (node.kind === 265 || node.kind === 264 || node.kind === 267 && !!node.name || node.kind === 268 || node.kind === 274 || node.kind === 270 || node.kind === 275 || node.kind === 271 && exportAssignmentIsAlias(node)) {
          return true;
        }
        return isInJSFile(node) && (ts3.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 2 && exportAssignmentIsAlias(node) || ts3.isPropertyAccessExpression(node) && ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 63 && isAliasableExpression(node.parent.right));
      }
      ts3.isAliasSymbolDeclaration = isAliasSymbolDeclaration;
      function getAliasDeclarationFromName(node) {
        switch (node.parent.kind) {
          case 267:
          case 270:
          case 268:
          case 275:
          case 271:
          case 265:
          case 274:
            return node.parent;
          case 161:
            do {
              node = node.parent;
            } while (node.parent.kind === 161);
            return getAliasDeclarationFromName(node);
        }
      }
      ts3.getAliasDeclarationFromName = getAliasDeclarationFromName;
      function isAliasableExpression(e) {
        return isEntityNameExpression(e) || ts3.isClassExpression(e);
      }
      ts3.isAliasableExpression = isAliasableExpression;
      function exportAssignmentIsAlias(node) {
        var e = getExportAssignmentExpression(node);
        return isAliasableExpression(e);
      }
      ts3.exportAssignmentIsAlias = exportAssignmentIsAlias;
      function getExportAssignmentExpression(node) {
        return ts3.isExportAssignment(node) ? node.expression : node.right;
      }
      ts3.getExportAssignmentExpression = getExportAssignmentExpression;
      function getPropertyAssignmentAliasLikeExpression(node) {
        return node.kind === 297 ? node.name : node.kind === 296 ? node.initializer : node.parent.right;
      }
      ts3.getPropertyAssignmentAliasLikeExpression = getPropertyAssignmentAliasLikeExpression;
      function getEffectiveBaseTypeNode(node) {
        var baseType = getClassExtendsHeritageElement(node);
        if (baseType && isInJSFile(node)) {
          var tag = ts3.getJSDocAugmentsTag(node);
          if (tag) {
            return tag.class;
          }
        }
        return baseType;
      }
      ts3.getEffectiveBaseTypeNode = getEffectiveBaseTypeNode;
      function getClassExtendsHeritageElement(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 94);
        return heritageClause && heritageClause.types.length > 0 ? heritageClause.types[0] : void 0;
      }
      ts3.getClassExtendsHeritageElement = getClassExtendsHeritageElement;
      function getEffectiveImplementsTypeNodes(node) {
        if (isInJSFile(node)) {
          return ts3.getJSDocImplementsTags(node).map(function(n) {
            return n.class;
          });
        } else {
          var heritageClause = getHeritageClause(node.heritageClauses, 117);
          return heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.types;
        }
      }
      ts3.getEffectiveImplementsTypeNodes = getEffectiveImplementsTypeNodes;
      function getAllSuperTypeNodes(node) {
        return ts3.isInterfaceDeclaration(node) ? getInterfaceBaseTypeNodes(node) || ts3.emptyArray : ts3.isClassLike(node) ? ts3.concatenate(ts3.singleElementArray(getEffectiveBaseTypeNode(node)), getEffectiveImplementsTypeNodes(node)) || ts3.emptyArray : ts3.emptyArray;
      }
      ts3.getAllSuperTypeNodes = getAllSuperTypeNodes;
      function getInterfaceBaseTypeNodes(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 94);
        return heritageClause ? heritageClause.types : void 0;
      }
      ts3.getInterfaceBaseTypeNodes = getInterfaceBaseTypeNodes;
      function getHeritageClause(clauses, kind) {
        if (clauses) {
          for (var _i = 0, clauses_1 = clauses; _i < clauses_1.length; _i++) {
            var clause = clauses_1[_i];
            if (clause.token === kind) {
              return clause;
            }
          }
        }
        return void 0;
      }
      ts3.getHeritageClause = getHeritageClause;
      function getAncestor(node, kind) {
        while (node) {
          if (node.kind === kind) {
            return node;
          }
          node = node.parent;
        }
        return void 0;
      }
      ts3.getAncestor = getAncestor;
      function isKeyword(token) {
        return 81 <= token && token <= 160;
      }
      ts3.isKeyword = isKeyword;
      function isContextualKeyword(token) {
        return 126 <= token && token <= 160;
      }
      ts3.isContextualKeyword = isContextualKeyword;
      function isNonContextualKeyword(token) {
        return isKeyword(token) && !isContextualKeyword(token);
      }
      ts3.isNonContextualKeyword = isNonContextualKeyword;
      function isFutureReservedKeyword(token) {
        return 117 <= token && token <= 125;
      }
      ts3.isFutureReservedKeyword = isFutureReservedKeyword;
      function isStringANonContextualKeyword(name) {
        var token = ts3.stringToToken(name);
        return token !== void 0 && isNonContextualKeyword(token);
      }
      ts3.isStringANonContextualKeyword = isStringANonContextualKeyword;
      function isStringAKeyword(name) {
        var token = ts3.stringToToken(name);
        return token !== void 0 && isKeyword(token);
      }
      ts3.isStringAKeyword = isStringAKeyword;
      function isIdentifierANonContextualKeyword(_a) {
        var originalKeywordKind = _a.originalKeywordKind;
        return !!originalKeywordKind && !isContextualKeyword(originalKeywordKind);
      }
      ts3.isIdentifierANonContextualKeyword = isIdentifierANonContextualKeyword;
      function isTrivia(token) {
        return 2 <= token && token <= 7;
      }
      ts3.isTrivia = isTrivia;
      var FunctionFlags;
      (function(FunctionFlags2) {
        FunctionFlags2[FunctionFlags2["Normal"] = 0] = "Normal";
        FunctionFlags2[FunctionFlags2["Generator"] = 1] = "Generator";
        FunctionFlags2[FunctionFlags2["Async"] = 2] = "Async";
        FunctionFlags2[FunctionFlags2["Invalid"] = 4] = "Invalid";
        FunctionFlags2[FunctionFlags2["AsyncGenerator"] = 3] = "AsyncGenerator";
      })(FunctionFlags = ts3.FunctionFlags || (ts3.FunctionFlags = {}));
      function getFunctionFlags(node) {
        if (!node) {
          return 4;
        }
        var flags = 0;
        switch (node.kind) {
          case 256:
          case 213:
          case 169:
            if (node.asteriskToken) {
              flags |= 1;
            }
          case 214:
            if (hasSyntacticModifier(node, 256)) {
              flags |= 2;
            }
            break;
        }
        if (!node.body) {
          flags |= 4;
        }
        return flags;
      }
      ts3.getFunctionFlags = getFunctionFlags;
      function isAsyncFunction(node) {
        switch (node.kind) {
          case 256:
          case 213:
          case 214:
          case 169:
            return node.body !== void 0 && node.asteriskToken === void 0 && hasSyntacticModifier(node, 256);
        }
        return false;
      }
      ts3.isAsyncFunction = isAsyncFunction;
      function isStringOrNumericLiteralLike(node) {
        return ts3.isStringLiteralLike(node) || ts3.isNumericLiteral(node);
      }
      ts3.isStringOrNumericLiteralLike = isStringOrNumericLiteralLike;
      function isSignedNumericLiteral(node) {
        return ts3.isPrefixUnaryExpression(node) && (node.operator === 39 || node.operator === 40) && ts3.isNumericLiteral(node.operand);
      }
      ts3.isSignedNumericLiteral = isSignedNumericLiteral;
      function hasDynamicName(declaration) {
        var name = ts3.getNameOfDeclaration(declaration);
        return !!name && isDynamicName(name);
      }
      ts3.hasDynamicName = hasDynamicName;
      function isDynamicName(name) {
        if (!(name.kind === 162 || name.kind === 207)) {
          return false;
        }
        var expr = ts3.isElementAccessExpression(name) ? skipParentheses(name.argumentExpression) : name.expression;
        return !isStringOrNumericLiteralLike(expr) && !isSignedNumericLiteral(expr);
      }
      ts3.isDynamicName = isDynamicName;
      function getPropertyNameForPropertyNameNode(name) {
        switch (name.kind) {
          case 79:
          case 80:
            return name.escapedText;
          case 10:
          case 8:
            return ts3.escapeLeadingUnderscores(name.text);
          case 162:
            var nameExpression = name.expression;
            if (isStringOrNumericLiteralLike(nameExpression)) {
              return ts3.escapeLeadingUnderscores(nameExpression.text);
            } else if (isSignedNumericLiteral(nameExpression)) {
              if (nameExpression.operator === 40) {
                return ts3.tokenToString(nameExpression.operator) + nameExpression.operand.text;
              }
              return nameExpression.operand.text;
            }
            return void 0;
          default:
            return ts3.Debug.assertNever(name);
        }
      }
      ts3.getPropertyNameForPropertyNameNode = getPropertyNameForPropertyNameNode;
      function isPropertyNameLiteral(node) {
        switch (node.kind) {
          case 79:
          case 10:
          case 14:
          case 8:
            return true;
          default:
            return false;
        }
      }
      ts3.isPropertyNameLiteral = isPropertyNameLiteral;
      function getTextOfIdentifierOrLiteral(node) {
        return ts3.isMemberName(node) ? ts3.idText(node) : node.text;
      }
      ts3.getTextOfIdentifierOrLiteral = getTextOfIdentifierOrLiteral;
      function getEscapedTextOfIdentifierOrLiteral(node) {
        return ts3.isMemberName(node) ? node.escapedText : ts3.escapeLeadingUnderscores(node.text);
      }
      ts3.getEscapedTextOfIdentifierOrLiteral = getEscapedTextOfIdentifierOrLiteral;
      function getPropertyNameForUniqueESSymbol(symbol) {
        return "__@".concat(ts3.getSymbolId(symbol), "@").concat(symbol.escapedName);
      }
      ts3.getPropertyNameForUniqueESSymbol = getPropertyNameForUniqueESSymbol;
      function getSymbolNameForPrivateIdentifier(containingClassSymbol, description) {
        return "__#".concat(ts3.getSymbolId(containingClassSymbol), "@").concat(description);
      }
      ts3.getSymbolNameForPrivateIdentifier = getSymbolNameForPrivateIdentifier;
      function isKnownSymbol(symbol) {
        return ts3.startsWith(symbol.escapedName, "__@");
      }
      ts3.isKnownSymbol = isKnownSymbol;
      function isPrivateIdentifierSymbol(symbol) {
        return ts3.startsWith(symbol.escapedName, "__#");
      }
      ts3.isPrivateIdentifierSymbol = isPrivateIdentifierSymbol;
      function isESSymbolIdentifier(node) {
        return node.kind === 79 && node.escapedText === "Symbol";
      }
      ts3.isESSymbolIdentifier = isESSymbolIdentifier;
      function isPushOrUnshiftIdentifier(node) {
        return node.escapedText === "push" || node.escapedText === "unshift";
      }
      ts3.isPushOrUnshiftIdentifier = isPushOrUnshiftIdentifier;
      function isParameterDeclaration(node) {
        var root = getRootDeclaration(node);
        return root.kind === 164;
      }
      ts3.isParameterDeclaration = isParameterDeclaration;
      function getRootDeclaration(node) {
        while (node.kind === 203) {
          node = node.parent.parent;
        }
        return node;
      }
      ts3.getRootDeclaration = getRootDeclaration;
      function nodeStartsNewLexicalEnvironment(node) {
        var kind = node.kind;
        return kind === 171 || kind === 213 || kind === 256 || kind === 214 || kind === 169 || kind === 172 || kind === 173 || kind === 261 || kind === 305;
      }
      ts3.nodeStartsNewLexicalEnvironment = nodeStartsNewLexicalEnvironment;
      function nodeIsSynthesized(range) {
        return positionIsSynthesized(range.pos) || positionIsSynthesized(range.end);
      }
      ts3.nodeIsSynthesized = nodeIsSynthesized;
      function getOriginalSourceFile(sourceFile) {
        return ts3.getParseTreeNode(sourceFile, ts3.isSourceFile) || sourceFile;
      }
      ts3.getOriginalSourceFile = getOriginalSourceFile;
      var Associativity;
      (function(Associativity2) {
        Associativity2[Associativity2["Left"] = 0] = "Left";
        Associativity2[Associativity2["Right"] = 1] = "Right";
      })(Associativity = ts3.Associativity || (ts3.Associativity = {}));
      function getExpressionAssociativity(expression) {
        var operator = getOperator(expression);
        var hasArguments = expression.kind === 209 && expression.arguments !== void 0;
        return getOperatorAssociativity(expression.kind, operator, hasArguments);
      }
      ts3.getExpressionAssociativity = getExpressionAssociativity;
      function getOperatorAssociativity(kind, operator, hasArguments) {
        switch (kind) {
          case 209:
            return hasArguments ? 0 : 1;
          case 219:
          case 216:
          case 217:
          case 215:
          case 218:
          case 222:
          case 224:
            return 1;
          case 221:
            switch (operator) {
              case 42:
              case 63:
              case 64:
              case 65:
              case 67:
              case 66:
              case 68:
              case 69:
              case 70:
              case 71:
              case 72:
              case 73:
              case 78:
              case 74:
              case 75:
              case 76:
              case 77:
                return 1;
            }
        }
        return 0;
      }
      ts3.getOperatorAssociativity = getOperatorAssociativity;
      function getExpressionPrecedence(expression) {
        var operator = getOperator(expression);
        var hasArguments = expression.kind === 209 && expression.arguments !== void 0;
        return getOperatorPrecedence(expression.kind, operator, hasArguments);
      }
      ts3.getExpressionPrecedence = getExpressionPrecedence;
      function getOperator(expression) {
        if (expression.kind === 221) {
          return expression.operatorToken.kind;
        } else if (expression.kind === 219 || expression.kind === 220) {
          return expression.operator;
        } else {
          return expression.kind;
        }
      }
      ts3.getOperator = getOperator;
      var OperatorPrecedence;
      (function(OperatorPrecedence2) {
        OperatorPrecedence2[OperatorPrecedence2["Comma"] = 0] = "Comma";
        OperatorPrecedence2[OperatorPrecedence2["Spread"] = 1] = "Spread";
        OperatorPrecedence2[OperatorPrecedence2["Yield"] = 2] = "Yield";
        OperatorPrecedence2[OperatorPrecedence2["Assignment"] = 3] = "Assignment";
        OperatorPrecedence2[OperatorPrecedence2["Conditional"] = 4] = "Conditional";
        OperatorPrecedence2[OperatorPrecedence2["Coalesce"] = 4] = "Coalesce";
        OperatorPrecedence2[OperatorPrecedence2["LogicalOR"] = 5] = "LogicalOR";
        OperatorPrecedence2[OperatorPrecedence2["LogicalAND"] = 6] = "LogicalAND";
        OperatorPrecedence2[OperatorPrecedence2["BitwiseOR"] = 7] = "BitwiseOR";
        OperatorPrecedence2[OperatorPrecedence2["BitwiseXOR"] = 8] = "BitwiseXOR";
        OperatorPrecedence2[OperatorPrecedence2["BitwiseAND"] = 9] = "BitwiseAND";
        OperatorPrecedence2[OperatorPrecedence2["Equality"] = 10] = "Equality";
        OperatorPrecedence2[OperatorPrecedence2["Relational"] = 11] = "Relational";
        OperatorPrecedence2[OperatorPrecedence2["Shift"] = 12] = "Shift";
        OperatorPrecedence2[OperatorPrecedence2["Additive"] = 13] = "Additive";
        OperatorPrecedence2[OperatorPrecedence2["Multiplicative"] = 14] = "Multiplicative";
        OperatorPrecedence2[OperatorPrecedence2["Exponentiation"] = 15] = "Exponentiation";
        OperatorPrecedence2[OperatorPrecedence2["Unary"] = 16] = "Unary";
        OperatorPrecedence2[OperatorPrecedence2["Update"] = 17] = "Update";
        OperatorPrecedence2[OperatorPrecedence2["LeftHandSide"] = 18] = "LeftHandSide";
        OperatorPrecedence2[OperatorPrecedence2["Member"] = 19] = "Member";
        OperatorPrecedence2[OperatorPrecedence2["Primary"] = 20] = "Primary";
        OperatorPrecedence2[OperatorPrecedence2["Highest"] = 20] = "Highest";
        OperatorPrecedence2[OperatorPrecedence2["Lowest"] = 0] = "Lowest";
        OperatorPrecedence2[OperatorPrecedence2["Invalid"] = -1] = "Invalid";
      })(OperatorPrecedence = ts3.OperatorPrecedence || (ts3.OperatorPrecedence = {}));
      function getOperatorPrecedence(nodeKind, operatorKind, hasArguments) {
        switch (nodeKind) {
          case 351:
            return 0;
          case 225:
            return 1;
          case 224:
            return 2;
          case 222:
            return 4;
          case 221:
            switch (operatorKind) {
              case 27:
                return 0;
              case 63:
              case 64:
              case 65:
              case 67:
              case 66:
              case 68:
              case 69:
              case 70:
              case 71:
              case 72:
              case 73:
              case 78:
              case 74:
              case 75:
              case 76:
              case 77:
                return 3;
              default:
                return getBinaryOperatorPrecedence(operatorKind);
            }
          case 211:
          case 230:
          case 219:
          case 216:
          case 217:
          case 215:
          case 218:
            return 16;
          case 220:
            return 17;
          case 208:
            return 18;
          case 209:
            return hasArguments ? 19 : 18;
          case 210:
          case 206:
          case 207:
          case 231:
            return 19;
          case 229:
            return 11;
          case 108:
          case 106:
          case 79:
          case 80:
          case 104:
          case 110:
          case 95:
          case 8:
          case 9:
          case 10:
          case 204:
          case 205:
          case 213:
          case 214:
          case 226:
          case 13:
          case 14:
          case 223:
          case 212:
          case 227:
          case 278:
          case 279:
          case 282:
            return 20;
          default:
            return -1;
        }
      }
      ts3.getOperatorPrecedence = getOperatorPrecedence;
      function getBinaryOperatorPrecedence(kind) {
        switch (kind) {
          case 60:
            return 4;
          case 56:
            return 5;
          case 55:
            return 6;
          case 51:
            return 7;
          case 52:
            return 8;
          case 50:
            return 9;
          case 34:
          case 35:
          case 36:
          case 37:
            return 10;
          case 29:
          case 31:
          case 32:
          case 33:
          case 102:
          case 101:
          case 127:
            return 11;
          case 47:
          case 48:
          case 49:
            return 12;
          case 39:
          case 40:
            return 13;
          case 41:
          case 43:
          case 44:
            return 14;
          case 42:
            return 15;
        }
        return -1;
      }
      ts3.getBinaryOperatorPrecedence = getBinaryOperatorPrecedence;
      function getSemanticJsxChildren(children) {
        return ts3.filter(children, function(i) {
          switch (i.kind) {
            case 288:
              return !!i.expression;
            case 11:
              return !i.containsOnlyTriviaWhiteSpaces;
            default:
              return true;
          }
        });
      }
      ts3.getSemanticJsxChildren = getSemanticJsxChildren;
      function createDiagnosticCollection() {
        var nonFileDiagnostics = [];
        var filesWithDiagnostics = [];
        var fileDiagnostics = new ts3.Map();
        var hasReadNonFileDiagnostics = false;
        return {
          add,
          lookup,
          getGlobalDiagnostics,
          getDiagnostics
        };
        function lookup(diagnostic) {
          var diagnostics;
          if (diagnostic.file) {
            diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
          } else {
            diagnostics = nonFileDiagnostics;
          }
          if (!diagnostics) {
            return void 0;
          }
          var result2 = ts3.binarySearch(diagnostics, diagnostic, ts3.identity, compareDiagnosticsSkipRelatedInformation);
          if (result2 >= 0) {
            return diagnostics[result2];
          }
          return void 0;
        }
        function add(diagnostic) {
          var diagnostics;
          if (diagnostic.file) {
            diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
            if (!diagnostics) {
              diagnostics = [];
              fileDiagnostics.set(diagnostic.file.fileName, diagnostics);
              ts3.insertSorted(filesWithDiagnostics, diagnostic.file.fileName, ts3.compareStringsCaseSensitive);
            }
          } else {
            if (hasReadNonFileDiagnostics) {
              hasReadNonFileDiagnostics = false;
              nonFileDiagnostics = nonFileDiagnostics.slice();
            }
            diagnostics = nonFileDiagnostics;
          }
          ts3.insertSorted(diagnostics, diagnostic, compareDiagnostics);
        }
        function getGlobalDiagnostics() {
          hasReadNonFileDiagnostics = true;
          return nonFileDiagnostics;
        }
        function getDiagnostics(fileName2) {
          if (fileName2) {
            return fileDiagnostics.get(fileName2) || [];
          }
          var fileDiags = ts3.flatMapToMutable(filesWithDiagnostics, function(f) {
            return fileDiagnostics.get(f);
          });
          if (!nonFileDiagnostics.length) {
            return fileDiags;
          }
          fileDiags.unshift.apply(fileDiags, nonFileDiagnostics);
          return fileDiags;
        }
      }
      ts3.createDiagnosticCollection = createDiagnosticCollection;
      var templateSubstitutionRegExp = /\$\{/g;
      function escapeTemplateSubstitution(str2) {
        return str2.replace(templateSubstitutionRegExp, "\\${");
      }
      function hasInvalidEscape(template) {
        return template && !!(ts3.isNoSubstitutionTemplateLiteral(template) ? template.templateFlags : template.head.templateFlags || ts3.some(template.templateSpans, function(span) {
          return !!span.literal.templateFlags;
        }));
      }
      ts3.hasInvalidEscape = hasInvalidEscape;
      var doubleQuoteEscapedCharsRegExp = /[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
      var singleQuoteEscapedCharsRegExp = /[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
      var backtickQuoteEscapedCharsRegExp = /\r\n|[\\\`\u0000-\u001f\t\v\f\b\r\u2028\u2029\u0085]/g;
      var escapedCharsMap = new ts3.Map(ts3.getEntries({
        "	": "\\t",
        "\v": "\\v",
        "\f": "\\f",
        "\b": "\\b",
        "\r": "\\r",
        "\n": "\\n",
        "\\": "\\\\",
        '"': '\\"',
        "'": "\\'",
        "`": "\\`",
        "\u2028": "\\u2028",
        "\u2029": "\\u2029",
        "\x85": "\\u0085",
        "\r\n": "\\r\\n"
      }));
      function encodeUtf16EscapeSequence(charCode) {
        var hexCharCode = charCode.toString(16).toUpperCase();
        var paddedHexCode = ("0000" + hexCharCode).slice(-4);
        return "\\u" + paddedHexCode;
      }
      function getReplacement(c, offset, input) {
        if (c.charCodeAt(0) === 0) {
          var lookAhead = input.charCodeAt(offset + c.length);
          if (lookAhead >= 48 && lookAhead <= 57) {
            return "\\x00";
          }
          return "\\0";
        }
        return escapedCharsMap.get(c) || encodeUtf16EscapeSequence(c.charCodeAt(0));
      }
      function escapeString2(s, quoteChar) {
        var escapedCharsRegExp = quoteChar === 96 ? backtickQuoteEscapedCharsRegExp : quoteChar === 39 ? singleQuoteEscapedCharsRegExp : doubleQuoteEscapedCharsRegExp;
        return s.replace(escapedCharsRegExp, getReplacement);
      }
      ts3.escapeString = escapeString2;
      var nonAsciiCharacters = /[^\u0000-\u007F]/g;
      function escapeNonAsciiString(s, quoteChar) {
        s = escapeString2(s, quoteChar);
        return nonAsciiCharacters.test(s) ? s.replace(nonAsciiCharacters, function(c) {
          return encodeUtf16EscapeSequence(c.charCodeAt(0));
        }) : s;
      }
      ts3.escapeNonAsciiString = escapeNonAsciiString;
      var jsxDoubleQuoteEscapedCharsRegExp = /[\"\u0000-\u001f\u2028\u2029\u0085]/g;
      var jsxSingleQuoteEscapedCharsRegExp = /[\'\u0000-\u001f\u2028\u2029\u0085]/g;
      var jsxEscapedCharsMap = new ts3.Map(ts3.getEntries({
        '"': "&quot;",
        "'": "&apos;"
      }));
      function encodeJsxCharacterEntity(charCode) {
        var hexCharCode = charCode.toString(16).toUpperCase();
        return "&#x" + hexCharCode + ";";
      }
      function getJsxAttributeStringReplacement(c) {
        if (c.charCodeAt(0) === 0) {
          return "&#0;";
        }
        return jsxEscapedCharsMap.get(c) || encodeJsxCharacterEntity(c.charCodeAt(0));
      }
      function escapeJsxAttributeString(s, quoteChar) {
        var escapedCharsRegExp = quoteChar === 39 ? jsxSingleQuoteEscapedCharsRegExp : jsxDoubleQuoteEscapedCharsRegExp;
        return s.replace(escapedCharsRegExp, getJsxAttributeStringReplacement);
      }
      ts3.escapeJsxAttributeString = escapeJsxAttributeString;
      function stripQuotes(name) {
        var length = name.length;
        if (length >= 2 && name.charCodeAt(0) === name.charCodeAt(length - 1) && isQuoteOrBacktick(name.charCodeAt(0))) {
          return name.substring(1, length - 1);
        }
        return name;
      }
      ts3.stripQuotes = stripQuotes;
      function isQuoteOrBacktick(charCode) {
        return charCode === 39 || charCode === 34 || charCode === 96;
      }
      function isIntrinsicJsxName(name) {
        var ch = name.charCodeAt(0);
        return ch >= 97 && ch <= 122 || ts3.stringContains(name, "-") || ts3.stringContains(name, ":");
      }
      ts3.isIntrinsicJsxName = isIntrinsicJsxName;
      var indentStrings = ["", "    "];
      function getIndentString(level) {
        var singleLevel = indentStrings[1];
        for (var current = indentStrings.length; current <= level; current++) {
          indentStrings.push(indentStrings[current - 1] + singleLevel);
        }
        return indentStrings[level];
      }
      ts3.getIndentString = getIndentString;
      function getIndentSize() {
        return indentStrings[1].length;
      }
      ts3.getIndentSize = getIndentSize;
      function isNightly() {
        return ts3.stringContains(ts3.version, "-dev") || ts3.stringContains(ts3.version, "-insiders");
      }
      ts3.isNightly = isNightly;
      function createTextWriter(newLine) {
        var output;
        var indent;
        var lineStart;
        var lineCount;
        var linePos;
        var hasTrailingComment = false;
        function updateLineCountAndPosFor(s) {
          var lineStartsOfS = ts3.computeLineStarts(s);
          if (lineStartsOfS.length > 1) {
            lineCount = lineCount + lineStartsOfS.length - 1;
            linePos = output.length - s.length + ts3.last(lineStartsOfS);
            lineStart = linePos - output.length === 0;
          } else {
            lineStart = false;
          }
        }
        function writeText(s) {
          if (s && s.length) {
            if (lineStart) {
              s = getIndentString(indent) + s;
              lineStart = false;
            }
            output += s;
            updateLineCountAndPosFor(s);
          }
        }
        function write(s) {
          if (s)
            hasTrailingComment = false;
          writeText(s);
        }
        function writeComment(s) {
          if (s)
            hasTrailingComment = true;
          writeText(s);
        }
        function reset2() {
          output = "";
          indent = 0;
          lineStart = true;
          lineCount = 0;
          linePos = 0;
          hasTrailingComment = false;
        }
        function rawWrite(s) {
          if (s !== void 0) {
            output += s;
            updateLineCountAndPosFor(s);
            hasTrailingComment = false;
          }
        }
        function writeLiteral(s) {
          if (s && s.length) {
            write(s);
          }
        }
        function writeLine(force) {
          if (!lineStart || force) {
            output += newLine;
            lineCount++;
            linePos = output.length;
            lineStart = true;
            hasTrailingComment = false;
          }
        }
        function getTextPosWithWriteLine() {
          return lineStart ? output.length : output.length + newLine.length;
        }
        reset2();
        return {
          write,
          rawWrite,
          writeLiteral,
          writeLine,
          increaseIndent: function() {
            indent++;
          },
          decreaseIndent: function() {
            indent--;
          },
          getIndent: function() {
            return indent;
          },
          getTextPos: function() {
            return output.length;
          },
          getLine: function() {
            return lineCount;
          },
          getColumn: function() {
            return lineStart ? indent * getIndentSize() : output.length - linePos;
          },
          getText: function() {
            return output;
          },
          isAtStartOfLine: function() {
            return lineStart;
          },
          hasTrailingComment: function() {
            return hasTrailingComment;
          },
          hasTrailingWhitespace: function() {
            return !!output.length && ts3.isWhiteSpaceLike(output.charCodeAt(output.length - 1));
          },
          clear: reset2,
          reportInaccessibleThisError: ts3.noop,
          reportPrivateInBaseOfClassExpression: ts3.noop,
          reportInaccessibleUniqueSymbolError: ts3.noop,
          trackSymbol: function() {
            return false;
          },
          writeKeyword: write,
          writeOperator: write,
          writeParameter: write,
          writeProperty: write,
          writePunctuation: write,
          writeSpace: write,
          writeStringLiteral: write,
          writeSymbol: function(s, _) {
            return write(s);
          },
          writeTrailingSemicolon: write,
          writeComment,
          getTextPosWithWriteLine
        };
      }
      ts3.createTextWriter = createTextWriter;
      function getTrailingSemicolonDeferringWriter(writer) {
        var pendingTrailingSemicolon = false;
        function commitPendingTrailingSemicolon() {
          if (pendingTrailingSemicolon) {
            writer.writeTrailingSemicolon(";");
            pendingTrailingSemicolon = false;
          }
        }
        return __assign(__assign({}, writer), { writeTrailingSemicolon: function() {
          pendingTrailingSemicolon = true;
        }, writeLiteral: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeLiteral(s);
        }, writeStringLiteral: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeStringLiteral(s);
        }, writeSymbol: function(s, sym) {
          commitPendingTrailingSemicolon();
          writer.writeSymbol(s, sym);
        }, writePunctuation: function(s) {
          commitPendingTrailingSemicolon();
          writer.writePunctuation(s);
        }, writeKeyword: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeKeyword(s);
        }, writeOperator: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeOperator(s);
        }, writeParameter: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeParameter(s);
        }, writeSpace: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeSpace(s);
        }, writeProperty: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeProperty(s);
        }, writeComment: function(s) {
          commitPendingTrailingSemicolon();
          writer.writeComment(s);
        }, writeLine: function() {
          commitPendingTrailingSemicolon();
          writer.writeLine();
        }, increaseIndent: function() {
          commitPendingTrailingSemicolon();
          writer.increaseIndent();
        }, decreaseIndent: function() {
          commitPendingTrailingSemicolon();
          writer.decreaseIndent();
        } });
      }
      ts3.getTrailingSemicolonDeferringWriter = getTrailingSemicolonDeferringWriter;
      function hostUsesCaseSensitiveFileNames(host) {
        return host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : false;
      }
      ts3.hostUsesCaseSensitiveFileNames = hostUsesCaseSensitiveFileNames;
      function hostGetCanonicalFileName(host) {
        return ts3.createGetCanonicalFileName(hostUsesCaseSensitiveFileNames(host));
      }
      ts3.hostGetCanonicalFileName = hostGetCanonicalFileName;
      function getResolvedExternalModuleName(host, file, referenceFile) {
        return file.moduleName || getExternalModuleNameFromPath(host, file.fileName, referenceFile && referenceFile.fileName);
      }
      ts3.getResolvedExternalModuleName = getResolvedExternalModuleName;
      function getCanonicalAbsolutePath(host, path2) {
        return host.getCanonicalFileName(ts3.getNormalizedAbsolutePath(path2, host.getCurrentDirectory()));
      }
      function getExternalModuleNameFromDeclaration(host, resolver, declaration) {
        var file = resolver.getExternalModuleFileFromDeclaration(declaration);
        if (!file || file.isDeclarationFile) {
          return void 0;
        }
        var specifier = getExternalModuleName(declaration);
        if (specifier && ts3.isStringLiteralLike(specifier) && !ts3.pathIsRelative(specifier.text) && getCanonicalAbsolutePath(host, file.path).indexOf(getCanonicalAbsolutePath(host, ts3.ensureTrailingDirectorySeparator(host.getCommonSourceDirectory()))) === -1) {
          return void 0;
        }
        return getResolvedExternalModuleName(host, file);
      }
      ts3.getExternalModuleNameFromDeclaration = getExternalModuleNameFromDeclaration;
      function getExternalModuleNameFromPath(host, fileName2, referencePath) {
        var getCanonicalFileName = function(f) {
          return host.getCanonicalFileName(f);
        };
        var dir = ts3.toPath(referencePath ? ts3.getDirectoryPath(referencePath) : host.getCommonSourceDirectory(), host.getCurrentDirectory(), getCanonicalFileName);
        var filePath = ts3.getNormalizedAbsolutePath(fileName2, host.getCurrentDirectory());
        var relativePath = ts3.getRelativePathToDirectoryOrUrl(dir, filePath, dir, getCanonicalFileName, false);
        var extensionless = removeFileExtension(relativePath);
        return referencePath ? ts3.ensurePathIsNonModuleName(extensionless) : extensionless;
      }
      ts3.getExternalModuleNameFromPath = getExternalModuleNameFromPath;
      function getOwnEmitOutputFilePath(fileName2, host, extension) {
        var compilerOptions = host.getCompilerOptions();
        var emitOutputFilePathWithoutExtension;
        if (compilerOptions.outDir) {
          emitOutputFilePathWithoutExtension = removeFileExtension(getSourceFilePathInNewDir(fileName2, host, compilerOptions.outDir));
        } else {
          emitOutputFilePathWithoutExtension = removeFileExtension(fileName2);
        }
        return emitOutputFilePathWithoutExtension + extension;
      }
      ts3.getOwnEmitOutputFilePath = getOwnEmitOutputFilePath;
      function getDeclarationEmitOutputFilePath(fileName2, host) {
        return getDeclarationEmitOutputFilePathWorker(fileName2, host.getCompilerOptions(), host.getCurrentDirectory(), host.getCommonSourceDirectory(), function(f) {
          return host.getCanonicalFileName(f);
        });
      }
      ts3.getDeclarationEmitOutputFilePath = getDeclarationEmitOutputFilePath;
      function getDeclarationEmitOutputFilePathWorker(fileName2, options, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
        var outputDir = options.declarationDir || options.outDir;
        var path2 = outputDir ? getSourceFilePathInNewDirWorker(fileName2, outputDir, currentDirectory, commonSourceDirectory, getCanonicalFileName) : fileName2;
        var declarationExtension = getDeclarationEmitExtensionForPath(path2);
        return removeFileExtension(path2) + declarationExtension;
      }
      ts3.getDeclarationEmitOutputFilePathWorker = getDeclarationEmitOutputFilePathWorker;
      function getDeclarationEmitExtensionForPath(path2) {
        return ts3.fileExtensionIsOneOf(path2, [".mjs", ".mts"]) ? ".d.mts" : ts3.fileExtensionIsOneOf(path2, [".cjs", ".cts"]) ? ".d.cts" : ts3.fileExtensionIsOneOf(path2, [".json"]) ? ".json.d.ts" : ".d.ts";
      }
      ts3.getDeclarationEmitExtensionForPath = getDeclarationEmitExtensionForPath;
      function getPossibleOriginalInputExtensionForExtension(path2) {
        return ts3.fileExtensionIsOneOf(path2, [".d.mts", ".mjs", ".mts"]) ? [".mts", ".mjs"] : ts3.fileExtensionIsOneOf(path2, [".d.cts", ".cjs", ".cts"]) ? [".cts", ".cjs"] : ts3.fileExtensionIsOneOf(path2, [".json.d.ts"]) ? [".json"] : [".tsx", ".ts", ".jsx", ".js"];
      }
      ts3.getPossibleOriginalInputExtensionForExtension = getPossibleOriginalInputExtensionForExtension;
      function outFile(options) {
        return options.outFile || options.out;
      }
      ts3.outFile = outFile;
      function getPathsBasePath(options, host) {
        var _a, _b;
        if (!options.paths)
          return void 0;
        return (_a = options.baseUrl) !== null && _a !== void 0 ? _a : ts3.Debug.checkDefined(options.pathsBasePath || ((_b = host.getCurrentDirectory) === null || _b === void 0 ? void 0 : _b.call(host)), "Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.");
      }
      ts3.getPathsBasePath = getPathsBasePath;
      function getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit) {
        var options = host.getCompilerOptions();
        if (outFile(options)) {
          var moduleKind = getEmitModuleKind(options);
          var moduleEmitEnabled_1 = options.emitDeclarationOnly || moduleKind === ts3.ModuleKind.AMD || moduleKind === ts3.ModuleKind.System;
          return ts3.filter(host.getSourceFiles(), function(sourceFile) {
            return (moduleEmitEnabled_1 || !ts3.isExternalModule(sourceFile)) && sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit);
          });
        } else {
          var sourceFiles = targetSourceFile === void 0 ? host.getSourceFiles() : [targetSourceFile];
          return ts3.filter(sourceFiles, function(sourceFile) {
            return sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit);
          });
        }
      }
      ts3.getSourceFilesToEmit = getSourceFilesToEmit;
      function sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit) {
        var options = host.getCompilerOptions();
        return !(options.noEmitForJsFiles && isSourceFileJS(sourceFile)) && !sourceFile.isDeclarationFile && !host.isSourceFileFromExternalLibrary(sourceFile) && (forceDtsEmit || !(isJsonSourceFile(sourceFile) && host.getResolvedProjectReferenceToRedirect(sourceFile.fileName)) && !host.isSourceOfProjectReferenceRedirect(sourceFile.fileName));
      }
      ts3.sourceFileMayBeEmitted = sourceFileMayBeEmitted;
      function getSourceFilePathInNewDir(fileName2, host, newDirPath) {
        return getSourceFilePathInNewDirWorker(fileName2, newDirPath, host.getCurrentDirectory(), host.getCommonSourceDirectory(), function(f) {
          return host.getCanonicalFileName(f);
        });
      }
      ts3.getSourceFilePathInNewDir = getSourceFilePathInNewDir;
      function getSourceFilePathInNewDirWorker(fileName2, newDirPath, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
        var sourceFilePath = ts3.getNormalizedAbsolutePath(fileName2, currentDirectory);
        var isSourceFileInCommonSourceDirectory = getCanonicalFileName(sourceFilePath).indexOf(getCanonicalFileName(commonSourceDirectory)) === 0;
        sourceFilePath = isSourceFileInCommonSourceDirectory ? sourceFilePath.substring(commonSourceDirectory.length) : sourceFilePath;
        return ts3.combinePaths(newDirPath, sourceFilePath);
      }
      ts3.getSourceFilePathInNewDirWorker = getSourceFilePathInNewDirWorker;
      function writeFile(host, diagnostics, fileName2, text, writeByteOrderMark, sourceFiles, data) {
        host.writeFile(fileName2, text, writeByteOrderMark, function(hostErrorMessage) {
          diagnostics.add(createCompilerDiagnostic(ts3.Diagnostics.Could_not_write_file_0_Colon_1, fileName2, hostErrorMessage));
        }, sourceFiles, data);
      }
      ts3.writeFile = writeFile;
      function ensureDirectoriesExist(directoryPath, createDirectory, directoryExists) {
        if (directoryPath.length > ts3.getRootLength(directoryPath) && !directoryExists(directoryPath)) {
          var parentDirectory = ts3.getDirectoryPath(directoryPath);
          ensureDirectoriesExist(parentDirectory, createDirectory, directoryExists);
          createDirectory(directoryPath);
        }
      }
      function writeFileEnsuringDirectories(path2, data, writeByteOrderMark, writeFile2, createDirectory, directoryExists) {
        try {
          writeFile2(path2, data, writeByteOrderMark);
        } catch (_a) {
          ensureDirectoriesExist(ts3.getDirectoryPath(ts3.normalizePath(path2)), createDirectory, directoryExists);
          writeFile2(path2, data, writeByteOrderMark);
        }
      }
      ts3.writeFileEnsuringDirectories = writeFileEnsuringDirectories;
      function getLineOfLocalPosition(sourceFile, pos) {
        var lineStarts = ts3.getLineStarts(sourceFile);
        return ts3.computeLineOfPosition(lineStarts, pos);
      }
      ts3.getLineOfLocalPosition = getLineOfLocalPosition;
      function getLineOfLocalPositionFromLineMap(lineMap, pos) {
        return ts3.computeLineOfPosition(lineMap, pos);
      }
      ts3.getLineOfLocalPositionFromLineMap = getLineOfLocalPositionFromLineMap;
      function getFirstConstructorWithBody(node) {
        return ts3.find(node.members, function(member) {
          return ts3.isConstructorDeclaration(member) && nodeIsPresent(member.body);
        });
      }
      ts3.getFirstConstructorWithBody = getFirstConstructorWithBody;
      function getSetAccessorValueParameter(accessor) {
        if (accessor && accessor.parameters.length > 0) {
          var hasThis = accessor.parameters.length === 2 && parameterIsThisKeyword(accessor.parameters[0]);
          return accessor.parameters[hasThis ? 1 : 0];
        }
      }
      ts3.getSetAccessorValueParameter = getSetAccessorValueParameter;
      function getSetAccessorTypeAnnotationNode(accessor) {
        var parameter = getSetAccessorValueParameter(accessor);
        return parameter && parameter.type;
      }
      ts3.getSetAccessorTypeAnnotationNode = getSetAccessorTypeAnnotationNode;
      function getThisParameter(signature) {
        if (signature.parameters.length && !ts3.isJSDocSignature(signature)) {
          var thisParameter = signature.parameters[0];
          if (parameterIsThisKeyword(thisParameter)) {
            return thisParameter;
          }
        }
      }
      ts3.getThisParameter = getThisParameter;
      function parameterIsThisKeyword(parameter) {
        return isThisIdentifier(parameter.name);
      }
      ts3.parameterIsThisKeyword = parameterIsThisKeyword;
      function isThisIdentifier(node) {
        return !!node && node.kind === 79 && identifierIsThisKeyword(node);
      }
      ts3.isThisIdentifier = isThisIdentifier;
      function isThisInTypeQuery(node) {
        if (!isThisIdentifier(node)) {
          return false;
        }
        while (ts3.isQualifiedName(node.parent) && node.parent.left === node) {
          node = node.parent;
        }
        return node.parent.kind === 181;
      }
      ts3.isThisInTypeQuery = isThisInTypeQuery;
      function identifierIsThisKeyword(id) {
        return id.originalKeywordKind === 108;
      }
      ts3.identifierIsThisKeyword = identifierIsThisKeyword;
      function getAllAccessorDeclarations(declarations, accessor) {
        var firstAccessor;
        var secondAccessor;
        var getAccessor;
        var setAccessor;
        if (hasDynamicName(accessor)) {
          firstAccessor = accessor;
          if (accessor.kind === 172) {
            getAccessor = accessor;
          } else if (accessor.kind === 173) {
            setAccessor = accessor;
          } else {
            ts3.Debug.fail("Accessor has wrong kind");
          }
        } else {
          ts3.forEach(declarations, function(member) {
            if (ts3.isAccessor(member) && isStatic(member) === isStatic(accessor)) {
              var memberName = getPropertyNameForPropertyNameNode(member.name);
              var accessorName = getPropertyNameForPropertyNameNode(accessor.name);
              if (memberName === accessorName) {
                if (!firstAccessor) {
                  firstAccessor = member;
                } else if (!secondAccessor) {
                  secondAccessor = member;
                }
                if (member.kind === 172 && !getAccessor) {
                  getAccessor = member;
                }
                if (member.kind === 173 && !setAccessor) {
                  setAccessor = member;
                }
              }
            }
          });
        }
        return {
          firstAccessor,
          secondAccessor,
          getAccessor,
          setAccessor
        };
      }
      ts3.getAllAccessorDeclarations = getAllAccessorDeclarations;
      function getEffectiveTypeAnnotationNode(node) {
        if (!isInJSFile(node) && ts3.isFunctionDeclaration(node))
          return void 0;
        var type2 = node.type;
        if (type2 || !isInJSFile(node))
          return type2;
        return ts3.isJSDocPropertyLikeTag(node) ? node.typeExpression && node.typeExpression.type : ts3.getJSDocType(node);
      }
      ts3.getEffectiveTypeAnnotationNode = getEffectiveTypeAnnotationNode;
      function getTypeAnnotationNode(node) {
        return node.type;
      }
      ts3.getTypeAnnotationNode = getTypeAnnotationNode;
      function getEffectiveReturnTypeNode(node) {
        return ts3.isJSDocSignature(node) ? node.type && node.type.typeExpression && node.type.typeExpression.type : node.type || (isInJSFile(node) ? ts3.getJSDocReturnType(node) : void 0);
      }
      ts3.getEffectiveReturnTypeNode = getEffectiveReturnTypeNode;
      function getJSDocTypeParameterDeclarations(node) {
        return ts3.flatMap(ts3.getJSDocTags(node), function(tag) {
          return isNonTypeAliasTemplate(tag) ? tag.typeParameters : void 0;
        });
      }
      ts3.getJSDocTypeParameterDeclarations = getJSDocTypeParameterDeclarations;
      function isNonTypeAliasTemplate(tag) {
        return ts3.isJSDocTemplateTag(tag) && !(tag.parent.kind === 320 && tag.parent.tags.some(isJSDocTypeAlias));
      }
      function getEffectiveSetAccessorTypeAnnotationNode(node) {
        var parameter = getSetAccessorValueParameter(node);
        return parameter && getEffectiveTypeAnnotationNode(parameter);
      }
      ts3.getEffectiveSetAccessorTypeAnnotationNode = getEffectiveSetAccessorTypeAnnotationNode;
      function emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments) {
        emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, node.pos, leadingComments);
      }
      ts3.emitNewLineBeforeLeadingComments = emitNewLineBeforeLeadingComments;
      function emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, pos, leadingComments) {
        if (leadingComments && leadingComments.length && pos !== leadingComments[0].pos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, leadingComments[0].pos)) {
          writer.writeLine();
        }
      }
      ts3.emitNewLineBeforeLeadingCommentsOfPosition = emitNewLineBeforeLeadingCommentsOfPosition;
      function emitNewLineBeforeLeadingCommentOfPosition(lineMap, writer, pos, commentPos) {
        if (pos !== commentPos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, commentPos)) {
          writer.writeLine();
        }
      }
      ts3.emitNewLineBeforeLeadingCommentOfPosition = emitNewLineBeforeLeadingCommentOfPosition;
      function emitComments(text, lineMap, writer, comments, leadingSeparator, trailingSeparator, newLine, writeComment) {
        if (comments && comments.length > 0) {
          if (leadingSeparator) {
            writer.writeSpace(" ");
          }
          var emitInterveningSeparator = false;
          for (var _i = 0, comments_1 = comments; _i < comments_1.length; _i++) {
            var comment = comments_1[_i];
            if (emitInterveningSeparator) {
              writer.writeSpace(" ");
              emitInterveningSeparator = false;
            }
            writeComment(text, lineMap, writer, comment.pos, comment.end, newLine);
            if (comment.hasTrailingNewLine) {
              writer.writeLine();
            } else {
              emitInterveningSeparator = true;
            }
          }
          if (emitInterveningSeparator && trailingSeparator) {
            writer.writeSpace(" ");
          }
        }
      }
      ts3.emitComments = emitComments;
      function emitDetachedComments(text, lineMap, writer, writeComment, node, newLine, removeComments) {
        var leadingComments;
        var currentDetachedCommentInfo;
        if (removeComments) {
          if (node.pos === 0) {
            leadingComments = ts3.filter(ts3.getLeadingCommentRanges(text, node.pos), isPinnedCommentLocal);
          }
        } else {
          leadingComments = ts3.getLeadingCommentRanges(text, node.pos);
        }
        if (leadingComments) {
          var detachedComments = [];
          var lastComment = void 0;
          for (var _i = 0, leadingComments_1 = leadingComments; _i < leadingComments_1.length; _i++) {
            var comment = leadingComments_1[_i];
            if (lastComment) {
              var lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, lastComment.end);
              var commentLine = getLineOfLocalPositionFromLineMap(lineMap, comment.pos);
              if (commentLine >= lastCommentLine + 2) {
                break;
              }
            }
            detachedComments.push(comment);
            lastComment = comment;
          }
          if (detachedComments.length) {
            var lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, ts3.last(detachedComments).end);
            var nodeLine = getLineOfLocalPositionFromLineMap(lineMap, ts3.skipTrivia(text, node.pos));
            if (nodeLine >= lastCommentLine + 2) {
              emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments);
              emitComments(text, lineMap, writer, detachedComments, false, true, newLine, writeComment);
              currentDetachedCommentInfo = { nodePos: node.pos, detachedCommentEndPos: ts3.last(detachedComments).end };
            }
          }
        }
        return currentDetachedCommentInfo;
        function isPinnedCommentLocal(comment2) {
          return isPinnedComment(text, comment2.pos);
        }
      }
      ts3.emitDetachedComments = emitDetachedComments;
      function writeCommentRange(text, lineMap, writer, commentPos, commentEnd, newLine) {
        if (text.charCodeAt(commentPos + 1) === 42) {
          var firstCommentLineAndCharacter = ts3.computeLineAndCharacterOfPosition(lineMap, commentPos);
          var lineCount = lineMap.length;
          var firstCommentLineIndent = void 0;
          for (var pos = commentPos, currentLine = firstCommentLineAndCharacter.line; pos < commentEnd; currentLine++) {
            var nextLineStart = currentLine + 1 === lineCount ? text.length + 1 : lineMap[currentLine + 1];
            if (pos !== commentPos) {
              if (firstCommentLineIndent === void 0) {
                firstCommentLineIndent = calculateIndent(text, lineMap[firstCommentLineAndCharacter.line], commentPos);
              }
              var currentWriterIndentSpacing = writer.getIndent() * getIndentSize();
              var spacesToEmit = currentWriterIndentSpacing - firstCommentLineIndent + calculateIndent(text, pos, nextLineStart);
              if (spacesToEmit > 0) {
                var numberOfSingleSpacesToEmit = spacesToEmit % getIndentSize();
                var indentSizeSpaceString = getIndentString((spacesToEmit - numberOfSingleSpacesToEmit) / getIndentSize());
                writer.rawWrite(indentSizeSpaceString);
                while (numberOfSingleSpacesToEmit) {
                  writer.rawWrite(" ");
                  numberOfSingleSpacesToEmit--;
                }
              } else {
                writer.rawWrite("");
              }
            }
            writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart);
            pos = nextLineStart;
          }
        } else {
          writer.writeComment(text.substring(commentPos, commentEnd));
        }
      }
      ts3.writeCommentRange = writeCommentRange;
      function writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart) {
        var end = Math.min(commentEnd, nextLineStart - 1);
        var currentLineText = ts3.trimString(text.substring(pos, end));
        if (currentLineText) {
          writer.writeComment(currentLineText);
          if (end !== commentEnd) {
            writer.writeLine();
          }
        } else {
          writer.rawWrite(newLine);
        }
      }
      function calculateIndent(text, pos, end) {
        var currentLineIndent = 0;
        for (; pos < end && ts3.isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++) {
          if (text.charCodeAt(pos) === 9) {
            currentLineIndent += getIndentSize() - currentLineIndent % getIndentSize();
          } else {
            currentLineIndent++;
          }
        }
        return currentLineIndent;
      }
      function hasEffectiveModifiers(node) {
        return getEffectiveModifierFlags(node) !== 0;
      }
      ts3.hasEffectiveModifiers = hasEffectiveModifiers;
      function hasSyntacticModifiers(node) {
        return getSyntacticModifierFlags(node) !== 0;
      }
      ts3.hasSyntacticModifiers = hasSyntacticModifiers;
      function hasEffectiveModifier(node, flags) {
        return !!getSelectedEffectiveModifierFlags(node, flags);
      }
      ts3.hasEffectiveModifier = hasEffectiveModifier;
      function hasSyntacticModifier(node, flags) {
        return !!getSelectedSyntacticModifierFlags(node, flags);
      }
      ts3.hasSyntacticModifier = hasSyntacticModifier;
      function isStatic(node) {
        return ts3.isClassElement(node) && hasStaticModifier(node) || ts3.isClassStaticBlockDeclaration(node);
      }
      ts3.isStatic = isStatic;
      function hasStaticModifier(node) {
        return hasSyntacticModifier(node, 32);
      }
      ts3.hasStaticModifier = hasStaticModifier;
      function hasOverrideModifier(node) {
        return hasEffectiveModifier(node, 16384);
      }
      ts3.hasOverrideModifier = hasOverrideModifier;
      function hasAbstractModifier(node) {
        return hasSyntacticModifier(node, 128);
      }
      ts3.hasAbstractModifier = hasAbstractModifier;
      function hasAmbientModifier(node) {
        return hasSyntacticModifier(node, 2);
      }
      ts3.hasAmbientModifier = hasAmbientModifier;
      function hasEffectiveReadonlyModifier(node) {
        return hasEffectiveModifier(node, 64);
      }
      ts3.hasEffectiveReadonlyModifier = hasEffectiveReadonlyModifier;
      function getSelectedEffectiveModifierFlags(node, flags) {
        return getEffectiveModifierFlags(node) & flags;
      }
      ts3.getSelectedEffectiveModifierFlags = getSelectedEffectiveModifierFlags;
      function getSelectedSyntacticModifierFlags(node, flags) {
        return getSyntacticModifierFlags(node) & flags;
      }
      ts3.getSelectedSyntacticModifierFlags = getSelectedSyntacticModifierFlags;
      function getModifierFlagsWorker(node, includeJSDoc, alwaysIncludeJSDoc) {
        if (node.kind >= 0 && node.kind <= 160) {
          return 0;
        }
        if (!(node.modifierFlagsCache & 536870912)) {
          node.modifierFlagsCache = getSyntacticModifierFlagsNoCache(node) | 536870912;
        }
        if (includeJSDoc && !(node.modifierFlagsCache & 4096) && (alwaysIncludeJSDoc || isInJSFile(node)) && node.parent) {
          node.modifierFlagsCache |= getJSDocModifierFlagsNoCache(node) | 4096;
        }
        return node.modifierFlagsCache & ~(536870912 | 4096);
      }
      function getEffectiveModifierFlags(node) {
        return getModifierFlagsWorker(node, true);
      }
      ts3.getEffectiveModifierFlags = getEffectiveModifierFlags;
      function getEffectiveModifierFlagsAlwaysIncludeJSDoc(node) {
        return getModifierFlagsWorker(node, true, true);
      }
      ts3.getEffectiveModifierFlagsAlwaysIncludeJSDoc = getEffectiveModifierFlagsAlwaysIncludeJSDoc;
      function getSyntacticModifierFlags(node) {
        return getModifierFlagsWorker(node, false);
      }
      ts3.getSyntacticModifierFlags = getSyntacticModifierFlags;
      function getJSDocModifierFlagsNoCache(node) {
        var flags = 0;
        if (!!node.parent && !ts3.isParameter(node)) {
          if (isInJSFile(node)) {
            if (ts3.getJSDocPublicTagNoCache(node))
              flags |= 4;
            if (ts3.getJSDocPrivateTagNoCache(node))
              flags |= 8;
            if (ts3.getJSDocProtectedTagNoCache(node))
              flags |= 16;
            if (ts3.getJSDocReadonlyTagNoCache(node))
              flags |= 64;
            if (ts3.getJSDocOverrideTagNoCache(node))
              flags |= 16384;
          }
          if (ts3.getJSDocDeprecatedTagNoCache(node))
            flags |= 8192;
        }
        return flags;
      }
      function getEffectiveModifierFlagsNoCache(node) {
        return getSyntacticModifierFlagsNoCache(node) | getJSDocModifierFlagsNoCache(node);
      }
      ts3.getEffectiveModifierFlagsNoCache = getEffectiveModifierFlagsNoCache;
      function getSyntacticModifierFlagsNoCache(node) {
        var flags = modifiersToFlags(node.modifiers);
        if (node.flags & 4 || node.kind === 79 && node.isInJSDocNamespace) {
          flags |= 1;
        }
        return flags;
      }
      ts3.getSyntacticModifierFlagsNoCache = getSyntacticModifierFlagsNoCache;
      function modifiersToFlags(modifiers) {
        var flags = 0;
        if (modifiers) {
          for (var _i = 0, modifiers_1 = modifiers; _i < modifiers_1.length; _i++) {
            var modifier = modifiers_1[_i];
            flags |= modifierToFlag(modifier.kind);
          }
        }
        return flags;
      }
      ts3.modifiersToFlags = modifiersToFlags;
      function modifierToFlag(token) {
        switch (token) {
          case 124:
            return 32;
          case 123:
            return 4;
          case 122:
            return 16;
          case 121:
            return 8;
          case 126:
            return 128;
          case 93:
            return 1;
          case 135:
            return 2;
          case 85:
            return 2048;
          case 88:
            return 512;
          case 131:
            return 256;
          case 145:
            return 64;
          case 159:
            return 16384;
          case 101:
            return 32768;
          case 144:
            return 65536;
        }
        return 0;
      }
      ts3.modifierToFlag = modifierToFlag;
      function createModifiers(modifierFlags) {
        return modifierFlags ? ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
      }
      ts3.createModifiers = createModifiers;
      function isLogicalOperator(token) {
        return token === 56 || token === 55 || token === 53;
      }
      ts3.isLogicalOperator = isLogicalOperator;
      function isLogicalOrCoalescingAssignmentOperator(token) {
        return token === 75 || token === 76 || token === 77;
      }
      ts3.isLogicalOrCoalescingAssignmentOperator = isLogicalOrCoalescingAssignmentOperator;
      function isLogicalOrCoalescingAssignmentExpression(expr) {
        return isLogicalOrCoalescingAssignmentOperator(expr.operatorToken.kind);
      }
      ts3.isLogicalOrCoalescingAssignmentExpression = isLogicalOrCoalescingAssignmentExpression;
      function isAssignmentOperator(token) {
        return token >= 63 && token <= 78;
      }
      ts3.isAssignmentOperator = isAssignmentOperator;
      function tryGetClassExtendingExpressionWithTypeArguments(node) {
        var cls = tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
        return cls && !cls.isImplements ? cls.class : void 0;
      }
      ts3.tryGetClassExtendingExpressionWithTypeArguments = tryGetClassExtendingExpressionWithTypeArguments;
      function tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node) {
        return ts3.isExpressionWithTypeArguments(node) && ts3.isHeritageClause(node.parent) && ts3.isClassLike(node.parent.parent) ? { class: node.parent.parent, isImplements: node.parent.token === 117 } : void 0;
      }
      ts3.tryGetClassImplementingOrExtendingExpressionWithTypeArguments = tryGetClassImplementingOrExtendingExpressionWithTypeArguments;
      function isAssignmentExpression(node, excludeCompoundAssignment) {
        return ts3.isBinaryExpression(node) && (excludeCompoundAssignment ? node.operatorToken.kind === 63 : isAssignmentOperator(node.operatorToken.kind)) && ts3.isLeftHandSideExpression(node.left);
      }
      ts3.isAssignmentExpression = isAssignmentExpression;
      function isLeftHandSideOfAssignment(node) {
        return isAssignmentExpression(node.parent) && node.parent.left === node;
      }
      ts3.isLeftHandSideOfAssignment = isLeftHandSideOfAssignment;
      function isDestructuringAssignment(node) {
        if (isAssignmentExpression(node, true)) {
          var kind = node.left.kind;
          return kind === 205 || kind === 204;
        }
        return false;
      }
      ts3.isDestructuringAssignment = isDestructuringAssignment;
      function isExpressionWithTypeArgumentsInClassExtendsClause(node) {
        return tryGetClassExtendingExpressionWithTypeArguments(node) !== void 0;
      }
      ts3.isExpressionWithTypeArgumentsInClassExtendsClause = isExpressionWithTypeArgumentsInClassExtendsClause;
      function isEntityNameExpression(node) {
        return node.kind === 79 || isPropertyAccessEntityNameExpression(node);
      }
      ts3.isEntityNameExpression = isEntityNameExpression;
      function getFirstIdentifier(node) {
        switch (node.kind) {
          case 79:
            return node;
          case 161:
            do {
              node = node.left;
            } while (node.kind !== 79);
            return node;
          case 206:
            do {
              node = node.expression;
            } while (node.kind !== 79);
            return node;
        }
      }
      ts3.getFirstIdentifier = getFirstIdentifier;
      function isDottedName(node) {
        return node.kind === 79 || node.kind === 108 || node.kind === 106 || node.kind === 231 || node.kind === 206 && isDottedName(node.expression) || node.kind === 212 && isDottedName(node.expression);
      }
      ts3.isDottedName = isDottedName;
      function isPropertyAccessEntityNameExpression(node) {
        return ts3.isPropertyAccessExpression(node) && ts3.isIdentifier(node.name) && isEntityNameExpression(node.expression);
      }
      ts3.isPropertyAccessEntityNameExpression = isPropertyAccessEntityNameExpression;
      function tryGetPropertyAccessOrIdentifierToString(expr) {
        if (ts3.isPropertyAccessExpression(expr)) {
          var baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (baseStr !== void 0) {
            return baseStr + "." + entityNameToString(expr.name);
          }
        } else if (ts3.isElementAccessExpression(expr)) {
          var baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (baseStr !== void 0 && ts3.isPropertyName(expr.argumentExpression)) {
            return baseStr + "." + getPropertyNameForPropertyNameNode(expr.argumentExpression);
          }
        } else if (ts3.isIdentifier(expr)) {
          return ts3.unescapeLeadingUnderscores(expr.escapedText);
        }
        return void 0;
      }
      ts3.tryGetPropertyAccessOrIdentifierToString = tryGetPropertyAccessOrIdentifierToString;
      function isPrototypeAccess(node) {
        return isBindableStaticAccessExpression(node) && getElementOrPropertyAccessName(node) === "prototype";
      }
      ts3.isPrototypeAccess = isPrototypeAccess;
      function isRightSideOfQualifiedNameOrPropertyAccess(node) {
        return node.parent.kind === 161 && node.parent.right === node || node.parent.kind === 206 && node.parent.name === node;
      }
      ts3.isRightSideOfQualifiedNameOrPropertyAccess = isRightSideOfQualifiedNameOrPropertyAccess;
      function isRightSideOfAccessExpression(node) {
        return ts3.isPropertyAccessExpression(node.parent) && node.parent.name === node || ts3.isElementAccessExpression(node.parent) && node.parent.argumentExpression === node;
      }
      ts3.isRightSideOfAccessExpression = isRightSideOfAccessExpression;
      function isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName(node) {
        return ts3.isQualifiedName(node.parent) && node.parent.right === node || ts3.isPropertyAccessExpression(node.parent) && node.parent.name === node || ts3.isJSDocMemberName(node.parent) && node.parent.right === node;
      }
      ts3.isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName = isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName;
      function isEmptyObjectLiteral(expression) {
        return expression.kind === 205 && expression.properties.length === 0;
      }
      ts3.isEmptyObjectLiteral = isEmptyObjectLiteral;
      function isEmptyArrayLiteral(expression) {
        return expression.kind === 204 && expression.elements.length === 0;
      }
      ts3.isEmptyArrayLiteral = isEmptyArrayLiteral;
      function getLocalSymbolForExportDefault(symbol) {
        if (!isExportDefaultSymbol(symbol) || !symbol.declarations)
          return void 0;
        for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
          var decl = _a[_i];
          if (decl.localSymbol)
            return decl.localSymbol;
        }
        return void 0;
      }
      ts3.getLocalSymbolForExportDefault = getLocalSymbolForExportDefault;
      function isExportDefaultSymbol(symbol) {
        return symbol && ts3.length(symbol.declarations) > 0 && hasSyntacticModifier(symbol.declarations[0], 512);
      }
      function tryExtractTSExtension(fileName2) {
        return ts3.find(supportedTSExtensionsForExtractExtension, function(extension) {
          return ts3.fileExtensionIs(fileName2, extension);
        });
      }
      ts3.tryExtractTSExtension = tryExtractTSExtension;
      function getExpandedCharCodes(input) {
        var output = [];
        var length = input.length;
        for (var i = 0; i < length; i++) {
          var charCode = input.charCodeAt(i);
          if (charCode < 128) {
            output.push(charCode);
          } else if (charCode < 2048) {
            output.push(charCode >> 6 | 192);
            output.push(charCode & 63 | 128);
          } else if (charCode < 65536) {
            output.push(charCode >> 12 | 224);
            output.push(charCode >> 6 & 63 | 128);
            output.push(charCode & 63 | 128);
          } else if (charCode < 131072) {
            output.push(charCode >> 18 | 240);
            output.push(charCode >> 12 & 63 | 128);
            output.push(charCode >> 6 & 63 | 128);
            output.push(charCode & 63 | 128);
          } else {
            ts3.Debug.assert(false, "Unexpected code point");
          }
        }
        return output;
      }
      var base64Digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
      function convertToBase64(input) {
        var result2 = "";
        var charCodes = getExpandedCharCodes(input);
        var i = 0;
        var length = charCodes.length;
        var byte1, byte2, byte3, byte4;
        while (i < length) {
          byte1 = charCodes[i] >> 2;
          byte2 = (charCodes[i] & 3) << 4 | charCodes[i + 1] >> 4;
          byte3 = (charCodes[i + 1] & 15) << 2 | charCodes[i + 2] >> 6;
          byte4 = charCodes[i + 2] & 63;
          if (i + 1 >= length) {
            byte3 = byte4 = 64;
          } else if (i + 2 >= length) {
            byte4 = 64;
          }
          result2 += base64Digits.charAt(byte1) + base64Digits.charAt(byte2) + base64Digits.charAt(byte3) + base64Digits.charAt(byte4);
          i += 3;
        }
        return result2;
      }
      ts3.convertToBase64 = convertToBase64;
      function getStringFromExpandedCharCodes(codes) {
        var output = "";
        var i = 0;
        var length = codes.length;
        while (i < length) {
          var charCode = codes[i];
          if (charCode < 128) {
            output += String.fromCharCode(charCode);
            i++;
          } else if ((charCode & 192) === 192) {
            var value = charCode & 63;
            i++;
            var nextCode = codes[i];
            while ((nextCode & 192) === 128) {
              value = value << 6 | nextCode & 63;
              i++;
              nextCode = codes[i];
            }
            output += String.fromCharCode(value);
          } else {
            output += String.fromCharCode(charCode);
            i++;
          }
        }
        return output;
      }
      function base64encode(host, input) {
        if (host && host.base64encode) {
          return host.base64encode(input);
        }
        return convertToBase64(input);
      }
      ts3.base64encode = base64encode;
      function base64decode(host, input) {
        if (host && host.base64decode) {
          return host.base64decode(input);
        }
        var length = input.length;
        var expandedCharCodes = [];
        var i = 0;
        while (i < length) {
          if (input.charCodeAt(i) === base64Digits.charCodeAt(64)) {
            break;
          }
          var ch1 = base64Digits.indexOf(input[i]);
          var ch2 = base64Digits.indexOf(input[i + 1]);
          var ch3 = base64Digits.indexOf(input[i + 2]);
          var ch4 = base64Digits.indexOf(input[i + 3]);
          var code1 = (ch1 & 63) << 2 | ch2 >> 4 & 3;
          var code2 = (ch2 & 15) << 4 | ch3 >> 2 & 15;
          var code3 = (ch3 & 3) << 6 | ch4 & 63;
          if (code2 === 0 && ch3 !== 0) {
            expandedCharCodes.push(code1);
          } else if (code3 === 0 && ch4 !== 0) {
            expandedCharCodes.push(code1, code2);
          } else {
            expandedCharCodes.push(code1, code2, code3);
          }
          i += 4;
        }
        return getStringFromExpandedCharCodes(expandedCharCodes);
      }
      ts3.base64decode = base64decode;
      function readJson(path2, host) {
        try {
          var jsonText = host.readFile(path2);
          if (!jsonText)
            return {};
          var result2 = ts3.parseConfigFileTextToJson(path2, jsonText);
          if (result2.error) {
            return {};
          }
          return result2.config;
        } catch (e) {
          return {};
        }
      }
      ts3.readJson = readJson;
      function directoryProbablyExists(directoryName, host) {
        return !host.directoryExists || host.directoryExists(directoryName);
      }
      ts3.directoryProbablyExists = directoryProbablyExists;
      var carriageReturnLineFeed = "\r\n";
      var lineFeed = "\n";
      function getNewLineCharacter(options, getNewLine) {
        switch (options.newLine) {
          case 0:
            return carriageReturnLineFeed;
          case 1:
            return lineFeed;
        }
        return getNewLine ? getNewLine() : ts3.sys ? ts3.sys.newLine : carriageReturnLineFeed;
      }
      ts3.getNewLineCharacter = getNewLineCharacter;
      function createRange(pos, end) {
        if (end === void 0) {
          end = pos;
        }
        ts3.Debug.assert(end >= pos || end === -1);
        return { pos, end };
      }
      ts3.createRange = createRange;
      function moveRangeEnd(range, end) {
        return createRange(range.pos, end);
      }
      ts3.moveRangeEnd = moveRangeEnd;
      function moveRangePos(range, pos) {
        return createRange(pos, range.end);
      }
      ts3.moveRangePos = moveRangePos;
      function moveRangePastDecorators(node) {
        return node.decorators && node.decorators.length > 0 ? moveRangePos(node, node.decorators.end) : node;
      }
      ts3.moveRangePastDecorators = moveRangePastDecorators;
      function moveRangePastModifiers(node) {
        return node.modifiers && node.modifiers.length > 0 ? moveRangePos(node, node.modifiers.end) : moveRangePastDecorators(node);
      }
      ts3.moveRangePastModifiers = moveRangePastModifiers;
      function isCollapsedRange(range) {
        return range.pos === range.end;
      }
      ts3.isCollapsedRange = isCollapsedRange;
      function createTokenRange(pos, token) {
        return createRange(pos, pos + ts3.tokenToString(token).length);
      }
      ts3.createTokenRange = createTokenRange;
      function rangeIsOnSingleLine(range, sourceFile) {
        return rangeStartIsOnSameLineAsRangeEnd(range, range, sourceFile);
      }
      ts3.rangeIsOnSingleLine = rangeIsOnSingleLine;
      function rangeStartPositionsAreOnSameLine(range1, range2, sourceFile) {
        return positionsAreOnSameLine(getStartPositionOfRange(range1, sourceFile, false), getStartPositionOfRange(range2, sourceFile, false), sourceFile);
      }
      ts3.rangeStartPositionsAreOnSameLine = rangeStartPositionsAreOnSameLine;
      function rangeEndPositionsAreOnSameLine(range1, range2, sourceFile) {
        return positionsAreOnSameLine(range1.end, range2.end, sourceFile);
      }
      ts3.rangeEndPositionsAreOnSameLine = rangeEndPositionsAreOnSameLine;
      function rangeStartIsOnSameLineAsRangeEnd(range1, range2, sourceFile) {
        return positionsAreOnSameLine(getStartPositionOfRange(range1, sourceFile, false), range2.end, sourceFile);
      }
      ts3.rangeStartIsOnSameLineAsRangeEnd = rangeStartIsOnSameLineAsRangeEnd;
      function rangeEndIsOnSameLineAsRangeStart(range1, range2, sourceFile) {
        return positionsAreOnSameLine(range1.end, getStartPositionOfRange(range2, sourceFile, false), sourceFile);
      }
      ts3.rangeEndIsOnSameLineAsRangeStart = rangeEndIsOnSameLineAsRangeStart;
      function getLinesBetweenRangeEndAndRangeStart(range1, range2, sourceFile, includeSecondRangeComments) {
        var range2Start = getStartPositionOfRange(range2, sourceFile, includeSecondRangeComments);
        return ts3.getLinesBetweenPositions(sourceFile, range1.end, range2Start);
      }
      ts3.getLinesBetweenRangeEndAndRangeStart = getLinesBetweenRangeEndAndRangeStart;
      function getLinesBetweenRangeEndPositions(range1, range2, sourceFile) {
        return ts3.getLinesBetweenPositions(sourceFile, range1.end, range2.end);
      }
      ts3.getLinesBetweenRangeEndPositions = getLinesBetweenRangeEndPositions;
      function isNodeArrayMultiLine(list, sourceFile) {
        return !positionsAreOnSameLine(list.pos, list.end, sourceFile);
      }
      ts3.isNodeArrayMultiLine = isNodeArrayMultiLine;
      function positionsAreOnSameLine(pos1, pos2, sourceFile) {
        return ts3.getLinesBetweenPositions(sourceFile, pos1, pos2) === 0;
      }
      ts3.positionsAreOnSameLine = positionsAreOnSameLine;
      function getStartPositionOfRange(range, sourceFile, includeComments) {
        return positionIsSynthesized(range.pos) ? -1 : ts3.skipTrivia(sourceFile.text, range.pos, false, includeComments);
      }
      ts3.getStartPositionOfRange = getStartPositionOfRange;
      function getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
        var startPos = ts3.skipTrivia(sourceFile.text, pos, false, includeComments);
        var prevPos = getPreviousNonWhitespacePosition(startPos, stopPos, sourceFile);
        return ts3.getLinesBetweenPositions(sourceFile, prevPos !== null && prevPos !== void 0 ? prevPos : stopPos, startPos);
      }
      ts3.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter = getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter;
      function getLinesBetweenPositionAndNextNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
        var nextPos = ts3.skipTrivia(sourceFile.text, pos, false, includeComments);
        return ts3.getLinesBetweenPositions(sourceFile, pos, Math.min(stopPos, nextPos));
      }
      ts3.getLinesBetweenPositionAndNextNonWhitespaceCharacter = getLinesBetweenPositionAndNextNonWhitespaceCharacter;
      function getPreviousNonWhitespacePosition(pos, stopPos, sourceFile) {
        if (stopPos === void 0) {
          stopPos = 0;
        }
        while (pos-- > stopPos) {
          if (!ts3.isWhiteSpaceLike(sourceFile.text.charCodeAt(pos))) {
            return pos;
          }
        }
      }
      function isDeclarationNameOfEnumOrNamespace(node) {
        var parseNode = ts3.getParseTreeNode(node);
        if (parseNode) {
          switch (parseNode.parent.kind) {
            case 260:
            case 261:
              return parseNode === parseNode.parent.name;
          }
        }
        return false;
      }
      ts3.isDeclarationNameOfEnumOrNamespace = isDeclarationNameOfEnumOrNamespace;
      function getInitializedVariables(node) {
        return ts3.filter(node.declarations, isInitializedVariable);
      }
      ts3.getInitializedVariables = getInitializedVariables;
      function isInitializedVariable(node) {
        return node.initializer !== void 0;
      }
      function isWatchSet(options) {
        return options.watch && options.hasOwnProperty("watch");
      }
      ts3.isWatchSet = isWatchSet;
      function closeFileWatcher(watcher) {
        watcher.close();
      }
      ts3.closeFileWatcher = closeFileWatcher;
      function getCheckFlags(symbol) {
        return symbol.flags & 33554432 ? symbol.checkFlags : 0;
      }
      ts3.getCheckFlags = getCheckFlags;
      function getDeclarationModifierFlagsFromSymbol(s, isWrite) {
        if (isWrite === void 0) {
          isWrite = false;
        }
        if (s.valueDeclaration) {
          var declaration = isWrite && s.declarations && ts3.find(s.declarations, function(d) {
            return d.kind === 173;
          }) || s.valueDeclaration;
          var flags = ts3.getCombinedModifierFlags(declaration);
          return s.parent && s.parent.flags & 32 ? flags : flags & ~28;
        }
        if (getCheckFlags(s) & 6) {
          var checkFlags = s.checkFlags;
          var accessModifier = checkFlags & 1024 ? 8 : checkFlags & 256 ? 4 : 16;
          var staticModifier = checkFlags & 2048 ? 32 : 0;
          return accessModifier | staticModifier;
        }
        if (s.flags & 4194304) {
          return 4 | 32;
        }
        return 0;
      }
      ts3.getDeclarationModifierFlagsFromSymbol = getDeclarationModifierFlagsFromSymbol;
      function skipAlias(symbol, checker) {
        return symbol.flags & 2097152 ? checker.getAliasedSymbol(symbol) : symbol;
      }
      ts3.skipAlias = skipAlias;
      function getCombinedLocalAndExportSymbolFlags(symbol) {
        return symbol.exportSymbol ? symbol.exportSymbol.flags | symbol.flags : symbol.flags;
      }
      ts3.getCombinedLocalAndExportSymbolFlags = getCombinedLocalAndExportSymbolFlags;
      function isWriteOnlyAccess(node) {
        return accessKind(node) === 1;
      }
      ts3.isWriteOnlyAccess = isWriteOnlyAccess;
      function isWriteAccess(node) {
        return accessKind(node) !== 0;
      }
      ts3.isWriteAccess = isWriteAccess;
      var AccessKind;
      (function(AccessKind2) {
        AccessKind2[AccessKind2["Read"] = 0] = "Read";
        AccessKind2[AccessKind2["Write"] = 1] = "Write";
        AccessKind2[AccessKind2["ReadWrite"] = 2] = "ReadWrite";
      })(AccessKind || (AccessKind = {}));
      function accessKind(node) {
        var parent = node.parent;
        if (!parent)
          return 0;
        switch (parent.kind) {
          case 212:
            return accessKind(parent);
          case 220:
          case 219:
            var operator = parent.operator;
            return operator === 45 || operator === 46 ? writeOrReadWrite() : 0;
          case 221:
            var _a = parent, left = _a.left, operatorToken = _a.operatorToken;
            return left === node && isAssignmentOperator(operatorToken.kind) ? operatorToken.kind === 63 ? 1 : writeOrReadWrite() : 0;
          case 206:
            return parent.name !== node ? 0 : accessKind(parent);
          case 296: {
            var parentAccess = accessKind(parent.parent);
            return node === parent.name ? reverseAccessKind(parentAccess) : parentAccess;
          }
          case 297:
            return node === parent.objectAssignmentInitializer ? 0 : accessKind(parent.parent);
          case 204:
            return accessKind(parent);
          default:
            return 0;
        }
        function writeOrReadWrite() {
          return parent.parent && walkUpParenthesizedExpressions(parent.parent).kind === 238 ? 1 : 2;
        }
      }
      function reverseAccessKind(a) {
        switch (a) {
          case 0:
            return 1;
          case 1:
            return 0;
          case 2:
            return 2;
          default:
            return ts3.Debug.assertNever(a);
        }
      }
      function compareDataObjects(dst, src) {
        if (!dst || !src || Object.keys(dst).length !== Object.keys(src).length) {
          return false;
        }
        for (var e in dst) {
          if (typeof dst[e] === "object") {
            if (!compareDataObjects(dst[e], src[e])) {
              return false;
            }
          } else if (typeof dst[e] !== "function") {
            if (dst[e] !== src[e]) {
              return false;
            }
          }
        }
        return true;
      }
      ts3.compareDataObjects = compareDataObjects;
      function clearMap(map2, onDeleteValue) {
        map2.forEach(onDeleteValue);
        map2.clear();
      }
      ts3.clearMap = clearMap;
      function mutateMapSkippingNewValues(map2, newMap, options) {
        var onDeleteValue = options.onDeleteValue, onExistingValue = options.onExistingValue;
        map2.forEach(function(existingValue, key) {
          var valueInNewMap = newMap.get(key);
          if (valueInNewMap === void 0) {
            map2.delete(key);
            onDeleteValue(existingValue, key);
          } else if (onExistingValue) {
            onExistingValue(existingValue, valueInNewMap, key);
          }
        });
      }
      ts3.mutateMapSkippingNewValues = mutateMapSkippingNewValues;
      function mutateMap(map2, newMap, options) {
        mutateMapSkippingNewValues(map2, newMap, options);
        var createNewValue = options.createNewValue;
        newMap.forEach(function(valueInNewMap, key) {
          if (!map2.has(key)) {
            map2.set(key, createNewValue(key, valueInNewMap));
          }
        });
      }
      ts3.mutateMap = mutateMap;
      function isAbstractConstructorSymbol(symbol) {
        if (symbol.flags & 32) {
          var declaration = getClassLikeDeclarationOfSymbol(symbol);
          return !!declaration && hasSyntacticModifier(declaration, 128);
        }
        return false;
      }
      ts3.isAbstractConstructorSymbol = isAbstractConstructorSymbol;
      function getClassLikeDeclarationOfSymbol(symbol) {
        var _a;
        return (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isClassLike);
      }
      ts3.getClassLikeDeclarationOfSymbol = getClassLikeDeclarationOfSymbol;
      function getObjectFlags(type2) {
        return type2.flags & 3899393 ? type2.objectFlags : 0;
      }
      ts3.getObjectFlags = getObjectFlags;
      function typeHasCallOrConstructSignatures(type2, checker) {
        return checker.getSignaturesOfType(type2, 0).length !== 0 || checker.getSignaturesOfType(type2, 1).length !== 0;
      }
      ts3.typeHasCallOrConstructSignatures = typeHasCallOrConstructSignatures;
      function forSomeAncestorDirectory(directory, callback) {
        return !!ts3.forEachAncestorDirectory(directory, function(d) {
          return callback(d) ? true : void 0;
        });
      }
      ts3.forSomeAncestorDirectory = forSomeAncestorDirectory;
      function isUMDExportSymbol(symbol) {
        return !!symbol && !!symbol.declarations && !!symbol.declarations[0] && ts3.isNamespaceExportDeclaration(symbol.declarations[0]);
      }
      ts3.isUMDExportSymbol = isUMDExportSymbol;
      function showModuleSpecifier(_a) {
        var moduleSpecifier = _a.moduleSpecifier;
        return ts3.isStringLiteral(moduleSpecifier) ? moduleSpecifier.text : getTextOfNode(moduleSpecifier);
      }
      ts3.showModuleSpecifier = showModuleSpecifier;
      function getLastChild(node) {
        var lastChild;
        ts3.forEachChild(node, function(child) {
          if (nodeIsPresent(child))
            lastChild = child;
        }, function(children) {
          for (var i = children.length - 1; i >= 0; i--) {
            if (nodeIsPresent(children[i])) {
              lastChild = children[i];
              break;
            }
          }
        });
        return lastChild;
      }
      ts3.getLastChild = getLastChild;
      function addToSeen(seen, key, value) {
        if (value === void 0) {
          value = true;
        }
        if (seen.has(key)) {
          return false;
        }
        seen.set(key, value);
        return true;
      }
      ts3.addToSeen = addToSeen;
      function isObjectTypeDeclaration(node) {
        return ts3.isClassLike(node) || ts3.isInterfaceDeclaration(node) || ts3.isTypeLiteralNode(node);
      }
      ts3.isObjectTypeDeclaration = isObjectTypeDeclaration;
      function isTypeNodeKind(kind) {
        return kind >= 177 && kind <= 200 || kind === 130 || kind === 155 || kind === 147 || kind === 158 || kind === 148 || kind === 133 || kind === 150 || kind === 151 || kind === 114 || kind === 153 || kind === 143 || kind === 228 || kind === 312 || kind === 313 || kind === 314 || kind === 315 || kind === 316 || kind === 317 || kind === 318;
      }
      ts3.isTypeNodeKind = isTypeNodeKind;
      function isAccessExpression(node) {
        return node.kind === 206 || node.kind === 207;
      }
      ts3.isAccessExpression = isAccessExpression;
      function getNameOfAccessExpression(node) {
        if (node.kind === 206) {
          return node.name;
        }
        ts3.Debug.assert(node.kind === 207);
        return node.argumentExpression;
      }
      ts3.getNameOfAccessExpression = getNameOfAccessExpression;
      function isBundleFileTextLike(section) {
        switch (section.kind) {
          case "text":
          case "internal":
            return true;
          default:
            return false;
        }
      }
      ts3.isBundleFileTextLike = isBundleFileTextLike;
      function isNamedImportsOrExports(node) {
        return node.kind === 269 || node.kind === 273;
      }
      ts3.isNamedImportsOrExports = isNamedImportsOrExports;
      function getLeftmostAccessExpression(expr) {
        while (isAccessExpression(expr)) {
          expr = expr.expression;
        }
        return expr;
      }
      ts3.getLeftmostAccessExpression = getLeftmostAccessExpression;
      function forEachNameInAccessChainWalkingLeft(name, action) {
        if (isAccessExpression(name.parent) && isRightSideOfAccessExpression(name)) {
          return walkAccessExpression(name.parent);
        }
        function walkAccessExpression(access) {
          if (access.kind === 206) {
            var res = action(access.name);
            if (res !== void 0) {
              return res;
            }
          } else if (access.kind === 207) {
            if (ts3.isIdentifier(access.argumentExpression) || ts3.isStringLiteralLike(access.argumentExpression)) {
              var res = action(access.argumentExpression);
              if (res !== void 0) {
                return res;
              }
            } else {
              return void 0;
            }
          }
          if (isAccessExpression(access.expression)) {
            return walkAccessExpression(access.expression);
          }
          if (ts3.isIdentifier(access.expression)) {
            return action(access.expression);
          }
          return void 0;
        }
      }
      ts3.forEachNameInAccessChainWalkingLeft = forEachNameInAccessChainWalkingLeft;
      function getLeftmostExpression(node, stopAtCallExpressions) {
        while (true) {
          switch (node.kind) {
            case 220:
              node = node.operand;
              continue;
            case 221:
              node = node.left;
              continue;
            case 222:
              node = node.condition;
              continue;
            case 210:
              node = node.tag;
              continue;
            case 208:
              if (stopAtCallExpressions) {
                return node;
              }
            case 229:
            case 207:
            case 206:
            case 230:
            case 350:
              node = node.expression;
              continue;
          }
          return node;
        }
      }
      ts3.getLeftmostExpression = getLeftmostExpression;
      function Symbol2(flags, name) {
        this.flags = flags;
        this.escapedName = name;
        this.declarations = void 0;
        this.valueDeclaration = void 0;
        this.id = void 0;
        this.mergeId = void 0;
        this.parent = void 0;
      }
      function Type2(checker, flags) {
        this.flags = flags;
        if (ts3.Debug.isDebugging || ts3.tracing) {
          this.checker = checker;
        }
      }
      function Signature(checker, flags) {
        this.flags = flags;
        if (ts3.Debug.isDebugging) {
          this.checker = checker;
        }
      }
      function Node(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.modifierFlagsCache = 0;
        this.transformFlags = 0;
        this.parent = void 0;
        this.original = void 0;
      }
      function Token(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.transformFlags = 0;
        this.parent = void 0;
      }
      function Identifier(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.transformFlags = 0;
        this.parent = void 0;
        this.original = void 0;
        this.flowNode = void 0;
      }
      function SourceMapSource(fileName2, text, skipTrivia) {
        this.fileName = fileName2;
        this.text = text;
        this.skipTrivia = skipTrivia || function(pos) {
          return pos;
        };
      }
      ts3.objectAllocator = {
        getNodeConstructor: function() {
          return Node;
        },
        getTokenConstructor: function() {
          return Token;
        },
        getIdentifierConstructor: function() {
          return Identifier;
        },
        getPrivateIdentifierConstructor: function() {
          return Node;
        },
        getSourceFileConstructor: function() {
          return Node;
        },
        getSymbolConstructor: function() {
          return Symbol2;
        },
        getTypeConstructor: function() {
          return Type2;
        },
        getSignatureConstructor: function() {
          return Signature;
        },
        getSourceMapSourceConstructor: function() {
          return SourceMapSource;
        }
      };
      function setObjectAllocator(alloc) {
        Object.assign(ts3.objectAllocator, alloc);
      }
      ts3.setObjectAllocator = setObjectAllocator;
      function formatStringFromArgs(text, args, baseIndex) {
        if (baseIndex === void 0) {
          baseIndex = 0;
        }
        return text.replace(/{(\d+)}/g, function(_match, index) {
          return "" + ts3.Debug.checkDefined(args[+index + baseIndex]);
        });
      }
      ts3.formatStringFromArgs = formatStringFromArgs;
      var localizedDiagnosticMessages;
      function setLocalizedDiagnosticMessages(messages) {
        localizedDiagnosticMessages = messages;
      }
      ts3.setLocalizedDiagnosticMessages = setLocalizedDiagnosticMessages;
      function maybeSetLocalizedDiagnosticMessages(getMessages) {
        if (!localizedDiagnosticMessages && getMessages) {
          localizedDiagnosticMessages = getMessages();
        }
      }
      ts3.maybeSetLocalizedDiagnosticMessages = maybeSetLocalizedDiagnosticMessages;
      function getLocaleSpecificMessage(message) {
        return localizedDiagnosticMessages && localizedDiagnosticMessages[message.key] || message.message;
      }
      ts3.getLocaleSpecificMessage = getLocaleSpecificMessage;
      function createDetachedDiagnostic(fileName2, start, length, message) {
        assertDiagnosticLocation(void 0, start, length);
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 4) {
          text = formatStringFromArgs(text, arguments, 4);
        }
        return {
          file: void 0,
          start,
          length,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary,
          fileName: fileName2
        };
      }
      ts3.createDetachedDiagnostic = createDetachedDiagnostic;
      function isDiagnosticWithDetachedLocation(diagnostic) {
        return diagnostic.file === void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0 && typeof diagnostic.fileName === "string";
      }
      function attachFileToDiagnostic(diagnostic, file) {
        var fileName2 = file.fileName || "";
        var length = file.text.length;
        ts3.Debug.assertEqual(diagnostic.fileName, fileName2);
        ts3.Debug.assertLessThanOrEqual(diagnostic.start, length);
        ts3.Debug.assertLessThanOrEqual(diagnostic.start + diagnostic.length, length);
        var diagnosticWithLocation = {
          file,
          start: diagnostic.start,
          length: diagnostic.length,
          messageText: diagnostic.messageText,
          category: diagnostic.category,
          code: diagnostic.code,
          reportsUnnecessary: diagnostic.reportsUnnecessary
        };
        if (diagnostic.relatedInformation) {
          diagnosticWithLocation.relatedInformation = [];
          for (var _i = 0, _a = diagnostic.relatedInformation; _i < _a.length; _i++) {
            var related = _a[_i];
            if (isDiagnosticWithDetachedLocation(related) && related.fileName === fileName2) {
              ts3.Debug.assertLessThanOrEqual(related.start, length);
              ts3.Debug.assertLessThanOrEqual(related.start + related.length, length);
              diagnosticWithLocation.relatedInformation.push(attachFileToDiagnostic(related, file));
            } else {
              diagnosticWithLocation.relatedInformation.push(related);
            }
          }
        }
        return diagnosticWithLocation;
      }
      function attachFileToDiagnostics(diagnostics, file) {
        var diagnosticsWithLocation = [];
        for (var _i = 0, diagnostics_1 = diagnostics; _i < diagnostics_1.length; _i++) {
          var diagnostic = diagnostics_1[_i];
          diagnosticsWithLocation.push(attachFileToDiagnostic(diagnostic, file));
        }
        return diagnosticsWithLocation;
      }
      ts3.attachFileToDiagnostics = attachFileToDiagnostics;
      function createFileDiagnostic(file, start, length, message) {
        assertDiagnosticLocation(file, start, length);
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 4) {
          text = formatStringFromArgs(text, arguments, 4);
        }
        return {
          file,
          start,
          length,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary,
          reportsDeprecated: message.reportsDeprecated
        };
      }
      ts3.createFileDiagnostic = createFileDiagnostic;
      function formatMessage(_dummy, message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 2) {
          text = formatStringFromArgs(text, arguments, 2);
        }
        return text;
      }
      ts3.formatMessage = formatMessage;
      function createCompilerDiagnostic(message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 1) {
          text = formatStringFromArgs(text, arguments, 1);
        }
        return {
          file: void 0,
          start: void 0,
          length: void 0,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary,
          reportsDeprecated: message.reportsDeprecated
        };
      }
      ts3.createCompilerDiagnostic = createCompilerDiagnostic;
      function createCompilerDiagnosticFromMessageChain(chain, relatedInformation) {
        return {
          file: void 0,
          start: void 0,
          length: void 0,
          code: chain.code,
          category: chain.category,
          messageText: chain.next ? chain : chain.messageText,
          relatedInformation
        };
      }
      ts3.createCompilerDiagnosticFromMessageChain = createCompilerDiagnosticFromMessageChain;
      function chainDiagnosticMessages(details, message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 2) {
          text = formatStringFromArgs(text, arguments, 2);
        }
        return {
          messageText: text,
          category: message.category,
          code: message.code,
          next: details === void 0 || Array.isArray(details) ? details : [details]
        };
      }
      ts3.chainDiagnosticMessages = chainDiagnosticMessages;
      function concatenateDiagnosticMessageChains(headChain, tailChain) {
        var lastChain = headChain;
        while (lastChain.next) {
          lastChain = lastChain.next[0];
        }
        lastChain.next = [tailChain];
      }
      ts3.concatenateDiagnosticMessageChains = concatenateDiagnosticMessageChains;
      function getDiagnosticFilePath(diagnostic) {
        return diagnostic.file ? diagnostic.file.path : void 0;
      }
      function compareDiagnostics(d1, d2) {
        return compareDiagnosticsSkipRelatedInformation(d1, d2) || compareRelatedInformation(d1, d2) || 0;
      }
      ts3.compareDiagnostics = compareDiagnostics;
      function compareDiagnosticsSkipRelatedInformation(d1, d2) {
        return ts3.compareStringsCaseSensitive(getDiagnosticFilePath(d1), getDiagnosticFilePath(d2)) || ts3.compareValues(d1.start, d2.start) || ts3.compareValues(d1.length, d2.length) || ts3.compareValues(d1.code, d2.code) || compareMessageText(d1.messageText, d2.messageText) || 0;
      }
      ts3.compareDiagnosticsSkipRelatedInformation = compareDiagnosticsSkipRelatedInformation;
      function compareRelatedInformation(d1, d2) {
        if (!d1.relatedInformation && !d2.relatedInformation) {
          return 0;
        }
        if (d1.relatedInformation && d2.relatedInformation) {
          return ts3.compareValues(d1.relatedInformation.length, d2.relatedInformation.length) || ts3.forEach(d1.relatedInformation, function(d1i, index) {
            var d2i = d2.relatedInformation[index];
            return compareDiagnostics(d1i, d2i);
          }) || 0;
        }
        return d1.relatedInformation ? -1 : 1;
      }
      function compareMessageText(t1, t2) {
        if (typeof t1 === "string" && typeof t2 === "string") {
          return ts3.compareStringsCaseSensitive(t1, t2);
        } else if (typeof t1 === "string") {
          return -1;
        } else if (typeof t2 === "string") {
          return 1;
        }
        var res = ts3.compareStringsCaseSensitive(t1.messageText, t2.messageText);
        if (res) {
          return res;
        }
        if (!t1.next && !t2.next) {
          return 0;
        }
        if (!t1.next) {
          return -1;
        }
        if (!t2.next) {
          return 1;
        }
        var len = Math.min(t1.next.length, t2.next.length);
        for (var i = 0; i < len; i++) {
          res = compareMessageText(t1.next[i], t2.next[i]);
          if (res) {
            return res;
          }
        }
        if (t1.next.length < t2.next.length) {
          return -1;
        } else if (t1.next.length > t2.next.length) {
          return 1;
        }
        return 0;
      }
      function getLanguageVariant(scriptKind) {
        return scriptKind === 4 || scriptKind === 2 || scriptKind === 1 || scriptKind === 6 ? 1 : 0;
      }
      ts3.getLanguageVariant = getLanguageVariant;
      function walkTreeForJSXTags(node) {
        if (!(node.transformFlags & 2))
          return void 0;
        return ts3.isJsxOpeningLikeElement(node) || ts3.isJsxFragment(node) ? node : ts3.forEachChild(node, walkTreeForJSXTags);
      }
      function isFileModuleFromUsingJSXTag(file) {
        return !file.isDeclarationFile ? walkTreeForJSXTags(file) : void 0;
      }
      function isFileForcedToBeModuleByFormat(file) {
        return (file.impliedNodeFormat === ts3.ModuleKind.ESNext || ts3.fileExtensionIsOneOf(file.fileName, [".cjs", ".cts"])) && !file.isDeclarationFile ? true : void 0;
      }
      function getSetExternalModuleIndicator(options) {
        switch (getEmitModuleDetectionKind(options)) {
          case ts3.ModuleDetectionKind.Force:
            return function(file) {
              file.externalModuleIndicator = ts3.isFileProbablyExternalModule(file) || !file.isDeclarationFile || void 0;
            };
          case ts3.ModuleDetectionKind.Legacy:
            return function(file) {
              file.externalModuleIndicator = ts3.isFileProbablyExternalModule(file);
            };
          case ts3.ModuleDetectionKind.Auto:
            var checks = [ts3.isFileProbablyExternalModule];
            if (options.jsx === 4 || options.jsx === 5) {
              checks.push(isFileModuleFromUsingJSXTag);
            }
            var moduleKind = getEmitModuleKind(options);
            if (moduleKind === ts3.ModuleKind.Node16 || moduleKind === ts3.ModuleKind.NodeNext) {
              checks.push(isFileForcedToBeModuleByFormat);
            }
            var combined_1 = ts3.or.apply(void 0, checks);
            var callback = function(file) {
              return void (file.externalModuleIndicator = combined_1(file));
            };
            return callback;
        }
      }
      ts3.getSetExternalModuleIndicator = getSetExternalModuleIndicator;
      function getEmitScriptTarget(compilerOptions) {
        return compilerOptions.target || compilerOptions.module === ts3.ModuleKind.Node16 && 9 || compilerOptions.module === ts3.ModuleKind.NodeNext && 99 || 0;
      }
      ts3.getEmitScriptTarget = getEmitScriptTarget;
      function getEmitModuleKind(compilerOptions) {
        return typeof compilerOptions.module === "number" ? compilerOptions.module : getEmitScriptTarget(compilerOptions) >= 2 ? ts3.ModuleKind.ES2015 : ts3.ModuleKind.CommonJS;
      }
      ts3.getEmitModuleKind = getEmitModuleKind;
      function getEmitModuleResolutionKind(compilerOptions) {
        var moduleResolution = compilerOptions.moduleResolution;
        if (moduleResolution === void 0) {
          switch (getEmitModuleKind(compilerOptions)) {
            case ts3.ModuleKind.CommonJS:
              moduleResolution = ts3.ModuleResolutionKind.NodeJs;
              break;
            case ts3.ModuleKind.Node16:
              moduleResolution = ts3.ModuleResolutionKind.Node16;
              break;
            case ts3.ModuleKind.NodeNext:
              moduleResolution = ts3.ModuleResolutionKind.NodeNext;
              break;
            default:
              moduleResolution = ts3.ModuleResolutionKind.Classic;
              break;
          }
        }
        return moduleResolution;
      }
      ts3.getEmitModuleResolutionKind = getEmitModuleResolutionKind;
      function getEmitModuleDetectionKind(options) {
        return options.moduleDetection || (getEmitModuleKind(options) === ts3.ModuleKind.Node16 || getEmitModuleKind(options) === ts3.ModuleKind.NodeNext ? ts3.ModuleDetectionKind.Force : ts3.ModuleDetectionKind.Auto);
      }
      ts3.getEmitModuleDetectionKind = getEmitModuleDetectionKind;
      function hasJsonModuleEmitEnabled(options) {
        switch (getEmitModuleKind(options)) {
          case ts3.ModuleKind.CommonJS:
          case ts3.ModuleKind.AMD:
          case ts3.ModuleKind.ES2015:
          case ts3.ModuleKind.ES2020:
          case ts3.ModuleKind.ES2022:
          case ts3.ModuleKind.ESNext:
          case ts3.ModuleKind.Node16:
          case ts3.ModuleKind.NodeNext:
            return true;
          default:
            return false;
        }
      }
      ts3.hasJsonModuleEmitEnabled = hasJsonModuleEmitEnabled;
      function unreachableCodeIsError(options) {
        return options.allowUnreachableCode === false;
      }
      ts3.unreachableCodeIsError = unreachableCodeIsError;
      function unusedLabelIsError(options) {
        return options.allowUnusedLabels === false;
      }
      ts3.unusedLabelIsError = unusedLabelIsError;
      function getAreDeclarationMapsEnabled(options) {
        return !!(getEmitDeclarations(options) && options.declarationMap);
      }
      ts3.getAreDeclarationMapsEnabled = getAreDeclarationMapsEnabled;
      function getESModuleInterop(compilerOptions) {
        if (compilerOptions.esModuleInterop !== void 0) {
          return compilerOptions.esModuleInterop;
        }
        switch (getEmitModuleKind(compilerOptions)) {
          case ts3.ModuleKind.Node16:
          case ts3.ModuleKind.NodeNext:
            return true;
        }
        return void 0;
      }
      ts3.getESModuleInterop = getESModuleInterop;
      function getAllowSyntheticDefaultImports(compilerOptions) {
        var moduleKind = getEmitModuleKind(compilerOptions);
        return compilerOptions.allowSyntheticDefaultImports !== void 0 ? compilerOptions.allowSyntheticDefaultImports : getESModuleInterop(compilerOptions) || moduleKind === ts3.ModuleKind.System;
      }
      ts3.getAllowSyntheticDefaultImports = getAllowSyntheticDefaultImports;
      function getEmitDeclarations(compilerOptions) {
        return !!(compilerOptions.declaration || compilerOptions.composite);
      }
      ts3.getEmitDeclarations = getEmitDeclarations;
      function shouldPreserveConstEnums(compilerOptions) {
        return !!(compilerOptions.preserveConstEnums || compilerOptions.isolatedModules);
      }
      ts3.shouldPreserveConstEnums = shouldPreserveConstEnums;
      function isIncrementalCompilation(options) {
        return !!(options.incremental || options.composite);
      }
      ts3.isIncrementalCompilation = isIncrementalCompilation;
      function getStrictOptionValue(compilerOptions, flag) {
        return compilerOptions[flag] === void 0 ? !!compilerOptions.strict : !!compilerOptions[flag];
      }
      ts3.getStrictOptionValue = getStrictOptionValue;
      function getAllowJSCompilerOption(compilerOptions) {
        return compilerOptions.allowJs === void 0 ? !!compilerOptions.checkJs : compilerOptions.allowJs;
      }
      ts3.getAllowJSCompilerOption = getAllowJSCompilerOption;
      function getUseDefineForClassFields(compilerOptions) {
        return compilerOptions.useDefineForClassFields === void 0 ? getEmitScriptTarget(compilerOptions) >= 9 : compilerOptions.useDefineForClassFields;
      }
      ts3.getUseDefineForClassFields = getUseDefineForClassFields;
      function compilerOptionsAffectSemanticDiagnostics(newOptions, oldOptions) {
        return optionsHaveChanges(oldOptions, newOptions, ts3.semanticDiagnosticsOptionDeclarations);
      }
      ts3.compilerOptionsAffectSemanticDiagnostics = compilerOptionsAffectSemanticDiagnostics;
      function compilerOptionsAffectEmit(newOptions, oldOptions) {
        return optionsHaveChanges(oldOptions, newOptions, ts3.affectsEmitOptionDeclarations);
      }
      ts3.compilerOptionsAffectEmit = compilerOptionsAffectEmit;
      function getCompilerOptionValue(options, option) {
        return option.strictFlag ? getStrictOptionValue(options, option.name) : options[option.name];
      }
      ts3.getCompilerOptionValue = getCompilerOptionValue;
      function getJSXTransformEnabled(options) {
        var jsx = options.jsx;
        return jsx === 2 || jsx === 4 || jsx === 5;
      }
      ts3.getJSXTransformEnabled = getJSXTransformEnabled;
      function getJSXImplicitImportBase(compilerOptions, file) {
        var jsxImportSourcePragmas = file === null || file === void 0 ? void 0 : file.pragmas.get("jsximportsource");
        var jsxImportSourcePragma = ts3.isArray(jsxImportSourcePragmas) ? jsxImportSourcePragmas[jsxImportSourcePragmas.length - 1] : jsxImportSourcePragmas;
        return compilerOptions.jsx === 4 || compilerOptions.jsx === 5 || compilerOptions.jsxImportSource || jsxImportSourcePragma ? (jsxImportSourcePragma === null || jsxImportSourcePragma === void 0 ? void 0 : jsxImportSourcePragma.arguments.factory) || compilerOptions.jsxImportSource || "react" : void 0;
      }
      ts3.getJSXImplicitImportBase = getJSXImplicitImportBase;
      function getJSXRuntimeImport(base, options) {
        return base ? "".concat(base, "/").concat(options.jsx === 5 ? "jsx-dev-runtime" : "jsx-runtime") : void 0;
      }
      ts3.getJSXRuntimeImport = getJSXRuntimeImport;
      function hasZeroOrOneAsteriskCharacter(str2) {
        var seenAsterisk = false;
        for (var i = 0; i < str2.length; i++) {
          if (str2.charCodeAt(i) === 42) {
            if (!seenAsterisk) {
              seenAsterisk = true;
            } else {
              return false;
            }
          }
        }
        return true;
      }
      ts3.hasZeroOrOneAsteriskCharacter = hasZeroOrOneAsteriskCharacter;
      function createSymlinkCache(cwd, getCanonicalFileName) {
        var symlinkedDirectories;
        var symlinkedDirectoriesByRealpath;
        var symlinkedFiles;
        var hasProcessedResolutions = false;
        return {
          getSymlinkedFiles: function() {
            return symlinkedFiles;
          },
          getSymlinkedDirectories: function() {
            return symlinkedDirectories;
          },
          getSymlinkedDirectoriesByRealpath: function() {
            return symlinkedDirectoriesByRealpath;
          },
          setSymlinkedFile: function(path2, real) {
            return (symlinkedFiles || (symlinkedFiles = new ts3.Map())).set(path2, real);
          },
          setSymlinkedDirectory: function(symlink, real) {
            var symlinkPath = ts3.toPath(symlink, cwd, getCanonicalFileName);
            if (!containsIgnoredPath(symlinkPath)) {
              symlinkPath = ts3.ensureTrailingDirectorySeparator(symlinkPath);
              if (real !== false && !(symlinkedDirectories === null || symlinkedDirectories === void 0 ? void 0 : symlinkedDirectories.has(symlinkPath))) {
                (symlinkedDirectoriesByRealpath || (symlinkedDirectoriesByRealpath = ts3.createMultiMap())).add(ts3.ensureTrailingDirectorySeparator(real.realPath), symlink);
              }
              (symlinkedDirectories || (symlinkedDirectories = new ts3.Map())).set(symlinkPath, real);
            }
          },
          setSymlinksFromResolutions: function(files, typeReferenceDirectives) {
            var _this = this;
            var _a;
            ts3.Debug.assert(!hasProcessedResolutions);
            hasProcessedResolutions = true;
            for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
              var file = files_1[_i];
              (_a = file.resolvedModules) === null || _a === void 0 ? void 0 : _a.forEach(function(resolution) {
                return processResolution(_this, resolution);
              });
            }
            typeReferenceDirectives === null || typeReferenceDirectives === void 0 ? void 0 : typeReferenceDirectives.forEach(function(resolution) {
              return processResolution(_this, resolution);
            });
          },
          hasProcessedResolutions: function() {
            return hasProcessedResolutions;
          }
        };
        function processResolution(cache, resolution) {
          if (!resolution || !resolution.originalPath || !resolution.resolvedFileName)
            return;
          var resolvedFileName = resolution.resolvedFileName, originalPath = resolution.originalPath;
          cache.setSymlinkedFile(ts3.toPath(originalPath, cwd, getCanonicalFileName), resolvedFileName);
          var _a = guessDirectorySymlink(resolvedFileName, originalPath, cwd, getCanonicalFileName) || ts3.emptyArray, commonResolved = _a[0], commonOriginal = _a[1];
          if (commonResolved && commonOriginal) {
            cache.setSymlinkedDirectory(commonOriginal, { real: commonResolved, realPath: ts3.toPath(commonResolved, cwd, getCanonicalFileName) });
          }
        }
      }
      ts3.createSymlinkCache = createSymlinkCache;
      function guessDirectorySymlink(a, b, cwd, getCanonicalFileName) {
        var aParts = ts3.getPathComponents(ts3.getNormalizedAbsolutePath(a, cwd));
        var bParts = ts3.getPathComponents(ts3.getNormalizedAbsolutePath(b, cwd));
        var isDirectory = false;
        while (aParts.length >= 2 && bParts.length >= 2 && !isNodeModulesOrScopedPackageDirectory(aParts[aParts.length - 2], getCanonicalFileName) && !isNodeModulesOrScopedPackageDirectory(bParts[bParts.length - 2], getCanonicalFileName) && getCanonicalFileName(aParts[aParts.length - 1]) === getCanonicalFileName(bParts[bParts.length - 1])) {
          aParts.pop();
          bParts.pop();
          isDirectory = true;
        }
        return isDirectory ? [ts3.getPathFromPathComponents(aParts), ts3.getPathFromPathComponents(bParts)] : void 0;
      }
      function isNodeModulesOrScopedPackageDirectory(s, getCanonicalFileName) {
        return s !== void 0 && (getCanonicalFileName(s) === "node_modules" || ts3.startsWith(s, "@"));
      }
      function stripLeadingDirectorySeparator(s) {
        return ts3.isAnyDirectorySeparator(s.charCodeAt(0)) ? s.slice(1) : void 0;
      }
      function tryRemoveDirectoryPrefix(path2, dirPath, getCanonicalFileName) {
        var withoutPrefix = ts3.tryRemovePrefix(path2, dirPath, getCanonicalFileName);
        return withoutPrefix === void 0 ? void 0 : stripLeadingDirectorySeparator(withoutPrefix);
      }
      ts3.tryRemoveDirectoryPrefix = tryRemoveDirectoryPrefix;
      var reservedCharacterPattern = /[^\w\s\/]/g;
      function regExpEscape(text) {
        return text.replace(reservedCharacterPattern, escapeRegExpCharacter);
      }
      ts3.regExpEscape = regExpEscape;
      function escapeRegExpCharacter(match) {
        return "\\" + match;
      }
      var wildcardCharCodes = [42, 63];
      ts3.commonPackageFolders = ["node_modules", "bower_components", "jspm_packages"];
      var implicitExcludePathRegexPattern = "(?!(".concat(ts3.commonPackageFolders.join("|"), ")(/|$))");
      var filesMatcher = {
        singleAsteriskRegexFragment: "([^./]|(\\.(?!min\\.js$))?)*",
        doubleAsteriskRegexFragment: "(/".concat(implicitExcludePathRegexPattern, "[^/.][^/]*)*?"),
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, filesMatcher.singleAsteriskRegexFragment);
        }
      };
      var directoriesMatcher = {
        singleAsteriskRegexFragment: "[^/]*",
        doubleAsteriskRegexFragment: "(/".concat(implicitExcludePathRegexPattern, "[^/.][^/]*)*?"),
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, directoriesMatcher.singleAsteriskRegexFragment);
        }
      };
      var excludeMatcher = {
        singleAsteriskRegexFragment: "[^/]*",
        doubleAsteriskRegexFragment: "(/.+?)?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, excludeMatcher.singleAsteriskRegexFragment);
        }
      };
      var wildcardMatchers = {
        files: filesMatcher,
        directories: directoriesMatcher,
        exclude: excludeMatcher
      };
      function getRegularExpressionForWildcard(specs, basePath, usage) {
        var patterns = getRegularExpressionsForWildcards(specs, basePath, usage);
        if (!patterns || !patterns.length) {
          return void 0;
        }
        var pattern = patterns.map(function(pattern2) {
          return "(".concat(pattern2, ")");
        }).join("|");
        var terminator = usage === "exclude" ? "($|/)" : "$";
        return "^(".concat(pattern, ")").concat(terminator);
      }
      ts3.getRegularExpressionForWildcard = getRegularExpressionForWildcard;
      function getRegularExpressionsForWildcards(specs, basePath, usage) {
        if (specs === void 0 || specs.length === 0) {
          return void 0;
        }
        return ts3.flatMap(specs, function(spec) {
          return spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]);
        });
      }
      ts3.getRegularExpressionsForWildcards = getRegularExpressionsForWildcards;
      function isImplicitGlob(lastPathComponent) {
        return !/[.*?]/.test(lastPathComponent);
      }
      ts3.isImplicitGlob = isImplicitGlob;
      function getPatternFromSpec(spec, basePath, usage) {
        var pattern = spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]);
        return pattern && "^(".concat(pattern, ")").concat(usage === "exclude" ? "($|/)" : "$");
      }
      ts3.getPatternFromSpec = getPatternFromSpec;
      function getSubPatternFromSpec(spec, basePath, usage, _a) {
        var singleAsteriskRegexFragment = _a.singleAsteriskRegexFragment, doubleAsteriskRegexFragment = _a.doubleAsteriskRegexFragment, replaceWildcardCharacter2 = _a.replaceWildcardCharacter;
        var subpattern = "";
        var hasWrittenComponent = false;
        var components = ts3.getNormalizedPathComponents(spec, basePath);
        var lastComponent = ts3.last(components);
        if (usage !== "exclude" && lastComponent === "**") {
          return void 0;
        }
        components[0] = ts3.removeTrailingDirectorySeparator(components[0]);
        if (isImplicitGlob(lastComponent)) {
          components.push("**", "*");
        }
        var optionalCount = 0;
        for (var _i = 0, components_1 = components; _i < components_1.length; _i++) {
          var component = components_1[_i];
          if (component === "**") {
            subpattern += doubleAsteriskRegexFragment;
          } else {
            if (usage === "directories") {
              subpattern += "(";
              optionalCount++;
            }
            if (hasWrittenComponent) {
              subpattern += ts3.directorySeparator;
            }
            if (usage !== "exclude") {
              var componentPattern = "";
              if (component.charCodeAt(0) === 42) {
                componentPattern += "([^./]" + singleAsteriskRegexFragment + ")?";
                component = component.substr(1);
              } else if (component.charCodeAt(0) === 63) {
                componentPattern += "[^./]";
                component = component.substr(1);
              }
              componentPattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
              if (componentPattern !== component) {
                subpattern += implicitExcludePathRegexPattern;
              }
              subpattern += componentPattern;
            } else {
              subpattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
            }
          }
          hasWrittenComponent = true;
        }
        while (optionalCount > 0) {
          subpattern += ")?";
          optionalCount--;
        }
        return subpattern;
      }
      function replaceWildcardCharacter(match, singleAsteriskRegexFragment) {
        return match === "*" ? singleAsteriskRegexFragment : match === "?" ? "[^/]" : "\\" + match;
      }
      function getFileMatcherPatterns(path2, excludes, includes, useCaseSensitiveFileNames, currentDirectory) {
        path2 = ts3.normalizePath(path2);
        currentDirectory = ts3.normalizePath(currentDirectory);
        var absolutePath = ts3.combinePaths(currentDirectory, path2);
        return {
          includeFilePatterns: ts3.map(getRegularExpressionsForWildcards(includes, absolutePath, "files"), function(pattern) {
            return "^".concat(pattern, "$");
          }),
          includeFilePattern: getRegularExpressionForWildcard(includes, absolutePath, "files"),
          includeDirectoryPattern: getRegularExpressionForWildcard(includes, absolutePath, "directories"),
          excludePattern: getRegularExpressionForWildcard(excludes, absolutePath, "exclude"),
          basePaths: getBasePaths(path2, includes, useCaseSensitiveFileNames)
        };
      }
      ts3.getFileMatcherPatterns = getFileMatcherPatterns;
      function getRegexFromPattern(pattern, useCaseSensitiveFileNames) {
        return new RegExp(pattern, useCaseSensitiveFileNames ? "" : "i");
      }
      ts3.getRegexFromPattern = getRegexFromPattern;
      function matchFiles(path2, extensions, excludes, includes, useCaseSensitiveFileNames, currentDirectory, depth, getFileSystemEntries, realpath) {
        path2 = ts3.normalizePath(path2);
        currentDirectory = ts3.normalizePath(currentDirectory);
        var patterns = getFileMatcherPatterns(path2, excludes, includes, useCaseSensitiveFileNames, currentDirectory);
        var includeFileRegexes = patterns.includeFilePatterns && patterns.includeFilePatterns.map(function(pattern) {
          return getRegexFromPattern(pattern, useCaseSensitiveFileNames);
        });
        var includeDirectoryRegex = patterns.includeDirectoryPattern && getRegexFromPattern(patterns.includeDirectoryPattern, useCaseSensitiveFileNames);
        var excludeRegex = patterns.excludePattern && getRegexFromPattern(patterns.excludePattern, useCaseSensitiveFileNames);
        var results = includeFileRegexes ? includeFileRegexes.map(function() {
          return [];
        }) : [[]];
        var visited = new ts3.Map();
        var toCanonical = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        for (var _i = 0, _a = patterns.basePaths; _i < _a.length; _i++) {
          var basePath = _a[_i];
          visitDirectory(basePath, ts3.combinePaths(currentDirectory, basePath), depth);
        }
        return ts3.flatten(results);
        function visitDirectory(path3, absolutePath, depth2) {
          var canonicalPath = toCanonical(realpath(absolutePath));
          if (visited.has(canonicalPath))
            return;
          visited.set(canonicalPath, true);
          var _a2 = getFileSystemEntries(path3), files = _a2.files, directories = _a2.directories;
          var _loop_1 = function(current2) {
            var name2 = ts3.combinePaths(path3, current2);
            var absoluteName2 = ts3.combinePaths(absolutePath, current2);
            if (extensions && !ts3.fileExtensionIsOneOf(name2, extensions))
              return "continue";
            if (excludeRegex && excludeRegex.test(absoluteName2))
              return "continue";
            if (!includeFileRegexes) {
              results[0].push(name2);
            } else {
              var includeIndex = ts3.findIndex(includeFileRegexes, function(re) {
                return re.test(absoluteName2);
              });
              if (includeIndex !== -1) {
                results[includeIndex].push(name2);
              }
            }
          };
          for (var _i2 = 0, _b = ts3.sort(files, ts3.compareStringsCaseSensitive); _i2 < _b.length; _i2++) {
            var current = _b[_i2];
            _loop_1(current);
          }
          if (depth2 !== void 0) {
            depth2--;
            if (depth2 === 0) {
              return;
            }
          }
          for (var _c = 0, _d = ts3.sort(directories, ts3.compareStringsCaseSensitive); _c < _d.length; _c++) {
            var current = _d[_c];
            var name = ts3.combinePaths(path3, current);
            var absoluteName = ts3.combinePaths(absolutePath, current);
            if ((!includeDirectoryRegex || includeDirectoryRegex.test(absoluteName)) && (!excludeRegex || !excludeRegex.test(absoluteName))) {
              visitDirectory(name, absoluteName, depth2);
            }
          }
        }
      }
      ts3.matchFiles = matchFiles;
      function getBasePaths(path2, includes, useCaseSensitiveFileNames) {
        var basePaths = [path2];
        if (includes) {
          var includeBasePaths = [];
          for (var _i = 0, includes_1 = includes; _i < includes_1.length; _i++) {
            var include = includes_1[_i];
            var absolute = ts3.isRootedDiskPath(include) ? include : ts3.normalizePath(ts3.combinePaths(path2, include));
            includeBasePaths.push(getIncludeBasePath(absolute));
          }
          includeBasePaths.sort(ts3.getStringComparer(!useCaseSensitiveFileNames));
          var _loop_2 = function(includeBasePath2) {
            if (ts3.every(basePaths, function(basePath) {
              return !ts3.containsPath(basePath, includeBasePath2, path2, !useCaseSensitiveFileNames);
            })) {
              basePaths.push(includeBasePath2);
            }
          };
          for (var _a = 0, includeBasePaths_1 = includeBasePaths; _a < includeBasePaths_1.length; _a++) {
            var includeBasePath = includeBasePaths_1[_a];
            _loop_2(includeBasePath);
          }
        }
        return basePaths;
      }
      function getIncludeBasePath(absolute) {
        var wildcardOffset = ts3.indexOfAnyCharCode(absolute, wildcardCharCodes);
        if (wildcardOffset < 0) {
          return !ts3.hasExtension(absolute) ? absolute : ts3.removeTrailingDirectorySeparator(ts3.getDirectoryPath(absolute));
        }
        return absolute.substring(0, absolute.lastIndexOf(ts3.directorySeparator, wildcardOffset));
      }
      function ensureScriptKind(fileName2, scriptKind) {
        return scriptKind || getScriptKindFromFileName(fileName2) || 3;
      }
      ts3.ensureScriptKind = ensureScriptKind;
      function getScriptKindFromFileName(fileName2) {
        var ext = fileName2.substr(fileName2.lastIndexOf("."));
        switch (ext.toLowerCase()) {
          case ".js":
          case ".cjs":
          case ".mjs":
            return 1;
          case ".jsx":
            return 2;
          case ".ts":
          case ".cts":
          case ".mts":
            return 3;
          case ".tsx":
            return 4;
          case ".json":
            return 6;
          default:
            return 0;
        }
      }
      ts3.getScriptKindFromFileName = getScriptKindFromFileName;
      ts3.supportedTSExtensions = [[".ts", ".tsx", ".d.ts"], [".cts", ".d.cts"], [".mts", ".d.mts"]];
      ts3.supportedTSExtensionsFlat = ts3.flatten(ts3.supportedTSExtensions);
      var supportedTSExtensionsWithJson = __spreadArray(__spreadArray([], ts3.supportedTSExtensions, true), [[".json"]], false);
      var supportedTSExtensionsForExtractExtension = [".d.ts", ".d.cts", ".d.mts", ".cts", ".mts", ".ts", ".tsx", ".cts", ".mts"];
      ts3.supportedJSExtensions = [[".js", ".jsx"], [".mjs"], [".cjs"]];
      ts3.supportedJSExtensionsFlat = ts3.flatten(ts3.supportedJSExtensions);
      var allSupportedExtensions = [[".ts", ".tsx", ".d.ts", ".js", ".jsx"], [".cts", ".d.cts", ".cjs"], [".mts", ".d.mts", ".mjs"]];
      var allSupportedExtensionsWithJson = __spreadArray(__spreadArray([], allSupportedExtensions, true), [[".json"]], false);
      ts3.supportedDeclarationExtensions = [".d.ts", ".d.cts", ".d.mts"];
      function getSupportedExtensions(options, extraFileExtensions) {
        var needJsExtensions = options && getAllowJSCompilerOption(options);
        if (!extraFileExtensions || extraFileExtensions.length === 0) {
          return needJsExtensions ? allSupportedExtensions : ts3.supportedTSExtensions;
        }
        var builtins = needJsExtensions ? allSupportedExtensions : ts3.supportedTSExtensions;
        var flatBuiltins = ts3.flatten(builtins);
        var extensions = __spreadArray(__spreadArray([], builtins, true), ts3.mapDefined(extraFileExtensions, function(x) {
          return x.scriptKind === 7 || needJsExtensions && isJSLike(x.scriptKind) && flatBuiltins.indexOf(x.extension) === -1 ? [x.extension] : void 0;
        }), true);
        return extensions;
      }
      ts3.getSupportedExtensions = getSupportedExtensions;
      function getSupportedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions) {
        if (!options || !options.resolveJsonModule)
          return supportedExtensions;
        if (supportedExtensions === allSupportedExtensions)
          return allSupportedExtensionsWithJson;
        if (supportedExtensions === ts3.supportedTSExtensions)
          return supportedTSExtensionsWithJson;
        return __spreadArray(__spreadArray([], supportedExtensions, true), [[".json"]], false);
      }
      ts3.getSupportedExtensionsWithJsonIfResolveJsonModule = getSupportedExtensionsWithJsonIfResolveJsonModule;
      function isJSLike(scriptKind) {
        return scriptKind === 1 || scriptKind === 2;
      }
      function hasJSFileExtension(fileName2) {
        return ts3.some(ts3.supportedJSExtensionsFlat, function(extension) {
          return ts3.fileExtensionIs(fileName2, extension);
        });
      }
      ts3.hasJSFileExtension = hasJSFileExtension;
      function hasTSFileExtension(fileName2) {
        return ts3.some(ts3.supportedTSExtensionsFlat, function(extension) {
          return ts3.fileExtensionIs(fileName2, extension);
        });
      }
      ts3.hasTSFileExtension = hasTSFileExtension;
      function isSupportedSourceFileName(fileName2, compilerOptions, extraFileExtensions) {
        if (!fileName2)
          return false;
        var supportedExtensions = getSupportedExtensions(compilerOptions, extraFileExtensions);
        for (var _i = 0, _a = ts3.flatten(getSupportedExtensionsWithJsonIfResolveJsonModule(compilerOptions, supportedExtensions)); _i < _a.length; _i++) {
          var extension = _a[_i];
          if (ts3.fileExtensionIs(fileName2, extension)) {
            return true;
          }
        }
        return false;
      }
      ts3.isSupportedSourceFileName = isSupportedSourceFileName;
      function numberOfDirectorySeparators(str2) {
        var match = str2.match(/\//g);
        return match ? match.length : 0;
      }
      function compareNumberOfDirectorySeparators(path1, path2) {
        return ts3.compareValues(numberOfDirectorySeparators(path1), numberOfDirectorySeparators(path2));
      }
      ts3.compareNumberOfDirectorySeparators = compareNumberOfDirectorySeparators;
      var extensionsToRemove = [".d.ts", ".d.mts", ".d.cts", ".mjs", ".mts", ".cjs", ".cts", ".ts", ".js", ".tsx", ".jsx", ".json"];
      function removeFileExtension(path2) {
        for (var _i = 0, extensionsToRemove_1 = extensionsToRemove; _i < extensionsToRemove_1.length; _i++) {
          var ext = extensionsToRemove_1[_i];
          var extensionless = tryRemoveExtension(path2, ext);
          if (extensionless !== void 0) {
            return extensionless;
          }
        }
        return path2;
      }
      ts3.removeFileExtension = removeFileExtension;
      function tryRemoveExtension(path2, extension) {
        return ts3.fileExtensionIs(path2, extension) ? removeExtension(path2, extension) : void 0;
      }
      ts3.tryRemoveExtension = tryRemoveExtension;
      function removeExtension(path2, extension) {
        return path2.substring(0, path2.length - extension.length);
      }
      ts3.removeExtension = removeExtension;
      function changeExtension(path2, newExtension) {
        return ts3.changeAnyExtension(path2, newExtension, extensionsToRemove, false);
      }
      ts3.changeExtension = changeExtension;
      function tryParsePattern(pattern) {
        var indexOfStar = pattern.indexOf("*");
        if (indexOfStar === -1) {
          return pattern;
        }
        return pattern.indexOf("*", indexOfStar + 1) !== -1 ? void 0 : {
          prefix: pattern.substr(0, indexOfStar),
          suffix: pattern.substr(indexOfStar + 1)
        };
      }
      ts3.tryParsePattern = tryParsePattern;
      function tryParsePatterns(paths) {
        return ts3.mapDefined(ts3.getOwnKeys(paths), function(path2) {
          return tryParsePattern(path2);
        });
      }
      ts3.tryParsePatterns = tryParsePatterns;
      function positionIsSynthesized(pos) {
        return !(pos >= 0);
      }
      ts3.positionIsSynthesized = positionIsSynthesized;
      function extensionIsTS(ext) {
        return ext === ".ts" || ext === ".tsx" || ext === ".d.ts" || ext === ".cts" || ext === ".mts" || ext === ".d.mts" || ext === ".d.cts";
      }
      ts3.extensionIsTS = extensionIsTS;
      function resolutionExtensionIsTSOrJson(ext) {
        return extensionIsTS(ext) || ext === ".json";
      }
      ts3.resolutionExtensionIsTSOrJson = resolutionExtensionIsTSOrJson;
      function extensionFromPath(path2) {
        var ext = tryGetExtensionFromPath(path2);
        return ext !== void 0 ? ext : ts3.Debug.fail("File ".concat(path2, " has unknown extension."));
      }
      ts3.extensionFromPath = extensionFromPath;
      function isAnySupportedFileExtension(path2) {
        return tryGetExtensionFromPath(path2) !== void 0;
      }
      ts3.isAnySupportedFileExtension = isAnySupportedFileExtension;
      function tryGetExtensionFromPath(path2) {
        return ts3.find(extensionsToRemove, function(e) {
          return ts3.fileExtensionIs(path2, e);
        });
      }
      ts3.tryGetExtensionFromPath = tryGetExtensionFromPath;
      function isCheckJsEnabledForFile(sourceFile, compilerOptions) {
        return sourceFile.checkJsDirective ? sourceFile.checkJsDirective.enabled : compilerOptions.checkJs;
      }
      ts3.isCheckJsEnabledForFile = isCheckJsEnabledForFile;
      ts3.emptyFileSystemEntries = {
        files: ts3.emptyArray,
        directories: ts3.emptyArray
      };
      function matchPatternOrExact(patternOrStrings, candidate) {
        var patterns = [];
        for (var _i = 0, patternOrStrings_1 = patternOrStrings; _i < patternOrStrings_1.length; _i++) {
          var patternOrString = patternOrStrings_1[_i];
          if (patternOrString === candidate) {
            return candidate;
          }
          if (!ts3.isString(patternOrString)) {
            patterns.push(patternOrString);
          }
        }
        return ts3.findBestPatternMatch(patterns, function(_) {
          return _;
        }, candidate);
      }
      ts3.matchPatternOrExact = matchPatternOrExact;
      function sliceAfter(arr, value) {
        var index = arr.indexOf(value);
        ts3.Debug.assert(index !== -1);
        return arr.slice(index);
      }
      ts3.sliceAfter = sliceAfter;
      function addRelatedInfo(diagnostic) {
        var _a;
        var relatedInformation = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          relatedInformation[_i - 1] = arguments[_i];
        }
        if (!relatedInformation.length) {
          return diagnostic;
        }
        if (!diagnostic.relatedInformation) {
          diagnostic.relatedInformation = [];
        }
        ts3.Debug.assert(diagnostic.relatedInformation !== ts3.emptyArray, "Diagnostic had empty array singleton for related info, but is still being constructed!");
        (_a = diagnostic.relatedInformation).push.apply(_a, relatedInformation);
        return diagnostic;
      }
      ts3.addRelatedInfo = addRelatedInfo;
      function minAndMax(arr, getValue) {
        ts3.Debug.assert(arr.length !== 0);
        var min = getValue(arr[0]);
        var max = min;
        for (var i = 1; i < arr.length; i++) {
          var value = getValue(arr[i]);
          if (value < min) {
            min = value;
          } else if (value > max) {
            max = value;
          }
        }
        return { min, max };
      }
      ts3.minAndMax = minAndMax;
      function rangeOfNode(node) {
        return { pos: getTokenPosOfNode(node), end: node.end };
      }
      ts3.rangeOfNode = rangeOfNode;
      function rangeOfTypeParameters(sourceFile, typeParameters) {
        var pos = typeParameters.pos - 1;
        var end = ts3.skipTrivia(sourceFile.text, typeParameters.end) + 1;
        return { pos, end };
      }
      ts3.rangeOfTypeParameters = rangeOfTypeParameters;
      function skipTypeChecking(sourceFile, options, host) {
        return options.skipLibCheck && sourceFile.isDeclarationFile || options.skipDefaultLibCheck && sourceFile.hasNoDefaultLib || host.isSourceOfProjectReferenceRedirect(sourceFile.fileName);
      }
      ts3.skipTypeChecking = skipTypeChecking;
      function isJsonEqual(a, b) {
        return a === b || typeof a === "object" && a !== null && typeof b === "object" && b !== null && ts3.equalOwnProperties(a, b, isJsonEqual);
      }
      ts3.isJsonEqual = isJsonEqual;
      function parsePseudoBigInt(stringValue) {
        var log2Base;
        switch (stringValue.charCodeAt(1)) {
          case 98:
          case 66:
            log2Base = 1;
            break;
          case 111:
          case 79:
            log2Base = 3;
            break;
          case 120:
          case 88:
            log2Base = 4;
            break;
          default:
            var nIndex = stringValue.length - 1;
            var nonZeroStart = 0;
            while (stringValue.charCodeAt(nonZeroStart) === 48) {
              nonZeroStart++;
            }
            return stringValue.slice(nonZeroStart, nIndex) || "0";
        }
        var startIndex = 2, endIndex = stringValue.length - 1;
        var bitsNeeded = (endIndex - startIndex) * log2Base;
        var segments = new Uint16Array((bitsNeeded >>> 4) + (bitsNeeded & 15 ? 1 : 0));
        for (var i = endIndex - 1, bitOffset = 0; i >= startIndex; i--, bitOffset += log2Base) {
          var segment = bitOffset >>> 4;
          var digitChar = stringValue.charCodeAt(i);
          var digit = digitChar <= 57 ? digitChar - 48 : 10 + digitChar - (digitChar <= 70 ? 65 : 97);
          var shiftedDigit = digit << (bitOffset & 15);
          segments[segment] |= shiftedDigit;
          var residual = shiftedDigit >>> 16;
          if (residual)
            segments[segment + 1] |= residual;
        }
        var base10Value = "";
        var firstNonzeroSegment = segments.length - 1;
        var segmentsRemaining = true;
        while (segmentsRemaining) {
          var mod10 = 0;
          segmentsRemaining = false;
          for (var segment = firstNonzeroSegment; segment >= 0; segment--) {
            var newSegment = mod10 << 16 | segments[segment];
            var segmentValue = newSegment / 10 | 0;
            segments[segment] = segmentValue;
            mod10 = newSegment - segmentValue * 10;
            if (segmentValue && !segmentsRemaining) {
              firstNonzeroSegment = segment;
              segmentsRemaining = true;
            }
          }
          base10Value = mod10 + base10Value;
        }
        return base10Value;
      }
      ts3.parsePseudoBigInt = parsePseudoBigInt;
      function pseudoBigIntToString(_a) {
        var negative = _a.negative, base10Value = _a.base10Value;
        return (negative && base10Value !== "0" ? "-" : "") + base10Value;
      }
      ts3.pseudoBigIntToString = pseudoBigIntToString;
      function isValidTypeOnlyAliasUseSite(useSite) {
        return !!(useSite.flags & 16777216) || isPartOfTypeQuery(useSite) || isIdentifierInNonEmittingHeritageClause(useSite) || isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(useSite) || !(isExpressionNode(useSite) || isShorthandPropertyNameUseSite(useSite));
      }
      ts3.isValidTypeOnlyAliasUseSite = isValidTypeOnlyAliasUseSite;
      function isShorthandPropertyNameUseSite(useSite) {
        return ts3.isIdentifier(useSite) && ts3.isShorthandPropertyAssignment(useSite.parent) && useSite.parent.name === useSite;
      }
      function isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(node) {
        while (node.kind === 79 || node.kind === 206) {
          node = node.parent;
        }
        if (node.kind !== 162) {
          return false;
        }
        if (hasSyntacticModifier(node.parent, 128)) {
          return true;
        }
        var containerKind = node.parent.parent.kind;
        return containerKind === 258 || containerKind === 182;
      }
      function isIdentifierInNonEmittingHeritageClause(node) {
        if (node.kind !== 79)
          return false;
        var heritageClause = ts3.findAncestor(node.parent, function(parent) {
          switch (parent.kind) {
            case 291:
              return true;
            case 206:
            case 228:
              return false;
            default:
              return "quit";
          }
        });
        return (heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.token) === 117 || (heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.parent.kind) === 258;
      }
      function isIdentifierTypeReference(node) {
        return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName);
      }
      ts3.isIdentifierTypeReference = isIdentifierTypeReference;
      function arrayIsHomogeneous(array, comparer) {
        if (comparer === void 0) {
          comparer = ts3.equateValues;
        }
        if (array.length < 2)
          return true;
        var first = array[0];
        for (var i = 1, length_1 = array.length; i < length_1; i++) {
          var target = array[i];
          if (!comparer(first, target))
            return false;
        }
        return true;
      }
      ts3.arrayIsHomogeneous = arrayIsHomogeneous;
      function setTextRangePos(range, pos) {
        range.pos = pos;
        return range;
      }
      ts3.setTextRangePos = setTextRangePos;
      function setTextRangeEnd(range, end) {
        range.end = end;
        return range;
      }
      ts3.setTextRangeEnd = setTextRangeEnd;
      function setTextRangePosEnd(range, pos, end) {
        return setTextRangeEnd(setTextRangePos(range, pos), end);
      }
      ts3.setTextRangePosEnd = setTextRangePosEnd;
      function setTextRangePosWidth(range, pos, width) {
        return setTextRangePosEnd(range, pos, pos + width);
      }
      ts3.setTextRangePosWidth = setTextRangePosWidth;
      function setNodeFlags(node, newFlags) {
        if (node) {
          node.flags = newFlags;
        }
        return node;
      }
      ts3.setNodeFlags = setNodeFlags;
      function setParent(child, parent) {
        if (child && parent) {
          child.parent = parent;
        }
        return child;
      }
      ts3.setParent = setParent;
      function setEachParent(children, parent) {
        if (children) {
          for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            setParent(child, parent);
          }
        }
        return children;
      }
      ts3.setEachParent = setEachParent;
      function setParentRecursive(rootNode, incremental) {
        if (!rootNode)
          return rootNode;
        ts3.forEachChildRecursively(rootNode, ts3.isJSDocNode(rootNode) ? bindParentToChildIgnoringJSDoc : bindParentToChild);
        return rootNode;
        function bindParentToChildIgnoringJSDoc(child, parent) {
          if (incremental && child.parent === parent) {
            return "skip";
          }
          setParent(child, parent);
        }
        function bindJSDoc(child) {
          if (ts3.hasJSDocNodes(child)) {
            for (var _i = 0, _a = child.jsDoc; _i < _a.length; _i++) {
              var doc = _a[_i];
              bindParentToChildIgnoringJSDoc(doc, child);
              ts3.forEachChildRecursively(doc, bindParentToChildIgnoringJSDoc);
            }
          }
        }
        function bindParentToChild(child, parent) {
          return bindParentToChildIgnoringJSDoc(child, parent) || bindJSDoc(child);
        }
      }
      ts3.setParentRecursive = setParentRecursive;
      function isPackedElement(node) {
        return !ts3.isOmittedExpression(node);
      }
      function isPackedArrayLiteral(node) {
        return ts3.isArrayLiteralExpression(node) && ts3.every(node.elements, isPackedElement);
      }
      ts3.isPackedArrayLiteral = isPackedArrayLiteral;
      function expressionResultIsUnused(node) {
        ts3.Debug.assertIsDefined(node.parent);
        while (true) {
          var parent = node.parent;
          if (ts3.isParenthesizedExpression(parent)) {
            node = parent;
            continue;
          }
          if (ts3.isExpressionStatement(parent) || ts3.isVoidExpression(parent) || ts3.isForStatement(parent) && (parent.initializer === node || parent.incrementor === node)) {
            return true;
          }
          if (ts3.isCommaListExpression(parent)) {
            if (node !== ts3.last(parent.elements))
              return true;
            node = parent;
            continue;
          }
          if (ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 27) {
            if (node === parent.left)
              return true;
            node = parent;
            continue;
          }
          return false;
        }
      }
      ts3.expressionResultIsUnused = expressionResultIsUnused;
      function containsIgnoredPath(path2) {
        return ts3.some(ts3.ignoredPaths, function(p) {
          return ts3.stringContains(path2, p);
        });
      }
      ts3.containsIgnoredPath = containsIgnoredPath;
      function getContainingNodeArray(node) {
        if (!node.parent)
          return void 0;
        switch (node.kind) {
          case 163:
            var parent_1 = node.parent;
            return parent_1.kind === 190 ? void 0 : parent_1.typeParameters;
          case 164:
            return node.parent.parameters;
          case 199:
            return node.parent.templateSpans;
          case 233:
            return node.parent.templateSpans;
          case 165:
            return node.parent.decorators;
          case 291:
            return node.parent.heritageClauses;
        }
        var parent = node.parent;
        if (ts3.isJSDocTag(node)) {
          return ts3.isJSDocTypeLiteral(node.parent) ? void 0 : node.parent.tags;
        }
        switch (parent.kind) {
          case 182:
          case 258:
            return ts3.isTypeElement(node) ? parent.members : void 0;
          case 187:
          case 188:
            return parent.types;
          case 184:
          case 204:
          case 351:
          case 269:
          case 273:
            return parent.elements;
          case 205:
          case 286:
            return parent.properties;
          case 208:
          case 209:
            return ts3.isTypeNode(node) ? parent.typeArguments : parent.expression === node ? void 0 : parent.arguments;
          case 278:
          case 282:
            return ts3.isJsxChild(node) ? parent.children : void 0;
          case 280:
          case 279:
            return ts3.isTypeNode(node) ? parent.typeArguments : void 0;
          case 235:
          case 289:
          case 290:
          case 262:
            return parent.statements;
          case 263:
            return parent.clauses;
          case 257:
          case 226:
            return ts3.isClassElement(node) ? parent.members : void 0;
          case 260:
            return ts3.isEnumMember(node) ? parent.members : void 0;
          case 305:
            return parent.statements;
        }
      }
      ts3.getContainingNodeArray = getContainingNodeArray;
      function hasContextSensitiveParameters(node) {
        if (!node.typeParameters) {
          if (ts3.some(node.parameters, function(p) {
            return !getEffectiveTypeAnnotationNode(p);
          })) {
            return true;
          }
          if (node.kind !== 214) {
            var parameter = ts3.firstOrUndefined(node.parameters);
            if (!(parameter && parameterIsThisKeyword(parameter))) {
              return true;
            }
          }
        }
        return false;
      }
      ts3.hasContextSensitiveParameters = hasContextSensitiveParameters;
      function isInfinityOrNaNString(name) {
        return name === "Infinity" || name === "-Infinity" || name === "NaN";
      }
      ts3.isInfinityOrNaNString = isInfinityOrNaNString;
      function isCatchClauseVariableDeclaration(node) {
        return node.kind === 254 && node.parent.kind === 292;
      }
      ts3.isCatchClauseVariableDeclaration = isCatchClauseVariableDeclaration;
      function isParameterOrCatchClauseVariable(symbol) {
        var declaration = symbol.valueDeclaration && getRootDeclaration(symbol.valueDeclaration);
        return !!declaration && (ts3.isParameter(declaration) || isCatchClauseVariableDeclaration(declaration));
      }
      ts3.isParameterOrCatchClauseVariable = isParameterOrCatchClauseVariable;
      function isFunctionExpressionOrArrowFunction(node) {
        return node.kind === 213 || node.kind === 214;
      }
      ts3.isFunctionExpressionOrArrowFunction = isFunctionExpressionOrArrowFunction;
      function escapeSnippetText(text) {
        return text.replace(/\$/gm, function() {
          return "\\$";
        });
      }
      ts3.escapeSnippetText = escapeSnippetText;
      function isNumericLiteralName(name) {
        return (+name).toString() === name;
      }
      ts3.isNumericLiteralName = isNumericLiteralName;
      function createPropertyNameNodeForIdentifierOrLiteral(name, target, singleQuote, stringNamed) {
        return ts3.isIdentifierText(name, target) ? ts3.factory.createIdentifier(name) : !stringNamed && isNumericLiteralName(name) && +name >= 0 ? ts3.factory.createNumericLiteral(+name) : ts3.factory.createStringLiteral(name, !!singleQuote);
      }
      ts3.createPropertyNameNodeForIdentifierOrLiteral = createPropertyNameNodeForIdentifierOrLiteral;
      function isThisTypeParameter(type2) {
        return !!(type2.flags & 262144 && type2.isThisType);
      }
      ts3.isThisTypeParameter = isThisTypeParameter;
      function getNodeModulePathParts(fullPath) {
        var topLevelNodeModulesIndex = 0;
        var topLevelPackageNameIndex = 0;
        var packageRootIndex = 0;
        var fileNameIndex = 0;
        var States;
        (function(States2) {
          States2[States2["BeforeNodeModules"] = 0] = "BeforeNodeModules";
          States2[States2["NodeModules"] = 1] = "NodeModules";
          States2[States2["Scope"] = 2] = "Scope";
          States2[States2["PackageContent"] = 3] = "PackageContent";
        })(States || (States = {}));
        var partStart = 0;
        var partEnd = 0;
        var state = 0;
        while (partEnd >= 0) {
          partStart = partEnd;
          partEnd = fullPath.indexOf("/", partStart + 1);
          switch (state) {
            case 0:
              if (fullPath.indexOf(ts3.nodeModulesPathPart, partStart) === partStart) {
                topLevelNodeModulesIndex = partStart;
                topLevelPackageNameIndex = partEnd;
                state = 1;
              }
              break;
            case 1:
            case 2:
              if (state === 1 && fullPath.charAt(partStart + 1) === "@") {
                state = 2;
              } else {
                packageRootIndex = partEnd;
                state = 3;
              }
              break;
            case 3:
              if (fullPath.indexOf(ts3.nodeModulesPathPart, partStart) === partStart) {
                state = 1;
              } else {
                state = 3;
              }
              break;
          }
        }
        fileNameIndex = partStart;
        return state > 1 ? { topLevelNodeModulesIndex, topLevelPackageNameIndex, packageRootIndex, fileNameIndex } : void 0;
      }
      ts3.getNodeModulePathParts = getNodeModulePathParts;
      function getParameterTypeNode(parameter) {
        var _a;
        return parameter.kind === 340 ? (_a = parameter.typeExpression) === null || _a === void 0 ? void 0 : _a.type : parameter.type;
      }
      ts3.getParameterTypeNode = getParameterTypeNode;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createBaseNodeFactory() {
        var NodeConstructor;
        var TokenConstructor;
        var IdentifierConstructor;
        var PrivateIdentifierConstructor;
        var SourceFileConstructor;
        return {
          createBaseSourceFileNode,
          createBaseIdentifierNode,
          createBasePrivateIdentifierNode,
          createBaseTokenNode,
          createBaseNode
        };
        function createBaseSourceFileNode(kind) {
          return new (SourceFileConstructor || (SourceFileConstructor = ts3.objectAllocator.getSourceFileConstructor()))(kind, -1, -1);
        }
        function createBaseIdentifierNode(kind) {
          return new (IdentifierConstructor || (IdentifierConstructor = ts3.objectAllocator.getIdentifierConstructor()))(kind, -1, -1);
        }
        function createBasePrivateIdentifierNode(kind) {
          return new (PrivateIdentifierConstructor || (PrivateIdentifierConstructor = ts3.objectAllocator.getPrivateIdentifierConstructor()))(kind, -1, -1);
        }
        function createBaseTokenNode(kind) {
          return new (TokenConstructor || (TokenConstructor = ts3.objectAllocator.getTokenConstructor()))(kind, -1, -1);
        }
        function createBaseNode(kind) {
          return new (NodeConstructor || (NodeConstructor = ts3.objectAllocator.getNodeConstructor()))(kind, -1, -1);
        }
      }
      ts3.createBaseNodeFactory = createBaseNodeFactory;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createParenthesizerRules(factory) {
        var binaryLeftOperandParenthesizerCache;
        var binaryRightOperandParenthesizerCache;
        return {
          getParenthesizeLeftSideOfBinaryForOperator,
          getParenthesizeRightSideOfBinaryForOperator,
          parenthesizeLeftSideOfBinary,
          parenthesizeRightSideOfBinary,
          parenthesizeExpressionOfComputedPropertyName,
          parenthesizeConditionOfConditionalExpression,
          parenthesizeBranchOfConditionalExpression,
          parenthesizeExpressionOfExportDefault,
          parenthesizeExpressionOfNew,
          parenthesizeLeftSideOfAccess,
          parenthesizeOperandOfPostfixUnary,
          parenthesizeOperandOfPrefixUnary,
          parenthesizeExpressionsOfCommaDelimitedList,
          parenthesizeExpressionForDisallowedComma,
          parenthesizeExpressionOfExpressionStatement,
          parenthesizeConciseBodyOfArrowFunction,
          parenthesizeCheckTypeOfConditionalType,
          parenthesizeExtendsTypeOfConditionalType,
          parenthesizeConstituentTypesOfUnionType,
          parenthesizeConstituentTypeOfUnionType,
          parenthesizeConstituentTypesOfIntersectionType,
          parenthesizeConstituentTypeOfIntersectionType,
          parenthesizeOperandOfTypeOperator,
          parenthesizeOperandOfReadonlyTypeOperator,
          parenthesizeNonArrayTypeOfPostfixType,
          parenthesizeElementTypesOfTupleType,
          parenthesizeElementTypeOfTupleType,
          parenthesizeTypeOfOptionalType,
          parenthesizeTypeArguments,
          parenthesizeLeadingTypeArgument
        };
        function getParenthesizeLeftSideOfBinaryForOperator(operatorKind) {
          binaryLeftOperandParenthesizerCache || (binaryLeftOperandParenthesizerCache = new ts3.Map());
          var parenthesizerRule = binaryLeftOperandParenthesizerCache.get(operatorKind);
          if (!parenthesizerRule) {
            parenthesizerRule = function(node) {
              return parenthesizeLeftSideOfBinary(operatorKind, node);
            };
            binaryLeftOperandParenthesizerCache.set(operatorKind, parenthesizerRule);
          }
          return parenthesizerRule;
        }
        function getParenthesizeRightSideOfBinaryForOperator(operatorKind) {
          binaryRightOperandParenthesizerCache || (binaryRightOperandParenthesizerCache = new ts3.Map());
          var parenthesizerRule = binaryRightOperandParenthesizerCache.get(operatorKind);
          if (!parenthesizerRule) {
            parenthesizerRule = function(node) {
              return parenthesizeRightSideOfBinary(operatorKind, void 0, node);
            };
            binaryRightOperandParenthesizerCache.set(operatorKind, parenthesizerRule);
          }
          return parenthesizerRule;
        }
        function binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
          var binaryOperatorPrecedence = ts3.getOperatorPrecedence(221, binaryOperator);
          var binaryOperatorAssociativity = ts3.getOperatorAssociativity(221, binaryOperator);
          var emittedOperand = ts3.skipPartiallyEmittedExpressions(operand);
          if (!isLeftSideOfBinary && operand.kind === 214 && binaryOperatorPrecedence > 3) {
            return true;
          }
          var operandPrecedence = ts3.getExpressionPrecedence(emittedOperand);
          switch (ts3.compareValues(operandPrecedence, binaryOperatorPrecedence)) {
            case -1:
              if (!isLeftSideOfBinary && binaryOperatorAssociativity === 1 && operand.kind === 224) {
                return false;
              }
              return true;
            case 1:
              return false;
            case 0:
              if (isLeftSideOfBinary) {
                return binaryOperatorAssociativity === 1;
              } else {
                if (ts3.isBinaryExpression(emittedOperand) && emittedOperand.operatorToken.kind === binaryOperator) {
                  if (operatorHasAssociativeProperty(binaryOperator)) {
                    return false;
                  }
                  if (binaryOperator === 39) {
                    var leftKind = leftOperand ? getLiteralKindOfBinaryPlusOperand(leftOperand) : 0;
                    if (ts3.isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(emittedOperand)) {
                      return false;
                    }
                  }
                }
                var operandAssociativity = ts3.getExpressionAssociativity(emittedOperand);
                return operandAssociativity === 0;
              }
          }
        }
        function operatorHasAssociativeProperty(binaryOperator) {
          return binaryOperator === 41 || binaryOperator === 51 || binaryOperator === 50 || binaryOperator === 52;
        }
        function getLiteralKindOfBinaryPlusOperand(node) {
          node = ts3.skipPartiallyEmittedExpressions(node);
          if (ts3.isLiteralKind(node.kind)) {
            return node.kind;
          }
          if (node.kind === 221 && node.operatorToken.kind === 39) {
            if (node.cachedLiteralKind !== void 0) {
              return node.cachedLiteralKind;
            }
            var leftKind = getLiteralKindOfBinaryPlusOperand(node.left);
            var literalKind = ts3.isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(node.right) ? leftKind : 0;
            node.cachedLiteralKind = literalKind;
            return literalKind;
          }
          return 0;
        }
        function parenthesizeBinaryOperand(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
          var skipped = ts3.skipPartiallyEmittedExpressions(operand);
          if (skipped.kind === 212) {
            return operand;
          }
          return binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) ? factory.createParenthesizedExpression(operand) : operand;
        }
        function parenthesizeLeftSideOfBinary(binaryOperator, leftSide) {
          return parenthesizeBinaryOperand(binaryOperator, leftSide, true);
        }
        function parenthesizeRightSideOfBinary(binaryOperator, leftSide, rightSide) {
          return parenthesizeBinaryOperand(binaryOperator, rightSide, false, leftSide);
        }
        function parenthesizeExpressionOfComputedPropertyName(expression) {
          return ts3.isCommaSequence(expression) ? factory.createParenthesizedExpression(expression) : expression;
        }
        function parenthesizeConditionOfConditionalExpression(condition) {
          var conditionalPrecedence = ts3.getOperatorPrecedence(222, 57);
          var emittedCondition = ts3.skipPartiallyEmittedExpressions(condition);
          var conditionPrecedence = ts3.getExpressionPrecedence(emittedCondition);
          if (ts3.compareValues(conditionPrecedence, conditionalPrecedence) !== 1) {
            return factory.createParenthesizedExpression(condition);
          }
          return condition;
        }
        function parenthesizeBranchOfConditionalExpression(branch) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(branch);
          return ts3.isCommaSequence(emittedExpression) ? factory.createParenthesizedExpression(branch) : branch;
        }
        function parenthesizeExpressionOfExportDefault(expression) {
          var check = ts3.skipPartiallyEmittedExpressions(expression);
          var needsParens = ts3.isCommaSequence(check);
          if (!needsParens) {
            switch (ts3.getLeftmostExpression(check, false).kind) {
              case 226:
              case 213:
                needsParens = true;
            }
          }
          return needsParens ? factory.createParenthesizedExpression(expression) : expression;
        }
        function parenthesizeExpressionOfNew(expression) {
          var leftmostExpr = ts3.getLeftmostExpression(expression, true);
          switch (leftmostExpr.kind) {
            case 208:
              return factory.createParenthesizedExpression(expression);
            case 209:
              return !leftmostExpr.arguments ? factory.createParenthesizedExpression(expression) : expression;
          }
          return parenthesizeLeftSideOfAccess(expression);
        }
        function parenthesizeLeftSideOfAccess(expression) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(expression);
          if (ts3.isLeftHandSideExpression(emittedExpression) && (emittedExpression.kind !== 209 || emittedExpression.arguments)) {
            return expression;
          }
          return ts3.setTextRange(factory.createParenthesizedExpression(expression), expression);
        }
        function parenthesizeOperandOfPostfixUnary(operand) {
          return ts3.isLeftHandSideExpression(operand) ? operand : ts3.setTextRange(factory.createParenthesizedExpression(operand), operand);
        }
        function parenthesizeOperandOfPrefixUnary(operand) {
          return ts3.isUnaryExpression(operand) ? operand : ts3.setTextRange(factory.createParenthesizedExpression(operand), operand);
        }
        function parenthesizeExpressionsOfCommaDelimitedList(elements) {
          var result2 = ts3.sameMap(elements, parenthesizeExpressionForDisallowedComma);
          return ts3.setTextRange(factory.createNodeArray(result2, elements.hasTrailingComma), elements);
        }
        function parenthesizeExpressionForDisallowedComma(expression) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(expression);
          var expressionPrecedence = ts3.getExpressionPrecedence(emittedExpression);
          var commaPrecedence = ts3.getOperatorPrecedence(221, 27);
          return expressionPrecedence > commaPrecedence ? expression : ts3.setTextRange(factory.createParenthesizedExpression(expression), expression);
        }
        function parenthesizeExpressionOfExpressionStatement(expression) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(expression);
          if (ts3.isCallExpression(emittedExpression)) {
            var callee = emittedExpression.expression;
            var kind = ts3.skipPartiallyEmittedExpressions(callee).kind;
            if (kind === 213 || kind === 214) {
              var updated = factory.updateCallExpression(emittedExpression, ts3.setTextRange(factory.createParenthesizedExpression(callee), callee), emittedExpression.typeArguments, emittedExpression.arguments);
              return factory.restoreOuterExpressions(expression, updated, 8);
            }
          }
          var leftmostExpressionKind = ts3.getLeftmostExpression(emittedExpression, false).kind;
          if (leftmostExpressionKind === 205 || leftmostExpressionKind === 213) {
            return ts3.setTextRange(factory.createParenthesizedExpression(expression), expression);
          }
          return expression;
        }
        function parenthesizeConciseBodyOfArrowFunction(body) {
          if (!ts3.isBlock(body) && (ts3.isCommaSequence(body) || ts3.getLeftmostExpression(body, false).kind === 205)) {
            return ts3.setTextRange(factory.createParenthesizedExpression(body), body);
          }
          return body;
        }
        function parenthesizeCheckTypeOfConditionalType(checkType) {
          switch (checkType.kind) {
            case 179:
            case 180:
            case 189:
              return factory.createParenthesizedType(checkType);
          }
          return checkType;
        }
        function parenthesizeExtendsTypeOfConditionalType(extendsType) {
          switch (extendsType.kind) {
            case 189:
              return factory.createParenthesizedType(extendsType);
          }
          return extendsType;
        }
        function parenthesizeConstituentTypeOfUnionType(type2) {
          switch (type2.kind) {
            case 187:
            case 188:
              return factory.createParenthesizedType(type2);
          }
          return parenthesizeCheckTypeOfConditionalType(type2);
        }
        function parenthesizeConstituentTypesOfUnionType(members) {
          return factory.createNodeArray(ts3.sameMap(members, parenthesizeConstituentTypeOfUnionType));
        }
        function parenthesizeConstituentTypeOfIntersectionType(type2) {
          switch (type2.kind) {
            case 187:
            case 188:
              return factory.createParenthesizedType(type2);
          }
          return parenthesizeConstituentTypeOfUnionType(type2);
        }
        function parenthesizeConstituentTypesOfIntersectionType(members) {
          return factory.createNodeArray(ts3.sameMap(members, parenthesizeConstituentTypeOfIntersectionType));
        }
        function parenthesizeOperandOfTypeOperator(type2) {
          switch (type2.kind) {
            case 188:
              return factory.createParenthesizedType(type2);
          }
          return parenthesizeConstituentTypeOfIntersectionType(type2);
        }
        function parenthesizeOperandOfReadonlyTypeOperator(type2) {
          switch (type2.kind) {
            case 193:
              return factory.createParenthesizedType(type2);
          }
          return parenthesizeOperandOfTypeOperator(type2);
        }
        function parenthesizeNonArrayTypeOfPostfixType(type2) {
          switch (type2.kind) {
            case 190:
            case 193:
            case 181:
              return factory.createParenthesizedType(type2);
          }
          return parenthesizeOperandOfTypeOperator(type2);
        }
        function parenthesizeElementTypesOfTupleType(types2) {
          return factory.createNodeArray(ts3.sameMap(types2, parenthesizeElementTypeOfTupleType));
        }
        function parenthesizeElementTypeOfTupleType(type2) {
          if (hasJSDocPostfixQuestion(type2))
            return factory.createParenthesizedType(type2);
          return type2;
        }
        function hasJSDocPostfixQuestion(type2) {
          if (ts3.isJSDocNullableType(type2))
            return type2.postfix;
          if (ts3.isNamedTupleMember(type2))
            return hasJSDocPostfixQuestion(type2.type);
          if (ts3.isFunctionTypeNode(type2) || ts3.isConstructorTypeNode(type2) || ts3.isTypeOperatorNode(type2))
            return hasJSDocPostfixQuestion(type2.type);
          if (ts3.isConditionalTypeNode(type2))
            return hasJSDocPostfixQuestion(type2.falseType);
          if (ts3.isUnionTypeNode(type2))
            return hasJSDocPostfixQuestion(ts3.last(type2.types));
          if (ts3.isIntersectionTypeNode(type2))
            return hasJSDocPostfixQuestion(ts3.last(type2.types));
          if (ts3.isInferTypeNode(type2))
            return !!type2.typeParameter.constraint && hasJSDocPostfixQuestion(type2.typeParameter.constraint);
          return false;
        }
        function parenthesizeTypeOfOptionalType(type2) {
          if (hasJSDocPostfixQuestion(type2))
            return factory.createParenthesizedType(type2);
          return parenthesizeNonArrayTypeOfPostfixType(type2);
        }
        function parenthesizeLeadingTypeArgument(node) {
          return ts3.isFunctionOrConstructorTypeNode(node) && node.typeParameters ? factory.createParenthesizedType(node) : node;
        }
        function parenthesizeOrdinalTypeArgument(node, i) {
          return i === 0 ? parenthesizeLeadingTypeArgument(node) : node;
        }
        function parenthesizeTypeArguments(typeArguments) {
          if (ts3.some(typeArguments)) {
            return factory.createNodeArray(ts3.sameMap(typeArguments, parenthesizeOrdinalTypeArgument));
          }
        }
      }
      ts3.createParenthesizerRules = createParenthesizerRules;
      ts3.nullParenthesizerRules = {
        getParenthesizeLeftSideOfBinaryForOperator: function(_) {
          return ts3.identity;
        },
        getParenthesizeRightSideOfBinaryForOperator: function(_) {
          return ts3.identity;
        },
        parenthesizeLeftSideOfBinary: function(_binaryOperator, leftSide) {
          return leftSide;
        },
        parenthesizeRightSideOfBinary: function(_binaryOperator, _leftSide, rightSide) {
          return rightSide;
        },
        parenthesizeExpressionOfComputedPropertyName: ts3.identity,
        parenthesizeConditionOfConditionalExpression: ts3.identity,
        parenthesizeBranchOfConditionalExpression: ts3.identity,
        parenthesizeExpressionOfExportDefault: ts3.identity,
        parenthesizeExpressionOfNew: function(expression) {
          return ts3.cast(expression, ts3.isLeftHandSideExpression);
        },
        parenthesizeLeftSideOfAccess: function(expression) {
          return ts3.cast(expression, ts3.isLeftHandSideExpression);
        },
        parenthesizeOperandOfPostfixUnary: function(operand) {
          return ts3.cast(operand, ts3.isLeftHandSideExpression);
        },
        parenthesizeOperandOfPrefixUnary: function(operand) {
          return ts3.cast(operand, ts3.isUnaryExpression);
        },
        parenthesizeExpressionsOfCommaDelimitedList: function(nodes) {
          return ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeExpressionForDisallowedComma: ts3.identity,
        parenthesizeExpressionOfExpressionStatement: ts3.identity,
        parenthesizeConciseBodyOfArrowFunction: ts3.identity,
        parenthesizeCheckTypeOfConditionalType: ts3.identity,
        parenthesizeExtendsTypeOfConditionalType: ts3.identity,
        parenthesizeConstituentTypesOfUnionType: function(nodes) {
          return ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeConstituentTypeOfUnionType: ts3.identity,
        parenthesizeConstituentTypesOfIntersectionType: function(nodes) {
          return ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeConstituentTypeOfIntersectionType: ts3.identity,
        parenthesizeOperandOfTypeOperator: ts3.identity,
        parenthesizeOperandOfReadonlyTypeOperator: ts3.identity,
        parenthesizeNonArrayTypeOfPostfixType: ts3.identity,
        parenthesizeElementTypesOfTupleType: function(nodes) {
          return ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeElementTypeOfTupleType: ts3.identity,
        parenthesizeTypeOfOptionalType: ts3.identity,
        parenthesizeTypeArguments: function(nodes) {
          return nodes && ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeLeadingTypeArgument: ts3.identity
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createNodeConverters(factory) {
        return {
          convertToFunctionBlock,
          convertToFunctionExpression,
          convertToArrayAssignmentElement,
          convertToObjectAssignmentElement,
          convertToAssignmentPattern,
          convertToObjectAssignmentPattern,
          convertToArrayAssignmentPattern,
          convertToAssignmentElementTarget
        };
        function convertToFunctionBlock(node, multiLine) {
          if (ts3.isBlock(node))
            return node;
          var returnStatement = factory.createReturnStatement(node);
          ts3.setTextRange(returnStatement, node);
          var body = factory.createBlock([returnStatement], multiLine);
          ts3.setTextRange(body, node);
          return body;
        }
        function convertToFunctionExpression(node) {
          if (!node.body)
            return ts3.Debug.fail("Cannot convert a FunctionDeclaration without a body");
          var updated = factory.createFunctionExpression(node.modifiers, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body);
          ts3.setOriginalNode(updated, node);
          ts3.setTextRange(updated, node);
          if (ts3.getStartsOnNewLine(node)) {
            ts3.setStartsOnNewLine(updated, true);
          }
          return updated;
        }
        function convertToArrayAssignmentElement(element) {
          if (ts3.isBindingElement(element)) {
            if (element.dotDotDotToken) {
              ts3.Debug.assertNode(element.name, ts3.isIdentifier);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createSpreadElement(element.name), element), element);
            }
            var expression = convertToAssignmentElementTarget(element.name);
            return element.initializer ? ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(expression, element.initializer), element), element) : expression;
          }
          return ts3.cast(element, ts3.isExpression);
        }
        function convertToObjectAssignmentElement(element) {
          if (ts3.isBindingElement(element)) {
            if (element.dotDotDotToken) {
              ts3.Debug.assertNode(element.name, ts3.isIdentifier);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createSpreadAssignment(element.name), element), element);
            }
            if (element.propertyName) {
              var expression = convertToAssignmentElementTarget(element.name);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createPropertyAssignment(element.propertyName, element.initializer ? factory.createAssignment(expression, element.initializer) : expression), element), element);
            }
            ts3.Debug.assertNode(element.name, ts3.isIdentifier);
            return ts3.setOriginalNode(ts3.setTextRange(factory.createShorthandPropertyAssignment(element.name, element.initializer), element), element);
          }
          return ts3.cast(element, ts3.isObjectLiteralElementLike);
        }
        function convertToAssignmentPattern(node) {
          switch (node.kind) {
            case 202:
            case 204:
              return convertToArrayAssignmentPattern(node);
            case 201:
            case 205:
              return convertToObjectAssignmentPattern(node);
          }
        }
        function convertToObjectAssignmentPattern(node) {
          if (ts3.isObjectBindingPattern(node)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createObjectLiteralExpression(ts3.map(node.elements, convertToObjectAssignmentElement)), node), node);
          }
          return ts3.cast(node, ts3.isObjectLiteralExpression);
        }
        function convertToArrayAssignmentPattern(node) {
          if (ts3.isArrayBindingPattern(node)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createArrayLiteralExpression(ts3.map(node.elements, convertToArrayAssignmentElement)), node), node);
          }
          return ts3.cast(node, ts3.isArrayLiteralExpression);
        }
        function convertToAssignmentElementTarget(node) {
          if (ts3.isBindingPattern(node)) {
            return convertToAssignmentPattern(node);
          }
          return ts3.cast(node, ts3.isExpression);
        }
      }
      ts3.createNodeConverters = createNodeConverters;
      ts3.nullNodeConverters = {
        convertToFunctionBlock: ts3.notImplemented,
        convertToFunctionExpression: ts3.notImplemented,
        convertToArrayAssignmentElement: ts3.notImplemented,
        convertToObjectAssignmentElement: ts3.notImplemented,
        convertToAssignmentPattern: ts3.notImplemented,
        convertToObjectAssignmentPattern: ts3.notImplemented,
        convertToArrayAssignmentPattern: ts3.notImplemented,
        convertToAssignmentElementTarget: ts3.notImplemented
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var nextAutoGenerateId = 0;
      var NodeFactoryFlags;
      (function(NodeFactoryFlags2) {
        NodeFactoryFlags2[NodeFactoryFlags2["None"] = 0] = "None";
        NodeFactoryFlags2[NodeFactoryFlags2["NoParenthesizerRules"] = 1] = "NoParenthesizerRules";
        NodeFactoryFlags2[NodeFactoryFlags2["NoNodeConverters"] = 2] = "NoNodeConverters";
        NodeFactoryFlags2[NodeFactoryFlags2["NoIndentationOnFreshPropertyAccess"] = 4] = "NoIndentationOnFreshPropertyAccess";
        NodeFactoryFlags2[NodeFactoryFlags2["NoOriginalNode"] = 8] = "NoOriginalNode";
      })(NodeFactoryFlags = ts3.NodeFactoryFlags || (ts3.NodeFactoryFlags = {}));
      function createNodeFactory(flags, baseFactory2) {
        var update = flags & 8 ? updateWithoutOriginal : updateWithOriginal;
        var parenthesizerRules = ts3.memoize(function() {
          return flags & 1 ? ts3.nullParenthesizerRules : ts3.createParenthesizerRules(factory);
        });
        var converters = ts3.memoize(function() {
          return flags & 2 ? ts3.nullNodeConverters : ts3.createNodeConverters(factory);
        });
        var getBinaryCreateFunction = ts3.memoizeOne(function(operator) {
          return function(left, right) {
            return createBinaryExpression(left, operator, right);
          };
        });
        var getPrefixUnaryCreateFunction = ts3.memoizeOne(function(operator) {
          return function(operand) {
            return createPrefixUnaryExpression(operator, operand);
          };
        });
        var getPostfixUnaryCreateFunction = ts3.memoizeOne(function(operator) {
          return function(operand) {
            return createPostfixUnaryExpression(operand, operator);
          };
        });
        var getJSDocPrimaryTypeCreateFunction = ts3.memoizeOne(function(kind) {
          return function() {
            return createJSDocPrimaryTypeWorker(kind);
          };
        });
        var getJSDocUnaryTypeCreateFunction = ts3.memoizeOne(function(kind) {
          return function(type2) {
            return createJSDocUnaryTypeWorker(kind, type2);
          };
        });
        var getJSDocUnaryTypeUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, type2) {
            return updateJSDocUnaryTypeWorker(kind, node, type2);
          };
        });
        var getJSDocPrePostfixUnaryTypeCreateFunction = ts3.memoizeOne(function(kind) {
          return function(type2, postfix) {
            return createJSDocPrePostfixUnaryTypeWorker(kind, type2, postfix);
          };
        });
        var getJSDocPrePostfixUnaryTypeUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, type2) {
            return updateJSDocPrePostfixUnaryTypeWorker(kind, node, type2);
          };
        });
        var getJSDocSimpleTagCreateFunction = ts3.memoizeOne(function(kind) {
          return function(tagName, comment) {
            return createJSDocSimpleTagWorker(kind, tagName, comment);
          };
        });
        var getJSDocSimpleTagUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, tagName, comment) {
            return updateJSDocSimpleTagWorker(kind, node, tagName, comment);
          };
        });
        var getJSDocTypeLikeTagCreateFunction = ts3.memoizeOne(function(kind) {
          return function(tagName, typeExpression, comment) {
            return createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment);
          };
        });
        var getJSDocTypeLikeTagUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, tagName, typeExpression, comment) {
            return updateJSDocTypeLikeTagWorker(kind, node, tagName, typeExpression, comment);
          };
        });
        var factory = {
          get parenthesizer() {
            return parenthesizerRules();
          },
          get converters() {
            return converters();
          },
          baseFactory: baseFactory2,
          flags,
          createNodeArray,
          createNumericLiteral,
          createBigIntLiteral,
          createStringLiteral,
          createStringLiteralFromNode,
          createRegularExpressionLiteral,
          createLiteralLikeNode,
          createIdentifier,
          updateIdentifier,
          createTempVariable,
          createLoopVariable,
          createUniqueName,
          getGeneratedNameForNode,
          createPrivateIdentifier,
          createToken,
          createSuper,
          createThis,
          createNull,
          createTrue,
          createFalse,
          createModifier,
          createModifiersFromModifierFlags,
          createQualifiedName,
          updateQualifiedName,
          createComputedPropertyName,
          updateComputedPropertyName,
          createTypeParameterDeclaration,
          updateTypeParameterDeclaration,
          createParameterDeclaration,
          updateParameterDeclaration,
          createDecorator,
          updateDecorator,
          createPropertySignature,
          updatePropertySignature,
          createPropertyDeclaration,
          updatePropertyDeclaration,
          createMethodSignature,
          updateMethodSignature,
          createMethodDeclaration,
          updateMethodDeclaration,
          createConstructorDeclaration,
          updateConstructorDeclaration,
          createGetAccessorDeclaration,
          updateGetAccessorDeclaration,
          createSetAccessorDeclaration,
          updateSetAccessorDeclaration,
          createCallSignature,
          updateCallSignature,
          createConstructSignature,
          updateConstructSignature,
          createIndexSignature,
          updateIndexSignature,
          createClassStaticBlockDeclaration,
          updateClassStaticBlockDeclaration,
          createTemplateLiteralTypeSpan,
          updateTemplateLiteralTypeSpan,
          createKeywordTypeNode,
          createTypePredicateNode,
          updateTypePredicateNode,
          createTypeReferenceNode,
          updateTypeReferenceNode,
          createFunctionTypeNode,
          updateFunctionTypeNode,
          createConstructorTypeNode,
          updateConstructorTypeNode,
          createTypeQueryNode,
          updateTypeQueryNode,
          createTypeLiteralNode,
          updateTypeLiteralNode,
          createArrayTypeNode,
          updateArrayTypeNode,
          createTupleTypeNode,
          updateTupleTypeNode,
          createNamedTupleMember,
          updateNamedTupleMember,
          createOptionalTypeNode,
          updateOptionalTypeNode,
          createRestTypeNode,
          updateRestTypeNode,
          createUnionTypeNode,
          updateUnionTypeNode,
          createIntersectionTypeNode,
          updateIntersectionTypeNode,
          createConditionalTypeNode,
          updateConditionalTypeNode,
          createInferTypeNode,
          updateInferTypeNode,
          createImportTypeNode,
          updateImportTypeNode,
          createParenthesizedType,
          updateParenthesizedType,
          createThisTypeNode,
          createTypeOperatorNode,
          updateTypeOperatorNode,
          createIndexedAccessTypeNode,
          updateIndexedAccessTypeNode,
          createMappedTypeNode,
          updateMappedTypeNode,
          createLiteralTypeNode,
          updateLiteralTypeNode,
          createTemplateLiteralType,
          updateTemplateLiteralType,
          createObjectBindingPattern,
          updateObjectBindingPattern,
          createArrayBindingPattern,
          updateArrayBindingPattern,
          createBindingElement,
          updateBindingElement,
          createArrayLiteralExpression,
          updateArrayLiteralExpression,
          createObjectLiteralExpression,
          updateObjectLiteralExpression,
          createPropertyAccessExpression: flags & 4 ? function(expression, name) {
            return ts3.setEmitFlags(createPropertyAccessExpression(expression, name), 131072);
          } : createPropertyAccessExpression,
          updatePropertyAccessExpression,
          createPropertyAccessChain: flags & 4 ? function(expression, questionDotToken, name) {
            return ts3.setEmitFlags(createPropertyAccessChain(expression, questionDotToken, name), 131072);
          } : createPropertyAccessChain,
          updatePropertyAccessChain,
          createElementAccessExpression,
          updateElementAccessExpression,
          createElementAccessChain,
          updateElementAccessChain,
          createCallExpression,
          updateCallExpression,
          createCallChain,
          updateCallChain,
          createNewExpression,
          updateNewExpression,
          createTaggedTemplateExpression,
          updateTaggedTemplateExpression,
          createTypeAssertion,
          updateTypeAssertion,
          createParenthesizedExpression,
          updateParenthesizedExpression,
          createFunctionExpression,
          updateFunctionExpression,
          createArrowFunction,
          updateArrowFunction,
          createDeleteExpression,
          updateDeleteExpression,
          createTypeOfExpression,
          updateTypeOfExpression,
          createVoidExpression,
          updateVoidExpression,
          createAwaitExpression,
          updateAwaitExpression,
          createPrefixUnaryExpression,
          updatePrefixUnaryExpression,
          createPostfixUnaryExpression,
          updatePostfixUnaryExpression,
          createBinaryExpression,
          updateBinaryExpression,
          createConditionalExpression,
          updateConditionalExpression,
          createTemplateExpression,
          updateTemplateExpression,
          createTemplateHead,
          createTemplateMiddle,
          createTemplateTail,
          createNoSubstitutionTemplateLiteral,
          createTemplateLiteralLikeNode,
          createYieldExpression,
          updateYieldExpression,
          createSpreadElement,
          updateSpreadElement,
          createClassExpression,
          updateClassExpression,
          createOmittedExpression,
          createExpressionWithTypeArguments,
          updateExpressionWithTypeArguments,
          createAsExpression,
          updateAsExpression,
          createNonNullExpression,
          updateNonNullExpression,
          createNonNullChain,
          updateNonNullChain,
          createMetaProperty,
          updateMetaProperty,
          createTemplateSpan,
          updateTemplateSpan,
          createSemicolonClassElement,
          createBlock,
          updateBlock,
          createVariableStatement,
          updateVariableStatement,
          createEmptyStatement,
          createExpressionStatement,
          updateExpressionStatement,
          createIfStatement,
          updateIfStatement,
          createDoStatement,
          updateDoStatement,
          createWhileStatement,
          updateWhileStatement,
          createForStatement,
          updateForStatement,
          createForInStatement,
          updateForInStatement,
          createForOfStatement,
          updateForOfStatement,
          createContinueStatement,
          updateContinueStatement,
          createBreakStatement,
          updateBreakStatement,
          createReturnStatement,
          updateReturnStatement,
          createWithStatement,
          updateWithStatement,
          createSwitchStatement,
          updateSwitchStatement,
          createLabeledStatement,
          updateLabeledStatement,
          createThrowStatement,
          updateThrowStatement,
          createTryStatement,
          updateTryStatement,
          createDebuggerStatement,
          createVariableDeclaration,
          updateVariableDeclaration,
          createVariableDeclarationList,
          updateVariableDeclarationList,
          createFunctionDeclaration,
          updateFunctionDeclaration,
          createClassDeclaration,
          updateClassDeclaration,
          createInterfaceDeclaration,
          updateInterfaceDeclaration,
          createTypeAliasDeclaration,
          updateTypeAliasDeclaration,
          createEnumDeclaration,
          updateEnumDeclaration,
          createModuleDeclaration,
          updateModuleDeclaration,
          createModuleBlock,
          updateModuleBlock,
          createCaseBlock,
          updateCaseBlock,
          createNamespaceExportDeclaration,
          updateNamespaceExportDeclaration,
          createImportEqualsDeclaration,
          updateImportEqualsDeclaration,
          createImportDeclaration,
          updateImportDeclaration,
          createImportClause,
          updateImportClause,
          createAssertClause,
          updateAssertClause,
          createAssertEntry,
          updateAssertEntry,
          createImportTypeAssertionContainer,
          updateImportTypeAssertionContainer,
          createNamespaceImport,
          updateNamespaceImport,
          createNamespaceExport,
          updateNamespaceExport,
          createNamedImports,
          updateNamedImports,
          createImportSpecifier,
          updateImportSpecifier,
          createExportAssignment,
          updateExportAssignment,
          createExportDeclaration,
          updateExportDeclaration,
          createNamedExports,
          updateNamedExports,
          createExportSpecifier,
          updateExportSpecifier,
          createMissingDeclaration,
          createExternalModuleReference,
          updateExternalModuleReference,
          get createJSDocAllType() {
            return getJSDocPrimaryTypeCreateFunction(312);
          },
          get createJSDocUnknownType() {
            return getJSDocPrimaryTypeCreateFunction(313);
          },
          get createJSDocNonNullableType() {
            return getJSDocPrePostfixUnaryTypeCreateFunction(315);
          },
          get updateJSDocNonNullableType() {
            return getJSDocPrePostfixUnaryTypeUpdateFunction(315);
          },
          get createJSDocNullableType() {
            return getJSDocPrePostfixUnaryTypeCreateFunction(314);
          },
          get updateJSDocNullableType() {
            return getJSDocPrePostfixUnaryTypeUpdateFunction(314);
          },
          get createJSDocOptionalType() {
            return getJSDocUnaryTypeCreateFunction(316);
          },
          get updateJSDocOptionalType() {
            return getJSDocUnaryTypeUpdateFunction(316);
          },
          get createJSDocVariadicType() {
            return getJSDocUnaryTypeCreateFunction(318);
          },
          get updateJSDocVariadicType() {
            return getJSDocUnaryTypeUpdateFunction(318);
          },
          get createJSDocNamepathType() {
            return getJSDocUnaryTypeCreateFunction(319);
          },
          get updateJSDocNamepathType() {
            return getJSDocUnaryTypeUpdateFunction(319);
          },
          createJSDocFunctionType,
          updateJSDocFunctionType,
          createJSDocTypeLiteral,
          updateJSDocTypeLiteral,
          createJSDocTypeExpression,
          updateJSDocTypeExpression,
          createJSDocSignature,
          updateJSDocSignature,
          createJSDocTemplateTag,
          updateJSDocTemplateTag,
          createJSDocTypedefTag,
          updateJSDocTypedefTag,
          createJSDocParameterTag,
          updateJSDocParameterTag,
          createJSDocPropertyTag,
          updateJSDocPropertyTag,
          createJSDocCallbackTag,
          updateJSDocCallbackTag,
          createJSDocAugmentsTag,
          updateJSDocAugmentsTag,
          createJSDocImplementsTag,
          updateJSDocImplementsTag,
          createJSDocSeeTag,
          updateJSDocSeeTag,
          createJSDocNameReference,
          updateJSDocNameReference,
          createJSDocMemberName,
          updateJSDocMemberName,
          createJSDocLink,
          updateJSDocLink,
          createJSDocLinkCode,
          updateJSDocLinkCode,
          createJSDocLinkPlain,
          updateJSDocLinkPlain,
          get createJSDocTypeTag() {
            return getJSDocTypeLikeTagCreateFunction(343);
          },
          get updateJSDocTypeTag() {
            return getJSDocTypeLikeTagUpdateFunction(343);
          },
          get createJSDocReturnTag() {
            return getJSDocTypeLikeTagCreateFunction(341);
          },
          get updateJSDocReturnTag() {
            return getJSDocTypeLikeTagUpdateFunction(341);
          },
          get createJSDocThisTag() {
            return getJSDocTypeLikeTagCreateFunction(342);
          },
          get updateJSDocThisTag() {
            return getJSDocTypeLikeTagUpdateFunction(342);
          },
          get createJSDocEnumTag() {
            return getJSDocTypeLikeTagCreateFunction(339);
          },
          get updateJSDocEnumTag() {
            return getJSDocTypeLikeTagUpdateFunction(339);
          },
          get createJSDocAuthorTag() {
            return getJSDocSimpleTagCreateFunction(330);
          },
          get updateJSDocAuthorTag() {
            return getJSDocSimpleTagUpdateFunction(330);
          },
          get createJSDocClassTag() {
            return getJSDocSimpleTagCreateFunction(332);
          },
          get updateJSDocClassTag() {
            return getJSDocSimpleTagUpdateFunction(332);
          },
          get createJSDocPublicTag() {
            return getJSDocSimpleTagCreateFunction(333);
          },
          get updateJSDocPublicTag() {
            return getJSDocSimpleTagUpdateFunction(333);
          },
          get createJSDocPrivateTag() {
            return getJSDocSimpleTagCreateFunction(334);
          },
          get updateJSDocPrivateTag() {
            return getJSDocSimpleTagUpdateFunction(334);
          },
          get createJSDocProtectedTag() {
            return getJSDocSimpleTagCreateFunction(335);
          },
          get updateJSDocProtectedTag() {
            return getJSDocSimpleTagUpdateFunction(335);
          },
          get createJSDocReadonlyTag() {
            return getJSDocSimpleTagCreateFunction(336);
          },
          get updateJSDocReadonlyTag() {
            return getJSDocSimpleTagUpdateFunction(336);
          },
          get createJSDocOverrideTag() {
            return getJSDocSimpleTagCreateFunction(337);
          },
          get updateJSDocOverrideTag() {
            return getJSDocSimpleTagUpdateFunction(337);
          },
          get createJSDocDeprecatedTag() {
            return getJSDocSimpleTagCreateFunction(331);
          },
          get updateJSDocDeprecatedTag() {
            return getJSDocSimpleTagUpdateFunction(331);
          },
          createJSDocUnknownTag,
          updateJSDocUnknownTag,
          createJSDocText,
          updateJSDocText,
          createJSDocComment,
          updateJSDocComment,
          createJsxElement,
          updateJsxElement,
          createJsxSelfClosingElement,
          updateJsxSelfClosingElement,
          createJsxOpeningElement,
          updateJsxOpeningElement,
          createJsxClosingElement,
          updateJsxClosingElement,
          createJsxFragment,
          createJsxText,
          updateJsxText,
          createJsxOpeningFragment,
          createJsxJsxClosingFragment,
          updateJsxFragment,
          createJsxAttribute,
          updateJsxAttribute,
          createJsxAttributes,
          updateJsxAttributes,
          createJsxSpreadAttribute,
          updateJsxSpreadAttribute,
          createJsxExpression,
          updateJsxExpression,
          createCaseClause,
          updateCaseClause,
          createDefaultClause,
          updateDefaultClause,
          createHeritageClause,
          updateHeritageClause,
          createCatchClause,
          updateCatchClause,
          createPropertyAssignment,
          updatePropertyAssignment,
          createShorthandPropertyAssignment,
          updateShorthandPropertyAssignment,
          createSpreadAssignment,
          updateSpreadAssignment,
          createEnumMember,
          updateEnumMember,
          createSourceFile,
          updateSourceFile,
          createBundle,
          updateBundle,
          createUnparsedSource,
          createUnparsedPrologue,
          createUnparsedPrepend,
          createUnparsedTextLike,
          createUnparsedSyntheticReference,
          createInputFiles: createInputFiles2,
          createSyntheticExpression,
          createSyntaxList,
          createNotEmittedStatement,
          createPartiallyEmittedExpression,
          updatePartiallyEmittedExpression,
          createCommaListExpression,
          updateCommaListExpression,
          createEndOfDeclarationMarker,
          createMergeDeclarationMarker,
          createSyntheticReferenceExpression,
          updateSyntheticReferenceExpression,
          cloneNode,
          get createComma() {
            return getBinaryCreateFunction(27);
          },
          get createAssignment() {
            return getBinaryCreateFunction(63);
          },
          get createLogicalOr() {
            return getBinaryCreateFunction(56);
          },
          get createLogicalAnd() {
            return getBinaryCreateFunction(55);
          },
          get createBitwiseOr() {
            return getBinaryCreateFunction(51);
          },
          get createBitwiseXor() {
            return getBinaryCreateFunction(52);
          },
          get createBitwiseAnd() {
            return getBinaryCreateFunction(50);
          },
          get createStrictEquality() {
            return getBinaryCreateFunction(36);
          },
          get createStrictInequality() {
            return getBinaryCreateFunction(37);
          },
          get createEquality() {
            return getBinaryCreateFunction(34);
          },
          get createInequality() {
            return getBinaryCreateFunction(35);
          },
          get createLessThan() {
            return getBinaryCreateFunction(29);
          },
          get createLessThanEquals() {
            return getBinaryCreateFunction(32);
          },
          get createGreaterThan() {
            return getBinaryCreateFunction(31);
          },
          get createGreaterThanEquals() {
            return getBinaryCreateFunction(33);
          },
          get createLeftShift() {
            return getBinaryCreateFunction(47);
          },
          get createRightShift() {
            return getBinaryCreateFunction(48);
          },
          get createUnsignedRightShift() {
            return getBinaryCreateFunction(49);
          },
          get createAdd() {
            return getBinaryCreateFunction(39);
          },
          get createSubtract() {
            return getBinaryCreateFunction(40);
          },
          get createMultiply() {
            return getBinaryCreateFunction(41);
          },
          get createDivide() {
            return getBinaryCreateFunction(43);
          },
          get createModulo() {
            return getBinaryCreateFunction(44);
          },
          get createExponent() {
            return getBinaryCreateFunction(42);
          },
          get createPrefixPlus() {
            return getPrefixUnaryCreateFunction(39);
          },
          get createPrefixMinus() {
            return getPrefixUnaryCreateFunction(40);
          },
          get createPrefixIncrement() {
            return getPrefixUnaryCreateFunction(45);
          },
          get createPrefixDecrement() {
            return getPrefixUnaryCreateFunction(46);
          },
          get createBitwiseNot() {
            return getPrefixUnaryCreateFunction(54);
          },
          get createLogicalNot() {
            return getPrefixUnaryCreateFunction(53);
          },
          get createPostfixIncrement() {
            return getPostfixUnaryCreateFunction(45);
          },
          get createPostfixDecrement() {
            return getPostfixUnaryCreateFunction(46);
          },
          createImmediatelyInvokedFunctionExpression,
          createImmediatelyInvokedArrowFunction,
          createVoidZero,
          createExportDefault,
          createExternalModuleExport,
          createTypeCheck,
          createMethodCall,
          createGlobalMethodCall,
          createFunctionBindCall,
          createFunctionCallCall,
          createFunctionApplyCall,
          createArraySliceCall,
          createArrayConcatCall,
          createObjectDefinePropertyCall,
          createReflectGetCall,
          createReflectSetCall,
          createPropertyDescriptor,
          createCallBinding,
          createAssignmentTargetWrapper,
          inlineExpressions,
          getInternalName,
          getLocalName,
          getExportName,
          getDeclarationName,
          getNamespaceMemberName,
          getExternalModuleOrNamespaceExportName,
          restoreOuterExpressions,
          restoreEnclosingLabel,
          createUseStrictPrologue,
          copyPrologue,
          copyStandardPrologue,
          copyCustomPrologue,
          ensureUseStrict,
          liftToBlock,
          mergeLexicalEnvironment,
          updateModifiers
        };
        return factory;
        function createNodeArray(elements, hasTrailingComma) {
          if (elements === void 0 || elements === ts3.emptyArray) {
            elements = [];
          } else if (ts3.isNodeArray(elements)) {
            if (hasTrailingComma === void 0 || elements.hasTrailingComma === hasTrailingComma) {
              if (elements.transformFlags === void 0) {
                aggregateChildrenFlags(elements);
              }
              ts3.Debug.attachNodeArrayDebugInfo(elements);
              return elements;
            }
            var array_8 = elements.slice();
            array_8.pos = elements.pos;
            array_8.end = elements.end;
            array_8.hasTrailingComma = hasTrailingComma;
            array_8.transformFlags = elements.transformFlags;
            ts3.Debug.attachNodeArrayDebugInfo(array_8);
            return array_8;
          }
          var length = elements.length;
          var array = length >= 1 && length <= 4 ? elements.slice() : elements;
          ts3.setTextRangePosEnd(array, -1, -1);
          array.hasTrailingComma = !!hasTrailingComma;
          aggregateChildrenFlags(array);
          ts3.Debug.attachNodeArrayDebugInfo(array);
          return array;
        }
        function createBaseNode(kind) {
          return baseFactory2.createBaseNode(kind);
        }
        function createBaseDeclaration(kind, decorators, modifiers) {
          var node = createBaseNode(kind);
          node.decorators = asNodeArray(decorators);
          node.modifiers = asNodeArray(modifiers);
          node.transformFlags |= propagateChildrenFlags(node.decorators) | propagateChildrenFlags(node.modifiers);
          node.symbol = void 0;
          node.localSymbol = void 0;
          node.locals = void 0;
          node.nextContainer = void 0;
          return node;
        }
        function createBaseNamedDeclaration(kind, decorators, modifiers, name) {
          var node = createBaseDeclaration(kind, decorators, modifiers);
          name = asName(name);
          node.name = name;
          if (name) {
            switch (node.kind) {
              case 169:
              case 172:
              case 173:
              case 167:
              case 296:
                if (ts3.isIdentifier(name)) {
                  node.transformFlags |= propagateIdentifierNameFlags(name);
                  break;
                }
              default:
                node.transformFlags |= propagateChildFlags(name);
                break;
            }
          }
          return node;
        }
        function createBaseGenericNamedDeclaration(kind, decorators, modifiers, name, typeParameters) {
          var node = createBaseNamedDeclaration(kind, decorators, modifiers, name);
          node.typeParameters = asNodeArray(typeParameters);
          node.transformFlags |= propagateChildrenFlags(node.typeParameters);
          if (typeParameters)
            node.transformFlags |= 1;
          return node;
        }
        function createBaseSignatureDeclaration(kind, decorators, modifiers, name, typeParameters, parameters, type2) {
          var node = createBaseGenericNamedDeclaration(kind, decorators, modifiers, name, typeParameters);
          node.parameters = createNodeArray(parameters);
          node.type = type2;
          node.transformFlags |= propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type);
          if (type2)
            node.transformFlags |= 1;
          return node;
        }
        function updateBaseSignatureDeclaration(updated, original) {
          if (original.typeArguments)
            updated.typeArguments = original.typeArguments;
          return update(updated, original);
        }
        function createBaseFunctionLikeDeclaration(kind, decorators, modifiers, name, typeParameters, parameters, type2, body) {
          var node = createBaseSignatureDeclaration(kind, decorators, modifiers, name, typeParameters, parameters, type2);
          node.body = body;
          node.transformFlags |= propagateChildFlags(node.body) & ~16777216;
          if (!body)
            node.transformFlags |= 1;
          return node;
        }
        function updateBaseFunctionLikeDeclaration(updated, original) {
          if (original.exclamationToken)
            updated.exclamationToken = original.exclamationToken;
          if (original.typeArguments)
            updated.typeArguments = original.typeArguments;
          return updateBaseSignatureDeclaration(updated, original);
        }
        function createBaseInterfaceOrClassLikeDeclaration(kind, decorators, modifiers, name, typeParameters, heritageClauses) {
          var node = createBaseGenericNamedDeclaration(kind, decorators, modifiers, name, typeParameters);
          node.heritageClauses = asNodeArray(heritageClauses);
          node.transformFlags |= propagateChildrenFlags(node.heritageClauses);
          return node;
        }
        function createBaseClassLikeDeclaration(kind, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseInterfaceOrClassLikeDeclaration(kind, decorators, modifiers, name, typeParameters, heritageClauses);
          node.members = createNodeArray(members);
          node.transformFlags |= propagateChildrenFlags(node.members);
          return node;
        }
        function createBaseBindingLikeDeclaration(kind, decorators, modifiers, name, initializer) {
          var node = createBaseNamedDeclaration(kind, decorators, modifiers, name);
          node.initializer = initializer;
          node.transformFlags |= propagateChildFlags(node.initializer);
          return node;
        }
        function createBaseVariableLikeDeclaration(kind, decorators, modifiers, name, type2, initializer) {
          var node = createBaseBindingLikeDeclaration(kind, decorators, modifiers, name, initializer);
          node.type = type2;
          node.transformFlags |= propagateChildFlags(type2);
          if (type2)
            node.transformFlags |= 1;
          return node;
        }
        function createBaseLiteral(kind, text) {
          var node = createBaseToken(kind);
          node.text = text;
          return node;
        }
        function createNumericLiteral(value, numericLiteralFlags) {
          if (numericLiteralFlags === void 0) {
            numericLiteralFlags = 0;
          }
          var node = createBaseLiteral(8, typeof value === "number" ? value + "" : value);
          node.numericLiteralFlags = numericLiteralFlags;
          if (numericLiteralFlags & 384)
            node.transformFlags |= 1024;
          return node;
        }
        function createBigIntLiteral(value) {
          var node = createBaseLiteral(9, typeof value === "string" ? value : ts3.pseudoBigIntToString(value) + "n");
          node.transformFlags |= 4;
          return node;
        }
        function createBaseStringLiteral(text, isSingleQuote) {
          var node = createBaseLiteral(10, text);
          node.singleQuote = isSingleQuote;
          return node;
        }
        function createStringLiteral(text, isSingleQuote, hasExtendedUnicodeEscape) {
          var node = createBaseStringLiteral(text, isSingleQuote);
          node.hasExtendedUnicodeEscape = hasExtendedUnicodeEscape;
          if (hasExtendedUnicodeEscape)
            node.transformFlags |= 1024;
          return node;
        }
        function createStringLiteralFromNode(sourceNode) {
          var node = createBaseStringLiteral(ts3.getTextOfIdentifierOrLiteral(sourceNode), void 0);
          node.textSourceNode = sourceNode;
          return node;
        }
        function createRegularExpressionLiteral(text) {
          var node = createBaseLiteral(13, text);
          return node;
        }
        function createLiteralLikeNode(kind, text) {
          switch (kind) {
            case 8:
              return createNumericLiteral(text, 0);
            case 9:
              return createBigIntLiteral(text);
            case 10:
              return createStringLiteral(text, void 0);
            case 11:
              return createJsxText(text, false);
            case 12:
              return createJsxText(text, true);
            case 13:
              return createRegularExpressionLiteral(text);
            case 14:
              return createTemplateLiteralLikeNode(kind, text, void 0, 0);
          }
        }
        function createBaseIdentifier(text, originalKeywordKind) {
          if (originalKeywordKind === void 0 && text) {
            originalKeywordKind = ts3.stringToToken(text);
          }
          if (originalKeywordKind === 79) {
            originalKeywordKind = void 0;
          }
          var node = baseFactory2.createBaseIdentifierNode(79);
          node.originalKeywordKind = originalKeywordKind;
          node.escapedText = ts3.escapeLeadingUnderscores(text);
          return node;
        }
        function createBaseGeneratedIdentifier(text, autoGenerateFlags) {
          var node = createBaseIdentifier(text, void 0);
          node.autoGenerateFlags = autoGenerateFlags;
          node.autoGenerateId = nextAutoGenerateId;
          nextAutoGenerateId++;
          return node;
        }
        function createIdentifier(text, typeArguments, originalKeywordKind) {
          var node = createBaseIdentifier(text, originalKeywordKind);
          if (typeArguments) {
            node.typeArguments = createNodeArray(typeArguments);
          }
          if (node.originalKeywordKind === 132) {
            node.transformFlags |= 16777216;
          }
          return node;
        }
        function updateIdentifier(node, typeArguments) {
          return node.typeArguments !== typeArguments ? update(createIdentifier(ts3.idText(node), typeArguments), node) : node;
        }
        function createTempVariable(recordTempVariable, reservedInNestedScopes) {
          var flags2 = 1;
          if (reservedInNestedScopes)
            flags2 |= 8;
          var name = createBaseGeneratedIdentifier("", flags2);
          if (recordTempVariable) {
            recordTempVariable(name);
          }
          return name;
        }
        function createLoopVariable(reservedInNestedScopes) {
          var flags2 = 2;
          if (reservedInNestedScopes)
            flags2 |= 8;
          return createBaseGeneratedIdentifier("", flags2);
        }
        function createUniqueName(text, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          ts3.Debug.assert(!(flags2 & 7), "Argument out of range: flags");
          ts3.Debug.assert((flags2 & (16 | 32)) !== 32, "GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic");
          return createBaseGeneratedIdentifier(text, 3 | flags2);
        }
        function getGeneratedNameForNode(node, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          ts3.Debug.assert(!(flags2 & 7), "Argument out of range: flags");
          var name = createBaseGeneratedIdentifier(node && ts3.isIdentifier(node) ? ts3.idText(node) : "", 4 | flags2);
          name.original = node;
          return name;
        }
        function createPrivateIdentifier(text) {
          if (!ts3.startsWith(text, "#"))
            ts3.Debug.fail("First character of private identifier must be #: " + text);
          var node = baseFactory2.createBasePrivateIdentifierNode(80);
          node.escapedText = ts3.escapeLeadingUnderscores(text);
          node.transformFlags |= 8388608;
          return node;
        }
        function createBaseToken(kind) {
          return baseFactory2.createBaseTokenNode(kind);
        }
        function createToken(token) {
          ts3.Debug.assert(token >= 0 && token <= 160, "Invalid token");
          ts3.Debug.assert(token <= 14 || token >= 17, "Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals.");
          ts3.Debug.assert(token <= 8 || token >= 14, "Invalid token. Use 'createLiteralLikeNode' to create literals.");
          ts3.Debug.assert(token !== 79, "Invalid token. Use 'createIdentifier' to create identifiers");
          var node = createBaseToken(token);
          var transformFlags = 0;
          switch (token) {
            case 131:
              transformFlags = 256 | 128;
              break;
            case 123:
            case 121:
            case 122:
            case 145:
            case 126:
            case 135:
            case 85:
            case 130:
            case 147:
            case 158:
            case 143:
            case 148:
            case 101:
            case 144:
            case 159:
            case 150:
            case 133:
            case 151:
            case 114:
            case 155:
            case 153:
              transformFlags = 1;
              break;
            case 106:
              transformFlags = 1024 | 33554432;
              break;
            case 124:
              transformFlags = 1024;
              break;
            case 108:
              transformFlags = 8192;
              break;
          }
          if (transformFlags) {
            node.transformFlags |= transformFlags;
          }
          return node;
        }
        function createSuper() {
          return createToken(106);
        }
        function createThis() {
          return createToken(108);
        }
        function createNull() {
          return createToken(104);
        }
        function createTrue() {
          return createToken(110);
        }
        function createFalse() {
          return createToken(95);
        }
        function createModifier(kind) {
          return createToken(kind);
        }
        function createModifiersFromModifierFlags(flags2) {
          var result2 = [];
          if (flags2 & 1)
            result2.push(createModifier(93));
          if (flags2 & 2)
            result2.push(createModifier(135));
          if (flags2 & 512)
            result2.push(createModifier(88));
          if (flags2 & 2048)
            result2.push(createModifier(85));
          if (flags2 & 4)
            result2.push(createModifier(123));
          if (flags2 & 8)
            result2.push(createModifier(121));
          if (flags2 & 16)
            result2.push(createModifier(122));
          if (flags2 & 128)
            result2.push(createModifier(126));
          if (flags2 & 32)
            result2.push(createModifier(124));
          if (flags2 & 16384)
            result2.push(createModifier(159));
          if (flags2 & 64)
            result2.push(createModifier(145));
          if (flags2 & 256)
            result2.push(createModifier(131));
          if (flags2 & 32768)
            result2.push(createModifier(101));
          if (flags2 & 65536)
            result2.push(createModifier(144));
          return result2.length ? result2 : void 0;
        }
        function createQualifiedName(left, right) {
          var node = createBaseNode(161);
          node.left = left;
          node.right = asName(right);
          node.transformFlags |= propagateChildFlags(node.left) | propagateIdentifierNameFlags(node.right);
          return node;
        }
        function updateQualifiedName(node, left, right) {
          return node.left !== left || node.right !== right ? update(createQualifiedName(left, right), node) : node;
        }
        function createComputedPropertyName(expression) {
          var node = createBaseNode(162);
          node.expression = parenthesizerRules().parenthesizeExpressionOfComputedPropertyName(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1024 | 65536;
          return node;
        }
        function updateComputedPropertyName(node, expression) {
          return node.expression !== expression ? update(createComputedPropertyName(expression), node) : node;
        }
        function createTypeParameterDeclaration(modifiersOrName, nameOrConstraint, constraintOrDefault, defaultType) {
          var name;
          var modifiers;
          var constraint;
          if (modifiersOrName === void 0 || ts3.isArray(modifiersOrName)) {
            modifiers = modifiersOrName;
            name = nameOrConstraint;
            constraint = constraintOrDefault;
          } else {
            modifiers = void 0;
            name = modifiersOrName;
            constraint = nameOrConstraint;
          }
          var node = createBaseNamedDeclaration(163, void 0, modifiers, name);
          node.constraint = constraint;
          node.default = defaultType;
          node.transformFlags = 1;
          return node;
        }
        function updateTypeParameterDeclaration(node, modifiersOrName, nameOrConstraint, constraintOrDefault, defaultType) {
          var name;
          var modifiers;
          var constraint;
          if (modifiersOrName === void 0 || ts3.isArray(modifiersOrName)) {
            modifiers = modifiersOrName;
            name = nameOrConstraint;
            constraint = constraintOrDefault;
          } else {
            modifiers = void 0;
            name = modifiersOrName;
            constraint = nameOrConstraint;
          }
          return node.modifiers !== modifiers || node.name !== name || node.constraint !== constraint || node.default !== defaultType ? update(createTypeParameterDeclaration(modifiers, name, constraint, defaultType), node) : node;
        }
        function createParameterDeclaration(decorators, modifiers, dotDotDotToken, name, questionToken, type2, initializer) {
          var node = createBaseVariableLikeDeclaration(164, decorators, modifiers, name, type2, initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer));
          node.dotDotDotToken = dotDotDotToken;
          node.questionToken = questionToken;
          if (ts3.isThisIdentifier(node.name)) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | propagateChildFlags(node.questionToken);
            if (questionToken)
              node.transformFlags |= 1;
            if (ts3.modifiersToFlags(node.modifiers) & 16476)
              node.transformFlags |= 4096;
            if (initializer || dotDotDotToken)
              node.transformFlags |= 1024;
          }
          return node;
        }
        function updateParameterDeclaration(node, decorators, modifiers, dotDotDotToken, name, questionToken, type2, initializer) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type2 || node.initializer !== initializer ? update(createParameterDeclaration(decorators, modifiers, dotDotDotToken, name, questionToken, type2, initializer), node) : node;
        }
        function createDecorator(expression) {
          var node = createBaseNode(165);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1 | 4096;
          return node;
        }
        function updateDecorator(node, expression) {
          return node.expression !== expression ? update(createDecorator(expression), node) : node;
        }
        function createPropertySignature(modifiers, name, questionToken, type2) {
          var node = createBaseNamedDeclaration(166, void 0, modifiers, name);
          node.type = type2;
          node.questionToken = questionToken;
          node.transformFlags = 1;
          return node;
        }
        function updatePropertySignature(node, modifiers, name, questionToken, type2) {
          return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.type !== type2 ? update(createPropertySignature(modifiers, name, questionToken, type2), node) : node;
        }
        function createPropertyDeclaration(decorators, modifiers, name, questionOrExclamationToken, type2, initializer) {
          var node = createBaseVariableLikeDeclaration(167, decorators, modifiers, name, type2, initializer);
          node.questionToken = questionOrExclamationToken && ts3.isQuestionToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0;
          node.exclamationToken = questionOrExclamationToken && ts3.isExclamationToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0;
          node.transformFlags |= propagateChildFlags(node.questionToken) | propagateChildFlags(node.exclamationToken) | 8388608;
          if (ts3.isComputedPropertyName(node.name) || ts3.hasStaticModifier(node) && node.initializer) {
            node.transformFlags |= 4096;
          }
          if (questionOrExclamationToken || ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updatePropertyDeclaration(node, decorators, modifiers, name, questionOrExclamationToken, type2, initializer) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.questionToken !== (questionOrExclamationToken !== void 0 && ts3.isQuestionToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0) || node.exclamationToken !== (questionOrExclamationToken !== void 0 && ts3.isExclamationToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0) || node.type !== type2 || node.initializer !== initializer ? update(createPropertyDeclaration(decorators, modifiers, name, questionOrExclamationToken, type2, initializer), node) : node;
        }
        function createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type2) {
          var node = createBaseSignatureDeclaration(168, void 0, modifiers, name, typeParameters, parameters, type2);
          node.questionToken = questionToken;
          node.transformFlags = 1;
          return node;
        }
        function updateMethodSignature(node, modifiers, name, questionToken, typeParameters, parameters, type2) {
          return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 ? updateBaseSignatureDeclaration(createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type2), node) : node;
        }
        function createMethodDeclaration(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type2, body) {
          var node = createBaseFunctionLikeDeclaration(169, decorators, modifiers, name, typeParameters, parameters, type2, body);
          node.asteriskToken = asteriskToken;
          node.questionToken = questionToken;
          node.transformFlags |= propagateChildFlags(node.asteriskToken) | propagateChildFlags(node.questionToken) | 1024;
          if (questionToken) {
            node.transformFlags |= 1;
          }
          if (ts3.modifiersToFlags(node.modifiers) & 256) {
            if (asteriskToken) {
              node.transformFlags |= 128;
            } else {
              node.transformFlags |= 256;
            }
          } else if (asteriskToken) {
            node.transformFlags |= 2048;
          }
          return node;
        }
        function updateMethodDeclaration(node, decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type2, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 || node.body !== body ? updateBaseFunctionLikeDeclaration(createMethodDeclaration(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type2, body), node) : node;
        }
        function createClassStaticBlockDeclaration(decorators, modifiers, body) {
          var node = createBaseGenericNamedDeclaration(170, decorators, modifiers, void 0, void 0);
          node.body = body;
          node.transformFlags = propagateChildFlags(body) | 8388608;
          return node;
        }
        function updateClassStaticBlockDeclaration(node, decorators, modifiers, body) {
          return node.decorators !== decorators || node.modifier !== modifiers || node.body !== body ? update(createClassStaticBlockDeclaration(decorators, modifiers, body), node) : node;
        }
        function createConstructorDeclaration(decorators, modifiers, parameters, body) {
          var node = createBaseFunctionLikeDeclaration(171, decorators, modifiers, void 0, void 0, parameters, void 0, body);
          node.transformFlags |= 1024;
          return node;
        }
        function updateConstructorDeclaration(node, decorators, modifiers, parameters, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.parameters !== parameters || node.body !== body ? updateBaseFunctionLikeDeclaration(createConstructorDeclaration(decorators, modifiers, parameters, body), node) : node;
        }
        function createGetAccessorDeclaration(decorators, modifiers, name, parameters, type2, body) {
          return createBaseFunctionLikeDeclaration(172, decorators, modifiers, name, void 0, parameters, type2, body);
        }
        function updateGetAccessorDeclaration(node, decorators, modifiers, name, parameters, type2, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.type !== type2 || node.body !== body ? updateBaseFunctionLikeDeclaration(createGetAccessorDeclaration(decorators, modifiers, name, parameters, type2, body), node) : node;
        }
        function createSetAccessorDeclaration(decorators, modifiers, name, parameters, body) {
          return createBaseFunctionLikeDeclaration(173, decorators, modifiers, name, void 0, parameters, void 0, body);
        }
        function updateSetAccessorDeclaration(node, decorators, modifiers, name, parameters, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.body !== body ? updateBaseFunctionLikeDeclaration(createSetAccessorDeclaration(decorators, modifiers, name, parameters, body), node) : node;
        }
        function createCallSignature(typeParameters, parameters, type2) {
          var node = createBaseSignatureDeclaration(174, void 0, void 0, void 0, typeParameters, parameters, type2);
          node.transformFlags = 1;
          return node;
        }
        function updateCallSignature(node, typeParameters, parameters, type2) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 ? updateBaseSignatureDeclaration(createCallSignature(typeParameters, parameters, type2), node) : node;
        }
        function createConstructSignature(typeParameters, parameters, type2) {
          var node = createBaseSignatureDeclaration(175, void 0, void 0, void 0, typeParameters, parameters, type2);
          node.transformFlags = 1;
          return node;
        }
        function updateConstructSignature(node, typeParameters, parameters, type2) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 ? updateBaseSignatureDeclaration(createConstructSignature(typeParameters, parameters, type2), node) : node;
        }
        function createIndexSignature(decorators, modifiers, parameters, type2) {
          var node = createBaseSignatureDeclaration(176, decorators, modifiers, void 0, void 0, parameters, type2);
          node.transformFlags = 1;
          return node;
        }
        function updateIndexSignature(node, decorators, modifiers, parameters, type2) {
          return node.parameters !== parameters || node.type !== type2 || node.decorators !== decorators || node.modifiers !== modifiers ? updateBaseSignatureDeclaration(createIndexSignature(decorators, modifiers, parameters, type2), node) : node;
        }
        function createTemplateLiteralTypeSpan(type2, literal) {
          var node = createBaseNode(199);
          node.type = type2;
          node.literal = literal;
          node.transformFlags = 1;
          return node;
        }
        function updateTemplateLiteralTypeSpan(node, type2, literal) {
          return node.type !== type2 || node.literal !== literal ? update(createTemplateLiteralTypeSpan(type2, literal), node) : node;
        }
        function createKeywordTypeNode(kind) {
          return createToken(kind);
        }
        function createTypePredicateNode(assertsModifier, parameterName, type2) {
          var node = createBaseNode(177);
          node.assertsModifier = assertsModifier;
          node.parameterName = asName(parameterName);
          node.type = type2;
          node.transformFlags = 1;
          return node;
        }
        function updateTypePredicateNode(node, assertsModifier, parameterName, type2) {
          return node.assertsModifier !== assertsModifier || node.parameterName !== parameterName || node.type !== type2 ? update(createTypePredicateNode(assertsModifier, parameterName, type2), node) : node;
        }
        function createTypeReferenceNode(typeName, typeArguments) {
          var node = createBaseNode(178);
          node.typeName = asName(typeName);
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(createNodeArray(typeArguments));
          node.transformFlags = 1;
          return node;
        }
        function updateTypeReferenceNode(node, typeName, typeArguments) {
          return node.typeName !== typeName || node.typeArguments !== typeArguments ? update(createTypeReferenceNode(typeName, typeArguments), node) : node;
        }
        function createFunctionTypeNode(typeParameters, parameters, type2) {
          var node = createBaseSignatureDeclaration(179, void 0, void 0, void 0, typeParameters, parameters, type2);
          node.transformFlags = 1;
          return node;
        }
        function updateFunctionTypeNode(node, typeParameters, parameters, type2) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 ? updateBaseSignatureDeclaration(createFunctionTypeNode(typeParameters, parameters, type2), node) : node;
        }
        function createConstructorTypeNode() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return args.length === 4 ? createConstructorTypeNode1.apply(void 0, args) : args.length === 3 ? createConstructorTypeNode2.apply(void 0, args) : ts3.Debug.fail("Incorrect number of arguments specified.");
        }
        function createConstructorTypeNode1(modifiers, typeParameters, parameters, type2) {
          var node = createBaseSignatureDeclaration(180, void 0, modifiers, void 0, typeParameters, parameters, type2);
          node.transformFlags = 1;
          return node;
        }
        function createConstructorTypeNode2(typeParameters, parameters, type2) {
          return createConstructorTypeNode1(void 0, typeParameters, parameters, type2);
        }
        function updateConstructorTypeNode() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return args.length === 5 ? updateConstructorTypeNode1.apply(void 0, args) : args.length === 4 ? updateConstructorTypeNode2.apply(void 0, args) : ts3.Debug.fail("Incorrect number of arguments specified.");
        }
        function updateConstructorTypeNode1(node, modifiers, typeParameters, parameters, type2) {
          return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 ? updateBaseSignatureDeclaration(createConstructorTypeNode(modifiers, typeParameters, parameters, type2), node) : node;
        }
        function updateConstructorTypeNode2(node, typeParameters, parameters, type2) {
          return updateConstructorTypeNode1(node, node.modifiers, typeParameters, parameters, type2);
        }
        function createTypeQueryNode(exprName, typeArguments) {
          var node = createBaseNode(181);
          node.exprName = exprName;
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
          node.transformFlags = 1;
          return node;
        }
        function updateTypeQueryNode(node, exprName, typeArguments) {
          return node.exprName !== exprName || node.typeArguments !== typeArguments ? update(createTypeQueryNode(exprName, typeArguments), node) : node;
        }
        function createTypeLiteralNode(members) {
          var node = createBaseNode(182);
          node.members = createNodeArray(members);
          node.transformFlags = 1;
          return node;
        }
        function updateTypeLiteralNode(node, members) {
          return node.members !== members ? update(createTypeLiteralNode(members), node) : node;
        }
        function createArrayTypeNode(elementType) {
          var node = createBaseNode(183);
          node.elementType = parenthesizerRules().parenthesizeNonArrayTypeOfPostfixType(elementType);
          node.transformFlags = 1;
          return node;
        }
        function updateArrayTypeNode(node, elementType) {
          return node.elementType !== elementType ? update(createArrayTypeNode(elementType), node) : node;
        }
        function createTupleTypeNode(elements) {
          var node = createBaseNode(184);
          node.elements = createNodeArray(parenthesizerRules().parenthesizeElementTypesOfTupleType(elements));
          node.transformFlags = 1;
          return node;
        }
        function updateTupleTypeNode(node, elements) {
          return node.elements !== elements ? update(createTupleTypeNode(elements), node) : node;
        }
        function createNamedTupleMember(dotDotDotToken, name, questionToken, type2) {
          var node = createBaseNode(197);
          node.dotDotDotToken = dotDotDotToken;
          node.name = name;
          node.questionToken = questionToken;
          node.type = type2;
          node.transformFlags = 1;
          return node;
        }
        function updateNamedTupleMember(node, dotDotDotToken, name, questionToken, type2) {
          return node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type2 ? update(createNamedTupleMember(dotDotDotToken, name, questionToken, type2), node) : node;
        }
        function createOptionalTypeNode(type2) {
          var node = createBaseNode(185);
          node.type = parenthesizerRules().parenthesizeTypeOfOptionalType(type2);
          node.transformFlags = 1;
          return node;
        }
        function updateOptionalTypeNode(node, type2) {
          return node.type !== type2 ? update(createOptionalTypeNode(type2), node) : node;
        }
        function createRestTypeNode(type2) {
          var node = createBaseNode(186);
          node.type = type2;
          node.transformFlags = 1;
          return node;
        }
        function updateRestTypeNode(node, type2) {
          return node.type !== type2 ? update(createRestTypeNode(type2), node) : node;
        }
        function createUnionOrIntersectionTypeNode(kind, types2, parenthesize) {
          var node = createBaseNode(kind);
          node.types = factory.createNodeArray(parenthesize(types2));
          node.transformFlags = 1;
          return node;
        }
        function updateUnionOrIntersectionTypeNode(node, types2, parenthesize) {
          return node.types !== types2 ? update(createUnionOrIntersectionTypeNode(node.kind, types2, parenthesize), node) : node;
        }
        function createUnionTypeNode(types2) {
          return createUnionOrIntersectionTypeNode(187, types2, parenthesizerRules().parenthesizeConstituentTypesOfUnionType);
        }
        function updateUnionTypeNode(node, types2) {
          return updateUnionOrIntersectionTypeNode(node, types2, parenthesizerRules().parenthesizeConstituentTypesOfUnionType);
        }
        function createIntersectionTypeNode(types2) {
          return createUnionOrIntersectionTypeNode(188, types2, parenthesizerRules().parenthesizeConstituentTypesOfIntersectionType);
        }
        function updateIntersectionTypeNode(node, types2) {
          return updateUnionOrIntersectionTypeNode(node, types2, parenthesizerRules().parenthesizeConstituentTypesOfIntersectionType);
        }
        function createConditionalTypeNode(checkType, extendsType, trueType, falseType) {
          var node = createBaseNode(189);
          node.checkType = parenthesizerRules().parenthesizeCheckTypeOfConditionalType(checkType);
          node.extendsType = parenthesizerRules().parenthesizeExtendsTypeOfConditionalType(extendsType);
          node.trueType = trueType;
          node.falseType = falseType;
          node.transformFlags = 1;
          return node;
        }
        function updateConditionalTypeNode(node, checkType, extendsType, trueType, falseType) {
          return node.checkType !== checkType || node.extendsType !== extendsType || node.trueType !== trueType || node.falseType !== falseType ? update(createConditionalTypeNode(checkType, extendsType, trueType, falseType), node) : node;
        }
        function createInferTypeNode(typeParameter) {
          var node = createBaseNode(190);
          node.typeParameter = typeParameter;
          node.transformFlags = 1;
          return node;
        }
        function updateInferTypeNode(node, typeParameter) {
          return node.typeParameter !== typeParameter ? update(createInferTypeNode(typeParameter), node) : node;
        }
        function createTemplateLiteralType(head, templateSpans) {
          var node = createBaseNode(198);
          node.head = head;
          node.templateSpans = createNodeArray(templateSpans);
          node.transformFlags = 1;
          return node;
        }
        function updateTemplateLiteralType(node, head, templateSpans) {
          return node.head !== head || node.templateSpans !== templateSpans ? update(createTemplateLiteralType(head, templateSpans), node) : node;
        }
        function createImportTypeNode(argument, qualifierOrAssertions, typeArgumentsOrQualifier, isTypeOfOrTypeArguments, isTypeOf) {
          var assertion = qualifierOrAssertions && qualifierOrAssertions.kind === 295 ? qualifierOrAssertions : void 0;
          var qualifier = qualifierOrAssertions && ts3.isEntityName(qualifierOrAssertions) ? qualifierOrAssertions : typeArgumentsOrQualifier && !ts3.isArray(typeArgumentsOrQualifier) ? typeArgumentsOrQualifier : void 0;
          var typeArguments = ts3.isArray(typeArgumentsOrQualifier) ? typeArgumentsOrQualifier : ts3.isArray(isTypeOfOrTypeArguments) ? isTypeOfOrTypeArguments : void 0;
          isTypeOf = typeof isTypeOfOrTypeArguments === "boolean" ? isTypeOfOrTypeArguments : typeof isTypeOf === "boolean" ? isTypeOf : false;
          var node = createBaseNode(200);
          node.argument = argument;
          node.assertions = assertion;
          node.qualifier = qualifier;
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
          node.isTypeOf = isTypeOf;
          node.transformFlags = 1;
          return node;
        }
        function updateImportTypeNode(node, argument, qualifierOrAssertions, typeArgumentsOrQualifier, isTypeOfOrTypeArguments, isTypeOf) {
          var assertion = qualifierOrAssertions && qualifierOrAssertions.kind === 295 ? qualifierOrAssertions : void 0;
          var qualifier = qualifierOrAssertions && ts3.isEntityName(qualifierOrAssertions) ? qualifierOrAssertions : typeArgumentsOrQualifier && !ts3.isArray(typeArgumentsOrQualifier) ? typeArgumentsOrQualifier : void 0;
          var typeArguments = ts3.isArray(typeArgumentsOrQualifier) ? typeArgumentsOrQualifier : ts3.isArray(isTypeOfOrTypeArguments) ? isTypeOfOrTypeArguments : void 0;
          isTypeOf = typeof isTypeOfOrTypeArguments === "boolean" ? isTypeOfOrTypeArguments : typeof isTypeOf === "boolean" ? isTypeOf : node.isTypeOf;
          return node.argument !== argument || node.assertions !== assertion || node.qualifier !== qualifier || node.typeArguments !== typeArguments || node.isTypeOf !== isTypeOf ? update(createImportTypeNode(argument, assertion, qualifier, typeArguments, isTypeOf), node) : node;
        }
        function createParenthesizedType(type2) {
          var node = createBaseNode(191);
          node.type = type2;
          node.transformFlags = 1;
          return node;
        }
        function updateParenthesizedType(node, type2) {
          return node.type !== type2 ? update(createParenthesizedType(type2), node) : node;
        }
        function createThisTypeNode() {
          var node = createBaseNode(192);
          node.transformFlags = 1;
          return node;
        }
        function createTypeOperatorNode(operator, type2) {
          var node = createBaseNode(193);
          node.operator = operator;
          node.type = operator === 145 ? parenthesizerRules().parenthesizeOperandOfReadonlyTypeOperator(type2) : parenthesizerRules().parenthesizeOperandOfTypeOperator(type2);
          node.transformFlags = 1;
          return node;
        }
        function updateTypeOperatorNode(node, type2) {
          return node.type !== type2 ? update(createTypeOperatorNode(node.operator, type2), node) : node;
        }
        function createIndexedAccessTypeNode(objectType, indexType) {
          var node = createBaseNode(194);
          node.objectType = parenthesizerRules().parenthesizeNonArrayTypeOfPostfixType(objectType);
          node.indexType = indexType;
          node.transformFlags = 1;
          return node;
        }
        function updateIndexedAccessTypeNode(node, objectType, indexType) {
          return node.objectType !== objectType || node.indexType !== indexType ? update(createIndexedAccessTypeNode(objectType, indexType), node) : node;
        }
        function createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type2, members) {
          var node = createBaseNode(195);
          node.readonlyToken = readonlyToken;
          node.typeParameter = typeParameter;
          node.nameType = nameType;
          node.questionToken = questionToken;
          node.type = type2;
          node.members = members && createNodeArray(members);
          node.transformFlags = 1;
          return node;
        }
        function updateMappedTypeNode(node, readonlyToken, typeParameter, nameType, questionToken, type2, members) {
          return node.readonlyToken !== readonlyToken || node.typeParameter !== typeParameter || node.nameType !== nameType || node.questionToken !== questionToken || node.type !== type2 || node.members !== members ? update(createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type2, members), node) : node;
        }
        function createLiteralTypeNode(literal) {
          var node = createBaseNode(196);
          node.literal = literal;
          node.transformFlags = 1;
          return node;
        }
        function updateLiteralTypeNode(node, literal) {
          return node.literal !== literal ? update(createLiteralTypeNode(literal), node) : node;
        }
        function createObjectBindingPattern(elements) {
          var node = createBaseNode(201);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements) | 1024 | 262144;
          if (node.transformFlags & 16384) {
            node.transformFlags |= 128 | 32768;
          }
          return node;
        }
        function updateObjectBindingPattern(node, elements) {
          return node.elements !== elements ? update(createObjectBindingPattern(elements), node) : node;
        }
        function createArrayBindingPattern(elements) {
          var node = createBaseNode(202);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements) | 1024 | 262144;
          return node;
        }
        function updateArrayBindingPattern(node, elements) {
          return node.elements !== elements ? update(createArrayBindingPattern(elements), node) : node;
        }
        function createBindingElement(dotDotDotToken, propertyName, name, initializer) {
          var node = createBaseBindingLikeDeclaration(203, void 0, void 0, name, initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer));
          node.propertyName = asName(propertyName);
          node.dotDotDotToken = dotDotDotToken;
          node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | 1024;
          if (node.propertyName) {
            node.transformFlags |= ts3.isIdentifier(node.propertyName) ? propagateIdentifierNameFlags(node.propertyName) : propagateChildFlags(node.propertyName);
          }
          if (dotDotDotToken)
            node.transformFlags |= 16384;
          return node;
        }
        function updateBindingElement(node, dotDotDotToken, propertyName, name, initializer) {
          return node.propertyName !== propertyName || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.initializer !== initializer ? update(createBindingElement(dotDotDotToken, propertyName, name, initializer), node) : node;
        }
        function createBaseExpression(kind) {
          var node = createBaseNode(kind);
          return node;
        }
        function createArrayLiteralExpression(elements, multiLine) {
          var node = createBaseExpression(204);
          var lastElement = elements && ts3.lastOrUndefined(elements);
          var elementsArray = createNodeArray(elements, lastElement && ts3.isOmittedExpression(lastElement) ? true : void 0);
          node.elements = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(elementsArray);
          node.multiLine = multiLine;
          node.transformFlags |= propagateChildrenFlags(node.elements);
          return node;
        }
        function updateArrayLiteralExpression(node, elements) {
          return node.elements !== elements ? update(createArrayLiteralExpression(elements, node.multiLine), node) : node;
        }
        function createObjectLiteralExpression(properties, multiLine) {
          var node = createBaseExpression(205);
          node.properties = createNodeArray(properties);
          node.multiLine = multiLine;
          node.transformFlags |= propagateChildrenFlags(node.properties);
          return node;
        }
        function updateObjectLiteralExpression(node, properties) {
          return node.properties !== properties ? update(createObjectLiteralExpression(properties, node.multiLine), node) : node;
        }
        function createPropertyAccessExpression(expression, name) {
          var node = createBaseExpression(206);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.name = asName(name);
          node.transformFlags = propagateChildFlags(node.expression) | (ts3.isIdentifier(node.name) ? propagateIdentifierNameFlags(node.name) : propagateChildFlags(node.name));
          if (ts3.isSuperKeyword(expression)) {
            node.transformFlags |= 256 | 128;
          }
          return node;
        }
        function updatePropertyAccessExpression(node, expression, name) {
          if (ts3.isPropertyAccessChain(node)) {
            return updatePropertyAccessChain(node, expression, node.questionDotToken, ts3.cast(name, ts3.isIdentifier));
          }
          return node.expression !== expression || node.name !== name ? update(createPropertyAccessExpression(expression, name), node) : node;
        }
        function createPropertyAccessChain(expression, questionDotToken, name) {
          var node = createBaseExpression(206);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.questionDotToken = questionDotToken;
          node.name = asName(name);
          node.transformFlags |= 32 | propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | (ts3.isIdentifier(node.name) ? propagateIdentifierNameFlags(node.name) : propagateChildFlags(node.name));
          return node;
        }
        function updatePropertyAccessChain(node, expression, questionDotToken, name) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead.");
          return node.expression !== expression || node.questionDotToken !== questionDotToken || node.name !== name ? update(createPropertyAccessChain(expression, questionDotToken, name), node) : node;
        }
        function createElementAccessExpression(expression, index) {
          var node = createBaseExpression(207);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.argumentExpression = asExpression(index);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.argumentExpression);
          if (ts3.isSuperKeyword(expression)) {
            node.transformFlags |= 256 | 128;
          }
          return node;
        }
        function updateElementAccessExpression(node, expression, argumentExpression) {
          if (ts3.isElementAccessChain(node)) {
            return updateElementAccessChain(node, expression, node.questionDotToken, argumentExpression);
          }
          return node.expression !== expression || node.argumentExpression !== argumentExpression ? update(createElementAccessExpression(expression, argumentExpression), node) : node;
        }
        function createElementAccessChain(expression, questionDotToken, index) {
          var node = createBaseExpression(207);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.questionDotToken = questionDotToken;
          node.argumentExpression = asExpression(index);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | propagateChildFlags(node.argumentExpression) | 32;
          return node;
        }
        function updateElementAccessChain(node, expression, questionDotToken, argumentExpression) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead.");
          return node.expression !== expression || node.questionDotToken !== questionDotToken || node.argumentExpression !== argumentExpression ? update(createElementAccessChain(expression, questionDotToken, argumentExpression), node) : node;
        }
        function createCallExpression(expression, typeArguments, argumentsArray) {
          var node = createBaseExpression(208);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.typeArguments = asNodeArray(typeArguments);
          node.arguments = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(argumentsArray));
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments);
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          if (ts3.isImportKeyword(node.expression)) {
            node.transformFlags |= 4194304;
          } else if (ts3.isSuperProperty(node.expression)) {
            node.transformFlags |= 8192;
          }
          return node;
        }
        function updateCallExpression(node, expression, typeArguments, argumentsArray) {
          if (ts3.isCallChain(node)) {
            return updateCallChain(node, expression, node.questionDotToken, typeArguments, argumentsArray);
          }
          return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createCallExpression(expression, typeArguments, argumentsArray), node) : node;
        }
        function createCallChain(expression, questionDotToken, typeArguments, argumentsArray) {
          var node = createBaseExpression(208);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.questionDotToken = questionDotToken;
          node.typeArguments = asNodeArray(typeArguments);
          node.arguments = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(argumentsArray));
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments) | 32;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          if (ts3.isSuperProperty(node.expression)) {
            node.transformFlags |= 8192;
          }
          return node;
        }
        function updateCallChain(node, expression, questionDotToken, typeArguments, argumentsArray) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a CallExpression using updateCallChain. Use updateCall instead.");
          return node.expression !== expression || node.questionDotToken !== questionDotToken || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createCallChain(expression, questionDotToken, typeArguments, argumentsArray), node) : node;
        }
        function createNewExpression(expression, typeArguments, argumentsArray) {
          var node = createBaseExpression(209);
          node.expression = parenthesizerRules().parenthesizeExpressionOfNew(expression);
          node.typeArguments = asNodeArray(typeArguments);
          node.arguments = argumentsArray ? parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(argumentsArray) : void 0;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments) | 32;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateNewExpression(node, expression, typeArguments, argumentsArray) {
          return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createNewExpression(expression, typeArguments, argumentsArray), node) : node;
        }
        function createTaggedTemplateExpression(tag, typeArguments, template) {
          var node = createBaseExpression(210);
          node.tag = parenthesizerRules().parenthesizeLeftSideOfAccess(tag);
          node.typeArguments = asNodeArray(typeArguments);
          node.template = template;
          node.transformFlags |= propagateChildFlags(node.tag) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.template) | 1024;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          if (ts3.hasInvalidEscape(node.template)) {
            node.transformFlags |= 128;
          }
          return node;
        }
        function updateTaggedTemplateExpression(node, tag, typeArguments, template) {
          return node.tag !== tag || node.typeArguments !== typeArguments || node.template !== template ? update(createTaggedTemplateExpression(tag, typeArguments, template), node) : node;
        }
        function createTypeAssertion(type2, expression) {
          var node = createBaseExpression(211);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.type = type2;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1;
          return node;
        }
        function updateTypeAssertion(node, type2, expression) {
          return node.type !== type2 || node.expression !== expression ? update(createTypeAssertion(type2, expression), node) : node;
        }
        function createParenthesizedExpression(expression) {
          var node = createBaseExpression(212);
          node.expression = expression;
          node.transformFlags = propagateChildFlags(node.expression);
          return node;
        }
        function updateParenthesizedExpression(node, expression) {
          return node.expression !== expression ? update(createParenthesizedExpression(expression), node) : node;
        }
        function createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type2, body) {
          var node = createBaseFunctionLikeDeclaration(213, void 0, modifiers, name, typeParameters, parameters, type2, body);
          node.asteriskToken = asteriskToken;
          node.transformFlags |= propagateChildFlags(node.asteriskToken);
          if (node.typeParameters) {
            node.transformFlags |= 1;
          }
          if (ts3.modifiersToFlags(node.modifiers) & 256) {
            if (node.asteriskToken) {
              node.transformFlags |= 128;
            } else {
              node.transformFlags |= 256;
            }
          } else if (node.asteriskToken) {
            node.transformFlags |= 2048;
          }
          return node;
        }
        function updateFunctionExpression(node, modifiers, asteriskToken, name, typeParameters, parameters, type2, body) {
          return node.name !== name || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 || node.body !== body ? updateBaseFunctionLikeDeclaration(createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type2, body), node) : node;
        }
        function createArrowFunction(modifiers, typeParameters, parameters, type2, equalsGreaterThanToken, body) {
          var node = createBaseFunctionLikeDeclaration(214, void 0, modifiers, void 0, typeParameters, parameters, type2, parenthesizerRules().parenthesizeConciseBodyOfArrowFunction(body));
          node.equalsGreaterThanToken = equalsGreaterThanToken !== null && equalsGreaterThanToken !== void 0 ? equalsGreaterThanToken : createToken(38);
          node.transformFlags |= propagateChildFlags(node.equalsGreaterThanToken) | 1024;
          if (ts3.modifiersToFlags(node.modifiers) & 256) {
            node.transformFlags |= 256 | 8192;
          }
          return node;
        }
        function updateArrowFunction(node, modifiers, typeParameters, parameters, type2, equalsGreaterThanToken, body) {
          return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 || node.equalsGreaterThanToken !== equalsGreaterThanToken || node.body !== body ? updateBaseFunctionLikeDeclaration(createArrowFunction(modifiers, typeParameters, parameters, type2, equalsGreaterThanToken, body), node) : node;
        }
        function createDeleteExpression(expression) {
          var node = createBaseExpression(215);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateDeleteExpression(node, expression) {
          return node.expression !== expression ? update(createDeleteExpression(expression), node) : node;
        }
        function createTypeOfExpression(expression) {
          var node = createBaseExpression(216);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateTypeOfExpression(node, expression) {
          return node.expression !== expression ? update(createTypeOfExpression(expression), node) : node;
        }
        function createVoidExpression(expression) {
          var node = createBaseExpression(217);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateVoidExpression(node, expression) {
          return node.expression !== expression ? update(createVoidExpression(expression), node) : node;
        }
        function createAwaitExpression(expression) {
          var node = createBaseExpression(218);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 256 | 128 | 1048576;
          return node;
        }
        function updateAwaitExpression(node, expression) {
          return node.expression !== expression ? update(createAwaitExpression(expression), node) : node;
        }
        function createPrefixUnaryExpression(operator, operand) {
          var node = createBaseExpression(219);
          node.operator = operator;
          node.operand = parenthesizerRules().parenthesizeOperandOfPrefixUnary(operand);
          node.transformFlags |= propagateChildFlags(node.operand);
          if ((operator === 45 || operator === 46) && ts3.isIdentifier(node.operand) && !ts3.isGeneratedIdentifier(node.operand) && !ts3.isLocalName(node.operand)) {
            node.transformFlags |= 67108864;
          }
          return node;
        }
        function updatePrefixUnaryExpression(node, operand) {
          return node.operand !== operand ? update(createPrefixUnaryExpression(node.operator, operand), node) : node;
        }
        function createPostfixUnaryExpression(operand, operator) {
          var node = createBaseExpression(220);
          node.operator = operator;
          node.operand = parenthesizerRules().parenthesizeOperandOfPostfixUnary(operand);
          node.transformFlags |= propagateChildFlags(node.operand);
          if (ts3.isIdentifier(node.operand) && !ts3.isGeneratedIdentifier(node.operand) && !ts3.isLocalName(node.operand)) {
            node.transformFlags |= 67108864;
          }
          return node;
        }
        function updatePostfixUnaryExpression(node, operand) {
          return node.operand !== operand ? update(createPostfixUnaryExpression(operand, node.operator), node) : node;
        }
        function createBinaryExpression(left, operator, right) {
          var node = createBaseExpression(221);
          var operatorToken = asToken(operator);
          var operatorKind = operatorToken.kind;
          node.left = parenthesizerRules().parenthesizeLeftSideOfBinary(operatorKind, left);
          node.operatorToken = operatorToken;
          node.right = parenthesizerRules().parenthesizeRightSideOfBinary(operatorKind, node.left, right);
          node.transformFlags |= propagateChildFlags(node.left) | propagateChildFlags(node.operatorToken) | propagateChildFlags(node.right);
          if (operatorKind === 60) {
            node.transformFlags |= 32;
          } else if (operatorKind === 63) {
            if (ts3.isObjectLiteralExpression(node.left)) {
              node.transformFlags |= 1024 | 128 | 4096 | propagateAssignmentPatternFlags(node.left);
            } else if (ts3.isArrayLiteralExpression(node.left)) {
              node.transformFlags |= 1024 | 4096 | propagateAssignmentPatternFlags(node.left);
            }
          } else if (operatorKind === 42 || operatorKind === 67) {
            node.transformFlags |= 512;
          } else if (ts3.isLogicalOrCoalescingAssignmentOperator(operatorKind)) {
            node.transformFlags |= 16;
          }
          return node;
        }
        function propagateAssignmentPatternFlags(node) {
          if (node.transformFlags & 32768)
            return 32768;
          if (node.transformFlags & 128) {
            for (var _i = 0, _a = ts3.getElementsOfBindingOrAssignmentPattern(node); _i < _a.length; _i++) {
              var element = _a[_i];
              var target = ts3.getTargetOfBindingOrAssignmentElement(element);
              if (target && ts3.isAssignmentPattern(target)) {
                if (target.transformFlags & 32768) {
                  return 32768;
                }
                if (target.transformFlags & 128) {
                  var flags_1 = propagateAssignmentPatternFlags(target);
                  if (flags_1)
                    return flags_1;
                }
              }
            }
          }
          return 0;
        }
        function updateBinaryExpression(node, left, operator, right) {
          return node.left !== left || node.operatorToken !== operator || node.right !== right ? update(createBinaryExpression(left, operator, right), node) : node;
        }
        function createConditionalExpression(condition, questionToken, whenTrue, colonToken, whenFalse) {
          var node = createBaseExpression(222);
          node.condition = parenthesizerRules().parenthesizeConditionOfConditionalExpression(condition);
          node.questionToken = questionToken !== null && questionToken !== void 0 ? questionToken : createToken(57);
          node.whenTrue = parenthesizerRules().parenthesizeBranchOfConditionalExpression(whenTrue);
          node.colonToken = colonToken !== null && colonToken !== void 0 ? colonToken : createToken(58);
          node.whenFalse = parenthesizerRules().parenthesizeBranchOfConditionalExpression(whenFalse);
          node.transformFlags |= propagateChildFlags(node.condition) | propagateChildFlags(node.questionToken) | propagateChildFlags(node.whenTrue) | propagateChildFlags(node.colonToken) | propagateChildFlags(node.whenFalse);
          return node;
        }
        function updateConditionalExpression(node, condition, questionToken, whenTrue, colonToken, whenFalse) {
          return node.condition !== condition || node.questionToken !== questionToken || node.whenTrue !== whenTrue || node.colonToken !== colonToken || node.whenFalse !== whenFalse ? update(createConditionalExpression(condition, questionToken, whenTrue, colonToken, whenFalse), node) : node;
        }
        function createTemplateExpression(head, templateSpans) {
          var node = createBaseExpression(223);
          node.head = head;
          node.templateSpans = createNodeArray(templateSpans);
          node.transformFlags |= propagateChildFlags(node.head) | propagateChildrenFlags(node.templateSpans) | 1024;
          return node;
        }
        function updateTemplateExpression(node, head, templateSpans) {
          return node.head !== head || node.templateSpans !== templateSpans ? update(createTemplateExpression(head, templateSpans), node) : node;
        }
        function createTemplateLiteralLikeNodeChecked(kind, text, rawText, templateFlags) {
          if (templateFlags === void 0) {
            templateFlags = 0;
          }
          ts3.Debug.assert(!(templateFlags & ~2048), "Unsupported template flags.");
          var cooked = void 0;
          if (rawText !== void 0 && rawText !== text) {
            cooked = getCookedText(kind, rawText);
            if (typeof cooked === "object") {
              return ts3.Debug.fail("Invalid raw text");
            }
          }
          if (text === void 0) {
            if (cooked === void 0) {
              return ts3.Debug.fail("Arguments 'text' and 'rawText' may not both be undefined.");
            }
            text = cooked;
          } else if (cooked !== void 0) {
            ts3.Debug.assert(text === cooked, "Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");
          }
          return createTemplateLiteralLikeNode(kind, text, rawText, templateFlags);
        }
        function createTemplateLiteralLikeNode(kind, text, rawText, templateFlags) {
          var node = createBaseToken(kind);
          node.text = text;
          node.rawText = rawText;
          node.templateFlags = templateFlags & 2048;
          node.transformFlags |= 1024;
          if (node.templateFlags) {
            node.transformFlags |= 128;
          }
          return node;
        }
        function createTemplateHead(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(15, text, rawText, templateFlags);
        }
        function createTemplateMiddle(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(16, text, rawText, templateFlags);
        }
        function createTemplateTail(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(17, text, rawText, templateFlags);
        }
        function createNoSubstitutionTemplateLiteral(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(14, text, rawText, templateFlags);
        }
        function createYieldExpression(asteriskToken, expression) {
          ts3.Debug.assert(!asteriskToken || !!expression, "A `YieldExpression` with an asteriskToken must have an expression.");
          var node = createBaseExpression(224);
          node.expression = expression && parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.asteriskToken = asteriskToken;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.asteriskToken) | 1024 | 128 | 524288;
          return node;
        }
        function updateYieldExpression(node, asteriskToken, expression) {
          return node.expression !== expression || node.asteriskToken !== asteriskToken ? update(createYieldExpression(asteriskToken, expression), node) : node;
        }
        function createSpreadElement(expression) {
          var node = createBaseExpression(225);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1024 | 16384;
          return node;
        }
        function updateSpreadElement(node, expression) {
          return node.expression !== expression ? update(createSpreadElement(expression), node) : node;
        }
        function createClassExpression(decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseClassLikeDeclaration(226, decorators, modifiers, name, typeParameters, heritageClauses, members);
          node.transformFlags |= 1024;
          return node;
        }
        function updateClassExpression(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createClassExpression(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
        }
        function createOmittedExpression() {
          return createBaseExpression(227);
        }
        function createExpressionWithTypeArguments(expression, typeArguments) {
          var node = createBaseNode(228);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | 1024;
          return node;
        }
        function updateExpressionWithTypeArguments(node, expression, typeArguments) {
          return node.expression !== expression || node.typeArguments !== typeArguments ? update(createExpressionWithTypeArguments(expression, typeArguments), node) : node;
        }
        function createAsExpression(expression, type2) {
          var node = createBaseExpression(229);
          node.expression = expression;
          node.type = type2;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1;
          return node;
        }
        function updateAsExpression(node, expression, type2) {
          return node.expression !== expression || node.type !== type2 ? update(createAsExpression(expression, type2), node) : node;
        }
        function createNonNullExpression(expression) {
          var node = createBaseExpression(230);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1;
          return node;
        }
        function updateNonNullExpression(node, expression) {
          if (ts3.isNonNullChain(node)) {
            return updateNonNullChain(node, expression);
          }
          return node.expression !== expression ? update(createNonNullExpression(expression), node) : node;
        }
        function createNonNullChain(expression) {
          var node = createBaseExpression(230);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1;
          return node;
        }
        function updateNonNullChain(node, expression) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead.");
          return node.expression !== expression ? update(createNonNullChain(expression), node) : node;
        }
        function createMetaProperty(keywordToken, name) {
          var node = createBaseExpression(231);
          node.keywordToken = keywordToken;
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.name);
          switch (keywordToken) {
            case 103:
              node.transformFlags |= 1024;
              break;
            case 100:
              node.transformFlags |= 4;
              break;
            default:
              return ts3.Debug.assertNever(keywordToken);
          }
          return node;
        }
        function updateMetaProperty(node, name) {
          return node.name !== name ? update(createMetaProperty(node.keywordToken, name), node) : node;
        }
        function createTemplateSpan(expression, literal) {
          var node = createBaseNode(233);
          node.expression = expression;
          node.literal = literal;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.literal) | 1024;
          return node;
        }
        function updateTemplateSpan(node, expression, literal) {
          return node.expression !== expression || node.literal !== literal ? update(createTemplateSpan(expression, literal), node) : node;
        }
        function createSemicolonClassElement() {
          var node = createBaseNode(234);
          node.transformFlags |= 1024;
          return node;
        }
        function createBlock(statements, multiLine) {
          var node = createBaseNode(235);
          node.statements = createNodeArray(statements);
          node.multiLine = multiLine;
          node.transformFlags |= propagateChildrenFlags(node.statements);
          return node;
        }
        function updateBlock(node, statements) {
          return node.statements !== statements ? update(createBlock(statements, node.multiLine), node) : node;
        }
        function createVariableStatement(modifiers, declarationList) {
          var node = createBaseDeclaration(237, void 0, modifiers);
          node.declarationList = ts3.isArray(declarationList) ? createVariableDeclarationList(declarationList) : declarationList;
          node.transformFlags |= propagateChildFlags(node.declarationList);
          if (ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          }
          return node;
        }
        function updateVariableStatement(node, modifiers, declarationList) {
          return node.modifiers !== modifiers || node.declarationList !== declarationList ? update(createVariableStatement(modifiers, declarationList), node) : node;
        }
        function createEmptyStatement() {
          return createBaseNode(236);
        }
        function createExpressionStatement(expression) {
          var node = createBaseNode(238);
          node.expression = parenthesizerRules().parenthesizeExpressionOfExpressionStatement(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateExpressionStatement(node, expression) {
          return node.expression !== expression ? update(createExpressionStatement(expression), node) : node;
        }
        function createIfStatement(expression, thenStatement, elseStatement) {
          var node = createBaseNode(239);
          node.expression = expression;
          node.thenStatement = asEmbeddedStatement(thenStatement);
          node.elseStatement = asEmbeddedStatement(elseStatement);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.thenStatement) | propagateChildFlags(node.elseStatement);
          return node;
        }
        function updateIfStatement(node, expression, thenStatement, elseStatement) {
          return node.expression !== expression || node.thenStatement !== thenStatement || node.elseStatement !== elseStatement ? update(createIfStatement(expression, thenStatement, elseStatement), node) : node;
        }
        function createDoStatement(statement, expression) {
          var node = createBaseNode(240);
          node.statement = asEmbeddedStatement(statement);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.statement) | propagateChildFlags(node.expression);
          return node;
        }
        function updateDoStatement(node, statement, expression) {
          return node.statement !== statement || node.expression !== expression ? update(createDoStatement(statement, expression), node) : node;
        }
        function createWhileStatement(expression, statement) {
          var node = createBaseNode(241);
          node.expression = expression;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
          return node;
        }
        function updateWhileStatement(node, expression, statement) {
          return node.expression !== expression || node.statement !== statement ? update(createWhileStatement(expression, statement), node) : node;
        }
        function createForStatement(initializer, condition, incrementor, statement) {
          var node = createBaseNode(242);
          node.initializer = initializer;
          node.condition = condition;
          node.incrementor = incrementor;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.initializer) | propagateChildFlags(node.condition) | propagateChildFlags(node.incrementor) | propagateChildFlags(node.statement);
          return node;
        }
        function updateForStatement(node, initializer, condition, incrementor, statement) {
          return node.initializer !== initializer || node.condition !== condition || node.incrementor !== incrementor || node.statement !== statement ? update(createForStatement(initializer, condition, incrementor, statement), node) : node;
        }
        function createForInStatement(initializer, expression, statement) {
          var node = createBaseNode(243);
          node.initializer = initializer;
          node.expression = expression;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.initializer) | propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
          return node;
        }
        function updateForInStatement(node, initializer, expression, statement) {
          return node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? update(createForInStatement(initializer, expression, statement), node) : node;
        }
        function createForOfStatement(awaitModifier, initializer, expression, statement) {
          var node = createBaseNode(244);
          node.awaitModifier = awaitModifier;
          node.initializer = initializer;
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.awaitModifier) | propagateChildFlags(node.initializer) | propagateChildFlags(node.expression) | propagateChildFlags(node.statement) | 1024;
          if (awaitModifier)
            node.transformFlags |= 128;
          return node;
        }
        function updateForOfStatement(node, awaitModifier, initializer, expression, statement) {
          return node.awaitModifier !== awaitModifier || node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? update(createForOfStatement(awaitModifier, initializer, expression, statement), node) : node;
        }
        function createContinueStatement(label) {
          var node = createBaseNode(245);
          node.label = asName(label);
          node.transformFlags |= propagateChildFlags(node.label) | 2097152;
          return node;
        }
        function updateContinueStatement(node, label) {
          return node.label !== label ? update(createContinueStatement(label), node) : node;
        }
        function createBreakStatement(label) {
          var node = createBaseNode(246);
          node.label = asName(label);
          node.transformFlags |= propagateChildFlags(node.label) | 2097152;
          return node;
        }
        function updateBreakStatement(node, label) {
          return node.label !== label ? update(createBreakStatement(label), node) : node;
        }
        function createReturnStatement(expression) {
          var node = createBaseNode(247);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression) | 128 | 2097152;
          return node;
        }
        function updateReturnStatement(node, expression) {
          return node.expression !== expression ? update(createReturnStatement(expression), node) : node;
        }
        function createWithStatement(expression, statement) {
          var node = createBaseNode(248);
          node.expression = expression;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
          return node;
        }
        function updateWithStatement(node, expression, statement) {
          return node.expression !== expression || node.statement !== statement ? update(createWithStatement(expression, statement), node) : node;
        }
        function createSwitchStatement(expression, caseBlock) {
          var node = createBaseNode(249);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.caseBlock = caseBlock;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.caseBlock);
          return node;
        }
        function updateSwitchStatement(node, expression, caseBlock) {
          return node.expression !== expression || node.caseBlock !== caseBlock ? update(createSwitchStatement(expression, caseBlock), node) : node;
        }
        function createLabeledStatement(label, statement) {
          var node = createBaseNode(250);
          node.label = asName(label);
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.label) | propagateChildFlags(node.statement);
          return node;
        }
        function updateLabeledStatement(node, label, statement) {
          return node.label !== label || node.statement !== statement ? update(createLabeledStatement(label, statement), node) : node;
        }
        function createThrowStatement(expression) {
          var node = createBaseNode(251);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateThrowStatement(node, expression) {
          return node.expression !== expression ? update(createThrowStatement(expression), node) : node;
        }
        function createTryStatement(tryBlock, catchClause, finallyBlock) {
          var node = createBaseNode(252);
          node.tryBlock = tryBlock;
          node.catchClause = catchClause;
          node.finallyBlock = finallyBlock;
          node.transformFlags |= propagateChildFlags(node.tryBlock) | propagateChildFlags(node.catchClause) | propagateChildFlags(node.finallyBlock);
          return node;
        }
        function updateTryStatement(node, tryBlock, catchClause, finallyBlock) {
          return node.tryBlock !== tryBlock || node.catchClause !== catchClause || node.finallyBlock !== finallyBlock ? update(createTryStatement(tryBlock, catchClause, finallyBlock), node) : node;
        }
        function createDebuggerStatement() {
          return createBaseNode(253);
        }
        function createVariableDeclaration(name, exclamationToken, type2, initializer) {
          var node = createBaseVariableLikeDeclaration(254, void 0, void 0, name, type2, initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer));
          node.exclamationToken = exclamationToken;
          node.transformFlags |= propagateChildFlags(node.exclamationToken);
          if (exclamationToken) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateVariableDeclaration(node, name, exclamationToken, type2, initializer) {
          return node.name !== name || node.type !== type2 || node.exclamationToken !== exclamationToken || node.initializer !== initializer ? update(createVariableDeclaration(name, exclamationToken, type2, initializer), node) : node;
        }
        function createVariableDeclarationList(declarations, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          var node = createBaseNode(255);
          node.flags |= flags2 & 3;
          node.declarations = createNodeArray(declarations);
          node.transformFlags |= propagateChildrenFlags(node.declarations) | 2097152;
          if (flags2 & 3) {
            node.transformFlags |= 1024 | 131072;
          }
          return node;
        }
        function updateVariableDeclarationList(node, declarations) {
          return node.declarations !== declarations ? update(createVariableDeclarationList(declarations, node.flags), node) : node;
        }
        function createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type2, body) {
          var node = createBaseFunctionLikeDeclaration(256, decorators, modifiers, name, typeParameters, parameters, type2, body);
          node.asteriskToken = asteriskToken;
          if (!node.body || ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= propagateChildFlags(node.asteriskToken) | 2097152;
            if (ts3.modifiersToFlags(node.modifiers) & 256) {
              if (node.asteriskToken) {
                node.transformFlags |= 128;
              } else {
                node.transformFlags |= 256;
              }
            } else if (node.asteriskToken) {
              node.transformFlags |= 2048;
            }
          }
          return node;
        }
        function updateFunctionDeclaration(node, decorators, modifiers, asteriskToken, name, typeParameters, parameters, type2, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 || node.body !== body ? updateBaseFunctionLikeDeclaration(createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type2, body), node) : node;
        }
        function createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseClassLikeDeclaration(257, decorators, modifiers, name, typeParameters, heritageClauses, members);
          if (ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= 1024;
            if (node.transformFlags & 4096) {
              node.transformFlags |= 1;
            }
          }
          return node;
        }
        function updateClassDeclaration(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
        }
        function createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseInterfaceOrClassLikeDeclaration(258, decorators, modifiers, name, typeParameters, heritageClauses);
          node.members = createNodeArray(members);
          node.transformFlags = 1;
          return node;
        }
        function updateInterfaceDeclaration(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
        }
        function createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type2) {
          var node = createBaseGenericNamedDeclaration(259, decorators, modifiers, name, typeParameters);
          node.type = type2;
          node.transformFlags = 1;
          return node;
        }
        function updateTypeAliasDeclaration(node, decorators, modifiers, name, typeParameters, type2) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.type !== type2 ? update(createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type2), node) : node;
        }
        function createEnumDeclaration(decorators, modifiers, name, members) {
          var node = createBaseNamedDeclaration(260, decorators, modifiers, name);
          node.members = createNodeArray(members);
          node.transformFlags |= propagateChildrenFlags(node.members) | 1;
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateEnumDeclaration(node, decorators, modifiers, name, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.members !== members ? update(createEnumDeclaration(decorators, modifiers, name, members), node) : node;
        }
        function createModuleDeclaration(decorators, modifiers, name, body, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          var node = createBaseDeclaration(261, decorators, modifiers);
          node.flags |= flags2 & (16 | 4 | 1024);
          node.name = name;
          node.body = body;
          if (ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.body) | 1;
          }
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateModuleDeclaration(node, decorators, modifiers, name, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.body !== body ? update(createModuleDeclaration(decorators, modifiers, name, body, node.flags), node) : node;
        }
        function createModuleBlock(statements) {
          var node = createBaseNode(262);
          node.statements = createNodeArray(statements);
          node.transformFlags |= propagateChildrenFlags(node.statements);
          return node;
        }
        function updateModuleBlock(node, statements) {
          return node.statements !== statements ? update(createModuleBlock(statements), node) : node;
        }
        function createCaseBlock(clauses) {
          var node = createBaseNode(263);
          node.clauses = createNodeArray(clauses);
          node.transformFlags |= propagateChildrenFlags(node.clauses);
          return node;
        }
        function updateCaseBlock(node, clauses) {
          return node.clauses !== clauses ? update(createCaseBlock(clauses), node) : node;
        }
        function createNamespaceExportDeclaration(name) {
          var node = createBaseNamedDeclaration(264, void 0, void 0, name);
          node.transformFlags = 1;
          return node;
        }
        function updateNamespaceExportDeclaration(node, name) {
          return node.name !== name ? update(createNamespaceExportDeclaration(name), node) : node;
        }
        function createImportEqualsDeclaration(decorators, modifiers, isTypeOnly, name, moduleReference) {
          var node = createBaseNamedDeclaration(265, decorators, modifiers, name);
          node.isTypeOnly = isTypeOnly;
          node.moduleReference = moduleReference;
          node.transformFlags |= propagateChildFlags(node.moduleReference);
          if (!ts3.isExternalModuleReference(node.moduleReference))
            node.transformFlags |= 1;
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportEqualsDeclaration(node, decorators, modifiers, isTypeOnly, name, moduleReference) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.name !== name || node.moduleReference !== moduleReference ? update(createImportEqualsDeclaration(decorators, modifiers, isTypeOnly, name, moduleReference), node) : node;
        }
        function createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier, assertClause) {
          var node = createBaseDeclaration(266, decorators, modifiers);
          node.importClause = importClause;
          node.moduleSpecifier = moduleSpecifier;
          node.assertClause = assertClause;
          node.transformFlags |= propagateChildFlags(node.importClause) | propagateChildFlags(node.moduleSpecifier);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportDeclaration(node, decorators, modifiers, importClause, moduleSpecifier, assertClause) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.importClause !== importClause || node.moduleSpecifier !== moduleSpecifier || node.assertClause !== assertClause ? update(createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier, assertClause), node) : node;
        }
        function createImportClause(isTypeOnly, name, namedBindings) {
          var node = createBaseNode(267);
          node.isTypeOnly = isTypeOnly;
          node.name = name;
          node.namedBindings = namedBindings;
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.namedBindings);
          if (isTypeOnly) {
            node.transformFlags |= 1;
          }
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportClause(node, isTypeOnly, name, namedBindings) {
          return node.isTypeOnly !== isTypeOnly || node.name !== name || node.namedBindings !== namedBindings ? update(createImportClause(isTypeOnly, name, namedBindings), node) : node;
        }
        function createAssertClause(elements, multiLine) {
          var node = createBaseNode(293);
          node.elements = createNodeArray(elements);
          node.multiLine = multiLine;
          node.transformFlags |= 4;
          return node;
        }
        function updateAssertClause(node, elements, multiLine) {
          return node.elements !== elements || node.multiLine !== multiLine ? update(createAssertClause(elements, multiLine), node) : node;
        }
        function createAssertEntry(name, value) {
          var node = createBaseNode(294);
          node.name = name;
          node.value = value;
          node.transformFlags |= 4;
          return node;
        }
        function updateAssertEntry(node, name, value) {
          return node.name !== name || node.value !== value ? update(createAssertEntry(name, value), node) : node;
        }
        function createImportTypeAssertionContainer(clause, multiLine) {
          var node = createBaseNode(295);
          node.assertClause = clause;
          node.multiLine = multiLine;
          return node;
        }
        function updateImportTypeAssertionContainer(node, clause, multiLine) {
          return node.assertClause !== clause || node.multiLine !== multiLine ? update(createImportTypeAssertionContainer(clause, multiLine), node) : node;
        }
        function createNamespaceImport(name) {
          var node = createBaseNode(268);
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.name);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamespaceImport(node, name) {
          return node.name !== name ? update(createNamespaceImport(name), node) : node;
        }
        function createNamespaceExport(name) {
          var node = createBaseNode(274);
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.name) | 4;
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamespaceExport(node, name) {
          return node.name !== name ? update(createNamespaceExport(name), node) : node;
        }
        function createNamedImports(elements) {
          var node = createBaseNode(269);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamedImports(node, elements) {
          return node.elements !== elements ? update(createNamedImports(elements), node) : node;
        }
        function createImportSpecifier(isTypeOnly, propertyName, name) {
          var node = createBaseNode(270);
          node.isTypeOnly = isTypeOnly;
          node.propertyName = propertyName;
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.propertyName) | propagateChildFlags(node.name);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportSpecifier(node, isTypeOnly, propertyName, name) {
          return node.isTypeOnly !== isTypeOnly || node.propertyName !== propertyName || node.name !== name ? update(createImportSpecifier(isTypeOnly, propertyName, name), node) : node;
        }
        function createExportAssignment(decorators, modifiers, isExportEquals, expression) {
          var node = createBaseDeclaration(271, decorators, modifiers);
          node.isExportEquals = isExportEquals;
          node.expression = isExportEquals ? parenthesizerRules().parenthesizeRightSideOfBinary(63, void 0, expression) : parenthesizerRules().parenthesizeExpressionOfExportDefault(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExportAssignment(node, decorators, modifiers, expression) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.expression !== expression ? update(createExportAssignment(decorators, modifiers, node.isExportEquals, expression), node) : node;
        }
        function createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier, assertClause) {
          var node = createBaseDeclaration(272, decorators, modifiers);
          node.isTypeOnly = isTypeOnly;
          node.exportClause = exportClause;
          node.moduleSpecifier = moduleSpecifier;
          node.assertClause = assertClause;
          node.transformFlags |= propagateChildFlags(node.exportClause) | propagateChildFlags(node.moduleSpecifier);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExportDeclaration(node, decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier, assertClause) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.exportClause !== exportClause || node.moduleSpecifier !== moduleSpecifier || node.assertClause !== assertClause ? update(createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier, assertClause), node) : node;
        }
        function createNamedExports(elements) {
          var node = createBaseNode(273);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamedExports(node, elements) {
          return node.elements !== elements ? update(createNamedExports(elements), node) : node;
        }
        function createExportSpecifier(isTypeOnly, propertyName, name) {
          var node = createBaseNode(275);
          node.isTypeOnly = isTypeOnly;
          node.propertyName = asName(propertyName);
          node.name = asName(name);
          node.transformFlags |= propagateChildFlags(node.propertyName) | propagateChildFlags(node.name);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExportSpecifier(node, isTypeOnly, propertyName, name) {
          return node.isTypeOnly !== isTypeOnly || node.propertyName !== propertyName || node.name !== name ? update(createExportSpecifier(isTypeOnly, propertyName, name), node) : node;
        }
        function createMissingDeclaration() {
          var node = createBaseDeclaration(276, void 0, void 0);
          return node;
        }
        function createExternalModuleReference(expression) {
          var node = createBaseNode(277);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExternalModuleReference(node, expression) {
          return node.expression !== expression ? update(createExternalModuleReference(expression), node) : node;
        }
        function createJSDocPrimaryTypeWorker(kind) {
          return createBaseNode(kind);
        }
        function createJSDocPrePostfixUnaryTypeWorker(kind, type2, postfix) {
          if (postfix === void 0) {
            postfix = false;
          }
          var node = createJSDocUnaryTypeWorker(kind, postfix ? type2 && parenthesizerRules().parenthesizeNonArrayTypeOfPostfixType(type2) : type2);
          node.postfix = postfix;
          return node;
        }
        function createJSDocUnaryTypeWorker(kind, type2) {
          var node = createBaseNode(kind);
          node.type = type2;
          return node;
        }
        function updateJSDocPrePostfixUnaryTypeWorker(kind, node, type2) {
          return node.type !== type2 ? update(createJSDocPrePostfixUnaryTypeWorker(kind, type2, node.postfix), node) : node;
        }
        function updateJSDocUnaryTypeWorker(kind, node, type2) {
          return node.type !== type2 ? update(createJSDocUnaryTypeWorker(kind, type2), node) : node;
        }
        function createJSDocFunctionType(parameters, type2) {
          var node = createBaseSignatureDeclaration(317, void 0, void 0, void 0, void 0, parameters, type2);
          return node;
        }
        function updateJSDocFunctionType(node, parameters, type2) {
          return node.parameters !== parameters || node.type !== type2 ? update(createJSDocFunctionType(parameters, type2), node) : node;
        }
        function createJSDocTypeLiteral(propertyTags, isArrayType) {
          if (isArrayType === void 0) {
            isArrayType = false;
          }
          var node = createBaseNode(322);
          node.jsDocPropertyTags = asNodeArray(propertyTags);
          node.isArrayType = isArrayType;
          return node;
        }
        function updateJSDocTypeLiteral(node, propertyTags, isArrayType) {
          return node.jsDocPropertyTags !== propertyTags || node.isArrayType !== isArrayType ? update(createJSDocTypeLiteral(propertyTags, isArrayType), node) : node;
        }
        function createJSDocTypeExpression(type2) {
          var node = createBaseNode(309);
          node.type = type2;
          return node;
        }
        function updateJSDocTypeExpression(node, type2) {
          return node.type !== type2 ? update(createJSDocTypeExpression(type2), node) : node;
        }
        function createJSDocSignature(typeParameters, parameters, type2) {
          var node = createBaseNode(323);
          node.typeParameters = asNodeArray(typeParameters);
          node.parameters = createNodeArray(parameters);
          node.type = type2;
          return node;
        }
        function updateJSDocSignature(node, typeParameters, parameters, type2) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type2 ? update(createJSDocSignature(typeParameters, parameters, type2), node) : node;
        }
        function getDefaultTagName(node) {
          var defaultTagName = getDefaultTagNameForKind(node.kind);
          return node.tagName.escapedText === ts3.escapeLeadingUnderscores(defaultTagName) ? node.tagName : createIdentifier(defaultTagName);
        }
        function createBaseJSDocTag(kind, tagName, comment) {
          var node = createBaseNode(kind);
          node.tagName = tagName;
          node.comment = comment;
          return node;
        }
        function createJSDocTemplateTag(tagName, constraint, typeParameters, comment) {
          var node = createBaseJSDocTag(344, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("template"), comment);
          node.constraint = constraint;
          node.typeParameters = createNodeArray(typeParameters);
          return node;
        }
        function updateJSDocTemplateTag(node, tagName, constraint, typeParameters, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.constraint !== constraint || node.typeParameters !== typeParameters || node.comment !== comment ? update(createJSDocTemplateTag(tagName, constraint, typeParameters, comment), node) : node;
        }
        function createJSDocTypedefTag(tagName, typeExpression, fullName, comment) {
          var node = createBaseJSDocTag(345, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("typedef"), comment);
          node.typeExpression = typeExpression;
          node.fullName = fullName;
          node.name = ts3.getJSDocTypeAliasName(fullName);
          return node;
        }
        function updateJSDocTypedefTag(node, tagName, typeExpression, fullName, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.typeExpression !== typeExpression || node.fullName !== fullName || node.comment !== comment ? update(createJSDocTypedefTag(tagName, typeExpression, fullName, comment), node) : node;
        }
        function createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          var node = createBaseJSDocTag(340, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("param"), comment);
          node.typeExpression = typeExpression;
          node.name = name;
          node.isNameFirst = !!isNameFirst;
          node.isBracketed = isBracketed;
          return node;
        }
        function updateJSDocParameterTag(node, tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.name !== name || node.isBracketed !== isBracketed || node.typeExpression !== typeExpression || node.isNameFirst !== isNameFirst || node.comment !== comment ? update(createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment), node) : node;
        }
        function createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          var node = createBaseJSDocTag(347, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("prop"), comment);
          node.typeExpression = typeExpression;
          node.name = name;
          node.isNameFirst = !!isNameFirst;
          node.isBracketed = isBracketed;
          return node;
        }
        function updateJSDocPropertyTag(node, tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.name !== name || node.isBracketed !== isBracketed || node.typeExpression !== typeExpression || node.isNameFirst !== isNameFirst || node.comment !== comment ? update(createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment), node) : node;
        }
        function createJSDocCallbackTag(tagName, typeExpression, fullName, comment) {
          var node = createBaseJSDocTag(338, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("callback"), comment);
          node.typeExpression = typeExpression;
          node.fullName = fullName;
          node.name = ts3.getJSDocTypeAliasName(fullName);
          return node;
        }
        function updateJSDocCallbackTag(node, tagName, typeExpression, fullName, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.typeExpression !== typeExpression || node.fullName !== fullName || node.comment !== comment ? update(createJSDocCallbackTag(tagName, typeExpression, fullName, comment), node) : node;
        }
        function createJSDocAugmentsTag(tagName, className, comment) {
          var node = createBaseJSDocTag(328, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("augments"), comment);
          node.class = className;
          return node;
        }
        function updateJSDocAugmentsTag(node, tagName, className, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.class !== className || node.comment !== comment ? update(createJSDocAugmentsTag(tagName, className, comment), node) : node;
        }
        function createJSDocImplementsTag(tagName, className, comment) {
          var node = createBaseJSDocTag(329, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("implements"), comment);
          node.class = className;
          return node;
        }
        function createJSDocSeeTag(tagName, name, comment) {
          var node = createBaseJSDocTag(346, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("see"), comment);
          node.name = name;
          return node;
        }
        function updateJSDocSeeTag(node, tagName, name, comment) {
          return node.tagName !== tagName || node.name !== name || node.comment !== comment ? update(createJSDocSeeTag(tagName, name, comment), node) : node;
        }
        function createJSDocNameReference(name) {
          var node = createBaseNode(310);
          node.name = name;
          return node;
        }
        function updateJSDocNameReference(node, name) {
          return node.name !== name ? update(createJSDocNameReference(name), node) : node;
        }
        function createJSDocMemberName(left, right) {
          var node = createBaseNode(311);
          node.left = left;
          node.right = right;
          node.transformFlags |= propagateChildFlags(node.left) | propagateChildFlags(node.right);
          return node;
        }
        function updateJSDocMemberName(node, left, right) {
          return node.left !== left || node.right !== right ? update(createJSDocMemberName(left, right), node) : node;
        }
        function createJSDocLink(name, text) {
          var node = createBaseNode(324);
          node.name = name;
          node.text = text;
          return node;
        }
        function updateJSDocLink(node, name, text) {
          return node.name !== name ? update(createJSDocLink(name, text), node) : node;
        }
        function createJSDocLinkCode(name, text) {
          var node = createBaseNode(325);
          node.name = name;
          node.text = text;
          return node;
        }
        function updateJSDocLinkCode(node, name, text) {
          return node.name !== name ? update(createJSDocLinkCode(name, text), node) : node;
        }
        function createJSDocLinkPlain(name, text) {
          var node = createBaseNode(326);
          node.name = name;
          node.text = text;
          return node;
        }
        function updateJSDocLinkPlain(node, name, text) {
          return node.name !== name ? update(createJSDocLinkPlain(name, text), node) : node;
        }
        function updateJSDocImplementsTag(node, tagName, className, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.class !== className || node.comment !== comment ? update(createJSDocImplementsTag(tagName, className, comment), node) : node;
        }
        function createJSDocSimpleTagWorker(kind, tagName, comment) {
          var node = createBaseJSDocTag(kind, tagName !== null && tagName !== void 0 ? tagName : createIdentifier(getDefaultTagNameForKind(kind)), comment);
          return node;
        }
        function updateJSDocSimpleTagWorker(kind, node, tagName, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.comment !== comment ? update(createJSDocSimpleTagWorker(kind, tagName, comment), node) : node;
        }
        function createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment) {
          var node = createBaseJSDocTag(kind, tagName !== null && tagName !== void 0 ? tagName : createIdentifier(getDefaultTagNameForKind(kind)), comment);
          node.typeExpression = typeExpression;
          return node;
        }
        function updateJSDocTypeLikeTagWorker(kind, node, tagName, typeExpression, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.typeExpression !== typeExpression || node.comment !== comment ? update(createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment), node) : node;
        }
        function createJSDocUnknownTag(tagName, comment) {
          var node = createBaseJSDocTag(327, tagName, comment);
          return node;
        }
        function updateJSDocUnknownTag(node, tagName, comment) {
          return node.tagName !== tagName || node.comment !== comment ? update(createJSDocUnknownTag(tagName, comment), node) : node;
        }
        function createJSDocText(text) {
          var node = createBaseNode(321);
          node.text = text;
          return node;
        }
        function updateJSDocText(node, text) {
          return node.text !== text ? update(createJSDocText(text), node) : node;
        }
        function createJSDocComment(comment, tags) {
          var node = createBaseNode(320);
          node.comment = comment;
          node.tags = asNodeArray(tags);
          return node;
        }
        function updateJSDocComment(node, comment, tags) {
          return node.comment !== comment || node.tags !== tags ? update(createJSDocComment(comment, tags), node) : node;
        }
        function createJsxElement(openingElement, children, closingElement) {
          var node = createBaseNode(278);
          node.openingElement = openingElement;
          node.children = createNodeArray(children);
          node.closingElement = closingElement;
          node.transformFlags |= propagateChildFlags(node.openingElement) | propagateChildrenFlags(node.children) | propagateChildFlags(node.closingElement) | 2;
          return node;
        }
        function updateJsxElement(node, openingElement, children, closingElement) {
          return node.openingElement !== openingElement || node.children !== children || node.closingElement !== closingElement ? update(createJsxElement(openingElement, children, closingElement), node) : node;
        }
        function createJsxSelfClosingElement(tagName, typeArguments, attributes) {
          var node = createBaseNode(279);
          node.tagName = tagName;
          node.typeArguments = asNodeArray(typeArguments);
          node.attributes = attributes;
          node.transformFlags |= propagateChildFlags(node.tagName) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.attributes) | 2;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateJsxSelfClosingElement(node, tagName, typeArguments, attributes) {
          return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? update(createJsxSelfClosingElement(tagName, typeArguments, attributes), node) : node;
        }
        function createJsxOpeningElement(tagName, typeArguments, attributes) {
          var node = createBaseNode(280);
          node.tagName = tagName;
          node.typeArguments = asNodeArray(typeArguments);
          node.attributes = attributes;
          node.transformFlags |= propagateChildFlags(node.tagName) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.attributes) | 2;
          if (typeArguments) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateJsxOpeningElement(node, tagName, typeArguments, attributes) {
          return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? update(createJsxOpeningElement(tagName, typeArguments, attributes), node) : node;
        }
        function createJsxClosingElement(tagName) {
          var node = createBaseNode(281);
          node.tagName = tagName;
          node.transformFlags |= propagateChildFlags(node.tagName) | 2;
          return node;
        }
        function updateJsxClosingElement(node, tagName) {
          return node.tagName !== tagName ? update(createJsxClosingElement(tagName), node) : node;
        }
        function createJsxFragment(openingFragment, children, closingFragment) {
          var node = createBaseNode(282);
          node.openingFragment = openingFragment;
          node.children = createNodeArray(children);
          node.closingFragment = closingFragment;
          node.transformFlags |= propagateChildFlags(node.openingFragment) | propagateChildrenFlags(node.children) | propagateChildFlags(node.closingFragment) | 2;
          return node;
        }
        function updateJsxFragment(node, openingFragment, children, closingFragment) {
          return node.openingFragment !== openingFragment || node.children !== children || node.closingFragment !== closingFragment ? update(createJsxFragment(openingFragment, children, closingFragment), node) : node;
        }
        function createJsxText(text, containsOnlyTriviaWhiteSpaces) {
          var node = createBaseNode(11);
          node.text = text;
          node.containsOnlyTriviaWhiteSpaces = !!containsOnlyTriviaWhiteSpaces;
          node.transformFlags |= 2;
          return node;
        }
        function updateJsxText(node, text, containsOnlyTriviaWhiteSpaces) {
          return node.text !== text || node.containsOnlyTriviaWhiteSpaces !== containsOnlyTriviaWhiteSpaces ? update(createJsxText(text, containsOnlyTriviaWhiteSpaces), node) : node;
        }
        function createJsxOpeningFragment() {
          var node = createBaseNode(283);
          node.transformFlags |= 2;
          return node;
        }
        function createJsxJsxClosingFragment() {
          var node = createBaseNode(284);
          node.transformFlags |= 2;
          return node;
        }
        function createJsxAttribute(name, initializer) {
          var node = createBaseNode(285);
          node.name = name;
          node.initializer = initializer;
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer) | 2;
          return node;
        }
        function updateJsxAttribute(node, name, initializer) {
          return node.name !== name || node.initializer !== initializer ? update(createJsxAttribute(name, initializer), node) : node;
        }
        function createJsxAttributes(properties) {
          var node = createBaseNode(286);
          node.properties = createNodeArray(properties);
          node.transformFlags |= propagateChildrenFlags(node.properties) | 2;
          return node;
        }
        function updateJsxAttributes(node, properties) {
          return node.properties !== properties ? update(createJsxAttributes(properties), node) : node;
        }
        function createJsxSpreadAttribute(expression) {
          var node = createBaseNode(287);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression) | 2;
          return node;
        }
        function updateJsxSpreadAttribute(node, expression) {
          return node.expression !== expression ? update(createJsxSpreadAttribute(expression), node) : node;
        }
        function createJsxExpression(dotDotDotToken, expression) {
          var node = createBaseNode(288);
          node.dotDotDotToken = dotDotDotToken;
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | propagateChildFlags(node.expression) | 2;
          return node;
        }
        function updateJsxExpression(node, expression) {
          return node.expression !== expression ? update(createJsxExpression(node.dotDotDotToken, expression), node) : node;
        }
        function createCaseClause(expression, statements) {
          var node = createBaseNode(289);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.statements = createNodeArray(statements);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.statements);
          return node;
        }
        function updateCaseClause(node, expression, statements) {
          return node.expression !== expression || node.statements !== statements ? update(createCaseClause(expression, statements), node) : node;
        }
        function createDefaultClause(statements) {
          var node = createBaseNode(290);
          node.statements = createNodeArray(statements);
          node.transformFlags = propagateChildrenFlags(node.statements);
          return node;
        }
        function updateDefaultClause(node, statements) {
          return node.statements !== statements ? update(createDefaultClause(statements), node) : node;
        }
        function createHeritageClause(token, types2) {
          var node = createBaseNode(291);
          node.token = token;
          node.types = createNodeArray(types2);
          node.transformFlags |= propagateChildrenFlags(node.types);
          switch (token) {
            case 94:
              node.transformFlags |= 1024;
              break;
            case 117:
              node.transformFlags |= 1;
              break;
            default:
              return ts3.Debug.assertNever(token);
          }
          return node;
        }
        function updateHeritageClause(node, types2) {
          return node.types !== types2 ? update(createHeritageClause(node.token, types2), node) : node;
        }
        function createCatchClause(variableDeclaration, block) {
          var node = createBaseNode(292);
          if (typeof variableDeclaration === "string" || variableDeclaration && !ts3.isVariableDeclaration(variableDeclaration)) {
            variableDeclaration = createVariableDeclaration(variableDeclaration, void 0, void 0, void 0);
          }
          node.variableDeclaration = variableDeclaration;
          node.block = block;
          node.transformFlags |= propagateChildFlags(node.variableDeclaration) | propagateChildFlags(node.block);
          if (!variableDeclaration)
            node.transformFlags |= 64;
          return node;
        }
        function updateCatchClause(node, variableDeclaration, block) {
          return node.variableDeclaration !== variableDeclaration || node.block !== block ? update(createCatchClause(variableDeclaration, block), node) : node;
        }
        function createPropertyAssignment(name, initializer) {
          var node = createBaseNamedDeclaration(296, void 0, void 0, name);
          node.initializer = parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer);
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer);
          return node;
        }
        function finishUpdatePropertyAssignment(updated, original) {
          if (original.decorators)
            updated.decorators = original.decorators;
          if (original.modifiers)
            updated.modifiers = original.modifiers;
          if (original.questionToken)
            updated.questionToken = original.questionToken;
          if (original.exclamationToken)
            updated.exclamationToken = original.exclamationToken;
          return update(updated, original);
        }
        function updatePropertyAssignment(node, name, initializer) {
          return node.name !== name || node.initializer !== initializer ? finishUpdatePropertyAssignment(createPropertyAssignment(name, initializer), node) : node;
        }
        function createShorthandPropertyAssignment(name, objectAssignmentInitializer) {
          var node = createBaseNamedDeclaration(297, void 0, void 0, name);
          node.objectAssignmentInitializer = objectAssignmentInitializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(objectAssignmentInitializer);
          node.transformFlags |= propagateChildFlags(node.objectAssignmentInitializer) | 1024;
          return node;
        }
        function finishUpdateShorthandPropertyAssignment(updated, original) {
          if (original.decorators)
            updated.decorators = original.decorators;
          if (original.modifiers)
            updated.modifiers = original.modifiers;
          if (original.equalsToken)
            updated.equalsToken = original.equalsToken;
          if (original.questionToken)
            updated.questionToken = original.questionToken;
          if (original.exclamationToken)
            updated.exclamationToken = original.exclamationToken;
          return update(updated, original);
        }
        function updateShorthandPropertyAssignment(node, name, objectAssignmentInitializer) {
          return node.name !== name || node.objectAssignmentInitializer !== objectAssignmentInitializer ? finishUpdateShorthandPropertyAssignment(createShorthandPropertyAssignment(name, objectAssignmentInitializer), node) : node;
        }
        function createSpreadAssignment(expression) {
          var node = createBaseNode(298);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 128 | 32768;
          return node;
        }
        function updateSpreadAssignment(node, expression) {
          return node.expression !== expression ? update(createSpreadAssignment(expression), node) : node;
        }
        function createEnumMember(name, initializer) {
          var node = createBaseNode(299);
          node.name = asName(name);
          node.initializer = initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer);
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer) | 1;
          return node;
        }
        function updateEnumMember(node, name, initializer) {
          return node.name !== name || node.initializer !== initializer ? update(createEnumMember(name, initializer), node) : node;
        }
        function createSourceFile(statements, endOfFileToken, flags2) {
          var node = baseFactory2.createBaseSourceFileNode(305);
          node.statements = createNodeArray(statements);
          node.endOfFileToken = endOfFileToken;
          node.flags |= flags2;
          node.fileName = "";
          node.text = "";
          node.languageVersion = 0;
          node.languageVariant = 0;
          node.scriptKind = 0;
          node.isDeclarationFile = false;
          node.hasNoDefaultLib = false;
          node.transformFlags |= propagateChildrenFlags(node.statements) | propagateChildFlags(node.endOfFileToken);
          return node;
        }
        function cloneSourceFileWithChanges(source, statements, isDeclarationFile, referencedFiles, typeReferences, hasNoDefaultLib, libReferences) {
          var node = source.redirectInfo ? Object.create(source.redirectInfo.redirectTarget) : baseFactory2.createBaseSourceFileNode(305);
          for (var p in source) {
            if (p === "emitNode" || ts3.hasProperty(node, p) || !ts3.hasProperty(source, p))
              continue;
            node[p] = source[p];
          }
          node.flags |= source.flags;
          node.statements = createNodeArray(statements);
          node.endOfFileToken = source.endOfFileToken;
          node.isDeclarationFile = isDeclarationFile;
          node.referencedFiles = referencedFiles;
          node.typeReferenceDirectives = typeReferences;
          node.hasNoDefaultLib = hasNoDefaultLib;
          node.libReferenceDirectives = libReferences;
          node.transformFlags = propagateChildrenFlags(node.statements) | propagateChildFlags(node.endOfFileToken);
          node.impliedNodeFormat = source.impliedNodeFormat;
          return node;
        }
        function updateSourceFile(node, statements, isDeclarationFile, referencedFiles, typeReferenceDirectives, hasNoDefaultLib, libReferenceDirectives) {
          if (isDeclarationFile === void 0) {
            isDeclarationFile = node.isDeclarationFile;
          }
          if (referencedFiles === void 0) {
            referencedFiles = node.referencedFiles;
          }
          if (typeReferenceDirectives === void 0) {
            typeReferenceDirectives = node.typeReferenceDirectives;
          }
          if (hasNoDefaultLib === void 0) {
            hasNoDefaultLib = node.hasNoDefaultLib;
          }
          if (libReferenceDirectives === void 0) {
            libReferenceDirectives = node.libReferenceDirectives;
          }
          return node.statements !== statements || node.isDeclarationFile !== isDeclarationFile || node.referencedFiles !== referencedFiles || node.typeReferenceDirectives !== typeReferenceDirectives || node.hasNoDefaultLib !== hasNoDefaultLib || node.libReferenceDirectives !== libReferenceDirectives ? update(cloneSourceFileWithChanges(node, statements, isDeclarationFile, referencedFiles, typeReferenceDirectives, hasNoDefaultLib, libReferenceDirectives), node) : node;
        }
        function createBundle(sourceFiles, prepends) {
          if (prepends === void 0) {
            prepends = ts3.emptyArray;
          }
          var node = createBaseNode(306);
          node.prepends = prepends;
          node.sourceFiles = sourceFiles;
          return node;
        }
        function updateBundle(node, sourceFiles, prepends) {
          if (prepends === void 0) {
            prepends = ts3.emptyArray;
          }
          return node.sourceFiles !== sourceFiles || node.prepends !== prepends ? update(createBundle(sourceFiles, prepends), node) : node;
        }
        function createUnparsedSource(prologues, syntheticReferences, texts) {
          var node = createBaseNode(307);
          node.prologues = prologues;
          node.syntheticReferences = syntheticReferences;
          node.texts = texts;
          node.fileName = "";
          node.text = "";
          node.referencedFiles = ts3.emptyArray;
          node.libReferenceDirectives = ts3.emptyArray;
          node.getLineAndCharacterOfPosition = function(pos) {
            return ts3.getLineAndCharacterOfPosition(node, pos);
          };
          return node;
        }
        function createBaseUnparsedNode(kind, data) {
          var node = createBaseNode(kind);
          node.data = data;
          return node;
        }
        function createUnparsedPrologue(data) {
          return createBaseUnparsedNode(300, data);
        }
        function createUnparsedPrepend(data, texts) {
          var node = createBaseUnparsedNode(301, data);
          node.texts = texts;
          return node;
        }
        function createUnparsedTextLike(data, internal) {
          return createBaseUnparsedNode(internal ? 303 : 302, data);
        }
        function createUnparsedSyntheticReference(section) {
          var node = createBaseNode(304);
          node.data = section.data;
          node.section = section;
          return node;
        }
        function createInputFiles2() {
          var node = createBaseNode(308);
          node.javascriptText = "";
          node.declarationText = "";
          return node;
        }
        function createSyntheticExpression(type2, isSpread, tupleNameSource) {
          if (isSpread === void 0) {
            isSpread = false;
          }
          var node = createBaseNode(232);
          node.type = type2;
          node.isSpread = isSpread;
          node.tupleNameSource = tupleNameSource;
          return node;
        }
        function createSyntaxList(children) {
          var node = createBaseNode(348);
          node._children = children;
          return node;
        }
        function createNotEmittedStatement(original) {
          var node = createBaseNode(349);
          node.original = original;
          ts3.setTextRange(node, original);
          return node;
        }
        function createPartiallyEmittedExpression(expression, original) {
          var node = createBaseNode(350);
          node.expression = expression;
          node.original = original;
          node.transformFlags |= propagateChildFlags(node.expression) | 1;
          ts3.setTextRange(node, original);
          return node;
        }
        function updatePartiallyEmittedExpression(node, expression) {
          return node.expression !== expression ? update(createPartiallyEmittedExpression(expression, node.original), node) : node;
        }
        function flattenCommaElements(node) {
          if (ts3.nodeIsSynthesized(node) && !ts3.isParseTreeNode(node) && !node.original && !node.emitNode && !node.id) {
            if (ts3.isCommaListExpression(node)) {
              return node.elements;
            }
            if (ts3.isBinaryExpression(node) && ts3.isCommaToken(node.operatorToken)) {
              return [node.left, node.right];
            }
          }
          return node;
        }
        function createCommaListExpression(elements) {
          var node = createBaseNode(351);
          node.elements = createNodeArray(ts3.sameFlatMap(elements, flattenCommaElements));
          node.transformFlags |= propagateChildrenFlags(node.elements);
          return node;
        }
        function updateCommaListExpression(node, elements) {
          return node.elements !== elements ? update(createCommaListExpression(elements), node) : node;
        }
        function createEndOfDeclarationMarker(original) {
          var node = createBaseNode(353);
          node.emitNode = {};
          node.original = original;
          return node;
        }
        function createMergeDeclarationMarker(original) {
          var node = createBaseNode(352);
          node.emitNode = {};
          node.original = original;
          return node;
        }
        function createSyntheticReferenceExpression(expression, thisArg) {
          var node = createBaseNode(354);
          node.expression = expression;
          node.thisArg = thisArg;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.thisArg);
          return node;
        }
        function updateSyntheticReferenceExpression(node, expression, thisArg) {
          return node.expression !== expression || node.thisArg !== thisArg ? update(createSyntheticReferenceExpression(expression, thisArg), node) : node;
        }
        function cloneNode(node) {
          if (node === void 0) {
            return node;
          }
          var clone = ts3.isSourceFile(node) ? baseFactory2.createBaseSourceFileNode(305) : ts3.isIdentifier(node) ? baseFactory2.createBaseIdentifierNode(79) : ts3.isPrivateIdentifier(node) ? baseFactory2.createBasePrivateIdentifierNode(80) : !ts3.isNodeKind(node.kind) ? baseFactory2.createBaseTokenNode(node.kind) : baseFactory2.createBaseNode(node.kind);
          clone.flags |= node.flags & ~8;
          clone.transformFlags = node.transformFlags;
          setOriginalNode(clone, node);
          for (var key in node) {
            if (clone.hasOwnProperty(key) || !node.hasOwnProperty(key)) {
              continue;
            }
            clone[key] = node[key];
          }
          return clone;
        }
        function createImmediatelyInvokedFunctionExpression(statements, param, paramValue) {
          return createCallExpression(createFunctionExpression(void 0, void 0, void 0, void 0, param ? [param] : [], void 0, createBlock(statements, true)), void 0, paramValue ? [paramValue] : []);
        }
        function createImmediatelyInvokedArrowFunction(statements, param, paramValue) {
          return createCallExpression(createArrowFunction(void 0, void 0, param ? [param] : [], void 0, void 0, createBlock(statements, true)), void 0, paramValue ? [paramValue] : []);
        }
        function createVoidZero() {
          return createVoidExpression(createNumericLiteral("0"));
        }
        function createExportDefault(expression) {
          return createExportAssignment(void 0, void 0, false, expression);
        }
        function createExternalModuleExport(exportName) {
          return createExportDeclaration(void 0, void 0, false, createNamedExports([
            createExportSpecifier(false, void 0, exportName)
          ]));
        }
        function createTypeCheck(value, tag) {
          return tag === "undefined" ? factory.createStrictEquality(value, createVoidZero()) : factory.createStrictEquality(createTypeOfExpression(value), createStringLiteral(tag));
        }
        function createMethodCall(object2, methodName, argumentsList) {
          if (ts3.isCallChain(object2)) {
            return createCallChain(createPropertyAccessChain(object2, void 0, methodName), void 0, void 0, argumentsList);
          }
          return createCallExpression(createPropertyAccessExpression(object2, methodName), void 0, argumentsList);
        }
        function createFunctionBindCall(target, thisArg, argumentsList) {
          return createMethodCall(target, "bind", __spreadArray([thisArg], argumentsList, true));
        }
        function createFunctionCallCall(target, thisArg, argumentsList) {
          return createMethodCall(target, "call", __spreadArray([thisArg], argumentsList, true));
        }
        function createFunctionApplyCall(target, thisArg, argumentsExpression) {
          return createMethodCall(target, "apply", [thisArg, argumentsExpression]);
        }
        function createGlobalMethodCall(globalObjectName, methodName, argumentsList) {
          return createMethodCall(createIdentifier(globalObjectName), methodName, argumentsList);
        }
        function createArraySliceCall(array, start) {
          return createMethodCall(array, "slice", start === void 0 ? [] : [asExpression(start)]);
        }
        function createArrayConcatCall(array, argumentsList) {
          return createMethodCall(array, "concat", argumentsList);
        }
        function createObjectDefinePropertyCall(target, propertyName, attributes) {
          return createGlobalMethodCall("Object", "defineProperty", [target, asExpression(propertyName), attributes]);
        }
        function createReflectGetCall(target, propertyKey, receiver) {
          return createGlobalMethodCall("Reflect", "get", receiver ? [target, propertyKey, receiver] : [target, propertyKey]);
        }
        function createReflectSetCall(target, propertyKey, value, receiver) {
          return createGlobalMethodCall("Reflect", "set", receiver ? [target, propertyKey, value, receiver] : [target, propertyKey, value]);
        }
        function tryAddPropertyAssignment(properties, propertyName, expression) {
          if (expression) {
            properties.push(createPropertyAssignment(propertyName, expression));
            return true;
          }
          return false;
        }
        function createPropertyDescriptor(attributes, singleLine) {
          var properties = [];
          tryAddPropertyAssignment(properties, "enumerable", asExpression(attributes.enumerable));
          tryAddPropertyAssignment(properties, "configurable", asExpression(attributes.configurable));
          var isData = tryAddPropertyAssignment(properties, "writable", asExpression(attributes.writable));
          isData = tryAddPropertyAssignment(properties, "value", attributes.value) || isData;
          var isAccessor = tryAddPropertyAssignment(properties, "get", attributes.get);
          isAccessor = tryAddPropertyAssignment(properties, "set", attributes.set) || isAccessor;
          ts3.Debug.assert(!(isData && isAccessor), "A PropertyDescriptor may not be both an accessor descriptor and a data descriptor.");
          return createObjectLiteralExpression(properties, !singleLine);
        }
        function updateOuterExpression(outerExpression, expression) {
          switch (outerExpression.kind) {
            case 212:
              return updateParenthesizedExpression(outerExpression, expression);
            case 211:
              return updateTypeAssertion(outerExpression, outerExpression.type, expression);
            case 229:
              return updateAsExpression(outerExpression, expression, outerExpression.type);
            case 230:
              return updateNonNullExpression(outerExpression, expression);
            case 350:
              return updatePartiallyEmittedExpression(outerExpression, expression);
          }
        }
        function isIgnorableParen(node) {
          return ts3.isParenthesizedExpression(node) && ts3.nodeIsSynthesized(node) && ts3.nodeIsSynthesized(ts3.getSourceMapRange(node)) && ts3.nodeIsSynthesized(ts3.getCommentRange(node)) && !ts3.some(ts3.getSyntheticLeadingComments(node)) && !ts3.some(ts3.getSyntheticTrailingComments(node));
        }
        function restoreOuterExpressions(outerExpression, innerExpression, kinds) {
          if (kinds === void 0) {
            kinds = 15;
          }
          if (outerExpression && ts3.isOuterExpression(outerExpression, kinds) && !isIgnorableParen(outerExpression)) {
            return updateOuterExpression(outerExpression, restoreOuterExpressions(outerExpression.expression, innerExpression));
          }
          return innerExpression;
        }
        function restoreEnclosingLabel(node, outermostLabeledStatement, afterRestoreLabelCallback) {
          if (!outermostLabeledStatement) {
            return node;
          }
          var updated = updateLabeledStatement(outermostLabeledStatement, outermostLabeledStatement.label, ts3.isLabeledStatement(outermostLabeledStatement.statement) ? restoreEnclosingLabel(node, outermostLabeledStatement.statement) : node);
          if (afterRestoreLabelCallback) {
            afterRestoreLabelCallback(outermostLabeledStatement);
          }
          return updated;
        }
        function shouldBeCapturedInTempVariable(node, cacheIdentifiers) {
          var target = ts3.skipParentheses(node);
          switch (target.kind) {
            case 79:
              return cacheIdentifiers;
            case 108:
            case 8:
            case 9:
            case 10:
              return false;
            case 204:
              var elements = target.elements;
              if (elements.length === 0) {
                return false;
              }
              return true;
            case 205:
              return target.properties.length > 0;
            default:
              return true;
          }
        }
        function createCallBinding(expression, recordTempVariable, languageVersion, cacheIdentifiers) {
          if (cacheIdentifiers === void 0) {
            cacheIdentifiers = false;
          }
          var callee = ts3.skipOuterExpressions(expression, 15);
          var thisArg;
          var target;
          if (ts3.isSuperProperty(callee)) {
            thisArg = createThis();
            target = callee;
          } else if (ts3.isSuperKeyword(callee)) {
            thisArg = createThis();
            target = languageVersion !== void 0 && languageVersion < 2 ? ts3.setTextRange(createIdentifier("_super"), callee) : callee;
          } else if (ts3.getEmitFlags(callee) & 4096) {
            thisArg = createVoidZero();
            target = parenthesizerRules().parenthesizeLeftSideOfAccess(callee);
          } else if (ts3.isPropertyAccessExpression(callee)) {
            if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
              thisArg = createTempVariable(recordTempVariable);
              target = createPropertyAccessExpression(ts3.setTextRange(factory.createAssignment(thisArg, callee.expression), callee.expression), callee.name);
              ts3.setTextRange(target, callee);
            } else {
              thisArg = callee.expression;
              target = callee;
            }
          } else if (ts3.isElementAccessExpression(callee)) {
            if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
              thisArg = createTempVariable(recordTempVariable);
              target = createElementAccessExpression(ts3.setTextRange(factory.createAssignment(thisArg, callee.expression), callee.expression), callee.argumentExpression);
              ts3.setTextRange(target, callee);
            } else {
              thisArg = callee.expression;
              target = callee;
            }
          } else {
            thisArg = createVoidZero();
            target = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          }
          return { target, thisArg };
        }
        function createAssignmentTargetWrapper(paramName, expression) {
          return createPropertyAccessExpression(createParenthesizedExpression(createObjectLiteralExpression([
            createSetAccessorDeclaration(void 0, void 0, "value", [createParameterDeclaration(void 0, void 0, void 0, paramName, void 0, void 0, void 0)], createBlock([
              createExpressionStatement(expression)
            ]))
          ])), "value");
        }
        function inlineExpressions(expressions) {
          return expressions.length > 10 ? createCommaListExpression(expressions) : ts3.reduceLeft(expressions, factory.createComma);
        }
        function getName(node, allowComments, allowSourceMaps, emitFlags) {
          if (emitFlags === void 0) {
            emitFlags = 0;
          }
          var nodeName = ts3.getNameOfDeclaration(node);
          if (nodeName && ts3.isIdentifier(nodeName) && !ts3.isGeneratedIdentifier(nodeName)) {
            var name = ts3.setParent(ts3.setTextRange(cloneNode(nodeName), nodeName), nodeName.parent);
            emitFlags |= ts3.getEmitFlags(nodeName);
            if (!allowSourceMaps)
              emitFlags |= 48;
            if (!allowComments)
              emitFlags |= 1536;
            if (emitFlags)
              ts3.setEmitFlags(name, emitFlags);
            return name;
          }
          return getGeneratedNameForNode(node);
        }
        function getInternalName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps, 16384 | 32768);
        }
        function getLocalName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps, 16384);
        }
        function getExportName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps, 8192);
        }
        function getDeclarationName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps);
        }
        function getNamespaceMemberName(ns, name, allowComments, allowSourceMaps) {
          var qualifiedName = createPropertyAccessExpression(ns, ts3.nodeIsSynthesized(name) ? name : cloneNode(name));
          ts3.setTextRange(qualifiedName, name);
          var emitFlags = 0;
          if (!allowSourceMaps)
            emitFlags |= 48;
          if (!allowComments)
            emitFlags |= 1536;
          if (emitFlags)
            ts3.setEmitFlags(qualifiedName, emitFlags);
          return qualifiedName;
        }
        function getExternalModuleOrNamespaceExportName(ns, node, allowComments, allowSourceMaps) {
          if (ns && ts3.hasSyntacticModifier(node, 1)) {
            return getNamespaceMemberName(ns, getName(node), allowComments, allowSourceMaps);
          }
          return getExportName(node, allowComments, allowSourceMaps);
        }
        function copyPrologue(source, target, ensureUseStrict2, visitor) {
          var offset = copyStandardPrologue(source, target, 0, ensureUseStrict2);
          return copyCustomPrologue(source, target, offset, visitor);
        }
        function isUseStrictPrologue(node) {
          return ts3.isStringLiteral(node.expression) && node.expression.text === "use strict";
        }
        function createUseStrictPrologue() {
          return ts3.startOnNewLine(createExpressionStatement(createStringLiteral("use strict")));
        }
        function copyStandardPrologue(source, target, statementOffset, ensureUseStrict2) {
          if (statementOffset === void 0) {
            statementOffset = 0;
          }
          ts3.Debug.assert(target.length === 0, "Prologue directives should be at the first statement in the target statements array");
          var foundUseStrict = false;
          var numStatements = source.length;
          while (statementOffset < numStatements) {
            var statement = source[statementOffset];
            if (ts3.isPrologueDirective(statement)) {
              if (isUseStrictPrologue(statement)) {
                foundUseStrict = true;
              }
              target.push(statement);
            } else {
              break;
            }
            statementOffset++;
          }
          if (ensureUseStrict2 && !foundUseStrict) {
            target.push(createUseStrictPrologue());
          }
          return statementOffset;
        }
        function copyCustomPrologue(source, target, statementOffset, visitor, filter) {
          if (filter === void 0) {
            filter = ts3.returnTrue;
          }
          var numStatements = source.length;
          while (statementOffset !== void 0 && statementOffset < numStatements) {
            var statement = source[statementOffset];
            if (ts3.getEmitFlags(statement) & 1048576 && filter(statement)) {
              ts3.append(target, visitor ? ts3.visitNode(statement, visitor, ts3.isStatement) : statement);
            } else {
              break;
            }
            statementOffset++;
          }
          return statementOffset;
        }
        function ensureUseStrict(statements) {
          var foundUseStrict = ts3.findUseStrictPrologue(statements);
          if (!foundUseStrict) {
            return ts3.setTextRange(createNodeArray(__spreadArray([createUseStrictPrologue()], statements, true)), statements);
          }
          return statements;
        }
        function liftToBlock(nodes) {
          ts3.Debug.assert(ts3.every(nodes, ts3.isStatementOrBlock), "Cannot lift nodes to a Block.");
          return ts3.singleOrUndefined(nodes) || createBlock(nodes);
        }
        function findSpanEnd(array, test, start) {
          var i = start;
          while (i < array.length && test(array[i])) {
            i++;
          }
          return i;
        }
        function mergeLexicalEnvironment(statements, declarations) {
          if (!ts3.some(declarations)) {
            return statements;
          }
          var leftStandardPrologueEnd = findSpanEnd(statements, ts3.isPrologueDirective, 0);
          var leftHoistedFunctionsEnd = findSpanEnd(statements, ts3.isHoistedFunction, leftStandardPrologueEnd);
          var leftHoistedVariablesEnd = findSpanEnd(statements, ts3.isHoistedVariableStatement, leftHoistedFunctionsEnd);
          var rightStandardPrologueEnd = findSpanEnd(declarations, ts3.isPrologueDirective, 0);
          var rightHoistedFunctionsEnd = findSpanEnd(declarations, ts3.isHoistedFunction, rightStandardPrologueEnd);
          var rightHoistedVariablesEnd = findSpanEnd(declarations, ts3.isHoistedVariableStatement, rightHoistedFunctionsEnd);
          var rightCustomPrologueEnd = findSpanEnd(declarations, ts3.isCustomPrologue, rightHoistedVariablesEnd);
          ts3.Debug.assert(rightCustomPrologueEnd === declarations.length, "Expected declarations to be valid standard or custom prologues");
          var left = ts3.isNodeArray(statements) ? statements.slice() : statements;
          if (rightCustomPrologueEnd > rightHoistedVariablesEnd) {
            left.splice.apply(left, __spreadArray([leftHoistedVariablesEnd, 0], declarations.slice(rightHoistedVariablesEnd, rightCustomPrologueEnd), false));
          }
          if (rightHoistedVariablesEnd > rightHoistedFunctionsEnd) {
            left.splice.apply(left, __spreadArray([leftHoistedFunctionsEnd, 0], declarations.slice(rightHoistedFunctionsEnd, rightHoistedVariablesEnd), false));
          }
          if (rightHoistedFunctionsEnd > rightStandardPrologueEnd) {
            left.splice.apply(left, __spreadArray([leftStandardPrologueEnd, 0], declarations.slice(rightStandardPrologueEnd, rightHoistedFunctionsEnd), false));
          }
          if (rightStandardPrologueEnd > 0) {
            if (leftStandardPrologueEnd === 0) {
              left.splice.apply(left, __spreadArray([0, 0], declarations.slice(0, rightStandardPrologueEnd), false));
            } else {
              var leftPrologues = new ts3.Map();
              for (var i = 0; i < leftStandardPrologueEnd; i++) {
                var leftPrologue = statements[i];
                leftPrologues.set(leftPrologue.expression.text, true);
              }
              for (var i = rightStandardPrologueEnd - 1; i >= 0; i--) {
                var rightPrologue = declarations[i];
                if (!leftPrologues.has(rightPrologue.expression.text)) {
                  left.unshift(rightPrologue);
                }
              }
            }
          }
          if (ts3.isNodeArray(statements)) {
            return ts3.setTextRange(createNodeArray(left, statements.hasTrailingComma), statements);
          }
          return statements;
        }
        function updateModifiers(node, modifiers) {
          var _a;
          var modifierArray;
          if (typeof modifiers === "number") {
            modifierArray = createModifiersFromModifierFlags(modifiers);
          } else {
            modifierArray = modifiers;
          }
          return ts3.isParameter(node) ? updateParameterDeclaration(node, node.decorators, modifierArray, node.dotDotDotToken, node.name, node.questionToken, node.type, node.initializer) : ts3.isPropertySignature(node) ? updatePropertySignature(node, modifierArray, node.name, node.questionToken, node.type) : ts3.isPropertyDeclaration(node) ? updatePropertyDeclaration(node, node.decorators, modifierArray, node.name, (_a = node.questionToken) !== null && _a !== void 0 ? _a : node.exclamationToken, node.type, node.initializer) : ts3.isMethodSignature(node) ? updateMethodSignature(node, modifierArray, node.name, node.questionToken, node.typeParameters, node.parameters, node.type) : ts3.isMethodDeclaration(node) ? updateMethodDeclaration(node, node.decorators, modifierArray, node.asteriskToken, node.name, node.questionToken, node.typeParameters, node.parameters, node.type, node.body) : ts3.isConstructorDeclaration(node) ? updateConstructorDeclaration(node, node.decorators, modifierArray, node.parameters, node.body) : ts3.isGetAccessorDeclaration(node) ? updateGetAccessorDeclaration(node, node.decorators, modifierArray, node.name, node.parameters, node.type, node.body) : ts3.isSetAccessorDeclaration(node) ? updateSetAccessorDeclaration(node, node.decorators, modifierArray, node.name, node.parameters, node.body) : ts3.isIndexSignatureDeclaration(node) ? updateIndexSignature(node, node.decorators, modifierArray, node.parameters, node.type) : ts3.isFunctionExpression(node) ? updateFunctionExpression(node, modifierArray, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body) : ts3.isArrowFunction(node) ? updateArrowFunction(node, modifierArray, node.typeParameters, node.parameters, node.type, node.equalsGreaterThanToken, node.body) : ts3.isClassExpression(node) ? updateClassExpression(node, node.decorators, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : ts3.isVariableStatement(node) ? updateVariableStatement(node, modifierArray, node.declarationList) : ts3.isFunctionDeclaration(node) ? updateFunctionDeclaration(node, node.decorators, modifierArray, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body) : ts3.isClassDeclaration(node) ? updateClassDeclaration(node, node.decorators, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : ts3.isInterfaceDeclaration(node) ? updateInterfaceDeclaration(node, node.decorators, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : ts3.isTypeAliasDeclaration(node) ? updateTypeAliasDeclaration(node, node.decorators, modifierArray, node.name, node.typeParameters, node.type) : ts3.isEnumDeclaration(node) ? updateEnumDeclaration(node, node.decorators, modifierArray, node.name, node.members) : ts3.isModuleDeclaration(node) ? updateModuleDeclaration(node, node.decorators, modifierArray, node.name, node.body) : ts3.isImportEqualsDeclaration(node) ? updateImportEqualsDeclaration(node, node.decorators, modifierArray, node.isTypeOnly, node.name, node.moduleReference) : ts3.isImportDeclaration(node) ? updateImportDeclaration(node, node.decorators, modifierArray, node.importClause, node.moduleSpecifier, node.assertClause) : ts3.isExportAssignment(node) ? updateExportAssignment(node, node.decorators, modifierArray, node.expression) : ts3.isExportDeclaration(node) ? updateExportDeclaration(node, node.decorators, modifierArray, node.isTypeOnly, node.exportClause, node.moduleSpecifier, node.assertClause) : ts3.Debug.assertNever(node);
        }
        function asNodeArray(array) {
          return array ? createNodeArray(array) : void 0;
        }
        function asName(name) {
          return typeof name === "string" ? createIdentifier(name) : name;
        }
        function asExpression(value) {
          return typeof value === "string" ? createStringLiteral(value) : typeof value === "number" ? createNumericLiteral(value) : typeof value === "boolean" ? value ? createTrue() : createFalse() : value;
        }
        function asToken(value) {
          return typeof value === "number" ? createToken(value) : value;
        }
        function asEmbeddedStatement(statement) {
          return statement && ts3.isNotEmittedStatement(statement) ? ts3.setTextRange(setOriginalNode(createEmptyStatement(), statement), statement) : statement;
        }
      }
      ts3.createNodeFactory = createNodeFactory;
      function updateWithoutOriginal(updated, original) {
        if (updated !== original) {
          ts3.setTextRange(updated, original);
        }
        return updated;
      }
      function updateWithOriginal(updated, original) {
        if (updated !== original) {
          setOriginalNode(updated, original);
          ts3.setTextRange(updated, original);
        }
        return updated;
      }
      function getDefaultTagNameForKind(kind) {
        switch (kind) {
          case 343:
            return "type";
          case 341:
            return "returns";
          case 342:
            return "this";
          case 339:
            return "enum";
          case 330:
            return "author";
          case 332:
            return "class";
          case 333:
            return "public";
          case 334:
            return "private";
          case 335:
            return "protected";
          case 336:
            return "readonly";
          case 337:
            return "override";
          case 344:
            return "template";
          case 345:
            return "typedef";
          case 340:
            return "param";
          case 347:
            return "prop";
          case 338:
            return "callback";
          case 328:
            return "augments";
          case 329:
            return "implements";
          default:
            return ts3.Debug.fail("Unsupported kind: ".concat(ts3.Debug.formatSyntaxKind(kind)));
        }
      }
      var rawTextScanner;
      var invalidValueSentinel = {};
      function getCookedText(kind, rawText) {
        if (!rawTextScanner) {
          rawTextScanner = ts3.createScanner(99, false, 0);
        }
        switch (kind) {
          case 14:
            rawTextScanner.setText("`" + rawText + "`");
            break;
          case 15:
            rawTextScanner.setText("`" + rawText + "${");
            break;
          case 16:
            rawTextScanner.setText("}" + rawText + "${");
            break;
          case 17:
            rawTextScanner.setText("}" + rawText + "`");
            break;
        }
        var token = rawTextScanner.scan();
        if (token === 19) {
          token = rawTextScanner.reScanTemplateToken(false);
        }
        if (rawTextScanner.isUnterminated()) {
          rawTextScanner.setText(void 0);
          return invalidValueSentinel;
        }
        var tokenValue;
        switch (token) {
          case 14:
          case 15:
          case 16:
          case 17:
            tokenValue = rawTextScanner.getTokenValue();
            break;
        }
        if (tokenValue === void 0 || rawTextScanner.scan() !== 1) {
          rawTextScanner.setText(void 0);
          return invalidValueSentinel;
        }
        rawTextScanner.setText(void 0);
        return tokenValue;
      }
      function propagateIdentifierNameFlags(node) {
        return propagateChildFlags(node) & ~16777216;
      }
      function propagatePropertyNameFlagsOfChild(node, transformFlags) {
        return transformFlags | node.transformFlags & 33562624;
      }
      function propagateChildFlags(child) {
        if (!child)
          return 0;
        var childFlags = child.transformFlags & ~getTransformFlagsSubtreeExclusions(child.kind);
        return ts3.isNamedDeclaration(child) && ts3.isPropertyName(child.name) ? propagatePropertyNameFlagsOfChild(child.name, childFlags) : childFlags;
      }
      function propagateChildrenFlags(children) {
        return children ? children.transformFlags : 0;
      }
      function aggregateChildrenFlags(children) {
        var subtreeFlags = 0;
        for (var _i = 0, children_2 = children; _i < children_2.length; _i++) {
          var child = children_2[_i];
          subtreeFlags |= propagateChildFlags(child);
        }
        children.transformFlags = subtreeFlags;
      }
      function getTransformFlagsSubtreeExclusions(kind) {
        if (kind >= 177 && kind <= 200) {
          return -2;
        }
        switch (kind) {
          case 208:
          case 209:
          case 204:
            return 536887296;
          case 261:
            return 589443072;
          case 164:
            return 536870912;
          case 214:
            return 557748224;
          case 213:
          case 256:
            return 591310848;
          case 255:
            return 537165824;
          case 257:
          case 226:
            return 536940544;
          case 171:
            return 591306752;
          case 167:
            return 570433536;
          case 169:
          case 172:
          case 173:
            return 574529536;
          case 130:
          case 147:
          case 158:
          case 143:
          case 150:
          case 148:
          case 133:
          case 151:
          case 114:
          case 163:
          case 166:
          case 168:
          case 174:
          case 175:
          case 176:
          case 258:
          case 259:
            return -2;
          case 205:
            return 536973312;
          case 292:
            return 536903680;
          case 201:
          case 202:
            return 536887296;
          case 211:
          case 229:
          case 350:
          case 212:
          case 106:
            return 536870912;
          case 206:
          case 207:
            return 536870912;
          default:
            return 536870912;
        }
      }
      ts3.getTransformFlagsSubtreeExclusions = getTransformFlagsSubtreeExclusions;
      var baseFactory = ts3.createBaseNodeFactory();
      function makeSynthetic(node) {
        node.flags |= 8;
        return node;
      }
      var syntheticFactory = {
        createBaseSourceFileNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseSourceFileNode(kind));
        },
        createBaseIdentifierNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseIdentifierNode(kind));
        },
        createBasePrivateIdentifierNode: function(kind) {
          return makeSynthetic(baseFactory.createBasePrivateIdentifierNode(kind));
        },
        createBaseTokenNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseTokenNode(kind));
        },
        createBaseNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseNode(kind));
        }
      };
      ts3.factory = createNodeFactory(4, syntheticFactory);
      function createUnparsedSourceFile(textOrInputFiles, mapPathOrType, mapTextOrStripInternal) {
        var stripInternal;
        var bundleFileInfo;
        var fileName2;
        var text;
        var length;
        var sourceMapPath;
        var sourceMapText;
        var getText;
        var getSourceMapText;
        var oldFileOfCurrentEmit;
        if (!ts3.isString(textOrInputFiles)) {
          ts3.Debug.assert(mapPathOrType === "js" || mapPathOrType === "dts");
          fileName2 = (mapPathOrType === "js" ? textOrInputFiles.javascriptPath : textOrInputFiles.declarationPath) || "";
          sourceMapPath = mapPathOrType === "js" ? textOrInputFiles.javascriptMapPath : textOrInputFiles.declarationMapPath;
          getText = function() {
            return mapPathOrType === "js" ? textOrInputFiles.javascriptText : textOrInputFiles.declarationText;
          };
          getSourceMapText = function() {
            return mapPathOrType === "js" ? textOrInputFiles.javascriptMapText : textOrInputFiles.declarationMapText;
          };
          length = function() {
            return getText().length;
          };
          if (textOrInputFiles.buildInfo && textOrInputFiles.buildInfo.bundle) {
            ts3.Debug.assert(mapTextOrStripInternal === void 0 || typeof mapTextOrStripInternal === "boolean");
            stripInternal = mapTextOrStripInternal;
            bundleFileInfo = mapPathOrType === "js" ? textOrInputFiles.buildInfo.bundle.js : textOrInputFiles.buildInfo.bundle.dts;
            oldFileOfCurrentEmit = textOrInputFiles.oldFileOfCurrentEmit;
          }
        } else {
          fileName2 = "";
          text = textOrInputFiles;
          length = textOrInputFiles.length;
          sourceMapPath = mapPathOrType;
          sourceMapText = mapTextOrStripInternal;
        }
        var node = oldFileOfCurrentEmit ? parseOldFileOfCurrentEmit(ts3.Debug.checkDefined(bundleFileInfo)) : parseUnparsedSourceFile(bundleFileInfo, stripInternal, length);
        node.fileName = fileName2;
        node.sourceMapPath = sourceMapPath;
        node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
        if (getText && getSourceMapText) {
          Object.defineProperty(node, "text", { get: getText });
          Object.defineProperty(node, "sourceMapText", { get: getSourceMapText });
        } else {
          ts3.Debug.assert(!oldFileOfCurrentEmit);
          node.text = text !== null && text !== void 0 ? text : "";
          node.sourceMapText = sourceMapText;
        }
        return node;
      }
      ts3.createUnparsedSourceFile = createUnparsedSourceFile;
      function parseUnparsedSourceFile(bundleFileInfo, stripInternal, length) {
        var prologues;
        var helpers;
        var referencedFiles;
        var typeReferenceDirectives;
        var libReferenceDirectives;
        var prependChildren;
        var texts;
        var hasNoDefaultLib;
        for (var _i = 0, _a = bundleFileInfo ? bundleFileInfo.sections : ts3.emptyArray; _i < _a.length; _i++) {
          var section = _a[_i];
          switch (section.kind) {
            case "prologue":
              prologues = ts3.append(prologues, ts3.setTextRange(ts3.factory.createUnparsedPrologue(section.data), section));
              break;
            case "emitHelpers":
              helpers = ts3.append(helpers, ts3.getAllUnscopedEmitHelpers().get(section.data));
              break;
            case "no-default-lib":
              hasNoDefaultLib = true;
              break;
            case "reference":
              referencedFiles = ts3.append(referencedFiles, { pos: -1, end: -1, fileName: section.data });
              break;
            case "type":
              typeReferenceDirectives = ts3.append(typeReferenceDirectives, { pos: -1, end: -1, fileName: section.data });
              break;
            case "type-import":
              typeReferenceDirectives = ts3.append(typeReferenceDirectives, { pos: -1, end: -1, fileName: section.data, resolutionMode: ts3.ModuleKind.ESNext });
              break;
            case "type-require":
              typeReferenceDirectives = ts3.append(typeReferenceDirectives, { pos: -1, end: -1, fileName: section.data, resolutionMode: ts3.ModuleKind.CommonJS });
              break;
            case "lib":
              libReferenceDirectives = ts3.append(libReferenceDirectives, { pos: -1, end: -1, fileName: section.data });
              break;
            case "prepend":
              var prependTexts = void 0;
              for (var _b = 0, _c = section.texts; _b < _c.length; _b++) {
                var text = _c[_b];
                if (!stripInternal || text.kind !== "internal") {
                  prependTexts = ts3.append(prependTexts, ts3.setTextRange(ts3.factory.createUnparsedTextLike(text.data, text.kind === "internal"), text));
                }
              }
              prependChildren = ts3.addRange(prependChildren, prependTexts);
              texts = ts3.append(texts, ts3.factory.createUnparsedPrepend(section.data, prependTexts !== null && prependTexts !== void 0 ? prependTexts : ts3.emptyArray));
              break;
            case "internal":
              if (stripInternal) {
                if (!texts)
                  texts = [];
                break;
              }
            case "text":
              texts = ts3.append(texts, ts3.setTextRange(ts3.factory.createUnparsedTextLike(section.data, section.kind === "internal"), section));
              break;
            default:
              ts3.Debug.assertNever(section);
          }
        }
        if (!texts) {
          var textNode = ts3.factory.createUnparsedTextLike(void 0, false);
          ts3.setTextRangePosWidth(textNode, 0, typeof length === "function" ? length() : length);
          texts = [textNode];
        }
        var node = ts3.parseNodeFactory.createUnparsedSource(prologues !== null && prologues !== void 0 ? prologues : ts3.emptyArray, void 0, texts);
        ts3.setEachParent(prologues, node);
        ts3.setEachParent(texts, node);
        ts3.setEachParent(prependChildren, node);
        node.hasNoDefaultLib = hasNoDefaultLib;
        node.helpers = helpers;
        node.referencedFiles = referencedFiles || ts3.emptyArray;
        node.typeReferenceDirectives = typeReferenceDirectives;
        node.libReferenceDirectives = libReferenceDirectives || ts3.emptyArray;
        return node;
      }
      function parseOldFileOfCurrentEmit(bundleFileInfo) {
        var texts;
        var syntheticReferences;
        for (var _i = 0, _a = bundleFileInfo.sections; _i < _a.length; _i++) {
          var section = _a[_i];
          switch (section.kind) {
            case "internal":
            case "text":
              texts = ts3.append(texts, ts3.setTextRange(ts3.factory.createUnparsedTextLike(section.data, section.kind === "internal"), section));
              break;
            case "no-default-lib":
            case "reference":
            case "type":
            case "type-import":
            case "type-require":
            case "lib":
              syntheticReferences = ts3.append(syntheticReferences, ts3.setTextRange(ts3.factory.createUnparsedSyntheticReference(section), section));
              break;
            case "prologue":
            case "emitHelpers":
            case "prepend":
              break;
            default:
              ts3.Debug.assertNever(section);
          }
        }
        var node = ts3.factory.createUnparsedSource(ts3.emptyArray, syntheticReferences, texts !== null && texts !== void 0 ? texts : ts3.emptyArray);
        ts3.setEachParent(syntheticReferences, node);
        ts3.setEachParent(texts, node);
        node.helpers = ts3.map(bundleFileInfo.sources && bundleFileInfo.sources.helpers, function(name) {
          return ts3.getAllUnscopedEmitHelpers().get(name);
        });
        return node;
      }
      function createInputFiles(javascriptTextOrReadFileText, declarationTextOrJavascriptPath, javascriptMapPath, javascriptMapTextOrDeclarationPath, declarationMapPath, declarationMapTextOrBuildInfoPath, javascriptPath, declarationPath, buildInfoPath, buildInfo, oldFileOfCurrentEmit) {
        var node = ts3.parseNodeFactory.createInputFiles();
        if (!ts3.isString(javascriptTextOrReadFileText)) {
          var cache_1 = new ts3.Map();
          var textGetter_1 = function(path2) {
            if (path2 === void 0)
              return void 0;
            var value = cache_1.get(path2);
            if (value === void 0) {
              value = javascriptTextOrReadFileText(path2);
              cache_1.set(path2, value !== void 0 ? value : false);
            }
            return value !== false ? value : void 0;
          };
          var definedTextGetter_1 = function(path2) {
            var result2 = textGetter_1(path2);
            return result2 !== void 0 ? result2 : "/* Input file ".concat(path2, " was missing */\r\n");
          };
          var buildInfo_1;
          var getAndCacheBuildInfo_1 = function(getText) {
            if (buildInfo_1 === void 0) {
              var result2 = getText();
              buildInfo_1 = result2 !== void 0 ? ts3.getBuildInfo(result2) : false;
            }
            return buildInfo_1 || void 0;
          };
          node.javascriptPath = declarationTextOrJavascriptPath;
          node.javascriptMapPath = javascriptMapPath;
          node.declarationPath = ts3.Debug.checkDefined(javascriptMapTextOrDeclarationPath);
          node.declarationMapPath = declarationMapPath;
          node.buildInfoPath = declarationMapTextOrBuildInfoPath;
          Object.defineProperties(node, {
            javascriptText: { get: function() {
              return definedTextGetter_1(declarationTextOrJavascriptPath);
            } },
            javascriptMapText: { get: function() {
              return textGetter_1(javascriptMapPath);
            } },
            declarationText: { get: function() {
              return definedTextGetter_1(ts3.Debug.checkDefined(javascriptMapTextOrDeclarationPath));
            } },
            declarationMapText: { get: function() {
              return textGetter_1(declarationMapPath);
            } },
            buildInfo: { get: function() {
              return getAndCacheBuildInfo_1(function() {
                return textGetter_1(declarationMapTextOrBuildInfoPath);
              });
            } }
          });
        } else {
          node.javascriptText = javascriptTextOrReadFileText;
          node.javascriptMapPath = javascriptMapPath;
          node.javascriptMapText = javascriptMapTextOrDeclarationPath;
          node.declarationText = declarationTextOrJavascriptPath;
          node.declarationMapPath = declarationMapPath;
          node.declarationMapText = declarationMapTextOrBuildInfoPath;
          node.javascriptPath = javascriptPath;
          node.declarationPath = declarationPath;
          node.buildInfoPath = buildInfoPath;
          node.buildInfo = buildInfo;
          node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
        }
        return node;
      }
      ts3.createInputFiles = createInputFiles;
      var SourceMapSource;
      function createSourceMapSource(fileName2, text, skipTrivia) {
        return new (SourceMapSource || (SourceMapSource = ts3.objectAllocator.getSourceMapSourceConstructor()))(fileName2, text, skipTrivia);
      }
      ts3.createSourceMapSource = createSourceMapSource;
      function setOriginalNode(node, original) {
        node.original = original;
        if (original) {
          var emitNode = original.emitNode;
          if (emitNode)
            node.emitNode = mergeEmitNode(emitNode, node.emitNode);
        }
        return node;
      }
      ts3.setOriginalNode = setOriginalNode;
      function mergeEmitNode(sourceEmitNode, destEmitNode) {
        var flags = sourceEmitNode.flags, leadingComments = sourceEmitNode.leadingComments, trailingComments = sourceEmitNode.trailingComments, commentRange = sourceEmitNode.commentRange, sourceMapRange = sourceEmitNode.sourceMapRange, tokenSourceMapRanges = sourceEmitNode.tokenSourceMapRanges, constantValue = sourceEmitNode.constantValue, helpers = sourceEmitNode.helpers, startsOnNewLine = sourceEmitNode.startsOnNewLine;
        if (!destEmitNode)
          destEmitNode = {};
        if (leadingComments)
          destEmitNode.leadingComments = ts3.addRange(leadingComments.slice(), destEmitNode.leadingComments);
        if (trailingComments)
          destEmitNode.trailingComments = ts3.addRange(trailingComments.slice(), destEmitNode.trailingComments);
        if (flags)
          destEmitNode.flags = flags & ~268435456;
        if (commentRange)
          destEmitNode.commentRange = commentRange;
        if (sourceMapRange)
          destEmitNode.sourceMapRange = sourceMapRange;
        if (tokenSourceMapRanges)
          destEmitNode.tokenSourceMapRanges = mergeTokenSourceMapRanges(tokenSourceMapRanges, destEmitNode.tokenSourceMapRanges);
        if (constantValue !== void 0)
          destEmitNode.constantValue = constantValue;
        if (helpers) {
          for (var _i = 0, helpers_1 = helpers; _i < helpers_1.length; _i++) {
            var helper = helpers_1[_i];
            destEmitNode.helpers = ts3.appendIfUnique(destEmitNode.helpers, helper);
          }
        }
        if (startsOnNewLine !== void 0)
          destEmitNode.startsOnNewLine = startsOnNewLine;
        return destEmitNode;
      }
      function mergeTokenSourceMapRanges(sourceRanges, destRanges) {
        if (!destRanges)
          destRanges = [];
        for (var key in sourceRanges) {
          destRanges[key] = sourceRanges[key];
        }
        return destRanges;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getOrCreateEmitNode(node) {
        var _a;
        if (!node.emitNode) {
          if (ts3.isParseTreeNode(node)) {
            if (node.kind === 305) {
              return node.emitNode = { annotatedNodes: [node] };
            }
            var sourceFile = (_a = ts3.getSourceFileOfNode(ts3.getParseTreeNode(ts3.getSourceFileOfNode(node)))) !== null && _a !== void 0 ? _a : ts3.Debug.fail("Could not determine parsed source file.");
            getOrCreateEmitNode(sourceFile).annotatedNodes.push(node);
          }
          node.emitNode = {};
        } else {
          ts3.Debug.assert(!(node.emitNode.flags & 268435456), "Invalid attempt to mutate an immutable node.");
        }
        return node.emitNode;
      }
      ts3.getOrCreateEmitNode = getOrCreateEmitNode;
      function disposeEmitNodes(sourceFile) {
        var _a, _b;
        var annotatedNodes = (_b = (_a = ts3.getSourceFileOfNode(ts3.getParseTreeNode(sourceFile))) === null || _a === void 0 ? void 0 : _a.emitNode) === null || _b === void 0 ? void 0 : _b.annotatedNodes;
        if (annotatedNodes) {
          for (var _i = 0, annotatedNodes_1 = annotatedNodes; _i < annotatedNodes_1.length; _i++) {
            var node = annotatedNodes_1[_i];
            node.emitNode = void 0;
          }
        }
      }
      ts3.disposeEmitNodes = disposeEmitNodes;
      function removeAllComments(node) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.flags |= 1536;
        emitNode.leadingComments = void 0;
        emitNode.trailingComments = void 0;
        return node;
      }
      ts3.removeAllComments = removeAllComments;
      function setEmitFlags(node, emitFlags) {
        getOrCreateEmitNode(node).flags = emitFlags;
        return node;
      }
      ts3.setEmitFlags = setEmitFlags;
      function addEmitFlags(node, emitFlags) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.flags = emitNode.flags | emitFlags;
        return node;
      }
      ts3.addEmitFlags = addEmitFlags;
      function getSourceMapRange(node) {
        var _a, _b;
        return (_b = (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.sourceMapRange) !== null && _b !== void 0 ? _b : node;
      }
      ts3.getSourceMapRange = getSourceMapRange;
      function setSourceMapRange(node, range) {
        getOrCreateEmitNode(node).sourceMapRange = range;
        return node;
      }
      ts3.setSourceMapRange = setSourceMapRange;
      function getTokenSourceMapRange(node, token) {
        var _a, _b;
        return (_b = (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.tokenSourceMapRanges) === null || _b === void 0 ? void 0 : _b[token];
      }
      ts3.getTokenSourceMapRange = getTokenSourceMapRange;
      function setTokenSourceMapRange(node, token, range) {
        var _a;
        var emitNode = getOrCreateEmitNode(node);
        var tokenSourceMapRanges = (_a = emitNode.tokenSourceMapRanges) !== null && _a !== void 0 ? _a : emitNode.tokenSourceMapRanges = [];
        tokenSourceMapRanges[token] = range;
        return node;
      }
      ts3.setTokenSourceMapRange = setTokenSourceMapRange;
      function getStartsOnNewLine(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.startsOnNewLine;
      }
      ts3.getStartsOnNewLine = getStartsOnNewLine;
      function setStartsOnNewLine(node, newLine) {
        getOrCreateEmitNode(node).startsOnNewLine = newLine;
        return node;
      }
      ts3.setStartsOnNewLine = setStartsOnNewLine;
      function getCommentRange(node) {
        var _a, _b;
        return (_b = (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.commentRange) !== null && _b !== void 0 ? _b : node;
      }
      ts3.getCommentRange = getCommentRange;
      function setCommentRange(node, range) {
        getOrCreateEmitNode(node).commentRange = range;
        return node;
      }
      ts3.setCommentRange = setCommentRange;
      function getSyntheticLeadingComments(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.leadingComments;
      }
      ts3.getSyntheticLeadingComments = getSyntheticLeadingComments;
      function setSyntheticLeadingComments(node, comments) {
        getOrCreateEmitNode(node).leadingComments = comments;
        return node;
      }
      ts3.setSyntheticLeadingComments = setSyntheticLeadingComments;
      function addSyntheticLeadingComment(node, kind, text, hasTrailingNewLine) {
        return setSyntheticLeadingComments(node, ts3.append(getSyntheticLeadingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
      }
      ts3.addSyntheticLeadingComment = addSyntheticLeadingComment;
      function getSyntheticTrailingComments(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.trailingComments;
      }
      ts3.getSyntheticTrailingComments = getSyntheticTrailingComments;
      function setSyntheticTrailingComments(node, comments) {
        getOrCreateEmitNode(node).trailingComments = comments;
        return node;
      }
      ts3.setSyntheticTrailingComments = setSyntheticTrailingComments;
      function addSyntheticTrailingComment(node, kind, text, hasTrailingNewLine) {
        return setSyntheticTrailingComments(node, ts3.append(getSyntheticTrailingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
      }
      ts3.addSyntheticTrailingComment = addSyntheticTrailingComment;
      function moveSyntheticComments(node, original) {
        setSyntheticLeadingComments(node, getSyntheticLeadingComments(original));
        setSyntheticTrailingComments(node, getSyntheticTrailingComments(original));
        var emit = getOrCreateEmitNode(original);
        emit.leadingComments = void 0;
        emit.trailingComments = void 0;
        return node;
      }
      ts3.moveSyntheticComments = moveSyntheticComments;
      function getConstantValue(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.constantValue;
      }
      ts3.getConstantValue = getConstantValue;
      function setConstantValue(node, value) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.constantValue = value;
        return node;
      }
      ts3.setConstantValue = setConstantValue;
      function addEmitHelper(node, helper) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.helpers = ts3.append(emitNode.helpers, helper);
        return node;
      }
      ts3.addEmitHelper = addEmitHelper;
      function addEmitHelpers(node, helpers) {
        if (ts3.some(helpers)) {
          var emitNode = getOrCreateEmitNode(node);
          for (var _i = 0, helpers_2 = helpers; _i < helpers_2.length; _i++) {
            var helper = helpers_2[_i];
            emitNode.helpers = ts3.appendIfUnique(emitNode.helpers, helper);
          }
        }
        return node;
      }
      ts3.addEmitHelpers = addEmitHelpers;
      function removeEmitHelper(node, helper) {
        var _a;
        var helpers = (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.helpers;
        if (helpers) {
          return ts3.orderedRemoveItem(helpers, helper);
        }
        return false;
      }
      ts3.removeEmitHelper = removeEmitHelper;
      function getEmitHelpers(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.helpers;
      }
      ts3.getEmitHelpers = getEmitHelpers;
      function moveEmitHelpers(source, target, predicate) {
        var sourceEmitNode = source.emitNode;
        var sourceEmitHelpers = sourceEmitNode && sourceEmitNode.helpers;
        if (!ts3.some(sourceEmitHelpers))
          return;
        var targetEmitNode = getOrCreateEmitNode(target);
        var helpersRemoved = 0;
        for (var i = 0; i < sourceEmitHelpers.length; i++) {
          var helper = sourceEmitHelpers[i];
          if (predicate(helper)) {
            helpersRemoved++;
            targetEmitNode.helpers = ts3.appendIfUnique(targetEmitNode.helpers, helper);
          } else if (helpersRemoved > 0) {
            sourceEmitHelpers[i - helpersRemoved] = helper;
          }
        }
        if (helpersRemoved > 0) {
          sourceEmitHelpers.length -= helpersRemoved;
        }
      }
      ts3.moveEmitHelpers = moveEmitHelpers;
      function getSnippetElement(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.snippetElement;
      }
      ts3.getSnippetElement = getSnippetElement;
      function setSnippetElement(node, snippet2) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.snippetElement = snippet2;
        return node;
      }
      ts3.setSnippetElement = setSnippetElement;
      function ignoreSourceNewlines(node) {
        getOrCreateEmitNode(node).flags |= 134217728;
        return node;
      }
      ts3.ignoreSourceNewlines = ignoreSourceNewlines;
      function setTypeNode(node, type2) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.typeNode = type2;
        return node;
      }
      ts3.setTypeNode = setTypeNode;
      function getTypeNode(node) {
        var _a;
        return (_a = node.emitNode) === null || _a === void 0 ? void 0 : _a.typeNode;
      }
      ts3.getTypeNode = getTypeNode;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createEmitHelperFactory(context) {
        var factory = context.factory;
        var immutableTrue = ts3.memoize(function() {
          return ts3.setEmitFlags(factory.createTrue(), 268435456);
        });
        var immutableFalse = ts3.memoize(function() {
          return ts3.setEmitFlags(factory.createFalse(), 268435456);
        });
        return {
          getUnscopedHelperName,
          createDecorateHelper,
          createMetadataHelper,
          createParamHelper,
          createAssignHelper,
          createAwaitHelper,
          createAsyncGeneratorHelper,
          createAsyncDelegatorHelper,
          createAsyncValuesHelper,
          createRestHelper,
          createAwaiterHelper,
          createExtendsHelper,
          createTemplateObjectHelper,
          createSpreadArrayHelper,
          createValuesHelper,
          createReadHelper,
          createGeneratorHelper,
          createCreateBindingHelper,
          createImportStarHelper,
          createImportStarCallbackHelper,
          createImportDefaultHelper,
          createExportStarHelper,
          createClassPrivateFieldGetHelper,
          createClassPrivateFieldSetHelper,
          createClassPrivateFieldInHelper
        };
        function getUnscopedHelperName(name) {
          return ts3.setEmitFlags(factory.createIdentifier(name), 4096 | 2);
        }
        function createDecorateHelper(decoratorExpressions, target, memberName, descriptor) {
          context.requestEmitHelper(ts3.decorateHelper);
          var argumentsArray = [];
          argumentsArray.push(factory.createArrayLiteralExpression(decoratorExpressions, true));
          argumentsArray.push(target);
          if (memberName) {
            argumentsArray.push(memberName);
            if (descriptor) {
              argumentsArray.push(descriptor);
            }
          }
          return factory.createCallExpression(getUnscopedHelperName("__decorate"), void 0, argumentsArray);
        }
        function createMetadataHelper(metadataKey, metadataValue) {
          context.requestEmitHelper(ts3.metadataHelper);
          return factory.createCallExpression(getUnscopedHelperName("__metadata"), void 0, [
            factory.createStringLiteral(metadataKey),
            metadataValue
          ]);
        }
        function createParamHelper(expression, parameterOffset, location) {
          context.requestEmitHelper(ts3.paramHelper);
          return ts3.setTextRange(factory.createCallExpression(getUnscopedHelperName("__param"), void 0, [
            factory.createNumericLiteral(parameterOffset + ""),
            expression
          ]), location);
        }
        function createAssignHelper(attributesSegments) {
          if (ts3.getEmitScriptTarget(context.getCompilerOptions()) >= 2) {
            return factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "assign"), void 0, attributesSegments);
          }
          context.requestEmitHelper(ts3.assignHelper);
          return factory.createCallExpression(getUnscopedHelperName("__assign"), void 0, attributesSegments);
        }
        function createAwaitHelper(expression) {
          context.requestEmitHelper(ts3.awaitHelper);
          return factory.createCallExpression(getUnscopedHelperName("__await"), void 0, [expression]);
        }
        function createAsyncGeneratorHelper(generatorFunc, hasLexicalThis) {
          context.requestEmitHelper(ts3.awaitHelper);
          context.requestEmitHelper(ts3.asyncGeneratorHelper);
          (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 262144 | 524288;
          return factory.createCallExpression(getUnscopedHelperName("__asyncGenerator"), void 0, [
            hasLexicalThis ? factory.createThis() : factory.createVoidZero(),
            factory.createIdentifier("arguments"),
            generatorFunc
          ]);
        }
        function createAsyncDelegatorHelper(expression) {
          context.requestEmitHelper(ts3.awaitHelper);
          context.requestEmitHelper(ts3.asyncDelegator);
          return factory.createCallExpression(getUnscopedHelperName("__asyncDelegator"), void 0, [expression]);
        }
        function createAsyncValuesHelper(expression) {
          context.requestEmitHelper(ts3.asyncValues);
          return factory.createCallExpression(getUnscopedHelperName("__asyncValues"), void 0, [expression]);
        }
        function createRestHelper(value, elements, computedTempVariables, location) {
          context.requestEmitHelper(ts3.restHelper);
          var propertyNames = [];
          var computedTempVariableOffset = 0;
          for (var i = 0; i < elements.length - 1; i++) {
            var propertyName = ts3.getPropertyNameOfBindingOrAssignmentElement(elements[i]);
            if (propertyName) {
              if (ts3.isComputedPropertyName(propertyName)) {
                ts3.Debug.assertIsDefined(computedTempVariables, "Encountered computed property name but 'computedTempVariables' argument was not provided.");
                var temp = computedTempVariables[computedTempVariableOffset];
                computedTempVariableOffset++;
                propertyNames.push(factory.createConditionalExpression(factory.createTypeCheck(temp, "symbol"), void 0, temp, void 0, factory.createAdd(temp, factory.createStringLiteral(""))));
              } else {
                propertyNames.push(factory.createStringLiteralFromNode(propertyName));
              }
            }
          }
          return factory.createCallExpression(getUnscopedHelperName("__rest"), void 0, [
            value,
            ts3.setTextRange(factory.createArrayLiteralExpression(propertyNames), location)
          ]);
        }
        function createAwaiterHelper(hasLexicalThis, hasLexicalArguments, promiseConstructor, body) {
          context.requestEmitHelper(ts3.awaiterHelper);
          var generatorFunc = factory.createFunctionExpression(void 0, factory.createToken(41), void 0, void 0, [], void 0, body);
          (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 262144 | 524288;
          return factory.createCallExpression(getUnscopedHelperName("__awaiter"), void 0, [
            hasLexicalThis ? factory.createThis() : factory.createVoidZero(),
            hasLexicalArguments ? factory.createIdentifier("arguments") : factory.createVoidZero(),
            promiseConstructor ? ts3.createExpressionFromEntityName(factory, promiseConstructor) : factory.createVoidZero(),
            generatorFunc
          ]);
        }
        function createExtendsHelper(name) {
          context.requestEmitHelper(ts3.extendsHelper);
          return factory.createCallExpression(getUnscopedHelperName("__extends"), void 0, [name, factory.createUniqueName("_super", 16 | 32)]);
        }
        function createTemplateObjectHelper(cooked, raw) {
          context.requestEmitHelper(ts3.templateObjectHelper);
          return factory.createCallExpression(getUnscopedHelperName("__makeTemplateObject"), void 0, [cooked, raw]);
        }
        function createSpreadArrayHelper(to, from, packFrom) {
          context.requestEmitHelper(ts3.spreadArrayHelper);
          return factory.createCallExpression(getUnscopedHelperName("__spreadArray"), void 0, [to, from, packFrom ? immutableTrue() : immutableFalse()]);
        }
        function createValuesHelper(expression) {
          context.requestEmitHelper(ts3.valuesHelper);
          return factory.createCallExpression(getUnscopedHelperName("__values"), void 0, [expression]);
        }
        function createReadHelper(iteratorRecord, count) {
          context.requestEmitHelper(ts3.readHelper);
          return factory.createCallExpression(getUnscopedHelperName("__read"), void 0, count !== void 0 ? [iteratorRecord, factory.createNumericLiteral(count + "")] : [iteratorRecord]);
        }
        function createGeneratorHelper(body) {
          context.requestEmitHelper(ts3.generatorHelper);
          return factory.createCallExpression(getUnscopedHelperName("__generator"), void 0, [factory.createThis(), body]);
        }
        function createCreateBindingHelper(module3, inputName, outputName) {
          context.requestEmitHelper(ts3.createBindingHelper);
          return factory.createCallExpression(getUnscopedHelperName("__createBinding"), void 0, __spreadArray([factory.createIdentifier("exports"), module3, inputName], outputName ? [outputName] : [], true));
        }
        function createImportStarHelper(expression) {
          context.requestEmitHelper(ts3.importStarHelper);
          return factory.createCallExpression(getUnscopedHelperName("__importStar"), void 0, [expression]);
        }
        function createImportStarCallbackHelper() {
          context.requestEmitHelper(ts3.importStarHelper);
          return getUnscopedHelperName("__importStar");
        }
        function createImportDefaultHelper(expression) {
          context.requestEmitHelper(ts3.importDefaultHelper);
          return factory.createCallExpression(getUnscopedHelperName("__importDefault"), void 0, [expression]);
        }
        function createExportStarHelper(moduleExpression, exportsExpression) {
          if (exportsExpression === void 0) {
            exportsExpression = factory.createIdentifier("exports");
          }
          context.requestEmitHelper(ts3.exportStarHelper);
          context.requestEmitHelper(ts3.createBindingHelper);
          return factory.createCallExpression(getUnscopedHelperName("__exportStar"), void 0, [moduleExpression, exportsExpression]);
        }
        function createClassPrivateFieldGetHelper(receiver, state, kind, f) {
          context.requestEmitHelper(ts3.classPrivateFieldGetHelper);
          var args;
          if (!f) {
            args = [receiver, state, factory.createStringLiteral(kind)];
          } else {
            args = [receiver, state, factory.createStringLiteral(kind), f];
          }
          return factory.createCallExpression(getUnscopedHelperName("__classPrivateFieldGet"), void 0, args);
        }
        function createClassPrivateFieldSetHelper(receiver, state, value, kind, f) {
          context.requestEmitHelper(ts3.classPrivateFieldSetHelper);
          var args;
          if (!f) {
            args = [receiver, state, value, factory.createStringLiteral(kind)];
          } else {
            args = [receiver, state, value, factory.createStringLiteral(kind), f];
          }
          return factory.createCallExpression(getUnscopedHelperName("__classPrivateFieldSet"), void 0, args);
        }
        function createClassPrivateFieldInHelper(state, receiver) {
          context.requestEmitHelper(ts3.classPrivateFieldInHelper);
          return factory.createCallExpression(getUnscopedHelperName("__classPrivateFieldIn"), void 0, [state, receiver]);
        }
      }
      ts3.createEmitHelperFactory = createEmitHelperFactory;
      function compareEmitHelpers(x, y) {
        if (x === y)
          return 0;
        if (x.priority === y.priority)
          return 0;
        if (x.priority === void 0)
          return 1;
        if (y.priority === void 0)
          return -1;
        return ts3.compareValues(x.priority, y.priority);
      }
      ts3.compareEmitHelpers = compareEmitHelpers;
      function helperString(input) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          args[_i - 1] = arguments[_i];
        }
        return function(uniqueName) {
          var result2 = "";
          for (var i = 0; i < args.length; i++) {
            result2 += input[i];
            result2 += uniqueName(args[i]);
          }
          result2 += input[input.length - 1];
          return result2;
        };
      }
      ts3.helperString = helperString;
      ts3.decorateHelper = {
        name: "typescript:decorate",
        importName: "__decorate",
        scoped: false,
        priority: 2,
        text: '\n            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {\n                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\n                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);\n                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\n                return c > 3 && r && Object.defineProperty(target, key, r), r;\n            };'
      };
      ts3.metadataHelper = {
        name: "typescript:metadata",
        importName: "__metadata",
        scoped: false,
        priority: 3,
        text: '\n            var __metadata = (this && this.__metadata) || function (k, v) {\n                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);\n            };'
      };
      ts3.paramHelper = {
        name: "typescript:param",
        importName: "__param",
        scoped: false,
        priority: 4,
        text: "\n            var __param = (this && this.__param) || function (paramIndex, decorator) {\n                return function (target, key) { decorator(target, key, paramIndex); }\n            };"
      };
      ts3.assignHelper = {
        name: "typescript:assign",
        importName: "__assign",
        scoped: false,
        priority: 1,
        text: "\n            var __assign = (this && this.__assign) || function () {\n                __assign = Object.assign || function(t) {\n                    for (var s, i = 1, n = arguments.length; i < n; i++) {\n                        s = arguments[i];\n                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))\n                            t[p] = s[p];\n                    }\n                    return t;\n                };\n                return __assign.apply(this, arguments);\n            };"
      };
      ts3.awaitHelper = {
        name: "typescript:await",
        importName: "__await",
        scoped: false,
        text: "\n            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }"
      };
      ts3.asyncGeneratorHelper = {
        name: "typescript:asyncGenerator",
        importName: "__asyncGenerator",
        scoped: false,
        dependencies: [ts3.awaitHelper],
        text: '\n            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var g = generator.apply(thisArg, _arguments || []), i, q = [];\n                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;\n                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }\n                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }\n                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }\n                function fulfill(value) { resume("next", value); }\n                function reject(value) { resume("throw", value); }\n                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }\n            };'
      };
      ts3.asyncDelegator = {
        name: "typescript:asyncDelegator",
        importName: "__asyncDelegator",
        scoped: false,
        dependencies: [ts3.awaitHelper],
        text: '\n            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {\n                var i, p;\n                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;\n                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }\n            };'
      };
      ts3.asyncValues = {
        name: "typescript:asyncValues",
        importName: "__asyncValues",
        scoped: false,
        text: '\n            var __asyncValues = (this && this.__asyncValues) || function (o) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var m = o[Symbol.asyncIterator], i;\n                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);\n                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }\n                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }\n            };'
      };
      ts3.restHelper = {
        name: "typescript:rest",
        importName: "__rest",
        scoped: false,
        text: '\n            var __rest = (this && this.__rest) || function (s, e) {\n                var t = {};\n                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)\n                    t[p] = s[p];\n                if (s != null && typeof Object.getOwnPropertySymbols === "function")\n                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {\n                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))\n                            t[p[i]] = s[p[i]];\n                    }\n                return t;\n            };'
      };
      ts3.awaiterHelper = {
        name: "typescript:awaiter",
        importName: "__awaiter",
        scoped: false,
        priority: 5,
        text: '\n            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {\n                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }\n                return new (P || (P = Promise))(function (resolve, reject) {\n                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }\n                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }\n                    step((generator = generator.apply(thisArg, _arguments || [])).next());\n                });\n            };'
      };
      ts3.extendsHelper = {
        name: "typescript:extends",
        importName: "__extends",
        scoped: false,
        priority: 0,
        text: '\n            var __extends = (this && this.__extends) || (function () {\n                var extendStatics = function (d, b) {\n                    extendStatics = Object.setPrototypeOf ||\n                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||\n                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };\n                    return extendStatics(d, b);\n                };\n\n                return function (d, b) {\n                    if (typeof b !== "function" && b !== null)\n                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");\n                    extendStatics(d, b);\n                    function __() { this.constructor = d; }\n                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\n                };\n            })();'
      };
      ts3.templateObjectHelper = {
        name: "typescript:makeTemplateObject",
        importName: "__makeTemplateObject",
        scoped: false,
        priority: 0,
        text: '\n            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {\n                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }\n                return cooked;\n            };'
      };
      ts3.readHelper = {
        name: "typescript:read",
        importName: "__read",
        scoped: false,
        text: '\n            var __read = (this && this.__read) || function (o, n) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator];\n                if (!m) return o;\n                var i = m.call(o), r, ar = [], e;\n                try {\n                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\n                }\n                catch (error) { e = { error: error }; }\n                finally {\n                    try {\n                        if (r && !r.done && (m = i["return"])) m.call(i);\n                    }\n                    finally { if (e) throw e.error; }\n                }\n                return ar;\n            };'
      };
      ts3.spreadArrayHelper = {
        name: "typescript:spreadArray",
        importName: "__spreadArray",
        scoped: false,
        text: "\n            var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {\n                if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {\n                    if (ar || !(i in from)) {\n                        if (!ar) ar = Array.prototype.slice.call(from, 0, i);\n                        ar[i] = from[i];\n                    }\n                }\n                return to.concat(ar || Array.prototype.slice.call(from));\n            };"
      };
      ts3.valuesHelper = {
        name: "typescript:values",
        importName: "__values",
        scoped: false,
        text: '\n            var __values = (this && this.__values) || function(o) {\n                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;\n                if (m) return m.call(o);\n                if (o && typeof o.length === "number") return {\n                    next: function () {\n                        if (o && i >= o.length) o = void 0;\n                        return { value: o && o[i++], done: !o };\n                    }\n                };\n                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");\n            };'
      };
      ts3.generatorHelper = {
        name: "typescript:generator",
        importName: "__generator",
        scoped: false,
        priority: 6,
        text: '\n            var __generator = (this && this.__generator) || function (thisArg, body) {\n                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;\n                function verb(n) { return function (v) { return step([n, v]); }; }\n                function step(op) {\n                    if (f) throw new TypeError("Generator is already executing.");\n                    while (_) try {\n                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\n                        if (y = 0, t) op = [op[0] & 2, t.value];\n                        switch (op[0]) {\n                            case 0: case 1: t = op; break;\n                            case 4: _.label++; return { value: op[1], done: false };\n                            case 5: _.label++; y = op[1]; op = [0]; continue;\n                            case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                            default:\n                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                                if (t[2]) _.ops.pop();\n                                _.trys.pop(); continue;\n                        }\n                        op = body.call(thisArg, _);\n                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n                }\n            };'
      };
      ts3.createBindingHelper = {
        name: "typescript:commonjscreatebinding",
        importName: "__createBinding",
        scoped: false,
        priority: 1,
        text: '\n            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {\n                if (k2 === undefined) k2 = k;\n                var desc = Object.getOwnPropertyDescriptor(m, k);\n                if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {\n                  desc = { enumerable: true, get: function() { return m[k]; } };\n                }\n                Object.defineProperty(o, k2, desc);\n            }) : (function(o, m, k, k2) {\n                if (k2 === undefined) k2 = k;\n                o[k2] = m[k];\n            }));'
      };
      ts3.setModuleDefaultHelper = {
        name: "typescript:commonjscreatevalue",
        importName: "__setModuleDefault",
        scoped: false,
        priority: 1,
        text: '\n            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {\n                Object.defineProperty(o, "default", { enumerable: true, value: v });\n            }) : function(o, v) {\n                o["default"] = v;\n            });'
      };
      ts3.importStarHelper = {
        name: "typescript:commonjsimportstar",
        importName: "__importStar",
        scoped: false,
        dependencies: [ts3.createBindingHelper, ts3.setModuleDefaultHelper],
        priority: 2,
        text: '\n            var __importStar = (this && this.__importStar) || function (mod) {\n                if (mod && mod.__esModule) return mod;\n                var result = {};\n                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);\n                __setModuleDefault(result, mod);\n                return result;\n            };'
      };
      ts3.importDefaultHelper = {
        name: "typescript:commonjsimportdefault",
        importName: "__importDefault",
        scoped: false,
        text: '\n            var __importDefault = (this && this.__importDefault) || function (mod) {\n                return (mod && mod.__esModule) ? mod : { "default": mod };\n            };'
      };
      ts3.exportStarHelper = {
        name: "typescript:export-star",
        importName: "__exportStar",
        scoped: false,
        dependencies: [ts3.createBindingHelper],
        priority: 2,
        text: '\n            var __exportStar = (this && this.__exportStar) || function(m, exports) {\n                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);\n            };'
      };
      ts3.classPrivateFieldGetHelper = {
        name: "typescript:classPrivateFieldGet",
        importName: "__classPrivateFieldGet",
        scoped: false,
        text: '\n            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {\n                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");\n                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");\n                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);\n            };'
      };
      ts3.classPrivateFieldSetHelper = {
        name: "typescript:classPrivateFieldSet",
        importName: "__classPrivateFieldSet",
        scoped: false,
        text: '\n            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {\n                if (kind === "m") throw new TypeError("Private method is not writable");\n                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");\n                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");\n                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;\n            };'
      };
      ts3.classPrivateFieldInHelper = {
        name: "typescript:classPrivateFieldIn",
        importName: "__classPrivateFieldIn",
        scoped: false,
        text: `
            var __classPrivateFieldIn = (this && this.__classPrivateFieldIn) || function(state, receiver) {
                if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
                return typeof state === "function" ? receiver === state : state.has(receiver);
            };`
      };
      var allUnscopedEmitHelpers;
      function getAllUnscopedEmitHelpers() {
        return allUnscopedEmitHelpers || (allUnscopedEmitHelpers = ts3.arrayToMap([
          ts3.decorateHelper,
          ts3.metadataHelper,
          ts3.paramHelper,
          ts3.assignHelper,
          ts3.awaitHelper,
          ts3.asyncGeneratorHelper,
          ts3.asyncDelegator,
          ts3.asyncValues,
          ts3.restHelper,
          ts3.awaiterHelper,
          ts3.extendsHelper,
          ts3.templateObjectHelper,
          ts3.spreadArrayHelper,
          ts3.valuesHelper,
          ts3.readHelper,
          ts3.generatorHelper,
          ts3.importStarHelper,
          ts3.importDefaultHelper,
          ts3.exportStarHelper,
          ts3.classPrivateFieldGetHelper,
          ts3.classPrivateFieldSetHelper,
          ts3.classPrivateFieldInHelper,
          ts3.createBindingHelper,
          ts3.setModuleDefaultHelper
        ], function(helper) {
          return helper.name;
        }));
      }
      ts3.getAllUnscopedEmitHelpers = getAllUnscopedEmitHelpers;
      ts3.asyncSuperHelper = {
        name: "typescript:async-super",
        scoped: true,
        text: helperString(__makeTemplateObject(["\n            const ", " = name => super[name];"], ["\n            const ", " = name => super[name];"]), "_superIndex")
      };
      ts3.advancedAsyncSuperHelper = {
        name: "typescript:advanced-async-super",
        scoped: true,
        text: helperString(__makeTemplateObject(["\n            const ", " = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"], ["\n            const ", " = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"]), "_superIndex")
      };
      function isCallToHelper(firstSegment, helperName) {
        return ts3.isCallExpression(firstSegment) && ts3.isIdentifier(firstSegment.expression) && (ts3.getEmitFlags(firstSegment.expression) & 4096) !== 0 && firstSegment.expression.escapedText === helperName;
      }
      ts3.isCallToHelper = isCallToHelper;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function isNumericLiteral(node) {
        return node.kind === 8;
      }
      ts3.isNumericLiteral = isNumericLiteral;
      function isBigIntLiteral(node) {
        return node.kind === 9;
      }
      ts3.isBigIntLiteral = isBigIntLiteral;
      function isStringLiteral(node) {
        return node.kind === 10;
      }
      ts3.isStringLiteral = isStringLiteral;
      function isJsxText(node) {
        return node.kind === 11;
      }
      ts3.isJsxText = isJsxText;
      function isRegularExpressionLiteral(node) {
        return node.kind === 13;
      }
      ts3.isRegularExpressionLiteral = isRegularExpressionLiteral;
      function isNoSubstitutionTemplateLiteral(node) {
        return node.kind === 14;
      }
      ts3.isNoSubstitutionTemplateLiteral = isNoSubstitutionTemplateLiteral;
      function isTemplateHead(node) {
        return node.kind === 15;
      }
      ts3.isTemplateHead = isTemplateHead;
      function isTemplateMiddle(node) {
        return node.kind === 16;
      }
      ts3.isTemplateMiddle = isTemplateMiddle;
      function isTemplateTail(node) {
        return node.kind === 17;
      }
      ts3.isTemplateTail = isTemplateTail;
      function isDotDotDotToken(node) {
        return node.kind === 25;
      }
      ts3.isDotDotDotToken = isDotDotDotToken;
      function isCommaToken(node) {
        return node.kind === 27;
      }
      ts3.isCommaToken = isCommaToken;
      function isPlusToken(node) {
        return node.kind === 39;
      }
      ts3.isPlusToken = isPlusToken;
      function isMinusToken(node) {
        return node.kind === 40;
      }
      ts3.isMinusToken = isMinusToken;
      function isAsteriskToken(node) {
        return node.kind === 41;
      }
      ts3.isAsteriskToken = isAsteriskToken;
      function isExclamationToken(node) {
        return node.kind === 53;
      }
      ts3.isExclamationToken = isExclamationToken;
      function isQuestionToken(node) {
        return node.kind === 57;
      }
      ts3.isQuestionToken = isQuestionToken;
      function isColonToken(node) {
        return node.kind === 58;
      }
      ts3.isColonToken = isColonToken;
      function isQuestionDotToken(node) {
        return node.kind === 28;
      }
      ts3.isQuestionDotToken = isQuestionDotToken;
      function isEqualsGreaterThanToken(node) {
        return node.kind === 38;
      }
      ts3.isEqualsGreaterThanToken = isEqualsGreaterThanToken;
      function isIdentifier(node) {
        return node.kind === 79;
      }
      ts3.isIdentifier = isIdentifier;
      function isPrivateIdentifier(node) {
        return node.kind === 80;
      }
      ts3.isPrivateIdentifier = isPrivateIdentifier;
      function isExportModifier(node) {
        return node.kind === 93;
      }
      ts3.isExportModifier = isExportModifier;
      function isAsyncModifier(node) {
        return node.kind === 131;
      }
      ts3.isAsyncModifier = isAsyncModifier;
      function isAssertsKeyword(node) {
        return node.kind === 128;
      }
      ts3.isAssertsKeyword = isAssertsKeyword;
      function isAwaitKeyword(node) {
        return node.kind === 132;
      }
      ts3.isAwaitKeyword = isAwaitKeyword;
      function isReadonlyKeyword(node) {
        return node.kind === 145;
      }
      ts3.isReadonlyKeyword = isReadonlyKeyword;
      function isStaticModifier(node) {
        return node.kind === 124;
      }
      ts3.isStaticModifier = isStaticModifier;
      function isAbstractModifier(node) {
        return node.kind === 126;
      }
      ts3.isAbstractModifier = isAbstractModifier;
      function isSuperKeyword(node) {
        return node.kind === 106;
      }
      ts3.isSuperKeyword = isSuperKeyword;
      function isImportKeyword(node) {
        return node.kind === 100;
      }
      ts3.isImportKeyword = isImportKeyword;
      function isQualifiedName(node) {
        return node.kind === 161;
      }
      ts3.isQualifiedName = isQualifiedName;
      function isComputedPropertyName(node) {
        return node.kind === 162;
      }
      ts3.isComputedPropertyName = isComputedPropertyName;
      function isTypeParameterDeclaration(node) {
        return node.kind === 163;
      }
      ts3.isTypeParameterDeclaration = isTypeParameterDeclaration;
      function isParameter(node) {
        return node.kind === 164;
      }
      ts3.isParameter = isParameter;
      function isDecorator(node) {
        return node.kind === 165;
      }
      ts3.isDecorator = isDecorator;
      function isPropertySignature(node) {
        return node.kind === 166;
      }
      ts3.isPropertySignature = isPropertySignature;
      function isPropertyDeclaration(node) {
        return node.kind === 167;
      }
      ts3.isPropertyDeclaration = isPropertyDeclaration;
      function isMethodSignature(node) {
        return node.kind === 168;
      }
      ts3.isMethodSignature = isMethodSignature;
      function isMethodDeclaration(node) {
        return node.kind === 169;
      }
      ts3.isMethodDeclaration = isMethodDeclaration;
      function isClassStaticBlockDeclaration(node) {
        return node.kind === 170;
      }
      ts3.isClassStaticBlockDeclaration = isClassStaticBlockDeclaration;
      function isConstructorDeclaration(node) {
        return node.kind === 171;
      }
      ts3.isConstructorDeclaration = isConstructorDeclaration;
      function isGetAccessorDeclaration(node) {
        return node.kind === 172;
      }
      ts3.isGetAccessorDeclaration = isGetAccessorDeclaration;
      function isSetAccessorDeclaration(node) {
        return node.kind === 173;
      }
      ts3.isSetAccessorDeclaration = isSetAccessorDeclaration;
      function isCallSignatureDeclaration(node) {
        return node.kind === 174;
      }
      ts3.isCallSignatureDeclaration = isCallSignatureDeclaration;
      function isConstructSignatureDeclaration(node) {
        return node.kind === 175;
      }
      ts3.isConstructSignatureDeclaration = isConstructSignatureDeclaration;
      function isIndexSignatureDeclaration(node) {
        return node.kind === 176;
      }
      ts3.isIndexSignatureDeclaration = isIndexSignatureDeclaration;
      function isTypePredicateNode(node) {
        return node.kind === 177;
      }
      ts3.isTypePredicateNode = isTypePredicateNode;
      function isTypeReferenceNode(node) {
        return node.kind === 178;
      }
      ts3.isTypeReferenceNode = isTypeReferenceNode;
      function isFunctionTypeNode(node) {
        return node.kind === 179;
      }
      ts3.isFunctionTypeNode = isFunctionTypeNode;
      function isConstructorTypeNode(node) {
        return node.kind === 180;
      }
      ts3.isConstructorTypeNode = isConstructorTypeNode;
      function isTypeQueryNode(node) {
        return node.kind === 181;
      }
      ts3.isTypeQueryNode = isTypeQueryNode;
      function isTypeLiteralNode(node) {
        return node.kind === 182;
      }
      ts3.isTypeLiteralNode = isTypeLiteralNode;
      function isArrayTypeNode(node) {
        return node.kind === 183;
      }
      ts3.isArrayTypeNode = isArrayTypeNode;
      function isTupleTypeNode(node) {
        return node.kind === 184;
      }
      ts3.isTupleTypeNode = isTupleTypeNode;
      function isNamedTupleMember(node) {
        return node.kind === 197;
      }
      ts3.isNamedTupleMember = isNamedTupleMember;
      function isOptionalTypeNode(node) {
        return node.kind === 185;
      }
      ts3.isOptionalTypeNode = isOptionalTypeNode;
      function isRestTypeNode(node) {
        return node.kind === 186;
      }
      ts3.isRestTypeNode = isRestTypeNode;
      function isUnionTypeNode(node) {
        return node.kind === 187;
      }
      ts3.isUnionTypeNode = isUnionTypeNode;
      function isIntersectionTypeNode(node) {
        return node.kind === 188;
      }
      ts3.isIntersectionTypeNode = isIntersectionTypeNode;
      function isConditionalTypeNode(node) {
        return node.kind === 189;
      }
      ts3.isConditionalTypeNode = isConditionalTypeNode;
      function isInferTypeNode(node) {
        return node.kind === 190;
      }
      ts3.isInferTypeNode = isInferTypeNode;
      function isParenthesizedTypeNode(node) {
        return node.kind === 191;
      }
      ts3.isParenthesizedTypeNode = isParenthesizedTypeNode;
      function isThisTypeNode(node) {
        return node.kind === 192;
      }
      ts3.isThisTypeNode = isThisTypeNode;
      function isTypeOperatorNode(node) {
        return node.kind === 193;
      }
      ts3.isTypeOperatorNode = isTypeOperatorNode;
      function isIndexedAccessTypeNode(node) {
        return node.kind === 194;
      }
      ts3.isIndexedAccessTypeNode = isIndexedAccessTypeNode;
      function isMappedTypeNode(node) {
        return node.kind === 195;
      }
      ts3.isMappedTypeNode = isMappedTypeNode;
      function isLiteralTypeNode(node) {
        return node.kind === 196;
      }
      ts3.isLiteralTypeNode = isLiteralTypeNode;
      function isImportTypeNode(node) {
        return node.kind === 200;
      }
      ts3.isImportTypeNode = isImportTypeNode;
      function isTemplateLiteralTypeSpan(node) {
        return node.kind === 199;
      }
      ts3.isTemplateLiteralTypeSpan = isTemplateLiteralTypeSpan;
      function isTemplateLiteralTypeNode(node) {
        return node.kind === 198;
      }
      ts3.isTemplateLiteralTypeNode = isTemplateLiteralTypeNode;
      function isObjectBindingPattern(node) {
        return node.kind === 201;
      }
      ts3.isObjectBindingPattern = isObjectBindingPattern;
      function isArrayBindingPattern(node) {
        return node.kind === 202;
      }
      ts3.isArrayBindingPattern = isArrayBindingPattern;
      function isBindingElement(node) {
        return node.kind === 203;
      }
      ts3.isBindingElement = isBindingElement;
      function isArrayLiteralExpression(node) {
        return node.kind === 204;
      }
      ts3.isArrayLiteralExpression = isArrayLiteralExpression;
      function isObjectLiteralExpression(node) {
        return node.kind === 205;
      }
      ts3.isObjectLiteralExpression = isObjectLiteralExpression;
      function isPropertyAccessExpression(node) {
        return node.kind === 206;
      }
      ts3.isPropertyAccessExpression = isPropertyAccessExpression;
      function isElementAccessExpression(node) {
        return node.kind === 207;
      }
      ts3.isElementAccessExpression = isElementAccessExpression;
      function isCallExpression(node) {
        return node.kind === 208;
      }
      ts3.isCallExpression = isCallExpression;
      function isNewExpression(node) {
        return node.kind === 209;
      }
      ts3.isNewExpression = isNewExpression;
      function isTaggedTemplateExpression(node) {
        return node.kind === 210;
      }
      ts3.isTaggedTemplateExpression = isTaggedTemplateExpression;
      function isTypeAssertionExpression(node) {
        return node.kind === 211;
      }
      ts3.isTypeAssertionExpression = isTypeAssertionExpression;
      function isParenthesizedExpression(node) {
        return node.kind === 212;
      }
      ts3.isParenthesizedExpression = isParenthesizedExpression;
      function isFunctionExpression(node) {
        return node.kind === 213;
      }
      ts3.isFunctionExpression = isFunctionExpression;
      function isArrowFunction(node) {
        return node.kind === 214;
      }
      ts3.isArrowFunction = isArrowFunction;
      function isDeleteExpression(node) {
        return node.kind === 215;
      }
      ts3.isDeleteExpression = isDeleteExpression;
      function isTypeOfExpression(node) {
        return node.kind === 216;
      }
      ts3.isTypeOfExpression = isTypeOfExpression;
      function isVoidExpression(node) {
        return node.kind === 217;
      }
      ts3.isVoidExpression = isVoidExpression;
      function isAwaitExpression(node) {
        return node.kind === 218;
      }
      ts3.isAwaitExpression = isAwaitExpression;
      function isPrefixUnaryExpression(node) {
        return node.kind === 219;
      }
      ts3.isPrefixUnaryExpression = isPrefixUnaryExpression;
      function isPostfixUnaryExpression(node) {
        return node.kind === 220;
      }
      ts3.isPostfixUnaryExpression = isPostfixUnaryExpression;
      function isBinaryExpression(node) {
        return node.kind === 221;
      }
      ts3.isBinaryExpression = isBinaryExpression;
      function isConditionalExpression(node) {
        return node.kind === 222;
      }
      ts3.isConditionalExpression = isConditionalExpression;
      function isTemplateExpression(node) {
        return node.kind === 223;
      }
      ts3.isTemplateExpression = isTemplateExpression;
      function isYieldExpression(node) {
        return node.kind === 224;
      }
      ts3.isYieldExpression = isYieldExpression;
      function isSpreadElement(node) {
        return node.kind === 225;
      }
      ts3.isSpreadElement = isSpreadElement;
      function isClassExpression(node) {
        return node.kind === 226;
      }
      ts3.isClassExpression = isClassExpression;
      function isOmittedExpression(node) {
        return node.kind === 227;
      }
      ts3.isOmittedExpression = isOmittedExpression;
      function isExpressionWithTypeArguments(node) {
        return node.kind === 228;
      }
      ts3.isExpressionWithTypeArguments = isExpressionWithTypeArguments;
      function isAsExpression(node) {
        return node.kind === 229;
      }
      ts3.isAsExpression = isAsExpression;
      function isNonNullExpression(node) {
        return node.kind === 230;
      }
      ts3.isNonNullExpression = isNonNullExpression;
      function isMetaProperty(node) {
        return node.kind === 231;
      }
      ts3.isMetaProperty = isMetaProperty;
      function isSyntheticExpression(node) {
        return node.kind === 232;
      }
      ts3.isSyntheticExpression = isSyntheticExpression;
      function isPartiallyEmittedExpression(node) {
        return node.kind === 350;
      }
      ts3.isPartiallyEmittedExpression = isPartiallyEmittedExpression;
      function isCommaListExpression(node) {
        return node.kind === 351;
      }
      ts3.isCommaListExpression = isCommaListExpression;
      function isTemplateSpan(node) {
        return node.kind === 233;
      }
      ts3.isTemplateSpan = isTemplateSpan;
      function isSemicolonClassElement(node) {
        return node.kind === 234;
      }
      ts3.isSemicolonClassElement = isSemicolonClassElement;
      function isBlock(node) {
        return node.kind === 235;
      }
      ts3.isBlock = isBlock;
      function isVariableStatement(node) {
        return node.kind === 237;
      }
      ts3.isVariableStatement = isVariableStatement;
      function isEmptyStatement(node) {
        return node.kind === 236;
      }
      ts3.isEmptyStatement = isEmptyStatement;
      function isExpressionStatement(node) {
        return node.kind === 238;
      }
      ts3.isExpressionStatement = isExpressionStatement;
      function isIfStatement(node) {
        return node.kind === 239;
      }
      ts3.isIfStatement = isIfStatement;
      function isDoStatement(node) {
        return node.kind === 240;
      }
      ts3.isDoStatement = isDoStatement;
      function isWhileStatement(node) {
        return node.kind === 241;
      }
      ts3.isWhileStatement = isWhileStatement;
      function isForStatement(node) {
        return node.kind === 242;
      }
      ts3.isForStatement = isForStatement;
      function isForInStatement(node) {
        return node.kind === 243;
      }
      ts3.isForInStatement = isForInStatement;
      function isForOfStatement(node) {
        return node.kind === 244;
      }
      ts3.isForOfStatement = isForOfStatement;
      function isContinueStatement(node) {
        return node.kind === 245;
      }
      ts3.isContinueStatement = isContinueStatement;
      function isBreakStatement(node) {
        return node.kind === 246;
      }
      ts3.isBreakStatement = isBreakStatement;
      function isReturnStatement(node) {
        return node.kind === 247;
      }
      ts3.isReturnStatement = isReturnStatement;
      function isWithStatement(node) {
        return node.kind === 248;
      }
      ts3.isWithStatement = isWithStatement;
      function isSwitchStatement(node) {
        return node.kind === 249;
      }
      ts3.isSwitchStatement = isSwitchStatement;
      function isLabeledStatement(node) {
        return node.kind === 250;
      }
      ts3.isLabeledStatement = isLabeledStatement;
      function isThrowStatement(node) {
        return node.kind === 251;
      }
      ts3.isThrowStatement = isThrowStatement;
      function isTryStatement(node) {
        return node.kind === 252;
      }
      ts3.isTryStatement = isTryStatement;
      function isDebuggerStatement(node) {
        return node.kind === 253;
      }
      ts3.isDebuggerStatement = isDebuggerStatement;
      function isVariableDeclaration(node) {
        return node.kind === 254;
      }
      ts3.isVariableDeclaration = isVariableDeclaration;
      function isVariableDeclarationList(node) {
        return node.kind === 255;
      }
      ts3.isVariableDeclarationList = isVariableDeclarationList;
      function isFunctionDeclaration(node) {
        return node.kind === 256;
      }
      ts3.isFunctionDeclaration = isFunctionDeclaration;
      function isClassDeclaration(node) {
        return node.kind === 257;
      }
      ts3.isClassDeclaration = isClassDeclaration;
      function isInterfaceDeclaration(node) {
        return node.kind === 258;
      }
      ts3.isInterfaceDeclaration = isInterfaceDeclaration;
      function isTypeAliasDeclaration(node) {
        return node.kind === 259;
      }
      ts3.isTypeAliasDeclaration = isTypeAliasDeclaration;
      function isEnumDeclaration(node) {
        return node.kind === 260;
      }
      ts3.isEnumDeclaration = isEnumDeclaration;
      function isModuleDeclaration(node) {
        return node.kind === 261;
      }
      ts3.isModuleDeclaration = isModuleDeclaration;
      function isModuleBlock(node) {
        return node.kind === 262;
      }
      ts3.isModuleBlock = isModuleBlock;
      function isCaseBlock(node) {
        return node.kind === 263;
      }
      ts3.isCaseBlock = isCaseBlock;
      function isNamespaceExportDeclaration(node) {
        return node.kind === 264;
      }
      ts3.isNamespaceExportDeclaration = isNamespaceExportDeclaration;
      function isImportEqualsDeclaration(node) {
        return node.kind === 265;
      }
      ts3.isImportEqualsDeclaration = isImportEqualsDeclaration;
      function isImportDeclaration(node) {
        return node.kind === 266;
      }
      ts3.isImportDeclaration = isImportDeclaration;
      function isImportClause(node) {
        return node.kind === 267;
      }
      ts3.isImportClause = isImportClause;
      function isImportTypeAssertionContainer(node) {
        return node.kind === 295;
      }
      ts3.isImportTypeAssertionContainer = isImportTypeAssertionContainer;
      function isAssertClause(node) {
        return node.kind === 293;
      }
      ts3.isAssertClause = isAssertClause;
      function isAssertEntry(node) {
        return node.kind === 294;
      }
      ts3.isAssertEntry = isAssertEntry;
      function isNamespaceImport(node) {
        return node.kind === 268;
      }
      ts3.isNamespaceImport = isNamespaceImport;
      function isNamespaceExport(node) {
        return node.kind === 274;
      }
      ts3.isNamespaceExport = isNamespaceExport;
      function isNamedImports(node) {
        return node.kind === 269;
      }
      ts3.isNamedImports = isNamedImports;
      function isImportSpecifier(node) {
        return node.kind === 270;
      }
      ts3.isImportSpecifier = isImportSpecifier;
      function isExportAssignment(node) {
        return node.kind === 271;
      }
      ts3.isExportAssignment = isExportAssignment;
      function isExportDeclaration(node) {
        return node.kind === 272;
      }
      ts3.isExportDeclaration = isExportDeclaration;
      function isNamedExports(node) {
        return node.kind === 273;
      }
      ts3.isNamedExports = isNamedExports;
      function isExportSpecifier(node) {
        return node.kind === 275;
      }
      ts3.isExportSpecifier = isExportSpecifier;
      function isMissingDeclaration(node) {
        return node.kind === 276;
      }
      ts3.isMissingDeclaration = isMissingDeclaration;
      function isNotEmittedStatement(node) {
        return node.kind === 349;
      }
      ts3.isNotEmittedStatement = isNotEmittedStatement;
      function isSyntheticReference(node) {
        return node.kind === 354;
      }
      ts3.isSyntheticReference = isSyntheticReference;
      function isMergeDeclarationMarker(node) {
        return node.kind === 352;
      }
      ts3.isMergeDeclarationMarker = isMergeDeclarationMarker;
      function isEndOfDeclarationMarker(node) {
        return node.kind === 353;
      }
      ts3.isEndOfDeclarationMarker = isEndOfDeclarationMarker;
      function isExternalModuleReference(node) {
        return node.kind === 277;
      }
      ts3.isExternalModuleReference = isExternalModuleReference;
      function isJsxElement(node) {
        return node.kind === 278;
      }
      ts3.isJsxElement = isJsxElement;
      function isJsxSelfClosingElement(node) {
        return node.kind === 279;
      }
      ts3.isJsxSelfClosingElement = isJsxSelfClosingElement;
      function isJsxOpeningElement(node) {
        return node.kind === 280;
      }
      ts3.isJsxOpeningElement = isJsxOpeningElement;
      function isJsxClosingElement(node) {
        return node.kind === 281;
      }
      ts3.isJsxClosingElement = isJsxClosingElement;
      function isJsxFragment(node) {
        return node.kind === 282;
      }
      ts3.isJsxFragment = isJsxFragment;
      function isJsxOpeningFragment(node) {
        return node.kind === 283;
      }
      ts3.isJsxOpeningFragment = isJsxOpeningFragment;
      function isJsxClosingFragment(node) {
        return node.kind === 284;
      }
      ts3.isJsxClosingFragment = isJsxClosingFragment;
      function isJsxAttribute(node) {
        return node.kind === 285;
      }
      ts3.isJsxAttribute = isJsxAttribute;
      function isJsxAttributes(node) {
        return node.kind === 286;
      }
      ts3.isJsxAttributes = isJsxAttributes;
      function isJsxSpreadAttribute(node) {
        return node.kind === 287;
      }
      ts3.isJsxSpreadAttribute = isJsxSpreadAttribute;
      function isJsxExpression(node) {
        return node.kind === 288;
      }
      ts3.isJsxExpression = isJsxExpression;
      function isCaseClause(node) {
        return node.kind === 289;
      }
      ts3.isCaseClause = isCaseClause;
      function isDefaultClause(node) {
        return node.kind === 290;
      }
      ts3.isDefaultClause = isDefaultClause;
      function isHeritageClause(node) {
        return node.kind === 291;
      }
      ts3.isHeritageClause = isHeritageClause;
      function isCatchClause(node) {
        return node.kind === 292;
      }
      ts3.isCatchClause = isCatchClause;
      function isPropertyAssignment(node) {
        return node.kind === 296;
      }
      ts3.isPropertyAssignment = isPropertyAssignment;
      function isShorthandPropertyAssignment(node) {
        return node.kind === 297;
      }
      ts3.isShorthandPropertyAssignment = isShorthandPropertyAssignment;
      function isSpreadAssignment(node) {
        return node.kind === 298;
      }
      ts3.isSpreadAssignment = isSpreadAssignment;
      function isEnumMember(node) {
        return node.kind === 299;
      }
      ts3.isEnumMember = isEnumMember;
      function isUnparsedPrepend(node) {
        return node.kind === 301;
      }
      ts3.isUnparsedPrepend = isUnparsedPrepend;
      function isSourceFile(node) {
        return node.kind === 305;
      }
      ts3.isSourceFile = isSourceFile;
      function isBundle(node) {
        return node.kind === 306;
      }
      ts3.isBundle = isBundle;
      function isUnparsedSource(node) {
        return node.kind === 307;
      }
      ts3.isUnparsedSource = isUnparsedSource;
      function isJSDocTypeExpression(node) {
        return node.kind === 309;
      }
      ts3.isJSDocTypeExpression = isJSDocTypeExpression;
      function isJSDocNameReference(node) {
        return node.kind === 310;
      }
      ts3.isJSDocNameReference = isJSDocNameReference;
      function isJSDocMemberName(node) {
        return node.kind === 311;
      }
      ts3.isJSDocMemberName = isJSDocMemberName;
      function isJSDocLink(node) {
        return node.kind === 324;
      }
      ts3.isJSDocLink = isJSDocLink;
      function isJSDocLinkCode(node) {
        return node.kind === 325;
      }
      ts3.isJSDocLinkCode = isJSDocLinkCode;
      function isJSDocLinkPlain(node) {
        return node.kind === 326;
      }
      ts3.isJSDocLinkPlain = isJSDocLinkPlain;
      function isJSDocAllType(node) {
        return node.kind === 312;
      }
      ts3.isJSDocAllType = isJSDocAllType;
      function isJSDocUnknownType(node) {
        return node.kind === 313;
      }
      ts3.isJSDocUnknownType = isJSDocUnknownType;
      function isJSDocNullableType(node) {
        return node.kind === 314;
      }
      ts3.isJSDocNullableType = isJSDocNullableType;
      function isJSDocNonNullableType(node) {
        return node.kind === 315;
      }
      ts3.isJSDocNonNullableType = isJSDocNonNullableType;
      function isJSDocOptionalType(node) {
        return node.kind === 316;
      }
      ts3.isJSDocOptionalType = isJSDocOptionalType;
      function isJSDocFunctionType(node) {
        return node.kind === 317;
      }
      ts3.isJSDocFunctionType = isJSDocFunctionType;
      function isJSDocVariadicType(node) {
        return node.kind === 318;
      }
      ts3.isJSDocVariadicType = isJSDocVariadicType;
      function isJSDocNamepathType(node) {
        return node.kind === 319;
      }
      ts3.isJSDocNamepathType = isJSDocNamepathType;
      function isJSDoc(node) {
        return node.kind === 320;
      }
      ts3.isJSDoc = isJSDoc;
      function isJSDocTypeLiteral(node) {
        return node.kind === 322;
      }
      ts3.isJSDocTypeLiteral = isJSDocTypeLiteral;
      function isJSDocSignature(node) {
        return node.kind === 323;
      }
      ts3.isJSDocSignature = isJSDocSignature;
      function isJSDocAugmentsTag(node) {
        return node.kind === 328;
      }
      ts3.isJSDocAugmentsTag = isJSDocAugmentsTag;
      function isJSDocAuthorTag(node) {
        return node.kind === 330;
      }
      ts3.isJSDocAuthorTag = isJSDocAuthorTag;
      function isJSDocClassTag(node) {
        return node.kind === 332;
      }
      ts3.isJSDocClassTag = isJSDocClassTag;
      function isJSDocCallbackTag(node) {
        return node.kind === 338;
      }
      ts3.isJSDocCallbackTag = isJSDocCallbackTag;
      function isJSDocPublicTag(node) {
        return node.kind === 333;
      }
      ts3.isJSDocPublicTag = isJSDocPublicTag;
      function isJSDocPrivateTag(node) {
        return node.kind === 334;
      }
      ts3.isJSDocPrivateTag = isJSDocPrivateTag;
      function isJSDocProtectedTag(node) {
        return node.kind === 335;
      }
      ts3.isJSDocProtectedTag = isJSDocProtectedTag;
      function isJSDocReadonlyTag(node) {
        return node.kind === 336;
      }
      ts3.isJSDocReadonlyTag = isJSDocReadonlyTag;
      function isJSDocOverrideTag(node) {
        return node.kind === 337;
      }
      ts3.isJSDocOverrideTag = isJSDocOverrideTag;
      function isJSDocDeprecatedTag(node) {
        return node.kind === 331;
      }
      ts3.isJSDocDeprecatedTag = isJSDocDeprecatedTag;
      function isJSDocSeeTag(node) {
        return node.kind === 346;
      }
      ts3.isJSDocSeeTag = isJSDocSeeTag;
      function isJSDocEnumTag(node) {
        return node.kind === 339;
      }
      ts3.isJSDocEnumTag = isJSDocEnumTag;
      function isJSDocParameterTag(node) {
        return node.kind === 340;
      }
      ts3.isJSDocParameterTag = isJSDocParameterTag;
      function isJSDocReturnTag(node) {
        return node.kind === 341;
      }
      ts3.isJSDocReturnTag = isJSDocReturnTag;
      function isJSDocThisTag(node) {
        return node.kind === 342;
      }
      ts3.isJSDocThisTag = isJSDocThisTag;
      function isJSDocTypeTag(node) {
        return node.kind === 343;
      }
      ts3.isJSDocTypeTag = isJSDocTypeTag;
      function isJSDocTemplateTag(node) {
        return node.kind === 344;
      }
      ts3.isJSDocTemplateTag = isJSDocTemplateTag;
      function isJSDocTypedefTag(node) {
        return node.kind === 345;
      }
      ts3.isJSDocTypedefTag = isJSDocTypedefTag;
      function isJSDocUnknownTag(node) {
        return node.kind === 327;
      }
      ts3.isJSDocUnknownTag = isJSDocUnknownTag;
      function isJSDocPropertyTag(node) {
        return node.kind === 347;
      }
      ts3.isJSDocPropertyTag = isJSDocPropertyTag;
      function isJSDocImplementsTag(node) {
        return node.kind === 329;
      }
      ts3.isJSDocImplementsTag = isJSDocImplementsTag;
      function isSyntaxList(n) {
        return n.kind === 348;
      }
      ts3.isSyntaxList = isSyntaxList;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createEmptyExports(factory) {
        return factory.createExportDeclaration(void 0, void 0, false, factory.createNamedExports([]), void 0);
      }
      ts3.createEmptyExports = createEmptyExports;
      function createMemberAccessForPropertyName(factory, target, memberName, location) {
        if (ts3.isComputedPropertyName(memberName)) {
          return ts3.setTextRange(factory.createElementAccessExpression(target, memberName.expression), location);
        } else {
          var expression = ts3.setTextRange(ts3.isMemberName(memberName) ? factory.createPropertyAccessExpression(target, memberName) : factory.createElementAccessExpression(target, memberName), memberName);
          ts3.getOrCreateEmitNode(expression).flags |= 64;
          return expression;
        }
      }
      ts3.createMemberAccessForPropertyName = createMemberAccessForPropertyName;
      function createReactNamespace(reactNamespace, parent) {
        var react = ts3.parseNodeFactory.createIdentifier(reactNamespace || "React");
        ts3.setParent(react, ts3.getParseTreeNode(parent));
        return react;
      }
      function createJsxFactoryExpressionFromEntityName(factory, jsxFactory, parent) {
        if (ts3.isQualifiedName(jsxFactory)) {
          var left = createJsxFactoryExpressionFromEntityName(factory, jsxFactory.left, parent);
          var right = factory.createIdentifier(ts3.idText(jsxFactory.right));
          right.escapedText = jsxFactory.right.escapedText;
          return factory.createPropertyAccessExpression(left, right);
        } else {
          return createReactNamespace(ts3.idText(jsxFactory), parent);
        }
      }
      function createJsxFactoryExpression(factory, jsxFactoryEntity, reactNamespace, parent) {
        return jsxFactoryEntity ? createJsxFactoryExpressionFromEntityName(factory, jsxFactoryEntity, parent) : factory.createPropertyAccessExpression(createReactNamespace(reactNamespace, parent), "createElement");
      }
      ts3.createJsxFactoryExpression = createJsxFactoryExpression;
      function createJsxFragmentFactoryExpression(factory, jsxFragmentFactoryEntity, reactNamespace, parent) {
        return jsxFragmentFactoryEntity ? createJsxFactoryExpressionFromEntityName(factory, jsxFragmentFactoryEntity, parent) : factory.createPropertyAccessExpression(createReactNamespace(reactNamespace, parent), "Fragment");
      }
      function createExpressionForJsxElement(factory, callee, tagName, props, children, location) {
        var argumentsList = [tagName];
        if (props) {
          argumentsList.push(props);
        }
        if (children && children.length > 0) {
          if (!props) {
            argumentsList.push(factory.createNull());
          }
          if (children.length > 1) {
            for (var _i = 0, children_3 = children; _i < children_3.length; _i++) {
              var child = children_3[_i];
              startOnNewLine(child);
              argumentsList.push(child);
            }
          } else {
            argumentsList.push(children[0]);
          }
        }
        return ts3.setTextRange(factory.createCallExpression(callee, void 0, argumentsList), location);
      }
      ts3.createExpressionForJsxElement = createExpressionForJsxElement;
      function createExpressionForJsxFragment(factory, jsxFactoryEntity, jsxFragmentFactoryEntity, reactNamespace, children, parentElement, location) {
        var tagName = createJsxFragmentFactoryExpression(factory, jsxFragmentFactoryEntity, reactNamespace, parentElement);
        var argumentsList = [tagName, factory.createNull()];
        if (children && children.length > 0) {
          if (children.length > 1) {
            for (var _i = 0, children_4 = children; _i < children_4.length; _i++) {
              var child = children_4[_i];
              startOnNewLine(child);
              argumentsList.push(child);
            }
          } else {
            argumentsList.push(children[0]);
          }
        }
        return ts3.setTextRange(factory.createCallExpression(createJsxFactoryExpression(factory, jsxFactoryEntity, reactNamespace, parentElement), void 0, argumentsList), location);
      }
      ts3.createExpressionForJsxFragment = createExpressionForJsxFragment;
      function createForOfBindingStatement(factory, node, boundValue) {
        if (ts3.isVariableDeclarationList(node)) {
          var firstDeclaration = ts3.first(node.declarations);
          var updatedDeclaration = factory.updateVariableDeclaration(firstDeclaration, firstDeclaration.name, void 0, void 0, boundValue);
          return ts3.setTextRange(factory.createVariableStatement(void 0, factory.updateVariableDeclarationList(node, [updatedDeclaration])), node);
        } else {
          var updatedExpression = ts3.setTextRange(factory.createAssignment(node, boundValue), node);
          return ts3.setTextRange(factory.createExpressionStatement(updatedExpression), node);
        }
      }
      ts3.createForOfBindingStatement = createForOfBindingStatement;
      function insertLeadingStatement(factory, dest, source) {
        if (ts3.isBlock(dest)) {
          return factory.updateBlock(dest, ts3.setTextRange(factory.createNodeArray(__spreadArray([source], dest.statements, true)), dest.statements));
        } else {
          return factory.createBlock(factory.createNodeArray([dest, source]), true);
        }
      }
      ts3.insertLeadingStatement = insertLeadingStatement;
      function createExpressionFromEntityName(factory, node) {
        if (ts3.isQualifiedName(node)) {
          var left = createExpressionFromEntityName(factory, node.left);
          var right = ts3.setParent(ts3.setTextRange(factory.cloneNode(node.right), node.right), node.right.parent);
          return ts3.setTextRange(factory.createPropertyAccessExpression(left, right), node);
        } else {
          return ts3.setParent(ts3.setTextRange(factory.cloneNode(node), node), node.parent);
        }
      }
      ts3.createExpressionFromEntityName = createExpressionFromEntityName;
      function createExpressionForPropertyName(factory, memberName) {
        if (ts3.isIdentifier(memberName)) {
          return factory.createStringLiteralFromNode(memberName);
        } else if (ts3.isComputedPropertyName(memberName)) {
          return ts3.setParent(ts3.setTextRange(factory.cloneNode(memberName.expression), memberName.expression), memberName.expression.parent);
        } else {
          return ts3.setParent(ts3.setTextRange(factory.cloneNode(memberName), memberName), memberName.parent);
        }
      }
      ts3.createExpressionForPropertyName = createExpressionForPropertyName;
      function createExpressionForAccessorDeclaration(factory, properties, property, receiver, multiLine) {
        var _a = ts3.getAllAccessorDeclarations(properties, property), firstAccessor = _a.firstAccessor, getAccessor = _a.getAccessor, setAccessor = _a.setAccessor;
        if (property === firstAccessor) {
          return ts3.setTextRange(factory.createObjectDefinePropertyCall(receiver, createExpressionForPropertyName(factory, property.name), factory.createPropertyDescriptor({
            enumerable: factory.createFalse(),
            configurable: true,
            get: getAccessor && ts3.setTextRange(ts3.setOriginalNode(factory.createFunctionExpression(getAccessor.modifiers, void 0, void 0, void 0, getAccessor.parameters, void 0, getAccessor.body), getAccessor), getAccessor),
            set: setAccessor && ts3.setTextRange(ts3.setOriginalNode(factory.createFunctionExpression(setAccessor.modifiers, void 0, void 0, void 0, setAccessor.parameters, void 0, setAccessor.body), setAccessor), setAccessor)
          }, !multiLine)), firstAccessor);
        }
        return void 0;
      }
      function createExpressionForPropertyAssignment(factory, property, receiver) {
        return ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(createMemberAccessForPropertyName(factory, receiver, property.name, property.name), property.initializer), property), property);
      }
      function createExpressionForShorthandPropertyAssignment(factory, property, receiver) {
        return ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(createMemberAccessForPropertyName(factory, receiver, property.name, property.name), factory.cloneNode(property.name)), property), property);
      }
      function createExpressionForMethodDeclaration(factory, method, receiver) {
        return ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(createMemberAccessForPropertyName(factory, receiver, method.name, method.name), ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionExpression(method.modifiers, method.asteriskToken, void 0, void 0, method.parameters, void 0, method.body), method), method)), method), method);
      }
      function createExpressionForObjectLiteralElementLike(factory, node, property, receiver) {
        if (property.name && ts3.isPrivateIdentifier(property.name)) {
          ts3.Debug.failBadSyntaxKind(property.name, "Private identifiers are not allowed in object literals.");
        }
        switch (property.kind) {
          case 172:
          case 173:
            return createExpressionForAccessorDeclaration(factory, node.properties, property, receiver, !!node.multiLine);
          case 296:
            return createExpressionForPropertyAssignment(factory, property, receiver);
          case 297:
            return createExpressionForShorthandPropertyAssignment(factory, property, receiver);
          case 169:
            return createExpressionForMethodDeclaration(factory, property, receiver);
        }
      }
      ts3.createExpressionForObjectLiteralElementLike = createExpressionForObjectLiteralElementLike;
      function expandPreOrPostfixIncrementOrDecrementExpression(factory, node, expression, recordTempVariable, resultVariable) {
        var operator = node.operator;
        ts3.Debug.assert(operator === 45 || operator === 46, "Expected 'node' to be a pre- or post-increment or pre- or post-decrement expression");
        var temp = factory.createTempVariable(recordTempVariable);
        expression = factory.createAssignment(temp, expression);
        ts3.setTextRange(expression, node.operand);
        var operation = ts3.isPrefixUnaryExpression(node) ? factory.createPrefixUnaryExpression(operator, temp) : factory.createPostfixUnaryExpression(temp, operator);
        ts3.setTextRange(operation, node);
        if (resultVariable) {
          operation = factory.createAssignment(resultVariable, operation);
          ts3.setTextRange(operation, node);
        }
        expression = factory.createComma(expression, operation);
        ts3.setTextRange(expression, node);
        if (ts3.isPostfixUnaryExpression(node)) {
          expression = factory.createComma(expression, temp);
          ts3.setTextRange(expression, node);
        }
        return expression;
      }
      ts3.expandPreOrPostfixIncrementOrDecrementExpression = expandPreOrPostfixIncrementOrDecrementExpression;
      function isInternalName(node) {
        return (ts3.getEmitFlags(node) & 32768) !== 0;
      }
      ts3.isInternalName = isInternalName;
      function isLocalName(node) {
        return (ts3.getEmitFlags(node) & 16384) !== 0;
      }
      ts3.isLocalName = isLocalName;
      function isExportName(node) {
        return (ts3.getEmitFlags(node) & 8192) !== 0;
      }
      ts3.isExportName = isExportName;
      function isUseStrictPrologue(node) {
        return ts3.isStringLiteral(node.expression) && node.expression.text === "use strict";
      }
      function findUseStrictPrologue(statements) {
        for (var _i = 0, statements_1 = statements; _i < statements_1.length; _i++) {
          var statement = statements_1[_i];
          if (ts3.isPrologueDirective(statement)) {
            if (isUseStrictPrologue(statement)) {
              return statement;
            }
          } else {
            break;
          }
        }
        return void 0;
      }
      ts3.findUseStrictPrologue = findUseStrictPrologue;
      function startsWithUseStrict(statements) {
        var firstStatement = ts3.firstOrUndefined(statements);
        return firstStatement !== void 0 && ts3.isPrologueDirective(firstStatement) && isUseStrictPrologue(firstStatement);
      }
      ts3.startsWithUseStrict = startsWithUseStrict;
      function isCommaSequence(node) {
        return node.kind === 221 && node.operatorToken.kind === 27 || node.kind === 351;
      }
      ts3.isCommaSequence = isCommaSequence;
      function isJSDocTypeAssertion(node) {
        return ts3.isParenthesizedExpression(node) && ts3.isInJSFile(node) && !!ts3.getJSDocTypeTag(node);
      }
      ts3.isJSDocTypeAssertion = isJSDocTypeAssertion;
      function getJSDocTypeAssertionType(node) {
        var type2 = ts3.getJSDocType(node);
        ts3.Debug.assertIsDefined(type2);
        return type2;
      }
      ts3.getJSDocTypeAssertionType = getJSDocTypeAssertionType;
      function isOuterExpression(node, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        switch (node.kind) {
          case 212:
            if (kinds & 16 && isJSDocTypeAssertion(node)) {
              return false;
            }
            return (kinds & 1) !== 0;
          case 211:
          case 229:
            return (kinds & 2) !== 0;
          case 230:
            return (kinds & 4) !== 0;
          case 350:
            return (kinds & 8) !== 0;
        }
        return false;
      }
      ts3.isOuterExpression = isOuterExpression;
      function skipOuterExpressions(node, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        while (isOuterExpression(node, kinds)) {
          node = node.expression;
        }
        return node;
      }
      ts3.skipOuterExpressions = skipOuterExpressions;
      function skipAssertions(node) {
        return skipOuterExpressions(node, 6);
      }
      ts3.skipAssertions = skipAssertions;
      function startOnNewLine(node) {
        return ts3.setStartsOnNewLine(node, true);
      }
      ts3.startOnNewLine = startOnNewLine;
      function getExternalHelpersModuleName(node) {
        var parseNode = ts3.getOriginalNode(node, ts3.isSourceFile);
        var emitNode = parseNode && parseNode.emitNode;
        return emitNode && emitNode.externalHelpersModuleName;
      }
      ts3.getExternalHelpersModuleName = getExternalHelpersModuleName;
      function hasRecordedExternalHelpers(sourceFile) {
        var parseNode = ts3.getOriginalNode(sourceFile, ts3.isSourceFile);
        var emitNode = parseNode && parseNode.emitNode;
        return !!emitNode && (!!emitNode.externalHelpersModuleName || !!emitNode.externalHelpers);
      }
      ts3.hasRecordedExternalHelpers = hasRecordedExternalHelpers;
      function createExternalHelpersImportDeclarationIfNeeded(nodeFactory, helperFactory, sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault) {
        if (compilerOptions.importHelpers && ts3.isEffectiveExternalModule(sourceFile, compilerOptions)) {
          var namedBindings = void 0;
          var moduleKind = ts3.getEmitModuleKind(compilerOptions);
          if (moduleKind >= ts3.ModuleKind.ES2015 && moduleKind <= ts3.ModuleKind.ESNext || sourceFile.impliedNodeFormat === ts3.ModuleKind.ESNext) {
            var helpers = ts3.getEmitHelpers(sourceFile);
            if (helpers) {
              var helperNames = [];
              for (var _i = 0, helpers_3 = helpers; _i < helpers_3.length; _i++) {
                var helper = helpers_3[_i];
                if (!helper.scoped) {
                  var importName = helper.importName;
                  if (importName) {
                    ts3.pushIfUnique(helperNames, importName);
                  }
                }
              }
              if (ts3.some(helperNames)) {
                helperNames.sort(ts3.compareStringsCaseSensitive);
                namedBindings = nodeFactory.createNamedImports(ts3.map(helperNames, function(name) {
                  return ts3.isFileLevelUniqueName(sourceFile, name) ? nodeFactory.createImportSpecifier(false, void 0, nodeFactory.createIdentifier(name)) : nodeFactory.createImportSpecifier(false, nodeFactory.createIdentifier(name), helperFactory.getUnscopedHelperName(name));
                }));
                var parseNode = ts3.getOriginalNode(sourceFile, ts3.isSourceFile);
                var emitNode = ts3.getOrCreateEmitNode(parseNode);
                emitNode.externalHelpers = true;
              }
            }
          } else {
            var externalHelpersModuleName = getOrCreateExternalHelpersModuleNameIfNeeded(nodeFactory, sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar || hasImportDefault);
            if (externalHelpersModuleName) {
              namedBindings = nodeFactory.createNamespaceImport(externalHelpersModuleName);
            }
          }
          if (namedBindings) {
            var externalHelpersImportDeclaration = nodeFactory.createImportDeclaration(void 0, void 0, nodeFactory.createImportClause(false, void 0, namedBindings), nodeFactory.createStringLiteral(ts3.externalHelpersModuleNameText), void 0);
            ts3.addEmitFlags(externalHelpersImportDeclaration, 67108864);
            return externalHelpersImportDeclaration;
          }
        }
      }
      ts3.createExternalHelpersImportDeclarationIfNeeded = createExternalHelpersImportDeclarationIfNeeded;
      function getOrCreateExternalHelpersModuleNameIfNeeded(factory, node, compilerOptions, hasExportStarsToExportValues, hasImportStarOrImportDefault) {
        if (compilerOptions.importHelpers && ts3.isEffectiveExternalModule(node, compilerOptions)) {
          var externalHelpersModuleName = getExternalHelpersModuleName(node);
          if (externalHelpersModuleName) {
            return externalHelpersModuleName;
          }
          var moduleKind = ts3.getEmitModuleKind(compilerOptions);
          var create = (hasExportStarsToExportValues || ts3.getESModuleInterop(compilerOptions) && hasImportStarOrImportDefault) && moduleKind !== ts3.ModuleKind.System && (moduleKind < ts3.ModuleKind.ES2015 || node.impliedNodeFormat === ts3.ModuleKind.CommonJS);
          if (!create) {
            var helpers = ts3.getEmitHelpers(node);
            if (helpers) {
              for (var _i = 0, helpers_4 = helpers; _i < helpers_4.length; _i++) {
                var helper = helpers_4[_i];
                if (!helper.scoped) {
                  create = true;
                  break;
                }
              }
            }
          }
          if (create) {
            var parseNode = ts3.getOriginalNode(node, ts3.isSourceFile);
            var emitNode = ts3.getOrCreateEmitNode(parseNode);
            return emitNode.externalHelpersModuleName || (emitNode.externalHelpersModuleName = factory.createUniqueName(ts3.externalHelpersModuleNameText));
          }
        }
      }
      ts3.getOrCreateExternalHelpersModuleNameIfNeeded = getOrCreateExternalHelpersModuleNameIfNeeded;
      function getLocalNameForExternalImport(factory, node, sourceFile) {
        var namespaceDeclaration = ts3.getNamespaceDeclarationNode(node);
        if (namespaceDeclaration && !ts3.isDefaultImport(node) && !ts3.isExportNamespaceAsDefaultDeclaration(node)) {
          var name = namespaceDeclaration.name;
          return ts3.isGeneratedIdentifier(name) ? name : factory.createIdentifier(ts3.getSourceTextOfNodeFromSourceFile(sourceFile, name) || ts3.idText(name));
        }
        if (node.kind === 266 && node.importClause) {
          return factory.getGeneratedNameForNode(node);
        }
        if (node.kind === 272 && node.moduleSpecifier) {
          return factory.getGeneratedNameForNode(node);
        }
        return void 0;
      }
      ts3.getLocalNameForExternalImport = getLocalNameForExternalImport;
      function getExternalModuleNameLiteral(factory, importNode, sourceFile, host, resolver, compilerOptions) {
        var moduleName = ts3.getExternalModuleName(importNode);
        if (moduleName && ts3.isStringLiteral(moduleName)) {
          return tryGetModuleNameFromDeclaration(importNode, host, factory, resolver, compilerOptions) || tryRenameExternalModule(factory, moduleName, sourceFile) || factory.cloneNode(moduleName);
        }
        return void 0;
      }
      ts3.getExternalModuleNameLiteral = getExternalModuleNameLiteral;
      function tryRenameExternalModule(factory, moduleName, sourceFile) {
        var rename = sourceFile.renamedDependencies && sourceFile.renamedDependencies.get(moduleName.text);
        return rename ? factory.createStringLiteral(rename) : void 0;
      }
      function tryGetModuleNameFromFile(factory, file, host, options) {
        if (!file) {
          return void 0;
        }
        if (file.moduleName) {
          return factory.createStringLiteral(file.moduleName);
        }
        if (!file.isDeclarationFile && ts3.outFile(options)) {
          return factory.createStringLiteral(ts3.getExternalModuleNameFromPath(host, file.fileName));
        }
        return void 0;
      }
      ts3.tryGetModuleNameFromFile = tryGetModuleNameFromFile;
      function tryGetModuleNameFromDeclaration(declaration, host, factory, resolver, compilerOptions) {
        return tryGetModuleNameFromFile(factory, resolver.getExternalModuleFileFromDeclaration(declaration), host, compilerOptions);
      }
      function getInitializerOfBindingOrAssignmentElement(bindingElement) {
        if (ts3.isDeclarationBindingElement(bindingElement)) {
          return bindingElement.initializer;
        }
        if (ts3.isPropertyAssignment(bindingElement)) {
          var initializer = bindingElement.initializer;
          return ts3.isAssignmentExpression(initializer, true) ? initializer.right : void 0;
        }
        if (ts3.isShorthandPropertyAssignment(bindingElement)) {
          return bindingElement.objectAssignmentInitializer;
        }
        if (ts3.isAssignmentExpression(bindingElement, true)) {
          return bindingElement.right;
        }
        if (ts3.isSpreadElement(bindingElement)) {
          return getInitializerOfBindingOrAssignmentElement(bindingElement.expression);
        }
      }
      ts3.getInitializerOfBindingOrAssignmentElement = getInitializerOfBindingOrAssignmentElement;
      function getTargetOfBindingOrAssignmentElement(bindingElement) {
        if (ts3.isDeclarationBindingElement(bindingElement)) {
          return bindingElement.name;
        }
        if (ts3.isObjectLiteralElementLike(bindingElement)) {
          switch (bindingElement.kind) {
            case 296:
              return getTargetOfBindingOrAssignmentElement(bindingElement.initializer);
            case 297:
              return bindingElement.name;
            case 298:
              return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
          }
          return void 0;
        }
        if (ts3.isAssignmentExpression(bindingElement, true)) {
          return getTargetOfBindingOrAssignmentElement(bindingElement.left);
        }
        if (ts3.isSpreadElement(bindingElement)) {
          return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
        }
        return bindingElement;
      }
      ts3.getTargetOfBindingOrAssignmentElement = getTargetOfBindingOrAssignmentElement;
      function getRestIndicatorOfBindingOrAssignmentElement(bindingElement) {
        switch (bindingElement.kind) {
          case 164:
          case 203:
            return bindingElement.dotDotDotToken;
          case 225:
          case 298:
            return bindingElement;
        }
        return void 0;
      }
      ts3.getRestIndicatorOfBindingOrAssignmentElement = getRestIndicatorOfBindingOrAssignmentElement;
      function getPropertyNameOfBindingOrAssignmentElement(bindingElement) {
        var propertyName = tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement);
        ts3.Debug.assert(!!propertyName || ts3.isSpreadAssignment(bindingElement), "Invalid property name for binding element.");
        return propertyName;
      }
      ts3.getPropertyNameOfBindingOrAssignmentElement = getPropertyNameOfBindingOrAssignmentElement;
      function tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement) {
        switch (bindingElement.kind) {
          case 203:
            if (bindingElement.propertyName) {
              var propertyName = bindingElement.propertyName;
              if (ts3.isPrivateIdentifier(propertyName)) {
                return ts3.Debug.failBadSyntaxKind(propertyName);
              }
              return ts3.isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
            }
            break;
          case 296:
            if (bindingElement.name) {
              var propertyName = bindingElement.name;
              if (ts3.isPrivateIdentifier(propertyName)) {
                return ts3.Debug.failBadSyntaxKind(propertyName);
              }
              return ts3.isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
            }
            break;
          case 298:
            if (bindingElement.name && ts3.isPrivateIdentifier(bindingElement.name)) {
              return ts3.Debug.failBadSyntaxKind(bindingElement.name);
            }
            return bindingElement.name;
        }
        var target = getTargetOfBindingOrAssignmentElement(bindingElement);
        if (target && ts3.isPropertyName(target)) {
          return target;
        }
      }
      ts3.tryGetPropertyNameOfBindingOrAssignmentElement = tryGetPropertyNameOfBindingOrAssignmentElement;
      function isStringOrNumericLiteral(node) {
        var kind = node.kind;
        return kind === 10 || kind === 8;
      }
      function getElementsOfBindingOrAssignmentPattern(name) {
        switch (name.kind) {
          case 201:
          case 202:
          case 204:
            return name.elements;
          case 205:
            return name.properties;
        }
      }
      ts3.getElementsOfBindingOrAssignmentPattern = getElementsOfBindingOrAssignmentPattern;
      function getJSDocTypeAliasName(fullName) {
        if (fullName) {
          var rightNode = fullName;
          while (true) {
            if (ts3.isIdentifier(rightNode) || !rightNode.body) {
              return ts3.isIdentifier(rightNode) ? rightNode : rightNode.name;
            }
            rightNode = rightNode.body;
          }
        }
      }
      ts3.getJSDocTypeAliasName = getJSDocTypeAliasName;
      function canHaveModifiers(node) {
        var kind = node.kind;
        return kind === 164 || kind === 166 || kind === 167 || kind === 168 || kind === 169 || kind === 171 || kind === 172 || kind === 173 || kind === 176 || kind === 213 || kind === 214 || kind === 226 || kind === 237 || kind === 256 || kind === 257 || kind === 258 || kind === 259 || kind === 260 || kind === 261 || kind === 265 || kind === 266 || kind === 271 || kind === 272;
      }
      ts3.canHaveModifiers = canHaveModifiers;
      ts3.isTypeNodeOrTypeParameterDeclaration = ts3.or(ts3.isTypeNode, ts3.isTypeParameterDeclaration);
      ts3.isQuestionOrExclamationToken = ts3.or(ts3.isQuestionToken, ts3.isExclamationToken);
      ts3.isIdentifierOrThisTypeNode = ts3.or(ts3.isIdentifier, ts3.isThisTypeNode);
      ts3.isReadonlyKeywordOrPlusOrMinusToken = ts3.or(ts3.isReadonlyKeyword, ts3.isPlusToken, ts3.isMinusToken);
      ts3.isQuestionOrPlusOrMinusToken = ts3.or(ts3.isQuestionToken, ts3.isPlusToken, ts3.isMinusToken);
      ts3.isModuleName = ts3.or(ts3.isIdentifier, ts3.isStringLiteral);
      function isLiteralTypeLikeExpression(node) {
        var kind = node.kind;
        return kind === 104 || kind === 110 || kind === 95 || ts3.isLiteralExpression(node) || ts3.isPrefixUnaryExpression(node);
      }
      ts3.isLiteralTypeLikeExpression = isLiteralTypeLikeExpression;
      function isExponentiationOperator(kind) {
        return kind === 42;
      }
      function isMultiplicativeOperator(kind) {
        return kind === 41 || kind === 43 || kind === 44;
      }
      function isMultiplicativeOperatorOrHigher(kind) {
        return isExponentiationOperator(kind) || isMultiplicativeOperator(kind);
      }
      function isAdditiveOperator(kind) {
        return kind === 39 || kind === 40;
      }
      function isAdditiveOperatorOrHigher(kind) {
        return isAdditiveOperator(kind) || isMultiplicativeOperatorOrHigher(kind);
      }
      function isShiftOperator(kind) {
        return kind === 47 || kind === 48 || kind === 49;
      }
      function isShiftOperatorOrHigher(kind) {
        return isShiftOperator(kind) || isAdditiveOperatorOrHigher(kind);
      }
      function isRelationalOperator(kind) {
        return kind === 29 || kind === 32 || kind === 31 || kind === 33 || kind === 102 || kind === 101;
      }
      function isRelationalOperatorOrHigher(kind) {
        return isRelationalOperator(kind) || isShiftOperatorOrHigher(kind);
      }
      function isEqualityOperator(kind) {
        return kind === 34 || kind === 36 || kind === 35 || kind === 37;
      }
      function isEqualityOperatorOrHigher(kind) {
        return isEqualityOperator(kind) || isRelationalOperatorOrHigher(kind);
      }
      function isBitwiseOperator(kind) {
        return kind === 50 || kind === 51 || kind === 52;
      }
      function isBitwiseOperatorOrHigher(kind) {
        return isBitwiseOperator(kind) || isEqualityOperatorOrHigher(kind);
      }
      function isLogicalOperator(kind) {
        return kind === 55 || kind === 56;
      }
      function isLogicalOperatorOrHigher(kind) {
        return isLogicalOperator(kind) || isBitwiseOperatorOrHigher(kind);
      }
      function isAssignmentOperatorOrHigher(kind) {
        return kind === 60 || isLogicalOperatorOrHigher(kind) || ts3.isAssignmentOperator(kind);
      }
      function isBinaryOperator(kind) {
        return isAssignmentOperatorOrHigher(kind) || kind === 27;
      }
      function isBinaryOperatorToken(node) {
        return isBinaryOperator(node.kind);
      }
      ts3.isBinaryOperatorToken = isBinaryOperatorToken;
      var BinaryExpressionState;
      (function(BinaryExpressionState2) {
        function enter(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, outerState) {
          var prevUserState = stackIndex > 0 ? userStateStack[stackIndex - 1] : void 0;
          ts3.Debug.assertEqual(stateStack[stackIndex], enter);
          userStateStack[stackIndex] = machine.onEnter(nodeStack[stackIndex], prevUserState, outerState);
          stateStack[stackIndex] = nextState(machine, enter);
          return stackIndex;
        }
        BinaryExpressionState2.enter = enter;
        function left(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], left);
          ts3.Debug.assertIsDefined(machine.onLeft);
          stateStack[stackIndex] = nextState(machine, left);
          var nextNode = machine.onLeft(nodeStack[stackIndex].left, userStateStack[stackIndex], nodeStack[stackIndex]);
          if (nextNode) {
            checkCircularity(stackIndex, nodeStack, nextNode);
            return pushStack(stackIndex, stateStack, nodeStack, userStateStack, nextNode);
          }
          return stackIndex;
        }
        BinaryExpressionState2.left = left;
        function operator(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], operator);
          ts3.Debug.assertIsDefined(machine.onOperator);
          stateStack[stackIndex] = nextState(machine, operator);
          machine.onOperator(nodeStack[stackIndex].operatorToken, userStateStack[stackIndex], nodeStack[stackIndex]);
          return stackIndex;
        }
        BinaryExpressionState2.operator = operator;
        function right(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], right);
          ts3.Debug.assertIsDefined(machine.onRight);
          stateStack[stackIndex] = nextState(machine, right);
          var nextNode = machine.onRight(nodeStack[stackIndex].right, userStateStack[stackIndex], nodeStack[stackIndex]);
          if (nextNode) {
            checkCircularity(stackIndex, nodeStack, nextNode);
            return pushStack(stackIndex, stateStack, nodeStack, userStateStack, nextNode);
          }
          return stackIndex;
        }
        BinaryExpressionState2.right = right;
        function exit(machine, stackIndex, stateStack, nodeStack, userStateStack, resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], exit);
          stateStack[stackIndex] = nextState(machine, exit);
          var result2 = machine.onExit(nodeStack[stackIndex], userStateStack[stackIndex]);
          if (stackIndex > 0) {
            stackIndex--;
            if (machine.foldState) {
              var side = stateStack[stackIndex] === exit ? "right" : "left";
              userStateStack[stackIndex] = machine.foldState(userStateStack[stackIndex], result2, side);
            }
          } else {
            resultHolder.value = result2;
          }
          return stackIndex;
        }
        BinaryExpressionState2.exit = exit;
        function done(_machine, stackIndex, stateStack, _nodeStack, _userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], done);
          return stackIndex;
        }
        BinaryExpressionState2.done = done;
        function nextState(machine, currentState) {
          switch (currentState) {
            case enter:
              if (machine.onLeft)
                return left;
            case left:
              if (machine.onOperator)
                return operator;
            case operator:
              if (machine.onRight)
                return right;
            case right:
              return exit;
            case exit:
              return done;
            case done:
              return done;
            default:
              ts3.Debug.fail("Invalid state");
          }
        }
        BinaryExpressionState2.nextState = nextState;
        function pushStack(stackIndex, stateStack, nodeStack, userStateStack, node) {
          stackIndex++;
          stateStack[stackIndex] = enter;
          nodeStack[stackIndex] = node;
          userStateStack[stackIndex] = void 0;
          return stackIndex;
        }
        function checkCircularity(stackIndex, nodeStack, node) {
          if (ts3.Debug.shouldAssert(2)) {
            while (stackIndex >= 0) {
              ts3.Debug.assert(nodeStack[stackIndex] !== node, "Circular traversal detected.");
              stackIndex--;
            }
          }
        }
      })(BinaryExpressionState || (BinaryExpressionState = {}));
      var BinaryExpressionStateMachine = function() {
        function BinaryExpressionStateMachine2(onEnter, onLeft, onOperator, onRight, onExit, foldState) {
          this.onEnter = onEnter;
          this.onLeft = onLeft;
          this.onOperator = onOperator;
          this.onRight = onRight;
          this.onExit = onExit;
          this.foldState = foldState;
        }
        return BinaryExpressionStateMachine2;
      }();
      function createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, foldState) {
        var machine = new BinaryExpressionStateMachine(onEnter, onLeft, onOperator, onRight, onExit, foldState);
        return trampoline;
        function trampoline(node, outerState) {
          var resultHolder = { value: void 0 };
          var stateStack = [BinaryExpressionState.enter];
          var nodeStack = [node];
          var userStateStack = [void 0];
          var stackIndex = 0;
          while (stateStack[stackIndex] !== BinaryExpressionState.done) {
            stackIndex = stateStack[stackIndex](machine, stackIndex, stateStack, nodeStack, userStateStack, resultHolder, outerState);
          }
          ts3.Debug.assertEqual(stackIndex, 0);
          return resultHolder.value;
        }
      }
      ts3.createBinaryExpressionTrampoline = createBinaryExpressionTrampoline;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function setTextRange(range, location) {
        return location ? ts3.setTextRangePosEnd(range, location.pos, location.end) : range;
      }
      ts3.setTextRange = setTextRange;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SignatureFlags;
      (function(SignatureFlags2) {
        SignatureFlags2[SignatureFlags2["None"] = 0] = "None";
        SignatureFlags2[SignatureFlags2["Yield"] = 1] = "Yield";
        SignatureFlags2[SignatureFlags2["Await"] = 2] = "Await";
        SignatureFlags2[SignatureFlags2["Type"] = 4] = "Type";
        SignatureFlags2[SignatureFlags2["IgnoreMissingOpenBrace"] = 16] = "IgnoreMissingOpenBrace";
        SignatureFlags2[SignatureFlags2["JSDoc"] = 32] = "JSDoc";
      })(SignatureFlags || (SignatureFlags = {}));
      var SpeculationKind;
      (function(SpeculationKind2) {
        SpeculationKind2[SpeculationKind2["TryParse"] = 0] = "TryParse";
        SpeculationKind2[SpeculationKind2["Lookahead"] = 1] = "Lookahead";
        SpeculationKind2[SpeculationKind2["Reparse"] = 2] = "Reparse";
      })(SpeculationKind || (SpeculationKind = {}));
      var NodeConstructor;
      var TokenConstructor;
      var IdentifierConstructor;
      var PrivateIdentifierConstructor;
      var SourceFileConstructor;
      ts3.parseBaseNodeFactory = {
        createBaseSourceFileNode: function(kind) {
          return new (SourceFileConstructor || (SourceFileConstructor = ts3.objectAllocator.getSourceFileConstructor()))(kind, -1, -1);
        },
        createBaseIdentifierNode: function(kind) {
          return new (IdentifierConstructor || (IdentifierConstructor = ts3.objectAllocator.getIdentifierConstructor()))(kind, -1, -1);
        },
        createBasePrivateIdentifierNode: function(kind) {
          return new (PrivateIdentifierConstructor || (PrivateIdentifierConstructor = ts3.objectAllocator.getPrivateIdentifierConstructor()))(kind, -1, -1);
        },
        createBaseTokenNode: function(kind) {
          return new (TokenConstructor || (TokenConstructor = ts3.objectAllocator.getTokenConstructor()))(kind, -1, -1);
        },
        createBaseNode: function(kind) {
          return new (NodeConstructor || (NodeConstructor = ts3.objectAllocator.getNodeConstructor()))(kind, -1, -1);
        }
      };
      ts3.parseNodeFactory = ts3.createNodeFactory(1, ts3.parseBaseNodeFactory);
      function visitNode(cbNode, node) {
        return node && cbNode(node);
      }
      function visitNodes(cbNode, cbNodes, nodes) {
        if (nodes) {
          if (cbNodes) {
            return cbNodes(nodes);
          }
          for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
            var node = nodes_1[_i];
            var result2 = cbNode(node);
            if (result2) {
              return result2;
            }
          }
        }
      }
      function isJSDocLikeText(text, start) {
        return text.charCodeAt(start + 1) === 42 && text.charCodeAt(start + 2) === 42 && text.charCodeAt(start + 3) !== 47;
      }
      ts3.isJSDocLikeText = isJSDocLikeText;
      function isFileProbablyExternalModule(sourceFile) {
        return ts3.forEach(sourceFile.statements, isAnExternalModuleIndicatorNode) || getImportMetaIfNecessary(sourceFile);
      }
      ts3.isFileProbablyExternalModule = isFileProbablyExternalModule;
      function isAnExternalModuleIndicatorNode(node) {
        return hasModifierOfKind(node, 93) || ts3.isImportEqualsDeclaration(node) && ts3.isExternalModuleReference(node.moduleReference) || ts3.isImportDeclaration(node) || ts3.isExportAssignment(node) || ts3.isExportDeclaration(node) ? node : void 0;
      }
      function getImportMetaIfNecessary(sourceFile) {
        return sourceFile.flags & 4194304 ? walkTreeForImportMeta(sourceFile) : void 0;
      }
      function walkTreeForImportMeta(node) {
        return isImportMeta(node) ? node : forEachChild(node, walkTreeForImportMeta);
      }
      function hasModifierOfKind(node, kind) {
        return ts3.some(node.modifiers, function(m) {
          return m.kind === kind;
        });
      }
      function isImportMeta(node) {
        return ts3.isMetaProperty(node) && node.keywordToken === 100 && node.name.escapedText === "meta";
      }
      function forEachChild(node, cbNode, cbNodes) {
        if (!node || node.kind <= 160) {
          return;
        }
        switch (node.kind) {
          case 161:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.right);
          case 163:
            return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.constraint) || visitNode(cbNode, node.default) || visitNode(cbNode, node.expression);
          case 297:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.equalsToken) || visitNode(cbNode, node.objectAssignmentInitializer);
          case 298:
            return visitNode(cbNode, node.expression);
          case 164:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 167:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 166:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 296:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.initializer);
          case 254:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 203:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.propertyName) || visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 179:
          case 180:
          case 174:
          case 175:
          case 176:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type);
          case 169:
          case 168:
          case 171:
          case 172:
          case 173:
          case 213:
          case 256:
          case 214:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.asteriskToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type) || visitNode(cbNode, node.equalsGreaterThanToken) || visitNode(cbNode, node.body);
          case 170:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.body);
          case 178:
            return visitNode(cbNode, node.typeName) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 177:
            return visitNode(cbNode, node.assertsModifier) || visitNode(cbNode, node.parameterName) || visitNode(cbNode, node.type);
          case 181:
            return visitNode(cbNode, node.exprName) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 182:
            return visitNodes(cbNode, cbNodes, node.members);
          case 183:
            return visitNode(cbNode, node.elementType);
          case 184:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 187:
          case 188:
            return visitNodes(cbNode, cbNodes, node.types);
          case 189:
            return visitNode(cbNode, node.checkType) || visitNode(cbNode, node.extendsType) || visitNode(cbNode, node.trueType) || visitNode(cbNode, node.falseType);
          case 190:
            return visitNode(cbNode, node.typeParameter);
          case 200:
            return visitNode(cbNode, node.argument) || visitNode(cbNode, node.assertions) || visitNode(cbNode, node.qualifier) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 295:
            return visitNode(cbNode, node.assertClause);
          case 191:
          case 193:
            return visitNode(cbNode, node.type);
          case 194:
            return visitNode(cbNode, node.objectType) || visitNode(cbNode, node.indexType);
          case 195:
            return visitNode(cbNode, node.readonlyToken) || visitNode(cbNode, node.typeParameter) || visitNode(cbNode, node.nameType) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNodes(cbNode, cbNodes, node.members);
          case 196:
            return visitNode(cbNode, node.literal);
          case 197:
            return visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type);
          case 201:
          case 202:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 204:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 205:
            return visitNodes(cbNode, cbNodes, node.properties);
          case 206:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNode(cbNode, node.name);
          case 207:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNode(cbNode, node.argumentExpression);
          case 208:
          case 209:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNodes(cbNode, cbNodes, node.arguments);
          case 210:
            return visitNode(cbNode, node.tag) || visitNode(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode(cbNode, node.template);
          case 211:
            return visitNode(cbNode, node.type) || visitNode(cbNode, node.expression);
          case 212:
            return visitNode(cbNode, node.expression);
          case 215:
            return visitNode(cbNode, node.expression);
          case 216:
            return visitNode(cbNode, node.expression);
          case 217:
            return visitNode(cbNode, node.expression);
          case 219:
            return visitNode(cbNode, node.operand);
          case 224:
            return visitNode(cbNode, node.asteriskToken) || visitNode(cbNode, node.expression);
          case 218:
            return visitNode(cbNode, node.expression);
          case 220:
            return visitNode(cbNode, node.operand);
          case 221:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.operatorToken) || visitNode(cbNode, node.right);
          case 229:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.type);
          case 230:
            return visitNode(cbNode, node.expression);
          case 231:
            return visitNode(cbNode, node.name);
          case 222:
            return visitNode(cbNode, node.condition) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.whenTrue) || visitNode(cbNode, node.colonToken) || visitNode(cbNode, node.whenFalse);
          case 225:
            return visitNode(cbNode, node.expression);
          case 235:
          case 262:
            return visitNodes(cbNode, cbNodes, node.statements);
          case 305:
            return visitNodes(cbNode, cbNodes, node.statements) || visitNode(cbNode, node.endOfFileToken);
          case 237:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.declarationList);
          case 255:
            return visitNodes(cbNode, cbNodes, node.declarations);
          case 238:
            return visitNode(cbNode, node.expression);
          case 239:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.thenStatement) || visitNode(cbNode, node.elseStatement);
          case 240:
            return visitNode(cbNode, node.statement) || visitNode(cbNode, node.expression);
          case 241:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 242:
            return visitNode(cbNode, node.initializer) || visitNode(cbNode, node.condition) || visitNode(cbNode, node.incrementor) || visitNode(cbNode, node.statement);
          case 243:
            return visitNode(cbNode, node.initializer) || visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 244:
            return visitNode(cbNode, node.awaitModifier) || visitNode(cbNode, node.initializer) || visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 245:
          case 246:
            return visitNode(cbNode, node.label);
          case 247:
            return visitNode(cbNode, node.expression);
          case 248:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 249:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.caseBlock);
          case 263:
            return visitNodes(cbNode, cbNodes, node.clauses);
          case 289:
            return visitNode(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.statements);
          case 290:
            return visitNodes(cbNode, cbNodes, node.statements);
          case 250:
            return visitNode(cbNode, node.label) || visitNode(cbNode, node.statement);
          case 251:
            return visitNode(cbNode, node.expression);
          case 252:
            return visitNode(cbNode, node.tryBlock) || visitNode(cbNode, node.catchClause) || visitNode(cbNode, node.finallyBlock);
          case 292:
            return visitNode(cbNode, node.variableDeclaration) || visitNode(cbNode, node.block);
          case 165:
            return visitNode(cbNode, node.expression);
          case 257:
          case 226:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
          case 258:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
          case 259:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNode(cbNode, node.type);
          case 260:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.members);
          case 299:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 261:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.body);
          case 265:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.moduleReference);
          case 266:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.importClause) || visitNode(cbNode, node.moduleSpecifier) || visitNode(cbNode, node.assertClause);
          case 267:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.namedBindings);
          case 293:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 294:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.value);
          case 264:
            return visitNode(cbNode, node.name);
          case 268:
            return visitNode(cbNode, node.name);
          case 274:
            return visitNode(cbNode, node.name);
          case 269:
          case 273:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 272:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.exportClause) || visitNode(cbNode, node.moduleSpecifier) || visitNode(cbNode, node.assertClause);
          case 270:
          case 275:
            return visitNode(cbNode, node.propertyName) || visitNode(cbNode, node.name);
          case 271:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.expression);
          case 223:
            return visitNode(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
          case 233:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
          case 198:
            return visitNode(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
          case 199:
            return visitNode(cbNode, node.type) || visitNode(cbNode, node.literal);
          case 162:
            return visitNode(cbNode, node.expression);
          case 291:
            return visitNodes(cbNode, cbNodes, node.types);
          case 228:
            return visitNode(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 277:
            return visitNode(cbNode, node.expression);
          case 276:
            return visitNodes(cbNode, cbNodes, node.decorators);
          case 351:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 278:
            return visitNode(cbNode, node.openingElement) || visitNodes(cbNode, cbNodes, node.children) || visitNode(cbNode, node.closingElement);
          case 282:
            return visitNode(cbNode, node.openingFragment) || visitNodes(cbNode, cbNodes, node.children) || visitNode(cbNode, node.closingFragment);
          case 279:
          case 280:
            return visitNode(cbNode, node.tagName) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode(cbNode, node.attributes);
          case 286:
            return visitNodes(cbNode, cbNodes, node.properties);
          case 285:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 287:
            return visitNode(cbNode, node.expression);
          case 288:
            return visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.expression);
          case 281:
            return visitNode(cbNode, node.tagName);
          case 185:
          case 186:
          case 309:
          case 315:
          case 314:
          case 316:
          case 318:
            return visitNode(cbNode, node.type);
          case 317:
            return visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type);
          case 320:
            return (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) || visitNodes(cbNode, cbNodes, node.tags);
          case 346:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.name) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 310:
            return visitNode(cbNode, node.name);
          case 311:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.right);
          case 340:
          case 347:
            return visitNode(cbNode, node.tagName) || (node.isNameFirst ? visitNode(cbNode, node.name) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) : visitNode(cbNode, node.typeExpression) || visitNode(cbNode, node.name) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)));
          case 330:
            return visitNode(cbNode, node.tagName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 329:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.class) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 328:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.class) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 344:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.constraint) || visitNodes(cbNode, cbNodes, node.typeParameters) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 345:
            return visitNode(cbNode, node.tagName) || (node.typeExpression && node.typeExpression.kind === 309 ? visitNode(cbNode, node.typeExpression) || visitNode(cbNode, node.fullName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) : visitNode(cbNode, node.fullName) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)));
          case 338:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.fullName) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 341:
          case 343:
          case 342:
          case 339:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 323:
            return ts3.forEach(node.typeParameters, cbNode) || ts3.forEach(node.parameters, cbNode) || visitNode(cbNode, node.type);
          case 324:
          case 325:
          case 326:
            return visitNode(cbNode, node.name);
          case 322:
            return ts3.forEach(node.jsDocPropertyTags, cbNode);
          case 327:
          case 332:
          case 333:
          case 334:
          case 335:
          case 336:
          case 331:
            return visitNode(cbNode, node.tagName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 350:
            return visitNode(cbNode, node.expression);
        }
      }
      ts3.forEachChild = forEachChild;
      function forEachChildRecursively(rootNode, cbNode, cbNodes) {
        var queue = gatherPossibleChildren(rootNode);
        var parents = [];
        while (parents.length < queue.length) {
          parents.push(rootNode);
        }
        while (queue.length !== 0) {
          var current = queue.pop();
          var parent = parents.pop();
          if (ts3.isArray(current)) {
            if (cbNodes) {
              var res = cbNodes(current, parent);
              if (res) {
                if (res === "skip")
                  continue;
                return res;
              }
            }
            for (var i = current.length - 1; i >= 0; --i) {
              queue.push(current[i]);
              parents.push(parent);
            }
          } else {
            var res = cbNode(current, parent);
            if (res) {
              if (res === "skip")
                continue;
              return res;
            }
            if (current.kind >= 161) {
              for (var _i = 0, _a = gatherPossibleChildren(current); _i < _a.length; _i++) {
                var child = _a[_i];
                queue.push(child);
                parents.push(current);
              }
            }
          }
        }
      }
      ts3.forEachChildRecursively = forEachChildRecursively;
      function gatherPossibleChildren(node) {
        var children = [];
        forEachChild(node, addWorkItem, addWorkItem);
        return children;
        function addWorkItem(n) {
          children.unshift(n);
        }
      }
      function setExternalModuleIndicator(sourceFile) {
        sourceFile.externalModuleIndicator = isFileProbablyExternalModule(sourceFile);
      }
      function createSourceFile(fileName2, sourceText, languageVersionOrOptions, setParentNodes, scriptKind) {
        if (setParentNodes === void 0) {
          setParentNodes = false;
        }
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("parse", "createSourceFile", { path: fileName2 }, true);
        ts3.performance.mark("beforeParse");
        var result2;
        ts3.perfLogger.logStartParseSourceFile(fileName2);
        var _a = typeof languageVersionOrOptions === "object" ? languageVersionOrOptions : { languageVersion: languageVersionOrOptions }, languageVersion = _a.languageVersion, overrideSetExternalModuleIndicator = _a.setExternalModuleIndicator, format = _a.impliedNodeFormat;
        if (languageVersion === 100) {
          result2 = Parser.parseSourceFile(fileName2, sourceText, languageVersion, void 0, setParentNodes, 6, ts3.noop);
        } else {
          var setIndicator = format === void 0 ? overrideSetExternalModuleIndicator : function(file) {
            file.impliedNodeFormat = format;
            return (overrideSetExternalModuleIndicator || setExternalModuleIndicator)(file);
          };
          result2 = Parser.parseSourceFile(fileName2, sourceText, languageVersion, void 0, setParentNodes, scriptKind, setIndicator);
        }
        ts3.perfLogger.logStopParseSourceFile();
        ts3.performance.mark("afterParse");
        ts3.performance.measure("Parse", "beforeParse", "afterParse");
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        return result2;
      }
      ts3.createSourceFile = createSourceFile;
      function parseIsolatedEntityName(text, languageVersion) {
        return Parser.parseIsolatedEntityName(text, languageVersion);
      }
      ts3.parseIsolatedEntityName = parseIsolatedEntityName;
      function parseJsonText(fileName2, sourceText) {
        return Parser.parseJsonText(fileName2, sourceText);
      }
      ts3.parseJsonText = parseJsonText;
      function isExternalModule(file) {
        return file.externalModuleIndicator !== void 0;
      }
      ts3.isExternalModule = isExternalModule;
      function updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks) {
        if (aggressiveChecks === void 0) {
          aggressiveChecks = false;
        }
        var newSourceFile = IncrementalParser.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
        newSourceFile.flags |= sourceFile.flags & 6291456;
        return newSourceFile;
      }
      ts3.updateSourceFile = updateSourceFile;
      function parseIsolatedJSDocComment(content, start, length) {
        var result2 = Parser.JSDocParser.parseIsolatedJSDocComment(content, start, length);
        if (result2 && result2.jsDoc) {
          Parser.fixupParentReferences(result2.jsDoc);
        }
        return result2;
      }
      ts3.parseIsolatedJSDocComment = parseIsolatedJSDocComment;
      function parseJSDocTypeExpressionForTests(content, start, length) {
        return Parser.JSDocParser.parseJSDocTypeExpressionForTests(content, start, length);
      }
      ts3.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests;
      var Parser;
      (function(Parser2) {
        var scanner = ts3.createScanner(99, true);
        var disallowInAndDecoratorContext = 4096 | 16384;
        var NodeConstructor2;
        var TokenConstructor2;
        var IdentifierConstructor2;
        var PrivateIdentifierConstructor2;
        var SourceFileConstructor2;
        function countNode(node) {
          nodeCount++;
          return node;
        }
        var baseNodeFactory = {
          createBaseSourceFileNode: function(kind) {
            return countNode(new SourceFileConstructor2(kind, 0, 0));
          },
          createBaseIdentifierNode: function(kind) {
            return countNode(new IdentifierConstructor2(kind, 0, 0));
          },
          createBasePrivateIdentifierNode: function(kind) {
            return countNode(new PrivateIdentifierConstructor2(kind, 0, 0));
          },
          createBaseTokenNode: function(kind) {
            return countNode(new TokenConstructor2(kind, 0, 0));
          },
          createBaseNode: function(kind) {
            return countNode(new NodeConstructor2(kind, 0, 0));
          }
        };
        var factory = ts3.createNodeFactory(1 | 2 | 8, baseNodeFactory);
        var fileName2;
        var sourceFlags;
        var sourceText;
        var languageVersion;
        var scriptKind;
        var languageVariant;
        var parseDiagnostics;
        var jsDocDiagnostics;
        var syntaxCursor;
        var currentToken;
        var nodeCount;
        var identifiers;
        var privateIdentifiers;
        var identifierCount;
        var parsingContext;
        var notParenthesizedArrow;
        var contextFlags;
        var topLevel = true;
        var parseErrorBeforeNextFinishedNode = false;
        function parseSourceFile(fileName3, sourceText2, languageVersion2, syntaxCursor2, setParentNodes, scriptKind2, setExternalModuleIndicatorOverride) {
          var _a;
          if (setParentNodes === void 0) {
            setParentNodes = false;
          }
          scriptKind2 = ts3.ensureScriptKind(fileName3, scriptKind2);
          if (scriptKind2 === 6) {
            var result_3 = parseJsonText2(fileName3, sourceText2, languageVersion2, syntaxCursor2, setParentNodes);
            ts3.convertToObjectWorker(result_3, (_a = result_3.statements[0]) === null || _a === void 0 ? void 0 : _a.expression, result_3.parseDiagnostics, false, void 0, void 0);
            result_3.referencedFiles = ts3.emptyArray;
            result_3.typeReferenceDirectives = ts3.emptyArray;
            result_3.libReferenceDirectives = ts3.emptyArray;
            result_3.amdDependencies = ts3.emptyArray;
            result_3.hasNoDefaultLib = false;
            result_3.pragmas = ts3.emptyMap;
            return result_3;
          }
          initializeState(fileName3, sourceText2, languageVersion2, syntaxCursor2, scriptKind2);
          var result2 = parseSourceFileWorker(languageVersion2, setParentNodes, scriptKind2, setExternalModuleIndicatorOverride || setExternalModuleIndicator);
          clearState();
          return result2;
        }
        Parser2.parseSourceFile = parseSourceFile;
        function parseIsolatedEntityName2(content, languageVersion2) {
          initializeState("", content, languageVersion2, void 0, 1);
          nextToken();
          var entityName = parseEntityName(true);
          var isInvalid = token() === 1 && !parseDiagnostics.length;
          clearState();
          return isInvalid ? entityName : void 0;
        }
        Parser2.parseIsolatedEntityName = parseIsolatedEntityName2;
        function parseJsonText2(fileName3, sourceText2, languageVersion2, syntaxCursor2, setParentNodes) {
          if (languageVersion2 === void 0) {
            languageVersion2 = 2;
          }
          if (setParentNodes === void 0) {
            setParentNodes = false;
          }
          initializeState(fileName3, sourceText2, languageVersion2, syntaxCursor2, 6);
          sourceFlags = contextFlags;
          nextToken();
          var pos = getNodePos();
          var statements, endOfFileToken;
          if (token() === 1) {
            statements = createNodeArray([], pos, pos);
            endOfFileToken = parseTokenNode();
          } else {
            var expressions = void 0;
            while (token() !== 1) {
              var expression_1 = void 0;
              switch (token()) {
                case 22:
                  expression_1 = parseArrayLiteralExpression();
                  break;
                case 110:
                case 95:
                case 104:
                  expression_1 = parseTokenNode();
                  break;
                case 40:
                  if (lookAhead(function() {
                    return nextToken() === 8 && nextToken() !== 58;
                  })) {
                    expression_1 = parsePrefixUnaryExpression();
                  } else {
                    expression_1 = parseObjectLiteralExpression();
                  }
                  break;
                case 8:
                case 10:
                  if (lookAhead(function() {
                    return nextToken() !== 58;
                  })) {
                    expression_1 = parseLiteralNode();
                    break;
                  }
                default:
                  expression_1 = parseObjectLiteralExpression();
                  break;
              }
              if (expressions && ts3.isArray(expressions)) {
                expressions.push(expression_1);
              } else if (expressions) {
                expressions = [expressions, expression_1];
              } else {
                expressions = expression_1;
                if (token() !== 1) {
                  parseErrorAtCurrentToken(ts3.Diagnostics.Unexpected_token);
                }
              }
            }
            var expression = ts3.isArray(expressions) ? finishNode(factory.createArrayLiteralExpression(expressions), pos) : ts3.Debug.checkDefined(expressions);
            var statement = factory.createExpressionStatement(expression);
            finishNode(statement, pos);
            statements = createNodeArray([statement], pos);
            endOfFileToken = parseExpectedToken(1, ts3.Diagnostics.Unexpected_token);
          }
          var sourceFile = createSourceFile2(fileName3, 2, 6, false, statements, endOfFileToken, sourceFlags, ts3.noop);
          if (setParentNodes) {
            fixupParentReferences(sourceFile);
          }
          sourceFile.nodeCount = nodeCount;
          sourceFile.identifierCount = identifierCount;
          sourceFile.identifiers = identifiers;
          sourceFile.parseDiagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
          if (jsDocDiagnostics) {
            sourceFile.jsDocDiagnostics = ts3.attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
          }
          var result2 = sourceFile;
          clearState();
          return result2;
        }
        Parser2.parseJsonText = parseJsonText2;
        function initializeState(_fileName, _sourceText, _languageVersion, _syntaxCursor, _scriptKind) {
          NodeConstructor2 = ts3.objectAllocator.getNodeConstructor();
          TokenConstructor2 = ts3.objectAllocator.getTokenConstructor();
          IdentifierConstructor2 = ts3.objectAllocator.getIdentifierConstructor();
          PrivateIdentifierConstructor2 = ts3.objectAllocator.getPrivateIdentifierConstructor();
          SourceFileConstructor2 = ts3.objectAllocator.getSourceFileConstructor();
          fileName2 = ts3.normalizePath(_fileName);
          sourceText = _sourceText;
          languageVersion = _languageVersion;
          syntaxCursor = _syntaxCursor;
          scriptKind = _scriptKind;
          languageVariant = ts3.getLanguageVariant(_scriptKind);
          parseDiagnostics = [];
          parsingContext = 0;
          identifiers = new ts3.Map();
          privateIdentifiers = new ts3.Map();
          identifierCount = 0;
          nodeCount = 0;
          sourceFlags = 0;
          topLevel = true;
          switch (scriptKind) {
            case 1:
            case 2:
              contextFlags = 262144;
              break;
            case 6:
              contextFlags = 262144 | 67108864;
              break;
            default:
              contextFlags = 0;
              break;
          }
          parseErrorBeforeNextFinishedNode = false;
          scanner.setText(sourceText);
          scanner.setOnError(scanError);
          scanner.setScriptTarget(languageVersion);
          scanner.setLanguageVariant(languageVariant);
        }
        function clearState() {
          scanner.clearCommentDirectives();
          scanner.setText("");
          scanner.setOnError(void 0);
          sourceText = void 0;
          languageVersion = void 0;
          syntaxCursor = void 0;
          scriptKind = void 0;
          languageVariant = void 0;
          sourceFlags = 0;
          parseDiagnostics = void 0;
          jsDocDiagnostics = void 0;
          parsingContext = 0;
          identifiers = void 0;
          notParenthesizedArrow = void 0;
          topLevel = true;
        }
        function parseSourceFileWorker(languageVersion2, setParentNodes, scriptKind2, setExternalModuleIndicator2) {
          var isDeclarationFile = isDeclarationFileName(fileName2);
          if (isDeclarationFile) {
            contextFlags |= 16777216;
          }
          sourceFlags = contextFlags;
          nextToken();
          var statements = parseList(0, parseStatement);
          ts3.Debug.assert(token() === 1);
          var endOfFileToken = addJSDocComment(parseTokenNode());
          var sourceFile = createSourceFile2(fileName2, languageVersion2, scriptKind2, isDeclarationFile, statements, endOfFileToken, sourceFlags, setExternalModuleIndicator2);
          processCommentPragmas(sourceFile, sourceText);
          processPragmasIntoFields(sourceFile, reportPragmaDiagnostic);
          sourceFile.commentDirectives = scanner.getCommentDirectives();
          sourceFile.nodeCount = nodeCount;
          sourceFile.identifierCount = identifierCount;
          sourceFile.identifiers = identifiers;
          sourceFile.parseDiagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
          if (jsDocDiagnostics) {
            sourceFile.jsDocDiagnostics = ts3.attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
          }
          if (setParentNodes) {
            fixupParentReferences(sourceFile);
          }
          return sourceFile;
          function reportPragmaDiagnostic(pos, end, diagnostic) {
            parseDiagnostics.push(ts3.createDetachedDiagnostic(fileName2, pos, end, diagnostic));
          }
        }
        function withJSDoc(node, hasJSDoc) {
          return hasJSDoc ? addJSDocComment(node) : node;
        }
        var hasDeprecatedTag = false;
        function addJSDocComment(node) {
          ts3.Debug.assert(!node.jsDoc);
          var jsDoc = ts3.mapDefined(ts3.getJSDocCommentRanges(node, sourceText), function(comment) {
            return JSDocParser.parseJSDocComment(node, comment.pos, comment.end - comment.pos);
          });
          if (jsDoc.length)
            node.jsDoc = jsDoc;
          if (hasDeprecatedTag) {
            hasDeprecatedTag = false;
            node.flags |= 268435456;
          }
          return node;
        }
        function reparseTopLevelAwait(sourceFile) {
          var savedSyntaxCursor = syntaxCursor;
          var baseSyntaxCursor = IncrementalParser.createSyntaxCursor(sourceFile);
          syntaxCursor = { currentNode: currentNode2 };
          var statements = [];
          var savedParseDiagnostics = parseDiagnostics;
          parseDiagnostics = [];
          var pos = 0;
          var start = findNextStatementWithAwait(sourceFile.statements, 0);
          var _loop_3 = function() {
            var prevStatement = sourceFile.statements[pos];
            var nextStatement = sourceFile.statements[start];
            ts3.addRange(statements, sourceFile.statements, pos, start);
            pos = findNextStatementWithoutAwait(sourceFile.statements, start);
            var diagnosticStart2 = ts3.findIndex(savedParseDiagnostics, function(diagnostic) {
              return diagnostic.start >= prevStatement.pos;
            });
            var diagnosticEnd = diagnosticStart2 >= 0 ? ts3.findIndex(savedParseDiagnostics, function(diagnostic) {
              return diagnostic.start >= nextStatement.pos;
            }, diagnosticStart2) : -1;
            if (diagnosticStart2 >= 0) {
              ts3.addRange(parseDiagnostics, savedParseDiagnostics, diagnosticStart2, diagnosticEnd >= 0 ? diagnosticEnd : void 0);
            }
            speculationHelper(function() {
              var savedContextFlags = contextFlags;
              contextFlags |= 32768;
              scanner.setTextPos(nextStatement.pos);
              nextToken();
              while (token() !== 1) {
                var startPos = scanner.getStartPos();
                var statement = parseListElement(0, parseStatement);
                statements.push(statement);
                if (startPos === scanner.getStartPos()) {
                  nextToken();
                }
                if (pos >= 0) {
                  var nonAwaitStatement = sourceFile.statements[pos];
                  if (statement.end === nonAwaitStatement.pos) {
                    break;
                  }
                  if (statement.end > nonAwaitStatement.pos) {
                    pos = findNextStatementWithoutAwait(sourceFile.statements, pos + 1);
                  }
                }
              }
              contextFlags = savedContextFlags;
            }, 2);
            start = pos >= 0 ? findNextStatementWithAwait(sourceFile.statements, pos) : -1;
          };
          while (start !== -1) {
            _loop_3();
          }
          if (pos >= 0) {
            var prevStatement_1 = sourceFile.statements[pos];
            ts3.addRange(statements, sourceFile.statements, pos);
            var diagnosticStart = ts3.findIndex(savedParseDiagnostics, function(diagnostic) {
              return diagnostic.start >= prevStatement_1.pos;
            });
            if (diagnosticStart >= 0) {
              ts3.addRange(parseDiagnostics, savedParseDiagnostics, diagnosticStart);
            }
          }
          syntaxCursor = savedSyntaxCursor;
          return factory.updateSourceFile(sourceFile, ts3.setTextRange(factory.createNodeArray(statements), sourceFile.statements));
          function containsPossibleTopLevelAwait(node) {
            return !(node.flags & 32768) && !!(node.transformFlags & 16777216);
          }
          function findNextStatementWithAwait(statements2, start2) {
            for (var i = start2; i < statements2.length; i++) {
              if (containsPossibleTopLevelAwait(statements2[i])) {
                return i;
              }
            }
            return -1;
          }
          function findNextStatementWithoutAwait(statements2, start2) {
            for (var i = start2; i < statements2.length; i++) {
              if (!containsPossibleTopLevelAwait(statements2[i])) {
                return i;
              }
            }
            return -1;
          }
          function currentNode2(position) {
            var node = baseSyntaxCursor.currentNode(position);
            if (topLevel && node && containsPossibleTopLevelAwait(node)) {
              node.intersectsChange = true;
            }
            return node;
          }
        }
        function fixupParentReferences(rootNode) {
          ts3.setParentRecursive(rootNode, true);
        }
        Parser2.fixupParentReferences = fixupParentReferences;
        function createSourceFile2(fileName3, languageVersion2, scriptKind2, isDeclarationFile, statements, endOfFileToken, flags, setExternalModuleIndicator2) {
          var sourceFile = factory.createSourceFile(statements, endOfFileToken, flags);
          ts3.setTextRangePosWidth(sourceFile, 0, sourceText.length);
          setFields(sourceFile);
          if (!isDeclarationFile && isExternalModule(sourceFile) && sourceFile.transformFlags & 16777216) {
            sourceFile = reparseTopLevelAwait(sourceFile);
            setFields(sourceFile);
          }
          return sourceFile;
          function setFields(sourceFile2) {
            sourceFile2.text = sourceText;
            sourceFile2.bindDiagnostics = [];
            sourceFile2.bindSuggestionDiagnostics = void 0;
            sourceFile2.languageVersion = languageVersion2;
            sourceFile2.fileName = fileName3;
            sourceFile2.languageVariant = ts3.getLanguageVariant(scriptKind2);
            sourceFile2.isDeclarationFile = isDeclarationFile;
            sourceFile2.scriptKind = scriptKind2;
            setExternalModuleIndicator2(sourceFile2);
            sourceFile2.setExternalModuleIndicator = setExternalModuleIndicator2;
          }
        }
        function setContextFlag(val, flag) {
          if (val) {
            contextFlags |= flag;
          } else {
            contextFlags &= ~flag;
          }
        }
        function setDisallowInContext(val) {
          setContextFlag(val, 4096);
        }
        function setYieldContext(val) {
          setContextFlag(val, 8192);
        }
        function setDecoratorContext(val) {
          setContextFlag(val, 16384);
        }
        function setAwaitContext(val) {
          setContextFlag(val, 32768);
        }
        function doOutsideOfContext(context, func) {
          var contextFlagsToClear = context & contextFlags;
          if (contextFlagsToClear) {
            setContextFlag(false, contextFlagsToClear);
            var result2 = func();
            setContextFlag(true, contextFlagsToClear);
            return result2;
          }
          return func();
        }
        function doInsideOfContext(context, func) {
          var contextFlagsToSet = context & ~contextFlags;
          if (contextFlagsToSet) {
            setContextFlag(true, contextFlagsToSet);
            var result2 = func();
            setContextFlag(false, contextFlagsToSet);
            return result2;
          }
          return func();
        }
        function allowInAnd(func) {
          return doOutsideOfContext(4096, func);
        }
        function disallowInAnd(func) {
          return doInsideOfContext(4096, func);
        }
        function allowConditionalTypesAnd(func) {
          return doOutsideOfContext(65536, func);
        }
        function disallowConditionalTypesAnd(func) {
          return doInsideOfContext(65536, func);
        }
        function doInYieldContext(func) {
          return doInsideOfContext(8192, func);
        }
        function doInDecoratorContext(func) {
          return doInsideOfContext(16384, func);
        }
        function doInAwaitContext(func) {
          return doInsideOfContext(32768, func);
        }
        function doOutsideOfAwaitContext(func) {
          return doOutsideOfContext(32768, func);
        }
        function doInYieldAndAwaitContext(func) {
          return doInsideOfContext(8192 | 32768, func);
        }
        function doOutsideOfYieldAndAwaitContext(func) {
          return doOutsideOfContext(8192 | 32768, func);
        }
        function inContext(flags) {
          return (contextFlags & flags) !== 0;
        }
        function inYieldContext() {
          return inContext(8192);
        }
        function inDisallowInContext() {
          return inContext(4096);
        }
        function inDisallowConditionalTypesContext() {
          return inContext(65536);
        }
        function inDecoratorContext() {
          return inContext(16384);
        }
        function inAwaitContext() {
          return inContext(32768);
        }
        function parseErrorAtCurrentToken(message, arg0) {
          return parseErrorAt(scanner.getTokenPos(), scanner.getTextPos(), message, arg0);
        }
        function parseErrorAtPosition(start, length, message, arg0) {
          var lastError = ts3.lastOrUndefined(parseDiagnostics);
          var result2;
          if (!lastError || start !== lastError.start) {
            result2 = ts3.createDetachedDiagnostic(fileName2, start, length, message, arg0);
            parseDiagnostics.push(result2);
          }
          parseErrorBeforeNextFinishedNode = true;
          return result2;
        }
        function parseErrorAt(start, end, message, arg0) {
          return parseErrorAtPosition(start, end - start, message, arg0);
        }
        function parseErrorAtRange(range, message, arg0) {
          parseErrorAt(range.pos, range.end, message, arg0);
        }
        function scanError(message, length) {
          parseErrorAtPosition(scanner.getTextPos(), length, message);
        }
        function getNodePos() {
          return scanner.getStartPos();
        }
        function hasPrecedingJSDocComment() {
          return scanner.hasPrecedingJSDocComment();
        }
        function token() {
          return currentToken;
        }
        function nextTokenWithoutCheck() {
          return currentToken = scanner.scan();
        }
        function nextTokenAnd(func) {
          nextToken();
          return func();
        }
        function nextToken() {
          if (ts3.isKeyword(currentToken) && (scanner.hasUnicodeEscape() || scanner.hasExtendedUnicodeEscape())) {
            parseErrorAt(scanner.getTokenPos(), scanner.getTextPos(), ts3.Diagnostics.Keywords_cannot_contain_escape_characters);
          }
          return nextTokenWithoutCheck();
        }
        function nextTokenJSDoc() {
          return currentToken = scanner.scanJsDocToken();
        }
        function reScanGreaterToken() {
          return currentToken = scanner.reScanGreaterToken();
        }
        function reScanSlashToken() {
          return currentToken = scanner.reScanSlashToken();
        }
        function reScanTemplateToken(isTaggedTemplate) {
          return currentToken = scanner.reScanTemplateToken(isTaggedTemplate);
        }
        function reScanTemplateHeadOrNoSubstitutionTemplate() {
          return currentToken = scanner.reScanTemplateHeadOrNoSubstitutionTemplate();
        }
        function reScanLessThanToken() {
          return currentToken = scanner.reScanLessThanToken();
        }
        function reScanHashToken() {
          return currentToken = scanner.reScanHashToken();
        }
        function scanJsxIdentifier() {
          return currentToken = scanner.scanJsxIdentifier();
        }
        function scanJsxText() {
          return currentToken = scanner.scanJsxToken();
        }
        function scanJsxAttributeValue() {
          return currentToken = scanner.scanJsxAttributeValue();
        }
        function speculationHelper(callback, speculationKind) {
          var saveToken = currentToken;
          var saveParseDiagnosticsLength = parseDiagnostics.length;
          var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
          var saveContextFlags = contextFlags;
          var result2 = speculationKind !== 0 ? scanner.lookAhead(callback) : scanner.tryScan(callback);
          ts3.Debug.assert(saveContextFlags === contextFlags);
          if (!result2 || speculationKind !== 0) {
            currentToken = saveToken;
            if (speculationKind !== 2) {
              parseDiagnostics.length = saveParseDiagnosticsLength;
            }
            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
          }
          return result2;
        }
        function lookAhead(callback) {
          return speculationHelper(callback, 1);
        }
        function tryParse(callback) {
          return speculationHelper(callback, 0);
        }
        function isBindingIdentifier() {
          if (token() === 79) {
            return true;
          }
          return token() > 116;
        }
        function isIdentifier() {
          if (token() === 79) {
            return true;
          }
          if (token() === 125 && inYieldContext()) {
            return false;
          }
          if (token() === 132 && inAwaitContext()) {
            return false;
          }
          return token() > 116;
        }
        function parseExpected(kind, diagnosticMessage, shouldAdvance) {
          if (shouldAdvance === void 0) {
            shouldAdvance = true;
          }
          if (token() === kind) {
            if (shouldAdvance) {
              nextToken();
            }
            return true;
          }
          if (diagnosticMessage) {
            parseErrorAtCurrentToken(diagnosticMessage);
          } else {
            parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(kind));
          }
          return false;
        }
        var viableKeywordSuggestions = Object.keys(ts3.textToKeywordObj).filter(function(keyword) {
          return keyword.length > 2;
        });
        function parseErrorForMissingSemicolonAfter(node) {
          var _a;
          if (ts3.isTaggedTemplateExpression(node)) {
            parseErrorAt(ts3.skipTrivia(sourceText, node.template.pos), node.template.end, ts3.Diagnostics.Module_declaration_names_may_only_use_or_quoted_strings);
            return;
          }
          var expressionText = ts3.isIdentifier(node) ? ts3.idText(node) : void 0;
          if (!expressionText || !ts3.isIdentifierText(expressionText, languageVersion)) {
            parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(26));
            return;
          }
          var pos = ts3.skipTrivia(sourceText, node.pos);
          switch (expressionText) {
            case "const":
            case "let":
            case "var":
              parseErrorAt(pos, node.end, ts3.Diagnostics.Variable_declaration_not_allowed_at_this_location);
              return;
            case "declare":
              return;
            case "interface":
              parseErrorForInvalidName(ts3.Diagnostics.Interface_name_cannot_be_0, ts3.Diagnostics.Interface_must_be_given_a_name, 18);
              return;
            case "is":
              parseErrorAt(pos, scanner.getTextPos(), ts3.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
              return;
            case "module":
            case "namespace":
              parseErrorForInvalidName(ts3.Diagnostics.Namespace_name_cannot_be_0, ts3.Diagnostics.Namespace_must_be_given_a_name, 18);
              return;
            case "type":
              parseErrorForInvalidName(ts3.Diagnostics.Type_alias_name_cannot_be_0, ts3.Diagnostics.Type_alias_must_be_given_a_name, 63);
              return;
          }
          var suggestion = (_a = ts3.getSpellingSuggestion(expressionText, viableKeywordSuggestions, function(n) {
            return n;
          })) !== null && _a !== void 0 ? _a : getSpaceSuggestion(expressionText);
          if (suggestion) {
            parseErrorAt(pos, node.end, ts3.Diagnostics.Unknown_keyword_or_identifier_Did_you_mean_0, suggestion);
            return;
          }
          if (token() === 0) {
            return;
          }
          parseErrorAt(pos, node.end, ts3.Diagnostics.Unexpected_keyword_or_identifier);
        }
        function parseErrorForInvalidName(nameDiagnostic, blankDiagnostic, tokenIfBlankName) {
          if (token() === tokenIfBlankName) {
            parseErrorAtCurrentToken(blankDiagnostic);
          } else {
            parseErrorAtCurrentToken(nameDiagnostic, scanner.getTokenValue());
          }
        }
        function getSpaceSuggestion(expressionText) {
          for (var _i = 0, viableKeywordSuggestions_1 = viableKeywordSuggestions; _i < viableKeywordSuggestions_1.length; _i++) {
            var keyword = viableKeywordSuggestions_1[_i];
            if (expressionText.length > keyword.length + 2 && ts3.startsWith(expressionText, keyword)) {
              return "".concat(keyword, " ").concat(expressionText.slice(keyword.length));
            }
          }
          return void 0;
        }
        function parseSemicolonAfterPropertyName(name, type2, initializer) {
          if (token() === 59 && !scanner.hasPrecedingLineBreak()) {
            parseErrorAtCurrentToken(ts3.Diagnostics.Decorators_must_precede_the_name_and_all_keywords_of_property_declarations);
            return;
          }
          if (token() === 20) {
            parseErrorAtCurrentToken(ts3.Diagnostics.Cannot_start_a_function_call_in_a_type_annotation);
            nextToken();
            return;
          }
          if (type2 && !canParseSemicolon()) {
            if (initializer) {
              parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(26));
            } else {
              parseErrorAtCurrentToken(ts3.Diagnostics.Expected_for_property_initializer);
            }
            return;
          }
          if (tryParseSemicolon()) {
            return;
          }
          if (initializer) {
            parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(26));
            return;
          }
          parseErrorForMissingSemicolonAfter(name);
        }
        function parseExpectedJSDoc(kind) {
          if (token() === kind) {
            nextTokenJSDoc();
            return true;
          }
          parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(kind));
          return false;
        }
        function parseExpectedMatchingBrackets(openKind, closeKind, openParsed, openPosition) {
          if (token() === closeKind) {
            nextToken();
            return;
          }
          var lastError = parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(closeKind));
          if (!openParsed) {
            return;
          }
          if (lastError) {
            ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName2, openPosition, 1, ts3.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, ts3.tokenToString(openKind), ts3.tokenToString(closeKind)));
          }
        }
        function parseOptional(t) {
          if (token() === t) {
            nextToken();
            return true;
          }
          return false;
        }
        function parseOptionalToken(t) {
          if (token() === t) {
            return parseTokenNode();
          }
          return void 0;
        }
        function parseOptionalTokenJSDoc(t) {
          if (token() === t) {
            return parseTokenNodeJSDoc();
          }
          return void 0;
        }
        function parseExpectedToken(t, diagnosticMessage, arg0) {
          return parseOptionalToken(t) || createMissingNode(t, false, diagnosticMessage || ts3.Diagnostics._0_expected, arg0 || ts3.tokenToString(t));
        }
        function parseExpectedTokenJSDoc(t) {
          return parseOptionalTokenJSDoc(t) || createMissingNode(t, false, ts3.Diagnostics._0_expected, ts3.tokenToString(t));
        }
        function parseTokenNode() {
          var pos = getNodePos();
          var kind = token();
          nextToken();
          return finishNode(factory.createToken(kind), pos);
        }
        function parseTokenNodeJSDoc() {
          var pos = getNodePos();
          var kind = token();
          nextTokenJSDoc();
          return finishNode(factory.createToken(kind), pos);
        }
        function canParseSemicolon() {
          if (token() === 26) {
            return true;
          }
          return token() === 19 || token() === 1 || scanner.hasPrecedingLineBreak();
        }
        function tryParseSemicolon() {
          if (!canParseSemicolon()) {
            return false;
          }
          if (token() === 26) {
            nextToken();
          }
          return true;
        }
        function parseSemicolon() {
          return tryParseSemicolon() || parseExpected(26);
        }
        function createNodeArray(elements, pos, end, hasTrailingComma) {
          var array = factory.createNodeArray(elements, hasTrailingComma);
          ts3.setTextRangePosEnd(array, pos, end !== null && end !== void 0 ? end : scanner.getStartPos());
          return array;
        }
        function finishNode(node, pos, end) {
          ts3.setTextRangePosEnd(node, pos, end !== null && end !== void 0 ? end : scanner.getStartPos());
          if (contextFlags) {
            node.flags |= contextFlags;
          }
          if (parseErrorBeforeNextFinishedNode) {
            parseErrorBeforeNextFinishedNode = false;
            node.flags |= 131072;
          }
          return node;
        }
        function createMissingNode(kind, reportAtCurrentPosition, diagnosticMessage, arg0) {
          if (reportAtCurrentPosition) {
            parseErrorAtPosition(scanner.getStartPos(), 0, diagnosticMessage, arg0);
          } else if (diagnosticMessage) {
            parseErrorAtCurrentToken(diagnosticMessage, arg0);
          }
          var pos = getNodePos();
          var result2 = kind === 79 ? factory.createIdentifier("", void 0, void 0) : ts3.isTemplateLiteralKind(kind) ? factory.createTemplateLiteralLikeNode(kind, "", "", void 0) : kind === 8 ? factory.createNumericLiteral("", void 0) : kind === 10 ? factory.createStringLiteral("", void 0) : kind === 276 ? factory.createMissingDeclaration() : factory.createToken(kind);
          return finishNode(result2, pos);
        }
        function internIdentifier(text) {
          var identifier = identifiers.get(text);
          if (identifier === void 0) {
            identifiers.set(text, identifier = text);
          }
          return identifier;
        }
        function createIdentifier(isIdentifier2, diagnosticMessage, privateIdentifierDiagnosticMessage) {
          if (isIdentifier2) {
            identifierCount++;
            var pos = getNodePos();
            var originalKeywordKind = token();
            var text = internIdentifier(scanner.getTokenValue());
            nextTokenWithoutCheck();
            return finishNode(factory.createIdentifier(text, void 0, originalKeywordKind), pos);
          }
          if (token() === 80) {
            parseErrorAtCurrentToken(privateIdentifierDiagnosticMessage || ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
            return createIdentifier(true);
          }
          if (token() === 0 && scanner.tryScan(function() {
            return scanner.reScanInvalidIdentifier() === 79;
          })) {
            return createIdentifier(true);
          }
          identifierCount++;
          var reportAtCurrentPosition = token() === 1;
          var isReservedWord = scanner.isReservedWord();
          var msgArg = scanner.getTokenText();
          var defaultMessage = isReservedWord ? ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here : ts3.Diagnostics.Identifier_expected;
          return createMissingNode(79, reportAtCurrentPosition, diagnosticMessage || defaultMessage, msgArg);
        }
        function parseBindingIdentifier(privateIdentifierDiagnosticMessage) {
          return createIdentifier(isBindingIdentifier(), void 0, privateIdentifierDiagnosticMessage);
        }
        function parseIdentifier(diagnosticMessage, privateIdentifierDiagnosticMessage) {
          return createIdentifier(isIdentifier(), diagnosticMessage, privateIdentifierDiagnosticMessage);
        }
        function parseIdentifierName(diagnosticMessage) {
          return createIdentifier(ts3.tokenIsIdentifierOrKeyword(token()), diagnosticMessage);
        }
        function isLiteralPropertyName() {
          return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 10 || token() === 8;
        }
        function isAssertionKey() {
          return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 10;
        }
        function parsePropertyNameWorker(allowComputedPropertyNames) {
          if (token() === 10 || token() === 8) {
            var node = parseLiteralNode();
            node.text = internIdentifier(node.text);
            return node;
          }
          if (allowComputedPropertyNames && token() === 22) {
            return parseComputedPropertyName();
          }
          if (token() === 80) {
            return parsePrivateIdentifier();
          }
          return parseIdentifierName();
        }
        function parsePropertyName() {
          return parsePropertyNameWorker(true);
        }
        function parseComputedPropertyName() {
          var pos = getNodePos();
          parseExpected(22);
          var expression = allowInAnd(parseExpression);
          parseExpected(23);
          return finishNode(factory.createComputedPropertyName(expression), pos);
        }
        function internPrivateIdentifier(text) {
          var privateIdentifier = privateIdentifiers.get(text);
          if (privateIdentifier === void 0) {
            privateIdentifiers.set(text, privateIdentifier = text);
          }
          return privateIdentifier;
        }
        function parsePrivateIdentifier() {
          var pos = getNodePos();
          var node = factory.createPrivateIdentifier(internPrivateIdentifier(scanner.getTokenText()));
          nextToken();
          return finishNode(node, pos);
        }
        function parseContextualModifier(t) {
          return token() === t && tryParse(nextTokenCanFollowModifier);
        }
        function nextTokenIsOnSameLineAndCanFollowModifier() {
          nextToken();
          if (scanner.hasPrecedingLineBreak()) {
            return false;
          }
          return canFollowModifier();
        }
        function nextTokenCanFollowModifier() {
          switch (token()) {
            case 85:
              return nextToken() === 92;
            case 93:
              nextToken();
              if (token() === 88) {
                return lookAhead(nextTokenCanFollowDefaultKeyword);
              }
              if (token() === 152) {
                return lookAhead(nextTokenCanFollowExportModifier);
              }
              return canFollowExportModifier();
            case 88:
              return nextTokenCanFollowDefaultKeyword();
            case 124:
            case 136:
            case 149:
              nextToken();
              return canFollowModifier();
            default:
              return nextTokenIsOnSameLineAndCanFollowModifier();
          }
        }
        function canFollowExportModifier() {
          return token() !== 41 && token() !== 127 && token() !== 18 && canFollowModifier();
        }
        function nextTokenCanFollowExportModifier() {
          nextToken();
          return canFollowExportModifier();
        }
        function parseAnyContextualModifier() {
          return ts3.isModifierKind(token()) && tryParse(nextTokenCanFollowModifier);
        }
        function canFollowModifier() {
          return token() === 22 || token() === 18 || token() === 41 || token() === 25 || isLiteralPropertyName();
        }
        function nextTokenCanFollowDefaultKeyword() {
          nextToken();
          return token() === 84 || token() === 98 || token() === 118 || token() === 126 && lookAhead(nextTokenIsClassKeywordOnSameLine) || token() === 131 && lookAhead(nextTokenIsFunctionKeywordOnSameLine);
        }
        function isListElement(parsingContext2, inErrorRecovery) {
          var node = currentNode(parsingContext2);
          if (node) {
            return true;
          }
          switch (parsingContext2) {
            case 0:
            case 1:
            case 3:
              return !(token() === 26 && inErrorRecovery) && isStartOfStatement();
            case 2:
              return token() === 82 || token() === 88;
            case 4:
              return lookAhead(isTypeMemberStart);
            case 5:
              return lookAhead(isClassMemberStart) || token() === 26 && !inErrorRecovery;
            case 6:
              return token() === 22 || isLiteralPropertyName();
            case 12:
              switch (token()) {
                case 22:
                case 41:
                case 25:
                case 24:
                  return true;
                default:
                  return isLiteralPropertyName();
              }
            case 18:
              return isLiteralPropertyName();
            case 9:
              return token() === 22 || token() === 25 || isLiteralPropertyName();
            case 24:
              return isAssertionKey();
            case 7:
              if (token() === 18) {
                return lookAhead(isValidHeritageClauseObjectLiteral);
              }
              if (!inErrorRecovery) {
                return isStartOfLeftHandSideExpression() && !isHeritageClauseExtendsOrImplementsKeyword();
              } else {
                return isIdentifier() && !isHeritageClauseExtendsOrImplementsKeyword();
              }
            case 8:
              return isBindingIdentifierOrPrivateIdentifierOrPattern();
            case 10:
              return token() === 27 || token() === 25 || isBindingIdentifierOrPrivateIdentifierOrPattern();
            case 19:
              return token() === 101 || isIdentifier();
            case 15:
              switch (token()) {
                case 27:
                case 24:
                  return true;
              }
            case 11:
              return token() === 25 || isStartOfExpression();
            case 16:
              return isStartOfParameter(false);
            case 17:
              return isStartOfParameter(true);
            case 20:
            case 21:
              return token() === 27 || isStartOfType();
            case 22:
              return isHeritageClause();
            case 23:
              return ts3.tokenIsIdentifierOrKeyword(token());
            case 13:
              return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 18;
            case 14:
              return true;
          }
          return ts3.Debug.fail("Non-exhaustive case in 'isListElement'.");
        }
        function isValidHeritageClauseObjectLiteral() {
          ts3.Debug.assert(token() === 18);
          if (nextToken() === 19) {
            var next = nextToken();
            return next === 27 || next === 18 || next === 94 || next === 117;
          }
          return true;
        }
        function nextTokenIsIdentifier() {
          nextToken();
          return isIdentifier();
        }
        function nextTokenIsIdentifierOrKeyword() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeyword(token());
        }
        function nextTokenIsIdentifierOrKeywordOrGreaterThan() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeywordOrGreaterThan(token());
        }
        function isHeritageClauseExtendsOrImplementsKeyword() {
          if (token() === 117 || token() === 94) {
            return lookAhead(nextTokenIsStartOfExpression);
          }
          return false;
        }
        function nextTokenIsStartOfExpression() {
          nextToken();
          return isStartOfExpression();
        }
        function nextTokenIsStartOfType() {
          nextToken();
          return isStartOfType();
        }
        function isListTerminator(kind) {
          if (token() === 1) {
            return true;
          }
          switch (kind) {
            case 1:
            case 2:
            case 4:
            case 5:
            case 6:
            case 12:
            case 9:
            case 23:
            case 24:
              return token() === 19;
            case 3:
              return token() === 19 || token() === 82 || token() === 88;
            case 7:
              return token() === 18 || token() === 94 || token() === 117;
            case 8:
              return isVariableDeclaratorListTerminator();
            case 19:
              return token() === 31 || token() === 20 || token() === 18 || token() === 94 || token() === 117;
            case 11:
              return token() === 21 || token() === 26;
            case 15:
            case 21:
            case 10:
              return token() === 23;
            case 17:
            case 16:
            case 18:
              return token() === 21 || token() === 23;
            case 20:
              return token() !== 27;
            case 22:
              return token() === 18 || token() === 19;
            case 13:
              return token() === 31 || token() === 43;
            case 14:
              return token() === 29 && lookAhead(nextTokenIsSlash);
            default:
              return false;
          }
        }
        function isVariableDeclaratorListTerminator() {
          if (canParseSemicolon()) {
            return true;
          }
          if (isInOrOfKeyword(token())) {
            return true;
          }
          if (token() === 38) {
            return true;
          }
          return false;
        }
        function isInSomeParsingContext() {
          for (var kind = 0; kind < 25; kind++) {
            if (parsingContext & 1 << kind) {
              if (isListElement(kind, true) || isListTerminator(kind)) {
                return true;
              }
            }
          }
          return false;
        }
        function parseList(kind, parseElement) {
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << kind;
          var list = [];
          var listPos = getNodePos();
          while (!isListTerminator(kind)) {
            if (isListElement(kind, false)) {
              list.push(parseListElement(kind, parseElement));
              continue;
            }
            if (abortParsingListOrMoveToNextToken(kind)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos);
        }
        function parseListElement(parsingContext2, parseElement) {
          var node = currentNode(parsingContext2);
          if (node) {
            return consumeNode(node);
          }
          return parseElement();
        }
        function currentNode(parsingContext2) {
          if (!syntaxCursor || !isReusableParsingContext(parsingContext2) || parseErrorBeforeNextFinishedNode) {
            return void 0;
          }
          var node = syntaxCursor.currentNode(scanner.getStartPos());
          if (ts3.nodeIsMissing(node) || node.intersectsChange || ts3.containsParseError(node)) {
            return void 0;
          }
          var nodeContextFlags = node.flags & 50720768;
          if (nodeContextFlags !== contextFlags) {
            return void 0;
          }
          if (!canReuseNode(node, parsingContext2)) {
            return void 0;
          }
          if (node.jsDocCache) {
            node.jsDocCache = void 0;
          }
          return node;
        }
        function consumeNode(node) {
          scanner.setTextPos(node.end);
          nextToken();
          return node;
        }
        function isReusableParsingContext(parsingContext2) {
          switch (parsingContext2) {
            case 5:
            case 2:
            case 0:
            case 1:
            case 3:
            case 6:
            case 4:
            case 8:
            case 17:
            case 16:
              return true;
          }
          return false;
        }
        function canReuseNode(node, parsingContext2) {
          switch (parsingContext2) {
            case 5:
              return isReusableClassMember(node);
            case 2:
              return isReusableSwitchClause(node);
            case 0:
            case 1:
            case 3:
              return isReusableStatement(node);
            case 6:
              return isReusableEnumMember(node);
            case 4:
              return isReusableTypeMember(node);
            case 8:
              return isReusableVariableDeclaration(node);
            case 17:
            case 16:
              return isReusableParameter(node);
          }
          return false;
        }
        function isReusableClassMember(node) {
          if (node) {
            switch (node.kind) {
              case 171:
              case 176:
              case 172:
              case 173:
              case 167:
              case 234:
                return true;
              case 169:
                var methodDeclaration = node;
                var nameIsConstructor = methodDeclaration.name.kind === 79 && methodDeclaration.name.originalKeywordKind === 134;
                return !nameIsConstructor;
            }
          }
          return false;
        }
        function isReusableSwitchClause(node) {
          if (node) {
            switch (node.kind) {
              case 289:
              case 290:
                return true;
            }
          }
          return false;
        }
        function isReusableStatement(node) {
          if (node) {
            switch (node.kind) {
              case 256:
              case 237:
              case 235:
              case 239:
              case 238:
              case 251:
              case 247:
              case 249:
              case 246:
              case 245:
              case 243:
              case 244:
              case 242:
              case 241:
              case 248:
              case 236:
              case 252:
              case 250:
              case 240:
              case 253:
              case 266:
              case 265:
              case 272:
              case 271:
              case 261:
              case 257:
              case 258:
              case 260:
              case 259:
                return true;
            }
          }
          return false;
        }
        function isReusableEnumMember(node) {
          return node.kind === 299;
        }
        function isReusableTypeMember(node) {
          if (node) {
            switch (node.kind) {
              case 175:
              case 168:
              case 176:
              case 166:
              case 174:
                return true;
            }
          }
          return false;
        }
        function isReusableVariableDeclaration(node) {
          if (node.kind !== 254) {
            return false;
          }
          var variableDeclarator = node;
          return variableDeclarator.initializer === void 0;
        }
        function isReusableParameter(node) {
          if (node.kind !== 164) {
            return false;
          }
          var parameter = node;
          return parameter.initializer === void 0;
        }
        function abortParsingListOrMoveToNextToken(kind) {
          parsingContextErrors(kind);
          if (isInSomeParsingContext()) {
            return true;
          }
          nextToken();
          return false;
        }
        function parsingContextErrors(context) {
          switch (context) {
            case 0:
              return token() === 88 ? parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(93)) : parseErrorAtCurrentToken(ts3.Diagnostics.Declaration_or_statement_expected);
            case 1:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Declaration_or_statement_expected);
            case 2:
              return parseErrorAtCurrentToken(ts3.Diagnostics.case_or_default_expected);
            case 3:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Statement_expected);
            case 18:
            case 4:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Property_or_signature_expected);
            case 5:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);
            case 6:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Enum_member_expected);
            case 7:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Expression_expected);
            case 8:
              return ts3.isKeyword(token()) ? parseErrorAtCurrentToken(ts3.Diagnostics._0_is_not_allowed_as_a_variable_declaration_name, ts3.tokenToString(token())) : parseErrorAtCurrentToken(ts3.Diagnostics.Variable_declaration_expected);
            case 9:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Property_destructuring_pattern_expected);
            case 10:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Array_element_destructuring_pattern_expected);
            case 11:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Argument_expression_expected);
            case 12:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Property_assignment_expected);
            case 15:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Expression_or_comma_expected);
            case 17:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Parameter_declaration_expected);
            case 16:
              return ts3.isKeyword(token()) ? parseErrorAtCurrentToken(ts3.Diagnostics._0_is_not_allowed_as_a_parameter_name, ts3.tokenToString(token())) : parseErrorAtCurrentToken(ts3.Diagnostics.Parameter_declaration_expected);
            case 19:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Type_parameter_declaration_expected);
            case 20:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Type_argument_expected);
            case 21:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Type_expected);
            case 22:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Unexpected_token_expected);
            case 23:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Identifier_expected);
            case 13:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Identifier_expected);
            case 14:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Identifier_expected);
            default:
              return [void 0];
          }
        }
        function parseDelimitedList(kind, parseElement, considerSemicolonAsDelimiter) {
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << kind;
          var list = [];
          var listPos = getNodePos();
          var commaStart = -1;
          while (true) {
            if (isListElement(kind, false)) {
              var startPos = scanner.getStartPos();
              var result2 = parseListElement(kind, parseElement);
              if (!result2) {
                parsingContext = saveParsingContext;
                return void 0;
              }
              list.push(result2);
              commaStart = scanner.getTokenPos();
              if (parseOptional(27)) {
                continue;
              }
              commaStart = -1;
              if (isListTerminator(kind)) {
                break;
              }
              parseExpected(27, getExpectedCommaDiagnostic(kind));
              if (considerSemicolonAsDelimiter && token() === 26 && !scanner.hasPrecedingLineBreak()) {
                nextToken();
              }
              if (startPos === scanner.getStartPos()) {
                nextToken();
              }
              continue;
            }
            if (isListTerminator(kind)) {
              break;
            }
            if (abortParsingListOrMoveToNextToken(kind)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos, void 0, commaStart >= 0);
        }
        function getExpectedCommaDiagnostic(kind) {
          return kind === 6 ? ts3.Diagnostics.An_enum_member_name_must_be_followed_by_a_or : void 0;
        }
        function createMissingList() {
          var list = createNodeArray([], getNodePos());
          list.isMissingList = true;
          return list;
        }
        function isMissingList(arr) {
          return !!arr.isMissingList;
        }
        function parseBracketedList(kind, parseElement, open, close) {
          if (parseExpected(open)) {
            var result2 = parseDelimitedList(kind, parseElement);
            parseExpected(close);
            return result2;
          }
          return createMissingList();
        }
        function parseEntityName(allowReservedWords, diagnosticMessage) {
          var pos = getNodePos();
          var entity = allowReservedWords ? parseIdentifierName(diagnosticMessage) : parseIdentifier(diagnosticMessage);
          var dotPos = getNodePos();
          while (parseOptional(24)) {
            if (token() === 29) {
              entity.jsdocDotPos = dotPos;
              break;
            }
            dotPos = getNodePos();
            entity = finishNode(factory.createQualifiedName(entity, parseRightSideOfDot(allowReservedWords, false)), pos);
          }
          return entity;
        }
        function createQualifiedName(entity, name) {
          return finishNode(factory.createQualifiedName(entity, name), entity.pos);
        }
        function parseRightSideOfDot(allowIdentifierNames, allowPrivateIdentifiers) {
          if (scanner.hasPrecedingLineBreak() && ts3.tokenIsIdentifierOrKeyword(token())) {
            var matchesPattern = lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
            if (matchesPattern) {
              return createMissingNode(79, true, ts3.Diagnostics.Identifier_expected);
            }
          }
          if (token() === 80) {
            var node = parsePrivateIdentifier();
            return allowPrivateIdentifiers ? node : createMissingNode(79, true, ts3.Diagnostics.Identifier_expected);
          }
          return allowIdentifierNames ? parseIdentifierName() : parseIdentifier();
        }
        function parseTemplateSpans(isTaggedTemplate) {
          var pos = getNodePos();
          var list = [];
          var node;
          do {
            node = parseTemplateSpan(isTaggedTemplate);
            list.push(node);
          } while (node.literal.kind === 16);
          return createNodeArray(list, pos);
        }
        function parseTemplateExpression(isTaggedTemplate) {
          var pos = getNodePos();
          return finishNode(factory.createTemplateExpression(parseTemplateHead(isTaggedTemplate), parseTemplateSpans(isTaggedTemplate)), pos);
        }
        function parseTemplateType() {
          var pos = getNodePos();
          return finishNode(factory.createTemplateLiteralType(parseTemplateHead(false), parseTemplateTypeSpans()), pos);
        }
        function parseTemplateTypeSpans() {
          var pos = getNodePos();
          var list = [];
          var node;
          do {
            node = parseTemplateTypeSpan();
            list.push(node);
          } while (node.literal.kind === 16);
          return createNodeArray(list, pos);
        }
        function parseTemplateTypeSpan() {
          var pos = getNodePos();
          return finishNode(factory.createTemplateLiteralTypeSpan(parseType(), parseLiteralOfTemplateSpan(false)), pos);
        }
        function parseLiteralOfTemplateSpan(isTaggedTemplate) {
          if (token() === 19) {
            reScanTemplateToken(isTaggedTemplate);
            return parseTemplateMiddleOrTemplateTail();
          } else {
            return parseExpectedToken(17, ts3.Diagnostics._0_expected, ts3.tokenToString(19));
          }
        }
        function parseTemplateSpan(isTaggedTemplate) {
          var pos = getNodePos();
          return finishNode(factory.createTemplateSpan(allowInAnd(parseExpression), parseLiteralOfTemplateSpan(isTaggedTemplate)), pos);
        }
        function parseLiteralNode() {
          return parseLiteralLikeNode(token());
        }
        function parseTemplateHead(isTaggedTemplate) {
          if (isTaggedTemplate) {
            reScanTemplateHeadOrNoSubstitutionTemplate();
          }
          var fragment = parseLiteralLikeNode(token());
          ts3.Debug.assert(fragment.kind === 15, "Template head has wrong token kind");
          return fragment;
        }
        function parseTemplateMiddleOrTemplateTail() {
          var fragment = parseLiteralLikeNode(token());
          ts3.Debug.assert(fragment.kind === 16 || fragment.kind === 17, "Template fragment has wrong token kind");
          return fragment;
        }
        function getTemplateLiteralRawText(kind) {
          var isLast = kind === 14 || kind === 17;
          var tokenText = scanner.getTokenText();
          return tokenText.substring(1, tokenText.length - (scanner.isUnterminated() ? 0 : isLast ? 1 : 2));
        }
        function parseLiteralLikeNode(kind) {
          var pos = getNodePos();
          var node = ts3.isTemplateLiteralKind(kind) ? factory.createTemplateLiteralLikeNode(kind, scanner.getTokenValue(), getTemplateLiteralRawText(kind), scanner.getTokenFlags() & 2048) : kind === 8 ? factory.createNumericLiteral(scanner.getTokenValue(), scanner.getNumericLiteralFlags()) : kind === 10 ? factory.createStringLiteral(scanner.getTokenValue(), void 0, scanner.hasExtendedUnicodeEscape()) : ts3.isLiteralKind(kind) ? factory.createLiteralLikeNode(kind, scanner.getTokenValue()) : ts3.Debug.fail();
          if (scanner.hasExtendedUnicodeEscape()) {
            node.hasExtendedUnicodeEscape = true;
          }
          if (scanner.isUnterminated()) {
            node.isUnterminated = true;
          }
          nextToken();
          return finishNode(node, pos);
        }
        function parseEntityNameOfTypeReference() {
          return parseEntityName(true, ts3.Diagnostics.Type_expected);
        }
        function parseTypeArgumentsOfTypeReference() {
          if (!scanner.hasPrecedingLineBreak() && reScanLessThanToken() === 29) {
            return parseBracketedList(20, parseType, 29, 31);
          }
        }
        function parseTypeReference() {
          var pos = getNodePos();
          return finishNode(factory.createTypeReferenceNode(parseEntityNameOfTypeReference(), parseTypeArgumentsOfTypeReference()), pos);
        }
        function typeHasArrowFunctionBlockingParseError(node) {
          switch (node.kind) {
            case 178:
              return ts3.nodeIsMissing(node.typeName);
            case 179:
            case 180: {
              var _a = node, parameters = _a.parameters, type2 = _a.type;
              return isMissingList(parameters) || typeHasArrowFunctionBlockingParseError(type2);
            }
            case 191:
              return typeHasArrowFunctionBlockingParseError(node.type);
            default:
              return false;
          }
        }
        function parseThisTypePredicate(lhs) {
          nextToken();
          return finishNode(factory.createTypePredicateNode(void 0, lhs, parseType()), lhs.pos);
        }
        function parseThisTypeNode() {
          var pos = getNodePos();
          nextToken();
          return finishNode(factory.createThisTypeNode(), pos);
        }
        function parseJSDocAllType() {
          var pos = getNodePos();
          nextToken();
          return finishNode(factory.createJSDocAllType(), pos);
        }
        function parseJSDocNonNullableType() {
          var pos = getNodePos();
          nextToken();
          return finishNode(factory.createJSDocNonNullableType(parseNonArrayType(), false), pos);
        }
        function parseJSDocUnknownOrNullableType() {
          var pos = getNodePos();
          nextToken();
          if (token() === 27 || token() === 19 || token() === 21 || token() === 31 || token() === 63 || token() === 51) {
            return finishNode(factory.createJSDocUnknownType(), pos);
          } else {
            return finishNode(factory.createJSDocNullableType(parseType(), false), pos);
          }
        }
        function parseJSDocFunctionType() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          if (lookAhead(nextTokenIsOpenParen)) {
            nextToken();
            var parameters = parseParameters(4 | 32);
            var type2 = parseReturnType(58, false);
            return withJSDoc(finishNode(factory.createJSDocFunctionType(parameters, type2), pos), hasJSDoc);
          }
          return finishNode(factory.createTypeReferenceNode(parseIdentifierName(), void 0), pos);
        }
        function parseJSDocParameter() {
          var pos = getNodePos();
          var name;
          if (token() === 108 || token() === 103) {
            name = parseIdentifierName();
            parseExpected(58);
          }
          return finishNode(factory.createParameterDeclaration(void 0, void 0, void 0, name, void 0, parseJSDocType(), void 0), pos);
        }
        function parseJSDocType() {
          scanner.setInJSDocType(true);
          var pos = getNodePos();
          if (parseOptional(141)) {
            var moduleTag = factory.createJSDocNamepathType(void 0);
            terminate:
              while (true) {
                switch (token()) {
                  case 19:
                  case 1:
                  case 27:
                  case 5:
                    break terminate;
                  default:
                    nextTokenJSDoc();
                }
              }
            scanner.setInJSDocType(false);
            return finishNode(moduleTag, pos);
          }
          var hasDotDotDot = parseOptional(25);
          var type2 = parseTypeOrTypePredicate();
          scanner.setInJSDocType(false);
          if (hasDotDotDot) {
            type2 = finishNode(factory.createJSDocVariadicType(type2), pos);
          }
          if (token() === 63) {
            nextToken();
            return finishNode(factory.createJSDocOptionalType(type2), pos);
          }
          return type2;
        }
        function parseTypeQuery() {
          var pos = getNodePos();
          parseExpected(112);
          var entityName = parseEntityName(true);
          var typeArguments = !scanner.hasPrecedingLineBreak() ? tryParseTypeArguments() : void 0;
          return finishNode(factory.createTypeQueryNode(entityName, typeArguments), pos);
        }
        function parseTypeParameter() {
          var pos = getNodePos();
          var modifiers = parseModifiers();
          var name = parseIdentifier();
          var constraint;
          var expression;
          if (parseOptional(94)) {
            if (isStartOfType() || !isStartOfExpression()) {
              constraint = parseType();
            } else {
              expression = parseUnaryExpressionOrHigher();
            }
          }
          var defaultType = parseOptional(63) ? parseType() : void 0;
          var node = factory.createTypeParameterDeclaration(modifiers, name, constraint, defaultType);
          node.expression = expression;
          return finishNode(node, pos);
        }
        function parseTypeParameters() {
          if (token() === 29) {
            return parseBracketedList(19, parseTypeParameter, 29, 31);
          }
        }
        function isStartOfParameter(isJSDocParameter) {
          return token() === 25 || isBindingIdentifierOrPrivateIdentifierOrPattern() || ts3.isModifierKind(token()) || token() === 59 || isStartOfType(!isJSDocParameter);
        }
        function parseNameOfParameter(modifiers) {
          var name = parseIdentifierOrPattern(ts3.Diagnostics.Private_identifiers_cannot_be_used_as_parameters);
          if (ts3.getFullWidth(name) === 0 && !ts3.some(modifiers) && ts3.isModifierKind(token())) {
            nextToken();
          }
          return name;
        }
        function isParameterNameStart() {
          return isBindingIdentifier() || token() === 22 || token() === 18;
        }
        function parseParameter(inOuterAwaitContext) {
          return parseParameterWorker(inOuterAwaitContext);
        }
        function parseParameterForSpeculation(inOuterAwaitContext) {
          return parseParameterWorker(inOuterAwaitContext, false);
        }
        function parseParameterWorker(inOuterAwaitContext, allowAmbiguity) {
          if (allowAmbiguity === void 0) {
            allowAmbiguity = true;
          }
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var decorators = inOuterAwaitContext ? doInAwaitContext(parseDecorators) : parseDecorators();
          if (token() === 108) {
            var node_1 = factory.createParameterDeclaration(decorators, void 0, void 0, createIdentifier(true), void 0, parseTypeAnnotation(), void 0);
            if (decorators) {
              parseErrorAtRange(decorators[0], ts3.Diagnostics.Decorators_may_not_be_applied_to_this_parameters);
            }
            return withJSDoc(finishNode(node_1, pos), hasJSDoc);
          }
          var savedTopLevel = topLevel;
          topLevel = false;
          var modifiers = parseModifiers();
          var dotDotDotToken = parseOptionalToken(25);
          if (!allowAmbiguity && !isParameterNameStart()) {
            return void 0;
          }
          var node = withJSDoc(finishNode(factory.createParameterDeclaration(decorators, modifiers, dotDotDotToken, parseNameOfParameter(modifiers), parseOptionalToken(57), parseTypeAnnotation(), parseInitializer()), pos), hasJSDoc);
          topLevel = savedTopLevel;
          return node;
        }
        function parseReturnType(returnToken, isType) {
          if (shouldParseReturnType(returnToken, isType)) {
            return allowConditionalTypesAnd(parseTypeOrTypePredicate);
          }
        }
        function shouldParseReturnType(returnToken, isType) {
          if (returnToken === 38) {
            parseExpected(returnToken);
            return true;
          } else if (parseOptional(58)) {
            return true;
          } else if (isType && token() === 38) {
            parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(58));
            nextToken();
            return true;
          }
          return false;
        }
        function parseParametersWorker(flags, allowAmbiguity) {
          var savedYieldContext = inYieldContext();
          var savedAwaitContext = inAwaitContext();
          setYieldContext(!!(flags & 1));
          setAwaitContext(!!(flags & 2));
          var parameters = flags & 32 ? parseDelimitedList(17, parseJSDocParameter) : parseDelimitedList(16, function() {
            return allowAmbiguity ? parseParameter(savedAwaitContext) : parseParameterForSpeculation(savedAwaitContext);
          });
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return parameters;
        }
        function parseParameters(flags) {
          if (!parseExpected(20)) {
            return createMissingList();
          }
          var parameters = parseParametersWorker(flags, true);
          parseExpected(21);
          return parameters;
        }
        function parseTypeMemberSemicolon() {
          if (parseOptional(27)) {
            return;
          }
          parseSemicolon();
        }
        function parseSignatureMember(kind) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          if (kind === 175) {
            parseExpected(103);
          }
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(4);
          var type2 = parseReturnType(58, true);
          parseTypeMemberSemicolon();
          var node = kind === 174 ? factory.createCallSignature(typeParameters, parameters, type2) : factory.createConstructSignature(typeParameters, parameters, type2);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function isIndexSignature() {
          return token() === 22 && lookAhead(isUnambiguouslyIndexSignature);
        }
        function isUnambiguouslyIndexSignature() {
          nextToken();
          if (token() === 25 || token() === 23) {
            return true;
          }
          if (ts3.isModifierKind(token())) {
            nextToken();
            if (isIdentifier()) {
              return true;
            }
          } else if (!isIdentifier()) {
            return false;
          } else {
            nextToken();
          }
          if (token() === 58 || token() === 27) {
            return true;
          }
          if (token() !== 57) {
            return false;
          }
          nextToken();
          return token() === 58 || token() === 27 || token() === 23;
        }
        function parseIndexSignatureDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var parameters = parseBracketedList(16, function() {
            return parseParameter(false);
          }, 22, 23);
          var type2 = parseTypeAnnotation();
          parseTypeMemberSemicolon();
          var node = factory.createIndexSignature(decorators, modifiers, parameters, type2);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parsePropertyOrMethodSignature(pos, hasJSDoc, modifiers) {
          var name = parsePropertyName();
          var questionToken = parseOptionalToken(57);
          var node;
          if (token() === 20 || token() === 29) {
            var typeParameters = parseTypeParameters();
            var parameters = parseParameters(4);
            var type2 = parseReturnType(58, true);
            node = factory.createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type2);
          } else {
            var type2 = parseTypeAnnotation();
            node = factory.createPropertySignature(modifiers, name, questionToken, type2);
            if (token() === 63)
              node.initializer = parseInitializer();
          }
          parseTypeMemberSemicolon();
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function isTypeMemberStart() {
          if (token() === 20 || token() === 29 || token() === 136 || token() === 149) {
            return true;
          }
          var idToken = false;
          while (ts3.isModifierKind(token())) {
            idToken = true;
            nextToken();
          }
          if (token() === 22) {
            return true;
          }
          if (isLiteralPropertyName()) {
            idToken = true;
            nextToken();
          }
          if (idToken) {
            return token() === 20 || token() === 29 || token() === 57 || token() === 58 || token() === 27 || canParseSemicolon();
          }
          return false;
        }
        function parseTypeMember() {
          if (token() === 20 || token() === 29) {
            return parseSignatureMember(174);
          }
          if (token() === 103 && lookAhead(nextTokenIsOpenParenOrLessThan)) {
            return parseSignatureMember(175);
          }
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiers();
          if (parseContextualModifier(136)) {
            return parseAccessorDeclaration(pos, hasJSDoc, void 0, modifiers, 172);
          }
          if (parseContextualModifier(149)) {
            return parseAccessorDeclaration(pos, hasJSDoc, void 0, modifiers, 173);
          }
          if (isIndexSignature()) {
            return parseIndexSignatureDeclaration(pos, hasJSDoc, void 0, modifiers);
          }
          return parsePropertyOrMethodSignature(pos, hasJSDoc, modifiers);
        }
        function nextTokenIsOpenParenOrLessThan() {
          nextToken();
          return token() === 20 || token() === 29;
        }
        function nextTokenIsDot() {
          return nextToken() === 24;
        }
        function nextTokenIsOpenParenOrLessThanOrDot() {
          switch (nextToken()) {
            case 20:
            case 29:
            case 24:
              return true;
          }
          return false;
        }
        function parseTypeLiteral() {
          var pos = getNodePos();
          return finishNode(factory.createTypeLiteralNode(parseObjectTypeMembers()), pos);
        }
        function parseObjectTypeMembers() {
          var members;
          if (parseExpected(18)) {
            members = parseList(4, parseTypeMember);
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          return members;
        }
        function isStartOfMappedType() {
          nextToken();
          if (token() === 39 || token() === 40) {
            return nextToken() === 145;
          }
          if (token() === 145) {
            nextToken();
          }
          return token() === 22 && nextTokenIsIdentifier() && nextToken() === 101;
        }
        function parseMappedTypeParameter() {
          var pos = getNodePos();
          var name = parseIdentifierName();
          parseExpected(101);
          var type2 = parseType();
          return finishNode(factory.createTypeParameterDeclaration(void 0, name, type2, void 0), pos);
        }
        function parseMappedType() {
          var pos = getNodePos();
          parseExpected(18);
          var readonlyToken;
          if (token() === 145 || token() === 39 || token() === 40) {
            readonlyToken = parseTokenNode();
            if (readonlyToken.kind !== 145) {
              parseExpected(145);
            }
          }
          parseExpected(22);
          var typeParameter = parseMappedTypeParameter();
          var nameType = parseOptional(127) ? parseType() : void 0;
          parseExpected(23);
          var questionToken;
          if (token() === 57 || token() === 39 || token() === 40) {
            questionToken = parseTokenNode();
            if (questionToken.kind !== 57) {
              parseExpected(57);
            }
          }
          var type2 = parseTypeAnnotation();
          parseSemicolon();
          var members = parseList(4, parseTypeMember);
          parseExpected(19);
          return finishNode(factory.createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type2, members), pos);
        }
        function parseTupleElementType() {
          var pos = getNodePos();
          if (parseOptional(25)) {
            return finishNode(factory.createRestTypeNode(parseType()), pos);
          }
          var type2 = parseType();
          if (ts3.isJSDocNullableType(type2) && type2.pos === type2.type.pos) {
            var node = factory.createOptionalTypeNode(type2.type);
            ts3.setTextRange(node, type2);
            node.flags = type2.flags;
            return node;
          }
          return type2;
        }
        function isNextTokenColonOrQuestionColon() {
          return nextToken() === 58 || token() === 57 && nextToken() === 58;
        }
        function isTupleElementName() {
          if (token() === 25) {
            return ts3.tokenIsIdentifierOrKeyword(nextToken()) && isNextTokenColonOrQuestionColon();
          }
          return ts3.tokenIsIdentifierOrKeyword(token()) && isNextTokenColonOrQuestionColon();
        }
        function parseTupleElementNameOrTupleElementType() {
          if (lookAhead(isTupleElementName)) {
            var pos = getNodePos();
            var hasJSDoc = hasPrecedingJSDocComment();
            var dotDotDotToken = parseOptionalToken(25);
            var name = parseIdentifierName();
            var questionToken = parseOptionalToken(57);
            parseExpected(58);
            var type2 = parseTupleElementType();
            var node = factory.createNamedTupleMember(dotDotDotToken, name, questionToken, type2);
            return withJSDoc(finishNode(node, pos), hasJSDoc);
          }
          return parseTupleElementType();
        }
        function parseTupleType() {
          var pos = getNodePos();
          return finishNode(factory.createTupleTypeNode(parseBracketedList(21, parseTupleElementNameOrTupleElementType, 22, 23)), pos);
        }
        function parseParenthesizedType() {
          var pos = getNodePos();
          parseExpected(20);
          var type2 = parseType();
          parseExpected(21);
          return finishNode(factory.createParenthesizedType(type2), pos);
        }
        function parseModifiersForConstructorType() {
          var modifiers;
          if (token() === 126) {
            var pos = getNodePos();
            nextToken();
            var modifier = finishNode(factory.createToken(126), pos);
            modifiers = createNodeArray([modifier], pos);
          }
          return modifiers;
        }
        function parseFunctionOrConstructorType() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiersForConstructorType();
          var isConstructorType = parseOptional(103);
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(4);
          var type2 = parseReturnType(38, false);
          var node = isConstructorType ? factory.createConstructorTypeNode(modifiers, typeParameters, parameters, type2) : factory.createFunctionTypeNode(typeParameters, parameters, type2);
          if (!isConstructorType)
            node.modifiers = modifiers;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseKeywordAndNoDot() {
          var node = parseTokenNode();
          return token() === 24 ? void 0 : node;
        }
        function parseLiteralTypeNode(negative) {
          var pos = getNodePos();
          if (negative) {
            nextToken();
          }
          var expression = token() === 110 || token() === 95 || token() === 104 ? parseTokenNode() : parseLiteralLikeNode(token());
          if (negative) {
            expression = finishNode(factory.createPrefixUnaryExpression(40, expression), pos);
          }
          return finishNode(factory.createLiteralTypeNode(expression), pos);
        }
        function isStartOfTypeOfImportType() {
          nextToken();
          return token() === 100;
        }
        function parseImportTypeAssertions() {
          var pos = getNodePos();
          var openBracePosition = scanner.getTokenPos();
          parseExpected(18);
          var multiLine = scanner.hasPrecedingLineBreak();
          parseExpected(129);
          parseExpected(58);
          var clause = parseAssertClause(true);
          if (!parseExpected(19)) {
            var lastError = ts3.lastOrUndefined(parseDiagnostics);
            if (lastError && lastError.code === ts3.Diagnostics._0_expected.code) {
              ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName2, openBracePosition, 1, ts3.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}"));
            }
          }
          return finishNode(factory.createImportTypeAssertionContainer(clause, multiLine), pos);
        }
        function parseImportType() {
          sourceFlags |= 2097152;
          var pos = getNodePos();
          var isTypeOf = parseOptional(112);
          parseExpected(100);
          parseExpected(20);
          var type2 = parseType();
          var assertions;
          if (parseOptional(27)) {
            assertions = parseImportTypeAssertions();
          }
          parseExpected(21);
          var qualifier = parseOptional(24) ? parseEntityNameOfTypeReference() : void 0;
          var typeArguments = parseTypeArgumentsOfTypeReference();
          return finishNode(factory.createImportTypeNode(type2, assertions, qualifier, typeArguments, isTypeOf), pos);
        }
        function nextTokenIsNumericOrBigIntLiteral() {
          nextToken();
          return token() === 8 || token() === 9;
        }
        function parseNonArrayType() {
          switch (token()) {
            case 130:
            case 155:
            case 150:
            case 147:
            case 158:
            case 151:
            case 133:
            case 153:
            case 143:
            case 148:
              return tryParse(parseKeywordAndNoDot) || parseTypeReference();
            case 66:
              scanner.reScanAsteriskEqualsToken();
            case 41:
              return parseJSDocAllType();
            case 60:
              scanner.reScanQuestionToken();
            case 57:
              return parseJSDocUnknownOrNullableType();
            case 98:
              return parseJSDocFunctionType();
            case 53:
              return parseJSDocNonNullableType();
            case 14:
            case 10:
            case 8:
            case 9:
            case 110:
            case 95:
            case 104:
              return parseLiteralTypeNode();
            case 40:
              return lookAhead(nextTokenIsNumericOrBigIntLiteral) ? parseLiteralTypeNode(true) : parseTypeReference();
            case 114:
              return parseTokenNode();
            case 108: {
              var thisKeyword = parseThisTypeNode();
              if (token() === 139 && !scanner.hasPrecedingLineBreak()) {
                return parseThisTypePredicate(thisKeyword);
              } else {
                return thisKeyword;
              }
            }
            case 112:
              return lookAhead(isStartOfTypeOfImportType) ? parseImportType() : parseTypeQuery();
            case 18:
              return lookAhead(isStartOfMappedType) ? parseMappedType() : parseTypeLiteral();
            case 22:
              return parseTupleType();
            case 20:
              return parseParenthesizedType();
            case 100:
              return parseImportType();
            case 128:
              return lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine) ? parseAssertsTypePredicate() : parseTypeReference();
            case 15:
              return parseTemplateType();
            default:
              return parseTypeReference();
          }
        }
        function isStartOfType(inStartOfParameter) {
          switch (token()) {
            case 130:
            case 155:
            case 150:
            case 147:
            case 158:
            case 133:
            case 145:
            case 151:
            case 154:
            case 114:
            case 153:
            case 104:
            case 108:
            case 112:
            case 143:
            case 18:
            case 22:
            case 29:
            case 51:
            case 50:
            case 103:
            case 10:
            case 8:
            case 9:
            case 110:
            case 95:
            case 148:
            case 41:
            case 57:
            case 53:
            case 25:
            case 137:
            case 100:
            case 128:
            case 14:
            case 15:
              return true;
            case 98:
              return !inStartOfParameter;
            case 40:
              return !inStartOfParameter && lookAhead(nextTokenIsNumericOrBigIntLiteral);
            case 20:
              return !inStartOfParameter && lookAhead(isStartOfParenthesizedOrFunctionType);
            default:
              return isIdentifier();
          }
        }
        function isStartOfParenthesizedOrFunctionType() {
          nextToken();
          return token() === 21 || isStartOfParameter(false) || isStartOfType();
        }
        function parsePostfixTypeOrHigher() {
          var pos = getNodePos();
          var type2 = parseNonArrayType();
          while (!scanner.hasPrecedingLineBreak()) {
            switch (token()) {
              case 53:
                nextToken();
                type2 = finishNode(factory.createJSDocNonNullableType(type2, true), pos);
                break;
              case 57:
                if (lookAhead(nextTokenIsStartOfType)) {
                  return type2;
                }
                nextToken();
                type2 = finishNode(factory.createJSDocNullableType(type2, true), pos);
                break;
              case 22:
                parseExpected(22);
                if (isStartOfType()) {
                  var indexType = parseType();
                  parseExpected(23);
                  type2 = finishNode(factory.createIndexedAccessTypeNode(type2, indexType), pos);
                } else {
                  parseExpected(23);
                  type2 = finishNode(factory.createArrayTypeNode(type2), pos);
                }
                break;
              default:
                return type2;
            }
          }
          return type2;
        }
        function parseTypeOperator(operator) {
          var pos = getNodePos();
          parseExpected(operator);
          return finishNode(factory.createTypeOperatorNode(operator, parseTypeOperatorOrHigher()), pos);
        }
        function tryParseConstraintOfInferType() {
          if (parseOptional(94)) {
            var constraint = disallowConditionalTypesAnd(parseType);
            if (inDisallowConditionalTypesContext() || token() !== 57) {
              return constraint;
            }
          }
        }
        function parseTypeParameterOfInferType() {
          var pos = getNodePos();
          var name = parseIdentifier();
          var constraint = tryParse(tryParseConstraintOfInferType);
          var node = factory.createTypeParameterDeclaration(void 0, name, constraint);
          return finishNode(node, pos);
        }
        function parseInferType() {
          var pos = getNodePos();
          parseExpected(137);
          return finishNode(factory.createInferTypeNode(parseTypeParameterOfInferType()), pos);
        }
        function parseTypeOperatorOrHigher() {
          var operator = token();
          switch (operator) {
            case 140:
            case 154:
            case 145:
              return parseTypeOperator(operator);
            case 137:
              return parseInferType();
          }
          return allowConditionalTypesAnd(parsePostfixTypeOrHigher);
        }
        function parseFunctionOrConstructorTypeToError(isInUnionType) {
          if (isStartOfFunctionTypeOrConstructorType()) {
            var type2 = parseFunctionOrConstructorType();
            var diagnostic = void 0;
            if (ts3.isFunctionTypeNode(type2)) {
              diagnostic = isInUnionType ? ts3.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type : ts3.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type;
            } else {
              diagnostic = isInUnionType ? ts3.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type : ts3.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type;
            }
            parseErrorAtRange(type2, diagnostic);
            return type2;
          }
          return void 0;
        }
        function parseUnionOrIntersectionType(operator, parseConstituentType, createTypeNode) {
          var pos = getNodePos();
          var isUnionType = operator === 51;
          var hasLeadingOperator = parseOptional(operator);
          var type2 = hasLeadingOperator && parseFunctionOrConstructorTypeToError(isUnionType) || parseConstituentType();
          if (token() === operator || hasLeadingOperator) {
            var types2 = [type2];
            while (parseOptional(operator)) {
              types2.push(parseFunctionOrConstructorTypeToError(isUnionType) || parseConstituentType());
            }
            type2 = finishNode(createTypeNode(createNodeArray(types2, pos)), pos);
          }
          return type2;
        }
        function parseIntersectionTypeOrHigher() {
          return parseUnionOrIntersectionType(50, parseTypeOperatorOrHigher, factory.createIntersectionTypeNode);
        }
        function parseUnionTypeOrHigher() {
          return parseUnionOrIntersectionType(51, parseIntersectionTypeOrHigher, factory.createUnionTypeNode);
        }
        function nextTokenIsNewKeyword() {
          nextToken();
          return token() === 103;
        }
        function isStartOfFunctionTypeOrConstructorType() {
          if (token() === 29) {
            return true;
          }
          if (token() === 20 && lookAhead(isUnambiguouslyStartOfFunctionType)) {
            return true;
          }
          return token() === 103 || token() === 126 && lookAhead(nextTokenIsNewKeyword);
        }
        function skipParameterStart() {
          if (ts3.isModifierKind(token())) {
            parseModifiers();
          }
          if (isIdentifier() || token() === 108) {
            nextToken();
            return true;
          }
          if (token() === 22 || token() === 18) {
            var previousErrorCount = parseDiagnostics.length;
            parseIdentifierOrPattern();
            return previousErrorCount === parseDiagnostics.length;
          }
          return false;
        }
        function isUnambiguouslyStartOfFunctionType() {
          nextToken();
          if (token() === 21 || token() === 25) {
            return true;
          }
          if (skipParameterStart()) {
            if (token() === 58 || token() === 27 || token() === 57 || token() === 63) {
              return true;
            }
            if (token() === 21) {
              nextToken();
              if (token() === 38) {
                return true;
              }
            }
          }
          return false;
        }
        function parseTypeOrTypePredicate() {
          var pos = getNodePos();
          var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
          var type2 = parseType();
          if (typePredicateVariable) {
            return finishNode(factory.createTypePredicateNode(void 0, typePredicateVariable, type2), pos);
          } else {
            return type2;
          }
        }
        function parseTypePredicatePrefix() {
          var id = parseIdentifier();
          if (token() === 139 && !scanner.hasPrecedingLineBreak()) {
            nextToken();
            return id;
          }
        }
        function parseAssertsTypePredicate() {
          var pos = getNodePos();
          var assertsModifier = parseExpectedToken(128);
          var parameterName = token() === 108 ? parseThisTypeNode() : parseIdentifier();
          var type2 = parseOptional(139) ? parseType() : void 0;
          return finishNode(factory.createTypePredicateNode(assertsModifier, parameterName, type2), pos);
        }
        function parseType() {
          if (contextFlags & 40960) {
            return doOutsideOfContext(40960, parseType);
          }
          if (isStartOfFunctionTypeOrConstructorType()) {
            return parseFunctionOrConstructorType();
          }
          var pos = getNodePos();
          var type2 = parseUnionTypeOrHigher();
          if (!inDisallowConditionalTypesContext() && !scanner.hasPrecedingLineBreak() && parseOptional(94)) {
            var extendsType = disallowConditionalTypesAnd(parseType);
            parseExpected(57);
            var trueType = allowConditionalTypesAnd(parseType);
            parseExpected(58);
            var falseType = allowConditionalTypesAnd(parseType);
            return finishNode(factory.createConditionalTypeNode(type2, extendsType, trueType, falseType), pos);
          }
          return type2;
        }
        function parseTypeAnnotation() {
          return parseOptional(58) ? parseType() : void 0;
        }
        function isStartOfLeftHandSideExpression() {
          switch (token()) {
            case 108:
            case 106:
            case 104:
            case 110:
            case 95:
            case 8:
            case 9:
            case 10:
            case 14:
            case 15:
            case 20:
            case 22:
            case 18:
            case 98:
            case 84:
            case 103:
            case 43:
            case 68:
            case 79:
              return true;
            case 100:
              return lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
            default:
              return isIdentifier();
          }
        }
        function isStartOfExpression() {
          if (isStartOfLeftHandSideExpression()) {
            return true;
          }
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
            case 89:
            case 112:
            case 114:
            case 45:
            case 46:
            case 29:
            case 132:
            case 125:
            case 80:
              return true;
            default:
              if (isBinaryOperator()) {
                return true;
              }
              return isIdentifier();
          }
        }
        function isStartOfExpressionStatement() {
          return token() !== 18 && token() !== 98 && token() !== 84 && token() !== 59 && isStartOfExpression();
        }
        function parseExpression() {
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var pos = getNodePos();
          var expr = parseAssignmentExpressionOrHigher();
          var operatorToken;
          while (operatorToken = parseOptionalToken(27)) {
            expr = makeBinaryExpression(expr, operatorToken, parseAssignmentExpressionOrHigher(), pos);
          }
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          return expr;
        }
        function parseInitializer() {
          return parseOptional(63) ? parseAssignmentExpressionOrHigher() : void 0;
        }
        function parseAssignmentExpressionOrHigher() {
          if (isYieldExpression()) {
            return parseYieldExpression();
          }
          var arrowExpression = tryParseParenthesizedArrowFunctionExpression() || tryParseAsyncSimpleArrowFunctionExpression();
          if (arrowExpression) {
            return arrowExpression;
          }
          var pos = getNodePos();
          var expr = parseBinaryExpressionOrHigher(0);
          if (expr.kind === 79 && token() === 38) {
            return parseSimpleArrowFunctionExpression(pos, expr, void 0);
          }
          if (ts3.isLeftHandSideExpression(expr) && ts3.isAssignmentOperator(reScanGreaterToken())) {
            return makeBinaryExpression(expr, parseTokenNode(), parseAssignmentExpressionOrHigher(), pos);
          }
          return parseConditionalExpressionRest(expr, pos);
        }
        function isYieldExpression() {
          if (token() === 125) {
            if (inYieldContext()) {
              return true;
            }
            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
          }
          return false;
        }
        function nextTokenIsIdentifierOnSameLine() {
          nextToken();
          return !scanner.hasPrecedingLineBreak() && isIdentifier();
        }
        function parseYieldExpression() {
          var pos = getNodePos();
          nextToken();
          if (!scanner.hasPrecedingLineBreak() && (token() === 41 || isStartOfExpression())) {
            return finishNode(factory.createYieldExpression(parseOptionalToken(41), parseAssignmentExpressionOrHigher()), pos);
          } else {
            return finishNode(factory.createYieldExpression(void 0, void 0), pos);
          }
        }
        function parseSimpleArrowFunctionExpression(pos, identifier, asyncModifier) {
          ts3.Debug.assert(token() === 38, "parseSimpleArrowFunctionExpression should only have been called if we had a =>");
          var parameter = factory.createParameterDeclaration(void 0, void 0, void 0, identifier, void 0, void 0, void 0);
          finishNode(parameter, identifier.pos);
          var parameters = createNodeArray([parameter], parameter.pos, parameter.end);
          var equalsGreaterThanToken = parseExpectedToken(38);
          var body = parseArrowFunctionExpressionBody(!!asyncModifier);
          var node = factory.createArrowFunction(asyncModifier, void 0, parameters, void 0, equalsGreaterThanToken, body);
          return addJSDocComment(finishNode(node, pos));
        }
        function tryParseParenthesizedArrowFunctionExpression() {
          var triState = isParenthesizedArrowFunctionExpression();
          if (triState === 0) {
            return void 0;
          }
          return triState === 1 ? parseParenthesizedArrowFunctionExpression(true) : tryParse(parsePossibleParenthesizedArrowFunctionExpression);
        }
        function isParenthesizedArrowFunctionExpression() {
          if (token() === 20 || token() === 29 || token() === 131) {
            return lookAhead(isParenthesizedArrowFunctionExpressionWorker);
          }
          if (token() === 38) {
            return 1;
          }
          return 0;
        }
        function isParenthesizedArrowFunctionExpressionWorker() {
          if (token() === 131) {
            nextToken();
            if (scanner.hasPrecedingLineBreak()) {
              return 0;
            }
            if (token() !== 20 && token() !== 29) {
              return 0;
            }
          }
          var first = token();
          var second = nextToken();
          if (first === 20) {
            if (second === 21) {
              var third = nextToken();
              switch (third) {
                case 38:
                case 58:
                case 18:
                  return 1;
                default:
                  return 0;
              }
            }
            if (second === 22 || second === 18) {
              return 2;
            }
            if (second === 25) {
              return 1;
            }
            if (ts3.isModifierKind(second) && second !== 131 && lookAhead(nextTokenIsIdentifier)) {
              if (lookAhead(function() {
                return nextToken() === 127;
              })) {
                return 0;
              }
              return 1;
            }
            if (!isIdentifier() && second !== 108) {
              return 0;
            }
            switch (nextToken()) {
              case 58:
                return 1;
              case 57:
                nextToken();
                if (token() === 58 || token() === 27 || token() === 63 || token() === 21) {
                  return 1;
                }
                return 0;
              case 27:
              case 63:
              case 21:
                return 2;
            }
            return 0;
          } else {
            ts3.Debug.assert(first === 29);
            if (!isIdentifier()) {
              return 0;
            }
            if (languageVariant === 1) {
              var isArrowFunctionInJsx = lookAhead(function() {
                var third2 = nextToken();
                if (third2 === 94) {
                  var fourth = nextToken();
                  switch (fourth) {
                    case 63:
                    case 31:
                      return false;
                    default:
                      return true;
                  }
                } else if (third2 === 27 || third2 === 63) {
                  return true;
                }
                return false;
              });
              if (isArrowFunctionInJsx) {
                return 1;
              }
              return 0;
            }
            return 2;
          }
        }
        function parsePossibleParenthesizedArrowFunctionExpression() {
          var tokenPos = scanner.getTokenPos();
          if (notParenthesizedArrow === null || notParenthesizedArrow === void 0 ? void 0 : notParenthesizedArrow.has(tokenPos)) {
            return void 0;
          }
          var result2 = parseParenthesizedArrowFunctionExpression(false);
          if (!result2) {
            (notParenthesizedArrow || (notParenthesizedArrow = new ts3.Set())).add(tokenPos);
          }
          return result2;
        }
        function tryParseAsyncSimpleArrowFunctionExpression() {
          if (token() === 131) {
            if (lookAhead(isUnParenthesizedAsyncArrowFunctionWorker) === 1) {
              var pos = getNodePos();
              var asyncModifier = parseModifiersForArrowFunction();
              var expr = parseBinaryExpressionOrHigher(0);
              return parseSimpleArrowFunctionExpression(pos, expr, asyncModifier);
            }
          }
          return void 0;
        }
        function isUnParenthesizedAsyncArrowFunctionWorker() {
          if (token() === 131) {
            nextToken();
            if (scanner.hasPrecedingLineBreak() || token() === 38) {
              return 0;
            }
            var expr = parseBinaryExpressionOrHigher(0);
            if (!scanner.hasPrecedingLineBreak() && expr.kind === 79 && token() === 38) {
              return 1;
            }
          }
          return 0;
        }
        function parseParenthesizedArrowFunctionExpression(allowAmbiguity) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiersForArrowFunction();
          var isAsync = ts3.some(modifiers, ts3.isAsyncModifier) ? 2 : 0;
          var typeParameters = parseTypeParameters();
          var parameters;
          if (!parseExpected(20)) {
            if (!allowAmbiguity) {
              return void 0;
            }
            parameters = createMissingList();
          } else {
            if (!allowAmbiguity) {
              var maybeParameters = parseParametersWorker(isAsync, allowAmbiguity);
              if (!maybeParameters) {
                return void 0;
              }
              parameters = maybeParameters;
            } else {
              parameters = parseParametersWorker(isAsync, allowAmbiguity);
            }
            if (!parseExpected(21) && !allowAmbiguity) {
              return void 0;
            }
          }
          var type2 = parseReturnType(58, false);
          if (type2 && !allowAmbiguity && typeHasArrowFunctionBlockingParseError(type2)) {
            return void 0;
          }
          var unwrappedType = type2;
          while ((unwrappedType === null || unwrappedType === void 0 ? void 0 : unwrappedType.kind) === 191) {
            unwrappedType = unwrappedType.type;
          }
          var hasJSDocFunctionType = unwrappedType && ts3.isJSDocFunctionType(unwrappedType);
          if (!allowAmbiguity && token() !== 38 && (hasJSDocFunctionType || token() !== 18)) {
            return void 0;
          }
          var lastToken = token();
          var equalsGreaterThanToken = parseExpectedToken(38);
          var body = lastToken === 38 || lastToken === 18 ? parseArrowFunctionExpressionBody(ts3.some(modifiers, ts3.isAsyncModifier)) : parseIdentifier();
          var node = factory.createArrowFunction(modifiers, typeParameters, parameters, type2, equalsGreaterThanToken, body);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseArrowFunctionExpressionBody(isAsync) {
          if (token() === 18) {
            return parseFunctionBlock(isAsync ? 2 : 0);
          }
          if (token() !== 26 && token() !== 98 && token() !== 84 && isStartOfStatement() && !isStartOfExpressionStatement()) {
            return parseFunctionBlock(16 | (isAsync ? 2 : 0));
          }
          var savedTopLevel = topLevel;
          topLevel = false;
          var node = isAsync ? doInAwaitContext(parseAssignmentExpressionOrHigher) : doOutsideOfAwaitContext(parseAssignmentExpressionOrHigher);
          topLevel = savedTopLevel;
          return node;
        }
        function parseConditionalExpressionRest(leftOperand, pos) {
          var questionToken = parseOptionalToken(57);
          if (!questionToken) {
            return leftOperand;
          }
          var colonToken;
          return finishNode(factory.createConditionalExpression(leftOperand, questionToken, doOutsideOfContext(disallowInAndDecoratorContext, parseAssignmentExpressionOrHigher), colonToken = parseExpectedToken(58), ts3.nodeIsPresent(colonToken) ? parseAssignmentExpressionOrHigher() : createMissingNode(79, false, ts3.Diagnostics._0_expected, ts3.tokenToString(58))), pos);
        }
        function parseBinaryExpressionOrHigher(precedence) {
          var pos = getNodePos();
          var leftOperand = parseUnaryExpressionOrHigher();
          return parseBinaryExpressionRest(precedence, leftOperand, pos);
        }
        function isInOrOfKeyword(t) {
          return t === 101 || t === 160;
        }
        function parseBinaryExpressionRest(precedence, leftOperand, pos) {
          while (true) {
            reScanGreaterToken();
            var newPrecedence = ts3.getBinaryOperatorPrecedence(token());
            var consumeCurrentOperator = token() === 42 ? newPrecedence >= precedence : newPrecedence > precedence;
            if (!consumeCurrentOperator) {
              break;
            }
            if (token() === 101 && inDisallowInContext()) {
              break;
            }
            if (token() === 127) {
              if (scanner.hasPrecedingLineBreak()) {
                break;
              } else {
                nextToken();
                leftOperand = makeAsExpression(leftOperand, parseType());
              }
            } else {
              leftOperand = makeBinaryExpression(leftOperand, parseTokenNode(), parseBinaryExpressionOrHigher(newPrecedence), pos);
            }
          }
          return leftOperand;
        }
        function isBinaryOperator() {
          if (inDisallowInContext() && token() === 101) {
            return false;
          }
          return ts3.getBinaryOperatorPrecedence(token()) > 0;
        }
        function makeBinaryExpression(left, operatorToken, right, pos) {
          return finishNode(factory.createBinaryExpression(left, operatorToken, right), pos);
        }
        function makeAsExpression(left, right) {
          return finishNode(factory.createAsExpression(left, right), left.pos);
        }
        function parsePrefixUnaryExpression() {
          var pos = getNodePos();
          return finishNode(factory.createPrefixUnaryExpression(token(), nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseDeleteExpression() {
          var pos = getNodePos();
          return finishNode(factory.createDeleteExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseTypeOfExpression() {
          var pos = getNodePos();
          return finishNode(factory.createTypeOfExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseVoidExpression() {
          var pos = getNodePos();
          return finishNode(factory.createVoidExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function isAwaitExpression() {
          if (token() === 132) {
            if (inAwaitContext()) {
              return true;
            }
            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
          }
          return false;
        }
        function parseAwaitExpression() {
          var pos = getNodePos();
          return finishNode(factory.createAwaitExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseUnaryExpressionOrHigher() {
          if (isUpdateExpression()) {
            var pos = getNodePos();
            var updateExpression = parseUpdateExpression();
            return token() === 42 ? parseBinaryExpressionRest(ts3.getBinaryOperatorPrecedence(token()), updateExpression, pos) : updateExpression;
          }
          var unaryOperator = token();
          var simpleUnaryExpression = parseSimpleUnaryExpression();
          if (token() === 42) {
            var pos = ts3.skipTrivia(sourceText, simpleUnaryExpression.pos);
            var end = simpleUnaryExpression.end;
            if (simpleUnaryExpression.kind === 211) {
              parseErrorAt(pos, end, ts3.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses);
            } else {
              parseErrorAt(pos, end, ts3.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses, ts3.tokenToString(unaryOperator));
            }
          }
          return simpleUnaryExpression;
        }
        function parseSimpleUnaryExpression() {
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
              return parsePrefixUnaryExpression();
            case 89:
              return parseDeleteExpression();
            case 112:
              return parseTypeOfExpression();
            case 114:
              return parseVoidExpression();
            case 29:
              return parseTypeAssertion();
            case 132:
              if (isAwaitExpression()) {
                return parseAwaitExpression();
              }
            default:
              return parseUpdateExpression();
          }
        }
        function isUpdateExpression() {
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
            case 89:
            case 112:
            case 114:
            case 132:
              return false;
            case 29:
              if (languageVariant !== 1) {
                return false;
              }
            default:
              return true;
          }
        }
        function parseUpdateExpression() {
          if (token() === 45 || token() === 46) {
            var pos = getNodePos();
            return finishNode(factory.createPrefixUnaryExpression(token(), nextTokenAnd(parseLeftHandSideExpressionOrHigher)), pos);
          } else if (languageVariant === 1 && token() === 29 && lookAhead(nextTokenIsIdentifierOrKeywordOrGreaterThan)) {
            return parseJsxElementOrSelfClosingElementOrFragment(true);
          }
          var expression = parseLeftHandSideExpressionOrHigher();
          ts3.Debug.assert(ts3.isLeftHandSideExpression(expression));
          if ((token() === 45 || token() === 46) && !scanner.hasPrecedingLineBreak()) {
            var operator = token();
            nextToken();
            return finishNode(factory.createPostfixUnaryExpression(expression, operator), expression.pos);
          }
          return expression;
        }
        function parseLeftHandSideExpressionOrHigher() {
          var pos = getNodePos();
          var expression;
          if (token() === 100) {
            if (lookAhead(nextTokenIsOpenParenOrLessThan)) {
              sourceFlags |= 2097152;
              expression = parseTokenNode();
            } else if (lookAhead(nextTokenIsDot)) {
              nextToken();
              nextToken();
              expression = finishNode(factory.createMetaProperty(100, parseIdentifierName()), pos);
              sourceFlags |= 4194304;
            } else {
              expression = parseMemberExpressionOrHigher();
            }
          } else {
            expression = token() === 106 ? parseSuperExpression() : parseMemberExpressionOrHigher();
          }
          return parseCallExpressionRest(pos, expression);
        }
        function parseMemberExpressionOrHigher() {
          var pos = getNodePos();
          var expression = parsePrimaryExpression();
          return parseMemberExpressionRest(pos, expression, true);
        }
        function parseSuperExpression() {
          var pos = getNodePos();
          var expression = parseTokenNode();
          if (token() === 29) {
            var startPos = getNodePos();
            var typeArguments = tryParse(parseTypeArgumentsInExpression);
            if (typeArguments !== void 0) {
              parseErrorAt(startPos, getNodePos(), ts3.Diagnostics.super_may_not_use_type_arguments);
            }
          }
          if (token() === 20 || token() === 24 || token() === 22) {
            return expression;
          }
          parseExpectedToken(24, ts3.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access);
          return finishNode(factory.createPropertyAccessExpression(expression, parseRightSideOfDot(true, true)), pos);
        }
        function parseJsxElementOrSelfClosingElementOrFragment(inExpressionContext, topInvalidNodePosition, openingTag) {
          var pos = getNodePos();
          var opening = parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext);
          var result2;
          if (opening.kind === 280) {
            var children = parseJsxChildren(opening);
            var closingElement = void 0;
            var lastChild = children[children.length - 1];
            if ((lastChild === null || lastChild === void 0 ? void 0 : lastChild.kind) === 278 && !tagNamesAreEquivalent(lastChild.openingElement.tagName, lastChild.closingElement.tagName) && tagNamesAreEquivalent(opening.tagName, lastChild.closingElement.tagName)) {
              var end = lastChild.children.end;
              var newLast = finishNode(factory.createJsxElement(lastChild.openingElement, lastChild.children, finishNode(factory.createJsxClosingElement(finishNode(factory.createIdentifier(""), end, end)), end, end)), lastChild.openingElement.pos, end);
              children = createNodeArray(__spreadArray(__spreadArray([], children.slice(0, children.length - 1), true), [newLast], false), children.pos, end);
              closingElement = lastChild.closingElement;
            } else {
              closingElement = parseJsxClosingElement(opening, inExpressionContext);
              if (!tagNamesAreEquivalent(opening.tagName, closingElement.tagName)) {
                if (openingTag && ts3.isJsxOpeningElement(openingTag) && tagNamesAreEquivalent(closingElement.tagName, openingTag.tagName)) {
                  parseErrorAtRange(opening.tagName, ts3.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, ts3.getTextOfNodeFromSourceText(sourceText, opening.tagName));
                } else {
                  parseErrorAtRange(closingElement.tagName, ts3.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0, ts3.getTextOfNodeFromSourceText(sourceText, opening.tagName));
                }
              }
            }
            result2 = finishNode(factory.createJsxElement(opening, children, closingElement), pos);
          } else if (opening.kind === 283) {
            result2 = finishNode(factory.createJsxFragment(opening, parseJsxChildren(opening), parseJsxClosingFragment(inExpressionContext)), pos);
          } else {
            ts3.Debug.assert(opening.kind === 279);
            result2 = opening;
          }
          if (inExpressionContext && token() === 29) {
            var topBadPos_1 = typeof topInvalidNodePosition === "undefined" ? result2.pos : topInvalidNodePosition;
            var invalidElement = tryParse(function() {
              return parseJsxElementOrSelfClosingElementOrFragment(true, topBadPos_1);
            });
            if (invalidElement) {
              var operatorToken = createMissingNode(27, false);
              ts3.setTextRangePosWidth(operatorToken, invalidElement.pos, 0);
              parseErrorAt(ts3.skipTrivia(sourceText, topBadPos_1), invalidElement.end, ts3.Diagnostics.JSX_expressions_must_have_one_parent_element);
              return finishNode(factory.createBinaryExpression(result2, operatorToken, invalidElement), pos);
            }
          }
          return result2;
        }
        function parseJsxText() {
          var pos = getNodePos();
          var node = factory.createJsxText(scanner.getTokenValue(), currentToken === 12);
          currentToken = scanner.scanJsxToken();
          return finishNode(node, pos);
        }
        function parseJsxChild(openingTag, token2) {
          switch (token2) {
            case 1:
              if (ts3.isJsxOpeningFragment(openingTag)) {
                parseErrorAtRange(openingTag, ts3.Diagnostics.JSX_fragment_has_no_corresponding_closing_tag);
              } else {
                var tag = openingTag.tagName;
                var start = ts3.skipTrivia(sourceText, tag.pos);
                parseErrorAt(start, tag.end, ts3.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, ts3.getTextOfNodeFromSourceText(sourceText, openingTag.tagName));
              }
              return void 0;
            case 30:
            case 7:
              return void 0;
            case 11:
            case 12:
              return parseJsxText();
            case 18:
              return parseJsxExpression(false);
            case 29:
              return parseJsxElementOrSelfClosingElementOrFragment(false, void 0, openingTag);
            default:
              return ts3.Debug.assertNever(token2);
          }
        }
        function parseJsxChildren(openingTag) {
          var list = [];
          var listPos = getNodePos();
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << 14;
          while (true) {
            var child = parseJsxChild(openingTag, currentToken = scanner.reScanJsxToken());
            if (!child)
              break;
            list.push(child);
            if (ts3.isJsxOpeningElement(openingTag) && (child === null || child === void 0 ? void 0 : child.kind) === 278 && !tagNamesAreEquivalent(child.openingElement.tagName, child.closingElement.tagName) && tagNamesAreEquivalent(openingTag.tagName, child.closingElement.tagName)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos);
        }
        function parseJsxAttributes() {
          var pos = getNodePos();
          return finishNode(factory.createJsxAttributes(parseList(13, parseJsxAttribute)), pos);
        }
        function parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext) {
          var pos = getNodePos();
          parseExpected(29);
          if (token() === 31) {
            scanJsxText();
            return finishNode(factory.createJsxOpeningFragment(), pos);
          }
          var tagName = parseJsxElementName();
          var typeArguments = (contextFlags & 262144) === 0 ? tryParseTypeArguments() : void 0;
          var attributes = parseJsxAttributes();
          var node;
          if (token() === 31) {
            scanJsxText();
            node = factory.createJsxOpeningElement(tagName, typeArguments, attributes);
          } else {
            parseExpected(43);
            if (parseExpected(31, void 0, false)) {
              if (inExpressionContext) {
                nextToken();
              } else {
                scanJsxText();
              }
            }
            node = factory.createJsxSelfClosingElement(tagName, typeArguments, attributes);
          }
          return finishNode(node, pos);
        }
        function parseJsxElementName() {
          var pos = getNodePos();
          scanJsxIdentifier();
          var expression = token() === 108 ? parseTokenNode() : parseIdentifierName();
          while (parseOptional(24)) {
            expression = finishNode(factory.createPropertyAccessExpression(expression, parseRightSideOfDot(true, false)), pos);
          }
          return expression;
        }
        function parseJsxExpression(inExpressionContext) {
          var pos = getNodePos();
          if (!parseExpected(18)) {
            return void 0;
          }
          var dotDotDotToken;
          var expression;
          if (token() !== 19) {
            dotDotDotToken = parseOptionalToken(25);
            expression = parseExpression();
          }
          if (inExpressionContext) {
            parseExpected(19);
          } else {
            if (parseExpected(19, void 0, false)) {
              scanJsxText();
            }
          }
          return finishNode(factory.createJsxExpression(dotDotDotToken, expression), pos);
        }
        function parseJsxAttribute() {
          if (token() === 18) {
            return parseJsxSpreadAttribute();
          }
          scanJsxIdentifier();
          var pos = getNodePos();
          return finishNode(factory.createJsxAttribute(parseIdentifierName(), token() !== 63 ? void 0 : scanJsxAttributeValue() === 10 ? parseLiteralNode() : parseJsxExpression(true)), pos);
        }
        function parseJsxSpreadAttribute() {
          var pos = getNodePos();
          parseExpected(18);
          parseExpected(25);
          var expression = parseExpression();
          parseExpected(19);
          return finishNode(factory.createJsxSpreadAttribute(expression), pos);
        }
        function parseJsxClosingElement(open, inExpressionContext) {
          var pos = getNodePos();
          parseExpected(30);
          var tagName = parseJsxElementName();
          if (parseExpected(31, void 0, false)) {
            if (inExpressionContext || !tagNamesAreEquivalent(open.tagName, tagName)) {
              nextToken();
            } else {
              scanJsxText();
            }
          }
          return finishNode(factory.createJsxClosingElement(tagName), pos);
        }
        function parseJsxClosingFragment(inExpressionContext) {
          var pos = getNodePos();
          parseExpected(30);
          if (ts3.tokenIsIdentifierOrKeyword(token())) {
            parseErrorAtRange(parseJsxElementName(), ts3.Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment);
          }
          if (parseExpected(31, void 0, false)) {
            if (inExpressionContext) {
              nextToken();
            } else {
              scanJsxText();
            }
          }
          return finishNode(factory.createJsxJsxClosingFragment(), pos);
        }
        function parseTypeAssertion() {
          var pos = getNodePos();
          parseExpected(29);
          var type2 = parseType();
          parseExpected(31);
          var expression = parseSimpleUnaryExpression();
          return finishNode(factory.createTypeAssertion(type2, expression), pos);
        }
        function nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 22 || isTemplateStartOfTaggedTemplate();
        }
        function isStartOfOptionalPropertyOrElementAccessChain() {
          return token() === 28 && lookAhead(nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate);
        }
        function tryReparseOptionalChain(node) {
          if (node.flags & 32) {
            return true;
          }
          if (ts3.isNonNullExpression(node)) {
            var expr = node.expression;
            while (ts3.isNonNullExpression(expr) && !(expr.flags & 32)) {
              expr = expr.expression;
            }
            if (expr.flags & 32) {
              while (ts3.isNonNullExpression(node)) {
                node.flags |= 32;
                node = node.expression;
              }
              return true;
            }
          }
          return false;
        }
        function parsePropertyAccessExpressionRest(pos, expression, questionDotToken) {
          var name = parseRightSideOfDot(true, true);
          var isOptionalChain = questionDotToken || tryReparseOptionalChain(expression);
          var propertyAccess = isOptionalChain ? factory.createPropertyAccessChain(expression, questionDotToken, name) : factory.createPropertyAccessExpression(expression, name);
          if (isOptionalChain && ts3.isPrivateIdentifier(propertyAccess.name)) {
            parseErrorAtRange(propertyAccess.name, ts3.Diagnostics.An_optional_chain_cannot_contain_private_identifiers);
          }
          return finishNode(propertyAccess, pos);
        }
        function parseElementAccessExpressionRest(pos, expression, questionDotToken) {
          var argumentExpression;
          if (token() === 23) {
            argumentExpression = createMissingNode(79, true, ts3.Diagnostics.An_element_access_expression_should_take_an_argument);
          } else {
            var argument = allowInAnd(parseExpression);
            if (ts3.isStringOrNumericLiteralLike(argument)) {
              argument.text = internIdentifier(argument.text);
            }
            argumentExpression = argument;
          }
          parseExpected(23);
          var indexedAccess = questionDotToken || tryReparseOptionalChain(expression) ? factory.createElementAccessChain(expression, questionDotToken, argumentExpression) : factory.createElementAccessExpression(expression, argumentExpression);
          return finishNode(indexedAccess, pos);
        }
        function parseMemberExpressionRest(pos, expression, allowOptionalChain) {
          while (true) {
            var questionDotToken = void 0;
            var isPropertyAccess = false;
            if (allowOptionalChain && isStartOfOptionalPropertyOrElementAccessChain()) {
              questionDotToken = parseExpectedToken(28);
              isPropertyAccess = ts3.tokenIsIdentifierOrKeyword(token());
            } else {
              isPropertyAccess = parseOptional(24);
            }
            if (isPropertyAccess) {
              expression = parsePropertyAccessExpressionRest(pos, expression, questionDotToken);
              continue;
            }
            if ((questionDotToken || !inDecoratorContext()) && parseOptional(22)) {
              expression = parseElementAccessExpressionRest(pos, expression, questionDotToken);
              continue;
            }
            if (isTemplateStartOfTaggedTemplate()) {
              expression = !questionDotToken && expression.kind === 228 ? parseTaggedTemplateRest(pos, expression.expression, questionDotToken, expression.typeArguments) : parseTaggedTemplateRest(pos, expression, questionDotToken, void 0);
              continue;
            }
            if (!questionDotToken) {
              if (token() === 53 && !scanner.hasPrecedingLineBreak()) {
                nextToken();
                expression = finishNode(factory.createNonNullExpression(expression), pos);
                continue;
              }
              var typeArguments = tryParse(parseTypeArgumentsInExpression);
              if (typeArguments) {
                expression = finishNode(factory.createExpressionWithTypeArguments(expression, typeArguments), pos);
                continue;
              }
            }
            return expression;
          }
        }
        function isTemplateStartOfTaggedTemplate() {
          return token() === 14 || token() === 15;
        }
        function parseTaggedTemplateRest(pos, tag, questionDotToken, typeArguments) {
          var tagExpression = factory.createTaggedTemplateExpression(tag, typeArguments, token() === 14 ? (reScanTemplateHeadOrNoSubstitutionTemplate(), parseLiteralNode()) : parseTemplateExpression(true));
          if (questionDotToken || tag.flags & 32) {
            tagExpression.flags |= 32;
          }
          tagExpression.questionDotToken = questionDotToken;
          return finishNode(tagExpression, pos);
        }
        function parseCallExpressionRest(pos, expression) {
          while (true) {
            expression = parseMemberExpressionRest(pos, expression, true);
            var typeArguments = void 0;
            var questionDotToken = parseOptionalToken(28);
            if (questionDotToken) {
              typeArguments = tryParse(parseTypeArgumentsInExpression);
              if (isTemplateStartOfTaggedTemplate()) {
                expression = parseTaggedTemplateRest(pos, expression, questionDotToken, typeArguments);
                continue;
              }
            }
            if (typeArguments || token() === 20) {
              if (!questionDotToken && expression.kind === 228) {
                typeArguments = expression.typeArguments;
                expression = expression.expression;
              }
              var argumentList = parseArgumentList();
              var callExpr = questionDotToken || tryReparseOptionalChain(expression) ? factory.createCallChain(expression, questionDotToken, typeArguments, argumentList) : factory.createCallExpression(expression, typeArguments, argumentList);
              expression = finishNode(callExpr, pos);
              continue;
            }
            if (questionDotToken) {
              var name = createMissingNode(79, false, ts3.Diagnostics.Identifier_expected);
              expression = finishNode(factory.createPropertyAccessChain(expression, questionDotToken, name), pos);
            }
            break;
          }
          return expression;
        }
        function parseArgumentList() {
          parseExpected(20);
          var result2 = parseDelimitedList(11, parseArgumentExpression);
          parseExpected(21);
          return result2;
        }
        function parseTypeArgumentsInExpression() {
          if ((contextFlags & 262144) !== 0) {
            return void 0;
          }
          if (reScanLessThanToken() !== 29) {
            return void 0;
          }
          nextToken();
          var typeArguments = parseDelimitedList(20, parseType);
          if (reScanGreaterToken() !== 31) {
            return void 0;
          }
          nextToken();
          return typeArguments && canFollowTypeArgumentsInExpression() ? typeArguments : void 0;
        }
        function canFollowTypeArgumentsInExpression() {
          switch (token()) {
            case 20:
            case 14:
            case 15:
              return true;
          }
          return !isStartOfExpression();
        }
        function parsePrimaryExpression() {
          switch (token()) {
            case 8:
            case 9:
            case 10:
            case 14:
              return parseLiteralNode();
            case 108:
            case 106:
            case 104:
            case 110:
            case 95:
              return parseTokenNode();
            case 20:
              return parseParenthesizedExpression();
            case 22:
              return parseArrayLiteralExpression();
            case 18:
              return parseObjectLiteralExpression();
            case 131:
              if (!lookAhead(nextTokenIsFunctionKeywordOnSameLine)) {
                break;
              }
              return parseFunctionExpression();
            case 84:
              return parseClassExpression();
            case 98:
              return parseFunctionExpression();
            case 103:
              return parseNewExpressionOrNewDotTarget();
            case 43:
            case 68:
              if (reScanSlashToken() === 13) {
                return parseLiteralNode();
              }
              break;
            case 15:
              return parseTemplateExpression(false);
            case 80:
              return parsePrivateIdentifier();
          }
          return parseIdentifier(ts3.Diagnostics.Expression_expected);
        }
        function parseParenthesizedExpression() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          return withJSDoc(finishNode(factory.createParenthesizedExpression(expression), pos), hasJSDoc);
        }
        function parseSpreadElement() {
          var pos = getNodePos();
          parseExpected(25);
          var expression = parseAssignmentExpressionOrHigher();
          return finishNode(factory.createSpreadElement(expression), pos);
        }
        function parseArgumentOrArrayLiteralElement() {
          return token() === 25 ? parseSpreadElement() : token() === 27 ? finishNode(factory.createOmittedExpression(), getNodePos()) : parseAssignmentExpressionOrHigher();
        }
        function parseArgumentExpression() {
          return doOutsideOfContext(disallowInAndDecoratorContext, parseArgumentOrArrayLiteralElement);
        }
        function parseArrayLiteralExpression() {
          var pos = getNodePos();
          var openBracketPosition = scanner.getTokenPos();
          var openBracketParsed = parseExpected(22);
          var multiLine = scanner.hasPrecedingLineBreak();
          var elements = parseDelimitedList(15, parseArgumentOrArrayLiteralElement);
          parseExpectedMatchingBrackets(22, 23, openBracketParsed, openBracketPosition);
          return finishNode(factory.createArrayLiteralExpression(elements, multiLine), pos);
        }
        function parseObjectLiteralElement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          if (parseOptionalToken(25)) {
            var expression = parseAssignmentExpressionOrHigher();
            return withJSDoc(finishNode(factory.createSpreadAssignment(expression), pos), hasJSDoc);
          }
          var decorators = parseDecorators();
          var modifiers = parseModifiers();
          if (parseContextualModifier(136)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 172);
          }
          if (parseContextualModifier(149)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 173);
          }
          var asteriskToken = parseOptionalToken(41);
          var tokenIsIdentifier = isIdentifier();
          var name = parsePropertyName();
          var questionToken = parseOptionalToken(57);
          var exclamationToken = parseOptionalToken(53);
          if (asteriskToken || token() === 20 || token() === 29) {
            return parseMethodDeclaration(pos, hasJSDoc, decorators, modifiers, asteriskToken, name, questionToken, exclamationToken);
          }
          var node;
          var isShorthandPropertyAssignment = tokenIsIdentifier && token() !== 58;
          if (isShorthandPropertyAssignment) {
            var equalsToken = parseOptionalToken(63);
            var objectAssignmentInitializer = equalsToken ? allowInAnd(parseAssignmentExpressionOrHigher) : void 0;
            node = factory.createShorthandPropertyAssignment(name, objectAssignmentInitializer);
            node.equalsToken = equalsToken;
          } else {
            parseExpected(58);
            var initializer = allowInAnd(parseAssignmentExpressionOrHigher);
            node = factory.createPropertyAssignment(name, initializer);
          }
          node.decorators = decorators;
          node.modifiers = modifiers;
          node.questionToken = questionToken;
          node.exclamationToken = exclamationToken;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseObjectLiteralExpression() {
          var pos = getNodePos();
          var openBracePosition = scanner.getTokenPos();
          var openBraceParsed = parseExpected(18);
          var multiLine = scanner.hasPrecedingLineBreak();
          var properties = parseDelimitedList(12, parseObjectLiteralElement, true);
          parseExpectedMatchingBrackets(18, 19, openBraceParsed, openBracePosition);
          return finishNode(factory.createObjectLiteralExpression(properties, multiLine), pos);
        }
        function parseFunctionExpression() {
          var savedDecoratorContext = inDecoratorContext();
          setDecoratorContext(false);
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiers();
          parseExpected(98);
          var asteriskToken = parseOptionalToken(41);
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = ts3.some(modifiers, ts3.isAsyncModifier) ? 2 : 0;
          var name = isGenerator && isAsync ? doInYieldAndAwaitContext(parseOptionalBindingIdentifier) : isGenerator ? doInYieldContext(parseOptionalBindingIdentifier) : isAsync ? doInAwaitContext(parseOptionalBindingIdentifier) : parseOptionalBindingIdentifier();
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(isGenerator | isAsync);
          var type2 = parseReturnType(58, false);
          var body = parseFunctionBlock(isGenerator | isAsync);
          setDecoratorContext(savedDecoratorContext);
          var node = factory.createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type2, body);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseOptionalBindingIdentifier() {
          return isBindingIdentifier() ? parseBindingIdentifier() : void 0;
        }
        function parseNewExpressionOrNewDotTarget() {
          var pos = getNodePos();
          parseExpected(103);
          if (parseOptional(24)) {
            var name = parseIdentifierName();
            return finishNode(factory.createMetaProperty(103, name), pos);
          }
          var expressionPos = getNodePos();
          var expression = parseMemberExpressionRest(expressionPos, parsePrimaryExpression(), false);
          var typeArguments;
          if (expression.kind === 228) {
            typeArguments = expression.typeArguments;
            expression = expression.expression;
          }
          var argumentList = token() === 20 ? parseArgumentList() : void 0;
          return finishNode(factory.createNewExpression(expression, typeArguments, argumentList), pos);
        }
        function parseBlock(ignoreMissingOpenBrace, diagnosticMessage) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var openBracePosition = scanner.getTokenPos();
          var openBraceParsed = parseExpected(18, diagnosticMessage);
          if (openBraceParsed || ignoreMissingOpenBrace) {
            var multiLine = scanner.hasPrecedingLineBreak();
            var statements = parseList(1, parseStatement);
            parseExpectedMatchingBrackets(18, 19, openBraceParsed, openBracePosition);
            var result2 = withJSDoc(finishNode(factory.createBlock(statements, multiLine), pos), hasJSDoc);
            if (token() === 63) {
              parseErrorAtCurrentToken(ts3.Diagnostics.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses);
              nextToken();
            }
            return result2;
          } else {
            var statements = createMissingList();
            return withJSDoc(finishNode(factory.createBlock(statements, void 0), pos), hasJSDoc);
          }
        }
        function parseFunctionBlock(flags, diagnosticMessage) {
          var savedYieldContext = inYieldContext();
          setYieldContext(!!(flags & 1));
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(!!(flags & 2));
          var savedTopLevel = topLevel;
          topLevel = false;
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var block = parseBlock(!!(flags & 16), diagnosticMessage);
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          topLevel = savedTopLevel;
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return block;
        }
        function parseEmptyStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(26);
          return withJSDoc(finishNode(factory.createEmptyStatement(), pos), hasJSDoc);
        }
        function parseIfStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(99);
          var openParenPosition = scanner.getTokenPos();
          var openParenParsed = parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpectedMatchingBrackets(20, 21, openParenParsed, openParenPosition);
          var thenStatement = parseStatement();
          var elseStatement = parseOptional(91) ? parseStatement() : void 0;
          return withJSDoc(finishNode(factory.createIfStatement(expression, thenStatement, elseStatement), pos), hasJSDoc);
        }
        function parseDoStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(90);
          var statement = parseStatement();
          parseExpected(115);
          var openParenPosition = scanner.getTokenPos();
          var openParenParsed = parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpectedMatchingBrackets(20, 21, openParenParsed, openParenPosition);
          parseOptional(26);
          return withJSDoc(finishNode(factory.createDoStatement(statement, expression), pos), hasJSDoc);
        }
        function parseWhileStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(115);
          var openParenPosition = scanner.getTokenPos();
          var openParenParsed = parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpectedMatchingBrackets(20, 21, openParenParsed, openParenPosition);
          var statement = parseStatement();
          return withJSDoc(finishNode(factory.createWhileStatement(expression, statement), pos), hasJSDoc);
        }
        function parseForOrForInOrForOfStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(97);
          var awaitToken = parseOptionalToken(132);
          parseExpected(20);
          var initializer;
          if (token() !== 26) {
            if (token() === 113 || token() === 119 || token() === 85) {
              initializer = parseVariableDeclarationList(true);
            } else {
              initializer = disallowInAnd(parseExpression);
            }
          }
          var node;
          if (awaitToken ? parseExpected(160) : parseOptional(160)) {
            var expression = allowInAnd(parseAssignmentExpressionOrHigher);
            parseExpected(21);
            node = factory.createForOfStatement(awaitToken, initializer, expression, parseStatement());
          } else if (parseOptional(101)) {
            var expression = allowInAnd(parseExpression);
            parseExpected(21);
            node = factory.createForInStatement(initializer, expression, parseStatement());
          } else {
            parseExpected(26);
            var condition = token() !== 26 && token() !== 21 ? allowInAnd(parseExpression) : void 0;
            parseExpected(26);
            var incrementor = token() !== 21 ? allowInAnd(parseExpression) : void 0;
            parseExpected(21);
            node = factory.createForStatement(initializer, condition, incrementor, parseStatement());
          }
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseBreakOrContinueStatement(kind) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(kind === 246 ? 81 : 86);
          var label = canParseSemicolon() ? void 0 : parseIdentifier();
          parseSemicolon();
          var node = kind === 246 ? factory.createBreakStatement(label) : factory.createContinueStatement(label);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseReturnStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(105);
          var expression = canParseSemicolon() ? void 0 : allowInAnd(parseExpression);
          parseSemicolon();
          return withJSDoc(finishNode(factory.createReturnStatement(expression), pos), hasJSDoc);
        }
        function parseWithStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(116);
          var openParenPosition = scanner.getTokenPos();
          var openParenParsed = parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpectedMatchingBrackets(20, 21, openParenParsed, openParenPosition);
          var statement = doInsideOfContext(33554432, parseStatement);
          return withJSDoc(finishNode(factory.createWithStatement(expression, statement), pos), hasJSDoc);
        }
        function parseCaseClause() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(82);
          var expression = allowInAnd(parseExpression);
          parseExpected(58);
          var statements = parseList(3, parseStatement);
          return withJSDoc(finishNode(factory.createCaseClause(expression, statements), pos), hasJSDoc);
        }
        function parseDefaultClause() {
          var pos = getNodePos();
          parseExpected(88);
          parseExpected(58);
          var statements = parseList(3, parseStatement);
          return finishNode(factory.createDefaultClause(statements), pos);
        }
        function parseCaseOrDefaultClause() {
          return token() === 82 ? parseCaseClause() : parseDefaultClause();
        }
        function parseCaseBlock() {
          var pos = getNodePos();
          parseExpected(18);
          var clauses = parseList(2, parseCaseOrDefaultClause);
          parseExpected(19);
          return finishNode(factory.createCaseBlock(clauses), pos);
        }
        function parseSwitchStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(107);
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          var caseBlock = parseCaseBlock();
          return withJSDoc(finishNode(factory.createSwitchStatement(expression, caseBlock), pos), hasJSDoc);
        }
        function parseThrowStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(109);
          var expression = scanner.hasPrecedingLineBreak() ? void 0 : allowInAnd(parseExpression);
          if (expression === void 0) {
            identifierCount++;
            expression = finishNode(factory.createIdentifier(""), getNodePos());
          }
          if (!tryParseSemicolon()) {
            parseErrorForMissingSemicolonAfter(expression);
          }
          return withJSDoc(finishNode(factory.createThrowStatement(expression), pos), hasJSDoc);
        }
        function parseTryStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(111);
          var tryBlock = parseBlock(false);
          var catchClause = token() === 83 ? parseCatchClause() : void 0;
          var finallyBlock;
          if (!catchClause || token() === 96) {
            parseExpected(96, ts3.Diagnostics.catch_or_finally_expected);
            finallyBlock = parseBlock(false);
          }
          return withJSDoc(finishNode(factory.createTryStatement(tryBlock, catchClause, finallyBlock), pos), hasJSDoc);
        }
        function parseCatchClause() {
          var pos = getNodePos();
          parseExpected(83);
          var variableDeclaration;
          if (parseOptional(20)) {
            variableDeclaration = parseVariableDeclaration();
            parseExpected(21);
          } else {
            variableDeclaration = void 0;
          }
          var block = parseBlock(false);
          return finishNode(factory.createCatchClause(variableDeclaration, block), pos);
        }
        function parseDebuggerStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(87);
          parseSemicolon();
          return withJSDoc(finishNode(factory.createDebuggerStatement(), pos), hasJSDoc);
        }
        function parseExpressionOrLabeledStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var node;
          var hasParen = token() === 20;
          var expression = allowInAnd(parseExpression);
          if (ts3.isIdentifier(expression) && parseOptional(58)) {
            node = factory.createLabeledStatement(expression, parseStatement());
          } else {
            if (!tryParseSemicolon()) {
              parseErrorForMissingSemicolonAfter(expression);
            }
            node = factory.createExpressionStatement(expression);
            if (hasParen) {
              hasJSDoc = false;
            }
          }
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function nextTokenIsIdentifierOrKeywordOnSameLine() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeyword(token()) && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsClassKeywordOnSameLine() {
          nextToken();
          return token() === 84 && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsFunctionKeywordOnSameLine() {
          nextToken();
          return token() === 98 && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine() {
          nextToken();
          return (ts3.tokenIsIdentifierOrKeyword(token()) || token() === 8 || token() === 9 || token() === 10) && !scanner.hasPrecedingLineBreak();
        }
        function isDeclaration() {
          while (true) {
            switch (token()) {
              case 113:
              case 119:
              case 85:
              case 98:
              case 84:
              case 92:
                return true;
              case 118:
              case 152:
                return nextTokenIsIdentifierOnSameLine();
              case 141:
              case 142:
                return nextTokenIsIdentifierOrStringLiteralOnSameLine();
              case 126:
              case 131:
              case 135:
              case 121:
              case 122:
              case 123:
              case 145:
                nextToken();
                if (scanner.hasPrecedingLineBreak()) {
                  return false;
                }
                continue;
              case 157:
                nextToken();
                return token() === 18 || token() === 79 || token() === 93;
              case 100:
                nextToken();
                return token() === 10 || token() === 41 || token() === 18 || ts3.tokenIsIdentifierOrKeyword(token());
              case 93:
                var currentToken_1 = nextToken();
                if (currentToken_1 === 152) {
                  currentToken_1 = lookAhead(nextToken);
                }
                if (currentToken_1 === 63 || currentToken_1 === 41 || currentToken_1 === 18 || currentToken_1 === 88 || currentToken_1 === 127) {
                  return true;
                }
                continue;
              case 124:
                nextToken();
                continue;
              default:
                return false;
            }
          }
        }
        function isStartOfDeclaration() {
          return lookAhead(isDeclaration);
        }
        function isStartOfStatement() {
          switch (token()) {
            case 59:
            case 26:
            case 18:
            case 113:
            case 119:
            case 98:
            case 84:
            case 92:
            case 99:
            case 90:
            case 115:
            case 97:
            case 86:
            case 81:
            case 105:
            case 116:
            case 107:
            case 109:
            case 111:
            case 87:
            case 83:
            case 96:
              return true;
            case 100:
              return isStartOfDeclaration() || lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
            case 85:
            case 93:
              return isStartOfDeclaration();
            case 131:
            case 135:
            case 118:
            case 141:
            case 142:
            case 152:
            case 157:
              return true;
            case 123:
            case 121:
            case 122:
            case 124:
            case 145:
              return isStartOfDeclaration() || !lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
            default:
              return isStartOfExpression();
          }
        }
        function nextTokenIsBindingIdentifierOrStartOfDestructuring() {
          nextToken();
          return isBindingIdentifier() || token() === 18 || token() === 22;
        }
        function isLetDeclaration() {
          return lookAhead(nextTokenIsBindingIdentifierOrStartOfDestructuring);
        }
        function parseStatement() {
          switch (token()) {
            case 26:
              return parseEmptyStatement();
            case 18:
              return parseBlock(false);
            case 113:
              return parseVariableStatement(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
            case 119:
              if (isLetDeclaration()) {
                return parseVariableStatement(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
              }
              break;
            case 98:
              return parseFunctionDeclaration(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
            case 84:
              return parseClassDeclaration(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
            case 99:
              return parseIfStatement();
            case 90:
              return parseDoStatement();
            case 115:
              return parseWhileStatement();
            case 97:
              return parseForOrForInOrForOfStatement();
            case 86:
              return parseBreakOrContinueStatement(245);
            case 81:
              return parseBreakOrContinueStatement(246);
            case 105:
              return parseReturnStatement();
            case 116:
              return parseWithStatement();
            case 107:
              return parseSwitchStatement();
            case 109:
              return parseThrowStatement();
            case 111:
            case 83:
            case 96:
              return parseTryStatement();
            case 87:
              return parseDebuggerStatement();
            case 59:
              return parseDeclaration();
            case 131:
            case 118:
            case 152:
            case 141:
            case 142:
            case 135:
            case 85:
            case 92:
            case 93:
            case 100:
            case 121:
            case 122:
            case 123:
            case 126:
            case 124:
            case 145:
            case 157:
              if (isStartOfDeclaration()) {
                return parseDeclaration();
              }
              break;
          }
          return parseExpressionOrLabeledStatement();
        }
        function isDeclareModifier(modifier) {
          return modifier.kind === 135;
        }
        function parseDeclaration() {
          var isAmbient = ts3.some(lookAhead(function() {
            return parseDecorators(), parseModifiers();
          }), isDeclareModifier);
          if (isAmbient) {
            var node = tryReuseAmbientDeclaration();
            if (node) {
              return node;
            }
          }
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var decorators = parseDecorators();
          var modifiers = parseModifiers();
          if (isAmbient) {
            for (var _i = 0, _a = modifiers; _i < _a.length; _i++) {
              var m = _a[_i];
              m.flags |= 16777216;
            }
            return doInsideOfContext(16777216, function() {
              return parseDeclarationWorker(pos, hasJSDoc, decorators, modifiers);
            });
          } else {
            return parseDeclarationWorker(pos, hasJSDoc, decorators, modifiers);
          }
        }
        function tryReuseAmbientDeclaration() {
          return doInsideOfContext(16777216, function() {
            var node = currentNode(parsingContext);
            if (node) {
              return consumeNode(node);
            }
          });
        }
        function parseDeclarationWorker(pos, hasJSDoc, decorators, modifiers) {
          switch (token()) {
            case 113:
            case 119:
            case 85:
              return parseVariableStatement(pos, hasJSDoc, decorators, modifiers);
            case 98:
              return parseFunctionDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 84:
              return parseClassDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 118:
              return parseInterfaceDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 152:
              return parseTypeAliasDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 92:
              return parseEnumDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 157:
            case 141:
            case 142:
              return parseModuleDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 100:
              return parseImportDeclarationOrImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 93:
              nextToken();
              switch (token()) {
                case 88:
                case 63:
                  return parseExportAssignment(pos, hasJSDoc, decorators, modifiers);
                case 127:
                  return parseNamespaceExportDeclaration(pos, hasJSDoc, decorators, modifiers);
                default:
                  return parseExportDeclaration(pos, hasJSDoc, decorators, modifiers);
              }
            default:
              if (decorators || modifiers) {
                var missing = createMissingNode(276, true, ts3.Diagnostics.Declaration_expected);
                ts3.setTextRangePos(missing, pos);
                missing.decorators = decorators;
                missing.modifiers = modifiers;
                return missing;
              }
              return void 0;
          }
        }
        function nextTokenIsIdentifierOrStringLiteralOnSameLine() {
          nextToken();
          return !scanner.hasPrecedingLineBreak() && (isIdentifier() || token() === 10);
        }
        function parseFunctionBlockOrSemicolon(flags, diagnosticMessage) {
          if (token() !== 18 && canParseSemicolon()) {
            parseSemicolon();
            return;
          }
          return parseFunctionBlock(flags, diagnosticMessage);
        }
        function parseArrayBindingElement() {
          var pos = getNodePos();
          if (token() === 27) {
            return finishNode(factory.createOmittedExpression(), pos);
          }
          var dotDotDotToken = parseOptionalToken(25);
          var name = parseIdentifierOrPattern();
          var initializer = parseInitializer();
          return finishNode(factory.createBindingElement(dotDotDotToken, void 0, name, initializer), pos);
        }
        function parseObjectBindingElement() {
          var pos = getNodePos();
          var dotDotDotToken = parseOptionalToken(25);
          var tokenIsIdentifier = isBindingIdentifier();
          var propertyName = parsePropertyName();
          var name;
          if (tokenIsIdentifier && token() !== 58) {
            name = propertyName;
            propertyName = void 0;
          } else {
            parseExpected(58);
            name = parseIdentifierOrPattern();
          }
          var initializer = parseInitializer();
          return finishNode(factory.createBindingElement(dotDotDotToken, propertyName, name, initializer), pos);
        }
        function parseObjectBindingPattern() {
          var pos = getNodePos();
          parseExpected(18);
          var elements = parseDelimitedList(9, parseObjectBindingElement);
          parseExpected(19);
          return finishNode(factory.createObjectBindingPattern(elements), pos);
        }
        function parseArrayBindingPattern() {
          var pos = getNodePos();
          parseExpected(22);
          var elements = parseDelimitedList(10, parseArrayBindingElement);
          parseExpected(23);
          return finishNode(factory.createArrayBindingPattern(elements), pos);
        }
        function isBindingIdentifierOrPrivateIdentifierOrPattern() {
          return token() === 18 || token() === 22 || token() === 80 || isBindingIdentifier();
        }
        function parseIdentifierOrPattern(privateIdentifierDiagnosticMessage) {
          if (token() === 22) {
            return parseArrayBindingPattern();
          }
          if (token() === 18) {
            return parseObjectBindingPattern();
          }
          return parseBindingIdentifier(privateIdentifierDiagnosticMessage);
        }
        function parseVariableDeclarationAllowExclamation() {
          return parseVariableDeclaration(true);
        }
        function parseVariableDeclaration(allowExclamation) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var name = parseIdentifierOrPattern(ts3.Diagnostics.Private_identifiers_are_not_allowed_in_variable_declarations);
          var exclamationToken;
          if (allowExclamation && name.kind === 79 && token() === 53 && !scanner.hasPrecedingLineBreak()) {
            exclamationToken = parseTokenNode();
          }
          var type2 = parseTypeAnnotation();
          var initializer = isInOrOfKeyword(token()) ? void 0 : parseInitializer();
          var node = factory.createVariableDeclaration(name, exclamationToken, type2, initializer);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseVariableDeclarationList(inForStatementInitializer) {
          var pos = getNodePos();
          var flags = 0;
          switch (token()) {
            case 113:
              break;
            case 119:
              flags |= 1;
              break;
            case 85:
              flags |= 2;
              break;
            default:
              ts3.Debug.fail();
          }
          nextToken();
          var declarations;
          if (token() === 160 && lookAhead(canFollowContextualOfKeyword)) {
            declarations = createMissingList();
          } else {
            var savedDisallowIn = inDisallowInContext();
            setDisallowInContext(inForStatementInitializer);
            declarations = parseDelimitedList(8, inForStatementInitializer ? parseVariableDeclaration : parseVariableDeclarationAllowExclamation);
            setDisallowInContext(savedDisallowIn);
          }
          return finishNode(factory.createVariableDeclarationList(declarations, flags), pos);
        }
        function canFollowContextualOfKeyword() {
          return nextTokenIsIdentifier() && nextToken() === 21;
        }
        function parseVariableStatement(pos, hasJSDoc, decorators, modifiers) {
          var declarationList = parseVariableDeclarationList(false);
          parseSemicolon();
          var node = factory.createVariableStatement(modifiers, declarationList);
          node.decorators = decorators;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseFunctionDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var savedAwaitContext = inAwaitContext();
          var modifierFlags = ts3.modifiersToFlags(modifiers);
          parseExpected(98);
          var asteriskToken = parseOptionalToken(41);
          var name = modifierFlags & 512 ? parseOptionalBindingIdentifier() : parseBindingIdentifier();
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = modifierFlags & 256 ? 2 : 0;
          var typeParameters = parseTypeParameters();
          if (modifierFlags & 1)
            setAwaitContext(true);
          var parameters = parseParameters(isGenerator | isAsync);
          var type2 = parseReturnType(58, false);
          var body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, ts3.Diagnostics.or_expected);
          setAwaitContext(savedAwaitContext);
          var node = factory.createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type2, body);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseConstructorName() {
          if (token() === 134) {
            return parseExpected(134);
          }
          if (token() === 10 && lookAhead(nextToken) === 20) {
            return tryParse(function() {
              var literalNode = parseLiteralNode();
              return literalNode.text === "constructor" ? literalNode : void 0;
            });
          }
        }
        function tryParseConstructorDeclaration(pos, hasJSDoc, decorators, modifiers) {
          return tryParse(function() {
            if (parseConstructorName()) {
              var typeParameters = parseTypeParameters();
              var parameters = parseParameters(0);
              var type2 = parseReturnType(58, false);
              var body = parseFunctionBlockOrSemicolon(0, ts3.Diagnostics.or_expected);
              var node = factory.createConstructorDeclaration(decorators, modifiers, parameters, body);
              node.typeParameters = typeParameters;
              node.type = type2;
              return withJSDoc(finishNode(node, pos), hasJSDoc);
            }
          });
        }
        function parseMethodDeclaration(pos, hasJSDoc, decorators, modifiers, asteriskToken, name, questionToken, exclamationToken, diagnosticMessage) {
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = ts3.some(modifiers, ts3.isAsyncModifier) ? 2 : 0;
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(isGenerator | isAsync);
          var type2 = parseReturnType(58, false);
          var body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, diagnosticMessage);
          var node = factory.createMethodDeclaration(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type2, body);
          node.exclamationToken = exclamationToken;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parsePropertyDeclaration(pos, hasJSDoc, decorators, modifiers, name, questionToken) {
          var exclamationToken = !questionToken && !scanner.hasPrecedingLineBreak() ? parseOptionalToken(53) : void 0;
          var type2 = parseTypeAnnotation();
          var initializer = doOutsideOfContext(8192 | 32768 | 4096, parseInitializer);
          parseSemicolonAfterPropertyName(name, type2, initializer);
          var node = factory.createPropertyDeclaration(decorators, modifiers, name, questionToken || exclamationToken, type2, initializer);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parsePropertyOrMethodDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var asteriskToken = parseOptionalToken(41);
          var name = parsePropertyName();
          var questionToken = parseOptionalToken(57);
          if (asteriskToken || token() === 20 || token() === 29) {
            return parseMethodDeclaration(pos, hasJSDoc, decorators, modifiers, asteriskToken, name, questionToken, void 0, ts3.Diagnostics.or_expected);
          }
          return parsePropertyDeclaration(pos, hasJSDoc, decorators, modifiers, name, questionToken);
        }
        function parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, kind) {
          var name = parsePropertyName();
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(0);
          var type2 = parseReturnType(58, false);
          var body = parseFunctionBlockOrSemicolon(0);
          var node = kind === 172 ? factory.createGetAccessorDeclaration(decorators, modifiers, name, parameters, type2, body) : factory.createSetAccessorDeclaration(decorators, modifiers, name, parameters, body);
          node.typeParameters = typeParameters;
          if (type2 && node.kind === 173)
            node.type = type2;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function isClassMemberStart() {
          var idToken;
          if (token() === 59) {
            return true;
          }
          while (ts3.isModifierKind(token())) {
            idToken = token();
            if (ts3.isClassMemberModifier(idToken)) {
              return true;
            }
            nextToken();
          }
          if (token() === 41) {
            return true;
          }
          if (isLiteralPropertyName()) {
            idToken = token();
            nextToken();
          }
          if (token() === 22) {
            return true;
          }
          if (idToken !== void 0) {
            if (!ts3.isKeyword(idToken) || idToken === 149 || idToken === 136) {
              return true;
            }
            switch (token()) {
              case 20:
              case 29:
              case 53:
              case 58:
              case 63:
              case 57:
                return true;
              default:
                return canParseSemicolon();
            }
          }
          return false;
        }
        function parseClassStaticBlockDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpectedToken(124);
          var body = parseClassStaticBlockBody();
          return withJSDoc(finishNode(factory.createClassStaticBlockDeclaration(decorators, modifiers, body), pos), hasJSDoc);
        }
        function parseClassStaticBlockBody() {
          var savedYieldContext = inYieldContext();
          var savedAwaitContext = inAwaitContext();
          setYieldContext(false);
          setAwaitContext(true);
          var body = parseBlock(false);
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return body;
        }
        function parseDecoratorExpression() {
          if (inAwaitContext() && token() === 132) {
            var pos = getNodePos();
            var awaitExpression = parseIdentifier(ts3.Diagnostics.Expression_expected);
            nextToken();
            var memberExpression = parseMemberExpressionRest(pos, awaitExpression, true);
            return parseCallExpressionRest(pos, memberExpression);
          }
          return parseLeftHandSideExpressionOrHigher();
        }
        function tryParseDecorator() {
          var pos = getNodePos();
          if (!parseOptional(59)) {
            return void 0;
          }
          var expression = doInDecoratorContext(parseDecoratorExpression);
          return finishNode(factory.createDecorator(expression), pos);
        }
        function parseDecorators() {
          var pos = getNodePos();
          var list, decorator;
          while (decorator = tryParseDecorator()) {
            list = ts3.append(list, decorator);
          }
          return list && createNodeArray(list, pos);
        }
        function tryParseModifier(permitInvalidConstAsModifier, stopOnStartOfClassStaticBlock, hasSeenStaticModifier) {
          var pos = getNodePos();
          var kind = token();
          if (token() === 85 && permitInvalidConstAsModifier) {
            if (!tryParse(nextTokenIsOnSameLineAndCanFollowModifier)) {
              return void 0;
            }
          } else if (stopOnStartOfClassStaticBlock && token() === 124 && lookAhead(nextTokenIsOpenBrace)) {
            return void 0;
          } else if (hasSeenStaticModifier && token() === 124) {
            return void 0;
          } else {
            if (!parseAnyContextualModifier()) {
              return void 0;
            }
          }
          return finishNode(factory.createToken(kind), pos);
        }
        function parseModifiers(permitInvalidConstAsModifier, stopOnStartOfClassStaticBlock) {
          var pos = getNodePos();
          var list, modifier, hasSeenStatic = false;
          while (modifier = tryParseModifier(permitInvalidConstAsModifier, stopOnStartOfClassStaticBlock, hasSeenStatic)) {
            if (modifier.kind === 124)
              hasSeenStatic = true;
            list = ts3.append(list, modifier);
          }
          return list && createNodeArray(list, pos);
        }
        function parseModifiersForArrowFunction() {
          var modifiers;
          if (token() === 131) {
            var pos = getNodePos();
            nextToken();
            var modifier = finishNode(factory.createToken(131), pos);
            modifiers = createNodeArray([modifier], pos);
          }
          return modifiers;
        }
        function parseClassElement() {
          var pos = getNodePos();
          if (token() === 26) {
            nextToken();
            return finishNode(factory.createSemicolonClassElement(), pos);
          }
          var hasJSDoc = hasPrecedingJSDocComment();
          var decorators = parseDecorators();
          var modifiers = parseModifiers(true, true);
          if (token() === 124 && lookAhead(nextTokenIsOpenBrace)) {
            return parseClassStaticBlockDeclaration(pos, hasJSDoc, decorators, modifiers);
          }
          if (parseContextualModifier(136)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 172);
          }
          if (parseContextualModifier(149)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 173);
          }
          if (token() === 134 || token() === 10) {
            var constructorDeclaration = tryParseConstructorDeclaration(pos, hasJSDoc, decorators, modifiers);
            if (constructorDeclaration) {
              return constructorDeclaration;
            }
          }
          if (isIndexSignature()) {
            return parseIndexSignatureDeclaration(pos, hasJSDoc, decorators, modifiers);
          }
          if (ts3.tokenIsIdentifierOrKeyword(token()) || token() === 10 || token() === 8 || token() === 41 || token() === 22) {
            var isAmbient = ts3.some(modifiers, isDeclareModifier);
            if (isAmbient) {
              for (var _i = 0, _a = modifiers; _i < _a.length; _i++) {
                var m = _a[_i];
                m.flags |= 16777216;
              }
              return doInsideOfContext(16777216, function() {
                return parsePropertyOrMethodDeclaration(pos, hasJSDoc, decorators, modifiers);
              });
            } else {
              return parsePropertyOrMethodDeclaration(pos, hasJSDoc, decorators, modifiers);
            }
          }
          if (decorators || modifiers) {
            var name = createMissingNode(79, true, ts3.Diagnostics.Declaration_expected);
            return parsePropertyDeclaration(pos, hasJSDoc, decorators, modifiers, name, void 0);
          }
          return ts3.Debug.fail("Should not have attempted to parse class member declaration.");
        }
        function parseClassExpression() {
          return parseClassDeclarationOrExpression(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0, 226);
        }
        function parseClassDeclaration(pos, hasJSDoc, decorators, modifiers) {
          return parseClassDeclarationOrExpression(pos, hasJSDoc, decorators, modifiers, 257);
        }
        function parseClassDeclarationOrExpression(pos, hasJSDoc, decorators, modifiers, kind) {
          var savedAwaitContext = inAwaitContext();
          parseExpected(84);
          var name = parseNameOfClassDeclarationOrExpression();
          var typeParameters = parseTypeParameters();
          if (ts3.some(modifiers, ts3.isExportModifier))
            setAwaitContext(true);
          var heritageClauses = parseHeritageClauses();
          var members;
          if (parseExpected(18)) {
            members = parseClassMembers();
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          setAwaitContext(savedAwaitContext);
          var node = kind === 257 ? factory.createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) : factory.createClassExpression(decorators, modifiers, name, typeParameters, heritageClauses, members);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseNameOfClassDeclarationOrExpression() {
          return isBindingIdentifier() && !isImplementsClause() ? createIdentifier(isBindingIdentifier()) : void 0;
        }
        function isImplementsClause() {
          return token() === 117 && lookAhead(nextTokenIsIdentifierOrKeyword);
        }
        function parseHeritageClauses() {
          if (isHeritageClause()) {
            return parseList(22, parseHeritageClause);
          }
          return void 0;
        }
        function parseHeritageClause() {
          var pos = getNodePos();
          var tok = token();
          ts3.Debug.assert(tok === 94 || tok === 117);
          nextToken();
          var types2 = parseDelimitedList(7, parseExpressionWithTypeArguments);
          return finishNode(factory.createHeritageClause(tok, types2), pos);
        }
        function parseExpressionWithTypeArguments() {
          var pos = getNodePos();
          var expression = parseLeftHandSideExpressionOrHigher();
          if (expression.kind === 228) {
            return expression;
          }
          var typeArguments = tryParseTypeArguments();
          return finishNode(factory.createExpressionWithTypeArguments(expression, typeArguments), pos);
        }
        function tryParseTypeArguments() {
          return token() === 29 ? parseBracketedList(20, parseType, 29, 31) : void 0;
        }
        function isHeritageClause() {
          return token() === 94 || token() === 117;
        }
        function parseClassMembers() {
          return parseList(5, parseClassElement);
        }
        function parseInterfaceDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(118);
          var name = parseIdentifier();
          var typeParameters = parseTypeParameters();
          var heritageClauses = parseHeritageClauses();
          var members = parseObjectTypeMembers();
          var node = factory.createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseTypeAliasDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(152);
          var name = parseIdentifier();
          var typeParameters = parseTypeParameters();
          parseExpected(63);
          var type2 = token() === 138 && tryParse(parseKeywordAndNoDot) || parseType();
          parseSemicolon();
          var node = factory.createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type2);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseEnumMember() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var name = parsePropertyName();
          var initializer = allowInAnd(parseInitializer);
          return withJSDoc(finishNode(factory.createEnumMember(name, initializer), pos), hasJSDoc);
        }
        function parseEnumDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(92);
          var name = parseIdentifier();
          var members;
          if (parseExpected(18)) {
            members = doOutsideOfYieldAndAwaitContext(function() {
              return parseDelimitedList(6, parseEnumMember);
            });
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          var node = factory.createEnumDeclaration(decorators, modifiers, name, members);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseModuleBlock() {
          var pos = getNodePos();
          var statements;
          if (parseExpected(18)) {
            statements = parseList(1, parseStatement);
            parseExpected(19);
          } else {
            statements = createMissingList();
          }
          return finishNode(factory.createModuleBlock(statements), pos);
        }
        function parseModuleOrNamespaceDeclaration(pos, hasJSDoc, decorators, modifiers, flags) {
          var namespaceFlag = flags & 16;
          var name = parseIdentifier();
          var body = parseOptional(24) ? parseModuleOrNamespaceDeclaration(getNodePos(), false, void 0, void 0, 4 | namespaceFlag) : parseModuleBlock();
          var node = factory.createModuleDeclaration(decorators, modifiers, name, body, flags);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseAmbientExternalModuleDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var flags = 0;
          var name;
          if (token() === 157) {
            name = parseIdentifier();
            flags |= 1024;
          } else {
            name = parseLiteralNode();
            name.text = internIdentifier(name.text);
          }
          var body;
          if (token() === 18) {
            body = parseModuleBlock();
          } else {
            parseSemicolon();
          }
          var node = factory.createModuleDeclaration(decorators, modifiers, name, body, flags);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseModuleDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var flags = 0;
          if (token() === 157) {
            return parseAmbientExternalModuleDeclaration(pos, hasJSDoc, decorators, modifiers);
          } else if (parseOptional(142)) {
            flags |= 16;
          } else {
            parseExpected(141);
            if (token() === 10) {
              return parseAmbientExternalModuleDeclaration(pos, hasJSDoc, decorators, modifiers);
            }
          }
          return parseModuleOrNamespaceDeclaration(pos, hasJSDoc, decorators, modifiers, flags);
        }
        function isExternalModuleReference() {
          return token() === 146 && lookAhead(nextTokenIsOpenParen);
        }
        function nextTokenIsOpenParen() {
          return nextToken() === 20;
        }
        function nextTokenIsOpenBrace() {
          return nextToken() === 18;
        }
        function nextTokenIsSlash() {
          return nextToken() === 43;
        }
        function parseNamespaceExportDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(127);
          parseExpected(142);
          var name = parseIdentifier();
          parseSemicolon();
          var node = factory.createNamespaceExportDeclaration(name);
          node.decorators = decorators;
          node.modifiers = modifiers;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseImportDeclarationOrImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(100);
          var afterImportPos = scanner.getStartPos();
          var identifier;
          if (isIdentifier()) {
            identifier = parseIdentifier();
          }
          var isTypeOnly = false;
          if (token() !== 156 && (identifier === null || identifier === void 0 ? void 0 : identifier.escapedText) === "type" && (isIdentifier() || tokenAfterImportDefinitelyProducesImportDeclaration())) {
            isTypeOnly = true;
            identifier = isIdentifier() ? parseIdentifier() : void 0;
          }
          if (identifier && !tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration()) {
            return parseImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers, identifier, isTypeOnly);
          }
          var importClause;
          if (identifier || token() === 41 || token() === 18) {
            importClause = parseImportClause(identifier, afterImportPos, isTypeOnly);
            parseExpected(156);
          }
          var moduleSpecifier = parseModuleSpecifier();
          var assertClause;
          if (token() === 129 && !scanner.hasPrecedingLineBreak()) {
            assertClause = parseAssertClause();
          }
          parseSemicolon();
          var node = factory.createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier, assertClause);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseAssertEntry() {
          var pos = getNodePos();
          var name = ts3.tokenIsIdentifierOrKeyword(token()) ? parseIdentifierName() : parseLiteralLikeNode(10);
          parseExpected(58);
          var value = parseAssignmentExpressionOrHigher();
          return finishNode(factory.createAssertEntry(name, value), pos);
        }
        function parseAssertClause(skipAssertKeyword) {
          var pos = getNodePos();
          if (!skipAssertKeyword) {
            parseExpected(129);
          }
          var openBracePosition = scanner.getTokenPos();
          if (parseExpected(18)) {
            var multiLine = scanner.hasPrecedingLineBreak();
            var elements = parseDelimitedList(24, parseAssertEntry, true);
            if (!parseExpected(19)) {
              var lastError = ts3.lastOrUndefined(parseDiagnostics);
              if (lastError && lastError.code === ts3.Diagnostics._0_expected.code) {
                ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName2, openBracePosition, 1, ts3.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}"));
              }
            }
            return finishNode(factory.createAssertClause(elements, multiLine), pos);
          } else {
            var elements = createNodeArray([], getNodePos(), void 0, false);
            return finishNode(factory.createAssertClause(elements, false), pos);
          }
        }
        function tokenAfterImportDefinitelyProducesImportDeclaration() {
          return token() === 41 || token() === 18;
        }
        function tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration() {
          return token() === 27 || token() === 156;
        }
        function parseImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers, identifier, isTypeOnly) {
          parseExpected(63);
          var moduleReference = parseModuleReference();
          parseSemicolon();
          var node = factory.createImportEqualsDeclaration(decorators, modifiers, isTypeOnly, identifier, moduleReference);
          var finished = withJSDoc(finishNode(node, pos), hasJSDoc);
          return finished;
        }
        function parseImportClause(identifier, pos, isTypeOnly) {
          var namedBindings;
          if (!identifier || parseOptional(27)) {
            namedBindings = token() === 41 ? parseNamespaceImport() : parseNamedImportsOrExports(269);
          }
          return finishNode(factory.createImportClause(isTypeOnly, identifier, namedBindings), pos);
        }
        function parseModuleReference() {
          return isExternalModuleReference() ? parseExternalModuleReference() : parseEntityName(false);
        }
        function parseExternalModuleReference() {
          var pos = getNodePos();
          parseExpected(146);
          parseExpected(20);
          var expression = parseModuleSpecifier();
          parseExpected(21);
          return finishNode(factory.createExternalModuleReference(expression), pos);
        }
        function parseModuleSpecifier() {
          if (token() === 10) {
            var result2 = parseLiteralNode();
            result2.text = internIdentifier(result2.text);
            return result2;
          } else {
            return parseExpression();
          }
        }
        function parseNamespaceImport() {
          var pos = getNodePos();
          parseExpected(41);
          parseExpected(127);
          var name = parseIdentifier();
          return finishNode(factory.createNamespaceImport(name), pos);
        }
        function parseNamedImportsOrExports(kind) {
          var pos = getNodePos();
          var node = kind === 269 ? factory.createNamedImports(parseBracketedList(23, parseImportSpecifier, 18, 19)) : factory.createNamedExports(parseBracketedList(23, parseExportSpecifier, 18, 19));
          return finishNode(node, pos);
        }
        function parseExportSpecifier() {
          var hasJSDoc = hasPrecedingJSDocComment();
          return withJSDoc(parseImportOrExportSpecifier(275), hasJSDoc);
        }
        function parseImportSpecifier() {
          return parseImportOrExportSpecifier(270);
        }
        function parseImportOrExportSpecifier(kind) {
          var pos = getNodePos();
          var checkIdentifierIsKeyword = ts3.isKeyword(token()) && !isIdentifier();
          var checkIdentifierStart = scanner.getTokenPos();
          var checkIdentifierEnd = scanner.getTextPos();
          var isTypeOnly = false;
          var propertyName;
          var canParseAsKeyword = true;
          var name = parseIdentifierName();
          if (name.escapedText === "type") {
            if (token() === 127) {
              var firstAs = parseIdentifierName();
              if (token() === 127) {
                var secondAs = parseIdentifierName();
                if (ts3.tokenIsIdentifierOrKeyword(token())) {
                  isTypeOnly = true;
                  propertyName = firstAs;
                  name = parseNameWithKeywordCheck();
                  canParseAsKeyword = false;
                } else {
                  propertyName = name;
                  name = secondAs;
                  canParseAsKeyword = false;
                }
              } else if (ts3.tokenIsIdentifierOrKeyword(token())) {
                propertyName = name;
                canParseAsKeyword = false;
                name = parseNameWithKeywordCheck();
              } else {
                isTypeOnly = true;
                name = firstAs;
              }
            } else if (ts3.tokenIsIdentifierOrKeyword(token())) {
              isTypeOnly = true;
              name = parseNameWithKeywordCheck();
            }
          }
          if (canParseAsKeyword && token() === 127) {
            propertyName = name;
            parseExpected(127);
            name = parseNameWithKeywordCheck();
          }
          if (kind === 270 && checkIdentifierIsKeyword) {
            parseErrorAt(checkIdentifierStart, checkIdentifierEnd, ts3.Diagnostics.Identifier_expected);
          }
          var node = kind === 270 ? factory.createImportSpecifier(isTypeOnly, propertyName, name) : factory.createExportSpecifier(isTypeOnly, propertyName, name);
          return finishNode(node, pos);
          function parseNameWithKeywordCheck() {
            checkIdentifierIsKeyword = ts3.isKeyword(token()) && !isIdentifier();
            checkIdentifierStart = scanner.getTokenPos();
            checkIdentifierEnd = scanner.getTextPos();
            return parseIdentifierName();
          }
        }
        function parseNamespaceExport(pos) {
          return finishNode(factory.createNamespaceExport(parseIdentifierName()), pos);
        }
        function parseExportDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(true);
          var exportClause;
          var moduleSpecifier;
          var assertClause;
          var isTypeOnly = parseOptional(152);
          var namespaceExportPos = getNodePos();
          if (parseOptional(41)) {
            if (parseOptional(127)) {
              exportClause = parseNamespaceExport(namespaceExportPos);
            }
            parseExpected(156);
            moduleSpecifier = parseModuleSpecifier();
          } else {
            exportClause = parseNamedImportsOrExports(273);
            if (token() === 156 || token() === 10 && !scanner.hasPrecedingLineBreak()) {
              parseExpected(156);
              moduleSpecifier = parseModuleSpecifier();
            }
          }
          if (moduleSpecifier && token() === 129 && !scanner.hasPrecedingLineBreak()) {
            assertClause = parseAssertClause();
          }
          parseSemicolon();
          setAwaitContext(savedAwaitContext);
          var node = factory.createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier, assertClause);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseExportAssignment(pos, hasJSDoc, decorators, modifiers) {
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(true);
          var isExportEquals;
          if (parseOptional(63)) {
            isExportEquals = true;
          } else {
            parseExpected(88);
          }
          var expression = parseAssignmentExpressionOrHigher();
          parseSemicolon();
          setAwaitContext(savedAwaitContext);
          var node = factory.createExportAssignment(decorators, modifiers, isExportEquals, expression);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        var ParsingContext;
        (function(ParsingContext2) {
          ParsingContext2[ParsingContext2["SourceElements"] = 0] = "SourceElements";
          ParsingContext2[ParsingContext2["BlockStatements"] = 1] = "BlockStatements";
          ParsingContext2[ParsingContext2["SwitchClauses"] = 2] = "SwitchClauses";
          ParsingContext2[ParsingContext2["SwitchClauseStatements"] = 3] = "SwitchClauseStatements";
          ParsingContext2[ParsingContext2["TypeMembers"] = 4] = "TypeMembers";
          ParsingContext2[ParsingContext2["ClassMembers"] = 5] = "ClassMembers";
          ParsingContext2[ParsingContext2["EnumMembers"] = 6] = "EnumMembers";
          ParsingContext2[ParsingContext2["HeritageClauseElement"] = 7] = "HeritageClauseElement";
          ParsingContext2[ParsingContext2["VariableDeclarations"] = 8] = "VariableDeclarations";
          ParsingContext2[ParsingContext2["ObjectBindingElements"] = 9] = "ObjectBindingElements";
          ParsingContext2[ParsingContext2["ArrayBindingElements"] = 10] = "ArrayBindingElements";
          ParsingContext2[ParsingContext2["ArgumentExpressions"] = 11] = "ArgumentExpressions";
          ParsingContext2[ParsingContext2["ObjectLiteralMembers"] = 12] = "ObjectLiteralMembers";
          ParsingContext2[ParsingContext2["JsxAttributes"] = 13] = "JsxAttributes";
          ParsingContext2[ParsingContext2["JsxChildren"] = 14] = "JsxChildren";
          ParsingContext2[ParsingContext2["ArrayLiteralMembers"] = 15] = "ArrayLiteralMembers";
          ParsingContext2[ParsingContext2["Parameters"] = 16] = "Parameters";
          ParsingContext2[ParsingContext2["JSDocParameters"] = 17] = "JSDocParameters";
          ParsingContext2[ParsingContext2["RestProperties"] = 18] = "RestProperties";
          ParsingContext2[ParsingContext2["TypeParameters"] = 19] = "TypeParameters";
          ParsingContext2[ParsingContext2["TypeArguments"] = 20] = "TypeArguments";
          ParsingContext2[ParsingContext2["TupleElementTypes"] = 21] = "TupleElementTypes";
          ParsingContext2[ParsingContext2["HeritageClauses"] = 22] = "HeritageClauses";
          ParsingContext2[ParsingContext2["ImportOrExportSpecifiers"] = 23] = "ImportOrExportSpecifiers";
          ParsingContext2[ParsingContext2["AssertEntries"] = 24] = "AssertEntries";
          ParsingContext2[ParsingContext2["Count"] = 25] = "Count";
        })(ParsingContext || (ParsingContext = {}));
        var Tristate;
        (function(Tristate2) {
          Tristate2[Tristate2["False"] = 0] = "False";
          Tristate2[Tristate2["True"] = 1] = "True";
          Tristate2[Tristate2["Unknown"] = 2] = "Unknown";
        })(Tristate || (Tristate = {}));
        var JSDocParser;
        (function(JSDocParser2) {
          function parseJSDocTypeExpressionForTests2(content, start, length) {
            initializeState("file.js", content, 99, void 0, 1);
            scanner.setText(content, start, length);
            currentToken = scanner.scan();
            var jsDocTypeExpression = parseJSDocTypeExpression();
            var sourceFile = createSourceFile2("file.js", 99, 1, false, [], factory.createToken(1), 0, ts3.noop);
            var diagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
            if (jsDocDiagnostics) {
              sourceFile.jsDocDiagnostics = ts3.attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
            }
            clearState();
            return jsDocTypeExpression ? { jsDocTypeExpression, diagnostics } : void 0;
          }
          JSDocParser2.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests2;
          function parseJSDocTypeExpression(mayOmitBraces) {
            var pos = getNodePos();
            var hasBrace = (mayOmitBraces ? parseOptional : parseExpected)(18);
            var type2 = doInsideOfContext(8388608, parseJSDocType);
            if (!mayOmitBraces || hasBrace) {
              parseExpectedJSDoc(19);
            }
            var result2 = factory.createJSDocTypeExpression(type2);
            fixupParentReferences(result2);
            return finishNode(result2, pos);
          }
          JSDocParser2.parseJSDocTypeExpression = parseJSDocTypeExpression;
          function parseJSDocNameReference() {
            var pos = getNodePos();
            var hasBrace = parseOptional(18);
            var p2 = getNodePos();
            var entityName = parseEntityName(false);
            while (token() === 80) {
              reScanHashToken();
              nextTokenJSDoc();
              entityName = finishNode(factory.createJSDocMemberName(entityName, parseIdentifier()), p2);
            }
            if (hasBrace) {
              parseExpectedJSDoc(19);
            }
            var result2 = factory.createJSDocNameReference(entityName);
            fixupParentReferences(result2);
            return finishNode(result2, pos);
          }
          JSDocParser2.parseJSDocNameReference = parseJSDocNameReference;
          function parseIsolatedJSDocComment2(content, start, length) {
            initializeState("", content, 99, void 0, 1);
            var jsDoc = doInsideOfContext(8388608, function() {
              return parseJSDocCommentWorker(start, length);
            });
            var sourceFile = { languageVariant: 0, text: content };
            var diagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
            clearState();
            return jsDoc ? { jsDoc, diagnostics } : void 0;
          }
          JSDocParser2.parseIsolatedJSDocComment = parseIsolatedJSDocComment2;
          function parseJSDocComment(parent, start, length) {
            var saveToken = currentToken;
            var saveParseDiagnosticsLength = parseDiagnostics.length;
            var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
            var comment = doInsideOfContext(8388608, function() {
              return parseJSDocCommentWorker(start, length);
            });
            ts3.setParent(comment, parent);
            if (contextFlags & 262144) {
              if (!jsDocDiagnostics) {
                jsDocDiagnostics = [];
              }
              jsDocDiagnostics.push.apply(jsDocDiagnostics, parseDiagnostics);
            }
            currentToken = saveToken;
            parseDiagnostics.length = saveParseDiagnosticsLength;
            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
            return comment;
          }
          JSDocParser2.parseJSDocComment = parseJSDocComment;
          var JSDocState;
          (function(JSDocState2) {
            JSDocState2[JSDocState2["BeginningOfLine"] = 0] = "BeginningOfLine";
            JSDocState2[JSDocState2["SawAsterisk"] = 1] = "SawAsterisk";
            JSDocState2[JSDocState2["SavingComments"] = 2] = "SavingComments";
            JSDocState2[JSDocState2["SavingBackticks"] = 3] = "SavingBackticks";
          })(JSDocState || (JSDocState = {}));
          var PropertyLikeParse;
          (function(PropertyLikeParse2) {
            PropertyLikeParse2[PropertyLikeParse2["Property"] = 1] = "Property";
            PropertyLikeParse2[PropertyLikeParse2["Parameter"] = 2] = "Parameter";
            PropertyLikeParse2[PropertyLikeParse2["CallbackParameter"] = 4] = "CallbackParameter";
          })(PropertyLikeParse || (PropertyLikeParse = {}));
          function parseJSDocCommentWorker(start, length) {
            if (start === void 0) {
              start = 0;
            }
            var content = sourceText;
            var end = length === void 0 ? content.length : start + length;
            length = end - start;
            ts3.Debug.assert(start >= 0);
            ts3.Debug.assert(start <= end);
            ts3.Debug.assert(end <= content.length);
            if (!isJSDocLikeText(content, start)) {
              return void 0;
            }
            var tags;
            var tagsPos;
            var tagsEnd;
            var linkEnd;
            var commentsPos;
            var comments = [];
            var parts = [];
            return scanner.scanRange(start + 3, length - 5, function() {
              var state = 1;
              var margin;
              var indent = start - (content.lastIndexOf("\n", start) + 1) + 4;
              function pushComment(text) {
                if (!margin) {
                  margin = indent;
                }
                comments.push(text);
                indent += text.length;
              }
              nextTokenJSDoc();
              while (parseOptionalJsdoc(5))
                ;
              if (parseOptionalJsdoc(4)) {
                state = 0;
                indent = 0;
              }
              loop:
                while (true) {
                  switch (token()) {
                    case 59:
                      if (state === 0 || state === 1) {
                        removeTrailingWhitespace(comments);
                        if (!commentsPos)
                          commentsPos = getNodePos();
                        addTag(parseTag(indent));
                        state = 0;
                        margin = void 0;
                      } else {
                        pushComment(scanner.getTokenText());
                      }
                      break;
                    case 4:
                      comments.push(scanner.getTokenText());
                      state = 0;
                      indent = 0;
                      break;
                    case 41:
                      var asterisk = scanner.getTokenText();
                      if (state === 1 || state === 2) {
                        state = 2;
                        pushComment(asterisk);
                      } else {
                        state = 1;
                        indent += asterisk.length;
                      }
                      break;
                    case 5:
                      var whitespace = scanner.getTokenText();
                      if (state === 2) {
                        comments.push(whitespace);
                      } else if (margin !== void 0 && indent + whitespace.length > margin) {
                        comments.push(whitespace.slice(margin - indent));
                      }
                      indent += whitespace.length;
                      break;
                    case 1:
                      break loop;
                    case 18:
                      state = 2;
                      var commentEnd = scanner.getStartPos();
                      var linkStart = scanner.getTextPos() - 1;
                      var link = parseJSDocLink(linkStart);
                      if (link) {
                        if (!linkEnd) {
                          removeLeadingNewlines(comments);
                        }
                        parts.push(finishNode(factory.createJSDocText(comments.join("")), linkEnd !== null && linkEnd !== void 0 ? linkEnd : start, commentEnd));
                        parts.push(link);
                        comments = [];
                        linkEnd = scanner.getTextPos();
                        break;
                      }
                    default:
                      state = 2;
                      pushComment(scanner.getTokenText());
                      break;
                  }
                  nextTokenJSDoc();
                }
              removeTrailingWhitespace(comments);
              if (parts.length && comments.length) {
                parts.push(finishNode(factory.createJSDocText(comments.join("")), linkEnd !== null && linkEnd !== void 0 ? linkEnd : start, commentsPos));
              }
              if (parts.length && tags)
                ts3.Debug.assertIsDefined(commentsPos, "having parsed tags implies that the end of the comment span should be set");
              var tagsArray = tags && createNodeArray(tags, tagsPos, tagsEnd);
              return finishNode(factory.createJSDocComment(parts.length ? createNodeArray(parts, start, commentsPos) : comments.length ? comments.join("") : void 0, tagsArray), start, end);
            });
            function removeLeadingNewlines(comments2) {
              while (comments2.length && (comments2[0] === "\n" || comments2[0] === "\r")) {
                comments2.shift();
              }
            }
            function removeTrailingWhitespace(comments2) {
              while (comments2.length && comments2[comments2.length - 1].trim() === "") {
                comments2.pop();
              }
            }
            function isNextNonwhitespaceTokenEndOfFile() {
              while (true) {
                nextTokenJSDoc();
                if (token() === 1) {
                  return true;
                }
                if (!(token() === 5 || token() === 4)) {
                  return false;
                }
              }
            }
            function skipWhitespace() {
              if (token() === 5 || token() === 4) {
                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
                  return;
                }
              }
              while (token() === 5 || token() === 4) {
                nextTokenJSDoc();
              }
            }
            function skipWhitespaceOrAsterisk() {
              if (token() === 5 || token() === 4) {
                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
                  return "";
                }
              }
              var precedingLineBreak = scanner.hasPrecedingLineBreak();
              var seenLineBreak = false;
              var indentText = "";
              while (precedingLineBreak && token() === 41 || token() === 5 || token() === 4) {
                indentText += scanner.getTokenText();
                if (token() === 4) {
                  precedingLineBreak = true;
                  seenLineBreak = true;
                  indentText = "";
                } else if (token() === 41) {
                  precedingLineBreak = false;
                }
                nextTokenJSDoc();
              }
              return seenLineBreak ? indentText : "";
            }
            function parseTag(margin) {
              ts3.Debug.assert(token() === 59);
              var start2 = scanner.getTokenPos();
              nextTokenJSDoc();
              var tagName = parseJSDocIdentifierName(void 0);
              var indentText = skipWhitespaceOrAsterisk();
              var tag;
              switch (tagName.escapedText) {
                case "author":
                  tag = parseAuthorTag(start2, tagName, margin, indentText);
                  break;
                case "implements":
                  tag = parseImplementsTag(start2, tagName, margin, indentText);
                  break;
                case "augments":
                case "extends":
                  tag = parseAugmentsTag(start2, tagName, margin, indentText);
                  break;
                case "class":
                case "constructor":
                  tag = parseSimpleTag(start2, factory.createJSDocClassTag, tagName, margin, indentText);
                  break;
                case "public":
                  tag = parseSimpleTag(start2, factory.createJSDocPublicTag, tagName, margin, indentText);
                  break;
                case "private":
                  tag = parseSimpleTag(start2, factory.createJSDocPrivateTag, tagName, margin, indentText);
                  break;
                case "protected":
                  tag = parseSimpleTag(start2, factory.createJSDocProtectedTag, tagName, margin, indentText);
                  break;
                case "readonly":
                  tag = parseSimpleTag(start2, factory.createJSDocReadonlyTag, tagName, margin, indentText);
                  break;
                case "override":
                  tag = parseSimpleTag(start2, factory.createJSDocOverrideTag, tagName, margin, indentText);
                  break;
                case "deprecated":
                  hasDeprecatedTag = true;
                  tag = parseSimpleTag(start2, factory.createJSDocDeprecatedTag, tagName, margin, indentText);
                  break;
                case "this":
                  tag = parseThisTag(start2, tagName, margin, indentText);
                  break;
                case "enum":
                  tag = parseEnumTag(start2, tagName, margin, indentText);
                  break;
                case "arg":
                case "argument":
                case "param":
                  return parseParameterOrPropertyTag(start2, tagName, 2, margin);
                case "return":
                case "returns":
                  tag = parseReturnTag(start2, tagName, margin, indentText);
                  break;
                case "template":
                  tag = parseTemplateTag(start2, tagName, margin, indentText);
                  break;
                case "type":
                  tag = parseTypeTag(start2, tagName, margin, indentText);
                  break;
                case "typedef":
                  tag = parseTypedefTag(start2, tagName, margin, indentText);
                  break;
                case "callback":
                  tag = parseCallbackTag(start2, tagName, margin, indentText);
                  break;
                case "see":
                  tag = parseSeeTag(start2, tagName, margin, indentText);
                  break;
                default:
                  tag = parseUnknownTag(start2, tagName, margin, indentText);
                  break;
              }
              return tag;
            }
            function parseTrailingTagComments(pos, end2, margin, indentText) {
              if (!indentText) {
                margin += end2 - pos;
              }
              return parseTagComments(margin, indentText.slice(margin));
            }
            function parseTagComments(indent, initialMargin) {
              var commentsPos2 = getNodePos();
              var comments2 = [];
              var parts2 = [];
              var linkEnd2;
              var state = 0;
              var previousWhitespace = true;
              var margin;
              function pushComment(text) {
                if (!margin) {
                  margin = indent;
                }
                comments2.push(text);
                indent += text.length;
              }
              if (initialMargin !== void 0) {
                if (initialMargin !== "") {
                  pushComment(initialMargin);
                }
                state = 1;
              }
              var tok = token();
              loop:
                while (true) {
                  switch (tok) {
                    case 4:
                      state = 0;
                      comments2.push(scanner.getTokenText());
                      indent = 0;
                      break;
                    case 59:
                      if (state === 3 || state === 2 && (!previousWhitespace || lookAhead(isNextJSDocTokenWhitespace))) {
                        comments2.push(scanner.getTokenText());
                        break;
                      }
                      scanner.setTextPos(scanner.getTextPos() - 1);
                    case 1:
                      break loop;
                    case 5:
                      if (state === 2 || state === 3) {
                        pushComment(scanner.getTokenText());
                      } else {
                        var whitespace = scanner.getTokenText();
                        if (margin !== void 0 && indent + whitespace.length > margin) {
                          comments2.push(whitespace.slice(margin - indent));
                        }
                        indent += whitespace.length;
                      }
                      break;
                    case 18:
                      state = 2;
                      var commentEnd = scanner.getStartPos();
                      var linkStart = scanner.getTextPos() - 1;
                      var link = parseJSDocLink(linkStart);
                      if (link) {
                        parts2.push(finishNode(factory.createJSDocText(comments2.join("")), linkEnd2 !== null && linkEnd2 !== void 0 ? linkEnd2 : commentsPos2, commentEnd));
                        parts2.push(link);
                        comments2 = [];
                        linkEnd2 = scanner.getTextPos();
                      } else {
                        pushComment(scanner.getTokenText());
                      }
                      break;
                    case 61:
                      if (state === 3) {
                        state = 2;
                      } else {
                        state = 3;
                      }
                      pushComment(scanner.getTokenText());
                      break;
                    case 41:
                      if (state === 0) {
                        state = 1;
                        indent += 1;
                        break;
                      }
                    default:
                      if (state !== 3) {
                        state = 2;
                      }
                      pushComment(scanner.getTokenText());
                      break;
                  }
                  previousWhitespace = token() === 5;
                  tok = nextTokenJSDoc();
                }
              removeLeadingNewlines(comments2);
              removeTrailingWhitespace(comments2);
              if (parts2.length) {
                if (comments2.length) {
                  parts2.push(finishNode(factory.createJSDocText(comments2.join("")), linkEnd2 !== null && linkEnd2 !== void 0 ? linkEnd2 : commentsPos2));
                }
                return createNodeArray(parts2, commentsPos2, scanner.getTextPos());
              } else if (comments2.length) {
                return comments2.join("");
              }
            }
            function isNextJSDocTokenWhitespace() {
              var next = nextTokenJSDoc();
              return next === 5 || next === 4;
            }
            function parseJSDocLink(start2) {
              var linkType = tryParse(parseJSDocLinkPrefix);
              if (!linkType) {
                return void 0;
              }
              nextTokenJSDoc();
              skipWhitespace();
              var p2 = getNodePos();
              var name = ts3.tokenIsIdentifierOrKeyword(token()) ? parseEntityName(true) : void 0;
              if (name) {
                while (token() === 80) {
                  reScanHashToken();
                  nextTokenJSDoc();
                  name = finishNode(factory.createJSDocMemberName(name, parseIdentifier()), p2);
                }
              }
              var text = [];
              while (token() !== 19 && token() !== 4 && token() !== 1) {
                text.push(scanner.getTokenText());
                nextTokenJSDoc();
              }
              var create = linkType === "link" ? factory.createJSDocLink : linkType === "linkcode" ? factory.createJSDocLinkCode : factory.createJSDocLinkPlain;
              return finishNode(create(name, text.join("")), start2, scanner.getTextPos());
            }
            function parseJSDocLinkPrefix() {
              skipWhitespaceOrAsterisk();
              if (token() === 18 && nextTokenJSDoc() === 59 && ts3.tokenIsIdentifierOrKeyword(nextTokenJSDoc())) {
                var kind = scanner.getTokenValue();
                if (isJSDocLinkTag(kind))
                  return kind;
              }
            }
            function isJSDocLinkTag(kind) {
              return kind === "link" || kind === "linkcode" || kind === "linkplain";
            }
            function parseUnknownTag(start2, tagName, indent, indentText) {
              return finishNode(factory.createJSDocUnknownTag(tagName, parseTrailingTagComments(start2, getNodePos(), indent, indentText)), start2);
            }
            function addTag(tag) {
              if (!tag) {
                return;
              }
              if (!tags) {
                tags = [tag];
                tagsPos = tag.pos;
              } else {
                tags.push(tag);
              }
              tagsEnd = tag.end;
            }
            function tryParseTypeExpression() {
              skipWhitespaceOrAsterisk();
              return token() === 18 ? parseJSDocTypeExpression() : void 0;
            }
            function parseBracketNameInPropertyAndParamTag() {
              var isBracketed = parseOptionalJsdoc(22);
              if (isBracketed) {
                skipWhitespace();
              }
              var isBackquoted = parseOptionalJsdoc(61);
              var name = parseJSDocEntityName();
              if (isBackquoted) {
                parseExpectedTokenJSDoc(61);
              }
              if (isBracketed) {
                skipWhitespace();
                if (parseOptionalToken(63)) {
                  parseExpression();
                }
                parseExpected(23);
              }
              return { name, isBracketed };
            }
            function isObjectOrObjectArrayTypeReference(node) {
              switch (node.kind) {
                case 148:
                  return true;
                case 183:
                  return isObjectOrObjectArrayTypeReference(node.elementType);
                default:
                  return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && !node.typeArguments;
              }
            }
            function parseParameterOrPropertyTag(start2, tagName, target, indent) {
              var typeExpression = tryParseTypeExpression();
              var isNameFirst = !typeExpression;
              skipWhitespaceOrAsterisk();
              var _a = parseBracketNameInPropertyAndParamTag(), name = _a.name, isBracketed = _a.isBracketed;
              var indentText = skipWhitespaceOrAsterisk();
              if (isNameFirst && !lookAhead(parseJSDocLinkPrefix)) {
                typeExpression = tryParseTypeExpression();
              }
              var comment = parseTrailingTagComments(start2, getNodePos(), indent, indentText);
              var nestedTypeLiteral = target !== 4 && parseNestedTypeLiteral(typeExpression, name, target, indent);
              if (nestedTypeLiteral) {
                typeExpression = nestedTypeLiteral;
                isNameFirst = true;
              }
              var result2 = target === 1 ? factory.createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) : factory.createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment);
              return finishNode(result2, start2);
            }
            function parseNestedTypeLiteral(typeExpression, name, target, indent) {
              if (typeExpression && isObjectOrObjectArrayTypeReference(typeExpression.type)) {
                var pos = getNodePos();
                var child = void 0;
                var children = void 0;
                while (child = tryParse(function() {
                  return parseChildParameterOrPropertyTag(target, indent, name);
                })) {
                  if (child.kind === 340 || child.kind === 347) {
                    children = ts3.append(children, child);
                  }
                }
                if (children) {
                  var literal = finishNode(factory.createJSDocTypeLiteral(children, typeExpression.type.kind === 183), pos);
                  return finishNode(factory.createJSDocTypeExpression(literal), pos);
                }
              }
            }
            function parseReturnTag(start2, tagName, indent, indentText) {
              if (ts3.some(tags, ts3.isJSDocReturnTag)) {
                parseErrorAt(tagName.pos, scanner.getTokenPos(), ts3.Diagnostics._0_tag_already_specified, tagName.escapedText);
              }
              var typeExpression = tryParseTypeExpression();
              return finishNode(factory.createJSDocReturnTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), indent, indentText)), start2);
            }
            function parseTypeTag(start2, tagName, indent, indentText) {
              if (ts3.some(tags, ts3.isJSDocTypeTag)) {
                parseErrorAt(tagName.pos, scanner.getTokenPos(), ts3.Diagnostics._0_tag_already_specified, tagName.escapedText);
              }
              var typeExpression = parseJSDocTypeExpression(true);
              var comments2 = indent !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), indent, indentText) : void 0;
              return finishNode(factory.createJSDocTypeTag(tagName, typeExpression, comments2), start2);
            }
            function parseSeeTag(start2, tagName, indent, indentText) {
              var isMarkdownOrJSDocLink = token() === 22 || lookAhead(function() {
                return nextTokenJSDoc() === 59 && ts3.tokenIsIdentifierOrKeyword(nextTokenJSDoc()) && isJSDocLinkTag(scanner.getTokenValue());
              });
              var nameExpression = isMarkdownOrJSDocLink ? void 0 : parseJSDocNameReference();
              var comments2 = indent !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), indent, indentText) : void 0;
              return finishNode(factory.createJSDocSeeTag(tagName, nameExpression, comments2), start2);
            }
            function parseAuthorTag(start2, tagName, indent, indentText) {
              var commentStart = getNodePos();
              var textOnly = parseAuthorNameAndEmail();
              var commentEnd = scanner.getStartPos();
              var comments2 = parseTrailingTagComments(start2, commentEnd, indent, indentText);
              if (!comments2) {
                commentEnd = scanner.getStartPos();
              }
              var allParts = typeof comments2 !== "string" ? createNodeArray(ts3.concatenate([finishNode(textOnly, commentStart, commentEnd)], comments2), commentStart) : textOnly.text + comments2;
              return finishNode(factory.createJSDocAuthorTag(tagName, allParts), start2);
            }
            function parseAuthorNameAndEmail() {
              var comments2 = [];
              var inEmail = false;
              var token2 = scanner.getToken();
              while (token2 !== 1 && token2 !== 4) {
                if (token2 === 29) {
                  inEmail = true;
                } else if (token2 === 59 && !inEmail) {
                  break;
                } else if (token2 === 31 && inEmail) {
                  comments2.push(scanner.getTokenText());
                  scanner.setTextPos(scanner.getTokenPos() + 1);
                  break;
                }
                comments2.push(scanner.getTokenText());
                token2 = nextTokenJSDoc();
              }
              return factory.createJSDocText(comments2.join(""));
            }
            function parseImplementsTag(start2, tagName, margin, indentText) {
              var className = parseExpressionWithTypeArgumentsForAugments();
              return finishNode(factory.createJSDocImplementsTag(tagName, className, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseAugmentsTag(start2, tagName, margin, indentText) {
              var className = parseExpressionWithTypeArgumentsForAugments();
              return finishNode(factory.createJSDocAugmentsTag(tagName, className, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseExpressionWithTypeArgumentsForAugments() {
              var usedBrace = parseOptional(18);
              var pos = getNodePos();
              var expression = parsePropertyAccessEntityNameExpression();
              var typeArguments = tryParseTypeArguments();
              var node = factory.createExpressionWithTypeArguments(expression, typeArguments);
              var res = finishNode(node, pos);
              if (usedBrace) {
                parseExpected(19);
              }
              return res;
            }
            function parsePropertyAccessEntityNameExpression() {
              var pos = getNodePos();
              var node = parseJSDocIdentifierName();
              while (parseOptional(24)) {
                var name = parseJSDocIdentifierName();
                node = finishNode(factory.createPropertyAccessExpression(node, name), pos);
              }
              return node;
            }
            function parseSimpleTag(start2, createTag, tagName, margin, indentText) {
              return finishNode(createTag(tagName, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseThisTag(start2, tagName, margin, indentText) {
              var typeExpression = parseJSDocTypeExpression(true);
              skipWhitespace();
              return finishNode(factory.createJSDocThisTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseEnumTag(start2, tagName, margin, indentText) {
              var typeExpression = parseJSDocTypeExpression(true);
              skipWhitespace();
              return finishNode(factory.createJSDocEnumTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseTypedefTag(start2, tagName, indent, indentText) {
              var _a;
              var typeExpression = tryParseTypeExpression();
              skipWhitespaceOrAsterisk();
              var fullName = parseJSDocTypeNameWithNamespace();
              skipWhitespace();
              var comment = parseTagComments(indent);
              var end2;
              if (!typeExpression || isObjectOrObjectArrayTypeReference(typeExpression.type)) {
                var child = void 0;
                var childTypeTag = void 0;
                var jsDocPropertyTags = void 0;
                var hasChildren = false;
                while (child = tryParse(function() {
                  return parseChildPropertyTag(indent);
                })) {
                  hasChildren = true;
                  if (child.kind === 343) {
                    if (childTypeTag) {
                      var lastError = parseErrorAtCurrentToken(ts3.Diagnostics.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);
                      if (lastError) {
                        ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName2, 0, 0, ts3.Diagnostics.The_tag_was_first_specified_here));
                      }
                      break;
                    } else {
                      childTypeTag = child;
                    }
                  } else {
                    jsDocPropertyTags = ts3.append(jsDocPropertyTags, child);
                  }
                }
                if (hasChildren) {
                  var isArrayType = typeExpression && typeExpression.type.kind === 183;
                  var jsdocTypeLiteral = factory.createJSDocTypeLiteral(jsDocPropertyTags, isArrayType);
                  typeExpression = childTypeTag && childTypeTag.typeExpression && !isObjectOrObjectArrayTypeReference(childTypeTag.typeExpression.type) ? childTypeTag.typeExpression : finishNode(jsdocTypeLiteral, start2);
                  end2 = typeExpression.end;
                }
              }
              end2 = end2 || comment !== void 0 ? getNodePos() : ((_a = fullName !== null && fullName !== void 0 ? fullName : typeExpression) !== null && _a !== void 0 ? _a : tagName).end;
              if (!comment) {
                comment = parseTrailingTagComments(start2, end2, indent, indentText);
              }
              var typedefTag = factory.createJSDocTypedefTag(tagName, typeExpression, fullName, comment);
              return finishNode(typedefTag, start2, end2);
            }
            function parseJSDocTypeNameWithNamespace(nested) {
              var pos = scanner.getTokenPos();
              if (!ts3.tokenIsIdentifierOrKeyword(token())) {
                return void 0;
              }
              var typeNameOrNamespaceName = parseJSDocIdentifierName();
              if (parseOptional(24)) {
                var body = parseJSDocTypeNameWithNamespace(true);
                var jsDocNamespaceNode = factory.createModuleDeclaration(void 0, void 0, typeNameOrNamespaceName, body, nested ? 4 : void 0);
                return finishNode(jsDocNamespaceNode, pos);
              }
              if (nested) {
                typeNameOrNamespaceName.isInJSDocNamespace = true;
              }
              return typeNameOrNamespaceName;
            }
            function parseCallbackTagParameters(indent) {
              var pos = getNodePos();
              var child;
              var parameters;
              while (child = tryParse(function() {
                return parseChildParameterOrPropertyTag(4, indent);
              })) {
                parameters = ts3.append(parameters, child);
              }
              return createNodeArray(parameters || [], pos);
            }
            function parseCallbackTag(start2, tagName, indent, indentText) {
              var fullName = parseJSDocTypeNameWithNamespace();
              skipWhitespace();
              var comment = parseTagComments(indent);
              var parameters = parseCallbackTagParameters(indent);
              var returnTag = tryParse(function() {
                if (parseOptionalJsdoc(59)) {
                  var tag = parseTag(indent);
                  if (tag && tag.kind === 341) {
                    return tag;
                  }
                }
              });
              var typeExpression = finishNode(factory.createJSDocSignature(void 0, parameters, returnTag), start2);
              if (!comment) {
                comment = parseTrailingTagComments(start2, getNodePos(), indent, indentText);
              }
              var end2 = comment !== void 0 ? getNodePos() : typeExpression.end;
              return finishNode(factory.createJSDocCallbackTag(tagName, typeExpression, fullName, comment), start2, end2);
            }
            function escapedTextsEqual(a, b) {
              while (!ts3.isIdentifier(a) || !ts3.isIdentifier(b)) {
                if (!ts3.isIdentifier(a) && !ts3.isIdentifier(b) && a.right.escapedText === b.right.escapedText) {
                  a = a.left;
                  b = b.left;
                } else {
                  return false;
                }
              }
              return a.escapedText === b.escapedText;
            }
            function parseChildPropertyTag(indent) {
              return parseChildParameterOrPropertyTag(1, indent);
            }
            function parseChildParameterOrPropertyTag(target, indent, name) {
              var canParseTag = true;
              var seenAsterisk = false;
              while (true) {
                switch (nextTokenJSDoc()) {
                  case 59:
                    if (canParseTag) {
                      var child = tryParseChildTag(target, indent);
                      if (child && (child.kind === 340 || child.kind === 347) && target !== 4 && name && (ts3.isIdentifier(child.name) || !escapedTextsEqual(name, child.name.left))) {
                        return false;
                      }
                      return child;
                    }
                    seenAsterisk = false;
                    break;
                  case 4:
                    canParseTag = true;
                    seenAsterisk = false;
                    break;
                  case 41:
                    if (seenAsterisk) {
                      canParseTag = false;
                    }
                    seenAsterisk = true;
                    break;
                  case 79:
                    canParseTag = false;
                    break;
                  case 1:
                    return false;
                }
              }
            }
            function tryParseChildTag(target, indent) {
              ts3.Debug.assert(token() === 59);
              var start2 = scanner.getStartPos();
              nextTokenJSDoc();
              var tagName = parseJSDocIdentifierName();
              skipWhitespace();
              var t;
              switch (tagName.escapedText) {
                case "type":
                  return target === 1 && parseTypeTag(start2, tagName);
                case "prop":
                case "property":
                  t = 1;
                  break;
                case "arg":
                case "argument":
                case "param":
                  t = 2 | 4;
                  break;
                default:
                  return false;
              }
              if (!(target & t)) {
                return false;
              }
              return parseParameterOrPropertyTag(start2, tagName, target, indent);
            }
            function parseTemplateTagTypeParameter() {
              var typeParameterPos = getNodePos();
              var isBracketed = parseOptionalJsdoc(22);
              if (isBracketed) {
                skipWhitespace();
              }
              var name = parseJSDocIdentifierName(ts3.Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces);
              var defaultType;
              if (isBracketed) {
                skipWhitespace();
                parseExpected(63);
                defaultType = doInsideOfContext(8388608, parseJSDocType);
                parseExpected(23);
              }
              if (ts3.nodeIsMissing(name)) {
                return void 0;
              }
              return finishNode(factory.createTypeParameterDeclaration(void 0, name, void 0, defaultType), typeParameterPos);
            }
            function parseTemplateTagTypeParameters() {
              var pos = getNodePos();
              var typeParameters = [];
              do {
                skipWhitespace();
                var node = parseTemplateTagTypeParameter();
                if (node !== void 0) {
                  typeParameters.push(node);
                }
                skipWhitespaceOrAsterisk();
              } while (parseOptionalJsdoc(27));
              return createNodeArray(typeParameters, pos);
            }
            function parseTemplateTag(start2, tagName, indent, indentText) {
              var constraint = token() === 18 ? parseJSDocTypeExpression() : void 0;
              var typeParameters = parseTemplateTagTypeParameters();
              return finishNode(factory.createJSDocTemplateTag(tagName, constraint, typeParameters, parseTrailingTagComments(start2, getNodePos(), indent, indentText)), start2);
            }
            function parseOptionalJsdoc(t) {
              if (token() === t) {
                nextTokenJSDoc();
                return true;
              }
              return false;
            }
            function parseJSDocEntityName() {
              var entity = parseJSDocIdentifierName();
              if (parseOptional(22)) {
                parseExpected(23);
              }
              while (parseOptional(24)) {
                var name = parseJSDocIdentifierName();
                if (parseOptional(22)) {
                  parseExpected(23);
                }
                entity = createQualifiedName(entity, name);
              }
              return entity;
            }
            function parseJSDocIdentifierName(message) {
              if (!ts3.tokenIsIdentifierOrKeyword(token())) {
                return createMissingNode(79, !message, message || ts3.Diagnostics.Identifier_expected);
              }
              identifierCount++;
              var pos = scanner.getTokenPos();
              var end2 = scanner.getTextPos();
              var originalKeywordKind = token();
              var text = internIdentifier(scanner.getTokenValue());
              var result2 = finishNode(factory.createIdentifier(text, void 0, originalKeywordKind), pos, end2);
              nextTokenJSDoc();
              return result2;
            }
          }
        })(JSDocParser = Parser2.JSDocParser || (Parser2.JSDocParser = {}));
      })(Parser || (Parser = {}));
      var IncrementalParser;
      (function(IncrementalParser2) {
        function updateSourceFile2(sourceFile, newText, textChangeRange, aggressiveChecks) {
          aggressiveChecks = aggressiveChecks || ts3.Debug.shouldAssert(2);
          checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks);
          if (ts3.textChangeRangeIsUnchanged(textChangeRange)) {
            return sourceFile;
          }
          if (sourceFile.statements.length === 0) {
            return Parser.parseSourceFile(sourceFile.fileName, newText, sourceFile.languageVersion, void 0, true, sourceFile.scriptKind, sourceFile.setExternalModuleIndicator);
          }
          var incrementalSourceFile = sourceFile;
          ts3.Debug.assert(!incrementalSourceFile.hasBeenIncrementallyParsed);
          incrementalSourceFile.hasBeenIncrementallyParsed = true;
          Parser.fixupParentReferences(incrementalSourceFile);
          var oldText = sourceFile.text;
          var syntaxCursor = createSyntaxCursor(sourceFile);
          var changeRange = extendToAffectedRange(sourceFile, textChangeRange);
          checkChangeRange(sourceFile, newText, changeRange, aggressiveChecks);
          ts3.Debug.assert(changeRange.span.start <= textChangeRange.span.start);
          ts3.Debug.assert(ts3.textSpanEnd(changeRange.span) === ts3.textSpanEnd(textChangeRange.span));
          ts3.Debug.assert(ts3.textSpanEnd(ts3.textChangeRangeNewSpan(changeRange)) === ts3.textSpanEnd(ts3.textChangeRangeNewSpan(textChangeRange)));
          var delta = ts3.textChangeRangeNewSpan(changeRange).length - changeRange.span.length;
          updateTokenPositionsAndMarkElements(incrementalSourceFile, changeRange.span.start, ts3.textSpanEnd(changeRange.span), ts3.textSpanEnd(ts3.textChangeRangeNewSpan(changeRange)), delta, oldText, newText, aggressiveChecks);
          var result2 = Parser.parseSourceFile(sourceFile.fileName, newText, sourceFile.languageVersion, syntaxCursor, true, sourceFile.scriptKind, sourceFile.setExternalModuleIndicator);
          result2.commentDirectives = getNewCommentDirectives(sourceFile.commentDirectives, result2.commentDirectives, changeRange.span.start, ts3.textSpanEnd(changeRange.span), delta, oldText, newText, aggressiveChecks);
          result2.impliedNodeFormat = sourceFile.impliedNodeFormat;
          return result2;
        }
        IncrementalParser2.updateSourceFile = updateSourceFile2;
        function getNewCommentDirectives(oldDirectives, newDirectives, changeStart, changeRangeOldEnd, delta, oldText, newText, aggressiveChecks) {
          if (!oldDirectives)
            return newDirectives;
          var commentDirectives;
          var addedNewlyScannedDirectives = false;
          for (var _i = 0, oldDirectives_1 = oldDirectives; _i < oldDirectives_1.length; _i++) {
            var directive = oldDirectives_1[_i];
            var range = directive.range, type2 = directive.type;
            if (range.end < changeStart) {
              commentDirectives = ts3.append(commentDirectives, directive);
            } else if (range.pos > changeRangeOldEnd) {
              addNewlyScannedDirectives();
              var updatedDirective = {
                range: { pos: range.pos + delta, end: range.end + delta },
                type: type2
              };
              commentDirectives = ts3.append(commentDirectives, updatedDirective);
              if (aggressiveChecks) {
                ts3.Debug.assert(oldText.substring(range.pos, range.end) === newText.substring(updatedDirective.range.pos, updatedDirective.range.end));
              }
            }
          }
          addNewlyScannedDirectives();
          return commentDirectives;
          function addNewlyScannedDirectives() {
            if (addedNewlyScannedDirectives)
              return;
            addedNewlyScannedDirectives = true;
            if (!commentDirectives) {
              commentDirectives = newDirectives;
            } else if (newDirectives) {
              commentDirectives.push.apply(commentDirectives, newDirectives);
            }
          }
        }
        function moveElementEntirelyPastChangeRange(element, isArray, delta, oldText, newText, aggressiveChecks) {
          if (isArray) {
            visitArray(element);
          } else {
            visitNode2(element);
          }
          return;
          function visitNode2(node) {
            var text = "";
            if (aggressiveChecks && shouldCheckNode(node)) {
              text = oldText.substring(node.pos, node.end);
            }
            if (node._children) {
              node._children = void 0;
            }
            ts3.setTextRangePosEnd(node, node.pos + delta, node.end + delta);
            if (aggressiveChecks && shouldCheckNode(node)) {
              ts3.Debug.assert(text === newText.substring(node.pos, node.end));
            }
            forEachChild(node, visitNode2, visitArray);
            if (ts3.hasJSDocNodes(node)) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var jsDocComment = _a[_i];
                visitNode2(jsDocComment);
              }
            }
            checkNodePositions(node, aggressiveChecks);
          }
          function visitArray(array) {
            array._children = void 0;
            ts3.setTextRangePosEnd(array, array.pos + delta, array.end + delta);
            for (var _i = 0, array_9 = array; _i < array_9.length; _i++) {
              var node = array_9[_i];
              visitNode2(node);
            }
          }
        }
        function shouldCheckNode(node) {
          switch (node.kind) {
            case 10:
            case 8:
            case 79:
              return true;
          }
          return false;
        }
        function adjustIntersectingElement(element, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta) {
          ts3.Debug.assert(element.end >= changeStart, "Adjusting an element that was entirely before the change range");
          ts3.Debug.assert(element.pos <= changeRangeOldEnd, "Adjusting an element that was entirely after the change range");
          ts3.Debug.assert(element.pos <= element.end);
          var pos = Math.min(element.pos, changeRangeNewEnd);
          var end = element.end >= changeRangeOldEnd ? element.end + delta : Math.min(element.end, changeRangeNewEnd);
          ts3.Debug.assert(pos <= end);
          if (element.parent) {
            ts3.Debug.assertGreaterThanOrEqual(pos, element.parent.pos);
            ts3.Debug.assertLessThanOrEqual(end, element.parent.end);
          }
          ts3.setTextRangePosEnd(element, pos, end);
        }
        function checkNodePositions(node, aggressiveChecks) {
          if (aggressiveChecks) {
            var pos_2 = node.pos;
            var visitNode_1 = function(child) {
              ts3.Debug.assert(child.pos >= pos_2);
              pos_2 = child.end;
            };
            if (ts3.hasJSDocNodes(node)) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var jsDocComment = _a[_i];
                visitNode_1(jsDocComment);
              }
            }
            forEachChild(node, visitNode_1);
            ts3.Debug.assert(pos_2 <= node.end);
          }
        }
        function updateTokenPositionsAndMarkElements(sourceFile, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta, oldText, newText, aggressiveChecks) {
          visitNode2(sourceFile);
          return;
          function visitNode2(child) {
            ts3.Debug.assert(child.pos <= child.end);
            if (child.pos > changeRangeOldEnd) {
              moveElementEntirelyPastChangeRange(child, false, delta, oldText, newText, aggressiveChecks);
              return;
            }
            var fullEnd = child.end;
            if (fullEnd >= changeStart) {
              child.intersectsChange = true;
              child._children = void 0;
              adjustIntersectingElement(child, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
              forEachChild(child, visitNode2, visitArray);
              if (ts3.hasJSDocNodes(child)) {
                for (var _i = 0, _a = child.jsDoc; _i < _a.length; _i++) {
                  var jsDocComment = _a[_i];
                  visitNode2(jsDocComment);
                }
              }
              checkNodePositions(child, aggressiveChecks);
              return;
            }
            ts3.Debug.assert(fullEnd < changeStart);
          }
          function visitArray(array) {
            ts3.Debug.assert(array.pos <= array.end);
            if (array.pos > changeRangeOldEnd) {
              moveElementEntirelyPastChangeRange(array, true, delta, oldText, newText, aggressiveChecks);
              return;
            }
            var fullEnd = array.end;
            if (fullEnd >= changeStart) {
              array.intersectsChange = true;
              array._children = void 0;
              adjustIntersectingElement(array, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
              for (var _i = 0, array_10 = array; _i < array_10.length; _i++) {
                var node = array_10[_i];
                visitNode2(node);
              }
              return;
            }
            ts3.Debug.assert(fullEnd < changeStart);
          }
        }
        function extendToAffectedRange(sourceFile, changeRange) {
          var maxLookahead = 1;
          var start = changeRange.span.start;
          for (var i = 0; start > 0 && i <= maxLookahead; i++) {
            var nearestNode = findNearestNodeStartingBeforeOrAtPosition(sourceFile, start);
            ts3.Debug.assert(nearestNode.pos <= start);
            var position = nearestNode.pos;
            start = Math.max(0, position - 1);
          }
          var finalSpan = ts3.createTextSpanFromBounds(start, ts3.textSpanEnd(changeRange.span));
          var finalLength = changeRange.newLength + (changeRange.span.start - start);
          return ts3.createTextChangeRange(finalSpan, finalLength);
        }
        function findNearestNodeStartingBeforeOrAtPosition(sourceFile, position) {
          var bestResult = sourceFile;
          var lastNodeEntirelyBeforePosition;
          forEachChild(sourceFile, visit);
          if (lastNodeEntirelyBeforePosition) {
            var lastChildOfLastEntireNodeBeforePosition = getLastDescendant(lastNodeEntirelyBeforePosition);
            if (lastChildOfLastEntireNodeBeforePosition.pos > bestResult.pos) {
              bestResult = lastChildOfLastEntireNodeBeforePosition;
            }
          }
          return bestResult;
          function getLastDescendant(node) {
            while (true) {
              var lastChild = ts3.getLastChild(node);
              if (lastChild) {
                node = lastChild;
              } else {
                return node;
              }
            }
          }
          function visit(child) {
            if (ts3.nodeIsMissing(child)) {
              return;
            }
            if (child.pos <= position) {
              if (child.pos >= bestResult.pos) {
                bestResult = child;
              }
              if (position < child.end) {
                forEachChild(child, visit);
                return true;
              } else {
                ts3.Debug.assert(child.end <= position);
                lastNodeEntirelyBeforePosition = child;
              }
            } else {
              ts3.Debug.assert(child.pos > position);
              return true;
            }
          }
        }
        function checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks) {
          var oldText = sourceFile.text;
          if (textChangeRange) {
            ts3.Debug.assert(oldText.length - textChangeRange.span.length + textChangeRange.newLength === newText.length);
            if (aggressiveChecks || ts3.Debug.shouldAssert(3)) {
              var oldTextPrefix = oldText.substr(0, textChangeRange.span.start);
              var newTextPrefix = newText.substr(0, textChangeRange.span.start);
              ts3.Debug.assert(oldTextPrefix === newTextPrefix);
              var oldTextSuffix = oldText.substring(ts3.textSpanEnd(textChangeRange.span), oldText.length);
              var newTextSuffix = newText.substring(ts3.textSpanEnd(ts3.textChangeRangeNewSpan(textChangeRange)), newText.length);
              ts3.Debug.assert(oldTextSuffix === newTextSuffix);
            }
          }
        }
        function createSyntaxCursor(sourceFile) {
          var currentArray = sourceFile.statements;
          var currentArrayIndex = 0;
          ts3.Debug.assert(currentArrayIndex < currentArray.length);
          var current = currentArray[currentArrayIndex];
          var lastQueriedPosition = -1;
          return {
            currentNode: function(position) {
              if (position !== lastQueriedPosition) {
                if (current && current.end === position && currentArrayIndex < currentArray.length - 1) {
                  currentArrayIndex++;
                  current = currentArray[currentArrayIndex];
                }
                if (!current || current.pos !== position) {
                  findHighestListElementThatStartsAtPosition(position);
                }
              }
              lastQueriedPosition = position;
              ts3.Debug.assert(!current || current.pos === position);
              return current;
            }
          };
          function findHighestListElementThatStartsAtPosition(position) {
            currentArray = void 0;
            currentArrayIndex = -1;
            current = void 0;
            forEachChild(sourceFile, visitNode2, visitArray);
            return;
            function visitNode2(node) {
              if (position >= node.pos && position < node.end) {
                forEachChild(node, visitNode2, visitArray);
                return true;
              }
              return false;
            }
            function visitArray(array) {
              if (position >= array.pos && position < array.end) {
                for (var i = 0; i < array.length; i++) {
                  var child = array[i];
                  if (child) {
                    if (child.pos === position) {
                      currentArray = array;
                      currentArrayIndex = i;
                      current = child;
                      return true;
                    } else {
                      if (child.pos < position && position < child.end) {
                        forEachChild(child, visitNode2, visitArray);
                        return true;
                      }
                    }
                  }
                }
              }
              return false;
            }
          }
        }
        IncrementalParser2.createSyntaxCursor = createSyntaxCursor;
        var InvalidPosition;
        (function(InvalidPosition2) {
          InvalidPosition2[InvalidPosition2["Value"] = -1] = "Value";
        })(InvalidPosition || (InvalidPosition = {}));
      })(IncrementalParser || (IncrementalParser = {}));
      function isDeclarationFileName(fileName2) {
        return ts3.fileExtensionIsOneOf(fileName2, ts3.supportedDeclarationExtensions);
      }
      ts3.isDeclarationFileName = isDeclarationFileName;
      function parseResolutionMode(mode, pos, end, reportDiagnostic) {
        if (!mode) {
          return void 0;
        }
        if (mode === "import") {
          return ts3.ModuleKind.ESNext;
        }
        if (mode === "require") {
          return ts3.ModuleKind.CommonJS;
        }
        reportDiagnostic(pos, end - pos, ts3.Diagnostics.resolution_mode_should_be_either_require_or_import);
        return void 0;
      }
      function processCommentPragmas(context, sourceText) {
        var pragmas = [];
        for (var _i = 0, _a = ts3.getLeadingCommentRanges(sourceText, 0) || ts3.emptyArray; _i < _a.length; _i++) {
          var range = _a[_i];
          var comment = sourceText.substring(range.pos, range.end);
          extractPragmas(pragmas, range, comment);
        }
        context.pragmas = new ts3.Map();
        for (var _b = 0, pragmas_1 = pragmas; _b < pragmas_1.length; _b++) {
          var pragma = pragmas_1[_b];
          if (context.pragmas.has(pragma.name)) {
            var currentValue = context.pragmas.get(pragma.name);
            if (currentValue instanceof Array) {
              currentValue.push(pragma.args);
            } else {
              context.pragmas.set(pragma.name, [currentValue, pragma.args]);
            }
            continue;
          }
          context.pragmas.set(pragma.name, pragma.args);
        }
      }
      ts3.processCommentPragmas = processCommentPragmas;
      function processPragmasIntoFields(context, reportDiagnostic) {
        context.checkJsDirective = void 0;
        context.referencedFiles = [];
        context.typeReferenceDirectives = [];
        context.libReferenceDirectives = [];
        context.amdDependencies = [];
        context.hasNoDefaultLib = false;
        context.pragmas.forEach(function(entryOrList, key) {
          switch (key) {
            case "reference": {
              var referencedFiles_1 = context.referencedFiles;
              var typeReferenceDirectives_1 = context.typeReferenceDirectives;
              var libReferenceDirectives_1 = context.libReferenceDirectives;
              ts3.forEach(ts3.toArray(entryOrList), function(arg) {
                var _a = arg.arguments, types2 = _a.types, lib = _a.lib, path2 = _a.path, res = _a["resolution-mode"];
                if (arg.arguments["no-default-lib"]) {
                  context.hasNoDefaultLib = true;
                } else if (types2) {
                  var parsed = parseResolutionMode(res, types2.pos, types2.end, reportDiagnostic);
                  typeReferenceDirectives_1.push(__assign({ pos: types2.pos, end: types2.end, fileName: types2.value }, parsed ? { resolutionMode: parsed } : {}));
                } else if (lib) {
                  libReferenceDirectives_1.push({ pos: lib.pos, end: lib.end, fileName: lib.value });
                } else if (path2) {
                  referencedFiles_1.push({ pos: path2.pos, end: path2.end, fileName: path2.value });
                } else {
                  reportDiagnostic(arg.range.pos, arg.range.end - arg.range.pos, ts3.Diagnostics.Invalid_reference_directive_syntax);
                }
              });
              break;
            }
            case "amd-dependency": {
              context.amdDependencies = ts3.map(ts3.toArray(entryOrList), function(x) {
                return { name: x.arguments.name, path: x.arguments.path };
              });
              break;
            }
            case "amd-module": {
              if (entryOrList instanceof Array) {
                for (var _i = 0, entryOrList_1 = entryOrList; _i < entryOrList_1.length; _i++) {
                  var entry = entryOrList_1[_i];
                  if (context.moduleName) {
                    reportDiagnostic(entry.range.pos, entry.range.end - entry.range.pos, ts3.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments);
                  }
                  context.moduleName = entry.arguments.name;
                }
              } else {
                context.moduleName = entryOrList.arguments.name;
              }
              break;
            }
            case "ts-nocheck":
            case "ts-check": {
              ts3.forEach(ts3.toArray(entryOrList), function(entry2) {
                if (!context.checkJsDirective || entry2.range.pos > context.checkJsDirective.pos) {
                  context.checkJsDirective = {
                    enabled: key === "ts-check",
                    end: entry2.range.end,
                    pos: entry2.range.pos
                  };
                }
              });
              break;
            }
            case "jsx":
            case "jsxfrag":
            case "jsximportsource":
            case "jsxruntime":
              return;
            default:
              ts3.Debug.fail("Unhandled pragma kind");
          }
        });
      }
      ts3.processPragmasIntoFields = processPragmasIntoFields;
      var namedArgRegExCache = new ts3.Map();
      function getNamedArgRegEx(name) {
        if (namedArgRegExCache.has(name)) {
          return namedArgRegExCache.get(name);
        }
        var result2 = new RegExp("(\\s".concat(name, `\\s*=\\s*)(?:(?:'([^']*)')|(?:"([^"]*)"))`), "im");
        namedArgRegExCache.set(name, result2);
        return result2;
      }
      var tripleSlashXMLCommentStartRegEx = /^\/\/\/\s*<(\S+)\s.*?\/>/im;
      var singleLinePragmaRegEx = /^\/\/\/?\s*@(\S+)\s*(.*)\s*$/im;
      function extractPragmas(pragmas, range, text) {
        var tripleSlash = range.kind === 2 && tripleSlashXMLCommentStartRegEx.exec(text);
        if (tripleSlash) {
          var name = tripleSlash[1].toLowerCase();
          var pragma = ts3.commentPragmas[name];
          if (!pragma || !(pragma.kind & 1)) {
            return;
          }
          if (pragma.args) {
            var argument = {};
            for (var _i = 0, _a = pragma.args; _i < _a.length; _i++) {
              var arg = _a[_i];
              var matcher = getNamedArgRegEx(arg.name);
              var matchResult = matcher.exec(text);
              if (!matchResult && !arg.optional) {
                return;
              } else if (matchResult) {
                var value = matchResult[2] || matchResult[3];
                if (arg.captureSpan) {
                  var startPos = range.pos + matchResult.index + matchResult[1].length + 1;
                  argument[arg.name] = {
                    value,
                    pos: startPos,
                    end: startPos + value.length
                  };
                } else {
                  argument[arg.name] = value;
                }
              }
            }
            pragmas.push({ name, args: { arguments: argument, range } });
          } else {
            pragmas.push({ name, args: { arguments: {}, range } });
          }
          return;
        }
        var singleLine = range.kind === 2 && singleLinePragmaRegEx.exec(text);
        if (singleLine) {
          return addPragmaForMatch(pragmas, range, 2, singleLine);
        }
        if (range.kind === 3) {
          var multiLinePragmaRegEx = /@(\S+)(\s+.*)?$/gim;
          var multiLineMatch = void 0;
          while (multiLineMatch = multiLinePragmaRegEx.exec(text)) {
            addPragmaForMatch(pragmas, range, 4, multiLineMatch);
          }
        }
      }
      function addPragmaForMatch(pragmas, range, kind, match) {
        if (!match)
          return;
        var name = match[1].toLowerCase();
        var pragma = ts3.commentPragmas[name];
        if (!pragma || !(pragma.kind & kind)) {
          return;
        }
        var args = match[2];
        var argument = getNamedPragmaArguments(pragma, args);
        if (argument === "fail")
          return;
        pragmas.push({ name, args: { arguments: argument, range } });
        return;
      }
      function getNamedPragmaArguments(pragma, text) {
        if (!text)
          return {};
        if (!pragma.args)
          return {};
        var args = ts3.trimString(text).split(/\s+/);
        var argMap = {};
        for (var i = 0; i < pragma.args.length; i++) {
          var argument = pragma.args[i];
          if (!args[i] && !argument.optional) {
            return "fail";
          }
          if (argument.captureSpan) {
            return ts3.Debug.fail("Capture spans not yet implemented for non-xml pragmas");
          }
          argMap[argument.name] = args[i];
        }
        return argMap;
      }
      function tagNamesAreEquivalent(lhs, rhs) {
        if (lhs.kind !== rhs.kind) {
          return false;
        }
        if (lhs.kind === 79) {
          return lhs.escapedText === rhs.escapedText;
        }
        if (lhs.kind === 108) {
          return true;
        }
        return lhs.name.escapedText === rhs.name.escapedText && tagNamesAreEquivalent(lhs.expression, rhs.expression);
      }
      ts3.tagNamesAreEquivalent = tagNamesAreEquivalent;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.compileOnSaveCommandLineOption = {
        name: "compileOnSave",
        type: "boolean",
        defaultValueDescription: false
      };
      var jsxOptionMap = new ts3.Map(ts3.getEntries({
        "preserve": 1,
        "react-native": 3,
        "react": 2,
        "react-jsx": 4,
        "react-jsxdev": 5
      }));
      ts3.inverseJsxOptionMap = new ts3.Map(ts3.arrayFrom(ts3.mapIterator(jsxOptionMap.entries(), function(_a) {
        var key = _a[0], value = _a[1];
        return ["" + value, key];
      })));
      var libEntries = [
        ["es5", "lib.es5.d.ts"],
        ["es6", "lib.es2015.d.ts"],
        ["es2015", "lib.es2015.d.ts"],
        ["es7", "lib.es2016.d.ts"],
        ["es2016", "lib.es2016.d.ts"],
        ["es2017", "lib.es2017.d.ts"],
        ["es2018", "lib.es2018.d.ts"],
        ["es2019", "lib.es2019.d.ts"],
        ["es2020", "lib.es2020.d.ts"],
        ["es2021", "lib.es2021.d.ts"],
        ["es2022", "lib.es2022.d.ts"],
        ["esnext", "lib.esnext.d.ts"],
        ["dom", "lib.dom.d.ts"],
        ["dom.iterable", "lib.dom.iterable.d.ts"],
        ["webworker", "lib.webworker.d.ts"],
        ["webworker.importscripts", "lib.webworker.importscripts.d.ts"],
        ["webworker.iterable", "lib.webworker.iterable.d.ts"],
        ["scripthost", "lib.scripthost.d.ts"],
        ["es2015.core", "lib.es2015.core.d.ts"],
        ["es2015.collection", "lib.es2015.collection.d.ts"],
        ["es2015.generator", "lib.es2015.generator.d.ts"],
        ["es2015.iterable", "lib.es2015.iterable.d.ts"],
        ["es2015.promise", "lib.es2015.promise.d.ts"],
        ["es2015.proxy", "lib.es2015.proxy.d.ts"],
        ["es2015.reflect", "lib.es2015.reflect.d.ts"],
        ["es2015.symbol", "lib.es2015.symbol.d.ts"],
        ["es2015.symbol.wellknown", "lib.es2015.symbol.wellknown.d.ts"],
        ["es2016.array.include", "lib.es2016.array.include.d.ts"],
        ["es2017.object", "lib.es2017.object.d.ts"],
        ["es2017.sharedmemory", "lib.es2017.sharedmemory.d.ts"],
        ["es2017.string", "lib.es2017.string.d.ts"],
        ["es2017.intl", "lib.es2017.intl.d.ts"],
        ["es2017.typedarrays", "lib.es2017.typedarrays.d.ts"],
        ["es2018.asyncgenerator", "lib.es2018.asyncgenerator.d.ts"],
        ["es2018.asynciterable", "lib.es2018.asynciterable.d.ts"],
        ["es2018.intl", "lib.es2018.intl.d.ts"],
        ["es2018.promise", "lib.es2018.promise.d.ts"],
        ["es2018.regexp", "lib.es2018.regexp.d.ts"],
        ["es2019.array", "lib.es2019.array.d.ts"],
        ["es2019.object", "lib.es2019.object.d.ts"],
        ["es2019.string", "lib.es2019.string.d.ts"],
        ["es2019.symbol", "lib.es2019.symbol.d.ts"],
        ["es2020.bigint", "lib.es2020.bigint.d.ts"],
        ["es2020.date", "lib.es2020.date.d.ts"],
        ["es2020.promise", "lib.es2020.promise.d.ts"],
        ["es2020.sharedmemory", "lib.es2020.sharedmemory.d.ts"],
        ["es2020.string", "lib.es2020.string.d.ts"],
        ["es2020.symbol.wellknown", "lib.es2020.symbol.wellknown.d.ts"],
        ["es2020.intl", "lib.es2020.intl.d.ts"],
        ["es2020.number", "lib.es2020.number.d.ts"],
        ["es2021.promise", "lib.es2021.promise.d.ts"],
        ["es2021.string", "lib.es2021.string.d.ts"],
        ["es2021.weakref", "lib.es2021.weakref.d.ts"],
        ["es2021.intl", "lib.es2021.intl.d.ts"],
        ["es2022.array", "lib.es2022.array.d.ts"],
        ["es2022.error", "lib.es2022.error.d.ts"],
        ["es2022.intl", "lib.es2022.intl.d.ts"],
        ["es2022.object", "lib.es2022.object.d.ts"],
        ["es2022.string", "lib.es2022.string.d.ts"],
        ["esnext.array", "lib.es2022.array.d.ts"],
        ["esnext.symbol", "lib.es2019.symbol.d.ts"],
        ["esnext.asynciterable", "lib.es2018.asynciterable.d.ts"],
        ["esnext.intl", "lib.esnext.intl.d.ts"],
        ["esnext.bigint", "lib.es2020.bigint.d.ts"],
        ["esnext.string", "lib.es2022.string.d.ts"],
        ["esnext.promise", "lib.es2021.promise.d.ts"],
        ["esnext.weakref", "lib.es2021.weakref.d.ts"]
      ];
      ts3.libs = libEntries.map(function(entry) {
        return entry[0];
      });
      ts3.libMap = new ts3.Map(libEntries);
      ts3.optionsForWatch = [
        {
          name: "watchFile",
          type: new ts3.Map(ts3.getEntries({
            fixedpollinginterval: ts3.WatchFileKind.FixedPollingInterval,
            prioritypollinginterval: ts3.WatchFileKind.PriorityPollingInterval,
            dynamicprioritypolling: ts3.WatchFileKind.DynamicPriorityPolling,
            fixedchunksizepolling: ts3.WatchFileKind.FixedChunkSizePolling,
            usefsevents: ts3.WatchFileKind.UseFsEvents,
            usefseventsonparentdirectory: ts3.WatchFileKind.UseFsEventsOnParentDirectory
          })),
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Specify_how_the_TypeScript_watch_mode_works,
          defaultValueDescription: ts3.WatchFileKind.UseFsEvents
        },
        {
          name: "watchDirectory",
          type: new ts3.Map(ts3.getEntries({
            usefsevents: ts3.WatchDirectoryKind.UseFsEvents,
            fixedpollinginterval: ts3.WatchDirectoryKind.FixedPollingInterval,
            dynamicprioritypolling: ts3.WatchDirectoryKind.DynamicPriorityPolling,
            fixedchunksizepolling: ts3.WatchDirectoryKind.FixedChunkSizePolling
          })),
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality,
          defaultValueDescription: ts3.WatchDirectoryKind.UseFsEvents
        },
        {
          name: "fallbackPolling",
          type: new ts3.Map(ts3.getEntries({
            fixedinterval: ts3.PollingWatchKind.FixedInterval,
            priorityinterval: ts3.PollingWatchKind.PriorityInterval,
            dynamicpriority: ts3.PollingWatchKind.DynamicPriority,
            fixedchunksize: ts3.PollingWatchKind.FixedChunkSize
          })),
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers,
          defaultValueDescription: ts3.PollingWatchKind.PriorityInterval
        },
        {
          name: "synchronousWatchDirectory",
          type: "boolean",
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively,
          defaultValueDescription: false
        },
        {
          name: "excludeDirectories",
          type: "list",
          element: {
            name: "excludeDirectory",
            type: "string",
            isFilePath: true,
            extraValidation: specToDiagnostic
          },
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Remove_a_list_of_directories_from_the_watch_process
        },
        {
          name: "excludeFiles",
          type: "list",
          element: {
            name: "excludeFile",
            type: "string",
            isFilePath: true,
            extraValidation: specToDiagnostic
          },
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Remove_a_list_of_files_from_the_watch_mode_s_processing
        }
      ];
      ts3.commonOptionsWithBuild = [
        {
          name: "help",
          shortName: "h",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Print_this_message,
          defaultValueDescription: false
        },
        {
          name: "help",
          shortName: "?",
          type: "boolean",
          defaultValueDescription: false
        },
        {
          name: "watch",
          shortName: "w",
          type: "boolean",
          showInSimplifiedHelpView: true,
          isCommandLineOnly: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Watch_input_files,
          defaultValueDescription: false
        },
        {
          name: "preserveWatchOutput",
          type: "boolean",
          showInSimplifiedHelpView: false,
          category: ts3.Diagnostics.Output_Formatting,
          description: ts3.Diagnostics.Disable_wiping_the_console_in_watch_mode,
          defaultValueDescription: false
        },
        {
          name: "listFiles",
          type: "boolean",
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Print_all_of_the_files_read_during_the_compilation,
          defaultValueDescription: false
        },
        {
          name: "explainFiles",
          type: "boolean",
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Print_files_read_during_the_compilation_including_why_it_was_included,
          defaultValueDescription: false
        },
        {
          name: "listEmittedFiles",
          type: "boolean",
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Print_the_names_of_emitted_files_after_a_compilation,
          defaultValueDescription: false
        },
        {
          name: "pretty",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Output_Formatting,
          description: ts3.Diagnostics.Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read,
          defaultValueDescription: true
        },
        {
          name: "traceResolution",
          type: "boolean",
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Log_paths_used_during_the_moduleResolution_process,
          defaultValueDescription: false
        },
        {
          name: "diagnostics",
          type: "boolean",
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Output_compiler_performance_information_after_building,
          defaultValueDescription: false
        },
        {
          name: "extendedDiagnostics",
          type: "boolean",
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Output_more_detailed_compiler_performance_information_after_building,
          defaultValueDescription: false
        },
        {
          name: "generateCpuProfile",
          type: "string",
          isFilePath: true,
          paramType: ts3.Diagnostics.FILE_OR_DIRECTORY,
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging,
          defaultValueDescription: "profile.cpuprofile"
        },
        {
          name: "generateTrace",
          type: "string",
          isFilePath: true,
          isCommandLineOnly: true,
          paramType: ts3.Diagnostics.DIRECTORY,
          category: ts3.Diagnostics.Compiler_Diagnostics,
          description: ts3.Diagnostics.Generates_an_event_trace_and_a_list_of_types
        },
        {
          name: "incremental",
          shortName: "i",
          type: "boolean",
          category: ts3.Diagnostics.Projects,
          description: ts3.Diagnostics.Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects,
          transpileOptionValue: void 0,
          defaultValueDescription: ts3.Diagnostics.false_unless_composite_is_set
        },
        {
          name: "assumeChangesOnlyAffectDirectDependencies",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts3.Diagnostics.Watch_and_Build_Modes,
          description: ts3.Diagnostics.Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it,
          defaultValueDescription: false
        },
        {
          name: "locale",
          type: "string",
          category: ts3.Diagnostics.Command_line_Options,
          isCommandLineOnly: true,
          description: ts3.Diagnostics.Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit,
          defaultValueDescription: ts3.Diagnostics.Platform_specific
        }
      ];
      ts3.targetOptionDeclaration = {
        name: "target",
        shortName: "t",
        type: new ts3.Map(ts3.getEntries({
          es3: 0,
          es5: 1,
          es6: 2,
          es2015: 2,
          es2016: 3,
          es2017: 4,
          es2018: 5,
          es2019: 6,
          es2020: 7,
          es2021: 8,
          es2022: 9,
          esnext: 99
        })),
        affectsSourceFile: true,
        affectsModuleResolution: true,
        affectsEmit: true,
        paramType: ts3.Diagnostics.VERSION,
        showInSimplifiedHelpView: true,
        category: ts3.Diagnostics.Language_and_Environment,
        description: ts3.Diagnostics.Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations,
        defaultValueDescription: 0
      };
      var commandOptionsWithoutBuild = [
        {
          name: "all",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Show_all_compiler_options,
          defaultValueDescription: false
        },
        {
          name: "version",
          shortName: "v",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Print_the_compiler_s_version,
          defaultValueDescription: false
        },
        {
          name: "init",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file,
          defaultValueDescription: false
        },
        {
          name: "project",
          shortName: "p",
          type: "string",
          isFilePath: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          paramType: ts3.Diagnostics.FILE_OR_DIRECTORY,
          description: ts3.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json
        },
        {
          name: "build",
          type: "boolean",
          shortName: "b",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date,
          defaultValueDescription: false
        },
        {
          name: "showConfig",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          isCommandLineOnly: true,
          description: ts3.Diagnostics.Print_the_final_configuration_instead_of_building,
          defaultValueDescription: false
        },
        {
          name: "listFilesOnly",
          type: "boolean",
          category: ts3.Diagnostics.Command_line_Options,
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          isCommandLineOnly: true,
          description: ts3.Diagnostics.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing,
          defaultValueDescription: false
        },
        ts3.targetOptionDeclaration,
        {
          name: "module",
          shortName: "m",
          type: new ts3.Map(ts3.getEntries({
            none: ts3.ModuleKind.None,
            commonjs: ts3.ModuleKind.CommonJS,
            amd: ts3.ModuleKind.AMD,
            system: ts3.ModuleKind.System,
            umd: ts3.ModuleKind.UMD,
            es6: ts3.ModuleKind.ES2015,
            es2015: ts3.ModuleKind.ES2015,
            es2020: ts3.ModuleKind.ES2020,
            es2022: ts3.ModuleKind.ES2022,
            esnext: ts3.ModuleKind.ESNext,
            node16: ts3.ModuleKind.Node16,
            nodenext: ts3.ModuleKind.NodeNext
          })),
          affectsModuleResolution: true,
          affectsEmit: true,
          paramType: ts3.Diagnostics.KIND,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_what_module_code_is_generated,
          defaultValueDescription: void 0
        },
        {
          name: "lib",
          type: "list",
          element: {
            name: "lib",
            type: ts3.libMap,
            defaultValueDescription: void 0
          },
          affectsProgramStructure: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment,
          transpileOptionValue: void 0
        },
        {
          name: "allowJs",
          type: "boolean",
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.JavaScript_Support,
          description: ts3.Diagnostics.Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files,
          defaultValueDescription: false
        },
        {
          name: "checkJs",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.JavaScript_Support,
          description: ts3.Diagnostics.Enable_error_reporting_in_type_checked_JavaScript_files,
          defaultValueDescription: false
        },
        {
          name: "jsx",
          type: jsxOptionMap,
          affectsSourceFile: true,
          affectsEmit: true,
          affectsModuleResolution: true,
          paramType: ts3.Diagnostics.KIND,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Specify_what_JSX_code_is_generated,
          defaultValueDescription: void 0
        },
        {
          name: "declaration",
          shortName: "d",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          transpileOptionValue: void 0,
          description: ts3.Diagnostics.Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project,
          defaultValueDescription: ts3.Diagnostics.false_unless_composite_is_set
        },
        {
          name: "declarationMap",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          transpileOptionValue: void 0,
          defaultValueDescription: false,
          description: ts3.Diagnostics.Create_sourcemaps_for_d_ts_files
        },
        {
          name: "emitDeclarationOnly",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Only_output_d_ts_files_and_not_JavaScript_files,
          transpileOptionValue: void 0,
          defaultValueDescription: false
        },
        {
          name: "sourceMap",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          defaultValueDescription: false,
          description: ts3.Diagnostics.Create_source_map_files_for_emitted_JavaScript_files
        },
        {
          name: "outFile",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.FILE,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output,
          transpileOptionValue: void 0
        },
        {
          name: "outDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.DIRECTORY,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Specify_an_output_folder_for_all_emitted_files
        },
        {
          name: "rootDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.LOCATION,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_the_root_folder_within_your_source_files,
          defaultValueDescription: ts3.Diagnostics.Computed_from_the_list_of_input_files
        },
        {
          name: "composite",
          type: "boolean",
          affectsEmit: true,
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Projects,
          transpileOptionValue: void 0,
          defaultValueDescription: false,
          description: ts3.Diagnostics.Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references
        },
        {
          name: "tsBuildInfoFile",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.FILE,
          category: ts3.Diagnostics.Projects,
          transpileOptionValue: void 0,
          defaultValueDescription: ".tsbuildinfo",
          description: ts3.Diagnostics.Specify_the_path_to_tsbuildinfo_incremental_compilation_file
        },
        {
          name: "removeComments",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          defaultValueDescription: false,
          description: ts3.Diagnostics.Disable_emitting_comments
        },
        {
          name: "noEmit",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Disable_emitting_files_from_a_compilation,
          transpileOptionValue: void 0,
          defaultValueDescription: false
        },
        {
          name: "importHelpers",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file,
          defaultValueDescription: false
        },
        {
          name: "importsNotUsedAsValues",
          type: new ts3.Map(ts3.getEntries({
            remove: 0,
            preserve: 1,
            error: 2
          })),
          affectsEmit: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types,
          defaultValueDescription: 0
        },
        {
          name: "downlevelIteration",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration,
          defaultValueDescription: false
        },
        {
          name: "isolatedModules",
          type: "boolean",
          category: ts3.Diagnostics.Interop_Constraints,
          description: ts3.Diagnostics.Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports,
          transpileOptionValue: true,
          defaultValueDescription: false
        },
        {
          name: "strict",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enable_all_strict_type_checking_options,
          defaultValueDescription: false
        },
        {
          name: "noImplicitAny",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "strictNullChecks",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.When_type_checking_take_into_account_null_and_undefined,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "strictFunctionTypes",
          type: "boolean",
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "strictBindCallApply",
          type: "boolean",
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "strictPropertyInitialization",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "noImplicitThis",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enable_error_reporting_when_this_is_given_the_type_any,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "useUnknownInCatchVariables",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Default_catch_clause_variables_as_unknown_instead_of_any,
          defaultValueDescription: false
        },
        {
          name: "alwaysStrict",
          type: "boolean",
          affectsSourceFile: true,
          strictFlag: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Ensure_use_strict_is_always_emitted,
          defaultValueDescription: ts3.Diagnostics.false_unless_strict_is_set
        },
        {
          name: "noUnusedLocals",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enable_error_reporting_when_local_variables_aren_t_read,
          defaultValueDescription: false
        },
        {
          name: "noUnusedParameters",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Raise_an_error_when_a_function_parameter_isn_t_read,
          defaultValueDescription: false
        },
        {
          name: "exactOptionalPropertyTypes",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Interpret_optional_property_types_as_written_rather_than_adding_undefined,
          defaultValueDescription: false
        },
        {
          name: "noImplicitReturns",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function,
          defaultValueDescription: false
        },
        {
          name: "noFallthroughCasesInSwitch",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enable_error_reporting_for_fallthrough_cases_in_switch_statements,
          defaultValueDescription: false
        },
        {
          name: "noUncheckedIndexedAccess",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Add_undefined_to_a_type_when_accessed_using_an_index,
          defaultValueDescription: false
        },
        {
          name: "noImplicitOverride",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier,
          defaultValueDescription: false
        },
        {
          name: "noPropertyAccessFromIndexSignature",
          type: "boolean",
          showInSimplifiedHelpView: false,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type,
          defaultValueDescription: false
        },
        {
          name: "moduleResolution",
          type: new ts3.Map(ts3.getEntries({
            node: ts3.ModuleResolutionKind.NodeJs,
            classic: ts3.ModuleResolutionKind.Classic,
            node16: ts3.ModuleResolutionKind.Node16,
            nodenext: ts3.ModuleResolutionKind.NodeNext
          })),
          affectsModuleResolution: true,
          paramType: ts3.Diagnostics.STRATEGY,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier,
          defaultValueDescription: ts3.Diagnostics.module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node
        },
        {
          name: "baseUrl",
          type: "string",
          affectsModuleResolution: true,
          isFilePath: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_the_base_directory_to_resolve_non_relative_module_names
        },
        {
          name: "paths",
          type: "object",
          affectsModuleResolution: true,
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations,
          transpileOptionValue: void 0
        },
        {
          name: "rootDirs",
          type: "list",
          isTSConfigOnly: true,
          element: {
            name: "rootDirs",
            type: "string",
            isFilePath: true
          },
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules,
          transpileOptionValue: void 0,
          defaultValueDescription: ts3.Diagnostics.Computed_from_the_list_of_input_files
        },
        {
          name: "typeRoots",
          type: "list",
          element: {
            name: "typeRoots",
            type: "string",
            isFilePath: true
          },
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types
        },
        {
          name: "types",
          type: "list",
          element: {
            name: "types",
            type: "string"
          },
          affectsProgramStructure: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file,
          transpileOptionValue: void 0
        },
        {
          name: "allowSyntheticDefaultImports",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Interop_Constraints,
          description: ts3.Diagnostics.Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export,
          defaultValueDescription: ts3.Diagnostics.module_system_or_esModuleInterop
        },
        {
          name: "esModuleInterop",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Interop_Constraints,
          description: ts3.Diagnostics.Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility,
          defaultValueDescription: false
        },
        {
          name: "preserveSymlinks",
          type: "boolean",
          category: ts3.Diagnostics.Interop_Constraints,
          description: ts3.Diagnostics.Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node,
          defaultValueDescription: false
        },
        {
          name: "allowUmdGlobalAccess",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Allow_accessing_UMD_globals_from_modules,
          defaultValueDescription: false
        },
        {
          name: "moduleSuffixes",
          type: "list",
          element: {
            name: "suffix",
            type: "string"
          },
          listPreserveFalsyValues: true,
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.List_of_file_name_suffixes_to_search_when_resolving_a_module
        },
        {
          name: "sourceRoot",
          type: "string",
          affectsEmit: true,
          paramType: ts3.Diagnostics.LOCATION,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Specify_the_root_path_for_debuggers_to_find_the_reference_source_code
        },
        {
          name: "mapRoot",
          type: "string",
          affectsEmit: true,
          paramType: ts3.Diagnostics.LOCATION,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations
        },
        {
          name: "inlineSourceMap",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Include_sourcemap_files_inside_the_emitted_JavaScript,
          defaultValueDescription: false
        },
        {
          name: "inlineSources",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript,
          defaultValueDescription: false
        },
        {
          name: "experimentalDecorators",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Enable_experimental_support_for_TC39_stage_2_draft_decorators,
          defaultValueDescription: false
        },
        {
          name: "emitDecoratorMetadata",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Emit_design_type_metadata_for_decorated_declarations_in_source_files,
          defaultValueDescription: false
        },
        {
          name: "jsxFactory",
          type: "string",
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h,
          defaultValueDescription: "`React.createElement`"
        },
        {
          name: "jsxFragmentFactory",
          type: "string",
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment,
          defaultValueDescription: "React.Fragment"
        },
        {
          name: "jsxImportSource",
          type: "string",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk,
          defaultValueDescription: "react"
        },
        {
          name: "resolveJsonModule",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Enable_importing_json_files,
          defaultValueDescription: false
        },
        {
          name: "out",
          type: "string",
          affectsEmit: true,
          isFilePath: false,
          category: ts3.Diagnostics.Backwards_Compatibility,
          paramType: ts3.Diagnostics.FILE,
          transpileOptionValue: void 0,
          description: ts3.Diagnostics.Deprecated_setting_Use_outFile_instead
        },
        {
          name: "reactNamespace",
          type: "string",
          affectsEmit: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit,
          defaultValueDescription: "`React`"
        },
        {
          name: "skipDefaultLibCheck",
          type: "boolean",
          category: ts3.Diagnostics.Completeness,
          description: ts3.Diagnostics.Skip_type_checking_d_ts_files_that_are_included_with_TypeScript,
          defaultValueDescription: false
        },
        {
          name: "charset",
          type: "string",
          category: ts3.Diagnostics.Backwards_Compatibility,
          description: ts3.Diagnostics.No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files,
          defaultValueDescription: "utf8"
        },
        {
          name: "emitBOM",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files,
          defaultValueDescription: false
        },
        {
          name: "newLine",
          type: new ts3.Map(ts3.getEntries({
            crlf: 0,
            lf: 1
          })),
          affectsEmit: true,
          paramType: ts3.Diagnostics.NEWLINE,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Set_the_newline_character_for_emitting_files,
          defaultValueDescription: ts3.Diagnostics.Platform_specific
        },
        {
          name: "noErrorTruncation",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Output_Formatting,
          description: ts3.Diagnostics.Disable_truncating_types_in_error_messages,
          defaultValueDescription: false
        },
        {
          name: "noLib",
          type: "boolean",
          category: ts3.Diagnostics.Language_and_Environment,
          affectsProgramStructure: true,
          description: ts3.Diagnostics.Disable_including_any_library_files_including_the_default_lib_d_ts,
          transpileOptionValue: true,
          defaultValueDescription: false
        },
        {
          name: "noResolve",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Modules,
          description: ts3.Diagnostics.Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project,
          transpileOptionValue: true,
          defaultValueDescription: false
        },
        {
          name: "stripInternal",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments,
          defaultValueDescription: false
        },
        {
          name: "disableSizeLimit",
          type: "boolean",
          affectsProgramStructure: true,
          category: ts3.Diagnostics.Editor_Support,
          description: ts3.Diagnostics.Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server,
          defaultValueDescription: false
        },
        {
          name: "disableSourceOfProjectReferenceRedirect",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Projects,
          description: ts3.Diagnostics.Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects,
          defaultValueDescription: false
        },
        {
          name: "disableSolutionSearching",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Projects,
          description: ts3.Diagnostics.Opt_a_project_out_of_multi_project_reference_checking_when_editing,
          defaultValueDescription: false
        },
        {
          name: "disableReferencedProjectLoad",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Projects,
          description: ts3.Diagnostics.Reduce_the_number_of_projects_loaded_automatically_by_TypeScript,
          defaultValueDescription: false
        },
        {
          name: "noImplicitUseStrict",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Backwards_Compatibility,
          description: ts3.Diagnostics.Disable_adding_use_strict_directives_in_emitted_JavaScript_files,
          defaultValueDescription: false
        },
        {
          name: "noEmitHelpers",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Disable_generating_custom_helper_functions_like_extends_in_compiled_output,
          defaultValueDescription: false
        },
        {
          name: "noEmitOnError",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          transpileOptionValue: void 0,
          description: ts3.Diagnostics.Disable_emitting_files_if_any_type_checking_errors_are_reported,
          defaultValueDescription: false
        },
        {
          name: "preserveConstEnums",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Disable_erasing_const_enum_declarations_in_generated_code,
          defaultValueDescription: false
        },
        {
          name: "declarationDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.DIRECTORY,
          category: ts3.Diagnostics.Emit,
          transpileOptionValue: void 0,
          description: ts3.Diagnostics.Specify_the_output_directory_for_generated_declaration_files
        },
        {
          name: "skipLibCheck",
          type: "boolean",
          category: ts3.Diagnostics.Completeness,
          description: ts3.Diagnostics.Skip_type_checking_all_d_ts_files,
          defaultValueDescription: false
        },
        {
          name: "allowUnusedLabels",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Disable_error_reporting_for_unused_labels,
          defaultValueDescription: void 0
        },
        {
          name: "allowUnreachableCode",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Type_Checking,
          description: ts3.Diagnostics.Disable_error_reporting_for_unreachable_code,
          defaultValueDescription: void 0
        },
        {
          name: "suppressExcessPropertyErrors",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Backwards_Compatibility,
          description: ts3.Diagnostics.Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals,
          defaultValueDescription: false
        },
        {
          name: "suppressImplicitAnyIndexErrors",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Backwards_Compatibility,
          description: ts3.Diagnostics.Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures,
          defaultValueDescription: false
        },
        {
          name: "forceConsistentCasingInFileNames",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Interop_Constraints,
          description: ts3.Diagnostics.Ensure_that_casing_is_correct_in_imports,
          defaultValueDescription: false
        },
        {
          name: "maxNodeModuleJsDepth",
          type: "number",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.JavaScript_Support,
          description: ts3.Diagnostics.Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs,
          defaultValueDescription: 0
        },
        {
          name: "noStrictGenericChecks",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Backwards_Compatibility,
          description: ts3.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types,
          defaultValueDescription: false
        },
        {
          name: "useDefineForClassFields",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts3.Diagnostics.Language_and_Environment,
          description: ts3.Diagnostics.Emit_ECMAScript_standard_compliant_class_fields,
          defaultValueDescription: ts3.Diagnostics.true_for_ES2022_and_above_including_ESNext
        },
        {
          name: "preserveValueImports",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Emit,
          description: ts3.Diagnostics.Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed,
          defaultValueDescription: false
        },
        {
          name: "keyofStringsOnly",
          type: "boolean",
          category: ts3.Diagnostics.Backwards_Compatibility,
          description: ts3.Diagnostics.Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option,
          defaultValueDescription: false
        },
        {
          name: "plugins",
          type: "list",
          isTSConfigOnly: true,
          element: {
            name: "plugin",
            type: "object"
          },
          description: ts3.Diagnostics.Specify_a_list_of_language_service_plugins_to_include,
          category: ts3.Diagnostics.Editor_Support
        },
        {
          name: "moduleDetection",
          type: new ts3.Map(ts3.getEntries({
            auto: ts3.ModuleDetectionKind.Auto,
            legacy: ts3.ModuleDetectionKind.Legacy,
            force: ts3.ModuleDetectionKind.Force
          })),
          affectsModuleResolution: true,
          description: ts3.Diagnostics.Control_what_method_is_used_to_detect_module_format_JS_files,
          category: ts3.Diagnostics.Language_and_Environment,
          defaultValueDescription: ts3.Diagnostics.auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules
        }
      ];
      ts3.optionDeclarations = __spreadArray(__spreadArray([], ts3.commonOptionsWithBuild, true), commandOptionsWithoutBuild, true);
      ts3.semanticDiagnosticsOptionDeclarations = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsSemanticDiagnostics;
      });
      ts3.affectsEmitOptionDeclarations = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsEmit;
      });
      ts3.moduleResolutionOptionDeclarations = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsModuleResolution;
      });
      ts3.sourceFileAffectingCompilerOptions = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsSourceFile || !!option.affectsModuleResolution || !!option.affectsBindDiagnostics;
      });
      ts3.optionsAffectingProgramStructure = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsProgramStructure;
      });
      ts3.transpileOptionValueCompilerOptions = ts3.optionDeclarations.filter(function(option) {
        return ts3.hasProperty(option, "transpileOptionValue");
      });
      ts3.optionsForBuild = [
        {
          name: "verbose",
          shortName: "v",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Enable_verbose_logging,
          type: "boolean",
          defaultValueDescription: false
        },
        {
          name: "dry",
          shortName: "d",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean,
          type: "boolean",
          defaultValueDescription: false
        },
        {
          name: "force",
          shortName: "f",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date,
          type: "boolean",
          defaultValueDescription: false
        },
        {
          name: "clean",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Delete_the_outputs_of_all_projects,
          type: "boolean",
          defaultValueDescription: false
        }
      ];
      ts3.buildOpts = __spreadArray(__spreadArray([], ts3.commonOptionsWithBuild, true), ts3.optionsForBuild, true);
      ts3.typeAcquisitionDeclarations = [
        {
          name: "enableAutoDiscovery",
          type: "boolean",
          defaultValueDescription: false
        },
        {
          name: "enable",
          type: "boolean",
          defaultValueDescription: false
        },
        {
          name: "include",
          type: "list",
          element: {
            name: "include",
            type: "string"
          }
        },
        {
          name: "exclude",
          type: "list",
          element: {
            name: "exclude",
            type: "string"
          }
        },
        {
          name: "disableFilenameBasedTypeAcquisition",
          type: "boolean",
          defaultValueDescription: false
        }
      ];
      function createOptionNameMap(optionDeclarations) {
        var optionsNameMap = new ts3.Map();
        var shortOptionNames = new ts3.Map();
        ts3.forEach(optionDeclarations, function(option) {
          optionsNameMap.set(option.name.toLowerCase(), option);
          if (option.shortName) {
            shortOptionNames.set(option.shortName, option.name);
          }
        });
        return { optionsNameMap, shortOptionNames };
      }
      ts3.createOptionNameMap = createOptionNameMap;
      var optionsNameMapCache;
      function getOptionsNameMap() {
        return optionsNameMapCache || (optionsNameMapCache = createOptionNameMap(ts3.optionDeclarations));
      }
      ts3.getOptionsNameMap = getOptionsNameMap;
      var compilerOptionsAlternateMode = {
        diagnostic: ts3.Diagnostics.Compiler_option_0_may_only_be_used_with_build,
        getOptionsNameMap: getBuildOptionsNameMap
      };
      ts3.defaultInitCompilerOptions = {
        module: ts3.ModuleKind.CommonJS,
        target: 3,
        strict: true,
        esModuleInterop: true,
        forceConsistentCasingInFileNames: true,
        skipLibCheck: true
      };
      function convertEnableAutoDiscoveryToEnable(typeAcquisition) {
        if (typeAcquisition && typeAcquisition.enableAutoDiscovery !== void 0 && typeAcquisition.enable === void 0) {
          return {
            enable: typeAcquisition.enableAutoDiscovery,
            include: typeAcquisition.include || [],
            exclude: typeAcquisition.exclude || []
          };
        }
        return typeAcquisition;
      }
      ts3.convertEnableAutoDiscoveryToEnable = convertEnableAutoDiscoveryToEnable;
      function createCompilerDiagnosticForInvalidCustomType(opt) {
        return createDiagnosticForInvalidCustomType(opt, ts3.createCompilerDiagnostic);
      }
      ts3.createCompilerDiagnosticForInvalidCustomType = createCompilerDiagnosticForInvalidCustomType;
      function createDiagnosticForInvalidCustomType(opt, createDiagnostic) {
        var namesOfType = ts3.arrayFrom(opt.type.keys()).map(function(key) {
          return "'".concat(key, "'");
        }).join(", ");
        return createDiagnostic(ts3.Diagnostics.Argument_for_0_option_must_be_Colon_1, "--".concat(opt.name), namesOfType);
      }
      function parseCustomTypeOption(opt, value, errors) {
        return convertJsonOptionOfCustomType(opt, ts3.trimString(value || ""), errors);
      }
      ts3.parseCustomTypeOption = parseCustomTypeOption;
      function parseListTypeOption(opt, value, errors) {
        if (value === void 0) {
          value = "";
        }
        value = ts3.trimString(value);
        if (ts3.startsWith(value, "-")) {
          return void 0;
        }
        if (value === "") {
          return [];
        }
        var values = value.split(",");
        switch (opt.element.type) {
          case "number":
            return ts3.mapDefined(values, function(v) {
              return validateJsonOptionValue(opt.element, parseInt(v), errors);
            });
          case "string":
            return ts3.mapDefined(values, function(v) {
              return validateJsonOptionValue(opt.element, v || "", errors);
            });
          default:
            return ts3.mapDefined(values, function(v) {
              return parseCustomTypeOption(opt.element, v, errors);
            });
        }
      }
      ts3.parseListTypeOption = parseListTypeOption;
      function getOptionName(option) {
        return option.name;
      }
      function createUnknownOptionError(unknownOption, diagnostics, createDiagnostics, unknownOptionErrorText) {
        var _a;
        if ((_a = diagnostics.alternateMode) === null || _a === void 0 ? void 0 : _a.getOptionsNameMap().optionsNameMap.has(unknownOption.toLowerCase())) {
          return createDiagnostics(diagnostics.alternateMode.diagnostic, unknownOption);
        }
        var possibleOption = ts3.getSpellingSuggestion(unknownOption, diagnostics.optionDeclarations, getOptionName);
        return possibleOption ? createDiagnostics(diagnostics.unknownDidYouMeanDiagnostic, unknownOptionErrorText || unknownOption, possibleOption.name) : createDiagnostics(diagnostics.unknownOptionDiagnostic, unknownOptionErrorText || unknownOption);
      }
      function parseCommandLineWorker(diagnostics, commandLine, readFile) {
        var options = {};
        var watchOptions;
        var fileNames = [];
        var errors = [];
        parseStrings(commandLine);
        return {
          options,
          watchOptions,
          fileNames,
          errors
        };
        function parseStrings(args) {
          var i = 0;
          while (i < args.length) {
            var s = args[i];
            i++;
            if (s.charCodeAt(0) === 64) {
              parseResponseFile(s.slice(1));
            } else if (s.charCodeAt(0) === 45) {
              var inputOptionName = s.slice(s.charCodeAt(1) === 45 ? 2 : 1);
              var opt = getOptionDeclarationFromName(diagnostics.getOptionsNameMap, inputOptionName, true);
              if (opt) {
                i = parseOptionValue(args, i, diagnostics, opt, options, errors);
              } else {
                var watchOpt = getOptionDeclarationFromName(watchOptionsDidYouMeanDiagnostics.getOptionsNameMap, inputOptionName, true);
                if (watchOpt) {
                  i = parseOptionValue(args, i, watchOptionsDidYouMeanDiagnostics, watchOpt, watchOptions || (watchOptions = {}), errors);
                } else {
                  errors.push(createUnknownOptionError(inputOptionName, diagnostics, ts3.createCompilerDiagnostic, s));
                }
              }
            } else {
              fileNames.push(s);
            }
          }
        }
        function parseResponseFile(fileName2) {
          var text = tryReadFile(fileName2, readFile || function(fileName3) {
            return ts3.sys.readFile(fileName3);
          });
          if (!ts3.isString(text)) {
            errors.push(text);
            return;
          }
          var args = [];
          var pos = 0;
          while (true) {
            while (pos < text.length && text.charCodeAt(pos) <= 32)
              pos++;
            if (pos >= text.length)
              break;
            var start = pos;
            if (text.charCodeAt(start) === 34) {
              pos++;
              while (pos < text.length && text.charCodeAt(pos) !== 34)
                pos++;
              if (pos < text.length) {
                args.push(text.substring(start + 1, pos));
                pos++;
              } else {
                errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Unterminated_quoted_string_in_response_file_0, fileName2));
              }
            } else {
              while (text.charCodeAt(pos) > 32)
                pos++;
              args.push(text.substring(start, pos));
            }
          }
          parseStrings(args);
        }
      }
      ts3.parseCommandLineWorker = parseCommandLineWorker;
      function parseOptionValue(args, i, diagnostics, opt, options, errors) {
        if (opt.isTSConfigOnly) {
          var optValue = args[i];
          if (optValue === "null") {
            options[opt.name] = void 0;
            i++;
          } else if (opt.type === "boolean") {
            if (optValue === "false") {
              options[opt.name] = validateJsonOptionValue(opt, false, errors);
              i++;
            } else {
              if (optValue === "true")
                i++;
              errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line, opt.name));
            }
          } else {
            errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line, opt.name));
            if (optValue && !ts3.startsWith(optValue, "-"))
              i++;
          }
        } else {
          if (!args[i] && opt.type !== "boolean") {
            errors.push(ts3.createCompilerDiagnostic(diagnostics.optionTypeMismatchDiagnostic, opt.name, getCompilerOptionValueTypeString(opt)));
          }
          if (args[i] !== "null") {
            switch (opt.type) {
              case "number":
                options[opt.name] = validateJsonOptionValue(opt, parseInt(args[i]), errors);
                i++;
                break;
              case "boolean":
                var optValue = args[i];
                options[opt.name] = validateJsonOptionValue(opt, optValue !== "false", errors);
                if (optValue === "false" || optValue === "true") {
                  i++;
                }
                break;
              case "string":
                options[opt.name] = validateJsonOptionValue(opt, args[i] || "", errors);
                i++;
                break;
              case "list":
                var result2 = parseListTypeOption(opt, args[i], errors);
                options[opt.name] = result2 || [];
                if (result2) {
                  i++;
                }
                break;
              default:
                options[opt.name] = parseCustomTypeOption(opt, args[i], errors);
                i++;
                break;
            }
          } else {
            options[opt.name] = void 0;
            i++;
          }
        }
        return i;
      }
      ts3.compilerOptionsDidYouMeanDiagnostics = {
        alternateMode: compilerOptionsAlternateMode,
        getOptionsNameMap,
        optionDeclarations: ts3.optionDeclarations,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_compiler_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_compiler_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts3.Diagnostics.Compiler_option_0_expects_an_argument
      };
      function parseCommandLine(commandLine, readFile) {
        return parseCommandLineWorker(ts3.compilerOptionsDidYouMeanDiagnostics, commandLine, readFile);
      }
      ts3.parseCommandLine = parseCommandLine;
      function getOptionFromName(optionName, allowShort) {
        return getOptionDeclarationFromName(getOptionsNameMap, optionName, allowShort);
      }
      ts3.getOptionFromName = getOptionFromName;
      function getOptionDeclarationFromName(getOptionNameMap, optionName, allowShort) {
        if (allowShort === void 0) {
          allowShort = false;
        }
        optionName = optionName.toLowerCase();
        var _a = getOptionNameMap(), optionsNameMap = _a.optionsNameMap, shortOptionNames = _a.shortOptionNames;
        if (allowShort) {
          var short = shortOptionNames.get(optionName);
          if (short !== void 0) {
            optionName = short;
          }
        }
        return optionsNameMap.get(optionName);
      }
      var buildOptionsNameMapCache;
      function getBuildOptionsNameMap() {
        return buildOptionsNameMapCache || (buildOptionsNameMapCache = createOptionNameMap(ts3.buildOpts));
      }
      var buildOptionsAlternateMode = {
        diagnostic: ts3.Diagnostics.Compiler_option_0_may_not_be_used_with_build,
        getOptionsNameMap
      };
      var buildOptionsDidYouMeanDiagnostics = {
        alternateMode: buildOptionsAlternateMode,
        getOptionsNameMap: getBuildOptionsNameMap,
        optionDeclarations: ts3.buildOpts,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_build_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_build_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts3.Diagnostics.Build_option_0_requires_a_value_of_type_1
      };
      function parseBuildCommand(args) {
        var _a = parseCommandLineWorker(buildOptionsDidYouMeanDiagnostics, args), options = _a.options, watchOptions = _a.watchOptions, projects = _a.fileNames, errors = _a.errors;
        var buildOptions = options;
        if (projects.length === 0) {
          projects.push(".");
        }
        if (buildOptions.clean && buildOptions.force) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "force"));
        }
        if (buildOptions.clean && buildOptions.verbose) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "verbose"));
        }
        if (buildOptions.clean && buildOptions.watch) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "watch"));
        }
        if (buildOptions.watch && buildOptions.dry) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "watch", "dry"));
        }
        return { buildOptions, watchOptions, projects, errors };
      }
      ts3.parseBuildCommand = parseBuildCommand;
      function getDiagnosticText(_message) {
        var _args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          _args[_i - 1] = arguments[_i];
        }
        var diagnostic = ts3.createCompilerDiagnostic.apply(void 0, arguments);
        return diagnostic.messageText;
      }
      ts3.getDiagnosticText = getDiagnosticText;
      function getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend, extraFileExtensions) {
        var configFileText = tryReadFile(configFileName, function(fileName2) {
          return host.readFile(fileName2);
        });
        if (!ts3.isString(configFileText)) {
          host.onUnRecoverableConfigFileDiagnostic(configFileText);
          return void 0;
        }
        var result2 = ts3.parseJsonText(configFileName, configFileText);
        var cwd = host.getCurrentDirectory();
        result2.path = ts3.toPath(configFileName, cwd, ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames));
        result2.resolvedPath = result2.path;
        result2.originalFileName = result2.fileName;
        return parseJsonSourceFileConfigFileContent(result2, host, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), cwd), optionsToExtend, ts3.getNormalizedAbsolutePath(configFileName, cwd), void 0, extraFileExtensions, extendedConfigCache, watchOptionsToExtend);
      }
      ts3.getParsedCommandLineOfConfigFile = getParsedCommandLineOfConfigFile;
      function readConfigFile(fileName2, readFile) {
        var textOrDiagnostic = tryReadFile(fileName2, readFile);
        return ts3.isString(textOrDiagnostic) ? parseConfigFileTextToJson(fileName2, textOrDiagnostic) : { config: {}, error: textOrDiagnostic };
      }
      ts3.readConfigFile = readConfigFile;
      function parseConfigFileTextToJson(fileName2, jsonText) {
        var jsonSourceFile = ts3.parseJsonText(fileName2, jsonText);
        return {
          config: convertConfigFileToObject(jsonSourceFile, jsonSourceFile.parseDiagnostics, false, void 0),
          error: jsonSourceFile.parseDiagnostics.length ? jsonSourceFile.parseDiagnostics[0] : void 0
        };
      }
      ts3.parseConfigFileTextToJson = parseConfigFileTextToJson;
      function readJsonConfigFile(fileName2, readFile) {
        var textOrDiagnostic = tryReadFile(fileName2, readFile);
        return ts3.isString(textOrDiagnostic) ? ts3.parseJsonText(fileName2, textOrDiagnostic) : { fileName: fileName2, parseDiagnostics: [textOrDiagnostic] };
      }
      ts3.readJsonConfigFile = readJsonConfigFile;
      function tryReadFile(fileName2, readFile) {
        var text;
        try {
          text = readFile(fileName2);
        } catch (e) {
          return ts3.createCompilerDiagnostic(ts3.Diagnostics.Cannot_read_file_0_Colon_1, fileName2, e.message);
        }
        return text === void 0 ? ts3.createCompilerDiagnostic(ts3.Diagnostics.Cannot_read_file_0, fileName2) : text;
      }
      ts3.tryReadFile = tryReadFile;
      function commandLineOptionsToMap(options) {
        return ts3.arrayToMap(options, getOptionName);
      }
      var typeAcquisitionDidYouMeanDiagnostics = {
        optionDeclarations: ts3.typeAcquisitionDeclarations,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_type_acquisition_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_type_acquisition_option_0_Did_you_mean_1
      };
      var watchOptionsNameMapCache;
      function getWatchOptionsNameMap() {
        return watchOptionsNameMapCache || (watchOptionsNameMapCache = createOptionNameMap(ts3.optionsForWatch));
      }
      var watchOptionsDidYouMeanDiagnostics = {
        getOptionsNameMap: getWatchOptionsNameMap,
        optionDeclarations: ts3.optionsForWatch,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_watch_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_watch_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts3.Diagnostics.Watch_option_0_requires_a_value_of_type_1
      };
      var commandLineCompilerOptionsMapCache;
      function getCommandLineCompilerOptionsMap() {
        return commandLineCompilerOptionsMapCache || (commandLineCompilerOptionsMapCache = commandLineOptionsToMap(ts3.optionDeclarations));
      }
      var commandLineWatchOptionsMapCache;
      function getCommandLineWatchOptionsMap() {
        return commandLineWatchOptionsMapCache || (commandLineWatchOptionsMapCache = commandLineOptionsToMap(ts3.optionsForWatch));
      }
      var commandLineTypeAcquisitionMapCache;
      function getCommandLineTypeAcquisitionMap() {
        return commandLineTypeAcquisitionMapCache || (commandLineTypeAcquisitionMapCache = commandLineOptionsToMap(ts3.typeAcquisitionDeclarations));
      }
      var _tsconfigRootOptions;
      function getTsconfigRootOptionsMap() {
        if (_tsconfigRootOptions === void 0) {
          _tsconfigRootOptions = {
            name: void 0,
            type: "object",
            elementOptions: commandLineOptionsToMap([
              {
                name: "compilerOptions",
                type: "object",
                elementOptions: getCommandLineCompilerOptionsMap(),
                extraKeyDiagnostics: ts3.compilerOptionsDidYouMeanDiagnostics
              },
              {
                name: "watchOptions",
                type: "object",
                elementOptions: getCommandLineWatchOptionsMap(),
                extraKeyDiagnostics: watchOptionsDidYouMeanDiagnostics
              },
              {
                name: "typingOptions",
                type: "object",
                elementOptions: getCommandLineTypeAcquisitionMap(),
                extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
              },
              {
                name: "typeAcquisition",
                type: "object",
                elementOptions: getCommandLineTypeAcquisitionMap(),
                extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
              },
              {
                name: "extends",
                type: "string",
                category: ts3.Diagnostics.File_Management
              },
              {
                name: "references",
                type: "list",
                element: {
                  name: "references",
                  type: "object"
                },
                category: ts3.Diagnostics.Projects
              },
              {
                name: "files",
                type: "list",
                element: {
                  name: "files",
                  type: "string"
                },
                category: ts3.Diagnostics.File_Management
              },
              {
                name: "include",
                type: "list",
                element: {
                  name: "include",
                  type: "string"
                },
                category: ts3.Diagnostics.File_Management,
                defaultValueDescription: ts3.Diagnostics.if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk
              },
              {
                name: "exclude",
                type: "list",
                element: {
                  name: "exclude",
                  type: "string"
                },
                category: ts3.Diagnostics.File_Management,
                defaultValueDescription: ts3.Diagnostics.node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified
              },
              ts3.compileOnSaveCommandLineOption
            ])
          };
        }
        return _tsconfigRootOptions;
      }
      function convertConfigFileToObject(sourceFile, errors, reportOptionsErrors, optionsIterator) {
        var _a;
        var rootExpression = (_a = sourceFile.statements[0]) === null || _a === void 0 ? void 0 : _a.expression;
        var knownRootOptions = reportOptionsErrors ? getTsconfigRootOptionsMap() : void 0;
        if (rootExpression && rootExpression.kind !== 205) {
          errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, rootExpression, ts3.Diagnostics.The_root_value_of_a_0_file_must_be_an_object, ts3.getBaseFileName(sourceFile.fileName) === "jsconfig.json" ? "jsconfig.json" : "tsconfig.json"));
          if (ts3.isArrayLiteralExpression(rootExpression)) {
            var firstObject = ts3.find(rootExpression.elements, ts3.isObjectLiteralExpression);
            if (firstObject) {
              return convertToObjectWorker(sourceFile, firstObject, errors, true, knownRootOptions, optionsIterator);
            }
          }
          return {};
        }
        return convertToObjectWorker(sourceFile, rootExpression, errors, true, knownRootOptions, optionsIterator);
      }
      function convertToObject(sourceFile, errors) {
        var _a;
        return convertToObjectWorker(sourceFile, (_a = sourceFile.statements[0]) === null || _a === void 0 ? void 0 : _a.expression, errors, true, void 0, void 0);
      }
      ts3.convertToObject = convertToObject;
      function convertToObjectWorker(sourceFile, rootExpression, errors, returnValue, knownRootOptions, jsonConversionNotifier) {
        if (!rootExpression) {
          return returnValue ? {} : void 0;
        }
        return convertPropertyValueToJson(rootExpression, knownRootOptions);
        function isRootOptionMap(knownOptions) {
          return knownRootOptions && knownRootOptions.elementOptions === knownOptions;
        }
        function convertObjectLiteralExpressionToJson(node, knownOptions, extraKeyDiagnostics, parentOption) {
          var result2 = returnValue ? {} : void 0;
          var _loop_4 = function(element2) {
            if (element2.kind !== 296) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2, ts3.Diagnostics.Property_assignment_expected));
              return "continue";
            }
            if (element2.questionToken) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.questionToken, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
            }
            if (!isDoubleQuotedString(element2.name)) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, ts3.Diagnostics.String_literal_with_double_quotes_expected));
            }
            var textOfKey = ts3.isComputedNonLiteralName(element2.name) ? void 0 : ts3.getTextOfPropertyName(element2.name);
            var keyText = textOfKey && ts3.unescapeLeadingUnderscores(textOfKey);
            var option = keyText && knownOptions ? knownOptions.get(keyText) : void 0;
            if (keyText && extraKeyDiagnostics && !option) {
              if (knownOptions) {
                errors.push(createUnknownOptionError(keyText, extraKeyDiagnostics, function(message, arg0, arg1) {
                  return ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, message, arg0, arg1);
                }));
              } else {
                errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, extraKeyDiagnostics.unknownOptionDiagnostic, keyText));
              }
            }
            var value = convertPropertyValueToJson(element2.initializer, option);
            if (typeof keyText !== "undefined") {
              if (returnValue) {
                result2[keyText] = value;
              }
              if (jsonConversionNotifier && (parentOption || isRootOptionMap(knownOptions))) {
                var isValidOptionValue = isCompilerOptionsValue(option, value);
                if (parentOption) {
                  if (isValidOptionValue) {
                    jsonConversionNotifier.onSetValidOptionKeyValueInParent(parentOption, option, value);
                  }
                } else if (isRootOptionMap(knownOptions)) {
                  if (isValidOptionValue) {
                    jsonConversionNotifier.onSetValidOptionKeyValueInRoot(keyText, element2.name, value, element2.initializer);
                  } else if (!option) {
                    jsonConversionNotifier.onSetUnknownOptionKeyValueInRoot(keyText, element2.name, value, element2.initializer);
                  }
                }
              }
            }
          };
          for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
            var element = _a[_i];
            _loop_4(element);
          }
          return result2;
        }
        function convertArrayLiteralExpressionToJson(elements, elementOption) {
          if (!returnValue) {
            elements.forEach(function(element) {
              return convertPropertyValueToJson(element, elementOption);
            });
            return void 0;
          }
          return ts3.filter(elements.map(function(element) {
            return convertPropertyValueToJson(element, elementOption);
          }), function(v) {
            return v !== void 0;
          });
        }
        function convertPropertyValueToJson(valueExpression, option) {
          var invalidReported;
          switch (valueExpression.kind) {
            case 110:
              reportInvalidOptionValue(option && option.type !== "boolean");
              return validateValue(true);
            case 95:
              reportInvalidOptionValue(option && option.type !== "boolean");
              return validateValue(false);
            case 104:
              reportInvalidOptionValue(option && option.name === "extends");
              return validateValue(null);
            case 10:
              if (!isDoubleQuotedString(valueExpression)) {
                errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts3.Diagnostics.String_literal_with_double_quotes_expected));
              }
              reportInvalidOptionValue(option && (ts3.isString(option.type) && option.type !== "string"));
              var text = valueExpression.text;
              if (option && !ts3.isString(option.type)) {
                var customOption = option;
                if (!customOption.type.has(text.toLowerCase())) {
                  errors.push(createDiagnosticForInvalidCustomType(customOption, function(message, arg0, arg1) {
                    return ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, message, arg0, arg1);
                  }));
                  invalidReported = true;
                }
              }
              return validateValue(text);
            case 8:
              reportInvalidOptionValue(option && option.type !== "number");
              return validateValue(Number(valueExpression.text));
            case 219:
              if (valueExpression.operator !== 40 || valueExpression.operand.kind !== 8) {
                break;
              }
              reportInvalidOptionValue(option && option.type !== "number");
              return validateValue(-Number(valueExpression.operand.text));
            case 205:
              reportInvalidOptionValue(option && option.type !== "object");
              var objectLiteralExpression = valueExpression;
              if (option) {
                var _a = option, elementOptions = _a.elementOptions, extraKeyDiagnostics = _a.extraKeyDiagnostics, optionName = _a.name;
                return validateValue(convertObjectLiteralExpressionToJson(objectLiteralExpression, elementOptions, extraKeyDiagnostics, optionName));
              } else {
                return validateValue(convertObjectLiteralExpressionToJson(objectLiteralExpression, void 0, void 0, void 0));
              }
            case 204:
              reportInvalidOptionValue(option && option.type !== "list");
              return validateValue(convertArrayLiteralExpressionToJson(valueExpression.elements, option && option.element));
          }
          if (option) {
            reportInvalidOptionValue(true);
          } else {
            errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts3.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal));
          }
          return void 0;
          function validateValue(value) {
            var _a2;
            if (!invalidReported) {
              var diagnostic = (_a2 = option === null || option === void 0 ? void 0 : option.extraValidation) === null || _a2 === void 0 ? void 0 : _a2.call(option, value);
              if (diagnostic) {
                errors.push(ts3.createDiagnosticForNodeInSourceFile.apply(void 0, __spreadArray([sourceFile, valueExpression], diagnostic, false)));
                return void 0;
              }
            }
            return value;
          }
          function reportInvalidOptionValue(isError) {
            if (isError) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, option.name, getCompilerOptionValueTypeString(option)));
              invalidReported = true;
            }
          }
        }
        function isDoubleQuotedString(node) {
          return ts3.isStringLiteral(node) && ts3.isStringDoubleQuoted(node, sourceFile);
        }
      }
      ts3.convertToObjectWorker = convertToObjectWorker;
      function getCompilerOptionValueTypeString(option) {
        return option.type === "list" ? "Array" : ts3.isString(option.type) ? option.type : "string";
      }
      function isCompilerOptionsValue(option, value) {
        if (option) {
          if (isNullOrUndefined(value))
            return true;
          if (option.type === "list") {
            return ts3.isArray(value);
          }
          var expectedType = ts3.isString(option.type) ? option.type : "string";
          return typeof value === expectedType;
        }
        return false;
      }
      function convertToTSConfig(configParseResult, configFileName, host) {
        var _a, _b, _c;
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        var files = ts3.map(ts3.filter(configParseResult.fileNames, !((_b = (_a = configParseResult.options.configFile) === null || _a === void 0 ? void 0 : _a.configFileSpecs) === null || _b === void 0 ? void 0 : _b.validatedIncludeSpecs) ? ts3.returnTrue : matchesSpecs(configFileName, configParseResult.options.configFile.configFileSpecs.validatedIncludeSpecs, configParseResult.options.configFile.configFileSpecs.validatedExcludeSpecs, host)), function(f) {
          return ts3.getRelativePathFromFile(ts3.getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), ts3.getNormalizedAbsolutePath(f, host.getCurrentDirectory()), getCanonicalFileName);
        });
        var optionMap = serializeCompilerOptions(configParseResult.options, { configFilePath: ts3.getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), useCaseSensitiveFileNames: host.useCaseSensitiveFileNames });
        var watchOptionMap = configParseResult.watchOptions && serializeWatchOptions(configParseResult.watchOptions);
        var config = __assign(__assign({ compilerOptions: __assign(__assign({}, optionMapToObject(optionMap)), { showConfig: void 0, configFile: void 0, configFilePath: void 0, help: void 0, init: void 0, listFiles: void 0, listEmittedFiles: void 0, project: void 0, build: void 0, version: void 0 }), watchOptions: watchOptionMap && optionMapToObject(watchOptionMap), references: ts3.map(configParseResult.projectReferences, function(r) {
          return __assign(__assign({}, r), { path: r.originalPath ? r.originalPath : "", originalPath: void 0 });
        }), files: ts3.length(files) ? files : void 0 }, ((_c = configParseResult.options.configFile) === null || _c === void 0 ? void 0 : _c.configFileSpecs) ? {
          include: filterSameAsDefaultInclude(configParseResult.options.configFile.configFileSpecs.validatedIncludeSpecs),
          exclude: configParseResult.options.configFile.configFileSpecs.validatedExcludeSpecs
        } : {}), { compileOnSave: !!configParseResult.compileOnSave ? true : void 0 });
        return config;
      }
      ts3.convertToTSConfig = convertToTSConfig;
      function optionMapToObject(optionMap) {
        return __assign({}, ts3.arrayFrom(optionMap.entries()).reduce(function(prev, cur) {
          var _a;
          return __assign(__assign({}, prev), (_a = {}, _a[cur[0]] = cur[1], _a));
        }, {}));
      }
      function filterSameAsDefaultInclude(specs) {
        if (!ts3.length(specs))
          return void 0;
        if (ts3.length(specs) !== 1)
          return specs;
        if (specs[0] === "**/*")
          return void 0;
        return specs;
      }
      function matchesSpecs(path2, includeSpecs, excludeSpecs, host) {
        if (!includeSpecs)
          return ts3.returnTrue;
        var patterns = ts3.getFileMatcherPatterns(path2, excludeSpecs, includeSpecs, host.useCaseSensitiveFileNames, host.getCurrentDirectory());
        var excludeRe = patterns.excludePattern && ts3.getRegexFromPattern(patterns.excludePattern, host.useCaseSensitiveFileNames);
        var includeRe = patterns.includeFilePattern && ts3.getRegexFromPattern(patterns.includeFilePattern, host.useCaseSensitiveFileNames);
        if (includeRe) {
          if (excludeRe) {
            return function(path3) {
              return !(includeRe.test(path3) && !excludeRe.test(path3));
            };
          }
          return function(path3) {
            return !includeRe.test(path3);
          };
        }
        if (excludeRe) {
          return function(path3) {
            return excludeRe.test(path3);
          };
        }
        return ts3.returnTrue;
      }
      function getCustomTypeMapOfCommandLineOption(optionDefinition) {
        if (optionDefinition.type === "string" || optionDefinition.type === "number" || optionDefinition.type === "boolean" || optionDefinition.type === "object") {
          return void 0;
        } else if (optionDefinition.type === "list") {
          return getCustomTypeMapOfCommandLineOption(optionDefinition.element);
        } else {
          return optionDefinition.type;
        }
      }
      function getNameOfCompilerOptionValue(value, customTypeMap) {
        return ts3.forEachEntry(customTypeMap, function(mapValue, key) {
          if (mapValue === value) {
            return key;
          }
        });
      }
      function serializeCompilerOptions(options, pathOptions) {
        return serializeOptionBaseObject(options, getOptionsNameMap(), pathOptions);
      }
      function serializeWatchOptions(options) {
        return serializeOptionBaseObject(options, getWatchOptionsNameMap());
      }
      function serializeOptionBaseObject(options, _a, pathOptions) {
        var optionsNameMap = _a.optionsNameMap;
        var result2 = new ts3.Map();
        var getCanonicalFileName = pathOptions && ts3.createGetCanonicalFileName(pathOptions.useCaseSensitiveFileNames);
        var _loop_5 = function(name2) {
          if (ts3.hasProperty(options, name2)) {
            if (optionsNameMap.has(name2) && (optionsNameMap.get(name2).category === ts3.Diagnostics.Command_line_Options || optionsNameMap.get(name2).category === ts3.Diagnostics.Output_Formatting)) {
              return "continue";
            }
            var value = options[name2];
            var optionDefinition = optionsNameMap.get(name2.toLowerCase());
            if (optionDefinition) {
              var customTypeMap_1 = getCustomTypeMapOfCommandLineOption(optionDefinition);
              if (!customTypeMap_1) {
                if (pathOptions && optionDefinition.isFilePath) {
                  result2.set(name2, ts3.getRelativePathFromFile(pathOptions.configFilePath, ts3.getNormalizedAbsolutePath(value, ts3.getDirectoryPath(pathOptions.configFilePath)), getCanonicalFileName));
                } else {
                  result2.set(name2, value);
                }
              } else {
                if (optionDefinition.type === "list") {
                  result2.set(name2, value.map(function(element) {
                    return getNameOfCompilerOptionValue(element, customTypeMap_1);
                  }));
                } else {
                  result2.set(name2, getNameOfCompilerOptionValue(value, customTypeMap_1));
                }
              }
            }
          }
        };
        for (var name in options) {
          _loop_5(name);
        }
        return result2;
      }
      function getCompilerOptionsDiffValue(options, newLine) {
        var compilerOptionsMap = getSerializedCompilerOption(options);
        return getOverwrittenDefaultOptions();
        function makePadding(paddingLength) {
          return Array(paddingLength + 1).join(" ");
        }
        function getOverwrittenDefaultOptions() {
          var result2 = [];
          var tab = makePadding(2);
          commandOptionsWithoutBuild.forEach(function(cmd) {
            if (!compilerOptionsMap.has(cmd.name)) {
              return;
            }
            var newValue = compilerOptionsMap.get(cmd.name);
            var defaultValue = getDefaultValueForOption(cmd);
            if (newValue !== defaultValue) {
              result2.push("".concat(tab).concat(cmd.name, ": ").concat(newValue));
            } else if (ts3.hasProperty(ts3.defaultInitCompilerOptions, cmd.name)) {
              result2.push("".concat(tab).concat(cmd.name, ": ").concat(defaultValue));
            }
          });
          return result2.join(newLine) + newLine;
        }
      }
      ts3.getCompilerOptionsDiffValue = getCompilerOptionsDiffValue;
      function getSerializedCompilerOption(options) {
        var compilerOptions = ts3.extend(options, ts3.defaultInitCompilerOptions);
        return serializeCompilerOptions(compilerOptions);
      }
      function generateTSConfig(options, fileNames, newLine) {
        var compilerOptionsMap = getSerializedCompilerOption(options);
        return writeConfigurations();
        function makePadding(paddingLength) {
          return Array(paddingLength + 1).join(" ");
        }
        function isAllowedOptionForOutput(_a) {
          var category = _a.category, name = _a.name, isCommandLineOnly = _a.isCommandLineOnly;
          var categoriesToSkip = [ts3.Diagnostics.Command_line_Options, ts3.Diagnostics.Editor_Support, ts3.Diagnostics.Compiler_Diagnostics, ts3.Diagnostics.Backwards_Compatibility, ts3.Diagnostics.Watch_and_Build_Modes, ts3.Diagnostics.Output_Formatting];
          return !isCommandLineOnly && category !== void 0 && (!categoriesToSkip.includes(category) || compilerOptionsMap.has(name));
        }
        function writeConfigurations() {
          var categorizedOptions = ts3.createMultiMap();
          for (var _i = 0, optionDeclarations_1 = ts3.optionDeclarations; _i < optionDeclarations_1.length; _i++) {
            var option = optionDeclarations_1[_i];
            var category = option.category;
            if (isAllowedOptionForOutput(option)) {
              categorizedOptions.add(ts3.getLocaleSpecificMessage(category), option);
            }
          }
          var marginLength = 0;
          var seenKnownKeys = 0;
          var entries = [];
          categorizedOptions.forEach(function(options2, category2) {
            if (entries.length !== 0) {
              entries.push({ value: "" });
            }
            entries.push({ value: "/* ".concat(category2, " */") });
            for (var _i2 = 0, options_1 = options2; _i2 < options_1.length; _i2++) {
              var option2 = options_1[_i2];
              var optionName = void 0;
              if (compilerOptionsMap.has(option2.name)) {
                optionName = '"'.concat(option2.name, '": ').concat(JSON.stringify(compilerOptionsMap.get(option2.name))).concat((seenKnownKeys += 1) === compilerOptionsMap.size ? "" : ",");
              } else {
                optionName = '// "'.concat(option2.name, '": ').concat(JSON.stringify(getDefaultValueForOption(option2)), ",");
              }
              entries.push({
                value: optionName,
                description: "/* ".concat(option2.description && ts3.getLocaleSpecificMessage(option2.description) || option2.name, " */")
              });
              marginLength = Math.max(optionName.length, marginLength);
            }
          });
          var tab = makePadding(2);
          var result2 = [];
          result2.push("{");
          result2.push("".concat(tab, '"compilerOptions": {'));
          result2.push("".concat(tab).concat(tab, "/* ").concat(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file), " */"));
          result2.push("");
          for (var _a = 0, entries_2 = entries; _a < entries_2.length; _a++) {
            var entry = entries_2[_a];
            var value = entry.value, _b = entry.description, description = _b === void 0 ? "" : _b;
            result2.push(value && "".concat(tab).concat(tab).concat(value).concat(description && makePadding(marginLength - value.length + 2) + description));
          }
          if (fileNames.length) {
            result2.push("".concat(tab, "},"));
            result2.push("".concat(tab, '"files": ['));
            for (var i = 0; i < fileNames.length; i++) {
              result2.push("".concat(tab).concat(tab).concat(JSON.stringify(fileNames[i])).concat(i === fileNames.length - 1 ? "" : ","));
            }
            result2.push("".concat(tab, "]"));
          } else {
            result2.push("".concat(tab, "}"));
          }
          result2.push("}");
          return result2.join(newLine) + newLine;
        }
      }
      ts3.generateTSConfig = generateTSConfig;
      function convertToOptionsWithAbsolutePaths(options, toAbsolutePath) {
        var result2 = {};
        var optionsNameMap = getOptionsNameMap().optionsNameMap;
        for (var name in options) {
          if (ts3.hasProperty(options, name)) {
            result2[name] = convertToOptionValueWithAbsolutePaths(optionsNameMap.get(name.toLowerCase()), options[name], toAbsolutePath);
          }
        }
        if (result2.configFilePath) {
          result2.configFilePath = toAbsolutePath(result2.configFilePath);
        }
        return result2;
      }
      ts3.convertToOptionsWithAbsolutePaths = convertToOptionsWithAbsolutePaths;
      function convertToOptionValueWithAbsolutePaths(option, value, toAbsolutePath) {
        if (option && !isNullOrUndefined(value)) {
          if (option.type === "list") {
            var values = value;
            if (option.element.isFilePath && values.length) {
              return values.map(toAbsolutePath);
            }
          } else if (option.isFilePath) {
            return toAbsolutePath(value);
          }
        }
        return value;
      }
      function parseJsonConfigFileContent(json2, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
        return parseJsonConfigFileContentWorker(json2, void 0, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache);
      }
      ts3.parseJsonConfigFileContent = parseJsonConfigFileContent;
      function parseJsonSourceFileConfigFileContent(sourceFile, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("parse", "parseJsonSourceFileConfigFileContent", { path: sourceFile.fileName });
        var result2 = parseJsonConfigFileContentWorker(void 0, sourceFile, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache);
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        return result2;
      }
      ts3.parseJsonSourceFileConfigFileContent = parseJsonSourceFileConfigFileContent;
      function setConfigFileInOptions(options, configFile) {
        if (configFile) {
          Object.defineProperty(options, "configFile", { enumerable: false, writable: false, value: configFile });
        }
      }
      ts3.setConfigFileInOptions = setConfigFileInOptions;
      function isNullOrUndefined(x) {
        return x === void 0 || x === null;
      }
      function directoryOfCombinedPath(fileName2, basePath) {
        return ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(fileName2, basePath));
      }
      function parseJsonConfigFileContentWorker(json2, sourceFile, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache) {
        if (existingOptions === void 0) {
          existingOptions = {};
        }
        if (resolutionStack === void 0) {
          resolutionStack = [];
        }
        if (extraFileExtensions === void 0) {
          extraFileExtensions = [];
        }
        ts3.Debug.assert(json2 === void 0 && sourceFile !== void 0 || json2 !== void 0 && sourceFile === void 0);
        var errors = [];
        var parsedConfig = parseConfig(json2, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache);
        var raw = parsedConfig.raw;
        var options = ts3.extend(existingOptions, parsedConfig.options || {});
        var watchOptions = existingWatchOptions && parsedConfig.watchOptions ? ts3.extend(existingWatchOptions, parsedConfig.watchOptions) : parsedConfig.watchOptions || existingWatchOptions;
        options.configFilePath = configFileName && ts3.normalizeSlashes(configFileName);
        var configFileSpecs = getConfigFileSpecs();
        if (sourceFile)
          sourceFile.configFileSpecs = configFileSpecs;
        setConfigFileInOptions(options, sourceFile);
        var basePathForFileNames = ts3.normalizePath(configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath);
        return {
          options,
          watchOptions,
          fileNames: getFileNames(basePathForFileNames),
          projectReferences: getProjectReferences(basePathForFileNames),
          typeAcquisition: parsedConfig.typeAcquisition || getDefaultTypeAcquisition(),
          raw,
          errors,
          wildcardDirectories: getWildcardDirectories(configFileSpecs, basePathForFileNames, host.useCaseSensitiveFileNames),
          compileOnSave: !!raw.compileOnSave
        };
        function getConfigFileSpecs() {
          var referencesOfRaw = getPropFromRaw("references", function(element) {
            return typeof element === "object";
          }, "object");
          var filesSpecs = toPropValue(getSpecsFromRaw("files"));
          if (filesSpecs) {
            var hasZeroOrNoReferences = referencesOfRaw === "no-prop" || ts3.isArray(referencesOfRaw) && referencesOfRaw.length === 0;
            var hasExtends = ts3.hasProperty(raw, "extends");
            if (filesSpecs.length === 0 && hasZeroOrNoReferences && !hasExtends) {
              if (sourceFile) {
                var fileName2 = configFileName || "tsconfig.json";
                var diagnosticMessage = ts3.Diagnostics.The_files_list_in_config_file_0_is_empty;
                var nodeValue = ts3.firstDefined(ts3.getTsConfigPropArray(sourceFile, "files"), function(property) {
                  return property.initializer;
                });
                var error = nodeValue ? ts3.createDiagnosticForNodeInSourceFile(sourceFile, nodeValue, diagnosticMessage, fileName2) : ts3.createCompilerDiagnostic(diagnosticMessage, fileName2);
                errors.push(error);
              } else {
                createCompilerDiagnosticOnlyIfJson(ts3.Diagnostics.The_files_list_in_config_file_0_is_empty, configFileName || "tsconfig.json");
              }
            }
          }
          var includeSpecs = toPropValue(getSpecsFromRaw("include"));
          var excludeOfRaw = getSpecsFromRaw("exclude");
          var excludeSpecs = toPropValue(excludeOfRaw);
          if (excludeOfRaw === "no-prop" && raw.compilerOptions) {
            var outDir = raw.compilerOptions.outDir;
            var declarationDir = raw.compilerOptions.declarationDir;
            if (outDir || declarationDir) {
              excludeSpecs = [outDir, declarationDir].filter(function(d) {
                return !!d;
              });
            }
          }
          if (filesSpecs === void 0 && includeSpecs === void 0) {
            includeSpecs = ["**/*"];
          }
          var validatedIncludeSpecs, validatedExcludeSpecs;
          if (includeSpecs) {
            validatedIncludeSpecs = validateSpecs(includeSpecs, errors, true, sourceFile, "include");
          }
          if (excludeSpecs) {
            validatedExcludeSpecs = validateSpecs(excludeSpecs, errors, false, sourceFile, "exclude");
          }
          return {
            filesSpecs,
            includeSpecs,
            excludeSpecs,
            validatedFilesSpec: ts3.filter(filesSpecs, ts3.isString),
            validatedIncludeSpecs,
            validatedExcludeSpecs,
            pathPatterns: void 0
          };
        }
        function getFileNames(basePath2) {
          var fileNames = getFileNamesFromConfigSpecs(configFileSpecs, basePath2, options, host, extraFileExtensions);
          if (shouldReportNoInputFiles(fileNames, canJsonReportNoInputFiles(raw), resolutionStack)) {
            errors.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
          }
          return fileNames;
        }
        function getProjectReferences(basePath2) {
          var projectReferences;
          var referencesOfRaw = getPropFromRaw("references", function(element) {
            return typeof element === "object";
          }, "object");
          if (ts3.isArray(referencesOfRaw)) {
            for (var _i = 0, referencesOfRaw_1 = referencesOfRaw; _i < referencesOfRaw_1.length; _i++) {
              var ref = referencesOfRaw_1[_i];
              if (typeof ref.path !== "string") {
                createCompilerDiagnosticOnlyIfJson(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "reference.path", "string");
              } else {
                (projectReferences || (projectReferences = [])).push({
                  path: ts3.getNormalizedAbsolutePath(ref.path, basePath2),
                  originalPath: ref.path,
                  prepend: ref.prepend,
                  circular: ref.circular
                });
              }
            }
          }
          return projectReferences;
        }
        function toPropValue(specResult) {
          return ts3.isArray(specResult) ? specResult : void 0;
        }
        function getSpecsFromRaw(prop) {
          return getPropFromRaw(prop, ts3.isString, "string");
        }
        function getPropFromRaw(prop, validateElement, elementTypeName) {
          if (ts3.hasProperty(raw, prop) && !isNullOrUndefined(raw[prop])) {
            if (ts3.isArray(raw[prop])) {
              var result2 = raw[prop];
              if (!sourceFile && !ts3.every(result2, validateElement)) {
                errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, prop, elementTypeName));
              }
              return result2;
            } else {
              createCompilerDiagnosticOnlyIfJson(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, prop, "Array");
              return "not-array";
            }
          }
          return "no-prop";
        }
        function createCompilerDiagnosticOnlyIfJson(message, arg0, arg1) {
          if (!sourceFile) {
            errors.push(ts3.createCompilerDiagnostic(message, arg0, arg1));
          }
        }
      }
      function isErrorNoInputFiles(error) {
        return error.code === ts3.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code;
      }
      function getErrorForNoInputFiles(_a, configFileName) {
        var includeSpecs = _a.includeSpecs, excludeSpecs = _a.excludeSpecs;
        return ts3.createCompilerDiagnostic(ts3.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2, configFileName || "tsconfig.json", JSON.stringify(includeSpecs || []), JSON.stringify(excludeSpecs || []));
      }
      function shouldReportNoInputFiles(fileNames, canJsonReportNoInutFiles, resolutionStack) {
        return fileNames.length === 0 && canJsonReportNoInutFiles && (!resolutionStack || resolutionStack.length === 0);
      }
      function canJsonReportNoInputFiles(raw) {
        return !ts3.hasProperty(raw, "files") && !ts3.hasProperty(raw, "references");
      }
      ts3.canJsonReportNoInputFiles = canJsonReportNoInputFiles;
      function updateErrorForNoInputFiles(fileNames, configFileName, configFileSpecs, configParseDiagnostics, canJsonReportNoInutFiles) {
        var existingErrors = configParseDiagnostics.length;
        if (shouldReportNoInputFiles(fileNames, canJsonReportNoInutFiles)) {
          configParseDiagnostics.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
        } else {
          ts3.filterMutate(configParseDiagnostics, function(error) {
            return !isErrorNoInputFiles(error);
          });
        }
        return existingErrors !== configParseDiagnostics.length;
      }
      ts3.updateErrorForNoInputFiles = updateErrorForNoInputFiles;
      function isSuccessfulParsedTsconfig(value) {
        return !!value.options;
      }
      function parseConfig(json2, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache) {
        var _a;
        basePath = ts3.normalizeSlashes(basePath);
        var resolvedPath = ts3.getNormalizedAbsolutePath(configFileName || "", basePath);
        if (resolutionStack.indexOf(resolvedPath) >= 0) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0, __spreadArray(__spreadArray([], resolutionStack, true), [resolvedPath], false).join(" -> ")));
          return { raw: json2 || convertToObject(sourceFile, errors) };
        }
        var ownConfig = json2 ? parseOwnConfigOfJson(json2, host, basePath, configFileName, errors) : parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors);
        if ((_a = ownConfig.options) === null || _a === void 0 ? void 0 : _a.paths) {
          ownConfig.options.pathsBasePath = basePath;
        }
        if (ownConfig.extendedConfigPath) {
          resolutionStack = resolutionStack.concat([resolvedPath]);
          var extendedConfig = getExtendedConfig(sourceFile, ownConfig.extendedConfigPath, host, resolutionStack, errors, extendedConfigCache);
          if (extendedConfig && isSuccessfulParsedTsconfig(extendedConfig)) {
            var baseRaw_1 = extendedConfig.raw;
            var raw_1 = ownConfig.raw;
            var relativeDifference_1;
            var setPropertyInRawIfNotUndefined = function(propertyName) {
              if (!raw_1[propertyName] && baseRaw_1[propertyName]) {
                raw_1[propertyName] = ts3.map(baseRaw_1[propertyName], function(path2) {
                  return ts3.isRootedDiskPath(path2) ? path2 : ts3.combinePaths(relativeDifference_1 || (relativeDifference_1 = ts3.convertToRelativePath(ts3.getDirectoryPath(ownConfig.extendedConfigPath), basePath, ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames))), path2);
                });
              }
            };
            setPropertyInRawIfNotUndefined("include");
            setPropertyInRawIfNotUndefined("exclude");
            setPropertyInRawIfNotUndefined("files");
            if (raw_1.compileOnSave === void 0) {
              raw_1.compileOnSave = baseRaw_1.compileOnSave;
            }
            ownConfig.options = ts3.assign({}, extendedConfig.options, ownConfig.options);
            ownConfig.watchOptions = ownConfig.watchOptions && extendedConfig.watchOptions ? ts3.assign({}, extendedConfig.watchOptions, ownConfig.watchOptions) : ownConfig.watchOptions || extendedConfig.watchOptions;
          }
        }
        return ownConfig;
      }
      function parseOwnConfigOfJson(json2, host, basePath, configFileName, errors) {
        if (ts3.hasProperty(json2, "excludes")) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
        }
        var options = convertCompilerOptionsFromJsonWorker(json2.compilerOptions, basePath, errors, configFileName);
        var typeAcquisition = convertTypeAcquisitionFromJsonWorker(json2.typeAcquisition || json2.typingOptions, basePath, errors, configFileName);
        var watchOptions = convertWatchOptionsFromJsonWorker(json2.watchOptions, basePath, errors);
        json2.compileOnSave = convertCompileOnSaveOptionFromJson(json2, basePath, errors);
        var extendedConfigPath;
        if (json2.extends) {
          if (!ts3.isString(json2.extends)) {
            errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "extends", "string"));
          } else {
            var newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
            extendedConfigPath = getExtendsConfigPath(json2.extends, host, newBase, errors, ts3.createCompilerDiagnostic);
          }
        }
        return { raw: json2, options, watchOptions, typeAcquisition, extendedConfigPath };
      }
      function parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors) {
        var options = getDefaultCompilerOptions(configFileName);
        var typeAcquisition, typingOptionstypeAcquisition;
        var watchOptions;
        var extendedConfigPath;
        var rootCompilerOptions;
        var optionsIterator = {
          onSetValidOptionKeyValueInParent: function(parentOption, option, value) {
            var currentOption;
            switch (parentOption) {
              case "compilerOptions":
                currentOption = options;
                break;
              case "watchOptions":
                currentOption = watchOptions || (watchOptions = {});
                break;
              case "typeAcquisition":
                currentOption = typeAcquisition || (typeAcquisition = getDefaultTypeAcquisition(configFileName));
                break;
              case "typingOptions":
                currentOption = typingOptionstypeAcquisition || (typingOptionstypeAcquisition = getDefaultTypeAcquisition(configFileName));
                break;
              default:
                ts3.Debug.fail("Unknown option");
            }
            currentOption[option.name] = normalizeOptionValue(option, basePath, value);
          },
          onSetValidOptionKeyValueInRoot: function(key, _keyNode, value, valueNode) {
            switch (key) {
              case "extends":
                var newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
                extendedConfigPath = getExtendsConfigPath(value, host, newBase, errors, function(message, arg0) {
                  return ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueNode, message, arg0);
                });
                return;
            }
          },
          onSetUnknownOptionKeyValueInRoot: function(key, keyNode, _value, _valueNode) {
            if (key === "excludes") {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, keyNode, ts3.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
            }
            if (ts3.find(commandOptionsWithoutBuild, function(opt) {
              return opt.name === key;
            })) {
              rootCompilerOptions = ts3.append(rootCompilerOptions, keyNode);
            }
          }
        };
        var json2 = convertConfigFileToObject(sourceFile, errors, true, optionsIterator);
        if (!typeAcquisition) {
          if (typingOptionstypeAcquisition) {
            typeAcquisition = typingOptionstypeAcquisition.enableAutoDiscovery !== void 0 ? {
              enable: typingOptionstypeAcquisition.enableAutoDiscovery,
              include: typingOptionstypeAcquisition.include,
              exclude: typingOptionstypeAcquisition.exclude
            } : typingOptionstypeAcquisition;
          } else {
            typeAcquisition = getDefaultTypeAcquisition(configFileName);
          }
        }
        if (rootCompilerOptions && json2 && json2.compilerOptions === void 0) {
          errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, rootCompilerOptions[0], ts3.Diagnostics._0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file, ts3.getTextOfPropertyName(rootCompilerOptions[0])));
        }
        return { raw: json2, options, watchOptions, typeAcquisition, extendedConfigPath };
      }
      function getExtendsConfigPath(extendedConfig, host, basePath, errors, createDiagnostic) {
        extendedConfig = ts3.normalizeSlashes(extendedConfig);
        if (ts3.isRootedDiskPath(extendedConfig) || ts3.startsWith(extendedConfig, "./") || ts3.startsWith(extendedConfig, "../")) {
          var extendedConfigPath = ts3.getNormalizedAbsolutePath(extendedConfig, basePath);
          if (!host.fileExists(extendedConfigPath) && !ts3.endsWith(extendedConfigPath, ".json")) {
            extendedConfigPath = "".concat(extendedConfigPath, ".json");
            if (!host.fileExists(extendedConfigPath)) {
              errors.push(createDiagnostic(ts3.Diagnostics.File_0_not_found, extendedConfig));
              return void 0;
            }
          }
          return extendedConfigPath;
        }
        var resolved = ts3.nodeModuleNameResolver(extendedConfig, ts3.combinePaths(basePath, "tsconfig.json"), { moduleResolution: ts3.ModuleResolutionKind.NodeJs }, host, void 0, void 0, true);
        if (resolved.resolvedModule) {
          return resolved.resolvedModule.resolvedFileName;
        }
        errors.push(createDiagnostic(ts3.Diagnostics.File_0_not_found, extendedConfig));
        return void 0;
      }
      function getExtendedConfig(sourceFile, extendedConfigPath, host, resolutionStack, errors, extendedConfigCache) {
        var _a;
        var path2 = host.useCaseSensitiveFileNames ? extendedConfigPath : ts3.toFileNameLowerCase(extendedConfigPath);
        var value;
        var extendedResult;
        var extendedConfig;
        if (extendedConfigCache && (value = extendedConfigCache.get(path2))) {
          extendedResult = value.extendedResult, extendedConfig = value.extendedConfig;
        } else {
          extendedResult = readJsonConfigFile(extendedConfigPath, function(path3) {
            return host.readFile(path3);
          });
          if (!extendedResult.parseDiagnostics.length) {
            extendedConfig = parseConfig(void 0, extendedResult, host, ts3.getDirectoryPath(extendedConfigPath), ts3.getBaseFileName(extendedConfigPath), resolutionStack, errors, extendedConfigCache);
          }
          if (extendedConfigCache) {
            extendedConfigCache.set(path2, { extendedResult, extendedConfig });
          }
        }
        if (sourceFile) {
          sourceFile.extendedSourceFiles = [extendedResult.fileName];
          if (extendedResult.extendedSourceFiles) {
            (_a = sourceFile.extendedSourceFiles).push.apply(_a, extendedResult.extendedSourceFiles);
          }
        }
        if (extendedResult.parseDiagnostics.length) {
          errors.push.apply(errors, extendedResult.parseDiagnostics);
          return void 0;
        }
        return extendedConfig;
      }
      function convertCompileOnSaveOptionFromJson(jsonOption, basePath, errors) {
        if (!ts3.hasProperty(jsonOption, ts3.compileOnSaveCommandLineOption.name)) {
          return false;
        }
        var result2 = convertJsonOption(ts3.compileOnSaveCommandLineOption, jsonOption.compileOnSave, basePath, errors);
        return typeof result2 === "boolean" && result2;
      }
      function convertCompilerOptionsFromJson(jsonOptions, basePath, configFileName) {
        var errors = [];
        var options = convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName);
        return { options, errors };
      }
      ts3.convertCompilerOptionsFromJson = convertCompilerOptionsFromJson;
      function convertTypeAcquisitionFromJson(jsonOptions, basePath, configFileName) {
        var errors = [];
        var options = convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName);
        return { options, errors };
      }
      ts3.convertTypeAcquisitionFromJson = convertTypeAcquisitionFromJson;
      function getDefaultCompilerOptions(configFileName) {
        var options = configFileName && ts3.getBaseFileName(configFileName) === "jsconfig.json" ? { allowJs: true, maxNodeModuleJsDepth: 2, allowSyntheticDefaultImports: true, skipLibCheck: true, noEmit: true } : {};
        return options;
      }
      function convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
        var options = getDefaultCompilerOptions(configFileName);
        convertOptionsFromJson(getCommandLineCompilerOptionsMap(), jsonOptions, basePath, options, ts3.compilerOptionsDidYouMeanDiagnostics, errors);
        if (configFileName) {
          options.configFilePath = ts3.normalizeSlashes(configFileName);
        }
        return options;
      }
      function getDefaultTypeAcquisition(configFileName) {
        return { enable: !!configFileName && ts3.getBaseFileName(configFileName) === "jsconfig.json", include: [], exclude: [] };
      }
      function convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
        var options = getDefaultTypeAcquisition(configFileName);
        var typeAcquisition = convertEnableAutoDiscoveryToEnable(jsonOptions);
        convertOptionsFromJson(getCommandLineTypeAcquisitionMap(), typeAcquisition, basePath, options, typeAcquisitionDidYouMeanDiagnostics, errors);
        return options;
      }
      function convertWatchOptionsFromJsonWorker(jsonOptions, basePath, errors) {
        return convertOptionsFromJson(getCommandLineWatchOptionsMap(), jsonOptions, basePath, void 0, watchOptionsDidYouMeanDiagnostics, errors);
      }
      function convertOptionsFromJson(optionsNameMap, jsonOptions, basePath, defaultOptions, diagnostics, errors) {
        if (!jsonOptions) {
          return;
        }
        for (var id in jsonOptions) {
          var opt = optionsNameMap.get(id);
          if (opt) {
            (defaultOptions || (defaultOptions = {}))[opt.name] = convertJsonOption(opt, jsonOptions[id], basePath, errors);
          } else {
            errors.push(createUnknownOptionError(id, diagnostics, ts3.createCompilerDiagnostic));
          }
        }
        return defaultOptions;
      }
      function convertJsonOption(opt, value, basePath, errors) {
        if (isCompilerOptionsValue(opt, value)) {
          var optType = opt.type;
          if (optType === "list" && ts3.isArray(value)) {
            return convertJsonOptionOfListType(opt, value, basePath, errors);
          } else if (!ts3.isString(optType)) {
            return convertJsonOptionOfCustomType(opt, value, errors);
          }
          var validatedValue = validateJsonOptionValue(opt, value, errors);
          return isNullOrUndefined(validatedValue) ? validatedValue : normalizeNonListOptionValue(opt, basePath, validatedValue);
        } else {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, opt.name, getCompilerOptionValueTypeString(opt)));
        }
      }
      ts3.convertJsonOption = convertJsonOption;
      function normalizeOptionValue(option, basePath, value) {
        if (isNullOrUndefined(value))
          return void 0;
        if (option.type === "list") {
          var listOption_1 = option;
          if (listOption_1.element.isFilePath || !ts3.isString(listOption_1.element.type)) {
            return ts3.filter(ts3.map(value, function(v) {
              return normalizeOptionValue(listOption_1.element, basePath, v);
            }), function(v) {
              return listOption_1.listPreserveFalsyValues ? true : !!v;
            });
          }
          return value;
        } else if (!ts3.isString(option.type)) {
          return option.type.get(ts3.isString(value) ? value.toLowerCase() : value);
        }
        return normalizeNonListOptionValue(option, basePath, value);
      }
      function normalizeNonListOptionValue(option, basePath, value) {
        if (option.isFilePath) {
          value = ts3.getNormalizedAbsolutePath(value, basePath);
          if (value === "") {
            value = ".";
          }
        }
        return value;
      }
      function validateJsonOptionValue(opt, value, errors) {
        var _a;
        if (isNullOrUndefined(value))
          return void 0;
        var d = (_a = opt.extraValidation) === null || _a === void 0 ? void 0 : _a.call(opt, value);
        if (!d)
          return value;
        errors.push(ts3.createCompilerDiagnostic.apply(void 0, d));
        return void 0;
      }
      function convertJsonOptionOfCustomType(opt, value, errors) {
        if (isNullOrUndefined(value))
          return void 0;
        var key = value.toLowerCase();
        var val = opt.type.get(key);
        if (val !== void 0) {
          return validateJsonOptionValue(opt, val, errors);
        } else {
          errors.push(createCompilerDiagnosticForInvalidCustomType(opt));
        }
      }
      function convertJsonOptionOfListType(option, values, basePath, errors) {
        return ts3.filter(ts3.map(values, function(v) {
          return convertJsonOption(option.element, v, basePath, errors);
        }), function(v) {
          return option.listPreserveFalsyValues ? true : !!v;
        });
      }
      var invalidTrailingRecursionPattern = /(^|\/)\*\*\/?$/;
      var wildcardDirectoryPattern = /^[^*?]*(?=\/[^/]*[*?])/;
      function getFileNamesFromConfigSpecs(configFileSpecs, basePath, options, host, extraFileExtensions) {
        if (extraFileExtensions === void 0) {
          extraFileExtensions = ts3.emptyArray;
        }
        basePath = ts3.normalizePath(basePath);
        var keyMapper = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        var literalFileMap = new ts3.Map();
        var wildcardFileMap = new ts3.Map();
        var wildCardJsonFileMap = new ts3.Map();
        var validatedFilesSpec = configFileSpecs.validatedFilesSpec, validatedIncludeSpecs = configFileSpecs.validatedIncludeSpecs, validatedExcludeSpecs = configFileSpecs.validatedExcludeSpecs;
        var supportedExtensions = ts3.getSupportedExtensions(options, extraFileExtensions);
        var supportedExtensionsWithJsonIfResolveJsonModule = ts3.getSupportedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
        if (validatedFilesSpec) {
          for (var _i = 0, validatedFilesSpec_1 = validatedFilesSpec; _i < validatedFilesSpec_1.length; _i++) {
            var fileName2 = validatedFilesSpec_1[_i];
            var file = ts3.getNormalizedAbsolutePath(fileName2, basePath);
            literalFileMap.set(keyMapper(file), file);
          }
        }
        var jsonOnlyIncludeRegexes;
        if (validatedIncludeSpecs && validatedIncludeSpecs.length > 0) {
          var _loop_6 = function(file2) {
            if (ts3.fileExtensionIs(file2, ".json")) {
              if (!jsonOnlyIncludeRegexes) {
                var includes = validatedIncludeSpecs.filter(function(s) {
                  return ts3.endsWith(s, ".json");
                });
                var includeFilePatterns = ts3.map(ts3.getRegularExpressionsForWildcards(includes, basePath, "files"), function(pattern) {
                  return "^".concat(pattern, "$");
                });
                jsonOnlyIncludeRegexes = includeFilePatterns ? includeFilePatterns.map(function(pattern) {
                  return ts3.getRegexFromPattern(pattern, host.useCaseSensitiveFileNames);
                }) : ts3.emptyArray;
              }
              var includeIndex = ts3.findIndex(jsonOnlyIncludeRegexes, function(re) {
                return re.test(file2);
              });
              if (includeIndex !== -1) {
                var key_1 = keyMapper(file2);
                if (!literalFileMap.has(key_1) && !wildCardJsonFileMap.has(key_1)) {
                  wildCardJsonFileMap.set(key_1, file2);
                }
              }
              return "continue";
            }
            if (hasFileWithHigherPriorityExtension(file2, literalFileMap, wildcardFileMap, supportedExtensions, keyMapper)) {
              return "continue";
            }
            removeWildcardFilesWithLowerPriorityExtension(file2, wildcardFileMap, supportedExtensions, keyMapper);
            var key = keyMapper(file2);
            if (!literalFileMap.has(key) && !wildcardFileMap.has(key)) {
              wildcardFileMap.set(key, file2);
            }
          };
          for (var _a = 0, _b = host.readDirectory(basePath, ts3.flatten(supportedExtensionsWithJsonIfResolveJsonModule), validatedExcludeSpecs, validatedIncludeSpecs, void 0); _a < _b.length; _a++) {
            var file = _b[_a];
            _loop_6(file);
          }
        }
        var literalFiles = ts3.arrayFrom(literalFileMap.values());
        var wildcardFiles = ts3.arrayFrom(wildcardFileMap.values());
        return literalFiles.concat(wildcardFiles, ts3.arrayFrom(wildCardJsonFileMap.values()));
      }
      ts3.getFileNamesFromConfigSpecs = getFileNamesFromConfigSpecs;
      function isExcludedFile(pathToCheck, spec, basePath, useCaseSensitiveFileNames, currentDirectory) {
        var validatedFilesSpec = spec.validatedFilesSpec, validatedIncludeSpecs = spec.validatedIncludeSpecs, validatedExcludeSpecs = spec.validatedExcludeSpecs;
        if (!ts3.length(validatedIncludeSpecs) || !ts3.length(validatedExcludeSpecs))
          return false;
        basePath = ts3.normalizePath(basePath);
        var keyMapper = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        if (validatedFilesSpec) {
          for (var _i = 0, validatedFilesSpec_2 = validatedFilesSpec; _i < validatedFilesSpec_2.length; _i++) {
            var fileName2 = validatedFilesSpec_2[_i];
            if (keyMapper(ts3.getNormalizedAbsolutePath(fileName2, basePath)) === pathToCheck)
              return false;
          }
        }
        return matchesExcludeWorker(pathToCheck, validatedExcludeSpecs, useCaseSensitiveFileNames, currentDirectory, basePath);
      }
      ts3.isExcludedFile = isExcludedFile;
      function invalidDotDotAfterRecursiveWildcard(s) {
        var wildcardIndex = ts3.startsWith(s, "**/") ? 0 : s.indexOf("/**/");
        if (wildcardIndex === -1) {
          return false;
        }
        var lastDotIndex = ts3.endsWith(s, "/..") ? s.length : s.lastIndexOf("/../");
        return lastDotIndex > wildcardIndex;
      }
      function matchesExclude(pathToCheck, excludeSpecs, useCaseSensitiveFileNames, currentDirectory) {
        return matchesExcludeWorker(pathToCheck, ts3.filter(excludeSpecs, function(spec) {
          return !invalidDotDotAfterRecursiveWildcard(spec);
        }), useCaseSensitiveFileNames, currentDirectory);
      }
      ts3.matchesExclude = matchesExclude;
      function matchesExcludeWorker(pathToCheck, excludeSpecs, useCaseSensitiveFileNames, currentDirectory, basePath) {
        var excludePattern = ts3.getRegularExpressionForWildcard(excludeSpecs, ts3.combinePaths(ts3.normalizePath(currentDirectory), basePath), "exclude");
        var excludeRegex = excludePattern && ts3.getRegexFromPattern(excludePattern, useCaseSensitiveFileNames);
        if (!excludeRegex)
          return false;
        if (excludeRegex.test(pathToCheck))
          return true;
        return !ts3.hasExtension(pathToCheck) && excludeRegex.test(ts3.ensureTrailingDirectorySeparator(pathToCheck));
      }
      function validateSpecs(specs, errors, disallowTrailingRecursion, jsonSourceFile, specKey) {
        return specs.filter(function(spec) {
          if (!ts3.isString(spec))
            return false;
          var diag = specToDiagnostic(spec, disallowTrailingRecursion);
          if (diag !== void 0) {
            errors.push(createDiagnostic.apply(void 0, diag));
          }
          return diag === void 0;
        });
        function createDiagnostic(message, spec) {
          var element = ts3.getTsConfigPropArrayElementValue(jsonSourceFile, specKey, spec);
          return element ? ts3.createDiagnosticForNodeInSourceFile(jsonSourceFile, element, message, spec) : ts3.createCompilerDiagnostic(message, spec);
        }
      }
      function specToDiagnostic(spec, disallowTrailingRecursion) {
        if (disallowTrailingRecursion && invalidTrailingRecursionPattern.test(spec)) {
          return [ts3.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, spec];
        } else if (invalidDotDotAfterRecursiveWildcard(spec)) {
          return [ts3.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, spec];
        }
      }
      function getWildcardDirectories(_a, path2, useCaseSensitiveFileNames) {
        var include = _a.validatedIncludeSpecs, exclude = _a.validatedExcludeSpecs;
        var rawExcludeRegex = ts3.getRegularExpressionForWildcard(exclude, path2, "exclude");
        var excludeRegex = rawExcludeRegex && new RegExp(rawExcludeRegex, useCaseSensitiveFileNames ? "" : "i");
        var wildcardDirectories = {};
        if (include !== void 0) {
          var recursiveKeys = [];
          for (var _i = 0, include_1 = include; _i < include_1.length; _i++) {
            var file = include_1[_i];
            var spec = ts3.normalizePath(ts3.combinePaths(path2, file));
            if (excludeRegex && excludeRegex.test(spec)) {
              continue;
            }
            var match = getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames);
            if (match) {
              var key = match.key, flags = match.flags;
              var existingFlags = wildcardDirectories[key];
              if (existingFlags === void 0 || existingFlags < flags) {
                wildcardDirectories[key] = flags;
                if (flags === 1) {
                  recursiveKeys.push(key);
                }
              }
            }
          }
          for (var key in wildcardDirectories) {
            if (ts3.hasProperty(wildcardDirectories, key)) {
              for (var _b = 0, recursiveKeys_1 = recursiveKeys; _b < recursiveKeys_1.length; _b++) {
                var recursiveKey = recursiveKeys_1[_b];
                if (key !== recursiveKey && ts3.containsPath(recursiveKey, key, path2, !useCaseSensitiveFileNames)) {
                  delete wildcardDirectories[key];
                }
              }
            }
          }
        }
        return wildcardDirectories;
      }
      function getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames) {
        var match = wildcardDirectoryPattern.exec(spec);
        if (match) {
          var questionWildcardIndex = spec.indexOf("?");
          var starWildcardIndex = spec.indexOf("*");
          var lastDirectorySeperatorIndex = spec.lastIndexOf(ts3.directorySeparator);
          return {
            key: useCaseSensitiveFileNames ? match[0] : ts3.toFileNameLowerCase(match[0]),
            flags: questionWildcardIndex !== -1 && questionWildcardIndex < lastDirectorySeperatorIndex || starWildcardIndex !== -1 && starWildcardIndex < lastDirectorySeperatorIndex ? 1 : 0
          };
        }
        if (ts3.isImplicitGlob(spec.substring(spec.lastIndexOf(ts3.directorySeparator) + 1))) {
          return {
            key: ts3.removeTrailingDirectorySeparator(useCaseSensitiveFileNames ? spec : ts3.toFileNameLowerCase(spec)),
            flags: 1
          };
        }
        return void 0;
      }
      function hasFileWithHigherPriorityExtension(file, literalFiles, wildcardFiles, extensions, keyMapper) {
        var extensionGroup = ts3.forEach(extensions, function(group) {
          return ts3.fileExtensionIsOneOf(file, group) ? group : void 0;
        });
        if (!extensionGroup) {
          return false;
        }
        for (var _i = 0, extensionGroup_1 = extensionGroup; _i < extensionGroup_1.length; _i++) {
          var ext = extensionGroup_1[_i];
          if (ts3.fileExtensionIs(file, ext)) {
            return false;
          }
          var higherPriorityPath = keyMapper(ts3.changeExtension(file, ext));
          if (literalFiles.has(higherPriorityPath) || wildcardFiles.has(higherPriorityPath)) {
            if (ext === ".d.ts" && (ts3.fileExtensionIs(file, ".js") || ts3.fileExtensionIs(file, ".jsx"))) {
              continue;
            }
            return true;
          }
        }
        return false;
      }
      function removeWildcardFilesWithLowerPriorityExtension(file, wildcardFiles, extensions, keyMapper) {
        var extensionGroup = ts3.forEach(extensions, function(group) {
          return ts3.fileExtensionIsOneOf(file, group) ? group : void 0;
        });
        if (!extensionGroup) {
          return;
        }
        for (var i = extensionGroup.length - 1; i >= 0; i--) {
          var ext = extensionGroup[i];
          if (ts3.fileExtensionIs(file, ext)) {
            return;
          }
          var lowerPriorityPath = keyMapper(ts3.changeExtension(file, ext));
          wildcardFiles.delete(lowerPriorityPath);
        }
      }
      function convertCompilerOptionsForTelemetry(opts) {
        var out = {};
        for (var key in opts) {
          if (opts.hasOwnProperty(key)) {
            var type2 = getOptionFromName(key);
            if (type2 !== void 0) {
              out[key] = getOptionValueWithEmptyStrings(opts[key], type2);
            }
          }
        }
        return out;
      }
      ts3.convertCompilerOptionsForTelemetry = convertCompilerOptionsForTelemetry;
      function getOptionValueWithEmptyStrings(value, option) {
        switch (option.type) {
          case "object":
            return "";
          case "string":
            return "";
          case "number":
            return typeof value === "number" ? value : "";
          case "boolean":
            return typeof value === "boolean" ? value : "";
          case "list":
            var elementType_1 = option.element;
            return ts3.isArray(value) ? value.map(function(v) {
              return getOptionValueWithEmptyStrings(v, elementType_1);
            }) : "";
          default:
            return ts3.forEachEntry(option.type, function(optionEnumValue, optionStringValue) {
              if (optionEnumValue === value) {
                return optionStringValue;
              }
            });
        }
      }
      function getDefaultValueForOption(option) {
        switch (option.type) {
          case "number":
            return 1;
          case "boolean":
            return true;
          case "string":
            var defaultValue = option.defaultValueDescription;
            return option.isFilePath ? "./".concat(defaultValue && typeof defaultValue === "string" ? defaultValue : "") : "";
          case "list":
            return [];
          case "object":
            return {};
          default:
            var iterResult = option.type.keys().next();
            if (!iterResult.done)
              return iterResult.value;
            return ts3.Debug.fail("Expected 'option.type' to have entries.");
        }
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function trace(host) {
        host.trace(ts3.formatMessage.apply(void 0, arguments));
      }
      ts3.trace = trace;
      function isTraceEnabled(compilerOptions, host) {
        return !!compilerOptions.traceResolution && host.trace !== void 0;
      }
      ts3.isTraceEnabled = isTraceEnabled;
      function withPackageId(packageInfo, r) {
        var packageId;
        if (r && packageInfo) {
          var packageJsonContent = packageInfo.packageJsonContent;
          if (typeof packageJsonContent.name === "string" && typeof packageJsonContent.version === "string") {
            packageId = {
              name: packageJsonContent.name,
              subModuleName: r.path.slice(packageInfo.packageDirectory.length + ts3.directorySeparator.length),
              version: packageJsonContent.version
            };
          }
        }
        return r && { path: r.path, extension: r.ext, packageId };
      }
      function noPackageId(r) {
        return withPackageId(void 0, r);
      }
      function removeIgnoredPackageId(r) {
        if (r) {
          ts3.Debug.assert(r.packageId === void 0);
          return { path: r.path, ext: r.extension };
        }
      }
      var Extensions;
      (function(Extensions2) {
        Extensions2[Extensions2["TypeScript"] = 0] = "TypeScript";
        Extensions2[Extensions2["JavaScript"] = 1] = "JavaScript";
        Extensions2[Extensions2["Json"] = 2] = "Json";
        Extensions2[Extensions2["TSConfig"] = 3] = "TSConfig";
        Extensions2[Extensions2["DtsOnly"] = 4] = "DtsOnly";
        Extensions2[Extensions2["TsOnly"] = 5] = "TsOnly";
      })(Extensions || (Extensions = {}));
      function resolvedTypeScriptOnly(resolved) {
        if (!resolved) {
          return void 0;
        }
        ts3.Debug.assert(ts3.extensionIsTS(resolved.extension));
        return { fileName: resolved.path, packageId: resolved.packageId };
      }
      function createResolvedModuleWithFailedLookupLocations(resolved, isExternalLibraryImport, failedLookupLocations, diagnostics, resultFromCache) {
        var _a;
        if (resultFromCache) {
          (_a = resultFromCache.failedLookupLocations).push.apply(_a, failedLookupLocations);
          return resultFromCache;
        }
        return {
          resolvedModule: resolved && { resolvedFileName: resolved.path, originalPath: resolved.originalPath === true ? void 0 : resolved.originalPath, extension: resolved.extension, isExternalLibraryImport, packageId: resolved.packageId },
          failedLookupLocations,
          resolutionDiagnostics: diagnostics
        };
      }
      function readPackageJsonField(jsonContent, fieldName, typeOfTag, state) {
        if (!ts3.hasProperty(jsonContent, fieldName)) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_does_not_have_a_0_field, fieldName);
          }
          return;
        }
        var value = jsonContent[fieldName];
        if (typeof value !== typeOfTag || value === null) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, fieldName, typeOfTag, value === null ? "null" : typeof value);
          }
          return;
        }
        return value;
      }
      function readPackageJsonPathField(jsonContent, fieldName, baseDirectory, state) {
        var fileName2 = readPackageJsonField(jsonContent, fieldName, "string", state);
        if (fileName2 === void 0) {
          return;
        }
        if (!fileName2) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_had_a_falsy_0_field, fieldName);
          }
          return;
        }
        var path2 = ts3.normalizePath(ts3.combinePaths(baseDirectory, fileName2));
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.package_json_has_0_field_1_that_references_2, fieldName, fileName2, path2);
        }
        return path2;
      }
      function readPackageJsonTypesFields(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "typings", baseDirectory, state) || readPackageJsonPathField(jsonContent, "types", baseDirectory, state);
      }
      function readPackageJsonTSConfigField(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "tsconfig", baseDirectory, state);
      }
      function readPackageJsonMainField(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "main", baseDirectory, state);
      }
      function readPackageJsonTypesVersionsField(jsonContent, state) {
        var typesVersions = readPackageJsonField(jsonContent, "typesVersions", "object", state);
        if (typesVersions === void 0)
          return;
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings);
        }
        return typesVersions;
      }
      function readPackageJsonTypesVersionPaths(jsonContent, state) {
        var typesVersions = readPackageJsonTypesVersionsField(jsonContent, state);
        if (typesVersions === void 0)
          return;
        if (state.traceEnabled) {
          for (var key in typesVersions) {
            if (ts3.hasProperty(typesVersions, key) && !ts3.VersionRange.tryParse(key)) {
              trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range, key);
            }
          }
        }
        var result2 = getPackageJsonTypesVersionsPaths(typesVersions);
        if (!result2) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0, ts3.versionMajorMinor);
          }
          return;
        }
        var bestVersionKey = result2.version, bestVersionPaths = result2.paths;
        if (typeof bestVersionPaths !== "object") {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, "typesVersions['".concat(bestVersionKey, "']"), "object", typeof bestVersionPaths);
          }
          return;
        }
        return result2;
      }
      var typeScriptVersion;
      function getPackageJsonTypesVersionsPaths(typesVersions) {
        if (!typeScriptVersion)
          typeScriptVersion = new ts3.Version(ts3.version);
        for (var key in typesVersions) {
          if (!ts3.hasProperty(typesVersions, key))
            continue;
          var keyRange = ts3.VersionRange.tryParse(key);
          if (keyRange === void 0) {
            continue;
          }
          if (keyRange.test(typeScriptVersion)) {
            return { version: key, paths: typesVersions[key] };
          }
        }
      }
      ts3.getPackageJsonTypesVersionsPaths = getPackageJsonTypesVersionsPaths;
      function getEffectiveTypeRoots(options, host) {
        if (options.typeRoots) {
          return options.typeRoots;
        }
        var currentDirectory;
        if (options.configFilePath) {
          currentDirectory = ts3.getDirectoryPath(options.configFilePath);
        } else if (host.getCurrentDirectory) {
          currentDirectory = host.getCurrentDirectory();
        }
        if (currentDirectory !== void 0) {
          return getDefaultTypeRoots(currentDirectory, host);
        }
      }
      ts3.getEffectiveTypeRoots = getEffectiveTypeRoots;
      function getDefaultTypeRoots(currentDirectory, host) {
        if (!host.directoryExists) {
          return [ts3.combinePaths(currentDirectory, nodeModulesAtTypes)];
        }
        var typeRoots;
        ts3.forEachAncestorDirectory(ts3.normalizePath(currentDirectory), function(directory) {
          var atTypes = ts3.combinePaths(directory, nodeModulesAtTypes);
          if (host.directoryExists(atTypes)) {
            (typeRoots || (typeRoots = [])).push(atTypes);
          }
          return void 0;
        });
        return typeRoots;
      }
      var nodeModulesAtTypes = ts3.combinePaths("node_modules", "@types");
      function arePathsEqual(path1, path2, host) {
        var useCaseSensitiveFileNames = typeof host.useCaseSensitiveFileNames === "function" ? host.useCaseSensitiveFileNames() : host.useCaseSensitiveFileNames;
        return ts3.comparePaths(path1, path2, !useCaseSensitiveFileNames) === 0;
      }
      function resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference, cache, resolutionMode) {
        ts3.Debug.assert(typeof typeReferenceDirectiveName === "string", "Non-string value passed to `ts.resolveTypeReferenceDirective`, likely by a wrapping package working with an outdated `resolveTypeReferenceDirectives` signature. This is probably not a problem in TS itself.");
        var traceEnabled = isTraceEnabled(options, host);
        if (redirectedReference) {
          options = redirectedReference.commandLine.options;
        }
        var containingDirectory = containingFile ? ts3.getDirectoryPath(containingFile) : void 0;
        var perFolderCache = containingDirectory ? cache && cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference) : void 0;
        var result2 = perFolderCache && perFolderCache.get(typeReferenceDirectiveName, resolutionMode);
        if (result2) {
          if (traceEnabled) {
            trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_1, typeReferenceDirectiveName, containingFile);
            if (redirectedReference)
              trace(host, ts3.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
            trace(host, ts3.Diagnostics.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1, typeReferenceDirectiveName, containingDirectory);
            traceResult(result2);
          }
          return result2;
        }
        var typeRoots = getEffectiveTypeRoots(options, host);
        if (traceEnabled) {
          if (containingFile === void 0) {
            if (typeRoots === void 0) {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set, typeReferenceDirectiveName);
            } else {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1, typeReferenceDirectiveName, typeRoots);
            }
          } else {
            if (typeRoots === void 0) {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set, typeReferenceDirectiveName, containingFile);
            } else {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2, typeReferenceDirectiveName, containingFile, typeRoots);
            }
          }
          if (redirectedReference) {
            trace(host, ts3.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
          }
        }
        var failedLookupLocations = [];
        var features = getDefaultNodeResolutionFeatures(options);
        if (resolutionMode === ts3.ModuleKind.ESNext && (ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.NodeNext)) {
          features |= NodeResolutionFeatures.EsmMode;
        }
        var conditions = features & NodeResolutionFeatures.Exports ? features & NodeResolutionFeatures.EsmMode ? ["node", "import", "types"] : ["node", "require", "types"] : [];
        var diagnostics = [];
        var moduleResolutionState = {
          compilerOptions: options,
          host,
          traceEnabled,
          failedLookupLocations,
          packageJsonInfoCache: cache,
          features,
          conditions,
          requestContainingDirectory: containingDirectory,
          reportDiagnostic: function(diag) {
            return void diagnostics.push(diag);
          }
        };
        var resolved = primaryLookup();
        var primary = true;
        if (!resolved) {
          resolved = secondaryLookup();
          primary = false;
        }
        var resolvedTypeReferenceDirective;
        if (resolved) {
          var fileName2 = resolved.fileName, packageId = resolved.packageId;
          var resolvedFileName = options.preserveSymlinks ? fileName2 : realPath(fileName2, host, traceEnabled);
          resolvedTypeReferenceDirective = {
            primary,
            resolvedFileName,
            originalPath: arePathsEqual(fileName2, resolvedFileName, host) ? void 0 : fileName2,
            packageId,
            isExternalLibraryImport: pathContainsNodeModules(fileName2)
          };
        }
        result2 = { resolvedTypeReferenceDirective, failedLookupLocations, resolutionDiagnostics: diagnostics };
        perFolderCache === null || perFolderCache === void 0 ? void 0 : perFolderCache.set(typeReferenceDirectiveName, resolutionMode, result2);
        if (traceEnabled)
          traceResult(result2);
        return result2;
        function traceResult(result3) {
          var _a;
          if (!((_a = result3.resolvedTypeReferenceDirective) === null || _a === void 0 ? void 0 : _a.resolvedFileName)) {
            trace(host, ts3.Diagnostics.Type_reference_directive_0_was_not_resolved, typeReferenceDirectiveName);
          } else if (result3.resolvedTypeReferenceDirective.packageId) {
            trace(host, ts3.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3, typeReferenceDirectiveName, result3.resolvedTypeReferenceDirective.resolvedFileName, ts3.packageIdToString(result3.resolvedTypeReferenceDirective.packageId), result3.resolvedTypeReferenceDirective.primary);
          } else {
            trace(host, ts3.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2, typeReferenceDirectiveName, result3.resolvedTypeReferenceDirective.resolvedFileName, result3.resolvedTypeReferenceDirective.primary);
          }
        }
        function primaryLookup() {
          if (typeRoots && typeRoots.length) {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Resolving_with_primary_search_path_0, typeRoots.join(", "));
            }
            return ts3.firstDefined(typeRoots, function(typeRoot) {
              var candidate = ts3.combinePaths(typeRoot, typeReferenceDirectiveName);
              var candidateDirectory = ts3.getDirectoryPath(candidate);
              var directoryExists = ts3.directoryProbablyExists(candidateDirectory, host);
              if (!directoryExists && traceEnabled) {
                trace(host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidateDirectory);
              }
              return resolvedTypeScriptOnly(loadNodeModuleFromDirectory(Extensions.DtsOnly, candidate, !directoryExists, moduleResolutionState));
            });
          } else {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths);
            }
          }
        }
        function secondaryLookup() {
          var initialLocationForSecondaryLookup = containingFile && ts3.getDirectoryPath(containingFile);
          if (initialLocationForSecondaryLookup !== void 0) {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0, initialLocationForSecondaryLookup);
            }
            var result_4;
            if (!ts3.isExternalModuleNameRelative(typeReferenceDirectiveName)) {
              var searchResult = loadModuleFromNearestNodeModulesDirectory(Extensions.DtsOnly, typeReferenceDirectiveName, initialLocationForSecondaryLookup, moduleResolutionState, void 0, void 0);
              result_4 = searchResult && searchResult.value;
            } else {
              var candidate = normalizePathForCJSResolution(initialLocationForSecondaryLookup, typeReferenceDirectiveName).path;
              result_4 = nodeLoadModuleByRelativeName(Extensions.DtsOnly, candidate, false, moduleResolutionState, true);
            }
            return resolvedTypeScriptOnly(result_4);
          } else {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder);
            }
          }
        }
      }
      ts3.resolveTypeReferenceDirective = resolveTypeReferenceDirective;
      function getDefaultNodeResolutionFeatures(options) {
        return ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.Node16 ? NodeResolutionFeatures.Node16Default : ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.NodeNext ? NodeResolutionFeatures.NodeNextDefault : NodeResolutionFeatures.None;
      }
      function resolvePackageNameToPackageJson(packageName, containingDirectory, options, host, cache) {
        var moduleResolutionState = {
          compilerOptions: options,
          host,
          traceEnabled: isTraceEnabled(options, host),
          failedLookupLocations: [],
          packageJsonInfoCache: cache === null || cache === void 0 ? void 0 : cache.getPackageJsonInfoCache(),
          conditions: ts3.emptyArray,
          features: NodeResolutionFeatures.None,
          requestContainingDirectory: containingDirectory,
          reportDiagnostic: ts3.noop
        };
        return ts3.forEachAncestorDirectory(containingDirectory, function(ancestorDirectory) {
          if (ts3.getBaseFileName(ancestorDirectory) !== "node_modules") {
            var nodeModulesFolder = ts3.combinePaths(ancestorDirectory, "node_modules");
            var candidate = ts3.combinePaths(nodeModulesFolder, packageName);
            return getPackageJsonInfo(candidate, false, moduleResolutionState);
          }
        });
      }
      ts3.resolvePackageNameToPackageJson = resolvePackageNameToPackageJson;
      function getAutomaticTypeDirectiveNames(options, host) {
        if (options.types) {
          return options.types;
        }
        var result2 = [];
        if (host.directoryExists && host.getDirectories) {
          var typeRoots = getEffectiveTypeRoots(options, host);
          if (typeRoots) {
            for (var _i = 0, typeRoots_1 = typeRoots; _i < typeRoots_1.length; _i++) {
              var root = typeRoots_1[_i];
              if (host.directoryExists(root)) {
                for (var _a = 0, _b = host.getDirectories(root); _a < _b.length; _a++) {
                  var typeDirectivePath = _b[_a];
                  var normalized = ts3.normalizePath(typeDirectivePath);
                  var packageJsonPath = ts3.combinePaths(root, normalized, "package.json");
                  var isNotNeededPackage = host.fileExists(packageJsonPath) && ts3.readJson(packageJsonPath, host).typings === null;
                  if (!isNotNeededPackage) {
                    var baseFileName = ts3.getBaseFileName(normalized);
                    if (baseFileName.charCodeAt(0) !== 46) {
                      result2.push(baseFileName);
                    }
                  }
                }
              }
            }
          }
        }
        return result2;
      }
      ts3.getAutomaticTypeDirectiveNames = getAutomaticTypeDirectiveNames;
      function createCacheWithRedirects(options) {
        var ownMap = new ts3.Map();
        var redirectsMap = new ts3.Map();
        return {
          getOwnMap,
          redirectsMap,
          getOrCreateMapOfCacheRedirects,
          clear,
          setOwnOptions,
          setOwnMap
        };
        function getOwnMap() {
          return ownMap;
        }
        function setOwnOptions(newOptions) {
          options = newOptions;
        }
        function setOwnMap(newOwnMap) {
          ownMap = newOwnMap;
        }
        function getOrCreateMapOfCacheRedirects(redirectedReference) {
          if (!redirectedReference) {
            return ownMap;
          }
          var path2 = redirectedReference.sourceFile.path;
          var redirects = redirectsMap.get(path2);
          if (!redirects) {
            redirects = !options || ts3.optionsHaveModuleResolutionChanges(options, redirectedReference.commandLine.options) ? new ts3.Map() : ownMap;
            redirectsMap.set(path2, redirects);
          }
          return redirects;
        }
        function clear() {
          ownMap.clear();
          redirectsMap.clear();
        }
      }
      ts3.createCacheWithRedirects = createCacheWithRedirects;
      function createPackageJsonInfoCache(currentDirectory, getCanonicalFileName) {
        var cache;
        return { getPackageJsonInfo: getPackageJsonInfo2, setPackageJsonInfo, clear, entries };
        function getPackageJsonInfo2(packageJsonPath) {
          return cache === null || cache === void 0 ? void 0 : cache.get(ts3.toPath(packageJsonPath, currentDirectory, getCanonicalFileName));
        }
        function setPackageJsonInfo(packageJsonPath, info) {
          (cache || (cache = new ts3.Map())).set(ts3.toPath(packageJsonPath, currentDirectory, getCanonicalFileName), info);
        }
        function clear() {
          cache = void 0;
        }
        function entries() {
          var iter = cache === null || cache === void 0 ? void 0 : cache.entries();
          return iter ? ts3.arrayFrom(iter) : [];
        }
      }
      function getOrCreateCache(cacheWithRedirects, redirectedReference, key, create) {
        var cache = cacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
        var result2 = cache.get(key);
        if (!result2) {
          result2 = create();
          cache.set(key, result2);
        }
        return result2;
      }
      function updateRedirectsMap(options, directoryToModuleNameMap, moduleNameToDirectoryMap) {
        if (!options.configFile)
          return;
        if (directoryToModuleNameMap.redirectsMap.size === 0) {
          ts3.Debug.assert(!moduleNameToDirectoryMap || moduleNameToDirectoryMap.redirectsMap.size === 0);
          ts3.Debug.assert(directoryToModuleNameMap.getOwnMap().size === 0);
          ts3.Debug.assert(!moduleNameToDirectoryMap || moduleNameToDirectoryMap.getOwnMap().size === 0);
          directoryToModuleNameMap.redirectsMap.set(options.configFile.path, directoryToModuleNameMap.getOwnMap());
          moduleNameToDirectoryMap === null || moduleNameToDirectoryMap === void 0 ? void 0 : moduleNameToDirectoryMap.redirectsMap.set(options.configFile.path, moduleNameToDirectoryMap.getOwnMap());
        } else {
          ts3.Debug.assert(!moduleNameToDirectoryMap || moduleNameToDirectoryMap.redirectsMap.size > 0);
          var ref = {
            sourceFile: options.configFile,
            commandLine: { options }
          };
          directoryToModuleNameMap.setOwnMap(directoryToModuleNameMap.getOrCreateMapOfCacheRedirects(ref));
          moduleNameToDirectoryMap === null || moduleNameToDirectoryMap === void 0 ? void 0 : moduleNameToDirectoryMap.setOwnMap(moduleNameToDirectoryMap.getOrCreateMapOfCacheRedirects(ref));
        }
        directoryToModuleNameMap.setOwnOptions(options);
        moduleNameToDirectoryMap === null || moduleNameToDirectoryMap === void 0 ? void 0 : moduleNameToDirectoryMap.setOwnOptions(options);
      }
      function createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, directoryToModuleNameMap) {
        return {
          getOrCreateCacheForDirectory,
          clear,
          update
        };
        function clear() {
          directoryToModuleNameMap.clear();
        }
        function update(options) {
          updateRedirectsMap(options, directoryToModuleNameMap);
        }
        function getOrCreateCacheForDirectory(directoryName, redirectedReference) {
          var path2 = ts3.toPath(directoryName, currentDirectory, getCanonicalFileName);
          return getOrCreateCache(directoryToModuleNameMap, redirectedReference, path2, function() {
            return createModeAwareCache();
          });
        }
      }
      function createModeAwareCache() {
        var underlying = new ts3.Map();
        var memoizedReverseKeys = new ts3.Map();
        var cache = {
          get: function(specifier, mode) {
            return underlying.get(getUnderlyingCacheKey(specifier, mode));
          },
          set: function(specifier, mode, value) {
            underlying.set(getUnderlyingCacheKey(specifier, mode), value);
            return cache;
          },
          delete: function(specifier, mode) {
            underlying.delete(getUnderlyingCacheKey(specifier, mode));
            return cache;
          },
          has: function(specifier, mode) {
            return underlying.has(getUnderlyingCacheKey(specifier, mode));
          },
          forEach: function(cb) {
            return underlying.forEach(function(elem, key) {
              var _a = memoizedReverseKeys.get(key), specifier = _a[0], mode = _a[1];
              return cb(elem, specifier, mode);
            });
          },
          size: function() {
            return underlying.size;
          }
        };
        return cache;
        function getUnderlyingCacheKey(specifier, mode) {
          var result2 = mode === void 0 ? specifier : "".concat(mode, "|").concat(specifier);
          memoizedReverseKeys.set(result2, [specifier, mode]);
          return result2;
        }
      }
      ts3.createModeAwareCache = createModeAwareCache;
      function zipToModeAwareCache(file, keys, values) {
        ts3.Debug.assert(keys.length === values.length);
        var map2 = createModeAwareCache();
        for (var i = 0; i < keys.length; ++i) {
          var entry = keys[i];
          var name = !ts3.isString(entry) ? entry.fileName.toLowerCase() : entry;
          var mode = !ts3.isString(entry) ? entry.resolutionMode || file.impliedNodeFormat : ts3.getModeForResolutionAtIndex(file, i);
          map2.set(name, mode, values[i]);
        }
        return map2;
      }
      ts3.zipToModeAwareCache = zipToModeAwareCache;
      function createModuleResolutionCache(currentDirectory, getCanonicalFileName, options, directoryToModuleNameMap, moduleNameToDirectoryMap) {
        var preDirectoryResolutionCache = createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, directoryToModuleNameMap || (directoryToModuleNameMap = createCacheWithRedirects(options)));
        moduleNameToDirectoryMap || (moduleNameToDirectoryMap = createCacheWithRedirects(options));
        var packageJsonInfoCache = createPackageJsonInfoCache(currentDirectory, getCanonicalFileName);
        return __assign(__assign(__assign({}, packageJsonInfoCache), preDirectoryResolutionCache), { getOrCreateCacheForModuleName, clear, update, getPackageJsonInfoCache: function() {
          return packageJsonInfoCache;
        } });
        function clear() {
          preDirectoryResolutionCache.clear();
          moduleNameToDirectoryMap.clear();
          packageJsonInfoCache.clear();
        }
        function update(options2) {
          updateRedirectsMap(options2, directoryToModuleNameMap, moduleNameToDirectoryMap);
        }
        function getOrCreateCacheForModuleName(nonRelativeModuleName, mode, redirectedReference) {
          ts3.Debug.assert(!ts3.isExternalModuleNameRelative(nonRelativeModuleName));
          return getOrCreateCache(moduleNameToDirectoryMap, redirectedReference, mode === void 0 ? nonRelativeModuleName : "".concat(mode, "|").concat(nonRelativeModuleName), createPerModuleNameCache);
        }
        function createPerModuleNameCache() {
          var directoryPathMap = new ts3.Map();
          return { get, set: set2 };
          function get(directory) {
            return directoryPathMap.get(ts3.toPath(directory, currentDirectory, getCanonicalFileName));
          }
          function set2(directory, result2) {
            var path2 = ts3.toPath(directory, currentDirectory, getCanonicalFileName);
            if (directoryPathMap.has(path2)) {
              return;
            }
            directoryPathMap.set(path2, result2);
            var resolvedFileName = result2.resolvedModule && (result2.resolvedModule.originalPath || result2.resolvedModule.resolvedFileName);
            var commonPrefix = resolvedFileName && getCommonPrefix(path2, resolvedFileName);
            var current = path2;
            while (current !== commonPrefix) {
              var parent = ts3.getDirectoryPath(current);
              if (parent === current || directoryPathMap.has(parent)) {
                break;
              }
              directoryPathMap.set(parent, result2);
              current = parent;
            }
          }
          function getCommonPrefix(directory, resolution) {
            var resolutionDirectory = ts3.toPath(ts3.getDirectoryPath(resolution), currentDirectory, getCanonicalFileName);
            var i = 0;
            var limit = Math.min(directory.length, resolutionDirectory.length);
            while (i < limit && directory.charCodeAt(i) === resolutionDirectory.charCodeAt(i)) {
              i++;
            }
            if (i === directory.length && (resolutionDirectory.length === i || resolutionDirectory[i] === ts3.directorySeparator)) {
              return directory;
            }
            var rootLength = ts3.getRootLength(directory);
            if (i < rootLength) {
              return void 0;
            }
            var sep = directory.lastIndexOf(ts3.directorySeparator, i - 1);
            if (sep === -1) {
              return void 0;
            }
            return directory.substr(0, Math.max(sep, rootLength));
          }
        }
      }
      ts3.createModuleResolutionCache = createModuleResolutionCache;
      function createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, options, packageJsonInfoCache, directoryToModuleNameMap) {
        var preDirectoryResolutionCache = createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, directoryToModuleNameMap || (directoryToModuleNameMap = createCacheWithRedirects(options)));
        packageJsonInfoCache || (packageJsonInfoCache = createPackageJsonInfoCache(currentDirectory, getCanonicalFileName));
        return __assign(__assign(__assign({}, packageJsonInfoCache), preDirectoryResolutionCache), { clear });
        function clear() {
          preDirectoryResolutionCache.clear();
          packageJsonInfoCache.clear();
        }
      }
      ts3.createTypeReferenceDirectiveResolutionCache = createTypeReferenceDirectiveResolutionCache;
      function resolveModuleNameFromCache(moduleName, containingFile, cache, mode) {
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var perFolderCache = cache && cache.getOrCreateCacheForDirectory(containingDirectory);
        if (!perFolderCache)
          return void 0;
        return perFolderCache.get(moduleName, mode);
      }
      ts3.resolveModuleNameFromCache = resolveModuleNameFromCache;
      function resolveModuleName(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        if (redirectedReference) {
          compilerOptions = redirectedReference.commandLine.options;
        }
        if (traceEnabled) {
          trace(host, ts3.Diagnostics.Resolving_module_0_from_1, moduleName, containingFile);
          if (redirectedReference) {
            trace(host, ts3.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
          }
        }
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var perFolderCache = cache && cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference);
        var result2 = perFolderCache && perFolderCache.get(moduleName, resolutionMode);
        if (result2) {
          if (traceEnabled) {
            trace(host, ts3.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
          }
        } else {
          var moduleResolution = compilerOptions.moduleResolution;
          if (moduleResolution === void 0) {
            switch (ts3.getEmitModuleKind(compilerOptions)) {
              case ts3.ModuleKind.CommonJS:
                moduleResolution = ts3.ModuleResolutionKind.NodeJs;
                break;
              case ts3.ModuleKind.Node16:
                moduleResolution = ts3.ModuleResolutionKind.Node16;
                break;
              case ts3.ModuleKind.NodeNext:
                moduleResolution = ts3.ModuleResolutionKind.NodeNext;
                break;
              default:
                moduleResolution = ts3.ModuleResolutionKind.Classic;
                break;
            }
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Module_resolution_kind_is_not_specified_using_0, ts3.ModuleResolutionKind[moduleResolution]);
            }
          } else {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0, ts3.ModuleResolutionKind[moduleResolution]);
            }
          }
          ts3.perfLogger.logStartResolveModule(moduleName);
          switch (moduleResolution) {
            case ts3.ModuleResolutionKind.Node16:
              result2 = node16ModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode);
              break;
            case ts3.ModuleResolutionKind.NodeNext:
              result2 = nodeNextModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode);
              break;
            case ts3.ModuleResolutionKind.NodeJs:
              result2 = nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
              break;
            case ts3.ModuleResolutionKind.Classic:
              result2 = classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
              break;
            default:
              return ts3.Debug.fail("Unexpected moduleResolution: ".concat(moduleResolution));
          }
          if (result2 && result2.resolvedModule)
            ts3.perfLogger.logInfoEvent('Module "'.concat(moduleName, '" resolved to "').concat(result2.resolvedModule.resolvedFileName, '"'));
          ts3.perfLogger.logStopResolveModule(result2 && result2.resolvedModule ? "" + result2.resolvedModule.resolvedFileName : "null");
          if (perFolderCache) {
            perFolderCache.set(moduleName, resolutionMode, result2);
            if (!ts3.isExternalModuleNameRelative(moduleName)) {
              cache.getOrCreateCacheForModuleName(moduleName, resolutionMode, redirectedReference).set(containingDirectory, result2);
            }
          }
        }
        if (traceEnabled) {
          if (result2.resolvedModule) {
            if (result2.resolvedModule.packageId) {
              trace(host, ts3.Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2, moduleName, result2.resolvedModule.resolvedFileName, ts3.packageIdToString(result2.resolvedModule.packageId));
            } else {
              trace(host, ts3.Diagnostics.Module_name_0_was_successfully_resolved_to_1, moduleName, result2.resolvedModule.resolvedFileName);
            }
          } else {
            trace(host, ts3.Diagnostics.Module_name_0_was_not_resolved, moduleName);
          }
        }
        return result2;
      }
      ts3.resolveModuleName = resolveModuleName;
      function tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loader2, state) {
        var resolved = tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader2, state);
        if (resolved)
          return resolved.value;
        if (!ts3.isExternalModuleNameRelative(moduleName)) {
          return tryLoadModuleUsingBaseUrl(extensions, moduleName, loader2, state);
        } else {
          return tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader2, state);
        }
      }
      function tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader2, state) {
        var _a;
        var _b = state.compilerOptions, baseUrl = _b.baseUrl, paths = _b.paths, configFile = _b.configFile;
        if (paths && !ts3.pathIsRelative(moduleName)) {
          if (state.traceEnabled) {
            if (baseUrl) {
              trace(state.host, ts3.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
            }
            trace(state.host, ts3.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0, moduleName);
          }
          var baseDirectory = ts3.getPathsBasePath(state.compilerOptions, state.host);
          var pathPatterns = (configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) ? (_a = configFile.configFileSpecs).pathPatterns || (_a.pathPatterns = ts3.tryParsePatterns(paths)) : void 0;
          return tryLoadModuleUsingPaths(extensions, moduleName, baseDirectory, paths, pathPatterns, loader2, false, state);
        }
      }
      function tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader2, state) {
        if (!state.compilerOptions.rootDirs) {
          return void 0;
        }
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0, moduleName);
        }
        var candidate = ts3.normalizePath(ts3.combinePaths(containingDirectory, moduleName));
        var matchedRootDir;
        var matchedNormalizedPrefix;
        for (var _i = 0, _a = state.compilerOptions.rootDirs; _i < _a.length; _i++) {
          var rootDir = _a[_i];
          var normalizedRoot = ts3.normalizePath(rootDir);
          if (!ts3.endsWith(normalizedRoot, ts3.directorySeparator)) {
            normalizedRoot += ts3.directorySeparator;
          }
          var isLongestMatchingPrefix = ts3.startsWith(candidate, normalizedRoot) && (matchedNormalizedPrefix === void 0 || matchedNormalizedPrefix.length < normalizedRoot.length);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2, normalizedRoot, candidate, isLongestMatchingPrefix);
          }
          if (isLongestMatchingPrefix) {
            matchedNormalizedPrefix = normalizedRoot;
            matchedRootDir = rootDir;
          }
        }
        if (matchedNormalizedPrefix) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Longest_matching_prefix_for_0_is_1, candidate, matchedNormalizedPrefix);
          }
          var suffix = candidate.substr(matchedNormalizedPrefix.length);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, matchedNormalizedPrefix, candidate);
          }
          var resolvedFileName = loader2(extensions, candidate, !ts3.directoryProbablyExists(containingDirectory, state.host), state);
          if (resolvedFileName) {
            return resolvedFileName;
          }
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Trying_other_entries_in_rootDirs);
          }
          for (var _b = 0, _c = state.compilerOptions.rootDirs; _b < _c.length; _b++) {
            var rootDir = _c[_b];
            if (rootDir === matchedRootDir) {
              continue;
            }
            var candidate_1 = ts3.combinePaths(ts3.normalizePath(rootDir), suffix);
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, rootDir, candidate_1);
            }
            var baseDirectory = ts3.getDirectoryPath(candidate_1);
            var resolvedFileName_1 = loader2(extensions, candidate_1, !ts3.directoryProbablyExists(baseDirectory, state.host), state);
            if (resolvedFileName_1) {
              return resolvedFileName_1;
            }
          }
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Module_resolution_using_rootDirs_has_failed);
          }
        }
        return void 0;
      }
      function tryLoadModuleUsingBaseUrl(extensions, moduleName, loader2, state) {
        var baseUrl = state.compilerOptions.baseUrl;
        if (!baseUrl) {
          return void 0;
        }
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
        }
        var candidate = ts3.normalizePath(ts3.combinePaths(baseUrl, moduleName));
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2, moduleName, baseUrl, candidate);
        }
        return loader2(extensions, candidate, !ts3.directoryProbablyExists(ts3.getDirectoryPath(candidate), state.host), state);
      }
      function resolveJSModule(moduleName, initialDir, host) {
        var _a = tryResolveJSModuleWorker(moduleName, initialDir, host), resolvedModule = _a.resolvedModule, failedLookupLocations = _a.failedLookupLocations;
        if (!resolvedModule) {
          throw new Error("Could not resolve JS module '".concat(moduleName, "' starting at '").concat(initialDir, "'. Looked in: ").concat(failedLookupLocations.join(", ")));
        }
        return resolvedModule.resolvedFileName;
      }
      ts3.resolveJSModule = resolveJSModule;
      var NodeResolutionFeatures;
      (function(NodeResolutionFeatures2) {
        NodeResolutionFeatures2[NodeResolutionFeatures2["None"] = 0] = "None";
        NodeResolutionFeatures2[NodeResolutionFeatures2["Imports"] = 2] = "Imports";
        NodeResolutionFeatures2[NodeResolutionFeatures2["SelfName"] = 4] = "SelfName";
        NodeResolutionFeatures2[NodeResolutionFeatures2["Exports"] = 8] = "Exports";
        NodeResolutionFeatures2[NodeResolutionFeatures2["ExportsPatternTrailers"] = 16] = "ExportsPatternTrailers";
        NodeResolutionFeatures2[NodeResolutionFeatures2["AllFeatures"] = 30] = "AllFeatures";
        NodeResolutionFeatures2[NodeResolutionFeatures2["Node16Default"] = 30] = "Node16Default";
        NodeResolutionFeatures2[NodeResolutionFeatures2["NodeNextDefault"] = 30] = "NodeNextDefault";
        NodeResolutionFeatures2[NodeResolutionFeatures2["EsmMode"] = 32] = "EsmMode";
      })(NodeResolutionFeatures || (NodeResolutionFeatures = {}));
      function node16ModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
        return nodeNextModuleNameResolverWorker(NodeResolutionFeatures.Node16Default, moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode);
      }
      function nodeNextModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
        return nodeNextModuleNameResolverWorker(NodeResolutionFeatures.NodeNextDefault, moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode);
      }
      var jsOnlyExtensions = [Extensions.JavaScript];
      var tsExtensions = [Extensions.TypeScript, Extensions.JavaScript];
      var tsPlusJsonExtensions = __spreadArray(__spreadArray([], tsExtensions, true), [Extensions.Json], false);
      var tsconfigExtensions = [Extensions.TSConfig];
      function nodeNextModuleNameResolverWorker(features, moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var esmMode = resolutionMode === ts3.ModuleKind.ESNext ? NodeResolutionFeatures.EsmMode : 0;
        var extensions = compilerOptions.noDtsResolution ? [Extensions.TsOnly, Extensions.JavaScript] : tsExtensions;
        if (compilerOptions.resolveJsonModule) {
          extensions = __spreadArray(__spreadArray([], extensions, true), [Extensions.Json], false);
        }
        return nodeModuleNameResolverWorker(features | esmMode, moduleName, containingDirectory, compilerOptions, host, cache, extensions, redirectedReference);
      }
      function tryResolveJSModuleWorker(moduleName, initialDir, host) {
        return nodeModuleNameResolverWorker(NodeResolutionFeatures.None, moduleName, initialDir, { moduleResolution: ts3.ModuleResolutionKind.NodeJs, allowJs: true }, host, void 0, jsOnlyExtensions, void 0);
      }
      function nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, lookupConfig) {
        var extensions;
        if (lookupConfig) {
          extensions = tsconfigExtensions;
        } else if (compilerOptions.noDtsResolution) {
          extensions = [Extensions.TsOnly];
          if (compilerOptions.allowJs)
            extensions.push(Extensions.JavaScript);
          if (compilerOptions.resolveJsonModule)
            extensions.push(Extensions.Json);
        } else {
          extensions = compilerOptions.resolveJsonModule ? tsPlusJsonExtensions : tsExtensions;
        }
        return nodeModuleNameResolverWorker(NodeResolutionFeatures.None, moduleName, ts3.getDirectoryPath(containingFile), compilerOptions, host, cache, extensions, redirectedReference);
      }
      ts3.nodeModuleNameResolver = nodeModuleNameResolver;
      function nodeModuleNameResolverWorker(features, moduleName, containingDirectory, compilerOptions, host, cache, extensions, redirectedReference) {
        var _a, _b;
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        var failedLookupLocations = [];
        var conditions = features & NodeResolutionFeatures.EsmMode ? ["node", "import", "types"] : ["node", "require", "types"];
        if (compilerOptions.noDtsResolution) {
          conditions.pop();
        }
        var diagnostics = [];
        var state = {
          compilerOptions,
          host,
          traceEnabled,
          failedLookupLocations,
          packageJsonInfoCache: cache,
          features,
          conditions,
          requestContainingDirectory: containingDirectory,
          reportDiagnostic: function(diag) {
            return void diagnostics.push(diag);
          }
        };
        var result2 = ts3.forEach(extensions, function(ext) {
          return tryResolve(ext);
        });
        return createResolvedModuleWithFailedLookupLocations((_a = result2 === null || result2 === void 0 ? void 0 : result2.value) === null || _a === void 0 ? void 0 : _a.resolved, (_b = result2 === null || result2 === void 0 ? void 0 : result2.value) === null || _b === void 0 ? void 0 : _b.isExternalLibraryImport, failedLookupLocations, diagnostics, state.resultFromCache);
        function tryResolve(extensions2) {
          var loader2 = function(extensions3, candidate2, onlyRecordFailures, state2) {
            return nodeLoadModuleByRelativeName(extensions3, candidate2, onlyRecordFailures, state2, true);
          };
          var resolved = tryLoadModuleUsingOptionalResolutionSettings(extensions2, moduleName, containingDirectory, loader2, state);
          if (resolved) {
            return toSearchResult({ resolved, isExternalLibraryImport: pathContainsNodeModules(resolved.path) });
          }
          if (!ts3.isExternalModuleNameRelative(moduleName)) {
            var resolved_1;
            if (features & NodeResolutionFeatures.Imports && ts3.startsWith(moduleName, "#")) {
              resolved_1 = loadModuleFromImports(extensions2, moduleName, containingDirectory, state, cache, redirectedReference);
            }
            if (!resolved_1 && features & NodeResolutionFeatures.SelfName) {
              resolved_1 = loadModuleFromSelfNameReference(extensions2, moduleName, containingDirectory, state, cache, redirectedReference);
            }
            if (!resolved_1) {
              if (traceEnabled) {
                trace(host, ts3.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1, moduleName, Extensions[extensions2]);
              }
              resolved_1 = loadModuleFromNearestNodeModulesDirectory(extensions2, moduleName, containingDirectory, state, cache, redirectedReference);
            }
            if (!resolved_1)
              return void 0;
            var resolvedValue = resolved_1.value;
            if (!compilerOptions.preserveSymlinks && resolvedValue && !resolvedValue.originalPath) {
              var path2 = realPath(resolvedValue.path, host, traceEnabled);
              var originalPath = arePathsEqual(path2, resolvedValue.path, host) ? void 0 : resolvedValue.path;
              resolvedValue = __assign(__assign({}, resolvedValue), { path: path2, originalPath });
            }
            return { value: resolvedValue && { resolved: resolvedValue, isExternalLibraryImport: true } };
          } else {
            var _a2 = normalizePathForCJSResolution(containingDirectory, moduleName), candidate = _a2.path, parts = _a2.parts;
            var resolved_2 = nodeLoadModuleByRelativeName(extensions2, candidate, false, state, true);
            return resolved_2 && toSearchResult({ resolved: resolved_2, isExternalLibraryImport: ts3.contains(parts, "node_modules") });
          }
        }
      }
      function normalizePathForCJSResolution(containingDirectory, moduleName) {
        var combined = ts3.combinePaths(containingDirectory, moduleName);
        var parts = ts3.getPathComponents(combined);
        var lastPart = ts3.lastOrUndefined(parts);
        var path2 = lastPart === "." || lastPart === ".." ? ts3.ensureTrailingDirectorySeparator(ts3.normalizePath(combined)) : ts3.normalizePath(combined);
        return { path: path2, parts };
      }
      function realPath(path2, host, traceEnabled) {
        if (!host.realpath) {
          return path2;
        }
        var real = ts3.normalizePath(host.realpath(path2));
        if (traceEnabled) {
          trace(host, ts3.Diagnostics.Resolving_real_path_for_0_result_1, path2, real);
        }
        ts3.Debug.assert(host.fileExists(real), "".concat(path2, " linked to nonexistent file ").concat(real));
        return real;
      }
      function nodeLoadModuleByRelativeName(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1, candidate, Extensions[extensions]);
        }
        if (!ts3.hasTrailingDirectorySeparator(candidate)) {
          if (!onlyRecordFailures) {
            var parentOfCandidate = ts3.getDirectoryPath(candidate);
            if (!ts3.directoryProbablyExists(parentOfCandidate, state.host)) {
              if (state.traceEnabled) {
                trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, parentOfCandidate);
              }
              onlyRecordFailures = true;
            }
          }
          var resolvedFromFile = loadModuleFromFile(extensions, candidate, onlyRecordFailures, state);
          if (resolvedFromFile) {
            var packageDirectory = considerPackageJson ? parseNodeModuleFromPath(resolvedFromFile.path) : void 0;
            var packageInfo = packageDirectory ? getPackageJsonInfo(packageDirectory, false, state) : void 0;
            return withPackageId(packageInfo, resolvedFromFile);
          }
        }
        if (!onlyRecordFailures) {
          var candidateExists = ts3.directoryProbablyExists(candidate, state.host);
          if (!candidateExists) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidate);
            }
            onlyRecordFailures = true;
          }
        }
        if (!(state.features & NodeResolutionFeatures.EsmMode)) {
          return loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson);
        }
        return void 0;
      }
      ts3.nodeModulesPathPart = "/node_modules/";
      function pathContainsNodeModules(path2) {
        return ts3.stringContains(path2, ts3.nodeModulesPathPart);
      }
      ts3.pathContainsNodeModules = pathContainsNodeModules;
      function parseNodeModuleFromPath(resolved) {
        var path2 = ts3.normalizePath(resolved);
        var idx2 = path2.lastIndexOf(ts3.nodeModulesPathPart);
        if (idx2 === -1) {
          return void 0;
        }
        var indexAfterNodeModules = idx2 + ts3.nodeModulesPathPart.length;
        var indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path2, indexAfterNodeModules);
        if (path2.charCodeAt(indexAfterNodeModules) === 64) {
          indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path2, indexAfterPackageName);
        }
        return path2.slice(0, indexAfterPackageName);
      }
      ts3.parseNodeModuleFromPath = parseNodeModuleFromPath;
      function moveToNextDirectorySeparatorIfAvailable(path2, prevSeparatorIndex) {
        var nextSeparatorIndex = path2.indexOf(ts3.directorySeparator, prevSeparatorIndex + 1);
        return nextSeparatorIndex === -1 ? prevSeparatorIndex : nextSeparatorIndex;
      }
      function loadModuleFromFileNoPackageId(extensions, candidate, onlyRecordFailures, state) {
        return noPackageId(loadModuleFromFile(extensions, candidate, onlyRecordFailures, state));
      }
      function loadModuleFromFile(extensions, candidate, onlyRecordFailures, state) {
        if (extensions === Extensions.Json || extensions === Extensions.TSConfig) {
          var extensionLess = ts3.tryRemoveExtension(candidate, ".json");
          var extension = extensionLess ? candidate.substring(extensionLess.length) : "";
          return extensionLess === void 0 && extensions === Extensions.Json ? void 0 : tryAddingExtensions(extensionLess || candidate, extensions, extension, onlyRecordFailures, state);
        }
        if (!(state.features & NodeResolutionFeatures.EsmMode)) {
          var resolvedByAddingExtension = tryAddingExtensions(candidate, extensions, "", onlyRecordFailures, state);
          if (resolvedByAddingExtension) {
            return resolvedByAddingExtension;
          }
        }
        return loadModuleFromFileNoImplicitExtensions(extensions, candidate, onlyRecordFailures, state);
      }
      function loadModuleFromFileNoImplicitExtensions(extensions, candidate, onlyRecordFailures, state) {
        if (ts3.hasJSFileExtension(candidate) || ts3.fileExtensionIs(candidate, ".json") && state.compilerOptions.resolveJsonModule) {
          var extensionless = ts3.removeFileExtension(candidate);
          var extension = candidate.substring(extensionless.length);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.File_name_0_has_a_1_extension_stripping_it, candidate, extension);
          }
          return tryAddingExtensions(extensionless, extensions, extension, onlyRecordFailures, state);
        }
      }
      function loadJSOrExactTSFileName(extensions, candidate, onlyRecordFailures, state) {
        if ((extensions === Extensions.TypeScript || extensions === Extensions.DtsOnly) && ts3.fileExtensionIsOneOf(candidate, ts3.supportedTSExtensionsFlat)) {
          var result2 = tryFile(candidate, onlyRecordFailures, state);
          return result2 !== void 0 ? { path: candidate, ext: ts3.tryExtractTSExtension(candidate) } : void 0;
        }
        return loadModuleFromFileNoImplicitExtensions(extensions, candidate, onlyRecordFailures, state);
      }
      function tryAddingExtensions(candidate, extensions, originalExtension, onlyRecordFailures, state) {
        if (!onlyRecordFailures) {
          var directory = ts3.getDirectoryPath(candidate);
          if (directory) {
            onlyRecordFailures = !ts3.directoryProbablyExists(directory, state.host);
          }
        }
        switch (extensions) {
          case Extensions.DtsOnly:
            switch (originalExtension) {
              case ".mjs":
              case ".mts":
              case ".d.mts":
                return tryExtension(".d.mts");
              case ".cjs":
              case ".cts":
              case ".d.cts":
                return tryExtension(".d.cts");
              case ".json":
                candidate += ".json";
                return tryExtension(".d.ts");
              default:
                return tryExtension(".d.ts");
            }
          case Extensions.TypeScript:
          case Extensions.TsOnly:
            var useDts = extensions === Extensions.TypeScript;
            switch (originalExtension) {
              case ".mjs":
              case ".mts":
              case ".d.mts":
                return tryExtension(".mts") || (useDts ? tryExtension(".d.mts") : void 0);
              case ".cjs":
              case ".cts":
              case ".d.cts":
                return tryExtension(".cts") || (useDts ? tryExtension(".d.cts") : void 0);
              case ".json":
                candidate += ".json";
                return useDts ? tryExtension(".d.ts") : void 0;
              default:
                return tryExtension(".ts") || tryExtension(".tsx") || (useDts ? tryExtension(".d.ts") : void 0);
            }
          case Extensions.JavaScript:
            switch (originalExtension) {
              case ".mjs":
              case ".mts":
              case ".d.mts":
                return tryExtension(".mjs");
              case ".cjs":
              case ".cts":
              case ".d.cts":
                return tryExtension(".cjs");
              case ".json":
                return tryExtension(".json");
              default:
                return tryExtension(".js") || tryExtension(".jsx");
            }
          case Extensions.TSConfig:
          case Extensions.Json:
            return tryExtension(".json");
        }
        function tryExtension(ext) {
          var path2 = tryFile(candidate + ext, onlyRecordFailures, state);
          return path2 === void 0 ? void 0 : { path: path2, ext };
        }
      }
      function tryFile(fileName2, onlyRecordFailures, state) {
        var _a, _b;
        if (!((_a = state.compilerOptions.moduleSuffixes) === null || _a === void 0 ? void 0 : _a.length)) {
          return tryFileLookup(fileName2, onlyRecordFailures, state);
        }
        var ext = (_b = ts3.tryGetExtensionFromPath(fileName2)) !== null && _b !== void 0 ? _b : "";
        var fileNameNoExtension = ext ? ts3.removeExtension(fileName2, ext) : fileName2;
        return ts3.forEach(state.compilerOptions.moduleSuffixes, function(suffix) {
          return tryFileLookup(fileNameNoExtension + suffix + ext, onlyRecordFailures, state);
        });
      }
      function tryFileLookup(fileName2, onlyRecordFailures, state) {
        if (!onlyRecordFailures) {
          if (state.host.fileExists(fileName2)) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result, fileName2);
            }
            return fileName2;
          } else {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.File_0_does_not_exist, fileName2);
            }
          }
        }
        state.failedLookupLocations.push(fileName2);
        return void 0;
      }
      function loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
        if (considerPackageJson === void 0) {
          considerPackageJson = true;
        }
        var packageInfo = considerPackageJson ? getPackageJsonInfo(candidate, onlyRecordFailures, state) : void 0;
        var packageJsonContent = packageInfo && packageInfo.packageJsonContent;
        var versionPaths = packageInfo && packageInfo.versionPaths;
        return withPackageId(packageInfo, loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, packageJsonContent, versionPaths));
      }
      function getEntrypointsFromPackageJsonInfo(packageJsonInfo, options, host, cache, resolveJs) {
        if (!resolveJs && packageJsonInfo.resolvedEntrypoints !== void 0) {
          return packageJsonInfo.resolvedEntrypoints;
        }
        var entrypoints;
        var extensions = resolveJs ? Extensions.JavaScript : Extensions.TypeScript;
        var features = getDefaultNodeResolutionFeatures(options);
        var requireState = {
          compilerOptions: options,
          host,
          traceEnabled: isTraceEnabled(options, host),
          failedLookupLocations: [],
          packageJsonInfoCache: cache === null || cache === void 0 ? void 0 : cache.getPackageJsonInfoCache(),
          conditions: ["node", "require", "types"],
          features,
          requestContainingDirectory: packageJsonInfo.packageDirectory,
          reportDiagnostic: ts3.noop
        };
        var requireResolution = loadNodeModuleFromDirectoryWorker(extensions, packageJsonInfo.packageDirectory, false, requireState, packageJsonInfo.packageJsonContent, packageJsonInfo.versionPaths);
        entrypoints = ts3.append(entrypoints, requireResolution === null || requireResolution === void 0 ? void 0 : requireResolution.path);
        if (features & NodeResolutionFeatures.Exports && packageJsonInfo.packageJsonContent.exports) {
          for (var _i = 0, _a = [["node", "import", "types"], ["node", "require", "types"]]; _i < _a.length; _i++) {
            var conditions = _a[_i];
            var exportState = __assign(__assign({}, requireState), { failedLookupLocations: [], conditions });
            var exportResolutions = loadEntrypointsFromExportMap(packageJsonInfo, packageJsonInfo.packageJsonContent.exports, exportState, extensions);
            if (exportResolutions) {
              for (var _b = 0, exportResolutions_1 = exportResolutions; _b < exportResolutions_1.length; _b++) {
                var resolution = exportResolutions_1[_b];
                entrypoints = ts3.appendIfUnique(entrypoints, resolution.path);
              }
            }
          }
        }
        return packageJsonInfo.resolvedEntrypoints = entrypoints || false;
      }
      ts3.getEntrypointsFromPackageJsonInfo = getEntrypointsFromPackageJsonInfo;
      function loadEntrypointsFromExportMap(scope, exports2, state, extensions) {
        var entrypoints;
        if (ts3.isArray(exports2)) {
          for (var _i = 0, exports_1 = exports2; _i < exports_1.length; _i++) {
            var target = exports_1[_i];
            loadEntrypointsFromTargetExports(target);
          }
        } else if (typeof exports2 === "object" && exports2 !== null && allKeysStartWithDot(exports2)) {
          for (var key in exports2) {
            loadEntrypointsFromTargetExports(exports2[key]);
          }
        } else {
          loadEntrypointsFromTargetExports(exports2);
        }
        return entrypoints;
        function loadEntrypointsFromTargetExports(target2) {
          var _a, _b;
          if (typeof target2 === "string" && ts3.startsWith(target2, "./") && target2.indexOf("*") === -1) {
            var partsAfterFirst = ts3.getPathComponents(target2).slice(2);
            if (partsAfterFirst.indexOf("..") >= 0 || partsAfterFirst.indexOf(".") >= 0 || partsAfterFirst.indexOf("node_modules") >= 0) {
              return false;
            }
            var resolvedTarget = ts3.combinePaths(scope.packageDirectory, target2);
            var finalPath = ts3.getNormalizedAbsolutePath(resolvedTarget, (_b = (_a = state.host).getCurrentDirectory) === null || _b === void 0 ? void 0 : _b.call(_a));
            var result2 = loadJSOrExactTSFileName(extensions, finalPath, false, state);
            if (result2) {
              entrypoints = ts3.appendIfUnique(entrypoints, result2, function(a, b) {
                return a.path === b.path;
              });
              return true;
            }
          } else if (Array.isArray(target2)) {
            for (var _i2 = 0, target_1 = target2; _i2 < target_1.length; _i2++) {
              var t = target_1[_i2];
              var success = loadEntrypointsFromTargetExports(t);
              if (success) {
                return true;
              }
            }
          } else if (typeof target2 === "object" && target2 !== null) {
            return ts3.forEach(ts3.getOwnKeys(target2), function(key2) {
              if (key2 === "default" || ts3.contains(state.conditions, key2) || isApplicableVersionedTypesKey(state.conditions, key2)) {
                loadEntrypointsFromTargetExports(target2[key2]);
                return true;
              }
            });
          }
        }
      }
      function getPackageScopeForPath(fileName2, packageJsonInfoCache, host, options) {
        var state = {
          host,
          compilerOptions: options,
          traceEnabled: isTraceEnabled(options, host),
          failedLookupLocations: [],
          packageJsonInfoCache,
          features: 0,
          conditions: [],
          requestContainingDirectory: void 0,
          reportDiagnostic: ts3.noop
        };
        var parts = ts3.getPathComponents(fileName2);
        parts.pop();
        while (parts.length > 0) {
          var pkg = getPackageJsonInfo(ts3.getPathFromPathComponents(parts), false, state);
          if (pkg) {
            return pkg;
          }
          parts.pop();
        }
        return void 0;
      }
      ts3.getPackageScopeForPath = getPackageScopeForPath;
      function getPackageJsonInfo(packageDirectory, onlyRecordFailures, state) {
        var _a, _b, _c;
        var host = state.host, traceEnabled = state.traceEnabled;
        var packageJsonPath = ts3.combinePaths(packageDirectory, "package.json");
        if (onlyRecordFailures) {
          state.failedLookupLocations.push(packageJsonPath);
          return void 0;
        }
        var existing = (_a = state.packageJsonInfoCache) === null || _a === void 0 ? void 0 : _a.getPackageJsonInfo(packageJsonPath);
        if (existing !== void 0) {
          if (typeof existing !== "boolean") {
            if (traceEnabled)
              trace(host, ts3.Diagnostics.File_0_exists_according_to_earlier_cached_lookups, packageJsonPath);
            return existing;
          } else {
            if (existing && traceEnabled)
              trace(host, ts3.Diagnostics.File_0_does_not_exist_according_to_earlier_cached_lookups, packageJsonPath);
            state.failedLookupLocations.push(packageJsonPath);
            return void 0;
          }
        }
        var directoryExists = ts3.directoryProbablyExists(packageDirectory, host);
        if (directoryExists && host.fileExists(packageJsonPath)) {
          var packageJsonContent = ts3.readJson(packageJsonPath, host);
          if (traceEnabled) {
            trace(host, ts3.Diagnostics.Found_package_json_at_0, packageJsonPath);
          }
          var versionPaths = readPackageJsonTypesVersionPaths(packageJsonContent, state);
          var result2 = { packageDirectory, packageJsonContent, versionPaths, resolvedEntrypoints: void 0 };
          (_b = state.packageJsonInfoCache) === null || _b === void 0 ? void 0 : _b.setPackageJsonInfo(packageJsonPath, result2);
          return result2;
        } else {
          if (directoryExists && traceEnabled) {
            trace(host, ts3.Diagnostics.File_0_does_not_exist, packageJsonPath);
          }
          (_c = state.packageJsonInfoCache) === null || _c === void 0 ? void 0 : _c.setPackageJsonInfo(packageJsonPath, directoryExists);
          state.failedLookupLocations.push(packageJsonPath);
        }
      }
      ts3.getPackageJsonInfo = getPackageJsonInfo;
      function loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, jsonContent, versionPaths) {
        var packageFile;
        if (jsonContent) {
          switch (extensions) {
            case Extensions.JavaScript:
            case Extensions.Json:
            case Extensions.TsOnly:
              packageFile = readPackageJsonMainField(jsonContent, candidate, state);
              break;
            case Extensions.TypeScript:
              packageFile = readPackageJsonTypesFields(jsonContent, candidate, state) || readPackageJsonMainField(jsonContent, candidate, state);
              break;
            case Extensions.DtsOnly:
              packageFile = readPackageJsonTypesFields(jsonContent, candidate, state);
              break;
            case Extensions.TSConfig:
              packageFile = readPackageJsonTSConfigField(jsonContent, candidate, state);
              break;
            default:
              return ts3.Debug.assertNever(extensions);
          }
        }
        var loader2 = function(extensions2, candidate2, onlyRecordFailures2, state2) {
          var fromFile = tryFile(candidate2, onlyRecordFailures2, state2);
          if (fromFile) {
            var resolved = resolvedIfExtensionMatches(extensions2, fromFile);
            if (resolved) {
              return noPackageId(resolved);
            }
            if (state2.traceEnabled) {
              trace(state2.host, ts3.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it, fromFile);
            }
          }
          var nextExtensions = extensions2 === Extensions.DtsOnly ? Extensions.TypeScript : extensions2;
          var features = state2.features;
          if ((jsonContent === null || jsonContent === void 0 ? void 0 : jsonContent.type) !== "module") {
            state2.features &= ~NodeResolutionFeatures.EsmMode;
          }
          var result3 = nodeLoadModuleByRelativeName(nextExtensions, candidate2, onlyRecordFailures2, state2, false);
          state2.features = features;
          return result3;
        };
        var onlyRecordFailuresForPackageFile = packageFile ? !ts3.directoryProbablyExists(ts3.getDirectoryPath(packageFile), state.host) : void 0;
        var onlyRecordFailuresForIndex = onlyRecordFailures || !ts3.directoryProbablyExists(candidate, state.host);
        var indexPath = ts3.combinePaths(candidate, extensions === Extensions.TSConfig ? "tsconfig" : "index");
        if (versionPaths && (!packageFile || ts3.containsPath(candidate, packageFile))) {
          var moduleName = ts3.getRelativePathFromDirectory(candidate, packageFile || indexPath, false);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, versionPaths.version, ts3.version, moduleName);
          }
          var result2 = tryLoadModuleUsingPaths(extensions, moduleName, candidate, versionPaths.paths, void 0, loader2, onlyRecordFailuresForPackageFile || onlyRecordFailuresForIndex, state);
          if (result2) {
            return removeIgnoredPackageId(result2.value);
          }
        }
        var packageFileResult = packageFile && removeIgnoredPackageId(loader2(extensions, packageFile, onlyRecordFailuresForPackageFile, state));
        if (packageFileResult)
          return packageFileResult;
        if (!(state.features & NodeResolutionFeatures.EsmMode)) {
          return loadModuleFromFile(extensions, indexPath, onlyRecordFailuresForIndex, state);
        }
      }
      function resolvedIfExtensionMatches(extensions, path2) {
        var ext = ts3.tryGetExtensionFromPath(path2);
        return ext !== void 0 && extensionIsOk(extensions, ext) ? { path: path2, ext } : void 0;
      }
      function extensionIsOk(extensions, extension) {
        switch (extensions) {
          case Extensions.JavaScript:
            return extension === ".js" || extension === ".jsx" || extension === ".mjs" || extension === ".cjs";
          case Extensions.TSConfig:
          case Extensions.Json:
            return extension === ".json";
          case Extensions.TypeScript:
            return extension === ".ts" || extension === ".tsx" || extension === ".mts" || extension === ".cts" || extension === ".d.ts" || extension === ".d.mts" || extension === ".d.cts";
          case Extensions.TsOnly:
            return extension === ".ts" || extension === ".tsx" || extension === ".mts" || extension === ".cts";
          case Extensions.DtsOnly:
            return extension === ".d.ts" || extension === ".d.mts" || extension === ".d.cts";
        }
      }
      function parsePackageName(moduleName) {
        var idx2 = moduleName.indexOf(ts3.directorySeparator);
        if (moduleName[0] === "@") {
          idx2 = moduleName.indexOf(ts3.directorySeparator, idx2 + 1);
        }
        return idx2 === -1 ? { packageName: moduleName, rest: "" } : { packageName: moduleName.slice(0, idx2), rest: moduleName.slice(idx2 + 1) };
      }
      ts3.parsePackageName = parsePackageName;
      function allKeysStartWithDot(obj) {
        return ts3.every(ts3.getOwnKeys(obj), function(k) {
          return ts3.startsWith(k, ".");
        });
      }
      ts3.allKeysStartWithDot = allKeysStartWithDot;
      function noKeyStartsWithDot(obj) {
        return !ts3.some(ts3.getOwnKeys(obj), function(k) {
          return ts3.startsWith(k, ".");
        });
      }
      function loadModuleFromSelfNameReference(extensions, moduleName, directory, state, cache, redirectedReference) {
        var _a, _b;
        var useCaseSensitiveFileNames = typeof state.host.useCaseSensitiveFileNames === "function" ? state.host.useCaseSensitiveFileNames() : state.host.useCaseSensitiveFileNames;
        var directoryPath = ts3.toPath(ts3.combinePaths(directory, "dummy"), (_b = (_a = state.host).getCurrentDirectory) === null || _b === void 0 ? void 0 : _b.call(_a), ts3.createGetCanonicalFileName(useCaseSensitiveFileNames === void 0 ? true : useCaseSensitiveFileNames));
        var scope = getPackageScopeForPath(directoryPath, state.packageJsonInfoCache, state.host, state.compilerOptions);
        if (!scope || !scope.packageJsonContent.exports) {
          return void 0;
        }
        if (typeof scope.packageJsonContent.name !== "string") {
          return void 0;
        }
        var parts = ts3.getPathComponents(moduleName);
        var nameParts = ts3.getPathComponents(scope.packageJsonContent.name);
        if (!ts3.every(nameParts, function(p, i) {
          return parts[i] === p;
        })) {
          return void 0;
        }
        var trailingParts = parts.slice(nameParts.length);
        return loadModuleFromExports(scope, extensions, !ts3.length(trailingParts) ? "." : ".".concat(ts3.directorySeparator).concat(trailingParts.join(ts3.directorySeparator)), state, cache, redirectedReference);
      }
      function loadModuleFromExports(scope, extensions, subpath, state, cache, redirectedReference) {
        if (!scope.packageJsonContent.exports) {
          return void 0;
        }
        if (subpath === ".") {
          var mainExport = void 0;
          if (typeof scope.packageJsonContent.exports === "string" || Array.isArray(scope.packageJsonContent.exports) || typeof scope.packageJsonContent.exports === "object" && noKeyStartsWithDot(scope.packageJsonContent.exports)) {
            mainExport = scope.packageJsonContent.exports;
          } else if (ts3.hasProperty(scope.packageJsonContent.exports, ".")) {
            mainExport = scope.packageJsonContent.exports["."];
          }
          if (mainExport) {
            var loadModuleFromTargetImportOrExport = getLoadModuleFromTargetImportOrExport(extensions, state, cache, redirectedReference, subpath, scope, false);
            return loadModuleFromTargetImportOrExport(mainExport, "", false);
          }
        } else if (allKeysStartWithDot(scope.packageJsonContent.exports)) {
          if (typeof scope.packageJsonContent.exports !== "object") {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, subpath, scope.packageDirectory);
            }
            return toSearchResult(void 0);
          }
          var result2 = loadModuleFromImportsOrExports(extensions, state, cache, redirectedReference, subpath, scope.packageJsonContent.exports, scope, false);
          if (result2) {
            return result2;
          }
        }
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, subpath, scope.packageDirectory);
        }
        return toSearchResult(void 0);
      }
      function loadModuleFromImports(extensions, moduleName, directory, state, cache, redirectedReference) {
        var _a, _b;
        if (moduleName === "#" || ts3.startsWith(moduleName, "#/")) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Invalid_import_specifier_0_has_no_possible_resolutions, moduleName);
          }
          return toSearchResult(void 0);
        }
        var useCaseSensitiveFileNames = typeof state.host.useCaseSensitiveFileNames === "function" ? state.host.useCaseSensitiveFileNames() : state.host.useCaseSensitiveFileNames;
        var directoryPath = ts3.toPath(ts3.combinePaths(directory, "dummy"), (_b = (_a = state.host).getCurrentDirectory) === null || _b === void 0 ? void 0 : _b.call(_a), ts3.createGetCanonicalFileName(useCaseSensitiveFileNames === void 0 ? true : useCaseSensitiveFileNames));
        var scope = getPackageScopeForPath(directoryPath, state.packageJsonInfoCache, state.host, state.compilerOptions);
        if (!scope) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve, directoryPath);
          }
          return toSearchResult(void 0);
        }
        if (!scope.packageJsonContent.imports) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_scope_0_has_no_imports_defined, scope.packageDirectory);
          }
          return toSearchResult(void 0);
        }
        var result2 = loadModuleFromImportsOrExports(extensions, state, cache, redirectedReference, moduleName, scope.packageJsonContent.imports, scope, true);
        if (result2) {
          return result2;
        }
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1, moduleName, scope.packageDirectory);
        }
        return toSearchResult(void 0);
      }
      function comparePatternKeys(a, b) {
        var aPatternIndex = a.indexOf("*");
        var bPatternIndex = b.indexOf("*");
        var baseLenA = aPatternIndex === -1 ? a.length : aPatternIndex + 1;
        var baseLenB = bPatternIndex === -1 ? b.length : bPatternIndex + 1;
        if (baseLenA > baseLenB)
          return -1;
        if (baseLenB > baseLenA)
          return 1;
        if (aPatternIndex === -1)
          return 1;
        if (bPatternIndex === -1)
          return -1;
        if (a.length > b.length)
          return -1;
        if (b.length > a.length)
          return 1;
        return 0;
      }
      function loadModuleFromImportsOrExports(extensions, state, cache, redirectedReference, moduleName, lookupTable, scope, isImports) {
        var loadModuleFromTargetImportOrExport = getLoadModuleFromTargetImportOrExport(extensions, state, cache, redirectedReference, moduleName, scope, isImports);
        if (!ts3.endsWith(moduleName, ts3.directorySeparator) && moduleName.indexOf("*") === -1 && ts3.hasProperty(lookupTable, moduleName)) {
          var target = lookupTable[moduleName];
          return loadModuleFromTargetImportOrExport(target, "", false);
        }
        var expandingKeys = ts3.sort(ts3.filter(ts3.getOwnKeys(lookupTable), function(k) {
          return k.indexOf("*") !== -1 || ts3.endsWith(k, "/");
        }), comparePatternKeys);
        for (var _i = 0, expandingKeys_1 = expandingKeys; _i < expandingKeys_1.length; _i++) {
          var potentialTarget = expandingKeys_1[_i];
          if (state.features & NodeResolutionFeatures.ExportsPatternTrailers && matchesPatternWithTrailer(potentialTarget, moduleName)) {
            var target = lookupTable[potentialTarget];
            var starPos = potentialTarget.indexOf("*");
            var subpath = moduleName.substring(potentialTarget.substring(0, starPos).length, moduleName.length - (potentialTarget.length - 1 - starPos));
            return loadModuleFromTargetImportOrExport(target, subpath, true);
          } else if (ts3.endsWith(potentialTarget, "*") && ts3.startsWith(moduleName, potentialTarget.substring(0, potentialTarget.length - 1))) {
            var target = lookupTable[potentialTarget];
            var subpath = moduleName.substring(potentialTarget.length - 1);
            return loadModuleFromTargetImportOrExport(target, subpath, true);
          } else if (ts3.startsWith(moduleName, potentialTarget)) {
            var target = lookupTable[potentialTarget];
            var subpath = moduleName.substring(potentialTarget.length);
            return loadModuleFromTargetImportOrExport(target, subpath, false);
          }
        }
        function matchesPatternWithTrailer(target2, name) {
          if (ts3.endsWith(target2, "*"))
            return false;
          var starPos2 = target2.indexOf("*");
          if (starPos2 === -1)
            return false;
          return ts3.startsWith(name, target2.substring(0, starPos2)) && ts3.endsWith(name, target2.substring(starPos2 + 1));
        }
      }
      function getLoadModuleFromTargetImportOrExport(extensions, state, cache, redirectedReference, moduleName, scope, isImports) {
        return loadModuleFromTargetImportOrExport;
        function loadModuleFromTargetImportOrExport(target, subpath, pattern) {
          if (typeof target === "string") {
            if (!pattern && subpath.length > 0 && !ts3.endsWith(target, "/")) {
              if (state.traceEnabled) {
                trace(state.host, ts3.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
              }
              return toSearchResult(void 0);
            }
            if (!ts3.startsWith(target, "./")) {
              if (isImports && !ts3.startsWith(target, "../") && !ts3.startsWith(target, "/") && !ts3.isRootedDiskPath(target)) {
                var combinedLookup = pattern ? target.replace(/\*/g, subpath) : target + subpath;
                var result2 = nodeModuleNameResolverWorker(state.features, combinedLookup, scope.packageDirectory + "/", state.compilerOptions, state.host, cache, [extensions], redirectedReference);
                return toSearchResult(result2.resolvedModule ? { path: result2.resolvedModule.resolvedFileName, extension: result2.resolvedModule.extension, packageId: result2.resolvedModule.packageId, originalPath: result2.resolvedModule.originalPath } : void 0);
              }
              if (state.traceEnabled) {
                trace(state.host, ts3.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
              }
              return toSearchResult(void 0);
            }
            var parts = ts3.pathIsRelative(target) ? ts3.getPathComponents(target).slice(1) : ts3.getPathComponents(target);
            var partsAfterFirst = parts.slice(1);
            if (partsAfterFirst.indexOf("..") >= 0 || partsAfterFirst.indexOf(".") >= 0 || partsAfterFirst.indexOf("node_modules") >= 0) {
              if (state.traceEnabled) {
                trace(state.host, ts3.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
              }
              return toSearchResult(void 0);
            }
            var resolvedTarget = ts3.combinePaths(scope.packageDirectory, target);
            var subpathParts = ts3.getPathComponents(subpath);
            if (subpathParts.indexOf("..") >= 0 || subpathParts.indexOf(".") >= 0 || subpathParts.indexOf("node_modules") >= 0) {
              if (state.traceEnabled) {
                trace(state.host, ts3.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
              }
              return toSearchResult(void 0);
            }
            var finalPath = toAbsolutePath(pattern ? resolvedTarget.replace(/\*/g, subpath) : resolvedTarget + subpath);
            var inputLink = tryLoadInputFileForPath(finalPath, subpath, ts3.combinePaths(scope.packageDirectory, "package.json"), isImports);
            if (inputLink)
              return inputLink;
            return toSearchResult(withPackageId(scope, loadJSOrExactTSFileName(extensions, finalPath, false, state)));
          } else if (typeof target === "object" && target !== null) {
            if (!Array.isArray(target)) {
              for (var _i = 0, _a = ts3.getOwnKeys(target); _i < _a.length; _i++) {
                var key = _a[_i];
                if (key === "default" || state.conditions.indexOf(key) >= 0 || isApplicableVersionedTypesKey(state.conditions, key)) {
                  var subTarget = target[key];
                  var result2 = loadModuleFromTargetImportOrExport(subTarget, subpath, pattern);
                  if (result2) {
                    return result2;
                  }
                }
              }
              return void 0;
            } else {
              if (!ts3.length(target)) {
                if (state.traceEnabled) {
                  trace(state.host, ts3.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
                }
                return toSearchResult(void 0);
              }
              for (var _b = 0, target_2 = target; _b < target_2.length; _b++) {
                var elem = target_2[_b];
                var result2 = loadModuleFromTargetImportOrExport(elem, subpath, pattern);
                if (result2) {
                  return result2;
                }
              }
            }
          } else if (target === null) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.package_json_scope_0_explicitly_maps_specifier_1_to_null, scope.packageDirectory, moduleName);
            }
            return toSearchResult(void 0);
          }
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
          }
          return toSearchResult(void 0);
          function toAbsolutePath(path2) {
            var _a2, _b2;
            if (path2 === void 0)
              return path2;
            return ts3.hostGetCanonicalFileName({ useCaseSensitiveFileNames })(ts3.getNormalizedAbsolutePath(path2, (_b2 = (_a2 = state.host).getCurrentDirectory) === null || _b2 === void 0 ? void 0 : _b2.call(_a2)));
          }
          function combineDirectoryPath(root, dir) {
            return ts3.ensureTrailingDirectorySeparator(ts3.combinePaths(root, dir));
          }
          function useCaseSensitiveFileNames() {
            return !state.host.useCaseSensitiveFileNames ? true : typeof state.host.useCaseSensitiveFileNames === "boolean" ? state.host.useCaseSensitiveFileNames : state.host.useCaseSensitiveFileNames();
          }
          function tryLoadInputFileForPath(finalPath2, entry, packagePath, isImports2) {
            var _a2, _b2, _c, _d;
            if ((extensions === Extensions.TypeScript || extensions === Extensions.JavaScript || extensions === Extensions.Json) && (state.compilerOptions.declarationDir || state.compilerOptions.outDir) && finalPath2.indexOf("/node_modules/") === -1 && (state.compilerOptions.configFile ? ts3.startsWith(toAbsolutePath(state.compilerOptions.configFile.fileName), scope.packageDirectory) : true)) {
              var getCanonicalFileName = ts3.hostGetCanonicalFileName({ useCaseSensitiveFileNames });
              var commonSourceDirGuesses = [];
              if (state.compilerOptions.rootDir || state.compilerOptions.composite && state.compilerOptions.configFilePath) {
                var commonDir = toAbsolutePath(ts3.getCommonSourceDirectory(state.compilerOptions, function() {
                  return [];
                }, ((_b2 = (_a2 = state.host).getCurrentDirectory) === null || _b2 === void 0 ? void 0 : _b2.call(_a2)) || "", getCanonicalFileName));
                commonSourceDirGuesses.push(commonDir);
              } else if (state.requestContainingDirectory) {
                var requestingFile_1 = toAbsolutePath(ts3.combinePaths(state.requestContainingDirectory, "index.ts"));
                var commonDir = toAbsolutePath(ts3.getCommonSourceDirectory(state.compilerOptions, function() {
                  return [requestingFile_1, toAbsolutePath(packagePath)];
                }, ((_d = (_c = state.host).getCurrentDirectory) === null || _d === void 0 ? void 0 : _d.call(_c)) || "", getCanonicalFileName));
                commonSourceDirGuesses.push(commonDir);
                var fragment = ts3.ensureTrailingDirectorySeparator(commonDir);
                while (fragment && fragment.length > 1) {
                  var parts2 = ts3.getPathComponents(fragment);
                  parts2.pop();
                  var commonDir_1 = ts3.getPathFromPathComponents(parts2);
                  commonSourceDirGuesses.unshift(commonDir_1);
                  fragment = ts3.ensureTrailingDirectorySeparator(commonDir_1);
                }
              }
              if (commonSourceDirGuesses.length > 1) {
                state.reportDiagnostic(ts3.createCompilerDiagnostic(isImports2 ? ts3.Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate : ts3.Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate, entry === "" ? "." : entry, packagePath));
              }
              for (var _i2 = 0, commonSourceDirGuesses_1 = commonSourceDirGuesses; _i2 < commonSourceDirGuesses_1.length; _i2++) {
                var commonSourceDirGuess = commonSourceDirGuesses_1[_i2];
                var candidateDirectories = getOutputDirectoriesForBaseDirectory(commonSourceDirGuess);
                for (var _e = 0, candidateDirectories_1 = candidateDirectories; _e < candidateDirectories_1.length; _e++) {
                  var candidateDir = candidateDirectories_1[_e];
                  if (ts3.startsWith(finalPath2, candidateDir)) {
                    var pathFragment = finalPath2.slice(candidateDir.length + 1);
                    var possibleInputBase = ts3.combinePaths(commonSourceDirGuess, pathFragment);
                    var jsAndDtsExtensions = [".mjs", ".cjs", ".js", ".json", ".d.mts", ".d.cts", ".d.ts"];
                    for (var _f = 0, jsAndDtsExtensions_1 = jsAndDtsExtensions; _f < jsAndDtsExtensions_1.length; _f++) {
                      var ext = jsAndDtsExtensions_1[_f];
                      if (ts3.fileExtensionIs(possibleInputBase, ext)) {
                        var inputExts = ts3.getPossibleOriginalInputExtensionForExtension(possibleInputBase);
                        for (var _g = 0, inputExts_1 = inputExts; _g < inputExts_1.length; _g++) {
                          var possibleExt = inputExts_1[_g];
                          var possibleInputWithInputExtension = ts3.changeAnyExtension(possibleInputBase, possibleExt, ext, !useCaseSensitiveFileNames());
                          if (extensions === Extensions.TypeScript && ts3.hasJSFileExtension(possibleInputWithInputExtension) || extensions === Extensions.JavaScript && ts3.hasTSFileExtension(possibleInputWithInputExtension)) {
                            continue;
                          }
                          if (state.host.fileExists(possibleInputWithInputExtension)) {
                            return toSearchResult(withPackageId(scope, loadJSOrExactTSFileName(extensions, possibleInputWithInputExtension, false, state)));
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
            return void 0;
            function getOutputDirectoriesForBaseDirectory(commonSourceDirGuess2) {
              var _a3, _b3;
              var currentDir = state.compilerOptions.configFile ? ((_b3 = (_a3 = state.host).getCurrentDirectory) === null || _b3 === void 0 ? void 0 : _b3.call(_a3)) || "" : commonSourceDirGuess2;
              var candidateDirectories2 = [];
              if (state.compilerOptions.declarationDir) {
                candidateDirectories2.push(toAbsolutePath(combineDirectoryPath(currentDir, state.compilerOptions.declarationDir)));
              }
              if (state.compilerOptions.outDir && state.compilerOptions.outDir !== state.compilerOptions.declarationDir) {
                candidateDirectories2.push(toAbsolutePath(combineDirectoryPath(currentDir, state.compilerOptions.outDir)));
              }
              return candidateDirectories2;
            }
          }
        }
      }
      function isApplicableVersionedTypesKey(conditions, key) {
        if (conditions.indexOf("types") === -1)
          return false;
        if (!ts3.startsWith(key, "types@"))
          return false;
        var range = ts3.VersionRange.tryParse(key.substring("types@".length));
        if (!range)
          return false;
        return range.test(ts3.version);
      }
      ts3.isApplicableVersionedTypesKey = isApplicableVersionedTypesKey;
      function loadModuleFromNearestNodeModulesDirectory(extensions, moduleName, directory, state, cache, redirectedReference) {
        return loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, false, cache, redirectedReference);
      }
      function loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, directory, state) {
        return loadModuleFromNearestNodeModulesDirectoryWorker(Extensions.DtsOnly, moduleName, directory, state, true, void 0, void 0);
      }
      function loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, typesScopeOnly, cache, redirectedReference) {
        var perModuleNameCache = cache && cache.getOrCreateCacheForModuleName(moduleName, state.features === 0 ? void 0 : state.features & NodeResolutionFeatures.EsmMode ? ts3.ModuleKind.ESNext : ts3.ModuleKind.CommonJS, redirectedReference);
        return ts3.forEachAncestorDirectory(ts3.normalizeSlashes(directory), function(ancestorDirectory) {
          if (ts3.getBaseFileName(ancestorDirectory) !== "node_modules") {
            var resolutionFromCache = tryFindNonRelativeModuleNameInCache(perModuleNameCache, moduleName, ancestorDirectory, state);
            if (resolutionFromCache) {
              return resolutionFromCache;
            }
            return toSearchResult(loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, ancestorDirectory, state, typesScopeOnly, cache, redirectedReference));
          }
        });
      }
      function loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, directory, state, typesScopeOnly, cache, redirectedReference) {
        var nodeModulesFolder = ts3.combinePaths(directory, "node_modules");
        var nodeModulesFolderExists = ts3.directoryProbablyExists(nodeModulesFolder, state.host);
        if (!nodeModulesFolderExists && state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesFolder);
        }
        var packageResult = typesScopeOnly ? void 0 : loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesFolder, nodeModulesFolderExists, state, cache, redirectedReference);
        if (packageResult) {
          return packageResult;
        }
        if (extensions === Extensions.TypeScript || extensions === Extensions.DtsOnly) {
          var nodeModulesAtTypes_1 = ts3.combinePaths(nodeModulesFolder, "@types");
          var nodeModulesAtTypesExists = nodeModulesFolderExists;
          if (nodeModulesFolderExists && !ts3.directoryProbablyExists(nodeModulesAtTypes_1, state.host)) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesAtTypes_1);
            }
            nodeModulesAtTypesExists = false;
          }
          return loadModuleFromSpecificNodeModulesDirectory(Extensions.DtsOnly, mangleScopedPackageNameWithTrace(moduleName, state), nodeModulesAtTypes_1, nodeModulesAtTypesExists, state, cache, redirectedReference);
        }
      }
      function loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesDirectory, nodeModulesDirectoryExists, state, cache, redirectedReference) {
        var candidate = ts3.normalizePath(ts3.combinePaths(nodeModulesDirectory, moduleName));
        var packageInfo = getPackageJsonInfo(candidate, !nodeModulesDirectoryExists, state);
        if (!(state.features & NodeResolutionFeatures.Exports)) {
          if (packageInfo) {
            var fromFile = loadModuleFromFile(extensions, candidate, !nodeModulesDirectoryExists, state);
            if (fromFile) {
              return noPackageId(fromFile);
            }
            var fromDirectory = loadNodeModuleFromDirectoryWorker(extensions, candidate, !nodeModulesDirectoryExists, state, packageInfo.packageJsonContent, packageInfo.versionPaths);
            return withPackageId(packageInfo, fromDirectory);
          }
        }
        var _a = parsePackageName(moduleName), packageName = _a.packageName, rest = _a.rest;
        var loader2 = function(extensions2, candidate2, onlyRecordFailures, state2) {
          var _a2;
          if (packageInfo && packageInfo.packageJsonContent.exports && state2.features & NodeResolutionFeatures.Exports) {
            return (_a2 = loadModuleFromExports(packageInfo, extensions2, ts3.combinePaths(".", rest), state2, cache, redirectedReference)) === null || _a2 === void 0 ? void 0 : _a2.value;
          }
          var pathAndExtension = loadModuleFromFile(extensions2, candidate2, onlyRecordFailures, state2) || loadNodeModuleFromDirectoryWorker(extensions2, candidate2, onlyRecordFailures, state2, packageInfo && packageInfo.packageJsonContent, packageInfo && packageInfo.versionPaths);
          if (!pathAndExtension && packageInfo && (packageInfo.packageJsonContent.exports === void 0 || packageInfo.packageJsonContent.exports === null) && state2.features & NodeResolutionFeatures.EsmMode) {
            pathAndExtension = loadModuleFromFile(extensions2, ts3.combinePaths(candidate2, "index.js"), onlyRecordFailures, state2);
          }
          return withPackageId(packageInfo, pathAndExtension);
        };
        if (rest !== "") {
          var packageDirectory = ts3.combinePaths(nodeModulesDirectory, packageName);
          packageInfo = getPackageJsonInfo(packageDirectory, !nodeModulesDirectoryExists, state);
          if (packageInfo && packageInfo.versionPaths) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, packageInfo.versionPaths.version, ts3.version, rest);
            }
            var packageDirectoryExists = nodeModulesDirectoryExists && ts3.directoryProbablyExists(packageDirectory, state.host);
            var fromPaths = tryLoadModuleUsingPaths(extensions, rest, packageDirectory, packageInfo.versionPaths.paths, void 0, loader2, !packageDirectoryExists, state);
            if (fromPaths) {
              return fromPaths.value;
            }
          }
        }
        return loader2(extensions, candidate, !nodeModulesDirectoryExists, state);
      }
      function tryLoadModuleUsingPaths(extensions, moduleName, baseDirectory, paths, pathPatterns, loader2, onlyRecordFailures, state) {
        pathPatterns || (pathPatterns = ts3.tryParsePatterns(paths));
        var matchedPattern = ts3.matchPatternOrExact(pathPatterns, moduleName);
        if (matchedPattern) {
          var matchedStar_1 = ts3.isString(matchedPattern) ? void 0 : ts3.matchedText(matchedPattern, moduleName);
          var matchedPatternText = ts3.isString(matchedPattern) ? matchedPattern : ts3.patternText(matchedPattern);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Module_name_0_matched_pattern_1, moduleName, matchedPatternText);
          }
          var resolved = ts3.forEach(paths[matchedPatternText], function(subst) {
            var path2 = matchedStar_1 ? subst.replace("*", matchedStar_1) : subst;
            var candidate = ts3.normalizePath(ts3.combinePaths(baseDirectory, path2));
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1, subst, path2);
            }
            var extension = ts3.tryGetExtensionFromPath(subst);
            if (extension !== void 0) {
              var path_1 = tryFile(candidate, onlyRecordFailures, state);
              if (path_1 !== void 0) {
                return noPackageId({ path: path_1, ext: extension });
              }
            }
            return loader2(extensions, candidate, onlyRecordFailures || !ts3.directoryProbablyExists(ts3.getDirectoryPath(candidate), state.host), state);
          });
          return { value: resolved };
        }
      }
      var mangledScopedPackageSeparator = "__";
      function mangleScopedPackageNameWithTrace(packageName, state) {
        var mangled = mangleScopedPackageName(packageName);
        if (state.traceEnabled && mangled !== packageName) {
          trace(state.host, ts3.Diagnostics.Scoped_package_detected_looking_in_0, mangled);
        }
        return mangled;
      }
      function getTypesPackageName(packageName) {
        return "@types/".concat(mangleScopedPackageName(packageName));
      }
      ts3.getTypesPackageName = getTypesPackageName;
      function mangleScopedPackageName(packageName) {
        if (ts3.startsWith(packageName, "@")) {
          var replaceSlash = packageName.replace(ts3.directorySeparator, mangledScopedPackageSeparator);
          if (replaceSlash !== packageName) {
            return replaceSlash.slice(1);
          }
        }
        return packageName;
      }
      ts3.mangleScopedPackageName = mangleScopedPackageName;
      function getPackageNameFromTypesPackageName(mangledName) {
        var withoutAtTypePrefix = ts3.removePrefix(mangledName, "@types/");
        if (withoutAtTypePrefix !== mangledName) {
          return unmangleScopedPackageName(withoutAtTypePrefix);
        }
        return mangledName;
      }
      ts3.getPackageNameFromTypesPackageName = getPackageNameFromTypesPackageName;
      function unmangleScopedPackageName(typesPackageName) {
        return ts3.stringContains(typesPackageName, mangledScopedPackageSeparator) ? "@" + typesPackageName.replace(mangledScopedPackageSeparator, ts3.directorySeparator) : typesPackageName;
      }
      ts3.unmangleScopedPackageName = unmangleScopedPackageName;
      function tryFindNonRelativeModuleNameInCache(cache, moduleName, containingDirectory, state) {
        var result2 = cache && cache.get(containingDirectory);
        if (result2) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
          }
          state.resultFromCache = result2;
          return { value: result2.resolvedModule && { path: result2.resolvedModule.resolvedFileName, originalPath: result2.resolvedModule.originalPath || true, extension: result2.resolvedModule.extension, packageId: result2.resolvedModule.packageId } };
        }
      }
      function classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        var failedLookupLocations = [];
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var diagnostics = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations, packageJsonInfoCache: cache, features: NodeResolutionFeatures.None, conditions: [], requestContainingDirectory: containingDirectory, reportDiagnostic: function(diag) {
          return void diagnostics.push(diag);
        } };
        var resolved = tryResolve(Extensions.TypeScript) || tryResolve(Extensions.JavaScript);
        return createResolvedModuleWithFailedLookupLocations(resolved && resolved.value, false, failedLookupLocations, diagnostics, state.resultFromCache);
        function tryResolve(extensions) {
          var resolvedUsingSettings = tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loadModuleFromFileNoPackageId, state);
          if (resolvedUsingSettings) {
            return { value: resolvedUsingSettings };
          }
          if (!ts3.isExternalModuleNameRelative(moduleName)) {
            var perModuleNameCache_1 = cache && cache.getOrCreateCacheForModuleName(moduleName, void 0, redirectedReference);
            var resolved_3 = ts3.forEachAncestorDirectory(containingDirectory, function(directory) {
              var resolutionFromCache = tryFindNonRelativeModuleNameInCache(perModuleNameCache_1, moduleName, directory, state);
              if (resolutionFromCache) {
                return resolutionFromCache;
              }
              var searchName = ts3.normalizePath(ts3.combinePaths(directory, moduleName));
              return toSearchResult(loadModuleFromFileNoPackageId(extensions, searchName, false, state));
            });
            if (resolved_3) {
              return resolved_3;
            }
            if (extensions === Extensions.TypeScript) {
              return loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, containingDirectory, state);
            }
          } else {
            var candidate = ts3.normalizePath(ts3.combinePaths(containingDirectory, moduleName));
            return toSearchResult(loadModuleFromFileNoPackageId(extensions, candidate, false, state));
          }
        }
      }
      ts3.classicNameResolver = classicNameResolver;
      function loadModuleFromGlobalCache(moduleName, projectName, compilerOptions, host, globalCache, packageJsonInfoCache) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        if (traceEnabled) {
          trace(host, ts3.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2, projectName, moduleName, globalCache);
        }
        var failedLookupLocations = [];
        var diagnostics = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations, packageJsonInfoCache, features: NodeResolutionFeatures.None, conditions: [], requestContainingDirectory: void 0, reportDiagnostic: function(diag) {
          return void diagnostics.push(diag);
        } };
        var resolved = loadModuleFromImmediateNodeModulesDirectory(Extensions.DtsOnly, moduleName, globalCache, state, false, void 0, void 0);
        return createResolvedModuleWithFailedLookupLocations(resolved, true, failedLookupLocations, diagnostics, state.resultFromCache);
      }
      ts3.loadModuleFromGlobalCache = loadModuleFromGlobalCache;
      function toSearchResult(value) {
        return value !== void 0 ? { value } : void 0;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ModuleInstanceState;
      (function(ModuleInstanceState2) {
        ModuleInstanceState2[ModuleInstanceState2["NonInstantiated"] = 0] = "NonInstantiated";
        ModuleInstanceState2[ModuleInstanceState2["Instantiated"] = 1] = "Instantiated";
        ModuleInstanceState2[ModuleInstanceState2["ConstEnumOnly"] = 2] = "ConstEnumOnly";
      })(ModuleInstanceState = ts3.ModuleInstanceState || (ts3.ModuleInstanceState = {}));
      function getModuleInstanceState(node, visited) {
        if (node.body && !node.body.parent) {
          ts3.setParent(node.body, node);
          ts3.setParentRecursive(node.body, false);
        }
        return node.body ? getModuleInstanceStateCached(node.body, visited) : 1;
      }
      ts3.getModuleInstanceState = getModuleInstanceState;
      function getModuleInstanceStateCached(node, visited) {
        if (visited === void 0) {
          visited = new ts3.Map();
        }
        var nodeId = ts3.getNodeId(node);
        if (visited.has(nodeId)) {
          return visited.get(nodeId) || 0;
        }
        visited.set(nodeId, void 0);
        var result2 = getModuleInstanceStateWorker(node, visited);
        visited.set(nodeId, result2);
        return result2;
      }
      function getModuleInstanceStateWorker(node, visited) {
        switch (node.kind) {
          case 258:
          case 259:
            return 0;
          case 260:
            if (ts3.isEnumConst(node)) {
              return 2;
            }
            break;
          case 266:
          case 265:
            if (!ts3.hasSyntacticModifier(node, 1)) {
              return 0;
            }
            break;
          case 272:
            var exportDeclaration = node;
            if (!exportDeclaration.moduleSpecifier && exportDeclaration.exportClause && exportDeclaration.exportClause.kind === 273) {
              var state = 0;
              for (var _i = 0, _a = exportDeclaration.exportClause.elements; _i < _a.length; _i++) {
                var specifier = _a[_i];
                var specifierState = getModuleInstanceStateForAliasTarget(specifier, visited);
                if (specifierState > state) {
                  state = specifierState;
                }
                if (state === 1) {
                  return state;
                }
              }
              return state;
            }
            break;
          case 262: {
            var state_1 = 0;
            ts3.forEachChild(node, function(n) {
              var childState = getModuleInstanceStateCached(n, visited);
              switch (childState) {
                case 0:
                  return;
                case 2:
                  state_1 = 2;
                  return;
                case 1:
                  state_1 = 1;
                  return true;
                default:
                  ts3.Debug.assertNever(childState);
              }
            });
            return state_1;
          }
          case 261:
            return getModuleInstanceState(node, visited);
          case 79:
            if (node.isInJSDocNamespace) {
              return 0;
            }
        }
        return 1;
      }
      function getModuleInstanceStateForAliasTarget(specifier, visited) {
        var name = specifier.propertyName || specifier.name;
        var p = specifier.parent;
        while (p) {
          if (ts3.isBlock(p) || ts3.isModuleBlock(p) || ts3.isSourceFile(p)) {
            var statements = p.statements;
            var found = void 0;
            for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
              var statement = statements_2[_i];
              if (ts3.nodeHasName(statement, name)) {
                if (!statement.parent) {
                  ts3.setParent(statement, p);
                  ts3.setParentRecursive(statement, false);
                }
                var state = getModuleInstanceStateCached(statement, visited);
                if (found === void 0 || state > found) {
                  found = state;
                }
                if (found === 1) {
                  return found;
                }
              }
            }
            if (found !== void 0) {
              return found;
            }
          }
          p = p.parent;
        }
        return 1;
      }
      var ContainerFlags;
      (function(ContainerFlags2) {
        ContainerFlags2[ContainerFlags2["None"] = 0] = "None";
        ContainerFlags2[ContainerFlags2["IsContainer"] = 1] = "IsContainer";
        ContainerFlags2[ContainerFlags2["IsBlockScopedContainer"] = 2] = "IsBlockScopedContainer";
        ContainerFlags2[ContainerFlags2["IsControlFlowContainer"] = 4] = "IsControlFlowContainer";
        ContainerFlags2[ContainerFlags2["IsFunctionLike"] = 8] = "IsFunctionLike";
        ContainerFlags2[ContainerFlags2["IsFunctionExpression"] = 16] = "IsFunctionExpression";
        ContainerFlags2[ContainerFlags2["HasLocals"] = 32] = "HasLocals";
        ContainerFlags2[ContainerFlags2["IsInterface"] = 64] = "IsInterface";
        ContainerFlags2[ContainerFlags2["IsObjectLiteralOrClassExpressionMethodOrAccessor"] = 128] = "IsObjectLiteralOrClassExpressionMethodOrAccessor";
      })(ContainerFlags || (ContainerFlags = {}));
      function initFlowNode(node) {
        ts3.Debug.attachFlowNodeDebugInfo(node);
        return node;
      }
      var binder = createBinder();
      function bindSourceFile(file, options) {
        ts3.performance.mark("beforeBind");
        ts3.perfLogger.logStartBindFile("" + file.fileName);
        binder(file, options);
        ts3.perfLogger.logStopBindFile();
        ts3.performance.mark("afterBind");
        ts3.performance.measure("Bind", "beforeBind", "afterBind");
      }
      ts3.bindSourceFile = bindSourceFile;
      function createBinder() {
        var file;
        var options;
        var languageVersion;
        var parent;
        var container;
        var thisParentContainer;
        var blockScopeContainer;
        var lastContainer;
        var delayedTypeAliases;
        var seenThisKeyword;
        var currentFlow;
        var currentBreakTarget;
        var currentContinueTarget;
        var currentReturnTarget;
        var currentTrueTarget;
        var currentFalseTarget;
        var currentExceptionTarget;
        var preSwitchCaseFlow;
        var activeLabelList;
        var hasExplicitReturn;
        var emitFlags;
        var inStrictMode;
        var inAssignmentPattern = false;
        var symbolCount = 0;
        var Symbol2;
        var classifiableNames;
        var unreachableFlow = { flags: 1 };
        var reportedUnreachableFlow = { flags: 1 };
        var bindBinaryExpressionFlow = createBindBinaryExpressionFlow();
        function createDiagnosticForNode(node, message, arg0, arg1, arg2) {
          return ts3.createDiagnosticForNodeInSourceFile(ts3.getSourceFileOfNode(node) || file, node, message, arg0, arg1, arg2);
        }
        function bindSourceFile2(f, opts) {
          file = f;
          options = opts;
          languageVersion = ts3.getEmitScriptTarget(options);
          inStrictMode = bindInStrictMode(file, opts);
          classifiableNames = new ts3.Set();
          symbolCount = 0;
          Symbol2 = ts3.objectAllocator.getSymbolConstructor();
          ts3.Debug.attachFlowNodeDebugInfo(unreachableFlow);
          ts3.Debug.attachFlowNodeDebugInfo(reportedUnreachableFlow);
          if (!file.locals) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("bind", "bindSourceFile", { path: file.path }, true);
            bind(file);
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
            file.symbolCount = symbolCount;
            file.classifiableNames = classifiableNames;
            delayedBindJSDocTypedefTag();
          }
          file = void 0;
          options = void 0;
          languageVersion = void 0;
          parent = void 0;
          container = void 0;
          thisParentContainer = void 0;
          blockScopeContainer = void 0;
          lastContainer = void 0;
          delayedTypeAliases = void 0;
          seenThisKeyword = false;
          currentFlow = void 0;
          currentBreakTarget = void 0;
          currentContinueTarget = void 0;
          currentReturnTarget = void 0;
          currentTrueTarget = void 0;
          currentFalseTarget = void 0;
          currentExceptionTarget = void 0;
          activeLabelList = void 0;
          hasExplicitReturn = false;
          inAssignmentPattern = false;
          emitFlags = 0;
        }
        return bindSourceFile2;
        function bindInStrictMode(file2, opts) {
          if (ts3.getStrictOptionValue(opts, "alwaysStrict") && !file2.isDeclarationFile) {
            return true;
          } else {
            return !!file2.externalModuleIndicator;
          }
        }
        function createSymbol(flags, name) {
          symbolCount++;
          return new Symbol2(flags, name);
        }
        function addDeclarationToSymbol(symbol, node, symbolFlags) {
          symbol.flags |= symbolFlags;
          node.symbol = symbol;
          symbol.declarations = ts3.appendIfUnique(symbol.declarations, node);
          if (symbolFlags & (32 | 384 | 1536 | 3) && !symbol.exports) {
            symbol.exports = ts3.createSymbolTable();
          }
          if (symbolFlags & (32 | 64 | 2048 | 4096) && !symbol.members) {
            symbol.members = ts3.createSymbolTable();
          }
          if (symbol.constEnumOnlyModule && symbol.flags & (16 | 32 | 256)) {
            symbol.constEnumOnlyModule = false;
          }
          if (symbolFlags & 111551) {
            ts3.setValueDeclaration(symbol, node);
          }
        }
        function getDeclarationName(node) {
          if (node.kind === 271) {
            return node.isExportEquals ? "export=" : "default";
          }
          var name = ts3.getNameOfDeclaration(node);
          if (name) {
            if (ts3.isAmbientModule(node)) {
              var moduleName = ts3.getTextOfIdentifierOrLiteral(name);
              return ts3.isGlobalScopeAugmentation(node) ? "__global" : '"'.concat(moduleName, '"');
            }
            if (name.kind === 162) {
              var nameExpression = name.expression;
              if (ts3.isStringOrNumericLiteralLike(nameExpression)) {
                return ts3.escapeLeadingUnderscores(nameExpression.text);
              }
              if (ts3.isSignedNumericLiteral(nameExpression)) {
                return ts3.tokenToString(nameExpression.operator) + nameExpression.operand.text;
              } else {
                ts3.Debug.fail("Only computed properties with literal names have declaration names");
              }
            }
            if (ts3.isPrivateIdentifier(name)) {
              var containingClass = ts3.getContainingClass(node);
              if (!containingClass) {
                return void 0;
              }
              var containingClassSymbol = containingClass.symbol;
              return ts3.getSymbolNameForPrivateIdentifier(containingClassSymbol, name.escapedText);
            }
            return ts3.isPropertyNameLiteral(name) ? ts3.getEscapedTextOfIdentifierOrLiteral(name) : void 0;
          }
          switch (node.kind) {
            case 171:
              return "__constructor";
            case 179:
            case 174:
            case 323:
              return "__call";
            case 180:
            case 175:
              return "__new";
            case 176:
              return "__index";
            case 272:
              return "__export";
            case 305:
              return "export=";
            case 221:
              if (ts3.getAssignmentDeclarationKind(node) === 2) {
                return "export=";
              }
              ts3.Debug.fail("Unknown binary declaration kind");
              break;
            case 317:
              return ts3.isJSDocConstructSignature(node) ? "__new" : "__call";
            case 164:
              ts3.Debug.assert(node.parent.kind === 317, "Impossible parameter parent kind", function() {
                return "parent is: ".concat(ts3.SyntaxKind ? ts3.SyntaxKind[node.parent.kind] : node.parent.kind, ", expected JSDocFunctionType");
              });
              var functionType = node.parent;
              var index = functionType.parameters.indexOf(node);
              return "arg" + index;
          }
        }
        function getDisplayName(node) {
          return ts3.isNamedDeclaration(node) ? ts3.declarationNameToString(node.name) : ts3.unescapeLeadingUnderscores(ts3.Debug.checkDefined(getDeclarationName(node)));
        }
        function declareSymbol(symbolTable, parent2, node, includes, excludes, isReplaceableByMethod, isComputedName) {
          ts3.Debug.assert(isComputedName || !ts3.hasDynamicName(node));
          var isDefaultExport = ts3.hasSyntacticModifier(node, 512) || ts3.isExportSpecifier(node) && node.name.escapedText === "default";
          var name = isComputedName ? "__computed" : isDefaultExport && parent2 ? "default" : getDeclarationName(node);
          var symbol;
          if (name === void 0) {
            symbol = createSymbol(0, "__missing");
          } else {
            symbol = symbolTable.get(name);
            if (includes & 2885600) {
              classifiableNames.add(name);
            }
            if (!symbol) {
              symbolTable.set(name, symbol = createSymbol(0, name));
              if (isReplaceableByMethod)
                symbol.isReplaceableByMethod = true;
            } else if (isReplaceableByMethod && !symbol.isReplaceableByMethod) {
              return symbol;
            } else if (symbol.flags & excludes) {
              if (symbol.isReplaceableByMethod) {
                symbolTable.set(name, symbol = createSymbol(0, name));
              } else if (!(includes & 3 && symbol.flags & 67108864)) {
                if (ts3.isNamedDeclaration(node)) {
                  ts3.setParent(node.name, node);
                }
                var message_1 = symbol.flags & 2 ? ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts3.Diagnostics.Duplicate_identifier_0;
                var messageNeedsName_1 = true;
                if (symbol.flags & 384 || includes & 384) {
                  message_1 = ts3.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations;
                  messageNeedsName_1 = false;
                }
                var multipleDefaultExports_1 = false;
                if (ts3.length(symbol.declarations)) {
                  if (isDefaultExport) {
                    message_1 = ts3.Diagnostics.A_module_cannot_have_multiple_default_exports;
                    messageNeedsName_1 = false;
                    multipleDefaultExports_1 = true;
                  } else {
                    if (symbol.declarations && symbol.declarations.length && (node.kind === 271 && !node.isExportEquals)) {
                      message_1 = ts3.Diagnostics.A_module_cannot_have_multiple_default_exports;
                      messageNeedsName_1 = false;
                      multipleDefaultExports_1 = true;
                    }
                  }
                }
                var relatedInformation_1 = [];
                if (ts3.isTypeAliasDeclaration(node) && ts3.nodeIsMissing(node.type) && ts3.hasSyntacticModifier(node, 1) && symbol.flags & (2097152 | 788968 | 1920)) {
                  relatedInformation_1.push(createDiagnosticForNode(node, ts3.Diagnostics.Did_you_mean_0, "export type { ".concat(ts3.unescapeLeadingUnderscores(node.name.escapedText), " }")));
                }
                var declarationName_1 = ts3.getNameOfDeclaration(node) || node;
                ts3.forEach(symbol.declarations, function(declaration, index) {
                  var decl = ts3.getNameOfDeclaration(declaration) || declaration;
                  var diag2 = createDiagnosticForNode(decl, message_1, messageNeedsName_1 ? getDisplayName(declaration) : void 0);
                  file.bindDiagnostics.push(multipleDefaultExports_1 ? ts3.addRelatedInfo(diag2, createDiagnosticForNode(declarationName_1, index === 0 ? ts3.Diagnostics.Another_export_default_is_here : ts3.Diagnostics.and_here)) : diag2);
                  if (multipleDefaultExports_1) {
                    relatedInformation_1.push(createDiagnosticForNode(decl, ts3.Diagnostics.The_first_export_default_is_here));
                  }
                });
                var diag = createDiagnosticForNode(declarationName_1, message_1, messageNeedsName_1 ? getDisplayName(node) : void 0);
                file.bindDiagnostics.push(ts3.addRelatedInfo.apply(void 0, __spreadArray([diag], relatedInformation_1, false)));
                symbol = createSymbol(0, name);
              }
            }
          }
          addDeclarationToSymbol(symbol, node, includes);
          if (symbol.parent) {
            ts3.Debug.assert(symbol.parent === parent2, "Existing symbol parent should match new one");
          } else {
            symbol.parent = parent2;
          }
          return symbol;
        }
        function declareModuleMember(node, symbolFlags, symbolExcludes) {
          var hasExportModifier = !!(ts3.getCombinedModifierFlags(node) & 1) || jsdocTreatAsExported(node);
          if (symbolFlags & 2097152) {
            if (node.kind === 275 || node.kind === 265 && hasExportModifier) {
              return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
            } else {
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
            }
          } else {
            if (ts3.isJSDocTypeAlias(node))
              ts3.Debug.assert(ts3.isInJSFile(node));
            if (!ts3.isAmbientModule(node) && (hasExportModifier || container.flags & 64)) {
              if (!container.locals || ts3.hasSyntacticModifier(node, 512) && !getDeclarationName(node)) {
                return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
              }
              var exportKind = symbolFlags & 111551 ? 1048576 : 0;
              var local = declareSymbol(container.locals, void 0, node, exportKind, symbolExcludes);
              local.exportSymbol = declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
              node.localSymbol = local;
              return local;
            } else {
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
            }
          }
        }
        function jsdocTreatAsExported(node) {
          if (node.parent && ts3.isModuleDeclaration(node)) {
            node = node.parent;
          }
          if (!ts3.isJSDocTypeAlias(node))
            return false;
          if (!ts3.isJSDocEnumTag(node) && !!node.fullName)
            return true;
          var declName = ts3.getNameOfDeclaration(node);
          if (!declName)
            return false;
          if (ts3.isPropertyAccessEntityNameExpression(declName.parent) && isTopLevelNamespaceAssignment(declName.parent))
            return true;
          if (ts3.isDeclaration(declName.parent) && ts3.getCombinedModifierFlags(declName.parent) & 1)
            return true;
          return false;
        }
        function bindContainer(node, containerFlags) {
          var saveContainer = container;
          var saveThisParentContainer = thisParentContainer;
          var savedBlockScopeContainer = blockScopeContainer;
          if (containerFlags & 1) {
            if (node.kind !== 214) {
              thisParentContainer = container;
            }
            container = blockScopeContainer = node;
            if (containerFlags & 32) {
              container.locals = ts3.createSymbolTable();
            }
            addToContainerChain(container);
          } else if (containerFlags & 2) {
            blockScopeContainer = node;
            blockScopeContainer.locals = void 0;
          }
          if (containerFlags & 4) {
            var saveCurrentFlow = currentFlow;
            var saveBreakTarget = currentBreakTarget;
            var saveContinueTarget = currentContinueTarget;
            var saveReturnTarget = currentReturnTarget;
            var saveExceptionTarget = currentExceptionTarget;
            var saveActiveLabelList = activeLabelList;
            var saveHasExplicitReturn = hasExplicitReturn;
            var isImmediatelyInvoked = containerFlags & 16 && !ts3.hasSyntacticModifier(node, 256) && !node.asteriskToken && !!ts3.getImmediatelyInvokedFunctionExpression(node) || node.kind === 170;
            if (!isImmediatelyInvoked) {
              currentFlow = initFlowNode({ flags: 2 });
              if (containerFlags & (16 | 128)) {
                currentFlow.node = node;
              }
            }
            currentReturnTarget = isImmediatelyInvoked || node.kind === 171 || ts3.isInJSFile(node) && (node.kind === 256 || node.kind === 213) ? createBranchLabel() : void 0;
            currentExceptionTarget = void 0;
            currentBreakTarget = void 0;
            currentContinueTarget = void 0;
            activeLabelList = void 0;
            hasExplicitReturn = false;
            bindChildren(node);
            node.flags &= ~2816;
            if (!(currentFlow.flags & 1) && containerFlags & 8 && ts3.nodeIsPresent(node.body)) {
              node.flags |= 256;
              if (hasExplicitReturn)
                node.flags |= 512;
              node.endFlowNode = currentFlow;
            }
            if (node.kind === 305) {
              node.flags |= emitFlags;
              node.endFlowNode = currentFlow;
            }
            if (currentReturnTarget) {
              addAntecedent(currentReturnTarget, currentFlow);
              currentFlow = finishFlowLabel(currentReturnTarget);
              if (node.kind === 171 || node.kind === 170 || ts3.isInJSFile(node) && (node.kind === 256 || node.kind === 213)) {
                node.returnFlowNode = currentFlow;
              }
            }
            if (!isImmediatelyInvoked) {
              currentFlow = saveCurrentFlow;
            }
            currentBreakTarget = saveBreakTarget;
            currentContinueTarget = saveContinueTarget;
            currentReturnTarget = saveReturnTarget;
            currentExceptionTarget = saveExceptionTarget;
            activeLabelList = saveActiveLabelList;
            hasExplicitReturn = saveHasExplicitReturn;
          } else if (containerFlags & 64) {
            seenThisKeyword = false;
            bindChildren(node);
            node.flags = seenThisKeyword ? node.flags | 128 : node.flags & ~128;
          } else {
            bindChildren(node);
          }
          container = saveContainer;
          thisParentContainer = saveThisParentContainer;
          blockScopeContainer = savedBlockScopeContainer;
        }
        function bindEachFunctionsFirst(nodes) {
          bindEach(nodes, function(n) {
            return n.kind === 256 ? bind(n) : void 0;
          });
          bindEach(nodes, function(n) {
            return n.kind !== 256 ? bind(n) : void 0;
          });
        }
        function bindEach(nodes, bindFunction) {
          if (bindFunction === void 0) {
            bindFunction = bind;
          }
          if (nodes === void 0) {
            return;
          }
          ts3.forEach(nodes, bindFunction);
        }
        function bindEachChild(node) {
          ts3.forEachChild(node, bind, bindEach);
        }
        function bindChildren(node) {
          var saveInAssignmentPattern = inAssignmentPattern;
          inAssignmentPattern = false;
          if (checkUnreachable(node)) {
            bindEachChild(node);
            bindJSDoc(node);
            inAssignmentPattern = saveInAssignmentPattern;
            return;
          }
          if (node.kind >= 237 && node.kind <= 253 && !options.allowUnreachableCode) {
            node.flowNode = currentFlow;
          }
          switch (node.kind) {
            case 241:
              bindWhileStatement(node);
              break;
            case 240:
              bindDoStatement(node);
              break;
            case 242:
              bindForStatement(node);
              break;
            case 243:
            case 244:
              bindForInOrForOfStatement(node);
              break;
            case 239:
              bindIfStatement(node);
              break;
            case 247:
            case 251:
              bindReturnOrThrow(node);
              break;
            case 246:
            case 245:
              bindBreakOrContinueStatement(node);
              break;
            case 252:
              bindTryStatement(node);
              break;
            case 249:
              bindSwitchStatement(node);
              break;
            case 263:
              bindCaseBlock(node);
              break;
            case 289:
              bindCaseClause(node);
              break;
            case 238:
              bindExpressionStatement(node);
              break;
            case 250:
              bindLabeledStatement(node);
              break;
            case 219:
              bindPrefixUnaryExpressionFlow(node);
              break;
            case 220:
              bindPostfixUnaryExpressionFlow(node);
              break;
            case 221:
              if (ts3.isDestructuringAssignment(node)) {
                inAssignmentPattern = saveInAssignmentPattern;
                bindDestructuringAssignmentFlow(node);
                return;
              }
              bindBinaryExpressionFlow(node);
              break;
            case 215:
              bindDeleteExpressionFlow(node);
              break;
            case 222:
              bindConditionalExpressionFlow(node);
              break;
            case 254:
              bindVariableDeclarationFlow(node);
              break;
            case 206:
            case 207:
              bindAccessExpressionFlow(node);
              break;
            case 208:
              bindCallExpressionFlow(node);
              break;
            case 230:
              bindNonNullExpressionFlow(node);
              break;
            case 345:
            case 338:
            case 339:
              bindJSDocTypeAlias(node);
              break;
            case 305: {
              bindEachFunctionsFirst(node.statements);
              bind(node.endOfFileToken);
              break;
            }
            case 235:
            case 262:
              bindEachFunctionsFirst(node.statements);
              break;
            case 203:
              bindBindingElementFlow(node);
              break;
            case 205:
            case 204:
            case 296:
            case 225:
              inAssignmentPattern = saveInAssignmentPattern;
            default:
              bindEachChild(node);
              break;
          }
          bindJSDoc(node);
          inAssignmentPattern = saveInAssignmentPattern;
        }
        function isNarrowingExpression(expr) {
          switch (expr.kind) {
            case 79:
            case 80:
            case 108:
            case 206:
            case 207:
              return containsNarrowableReference(expr);
            case 208:
              return hasNarrowableArgument(expr);
            case 212:
            case 230:
              return isNarrowingExpression(expr.expression);
            case 221:
              return isNarrowingBinaryExpression(expr);
            case 219:
              return expr.operator === 53 && isNarrowingExpression(expr.operand);
            case 216:
              return isNarrowingExpression(expr.expression);
          }
          return false;
        }
        function isNarrowableReference(expr) {
          return ts3.isDottedName(expr) || (ts3.isPropertyAccessExpression(expr) || ts3.isNonNullExpression(expr) || ts3.isParenthesizedExpression(expr)) && isNarrowableReference(expr.expression) || ts3.isBinaryExpression(expr) && expr.operatorToken.kind === 27 && isNarrowableReference(expr.right) || ts3.isElementAccessExpression(expr) && (ts3.isStringOrNumericLiteralLike(expr.argumentExpression) || ts3.isEntityNameExpression(expr.argumentExpression)) && isNarrowableReference(expr.expression) || ts3.isAssignmentExpression(expr) && isNarrowableReference(expr.left);
        }
        function containsNarrowableReference(expr) {
          return isNarrowableReference(expr) || ts3.isOptionalChain(expr) && containsNarrowableReference(expr.expression);
        }
        function hasNarrowableArgument(expr) {
          if (expr.arguments) {
            for (var _i = 0, _a = expr.arguments; _i < _a.length; _i++) {
              var argument = _a[_i];
              if (containsNarrowableReference(argument)) {
                return true;
              }
            }
          }
          if (expr.expression.kind === 206 && containsNarrowableReference(expr.expression.expression)) {
            return true;
          }
          return false;
        }
        function isNarrowingTypeofOperands(expr1, expr2) {
          return ts3.isTypeOfExpression(expr1) && isNarrowableOperand(expr1.expression) && ts3.isStringLiteralLike(expr2);
        }
        function isNarrowingBinaryExpression(expr) {
          switch (expr.operatorToken.kind) {
            case 63:
            case 75:
            case 76:
            case 77:
              return containsNarrowableReference(expr.left);
            case 34:
            case 35:
            case 36:
            case 37:
              return isNarrowableOperand(expr.left) || isNarrowableOperand(expr.right) || isNarrowingTypeofOperands(expr.right, expr.left) || isNarrowingTypeofOperands(expr.left, expr.right);
            case 102:
              return isNarrowableOperand(expr.left);
            case 101:
              return isNarrowingExpression(expr.right);
            case 27:
              return isNarrowingExpression(expr.right);
          }
          return false;
        }
        function isNarrowableOperand(expr) {
          switch (expr.kind) {
            case 212:
              return isNarrowableOperand(expr.expression);
            case 221:
              switch (expr.operatorToken.kind) {
                case 63:
                  return isNarrowableOperand(expr.left);
                case 27:
                  return isNarrowableOperand(expr.right);
              }
          }
          return containsNarrowableReference(expr);
        }
        function createBranchLabel() {
          return initFlowNode({ flags: 4, antecedents: void 0 });
        }
        function createLoopLabel() {
          return initFlowNode({ flags: 8, antecedents: void 0 });
        }
        function createReduceLabel(target, antecedents, antecedent) {
          return initFlowNode({ flags: 1024, target, antecedents, antecedent });
        }
        function setFlowNodeReferenced(flow) {
          flow.flags |= flow.flags & 2048 ? 4096 : 2048;
        }
        function addAntecedent(label, antecedent) {
          if (!(antecedent.flags & 1) && !ts3.contains(label.antecedents, antecedent)) {
            (label.antecedents || (label.antecedents = [])).push(antecedent);
            setFlowNodeReferenced(antecedent);
          }
        }
        function createFlowCondition(flags, antecedent, expression) {
          if (antecedent.flags & 1) {
            return antecedent;
          }
          if (!expression) {
            return flags & 32 ? antecedent : unreachableFlow;
          }
          if ((expression.kind === 110 && flags & 64 || expression.kind === 95 && flags & 32) && !ts3.isExpressionOfOptionalChainRoot(expression) && !ts3.isNullishCoalesce(expression.parent)) {
            return unreachableFlow;
          }
          if (!isNarrowingExpression(expression)) {
            return antecedent;
          }
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags, antecedent, node: expression });
        }
        function createFlowSwitchClause(antecedent, switchStatement, clauseStart, clauseEnd) {
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags: 128, antecedent, switchStatement, clauseStart, clauseEnd });
        }
        function createFlowMutation(flags, antecedent, node) {
          setFlowNodeReferenced(antecedent);
          var result2 = initFlowNode({ flags, antecedent, node });
          if (currentExceptionTarget) {
            addAntecedent(currentExceptionTarget, result2);
          }
          return result2;
        }
        function createFlowCall(antecedent, node) {
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags: 512, antecedent, node });
        }
        function finishFlowLabel(flow) {
          var antecedents = flow.antecedents;
          if (!antecedents) {
            return unreachableFlow;
          }
          if (antecedents.length === 1) {
            return antecedents[0];
          }
          return flow;
        }
        function isStatementCondition(node) {
          var parent2 = node.parent;
          switch (parent2.kind) {
            case 239:
            case 241:
            case 240:
              return parent2.expression === node;
            case 242:
            case 222:
              return parent2.condition === node;
          }
          return false;
        }
        function isLogicalExpression(node) {
          while (true) {
            if (node.kind === 212) {
              node = node.expression;
            } else if (node.kind === 219 && node.operator === 53) {
              node = node.operand;
            } else {
              return node.kind === 221 && (node.operatorToken.kind === 55 || node.operatorToken.kind === 56 || node.operatorToken.kind === 60);
            }
          }
        }
        function isLogicalAssignmentExpression(node) {
          node = ts3.skipParentheses(node);
          return ts3.isBinaryExpression(node) && ts3.isLogicalOrCoalescingAssignmentOperator(node.operatorToken.kind);
        }
        function isTopLevelLogicalExpression(node) {
          while (ts3.isParenthesizedExpression(node.parent) || ts3.isPrefixUnaryExpression(node.parent) && node.parent.operator === 53) {
            node = node.parent;
          }
          return !isStatementCondition(node) && !isLogicalExpression(node.parent) && !(ts3.isOptionalChain(node.parent) && node.parent.expression === node);
        }
        function doWithConditionalBranches(action, value, trueTarget, falseTarget) {
          var savedTrueTarget = currentTrueTarget;
          var savedFalseTarget = currentFalseTarget;
          currentTrueTarget = trueTarget;
          currentFalseTarget = falseTarget;
          action(value);
          currentTrueTarget = savedTrueTarget;
          currentFalseTarget = savedFalseTarget;
        }
        function bindCondition(node, trueTarget, falseTarget) {
          doWithConditionalBranches(bind, node, trueTarget, falseTarget);
          if (!node || !isLogicalAssignmentExpression(node) && !isLogicalExpression(node) && !(ts3.isOptionalChain(node) && ts3.isOutermostOptionalChain(node))) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindIterativeStatement(node, breakTarget, continueTarget) {
          var saveBreakTarget = currentBreakTarget;
          var saveContinueTarget = currentContinueTarget;
          currentBreakTarget = breakTarget;
          currentContinueTarget = continueTarget;
          bind(node);
          currentBreakTarget = saveBreakTarget;
          currentContinueTarget = saveContinueTarget;
        }
        function setContinueTarget(node, target) {
          var label = activeLabelList;
          while (label && node.parent.kind === 250) {
            label.continueTarget = target;
            label = label.next;
            node = node.parent;
          }
          return target;
        }
        function bindWhileStatement(node) {
          var preWhileLabel = setContinueTarget(node, createLoopLabel());
          var preBodyLabel = createBranchLabel();
          var postWhileLabel = createBranchLabel();
          addAntecedent(preWhileLabel, currentFlow);
          currentFlow = preWhileLabel;
          bindCondition(node.expression, preBodyLabel, postWhileLabel);
          currentFlow = finishFlowLabel(preBodyLabel);
          bindIterativeStatement(node.statement, postWhileLabel, preWhileLabel);
          addAntecedent(preWhileLabel, currentFlow);
          currentFlow = finishFlowLabel(postWhileLabel);
        }
        function bindDoStatement(node) {
          var preDoLabel = createLoopLabel();
          var preConditionLabel = setContinueTarget(node, createBranchLabel());
          var postDoLabel = createBranchLabel();
          addAntecedent(preDoLabel, currentFlow);
          currentFlow = preDoLabel;
          bindIterativeStatement(node.statement, postDoLabel, preConditionLabel);
          addAntecedent(preConditionLabel, currentFlow);
          currentFlow = finishFlowLabel(preConditionLabel);
          bindCondition(node.expression, preDoLabel, postDoLabel);
          currentFlow = finishFlowLabel(postDoLabel);
        }
        function bindForStatement(node) {
          var preLoopLabel = setContinueTarget(node, createLoopLabel());
          var preBodyLabel = createBranchLabel();
          var postLoopLabel = createBranchLabel();
          bind(node.initializer);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = preLoopLabel;
          bindCondition(node.condition, preBodyLabel, postLoopLabel);
          currentFlow = finishFlowLabel(preBodyLabel);
          bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
          bind(node.incrementor);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = finishFlowLabel(postLoopLabel);
        }
        function bindForInOrForOfStatement(node) {
          var preLoopLabel = setContinueTarget(node, createLoopLabel());
          var postLoopLabel = createBranchLabel();
          bind(node.expression);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = preLoopLabel;
          if (node.kind === 244) {
            bind(node.awaitModifier);
          }
          addAntecedent(postLoopLabel, currentFlow);
          bind(node.initializer);
          if (node.initializer.kind !== 255) {
            bindAssignmentTargetFlow(node.initializer);
          }
          bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = finishFlowLabel(postLoopLabel);
        }
        function bindIfStatement(node) {
          var thenLabel = createBranchLabel();
          var elseLabel = createBranchLabel();
          var postIfLabel = createBranchLabel();
          bindCondition(node.expression, thenLabel, elseLabel);
          currentFlow = finishFlowLabel(thenLabel);
          bind(node.thenStatement);
          addAntecedent(postIfLabel, currentFlow);
          currentFlow = finishFlowLabel(elseLabel);
          bind(node.elseStatement);
          addAntecedent(postIfLabel, currentFlow);
          currentFlow = finishFlowLabel(postIfLabel);
        }
        function bindReturnOrThrow(node) {
          bind(node.expression);
          if (node.kind === 247) {
            hasExplicitReturn = true;
            if (currentReturnTarget) {
              addAntecedent(currentReturnTarget, currentFlow);
            }
          }
          currentFlow = unreachableFlow;
        }
        function findActiveLabel(name) {
          for (var label = activeLabelList; label; label = label.next) {
            if (label.name === name) {
              return label;
            }
          }
          return void 0;
        }
        function bindBreakOrContinueFlow(node, breakTarget, continueTarget) {
          var flowLabel = node.kind === 246 ? breakTarget : continueTarget;
          if (flowLabel) {
            addAntecedent(flowLabel, currentFlow);
            currentFlow = unreachableFlow;
          }
        }
        function bindBreakOrContinueStatement(node) {
          bind(node.label);
          if (node.label) {
            var activeLabel = findActiveLabel(node.label.escapedText);
            if (activeLabel) {
              activeLabel.referenced = true;
              bindBreakOrContinueFlow(node, activeLabel.breakTarget, activeLabel.continueTarget);
            }
          } else {
            bindBreakOrContinueFlow(node, currentBreakTarget, currentContinueTarget);
          }
        }
        function bindTryStatement(node) {
          var saveReturnTarget = currentReturnTarget;
          var saveExceptionTarget = currentExceptionTarget;
          var normalExitLabel = createBranchLabel();
          var returnLabel = createBranchLabel();
          var exceptionLabel = createBranchLabel();
          if (node.finallyBlock) {
            currentReturnTarget = returnLabel;
          }
          addAntecedent(exceptionLabel, currentFlow);
          currentExceptionTarget = exceptionLabel;
          bind(node.tryBlock);
          addAntecedent(normalExitLabel, currentFlow);
          if (node.catchClause) {
            currentFlow = finishFlowLabel(exceptionLabel);
            exceptionLabel = createBranchLabel();
            addAntecedent(exceptionLabel, currentFlow);
            currentExceptionTarget = exceptionLabel;
            bind(node.catchClause);
            addAntecedent(normalExitLabel, currentFlow);
          }
          currentReturnTarget = saveReturnTarget;
          currentExceptionTarget = saveExceptionTarget;
          if (node.finallyBlock) {
            var finallyLabel = createBranchLabel();
            finallyLabel.antecedents = ts3.concatenate(ts3.concatenate(normalExitLabel.antecedents, exceptionLabel.antecedents), returnLabel.antecedents);
            currentFlow = finallyLabel;
            bind(node.finallyBlock);
            if (currentFlow.flags & 1) {
              currentFlow = unreachableFlow;
            } else {
              if (currentReturnTarget && returnLabel.antecedents) {
                addAntecedent(currentReturnTarget, createReduceLabel(finallyLabel, returnLabel.antecedents, currentFlow));
              }
              if (currentExceptionTarget && exceptionLabel.antecedents) {
                addAntecedent(currentExceptionTarget, createReduceLabel(finallyLabel, exceptionLabel.antecedents, currentFlow));
              }
              currentFlow = normalExitLabel.antecedents ? createReduceLabel(finallyLabel, normalExitLabel.antecedents, currentFlow) : unreachableFlow;
            }
          } else {
            currentFlow = finishFlowLabel(normalExitLabel);
          }
        }
        function bindSwitchStatement(node) {
          var postSwitchLabel = createBranchLabel();
          bind(node.expression);
          var saveBreakTarget = currentBreakTarget;
          var savePreSwitchCaseFlow = preSwitchCaseFlow;
          currentBreakTarget = postSwitchLabel;
          preSwitchCaseFlow = currentFlow;
          bind(node.caseBlock);
          addAntecedent(postSwitchLabel, currentFlow);
          var hasDefault = ts3.forEach(node.caseBlock.clauses, function(c) {
            return c.kind === 290;
          });
          node.possiblyExhaustive = !hasDefault && !postSwitchLabel.antecedents;
          if (!hasDefault) {
            addAntecedent(postSwitchLabel, createFlowSwitchClause(preSwitchCaseFlow, node, 0, 0));
          }
          currentBreakTarget = saveBreakTarget;
          preSwitchCaseFlow = savePreSwitchCaseFlow;
          currentFlow = finishFlowLabel(postSwitchLabel);
        }
        function bindCaseBlock(node) {
          var clauses = node.clauses;
          var isNarrowingSwitch = isNarrowingExpression(node.parent.expression);
          var fallthroughFlow = unreachableFlow;
          for (var i = 0; i < clauses.length; i++) {
            var clauseStart = i;
            while (!clauses[i].statements.length && i + 1 < clauses.length) {
              bind(clauses[i]);
              i++;
            }
            var preCaseLabel = createBranchLabel();
            addAntecedent(preCaseLabel, isNarrowingSwitch ? createFlowSwitchClause(preSwitchCaseFlow, node.parent, clauseStart, i + 1) : preSwitchCaseFlow);
            addAntecedent(preCaseLabel, fallthroughFlow);
            currentFlow = finishFlowLabel(preCaseLabel);
            var clause = clauses[i];
            bind(clause);
            fallthroughFlow = currentFlow;
            if (!(currentFlow.flags & 1) && i !== clauses.length - 1 && options.noFallthroughCasesInSwitch) {
              clause.fallthroughFlowNode = currentFlow;
            }
          }
        }
        function bindCaseClause(node) {
          var saveCurrentFlow = currentFlow;
          currentFlow = preSwitchCaseFlow;
          bind(node.expression);
          currentFlow = saveCurrentFlow;
          bindEach(node.statements);
        }
        function bindExpressionStatement(node) {
          bind(node.expression);
          maybeBindExpressionFlowIfCall(node.expression);
        }
        function maybeBindExpressionFlowIfCall(node) {
          if (node.kind === 208) {
            var call = node;
            if (call.expression.kind !== 106 && ts3.isDottedName(call.expression)) {
              currentFlow = createFlowCall(currentFlow, call);
            }
          }
        }
        function bindLabeledStatement(node) {
          var postStatementLabel = createBranchLabel();
          activeLabelList = {
            next: activeLabelList,
            name: node.label.escapedText,
            breakTarget: postStatementLabel,
            continueTarget: void 0,
            referenced: false
          };
          bind(node.label);
          bind(node.statement);
          if (!activeLabelList.referenced && !options.allowUnusedLabels) {
            errorOrSuggestionOnNode(ts3.unusedLabelIsError(options), node.label, ts3.Diagnostics.Unused_label);
          }
          activeLabelList = activeLabelList.next;
          addAntecedent(postStatementLabel, currentFlow);
          currentFlow = finishFlowLabel(postStatementLabel);
        }
        function bindDestructuringTargetFlow(node) {
          if (node.kind === 221 && node.operatorToken.kind === 63) {
            bindAssignmentTargetFlow(node.left);
          } else {
            bindAssignmentTargetFlow(node);
          }
        }
        function bindAssignmentTargetFlow(node) {
          if (isNarrowableReference(node)) {
            currentFlow = createFlowMutation(16, currentFlow, node);
          } else if (node.kind === 204) {
            for (var _i = 0, _a = node.elements; _i < _a.length; _i++) {
              var e = _a[_i];
              if (e.kind === 225) {
                bindAssignmentTargetFlow(e.expression);
              } else {
                bindDestructuringTargetFlow(e);
              }
            }
          } else if (node.kind === 205) {
            for (var _b = 0, _c = node.properties; _b < _c.length; _b++) {
              var p = _c[_b];
              if (p.kind === 296) {
                bindDestructuringTargetFlow(p.initializer);
              } else if (p.kind === 297) {
                bindAssignmentTargetFlow(p.name);
              } else if (p.kind === 298) {
                bindAssignmentTargetFlow(p.expression);
              }
            }
          }
        }
        function bindLogicalLikeExpression(node, trueTarget, falseTarget) {
          var preRightLabel = createBranchLabel();
          if (node.operatorToken.kind === 55 || node.operatorToken.kind === 76) {
            bindCondition(node.left, preRightLabel, falseTarget);
          } else {
            bindCondition(node.left, trueTarget, preRightLabel);
          }
          currentFlow = finishFlowLabel(preRightLabel);
          bind(node.operatorToken);
          if (ts3.isLogicalOrCoalescingAssignmentOperator(node.operatorToken.kind)) {
            doWithConditionalBranches(bind, node.right, trueTarget, falseTarget);
            bindAssignmentTargetFlow(node.left);
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          } else {
            bindCondition(node.right, trueTarget, falseTarget);
          }
        }
        function bindPrefixUnaryExpressionFlow(node) {
          if (node.operator === 53) {
            var saveTrueTarget = currentTrueTarget;
            currentTrueTarget = currentFalseTarget;
            currentFalseTarget = saveTrueTarget;
            bindEachChild(node);
            currentFalseTarget = currentTrueTarget;
            currentTrueTarget = saveTrueTarget;
          } else {
            bindEachChild(node);
            if (node.operator === 45 || node.operator === 46) {
              bindAssignmentTargetFlow(node.operand);
            }
          }
        }
        function bindPostfixUnaryExpressionFlow(node) {
          bindEachChild(node);
          if (node.operator === 45 || node.operator === 46) {
            bindAssignmentTargetFlow(node.operand);
          }
        }
        function bindDestructuringAssignmentFlow(node) {
          if (inAssignmentPattern) {
            inAssignmentPattern = false;
            bind(node.operatorToken);
            bind(node.right);
            inAssignmentPattern = true;
            bind(node.left);
          } else {
            inAssignmentPattern = true;
            bind(node.left);
            inAssignmentPattern = false;
            bind(node.operatorToken);
            bind(node.right);
          }
          bindAssignmentTargetFlow(node.left);
        }
        function createBindBinaryExpressionFlow() {
          return ts3.createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, void 0);
          function onEnter(node, state) {
            if (state) {
              state.stackIndex++;
              ts3.setParent(node, parent);
              var saveInStrictMode = inStrictMode;
              bindWorker(node);
              var saveParent = parent;
              parent = node;
              state.skip = false;
              state.inStrictModeStack[state.stackIndex] = saveInStrictMode;
              state.parentStack[state.stackIndex] = saveParent;
            } else {
              state = {
                stackIndex: 0,
                skip: false,
                inStrictModeStack: [void 0],
                parentStack: [void 0]
              };
            }
            var operator = node.operatorToken.kind;
            if (operator === 55 || operator === 56 || operator === 60 || ts3.isLogicalOrCoalescingAssignmentOperator(operator)) {
              if (isTopLevelLogicalExpression(node)) {
                var postExpressionLabel = createBranchLabel();
                bindLogicalLikeExpression(node, postExpressionLabel, postExpressionLabel);
                currentFlow = finishFlowLabel(postExpressionLabel);
              } else {
                bindLogicalLikeExpression(node, currentTrueTarget, currentFalseTarget);
              }
              state.skip = true;
            }
            return state;
          }
          function onLeft(left, state, node) {
            if (!state.skip) {
              var maybeBound = maybeBind(left);
              if (node.operatorToken.kind === 27) {
                maybeBindExpressionFlowIfCall(left);
              }
              return maybeBound;
            }
          }
          function onOperator(operatorToken, state, _node) {
            if (!state.skip) {
              bind(operatorToken);
            }
          }
          function onRight(right, state, node) {
            if (!state.skip) {
              var maybeBound = maybeBind(right);
              if (node.operatorToken.kind === 27) {
                maybeBindExpressionFlowIfCall(right);
              }
              return maybeBound;
            }
          }
          function onExit(node, state) {
            if (!state.skip) {
              var operator = node.operatorToken.kind;
              if (ts3.isAssignmentOperator(operator) && !ts3.isAssignmentTarget(node)) {
                bindAssignmentTargetFlow(node.left);
                if (operator === 63 && node.left.kind === 207) {
                  var elementAccess = node.left;
                  if (isNarrowableOperand(elementAccess.expression)) {
                    currentFlow = createFlowMutation(256, currentFlow, node);
                  }
                }
              }
            }
            var savedInStrictMode = state.inStrictModeStack[state.stackIndex];
            var savedParent = state.parentStack[state.stackIndex];
            if (savedInStrictMode !== void 0) {
              inStrictMode = savedInStrictMode;
            }
            if (savedParent !== void 0) {
              parent = savedParent;
            }
            state.skip = false;
            state.stackIndex--;
          }
          function maybeBind(node) {
            if (node && ts3.isBinaryExpression(node) && !ts3.isDestructuringAssignment(node)) {
              return node;
            }
            bind(node);
          }
        }
        function bindDeleteExpressionFlow(node) {
          bindEachChild(node);
          if (node.expression.kind === 206) {
            bindAssignmentTargetFlow(node.expression);
          }
        }
        function bindConditionalExpressionFlow(node) {
          var trueLabel = createBranchLabel();
          var falseLabel = createBranchLabel();
          var postExpressionLabel = createBranchLabel();
          bindCondition(node.condition, trueLabel, falseLabel);
          currentFlow = finishFlowLabel(trueLabel);
          bind(node.questionToken);
          bind(node.whenTrue);
          addAntecedent(postExpressionLabel, currentFlow);
          currentFlow = finishFlowLabel(falseLabel);
          bind(node.colonToken);
          bind(node.whenFalse);
          addAntecedent(postExpressionLabel, currentFlow);
          currentFlow = finishFlowLabel(postExpressionLabel);
        }
        function bindInitializedVariableFlow(node) {
          var name = !ts3.isOmittedExpression(node) ? node.name : void 0;
          if (ts3.isBindingPattern(name)) {
            for (var _i = 0, _a = name.elements; _i < _a.length; _i++) {
              var child = _a[_i];
              bindInitializedVariableFlow(child);
            }
          } else {
            currentFlow = createFlowMutation(16, currentFlow, node);
          }
        }
        function bindVariableDeclarationFlow(node) {
          bindEachChild(node);
          if (node.initializer || ts3.isForInOrOfStatement(node.parent.parent)) {
            bindInitializedVariableFlow(node);
          }
        }
        function bindBindingElementFlow(node) {
          if (ts3.isBindingPattern(node.name)) {
            bindEach(node.decorators);
            bindEach(node.modifiers);
            bind(node.dotDotDotToken);
            bind(node.propertyName);
            bind(node.initializer);
            bind(node.name);
          } else {
            bindEachChild(node);
          }
        }
        function bindJSDocTypeAlias(node) {
          bind(node.tagName);
          if (node.kind !== 339 && node.fullName) {
            ts3.setParent(node.fullName, node);
            ts3.setParentRecursive(node.fullName, false);
          }
          if (typeof node.comment !== "string") {
            bindEach(node.comment);
          }
        }
        function bindJSDocClassTag(node) {
          bindEachChild(node);
          var host = ts3.getHostSignatureFromJSDoc(node);
          if (host && host.kind !== 169) {
            addDeclarationToSymbol(host.symbol, host, 32);
          }
        }
        function bindOptionalExpression(node, trueTarget, falseTarget) {
          doWithConditionalBranches(bind, node, trueTarget, falseTarget);
          if (!ts3.isOptionalChain(node) || ts3.isOutermostOptionalChain(node)) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindOptionalChainRest(node) {
          switch (node.kind) {
            case 206:
              bind(node.questionDotToken);
              bind(node.name);
              break;
            case 207:
              bind(node.questionDotToken);
              bind(node.argumentExpression);
              break;
            case 208:
              bind(node.questionDotToken);
              bindEach(node.typeArguments);
              bindEach(node.arguments);
              break;
          }
        }
        function bindOptionalChain(node, trueTarget, falseTarget) {
          var preChainLabel = ts3.isOptionalChainRoot(node) ? createBranchLabel() : void 0;
          bindOptionalExpression(node.expression, preChainLabel || trueTarget, falseTarget);
          if (preChainLabel) {
            currentFlow = finishFlowLabel(preChainLabel);
          }
          doWithConditionalBranches(bindOptionalChainRest, node, trueTarget, falseTarget);
          if (ts3.isOutermostOptionalChain(node)) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindOptionalChainFlow(node) {
          if (isTopLevelLogicalExpression(node)) {
            var postExpressionLabel = createBranchLabel();
            bindOptionalChain(node, postExpressionLabel, postExpressionLabel);
            currentFlow = finishFlowLabel(postExpressionLabel);
          } else {
            bindOptionalChain(node, currentTrueTarget, currentFalseTarget);
          }
        }
        function bindNonNullExpressionFlow(node) {
          if (ts3.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            bindEachChild(node);
          }
        }
        function bindAccessExpressionFlow(node) {
          if (ts3.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            bindEachChild(node);
          }
        }
        function bindCallExpressionFlow(node) {
          if (ts3.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            var expr = ts3.skipParentheses(node.expression);
            if (expr.kind === 213 || expr.kind === 214) {
              bindEach(node.typeArguments);
              bindEach(node.arguments);
              bind(node.expression);
            } else {
              bindEachChild(node);
              if (node.expression.kind === 106) {
                currentFlow = createFlowCall(currentFlow, node);
              }
            }
          }
          if (node.expression.kind === 206) {
            var propertyAccess = node.expression;
            if (ts3.isIdentifier(propertyAccess.name) && isNarrowableOperand(propertyAccess.expression) && ts3.isPushOrUnshiftIdentifier(propertyAccess.name)) {
              currentFlow = createFlowMutation(256, currentFlow, node);
            }
          }
        }
        function getContainerFlags(node) {
          switch (node.kind) {
            case 226:
            case 257:
            case 260:
            case 205:
            case 182:
            case 322:
            case 286:
              return 1;
            case 258:
              return 1 | 64;
            case 261:
            case 259:
            case 195:
            case 176:
              return 1 | 32;
            case 305:
              return 1 | 4 | 32;
            case 172:
            case 173:
            case 169:
              if (ts3.isObjectLiteralOrClassExpressionMethodOrAccessor(node)) {
                return 1 | 4 | 32 | 8 | 128;
              }
            case 171:
            case 256:
            case 168:
            case 174:
            case 323:
            case 317:
            case 179:
            case 175:
            case 180:
            case 170:
              return 1 | 4 | 32 | 8;
            case 213:
            case 214:
              return 1 | 4 | 32 | 8 | 16;
            case 262:
              return 4;
            case 167:
              return node.initializer ? 4 : 0;
            case 292:
            case 242:
            case 243:
            case 244:
            case 263:
              return 2;
            case 235:
              return ts3.isFunctionLike(node.parent) || ts3.isClassStaticBlockDeclaration(node.parent) ? 0 : 2;
          }
          return 0;
        }
        function addToContainerChain(next) {
          if (lastContainer) {
            lastContainer.nextContainer = next;
          }
          lastContainer = next;
        }
        function declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes) {
          switch (container.kind) {
            case 261:
              return declareModuleMember(node, symbolFlags, symbolExcludes);
            case 305:
              return declareSourceFileMember(node, symbolFlags, symbolExcludes);
            case 226:
            case 257:
              return declareClassMember(node, symbolFlags, symbolExcludes);
            case 260:
              return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
            case 182:
            case 322:
            case 205:
            case 258:
            case 286:
              return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
            case 179:
            case 180:
            case 174:
            case 175:
            case 323:
            case 176:
            case 169:
            case 168:
            case 171:
            case 172:
            case 173:
            case 256:
            case 213:
            case 214:
            case 317:
            case 345:
            case 338:
            case 170:
            case 259:
            case 195:
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
          }
        }
        function declareClassMember(node, symbolFlags, symbolExcludes) {
          return ts3.isStatic(node) ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes) : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
        function declareSourceFileMember(node, symbolFlags, symbolExcludes) {
          return ts3.isExternalModule(file) ? declareModuleMember(node, symbolFlags, symbolExcludes) : declareSymbol(file.locals, void 0, node, symbolFlags, symbolExcludes);
        }
        function hasExportDeclarations(node) {
          var body = ts3.isSourceFile(node) ? node : ts3.tryCast(node.body, ts3.isModuleBlock);
          return !!body && body.statements.some(function(s) {
            return ts3.isExportDeclaration(s) || ts3.isExportAssignment(s);
          });
        }
        function setExportContextFlag(node) {
          if (node.flags & 16777216 && !hasExportDeclarations(node)) {
            node.flags |= 64;
          } else {
            node.flags &= ~64;
          }
        }
        function bindModuleDeclaration(node) {
          setExportContextFlag(node);
          if (ts3.isAmbientModule(node)) {
            if (ts3.hasSyntacticModifier(node, 1)) {
              errorOnFirstToken(node, ts3.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible);
            }
            if (ts3.isModuleAugmentationExternal(node)) {
              declareModuleSymbol(node);
            } else {
              var pattern = void 0;
              if (node.name.kind === 10) {
                var text = node.name.text;
                pattern = ts3.tryParsePattern(text);
                if (pattern === void 0) {
                  errorOnFirstToken(node.name, ts3.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, text);
                }
              }
              var symbol = declareSymbolAndAddToSymbolTable(node, 512, 110735);
              file.patternAmbientModules = ts3.append(file.patternAmbientModules, pattern && !ts3.isString(pattern) ? { pattern, symbol } : void 0);
            }
          } else {
            var state = declareModuleSymbol(node);
            if (state !== 0) {
              var symbol = node.symbol;
              symbol.constEnumOnlyModule = !(symbol.flags & (16 | 32 | 256)) && state === 2 && symbol.constEnumOnlyModule !== false;
            }
          }
        }
        function declareModuleSymbol(node) {
          var state = getModuleInstanceState(node);
          var instantiated = state !== 0;
          declareSymbolAndAddToSymbolTable(node, instantiated ? 512 : 1024, instantiated ? 110735 : 0);
          return state;
        }
        function bindFunctionOrConstructorType(node) {
          var symbol = createSymbol(131072, getDeclarationName(node));
          addDeclarationToSymbol(symbol, node, 131072);
          var typeLiteralSymbol = createSymbol(2048, "__type");
          addDeclarationToSymbol(typeLiteralSymbol, node, 2048);
          typeLiteralSymbol.members = ts3.createSymbolTable();
          typeLiteralSymbol.members.set(symbol.escapedName, symbol);
        }
        function bindObjectLiteralExpression(node) {
          var ElementKind;
          (function(ElementKind2) {
            ElementKind2[ElementKind2["Property"] = 1] = "Property";
            ElementKind2[ElementKind2["Accessor"] = 2] = "Accessor";
          })(ElementKind || (ElementKind = {}));
          if (inStrictMode && !ts3.isAssignmentTarget(node)) {
            var seen = new ts3.Map();
            for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
              var prop = _a[_i];
              if (prop.kind === 298 || prop.name.kind !== 79) {
                continue;
              }
              var identifier = prop.name;
              var currentKind = prop.kind === 296 || prop.kind === 297 || prop.kind === 169 ? 1 : 2;
              var existingKind = seen.get(identifier.escapedText);
              if (!existingKind) {
                seen.set(identifier.escapedText, currentKind);
                continue;
              }
            }
          }
          return bindAnonymousDeclaration(node, 4096, "__object");
        }
        function bindJsxAttributes(node) {
          return bindAnonymousDeclaration(node, 4096, "__jsxAttributes");
        }
        function bindJsxAttribute(node, symbolFlags, symbolExcludes) {
          return declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
        function bindAnonymousDeclaration(node, symbolFlags, name) {
          var symbol = createSymbol(symbolFlags, name);
          if (symbolFlags & (8 | 106500)) {
            symbol.parent = container.symbol;
          }
          addDeclarationToSymbol(symbol, node, symbolFlags);
          return symbol;
        }
        function bindBlockScopedDeclaration(node, symbolFlags, symbolExcludes) {
          switch (blockScopeContainer.kind) {
            case 261:
              declareModuleMember(node, symbolFlags, symbolExcludes);
              break;
            case 305:
              if (ts3.isExternalOrCommonJsModule(container)) {
                declareModuleMember(node, symbolFlags, symbolExcludes);
                break;
              }
            default:
              if (!blockScopeContainer.locals) {
                blockScopeContainer.locals = ts3.createSymbolTable();
                addToContainerChain(blockScopeContainer);
              }
              declareSymbol(blockScopeContainer.locals, void 0, node, symbolFlags, symbolExcludes);
          }
        }
        function delayedBindJSDocTypedefTag() {
          if (!delayedTypeAliases) {
            return;
          }
          var saveContainer = container;
          var saveLastContainer = lastContainer;
          var saveBlockScopeContainer = blockScopeContainer;
          var saveParent = parent;
          var saveCurrentFlow = currentFlow;
          for (var _i = 0, delayedTypeAliases_1 = delayedTypeAliases; _i < delayedTypeAliases_1.length; _i++) {
            var typeAlias = delayedTypeAliases_1[_i];
            var host = typeAlias.parent.parent;
            container = ts3.findAncestor(host.parent, function(n) {
              return !!(getContainerFlags(n) & 1);
            }) || file;
            blockScopeContainer = ts3.getEnclosingBlockScopeContainer(host) || file;
            currentFlow = initFlowNode({ flags: 2 });
            parent = typeAlias;
            bind(typeAlias.typeExpression);
            var declName = ts3.getNameOfDeclaration(typeAlias);
            if ((ts3.isJSDocEnumTag(typeAlias) || !typeAlias.fullName) && declName && ts3.isPropertyAccessEntityNameExpression(declName.parent)) {
              var isTopLevel = isTopLevelNamespaceAssignment(declName.parent);
              if (isTopLevel) {
                bindPotentiallyMissingNamespaces(file.symbol, declName.parent, isTopLevel, !!ts3.findAncestor(declName, function(d) {
                  return ts3.isPropertyAccessExpression(d) && d.name.escapedText === "prototype";
                }), false);
                var oldContainer = container;
                switch (ts3.getAssignmentDeclarationPropertyAccessKind(declName.parent)) {
                  case 1:
                  case 2:
                    if (!ts3.isExternalOrCommonJsModule(file)) {
                      container = void 0;
                    } else {
                      container = file;
                    }
                    break;
                  case 4:
                    container = declName.parent.expression;
                    break;
                  case 3:
                    container = declName.parent.expression.name;
                    break;
                  case 5:
                    container = isExportsOrModuleExportsOrAlias(file, declName.parent.expression) ? file : ts3.isPropertyAccessExpression(declName.parent.expression) ? declName.parent.expression.name : declName.parent.expression;
                    break;
                  case 0:
                    return ts3.Debug.fail("Shouldn't have detected typedef or enum on non-assignment declaration");
                }
                if (container) {
                  declareModuleMember(typeAlias, 524288, 788968);
                }
                container = oldContainer;
              }
            } else if (ts3.isJSDocEnumTag(typeAlias) || !typeAlias.fullName || typeAlias.fullName.kind === 79) {
              parent = typeAlias.parent;
              bindBlockScopedDeclaration(typeAlias, 524288, 788968);
            } else {
              bind(typeAlias.fullName);
            }
          }
          container = saveContainer;
          lastContainer = saveLastContainer;
          blockScopeContainer = saveBlockScopeContainer;
          parent = saveParent;
          currentFlow = saveCurrentFlow;
        }
        function checkContextualIdentifier(node) {
          if (!file.parseDiagnostics.length && !(node.flags & 16777216) && !(node.flags & 8388608) && !ts3.isIdentifierName(node)) {
            if (inStrictMode && node.originalKeywordKind >= 117 && node.originalKeywordKind <= 125) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, getStrictModeIdentifierMessage(node), ts3.declarationNameToString(node)));
            } else if (node.originalKeywordKind === 132) {
              if (ts3.isExternalModule(file) && ts3.isInTopLevelContext(node)) {
                file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module, ts3.declarationNameToString(node)));
              } else if (node.flags & 32768) {
                file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, ts3.declarationNameToString(node)));
              }
            } else if (node.originalKeywordKind === 125 && node.flags & 8192) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, ts3.declarationNameToString(node)));
            }
          }
        }
        function getStrictModeIdentifierMessage(node) {
          if (ts3.getContainingClass(node)) {
            return ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode;
          }
          return ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode;
        }
        function checkPrivateIdentifier(node) {
          if (node.escapedText === "#constructor") {
            if (!file.parseDiagnostics.length) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.constructor_is_a_reserved_word, ts3.declarationNameToString(node)));
            }
          }
        }
        function checkStrictModeBinaryExpression(node) {
          if (inStrictMode && ts3.isLeftHandSideExpression(node.left) && ts3.isAssignmentOperator(node.operatorToken.kind)) {
            checkStrictModeEvalOrArguments(node, node.left);
          }
        }
        function checkStrictModeCatchClause(node) {
          if (inStrictMode && node.variableDeclaration) {
            checkStrictModeEvalOrArguments(node, node.variableDeclaration.name);
          }
        }
        function checkStrictModeDeleteExpression(node) {
          if (inStrictMode && node.expression.kind === 79) {
            var span = ts3.getErrorSpanForNode(file, node.expression);
            file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, ts3.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode));
          }
        }
        function isEvalOrArgumentsIdentifier(node) {
          return ts3.isIdentifier(node) && (node.escapedText === "eval" || node.escapedText === "arguments");
        }
        function checkStrictModeEvalOrArguments(contextNode, name) {
          if (name && name.kind === 79) {
            var identifier = name;
            if (isEvalOrArgumentsIdentifier(identifier)) {
              var span = ts3.getErrorSpanForNode(file, name);
              file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, getStrictModeEvalOrArgumentsMessage(contextNode), ts3.idText(identifier)));
            }
          }
        }
        function getStrictModeEvalOrArgumentsMessage(node) {
          if (ts3.getContainingClass(node)) {
            return ts3.Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts3.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode;
          }
          return ts3.Diagnostics.Invalid_use_of_0_in_strict_mode;
        }
        function checkStrictModeFunctionName(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
        }
        function getStrictModeBlockScopeFunctionDeclarationMessage(node) {
          if (ts3.getContainingClass(node)) {
            return ts3.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts3.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode;
          }
          return ts3.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5;
        }
        function checkStrictModeFunctionDeclaration(node) {
          if (languageVersion < 2) {
            if (blockScopeContainer.kind !== 305 && blockScopeContainer.kind !== 261 && !ts3.isFunctionLikeOrClassStaticBlockDeclaration(blockScopeContainer)) {
              var errorSpan = ts3.getErrorSpanForNode(file, node);
              file.bindDiagnostics.push(ts3.createFileDiagnostic(file, errorSpan.start, errorSpan.length, getStrictModeBlockScopeFunctionDeclarationMessage(node)));
            }
          }
        }
        function checkStrictModeNumericLiteral(node) {
          if (languageVersion < 1 && inStrictMode && node.numericLiteralFlags & 32) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode));
          }
        }
        function checkStrictModePostfixUnaryExpression(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.operand);
          }
        }
        function checkStrictModePrefixUnaryExpression(node) {
          if (inStrictMode) {
            if (node.operator === 45 || node.operator === 46) {
              checkStrictModeEvalOrArguments(node, node.operand);
            }
          }
        }
        function checkStrictModeWithStatement(node) {
          if (inStrictMode) {
            errorOnFirstToken(node, ts3.Diagnostics.with_statements_are_not_allowed_in_strict_mode);
          }
        }
        function checkStrictModeLabeledStatement(node) {
          if (inStrictMode && ts3.getEmitScriptTarget(options) >= 2) {
            if (ts3.isDeclarationStatement(node.statement) || ts3.isVariableStatement(node.statement)) {
              errorOnFirstToken(node.label, ts3.Diagnostics.A_label_is_not_allowed_here);
            }
          }
        }
        function errorOnFirstToken(node, message, arg0, arg1, arg2) {
          var span = ts3.getSpanOfTokenAtPosition(file, node.pos);
          file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, message, arg0, arg1, arg2));
        }
        function errorOrSuggestionOnNode(isError, node, message) {
          errorOrSuggestionOnRange(isError, node, node, message);
        }
        function errorOrSuggestionOnRange(isError, startNode, endNode, message) {
          addErrorOrSuggestionDiagnostic(isError, { pos: ts3.getTokenPosOfNode(startNode, file), end: endNode.end }, message);
        }
        function addErrorOrSuggestionDiagnostic(isError, range, message) {
          var diag = ts3.createFileDiagnostic(file, range.pos, range.end - range.pos, message);
          if (isError) {
            file.bindDiagnostics.push(diag);
          } else {
            file.bindSuggestionDiagnostics = ts3.append(file.bindSuggestionDiagnostics, __assign(__assign({}, diag), { category: ts3.DiagnosticCategory.Suggestion }));
          }
        }
        function bind(node) {
          if (!node) {
            return;
          }
          ts3.setParent(node, parent);
          if (ts3.tracing)
            node.tracingPath = file.path;
          var saveInStrictMode = inStrictMode;
          bindWorker(node);
          if (node.kind > 160) {
            var saveParent = parent;
            parent = node;
            var containerFlags = getContainerFlags(node);
            if (containerFlags === 0) {
              bindChildren(node);
            } else {
              bindContainer(node, containerFlags);
            }
            parent = saveParent;
          } else {
            var saveParent = parent;
            if (node.kind === 1)
              parent = node;
            bindJSDoc(node);
            parent = saveParent;
          }
          inStrictMode = saveInStrictMode;
        }
        function bindJSDoc(node) {
          if (ts3.hasJSDocNodes(node)) {
            if (ts3.isInJSFile(node)) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var j = _a[_i];
                bind(j);
              }
            } else {
              for (var _b = 0, _c = node.jsDoc; _b < _c.length; _b++) {
                var j = _c[_b];
                ts3.setParent(j, node);
                ts3.setParentRecursive(j, false);
              }
            }
          }
        }
        function updateStrictModeStatementList(statements) {
          if (!inStrictMode) {
            for (var _i = 0, statements_3 = statements; _i < statements_3.length; _i++) {
              var statement = statements_3[_i];
              if (!ts3.isPrologueDirective(statement)) {
                return;
              }
              if (isUseStrictPrologueDirective(statement)) {
                inStrictMode = true;
                return;
              }
            }
          }
        }
        function isUseStrictPrologueDirective(node) {
          var nodeText = ts3.getSourceTextOfNodeFromSourceFile(file, node.expression);
          return nodeText === '"use strict"' || nodeText === "'use strict'";
        }
        function bindWorker(node) {
          switch (node.kind) {
            case 79:
              if (node.isInJSDocNamespace) {
                var parentNode = node.parent;
                while (parentNode && !ts3.isJSDocTypeAlias(parentNode)) {
                  parentNode = parentNode.parent;
                }
                bindBlockScopedDeclaration(parentNode, 524288, 788968);
                break;
              }
            case 108:
              if (currentFlow && (ts3.isExpression(node) || parent.kind === 297)) {
                node.flowNode = currentFlow;
              }
              return checkContextualIdentifier(node);
            case 161:
              if (currentFlow && ts3.isPartOfTypeQuery(node)) {
                node.flowNode = currentFlow;
              }
              break;
            case 231:
            case 106:
              node.flowNode = currentFlow;
              break;
            case 80:
              return checkPrivateIdentifier(node);
            case 206:
            case 207:
              var expr = node;
              if (currentFlow && isNarrowableReference(expr)) {
                expr.flowNode = currentFlow;
              }
              if (ts3.isSpecialPropertyDeclaration(expr)) {
                bindSpecialPropertyDeclaration(expr);
              }
              if (ts3.isInJSFile(expr) && file.commonJsModuleIndicator && ts3.isModuleExportsAccessExpression(expr) && !lookupSymbolForName(blockScopeContainer, "module")) {
                declareSymbol(file.locals, void 0, expr.expression, 1 | 134217728, 111550);
              }
              break;
            case 221:
              var specialKind = ts3.getAssignmentDeclarationKind(node);
              switch (specialKind) {
                case 1:
                  bindExportsPropertyAssignment(node);
                  break;
                case 2:
                  bindModuleExportsAssignment(node);
                  break;
                case 3:
                  bindPrototypePropertyAssignment(node.left, node);
                  break;
                case 6:
                  bindPrototypeAssignment(node);
                  break;
                case 4:
                  bindThisPropertyAssignment(node);
                  break;
                case 5:
                  var expression = node.left.expression;
                  if (ts3.isInJSFile(node) && ts3.isIdentifier(expression)) {
                    var symbol = lookupSymbolForName(blockScopeContainer, expression.escapedText);
                    if (ts3.isThisInitializedDeclaration(symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration)) {
                      bindThisPropertyAssignment(node);
                      break;
                    }
                  }
                  bindSpecialPropertyAssignment(node);
                  break;
                case 0:
                  break;
                default:
                  ts3.Debug.fail("Unknown binary expression special property assignment kind");
              }
              return checkStrictModeBinaryExpression(node);
            case 292:
              return checkStrictModeCatchClause(node);
            case 215:
              return checkStrictModeDeleteExpression(node);
            case 8:
              return checkStrictModeNumericLiteral(node);
            case 220:
              return checkStrictModePostfixUnaryExpression(node);
            case 219:
              return checkStrictModePrefixUnaryExpression(node);
            case 248:
              return checkStrictModeWithStatement(node);
            case 250:
              return checkStrictModeLabeledStatement(node);
            case 192:
              seenThisKeyword = true;
              return;
            case 177:
              break;
            case 163:
              return bindTypeParameter(node);
            case 164:
              return bindParameter(node);
            case 254:
              return bindVariableDeclarationOrBindingElement(node);
            case 203:
              node.flowNode = currentFlow;
              return bindVariableDeclarationOrBindingElement(node);
            case 167:
            case 166:
              return bindPropertyWorker(node);
            case 296:
            case 297:
              return bindPropertyOrMethodOrAccessor(node, 4, 0);
            case 299:
              return bindPropertyOrMethodOrAccessor(node, 8, 900095);
            case 174:
            case 175:
            case 176:
              return declareSymbolAndAddToSymbolTable(node, 131072, 0);
            case 169:
            case 168:
              return bindPropertyOrMethodOrAccessor(node, 8192 | (node.questionToken ? 16777216 : 0), ts3.isObjectLiteralMethod(node) ? 0 : 103359);
            case 256:
              return bindFunctionDeclaration(node);
            case 171:
              return declareSymbolAndAddToSymbolTable(node, 16384, 0);
            case 172:
              return bindPropertyOrMethodOrAccessor(node, 32768, 46015);
            case 173:
              return bindPropertyOrMethodOrAccessor(node, 65536, 78783);
            case 179:
            case 317:
            case 323:
            case 180:
              return bindFunctionOrConstructorType(node);
            case 182:
            case 322:
            case 195:
              return bindAnonymousTypeWorker(node);
            case 332:
              return bindJSDocClassTag(node);
            case 205:
              return bindObjectLiteralExpression(node);
            case 213:
            case 214:
              return bindFunctionExpression(node);
            case 208:
              var assignmentKind = ts3.getAssignmentDeclarationKind(node);
              switch (assignmentKind) {
                case 7:
                  return bindObjectDefinePropertyAssignment(node);
                case 8:
                  return bindObjectDefinePropertyExport(node);
                case 9:
                  return bindObjectDefinePrototypeProperty(node);
                case 0:
                  break;
                default:
                  return ts3.Debug.fail("Unknown call expression assignment declaration kind");
              }
              if (ts3.isInJSFile(node)) {
                bindCallExpression(node);
              }
              break;
            case 226:
            case 257:
              inStrictMode = true;
              return bindClassLikeDeclaration(node);
            case 258:
              return bindBlockScopedDeclaration(node, 64, 788872);
            case 259:
              return bindBlockScopedDeclaration(node, 524288, 788968);
            case 260:
              return bindEnumDeclaration(node);
            case 261:
              return bindModuleDeclaration(node);
            case 286:
              return bindJsxAttributes(node);
            case 285:
              return bindJsxAttribute(node, 4, 0);
            case 265:
            case 268:
            case 270:
            case 275:
              return declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
            case 264:
              return bindNamespaceExportDeclaration(node);
            case 267:
              return bindImportClause(node);
            case 272:
              return bindExportDeclaration(node);
            case 271:
              return bindExportAssignment(node);
            case 305:
              updateStrictModeStatementList(node.statements);
              return bindSourceFileIfExternalModule();
            case 235:
              if (!ts3.isFunctionLikeOrClassStaticBlockDeclaration(node.parent)) {
                return;
              }
            case 262:
              return updateStrictModeStatementList(node.statements);
            case 340:
              if (node.parent.kind === 323) {
                return bindParameter(node);
              }
              if (node.parent.kind !== 322) {
                break;
              }
            case 347:
              var propTag = node;
              var flags = propTag.isBracketed || propTag.typeExpression && propTag.typeExpression.type.kind === 316 ? 4 | 16777216 : 4;
              return declareSymbolAndAddToSymbolTable(propTag, flags, 0);
            case 345:
            case 338:
            case 339:
              return (delayedTypeAliases || (delayedTypeAliases = [])).push(node);
          }
        }
        function bindPropertyWorker(node) {
          return bindPropertyOrMethodOrAccessor(node, 4 | (node.questionToken ? 16777216 : 0), 0);
        }
        function bindAnonymousTypeWorker(node) {
          return bindAnonymousDeclaration(node, 2048, "__type");
        }
        function bindSourceFileIfExternalModule() {
          setExportContextFlag(file);
          if (ts3.isExternalModule(file)) {
            bindSourceFileAsExternalModule();
          } else if (ts3.isJsonSourceFile(file)) {
            bindSourceFileAsExternalModule();
            var originalSymbol = file.symbol;
            declareSymbol(file.symbol.exports, file.symbol, file, 4, 67108863);
            file.symbol = originalSymbol;
          }
        }
        function bindSourceFileAsExternalModule() {
          bindAnonymousDeclaration(file, 512, '"'.concat(ts3.removeFileExtension(file.fileName), '"'));
        }
        function bindExportAssignment(node) {
          if (!container.symbol || !container.symbol.exports) {
            bindAnonymousDeclaration(node, 111551, getDeclarationName(node));
          } else {
            var flags = ts3.exportAssignmentIsAlias(node) ? 2097152 : 4;
            var symbol = declareSymbol(container.symbol.exports, container.symbol, node, flags, 67108863);
            if (node.isExportEquals) {
              ts3.setValueDeclaration(symbol, node);
            }
          }
        }
        function bindNamespaceExportDeclaration(node) {
          if (node.modifiers && node.modifiers.length) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Modifiers_cannot_appear_here));
          }
          var diag = !ts3.isSourceFile(node.parent) ? ts3.Diagnostics.Global_module_exports_may_only_appear_at_top_level : !ts3.isExternalModule(node.parent) ? ts3.Diagnostics.Global_module_exports_may_only_appear_in_module_files : !node.parent.isDeclarationFile ? ts3.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files : void 0;
          if (diag) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, diag));
          } else {
            file.symbol.globalExports = file.symbol.globalExports || ts3.createSymbolTable();
            declareSymbol(file.symbol.globalExports, file.symbol, node, 2097152, 2097152);
          }
        }
        function bindExportDeclaration(node) {
          if (!container.symbol || !container.symbol.exports) {
            bindAnonymousDeclaration(node, 8388608, getDeclarationName(node));
          } else if (!node.exportClause) {
            declareSymbol(container.symbol.exports, container.symbol, node, 8388608, 0);
          } else if (ts3.isNamespaceExport(node.exportClause)) {
            ts3.setParent(node.exportClause, node);
            declareSymbol(container.symbol.exports, container.symbol, node.exportClause, 2097152, 2097152);
          }
        }
        function bindImportClause(node) {
          if (node.name) {
            declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
          }
        }
        function setCommonJsModuleIndicator(node) {
          if (file.externalModuleIndicator && file.externalModuleIndicator !== true) {
            return false;
          }
          if (!file.commonJsModuleIndicator) {
            file.commonJsModuleIndicator = node;
            if (!file.externalModuleIndicator) {
              bindSourceFileAsExternalModule();
            }
          }
          return true;
        }
        function bindObjectDefinePropertyExport(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var symbol = forEachIdentifierInEntityName(node.arguments[0], void 0, function(id, symbol2) {
            if (symbol2) {
              addDeclarationToSymbol(symbol2, id, 1536 | 67108864);
            }
            return symbol2;
          });
          if (symbol) {
            var flags = 4 | 1048576;
            declareSymbol(symbol.exports, symbol, node, flags, 0);
          }
        }
        function bindExportsPropertyAssignment(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var symbol = forEachIdentifierInEntityName(node.left.expression, void 0, function(id, symbol2) {
            if (symbol2) {
              addDeclarationToSymbol(symbol2, id, 1536 | 67108864);
            }
            return symbol2;
          });
          if (symbol) {
            var isAlias = ts3.isAliasableExpression(node.right) && (ts3.isExportsIdentifier(node.left.expression) || ts3.isModuleExportsAccessExpression(node.left.expression));
            var flags = isAlias ? 2097152 : 4 | 1048576;
            ts3.setParent(node.left, node);
            declareSymbol(symbol.exports, symbol, node.left, flags, 0);
          }
        }
        function bindModuleExportsAssignment(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var assignedExpression = ts3.getRightMostAssignedExpression(node.right);
          if (ts3.isEmptyObjectLiteral(assignedExpression) || container === file && isExportsOrModuleExportsOrAlias(file, assignedExpression)) {
            return;
          }
          if (ts3.isObjectLiteralExpression(assignedExpression) && ts3.every(assignedExpression.properties, ts3.isShorthandPropertyAssignment)) {
            ts3.forEach(assignedExpression.properties, bindExportAssignedObjectMemberAlias);
            return;
          }
          var flags = ts3.exportAssignmentIsAlias(node) ? 2097152 : 4 | 1048576 | 512;
          var symbol = declareSymbol(file.symbol.exports, file.symbol, node, flags | 67108864, 0);
          ts3.setValueDeclaration(symbol, node);
        }
        function bindExportAssignedObjectMemberAlias(node) {
          declareSymbol(file.symbol.exports, file.symbol, node, 2097152 | 67108864, 0);
        }
        function bindThisPropertyAssignment(node) {
          ts3.Debug.assert(ts3.isInJSFile(node));
          var hasPrivateIdentifier = ts3.isBinaryExpression(node) && ts3.isPropertyAccessExpression(node.left) && ts3.isPrivateIdentifier(node.left.name) || ts3.isPropertyAccessExpression(node) && ts3.isPrivateIdentifier(node.name);
          if (hasPrivateIdentifier) {
            return;
          }
          var thisContainer = ts3.getThisContainer(node, false);
          switch (thisContainer.kind) {
            case 256:
            case 213:
              var constructorSymbol = thisContainer.symbol;
              if (ts3.isBinaryExpression(thisContainer.parent) && thisContainer.parent.operatorToken.kind === 63) {
                var l = thisContainer.parent.left;
                if (ts3.isBindableStaticAccessExpression(l) && ts3.isPrototypeAccess(l.expression)) {
                  constructorSymbol = lookupSymbolForPropertyAccess(l.expression.expression, thisParentContainer);
                }
              }
              if (constructorSymbol && constructorSymbol.valueDeclaration) {
                constructorSymbol.members = constructorSymbol.members || ts3.createSymbolTable();
                if (ts3.hasDynamicName(node)) {
                  bindDynamicallyNamedThisPropertyAssignment(node, constructorSymbol, constructorSymbol.members);
                } else {
                  declareSymbol(constructorSymbol.members, constructorSymbol, node, 4 | 67108864, 0 & ~4);
                }
                addDeclarationToSymbol(constructorSymbol, constructorSymbol.valueDeclaration, 32);
              }
              break;
            case 171:
            case 167:
            case 169:
            case 172:
            case 173:
            case 170:
              var containingClass = thisContainer.parent;
              var symbolTable = ts3.isStatic(thisContainer) ? containingClass.symbol.exports : containingClass.symbol.members;
              if (ts3.hasDynamicName(node)) {
                bindDynamicallyNamedThisPropertyAssignment(node, containingClass.symbol, symbolTable);
              } else {
                declareSymbol(symbolTable, containingClass.symbol, node, 4 | 67108864, 0, true);
              }
              break;
            case 305:
              if (ts3.hasDynamicName(node)) {
                break;
              } else if (thisContainer.commonJsModuleIndicator) {
                declareSymbol(thisContainer.symbol.exports, thisContainer.symbol, node, 4 | 1048576, 0);
              } else {
                declareSymbolAndAddToSymbolTable(node, 1, 111550);
              }
              break;
            default:
              ts3.Debug.failBadSyntaxKind(thisContainer);
          }
        }
        function bindDynamicallyNamedThisPropertyAssignment(node, symbol, symbolTable) {
          declareSymbol(symbolTable, symbol, node, 4, 0, true, true);
          addLateBoundAssignmentDeclarationToSymbol(node, symbol);
        }
        function addLateBoundAssignmentDeclarationToSymbol(node, symbol) {
          if (symbol) {
            (symbol.assignmentDeclarationMembers || (symbol.assignmentDeclarationMembers = new ts3.Map())).set(ts3.getNodeId(node), node);
          }
        }
        function bindSpecialPropertyDeclaration(node) {
          if (node.expression.kind === 108) {
            bindThisPropertyAssignment(node);
          } else if (ts3.isBindableStaticAccessExpression(node) && node.parent.parent.kind === 305) {
            if (ts3.isPrototypeAccess(node.expression)) {
              bindPrototypePropertyAssignment(node, node.parent);
            } else {
              bindStaticPropertyAssignment(node);
            }
          }
        }
        function bindPrototypeAssignment(node) {
          ts3.setParent(node.left, node);
          ts3.setParent(node.right, node);
          bindPropertyAssignment(node.left.expression, node.left, false, true);
        }
        function bindObjectDefinePrototypeProperty(node) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0].expression);
          if (namespaceSymbol && namespaceSymbol.valueDeclaration) {
            addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32);
          }
          bindPotentiallyNewExpandoMemberToNamespace(node, namespaceSymbol, true);
        }
        function bindPrototypePropertyAssignment(lhs, parent2) {
          var classPrototype = lhs.expression;
          var constructorFunction = classPrototype.expression;
          ts3.setParent(constructorFunction, classPrototype);
          ts3.setParent(classPrototype, lhs);
          ts3.setParent(lhs, parent2);
          bindPropertyAssignment(constructorFunction, lhs, true, true);
        }
        function bindObjectDefinePropertyAssignment(node) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0]);
          var isToplevel = node.parent.parent.kind === 305;
          namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, node.arguments[0], isToplevel, false, false);
          bindPotentiallyNewExpandoMemberToNamespace(node, namespaceSymbol, false);
        }
        function bindSpecialPropertyAssignment(node) {
          var _a;
          var parentSymbol = lookupSymbolForPropertyAccess(node.left.expression, container) || lookupSymbolForPropertyAccess(node.left.expression, blockScopeContainer);
          if (!ts3.isInJSFile(node) && !ts3.isFunctionSymbol(parentSymbol)) {
            return;
          }
          var rootExpr = ts3.getLeftmostAccessExpression(node.left);
          if (ts3.isIdentifier(rootExpr) && ((_a = lookupSymbolForName(container, rootExpr.escapedText)) === null || _a === void 0 ? void 0 : _a.flags) & 2097152) {
            return;
          }
          ts3.setParent(node.left, node);
          ts3.setParent(node.right, node);
          if (ts3.isIdentifier(node.left.expression) && container === file && isExportsOrModuleExportsOrAlias(file, node.left.expression)) {
            bindExportsPropertyAssignment(node);
          } else if (ts3.hasDynamicName(node)) {
            bindAnonymousDeclaration(node, 4 | 67108864, "__computed");
            var sym = bindPotentiallyMissingNamespaces(parentSymbol, node.left.expression, isTopLevelNamespaceAssignment(node.left), false, false);
            addLateBoundAssignmentDeclarationToSymbol(node, sym);
          } else {
            bindStaticPropertyAssignment(ts3.cast(node.left, ts3.isBindableStaticNameExpression));
          }
        }
        function bindStaticPropertyAssignment(node) {
          ts3.Debug.assert(!ts3.isIdentifier(node));
          ts3.setParent(node.expression, node);
          bindPropertyAssignment(node.expression, node, false, false);
        }
        function bindPotentiallyMissingNamespaces(namespaceSymbol, entityName, isToplevel, isPrototypeProperty, containerIsClass) {
          if ((namespaceSymbol === null || namespaceSymbol === void 0 ? void 0 : namespaceSymbol.flags) & 2097152) {
            return namespaceSymbol;
          }
          if (isToplevel && !isPrototypeProperty) {
            var flags_2 = 1536 | 67108864;
            var excludeFlags_1 = 110735 & ~67108864;
            namespaceSymbol = forEachIdentifierInEntityName(entityName, namespaceSymbol, function(id, symbol, parent2) {
              if (symbol) {
                addDeclarationToSymbol(symbol, id, flags_2);
                return symbol;
              } else {
                var table = parent2 ? parent2.exports : file.jsGlobalAugmentations || (file.jsGlobalAugmentations = ts3.createSymbolTable());
                return declareSymbol(table, parent2, id, flags_2, excludeFlags_1);
              }
            });
          }
          if (containerIsClass && namespaceSymbol && namespaceSymbol.valueDeclaration) {
            addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32);
          }
          return namespaceSymbol;
        }
        function bindPotentiallyNewExpandoMemberToNamespace(declaration, namespaceSymbol, isPrototypeProperty) {
          if (!namespaceSymbol || !isExpandoSymbol(namespaceSymbol)) {
            return;
          }
          var symbolTable = isPrototypeProperty ? namespaceSymbol.members || (namespaceSymbol.members = ts3.createSymbolTable()) : namespaceSymbol.exports || (namespaceSymbol.exports = ts3.createSymbolTable());
          var includes = 0;
          var excludes = 0;
          if (ts3.isFunctionLikeDeclaration(ts3.getAssignedExpandoInitializer(declaration))) {
            includes = 8192;
            excludes = 103359;
          } else if (ts3.isCallExpression(declaration) && ts3.isBindableObjectDefinePropertyCall(declaration)) {
            if (ts3.some(declaration.arguments[2].properties, function(p) {
              var id = ts3.getNameOfDeclaration(p);
              return !!id && ts3.isIdentifier(id) && ts3.idText(id) === "set";
            })) {
              includes |= 65536 | 4;
              excludes |= 78783;
            }
            if (ts3.some(declaration.arguments[2].properties, function(p) {
              var id = ts3.getNameOfDeclaration(p);
              return !!id && ts3.isIdentifier(id) && ts3.idText(id) === "get";
            })) {
              includes |= 32768 | 4;
              excludes |= 46015;
            }
          }
          if (includes === 0) {
            includes = 4;
            excludes = 0;
          }
          declareSymbol(symbolTable, namespaceSymbol, declaration, includes | 67108864, excludes & ~67108864);
        }
        function isTopLevelNamespaceAssignment(propertyAccess) {
          return ts3.isBinaryExpression(propertyAccess.parent) ? getParentOfBinaryExpression(propertyAccess.parent).parent.kind === 305 : propertyAccess.parent.parent.kind === 305;
        }
        function bindPropertyAssignment(name, propertyAccess, isPrototypeProperty, containerIsClass) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(name, container) || lookupSymbolForPropertyAccess(name, blockScopeContainer);
          var isToplevel = isTopLevelNamespaceAssignment(propertyAccess);
          namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, propertyAccess.expression, isToplevel, isPrototypeProperty, containerIsClass);
          bindPotentiallyNewExpandoMemberToNamespace(propertyAccess, namespaceSymbol, isPrototypeProperty);
        }
        function isExpandoSymbol(symbol) {
          if (symbol.flags & (16 | 32 | 1024)) {
            return true;
          }
          var node = symbol.valueDeclaration;
          if (node && ts3.isCallExpression(node)) {
            return !!ts3.getAssignedExpandoInitializer(node);
          }
          var init = !node ? void 0 : ts3.isVariableDeclaration(node) ? node.initializer : ts3.isBinaryExpression(node) ? node.right : ts3.isPropertyAccessExpression(node) && ts3.isBinaryExpression(node.parent) ? node.parent.right : void 0;
          init = init && ts3.getRightMostAssignedExpression(init);
          if (init) {
            var isPrototypeAssignment = ts3.isPrototypeAccess(ts3.isVariableDeclaration(node) ? node.name : ts3.isBinaryExpression(node) ? node.left : node);
            return !!ts3.getExpandoInitializer(ts3.isBinaryExpression(init) && (init.operatorToken.kind === 56 || init.operatorToken.kind === 60) ? init.right : init, isPrototypeAssignment);
          }
          return false;
        }
        function getParentOfBinaryExpression(expr) {
          while (ts3.isBinaryExpression(expr.parent)) {
            expr = expr.parent;
          }
          return expr.parent;
        }
        function lookupSymbolForPropertyAccess(node, lookupContainer) {
          if (lookupContainer === void 0) {
            lookupContainer = container;
          }
          if (ts3.isIdentifier(node)) {
            return lookupSymbolForName(lookupContainer, node.escapedText);
          } else {
            var symbol = lookupSymbolForPropertyAccess(node.expression);
            return symbol && symbol.exports && symbol.exports.get(ts3.getElementOrPropertyAccessName(node));
          }
        }
        function forEachIdentifierInEntityName(e, parent2, action) {
          if (isExportsOrModuleExportsOrAlias(file, e)) {
            return file.symbol;
          } else if (ts3.isIdentifier(e)) {
            return action(e, lookupSymbolForPropertyAccess(e), parent2);
          } else {
            var s = forEachIdentifierInEntityName(e.expression, parent2, action);
            var name = ts3.getNameOrArgument(e);
            if (ts3.isPrivateIdentifier(name)) {
              ts3.Debug.fail("unexpected PrivateIdentifier");
            }
            return action(name, s && s.exports && s.exports.get(ts3.getElementOrPropertyAccessName(e)), s);
          }
        }
        function bindCallExpression(node) {
          if (!file.commonJsModuleIndicator && ts3.isRequireCall(node, false)) {
            setCommonJsModuleIndicator(node);
          }
        }
        function bindClassLikeDeclaration(node) {
          if (node.kind === 257) {
            bindBlockScopedDeclaration(node, 32, 899503);
          } else {
            var bindingName = node.name ? node.name.escapedText : "__class";
            bindAnonymousDeclaration(node, 32, bindingName);
            if (node.name) {
              classifiableNames.add(node.name.escapedText);
            }
          }
          var symbol = node.symbol;
          var prototypeSymbol = createSymbol(4 | 4194304, "prototype");
          var symbolExport = symbol.exports.get(prototypeSymbol.escapedName);
          if (symbolExport) {
            if (node.name) {
              ts3.setParent(node.name, node);
            }
            file.bindDiagnostics.push(createDiagnosticForNode(symbolExport.declarations[0], ts3.Diagnostics.Duplicate_identifier_0, ts3.symbolName(prototypeSymbol)));
          }
          symbol.exports.set(prototypeSymbol.escapedName, prototypeSymbol);
          prototypeSymbol.parent = symbol;
        }
        function bindEnumDeclaration(node) {
          return ts3.isEnumConst(node) ? bindBlockScopedDeclaration(node, 128, 899967) : bindBlockScopedDeclaration(node, 256, 899327);
        }
        function bindVariableDeclarationOrBindingElement(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
          if (!ts3.isBindingPattern(node.name)) {
            var possibleVariableDecl = node.kind === 254 ? node : node.parent.parent;
            if (ts3.isInJSFile(node) && ts3.isVariableDeclarationInitializedToBareOrAccessedRequire(possibleVariableDecl) && !ts3.getJSDocTypeTag(node) && !(ts3.getCombinedModifierFlags(node) & 1)) {
              declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
            } else if (ts3.isBlockOrCatchScoped(node)) {
              bindBlockScopedDeclaration(node, 2, 111551);
            } else if (ts3.isParameterDeclaration(node)) {
              declareSymbolAndAddToSymbolTable(node, 1, 111551);
            } else {
              declareSymbolAndAddToSymbolTable(node, 1, 111550);
            }
          }
        }
        function bindParameter(node) {
          if (node.kind === 340 && container.kind !== 323) {
            return;
          }
          if (inStrictMode && !(node.flags & 16777216)) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
          if (ts3.isBindingPattern(node.name)) {
            bindAnonymousDeclaration(node, 1, "__" + node.parent.parameters.indexOf(node));
          } else {
            declareSymbolAndAddToSymbolTable(node, 1, 111551);
          }
          if (ts3.isParameterPropertyDeclaration(node, node.parent)) {
            var classDeclaration = node.parent.parent;
            declareSymbol(classDeclaration.symbol.members, classDeclaration.symbol, node, 4 | (node.questionToken ? 16777216 : 0), 0);
          }
        }
        function bindFunctionDeclaration(node) {
          if (!file.isDeclarationFile && !(node.flags & 16777216)) {
            if (ts3.isAsyncFunction(node)) {
              emitFlags |= 2048;
            }
          }
          checkStrictModeFunctionName(node);
          if (inStrictMode) {
            checkStrictModeFunctionDeclaration(node);
            bindBlockScopedDeclaration(node, 16, 110991);
          } else {
            declareSymbolAndAddToSymbolTable(node, 16, 110991);
          }
        }
        function bindFunctionExpression(node) {
          if (!file.isDeclarationFile && !(node.flags & 16777216)) {
            if (ts3.isAsyncFunction(node)) {
              emitFlags |= 2048;
            }
          }
          if (currentFlow) {
            node.flowNode = currentFlow;
          }
          checkStrictModeFunctionName(node);
          var bindingName = node.name ? node.name.escapedText : "__function";
          return bindAnonymousDeclaration(node, 16, bindingName);
        }
        function bindPropertyOrMethodOrAccessor(node, symbolFlags, symbolExcludes) {
          if (!file.isDeclarationFile && !(node.flags & 16777216) && ts3.isAsyncFunction(node)) {
            emitFlags |= 2048;
          }
          if (currentFlow && ts3.isObjectLiteralOrClassExpressionMethodOrAccessor(node)) {
            node.flowNode = currentFlow;
          }
          return ts3.hasDynamicName(node) ? bindAnonymousDeclaration(node, symbolFlags, "__computed") : declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
        function getInferTypeContainer(node) {
          var extendsType = ts3.findAncestor(node, function(n) {
            return n.parent && ts3.isConditionalTypeNode(n.parent) && n.parent.extendsType === n;
          });
          return extendsType && extendsType.parent;
        }
        function bindTypeParameter(node) {
          if (ts3.isJSDocTemplateTag(node.parent)) {
            var container_1 = ts3.getEffectiveContainerForJSDocTemplateTag(node.parent);
            if (container_1) {
              if (!container_1.locals) {
                container_1.locals = ts3.createSymbolTable();
              }
              declareSymbol(container_1.locals, void 0, node, 262144, 526824);
            } else {
              declareSymbolAndAddToSymbolTable(node, 262144, 526824);
            }
          } else if (node.parent.kind === 190) {
            var container_2 = getInferTypeContainer(node.parent);
            if (container_2) {
              if (!container_2.locals) {
                container_2.locals = ts3.createSymbolTable();
              }
              declareSymbol(container_2.locals, void 0, node, 262144, 526824);
            } else {
              bindAnonymousDeclaration(node, 262144, getDeclarationName(node));
            }
          } else {
            declareSymbolAndAddToSymbolTable(node, 262144, 526824);
          }
        }
        function shouldReportErrorOnModuleDeclaration(node) {
          var instanceState = getModuleInstanceState(node);
          return instanceState === 1 || instanceState === 2 && ts3.shouldPreserveConstEnums(options);
        }
        function checkUnreachable(node) {
          if (!(currentFlow.flags & 1)) {
            return false;
          }
          if (currentFlow === unreachableFlow) {
            var reportError = ts3.isStatementButNotDeclaration(node) && node.kind !== 236 || node.kind === 257 || node.kind === 261 && shouldReportErrorOnModuleDeclaration(node);
            if (reportError) {
              currentFlow = reportedUnreachableFlow;
              if (!options.allowUnreachableCode) {
                var isError_1 = ts3.unreachableCodeIsError(options) && !(node.flags & 16777216) && (!ts3.isVariableStatement(node) || !!(ts3.getCombinedNodeFlags(node.declarationList) & 3) || node.declarationList.declarations.some(function(d) {
                  return !!d.initializer;
                }));
                eachUnreachableRange(node, function(start, end) {
                  return errorOrSuggestionOnRange(isError_1, start, end, ts3.Diagnostics.Unreachable_code_detected);
                });
              }
            }
          }
          return true;
        }
      }
      function eachUnreachableRange(node, cb) {
        if (ts3.isStatement(node) && isExecutableStatement(node) && ts3.isBlock(node.parent)) {
          var statements = node.parent.statements;
          var slice_1 = ts3.sliceAfter(statements, node);
          ts3.getRangesWhere(slice_1, isExecutableStatement, function(start, afterEnd) {
            return cb(slice_1[start], slice_1[afterEnd - 1]);
          });
        } else {
          cb(node, node);
        }
      }
      function isExecutableStatement(s) {
        return !ts3.isFunctionDeclaration(s) && !isPurelyTypeDeclaration(s) && !ts3.isEnumDeclaration(s) && !(ts3.isVariableStatement(s) && !(ts3.getCombinedNodeFlags(s) & (1 | 2)) && s.declarationList.declarations.some(function(d) {
          return !d.initializer;
        }));
      }
      function isPurelyTypeDeclaration(s) {
        switch (s.kind) {
          case 258:
          case 259:
            return true;
          case 261:
            return getModuleInstanceState(s) !== 1;
          case 260:
            return ts3.hasSyntacticModifier(s, 2048);
          default:
            return false;
        }
      }
      function isExportsOrModuleExportsOrAlias(sourceFile, node) {
        var i = 0;
        var q = [node];
        while (q.length && i < 100) {
          i++;
          node = q.shift();
          if (ts3.isExportsIdentifier(node) || ts3.isModuleExportsAccessExpression(node)) {
            return true;
          } else if (ts3.isIdentifier(node)) {
            var symbol = lookupSymbolForName(sourceFile, node.escapedText);
            if (!!symbol && !!symbol.valueDeclaration && ts3.isVariableDeclaration(symbol.valueDeclaration) && !!symbol.valueDeclaration.initializer) {
              var init = symbol.valueDeclaration.initializer;
              q.push(init);
              if (ts3.isAssignmentExpression(init, true)) {
                q.push(init.left);
                q.push(init.right);
              }
            }
          }
        }
        return false;
      }
      ts3.isExportsOrModuleExportsOrAlias = isExportsOrModuleExportsOrAlias;
      function lookupSymbolForName(container, name) {
        var local = container.locals && container.locals.get(name);
        if (local) {
          return local.exportSymbol || local;
        }
        if (ts3.isSourceFile(container) && container.jsGlobalAugmentations && container.jsGlobalAugmentations.has(name)) {
          return container.jsGlobalAugmentations.get(name);
        }
        return container.symbol && container.symbol.exports && container.symbol.exports.get(name);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getConstraintOfTypeParameter, getFirstIdentifier, getTypeArguments) {
        return getSymbolWalker;
        function getSymbolWalker(accept) {
          if (accept === void 0) {
            accept = function() {
              return true;
            };
          }
          var visitedTypes = [];
          var visitedSymbols = [];
          return {
            walkType: function(type2) {
              try {
                visitType(type2);
                return { visitedTypes: ts3.getOwnValues(visitedTypes), visitedSymbols: ts3.getOwnValues(visitedSymbols) };
              } finally {
                ts3.clear(visitedTypes);
                ts3.clear(visitedSymbols);
              }
            },
            walkSymbol: function(symbol) {
              try {
                visitSymbol(symbol);
                return { visitedTypes: ts3.getOwnValues(visitedTypes), visitedSymbols: ts3.getOwnValues(visitedSymbols) };
              } finally {
                ts3.clear(visitedTypes);
                ts3.clear(visitedSymbols);
              }
            }
          };
          function visitType(type2) {
            if (!type2) {
              return;
            }
            if (visitedTypes[type2.id]) {
              return;
            }
            visitedTypes[type2.id] = type2;
            var shouldBail = visitSymbol(type2.symbol);
            if (shouldBail)
              return;
            if (type2.flags & 524288) {
              var objectType = type2;
              var objectFlags = objectType.objectFlags;
              if (objectFlags & 4) {
                visitTypeReference(type2);
              }
              if (objectFlags & 32) {
                visitMappedType(type2);
              }
              if (objectFlags & (1 | 2)) {
                visitInterfaceType(type2);
              }
              if (objectFlags & (8 | 16)) {
                visitObjectType(objectType);
              }
            }
            if (type2.flags & 262144) {
              visitTypeParameter(type2);
            }
            if (type2.flags & 3145728) {
              visitUnionOrIntersectionType(type2);
            }
            if (type2.flags & 4194304) {
              visitIndexType(type2);
            }
            if (type2.flags & 8388608) {
              visitIndexedAccessType(type2);
            }
          }
          function visitTypeReference(type2) {
            visitType(type2.target);
            ts3.forEach(getTypeArguments(type2), visitType);
          }
          function visitTypeParameter(type2) {
            visitType(getConstraintOfTypeParameter(type2));
          }
          function visitUnionOrIntersectionType(type2) {
            ts3.forEach(type2.types, visitType);
          }
          function visitIndexType(type2) {
            visitType(type2.type);
          }
          function visitIndexedAccessType(type2) {
            visitType(type2.objectType);
            visitType(type2.indexType);
            visitType(type2.constraint);
          }
          function visitMappedType(type2) {
            visitType(type2.typeParameter);
            visitType(type2.constraintType);
            visitType(type2.templateType);
            visitType(type2.modifiersType);
          }
          function visitSignature(signature) {
            var typePredicate = getTypePredicateOfSignature(signature);
            if (typePredicate) {
              visitType(typePredicate.type);
            }
            ts3.forEach(signature.typeParameters, visitType);
            for (var _i = 0, _a = signature.parameters; _i < _a.length; _i++) {
              var parameter = _a[_i];
              visitSymbol(parameter);
            }
            visitType(getRestTypeOfSignature(signature));
            visitType(getReturnTypeOfSignature(signature));
          }
          function visitInterfaceType(interfaceT) {
            visitObjectType(interfaceT);
            ts3.forEach(interfaceT.typeParameters, visitType);
            ts3.forEach(getBaseTypes(interfaceT), visitType);
            visitType(interfaceT.thisType);
          }
          function visitObjectType(type2) {
            var resolved = resolveStructuredTypeMembers(type2);
            for (var _i = 0, _a = resolved.indexInfos; _i < _a.length; _i++) {
              var info = _a[_i];
              visitType(info.keyType);
              visitType(info.type);
            }
            for (var _b = 0, _c = resolved.callSignatures; _b < _c.length; _b++) {
              var signature = _c[_b];
              visitSignature(signature);
            }
            for (var _d = 0, _e = resolved.constructSignatures; _d < _e.length; _d++) {
              var signature = _e[_d];
              visitSignature(signature);
            }
            for (var _f = 0, _g = resolved.properties; _f < _g.length; _f++) {
              var p = _g[_f];
              visitSymbol(p);
            }
          }
          function visitSymbol(symbol) {
            if (!symbol) {
              return false;
            }
            var symbolId = ts3.getSymbolId(symbol);
            if (visitedSymbols[symbolId]) {
              return false;
            }
            visitedSymbols[symbolId] = symbol;
            if (!accept(symbol)) {
              return true;
            }
            var t = getTypeOfSymbol(symbol);
            visitType(t);
            if (symbol.exports) {
              symbol.exports.forEach(visitSymbol);
            }
            ts3.forEach(symbol.declarations, function(d) {
              if (d.type && d.type.kind === 181) {
                var query = d.type;
                var entity = getResolvedSymbol(getFirstIdentifier(query.exprName));
                visitSymbol(entity);
              }
            });
            return false;
          }
        }
      }
      ts3.createGetSymbolWalker = createGetSymbolWalker;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ambientModuleSymbolRegex = /^".+"$/;
      var anon = "(anonymous)";
      var nextSymbolId = 1;
      var nextNodeId = 1;
      var nextMergeId = 1;
      var nextFlowId = 1;
      var IterationUse;
      (function(IterationUse2) {
        IterationUse2[IterationUse2["AllowsSyncIterablesFlag"] = 1] = "AllowsSyncIterablesFlag";
        IterationUse2[IterationUse2["AllowsAsyncIterablesFlag"] = 2] = "AllowsAsyncIterablesFlag";
        IterationUse2[IterationUse2["AllowsStringInputFlag"] = 4] = "AllowsStringInputFlag";
        IterationUse2[IterationUse2["ForOfFlag"] = 8] = "ForOfFlag";
        IterationUse2[IterationUse2["YieldStarFlag"] = 16] = "YieldStarFlag";
        IterationUse2[IterationUse2["SpreadFlag"] = 32] = "SpreadFlag";
        IterationUse2[IterationUse2["DestructuringFlag"] = 64] = "DestructuringFlag";
        IterationUse2[IterationUse2["PossiblyOutOfBounds"] = 128] = "PossiblyOutOfBounds";
        IterationUse2[IterationUse2["Element"] = 1] = "Element";
        IterationUse2[IterationUse2["Spread"] = 33] = "Spread";
        IterationUse2[IterationUse2["Destructuring"] = 65] = "Destructuring";
        IterationUse2[IterationUse2["ForOf"] = 13] = "ForOf";
        IterationUse2[IterationUse2["ForAwaitOf"] = 15] = "ForAwaitOf";
        IterationUse2[IterationUse2["YieldStar"] = 17] = "YieldStar";
        IterationUse2[IterationUse2["AsyncYieldStar"] = 19] = "AsyncYieldStar";
        IterationUse2[IterationUse2["GeneratorReturnType"] = 1] = "GeneratorReturnType";
        IterationUse2[IterationUse2["AsyncGeneratorReturnType"] = 2] = "AsyncGeneratorReturnType";
      })(IterationUse || (IterationUse = {}));
      var IterationTypeKind;
      (function(IterationTypeKind2) {
        IterationTypeKind2[IterationTypeKind2["Yield"] = 0] = "Yield";
        IterationTypeKind2[IterationTypeKind2["Return"] = 1] = "Return";
        IterationTypeKind2[IterationTypeKind2["Next"] = 2] = "Next";
      })(IterationTypeKind || (IterationTypeKind = {}));
      var WideningKind;
      (function(WideningKind2) {
        WideningKind2[WideningKind2["Normal"] = 0] = "Normal";
        WideningKind2[WideningKind2["FunctionReturn"] = 1] = "FunctionReturn";
        WideningKind2[WideningKind2["GeneratorNext"] = 2] = "GeneratorNext";
        WideningKind2[WideningKind2["GeneratorYield"] = 3] = "GeneratorYield";
      })(WideningKind || (WideningKind = {}));
      var TypeFacts;
      (function(TypeFacts2) {
        TypeFacts2[TypeFacts2["None"] = 0] = "None";
        TypeFacts2[TypeFacts2["TypeofEQString"] = 1] = "TypeofEQString";
        TypeFacts2[TypeFacts2["TypeofEQNumber"] = 2] = "TypeofEQNumber";
        TypeFacts2[TypeFacts2["TypeofEQBigInt"] = 4] = "TypeofEQBigInt";
        TypeFacts2[TypeFacts2["TypeofEQBoolean"] = 8] = "TypeofEQBoolean";
        TypeFacts2[TypeFacts2["TypeofEQSymbol"] = 16] = "TypeofEQSymbol";
        TypeFacts2[TypeFacts2["TypeofEQObject"] = 32] = "TypeofEQObject";
        TypeFacts2[TypeFacts2["TypeofEQFunction"] = 64] = "TypeofEQFunction";
        TypeFacts2[TypeFacts2["TypeofEQHostObject"] = 128] = "TypeofEQHostObject";
        TypeFacts2[TypeFacts2["TypeofNEString"] = 256] = "TypeofNEString";
        TypeFacts2[TypeFacts2["TypeofNENumber"] = 512] = "TypeofNENumber";
        TypeFacts2[TypeFacts2["TypeofNEBigInt"] = 1024] = "TypeofNEBigInt";
        TypeFacts2[TypeFacts2["TypeofNEBoolean"] = 2048] = "TypeofNEBoolean";
        TypeFacts2[TypeFacts2["TypeofNESymbol"] = 4096] = "TypeofNESymbol";
        TypeFacts2[TypeFacts2["TypeofNEObject"] = 8192] = "TypeofNEObject";
        TypeFacts2[TypeFacts2["TypeofNEFunction"] = 16384] = "TypeofNEFunction";
        TypeFacts2[TypeFacts2["TypeofNEHostObject"] = 32768] = "TypeofNEHostObject";
        TypeFacts2[TypeFacts2["EQUndefined"] = 65536] = "EQUndefined";
        TypeFacts2[TypeFacts2["EQNull"] = 131072] = "EQNull";
        TypeFacts2[TypeFacts2["EQUndefinedOrNull"] = 262144] = "EQUndefinedOrNull";
        TypeFacts2[TypeFacts2["NEUndefined"] = 524288] = "NEUndefined";
        TypeFacts2[TypeFacts2["NENull"] = 1048576] = "NENull";
        TypeFacts2[TypeFacts2["NEUndefinedOrNull"] = 2097152] = "NEUndefinedOrNull";
        TypeFacts2[TypeFacts2["Truthy"] = 4194304] = "Truthy";
        TypeFacts2[TypeFacts2["Falsy"] = 8388608] = "Falsy";
        TypeFacts2[TypeFacts2["All"] = 16777215] = "All";
        TypeFacts2[TypeFacts2["BaseStringStrictFacts"] = 3735041] = "BaseStringStrictFacts";
        TypeFacts2[TypeFacts2["BaseStringFacts"] = 12582401] = "BaseStringFacts";
        TypeFacts2[TypeFacts2["StringStrictFacts"] = 16317953] = "StringStrictFacts";
        TypeFacts2[TypeFacts2["StringFacts"] = 16776705] = "StringFacts";
        TypeFacts2[TypeFacts2["EmptyStringStrictFacts"] = 12123649] = "EmptyStringStrictFacts";
        TypeFacts2[TypeFacts2["EmptyStringFacts"] = 12582401] = "EmptyStringFacts";
        TypeFacts2[TypeFacts2["NonEmptyStringStrictFacts"] = 7929345] = "NonEmptyStringStrictFacts";
        TypeFacts2[TypeFacts2["NonEmptyStringFacts"] = 16776705] = "NonEmptyStringFacts";
        TypeFacts2[TypeFacts2["BaseNumberStrictFacts"] = 3734786] = "BaseNumberStrictFacts";
        TypeFacts2[TypeFacts2["BaseNumberFacts"] = 12582146] = "BaseNumberFacts";
        TypeFacts2[TypeFacts2["NumberStrictFacts"] = 16317698] = "NumberStrictFacts";
        TypeFacts2[TypeFacts2["NumberFacts"] = 16776450] = "NumberFacts";
        TypeFacts2[TypeFacts2["ZeroNumberStrictFacts"] = 12123394] = "ZeroNumberStrictFacts";
        TypeFacts2[TypeFacts2["ZeroNumberFacts"] = 12582146] = "ZeroNumberFacts";
        TypeFacts2[TypeFacts2["NonZeroNumberStrictFacts"] = 7929090] = "NonZeroNumberStrictFacts";
        TypeFacts2[TypeFacts2["NonZeroNumberFacts"] = 16776450] = "NonZeroNumberFacts";
        TypeFacts2[TypeFacts2["BaseBigIntStrictFacts"] = 3734276] = "BaseBigIntStrictFacts";
        TypeFacts2[TypeFacts2["BaseBigIntFacts"] = 12581636] = "BaseBigIntFacts";
        TypeFacts2[TypeFacts2["BigIntStrictFacts"] = 16317188] = "BigIntStrictFacts";
        TypeFacts2[TypeFacts2["BigIntFacts"] = 16775940] = "BigIntFacts";
        TypeFacts2[TypeFacts2["ZeroBigIntStrictFacts"] = 12122884] = "ZeroBigIntStrictFacts";
        TypeFacts2[TypeFacts2["ZeroBigIntFacts"] = 12581636] = "ZeroBigIntFacts";
        TypeFacts2[TypeFacts2["NonZeroBigIntStrictFacts"] = 7928580] = "NonZeroBigIntStrictFacts";
        TypeFacts2[TypeFacts2["NonZeroBigIntFacts"] = 16775940] = "NonZeroBigIntFacts";
        TypeFacts2[TypeFacts2["BaseBooleanStrictFacts"] = 3733256] = "BaseBooleanStrictFacts";
        TypeFacts2[TypeFacts2["BaseBooleanFacts"] = 12580616] = "BaseBooleanFacts";
        TypeFacts2[TypeFacts2["BooleanStrictFacts"] = 16316168] = "BooleanStrictFacts";
        TypeFacts2[TypeFacts2["BooleanFacts"] = 16774920] = "BooleanFacts";
        TypeFacts2[TypeFacts2["FalseStrictFacts"] = 12121864] = "FalseStrictFacts";
        TypeFacts2[TypeFacts2["FalseFacts"] = 12580616] = "FalseFacts";
        TypeFacts2[TypeFacts2["TrueStrictFacts"] = 7927560] = "TrueStrictFacts";
        TypeFacts2[TypeFacts2["TrueFacts"] = 16774920] = "TrueFacts";
        TypeFacts2[TypeFacts2["SymbolStrictFacts"] = 7925520] = "SymbolStrictFacts";
        TypeFacts2[TypeFacts2["SymbolFacts"] = 16772880] = "SymbolFacts";
        TypeFacts2[TypeFacts2["ObjectStrictFacts"] = 7888800] = "ObjectStrictFacts";
        TypeFacts2[TypeFacts2["ObjectFacts"] = 16736160] = "ObjectFacts";
        TypeFacts2[TypeFacts2["FunctionStrictFacts"] = 7880640] = "FunctionStrictFacts";
        TypeFacts2[TypeFacts2["FunctionFacts"] = 16728e3] = "FunctionFacts";
        TypeFacts2[TypeFacts2["UndefinedFacts"] = 9830144] = "UndefinedFacts";
        TypeFacts2[TypeFacts2["NullFacts"] = 9363232] = "NullFacts";
        TypeFacts2[TypeFacts2["EmptyObjectStrictFacts"] = 16318463] = "EmptyObjectStrictFacts";
        TypeFacts2[TypeFacts2["AllTypeofNE"] = 556800] = "AllTypeofNE";
        TypeFacts2[TypeFacts2["EmptyObjectFacts"] = 16777215] = "EmptyObjectFacts";
        TypeFacts2[TypeFacts2["OrFactsMask"] = 8256] = "OrFactsMask";
        TypeFacts2[TypeFacts2["AndFactsMask"] = 16768959] = "AndFactsMask";
      })(TypeFacts || (TypeFacts = {}));
      var typeofEQFacts = new ts3.Map(ts3.getEntries({
        string: 1,
        number: 2,
        bigint: 4,
        boolean: 8,
        symbol: 16,
        undefined: 65536,
        object: 32,
        function: 64
      }));
      var typeofNEFacts = new ts3.Map(ts3.getEntries({
        string: 256,
        number: 512,
        bigint: 1024,
        boolean: 2048,
        symbol: 4096,
        undefined: 524288,
        object: 8192,
        function: 16384
      }));
      var TypeSystemPropertyName;
      (function(TypeSystemPropertyName2) {
        TypeSystemPropertyName2[TypeSystemPropertyName2["Type"] = 0] = "Type";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedBaseConstructorType"] = 1] = "ResolvedBaseConstructorType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["DeclaredType"] = 2] = "DeclaredType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedReturnType"] = 3] = "ResolvedReturnType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ImmediateBaseConstraint"] = 4] = "ImmediateBaseConstraint";
        TypeSystemPropertyName2[TypeSystemPropertyName2["EnumTagType"] = 5] = "EnumTagType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedTypeArguments"] = 6] = "ResolvedTypeArguments";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedBaseTypes"] = 7] = "ResolvedBaseTypes";
        TypeSystemPropertyName2[TypeSystemPropertyName2["WriteType"] = 8] = "WriteType";
      })(TypeSystemPropertyName || (TypeSystemPropertyName = {}));
      var CheckMode;
      (function(CheckMode2) {
        CheckMode2[CheckMode2["Normal"] = 0] = "Normal";
        CheckMode2[CheckMode2["Contextual"] = 1] = "Contextual";
        CheckMode2[CheckMode2["Inferential"] = 2] = "Inferential";
        CheckMode2[CheckMode2["SkipContextSensitive"] = 4] = "SkipContextSensitive";
        CheckMode2[CheckMode2["SkipGenericFunctions"] = 8] = "SkipGenericFunctions";
        CheckMode2[CheckMode2["IsForSignatureHelp"] = 16] = "IsForSignatureHelp";
        CheckMode2[CheckMode2["IsForStringLiteralArgumentCompletions"] = 32] = "IsForStringLiteralArgumentCompletions";
        CheckMode2[CheckMode2["RestBindingElement"] = 64] = "RestBindingElement";
      })(CheckMode || (CheckMode = {}));
      var SignatureCheckMode;
      (function(SignatureCheckMode2) {
        SignatureCheckMode2[SignatureCheckMode2["BivariantCallback"] = 1] = "BivariantCallback";
        SignatureCheckMode2[SignatureCheckMode2["StrictCallback"] = 2] = "StrictCallback";
        SignatureCheckMode2[SignatureCheckMode2["IgnoreReturnTypes"] = 4] = "IgnoreReturnTypes";
        SignatureCheckMode2[SignatureCheckMode2["StrictArity"] = 8] = "StrictArity";
        SignatureCheckMode2[SignatureCheckMode2["Callback"] = 3] = "Callback";
      })(SignatureCheckMode || (SignatureCheckMode = {}));
      var IntersectionState;
      (function(IntersectionState2) {
        IntersectionState2[IntersectionState2["None"] = 0] = "None";
        IntersectionState2[IntersectionState2["Source"] = 1] = "Source";
        IntersectionState2[IntersectionState2["Target"] = 2] = "Target";
        IntersectionState2[IntersectionState2["PropertyCheck"] = 4] = "PropertyCheck";
        IntersectionState2[IntersectionState2["InPropertyCheck"] = 8] = "InPropertyCheck";
      })(IntersectionState || (IntersectionState = {}));
      var RecursionFlags;
      (function(RecursionFlags2) {
        RecursionFlags2[RecursionFlags2["None"] = 0] = "None";
        RecursionFlags2[RecursionFlags2["Source"] = 1] = "Source";
        RecursionFlags2[RecursionFlags2["Target"] = 2] = "Target";
        RecursionFlags2[RecursionFlags2["Both"] = 3] = "Both";
      })(RecursionFlags || (RecursionFlags = {}));
      var MappedTypeModifiers;
      (function(MappedTypeModifiers2) {
        MappedTypeModifiers2[MappedTypeModifiers2["IncludeReadonly"] = 1] = "IncludeReadonly";
        MappedTypeModifiers2[MappedTypeModifiers2["ExcludeReadonly"] = 2] = "ExcludeReadonly";
        MappedTypeModifiers2[MappedTypeModifiers2["IncludeOptional"] = 4] = "IncludeOptional";
        MappedTypeModifiers2[MappedTypeModifiers2["ExcludeOptional"] = 8] = "ExcludeOptional";
      })(MappedTypeModifiers || (MappedTypeModifiers = {}));
      var ExpandingFlags;
      (function(ExpandingFlags2) {
        ExpandingFlags2[ExpandingFlags2["None"] = 0] = "None";
        ExpandingFlags2[ExpandingFlags2["Source"] = 1] = "Source";
        ExpandingFlags2[ExpandingFlags2["Target"] = 2] = "Target";
        ExpandingFlags2[ExpandingFlags2["Both"] = 3] = "Both";
      })(ExpandingFlags || (ExpandingFlags = {}));
      var MembersOrExportsResolutionKind;
      (function(MembersOrExportsResolutionKind2) {
        MembersOrExportsResolutionKind2["resolvedExports"] = "resolvedExports";
        MembersOrExportsResolutionKind2["resolvedMembers"] = "resolvedMembers";
      })(MembersOrExportsResolutionKind || (MembersOrExportsResolutionKind = {}));
      var UnusedKind;
      (function(UnusedKind2) {
        UnusedKind2[UnusedKind2["Local"] = 0] = "Local";
        UnusedKind2[UnusedKind2["Parameter"] = 1] = "Parameter";
      })(UnusedKind || (UnusedKind = {}));
      var isNotOverloadAndNotAccessor = ts3.and(isNotOverload, isNotAccessor);
      var DeclarationMeaning;
      (function(DeclarationMeaning2) {
        DeclarationMeaning2[DeclarationMeaning2["GetAccessor"] = 1] = "GetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["SetAccessor"] = 2] = "SetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["PropertyAssignment"] = 4] = "PropertyAssignment";
        DeclarationMeaning2[DeclarationMeaning2["Method"] = 8] = "Method";
        DeclarationMeaning2[DeclarationMeaning2["PrivateStatic"] = 16] = "PrivateStatic";
        DeclarationMeaning2[DeclarationMeaning2["GetOrSetAccessor"] = 3] = "GetOrSetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["PropertyAssignmentOrMethod"] = 12] = "PropertyAssignmentOrMethod";
      })(DeclarationMeaning || (DeclarationMeaning = {}));
      var DeclarationSpaces;
      (function(DeclarationSpaces2) {
        DeclarationSpaces2[DeclarationSpaces2["None"] = 0] = "None";
        DeclarationSpaces2[DeclarationSpaces2["ExportValue"] = 1] = "ExportValue";
        DeclarationSpaces2[DeclarationSpaces2["ExportType"] = 2] = "ExportType";
        DeclarationSpaces2[DeclarationSpaces2["ExportNamespace"] = 4] = "ExportNamespace";
      })(DeclarationSpaces || (DeclarationSpaces = {}));
      var MinArgumentCountFlags;
      (function(MinArgumentCountFlags2) {
        MinArgumentCountFlags2[MinArgumentCountFlags2["None"] = 0] = "None";
        MinArgumentCountFlags2[MinArgumentCountFlags2["StrongArityForUntypedJS"] = 1] = "StrongArityForUntypedJS";
        MinArgumentCountFlags2[MinArgumentCountFlags2["VoidIsNonOptional"] = 2] = "VoidIsNonOptional";
      })(MinArgumentCountFlags || (MinArgumentCountFlags = {}));
      var IntrinsicTypeKind;
      (function(IntrinsicTypeKind2) {
        IntrinsicTypeKind2[IntrinsicTypeKind2["Uppercase"] = 0] = "Uppercase";
        IntrinsicTypeKind2[IntrinsicTypeKind2["Lowercase"] = 1] = "Lowercase";
        IntrinsicTypeKind2[IntrinsicTypeKind2["Capitalize"] = 2] = "Capitalize";
        IntrinsicTypeKind2[IntrinsicTypeKind2["Uncapitalize"] = 3] = "Uncapitalize";
      })(IntrinsicTypeKind || (IntrinsicTypeKind = {}));
      var intrinsicTypeKinds = new ts3.Map(ts3.getEntries({
        Uppercase: 0,
        Lowercase: 1,
        Capitalize: 2,
        Uncapitalize: 3
      }));
      function SymbolLinks() {
      }
      function NodeLinks() {
        this.flags = 0;
      }
      function getNodeId(node) {
        if (!node.id) {
          node.id = nextNodeId;
          nextNodeId++;
        }
        return node.id;
      }
      ts3.getNodeId = getNodeId;
      function getSymbolId(symbol) {
        if (!symbol.id) {
          symbol.id = nextSymbolId;
          nextSymbolId++;
        }
        return symbol.id;
      }
      ts3.getSymbolId = getSymbolId;
      function isInstantiatedModule(node, preserveConstEnums) {
        var moduleState = ts3.getModuleInstanceState(node);
        return moduleState === 1 || preserveConstEnums && moduleState === 2;
      }
      ts3.isInstantiatedModule = isInstantiatedModule;
      function createTypeChecker(host) {
        var getPackagesMap = ts3.memoize(function() {
          var map2 = new ts3.Map();
          host.getSourceFiles().forEach(function(sf) {
            if (!sf.resolvedModules)
              return;
            sf.resolvedModules.forEach(function(r) {
              if (r && r.packageId)
                map2.set(r.packageId.name, r.extension === ".d.ts" || !!map2.get(r.packageId.name));
            });
          });
          return map2;
        });
        var deferredDiagnosticsCallbacks = [];
        var addLazyDiagnostic = function(arg) {
          deferredDiagnosticsCallbacks.push(arg);
        };
        var cancellationToken;
        var requestedExternalEmitHelpers;
        var externalHelpersModule;
        var Symbol2 = ts3.objectAllocator.getSymbolConstructor();
        var Type2 = ts3.objectAllocator.getTypeConstructor();
        var Signature = ts3.objectAllocator.getSignatureConstructor();
        var typeCount = 0;
        var symbolCount = 0;
        var enumCount = 0;
        var totalInstantiationCount = 0;
        var instantiationCount = 0;
        var instantiationDepth = 0;
        var inlineLevel = 0;
        var currentNode;
        var varianceTypeParameter;
        var emptySymbols = ts3.createSymbolTable();
        var arrayVariances = [1];
        var compilerOptions = host.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var useDefineForClassFields = ts3.getUseDefineForClassFields(compilerOptions);
        var allowSyntheticDefaultImports = ts3.getAllowSyntheticDefaultImports(compilerOptions);
        var strictNullChecks = ts3.getStrictOptionValue(compilerOptions, "strictNullChecks");
        var strictFunctionTypes = ts3.getStrictOptionValue(compilerOptions, "strictFunctionTypes");
        var strictBindCallApply = ts3.getStrictOptionValue(compilerOptions, "strictBindCallApply");
        var strictPropertyInitialization = ts3.getStrictOptionValue(compilerOptions, "strictPropertyInitialization");
        var noImplicitAny = ts3.getStrictOptionValue(compilerOptions, "noImplicitAny");
        var noImplicitThis = ts3.getStrictOptionValue(compilerOptions, "noImplicitThis");
        var useUnknownInCatchVariables = ts3.getStrictOptionValue(compilerOptions, "useUnknownInCatchVariables");
        var keyofStringsOnly = !!compilerOptions.keyofStringsOnly;
        var freshObjectLiteralFlag = compilerOptions.suppressExcessPropertyErrors ? 0 : 8192;
        var exactOptionalPropertyTypes = compilerOptions.exactOptionalPropertyTypes;
        var checkBinaryExpression = createCheckBinaryExpression();
        var emitResolver = createResolver();
        var nodeBuilder = createNodeBuilder();
        var globals = ts3.createSymbolTable();
        var undefinedSymbol = createSymbol(4, "undefined");
        undefinedSymbol.declarations = [];
        var globalThisSymbol = createSymbol(1536, "globalThis", 8);
        globalThisSymbol.exports = globals;
        globalThisSymbol.declarations = [];
        globals.set(globalThisSymbol.escapedName, globalThisSymbol);
        var argumentsSymbol = createSymbol(4, "arguments");
        var requireSymbol = createSymbol(4, "require");
        var apparentArgumentCount;
        var checker = {
          getNodeCount: function() {
            return ts3.sum(host.getSourceFiles(), "nodeCount");
          },
          getIdentifierCount: function() {
            return ts3.sum(host.getSourceFiles(), "identifierCount");
          },
          getSymbolCount: function() {
            return ts3.sum(host.getSourceFiles(), "symbolCount") + symbolCount;
          },
          getTypeCount: function() {
            return typeCount;
          },
          getInstantiationCount: function() {
            return totalInstantiationCount;
          },
          getRelationCacheSizes: function() {
            return {
              assignable: assignableRelation.size,
              identity: identityRelation.size,
              subtype: subtypeRelation.size,
              strictSubtype: strictSubtypeRelation.size
            };
          },
          isUndefinedSymbol: function(symbol) {
            return symbol === undefinedSymbol;
          },
          isArgumentsSymbol: function(symbol) {
            return symbol === argumentsSymbol;
          },
          isUnknownSymbol: function(symbol) {
            return symbol === unknownSymbol;
          },
          getMergedSymbol,
          getDiagnostics,
          getGlobalDiagnostics,
          getRecursionIdentity,
          getUnmatchedProperties,
          getTypeOfSymbolAtLocation: function(symbol, locationIn) {
            var location = ts3.getParseTreeNode(locationIn);
            return location ? getTypeOfSymbolAtLocation(symbol, location) : errorType;
          },
          getTypeOfSymbol,
          getSymbolsOfParameterPropertyDeclaration: function(parameterIn, parameterName) {
            var parameter = ts3.getParseTreeNode(parameterIn, ts3.isParameter);
            if (parameter === void 0)
              return ts3.Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node.");
            return getSymbolsOfParameterPropertyDeclaration(parameter, ts3.escapeLeadingUnderscores(parameterName));
          },
          getDeclaredTypeOfSymbol,
          getPropertiesOfType,
          getPropertyOfType: function(type2, name) {
            return getPropertyOfType(type2, ts3.escapeLeadingUnderscores(name));
          },
          getPrivateIdentifierPropertyOfType: function(leftType, name, location) {
            var node = ts3.getParseTreeNode(location);
            if (!node) {
              return void 0;
            }
            var propName = ts3.escapeLeadingUnderscores(name);
            var lexicallyScopedIdentifier = lookupSymbolForPrivateIdentifierDeclaration(propName, node);
            return lexicallyScopedIdentifier ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) : void 0;
          },
          getTypeOfPropertyOfType: function(type2, name) {
            return getTypeOfPropertyOfType(type2, ts3.escapeLeadingUnderscores(name));
          },
          getIndexInfoOfType: function(type2, kind) {
            return getIndexInfoOfType(type2, kind === 0 ? stringType : numberType);
          },
          getIndexInfosOfType,
          getSignaturesOfType,
          getIndexTypeOfType: function(type2, kind) {
            return getIndexTypeOfType(type2, kind === 0 ? stringType : numberType);
          },
          getIndexType: function(type2) {
            return getIndexType(type2);
          },
          getBaseTypes,
          getBaseTypeOfLiteralType,
          getWidenedType,
          getTypeFromTypeNode: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isTypeNode);
            return node ? getTypeFromTypeNode(node) : errorType;
          },
          getParameterType: getTypeAtPosition,
          getParameterIdentifierNameAtPosition,
          getPromisedTypeOfPromise,
          getAwaitedType: function(type2) {
            return getAwaitedType(type2);
          },
          getReturnTypeOfSignature,
          isNullableType,
          getNullableType,
          getNonNullableType,
          getNonOptionalType: removeOptionalTypeMarker,
          getTypeArguments,
          typeToTypeNode: nodeBuilder.typeToTypeNode,
          indexInfoToIndexSignatureDeclaration: nodeBuilder.indexInfoToIndexSignatureDeclaration,
          signatureToSignatureDeclaration: nodeBuilder.signatureToSignatureDeclaration,
          symbolToEntityName: nodeBuilder.symbolToEntityName,
          symbolToExpression: nodeBuilder.symbolToExpression,
          symbolToTypeParameterDeclarations: nodeBuilder.symbolToTypeParameterDeclarations,
          symbolToParameterDeclaration: nodeBuilder.symbolToParameterDeclaration,
          typeParameterToDeclaration: nodeBuilder.typeParameterToDeclaration,
          getSymbolsInScope: function(locationIn, meaning) {
            var location = ts3.getParseTreeNode(locationIn);
            return location ? getSymbolsInScope(location, meaning) : [];
          },
          getSymbolAtLocation: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getSymbolAtLocation(node, true) : void 0;
          },
          getIndexInfosAtLocation: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getIndexInfosAtLocation(node) : void 0;
          },
          getShorthandAssignmentValueSymbol: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getShorthandAssignmentValueSymbol(node) : void 0;
          },
          getExportSpecifierLocalTargetSymbol: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isExportSpecifier);
            return node ? getExportSpecifierLocalTargetSymbol(node) : void 0;
          },
          getExportSymbolOfSymbol: function(symbol) {
            return getMergedSymbol(symbol.exportSymbol || symbol);
          },
          getTypeAtLocation: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getTypeOfNode(node) : errorType;
          },
          getTypeOfAssignmentPattern: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isAssignmentPattern);
            return node && getTypeOfAssignmentPattern(node) || errorType;
          },
          getPropertySymbolOfDestructuringAssignment: function(locationIn) {
            var location = ts3.getParseTreeNode(locationIn, ts3.isIdentifier);
            return location ? getPropertySymbolOfDestructuringAssignment(location) : void 0;
          },
          signatureToString: function(signature, enclosingDeclaration, flags, kind) {
            return signatureToString(signature, ts3.getParseTreeNode(enclosingDeclaration), flags, kind);
          },
          typeToString: function(type2, enclosingDeclaration, flags) {
            return typeToString(type2, ts3.getParseTreeNode(enclosingDeclaration), flags);
          },
          symbolToString: function(symbol, enclosingDeclaration, meaning, flags) {
            return symbolToString(symbol, ts3.getParseTreeNode(enclosingDeclaration), meaning, flags);
          },
          typePredicateToString: function(predicate, enclosingDeclaration, flags) {
            return typePredicateToString(predicate, ts3.getParseTreeNode(enclosingDeclaration), flags);
          },
          writeSignature: function(signature, enclosingDeclaration, flags, kind, writer) {
            return signatureToString(signature, ts3.getParseTreeNode(enclosingDeclaration), flags, kind, writer);
          },
          writeType: function(type2, enclosingDeclaration, flags, writer) {
            return typeToString(type2, ts3.getParseTreeNode(enclosingDeclaration), flags, writer);
          },
          writeSymbol: function(symbol, enclosingDeclaration, meaning, flags, writer) {
            return symbolToString(symbol, ts3.getParseTreeNode(enclosingDeclaration), meaning, flags, writer);
          },
          writeTypePredicate: function(predicate, enclosingDeclaration, flags, writer) {
            return typePredicateToString(predicate, ts3.getParseTreeNode(enclosingDeclaration), flags, writer);
          },
          getAugmentedPropertiesOfType,
          getRootSymbols,
          getSymbolOfExpando,
          getContextualType: function(nodeIn, contextFlags) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isExpression);
            if (!node) {
              return void 0;
            }
            if (contextFlags & 4) {
              return runWithInferenceBlockedFromSourceNode(node, function() {
                return getContextualType(node, contextFlags);
              });
            }
            return getContextualType(node, contextFlags);
          },
          getContextualTypeForObjectLiteralElement: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isObjectLiteralElementLike);
            return node ? getContextualTypeForObjectLiteralElement(node) : void 0;
          },
          getContextualTypeForArgumentAtIndex: function(nodeIn, argIndex) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isCallLikeExpression);
            return node && getContextualTypeForArgumentAtIndex(node, argIndex);
          },
          getContextualTypeForJsxAttribute: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isJsxAttributeLike);
            return node && getContextualTypeForJsxAttribute(node);
          },
          isContextSensitive,
          getTypeOfPropertyOfContextualType,
          getFullyQualifiedName,
          getResolvedSignature: function(node, candidatesOutArray, argumentCount) {
            return getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 0);
          },
          getResolvedSignatureForStringLiteralCompletions: function(call, editingArgument, candidatesOutArray) {
            return getResolvedSignatureWorker(call, candidatesOutArray, void 0, 32, editingArgument);
          },
          getResolvedSignatureForSignatureHelp: function(node, candidatesOutArray, argumentCount) {
            return getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 16);
          },
          getExpandedParameters,
          hasEffectiveRestParameter,
          containsArgumentsReference,
          getConstantValue: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, canHaveConstantValue);
            return node ? getConstantValue(node) : void 0;
          },
          isValidPropertyAccess: function(nodeIn, propertyName) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isPropertyAccessOrQualifiedNameOrImportTypeNode);
            return !!node && isValidPropertyAccess(node, ts3.escapeLeadingUnderscores(propertyName));
          },
          isValidPropertyAccessForCompletions: function(nodeIn, type2, property) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isPropertyAccessExpression);
            return !!node && isValidPropertyAccessForCompletions(node, type2, property);
          },
          getSignatureFromDeclaration: function(declarationIn) {
            var declaration = ts3.getParseTreeNode(declarationIn, ts3.isFunctionLike);
            return declaration ? getSignatureFromDeclaration(declaration) : void 0;
          },
          isImplementationOfOverload: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isFunctionLike);
            return node ? isImplementationOfOverload(node) : void 0;
          },
          getImmediateAliasedSymbol,
          getAliasedSymbol: resolveAlias,
          getEmitResolver,
          getExportsOfModule: getExportsOfModuleAsArray,
          getExportsAndPropertiesOfModule,
          forEachExportAndPropertyOfModule,
          getSymbolWalker: ts3.createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getConstraintOfTypeParameter, ts3.getFirstIdentifier, getTypeArguments),
          getAmbientModules,
          getJsxIntrinsicTagNamesAt,
          isOptionalParameter: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isParameter);
            return node ? isOptionalParameter(node) : false;
          },
          tryGetMemberInModuleExports: function(name, symbol) {
            return tryGetMemberInModuleExports(ts3.escapeLeadingUnderscores(name), symbol);
          },
          tryGetMemberInModuleExportsAndProperties: function(name, symbol) {
            return tryGetMemberInModuleExportsAndProperties(ts3.escapeLeadingUnderscores(name), symbol);
          },
          tryFindAmbientModule: function(moduleName) {
            return tryFindAmbientModule(moduleName, true);
          },
          tryFindAmbientModuleWithoutAugmentations: function(moduleName) {
            return tryFindAmbientModule(moduleName, false);
          },
          getApparentType,
          getUnionType,
          isTypeAssignableTo,
          createAnonymousType,
          createSignature,
          createSymbol,
          createIndexInfo,
          getAnyType: function() {
            return anyType;
          },
          getStringType: function() {
            return stringType;
          },
          getNumberType: function() {
            return numberType;
          },
          createPromiseType,
          createArrayType,
          getElementTypeOfArrayType,
          getBooleanType: function() {
            return booleanType;
          },
          getFalseType: function(fresh) {
            return fresh ? falseType : regularFalseType;
          },
          getTrueType: function(fresh) {
            return fresh ? trueType : regularTrueType;
          },
          getVoidType: function() {
            return voidType;
          },
          getUndefinedType: function() {
            return undefinedType;
          },
          getNullType: function() {
            return nullType;
          },
          getESSymbolType: function() {
            return esSymbolType;
          },
          getNeverType: function() {
            return neverType;
          },
          getOptionalType: function() {
            return optionalType;
          },
          getPromiseType: function() {
            return getGlobalPromiseType(false);
          },
          getPromiseLikeType: function() {
            return getGlobalPromiseLikeType(false);
          },
          isSymbolAccessible,
          isArrayType,
          isTupleType,
          isArrayLikeType,
          isTypeInvalidDueToUnionDiscriminant,
          getExactOptionalProperties,
          getAllPossiblePropertiesOfTypes,
          getSuggestedSymbolForNonexistentProperty,
          getSuggestionForNonexistentProperty,
          getSuggestedSymbolForNonexistentJSXAttribute,
          getSuggestedSymbolForNonexistentSymbol: function(location, name, meaning) {
            return getSuggestedSymbolForNonexistentSymbol(location, ts3.escapeLeadingUnderscores(name), meaning);
          },
          getSuggestionForNonexistentSymbol: function(location, name, meaning) {
            return getSuggestionForNonexistentSymbol(location, ts3.escapeLeadingUnderscores(name), meaning);
          },
          getSuggestedSymbolForNonexistentModule,
          getSuggestionForNonexistentExport,
          getSuggestedSymbolForNonexistentClassMember,
          getBaseConstraintOfType,
          getDefaultFromTypeParameter: function(type2) {
            return type2 && type2.flags & 262144 ? getDefaultFromTypeParameter(type2) : void 0;
          },
          resolveName: function(name, location, meaning, excludeGlobals) {
            return resolveName(location, ts3.escapeLeadingUnderscores(name), meaning, void 0, void 0, false, excludeGlobals);
          },
          getJsxNamespace: function(n) {
            return ts3.unescapeLeadingUnderscores(getJsxNamespace(n));
          },
          getJsxFragmentFactory: function(n) {
            var jsxFragmentFactory = getJsxFragmentFactoryEntity(n);
            return jsxFragmentFactory && ts3.unescapeLeadingUnderscores(ts3.getFirstIdentifier(jsxFragmentFactory).escapedText);
          },
          getAccessibleSymbolChain,
          getTypePredicateOfSignature,
          resolveExternalModuleName: function(moduleSpecifierIn) {
            var moduleSpecifier = ts3.getParseTreeNode(moduleSpecifierIn, ts3.isExpression);
            return moduleSpecifier && resolveExternalModuleName(moduleSpecifier, moduleSpecifier, true);
          },
          resolveExternalModuleSymbol,
          tryGetThisTypeAt: function(nodeIn, includeGlobalThis) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node && tryGetThisTypeAt(node, includeGlobalThis);
          },
          getTypeArgumentConstraint: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isTypeNode);
            return node && getTypeArgumentConstraint(node);
          },
          getSuggestionDiagnostics: function(fileIn, ct) {
            var file = ts3.getParseTreeNode(fileIn, ts3.isSourceFile) || ts3.Debug.fail("Could not determine parsed source file.");
            if (ts3.skipTypeChecking(file, compilerOptions, host)) {
              return ts3.emptyArray;
            }
            var diagnostics2;
            try {
              cancellationToken = ct;
              checkSourceFileWithEagerDiagnostics(file);
              ts3.Debug.assert(!!(getNodeLinks(file).flags & 1));
              diagnostics2 = ts3.addRange(diagnostics2, suggestionDiagnostics.getDiagnostics(file.fileName));
              checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(file), function(containingNode, kind, diag) {
                if (!ts3.containsParseError(containingNode) && !unusedIsError(kind, !!(containingNode.flags & 16777216))) {
                  (diagnostics2 || (diagnostics2 = [])).push(__assign(__assign({}, diag), { category: ts3.DiagnosticCategory.Suggestion }));
                }
              });
              return diagnostics2 || ts3.emptyArray;
            } finally {
              cancellationToken = void 0;
            }
          },
          runWithCancellationToken: function(token, callback) {
            try {
              cancellationToken = token;
              return callback(checker);
            } finally {
              cancellationToken = void 0;
            }
          },
          getLocalTypeParametersOfClassOrInterfaceOrTypeAlias,
          isDeclarationVisible,
          isPropertyAccessible,
          getTypeOnlyAliasDeclaration,
          getMemberOverrideModifierStatus
        };
        function runWithInferenceBlockedFromSourceNode(node, fn) {
          var containingCall = ts3.findAncestor(node, ts3.isCallLikeExpression);
          var containingCallResolvedSignature = containingCall && getNodeLinks(containingCall).resolvedSignature;
          if (containingCall) {
            var toMarkSkip = node;
            do {
              getNodeLinks(toMarkSkip).skipDirectInference = true;
              toMarkSkip = toMarkSkip.parent;
            } while (toMarkSkip && toMarkSkip !== containingCall);
            getNodeLinks(containingCall).resolvedSignature = void 0;
          }
          var result2 = fn();
          if (containingCall) {
            var toMarkSkip = node;
            do {
              getNodeLinks(toMarkSkip).skipDirectInference = void 0;
              toMarkSkip = toMarkSkip.parent;
            } while (toMarkSkip && toMarkSkip !== containingCall);
            getNodeLinks(containingCall).resolvedSignature = containingCallResolvedSignature;
          }
          return result2;
        }
        function getResolvedSignatureWorker(nodeIn, candidatesOutArray, argumentCount, checkMode, editingArgument) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isCallLikeExpression);
          apparentArgumentCount = argumentCount;
          var res = !node ? void 0 : editingArgument ? runWithInferenceBlockedFromSourceNode(editingArgument, function() {
            return getResolvedSignature(node, candidatesOutArray, checkMode);
          }) : getResolvedSignature(node, candidatesOutArray, checkMode);
          apparentArgumentCount = void 0;
          return res;
        }
        var tupleTypes = new ts3.Map();
        var unionTypes = new ts3.Map();
        var intersectionTypes = new ts3.Map();
        var stringLiteralTypes = new ts3.Map();
        var numberLiteralTypes = new ts3.Map();
        var bigIntLiteralTypes = new ts3.Map();
        var enumLiteralTypes = new ts3.Map();
        var indexedAccessTypes = new ts3.Map();
        var templateLiteralTypes = new ts3.Map();
        var stringMappingTypes = new ts3.Map();
        var substitutionTypes = new ts3.Map();
        var subtypeReductionCache = new ts3.Map();
        var evolvingArrayTypes = [];
        var undefinedProperties = new ts3.Map();
        var markerTypes = new ts3.Set();
        var unknownSymbol = createSymbol(4, "unknown");
        var resolvingSymbol = createSymbol(0, "__resolving__");
        var unresolvedSymbols = new ts3.Map();
        var errorTypes = new ts3.Map();
        var anyType = createIntrinsicType(1, "any");
        var autoType = createIntrinsicType(1, "any");
        var wildcardType = createIntrinsicType(1, "any");
        var errorType = createIntrinsicType(1, "error");
        var unresolvedType = createIntrinsicType(1, "unresolved");
        var nonInferrableAnyType = createIntrinsicType(1, "any", 65536);
        var intrinsicMarkerType = createIntrinsicType(1, "intrinsic");
        var unknownType = createIntrinsicType(2, "unknown");
        var nonNullUnknownType = createIntrinsicType(2, "unknown");
        var undefinedType = createIntrinsicType(32768, "undefined");
        var undefinedWideningType = strictNullChecks ? undefinedType : createIntrinsicType(32768, "undefined", 65536);
        var optionalType = createIntrinsicType(32768, "undefined");
        var missingType = exactOptionalPropertyTypes ? createIntrinsicType(32768, "undefined") : undefinedType;
        var nullType = createIntrinsicType(65536, "null");
        var nullWideningType = strictNullChecks ? nullType : createIntrinsicType(65536, "null", 65536);
        var stringType = createIntrinsicType(4, "string");
        var numberType = createIntrinsicType(8, "number");
        var bigintType = createIntrinsicType(64, "bigint");
        var falseType = createIntrinsicType(512, "false");
        var regularFalseType = createIntrinsicType(512, "false");
        var trueType = createIntrinsicType(512, "true");
        var regularTrueType = createIntrinsicType(512, "true");
        trueType.regularType = regularTrueType;
        trueType.freshType = trueType;
        regularTrueType.regularType = regularTrueType;
        regularTrueType.freshType = trueType;
        falseType.regularType = regularFalseType;
        falseType.freshType = falseType;
        regularFalseType.regularType = regularFalseType;
        regularFalseType.freshType = falseType;
        var booleanType = getUnionType([regularFalseType, regularTrueType]);
        var esSymbolType = createIntrinsicType(4096, "symbol");
        var voidType = createIntrinsicType(16384, "void");
        var neverType = createIntrinsicType(131072, "never");
        var silentNeverType = createIntrinsicType(131072, "never");
        var nonInferrableType = createIntrinsicType(131072, "never", 262144);
        var implicitNeverType = createIntrinsicType(131072, "never");
        var unreachableNeverType = createIntrinsicType(131072, "never");
        var nonPrimitiveType = createIntrinsicType(67108864, "object");
        var stringOrNumberType = getUnionType([stringType, numberType]);
        var stringNumberSymbolType = getUnionType([stringType, numberType, esSymbolType]);
        var keyofConstraintType = keyofStringsOnly ? stringType : stringNumberSymbolType;
        var numberOrBigIntType = getUnionType([numberType, bigintType]);
        var templateConstraintType = getUnionType([stringType, numberType, booleanType, bigintType, nullType, undefinedType]);
        var numericStringType = getTemplateLiteralType(["", ""], [numberType]);
        var restrictiveMapper = makeFunctionTypeMapper(function(t) {
          return t.flags & 262144 ? getRestrictiveTypeParameter(t) : t;
        });
        var permissiveMapper = makeFunctionTypeMapper(function(t) {
          return t.flags & 262144 ? wildcardType : t;
        });
        var uniqueLiteralType = createIntrinsicType(131072, "never");
        var uniqueLiteralMapper = makeFunctionTypeMapper(function(t) {
          return t.flags & 262144 ? uniqueLiteralType : t;
        });
        var emptyObjectType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        var emptyJsxObjectType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        emptyJsxObjectType.objectFlags |= 2048;
        var emptyTypeLiteralSymbol = createSymbol(2048, "__type");
        emptyTypeLiteralSymbol.members = ts3.createSymbolTable();
        var emptyTypeLiteralType = createAnonymousType(emptyTypeLiteralSymbol, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        var emptyGenericType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        emptyGenericType.instantiations = new ts3.Map();
        var anyFunctionType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        anyFunctionType.objectFlags |= 262144;
        var noConstraintType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        var circularConstraintType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        var resolvingDefaultType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        var markerSuperType = createTypeParameter();
        var markerSubType = createTypeParameter();
        markerSubType.constraint = markerSuperType;
        var markerOtherType = createTypeParameter();
        var noTypePredicate = createTypePredicate(1, "<<unresolved>>", 0, anyType);
        var anySignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, anyType, void 0, 0, 0);
        var unknownSignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, errorType, void 0, 0, 0);
        var resolvingSignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, anyType, void 0, 0, 0);
        var silentNeverSignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, silentNeverType, void 0, 0, 0);
        var enumNumberIndexInfo = createIndexInfo(numberType, stringType, true);
        var iterationTypesCache = new ts3.Map();
        var noIterationTypes = {
          get yieldType() {
            return ts3.Debug.fail("Not supported");
          },
          get returnType() {
            return ts3.Debug.fail("Not supported");
          },
          get nextType() {
            return ts3.Debug.fail("Not supported");
          }
        };
        var anyIterationTypes = createIterationTypes(anyType, anyType, anyType);
        var anyIterationTypesExceptNext = createIterationTypes(anyType, anyType, unknownType);
        var defaultIterationTypes = createIterationTypes(neverType, anyType, undefinedType);
        var asyncIterationTypesResolver = {
          iterableCacheKey: "iterationTypesOfAsyncIterable",
          iteratorCacheKey: "iterationTypesOfAsyncIterator",
          iteratorSymbolName: "asyncIterator",
          getGlobalIteratorType: getGlobalAsyncIteratorType,
          getGlobalIterableType: getGlobalAsyncIterableType,
          getGlobalIterableIteratorType: getGlobalAsyncIterableIteratorType,
          getGlobalGeneratorType: getGlobalAsyncGeneratorType,
          resolveIterationType: getAwaitedType,
          mustHaveANextMethodDiagnostic: ts3.Diagnostics.An_async_iterator_must_have_a_next_method,
          mustBeAMethodDiagnostic: ts3.Diagnostics.The_0_property_of_an_async_iterator_must_be_a_method,
          mustHaveAValueDiagnostic: ts3.Diagnostics.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property
        };
        var syncIterationTypesResolver = {
          iterableCacheKey: "iterationTypesOfIterable",
          iteratorCacheKey: "iterationTypesOfIterator",
          iteratorSymbolName: "iterator",
          getGlobalIteratorType,
          getGlobalIterableType,
          getGlobalIterableIteratorType,
          getGlobalGeneratorType,
          resolveIterationType: function(type2, _errorNode) {
            return type2;
          },
          mustHaveANextMethodDiagnostic: ts3.Diagnostics.An_iterator_must_have_a_next_method,
          mustBeAMethodDiagnostic: ts3.Diagnostics.The_0_property_of_an_iterator_must_be_a_method,
          mustHaveAValueDiagnostic: ts3.Diagnostics.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property
        };
        var amalgamatedDuplicates;
        var reverseMappedCache = new ts3.Map();
        var inInferTypeForHomomorphicMappedType = false;
        var ambientModulesCache;
        var patternAmbientModules;
        var patternAmbientModuleAugmentations;
        var globalObjectType;
        var globalFunctionType;
        var globalCallableFunctionType;
        var globalNewableFunctionType;
        var globalArrayType;
        var globalReadonlyArrayType;
        var globalStringType;
        var globalNumberType;
        var globalBooleanType;
        var globalRegExpType;
        var globalThisType;
        var anyArrayType;
        var autoArrayType;
        var anyReadonlyArrayType;
        var deferredGlobalNonNullableTypeAlias;
        var deferredGlobalESSymbolConstructorSymbol;
        var deferredGlobalESSymbolConstructorTypeSymbol;
        var deferredGlobalESSymbolType;
        var deferredGlobalTypedPropertyDescriptorType;
        var deferredGlobalPromiseType;
        var deferredGlobalPromiseLikeType;
        var deferredGlobalPromiseConstructorSymbol;
        var deferredGlobalPromiseConstructorLikeType;
        var deferredGlobalIterableType;
        var deferredGlobalIteratorType;
        var deferredGlobalIterableIteratorType;
        var deferredGlobalGeneratorType;
        var deferredGlobalIteratorYieldResultType;
        var deferredGlobalIteratorReturnResultType;
        var deferredGlobalAsyncIterableType;
        var deferredGlobalAsyncIteratorType;
        var deferredGlobalAsyncIterableIteratorType;
        var deferredGlobalAsyncGeneratorType;
        var deferredGlobalTemplateStringsArrayType;
        var deferredGlobalImportMetaType;
        var deferredGlobalImportMetaExpressionType;
        var deferredGlobalImportCallOptionsType;
        var deferredGlobalExtractSymbol;
        var deferredGlobalOmitSymbol;
        var deferredGlobalAwaitedSymbol;
        var deferredGlobalBigIntType;
        var allPotentiallyUnusedIdentifiers = new ts3.Map();
        var flowLoopStart = 0;
        var flowLoopCount = 0;
        var sharedFlowCount = 0;
        var flowAnalysisDisabled = false;
        var flowInvocationCount = 0;
        var lastFlowNode;
        var lastFlowNodeReachable;
        var flowTypeCache;
        var emptyStringType = getStringLiteralType("");
        var zeroType = getNumberLiteralType(0);
        var zeroBigIntType = getBigIntLiteralType({ negative: false, base10Value: "0" });
        var resolutionTargets = [];
        var resolutionResults = [];
        var resolutionPropertyNames = [];
        var suggestionCount = 0;
        var maximumSuggestionCount = 10;
        var mergedSymbols = [];
        var symbolLinks = [];
        var nodeLinks = [];
        var flowLoopCaches = [];
        var flowLoopNodes = [];
        var flowLoopKeys = [];
        var flowLoopTypes = [];
        var sharedFlowNodes = [];
        var sharedFlowTypes = [];
        var flowNodeReachable = [];
        var flowNodePostSuper = [];
        var potentialThisCollisions = [];
        var potentialNewTargetCollisions = [];
        var potentialWeakMapSetCollisions = [];
        var potentialReflectCollisions = [];
        var awaitedTypeStack = [];
        var diagnostics = ts3.createDiagnosticCollection();
        var suggestionDiagnostics = ts3.createDiagnosticCollection();
        var typeofTypesByName = new ts3.Map(ts3.getEntries({
          string: stringType,
          number: numberType,
          bigint: bigintType,
          boolean: booleanType,
          symbol: esSymbolType,
          undefined: undefinedType
        }));
        var typeofType = createTypeofType();
        var _jsxNamespace;
        var _jsxFactoryEntity;
        var outofbandVarianceMarkerHandler;
        var subtypeRelation = new ts3.Map();
        var strictSubtypeRelation = new ts3.Map();
        var assignableRelation = new ts3.Map();
        var comparableRelation = new ts3.Map();
        var identityRelation = new ts3.Map();
        var enumRelation = new ts3.Map();
        var builtinGlobals = ts3.createSymbolTable();
        builtinGlobals.set(undefinedSymbol.escapedName, undefinedSymbol);
        var suggestedExtensions = [
          [".mts", ".mjs"],
          [".ts", ".js"],
          [".cts", ".cjs"],
          [".mjs", ".mjs"],
          [".js", ".js"],
          [".cjs", ".cjs"],
          [".tsx", compilerOptions.jsx === 1 ? ".jsx" : ".js"],
          [".jsx", ".jsx"],
          [".json", ".json"]
        ];
        initializeTypeChecker();
        return checker;
        function getJsxNamespace(location) {
          if (location) {
            var file = ts3.getSourceFileOfNode(location);
            if (file) {
              if (ts3.isJsxOpeningFragment(location)) {
                if (file.localJsxFragmentNamespace) {
                  return file.localJsxFragmentNamespace;
                }
                var jsxFragmentPragma = file.pragmas.get("jsxfrag");
                if (jsxFragmentPragma) {
                  var chosenPragma = ts3.isArray(jsxFragmentPragma) ? jsxFragmentPragma[0] : jsxFragmentPragma;
                  file.localJsxFragmentFactory = ts3.parseIsolatedEntityName(chosenPragma.arguments.factory, languageVersion);
                  ts3.visitNode(file.localJsxFragmentFactory, markAsSynthetic);
                  if (file.localJsxFragmentFactory) {
                    return file.localJsxFragmentNamespace = ts3.getFirstIdentifier(file.localJsxFragmentFactory).escapedText;
                  }
                }
                var entity = getJsxFragmentFactoryEntity(location);
                if (entity) {
                  file.localJsxFragmentFactory = entity;
                  return file.localJsxFragmentNamespace = ts3.getFirstIdentifier(entity).escapedText;
                }
              } else {
                var localJsxNamespace = getLocalJsxNamespace(file);
                if (localJsxNamespace) {
                  return file.localJsxNamespace = localJsxNamespace;
                }
              }
            }
          }
          if (!_jsxNamespace) {
            _jsxNamespace = "React";
            if (compilerOptions.jsxFactory) {
              _jsxFactoryEntity = ts3.parseIsolatedEntityName(compilerOptions.jsxFactory, languageVersion);
              ts3.visitNode(_jsxFactoryEntity, markAsSynthetic);
              if (_jsxFactoryEntity) {
                _jsxNamespace = ts3.getFirstIdentifier(_jsxFactoryEntity).escapedText;
              }
            } else if (compilerOptions.reactNamespace) {
              _jsxNamespace = ts3.escapeLeadingUnderscores(compilerOptions.reactNamespace);
            }
          }
          if (!_jsxFactoryEntity) {
            _jsxFactoryEntity = ts3.factory.createQualifiedName(ts3.factory.createIdentifier(ts3.unescapeLeadingUnderscores(_jsxNamespace)), "createElement");
          }
          return _jsxNamespace;
        }
        function getLocalJsxNamespace(file) {
          if (file.localJsxNamespace) {
            return file.localJsxNamespace;
          }
          var jsxPragma = file.pragmas.get("jsx");
          if (jsxPragma) {
            var chosenPragma = ts3.isArray(jsxPragma) ? jsxPragma[0] : jsxPragma;
            file.localJsxFactory = ts3.parseIsolatedEntityName(chosenPragma.arguments.factory, languageVersion);
            ts3.visitNode(file.localJsxFactory, markAsSynthetic);
            if (file.localJsxFactory) {
              return file.localJsxNamespace = ts3.getFirstIdentifier(file.localJsxFactory).escapedText;
            }
          }
        }
        function markAsSynthetic(node) {
          ts3.setTextRangePosEnd(node, -1, -1);
          return ts3.visitEachChild(node, markAsSynthetic, ts3.nullTransformationContext);
        }
        function getEmitResolver(sourceFile, cancellationToken2) {
          getDiagnostics(sourceFile, cancellationToken2);
          return emitResolver;
        }
        function lookupOrIssueError(location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = location ? ts3.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts3.createCompilerDiagnostic(message, arg0, arg1, arg2, arg3);
          var existing = diagnostics.lookup(diagnostic);
          if (existing) {
            return existing;
          } else {
            diagnostics.add(diagnostic);
            return diagnostic;
          }
        }
        function errorSkippedOn(key, location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = error(location, message, arg0, arg1, arg2, arg3);
          diagnostic.skippedOn = key;
          return diagnostic;
        }
        function createError(location, message, arg0, arg1, arg2, arg3) {
          return location ? ts3.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts3.createCompilerDiagnostic(message, arg0, arg1, arg2, arg3);
        }
        function error(location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = createError(location, message, arg0, arg1, arg2, arg3);
          diagnostics.add(diagnostic);
          return diagnostic;
        }
        function addErrorOrSuggestion(isError, diagnostic) {
          if (isError) {
            diagnostics.add(diagnostic);
          } else {
            suggestionDiagnostics.add(__assign(__assign({}, diagnostic), { category: ts3.DiagnosticCategory.Suggestion }));
          }
        }
        function errorOrSuggestion(isError, location, message, arg0, arg1, arg2, arg3) {
          if (location.pos < 0 || location.end < 0) {
            if (!isError) {
              return;
            }
            var file = ts3.getSourceFileOfNode(location);
            addErrorOrSuggestion(isError, "message" in message ? ts3.createFileDiagnostic(file, 0, 0, message, arg0, arg1, arg2, arg3) : ts3.createDiagnosticForFileFromMessageChain(file, message));
            return;
          }
          addErrorOrSuggestion(isError, "message" in message ? ts3.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts3.createDiagnosticForNodeFromMessageChain(location, message));
        }
        function errorAndMaybeSuggestAwait(location, maybeMissingAwait, message, arg0, arg1, arg2, arg3) {
          var diagnostic = error(location, message, arg0, arg1, arg2, arg3);
          if (maybeMissingAwait) {
            var related = ts3.createDiagnosticForNode(location, ts3.Diagnostics.Did_you_forget_to_use_await);
            ts3.addRelatedInfo(diagnostic, related);
          }
          return diagnostic;
        }
        function addDeprecatedSuggestionWorker(declarations, diagnostic) {
          var deprecatedTag = Array.isArray(declarations) ? ts3.forEach(declarations, ts3.getJSDocDeprecatedTag) : ts3.getJSDocDeprecatedTag(declarations);
          if (deprecatedTag) {
            ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(deprecatedTag, ts3.Diagnostics.The_declaration_was_marked_as_deprecated_here));
          }
          suggestionDiagnostics.add(diagnostic);
          return diagnostic;
        }
        function isDeprecatedSymbol(symbol) {
          return !!(getDeclarationNodeFlagsFromSymbol(symbol) & 268435456);
        }
        function addDeprecatedSuggestion(location, declarations, deprecatedEntity) {
          var diagnostic = ts3.createDiagnosticForNode(location, ts3.Diagnostics._0_is_deprecated, deprecatedEntity);
          return addDeprecatedSuggestionWorker(declarations, diagnostic);
        }
        function addDeprecatedSuggestionWithSignature(location, declaration, deprecatedEntity, signatureString) {
          var diagnostic = deprecatedEntity ? ts3.createDiagnosticForNode(location, ts3.Diagnostics.The_signature_0_of_1_is_deprecated, signatureString, deprecatedEntity) : ts3.createDiagnosticForNode(location, ts3.Diagnostics._0_is_deprecated, signatureString);
          return addDeprecatedSuggestionWorker(declaration, diagnostic);
        }
        function createSymbol(flags, name, checkFlags) {
          symbolCount++;
          var symbol = new Symbol2(flags | 33554432, name);
          symbol.checkFlags = checkFlags || 0;
          return symbol;
        }
        function getExcludedSymbolFlags(flags) {
          var result2 = 0;
          if (flags & 2)
            result2 |= 111551;
          if (flags & 1)
            result2 |= 111550;
          if (flags & 4)
            result2 |= 0;
          if (flags & 8)
            result2 |= 900095;
          if (flags & 16)
            result2 |= 110991;
          if (flags & 32)
            result2 |= 899503;
          if (flags & 64)
            result2 |= 788872;
          if (flags & 256)
            result2 |= 899327;
          if (flags & 128)
            result2 |= 899967;
          if (flags & 512)
            result2 |= 110735;
          if (flags & 8192)
            result2 |= 103359;
          if (flags & 32768)
            result2 |= 46015;
          if (flags & 65536)
            result2 |= 78783;
          if (flags & 262144)
            result2 |= 526824;
          if (flags & 524288)
            result2 |= 788968;
          if (flags & 2097152)
            result2 |= 2097152;
          return result2;
        }
        function recordMergedSymbol(target, source) {
          if (!source.mergeId) {
            source.mergeId = nextMergeId;
            nextMergeId++;
          }
          mergedSymbols[source.mergeId] = target;
        }
        function cloneSymbol(symbol) {
          var result2 = createSymbol(symbol.flags, symbol.escapedName);
          result2.declarations = symbol.declarations ? symbol.declarations.slice() : [];
          result2.parent = symbol.parent;
          if (symbol.valueDeclaration)
            result2.valueDeclaration = symbol.valueDeclaration;
          if (symbol.constEnumOnlyModule)
            result2.constEnumOnlyModule = true;
          if (symbol.members)
            result2.members = new ts3.Map(symbol.members);
          if (symbol.exports)
            result2.exports = new ts3.Map(symbol.exports);
          recordMergedSymbol(result2, symbol);
          return result2;
        }
        function mergeSymbol(target, source, unidirectional) {
          if (unidirectional === void 0) {
            unidirectional = false;
          }
          if (!(target.flags & getExcludedSymbolFlags(source.flags)) || (source.flags | target.flags) & 67108864) {
            if (source === target) {
              return target;
            }
            if (!(target.flags & 33554432)) {
              var resolvedTarget = resolveSymbol(target);
              if (resolvedTarget === unknownSymbol) {
                return source;
              }
              target = cloneSymbol(resolvedTarget);
            }
            if (source.flags & 512 && target.flags & 512 && target.constEnumOnlyModule && !source.constEnumOnlyModule) {
              target.constEnumOnlyModule = false;
            }
            target.flags |= source.flags;
            if (source.valueDeclaration) {
              ts3.setValueDeclaration(target, source.valueDeclaration);
            }
            ts3.addRange(target.declarations, source.declarations);
            if (source.members) {
              if (!target.members)
                target.members = ts3.createSymbolTable();
              mergeSymbolTable(target.members, source.members, unidirectional);
            }
            if (source.exports) {
              if (!target.exports)
                target.exports = ts3.createSymbolTable();
              mergeSymbolTable(target.exports, source.exports, unidirectional);
            }
            if (!unidirectional) {
              recordMergedSymbol(target, source);
            }
          } else if (target.flags & 1024) {
            if (target !== globalThisSymbol) {
              error(source.declarations && ts3.getNameOfDeclaration(source.declarations[0]), ts3.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity, symbolToString(target));
            }
          } else {
            var isEitherEnum = !!(target.flags & 384 || source.flags & 384);
            var isEitherBlockScoped_1 = !!(target.flags & 2 || source.flags & 2);
            var message = isEitherEnum ? ts3.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations : isEitherBlockScoped_1 ? ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts3.Diagnostics.Duplicate_identifier_0;
            var sourceSymbolFile = source.declarations && ts3.getSourceFileOfNode(source.declarations[0]);
            var targetSymbolFile = target.declarations && ts3.getSourceFileOfNode(target.declarations[0]);
            var isSourcePlainJs = ts3.isPlainJsFile(sourceSymbolFile, compilerOptions.checkJs);
            var isTargetPlainJs = ts3.isPlainJsFile(targetSymbolFile, compilerOptions.checkJs);
            var symbolName_1 = symbolToString(source);
            if (sourceSymbolFile && targetSymbolFile && amalgamatedDuplicates && !isEitherEnum && sourceSymbolFile !== targetSymbolFile) {
              var firstFile_1 = ts3.comparePaths(sourceSymbolFile.path, targetSymbolFile.path) === -1 ? sourceSymbolFile : targetSymbolFile;
              var secondFile_1 = firstFile_1 === sourceSymbolFile ? targetSymbolFile : sourceSymbolFile;
              var filesDuplicates = ts3.getOrUpdate(amalgamatedDuplicates, "".concat(firstFile_1.path, "|").concat(secondFile_1.path), function() {
                return { firstFile: firstFile_1, secondFile: secondFile_1, conflictingSymbols: new ts3.Map() };
              });
              var conflictingSymbolInfo = ts3.getOrUpdate(filesDuplicates.conflictingSymbols, symbolName_1, function() {
                return { isBlockScoped: isEitherBlockScoped_1, firstFileLocations: [], secondFileLocations: [] };
              });
              if (!isSourcePlainJs)
                addDuplicateLocations(conflictingSymbolInfo.firstFileLocations, source);
              if (!isTargetPlainJs)
                addDuplicateLocations(conflictingSymbolInfo.secondFileLocations, target);
            } else {
              if (!isSourcePlainJs)
                addDuplicateDeclarationErrorsForSymbols(source, message, symbolName_1, target);
              if (!isTargetPlainJs)
                addDuplicateDeclarationErrorsForSymbols(target, message, symbolName_1, source);
            }
          }
          return target;
          function addDuplicateLocations(locs, symbol) {
            if (symbol.declarations) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var decl = _a[_i];
                ts3.pushIfUnique(locs, decl);
              }
            }
          }
        }
        function addDuplicateDeclarationErrorsForSymbols(target, message, symbolName, source) {
          ts3.forEach(target.declarations, function(node) {
            addDuplicateDeclarationError(node, message, symbolName, source.declarations);
          });
        }
        function addDuplicateDeclarationError(node, message, symbolName, relatedNodes) {
          var errorNode = (ts3.getExpandoInitializer(node, false) ? ts3.getNameOfExpando(node) : ts3.getNameOfDeclaration(node)) || node;
          var err = lookupOrIssueError(errorNode, message, symbolName);
          var _loop_7 = function(relatedNode2) {
            var adjustedNode = (ts3.getExpandoInitializer(relatedNode2, false) ? ts3.getNameOfExpando(relatedNode2) : ts3.getNameOfDeclaration(relatedNode2)) || relatedNode2;
            if (adjustedNode === errorNode)
              return "continue";
            err.relatedInformation = err.relatedInformation || [];
            var leadingMessage = ts3.createDiagnosticForNode(adjustedNode, ts3.Diagnostics._0_was_also_declared_here, symbolName);
            var followOnMessage = ts3.createDiagnosticForNode(adjustedNode, ts3.Diagnostics.and_here);
            if (ts3.length(err.relatedInformation) >= 5 || ts3.some(err.relatedInformation, function(r) {
              return ts3.compareDiagnostics(r, followOnMessage) === 0 || ts3.compareDiagnostics(r, leadingMessage) === 0;
            }))
              return "continue";
            ts3.addRelatedInfo(err, !ts3.length(err.relatedInformation) ? leadingMessage : followOnMessage);
          };
          for (var _i = 0, _a = relatedNodes || ts3.emptyArray; _i < _a.length; _i++) {
            var relatedNode = _a[_i];
            _loop_7(relatedNode);
          }
        }
        function combineSymbolTables(first, second) {
          if (!(first === null || first === void 0 ? void 0 : first.size))
            return second;
          if (!(second === null || second === void 0 ? void 0 : second.size))
            return first;
          var combined = ts3.createSymbolTable();
          mergeSymbolTable(combined, first);
          mergeSymbolTable(combined, second);
          return combined;
        }
        function mergeSymbolTable(target, source, unidirectional) {
          if (unidirectional === void 0) {
            unidirectional = false;
          }
          source.forEach(function(sourceSymbol, id) {
            var targetSymbol = target.get(id);
            target.set(id, targetSymbol ? mergeSymbol(targetSymbol, sourceSymbol, unidirectional) : sourceSymbol);
          });
        }
        function mergeModuleAugmentation(moduleName) {
          var _a, _b, _c;
          var moduleAugmentation = moduleName.parent;
          if (((_a = moduleAugmentation.symbol.declarations) === null || _a === void 0 ? void 0 : _a[0]) !== moduleAugmentation) {
            ts3.Debug.assert(moduleAugmentation.symbol.declarations.length > 1);
            return;
          }
          if (ts3.isGlobalScopeAugmentation(moduleAugmentation)) {
            mergeSymbolTable(globals, moduleAugmentation.symbol.exports);
          } else {
            var moduleNotFoundError = !(moduleName.parent.parent.flags & 16777216) ? ts3.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found : void 0;
            var mainModule_1 = resolveExternalModuleNameWorker(moduleName, moduleName, moduleNotFoundError, true);
            if (!mainModule_1) {
              return;
            }
            mainModule_1 = resolveExternalModuleSymbol(mainModule_1);
            if (mainModule_1.flags & 1920) {
              if (ts3.some(patternAmbientModules, function(module3) {
                return mainModule_1 === module3.symbol;
              })) {
                var merged = mergeSymbol(moduleAugmentation.symbol, mainModule_1, true);
                if (!patternAmbientModuleAugmentations) {
                  patternAmbientModuleAugmentations = new ts3.Map();
                }
                patternAmbientModuleAugmentations.set(moduleName.text, merged);
              } else {
                if (((_b = mainModule_1.exports) === null || _b === void 0 ? void 0 : _b.get("__export")) && ((_c = moduleAugmentation.symbol.exports) === null || _c === void 0 ? void 0 : _c.size)) {
                  var resolvedExports = getResolvedMembersOrExportsOfSymbol(mainModule_1, "resolvedExports");
                  for (var _i = 0, _d = ts3.arrayFrom(moduleAugmentation.symbol.exports.entries()); _i < _d.length; _i++) {
                    var _e = _d[_i], key = _e[0], value = _e[1];
                    if (resolvedExports.has(key) && !mainModule_1.exports.has(key)) {
                      mergeSymbol(resolvedExports.get(key), value);
                    }
                  }
                }
                mergeSymbol(mainModule_1, moduleAugmentation.symbol);
              }
            } else {
              error(moduleName, ts3.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity, moduleName.text);
            }
          }
        }
        function addToSymbolTable(target, source, message) {
          source.forEach(function(sourceSymbol, id) {
            var targetSymbol = target.get(id);
            if (targetSymbol) {
              ts3.forEach(targetSymbol.declarations, addDeclarationDiagnostic(ts3.unescapeLeadingUnderscores(id), message));
            } else {
              target.set(id, sourceSymbol);
            }
          });
          function addDeclarationDiagnostic(id, message2) {
            return function(declaration) {
              return diagnostics.add(ts3.createDiagnosticForNode(declaration, message2, id));
            };
          }
        }
        function getSymbolLinks(symbol) {
          if (symbol.flags & 33554432)
            return symbol;
          var id = getSymbolId(symbol);
          return symbolLinks[id] || (symbolLinks[id] = new SymbolLinks());
        }
        function getNodeLinks(node) {
          var nodeId = getNodeId(node);
          return nodeLinks[nodeId] || (nodeLinks[nodeId] = new NodeLinks());
        }
        function isGlobalSourceFile(node) {
          return node.kind === 305 && !ts3.isExternalOrCommonJsModule(node);
        }
        function getSymbol(symbols, name, meaning) {
          if (meaning) {
            var symbol = getMergedSymbol(symbols.get(name));
            if (symbol) {
              ts3.Debug.assert((ts3.getCheckFlags(symbol) & 1) === 0, "Should never get an instantiated symbol here.");
              if (symbol.flags & meaning) {
                return symbol;
              }
              if (symbol.flags & 2097152) {
                var target = resolveAlias(symbol);
                if (target === unknownSymbol || target.flags & meaning) {
                  return symbol;
                }
              }
            }
          }
        }
        function getSymbolsOfParameterPropertyDeclaration(parameter, parameterName) {
          var constructorDeclaration = parameter.parent;
          var classDeclaration = parameter.parent.parent;
          var parameterSymbol = getSymbol(constructorDeclaration.locals, parameterName, 111551);
          var propertySymbol = getSymbol(getMembersOfSymbol(classDeclaration.symbol), parameterName, 111551);
          if (parameterSymbol && propertySymbol) {
            return [parameterSymbol, propertySymbol];
          }
          return ts3.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration");
        }
        function isBlockScopedNameDeclaredBeforeUse(declaration, usage) {
          var declarationFile = ts3.getSourceFileOfNode(declaration);
          var useFile = ts3.getSourceFileOfNode(usage);
          var declContainer = ts3.getEnclosingBlockScopeContainer(declaration);
          if (declarationFile !== useFile) {
            if (moduleKind && (declarationFile.externalModuleIndicator || useFile.externalModuleIndicator) || !ts3.outFile(compilerOptions) || isInTypeQuery(usage) || declaration.flags & 16777216) {
              return true;
            }
            if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
              return true;
            }
            var sourceFiles = host.getSourceFiles();
            return sourceFiles.indexOf(declarationFile) <= sourceFiles.indexOf(useFile);
          }
          if (declaration.pos <= usage.pos && !(ts3.isPropertyDeclaration(declaration) && ts3.isThisProperty(usage.parent) && !declaration.initializer && !declaration.exclamationToken)) {
            if (declaration.kind === 203) {
              var errorBindingElement = ts3.getAncestor(usage, 203);
              if (errorBindingElement) {
                return ts3.findAncestor(errorBindingElement, ts3.isBindingElement) !== ts3.findAncestor(declaration, ts3.isBindingElement) || declaration.pos < errorBindingElement.pos;
              }
              return isBlockScopedNameDeclaredBeforeUse(ts3.getAncestor(declaration, 254), usage);
            } else if (declaration.kind === 254) {
              return !isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration, usage);
            } else if (ts3.isClassDeclaration(declaration)) {
              return !ts3.findAncestor(usage, function(n) {
                return ts3.isComputedPropertyName(n) && n.parent.parent === declaration;
              });
            } else if (ts3.isPropertyDeclaration(declaration)) {
              return !isPropertyImmediatelyReferencedWithinDeclaration(declaration, usage, false);
            } else if (ts3.isParameterPropertyDeclaration(declaration, declaration.parent)) {
              return !(ts3.getEmitScriptTarget(compilerOptions) === 99 && useDefineForClassFields && ts3.getContainingClass(declaration) === ts3.getContainingClass(usage) && isUsedInFunctionOrInstanceProperty(usage, declaration));
            }
            return true;
          }
          if (usage.parent.kind === 275 || usage.parent.kind === 271 && usage.parent.isExportEquals) {
            return true;
          }
          if (usage.kind === 271 && usage.isExportEquals) {
            return true;
          }
          if (!!(usage.flags & 8388608) || isInTypeQuery(usage) || usageInTypeDeclaration()) {
            return true;
          }
          if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
            if (ts3.getEmitScriptTarget(compilerOptions) === 99 && useDefineForClassFields && ts3.getContainingClass(declaration) && (ts3.isPropertyDeclaration(declaration) || ts3.isParameterPropertyDeclaration(declaration, declaration.parent))) {
              return !isPropertyImmediatelyReferencedWithinDeclaration(declaration, usage, true);
            } else {
              return true;
            }
          }
          return false;
          function usageInTypeDeclaration() {
            return !!ts3.findAncestor(usage, function(node) {
              return ts3.isInterfaceDeclaration(node) || ts3.isTypeAliasDeclaration(node);
            });
          }
          function isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration2, usage2) {
            switch (declaration2.parent.parent.kind) {
              case 237:
              case 242:
              case 244:
                if (isSameScopeDescendentOf(usage2, declaration2, declContainer)) {
                  return true;
                }
                break;
            }
            var grandparent = declaration2.parent.parent;
            return ts3.isForInOrOfStatement(grandparent) && isSameScopeDescendentOf(usage2, grandparent.expression, declContainer);
          }
          function isUsedInFunctionOrInstanceProperty(usage2, declaration2) {
            return !!ts3.findAncestor(usage2, function(current) {
              if (current === declContainer) {
                return "quit";
              }
              if (ts3.isFunctionLike(current)) {
                return true;
              }
              if (ts3.isClassStaticBlockDeclaration(current)) {
                return declaration2.pos < usage2.pos;
              }
              var propertyDeclaration = ts3.tryCast(current.parent, ts3.isPropertyDeclaration);
              if (propertyDeclaration) {
                var initializerOfProperty = propertyDeclaration.initializer === current;
                if (initializerOfProperty) {
                  if (ts3.isStatic(current.parent)) {
                    if (declaration2.kind === 169) {
                      return true;
                    }
                    if (ts3.isPropertyDeclaration(declaration2) && ts3.getContainingClass(usage2) === ts3.getContainingClass(declaration2)) {
                      var propName = declaration2.name;
                      if (ts3.isIdentifier(propName) || ts3.isPrivateIdentifier(propName)) {
                        var type2 = getTypeOfSymbol(getSymbolOfNode(declaration2));
                        var staticBlocks = ts3.filter(declaration2.parent.members, ts3.isClassStaticBlockDeclaration);
                        if (isPropertyInitializedInStaticBlocks(propName, type2, staticBlocks, declaration2.parent.pos, current.pos)) {
                          return true;
                        }
                      }
                    }
                  } else {
                    var isDeclarationInstanceProperty = declaration2.kind === 167 && !ts3.isStatic(declaration2);
                    if (!isDeclarationInstanceProperty || ts3.getContainingClass(usage2) !== ts3.getContainingClass(declaration2)) {
                      return true;
                    }
                  }
                }
              }
              return false;
            });
          }
          function isPropertyImmediatelyReferencedWithinDeclaration(declaration2, usage2, stopAtAnyPropertyDeclaration) {
            if (usage2.end > declaration2.end) {
              return false;
            }
            var ancestorChangingReferenceScope = ts3.findAncestor(usage2, function(node) {
              if (node === declaration2) {
                return "quit";
              }
              switch (node.kind) {
                case 214:
                  return true;
                case 167:
                  return stopAtAnyPropertyDeclaration && (ts3.isPropertyDeclaration(declaration2) && node.parent === declaration2.parent || ts3.isParameterPropertyDeclaration(declaration2, declaration2.parent) && node.parent === declaration2.parent.parent) ? "quit" : true;
                case 235:
                  switch (node.parent.kind) {
                    case 172:
                    case 169:
                    case 173:
                      return true;
                    default:
                      return false;
                  }
                default:
                  return false;
              }
            });
            return ancestorChangingReferenceScope === void 0;
          }
        }
        function useOuterVariableScopeInParameter(result2, location, lastLocation) {
          var target = ts3.getEmitScriptTarget(compilerOptions);
          var functionLocation = location;
          if (ts3.isParameter(lastLocation) && functionLocation.body && result2.valueDeclaration && result2.valueDeclaration.pos >= functionLocation.body.pos && result2.valueDeclaration.end <= functionLocation.body.end) {
            if (target >= 2) {
              var links = getNodeLinks(functionLocation);
              if (links.declarationRequiresScopeChange === void 0) {
                links.declarationRequiresScopeChange = ts3.forEach(functionLocation.parameters, requiresScopeChange) || false;
              }
              return !links.declarationRequiresScopeChange;
            }
          }
          return false;
          function requiresScopeChange(node) {
            return requiresScopeChangeWorker(node.name) || !!node.initializer && requiresScopeChangeWorker(node.initializer);
          }
          function requiresScopeChangeWorker(node) {
            switch (node.kind) {
              case 214:
              case 213:
              case 256:
              case 171:
                return false;
              case 169:
              case 172:
              case 173:
              case 296:
                return requiresScopeChangeWorker(node.name);
              case 167:
                if (ts3.hasStaticModifier(node)) {
                  return target < 99 || !useDefineForClassFields;
                }
                return requiresScopeChangeWorker(node.name);
              default:
                if (ts3.isNullishCoalesce(node) || ts3.isOptionalChain(node)) {
                  return target < 7;
                }
                if (ts3.isBindingElement(node) && node.dotDotDotToken && ts3.isObjectBindingPattern(node.parent)) {
                  return target < 4;
                }
                if (ts3.isTypeNode(node))
                  return false;
                return ts3.forEachChild(node, requiresScopeChangeWorker) || false;
            }
          }
        }
        function isConstAssertion(location) {
          return ts3.isAssertionExpression(location) && ts3.isConstTypeReference(location.type) || ts3.isJSDocTypeTag(location) && ts3.isConstTypeReference(location.typeExpression);
        }
        function resolveName(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSpellingSuggstions) {
          if (excludeGlobals === void 0) {
            excludeGlobals = false;
          }
          if (getSpellingSuggstions === void 0) {
            getSpellingSuggstions = true;
          }
          return resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSpellingSuggstions, getSymbol);
        }
        function resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSpellingSuggestions, lookup) {
          var _a, _b, _c;
          var originalLocation = location;
          var result2;
          var lastLocation;
          var lastSelfReferenceLocation;
          var propertyWithInvalidInitializer;
          var associatedDeclarationForContainingInitializerOrBindingName;
          var withinDeferredContext = false;
          var errorLocation = location;
          var grandparent;
          var isInExternalModule = false;
          loop:
            while (location) {
              if (name === "const" && isConstAssertion(location)) {
                return void 0;
              }
              if (location.locals && !isGlobalSourceFile(location)) {
                if (result2 = lookup(location.locals, name, meaning)) {
                  var useResult = true;
                  if (ts3.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                    if (meaning & result2.flags & 788968 && lastLocation.kind !== 320) {
                      useResult = result2.flags & 262144 ? lastLocation === location.type || lastLocation.kind === 164 || lastLocation.kind === 340 || lastLocation.kind === 341 || lastLocation.kind === 163 : false;
                    }
                    if (meaning & result2.flags & 3) {
                      if (useOuterVariableScopeInParameter(result2, location, lastLocation)) {
                        useResult = false;
                      } else if (result2.flags & 1) {
                        useResult = lastLocation.kind === 164 || lastLocation === location.type && !!ts3.findAncestor(result2.valueDeclaration, ts3.isParameter);
                      }
                    }
                  } else if (location.kind === 189) {
                    useResult = lastLocation === location.trueType;
                  }
                  if (useResult) {
                    break loop;
                  } else {
                    result2 = void 0;
                  }
                }
              }
              withinDeferredContext = withinDeferredContext || getIsDeferredContext(location, lastLocation);
              switch (location.kind) {
                case 305:
                  if (!ts3.isExternalOrCommonJsModule(location))
                    break;
                  isInExternalModule = true;
                case 261:
                  var moduleExports = ((_a = getSymbolOfNode(location)) === null || _a === void 0 ? void 0 : _a.exports) || emptySymbols;
                  if (location.kind === 305 || ts3.isModuleDeclaration(location) && location.flags & 16777216 && !ts3.isGlobalScopeAugmentation(location)) {
                    if (result2 = moduleExports.get("default")) {
                      var localSymbol = ts3.getLocalSymbolForExportDefault(result2);
                      if (localSymbol && result2.flags & meaning && localSymbol.escapedName === name) {
                        break loop;
                      }
                      result2 = void 0;
                    }
                    var moduleExport = moduleExports.get(name);
                    if (moduleExport && moduleExport.flags === 2097152 && (ts3.getDeclarationOfKind(moduleExport, 275) || ts3.getDeclarationOfKind(moduleExport, 274))) {
                      break;
                    }
                  }
                  if (name !== "default" && (result2 = lookup(moduleExports, name, meaning & 2623475))) {
                    if (ts3.isSourceFile(location) && location.commonJsModuleIndicator && !((_b = result2.declarations) === null || _b === void 0 ? void 0 : _b.some(ts3.isJSDocTypeAlias))) {
                      result2 = void 0;
                    } else {
                      break loop;
                    }
                  }
                  break;
                case 260:
                  if (result2 = lookup(((_c = getSymbolOfNode(location)) === null || _c === void 0 ? void 0 : _c.exports) || emptySymbols, name, meaning & 8)) {
                    break loop;
                  }
                  break;
                case 167:
                  if (!ts3.isStatic(location)) {
                    var ctor = findConstructorDeclaration(location.parent);
                    if (ctor && ctor.locals) {
                      if (lookup(ctor.locals, name, meaning & 111551)) {
                        propertyWithInvalidInitializer = location;
                      }
                    }
                  }
                  break;
                case 257:
                case 226:
                case 258:
                  if (result2 = lookup(getSymbolOfNode(location).members || emptySymbols, name, meaning & 788968)) {
                    if (!isTypeParameterSymbolDeclaredInContainer(result2, location)) {
                      result2 = void 0;
                      break;
                    }
                    if (lastLocation && ts3.isStatic(lastLocation)) {
                      error(errorLocation, ts3.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                      return void 0;
                    }
                    break loop;
                  }
                  if (location.kind === 226 && meaning & 32) {
                    var className = location.name;
                    if (className && name === className.escapedText) {
                      result2 = location.symbol;
                      break loop;
                    }
                  }
                  break;
                case 228:
                  if (lastLocation === location.expression && location.parent.token === 94) {
                    var container = location.parent.parent;
                    if (ts3.isClassLike(container) && (result2 = lookup(getSymbolOfNode(container).members, name, meaning & 788968))) {
                      if (nameNotFoundMessage) {
                        error(errorLocation, ts3.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters);
                      }
                      return void 0;
                    }
                  }
                  break;
                case 162:
                  grandparent = location.parent.parent;
                  if (ts3.isClassLike(grandparent) || grandparent.kind === 258) {
                    if (result2 = lookup(getSymbolOfNode(grandparent).members, name, meaning & 788968)) {
                      error(errorLocation, ts3.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                      return void 0;
                    }
                  }
                  break;
                case 214:
                  if (ts3.getEmitScriptTarget(compilerOptions) >= 2) {
                    break;
                  }
                case 169:
                case 171:
                case 172:
                case 173:
                case 256:
                  if (meaning & 3 && name === "arguments") {
                    result2 = argumentsSymbol;
                    break loop;
                  }
                  break;
                case 213:
                  if (meaning & 3 && name === "arguments") {
                    result2 = argumentsSymbol;
                    break loop;
                  }
                  if (meaning & 16) {
                    var functionName = location.name;
                    if (functionName && name === functionName.escapedText) {
                      result2 = location.symbol;
                      break loop;
                    }
                  }
                  break;
                case 165:
                  if (location.parent && location.parent.kind === 164) {
                    location = location.parent;
                  }
                  if (location.parent && (ts3.isClassElement(location.parent) || location.parent.kind === 257)) {
                    location = location.parent;
                  }
                  break;
                case 345:
                case 338:
                case 339:
                  var root = ts3.getJSDocRoot(location);
                  if (root) {
                    location = root.parent;
                  }
                  break;
                case 164:
                  if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && ts3.isBindingPattern(lastLocation))) {
                    if (!associatedDeclarationForContainingInitializerOrBindingName) {
                      associatedDeclarationForContainingInitializerOrBindingName = location;
                    }
                  }
                  break;
                case 203:
                  if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && ts3.isBindingPattern(lastLocation))) {
                    if (ts3.isParameterDeclaration(location) && !associatedDeclarationForContainingInitializerOrBindingName) {
                      associatedDeclarationForContainingInitializerOrBindingName = location;
                    }
                  }
                  break;
                case 190:
                  if (meaning & 262144) {
                    var parameterName = location.typeParameter.name;
                    if (parameterName && name === parameterName.escapedText) {
                      result2 = location.typeParameter.symbol;
                      break loop;
                    }
                  }
                  break;
              }
              if (isSelfReferenceLocation(location)) {
                lastSelfReferenceLocation = location;
              }
              lastLocation = location;
              location = ts3.isJSDocTemplateTag(location) ? ts3.getEffectiveContainerForJSDocTemplateTag(location) || location.parent : ts3.isJSDocParameterTag(location) || ts3.isJSDocReturnTag(location) ? ts3.getHostSignatureFromJSDoc(location) || location.parent : location.parent;
            }
          if (isUse && result2 && (!lastSelfReferenceLocation || result2 !== lastSelfReferenceLocation.symbol)) {
            result2.isReferenced |= meaning;
          }
          if (!result2) {
            if (lastLocation) {
              ts3.Debug.assert(lastLocation.kind === 305);
              if (lastLocation.commonJsModuleIndicator && name === "exports" && meaning & lastLocation.symbol.flags) {
                return lastLocation.symbol;
              }
            }
            if (!excludeGlobals) {
              result2 = lookup(globals, name, meaning);
            }
          }
          if (!result2) {
            if (originalLocation && ts3.isInJSFile(originalLocation) && originalLocation.parent) {
              if (ts3.isRequireCall(originalLocation.parent, false)) {
                return requireSymbol;
              }
            }
          }
          if (!result2) {
            if (nameNotFoundMessage) {
              addLazyDiagnostic(function() {
                if (!errorLocation || !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) && !checkAndReportErrorForExtendingInterface(errorLocation) && !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) && !checkAndReportErrorForExportingPrimitiveType(errorLocation, name) && !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingNamespaceModuleAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning)) {
                  var suggestion = void 0;
                  if (getSpellingSuggestions && suggestionCount < maximumSuggestionCount) {
                    suggestion = getSuggestedSymbolForNonexistentSymbol(originalLocation, name, meaning);
                    var isGlobalScopeAugmentationDeclaration = (suggestion === null || suggestion === void 0 ? void 0 : suggestion.valueDeclaration) && ts3.isAmbientModule(suggestion.valueDeclaration) && ts3.isGlobalScopeAugmentation(suggestion.valueDeclaration);
                    if (isGlobalScopeAugmentationDeclaration) {
                      suggestion = void 0;
                    }
                    if (suggestion) {
                      var suggestionName = symbolToString(suggestion);
                      var isUncheckedJS = isUncheckedJSSuggestion(originalLocation, suggestion, false);
                      var message = meaning === 1920 || nameArg && typeof nameArg !== "string" && ts3.nodeIsSynthesized(nameArg) ? ts3.Diagnostics.Cannot_find_namespace_0_Did_you_mean_1 : isUncheckedJS ? ts3.Diagnostics.Could_not_find_name_0_Did_you_mean_1 : ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_1;
                      var diagnostic = createError(errorLocation, message, diagnosticName(nameArg), suggestionName);
                      addErrorOrSuggestion(!isUncheckedJS, diagnostic);
                      if (suggestion.valueDeclaration) {
                        ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(suggestion.valueDeclaration, ts3.Diagnostics._0_is_declared_here, suggestionName));
                      }
                    }
                  }
                  if (!suggestion) {
                    if (nameArg) {
                      var lib = getSuggestedLibForNonExistentName(nameArg);
                      if (lib) {
                        error(errorLocation, nameNotFoundMessage, diagnosticName(nameArg), lib);
                      } else {
                        error(errorLocation, nameNotFoundMessage, diagnosticName(nameArg));
                      }
                    }
                  }
                  suggestionCount++;
                }
              });
            }
            return void 0;
          }
          if (propertyWithInvalidInitializer && !(ts3.getEmitScriptTarget(compilerOptions) === 99 && useDefineForClassFields)) {
            var propertyName = propertyWithInvalidInitializer.name;
            error(errorLocation, ts3.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts3.declarationNameToString(propertyName), diagnosticName(nameArg));
            return void 0;
          }
          if (nameNotFoundMessage) {
            addLazyDiagnostic(function() {
              if (errorLocation && (meaning & 2 || (meaning & 32 || meaning & 384) && (meaning & 111551) === 111551)) {
                var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result2);
                if (exportOrLocalSymbol.flags & 2 || exportOrLocalSymbol.flags & 32 || exportOrLocalSymbol.flags & 384) {
                  checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                }
              }
              if (result2 && isInExternalModule && (meaning & 111551) === 111551 && !(originalLocation.flags & 8388608)) {
                var merged = getMergedSymbol(result2);
                if (ts3.length(merged.declarations) && ts3.every(merged.declarations, function(d) {
                  return ts3.isNamespaceExportDeclaration(d) || ts3.isSourceFile(d) && !!d.symbol.globalExports;
                })) {
                  errorOrSuggestion(!compilerOptions.allowUmdGlobalAccess, errorLocation, ts3.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, ts3.unescapeLeadingUnderscores(name));
                }
              }
              if (result2 && associatedDeclarationForContainingInitializerOrBindingName && !withinDeferredContext && (meaning & 111551) === 111551) {
                var candidate = getMergedSymbol(getLateBoundSymbol(result2));
                var root2 = ts3.getRootDeclaration(associatedDeclarationForContainingInitializerOrBindingName);
                if (candidate === getSymbolOfNode(associatedDeclarationForContainingInitializerOrBindingName)) {
                  error(errorLocation, ts3.Diagnostics.Parameter_0_cannot_reference_itself, ts3.declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name));
                } else if (candidate.valueDeclaration && candidate.valueDeclaration.pos > associatedDeclarationForContainingInitializerOrBindingName.pos && root2.parent.locals && lookup(root2.parent.locals, candidate.escapedName, meaning) === candidate) {
                  error(errorLocation, ts3.Diagnostics.Parameter_0_cannot_reference_identifier_1_declared_after_it, ts3.declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name), ts3.declarationNameToString(errorLocation));
                }
              }
              if (result2 && errorLocation && meaning & 111551 && result2.flags & 2097152 && !(result2.flags & 111551) && !ts3.isValidTypeOnlyAliasUseSite(errorLocation)) {
                var typeOnlyDeclaration = getTypeOnlyAliasDeclaration(result2);
                if (typeOnlyDeclaration) {
                  var message = typeOnlyDeclaration.kind === 275 ? ts3.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type : ts3.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type;
                  var unescapedName = ts3.unescapeLeadingUnderscores(name);
                  addTypeOnlyDeclarationRelatedInfo(error(errorLocation, message, unescapedName), typeOnlyDeclaration, unescapedName);
                }
              }
            });
          }
          return result2;
        }
        function addTypeOnlyDeclarationRelatedInfo(diagnostic, typeOnlyDeclaration, unescapedName) {
          if (!typeOnlyDeclaration)
            return diagnostic;
          return ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(typeOnlyDeclaration, typeOnlyDeclaration.kind === 275 ? ts3.Diagnostics._0_was_exported_here : ts3.Diagnostics._0_was_imported_here, unescapedName));
        }
        function getIsDeferredContext(location, lastLocation) {
          if (location.kind !== 214 && location.kind !== 213) {
            return ts3.isTypeQueryNode(location) || (ts3.isFunctionLikeDeclaration(location) || location.kind === 167 && !ts3.isStatic(location)) && (!lastLocation || lastLocation !== location.name);
          }
          if (lastLocation && lastLocation === location.name) {
            return false;
          }
          if (location.asteriskToken || ts3.hasSyntacticModifier(location, 256)) {
            return true;
          }
          return !ts3.getImmediatelyInvokedFunctionExpression(location);
        }
        function isSelfReferenceLocation(node) {
          switch (node.kind) {
            case 256:
            case 257:
            case 258:
            case 260:
            case 259:
            case 261:
              return true;
            default:
              return false;
          }
        }
        function diagnosticName(nameArg) {
          return ts3.isString(nameArg) ? ts3.unescapeLeadingUnderscores(nameArg) : ts3.declarationNameToString(nameArg);
        }
        function isTypeParameterSymbolDeclaredInContainer(symbol, container) {
          if (symbol.declarations) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              if (decl.kind === 163) {
                var parent = ts3.isJSDocTemplateTag(decl.parent) ? ts3.getJSDocHost(decl.parent) : decl.parent;
                if (parent === container) {
                  return !(ts3.isJSDocTemplateTag(decl.parent) && ts3.find(decl.parent.parent.tags, ts3.isJSDocTypeAlias));
                }
              }
            }
          }
          return false;
        }
        function checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) {
          if (!ts3.isIdentifier(errorLocation) || errorLocation.escapedText !== name || isTypeReferenceIdentifier(errorLocation) || isInTypeQuery(errorLocation)) {
            return false;
          }
          var container = ts3.getThisContainer(errorLocation, false);
          var location = container;
          while (location) {
            if (ts3.isClassLike(location.parent)) {
              var classSymbol = getSymbolOfNode(location.parent);
              if (!classSymbol) {
                break;
              }
              var constructorType = getTypeOfSymbol(classSymbol);
              if (getPropertyOfType(constructorType, name)) {
                error(errorLocation, ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0, diagnosticName(nameArg), symbolToString(classSymbol));
                return true;
              }
              if (location === container && !ts3.isStatic(location)) {
                var instanceType = getDeclaredTypeOfSymbol(classSymbol).thisType;
                if (getPropertyOfType(instanceType, name)) {
                  error(errorLocation, ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0, diagnosticName(nameArg));
                  return true;
                }
              }
            }
            location = location.parent;
          }
          return false;
        }
        function checkAndReportErrorForExtendingInterface(errorLocation) {
          var expression = getEntityNameForExtendingInterface(errorLocation);
          if (expression && resolveEntityName(expression, 64, true)) {
            error(errorLocation, ts3.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements, ts3.getTextOfNode(expression));
            return true;
          }
          return false;
        }
        function getEntityNameForExtendingInterface(node) {
          switch (node.kind) {
            case 79:
            case 206:
              return node.parent ? getEntityNameForExtendingInterface(node.parent) : void 0;
            case 228:
              if (ts3.isEntityNameExpression(node.expression)) {
                return node.expression;
              }
            default:
              return void 0;
          }
        }
        function checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) {
          var namespaceMeaning = 1920 | (ts3.isInJSFile(errorLocation) ? 111551 : 0);
          if (meaning === namespaceMeaning) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, 788968 & ~namespaceMeaning, void 0, void 0, false));
            var parent = errorLocation.parent;
            if (symbol) {
              if (ts3.isQualifiedName(parent)) {
                ts3.Debug.assert(parent.left === errorLocation, "Should only be resolving left side of qualified name as a namespace");
                var propName = parent.right.escapedText;
                var propType = getPropertyOfType(getDeclaredTypeOfSymbol(symbol), propName);
                if (propType) {
                  error(parent, ts3.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, ts3.unescapeLeadingUnderscores(name), ts3.unescapeLeadingUnderscores(propName));
                  return true;
                }
              }
              error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning) {
          if (meaning & (788968 & ~1920)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, ~788968 & 111551, void 0, void 0, false));
            if (symbol && !(symbol.flags & 1920)) {
              error(errorLocation, ts3.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function isPrimitiveTypeName(name) {
          return name === "any" || name === "string" || name === "number" || name === "boolean" || name === "never" || name === "unknown";
        }
        function checkAndReportErrorForExportingPrimitiveType(errorLocation, name) {
          if (isPrimitiveTypeName(name) && errorLocation.parent.kind === 275) {
            error(errorLocation, ts3.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, name);
            return true;
          }
          return false;
        }
        function checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) {
          if (meaning & (111551 & ~1024)) {
            if (isPrimitiveTypeName(name)) {
              error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
            var symbol = resolveSymbol(resolveName(errorLocation, name, 788968 & ~111551, void 0, void 0, false));
            if (symbol && !(symbol.flags & 1024)) {
              var rawName = ts3.unescapeLeadingUnderscores(name);
              if (isES2015OrLaterConstructorName(name)) {
                error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later, rawName);
              } else if (maybeMappedType(errorLocation, symbol)) {
                error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0, rawName, rawName === "K" ? "P" : "K");
              } else {
                error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, rawName);
              }
              return true;
            }
          }
          return false;
        }
        function maybeMappedType(node, symbol) {
          var container = ts3.findAncestor(node.parent, function(n) {
            return ts3.isComputedPropertyName(n) || ts3.isPropertySignature(n) ? false : ts3.isTypeLiteralNode(n) || "quit";
          });
          if (container && container.members.length === 1) {
            var type2 = getDeclaredTypeOfSymbol(symbol);
            return !!(type2.flags & 1048576) && allTypesAssignableToKind(type2, 384, true);
          }
          return false;
        }
        function isES2015OrLaterConstructorName(n) {
          switch (n) {
            case "Promise":
            case "Symbol":
            case "Map":
            case "WeakMap":
            case "Set":
            case "WeakSet":
              return true;
          }
          return false;
        }
        function checkAndReportErrorForUsingNamespaceModuleAsValue(errorLocation, name, meaning) {
          if (meaning & (111551 & ~1024 & ~788968)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, 1024 & ~111551, void 0, void 0, false));
            if (symbol) {
              error(errorLocation, ts3.Diagnostics.Cannot_use_namespace_0_as_a_value, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          } else if (meaning & (788968 & ~1024 & ~111551)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, (512 | 1024) & ~788968, void 0, void 0, false));
            if (symbol) {
              error(errorLocation, ts3.Diagnostics.Cannot_use_namespace_0_as_a_type, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function checkResolvedBlockScopedVariable(result2, errorLocation) {
          var _a;
          ts3.Debug.assert(!!(result2.flags & 2 || result2.flags & 32 || result2.flags & 384));
          if (result2.flags & (16 | 1 | 67108864) && result2.flags & 32) {
            return;
          }
          var declaration = (_a = result2.declarations) === null || _a === void 0 ? void 0 : _a.find(function(d) {
            return ts3.isBlockOrCatchScoped(d) || ts3.isClassLike(d) || d.kind === 260;
          });
          if (declaration === void 0)
            return ts3.Debug.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");
          if (!(declaration.flags & 16777216) && !isBlockScopedNameDeclaredBeforeUse(declaration, errorLocation)) {
            var diagnosticMessage = void 0;
            var declarationName = ts3.declarationNameToString(ts3.getNameOfDeclaration(declaration));
            if (result2.flags & 2) {
              diagnosticMessage = error(errorLocation, ts3.Diagnostics.Block_scoped_variable_0_used_before_its_declaration, declarationName);
            } else if (result2.flags & 32) {
              diagnosticMessage = error(errorLocation, ts3.Diagnostics.Class_0_used_before_its_declaration, declarationName);
            } else if (result2.flags & 256) {
              diagnosticMessage = error(errorLocation, ts3.Diagnostics.Enum_0_used_before_its_declaration, declarationName);
            } else {
              ts3.Debug.assert(!!(result2.flags & 128));
              if (ts3.shouldPreserveConstEnums(compilerOptions)) {
                diagnosticMessage = error(errorLocation, ts3.Diagnostics.Enum_0_used_before_its_declaration, declarationName);
              }
            }
            if (diagnosticMessage) {
              ts3.addRelatedInfo(diagnosticMessage, ts3.createDiagnosticForNode(declaration, ts3.Diagnostics._0_is_declared_here, declarationName));
            }
          }
        }
        function isSameScopeDescendentOf(initial, parent, stopAt) {
          return !!parent && !!ts3.findAncestor(initial, function(n) {
            return n === parent || (n === stopAt || ts3.isFunctionLike(n) && !ts3.getImmediatelyInvokedFunctionExpression(n) ? "quit" : false);
          });
        }
        function getAnyImportSyntax(node) {
          switch (node.kind) {
            case 265:
              return node;
            case 267:
              return node.parent;
            case 268:
              return node.parent.parent;
            case 270:
              return node.parent.parent.parent;
            default:
              return void 0;
          }
        }
        function getDeclarationOfAliasSymbol(symbol) {
          return symbol.declarations && ts3.findLast(symbol.declarations, isAliasSymbolDeclaration);
        }
        function isAliasSymbolDeclaration(node) {
          return node.kind === 265 || node.kind === 264 || node.kind === 267 && !!node.name || node.kind === 268 || node.kind === 274 || node.kind === 270 || node.kind === 275 || node.kind === 271 && ts3.exportAssignmentIsAlias(node) || ts3.isBinaryExpression(node) && ts3.getAssignmentDeclarationKind(node) === 2 && ts3.exportAssignmentIsAlias(node) || ts3.isAccessExpression(node) && ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 63 && isAliasableOrJsExpression(node.parent.right) || node.kind === 297 || node.kind === 296 && isAliasableOrJsExpression(node.initializer) || node.kind === 254 && ts3.isVariableDeclarationInitializedToBareOrAccessedRequire(node) || node.kind === 203 && ts3.isVariableDeclarationInitializedToBareOrAccessedRequire(node.parent.parent);
        }
        function isAliasableOrJsExpression(e) {
          return ts3.isAliasableExpression(e) || ts3.isFunctionExpression(e) && isJSConstructor(e);
        }
        function getTargetOfImportEqualsDeclaration(node, dontResolveAlias) {
          var commonJSPropertyAccess = getCommonJSPropertyAccess(node);
          if (commonJSPropertyAccess) {
            var name = ts3.getLeftmostAccessExpression(commonJSPropertyAccess.expression).arguments[0];
            return ts3.isIdentifier(commonJSPropertyAccess.name) ? resolveSymbol(getPropertyOfType(resolveExternalModuleTypeByLiteral(name), commonJSPropertyAccess.name.escapedText)) : void 0;
          }
          if (ts3.isVariableDeclaration(node) || node.moduleReference.kind === 277) {
            var immediate = resolveExternalModuleName(node, ts3.getExternalModuleRequireArgument(node) || ts3.getExternalModuleImportEqualsDeclarationExpression(node));
            var resolved_4 = resolveExternalModuleSymbol(immediate);
            markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved_4, false);
            return resolved_4;
          }
          var resolved = getSymbolOfPartOfRightHandSideOfImportEquals(node.moduleReference, dontResolveAlias);
          checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved);
          return resolved;
        }
        function checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved) {
          if (markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false) && !node.isTypeOnly) {
            var typeOnlyDeclaration = getTypeOnlyAliasDeclaration(getSymbolOfNode(node));
            var isExport = typeOnlyDeclaration.kind === 275;
            var message = isExport ? ts3.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type : ts3.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type;
            var relatedMessage = isExport ? ts3.Diagnostics._0_was_exported_here : ts3.Diagnostics._0_was_imported_here;
            var name = ts3.unescapeLeadingUnderscores(typeOnlyDeclaration.name.escapedText);
            ts3.addRelatedInfo(error(node.moduleReference, message), ts3.createDiagnosticForNode(typeOnlyDeclaration, relatedMessage, name));
          }
        }
        function resolveExportByName(moduleSymbol, name, sourceNode, dontResolveAlias) {
          var exportValue = moduleSymbol.exports.get("export=");
          var exportSymbol = exportValue ? getPropertyOfType(getTypeOfSymbol(exportValue), name) : moduleSymbol.exports.get(name);
          var resolved = resolveSymbol(exportSymbol, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(sourceNode, exportSymbol, resolved, false);
          return resolved;
        }
        function isSyntacticDefault(node) {
          return ts3.isExportAssignment(node) && !node.isExportEquals || ts3.hasSyntacticModifier(node, 512) || ts3.isExportSpecifier(node);
        }
        function getUsageModeForExpression(usage) {
          return ts3.isStringLiteralLike(usage) ? ts3.getModeForUsageLocation(ts3.getSourceFileOfNode(usage), usage) : void 0;
        }
        function isESMFormatImportImportingCommonjsFormatFile(usageMode, targetMode) {
          return usageMode === ts3.ModuleKind.ESNext && targetMode === ts3.ModuleKind.CommonJS;
        }
        function isOnlyImportedAsDefault(usage) {
          var usageMode = getUsageModeForExpression(usage);
          return usageMode === ts3.ModuleKind.ESNext && ts3.endsWith(usage.text, ".json");
        }
        function canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias, usage) {
          var usageMode = file && getUsageModeForExpression(usage);
          if (file && usageMode !== void 0) {
            var result2 = isESMFormatImportImportingCommonjsFormatFile(usageMode, file.impliedNodeFormat);
            if (usageMode === ts3.ModuleKind.ESNext || result2) {
              return result2;
            }
          }
          if (!allowSyntheticDefaultImports) {
            return false;
          }
          if (!file || file.isDeclarationFile) {
            var defaultExportSymbol = resolveExportByName(moduleSymbol, "default", void 0, true);
            if (defaultExportSymbol && ts3.some(defaultExportSymbol.declarations, isSyntacticDefault)) {
              return false;
            }
            if (resolveExportByName(moduleSymbol, ts3.escapeLeadingUnderscores("__esModule"), void 0, dontResolveAlias)) {
              return false;
            }
            return true;
          }
          if (!ts3.isSourceFileJS(file)) {
            return hasExportAssignmentSymbol(moduleSymbol);
          }
          return typeof file.externalModuleIndicator !== "object" && !resolveExportByName(moduleSymbol, ts3.escapeLeadingUnderscores("__esModule"), void 0, dontResolveAlias);
        }
        function getTargetOfImportClause(node, dontResolveAlias) {
          var _a;
          var moduleSymbol = resolveExternalModuleName(node, node.parent.moduleSpecifier);
          if (moduleSymbol) {
            var exportDefaultSymbol = void 0;
            if (ts3.isShorthandAmbientModuleSymbol(moduleSymbol)) {
              exportDefaultSymbol = moduleSymbol;
            } else {
              exportDefaultSymbol = resolveExportByName(moduleSymbol, "default", node, dontResolveAlias);
            }
            var file = (_a = moduleSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isSourceFile);
            var hasDefaultOnly = isOnlyImportedAsDefault(node.parent.moduleSpecifier);
            var hasSyntheticDefault = canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias, node.parent.moduleSpecifier);
            if (!exportDefaultSymbol && !hasSyntheticDefault && !hasDefaultOnly) {
              if (hasExportAssignmentSymbol(moduleSymbol)) {
                var compilerOptionName = moduleKind >= ts3.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
                var exportEqualsSymbol = moduleSymbol.exports.get("export=");
                var exportAssignment = exportEqualsSymbol.valueDeclaration;
                var err = error(node.name, ts3.Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag, symbolToString(moduleSymbol), compilerOptionName);
                if (exportAssignment) {
                  ts3.addRelatedInfo(err, ts3.createDiagnosticForNode(exportAssignment, ts3.Diagnostics.This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag, compilerOptionName));
                }
              } else {
                reportNonDefaultExport(moduleSymbol, node);
              }
            } else if (hasSyntheticDefault || hasDefaultOnly) {
              var resolved = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
              markSymbolOfAliasDeclarationIfTypeOnly(node, moduleSymbol, resolved, false);
              return resolved;
            }
            markSymbolOfAliasDeclarationIfTypeOnly(node, exportDefaultSymbol, void 0, false);
            return exportDefaultSymbol;
          }
        }
        function reportNonDefaultExport(moduleSymbol, node) {
          var _a, _b, _c;
          if ((_a = moduleSymbol.exports) === null || _a === void 0 ? void 0 : _a.has(node.symbol.escapedName)) {
            error(node.name, ts3.Diagnostics.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead, symbolToString(moduleSymbol), symbolToString(node.symbol));
          } else {
            var diagnostic = error(node.name, ts3.Diagnostics.Module_0_has_no_default_export, symbolToString(moduleSymbol));
            var exportStar = (_b = moduleSymbol.exports) === null || _b === void 0 ? void 0 : _b.get("__export");
            if (exportStar) {
              var defaultExport = (_c = exportStar.declarations) === null || _c === void 0 ? void 0 : _c.find(function(decl) {
                var _a2, _b2;
                return !!(ts3.isExportDeclaration(decl) && decl.moduleSpecifier && ((_b2 = (_a2 = resolveExternalModuleName(decl, decl.moduleSpecifier)) === null || _a2 === void 0 ? void 0 : _a2.exports) === null || _b2 === void 0 ? void 0 : _b2.has("default")));
              });
              if (defaultExport) {
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(defaultExport, ts3.Diagnostics.export_Asterisk_does_not_re_export_a_default));
              }
            }
          }
        }
        function getTargetOfNamespaceImport(node, dontResolveAlias) {
          var moduleSpecifier = node.parent.parent.moduleSpecifier;
          var immediate = resolveExternalModuleName(node, moduleSpecifier);
          var resolved = resolveESModuleSymbol(immediate, moduleSpecifier, dontResolveAlias, false);
          markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved, false);
          return resolved;
        }
        function getTargetOfNamespaceExport(node, dontResolveAlias) {
          var moduleSpecifier = node.parent.moduleSpecifier;
          var immediate = moduleSpecifier && resolveExternalModuleName(node, moduleSpecifier);
          var resolved = moduleSpecifier && resolveESModuleSymbol(immediate, moduleSpecifier, dontResolveAlias, false);
          markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved, false);
          return resolved;
        }
        function combineValueAndTypeSymbols(valueSymbol, typeSymbol) {
          if (valueSymbol === unknownSymbol && typeSymbol === unknownSymbol) {
            return unknownSymbol;
          }
          if (valueSymbol.flags & (788968 | 1920)) {
            return valueSymbol;
          }
          var result2 = createSymbol(valueSymbol.flags | typeSymbol.flags, valueSymbol.escapedName);
          result2.declarations = ts3.deduplicate(ts3.concatenate(valueSymbol.declarations, typeSymbol.declarations), ts3.equateValues);
          result2.parent = valueSymbol.parent || typeSymbol.parent;
          if (valueSymbol.valueDeclaration)
            result2.valueDeclaration = valueSymbol.valueDeclaration;
          if (typeSymbol.members)
            result2.members = new ts3.Map(typeSymbol.members);
          if (valueSymbol.exports)
            result2.exports = new ts3.Map(valueSymbol.exports);
          return result2;
        }
        function getExportOfModule(symbol, name, specifier, dontResolveAlias) {
          if (symbol.flags & 1536) {
            var exportSymbol = getExportsOfSymbol(symbol).get(name.escapedText);
            var resolved = resolveSymbol(exportSymbol, dontResolveAlias);
            markSymbolOfAliasDeclarationIfTypeOnly(specifier, exportSymbol, resolved, false);
            return resolved;
          }
        }
        function getPropertyOfVariable(symbol, name) {
          if (symbol.flags & 3) {
            var typeAnnotation = symbol.valueDeclaration.type;
            if (typeAnnotation) {
              return resolveSymbol(getPropertyOfType(getTypeFromTypeNode(typeAnnotation), name));
            }
          }
        }
        function getExternalModuleMember(node, specifier, dontResolveAlias) {
          var _a, _b;
          if (dontResolveAlias === void 0) {
            dontResolveAlias = false;
          }
          var moduleSpecifier = ts3.getExternalModuleRequireArgument(node) || node.moduleSpecifier;
          var moduleSymbol = resolveExternalModuleName(node, moduleSpecifier);
          var name = !ts3.isPropertyAccessExpression(specifier) && specifier.propertyName || specifier.name;
          if (!ts3.isIdentifier(name)) {
            return void 0;
          }
          var suppressInteropError = name.escapedText === "default" && !!(compilerOptions.allowSyntheticDefaultImports || ts3.getESModuleInterop(compilerOptions));
          var targetSymbol = resolveESModuleSymbol(moduleSymbol, moduleSpecifier, false, suppressInteropError);
          if (targetSymbol) {
            if (name.escapedText) {
              if (ts3.isShorthandAmbientModuleSymbol(moduleSymbol)) {
                return moduleSymbol;
              }
              var symbolFromVariable = void 0;
              if (moduleSymbol && moduleSymbol.exports && moduleSymbol.exports.get("export=")) {
                symbolFromVariable = getPropertyOfType(getTypeOfSymbol(targetSymbol), name.escapedText, true);
              } else {
                symbolFromVariable = getPropertyOfVariable(targetSymbol, name.escapedText);
              }
              symbolFromVariable = resolveSymbol(symbolFromVariable, dontResolveAlias);
              var symbolFromModule = getExportOfModule(targetSymbol, name, specifier, dontResolveAlias);
              if (symbolFromModule === void 0 && name.escapedText === "default") {
                var file = (_a = moduleSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isSourceFile);
                if (isOnlyImportedAsDefault(moduleSpecifier) || canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias, moduleSpecifier)) {
                  symbolFromModule = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
                }
              }
              var symbol = symbolFromModule && symbolFromVariable && symbolFromModule !== symbolFromVariable ? combineValueAndTypeSymbols(symbolFromVariable, symbolFromModule) : symbolFromModule || symbolFromVariable;
              if (!symbol) {
                var moduleName = getFullyQualifiedName(moduleSymbol, node);
                var declarationName = ts3.declarationNameToString(name);
                var suggestion = getSuggestedSymbolForNonexistentModule(name, targetSymbol);
                if (suggestion !== void 0) {
                  var suggestionName = symbolToString(suggestion);
                  var diagnostic = error(name, ts3.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, moduleName, declarationName, suggestionName);
                  if (suggestion.valueDeclaration) {
                    ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(suggestion.valueDeclaration, ts3.Diagnostics._0_is_declared_here, suggestionName));
                  }
                } else {
                  if ((_b = moduleSymbol.exports) === null || _b === void 0 ? void 0 : _b.has("default")) {
                    error(name, ts3.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead, moduleName, declarationName);
                  } else {
                    reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName);
                  }
                }
              }
              return symbol;
            }
          }
        }
        function reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName) {
          var _a, _b;
          var localSymbol = (_b = (_a = moduleSymbol.valueDeclaration) === null || _a === void 0 ? void 0 : _a.locals) === null || _b === void 0 ? void 0 : _b.get(name.escapedText);
          var exports2 = moduleSymbol.exports;
          if (localSymbol) {
            var exportedEqualsSymbol = exports2 === null || exports2 === void 0 ? void 0 : exports2.get("export=");
            if (exportedEqualsSymbol) {
              getSymbolIfSameReference(exportedEqualsSymbol, localSymbol) ? reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) : error(name, ts3.Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
            } else {
              var exportedSymbol = exports2 ? ts3.find(symbolsToArray(exports2), function(symbol) {
                return !!getSymbolIfSameReference(symbol, localSymbol);
              }) : void 0;
              var diagnostic = exportedSymbol ? error(name, ts3.Diagnostics.Module_0_declares_1_locally_but_it_is_exported_as_2, moduleName, declarationName, symbolToString(exportedSymbol)) : error(name, ts3.Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported, moduleName, declarationName);
              if (localSymbol.declarations) {
                ts3.addRelatedInfo.apply(void 0, __spreadArray([diagnostic], ts3.map(localSymbol.declarations, function(decl, index) {
                  return ts3.createDiagnosticForNode(decl, index === 0 ? ts3.Diagnostics._0_is_declared_here : ts3.Diagnostics.and_here, declarationName);
                }), false));
              }
            }
          } else {
            error(name, ts3.Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
          }
        }
        function reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) {
          if (moduleKind >= ts3.ModuleKind.ES2015) {
            var message = ts3.getESModuleInterop(compilerOptions) ? ts3.Diagnostics._0_can_only_be_imported_by_using_a_default_import : ts3.Diagnostics._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
            error(name, message, declarationName);
          } else {
            if (ts3.isInJSFile(node)) {
              var message = ts3.getESModuleInterop(compilerOptions) ? ts3.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import : ts3.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
              error(name, message, declarationName);
            } else {
              var message = ts3.getESModuleInterop(compilerOptions) ? ts3.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import : ts3.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
              error(name, message, declarationName, declarationName, moduleName);
            }
          }
        }
        function getTargetOfImportSpecifier(node, dontResolveAlias) {
          var root = ts3.isBindingElement(node) ? ts3.getRootDeclaration(node) : node.parent.parent.parent;
          var commonJSPropertyAccess = getCommonJSPropertyAccess(root);
          var resolved = getExternalModuleMember(root, commonJSPropertyAccess || node, dontResolveAlias);
          var name = node.propertyName || node.name;
          if (commonJSPropertyAccess && resolved && ts3.isIdentifier(name)) {
            return resolveSymbol(getPropertyOfType(getTypeOfSymbol(resolved), name.escapedText), dontResolveAlias);
          }
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getCommonJSPropertyAccess(node) {
          if (ts3.isVariableDeclaration(node) && node.initializer && ts3.isPropertyAccessExpression(node.initializer)) {
            return node.initializer;
          }
        }
        function getTargetOfNamespaceExportDeclaration(node, dontResolveAlias) {
          var resolved = resolveExternalModuleSymbol(node.parent.symbol, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfExportSpecifier(node, meaning, dontResolveAlias) {
          var resolved = node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node, dontResolveAlias) : resolveEntityName(node.propertyName || node.name, meaning, false, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfExportAssignment(node, dontResolveAlias) {
          var expression = ts3.isExportAssignment(node) ? node.expression : node.right;
          var resolved = getTargetOfAliasLikeExpression(expression, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfAliasLikeExpression(expression, dontResolveAlias) {
          if (ts3.isClassExpression(expression)) {
            return checkExpressionCached(expression).symbol;
          }
          if (!ts3.isEntityName(expression) && !ts3.isEntityNameExpression(expression)) {
            return void 0;
          }
          var aliasLike = resolveEntityName(expression, 111551 | 788968 | 1920, true, dontResolveAlias);
          if (aliasLike) {
            return aliasLike;
          }
          checkExpressionCached(expression);
          return getNodeLinks(expression).resolvedSymbol;
        }
        function getTargetOfPropertyAssignment(node, dontRecursivelyResolve) {
          var expression = node.initializer;
          return getTargetOfAliasLikeExpression(expression, dontRecursivelyResolve);
        }
        function getTargetOfAccessExpression(node, dontRecursivelyResolve) {
          if (!(ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 63)) {
            return void 0;
          }
          return getTargetOfAliasLikeExpression(node.parent.right, dontRecursivelyResolve);
        }
        function getTargetOfAliasDeclaration(node, dontRecursivelyResolve) {
          if (dontRecursivelyResolve === void 0) {
            dontRecursivelyResolve = false;
          }
          switch (node.kind) {
            case 265:
            case 254:
              return getTargetOfImportEqualsDeclaration(node, dontRecursivelyResolve);
            case 267:
              return getTargetOfImportClause(node, dontRecursivelyResolve);
            case 268:
              return getTargetOfNamespaceImport(node, dontRecursivelyResolve);
            case 274:
              return getTargetOfNamespaceExport(node, dontRecursivelyResolve);
            case 270:
            case 203:
              return getTargetOfImportSpecifier(node, dontRecursivelyResolve);
            case 275:
              return getTargetOfExportSpecifier(node, 111551 | 788968 | 1920, dontRecursivelyResolve);
            case 271:
            case 221:
              return getTargetOfExportAssignment(node, dontRecursivelyResolve);
            case 264:
              return getTargetOfNamespaceExportDeclaration(node, dontRecursivelyResolve);
            case 297:
              return resolveEntityName(node.name, 111551 | 788968 | 1920, true, dontRecursivelyResolve);
            case 296:
              return getTargetOfPropertyAssignment(node, dontRecursivelyResolve);
            case 207:
            case 206:
              return getTargetOfAccessExpression(node, dontRecursivelyResolve);
            default:
              return ts3.Debug.fail();
          }
        }
        function isNonLocalAlias(symbol, excludes) {
          if (excludes === void 0) {
            excludes = 111551 | 788968 | 1920;
          }
          if (!symbol)
            return false;
          return (symbol.flags & (2097152 | excludes)) === 2097152 || !!(symbol.flags & 2097152 && symbol.flags & 67108864);
        }
        function resolveSymbol(symbol, dontResolveAlias) {
          return !dontResolveAlias && isNonLocalAlias(symbol) ? resolveAlias(symbol) : symbol;
        }
        function resolveAlias(symbol) {
          ts3.Debug.assert((symbol.flags & 2097152) !== 0, "Should only get Alias here.");
          var links = getSymbolLinks(symbol);
          if (!links.aliasTarget) {
            links.aliasTarget = resolvingSymbol;
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts3.Debug.fail();
            var target = getTargetOfAliasDeclaration(node);
            if (links.aliasTarget === resolvingSymbol) {
              links.aliasTarget = target || unknownSymbol;
            } else {
              error(node, ts3.Diagnostics.Circular_definition_of_import_alias_0, symbolToString(symbol));
            }
          } else if (links.aliasTarget === resolvingSymbol) {
            links.aliasTarget = unknownSymbol;
          }
          return links.aliasTarget;
        }
        function tryResolveAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.aliasTarget !== resolvingSymbol) {
            return resolveAlias(symbol);
          }
          return void 0;
        }
        function markSymbolOfAliasDeclarationIfTypeOnly(aliasDeclaration, immediateTarget, finalTarget, overwriteEmpty) {
          if (!aliasDeclaration || ts3.isPropertyAccessExpression(aliasDeclaration))
            return false;
          var sourceSymbol = getSymbolOfNode(aliasDeclaration);
          if (ts3.isTypeOnlyImportOrExportDeclaration(aliasDeclaration)) {
            var links_1 = getSymbolLinks(sourceSymbol);
            links_1.typeOnlyDeclaration = aliasDeclaration;
            return true;
          }
          var links = getSymbolLinks(sourceSymbol);
          return markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, immediateTarget, overwriteEmpty) || markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, finalTarget, overwriteEmpty);
        }
        function markSymbolOfAliasDeclarationIfTypeOnlyWorker(aliasDeclarationLinks, target, overwriteEmpty) {
          var _a, _b, _c;
          if (target && (aliasDeclarationLinks.typeOnlyDeclaration === void 0 || overwriteEmpty && aliasDeclarationLinks.typeOnlyDeclaration === false)) {
            var exportSymbol = (_b = (_a = target.exports) === null || _a === void 0 ? void 0 : _a.get("export=")) !== null && _b !== void 0 ? _b : target;
            var typeOnly = exportSymbol.declarations && ts3.find(exportSymbol.declarations, ts3.isTypeOnlyImportOrExportDeclaration);
            aliasDeclarationLinks.typeOnlyDeclaration = (_c = typeOnly !== null && typeOnly !== void 0 ? typeOnly : getSymbolLinks(exportSymbol).typeOnlyDeclaration) !== null && _c !== void 0 ? _c : false;
          }
          return !!aliasDeclarationLinks.typeOnlyDeclaration;
        }
        function getTypeOnlyAliasDeclaration(symbol) {
          if (!(symbol.flags & 2097152)) {
            return void 0;
          }
          var links = getSymbolLinks(symbol);
          return links.typeOnlyDeclaration || void 0;
        }
        function markExportAsReferenced(node) {
          var symbol = getSymbolOfNode(node);
          var target = resolveAlias(symbol);
          if (target) {
            var markAlias = target === unknownSymbol || target.flags & 111551 && !isConstEnumOrConstEnumOnlyModule(target) && !getTypeOnlyAliasDeclaration(symbol);
            if (markAlias) {
              markAliasSymbolAsReferenced(symbol);
            }
          }
        }
        function markAliasSymbolAsReferenced(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.referenced) {
            links.referenced = true;
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts3.Debug.fail();
            if (ts3.isInternalModuleImportEqualsDeclaration(node)) {
              var target = resolveSymbol(symbol);
              if (target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.moduleReference);
              }
            }
          }
        }
        function markConstEnumAliasAsReferenced(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.constEnumReferenced) {
            links.constEnumReferenced = true;
          }
        }
        function getSymbolOfPartOfRightHandSideOfImportEquals(entityName, dontResolveAlias) {
          if (entityName.kind === 79 && ts3.isRightSideOfQualifiedNameOrPropertyAccess(entityName)) {
            entityName = entityName.parent;
          }
          if (entityName.kind === 79 || entityName.parent.kind === 161) {
            return resolveEntityName(entityName, 1920, false, dontResolveAlias);
          } else {
            ts3.Debug.assert(entityName.parent.kind === 265);
            return resolveEntityName(entityName, 111551 | 788968 | 1920, false, dontResolveAlias);
          }
        }
        function getFullyQualifiedName(symbol, containingLocation) {
          return symbol.parent ? getFullyQualifiedName(symbol.parent, containingLocation) + "." + symbolToString(symbol) : symbolToString(symbol, containingLocation, void 0, 16 | 4);
        }
        function getContainingQualifiedNameNode(node) {
          while (ts3.isQualifiedName(node.parent)) {
            node = node.parent;
          }
          return node;
        }
        function tryGetQualifiedNameAsValue(node) {
          var left = ts3.getFirstIdentifier(node);
          var symbol = resolveName(left, left.escapedText, 111551, void 0, left, true);
          if (!symbol) {
            return void 0;
          }
          while (ts3.isQualifiedName(left.parent)) {
            var type2 = getTypeOfSymbol(symbol);
            symbol = getPropertyOfType(type2, left.parent.right.escapedText);
            if (!symbol) {
              return void 0;
            }
            left = left.parent;
          }
          return symbol;
        }
        function resolveEntityName(name, meaning, ignoreErrors, dontResolveAlias, location) {
          if (ts3.nodeIsMissing(name)) {
            return void 0;
          }
          var namespaceMeaning = 1920 | (ts3.isInJSFile(name) ? meaning & 111551 : 0);
          var symbol;
          if (name.kind === 79) {
            var message = meaning === namespaceMeaning || ts3.nodeIsSynthesized(name) ? ts3.Diagnostics.Cannot_find_namespace_0 : getCannotFindNameDiagnosticForName(ts3.getFirstIdentifier(name));
            var symbolFromJSPrototype = ts3.isInJSFile(name) && !ts3.nodeIsSynthesized(name) ? resolveEntityNameFromAssignmentDeclaration(name, meaning) : void 0;
            symbol = getMergedSymbol(resolveName(location || name, name.escapedText, meaning, ignoreErrors || symbolFromJSPrototype ? void 0 : message, name, true, false));
            if (!symbol) {
              return getMergedSymbol(symbolFromJSPrototype);
            }
          } else if (name.kind === 161 || name.kind === 206) {
            var left = name.kind === 161 ? name.left : name.expression;
            var right = name.kind === 161 ? name.right : name.name;
            var namespace = resolveEntityName(left, namespaceMeaning, ignoreErrors, false, location);
            if (!namespace || ts3.nodeIsMissing(right)) {
              return void 0;
            } else if (namespace === unknownSymbol) {
              return namespace;
            }
            if (namespace.valueDeclaration && ts3.isInJSFile(namespace.valueDeclaration) && ts3.isVariableDeclaration(namespace.valueDeclaration) && namespace.valueDeclaration.initializer && isCommonJsRequire(namespace.valueDeclaration.initializer)) {
              var moduleName = namespace.valueDeclaration.initializer.arguments[0];
              var moduleSym = resolveExternalModuleName(moduleName, moduleName);
              if (moduleSym) {
                var resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
                if (resolvedModuleSymbol) {
                  namespace = resolvedModuleSymbol;
                }
              }
            }
            symbol = getMergedSymbol(getSymbol(getExportsOfSymbol(namespace), right.escapedText, meaning));
            if (!symbol) {
              if (!ignoreErrors) {
                var namespaceName = getFullyQualifiedName(namespace);
                var declarationName = ts3.declarationNameToString(right);
                var suggestionForNonexistentModule = getSuggestedSymbolForNonexistentModule(right, namespace);
                if (suggestionForNonexistentModule) {
                  error(right, ts3.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, namespaceName, declarationName, symbolToString(suggestionForNonexistentModule));
                  return void 0;
                }
                var containingQualifiedName = ts3.isQualifiedName(name) && getContainingQualifiedNameNode(name);
                var canSuggestTypeof = globalObjectType && meaning & 788968 && containingQualifiedName && !ts3.isTypeOfExpression(containingQualifiedName.parent) && tryGetQualifiedNameAsValue(containingQualifiedName);
                if (canSuggestTypeof) {
                  error(containingQualifiedName, ts3.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, ts3.entityNameToString(containingQualifiedName));
                  return void 0;
                }
                if (meaning & 1920 && ts3.isQualifiedName(name.parent)) {
                  var exportedTypeSymbol = getMergedSymbol(getSymbol(getExportsOfSymbol(namespace), right.escapedText, 788968));
                  if (exportedTypeSymbol) {
                    error(name.parent.right, ts3.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, symbolToString(exportedTypeSymbol), ts3.unescapeLeadingUnderscores(name.parent.right.escapedText));
                    return void 0;
                  }
                }
                error(right, ts3.Diagnostics.Namespace_0_has_no_exported_member_1, namespaceName, declarationName);
              }
              return void 0;
            }
          } else {
            throw ts3.Debug.assertNever(name, "Unknown entity name kind.");
          }
          ts3.Debug.assert((ts3.getCheckFlags(symbol) & 1) === 0, "Should never get an instantiated symbol here.");
          if (!ts3.nodeIsSynthesized(name) && ts3.isEntityName(name) && (symbol.flags & 2097152 || name.parent.kind === 271)) {
            markSymbolOfAliasDeclarationIfTypeOnly(ts3.getAliasDeclarationFromName(name), symbol, void 0, true);
          }
          return symbol.flags & meaning || dontResolveAlias ? symbol : resolveAlias(symbol);
        }
        function resolveEntityNameFromAssignmentDeclaration(name, meaning) {
          if (isJSDocTypeReference(name.parent)) {
            var secondaryLocation = getAssignmentDeclarationLocation(name.parent);
            if (secondaryLocation) {
              return resolveName(secondaryLocation, name.escapedText, meaning, void 0, name, true);
            }
          }
        }
        function getAssignmentDeclarationLocation(node) {
          var typeAlias = ts3.findAncestor(node, function(node2) {
            return !(ts3.isJSDocNode(node2) || node2.flags & 8388608) ? "quit" : ts3.isJSDocTypeAlias(node2);
          });
          if (typeAlias) {
            return;
          }
          var host2 = ts3.getJSDocHost(node);
          if (host2 && ts3.isExpressionStatement(host2) && ts3.isPrototypePropertyAssignment(host2.expression)) {
            var symbol = getSymbolOfNode(host2.expression.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          if (host2 && ts3.isFunctionExpression(host2) && ts3.isPrototypePropertyAssignment(host2.parent) && ts3.isExpressionStatement(host2.parent.parent)) {
            var symbol = getSymbolOfNode(host2.parent.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          if (host2 && (ts3.isObjectLiteralMethod(host2) || ts3.isPropertyAssignment(host2)) && ts3.isBinaryExpression(host2.parent.parent) && ts3.getAssignmentDeclarationKind(host2.parent.parent) === 6) {
            var symbol = getSymbolOfNode(host2.parent.parent.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          var sig = ts3.getEffectiveJSDocHost(node);
          if (sig && ts3.isFunctionLike(sig)) {
            var symbol = getSymbolOfNode(sig);
            return symbol && symbol.valueDeclaration;
          }
        }
        function getDeclarationOfJSPrototypeContainer(symbol) {
          var decl = symbol.parent.valueDeclaration;
          if (!decl) {
            return void 0;
          }
          var initializer = ts3.isAssignmentDeclaration(decl) ? ts3.getAssignedExpandoInitializer(decl) : ts3.hasOnlyExpressionInitializer(decl) ? ts3.getDeclaredExpandoInitializer(decl) : void 0;
          return initializer || decl;
        }
        function getExpandoSymbol(symbol) {
          var decl = symbol.valueDeclaration;
          if (!decl || !ts3.isInJSFile(decl) || symbol.flags & 524288 || ts3.getExpandoInitializer(decl, false)) {
            return void 0;
          }
          var init = ts3.isVariableDeclaration(decl) ? ts3.getDeclaredExpandoInitializer(decl) : ts3.getAssignedExpandoInitializer(decl);
          if (init) {
            var initSymbol = getSymbolOfNode(init);
            if (initSymbol) {
              return mergeJSSymbols(initSymbol, symbol);
            }
          }
        }
        function resolveExternalModuleName(location, moduleReferenceExpression, ignoreErrors) {
          var isClassic = ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Classic;
          var errorMessage = isClassic ? ts3.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : ts3.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
          return resolveExternalModuleNameWorker(location, moduleReferenceExpression, ignoreErrors ? void 0 : errorMessage);
        }
        function resolveExternalModuleNameWorker(location, moduleReferenceExpression, moduleNotFoundError, isForAugmentation) {
          if (isForAugmentation === void 0) {
            isForAugmentation = false;
          }
          return ts3.isStringLiteralLike(moduleReferenceExpression) ? resolveExternalModule(location, moduleReferenceExpression.text, moduleNotFoundError, moduleReferenceExpression, isForAugmentation) : void 0;
        }
        function resolveExternalModule(location, moduleReference, moduleNotFoundError, errorNode, isForAugmentation) {
          var _a, _b, _c, _d, _e, _f, _g, _h;
          if (isForAugmentation === void 0) {
            isForAugmentation = false;
          }
          if (ts3.startsWith(moduleReference, "@types/")) {
            var diag = ts3.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1;
            var withoutAtTypePrefix = ts3.removePrefix(moduleReference, "@types/");
            error(errorNode, diag, withoutAtTypePrefix, moduleReference);
          }
          var ambientModule = tryFindAmbientModule(moduleReference, true);
          if (ambientModule) {
            return ambientModule;
          }
          var currentSourceFile = ts3.getSourceFileOfNode(location);
          var contextSpecifier = ts3.isStringLiteralLike(location) ? location : ((_a = ts3.findAncestor(location, ts3.isImportCall)) === null || _a === void 0 ? void 0 : _a.arguments[0]) || ((_b = ts3.findAncestor(location, ts3.isImportDeclaration)) === null || _b === void 0 ? void 0 : _b.moduleSpecifier) || ((_c = ts3.findAncestor(location, ts3.isExternalModuleImportEqualsDeclaration)) === null || _c === void 0 ? void 0 : _c.moduleReference.expression) || ((_d = ts3.findAncestor(location, ts3.isExportDeclaration)) === null || _d === void 0 ? void 0 : _d.moduleSpecifier) || ((_e = ts3.isModuleDeclaration(location) ? location : location.parent && ts3.isModuleDeclaration(location.parent) && location.parent.name === location ? location.parent : void 0) === null || _e === void 0 ? void 0 : _e.name) || ((_f = ts3.isLiteralImportTypeNode(location) ? location : void 0) === null || _f === void 0 ? void 0 : _f.argument.literal);
          var mode = contextSpecifier && ts3.isStringLiteralLike(contextSpecifier) ? ts3.getModeForUsageLocation(currentSourceFile, contextSpecifier) : currentSourceFile.impliedNodeFormat;
          var resolvedModule = ts3.getResolvedModule(currentSourceFile, moduleReference, mode);
          var resolutionDiagnostic = resolvedModule && ts3.getResolutionDiagnostic(compilerOptions, resolvedModule);
          var sourceFile = resolvedModule && (!resolutionDiagnostic || resolutionDiagnostic === ts3.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set) && host.getSourceFile(resolvedModule.resolvedFileName);
          if (sourceFile) {
            if (resolutionDiagnostic) {
              error(errorNode, resolutionDiagnostic, moduleReference, resolvedModule.resolvedFileName);
            }
            if (sourceFile.symbol) {
              if (resolvedModule.isExternalLibraryImport && !ts3.resolutionExtensionIsTSOrJson(resolvedModule.extension)) {
                errorOnImplicitAnyModule(false, errorNode, resolvedModule, moduleReference);
              }
              if (ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeNext) {
                var isSyncImport = currentSourceFile.impliedNodeFormat === ts3.ModuleKind.CommonJS && !ts3.findAncestor(location, ts3.isImportCall) || !!ts3.findAncestor(location, ts3.isImportEqualsDeclaration);
                var overrideClauseHost = ts3.findAncestor(location, function(l) {
                  return ts3.isImportTypeNode(l) || ts3.isExportDeclaration(l) || ts3.isImportDeclaration(l);
                });
                var overrideClause = overrideClauseHost && ts3.isImportTypeNode(overrideClauseHost) ? (_g = overrideClauseHost.assertions) === null || _g === void 0 ? void 0 : _g.assertClause : overrideClauseHost === null || overrideClauseHost === void 0 ? void 0 : overrideClauseHost.assertClause;
                if (isSyncImport && sourceFile.impliedNodeFormat === ts3.ModuleKind.ESNext && !ts3.getResolutionModeOverrideForClause(overrideClause)) {
                  error(errorNode, ts3.Diagnostics.Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_synchronously_Use_dynamic_import_instead, moduleReference);
                }
              }
              return getMergedSymbol(sourceFile.symbol);
            }
            if (moduleNotFoundError) {
              error(errorNode, ts3.Diagnostics.File_0_is_not_a_module, sourceFile.fileName);
            }
            return void 0;
          }
          if (patternAmbientModules) {
            var pattern = ts3.findBestPatternMatch(patternAmbientModules, function(_) {
              return _.pattern;
            }, moduleReference);
            if (pattern) {
              var augmentation = patternAmbientModuleAugmentations && patternAmbientModuleAugmentations.get(moduleReference);
              if (augmentation) {
                return getMergedSymbol(augmentation);
              }
              return getMergedSymbol(pattern.symbol);
            }
          }
          if (resolvedModule && !ts3.resolutionExtensionIsTSOrJson(resolvedModule.extension) && resolutionDiagnostic === void 0 || resolutionDiagnostic === ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type) {
            if (isForAugmentation) {
              var diag = ts3.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;
              error(errorNode, diag, moduleReference, resolvedModule.resolvedFileName);
            } else {
              errorOnImplicitAnyModule(noImplicitAny && !!moduleNotFoundError, errorNode, resolvedModule, moduleReference);
            }
            return void 0;
          }
          if (moduleNotFoundError) {
            if (resolvedModule) {
              var redirect = host.getProjectReferenceRedirect(resolvedModule.resolvedFileName);
              if (redirect) {
                error(errorNode, ts3.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, resolvedModule.resolvedFileName);
                return void 0;
              }
            }
            if (resolutionDiagnostic) {
              error(errorNode, resolutionDiagnostic, moduleReference, resolvedModule.resolvedFileName);
            } else {
              var tsExtension = ts3.tryExtractTSExtension(moduleReference);
              var isExtensionlessRelativePathImport = ts3.pathIsRelative(moduleReference) && !ts3.hasExtension(moduleReference);
              var moduleResolutionKind = ts3.getEmitModuleResolutionKind(compilerOptions);
              var resolutionIsNode16OrNext = moduleResolutionKind === ts3.ModuleResolutionKind.Node16 || moduleResolutionKind === ts3.ModuleResolutionKind.NodeNext;
              if (tsExtension) {
                var diag = ts3.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead;
                var importSourceWithoutExtension = ts3.removeExtension(moduleReference, tsExtension);
                var replacedImportSource = importSourceWithoutExtension;
                if (moduleKind >= ts3.ModuleKind.ES2015) {
                  replacedImportSource += tsExtension === ".mts" ? ".mjs" : tsExtension === ".cts" ? ".cjs" : ".js";
                }
                error(errorNode, diag, tsExtension, replacedImportSource);
              } else if (!compilerOptions.resolveJsonModule && ts3.fileExtensionIs(moduleReference, ".json") && ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.Classic && ts3.hasJsonModuleEmitEnabled(compilerOptions)) {
                error(errorNode, ts3.Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension, moduleReference);
              } else if (mode === ts3.ModuleKind.ESNext && resolutionIsNode16OrNext && isExtensionlessRelativePathImport) {
                var absoluteRef_1 = ts3.getNormalizedAbsolutePath(moduleReference, ts3.getDirectoryPath(currentSourceFile.path));
                var suggestedExt = (_h = suggestedExtensions.find(function(_a2) {
                  var actualExt = _a2[0], _importExt = _a2[1];
                  return host.fileExists(absoluteRef_1 + actualExt);
                })) === null || _h === void 0 ? void 0 : _h[1];
                if (suggestedExt) {
                  error(errorNode, ts3.Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0, moduleReference + suggestedExt);
                } else {
                  error(errorNode, ts3.Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path);
                }
              } else {
                error(errorNode, moduleNotFoundError, moduleReference);
              }
            }
          }
          return void 0;
        }
        function errorOnImplicitAnyModule(isError, errorNode, _a, moduleReference) {
          var packageId = _a.packageId, resolvedFileName = _a.resolvedFileName;
          var errorInfo = !ts3.isExternalModuleNameRelative(moduleReference) && packageId ? typesPackageExists(packageId.name) ? ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1, packageId.name, ts3.mangleScopedPackageName(packageId.name)) : packageBundlesTypes(packageId.name) ? ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1, packageId.name, moduleReference) : ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0, moduleReference, ts3.mangleScopedPackageName(packageId.name)) : void 0;
          errorOrSuggestion(isError, errorNode, ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type, moduleReference, resolvedFileName));
        }
        function typesPackageExists(packageName) {
          return getPackagesMap().has(ts3.getTypesPackageName(packageName));
        }
        function packageBundlesTypes(packageName) {
          return !!getPackagesMap().get(packageName);
        }
        function resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) {
          if (moduleSymbol === null || moduleSymbol === void 0 ? void 0 : moduleSymbol.exports) {
            var exportEquals = resolveSymbol(moduleSymbol.exports.get("export="), dontResolveAlias);
            var exported = getCommonJsExportEquals(getMergedSymbol(exportEquals), getMergedSymbol(moduleSymbol));
            return getMergedSymbol(exported) || moduleSymbol;
          }
          return void 0;
        }
        function getCommonJsExportEquals(exported, moduleSymbol) {
          if (!exported || exported === unknownSymbol || exported === moduleSymbol || moduleSymbol.exports.size === 1 || exported.flags & 2097152) {
            return exported;
          }
          var links = getSymbolLinks(exported);
          if (links.cjsExportMerged) {
            return links.cjsExportMerged;
          }
          var merged = exported.flags & 33554432 ? exported : cloneSymbol(exported);
          merged.flags = merged.flags | 512;
          if (merged.exports === void 0) {
            merged.exports = ts3.createSymbolTable();
          }
          moduleSymbol.exports.forEach(function(s, name) {
            if (name === "export=")
              return;
            merged.exports.set(name, merged.exports.has(name) ? mergeSymbol(merged.exports.get(name), s) : s);
          });
          getSymbolLinks(merged).cjsExportMerged = merged;
          return links.cjsExportMerged = merged;
        }
        function resolveESModuleSymbol(moduleSymbol, referencingLocation, dontResolveAlias, suppressInteropError) {
          var _a;
          var symbol = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias);
          if (!dontResolveAlias && symbol) {
            if (!suppressInteropError && !(symbol.flags & (1536 | 3)) && !ts3.getDeclarationOfKind(symbol, 305)) {
              var compilerOptionName = moduleKind >= ts3.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
              error(referencingLocation, ts3.Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export, compilerOptionName);
              return symbol;
            }
            var referenceParent = referencingLocation.parent;
            if (ts3.isImportDeclaration(referenceParent) && ts3.getNamespaceDeclarationNode(referenceParent) || ts3.isImportCall(referenceParent)) {
              var reference = ts3.isImportCall(referenceParent) ? referenceParent.arguments[0] : referenceParent.moduleSpecifier;
              var type2 = getTypeOfSymbol(symbol);
              var defaultOnlyType = getTypeWithSyntheticDefaultOnly(type2, symbol, moduleSymbol, reference);
              if (defaultOnlyType) {
                return cloneTypeAsModuleType(symbol, defaultOnlyType, referenceParent);
              }
              var targetFile = (_a = moduleSymbol === null || moduleSymbol === void 0 ? void 0 : moduleSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isSourceFile);
              var isEsmCjsRef = targetFile && isESMFormatImportImportingCommonjsFormatFile(getUsageModeForExpression(reference), targetFile.impliedNodeFormat);
              if (ts3.getESModuleInterop(compilerOptions) || isEsmCjsRef) {
                var sigs = getSignaturesOfStructuredType(type2, 0);
                if (!sigs || !sigs.length) {
                  sigs = getSignaturesOfStructuredType(type2, 1);
                }
                if (sigs && sigs.length || getPropertyOfType(type2, "default", true) || isEsmCjsRef) {
                  var moduleType = getTypeWithSyntheticDefaultImportType(type2, symbol, moduleSymbol, reference);
                  return cloneTypeAsModuleType(symbol, moduleType, referenceParent);
                }
              }
            }
          }
          return symbol;
        }
        function cloneTypeAsModuleType(symbol, moduleType, referenceParent) {
          var result2 = createSymbol(symbol.flags, symbol.escapedName);
          result2.declarations = symbol.declarations ? symbol.declarations.slice() : [];
          result2.parent = symbol.parent;
          result2.target = symbol;
          result2.originatingImport = referenceParent;
          if (symbol.valueDeclaration)
            result2.valueDeclaration = symbol.valueDeclaration;
          if (symbol.constEnumOnlyModule)
            result2.constEnumOnlyModule = true;
          if (symbol.members)
            result2.members = new ts3.Map(symbol.members);
          if (symbol.exports)
            result2.exports = new ts3.Map(symbol.exports);
          var resolvedModuleType = resolveStructuredTypeMembers(moduleType);
          result2.type = createAnonymousType(result2, resolvedModuleType.members, ts3.emptyArray, ts3.emptyArray, resolvedModuleType.indexInfos);
          return result2;
        }
        function hasExportAssignmentSymbol(moduleSymbol) {
          return moduleSymbol.exports.get("export=") !== void 0;
        }
        function getExportsOfModuleAsArray(moduleSymbol) {
          return symbolsToArray(getExportsOfModule(moduleSymbol));
        }
        function getExportsAndPropertiesOfModule(moduleSymbol) {
          var exports2 = getExportsOfModuleAsArray(moduleSymbol);
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals !== moduleSymbol) {
            var type2 = getTypeOfSymbol(exportEquals);
            if (shouldTreatPropertiesOfExternalModuleAsExports(type2)) {
              ts3.addRange(exports2, getPropertiesOfType(type2));
            }
          }
          return exports2;
        }
        function forEachExportAndPropertyOfModule(moduleSymbol, cb) {
          var exports2 = getExportsOfModule(moduleSymbol);
          exports2.forEach(function(symbol, key) {
            if (!isReservedMemberName(key)) {
              cb(symbol, key);
            }
          });
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals !== moduleSymbol) {
            var type2 = getTypeOfSymbol(exportEquals);
            if (shouldTreatPropertiesOfExternalModuleAsExports(type2)) {
              forEachPropertyOfType(type2, function(symbol, escapedName) {
                cb(symbol, escapedName);
              });
            }
          }
        }
        function tryGetMemberInModuleExports(memberName, moduleSymbol) {
          var symbolTable = getExportsOfModule(moduleSymbol);
          if (symbolTable) {
            return symbolTable.get(memberName);
          }
        }
        function tryGetMemberInModuleExportsAndProperties(memberName, moduleSymbol) {
          var symbol = tryGetMemberInModuleExports(memberName, moduleSymbol);
          if (symbol) {
            return symbol;
          }
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals === moduleSymbol) {
            return void 0;
          }
          var type2 = getTypeOfSymbol(exportEquals);
          return shouldTreatPropertiesOfExternalModuleAsExports(type2) ? getPropertyOfType(type2, memberName) : void 0;
        }
        function shouldTreatPropertiesOfExternalModuleAsExports(resolvedExternalModuleType) {
          return !(resolvedExternalModuleType.flags & 131068 || ts3.getObjectFlags(resolvedExternalModuleType) & 1 || isArrayType(resolvedExternalModuleType) || isTupleType(resolvedExternalModuleType));
        }
        function getExportsOfSymbol(symbol) {
          return symbol.flags & 6256 ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedExports") : symbol.flags & 1536 ? getExportsOfModule(symbol) : symbol.exports || emptySymbols;
        }
        function getExportsOfModule(moduleSymbol) {
          var links = getSymbolLinks(moduleSymbol);
          return links.resolvedExports || (links.resolvedExports = getExportsOfModuleWorker(moduleSymbol));
        }
        function extendExportSymbols(target, source, lookupTable, exportNode) {
          if (!source)
            return;
          source.forEach(function(sourceSymbol, id) {
            if (id === "default")
              return;
            var targetSymbol = target.get(id);
            if (!targetSymbol) {
              target.set(id, sourceSymbol);
              if (lookupTable && exportNode) {
                lookupTable.set(id, {
                  specifierText: ts3.getTextOfNode(exportNode.moduleSpecifier)
                });
              }
            } else if (lookupTable && exportNode && targetSymbol && resolveSymbol(targetSymbol) !== resolveSymbol(sourceSymbol)) {
              var collisionTracker = lookupTable.get(id);
              if (!collisionTracker.exportsWithDuplicate) {
                collisionTracker.exportsWithDuplicate = [exportNode];
              } else {
                collisionTracker.exportsWithDuplicate.push(exportNode);
              }
            }
          });
        }
        function getExportsOfModuleWorker(moduleSymbol) {
          var visitedSymbols = [];
          moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
          return visit(moduleSymbol) || emptySymbols;
          function visit(symbol) {
            if (!(symbol && symbol.exports && ts3.pushIfUnique(visitedSymbols, symbol))) {
              return;
            }
            var symbols = new ts3.Map(symbol.exports);
            var exportStars = symbol.exports.get("__export");
            if (exportStars) {
              var nestedSymbols = ts3.createSymbolTable();
              var lookupTable_1 = new ts3.Map();
              if (exportStars.declarations) {
                for (var _i = 0, _a = exportStars.declarations; _i < _a.length; _i++) {
                  var node = _a[_i];
                  var resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
                  var exportedSymbols = visit(resolvedModule);
                  extendExportSymbols(nestedSymbols, exportedSymbols, lookupTable_1, node);
                }
              }
              lookupTable_1.forEach(function(_a2, id) {
                var exportsWithDuplicate = _a2.exportsWithDuplicate;
                if (id === "export=" || !(exportsWithDuplicate && exportsWithDuplicate.length) || symbols.has(id)) {
                  return;
                }
                for (var _i2 = 0, exportsWithDuplicate_1 = exportsWithDuplicate; _i2 < exportsWithDuplicate_1.length; _i2++) {
                  var node2 = exportsWithDuplicate_1[_i2];
                  diagnostics.add(ts3.createDiagnosticForNode(node2, ts3.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity, lookupTable_1.get(id).specifierText, ts3.unescapeLeadingUnderscores(id)));
                }
              });
              extendExportSymbols(symbols, nestedSymbols);
            }
            return symbols;
          }
        }
        function getMergedSymbol(symbol) {
          var merged;
          return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
        function getSymbolOfNode(node) {
          return getMergedSymbol(node.symbol && getLateBoundSymbol(node.symbol));
        }
        function getParentOfSymbol(symbol) {
          return getMergedSymbol(symbol.parent && getLateBoundSymbol(symbol.parent));
        }
        function getAlternativeContainingModules(symbol, enclosingDeclaration) {
          var containingFile = ts3.getSourceFileOfNode(enclosingDeclaration);
          var id = getNodeId(containingFile);
          var links = getSymbolLinks(symbol);
          var results;
          if (links.extendedContainersByFile && (results = links.extendedContainersByFile.get(id))) {
            return results;
          }
          if (containingFile && containingFile.imports) {
            for (var _i = 0, _a = containingFile.imports; _i < _a.length; _i++) {
              var importRef = _a[_i];
              if (ts3.nodeIsSynthesized(importRef))
                continue;
              var resolvedModule = resolveExternalModuleName(enclosingDeclaration, importRef, true);
              if (!resolvedModule)
                continue;
              var ref = getAliasForSymbolInContainer(resolvedModule, symbol);
              if (!ref)
                continue;
              results = ts3.append(results, resolvedModule);
            }
            if (ts3.length(results)) {
              (links.extendedContainersByFile || (links.extendedContainersByFile = new ts3.Map())).set(id, results);
              return results;
            }
          }
          if (links.extendedContainers) {
            return links.extendedContainers;
          }
          var otherFiles = host.getSourceFiles();
          for (var _b = 0, otherFiles_1 = otherFiles; _b < otherFiles_1.length; _b++) {
            var file = otherFiles_1[_b];
            if (!ts3.isExternalModule(file))
              continue;
            var sym = getSymbolOfNode(file);
            var ref = getAliasForSymbolInContainer(sym, symbol);
            if (!ref)
              continue;
            results = ts3.append(results, sym);
          }
          return links.extendedContainers = results || ts3.emptyArray;
        }
        function getContainersOfSymbol(symbol, enclosingDeclaration, meaning) {
          var container = getParentOfSymbol(symbol);
          if (container && !(symbol.flags & 262144)) {
            var additionalContainers = ts3.mapDefined(container.declarations, fileSymbolIfFileSymbolExportEqualsContainer);
            var reexportContainers = enclosingDeclaration && getAlternativeContainingModules(symbol, enclosingDeclaration);
            var objectLiteralContainer = getVariableDeclarationOfObjectLiteral(container, meaning);
            if (enclosingDeclaration && container.flags & getQualifiedLeftMeaning(meaning) && getAccessibleSymbolChain(container, enclosingDeclaration, 1920, false)) {
              return ts3.append(ts3.concatenate(ts3.concatenate([container], additionalContainers), reexportContainers), objectLiteralContainer);
            }
            var firstVariableMatch = !(container.flags & getQualifiedLeftMeaning(meaning)) && container.flags & 788968 && getDeclaredTypeOfSymbol(container).flags & 524288 && meaning === 111551 ? forEachSymbolTableInScope(enclosingDeclaration, function(t) {
              return ts3.forEachEntry(t, function(s) {
                if (s.flags & getQualifiedLeftMeaning(meaning) && getTypeOfSymbol(s) === getDeclaredTypeOfSymbol(container)) {
                  return s;
                }
              });
            }) : void 0;
            var res = firstVariableMatch ? __spreadArray(__spreadArray([firstVariableMatch], additionalContainers, true), [container], false) : __spreadArray(__spreadArray([], additionalContainers, true), [container], false);
            res = ts3.append(res, objectLiteralContainer);
            res = ts3.addRange(res, reexportContainers);
            return res;
          }
          var candidates = ts3.mapDefined(symbol.declarations, function(d) {
            if (!ts3.isAmbientModule(d) && d.parent) {
              if (hasNonGlobalAugmentationExternalModuleSymbol(d.parent)) {
                return getSymbolOfNode(d.parent);
              }
              if (ts3.isModuleBlock(d.parent) && d.parent.parent && resolveExternalModuleSymbol(getSymbolOfNode(d.parent.parent)) === symbol) {
                return getSymbolOfNode(d.parent.parent);
              }
            }
            if (ts3.isClassExpression(d) && ts3.isBinaryExpression(d.parent) && d.parent.operatorToken.kind === 63 && ts3.isAccessExpression(d.parent.left) && ts3.isEntityNameExpression(d.parent.left.expression)) {
              if (ts3.isModuleExportsAccessExpression(d.parent.left) || ts3.isExportsIdentifier(d.parent.left.expression)) {
                return getSymbolOfNode(ts3.getSourceFileOfNode(d));
              }
              checkExpressionCached(d.parent.left.expression);
              return getNodeLinks(d.parent.left.expression).resolvedSymbol;
            }
          });
          if (!ts3.length(candidates)) {
            return void 0;
          }
          return ts3.mapDefined(candidates, function(candidate) {
            return getAliasForSymbolInContainer(candidate, symbol) ? candidate : void 0;
          });
          function fileSymbolIfFileSymbolExportEqualsContainer(d) {
            return container && getFileSymbolIfFileSymbolExportEqualsContainer(d, container);
          }
        }
        function getVariableDeclarationOfObjectLiteral(symbol, meaning) {
          var firstDecl = !!ts3.length(symbol.declarations) && ts3.first(symbol.declarations);
          if (meaning & 111551 && firstDecl && firstDecl.parent && ts3.isVariableDeclaration(firstDecl.parent)) {
            if (ts3.isObjectLiteralExpression(firstDecl) && firstDecl === firstDecl.parent.initializer || ts3.isTypeLiteralNode(firstDecl) && firstDecl === firstDecl.parent.type) {
              return getSymbolOfNode(firstDecl.parent);
            }
          }
        }
        function getFileSymbolIfFileSymbolExportEqualsContainer(d, container) {
          var fileSymbol = getExternalModuleContainer(d);
          var exported = fileSymbol && fileSymbol.exports && fileSymbol.exports.get("export=");
          return exported && getSymbolIfSameReference(exported, container) ? fileSymbol : void 0;
        }
        function getAliasForSymbolInContainer(container, symbol) {
          if (container === getParentOfSymbol(symbol)) {
            return symbol;
          }
          var exportEquals = container.exports && container.exports.get("export=");
          if (exportEquals && getSymbolIfSameReference(exportEquals, symbol)) {
            return container;
          }
          var exports2 = getExportsOfSymbol(container);
          var quick = exports2.get(symbol.escapedName);
          if (quick && getSymbolIfSameReference(quick, symbol)) {
            return quick;
          }
          return ts3.forEachEntry(exports2, function(exported) {
            if (getSymbolIfSameReference(exported, symbol)) {
              return exported;
            }
          });
        }
        function getSymbolIfSameReference(s1, s2) {
          if (getMergedSymbol(resolveSymbol(getMergedSymbol(s1))) === getMergedSymbol(resolveSymbol(getMergedSymbol(s2)))) {
            return s1;
          }
        }
        function getExportSymbolOfValueSymbolIfExported(symbol) {
          return getMergedSymbol(symbol && (symbol.flags & 1048576) !== 0 && symbol.exportSymbol || symbol);
        }
        function symbolIsValue(symbol) {
          return !!(symbol.flags & 111551 || symbol.flags & 2097152 && resolveAlias(symbol).flags & 111551 && !getTypeOnlyAliasDeclaration(symbol));
        }
        function findConstructorDeclaration(node) {
          var members = node.members;
          for (var _i = 0, members_3 = members; _i < members_3.length; _i++) {
            var member = members_3[_i];
            if (member.kind === 171 && ts3.nodeIsPresent(member.body)) {
              return member;
            }
          }
        }
        function createType(flags) {
          var result2 = new Type2(checker, flags);
          typeCount++;
          result2.id = typeCount;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.recordType(result2);
          return result2;
        }
        function createOriginType(flags) {
          return new Type2(checker, flags);
        }
        function createIntrinsicType(kind, intrinsicName, objectFlags) {
          if (objectFlags === void 0) {
            objectFlags = 0;
          }
          var type2 = createType(kind);
          type2.intrinsicName = intrinsicName;
          type2.objectFlags = objectFlags;
          return type2;
        }
        function createObjectType(objectFlags, symbol) {
          var type2 = createType(524288);
          type2.objectFlags = objectFlags;
          type2.symbol = symbol;
          type2.members = void 0;
          type2.properties = void 0;
          type2.callSignatures = void 0;
          type2.constructSignatures = void 0;
          type2.indexInfos = void 0;
          return type2;
        }
        function createTypeofType() {
          return getUnionType(ts3.arrayFrom(typeofEQFacts.keys(), getStringLiteralType));
        }
        function createTypeParameter(symbol) {
          var type2 = createType(262144);
          if (symbol)
            type2.symbol = symbol;
          return type2;
        }
        function isReservedMemberName(name) {
          return name.charCodeAt(0) === 95 && name.charCodeAt(1) === 95 && name.charCodeAt(2) !== 95 && name.charCodeAt(2) !== 64 && name.charCodeAt(2) !== 35;
        }
        function getNamedMembers(members) {
          var result2;
          members.forEach(function(symbol, id) {
            if (isNamedMember(symbol, id)) {
              (result2 || (result2 = [])).push(symbol);
            }
          });
          return result2 || ts3.emptyArray;
        }
        function isNamedMember(member, escapedName) {
          return !isReservedMemberName(escapedName) && symbolIsValue(member);
        }
        function getNamedOrIndexSignatureMembers(members) {
          var result2 = getNamedMembers(members);
          var index = getIndexSymbolFromSymbolTable(members);
          return index ? ts3.concatenate(result2, [index]) : result2;
        }
        function setStructuredTypeMembers(type2, members, callSignatures, constructSignatures, indexInfos) {
          var resolved = type2;
          resolved.members = members;
          resolved.properties = ts3.emptyArray;
          resolved.callSignatures = callSignatures;
          resolved.constructSignatures = constructSignatures;
          resolved.indexInfos = indexInfos;
          if (members !== emptySymbols)
            resolved.properties = getNamedMembers(members);
          return resolved;
        }
        function createAnonymousType(symbol, members, callSignatures, constructSignatures, indexInfos) {
          return setStructuredTypeMembers(createObjectType(16, symbol), members, callSignatures, constructSignatures, indexInfos);
        }
        function getResolvedTypeWithoutAbstractConstructSignatures(type2) {
          if (type2.constructSignatures.length === 0)
            return type2;
          if (type2.objectTypeWithoutAbstractConstructSignatures)
            return type2.objectTypeWithoutAbstractConstructSignatures;
          var constructSignatures = ts3.filter(type2.constructSignatures, function(signature) {
            return !(signature.flags & 4);
          });
          if (type2.constructSignatures === constructSignatures)
            return type2;
          var typeCopy = createAnonymousType(type2.symbol, type2.members, type2.callSignatures, ts3.some(constructSignatures) ? constructSignatures : ts3.emptyArray, type2.indexInfos);
          type2.objectTypeWithoutAbstractConstructSignatures = typeCopy;
          typeCopy.objectTypeWithoutAbstractConstructSignatures = typeCopy;
          return typeCopy;
        }
        function forEachSymbolTableInScope(enclosingDeclaration, callback) {
          var result2;
          var _loop_8 = function(location2) {
            if (location2.locals && !isGlobalSourceFile(location2)) {
              if (result2 = callback(location2.locals, void 0, true, location2)) {
                return { value: result2 };
              }
            }
            switch (location2.kind) {
              case 305:
                if (!ts3.isExternalOrCommonJsModule(location2)) {
                  break;
                }
              case 261:
                var sym = getSymbolOfNode(location2);
                if (result2 = callback((sym === null || sym === void 0 ? void 0 : sym.exports) || emptySymbols, void 0, true, location2)) {
                  return { value: result2 };
                }
                break;
              case 257:
              case 226:
              case 258:
                var table_1;
                (getSymbolOfNode(location2).members || emptySymbols).forEach(function(memberSymbol, key) {
                  if (memberSymbol.flags & (788968 & ~67108864)) {
                    (table_1 || (table_1 = ts3.createSymbolTable())).set(key, memberSymbol);
                  }
                });
                if (table_1 && (result2 = callback(table_1, void 0, false, location2))) {
                  return { value: result2 };
                }
                break;
            }
          };
          for (var location = enclosingDeclaration; location; location = location.parent) {
            var state_2 = _loop_8(location);
            if (typeof state_2 === "object")
              return state_2.value;
          }
          return callback(globals, void 0, true);
        }
        function getQualifiedLeftMeaning(rightMeaning) {
          return rightMeaning === 111551 ? 111551 : 1920;
        }
        function getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, useOnlyExternalAliasing, visitedSymbolTablesMap) {
          if (visitedSymbolTablesMap === void 0) {
            visitedSymbolTablesMap = new ts3.Map();
          }
          if (!(symbol && !isPropertyOrMethodDeclarationSymbol(symbol))) {
            return void 0;
          }
          var links = getSymbolLinks(symbol);
          var cache = links.accessibleChainCache || (links.accessibleChainCache = new ts3.Map());
          var firstRelevantLocation = forEachSymbolTableInScope(enclosingDeclaration, function(_, __, ___, node) {
            return node;
          });
          var key = "".concat(useOnlyExternalAliasing ? 0 : 1, "|").concat(firstRelevantLocation && getNodeId(firstRelevantLocation), "|").concat(meaning);
          if (cache.has(key)) {
            return cache.get(key);
          }
          var id = getSymbolId(symbol);
          var visitedSymbolTables = visitedSymbolTablesMap.get(id);
          if (!visitedSymbolTables) {
            visitedSymbolTablesMap.set(id, visitedSymbolTables = []);
          }
          var result2 = forEachSymbolTableInScope(enclosingDeclaration, getAccessibleSymbolChainFromSymbolTable);
          cache.set(key, result2);
          return result2;
          function getAccessibleSymbolChainFromSymbolTable(symbols, ignoreQualification, isLocalNameLookup) {
            if (!ts3.pushIfUnique(visitedSymbolTables, symbols)) {
              return void 0;
            }
            var result3 = trySymbolTable(symbols, ignoreQualification, isLocalNameLookup);
            visitedSymbolTables.pop();
            return result3;
          }
          function canQualifySymbol(symbolFromSymbolTable, meaning2) {
            return !needsQualification(symbolFromSymbolTable, enclosingDeclaration, meaning2) || !!getAccessibleSymbolChain(symbolFromSymbolTable.parent, enclosingDeclaration, getQualifiedLeftMeaning(meaning2), useOnlyExternalAliasing, visitedSymbolTablesMap);
          }
          function isAccessible(symbolFromSymbolTable, resolvedAliasSymbol, ignoreQualification) {
            return (symbol === (resolvedAliasSymbol || symbolFromSymbolTable) || getMergedSymbol(symbol) === getMergedSymbol(resolvedAliasSymbol || symbolFromSymbolTable)) && !ts3.some(symbolFromSymbolTable.declarations, hasNonGlobalAugmentationExternalModuleSymbol) && (ignoreQualification || canQualifySymbol(getMergedSymbol(symbolFromSymbolTable), meaning));
          }
          function trySymbolTable(symbols, ignoreQualification, isLocalNameLookup) {
            if (isAccessible(symbols.get(symbol.escapedName), void 0, ignoreQualification)) {
              return [symbol];
            }
            var result3 = ts3.forEachEntry(symbols, function(symbolFromSymbolTable) {
              if (symbolFromSymbolTable.flags & 2097152 && symbolFromSymbolTable.escapedName !== "export=" && symbolFromSymbolTable.escapedName !== "default" && !(ts3.isUMDExportSymbol(symbolFromSymbolTable) && enclosingDeclaration && ts3.isExternalModule(ts3.getSourceFileOfNode(enclosingDeclaration))) && (!useOnlyExternalAliasing || ts3.some(symbolFromSymbolTable.declarations, ts3.isExternalModuleImportEqualsDeclaration)) && (isLocalNameLookup ? !ts3.some(symbolFromSymbolTable.declarations, ts3.isNamespaceReexportDeclaration) : true) && (ignoreQualification || !ts3.getDeclarationOfKind(symbolFromSymbolTable, 275))) {
                var resolvedImportedSymbol = resolveAlias(symbolFromSymbolTable);
                var candidate = getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification);
                if (candidate) {
                  return candidate;
                }
              }
              if (symbolFromSymbolTable.escapedName === symbol.escapedName && symbolFromSymbolTable.exportSymbol) {
                if (isAccessible(getMergedSymbol(symbolFromSymbolTable.exportSymbol), void 0, ignoreQualification)) {
                  return [symbol];
                }
              }
            });
            return result3 || (symbols === globals ? getCandidateListForSymbol(globalThisSymbol, globalThisSymbol, ignoreQualification) : void 0);
          }
          function getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification) {
            if (isAccessible(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification)) {
              return [symbolFromSymbolTable];
            }
            var candidateTable = getExportsOfSymbol(resolvedImportedSymbol);
            var accessibleSymbolsFromExports = candidateTable && getAccessibleSymbolChainFromSymbolTable(candidateTable, true);
            if (accessibleSymbolsFromExports && canQualifySymbol(symbolFromSymbolTable, getQualifiedLeftMeaning(meaning))) {
              return [symbolFromSymbolTable].concat(accessibleSymbolsFromExports);
            }
          }
        }
        function needsQualification(symbol, enclosingDeclaration, meaning) {
          var qualify = false;
          forEachSymbolTableInScope(enclosingDeclaration, function(symbolTable) {
            var symbolFromSymbolTable = getMergedSymbol(symbolTable.get(symbol.escapedName));
            if (!symbolFromSymbolTable) {
              return false;
            }
            if (symbolFromSymbolTable === symbol) {
              return true;
            }
            symbolFromSymbolTable = symbolFromSymbolTable.flags & 2097152 && !ts3.getDeclarationOfKind(symbolFromSymbolTable, 275) ? resolveAlias(symbolFromSymbolTable) : symbolFromSymbolTable;
            if (symbolFromSymbolTable.flags & meaning) {
              qualify = true;
              return true;
            }
            return false;
          });
          return qualify;
        }
        function isPropertyOrMethodDeclarationSymbol(symbol) {
          if (symbol.declarations && symbol.declarations.length) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              switch (declaration.kind) {
                case 167:
                case 169:
                case 172:
                case 173:
                  continue;
                default:
                  return false;
              }
            }
            return true;
          }
          return false;
        }
        function isTypeSymbolAccessible(typeSymbol, enclosingDeclaration) {
          var access = isSymbolAccessibleWorker(typeSymbol, enclosingDeclaration, 788968, false, true);
          return access.accessibility === 0;
        }
        function isValueSymbolAccessible(typeSymbol, enclosingDeclaration) {
          var access = isSymbolAccessibleWorker(typeSymbol, enclosingDeclaration, 111551, false, true);
          return access.accessibility === 0;
        }
        function isSymbolAccessibleByFlags(typeSymbol, enclosingDeclaration, flags) {
          var access = isSymbolAccessibleWorker(typeSymbol, enclosingDeclaration, flags, false, false);
          return access.accessibility === 0;
        }
        function isAnySymbolAccessible(symbols, enclosingDeclaration, initialSymbol, meaning, shouldComputeAliasesToMakeVisible, allowModules) {
          if (!ts3.length(symbols))
            return;
          var hadAccessibleChain;
          var earlyModuleBail = false;
          for (var _i = 0, _a = symbols; _i < _a.length; _i++) {
            var symbol = _a[_i];
            var accessibleSymbolChain = getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, false);
            if (accessibleSymbolChain) {
              hadAccessibleChain = symbol;
              var hasAccessibleDeclarations = hasVisibleDeclarations(accessibleSymbolChain[0], shouldComputeAliasesToMakeVisible);
              if (hasAccessibleDeclarations) {
                return hasAccessibleDeclarations;
              }
            }
            if (allowModules) {
              if (ts3.some(symbol.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                if (shouldComputeAliasesToMakeVisible) {
                  earlyModuleBail = true;
                  continue;
                }
                return {
                  accessibility: 0
                };
              }
            }
            var containers = getContainersOfSymbol(symbol, enclosingDeclaration, meaning);
            var parentResult = isAnySymbolAccessible(containers, enclosingDeclaration, initialSymbol, initialSymbol === symbol ? getQualifiedLeftMeaning(meaning) : meaning, shouldComputeAliasesToMakeVisible, allowModules);
            if (parentResult) {
              return parentResult;
            }
          }
          if (earlyModuleBail) {
            return {
              accessibility: 0
            };
          }
          if (hadAccessibleChain) {
            return {
              accessibility: 1,
              errorSymbolName: symbolToString(initialSymbol, enclosingDeclaration, meaning),
              errorModuleName: hadAccessibleChain !== initialSymbol ? symbolToString(hadAccessibleChain, enclosingDeclaration, 1920) : void 0
            };
          }
        }
        function isSymbolAccessible(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible) {
          return isSymbolAccessibleWorker(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible, true);
        }
        function isSymbolAccessibleWorker(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible, allowModules) {
          if (symbol && enclosingDeclaration) {
            var result2 = isAnySymbolAccessible([symbol], enclosingDeclaration, symbol, meaning, shouldComputeAliasesToMakeVisible, allowModules);
            if (result2) {
              return result2;
            }
            var symbolExternalModule = ts3.forEach(symbol.declarations, getExternalModuleContainer);
            if (symbolExternalModule) {
              var enclosingExternalModule = getExternalModuleContainer(enclosingDeclaration);
              if (symbolExternalModule !== enclosingExternalModule) {
                return {
                  accessibility: 2,
                  errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning),
                  errorModuleName: symbolToString(symbolExternalModule),
                  errorNode: ts3.isInJSFile(enclosingDeclaration) ? enclosingDeclaration : void 0
                };
              }
            }
            return {
              accessibility: 1,
              errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning)
            };
          }
          return { accessibility: 0 };
        }
        function getExternalModuleContainer(declaration) {
          var node = ts3.findAncestor(declaration, hasExternalModuleSymbol);
          return node && getSymbolOfNode(node);
        }
        function hasExternalModuleSymbol(declaration) {
          return ts3.isAmbientModule(declaration) || declaration.kind === 305 && ts3.isExternalOrCommonJsModule(declaration);
        }
        function hasNonGlobalAugmentationExternalModuleSymbol(declaration) {
          return ts3.isModuleWithStringLiteralName(declaration) || declaration.kind === 305 && ts3.isExternalOrCommonJsModule(declaration);
        }
        function hasVisibleDeclarations(symbol, shouldComputeAliasToMakeVisible) {
          var aliasesToMakeVisible;
          if (!ts3.every(ts3.filter(symbol.declarations, function(d) {
            return d.kind !== 79;
          }), getIsDeclarationVisible)) {
            return void 0;
          }
          return { accessibility: 0, aliasesToMakeVisible };
          function getIsDeclarationVisible(declaration) {
            var _a, _b;
            if (!isDeclarationVisible(declaration)) {
              var anyImportSyntax = getAnyImportSyntax(declaration);
              if (anyImportSyntax && !ts3.hasSyntacticModifier(anyImportSyntax, 1) && isDeclarationVisible(anyImportSyntax.parent)) {
                return addVisibleAlias(declaration, anyImportSyntax);
              } else if (ts3.isVariableDeclaration(declaration) && ts3.isVariableStatement(declaration.parent.parent) && !ts3.hasSyntacticModifier(declaration.parent.parent, 1) && isDeclarationVisible(declaration.parent.parent.parent)) {
                return addVisibleAlias(declaration, declaration.parent.parent);
              } else if (ts3.isLateVisibilityPaintedStatement(declaration) && !ts3.hasSyntacticModifier(declaration, 1) && isDeclarationVisible(declaration.parent)) {
                return addVisibleAlias(declaration, declaration);
              } else if (symbol.flags & 2097152 && ts3.isBindingElement(declaration) && ts3.isInJSFile(declaration) && ((_a = declaration.parent) === null || _a === void 0 ? void 0 : _a.parent) && ts3.isVariableDeclaration(declaration.parent.parent) && ((_b = declaration.parent.parent.parent) === null || _b === void 0 ? void 0 : _b.parent) && ts3.isVariableStatement(declaration.parent.parent.parent.parent) && !ts3.hasSyntacticModifier(declaration.parent.parent.parent.parent, 1) && declaration.parent.parent.parent.parent.parent && isDeclarationVisible(declaration.parent.parent.parent.parent.parent)) {
                return addVisibleAlias(declaration, declaration.parent.parent.parent.parent);
              }
              return false;
            }
            return true;
          }
          function addVisibleAlias(declaration, aliasingStatement) {
            if (shouldComputeAliasToMakeVisible) {
              getNodeLinks(declaration).isVisible = true;
              aliasesToMakeVisible = ts3.appendIfUnique(aliasesToMakeVisible, aliasingStatement);
            }
            return true;
          }
        }
        function isEntityNameVisible(entityName, enclosingDeclaration) {
          var meaning;
          if (entityName.parent.kind === 181 || entityName.parent.kind === 228 && !ts3.isPartOfTypeNode(entityName.parent) || entityName.parent.kind === 162) {
            meaning = 111551 | 1048576;
          } else if (entityName.kind === 161 || entityName.kind === 206 || entityName.parent.kind === 265) {
            meaning = 1920;
          } else {
            meaning = 788968;
          }
          var firstIdentifier = ts3.getFirstIdentifier(entityName);
          var symbol = resolveName(enclosingDeclaration, firstIdentifier.escapedText, meaning, void 0, void 0, false);
          if (symbol && symbol.flags & 262144 && meaning & 788968) {
            return { accessibility: 0 };
          }
          return symbol && hasVisibleDeclarations(symbol, true) || {
            accessibility: 1,
            errorSymbolName: ts3.getTextOfNode(firstIdentifier),
            errorNode: firstIdentifier
          };
        }
        function symbolToString(symbol, enclosingDeclaration, meaning, flags, writer) {
          if (flags === void 0) {
            flags = 4;
          }
          var nodeFlags = 70221824;
          if (flags & 2) {
            nodeFlags |= 128;
          }
          if (flags & 1) {
            nodeFlags |= 512;
          }
          if (flags & 8) {
            nodeFlags |= 16384;
          }
          if (flags & 16) {
            nodeFlags |= 134217728;
          }
          var builder = flags & 4 ? nodeBuilder.symbolToExpression : nodeBuilder.symbolToEntityName;
          return writer ? symbolToStringWorker(writer).getText() : ts3.usingSingleLineStringWriter(symbolToStringWorker);
          function symbolToStringWorker(writer2) {
            var entity = builder(symbol, meaning, enclosingDeclaration, nodeFlags);
            var printer2 = (enclosingDeclaration === null || enclosingDeclaration === void 0 ? void 0 : enclosingDeclaration.kind) === 305 ? ts3.createPrinter({ removeComments: true, neverAsciiEscape: true }) : ts3.createPrinter({ removeComments: true });
            var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
            printer2.writeNode(4, entity, sourceFile, writer2);
            return writer2;
          }
        }
        function signatureToString(signature, enclosingDeclaration, flags, kind, writer) {
          if (flags === void 0) {
            flags = 0;
          }
          return writer ? signatureToStringWorker(writer).getText() : ts3.usingSingleLineStringWriter(signatureToStringWorker);
          function signatureToStringWorker(writer2) {
            var sigOutput;
            if (flags & 262144) {
              sigOutput = kind === 1 ? 180 : 179;
            } else {
              sigOutput = kind === 1 ? 175 : 174;
            }
            var sig = nodeBuilder.signatureToSignatureDeclaration(signature, sigOutput, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | 512);
            var printer2 = ts3.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
            var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
            printer2.writeNode(4, sig, sourceFile, ts3.getTrailingSemicolonDeferringWriter(writer2));
            return writer2;
          }
        }
        function typeToString(type2, enclosingDeclaration, flags, writer) {
          if (flags === void 0) {
            flags = 1048576 | 16384;
          }
          if (writer === void 0) {
            writer = ts3.createTextWriter("");
          }
          var noTruncation = compilerOptions.noErrorTruncation || flags & 1;
          var typeNode = nodeBuilder.typeToTypeNode(type2, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | (noTruncation ? 1 : 0), writer);
          if (typeNode === void 0)
            return ts3.Debug.fail("should always get typenode");
          var options = { removeComments: type2 !== unresolvedType };
          var printer2 = ts3.createPrinter(options);
          var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
          printer2.writeNode(4, typeNode, sourceFile, writer);
          var result2 = writer.getText();
          var maxLength = noTruncation ? ts3.noTruncationMaximumTruncationLength * 2 : ts3.defaultMaximumTruncationLength * 2;
          if (maxLength && result2 && result2.length >= maxLength) {
            return result2.substr(0, maxLength - "...".length) + "...";
          }
          return result2;
        }
        function getTypeNamesForErrorDisplay(left, right) {
          var leftStr = symbolValueDeclarationIsContextSensitive(left.symbol) ? typeToString(left, left.symbol.valueDeclaration) : typeToString(left);
          var rightStr = symbolValueDeclarationIsContextSensitive(right.symbol) ? typeToString(right, right.symbol.valueDeclaration) : typeToString(right);
          if (leftStr === rightStr) {
            leftStr = getTypeNameForErrorDisplay(left);
            rightStr = getTypeNameForErrorDisplay(right);
          }
          return [leftStr, rightStr];
        }
        function getTypeNameForErrorDisplay(type2) {
          return typeToString(type2, void 0, 64);
        }
        function symbolValueDeclarationIsContextSensitive(symbol) {
          return symbol && !!symbol.valueDeclaration && ts3.isExpression(symbol.valueDeclaration) && !isContextSensitive(symbol.valueDeclaration);
        }
        function toNodeBuilderFlags(flags) {
          if (flags === void 0) {
            flags = 0;
          }
          return flags & 814775659;
        }
        function isClassInstanceSide(type2) {
          return !!type2.symbol && !!(type2.symbol.flags & 32) && (type2 === getDeclaredTypeOfClassOrInterface(type2.symbol) || !!(type2.flags & 524288) && !!(ts3.getObjectFlags(type2) & 16777216));
        }
        function createNodeBuilder() {
          return {
            typeToTypeNode: function(type2, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeToTypeNodeHelper(type2, context);
              });
            },
            indexInfoToIndexSignatureDeclaration: function(indexInfo, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return indexInfoToIndexSignatureDeclarationHelper(indexInfo, context, void 0);
              });
            },
            signatureToSignatureDeclaration: function(signature, kind, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return signatureToSignatureDeclarationHelper(signature, kind, context);
              });
            },
            symbolToEntityName: function(symbol, meaning, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToName(symbol, context, meaning, false);
              });
            },
            symbolToExpression: function(symbol, meaning, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToExpression(symbol, context, meaning);
              });
            },
            symbolToTypeParameterDeclarations: function(symbol, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeParametersToTypeParameterDeclarations(symbol, context);
              });
            },
            symbolToParameterDeclaration: function(symbol, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToParameterDeclaration(symbol, context);
              });
            },
            typeParameterToDeclaration: function(parameter, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeParameterToDeclaration(parameter, context);
              });
            },
            symbolTableToDeclarationStatements: function(symbolTable, enclosingDeclaration, flags, tracker, bundled) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolTableToDeclarationStatements(symbolTable, context, bundled);
              });
            }
          };
          function withContext(enclosingDeclaration, flags, tracker, cb) {
            var _a, _b;
            ts3.Debug.assert(enclosingDeclaration === void 0 || (enclosingDeclaration.flags & 8) === 0);
            var context = {
              enclosingDeclaration,
              flags: flags || 0,
              tracker: tracker && tracker.trackSymbol ? tracker : { trackSymbol: function() {
                return false;
              }, moduleResolverHost: flags & 134217728 ? {
                getCommonSourceDirectory: !!host.getCommonSourceDirectory ? function() {
                  return host.getCommonSourceDirectory();
                } : function() {
                  return "";
                },
                getCurrentDirectory: function() {
                  return host.getCurrentDirectory();
                },
                getSymlinkCache: ts3.maybeBind(host, host.getSymlinkCache),
                getPackageJsonInfoCache: function() {
                  var _a2;
                  return (_a2 = host.getPackageJsonInfoCache) === null || _a2 === void 0 ? void 0 : _a2.call(host);
                },
                useCaseSensitiveFileNames: ts3.maybeBind(host, host.useCaseSensitiveFileNames),
                redirectTargetsMap: host.redirectTargetsMap,
                getProjectReferenceRedirect: function(fileName2) {
                  return host.getProjectReferenceRedirect(fileName2);
                },
                isSourceOfProjectReferenceRedirect: function(fileName2) {
                  return host.isSourceOfProjectReferenceRedirect(fileName2);
                },
                fileExists: function(fileName2) {
                  return host.fileExists(fileName2);
                },
                getFileIncludeReasons: function() {
                  return host.getFileIncludeReasons();
                },
                readFile: host.readFile ? function(fileName2) {
                  return host.readFile(fileName2);
                } : void 0
              } : void 0 },
              encounteredError: false,
              reportedDiagnostic: false,
              visitedTypes: void 0,
              symbolDepth: void 0,
              inferTypeParameters: void 0,
              approximateLength: 0
            };
            context.tracker = wrapSymbolTrackerToReportForContext(context, context.tracker);
            var resultingNode = cb(context);
            if (context.truncating && context.flags & 1) {
              (_b = (_a = context.tracker) === null || _a === void 0 ? void 0 : _a.reportTruncationError) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            return context.encounteredError ? void 0 : resultingNode;
          }
          function wrapSymbolTrackerToReportForContext(context, tracker) {
            var oldTrackSymbol = tracker.trackSymbol;
            return __assign(__assign({}, tracker), { reportCyclicStructureError: wrapReportedDiagnostic(tracker.reportCyclicStructureError), reportInaccessibleThisError: wrapReportedDiagnostic(tracker.reportInaccessibleThisError), reportInaccessibleUniqueSymbolError: wrapReportedDiagnostic(tracker.reportInaccessibleUniqueSymbolError), reportLikelyUnsafeImportRequiredError: wrapReportedDiagnostic(tracker.reportLikelyUnsafeImportRequiredError), reportNonlocalAugmentation: wrapReportedDiagnostic(tracker.reportNonlocalAugmentation), reportPrivateInBaseOfClassExpression: wrapReportedDiagnostic(tracker.reportPrivateInBaseOfClassExpression), reportNonSerializableProperty: wrapReportedDiagnostic(tracker.reportNonSerializableProperty), trackSymbol: oldTrackSymbol && function() {
              var args = [];
              for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
              }
              var result2 = oldTrackSymbol.apply(void 0, args);
              if (result2) {
                context.reportedDiagnostic = true;
              }
              return result2;
            } });
            function wrapReportedDiagnostic(method) {
              if (!method) {
                return method;
              }
              return function() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                  args[_i] = arguments[_i];
                }
                context.reportedDiagnostic = true;
                return method.apply(void 0, args);
              };
            }
          }
          function checkTruncationLength(context) {
            if (context.truncating)
              return context.truncating;
            return context.truncating = context.approximateLength > (context.flags & 1 ? ts3.noTruncationMaximumTruncationLength : ts3.defaultMaximumTruncationLength);
          }
          function typeToTypeNodeHelper(type2, context) {
            if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
              cancellationToken.throwIfCancellationRequested();
            }
            var inTypeAlias = context.flags & 8388608;
            context.flags &= ~8388608;
            if (!type2) {
              if (!(context.flags & 262144)) {
                context.encounteredError = true;
                return void 0;
              }
              context.approximateLength += 3;
              return ts3.factory.createKeywordTypeNode(130);
            }
            if (!(context.flags & 536870912)) {
              type2 = getReducedType(type2);
            }
            if (type2.flags & 1) {
              if (type2.aliasSymbol) {
                return ts3.factory.createTypeReferenceNode(symbolToEntityNameNode(type2.aliasSymbol), mapToTypeNodes(type2.aliasTypeArguments, context));
              }
              if (type2 === unresolvedType) {
                return ts3.addSyntheticLeadingComment(ts3.factory.createKeywordTypeNode(130), 3, "unresolved");
              }
              context.approximateLength += 3;
              return ts3.factory.createKeywordTypeNode(type2 === intrinsicMarkerType ? 138 : 130);
            }
            if (type2.flags & 2) {
              return ts3.factory.createKeywordTypeNode(155);
            }
            if (type2.flags & 4) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(150);
            }
            if (type2.flags & 8) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(147);
            }
            if (type2.flags & 64) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(158);
            }
            if (type2.flags & 16 && !type2.aliasSymbol) {
              context.approximateLength += 7;
              return ts3.factory.createKeywordTypeNode(133);
            }
            if (type2.flags & 1024 && !(type2.flags & 1048576)) {
              var parentSymbol = getParentOfSymbol(type2.symbol);
              var parentName = symbolToTypeNode(parentSymbol, context, 788968);
              if (getDeclaredTypeOfSymbol(parentSymbol) === type2) {
                return parentName;
              }
              var memberName = ts3.symbolName(type2.symbol);
              if (ts3.isIdentifierText(memberName, 0)) {
                return appendReferenceToType(parentName, ts3.factory.createTypeReferenceNode(memberName, void 0));
              }
              if (ts3.isImportTypeNode(parentName)) {
                parentName.isTypeOf = true;
                return ts3.factory.createIndexedAccessTypeNode(parentName, ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(memberName)));
              } else if (ts3.isTypeReferenceNode(parentName)) {
                return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createTypeQueryNode(parentName.typeName), ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(memberName)));
              } else {
                return ts3.Debug.fail("Unhandled type node kind returned from `symbolToTypeNode`.");
              }
            }
            if (type2.flags & 1056) {
              return symbolToTypeNode(type2.symbol, context, 788968);
            }
            if (type2.flags & 128) {
              context.approximateLength += type2.value.length + 2;
              return ts3.factory.createLiteralTypeNode(ts3.setEmitFlags(ts3.factory.createStringLiteral(type2.value, !!(context.flags & 268435456)), 16777216));
            }
            if (type2.flags & 256) {
              var value = type2.value;
              context.approximateLength += ("" + value).length;
              return ts3.factory.createLiteralTypeNode(value < 0 ? ts3.factory.createPrefixUnaryExpression(40, ts3.factory.createNumericLiteral(-value)) : ts3.factory.createNumericLiteral(value));
            }
            if (type2.flags & 2048) {
              context.approximateLength += ts3.pseudoBigIntToString(type2.value).length + 1;
              return ts3.factory.createLiteralTypeNode(ts3.factory.createBigIntLiteral(type2.value));
            }
            if (type2.flags & 512) {
              context.approximateLength += type2.intrinsicName.length;
              return ts3.factory.createLiteralTypeNode(type2.intrinsicName === "true" ? ts3.factory.createTrue() : ts3.factory.createFalse());
            }
            if (type2.flags & 8192) {
              if (!(context.flags & 1048576)) {
                if (isValueSymbolAccessible(type2.symbol, context.enclosingDeclaration)) {
                  context.approximateLength += 6;
                  return symbolToTypeNode(type2.symbol, context, 111551);
                }
                if (context.tracker.reportInaccessibleUniqueSymbolError) {
                  context.tracker.reportInaccessibleUniqueSymbolError();
                }
              }
              context.approximateLength += 13;
              return ts3.factory.createTypeOperatorNode(154, ts3.factory.createKeywordTypeNode(151));
            }
            if (type2.flags & 16384) {
              context.approximateLength += 4;
              return ts3.factory.createKeywordTypeNode(114);
            }
            if (type2.flags & 32768) {
              context.approximateLength += 9;
              return ts3.factory.createKeywordTypeNode(153);
            }
            if (type2.flags & 65536) {
              context.approximateLength += 4;
              return ts3.factory.createLiteralTypeNode(ts3.factory.createNull());
            }
            if (type2.flags & 131072) {
              context.approximateLength += 5;
              return ts3.factory.createKeywordTypeNode(143);
            }
            if (type2.flags & 4096) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(151);
            }
            if (type2.flags & 67108864) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(148);
            }
            if (ts3.isThisTypeParameter(type2)) {
              if (context.flags & 4194304) {
                if (!context.encounteredError && !(context.flags & 32768)) {
                  context.encounteredError = true;
                }
                if (context.tracker.reportInaccessibleThisError) {
                  context.tracker.reportInaccessibleThisError();
                }
              }
              context.approximateLength += 4;
              return ts3.factory.createThisTypeNode();
            }
            if (!inTypeAlias && type2.aliasSymbol && (context.flags & 16384 || isTypeSymbolAccessible(type2.aliasSymbol, context.enclosingDeclaration))) {
              var typeArgumentNodes = mapToTypeNodes(type2.aliasTypeArguments, context);
              if (isReservedMemberName(type2.aliasSymbol.escapedName) && !(type2.aliasSymbol.flags & 32))
                return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(""), typeArgumentNodes);
              return symbolToTypeNode(type2.aliasSymbol, context, 788968, typeArgumentNodes);
            }
            var objectFlags = ts3.getObjectFlags(type2);
            if (objectFlags & 4) {
              ts3.Debug.assert(!!(type2.flags & 524288));
              return type2.node ? visitAndTransformType(type2, typeReferenceToTypeNode) : typeReferenceToTypeNode(type2);
            }
            if (type2.flags & 262144 || objectFlags & 3) {
              if (type2.flags & 262144 && ts3.contains(context.inferTypeParameters, type2)) {
                context.approximateLength += ts3.symbolName(type2.symbol).length + 6;
                var constraintNode = void 0;
                var constraint = getConstraintOfTypeParameter(type2);
                if (constraint) {
                  var inferredConstraint = getInferredTypeParameterConstraint(type2, true);
                  if (!(inferredConstraint && isTypeIdenticalTo(constraint, inferredConstraint))) {
                    context.approximateLength += 9;
                    constraintNode = constraint && typeToTypeNodeHelper(constraint, context);
                  }
                }
                return ts3.factory.createInferTypeNode(typeParameterToDeclarationWithConstraint(type2, context, constraintNode));
              }
              if (context.flags & 4 && type2.flags & 262144 && !isTypeSymbolAccessible(type2.symbol, context.enclosingDeclaration)) {
                var name_2 = typeParameterToName(type2, context);
                context.approximateLength += ts3.idText(name_2).length;
                return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(ts3.idText(name_2)), void 0);
              }
              if (type2.symbol) {
                return symbolToTypeNode(type2.symbol, context, 788968);
              }
              var name = (type2 === markerSuperType || type2 === markerSubType) && varianceTypeParameter && varianceTypeParameter.symbol ? (type2 === markerSubType ? "sub-" : "super-") + ts3.symbolName(varianceTypeParameter.symbol) : "?";
              return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(name), void 0);
            }
            if (type2.flags & 1048576 && type2.origin) {
              type2 = type2.origin;
            }
            if (type2.flags & (1048576 | 2097152)) {
              var types2 = type2.flags & 1048576 ? formatUnionTypes(type2.types) : type2.types;
              if (ts3.length(types2) === 1) {
                return typeToTypeNodeHelper(types2[0], context);
              }
              var typeNodes = mapToTypeNodes(types2, context, true);
              if (typeNodes && typeNodes.length > 0) {
                return type2.flags & 1048576 ? ts3.factory.createUnionTypeNode(typeNodes) : ts3.factory.createIntersectionTypeNode(typeNodes);
              } else {
                if (!context.encounteredError && !(context.flags & 262144)) {
                  context.encounteredError = true;
                }
                return void 0;
              }
            }
            if (objectFlags & (16 | 32)) {
              ts3.Debug.assert(!!(type2.flags & 524288));
              return createAnonymousTypeNode(type2);
            }
            if (type2.flags & 4194304) {
              var indexedType = type2.type;
              context.approximateLength += 6;
              var indexTypeNode = typeToTypeNodeHelper(indexedType, context);
              return ts3.factory.createTypeOperatorNode(140, indexTypeNode);
            }
            if (type2.flags & 134217728) {
              var texts_1 = type2.texts;
              var types_1 = type2.types;
              var templateHead = ts3.factory.createTemplateHead(texts_1[0]);
              var templateSpans = ts3.factory.createNodeArray(ts3.map(types_1, function(t, i) {
                return ts3.factory.createTemplateLiteralTypeSpan(typeToTypeNodeHelper(t, context), (i < types_1.length - 1 ? ts3.factory.createTemplateMiddle : ts3.factory.createTemplateTail)(texts_1[i + 1]));
              }));
              context.approximateLength += 2;
              return ts3.factory.createTemplateLiteralType(templateHead, templateSpans);
            }
            if (type2.flags & 268435456) {
              var typeNode = typeToTypeNodeHelper(type2.type, context);
              return symbolToTypeNode(type2.symbol, context, 788968, [typeNode]);
            }
            if (type2.flags & 8388608) {
              var objectTypeNode = typeToTypeNodeHelper(type2.objectType, context);
              var indexTypeNode = typeToTypeNodeHelper(type2.indexType, context);
              context.approximateLength += 2;
              return ts3.factory.createIndexedAccessTypeNode(objectTypeNode, indexTypeNode);
            }
            if (type2.flags & 16777216) {
              return visitAndTransformType(type2, function(type3) {
                return conditionalTypeToTypeNode(type3);
              });
            }
            if (type2.flags & 33554432) {
              return typeToTypeNodeHelper(type2.baseType, context);
            }
            return ts3.Debug.fail("Should be unreachable.");
            function conditionalTypeToTypeNode(type3) {
              var checkTypeNode = typeToTypeNodeHelper(type3.checkType, context);
              context.approximateLength += 15;
              if (context.flags & 4 && type3.root.isDistributive && !(type3.checkType.flags & 262144)) {
                var newParam = createTypeParameter(createSymbol(262144, "T"));
                var name2 = typeParameterToName(newParam, context);
                var newTypeVariable = ts3.factory.createTypeReferenceNode(name2);
                context.approximateLength += 37;
                var newMapper = prependTypeMapping(type3.root.checkType, newParam, type3.combinedMapper || type3.mapper);
                var saveInferTypeParameters_1 = context.inferTypeParameters;
                context.inferTypeParameters = type3.root.inferTypeParameters;
                var extendsTypeNode_1 = typeToTypeNodeHelper(instantiateType(type3.root.extendsType, newMapper), context);
                context.inferTypeParameters = saveInferTypeParameters_1;
                var trueTypeNode_1 = typeToTypeNodeOrCircularityElision(instantiateType(getTypeFromTypeNode(type3.root.node.trueType), newMapper));
                var falseTypeNode_1 = typeToTypeNodeOrCircularityElision(instantiateType(getTypeFromTypeNode(type3.root.node.falseType), newMapper));
                return ts3.factory.createConditionalTypeNode(checkTypeNode, ts3.factory.createInferTypeNode(ts3.factory.createTypeParameterDeclaration(void 0, ts3.factory.cloneNode(newTypeVariable.typeName))), ts3.factory.createConditionalTypeNode(ts3.factory.createTypeReferenceNode(ts3.factory.cloneNode(name2)), typeToTypeNodeHelper(type3.checkType, context), ts3.factory.createConditionalTypeNode(newTypeVariable, extendsTypeNode_1, trueTypeNode_1, falseTypeNode_1), ts3.factory.createKeywordTypeNode(143)), ts3.factory.createKeywordTypeNode(143));
              }
              var saveInferTypeParameters = context.inferTypeParameters;
              context.inferTypeParameters = type3.root.inferTypeParameters;
              var extendsTypeNode = typeToTypeNodeHelper(type3.extendsType, context);
              context.inferTypeParameters = saveInferTypeParameters;
              var trueTypeNode = typeToTypeNodeOrCircularityElision(getTrueTypeFromConditionalType(type3));
              var falseTypeNode = typeToTypeNodeOrCircularityElision(getFalseTypeFromConditionalType(type3));
              return ts3.factory.createConditionalTypeNode(checkTypeNode, extendsTypeNode, trueTypeNode, falseTypeNode);
            }
            function typeToTypeNodeOrCircularityElision(type3) {
              var _a, _b, _c;
              if (type3.flags & 1048576) {
                if ((_a = context.visitedTypes) === null || _a === void 0 ? void 0 : _a.has(getTypeId(type3))) {
                  if (!(context.flags & 131072)) {
                    context.encounteredError = true;
                    (_c = (_b = context.tracker) === null || _b === void 0 ? void 0 : _b.reportCyclicStructureError) === null || _c === void 0 ? void 0 : _c.call(_b);
                  }
                  return createElidedInformationPlaceholder(context);
                }
                return visitAndTransformType(type3, function(type4) {
                  return typeToTypeNodeHelper(type4, context);
                });
              }
              return typeToTypeNodeHelper(type3, context);
            }
            function createMappedTypeNodeFromType(type3) {
              ts3.Debug.assert(!!(type3.flags & 524288));
              var readonlyToken = type3.declaration.readonlyToken ? ts3.factory.createToken(type3.declaration.readonlyToken.kind) : void 0;
              var questionToken = type3.declaration.questionToken ? ts3.factory.createToken(type3.declaration.questionToken.kind) : void 0;
              var appropriateConstraintTypeNode;
              var newTypeVariable;
              if (isMappedTypeWithKeyofConstraintDeclaration(type3)) {
                if (!(getModifiersTypeFromMappedType(type3).flags & 262144) && context.flags & 4) {
                  var newParam = createTypeParameter(createSymbol(262144, "T"));
                  var name2 = typeParameterToName(newParam, context);
                  newTypeVariable = ts3.factory.createTypeReferenceNode(name2);
                }
                appropriateConstraintTypeNode = ts3.factory.createTypeOperatorNode(140, newTypeVariable || typeToTypeNodeHelper(getModifiersTypeFromMappedType(type3), context));
              } else {
                appropriateConstraintTypeNode = typeToTypeNodeHelper(getConstraintTypeFromMappedType(type3), context);
              }
              var typeParameterNode = typeParameterToDeclarationWithConstraint(getTypeParameterFromMappedType(type3), context, appropriateConstraintTypeNode);
              var nameTypeNode = type3.declaration.nameType ? typeToTypeNodeHelper(getNameTypeFromMappedType(type3), context) : void 0;
              var templateTypeNode = typeToTypeNodeHelper(removeMissingType(getTemplateTypeFromMappedType(type3), !!(getMappedTypeModifiers(type3) & 4)), context);
              var mappedTypeNode = ts3.factory.createMappedTypeNode(readonlyToken, typeParameterNode, nameTypeNode, questionToken, templateTypeNode, void 0);
              context.approximateLength += 10;
              var result2 = ts3.setEmitFlags(mappedTypeNode, 1);
              if (isMappedTypeWithKeyofConstraintDeclaration(type3) && !(getModifiersTypeFromMappedType(type3).flags & 262144) && context.flags & 4) {
                return ts3.factory.createConditionalTypeNode(typeToTypeNodeHelper(getModifiersTypeFromMappedType(type3), context), ts3.factory.createInferTypeNode(ts3.factory.createTypeParameterDeclaration(void 0, ts3.factory.cloneNode(newTypeVariable.typeName))), result2, ts3.factory.createKeywordTypeNode(143));
              }
              return result2;
            }
            function createAnonymousTypeNode(type3) {
              var _a;
              var typeId = type3.id;
              var symbol = type3.symbol;
              if (symbol) {
                var isInstanceType = isClassInstanceSide(type3) ? 788968 : 111551;
                if (isJSConstructor(symbol.valueDeclaration)) {
                  return symbolToTypeNode(symbol, context, isInstanceType);
                } else if (symbol.flags & 32 && !getBaseTypeVariableOfClass(symbol) && !(symbol.valueDeclaration && symbol.valueDeclaration.kind === 226 && context.flags & 2048) || symbol.flags & (384 | 512) || shouldWriteTypeOfFunctionSymbol()) {
                  return symbolToTypeNode(symbol, context, isInstanceType);
                } else if ((_a = context.visitedTypes) === null || _a === void 0 ? void 0 : _a.has(typeId)) {
                  var typeAlias = getTypeAliasForTypeLiteral(type3);
                  if (typeAlias) {
                    return symbolToTypeNode(typeAlias, context, 788968);
                  } else {
                    return createElidedInformationPlaceholder(context);
                  }
                } else {
                  return visitAndTransformType(type3, createTypeNodeFromObjectType);
                }
              } else {
                return createTypeNodeFromObjectType(type3);
              }
              function shouldWriteTypeOfFunctionSymbol() {
                var _a2;
                var isStaticMethodSymbol = !!(symbol.flags & 8192) && ts3.some(symbol.declarations, function(declaration) {
                  return ts3.isStatic(declaration);
                });
                var isNonLocalFunctionSymbol = !!(symbol.flags & 16) && (symbol.parent || ts3.forEach(symbol.declarations, function(declaration) {
                  return declaration.parent.kind === 305 || declaration.parent.kind === 262;
                }));
                if (isStaticMethodSymbol || isNonLocalFunctionSymbol) {
                  return (!!(context.flags & 4096) || ((_a2 = context.visitedTypes) === null || _a2 === void 0 ? void 0 : _a2.has(typeId))) && (!(context.flags & 8) || isValueSymbolAccessible(symbol, context.enclosingDeclaration));
                }
              }
            }
            function visitAndTransformType(type3, transform) {
              var _a, _b;
              var typeId = type3.id;
              var isConstructorObject = ts3.getObjectFlags(type3) & 16 && type3.symbol && type3.symbol.flags & 32;
              var id = ts3.getObjectFlags(type3) & 4 && type3.node ? "N" + getNodeId(type3.node) : type3.flags & 16777216 ? "N" + getNodeId(type3.root.node) : type3.symbol ? (isConstructorObject ? "+" : "") + getSymbolId(type3.symbol) : void 0;
              if (!context.visitedTypes) {
                context.visitedTypes = new ts3.Set();
              }
              if (id && !context.symbolDepth) {
                context.symbolDepth = new ts3.Map();
              }
              var links = context.enclosingDeclaration && getNodeLinks(context.enclosingDeclaration);
              var key = "".concat(getTypeId(type3), "|").concat(context.flags);
              if (links) {
                links.serializedTypes || (links.serializedTypes = new ts3.Map());
              }
              var cachedResult = (_a = links === null || links === void 0 ? void 0 : links.serializedTypes) === null || _a === void 0 ? void 0 : _a.get(key);
              if (cachedResult) {
                if (cachedResult.truncating) {
                  context.truncating = true;
                }
                context.approximateLength += cachedResult.addedLength;
                return deepCloneOrReuseNode(cachedResult);
              }
              var depth;
              if (id) {
                depth = context.symbolDepth.get(id) || 0;
                if (depth > 10) {
                  return createElidedInformationPlaceholder(context);
                }
                context.symbolDepth.set(id, depth + 1);
              }
              context.visitedTypes.add(typeId);
              var startLength = context.approximateLength;
              var result2 = transform(type3);
              var addedLength = context.approximateLength - startLength;
              if (!context.reportedDiagnostic && !context.encounteredError) {
                if (context.truncating) {
                  result2.truncating = true;
                }
                result2.addedLength = addedLength;
                (_b = links === null || links === void 0 ? void 0 : links.serializedTypes) === null || _b === void 0 ? void 0 : _b.set(key, result2);
              }
              context.visitedTypes.delete(typeId);
              if (id) {
                context.symbolDepth.set(id, depth);
              }
              return result2;
              function deepCloneOrReuseNode(node) {
                if (!ts3.nodeIsSynthesized(node) && ts3.getParseTreeNode(node) === node) {
                  return node;
                }
                return ts3.setTextRange(ts3.factory.cloneNode(ts3.visitEachChild(node, deepCloneOrReuseNode, ts3.nullTransformationContext, deepCloneOrReuseNodes)), node);
              }
              function deepCloneOrReuseNodes(nodes, visitor, test, start, count) {
                if (nodes && nodes.length === 0) {
                  return ts3.setTextRange(ts3.factory.createNodeArray(void 0, nodes.hasTrailingComma), nodes);
                }
                return ts3.visitNodes(nodes, visitor, test, start, count);
              }
            }
            function createTypeNodeFromObjectType(type3) {
              if (isGenericMappedType(type3) || type3.containsError) {
                return createMappedTypeNodeFromType(type3);
              }
              var resolved = resolveStructuredTypeMembers(type3);
              if (!resolved.properties.length && !resolved.indexInfos.length) {
                if (!resolved.callSignatures.length && !resolved.constructSignatures.length) {
                  context.approximateLength += 2;
                  return ts3.setEmitFlags(ts3.factory.createTypeLiteralNode(void 0), 1);
                }
                if (resolved.callSignatures.length === 1 && !resolved.constructSignatures.length) {
                  var signature = resolved.callSignatures[0];
                  var signatureNode = signatureToSignatureDeclarationHelper(signature, 179, context);
                  return signatureNode;
                }
                if (resolved.constructSignatures.length === 1 && !resolved.callSignatures.length) {
                  var signature = resolved.constructSignatures[0];
                  var signatureNode = signatureToSignatureDeclarationHelper(signature, 180, context);
                  return signatureNode;
                }
              }
              var abstractSignatures = ts3.filter(resolved.constructSignatures, function(signature2) {
                return !!(signature2.flags & 4);
              });
              if (ts3.some(abstractSignatures)) {
                var types3 = ts3.map(abstractSignatures, getOrCreateTypeFromSignature);
                var typeElementCount = resolved.callSignatures.length + (resolved.constructSignatures.length - abstractSignatures.length) + resolved.indexInfos.length + (context.flags & 2048 ? ts3.countWhere(resolved.properties, function(p) {
                  return !(p.flags & 4194304);
                }) : ts3.length(resolved.properties));
                if (typeElementCount) {
                  types3.push(getResolvedTypeWithoutAbstractConstructSignatures(resolved));
                }
                return typeToTypeNodeHelper(getIntersectionType(types3), context);
              }
              var savedFlags = context.flags;
              context.flags |= 4194304;
              var members = createTypeNodesFromResolvedType(resolved);
              context.flags = savedFlags;
              var typeLiteralNode = ts3.factory.createTypeLiteralNode(members);
              context.approximateLength += 2;
              ts3.setEmitFlags(typeLiteralNode, context.flags & 1024 ? 0 : 1);
              return typeLiteralNode;
            }
            function typeReferenceToTypeNode(type3) {
              var typeArguments = getTypeArguments(type3);
              if (type3.target === globalArrayType || type3.target === globalReadonlyArrayType) {
                if (context.flags & 2) {
                  var typeArgumentNode = typeToTypeNodeHelper(typeArguments[0], context);
                  return ts3.factory.createTypeReferenceNode(type3.target === globalArrayType ? "Array" : "ReadonlyArray", [typeArgumentNode]);
                }
                var elementType = typeToTypeNodeHelper(typeArguments[0], context);
                var arrayType = ts3.factory.createArrayTypeNode(elementType);
                return type3.target === globalArrayType ? arrayType : ts3.factory.createTypeOperatorNode(145, arrayType);
              } else if (type3.target.objectFlags & 8) {
                typeArguments = ts3.sameMap(typeArguments, function(t, i2) {
                  return removeMissingType(t, !!(type3.target.elementFlags[i2] & 2));
                });
                if (typeArguments.length > 0) {
                  var arity = getTypeReferenceArity(type3);
                  var tupleConstituentNodes = mapToTypeNodes(typeArguments.slice(0, arity), context);
                  if (tupleConstituentNodes) {
                    if (type3.target.labeledElementDeclarations) {
                      for (var i = 0; i < tupleConstituentNodes.length; i++) {
                        var flags = type3.target.elementFlags[i];
                        tupleConstituentNodes[i] = ts3.factory.createNamedTupleMember(flags & 12 ? ts3.factory.createToken(25) : void 0, ts3.factory.createIdentifier(ts3.unescapeLeadingUnderscores(getTupleElementLabel(type3.target.labeledElementDeclarations[i]))), flags & 2 ? ts3.factory.createToken(57) : void 0, flags & 4 ? ts3.factory.createArrayTypeNode(tupleConstituentNodes[i]) : tupleConstituentNodes[i]);
                      }
                    } else {
                      for (var i = 0; i < Math.min(arity, tupleConstituentNodes.length); i++) {
                        var flags = type3.target.elementFlags[i];
                        tupleConstituentNodes[i] = flags & 12 ? ts3.factory.createRestTypeNode(flags & 4 ? ts3.factory.createArrayTypeNode(tupleConstituentNodes[i]) : tupleConstituentNodes[i]) : flags & 2 ? ts3.factory.createOptionalTypeNode(tupleConstituentNodes[i]) : tupleConstituentNodes[i];
                      }
                    }
                    var tupleTypeNode = ts3.setEmitFlags(ts3.factory.createTupleTypeNode(tupleConstituentNodes), 1);
                    return type3.target.readonly ? ts3.factory.createTypeOperatorNode(145, tupleTypeNode) : tupleTypeNode;
                  }
                }
                if (context.encounteredError || context.flags & 524288) {
                  var tupleTypeNode = ts3.setEmitFlags(ts3.factory.createTupleTypeNode([]), 1);
                  return type3.target.readonly ? ts3.factory.createTypeOperatorNode(145, tupleTypeNode) : tupleTypeNode;
                }
                context.encounteredError = true;
                return void 0;
              } else if (context.flags & 2048 && type3.symbol.valueDeclaration && ts3.isClassLike(type3.symbol.valueDeclaration) && !isValueSymbolAccessible(type3.symbol, context.enclosingDeclaration)) {
                return createAnonymousTypeNode(type3);
              } else {
                var outerTypeParameters = type3.target.outerTypeParameters;
                var i = 0;
                var resultType = void 0;
                if (outerTypeParameters) {
                  var length_2 = outerTypeParameters.length;
                  while (i < length_2) {
                    var start = i;
                    var parent = getParentSymbolOfTypeParameter(outerTypeParameters[i]);
                    do {
                      i++;
                    } while (i < length_2 && getParentSymbolOfTypeParameter(outerTypeParameters[i]) === parent);
                    if (!ts3.rangeEquals(outerTypeParameters, typeArguments, start, i)) {
                      var typeArgumentSlice = mapToTypeNodes(typeArguments.slice(start, i), context);
                      var flags_3 = context.flags;
                      context.flags |= 16;
                      var ref = symbolToTypeNode(parent, context, 788968, typeArgumentSlice);
                      context.flags = flags_3;
                      resultType = !resultType ? ref : appendReferenceToType(resultType, ref);
                    }
                  }
                }
                var typeArgumentNodes2 = void 0;
                if (typeArguments.length > 0) {
                  var typeParameterCount = (type3.target.typeParameters || ts3.emptyArray).length;
                  typeArgumentNodes2 = mapToTypeNodes(typeArguments.slice(i, typeParameterCount), context);
                }
                var flags = context.flags;
                context.flags |= 16;
                var finalRef = symbolToTypeNode(type3.symbol, context, 788968, typeArgumentNodes2);
                context.flags = flags;
                return !resultType ? finalRef : appendReferenceToType(resultType, finalRef);
              }
            }
            function appendReferenceToType(root, ref) {
              if (ts3.isImportTypeNode(root)) {
                var typeArguments = root.typeArguments;
                var qualifier = root.qualifier;
                if (qualifier) {
                  if (ts3.isIdentifier(qualifier)) {
                    qualifier = ts3.factory.updateIdentifier(qualifier, typeArguments);
                  } else {
                    qualifier = ts3.factory.updateQualifiedName(qualifier, qualifier.left, ts3.factory.updateIdentifier(qualifier.right, typeArguments));
                  }
                }
                typeArguments = ref.typeArguments;
                var ids = getAccessStack(ref);
                for (var _i = 0, ids_1 = ids; _i < ids_1.length; _i++) {
                  var id = ids_1[_i];
                  qualifier = qualifier ? ts3.factory.createQualifiedName(qualifier, id) : id;
                }
                return ts3.factory.updateImportTypeNode(root, root.argument, qualifier, typeArguments, root.isTypeOf);
              } else {
                var typeArguments = root.typeArguments;
                var typeName = root.typeName;
                if (ts3.isIdentifier(typeName)) {
                  typeName = ts3.factory.updateIdentifier(typeName, typeArguments);
                } else {
                  typeName = ts3.factory.updateQualifiedName(typeName, typeName.left, ts3.factory.updateIdentifier(typeName.right, typeArguments));
                }
                typeArguments = ref.typeArguments;
                var ids = getAccessStack(ref);
                for (var _a = 0, ids_2 = ids; _a < ids_2.length; _a++) {
                  var id = ids_2[_a];
                  typeName = ts3.factory.createQualifiedName(typeName, id);
                }
                return ts3.factory.updateTypeReferenceNode(root, typeName, typeArguments);
              }
            }
            function getAccessStack(ref) {
              var state = ref.typeName;
              var ids = [];
              while (!ts3.isIdentifier(state)) {
                ids.unshift(state.right);
                state = state.left;
              }
              ids.unshift(state);
              return ids;
            }
            function createTypeNodesFromResolvedType(resolvedType) {
              if (checkTruncationLength(context)) {
                return [ts3.factory.createPropertySignature(void 0, "...", void 0, void 0)];
              }
              var typeElements = [];
              for (var _i = 0, _a = resolvedType.callSignatures; _i < _a.length; _i++) {
                var signature = _a[_i];
                typeElements.push(signatureToSignatureDeclarationHelper(signature, 174, context));
              }
              for (var _b = 0, _c = resolvedType.constructSignatures; _b < _c.length; _b++) {
                var signature = _c[_b];
                if (signature.flags & 4)
                  continue;
                typeElements.push(signatureToSignatureDeclarationHelper(signature, 175, context));
              }
              for (var _d = 0, _e = resolvedType.indexInfos; _d < _e.length; _d++) {
                var info = _e[_d];
                typeElements.push(indexInfoToIndexSignatureDeclarationHelper(info, context, resolvedType.objectFlags & 1024 ? createElidedInformationPlaceholder(context) : void 0));
              }
              var properties = resolvedType.properties;
              if (!properties) {
                return typeElements;
              }
              var i = 0;
              for (var _f = 0, properties_1 = properties; _f < properties_1.length; _f++) {
                var propertySymbol = properties_1[_f];
                i++;
                if (context.flags & 2048) {
                  if (propertySymbol.flags & 4194304) {
                    continue;
                  }
                  if (ts3.getDeclarationModifierFlagsFromSymbol(propertySymbol) & (8 | 16) && context.tracker.reportPrivateInBaseOfClassExpression) {
                    context.tracker.reportPrivateInBaseOfClassExpression(ts3.unescapeLeadingUnderscores(propertySymbol.escapedName));
                  }
                }
                if (checkTruncationLength(context) && i + 2 < properties.length - 1) {
                  typeElements.push(ts3.factory.createPropertySignature(void 0, "... ".concat(properties.length - i, " more ..."), void 0, void 0));
                  addPropertyToElementList(properties[properties.length - 1], context, typeElements);
                  break;
                }
                addPropertyToElementList(propertySymbol, context, typeElements);
              }
              return typeElements.length ? typeElements : void 0;
            }
          }
          function createElidedInformationPlaceholder(context) {
            context.approximateLength += 3;
            if (!(context.flags & 1)) {
              return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier("..."), void 0);
            }
            return ts3.factory.createKeywordTypeNode(130);
          }
          function shouldUsePlaceholderForProperty(propertySymbol, context) {
            var _a;
            return !!(ts3.getCheckFlags(propertySymbol) & 8192) && (ts3.contains(context.reverseMappedStack, propertySymbol) || ((_a = context.reverseMappedStack) === null || _a === void 0 ? void 0 : _a[0]) && !(ts3.getObjectFlags(ts3.last(context.reverseMappedStack).propertyType) & 16));
          }
          function addPropertyToElementList(propertySymbol, context, typeElements) {
            var _a, _b;
            var propertyIsReverseMapped = !!(ts3.getCheckFlags(propertySymbol) & 8192);
            var propertyType = shouldUsePlaceholderForProperty(propertySymbol, context) ? anyType : getNonMissingTypeOfSymbol(propertySymbol);
            var saveEnclosingDeclaration = context.enclosingDeclaration;
            context.enclosingDeclaration = void 0;
            if (context.tracker.trackSymbol && ts3.getCheckFlags(propertySymbol) & 4096 && isLateBoundName(propertySymbol.escapedName)) {
              if (propertySymbol.declarations) {
                var decl = ts3.first(propertySymbol.declarations);
                if (hasLateBindableName(decl)) {
                  if (ts3.isBinaryExpression(decl)) {
                    var name = ts3.getNameOfDeclaration(decl);
                    if (name && ts3.isElementAccessExpression(name) && ts3.isPropertyAccessEntityNameExpression(name.argumentExpression)) {
                      trackComputedName(name.argumentExpression, saveEnclosingDeclaration, context);
                    }
                  } else {
                    trackComputedName(decl.name.expression, saveEnclosingDeclaration, context);
                  }
                }
              } else if ((_a = context.tracker) === null || _a === void 0 ? void 0 : _a.reportNonSerializableProperty) {
                context.tracker.reportNonSerializableProperty(symbolToString(propertySymbol));
              }
            }
            context.enclosingDeclaration = propertySymbol.valueDeclaration || ((_b = propertySymbol.declarations) === null || _b === void 0 ? void 0 : _b[0]) || saveEnclosingDeclaration;
            var propertyName = getPropertyNameNodeForSymbol(propertySymbol, context);
            context.enclosingDeclaration = saveEnclosingDeclaration;
            context.approximateLength += ts3.symbolName(propertySymbol).length + 1;
            var optionalToken = propertySymbol.flags & 16777216 ? ts3.factory.createToken(57) : void 0;
            if (propertySymbol.flags & (16 | 8192) && !getPropertiesOfObjectType(propertyType).length && !isReadonlySymbol(propertySymbol)) {
              var signatures = getSignaturesOfType(filterType(propertyType, function(t) {
                return !(t.flags & 32768);
              }), 0);
              for (var _i = 0, signatures_1 = signatures; _i < signatures_1.length; _i++) {
                var signature = signatures_1[_i];
                var methodDeclaration = signatureToSignatureDeclarationHelper(signature, 168, context, { name: propertyName, questionToken: optionalToken });
                typeElements.push(preserveCommentsOn(methodDeclaration));
              }
            } else {
              var propertyTypeNode = void 0;
              if (shouldUsePlaceholderForProperty(propertySymbol, context)) {
                propertyTypeNode = createElidedInformationPlaceholder(context);
              } else {
                if (propertyIsReverseMapped) {
                  context.reverseMappedStack || (context.reverseMappedStack = []);
                  context.reverseMappedStack.push(propertySymbol);
                }
                propertyTypeNode = propertyType ? serializeTypeForDeclaration(context, propertyType, propertySymbol, saveEnclosingDeclaration) : ts3.factory.createKeywordTypeNode(130);
                if (propertyIsReverseMapped) {
                  context.reverseMappedStack.pop();
                }
              }
              var modifiers = isReadonlySymbol(propertySymbol) ? [ts3.factory.createToken(145)] : void 0;
              if (modifiers) {
                context.approximateLength += 9;
              }
              var propertySignature = ts3.factory.createPropertySignature(modifiers, propertyName, optionalToken, propertyTypeNode);
              typeElements.push(preserveCommentsOn(propertySignature));
            }
            function preserveCommentsOn(node) {
              var _a2;
              if (ts3.some(propertySymbol.declarations, function(d2) {
                return d2.kind === 347;
              })) {
                var d = (_a2 = propertySymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(d2) {
                  return d2.kind === 347;
                });
                var commentText = ts3.getTextOfJSDocComment(d.comment);
                if (commentText) {
                  ts3.setSyntheticLeadingComments(node, [{ kind: 3, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]);
                }
              } else if (propertySymbol.valueDeclaration) {
                ts3.setCommentRange(node, propertySymbol.valueDeclaration);
              }
              return node;
            }
          }
          function mapToTypeNodes(types2, context, isBareList) {
            if (ts3.some(types2)) {
              if (checkTruncationLength(context)) {
                if (!isBareList) {
                  return [ts3.factory.createTypeReferenceNode("...", void 0)];
                } else if (types2.length > 2) {
                  return [
                    typeToTypeNodeHelper(types2[0], context),
                    ts3.factory.createTypeReferenceNode("... ".concat(types2.length - 2, " more ..."), void 0),
                    typeToTypeNodeHelper(types2[types2.length - 1], context)
                  ];
                }
              }
              var mayHaveNameCollisions = !(context.flags & 64);
              var seenNames = mayHaveNameCollisions ? ts3.createUnderscoreEscapedMultiMap() : void 0;
              var result_5 = [];
              var i = 0;
              for (var _i = 0, types_2 = types2; _i < types_2.length; _i++) {
                var type2 = types_2[_i];
                i++;
                if (checkTruncationLength(context) && i + 2 < types2.length - 1) {
                  result_5.push(ts3.factory.createTypeReferenceNode("... ".concat(types2.length - i, " more ..."), void 0));
                  var typeNode_1 = typeToTypeNodeHelper(types2[types2.length - 1], context);
                  if (typeNode_1) {
                    result_5.push(typeNode_1);
                  }
                  break;
                }
                context.approximateLength += 2;
                var typeNode = typeToTypeNodeHelper(type2, context);
                if (typeNode) {
                  result_5.push(typeNode);
                  if (seenNames && ts3.isIdentifierTypeReference(typeNode)) {
                    seenNames.add(typeNode.typeName.escapedText, [type2, result_5.length - 1]);
                  }
                }
              }
              if (seenNames) {
                var saveContextFlags = context.flags;
                context.flags |= 64;
                seenNames.forEach(function(types3) {
                  if (!ts3.arrayIsHomogeneous(types3, function(_a2, _b) {
                    var a = _a2[0];
                    var b = _b[0];
                    return typesAreSameReference(a, b);
                  })) {
                    for (var _i2 = 0, types_3 = types3; _i2 < types_3.length; _i2++) {
                      var _a = types_3[_i2], type3 = _a[0], resultIndex = _a[1];
                      result_5[resultIndex] = typeToTypeNodeHelper(type3, context);
                    }
                  }
                });
                context.flags = saveContextFlags;
              }
              return result_5;
            }
          }
          function typesAreSameReference(a, b) {
            return a === b || !!a.symbol && a.symbol === b.symbol || !!a.aliasSymbol && a.aliasSymbol === b.aliasSymbol;
          }
          function indexInfoToIndexSignatureDeclarationHelper(indexInfo, context, typeNode) {
            var name = ts3.getNameFromIndexInfo(indexInfo) || "x";
            var indexerTypeNode = typeToTypeNodeHelper(indexInfo.keyType, context);
            var indexingParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, name, void 0, indexerTypeNode, void 0);
            if (!typeNode) {
              typeNode = typeToTypeNodeHelper(indexInfo.type || anyType, context);
            }
            if (!indexInfo.type && !(context.flags & 2097152)) {
              context.encounteredError = true;
            }
            context.approximateLength += name.length + 4;
            return ts3.factory.createIndexSignature(void 0, indexInfo.isReadonly ? [ts3.factory.createToken(145)] : void 0, [indexingParameter], typeNode);
          }
          function signatureToSignatureDeclarationHelper(signature, kind, context, options) {
            var _a, _b, _c, _d;
            var suppressAny = context.flags & 256;
            if (suppressAny)
              context.flags &= ~256;
            context.approximateLength += 3;
            var typeParameters;
            var typeArguments;
            if (context.flags & 32 && signature.target && signature.mapper && signature.target.typeParameters) {
              typeArguments = signature.target.typeParameters.map(function(parameter) {
                return typeToTypeNodeHelper(instantiateType(parameter, signature.mapper), context);
              });
            } else {
              typeParameters = signature.typeParameters && signature.typeParameters.map(function(parameter) {
                return typeParameterToDeclaration(parameter, context);
              });
            }
            var expandedParams = getExpandedParameters(signature, true)[0];
            var parameters = (ts3.some(expandedParams, function(p) {
              return p !== expandedParams[expandedParams.length - 1] && !!(ts3.getCheckFlags(p) & 32768);
            }) ? signature.parameters : expandedParams).map(function(parameter) {
              return symbolToParameterDeclaration(parameter, context, kind === 171, options === null || options === void 0 ? void 0 : options.privateSymbolVisitor, options === null || options === void 0 ? void 0 : options.bundledImports);
            });
            var thisParameter = tryGetThisParameterDeclaration(signature, context);
            if (thisParameter) {
              parameters.unshift(thisParameter);
            }
            var returnTypeNode;
            var typePredicate = getTypePredicateOfSignature(signature);
            if (typePredicate) {
              var assertsModifier = typePredicate.kind === 2 || typePredicate.kind === 3 ? ts3.factory.createToken(128) : void 0;
              var parameterName = typePredicate.kind === 1 || typePredicate.kind === 3 ? ts3.setEmitFlags(ts3.factory.createIdentifier(typePredicate.parameterName), 16777216) : ts3.factory.createThisTypeNode();
              var typeNode = typePredicate.type && typeToTypeNodeHelper(typePredicate.type, context);
              returnTypeNode = ts3.factory.createTypePredicateNode(assertsModifier, parameterName, typeNode);
            } else {
              var returnType = getReturnTypeOfSignature(signature);
              if (returnType && !(suppressAny && isTypeAny(returnType))) {
                returnTypeNode = serializeReturnTypeForSignature(context, returnType, signature, options === null || options === void 0 ? void 0 : options.privateSymbolVisitor, options === null || options === void 0 ? void 0 : options.bundledImports);
              } else if (!suppressAny) {
                returnTypeNode = ts3.factory.createKeywordTypeNode(130);
              }
            }
            var modifiers = options === null || options === void 0 ? void 0 : options.modifiers;
            if (kind === 180 && signature.flags & 4) {
              var flags = ts3.modifiersToFlags(modifiers);
              modifiers = ts3.factory.createModifiersFromModifierFlags(flags | 128);
            }
            var node = kind === 174 ? ts3.factory.createCallSignature(typeParameters, parameters, returnTypeNode) : kind === 175 ? ts3.factory.createConstructSignature(typeParameters, parameters, returnTypeNode) : kind === 168 ? ts3.factory.createMethodSignature(modifiers, (_a = options === null || options === void 0 ? void 0 : options.name) !== null && _a !== void 0 ? _a : ts3.factory.createIdentifier(""), options === null || options === void 0 ? void 0 : options.questionToken, typeParameters, parameters, returnTypeNode) : kind === 169 ? ts3.factory.createMethodDeclaration(void 0, modifiers, void 0, (_b = options === null || options === void 0 ? void 0 : options.name) !== null && _b !== void 0 ? _b : ts3.factory.createIdentifier(""), void 0, typeParameters, parameters, returnTypeNode, void 0) : kind === 171 ? ts3.factory.createConstructorDeclaration(void 0, modifiers, parameters, void 0) : kind === 172 ? ts3.factory.createGetAccessorDeclaration(void 0, modifiers, (_c = options === null || options === void 0 ? void 0 : options.name) !== null && _c !== void 0 ? _c : ts3.factory.createIdentifier(""), parameters, returnTypeNode, void 0) : kind === 173 ? ts3.factory.createSetAccessorDeclaration(void 0, modifiers, (_d = options === null || options === void 0 ? void 0 : options.name) !== null && _d !== void 0 ? _d : ts3.factory.createIdentifier(""), parameters, void 0) : kind === 176 ? ts3.factory.createIndexSignature(void 0, modifiers, parameters, returnTypeNode) : kind === 317 ? ts3.factory.createJSDocFunctionType(parameters, returnTypeNode) : kind === 179 ? ts3.factory.createFunctionTypeNode(typeParameters, parameters, returnTypeNode !== null && returnTypeNode !== void 0 ? returnTypeNode : ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(""))) : kind === 180 ? ts3.factory.createConstructorTypeNode(modifiers, typeParameters, parameters, returnTypeNode !== null && returnTypeNode !== void 0 ? returnTypeNode : ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(""))) : kind === 256 ? ts3.factory.createFunctionDeclaration(void 0, modifiers, void 0, (options === null || options === void 0 ? void 0 : options.name) ? ts3.cast(options.name, ts3.isIdentifier) : ts3.factory.createIdentifier(""), typeParameters, parameters, returnTypeNode, void 0) : kind === 213 ? ts3.factory.createFunctionExpression(modifiers, void 0, (options === null || options === void 0 ? void 0 : options.name) ? ts3.cast(options.name, ts3.isIdentifier) : ts3.factory.createIdentifier(""), typeParameters, parameters, returnTypeNode, ts3.factory.createBlock([])) : kind === 214 ? ts3.factory.createArrowFunction(modifiers, typeParameters, parameters, returnTypeNode, void 0, ts3.factory.createBlock([])) : ts3.Debug.assertNever(kind);
            if (typeArguments) {
              node.typeArguments = ts3.factory.createNodeArray(typeArguments);
            }
            return node;
          }
          function tryGetThisParameterDeclaration(signature, context) {
            if (signature.thisParameter) {
              return symbolToParameterDeclaration(signature.thisParameter, context);
            }
            if (signature.declaration) {
              var thisTag = ts3.getJSDocThisTag(signature.declaration);
              if (thisTag && thisTag.typeExpression) {
                return ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, typeToTypeNodeHelper(getTypeFromTypeNode(thisTag.typeExpression), context));
              }
            }
          }
          function typeParameterToDeclarationWithConstraint(type2, context, constraintNode) {
            var savedContextFlags = context.flags;
            context.flags &= ~512;
            var modifiers = ts3.factory.createModifiersFromModifierFlags(getVarianceModifiers(type2));
            var name = typeParameterToName(type2, context);
            var defaultParameter = getDefaultFromTypeParameter(type2);
            var defaultParameterNode = defaultParameter && typeToTypeNodeHelper(defaultParameter, context);
            context.flags = savedContextFlags;
            return ts3.factory.createTypeParameterDeclaration(modifiers, name, constraintNode, defaultParameterNode);
          }
          function typeParameterToDeclaration(type2, context, constraint) {
            if (constraint === void 0) {
              constraint = getConstraintOfTypeParameter(type2);
            }
            var constraintNode = constraint && typeToTypeNodeHelper(constraint, context);
            return typeParameterToDeclarationWithConstraint(type2, context, constraintNode);
          }
          function symbolToParameterDeclaration(parameterSymbol, context, preserveModifierFlags, privateSymbolVisitor, bundledImports) {
            var parameterDeclaration = ts3.getDeclarationOfKind(parameterSymbol, 164);
            if (!parameterDeclaration && !ts3.isTransientSymbol(parameterSymbol)) {
              parameterDeclaration = ts3.getDeclarationOfKind(parameterSymbol, 340);
            }
            var parameterType = getTypeOfSymbol(parameterSymbol);
            if (parameterDeclaration && isRequiredInitializedParameter(parameterDeclaration)) {
              parameterType = getOptionalType(parameterType);
            }
            var parameterTypeNode = serializeTypeForDeclaration(context, parameterType, parameterSymbol, context.enclosingDeclaration, privateSymbolVisitor, bundledImports);
            var modifiers = !(context.flags & 8192) && preserveModifierFlags && parameterDeclaration && parameterDeclaration.modifiers ? parameterDeclaration.modifiers.map(ts3.factory.cloneNode) : void 0;
            var isRest = parameterDeclaration && ts3.isRestParameter(parameterDeclaration) || ts3.getCheckFlags(parameterSymbol) & 32768;
            var dotDotDotToken = isRest ? ts3.factory.createToken(25) : void 0;
            var name = parameterDeclaration ? parameterDeclaration.name ? parameterDeclaration.name.kind === 79 ? ts3.setEmitFlags(ts3.factory.cloneNode(parameterDeclaration.name), 16777216) : parameterDeclaration.name.kind === 161 ? ts3.setEmitFlags(ts3.factory.cloneNode(parameterDeclaration.name.right), 16777216) : cloneBindingName(parameterDeclaration.name) : ts3.symbolName(parameterSymbol) : ts3.symbolName(parameterSymbol);
            var isOptional = parameterDeclaration && isOptionalParameter(parameterDeclaration) || ts3.getCheckFlags(parameterSymbol) & 16384;
            var questionToken = isOptional ? ts3.factory.createToken(57) : void 0;
            var parameterNode = ts3.factory.createParameterDeclaration(void 0, modifiers, dotDotDotToken, name, questionToken, parameterTypeNode, void 0);
            context.approximateLength += ts3.symbolName(parameterSymbol).length + 3;
            return parameterNode;
            function cloneBindingName(node) {
              return elideInitializerAndSetEmitFlags(node);
              function elideInitializerAndSetEmitFlags(node2) {
                if (context.tracker.trackSymbol && ts3.isComputedPropertyName(node2) && isLateBindableName(node2)) {
                  trackComputedName(node2.expression, context.enclosingDeclaration, context);
                }
                var visited = ts3.visitEachChild(node2, elideInitializerAndSetEmitFlags, ts3.nullTransformationContext, void 0, elideInitializerAndSetEmitFlags);
                if (ts3.isBindingElement(visited)) {
                  visited = ts3.factory.updateBindingElement(visited, visited.dotDotDotToken, visited.propertyName, visited.name, void 0);
                }
                if (!ts3.nodeIsSynthesized(visited)) {
                  visited = ts3.factory.cloneNode(visited);
                }
                return ts3.setEmitFlags(visited, 1 | 16777216);
              }
            }
          }
          function trackComputedName(accessExpression, enclosingDeclaration, context) {
            if (!context.tracker.trackSymbol)
              return;
            var firstIdentifier = ts3.getFirstIdentifier(accessExpression);
            var name = resolveName(firstIdentifier, firstIdentifier.escapedText, 111551 | 1048576, void 0, void 0, true);
            if (name) {
              context.tracker.trackSymbol(name, enclosingDeclaration, 111551);
            }
          }
          function lookupSymbolChain(symbol, context, meaning, yieldModuleSymbol) {
            context.tracker.trackSymbol(symbol, context.enclosingDeclaration, meaning);
            return lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol);
          }
          function lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol) {
            var chain;
            var isTypeParameter = symbol.flags & 262144;
            if (!isTypeParameter && (context.enclosingDeclaration || context.flags & 64) && !(context.flags & 134217728)) {
              chain = ts3.Debug.checkDefined(getSymbolChain(symbol, meaning, true));
              ts3.Debug.assert(chain && chain.length > 0);
            } else {
              chain = [symbol];
            }
            return chain;
            function getSymbolChain(symbol2, meaning2, endOfChain) {
              var accessibleSymbolChain = getAccessibleSymbolChain(symbol2, context.enclosingDeclaration, meaning2, !!(context.flags & 128));
              var parentSpecifiers;
              if (!accessibleSymbolChain || needsQualification(accessibleSymbolChain[0], context.enclosingDeclaration, accessibleSymbolChain.length === 1 ? meaning2 : getQualifiedLeftMeaning(meaning2))) {
                var parents_1 = getContainersOfSymbol(accessibleSymbolChain ? accessibleSymbolChain[0] : symbol2, context.enclosingDeclaration, meaning2);
                if (ts3.length(parents_1)) {
                  parentSpecifiers = parents_1.map(function(symbol3) {
                    return ts3.some(symbol3.declarations, hasNonGlobalAugmentationExternalModuleSymbol) ? getSpecifierForModuleSymbol(symbol3, context) : void 0;
                  });
                  var indices = parents_1.map(function(_, i) {
                    return i;
                  });
                  indices.sort(sortByBestName);
                  var sortedParents = indices.map(function(i) {
                    return parents_1[i];
                  });
                  for (var _i = 0, sortedParents_1 = sortedParents; _i < sortedParents_1.length; _i++) {
                    var parent = sortedParents_1[_i];
                    var parentChain = getSymbolChain(parent, getQualifiedLeftMeaning(meaning2), false);
                    if (parentChain) {
                      if (parent.exports && parent.exports.get("export=") && getSymbolIfSameReference(parent.exports.get("export="), symbol2)) {
                        accessibleSymbolChain = parentChain;
                        break;
                      }
                      accessibleSymbolChain = parentChain.concat(accessibleSymbolChain || [getAliasForSymbolInContainer(parent, symbol2) || symbol2]);
                      break;
                    }
                  }
                }
              }
              if (accessibleSymbolChain) {
                return accessibleSymbolChain;
              }
              if (endOfChain || !(symbol2.flags & (2048 | 4096))) {
                if (!endOfChain && !yieldModuleSymbol && !!ts3.forEach(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                  return;
                }
                return [symbol2];
              }
              function sortByBestName(a, b) {
                var specifierA = parentSpecifiers[a];
                var specifierB = parentSpecifiers[b];
                if (specifierA && specifierB) {
                  var isBRelative = ts3.pathIsRelative(specifierB);
                  if (ts3.pathIsRelative(specifierA) === isBRelative) {
                    return ts3.moduleSpecifiers.countPathComponents(specifierA) - ts3.moduleSpecifiers.countPathComponents(specifierB);
                  }
                  if (isBRelative) {
                    return -1;
                  }
                  return 1;
                }
                return 0;
              }
            }
          }
          function typeParametersToTypeParameterDeclarations(symbol, context) {
            var typeParameterNodes;
            var targetSymbol = getTargetSymbol(symbol);
            if (targetSymbol.flags & (32 | 64 | 524288)) {
              typeParameterNodes = ts3.factory.createNodeArray(ts3.map(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol), function(tp) {
                return typeParameterToDeclaration(tp, context);
              }));
            }
            return typeParameterNodes;
          }
          function lookupTypeParameterNodes(chain, index, context) {
            var _a;
            ts3.Debug.assert(chain && 0 <= index && index < chain.length);
            var symbol = chain[index];
            var symbolId = getSymbolId(symbol);
            if ((_a = context.typeParameterSymbolList) === null || _a === void 0 ? void 0 : _a.has(symbolId)) {
              return void 0;
            }
            (context.typeParameterSymbolList || (context.typeParameterSymbolList = new ts3.Set())).add(symbolId);
            var typeParameterNodes;
            if (context.flags & 512 && index < chain.length - 1) {
              var parentSymbol = symbol;
              var nextSymbol_1 = chain[index + 1];
              if (ts3.getCheckFlags(nextSymbol_1) & 1) {
                var params = getTypeParametersOfClassOrInterface(parentSymbol.flags & 2097152 ? resolveAlias(parentSymbol) : parentSymbol);
                typeParameterNodes = mapToTypeNodes(ts3.map(params, function(t) {
                  return getMappedType(t, nextSymbol_1.mapper);
                }), context);
              } else {
                typeParameterNodes = typeParametersToTypeParameterDeclarations(symbol, context);
              }
            }
            return typeParameterNodes;
          }
          function getTopmostIndexedAccessType(top) {
            if (ts3.isIndexedAccessTypeNode(top.objectType)) {
              return getTopmostIndexedAccessType(top.objectType);
            }
            return top;
          }
          function getSpecifierForModuleSymbol(symbol, context, overrideImportMode) {
            var _a;
            var file = ts3.getDeclarationOfKind(symbol, 305);
            if (!file) {
              var equivalentFileSymbol = ts3.firstDefined(symbol.declarations, function(d) {
                return getFileSymbolIfFileSymbolExportEqualsContainer(d, symbol);
              });
              if (equivalentFileSymbol) {
                file = ts3.getDeclarationOfKind(equivalentFileSymbol, 305);
              }
            }
            if (file && file.moduleName !== void 0) {
              return file.moduleName;
            }
            if (!file) {
              if (context.tracker.trackReferencedAmbientModule) {
                var ambientDecls = ts3.filter(symbol.declarations, ts3.isAmbientModule);
                if (ts3.length(ambientDecls)) {
                  for (var _i = 0, _b = ambientDecls; _i < _b.length; _i++) {
                    var decl = _b[_i];
                    context.tracker.trackReferencedAmbientModule(decl, symbol);
                  }
                }
              }
              if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
                return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
              }
            }
            if (!context.enclosingDeclaration || !context.tracker.moduleResolverHost) {
              if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
                return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
              }
              return ts3.getSourceFileOfNode(ts3.getNonAugmentationDeclaration(symbol)).fileName;
            }
            var contextFile = ts3.getSourceFileOfNode(ts3.getOriginalNode(context.enclosingDeclaration));
            var resolutionMode = overrideImportMode || (contextFile === null || contextFile === void 0 ? void 0 : contextFile.impliedNodeFormat);
            var cacheKey = getSpecifierCacheKey(contextFile.path, resolutionMode);
            var links = getSymbolLinks(symbol);
            var specifier = links.specifierCache && links.specifierCache.get(cacheKey);
            if (!specifier) {
              var isBundle_1 = !!ts3.outFile(compilerOptions);
              var moduleResolverHost = context.tracker.moduleResolverHost;
              var specifierCompilerOptions = isBundle_1 ? __assign(__assign({}, compilerOptions), { baseUrl: moduleResolverHost.getCommonSourceDirectory() }) : compilerOptions;
              specifier = ts3.first(ts3.moduleSpecifiers.getModuleSpecifiers(symbol, checker, specifierCompilerOptions, contextFile, moduleResolverHost, {
                importModuleSpecifierPreference: isBundle_1 ? "non-relative" : "project-relative",
                importModuleSpecifierEnding: isBundle_1 ? "minimal" : resolutionMode === ts3.ModuleKind.ESNext ? "js" : void 0
              }, { overrideImportMode }));
              (_a = links.specifierCache) !== null && _a !== void 0 ? _a : links.specifierCache = new ts3.Map();
              links.specifierCache.set(cacheKey, specifier);
            }
            return specifier;
            function getSpecifierCacheKey(path2, mode) {
              return mode === void 0 ? path2 : "".concat(mode, "|").concat(path2);
            }
          }
          function symbolToEntityNameNode(symbol) {
            var identifier = ts3.factory.createIdentifier(ts3.unescapeLeadingUnderscores(symbol.escapedName));
            return symbol.parent ? ts3.factory.createQualifiedName(symbolToEntityNameNode(symbol.parent), identifier) : identifier;
          }
          function symbolToTypeNode(symbol, context, meaning, overrideTypeArguments) {
            var _a, _b, _c, _d;
            var chain = lookupSymbolChain(symbol, context, meaning, !(context.flags & 16384));
            var isTypeOf = meaning === 111551;
            if (ts3.some(chain[0].declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
              var nonRootParts = chain.length > 1 ? createAccessFromSymbolChain(chain, chain.length - 1, 1) : void 0;
              var typeParameterNodes = overrideTypeArguments || lookupTypeParameterNodes(chain, 0, context);
              var contextFile = ts3.getSourceFileOfNode(ts3.getOriginalNode(context.enclosingDeclaration));
              var targetFile = ts3.getSourceFileOfModule(chain[0]);
              var specifier = void 0;
              var assertion = void 0;
              if (ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeNext) {
                if ((targetFile === null || targetFile === void 0 ? void 0 : targetFile.impliedNodeFormat) === ts3.ModuleKind.ESNext && targetFile.impliedNodeFormat !== (contextFile === null || contextFile === void 0 ? void 0 : contextFile.impliedNodeFormat)) {
                  specifier = getSpecifierForModuleSymbol(chain[0], context, ts3.ModuleKind.ESNext);
                  assertion = ts3.factory.createImportTypeAssertionContainer(ts3.factory.createAssertClause(ts3.factory.createNodeArray([
                    ts3.factory.createAssertEntry(ts3.factory.createStringLiteral("resolution-mode"), ts3.factory.createStringLiteral("import"))
                  ])));
                  (_b = (_a = context.tracker).reportImportTypeNodeResolutionModeOverride) === null || _b === void 0 ? void 0 : _b.call(_a);
                }
              }
              if (!specifier) {
                specifier = getSpecifierForModuleSymbol(chain[0], context);
              }
              if (!(context.flags & 67108864) && ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.Classic && specifier.indexOf("/node_modules/") >= 0) {
                var oldSpecifier = specifier;
                if (ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeNext) {
                  var swappedMode = (contextFile === null || contextFile === void 0 ? void 0 : contextFile.impliedNodeFormat) === ts3.ModuleKind.ESNext ? ts3.ModuleKind.CommonJS : ts3.ModuleKind.ESNext;
                  specifier = getSpecifierForModuleSymbol(chain[0], context, swappedMode);
                  if (specifier.indexOf("/node_modules/") >= 0) {
                    specifier = oldSpecifier;
                  } else {
                    assertion = ts3.factory.createImportTypeAssertionContainer(ts3.factory.createAssertClause(ts3.factory.createNodeArray([
                      ts3.factory.createAssertEntry(ts3.factory.createStringLiteral("resolution-mode"), ts3.factory.createStringLiteral(swappedMode === ts3.ModuleKind.ESNext ? "import" : "require"))
                    ])));
                    (_d = (_c = context.tracker).reportImportTypeNodeResolutionModeOverride) === null || _d === void 0 ? void 0 : _d.call(_c);
                  }
                }
                if (!assertion) {
                  context.encounteredError = true;
                  if (context.tracker.reportLikelyUnsafeImportRequiredError) {
                    context.tracker.reportLikelyUnsafeImportRequiredError(oldSpecifier);
                  }
                }
              }
              var lit = ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(specifier));
              if (context.tracker.trackExternalModuleSymbolOfImportTypeNode)
                context.tracker.trackExternalModuleSymbolOfImportTypeNode(chain[0]);
              context.approximateLength += specifier.length + 10;
              if (!nonRootParts || ts3.isEntityName(nonRootParts)) {
                if (nonRootParts) {
                  var lastId = ts3.isIdentifier(nonRootParts) ? nonRootParts : nonRootParts.right;
                  lastId.typeArguments = void 0;
                }
                return ts3.factory.createImportTypeNode(lit, assertion, nonRootParts, typeParameterNodes, isTypeOf);
              } else {
                var splitNode = getTopmostIndexedAccessType(nonRootParts);
                var qualifier = splitNode.objectType.typeName;
                return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createImportTypeNode(lit, assertion, qualifier, typeParameterNodes, isTypeOf), splitNode.indexType);
              }
            }
            var entityName = createAccessFromSymbolChain(chain, chain.length - 1, 0);
            if (ts3.isIndexedAccessTypeNode(entityName)) {
              return entityName;
            }
            if (isTypeOf) {
              return ts3.factory.createTypeQueryNode(entityName);
            } else {
              var lastId = ts3.isIdentifier(entityName) ? entityName : entityName.right;
              var lastTypeArgs = lastId.typeArguments;
              lastId.typeArguments = void 0;
              return ts3.factory.createTypeReferenceNode(entityName, lastTypeArgs);
            }
            function createAccessFromSymbolChain(chain2, index, stopper) {
              var typeParameterNodes2 = index === chain2.length - 1 ? overrideTypeArguments : lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              var parent = chain2[index - 1];
              var symbolName;
              if (index === 0) {
                context.flags |= 16777216;
                symbolName = getNameOfSymbolAsWritten(symbol2, context);
                context.approximateLength += (symbolName ? symbolName.length : 0) + 1;
                context.flags ^= 16777216;
              } else {
                if (parent && getExportsOfSymbol(parent)) {
                  var exports_2 = getExportsOfSymbol(parent);
                  ts3.forEachEntry(exports_2, function(ex, name2) {
                    if (getSymbolIfSameReference(ex, symbol2) && !isLateBoundName(name2) && name2 !== "export=") {
                      symbolName = ts3.unescapeLeadingUnderscores(name2);
                      return true;
                    }
                  });
                }
              }
              if (symbolName === void 0) {
                var name = ts3.firstDefined(symbol2.declarations, ts3.getNameOfDeclaration);
                if (name && ts3.isComputedPropertyName(name) && ts3.isEntityName(name.expression)) {
                  var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                  if (ts3.isEntityName(LHS)) {
                    return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createParenthesizedType(ts3.factory.createTypeQueryNode(LHS)), ts3.factory.createTypeQueryNode(name.expression));
                  }
                  return LHS;
                }
                symbolName = getNameOfSymbolAsWritten(symbol2, context);
              }
              context.approximateLength += symbolName.length + 1;
              if (!(context.flags & 16) && parent && getMembersOfSymbol(parent) && getMembersOfSymbol(parent).get(symbol2.escapedName) && getSymbolIfSameReference(getMembersOfSymbol(parent).get(symbol2.escapedName), symbol2)) {
                var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                if (ts3.isIndexedAccessTypeNode(LHS)) {
                  return ts3.factory.createIndexedAccessTypeNode(LHS, ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(symbolName)));
                } else {
                  return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createTypeReferenceNode(LHS, typeParameterNodes2), ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(symbolName)));
                }
              }
              var identifier = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes2), 16777216);
              identifier.symbol = symbol2;
              if (index > stopper) {
                var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                if (!ts3.isEntityName(LHS)) {
                  return ts3.Debug.fail("Impossible construct - an export of an indexed access cannot be reachable");
                }
                return ts3.factory.createQualifiedName(LHS, identifier);
              }
              return identifier;
            }
          }
          function typeParameterShadowsNameInScope(escapedName, context, type2) {
            var result2 = resolveName(context.enclosingDeclaration, escapedName, 788968, void 0, escapedName, false);
            if (result2) {
              if (result2.flags & 262144 && result2 === type2.symbol) {
                return false;
              }
              return true;
            }
            return false;
          }
          function typeParameterToName(type2, context) {
            var _a, _b;
            if (context.flags & 4 && context.typeParameterNames) {
              var cached = context.typeParameterNames.get(getTypeId(type2));
              if (cached) {
                return cached;
              }
            }
            var result2 = symbolToName(type2.symbol, context, 788968, true);
            if (!(result2.kind & 79)) {
              return ts3.factory.createIdentifier("(Missing type parameter)");
            }
            if (context.flags & 4) {
              var rawtext = result2.escapedText;
              var i = ((_a = context.typeParameterNamesByTextNextNameCount) === null || _a === void 0 ? void 0 : _a.get(rawtext)) || 0;
              var text = rawtext;
              while (((_b = context.typeParameterNamesByText) === null || _b === void 0 ? void 0 : _b.has(text)) || typeParameterShadowsNameInScope(text, context, type2)) {
                i++;
                text = "".concat(rawtext, "_").concat(i);
              }
              if (text !== rawtext) {
                result2 = ts3.factory.createIdentifier(text, result2.typeArguments);
              }
              (context.typeParameterNamesByTextNextNameCount || (context.typeParameterNamesByTextNextNameCount = new ts3.Map())).set(rawtext, i);
              (context.typeParameterNames || (context.typeParameterNames = new ts3.Map())).set(getTypeId(type2), result2);
              (context.typeParameterNamesByText || (context.typeParameterNamesByText = new ts3.Set())).add(rawtext);
            }
            return result2;
          }
          function symbolToName(symbol, context, meaning, expectsIdentifier) {
            var chain = lookupSymbolChain(symbol, context, meaning);
            if (expectsIdentifier && chain.length !== 1 && !context.encounteredError && !(context.flags & 65536)) {
              context.encounteredError = true;
            }
            return createEntityNameFromSymbolChain(chain, chain.length - 1);
            function createEntityNameFromSymbolChain(chain2, index) {
              var typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              if (index === 0) {
                context.flags |= 16777216;
              }
              var symbolName = getNameOfSymbolAsWritten(symbol2, context);
              if (index === 0) {
                context.flags ^= 16777216;
              }
              var identifier = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes), 16777216);
              identifier.symbol = symbol2;
              return index > 0 ? ts3.factory.createQualifiedName(createEntityNameFromSymbolChain(chain2, index - 1), identifier) : identifier;
            }
          }
          function symbolToExpression(symbol, context, meaning) {
            var chain = lookupSymbolChain(symbol, context, meaning);
            return createExpressionFromSymbolChain(chain, chain.length - 1);
            function createExpressionFromSymbolChain(chain2, index) {
              var typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              if (index === 0) {
                context.flags |= 16777216;
              }
              var symbolName = getNameOfSymbolAsWritten(symbol2, context);
              if (index === 0) {
                context.flags ^= 16777216;
              }
              var firstChar = symbolName.charCodeAt(0);
              if (ts3.isSingleOrDoubleQuote(firstChar) && ts3.some(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                return ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(symbol2, context));
              }
              var canUsePropertyAccess = firstChar === 35 ? symbolName.length > 1 && ts3.isIdentifierStart(symbolName.charCodeAt(1), languageVersion) : ts3.isIdentifierStart(firstChar, languageVersion);
              if (index === 0 || canUsePropertyAccess) {
                var identifier = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes), 16777216);
                identifier.symbol = symbol2;
                return index > 0 ? ts3.factory.createPropertyAccessExpression(createExpressionFromSymbolChain(chain2, index - 1), identifier) : identifier;
              } else {
                if (firstChar === 91) {
                  symbolName = symbolName.substring(1, symbolName.length - 1);
                  firstChar = symbolName.charCodeAt(0);
                }
                var expression = void 0;
                if (ts3.isSingleOrDoubleQuote(firstChar) && !(symbol2.flags & 8)) {
                  expression = ts3.factory.createStringLiteral(ts3.stripQuotes(symbolName).replace(/\\./g, function(s) {
                    return s.substring(1);
                  }), firstChar === 39);
                } else if ("" + +symbolName === symbolName) {
                  expression = ts3.factory.createNumericLiteral(+symbolName);
                }
                if (!expression) {
                  expression = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes), 16777216);
                  expression.symbol = symbol2;
                }
                return ts3.factory.createElementAccessExpression(createExpressionFromSymbolChain(chain2, index - 1), expression);
              }
            }
          }
          function isStringNamed(d) {
            var name = ts3.getNameOfDeclaration(d);
            return !!name && ts3.isStringLiteral(name);
          }
          function isSingleQuotedStringNamed(d) {
            var name = ts3.getNameOfDeclaration(d);
            return !!(name && ts3.isStringLiteral(name) && (name.singleQuote || !ts3.nodeIsSynthesized(name) && ts3.startsWith(ts3.getTextOfNode(name, false), "'")));
          }
          function getPropertyNameNodeForSymbol(symbol, context) {
            var singleQuote = !!ts3.length(symbol.declarations) && ts3.every(symbol.declarations, isSingleQuotedStringNamed);
            var fromNameType = getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote);
            if (fromNameType) {
              return fromNameType;
            }
            var rawName = ts3.unescapeLeadingUnderscores(symbol.escapedName);
            var stringNamed = !!ts3.length(symbol.declarations) && ts3.every(symbol.declarations, isStringNamed);
            return ts3.createPropertyNameNodeForIdentifierOrLiteral(rawName, ts3.getEmitScriptTarget(compilerOptions), singleQuote, stringNamed);
          }
          function getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote) {
            var nameType = getSymbolLinks(symbol).nameType;
            if (nameType) {
              if (nameType.flags & 384) {
                var name = "" + nameType.value;
                if (!ts3.isIdentifierText(name, ts3.getEmitScriptTarget(compilerOptions)) && !ts3.isNumericLiteralName(name)) {
                  return ts3.factory.createStringLiteral(name, !!singleQuote);
                }
                if (ts3.isNumericLiteralName(name) && ts3.startsWith(name, "-")) {
                  return ts3.factory.createComputedPropertyName(ts3.factory.createNumericLiteral(+name));
                }
                return ts3.createPropertyNameNodeForIdentifierOrLiteral(name, ts3.getEmitScriptTarget(compilerOptions));
              }
              if (nameType.flags & 8192) {
                return ts3.factory.createComputedPropertyName(symbolToExpression(nameType.symbol, context, 111551));
              }
            }
          }
          function cloneNodeBuilderContext(context) {
            var initial = __assign({}, context);
            if (initial.typeParameterNames) {
              initial.typeParameterNames = new ts3.Map(initial.typeParameterNames);
            }
            if (initial.typeParameterNamesByText) {
              initial.typeParameterNamesByText = new ts3.Set(initial.typeParameterNamesByText);
            }
            if (initial.typeParameterSymbolList) {
              initial.typeParameterSymbolList = new ts3.Set(initial.typeParameterSymbolList);
            }
            initial.tracker = wrapSymbolTrackerToReportForContext(initial, initial.tracker);
            return initial;
          }
          function getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration) {
            return symbol.declarations && ts3.find(symbol.declarations, function(s) {
              return !!ts3.getEffectiveTypeAnnotationNode(s) && (!enclosingDeclaration || !!ts3.findAncestor(s, function(n) {
                return n === enclosingDeclaration;
              }));
            });
          }
          function existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type2) {
            return !(ts3.getObjectFlags(type2) & 4) || !ts3.isTypeReferenceNode(existing) || ts3.length(existing.typeArguments) >= getMinTypeArgumentCount(type2.target.typeParameters);
          }
          function serializeTypeForDeclaration(context, type2, symbol, enclosingDeclaration, includePrivateSymbol, bundled) {
            if (!isErrorType(type2) && enclosingDeclaration) {
              var declWithExistingAnnotation = getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration);
              if (declWithExistingAnnotation && !ts3.isFunctionLikeDeclaration(declWithExistingAnnotation) && !ts3.isGetAccessorDeclaration(declWithExistingAnnotation)) {
                var existing = ts3.getEffectiveTypeAnnotationNode(declWithExistingAnnotation);
                if (typeNodeIsEquivalentToType(existing, declWithExistingAnnotation, type2) && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type2)) {
                  var result_6 = serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled);
                  if (result_6) {
                    return result_6;
                  }
                }
              }
            }
            var oldFlags = context.flags;
            if (type2.flags & 8192 && type2.symbol === symbol && (!context.enclosingDeclaration || ts3.some(symbol.declarations, function(d) {
              return ts3.getSourceFileOfNode(d) === ts3.getSourceFileOfNode(context.enclosingDeclaration);
            }))) {
              context.flags |= 1048576;
            }
            var result2 = typeToTypeNodeHelper(type2, context);
            context.flags = oldFlags;
            return result2;
          }
          function typeNodeIsEquivalentToType(typeNode, annotatedDeclaration, type2) {
            var typeFromTypeNode = getTypeFromTypeNode(typeNode);
            if (typeFromTypeNode === type2) {
              return true;
            }
            if (ts3.isParameter(annotatedDeclaration) && annotatedDeclaration.questionToken) {
              return getTypeWithFacts(type2, 524288) === typeFromTypeNode;
            }
            return false;
          }
          function serializeReturnTypeForSignature(context, type2, signature, includePrivateSymbol, bundled) {
            if (!isErrorType(type2) && context.enclosingDeclaration) {
              var annotation = signature.declaration && ts3.getEffectiveReturnTypeNode(signature.declaration);
              if (!!ts3.findAncestor(annotation, function(n) {
                return n === context.enclosingDeclaration;
              }) && annotation) {
                var annotated = getTypeFromTypeNode(annotation);
                var thisInstantiated = annotated.flags & 262144 && annotated.isThisType ? instantiateType(annotated, signature.mapper) : annotated;
                if (thisInstantiated === type2 && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(annotation, type2)) {
                  var result2 = serializeExistingTypeNode(context, annotation, includePrivateSymbol, bundled);
                  if (result2) {
                    return result2;
                  }
                }
              }
            }
            return typeToTypeNodeHelper(type2, context);
          }
          function trackExistingEntityName(node, context, includePrivateSymbol) {
            var _a, _b;
            var introducesError = false;
            var leftmost = ts3.getFirstIdentifier(node);
            if (ts3.isInJSFile(node) && (ts3.isExportsIdentifier(leftmost) || ts3.isModuleExportsAccessExpression(leftmost.parent) || ts3.isQualifiedName(leftmost.parent) && ts3.isModuleIdentifier(leftmost.parent.left) && ts3.isExportsIdentifier(leftmost.parent.right))) {
              introducesError = true;
              return { introducesError, node };
            }
            var sym = resolveEntityName(leftmost, 67108863, true, true);
            if (sym) {
              if (isSymbolAccessible(sym, context.enclosingDeclaration, 67108863, false).accessibility !== 0) {
                introducesError = true;
              } else {
                (_b = (_a = context.tracker) === null || _a === void 0 ? void 0 : _a.trackSymbol) === null || _b === void 0 ? void 0 : _b.call(_a, sym, context.enclosingDeclaration, 67108863);
                includePrivateSymbol === null || includePrivateSymbol === void 0 ? void 0 : includePrivateSymbol(sym);
              }
              if (ts3.isIdentifier(node)) {
                var type2 = getDeclaredTypeOfSymbol(sym);
                var name = sym.flags & 262144 && !isTypeSymbolAccessible(type2.symbol, context.enclosingDeclaration) ? typeParameterToName(type2, context) : ts3.factory.cloneNode(node);
                name.symbol = sym;
                return { introducesError, node: ts3.setEmitFlags(ts3.setOriginalNode(name, node), 16777216) };
              }
            }
            return { introducesError, node };
          }
          function serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled) {
            if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
              cancellationToken.throwIfCancellationRequested();
            }
            var hadError = false;
            var file = ts3.getSourceFileOfNode(existing);
            var transformed = ts3.visitNode(existing, visitExistingNodeTreeSymbols);
            if (hadError) {
              return void 0;
            }
            return transformed === existing ? ts3.setTextRange(ts3.factory.cloneNode(existing), existing) : transformed;
            function visitExistingNodeTreeSymbols(node) {
              if (ts3.isJSDocAllType(node) || node.kind === 319) {
                return ts3.factory.createKeywordTypeNode(130);
              }
              if (ts3.isJSDocUnknownType(node)) {
                return ts3.factory.createKeywordTypeNode(155);
              }
              if (ts3.isJSDocNullableType(node)) {
                return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, visitExistingNodeTreeSymbols), ts3.factory.createLiteralTypeNode(ts3.factory.createNull())]);
              }
              if (ts3.isJSDocOptionalType(node)) {
                return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, visitExistingNodeTreeSymbols), ts3.factory.createKeywordTypeNode(153)]);
              }
              if (ts3.isJSDocNonNullableType(node)) {
                return ts3.visitNode(node.type, visitExistingNodeTreeSymbols);
              }
              if (ts3.isJSDocVariadicType(node)) {
                return ts3.factory.createArrayTypeNode(ts3.visitNode(node.type, visitExistingNodeTreeSymbols));
              }
              if (ts3.isJSDocTypeLiteral(node)) {
                return ts3.factory.createTypeLiteralNode(ts3.map(node.jsDocPropertyTags, function(t) {
                  var name = ts3.isIdentifier(t.name) ? t.name : t.name.right;
                  var typeViaParent = getTypeOfPropertyOfType(getTypeFromTypeNode(node), name.escapedText);
                  var overrideTypeNode = typeViaParent && t.typeExpression && getTypeFromTypeNode(t.typeExpression.type) !== typeViaParent ? typeToTypeNodeHelper(typeViaParent, context) : void 0;
                  return ts3.factory.createPropertySignature(void 0, name, t.isBracketed || t.typeExpression && ts3.isJSDocOptionalType(t.typeExpression.type) ? ts3.factory.createToken(57) : void 0, overrideTypeNode || t.typeExpression && ts3.visitNode(t.typeExpression.type, visitExistingNodeTreeSymbols) || ts3.factory.createKeywordTypeNode(130));
                }));
              }
              if (ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "") {
                return ts3.setOriginalNode(ts3.factory.createKeywordTypeNode(130), node);
              }
              if ((ts3.isExpressionWithTypeArguments(node) || ts3.isTypeReferenceNode(node)) && ts3.isJSDocIndexSignature(node)) {
                return ts3.factory.createTypeLiteralNode([ts3.factory.createIndexSignature(void 0, void 0, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, ts3.visitNode(node.typeArguments[0], visitExistingNodeTreeSymbols))], ts3.visitNode(node.typeArguments[1], visitExistingNodeTreeSymbols))]);
              }
              if (ts3.isJSDocFunctionType(node)) {
                if (ts3.isJSDocConstructSignature(node)) {
                  var newTypeNode_1;
                  return ts3.factory.createConstructorTypeNode(node.modifiers, ts3.visitNodes(node.typeParameters, visitExistingNodeTreeSymbols), ts3.mapDefined(node.parameters, function(p, i) {
                    return p.name && ts3.isIdentifier(p.name) && p.name.escapedText === "new" ? (newTypeNode_1 = p.type, void 0) : ts3.factory.createParameterDeclaration(void 0, void 0, getEffectiveDotDotDotForParameter(p), getNameForJSDocFunctionParameter(p, i), p.questionToken, ts3.visitNode(p.type, visitExistingNodeTreeSymbols), void 0);
                  }), ts3.visitNode(newTypeNode_1 || node.type, visitExistingNodeTreeSymbols) || ts3.factory.createKeywordTypeNode(130));
                } else {
                  return ts3.factory.createFunctionTypeNode(ts3.visitNodes(node.typeParameters, visitExistingNodeTreeSymbols), ts3.map(node.parameters, function(p, i) {
                    return ts3.factory.createParameterDeclaration(void 0, void 0, getEffectiveDotDotDotForParameter(p), getNameForJSDocFunctionParameter(p, i), p.questionToken, ts3.visitNode(p.type, visitExistingNodeTreeSymbols), void 0);
                  }), ts3.visitNode(node.type, visitExistingNodeTreeSymbols) || ts3.factory.createKeywordTypeNode(130));
                }
              }
              if (ts3.isTypeReferenceNode(node) && ts3.isInJSDoc(node) && (!existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(node, getTypeFromTypeNode(node)) || getIntendedTypeFromJSDocTypeReference(node) || unknownSymbol === resolveTypeReferenceName(node, 788968, true))) {
                return ts3.setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
              }
              if (ts3.isLiteralImportTypeNode(node)) {
                var nodeSymbol = getNodeLinks(node).resolvedSymbol;
                if (ts3.isInJSDoc(node) && nodeSymbol && (!node.isTypeOf && !(nodeSymbol.flags & 788968) || !(ts3.length(node.typeArguments) >= getMinTypeArgumentCount(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(nodeSymbol))))) {
                  return ts3.setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
                }
                return ts3.factory.updateImportTypeNode(node, ts3.factory.updateLiteralTypeNode(node.argument, rewriteModuleSpecifier(node, node.argument.literal)), node.qualifier, ts3.visitNodes(node.typeArguments, visitExistingNodeTreeSymbols, ts3.isTypeNode), node.isTypeOf);
              }
              if (ts3.isEntityName(node) || ts3.isEntityNameExpression(node)) {
                var _a = trackExistingEntityName(node, context, includePrivateSymbol), introducesError = _a.introducesError, result2 = _a.node;
                hadError = hadError || introducesError;
                if (result2 !== node) {
                  return result2;
                }
              }
              if (file && ts3.isTupleTypeNode(node) && ts3.getLineAndCharacterOfPosition(file, node.pos).line === ts3.getLineAndCharacterOfPosition(file, node.end).line) {
                ts3.setEmitFlags(node, 1);
              }
              return ts3.visitEachChild(node, visitExistingNodeTreeSymbols, ts3.nullTransformationContext);
              function getEffectiveDotDotDotForParameter(p) {
                return p.dotDotDotToken || (p.type && ts3.isJSDocVariadicType(p.type) ? ts3.factory.createToken(25) : void 0);
              }
              function getNameForJSDocFunctionParameter(p, index) {
                return p.name && ts3.isIdentifier(p.name) && p.name.escapedText === "this" ? "this" : getEffectiveDotDotDotForParameter(p) ? "args" : "arg".concat(index);
              }
              function rewriteModuleSpecifier(parent, lit) {
                if (bundled) {
                  if (context.tracker && context.tracker.moduleResolverHost) {
                    var targetFile = getExternalModuleFileFromDeclaration(parent);
                    if (targetFile) {
                      var getCanonicalFileName = ts3.createGetCanonicalFileName(!!host.useCaseSensitiveFileNames);
                      var resolverHost = {
                        getCanonicalFileName,
                        getCurrentDirectory: function() {
                          return context.tracker.moduleResolverHost.getCurrentDirectory();
                        },
                        getCommonSourceDirectory: function() {
                          return context.tracker.moduleResolverHost.getCommonSourceDirectory();
                        }
                      };
                      var newName = ts3.getResolvedExternalModuleName(resolverHost, targetFile);
                      return ts3.factory.createStringLiteral(newName);
                    }
                  }
                } else {
                  if (context.tracker && context.tracker.trackExternalModuleSymbolOfImportTypeNode) {
                    var moduleSym = resolveExternalModuleNameWorker(lit, lit, void 0);
                    if (moduleSym) {
                      context.tracker.trackExternalModuleSymbolOfImportTypeNode(moduleSym);
                    }
                  }
                }
                return lit;
              }
            }
          }
          function symbolTableToDeclarationStatements(symbolTable, context, bundled) {
            var serializePropertySymbolForClass = makeSerializePropertySymbol(ts3.factory.createPropertyDeclaration, 169, true);
            var serializePropertySymbolForInterfaceWorker = makeSerializePropertySymbol(function(_decorators, mods, name, question, type2) {
              return ts3.factory.createPropertySignature(mods, name, question, type2);
            }, 168, false);
            var enclosingDeclaration = context.enclosingDeclaration;
            var results = [];
            var visitedSymbols = new ts3.Set();
            var deferredPrivatesStack = [];
            var oldcontext = context;
            context = __assign(__assign({}, oldcontext), { usedSymbolNames: new ts3.Set(oldcontext.usedSymbolNames), remappedSymbolNames: new ts3.Map(), tracker: __assign(__assign({}, oldcontext.tracker), { trackSymbol: function(sym, decl, meaning) {
              var accessibleResult = isSymbolAccessible(sym, decl, meaning, false);
              if (accessibleResult.accessibility === 0) {
                var chain = lookupSymbolChainWorker(sym, context, meaning);
                if (!(sym.flags & 4)) {
                  includePrivateSymbol(chain[0]);
                }
              } else if (oldcontext.tracker && oldcontext.tracker.trackSymbol) {
                return oldcontext.tracker.trackSymbol(sym, decl, meaning);
              }
              return false;
            } }) });
            context.tracker = wrapSymbolTrackerToReportForContext(context, context.tracker);
            ts3.forEachEntry(symbolTable, function(symbol, name) {
              var baseName = ts3.unescapeLeadingUnderscores(name);
              void getInternalSymbolName(symbol, baseName);
            });
            var addingDeclare = !bundled;
            var exportEquals = symbolTable.get("export=");
            if (exportEquals && symbolTable.size > 1 && exportEquals.flags & 2097152) {
              symbolTable = ts3.createSymbolTable();
              symbolTable.set("export=", exportEquals);
            }
            visitSymbolTable(symbolTable);
            return mergeRedundantStatements(results);
            function isIdentifierAndNotUndefined(node) {
              return !!node && node.kind === 79;
            }
            function getNamesOfDeclaration(statement) {
              if (ts3.isVariableStatement(statement)) {
                return ts3.filter(ts3.map(statement.declarationList.declarations, ts3.getNameOfDeclaration), isIdentifierAndNotUndefined);
              }
              return ts3.filter([ts3.getNameOfDeclaration(statement)], isIdentifierAndNotUndefined);
            }
            function flattenExportAssignedNamespace(statements) {
              var exportAssignment = ts3.find(statements, ts3.isExportAssignment);
              var nsIndex = ts3.findIndex(statements, ts3.isModuleDeclaration);
              var ns = nsIndex !== -1 ? statements[nsIndex] : void 0;
              if (ns && exportAssignment && exportAssignment.isExportEquals && ts3.isIdentifier(exportAssignment.expression) && ts3.isIdentifier(ns.name) && ts3.idText(ns.name) === ts3.idText(exportAssignment.expression) && ns.body && ts3.isModuleBlock(ns.body)) {
                var excessExports = ts3.filter(statements, function(s) {
                  return !!(ts3.getEffectiveModifierFlags(s) & 1);
                });
                var name_3 = ns.name;
                var body = ns.body;
                if (ts3.length(excessExports)) {
                  ns = ts3.factory.updateModuleDeclaration(ns, ns.decorators, ns.modifiers, ns.name, body = ts3.factory.updateModuleBlock(body, ts3.factory.createNodeArray(__spreadArray(__spreadArray([], ns.body.statements, true), [ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.map(ts3.flatMap(excessExports, function(e) {
                    return getNamesOfDeclaration(e);
                  }), function(id) {
                    return ts3.factory.createExportSpecifier(false, void 0, id);
                  })), void 0)], false))));
                  statements = __spreadArray(__spreadArray(__spreadArray([], statements.slice(0, nsIndex), true), [ns], false), statements.slice(nsIndex + 1), true);
                }
                if (!ts3.find(statements, function(s) {
                  return s !== ns && ts3.nodeHasName(s, name_3);
                })) {
                  results = [];
                  var mixinExportFlag_1 = !ts3.some(body.statements, function(s) {
                    return ts3.hasSyntacticModifier(s, 1) || ts3.isExportAssignment(s) || ts3.isExportDeclaration(s);
                  });
                  ts3.forEach(body.statements, function(s) {
                    addResult(s, mixinExportFlag_1 ? 1 : 0);
                  });
                  statements = __spreadArray(__spreadArray([], ts3.filter(statements, function(s) {
                    return s !== ns && s !== exportAssignment;
                  }), true), results, true);
                }
              }
              return statements;
            }
            function mergeExportDeclarations(statements) {
              var exports2 = ts3.filter(statements, function(d) {
                return ts3.isExportDeclaration(d) && !d.moduleSpecifier && !!d.exportClause && ts3.isNamedExports(d.exportClause);
              });
              if (ts3.length(exports2) > 1) {
                var nonExports = ts3.filter(statements, function(d) {
                  return !ts3.isExportDeclaration(d) || !!d.moduleSpecifier || !d.exportClause;
                });
                statements = __spreadArray(__spreadArray([], nonExports, true), [ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.flatMap(exports2, function(e) {
                  return ts3.cast(e.exportClause, ts3.isNamedExports).elements;
                })), void 0)], false);
              }
              var reexports = ts3.filter(statements, function(d) {
                return ts3.isExportDeclaration(d) && !!d.moduleSpecifier && !!d.exportClause && ts3.isNamedExports(d.exportClause);
              });
              if (ts3.length(reexports) > 1) {
                var groups = ts3.group(reexports, function(decl) {
                  return ts3.isStringLiteral(decl.moduleSpecifier) ? ">" + decl.moduleSpecifier.text : ">";
                });
                if (groups.length !== reexports.length) {
                  var _loop_9 = function(group_12) {
                    if (group_12.length > 1) {
                      statements = __spreadArray(__spreadArray([], ts3.filter(statements, function(s) {
                        return group_12.indexOf(s) === -1;
                      }), true), [
                        ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.flatMap(group_12, function(e) {
                          return ts3.cast(e.exportClause, ts3.isNamedExports).elements;
                        })), group_12[0].moduleSpecifier)
                      ], false);
                    }
                  };
                  for (var _i = 0, groups_1 = groups; _i < groups_1.length; _i++) {
                    var group_1 = groups_1[_i];
                    _loop_9(group_1);
                  }
                }
              }
              return statements;
            }
            function inlineExportModifiers(statements) {
              var index = ts3.findIndex(statements, function(d) {
                return ts3.isExportDeclaration(d) && !d.moduleSpecifier && !d.assertClause && !!d.exportClause && ts3.isNamedExports(d.exportClause);
              });
              if (index >= 0) {
                var exportDecl = statements[index];
                var replacements = ts3.mapDefined(exportDecl.exportClause.elements, function(e) {
                  if (!e.propertyName) {
                    var indices = ts3.indicesOf(statements);
                    var associatedIndices = ts3.filter(indices, function(i) {
                      return ts3.nodeHasName(statements[i], e.name);
                    });
                    if (ts3.length(associatedIndices) && ts3.every(associatedIndices, function(i) {
                      return canHaveExportModifier(statements[i]);
                    })) {
                      for (var _i = 0, associatedIndices_1 = associatedIndices; _i < associatedIndices_1.length; _i++) {
                        var index_1 = associatedIndices_1[_i];
                        statements[index_1] = addExportModifier(statements[index_1]);
                      }
                      return void 0;
                    }
                  }
                  return e;
                });
                if (!ts3.length(replacements)) {
                  ts3.orderedRemoveItemAt(statements, index);
                } else {
                  statements[index] = ts3.factory.updateExportDeclaration(exportDecl, exportDecl.decorators, exportDecl.modifiers, exportDecl.isTypeOnly, ts3.factory.updateNamedExports(exportDecl.exportClause, replacements), exportDecl.moduleSpecifier, exportDecl.assertClause);
                }
              }
              return statements;
            }
            function mergeRedundantStatements(statements) {
              statements = flattenExportAssignedNamespace(statements);
              statements = mergeExportDeclarations(statements);
              statements = inlineExportModifiers(statements);
              if (enclosingDeclaration && (ts3.isSourceFile(enclosingDeclaration) && ts3.isExternalOrCommonJsModule(enclosingDeclaration) || ts3.isModuleDeclaration(enclosingDeclaration)) && (!ts3.some(statements, ts3.isExternalModuleIndicator) || !ts3.hasScopeMarker(statements) && ts3.some(statements, ts3.needsScopeMarker))) {
                statements.push(ts3.createEmptyExports(ts3.factory));
              }
              return statements;
            }
            function canHaveExportModifier(node) {
              return ts3.isEnumDeclaration(node) || ts3.isVariableStatement(node) || ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isModuleDeclaration(node) && !ts3.isExternalModuleAugmentation(node) && !ts3.isGlobalScopeAugmentation(node) || ts3.isInterfaceDeclaration(node) || isTypeDeclaration(node);
            }
            function addExportModifier(node) {
              var flags = (ts3.getEffectiveModifierFlags(node) | 1) & ~2;
              return ts3.factory.updateModifiers(node, flags);
            }
            function removeExportModifier(node) {
              var flags = ts3.getEffectiveModifierFlags(node) & ~1;
              return ts3.factory.updateModifiers(node, flags);
            }
            function visitSymbolTable(symbolTable2, suppressNewPrivateContext, propertyAsAlias) {
              if (!suppressNewPrivateContext) {
                deferredPrivatesStack.push(new ts3.Map());
              }
              symbolTable2.forEach(function(symbol) {
                serializeSymbol(symbol, false, !!propertyAsAlias);
              });
              if (!suppressNewPrivateContext) {
                deferredPrivatesStack[deferredPrivatesStack.length - 1].forEach(function(symbol) {
                  serializeSymbol(symbol, true, !!propertyAsAlias);
                });
                deferredPrivatesStack.pop();
              }
            }
            function serializeSymbol(symbol, isPrivate, propertyAsAlias) {
              var visitedSym = getMergedSymbol(symbol);
              if (visitedSymbols.has(getSymbolId(visitedSym))) {
                return;
              }
              visitedSymbols.add(getSymbolId(visitedSym));
              var skipMembershipCheck = !isPrivate;
              if (skipMembershipCheck || !!ts3.length(symbol.declarations) && ts3.some(symbol.declarations, function(d) {
                return !!ts3.findAncestor(d, function(n) {
                  return n === enclosingDeclaration;
                });
              })) {
                var oldContext = context;
                context = cloneNodeBuilderContext(context);
                var result2 = serializeSymbolWorker(symbol, isPrivate, propertyAsAlias);
                if (context.reportedDiagnostic) {
                  oldcontext.reportedDiagnostic = context.reportedDiagnostic;
                }
                context = oldContext;
                return result2;
              }
            }
            function serializeSymbolWorker(symbol, isPrivate, propertyAsAlias) {
              var _a, _b, _c, _d;
              var symbolName = ts3.unescapeLeadingUnderscores(symbol.escapedName);
              var isDefault = symbol.escapedName === "default";
              if (isPrivate && !(context.flags & 131072) && ts3.isStringANonContextualKeyword(symbolName) && !isDefault) {
                context.encounteredError = true;
                return;
              }
              var needsPostExportDefault = isDefault && !!(symbol.flags & -113 || symbol.flags & 16 && ts3.length(getPropertiesOfType(getTypeOfSymbol(symbol)))) && !(symbol.flags & 2097152);
              var needsExportDeclaration = !needsPostExportDefault && !isPrivate && ts3.isStringANonContextualKeyword(symbolName) && !isDefault;
              if (needsPostExportDefault || needsExportDeclaration) {
                isPrivate = true;
              }
              var modifierFlags = (!isPrivate ? 1 : 0) | (isDefault && !needsPostExportDefault ? 512 : 0);
              var isConstMergedWithNS = symbol.flags & 1536 && symbol.flags & (2 | 1 | 4) && symbol.escapedName !== "export=";
              var isConstMergedWithNSPrintableAsSignatureMerge = isConstMergedWithNS && isTypeRepresentableAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol);
              if (symbol.flags & (16 | 8192) || isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
              }
              if (symbol.flags & 524288) {
                serializeTypeAlias(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & (2 | 1 | 4) && symbol.escapedName !== "export=" && !(symbol.flags & 4194304) && !(symbol.flags & 32) && !isConstMergedWithNSPrintableAsSignatureMerge) {
                if (propertyAsAlias) {
                  var createdExport = serializeMaybeAliasAssignment(symbol);
                  if (createdExport) {
                    needsExportDeclaration = false;
                    needsPostExportDefault = false;
                  }
                } else {
                  var type2 = getTypeOfSymbol(symbol);
                  var localName = getInternalSymbolName(symbol, symbolName);
                  if (!(symbol.flags & 16) && isTypeRepresentableAsFunctionNamespaceMerge(type2, symbol)) {
                    serializeAsFunctionNamespaceMerge(type2, symbol, localName, modifierFlags);
                  } else {
                    var flags = !(symbol.flags & 2) ? ((_a = symbol.parent) === null || _a === void 0 ? void 0 : _a.valueDeclaration) && ts3.isSourceFile((_b = symbol.parent) === null || _b === void 0 ? void 0 : _b.valueDeclaration) ? 2 : void 0 : isConstVariable(symbol) ? 2 : 1;
                    var name = needsPostExportDefault || !(symbol.flags & 4) ? localName : getUnusedName(localName, symbol);
                    var textRange = symbol.declarations && ts3.find(symbol.declarations, function(d) {
                      return ts3.isVariableDeclaration(d);
                    });
                    if (textRange && ts3.isVariableDeclarationList(textRange.parent) && textRange.parent.declarations.length === 1) {
                      textRange = textRange.parent.parent;
                    }
                    var propertyAccessRequire = (_c = symbol.declarations) === null || _c === void 0 ? void 0 : _c.find(ts3.isPropertyAccessExpression);
                    if (propertyAccessRequire && ts3.isBinaryExpression(propertyAccessRequire.parent) && ts3.isIdentifier(propertyAccessRequire.parent.right) && ((_d = type2.symbol) === null || _d === void 0 ? void 0 : _d.valueDeclaration) && ts3.isSourceFile(type2.symbol.valueDeclaration)) {
                      var alias = localName === propertyAccessRequire.parent.right.escapedText ? void 0 : propertyAccessRequire.parent.right;
                      addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(false, alias, localName)])), 0);
                      context.tracker.trackSymbol(type2.symbol, context.enclosingDeclaration, 111551);
                    } else {
                      var statement = ts3.setTextRange(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
                        ts3.factory.createVariableDeclaration(name, void 0, serializeTypeForDeclaration(context, type2, symbol, enclosingDeclaration, includePrivateSymbol, bundled))
                      ], flags)), textRange);
                      addResult(statement, name !== localName ? modifierFlags & ~1 : modifierFlags);
                      if (name !== localName && !isPrivate) {
                        addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(false, name, localName)])), 0);
                        needsExportDeclaration = false;
                        needsPostExportDefault = false;
                      }
                    }
                  }
                }
              }
              if (symbol.flags & 384) {
                serializeEnum(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 32) {
                if (symbol.flags & 4 && symbol.valueDeclaration && ts3.isBinaryExpression(symbol.valueDeclaration.parent) && ts3.isClassExpression(symbol.valueDeclaration.parent.right)) {
                  serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
                } else {
                  serializeAsClass(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
                }
              }
              if (symbol.flags & (512 | 1024) && (!isConstMergedWithNS || isTypeOnlyNamespace(symbol)) || isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeModule(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 64 && !(symbol.flags & 32)) {
                serializeInterface(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 2097152) {
                serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
              }
              if (symbol.flags & 4 && symbol.escapedName === "export=") {
                serializeMaybeAliasAssignment(symbol);
              }
              if (symbol.flags & 8388608) {
                if (symbol.declarations) {
                  for (var _i = 0, _e = symbol.declarations; _i < _e.length; _i++) {
                    var node = _e[_i];
                    var resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
                    if (!resolvedModule)
                      continue;
                    addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, void 0, ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(resolvedModule, context))), 0);
                  }
                }
              }
              if (needsPostExportDefault) {
                addResult(ts3.factory.createExportAssignment(void 0, void 0, false, ts3.factory.createIdentifier(getInternalSymbolName(symbol, symbolName))), 0);
              } else if (needsExportDeclaration) {
                addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(false, getInternalSymbolName(symbol, symbolName), symbolName)])), 0);
              }
            }
            function includePrivateSymbol(symbol) {
              if (ts3.some(symbol.declarations, ts3.isParameterDeclaration))
                return;
              ts3.Debug.assertIsDefined(deferredPrivatesStack[deferredPrivatesStack.length - 1]);
              getUnusedName(ts3.unescapeLeadingUnderscores(symbol.escapedName), symbol);
              var isExternalImportAlias = !!(symbol.flags & 2097152) && !ts3.some(symbol.declarations, function(d) {
                return !!ts3.findAncestor(d, ts3.isExportDeclaration) || ts3.isNamespaceExport(d) || ts3.isImportEqualsDeclaration(d) && !ts3.isExternalModuleReference(d.moduleReference);
              });
              deferredPrivatesStack[isExternalImportAlias ? 0 : deferredPrivatesStack.length - 1].set(getSymbolId(symbol), symbol);
            }
            function isExportingScope(enclosingDeclaration2) {
              return ts3.isSourceFile(enclosingDeclaration2) && (ts3.isExternalOrCommonJsModule(enclosingDeclaration2) || ts3.isJsonSourceFile(enclosingDeclaration2)) || ts3.isAmbientModule(enclosingDeclaration2) && !ts3.isGlobalScopeAugmentation(enclosingDeclaration2);
            }
            function addResult(node, additionalModifierFlags) {
              if (ts3.canHaveModifiers(node)) {
                var newModifierFlags = 0;
                var enclosingDeclaration_1 = context.enclosingDeclaration && (ts3.isJSDocTypeAlias(context.enclosingDeclaration) ? ts3.getSourceFileOfNode(context.enclosingDeclaration) : context.enclosingDeclaration);
                if (additionalModifierFlags & 1 && enclosingDeclaration_1 && (isExportingScope(enclosingDeclaration_1) || ts3.isModuleDeclaration(enclosingDeclaration_1)) && canHaveExportModifier(node)) {
                  newModifierFlags |= 1;
                }
                if (addingDeclare && !(newModifierFlags & 1) && (!enclosingDeclaration_1 || !(enclosingDeclaration_1.flags & 16777216)) && (ts3.isEnumDeclaration(node) || ts3.isVariableStatement(node) || ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isModuleDeclaration(node))) {
                  newModifierFlags |= 2;
                }
                if (additionalModifierFlags & 512 && (ts3.isClassDeclaration(node) || ts3.isInterfaceDeclaration(node) || ts3.isFunctionDeclaration(node))) {
                  newModifierFlags |= 512;
                }
                if (newModifierFlags) {
                  node = ts3.factory.updateModifiers(node, newModifierFlags | ts3.getEffectiveModifierFlags(node));
                }
              }
              results.push(node);
            }
            function serializeTypeAlias(symbol, symbolName, modifierFlags) {
              var _a;
              var aliasType = getDeclaredTypeOfTypeAlias(symbol);
              var typeParams = getSymbolLinks(symbol).typeParameters;
              var typeParamDecls = ts3.map(typeParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var jsdocAliasDecl = (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isJSDocTypeAlias);
              var commentText = ts3.getTextOfJSDocComment(jsdocAliasDecl ? jsdocAliasDecl.comment || jsdocAliasDecl.parent.comment : void 0);
              var oldFlags = context.flags;
              context.flags |= 8388608;
              var oldEnclosingDecl = context.enclosingDeclaration;
              context.enclosingDeclaration = jsdocAliasDecl;
              var typeNode = jsdocAliasDecl && jsdocAliasDecl.typeExpression && ts3.isJSDocTypeExpression(jsdocAliasDecl.typeExpression) && serializeExistingTypeNode(context, jsdocAliasDecl.typeExpression.type, includePrivateSymbol, bundled) || typeToTypeNodeHelper(aliasType, context);
              addResult(ts3.setSyntheticLeadingComments(ts3.factory.createTypeAliasDeclaration(void 0, void 0, getInternalSymbolName(symbol, symbolName), typeParamDecls, typeNode), !commentText ? [] : [{ kind: 3, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]), modifierFlags);
              context.flags = oldFlags;
              context.enclosingDeclaration = oldEnclosingDecl;
            }
            function serializeInterface(symbol, symbolName, modifierFlags) {
              var interfaceType = getDeclaredTypeOfClassOrInterface(symbol);
              var localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              var typeParamDecls = ts3.map(localParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var baseTypes = getBaseTypes(interfaceType);
              var baseType = ts3.length(baseTypes) ? getIntersectionType(baseTypes) : void 0;
              var members = ts3.flatMap(getPropertiesOfType(interfaceType), function(p) {
                return serializePropertySymbolForInterface(p, baseType);
              });
              var callSignatures = serializeSignatures(0, interfaceType, baseType, 174);
              var constructSignatures = serializeSignatures(1, interfaceType, baseType, 175);
              var indexSignatures = serializeIndexSignatures(interfaceType, baseType);
              var heritageClauses = !ts3.length(baseTypes) ? void 0 : [ts3.factory.createHeritageClause(94, ts3.mapDefined(baseTypes, function(b) {
                return trySerializeAsTypeReference(b, 111551);
              }))];
              addResult(ts3.factory.createInterfaceDeclaration(void 0, void 0, getInternalSymbolName(symbol, symbolName), typeParamDecls, heritageClauses, __spreadArray(__spreadArray(__spreadArray(__spreadArray([], indexSignatures, true), constructSignatures, true), callSignatures, true), members, true)), modifierFlags);
            }
            function getNamespaceMembersForSerialization(symbol) {
              return !symbol.exports ? [] : ts3.filter(ts3.arrayFrom(symbol.exports.values()), isNamespaceMember);
            }
            function isTypeOnlyNamespace(symbol) {
              return ts3.every(getNamespaceMembersForSerialization(symbol), function(m) {
                return !(resolveSymbol(m).flags & 111551);
              });
            }
            function serializeModule(symbol, symbolName, modifierFlags) {
              var members = getNamespaceMembersForSerialization(symbol);
              var locationMap = ts3.arrayToMultiMap(members, function(m) {
                return m.parent && m.parent === symbol ? "real" : "merged";
              });
              var realMembers = locationMap.get("real") || ts3.emptyArray;
              var mergedMembers = locationMap.get("merged") || ts3.emptyArray;
              if (ts3.length(realMembers)) {
                var localName = getInternalSymbolName(symbol, symbolName);
                serializeAsNamespaceDeclaration(realMembers, localName, modifierFlags, !!(symbol.flags & (16 | 67108864)));
              }
              if (ts3.length(mergedMembers)) {
                var containingFile_1 = ts3.getSourceFileOfNode(context.enclosingDeclaration);
                var localName = getInternalSymbolName(symbol, symbolName);
                var nsBody = ts3.factory.createModuleBlock([ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.mapDefined(ts3.filter(mergedMembers, function(n) {
                  return n.escapedName !== "export=";
                }), function(s) {
                  var _a, _b;
                  var name = ts3.unescapeLeadingUnderscores(s.escapedName);
                  var localName2 = getInternalSymbolName(s, name);
                  var aliasDecl = s.declarations && getDeclarationOfAliasSymbol(s);
                  if (containingFile_1 && (aliasDecl ? containingFile_1 !== ts3.getSourceFileOfNode(aliasDecl) : !ts3.some(s.declarations, function(d) {
                    return ts3.getSourceFileOfNode(d) === containingFile_1;
                  }))) {
                    (_b = (_a = context.tracker) === null || _a === void 0 ? void 0 : _a.reportNonlocalAugmentation) === null || _b === void 0 ? void 0 : _b.call(_a, containingFile_1, symbol, s);
                    return void 0;
                  }
                  var target = aliasDecl && getTargetOfAliasDeclaration(aliasDecl, true);
                  includePrivateSymbol(target || s);
                  var targetName = target ? getInternalSymbolName(target, ts3.unescapeLeadingUnderscores(target.escapedName)) : localName2;
                  return ts3.factory.createExportSpecifier(false, name === targetName ? void 0 : targetName, name);
                })))]);
                addResult(ts3.factory.createModuleDeclaration(void 0, void 0, ts3.factory.createIdentifier(localName), nsBody, 16), 0);
              }
            }
            function serializeEnum(symbol, symbolName, modifierFlags) {
              addResult(ts3.factory.createEnumDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(isConstEnumSymbol(symbol) ? 2048 : 0), getInternalSymbolName(symbol, symbolName), ts3.map(ts3.filter(getPropertiesOfType(getTypeOfSymbol(symbol)), function(p) {
                return !!(p.flags & 8);
              }), function(p) {
                var initializedValue = p.declarations && p.declarations[0] && ts3.isEnumMember(p.declarations[0]) ? getConstantValue(p.declarations[0]) : void 0;
                return ts3.factory.createEnumMember(ts3.unescapeLeadingUnderscores(p.escapedName), initializedValue === void 0 ? void 0 : typeof initializedValue === "string" ? ts3.factory.createStringLiteral(initializedValue) : ts3.factory.createNumericLiteral(initializedValue));
              })), modifierFlags);
            }
            function serializeAsFunctionNamespaceMerge(type2, symbol, localName, modifierFlags) {
              var signatures = getSignaturesOfType(type2, 0);
              for (var _i = 0, signatures_2 = signatures; _i < signatures_2.length; _i++) {
                var sig = signatures_2[_i];
                var decl = signatureToSignatureDeclarationHelper(sig, 256, context, { name: ts3.factory.createIdentifier(localName), privateSymbolVisitor: includePrivateSymbol, bundledImports: bundled });
                addResult(ts3.setTextRange(decl, getSignatureTextRangeLocation(sig)), modifierFlags);
              }
              if (!(symbol.flags & (512 | 1024) && !!symbol.exports && !!symbol.exports.size)) {
                var props = ts3.filter(getPropertiesOfType(type2), isNamespaceMember);
                serializeAsNamespaceDeclaration(props, localName, modifierFlags, true);
              }
            }
            function getSignatureTextRangeLocation(signature) {
              if (signature.declaration && signature.declaration.parent) {
                if (ts3.isBinaryExpression(signature.declaration.parent) && ts3.getAssignmentDeclarationKind(signature.declaration.parent) === 5) {
                  return signature.declaration.parent;
                }
                if (ts3.isVariableDeclaration(signature.declaration.parent) && signature.declaration.parent.parent) {
                  return signature.declaration.parent.parent;
                }
              }
              return signature.declaration;
            }
            function serializeAsNamespaceDeclaration(props, localName, modifierFlags, suppressNewPrivateContext) {
              if (ts3.length(props)) {
                var localVsRemoteMap = ts3.arrayToMultiMap(props, function(p) {
                  return !ts3.length(p.declarations) || ts3.some(p.declarations, function(d) {
                    return ts3.getSourceFileOfNode(d) === ts3.getSourceFileOfNode(context.enclosingDeclaration);
                  }) ? "local" : "remote";
                });
                var localProps = localVsRemoteMap.get("local") || ts3.emptyArray;
                var fakespace = ts3.parseNodeFactory.createModuleDeclaration(void 0, void 0, ts3.factory.createIdentifier(localName), ts3.factory.createModuleBlock([]), 16);
                ts3.setParent(fakespace, enclosingDeclaration);
                fakespace.locals = ts3.createSymbolTable(props);
                fakespace.symbol = props[0].parent;
                var oldResults = results;
                results = [];
                var oldAddingDeclare = addingDeclare;
                addingDeclare = false;
                var subcontext = __assign(__assign({}, context), { enclosingDeclaration: fakespace });
                var oldContext = context;
                context = subcontext;
                visitSymbolTable(ts3.createSymbolTable(localProps), suppressNewPrivateContext, true);
                context = oldContext;
                addingDeclare = oldAddingDeclare;
                var declarations = results;
                results = oldResults;
                var defaultReplaced = ts3.map(declarations, function(d) {
                  return ts3.isExportAssignment(d) && !d.isExportEquals && ts3.isIdentifier(d.expression) ? ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(false, d.expression, ts3.factory.createIdentifier("default"))])) : d;
                });
                var exportModifierStripped = ts3.every(defaultReplaced, function(d) {
                  return ts3.hasSyntacticModifier(d, 1);
                }) ? ts3.map(defaultReplaced, removeExportModifier) : defaultReplaced;
                fakespace = ts3.factory.updateModuleDeclaration(fakespace, fakespace.decorators, fakespace.modifiers, fakespace.name, ts3.factory.createModuleBlock(exportModifierStripped));
                addResult(fakespace, modifierFlags);
              }
            }
            function isNamespaceMember(p) {
              return !!(p.flags & (788968 | 1920 | 2097152)) || !(p.flags & 4194304 || p.escapedName === "prototype" || p.valueDeclaration && ts3.isStatic(p.valueDeclaration) && ts3.isClassLike(p.valueDeclaration.parent));
            }
            function sanitizeJSDocImplements(clauses) {
              var result2 = ts3.mapDefined(clauses, function(e) {
                var _a;
                var oldEnclosing = context.enclosingDeclaration;
                context.enclosingDeclaration = e;
                var expr = e.expression;
                if (ts3.isEntityNameExpression(expr)) {
                  if (ts3.isIdentifier(expr) && ts3.idText(expr) === "") {
                    return cleanup(void 0);
                  }
                  var introducesError = void 0;
                  _a = trackExistingEntityName(expr, context, includePrivateSymbol), introducesError = _a.introducesError, expr = _a.node;
                  if (introducesError) {
                    return cleanup(void 0);
                  }
                }
                return cleanup(ts3.factory.createExpressionWithTypeArguments(expr, ts3.map(e.typeArguments, function(a) {
                  return serializeExistingTypeNode(context, a, includePrivateSymbol, bundled) || typeToTypeNodeHelper(getTypeFromTypeNode(a), context);
                })));
                function cleanup(result3) {
                  context.enclosingDeclaration = oldEnclosing;
                  return result3;
                }
              });
              if (result2.length === clauses.length) {
                return result2;
              }
              return void 0;
            }
            function serializeAsClass(symbol, localName, modifierFlags) {
              var _a, _b;
              var originalDecl = (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isClassLike);
              var oldEnclosing = context.enclosingDeclaration;
              context.enclosingDeclaration = originalDecl || oldEnclosing;
              var localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              var typeParamDecls = ts3.map(localParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var classType = getDeclaredTypeOfClassOrInterface(symbol);
              var baseTypes = getBaseTypes(classType);
              var originalImplements = originalDecl && ts3.getEffectiveImplementsTypeNodes(originalDecl);
              var implementsExpressions = originalImplements && sanitizeJSDocImplements(originalImplements) || ts3.mapDefined(getImplementsTypes(classType), serializeImplementedType);
              var staticType = getTypeOfSymbol(symbol);
              var isClass = !!((_b = staticType.symbol) === null || _b === void 0 ? void 0 : _b.valueDeclaration) && ts3.isClassLike(staticType.symbol.valueDeclaration);
              var staticBaseType = isClass ? getBaseConstructorTypeOfClass(staticType) : anyType;
              var heritageClauses = __spreadArray(__spreadArray([], !ts3.length(baseTypes) ? [] : [ts3.factory.createHeritageClause(94, ts3.map(baseTypes, function(b) {
                return serializeBaseType(b, staticBaseType, localName);
              }))], true), !ts3.length(implementsExpressions) ? [] : [ts3.factory.createHeritageClause(117, implementsExpressions)], true);
              var symbolProps = getNonInterhitedProperties(classType, baseTypes, getPropertiesOfType(classType));
              var publicSymbolProps = ts3.filter(symbolProps, function(s) {
                var valueDecl = s.valueDeclaration;
                return !!valueDecl && !(ts3.isNamedDeclaration(valueDecl) && ts3.isPrivateIdentifier(valueDecl.name));
              });
              var hasPrivateIdentifier = ts3.some(symbolProps, function(s) {
                var valueDecl = s.valueDeclaration;
                return !!valueDecl && ts3.isNamedDeclaration(valueDecl) && ts3.isPrivateIdentifier(valueDecl.name);
              });
              var privateProperties = hasPrivateIdentifier ? [ts3.factory.createPropertyDeclaration(void 0, void 0, ts3.factory.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : ts3.emptyArray;
              var publicProperties = ts3.flatMap(publicSymbolProps, function(p) {
                return serializePropertySymbolForClass(p, false, baseTypes[0]);
              });
              var staticMembers = ts3.flatMap(ts3.filter(getPropertiesOfType(staticType), function(p) {
                return !(p.flags & 4194304) && p.escapedName !== "prototype" && !isNamespaceMember(p);
              }), function(p) {
                return serializePropertySymbolForClass(p, true, staticBaseType);
              });
              var isNonConstructableClassLikeInJsFile = !isClass && !!symbol.valueDeclaration && ts3.isInJSFile(symbol.valueDeclaration) && !ts3.some(getSignaturesOfType(staticType, 1));
              var constructors = isNonConstructableClassLikeInJsFile ? [ts3.factory.createConstructorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(8), [], void 0)] : serializeSignatures(1, staticType, staticBaseType, 171);
              var indexSignatures = serializeIndexSignatures(classType, baseTypes[0]);
              context.enclosingDeclaration = oldEnclosing;
              addResult(ts3.setTextRange(ts3.factory.createClassDeclaration(void 0, void 0, localName, typeParamDecls, heritageClauses, __spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], indexSignatures, true), staticMembers, true), constructors, true), publicProperties, true), privateProperties, true)), symbol.declarations && ts3.filter(symbol.declarations, function(d) {
                return ts3.isClassDeclaration(d) || ts3.isClassExpression(d);
              })[0]), modifierFlags);
            }
            function getSomeTargetNameFromDeclarations(declarations) {
              return ts3.firstDefined(declarations, function(d) {
                if (ts3.isImportSpecifier(d) || ts3.isExportSpecifier(d)) {
                  return ts3.idText(d.propertyName || d.name);
                }
                if (ts3.isBinaryExpression(d) || ts3.isExportAssignment(d)) {
                  var expression = ts3.isExportAssignment(d) ? d.expression : d.right;
                  if (ts3.isPropertyAccessExpression(expression)) {
                    return ts3.idText(expression.name);
                  }
                }
                if (isAliasSymbolDeclaration(d)) {
                  var name = ts3.getNameOfDeclaration(d);
                  if (name && ts3.isIdentifier(name)) {
                    return ts3.idText(name);
                  }
                }
                return void 0;
              });
            }
            function serializeAsAlias(symbol, localName, modifierFlags) {
              var _a, _b, _c, _d, _e;
              var node = getDeclarationOfAliasSymbol(symbol);
              if (!node)
                return ts3.Debug.fail();
              var target = getMergedSymbol(getTargetOfAliasDeclaration(node, true));
              if (!target) {
                return;
              }
              var verbatimTargetName = ts3.isShorthandAmbientModuleSymbol(target) && getSomeTargetNameFromDeclarations(symbol.declarations) || ts3.unescapeLeadingUnderscores(target.escapedName);
              if (verbatimTargetName === "export=" && (ts3.getESModuleInterop(compilerOptions) || compilerOptions.allowSyntheticDefaultImports)) {
                verbatimTargetName = "default";
              }
              var targetName = getInternalSymbolName(target, verbatimTargetName);
              includePrivateSymbol(target);
              switch (node.kind) {
                case 203:
                  if (((_b = (_a = node.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.kind) === 254) {
                    var specifier_1 = getSpecifierForModuleSymbol(target.parent || target, context);
                    var propertyName = node.propertyName;
                    addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamedImports([ts3.factory.createImportSpecifier(false, propertyName && ts3.isIdentifier(propertyName) ? ts3.factory.createIdentifier(ts3.idText(propertyName)) : void 0, ts3.factory.createIdentifier(localName))])), ts3.factory.createStringLiteral(specifier_1), void 0), 0);
                    break;
                  }
                  ts3.Debug.failBadSyntaxKind(((_c = node.parent) === null || _c === void 0 ? void 0 : _c.parent) || node, "Unhandled binding element grandparent kind in declaration serialization");
                  break;
                case 297:
                  if (((_e = (_d = node.parent) === null || _d === void 0 ? void 0 : _d.parent) === null || _e === void 0 ? void 0 : _e.kind) === 221) {
                    serializeExportSpecifier(ts3.unescapeLeadingUnderscores(symbol.escapedName), targetName);
                  }
                  break;
                case 254:
                  if (ts3.isPropertyAccessExpression(node.initializer)) {
                    var initializer = node.initializer;
                    var uniqueName = ts3.factory.createUniqueName(localName);
                    var specifier_2 = getSpecifierForModuleSymbol(target.parent || target, context);
                    addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, uniqueName, ts3.factory.createExternalModuleReference(ts3.factory.createStringLiteral(specifier_2))), 0);
                    addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, ts3.factory.createIdentifier(localName), ts3.factory.createQualifiedName(uniqueName, initializer.name)), modifierFlags);
                    break;
                  }
                case 265:
                  if (target.escapedName === "export=" && ts3.some(target.declarations, ts3.isJsonSourceFile)) {
                    serializeMaybeAliasAssignment(symbol);
                    break;
                  }
                  var isLocalImport = !(target.flags & 512) && !ts3.isVariableDeclaration(node);
                  addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, ts3.factory.createIdentifier(localName), isLocalImport ? symbolToName(target, context, 67108863, false) : ts3.factory.createExternalModuleReference(ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target, context)))), isLocalImport ? modifierFlags : 0);
                  break;
                case 264:
                  addResult(ts3.factory.createNamespaceExportDeclaration(ts3.idText(node.name)), 0);
                  break;
                case 267:
                  addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, ts3.factory.createIdentifier(localName), void 0), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target.parent || target, context)), void 0), 0);
                  break;
                case 268:
                  addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamespaceImport(ts3.factory.createIdentifier(localName))), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target, context)), void 0), 0);
                  break;
                case 274:
                  addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamespaceExport(ts3.factory.createIdentifier(localName)), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target, context))), 0);
                  break;
                case 270:
                  addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamedImports([
                    ts3.factory.createImportSpecifier(false, localName !== verbatimTargetName ? ts3.factory.createIdentifier(verbatimTargetName) : void 0, ts3.factory.createIdentifier(localName))
                  ])), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target.parent || target, context)), void 0), 0);
                  break;
                case 275:
                  var specifier = node.parent.parent.moduleSpecifier;
                  serializeExportSpecifier(ts3.unescapeLeadingUnderscores(symbol.escapedName), specifier ? verbatimTargetName : targetName, specifier && ts3.isStringLiteralLike(specifier) ? ts3.factory.createStringLiteral(specifier.text) : void 0);
                  break;
                case 271:
                  serializeMaybeAliasAssignment(symbol);
                  break;
                case 221:
                case 206:
                case 207:
                  if (symbol.escapedName === "default" || symbol.escapedName === "export=") {
                    serializeMaybeAliasAssignment(symbol);
                  } else {
                    serializeExportSpecifier(localName, targetName);
                  }
                  break;
                default:
                  return ts3.Debug.failBadSyntaxKind(node, "Unhandled alias declaration kind in symbol serializer!");
              }
            }
            function serializeExportSpecifier(localName, targetName, specifier) {
              addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(false, localName !== targetName ? targetName : void 0, localName)]), specifier), 0);
            }
            function serializeMaybeAliasAssignment(symbol) {
              if (symbol.flags & 4194304) {
                return false;
              }
              var name = ts3.unescapeLeadingUnderscores(symbol.escapedName);
              var isExportEquals = name === "export=";
              var isDefault = name === "default";
              var isExportAssignmentCompatibleSymbolName = isExportEquals || isDefault;
              var aliasDecl = symbol.declarations && getDeclarationOfAliasSymbol(symbol);
              var target = aliasDecl && getTargetOfAliasDeclaration(aliasDecl, true);
              if (target && ts3.length(target.declarations) && ts3.some(target.declarations, function(d) {
                return ts3.getSourceFileOfNode(d) === ts3.getSourceFileOfNode(enclosingDeclaration);
              })) {
                var expr = aliasDecl && (ts3.isExportAssignment(aliasDecl) || ts3.isBinaryExpression(aliasDecl) ? ts3.getExportAssignmentExpression(aliasDecl) : ts3.getPropertyAssignmentAliasLikeExpression(aliasDecl));
                var first_1 = expr && ts3.isEntityNameExpression(expr) ? getFirstNonModuleExportsIdentifier(expr) : void 0;
                var referenced = first_1 && resolveEntityName(first_1, 67108863, true, true, enclosingDeclaration);
                if (referenced || target) {
                  includePrivateSymbol(referenced || target);
                }
                var oldTrack = context.tracker.trackSymbol;
                context.tracker.trackSymbol = function() {
                  return false;
                };
                if (isExportAssignmentCompatibleSymbolName) {
                  results.push(ts3.factory.createExportAssignment(void 0, void 0, isExportEquals, symbolToExpression(target, context, 67108863)));
                } else {
                  if (first_1 === expr && first_1) {
                    serializeExportSpecifier(name, ts3.idText(first_1));
                  } else if (expr && ts3.isClassExpression(expr)) {
                    serializeExportSpecifier(name, getInternalSymbolName(target, ts3.symbolName(target)));
                  } else {
                    var varName = getUnusedName(name, symbol);
                    addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, ts3.factory.createIdentifier(varName), symbolToName(target, context, 67108863, false)), 0);
                    serializeExportSpecifier(name, varName);
                  }
                }
                context.tracker.trackSymbol = oldTrack;
                return true;
              } else {
                var varName = getUnusedName(name, symbol);
                var typeToSerialize = getWidenedType(getTypeOfSymbol(getMergedSymbol(symbol)));
                if (isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, symbol)) {
                  serializeAsFunctionNamespaceMerge(typeToSerialize, symbol, varName, isExportAssignmentCompatibleSymbolName ? 0 : 1);
                } else {
                  var statement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
                    ts3.factory.createVariableDeclaration(varName, void 0, serializeTypeForDeclaration(context, typeToSerialize, symbol, enclosingDeclaration, includePrivateSymbol, bundled))
                  ], 2));
                  addResult(statement, target && target.flags & 4 && target.escapedName === "export=" ? 2 : name === varName ? 1 : 0);
                }
                if (isExportAssignmentCompatibleSymbolName) {
                  results.push(ts3.factory.createExportAssignment(void 0, void 0, isExportEquals, ts3.factory.createIdentifier(varName)));
                  return true;
                } else if (name !== varName) {
                  serializeExportSpecifier(name, varName);
                  return true;
                }
                return false;
              }
            }
            function isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, hostSymbol) {
              var ctxSrc = ts3.getSourceFileOfNode(context.enclosingDeclaration);
              return ts3.getObjectFlags(typeToSerialize) & (16 | 32) && !ts3.length(getIndexInfosOfType(typeToSerialize)) && !isClassInstanceSide(typeToSerialize) && !!(ts3.length(ts3.filter(getPropertiesOfType(typeToSerialize), isNamespaceMember)) || ts3.length(getSignaturesOfType(typeToSerialize, 0))) && !ts3.length(getSignaturesOfType(typeToSerialize, 1)) && !getDeclarationWithTypeAnnotation(hostSymbol, enclosingDeclaration) && !(typeToSerialize.symbol && ts3.some(typeToSerialize.symbol.declarations, function(d) {
                return ts3.getSourceFileOfNode(d) !== ctxSrc;
              })) && !ts3.some(getPropertiesOfType(typeToSerialize), function(p) {
                return isLateBoundName(p.escapedName);
              }) && !ts3.some(getPropertiesOfType(typeToSerialize), function(p) {
                return ts3.some(p.declarations, function(d) {
                  return ts3.getSourceFileOfNode(d) !== ctxSrc;
                });
              }) && ts3.every(getPropertiesOfType(typeToSerialize), function(p) {
                return ts3.isIdentifierText(ts3.symbolName(p), languageVersion);
              });
            }
            function makeSerializePropertySymbol(createProperty, methodKind, useAccessors) {
              return function serializePropertySymbol(p, isStatic, baseType) {
                var _a, _b, _c, _d, _e;
                var modifierFlags = ts3.getDeclarationModifierFlagsFromSymbol(p);
                var isPrivate = !!(modifierFlags & 8);
                if (isStatic && p.flags & (788968 | 1920 | 2097152)) {
                  return [];
                }
                if (p.flags & 4194304 || baseType && getPropertyOfType(baseType, p.escapedName) && isReadonlySymbol(getPropertyOfType(baseType, p.escapedName)) === isReadonlySymbol(p) && (p.flags & 16777216) === (getPropertyOfType(baseType, p.escapedName).flags & 16777216) && isTypeIdenticalTo(getTypeOfSymbol(p), getTypeOfPropertyOfType(baseType, p.escapedName))) {
                  return [];
                }
                var flag = modifierFlags & ~256 | (isStatic ? 32 : 0);
                var name = getPropertyNameNodeForSymbol(p, context);
                var firstPropertyLikeDecl = (_a = p.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.or(ts3.isPropertyDeclaration, ts3.isAccessor, ts3.isVariableDeclaration, ts3.isPropertySignature, ts3.isBinaryExpression, ts3.isPropertyAccessExpression));
                if (p.flags & 98304 && useAccessors) {
                  var result2 = [];
                  if (p.flags & 65536) {
                    result2.push(ts3.setTextRange(ts3.factory.createSetAccessorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(flag), name, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "arg", void 0, isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled))], void 0), ((_b = p.declarations) === null || _b === void 0 ? void 0 : _b.find(ts3.isSetAccessor)) || firstPropertyLikeDecl));
                  }
                  if (p.flags & 32768) {
                    var isPrivate_1 = modifierFlags & 8;
                    result2.push(ts3.setTextRange(ts3.factory.createGetAccessorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(flag), name, [], isPrivate_1 ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled), void 0), ((_c = p.declarations) === null || _c === void 0 ? void 0 : _c.find(ts3.isGetAccessor)) || firstPropertyLikeDecl));
                  }
                  return result2;
                } else if (p.flags & (4 | 3 | 98304)) {
                  return ts3.setTextRange(createProperty(void 0, ts3.factory.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 64 : 0) | flag), name, p.flags & 16777216 ? ts3.factory.createToken(57) : void 0, isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled), void 0), ((_d = p.declarations) === null || _d === void 0 ? void 0 : _d.find(ts3.or(ts3.isPropertyDeclaration, ts3.isVariableDeclaration))) || firstPropertyLikeDecl);
                }
                if (p.flags & (8192 | 16)) {
                  var type2 = getTypeOfSymbol(p);
                  var signatures = getSignaturesOfType(type2, 0);
                  if (flag & 8) {
                    return ts3.setTextRange(createProperty(void 0, ts3.factory.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 64 : 0) | flag), name, p.flags & 16777216 ? ts3.factory.createToken(57) : void 0, void 0, void 0), ((_e = p.declarations) === null || _e === void 0 ? void 0 : _e.find(ts3.isFunctionLikeDeclaration)) || signatures[0] && signatures[0].declaration || p.declarations && p.declarations[0]);
                  }
                  var results_1 = [];
                  for (var _i = 0, signatures_3 = signatures; _i < signatures_3.length; _i++) {
                    var sig = signatures_3[_i];
                    var decl = signatureToSignatureDeclarationHelper(sig, methodKind, context, {
                      name,
                      questionToken: p.flags & 16777216 ? ts3.factory.createToken(57) : void 0,
                      modifiers: flag ? ts3.factory.createModifiersFromModifierFlags(flag) : void 0
                    });
                    var location = sig.declaration && ts3.isPrototypePropertyAssignment(sig.declaration.parent) ? sig.declaration.parent : sig.declaration;
                    results_1.push(ts3.setTextRange(decl, location));
                  }
                  return results_1;
                }
                return ts3.Debug.fail("Unhandled class member kind! ".concat(p.__debugFlags || p.flags));
              };
            }
            function serializePropertySymbolForInterface(p, baseType) {
              return serializePropertySymbolForInterfaceWorker(p, false, baseType);
            }
            function serializeSignatures(kind, input, baseType, outputKind) {
              var signatures = getSignaturesOfType(input, kind);
              if (kind === 1) {
                if (!baseType && ts3.every(signatures, function(s2) {
                  return ts3.length(s2.parameters) === 0;
                })) {
                  return [];
                }
                if (baseType) {
                  var baseSigs = getSignaturesOfType(baseType, 1);
                  if (!ts3.length(baseSigs) && ts3.every(signatures, function(s2) {
                    return ts3.length(s2.parameters) === 0;
                  })) {
                    return [];
                  }
                  if (baseSigs.length === signatures.length) {
                    var failed = false;
                    for (var i = 0; i < baseSigs.length; i++) {
                      if (!compareSignaturesIdentical(signatures[i], baseSigs[i], false, false, true, compareTypesIdentical)) {
                        failed = true;
                        break;
                      }
                    }
                    if (!failed) {
                      return [];
                    }
                  }
                }
                var privateProtected = 0;
                for (var _i = 0, signatures_4 = signatures; _i < signatures_4.length; _i++) {
                  var s = signatures_4[_i];
                  if (s.declaration) {
                    privateProtected |= ts3.getSelectedEffectiveModifierFlags(s.declaration, 8 | 16);
                  }
                }
                if (privateProtected) {
                  return [ts3.setTextRange(ts3.factory.createConstructorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(privateProtected), [], void 0), signatures[0].declaration)];
                }
              }
              var results2 = [];
              for (var _a = 0, signatures_5 = signatures; _a < signatures_5.length; _a++) {
                var sig = signatures_5[_a];
                var decl = signatureToSignatureDeclarationHelper(sig, outputKind, context);
                results2.push(ts3.setTextRange(decl, sig.declaration));
              }
              return results2;
            }
            function serializeIndexSignatures(input, baseType) {
              var results2 = [];
              for (var _i = 0, _a = getIndexInfosOfType(input); _i < _a.length; _i++) {
                var info = _a[_i];
                if (baseType) {
                  var baseInfo = getIndexInfoOfType(baseType, info.keyType);
                  if (baseInfo) {
                    if (isTypeIdenticalTo(info.type, baseInfo.type)) {
                      continue;
                    }
                  }
                }
                results2.push(indexInfoToIndexSignatureDeclarationHelper(info, context, void 0));
              }
              return results2;
            }
            function serializeBaseType(t, staticType, rootName) {
              var ref = trySerializeAsTypeReference(t, 111551);
              if (ref) {
                return ref;
              }
              var tempName = getUnusedName("".concat(rootName, "_base"));
              var statement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
                ts3.factory.createVariableDeclaration(tempName, void 0, typeToTypeNodeHelper(staticType, context))
              ], 2));
              addResult(statement, 0);
              return ts3.factory.createExpressionWithTypeArguments(ts3.factory.createIdentifier(tempName), void 0);
            }
            function trySerializeAsTypeReference(t, flags) {
              var typeArgs;
              var reference;
              if (t.target && isSymbolAccessibleByFlags(t.target.symbol, enclosingDeclaration, flags)) {
                typeArgs = ts3.map(getTypeArguments(t), function(t2) {
                  return typeToTypeNodeHelper(t2, context);
                });
                reference = symbolToExpression(t.target.symbol, context, 788968);
              } else if (t.symbol && isSymbolAccessibleByFlags(t.symbol, enclosingDeclaration, flags)) {
                reference = symbolToExpression(t.symbol, context, 788968);
              }
              if (reference) {
                return ts3.factory.createExpressionWithTypeArguments(reference, typeArgs);
              }
            }
            function serializeImplementedType(t) {
              var ref = trySerializeAsTypeReference(t, 788968);
              if (ref) {
                return ref;
              }
              if (t.symbol) {
                return ts3.factory.createExpressionWithTypeArguments(symbolToExpression(t.symbol, context, 788968), void 0);
              }
            }
            function getUnusedName(input, symbol) {
              var _a, _b;
              var id = symbol ? getSymbolId(symbol) : void 0;
              if (id) {
                if (context.remappedSymbolNames.has(id)) {
                  return context.remappedSymbolNames.get(id);
                }
              }
              if (symbol) {
                input = getNameCandidateWorker(symbol, input);
              }
              var i = 0;
              var original = input;
              while ((_a = context.usedSymbolNames) === null || _a === void 0 ? void 0 : _a.has(input)) {
                i++;
                input = "".concat(original, "_").concat(i);
              }
              (_b = context.usedSymbolNames) === null || _b === void 0 ? void 0 : _b.add(input);
              if (id) {
                context.remappedSymbolNames.set(id, input);
              }
              return input;
            }
            function getNameCandidateWorker(symbol, localName) {
              if (localName === "default" || localName === "__class" || localName === "__function") {
                var flags = context.flags;
                context.flags |= 16777216;
                var nameCandidate = getNameOfSymbolAsWritten(symbol, context);
                context.flags = flags;
                localName = nameCandidate.length > 0 && ts3.isSingleOrDoubleQuote(nameCandidate.charCodeAt(0)) ? ts3.stripQuotes(nameCandidate) : nameCandidate;
              }
              if (localName === "default") {
                localName = "_default";
              } else if (localName === "export=") {
                localName = "_exports";
              }
              localName = ts3.isIdentifierText(localName, languageVersion) && !ts3.isStringANonContextualKeyword(localName) ? localName : "_" + localName.replace(/[^a-zA-Z0-9]/g, "_");
              return localName;
            }
            function getInternalSymbolName(symbol, localName) {
              var id = getSymbolId(symbol);
              if (context.remappedSymbolNames.has(id)) {
                return context.remappedSymbolNames.get(id);
              }
              localName = getNameCandidateWorker(symbol, localName);
              context.remappedSymbolNames.set(id, localName);
              return localName;
            }
          }
        }
        function typePredicateToString(typePredicate, enclosingDeclaration, flags, writer) {
          if (flags === void 0) {
            flags = 16384;
          }
          return writer ? typePredicateToStringWorker(writer).getText() : ts3.usingSingleLineStringWriter(typePredicateToStringWorker);
          function typePredicateToStringWorker(writer2) {
            var predicate = ts3.factory.createTypePredicateNode(typePredicate.kind === 2 || typePredicate.kind === 3 ? ts3.factory.createToken(128) : void 0, typePredicate.kind === 1 || typePredicate.kind === 3 ? ts3.factory.createIdentifier(typePredicate.parameterName) : ts3.factory.createThisTypeNode(), typePredicate.type && nodeBuilder.typeToTypeNode(typePredicate.type, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | 512));
            var printer2 = ts3.createPrinter({ removeComments: true });
            var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
            printer2.writeNode(4, predicate, sourceFile, writer2);
            return writer2;
          }
        }
        function formatUnionTypes(types2) {
          var result2 = [];
          var flags = 0;
          for (var i = 0; i < types2.length; i++) {
            var t = types2[i];
            flags |= t.flags;
            if (!(t.flags & 98304)) {
              if (t.flags & (512 | 1024)) {
                var baseType = t.flags & 512 ? booleanType : getBaseTypeOfEnumLiteralType(t);
                if (baseType.flags & 1048576) {
                  var count = baseType.types.length;
                  if (i + count <= types2.length && getRegularTypeOfLiteralType(types2[i + count - 1]) === getRegularTypeOfLiteralType(baseType.types[count - 1])) {
                    result2.push(baseType);
                    i += count - 1;
                    continue;
                  }
                }
              }
              result2.push(t);
            }
          }
          if (flags & 65536)
            result2.push(nullType);
          if (flags & 32768)
            result2.push(undefinedType);
          return result2 || types2;
        }
        function visibilityToString(flags) {
          if (flags === 8) {
            return "private";
          }
          if (flags === 16) {
            return "protected";
          }
          return "public";
        }
        function getTypeAliasForTypeLiteral(type2) {
          if (type2.symbol && type2.symbol.flags & 2048 && type2.symbol.declarations) {
            var node = ts3.walkUpParenthesizedTypes(type2.symbol.declarations[0].parent);
            if (node.kind === 259) {
              return getSymbolOfNode(node);
            }
          }
          return void 0;
        }
        function isTopLevelInExternalModuleAugmentation(node) {
          return node && node.parent && node.parent.kind === 262 && ts3.isExternalModuleAugmentation(node.parent.parent);
        }
        function isDefaultBindingContext(location) {
          return location.kind === 305 || ts3.isAmbientModule(location);
        }
        function getNameOfSymbolFromNameType(symbol, context) {
          var nameType = getSymbolLinks(symbol).nameType;
          if (nameType) {
            if (nameType.flags & 384) {
              var name = "" + nameType.value;
              if (!ts3.isIdentifierText(name, ts3.getEmitScriptTarget(compilerOptions)) && !ts3.isNumericLiteralName(name)) {
                return '"'.concat(ts3.escapeString(name, 34), '"');
              }
              if (ts3.isNumericLiteralName(name) && ts3.startsWith(name, "-")) {
                return "[".concat(name, "]");
              }
              return name;
            }
            if (nameType.flags & 8192) {
              return "[".concat(getNameOfSymbolAsWritten(nameType.symbol, context), "]");
            }
          }
        }
        function getNameOfSymbolAsWritten(symbol, context) {
          if (context && symbol.escapedName === "default" && !(context.flags & 16384) && (!(context.flags & 16777216) || !symbol.declarations || context.enclosingDeclaration && ts3.findAncestor(symbol.declarations[0], isDefaultBindingContext) !== ts3.findAncestor(context.enclosingDeclaration, isDefaultBindingContext))) {
            return "default";
          }
          if (symbol.declarations && symbol.declarations.length) {
            var declaration = ts3.firstDefined(symbol.declarations, function(d) {
              return ts3.getNameOfDeclaration(d) ? d : void 0;
            });
            var name_4 = declaration && ts3.getNameOfDeclaration(declaration);
            if (declaration && name_4) {
              if (ts3.isCallExpression(declaration) && ts3.isBindableObjectDefinePropertyCall(declaration)) {
                return ts3.symbolName(symbol);
              }
              if (ts3.isComputedPropertyName(name_4) && !(ts3.getCheckFlags(symbol) & 4096)) {
                var nameType = getSymbolLinks(symbol).nameType;
                if (nameType && nameType.flags & 384) {
                  var result2 = getNameOfSymbolFromNameType(symbol, context);
                  if (result2 !== void 0) {
                    return result2;
                  }
                }
              }
              return ts3.declarationNameToString(name_4);
            }
            if (!declaration) {
              declaration = symbol.declarations[0];
            }
            if (declaration.parent && declaration.parent.kind === 254) {
              return ts3.declarationNameToString(declaration.parent.name);
            }
            switch (declaration.kind) {
              case 226:
              case 213:
              case 214:
                if (context && !context.encounteredError && !(context.flags & 131072)) {
                  context.encounteredError = true;
                }
                return declaration.kind === 226 ? "(Anonymous class)" : "(Anonymous function)";
            }
          }
          var name = getNameOfSymbolFromNameType(symbol, context);
          return name !== void 0 ? name : ts3.symbolName(symbol);
        }
        function isDeclarationVisible(node) {
          if (node) {
            var links = getNodeLinks(node);
            if (links.isVisible === void 0) {
              links.isVisible = !!determineIfDeclarationIsVisible();
            }
            return links.isVisible;
          }
          return false;
          function determineIfDeclarationIsVisible() {
            switch (node.kind) {
              case 338:
              case 345:
              case 339:
                return !!(node.parent && node.parent.parent && node.parent.parent.parent && ts3.isSourceFile(node.parent.parent.parent));
              case 203:
                return isDeclarationVisible(node.parent.parent);
              case 254:
                if (ts3.isBindingPattern(node.name) && !node.name.elements.length) {
                  return false;
                }
              case 261:
              case 257:
              case 258:
              case 259:
              case 256:
              case 260:
              case 265:
                if (ts3.isExternalModuleAugmentation(node)) {
                  return true;
                }
                var parent = getDeclarationContainer(node);
                if (!(ts3.getCombinedModifierFlags(node) & 1) && !(node.kind !== 265 && parent.kind !== 305 && parent.flags & 16777216)) {
                  return isGlobalSourceFile(parent);
                }
                return isDeclarationVisible(parent);
              case 167:
              case 166:
              case 172:
              case 173:
              case 169:
              case 168:
                if (ts3.hasEffectiveModifier(node, 8 | 16)) {
                  return false;
                }
              case 171:
              case 175:
              case 174:
              case 176:
              case 164:
              case 262:
              case 179:
              case 180:
              case 182:
              case 178:
              case 183:
              case 184:
              case 187:
              case 188:
              case 191:
              case 197:
                return isDeclarationVisible(node.parent);
              case 267:
              case 268:
              case 270:
                return false;
              case 163:
              case 305:
              case 264:
                return true;
              case 271:
                return false;
              default:
                return false;
            }
          }
        }
        function collectLinkedAliases(node, setVisibility) {
          var exportSymbol;
          if (node.parent && node.parent.kind === 271) {
            exportSymbol = resolveName(node, node.escapedText, 111551 | 788968 | 1920 | 2097152, void 0, node, false);
          } else if (node.parent.kind === 275) {
            exportSymbol = getTargetOfExportSpecifier(node.parent, 111551 | 788968 | 1920 | 2097152);
          }
          var result2;
          var visited;
          if (exportSymbol) {
            visited = new ts3.Set();
            visited.add(getSymbolId(exportSymbol));
            buildVisibleNodeList(exportSymbol.declarations);
          }
          return result2;
          function buildVisibleNodeList(declarations) {
            ts3.forEach(declarations, function(declaration) {
              var resultNode = getAnyImportSyntax(declaration) || declaration;
              if (setVisibility) {
                getNodeLinks(declaration).isVisible = true;
              } else {
                result2 = result2 || [];
                ts3.pushIfUnique(result2, resultNode);
              }
              if (ts3.isInternalModuleImportEqualsDeclaration(declaration)) {
                var internalModuleReference = declaration.moduleReference;
                var firstIdentifier = ts3.getFirstIdentifier(internalModuleReference);
                var importSymbol = resolveName(declaration, firstIdentifier.escapedText, 111551 | 788968 | 1920, void 0, void 0, false);
                if (importSymbol && visited) {
                  if (ts3.tryAddToSet(visited, getSymbolId(importSymbol))) {
                    buildVisibleNodeList(importSymbol.declarations);
                  }
                }
              }
            });
          }
        }
        function pushTypeResolution(target, propertyName) {
          var resolutionCycleStartIndex = findResolutionCycleStartIndex(target, propertyName);
          if (resolutionCycleStartIndex >= 0) {
            var length_3 = resolutionTargets.length;
            for (var i = resolutionCycleStartIndex; i < length_3; i++) {
              resolutionResults[i] = false;
            }
            return false;
          }
          resolutionTargets.push(target);
          resolutionResults.push(true);
          resolutionPropertyNames.push(propertyName);
          return true;
        }
        function findResolutionCycleStartIndex(target, propertyName) {
          for (var i = resolutionTargets.length - 1; i >= 0; i--) {
            if (hasType(resolutionTargets[i], resolutionPropertyNames[i])) {
              return -1;
            }
            if (resolutionTargets[i] === target && resolutionPropertyNames[i] === propertyName) {
              return i;
            }
          }
          return -1;
        }
        function hasType(target, propertyName) {
          switch (propertyName) {
            case 0:
              return !!getSymbolLinks(target).type;
            case 5:
              return !!getNodeLinks(target).resolvedEnumType;
            case 2:
              return !!getSymbolLinks(target).declaredType;
            case 1:
              return !!target.resolvedBaseConstructorType;
            case 3:
              return !!target.resolvedReturnType;
            case 4:
              return !!target.immediateBaseConstraint;
            case 6:
              return !!target.resolvedTypeArguments;
            case 7:
              return !!target.baseTypesResolved;
            case 8:
              return !!getSymbolLinks(target).writeType;
          }
          return ts3.Debug.assertNever(propertyName);
        }
        function popTypeResolution() {
          resolutionTargets.pop();
          resolutionPropertyNames.pop();
          return resolutionResults.pop();
        }
        function getDeclarationContainer(node) {
          return ts3.findAncestor(ts3.getRootDeclaration(node), function(node2) {
            switch (node2.kind) {
              case 254:
              case 255:
              case 270:
              case 269:
              case 268:
              case 267:
                return false;
              default:
                return true;
            }
          }).parent;
        }
        function getTypeOfPrototypeProperty(prototype) {
          var classType = getDeclaredTypeOfSymbol(getParentOfSymbol(prototype));
          return classType.typeParameters ? createTypeReference(classType, ts3.map(classType.typeParameters, function(_) {
            return anyType;
          })) : classType;
        }
        function getTypeOfPropertyOfType(type2, name) {
          var prop = getPropertyOfType(type2, name);
          return prop ? getTypeOfSymbol(prop) : void 0;
        }
        function getTypeOfPropertyOrIndexSignature(type2, name) {
          var _a;
          return getTypeOfPropertyOfType(type2, name) || ((_a = getApplicableIndexInfoForName(type2, name)) === null || _a === void 0 ? void 0 : _a.type) || unknownType;
        }
        function isTypeAny(type2) {
          return type2 && (type2.flags & 1) !== 0;
        }
        function isErrorType(type2) {
          return type2 === errorType || !!(type2.flags & 1 && type2.aliasSymbol);
        }
        function getTypeForBindingElementParent(node, checkMode) {
          if (checkMode !== 0) {
            return getTypeForVariableLikeDeclaration(node, false, checkMode);
          }
          var symbol = getSymbolOfNode(node);
          return symbol && getSymbolLinks(symbol).type || getTypeForVariableLikeDeclaration(node, false, checkMode);
        }
        function getRestType(source, properties, symbol) {
          source = filterType(source, function(t) {
            return !(t.flags & 98304);
          });
          if (source.flags & 131072) {
            return emptyObjectType;
          }
          if (source.flags & 1048576) {
            return mapType(source, function(t) {
              return getRestType(t, properties, symbol);
            });
          }
          var omitKeyType = getUnionType(ts3.map(properties, getLiteralTypeFromPropertyName));
          var spreadableProperties = [];
          var unspreadableToRestKeys = [];
          for (var _i = 0, _a = getPropertiesOfType(source); _i < _a.length; _i++) {
            var prop = _a[_i];
            var literalTypeFromProperty = getLiteralTypeFromProperty(prop, 8576);
            if (!isTypeAssignableTo(literalTypeFromProperty, omitKeyType) && !(ts3.getDeclarationModifierFlagsFromSymbol(prop) & (8 | 16)) && isSpreadableProperty(prop)) {
              spreadableProperties.push(prop);
            } else {
              unspreadableToRestKeys.push(literalTypeFromProperty);
            }
          }
          if (isGenericObjectType(source) || isGenericIndexType(omitKeyType)) {
            if (unspreadableToRestKeys.length) {
              omitKeyType = getUnionType(__spreadArray([omitKeyType], unspreadableToRestKeys, true));
            }
            if (omitKeyType.flags & 131072) {
              return source;
            }
            var omitTypeAlias = getGlobalOmitSymbol();
            if (!omitTypeAlias) {
              return errorType;
            }
            return getTypeAliasInstantiation(omitTypeAlias, [source, omitKeyType]);
          }
          var members = ts3.createSymbolTable();
          for (var _b = 0, spreadableProperties_1 = spreadableProperties; _b < spreadableProperties_1.length; _b++) {
            var prop = spreadableProperties_1[_b];
            members.set(prop.escapedName, getSpreadSymbol(prop, false));
          }
          var result2 = createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, getIndexInfosOfType(source));
          result2.objectFlags |= 4194304;
          return result2;
        }
        function isGenericTypeWithUndefinedConstraint(type2) {
          return !!(type2.flags & 465829888) && maybeTypeOfKind(getBaseConstraintOfType(type2) || unknownType, 32768);
        }
        function getNonUndefinedType(type2) {
          var typeOrConstraint = someType(type2, isGenericTypeWithUndefinedConstraint) ? mapType(type2, function(t) {
            return t.flags & 465829888 ? getBaseConstraintOrType(t) : t;
          }) : type2;
          return getTypeWithFacts(typeOrConstraint, 524288);
        }
        function getFlowTypeOfDestructuring(node, declaredType) {
          var reference = getSyntheticElementAccess(node);
          return reference ? getFlowTypeOfReference(reference, declaredType) : declaredType;
        }
        function getSyntheticElementAccess(node) {
          var parentAccess = getParentElementAccess(node);
          if (parentAccess && parentAccess.flowNode) {
            var propName = getDestructuringPropertyName(node);
            if (propName) {
              var literal = ts3.setTextRange(ts3.parseNodeFactory.createStringLiteral(propName), node);
              var lhsExpr = ts3.isLeftHandSideExpression(parentAccess) ? parentAccess : ts3.parseNodeFactory.createParenthesizedExpression(parentAccess);
              var result2 = ts3.setTextRange(ts3.parseNodeFactory.createElementAccessExpression(lhsExpr, literal), node);
              ts3.setParent(literal, result2);
              ts3.setParent(result2, node);
              if (lhsExpr !== parentAccess) {
                ts3.setParent(lhsExpr, result2);
              }
              result2.flowNode = parentAccess.flowNode;
              return result2;
            }
          }
        }
        function getParentElementAccess(node) {
          var ancestor = node.parent.parent;
          switch (ancestor.kind) {
            case 203:
            case 296:
              return getSyntheticElementAccess(ancestor);
            case 204:
              return getSyntheticElementAccess(node.parent);
            case 254:
              return ancestor.initializer;
            case 221:
              return ancestor.right;
          }
        }
        function getDestructuringPropertyName(node) {
          var parent = node.parent;
          if (node.kind === 203 && parent.kind === 201) {
            return getLiteralPropertyNameText(node.propertyName || node.name);
          }
          if (node.kind === 296 || node.kind === 297) {
            return getLiteralPropertyNameText(node.name);
          }
          return "" + parent.elements.indexOf(node);
        }
        function getLiteralPropertyNameText(name) {
          var type2 = getLiteralTypeFromPropertyName(name);
          return type2.flags & (128 | 256) ? "" + type2.value : void 0;
        }
        function getTypeForBindingElement(declaration) {
          var checkMode = declaration.dotDotDotToken ? 64 : 0;
          var parentType = getTypeForBindingElementParent(declaration.parent.parent, checkMode);
          return parentType && getBindingElementTypeFromParentType(declaration, parentType);
        }
        function getBindingElementTypeFromParentType(declaration, parentType) {
          if (isTypeAny(parentType)) {
            return parentType;
          }
          var pattern = declaration.parent;
          if (strictNullChecks && declaration.flags & 16777216 && ts3.isParameterDeclaration(declaration)) {
            parentType = getNonNullableType(parentType);
          } else if (strictNullChecks && pattern.parent.initializer && !(getTypeFacts(getTypeOfInitializer(pattern.parent.initializer)) & 65536)) {
            parentType = getTypeWithFacts(parentType, 524288);
          }
          var type2;
          if (pattern.kind === 201) {
            if (declaration.dotDotDotToken) {
              parentType = getReducedType(parentType);
              if (parentType.flags & 2 || !isValidSpreadType(parentType)) {
                error(declaration, ts3.Diagnostics.Rest_types_may_only_be_created_from_object_types);
                return errorType;
              }
              var literalMembers = [];
              for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
                var element = _a[_i];
                if (!element.dotDotDotToken) {
                  literalMembers.push(element.propertyName || element.name);
                }
              }
              type2 = getRestType(parentType, literalMembers, declaration.symbol);
            } else {
              var name = declaration.propertyName || declaration.name;
              var indexType = getLiteralTypeFromPropertyName(name);
              var declaredType = getIndexedAccessType(parentType, indexType, 32, name);
              type2 = getFlowTypeOfDestructuring(declaration, declaredType);
            }
          } else {
            var elementType = checkIteratedTypeOrElementType(65 | (declaration.dotDotDotToken ? 0 : 128), parentType, undefinedType, pattern);
            var index_2 = pattern.elements.indexOf(declaration);
            if (declaration.dotDotDotToken) {
              type2 = everyType(parentType, isTupleType) ? mapType(parentType, function(t) {
                return sliceTupleType(t, index_2);
              }) : createArrayType(elementType);
            } else if (isArrayLikeType(parentType)) {
              var indexType = getNumberLiteralType(index_2);
              var accessFlags = 32 | (hasDefaultValue(declaration) ? 16 : 0);
              var declaredType = getIndexedAccessTypeOrUndefined(parentType, indexType, accessFlags, declaration.name) || errorType;
              type2 = getFlowTypeOfDestructuring(declaration, declaredType);
            } else {
              type2 = elementType;
            }
          }
          if (!declaration.initializer) {
            return type2;
          }
          if (ts3.getEffectiveTypeAnnotationNode(ts3.walkUpBindingElementsAndPatterns(declaration))) {
            return strictNullChecks && !(getFalsyFlags(checkDeclarationInitializer(declaration, 0)) & 32768) ? getNonUndefinedType(type2) : type2;
          }
          return widenTypeInferredFromInitializer(declaration, getUnionType([getNonUndefinedType(type2), checkDeclarationInitializer(declaration, 0)], 2));
        }
        function getTypeForDeclarationFromJSDocComment(declaration) {
          var jsdocType = ts3.getJSDocType(declaration);
          if (jsdocType) {
            return getTypeFromTypeNode(jsdocType);
          }
          return void 0;
        }
        function isNullOrUndefined(node) {
          var expr = ts3.skipParentheses(node, true);
          return expr.kind === 104 || expr.kind === 79 && getResolvedSymbol(expr) === undefinedSymbol;
        }
        function isEmptyArrayLiteral(node) {
          var expr = ts3.skipParentheses(node, true);
          return expr.kind === 204 && expr.elements.length === 0;
        }
        function addOptionality(type2, isProperty, isOptional) {
          if (isProperty === void 0) {
            isProperty = false;
          }
          if (isOptional === void 0) {
            isOptional = true;
          }
          return strictNullChecks && isOptional ? getOptionalType(type2, isProperty) : type2;
        }
        function getTypeForVariableLikeDeclaration(declaration, includeOptionality, checkMode) {
          if (ts3.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 243) {
            var indexType = getIndexType(getNonNullableTypeIfNeeded(checkExpression(declaration.parent.parent.expression, checkMode)));
            return indexType.flags & (262144 | 4194304) ? getExtractStringType(indexType) : stringType;
          }
          if (ts3.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 244) {
            var forOfStatement = declaration.parent.parent;
            return checkRightHandSideOfForOf(forOfStatement) || anyType;
          }
          if (ts3.isBindingPattern(declaration.parent)) {
            return getTypeForBindingElement(declaration);
          }
          var isProperty = ts3.isPropertyDeclaration(declaration) || ts3.isPropertySignature(declaration);
          var isOptional = includeOptionality && (isProperty && !!declaration.questionToken || ts3.isParameter(declaration) && (!!declaration.questionToken || isJSDocOptionalParameter(declaration)) || isOptionalJSDocPropertyLikeTag(declaration));
          var declaredType = tryGetTypeFromEffectiveTypeNode(declaration);
          if (declaredType) {
            return addOptionality(declaredType, isProperty, isOptional);
          }
          if ((noImplicitAny || ts3.isInJSFile(declaration)) && ts3.isVariableDeclaration(declaration) && !ts3.isBindingPattern(declaration.name) && !(ts3.getCombinedModifierFlags(declaration) & 1) && !(declaration.flags & 16777216)) {
            if (!(ts3.getCombinedNodeFlags(declaration) & 2) && (!declaration.initializer || isNullOrUndefined(declaration.initializer))) {
              return autoType;
            }
            if (declaration.initializer && isEmptyArrayLiteral(declaration.initializer)) {
              return autoArrayType;
            }
          }
          if (ts3.isParameter(declaration)) {
            var func = declaration.parent;
            if (func.kind === 173 && hasBindableName(func)) {
              var getter = ts3.getDeclarationOfKind(getSymbolOfNode(declaration.parent), 172);
              if (getter) {
                var getterSignature = getSignatureFromDeclaration(getter);
                var thisParameter = getAccessorThisParameter(func);
                if (thisParameter && declaration === thisParameter) {
                  ts3.Debug.assert(!thisParameter.type);
                  return getTypeOfSymbol(getterSignature.thisParameter);
                }
                return getReturnTypeOfSignature(getterSignature);
              }
            }
            if (ts3.isInJSFile(declaration)) {
              var type_1 = getParameterTypeOfTypeTag(func, declaration);
              if (type_1)
                return type_1;
            }
            var type2 = declaration.symbol.escapedName === "this" ? getContextualThisParameterType(func) : getContextuallyTypedParameterType(declaration);
            if (type2) {
              return addOptionality(type2, false, isOptional);
            }
          }
          if (ts3.hasOnlyExpressionInitializer(declaration) && !!declaration.initializer) {
            if (ts3.isInJSFile(declaration) && !ts3.isParameter(declaration)) {
              var containerObjectType = getJSContainerObjectType(declaration, getSymbolOfNode(declaration), ts3.getDeclaredExpandoInitializer(declaration));
              if (containerObjectType) {
                return containerObjectType;
              }
            }
            var type2 = widenTypeInferredFromInitializer(declaration, checkDeclarationInitializer(declaration, checkMode));
            return addOptionality(type2, isProperty, isOptional);
          }
          if (ts3.isPropertyDeclaration(declaration) && (noImplicitAny || ts3.isInJSFile(declaration))) {
            if (!ts3.hasStaticModifier(declaration)) {
              var constructor = findConstructorDeclaration(declaration.parent);
              var type2 = constructor ? getFlowTypeInConstructor(declaration.symbol, constructor) : ts3.getEffectiveModifierFlags(declaration) & 2 ? getTypeOfPropertyInBaseClass(declaration.symbol) : void 0;
              return type2 && addOptionality(type2, true, isOptional);
            } else {
              var staticBlocks = ts3.filter(declaration.parent.members, ts3.isClassStaticBlockDeclaration);
              var type2 = staticBlocks.length ? getFlowTypeInStaticBlocks(declaration.symbol, staticBlocks) : ts3.getEffectiveModifierFlags(declaration) & 2 ? getTypeOfPropertyInBaseClass(declaration.symbol) : void 0;
              return type2 && addOptionality(type2, true, isOptional);
            }
          }
          if (ts3.isJsxAttribute(declaration)) {
            return trueType;
          }
          if (ts3.isBindingPattern(declaration.name)) {
            return getTypeFromBindingPattern(declaration.name, false, true);
          }
          return void 0;
        }
        function isConstructorDeclaredProperty(symbol) {
          if (symbol.valueDeclaration && ts3.isBinaryExpression(symbol.valueDeclaration)) {
            var links = getSymbolLinks(symbol);
            if (links.isConstructorDeclaredProperty === void 0) {
              links.isConstructorDeclaredProperty = false;
              links.isConstructorDeclaredProperty = !!getDeclaringConstructor(symbol) && ts3.every(symbol.declarations, function(declaration) {
                return ts3.isBinaryExpression(declaration) && isPossiblyAliasedThisProperty(declaration) && (declaration.left.kind !== 207 || ts3.isStringOrNumericLiteralLike(declaration.left.argumentExpression)) && !getAnnotatedTypeForAssignmentDeclaration(void 0, declaration, symbol, declaration);
              });
            }
            return links.isConstructorDeclaredProperty;
          }
          return false;
        }
        function isAutoTypedProperty(symbol) {
          var declaration = symbol.valueDeclaration;
          return declaration && ts3.isPropertyDeclaration(declaration) && !ts3.getEffectiveTypeAnnotationNode(declaration) && !declaration.initializer && (noImplicitAny || ts3.isInJSFile(declaration));
        }
        function getDeclaringConstructor(symbol) {
          if (!symbol.declarations) {
            return;
          }
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            var container = ts3.getThisContainer(declaration, false);
            if (container && (container.kind === 171 || isJSConstructor(container))) {
              return container;
            }
          }
          ;
        }
        function getFlowTypeFromCommonJSExport(symbol) {
          var file = ts3.getSourceFileOfNode(symbol.declarations[0]);
          var accessName = ts3.unescapeLeadingUnderscores(symbol.escapedName);
          var areAllModuleExports = symbol.declarations.every(function(d) {
            return ts3.isInJSFile(d) && ts3.isAccessExpression(d) && ts3.isModuleExportsAccessExpression(d.expression);
          });
          var reference = areAllModuleExports ? ts3.factory.createPropertyAccessExpression(ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier("module"), ts3.factory.createIdentifier("exports")), accessName) : ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier("exports"), accessName);
          if (areAllModuleExports) {
            ts3.setParent(reference.expression.expression, reference.expression);
          }
          ts3.setParent(reference.expression, reference);
          ts3.setParent(reference, file);
          reference.flowNode = file.endFlowNode;
          return getFlowTypeOfReference(reference, autoType, undefinedType);
        }
        function getFlowTypeInStaticBlocks(symbol, staticBlocks) {
          var accessName = ts3.startsWith(symbol.escapedName, "__#") ? ts3.factory.createPrivateIdentifier(symbol.escapedName.split("@")[1]) : ts3.unescapeLeadingUnderscores(symbol.escapedName);
          for (var _i = 0, staticBlocks_1 = staticBlocks; _i < staticBlocks_1.length; _i++) {
            var staticBlock = staticBlocks_1[_i];
            var reference = ts3.factory.createPropertyAccessExpression(ts3.factory.createThis(), accessName);
            ts3.setParent(reference.expression, reference);
            ts3.setParent(reference, staticBlock);
            reference.flowNode = staticBlock.returnFlowNode;
            var flowType = getFlowTypeOfProperty(reference, symbol);
            if (noImplicitAny && (flowType === autoType || flowType === autoArrayType)) {
              error(symbol.valueDeclaration, ts3.Diagnostics.Member_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
            }
            if (everyType(flowType, isNullableType)) {
              continue;
            }
            return convertAutoToAny(flowType);
          }
        }
        function getFlowTypeInConstructor(symbol, constructor) {
          var accessName = ts3.startsWith(symbol.escapedName, "__#") ? ts3.factory.createPrivateIdentifier(symbol.escapedName.split("@")[1]) : ts3.unescapeLeadingUnderscores(symbol.escapedName);
          var reference = ts3.factory.createPropertyAccessExpression(ts3.factory.createThis(), accessName);
          ts3.setParent(reference.expression, reference);
          ts3.setParent(reference, constructor);
          reference.flowNode = constructor.returnFlowNode;
          var flowType = getFlowTypeOfProperty(reference, symbol);
          if (noImplicitAny && (flowType === autoType || flowType === autoArrayType)) {
            error(symbol.valueDeclaration, ts3.Diagnostics.Member_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
          }
          return everyType(flowType, isNullableType) ? void 0 : convertAutoToAny(flowType);
        }
        function getFlowTypeOfProperty(reference, prop) {
          var initialType = (prop === null || prop === void 0 ? void 0 : prop.valueDeclaration) && (!isAutoTypedProperty(prop) || ts3.getEffectiveModifierFlags(prop.valueDeclaration) & 2) && getTypeOfPropertyInBaseClass(prop) || undefinedType;
          return getFlowTypeOfReference(reference, autoType, initialType);
        }
        function getWidenedTypeForAssignmentDeclaration(symbol, resolvedSymbol) {
          var container = ts3.getAssignedExpandoInitializer(symbol.valueDeclaration);
          if (container) {
            var tag = ts3.getJSDocTypeTag(container);
            if (tag && tag.typeExpression) {
              return getTypeFromTypeNode(tag.typeExpression);
            }
            var containerObjectType = symbol.valueDeclaration && getJSContainerObjectType(symbol.valueDeclaration, symbol, container);
            return containerObjectType || getWidenedLiteralType(checkExpressionCached(container));
          }
          var type2;
          var definedInConstructor = false;
          var definedInMethod = false;
          if (isConstructorDeclaredProperty(symbol)) {
            type2 = getFlowTypeInConstructor(symbol, getDeclaringConstructor(symbol));
          }
          if (!type2) {
            var types2 = void 0;
            if (symbol.declarations) {
              var jsdocType = void 0;
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                var expression = ts3.isBinaryExpression(declaration) || ts3.isCallExpression(declaration) ? declaration : ts3.isAccessExpression(declaration) ? ts3.isBinaryExpression(declaration.parent) ? declaration.parent : declaration : void 0;
                if (!expression) {
                  continue;
                }
                var kind = ts3.isAccessExpression(expression) ? ts3.getAssignmentDeclarationPropertyAccessKind(expression) : ts3.getAssignmentDeclarationKind(expression);
                if (kind === 4 || ts3.isBinaryExpression(expression) && isPossiblyAliasedThisProperty(expression, kind)) {
                  if (isDeclarationInConstructor(expression)) {
                    definedInConstructor = true;
                  } else {
                    definedInMethod = true;
                  }
                }
                if (!ts3.isCallExpression(expression)) {
                  jsdocType = getAnnotatedTypeForAssignmentDeclaration(jsdocType, expression, symbol, declaration);
                }
                if (!jsdocType) {
                  (types2 || (types2 = [])).push(ts3.isBinaryExpression(expression) || ts3.isCallExpression(expression) ? getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) : neverType);
                }
              }
              type2 = jsdocType;
            }
            if (!type2) {
              if (!ts3.length(types2)) {
                return errorType;
              }
              var constructorTypes = definedInConstructor && symbol.declarations ? getConstructorDefinedThisAssignmentTypes(types2, symbol.declarations) : void 0;
              if (definedInMethod) {
                var propType = getTypeOfPropertyInBaseClass(symbol);
                if (propType) {
                  (constructorTypes || (constructorTypes = [])).push(propType);
                  definedInConstructor = true;
                }
              }
              var sourceTypes = ts3.some(constructorTypes, function(t) {
                return !!(t.flags & ~98304);
              }) ? constructorTypes : types2;
              type2 = getUnionType(sourceTypes);
            }
          }
          var widened = getWidenedType(addOptionality(type2, false, definedInMethod && !definedInConstructor));
          if (symbol.valueDeclaration && filterType(widened, function(t) {
            return !!(t.flags & ~98304);
          }) === neverType) {
            reportImplicitAny(symbol.valueDeclaration, anyType);
            return anyType;
          }
          return widened;
        }
        function getJSContainerObjectType(decl, symbol, init) {
          var _a, _b;
          if (!ts3.isInJSFile(decl) || !init || !ts3.isObjectLiteralExpression(init) || init.properties.length) {
            return void 0;
          }
          var exports2 = ts3.createSymbolTable();
          while (ts3.isBinaryExpression(decl) || ts3.isPropertyAccessExpression(decl)) {
            var s_2 = getSymbolOfNode(decl);
            if ((_a = s_2 === null || s_2 === void 0 ? void 0 : s_2.exports) === null || _a === void 0 ? void 0 : _a.size) {
              mergeSymbolTable(exports2, s_2.exports);
            }
            decl = ts3.isBinaryExpression(decl) ? decl.parent : decl.parent.parent;
          }
          var s = getSymbolOfNode(decl);
          if ((_b = s === null || s === void 0 ? void 0 : s.exports) === null || _b === void 0 ? void 0 : _b.size) {
            mergeSymbolTable(exports2, s.exports);
          }
          var type2 = createAnonymousType(symbol, exports2, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
          type2.objectFlags |= 4096;
          return type2;
        }
        function getAnnotatedTypeForAssignmentDeclaration(declaredType, expression, symbol, declaration) {
          var _a;
          var typeNode = ts3.getEffectiveTypeAnnotationNode(expression.parent);
          if (typeNode) {
            var type2 = getWidenedType(getTypeFromTypeNode(typeNode));
            if (!declaredType) {
              return type2;
            } else if (!isErrorType(declaredType) && !isErrorType(type2) && !isTypeIdenticalTo(declaredType, type2)) {
              errorNextVariableOrPropertyDeclarationMustHaveSameType(void 0, declaredType, declaration, type2);
            }
          }
          if ((_a = symbol.parent) === null || _a === void 0 ? void 0 : _a.valueDeclaration) {
            var typeNode_2 = ts3.getEffectiveTypeAnnotationNode(symbol.parent.valueDeclaration);
            if (typeNode_2) {
              var annotationSymbol = getPropertyOfType(getTypeFromTypeNode(typeNode_2), symbol.escapedName);
              if (annotationSymbol) {
                return getNonMissingTypeOfSymbol(annotationSymbol);
              }
            }
          }
          return declaredType;
        }
        function getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) {
          if (ts3.isCallExpression(expression)) {
            if (resolvedSymbol) {
              return getTypeOfSymbol(resolvedSymbol);
            }
            var objectLitType = checkExpressionCached(expression.arguments[2]);
            var valueType = getTypeOfPropertyOfType(objectLitType, "value");
            if (valueType) {
              return valueType;
            }
            var getFunc = getTypeOfPropertyOfType(objectLitType, "get");
            if (getFunc) {
              var getSig = getSingleCallSignature(getFunc);
              if (getSig) {
                return getReturnTypeOfSignature(getSig);
              }
            }
            var setFunc = getTypeOfPropertyOfType(objectLitType, "set");
            if (setFunc) {
              var setSig = getSingleCallSignature(setFunc);
              if (setSig) {
                return getTypeOfFirstParameterOfSignature(setSig);
              }
            }
            return anyType;
          }
          if (containsSameNamedThisProperty(expression.left, expression.right)) {
            return anyType;
          }
          var isDirectExport = kind === 1 && (ts3.isPropertyAccessExpression(expression.left) || ts3.isElementAccessExpression(expression.left)) && (ts3.isModuleExportsAccessExpression(expression.left.expression) || ts3.isIdentifier(expression.left.expression) && ts3.isExportsIdentifier(expression.left.expression));
          var type2 = resolvedSymbol ? getTypeOfSymbol(resolvedSymbol) : isDirectExport ? getRegularTypeOfLiteralType(checkExpressionCached(expression.right)) : getWidenedLiteralType(checkExpressionCached(expression.right));
          if (type2.flags & 524288 && kind === 2 && symbol.escapedName === "export=") {
            var exportedType = resolveStructuredTypeMembers(type2);
            var members_4 = ts3.createSymbolTable();
            ts3.copyEntries(exportedType.members, members_4);
            var initialSize = members_4.size;
            if (resolvedSymbol && !resolvedSymbol.exports) {
              resolvedSymbol.exports = ts3.createSymbolTable();
            }
            (resolvedSymbol || symbol).exports.forEach(function(s, name) {
              var _a;
              var exportedMember = members_4.get(name);
              if (exportedMember && exportedMember !== s) {
                if (s.flags & 111551 && exportedMember.flags & 111551) {
                  if (s.valueDeclaration && exportedMember.valueDeclaration && ts3.getSourceFileOfNode(s.valueDeclaration) !== ts3.getSourceFileOfNode(exportedMember.valueDeclaration)) {
                    var unescapedName = ts3.unescapeLeadingUnderscores(s.escapedName);
                    var exportedMemberName = ((_a = ts3.tryCast(exportedMember.valueDeclaration, ts3.isNamedDeclaration)) === null || _a === void 0 ? void 0 : _a.name) || exportedMember.valueDeclaration;
                    ts3.addRelatedInfo(error(s.valueDeclaration, ts3.Diagnostics.Duplicate_identifier_0, unescapedName), ts3.createDiagnosticForNode(exportedMemberName, ts3.Diagnostics._0_was_also_declared_here, unescapedName));
                    ts3.addRelatedInfo(error(exportedMemberName, ts3.Diagnostics.Duplicate_identifier_0, unescapedName), ts3.createDiagnosticForNode(s.valueDeclaration, ts3.Diagnostics._0_was_also_declared_here, unescapedName));
                  }
                  var union = createSymbol(s.flags | exportedMember.flags, name);
                  union.type = getUnionType([getTypeOfSymbol(s), getTypeOfSymbol(exportedMember)]);
                  union.valueDeclaration = exportedMember.valueDeclaration;
                  union.declarations = ts3.concatenate(exportedMember.declarations, s.declarations);
                  members_4.set(name, union);
                } else {
                  members_4.set(name, mergeSymbol(s, exportedMember));
                }
              } else {
                members_4.set(name, s);
              }
            });
            var result2 = createAnonymousType(initialSize !== members_4.size ? void 0 : exportedType.symbol, members_4, exportedType.callSignatures, exportedType.constructSignatures, exportedType.indexInfos);
            result2.objectFlags |= ts3.getObjectFlags(type2) & 4096;
            if (result2.symbol && result2.symbol.flags & 32 && type2 === getDeclaredTypeOfClassOrInterface(result2.symbol)) {
              result2.objectFlags |= 16777216;
            }
            return result2;
          }
          if (isEmptyArrayLiteralType(type2)) {
            reportImplicitAny(expression, anyArrayType);
            return anyArrayType;
          }
          return type2;
        }
        function containsSameNamedThisProperty(thisProperty, expression) {
          return ts3.isPropertyAccessExpression(thisProperty) && thisProperty.expression.kind === 108 && ts3.forEachChildRecursively(expression, function(n) {
            return isMatchingReference(thisProperty, n);
          });
        }
        function isDeclarationInConstructor(expression) {
          var thisContainer = ts3.getThisContainer(expression, false);
          return thisContainer.kind === 171 || thisContainer.kind === 256 || thisContainer.kind === 213 && !ts3.isPrototypePropertyAssignment(thisContainer.parent);
        }
        function getConstructorDefinedThisAssignmentTypes(types2, declarations) {
          ts3.Debug.assert(types2.length === declarations.length);
          return types2.filter(function(_, i) {
            var declaration = declarations[i];
            var expression = ts3.isBinaryExpression(declaration) ? declaration : ts3.isBinaryExpression(declaration.parent) ? declaration.parent : void 0;
            return expression && isDeclarationInConstructor(expression);
          });
        }
        function getTypeFromBindingElement(element, includePatternInType, reportErrors) {
          if (element.initializer) {
            var contextualType = ts3.isBindingPattern(element.name) ? getTypeFromBindingPattern(element.name, true, false) : unknownType;
            return addOptionality(widenTypeInferredFromInitializer(element, checkDeclarationInitializer(element, 0, contextualType)));
          }
          if (ts3.isBindingPattern(element.name)) {
            return getTypeFromBindingPattern(element.name, includePatternInType, reportErrors);
          }
          if (reportErrors && !declarationBelongsToPrivateAmbientMember(element)) {
            reportImplicitAny(element, anyType);
          }
          return includePatternInType ? nonInferrableAnyType : anyType;
        }
        function getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors) {
          var members = ts3.createSymbolTable();
          var stringIndexInfo;
          var objectFlags = 128 | 131072;
          ts3.forEach(pattern.elements, function(e) {
            var name = e.propertyName || e.name;
            if (e.dotDotDotToken) {
              stringIndexInfo = createIndexInfo(stringType, anyType, false);
              return;
            }
            var exprType = getLiteralTypeFromPropertyName(name);
            if (!isTypeUsableAsPropertyName(exprType)) {
              objectFlags |= 512;
              return;
            }
            var text = getPropertyNameFromType(exprType);
            var flags = 4 | (e.initializer ? 16777216 : 0);
            var symbol = createSymbol(flags, text);
            symbol.type = getTypeFromBindingElement(e, includePatternInType, reportErrors);
            symbol.bindingElement = e;
            members.set(symbol.escapedName, symbol);
          });
          var result2 = createAnonymousType(void 0, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo ? [stringIndexInfo] : ts3.emptyArray);
          result2.objectFlags |= objectFlags;
          if (includePatternInType) {
            result2.pattern = pattern;
            result2.objectFlags |= 131072;
          }
          return result2;
        }
        function getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors) {
          var elements = pattern.elements;
          var lastElement = ts3.lastOrUndefined(elements);
          var restElement = lastElement && lastElement.kind === 203 && lastElement.dotDotDotToken ? lastElement : void 0;
          if (elements.length === 0 || elements.length === 1 && restElement) {
            return languageVersion >= 2 ? createIterableType(anyType) : anyArrayType;
          }
          var elementTypes = ts3.map(elements, function(e) {
            return ts3.isOmittedExpression(e) ? anyType : getTypeFromBindingElement(e, includePatternInType, reportErrors);
          });
          var minLength = ts3.findLastIndex(elements, function(e) {
            return !(e === restElement || ts3.isOmittedExpression(e) || hasDefaultValue(e));
          }, elements.length - 1) + 1;
          var elementFlags = ts3.map(elements, function(e, i) {
            return e === restElement ? 4 : i >= minLength ? 2 : 1;
          });
          var result2 = createTupleType(elementTypes, elementFlags);
          if (includePatternInType) {
            result2 = cloneTypeReference(result2);
            result2.pattern = pattern;
            result2.objectFlags |= 131072;
          }
          return result2;
        }
        function getTypeFromBindingPattern(pattern, includePatternInType, reportErrors) {
          if (includePatternInType === void 0) {
            includePatternInType = false;
          }
          if (reportErrors === void 0) {
            reportErrors = false;
          }
          return pattern.kind === 201 ? getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors) : getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors);
        }
        function getWidenedTypeForVariableLikeDeclaration(declaration, reportErrors) {
          return widenTypeForVariableLikeDeclaration(getTypeForVariableLikeDeclaration(declaration, true, 0), declaration, reportErrors);
        }
        function isGlobalSymbolConstructor(node) {
          var symbol = getSymbolOfNode(node);
          var globalSymbol = getGlobalESSymbolConstructorTypeSymbol(false);
          return globalSymbol && symbol && symbol === globalSymbol;
        }
        function widenTypeForVariableLikeDeclaration(type2, declaration, reportErrors) {
          if (type2) {
            if (type2.flags & 4096 && isGlobalSymbolConstructor(declaration.parent)) {
              type2 = getESSymbolLikeTypeForNode(declaration);
            }
            if (reportErrors) {
              reportErrorsFromWidening(declaration, type2);
            }
            if (type2.flags & 8192 && (ts3.isBindingElement(declaration) || !declaration.type) && type2.symbol !== getSymbolOfNode(declaration)) {
              type2 = esSymbolType;
            }
            return getWidenedType(type2);
          }
          type2 = ts3.isParameter(declaration) && declaration.dotDotDotToken ? anyArrayType : anyType;
          if (reportErrors) {
            if (!declarationBelongsToPrivateAmbientMember(declaration)) {
              reportImplicitAny(declaration, type2);
            }
          }
          return type2;
        }
        function declarationBelongsToPrivateAmbientMember(declaration) {
          var root = ts3.getRootDeclaration(declaration);
          var memberDeclaration = root.kind === 164 ? root.parent : root;
          return isPrivateWithinAmbient(memberDeclaration);
        }
        function tryGetTypeFromEffectiveTypeNode(node) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(node);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
        }
        function getTypeOfVariableOrParameterOrProperty(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            var type2 = getTypeOfVariableOrParameterOrPropertyWorker(symbol);
            if (!links.type) {
              links.type = type2;
            }
          }
          return links.type;
        }
        function getTypeOfVariableOrParameterOrPropertyWorker(symbol) {
          if (symbol.flags & 4194304) {
            return getTypeOfPrototypeProperty(symbol);
          }
          if (symbol === requireSymbol) {
            return anyType;
          }
          if (symbol.flags & 134217728 && symbol.valueDeclaration) {
            var fileSymbol = getSymbolOfNode(ts3.getSourceFileOfNode(symbol.valueDeclaration));
            var result2 = createSymbol(fileSymbol.flags, "exports");
            result2.declarations = fileSymbol.declarations ? fileSymbol.declarations.slice() : [];
            result2.parent = symbol;
            result2.target = fileSymbol;
            if (fileSymbol.valueDeclaration)
              result2.valueDeclaration = fileSymbol.valueDeclaration;
            if (fileSymbol.members)
              result2.members = new ts3.Map(fileSymbol.members);
            if (fileSymbol.exports)
              result2.exports = new ts3.Map(fileSymbol.exports);
            var members = ts3.createSymbolTable();
            members.set("exports", result2);
            return createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
          }
          ts3.Debug.assertIsDefined(symbol.valueDeclaration);
          var declaration = symbol.valueDeclaration;
          if (ts3.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
            var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
            if (typeNode === void 0) {
              return useUnknownInCatchVariables ? unknownType : anyType;
            }
            var type_2 = getTypeOfNode(typeNode);
            return isTypeAny(type_2) || type_2 === unknownType ? type_2 : errorType;
          }
          if (ts3.isSourceFile(declaration) && ts3.isJsonSourceFile(declaration)) {
            if (!declaration.statements.length) {
              return emptyObjectType;
            }
            return getWidenedType(getWidenedLiteralType(checkExpression(declaration.statements[0].expression)));
          }
          if (ts3.isAccessor(declaration)) {
            return getTypeOfAccessors(symbol);
          }
          if (!pushTypeResolution(symbol, 0)) {
            if (symbol.flags & 512 && !(symbol.flags & 67108864)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            return reportCircularityError(symbol);
          }
          var type2;
          if (declaration.kind === 271) {
            type2 = widenTypeForVariableLikeDeclaration(tryGetTypeFromEffectiveTypeNode(declaration) || checkExpressionCached(declaration.expression), declaration);
          } else if (ts3.isBinaryExpression(declaration) || ts3.isInJSFile(declaration) && (ts3.isCallExpression(declaration) || (ts3.isPropertyAccessExpression(declaration) || ts3.isBindableStaticElementAccessExpression(declaration)) && ts3.isBinaryExpression(declaration.parent))) {
            type2 = getWidenedTypeForAssignmentDeclaration(symbol);
          } else if (ts3.isPropertyAccessExpression(declaration) || ts3.isElementAccessExpression(declaration) || ts3.isIdentifier(declaration) || ts3.isStringLiteralLike(declaration) || ts3.isNumericLiteral(declaration) || ts3.isClassDeclaration(declaration) || ts3.isFunctionDeclaration(declaration) || ts3.isMethodDeclaration(declaration) && !ts3.isObjectLiteralMethod(declaration) || ts3.isMethodSignature(declaration) || ts3.isSourceFile(declaration)) {
            if (symbol.flags & (16 | 8192 | 32 | 384 | 512)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            type2 = ts3.isBinaryExpression(declaration.parent) ? getWidenedTypeForAssignmentDeclaration(symbol) : tryGetTypeFromEffectiveTypeNode(declaration) || anyType;
          } else if (ts3.isPropertyAssignment(declaration)) {
            type2 = tryGetTypeFromEffectiveTypeNode(declaration) || checkPropertyAssignment(declaration);
          } else if (ts3.isJsxAttribute(declaration)) {
            type2 = tryGetTypeFromEffectiveTypeNode(declaration) || checkJsxAttribute(declaration);
          } else if (ts3.isShorthandPropertyAssignment(declaration)) {
            type2 = tryGetTypeFromEffectiveTypeNode(declaration) || checkExpressionForMutableLocation(declaration.name, 0);
          } else if (ts3.isObjectLiteralMethod(declaration)) {
            type2 = tryGetTypeFromEffectiveTypeNode(declaration) || checkObjectLiteralMethod(declaration, 0);
          } else if (ts3.isParameter(declaration) || ts3.isPropertyDeclaration(declaration) || ts3.isPropertySignature(declaration) || ts3.isVariableDeclaration(declaration) || ts3.isBindingElement(declaration) || ts3.isJSDocPropertyLikeTag(declaration)) {
            type2 = getWidenedTypeForVariableLikeDeclaration(declaration, true);
          } else if (ts3.isEnumDeclaration(declaration)) {
            type2 = getTypeOfFuncClassEnumModule(symbol);
          } else if (ts3.isEnumMember(declaration)) {
            type2 = getTypeOfEnumMember(symbol);
          } else {
            return ts3.Debug.fail("Unhandled declaration kind! " + ts3.Debug.formatSyntaxKind(declaration.kind) + " for " + ts3.Debug.formatSymbol(symbol));
          }
          if (!popTypeResolution()) {
            if (symbol.flags & 512 && !(symbol.flags & 67108864)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            return reportCircularityError(symbol);
          }
          return type2;
        }
        function getAnnotatedAccessorTypeNode(accessor) {
          if (accessor) {
            if (accessor.kind === 172) {
              var getterTypeAnnotation = ts3.getEffectiveReturnTypeNode(accessor);
              return getterTypeAnnotation;
            } else {
              var setterTypeAnnotation = ts3.getEffectiveSetAccessorTypeAnnotationNode(accessor);
              return setterTypeAnnotation;
            }
          }
          return void 0;
        }
        function getAnnotatedAccessorType(accessor) {
          var node = getAnnotatedAccessorTypeNode(accessor);
          return node && getTypeFromTypeNode(node);
        }
        function getAnnotatedAccessorThisParameter(accessor) {
          var parameter = getAccessorThisParameter(accessor);
          return parameter && parameter.symbol;
        }
        function getThisTypeOfDeclaration(declaration) {
          return getThisTypeOfSignature(getSignatureFromDeclaration(declaration));
        }
        function getTypeOfAccessors(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            if (!pushTypeResolution(symbol, 0)) {
              return errorType;
            }
            var getter = ts3.getDeclarationOfKind(symbol, 172);
            var setter = ts3.getDeclarationOfKind(symbol, 173);
            var type2 = getter && ts3.isInJSFile(getter) && getTypeForDeclarationFromJSDocComment(getter) || getAnnotatedAccessorType(getter) || getAnnotatedAccessorType(setter) || getter && getter.body && getReturnTypeFromBody(getter);
            if (!type2) {
              if (setter && !isPrivateWithinAmbient(setter)) {
                errorOrSuggestion(noImplicitAny, setter, ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation, symbolToString(symbol));
              } else if (getter && !isPrivateWithinAmbient(getter)) {
                errorOrSuggestion(noImplicitAny, getter, ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation, symbolToString(symbol));
              }
              type2 = anyType;
            }
            if (!popTypeResolution()) {
              if (getAnnotatedAccessorTypeNode(getter)) {
                error(getter, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
              } else if (getAnnotatedAccessorTypeNode(setter)) {
                error(setter, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
              } else if (getter && noImplicitAny) {
                error(getter, ts3.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, symbolToString(symbol));
              }
              type2 = anyType;
            }
            links.type = type2;
          }
          return links.type;
        }
        function getWriteTypeOfAccessors(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.writeType) {
            if (!pushTypeResolution(symbol, 8)) {
              return errorType;
            }
            var setter = ts3.getDeclarationOfKind(symbol, 173);
            var writeType = getAnnotatedAccessorType(setter);
            if (!popTypeResolution()) {
              if (getAnnotatedAccessorTypeNode(setter)) {
                error(setter, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
              }
              writeType = anyType;
            }
            links.writeType = writeType || getTypeOfAccessors(symbol);
          }
          return links.writeType;
        }
        function getBaseTypeVariableOfClass(symbol) {
          var baseConstructorType = getBaseConstructorTypeOfClass(getDeclaredTypeOfClassOrInterface(symbol));
          return baseConstructorType.flags & 8650752 ? baseConstructorType : baseConstructorType.flags & 2097152 ? ts3.find(baseConstructorType.types, function(t) {
            return !!(t.flags & 8650752);
          }) : void 0;
        }
        function getTypeOfFuncClassEnumModule(symbol) {
          var links = getSymbolLinks(symbol);
          var originalLinks = links;
          if (!links.type) {
            var expando = symbol.valueDeclaration && getSymbolOfExpando(symbol.valueDeclaration, false);
            if (expando) {
              var merged = mergeJSSymbols(symbol, expando);
              if (merged) {
                symbol = links = merged;
              }
            }
            originalLinks.type = links.type = getTypeOfFuncClassEnumModuleWorker(symbol);
          }
          return links.type;
        }
        function getTypeOfFuncClassEnumModuleWorker(symbol) {
          var declaration = symbol.valueDeclaration;
          if (symbol.flags & 1536 && ts3.isShorthandAmbientModuleSymbol(symbol)) {
            return anyType;
          } else if (declaration && (declaration.kind === 221 || ts3.isAccessExpression(declaration) && declaration.parent.kind === 221)) {
            return getWidenedTypeForAssignmentDeclaration(symbol);
          } else if (symbol.flags & 512 && declaration && ts3.isSourceFile(declaration) && declaration.commonJsModuleIndicator) {
            var resolvedModule = resolveExternalModuleSymbol(symbol);
            if (resolvedModule !== symbol) {
              if (!pushTypeResolution(symbol, 0)) {
                return errorType;
              }
              var exportEquals = getMergedSymbol(symbol.exports.get("export="));
              var type_3 = getWidenedTypeForAssignmentDeclaration(exportEquals, exportEquals === resolvedModule ? void 0 : resolvedModule);
              if (!popTypeResolution()) {
                return reportCircularityError(symbol);
              }
              return type_3;
            }
          }
          var type2 = createObjectType(16, symbol);
          if (symbol.flags & 32) {
            var baseTypeVariable = getBaseTypeVariableOfClass(symbol);
            return baseTypeVariable ? getIntersectionType([type2, baseTypeVariable]) : type2;
          } else {
            return strictNullChecks && symbol.flags & 16777216 ? getOptionalType(type2) : type2;
          }
        }
        function getTypeOfEnumMember(symbol) {
          var links = getSymbolLinks(symbol);
          return links.type || (links.type = getDeclaredTypeOfEnumMember(symbol));
        }
        function getTypeOfAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            var targetSymbol = resolveAlias(symbol);
            var exportSymbol = symbol.declarations && getTargetOfAliasDeclaration(getDeclarationOfAliasSymbol(symbol), true);
            var declaredType = ts3.firstDefined(exportSymbol === null || exportSymbol === void 0 ? void 0 : exportSymbol.declarations, function(d) {
              return ts3.isExportAssignment(d) ? tryGetTypeFromEffectiveTypeNode(d) : void 0;
            });
            links.type = (exportSymbol === null || exportSymbol === void 0 ? void 0 : exportSymbol.declarations) && isDuplicatedCommonJSExport(exportSymbol.declarations) && symbol.declarations.length ? getFlowTypeFromCommonJSExport(exportSymbol) : isDuplicatedCommonJSExport(symbol.declarations) ? autoType : declaredType ? declaredType : targetSymbol.flags & 111551 ? getTypeOfSymbol(targetSymbol) : errorType;
          }
          return links.type;
        }
        function getTypeOfInstantiatedSymbol(symbol) {
          var links = getSymbolLinks(symbol);
          return links.type || (links.type = instantiateType(getTypeOfSymbol(links.target), links.mapper));
        }
        function getWriteTypeOfInstantiatedSymbol(symbol) {
          var links = getSymbolLinks(symbol);
          return links.writeType || (links.writeType = instantiateType(getWriteTypeOfSymbol(links.target), links.mapper));
        }
        function reportCircularityError(symbol) {
          var declaration = symbol.valueDeclaration;
          if (ts3.getEffectiveTypeAnnotationNode(declaration)) {
            error(symbol.valueDeclaration, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
            return errorType;
          }
          if (noImplicitAny && (declaration.kind !== 164 || declaration.initializer)) {
            error(symbol.valueDeclaration, ts3.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer, symbolToString(symbol));
          }
          return anyType;
        }
        function getTypeOfSymbolWithDeferredType(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            ts3.Debug.assertIsDefined(links.deferralParent);
            ts3.Debug.assertIsDefined(links.deferralConstituents);
            links.type = links.deferralParent.flags & 1048576 ? getUnionType(links.deferralConstituents) : getIntersectionType(links.deferralConstituents);
          }
          return links.type;
        }
        function getWriteTypeOfSymbolWithDeferredType(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.writeType && links.deferralWriteConstituents) {
            ts3.Debug.assertIsDefined(links.deferralParent);
            ts3.Debug.assertIsDefined(links.deferralConstituents);
            links.writeType = links.deferralParent.flags & 1048576 ? getUnionType(links.deferralWriteConstituents) : getIntersectionType(links.deferralWriteConstituents);
          }
          return links.writeType;
        }
        function getWriteTypeOfSymbol(symbol) {
          var checkFlags = ts3.getCheckFlags(symbol);
          if (symbol.flags & 4) {
            return checkFlags & 2 ? checkFlags & 65536 ? getWriteTypeOfSymbolWithDeferredType(symbol) || getTypeOfSymbolWithDeferredType(symbol) : symbol.writeType || symbol.type : getTypeOfSymbol(symbol);
          }
          if (symbol.flags & 98304) {
            return checkFlags & 1 ? getWriteTypeOfInstantiatedSymbol(symbol) : getWriteTypeOfAccessors(symbol);
          }
          return getTypeOfSymbol(symbol);
        }
        function getTypeOfSymbol(symbol) {
          var checkFlags = ts3.getCheckFlags(symbol);
          if (checkFlags & 65536) {
            return getTypeOfSymbolWithDeferredType(symbol);
          }
          if (checkFlags & 1) {
            return getTypeOfInstantiatedSymbol(symbol);
          }
          if (checkFlags & 262144) {
            return getTypeOfMappedSymbol(symbol);
          }
          if (checkFlags & 8192) {
            return getTypeOfReverseMappedSymbol(symbol);
          }
          if (symbol.flags & (3 | 4)) {
            return getTypeOfVariableOrParameterOrProperty(symbol);
          }
          if (symbol.flags & (16 | 8192 | 32 | 384 | 512)) {
            return getTypeOfFuncClassEnumModule(symbol);
          }
          if (symbol.flags & 8) {
            return getTypeOfEnumMember(symbol);
          }
          if (symbol.flags & 98304) {
            return getTypeOfAccessors(symbol);
          }
          if (symbol.flags & 2097152) {
            return getTypeOfAlias(symbol);
          }
          return errorType;
        }
        function getNonMissingTypeOfSymbol(symbol) {
          return removeMissingType(getTypeOfSymbol(symbol), !!(symbol.flags & 16777216));
        }
        function isReferenceToType(type2, target) {
          return type2 !== void 0 && target !== void 0 && (ts3.getObjectFlags(type2) & 4) !== 0 && type2.target === target;
        }
        function getTargetType(type2) {
          return ts3.getObjectFlags(type2) & 4 ? type2.target : type2;
        }
        function hasBaseType(type2, checkBase) {
          return check(type2);
          function check(type3) {
            if (ts3.getObjectFlags(type3) & (3 | 4)) {
              var target = getTargetType(type3);
              return target === checkBase || ts3.some(getBaseTypes(target), check);
            } else if (type3.flags & 2097152) {
              return ts3.some(type3.types, check);
            }
            return false;
          }
        }
        function appendTypeParameters(typeParameters, declarations) {
          for (var _i = 0, declarations_2 = declarations; _i < declarations_2.length; _i++) {
            var declaration = declarations_2[_i];
            typeParameters = ts3.appendIfUnique(typeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfNode(declaration)));
          }
          return typeParameters;
        }
        function getOuterTypeParameters(node, includeThisTypes) {
          while (true) {
            node = node.parent;
            if (node && ts3.isBinaryExpression(node)) {
              var assignmentKind = ts3.getAssignmentDeclarationKind(node);
              if (assignmentKind === 6 || assignmentKind === 3) {
                var symbol = getSymbolOfNode(node.left);
                if (symbol && symbol.parent && !ts3.findAncestor(symbol.parent.valueDeclaration, function(d) {
                  return node === d;
                })) {
                  node = symbol.parent.valueDeclaration;
                }
              }
            }
            if (!node) {
              return void 0;
            }
            switch (node.kind) {
              case 257:
              case 226:
              case 258:
              case 174:
              case 175:
              case 168:
              case 179:
              case 180:
              case 317:
              case 256:
              case 169:
              case 213:
              case 214:
              case 259:
              case 344:
              case 345:
              case 339:
              case 338:
              case 195:
              case 189: {
                var outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
                if (node.kind === 195) {
                  return ts3.append(outerTypeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfNode(node.typeParameter)));
                } else if (node.kind === 189) {
                  return ts3.concatenate(outerTypeParameters, getInferTypeParameters(node));
                }
                var outerAndOwnTypeParameters = appendTypeParameters(outerTypeParameters, ts3.getEffectiveTypeParameterDeclarations(node));
                var thisType = includeThisTypes && (node.kind === 257 || node.kind === 226 || node.kind === 258 || isJSConstructor(node)) && getDeclaredTypeOfClassOrInterface(getSymbolOfNode(node)).thisType;
                return thisType ? ts3.append(outerAndOwnTypeParameters, thisType) : outerAndOwnTypeParameters;
              }
              case 340:
                var paramSymbol = ts3.getParameterSymbolFromJSDoc(node);
                if (paramSymbol) {
                  node = paramSymbol.valueDeclaration;
                }
                break;
              case 320: {
                var outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
                return node.tags ? appendTypeParameters(outerTypeParameters, ts3.flatMap(node.tags, function(t) {
                  return ts3.isJSDocTemplateTag(t) ? t.typeParameters : void 0;
                })) : outerTypeParameters;
              }
            }
          }
        }
        function getOuterTypeParametersOfClassOrInterface(symbol) {
          var declaration = symbol.flags & 32 ? symbol.valueDeclaration : ts3.getDeclarationOfKind(symbol, 258);
          ts3.Debug.assert(!!declaration, "Class was missing valueDeclaration -OR- non-class had no interface declarations");
          return getOuterTypeParameters(declaration);
        }
        function getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) {
          if (!symbol.declarations) {
            return;
          }
          var result2;
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var node = _a[_i];
            if (node.kind === 258 || node.kind === 257 || node.kind === 226 || isJSConstructor(node) || ts3.isTypeAlias(node)) {
              var declaration = node;
              result2 = appendTypeParameters(result2, ts3.getEffectiveTypeParameterDeclarations(declaration));
            }
          }
          return result2;
        }
        function getTypeParametersOfClassOrInterface(symbol) {
          return ts3.concatenate(getOuterTypeParametersOfClassOrInterface(symbol), getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol));
        }
        function isMixinConstructorType(type2) {
          var signatures = getSignaturesOfType(type2, 1);
          if (signatures.length === 1) {
            var s = signatures[0];
            if (!s.typeParameters && s.parameters.length === 1 && signatureHasRestParameter(s)) {
              var paramType = getTypeOfParameter(s.parameters[0]);
              return isTypeAny(paramType) || getElementTypeOfArrayType(paramType) === anyType;
            }
          }
          return false;
        }
        function isConstructorType(type2) {
          if (getSignaturesOfType(type2, 1).length > 0) {
            return true;
          }
          if (type2.flags & 8650752) {
            var constraint = getBaseConstraintOfType(type2);
            return !!constraint && isMixinConstructorType(constraint);
          }
          return false;
        }
        function getBaseTypeNodeOfClass(type2) {
          var decl = ts3.getClassLikeDeclarationOfSymbol(type2.symbol);
          return decl && ts3.getEffectiveBaseTypeNode(decl);
        }
        function getConstructorsForTypeArguments(type2, typeArgumentNodes, location) {
          var typeArgCount = ts3.length(typeArgumentNodes);
          var isJavascript = ts3.isInJSFile(location);
          return ts3.filter(getSignaturesOfType(type2, 1), function(sig) {
            return (isJavascript || typeArgCount >= getMinTypeArgumentCount(sig.typeParameters)) && typeArgCount <= ts3.length(sig.typeParameters);
          });
        }
        function getInstantiatedConstructorsForTypeArguments(type2, typeArgumentNodes, location) {
          var signatures = getConstructorsForTypeArguments(type2, typeArgumentNodes, location);
          var typeArguments = ts3.map(typeArgumentNodes, getTypeFromTypeNode);
          return ts3.sameMap(signatures, function(sig) {
            return ts3.some(sig.typeParameters) ? getSignatureInstantiation(sig, typeArguments, ts3.isInJSFile(location)) : sig;
          });
        }
        function getBaseConstructorTypeOfClass(type2) {
          if (!type2.resolvedBaseConstructorType) {
            var decl = ts3.getClassLikeDeclarationOfSymbol(type2.symbol);
            var extended = decl && ts3.getEffectiveBaseTypeNode(decl);
            var baseTypeNode = getBaseTypeNodeOfClass(type2);
            if (!baseTypeNode) {
              return type2.resolvedBaseConstructorType = undefinedType;
            }
            if (!pushTypeResolution(type2, 1)) {
              return errorType;
            }
            var baseConstructorType = checkExpression(baseTypeNode.expression);
            if (extended && baseTypeNode !== extended) {
              ts3.Debug.assert(!extended.typeArguments);
              checkExpression(extended.expression);
            }
            if (baseConstructorType.flags & (524288 | 2097152)) {
              resolveStructuredTypeMembers(baseConstructorType);
            }
            if (!popTypeResolution()) {
              error(type2.symbol.valueDeclaration, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression, symbolToString(type2.symbol));
              return type2.resolvedBaseConstructorType = errorType;
            }
            if (!(baseConstructorType.flags & 1) && baseConstructorType !== nullWideningType && !isConstructorType(baseConstructorType)) {
              var err = error(baseTypeNode.expression, ts3.Diagnostics.Type_0_is_not_a_constructor_function_type, typeToString(baseConstructorType));
              if (baseConstructorType.flags & 262144) {
                var constraint = getConstraintFromTypeParameter(baseConstructorType);
                var ctorReturn = unknownType;
                if (constraint) {
                  var ctorSig = getSignaturesOfType(constraint, 1);
                  if (ctorSig[0]) {
                    ctorReturn = getReturnTypeOfSignature(ctorSig[0]);
                  }
                }
                if (baseConstructorType.symbol.declarations) {
                  ts3.addRelatedInfo(err, ts3.createDiagnosticForNode(baseConstructorType.symbol.declarations[0], ts3.Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1, symbolToString(baseConstructorType.symbol), typeToString(ctorReturn)));
                }
              }
              return type2.resolvedBaseConstructorType = errorType;
            }
            type2.resolvedBaseConstructorType = baseConstructorType;
          }
          return type2.resolvedBaseConstructorType;
        }
        function getImplementsTypes(type2) {
          var resolvedImplementsTypes = ts3.emptyArray;
          if (type2.symbol.declarations) {
            for (var _i = 0, _a = type2.symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              var implementsTypeNodes = ts3.getEffectiveImplementsTypeNodes(declaration);
              if (!implementsTypeNodes)
                continue;
              for (var _b = 0, implementsTypeNodes_1 = implementsTypeNodes; _b < implementsTypeNodes_1.length; _b++) {
                var node = implementsTypeNodes_1[_b];
                var implementsType = getTypeFromTypeNode(node);
                if (!isErrorType(implementsType)) {
                  if (resolvedImplementsTypes === ts3.emptyArray) {
                    resolvedImplementsTypes = [implementsType];
                  } else {
                    resolvedImplementsTypes.push(implementsType);
                  }
                }
              }
            }
          }
          return resolvedImplementsTypes;
        }
        function reportCircularBaseType(node, type2) {
          error(node, ts3.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type2, void 0, 2));
        }
        function getBaseTypes(type2) {
          if (!type2.baseTypesResolved) {
            if (pushTypeResolution(type2, 7)) {
              if (type2.objectFlags & 8) {
                type2.resolvedBaseTypes = [getTupleBaseType(type2)];
              } else if (type2.symbol.flags & (32 | 64)) {
                if (type2.symbol.flags & 32) {
                  resolveBaseTypesOfClass(type2);
                }
                if (type2.symbol.flags & 64) {
                  resolveBaseTypesOfInterface(type2);
                }
              } else {
                ts3.Debug.fail("type must be class or interface");
              }
              if (!popTypeResolution() && type2.symbol.declarations) {
                for (var _i = 0, _a = type2.symbol.declarations; _i < _a.length; _i++) {
                  var declaration = _a[_i];
                  if (declaration.kind === 257 || declaration.kind === 258) {
                    reportCircularBaseType(declaration, type2);
                  }
                }
              }
            }
            type2.baseTypesResolved = true;
          }
          return type2.resolvedBaseTypes;
        }
        function getTupleBaseType(type2) {
          var elementTypes = ts3.sameMap(type2.typeParameters, function(t, i) {
            return type2.elementFlags[i] & 8 ? getIndexedAccessType(t, numberType) : t;
          });
          return createArrayType(getUnionType(elementTypes || ts3.emptyArray), type2.readonly);
        }
        function resolveBaseTypesOfClass(type2) {
          type2.resolvedBaseTypes = ts3.resolvingEmptyArray;
          var baseConstructorType = getApparentType(getBaseConstructorTypeOfClass(type2));
          if (!(baseConstructorType.flags & (524288 | 2097152 | 1))) {
            return type2.resolvedBaseTypes = ts3.emptyArray;
          }
          var baseTypeNode = getBaseTypeNodeOfClass(type2);
          var baseType;
          var originalBaseType = baseConstructorType.symbol ? getDeclaredTypeOfSymbol(baseConstructorType.symbol) : void 0;
          if (baseConstructorType.symbol && baseConstructorType.symbol.flags & 32 && areAllOuterTypeParametersApplied(originalBaseType)) {
            baseType = getTypeFromClassOrInterfaceReference(baseTypeNode, baseConstructorType.symbol);
          } else if (baseConstructorType.flags & 1) {
            baseType = baseConstructorType;
          } else {
            var constructors = getInstantiatedConstructorsForTypeArguments(baseConstructorType, baseTypeNode.typeArguments, baseTypeNode);
            if (!constructors.length) {
              error(baseTypeNode.expression, ts3.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments);
              return type2.resolvedBaseTypes = ts3.emptyArray;
            }
            baseType = getReturnTypeOfSignature(constructors[0]);
          }
          if (isErrorType(baseType)) {
            return type2.resolvedBaseTypes = ts3.emptyArray;
          }
          var reducedBaseType = getReducedType(baseType);
          if (!isValidBaseType(reducedBaseType)) {
            var elaboration = elaborateNeverIntersection(void 0, baseType);
            var diagnostic = ts3.chainDiagnosticMessages(elaboration, ts3.Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members, typeToString(reducedBaseType));
            diagnostics.add(ts3.createDiagnosticForNodeFromMessageChain(baseTypeNode.expression, diagnostic));
            return type2.resolvedBaseTypes = ts3.emptyArray;
          }
          if (type2 === reducedBaseType || hasBaseType(reducedBaseType, type2)) {
            error(type2.symbol.valueDeclaration, ts3.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type2, void 0, 2));
            return type2.resolvedBaseTypes = ts3.emptyArray;
          }
          if (type2.resolvedBaseTypes === ts3.resolvingEmptyArray) {
            type2.members = void 0;
          }
          return type2.resolvedBaseTypes = [reducedBaseType];
        }
        function areAllOuterTypeParametersApplied(type2) {
          var outerTypeParameters = type2.outerTypeParameters;
          if (outerTypeParameters) {
            var last_1 = outerTypeParameters.length - 1;
            var typeArguments = getTypeArguments(type2);
            return outerTypeParameters[last_1].symbol !== typeArguments[last_1].symbol;
          }
          return true;
        }
        function isValidBaseType(type2) {
          if (type2.flags & 262144) {
            var constraint = getBaseConstraintOfType(type2);
            if (constraint) {
              return isValidBaseType(constraint);
            }
          }
          return !!(type2.flags & (524288 | 67108864 | 1) && !isGenericMappedType(type2) || type2.flags & 2097152 && ts3.every(type2.types, isValidBaseType));
        }
        function resolveBaseTypesOfInterface(type2) {
          type2.resolvedBaseTypes = type2.resolvedBaseTypes || ts3.emptyArray;
          if (type2.symbol.declarations) {
            for (var _i = 0, _a = type2.symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (declaration.kind === 258 && ts3.getInterfaceBaseTypeNodes(declaration)) {
                for (var _b = 0, _c = ts3.getInterfaceBaseTypeNodes(declaration); _b < _c.length; _b++) {
                  var node = _c[_b];
                  var baseType = getReducedType(getTypeFromTypeNode(node));
                  if (!isErrorType(baseType)) {
                    if (isValidBaseType(baseType)) {
                      if (type2 !== baseType && !hasBaseType(baseType, type2)) {
                        if (type2.resolvedBaseTypes === ts3.emptyArray) {
                          type2.resolvedBaseTypes = [baseType];
                        } else {
                          type2.resolvedBaseTypes.push(baseType);
                        }
                      } else {
                        reportCircularBaseType(declaration, type2);
                      }
                    } else {
                      error(node, ts3.Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                    }
                  }
                }
              }
            }
          }
        }
        function isThislessInterface(symbol) {
          if (!symbol.declarations) {
            return true;
          }
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            if (declaration.kind === 258) {
              if (declaration.flags & 128) {
                return false;
              }
              var baseTypeNodes = ts3.getInterfaceBaseTypeNodes(declaration);
              if (baseTypeNodes) {
                for (var _b = 0, baseTypeNodes_1 = baseTypeNodes; _b < baseTypeNodes_1.length; _b++) {
                  var node = baseTypeNodes_1[_b];
                  if (ts3.isEntityNameExpression(node.expression)) {
                    var baseSymbol = resolveEntityName(node.expression, 788968, true);
                    if (!baseSymbol || !(baseSymbol.flags & 64) || getDeclaredTypeOfClassOrInterface(baseSymbol).thisType) {
                      return false;
                    }
                  }
                }
              }
            }
          }
          return true;
        }
        function getDeclaredTypeOfClassOrInterface(symbol) {
          var links = getSymbolLinks(symbol);
          var originalLinks = links;
          if (!links.declaredType) {
            var kind = symbol.flags & 32 ? 1 : 2;
            var merged = mergeJSSymbols(symbol, symbol.valueDeclaration && getAssignedClassSymbol(symbol.valueDeclaration));
            if (merged) {
              symbol = links = merged;
            }
            var type2 = originalLinks.declaredType = links.declaredType = createObjectType(kind, symbol);
            var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
            var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
            if (outerTypeParameters || localTypeParameters || kind === 1 || !isThislessInterface(symbol)) {
              type2.objectFlags |= 4;
              type2.typeParameters = ts3.concatenate(outerTypeParameters, localTypeParameters);
              type2.outerTypeParameters = outerTypeParameters;
              type2.localTypeParameters = localTypeParameters;
              type2.instantiations = new ts3.Map();
              type2.instantiations.set(getTypeListId(type2.typeParameters), type2);
              type2.target = type2;
              type2.resolvedTypeArguments = type2.typeParameters;
              type2.thisType = createTypeParameter(symbol);
              type2.thisType.isThisType = true;
              type2.thisType.constraint = type2;
            }
          }
          return links.declaredType;
        }
        function getDeclaredTypeOfTypeAlias(symbol) {
          var _a;
          var links = getSymbolLinks(symbol);
          if (!links.declaredType) {
            if (!pushTypeResolution(symbol, 2)) {
              return errorType;
            }
            var declaration = ts3.Debug.checkDefined((_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isTypeAlias), "Type alias symbol with no valid declaration found");
            var typeNode = ts3.isJSDocTypeAlias(declaration) ? declaration.typeExpression : declaration.type;
            var type2 = typeNode ? getTypeFromTypeNode(typeNode) : errorType;
            if (popTypeResolution()) {
              var typeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              if (typeParameters) {
                links.typeParameters = typeParameters;
                links.instantiations = new ts3.Map();
                links.instantiations.set(getTypeListId(typeParameters), type2);
              }
            } else {
              type2 = errorType;
              if (declaration.kind === 339) {
                error(declaration.typeExpression.type, ts3.Diagnostics.Type_alias_0_circularly_references_itself, symbolToString(symbol));
              } else {
                error(ts3.isNamedDeclaration(declaration) ? declaration.name : declaration || declaration, ts3.Diagnostics.Type_alias_0_circularly_references_itself, symbolToString(symbol));
              }
            }
            links.declaredType = type2;
          }
          return links.declaredType;
        }
        function isStringConcatExpression(expr) {
          if (ts3.isStringLiteralLike(expr)) {
            return true;
          } else if (expr.kind === 221) {
            return isStringConcatExpression(expr.left) && isStringConcatExpression(expr.right);
          }
          return false;
        }
        function isLiteralEnumMember(member) {
          var expr = member.initializer;
          if (!expr) {
            return !(member.flags & 16777216);
          }
          switch (expr.kind) {
            case 10:
            case 8:
            case 14:
              return true;
            case 219:
              return expr.operator === 40 && expr.operand.kind === 8;
            case 79:
              return ts3.nodeIsMissing(expr) || !!getSymbolOfNode(member.parent).exports.get(expr.escapedText);
            case 221:
              return isStringConcatExpression(expr);
            default:
              return false;
          }
        }
        function getEnumKind(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.enumKind !== void 0) {
            return links.enumKind;
          }
          var hasNonLiteralMember = false;
          if (symbol.declarations) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (declaration.kind === 260) {
                for (var _b = 0, _c = declaration.members; _b < _c.length; _b++) {
                  var member = _c[_b];
                  if (member.initializer && ts3.isStringLiteralLike(member.initializer)) {
                    return links.enumKind = 1;
                  }
                  if (!isLiteralEnumMember(member)) {
                    hasNonLiteralMember = true;
                  }
                }
              }
            }
          }
          return links.enumKind = hasNonLiteralMember ? 0 : 1;
        }
        function getBaseTypeOfEnumLiteralType(type2) {
          return type2.flags & 1024 && !(type2.flags & 1048576) ? getDeclaredTypeOfSymbol(getParentOfSymbol(type2.symbol)) : type2;
        }
        function getDeclaredTypeOfEnum(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.declaredType) {
            return links.declaredType;
          }
          if (getEnumKind(symbol) === 1) {
            enumCount++;
            var memberTypeList = [];
            if (symbol.declarations) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (declaration.kind === 260) {
                  for (var _b = 0, _c = declaration.members; _b < _c.length; _b++) {
                    var member = _c[_b];
                    var value = getEnumMemberValue(member);
                    var memberType = getFreshTypeOfLiteralType(getEnumLiteralType(value !== void 0 ? value : 0, enumCount, getSymbolOfNode(member)));
                    getSymbolLinks(getSymbolOfNode(member)).declaredType = memberType;
                    memberTypeList.push(getRegularTypeOfLiteralType(memberType));
                  }
                }
              }
            }
            if (memberTypeList.length) {
              var enumType_1 = getUnionType(memberTypeList, 1, symbol, void 0);
              if (enumType_1.flags & 1048576) {
                enumType_1.flags |= 1024;
                enumType_1.symbol = symbol;
              }
              return links.declaredType = enumType_1;
            }
          }
          var enumType = createType(32);
          enumType.symbol = symbol;
          return links.declaredType = enumType;
        }
        function getDeclaredTypeOfEnumMember(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.declaredType) {
            var enumType = getDeclaredTypeOfEnum(getParentOfSymbol(symbol));
            if (!links.declaredType) {
              links.declaredType = enumType;
            }
          }
          return links.declaredType;
        }
        function getDeclaredTypeOfTypeParameter(symbol) {
          var links = getSymbolLinks(symbol);
          return links.declaredType || (links.declaredType = createTypeParameter(symbol));
        }
        function getDeclaredTypeOfAlias(symbol) {
          var links = getSymbolLinks(symbol);
          return links.declaredType || (links.declaredType = getDeclaredTypeOfSymbol(resolveAlias(symbol)));
        }
        function getDeclaredTypeOfSymbol(symbol) {
          return tryGetDeclaredTypeOfSymbol(symbol) || errorType;
        }
        function tryGetDeclaredTypeOfSymbol(symbol) {
          if (symbol.flags & (32 | 64)) {
            return getDeclaredTypeOfClassOrInterface(symbol);
          }
          if (symbol.flags & 524288) {
            return getDeclaredTypeOfTypeAlias(symbol);
          }
          if (symbol.flags & 262144) {
            return getDeclaredTypeOfTypeParameter(symbol);
          }
          if (symbol.flags & 384) {
            return getDeclaredTypeOfEnum(symbol);
          }
          if (symbol.flags & 8) {
            return getDeclaredTypeOfEnumMember(symbol);
          }
          if (symbol.flags & 2097152) {
            return getDeclaredTypeOfAlias(symbol);
          }
          return void 0;
        }
        function isThislessType(node) {
          switch (node.kind) {
            case 130:
            case 155:
            case 150:
            case 147:
            case 158:
            case 133:
            case 151:
            case 148:
            case 114:
            case 153:
            case 143:
            case 196:
              return true;
            case 183:
              return isThislessType(node.elementType);
            case 178:
              return !node.typeArguments || node.typeArguments.every(isThislessType);
          }
          return false;
        }
        function isThislessTypeParameter(node) {
          var constraint = ts3.getEffectiveConstraintOfTypeParameter(node);
          return !constraint || isThislessType(constraint);
        }
        function isThislessVariableLikeDeclaration(node) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(node);
          return typeNode ? isThislessType(typeNode) : !ts3.hasInitializer(node);
        }
        function isThislessFunctionLikeDeclaration(node) {
          var returnType = ts3.getEffectiveReturnTypeNode(node);
          var typeParameters = ts3.getEffectiveTypeParameterDeclarations(node);
          return (node.kind === 171 || !!returnType && isThislessType(returnType)) && node.parameters.every(isThislessVariableLikeDeclaration) && typeParameters.every(isThislessTypeParameter);
        }
        function isThisless(symbol) {
          if (symbol.declarations && symbol.declarations.length === 1) {
            var declaration = symbol.declarations[0];
            if (declaration) {
              switch (declaration.kind) {
                case 167:
                case 166:
                  return isThislessVariableLikeDeclaration(declaration);
                case 169:
                case 168:
                case 171:
                case 172:
                case 173:
                  return isThislessFunctionLikeDeclaration(declaration);
              }
            }
          }
          return false;
        }
        function createInstantiatedSymbolTable(symbols, mapper, mappingThisOnly) {
          var result2 = ts3.createSymbolTable();
          for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
            var symbol = symbols_2[_i];
            result2.set(symbol.escapedName, mappingThisOnly && isThisless(symbol) ? symbol : instantiateSymbol(symbol, mapper));
          }
          return result2;
        }
        function addInheritedMembers(symbols, baseSymbols) {
          for (var _i = 0, baseSymbols_1 = baseSymbols; _i < baseSymbols_1.length; _i++) {
            var s = baseSymbols_1[_i];
            if (!symbols.has(s.escapedName) && !isStaticPrivateIdentifierProperty(s)) {
              symbols.set(s.escapedName, s);
            }
          }
        }
        function isStaticPrivateIdentifierProperty(s) {
          return !!s.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(s.valueDeclaration) && ts3.isStatic(s.valueDeclaration);
        }
        function resolveDeclaredMembers(type2) {
          if (!type2.declaredProperties) {
            var symbol = type2.symbol;
            var members = getMembersOfSymbol(symbol);
            type2.declaredProperties = getNamedMembers(members);
            type2.declaredCallSignatures = ts3.emptyArray;
            type2.declaredConstructSignatures = ts3.emptyArray;
            type2.declaredIndexInfos = ts3.emptyArray;
            type2.declaredCallSignatures = getSignaturesOfSymbol(members.get("__call"));
            type2.declaredConstructSignatures = getSignaturesOfSymbol(members.get("__new"));
            type2.declaredIndexInfos = getIndexInfosOfSymbol(symbol);
          }
          return type2;
        }
        function isTypeUsableAsPropertyName(type2) {
          return !!(type2.flags & 8576);
        }
        function isLateBindableName(node) {
          if (!ts3.isComputedPropertyName(node) && !ts3.isElementAccessExpression(node)) {
            return false;
          }
          var expr = ts3.isComputedPropertyName(node) ? node.expression : node.argumentExpression;
          return ts3.isEntityNameExpression(expr) && isTypeUsableAsPropertyName(ts3.isComputedPropertyName(node) ? checkComputedPropertyName(node) : checkExpressionCached(expr));
        }
        function isLateBoundName(name) {
          return name.charCodeAt(0) === 95 && name.charCodeAt(1) === 95 && name.charCodeAt(2) === 64;
        }
        function hasLateBindableName(node) {
          var name = ts3.getNameOfDeclaration(node);
          return !!name && isLateBindableName(name);
        }
        function hasBindableName(node) {
          return !ts3.hasDynamicName(node) || hasLateBindableName(node);
        }
        function isNonBindableDynamicName(node) {
          return ts3.isDynamicName(node) && !isLateBindableName(node);
        }
        function getPropertyNameFromType(type2) {
          if (type2.flags & 8192) {
            return type2.escapedName;
          }
          if (type2.flags & (128 | 256)) {
            return ts3.escapeLeadingUnderscores("" + type2.value);
          }
          return ts3.Debug.fail();
        }
        function addDeclarationToLateBoundSymbol(symbol, member, symbolFlags) {
          ts3.Debug.assert(!!(ts3.getCheckFlags(symbol) & 4096), "Expected a late-bound symbol.");
          symbol.flags |= symbolFlags;
          getSymbolLinks(member.symbol).lateSymbol = symbol;
          if (!symbol.declarations) {
            symbol.declarations = [member];
          } else if (!member.symbol.isReplaceableByMethod) {
            symbol.declarations.push(member);
          }
          if (symbolFlags & 111551) {
            if (!symbol.valueDeclaration || symbol.valueDeclaration.kind !== member.kind) {
              symbol.valueDeclaration = member;
            }
          }
        }
        function lateBindMember(parent, earlySymbols, lateSymbols, decl) {
          ts3.Debug.assert(!!decl.symbol, "The member is expected to have a symbol.");
          var links = getNodeLinks(decl);
          if (!links.resolvedSymbol) {
            links.resolvedSymbol = decl.symbol;
            var declName = ts3.isBinaryExpression(decl) ? decl.left : decl.name;
            var type2 = ts3.isElementAccessExpression(declName) ? checkExpressionCached(declName.argumentExpression) : checkComputedPropertyName(declName);
            if (isTypeUsableAsPropertyName(type2)) {
              var memberName = getPropertyNameFromType(type2);
              var symbolFlags = decl.symbol.flags;
              var lateSymbol = lateSymbols.get(memberName);
              if (!lateSymbol)
                lateSymbols.set(memberName, lateSymbol = createSymbol(0, memberName, 4096));
              var earlySymbol = earlySymbols && earlySymbols.get(memberName);
              if (lateSymbol.flags & getExcludedSymbolFlags(symbolFlags) || earlySymbol) {
                var declarations = earlySymbol ? ts3.concatenate(earlySymbol.declarations, lateSymbol.declarations) : lateSymbol.declarations;
                var name_5 = !(type2.flags & 8192) && ts3.unescapeLeadingUnderscores(memberName) || ts3.declarationNameToString(declName);
                ts3.forEach(declarations, function(declaration) {
                  return error(ts3.getNameOfDeclaration(declaration) || declaration, ts3.Diagnostics.Property_0_was_also_declared_here, name_5);
                });
                error(declName || decl, ts3.Diagnostics.Duplicate_property_0, name_5);
                lateSymbol = createSymbol(0, memberName, 4096);
              }
              lateSymbol.nameType = type2;
              addDeclarationToLateBoundSymbol(lateSymbol, decl, symbolFlags);
              if (lateSymbol.parent) {
                ts3.Debug.assert(lateSymbol.parent === parent, "Existing symbol parent should match new one");
              } else {
                lateSymbol.parent = parent;
              }
              return links.resolvedSymbol = lateSymbol;
            }
          }
          return links.resolvedSymbol;
        }
        function getResolvedMembersOrExportsOfSymbol(symbol, resolutionKind) {
          var links = getSymbolLinks(symbol);
          if (!links[resolutionKind]) {
            var isStatic_1 = resolutionKind === "resolvedExports";
            var earlySymbols = !isStatic_1 ? symbol.members : symbol.flags & 1536 ? getExportsOfModuleWorker(symbol) : symbol.exports;
            links[resolutionKind] = earlySymbols || emptySymbols;
            var lateSymbols = ts3.createSymbolTable();
            for (var _i = 0, _a = symbol.declarations || ts3.emptyArray; _i < _a.length; _i++) {
              var decl = _a[_i];
              var members = ts3.getMembersOfDeclaration(decl);
              if (members) {
                for (var _b = 0, members_5 = members; _b < members_5.length; _b++) {
                  var member = members_5[_b];
                  if (isStatic_1 === ts3.hasStaticModifier(member) && hasLateBindableName(member)) {
                    lateBindMember(symbol, earlySymbols, lateSymbols, member);
                  }
                }
              }
            }
            var assignments = symbol.assignmentDeclarationMembers;
            if (assignments) {
              var decls = ts3.arrayFrom(assignments.values());
              for (var _c = 0, decls_1 = decls; _c < decls_1.length; _c++) {
                var member = decls_1[_c];
                var assignmentKind = ts3.getAssignmentDeclarationKind(member);
                var isInstanceMember = assignmentKind === 3 || ts3.isBinaryExpression(member) && isPossiblyAliasedThisProperty(member, assignmentKind) || assignmentKind === 9 || assignmentKind === 6;
                if (isStatic_1 === !isInstanceMember && hasLateBindableName(member)) {
                  lateBindMember(symbol, earlySymbols, lateSymbols, member);
                }
              }
            }
            links[resolutionKind] = combineSymbolTables(earlySymbols, lateSymbols) || emptySymbols;
          }
          return links[resolutionKind];
        }
        function getMembersOfSymbol(symbol) {
          return symbol.flags & 6256 ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedMembers") : symbol.members || emptySymbols;
        }
        function getLateBoundSymbol(symbol) {
          if (symbol.flags & 106500 && symbol.escapedName === "__computed") {
            var links = getSymbolLinks(symbol);
            if (!links.lateSymbol && ts3.some(symbol.declarations, hasLateBindableName)) {
              var parent = getMergedSymbol(symbol.parent);
              if (ts3.some(symbol.declarations, ts3.hasStaticModifier)) {
                getExportsOfSymbol(parent);
              } else {
                getMembersOfSymbol(parent);
              }
            }
            return links.lateSymbol || (links.lateSymbol = symbol);
          }
          return symbol;
        }
        function getTypeWithThisArgument(type2, thisArgument, needApparentType) {
          if (ts3.getObjectFlags(type2) & 4) {
            var target = type2.target;
            var typeArguments = getTypeArguments(type2);
            if (ts3.length(target.typeParameters) === ts3.length(typeArguments)) {
              var ref = createTypeReference(target, ts3.concatenate(typeArguments, [thisArgument || target.thisType]));
              return needApparentType ? getApparentType(ref) : ref;
            }
          } else if (type2.flags & 2097152) {
            var types2 = ts3.sameMap(type2.types, function(t) {
              return getTypeWithThisArgument(t, thisArgument, needApparentType);
            });
            return types2 !== type2.types ? getIntersectionType(types2) : type2;
          }
          return needApparentType ? getApparentType(type2) : type2;
        }
        function resolveObjectTypeMembers(type2, source, typeParameters, typeArguments) {
          var mapper;
          var members;
          var callSignatures;
          var constructSignatures;
          var indexInfos;
          if (ts3.rangeEquals(typeParameters, typeArguments, 0, typeParameters.length)) {
            members = source.symbol ? getMembersOfSymbol(source.symbol) : ts3.createSymbolTable(source.declaredProperties);
            callSignatures = source.declaredCallSignatures;
            constructSignatures = source.declaredConstructSignatures;
            indexInfos = source.declaredIndexInfos;
          } else {
            mapper = createTypeMapper(typeParameters, typeArguments);
            members = createInstantiatedSymbolTable(source.declaredProperties, mapper, typeParameters.length === 1);
            callSignatures = instantiateSignatures(source.declaredCallSignatures, mapper);
            constructSignatures = instantiateSignatures(source.declaredConstructSignatures, mapper);
            indexInfos = instantiateIndexInfos(source.declaredIndexInfos, mapper);
          }
          var baseTypes = getBaseTypes(source);
          if (baseTypes.length) {
            if (source.symbol && members === getMembersOfSymbol(source.symbol)) {
              members = ts3.createSymbolTable(source.declaredProperties);
            }
            setStructuredTypeMembers(type2, members, callSignatures, constructSignatures, indexInfos);
            var thisArgument = ts3.lastOrUndefined(typeArguments);
            for (var _i = 0, baseTypes_1 = baseTypes; _i < baseTypes_1.length; _i++) {
              var baseType = baseTypes_1[_i];
              var instantiatedBaseType = thisArgument ? getTypeWithThisArgument(instantiateType(baseType, mapper), thisArgument) : baseType;
              addInheritedMembers(members, getPropertiesOfType(instantiatedBaseType));
              callSignatures = ts3.concatenate(callSignatures, getSignaturesOfType(instantiatedBaseType, 0));
              constructSignatures = ts3.concatenate(constructSignatures, getSignaturesOfType(instantiatedBaseType, 1));
              var inheritedIndexInfos = instantiatedBaseType !== anyType ? getIndexInfosOfType(instantiatedBaseType) : [createIndexInfo(stringType, anyType, false)];
              indexInfos = ts3.concatenate(indexInfos, ts3.filter(inheritedIndexInfos, function(info) {
                return !findIndexInfo(indexInfos, info.keyType);
              }));
            }
          }
          setStructuredTypeMembers(type2, members, callSignatures, constructSignatures, indexInfos);
        }
        function resolveClassOrInterfaceMembers(type2) {
          resolveObjectTypeMembers(type2, resolveDeclaredMembers(type2), ts3.emptyArray, ts3.emptyArray);
        }
        function resolveTypeReferenceMembers(type2) {
          var source = resolveDeclaredMembers(type2.target);
          var typeParameters = ts3.concatenate(source.typeParameters, [source.thisType]);
          var typeArguments = getTypeArguments(type2);
          var paddedTypeArguments = typeArguments.length === typeParameters.length ? typeArguments : ts3.concatenate(typeArguments, [type2]);
          resolveObjectTypeMembers(type2, source, typeParameters, paddedTypeArguments);
        }
        function createSignature(declaration, typeParameters, thisParameter, parameters, resolvedReturnType, resolvedTypePredicate, minArgumentCount, flags) {
          var sig = new Signature(checker, flags);
          sig.declaration = declaration;
          sig.typeParameters = typeParameters;
          sig.parameters = parameters;
          sig.thisParameter = thisParameter;
          sig.resolvedReturnType = resolvedReturnType;
          sig.resolvedTypePredicate = resolvedTypePredicate;
          sig.minArgumentCount = minArgumentCount;
          sig.resolvedMinArgumentCount = void 0;
          sig.target = void 0;
          sig.mapper = void 0;
          sig.compositeSignatures = void 0;
          sig.compositeKind = void 0;
          return sig;
        }
        function cloneSignature(sig) {
          var result2 = createSignature(sig.declaration, sig.typeParameters, sig.thisParameter, sig.parameters, void 0, void 0, sig.minArgumentCount, sig.flags & 39);
          result2.target = sig.target;
          result2.mapper = sig.mapper;
          result2.compositeSignatures = sig.compositeSignatures;
          result2.compositeKind = sig.compositeKind;
          return result2;
        }
        function createUnionSignature(signature, unionSignatures) {
          var result2 = cloneSignature(signature);
          result2.compositeSignatures = unionSignatures;
          result2.compositeKind = 1048576;
          result2.target = void 0;
          result2.mapper = void 0;
          return result2;
        }
        function getOptionalCallSignature(signature, callChainFlags) {
          if ((signature.flags & 24) === callChainFlags) {
            return signature;
          }
          if (!signature.optionalCallSignatureCache) {
            signature.optionalCallSignatureCache = {};
          }
          var key = callChainFlags === 8 ? "inner" : "outer";
          return signature.optionalCallSignatureCache[key] || (signature.optionalCallSignatureCache[key] = createOptionalCallSignature(signature, callChainFlags));
        }
        function createOptionalCallSignature(signature, callChainFlags) {
          ts3.Debug.assert(callChainFlags === 8 || callChainFlags === 16, "An optional call signature can either be for an inner call chain or an outer call chain, but not both.");
          var result2 = cloneSignature(signature);
          result2.flags |= callChainFlags;
          return result2;
        }
        function getExpandedParameters(sig, skipUnionExpanding) {
          if (signatureHasRestParameter(sig)) {
            var restIndex_1 = sig.parameters.length - 1;
            var restType = getTypeOfSymbol(sig.parameters[restIndex_1]);
            if (isTupleType(restType)) {
              return [expandSignatureParametersWithTupleMembers(restType, restIndex_1)];
            } else if (!skipUnionExpanding && restType.flags & 1048576 && ts3.every(restType.types, isTupleType)) {
              return ts3.map(restType.types, function(t) {
                return expandSignatureParametersWithTupleMembers(t, restIndex_1);
              });
            }
          }
          return [sig.parameters];
          function expandSignatureParametersWithTupleMembers(restType2, restIndex) {
            var elementTypes = getTypeArguments(restType2);
            var associatedNames = restType2.target.labeledElementDeclarations;
            var restParams = ts3.map(elementTypes, function(t, i) {
              var tupleLabelName = !!associatedNames && getTupleElementLabel(associatedNames[i]);
              var name = tupleLabelName || getParameterNameAtPosition(sig, restIndex + i, restType2);
              var flags = restType2.target.elementFlags[i];
              var checkFlags = flags & 12 ? 32768 : flags & 2 ? 16384 : 0;
              var symbol = createSymbol(1, name, checkFlags);
              symbol.type = flags & 4 ? createArrayType(t) : t;
              return symbol;
            });
            return ts3.concatenate(sig.parameters.slice(0, restIndex), restParams);
          }
        }
        function getDefaultConstructSignatures(classType) {
          var baseConstructorType = getBaseConstructorTypeOfClass(classType);
          var baseSignatures = getSignaturesOfType(baseConstructorType, 1);
          var declaration = ts3.getClassLikeDeclarationOfSymbol(classType.symbol);
          var isAbstract = !!declaration && ts3.hasSyntacticModifier(declaration, 128);
          if (baseSignatures.length === 0) {
            return [createSignature(void 0, classType.localTypeParameters, void 0, ts3.emptyArray, classType, void 0, 0, isAbstract ? 4 : 0)];
          }
          var baseTypeNode = getBaseTypeNodeOfClass(classType);
          var isJavaScript = ts3.isInJSFile(baseTypeNode);
          var typeArguments = typeArgumentsFromTypeReferenceNode(baseTypeNode);
          var typeArgCount = ts3.length(typeArguments);
          var result2 = [];
          for (var _i = 0, baseSignatures_1 = baseSignatures; _i < baseSignatures_1.length; _i++) {
            var baseSig = baseSignatures_1[_i];
            var minTypeArgumentCount = getMinTypeArgumentCount(baseSig.typeParameters);
            var typeParamCount = ts3.length(baseSig.typeParameters);
            if (isJavaScript || typeArgCount >= minTypeArgumentCount && typeArgCount <= typeParamCount) {
              var sig = typeParamCount ? createSignatureInstantiation(baseSig, fillMissingTypeArguments(typeArguments, baseSig.typeParameters, minTypeArgumentCount, isJavaScript)) : cloneSignature(baseSig);
              sig.typeParameters = classType.localTypeParameters;
              sig.resolvedReturnType = classType;
              sig.flags = isAbstract ? sig.flags | 4 : sig.flags & ~4;
              result2.push(sig);
            }
          }
          return result2;
        }
        function findMatchingSignature(signatureList, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes) {
          for (var _i = 0, signatureList_1 = signatureList; _i < signatureList_1.length; _i++) {
            var s = signatureList_1[_i];
            if (compareSignaturesIdentical(s, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes, partialMatch ? compareTypesSubtypeOf : compareTypesIdentical)) {
              return s;
            }
          }
        }
        function findMatchingSignatures(signatureLists, signature, listIndex) {
          if (signature.typeParameters) {
            if (listIndex > 0) {
              return void 0;
            }
            for (var i = 1; i < signatureLists.length; i++) {
              if (!findMatchingSignature(signatureLists[i], signature, false, false, false)) {
                return void 0;
              }
            }
            return [signature];
          }
          var result2;
          for (var i = 0; i < signatureLists.length; i++) {
            var match = i === listIndex ? signature : findMatchingSignature(signatureLists[i], signature, true, false, true);
            if (!match) {
              return void 0;
            }
            result2 = ts3.appendIfUnique(result2, match);
          }
          return result2;
        }
        function getUnionSignatures(signatureLists) {
          var result2;
          var indexWithLengthOverOne;
          for (var i = 0; i < signatureLists.length; i++) {
            if (signatureLists[i].length === 0)
              return ts3.emptyArray;
            if (signatureLists[i].length > 1) {
              indexWithLengthOverOne = indexWithLengthOverOne === void 0 ? i : -1;
            }
            for (var _i = 0, _a = signatureLists[i]; _i < _a.length; _i++) {
              var signature = _a[_i];
              if (!result2 || !findMatchingSignature(result2, signature, false, false, true)) {
                var unionSignatures = findMatchingSignatures(signatureLists, signature, i);
                if (unionSignatures) {
                  var s = signature;
                  if (unionSignatures.length > 1) {
                    var thisParameter = signature.thisParameter;
                    var firstThisParameterOfUnionSignatures = ts3.forEach(unionSignatures, function(sig) {
                      return sig.thisParameter;
                    });
                    if (firstThisParameterOfUnionSignatures) {
                      var thisType = getIntersectionType(ts3.mapDefined(unionSignatures, function(sig) {
                        return sig.thisParameter && getTypeOfSymbol(sig.thisParameter);
                      }));
                      thisParameter = createSymbolWithType(firstThisParameterOfUnionSignatures, thisType);
                    }
                    s = createUnionSignature(signature, unionSignatures);
                    s.thisParameter = thisParameter;
                  }
                  (result2 || (result2 = [])).push(s);
                }
              }
            }
          }
          if (!ts3.length(result2) && indexWithLengthOverOne !== -1) {
            var masterList = signatureLists[indexWithLengthOverOne !== void 0 ? indexWithLengthOverOne : 0];
            var results = masterList.slice();
            var _loop_10 = function(signatures2) {
              if (signatures2 !== masterList) {
                var signature_1 = signatures2[0];
                ts3.Debug.assert(!!signature_1, "getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass");
                results = !!signature_1.typeParameters && ts3.some(results, function(s2) {
                  return !!s2.typeParameters && !compareTypeParametersIdentical(signature_1.typeParameters, s2.typeParameters);
                }) ? void 0 : ts3.map(results, function(sig) {
                  return combineSignaturesOfUnionMembers(sig, signature_1);
                });
                if (!results) {
                  return "break";
                }
              }
            };
            for (var _b = 0, signatureLists_1 = signatureLists; _b < signatureLists_1.length; _b++) {
              var signatures = signatureLists_1[_b];
              var state_3 = _loop_10(signatures);
              if (state_3 === "break")
                break;
            }
            result2 = results;
          }
          return result2 || ts3.emptyArray;
        }
        function compareTypeParametersIdentical(sourceParams, targetParams) {
          if (ts3.length(sourceParams) !== ts3.length(targetParams)) {
            return false;
          }
          if (!sourceParams || !targetParams) {
            return true;
          }
          var mapper = createTypeMapper(targetParams, sourceParams);
          for (var i = 0; i < sourceParams.length; i++) {
            var source = sourceParams[i];
            var target = targetParams[i];
            if (source === target)
              continue;
            if (!isTypeIdenticalTo(getConstraintFromTypeParameter(source) || unknownType, instantiateType(getConstraintFromTypeParameter(target) || unknownType, mapper)))
              return false;
          }
          return true;
        }
        function combineUnionThisParam(left, right, mapper) {
          if (!left || !right) {
            return left || right;
          }
          var thisType = getIntersectionType([getTypeOfSymbol(left), instantiateType(getTypeOfSymbol(right), mapper)]);
          return createSymbolWithType(left, thisType);
        }
        function combineUnionParameters(left, right, mapper) {
          var leftCount = getParameterCount(left);
          var rightCount = getParameterCount(right);
          var longest = leftCount >= rightCount ? left : right;
          var shorter = longest === left ? right : left;
          var longestCount = longest === left ? leftCount : rightCount;
          var eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
          var needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
          var params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
          for (var i = 0; i < longestCount; i++) {
            var longestParamType = tryGetTypeAtPosition(longest, i);
            if (longest === right) {
              longestParamType = instantiateType(longestParamType, mapper);
            }
            var shorterParamType = tryGetTypeAtPosition(shorter, i) || unknownType;
            if (shorter === right) {
              shorterParamType = instantiateType(shorterParamType, mapper);
            }
            var unionParamType = getIntersectionType([longestParamType, shorterParamType]);
            var isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i === longestCount - 1;
            var isOptional = i >= getMinArgumentCount(longest) && i >= getMinArgumentCount(shorter);
            var leftName = i >= leftCount ? void 0 : getParameterNameAtPosition(left, i);
            var rightName = i >= rightCount ? void 0 : getParameterNameAtPosition(right, i);
            var paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
            var paramSymbol = createSymbol(1 | (isOptional && !isRestParam ? 16777216 : 0), paramName || "arg".concat(i));
            paramSymbol.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
            params[i] = paramSymbol;
          }
          if (needsExtraRestElement) {
            var restParamSymbol = createSymbol(1, "args");
            restParamSymbol.type = createArrayType(getTypeAtPosition(shorter, longestCount));
            if (shorter === right) {
              restParamSymbol.type = instantiateType(restParamSymbol.type, mapper);
            }
            params[longestCount] = restParamSymbol;
          }
          return params;
        }
        function combineSignaturesOfUnionMembers(left, right) {
          var typeParams = left.typeParameters || right.typeParameters;
          var paramMapper;
          if (left.typeParameters && right.typeParameters) {
            paramMapper = createTypeMapper(right.typeParameters, left.typeParameters);
          }
          var declaration = left.declaration;
          var params = combineUnionParameters(left, right, paramMapper);
          var thisParam = combineUnionThisParam(left.thisParameter, right.thisParameter, paramMapper);
          var minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
          var result2 = createSignature(declaration, typeParams, thisParam, params, void 0, void 0, minArgCount, (left.flags | right.flags) & 39);
          result2.compositeKind = 1048576;
          result2.compositeSignatures = ts3.concatenate(left.compositeKind !== 2097152 && left.compositeSignatures || [left], [right]);
          if (paramMapper) {
            result2.mapper = left.compositeKind !== 2097152 && left.mapper && left.compositeSignatures ? combineTypeMappers(left.mapper, paramMapper) : paramMapper;
          }
          return result2;
        }
        function getUnionIndexInfos(types2) {
          var sourceInfos = getIndexInfosOfType(types2[0]);
          if (sourceInfos) {
            var result2 = [];
            var _loop_11 = function(info2) {
              var indexType = info2.keyType;
              if (ts3.every(types2, function(t) {
                return !!getIndexInfoOfType(t, indexType);
              })) {
                result2.push(createIndexInfo(indexType, getUnionType(ts3.map(types2, function(t) {
                  return getIndexTypeOfType(t, indexType);
                })), ts3.some(types2, function(t) {
                  return getIndexInfoOfType(t, indexType).isReadonly;
                })));
              }
            };
            for (var _i = 0, sourceInfos_1 = sourceInfos; _i < sourceInfos_1.length; _i++) {
              var info = sourceInfos_1[_i];
              _loop_11(info);
            }
            return result2;
          }
          return ts3.emptyArray;
        }
        function resolveUnionTypeMembers(type2) {
          var callSignatures = getUnionSignatures(ts3.map(type2.types, function(t) {
            return t === globalFunctionType ? [unknownSignature] : getSignaturesOfType(t, 0);
          }));
          var constructSignatures = getUnionSignatures(ts3.map(type2.types, function(t) {
            return getSignaturesOfType(t, 1);
          }));
          var indexInfos = getUnionIndexInfos(type2.types);
          setStructuredTypeMembers(type2, emptySymbols, callSignatures, constructSignatures, indexInfos);
        }
        function intersectTypes(type1, type2) {
          return !type1 ? type2 : !type2 ? type1 : getIntersectionType([type1, type2]);
        }
        function findMixins(types2) {
          var constructorTypeCount = ts3.countWhere(types2, function(t) {
            return getSignaturesOfType(t, 1).length > 0;
          });
          var mixinFlags = ts3.map(types2, isMixinConstructorType);
          if (constructorTypeCount > 0 && constructorTypeCount === ts3.countWhere(mixinFlags, function(b) {
            return b;
          })) {
            var firstMixinIndex = mixinFlags.indexOf(true);
            mixinFlags[firstMixinIndex] = false;
          }
          return mixinFlags;
        }
        function includeMixinType(type2, types2, mixinFlags, index) {
          var mixedTypes = [];
          for (var i = 0; i < types2.length; i++) {
            if (i === index) {
              mixedTypes.push(type2);
            } else if (mixinFlags[i]) {
              mixedTypes.push(getReturnTypeOfSignature(getSignaturesOfType(types2[i], 1)[0]));
            }
          }
          return getIntersectionType(mixedTypes);
        }
        function resolveIntersectionTypeMembers(type2) {
          var callSignatures;
          var constructSignatures;
          var indexInfos;
          var types2 = type2.types;
          var mixinFlags = findMixins(types2);
          var mixinCount = ts3.countWhere(mixinFlags, function(b) {
            return b;
          });
          var _loop_12 = function(i2) {
            var t = type2.types[i2];
            if (!mixinFlags[i2]) {
              var signatures = getSignaturesOfType(t, 1);
              if (signatures.length && mixinCount > 0) {
                signatures = ts3.map(signatures, function(s) {
                  var clone = cloneSignature(s);
                  clone.resolvedReturnType = includeMixinType(getReturnTypeOfSignature(s), types2, mixinFlags, i2);
                  return clone;
                });
              }
              constructSignatures = appendSignatures(constructSignatures, signatures);
            }
            callSignatures = appendSignatures(callSignatures, getSignaturesOfType(t, 0));
            indexInfos = ts3.reduceLeft(getIndexInfosOfType(t), function(infos, newInfo) {
              return appendIndexInfo(infos, newInfo, false);
            }, indexInfos);
          };
          for (var i = 0; i < types2.length; i++) {
            _loop_12(i);
          }
          setStructuredTypeMembers(type2, emptySymbols, callSignatures || ts3.emptyArray, constructSignatures || ts3.emptyArray, indexInfos || ts3.emptyArray);
        }
        function appendSignatures(signatures, newSignatures) {
          var _loop_13 = function(sig2) {
            if (!signatures || ts3.every(signatures, function(s) {
              return !compareSignaturesIdentical(s, sig2, false, false, false, compareTypesIdentical);
            })) {
              signatures = ts3.append(signatures, sig2);
            }
          };
          for (var _i = 0, newSignatures_1 = newSignatures; _i < newSignatures_1.length; _i++) {
            var sig = newSignatures_1[_i];
            _loop_13(sig);
          }
          return signatures;
        }
        function appendIndexInfo(indexInfos, newInfo, union) {
          if (indexInfos) {
            for (var i = 0; i < indexInfos.length; i++) {
              var info = indexInfos[i];
              if (info.keyType === newInfo.keyType) {
                indexInfos[i] = createIndexInfo(info.keyType, union ? getUnionType([info.type, newInfo.type]) : getIntersectionType([info.type, newInfo.type]), union ? info.isReadonly || newInfo.isReadonly : info.isReadonly && newInfo.isReadonly);
                return indexInfos;
              }
            }
          }
          return ts3.append(indexInfos, newInfo);
        }
        function resolveAnonymousTypeMembers(type2) {
          if (type2.target) {
            setStructuredTypeMembers(type2, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
            var members_6 = createInstantiatedSymbolTable(getPropertiesOfObjectType(type2.target), type2.mapper, false);
            var callSignatures = instantiateSignatures(getSignaturesOfType(type2.target, 0), type2.mapper);
            var constructSignatures = instantiateSignatures(getSignaturesOfType(type2.target, 1), type2.mapper);
            var indexInfos_1 = instantiateIndexInfos(getIndexInfosOfType(type2.target), type2.mapper);
            setStructuredTypeMembers(type2, members_6, callSignatures, constructSignatures, indexInfos_1);
            return;
          }
          var symbol = getMergedSymbol(type2.symbol);
          if (symbol.flags & 2048) {
            setStructuredTypeMembers(type2, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
            var members_7 = getMembersOfSymbol(symbol);
            var callSignatures = getSignaturesOfSymbol(members_7.get("__call"));
            var constructSignatures = getSignaturesOfSymbol(members_7.get("__new"));
            var indexInfos_2 = getIndexInfosOfSymbol(symbol);
            setStructuredTypeMembers(type2, members_7, callSignatures, constructSignatures, indexInfos_2);
            return;
          }
          var members = emptySymbols;
          var indexInfos;
          if (symbol.exports) {
            members = getExportsOfSymbol(symbol);
            if (symbol === globalThisSymbol) {
              var varsOnly_1 = new ts3.Map();
              members.forEach(function(p) {
                var _a;
                if (!(p.flags & 418) && !(p.flags & 512 && ((_a = p.declarations) === null || _a === void 0 ? void 0 : _a.length) && ts3.every(p.declarations, ts3.isAmbientModule))) {
                  varsOnly_1.set(p.escapedName, p);
                }
              });
              members = varsOnly_1;
            }
          }
          var baseConstructorIndexInfo;
          setStructuredTypeMembers(type2, members, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
          if (symbol.flags & 32) {
            var classType = getDeclaredTypeOfClassOrInterface(symbol);
            var baseConstructorType = getBaseConstructorTypeOfClass(classType);
            if (baseConstructorType.flags & (524288 | 2097152 | 8650752)) {
              members = ts3.createSymbolTable(getNamedOrIndexSignatureMembers(members));
              addInheritedMembers(members, getPropertiesOfType(baseConstructorType));
            } else if (baseConstructorType === anyType) {
              baseConstructorIndexInfo = createIndexInfo(stringType, anyType, false);
            }
          }
          var indexSymbol = getIndexSymbolFromSymbolTable(members);
          if (indexSymbol) {
            indexInfos = getIndexInfosOfIndexSymbol(indexSymbol);
          } else {
            if (baseConstructorIndexInfo) {
              indexInfos = ts3.append(indexInfos, baseConstructorIndexInfo);
            }
            if (symbol.flags & 384 && (getDeclaredTypeOfSymbol(symbol).flags & 32 || ts3.some(type2.properties, function(prop) {
              return !!(getTypeOfSymbol(prop).flags & 296);
            }))) {
              indexInfos = ts3.append(indexInfos, enumNumberIndexInfo);
            }
          }
          setStructuredTypeMembers(type2, members, ts3.emptyArray, ts3.emptyArray, indexInfos || ts3.emptyArray);
          if (symbol.flags & (16 | 8192)) {
            type2.callSignatures = getSignaturesOfSymbol(symbol);
          }
          if (symbol.flags & 32) {
            var classType_1 = getDeclaredTypeOfClassOrInterface(symbol);
            var constructSignatures = symbol.members ? getSignaturesOfSymbol(symbol.members.get("__constructor")) : ts3.emptyArray;
            if (symbol.flags & 16) {
              constructSignatures = ts3.addRange(constructSignatures.slice(), ts3.mapDefined(type2.callSignatures, function(sig) {
                return isJSConstructor(sig.declaration) ? createSignature(sig.declaration, sig.typeParameters, sig.thisParameter, sig.parameters, classType_1, void 0, sig.minArgumentCount, sig.flags & 39) : void 0;
              }));
            }
            if (!constructSignatures.length) {
              constructSignatures = getDefaultConstructSignatures(classType_1);
            }
            type2.constructSignatures = constructSignatures;
          }
        }
        function replaceIndexedAccess(instantiable, type2, replacement) {
          return instantiateType(instantiable, createTypeMapper([type2.indexType, type2.objectType], [getNumberLiteralType(0), createTupleType([replacement])]));
        }
        function resolveReverseMappedTypeMembers(type2) {
          var indexInfo = getIndexInfoOfType(type2.source, stringType);
          var modifiers = getMappedTypeModifiers(type2.mappedType);
          var readonlyMask = modifiers & 1 ? false : true;
          var optionalMask = modifiers & 4 ? 0 : 16777216;
          var indexInfos = indexInfo ? [createIndexInfo(stringType, inferReverseMappedType(indexInfo.type, type2.mappedType, type2.constraintType), readonlyMask && indexInfo.isReadonly)] : ts3.emptyArray;
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfType(type2.source); _i < _a.length; _i++) {
            var prop = _a[_i];
            var checkFlags = 8192 | (readonlyMask && isReadonlySymbol(prop) ? 8 : 0);
            var inferredProp = createSymbol(4 | prop.flags & optionalMask, prop.escapedName, checkFlags);
            inferredProp.declarations = prop.declarations;
            inferredProp.nameType = getSymbolLinks(prop).nameType;
            inferredProp.propertyType = getTypeOfSymbol(prop);
            if (type2.constraintType.type.flags & 8388608 && type2.constraintType.type.objectType.flags & 262144 && type2.constraintType.type.indexType.flags & 262144) {
              var newTypeParam = type2.constraintType.type.objectType;
              var newMappedType = replaceIndexedAccess(type2.mappedType, type2.constraintType.type, newTypeParam);
              inferredProp.mappedType = newMappedType;
              inferredProp.constraintType = getIndexType(newTypeParam);
            } else {
              inferredProp.mappedType = type2.mappedType;
              inferredProp.constraintType = type2.constraintType;
            }
            members.set(prop.escapedName, inferredProp);
          }
          setStructuredTypeMembers(type2, members, ts3.emptyArray, ts3.emptyArray, indexInfos);
        }
        function getLowerBoundOfKeyType(type2) {
          if (type2.flags & 4194304) {
            var t = getApparentType(type2.type);
            return isGenericTupleType(t) ? getKnownKeysOfTupleType(t) : getIndexType(t);
          }
          if (type2.flags & 16777216) {
            if (type2.root.isDistributive) {
              var checkType = type2.checkType;
              var constraint = getLowerBoundOfKeyType(checkType);
              if (constraint !== checkType) {
                return getConditionalTypeInstantiation(type2, prependTypeMapping(type2.root.checkType, constraint, type2.mapper));
              }
            }
            return type2;
          }
          if (type2.flags & 1048576) {
            return mapType(type2, getLowerBoundOfKeyType);
          }
          if (type2.flags & 2097152) {
            return getIntersectionType(ts3.sameMap(type2.types, getLowerBoundOfKeyType));
          }
          return type2;
        }
        function getIsLateCheckFlag(s) {
          return ts3.getCheckFlags(s) & 4096;
        }
        function forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(type2, include, stringsOnly, cb) {
          for (var _i = 0, _a = getPropertiesOfType(type2); _i < _a.length; _i++) {
            var prop = _a[_i];
            cb(getLiteralTypeFromProperty(prop, include));
          }
          if (type2.flags & 1) {
            cb(stringType);
          } else {
            for (var _b = 0, _c = getIndexInfosOfType(type2); _b < _c.length; _b++) {
              var info = _c[_b];
              if (!stringsOnly || info.keyType.flags & (4 | 134217728)) {
                cb(info.keyType);
              }
            }
          }
        }
        function resolveMappedTypeMembers(type2) {
          var members = ts3.createSymbolTable();
          var indexInfos;
          setStructuredTypeMembers(type2, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
          var typeParameter = getTypeParameterFromMappedType(type2);
          var constraintType = getConstraintTypeFromMappedType(type2);
          var nameType = getNameTypeFromMappedType(type2.target || type2);
          var templateType = getTemplateTypeFromMappedType(type2.target || type2);
          var modifiersType = getApparentType(getModifiersTypeFromMappedType(type2));
          var templateModifiers = getMappedTypeModifiers(type2);
          var include = keyofStringsOnly ? 128 : 8576;
          if (isMappedTypeWithKeyofConstraintDeclaration(type2)) {
            forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(modifiersType, include, keyofStringsOnly, addMemberForKeyType);
          } else {
            forEachType(getLowerBoundOfKeyType(constraintType), addMemberForKeyType);
          }
          setStructuredTypeMembers(type2, members, ts3.emptyArray, ts3.emptyArray, indexInfos || ts3.emptyArray);
          function addMemberForKeyType(keyType) {
            var propNameType = nameType ? instantiateType(nameType, appendTypeMapping(type2.mapper, typeParameter, keyType)) : keyType;
            forEachType(propNameType, function(t) {
              return addMemberForKeyTypeWorker(keyType, t);
            });
          }
          function addMemberForKeyTypeWorker(keyType, propNameType) {
            if (isTypeUsableAsPropertyName(propNameType)) {
              var propName = getPropertyNameFromType(propNameType);
              var existingProp = members.get(propName);
              if (existingProp) {
                existingProp.nameType = getUnionType([existingProp.nameType, propNameType]);
                existingProp.keyType = getUnionType([existingProp.keyType, keyType]);
              } else {
                var modifiersProp = isTypeUsableAsPropertyName(keyType) ? getPropertyOfType(modifiersType, getPropertyNameFromType(keyType)) : void 0;
                var isOptional = !!(templateModifiers & 4 || !(templateModifiers & 8) && modifiersProp && modifiersProp.flags & 16777216);
                var isReadonly = !!(templateModifiers & 1 || !(templateModifiers & 2) && modifiersProp && isReadonlySymbol(modifiersProp));
                var stripOptional = strictNullChecks && !isOptional && modifiersProp && modifiersProp.flags & 16777216;
                var lateFlag = modifiersProp ? getIsLateCheckFlag(modifiersProp) : 0;
                var prop = createSymbol(4 | (isOptional ? 16777216 : 0), propName, lateFlag | 262144 | (isReadonly ? 8 : 0) | (stripOptional ? 524288 : 0));
                prop.mappedType = type2;
                prop.nameType = propNameType;
                prop.keyType = keyType;
                if (modifiersProp) {
                  prop.syntheticOrigin = modifiersProp;
                  prop.declarations = nameType ? void 0 : modifiersProp.declarations;
                }
                members.set(propName, prop);
              }
            } else if (isValidIndexKeyType(propNameType) || propNameType.flags & (1 | 32)) {
              var indexKeyType = propNameType.flags & (1 | 4) ? stringType : propNameType.flags & (8 | 32) ? numberType : propNameType;
              var propType = instantiateType(templateType, appendTypeMapping(type2.mapper, typeParameter, keyType));
              var indexInfo = createIndexInfo(indexKeyType, propType, !!(templateModifiers & 1));
              indexInfos = appendIndexInfo(indexInfos, indexInfo, true);
            }
          }
        }
        function getTypeOfMappedSymbol(symbol) {
          if (!symbol.type) {
            var mappedType = symbol.mappedType;
            if (!pushTypeResolution(symbol, 0)) {
              mappedType.containsError = true;
              return errorType;
            }
            var templateType = getTemplateTypeFromMappedType(mappedType.target || mappedType);
            var mapper = appendTypeMapping(mappedType.mapper, getTypeParameterFromMappedType(mappedType), symbol.keyType);
            var propType = instantiateType(templateType, mapper);
            var type2 = strictNullChecks && symbol.flags & 16777216 && !maybeTypeOfKind(propType, 32768 | 16384) ? getOptionalType(propType, true) : symbol.checkFlags & 524288 ? removeMissingOrUndefinedType(propType) : propType;
            if (!popTypeResolution()) {
              error(currentNode, ts3.Diagnostics.Type_of_property_0_circularly_references_itself_in_mapped_type_1, symbolToString(symbol), typeToString(mappedType));
              type2 = errorType;
            }
            symbol.type = type2;
          }
          return symbol.type;
        }
        function getTypeParameterFromMappedType(type2) {
          return type2.typeParameter || (type2.typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(type2.declaration.typeParameter)));
        }
        function getConstraintTypeFromMappedType(type2) {
          return type2.constraintType || (type2.constraintType = getConstraintOfTypeParameter(getTypeParameterFromMappedType(type2)) || errorType);
        }
        function getNameTypeFromMappedType(type2) {
          return type2.declaration.nameType ? type2.nameType || (type2.nameType = instantiateType(getTypeFromTypeNode(type2.declaration.nameType), type2.mapper)) : void 0;
        }
        function getTemplateTypeFromMappedType(type2) {
          return type2.templateType || (type2.templateType = type2.declaration.type ? instantiateType(addOptionality(getTypeFromTypeNode(type2.declaration.type), true, !!(getMappedTypeModifiers(type2) & 4)), type2.mapper) : errorType);
        }
        function getConstraintDeclarationForMappedType(type2) {
          return ts3.getEffectiveConstraintOfTypeParameter(type2.declaration.typeParameter);
        }
        function isMappedTypeWithKeyofConstraintDeclaration(type2) {
          var constraintDeclaration = getConstraintDeclarationForMappedType(type2);
          return constraintDeclaration.kind === 193 && constraintDeclaration.operator === 140;
        }
        function getModifiersTypeFromMappedType(type2) {
          if (!type2.modifiersType) {
            if (isMappedTypeWithKeyofConstraintDeclaration(type2)) {
              type2.modifiersType = instantiateType(getTypeFromTypeNode(getConstraintDeclarationForMappedType(type2).type), type2.mapper);
            } else {
              var declaredType = getTypeFromMappedTypeNode(type2.declaration);
              var constraint = getConstraintTypeFromMappedType(declaredType);
              var extendedConstraint = constraint && constraint.flags & 262144 ? getConstraintOfTypeParameter(constraint) : constraint;
              type2.modifiersType = extendedConstraint && extendedConstraint.flags & 4194304 ? instantiateType(extendedConstraint.type, type2.mapper) : unknownType;
            }
          }
          return type2.modifiersType;
        }
        function getMappedTypeModifiers(type2) {
          var declaration = type2.declaration;
          return (declaration.readonlyToken ? declaration.readonlyToken.kind === 40 ? 2 : 1 : 0) | (declaration.questionToken ? declaration.questionToken.kind === 40 ? 8 : 4 : 0);
        }
        function getMappedTypeOptionality(type2) {
          var modifiers = getMappedTypeModifiers(type2);
          return modifiers & 8 ? -1 : modifiers & 4 ? 1 : 0;
        }
        function getCombinedMappedTypeOptionality(type2) {
          var optionality = getMappedTypeOptionality(type2);
          var modifiersType = getModifiersTypeFromMappedType(type2);
          return optionality || (isGenericMappedType(modifiersType) ? getMappedTypeOptionality(modifiersType) : 0);
        }
        function isPartialMappedType(type2) {
          return !!(ts3.getObjectFlags(type2) & 32 && getMappedTypeModifiers(type2) & 4);
        }
        function isGenericMappedType(type2) {
          return !!(ts3.getObjectFlags(type2) & 32) && isGenericIndexType(getConstraintTypeFromMappedType(type2));
        }
        function resolveStructuredTypeMembers(type2) {
          if (!type2.members) {
            if (type2.flags & 524288) {
              if (type2.objectFlags & 4) {
                resolveTypeReferenceMembers(type2);
              } else if (type2.objectFlags & 3) {
                resolveClassOrInterfaceMembers(type2);
              } else if (type2.objectFlags & 1024) {
                resolveReverseMappedTypeMembers(type2);
              } else if (type2.objectFlags & 16) {
                resolveAnonymousTypeMembers(type2);
              } else if (type2.objectFlags & 32) {
                resolveMappedTypeMembers(type2);
              }
            } else if (type2.flags & 1048576) {
              resolveUnionTypeMembers(type2);
            } else if (type2.flags & 2097152) {
              resolveIntersectionTypeMembers(type2);
            }
          }
          return type2;
        }
        function getPropertiesOfObjectType(type2) {
          if (type2.flags & 524288) {
            return resolveStructuredTypeMembers(type2).properties;
          }
          return ts3.emptyArray;
        }
        function getPropertyOfObjectType(type2, name) {
          if (type2.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type2);
            var symbol = resolved.members.get(name);
            if (symbol && symbolIsValue(symbol)) {
              return symbol;
            }
          }
        }
        function getPropertiesOfUnionOrIntersectionType(type2) {
          if (!type2.resolvedProperties) {
            var members = ts3.createSymbolTable();
            for (var _i = 0, _a = type2.types; _i < _a.length; _i++) {
              var current = _a[_i];
              for (var _b = 0, _c = getPropertiesOfType(current); _b < _c.length; _b++) {
                var prop = _c[_b];
                if (!members.has(prop.escapedName)) {
                  var combinedProp = getPropertyOfUnionOrIntersectionType(type2, prop.escapedName);
                  if (combinedProp) {
                    members.set(prop.escapedName, combinedProp);
                  }
                }
              }
              if (type2.flags & 1048576 && getIndexInfosOfType(current).length === 0) {
                break;
              }
            }
            type2.resolvedProperties = getNamedMembers(members);
          }
          return type2.resolvedProperties;
        }
        function getPropertiesOfType(type2) {
          type2 = getReducedApparentType(type2);
          return type2.flags & 3145728 ? getPropertiesOfUnionOrIntersectionType(type2) : getPropertiesOfObjectType(type2);
        }
        function forEachPropertyOfType(type2, action) {
          type2 = getReducedApparentType(type2);
          if (type2.flags & 3670016) {
            resolveStructuredTypeMembers(type2).members.forEach(function(symbol, escapedName) {
              if (isNamedMember(symbol, escapedName)) {
                action(symbol, escapedName);
              }
            });
          }
        }
        function isTypeInvalidDueToUnionDiscriminant(contextualType, obj) {
          var list = obj.properties;
          return list.some(function(property) {
            var nameType = property.name && getLiteralTypeFromPropertyName(property.name);
            var name = nameType && isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
            var expected = name === void 0 ? void 0 : getTypeOfPropertyOfType(contextualType, name);
            return !!expected && isLiteralType(expected) && !isTypeAssignableTo(getTypeOfNode(property), expected);
          });
        }
        function getAllPossiblePropertiesOfTypes(types2) {
          var unionType = getUnionType(types2);
          if (!(unionType.flags & 1048576)) {
            return getAugmentedPropertiesOfType(unionType);
          }
          var props = ts3.createSymbolTable();
          for (var _i = 0, types_4 = types2; _i < types_4.length; _i++) {
            var memberType = types_4[_i];
            for (var _a = 0, _b = getAugmentedPropertiesOfType(memberType); _a < _b.length; _a++) {
              var escapedName = _b[_a].escapedName;
              if (!props.has(escapedName)) {
                var prop = createUnionOrIntersectionProperty(unionType, escapedName);
                if (prop)
                  props.set(escapedName, prop);
              }
            }
          }
          return ts3.arrayFrom(props.values());
        }
        function getConstraintOfType(type2) {
          return type2.flags & 262144 ? getConstraintOfTypeParameter(type2) : type2.flags & 8388608 ? getConstraintOfIndexedAccess(type2) : type2.flags & 16777216 ? getConstraintOfConditionalType(type2) : getBaseConstraintOfType(type2);
        }
        function getConstraintOfTypeParameter(typeParameter) {
          return hasNonCircularBaseConstraint(typeParameter) ? getConstraintFromTypeParameter(typeParameter) : void 0;
        }
        function getConstraintOfIndexedAccess(type2) {
          return hasNonCircularBaseConstraint(type2) ? getConstraintFromIndexedAccess(type2) : void 0;
        }
        function getSimplifiedTypeOrConstraint(type2) {
          var simplified = getSimplifiedType(type2, false);
          return simplified !== type2 ? simplified : getConstraintOfType(type2);
        }
        function getConstraintFromIndexedAccess(type2) {
          if (isMappedTypeGenericIndexedAccess(type2)) {
            return substituteIndexedMappedType(type2.objectType, type2.indexType);
          }
          var indexConstraint = getSimplifiedTypeOrConstraint(type2.indexType);
          if (indexConstraint && indexConstraint !== type2.indexType) {
            var indexedAccess = getIndexedAccessTypeOrUndefined(type2.objectType, indexConstraint, type2.accessFlags);
            if (indexedAccess) {
              return indexedAccess;
            }
          }
          var objectConstraint = getSimplifiedTypeOrConstraint(type2.objectType);
          if (objectConstraint && objectConstraint !== type2.objectType) {
            return getIndexedAccessTypeOrUndefined(objectConstraint, type2.indexType, type2.accessFlags);
          }
          return void 0;
        }
        function getDefaultConstraintOfConditionalType(type2) {
          if (!type2.resolvedDefaultConstraint) {
            var trueConstraint = getInferredTrueTypeFromConditionalType(type2);
            var falseConstraint = getFalseTypeFromConditionalType(type2);
            type2.resolvedDefaultConstraint = isTypeAny(trueConstraint) ? falseConstraint : isTypeAny(falseConstraint) ? trueConstraint : getUnionType([trueConstraint, falseConstraint]);
          }
          return type2.resolvedDefaultConstraint;
        }
        function getConstraintOfDistributiveConditionalType(type2) {
          if (type2.root.isDistributive && type2.restrictiveInstantiation !== type2) {
            var simplified = getSimplifiedType(type2.checkType, false);
            var constraint = simplified === type2.checkType ? getConstraintOfType(simplified) : simplified;
            if (constraint && constraint !== type2.checkType) {
              var instantiated = getConditionalTypeInstantiation(type2, prependTypeMapping(type2.root.checkType, constraint, type2.mapper));
              if (!(instantiated.flags & 131072)) {
                return instantiated;
              }
            }
          }
          return void 0;
        }
        function getConstraintFromConditionalType(type2) {
          return getConstraintOfDistributiveConditionalType(type2) || getDefaultConstraintOfConditionalType(type2);
        }
        function getConstraintOfConditionalType(type2) {
          return hasNonCircularBaseConstraint(type2) ? getConstraintFromConditionalType(type2) : void 0;
        }
        function getEffectiveConstraintOfIntersection(types2, targetIsUnion) {
          var constraints;
          var hasDisjointDomainType = false;
          for (var _i = 0, types_5 = types2; _i < types_5.length; _i++) {
            var t = types_5[_i];
            if (t.flags & 465829888) {
              var constraint = getConstraintOfType(t);
              while (constraint && constraint.flags & (262144 | 4194304 | 16777216)) {
                constraint = getConstraintOfType(constraint);
              }
              if (constraint) {
                constraints = ts3.append(constraints, constraint);
                if (targetIsUnion) {
                  constraints = ts3.append(constraints, t);
                }
              }
            } else if (t.flags & 469892092) {
              hasDisjointDomainType = true;
            }
          }
          if (constraints && (targetIsUnion || hasDisjointDomainType)) {
            if (hasDisjointDomainType) {
              for (var _a = 0, types_6 = types2; _a < types_6.length; _a++) {
                var t = types_6[_a];
                if (t.flags & 469892092) {
                  constraints = ts3.append(constraints, t);
                }
              }
            }
            return getIntersectionType(constraints);
          }
          return void 0;
        }
        function getBaseConstraintOfType(type2) {
          if (type2.flags & (58982400 | 3145728 | 134217728 | 268435456)) {
            var constraint = getResolvedBaseConstraint(type2);
            return constraint !== noConstraintType && constraint !== circularConstraintType ? constraint : void 0;
          }
          return type2.flags & 4194304 ? keyofConstraintType : void 0;
        }
        function getBaseConstraintOrType(type2) {
          return getBaseConstraintOfType(type2) || type2;
        }
        function hasNonCircularBaseConstraint(type2) {
          return getResolvedBaseConstraint(type2) !== circularConstraintType;
        }
        function getResolvedBaseConstraint(type2) {
          if (type2.resolvedBaseConstraint) {
            return type2.resolvedBaseConstraint;
          }
          var stack = [];
          return type2.resolvedBaseConstraint = getTypeWithThisArgument(getImmediateBaseConstraint(type2), type2);
          function getImmediateBaseConstraint(t) {
            if (!t.immediateBaseConstraint) {
              if (!pushTypeResolution(t, 4)) {
                return circularConstraintType;
              }
              var result2 = void 0;
              var identity_1 = getRecursionIdentity(t);
              if (stack.length < 10 || stack.length < 50 && !ts3.contains(stack, identity_1)) {
                stack.push(identity_1);
                result2 = computeBaseConstraint(getSimplifiedType(t, false));
                stack.pop();
              }
              if (!popTypeResolution()) {
                if (t.flags & 262144) {
                  var errorNode = getConstraintDeclaration(t);
                  if (errorNode) {
                    var diagnostic = error(errorNode, ts3.Diagnostics.Type_parameter_0_has_a_circular_constraint, typeToString(t));
                    if (currentNode && !ts3.isNodeDescendantOf(errorNode, currentNode) && !ts3.isNodeDescendantOf(currentNode, errorNode)) {
                      ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(currentNode, ts3.Diagnostics.Circularity_originates_in_type_at_this_location));
                    }
                  }
                }
                result2 = circularConstraintType;
              }
              t.immediateBaseConstraint = result2 || noConstraintType;
            }
            return t.immediateBaseConstraint;
          }
          function getBaseConstraint(t) {
            var c = getImmediateBaseConstraint(t);
            return c !== noConstraintType && c !== circularConstraintType ? c : void 0;
          }
          function computeBaseConstraint(t) {
            if (t.flags & 262144) {
              var constraint = getConstraintFromTypeParameter(t);
              return t.isThisType || !constraint ? constraint : getBaseConstraint(constraint);
            }
            if (t.flags & 3145728) {
              var types2 = t.types;
              var baseTypes = [];
              var different = false;
              for (var _i = 0, types_7 = types2; _i < types_7.length; _i++) {
                var type_4 = types_7[_i];
                var baseType = getBaseConstraint(type_4);
                if (baseType) {
                  if (baseType !== type_4) {
                    different = true;
                  }
                  baseTypes.push(baseType);
                } else {
                  different = true;
                }
              }
              if (!different) {
                return t;
              }
              return t.flags & 1048576 && baseTypes.length === types2.length ? getUnionType(baseTypes) : t.flags & 2097152 && baseTypes.length ? getIntersectionType(baseTypes) : void 0;
            }
            if (t.flags & 4194304) {
              return keyofConstraintType;
            }
            if (t.flags & 134217728) {
              var types2 = t.types;
              var constraints = ts3.mapDefined(types2, getBaseConstraint);
              return constraints.length === types2.length ? getTemplateLiteralType(t.texts, constraints) : stringType;
            }
            if (t.flags & 268435456) {
              var constraint = getBaseConstraint(t.type);
              return constraint ? getStringMappingType(t.symbol, constraint) : stringType;
            }
            if (t.flags & 8388608) {
              if (isMappedTypeGenericIndexedAccess(t)) {
                return getBaseConstraint(substituteIndexedMappedType(t.objectType, t.indexType));
              }
              var baseObjectType = getBaseConstraint(t.objectType);
              var baseIndexType = getBaseConstraint(t.indexType);
              var baseIndexedAccess = baseObjectType && baseIndexType && getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, t.accessFlags);
              return baseIndexedAccess && getBaseConstraint(baseIndexedAccess);
            }
            if (t.flags & 16777216) {
              var constraint = getConstraintFromConditionalType(t);
              return constraint && getBaseConstraint(constraint);
            }
            if (t.flags & 33554432) {
              return getBaseConstraint(t.substitute);
            }
            return t;
          }
        }
        function getApparentTypeOfIntersectionType(type2) {
          return type2.resolvedApparentType || (type2.resolvedApparentType = getTypeWithThisArgument(type2, type2, true));
        }
        function getResolvedTypeParameterDefault(typeParameter) {
          if (!typeParameter.default) {
            if (typeParameter.target) {
              var targetDefault = getResolvedTypeParameterDefault(typeParameter.target);
              typeParameter.default = targetDefault ? instantiateType(targetDefault, typeParameter.mapper) : noConstraintType;
            } else {
              typeParameter.default = resolvingDefaultType;
              var defaultDeclaration = typeParameter.symbol && ts3.forEach(typeParameter.symbol.declarations, function(decl) {
                return ts3.isTypeParameterDeclaration(decl) && decl.default;
              });
              var defaultType = defaultDeclaration ? getTypeFromTypeNode(defaultDeclaration) : noConstraintType;
              if (typeParameter.default === resolvingDefaultType) {
                typeParameter.default = defaultType;
              }
            }
          } else if (typeParameter.default === resolvingDefaultType) {
            typeParameter.default = circularConstraintType;
          }
          return typeParameter.default;
        }
        function getDefaultFromTypeParameter(typeParameter) {
          var defaultType = getResolvedTypeParameterDefault(typeParameter);
          return defaultType !== noConstraintType && defaultType !== circularConstraintType ? defaultType : void 0;
        }
        function hasNonCircularTypeParameterDefault(typeParameter) {
          return getResolvedTypeParameterDefault(typeParameter) !== circularConstraintType;
        }
        function hasTypeParameterDefault(typeParameter) {
          return !!(typeParameter.symbol && ts3.forEach(typeParameter.symbol.declarations, function(decl) {
            return ts3.isTypeParameterDeclaration(decl) && decl.default;
          }));
        }
        function getApparentTypeOfMappedType(type2) {
          return type2.resolvedApparentType || (type2.resolvedApparentType = getResolvedApparentTypeOfMappedType(type2));
        }
        function getResolvedApparentTypeOfMappedType(type2) {
          var typeVariable = getHomomorphicTypeVariable(type2);
          if (typeVariable && !type2.declaration.nameType) {
            var constraint = getConstraintOfTypeParameter(typeVariable);
            if (constraint && isArrayOrTupleType(constraint)) {
              return instantiateType(type2, prependTypeMapping(typeVariable, constraint, type2.mapper));
            }
          }
          return type2;
        }
        function isMappedTypeGenericIndexedAccess(type2) {
          var objectType;
          return !!(type2.flags & 8388608 && ts3.getObjectFlags(objectType = type2.objectType) & 32 && !isGenericMappedType(objectType) && isGenericIndexType(type2.indexType) && !(getMappedTypeModifiers(objectType) & 8) && !objectType.declaration.nameType);
        }
        function getApparentType(type2) {
          var t = !(type2.flags & 465829888) ? type2 : getBaseConstraintOfType(type2) || unknownType;
          return ts3.getObjectFlags(t) & 32 ? getApparentTypeOfMappedType(t) : t.flags & 2097152 ? getApparentTypeOfIntersectionType(t) : t.flags & 402653316 ? globalStringType : t.flags & 296 ? globalNumberType : t.flags & 2112 ? getGlobalBigIntType() : t.flags & 528 ? globalBooleanType : t.flags & 12288 ? getGlobalESSymbolType() : t.flags & 67108864 ? emptyObjectType : t.flags & 4194304 ? keyofConstraintType : t.flags & 2 && !strictNullChecks ? emptyObjectType : t;
        }
        function getReducedApparentType(type2) {
          return getReducedType(getApparentType(getReducedType(type2)));
        }
        function createUnionOrIntersectionProperty(containingType, name, skipObjectFunctionPropertyAugment) {
          var _a, _b;
          var singleProp;
          var propSet;
          var indexTypes;
          var isUnion = containingType.flags & 1048576;
          var optionalFlag = isUnion ? 0 : 16777216;
          var syntheticFlag = 4;
          var checkFlags = isUnion ? 0 : 8;
          var mergedInstantiations = false;
          for (var _i = 0, _c = containingType.types; _i < _c.length; _i++) {
            var current = _c[_i];
            var type2 = getApparentType(current);
            if (!(isErrorType(type2) || type2.flags & 131072)) {
              var prop = getPropertyOfType(type2, name, skipObjectFunctionPropertyAugment);
              var modifiers = prop ? ts3.getDeclarationModifierFlagsFromSymbol(prop) : 0;
              if (prop) {
                if (isUnion) {
                  optionalFlag |= prop.flags & 16777216;
                } else {
                  optionalFlag &= prop.flags;
                }
                if (!singleProp) {
                  singleProp = prop;
                } else if (prop !== singleProp) {
                  var isInstantiation = (getTargetSymbol(prop) || prop) === (getTargetSymbol(singleProp) || singleProp);
                  if (isInstantiation && compareProperties(singleProp, prop, function(a, b) {
                    return a === b ? -1 : 0;
                  }) === -1) {
                    mergedInstantiations = !!singleProp.parent && !!ts3.length(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(singleProp.parent));
                  } else {
                    if (!propSet) {
                      propSet = new ts3.Map();
                      propSet.set(getSymbolId(singleProp), singleProp);
                    }
                    var id = getSymbolId(prop);
                    if (!propSet.has(id)) {
                      propSet.set(id, prop);
                    }
                  }
                }
                if (isUnion && isReadonlySymbol(prop)) {
                  checkFlags |= 8;
                } else if (!isUnion && !isReadonlySymbol(prop)) {
                  checkFlags &= ~8;
                }
                checkFlags |= (!(modifiers & 24) ? 256 : 0) | (modifiers & 16 ? 512 : 0) | (modifiers & 8 ? 1024 : 0) | (modifiers & 32 ? 2048 : 0);
                if (!isPrototypeProperty(prop)) {
                  syntheticFlag = 2;
                }
              } else if (isUnion) {
                var indexInfo = !isLateBoundName(name) && getApplicableIndexInfoForName(type2, name);
                if (indexInfo) {
                  checkFlags |= 32 | (indexInfo.isReadonly ? 8 : 0);
                  indexTypes = ts3.append(indexTypes, isTupleType(type2) ? getRestTypeOfTupleType(type2) || undefinedType : indexInfo.type);
                } else if (isObjectLiteralType(type2) && !(ts3.getObjectFlags(type2) & 2097152)) {
                  checkFlags |= 32;
                  indexTypes = ts3.append(indexTypes, undefinedType);
                } else {
                  checkFlags |= 16;
                }
              }
            }
          }
          if (!singleProp || isUnion && (propSet || checkFlags & 48) && checkFlags & (1024 | 512)) {
            return void 0;
          }
          if (!propSet && !(checkFlags & 16) && !indexTypes) {
            if (mergedInstantiations) {
              var clone_1 = createSymbolWithType(singleProp, singleProp.type);
              clone_1.parent = (_b = (_a = singleProp.valueDeclaration) === null || _a === void 0 ? void 0 : _a.symbol) === null || _b === void 0 ? void 0 : _b.parent;
              clone_1.containingType = containingType;
              clone_1.mapper = singleProp.mapper;
              return clone_1;
            } else {
              return singleProp;
            }
          }
          var props = propSet ? ts3.arrayFrom(propSet.values()) : [singleProp];
          var declarations;
          var firstType;
          var nameType;
          var propTypes = [];
          var writeTypes;
          var firstValueDeclaration;
          var hasNonUniformValueDeclaration = false;
          for (var _d = 0, props_1 = props; _d < props_1.length; _d++) {
            var prop = props_1[_d];
            if (!firstValueDeclaration) {
              firstValueDeclaration = prop.valueDeclaration;
            } else if (prop.valueDeclaration && prop.valueDeclaration !== firstValueDeclaration) {
              hasNonUniformValueDeclaration = true;
            }
            declarations = ts3.addRange(declarations, prop.declarations);
            var type2 = getTypeOfSymbol(prop);
            if (!firstType) {
              firstType = type2;
              nameType = getSymbolLinks(prop).nameType;
            }
            var writeType = getWriteTypeOfSymbol(prop);
            if (writeTypes || writeType !== type2) {
              writeTypes = ts3.append(!writeTypes ? propTypes.slice() : writeTypes, writeType);
            } else if (type2 !== firstType) {
              checkFlags |= 64;
            }
            if (isLiteralType(type2) || isPatternLiteralType(type2) || type2 === uniqueLiteralType) {
              checkFlags |= 128;
            }
            if (type2.flags & 131072 && type2 !== uniqueLiteralType) {
              checkFlags |= 131072;
            }
            propTypes.push(type2);
          }
          ts3.addRange(propTypes, indexTypes);
          var result2 = createSymbol(4 | optionalFlag, name, syntheticFlag | checkFlags);
          result2.containingType = containingType;
          if (!hasNonUniformValueDeclaration && firstValueDeclaration) {
            result2.valueDeclaration = firstValueDeclaration;
            if (firstValueDeclaration.symbol.parent) {
              result2.parent = firstValueDeclaration.symbol.parent;
            }
          }
          result2.declarations = declarations;
          result2.nameType = nameType;
          if (propTypes.length > 2) {
            result2.checkFlags |= 65536;
            result2.deferralParent = containingType;
            result2.deferralConstituents = propTypes;
            result2.deferralWriteConstituents = writeTypes;
          } else {
            result2.type = isUnion ? getUnionType(propTypes) : getIntersectionType(propTypes);
            if (writeTypes) {
              result2.writeType = isUnion ? getUnionType(writeTypes) : getIntersectionType(writeTypes);
            }
          }
          return result2;
        }
        function getUnionOrIntersectionProperty(type2, name, skipObjectFunctionPropertyAugment) {
          var _a, _b;
          var property = ((_a = type2.propertyCacheWithoutObjectFunctionPropertyAugment) === null || _a === void 0 ? void 0 : _a.get(name)) || !skipObjectFunctionPropertyAugment ? (_b = type2.propertyCache) === null || _b === void 0 ? void 0 : _b.get(name) : void 0;
          if (!property) {
            property = createUnionOrIntersectionProperty(type2, name, skipObjectFunctionPropertyAugment);
            if (property) {
              var properties = skipObjectFunctionPropertyAugment ? type2.propertyCacheWithoutObjectFunctionPropertyAugment || (type2.propertyCacheWithoutObjectFunctionPropertyAugment = ts3.createSymbolTable()) : type2.propertyCache || (type2.propertyCache = ts3.createSymbolTable());
              properties.set(name, property);
            }
          }
          return property;
        }
        function getPropertyOfUnionOrIntersectionType(type2, name, skipObjectFunctionPropertyAugment) {
          var property = getUnionOrIntersectionProperty(type2, name, skipObjectFunctionPropertyAugment);
          return property && !(ts3.getCheckFlags(property) & 16) ? property : void 0;
        }
        function getReducedType(type2) {
          if (type2.flags & 1048576 && type2.objectFlags & 16777216) {
            return type2.resolvedReducedType || (type2.resolvedReducedType = getReducedUnionType(type2));
          } else if (type2.flags & 2097152) {
            if (!(type2.objectFlags & 16777216)) {
              type2.objectFlags |= 16777216 | (ts3.some(getPropertiesOfUnionOrIntersectionType(type2), isNeverReducedProperty) ? 33554432 : 0);
            }
            return type2.objectFlags & 33554432 ? neverType : type2;
          }
          return type2;
        }
        function getReducedUnionType(unionType) {
          var reducedTypes = ts3.sameMap(unionType.types, getReducedType);
          if (reducedTypes === unionType.types) {
            return unionType;
          }
          var reduced = getUnionType(reducedTypes);
          if (reduced.flags & 1048576) {
            reduced.resolvedReducedType = reduced;
          }
          return reduced;
        }
        function isNeverReducedProperty(prop) {
          return isDiscriminantWithNeverType(prop) || isConflictingPrivateProperty(prop);
        }
        function isDiscriminantWithNeverType(prop) {
          return !(prop.flags & 16777216) && (ts3.getCheckFlags(prop) & (192 | 131072)) === 192 && !!(getTypeOfSymbol(prop).flags & 131072);
        }
        function isConflictingPrivateProperty(prop) {
          return !prop.valueDeclaration && !!(ts3.getCheckFlags(prop) & 1024);
        }
        function elaborateNeverIntersection(errorInfo, type2) {
          if (type2.flags & 2097152 && ts3.getObjectFlags(type2) & 33554432) {
            var neverProp = ts3.find(getPropertiesOfUnionOrIntersectionType(type2), isDiscriminantWithNeverType);
            if (neverProp) {
              return ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents, typeToString(type2, void 0, 536870912), symbolToString(neverProp));
            }
            var privateProp = ts3.find(getPropertiesOfUnionOrIntersectionType(type2), isConflictingPrivateProperty);
            if (privateProp) {
              return ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some, typeToString(type2, void 0, 536870912), symbolToString(privateProp));
            }
          }
          return errorInfo;
        }
        function getPropertyOfType(type2, name, skipObjectFunctionPropertyAugment) {
          type2 = getReducedApparentType(type2);
          if (type2.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type2);
            var symbol = resolved.members.get(name);
            if (symbol && symbolIsValue(symbol)) {
              return symbol;
            }
            if (skipObjectFunctionPropertyAugment)
              return void 0;
            var functionType = resolved === anyFunctionType ? globalFunctionType : resolved.callSignatures.length ? globalCallableFunctionType : resolved.constructSignatures.length ? globalNewableFunctionType : void 0;
            if (functionType) {
              var symbol_1 = getPropertyOfObjectType(functionType, name);
              if (symbol_1) {
                return symbol_1;
              }
            }
            return getPropertyOfObjectType(globalObjectType, name);
          }
          if (type2.flags & 3145728) {
            return getPropertyOfUnionOrIntersectionType(type2, name, skipObjectFunctionPropertyAugment);
          }
          return void 0;
        }
        function getSignaturesOfStructuredType(type2, kind) {
          if (type2.flags & 3670016) {
            var resolved = resolveStructuredTypeMembers(type2);
            return kind === 0 ? resolved.callSignatures : resolved.constructSignatures;
          }
          return ts3.emptyArray;
        }
        function getSignaturesOfType(type2, kind) {
          return getSignaturesOfStructuredType(getReducedApparentType(type2), kind);
        }
        function findIndexInfo(indexInfos, keyType) {
          return ts3.find(indexInfos, function(info) {
            return info.keyType === keyType;
          });
        }
        function findApplicableIndexInfo(indexInfos, keyType) {
          var stringIndexInfo;
          var applicableInfo;
          var applicableInfos;
          for (var _i = 0, indexInfos_3 = indexInfos; _i < indexInfos_3.length; _i++) {
            var info = indexInfos_3[_i];
            if (info.keyType === stringType) {
              stringIndexInfo = info;
            } else if (isApplicableIndexType(keyType, info.keyType)) {
              if (!applicableInfo) {
                applicableInfo = info;
              } else {
                (applicableInfos || (applicableInfos = [applicableInfo])).push(info);
              }
            }
          }
          return applicableInfos ? createIndexInfo(unknownType, getIntersectionType(ts3.map(applicableInfos, function(info2) {
            return info2.type;
          })), ts3.reduceLeft(applicableInfos, function(isReadonly, info2) {
            return isReadonly && info2.isReadonly;
          }, true)) : applicableInfo ? applicableInfo : stringIndexInfo && isApplicableIndexType(keyType, stringType) ? stringIndexInfo : void 0;
        }
        function isApplicableIndexType(source, target) {
          return isTypeAssignableTo(source, target) || target === stringType && isTypeAssignableTo(source, numberType) || target === numberType && (source === numericStringType || !!(source.flags & 128) && ts3.isNumericLiteralName(source.value));
        }
        function getIndexInfosOfStructuredType(type2) {
          if (type2.flags & 3670016) {
            var resolved = resolveStructuredTypeMembers(type2);
            return resolved.indexInfos;
          }
          return ts3.emptyArray;
        }
        function getIndexInfosOfType(type2) {
          return getIndexInfosOfStructuredType(getReducedApparentType(type2));
        }
        function getIndexInfoOfType(type2, keyType) {
          return findIndexInfo(getIndexInfosOfType(type2), keyType);
        }
        function getIndexTypeOfType(type2, keyType) {
          var _a;
          return (_a = getIndexInfoOfType(type2, keyType)) === null || _a === void 0 ? void 0 : _a.type;
        }
        function getApplicableIndexInfos(type2, keyType) {
          return getIndexInfosOfType(type2).filter(function(info) {
            return isApplicableIndexType(keyType, info.keyType);
          });
        }
        function getApplicableIndexInfo(type2, keyType) {
          return findApplicableIndexInfo(getIndexInfosOfType(type2), keyType);
        }
        function getApplicableIndexInfoForName(type2, name) {
          return getApplicableIndexInfo(type2, isLateBoundName(name) ? esSymbolType : getStringLiteralType(ts3.unescapeLeadingUnderscores(name)));
        }
        function getTypeParametersFromDeclaration(declaration) {
          var result2;
          for (var _i = 0, _a = ts3.getEffectiveTypeParameterDeclarations(declaration); _i < _a.length; _i++) {
            var node = _a[_i];
            result2 = ts3.appendIfUnique(result2, getDeclaredTypeOfTypeParameter(node.symbol));
          }
          return result2;
        }
        function symbolsToArray(symbols) {
          var result2 = [];
          symbols.forEach(function(symbol, id) {
            if (!isReservedMemberName(id)) {
              result2.push(symbol);
            }
          });
          return result2;
        }
        function isJSDocOptionalParameter(node) {
          return ts3.isInJSFile(node) && (node.type && node.type.kind === 316 || ts3.getJSDocParameterTags(node).some(function(_a) {
            var isBracketed = _a.isBracketed, typeExpression = _a.typeExpression;
            return isBracketed || !!typeExpression && typeExpression.type.kind === 316;
          }));
        }
        function tryFindAmbientModule(moduleName, withAugmentations) {
          if (ts3.isExternalModuleNameRelative(moduleName)) {
            return void 0;
          }
          var symbol = getSymbol(globals, '"' + moduleName + '"', 512);
          return symbol && withAugmentations ? getMergedSymbol(symbol) : symbol;
        }
        function isOptionalParameter(node) {
          if (ts3.hasQuestionToken(node) || isOptionalJSDocPropertyLikeTag(node) || isJSDocOptionalParameter(node)) {
            return true;
          }
          if (node.initializer) {
            var signature = getSignatureFromDeclaration(node.parent);
            var parameterIndex = node.parent.parameters.indexOf(node);
            ts3.Debug.assert(parameterIndex >= 0);
            return parameterIndex >= getMinArgumentCount(signature, 1 | 2);
          }
          var iife = ts3.getImmediatelyInvokedFunctionExpression(node.parent);
          if (iife) {
            return !node.type && !node.dotDotDotToken && node.parent.parameters.indexOf(node) >= iife.arguments.length;
          }
          return false;
        }
        function isOptionalPropertyDeclaration(node) {
          return ts3.isPropertyDeclaration(node) && node.questionToken;
        }
        function isOptionalJSDocPropertyLikeTag(node) {
          if (!ts3.isJSDocPropertyLikeTag(node)) {
            return false;
          }
          var isBracketed = node.isBracketed, typeExpression = node.typeExpression;
          return isBracketed || !!typeExpression && typeExpression.type.kind === 316;
        }
        function createTypePredicate(kind, parameterName, parameterIndex, type2) {
          return { kind, parameterName, parameterIndex, type: type2 };
        }
        function getMinTypeArgumentCount(typeParameters) {
          var minTypeArgumentCount = 0;
          if (typeParameters) {
            for (var i = 0; i < typeParameters.length; i++) {
              if (!hasTypeParameterDefault(typeParameters[i])) {
                minTypeArgumentCount = i + 1;
              }
            }
          }
          return minTypeArgumentCount;
        }
        function fillMissingTypeArguments(typeArguments, typeParameters, minTypeArgumentCount, isJavaScriptImplicitAny) {
          var numTypeParameters = ts3.length(typeParameters);
          if (!numTypeParameters) {
            return [];
          }
          var numTypeArguments = ts3.length(typeArguments);
          if (isJavaScriptImplicitAny || numTypeArguments >= minTypeArgumentCount && numTypeArguments <= numTypeParameters) {
            var result2 = typeArguments ? typeArguments.slice() : [];
            for (var i = numTypeArguments; i < numTypeParameters; i++) {
              result2[i] = errorType;
            }
            var baseDefaultType = getDefaultTypeArgumentType(isJavaScriptImplicitAny);
            for (var i = numTypeArguments; i < numTypeParameters; i++) {
              var defaultType = getDefaultFromTypeParameter(typeParameters[i]);
              if (isJavaScriptImplicitAny && defaultType && (isTypeIdenticalTo(defaultType, unknownType) || isTypeIdenticalTo(defaultType, emptyObjectType))) {
                defaultType = anyType;
              }
              result2[i] = defaultType ? instantiateType(defaultType, createTypeMapper(typeParameters, result2)) : baseDefaultType;
            }
            result2.length = typeParameters.length;
            return result2;
          }
          return typeArguments && typeArguments.slice();
        }
        function getSignatureFromDeclaration(declaration) {
          var links = getNodeLinks(declaration);
          if (!links.resolvedSignature) {
            var parameters = [];
            var flags = 0;
            var minArgumentCount = 0;
            var thisParameter = void 0;
            var hasThisParameter = false;
            var iife = ts3.getImmediatelyInvokedFunctionExpression(declaration);
            var isJSConstructSignature = ts3.isJSDocConstructSignature(declaration);
            var isUntypedSignatureInJSFile = !iife && ts3.isInJSFile(declaration) && ts3.isValueSignatureDeclaration(declaration) && !ts3.hasJSDocParameterTags(declaration) && !ts3.getJSDocType(declaration);
            if (isUntypedSignatureInJSFile) {
              flags |= 32;
            }
            for (var i = isJSConstructSignature ? 1 : 0; i < declaration.parameters.length; i++) {
              var param = declaration.parameters[i];
              var paramSymbol = param.symbol;
              var type2 = ts3.isJSDocParameterTag(param) ? param.typeExpression && param.typeExpression.type : param.type;
              if (paramSymbol && !!(paramSymbol.flags & 4) && !ts3.isBindingPattern(param.name)) {
                var resolvedSymbol = resolveName(param, paramSymbol.escapedName, 111551, void 0, void 0, false);
                paramSymbol = resolvedSymbol;
              }
              if (i === 0 && paramSymbol.escapedName === "this") {
                hasThisParameter = true;
                thisParameter = param.symbol;
              } else {
                parameters.push(paramSymbol);
              }
              if (type2 && type2.kind === 196) {
                flags |= 2;
              }
              var isOptionalParameter_1 = isOptionalJSDocPropertyLikeTag(param) || param.initializer || param.questionToken || ts3.isRestParameter(param) || iife && parameters.length > iife.arguments.length && !type2 || isJSDocOptionalParameter(param);
              if (!isOptionalParameter_1) {
                minArgumentCount = parameters.length;
              }
            }
            if ((declaration.kind === 172 || declaration.kind === 173) && hasBindableName(declaration) && (!hasThisParameter || !thisParameter)) {
              var otherKind = declaration.kind === 172 ? 173 : 172;
              var other = ts3.getDeclarationOfKind(getSymbolOfNode(declaration), otherKind);
              if (other) {
                thisParameter = getAnnotatedAccessorThisParameter(other);
              }
            }
            var classType = declaration.kind === 171 ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol)) : void 0;
            var typeParameters = classType ? classType.localTypeParameters : getTypeParametersFromDeclaration(declaration);
            if (ts3.hasRestParameter(declaration) || ts3.isInJSFile(declaration) && maybeAddJsSyntheticRestParameter(declaration, parameters)) {
              flags |= 1;
            }
            if (ts3.isConstructorTypeNode(declaration) && ts3.hasSyntacticModifier(declaration, 128) || ts3.isConstructorDeclaration(declaration) && ts3.hasSyntacticModifier(declaration.parent, 128)) {
              flags |= 4;
            }
            links.resolvedSignature = createSignature(declaration, typeParameters, thisParameter, parameters, void 0, void 0, minArgumentCount, flags);
          }
          return links.resolvedSignature;
        }
        function maybeAddJsSyntheticRestParameter(declaration, parameters) {
          if (ts3.isJSDocSignature(declaration) || !containsArgumentsReference(declaration)) {
            return false;
          }
          var lastParam = ts3.lastOrUndefined(declaration.parameters);
          var lastParamTags = lastParam ? ts3.getJSDocParameterTags(lastParam) : ts3.getJSDocTags(declaration).filter(ts3.isJSDocParameterTag);
          var lastParamVariadicType = ts3.firstDefined(lastParamTags, function(p) {
            return p.typeExpression && ts3.isJSDocVariadicType(p.typeExpression.type) ? p.typeExpression.type : void 0;
          });
          var syntheticArgsSymbol = createSymbol(3, "args", 32768);
          if (lastParamVariadicType) {
            syntheticArgsSymbol.type = createArrayType(getTypeFromTypeNode(lastParamVariadicType.type));
          } else {
            syntheticArgsSymbol.checkFlags |= 65536;
            syntheticArgsSymbol.deferralParent = neverType;
            syntheticArgsSymbol.deferralConstituents = [anyArrayType];
            syntheticArgsSymbol.deferralWriteConstituents = [anyArrayType];
          }
          if (lastParamVariadicType) {
            parameters.pop();
          }
          parameters.push(syntheticArgsSymbol);
          return true;
        }
        function getSignatureOfTypeTag(node) {
          if (!(ts3.isInJSFile(node) && ts3.isFunctionLikeDeclaration(node)))
            return void 0;
          var typeTag = ts3.getJSDocTypeTag(node);
          return (typeTag === null || typeTag === void 0 ? void 0 : typeTag.typeExpression) && getSingleCallSignature(getTypeFromTypeNode(typeTag.typeExpression));
        }
        function getParameterTypeOfTypeTag(func, parameter) {
          var signature = getSignatureOfTypeTag(func);
          if (!signature)
            return void 0;
          var pos = func.parameters.indexOf(parameter);
          return parameter.dotDotDotToken ? getRestTypeAtPosition(signature, pos) : getTypeAtPosition(signature, pos);
        }
        function getReturnTypeOfTypeTag(node) {
          var signature = getSignatureOfTypeTag(node);
          return signature && getReturnTypeOfSignature(signature);
        }
        function containsArgumentsReference(declaration) {
          var links = getNodeLinks(declaration);
          if (links.containsArgumentsReference === void 0) {
            if (links.flags & 8192) {
              links.containsArgumentsReference = true;
            } else {
              links.containsArgumentsReference = traverse(declaration.body);
            }
          }
          return links.containsArgumentsReference;
          function traverse(node) {
            if (!node)
              return false;
            switch (node.kind) {
              case 79:
                return node.escapedText === argumentsSymbol.escapedName && getReferencedValueSymbol(node) === argumentsSymbol;
              case 167:
              case 169:
              case 172:
              case 173:
                return node.name.kind === 162 && traverse(node.name);
              case 206:
              case 207:
                return traverse(node.expression);
              case 296:
                return traverse(node.initializer);
              default:
                return !ts3.nodeStartsNewLexicalEnvironment(node) && !ts3.isPartOfTypeNode(node) && !!ts3.forEachChild(node, traverse);
            }
          }
        }
        function getSignaturesOfSymbol(symbol) {
          if (!symbol || !symbol.declarations)
            return ts3.emptyArray;
          var result2 = [];
          for (var i = 0; i < symbol.declarations.length; i++) {
            var decl = symbol.declarations[i];
            if (!ts3.isFunctionLike(decl))
              continue;
            if (i > 0 && decl.body) {
              var previous = symbol.declarations[i - 1];
              if (decl.parent === previous.parent && decl.kind === previous.kind && decl.pos === previous.end) {
                continue;
              }
            }
            result2.push(getSignatureFromDeclaration(decl));
          }
          return result2;
        }
        function resolveExternalModuleTypeByLiteral(name) {
          var moduleSym = resolveExternalModuleName(name, name);
          if (moduleSym) {
            var resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
            if (resolvedModuleSymbol) {
              return getTypeOfSymbol(resolvedModuleSymbol);
            }
          }
          return anyType;
        }
        function getThisTypeOfSignature(signature) {
          if (signature.thisParameter) {
            return getTypeOfSymbol(signature.thisParameter);
          }
        }
        function getTypePredicateOfSignature(signature) {
          if (!signature.resolvedTypePredicate) {
            if (signature.target) {
              var targetTypePredicate = getTypePredicateOfSignature(signature.target);
              signature.resolvedTypePredicate = targetTypePredicate ? instantiateTypePredicate(targetTypePredicate, signature.mapper) : noTypePredicate;
            } else if (signature.compositeSignatures) {
              signature.resolvedTypePredicate = getUnionOrIntersectionTypePredicate(signature.compositeSignatures, signature.compositeKind) || noTypePredicate;
            } else {
              var type2 = signature.declaration && ts3.getEffectiveReturnTypeNode(signature.declaration);
              var jsdocPredicate = void 0;
              if (!type2 && ts3.isInJSFile(signature.declaration)) {
                var jsdocSignature = getSignatureOfTypeTag(signature.declaration);
                if (jsdocSignature && signature !== jsdocSignature) {
                  jsdocPredicate = getTypePredicateOfSignature(jsdocSignature);
                }
              }
              signature.resolvedTypePredicate = type2 && ts3.isTypePredicateNode(type2) ? createTypePredicateFromTypePredicateNode(type2, signature) : jsdocPredicate || noTypePredicate;
            }
            ts3.Debug.assert(!!signature.resolvedTypePredicate);
          }
          return signature.resolvedTypePredicate === noTypePredicate ? void 0 : signature.resolvedTypePredicate;
        }
        function createTypePredicateFromTypePredicateNode(node, signature) {
          var parameterName = node.parameterName;
          var type2 = node.type && getTypeFromTypeNode(node.type);
          return parameterName.kind === 192 ? createTypePredicate(node.assertsModifier ? 2 : 0, void 0, void 0, type2) : createTypePredicate(node.assertsModifier ? 3 : 1, parameterName.escapedText, ts3.findIndex(signature.parameters, function(p) {
            return p.escapedName === parameterName.escapedText;
          }), type2);
        }
        function getUnionOrIntersectionType(types2, kind, unionReduction) {
          return kind !== 2097152 ? getUnionType(types2, unionReduction) : getIntersectionType(types2);
        }
        function getReturnTypeOfSignature(signature) {
          if (!signature.resolvedReturnType) {
            if (!pushTypeResolution(signature, 3)) {
              return errorType;
            }
            var type2 = signature.target ? instantiateType(getReturnTypeOfSignature(signature.target), signature.mapper) : signature.compositeSignatures ? instantiateType(getUnionOrIntersectionType(ts3.map(signature.compositeSignatures, getReturnTypeOfSignature), signature.compositeKind, 2), signature.mapper) : getReturnTypeFromAnnotation(signature.declaration) || (ts3.nodeIsMissing(signature.declaration.body) ? anyType : getReturnTypeFromBody(signature.declaration));
            if (signature.flags & 8) {
              type2 = addOptionalTypeMarker(type2);
            } else if (signature.flags & 16) {
              type2 = getOptionalType(type2);
            }
            if (!popTypeResolution()) {
              if (signature.declaration) {
                var typeNode = ts3.getEffectiveReturnTypeNode(signature.declaration);
                if (typeNode) {
                  error(typeNode, ts3.Diagnostics.Return_type_annotation_circularly_references_itself);
                } else if (noImplicitAny) {
                  var declaration = signature.declaration;
                  var name = ts3.getNameOfDeclaration(declaration);
                  if (name) {
                    error(name, ts3.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, ts3.declarationNameToString(name));
                  } else {
                    error(declaration, ts3.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions);
                  }
                }
              }
              type2 = anyType;
            }
            signature.resolvedReturnType = type2;
          }
          return signature.resolvedReturnType;
        }
        function getReturnTypeFromAnnotation(declaration) {
          if (declaration.kind === 171) {
            return getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol));
          }
          if (ts3.isJSDocConstructSignature(declaration)) {
            return getTypeFromTypeNode(declaration.parameters[0].type);
          }
          var typeNode = ts3.getEffectiveReturnTypeNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
          if (declaration.kind === 172 && hasBindableName(declaration)) {
            var jsDocType = ts3.isInJSFile(declaration) && getTypeForDeclarationFromJSDocComment(declaration);
            if (jsDocType) {
              return jsDocType;
            }
            var setter = ts3.getDeclarationOfKind(getSymbolOfNode(declaration), 173);
            var setterType = getAnnotatedAccessorType(setter);
            if (setterType) {
              return setterType;
            }
          }
          return getReturnTypeOfTypeTag(declaration);
        }
        function isResolvingReturnTypeOfSignature(signature) {
          return !signature.resolvedReturnType && findResolutionCycleStartIndex(signature, 3) >= 0;
        }
        function getRestTypeOfSignature(signature) {
          return tryGetRestTypeOfSignature(signature) || anyType;
        }
        function tryGetRestTypeOfSignature(signature) {
          if (signatureHasRestParameter(signature)) {
            var sigRestType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            var restType = isTupleType(sigRestType) ? getRestTypeOfTupleType(sigRestType) : sigRestType;
            return restType && getIndexTypeOfType(restType, numberType);
          }
          return void 0;
        }
        function getSignatureInstantiation(signature, typeArguments, isJavascript, inferredTypeParameters) {
          var instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, fillMissingTypeArguments(typeArguments, signature.typeParameters, getMinTypeArgumentCount(signature.typeParameters), isJavascript));
          if (inferredTypeParameters) {
            var returnSignature = getSingleCallOrConstructSignature(getReturnTypeOfSignature(instantiatedSignature));
            if (returnSignature) {
              var newReturnSignature = cloneSignature(returnSignature);
              newReturnSignature.typeParameters = inferredTypeParameters;
              var newInstantiatedSignature = cloneSignature(instantiatedSignature);
              newInstantiatedSignature.resolvedReturnType = getOrCreateTypeFromSignature(newReturnSignature);
              return newInstantiatedSignature;
            }
          }
          return instantiatedSignature;
        }
        function getSignatureInstantiationWithoutFillingInTypeArguments(signature, typeArguments) {
          var instantiations = signature.instantiations || (signature.instantiations = new ts3.Map());
          var id = getTypeListId(typeArguments);
          var instantiation = instantiations.get(id);
          if (!instantiation) {
            instantiations.set(id, instantiation = createSignatureInstantiation(signature, typeArguments));
          }
          return instantiation;
        }
        function createSignatureInstantiation(signature, typeArguments) {
          return instantiateSignature(signature, createSignatureTypeMapper(signature, typeArguments), true);
        }
        function createSignatureTypeMapper(signature, typeArguments) {
          return createTypeMapper(signature.typeParameters, typeArguments);
        }
        function getErasedSignature(signature) {
          return signature.typeParameters ? signature.erasedSignatureCache || (signature.erasedSignatureCache = createErasedSignature(signature)) : signature;
        }
        function createErasedSignature(signature) {
          return instantiateSignature(signature, createTypeEraser(signature.typeParameters), true);
        }
        function getCanonicalSignature(signature) {
          return signature.typeParameters ? signature.canonicalSignatureCache || (signature.canonicalSignatureCache = createCanonicalSignature(signature)) : signature;
        }
        function createCanonicalSignature(signature) {
          return getSignatureInstantiation(signature, ts3.map(signature.typeParameters, function(tp) {
            return tp.target && !getConstraintOfTypeParameter(tp.target) ? tp.target : tp;
          }), ts3.isInJSFile(signature.declaration));
        }
        function getBaseSignature(signature) {
          var typeParameters = signature.typeParameters;
          if (typeParameters) {
            if (signature.baseSignatureCache) {
              return signature.baseSignatureCache;
            }
            var typeEraser = createTypeEraser(typeParameters);
            var baseConstraintMapper_1 = createTypeMapper(typeParameters, ts3.map(typeParameters, function(tp) {
              return getConstraintOfTypeParameter(tp) || unknownType;
            }));
            var baseConstraints = ts3.map(typeParameters, function(tp) {
              return instantiateType(tp, baseConstraintMapper_1) || unknownType;
            });
            for (var i = 0; i < typeParameters.length - 1; i++) {
              baseConstraints = instantiateTypes(baseConstraints, baseConstraintMapper_1);
            }
            baseConstraints = instantiateTypes(baseConstraints, typeEraser);
            return signature.baseSignatureCache = instantiateSignature(signature, createTypeMapper(typeParameters, baseConstraints), true);
          }
          return signature;
        }
        function getOrCreateTypeFromSignature(signature) {
          var _a;
          if (!signature.isolatedSignatureType) {
            var kind = (_a = signature.declaration) === null || _a === void 0 ? void 0 : _a.kind;
            var isConstructor = kind === void 0 || kind === 171 || kind === 175 || kind === 180;
            var type2 = createObjectType(16);
            type2.members = emptySymbols;
            type2.properties = ts3.emptyArray;
            type2.callSignatures = !isConstructor ? [signature] : ts3.emptyArray;
            type2.constructSignatures = isConstructor ? [signature] : ts3.emptyArray;
            type2.indexInfos = ts3.emptyArray;
            signature.isolatedSignatureType = type2;
          }
          return signature.isolatedSignatureType;
        }
        function getIndexSymbol(symbol) {
          return symbol.members ? getIndexSymbolFromSymbolTable(symbol.members) : void 0;
        }
        function getIndexSymbolFromSymbolTable(symbolTable) {
          return symbolTable.get("__index");
        }
        function createIndexInfo(keyType, type2, isReadonly, declaration) {
          return { keyType, type: type2, isReadonly, declaration };
        }
        function getIndexInfosOfSymbol(symbol) {
          var indexSymbol = getIndexSymbol(symbol);
          return indexSymbol ? getIndexInfosOfIndexSymbol(indexSymbol) : ts3.emptyArray;
        }
        function getIndexInfosOfIndexSymbol(indexSymbol) {
          if (indexSymbol.declarations) {
            var indexInfos_4 = [];
            var _loop_14 = function(declaration2) {
              if (declaration2.parameters.length === 1) {
                var parameter = declaration2.parameters[0];
                if (parameter.type) {
                  forEachType(getTypeFromTypeNode(parameter.type), function(keyType) {
                    if (isValidIndexKeyType(keyType) && !findIndexInfo(indexInfos_4, keyType)) {
                      indexInfos_4.push(createIndexInfo(keyType, declaration2.type ? getTypeFromTypeNode(declaration2.type) : anyType, ts3.hasEffectiveModifier(declaration2, 64), declaration2));
                    }
                  });
                }
              }
            };
            for (var _i = 0, _a = indexSymbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              _loop_14(declaration);
            }
            return indexInfos_4;
          }
          return ts3.emptyArray;
        }
        function isValidIndexKeyType(type2) {
          return !!(type2.flags & (4 | 8 | 4096)) || isPatternLiteralType(type2) || !!(type2.flags & 2097152) && !isGenericType(type2) && ts3.some(type2.types, isValidIndexKeyType);
        }
        function getConstraintDeclaration(type2) {
          return ts3.mapDefined(ts3.filter(type2.symbol && type2.symbol.declarations, ts3.isTypeParameterDeclaration), ts3.getEffectiveConstraintOfTypeParameter)[0];
        }
        function getInferredTypeParameterConstraint(typeParameter, omitTypeReferences) {
          var _a;
          var inferences;
          if ((_a = typeParameter.symbol) === null || _a === void 0 ? void 0 : _a.declarations) {
            for (var _i = 0, _b = typeParameter.symbol.declarations; _i < _b.length; _i++) {
              var declaration = _b[_i];
              if (declaration.parent.kind === 190) {
                var _c = ts3.walkUpParenthesizedTypesAndGetParentAndChild(declaration.parent.parent), _d = _c[0], childTypeParameter = _d === void 0 ? declaration.parent : _d, grandParent = _c[1];
                if (grandParent.kind === 178 && !omitTypeReferences) {
                  var typeReference = grandParent;
                  var typeParameters = getTypeParametersForTypeReference(typeReference);
                  if (typeParameters) {
                    var index = typeReference.typeArguments.indexOf(childTypeParameter);
                    if (index < typeParameters.length) {
                      var declaredConstraint = getConstraintOfTypeParameter(typeParameters[index]);
                      if (declaredConstraint) {
                        var mapper = createTypeMapper(typeParameters, getEffectiveTypeArguments(typeReference, typeParameters));
                        var constraint = instantiateType(declaredConstraint, mapper);
                        if (constraint !== typeParameter) {
                          inferences = ts3.append(inferences, constraint);
                        }
                      }
                    }
                  }
                } else if (grandParent.kind === 164 && grandParent.dotDotDotToken || grandParent.kind === 186 || grandParent.kind === 197 && grandParent.dotDotDotToken) {
                  inferences = ts3.append(inferences, createArrayType(unknownType));
                } else if (grandParent.kind === 199) {
                  inferences = ts3.append(inferences, stringType);
                } else if (grandParent.kind === 163 && grandParent.parent.kind === 195) {
                  inferences = ts3.append(inferences, keyofConstraintType);
                } else if (grandParent.kind === 195 && grandParent.type && ts3.skipParentheses(grandParent.type) === declaration.parent && grandParent.parent.kind === 189 && grandParent.parent.extendsType === grandParent && grandParent.parent.checkType.kind === 195 && grandParent.parent.checkType.type) {
                  var checkMappedType_1 = grandParent.parent.checkType;
                  var nodeType = getTypeFromTypeNode(checkMappedType_1.type);
                  inferences = ts3.append(inferences, instantiateType(nodeType, makeUnaryTypeMapper(getDeclaredTypeOfTypeParameter(getSymbolOfNode(checkMappedType_1.typeParameter)), checkMappedType_1.typeParameter.constraint ? getTypeFromTypeNode(checkMappedType_1.typeParameter.constraint) : keyofConstraintType)));
                }
              }
            }
          }
          return inferences && getIntersectionType(inferences);
        }
        function getConstraintFromTypeParameter(typeParameter) {
          if (!typeParameter.constraint) {
            if (typeParameter.target) {
              var targetConstraint = getConstraintOfTypeParameter(typeParameter.target);
              typeParameter.constraint = targetConstraint ? instantiateType(targetConstraint, typeParameter.mapper) : noConstraintType;
            } else {
              var constraintDeclaration = getConstraintDeclaration(typeParameter);
              if (!constraintDeclaration) {
                typeParameter.constraint = getInferredTypeParameterConstraint(typeParameter) || noConstraintType;
              } else {
                var type2 = getTypeFromTypeNode(constraintDeclaration);
                if (type2.flags & 1 && !isErrorType(type2)) {
                  type2 = constraintDeclaration.parent.parent.kind === 195 ? keyofConstraintType : unknownType;
                }
                typeParameter.constraint = type2;
              }
            }
          }
          return typeParameter.constraint === noConstraintType ? void 0 : typeParameter.constraint;
        }
        function getParentSymbolOfTypeParameter(typeParameter) {
          var tp = ts3.getDeclarationOfKind(typeParameter.symbol, 163);
          var host2 = ts3.isJSDocTemplateTag(tp.parent) ? ts3.getEffectiveContainerForJSDocTemplateTag(tp.parent) : tp.parent;
          return host2 && getSymbolOfNode(host2);
        }
        function getTypeListId(types2) {
          var result2 = "";
          if (types2) {
            var length_4 = types2.length;
            var i = 0;
            while (i < length_4) {
              var startId = types2[i].id;
              var count = 1;
              while (i + count < length_4 && types2[i + count].id === startId + count) {
                count++;
              }
              if (result2.length) {
                result2 += ",";
              }
              result2 += startId;
              if (count > 1) {
                result2 += ":" + count;
              }
              i += count;
            }
          }
          return result2;
        }
        function getAliasId(aliasSymbol, aliasTypeArguments) {
          return aliasSymbol ? "@".concat(getSymbolId(aliasSymbol)) + (aliasTypeArguments ? ":".concat(getTypeListId(aliasTypeArguments)) : "") : "";
        }
        function getPropagatingFlagsOfTypes(types2, excludeKinds) {
          var result2 = 0;
          for (var _i = 0, types_8 = types2; _i < types_8.length; _i++) {
            var type2 = types_8[_i];
            if (!(type2.flags & excludeKinds)) {
              result2 |= ts3.getObjectFlags(type2);
            }
          }
          return result2 & 458752;
        }
        function createTypeReference(target, typeArguments) {
          var id = getTypeListId(typeArguments);
          var type2 = target.instantiations.get(id);
          if (!type2) {
            type2 = createObjectType(4, target.symbol);
            target.instantiations.set(id, type2);
            type2.objectFlags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, 0) : 0;
            type2.target = target;
            type2.resolvedTypeArguments = typeArguments;
          }
          return type2;
        }
        function cloneTypeReference(source) {
          var type2 = createType(source.flags);
          type2.symbol = source.symbol;
          type2.objectFlags = source.objectFlags;
          type2.target = source.target;
          type2.resolvedTypeArguments = source.resolvedTypeArguments;
          return type2;
        }
        function createDeferredTypeReference(target, node, mapper, aliasSymbol, aliasTypeArguments) {
          if (!aliasSymbol) {
            aliasSymbol = getAliasSymbolForTypeNode(node);
            var localAliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
            aliasTypeArguments = mapper ? instantiateTypes(localAliasTypeArguments, mapper) : localAliasTypeArguments;
          }
          var type2 = createObjectType(4, target.symbol);
          type2.target = target;
          type2.node = node;
          type2.mapper = mapper;
          type2.aliasSymbol = aliasSymbol;
          type2.aliasTypeArguments = aliasTypeArguments;
          return type2;
        }
        function getTypeArguments(type2) {
          var _a, _b;
          if (!type2.resolvedTypeArguments) {
            if (!pushTypeResolution(type2, 6)) {
              return ((_a = type2.target.localTypeParameters) === null || _a === void 0 ? void 0 : _a.map(function() {
                return errorType;
              })) || ts3.emptyArray;
            }
            var node = type2.node;
            var typeArguments = !node ? ts3.emptyArray : node.kind === 178 ? ts3.concatenate(type2.target.outerTypeParameters, getEffectiveTypeArguments(node, type2.target.localTypeParameters)) : node.kind === 183 ? [getTypeFromTypeNode(node.elementType)] : ts3.map(node.elements, getTypeFromTypeNode);
            if (popTypeResolution()) {
              type2.resolvedTypeArguments = type2.mapper ? instantiateTypes(typeArguments, type2.mapper) : typeArguments;
            } else {
              type2.resolvedTypeArguments = ((_b = type2.target.localTypeParameters) === null || _b === void 0 ? void 0 : _b.map(function() {
                return errorType;
              })) || ts3.emptyArray;
              error(type2.node || currentNode, type2.target.symbol ? ts3.Diagnostics.Type_arguments_for_0_circularly_reference_themselves : ts3.Diagnostics.Tuple_type_arguments_circularly_reference_themselves, type2.target.symbol && symbolToString(type2.target.symbol));
            }
          }
          return type2.resolvedTypeArguments;
        }
        function getTypeReferenceArity(type2) {
          return ts3.length(type2.target.typeParameters);
        }
        function getTypeFromClassOrInterfaceReference(node, symbol) {
          var type2 = getDeclaredTypeOfSymbol(getMergedSymbol(symbol));
          var typeParameters = type2.localTypeParameters;
          if (typeParameters) {
            var numTypeArguments = ts3.length(node.typeArguments);
            var minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
            var isJs = ts3.isInJSFile(node);
            var isJsImplicitAny = !noImplicitAny && isJs;
            if (!isJsImplicitAny && (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length)) {
              var missingAugmentsTag = isJs && ts3.isExpressionWithTypeArguments(node) && !ts3.isJSDocAugmentsTag(node.parent);
              var diag = minTypeArgumentCount === typeParameters.length ? missingAugmentsTag ? ts3.Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag : ts3.Diagnostics.Generic_type_0_requires_1_type_argument_s : missingAugmentsTag ? ts3.Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag : ts3.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments;
              var typeStr = typeToString(type2, void 0, 2);
              error(node, diag, typeStr, minTypeArgumentCount, typeParameters.length);
              if (!isJs) {
                return errorType;
              }
            }
            if (node.kind === 178 && isDeferredTypeReferenceNode(node, ts3.length(node.typeArguments) !== typeParameters.length)) {
              return createDeferredTypeReference(type2, node, void 0);
            }
            var typeArguments = ts3.concatenate(type2.outerTypeParameters, fillMissingTypeArguments(typeArgumentsFromTypeReferenceNode(node), typeParameters, minTypeArgumentCount, isJs));
            return createTypeReference(type2, typeArguments);
          }
          return checkNoTypeArguments(node, symbol) ? type2 : errorType;
        }
        function getTypeAliasInstantiation(symbol, typeArguments, aliasSymbol, aliasTypeArguments) {
          var type2 = getDeclaredTypeOfSymbol(symbol);
          if (type2 === intrinsicMarkerType && intrinsicTypeKinds.has(symbol.escapedName) && typeArguments && typeArguments.length === 1) {
            return getStringMappingType(symbol, typeArguments[0]);
          }
          var links = getSymbolLinks(symbol);
          var typeParameters = links.typeParameters;
          var id = getTypeListId(typeArguments) + getAliasId(aliasSymbol, aliasTypeArguments);
          var instantiation = links.instantiations.get(id);
          if (!instantiation) {
            links.instantiations.set(id, instantiation = instantiateTypeWithAlias(type2, createTypeMapper(typeParameters, fillMissingTypeArguments(typeArguments, typeParameters, getMinTypeArgumentCount(typeParameters), ts3.isInJSFile(symbol.valueDeclaration))), aliasSymbol, aliasTypeArguments));
          }
          return instantiation;
        }
        function getTypeFromTypeAliasReference(node, symbol) {
          if (ts3.getCheckFlags(symbol) & 1048576) {
            var typeArguments = typeArgumentsFromTypeReferenceNode(node);
            var id = getAliasId(symbol, typeArguments);
            var errorType_1 = errorTypes.get(id);
            if (!errorType_1) {
              errorType_1 = createIntrinsicType(1, "error");
              errorType_1.aliasSymbol = symbol;
              errorType_1.aliasTypeArguments = typeArguments;
              errorTypes.set(id, errorType_1);
            }
            return errorType_1;
          }
          var type2 = getDeclaredTypeOfSymbol(symbol);
          var typeParameters = getSymbolLinks(symbol).typeParameters;
          if (typeParameters) {
            var numTypeArguments = ts3.length(node.typeArguments);
            var minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
            if (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length) {
              error(node, minTypeArgumentCount === typeParameters.length ? ts3.Diagnostics.Generic_type_0_requires_1_type_argument_s : ts3.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, symbolToString(symbol), minTypeArgumentCount, typeParameters.length);
              return errorType;
            }
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            var newAliasSymbol = aliasSymbol && (isLocalTypeAlias(symbol) || !isLocalTypeAlias(aliasSymbol)) ? aliasSymbol : void 0;
            return getTypeAliasInstantiation(symbol, typeArgumentsFromTypeReferenceNode(node), newAliasSymbol, getTypeArgumentsForAliasSymbol(newAliasSymbol));
          }
          return checkNoTypeArguments(node, symbol) ? type2 : errorType;
        }
        function isLocalTypeAlias(symbol) {
          var _a;
          var declaration = (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isTypeAlias);
          return !!(declaration && ts3.getContainingFunction(declaration));
        }
        function getTypeReferenceName(node) {
          switch (node.kind) {
            case 178:
              return node.typeName;
            case 228:
              var expr = node.expression;
              if (ts3.isEntityNameExpression(expr)) {
                return expr;
              }
          }
          return void 0;
        }
        function getSymbolPath(symbol) {
          return symbol.parent ? "".concat(getSymbolPath(symbol.parent), ".").concat(symbol.escapedName) : symbol.escapedName;
        }
        function getUnresolvedSymbolForEntityName(name) {
          var identifier = name.kind === 161 ? name.right : name.kind === 206 ? name.name : name;
          var text = identifier.escapedText;
          if (text) {
            var parentSymbol = name.kind === 161 ? getUnresolvedSymbolForEntityName(name.left) : name.kind === 206 ? getUnresolvedSymbolForEntityName(name.expression) : void 0;
            var path2 = parentSymbol ? "".concat(getSymbolPath(parentSymbol), ".").concat(text) : text;
            var result2 = unresolvedSymbols.get(path2);
            if (!result2) {
              unresolvedSymbols.set(path2, result2 = createSymbol(524288, text, 1048576));
              result2.parent = parentSymbol;
              result2.declaredType = unresolvedType;
            }
            return result2;
          }
          return unknownSymbol;
        }
        function resolveTypeReferenceName(typeReference, meaning, ignoreErrors) {
          var name = getTypeReferenceName(typeReference);
          if (!name) {
            return unknownSymbol;
          }
          var symbol = resolveEntityName(name, meaning, ignoreErrors);
          return symbol && symbol !== unknownSymbol ? symbol : ignoreErrors ? unknownSymbol : getUnresolvedSymbolForEntityName(name);
        }
        function getTypeReferenceType(node, symbol) {
          if (symbol === unknownSymbol) {
            return errorType;
          }
          symbol = getExpandoSymbol(symbol) || symbol;
          if (symbol.flags & (32 | 64)) {
            return getTypeFromClassOrInterfaceReference(node, symbol);
          }
          if (symbol.flags & 524288) {
            return getTypeFromTypeAliasReference(node, symbol);
          }
          var res = tryGetDeclaredTypeOfSymbol(symbol);
          if (res) {
            return checkNoTypeArguments(node, symbol) ? getRegularTypeOfLiteralType(res) : errorType;
          }
          if (symbol.flags & 111551 && isJSDocTypeReference(node)) {
            var jsdocType = getTypeFromJSDocValueReference(node, symbol);
            if (jsdocType) {
              return jsdocType;
            } else {
              resolveTypeReferenceName(node, 788968);
              return getTypeOfSymbol(symbol);
            }
          }
          return errorType;
        }
        function getTypeFromJSDocValueReference(node, symbol) {
          var links = getNodeLinks(node);
          if (!links.resolvedJSDocType) {
            var valueType = getTypeOfSymbol(symbol);
            var typeType = valueType;
            if (symbol.valueDeclaration) {
              var isImportTypeWithQualifier = node.kind === 200 && node.qualifier;
              if (valueType.symbol && valueType.symbol !== symbol && isImportTypeWithQualifier) {
                typeType = getTypeReferenceType(node, valueType.symbol);
              }
            }
            links.resolvedJSDocType = typeType;
          }
          return links.resolvedJSDocType;
        }
        function getSubstitutionType(baseType, substitute) {
          if (substitute.flags & 3 || substitute === baseType) {
            return baseType;
          }
          var id = "".concat(getTypeId(baseType), ">").concat(getTypeId(substitute));
          var cached = substitutionTypes.get(id);
          if (cached) {
            return cached;
          }
          var result2 = createType(33554432);
          result2.baseType = baseType;
          result2.substitute = substitute;
          substitutionTypes.set(id, result2);
          return result2;
        }
        function isUnaryTupleTypeNode(node) {
          return node.kind === 184 && node.elements.length === 1;
        }
        function getImpliedConstraint(type2, checkNode, extendsNode) {
          return isUnaryTupleTypeNode(checkNode) && isUnaryTupleTypeNode(extendsNode) ? getImpliedConstraint(type2, checkNode.elements[0], extendsNode.elements[0]) : getActualTypeVariable(getTypeFromTypeNode(checkNode)) === getActualTypeVariable(type2) ? getTypeFromTypeNode(extendsNode) : void 0;
        }
        function getConditionalFlowTypeOfType(type2, node) {
          var constraints;
          var covariant = true;
          while (node && !ts3.isStatement(node) && node.kind !== 320) {
            var parent = node.parent;
            if (parent.kind === 164) {
              covariant = !covariant;
            }
            if ((covariant || type2.flags & 8650752) && parent.kind === 189 && node === parent.trueType) {
              var constraint = getImpliedConstraint(type2, parent.checkType, parent.extendsType);
              if (constraint) {
                constraints = ts3.append(constraints, constraint);
              }
            } else if (type2.flags & 262144 && parent.kind === 195 && node === parent.type) {
              var mappedType = getTypeFromTypeNode(parent);
              if (getTypeParameterFromMappedType(mappedType) === getActualTypeVariable(type2)) {
                var typeParameter = getHomomorphicTypeVariable(mappedType);
                if (typeParameter) {
                  var constraint = getConstraintOfTypeParameter(typeParameter);
                  if (constraint && everyType(constraint, isArrayOrTupleType)) {
                    constraints = ts3.append(constraints, getUnionType([numberType, numericStringType]));
                  }
                }
              }
            }
            node = parent;
          }
          return constraints ? getSubstitutionType(type2, getIntersectionType(ts3.append(constraints, type2))) : type2;
        }
        function isJSDocTypeReference(node) {
          return !!(node.flags & 8388608) && (node.kind === 178 || node.kind === 200);
        }
        function checkNoTypeArguments(node, symbol) {
          if (node.typeArguments) {
            error(node, ts3.Diagnostics.Type_0_is_not_generic, symbol ? symbolToString(symbol) : node.typeName ? ts3.declarationNameToString(node.typeName) : anon);
            return false;
          }
          return true;
        }
        function getIntendedTypeFromJSDocTypeReference(node) {
          if (ts3.isIdentifier(node.typeName)) {
            var typeArgs = node.typeArguments;
            switch (node.typeName.escapedText) {
              case "String":
                checkNoTypeArguments(node);
                return stringType;
              case "Number":
                checkNoTypeArguments(node);
                return numberType;
              case "Boolean":
                checkNoTypeArguments(node);
                return booleanType;
              case "Void":
                checkNoTypeArguments(node);
                return voidType;
              case "Undefined":
                checkNoTypeArguments(node);
                return undefinedType;
              case "Null":
                checkNoTypeArguments(node);
                return nullType;
              case "Function":
              case "function":
                checkNoTypeArguments(node);
                return globalFunctionType;
              case "array":
                return (!typeArgs || !typeArgs.length) && !noImplicitAny ? anyArrayType : void 0;
              case "promise":
                return (!typeArgs || !typeArgs.length) && !noImplicitAny ? createPromiseType(anyType) : void 0;
              case "Object":
                if (typeArgs && typeArgs.length === 2) {
                  if (ts3.isJSDocIndexSignature(node)) {
                    var indexed = getTypeFromTypeNode(typeArgs[0]);
                    var target = getTypeFromTypeNode(typeArgs[1]);
                    var indexInfo = indexed === stringType || indexed === numberType ? [createIndexInfo(indexed, target, false)] : ts3.emptyArray;
                    return createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, indexInfo);
                  }
                  return anyType;
                }
                checkNoTypeArguments(node);
                return !noImplicitAny ? anyType : void 0;
            }
          }
        }
        function getTypeFromJSDocNullableTypeNode(node) {
          var type2 = getTypeFromTypeNode(node.type);
          return strictNullChecks ? getNullableType(type2, 65536) : type2;
        }
        function getTypeFromTypeReference(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (ts3.isConstTypeReference(node) && ts3.isAssertionExpression(node.parent)) {
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = checkExpressionCached(node.parent.expression);
            }
            var symbol = void 0;
            var type2 = void 0;
            var meaning = 788968;
            if (isJSDocTypeReference(node)) {
              type2 = getIntendedTypeFromJSDocTypeReference(node);
              if (!type2) {
                symbol = resolveTypeReferenceName(node, meaning, true);
                if (symbol === unknownSymbol) {
                  symbol = resolveTypeReferenceName(node, meaning | 111551);
                } else {
                  resolveTypeReferenceName(node, meaning);
                }
                type2 = getTypeReferenceType(node, symbol);
              }
            }
            if (!type2) {
              symbol = resolveTypeReferenceName(node, meaning);
              type2 = getTypeReferenceType(node, symbol);
            }
            links.resolvedSymbol = symbol;
            links.resolvedType = type2;
          }
          return links.resolvedType;
        }
        function typeArgumentsFromTypeReferenceNode(node) {
          return ts3.map(node.typeArguments, getTypeFromTypeNode);
        }
        function getTypeFromTypeQueryNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var type2 = checkExpressionWithTypeArguments(node);
            links.resolvedType = getRegularTypeOfLiteralType(getWidenedType(type2));
          }
          return links.resolvedType;
        }
        function getTypeOfGlobalSymbol(symbol, arity) {
          function getTypeDeclaration(symbol2) {
            var declarations = symbol2.declarations;
            if (declarations) {
              for (var _i = 0, declarations_3 = declarations; _i < declarations_3.length; _i++) {
                var declaration = declarations_3[_i];
                switch (declaration.kind) {
                  case 257:
                  case 258:
                  case 260:
                    return declaration;
                }
              }
            }
          }
          if (!symbol) {
            return arity ? emptyGenericType : emptyObjectType;
          }
          var type2 = getDeclaredTypeOfSymbol(symbol);
          if (!(type2.flags & 524288)) {
            error(getTypeDeclaration(symbol), ts3.Diagnostics.Global_type_0_must_be_a_class_or_interface_type, ts3.symbolName(symbol));
            return arity ? emptyGenericType : emptyObjectType;
          }
          if (ts3.length(type2.typeParameters) !== arity) {
            error(getTypeDeclaration(symbol), ts3.Diagnostics.Global_type_0_must_have_1_type_parameter_s, ts3.symbolName(symbol), arity);
            return arity ? emptyGenericType : emptyObjectType;
          }
          return type2;
        }
        function getGlobalValueSymbol(name, reportErrors) {
          return getGlobalSymbol(name, 111551, reportErrors ? ts3.Diagnostics.Cannot_find_global_value_0 : void 0);
        }
        function getGlobalTypeSymbol(name, reportErrors) {
          return getGlobalSymbol(name, 788968, reportErrors ? ts3.Diagnostics.Cannot_find_global_type_0 : void 0);
        }
        function getGlobalTypeAliasSymbol(name, arity, reportErrors) {
          var symbol = getGlobalSymbol(name, 788968, reportErrors ? ts3.Diagnostics.Cannot_find_global_type_0 : void 0);
          if (symbol) {
            getDeclaredTypeOfSymbol(symbol);
            if (ts3.length(getSymbolLinks(symbol).typeParameters) !== arity) {
              var decl = symbol.declarations && ts3.find(symbol.declarations, ts3.isTypeAliasDeclaration);
              error(decl, ts3.Diagnostics.Global_type_0_must_have_1_type_parameter_s, ts3.symbolName(symbol), arity);
              return void 0;
            }
          }
          return symbol;
        }
        function getGlobalSymbol(name, meaning, diagnostic) {
          return resolveName(void 0, name, meaning, diagnostic, name, false, false, false);
        }
        function getGlobalType(name, arity, reportErrors) {
          var symbol = getGlobalTypeSymbol(name, reportErrors);
          return symbol || reportErrors ? getTypeOfGlobalSymbol(symbol, arity) : void 0;
        }
        function getGlobalTypedPropertyDescriptorType() {
          return deferredGlobalTypedPropertyDescriptorType || (deferredGlobalTypedPropertyDescriptorType = getGlobalType("TypedPropertyDescriptor", 1, true) || emptyGenericType);
        }
        function getGlobalTemplateStringsArrayType() {
          return deferredGlobalTemplateStringsArrayType || (deferredGlobalTemplateStringsArrayType = getGlobalType("TemplateStringsArray", 0, true) || emptyObjectType);
        }
        function getGlobalImportMetaType() {
          return deferredGlobalImportMetaType || (deferredGlobalImportMetaType = getGlobalType("ImportMeta", 0, true) || emptyObjectType);
        }
        function getGlobalImportMetaExpressionType() {
          if (!deferredGlobalImportMetaExpressionType) {
            var symbol = createSymbol(0, "ImportMetaExpression");
            var importMetaType = getGlobalImportMetaType();
            var metaPropertySymbol = createSymbol(4, "meta", 8);
            metaPropertySymbol.parent = symbol;
            metaPropertySymbol.type = importMetaType;
            var members = ts3.createSymbolTable([metaPropertySymbol]);
            symbol.members = members;
            deferredGlobalImportMetaExpressionType = createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
          }
          return deferredGlobalImportMetaExpressionType;
        }
        function getGlobalImportCallOptionsType(reportErrors) {
          return deferredGlobalImportCallOptionsType || (deferredGlobalImportCallOptionsType = getGlobalType("ImportCallOptions", 0, reportErrors)) || emptyObjectType;
        }
        function getGlobalESSymbolConstructorSymbol(reportErrors) {
          return deferredGlobalESSymbolConstructorSymbol || (deferredGlobalESSymbolConstructorSymbol = getGlobalValueSymbol("Symbol", reportErrors));
        }
        function getGlobalESSymbolConstructorTypeSymbol(reportErrors) {
          return deferredGlobalESSymbolConstructorTypeSymbol || (deferredGlobalESSymbolConstructorTypeSymbol = getGlobalTypeSymbol("SymbolConstructor", reportErrors));
        }
        function getGlobalESSymbolType() {
          return deferredGlobalESSymbolType || (deferredGlobalESSymbolType = getGlobalType("Symbol", 0, false)) || emptyObjectType;
        }
        function getGlobalPromiseType(reportErrors) {
          return deferredGlobalPromiseType || (deferredGlobalPromiseType = getGlobalType("Promise", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalPromiseLikeType(reportErrors) {
          return deferredGlobalPromiseLikeType || (deferredGlobalPromiseLikeType = getGlobalType("PromiseLike", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalPromiseConstructorSymbol(reportErrors) {
          return deferredGlobalPromiseConstructorSymbol || (deferredGlobalPromiseConstructorSymbol = getGlobalValueSymbol("Promise", reportErrors));
        }
        function getGlobalPromiseConstructorLikeType(reportErrors) {
          return deferredGlobalPromiseConstructorLikeType || (deferredGlobalPromiseConstructorLikeType = getGlobalType("PromiseConstructorLike", 0, reportErrors)) || emptyObjectType;
        }
        function getGlobalAsyncIterableType(reportErrors) {
          return deferredGlobalAsyncIterableType || (deferredGlobalAsyncIterableType = getGlobalType("AsyncIterable", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncIteratorType(reportErrors) {
          return deferredGlobalAsyncIteratorType || (deferredGlobalAsyncIteratorType = getGlobalType("AsyncIterator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncIterableIteratorType(reportErrors) {
          return deferredGlobalAsyncIterableIteratorType || (deferredGlobalAsyncIterableIteratorType = getGlobalType("AsyncIterableIterator", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncGeneratorType(reportErrors) {
          return deferredGlobalAsyncGeneratorType || (deferredGlobalAsyncGeneratorType = getGlobalType("AsyncGenerator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIterableType(reportErrors) {
          return deferredGlobalIterableType || (deferredGlobalIterableType = getGlobalType("Iterable", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorType(reportErrors) {
          return deferredGlobalIteratorType || (deferredGlobalIteratorType = getGlobalType("Iterator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIterableIteratorType(reportErrors) {
          return deferredGlobalIterableIteratorType || (deferredGlobalIterableIteratorType = getGlobalType("IterableIterator", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalGeneratorType(reportErrors) {
          return deferredGlobalGeneratorType || (deferredGlobalGeneratorType = getGlobalType("Generator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorYieldResultType(reportErrors) {
          return deferredGlobalIteratorYieldResultType || (deferredGlobalIteratorYieldResultType = getGlobalType("IteratorYieldResult", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorReturnResultType(reportErrors) {
          return deferredGlobalIteratorReturnResultType || (deferredGlobalIteratorReturnResultType = getGlobalType("IteratorReturnResult", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalTypeOrUndefined(name, arity) {
          if (arity === void 0) {
            arity = 0;
          }
          var symbol = getGlobalSymbol(name, 788968, void 0);
          return symbol && getTypeOfGlobalSymbol(symbol, arity);
        }
        function getGlobalExtractSymbol() {
          deferredGlobalExtractSymbol || (deferredGlobalExtractSymbol = getGlobalTypeAliasSymbol("Extract", 2, true) || unknownSymbol);
          return deferredGlobalExtractSymbol === unknownSymbol ? void 0 : deferredGlobalExtractSymbol;
        }
        function getGlobalOmitSymbol() {
          deferredGlobalOmitSymbol || (deferredGlobalOmitSymbol = getGlobalTypeAliasSymbol("Omit", 2, true) || unknownSymbol);
          return deferredGlobalOmitSymbol === unknownSymbol ? void 0 : deferredGlobalOmitSymbol;
        }
        function getGlobalAwaitedSymbol(reportErrors) {
          deferredGlobalAwaitedSymbol || (deferredGlobalAwaitedSymbol = getGlobalTypeAliasSymbol("Awaited", 1, reportErrors) || (reportErrors ? unknownSymbol : void 0));
          return deferredGlobalAwaitedSymbol === unknownSymbol ? void 0 : deferredGlobalAwaitedSymbol;
        }
        function getGlobalBigIntType() {
          return deferredGlobalBigIntType || (deferredGlobalBigIntType = getGlobalType("BigInt", 0, false)) || emptyObjectType;
        }
        function createTypeFromGenericGlobalType(genericGlobalType, typeArguments) {
          return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
        function createTypedPropertyDescriptorType(propertyType) {
          return createTypeFromGenericGlobalType(getGlobalTypedPropertyDescriptorType(), [propertyType]);
        }
        function createIterableType(iteratedType) {
          return createTypeFromGenericGlobalType(getGlobalIterableType(true), [iteratedType]);
        }
        function createArrayType(elementType, readonly) {
          return createTypeFromGenericGlobalType(readonly ? globalReadonlyArrayType : globalArrayType, [elementType]);
        }
        function getTupleElementFlags(node) {
          switch (node.kind) {
            case 185:
              return 2;
            case 186:
              return getRestTypeElementFlags(node);
            case 197:
              return node.questionToken ? 2 : node.dotDotDotToken ? getRestTypeElementFlags(node) : 1;
            default:
              return 1;
          }
        }
        function getRestTypeElementFlags(node) {
          return getArrayElementTypeNode(node.type) ? 4 : 8;
        }
        function getArrayOrTupleTargetType(node) {
          var readonly = isReadonlyTypeOperator(node.parent);
          var elementType = getArrayElementTypeNode(node);
          if (elementType) {
            return readonly ? globalReadonlyArrayType : globalArrayType;
          }
          var elementFlags = ts3.map(node.elements, getTupleElementFlags);
          var missingName = ts3.some(node.elements, function(e) {
            return e.kind !== 197;
          });
          return getTupleTargetType(elementFlags, readonly, missingName ? void 0 : node.elements);
        }
        function isDeferredTypeReferenceNode(node, hasDefaultTypeArguments) {
          return !!getAliasSymbolForTypeNode(node) || isResolvedByTypeAlias(node) && (node.kind === 183 ? mayResolveTypeAlias(node.elementType) : node.kind === 184 ? ts3.some(node.elements, mayResolveTypeAlias) : hasDefaultTypeArguments || ts3.some(node.typeArguments, mayResolveTypeAlias));
        }
        function isResolvedByTypeAlias(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 191:
            case 197:
            case 178:
            case 187:
            case 188:
            case 194:
            case 189:
            case 193:
            case 183:
            case 184:
              return isResolvedByTypeAlias(parent);
            case 259:
              return true;
          }
          return false;
        }
        function mayResolveTypeAlias(node) {
          switch (node.kind) {
            case 178:
              return isJSDocTypeReference(node) || !!(resolveTypeReferenceName(node, 788968).flags & 524288);
            case 181:
              return true;
            case 193:
              return node.operator !== 154 && mayResolveTypeAlias(node.type);
            case 191:
            case 185:
            case 197:
            case 316:
            case 314:
            case 315:
            case 309:
              return mayResolveTypeAlias(node.type);
            case 186:
              return node.type.kind !== 183 || mayResolveTypeAlias(node.type.elementType);
            case 187:
            case 188:
              return ts3.some(node.types, mayResolveTypeAlias);
            case 194:
              return mayResolveTypeAlias(node.objectType) || mayResolveTypeAlias(node.indexType);
            case 189:
              return mayResolveTypeAlias(node.checkType) || mayResolveTypeAlias(node.extendsType) || mayResolveTypeAlias(node.trueType) || mayResolveTypeAlias(node.falseType);
          }
          return false;
        }
        function getTypeFromArrayOrTupleTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var target = getArrayOrTupleTargetType(node);
            if (target === emptyGenericType) {
              links.resolvedType = emptyObjectType;
            } else if (!(node.kind === 184 && ts3.some(node.elements, function(e) {
              return !!(getTupleElementFlags(e) & 8);
            })) && isDeferredTypeReferenceNode(node)) {
              links.resolvedType = node.kind === 184 && node.elements.length === 0 ? target : createDeferredTypeReference(target, node, void 0);
            } else {
              var elementTypes = node.kind === 183 ? [getTypeFromTypeNode(node.elementType)] : ts3.map(node.elements, getTypeFromTypeNode);
              links.resolvedType = createNormalizedTypeReference(target, elementTypes);
            }
          }
          return links.resolvedType;
        }
        function isReadonlyTypeOperator(node) {
          return ts3.isTypeOperatorNode(node) && node.operator === 145;
        }
        function createTupleType(elementTypes, elementFlags, readonly, namedMemberDeclarations) {
          if (readonly === void 0) {
            readonly = false;
          }
          var tupleTarget = getTupleTargetType(elementFlags || ts3.map(elementTypes, function(_) {
            return 1;
          }), readonly, namedMemberDeclarations);
          return tupleTarget === emptyGenericType ? emptyObjectType : elementTypes.length ? createNormalizedTypeReference(tupleTarget, elementTypes) : tupleTarget;
        }
        function getTupleTargetType(elementFlags, readonly, namedMemberDeclarations) {
          if (elementFlags.length === 1 && elementFlags[0] & 4) {
            return readonly ? globalReadonlyArrayType : globalArrayType;
          }
          var key = ts3.map(elementFlags, function(f) {
            return f & 1 ? "#" : f & 2 ? "?" : f & 4 ? "." : "*";
          }).join() + (readonly ? "R" : "") + (namedMemberDeclarations && namedMemberDeclarations.length ? "," + ts3.map(namedMemberDeclarations, getNodeId).join(",") : "");
          var type2 = tupleTypes.get(key);
          if (!type2) {
            tupleTypes.set(key, type2 = createTupleTargetType(elementFlags, readonly, namedMemberDeclarations));
          }
          return type2;
        }
        function createTupleTargetType(elementFlags, readonly, namedMemberDeclarations) {
          var arity = elementFlags.length;
          var minLength = ts3.countWhere(elementFlags, function(f) {
            return !!(f & (1 | 8));
          });
          var typeParameters;
          var properties = [];
          var combinedFlags = 0;
          if (arity) {
            typeParameters = new Array(arity);
            for (var i = 0; i < arity; i++) {
              var typeParameter = typeParameters[i] = createTypeParameter();
              var flags = elementFlags[i];
              combinedFlags |= flags;
              if (!(combinedFlags & 12)) {
                var property = createSymbol(4 | (flags & 2 ? 16777216 : 0), "" + i, readonly ? 8 : 0);
                property.tupleLabelDeclaration = namedMemberDeclarations === null || namedMemberDeclarations === void 0 ? void 0 : namedMemberDeclarations[i];
                property.type = typeParameter;
                properties.push(property);
              }
            }
          }
          var fixedLength = properties.length;
          var lengthSymbol = createSymbol(4, "length", readonly ? 8 : 0);
          if (combinedFlags & 12) {
            lengthSymbol.type = numberType;
          } else {
            var literalTypes = [];
            for (var i = minLength; i <= arity; i++)
              literalTypes.push(getNumberLiteralType(i));
            lengthSymbol.type = getUnionType(literalTypes);
          }
          properties.push(lengthSymbol);
          var type2 = createObjectType(8 | 4);
          type2.typeParameters = typeParameters;
          type2.outerTypeParameters = void 0;
          type2.localTypeParameters = typeParameters;
          type2.instantiations = new ts3.Map();
          type2.instantiations.set(getTypeListId(type2.typeParameters), type2);
          type2.target = type2;
          type2.resolvedTypeArguments = type2.typeParameters;
          type2.thisType = createTypeParameter();
          type2.thisType.isThisType = true;
          type2.thisType.constraint = type2;
          type2.declaredProperties = properties;
          type2.declaredCallSignatures = ts3.emptyArray;
          type2.declaredConstructSignatures = ts3.emptyArray;
          type2.declaredIndexInfos = ts3.emptyArray;
          type2.elementFlags = elementFlags;
          type2.minLength = minLength;
          type2.fixedLength = fixedLength;
          type2.hasRestElement = !!(combinedFlags & 12);
          type2.combinedFlags = combinedFlags;
          type2.readonly = readonly;
          type2.labeledElementDeclarations = namedMemberDeclarations;
          return type2;
        }
        function createNormalizedTypeReference(target, typeArguments) {
          return target.objectFlags & 8 ? createNormalizedTupleType(target, typeArguments) : createTypeReference(target, typeArguments);
        }
        function createNormalizedTupleType(target, elementTypes) {
          var _a, _b, _c;
          if (!(target.combinedFlags & 14)) {
            return createTypeReference(target, elementTypes);
          }
          if (target.combinedFlags & 8) {
            var unionIndex_1 = ts3.findIndex(elementTypes, function(t, i2) {
              return !!(target.elementFlags[i2] & 8 && t.flags & (131072 | 1048576));
            });
            if (unionIndex_1 >= 0) {
              return checkCrossProductUnion(ts3.map(elementTypes, function(t, i2) {
                return target.elementFlags[i2] & 8 ? t : unknownType;
              })) ? mapType(elementTypes[unionIndex_1], function(t) {
                return createNormalizedTupleType(target, ts3.replaceElement(elementTypes, unionIndex_1, t));
              }) : errorType;
            }
          }
          var expandedTypes = [];
          var expandedFlags = [];
          var expandedDeclarations = [];
          var lastRequiredIndex = -1;
          var firstRestIndex = -1;
          var lastOptionalOrRestIndex = -1;
          var _loop_15 = function(i2) {
            var type2 = elementTypes[i2];
            var flags = target.elementFlags[i2];
            if (flags & 8) {
              if (type2.flags & 58982400 || isGenericMappedType(type2)) {
                addElement(type2, 8, (_a = target.labeledElementDeclarations) === null || _a === void 0 ? void 0 : _a[i2]);
              } else if (isTupleType(type2)) {
                var elements = getTypeArguments(type2);
                if (elements.length + expandedTypes.length >= 1e4) {
                  error(currentNode, ts3.isPartOfTypeNode(currentNode) ? ts3.Diagnostics.Type_produces_a_tuple_type_that_is_too_large_to_represent : ts3.Diagnostics.Expression_produces_a_tuple_type_that_is_too_large_to_represent);
                  return { value: errorType };
                }
                ts3.forEach(elements, function(t, n) {
                  var _a2;
                  return addElement(t, type2.target.elementFlags[n], (_a2 = type2.target.labeledElementDeclarations) === null || _a2 === void 0 ? void 0 : _a2[n]);
                });
              } else {
                addElement(isArrayLikeType(type2) && getIndexTypeOfType(type2, numberType) || errorType, 4, (_b = target.labeledElementDeclarations) === null || _b === void 0 ? void 0 : _b[i2]);
              }
            } else {
              addElement(type2, flags, (_c = target.labeledElementDeclarations) === null || _c === void 0 ? void 0 : _c[i2]);
            }
          };
          for (var i = 0; i < elementTypes.length; i++) {
            var state_4 = _loop_15(i);
            if (typeof state_4 === "object")
              return state_4.value;
          }
          for (var i = 0; i < lastRequiredIndex; i++) {
            if (expandedFlags[i] & 2)
              expandedFlags[i] = 1;
          }
          if (firstRestIndex >= 0 && firstRestIndex < lastOptionalOrRestIndex) {
            expandedTypes[firstRestIndex] = getUnionType(ts3.sameMap(expandedTypes.slice(firstRestIndex, lastOptionalOrRestIndex + 1), function(t, i2) {
              return expandedFlags[firstRestIndex + i2] & 8 ? getIndexedAccessType(t, numberType) : t;
            }));
            expandedTypes.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
            expandedFlags.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
            expandedDeclarations === null || expandedDeclarations === void 0 ? void 0 : expandedDeclarations.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
          }
          var tupleTarget = getTupleTargetType(expandedFlags, target.readonly, expandedDeclarations);
          return tupleTarget === emptyGenericType ? emptyObjectType : expandedFlags.length ? createTypeReference(tupleTarget, expandedTypes) : tupleTarget;
          function addElement(type2, flags, declaration) {
            if (flags & 1) {
              lastRequiredIndex = expandedFlags.length;
            }
            if (flags & 4 && firstRestIndex < 0) {
              firstRestIndex = expandedFlags.length;
            }
            if (flags & (2 | 4)) {
              lastOptionalOrRestIndex = expandedFlags.length;
            }
            expandedTypes.push(type2);
            expandedFlags.push(flags);
            if (expandedDeclarations && declaration) {
              expandedDeclarations.push(declaration);
            } else {
              expandedDeclarations = void 0;
            }
          }
        }
        function sliceTupleType(type2, index, endSkipCount) {
          if (endSkipCount === void 0) {
            endSkipCount = 0;
          }
          var target = type2.target;
          var endIndex = getTypeReferenceArity(type2) - endSkipCount;
          return index > target.fixedLength ? getRestArrayTypeOfTupleType(type2) || createTupleType(ts3.emptyArray) : createTupleType(getTypeArguments(type2).slice(index, endIndex), target.elementFlags.slice(index, endIndex), false, target.labeledElementDeclarations && target.labeledElementDeclarations.slice(index, endIndex));
        }
        function getKnownKeysOfTupleType(type2) {
          return getUnionType(ts3.append(ts3.arrayOf(type2.target.fixedLength, function(i) {
            return getStringLiteralType("" + i);
          }), getIndexType(type2.target.readonly ? globalReadonlyArrayType : globalArrayType)));
        }
        function getStartElementCount(type2, flags) {
          var index = ts3.findIndex(type2.elementFlags, function(f) {
            return !(f & flags);
          });
          return index >= 0 ? index : type2.elementFlags.length;
        }
        function getEndElementCount(type2, flags) {
          return type2.elementFlags.length - ts3.findLastIndex(type2.elementFlags, function(f) {
            return !(f & flags);
          }) - 1;
        }
        function getTypeFromOptionalTypeNode(node) {
          return addOptionality(getTypeFromTypeNode(node.type), true);
        }
        function getTypeId(type2) {
          return type2.id;
        }
        function containsType(types2, type2) {
          return ts3.binarySearch(types2, type2, getTypeId, ts3.compareValues) >= 0;
        }
        function insertType(types2, type2) {
          var index = ts3.binarySearch(types2, type2, getTypeId, ts3.compareValues);
          if (index < 0) {
            types2.splice(~index, 0, type2);
            return true;
          }
          return false;
        }
        function addTypeToUnion(typeSet, includes, type2) {
          var flags = type2.flags;
          if (flags & 1048576) {
            return addTypesToUnion(typeSet, includes | (isNamedUnionType(type2) ? 1048576 : 0), type2.types);
          }
          if (!(flags & 131072)) {
            includes |= flags & 205258751;
            if (flags & 465829888)
              includes |= 33554432;
            if (type2 === wildcardType)
              includes |= 8388608;
            if (!strictNullChecks && flags & 98304) {
              if (!(ts3.getObjectFlags(type2) & 65536))
                includes |= 4194304;
            } else {
              var len = typeSet.length;
              var index = len && type2.id > typeSet[len - 1].id ? ~len : ts3.binarySearch(typeSet, type2, getTypeId, ts3.compareValues);
              if (index < 0) {
                typeSet.splice(~index, 0, type2);
              }
            }
          }
          return includes;
        }
        function addTypesToUnion(typeSet, includes, types2) {
          for (var _i = 0, types_9 = types2; _i < types_9.length; _i++) {
            var type2 = types_9[_i];
            includes = addTypeToUnion(typeSet, includes, type2);
          }
          return includes;
        }
        function removeSubtypes(types2, hasObjectTypes) {
          if (types2.length < 2) {
            return types2;
          }
          var id = getTypeListId(types2);
          var match = subtypeReductionCache.get(id);
          if (match) {
            return match;
          }
          var hasEmptyObject = hasObjectTypes && ts3.some(types2, function(t2) {
            return !!(t2.flags & 524288) && !isGenericMappedType(t2) && isEmptyResolvedType(resolveStructuredTypeMembers(t2));
          });
          var len = types2.length;
          var i = len;
          var count = 0;
          while (i > 0) {
            i--;
            var source = types2[i];
            if (hasEmptyObject || source.flags & 469499904) {
              var keyProperty = source.flags & (524288 | 2097152 | 58982400) ? ts3.find(getPropertiesOfType(source), function(p) {
                return isUnitType(getTypeOfSymbol(p));
              }) : void 0;
              var keyPropertyType = keyProperty && getRegularTypeOfLiteralType(getTypeOfSymbol(keyProperty));
              for (var _i = 0, types_10 = types2; _i < types_10.length; _i++) {
                var target = types_10[_i];
                if (source !== target) {
                  if (count === 1e5) {
                    var estimatedCount = count / (len - i) * len;
                    if (estimatedCount > 1e6) {
                      ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "removeSubtypes_DepthLimit", { typeIds: types2.map(function(t2) {
                        return t2.id;
                      }) });
                      error(currentNode, ts3.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
                      return void 0;
                    }
                  }
                  count++;
                  if (keyProperty && target.flags & (524288 | 2097152 | 58982400)) {
                    var t = getTypeOfPropertyOfType(target, keyProperty.escapedName);
                    if (t && isUnitType(t) && getRegularTypeOfLiteralType(t) !== keyPropertyType) {
                      continue;
                    }
                  }
                  if (isTypeRelatedTo(source, target, strictSubtypeRelation) && (!(ts3.getObjectFlags(getTargetType(source)) & 1) || !(ts3.getObjectFlags(getTargetType(target)) & 1) || isTypeDerivedFrom(source, target))) {
                    ts3.orderedRemoveItemAt(types2, i);
                    break;
                  }
                }
              }
            }
          }
          subtypeReductionCache.set(id, types2);
          return types2;
        }
        function removeRedundantLiteralTypes(types2, includes, reduceVoidUndefined) {
          var i = types2.length;
          while (i > 0) {
            i--;
            var t = types2[i];
            var flags = t.flags;
            var remove = flags & (128 | 134217728 | 268435456) && includes & 4 || flags & 256 && includes & 8 || flags & 2048 && includes & 64 || flags & 8192 && includes & 4096 || reduceVoidUndefined && flags & 32768 && includes & 16384 || isFreshLiteralType(t) && containsType(types2, t.regularType);
            if (remove) {
              ts3.orderedRemoveItemAt(types2, i);
            }
          }
        }
        function removeStringLiteralsMatchedByTemplateLiterals(types2) {
          var templates = ts3.filter(types2, isPatternLiteralType);
          if (templates.length) {
            var i = types2.length;
            var _loop_16 = function() {
              i--;
              var t = types2[i];
              if (t.flags & 128 && ts3.some(templates, function(template) {
                return isTypeMatchedByTemplateLiteralType(t, template);
              })) {
                ts3.orderedRemoveItemAt(types2, i);
              }
            };
            while (i > 0) {
              _loop_16();
            }
          }
        }
        function isNamedUnionType(type2) {
          return !!(type2.flags & 1048576 && (type2.aliasSymbol || type2.origin));
        }
        function addNamedUnions(namedUnions, types2) {
          for (var _i = 0, types_11 = types2; _i < types_11.length; _i++) {
            var t = types_11[_i];
            if (t.flags & 1048576) {
              var origin = t.origin;
              if (t.aliasSymbol || origin && !(origin.flags & 1048576)) {
                ts3.pushIfUnique(namedUnions, t);
              } else if (origin && origin.flags & 1048576) {
                addNamedUnions(namedUnions, origin.types);
              }
            }
          }
        }
        function createOriginUnionOrIntersectionType(flags, types2) {
          var result2 = createOriginType(flags);
          result2.types = types2;
          return result2;
        }
        function getUnionType(types2, unionReduction, aliasSymbol, aliasTypeArguments, origin) {
          if (unionReduction === void 0) {
            unionReduction = 1;
          }
          if (types2.length === 0) {
            return neverType;
          }
          if (types2.length === 1) {
            return types2[0];
          }
          var typeSet = [];
          var includes = addTypesToUnion(typeSet, 0, types2);
          if (unionReduction !== 0) {
            if (includes & 3) {
              return includes & 1 ? includes & 8388608 ? wildcardType : anyType : includes & 65536 || containsType(typeSet, unknownType) ? unknownType : nonNullUnknownType;
            }
            if (exactOptionalPropertyTypes && includes & 32768) {
              var missingIndex = ts3.binarySearch(typeSet, missingType, getTypeId, ts3.compareValues);
              if (missingIndex >= 0 && containsType(typeSet, undefinedType)) {
                ts3.orderedRemoveItemAt(typeSet, missingIndex);
              }
            }
            if (includes & (2944 | 8192 | 134217728 | 268435456) || includes & 16384 && includes & 32768) {
              removeRedundantLiteralTypes(typeSet, includes, !!(unionReduction & 2));
            }
            if (includes & 128 && includes & 134217728) {
              removeStringLiteralsMatchedByTemplateLiterals(typeSet);
            }
            if (unionReduction === 2) {
              typeSet = removeSubtypes(typeSet, !!(includes & 524288));
              if (!typeSet) {
                return errorType;
              }
            }
            if (typeSet.length === 0) {
              return includes & 65536 ? includes & 4194304 ? nullType : nullWideningType : includes & 32768 ? includes & 4194304 ? undefinedType : undefinedWideningType : neverType;
            }
          }
          if (!origin && includes & 1048576) {
            var namedUnions = [];
            addNamedUnions(namedUnions, types2);
            var reducedTypes = [];
            var _loop_17 = function(t2) {
              if (!ts3.some(namedUnions, function(union) {
                return containsType(union.types, t2);
              })) {
                reducedTypes.push(t2);
              }
            };
            for (var _i = 0, typeSet_1 = typeSet; _i < typeSet_1.length; _i++) {
              var t = typeSet_1[_i];
              _loop_17(t);
            }
            if (!aliasSymbol && namedUnions.length === 1 && reducedTypes.length === 0) {
              return namedUnions[0];
            }
            var namedTypesCount = ts3.reduceLeft(namedUnions, function(sum, union) {
              return sum + union.types.length;
            }, 0);
            if (namedTypesCount + reducedTypes.length === typeSet.length) {
              for (var _a = 0, namedUnions_1 = namedUnions; _a < namedUnions_1.length; _a++) {
                var t = namedUnions_1[_a];
                insertType(reducedTypes, t);
              }
              origin = createOriginUnionOrIntersectionType(1048576, reducedTypes);
            }
          }
          var objectFlags = (includes & 36323363 ? 0 : 32768) | (includes & 2097152 ? 16777216 : 0);
          return getUnionTypeFromSortedList(typeSet, objectFlags, aliasSymbol, aliasTypeArguments, origin);
        }
        function getUnionOrIntersectionTypePredicate(signatures, kind) {
          var first;
          var types2 = [];
          for (var _i = 0, signatures_6 = signatures; _i < signatures_6.length; _i++) {
            var sig = signatures_6[_i];
            var pred = getTypePredicateOfSignature(sig);
            if (!pred || pred.kind === 2 || pred.kind === 3) {
              if (kind !== 2097152) {
                continue;
              } else {
                return;
              }
            }
            if (first) {
              if (!typePredicateKindsMatch(first, pred)) {
                return void 0;
              }
            } else {
              first = pred;
            }
            types2.push(pred.type);
          }
          if (!first) {
            return void 0;
          }
          var compositeType = getUnionOrIntersectionType(types2, kind);
          return createTypePredicate(first.kind, first.parameterName, first.parameterIndex, compositeType);
        }
        function typePredicateKindsMatch(a, b) {
          return a.kind === b.kind && a.parameterIndex === b.parameterIndex;
        }
        function getUnionTypeFromSortedList(types2, objectFlags, aliasSymbol, aliasTypeArguments, origin) {
          if (types2.length === 0) {
            return neverType;
          }
          if (types2.length === 1) {
            return types2[0];
          }
          var typeKey = !origin ? getTypeListId(types2) : origin.flags & 1048576 ? "|".concat(getTypeListId(origin.types)) : origin.flags & 2097152 ? "&".concat(getTypeListId(origin.types)) : "#".concat(origin.type.id, "|").concat(getTypeListId(types2));
          var id = typeKey + getAliasId(aliasSymbol, aliasTypeArguments);
          var type2 = unionTypes.get(id);
          if (!type2) {
            type2 = createType(1048576);
            type2.objectFlags = objectFlags | getPropagatingFlagsOfTypes(types2, 98304);
            type2.types = types2;
            type2.origin = origin;
            type2.aliasSymbol = aliasSymbol;
            type2.aliasTypeArguments = aliasTypeArguments;
            if (types2.length === 2 && types2[0].flags & 512 && types2[1].flags & 512) {
              type2.flags |= 16;
              type2.intrinsicName = "boolean";
            }
            unionTypes.set(id, type2);
          }
          return type2;
        }
        function getTypeFromUnionTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            links.resolvedType = getUnionType(ts3.map(node.types, getTypeFromTypeNode), 1, aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
          }
          return links.resolvedType;
        }
        function addTypeToIntersection(typeSet, includes, type2) {
          var flags = type2.flags;
          if (flags & 2097152) {
            return addTypesToIntersection(typeSet, includes, type2.types);
          }
          if (isEmptyAnonymousObjectType(type2)) {
            if (!(includes & 16777216)) {
              includes |= 16777216;
              typeSet.set(type2.id.toString(), type2);
            }
          } else {
            if (flags & 3) {
              if (type2 === wildcardType)
                includes |= 8388608;
            } else if (strictNullChecks || !(flags & 98304)) {
              if (exactOptionalPropertyTypes && type2 === missingType) {
                includes |= 262144;
                type2 = undefinedType;
              }
              if (!typeSet.has(type2.id.toString())) {
                if (type2.flags & 109440 && includes & 109440) {
                  includes |= 67108864;
                }
                typeSet.set(type2.id.toString(), type2);
              }
            }
            includes |= flags & 205258751;
          }
          return includes;
        }
        function addTypesToIntersection(typeSet, includes, types2) {
          for (var _i = 0, types_12 = types2; _i < types_12.length; _i++) {
            var type2 = types_12[_i];
            includes = addTypeToIntersection(typeSet, includes, getRegularTypeOfLiteralType(type2));
          }
          return includes;
        }
        function removeRedundantPrimitiveTypes(types2, includes) {
          var i = types2.length;
          while (i > 0) {
            i--;
            var t = types2[i];
            var remove = t.flags & 4 && includes & (128 | 134217728 | 268435456) || t.flags & 8 && includes & 256 || t.flags & 64 && includes & 2048 || t.flags & 4096 && includes & 8192;
            if (remove) {
              ts3.orderedRemoveItemAt(types2, i);
            }
          }
        }
        function eachUnionContains(unionTypes2, type2) {
          for (var _i = 0, unionTypes_1 = unionTypes2; _i < unionTypes_1.length; _i++) {
            var u = unionTypes_1[_i];
            if (!containsType(u.types, type2)) {
              var primitive = type2.flags & 128 ? stringType : type2.flags & 256 ? numberType : type2.flags & 2048 ? bigintType : type2.flags & 8192 ? esSymbolType : void 0;
              if (!primitive || !containsType(u.types, primitive)) {
                return false;
              }
            }
          }
          return true;
        }
        function extractRedundantTemplateLiterals(types2) {
          var i = types2.length;
          var literals = ts3.filter(types2, function(t3) {
            return !!(t3.flags & 128);
          });
          while (i > 0) {
            i--;
            var t = types2[i];
            if (!(t.flags & 134217728))
              continue;
            for (var _i = 0, literals_1 = literals; _i < literals_1.length; _i++) {
              var t2 = literals_1[_i];
              if (isTypeSubtypeOf(t2, t)) {
                ts3.orderedRemoveItemAt(types2, i);
                break;
              } else if (isPatternLiteralType(t)) {
                return true;
              }
            }
          }
          return false;
        }
        function eachIsUnionContaining(types2, flag) {
          return ts3.every(types2, function(t) {
            return !!(t.flags & 1048576) && ts3.some(t.types, function(tt) {
              return !!(tt.flags & flag);
            });
          });
        }
        function removeFromEach(types2, flag) {
          for (var i = 0; i < types2.length; i++) {
            types2[i] = filterType(types2[i], function(t) {
              return !(t.flags & flag);
            });
          }
        }
        function intersectUnionsOfPrimitiveTypes(types2) {
          var unionTypes2;
          var index = ts3.findIndex(types2, function(t2) {
            return !!(ts3.getObjectFlags(t2) & 32768);
          });
          if (index < 0) {
            return false;
          }
          var i = index + 1;
          while (i < types2.length) {
            var t = types2[i];
            if (ts3.getObjectFlags(t) & 32768) {
              (unionTypes2 || (unionTypes2 = [types2[index]])).push(t);
              ts3.orderedRemoveItemAt(types2, i);
            } else {
              i++;
            }
          }
          if (!unionTypes2) {
            return false;
          }
          var checked = [];
          var result2 = [];
          for (var _i = 0, unionTypes_2 = unionTypes2; _i < unionTypes_2.length; _i++) {
            var u = unionTypes_2[_i];
            for (var _a = 0, _b = u.types; _a < _b.length; _a++) {
              var t = _b[_a];
              if (insertType(checked, t)) {
                if (eachUnionContains(unionTypes2, t)) {
                  insertType(result2, t);
                }
              }
            }
          }
          types2[index] = getUnionTypeFromSortedList(result2, 32768);
          return true;
        }
        function createIntersectionType(types2, aliasSymbol, aliasTypeArguments) {
          var result2 = createType(2097152);
          result2.objectFlags = getPropagatingFlagsOfTypes(types2, 98304);
          result2.types = types2;
          result2.aliasSymbol = aliasSymbol;
          result2.aliasTypeArguments = aliasTypeArguments;
          return result2;
        }
        function getIntersectionType(types2, aliasSymbol, aliasTypeArguments) {
          var typeMembershipMap = new ts3.Map();
          var includes = addTypesToIntersection(typeMembershipMap, 0, types2);
          var typeSet = ts3.arrayFrom(typeMembershipMap.values());
          if (includes & 131072) {
            return ts3.contains(typeSet, silentNeverType) ? silentNeverType : neverType;
          }
          if (strictNullChecks && includes & 98304 && includes & (524288 | 67108864 | 16777216) || includes & 67108864 && includes & (469892092 & ~67108864) || includes & 402653316 && includes & (469892092 & ~402653316) || includes & 296 && includes & (469892092 & ~296) || includes & 2112 && includes & (469892092 & ~2112) || includes & 12288 && includes & (469892092 & ~12288) || includes & 49152 && includes & (469892092 & ~49152)) {
            return neverType;
          }
          if (includes & 134217728 && includes & 128 && extractRedundantTemplateLiterals(typeSet)) {
            return neverType;
          }
          if (includes & 1) {
            return includes & 8388608 ? wildcardType : anyType;
          }
          if (!strictNullChecks && includes & 98304) {
            return includes & 32768 ? undefinedType : nullType;
          }
          if (includes & 4 && includes & (128 | 134217728 | 268435456) || includes & 8 && includes & 256 || includes & 64 && includes & 2048 || includes & 4096 && includes & 8192) {
            removeRedundantPrimitiveTypes(typeSet, includes);
          }
          if (includes & 16777216 && includes & 524288) {
            ts3.orderedRemoveItemAt(typeSet, ts3.findIndex(typeSet, isEmptyAnonymousObjectType));
          }
          if (includes & 262144) {
            typeSet[typeSet.indexOf(undefinedType)] = missingType;
          }
          if (typeSet.length === 0) {
            return unknownType;
          }
          if (typeSet.length === 1) {
            return typeSet[0];
          }
          var id = getTypeListId(typeSet) + getAliasId(aliasSymbol, aliasTypeArguments);
          var result2 = intersectionTypes.get(id);
          if (!result2) {
            if (includes & 1048576) {
              if (intersectUnionsOfPrimitiveTypes(typeSet)) {
                result2 = getIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
              } else if (eachIsUnionContaining(typeSet, 32768)) {
                var undefinedOrMissingType = exactOptionalPropertyTypes && ts3.some(typeSet, function(t) {
                  return containsType(t.types, missingType);
                }) ? missingType : undefinedType;
                removeFromEach(typeSet, 32768);
                result2 = getUnionType([getIntersectionType(typeSet), undefinedOrMissingType], 1, aliasSymbol, aliasTypeArguments);
              } else if (eachIsUnionContaining(typeSet, 65536)) {
                removeFromEach(typeSet, 65536);
                result2 = getUnionType([getIntersectionType(typeSet), nullType], 1, aliasSymbol, aliasTypeArguments);
              } else {
                if (!checkCrossProductUnion(typeSet)) {
                  return errorType;
                }
                var constituents = getCrossProductIntersections(typeSet);
                var origin = ts3.some(constituents, function(t) {
                  return !!(t.flags & 2097152);
                }) ? createOriginUnionOrIntersectionType(2097152, typeSet) : void 0;
                result2 = getUnionType(constituents, 1, aliasSymbol, aliasTypeArguments, origin);
              }
            } else {
              result2 = createIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
            }
            intersectionTypes.set(id, result2);
          }
          return result2;
        }
        function getCrossProductUnionSize(types2) {
          return ts3.reduceLeft(types2, function(n, t) {
            return t.flags & 1048576 ? n * t.types.length : t.flags & 131072 ? 0 : n;
          }, 1);
        }
        function checkCrossProductUnion(types2) {
          var size = getCrossProductUnionSize(types2);
          if (size >= 1e5) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "checkCrossProductUnion_DepthLimit", { typeIds: types2.map(function(t) {
              return t.id;
            }), size });
            error(currentNode, ts3.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
            return false;
          }
          return true;
        }
        function getCrossProductIntersections(types2) {
          var count = getCrossProductUnionSize(types2);
          var intersections = [];
          for (var i = 0; i < count; i++) {
            var constituents = types2.slice();
            var n = i;
            for (var j = types2.length - 1; j >= 0; j--) {
              if (types2[j].flags & 1048576) {
                var sourceTypes = types2[j].types;
                var length_5 = sourceTypes.length;
                constituents[j] = sourceTypes[n % length_5];
                n = Math.floor(n / length_5);
              }
            }
            var t = getIntersectionType(constituents);
            if (!(t.flags & 131072))
              intersections.push(t);
          }
          return intersections;
        }
        function getTypeFromIntersectionTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            links.resolvedType = getIntersectionType(ts3.map(node.types, getTypeFromTypeNode), aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
          }
          return links.resolvedType;
        }
        function createIndexType(type2, stringsOnly) {
          var result2 = createType(4194304);
          result2.type = type2;
          result2.stringsOnly = stringsOnly;
          return result2;
        }
        function createOriginIndexType(type2) {
          var result2 = createOriginType(4194304);
          result2.type = type2;
          return result2;
        }
        function getIndexTypeForGenericType(type2, stringsOnly) {
          return stringsOnly ? type2.resolvedStringIndexType || (type2.resolvedStringIndexType = createIndexType(type2, true)) : type2.resolvedIndexType || (type2.resolvedIndexType = createIndexType(type2, false));
        }
        function getIndexTypeForMappedType(type2, stringsOnly, noIndexSignatures) {
          var typeParameter = getTypeParameterFromMappedType(type2);
          var constraintType = getConstraintTypeFromMappedType(type2);
          var nameType = getNameTypeFromMappedType(type2.target || type2);
          if (!nameType && !noIndexSignatures) {
            return constraintType;
          }
          var keyTypes = [];
          if (isMappedTypeWithKeyofConstraintDeclaration(type2)) {
            if (!isGenericIndexType(constraintType)) {
              var modifiersType = getApparentType(getModifiersTypeFromMappedType(type2));
              forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(modifiersType, 8576, stringsOnly, addMemberForKeyType);
            } else {
              return getIndexTypeForGenericType(type2, stringsOnly);
            }
          } else {
            forEachType(getLowerBoundOfKeyType(constraintType), addMemberForKeyType);
          }
          if (isGenericIndexType(constraintType)) {
            forEachType(constraintType, addMemberForKeyType);
          }
          var result2 = noIndexSignatures ? filterType(getUnionType(keyTypes), function(t) {
            return !(t.flags & (1 | 4));
          }) : getUnionType(keyTypes);
          if (result2.flags & 1048576 && constraintType.flags & 1048576 && getTypeListId(result2.types) === getTypeListId(constraintType.types)) {
            return constraintType;
          }
          return result2;
          function addMemberForKeyType(keyType) {
            var propNameType = nameType ? instantiateType(nameType, appendTypeMapping(type2.mapper, typeParameter, keyType)) : keyType;
            keyTypes.push(propNameType === stringType ? stringOrNumberType : propNameType);
          }
        }
        function hasDistributiveNameType(mappedType) {
          var typeVariable = getTypeParameterFromMappedType(mappedType);
          return isDistributive(getNameTypeFromMappedType(mappedType) || typeVariable);
          function isDistributive(type2) {
            return type2.flags & (3 | 131068 | 131072 | 262144 | 524288 | 67108864) ? true : type2.flags & 16777216 ? type2.root.isDistributive && type2.checkType === typeVariable : type2.flags & (3145728 | 134217728) ? ts3.every(type2.types, isDistributive) : type2.flags & 8388608 ? isDistributive(type2.objectType) && isDistributive(type2.indexType) : type2.flags & 33554432 ? isDistributive(type2.substitute) : type2.flags & 268435456 ? isDistributive(type2.type) : false;
          }
        }
        function getLiteralTypeFromPropertyName(name) {
          if (ts3.isPrivateIdentifier(name)) {
            return neverType;
          }
          return ts3.isIdentifier(name) ? getStringLiteralType(ts3.unescapeLeadingUnderscores(name.escapedText)) : getRegularTypeOfLiteralType(ts3.isComputedPropertyName(name) ? checkComputedPropertyName(name) : checkExpression(name));
        }
        function getLiteralTypeFromProperty(prop, include, includeNonPublic) {
          if (includeNonPublic || !(ts3.getDeclarationModifierFlagsFromSymbol(prop) & 24)) {
            var type2 = getSymbolLinks(getLateBoundSymbol(prop)).nameType;
            if (!type2) {
              var name = ts3.getNameOfDeclaration(prop.valueDeclaration);
              type2 = prop.escapedName === "default" ? getStringLiteralType("default") : name && getLiteralTypeFromPropertyName(name) || (!ts3.isKnownSymbol(prop) ? getStringLiteralType(ts3.symbolName(prop)) : void 0);
            }
            if (type2 && type2.flags & include) {
              return type2;
            }
          }
          return neverType;
        }
        function isKeyTypeIncluded(keyType, include) {
          return !!(keyType.flags & include || keyType.flags & 2097152 && ts3.some(keyType.types, function(t) {
            return isKeyTypeIncluded(t, include);
          }));
        }
        function getLiteralTypeFromProperties(type2, include, includeOrigin) {
          var origin = includeOrigin && (ts3.getObjectFlags(type2) & (3 | 4) || type2.aliasSymbol) ? createOriginIndexType(type2) : void 0;
          var propertyTypes = ts3.map(getPropertiesOfType(type2), function(prop) {
            return getLiteralTypeFromProperty(prop, include);
          });
          var indexKeyTypes = ts3.map(getIndexInfosOfType(type2), function(info) {
            return info !== enumNumberIndexInfo && isKeyTypeIncluded(info.keyType, include) ? info.keyType === stringType && include & 8 ? stringOrNumberType : info.keyType : neverType;
          });
          return getUnionType(ts3.concatenate(propertyTypes, indexKeyTypes), 1, void 0, void 0, origin);
        }
        function isPossiblyReducibleByInstantiation(type2) {
          return ts3.some(type2.types, function(t) {
            var uniqueFilled = getUniqueLiteralFilledInstantiation(t);
            return getReducedType(uniqueFilled) !== uniqueFilled;
          });
        }
        function getIndexType(type2, stringsOnly, noIndexSignatures) {
          if (stringsOnly === void 0) {
            stringsOnly = keyofStringsOnly;
          }
          type2 = getReducedType(type2);
          return type2.flags & 1048576 ? isPossiblyReducibleByInstantiation(type2) ? getIndexTypeForGenericType(type2, stringsOnly) : getIntersectionType(ts3.map(type2.types, function(t) {
            return getIndexType(t, stringsOnly, noIndexSignatures);
          })) : type2.flags & 2097152 ? getUnionType(ts3.map(type2.types, function(t) {
            return getIndexType(t, stringsOnly, noIndexSignatures);
          })) : type2.flags & 58982400 || isGenericTupleType(type2) || isGenericMappedType(type2) && !hasDistributiveNameType(type2) ? getIndexTypeForGenericType(type2, stringsOnly) : ts3.getObjectFlags(type2) & 32 ? getIndexTypeForMappedType(type2, stringsOnly, noIndexSignatures) : type2 === wildcardType ? wildcardType : type2.flags & 2 ? neverType : type2.flags & (1 | 131072) ? keyofConstraintType : getLiteralTypeFromProperties(type2, (noIndexSignatures ? 128 : 402653316) | (stringsOnly ? 0 : 296 | 12288), stringsOnly === keyofStringsOnly && !noIndexSignatures);
        }
        function getExtractStringType(type2) {
          if (keyofStringsOnly) {
            return type2;
          }
          var extractTypeAlias = getGlobalExtractSymbol();
          return extractTypeAlias ? getTypeAliasInstantiation(extractTypeAlias, [type2, stringType]) : stringType;
        }
        function getIndexTypeOrString(type2) {
          var indexType = getExtractStringType(getIndexType(type2));
          return indexType.flags & 131072 ? stringType : indexType;
        }
        function getTypeFromTypeOperatorNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            switch (node.operator) {
              case 140:
                links.resolvedType = getIndexType(getTypeFromTypeNode(node.type));
                break;
              case 154:
                links.resolvedType = node.type.kind === 151 ? getESSymbolLikeTypeForNode(ts3.walkUpParenthesizedTypes(node.parent)) : errorType;
                break;
              case 145:
                links.resolvedType = getTypeFromTypeNode(node.type);
                break;
              default:
                throw ts3.Debug.assertNever(node.operator);
            }
          }
          return links.resolvedType;
        }
        function getTypeFromTemplateTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getTemplateLiteralType(__spreadArray([node.head.text], ts3.map(node.templateSpans, function(span) {
              return span.literal.text;
            }), true), ts3.map(node.templateSpans, function(span) {
              return getTypeFromTypeNode(span.type);
            }));
          }
          return links.resolvedType;
        }
        function getTemplateLiteralType(texts, types2) {
          var unionIndex = ts3.findIndex(types2, function(t) {
            return !!(t.flags & (131072 | 1048576));
          });
          if (unionIndex >= 0) {
            return checkCrossProductUnion(types2) ? mapType(types2[unionIndex], function(t) {
              return getTemplateLiteralType(texts, ts3.replaceElement(types2, unionIndex, t));
            }) : errorType;
          }
          if (ts3.contains(types2, wildcardType)) {
            return wildcardType;
          }
          var newTypes = [];
          var newTexts = [];
          var text = texts[0];
          if (!addSpans(texts, types2)) {
            return stringType;
          }
          if (newTypes.length === 0) {
            return getStringLiteralType(text);
          }
          newTexts.push(text);
          if (ts3.every(newTexts, function(t) {
            return t === "";
          }) && ts3.every(newTypes, function(t) {
            return !!(t.flags & 4);
          })) {
            return stringType;
          }
          var id = "".concat(getTypeListId(newTypes), "|").concat(ts3.map(newTexts, function(t) {
            return t.length;
          }).join(","), "|").concat(newTexts.join(""));
          var type2 = templateLiteralTypes.get(id);
          if (!type2) {
            templateLiteralTypes.set(id, type2 = createTemplateLiteralType(newTexts, newTypes));
          }
          return type2;
          function addSpans(texts2, types3) {
            var isTextsArray = ts3.isArray(texts2);
            for (var i = 0; i < types3.length; i++) {
              var t = types3[i];
              var addText = isTextsArray ? texts2[i + 1] : texts2;
              if (t.flags & (2944 | 65536 | 32768)) {
                text += getTemplateStringForType(t) || "";
                text += addText;
                if (!isTextsArray)
                  return true;
              } else if (t.flags & 134217728) {
                text += t.texts[0];
                if (!addSpans(t.texts, t.types))
                  return false;
                text += addText;
                if (!isTextsArray)
                  return true;
              } else if (isGenericIndexType(t) || isPatternLiteralPlaceholderType(t)) {
                newTypes.push(t);
                newTexts.push(text);
                text = addText;
              } else if (t.flags & 2097152) {
                var added = addSpans(texts2[i + 1], t.types);
                if (!added)
                  return false;
              } else if (isTextsArray) {
                return false;
              }
            }
            return true;
          }
        }
        function getTemplateStringForType(type2) {
          return type2.flags & 128 ? type2.value : type2.flags & 256 ? "" + type2.value : type2.flags & 2048 ? ts3.pseudoBigIntToString(type2.value) : type2.flags & (512 | 98304) ? type2.intrinsicName : void 0;
        }
        function createTemplateLiteralType(texts, types2) {
          var type2 = createType(134217728);
          type2.texts = texts;
          type2.types = types2;
          return type2;
        }
        function getStringMappingType(symbol, type2) {
          return type2.flags & (1048576 | 131072) ? mapType(type2, function(t) {
            return getStringMappingType(symbol, t);
          }) : isGenericIndexType(type2) ? getStringMappingTypeForGenericType(symbol, type2) : type2.flags & 128 ? getStringLiteralType(applyStringMapping(symbol, type2.value)) : type2;
        }
        function applyStringMapping(symbol, str2) {
          switch (intrinsicTypeKinds.get(symbol.escapedName)) {
            case 0:
              return str2.toUpperCase();
            case 1:
              return str2.toLowerCase();
            case 2:
              return str2.charAt(0).toUpperCase() + str2.slice(1);
            case 3:
              return str2.charAt(0).toLowerCase() + str2.slice(1);
          }
          return str2;
        }
        function getStringMappingTypeForGenericType(symbol, type2) {
          var id = "".concat(getSymbolId(symbol), ",").concat(getTypeId(type2));
          var result2 = stringMappingTypes.get(id);
          if (!result2) {
            stringMappingTypes.set(id, result2 = createStringMappingType(symbol, type2));
          }
          return result2;
        }
        function createStringMappingType(symbol, type2) {
          var result2 = createType(268435456);
          result2.symbol = symbol;
          result2.type = type2;
          return result2;
        }
        function createIndexedAccessType(objectType, indexType, accessFlags, aliasSymbol, aliasTypeArguments) {
          var type2 = createType(8388608);
          type2.objectType = objectType;
          type2.indexType = indexType;
          type2.accessFlags = accessFlags;
          type2.aliasSymbol = aliasSymbol;
          type2.aliasTypeArguments = aliasTypeArguments;
          return type2;
        }
        function isJSLiteralType(type2) {
          if (noImplicitAny) {
            return false;
          }
          if (ts3.getObjectFlags(type2) & 4096) {
            return true;
          }
          if (type2.flags & 1048576) {
            return ts3.every(type2.types, isJSLiteralType);
          }
          if (type2.flags & 2097152) {
            return ts3.some(type2.types, isJSLiteralType);
          }
          if (type2.flags & 465829888) {
            var constraint = getResolvedBaseConstraint(type2);
            return constraint !== type2 && isJSLiteralType(constraint);
          }
          return false;
        }
        function getPropertyNameFromIndex(indexType, accessNode) {
          return isTypeUsableAsPropertyName(indexType) ? getPropertyNameFromType(indexType) : accessNode && ts3.isPropertyName(accessNode) ? ts3.getPropertyNameForPropertyNameNode(accessNode) : void 0;
        }
        function isUncalledFunctionReference(node, symbol) {
          if (symbol.flags & (16 | 8192)) {
            var parent = ts3.findAncestor(node.parent, function(n) {
              return !ts3.isAccessExpression(n);
            }) || node.parent;
            if (ts3.isCallLikeExpression(parent)) {
              return ts3.isCallOrNewExpression(parent) && ts3.isIdentifier(node) && hasMatchingArgument(parent, node);
            }
            return ts3.every(symbol.declarations, function(d) {
              return !ts3.isFunctionLike(d) || !!(ts3.getCombinedNodeFlags(d) & 268435456);
            });
          }
          return true;
        }
        function getPropertyTypeForIndexType(originalObjectType, objectType, indexType, fullIndexType, accessNode, accessFlags) {
          var _a;
          var accessExpression = accessNode && accessNode.kind === 207 ? accessNode : void 0;
          var propName = accessNode && ts3.isPrivateIdentifier(accessNode) ? void 0 : getPropertyNameFromIndex(indexType, accessNode);
          if (propName !== void 0) {
            if (accessFlags & 256) {
              return getTypeOfPropertyOfContextualType(objectType, propName) || anyType;
            }
            var prop = getPropertyOfType(objectType, propName);
            if (prop) {
              if (accessFlags & 64 && accessNode && prop.declarations && isDeprecatedSymbol(prop) && isUncalledFunctionReference(accessNode, prop)) {
                var deprecatedNode = (_a = accessExpression === null || accessExpression === void 0 ? void 0 : accessExpression.argumentExpression) !== null && _a !== void 0 ? _a : ts3.isIndexedAccessTypeNode(accessNode) ? accessNode.indexType : accessNode;
                addDeprecatedSuggestion(deprecatedNode, prop.declarations, propName);
              }
              if (accessExpression) {
                markPropertyAsReferenced(prop, accessExpression, isSelfTypeAccess(accessExpression.expression, objectType.symbol));
                if (isAssignmentToReadonlyEntity(accessExpression, prop, ts3.getAssignmentTargetKind(accessExpression))) {
                  error(accessExpression.argumentExpression, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(prop));
                  return void 0;
                }
                if (accessFlags & 8) {
                  getNodeLinks(accessNode).resolvedSymbol = prop;
                }
                if (isThisPropertyAccessInConstructor(accessExpression, prop)) {
                  return autoType;
                }
              }
              var propType = getTypeOfSymbol(prop);
              return accessExpression && ts3.getAssignmentTargetKind(accessExpression) !== 1 ? getFlowTypeOfReference(accessExpression, propType) : propType;
            }
            if (everyType(objectType, isTupleType) && ts3.isNumericLiteralName(propName) && +propName >= 0) {
              if (accessNode && everyType(objectType, function(t) {
                return !t.target.hasRestElement;
              }) && !(accessFlags & 16)) {
                var indexNode = getIndexNodeForAccessExpression(accessNode);
                if (isTupleType(objectType)) {
                  error(indexNode, ts3.Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2, typeToString(objectType), getTypeReferenceArity(objectType), ts3.unescapeLeadingUnderscores(propName));
                } else {
                  error(indexNode, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.unescapeLeadingUnderscores(propName), typeToString(objectType));
                }
              }
              errorIfWritingToReadonlyIndex(getIndexInfoOfType(objectType, numberType));
              return mapType(objectType, function(t) {
                var restType = getRestTypeOfTupleType(t) || undefinedType;
                return accessFlags & 1 ? getUnionType([restType, undefinedType]) : restType;
              });
            }
          }
          if (!(indexType.flags & 98304) && isTypeAssignableToKind(indexType, 402653316 | 296 | 12288)) {
            if (objectType.flags & (1 | 131072)) {
              return objectType;
            }
            var indexInfo = getApplicableIndexInfo(objectType, indexType) || getIndexInfoOfType(objectType, stringType);
            if (indexInfo) {
              if (accessFlags & 2 && indexInfo.keyType !== numberType) {
                if (accessExpression) {
                  error(accessExpression, ts3.Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(originalObjectType));
                }
                return void 0;
              }
              if (accessNode && indexInfo.keyType === stringType && !isTypeAssignableToKind(indexType, 4 | 8)) {
                var indexNode = getIndexNodeForAccessExpression(accessNode);
                error(indexNode, ts3.Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
                return accessFlags & 1 ? getUnionType([indexInfo.type, undefinedType]) : indexInfo.type;
              }
              errorIfWritingToReadonlyIndex(indexInfo);
              return accessFlags & 1 ? getUnionType([indexInfo.type, undefinedType]) : indexInfo.type;
            }
            if (indexType.flags & 131072) {
              return neverType;
            }
            if (isJSLiteralType(objectType)) {
              return anyType;
            }
            if (accessExpression && !isConstEnumObjectType(objectType)) {
              if (isObjectLiteralType(objectType)) {
                if (noImplicitAny && indexType.flags & (128 | 256)) {
                  diagnostics.add(ts3.createDiagnosticForNode(accessExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType)));
                  return undefinedType;
                } else if (indexType.flags & (8 | 4)) {
                  var types2 = ts3.map(objectType.properties, function(property) {
                    return getTypeOfSymbol(property);
                  });
                  return getUnionType(ts3.append(types2, undefinedType));
                }
              }
              if (objectType.symbol === globalThisSymbol && propName !== void 0 && globalThisSymbol.exports.has(propName) && globalThisSymbol.exports.get(propName).flags & 418) {
                error(accessExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.unescapeLeadingUnderscores(propName), typeToString(objectType));
              } else if (noImplicitAny && !compilerOptions.suppressImplicitAnyIndexErrors && !(accessFlags & 128)) {
                if (propName !== void 0 && typeHasStaticProperty(propName, objectType)) {
                  var typeName = typeToString(objectType);
                  error(accessExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, propName, typeName, typeName + "[" + ts3.getTextOfNode(accessExpression.argumentExpression) + "]");
                } else if (getIndexTypeOfType(objectType, numberType)) {
                  error(accessExpression.argumentExpression, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);
                } else {
                  var suggestion = void 0;
                  if (propName !== void 0 && (suggestion = getSuggestionForNonexistentProperty(propName, objectType))) {
                    if (suggestion !== void 0) {
                      error(accessExpression.argumentExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(objectType), suggestion);
                    }
                  } else {
                    var suggestion_1 = getSuggestionForNonexistentIndexSignature(objectType, accessExpression, indexType);
                    if (suggestion_1 !== void 0) {
                      error(accessExpression, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1, typeToString(objectType), suggestion_1);
                    } else {
                      var errorInfo = void 0;
                      if (indexType.flags & 1024) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + typeToString(indexType) + "]", typeToString(objectType));
                      } else if (indexType.flags & 8192) {
                        var symbolName_2 = getFullyQualifiedName(indexType.symbol, accessExpression);
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + symbolName_2 + "]", typeToString(objectType));
                      } else if (indexType.flags & 128) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType));
                      } else if (indexType.flags & 256) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType));
                      } else if (indexType.flags & (8 | 4)) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1, typeToString(indexType), typeToString(objectType));
                      }
                      errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1, typeToString(fullIndexType), typeToString(objectType));
                      diagnostics.add(ts3.createDiagnosticForNodeFromMessageChain(accessExpression, errorInfo));
                    }
                  }
                }
              }
              return void 0;
            }
          }
          if (isJSLiteralType(objectType)) {
            return anyType;
          }
          if (accessNode) {
            var indexNode = getIndexNodeForAccessExpression(accessNode);
            if (indexType.flags & (128 | 256)) {
              error(indexNode, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, "" + indexType.value, typeToString(objectType));
            } else if (indexType.flags & (4 | 8)) {
              error(indexNode, ts3.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1, typeToString(objectType), typeToString(indexType));
            } else {
              error(indexNode, ts3.Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
            }
          }
          if (isTypeAny(indexType)) {
            return indexType;
          }
          return void 0;
          function errorIfWritingToReadonlyIndex(indexInfo2) {
            if (indexInfo2 && indexInfo2.isReadonly && accessExpression && (ts3.isAssignmentTarget(accessExpression) || ts3.isDeleteTarget(accessExpression))) {
              error(accessExpression, ts3.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
            }
          }
        }
        function getIndexNodeForAccessExpression(accessNode) {
          return accessNode.kind === 207 ? accessNode.argumentExpression : accessNode.kind === 194 ? accessNode.indexType : accessNode.kind === 162 ? accessNode.expression : accessNode;
        }
        function isPatternLiteralPlaceholderType(type2) {
          return !!(type2.flags & (1 | 4 | 8 | 64));
        }
        function isPatternLiteralType(type2) {
          return !!(type2.flags & 134217728) && ts3.every(type2.types, isPatternLiteralPlaceholderType);
        }
        function isGenericType(type2) {
          return !!getGenericObjectFlags(type2);
        }
        function isGenericObjectType(type2) {
          return !!(getGenericObjectFlags(type2) & 4194304);
        }
        function isGenericIndexType(type2) {
          return !!(getGenericObjectFlags(type2) & 8388608);
        }
        function getGenericObjectFlags(type2) {
          if (type2.flags & 3145728) {
            if (!(type2.objectFlags & 2097152)) {
              type2.objectFlags |= 2097152 | ts3.reduceLeft(type2.types, function(flags, t) {
                return flags | getGenericObjectFlags(t);
              }, 0);
            }
            return type2.objectFlags & 12582912;
          }
          if (type2.flags & 33554432) {
            if (!(type2.objectFlags & 2097152)) {
              type2.objectFlags |= 2097152 | getGenericObjectFlags(type2.substitute) | getGenericObjectFlags(type2.baseType);
            }
            return type2.objectFlags & 12582912;
          }
          return (type2.flags & 58982400 || isGenericMappedType(type2) || isGenericTupleType(type2) ? 4194304 : 0) | (type2.flags & (58982400 | 4194304 | 134217728 | 268435456) && !isPatternLiteralType(type2) ? 8388608 : 0);
        }
        function getSimplifiedType(type2, writing) {
          return type2.flags & 8388608 ? getSimplifiedIndexedAccessType(type2, writing) : type2.flags & 16777216 ? getSimplifiedConditionalType(type2, writing) : type2;
        }
        function distributeIndexOverObjectType(objectType, indexType, writing) {
          if (objectType.flags & 3145728) {
            var types2 = ts3.map(objectType.types, function(t) {
              return getSimplifiedType(getIndexedAccessType(t, indexType), writing);
            });
            return objectType.flags & 2097152 || writing ? getIntersectionType(types2) : getUnionType(types2);
          }
        }
        function distributeObjectOverIndexType(objectType, indexType, writing) {
          if (indexType.flags & 1048576) {
            var types2 = ts3.map(indexType.types, function(t) {
              return getSimplifiedType(getIndexedAccessType(objectType, t), writing);
            });
            return writing ? getIntersectionType(types2) : getUnionType(types2);
          }
        }
        function getSimplifiedIndexedAccessType(type2, writing) {
          var cache = writing ? "simplifiedForWriting" : "simplifiedForReading";
          if (type2[cache]) {
            return type2[cache] === circularConstraintType ? type2 : type2[cache];
          }
          type2[cache] = circularConstraintType;
          var objectType = getSimplifiedType(type2.objectType, writing);
          var indexType = getSimplifiedType(type2.indexType, writing);
          var distributedOverIndex = distributeObjectOverIndexType(objectType, indexType, writing);
          if (distributedOverIndex) {
            return type2[cache] = distributedOverIndex;
          }
          if (!(indexType.flags & 465829888)) {
            var distributedOverObject = distributeIndexOverObjectType(objectType, indexType, writing);
            if (distributedOverObject) {
              return type2[cache] = distributedOverObject;
            }
          }
          if (isGenericTupleType(objectType) && indexType.flags & 296) {
            var elementType = getElementTypeOfSliceOfTupleType(objectType, indexType.flags & 8 ? 0 : objectType.target.fixedLength, 0, writing);
            if (elementType) {
              return type2[cache] = elementType;
            }
          }
          if (isGenericMappedType(objectType)) {
            var nameType = getNameTypeFromMappedType(objectType);
            if (!nameType || isTypeAssignableTo(nameType, getTypeParameterFromMappedType(objectType))) {
              return type2[cache] = mapType(substituteIndexedMappedType(objectType, type2.indexType), function(t) {
                return getSimplifiedType(t, writing);
              });
            }
          }
          return type2[cache] = type2;
        }
        function getSimplifiedConditionalType(type2, writing) {
          var checkType = type2.checkType;
          var extendsType = type2.extendsType;
          var trueType2 = getTrueTypeFromConditionalType(type2);
          var falseType2 = getFalseTypeFromConditionalType(type2);
          if (falseType2.flags & 131072 && getActualTypeVariable(trueType2) === getActualTypeVariable(checkType)) {
            if (checkType.flags & 1 || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
              return getSimplifiedType(trueType2, writing);
            } else if (isIntersectionEmpty(checkType, extendsType)) {
              return neverType;
            }
          } else if (trueType2.flags & 131072 && getActualTypeVariable(falseType2) === getActualTypeVariable(checkType)) {
            if (!(checkType.flags & 1) && isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
              return neverType;
            } else if (checkType.flags & 1 || isIntersectionEmpty(checkType, extendsType)) {
              return getSimplifiedType(falseType2, writing);
            }
          }
          return type2;
        }
        function isIntersectionEmpty(type1, type2) {
          return !!(getUnionType([intersectTypes(type1, type2), neverType]).flags & 131072);
        }
        function substituteIndexedMappedType(objectType, index) {
          var mapper = createTypeMapper([getTypeParameterFromMappedType(objectType)], [index]);
          var templateMapper = combineTypeMappers(objectType.mapper, mapper);
          return instantiateType(getTemplateTypeFromMappedType(objectType), templateMapper);
        }
        function getIndexedAccessType(objectType, indexType, accessFlags, accessNode, aliasSymbol, aliasTypeArguments) {
          if (accessFlags === void 0) {
            accessFlags = 0;
          }
          return getIndexedAccessTypeOrUndefined(objectType, indexType, accessFlags, accessNode, aliasSymbol, aliasTypeArguments) || (accessNode ? errorType : unknownType);
        }
        function indexTypeLessThan(indexType, limit) {
          return everyType(indexType, function(t) {
            if (t.flags & 384) {
              var propName = getPropertyNameFromType(t);
              if (ts3.isNumericLiteralName(propName)) {
                var index = +propName;
                return index >= 0 && index < limit;
              }
            }
            return false;
          });
        }
        function getIndexedAccessTypeOrUndefined(objectType, indexType, accessFlags, accessNode, aliasSymbol, aliasTypeArguments) {
          if (accessFlags === void 0) {
            accessFlags = 0;
          }
          if (objectType === wildcardType || indexType === wildcardType) {
            return wildcardType;
          }
          if (isStringIndexSignatureOnlyType(objectType) && !(indexType.flags & 98304) && isTypeAssignableToKind(indexType, 4 | 8)) {
            indexType = stringType;
          }
          if (compilerOptions.noUncheckedIndexedAccess && accessFlags & 32)
            accessFlags |= 1;
          if (isGenericIndexType(indexType) || (accessNode && accessNode.kind !== 194 ? isGenericTupleType(objectType) && !indexTypeLessThan(indexType, objectType.target.fixedLength) : isGenericObjectType(objectType) && !(isTupleType(objectType) && indexTypeLessThan(indexType, objectType.target.fixedLength)))) {
            if (objectType.flags & 3) {
              return objectType;
            }
            var persistentAccessFlags = accessFlags & 1;
            var id = objectType.id + "," + indexType.id + "," + persistentAccessFlags + getAliasId(aliasSymbol, aliasTypeArguments);
            var type2 = indexedAccessTypes.get(id);
            if (!type2) {
              indexedAccessTypes.set(id, type2 = createIndexedAccessType(objectType, indexType, persistentAccessFlags, aliasSymbol, aliasTypeArguments));
            }
            return type2;
          }
          var apparentObjectType = getReducedApparentType(objectType);
          if (indexType.flags & 1048576 && !(indexType.flags & 16)) {
            var propTypes = [];
            var wasMissingProp = false;
            for (var _i = 0, _a = indexType.types; _i < _a.length; _i++) {
              var t = _a[_i];
              var propType = getPropertyTypeForIndexType(objectType, apparentObjectType, t, indexType, accessNode, accessFlags | (wasMissingProp ? 128 : 0));
              if (propType) {
                propTypes.push(propType);
              } else if (!accessNode) {
                return void 0;
              } else {
                wasMissingProp = true;
              }
            }
            if (wasMissingProp) {
              return void 0;
            }
            return accessFlags & 4 ? getIntersectionType(propTypes, aliasSymbol, aliasTypeArguments) : getUnionType(propTypes, 1, aliasSymbol, aliasTypeArguments);
          }
          return getPropertyTypeForIndexType(objectType, apparentObjectType, indexType, indexType, accessNode, accessFlags | 8 | 64);
        }
        function getTypeFromIndexedAccessTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var objectType = getTypeFromTypeNode(node.objectType);
            var indexType = getTypeFromTypeNode(node.indexType);
            var potentialAlias = getAliasSymbolForTypeNode(node);
            var resolved = getIndexedAccessType(objectType, indexType, 0, node, potentialAlias, getTypeArgumentsForAliasSymbol(potentialAlias));
            links.resolvedType = resolved.flags & 8388608 && resolved.objectType === objectType && resolved.indexType === indexType ? getConditionalFlowTypeOfType(resolved, node) : resolved;
          }
          return links.resolvedType;
        }
        function getTypeFromMappedTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var type2 = createObjectType(32, node.symbol);
            type2.declaration = node;
            type2.aliasSymbol = getAliasSymbolForTypeNode(node);
            type2.aliasTypeArguments = getTypeArgumentsForAliasSymbol(type2.aliasSymbol);
            links.resolvedType = type2;
            getConstraintTypeFromMappedType(type2);
          }
          return links.resolvedType;
        }
        function getActualTypeVariable(type2) {
          if (type2.flags & 33554432) {
            return type2.baseType;
          }
          if (type2.flags & 8388608 && (type2.objectType.flags & 33554432 || type2.indexType.flags & 33554432)) {
            return getIndexedAccessType(getActualTypeVariable(type2.objectType), getActualTypeVariable(type2.indexType));
          }
          return type2;
        }
        function maybeCloneTypeParameter(p) {
          var constraint = getConstraintOfTypeParameter(p);
          return constraint && (isGenericObjectType(constraint) || isGenericIndexType(constraint)) ? cloneTypeParameter(p) : p;
        }
        function isTypicalNondistributiveConditional(root) {
          return !root.isDistributive && isSingletonTupleType(root.node.checkType) && isSingletonTupleType(root.node.extendsType);
        }
        function isSingletonTupleType(node) {
          return ts3.isTupleTypeNode(node) && ts3.length(node.elements) === 1 && !ts3.isOptionalTypeNode(node.elements[0]) && !ts3.isRestTypeNode(node.elements[0]) && !(ts3.isNamedTupleMember(node.elements[0]) && (node.elements[0].questionToken || node.elements[0].dotDotDotToken));
        }
        function unwrapNondistributiveConditionalTuple(root, type2) {
          return isTypicalNondistributiveConditional(root) && isTupleType(type2) ? getTypeArguments(type2)[0] : type2;
        }
        function getConditionalType(root, mapper, aliasSymbol, aliasTypeArguments) {
          var result2;
          var extraTypes;
          var tailCount = 0;
          var _loop_18 = function() {
            if (tailCount === 1e3) {
              error(currentNode, ts3.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
              result2 = errorType;
              return "break";
            }
            var isUnwrapped = isTypicalNondistributiveConditional(root);
            var checkType = instantiateType(unwrapNondistributiveConditionalTuple(root, getActualTypeVariable(root.checkType)), mapper);
            var checkTypeInstantiable = isGenericType(checkType);
            var extendsType = instantiateType(unwrapNondistributiveConditionalTuple(root, root.extendsType), mapper);
            if (checkType === wildcardType || extendsType === wildcardType) {
              return { value: wildcardType };
            }
            var combinedMapper = void 0;
            if (root.inferTypeParameters) {
              var freshParams = ts3.sameMap(root.inferTypeParameters, maybeCloneTypeParameter);
              var freshMapper = freshParams !== root.inferTypeParameters ? createTypeMapper(root.inferTypeParameters, freshParams) : void 0;
              var context = createInferenceContext(freshParams, void 0, 0);
              if (freshMapper) {
                var freshCombinedMapper = combineTypeMappers(mapper, freshMapper);
                for (var _i = 0, freshParams_1 = freshParams; _i < freshParams_1.length; _i++) {
                  var p = freshParams_1[_i];
                  if (root.inferTypeParameters.indexOf(p) === -1) {
                    p.mapper = freshCombinedMapper;
                  }
                }
              }
              if (!checkTypeInstantiable || !ts3.some(root.inferTypeParameters, function(t) {
                return t === extendsType;
              })) {
                inferTypes(context.inferences, checkType, instantiateType(extendsType, freshMapper), 512 | 1024);
              }
              var innerMapper = combineTypeMappers(freshMapper, context.mapper);
              combinedMapper = mapper ? combineTypeMappers(innerMapper, mapper) : innerMapper;
            }
            var inferredExtendsType = combinedMapper ? instantiateType(unwrapNondistributiveConditionalTuple(root, root.extendsType), combinedMapper) : extendsType;
            if (!checkTypeInstantiable && !isGenericType(inferredExtendsType)) {
              if (!(inferredExtendsType.flags & 3) && (checkType.flags & 1 && !isUnwrapped || !isTypeAssignableTo(getPermissiveInstantiation(checkType), getPermissiveInstantiation(inferredExtendsType)))) {
                if (checkType.flags & 1 && !isUnwrapped) {
                  (extraTypes || (extraTypes = [])).push(instantiateType(getTypeFromTypeNode(root.node.trueType), combinedMapper || mapper));
                }
                var falseType_1 = getTypeFromTypeNode(root.node.falseType);
                if (falseType_1.flags & 16777216) {
                  var newRoot = falseType_1.root;
                  if (newRoot.node.parent === root.node && (!newRoot.isDistributive || newRoot.checkType === root.checkType)) {
                    root = newRoot;
                    return "continue";
                  }
                  if (canTailRecurse(falseType_1, mapper)) {
                    return "continue";
                  }
                }
                result2 = instantiateType(falseType_1, mapper);
                return "break";
              }
              if (inferredExtendsType.flags & 3 || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(inferredExtendsType))) {
                var trueType_1 = getTypeFromTypeNode(root.node.trueType);
                var trueMapper = combinedMapper || mapper;
                if (canTailRecurse(trueType_1, trueMapper)) {
                  return "continue";
                }
                result2 = instantiateType(trueType_1, trueMapper);
                return "break";
              }
            }
            result2 = createType(16777216);
            result2.root = root;
            result2.checkType = instantiateType(root.checkType, mapper);
            result2.extendsType = instantiateType(root.extendsType, mapper);
            result2.mapper = mapper;
            result2.combinedMapper = combinedMapper;
            result2.aliasSymbol = aliasSymbol || root.aliasSymbol;
            result2.aliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(root.aliasTypeArguments, mapper);
            return "break";
          };
          while (true) {
            var state_5 = _loop_18();
            if (typeof state_5 === "object")
              return state_5.value;
            if (state_5 === "break")
              break;
          }
          return extraTypes ? getUnionType(ts3.append(extraTypes, result2)) : result2;
          function canTailRecurse(newType, newMapper) {
            if (newType.flags & 16777216 && newMapper) {
              var newRoot = newType.root;
              if (newRoot.outerTypeParameters) {
                var typeParamMapper_1 = combineTypeMappers(newType.mapper, newMapper);
                var typeArguments = ts3.map(newRoot.outerTypeParameters, function(t) {
                  return getMappedType(t, typeParamMapper_1);
                });
                var newRootMapper = createTypeMapper(newRoot.outerTypeParameters, typeArguments);
                var newCheckType = newRoot.isDistributive ? getMappedType(newRoot.checkType, newRootMapper) : void 0;
                if (!newCheckType || newCheckType === newRoot.checkType || !(newCheckType.flags & (1048576 | 131072))) {
                  root = newRoot;
                  mapper = newRootMapper;
                  aliasSymbol = void 0;
                  aliasTypeArguments = void 0;
                  if (newRoot.aliasSymbol) {
                    tailCount++;
                  }
                  return true;
                }
              }
            }
            return false;
          }
        }
        function getTrueTypeFromConditionalType(type2) {
          return type2.resolvedTrueType || (type2.resolvedTrueType = instantiateType(getTypeFromTypeNode(type2.root.node.trueType), type2.mapper));
        }
        function getFalseTypeFromConditionalType(type2) {
          return type2.resolvedFalseType || (type2.resolvedFalseType = instantiateType(getTypeFromTypeNode(type2.root.node.falseType), type2.mapper));
        }
        function getInferredTrueTypeFromConditionalType(type2) {
          return type2.resolvedInferredTrueType || (type2.resolvedInferredTrueType = type2.combinedMapper ? instantiateType(getTypeFromTypeNode(type2.root.node.trueType), type2.combinedMapper) : getTrueTypeFromConditionalType(type2));
        }
        function getInferTypeParameters(node) {
          var result2;
          if (node.locals) {
            node.locals.forEach(function(symbol) {
              if (symbol.flags & 262144) {
                result2 = ts3.append(result2, getDeclaredTypeOfSymbol(symbol));
              }
            });
          }
          return result2;
        }
        function isDistributionDependent(root) {
          return root.isDistributive && (isTypeParameterPossiblyReferenced(root.checkType, root.node.trueType) || isTypeParameterPossiblyReferenced(root.checkType, root.node.falseType));
        }
        function getTypeFromConditionalTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var checkType = getTypeFromTypeNode(node.checkType);
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            var aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
            var allOuterTypeParameters = getOuterTypeParameters(node, true);
            var outerTypeParameters = aliasTypeArguments ? allOuterTypeParameters : ts3.filter(allOuterTypeParameters, function(tp) {
              return isTypeParameterPossiblyReferenced(tp, node);
            });
            var root = {
              node,
              checkType,
              extendsType: getTypeFromTypeNode(node.extendsType),
              isDistributive: !!(checkType.flags & 262144),
              inferTypeParameters: getInferTypeParameters(node),
              outerTypeParameters,
              instantiations: void 0,
              aliasSymbol,
              aliasTypeArguments
            };
            links.resolvedType = getConditionalType(root, void 0);
            if (outerTypeParameters) {
              root.instantiations = new ts3.Map();
              root.instantiations.set(getTypeListId(outerTypeParameters), links.resolvedType);
            }
          }
          return links.resolvedType;
        }
        function getTypeFromInferTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node.typeParameter));
          }
          return links.resolvedType;
        }
        function getIdentifierChain(node) {
          if (ts3.isIdentifier(node)) {
            return [node];
          } else {
            return ts3.append(getIdentifierChain(node.left), node.right);
          }
        }
        function getTypeFromImportTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (node.isTypeOf && node.typeArguments) {
              error(node, ts3.Diagnostics.Type_arguments_cannot_be_used_here);
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            if (!ts3.isLiteralImportTypeNode(node)) {
              error(node.argument, ts3.Diagnostics.String_literal_expected);
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            var targetMeaning = node.isTypeOf ? 111551 : node.flags & 8388608 ? 111551 | 788968 : 788968;
            var innerModuleSymbol = resolveExternalModuleName(node, node.argument.literal);
            if (!innerModuleSymbol) {
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            var moduleSymbol = resolveExternalModuleSymbol(innerModuleSymbol, false);
            if (!ts3.nodeIsMissing(node.qualifier)) {
              var nameStack = getIdentifierChain(node.qualifier);
              var currentNamespace = moduleSymbol;
              var current = void 0;
              while (current = nameStack.shift()) {
                var meaning = nameStack.length ? 1920 : targetMeaning;
                var mergedResolvedSymbol = getMergedSymbol(resolveSymbol(currentNamespace));
                var next = node.isTypeOf ? getPropertyOfType(getTypeOfSymbol(mergedResolvedSymbol), current.escapedText) : getSymbol(getExportsOfSymbol(mergedResolvedSymbol), current.escapedText, meaning);
                if (!next) {
                  error(current, ts3.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(currentNamespace), ts3.declarationNameToString(current));
                  return links.resolvedType = errorType;
                }
                getNodeLinks(current).resolvedSymbol = next;
                getNodeLinks(current.parent).resolvedSymbol = next;
                currentNamespace = next;
              }
              links.resolvedType = resolveImportSymbolType(node, links, currentNamespace, targetMeaning);
            } else {
              if (moduleSymbol.flags & targetMeaning) {
                links.resolvedType = resolveImportSymbolType(node, links, moduleSymbol, targetMeaning);
              } else {
                var errorMessage = targetMeaning === 111551 ? ts3.Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here : ts3.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;
                error(node, errorMessage, node.argument.literal.text);
                links.resolvedSymbol = unknownSymbol;
                links.resolvedType = errorType;
              }
            }
          }
          return links.resolvedType;
        }
        function resolveImportSymbolType(node, links, symbol, meaning) {
          var resolvedSymbol = resolveSymbol(symbol);
          links.resolvedSymbol = resolvedSymbol;
          if (meaning === 111551) {
            return getTypeOfSymbol(symbol);
          } else {
            return getTypeReferenceType(node, resolvedSymbol);
          }
        }
        function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            if (getMembersOfSymbol(node.symbol).size === 0 && !aliasSymbol) {
              links.resolvedType = emptyTypeLiteralType;
            } else {
              var type2 = createObjectType(16, node.symbol);
              type2.aliasSymbol = aliasSymbol;
              type2.aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
              if (ts3.isJSDocTypeLiteral(node) && node.isArrayType) {
                type2 = createArrayType(type2);
              }
              links.resolvedType = type2;
            }
          }
          return links.resolvedType;
        }
        function getAliasSymbolForTypeNode(node) {
          var host2 = node.parent;
          while (ts3.isParenthesizedTypeNode(host2) || ts3.isJSDocTypeExpression(host2) || ts3.isTypeOperatorNode(host2) && host2.operator === 145) {
            host2 = host2.parent;
          }
          return ts3.isTypeAlias(host2) ? getSymbolOfNode(host2) : void 0;
        }
        function getTypeArgumentsForAliasSymbol(symbol) {
          return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : void 0;
        }
        function isNonGenericObjectType(type2) {
          return !!(type2.flags & 524288) && !isGenericMappedType(type2);
        }
        function isEmptyObjectTypeOrSpreadsIntoEmptyObject(type2) {
          return isEmptyObjectType(type2) || !!(type2.flags & (65536 | 32768 | 528 | 296 | 2112 | 402653316 | 1056 | 67108864 | 4194304));
        }
        function tryMergeUnionOfObjectTypeAndEmptyObject(type2, readonly) {
          if (!(type2.flags & 1048576)) {
            return type2;
          }
          if (ts3.every(type2.types, isEmptyObjectTypeOrSpreadsIntoEmptyObject)) {
            return ts3.find(type2.types, isEmptyObjectType) || emptyObjectType;
          }
          var firstType = ts3.find(type2.types, function(t) {
            return !isEmptyObjectTypeOrSpreadsIntoEmptyObject(t);
          });
          if (!firstType) {
            return type2;
          }
          var secondType = ts3.find(type2.types, function(t) {
            return t !== firstType && !isEmptyObjectTypeOrSpreadsIntoEmptyObject(t);
          });
          if (secondType) {
            return type2;
          }
          return getAnonymousPartialType(firstType);
          function getAnonymousPartialType(type3) {
            var members = ts3.createSymbolTable();
            for (var _i = 0, _a = getPropertiesOfType(type3); _i < _a.length; _i++) {
              var prop = _a[_i];
              if (ts3.getDeclarationModifierFlagsFromSymbol(prop) & (8 | 16)) {
              } else if (isSpreadableProperty(prop)) {
                var isSetonlyAccessor = prop.flags & 65536 && !(prop.flags & 32768);
                var flags = 4 | 16777216;
                var result2 = createSymbol(flags, prop.escapedName, getIsLateCheckFlag(prop) | (readonly ? 8 : 0));
                result2.type = isSetonlyAccessor ? undefinedType : addOptionality(getTypeOfSymbol(prop), true);
                result2.declarations = prop.declarations;
                result2.nameType = getSymbolLinks(prop).nameType;
                result2.syntheticOrigin = prop;
                members.set(prop.escapedName, result2);
              }
            }
            var spread = createAnonymousType(type3.symbol, members, ts3.emptyArray, ts3.emptyArray, getIndexInfosOfType(type3));
            spread.objectFlags |= 128 | 131072;
            return spread;
          }
        }
        function getSpreadType(left, right, symbol, objectFlags, readonly) {
          if (left.flags & 1 || right.flags & 1) {
            return anyType;
          }
          if (left.flags & 2 || right.flags & 2) {
            return unknownType;
          }
          if (left.flags & 131072) {
            return right;
          }
          if (right.flags & 131072) {
            return left;
          }
          left = tryMergeUnionOfObjectTypeAndEmptyObject(left, readonly);
          if (left.flags & 1048576) {
            return checkCrossProductUnion([left, right]) ? mapType(left, function(t) {
              return getSpreadType(t, right, symbol, objectFlags, readonly);
            }) : errorType;
          }
          right = tryMergeUnionOfObjectTypeAndEmptyObject(right, readonly);
          if (right.flags & 1048576) {
            return checkCrossProductUnion([left, right]) ? mapType(right, function(t) {
              return getSpreadType(left, t, symbol, objectFlags, readonly);
            }) : errorType;
          }
          if (right.flags & (528 | 296 | 2112 | 402653316 | 1056 | 67108864 | 4194304)) {
            return left;
          }
          if (isGenericObjectType(left) || isGenericObjectType(right)) {
            if (isEmptyObjectType(left)) {
              return right;
            }
            if (left.flags & 2097152) {
              var types2 = left.types;
              var lastLeft = types2[types2.length - 1];
              if (isNonGenericObjectType(lastLeft) && isNonGenericObjectType(right)) {
                return getIntersectionType(ts3.concatenate(types2.slice(0, types2.length - 1), [getSpreadType(lastLeft, right, symbol, objectFlags, readonly)]));
              }
            }
            return getIntersectionType([left, right]);
          }
          var members = ts3.createSymbolTable();
          var skippedPrivateMembers = new ts3.Set();
          var indexInfos = left === emptyObjectType ? getIndexInfosOfType(right) : getUnionIndexInfos([left, right]);
          for (var _i = 0, _a = getPropertiesOfType(right); _i < _a.length; _i++) {
            var rightProp = _a[_i];
            if (ts3.getDeclarationModifierFlagsFromSymbol(rightProp) & (8 | 16)) {
              skippedPrivateMembers.add(rightProp.escapedName);
            } else if (isSpreadableProperty(rightProp)) {
              members.set(rightProp.escapedName, getSpreadSymbol(rightProp, readonly));
            }
          }
          for (var _b = 0, _c = getPropertiesOfType(left); _b < _c.length; _b++) {
            var leftProp = _c[_b];
            if (skippedPrivateMembers.has(leftProp.escapedName) || !isSpreadableProperty(leftProp)) {
              continue;
            }
            if (members.has(leftProp.escapedName)) {
              var rightProp = members.get(leftProp.escapedName);
              var rightType = getTypeOfSymbol(rightProp);
              if (rightProp.flags & 16777216) {
                var declarations = ts3.concatenate(leftProp.declarations, rightProp.declarations);
                var flags = 4 | leftProp.flags & 16777216;
                var result2 = createSymbol(flags, leftProp.escapedName);
                result2.type = getUnionType([getTypeOfSymbol(leftProp), removeMissingOrUndefinedType(rightType)], 2);
                result2.leftSpread = leftProp;
                result2.rightSpread = rightProp;
                result2.declarations = declarations;
                result2.nameType = getSymbolLinks(leftProp).nameType;
                members.set(leftProp.escapedName, result2);
              }
            } else {
              members.set(leftProp.escapedName, getSpreadSymbol(leftProp, readonly));
            }
          }
          var spread = createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, ts3.sameMap(indexInfos, function(info) {
            return getIndexInfoWithReadonly(info, readonly);
          }));
          spread.objectFlags |= 128 | 131072 | 2097152 | objectFlags;
          return spread;
        }
        function isSpreadableProperty(prop) {
          var _a;
          return !ts3.some(prop.declarations, ts3.isPrivateIdentifierClassElementDeclaration) && (!(prop.flags & (8192 | 32768 | 65536)) || !((_a = prop.declarations) === null || _a === void 0 ? void 0 : _a.some(function(decl) {
            return ts3.isClassLike(decl.parent);
          })));
        }
        function getSpreadSymbol(prop, readonly) {
          var isSetonlyAccessor = prop.flags & 65536 && !(prop.flags & 32768);
          if (!isSetonlyAccessor && readonly === isReadonlySymbol(prop)) {
            return prop;
          }
          var flags = 4 | prop.flags & 16777216;
          var result2 = createSymbol(flags, prop.escapedName, getIsLateCheckFlag(prop) | (readonly ? 8 : 0));
          result2.type = isSetonlyAccessor ? undefinedType : getTypeOfSymbol(prop);
          result2.declarations = prop.declarations;
          result2.nameType = getSymbolLinks(prop).nameType;
          result2.syntheticOrigin = prop;
          return result2;
        }
        function getIndexInfoWithReadonly(info, readonly) {
          return info.isReadonly !== readonly ? createIndexInfo(info.keyType, info.type, readonly, info.declaration) : info;
        }
        function createLiteralType(flags, value, symbol, regularType) {
          var type2 = createType(flags);
          type2.symbol = symbol;
          type2.value = value;
          type2.regularType = regularType || type2;
          return type2;
        }
        function getFreshTypeOfLiteralType(type2) {
          if (type2.flags & 2944) {
            if (!type2.freshType) {
              var freshType = createLiteralType(type2.flags, type2.value, type2.symbol, type2);
              freshType.freshType = freshType;
              type2.freshType = freshType;
            }
            return type2.freshType;
          }
          return type2;
        }
        function getRegularTypeOfLiteralType(type2) {
          return type2.flags & 2944 ? type2.regularType : type2.flags & 1048576 ? type2.regularType || (type2.regularType = mapType(type2, getRegularTypeOfLiteralType)) : type2;
        }
        function isFreshLiteralType(type2) {
          return !!(type2.flags & 2944) && type2.freshType === type2;
        }
        function getStringLiteralType(value) {
          var type2;
          return stringLiteralTypes.get(value) || (stringLiteralTypes.set(value, type2 = createLiteralType(128, value)), type2);
        }
        function getNumberLiteralType(value) {
          var type2;
          return numberLiteralTypes.get(value) || (numberLiteralTypes.set(value, type2 = createLiteralType(256, value)), type2);
        }
        function getBigIntLiteralType(value) {
          var type2;
          var key = ts3.pseudoBigIntToString(value);
          return bigIntLiteralTypes.get(key) || (bigIntLiteralTypes.set(key, type2 = createLiteralType(2048, value)), type2);
        }
        function getEnumLiteralType(value, enumId, symbol) {
          var type2;
          var qualifier = typeof value === "string" ? "@" : "#";
          var key = enumId + qualifier + value;
          var flags = 1024 | (typeof value === "string" ? 128 : 256);
          return enumLiteralTypes.get(key) || (enumLiteralTypes.set(key, type2 = createLiteralType(flags, value, symbol)), type2);
        }
        function getTypeFromLiteralTypeNode(node) {
          if (node.literal.kind === 104) {
            return nullType;
          }
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
          }
          return links.resolvedType;
        }
        function createUniqueESSymbolType(symbol) {
          var type2 = createType(8192);
          type2.symbol = symbol;
          type2.escapedName = "__@".concat(type2.symbol.escapedName, "@").concat(getSymbolId(type2.symbol));
          return type2;
        }
        function getESSymbolLikeTypeForNode(node) {
          if (ts3.isValidESSymbolDeclaration(node)) {
            var symbol = ts3.isCommonJsExportPropertyAssignment(node) ? getSymbolOfNode(node.left) : getSymbolOfNode(node);
            if (symbol) {
              var links = getSymbolLinks(symbol);
              return links.uniqueESSymbolType || (links.uniqueESSymbolType = createUniqueESSymbolType(symbol));
            }
          }
          return esSymbolType;
        }
        function getThisType(node) {
          var container = ts3.getThisContainer(node, false);
          var parent = container && container.parent;
          if (parent && (ts3.isClassLike(parent) || parent.kind === 258)) {
            if (!ts3.isStatic(container) && (!ts3.isConstructorDeclaration(container) || ts3.isNodeDescendantOf(node, container.body))) {
              return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent)).thisType;
            }
          }
          if (parent && ts3.isObjectLiteralExpression(parent) && ts3.isBinaryExpression(parent.parent) && ts3.getAssignmentDeclarationKind(parent.parent) === 6) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent.parent.left).parent).thisType;
          }
          var host2 = node.flags & 8388608 ? ts3.getHostSignatureFromJSDoc(node) : void 0;
          if (host2 && ts3.isFunctionExpression(host2) && ts3.isBinaryExpression(host2.parent) && ts3.getAssignmentDeclarationKind(host2.parent) === 3) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(host2.parent.left).parent).thisType;
          }
          if (isJSConstructor(container) && ts3.isNodeDescendantOf(node, container.body)) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(container)).thisType;
          }
          error(node, ts3.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface);
          return errorType;
        }
        function getTypeFromThisTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getThisType(node);
          }
          return links.resolvedType;
        }
        function getTypeFromRestTypeNode(node) {
          return getTypeFromTypeNode(getArrayElementTypeNode(node.type) || node.type);
        }
        function getArrayElementTypeNode(node) {
          switch (node.kind) {
            case 191:
              return getArrayElementTypeNode(node.type);
            case 184:
              if (node.elements.length === 1) {
                node = node.elements[0];
                if (node.kind === 186 || node.kind === 197 && node.dotDotDotToken) {
                  return getArrayElementTypeNode(node.type);
                }
              }
              break;
            case 183:
              return node.elementType;
          }
          return void 0;
        }
        function getTypeFromNamedTupleTypeNode(node) {
          var links = getNodeLinks(node);
          return links.resolvedType || (links.resolvedType = node.dotDotDotToken ? getTypeFromRestTypeNode(node) : addOptionality(getTypeFromTypeNode(node.type), true, !!node.questionToken));
        }
        function getTypeFromTypeNode(node) {
          return getConditionalFlowTypeOfType(getTypeFromTypeNodeWorker(node), node);
        }
        function getTypeFromTypeNodeWorker(node) {
          switch (node.kind) {
            case 130:
            case 312:
            case 313:
              return anyType;
            case 155:
              return unknownType;
            case 150:
              return stringType;
            case 147:
              return numberType;
            case 158:
              return bigintType;
            case 133:
              return booleanType;
            case 151:
              return esSymbolType;
            case 114:
              return voidType;
            case 153:
              return undefinedType;
            case 104:
              return nullType;
            case 143:
              return neverType;
            case 148:
              return node.flags & 262144 && !noImplicitAny ? anyType : nonPrimitiveType;
            case 138:
              return intrinsicMarkerType;
            case 192:
            case 108:
              return getTypeFromThisTypeNode(node);
            case 196:
              return getTypeFromLiteralTypeNode(node);
            case 178:
              return getTypeFromTypeReference(node);
            case 177:
              return node.assertsModifier ? voidType : booleanType;
            case 228:
              return getTypeFromTypeReference(node);
            case 181:
              return getTypeFromTypeQueryNode(node);
            case 183:
            case 184:
              return getTypeFromArrayOrTupleTypeNode(node);
            case 185:
              return getTypeFromOptionalTypeNode(node);
            case 187:
              return getTypeFromUnionTypeNode(node);
            case 188:
              return getTypeFromIntersectionTypeNode(node);
            case 314:
              return getTypeFromJSDocNullableTypeNode(node);
            case 316:
              return addOptionality(getTypeFromTypeNode(node.type));
            case 197:
              return getTypeFromNamedTupleTypeNode(node);
            case 191:
            case 315:
            case 309:
              return getTypeFromTypeNode(node.type);
            case 186:
              return getTypeFromRestTypeNode(node);
            case 318:
              return getTypeFromJSDocVariadicType(node);
            case 179:
            case 180:
            case 182:
            case 322:
            case 317:
            case 323:
              return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
            case 193:
              return getTypeFromTypeOperatorNode(node);
            case 194:
              return getTypeFromIndexedAccessTypeNode(node);
            case 195:
              return getTypeFromMappedTypeNode(node);
            case 189:
              return getTypeFromConditionalTypeNode(node);
            case 190:
              return getTypeFromInferTypeNode(node);
            case 198:
              return getTypeFromTemplateTypeNode(node);
            case 200:
              return getTypeFromImportTypeNode(node);
            case 79:
            case 161:
            case 206:
              var symbol = getSymbolAtLocation(node);
              return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
            default:
              return errorType;
          }
        }
        function instantiateList(items, mapper, instantiator) {
          if (items && items.length) {
            for (var i = 0; i < items.length; i++) {
              var item = items[i];
              var mapped = instantiator(item, mapper);
              if (item !== mapped) {
                var result2 = i === 0 ? [] : items.slice(0, i);
                result2.push(mapped);
                for (i++; i < items.length; i++) {
                  result2.push(instantiator(items[i], mapper));
                }
                return result2;
              }
            }
          }
          return items;
        }
        function instantiateTypes(types2, mapper) {
          return instantiateList(types2, mapper, instantiateType);
        }
        function instantiateSignatures(signatures, mapper) {
          return instantiateList(signatures, mapper, instantiateSignature);
        }
        function instantiateIndexInfos(indexInfos, mapper) {
          return instantiateList(indexInfos, mapper, instantiateIndexInfo);
        }
        function createTypeMapper(sources, targets) {
          return sources.length === 1 ? makeUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) : makeArrayTypeMapper(sources, targets);
        }
        function getMappedType(type2, mapper) {
          switch (mapper.kind) {
            case 0:
              return type2 === mapper.source ? mapper.target : type2;
            case 1:
              var sources = mapper.sources;
              var targets = mapper.targets;
              for (var i = 0; i < sources.length; i++) {
                if (type2 === sources[i]) {
                  return targets ? targets[i] : anyType;
                }
              }
              return type2;
            case 2:
              return mapper.func(type2);
            case 3:
            case 4:
              var t1 = getMappedType(type2, mapper.mapper1);
              return t1 !== type2 && mapper.kind === 3 ? instantiateType(t1, mapper.mapper2) : getMappedType(t1, mapper.mapper2);
          }
        }
        function makeUnaryTypeMapper(source, target) {
          return { kind: 0, source, target };
        }
        function makeArrayTypeMapper(sources, targets) {
          return { kind: 1, sources, targets };
        }
        function makeFunctionTypeMapper(func) {
          return { kind: 2, func };
        }
        function makeCompositeTypeMapper(kind, mapper1, mapper2) {
          return { kind, mapper1, mapper2 };
        }
        function createTypeEraser(sources) {
          return createTypeMapper(sources, void 0);
        }
        function createBackreferenceMapper(context, index) {
          return makeFunctionTypeMapper(function(t) {
            return ts3.findIndex(context.inferences, function(info) {
              return info.typeParameter === t;
            }) >= index ? unknownType : t;
          });
        }
        function combineTypeMappers(mapper1, mapper2) {
          return mapper1 ? makeCompositeTypeMapper(3, mapper1, mapper2) : mapper2;
        }
        function mergeTypeMappers(mapper1, mapper2) {
          return mapper1 ? makeCompositeTypeMapper(4, mapper1, mapper2) : mapper2;
        }
        function prependTypeMapping(source, target, mapper) {
          return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(4, makeUnaryTypeMapper(source, target), mapper);
        }
        function appendTypeMapping(mapper, source, target) {
          return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(4, mapper, makeUnaryTypeMapper(source, target));
        }
        function getRestrictiveTypeParameter(tp) {
          return tp.constraint === unknownType ? tp : tp.restrictiveInstantiation || (tp.restrictiveInstantiation = createTypeParameter(tp.symbol), tp.restrictiveInstantiation.constraint = unknownType, tp.restrictiveInstantiation);
        }
        function cloneTypeParameter(typeParameter) {
          var result2 = createTypeParameter(typeParameter.symbol);
          result2.target = typeParameter;
          return result2;
        }
        function instantiateTypePredicate(predicate, mapper) {
          return createTypePredicate(predicate.kind, predicate.parameterName, predicate.parameterIndex, instantiateType(predicate.type, mapper));
        }
        function instantiateSignature(signature, mapper, eraseTypeParameters) {
          var freshTypeParameters;
          if (signature.typeParameters && !eraseTypeParameters) {
            freshTypeParameters = ts3.map(signature.typeParameters, cloneTypeParameter);
            mapper = combineTypeMappers(createTypeMapper(signature.typeParameters, freshTypeParameters), mapper);
            for (var _i = 0, freshTypeParameters_1 = freshTypeParameters; _i < freshTypeParameters_1.length; _i++) {
              var tp = freshTypeParameters_1[_i];
              tp.mapper = mapper;
            }
          }
          var result2 = createSignature(signature.declaration, freshTypeParameters, signature.thisParameter && instantiateSymbol(signature.thisParameter, mapper), instantiateList(signature.parameters, mapper, instantiateSymbol), void 0, void 0, signature.minArgumentCount, signature.flags & 39);
          result2.target = signature;
          result2.mapper = mapper;
          return result2;
        }
        function instantiateSymbol(symbol, mapper) {
          var links = getSymbolLinks(symbol);
          if (links.type && !couldContainTypeVariables(links.type)) {
            return symbol;
          }
          if (ts3.getCheckFlags(symbol) & 1) {
            symbol = links.target;
            mapper = combineTypeMappers(links.mapper, mapper);
          }
          var result2 = createSymbol(symbol.flags, symbol.escapedName, 1 | ts3.getCheckFlags(symbol) & (8 | 4096 | 16384 | 32768));
          result2.declarations = symbol.declarations;
          result2.parent = symbol.parent;
          result2.target = symbol;
          result2.mapper = mapper;
          if (symbol.valueDeclaration) {
            result2.valueDeclaration = symbol.valueDeclaration;
          }
          if (links.nameType) {
            result2.nameType = links.nameType;
          }
          return result2;
        }
        function getObjectTypeInstantiation(type2, mapper, aliasSymbol, aliasTypeArguments) {
          var declaration = type2.objectFlags & 4 ? type2.node : type2.objectFlags & 8388608 ? type2.node : type2.symbol.declarations[0];
          var links = getNodeLinks(declaration);
          var target = type2.objectFlags & 4 ? links.resolvedType : type2.objectFlags & 64 ? type2.target : type2;
          var typeParameters = links.outerTypeParameters;
          if (!typeParameters) {
            var outerTypeParameters = getOuterTypeParameters(declaration, true);
            if (isJSConstructor(declaration)) {
              var templateTagParameters = getTypeParametersFromDeclaration(declaration);
              outerTypeParameters = ts3.addRange(outerTypeParameters, templateTagParameters);
            }
            typeParameters = outerTypeParameters || ts3.emptyArray;
            var allDeclarations_1 = type2.objectFlags & (4 | 8388608) ? [declaration] : type2.symbol.declarations;
            typeParameters = (target.objectFlags & (4 | 8388608) || target.symbol.flags & 8192 || target.symbol.flags & 2048) && !target.aliasTypeArguments ? ts3.filter(typeParameters, function(tp) {
              return ts3.some(allDeclarations_1, function(d) {
                return isTypeParameterPossiblyReferenced(tp, d);
              });
            }) : typeParameters;
            links.outerTypeParameters = typeParameters;
          }
          if (typeParameters.length) {
            var combinedMapper_1 = combineTypeMappers(type2.mapper, mapper);
            var typeArguments = ts3.map(typeParameters, function(t) {
              return getMappedType(t, combinedMapper_1);
            });
            var newAliasSymbol = aliasSymbol || type2.aliasSymbol;
            var newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type2.aliasTypeArguments, mapper);
            var id = getTypeListId(typeArguments) + getAliasId(newAliasSymbol, newAliasTypeArguments);
            if (!target.instantiations) {
              target.instantiations = new ts3.Map();
              target.instantiations.set(getTypeListId(typeParameters) + getAliasId(target.aliasSymbol, target.aliasTypeArguments), target);
            }
            var result2 = target.instantiations.get(id);
            if (!result2) {
              var newMapper = createTypeMapper(typeParameters, typeArguments);
              result2 = target.objectFlags & 4 ? createDeferredTypeReference(type2.target, type2.node, newMapper, newAliasSymbol, newAliasTypeArguments) : target.objectFlags & 32 ? instantiateMappedType(target, newMapper, newAliasSymbol, newAliasTypeArguments) : instantiateAnonymousType(target, newMapper, newAliasSymbol, newAliasTypeArguments);
              target.instantiations.set(id, result2);
            }
            return result2;
          }
          return type2;
        }
        function maybeTypeParameterReference(node) {
          return !(node.parent.kind === 178 && node.parent.typeArguments && node === node.parent.typeName || node.parent.kind === 200 && node.parent.typeArguments && node === node.parent.qualifier);
        }
        function isTypeParameterPossiblyReferenced(tp, node) {
          if (tp.symbol && tp.symbol.declarations && tp.symbol.declarations.length === 1) {
            var container = tp.symbol.declarations[0].parent;
            for (var n = node; n !== container; n = n.parent) {
              if (!n || n.kind === 235 || n.kind === 189 && ts3.forEachChild(n.extendsType, containsReference)) {
                return true;
              }
            }
            return containsReference(node);
          }
          return true;
          function containsReference(node2) {
            switch (node2.kind) {
              case 192:
                return !!tp.isThisType;
              case 79:
                return !tp.isThisType && ts3.isPartOfTypeNode(node2) && maybeTypeParameterReference(node2) && getTypeFromTypeNodeWorker(node2) === tp;
              case 181:
                return true;
              case 169:
              case 168:
                return !node2.type && !!node2.body || ts3.some(node2.typeParameters, containsReference) || ts3.some(node2.parameters, containsReference) || !!node2.type && containsReference(node2.type);
            }
            return !!ts3.forEachChild(node2, containsReference);
          }
        }
        function getHomomorphicTypeVariable(type2) {
          var constraintType = getConstraintTypeFromMappedType(type2);
          if (constraintType.flags & 4194304) {
            var typeVariable = getActualTypeVariable(constraintType.type);
            if (typeVariable.flags & 262144) {
              return typeVariable;
            }
          }
          return void 0;
        }
        function instantiateMappedType(type2, mapper, aliasSymbol, aliasTypeArguments) {
          var typeVariable = getHomomorphicTypeVariable(type2);
          if (typeVariable) {
            var mappedTypeVariable = instantiateType(typeVariable, mapper);
            if (typeVariable !== mappedTypeVariable) {
              return mapTypeWithAlias(getReducedType(mappedTypeVariable), function(t) {
                if (t.flags & (3 | 58982400 | 524288 | 2097152) && t !== wildcardType && !isErrorType(t)) {
                  if (!type2.declaration.nameType) {
                    var constraint = void 0;
                    if (isArrayType(t) || t.flags & 1 && findResolutionCycleStartIndex(typeVariable, 4) < 0 && (constraint = getConstraintOfTypeParameter(typeVariable)) && everyType(constraint, isArrayOrTupleType)) {
                      return instantiateMappedArrayType(t, type2, prependTypeMapping(typeVariable, t, mapper));
                    }
                    if (isGenericTupleType(t)) {
                      return instantiateMappedGenericTupleType(t, type2, typeVariable, mapper);
                    }
                    if (isTupleType(t)) {
                      return instantiateMappedTupleType(t, type2, prependTypeMapping(typeVariable, t, mapper));
                    }
                  }
                  return instantiateAnonymousType(type2, prependTypeMapping(typeVariable, t, mapper));
                }
                return t;
              }, aliasSymbol, aliasTypeArguments);
            }
          }
          return instantiateType(getConstraintTypeFromMappedType(type2), mapper) === wildcardType ? wildcardType : instantiateAnonymousType(type2, mapper, aliasSymbol, aliasTypeArguments);
        }
        function getModifiedReadonlyState(state, modifiers) {
          return modifiers & 1 ? true : modifiers & 2 ? false : state;
        }
        function instantiateMappedGenericTupleType(tupleType, mappedType, typeVariable, mapper) {
          var elementFlags = tupleType.target.elementFlags;
          var elementTypes = ts3.map(getTypeArguments(tupleType), function(t, i) {
            var singleton = elementFlags[i] & 8 ? t : elementFlags[i] & 4 ? createArrayType(t) : createTupleType([t], [elementFlags[i]]);
            return instantiateMappedType(mappedType, prependTypeMapping(typeVariable, singleton, mapper));
          });
          var newReadonly = getModifiedReadonlyState(tupleType.target.readonly, getMappedTypeModifiers(mappedType));
          return createTupleType(elementTypes, ts3.map(elementTypes, function(_) {
            return 8;
          }), newReadonly);
        }
        function instantiateMappedArrayType(arrayType, mappedType, mapper) {
          var elementType = instantiateMappedTypeTemplate(mappedType, numberType, true, mapper);
          return isErrorType(elementType) ? errorType : createArrayType(elementType, getModifiedReadonlyState(isReadonlyArrayType(arrayType), getMappedTypeModifiers(mappedType)));
        }
        function instantiateMappedTupleType(tupleType, mappedType, mapper) {
          var elementFlags = tupleType.target.elementFlags;
          var elementTypes = ts3.map(getTypeArguments(tupleType), function(_, i) {
            return instantiateMappedTypeTemplate(mappedType, getStringLiteralType("" + i), !!(elementFlags[i] & 2), mapper);
          });
          var modifiers = getMappedTypeModifiers(mappedType);
          var newTupleModifiers = modifiers & 4 ? ts3.map(elementFlags, function(f) {
            return f & 1 ? 2 : f;
          }) : modifiers & 8 ? ts3.map(elementFlags, function(f) {
            return f & 2 ? 1 : f;
          }) : elementFlags;
          var newReadonly = getModifiedReadonlyState(tupleType.target.readonly, modifiers);
          return ts3.contains(elementTypes, errorType) ? errorType : createTupleType(elementTypes, newTupleModifiers, newReadonly, tupleType.target.labeledElementDeclarations);
        }
        function instantiateMappedTypeTemplate(type2, key, isOptional, mapper) {
          var templateMapper = appendTypeMapping(mapper, getTypeParameterFromMappedType(type2), key);
          var propType = instantiateType(getTemplateTypeFromMappedType(type2.target || type2), templateMapper);
          var modifiers = getMappedTypeModifiers(type2);
          return strictNullChecks && modifiers & 4 && !maybeTypeOfKind(propType, 32768 | 16384) ? getOptionalType(propType, true) : strictNullChecks && modifiers & 8 && isOptional ? getTypeWithFacts(propType, 524288) : propType;
        }
        function instantiateAnonymousType(type2, mapper, aliasSymbol, aliasTypeArguments) {
          var result2 = createObjectType(type2.objectFlags | 64, type2.symbol);
          if (type2.objectFlags & 32) {
            result2.declaration = type2.declaration;
            var origTypeParameter = getTypeParameterFromMappedType(type2);
            var freshTypeParameter = cloneTypeParameter(origTypeParameter);
            result2.typeParameter = freshTypeParameter;
            mapper = combineTypeMappers(makeUnaryTypeMapper(origTypeParameter, freshTypeParameter), mapper);
            freshTypeParameter.mapper = mapper;
          }
          if (type2.objectFlags & 8388608) {
            result2.node = type2.node;
          }
          result2.target = type2;
          result2.mapper = mapper;
          result2.aliasSymbol = aliasSymbol || type2.aliasSymbol;
          result2.aliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type2.aliasTypeArguments, mapper);
          return result2;
        }
        function getConditionalTypeInstantiation(type2, mapper, aliasSymbol, aliasTypeArguments) {
          var root = type2.root;
          if (root.outerTypeParameters) {
            var typeArguments = ts3.map(root.outerTypeParameters, function(t) {
              return getMappedType(t, mapper);
            });
            var id = getTypeListId(typeArguments) + getAliasId(aliasSymbol, aliasTypeArguments);
            var result2 = root.instantiations.get(id);
            if (!result2) {
              var newMapper_1 = createTypeMapper(root.outerTypeParameters, typeArguments);
              var checkType_1 = root.checkType;
              var distributionType = root.isDistributive ? getMappedType(checkType_1, newMapper_1) : void 0;
              result2 = distributionType && checkType_1 !== distributionType && distributionType.flags & (1048576 | 131072) ? mapTypeWithAlias(getReducedType(distributionType), function(t) {
                return getConditionalType(root, prependTypeMapping(checkType_1, t, newMapper_1));
              }, aliasSymbol, aliasTypeArguments) : getConditionalType(root, newMapper_1, aliasSymbol, aliasTypeArguments);
              root.instantiations.set(id, result2);
            }
            return result2;
          }
          return type2;
        }
        function instantiateType(type2, mapper) {
          return type2 && mapper ? instantiateTypeWithAlias(type2, mapper, void 0, void 0) : type2;
        }
        function instantiateTypeWithAlias(type2, mapper, aliasSymbol, aliasTypeArguments) {
          if (!couldContainTypeVariables(type2)) {
            return type2;
          }
          if (instantiationDepth === 100 || instantiationCount >= 5e6) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "instantiateType_DepthLimit", { typeId: type2.id, instantiationDepth, instantiationCount });
            error(currentNode, ts3.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
            return errorType;
          }
          totalInstantiationCount++;
          instantiationCount++;
          instantiationDepth++;
          var result2 = instantiateTypeWorker(type2, mapper, aliasSymbol, aliasTypeArguments);
          instantiationDepth--;
          return result2;
        }
        function instantiateTypeWorker(type2, mapper, aliasSymbol, aliasTypeArguments) {
          var flags = type2.flags;
          if (flags & 262144) {
            return getMappedType(type2, mapper);
          }
          if (flags & 524288) {
            var objectFlags = type2.objectFlags;
            if (objectFlags & (4 | 16 | 32)) {
              if (objectFlags & 4 && !type2.node) {
                var resolvedTypeArguments = type2.resolvedTypeArguments;
                var newTypeArguments = instantiateTypes(resolvedTypeArguments, mapper);
                return newTypeArguments !== resolvedTypeArguments ? createNormalizedTypeReference(type2.target, newTypeArguments) : type2;
              }
              if (objectFlags & 1024) {
                return instantiateReverseMappedType(type2, mapper);
              }
              return getObjectTypeInstantiation(type2, mapper, aliasSymbol, aliasTypeArguments);
            }
            return type2;
          }
          if (flags & 3145728) {
            var origin = type2.flags & 1048576 ? type2.origin : void 0;
            var types2 = origin && origin.flags & 3145728 ? origin.types : type2.types;
            var newTypes = instantiateTypes(types2, mapper);
            if (newTypes === types2 && aliasSymbol === type2.aliasSymbol) {
              return type2;
            }
            var newAliasSymbol = aliasSymbol || type2.aliasSymbol;
            var newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type2.aliasTypeArguments, mapper);
            return flags & 2097152 || origin && origin.flags & 2097152 ? getIntersectionType(newTypes, newAliasSymbol, newAliasTypeArguments) : getUnionType(newTypes, 1, newAliasSymbol, newAliasTypeArguments);
          }
          if (flags & 4194304) {
            return getIndexType(instantiateType(type2.type, mapper));
          }
          if (flags & 134217728) {
            return getTemplateLiteralType(type2.texts, instantiateTypes(type2.types, mapper));
          }
          if (flags & 268435456) {
            return getStringMappingType(type2.symbol, instantiateType(type2.type, mapper));
          }
          if (flags & 8388608) {
            var newAliasSymbol = aliasSymbol || type2.aliasSymbol;
            var newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type2.aliasTypeArguments, mapper);
            return getIndexedAccessType(instantiateType(type2.objectType, mapper), instantiateType(type2.indexType, mapper), type2.accessFlags, void 0, newAliasSymbol, newAliasTypeArguments);
          }
          if (flags & 16777216) {
            return getConditionalTypeInstantiation(type2, combineTypeMappers(type2.mapper, mapper), aliasSymbol, aliasTypeArguments);
          }
          if (flags & 33554432) {
            var maybeVariable = instantiateType(type2.baseType, mapper);
            if (maybeVariable.flags & 8650752) {
              return getSubstitutionType(maybeVariable, instantiateType(type2.substitute, mapper));
            } else {
              var sub = instantiateType(type2.substitute, mapper);
              if (sub.flags & 3 || isTypeAssignableTo(getRestrictiveInstantiation(maybeVariable), getRestrictiveInstantiation(sub))) {
                return maybeVariable;
              }
              return sub;
            }
          }
          return type2;
        }
        function instantiateReverseMappedType(type2, mapper) {
          var innerMappedType = instantiateType(type2.mappedType, mapper);
          if (!(ts3.getObjectFlags(innerMappedType) & 32)) {
            return type2;
          }
          var innerIndexType = instantiateType(type2.constraintType, mapper);
          if (!(innerIndexType.flags & 4194304)) {
            return type2;
          }
          var instantiated = inferTypeForHomomorphicMappedType(instantiateType(type2.source, mapper), innerMappedType, innerIndexType);
          if (instantiated) {
            return instantiated;
          }
          return type2;
        }
        function getUniqueLiteralFilledInstantiation(type2) {
          return type2.flags & (131068 | 3 | 131072) ? type2 : type2.uniqueLiteralFilledInstantiation || (type2.uniqueLiteralFilledInstantiation = instantiateType(type2, uniqueLiteralMapper));
        }
        function getPermissiveInstantiation(type2) {
          return type2.flags & (131068 | 3 | 131072) ? type2 : type2.permissiveInstantiation || (type2.permissiveInstantiation = instantiateType(type2, permissiveMapper));
        }
        function getRestrictiveInstantiation(type2) {
          if (type2.flags & (131068 | 3 | 131072)) {
            return type2;
          }
          if (type2.restrictiveInstantiation) {
            return type2.restrictiveInstantiation;
          }
          type2.restrictiveInstantiation = instantiateType(type2, restrictiveMapper);
          type2.restrictiveInstantiation.restrictiveInstantiation = type2.restrictiveInstantiation;
          return type2.restrictiveInstantiation;
        }
        function instantiateIndexInfo(info, mapper) {
          return createIndexInfo(info.keyType, instantiateType(info.type, mapper), info.isReadonly, info.declaration);
        }
        function isContextSensitive(node) {
          ts3.Debug.assert(node.kind !== 169 || ts3.isObjectLiteralMethod(node));
          switch (node.kind) {
            case 213:
            case 214:
            case 169:
            case 256:
              return isContextSensitiveFunctionLikeDeclaration(node);
            case 205:
              return ts3.some(node.properties, isContextSensitive);
            case 204:
              return ts3.some(node.elements, isContextSensitive);
            case 222:
              return isContextSensitive(node.whenTrue) || isContextSensitive(node.whenFalse);
            case 221:
              return (node.operatorToken.kind === 56 || node.operatorToken.kind === 60) && (isContextSensitive(node.left) || isContextSensitive(node.right));
            case 296:
              return isContextSensitive(node.initializer);
            case 212:
              return isContextSensitive(node.expression);
            case 286:
              return ts3.some(node.properties, isContextSensitive) || ts3.isJsxOpeningElement(node.parent) && ts3.some(node.parent.parent.children, isContextSensitive);
            case 285: {
              var initializer = node.initializer;
              return !!initializer && isContextSensitive(initializer);
            }
            case 288: {
              var expression = node.expression;
              return !!expression && isContextSensitive(expression);
            }
          }
          return false;
        }
        function isContextSensitiveFunctionLikeDeclaration(node) {
          return (!ts3.isFunctionDeclaration(node) || ts3.isInJSFile(node) && !!getTypeForDeclarationFromJSDocComment(node)) && (ts3.hasContextSensitiveParameters(node) || hasContextSensitiveReturnExpression(node));
        }
        function hasContextSensitiveReturnExpression(node) {
          return !node.typeParameters && !ts3.getEffectiveReturnTypeNode(node) && !!node.body && node.body.kind !== 235 && isContextSensitive(node.body);
        }
        function isContextSensitiveFunctionOrObjectLiteralMethod(func) {
          return (ts3.isInJSFile(func) && ts3.isFunctionDeclaration(func) || ts3.isFunctionExpressionOrArrowFunction(func) || ts3.isObjectLiteralMethod(func)) && isContextSensitiveFunctionLikeDeclaration(func);
        }
        function getTypeWithoutSignatures(type2) {
          if (type2.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type2);
            if (resolved.constructSignatures.length || resolved.callSignatures.length) {
              var result2 = createObjectType(16, type2.symbol);
              result2.members = resolved.members;
              result2.properties = resolved.properties;
              result2.callSignatures = ts3.emptyArray;
              result2.constructSignatures = ts3.emptyArray;
              result2.indexInfos = ts3.emptyArray;
              return result2;
            }
          } else if (type2.flags & 2097152) {
            return getIntersectionType(ts3.map(type2.types, getTypeWithoutSignatures));
          }
          return type2;
        }
        function isTypeIdenticalTo(source, target) {
          return isTypeRelatedTo(source, target, identityRelation);
        }
        function compareTypesIdentical(source, target) {
          return isTypeRelatedTo(source, target, identityRelation) ? -1 : 0;
        }
        function compareTypesAssignable(source, target) {
          return isTypeRelatedTo(source, target, assignableRelation) ? -1 : 0;
        }
        function compareTypesSubtypeOf(source, target) {
          return isTypeRelatedTo(source, target, subtypeRelation) ? -1 : 0;
        }
        function isTypeSubtypeOf(source, target) {
          return isTypeRelatedTo(source, target, subtypeRelation);
        }
        function isTypeAssignableTo(source, target) {
          return isTypeRelatedTo(source, target, assignableRelation);
        }
        function isTypeDerivedFrom(source, target) {
          return source.flags & 1048576 ? ts3.every(source.types, function(t) {
            return isTypeDerivedFrom(t, target);
          }) : target.flags & 1048576 ? ts3.some(target.types, function(t) {
            return isTypeDerivedFrom(source, t);
          }) : source.flags & 58982400 ? isTypeDerivedFrom(getBaseConstraintOfType(source) || unknownType, target) : target === globalObjectType ? !!(source.flags & (524288 | 67108864)) : target === globalFunctionType ? !!(source.flags & 524288) && isFunctionObjectType(source) : hasBaseType(source, getTargetType(target)) || isArrayType(target) && !isReadonlyArrayType(target) && isTypeDerivedFrom(source, globalReadonlyArrayType);
        }
        function isTypeComparableTo(source, target) {
          return isTypeRelatedTo(source, target, comparableRelation);
        }
        function areTypesComparable(type1, type2) {
          return isTypeComparableTo(type1, type2) || isTypeComparableTo(type2, type1);
        }
        function checkTypeAssignableTo(source, target, errorNode, headMessage, containingMessageChain, errorOutputObject) {
          return checkTypeRelatedTo(source, target, assignableRelation, errorNode, headMessage, containingMessageChain, errorOutputObject);
        }
        function checkTypeAssignableToAndOptionallyElaborate(source, target, errorNode, expr, headMessage, containingMessageChain) {
          return checkTypeRelatedToAndOptionallyElaborate(source, target, assignableRelation, errorNode, expr, headMessage, containingMessageChain, void 0);
        }
        function checkTypeRelatedToAndOptionallyElaborate(source, target, relation, errorNode, expr, headMessage, containingMessageChain, errorOutputContainer) {
          if (isTypeRelatedTo(source, target, relation))
            return true;
          if (!errorNode || !elaborateError(expr, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
            return checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer);
          }
          return false;
        }
        function isOrHasGenericConditional(type2) {
          return !!(type2.flags & 16777216 || type2.flags & 2097152 && ts3.some(type2.types, isOrHasGenericConditional));
        }
        function elaborateError(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
          if (!node || isOrHasGenericConditional(target))
            return false;
          if (!checkTypeRelatedTo(source, target, relation, void 0) && elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
            return true;
          }
          switch (node.kind) {
            case 288:
            case 212:
              return elaborateError(node.expression, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
            case 221:
              switch (node.operatorToken.kind) {
                case 63:
                case 27:
                  return elaborateError(node.right, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
              }
              break;
            case 205:
              return elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 204:
              return elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 286:
              return elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 214:
              return elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer);
          }
          return false;
        }
        function elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
          var callSignatures = getSignaturesOfType(source, 0);
          var constructSignatures = getSignaturesOfType(source, 1);
          for (var _i = 0, _a = [constructSignatures, callSignatures]; _i < _a.length; _i++) {
            var signatures = _a[_i];
            if (ts3.some(signatures, function(s) {
              var returnType = getReturnTypeOfSignature(s);
              return !(returnType.flags & (1 | 131072)) && checkTypeRelatedTo(returnType, target, relation, void 0);
            })) {
              var resultObj = errorOutputContainer || {};
              checkTypeAssignableTo(source, target, node, headMessage, containingMessageChain, resultObj);
              var diagnostic = resultObj.errors[resultObj.errors.length - 1];
              ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(node, signatures === constructSignatures ? ts3.Diagnostics.Did_you_mean_to_use_new_with_this_expression : ts3.Diagnostics.Did_you_mean_to_call_this_expression));
              return true;
            }
          }
          return false;
        }
        function elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (ts3.isBlock(node.body)) {
            return false;
          }
          if (ts3.some(node.parameters, ts3.hasType)) {
            return false;
          }
          var sourceSig = getSingleCallSignature(source);
          if (!sourceSig) {
            return false;
          }
          var targetSignatures = getSignaturesOfType(target, 0);
          if (!ts3.length(targetSignatures)) {
            return false;
          }
          var returnExpression = node.body;
          var sourceReturn = getReturnTypeOfSignature(sourceSig);
          var targetReturn = getUnionType(ts3.map(targetSignatures, getReturnTypeOfSignature));
          if (!checkTypeRelatedTo(sourceReturn, targetReturn, relation, void 0)) {
            var elaborated = returnExpression && elaborateError(returnExpression, sourceReturn, targetReturn, relation, void 0, containingMessageChain, errorOutputContainer);
            if (elaborated) {
              return elaborated;
            }
            var resultObj = errorOutputContainer || {};
            checkTypeRelatedTo(sourceReturn, targetReturn, relation, returnExpression, void 0, containingMessageChain, resultObj);
            if (resultObj.errors) {
              if (target.symbol && ts3.length(target.symbol.declarations)) {
                ts3.addRelatedInfo(resultObj.errors[resultObj.errors.length - 1], ts3.createDiagnosticForNode(target.symbol.declarations[0], ts3.Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature));
              }
              if ((ts3.getFunctionFlags(node) & 2) === 0 && !getTypeOfPropertyOfType(sourceReturn, "then") && checkTypeRelatedTo(createPromiseType(sourceReturn), targetReturn, relation, void 0)) {
                ts3.addRelatedInfo(resultObj.errors[resultObj.errors.length - 1], ts3.createDiagnosticForNode(node, ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async));
              }
              return true;
            }
          }
          return false;
        }
        function getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType) {
          var idx2 = getIndexedAccessTypeOrUndefined(target, nameType);
          if (idx2) {
            return idx2;
          }
          if (target.flags & 1048576) {
            var best = getBestMatchingType(source, target);
            if (best) {
              return getIndexedAccessTypeOrUndefined(best, nameType);
            }
          }
        }
        function checkExpressionForMutableLocationWithContextualType(next, sourcePropType) {
          next.contextualType = sourcePropType;
          try {
            return checkExpressionForMutableLocation(next, 1, sourcePropType);
          } finally {
            next.contextualType = void 0;
          }
        }
        function elaborateElementwise(iterator, source, target, relation, containingMessageChain, errorOutputContainer) {
          var reportedError = false;
          for (var status = iterator.next(); !status.done; status = iterator.next()) {
            var _a = status.value, prop = _a.errorNode, next = _a.innerExpression, nameType = _a.nameType, errorMessage = _a.errorMessage;
            var targetPropType = getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType);
            if (!targetPropType || targetPropType.flags & 8388608)
              continue;
            var sourcePropType = getIndexedAccessTypeOrUndefined(source, nameType);
            if (!sourcePropType)
              continue;
            var propName = getPropertyNameFromIndex(nameType, void 0);
            if (!checkTypeRelatedTo(sourcePropType, targetPropType, relation, void 0)) {
              var elaborated = next && elaborateError(next, sourcePropType, targetPropType, relation, void 0, containingMessageChain, errorOutputContainer);
              reportedError = true;
              if (!elaborated) {
                var resultObj = errorOutputContainer || {};
                var specificSource = next ? checkExpressionForMutableLocationWithContextualType(next, sourcePropType) : sourcePropType;
                if (exactOptionalPropertyTypes && isExactOptionalPropertyMismatch(specificSource, targetPropType)) {
                  var diag = ts3.createDiagnosticForNode(prop, ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target, typeToString(specificSource), typeToString(targetPropType));
                  diagnostics.add(diag);
                  resultObj.errors = [diag];
                } else {
                  var targetIsOptional = !!(propName && (getPropertyOfType(target, propName) || unknownSymbol).flags & 16777216);
                  var sourceIsOptional = !!(propName && (getPropertyOfType(source, propName) || unknownSymbol).flags & 16777216);
                  targetPropType = removeMissingType(targetPropType, targetIsOptional);
                  sourcePropType = removeMissingType(sourcePropType, targetIsOptional && sourceIsOptional);
                  var result2 = checkTypeRelatedTo(specificSource, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
                  if (result2 && specificSource !== sourcePropType) {
                    checkTypeRelatedTo(sourcePropType, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
                  }
                }
                if (resultObj.errors) {
                  var reportedDiag = resultObj.errors[resultObj.errors.length - 1];
                  var propertyName = isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
                  var targetProp = propertyName !== void 0 ? getPropertyOfType(target, propertyName) : void 0;
                  var issuedElaboration = false;
                  if (!targetProp) {
                    var indexInfo = getApplicableIndexInfo(target, nameType);
                    if (indexInfo && indexInfo.declaration && !ts3.getSourceFileOfNode(indexInfo.declaration).hasNoDefaultLib) {
                      issuedElaboration = true;
                      ts3.addRelatedInfo(reportedDiag, ts3.createDiagnosticForNode(indexInfo.declaration, ts3.Diagnostics.The_expected_type_comes_from_this_index_signature));
                    }
                  }
                  if (!issuedElaboration && (targetProp && ts3.length(targetProp.declarations) || target.symbol && ts3.length(target.symbol.declarations))) {
                    var targetNode = targetProp && ts3.length(targetProp.declarations) ? targetProp.declarations[0] : target.symbol.declarations[0];
                    if (!ts3.getSourceFileOfNode(targetNode).hasNoDefaultLib) {
                      ts3.addRelatedInfo(reportedDiag, ts3.createDiagnosticForNode(targetNode, ts3.Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1, propertyName && !(nameType.flags & 8192) ? ts3.unescapeLeadingUnderscores(propertyName) : typeToString(nameType), typeToString(target)));
                    }
                  }
                }
              }
            }
          }
          return reportedError;
        }
        function generateJsxAttributes(node) {
          var _i, _a, prop;
          return __generator(this, function(_b) {
            switch (_b.label) {
              case 0:
                if (!ts3.length(node.properties))
                  return [2];
                _i = 0, _a = node.properties;
                _b.label = 1;
              case 1:
                if (!(_i < _a.length))
                  return [3, 4];
                prop = _a[_i];
                if (ts3.isJsxSpreadAttribute(prop) || isHyphenatedJsxName(ts3.idText(prop.name)))
                  return [3, 3];
                return [4, { errorNode: prop.name, innerExpression: prop.initializer, nameType: getStringLiteralType(ts3.idText(prop.name)) }];
              case 2:
                _b.sent();
                _b.label = 3;
              case 3:
                _i++;
                return [3, 1];
              case 4:
                return [2];
            }
          });
        }
        function generateJsxChildren(node, getInvalidTextDiagnostic) {
          var memberOffset, i, child, nameType, elem;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                if (!ts3.length(node.children))
                  return [2];
                memberOffset = 0;
                i = 0;
                _a.label = 1;
              case 1:
                if (!(i < node.children.length))
                  return [3, 5];
                child = node.children[i];
                nameType = getNumberLiteralType(i - memberOffset);
                elem = getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic);
                if (!elem)
                  return [3, 3];
                return [4, elem];
              case 2:
                _a.sent();
                return [3, 4];
              case 3:
                memberOffset++;
                _a.label = 4;
              case 4:
                i++;
                return [3, 1];
              case 5:
                return [2];
            }
          });
        }
        function getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic) {
          switch (child.kind) {
            case 288:
              return { errorNode: child, innerExpression: child.expression, nameType };
            case 11:
              if (child.containsOnlyTriviaWhiteSpaces) {
                break;
              }
              return { errorNode: child, innerExpression: void 0, nameType, errorMessage: getInvalidTextDiagnostic() };
            case 278:
            case 279:
            case 282:
              return { errorNode: child, innerExpression: child, nameType };
            default:
              return ts3.Debug.assertNever(child, "Found invalid jsx child");
          }
        }
        function elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          var result2 = elaborateElementwise(generateJsxAttributes(node), source, target, relation, containingMessageChain, errorOutputContainer);
          var invalidTextDiagnostic;
          if (ts3.isJsxOpeningElement(node.parent) && ts3.isJsxElement(node.parent.parent)) {
            var containingElement = node.parent.parent;
            var childPropName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
            var childrenPropName = childPropName === void 0 ? "children" : ts3.unescapeLeadingUnderscores(childPropName);
            var childrenNameType = getStringLiteralType(childrenPropName);
            var childrenTargetType = getIndexedAccessType(target, childrenNameType);
            var validChildren = ts3.getSemanticJsxChildren(containingElement.children);
            if (!ts3.length(validChildren)) {
              return result2;
            }
            var moreThanOneRealChildren = ts3.length(validChildren) > 1;
            var arrayLikeTargetParts = filterType(childrenTargetType, isArrayOrTupleLikeType);
            var nonArrayLikeTargetParts = filterType(childrenTargetType, function(t) {
              return !isArrayOrTupleLikeType(t);
            });
            if (moreThanOneRealChildren) {
              if (arrayLikeTargetParts !== neverType) {
                var realSource = createTupleType(checkJsxChildren(containingElement, 0));
                var children = generateJsxChildren(containingElement, getInvalidTextualChildDiagnostic);
                result2 = elaborateElementwise(children, realSource, arrayLikeTargetParts, relation, containingMessageChain, errorOutputContainer) || result2;
              } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
                result2 = true;
                var diag = error(containingElement.openingElement.tagName, ts3.Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided, childrenPropName, typeToString(childrenTargetType));
                if (errorOutputContainer && errorOutputContainer.skipLogging) {
                  (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
                }
              }
            } else {
              if (nonArrayLikeTargetParts !== neverType) {
                var child = validChildren[0];
                var elem_1 = getElaborationElementForJsxChild(child, childrenNameType, getInvalidTextualChildDiagnostic);
                if (elem_1) {
                  result2 = elaborateElementwise(function() {
                    return __generator(this, function(_a) {
                      switch (_a.label) {
                        case 0:
                          return [4, elem_1];
                        case 1:
                          _a.sent();
                          return [2];
                      }
                    });
                  }(), source, target, relation, containingMessageChain, errorOutputContainer) || result2;
                }
              } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
                result2 = true;
                var diag = error(containingElement.openingElement.tagName, ts3.Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided, childrenPropName, typeToString(childrenTargetType));
                if (errorOutputContainer && errorOutputContainer.skipLogging) {
                  (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
                }
              }
            }
          }
          return result2;
          function getInvalidTextualChildDiagnostic() {
            if (!invalidTextDiagnostic) {
              var tagNameText = ts3.getTextOfNode(node.parent.tagName);
              var childPropName2 = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
              var childrenPropName2 = childPropName2 === void 0 ? "children" : ts3.unescapeLeadingUnderscores(childPropName2);
              var childrenTargetType2 = getIndexedAccessType(target, getStringLiteralType(childrenPropName2));
              var diagnostic = ts3.Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;
              invalidTextDiagnostic = __assign(__assign({}, diagnostic), { key: "!!ALREADY FORMATTED!!", message: ts3.formatMessage(void 0, diagnostic, tagNameText, childrenPropName2, typeToString(childrenTargetType2)) });
            }
            return invalidTextDiagnostic;
          }
        }
        function generateLimitedTupleElements(node, target) {
          var len, i, elem, nameType;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                len = ts3.length(node.elements);
                if (!len)
                  return [2];
                i = 0;
                _a.label = 1;
              case 1:
                if (!(i < len))
                  return [3, 4];
                if (isTupleLikeType(target) && !getPropertyOfType(target, "" + i))
                  return [3, 3];
                elem = node.elements[i];
                if (ts3.isOmittedExpression(elem))
                  return [3, 3];
                nameType = getNumberLiteralType(i);
                return [4, { errorNode: elem, innerExpression: elem, nameType }];
              case 2:
                _a.sent();
                _a.label = 3;
              case 3:
                i++;
                return [3, 1];
              case 4:
                return [2];
            }
          });
        }
        function elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (target.flags & 131068)
            return false;
          if (isTupleLikeType(source)) {
            return elaborateElementwise(generateLimitedTupleElements(node, target), source, target, relation, containingMessageChain, errorOutputContainer);
          }
          var oldContext = node.contextualType;
          node.contextualType = target;
          try {
            var tupleizedType = checkArrayLiteral(node, 1, true);
            node.contextualType = oldContext;
            if (isTupleLikeType(tupleizedType)) {
              return elaborateElementwise(generateLimitedTupleElements(node, target), tupleizedType, target, relation, containingMessageChain, errorOutputContainer);
            }
            return false;
          } finally {
            node.contextualType = oldContext;
          }
        }
        function generateObjectLiteralElements(node) {
          var _i, _a, prop, type2, _b;
          return __generator(this, function(_c) {
            switch (_c.label) {
              case 0:
                if (!ts3.length(node.properties))
                  return [2];
                _i = 0, _a = node.properties;
                _c.label = 1;
              case 1:
                if (!(_i < _a.length))
                  return [3, 8];
                prop = _a[_i];
                if (ts3.isSpreadAssignment(prop))
                  return [3, 7];
                type2 = getLiteralTypeFromProperty(getSymbolOfNode(prop), 8576);
                if (!type2 || type2.flags & 131072) {
                  return [3, 7];
                }
                _b = prop.kind;
                switch (_b) {
                  case 173:
                    return [3, 2];
                  case 172:
                    return [3, 2];
                  case 169:
                    return [3, 2];
                  case 297:
                    return [3, 2];
                  case 296:
                    return [3, 4];
                }
                return [3, 6];
              case 2:
                return [4, { errorNode: prop.name, innerExpression: void 0, nameType: type2 }];
              case 3:
                _c.sent();
                return [3, 7];
              case 4:
                return [4, { errorNode: prop.name, innerExpression: prop.initializer, nameType: type2, errorMessage: ts3.isComputedNonLiteralName(prop.name) ? ts3.Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1 : void 0 }];
              case 5:
                _c.sent();
                return [3, 7];
              case 6:
                ts3.Debug.assertNever(prop);
                _c.label = 7;
              case 7:
                _i++;
                return [3, 1];
              case 8:
                return [2];
            }
          });
        }
        function elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (target.flags & 131068)
            return false;
          return elaborateElementwise(generateObjectLiteralElements(node), source, target, relation, containingMessageChain, errorOutputContainer);
        }
        function checkTypeComparableTo(source, target, errorNode, headMessage, containingMessageChain) {
          return checkTypeRelatedTo(source, target, comparableRelation, errorNode, headMessage, containingMessageChain);
        }
        function isSignatureAssignableTo(source, target, ignoreReturnTypes) {
          return compareSignaturesRelated(source, target, ignoreReturnTypes ? 4 : 0, false, void 0, void 0, compareTypesAssignable, void 0) !== 0;
        }
        function isAnySignature(s) {
          return !s.typeParameters && (!s.thisParameter || isTypeAny(getTypeOfParameter(s.thisParameter))) && s.parameters.length === 1 && signatureHasRestParameter(s) && (getTypeOfParameter(s.parameters[0]) === anyArrayType || isTypeAny(getTypeOfParameter(s.parameters[0]))) && isTypeAny(getReturnTypeOfSignature(s));
        }
        function compareSignaturesRelated(source, target, checkMode, reportErrors, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) {
          if (source === target) {
            return -1;
          }
          if (isAnySignature(target)) {
            return -1;
          }
          var targetCount = getParameterCount(target);
          var sourceHasMoreParameters = !hasEffectiveRestParameter(target) && (checkMode & 8 ? hasEffectiveRestParameter(source) || getParameterCount(source) > targetCount : getMinArgumentCount(source) > targetCount);
          if (sourceHasMoreParameters) {
            return 0;
          }
          if (source.typeParameters && source.typeParameters !== target.typeParameters) {
            target = getCanonicalSignature(target);
            source = instantiateSignatureInContextOf(source, target, void 0, compareTypes);
          }
          var sourceCount = getParameterCount(source);
          var sourceRestType = getNonArrayRestType(source);
          var targetRestType = getNonArrayRestType(target);
          if (sourceRestType || targetRestType) {
            void instantiateType(sourceRestType || targetRestType, reportUnreliableMarkers);
          }
          var kind = target.declaration ? target.declaration.kind : 0;
          var strictVariance = !(checkMode & 3) && strictFunctionTypes && kind !== 169 && kind !== 168 && kind !== 171;
          var result2 = -1;
          var sourceThisType = getThisTypeOfSignature(source);
          if (sourceThisType && sourceThisType !== voidType) {
            var targetThisType = getThisTypeOfSignature(target);
            if (targetThisType) {
              var related = !strictVariance && compareTypes(sourceThisType, targetThisType, false) || compareTypes(targetThisType, sourceThisType, reportErrors);
              if (!related) {
                if (reportErrors) {
                  errorReporter(ts3.Diagnostics.The_this_types_of_each_signature_are_incompatible);
                }
                return 0;
              }
              result2 &= related;
            }
          }
          var paramCount = sourceRestType || targetRestType ? Math.min(sourceCount, targetCount) : Math.max(sourceCount, targetCount);
          var restIndex = sourceRestType || targetRestType ? paramCount - 1 : -1;
          for (var i = 0; i < paramCount; i++) {
            var sourceType = i === restIndex ? getRestTypeAtPosition(source, i) : tryGetTypeAtPosition(source, i);
            var targetType = i === restIndex ? getRestTypeAtPosition(target, i) : tryGetTypeAtPosition(target, i);
            if (sourceType && targetType) {
              var sourceSig = checkMode & 3 ? void 0 : getSingleCallSignature(getNonNullableType(sourceType));
              var targetSig = checkMode & 3 ? void 0 : getSingleCallSignature(getNonNullableType(targetType));
              var callbacks = sourceSig && targetSig && !getTypePredicateOfSignature(sourceSig) && !getTypePredicateOfSignature(targetSig) && (getFalsyFlags(sourceType) & 98304) === (getFalsyFlags(targetType) & 98304);
              var related = callbacks ? compareSignaturesRelated(targetSig, sourceSig, checkMode & 8 | (strictVariance ? 2 : 1), reportErrors, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) : !(checkMode & 3) && !strictVariance && compareTypes(sourceType, targetType, false) || compareTypes(targetType, sourceType, reportErrors);
              if (related && checkMode & 8 && i >= getMinArgumentCount(source) && i < getMinArgumentCount(target) && compareTypes(sourceType, targetType, false)) {
                related = 0;
              }
              if (!related) {
                if (reportErrors) {
                  errorReporter(ts3.Diagnostics.Types_of_parameters_0_and_1_are_incompatible, ts3.unescapeLeadingUnderscores(getParameterNameAtPosition(source, i)), ts3.unescapeLeadingUnderscores(getParameterNameAtPosition(target, i)));
                }
                return 0;
              }
              result2 &= related;
            }
          }
          if (!(checkMode & 4)) {
            var targetReturnType = isResolvingReturnTypeOfSignature(target) ? anyType : target.declaration && isJSConstructor(target.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(target.declaration.symbol)) : getReturnTypeOfSignature(target);
            if (targetReturnType === voidType || targetReturnType === anyType) {
              return result2;
            }
            var sourceReturnType = isResolvingReturnTypeOfSignature(source) ? anyType : source.declaration && isJSConstructor(source.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(source.declaration.symbol)) : getReturnTypeOfSignature(source);
            var targetTypePredicate = getTypePredicateOfSignature(target);
            if (targetTypePredicate) {
              var sourceTypePredicate = getTypePredicateOfSignature(source);
              if (sourceTypePredicate) {
                result2 &= compareTypePredicateRelatedTo(sourceTypePredicate, targetTypePredicate, reportErrors, errorReporter, compareTypes);
              } else if (ts3.isIdentifierTypePredicate(targetTypePredicate)) {
                if (reportErrors) {
                  errorReporter(ts3.Diagnostics.Signature_0_must_be_a_type_predicate, signatureToString(source));
                }
                return 0;
              }
            } else {
              result2 &= checkMode & 1 && compareTypes(targetReturnType, sourceReturnType, false) || compareTypes(sourceReturnType, targetReturnType, reportErrors);
              if (!result2 && reportErrors && incompatibleErrorReporter) {
                incompatibleErrorReporter(sourceReturnType, targetReturnType);
              }
            }
          }
          return result2;
        }
        function compareTypePredicateRelatedTo(source, target, reportErrors, errorReporter, compareTypes) {
          if (source.kind !== target.kind) {
            if (reportErrors) {
              errorReporter(ts3.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard);
              errorReporter(ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
            }
            return 0;
          }
          if (source.kind === 1 || source.kind === 3) {
            if (source.parameterIndex !== target.parameterIndex) {
              if (reportErrors) {
                errorReporter(ts3.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1, source.parameterName, target.parameterName);
                errorReporter(ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
              }
              return 0;
            }
          }
          var related = source.type === target.type ? -1 : source.type && target.type ? compareTypes(source.type, target.type, reportErrors) : 0;
          if (related === 0 && reportErrors) {
            errorReporter(ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
          }
          return related;
        }
        function isImplementationCompatibleWithOverload(implementation, overload) {
          var erasedSource = getErasedSignature(implementation);
          var erasedTarget = getErasedSignature(overload);
          var sourceReturnType = getReturnTypeOfSignature(erasedSource);
          var targetReturnType = getReturnTypeOfSignature(erasedTarget);
          if (targetReturnType === voidType || isTypeRelatedTo(targetReturnType, sourceReturnType, assignableRelation) || isTypeRelatedTo(sourceReturnType, targetReturnType, assignableRelation)) {
            return isSignatureAssignableTo(erasedSource, erasedTarget, true);
          }
          return false;
        }
        function isEmptyResolvedType(t) {
          return t !== anyFunctionType && t.properties.length === 0 && t.callSignatures.length === 0 && t.constructSignatures.length === 0 && t.indexInfos.length === 0;
        }
        function isEmptyObjectType(type2) {
          return type2.flags & 524288 ? !isGenericMappedType(type2) && isEmptyResolvedType(resolveStructuredTypeMembers(type2)) : type2.flags & 67108864 ? true : type2.flags & 1048576 ? ts3.some(type2.types, isEmptyObjectType) : type2.flags & 2097152 ? ts3.every(type2.types, isEmptyObjectType) : false;
        }
        function isEmptyAnonymousObjectType(type2) {
          return !!(ts3.getObjectFlags(type2) & 16 && (type2.members && isEmptyResolvedType(type2) || type2.symbol && type2.symbol.flags & 2048 && getMembersOfSymbol(type2.symbol).size === 0));
        }
        function isStringIndexSignatureOnlyType(type2) {
          return type2.flags & 524288 && !isGenericMappedType(type2) && getPropertiesOfType(type2).length === 0 && getIndexInfosOfType(type2).length === 1 && !!getIndexInfoOfType(type2, stringType) || type2.flags & 3145728 && ts3.every(type2.types, isStringIndexSignatureOnlyType) || false;
        }
        function isEnumTypeRelatedTo(sourceSymbol, targetSymbol, errorReporter) {
          if (sourceSymbol === targetSymbol) {
            return true;
          }
          var id = getSymbolId(sourceSymbol) + "," + getSymbolId(targetSymbol);
          var entry = enumRelation.get(id);
          if (entry !== void 0 && !(!(entry & 4) && entry & 2 && errorReporter)) {
            return !!(entry & 1);
          }
          if (sourceSymbol.escapedName !== targetSymbol.escapedName || !(sourceSymbol.flags & 256) || !(targetSymbol.flags & 256)) {
            enumRelation.set(id, 2 | 4);
            return false;
          }
          var targetEnumType = getTypeOfSymbol(targetSymbol);
          for (var _i = 0, _a = getPropertiesOfType(getTypeOfSymbol(sourceSymbol)); _i < _a.length; _i++) {
            var property = _a[_i];
            if (property.flags & 8) {
              var targetProperty = getPropertyOfType(targetEnumType, property.escapedName);
              if (!targetProperty || !(targetProperty.flags & 8)) {
                if (errorReporter) {
                  errorReporter(ts3.Diagnostics.Property_0_is_missing_in_type_1, ts3.symbolName(property), typeToString(getDeclaredTypeOfSymbol(targetSymbol), void 0, 64));
                  enumRelation.set(id, 2 | 4);
                } else {
                  enumRelation.set(id, 2);
                }
                return false;
              }
            }
          }
          enumRelation.set(id, 1);
          return true;
        }
        function isSimpleTypeRelatedTo(source, target, relation, errorReporter) {
          var s = source.flags;
          var t = target.flags;
          if (t & 3 || s & 131072 || source === wildcardType)
            return true;
          if (t & 131072)
            return false;
          if (s & 402653316 && t & 4)
            return true;
          if (s & 128 && s & 1024 && t & 128 && !(t & 1024) && source.value === target.value)
            return true;
          if (s & 296 && t & 8)
            return true;
          if (s & 256 && s & 1024 && t & 256 && !(t & 1024) && source.value === target.value)
            return true;
          if (s & 2112 && t & 64)
            return true;
          if (s & 528 && t & 16)
            return true;
          if (s & 12288 && t & 4096)
            return true;
          if (s & 32 && t & 32 && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
            return true;
          if (s & 1024 && t & 1024) {
            if (s & 1048576 && t & 1048576 && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
              return true;
            if (s & 2944 && t & 2944 && source.value === target.value && isEnumTypeRelatedTo(getParentOfSymbol(source.symbol), getParentOfSymbol(target.symbol), errorReporter))
              return true;
          }
          if (s & 32768 && (!strictNullChecks && !(t & 3145728) || t & (32768 | 16384)))
            return true;
          if (s & 65536 && (!strictNullChecks && !(t & 3145728) || t & 65536))
            return true;
          if (s & 524288 && t & 67108864)
            return true;
          if (relation === assignableRelation || relation === comparableRelation) {
            if (s & 1)
              return true;
            if (s & (8 | 256) && !(s & 1024) && (t & 32 || relation === assignableRelation && t & 256 && t & 1024))
              return true;
          }
          return false;
        }
        function isTypeRelatedTo(source, target, relation) {
          if (isFreshLiteralType(source)) {
            source = source.regularType;
          }
          if (isFreshLiteralType(target)) {
            target = target.regularType;
          }
          if (source === target) {
            return true;
          }
          if (relation !== identityRelation) {
            if (relation === comparableRelation && !(target.flags & 131072) && isSimpleTypeRelatedTo(target, source, relation) || isSimpleTypeRelatedTo(source, target, relation)) {
              return true;
            }
          } else if (!((source.flags | target.flags) & (3145728 | 8388608 | 16777216 | 33554432))) {
            if (source.flags !== target.flags)
              return false;
            if (source.flags & 67358815)
              return true;
          }
          if (source.flags & 524288 && target.flags & 524288) {
            var related = relation.get(getRelationKey(source, target, 0, relation, false));
            if (related !== void 0) {
              return !!(related & 1);
            }
          }
          if (source.flags & 469499904 || target.flags & 469499904) {
            return checkTypeRelatedTo(source, target, relation, void 0);
          }
          return false;
        }
        function isIgnoredJsxProperty(source, sourceProp) {
          return ts3.getObjectFlags(source) & 2048 && isHyphenatedJsxName(sourceProp.escapedName);
        }
        function getNormalizedType(type2, writing) {
          while (true) {
            var t = isFreshLiteralType(type2) ? type2.regularType : ts3.getObjectFlags(type2) & 4 && type2.node ? createTypeReference(type2.target, getTypeArguments(type2)) : type2.flags & 3145728 ? getReducedType(type2) : type2.flags & 33554432 ? writing ? type2.baseType : type2.substitute : type2.flags & 25165824 ? getSimplifiedType(type2, writing) : type2;
            t = getSingleBaseForNonAugmentingSubtype(t) || t;
            if (t === type2)
              break;
            type2 = t;
          }
          return type2;
        }
        function checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer) {
          var errorInfo;
          var relatedInfo;
          var maybeKeys;
          var sourceStack;
          var targetStack;
          var maybeCount = 0;
          var sourceDepth = 0;
          var targetDepth = 0;
          var expandingFlags = 0;
          var overflow = false;
          var overrideNextErrorInfo = 0;
          var lastSkippedInfo;
          var incompatibleStack;
          var inPropertyCheck = false;
          ts3.Debug.assert(relation !== identityRelation || !errorNode, "no error reporting in identity checking");
          var result2 = isRelatedTo(source, target, 3, !!errorNode, headMessage);
          if (incompatibleStack) {
            reportIncompatibleStack();
          }
          if (overflow) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "checkTypeRelatedTo_DepthLimit", { sourceId: source.id, targetId: target.id, depth: sourceDepth, targetDepth });
            var diag = error(errorNode || currentNode, ts3.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1, typeToString(source), typeToString(target));
            if (errorOutputContainer) {
              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
            }
          } else if (errorInfo) {
            if (containingMessageChain) {
              var chain = containingMessageChain();
              if (chain) {
                ts3.concatenateDiagnosticMessageChains(chain, errorInfo);
                errorInfo = chain;
              }
            }
            var relatedInformation = void 0;
            if (headMessage && errorNode && !result2 && source.symbol) {
              var links = getSymbolLinks(source.symbol);
              if (links.originatingImport && !ts3.isImportCall(links.originatingImport)) {
                var helpfulRetry = checkTypeRelatedTo(getTypeOfSymbol(links.target), target, relation, void 0);
                if (helpfulRetry) {
                  var diag_1 = ts3.createDiagnosticForNode(links.originatingImport, ts3.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);
                  relatedInformation = ts3.append(relatedInformation, diag_1);
                }
              }
            }
            var diag = ts3.createDiagnosticForNodeFromMessageChain(errorNode, errorInfo, relatedInformation);
            if (relatedInfo) {
              ts3.addRelatedInfo.apply(void 0, __spreadArray([diag], relatedInfo, false));
            }
            if (errorOutputContainer) {
              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
            }
            if (!errorOutputContainer || !errorOutputContainer.skipLogging) {
              diagnostics.add(diag);
            }
          }
          if (errorNode && errorOutputContainer && errorOutputContainer.skipLogging && result2 === 0) {
            ts3.Debug.assert(!!errorOutputContainer.errors, "missed opportunity to interact with error.");
          }
          return result2 !== 0;
          function resetErrorInfo(saved) {
            errorInfo = saved.errorInfo;
            lastSkippedInfo = saved.lastSkippedInfo;
            incompatibleStack = saved.incompatibleStack;
            overrideNextErrorInfo = saved.overrideNextErrorInfo;
            relatedInfo = saved.relatedInfo;
          }
          function captureErrorCalculationState() {
            return {
              errorInfo,
              lastSkippedInfo,
              incompatibleStack: incompatibleStack === null || incompatibleStack === void 0 ? void 0 : incompatibleStack.slice(),
              overrideNextErrorInfo,
              relatedInfo: relatedInfo === null || relatedInfo === void 0 ? void 0 : relatedInfo.slice()
            };
          }
          function reportIncompatibleError(message, arg0, arg1, arg2, arg3) {
            overrideNextErrorInfo++;
            lastSkippedInfo = void 0;
            (incompatibleStack || (incompatibleStack = [])).push([message, arg0, arg1, arg2, arg3]);
          }
          function reportIncompatibleStack() {
            var stack = incompatibleStack || [];
            incompatibleStack = void 0;
            var info = lastSkippedInfo;
            lastSkippedInfo = void 0;
            if (stack.length === 1) {
              reportError.apply(void 0, stack[0]);
              if (info) {
                reportRelationError.apply(void 0, __spreadArray([void 0], info, false));
              }
              return;
            }
            var path2 = "";
            var secondaryRootErrors = [];
            while (stack.length) {
              var _a = stack.pop(), msg = _a[0], args = _a.slice(1);
              switch (msg.code) {
                case ts3.Diagnostics.Types_of_property_0_are_incompatible.code: {
                  if (path2.indexOf("new ") === 0) {
                    path2 = "(".concat(path2, ")");
                  }
                  var str2 = "" + args[0];
                  if (path2.length === 0) {
                    path2 = "".concat(str2);
                  } else if (ts3.isIdentifierText(str2, ts3.getEmitScriptTarget(compilerOptions))) {
                    path2 = "".concat(path2, ".").concat(str2);
                  } else if (str2[0] === "[" && str2[str2.length - 1] === "]") {
                    path2 = "".concat(path2).concat(str2);
                  } else {
                    path2 = "".concat(path2, "[").concat(str2, "]");
                  }
                  break;
                }
                case ts3.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible.code:
                case ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code:
                case ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:
                case ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code: {
                  if (path2.length === 0) {
                    var mappedMsg = msg;
                    if (msg.code === ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
                      mappedMsg = ts3.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible;
                    } else if (msg.code === ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
                      mappedMsg = ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible;
                    }
                    secondaryRootErrors.unshift([mappedMsg, args[0], args[1]]);
                  } else {
                    var prefix = msg.code === ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code || msg.code === ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "new " : "";
                    var params = msg.code === ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code || msg.code === ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "" : "...";
                    path2 = "".concat(prefix).concat(path2, "(").concat(params, ")");
                  }
                  break;
                }
                case ts3.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code: {
                  secondaryRootErrors.unshift([ts3.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, args[0], args[1]]);
                  break;
                }
                case ts3.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code: {
                  secondaryRootErrors.unshift([ts3.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, args[0], args[1], args[2]]);
                  break;
                }
                default:
                  return ts3.Debug.fail("Unhandled Diagnostic: ".concat(msg.code));
              }
            }
            if (path2) {
              reportError(path2[path2.length - 1] === ")" ? ts3.Diagnostics.The_types_returned_by_0_are_incompatible_between_these_types : ts3.Diagnostics.The_types_of_0_are_incompatible_between_these_types, path2);
            } else {
              secondaryRootErrors.shift();
            }
            for (var _i = 0, secondaryRootErrors_1 = secondaryRootErrors; _i < secondaryRootErrors_1.length; _i++) {
              var _b = secondaryRootErrors_1[_i], msg = _b[0], args = _b.slice(1);
              var originalValue = msg.elidedInCompatabilityPyramid;
              msg.elidedInCompatabilityPyramid = false;
              reportError.apply(void 0, __spreadArray([msg], args, false));
              msg.elidedInCompatabilityPyramid = originalValue;
            }
            if (info) {
              reportRelationError.apply(void 0, __spreadArray([void 0], info, false));
            }
          }
          function reportError(message, arg0, arg1, arg2, arg3) {
            ts3.Debug.assert(!!errorNode);
            if (incompatibleStack)
              reportIncompatibleStack();
            if (message.elidedInCompatabilityPyramid)
              return;
            errorInfo = ts3.chainDiagnosticMessages(errorInfo, message, arg0, arg1, arg2, arg3);
          }
          function associateRelatedInfo(info) {
            ts3.Debug.assert(!!errorInfo);
            if (!relatedInfo) {
              relatedInfo = [info];
            } else {
              relatedInfo.push(info);
            }
          }
          function reportRelationError(message, source2, target2) {
            if (incompatibleStack)
              reportIncompatibleStack();
            var _a = getTypeNamesForErrorDisplay(source2, target2), sourceType = _a[0], targetType = _a[1];
            var generalizedSource = source2;
            var generalizedSourceType = sourceType;
            if (isLiteralType(source2) && !typeCouldHaveTopLevelSingletonTypes(target2)) {
              generalizedSource = getBaseTypeOfLiteralType(source2);
              ts3.Debug.assert(!isTypeAssignableTo(generalizedSource, target2), "generalized source shouldn't be assignable");
              generalizedSourceType = getTypeNameForErrorDisplay(generalizedSource);
            }
            if (target2.flags & 262144 && target2 !== markerSuperType && target2 !== markerSubType) {
              var constraint = getBaseConstraintOfType(target2);
              var needsOriginalSource = void 0;
              if (constraint && (isTypeAssignableTo(generalizedSource, constraint) || (needsOriginalSource = isTypeAssignableTo(source2, constraint)))) {
                reportError(ts3.Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2, needsOriginalSource ? sourceType : generalizedSourceType, targetType, typeToString(constraint));
              } else {
                errorInfo = void 0;
                reportError(ts3.Diagnostics._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1, targetType, generalizedSourceType);
              }
            }
            if (!message) {
              if (relation === comparableRelation) {
                message = ts3.Diagnostics.Type_0_is_not_comparable_to_type_1;
              } else if (sourceType === targetType) {
                message = ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
              } else if (exactOptionalPropertyTypes && getExactOptionalUnassignableProperties(source2, target2).length) {
                message = ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;
              } else {
                if (source2.flags & 128 && target2.flags & 1048576) {
                  var suggestedType = getSuggestedTypeForNonexistentStringLiteralType(source2, target2);
                  if (suggestedType) {
                    reportError(ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_Did_you_mean_2, generalizedSourceType, targetType, typeToString(suggestedType));
                    return;
                  }
                }
                message = ts3.Diagnostics.Type_0_is_not_assignable_to_type_1;
              }
            } else if (message === ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1 && exactOptionalPropertyTypes && getExactOptionalUnassignableProperties(source2, target2).length) {
              message = ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;
            }
            reportError(message, generalizedSourceType, targetType);
          }
          function tryElaborateErrorsForPrimitivesAndObjects(source2, target2) {
            var sourceType = symbolValueDeclarationIsContextSensitive(source2.symbol) ? typeToString(source2, source2.symbol.valueDeclaration) : typeToString(source2);
            var targetType = symbolValueDeclarationIsContextSensitive(target2.symbol) ? typeToString(target2, target2.symbol.valueDeclaration) : typeToString(target2);
            if (globalStringType === source2 && stringType === target2 || globalNumberType === source2 && numberType === target2 || globalBooleanType === source2 && booleanType === target2 || getGlobalESSymbolType() === source2 && esSymbolType === target2) {
              reportError(ts3.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, targetType, sourceType);
            }
          }
          function tryElaborateArrayLikeErrors(source2, target2, reportErrors) {
            if (isTupleType(source2)) {
              if (source2.target.readonly && isMutableArrayOrTuple(target2)) {
                if (reportErrors) {
                  reportError(ts3.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
                }
                return false;
              }
              return isArrayOrTupleType(target2);
            }
            if (isReadonlyArrayType(source2) && isMutableArrayOrTuple(target2)) {
              if (reportErrors) {
                reportError(ts3.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
              }
              return false;
            }
            if (isTupleType(target2)) {
              return isArrayType(source2);
            }
            return true;
          }
          function isRelatedToWorker(source2, target2, reportErrors) {
            return isRelatedTo(source2, target2, 3, reportErrors);
          }
          function isRelatedTo(originalSource, originalTarget, recursionFlags, reportErrors, headMessage2, intersectionState) {
            if (recursionFlags === void 0) {
              recursionFlags = 3;
            }
            if (reportErrors === void 0) {
              reportErrors = false;
            }
            if (intersectionState === void 0) {
              intersectionState = 0;
            }
            if (originalSource.flags & 524288 && originalTarget.flags & 131068) {
              if (isSimpleTypeRelatedTo(originalSource, originalTarget, relation, reportErrors ? reportError : void 0)) {
                return -1;
              }
              if (reportErrors) {
                reportErrorResults(originalSource, originalTarget, originalSource, originalTarget, headMessage2);
              }
              return 0;
            }
            var source2 = getNormalizedType(originalSource, false);
            var target2 = getNormalizedType(originalTarget, true);
            if (source2 === target2)
              return -1;
            if (relation === identityRelation) {
              if (source2.flags !== target2.flags)
                return 0;
              if (source2.flags & 67358815)
                return -1;
              traceUnionsOrIntersectionsTooLarge(source2, target2);
              return recursiveTypeRelatedTo(source2, target2, false, 0, recursionFlags);
            }
            if (source2.flags & 262144 && getConstraintOfType(source2) === target2) {
              return -1;
            }
            if (source2.flags & 470302716 && target2.flags & 1048576) {
              var types2 = target2.types;
              var candidate = types2.length === 2 && types2[0].flags & 98304 ? types2[1] : types2.length === 3 && types2[0].flags & 98304 && types2[1].flags & 98304 ? types2[2] : void 0;
              if (candidate && !(candidate.flags & 98304)) {
                target2 = getNormalizedType(candidate, true);
                if (source2 === target2)
                  return -1;
              }
            }
            if (relation === comparableRelation && !(target2.flags & 131072) && isSimpleTypeRelatedTo(target2, source2, relation) || isSimpleTypeRelatedTo(source2, target2, relation, reportErrors ? reportError : void 0))
              return -1;
            if (source2.flags & 469499904 || target2.flags & 469499904) {
              var isPerformingExcessPropertyChecks = !(intersectionState & 2) && (isObjectLiteralType(source2) && ts3.getObjectFlags(source2) & 8192);
              if (isPerformingExcessPropertyChecks) {
                if (hasExcessProperties(source2, target2, reportErrors)) {
                  if (reportErrors) {
                    reportRelationError(headMessage2, source2, originalTarget.aliasSymbol ? originalTarget : target2);
                  }
                  return 0;
                }
              }
              var isPerformingCommonPropertyChecks = relation !== comparableRelation && !(intersectionState & 2) && source2.flags & (131068 | 524288 | 2097152) && source2 !== globalObjectType && target2.flags & (524288 | 2097152) && isWeakType(target2) && (getPropertiesOfType(source2).length > 0 || typeHasCallOrConstructSignatures(source2));
              var isComparingJsxAttributes = !!(ts3.getObjectFlags(source2) & 2048);
              if (isPerformingCommonPropertyChecks && !hasCommonProperties(source2, target2, isComparingJsxAttributes)) {
                if (reportErrors) {
                  var sourceString = typeToString(originalSource.aliasSymbol ? originalSource : source2);
                  var targetString = typeToString(originalTarget.aliasSymbol ? originalTarget : target2);
                  var calls = getSignaturesOfType(source2, 0);
                  var constructs = getSignaturesOfType(source2, 1);
                  if (calls.length > 0 && isRelatedTo(getReturnTypeOfSignature(calls[0]), target2, 1, false) || constructs.length > 0 && isRelatedTo(getReturnTypeOfSignature(constructs[0]), target2, 1, false)) {
                    reportError(ts3.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it, sourceString, targetString);
                  } else {
                    reportError(ts3.Diagnostics.Type_0_has_no_properties_in_common_with_type_1, sourceString, targetString);
                  }
                }
                return 0;
              }
              traceUnionsOrIntersectionsTooLarge(source2, target2);
              var skipCaching = source2.flags & 1048576 && source2.types.length < 4 && !(target2.flags & 1048576) || target2.flags & 1048576 && target2.types.length < 4 && !(source2.flags & 469499904);
              var result_7 = skipCaching ? unionOrIntersectionRelatedTo(source2, target2, reportErrors, intersectionState) : recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState, recursionFlags);
              if (result_7 && !inPropertyCheck && (target2.flags & 2097152 && (isPerformingExcessPropertyChecks || isPerformingCommonPropertyChecks) || isNonGenericObjectType(target2) && !isArrayOrTupleType(target2) && source2.flags & 2097152 && getApparentType(source2).flags & 3670016 && !ts3.some(source2.types, function(t) {
                return !!(ts3.getObjectFlags(t) & 262144);
              }))) {
                inPropertyCheck = true;
                result_7 &= recursiveTypeRelatedTo(source2, target2, reportErrors, 4, recursionFlags);
                inPropertyCheck = false;
              }
              if (result_7) {
                return result_7;
              }
            }
            if (reportErrors) {
              reportErrorResults(originalSource, originalTarget, source2, target2, headMessage2);
            }
            return 0;
          }
          function reportErrorResults(originalSource, originalTarget, source2, target2, headMessage2) {
            var sourceHasBase = !!getSingleBaseForNonAugmentingSubtype(originalSource);
            var targetHasBase = !!getSingleBaseForNonAugmentingSubtype(originalTarget);
            source2 = originalSource.aliasSymbol || sourceHasBase ? originalSource : source2;
            target2 = originalTarget.aliasSymbol || targetHasBase ? originalTarget : target2;
            var maybeSuppress = overrideNextErrorInfo > 0;
            if (maybeSuppress) {
              overrideNextErrorInfo--;
            }
            if (source2.flags & 524288 && target2.flags & 524288) {
              var currentError = errorInfo;
              tryElaborateArrayLikeErrors(source2, target2, true);
              if (errorInfo !== currentError) {
                maybeSuppress = !!errorInfo;
              }
            }
            if (source2.flags & 524288 && target2.flags & 131068) {
              tryElaborateErrorsForPrimitivesAndObjects(source2, target2);
            } else if (source2.symbol && source2.flags & 524288 && globalObjectType === source2) {
              reportError(ts3.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
            } else if (ts3.getObjectFlags(source2) & 2048 && target2.flags & 2097152) {
              var targetTypes = target2.types;
              var intrinsicAttributes = getJsxType(JsxNames.IntrinsicAttributes, errorNode);
              var intrinsicClassAttributes = getJsxType(JsxNames.IntrinsicClassAttributes, errorNode);
              if (!isErrorType(intrinsicAttributes) && !isErrorType(intrinsicClassAttributes) && (ts3.contains(targetTypes, intrinsicAttributes) || ts3.contains(targetTypes, intrinsicClassAttributes))) {
                return;
              }
            } else {
              errorInfo = elaborateNeverIntersection(errorInfo, originalTarget);
            }
            if (!headMessage2 && maybeSuppress) {
              lastSkippedInfo = [source2, target2];
              return;
            }
            reportRelationError(headMessage2, source2, target2);
          }
          function traceUnionsOrIntersectionsTooLarge(source2, target2) {
            if (!ts3.tracing) {
              return;
            }
            if (source2.flags & 3145728 && target2.flags & 3145728) {
              var sourceUnionOrIntersection = source2;
              var targetUnionOrIntersection = target2;
              if (sourceUnionOrIntersection.objectFlags & targetUnionOrIntersection.objectFlags & 32768) {
                return;
              }
              var sourceSize = sourceUnionOrIntersection.types.length;
              var targetSize = targetUnionOrIntersection.types.length;
              if (sourceSize * targetSize > 1e6) {
                ts3.tracing.instant("checkTypes", "traceUnionsOrIntersectionsTooLarge_DepthLimit", {
                  sourceId: source2.id,
                  sourceSize,
                  targetId: target2.id,
                  targetSize,
                  pos: errorNode === null || errorNode === void 0 ? void 0 : errorNode.pos,
                  end: errorNode === null || errorNode === void 0 ? void 0 : errorNode.end
                });
              }
            }
          }
          function getTypeOfPropertyInTypes(types2, name) {
            var appendPropType = function(propTypes, type2) {
              var _a;
              type2 = getApparentType(type2);
              var prop = type2.flags & 3145728 ? getPropertyOfUnionOrIntersectionType(type2, name) : getPropertyOfObjectType(type2, name);
              var propType = prop && getTypeOfSymbol(prop) || ((_a = getApplicableIndexInfoForName(type2, name)) === null || _a === void 0 ? void 0 : _a.type) || undefinedType;
              return ts3.append(propTypes, propType);
            };
            return getUnionType(ts3.reduceLeft(types2, appendPropType, void 0) || ts3.emptyArray);
          }
          function hasExcessProperties(source2, target2, reportErrors) {
            var _a;
            if (!isExcessPropertyCheckTarget(target2) || !noImplicitAny && ts3.getObjectFlags(target2) & 4096) {
              return false;
            }
            var isComparingJsxAttributes = !!(ts3.getObjectFlags(source2) & 2048);
            if ((relation === assignableRelation || relation === comparableRelation) && (isTypeSubsetOf(globalObjectType, target2) || !isComparingJsxAttributes && isEmptyObjectType(target2))) {
              return false;
            }
            var reducedTarget = target2;
            var checkTypes;
            if (target2.flags & 1048576) {
              reducedTarget = findMatchingDiscriminantType(source2, target2, isRelatedTo) || filterPrimitivesIfContainsNonPrimitive(target2);
              checkTypes = reducedTarget.flags & 1048576 ? reducedTarget.types : [reducedTarget];
            }
            var _loop_19 = function(prop2) {
              if (shouldCheckAsExcessProperty(prop2, source2.symbol) && !isIgnoredJsxProperty(source2, prop2)) {
                if (!isKnownProperty(reducedTarget, prop2.escapedName, isComparingJsxAttributes)) {
                  if (reportErrors) {
                    var errorTarget = filterType(reducedTarget, isExcessPropertyCheckTarget);
                    if (!errorNode)
                      return { value: ts3.Debug.fail() };
                    if (ts3.isJsxAttributes(errorNode) || ts3.isJsxOpeningLikeElement(errorNode) || ts3.isJsxOpeningLikeElement(errorNode.parent)) {
                      if (prop2.valueDeclaration && ts3.isJsxAttribute(prop2.valueDeclaration) && ts3.getSourceFileOfNode(errorNode) === ts3.getSourceFileOfNode(prop2.valueDeclaration.name)) {
                        errorNode = prop2.valueDeclaration.name;
                      }
                      var propName = symbolToString(prop2);
                      var suggestionSymbol = getSuggestedSymbolForNonexistentJSXAttribute(propName, errorTarget);
                      var suggestion = suggestionSymbol ? symbolToString(suggestionSymbol) : void 0;
                      if (suggestion) {
                        reportError(ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(errorTarget), suggestion);
                      } else {
                        reportError(ts3.Diagnostics.Property_0_does_not_exist_on_type_1, propName, typeToString(errorTarget));
                      }
                    } else {
                      var objectLiteralDeclaration_1 = ((_a = source2.symbol) === null || _a === void 0 ? void 0 : _a.declarations) && ts3.firstOrUndefined(source2.symbol.declarations);
                      var suggestion = void 0;
                      if (prop2.valueDeclaration && ts3.findAncestor(prop2.valueDeclaration, function(d) {
                        return d === objectLiteralDeclaration_1;
                      }) && ts3.getSourceFileOfNode(objectLiteralDeclaration_1) === ts3.getSourceFileOfNode(errorNode)) {
                        var propDeclaration = prop2.valueDeclaration;
                        ts3.Debug.assertNode(propDeclaration, ts3.isObjectLiteralElementLike);
                        errorNode = propDeclaration;
                        var name = propDeclaration.name;
                        if (ts3.isIdentifier(name)) {
                          suggestion = getSuggestionForNonexistentProperty(name, errorTarget);
                        }
                      }
                      if (suggestion !== void 0) {
                        reportError(ts3.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2, symbolToString(prop2), typeToString(errorTarget), suggestion);
                      } else {
                        reportError(ts3.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(prop2), typeToString(errorTarget));
                      }
                    }
                  }
                  return { value: true };
                }
                if (checkTypes && !isRelatedTo(getTypeOfSymbol(prop2), getTypeOfPropertyInTypes(checkTypes, prop2.escapedName), 3, reportErrors)) {
                  if (reportErrors) {
                    reportIncompatibleError(ts3.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(prop2));
                  }
                  return { value: true };
                }
              }
            };
            for (var _i = 0, _b = getPropertiesOfType(source2); _i < _b.length; _i++) {
              var prop = _b[_i];
              var state_6 = _loop_19(prop);
              if (typeof state_6 === "object")
                return state_6.value;
            }
            return false;
          }
          function shouldCheckAsExcessProperty(prop, container) {
            return prop.valueDeclaration && container.valueDeclaration && prop.valueDeclaration.parent === container.valueDeclaration;
          }
          function unionOrIntersectionRelatedTo(source2, target2, reportErrors, intersectionState) {
            if (source2.flags & 1048576) {
              return relation === comparableRelation ? someTypeRelatedToType(source2, target2, reportErrors && !(source2.flags & 131068), intersectionState) : eachTypeRelatedToType(source2, target2, reportErrors && !(source2.flags & 131068), intersectionState);
            }
            if (target2.flags & 1048576) {
              return typeRelatedToSomeType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors && !(source2.flags & 131068) && !(target2.flags & 131068));
            }
            if (target2.flags & 2097152) {
              return typeRelatedToEachType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors, 2);
            }
            if (relation === comparableRelation && target2.flags & 131068) {
              var constraints = ts3.sameMap(source2.types, getBaseConstraintOrType);
              if (constraints !== source2.types) {
                source2 = getIntersectionType(constraints);
                if (!(source2.flags & 2097152)) {
                  return isRelatedTo(source2, target2, 1, false);
                }
              }
            }
            return someTypeRelatedToType(source2, target2, false, 1);
          }
          function eachTypeRelatedToSomeType(source2, target2) {
            var result3 = -1;
            var sourceTypes = source2.types;
            for (var _i = 0, sourceTypes_1 = sourceTypes; _i < sourceTypes_1.length; _i++) {
              var sourceType = sourceTypes_1[_i];
              var related = typeRelatedToSomeType(sourceType, target2, false);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function typeRelatedToSomeType(source2, target2, reportErrors) {
            var targetTypes = target2.types;
            if (target2.flags & 1048576) {
              if (containsType(targetTypes, source2)) {
                return -1;
              }
              var match = getMatchingUnionConstituentForType(target2, source2);
              if (match) {
                var related = isRelatedTo(source2, match, 2, false);
                if (related) {
                  return related;
                }
              }
            }
            for (var _i = 0, targetTypes_1 = targetTypes; _i < targetTypes_1.length; _i++) {
              var type2 = targetTypes_1[_i];
              var related = isRelatedTo(source2, type2, 2, false);
              if (related) {
                return related;
              }
            }
            if (reportErrors) {
              var bestMatchingType = getBestMatchingType(source2, target2, isRelatedTo);
              if (bestMatchingType) {
                isRelatedTo(source2, bestMatchingType, 2, true);
              }
            }
            return 0;
          }
          function typeRelatedToEachType(source2, target2, reportErrors, intersectionState) {
            var result3 = -1;
            var targetTypes = target2.types;
            for (var _i = 0, targetTypes_2 = targetTypes; _i < targetTypes_2.length; _i++) {
              var targetType = targetTypes_2[_i];
              var related = isRelatedTo(source2, targetType, 2, reportErrors, void 0, intersectionState);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function someTypeRelatedToType(source2, target2, reportErrors, intersectionState) {
            var sourceTypes = source2.types;
            if (source2.flags & 1048576 && containsType(sourceTypes, target2)) {
              return -1;
            }
            var len = sourceTypes.length;
            for (var i = 0; i < len; i++) {
              var related = isRelatedTo(sourceTypes[i], target2, 1, reportErrors && i === len - 1, void 0, intersectionState);
              if (related) {
                return related;
              }
            }
            return 0;
          }
          function getUndefinedStrippedTargetIfNeeded(source2, target2) {
            if (source2.flags & 1048576 && target2.flags & 1048576 && !(source2.types[0].flags & 32768) && target2.types[0].flags & 32768) {
              return extractTypesOfKind(target2, ~32768);
            }
            return target2;
          }
          function eachTypeRelatedToType(source2, target2, reportErrors, intersectionState) {
            var result3 = -1;
            var sourceTypes = source2.types;
            var undefinedStrippedTarget = getUndefinedStrippedTargetIfNeeded(source2, target2);
            for (var i = 0; i < sourceTypes.length; i++) {
              var sourceType = sourceTypes[i];
              if (undefinedStrippedTarget.flags & 1048576 && sourceTypes.length >= undefinedStrippedTarget.types.length && sourceTypes.length % undefinedStrippedTarget.types.length === 0) {
                var related_1 = isRelatedTo(sourceType, undefinedStrippedTarget.types[i % undefinedStrippedTarget.types.length], 3, false, void 0, intersectionState);
                if (related_1) {
                  result3 &= related_1;
                  continue;
                }
              }
              var related = isRelatedTo(sourceType, target2, 1, reportErrors, void 0, intersectionState);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function typeArgumentsRelatedTo(sources, targets, variances, reportErrors, intersectionState) {
            if (sources === void 0) {
              sources = ts3.emptyArray;
            }
            if (targets === void 0) {
              targets = ts3.emptyArray;
            }
            if (variances === void 0) {
              variances = ts3.emptyArray;
            }
            if (sources.length !== targets.length && relation === identityRelation) {
              return 0;
            }
            var length = sources.length <= targets.length ? sources.length : targets.length;
            var result3 = -1;
            for (var i = 0; i < length; i++) {
              var varianceFlags = i < variances.length ? variances[i] : 1;
              var variance = varianceFlags & 7;
              if (variance !== 4) {
                var s = sources[i];
                var t = targets[i];
                var related = -1;
                if (varianceFlags & 8) {
                  related = relation === identityRelation ? isRelatedTo(s, t, 3, false) : compareTypesIdentical(s, t);
                } else if (variance === 1) {
                  related = isRelatedTo(s, t, 3, reportErrors, void 0, intersectionState);
                } else if (variance === 2) {
                  related = isRelatedTo(t, s, 3, reportErrors, void 0, intersectionState);
                } else if (variance === 3) {
                  related = isRelatedTo(t, s, 3, false);
                  if (!related) {
                    related = isRelatedTo(s, t, 3, reportErrors, void 0, intersectionState);
                  }
                } else {
                  related = isRelatedTo(s, t, 3, reportErrors, void 0, intersectionState);
                  if (related) {
                    related &= isRelatedTo(t, s, 3, reportErrors, void 0, intersectionState);
                  }
                }
                if (!related) {
                  return 0;
                }
                result3 &= related;
              }
            }
            return result3;
          }
          function recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState, recursionFlags) {
            if (overflow) {
              return 0;
            }
            var keyIntersectionState = intersectionState | (inPropertyCheck ? 8 : 0);
            var id = getRelationKey(source2, target2, keyIntersectionState, relation, false);
            var entry = relation.get(id);
            if (entry !== void 0) {
              if (reportErrors && entry & 2 && !(entry & 4)) {
              } else {
                if (outofbandVarianceMarkerHandler) {
                  var saved = entry & 24;
                  if (saved & 8) {
                    instantiateType(source2, makeFunctionTypeMapper(reportUnmeasurableMarkers));
                  }
                  if (saved & 16) {
                    instantiateType(source2, makeFunctionTypeMapper(reportUnreliableMarkers));
                  }
                }
                return entry & 1 ? -1 : 0;
              }
            }
            if (!maybeKeys) {
              maybeKeys = [];
              sourceStack = [];
              targetStack = [];
            } else {
              var broadestEquivalentId = id.startsWith("*") ? getRelationKey(source2, target2, keyIntersectionState, relation, true) : void 0;
              for (var i = 0; i < maybeCount; i++) {
                if (id === maybeKeys[i] || broadestEquivalentId && broadestEquivalentId === maybeKeys[i]) {
                  return 3;
                }
              }
              if (sourceDepth === 100 || targetDepth === 100) {
                overflow = true;
                return 0;
              }
            }
            var maybeStart = maybeCount;
            maybeKeys[maybeCount] = id;
            maybeCount++;
            var saveExpandingFlags = expandingFlags;
            if (recursionFlags & 1) {
              sourceStack[sourceDepth] = source2;
              sourceDepth++;
              if (!(expandingFlags & 1) && isDeeplyNestedType(source2, sourceStack, sourceDepth))
                expandingFlags |= 1;
            }
            if (recursionFlags & 2) {
              targetStack[targetDepth] = target2;
              targetDepth++;
              if (!(expandingFlags & 2) && isDeeplyNestedType(target2, targetStack, targetDepth))
                expandingFlags |= 2;
            }
            var originalHandler;
            var propagatingVarianceFlags = 0;
            if (outofbandVarianceMarkerHandler) {
              originalHandler = outofbandVarianceMarkerHandler;
              outofbandVarianceMarkerHandler = function(onlyUnreliable) {
                propagatingVarianceFlags |= onlyUnreliable ? 16 : 8;
                return originalHandler(onlyUnreliable);
              };
            }
            var result3;
            if (expandingFlags === 3) {
              ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "recursiveTypeRelatedTo_DepthLimit", {
                sourceId: source2.id,
                sourceIdStack: sourceStack.map(function(t) {
                  return t.id;
                }),
                targetId: target2.id,
                targetIdStack: targetStack.map(function(t) {
                  return t.id;
                }),
                depth: sourceDepth,
                targetDepth
              });
              result3 = 3;
            } else {
              ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("checkTypes", "structuredTypeRelatedTo", { sourceId: source2.id, targetId: target2.id });
              result3 = structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState);
              ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
            }
            if (outofbandVarianceMarkerHandler) {
              outofbandVarianceMarkerHandler = originalHandler;
            }
            if (recursionFlags & 1) {
              sourceDepth--;
            }
            if (recursionFlags & 2) {
              targetDepth--;
            }
            expandingFlags = saveExpandingFlags;
            if (result3) {
              if (result3 === -1 || sourceDepth === 0 && targetDepth === 0) {
                if (result3 === -1 || result3 === 3) {
                  for (var i = maybeStart; i < maybeCount; i++) {
                    relation.set(maybeKeys[i], 1 | propagatingVarianceFlags);
                  }
                }
                maybeCount = maybeStart;
              }
            } else {
              relation.set(id, (reportErrors ? 4 : 0) | 2 | propagatingVarianceFlags);
              maybeCount = maybeStart;
            }
            return result3;
          }
          function structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState) {
            if (intersectionState & 4) {
              return propertiesRelatedTo(source2, target2, reportErrors, void 0, 0);
            }
            var result3;
            var originalErrorInfo;
            var varianceCheckFailed = false;
            var saveErrorInfo = captureErrorCalculationState();
            var sourceFlags = source2.flags;
            var targetFlags = target2.flags;
            if (relation === identityRelation) {
              if (sourceFlags & 3145728) {
                var result_8 = eachTypeRelatedToSomeType(source2, target2);
                if (result_8) {
                  result_8 &= eachTypeRelatedToSomeType(target2, source2);
                }
                return result_8;
              }
              if (sourceFlags & 4194304) {
                return isRelatedTo(source2.type, target2.type, 3, false);
              }
              if (sourceFlags & 8388608) {
                if (result3 = isRelatedTo(source2.objectType, target2.objectType, 3, false)) {
                  if (result3 &= isRelatedTo(source2.indexType, target2.indexType, 3, false)) {
                    return result3;
                  }
                }
              }
              if (sourceFlags & 16777216) {
                if (source2.root.isDistributive === target2.root.isDistributive) {
                  if (result3 = isRelatedTo(source2.checkType, target2.checkType, 3, false)) {
                    if (result3 &= isRelatedTo(source2.extendsType, target2.extendsType, 3, false)) {
                      if (result3 &= isRelatedTo(getTrueTypeFromConditionalType(source2), getTrueTypeFromConditionalType(target2), 3, false)) {
                        if (result3 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), 3, false)) {
                          return result3;
                        }
                      }
                    }
                  }
                }
              }
              if (sourceFlags & 33554432) {
                return isRelatedTo(source2.substitute, target2.substitute, 3, false);
              }
              if (!(sourceFlags & 524288)) {
                return 0;
              }
            } else if (sourceFlags & 3145728 || targetFlags & 3145728) {
              if (result3 = unionOrIntersectionRelatedTo(source2, target2, reportErrors, intersectionState)) {
                return result3;
              }
              if (source2.flags & 2097152 || source2.flags & 262144 && target2.flags & 1048576) {
                var constraint = getEffectiveConstraintOfIntersection(source2.flags & 2097152 ? source2.types : [source2], !!(target2.flags & 1048576));
                if (constraint && everyType(constraint, function(c2) {
                  return c2 !== source2;
                })) {
                  if (result3 = isRelatedTo(constraint, target2, 1, false, void 0, intersectionState)) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
              }
              if (!(sourceFlags & 465829888 || sourceFlags & 524288 && targetFlags & 1048576 || sourceFlags & 2097152 && targetFlags & (524288 | 1048576 | 465829888))) {
                return 0;
              }
            }
            if (sourceFlags & (524288 | 16777216) && source2.aliasSymbol && source2.aliasTypeArguments && source2.aliasSymbol === target2.aliasSymbol && !(isMarkerType(source2) || isMarkerType(target2))) {
              var variances = getAliasVariances(source2.aliasSymbol);
              if (variances === ts3.emptyArray) {
                return 1;
              }
              var varianceResult = relateVariances(source2.aliasTypeArguments, target2.aliasTypeArguments, variances, intersectionState);
              if (varianceResult !== void 0) {
                return varianceResult;
              }
            }
            if (isSingleElementGenericTupleType(source2) && !source2.target.readonly && (result3 = isRelatedTo(getTypeArguments(source2)[0], target2, 1)) || isSingleElementGenericTupleType(target2) && (target2.target.readonly || isMutableArrayOrTuple(getBaseConstraintOfType(source2) || source2)) && (result3 = isRelatedTo(source2, getTypeArguments(target2)[0], 2))) {
              return result3;
            }
            if (targetFlags & 262144) {
              if (ts3.getObjectFlags(source2) & 32 && !source2.declaration.nameType && isRelatedTo(getIndexType(target2), getConstraintTypeFromMappedType(source2), 3)) {
                if (!(getMappedTypeModifiers(source2) & 4)) {
                  var templateType = getTemplateTypeFromMappedType(source2);
                  var indexedAccessType = getIndexedAccessType(target2, getTypeParameterFromMappedType(source2));
                  if (result3 = isRelatedTo(templateType, indexedAccessType, 3, reportErrors)) {
                    return result3;
                  }
                }
              }
            } else if (targetFlags & 4194304) {
              var targetType_1 = target2.type;
              if (sourceFlags & 4194304) {
                if (result3 = isRelatedTo(targetType_1, source2.type, 3, false)) {
                  return result3;
                }
              }
              if (isTupleType(targetType_1)) {
                if (result3 = isRelatedTo(source2, getKnownKeysOfTupleType(targetType_1), 2, reportErrors)) {
                  return result3;
                }
              } else {
                var constraint = getSimplifiedTypeOrConstraint(targetType_1);
                if (constraint) {
                  if (isRelatedTo(source2, getIndexType(constraint, target2.stringsOnly), 2, reportErrors) === -1) {
                    return -1;
                  }
                } else if (isGenericMappedType(targetType_1)) {
                  var nameType_1 = getNameTypeFromMappedType(targetType_1);
                  var constraintType = getConstraintTypeFromMappedType(targetType_1);
                  var targetKeys = void 0;
                  if (nameType_1 && isMappedTypeWithKeyofConstraintDeclaration(targetType_1)) {
                    var modifiersType = getApparentType(getModifiersTypeFromMappedType(targetType_1));
                    var mappedKeys_1 = [];
                    forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(modifiersType, 8576, false, function(t) {
                      return void mappedKeys_1.push(instantiateType(nameType_1, appendTypeMapping(targetType_1.mapper, getTypeParameterFromMappedType(targetType_1), t)));
                    });
                    targetKeys = getUnionType(__spreadArray(__spreadArray([], mappedKeys_1, true), [nameType_1], false));
                  } else {
                    targetKeys = nameType_1 || constraintType;
                  }
                  if (isRelatedTo(source2, targetKeys, 2, reportErrors) === -1) {
                    return -1;
                  }
                }
              }
            } else if (targetFlags & 8388608) {
              if (sourceFlags & 8388608) {
                if (result3 = isRelatedTo(source2.objectType, target2.objectType, 3, reportErrors)) {
                  result3 &= isRelatedTo(source2.indexType, target2.indexType, 3, reportErrors);
                }
                if (result3) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
                if (reportErrors) {
                  originalErrorInfo = errorInfo;
                }
              }
              if (relation === assignableRelation || relation === comparableRelation) {
                var objectType = target2.objectType;
                var indexType = target2.indexType;
                var baseObjectType = getBaseConstraintOfType(objectType) || objectType;
                var baseIndexType = getBaseConstraintOfType(indexType) || indexType;
                if (!isGenericObjectType(baseObjectType) && !isGenericIndexType(baseIndexType)) {
                  var accessFlags = 4 | (baseObjectType !== objectType ? 2 : 0);
                  var constraint = getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, accessFlags);
                  if (constraint) {
                    if (reportErrors && originalErrorInfo) {
                      resetErrorInfo(saveErrorInfo);
                    }
                    if (result3 = isRelatedTo(source2, constraint, 2, reportErrors)) {
                      return result3;
                    }
                    if (reportErrors && originalErrorInfo && errorInfo) {
                      errorInfo = countMessageChainBreadth([originalErrorInfo]) <= countMessageChainBreadth([errorInfo]) ? originalErrorInfo : errorInfo;
                    }
                  }
                }
              }
              if (reportErrors) {
                originalErrorInfo = void 0;
              }
            } else if (isGenericMappedType(target2) && relation !== identityRelation) {
              var keysRemapped = !!target2.declaration.nameType;
              var templateType = getTemplateTypeFromMappedType(target2);
              var modifiers = getMappedTypeModifiers(target2);
              if (!(modifiers & 8)) {
                if (!keysRemapped && templateType.flags & 8388608 && templateType.objectType === source2 && templateType.indexType === getTypeParameterFromMappedType(target2)) {
                  return -1;
                }
                if (!isGenericMappedType(source2)) {
                  var targetKeys = keysRemapped ? getNameTypeFromMappedType(target2) : getConstraintTypeFromMappedType(target2);
                  var sourceKeys = getIndexType(source2, void 0, true);
                  var includeOptional = modifiers & 4;
                  var filteredByApplicability = includeOptional ? intersectTypes(targetKeys, sourceKeys) : void 0;
                  if (includeOptional ? !(filteredByApplicability.flags & 131072) : isRelatedTo(targetKeys, sourceKeys, 3)) {
                    var templateType_1 = getTemplateTypeFromMappedType(target2);
                    var typeParameter = getTypeParameterFromMappedType(target2);
                    var nonNullComponent = extractTypesOfKind(templateType_1, ~98304);
                    if (!keysRemapped && nonNullComponent.flags & 8388608 && nonNullComponent.indexType === typeParameter) {
                      if (result3 = isRelatedTo(source2, nonNullComponent.objectType, 2, reportErrors)) {
                        return result3;
                      }
                    } else {
                      var indexingType = keysRemapped ? filteredByApplicability || targetKeys : filteredByApplicability ? getIntersectionType([filteredByApplicability, typeParameter]) : typeParameter;
                      var indexedAccessType = getIndexedAccessType(source2, indexingType);
                      if (result3 = isRelatedTo(indexedAccessType, templateType_1, 3, reportErrors)) {
                        return result3;
                      }
                    }
                  }
                  originalErrorInfo = errorInfo;
                  resetErrorInfo(saveErrorInfo);
                }
              }
            } else if (targetFlags & 16777216) {
              if (isDeeplyNestedType(target2, targetStack, targetDepth, 10)) {
                resetErrorInfo(saveErrorInfo);
                return 3;
              }
              var c = target2;
              if (!c.root.inferTypeParameters && !isDistributionDependent(c.root)) {
                var skipTrue = !isTypeAssignableTo(getPermissiveInstantiation(c.checkType), getPermissiveInstantiation(c.extendsType));
                var skipFalse = !skipTrue && isTypeAssignableTo(getRestrictiveInstantiation(c.checkType), getRestrictiveInstantiation(c.extendsType));
                if (result3 = skipTrue ? -1 : isRelatedTo(source2, getTrueTypeFromConditionalType(c), 2, false)) {
                  result3 &= skipFalse ? -1 : isRelatedTo(source2, getFalseTypeFromConditionalType(c), 2, false);
                  if (result3) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
              }
            } else if (targetFlags & 134217728) {
              if (sourceFlags & 134217728) {
                if (relation === comparableRelation) {
                  return templateLiteralTypesDefinitelyUnrelated(source2, target2) ? 0 : -1;
                }
                instantiateType(source2, makeFunctionTypeMapper(reportUnreliableMarkers));
              }
              if (isTypeMatchedByTemplateLiteralType(source2, target2)) {
                return -1;
              }
            }
            if (sourceFlags & 8650752) {
              if (!(sourceFlags & 8388608 && targetFlags & 8388608)) {
                var constraint = getConstraintOfType(source2);
                if (!constraint || sourceFlags & 262144 && constraint.flags & 1) {
                  if (result3 = isRelatedTo(emptyObjectType, extractTypesOfKind(target2, ~67108864), 3)) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                } else if (result3 = isRelatedTo(constraint, target2, 1, false, void 0, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                } else if (result3 = isRelatedTo(getTypeWithThisArgument(constraint, source2), target2, 1, reportErrors && !(targetFlags & sourceFlags & 262144), void 0, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
                if (isMappedTypeGenericIndexedAccess(source2)) {
                  var indexConstraint = getConstraintOfType(source2.indexType);
                  if (indexConstraint) {
                    if (result3 = isRelatedTo(getIndexedAccessType(source2.objectType, indexConstraint), target2, 1, reportErrors)) {
                      resetErrorInfo(saveErrorInfo);
                      return result3;
                    }
                  }
                }
              }
            } else if (sourceFlags & 4194304) {
              if (result3 = isRelatedTo(keyofConstraintType, target2, 1, reportErrors)) {
                resetErrorInfo(saveErrorInfo);
                return result3;
              }
            } else if (sourceFlags & 134217728 && !(targetFlags & 524288)) {
              if (!(targetFlags & 134217728)) {
                var constraint = getBaseConstraintOfType(source2);
                if (constraint && constraint !== source2 && (result3 = isRelatedTo(constraint, target2, 1, reportErrors))) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else if (sourceFlags & 268435456) {
              if (targetFlags & 268435456 && source2.symbol === target2.symbol) {
                if (result3 = isRelatedTo(source2.type, target2.type, 3, reportErrors)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              } else {
                var constraint = getBaseConstraintOfType(source2);
                if (constraint && (result3 = isRelatedTo(constraint, target2, 1, reportErrors))) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else if (sourceFlags & 16777216) {
              if (isDeeplyNestedType(source2, sourceStack, sourceDepth, 10)) {
                resetErrorInfo(saveErrorInfo);
                return 3;
              }
              if (targetFlags & 16777216) {
                var sourceParams = source2.root.inferTypeParameters;
                var sourceExtends = source2.extendsType;
                var mapper = void 0;
                if (sourceParams) {
                  var ctx = createInferenceContext(sourceParams, void 0, 0, isRelatedToWorker);
                  inferTypes(ctx.inferences, target2.extendsType, sourceExtends, 512 | 1024);
                  sourceExtends = instantiateType(sourceExtends, ctx.mapper);
                  mapper = ctx.mapper;
                }
                if (isTypeIdenticalTo(sourceExtends, target2.extendsType) && (isRelatedTo(source2.checkType, target2.checkType, 3) || isRelatedTo(target2.checkType, source2.checkType, 3))) {
                  if (result3 = isRelatedTo(instantiateType(getTrueTypeFromConditionalType(source2), mapper), getTrueTypeFromConditionalType(target2), 3, reportErrors)) {
                    result3 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), 3, reportErrors);
                  }
                  if (result3) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
              } else {
                var distributiveConstraint = hasNonCircularBaseConstraint(source2) ? getConstraintOfDistributiveConditionalType(source2) : void 0;
                if (distributiveConstraint) {
                  if (result3 = isRelatedTo(distributiveConstraint, target2, 1, reportErrors)) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
              }
              var defaultConstraint = getDefaultConstraintOfConditionalType(source2);
              if (defaultConstraint) {
                if (result3 = isRelatedTo(defaultConstraint, target2, 1, reportErrors)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else {
              if (relation !== subtypeRelation && relation !== strictSubtypeRelation && isPartialMappedType(target2) && isEmptyObjectType(source2)) {
                return -1;
              }
              if (isGenericMappedType(target2)) {
                if (isGenericMappedType(source2)) {
                  if (result3 = mappedTypeRelatedTo(source2, target2, reportErrors)) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
                return 0;
              }
              var sourceIsPrimitive = !!(sourceFlags & 131068);
              if (relation !== identityRelation) {
                source2 = getApparentType(source2);
                sourceFlags = source2.flags;
              } else if (isGenericMappedType(source2)) {
                return 0;
              }
              if (ts3.getObjectFlags(source2) & 4 && ts3.getObjectFlags(target2) & 4 && source2.target === target2.target && !isTupleType(source2) && !(isMarkerType(source2) || isMarkerType(target2))) {
                if (isEmptyArrayLiteralType(source2)) {
                  return -1;
                }
                var variances = getVariances(source2.target);
                if (variances === ts3.emptyArray) {
                  return 1;
                }
                var varianceResult = relateVariances(getTypeArguments(source2), getTypeArguments(target2), variances, intersectionState);
                if (varianceResult !== void 0) {
                  return varianceResult;
                }
              } else if (isReadonlyArrayType(target2) ? isArrayOrTupleType(source2) : isArrayType(target2) && isTupleType(source2) && !source2.target.readonly) {
                if (relation !== identityRelation) {
                  return isRelatedTo(getIndexTypeOfType(source2, numberType) || anyType, getIndexTypeOfType(target2, numberType) || anyType, 3, reportErrors);
                } else {
                  return 0;
                }
              } else if ((relation === subtypeRelation || relation === strictSubtypeRelation) && isEmptyObjectType(target2) && ts3.getObjectFlags(target2) & 8192 && !isEmptyObjectType(source2)) {
                return 0;
              }
              if (sourceFlags & (524288 | 2097152) && targetFlags & 524288) {
                var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo.errorInfo && !sourceIsPrimitive;
                result3 = propertiesRelatedTo(source2, target2, reportStructuralErrors, void 0, intersectionState);
                if (result3) {
                  result3 &= signaturesRelatedTo(source2, target2, 0, reportStructuralErrors);
                  if (result3) {
                    result3 &= signaturesRelatedTo(source2, target2, 1, reportStructuralErrors);
                    if (result3) {
                      result3 &= indexSignaturesRelatedTo(source2, target2, sourceIsPrimitive, reportStructuralErrors, intersectionState);
                    }
                  }
                }
                if (varianceCheckFailed && result3) {
                  errorInfo = originalErrorInfo || errorInfo || saveErrorInfo.errorInfo;
                } else if (result3) {
                  return result3;
                }
              }
              if (sourceFlags & (524288 | 2097152) && targetFlags & 1048576) {
                var objectOnlyTarget = extractTypesOfKind(target2, 524288 | 2097152 | 33554432);
                if (objectOnlyTarget.flags & 1048576) {
                  var result_9 = typeRelatedToDiscriminatedType(source2, objectOnlyTarget);
                  if (result_9) {
                    return result_9;
                  }
                }
              }
            }
            return 0;
            function countMessageChainBreadth(info) {
              if (!info)
                return 0;
              return ts3.reduceLeft(info, function(value, chain2) {
                return value + 1 + countMessageChainBreadth(chain2.next);
              }, 0);
            }
            function relateVariances(sourceTypeArguments, targetTypeArguments, variances2, intersectionState2) {
              if (result3 = typeArgumentsRelatedTo(sourceTypeArguments, targetTypeArguments, variances2, reportErrors, intersectionState2)) {
                return result3;
              }
              if (ts3.some(variances2, function(v) {
                return !!(v & 24);
              })) {
                originalErrorInfo = void 0;
                resetErrorInfo(saveErrorInfo);
                return void 0;
              }
              var allowStructuralFallback = targetTypeArguments && hasCovariantVoidArgument(targetTypeArguments, variances2);
              varianceCheckFailed = !allowStructuralFallback;
              if (variances2 !== ts3.emptyArray && !allowStructuralFallback) {
                if (varianceCheckFailed && !(reportErrors && ts3.some(variances2, function(v) {
                  return (v & 7) === 0;
                }))) {
                  return 0;
                }
                originalErrorInfo = errorInfo;
                resetErrorInfo(saveErrorInfo);
              }
            }
          }
          function reportUnmeasurableMarkers(p) {
            if (outofbandVarianceMarkerHandler && (p === markerSuperType || p === markerSubType || p === markerOtherType)) {
              outofbandVarianceMarkerHandler(false);
            }
            return p;
          }
          function reportUnreliableMarkers(p) {
            if (outofbandVarianceMarkerHandler && (p === markerSuperType || p === markerSubType || p === markerOtherType)) {
              outofbandVarianceMarkerHandler(true);
            }
            return p;
          }
          function mappedTypeRelatedTo(source2, target2, reportErrors) {
            var modifiersRelated = relation === comparableRelation || (relation === identityRelation ? getMappedTypeModifiers(source2) === getMappedTypeModifiers(target2) : getCombinedMappedTypeOptionality(source2) <= getCombinedMappedTypeOptionality(target2));
            if (modifiersRelated) {
              var result_10;
              var targetConstraint = getConstraintTypeFromMappedType(target2);
              var sourceConstraint = instantiateType(getConstraintTypeFromMappedType(source2), makeFunctionTypeMapper(getCombinedMappedTypeOptionality(source2) < 0 ? reportUnmeasurableMarkers : reportUnreliableMarkers));
              if (result_10 = isRelatedTo(targetConstraint, sourceConstraint, 3, reportErrors)) {
                var mapper = createTypeMapper([getTypeParameterFromMappedType(source2)], [getTypeParameterFromMappedType(target2)]);
                if (instantiateType(getNameTypeFromMappedType(source2), mapper) === instantiateType(getNameTypeFromMappedType(target2), mapper)) {
                  return result_10 & isRelatedTo(instantiateType(getTemplateTypeFromMappedType(source2), mapper), getTemplateTypeFromMappedType(target2), 3, reportErrors);
                }
              }
            }
            return 0;
          }
          function typeRelatedToDiscriminatedType(source2, target2) {
            var sourceProperties = getPropertiesOfType(source2);
            var sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target2);
            if (!sourcePropertiesFiltered)
              return 0;
            var numCombinations = 1;
            for (var _i = 0, sourcePropertiesFiltered_1 = sourcePropertiesFiltered; _i < sourcePropertiesFiltered_1.length; _i++) {
              var sourceProperty = sourcePropertiesFiltered_1[_i];
              numCombinations *= countTypes(getNonMissingTypeOfSymbol(sourceProperty));
              if (numCombinations > 25) {
                ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "typeRelatedToDiscriminatedType_DepthLimit", { sourceId: source2.id, targetId: target2.id, numCombinations });
                return 0;
              }
            }
            var sourceDiscriminantTypes = new Array(sourcePropertiesFiltered.length);
            var excludedProperties = new ts3.Set();
            for (var i = 0; i < sourcePropertiesFiltered.length; i++) {
              var sourceProperty = sourcePropertiesFiltered[i];
              var sourcePropertyType = getNonMissingTypeOfSymbol(sourceProperty);
              sourceDiscriminantTypes[i] = sourcePropertyType.flags & 1048576 ? sourcePropertyType.types : [sourcePropertyType];
              excludedProperties.add(sourceProperty.escapedName);
            }
            var discriminantCombinations = ts3.cartesianProduct(sourceDiscriminantTypes);
            var matchingTypes = [];
            var _loop_20 = function(combination2) {
              var hasMatch = false;
              outer:
                for (var _c = 0, _d = target2.types; _c < _d.length; _c++) {
                  var type3 = _d[_c];
                  var _loop_21 = function(i3) {
                    var sourceProperty2 = sourcePropertiesFiltered[i3];
                    var targetProperty = getPropertyOfType(type3, sourceProperty2.escapedName);
                    if (!targetProperty)
                      return "continue-outer";
                    if (sourceProperty2 === targetProperty)
                      return "continue";
                    var related = propertyRelatedTo(source2, target2, sourceProperty2, targetProperty, function(_) {
                      return combination2[i3];
                    }, false, 0, strictNullChecks || relation === comparableRelation);
                    if (!related) {
                      return "continue-outer";
                    }
                  };
                  for (var i2 = 0; i2 < sourcePropertiesFiltered.length; i2++) {
                    var state_8 = _loop_21(i2);
                    switch (state_8) {
                      case "continue-outer":
                        continue outer;
                    }
                  }
                  ts3.pushIfUnique(matchingTypes, type3, ts3.equateValues);
                  hasMatch = true;
                }
              if (!hasMatch) {
                return { value: 0 };
              }
            };
            for (var _a = 0, discriminantCombinations_1 = discriminantCombinations; _a < discriminantCombinations_1.length; _a++) {
              var combination = discriminantCombinations_1[_a];
              var state_7 = _loop_20(combination);
              if (typeof state_7 === "object")
                return state_7.value;
            }
            var result3 = -1;
            for (var _b = 0, matchingTypes_1 = matchingTypes; _b < matchingTypes_1.length; _b++) {
              var type2 = matchingTypes_1[_b];
              result3 &= propertiesRelatedTo(source2, type2, false, excludedProperties, 0);
              if (result3) {
                result3 &= signaturesRelatedTo(source2, type2, 0, false);
                if (result3) {
                  result3 &= signaturesRelatedTo(source2, type2, 1, false);
                  if (result3 && !(isTupleType(source2) && isTupleType(type2))) {
                    result3 &= indexSignaturesRelatedTo(source2, type2, false, false, 0);
                  }
                }
              }
              if (!result3) {
                return result3;
              }
            }
            return result3;
          }
          function excludeProperties(properties, excludedProperties) {
            if (!excludedProperties || properties.length === 0)
              return properties;
            var result3;
            for (var i = 0; i < properties.length; i++) {
              if (!excludedProperties.has(properties[i].escapedName)) {
                if (result3) {
                  result3.push(properties[i]);
                }
              } else if (!result3) {
                result3 = properties.slice(0, i);
              }
            }
            return result3 || properties;
          }
          function isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState) {
            var targetIsOptional = strictNullChecks && !!(ts3.getCheckFlags(targetProp) & 48);
            var effectiveTarget = addOptionality(getNonMissingTypeOfSymbol(targetProp), false, targetIsOptional);
            var effectiveSource = getTypeOfSourceProperty(sourceProp);
            return isRelatedTo(effectiveSource, effectiveTarget, 3, reportErrors, void 0, intersectionState);
          }
          function propertyRelatedTo(source2, target2, sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState, skipOptional) {
            var sourcePropFlags = ts3.getDeclarationModifierFlagsFromSymbol(sourceProp);
            var targetPropFlags = ts3.getDeclarationModifierFlagsFromSymbol(targetProp);
            if (sourcePropFlags & 8 || targetPropFlags & 8) {
              if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                if (reportErrors) {
                  if (sourcePropFlags & 8 && targetPropFlags & 8) {
                    reportError(ts3.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                  } else {
                    reportError(ts3.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 ? source2 : target2), typeToString(sourcePropFlags & 8 ? target2 : source2));
                  }
                }
                return 0;
              }
            } else if (targetPropFlags & 16) {
              if (!isValidOverrideOf(sourceProp, targetProp)) {
                if (reportErrors) {
                  reportError(ts3.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(getDeclaringClass(sourceProp) || source2), typeToString(getDeclaringClass(targetProp) || target2));
                }
                return 0;
              }
            } else if (sourcePropFlags & 16) {
              if (reportErrors) {
                reportError(ts3.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
              }
              return 0;
            }
            if (relation === strictSubtypeRelation && isReadonlySymbol(sourceProp) && !isReadonlySymbol(targetProp)) {
              return 0;
            }
            var related = isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState);
            if (!related) {
              if (reportErrors) {
                reportIncompatibleError(ts3.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
              }
              return 0;
            }
            if (!skipOptional && sourceProp.flags & 16777216 && !(targetProp.flags & 16777216)) {
              if (reportErrors) {
                reportError(ts3.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
              }
              return 0;
            }
            return related;
          }
          function reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties) {
            var shouldSkipElaboration = false;
            if (unmatchedProperty.valueDeclaration && ts3.isNamedDeclaration(unmatchedProperty.valueDeclaration) && ts3.isPrivateIdentifier(unmatchedProperty.valueDeclaration.name) && source2.symbol && source2.symbol.flags & 32) {
              var privateIdentifierDescription = unmatchedProperty.valueDeclaration.name.escapedText;
              var symbolTableKey = ts3.getSymbolNameForPrivateIdentifier(source2.symbol, privateIdentifierDescription);
              if (symbolTableKey && getPropertyOfType(source2, symbolTableKey)) {
                var sourceName = ts3.factory.getDeclarationName(source2.symbol.valueDeclaration);
                var targetName = ts3.factory.getDeclarationName(target2.symbol.valueDeclaration);
                reportError(ts3.Diagnostics.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2, diagnosticName(privateIdentifierDescription), diagnosticName(sourceName.escapedText === "" ? anon : sourceName), diagnosticName(targetName.escapedText === "" ? anon : targetName));
                return;
              }
            }
            var props = ts3.arrayFrom(getUnmatchedProperties(source2, target2, requireOptionalProperties, false));
            if (!headMessage || headMessage.code !== ts3.Diagnostics.Class_0_incorrectly_implements_interface_1.code && headMessage.code !== ts3.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code) {
              shouldSkipElaboration = true;
            }
            if (props.length === 1) {
              var propName = symbolToString(unmatchedProperty);
              reportError.apply(void 0, __spreadArray([ts3.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2, propName], getTypeNamesForErrorDisplay(source2, target2), false));
              if (ts3.length(unmatchedProperty.declarations)) {
                associateRelatedInfo(ts3.createDiagnosticForNode(unmatchedProperty.declarations[0], ts3.Diagnostics._0_is_declared_here, propName));
              }
              if (shouldSkipElaboration && errorInfo) {
                overrideNextErrorInfo++;
              }
            } else if (tryElaborateArrayLikeErrors(source2, target2, false)) {
              if (props.length > 5) {
                reportError(ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more, typeToString(source2), typeToString(target2), ts3.map(props.slice(0, 4), function(p) {
                  return symbolToString(p);
                }).join(", "), props.length - 4);
              } else {
                reportError(ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2, typeToString(source2), typeToString(target2), ts3.map(props, function(p) {
                  return symbolToString(p);
                }).join(", "));
              }
              if (shouldSkipElaboration && errorInfo) {
                overrideNextErrorInfo++;
              }
            }
          }
          function propertiesRelatedTo(source2, target2, reportErrors, excludedProperties, intersectionState) {
            if (relation === identityRelation) {
              return propertiesIdenticalTo(source2, target2, excludedProperties);
            }
            var result3 = -1;
            if (isTupleType(target2)) {
              if (isArrayOrTupleType(source2)) {
                if (!target2.target.readonly && (isReadonlyArrayType(source2) || isTupleType(source2) && source2.target.readonly)) {
                  return 0;
                }
                var sourceArity = getTypeReferenceArity(source2);
                var targetArity = getTypeReferenceArity(target2);
                var sourceRestFlag = isTupleType(source2) ? source2.target.combinedFlags & 4 : 4;
                var targetRestFlag = target2.target.combinedFlags & 4;
                var sourceMinLength = isTupleType(source2) ? source2.target.minLength : 0;
                var targetMinLength = target2.target.minLength;
                if (!sourceRestFlag && sourceArity < targetMinLength) {
                  if (reportErrors) {
                    reportError(ts3.Diagnostics.Source_has_0_element_s_but_target_requires_1, sourceArity, targetMinLength);
                  }
                  return 0;
                }
                if (!targetRestFlag && targetArity < sourceMinLength) {
                  if (reportErrors) {
                    reportError(ts3.Diagnostics.Source_has_0_element_s_but_target_allows_only_1, sourceMinLength, targetArity);
                  }
                  return 0;
                }
                if (!targetRestFlag && (sourceRestFlag || targetArity < sourceArity)) {
                  if (reportErrors) {
                    if (sourceMinLength < targetMinLength) {
                      reportError(ts3.Diagnostics.Target_requires_0_element_s_but_source_may_have_fewer, targetMinLength);
                    } else {
                      reportError(ts3.Diagnostics.Target_allows_only_0_element_s_but_source_may_have_more, targetArity);
                    }
                  }
                  return 0;
                }
                var sourceTypeArguments = getTypeArguments(source2);
                var targetTypeArguments = getTypeArguments(target2);
                var startCount = Math.min(isTupleType(source2) ? getStartElementCount(source2.target, 11) : 0, getStartElementCount(target2.target, 11));
                var endCount = Math.min(isTupleType(source2) ? getEndElementCount(source2.target, 11) : 0, targetRestFlag ? getEndElementCount(target2.target, 11) : 0);
                var canExcludeDiscriminants = !!excludedProperties;
                for (var i = 0; i < targetArity; i++) {
                  var sourceIndex = i < targetArity - endCount ? i : i + sourceArity - targetArity;
                  var sourceFlags = isTupleType(source2) && (i < startCount || i >= targetArity - endCount) ? source2.target.elementFlags[sourceIndex] : 4;
                  var targetFlags = target2.target.elementFlags[i];
                  if (targetFlags & 8 && !(sourceFlags & 8)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Source_provides_no_match_for_variadic_element_at_position_0_in_target, i);
                    }
                    return 0;
                  }
                  if (sourceFlags & 8 && !(targetFlags & 12)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target, sourceIndex, i);
                    }
                    return 0;
                  }
                  if (targetFlags & 1 && !(sourceFlags & 1)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Source_provides_no_match_for_required_element_at_position_0_in_target, i);
                    }
                    return 0;
                  }
                  if (canExcludeDiscriminants) {
                    if (sourceFlags & 12 || targetFlags & 12) {
                      canExcludeDiscriminants = false;
                    }
                    if (canExcludeDiscriminants && (excludedProperties === null || excludedProperties === void 0 ? void 0 : excludedProperties.has("" + i))) {
                      continue;
                    }
                  }
                  var sourceType = !isTupleType(source2) ? sourceTypeArguments[0] : i < startCount || i >= targetArity - endCount ? removeMissingType(sourceTypeArguments[sourceIndex], !!(sourceFlags & targetFlags & 2)) : getElementTypeOfSliceOfTupleType(source2, startCount, endCount) || neverType;
                  var targetType = targetTypeArguments[i];
                  var targetCheckType = sourceFlags & 8 && targetFlags & 4 ? createArrayType(targetType) : removeMissingType(targetType, !!(targetFlags & 2));
                  var related = isRelatedTo(sourceType, targetCheckType, 3, reportErrors, void 0, intersectionState);
                  if (!related) {
                    if (reportErrors && (targetArity > 1 || sourceArity > 1)) {
                      if (i < startCount || i >= targetArity - endCount || sourceArity - startCount - endCount === 1) {
                        reportIncompatibleError(ts3.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, sourceIndex, i);
                      } else {
                        reportIncompatibleError(ts3.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, startCount, sourceArity - endCount - 1, i);
                      }
                    }
                    return 0;
                  }
                  result3 &= related;
                }
                return result3;
              }
              if (target2.target.combinedFlags & 12) {
                return 0;
              }
            }
            var requireOptionalProperties = (relation === subtypeRelation || relation === strictSubtypeRelation) && !isObjectLiteralType(source2) && !isEmptyArrayLiteralType(source2) && !isTupleType(source2);
            var unmatchedProperty = getUnmatchedProperty(source2, target2, requireOptionalProperties, false);
            if (unmatchedProperty) {
              if (reportErrors && shouldReportUnmatchedPropertyError(source2, target2)) {
                reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties);
              }
              return 0;
            }
            if (isObjectLiteralType(target2)) {
              for (var _i = 0, _a = excludeProperties(getPropertiesOfType(source2), excludedProperties); _i < _a.length; _i++) {
                var sourceProp = _a[_i];
                if (!getPropertyOfObjectType(target2, sourceProp.escapedName)) {
                  var sourceType = getTypeOfSymbol(sourceProp);
                  if (!(sourceType.flags & 32768)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Property_0_does_not_exist_on_type_1, symbolToString(sourceProp), typeToString(target2));
                    }
                    return 0;
                  }
                }
              }
            }
            var properties = getPropertiesOfType(target2);
            var numericNamesOnly = isTupleType(source2) && isTupleType(target2);
            for (var _b = 0, _c = excludeProperties(properties, excludedProperties); _b < _c.length; _b++) {
              var targetProp = _c[_b];
              var name = targetProp.escapedName;
              if (!(targetProp.flags & 4194304) && (!numericNamesOnly || ts3.isNumericLiteralName(name) || name === "length")) {
                var sourceProp = getPropertyOfType(source2, name);
                if (sourceProp && sourceProp !== targetProp) {
                  var related = propertyRelatedTo(source2, target2, sourceProp, targetProp, getNonMissingTypeOfSymbol, reportErrors, intersectionState, relation === comparableRelation);
                  if (!related) {
                    return 0;
                  }
                  result3 &= related;
                }
              }
            }
            return result3;
          }
          function propertiesIdenticalTo(source2, target2, excludedProperties) {
            if (!(source2.flags & 524288 && target2.flags & 524288)) {
              return 0;
            }
            var sourceProperties = excludeProperties(getPropertiesOfObjectType(source2), excludedProperties);
            var targetProperties = excludeProperties(getPropertiesOfObjectType(target2), excludedProperties);
            if (sourceProperties.length !== targetProperties.length) {
              return 0;
            }
            var result3 = -1;
            for (var _i = 0, sourceProperties_1 = sourceProperties; _i < sourceProperties_1.length; _i++) {
              var sourceProp = sourceProperties_1[_i];
              var targetProp = getPropertyOfObjectType(target2, sourceProp.escapedName);
              if (!targetProp) {
                return 0;
              }
              var related = compareProperties(sourceProp, targetProp, isRelatedTo);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function signaturesRelatedTo(source2, target2, kind, reportErrors) {
            var _a, _b;
            if (relation === identityRelation) {
              return signaturesIdenticalTo(source2, target2, kind);
            }
            if (target2 === anyFunctionType || source2 === anyFunctionType) {
              return -1;
            }
            var sourceIsJSConstructor = source2.symbol && isJSConstructor(source2.symbol.valueDeclaration);
            var targetIsJSConstructor = target2.symbol && isJSConstructor(target2.symbol.valueDeclaration);
            var sourceSignatures = getSignaturesOfType(source2, sourceIsJSConstructor && kind === 1 ? 0 : kind);
            var targetSignatures = getSignaturesOfType(target2, targetIsJSConstructor && kind === 1 ? 0 : kind);
            if (kind === 1 && sourceSignatures.length && targetSignatures.length) {
              var sourceIsAbstract = !!(sourceSignatures[0].flags & 4);
              var targetIsAbstract = !!(targetSignatures[0].flags & 4);
              if (sourceIsAbstract && !targetIsAbstract) {
                if (reportErrors) {
                  reportError(ts3.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type);
                }
                return 0;
              }
              if (!constructorVisibilitiesAreCompatible(sourceSignatures[0], targetSignatures[0], reportErrors)) {
                return 0;
              }
            }
            var result3 = -1;
            var incompatibleReporter = kind === 1 ? reportIncompatibleConstructSignatureReturn : reportIncompatibleCallSignatureReturn;
            var sourceObjectFlags = ts3.getObjectFlags(source2);
            var targetObjectFlags = ts3.getObjectFlags(target2);
            if (sourceObjectFlags & 64 && targetObjectFlags & 64 && source2.symbol === target2.symbol || sourceObjectFlags & 4 && targetObjectFlags & 4 && source2.target === target2.target) {
              for (var i = 0; i < targetSignatures.length; i++) {
                var related = signatureRelatedTo(sourceSignatures[i], targetSignatures[i], true, reportErrors, incompatibleReporter(sourceSignatures[i], targetSignatures[i]));
                if (!related) {
                  return 0;
                }
                result3 &= related;
              }
            } else if (sourceSignatures.length === 1 && targetSignatures.length === 1) {
              var eraseGenerics = relation === comparableRelation || !!compilerOptions.noStrictGenericChecks;
              var sourceSignature = ts3.first(sourceSignatures);
              var targetSignature = ts3.first(targetSignatures);
              result3 = signatureRelatedTo(sourceSignature, targetSignature, eraseGenerics, reportErrors, incompatibleReporter(sourceSignature, targetSignature));
              if (!result3 && reportErrors && kind === 1 && sourceObjectFlags & targetObjectFlags && (((_a = targetSignature.declaration) === null || _a === void 0 ? void 0 : _a.kind) === 171 || ((_b = sourceSignature.declaration) === null || _b === void 0 ? void 0 : _b.kind) === 171)) {
                var constructSignatureToString = function(signature) {
                  return signatureToString(signature, void 0, 262144, kind);
                };
                reportError(ts3.Diagnostics.Type_0_is_not_assignable_to_type_1, constructSignatureToString(sourceSignature), constructSignatureToString(targetSignature));
                reportError(ts3.Diagnostics.Types_of_construct_signatures_are_incompatible);
                return result3;
              }
            } else {
              outer:
                for (var _i = 0, targetSignatures_1 = targetSignatures; _i < targetSignatures_1.length; _i++) {
                  var t = targetSignatures_1[_i];
                  var saveErrorInfo = captureErrorCalculationState();
                  var shouldElaborateErrors = reportErrors;
                  for (var _c = 0, sourceSignatures_1 = sourceSignatures; _c < sourceSignatures_1.length; _c++) {
                    var s = sourceSignatures_1[_c];
                    var related = signatureRelatedTo(s, t, true, shouldElaborateErrors, incompatibleReporter(s, t));
                    if (related) {
                      result3 &= related;
                      resetErrorInfo(saveErrorInfo);
                      continue outer;
                    }
                    shouldElaborateErrors = false;
                  }
                  if (shouldElaborateErrors) {
                    reportError(ts3.Diagnostics.Type_0_provides_no_match_for_the_signature_1, typeToString(source2), signatureToString(t, void 0, void 0, kind));
                  }
                  return 0;
                }
            }
            return result3;
          }
          function shouldReportUnmatchedPropertyError(source2, target2) {
            var typeCallSignatures = getSignaturesOfStructuredType(source2, 0);
            var typeConstructSignatures = getSignaturesOfStructuredType(source2, 1);
            var typeProperties = getPropertiesOfObjectType(source2);
            if ((typeCallSignatures.length || typeConstructSignatures.length) && !typeProperties.length) {
              if (getSignaturesOfType(target2, 0).length && typeCallSignatures.length || getSignaturesOfType(target2, 1).length && typeConstructSignatures.length) {
                return true;
              }
              return false;
            }
            return true;
          }
          function reportIncompatibleCallSignatureReturn(siga, sigb) {
            if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
              return function(source2, target2) {
                return reportIncompatibleError(ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
              };
            }
            return function(source2, target2) {
              return reportIncompatibleError(ts3.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
            };
          }
          function reportIncompatibleConstructSignatureReturn(siga, sigb) {
            if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
              return function(source2, target2) {
                return reportIncompatibleError(ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
              };
            }
            return function(source2, target2) {
              return reportIncompatibleError(ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
            };
          }
          function signatureRelatedTo(source2, target2, erase, reportErrors, incompatibleReporter) {
            return compareSignaturesRelated(erase ? getErasedSignature(source2) : source2, erase ? getErasedSignature(target2) : target2, relation === strictSubtypeRelation ? 8 : 0, reportErrors, reportError, incompatibleReporter, isRelatedToWorker, makeFunctionTypeMapper(reportUnreliableMarkers));
          }
          function signaturesIdenticalTo(source2, target2, kind) {
            var sourceSignatures = getSignaturesOfType(source2, kind);
            var targetSignatures = getSignaturesOfType(target2, kind);
            if (sourceSignatures.length !== targetSignatures.length) {
              return 0;
            }
            var result3 = -1;
            for (var i = 0; i < sourceSignatures.length; i++) {
              var related = compareSignaturesIdentical(sourceSignatures[i], targetSignatures[i], false, false, false, isRelatedTo);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function membersRelatedToIndexInfo(source2, targetInfo, reportErrors) {
            var result3 = -1;
            var keyType = targetInfo.keyType;
            var props = source2.flags & 2097152 ? getPropertiesOfUnionOrIntersectionType(source2) : getPropertiesOfObjectType(source2);
            for (var _i = 0, props_2 = props; _i < props_2.length; _i++) {
              var prop = props_2[_i];
              if (isIgnoredJsxProperty(source2, prop)) {
                continue;
              }
              if (isApplicableIndexType(getLiteralTypeFromProperty(prop, 8576), keyType)) {
                var propType = getNonMissingTypeOfSymbol(prop);
                var type2 = exactOptionalPropertyTypes || propType.flags & 32768 || keyType === numberType || !(prop.flags & 16777216) ? propType : getTypeWithFacts(propType, 524288);
                var related = isRelatedTo(type2, targetInfo.type, 3, reportErrors);
                if (!related) {
                  if (reportErrors) {
                    reportError(ts3.Diagnostics.Property_0_is_incompatible_with_index_signature, symbolToString(prop));
                  }
                  return 0;
                }
                result3 &= related;
              }
            }
            for (var _a = 0, _b = getIndexInfosOfType(source2); _a < _b.length; _a++) {
              var info = _b[_a];
              if (isApplicableIndexType(info.keyType, keyType)) {
                var related = indexInfoRelatedTo(info, targetInfo, reportErrors);
                if (!related) {
                  return 0;
                }
                result3 &= related;
              }
            }
            return result3;
          }
          function indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors) {
            var related = isRelatedTo(sourceInfo.type, targetInfo.type, 3, reportErrors);
            if (!related && reportErrors) {
              if (sourceInfo.keyType === targetInfo.keyType) {
                reportError(ts3.Diagnostics._0_index_signatures_are_incompatible, typeToString(sourceInfo.keyType));
              } else {
                reportError(ts3.Diagnostics._0_and_1_index_signatures_are_incompatible, typeToString(sourceInfo.keyType), typeToString(targetInfo.keyType));
              }
            }
            return related;
          }
          function indexSignaturesRelatedTo(source2, target2, sourceIsPrimitive, reportErrors, intersectionState) {
            if (relation === identityRelation) {
              return indexSignaturesIdenticalTo(source2, target2);
            }
            var indexInfos = getIndexInfosOfType(target2);
            var targetHasStringIndex = ts3.some(indexInfos, function(info) {
              return info.keyType === stringType;
            });
            var result3 = -1;
            for (var _i = 0, indexInfos_5 = indexInfos; _i < indexInfos_5.length; _i++) {
              var targetInfo = indexInfos_5[_i];
              var related = !sourceIsPrimitive && targetHasStringIndex && targetInfo.type.flags & 1 ? -1 : isGenericMappedType(source2) && targetHasStringIndex ? isRelatedTo(getTemplateTypeFromMappedType(source2), targetInfo.type, 3, reportErrors) : typeRelatedToIndexInfo(source2, targetInfo, reportErrors, intersectionState);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function typeRelatedToIndexInfo(source2, targetInfo, reportErrors, intersectionState) {
            var sourceInfo = getApplicableIndexInfo(source2, targetInfo.keyType);
            if (sourceInfo) {
              return indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors);
            }
            if (!(intersectionState & 1) && isObjectTypeWithInferableIndex(source2)) {
              return membersRelatedToIndexInfo(source2, targetInfo, reportErrors);
            }
            if (reportErrors) {
              reportError(ts3.Diagnostics.Index_signature_for_type_0_is_missing_in_type_1, typeToString(targetInfo.keyType), typeToString(source2));
            }
            return 0;
          }
          function indexSignaturesIdenticalTo(source2, target2) {
            var sourceInfos = getIndexInfosOfType(source2);
            var targetInfos = getIndexInfosOfType(target2);
            if (sourceInfos.length !== targetInfos.length) {
              return 0;
            }
            for (var _i = 0, targetInfos_1 = targetInfos; _i < targetInfos_1.length; _i++) {
              var targetInfo = targetInfos_1[_i];
              var sourceInfo = getIndexInfoOfType(source2, targetInfo.keyType);
              if (!(sourceInfo && isRelatedTo(sourceInfo.type, targetInfo.type, 3) && sourceInfo.isReadonly === targetInfo.isReadonly)) {
                return 0;
              }
            }
            return -1;
          }
          function constructorVisibilitiesAreCompatible(sourceSignature, targetSignature, reportErrors) {
            if (!sourceSignature.declaration || !targetSignature.declaration) {
              return true;
            }
            var sourceAccessibility = ts3.getSelectedEffectiveModifierFlags(sourceSignature.declaration, 24);
            var targetAccessibility = ts3.getSelectedEffectiveModifierFlags(targetSignature.declaration, 24);
            if (targetAccessibility === 8) {
              return true;
            }
            if (targetAccessibility === 16 && sourceAccessibility !== 8) {
              return true;
            }
            if (targetAccessibility !== 16 && !sourceAccessibility) {
              return true;
            }
            if (reportErrors) {
              reportError(ts3.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, visibilityToString(sourceAccessibility), visibilityToString(targetAccessibility));
            }
            return false;
          }
        }
        function typeCouldHaveTopLevelSingletonTypes(type2) {
          if (type2.flags & 16) {
            return false;
          }
          if (type2.flags & 3145728) {
            return !!ts3.forEach(type2.types, typeCouldHaveTopLevelSingletonTypes);
          }
          if (type2.flags & 465829888) {
            var constraint = getConstraintOfType(type2);
            if (constraint && constraint !== type2) {
              return typeCouldHaveTopLevelSingletonTypes(constraint);
            }
          }
          return isUnitType(type2) || !!(type2.flags & 134217728);
        }
        function getExactOptionalUnassignableProperties(source, target) {
          if (isTupleType(source) && isTupleType(target))
            return ts3.emptyArray;
          return getPropertiesOfType(target).filter(function(targetProp) {
            return isExactOptionalPropertyMismatch(getTypeOfPropertyOfType(source, targetProp.escapedName), getTypeOfSymbol(targetProp));
          });
        }
        function isExactOptionalPropertyMismatch(source, target) {
          return !!source && !!target && maybeTypeOfKind(source, 32768) && !!containsMissingType(target);
        }
        function getExactOptionalProperties(type2) {
          return getPropertiesOfType(type2).filter(function(targetProp) {
            return containsMissingType(getTypeOfSymbol(targetProp));
          });
        }
        function getBestMatchingType(source, target, isRelatedTo) {
          if (isRelatedTo === void 0) {
            isRelatedTo = compareTypesAssignable;
          }
          return findMatchingDiscriminantType(source, target, isRelatedTo, true) || findMatchingTypeReferenceOrTypeAliasReference(source, target) || findBestTypeForObjectLiteral(source, target) || findBestTypeForInvokable(source, target) || findMostOverlappyType(source, target);
        }
        function discriminateTypeByDiscriminableItems(target, discriminators, related, defaultValue, skipPartial) {
          var discriminable = target.types.map(function(_) {
            return void 0;
          });
          for (var _i = 0, discriminators_1 = discriminators; _i < discriminators_1.length; _i++) {
            var _a = discriminators_1[_i], getDiscriminatingType = _a[0], propertyName = _a[1];
            var targetProp = getUnionOrIntersectionProperty(target, propertyName);
            if (skipPartial && targetProp && ts3.getCheckFlags(targetProp) & 16) {
              continue;
            }
            var i = 0;
            for (var _b = 0, _c = target.types; _b < _c.length; _b++) {
              var type2 = _c[_b];
              var targetType = getTypeOfPropertyOfType(type2, propertyName);
              if (targetType && related(getDiscriminatingType(), targetType)) {
                discriminable[i] = discriminable[i] === void 0 ? true : discriminable[i];
              } else {
                discriminable[i] = false;
              }
              i++;
            }
          }
          var match = discriminable.indexOf(true);
          if (match === -1) {
            return defaultValue;
          }
          var nextMatch = discriminable.indexOf(true, match + 1);
          while (nextMatch !== -1) {
            if (!isTypeIdenticalTo(target.types[match], target.types[nextMatch])) {
              return defaultValue;
            }
            nextMatch = discriminable.indexOf(true, nextMatch + 1);
          }
          return target.types[match];
        }
        function isWeakType(type2) {
          if (type2.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type2);
            return resolved.callSignatures.length === 0 && resolved.constructSignatures.length === 0 && resolved.indexInfos.length === 0 && resolved.properties.length > 0 && ts3.every(resolved.properties, function(p) {
              return !!(p.flags & 16777216);
            });
          }
          if (type2.flags & 2097152) {
            return ts3.every(type2.types, isWeakType);
          }
          return false;
        }
        function hasCommonProperties(source, target, isComparingJsxAttributes) {
          for (var _i = 0, _a = getPropertiesOfType(source); _i < _a.length; _i++) {
            var prop = _a[_i];
            if (isKnownProperty(target, prop.escapedName, isComparingJsxAttributes)) {
              return true;
            }
          }
          return false;
        }
        function getVariances(type2) {
          return type2 === globalArrayType || type2 === globalReadonlyArrayType || type2.objectFlags & 8 ? arrayVariances : getVariancesWorker(type2.symbol, type2.typeParameters);
        }
        function getAliasVariances(symbol) {
          return getVariancesWorker(symbol, getSymbolLinks(symbol).typeParameters);
        }
        function getVariancesWorker(symbol, typeParameters) {
          if (typeParameters === void 0) {
            typeParameters = ts3.emptyArray;
          }
          var links = getSymbolLinks(symbol);
          if (!links.variances) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("checkTypes", "getVariancesWorker", { arity: typeParameters.length, id: getTypeId(getDeclaredTypeOfSymbol(symbol)) });
            links.variances = ts3.emptyArray;
            var variances = [];
            var _loop_22 = function(tp2) {
              var modifiers = getVarianceModifiers(tp2);
              var variance = modifiers & 65536 ? modifiers & 32768 ? 0 : 1 : modifiers & 32768 ? 2 : void 0;
              if (variance === void 0) {
                var unmeasurable_1 = false;
                var unreliable_1 = false;
                var oldHandler = outofbandVarianceMarkerHandler;
                outofbandVarianceMarkerHandler = function(onlyUnreliable) {
                  return onlyUnreliable ? unreliable_1 = true : unmeasurable_1 = true;
                };
                var typeWithSuper = createMarkerType(symbol, tp2, markerSuperType);
                var typeWithSub = createMarkerType(symbol, tp2, markerSubType);
                variance = (isTypeAssignableTo(typeWithSub, typeWithSuper) ? 1 : 0) | (isTypeAssignableTo(typeWithSuper, typeWithSub) ? 2 : 0);
                if (variance === 3 && isTypeAssignableTo(createMarkerType(symbol, tp2, markerOtherType), typeWithSuper)) {
                  variance = 4;
                }
                outofbandVarianceMarkerHandler = oldHandler;
                if (unmeasurable_1 || unreliable_1) {
                  if (unmeasurable_1) {
                    variance |= 8;
                  }
                  if (unreliable_1) {
                    variance |= 16;
                  }
                }
              }
              variances.push(variance);
            };
            for (var _i = 0, typeParameters_1 = typeParameters; _i < typeParameters_1.length; _i++) {
              var tp = typeParameters_1[_i];
              _loop_22(tp);
            }
            links.variances = variances;
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          }
          return links.variances;
        }
        function createMarkerType(symbol, source, target) {
          var mapper = makeUnaryTypeMapper(source, target);
          var type2 = getDeclaredTypeOfSymbol(symbol);
          if (isErrorType(type2)) {
            return type2;
          }
          var result2 = symbol.flags & 524288 ? getTypeAliasInstantiation(symbol, instantiateTypes(getSymbolLinks(symbol).typeParameters, mapper)) : createTypeReference(type2, instantiateTypes(type2.typeParameters, mapper));
          markerTypes.add(getTypeId(result2));
          return result2;
        }
        function isMarkerType(type2) {
          return markerTypes.has(getTypeId(type2));
        }
        function getVarianceModifiers(tp) {
          var _a, _b;
          return (ts3.some((_a = tp.symbol) === null || _a === void 0 ? void 0 : _a.declarations, function(d) {
            return ts3.hasSyntacticModifier(d, 32768);
          }) ? 32768 : 0) | (ts3.some((_b = tp.symbol) === null || _b === void 0 ? void 0 : _b.declarations, function(d) {
            return ts3.hasSyntacticModifier(d, 65536);
          }) ? 65536 : 0);
        }
        function hasCovariantVoidArgument(typeArguments, variances) {
          for (var i = 0; i < variances.length; i++) {
            if ((variances[i] & 7) === 1 && typeArguments[i].flags & 16384) {
              return true;
            }
          }
          return false;
        }
        function isUnconstrainedTypeParameter(type2) {
          return type2.flags & 262144 && !getConstraintOfTypeParameter(type2);
        }
        function isNonDeferredTypeReference(type2) {
          return !!(ts3.getObjectFlags(type2) & 4) && !type2.node;
        }
        function isTypeReferenceWithGenericArguments(type2) {
          return isNonDeferredTypeReference(type2) && ts3.some(getTypeArguments(type2), function(t) {
            return !!(t.flags & 262144) || isTypeReferenceWithGenericArguments(t);
          });
        }
        function getGenericTypeReferenceRelationKey(source, target, postFix, ignoreConstraints) {
          var typeParameters = [];
          var constraintMarker = "";
          var sourceId = getTypeReferenceId(source, 0);
          var targetId = getTypeReferenceId(target, 0);
          return "".concat(constraintMarker).concat(sourceId, ",").concat(targetId).concat(postFix);
          function getTypeReferenceId(type2, depth) {
            if (depth === void 0) {
              depth = 0;
            }
            var result2 = "" + type2.target.id;
            for (var _i = 0, _a = getTypeArguments(type2); _i < _a.length; _i++) {
              var t = _a[_i];
              if (t.flags & 262144) {
                if (ignoreConstraints || isUnconstrainedTypeParameter(t)) {
                  var index = typeParameters.indexOf(t);
                  if (index < 0) {
                    index = typeParameters.length;
                    typeParameters.push(t);
                  }
                  result2 += "=" + index;
                  continue;
                }
                constraintMarker = "*";
              } else if (depth < 4 && isTypeReferenceWithGenericArguments(t)) {
                result2 += "<" + getTypeReferenceId(t, depth + 1) + ">";
                continue;
              }
              result2 += "-" + t.id;
            }
            return result2;
          }
        }
        function getRelationKey(source, target, intersectionState, relation, ignoreConstraints) {
          if (relation === identityRelation && source.id > target.id) {
            var temp = source;
            source = target;
            target = temp;
          }
          var postFix = intersectionState ? ":" + intersectionState : "";
          return isTypeReferenceWithGenericArguments(source) && isTypeReferenceWithGenericArguments(target) ? getGenericTypeReferenceRelationKey(source, target, postFix, ignoreConstraints) : "".concat(source.id, ",").concat(target.id).concat(postFix);
        }
        function forEachProperty(prop, callback) {
          if (ts3.getCheckFlags(prop) & 6) {
            for (var _i = 0, _a = prop.containingType.types; _i < _a.length; _i++) {
              var t = _a[_i];
              var p = getPropertyOfType(t, prop.escapedName);
              var result2 = p && forEachProperty(p, callback);
              if (result2) {
                return result2;
              }
            }
            return void 0;
          }
          return callback(prop);
        }
        function getDeclaringClass(prop) {
          return prop.parent && prop.parent.flags & 32 ? getDeclaredTypeOfSymbol(getParentOfSymbol(prop)) : void 0;
        }
        function getTypeOfPropertyInBaseClass(property) {
          var classType = getDeclaringClass(property);
          var baseClassType = classType && getBaseTypes(classType)[0];
          return baseClassType && getTypeOfPropertyOfType(baseClassType, property.escapedName);
        }
        function isPropertyInClassDerivedFrom(prop, baseClass) {
          return forEachProperty(prop, function(sp) {
            var sourceClass = getDeclaringClass(sp);
            return sourceClass ? hasBaseType(sourceClass, baseClass) : false;
          });
        }
        function isValidOverrideOf(sourceProp, targetProp) {
          return !forEachProperty(targetProp, function(tp) {
            return ts3.getDeclarationModifierFlagsFromSymbol(tp) & 16 ? !isPropertyInClassDerivedFrom(sourceProp, getDeclaringClass(tp)) : false;
          });
        }
        function isClassDerivedFromDeclaringClasses(checkClass, prop, writing) {
          return forEachProperty(prop, function(p) {
            return ts3.getDeclarationModifierFlagsFromSymbol(p, writing) & 16 ? !hasBaseType(checkClass, getDeclaringClass(p)) : false;
          }) ? void 0 : checkClass;
        }
        function isDeeplyNestedType(type2, stack, depth, maxDepth) {
          if (maxDepth === void 0) {
            maxDepth = 3;
          }
          if (depth >= maxDepth) {
            var identity_2 = getRecursionIdentity(type2);
            var count = 0;
            var lastTypeId = 0;
            for (var i = 0; i < depth; i++) {
              var t = stack[i];
              if (getRecursionIdentity(t) === identity_2) {
                if (t.id >= lastTypeId) {
                  count++;
                  if (count >= maxDepth) {
                    return true;
                  }
                }
                lastTypeId = t.id;
              }
            }
          }
          return false;
        }
        function getRecursionIdentity(type2) {
          if (type2.flags & 524288 && !isObjectOrArrayLiteralType(type2)) {
            if (ts3.getObjectFlags(type2) && 4 && type2.node) {
              return type2.node;
            }
            if (type2.symbol && !(ts3.getObjectFlags(type2) & 16 && type2.symbol.flags & 32)) {
              return type2.symbol;
            }
            if (isTupleType(type2)) {
              return type2.target;
            }
          }
          if (type2.flags & 262144) {
            return type2.symbol;
          }
          if (type2.flags & 8388608) {
            do {
              type2 = type2.objectType;
            } while (type2.flags & 8388608);
            return type2;
          }
          if (type2.flags & 16777216) {
            return type2.root;
          }
          return type2;
        }
        function isPropertyIdenticalTo(sourceProp, targetProp) {
          return compareProperties(sourceProp, targetProp, compareTypesIdentical) !== 0;
        }
        function compareProperties(sourceProp, targetProp, compareTypes) {
          if (sourceProp === targetProp) {
            return -1;
          }
          var sourcePropAccessibility = ts3.getDeclarationModifierFlagsFromSymbol(sourceProp) & 24;
          var targetPropAccessibility = ts3.getDeclarationModifierFlagsFromSymbol(targetProp) & 24;
          if (sourcePropAccessibility !== targetPropAccessibility) {
            return 0;
          }
          if (sourcePropAccessibility) {
            if (getTargetSymbol(sourceProp) !== getTargetSymbol(targetProp)) {
              return 0;
            }
          } else {
            if ((sourceProp.flags & 16777216) !== (targetProp.flags & 16777216)) {
              return 0;
            }
          }
          if (isReadonlySymbol(sourceProp) !== isReadonlySymbol(targetProp)) {
            return 0;
          }
          return compareTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
        }
        function isMatchingSignature(source, target, partialMatch) {
          var sourceParameterCount = getParameterCount(source);
          var targetParameterCount = getParameterCount(target);
          var sourceMinArgumentCount = getMinArgumentCount(source);
          var targetMinArgumentCount = getMinArgumentCount(target);
          var sourceHasRestParameter = hasEffectiveRestParameter(source);
          var targetHasRestParameter = hasEffectiveRestParameter(target);
          if (sourceParameterCount === targetParameterCount && sourceMinArgumentCount === targetMinArgumentCount && sourceHasRestParameter === targetHasRestParameter) {
            return true;
          }
          if (partialMatch && sourceMinArgumentCount <= targetMinArgumentCount) {
            return true;
          }
          return false;
        }
        function compareSignaturesIdentical(source, target, partialMatch, ignoreThisTypes, ignoreReturnTypes, compareTypes) {
          if (source === target) {
            return -1;
          }
          if (!isMatchingSignature(source, target, partialMatch)) {
            return 0;
          }
          if (ts3.length(source.typeParameters) !== ts3.length(target.typeParameters)) {
            return 0;
          }
          if (target.typeParameters) {
            var mapper = createTypeMapper(source.typeParameters, target.typeParameters);
            for (var i = 0; i < target.typeParameters.length; i++) {
              var s = source.typeParameters[i];
              var t = target.typeParameters[i];
              if (!(s === t || compareTypes(instantiateType(getConstraintFromTypeParameter(s), mapper) || unknownType, getConstraintFromTypeParameter(t) || unknownType) && compareTypes(instantiateType(getDefaultFromTypeParameter(s), mapper) || unknownType, getDefaultFromTypeParameter(t) || unknownType))) {
                return 0;
              }
            }
            source = instantiateSignature(source, mapper, true);
          }
          var result2 = -1;
          if (!ignoreThisTypes) {
            var sourceThisType = getThisTypeOfSignature(source);
            if (sourceThisType) {
              var targetThisType = getThisTypeOfSignature(target);
              if (targetThisType) {
                var related = compareTypes(sourceThisType, targetThisType);
                if (!related) {
                  return 0;
                }
                result2 &= related;
              }
            }
          }
          var targetLen = getParameterCount(target);
          for (var i = 0; i < targetLen; i++) {
            var s = getTypeAtPosition(source, i);
            var t = getTypeAtPosition(target, i);
            var related = compareTypes(t, s);
            if (!related) {
              return 0;
            }
            result2 &= related;
          }
          if (!ignoreReturnTypes) {
            var sourceTypePredicate = getTypePredicateOfSignature(source);
            var targetTypePredicate = getTypePredicateOfSignature(target);
            result2 &= sourceTypePredicate || targetTypePredicate ? compareTypePredicatesIdentical(sourceTypePredicate, targetTypePredicate, compareTypes) : compareTypes(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
          }
          return result2;
        }
        function compareTypePredicatesIdentical(source, target, compareTypes) {
          return !(source && target && typePredicateKindsMatch(source, target)) ? 0 : source.type === target.type ? -1 : source.type && target.type ? compareTypes(source.type, target.type) : 0;
        }
        function literalTypesWithSameBaseType(types2) {
          var commonBaseType;
          for (var _i = 0, types_13 = types2; _i < types_13.length; _i++) {
            var t = types_13[_i];
            var baseType = getBaseTypeOfLiteralType(t);
            if (!commonBaseType) {
              commonBaseType = baseType;
            }
            if (baseType === t || baseType !== commonBaseType) {
              return false;
            }
          }
          return true;
        }
        function getSupertypeOrUnion(types2) {
          if (types2.length === 1) {
            return types2[0];
          }
          return literalTypesWithSameBaseType(types2) ? getUnionType(types2) : ts3.reduceLeft(types2, function(s, t) {
            return isTypeSubtypeOf(s, t) ? t : s;
          });
        }
        function getCommonSupertype(types2) {
          if (!strictNullChecks) {
            return getSupertypeOrUnion(types2);
          }
          var primaryTypes = ts3.filter(types2, function(t) {
            return !(t.flags & 98304);
          });
          return primaryTypes.length ? getNullableType(getSupertypeOrUnion(primaryTypes), getFalsyFlagsOfTypes(types2) & 98304) : getUnionType(types2, 2);
        }
        function getCommonSubtype(types2) {
          return ts3.reduceLeft(types2, function(s, t) {
            return isTypeSubtypeOf(t, s) ? t : s;
          });
        }
        function isArrayType(type2) {
          return !!(ts3.getObjectFlags(type2) & 4) && (type2.target === globalArrayType || type2.target === globalReadonlyArrayType);
        }
        function isReadonlyArrayType(type2) {
          return !!(ts3.getObjectFlags(type2) & 4) && type2.target === globalReadonlyArrayType;
        }
        function isArrayOrTupleType(type2) {
          return isArrayType(type2) || isTupleType(type2);
        }
        function isMutableArrayOrTuple(type2) {
          return isArrayType(type2) && !isReadonlyArrayType(type2) || isTupleType(type2) && !type2.target.readonly;
        }
        function getElementTypeOfArrayType(type2) {
          return isArrayType(type2) ? getTypeArguments(type2)[0] : void 0;
        }
        function isArrayLikeType(type2) {
          return isArrayType(type2) || !(type2.flags & 98304) && isTypeAssignableTo(type2, anyReadonlyArrayType);
        }
        function getSingleBaseForNonAugmentingSubtype(type2) {
          if (!(ts3.getObjectFlags(type2) & 4) || !(ts3.getObjectFlags(type2.target) & 3)) {
            return void 0;
          }
          if (ts3.getObjectFlags(type2) & 33554432) {
            return ts3.getObjectFlags(type2) & 67108864 ? type2.cachedEquivalentBaseType : void 0;
          }
          type2.objectFlags |= 33554432;
          var target = type2.target;
          if (ts3.getObjectFlags(target) & 1) {
            var baseTypeNode = getBaseTypeNodeOfClass(target);
            if (baseTypeNode && baseTypeNode.expression.kind !== 79 && baseTypeNode.expression.kind !== 206) {
              return void 0;
            }
          }
          var bases = getBaseTypes(target);
          if (bases.length !== 1) {
            return void 0;
          }
          if (getMembersOfSymbol(type2.symbol).size) {
            return void 0;
          }
          var instantiatedBase = !ts3.length(target.typeParameters) ? bases[0] : instantiateType(bases[0], createTypeMapper(target.typeParameters, getTypeArguments(type2).slice(0, target.typeParameters.length)));
          if (ts3.length(getTypeArguments(type2)) > ts3.length(target.typeParameters)) {
            instantiatedBase = getTypeWithThisArgument(instantiatedBase, ts3.last(getTypeArguments(type2)));
          }
          type2.objectFlags |= 67108864;
          return type2.cachedEquivalentBaseType = instantiatedBase;
        }
        function isEmptyLiteralType(type2) {
          return strictNullChecks ? type2 === implicitNeverType : type2 === undefinedWideningType;
        }
        function isEmptyArrayLiteralType(type2) {
          var elementType = getElementTypeOfArrayType(type2);
          return !!elementType && isEmptyLiteralType(elementType);
        }
        function isTupleLikeType(type2) {
          return isTupleType(type2) || !!getPropertyOfType(type2, "0");
        }
        function isArrayOrTupleLikeType(type2) {
          return isArrayLikeType(type2) || isTupleLikeType(type2);
        }
        function getTupleElementType(type2, index) {
          var propType = getTypeOfPropertyOfType(type2, "" + index);
          if (propType) {
            return propType;
          }
          if (everyType(type2, isTupleType)) {
            return mapType(type2, function(t) {
              return getRestTypeOfTupleType(t) || undefinedType;
            });
          }
          return void 0;
        }
        function isNeitherUnitTypeNorNever(type2) {
          return !(type2.flags & (109440 | 131072));
        }
        function isUnitType(type2) {
          return !!(type2.flags & 109440);
        }
        function isUnitLikeType(type2) {
          return type2.flags & 2097152 ? ts3.some(type2.types, isUnitType) : !!(type2.flags & 109440);
        }
        function extractUnitType(type2) {
          return type2.flags & 2097152 ? ts3.find(type2.types, isUnitType) || type2 : type2;
        }
        function isLiteralType(type2) {
          return type2.flags & 16 ? true : type2.flags & 1048576 ? type2.flags & 1024 ? true : ts3.every(type2.types, isUnitType) : isUnitType(type2);
        }
        function getBaseTypeOfLiteralType(type2) {
          return type2.flags & 1024 ? getBaseTypeOfEnumLiteralType(type2) : type2.flags & (128 | 134217728 | 268435456) ? stringType : type2.flags & 256 ? numberType : type2.flags & 2048 ? bigintType : type2.flags & 512 ? booleanType : type2.flags & 1048576 ? mapType(type2, getBaseTypeOfLiteralType) : type2;
        }
        function getWidenedLiteralType(type2) {
          return type2.flags & 1024 && isFreshLiteralType(type2) ? getBaseTypeOfEnumLiteralType(type2) : type2.flags & 128 && isFreshLiteralType(type2) ? stringType : type2.flags & 256 && isFreshLiteralType(type2) ? numberType : type2.flags & 2048 && isFreshLiteralType(type2) ? bigintType : type2.flags & 512 && isFreshLiteralType(type2) ? booleanType : type2.flags & 1048576 ? mapType(type2, getWidenedLiteralType) : type2;
        }
        function getWidenedUniqueESSymbolType(type2) {
          return type2.flags & 8192 ? esSymbolType : type2.flags & 1048576 ? mapType(type2, getWidenedUniqueESSymbolType) : type2;
        }
        function getWidenedLiteralLikeTypeForContextualType(type2, contextualType) {
          if (!isLiteralOfContextualType(type2, contextualType)) {
            type2 = getWidenedUniqueESSymbolType(getWidenedLiteralType(type2));
          }
          return type2;
        }
        function getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(type2, contextualSignatureReturnType, isAsync) {
          if (type2 && isUnitType(type2)) {
            var contextualType = !contextualSignatureReturnType ? void 0 : isAsync ? getPromisedTypeOfPromise(contextualSignatureReturnType) : contextualSignatureReturnType;
            type2 = getWidenedLiteralLikeTypeForContextualType(type2, contextualType);
          }
          return type2;
        }
        function getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(type2, contextualSignatureReturnType, kind, isAsyncGenerator) {
          if (type2 && isUnitType(type2)) {
            var contextualType = !contextualSignatureReturnType ? void 0 : getIterationTypeOfGeneratorFunctionReturnType(kind, contextualSignatureReturnType, isAsyncGenerator);
            type2 = getWidenedLiteralLikeTypeForContextualType(type2, contextualType);
          }
          return type2;
        }
        function isTupleType(type2) {
          return !!(ts3.getObjectFlags(type2) & 4 && type2.target.objectFlags & 8);
        }
        function isGenericTupleType(type2) {
          return isTupleType(type2) && !!(type2.target.combinedFlags & 8);
        }
        function isSingleElementGenericTupleType(type2) {
          return isGenericTupleType(type2) && type2.target.elementFlags.length === 1;
        }
        function getRestTypeOfTupleType(type2) {
          return getElementTypeOfSliceOfTupleType(type2, type2.target.fixedLength);
        }
        function getRestArrayTypeOfTupleType(type2) {
          var restType = getRestTypeOfTupleType(type2);
          return restType && createArrayType(restType);
        }
        function getElementTypeOfSliceOfTupleType(type2, index, endSkipCount, writing) {
          if (endSkipCount === void 0) {
            endSkipCount = 0;
          }
          if (writing === void 0) {
            writing = false;
          }
          var length = getTypeReferenceArity(type2) - endSkipCount;
          if (index < length) {
            var typeArguments = getTypeArguments(type2);
            var elementTypes = [];
            for (var i = index; i < length; i++) {
              var t = typeArguments[i];
              elementTypes.push(type2.target.elementFlags[i] & 8 ? getIndexedAccessType(t, numberType) : t);
            }
            return writing ? getIntersectionType(elementTypes) : getUnionType(elementTypes);
          }
          return void 0;
        }
        function isTupleTypeStructureMatching(t1, t2) {
          return getTypeReferenceArity(t1) === getTypeReferenceArity(t2) && ts3.every(t1.target.elementFlags, function(f, i) {
            return (f & 12) === (t2.target.elementFlags[i] & 12);
          });
        }
        function isZeroBigInt(_a) {
          var value = _a.value;
          return value.base10Value === "0";
        }
        function getFalsyFlagsOfTypes(types2) {
          var result2 = 0;
          for (var _i = 0, types_14 = types2; _i < types_14.length; _i++) {
            var t = types_14[_i];
            result2 |= getFalsyFlags(t);
          }
          return result2;
        }
        function getFalsyFlags(type2) {
          return type2.flags & 1048576 ? getFalsyFlagsOfTypes(type2.types) : type2.flags & 128 ? type2.value === "" ? 128 : 0 : type2.flags & 256 ? type2.value === 0 ? 256 : 0 : type2.flags & 2048 ? isZeroBigInt(type2) ? 2048 : 0 : type2.flags & 512 ? type2 === falseType || type2 === regularFalseType ? 512 : 0 : type2.flags & 117724;
        }
        function removeDefinitelyFalsyTypes(type2) {
          return getFalsyFlags(type2) & 117632 ? filterType(type2, function(t) {
            return !(getFalsyFlags(t) & 117632);
          }) : type2;
        }
        function extractDefinitelyFalsyTypes(type2) {
          return mapType(type2, getDefinitelyFalsyPartOfType);
        }
        function getDefinitelyFalsyPartOfType(type2) {
          return type2.flags & 4 ? emptyStringType : type2.flags & 8 ? zeroType : type2.flags & 64 ? zeroBigIntType : type2 === regularFalseType || type2 === falseType || type2.flags & (16384 | 32768 | 65536 | 3) || type2.flags & 128 && type2.value === "" || type2.flags & 256 && type2.value === 0 || type2.flags & 2048 && isZeroBigInt(type2) ? type2 : neverType;
        }
        function getNullableType(type2, flags) {
          var missing = flags & ~type2.flags & (32768 | 65536);
          return missing === 0 ? type2 : missing === 32768 ? getUnionType([type2, undefinedType]) : missing === 65536 ? getUnionType([type2, nullType]) : getUnionType([type2, undefinedType, nullType]);
        }
        function getOptionalType(type2, isProperty) {
          if (isProperty === void 0) {
            isProperty = false;
          }
          ts3.Debug.assert(strictNullChecks);
          return type2.flags & 32768 ? type2 : getUnionType([type2, isProperty ? missingType : undefinedType]);
        }
        function getGlobalNonNullableTypeInstantiation(type2) {
          var reducedType = getTypeWithFacts(type2, 2097152);
          if (!deferredGlobalNonNullableTypeAlias) {
            deferredGlobalNonNullableTypeAlias = getGlobalSymbol("NonNullable", 524288, void 0) || unknownSymbol;
          }
          return deferredGlobalNonNullableTypeAlias !== unknownSymbol ? getTypeAliasInstantiation(deferredGlobalNonNullableTypeAlias, [reducedType]) : reducedType;
        }
        function getNonNullableType(type2) {
          return strictNullChecks ? getGlobalNonNullableTypeInstantiation(type2) : type2;
        }
        function addOptionalTypeMarker(type2) {
          return strictNullChecks ? getUnionType([type2, optionalType]) : type2;
        }
        function removeOptionalTypeMarker(type2) {
          return strictNullChecks ? removeType(type2, optionalType) : type2;
        }
        function propagateOptionalTypeMarker(type2, node, wasOptional) {
          return wasOptional ? ts3.isOutermostOptionalChain(node) ? getOptionalType(type2) : addOptionalTypeMarker(type2) : type2;
        }
        function getOptionalExpressionType(exprType, expression) {
          return ts3.isExpressionOfOptionalChainRoot(expression) ? getNonNullableType(exprType) : ts3.isOptionalChain(expression) ? removeOptionalTypeMarker(exprType) : exprType;
        }
        function removeMissingType(type2, isOptional) {
          return exactOptionalPropertyTypes && isOptional ? removeType(type2, missingType) : type2;
        }
        function containsMissingType(type2) {
          return exactOptionalPropertyTypes && (type2 === missingType || type2.flags & 1048576 && containsType(type2.types, missingType));
        }
        function removeMissingOrUndefinedType(type2) {
          return exactOptionalPropertyTypes ? removeType(type2, missingType) : getTypeWithFacts(type2, 524288);
        }
        function isCoercibleUnderDoubleEquals(source, target) {
          return (source.flags & (8 | 4 | 512)) !== 0 && (target.flags & (8 | 4 | 16)) !== 0;
        }
        function isObjectTypeWithInferableIndex(type2) {
          return type2.flags & 2097152 ? ts3.every(type2.types, isObjectTypeWithInferableIndex) : !!(type2.symbol && (type2.symbol.flags & (4096 | 2048 | 384 | 512)) !== 0 && !(type2.symbol.flags & 32) && !typeHasCallOrConstructSignatures(type2)) || !!(ts3.getObjectFlags(type2) & 1024 && isObjectTypeWithInferableIndex(type2.source));
        }
        function createSymbolWithType(source, type2) {
          var symbol = createSymbol(source.flags, source.escapedName, ts3.getCheckFlags(source) & 8);
          symbol.declarations = source.declarations;
          symbol.parent = source.parent;
          symbol.type = type2;
          symbol.target = source;
          if (source.valueDeclaration) {
            symbol.valueDeclaration = source.valueDeclaration;
          }
          var nameType = getSymbolLinks(source).nameType;
          if (nameType) {
            symbol.nameType = nameType;
          }
          return symbol;
        }
        function transformTypeOfMembers(type2, f) {
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfObjectType(type2); _i < _a.length; _i++) {
            var property = _a[_i];
            var original = getTypeOfSymbol(property);
            var updated = f(original);
            members.set(property.escapedName, updated === original ? property : createSymbolWithType(property, updated));
          }
          return members;
        }
        function getRegularTypeOfObjectLiteral(type2) {
          if (!(isObjectLiteralType(type2) && ts3.getObjectFlags(type2) & 8192)) {
            return type2;
          }
          var regularType = type2.regularType;
          if (regularType) {
            return regularType;
          }
          var resolved = type2;
          var members = transformTypeOfMembers(type2, getRegularTypeOfObjectLiteral);
          var regularNew = createAnonymousType(resolved.symbol, members, resolved.callSignatures, resolved.constructSignatures, resolved.indexInfos);
          regularNew.flags = resolved.flags;
          regularNew.objectFlags |= resolved.objectFlags & ~8192;
          type2.regularType = regularNew;
          return regularNew;
        }
        function createWideningContext(parent, propertyName, siblings) {
          return { parent, propertyName, siblings, resolvedProperties: void 0 };
        }
        function getSiblingsOfContext(context) {
          if (!context.siblings) {
            var siblings_1 = [];
            for (var _i = 0, _a = getSiblingsOfContext(context.parent); _i < _a.length; _i++) {
              var type2 = _a[_i];
              if (isObjectLiteralType(type2)) {
                var prop = getPropertyOfObjectType(type2, context.propertyName);
                if (prop) {
                  forEachType(getTypeOfSymbol(prop), function(t) {
                    siblings_1.push(t);
                  });
                }
              }
            }
            context.siblings = siblings_1;
          }
          return context.siblings;
        }
        function getPropertiesOfContext(context) {
          if (!context.resolvedProperties) {
            var names = new ts3.Map();
            for (var _i = 0, _a = getSiblingsOfContext(context); _i < _a.length; _i++) {
              var t = _a[_i];
              if (isObjectLiteralType(t) && !(ts3.getObjectFlags(t) & 2097152)) {
                for (var _b = 0, _c = getPropertiesOfType(t); _b < _c.length; _b++) {
                  var prop = _c[_b];
                  names.set(prop.escapedName, prop);
                }
              }
            }
            context.resolvedProperties = ts3.arrayFrom(names.values());
          }
          return context.resolvedProperties;
        }
        function getWidenedProperty(prop, context) {
          if (!(prop.flags & 4)) {
            return prop;
          }
          var original = getTypeOfSymbol(prop);
          var propContext = context && createWideningContext(context, prop.escapedName, void 0);
          var widened = getWidenedTypeWithContext(original, propContext);
          return widened === original ? prop : createSymbolWithType(prop, widened);
        }
        function getUndefinedProperty(prop) {
          var cached = undefinedProperties.get(prop.escapedName);
          if (cached) {
            return cached;
          }
          var result2 = createSymbolWithType(prop, missingType);
          result2.flags |= 16777216;
          undefinedProperties.set(prop.escapedName, result2);
          return result2;
        }
        function getWidenedTypeOfObjectLiteral(type2, context) {
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfObjectType(type2); _i < _a.length; _i++) {
            var prop = _a[_i];
            members.set(prop.escapedName, getWidenedProperty(prop, context));
          }
          if (context) {
            for (var _b = 0, _c = getPropertiesOfContext(context); _b < _c.length; _b++) {
              var prop = _c[_b];
              if (!members.has(prop.escapedName)) {
                members.set(prop.escapedName, getUndefinedProperty(prop));
              }
            }
          }
          var result2 = createAnonymousType(type2.symbol, members, ts3.emptyArray, ts3.emptyArray, ts3.sameMap(getIndexInfosOfType(type2), function(info) {
            return createIndexInfo(info.keyType, getWidenedType(info.type), info.isReadonly);
          }));
          result2.objectFlags |= ts3.getObjectFlags(type2) & (4096 | 262144);
          return result2;
        }
        function getWidenedType(type2) {
          return getWidenedTypeWithContext(type2, void 0);
        }
        function getWidenedTypeWithContext(type2, context) {
          if (ts3.getObjectFlags(type2) & 196608) {
            if (context === void 0 && type2.widened) {
              return type2.widened;
            }
            var result2 = void 0;
            if (type2.flags & (1 | 98304)) {
              result2 = anyType;
            } else if (isObjectLiteralType(type2)) {
              result2 = getWidenedTypeOfObjectLiteral(type2, context);
            } else if (type2.flags & 1048576) {
              var unionContext_1 = context || createWideningContext(void 0, void 0, type2.types);
              var widenedTypes = ts3.sameMap(type2.types, function(t) {
                return t.flags & 98304 ? t : getWidenedTypeWithContext(t, unionContext_1);
              });
              result2 = getUnionType(widenedTypes, ts3.some(widenedTypes, isEmptyObjectType) ? 2 : 1);
            } else if (type2.flags & 2097152) {
              result2 = getIntersectionType(ts3.sameMap(type2.types, getWidenedType));
            } else if (isArrayOrTupleType(type2)) {
              result2 = createTypeReference(type2.target, ts3.sameMap(getTypeArguments(type2), getWidenedType));
            }
            if (result2 && context === void 0) {
              type2.widened = result2;
            }
            return result2 || type2;
          }
          return type2;
        }
        function reportWideningErrorsInType(type2) {
          var errorReported = false;
          if (ts3.getObjectFlags(type2) & 65536) {
            if (type2.flags & 1048576) {
              if (ts3.some(type2.types, isEmptyObjectType)) {
                errorReported = true;
              } else {
                for (var _i = 0, _a = type2.types; _i < _a.length; _i++) {
                  var t = _a[_i];
                  if (reportWideningErrorsInType(t)) {
                    errorReported = true;
                  }
                }
              }
            }
            if (isArrayOrTupleType(type2)) {
              for (var _b = 0, _c = getTypeArguments(type2); _b < _c.length; _b++) {
                var t = _c[_b];
                if (reportWideningErrorsInType(t)) {
                  errorReported = true;
                }
              }
            }
            if (isObjectLiteralType(type2)) {
              for (var _d = 0, _e = getPropertiesOfObjectType(type2); _d < _e.length; _d++) {
                var p = _e[_d];
                var t = getTypeOfSymbol(p);
                if (ts3.getObjectFlags(t) & 65536) {
                  if (!reportWideningErrorsInType(t)) {
                    error(p.valueDeclaration, ts3.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type, symbolToString(p), typeToString(getWidenedType(t)));
                  }
                  errorReported = true;
                }
              }
            }
          }
          return errorReported;
        }
        function reportImplicitAny(declaration, type2, wideningKind) {
          var typeAsString = typeToString(getWidenedType(type2));
          if (ts3.isInJSFile(declaration) && !ts3.isCheckJsEnabledForFile(ts3.getSourceFileOfNode(declaration), compilerOptions)) {
            return;
          }
          var diagnostic;
          switch (declaration.kind) {
            case 221:
            case 167:
            case 166:
              diagnostic = noImplicitAny ? ts3.Diagnostics.Member_0_implicitly_has_an_1_type : ts3.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
              break;
            case 164:
              var param = declaration;
              if (ts3.isIdentifier(param.name) && (ts3.isCallSignatureDeclaration(param.parent) || ts3.isMethodSignature(param.parent) || ts3.isFunctionTypeNode(param.parent)) && param.parent.parameters.indexOf(param) > -1 && (resolveName(param, param.name.escapedText, 788968, void 0, param.name.escapedText, true) || param.name.originalKeywordKind && ts3.isTypeNodeKind(param.name.originalKeywordKind))) {
                var newName = "arg" + param.parent.parameters.indexOf(param);
                var typeName = ts3.declarationNameToString(param.name) + (param.dotDotDotToken ? "[]" : "");
                errorOrSuggestion(noImplicitAny, declaration, ts3.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1, newName, typeName);
                return;
              }
              diagnostic = declaration.dotDotDotToken ? noImplicitAny ? ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type : ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage : noImplicitAny ? ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type : ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
              break;
            case 203:
              diagnostic = ts3.Diagnostics.Binding_element_0_implicitly_has_an_1_type;
              if (!noImplicitAny) {
                return;
              }
              break;
            case 317:
              error(declaration, ts3.Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
              return;
            case 256:
            case 169:
            case 168:
            case 172:
            case 173:
            case 213:
            case 214:
              if (noImplicitAny && !declaration.name) {
                if (wideningKind === 3) {
                  error(declaration, ts3.Diagnostics.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation, typeAsString);
                } else {
                  error(declaration, ts3.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
                }
                return;
              }
              diagnostic = !noImplicitAny ? ts3.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage : wideningKind === 3 ? ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type : ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type;
              break;
            case 195:
              if (noImplicitAny) {
                error(declaration, ts3.Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type);
              }
              return;
            default:
              diagnostic = noImplicitAny ? ts3.Diagnostics.Variable_0_implicitly_has_an_1_type : ts3.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
          }
          errorOrSuggestion(noImplicitAny, declaration, diagnostic, ts3.declarationNameToString(ts3.getNameOfDeclaration(declaration)), typeAsString);
        }
        function reportErrorsFromWidening(declaration, type2, wideningKind) {
          addLazyDiagnostic(function() {
            if (noImplicitAny && ts3.getObjectFlags(type2) & 65536 && (!wideningKind || !getContextualSignatureForFunctionLikeDeclaration(declaration))) {
              if (!reportWideningErrorsInType(type2)) {
                reportImplicitAny(declaration, type2, wideningKind);
              }
            }
          });
        }
        function applyToParameterTypes(source, target, callback) {
          var sourceCount = getParameterCount(source);
          var targetCount = getParameterCount(target);
          var sourceRestType = getEffectiveRestType(source);
          var targetRestType = getEffectiveRestType(target);
          var targetNonRestCount = targetRestType ? targetCount - 1 : targetCount;
          var paramCount = sourceRestType ? targetNonRestCount : Math.min(sourceCount, targetNonRestCount);
          var sourceThisType = getThisTypeOfSignature(source);
          if (sourceThisType) {
            var targetThisType = getThisTypeOfSignature(target);
            if (targetThisType) {
              callback(sourceThisType, targetThisType);
            }
          }
          for (var i = 0; i < paramCount; i++) {
            callback(getTypeAtPosition(source, i), getTypeAtPosition(target, i));
          }
          if (targetRestType) {
            callback(getRestTypeAtPosition(source, paramCount), targetRestType);
          }
        }
        function applyToReturnTypes(source, target, callback) {
          var sourceTypePredicate = getTypePredicateOfSignature(source);
          var targetTypePredicate = getTypePredicateOfSignature(target);
          if (sourceTypePredicate && targetTypePredicate && typePredicateKindsMatch(sourceTypePredicate, targetTypePredicate) && sourceTypePredicate.type && targetTypePredicate.type) {
            callback(sourceTypePredicate.type, targetTypePredicate.type);
          } else {
            callback(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
          }
        }
        function createInferenceContext(typeParameters, signature, flags, compareTypes) {
          return createInferenceContextWorker(typeParameters.map(createInferenceInfo), signature, flags, compareTypes || compareTypesAssignable);
        }
        function cloneInferenceContext(context, extraFlags) {
          if (extraFlags === void 0) {
            extraFlags = 0;
          }
          return context && createInferenceContextWorker(ts3.map(context.inferences, cloneInferenceInfo), context.signature, context.flags | extraFlags, context.compareTypes);
        }
        function createInferenceContextWorker(inferences, signature, flags, compareTypes) {
          var context = {
            inferences,
            signature,
            flags,
            compareTypes,
            mapper: makeFunctionTypeMapper(function(t) {
              return mapToInferredType(context, t, true);
            }),
            nonFixingMapper: makeFunctionTypeMapper(function(t) {
              return mapToInferredType(context, t, false);
            })
          };
          return context;
        }
        function mapToInferredType(context, t, fix) {
          var inferences = context.inferences;
          for (var i = 0; i < inferences.length; i++) {
            var inference = inferences[i];
            if (t === inference.typeParameter) {
              if (fix && !inference.isFixed) {
                inferFromIntraExpressionSites(context);
                clearCachedInferences(inferences);
                inference.isFixed = true;
              }
              return getInferredType(context, i);
            }
          }
          return t;
        }
        function clearCachedInferences(inferences) {
          for (var _i = 0, inferences_1 = inferences; _i < inferences_1.length; _i++) {
            var inference = inferences_1[_i];
            if (!inference.isFixed) {
              inference.inferredType = void 0;
            }
          }
        }
        function addIntraExpressionInferenceSite(context, node, type2) {
          var _a;
          ((_a = context.intraExpressionInferenceSites) !== null && _a !== void 0 ? _a : context.intraExpressionInferenceSites = []).push({ node, type: type2 });
        }
        function inferFromIntraExpressionSites(context) {
          if (context.intraExpressionInferenceSites) {
            for (var _i = 0, _a = context.intraExpressionInferenceSites; _i < _a.length; _i++) {
              var _b = _a[_i], node = _b.node, type2 = _b.type;
              var contextualType = node.kind === 169 ? getContextualTypeForObjectLiteralMethod(node, 2) : getContextualType(node, 2);
              if (contextualType) {
                inferTypes(context.inferences, type2, contextualType);
              }
            }
            context.intraExpressionInferenceSites = void 0;
          }
        }
        function createInferenceInfo(typeParameter) {
          return {
            typeParameter,
            candidates: void 0,
            contraCandidates: void 0,
            inferredType: void 0,
            priority: void 0,
            topLevel: true,
            isFixed: false,
            impliedArity: void 0
          };
        }
        function cloneInferenceInfo(inference) {
          return {
            typeParameter: inference.typeParameter,
            candidates: inference.candidates && inference.candidates.slice(),
            contraCandidates: inference.contraCandidates && inference.contraCandidates.slice(),
            inferredType: inference.inferredType,
            priority: inference.priority,
            topLevel: inference.topLevel,
            isFixed: inference.isFixed,
            impliedArity: inference.impliedArity
          };
        }
        function cloneInferredPartOfContext(context) {
          var inferences = ts3.filter(context.inferences, hasInferenceCandidates);
          return inferences.length ? createInferenceContextWorker(ts3.map(inferences, cloneInferenceInfo), context.signature, context.flags, context.compareTypes) : void 0;
        }
        function getMapperFromContext(context) {
          return context && context.mapper;
        }
        function couldContainTypeVariables(type2) {
          var objectFlags = ts3.getObjectFlags(type2);
          if (objectFlags & 524288) {
            return !!(objectFlags & 1048576);
          }
          var result2 = !!(type2.flags & 465829888 || type2.flags & 524288 && !isNonGenericTopLevelType(type2) && (objectFlags & 4 && (type2.node || ts3.forEach(getTypeArguments(type2), couldContainTypeVariables)) || objectFlags & 16 && type2.symbol && type2.symbol.flags & (16 | 8192 | 32 | 2048 | 4096) && type2.symbol.declarations || objectFlags & (32 | 1024 | 4194304 | 8388608)) || type2.flags & 3145728 && !(type2.flags & 1024) && !isNonGenericTopLevelType(type2) && ts3.some(type2.types, couldContainTypeVariables));
          if (type2.flags & 3899393) {
            type2.objectFlags |= 524288 | (result2 ? 1048576 : 0);
          }
          return result2;
        }
        function isNonGenericTopLevelType(type2) {
          if (type2.aliasSymbol && !type2.aliasTypeArguments) {
            var declaration = ts3.getDeclarationOfKind(type2.aliasSymbol, 259);
            return !!(declaration && ts3.findAncestor(declaration.parent, function(n) {
              return n.kind === 305 ? true : n.kind === 261 ? false : "quit";
            }));
          }
          return false;
        }
        function isTypeParameterAtTopLevel(type2, typeParameter) {
          return !!(type2 === typeParameter || type2.flags & 3145728 && ts3.some(type2.types, function(t) {
            return isTypeParameterAtTopLevel(t, typeParameter);
          }) || type2.flags & 16777216 && (getTrueTypeFromConditionalType(type2) === typeParameter || getFalseTypeFromConditionalType(type2) === typeParameter));
        }
        function createEmptyObjectTypeFromStringLiteral(type2) {
          var members = ts3.createSymbolTable();
          forEachType(type2, function(t) {
            if (!(t.flags & 128)) {
              return;
            }
            var name = ts3.escapeLeadingUnderscores(t.value);
            var literalProp = createSymbol(4, name);
            literalProp.type = anyType;
            if (t.symbol) {
              literalProp.declarations = t.symbol.declarations;
              literalProp.valueDeclaration = t.symbol.valueDeclaration;
            }
            members.set(name, literalProp);
          });
          var indexInfos = type2.flags & 4 ? [createIndexInfo(stringType, emptyObjectType, false)] : ts3.emptyArray;
          return createAnonymousType(void 0, members, ts3.emptyArray, ts3.emptyArray, indexInfos);
        }
        function inferTypeForHomomorphicMappedType(source, target, constraint) {
          if (inInferTypeForHomomorphicMappedType) {
            return void 0;
          }
          var key = source.id + "," + target.id + "," + constraint.id;
          if (reverseMappedCache.has(key)) {
            return reverseMappedCache.get(key);
          }
          inInferTypeForHomomorphicMappedType = true;
          var type2 = createReverseMappedType(source, target, constraint);
          inInferTypeForHomomorphicMappedType = false;
          reverseMappedCache.set(key, type2);
          return type2;
        }
        function isPartiallyInferableType(type2) {
          return !(ts3.getObjectFlags(type2) & 262144) || isObjectLiteralType(type2) && ts3.some(getPropertiesOfType(type2), function(prop) {
            return isPartiallyInferableType(getTypeOfSymbol(prop));
          }) || isTupleType(type2) && ts3.some(getTypeArguments(type2), isPartiallyInferableType);
        }
        function createReverseMappedType(source, target, constraint) {
          if (!(getIndexInfoOfType(source, stringType) || getPropertiesOfType(source).length !== 0 && isPartiallyInferableType(source))) {
            return void 0;
          }
          if (isArrayType(source)) {
            return createArrayType(inferReverseMappedType(getTypeArguments(source)[0], target, constraint), isReadonlyArrayType(source));
          }
          if (isTupleType(source)) {
            var elementTypes = ts3.map(getTypeArguments(source), function(t) {
              return inferReverseMappedType(t, target, constraint);
            });
            var elementFlags = getMappedTypeModifiers(target) & 4 ? ts3.sameMap(source.target.elementFlags, function(f) {
              return f & 2 ? 1 : f;
            }) : source.target.elementFlags;
            return createTupleType(elementTypes, elementFlags, source.target.readonly, source.target.labeledElementDeclarations);
          }
          var reversed = createObjectType(1024 | 16, void 0);
          reversed.source = source;
          reversed.mappedType = target;
          reversed.constraintType = constraint;
          return reversed;
        }
        function getTypeOfReverseMappedSymbol(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            links.type = inferReverseMappedType(symbol.propertyType, symbol.mappedType, symbol.constraintType);
          }
          return links.type;
        }
        function inferReverseMappedType(sourceType, target, constraint) {
          var typeParameter = getIndexedAccessType(constraint.type, getTypeParameterFromMappedType(target));
          var templateType = getTemplateTypeFromMappedType(target);
          var inference = createInferenceInfo(typeParameter);
          inferTypes([inference], sourceType, templateType);
          return getTypeFromInference(inference) || unknownType;
        }
        function getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties) {
          var properties, _i, properties_2, targetProp, sourceProp, targetType, sourceType;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                properties = getPropertiesOfType(target);
                _i = 0, properties_2 = properties;
                _a.label = 1;
              case 1:
                if (!(_i < properties_2.length))
                  return [3, 6];
                targetProp = properties_2[_i];
                if (isStaticPrivateIdentifierProperty(targetProp)) {
                  return [3, 5];
                }
                if (!(requireOptionalProperties || !(targetProp.flags & 16777216 || ts3.getCheckFlags(targetProp) & 48)))
                  return [3, 5];
                sourceProp = getPropertyOfType(source, targetProp.escapedName);
                if (!!sourceProp)
                  return [3, 3];
                return [4, targetProp];
              case 2:
                _a.sent();
                return [3, 5];
              case 3:
                if (!matchDiscriminantProperties)
                  return [3, 5];
                targetType = getTypeOfSymbol(targetProp);
                if (!(targetType.flags & 109440))
                  return [3, 5];
                sourceType = getTypeOfSymbol(sourceProp);
                if (!!(sourceType.flags & 1 || getRegularTypeOfLiteralType(sourceType) === getRegularTypeOfLiteralType(targetType)))
                  return [3, 5];
                return [4, targetProp];
              case 4:
                _a.sent();
                _a.label = 5;
              case 5:
                _i++;
                return [3, 1];
              case 6:
                return [2];
            }
          });
        }
        function getUnmatchedProperty(source, target, requireOptionalProperties, matchDiscriminantProperties) {
          var result2 = getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties).next();
          if (!result2.done)
            return result2.value;
        }
        function tupleTypesDefinitelyUnrelated(source, target) {
          return !(target.target.combinedFlags & 8) && target.target.minLength > source.target.minLength || !target.target.hasRestElement && (source.target.hasRestElement || target.target.fixedLength < source.target.fixedLength);
        }
        function typesDefinitelyUnrelated(source, target) {
          return isTupleType(source) && isTupleType(target) ? tupleTypesDefinitelyUnrelated(source, target) : !!getUnmatchedProperty(source, target, false, true) && !!getUnmatchedProperty(target, source, false, false);
        }
        function getTypeFromInference(inference) {
          return inference.candidates ? getUnionType(inference.candidates, 2) : inference.contraCandidates ? getIntersectionType(inference.contraCandidates) : void 0;
        }
        function hasSkipDirectInferenceFlag(node) {
          return !!getNodeLinks(node).skipDirectInference;
        }
        function isFromInferenceBlockedSource(type2) {
          return !!(type2.symbol && ts3.some(type2.symbol.declarations, hasSkipDirectInferenceFlag));
        }
        function templateLiteralTypesDefinitelyUnrelated(source, target) {
          var sourceStart = source.texts[0];
          var targetStart = target.texts[0];
          var sourceEnd = source.texts[source.texts.length - 1];
          var targetEnd = target.texts[target.texts.length - 1];
          var startLen = Math.min(sourceStart.length, targetStart.length);
          var endLen = Math.min(sourceEnd.length, targetEnd.length);
          return sourceStart.slice(0, startLen) !== targetStart.slice(0, startLen) || sourceEnd.slice(sourceEnd.length - endLen) !== targetEnd.slice(targetEnd.length - endLen);
        }
        function isValidBigIntString(s) {
          var scanner = ts3.createScanner(99, false);
          var success = true;
          scanner.setOnError(function() {
            return success = false;
          });
          scanner.setText(s + "n");
          var result2 = scanner.scan();
          if (result2 === 40) {
            result2 = scanner.scan();
          }
          var flags = scanner.getTokenFlags();
          return success && result2 === 9 && scanner.getTextPos() === s.length + 1 && !(flags & 512);
        }
        function isValidTypeForTemplateLiteralPlaceholder(source, target) {
          if (source === target || target.flags & (1 | 4)) {
            return true;
          }
          if (source.flags & 128) {
            var value = source.value;
            return !!(target.flags & 8 && value !== "" && isFinite(+value) || target.flags & 64 && value !== "" && isValidBigIntString(value) || target.flags & (512 | 98304) && value === target.intrinsicName);
          }
          if (source.flags & 134217728) {
            var texts = source.texts;
            return texts.length === 2 && texts[0] === "" && texts[1] === "" && isTypeAssignableTo(source.types[0], target);
          }
          return isTypeAssignableTo(source, target);
        }
        function inferTypesFromTemplateLiteralType(source, target) {
          return source.flags & 128 ? inferFromLiteralPartsToTemplateLiteral([source.value], ts3.emptyArray, target) : source.flags & 134217728 ? ts3.arraysEqual(source.texts, target.texts) ? ts3.map(source.types, getStringLikeTypeForType) : inferFromLiteralPartsToTemplateLiteral(source.texts, source.types, target) : void 0;
        }
        function isTypeMatchedByTemplateLiteralType(source, target) {
          var inferences = inferTypesFromTemplateLiteralType(source, target);
          return !!inferences && ts3.every(inferences, function(r, i) {
            return isValidTypeForTemplateLiteralPlaceholder(r, target.types[i]);
          });
        }
        function getStringLikeTypeForType(type2) {
          return type2.flags & (1 | 402653316) ? type2 : getTemplateLiteralType(["", ""], [type2]);
        }
        function inferFromLiteralPartsToTemplateLiteral(sourceTexts, sourceTypes, target) {
          var lastSourceIndex = sourceTexts.length - 1;
          var sourceStartText = sourceTexts[0];
          var sourceEndText = sourceTexts[lastSourceIndex];
          var targetTexts = target.texts;
          var lastTargetIndex = targetTexts.length - 1;
          var targetStartText = targetTexts[0];
          var targetEndText = targetTexts[lastTargetIndex];
          if (lastSourceIndex === 0 && sourceStartText.length < targetStartText.length + targetEndText.length || !sourceStartText.startsWith(targetStartText) || !sourceEndText.endsWith(targetEndText))
            return void 0;
          var remainingEndText = sourceEndText.slice(0, sourceEndText.length - targetEndText.length);
          var matches = [];
          var seg = 0;
          var pos = targetStartText.length;
          for (var i = 1; i < lastTargetIndex; i++) {
            var delim = targetTexts[i];
            if (delim.length > 0) {
              var s = seg;
              var p = pos;
              while (true) {
                p = getSourceText(s).indexOf(delim, p);
                if (p >= 0)
                  break;
                s++;
                if (s === sourceTexts.length)
                  return void 0;
                p = 0;
              }
              addMatch(s, p);
              pos += delim.length;
            } else if (pos < getSourceText(seg).length) {
              addMatch(seg, pos + 1);
            } else if (seg < lastSourceIndex) {
              addMatch(seg + 1, 0);
            } else {
              return void 0;
            }
          }
          addMatch(lastSourceIndex, getSourceText(lastSourceIndex).length);
          return matches;
          function getSourceText(index) {
            return index < lastSourceIndex ? sourceTexts[index] : remainingEndText;
          }
          function addMatch(s2, p2) {
            var matchType = s2 === seg ? getStringLiteralType(getSourceText(s2).slice(pos, p2)) : getTemplateLiteralType(__spreadArray(__spreadArray([sourceTexts[seg].slice(pos)], sourceTexts.slice(seg + 1, s2), true), [getSourceText(s2).slice(0, p2)], false), sourceTypes.slice(seg, s2));
            matches.push(matchType);
            seg = s2;
            pos = p2;
          }
        }
        function inferTypes(inferences, originalSource, originalTarget, priority, contravariant) {
          if (priority === void 0) {
            priority = 0;
          }
          if (contravariant === void 0) {
            contravariant = false;
          }
          var bivariant = false;
          var propagationType;
          var inferencePriority = 2048;
          var allowComplexConstraintInference = true;
          var visited;
          var sourceStack;
          var targetStack;
          var expandingFlags = 0;
          inferFromTypes(originalSource, originalTarget);
          function inferFromTypes(source, target) {
            if (!couldContainTypeVariables(target)) {
              return;
            }
            if (source === wildcardType) {
              var savePropagationType = propagationType;
              propagationType = source;
              inferFromTypes(target, target);
              propagationType = savePropagationType;
              return;
            }
            if (source.aliasSymbol && source.aliasTypeArguments && source.aliasSymbol === target.aliasSymbol) {
              inferFromTypeArguments(source.aliasTypeArguments, target.aliasTypeArguments, getAliasVariances(source.aliasSymbol));
              return;
            }
            if (source === target && source.flags & 3145728) {
              for (var _i = 0, _a = source.types; _i < _a.length; _i++) {
                var t = _a[_i];
                inferFromTypes(t, t);
              }
              return;
            }
            if (target.flags & 1048576) {
              var _b = inferFromMatchingTypes(source.flags & 1048576 ? source.types : [source], target.types, isTypeOrBaseIdenticalTo), tempSources = _b[0], tempTargets = _b[1];
              var _c = inferFromMatchingTypes(tempSources, tempTargets, isTypeCloselyMatchedBy), sources = _c[0], targets = _c[1];
              if (targets.length === 0) {
                return;
              }
              target = getUnionType(targets);
              if (sources.length === 0) {
                inferWithPriority(source, target, 1);
                return;
              }
              source = getUnionType(sources);
            } else if (target.flags & 2097152 && ts3.some(target.types, function(t2) {
              return !!getInferenceInfoForType(t2) || isGenericMappedType(t2) && !!getInferenceInfoForType(getHomomorphicTypeVariable(t2) || neverType);
            })) {
              if (!(source.flags & 1048576)) {
                var _d = inferFromMatchingTypes(source.flags & 2097152 ? source.types : [source], target.types, isTypeIdenticalTo), sources = _d[0], targets = _d[1];
                if (sources.length === 0 || targets.length === 0) {
                  return;
                }
                source = getIntersectionType(sources);
                target = getIntersectionType(targets);
              }
            } else if (target.flags & (8388608 | 33554432)) {
              target = getActualTypeVariable(target);
            }
            if (target.flags & 8650752) {
              if (source === nonInferrableAnyType || source === silentNeverType || priority & 128 && (source === autoType || source === autoArrayType) || isFromInferenceBlockedSource(source)) {
                return;
              }
              var inference = getInferenceInfoForType(target);
              if (inference) {
                if (ts3.getObjectFlags(source) & 262144) {
                  return;
                }
                if (!inference.isFixed) {
                  if (inference.priority === void 0 || priority < inference.priority) {
                    inference.candidates = void 0;
                    inference.contraCandidates = void 0;
                    inference.topLevel = true;
                    inference.priority = priority;
                  }
                  if (priority === inference.priority) {
                    var candidate = propagationType || source;
                    if (contravariant && !bivariant) {
                      if (!ts3.contains(inference.contraCandidates, candidate)) {
                        inference.contraCandidates = ts3.append(inference.contraCandidates, candidate);
                        clearCachedInferences(inferences);
                      }
                    } else if (!ts3.contains(inference.candidates, candidate)) {
                      inference.candidates = ts3.append(inference.candidates, candidate);
                      clearCachedInferences(inferences);
                    }
                  }
                  if (!(priority & 128) && target.flags & 262144 && inference.topLevel && !isTypeParameterAtTopLevel(originalTarget, target)) {
                    inference.topLevel = false;
                    clearCachedInferences(inferences);
                  }
                }
                inferencePriority = Math.min(inferencePriority, priority);
                return;
              }
              var simplified = getSimplifiedType(target, false);
              if (simplified !== target) {
                inferFromTypes(source, simplified);
              } else if (target.flags & 8388608) {
                var indexType = getSimplifiedType(target.indexType, false);
                if (indexType.flags & 465829888) {
                  var simplified_1 = distributeIndexOverObjectType(getSimplifiedType(target.objectType, false), indexType, false);
                  if (simplified_1 && simplified_1 !== target) {
                    inferFromTypes(source, simplified_1);
                  }
                }
              }
            }
            if (ts3.getObjectFlags(source) & 4 && ts3.getObjectFlags(target) & 4 && (source.target === target.target || isArrayType(source) && isArrayType(target)) && !(source.node && target.node)) {
              inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
            } else if (source.flags & 4194304 && target.flags & 4194304) {
              contravariant = !contravariant;
              inferFromTypes(source.type, target.type);
              contravariant = !contravariant;
            } else if ((isLiteralType(source) || source.flags & 4) && target.flags & 4194304) {
              var empty = createEmptyObjectTypeFromStringLiteral(source);
              contravariant = !contravariant;
              inferWithPriority(empty, target.type, 256);
              contravariant = !contravariant;
            } else if (source.flags & 8388608 && target.flags & 8388608) {
              inferFromTypes(source.objectType, target.objectType);
              inferFromTypes(source.indexType, target.indexType);
            } else if (source.flags & 268435456 && target.flags & 268435456) {
              if (source.symbol === target.symbol) {
                inferFromTypes(source.type, target.type);
              }
            } else if (source.flags & 33554432) {
              inferFromTypes(source.baseType, target);
              var oldPriority = priority;
              priority |= 4;
              inferFromTypes(source.substitute, target);
              priority = oldPriority;
            } else if (target.flags & 16777216) {
              invokeOnce(source, target, inferToConditionalType);
            } else if (target.flags & 3145728) {
              inferToMultipleTypes(source, target.types, target.flags);
            } else if (source.flags & 1048576) {
              var sourceTypes = source.types;
              for (var _e = 0, sourceTypes_2 = sourceTypes; _e < sourceTypes_2.length; _e++) {
                var sourceType = sourceTypes_2[_e];
                inferFromTypes(sourceType, target);
              }
            } else if (target.flags & 134217728) {
              inferToTemplateLiteralType(source, target);
            } else {
              source = getReducedType(source);
              if (!(priority & 512 && source.flags & (2097152 | 465829888))) {
                var apparentSource = getApparentType(source);
                if (apparentSource !== source && allowComplexConstraintInference && !(apparentSource.flags & (524288 | 2097152))) {
                  allowComplexConstraintInference = false;
                  return inferFromTypes(apparentSource, target);
                }
                source = apparentSource;
              }
              if (source.flags & (524288 | 2097152)) {
                invokeOnce(source, target, inferFromObjectTypes);
              }
            }
          }
          function inferWithPriority(source, target, newPriority) {
            var savePriority = priority;
            priority |= newPriority;
            inferFromTypes(source, target);
            priority = savePriority;
          }
          function invokeOnce(source, target, action) {
            var key = source.id + "," + target.id;
            var status = visited && visited.get(key);
            if (status !== void 0) {
              inferencePriority = Math.min(inferencePriority, status);
              return;
            }
            (visited || (visited = new ts3.Map())).set(key, -1);
            var saveInferencePriority = inferencePriority;
            inferencePriority = 2048;
            var saveExpandingFlags = expandingFlags;
            var sourceIdentity = getRecursionIdentity(source);
            var targetIdentity = getRecursionIdentity(target);
            if (ts3.contains(sourceStack, sourceIdentity))
              expandingFlags |= 1;
            if (ts3.contains(targetStack, targetIdentity))
              expandingFlags |= 2;
            if (expandingFlags !== 3) {
              (sourceStack || (sourceStack = [])).push(sourceIdentity);
              (targetStack || (targetStack = [])).push(targetIdentity);
              action(source, target);
              targetStack.pop();
              sourceStack.pop();
            } else {
              inferencePriority = -1;
            }
            expandingFlags = saveExpandingFlags;
            visited.set(key, inferencePriority);
            inferencePriority = Math.min(inferencePriority, saveInferencePriority);
          }
          function inferFromMatchingTypes(sources, targets, matches) {
            var matchedSources;
            var matchedTargets;
            for (var _i = 0, targets_1 = targets; _i < targets_1.length; _i++) {
              var t = targets_1[_i];
              for (var _a = 0, sources_1 = sources; _a < sources_1.length; _a++) {
                var s = sources_1[_a];
                if (matches(s, t)) {
                  inferFromTypes(s, t);
                  matchedSources = ts3.appendIfUnique(matchedSources, s);
                  matchedTargets = ts3.appendIfUnique(matchedTargets, t);
                }
              }
            }
            return [
              matchedSources ? ts3.filter(sources, function(t2) {
                return !ts3.contains(matchedSources, t2);
              }) : sources,
              matchedTargets ? ts3.filter(targets, function(t2) {
                return !ts3.contains(matchedTargets, t2);
              }) : targets
            ];
          }
          function inferFromTypeArguments(sourceTypes, targetTypes, variances) {
            var count = sourceTypes.length < targetTypes.length ? sourceTypes.length : targetTypes.length;
            for (var i = 0; i < count; i++) {
              if (i < variances.length && (variances[i] & 7) === 2) {
                inferFromContravariantTypes(sourceTypes[i], targetTypes[i]);
              } else {
                inferFromTypes(sourceTypes[i], targetTypes[i]);
              }
            }
          }
          function inferFromContravariantTypes(source, target) {
            if (strictFunctionTypes || priority & 1024) {
              contravariant = !contravariant;
              inferFromTypes(source, target);
              contravariant = !contravariant;
            } else {
              inferFromTypes(source, target);
            }
          }
          function getInferenceInfoForType(type2) {
            if (type2.flags & 8650752) {
              for (var _i = 0, inferences_2 = inferences; _i < inferences_2.length; _i++) {
                var inference = inferences_2[_i];
                if (type2 === inference.typeParameter) {
                  return inference;
                }
              }
            }
            return void 0;
          }
          function getSingleTypeVariableFromIntersectionTypes(types2) {
            var typeVariable;
            for (var _i = 0, types_15 = types2; _i < types_15.length; _i++) {
              var type2 = types_15[_i];
              var t = type2.flags & 2097152 && ts3.find(type2.types, function(t2) {
                return !!getInferenceInfoForType(t2);
              });
              if (!t || typeVariable && t !== typeVariable) {
                return void 0;
              }
              typeVariable = t;
            }
            return typeVariable;
          }
          function inferToMultipleTypes(source, targets, targetFlags) {
            var typeVariableCount = 0;
            if (targetFlags & 1048576) {
              var nakedTypeVariable = void 0;
              var sources = source.flags & 1048576 ? source.types : [source];
              var matched_1 = new Array(sources.length);
              var inferenceCircularity = false;
              for (var _i = 0, targets_2 = targets; _i < targets_2.length; _i++) {
                var t = targets_2[_i];
                if (getInferenceInfoForType(t)) {
                  nakedTypeVariable = t;
                  typeVariableCount++;
                } else {
                  for (var i = 0; i < sources.length; i++) {
                    var saveInferencePriority = inferencePriority;
                    inferencePriority = 2048;
                    inferFromTypes(sources[i], t);
                    if (inferencePriority === priority)
                      matched_1[i] = true;
                    inferenceCircularity = inferenceCircularity || inferencePriority === -1;
                    inferencePriority = Math.min(inferencePriority, saveInferencePriority);
                  }
                }
              }
              if (typeVariableCount === 0) {
                var intersectionTypeVariable = getSingleTypeVariableFromIntersectionTypes(targets);
                if (intersectionTypeVariable) {
                  inferWithPriority(source, intersectionTypeVariable, 1);
                }
                return;
              }
              if (typeVariableCount === 1 && !inferenceCircularity) {
                var unmatched = ts3.flatMap(sources, function(s, i2) {
                  return matched_1[i2] ? void 0 : s;
                });
                if (unmatched.length) {
                  inferFromTypes(getUnionType(unmatched), nakedTypeVariable);
                  return;
                }
              }
            } else {
              for (var _a = 0, targets_3 = targets; _a < targets_3.length; _a++) {
                var t = targets_3[_a];
                if (getInferenceInfoForType(t)) {
                  typeVariableCount++;
                } else {
                  inferFromTypes(source, t);
                }
              }
            }
            if (targetFlags & 2097152 ? typeVariableCount === 1 : typeVariableCount > 0) {
              for (var _b = 0, targets_4 = targets; _b < targets_4.length; _b++) {
                var t = targets_4[_b];
                if (getInferenceInfoForType(t)) {
                  inferWithPriority(source, t, 1);
                }
              }
            }
          }
          function inferToMappedType(source, target, constraintType) {
            if (constraintType.flags & 1048576) {
              var result2 = false;
              for (var _i = 0, _a = constraintType.types; _i < _a.length; _i++) {
                var type2 = _a[_i];
                result2 = inferToMappedType(source, target, type2) || result2;
              }
              return result2;
            }
            if (constraintType.flags & 4194304) {
              var inference = getInferenceInfoForType(constraintType.type);
              if (inference && !inference.isFixed && !isFromInferenceBlockedSource(source)) {
                var inferredType = inferTypeForHomomorphicMappedType(source, target, constraintType);
                if (inferredType) {
                  inferWithPriority(inferredType, inference.typeParameter, ts3.getObjectFlags(source) & 262144 ? 16 : 8);
                }
              }
              return true;
            }
            if (constraintType.flags & 262144) {
              inferWithPriority(getIndexType(source), constraintType, 32);
              var extendedConstraint = getConstraintOfType(constraintType);
              if (extendedConstraint && inferToMappedType(source, target, extendedConstraint)) {
                return true;
              }
              var propTypes = ts3.map(getPropertiesOfType(source), getTypeOfSymbol);
              var indexTypes = ts3.map(getIndexInfosOfType(source), function(info) {
                return info !== enumNumberIndexInfo ? info.type : neverType;
              });
              inferFromTypes(getUnionType(ts3.concatenate(propTypes, indexTypes)), getTemplateTypeFromMappedType(target));
              return true;
            }
            return false;
          }
          function inferToConditionalType(source, target) {
            if (source.flags & 16777216) {
              inferFromTypes(source.checkType, target.checkType);
              inferFromTypes(source.extendsType, target.extendsType);
              inferFromTypes(getTrueTypeFromConditionalType(source), getTrueTypeFromConditionalType(target));
              inferFromTypes(getFalseTypeFromConditionalType(source), getFalseTypeFromConditionalType(target));
            } else {
              var savePriority = priority;
              priority |= contravariant ? 64 : 0;
              var targetTypes = [getTrueTypeFromConditionalType(target), getFalseTypeFromConditionalType(target)];
              inferToMultipleTypes(source, targetTypes, target.flags);
              priority = savePriority;
            }
          }
          function inferToTemplateLiteralType(source, target) {
            var matches = inferTypesFromTemplateLiteralType(source, target);
            var types2 = target.types;
            if (matches || ts3.every(target.texts, function(s) {
              return s.length === 0;
            })) {
              for (var i = 0; i < types2.length; i++) {
                inferFromTypes(matches ? matches[i] : neverType, types2[i]);
              }
            }
          }
          function inferFromObjectTypes(source, target) {
            if (ts3.getObjectFlags(source) & 4 && ts3.getObjectFlags(target) & 4 && (source.target === target.target || isArrayType(source) && isArrayType(target))) {
              inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
              return;
            }
            if (isGenericMappedType(source) && isGenericMappedType(target)) {
              inferFromTypes(getConstraintTypeFromMappedType(source), getConstraintTypeFromMappedType(target));
              inferFromTypes(getTemplateTypeFromMappedType(source), getTemplateTypeFromMappedType(target));
              var sourceNameType = getNameTypeFromMappedType(source);
              var targetNameType = getNameTypeFromMappedType(target);
              if (sourceNameType && targetNameType)
                inferFromTypes(sourceNameType, targetNameType);
            }
            if (ts3.getObjectFlags(target) & 32 && !target.declaration.nameType) {
              var constraintType = getConstraintTypeFromMappedType(target);
              if (inferToMappedType(source, target, constraintType)) {
                return;
              }
            }
            if (!typesDefinitelyUnrelated(source, target)) {
              if (isArrayOrTupleType(source)) {
                if (isTupleType(target)) {
                  var sourceArity = getTypeReferenceArity(source);
                  var targetArity = getTypeReferenceArity(target);
                  var elementTypes = getTypeArguments(target);
                  var elementFlags = target.target.elementFlags;
                  if (isTupleType(source) && isTupleTypeStructureMatching(source, target)) {
                    for (var i = 0; i < targetArity; i++) {
                      inferFromTypes(getTypeArguments(source)[i], elementTypes[i]);
                    }
                    return;
                  }
                  var startLength = isTupleType(source) ? Math.min(source.target.fixedLength, target.target.fixedLength) : 0;
                  var endLength = Math.min(isTupleType(source) ? getEndElementCount(source.target, 3) : 0, target.target.hasRestElement ? getEndElementCount(target.target, 3) : 0);
                  for (var i = 0; i < startLength; i++) {
                    inferFromTypes(getTypeArguments(source)[i], elementTypes[i]);
                  }
                  if (!isTupleType(source) || sourceArity - startLength - endLength === 1 && source.target.elementFlags[startLength] & 4) {
                    var restType = getTypeArguments(source)[startLength];
                    for (var i = startLength; i < targetArity - endLength; i++) {
                      inferFromTypes(elementFlags[i] & 8 ? createArrayType(restType) : restType, elementTypes[i]);
                    }
                  } else {
                    var middleLength = targetArity - startLength - endLength;
                    if (middleLength === 2 && elementFlags[startLength] & elementFlags[startLength + 1] & 8 && isTupleType(source)) {
                      var targetInfo = getInferenceInfoForType(elementTypes[startLength]);
                      if (targetInfo && targetInfo.impliedArity !== void 0) {
                        inferFromTypes(sliceTupleType(source, startLength, endLength + sourceArity - targetInfo.impliedArity), elementTypes[startLength]);
                        inferFromTypes(sliceTupleType(source, startLength + targetInfo.impliedArity, endLength), elementTypes[startLength + 1]);
                      }
                    } else if (middleLength === 1 && elementFlags[startLength] & 8) {
                      var endsInOptional = target.target.elementFlags[targetArity - 1] & 2;
                      var sourceSlice = isTupleType(source) ? sliceTupleType(source, startLength, endLength) : createArrayType(getTypeArguments(source)[0]);
                      inferWithPriority(sourceSlice, elementTypes[startLength], endsInOptional ? 2 : 0);
                    } else if (middleLength === 1 && elementFlags[startLength] & 4) {
                      var restType = isTupleType(source) ? getElementTypeOfSliceOfTupleType(source, startLength, endLength) : getTypeArguments(source)[0];
                      if (restType) {
                        inferFromTypes(restType, elementTypes[startLength]);
                      }
                    }
                  }
                  for (var i = 0; i < endLength; i++) {
                    inferFromTypes(getTypeArguments(source)[sourceArity - i - 1], elementTypes[targetArity - i - 1]);
                  }
                  return;
                }
                if (isArrayType(target)) {
                  inferFromIndexTypes(source, target);
                  return;
                }
              }
              inferFromProperties(source, target);
              inferFromSignatures(source, target, 0);
              inferFromSignatures(source, target, 1);
              inferFromIndexTypes(source, target);
            }
          }
          function inferFromProperties(source, target) {
            var properties = getPropertiesOfObjectType(target);
            for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
              var targetProp = properties_3[_i];
              var sourceProp = getPropertyOfType(source, targetProp.escapedName);
              if (sourceProp && !ts3.some(sourceProp.declarations, hasSkipDirectInferenceFlag)) {
                inferFromTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
              }
            }
          }
          function inferFromSignatures(source, target, kind) {
            var sourceSignatures = getSignaturesOfType(source, kind);
            var targetSignatures = getSignaturesOfType(target, kind);
            var sourceLen = sourceSignatures.length;
            var targetLen = targetSignatures.length;
            var len = sourceLen < targetLen ? sourceLen : targetLen;
            var skipParameters = !!(ts3.getObjectFlags(source) & 262144);
            for (var i = 0; i < len; i++) {
              inferFromSignature(getBaseSignature(sourceSignatures[sourceLen - len + i]), getErasedSignature(targetSignatures[targetLen - len + i]), skipParameters);
            }
          }
          function inferFromSignature(source, target, skipParameters) {
            if (!skipParameters) {
              var saveBivariant = bivariant;
              var kind = target.declaration ? target.declaration.kind : 0;
              bivariant = bivariant || kind === 169 || kind === 168 || kind === 171;
              applyToParameterTypes(source, target, inferFromContravariantTypes);
              bivariant = saveBivariant;
            }
            applyToReturnTypes(source, target, inferFromTypes);
          }
          function inferFromIndexTypes(source, target) {
            var priority2 = ts3.getObjectFlags(source) & ts3.getObjectFlags(target) & 32 ? 8 : 0;
            var indexInfos = getIndexInfosOfType(target);
            if (isObjectTypeWithInferableIndex(source)) {
              for (var _i = 0, indexInfos_6 = indexInfos; _i < indexInfos_6.length; _i++) {
                var targetInfo = indexInfos_6[_i];
                var propTypes = [];
                for (var _a = 0, _b = getPropertiesOfType(source); _a < _b.length; _a++) {
                  var prop = _b[_a];
                  if (isApplicableIndexType(getLiteralTypeFromProperty(prop, 8576), targetInfo.keyType)) {
                    var propType = getTypeOfSymbol(prop);
                    propTypes.push(prop.flags & 16777216 ? removeMissingOrUndefinedType(propType) : propType);
                  }
                }
                for (var _c = 0, _d = getIndexInfosOfType(source); _c < _d.length; _c++) {
                  var info = _d[_c];
                  if (isApplicableIndexType(info.keyType, targetInfo.keyType)) {
                    propTypes.push(info.type);
                  }
                }
                if (propTypes.length) {
                  inferWithPriority(getUnionType(propTypes), targetInfo.type, priority2);
                }
              }
            }
            for (var _e = 0, indexInfos_7 = indexInfos; _e < indexInfos_7.length; _e++) {
              var targetInfo = indexInfos_7[_e];
              var sourceInfo = getApplicableIndexInfo(source, targetInfo.keyType);
              if (sourceInfo) {
                inferWithPriority(sourceInfo.type, targetInfo.type, priority2);
              }
            }
          }
        }
        function isTypeOrBaseIdenticalTo(s, t) {
          return exactOptionalPropertyTypes && t === missingType ? s === t : isTypeIdenticalTo(s, t) || !!(t.flags & 4 && s.flags & 128 || t.flags & 8 && s.flags & 256);
        }
        function isTypeCloselyMatchedBy(s, t) {
          return !!(s.flags & 524288 && t.flags & 524288 && s.symbol && s.symbol === t.symbol || s.aliasSymbol && s.aliasTypeArguments && s.aliasSymbol === t.aliasSymbol);
        }
        function hasPrimitiveConstraint(type2) {
          var constraint = getConstraintOfTypeParameter(type2);
          return !!constraint && maybeTypeOfKind(constraint.flags & 16777216 ? getDefaultConstraintOfConditionalType(constraint) : constraint, 131068 | 4194304 | 134217728 | 268435456);
        }
        function isObjectLiteralType(type2) {
          return !!(ts3.getObjectFlags(type2) & 128);
        }
        function isObjectOrArrayLiteralType(type2) {
          return !!(ts3.getObjectFlags(type2) & (128 | 16384));
        }
        function unionObjectAndArrayLiteralCandidates(candidates) {
          if (candidates.length > 1) {
            var objectLiterals = ts3.filter(candidates, isObjectOrArrayLiteralType);
            if (objectLiterals.length) {
              var literalsType = getUnionType(objectLiterals, 2);
              return ts3.concatenate(ts3.filter(candidates, function(t) {
                return !isObjectOrArrayLiteralType(t);
              }), [literalsType]);
            }
          }
          return candidates;
        }
        function getContravariantInference(inference) {
          return inference.priority & 416 ? getIntersectionType(inference.contraCandidates) : getCommonSubtype(inference.contraCandidates);
        }
        function getCovariantInference(inference, signature) {
          var candidates = unionObjectAndArrayLiteralCandidates(inference.candidates);
          var primitiveConstraint = hasPrimitiveConstraint(inference.typeParameter);
          var widenLiteralTypes = !primitiveConstraint && inference.topLevel && (inference.isFixed || !isTypeParameterAtTopLevel(getReturnTypeOfSignature(signature), inference.typeParameter));
          var baseCandidates = primitiveConstraint ? ts3.sameMap(candidates, getRegularTypeOfLiteralType) : widenLiteralTypes ? ts3.sameMap(candidates, getWidenedLiteralType) : candidates;
          var unwidenedType = inference.priority & 416 ? getUnionType(baseCandidates, 2) : getCommonSupertype(baseCandidates);
          return getWidenedType(unwidenedType);
        }
        function getInferredType(context, index) {
          var inference = context.inferences[index];
          if (!inference.inferredType) {
            var inferredType = void 0;
            var signature = context.signature;
            if (signature) {
              var inferredCovariantType_1 = inference.candidates ? getCovariantInference(inference, signature) : void 0;
              if (inference.contraCandidates) {
                inferredType = inferredCovariantType_1 && !(inferredCovariantType_1.flags & 131072) && ts3.some(inference.contraCandidates, function(t) {
                  return isTypeSubtypeOf(inferredCovariantType_1, t);
                }) ? inferredCovariantType_1 : getContravariantInference(inference);
              } else if (inferredCovariantType_1) {
                inferredType = inferredCovariantType_1;
              } else if (context.flags & 1) {
                inferredType = silentNeverType;
              } else {
                var defaultType = getDefaultFromTypeParameter(inference.typeParameter);
                if (defaultType) {
                  inferredType = instantiateType(defaultType, mergeTypeMappers(createBackreferenceMapper(context, index), context.nonFixingMapper));
                }
              }
            } else {
              inferredType = getTypeFromInference(inference);
            }
            inference.inferredType = inferredType || getDefaultTypeArgumentType(!!(context.flags & 2));
            var constraint = getConstraintOfTypeParameter(inference.typeParameter);
            if (constraint) {
              var instantiatedConstraint = instantiateType(constraint, context.nonFixingMapper);
              if (!inferredType || !context.compareTypes(inferredType, getTypeWithThisArgument(instantiatedConstraint, inferredType))) {
                inference.inferredType = inferredType = instantiatedConstraint;
              }
            }
          }
          return inference.inferredType;
        }
        function getDefaultTypeArgumentType(isInJavaScriptFile) {
          return isInJavaScriptFile ? anyType : unknownType;
        }
        function getInferredTypes(context) {
          var result2 = [];
          for (var i = 0; i < context.inferences.length; i++) {
            result2.push(getInferredType(context, i));
          }
          return result2;
        }
        function getCannotFindNameDiagnosticForName(node) {
          switch (node.escapedText) {
            case "document":
            case "console":
              return ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;
            case "$":
              return compilerOptions.types ? ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig : ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;
            case "describe":
            case "suite":
            case "it":
            case "test":
              return compilerOptions.types ? ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig : ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;
            case "process":
            case "require":
            case "Buffer":
            case "module":
              return compilerOptions.types ? ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig : ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;
            case "Map":
            case "Set":
            case "Promise":
            case "Symbol":
            case "WeakMap":
            case "WeakSet":
            case "Iterator":
            case "AsyncIterator":
            case "SharedArrayBuffer":
            case "Atomics":
            case "AsyncIterable":
            case "AsyncIterableIterator":
            case "AsyncGenerator":
            case "AsyncGeneratorFunction":
            case "BigInt":
            case "Reflect":
            case "BigInt64Array":
            case "BigUint64Array":
              return ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;
            case "await":
              if (ts3.isCallExpression(node.parent)) {
                return ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function;
              }
            default:
              if (node.parent.kind === 297) {
                return ts3.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer;
              } else {
                return ts3.Diagnostics.Cannot_find_name_0;
              }
          }
        }
        function getResolvedSymbol(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedSymbol) {
            links.resolvedSymbol = !ts3.nodeIsMissing(node) && resolveName(node, node.escapedText, 111551 | 1048576, getCannotFindNameDiagnosticForName(node), node, !ts3.isWriteOnlyAccess(node), false) || unknownSymbol;
          }
          return links.resolvedSymbol;
        }
        function isInTypeQuery(node) {
          return !!ts3.findAncestor(node, function(n) {
            return n.kind === 181 ? true : n.kind === 79 || n.kind === 161 ? false : "quit";
          });
        }
        function getFlowCacheKey(node, declaredType, initialType, flowContainer) {
          switch (node.kind) {
            case 79:
              if (!ts3.isThisInTypeQuery(node)) {
                var symbol = getResolvedSymbol(node);
                return symbol !== unknownSymbol ? "".concat(flowContainer ? getNodeId(flowContainer) : "-1", "|").concat(getTypeId(declaredType), "|").concat(getTypeId(initialType), "|").concat(getSymbolId(symbol)) : void 0;
              }
            case 108:
              return "0|".concat(flowContainer ? getNodeId(flowContainer) : "-1", "|").concat(getTypeId(declaredType), "|").concat(getTypeId(initialType));
            case 230:
            case 212:
              return getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
            case 161:
              var left = getFlowCacheKey(node.left, declaredType, initialType, flowContainer);
              return left && left + "." + node.right.escapedText;
            case 206:
            case 207:
              var propName = getAccessedPropertyName(node);
              if (propName !== void 0) {
                var key = getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
                return key && key + "." + propName;
              }
          }
          return void 0;
        }
        function isMatchingReference(source, target) {
          switch (target.kind) {
            case 212:
            case 230:
              return isMatchingReference(source, target.expression);
            case 221:
              return ts3.isAssignmentExpression(target) && isMatchingReference(source, target.left) || ts3.isBinaryExpression(target) && target.operatorToken.kind === 27 && isMatchingReference(source, target.right);
          }
          switch (source.kind) {
            case 231:
              return target.kind === 231 && source.keywordToken === target.keywordToken && source.name.escapedText === target.name.escapedText;
            case 79:
            case 80:
              return ts3.isThisInTypeQuery(source) ? target.kind === 108 : target.kind === 79 && getResolvedSymbol(source) === getResolvedSymbol(target) || (target.kind === 254 || target.kind === 203) && getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(source)) === getSymbolOfNode(target);
            case 108:
              return target.kind === 108;
            case 106:
              return target.kind === 106;
            case 230:
            case 212:
              return isMatchingReference(source.expression, target);
            case 206:
            case 207:
              var sourcePropertyName = getAccessedPropertyName(source);
              var targetPropertyName = ts3.isAccessExpression(target) ? getAccessedPropertyName(target) : void 0;
              return sourcePropertyName !== void 0 && targetPropertyName !== void 0 && targetPropertyName === sourcePropertyName && isMatchingReference(source.expression, target.expression);
            case 161:
              return ts3.isAccessExpression(target) && source.right.escapedText === getAccessedPropertyName(target) && isMatchingReference(source.left, target.expression);
            case 221:
              return ts3.isBinaryExpression(source) && source.operatorToken.kind === 27 && isMatchingReference(source.right, target);
          }
          return false;
        }
        function getAccessedPropertyName(access) {
          if (ts3.isPropertyAccessExpression(access)) {
            return access.name.escapedText;
          }
          if (ts3.isElementAccessExpression(access)) {
            return tryGetElementAccessExpressionName(access);
          }
          if (ts3.isBindingElement(access)) {
            var name = getDestructuringPropertyName(access);
            return name ? ts3.escapeLeadingUnderscores(name) : void 0;
          }
          if (ts3.isParameter(access)) {
            return "" + access.parent.parameters.indexOf(access);
          }
          return void 0;
        }
        function tryGetNameFromType(type2) {
          return type2.flags & 8192 ? type2.escapedName : type2.flags & 384 ? ts3.escapeLeadingUnderscores("" + type2.value) : void 0;
        }
        function tryGetElementAccessExpressionName(node) {
          if (ts3.isStringOrNumericLiteralLike(node.argumentExpression)) {
            return ts3.escapeLeadingUnderscores(node.argumentExpression.text);
          }
          if (ts3.isEntityNameExpression(node.argumentExpression)) {
            var symbol = resolveEntityName(node.argumentExpression, 111551, true);
            if (!symbol || !isConstVariable(symbol))
              return void 0;
            var declaration = symbol.valueDeclaration;
            if (declaration === void 0)
              return void 0;
            var type2 = tryGetTypeFromEffectiveTypeNode(declaration);
            if (type2) {
              var name = tryGetNameFromType(type2);
              if (name !== void 0) {
                return name;
              }
            }
            if (ts3.hasOnlyExpressionInitializer(declaration)) {
              var initializer = ts3.getEffectiveInitializer(declaration);
              return initializer && tryGetNameFromType(getTypeOfExpression(initializer));
            }
          }
          return void 0;
        }
        function containsMatchingReference(source, target) {
          while (ts3.isAccessExpression(source)) {
            source = source.expression;
            if (isMatchingReference(source, target)) {
              return true;
            }
          }
          return false;
        }
        function optionalChainContainsReference(source, target) {
          while (ts3.isOptionalChain(source)) {
            source = source.expression;
            if (isMatchingReference(source, target)) {
              return true;
            }
          }
          return false;
        }
        function isDiscriminantProperty(type2, name) {
          if (type2 && type2.flags & 1048576) {
            var prop = getUnionOrIntersectionProperty(type2, name);
            if (prop && ts3.getCheckFlags(prop) & 2) {
              if (prop.isDiscriminantProperty === void 0) {
                prop.isDiscriminantProperty = (prop.checkFlags & 192) === 192 && !isGenericType(getTypeOfSymbol(prop));
              }
              return !!prop.isDiscriminantProperty;
            }
          }
          return false;
        }
        function findDiscriminantProperties(sourceProperties, target) {
          var result2;
          for (var _i = 0, sourceProperties_2 = sourceProperties; _i < sourceProperties_2.length; _i++) {
            var sourceProperty = sourceProperties_2[_i];
            if (isDiscriminantProperty(target, sourceProperty.escapedName)) {
              if (result2) {
                result2.push(sourceProperty);
                continue;
              }
              result2 = [sourceProperty];
            }
          }
          return result2;
        }
        function mapTypesByKeyProperty(types2, name) {
          var map2 = new ts3.Map();
          var count = 0;
          var _loop_23 = function(type3) {
            if (type3.flags & (524288 | 2097152 | 58982400)) {
              var discriminant = getTypeOfPropertyOfType(type3, name);
              if (discriminant) {
                if (!isLiteralType(discriminant)) {
                  return { value: void 0 };
                }
                var duplicate_1 = false;
                forEachType(discriminant, function(t) {
                  var id = getTypeId(getRegularTypeOfLiteralType(t));
                  var existing = map2.get(id);
                  if (!existing) {
                    map2.set(id, type3);
                  } else if (existing !== unknownType) {
                    map2.set(id, unknownType);
                    duplicate_1 = true;
                  }
                });
                if (!duplicate_1)
                  count++;
              }
            }
          };
          for (var _i = 0, types_16 = types2; _i < types_16.length; _i++) {
            var type2 = types_16[_i];
            var state_9 = _loop_23(type2);
            if (typeof state_9 === "object")
              return state_9.value;
          }
          return count >= 10 && count * 2 >= types2.length ? map2 : void 0;
        }
        function getKeyPropertyName(unionType) {
          var types2 = unionType.types;
          if (types2.length < 10 || ts3.getObjectFlags(unionType) & 32768 || ts3.countWhere(types2, function(t) {
            return !!(t.flags & (524288 | 58982400));
          }) < 10) {
            return void 0;
          }
          if (unionType.keyPropertyName === void 0) {
            var keyPropertyName = ts3.forEach(types2, function(t) {
              return t.flags & (524288 | 58982400) ? ts3.forEach(getPropertiesOfType(t), function(p) {
                return isUnitType(getTypeOfSymbol(p)) ? p.escapedName : void 0;
              }) : void 0;
            });
            var mapByKeyProperty = keyPropertyName && mapTypesByKeyProperty(types2, keyPropertyName);
            unionType.keyPropertyName = mapByKeyProperty ? keyPropertyName : "";
            unionType.constituentMap = mapByKeyProperty;
          }
          return unionType.keyPropertyName.length ? unionType.keyPropertyName : void 0;
        }
        function getConstituentTypeForKeyType(unionType, keyType) {
          var _a;
          var result2 = (_a = unionType.constituentMap) === null || _a === void 0 ? void 0 : _a.get(getTypeId(getRegularTypeOfLiteralType(keyType)));
          return result2 !== unknownType ? result2 : void 0;
        }
        function getMatchingUnionConstituentForType(unionType, type2) {
          var keyPropertyName = getKeyPropertyName(unionType);
          var propType = keyPropertyName && getTypeOfPropertyOfType(type2, keyPropertyName);
          return propType && getConstituentTypeForKeyType(unionType, propType);
        }
        function getMatchingUnionConstituentForObjectLiteral(unionType, node) {
          var keyPropertyName = getKeyPropertyName(unionType);
          var propNode = keyPropertyName && ts3.find(node.properties, function(p) {
            return p.symbol && p.kind === 296 && p.symbol.escapedName === keyPropertyName && isPossiblyDiscriminantValue(p.initializer);
          });
          var propType = propNode && getContextFreeTypeOfExpression(propNode.initializer);
          return propType && getConstituentTypeForKeyType(unionType, propType);
        }
        function isOrContainsMatchingReference(source, target) {
          return isMatchingReference(source, target) || containsMatchingReference(source, target);
        }
        function hasMatchingArgument(expression, reference) {
          if (expression.arguments) {
            for (var _i = 0, _a = expression.arguments; _i < _a.length; _i++) {
              var argument = _a[_i];
              if (isOrContainsMatchingReference(reference, argument)) {
                return true;
              }
            }
          }
          if (expression.expression.kind === 206 && isOrContainsMatchingReference(reference, expression.expression.expression)) {
            return true;
          }
          return false;
        }
        function getFlowNodeId(flow) {
          if (!flow.id || flow.id < 0) {
            flow.id = nextFlowId;
            nextFlowId++;
          }
          return flow.id;
        }
        function typeMaybeAssignableTo(source, target) {
          if (!(source.flags & 1048576)) {
            return isTypeAssignableTo(source, target);
          }
          for (var _i = 0, _a = source.types; _i < _a.length; _i++) {
            var t = _a[_i];
            if (isTypeAssignableTo(t, target)) {
              return true;
            }
          }
          return false;
        }
        function getAssignmentReducedType(declaredType, assignedType) {
          if (declaredType !== assignedType) {
            if (assignedType.flags & 131072) {
              return assignedType;
            }
            var reducedType = filterType(declaredType, function(t) {
              return typeMaybeAssignableTo(assignedType, t);
            });
            if (assignedType.flags & 512 && isFreshLiteralType(assignedType)) {
              reducedType = mapType(reducedType, getFreshTypeOfLiteralType);
            }
            if (isTypeAssignableTo(assignedType, reducedType)) {
              return reducedType;
            }
          }
          return declaredType;
        }
        function isFunctionObjectType(type2) {
          var resolved = resolveStructuredTypeMembers(type2);
          return !!(resolved.callSignatures.length || resolved.constructSignatures.length || resolved.members.get("bind") && isTypeSubtypeOf(type2, globalFunctionType));
        }
        function getTypeFacts(type2, ignoreObjects) {
          if (ignoreObjects === void 0) {
            ignoreObjects = false;
          }
          var flags = type2.flags;
          if (flags & 4) {
            return strictNullChecks ? 16317953 : 16776705;
          }
          if (flags & 128) {
            var isEmpty = type2.value === "";
            return strictNullChecks ? isEmpty ? 12123649 : 7929345 : isEmpty ? 12582401 : 16776705;
          }
          if (flags & (8 | 32)) {
            return strictNullChecks ? 16317698 : 16776450;
          }
          if (flags & 256) {
            var isZero = type2.value === 0;
            return strictNullChecks ? isZero ? 12123394 : 7929090 : isZero ? 12582146 : 16776450;
          }
          if (flags & 64) {
            return strictNullChecks ? 16317188 : 16775940;
          }
          if (flags & 2048) {
            var isZero = isZeroBigInt(type2);
            return strictNullChecks ? isZero ? 12122884 : 7928580 : isZero ? 12581636 : 16775940;
          }
          if (flags & 16) {
            return strictNullChecks ? 16316168 : 16774920;
          }
          if (flags & 528) {
            return strictNullChecks ? type2 === falseType || type2 === regularFalseType ? 12121864 : 7927560 : type2 === falseType || type2 === regularFalseType ? 12580616 : 16774920;
          }
          if (flags & 524288) {
            if (ignoreObjects) {
              return 16768959;
            }
            return ts3.getObjectFlags(type2) & 16 && isEmptyObjectType(type2) ? strictNullChecks ? 16318463 : 16777215 : isFunctionObjectType(type2) ? strictNullChecks ? 7880640 : 16728e3 : strictNullChecks ? 7888800 : 16736160;
          }
          if (flags & (16384 | 32768)) {
            return 9830144;
          }
          if (flags & 65536) {
            return 9363232;
          }
          if (flags & 12288) {
            return strictNullChecks ? 7925520 : 16772880;
          }
          if (flags & 67108864) {
            return strictNullChecks ? 7888800 : 16736160;
          }
          if (flags & 131072) {
            return 0;
          }
          if (flags & 465829888) {
            return !isPatternLiteralType(type2) ? getTypeFacts(getBaseConstraintOfType(type2) || unknownType, ignoreObjects) : strictNullChecks ? 7929345 : 16776705;
          }
          if (flags & 1048576) {
            return ts3.reduceLeft(type2.types, function(facts, t) {
              return facts | getTypeFacts(t, ignoreObjects);
            }, 0);
          }
          if (flags & 2097152) {
            ignoreObjects || (ignoreObjects = maybeTypeOfKind(type2, 131068));
            return getIntersectionTypeFacts(type2, ignoreObjects);
          }
          return 16777215;
        }
        function getIntersectionTypeFacts(type2, ignoreObjects) {
          var oredFacts = 0;
          var andedFacts = 16777215;
          for (var _i = 0, _a = type2.types; _i < _a.length; _i++) {
            var t = _a[_i];
            var f = getTypeFacts(t, ignoreObjects);
            oredFacts |= f;
            andedFacts &= f;
          }
          return oredFacts & 8256 | andedFacts & 16768959;
        }
        function getTypeWithFacts(type2, include) {
          return filterType(type2, function(t) {
            return (getTypeFacts(t) & include) !== 0;
          });
        }
        function getTypeWithDefault(type2, defaultExpression) {
          return defaultExpression ? getUnionType([getNonUndefinedType(type2), getTypeOfExpression(defaultExpression)]) : type2;
        }
        function getTypeOfDestructuredProperty(type2, name) {
          var _a;
          var nameType = getLiteralTypeFromPropertyName(name);
          if (!isTypeUsableAsPropertyName(nameType))
            return errorType;
          var text = getPropertyNameFromType(nameType);
          return getTypeOfPropertyOfType(type2, text) || includeUndefinedInIndexSignature((_a = getApplicableIndexInfoForName(type2, text)) === null || _a === void 0 ? void 0 : _a.type) || errorType;
        }
        function getTypeOfDestructuredArrayElement(type2, index) {
          return everyType(type2, isTupleLikeType) && getTupleElementType(type2, index) || includeUndefinedInIndexSignature(checkIteratedTypeOrElementType(65, type2, undefinedType, void 0)) || errorType;
        }
        function includeUndefinedInIndexSignature(type2) {
          if (!type2)
            return type2;
          return compilerOptions.noUncheckedIndexedAccess ? getUnionType([type2, undefinedType]) : type2;
        }
        function getTypeOfDestructuredSpreadExpression(type2) {
          return createArrayType(checkIteratedTypeOrElementType(65, type2, undefinedType, void 0) || errorType);
        }
        function getAssignedTypeOfBinaryExpression(node) {
          var isDestructuringDefaultAssignment = node.parent.kind === 204 && isDestructuringAssignmentTarget(node.parent) || node.parent.kind === 296 && isDestructuringAssignmentTarget(node.parent.parent);
          return isDestructuringDefaultAssignment ? getTypeWithDefault(getAssignedType(node), node.right) : getTypeOfExpression(node.right);
        }
        function isDestructuringAssignmentTarget(parent) {
          return parent.parent.kind === 221 && parent.parent.left === parent || parent.parent.kind === 244 && parent.parent.initializer === parent;
        }
        function getAssignedTypeOfArrayLiteralElement(node, element) {
          return getTypeOfDestructuredArrayElement(getAssignedType(node), node.elements.indexOf(element));
        }
        function getAssignedTypeOfSpreadExpression(node) {
          return getTypeOfDestructuredSpreadExpression(getAssignedType(node.parent));
        }
        function getAssignedTypeOfPropertyAssignment(node) {
          return getTypeOfDestructuredProperty(getAssignedType(node.parent), node.name);
        }
        function getAssignedTypeOfShorthandPropertyAssignment(node) {
          return getTypeWithDefault(getAssignedTypeOfPropertyAssignment(node), node.objectAssignmentInitializer);
        }
        function getAssignedType(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 243:
              return stringType;
            case 244:
              return checkRightHandSideOfForOf(parent) || errorType;
            case 221:
              return getAssignedTypeOfBinaryExpression(parent);
            case 215:
              return undefinedType;
            case 204:
              return getAssignedTypeOfArrayLiteralElement(parent, node);
            case 225:
              return getAssignedTypeOfSpreadExpression(parent);
            case 296:
              return getAssignedTypeOfPropertyAssignment(parent);
            case 297:
              return getAssignedTypeOfShorthandPropertyAssignment(parent);
          }
          return errorType;
        }
        function getInitialTypeOfBindingElement(node) {
          var pattern = node.parent;
          var parentType = getInitialType(pattern.parent);
          var type2 = pattern.kind === 201 ? getTypeOfDestructuredProperty(parentType, node.propertyName || node.name) : !node.dotDotDotToken ? getTypeOfDestructuredArrayElement(parentType, pattern.elements.indexOf(node)) : getTypeOfDestructuredSpreadExpression(parentType);
          return getTypeWithDefault(type2, node.initializer);
        }
        function getTypeOfInitializer(node) {
          var links = getNodeLinks(node);
          return links.resolvedType || getTypeOfExpression(node);
        }
        function getInitialTypeOfVariableDeclaration(node) {
          if (node.initializer) {
            return getTypeOfInitializer(node.initializer);
          }
          if (node.parent.parent.kind === 243) {
            return stringType;
          }
          if (node.parent.parent.kind === 244) {
            return checkRightHandSideOfForOf(node.parent.parent) || errorType;
          }
          return errorType;
        }
        function getInitialType(node) {
          return node.kind === 254 ? getInitialTypeOfVariableDeclaration(node) : getInitialTypeOfBindingElement(node);
        }
        function isEmptyArrayAssignment(node) {
          return node.kind === 254 && node.initializer && isEmptyArrayLiteral(node.initializer) || node.kind !== 203 && node.parent.kind === 221 && isEmptyArrayLiteral(node.parent.right);
        }
        function getReferenceCandidate(node) {
          switch (node.kind) {
            case 212:
              return getReferenceCandidate(node.expression);
            case 221:
              switch (node.operatorToken.kind) {
                case 63:
                case 75:
                case 76:
                case 77:
                  return getReferenceCandidate(node.left);
                case 27:
                  return getReferenceCandidate(node.right);
              }
          }
          return node;
        }
        function getReferenceRoot(node) {
          var parent = node.parent;
          return parent.kind === 212 || parent.kind === 221 && parent.operatorToken.kind === 63 && parent.left === node || parent.kind === 221 && parent.operatorToken.kind === 27 && parent.right === node ? getReferenceRoot(parent) : node;
        }
        function getTypeOfSwitchClause(clause) {
          if (clause.kind === 289) {
            return getRegularTypeOfLiteralType(getTypeOfExpression(clause.expression));
          }
          return neverType;
        }
        function getSwitchClauseTypes(switchStatement) {
          var links = getNodeLinks(switchStatement);
          if (!links.switchTypes) {
            links.switchTypes = [];
            for (var _i = 0, _a = switchStatement.caseBlock.clauses; _i < _a.length; _i++) {
              var clause = _a[_i];
              links.switchTypes.push(getTypeOfSwitchClause(clause));
            }
          }
          return links.switchTypes;
        }
        function getSwitchClauseTypeOfWitnesses(switchStatement, retainDefault) {
          var witnesses = [];
          for (var _i = 0, _a = switchStatement.caseBlock.clauses; _i < _a.length; _i++) {
            var clause = _a[_i];
            if (clause.kind === 289) {
              if (ts3.isStringLiteralLike(clause.expression)) {
                witnesses.push(clause.expression.text);
                continue;
              }
              return ts3.emptyArray;
            }
            if (retainDefault)
              witnesses.push(void 0);
          }
          return witnesses;
        }
        function eachTypeContainedIn(source, types2) {
          return source.flags & 1048576 ? !ts3.forEach(source.types, function(t) {
            return !ts3.contains(types2, t);
          }) : ts3.contains(types2, source);
        }
        function isTypeSubsetOf(source, target) {
          return source === target || target.flags & 1048576 && isTypeSubsetOfUnion(source, target);
        }
        function isTypeSubsetOfUnion(source, target) {
          if (source.flags & 1048576) {
            for (var _i = 0, _a = source.types; _i < _a.length; _i++) {
              var t = _a[_i];
              if (!containsType(target.types, t)) {
                return false;
              }
            }
            return true;
          }
          if (source.flags & 1024 && getBaseTypeOfEnumLiteralType(source) === target) {
            return true;
          }
          return containsType(target.types, source);
        }
        function forEachType(type2, f) {
          return type2.flags & 1048576 ? ts3.forEach(type2.types, f) : f(type2);
        }
        function someType(type2, f) {
          return type2.flags & 1048576 ? ts3.some(type2.types, f) : f(type2);
        }
        function everyType(type2, f) {
          return type2.flags & 1048576 ? ts3.every(type2.types, f) : f(type2);
        }
        function everyContainedType(type2, f) {
          return type2.flags & 3145728 ? ts3.every(type2.types, f) : f(type2);
        }
        function filterType(type2, f) {
          if (type2.flags & 1048576) {
            var types2 = type2.types;
            var filtered = ts3.filter(types2, f);
            if (filtered === types2) {
              return type2;
            }
            var origin = type2.origin;
            var newOrigin = void 0;
            if (origin && origin.flags & 1048576) {
              var originTypes = origin.types;
              var originFiltered = ts3.filter(originTypes, function(t) {
                return !!(t.flags & 1048576) || f(t);
              });
              if (originTypes.length - originFiltered.length === types2.length - filtered.length) {
                if (originFiltered.length === 1) {
                  return originFiltered[0];
                }
                newOrigin = createOriginUnionOrIntersectionType(1048576, originFiltered);
              }
            }
            return getUnionTypeFromSortedList(filtered, type2.objectFlags, void 0, void 0, newOrigin);
          }
          return type2.flags & 131072 || f(type2) ? type2 : neverType;
        }
        function removeType(type2, targetType) {
          return filterType(type2, function(t) {
            return t !== targetType;
          });
        }
        function countTypes(type2) {
          return type2.flags & 1048576 ? type2.types.length : 1;
        }
        function mapType(type2, mapper, noReductions) {
          if (type2.flags & 131072) {
            return type2;
          }
          if (!(type2.flags & 1048576)) {
            return mapper(type2);
          }
          var origin = type2.origin;
          var types2 = origin && origin.flags & 1048576 ? origin.types : type2.types;
          var mappedTypes;
          var changed = false;
          for (var _i = 0, types_17 = types2; _i < types_17.length; _i++) {
            var t = types_17[_i];
            var mapped = t.flags & 1048576 ? mapType(t, mapper, noReductions) : mapper(t);
            changed || (changed = t !== mapped);
            if (mapped) {
              if (!mappedTypes) {
                mappedTypes = [mapped];
              } else {
                mappedTypes.push(mapped);
              }
            }
          }
          return changed ? mappedTypes && getUnionType(mappedTypes, noReductions ? 0 : 1) : type2;
        }
        function mapTypeWithAlias(type2, mapper, aliasSymbol, aliasTypeArguments) {
          return type2.flags & 1048576 && aliasSymbol ? getUnionType(ts3.map(type2.types, mapper), 1, aliasSymbol, aliasTypeArguments) : mapType(type2, mapper);
        }
        function extractTypesOfKind(type2, kind) {
          return filterType(type2, function(t) {
            return (t.flags & kind) !== 0;
          });
        }
        function replacePrimitivesWithLiterals(typeWithPrimitives, typeWithLiterals) {
          if (maybeTypeOfKind(typeWithPrimitives, 4 | 134217728 | 8 | 64) && maybeTypeOfKind(typeWithLiterals, 128 | 134217728 | 268435456 | 256 | 2048)) {
            return mapType(typeWithPrimitives, function(t) {
              return t.flags & 4 ? extractTypesOfKind(typeWithLiterals, 4 | 128 | 134217728 | 268435456) : isPatternLiteralType(t) && !maybeTypeOfKind(typeWithLiterals, 4 | 134217728 | 268435456) ? extractTypesOfKind(typeWithLiterals, 128) : t.flags & 8 ? extractTypesOfKind(typeWithLiterals, 8 | 256) : t.flags & 64 ? extractTypesOfKind(typeWithLiterals, 64 | 2048) : t;
            });
          }
          return typeWithPrimitives;
        }
        function isIncomplete(flowType) {
          return flowType.flags === 0;
        }
        function getTypeFromFlowType(flowType) {
          return flowType.flags === 0 ? flowType.type : flowType;
        }
        function createFlowType(type2, incomplete) {
          return incomplete ? { flags: 0, type: type2.flags & 131072 ? silentNeverType : type2 } : type2;
        }
        function createEvolvingArrayType(elementType) {
          var result2 = createObjectType(256);
          result2.elementType = elementType;
          return result2;
        }
        function getEvolvingArrayType(elementType) {
          return evolvingArrayTypes[elementType.id] || (evolvingArrayTypes[elementType.id] = createEvolvingArrayType(elementType));
        }
        function addEvolvingArrayElementType(evolvingArrayType, node) {
          var elementType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(getContextFreeTypeOfExpression(node)));
          return isTypeSubsetOf(elementType, evolvingArrayType.elementType) ? evolvingArrayType : getEvolvingArrayType(getUnionType([evolvingArrayType.elementType, elementType]));
        }
        function createFinalArrayType(elementType) {
          return elementType.flags & 131072 ? autoArrayType : createArrayType(elementType.flags & 1048576 ? getUnionType(elementType.types, 2) : elementType);
        }
        function getFinalArrayType(evolvingArrayType) {
          return evolvingArrayType.finalArrayType || (evolvingArrayType.finalArrayType = createFinalArrayType(evolvingArrayType.elementType));
        }
        function finalizeEvolvingArrayType(type2) {
          return ts3.getObjectFlags(type2) & 256 ? getFinalArrayType(type2) : type2;
        }
        function getElementTypeOfEvolvingArrayType(type2) {
          return ts3.getObjectFlags(type2) & 256 ? type2.elementType : neverType;
        }
        function isEvolvingArrayTypeList(types2) {
          var hasEvolvingArrayType = false;
          for (var _i = 0, types_18 = types2; _i < types_18.length; _i++) {
            var t = types_18[_i];
            if (!(t.flags & 131072)) {
              if (!(ts3.getObjectFlags(t) & 256)) {
                return false;
              }
              hasEvolvingArrayType = true;
            }
          }
          return hasEvolvingArrayType;
        }
        function isEvolvingArrayOperationTarget(node) {
          var root = getReferenceRoot(node);
          var parent = root.parent;
          var isLengthPushOrUnshift = ts3.isPropertyAccessExpression(parent) && (parent.name.escapedText === "length" || parent.parent.kind === 208 && ts3.isIdentifier(parent.name) && ts3.isPushOrUnshiftIdentifier(parent.name));
          var isElementAssignment = parent.kind === 207 && parent.expression === root && parent.parent.kind === 221 && parent.parent.operatorToken.kind === 63 && parent.parent.left === parent && !ts3.isAssignmentTarget(parent.parent) && isTypeAssignableToKind(getTypeOfExpression(parent.argumentExpression), 296);
          return isLengthPushOrUnshift || isElementAssignment;
        }
        function isDeclarationWithExplicitTypeAnnotation(node) {
          return (ts3.isVariableDeclaration(node) || ts3.isPropertyDeclaration(node) || ts3.isPropertySignature(node) || ts3.isParameter(node)) && !!(ts3.getEffectiveTypeAnnotationNode(node) || ts3.isInJSFile(node) && ts3.hasInitializer(node) && node.initializer && ts3.isFunctionExpressionOrArrowFunction(node.initializer) && ts3.getEffectiveReturnTypeNode(node.initializer));
        }
        function getExplicitTypeOfSymbol(symbol, diagnostic) {
          if (symbol.flags & (16 | 8192 | 32 | 512)) {
            return getTypeOfSymbol(symbol);
          }
          if (symbol.flags & (3 | 4)) {
            if (ts3.getCheckFlags(symbol) & 262144) {
              var origin = symbol.syntheticOrigin;
              if (origin && getExplicitTypeOfSymbol(origin)) {
                return getTypeOfSymbol(symbol);
              }
            }
            var declaration = symbol.valueDeclaration;
            if (declaration) {
              if (isDeclarationWithExplicitTypeAnnotation(declaration)) {
                return getTypeOfSymbol(symbol);
              }
              if (ts3.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 244) {
                var statement = declaration.parent.parent;
                var expressionType = getTypeOfDottedName(statement.expression, void 0);
                if (expressionType) {
                  var use = statement.awaitModifier ? 15 : 13;
                  return checkIteratedTypeOrElementType(use, expressionType, undefinedType, void 0);
                }
              }
              if (diagnostic) {
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(declaration, ts3.Diagnostics._0_needs_an_explicit_type_annotation, symbolToString(symbol)));
              }
            }
          }
        }
        function getTypeOfDottedName(node, diagnostic) {
          if (!(node.flags & 33554432)) {
            switch (node.kind) {
              case 79:
                var symbol = getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(node));
                return getExplicitTypeOfSymbol(symbol.flags & 2097152 ? resolveAlias(symbol) : symbol, diagnostic);
              case 108:
                return getExplicitThisType(node);
              case 106:
                return checkSuperExpression(node);
              case 206: {
                var type2 = getTypeOfDottedName(node.expression, diagnostic);
                if (type2) {
                  var name = node.name;
                  var prop = void 0;
                  if (ts3.isPrivateIdentifier(name)) {
                    if (!type2.symbol) {
                      return void 0;
                    }
                    prop = getPropertyOfType(type2, ts3.getSymbolNameForPrivateIdentifier(type2.symbol, name.escapedText));
                  } else {
                    prop = getPropertyOfType(type2, name.escapedText);
                  }
                  return prop && getExplicitTypeOfSymbol(prop, diagnostic);
                }
                return void 0;
              }
              case 212:
                return getTypeOfDottedName(node.expression, diagnostic);
            }
          }
        }
        function getEffectsSignature(node) {
          var links = getNodeLinks(node);
          var signature = links.effectsSignature;
          if (signature === void 0) {
            var funcType = void 0;
            if (node.parent.kind === 238) {
              funcType = getTypeOfDottedName(node.expression, void 0);
            } else if (node.expression.kind !== 106) {
              if (ts3.isOptionalChain(node)) {
                funcType = checkNonNullType(getOptionalExpressionType(checkExpression(node.expression), node.expression), node.expression);
              } else {
                funcType = checkNonNullExpression(node.expression);
              }
            }
            var signatures = getSignaturesOfType(funcType && getApparentType(funcType) || unknownType, 0);
            var candidate = signatures.length === 1 && !signatures[0].typeParameters ? signatures[0] : ts3.some(signatures, hasTypePredicateOrNeverReturnType) ? getResolvedSignature(node) : void 0;
            signature = links.effectsSignature = candidate && hasTypePredicateOrNeverReturnType(candidate) ? candidate : unknownSignature;
          }
          return signature === unknownSignature ? void 0 : signature;
        }
        function hasTypePredicateOrNeverReturnType(signature) {
          return !!(getTypePredicateOfSignature(signature) || signature.declaration && (getReturnTypeFromAnnotation(signature.declaration) || unknownType).flags & 131072);
        }
        function getTypePredicateArgument(predicate, callExpression) {
          if (predicate.kind === 1 || predicate.kind === 3) {
            return callExpression.arguments[predicate.parameterIndex];
          }
          var invokedExpression = ts3.skipParentheses(callExpression.expression);
          return ts3.isAccessExpression(invokedExpression) ? ts3.skipParentheses(invokedExpression.expression) : void 0;
        }
        function reportFlowControlError(node) {
          var block = ts3.findAncestor(node, ts3.isFunctionOrModuleBlock);
          var sourceFile = ts3.getSourceFileOfNode(node);
          var span = ts3.getSpanOfTokenAtPosition(sourceFile, block.statements.pos);
          diagnostics.add(ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis));
        }
        function isReachableFlowNode(flow) {
          var result2 = isReachableFlowNodeWorker(flow, false);
          lastFlowNode = flow;
          lastFlowNodeReachable = result2;
          return result2;
        }
        function isFalseExpression(expr) {
          var node = ts3.skipParentheses(expr, true);
          return node.kind === 95 || node.kind === 221 && (node.operatorToken.kind === 55 && (isFalseExpression(node.left) || isFalseExpression(node.right)) || node.operatorToken.kind === 56 && isFalseExpression(node.left) && isFalseExpression(node.right));
        }
        function isReachableFlowNodeWorker(flow, noCacheCheck) {
          while (true) {
            if (flow === lastFlowNode) {
              return lastFlowNodeReachable;
            }
            var flags = flow.flags;
            if (flags & 4096) {
              if (!noCacheCheck) {
                var id = getFlowNodeId(flow);
                var reachable = flowNodeReachable[id];
                return reachable !== void 0 ? reachable : flowNodeReachable[id] = isReachableFlowNodeWorker(flow, true);
              }
              noCacheCheck = false;
            }
            if (flags & (16 | 96 | 256)) {
              flow = flow.antecedent;
            } else if (flags & 512) {
              var signature = getEffectsSignature(flow.node);
              if (signature) {
                var predicate = getTypePredicateOfSignature(signature);
                if (predicate && predicate.kind === 3 && !predicate.type) {
                  var predicateArgument = flow.node.arguments[predicate.parameterIndex];
                  if (predicateArgument && isFalseExpression(predicateArgument)) {
                    return false;
                  }
                }
                if (getReturnTypeOfSignature(signature).flags & 131072) {
                  return false;
                }
              }
              flow = flow.antecedent;
            } else if (flags & 4) {
              return ts3.some(flow.antecedents, function(f) {
                return isReachableFlowNodeWorker(f, false);
              });
            } else if (flags & 8) {
              var antecedents = flow.antecedents;
              if (antecedents === void 0 || antecedents.length === 0) {
                return false;
              }
              flow = antecedents[0];
            } else if (flags & 128) {
              if (flow.clauseStart === flow.clauseEnd && isExhaustiveSwitchStatement(flow.switchStatement)) {
                return false;
              }
              flow = flow.antecedent;
            } else if (flags & 1024) {
              lastFlowNode = void 0;
              var target = flow.target;
              var saveAntecedents = target.antecedents;
              target.antecedents = flow.antecedents;
              var result2 = isReachableFlowNodeWorker(flow.antecedent, false);
              target.antecedents = saveAntecedents;
              return result2;
            } else {
              return !(flags & 1);
            }
          }
        }
        function isPostSuperFlowNode(flow, noCacheCheck) {
          while (true) {
            var flags = flow.flags;
            if (flags & 4096) {
              if (!noCacheCheck) {
                var id = getFlowNodeId(flow);
                var postSuper = flowNodePostSuper[id];
                return postSuper !== void 0 ? postSuper : flowNodePostSuper[id] = isPostSuperFlowNode(flow, true);
              }
              noCacheCheck = false;
            }
            if (flags & (16 | 96 | 256 | 128)) {
              flow = flow.antecedent;
            } else if (flags & 512) {
              if (flow.node.expression.kind === 106) {
                return true;
              }
              flow = flow.antecedent;
            } else if (flags & 4) {
              return ts3.every(flow.antecedents, function(f) {
                return isPostSuperFlowNode(f, false);
              });
            } else if (flags & 8) {
              flow = flow.antecedents[0];
            } else if (flags & 1024) {
              var target = flow.target;
              var saveAntecedents = target.antecedents;
              target.antecedents = flow.antecedents;
              var result2 = isPostSuperFlowNode(flow.antecedent, false);
              target.antecedents = saveAntecedents;
              return result2;
            } else {
              return !!(flags & 1);
            }
          }
        }
        function isConstantReference(node) {
          switch (node.kind) {
            case 79: {
              var symbol = getResolvedSymbol(node);
              return isConstVariable(symbol) || ts3.isParameterOrCatchClauseVariable(symbol) && !isSymbolAssigned(symbol);
            }
            case 206:
            case 207:
              return isConstantReference(node.expression) && isReadonlySymbol(getNodeLinks(node).resolvedSymbol || unknownSymbol);
          }
          return false;
        }
        function getFlowTypeOfReference(reference, declaredType, initialType, flowContainer, flowNode) {
          if (initialType === void 0) {
            initialType = declaredType;
          }
          if (flowNode === void 0) {
            flowNode = reference.flowNode;
          }
          var key;
          var isKeySet = false;
          var flowDepth = 0;
          if (flowAnalysisDisabled) {
            return errorType;
          }
          if (!flowNode) {
            return declaredType;
          }
          flowInvocationCount++;
          var sharedFlowStart = sharedFlowCount;
          var evolvedType = getTypeFromFlowType(getTypeAtFlowNode(flowNode));
          sharedFlowCount = sharedFlowStart;
          var resultType = ts3.getObjectFlags(evolvedType) & 256 && isEvolvingArrayOperationTarget(reference) ? autoArrayType : finalizeEvolvingArrayType(evolvedType);
          if (resultType === unreachableNeverType || reference.parent && reference.parent.kind === 230 && !(resultType.flags & 131072) && getTypeWithFacts(resultType, 2097152).flags & 131072) {
            return declaredType;
          }
          return resultType === nonNullUnknownType ? unknownType : resultType;
          function getOrSetCacheKey() {
            if (isKeySet) {
              return key;
            }
            isKeySet = true;
            return key = getFlowCacheKey(reference, declaredType, initialType, flowContainer);
          }
          function getTypeAtFlowNode(flow) {
            if (flowDepth === 2e3) {
              ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "getTypeAtFlowNode_DepthLimit", { flowId: flow.id });
              flowAnalysisDisabled = true;
              reportFlowControlError(reference);
              return errorType;
            }
            flowDepth++;
            var sharedFlow;
            while (true) {
              var flags = flow.flags;
              if (flags & 4096) {
                for (var i = sharedFlowStart; i < sharedFlowCount; i++) {
                  if (sharedFlowNodes[i] === flow) {
                    flowDepth--;
                    return sharedFlowTypes[i];
                  }
                }
                sharedFlow = flow;
              }
              var type2 = void 0;
              if (flags & 16) {
                type2 = getTypeAtFlowAssignment(flow);
                if (!type2) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 512) {
                type2 = getTypeAtFlowCall(flow);
                if (!type2) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 96) {
                type2 = getTypeAtFlowCondition(flow);
              } else if (flags & 128) {
                type2 = getTypeAtSwitchClause(flow);
              } else if (flags & 12) {
                if (flow.antecedents.length === 1) {
                  flow = flow.antecedents[0];
                  continue;
                }
                type2 = flags & 4 ? getTypeAtFlowBranchLabel(flow) : getTypeAtFlowLoopLabel(flow);
              } else if (flags & 256) {
                type2 = getTypeAtFlowArrayMutation(flow);
                if (!type2) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 1024) {
                var target = flow.target;
                var saveAntecedents = target.antecedents;
                target.antecedents = flow.antecedents;
                type2 = getTypeAtFlowNode(flow.antecedent);
                target.antecedents = saveAntecedents;
              } else if (flags & 2) {
                var container = flow.node;
                if (container && container !== flowContainer && reference.kind !== 206 && reference.kind !== 207 && reference.kind !== 108) {
                  flow = container.flowNode;
                  continue;
                }
                type2 = initialType;
              } else {
                type2 = convertAutoToAny(declaredType);
              }
              if (sharedFlow) {
                sharedFlowNodes[sharedFlowCount] = sharedFlow;
                sharedFlowTypes[sharedFlowCount] = type2;
                sharedFlowCount++;
              }
              flowDepth--;
              return type2;
            }
          }
          function getInitialOrAssignedType(flow) {
            var node = flow.node;
            return getNarrowableTypeForReference(node.kind === 254 || node.kind === 203 ? getInitialType(node) : getAssignedType(node), reference);
          }
          function getTypeAtFlowAssignment(flow) {
            var node = flow.node;
            if (isMatchingReference(reference, node)) {
              if (!isReachableFlowNode(flow)) {
                return unreachableNeverType;
              }
              if (ts3.getAssignmentTargetKind(node) === 2) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                return createFlowType(getBaseTypeOfLiteralType(getTypeFromFlowType(flowType)), isIncomplete(flowType));
              }
              if (declaredType === autoType || declaredType === autoArrayType) {
                if (isEmptyArrayAssignment(node)) {
                  return getEvolvingArrayType(neverType);
                }
                var assignedType = getWidenedLiteralType(getInitialOrAssignedType(flow));
                return isTypeAssignableTo(assignedType, declaredType) ? assignedType : anyArrayType;
              }
              if (declaredType.flags & 1048576) {
                return getAssignmentReducedType(declaredType, getInitialOrAssignedType(flow));
              }
              return declaredType;
            }
            if (containsMatchingReference(reference, node)) {
              if (!isReachableFlowNode(flow)) {
                return unreachableNeverType;
              }
              if (ts3.isVariableDeclaration(node) && (ts3.isInJSFile(node) || ts3.isVarConst(node))) {
                var init = ts3.getDeclaredExpandoInitializer(node);
                if (init && (init.kind === 213 || init.kind === 214)) {
                  return getTypeAtFlowNode(flow.antecedent);
                }
              }
              return declaredType;
            }
            if (ts3.isVariableDeclaration(node) && node.parent.parent.kind === 243 && isMatchingReference(reference, node.parent.parent.expression)) {
              return getNonNullableTypeIfNeeded(getTypeFromFlowType(getTypeAtFlowNode(flow.antecedent)));
            }
            return void 0;
          }
          function narrowTypeByAssertion(type2, expr) {
            var node = ts3.skipParentheses(expr, true);
            if (node.kind === 95) {
              return unreachableNeverType;
            }
            if (node.kind === 221) {
              if (node.operatorToken.kind === 55) {
                return narrowTypeByAssertion(narrowTypeByAssertion(type2, node.left), node.right);
              }
              if (node.operatorToken.kind === 56) {
                return getUnionType([narrowTypeByAssertion(type2, node.left), narrowTypeByAssertion(type2, node.right)]);
              }
            }
            return narrowType(type2, node, true);
          }
          function getTypeAtFlowCall(flow) {
            var signature = getEffectsSignature(flow.node);
            if (signature) {
              var predicate = getTypePredicateOfSignature(signature);
              if (predicate && (predicate.kind === 2 || predicate.kind === 3)) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                var type2 = finalizeEvolvingArrayType(getTypeFromFlowType(flowType));
                var narrowedType = predicate.type ? narrowTypeByTypePredicate(type2, predicate, flow.node, true) : predicate.kind === 3 && predicate.parameterIndex >= 0 && predicate.parameterIndex < flow.node.arguments.length ? narrowTypeByAssertion(type2, flow.node.arguments[predicate.parameterIndex]) : type2;
                return narrowedType === type2 ? flowType : createFlowType(narrowedType, isIncomplete(flowType));
              }
              if (getReturnTypeOfSignature(signature).flags & 131072) {
                return unreachableNeverType;
              }
            }
            return void 0;
          }
          function getTypeAtFlowArrayMutation(flow) {
            if (declaredType === autoType || declaredType === autoArrayType) {
              var node = flow.node;
              var expr = node.kind === 208 ? node.expression.expression : node.left.expression;
              if (isMatchingReference(reference, getReferenceCandidate(expr))) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                var type2 = getTypeFromFlowType(flowType);
                if (ts3.getObjectFlags(type2) & 256) {
                  var evolvedType_1 = type2;
                  if (node.kind === 208) {
                    for (var _i = 0, _a = node.arguments; _i < _a.length; _i++) {
                      var arg = _a[_i];
                      evolvedType_1 = addEvolvingArrayElementType(evolvedType_1, arg);
                    }
                  } else {
                    var indexType = getContextFreeTypeOfExpression(node.left.argumentExpression);
                    if (isTypeAssignableToKind(indexType, 296)) {
                      evolvedType_1 = addEvolvingArrayElementType(evolvedType_1, node.right);
                    }
                  }
                  return evolvedType_1 === type2 ? flowType : createFlowType(evolvedType_1, isIncomplete(flowType));
                }
                return flowType;
              }
            }
            return void 0;
          }
          function getTypeAtFlowCondition(flow) {
            var flowType = getTypeAtFlowNode(flow.antecedent);
            var type2 = getTypeFromFlowType(flowType);
            if (type2.flags & 131072) {
              return flowType;
            }
            var assumeTrue = (flow.flags & 32) !== 0;
            var nonEvolvingType = finalizeEvolvingArrayType(type2);
            var narrowedType = narrowType(nonEvolvingType, flow.node, assumeTrue);
            if (narrowedType === nonEvolvingType) {
              return flowType;
            }
            return createFlowType(narrowedType, isIncomplete(flowType));
          }
          function getTypeAtSwitchClause(flow) {
            var expr = flow.switchStatement.expression;
            var flowType = getTypeAtFlowNode(flow.antecedent);
            var type2 = getTypeFromFlowType(flowType);
            if (isMatchingReference(reference, expr)) {
              type2 = narrowTypeBySwitchOnDiscriminant(type2, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
            } else if (expr.kind === 216 && isMatchingReference(reference, expr.expression)) {
              type2 = narrowBySwitchOnTypeOf(type2, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
            } else {
              if (strictNullChecks) {
                if (optionalChainContainsReference(expr, reference)) {
                  type2 = narrowTypeBySwitchOptionalChainContainment(type2, flow.switchStatement, flow.clauseStart, flow.clauseEnd, function(t) {
                    return !(t.flags & (32768 | 131072));
                  });
                } else if (expr.kind === 216 && optionalChainContainsReference(expr.expression, reference)) {
                  type2 = narrowTypeBySwitchOptionalChainContainment(type2, flow.switchStatement, flow.clauseStart, flow.clauseEnd, function(t) {
                    return !(t.flags & 131072 || t.flags & 128 && t.value === "undefined");
                  });
                }
              }
              var access = getDiscriminantPropertyAccess(expr, type2);
              if (access) {
                type2 = narrowTypeBySwitchOnDiscriminantProperty(type2, access, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
              }
            }
            return createFlowType(type2, isIncomplete(flowType));
          }
          function getTypeAtFlowBranchLabel(flow) {
            var antecedentTypes = [];
            var subtypeReduction = false;
            var seenIncomplete = false;
            var bypassFlow;
            for (var _i = 0, _a = flow.antecedents; _i < _a.length; _i++) {
              var antecedent = _a[_i];
              if (!bypassFlow && antecedent.flags & 128 && antecedent.clauseStart === antecedent.clauseEnd) {
                bypassFlow = antecedent;
                continue;
              }
              var flowType = getTypeAtFlowNode(antecedent);
              var type2 = getTypeFromFlowType(flowType);
              if (type2 === declaredType && declaredType === initialType) {
                return type2;
              }
              ts3.pushIfUnique(antecedentTypes, type2);
              if (!isTypeSubsetOf(type2, declaredType)) {
                subtypeReduction = true;
              }
              if (isIncomplete(flowType)) {
                seenIncomplete = true;
              }
            }
            if (bypassFlow) {
              var flowType = getTypeAtFlowNode(bypassFlow);
              var type2 = getTypeFromFlowType(flowType);
              if (!ts3.contains(antecedentTypes, type2) && !isExhaustiveSwitchStatement(bypassFlow.switchStatement)) {
                if (type2 === declaredType && declaredType === initialType) {
                  return type2;
                }
                antecedentTypes.push(type2);
                if (!isTypeSubsetOf(type2, declaredType)) {
                  subtypeReduction = true;
                }
                if (isIncomplete(flowType)) {
                  seenIncomplete = true;
                }
              }
            }
            return createFlowType(getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 : 1), seenIncomplete);
          }
          function getTypeAtFlowLoopLabel(flow) {
            var id = getFlowNodeId(flow);
            var cache = flowLoopCaches[id] || (flowLoopCaches[id] = new ts3.Map());
            var key2 = getOrSetCacheKey();
            if (!key2) {
              return declaredType;
            }
            var cached = cache.get(key2);
            if (cached) {
              return cached;
            }
            for (var i = flowLoopStart; i < flowLoopCount; i++) {
              if (flowLoopNodes[i] === flow && flowLoopKeys[i] === key2 && flowLoopTypes[i].length) {
                return createFlowType(getUnionOrEvolvingArrayType(flowLoopTypes[i], 1), true);
              }
            }
            var antecedentTypes = [];
            var subtypeReduction = false;
            var firstAntecedentType;
            for (var _i = 0, _a = flow.antecedents; _i < _a.length; _i++) {
              var antecedent = _a[_i];
              var flowType = void 0;
              if (!firstAntecedentType) {
                flowType = firstAntecedentType = getTypeAtFlowNode(antecedent);
              } else {
                flowLoopNodes[flowLoopCount] = flow;
                flowLoopKeys[flowLoopCount] = key2;
                flowLoopTypes[flowLoopCount] = antecedentTypes;
                flowLoopCount++;
                var saveFlowTypeCache = flowTypeCache;
                flowTypeCache = void 0;
                flowType = getTypeAtFlowNode(antecedent);
                flowTypeCache = saveFlowTypeCache;
                flowLoopCount--;
                var cached_1 = cache.get(key2);
                if (cached_1) {
                  return cached_1;
                }
              }
              var type2 = getTypeFromFlowType(flowType);
              ts3.pushIfUnique(antecedentTypes, type2);
              if (!isTypeSubsetOf(type2, declaredType)) {
                subtypeReduction = true;
              }
              if (type2 === declaredType) {
                break;
              }
            }
            var result2 = getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 : 1);
            if (isIncomplete(firstAntecedentType)) {
              return createFlowType(result2, true);
            }
            cache.set(key2, result2);
            return result2;
          }
          function getUnionOrEvolvingArrayType(types2, subtypeReduction) {
            if (isEvolvingArrayTypeList(types2)) {
              return getEvolvingArrayType(getUnionType(ts3.map(types2, getElementTypeOfEvolvingArrayType)));
            }
            var result2 = getUnionType(ts3.sameMap(types2, finalizeEvolvingArrayType), subtypeReduction);
            if (result2 !== declaredType && result2.flags & declaredType.flags & 1048576 && ts3.arraysEqual(result2.types, declaredType.types)) {
              return declaredType;
            }
            return result2;
          }
          function getCandidateDiscriminantPropertyAccess(expr) {
            if (ts3.isBindingPattern(reference) || ts3.isFunctionExpressionOrArrowFunction(reference) || ts3.isObjectLiteralMethod(reference)) {
              if (ts3.isIdentifier(expr)) {
                var symbol = getResolvedSymbol(expr);
                var declaration = symbol.valueDeclaration;
                if (declaration && (ts3.isBindingElement(declaration) || ts3.isParameter(declaration)) && reference === declaration.parent && !declaration.initializer && !declaration.dotDotDotToken) {
                  return declaration;
                }
              }
            } else if (ts3.isAccessExpression(expr)) {
              if (isMatchingReference(reference, expr.expression)) {
                return expr;
              }
            } else if (ts3.isIdentifier(expr)) {
              var symbol = getResolvedSymbol(expr);
              if (isConstVariable(symbol)) {
                var declaration = symbol.valueDeclaration;
                if (ts3.isVariableDeclaration(declaration) && !declaration.type && declaration.initializer && ts3.isAccessExpression(declaration.initializer) && isMatchingReference(reference, declaration.initializer.expression)) {
                  return declaration.initializer;
                }
                if (ts3.isBindingElement(declaration) && !declaration.initializer) {
                  var parent = declaration.parent.parent;
                  if (ts3.isVariableDeclaration(parent) && !parent.type && parent.initializer && (ts3.isIdentifier(parent.initializer) || ts3.isAccessExpression(parent.initializer)) && isMatchingReference(reference, parent.initializer)) {
                    return declaration;
                  }
                }
              }
            }
            return void 0;
          }
          function getDiscriminantPropertyAccess(expr, computedType) {
            var type2 = declaredType.flags & 1048576 ? declaredType : computedType;
            if (type2.flags & 1048576) {
              var access = getCandidateDiscriminantPropertyAccess(expr);
              if (access) {
                var name = getAccessedPropertyName(access);
                if (name && isDiscriminantProperty(type2, name)) {
                  return access;
                }
              }
            }
            return void 0;
          }
          function narrowTypeByDiscriminant(type2, access, narrowType2) {
            var propName = getAccessedPropertyName(access);
            if (propName === void 0) {
              return type2;
            }
            var removeNullable = strictNullChecks && ts3.isOptionalChain(access) && maybeTypeOfKind(type2, 98304);
            var propType = getTypeOfPropertyOfType(removeNullable ? getTypeWithFacts(type2, 2097152) : type2, propName);
            if (!propType) {
              return type2;
            }
            propType = removeNullable ? getOptionalType(propType) : propType;
            var narrowedPropType = narrowType2(propType);
            return filterType(type2, function(t) {
              var discriminantType = getTypeOfPropertyOrIndexSignature(t, propName);
              return !(narrowedPropType.flags & 131072) && isTypeComparableTo(narrowedPropType, discriminantType);
            });
          }
          function narrowTypeByDiscriminantProperty(type2, access, operator, value, assumeTrue) {
            if ((operator === 36 || operator === 37) && type2.flags & 1048576) {
              var keyPropertyName = getKeyPropertyName(type2);
              if (keyPropertyName && keyPropertyName === getAccessedPropertyName(access)) {
                var candidate = getConstituentTypeForKeyType(type2, getTypeOfExpression(value));
                if (candidate) {
                  return operator === (assumeTrue ? 36 : 37) ? candidate : isUnitType(getTypeOfPropertyOfType(candidate, keyPropertyName) || unknownType) ? removeType(type2, candidate) : type2;
                }
              }
            }
            return narrowTypeByDiscriminant(type2, access, function(t) {
              return narrowTypeByEquality(t, operator, value, assumeTrue);
            });
          }
          function narrowTypeBySwitchOnDiscriminantProperty(type2, access, switchStatement, clauseStart, clauseEnd) {
            if (clauseStart < clauseEnd && type2.flags & 1048576 && getKeyPropertyName(type2) === getAccessedPropertyName(access)) {
              var clauseTypes = getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd);
              var candidate = getUnionType(ts3.map(clauseTypes, function(t) {
                return getConstituentTypeForKeyType(type2, t) || unknownType;
              }));
              if (candidate !== unknownType) {
                return candidate;
              }
            }
            return narrowTypeByDiscriminant(type2, access, function(t) {
              return narrowTypeBySwitchOnDiscriminant(t, switchStatement, clauseStart, clauseEnd);
            });
          }
          function narrowTypeByTruthiness(type2, expr, assumeTrue) {
            if (isMatchingReference(reference, expr)) {
              return type2.flags & 2 && assumeTrue ? nonNullUnknownType : getTypeWithFacts(type2, assumeTrue ? 4194304 : 8388608);
            }
            if (strictNullChecks && assumeTrue && optionalChainContainsReference(expr, reference)) {
              type2 = getTypeWithFacts(type2, 2097152);
            }
            var access = getDiscriminantPropertyAccess(expr, type2);
            if (access) {
              return narrowTypeByDiscriminant(type2, access, function(t) {
                return getTypeWithFacts(t, assumeTrue ? 4194304 : 8388608);
              });
            }
            return type2;
          }
          function isTypePresencePossible(type2, propName, assumeTrue) {
            var prop = getPropertyOfType(type2, propName);
            if (prop) {
              return prop.flags & 16777216 ? true : assumeTrue;
            }
            return getApplicableIndexInfoForName(type2, propName) ? true : !assumeTrue;
          }
          function narrowByInKeyword(type2, name, assumeTrue) {
            if (type2.flags & 1048576 || type2.flags & 524288 && declaredType !== type2 || ts3.isThisTypeParameter(type2) || type2.flags & 2097152 && ts3.every(type2.types, function(t) {
              return t.symbol !== globalThisSymbol;
            })) {
              return filterType(type2, function(t) {
                return isTypePresencePossible(t, name, assumeTrue);
              });
            }
            return type2;
          }
          function narrowTypeByBinaryExpression(type2, expr, assumeTrue) {
            switch (expr.operatorToken.kind) {
              case 63:
              case 75:
              case 76:
              case 77:
                return narrowTypeByTruthiness(narrowType(type2, expr.right, assumeTrue), expr.left, assumeTrue);
              case 34:
              case 35:
              case 36:
              case 37:
                var operator = expr.operatorToken.kind;
                var left = getReferenceCandidate(expr.left);
                var right = getReferenceCandidate(expr.right);
                if (left.kind === 216 && ts3.isStringLiteralLike(right)) {
                  return narrowTypeByTypeof(type2, left, operator, right, assumeTrue);
                }
                if (right.kind === 216 && ts3.isStringLiteralLike(left)) {
                  return narrowTypeByTypeof(type2, right, operator, left, assumeTrue);
                }
                if (isMatchingReference(reference, left)) {
                  return narrowTypeByEquality(type2, operator, right, assumeTrue);
                }
                if (isMatchingReference(reference, right)) {
                  return narrowTypeByEquality(type2, operator, left, assumeTrue);
                }
                if (strictNullChecks) {
                  if (optionalChainContainsReference(left, reference)) {
                    type2 = narrowTypeByOptionalChainContainment(type2, operator, right, assumeTrue);
                  } else if (optionalChainContainsReference(right, reference)) {
                    type2 = narrowTypeByOptionalChainContainment(type2, operator, left, assumeTrue);
                  }
                }
                var leftAccess = getDiscriminantPropertyAccess(left, type2);
                if (leftAccess) {
                  return narrowTypeByDiscriminantProperty(type2, leftAccess, operator, right, assumeTrue);
                }
                var rightAccess = getDiscriminantPropertyAccess(right, type2);
                if (rightAccess) {
                  return narrowTypeByDiscriminantProperty(type2, rightAccess, operator, left, assumeTrue);
                }
                if (isMatchingConstructorReference(left)) {
                  return narrowTypeByConstructor(type2, operator, right, assumeTrue);
                }
                if (isMatchingConstructorReference(right)) {
                  return narrowTypeByConstructor(type2, operator, left, assumeTrue);
                }
                break;
              case 102:
                return narrowTypeByInstanceof(type2, expr, assumeTrue);
              case 101:
                if (ts3.isPrivateIdentifier(expr.left)) {
                  return narrowTypeByPrivateIdentifierInInExpression(type2, expr, assumeTrue);
                }
                var target = getReferenceCandidate(expr.right);
                var leftType = getTypeOfNode(expr.left);
                if (leftType.flags & 128) {
                  var name = ts3.escapeLeadingUnderscores(leftType.value);
                  if (containsMissingType(type2) && ts3.isAccessExpression(reference) && isMatchingReference(reference.expression, target) && getAccessedPropertyName(reference) === name) {
                    return getTypeWithFacts(type2, assumeTrue ? 524288 : 65536);
                  }
                  if (isMatchingReference(reference, target)) {
                    return narrowByInKeyword(type2, name, assumeTrue);
                  }
                }
                break;
              case 27:
                return narrowType(type2, expr.right, assumeTrue);
              case 55:
                return assumeTrue ? narrowType(narrowType(type2, expr.left, true), expr.right, true) : getUnionType([narrowType(type2, expr.left, false), narrowType(type2, expr.right, false)]);
              case 56:
                return assumeTrue ? getUnionType([narrowType(type2, expr.left, true), narrowType(type2, expr.right, true)]) : narrowType(narrowType(type2, expr.left, false), expr.right, false);
            }
            return type2;
          }
          function narrowTypeByPrivateIdentifierInInExpression(type2, expr, assumeTrue) {
            var target = getReferenceCandidate(expr.right);
            if (!isMatchingReference(reference, target)) {
              return type2;
            }
            ts3.Debug.assertNode(expr.left, ts3.isPrivateIdentifier);
            var symbol = getSymbolForPrivateIdentifierExpression(expr.left);
            if (symbol === void 0) {
              return type2;
            }
            var classSymbol = symbol.parent;
            var targetType = ts3.hasStaticModifier(ts3.Debug.checkDefined(symbol.valueDeclaration, "should always have a declaration")) ? getTypeOfSymbol(classSymbol) : getDeclaredTypeOfSymbol(classSymbol);
            return getNarrowedType(type2, targetType, assumeTrue, isTypeDerivedFrom);
          }
          function narrowTypeByOptionalChainContainment(type2, operator, value, assumeTrue) {
            var equalsOperator = operator === 34 || operator === 36;
            var nullableFlags = operator === 34 || operator === 35 ? 98304 : 32768;
            var valueType = getTypeOfExpression(value);
            var removeNullable = equalsOperator !== assumeTrue && everyType(valueType, function(t) {
              return !!(t.flags & nullableFlags);
            }) || equalsOperator === assumeTrue && everyType(valueType, function(t) {
              return !(t.flags & (3 | nullableFlags));
            });
            return removeNullable ? getTypeWithFacts(type2, 2097152) : type2;
          }
          function narrowTypeByEquality(type2, operator, value, assumeTrue) {
            if (type2.flags & 1) {
              return type2;
            }
            if (operator === 35 || operator === 37) {
              assumeTrue = !assumeTrue;
            }
            var valueType = getTypeOfExpression(value);
            if (assumeTrue && type2.flags & 2 && (operator === 34 || operator === 35) && valueType.flags & 65536) {
              return getUnionType([nullType, undefinedType]);
            }
            if (type2.flags & 2 && assumeTrue && (operator === 36 || operator === 37)) {
              if (valueType.flags & (131068 | 67108864)) {
                return valueType;
              }
              if (valueType.flags & 524288) {
                return nonPrimitiveType;
              }
              return type2;
            }
            if (valueType.flags & 98304) {
              if (!strictNullChecks) {
                return type2;
              }
              var doubleEquals = operator === 34 || operator === 35;
              var facts = doubleEquals ? assumeTrue ? 262144 : 2097152 : valueType.flags & 65536 ? assumeTrue ? 131072 : 1048576 : assumeTrue ? 65536 : 524288;
              return type2.flags & 2 && facts & (1048576 | 2097152) ? nonNullUnknownType : getTypeWithFacts(type2, facts);
            }
            if (assumeTrue) {
              var filterFn = operator === 34 ? function(t) {
                return areTypesComparable(t, valueType) || isCoercibleUnderDoubleEquals(t, valueType);
              } : function(t) {
                return areTypesComparable(t, valueType);
              };
              return replacePrimitivesWithLiterals(filterType(type2, filterFn), valueType);
            }
            if (isUnitType(valueType)) {
              return filterType(type2, function(t) {
                return !(isUnitLikeType(t) && areTypesComparable(t, valueType));
              });
            }
            return type2;
          }
          function narrowTypeByTypeof(type2, typeOfExpr, operator, literal, assumeTrue) {
            if (operator === 35 || operator === 37) {
              assumeTrue = !assumeTrue;
            }
            var target = getReferenceCandidate(typeOfExpr.expression);
            if (!isMatchingReference(reference, target)) {
              if (strictNullChecks && optionalChainContainsReference(target, reference) && assumeTrue === (literal.text !== "undefined")) {
                return getTypeWithFacts(type2, 2097152);
              }
              return type2;
            }
            if (type2.flags & 1 && literal.text === "function") {
              return type2;
            }
            if (assumeTrue && type2.flags & 2 && literal.text === "object") {
              return type2 === nonNullUnknownType ? nonPrimitiveType : getUnionType([nonPrimitiveType, nullType]);
            }
            var facts = assumeTrue ? typeofEQFacts.get(literal.text) || 128 : typeofNEFacts.get(literal.text) || 32768;
            var impliedType = getImpliedTypeFromTypeofGuard(type2, literal.text);
            return getTypeWithFacts(assumeTrue && impliedType ? mapType(type2, narrowUnionMemberByTypeof(impliedType)) : type2, facts);
          }
          function narrowTypeBySwitchOptionalChainContainment(type2, switchStatement, clauseStart, clauseEnd, clauseCheck) {
            var everyClauseChecks = clauseStart !== clauseEnd && ts3.every(getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd), clauseCheck);
            return everyClauseChecks ? getTypeWithFacts(type2, 2097152) : type2;
          }
          function narrowTypeBySwitchOnDiscriminant(type2, switchStatement, clauseStart, clauseEnd) {
            var switchTypes = getSwitchClauseTypes(switchStatement);
            if (!switchTypes.length) {
              return type2;
            }
            var clauseTypes = switchTypes.slice(clauseStart, clauseEnd);
            var hasDefaultClause = clauseStart === clauseEnd || ts3.contains(clauseTypes, neverType);
            if (type2.flags & 2 && !hasDefaultClause) {
              var groundClauseTypes = void 0;
              for (var i = 0; i < clauseTypes.length; i += 1) {
                var t = clauseTypes[i];
                if (t.flags & (131068 | 67108864)) {
                  if (groundClauseTypes !== void 0) {
                    groundClauseTypes.push(t);
                  }
                } else if (t.flags & 524288) {
                  if (groundClauseTypes === void 0) {
                    groundClauseTypes = clauseTypes.slice(0, i);
                  }
                  groundClauseTypes.push(nonPrimitiveType);
                } else {
                  return type2;
                }
              }
              return getUnionType(groundClauseTypes === void 0 ? clauseTypes : groundClauseTypes);
            }
            var discriminantType = getUnionType(clauseTypes);
            var caseType = discriminantType.flags & 131072 ? neverType : replacePrimitivesWithLiterals(filterType(type2, function(t2) {
              return areTypesComparable(discriminantType, t2);
            }), discriminantType);
            if (!hasDefaultClause) {
              return caseType;
            }
            var defaultType = filterType(type2, function(t2) {
              return !(isUnitLikeType(t2) && ts3.contains(switchTypes, getRegularTypeOfLiteralType(extractUnitType(t2))));
            });
            return caseType.flags & 131072 ? defaultType : getUnionType([caseType, defaultType]);
          }
          function getImpliedTypeFromTypeofGuard(type2, text) {
            switch (text) {
              case "function":
                return type2.flags & 1 ? type2 : globalFunctionType;
              case "object":
                return type2.flags & 2 ? getUnionType([nonPrimitiveType, nullType]) : type2;
              default:
                return typeofTypesByName.get(text);
            }
          }
          function narrowUnionMemberByTypeof(candidate) {
            return function(type2) {
              if (isTypeSubtypeOf(type2, candidate)) {
                return type2;
              }
              if (isTypeSubtypeOf(candidate, type2)) {
                return candidate;
              }
              if (type2.flags & 465829888) {
                var constraint = getBaseConstraintOfType(type2) || anyType;
                if (isTypeSubtypeOf(candidate, constraint)) {
                  return getIntersectionType([type2, candidate]);
                }
              }
              return type2;
            };
          }
          function narrowBySwitchOnTypeOf(type2, switchStatement, clauseStart, clauseEnd) {
            var switchWitnesses = getSwitchClauseTypeOfWitnesses(switchStatement, true);
            if (!switchWitnesses.length) {
              return type2;
            }
            var defaultCaseLocation = ts3.findIndex(switchWitnesses, function(elem) {
              return elem === void 0;
            });
            var hasDefaultClause = clauseStart === clauseEnd || defaultCaseLocation >= clauseStart && defaultCaseLocation < clauseEnd;
            var clauseWitnesses;
            var switchFacts;
            if (defaultCaseLocation > -1) {
              var witnesses = switchWitnesses.filter(function(witness) {
                return witness !== void 0;
              });
              var fixedClauseStart = defaultCaseLocation < clauseStart ? clauseStart - 1 : clauseStart;
              var fixedClauseEnd = defaultCaseLocation < clauseEnd ? clauseEnd - 1 : clauseEnd;
              clauseWitnesses = witnesses.slice(fixedClauseStart, fixedClauseEnd);
              switchFacts = getFactsFromTypeofSwitch(fixedClauseStart, fixedClauseEnd, witnesses, hasDefaultClause);
            } else {
              clauseWitnesses = switchWitnesses.slice(clauseStart, clauseEnd);
              switchFacts = getFactsFromTypeofSwitch(clauseStart, clauseEnd, switchWitnesses, hasDefaultClause);
            }
            if (hasDefaultClause) {
              return filterType(type2, function(t) {
                return (getTypeFacts(t) & switchFacts) === switchFacts;
              });
            }
            var impliedType = getTypeWithFacts(getUnionType(clauseWitnesses.map(function(text) {
              return getImpliedTypeFromTypeofGuard(type2, text) || type2;
            })), switchFacts);
            return getTypeWithFacts(mapType(type2, narrowUnionMemberByTypeof(impliedType)), switchFacts);
          }
          function isMatchingConstructorReference(expr) {
            return (ts3.isPropertyAccessExpression(expr) && ts3.idText(expr.name) === "constructor" || ts3.isElementAccessExpression(expr) && ts3.isStringLiteralLike(expr.argumentExpression) && expr.argumentExpression.text === "constructor") && isMatchingReference(reference, expr.expression);
          }
          function narrowTypeByConstructor(type2, operator, identifier, assumeTrue) {
            if (assumeTrue ? operator !== 34 && operator !== 36 : operator !== 35 && operator !== 37) {
              return type2;
            }
            var identifierType = getTypeOfExpression(identifier);
            if (!isFunctionType(identifierType) && !isConstructorType(identifierType)) {
              return type2;
            }
            var prototypeProperty = getPropertyOfType(identifierType, "prototype");
            if (!prototypeProperty) {
              return type2;
            }
            var prototypeType = getTypeOfSymbol(prototypeProperty);
            var candidate = !isTypeAny(prototypeType) ? prototypeType : void 0;
            if (!candidate || candidate === globalObjectType || candidate === globalFunctionType) {
              return type2;
            }
            if (isTypeAny(type2)) {
              return candidate;
            }
            return filterType(type2, function(t) {
              return isConstructedBy(t, candidate);
            });
            function isConstructedBy(source, target) {
              if (source.flags & 524288 && ts3.getObjectFlags(source) & 1 || target.flags & 524288 && ts3.getObjectFlags(target) & 1) {
                return source.symbol === target.symbol;
              }
              return isTypeSubtypeOf(source, target);
            }
          }
          function narrowTypeByInstanceof(type2, expr, assumeTrue) {
            var left = getReferenceCandidate(expr.left);
            if (!isMatchingReference(reference, left)) {
              if (assumeTrue && strictNullChecks && optionalChainContainsReference(left, reference)) {
                return getTypeWithFacts(type2, 2097152);
              }
              return type2;
            }
            var rightType = getTypeOfExpression(expr.right);
            if (!isTypeDerivedFrom(rightType, globalFunctionType)) {
              return type2;
            }
            var targetType;
            var prototypeProperty = getPropertyOfType(rightType, "prototype");
            if (prototypeProperty) {
              var prototypePropertyType = getTypeOfSymbol(prototypeProperty);
              if (!isTypeAny(prototypePropertyType)) {
                targetType = prototypePropertyType;
              }
            }
            if (isTypeAny(type2) && (targetType === globalObjectType || targetType === globalFunctionType)) {
              return type2;
            }
            if (!targetType) {
              var constructSignatures = getSignaturesOfType(rightType, 1);
              targetType = constructSignatures.length ? getUnionType(ts3.map(constructSignatures, function(signature) {
                return getReturnTypeOfSignature(getErasedSignature(signature));
              })) : emptyObjectType;
            }
            if (!assumeTrue && rightType.flags & 1048576) {
              var nonConstructorTypeInUnion = ts3.find(rightType.types, function(t) {
                return !isConstructorType(t);
              });
              if (!nonConstructorTypeInUnion)
                return type2;
            }
            return getNarrowedType(type2, targetType, assumeTrue, isTypeDerivedFrom);
          }
          function getNarrowedType(type2, candidate, assumeTrue, isRelated) {
            if (!assumeTrue) {
              return filterType(type2, function(t) {
                return !isRelated(t, candidate);
              });
            }
            if (type2.flags & 1048576) {
              var assignableType = filterType(type2, function(t) {
                return isRelated(t, candidate);
              });
              if (!(assignableType.flags & 131072)) {
                return assignableType;
              }
            }
            return isTypeSubtypeOf(candidate, type2) ? candidate : isTypeAssignableTo(type2, candidate) ? type2 : isTypeAssignableTo(candidate, type2) ? candidate : getIntersectionType([type2, candidate]);
          }
          function narrowTypeByCallExpression(type2, callExpression, assumeTrue) {
            if (hasMatchingArgument(callExpression, reference)) {
              var signature = assumeTrue || !ts3.isCallChain(callExpression) ? getEffectsSignature(callExpression) : void 0;
              var predicate = signature && getTypePredicateOfSignature(signature);
              if (predicate && (predicate.kind === 0 || predicate.kind === 1)) {
                return narrowTypeByTypePredicate(type2, predicate, callExpression, assumeTrue);
              }
            }
            if (containsMissingType(type2) && ts3.isAccessExpression(reference) && ts3.isPropertyAccessExpression(callExpression.expression)) {
              var callAccess = callExpression.expression;
              if (isMatchingReference(reference.expression, getReferenceCandidate(callAccess.expression)) && ts3.isIdentifier(callAccess.name) && callAccess.name.escapedText === "hasOwnProperty" && callExpression.arguments.length === 1) {
                var argument = callExpression.arguments[0];
                if (ts3.isStringLiteralLike(argument) && getAccessedPropertyName(reference) === ts3.escapeLeadingUnderscores(argument.text)) {
                  return getTypeWithFacts(type2, assumeTrue ? 524288 : 65536);
                }
              }
            }
            return type2;
          }
          function narrowTypeByTypePredicate(type2, predicate, callExpression, assumeTrue) {
            if (predicate.type && !(isTypeAny(type2) && (predicate.type === globalObjectType || predicate.type === globalFunctionType))) {
              var predicateArgument = getTypePredicateArgument(predicate, callExpression);
              if (predicateArgument) {
                if (isMatchingReference(reference, predicateArgument)) {
                  return getNarrowedType(type2, predicate.type, assumeTrue, isTypeSubtypeOf);
                }
                if (strictNullChecks && assumeTrue && optionalChainContainsReference(predicateArgument, reference) && !(getTypeFacts(predicate.type) & 65536)) {
                  type2 = getTypeWithFacts(type2, 2097152);
                }
                var access = getDiscriminantPropertyAccess(predicateArgument, type2);
                if (access) {
                  return narrowTypeByDiscriminant(type2, access, function(t) {
                    return getNarrowedType(t, predicate.type, assumeTrue, isTypeSubtypeOf);
                  });
                }
              }
            }
            return type2;
          }
          function narrowType(type2, expr, assumeTrue) {
            if (ts3.isExpressionOfOptionalChainRoot(expr) || ts3.isBinaryExpression(expr.parent) && expr.parent.operatorToken.kind === 60 && expr.parent.left === expr) {
              return narrowTypeByOptionality(type2, expr, assumeTrue);
            }
            switch (expr.kind) {
              case 79:
                if (!isMatchingReference(reference, expr) && inlineLevel < 5) {
                  var symbol = getResolvedSymbol(expr);
                  if (isConstVariable(symbol)) {
                    var declaration = symbol.valueDeclaration;
                    if (declaration && ts3.isVariableDeclaration(declaration) && !declaration.type && declaration.initializer && isConstantReference(reference)) {
                      inlineLevel++;
                      var result2 = narrowType(type2, declaration.initializer, assumeTrue);
                      inlineLevel--;
                      return result2;
                    }
                  }
                }
              case 108:
              case 106:
              case 206:
              case 207:
                return narrowTypeByTruthiness(type2, expr, assumeTrue);
              case 208:
                return narrowTypeByCallExpression(type2, expr, assumeTrue);
              case 212:
              case 230:
                return narrowType(type2, expr.expression, assumeTrue);
              case 221:
                return narrowTypeByBinaryExpression(type2, expr, assumeTrue);
              case 219:
                if (expr.operator === 53) {
                  return narrowType(type2, expr.operand, !assumeTrue);
                }
                break;
            }
            return type2;
          }
          function narrowTypeByOptionality(type2, expr, assumePresent) {
            if (isMatchingReference(reference, expr)) {
              return getTypeWithFacts(type2, assumePresent ? 2097152 : 262144);
            }
            var access = getDiscriminantPropertyAccess(expr, type2);
            if (access) {
              return narrowTypeByDiscriminant(type2, access, function(t) {
                return getTypeWithFacts(t, assumePresent ? 2097152 : 262144);
              });
            }
            return type2;
          }
        }
        function getTypeOfSymbolAtLocation(symbol, location) {
          symbol = symbol.exportSymbol || symbol;
          if (location.kind === 79 || location.kind === 80) {
            if (ts3.isRightSideOfQualifiedNameOrPropertyAccess(location)) {
              location = location.parent;
            }
            if (ts3.isExpressionNode(location) && (!ts3.isAssignmentTarget(location) || ts3.isWriteAccess(location))) {
              var type2 = getTypeOfExpression(location);
              if (getExportSymbolOfValueSymbolIfExported(getNodeLinks(location).resolvedSymbol) === symbol) {
                return type2;
              }
            }
          }
          if (ts3.isDeclarationName(location) && ts3.isSetAccessor(location.parent) && getAnnotatedAccessorTypeNode(location.parent)) {
            return getWriteTypeOfAccessors(location.parent.symbol);
          }
          return getNonMissingTypeOfSymbol(symbol);
        }
        function getControlFlowContainer(node) {
          return ts3.findAncestor(node.parent, function(node2) {
            return ts3.isFunctionLike(node2) && !ts3.getImmediatelyInvokedFunctionExpression(node2) || node2.kind === 262 || node2.kind === 305 || node2.kind === 167;
          });
        }
        function isSymbolAssigned(symbol) {
          if (!symbol.valueDeclaration) {
            return false;
          }
          var parent = ts3.getRootDeclaration(symbol.valueDeclaration).parent;
          var links = getNodeLinks(parent);
          if (!(links.flags & 8388608)) {
            links.flags |= 8388608;
            if (!hasParentWithAssignmentsMarked(parent)) {
              markNodeAssignments(parent);
            }
          }
          return symbol.isAssigned || false;
        }
        function hasParentWithAssignmentsMarked(node) {
          return !!ts3.findAncestor(node.parent, function(node2) {
            return (ts3.isFunctionLike(node2) || ts3.isCatchClause(node2)) && !!(getNodeLinks(node2).flags & 8388608);
          });
        }
        function markNodeAssignments(node) {
          if (node.kind === 79) {
            if (ts3.isAssignmentTarget(node)) {
              var symbol = getResolvedSymbol(node);
              if (ts3.isParameterOrCatchClauseVariable(symbol)) {
                symbol.isAssigned = true;
              }
            }
          } else {
            ts3.forEachChild(node, markNodeAssignments);
          }
        }
        function isConstVariable(symbol) {
          return symbol.flags & 3 && (getDeclarationNodeFlagsFromSymbol(symbol) & 2) !== 0;
        }
        function removeOptionalityFromDeclaredType(declaredType, declaration) {
          if (pushTypeResolution(declaration.symbol, 2)) {
            var annotationIncludesUndefined = strictNullChecks && declaration.kind === 164 && declaration.initializer && getFalsyFlags(declaredType) & 32768 && !(getFalsyFlags(checkExpression(declaration.initializer)) & 32768);
            popTypeResolution();
            return annotationIncludesUndefined ? getTypeWithFacts(declaredType, 524288) : declaredType;
          } else {
            reportCircularityError(declaration.symbol);
            return declaredType;
          }
        }
        function isConstraintPosition(type2, node) {
          var parent = node.parent;
          return parent.kind === 206 || parent.kind === 161 || parent.kind === 208 && parent.expression === node || parent.kind === 207 && parent.expression === node && !(someType(type2, isGenericTypeWithoutNullableConstraint) && isGenericIndexType(getTypeOfExpression(parent.argumentExpression)));
        }
        function isGenericTypeWithUnionConstraint(type2) {
          return !!(type2.flags & 465829888 && getBaseConstraintOrType(type2).flags & (98304 | 1048576));
        }
        function isGenericTypeWithoutNullableConstraint(type2) {
          return !!(type2.flags & 465829888 && !maybeTypeOfKind(getBaseConstraintOrType(type2), 98304));
        }
        function hasContextualTypeWithNoGenericTypes(node, checkMode) {
          var contextualType = (ts3.isIdentifier(node) || ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node)) && !((ts3.isJsxOpeningElement(node.parent) || ts3.isJsxSelfClosingElement(node.parent)) && node.parent.tagName === node) && (checkMode && checkMode & 64 ? getContextualType(node, 8) : getContextualType(node));
          return contextualType && !isGenericType(contextualType);
        }
        function getNarrowableTypeForReference(type2, reference, checkMode) {
          var substituteConstraints = !(checkMode && checkMode & 2) && someType(type2, isGenericTypeWithUnionConstraint) && (isConstraintPosition(type2, reference) || hasContextualTypeWithNoGenericTypes(reference, checkMode));
          return substituteConstraints ? mapType(type2, function(t) {
            return t.flags & 465829888 ? getBaseConstraintOrType(t) : t;
          }) : type2;
        }
        function isExportOrExportExpression(location) {
          return !!ts3.findAncestor(location, function(n) {
            var parent = n.parent;
            if (parent === void 0) {
              return "quit";
            }
            if (ts3.isExportAssignment(parent)) {
              return parent.expression === n && ts3.isEntityNameExpression(n);
            }
            if (ts3.isExportSpecifier(parent)) {
              return parent.name === n || parent.propertyName === n;
            }
            return false;
          });
        }
        function markAliasReferenced(symbol, location) {
          if (isNonLocalAlias(symbol, 111551) && !isInTypeQuery(location) && !getTypeOnlyAliasDeclaration(symbol)) {
            var target = resolveAlias(symbol);
            if (target.flags & 111551) {
              if (compilerOptions.isolatedModules || ts3.shouldPreserveConstEnums(compilerOptions) && isExportOrExportExpression(location) || !isConstEnumOrConstEnumOnlyModule(target)) {
                markAliasSymbolAsReferenced(symbol);
              } else {
                markConstEnumAliasAsReferenced(symbol);
              }
            }
          }
        }
        function getNarrowedTypeOfSymbol(symbol, location) {
          var declaration = symbol.valueDeclaration;
          if (declaration) {
            if (ts3.isBindingElement(declaration) && !declaration.initializer && !declaration.dotDotDotToken && declaration.parent.elements.length >= 2) {
              var parent = declaration.parent.parent;
              if (parent.kind === 254 && ts3.getCombinedNodeFlags(declaration) & 2 || parent.kind === 164) {
                var links = getNodeLinks(parent);
                if (!(links.flags & 268435456)) {
                  links.flags |= 268435456;
                  var parentType = getTypeForBindingElementParent(parent, 0);
                  links.flags &= ~268435456;
                  if (parentType && parentType.flags & 1048576 && !(parent.kind === 164 && isSymbolAssigned(symbol))) {
                    var pattern = declaration.parent;
                    var narrowedType = getFlowTypeOfReference(pattern, parentType, parentType, void 0, location.flowNode);
                    if (narrowedType.flags & 131072) {
                      return neverType;
                    }
                    return getBindingElementTypeFromParentType(declaration, narrowedType);
                  }
                }
              }
            }
            if (ts3.isParameter(declaration) && !declaration.type && !declaration.initializer && !declaration.dotDotDotToken) {
              var func = declaration.parent;
              if (func.parameters.length >= 2 && isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
                var contextualSignature = getContextualSignature(func);
                if (contextualSignature && contextualSignature.parameters.length === 1 && signatureHasRestParameter(contextualSignature)) {
                  var restType = getReducedApparentType(getTypeOfSymbol(contextualSignature.parameters[0]));
                  if (restType.flags & 1048576 && everyType(restType, isTupleType) && !isSymbolAssigned(symbol)) {
                    var narrowedType = getFlowTypeOfReference(func, restType, restType, void 0, location.flowNode);
                    var index = func.parameters.indexOf(declaration) - (ts3.getThisParameter(func) ? 1 : 0);
                    return getIndexedAccessType(narrowedType, getNumberLiteralType(index));
                  }
                }
              }
            }
          }
          return getTypeOfSymbol(symbol);
        }
        function checkIdentifier(node, checkMode) {
          if (ts3.isThisInTypeQuery(node)) {
            return checkThisExpression(node);
          }
          var symbol = getResolvedSymbol(node);
          if (symbol === unknownSymbol) {
            return errorType;
          }
          if (symbol === argumentsSymbol) {
            if (isInPropertyInitializerOrClassStaticBlock(node)) {
              error(node, ts3.Diagnostics.arguments_cannot_be_referenced_in_property_initializers);
              return errorType;
            }
            var container = ts3.getContainingFunction(node);
            if (languageVersion < 2) {
              if (container.kind === 214) {
                error(node, ts3.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression);
              } else if (ts3.hasSyntacticModifier(container, 256)) {
                error(node, ts3.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method);
              }
            }
            getNodeLinks(container).flags |= 8192;
            return getTypeOfSymbol(symbol);
          }
          if (!(node.parent && ts3.isPropertyAccessExpression(node.parent) && node.parent.expression === node)) {
            markAliasReferenced(symbol, node);
          }
          var localOrExportSymbol = getExportSymbolOfValueSymbolIfExported(symbol);
          var targetSymbol = checkDeprecatedAliasedSymbol(localOrExportSymbol, node);
          if (isDeprecatedSymbol(targetSymbol) && isUncalledFunctionReference(node, targetSymbol) && targetSymbol.declarations) {
            addDeprecatedSuggestion(node, targetSymbol.declarations, node.escapedText);
          }
          var declaration = localOrExportSymbol.valueDeclaration;
          if (declaration && localOrExportSymbol.flags & 32) {
            if (declaration.kind === 257 && ts3.nodeIsDecorated(declaration)) {
              var container = ts3.getContainingClass(node);
              while (container !== void 0) {
                if (container === declaration && container.name !== node) {
                  getNodeLinks(declaration).flags |= 16777216;
                  getNodeLinks(node).flags |= 33554432;
                  break;
                }
                container = ts3.getContainingClass(container);
              }
            } else if (declaration.kind === 226) {
              var container = ts3.getThisContainer(node, false);
              while (container.kind !== 305) {
                if (container.parent === declaration) {
                  if (ts3.isPropertyDeclaration(container) && ts3.isStatic(container) || ts3.isClassStaticBlockDeclaration(container)) {
                    getNodeLinks(declaration).flags |= 16777216;
                    getNodeLinks(node).flags |= 33554432;
                  }
                  break;
                }
                container = ts3.getThisContainer(container, false);
              }
            }
          }
          checkNestedBlockScopedBinding(node, symbol);
          var type2 = getNarrowedTypeOfSymbol(localOrExportSymbol, node);
          var assignmentKind = ts3.getAssignmentTargetKind(node);
          if (assignmentKind) {
            if (!(localOrExportSymbol.flags & 3) && !(ts3.isInJSFile(node) && localOrExportSymbol.flags & 512)) {
              var assignmentError = localOrExportSymbol.flags & 384 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_an_enum : localOrExportSymbol.flags & 32 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_class : localOrExportSymbol.flags & 1536 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_namespace : localOrExportSymbol.flags & 16 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_function : localOrExportSymbol.flags & 2097152 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_an_import : ts3.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable;
              error(node, assignmentError, symbolToString(symbol));
              return errorType;
            }
            if (isReadonlySymbol(localOrExportSymbol)) {
              if (localOrExportSymbol.flags & 3) {
                error(node, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant, symbolToString(symbol));
              } else {
                error(node, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(symbol));
              }
              return errorType;
            }
          }
          var isAlias = localOrExportSymbol.flags & 2097152;
          if (localOrExportSymbol.flags & 3) {
            if (assignmentKind === 1) {
              return type2;
            }
          } else if (isAlias) {
            declaration = getDeclarationOfAliasSymbol(symbol);
          } else {
            return type2;
          }
          if (!declaration) {
            return type2;
          }
          type2 = getNarrowableTypeForReference(type2, node, checkMode);
          var isParameter = ts3.getRootDeclaration(declaration).kind === 164;
          var declarationContainer = getControlFlowContainer(declaration);
          var flowContainer = getControlFlowContainer(node);
          var isOuterVariable = flowContainer !== declarationContainer;
          var isSpreadDestructuringAssignmentTarget = node.parent && node.parent.parent && ts3.isSpreadAssignment(node.parent) && isDestructuringAssignmentTarget(node.parent.parent);
          var isModuleExports = symbol.flags & 134217728;
          while (flowContainer !== declarationContainer && (flowContainer.kind === 213 || flowContainer.kind === 214 || ts3.isObjectLiteralOrClassExpressionMethodOrAccessor(flowContainer)) && (isConstVariable(localOrExportSymbol) && type2 !== autoArrayType || isParameter && !isSymbolAssigned(localOrExportSymbol))) {
            flowContainer = getControlFlowContainer(flowContainer);
          }
          var assumeInitialized = isParameter || isAlias || isOuterVariable || isSpreadDestructuringAssignmentTarget || isModuleExports || ts3.isBindingElement(declaration) || type2 !== autoType && type2 !== autoArrayType && (!strictNullChecks || (type2.flags & (3 | 16384)) !== 0 || isInTypeQuery(node) || node.parent.kind === 275) || node.parent.kind === 230 || declaration.kind === 254 && declaration.exclamationToken || declaration.flags & 16777216;
          var initialType = assumeInitialized ? isParameter ? removeOptionalityFromDeclaredType(type2, declaration) : type2 : type2 === autoType || type2 === autoArrayType ? undefinedType : getOptionalType(type2);
          var flowType = getFlowTypeOfReference(node, type2, initialType, flowContainer);
          if (!isEvolvingArrayOperationTarget(node) && (type2 === autoType || type2 === autoArrayType)) {
            if (flowType === autoType || flowType === autoArrayType) {
              if (noImplicitAny) {
                error(ts3.getNameOfDeclaration(declaration), ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined, symbolToString(symbol), typeToString(flowType));
                error(node, ts3.Diagnostics.Variable_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
              }
              return convertAutoToAny(flowType);
            }
          } else if (!assumeInitialized && !(getFalsyFlags(type2) & 32768) && getFalsyFlags(flowType) & 32768) {
            error(node, ts3.Diagnostics.Variable_0_is_used_before_being_assigned, symbolToString(symbol));
            return type2;
          }
          return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
        }
        function isInsideFunctionOrInstancePropertyInitializer(node, threshold) {
          return !!ts3.findAncestor(node, function(n) {
            return n === threshold ? "quit" : ts3.isFunctionLike(n) || n.parent && ts3.isPropertyDeclaration(n.parent) && !ts3.hasStaticModifier(n.parent) && n.parent.initializer === n;
          });
        }
        function getPartOfForStatementContainingNode(node, container) {
          return ts3.findAncestor(node, function(n) {
            return n === container ? "quit" : n === container.initializer || n === container.condition || n === container.incrementor || n === container.statement;
          });
        }
        function getEnclosingIterationStatement(node) {
          return ts3.findAncestor(node, function(n) {
            return !n || ts3.nodeStartsNewLexicalEnvironment(n) ? "quit" : ts3.isIterationStatement(n, false);
          });
        }
        function checkNestedBlockScopedBinding(node, symbol) {
          if (languageVersion >= 2 || (symbol.flags & (2 | 32)) === 0 || !symbol.valueDeclaration || ts3.isSourceFile(symbol.valueDeclaration) || symbol.valueDeclaration.parent.kind === 292) {
            return;
          }
          var container = ts3.getEnclosingBlockScopeContainer(symbol.valueDeclaration);
          var isCaptured = isInsideFunctionOrInstancePropertyInitializer(node, container);
          var enclosingIterationStatement = getEnclosingIterationStatement(container);
          if (enclosingIterationStatement) {
            if (isCaptured) {
              var capturesBlockScopeBindingInLoopBody = true;
              if (ts3.isForStatement(container)) {
                var varDeclList = ts3.getAncestor(symbol.valueDeclaration, 255);
                if (varDeclList && varDeclList.parent === container) {
                  var part = getPartOfForStatementContainingNode(node.parent, container);
                  if (part) {
                    var links = getNodeLinks(part);
                    links.flags |= 131072;
                    var capturedBindings = links.capturedBlockScopeBindings || (links.capturedBlockScopeBindings = []);
                    ts3.pushIfUnique(capturedBindings, symbol);
                    if (part === container.initializer) {
                      capturesBlockScopeBindingInLoopBody = false;
                    }
                  }
                }
              }
              if (capturesBlockScopeBindingInLoopBody) {
                getNodeLinks(enclosingIterationStatement).flags |= 65536;
              }
            }
            if (ts3.isForStatement(container)) {
              var varDeclList = ts3.getAncestor(symbol.valueDeclaration, 255);
              if (varDeclList && varDeclList.parent === container && isAssignedInBodyOfForStatement(node, container)) {
                getNodeLinks(symbol.valueDeclaration).flags |= 4194304;
              }
            }
            getNodeLinks(symbol.valueDeclaration).flags |= 524288;
          }
          if (isCaptured) {
            getNodeLinks(symbol.valueDeclaration).flags |= 262144;
          }
        }
        function isBindingCapturedByNode(node, decl) {
          var links = getNodeLinks(node);
          return !!links && ts3.contains(links.capturedBlockScopeBindings, getSymbolOfNode(decl));
        }
        function isAssignedInBodyOfForStatement(node, container) {
          var current = node;
          while (current.parent.kind === 212) {
            current = current.parent;
          }
          var isAssigned = false;
          if (ts3.isAssignmentTarget(current)) {
            isAssigned = true;
          } else if (current.parent.kind === 219 || current.parent.kind === 220) {
            var expr = current.parent;
            isAssigned = expr.operator === 45 || expr.operator === 46;
          }
          if (!isAssigned) {
            return false;
          }
          return !!ts3.findAncestor(current, function(n) {
            return n === container ? "quit" : n === container.statement;
          });
        }
        function captureLexicalThis(node, container) {
          getNodeLinks(node).flags |= 2;
          if (container.kind === 167 || container.kind === 171) {
            var classNode = container.parent;
            getNodeLinks(classNode).flags |= 4;
          } else {
            getNodeLinks(container).flags |= 4;
          }
        }
        function findFirstSuperCall(node) {
          return ts3.isSuperCall(node) ? node : ts3.isFunctionLike(node) ? void 0 : ts3.forEachChild(node, findFirstSuperCall);
        }
        function classDeclarationExtendsNull(classDecl) {
          var classSymbol = getSymbolOfNode(classDecl);
          var classInstanceType = getDeclaredTypeOfSymbol(classSymbol);
          var baseConstructorType = getBaseConstructorTypeOfClass(classInstanceType);
          return baseConstructorType === nullWideningType;
        }
        function checkThisBeforeSuper(node, container, diagnosticMessage) {
          var containingClassDecl = container.parent;
          var baseTypeNode = ts3.getClassExtendsHeritageElement(containingClassDecl);
          if (baseTypeNode && !classDeclarationExtendsNull(containingClassDecl)) {
            if (node.flowNode && !isPostSuperFlowNode(node.flowNode, false)) {
              error(node, diagnosticMessage);
            }
          }
        }
        function checkThisInStaticClassFieldInitializerInDecoratedClass(thisExpression, container) {
          if (ts3.isPropertyDeclaration(container) && ts3.hasStaticModifier(container) && container.initializer && ts3.textRangeContainsPositionInclusive(container.initializer, thisExpression.pos) && ts3.length(container.parent.decorators)) {
            error(thisExpression, ts3.Diagnostics.Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class);
          }
        }
        function checkThisExpression(node) {
          var isNodeInTypeQuery = isInTypeQuery(node);
          var container = ts3.getThisContainer(node, true);
          var capturedByArrowFunction = false;
          if (container.kind === 171) {
            checkThisBeforeSuper(node, container, ts3.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class);
          }
          if (container.kind === 214) {
            container = ts3.getThisContainer(container, false);
            capturedByArrowFunction = true;
          }
          checkThisInStaticClassFieldInitializerInDecoratedClass(node, container);
          switch (container.kind) {
            case 261:
              error(node, ts3.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);
              break;
            case 260:
              error(node, ts3.Diagnostics.this_cannot_be_referenced_in_current_location);
              break;
            case 171:
              if (isInConstructorArgumentInitializer(node, container)) {
                error(node, ts3.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);
              }
              break;
            case 162:
              error(node, ts3.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name);
              break;
          }
          if (!isNodeInTypeQuery && capturedByArrowFunction && languageVersion < 2) {
            captureLexicalThis(node, container);
          }
          var type2 = tryGetThisTypeAt(node, true, container);
          if (noImplicitThis) {
            var globalThisType_1 = getTypeOfSymbol(globalThisSymbol);
            if (type2 === globalThisType_1 && capturedByArrowFunction) {
              error(node, ts3.Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);
            } else if (!type2) {
              var diag = error(node, ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);
              if (!ts3.isSourceFile(container)) {
                var outsideThis = tryGetThisTypeAt(container);
                if (outsideThis && outsideThis !== globalThisType_1) {
                  ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(container, ts3.Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container));
                }
              }
            }
          }
          return type2 || anyType;
        }
        function tryGetThisTypeAt(node, includeGlobalThis, container) {
          if (includeGlobalThis === void 0) {
            includeGlobalThis = true;
          }
          if (container === void 0) {
            container = ts3.getThisContainer(node, false);
          }
          var isInJS = ts3.isInJSFile(node);
          if (ts3.isFunctionLike(container) && (!isInParameterInitializerBeforeContainingFunction(node) || ts3.getThisParameter(container))) {
            var thisType = getThisTypeOfDeclaration(container) || isInJS && getTypeForThisExpressionFromJSDoc(container);
            if (!thisType) {
              var className = getClassNameFromPrototypeMethod(container);
              if (isInJS && className) {
                var classSymbol = checkExpression(className).symbol;
                if (classSymbol && classSymbol.members && classSymbol.flags & 16) {
                  thisType = getDeclaredTypeOfSymbol(classSymbol).thisType;
                }
              } else if (isJSConstructor(container)) {
                thisType = getDeclaredTypeOfSymbol(getMergedSymbol(container.symbol)).thisType;
              }
              thisType || (thisType = getContextualThisParameterType(container));
            }
            if (thisType) {
              return getFlowTypeOfReference(node, thisType);
            }
          }
          if (ts3.isClassLike(container.parent)) {
            var symbol = getSymbolOfNode(container.parent);
            var type2 = ts3.isStatic(container) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
            return getFlowTypeOfReference(node, type2);
          }
          if (ts3.isSourceFile(container)) {
            if (container.commonJsModuleIndicator) {
              var fileSymbol = getSymbolOfNode(container);
              return fileSymbol && getTypeOfSymbol(fileSymbol);
            } else if (container.externalModuleIndicator) {
              return undefinedType;
            } else if (includeGlobalThis) {
              return getTypeOfSymbol(globalThisSymbol);
            }
          }
        }
        function getExplicitThisType(node) {
          var container = ts3.getThisContainer(node, false);
          if (ts3.isFunctionLike(container)) {
            var signature = getSignatureFromDeclaration(container);
            if (signature.thisParameter) {
              return getExplicitTypeOfSymbol(signature.thisParameter);
            }
          }
          if (ts3.isClassLike(container.parent)) {
            var symbol = getSymbolOfNode(container.parent);
            return ts3.isStatic(container) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
          }
        }
        function getClassNameFromPrototypeMethod(container) {
          if (container.kind === 213 && ts3.isBinaryExpression(container.parent) && ts3.getAssignmentDeclarationKind(container.parent) === 3) {
            return container.parent.left.expression.expression;
          } else if (container.kind === 169 && container.parent.kind === 205 && ts3.isBinaryExpression(container.parent.parent) && ts3.getAssignmentDeclarationKind(container.parent.parent) === 6) {
            return container.parent.parent.left.expression;
          } else if (container.kind === 213 && container.parent.kind === 296 && container.parent.parent.kind === 205 && ts3.isBinaryExpression(container.parent.parent.parent) && ts3.getAssignmentDeclarationKind(container.parent.parent.parent) === 6) {
            return container.parent.parent.parent.left.expression;
          } else if (container.kind === 213 && ts3.isPropertyAssignment(container.parent) && ts3.isIdentifier(container.parent.name) && (container.parent.name.escapedText === "value" || container.parent.name.escapedText === "get" || container.parent.name.escapedText === "set") && ts3.isObjectLiteralExpression(container.parent.parent) && ts3.isCallExpression(container.parent.parent.parent) && container.parent.parent.parent.arguments[2] === container.parent.parent && ts3.getAssignmentDeclarationKind(container.parent.parent.parent) === 9) {
            return container.parent.parent.parent.arguments[0].expression;
          } else if (ts3.isMethodDeclaration(container) && ts3.isIdentifier(container.name) && (container.name.escapedText === "value" || container.name.escapedText === "get" || container.name.escapedText === "set") && ts3.isObjectLiteralExpression(container.parent) && ts3.isCallExpression(container.parent.parent) && container.parent.parent.arguments[2] === container.parent && ts3.getAssignmentDeclarationKind(container.parent.parent) === 9) {
            return container.parent.parent.arguments[0].expression;
          }
        }
        function getTypeForThisExpressionFromJSDoc(node) {
          var jsdocType = ts3.getJSDocType(node);
          if (jsdocType && jsdocType.kind === 317) {
            var jsDocFunctionType = jsdocType;
            if (jsDocFunctionType.parameters.length > 0 && jsDocFunctionType.parameters[0].name && jsDocFunctionType.parameters[0].name.escapedText === "this") {
              return getTypeFromTypeNode(jsDocFunctionType.parameters[0].type);
            }
          }
          var thisTag = ts3.getJSDocThisTag(node);
          if (thisTag && thisTag.typeExpression) {
            return getTypeFromTypeNode(thisTag.typeExpression);
          }
        }
        function isInConstructorArgumentInitializer(node, constructorDecl) {
          return !!ts3.findAncestor(node, function(n) {
            return ts3.isFunctionLikeDeclaration(n) ? "quit" : n.kind === 164 && n.parent === constructorDecl;
          });
        }
        function checkSuperExpression(node) {
          var isCallExpression = node.parent.kind === 208 && node.parent.expression === node;
          var immediateContainer = ts3.getSuperContainer(node, true);
          var container = immediateContainer;
          var needToCaptureLexicalThis = false;
          if (!isCallExpression) {
            while (container && container.kind === 214) {
              container = ts3.getSuperContainer(container, true);
              needToCaptureLexicalThis = languageVersion < 2;
            }
          }
          var canUseSuperExpression = isLegalUsageOfSuperExpression(container);
          var nodeCheckFlag = 0;
          if (!canUseSuperExpression) {
            var current = ts3.findAncestor(node, function(n) {
              return n === container ? "quit" : n.kind === 162;
            });
            if (current && current.kind === 162) {
              error(node, ts3.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name);
            } else if (isCallExpression) {
              error(node, ts3.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors);
            } else if (!container || !container.parent || !(ts3.isClassLike(container.parent) || container.parent.kind === 205)) {
              error(node, ts3.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions);
            } else {
              error(node, ts3.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class);
            }
            return errorType;
          }
          if (!isCallExpression && immediateContainer.kind === 171) {
            checkThisBeforeSuper(node, container, ts3.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class);
          }
          if (ts3.isStatic(container) || isCallExpression) {
            nodeCheckFlag = 512;
            if (!isCallExpression && languageVersion >= 2 && languageVersion <= 8 && (ts3.isPropertyDeclaration(container) || ts3.isClassStaticBlockDeclaration(container))) {
              ts3.forEachEnclosingBlockScopeContainer(node.parent, function(current2) {
                if (!ts3.isSourceFile(current2) || ts3.isExternalOrCommonJsModule(current2)) {
                  getNodeLinks(current2).flags |= 134217728;
                }
              });
            }
          } else {
            nodeCheckFlag = 256;
          }
          getNodeLinks(node).flags |= nodeCheckFlag;
          if (container.kind === 169 && ts3.hasSyntacticModifier(container, 256)) {
            if (ts3.isSuperProperty(node.parent) && ts3.isAssignmentTarget(node.parent)) {
              getNodeLinks(container).flags |= 4096;
            } else {
              getNodeLinks(container).flags |= 2048;
            }
          }
          if (needToCaptureLexicalThis) {
            captureLexicalThis(node.parent, container);
          }
          if (container.parent.kind === 205) {
            if (languageVersion < 2) {
              error(node, ts3.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher);
              return errorType;
            } else {
              return anyType;
            }
          }
          var classLikeDeclaration = container.parent;
          if (!ts3.getClassExtendsHeritageElement(classLikeDeclaration)) {
            error(node, ts3.Diagnostics.super_can_only_be_referenced_in_a_derived_class);
            return errorType;
          }
          var classType = getDeclaredTypeOfSymbol(getSymbolOfNode(classLikeDeclaration));
          var baseClassType = classType && getBaseTypes(classType)[0];
          if (!baseClassType) {
            return errorType;
          }
          if (container.kind === 171 && isInConstructorArgumentInitializer(node, container)) {
            error(node, ts3.Diagnostics.super_cannot_be_referenced_in_constructor_arguments);
            return errorType;
          }
          return nodeCheckFlag === 512 ? getBaseConstructorTypeOfClass(classType) : getTypeWithThisArgument(baseClassType, classType.thisType);
          function isLegalUsageOfSuperExpression(container2) {
            if (!container2) {
              return false;
            }
            if (isCallExpression) {
              return container2.kind === 171;
            } else {
              if (ts3.isClassLike(container2.parent) || container2.parent.kind === 205) {
                if (ts3.isStatic(container2)) {
                  return container2.kind === 169 || container2.kind === 168 || container2.kind === 172 || container2.kind === 173 || container2.kind === 167 || container2.kind === 170;
                } else {
                  return container2.kind === 169 || container2.kind === 168 || container2.kind === 172 || container2.kind === 173 || container2.kind === 167 || container2.kind === 166 || container2.kind === 171;
                }
              }
            }
            return false;
          }
        }
        function getContainingObjectLiteral(func) {
          return (func.kind === 169 || func.kind === 172 || func.kind === 173) && func.parent.kind === 205 ? func.parent : func.kind === 213 && func.parent.kind === 296 ? func.parent.parent : void 0;
        }
        function getThisTypeArgument(type2) {
          return ts3.getObjectFlags(type2) & 4 && type2.target === globalThisType ? getTypeArguments(type2)[0] : void 0;
        }
        function getThisTypeFromContextualType(type2) {
          return mapType(type2, function(t) {
            return t.flags & 2097152 ? ts3.forEach(t.types, getThisTypeArgument) : getThisTypeArgument(t);
          });
        }
        function getContextualThisParameterType(func) {
          if (func.kind === 214) {
            return void 0;
          }
          if (isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
            var contextualSignature = getContextualSignature(func);
            if (contextualSignature) {
              var thisParameter = contextualSignature.thisParameter;
              if (thisParameter) {
                return getTypeOfSymbol(thisParameter);
              }
            }
          }
          var inJs = ts3.isInJSFile(func);
          if (noImplicitThis || inJs) {
            var containingLiteral = getContainingObjectLiteral(func);
            if (containingLiteral) {
              var contextualType = getApparentTypeOfContextualType(containingLiteral);
              var literal = containingLiteral;
              var type2 = contextualType;
              while (type2) {
                var thisType = getThisTypeFromContextualType(type2);
                if (thisType) {
                  return instantiateType(thisType, getMapperFromContext(getInferenceContext(containingLiteral)));
                }
                if (literal.parent.kind !== 296) {
                  break;
                }
                literal = literal.parent.parent;
                type2 = getApparentTypeOfContextualType(literal);
              }
              return getWidenedType(contextualType ? getNonNullableType(contextualType) : checkExpressionCached(containingLiteral));
            }
            var parent = ts3.walkUpParenthesizedExpressions(func.parent);
            if (parent.kind === 221 && parent.operatorToken.kind === 63) {
              var target = parent.left;
              if (ts3.isAccessExpression(target)) {
                var expression = target.expression;
                if (inJs && ts3.isIdentifier(expression)) {
                  var sourceFile = ts3.getSourceFileOfNode(parent);
                  if (sourceFile.commonJsModuleIndicator && getResolvedSymbol(expression) === sourceFile.symbol) {
                    return void 0;
                  }
                }
                return getWidenedType(checkExpressionCached(expression));
              }
            }
          }
          return void 0;
        }
        function getContextuallyTypedParameterType(parameter) {
          var func = parameter.parent;
          if (!isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
            return void 0;
          }
          var iife = ts3.getImmediatelyInvokedFunctionExpression(func);
          if (iife && iife.arguments) {
            var args = getEffectiveCallArguments(iife);
            var indexOfParameter = func.parameters.indexOf(parameter);
            if (parameter.dotDotDotToken) {
              return getSpreadArgumentType(args, indexOfParameter, args.length, anyType, void 0, 0);
            }
            var links = getNodeLinks(iife);
            var cached = links.resolvedSignature;
            links.resolvedSignature = anySignature;
            var type2 = indexOfParameter < args.length ? getWidenedLiteralType(checkExpression(args[indexOfParameter])) : parameter.initializer ? void 0 : undefinedWideningType;
            links.resolvedSignature = cached;
            return type2;
          }
          var contextualSignature = getContextualSignature(func);
          if (contextualSignature) {
            var index = func.parameters.indexOf(parameter) - (ts3.getThisParameter(func) ? 1 : 0);
            return parameter.dotDotDotToken && ts3.lastOrUndefined(func.parameters) === parameter ? getRestTypeAtPosition(contextualSignature, index) : tryGetTypeAtPosition(contextualSignature, index);
          }
        }
        function getContextualTypeForVariableLikeDeclaration(declaration) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
          switch (declaration.kind) {
            case 164:
              return getContextuallyTypedParameterType(declaration);
            case 203:
              return getContextualTypeForBindingElement(declaration);
            case 167:
              if (ts3.isStatic(declaration)) {
                return getContextualTypeForStaticPropertyDeclaration(declaration);
              }
          }
        }
        function getContextualTypeForBindingElement(declaration) {
          var parent = declaration.parent.parent;
          var name = declaration.propertyName || declaration.name;
          var parentType = getContextualTypeForVariableLikeDeclaration(parent) || parent.kind !== 203 && parent.initializer && checkDeclarationInitializer(parent, declaration.dotDotDotToken ? 64 : 0);
          if (!parentType || ts3.isBindingPattern(name) || ts3.isComputedNonLiteralName(name))
            return void 0;
          if (parent.name.kind === 202) {
            var index = ts3.indexOfNode(declaration.parent.elements, declaration);
            if (index < 0)
              return void 0;
            return getContextualTypeForElementExpression(parentType, index);
          }
          var nameType = getLiteralTypeFromPropertyName(name);
          if (isTypeUsableAsPropertyName(nameType)) {
            var text = getPropertyNameFromType(nameType);
            return getTypeOfPropertyOfType(parentType, text);
          }
        }
        function getContextualTypeForStaticPropertyDeclaration(declaration) {
          var parentType = ts3.isExpression(declaration.parent) && getContextualType(declaration.parent);
          if (!parentType)
            return void 0;
          return getTypeOfPropertyOfContextualType(parentType, getSymbolOfNode(declaration).escapedName);
        }
        function getContextualTypeForInitializerExpression(node, contextFlags) {
          var declaration = node.parent;
          if (ts3.hasInitializer(declaration) && node === declaration.initializer) {
            var result2 = getContextualTypeForVariableLikeDeclaration(declaration);
            if (result2) {
              return result2;
            }
            if (!(contextFlags & 8) && ts3.isBindingPattern(declaration.name)) {
              return getTypeFromBindingPattern(declaration.name, true, false);
            }
          }
          return void 0;
        }
        function getContextualTypeForReturnExpression(node) {
          var func = ts3.getContainingFunction(node);
          if (func) {
            var contextualReturnType = getContextualReturnType(func);
            if (contextualReturnType) {
              var functionFlags = ts3.getFunctionFlags(func);
              if (functionFlags & 1) {
                var use = functionFlags & 2 ? 2 : 1;
                var iterationTypes = getIterationTypesOfIterable(contextualReturnType, use, void 0);
                if (!iterationTypes) {
                  return void 0;
                }
                contextualReturnType = iterationTypes.returnType;
              }
              if (functionFlags & 2) {
                var contextualAwaitedType = mapType(contextualReturnType, getAwaitedTypeNoAlias);
                return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
              }
              return contextualReturnType;
            }
          }
          return void 0;
        }
        function getContextualTypeForAwaitOperand(node, contextFlags) {
          var contextualType = getContextualType(node, contextFlags);
          if (contextualType) {
            var contextualAwaitedType = getAwaitedTypeNoAlias(contextualType);
            return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
          }
          return void 0;
        }
        function getContextualTypeForYieldOperand(node) {
          var func = ts3.getContainingFunction(node);
          if (func) {
            var functionFlags = ts3.getFunctionFlags(func);
            var contextualReturnType = getContextualReturnType(func);
            if (contextualReturnType) {
              return node.asteriskToken ? contextualReturnType : getIterationTypeOfGeneratorFunctionReturnType(0, contextualReturnType, (functionFlags & 2) !== 0);
            }
          }
          return void 0;
        }
        function isInParameterInitializerBeforeContainingFunction(node) {
          var inBindingInitializer = false;
          while (node.parent && !ts3.isFunctionLike(node.parent)) {
            if (ts3.isParameter(node.parent) && (inBindingInitializer || node.parent.initializer === node)) {
              return true;
            }
            if (ts3.isBindingElement(node.parent) && node.parent.initializer === node) {
              inBindingInitializer = true;
            }
            node = node.parent;
          }
          return false;
        }
        function getContextualIterationType(kind, functionDecl) {
          var isAsync = !!(ts3.getFunctionFlags(functionDecl) & 2);
          var contextualReturnType = getContextualReturnType(functionDecl);
          if (contextualReturnType) {
            return getIterationTypeOfGeneratorFunctionReturnType(kind, contextualReturnType, isAsync) || void 0;
          }
          return void 0;
        }
        function getContextualReturnType(functionDecl) {
          var returnType = getReturnTypeFromAnnotation(functionDecl);
          if (returnType) {
            return returnType;
          }
          var signature = getContextualSignatureForFunctionLikeDeclaration(functionDecl);
          if (signature && !isResolvingReturnTypeOfSignature(signature)) {
            return getReturnTypeOfSignature(signature);
          }
          var iife = ts3.getImmediatelyInvokedFunctionExpression(functionDecl);
          if (iife) {
            return getContextualType(iife);
          }
          return void 0;
        }
        function getContextualTypeForArgument(callTarget, arg) {
          var args = getEffectiveCallArguments(callTarget);
          var argIndex = args.indexOf(arg);
          return argIndex === -1 ? void 0 : getContextualTypeForArgumentAtIndex(callTarget, argIndex);
        }
        function getContextualTypeForArgumentAtIndex(callTarget, argIndex) {
          if (ts3.isImportCall(callTarget)) {
            return argIndex === 0 ? stringType : argIndex === 1 ? getGlobalImportCallOptionsType(false) : anyType;
          }
          var signature = getNodeLinks(callTarget).resolvedSignature === resolvingSignature ? resolvingSignature : getResolvedSignature(callTarget);
          if (ts3.isJsxOpeningLikeElement(callTarget) && argIndex === 0) {
            return getEffectiveFirstArgumentForJsxSignature(signature, callTarget);
          }
          var restIndex = signature.parameters.length - 1;
          return signatureHasRestParameter(signature) && argIndex >= restIndex ? getIndexedAccessType(getTypeOfSymbol(signature.parameters[restIndex]), getNumberLiteralType(argIndex - restIndex), 256) : getTypeAtPosition(signature, argIndex);
        }
        function getContextualTypeForSubstitutionExpression(template, substitutionExpression) {
          if (template.parent.kind === 210) {
            return getContextualTypeForArgument(template.parent, substitutionExpression);
          }
          return void 0;
        }
        function getContextualTypeForBinaryOperand(node, contextFlags) {
          var binaryExpression = node.parent;
          var left = binaryExpression.left, operatorToken = binaryExpression.operatorToken, right = binaryExpression.right;
          switch (operatorToken.kind) {
            case 63:
            case 76:
            case 75:
            case 77:
              return node === right ? getContextualTypeForAssignmentDeclaration(binaryExpression) : void 0;
            case 56:
            case 60:
              var type2 = getContextualType(binaryExpression, contextFlags);
              return node === right && (type2 && type2.pattern || !type2 && !ts3.isDefaultedExpandoInitializer(binaryExpression)) ? getTypeOfExpression(left) : type2;
            case 55:
            case 27:
              return node === right ? getContextualType(binaryExpression, contextFlags) : void 0;
            default:
              return void 0;
          }
        }
        function getSymbolForExpression(e) {
          if (e.symbol) {
            return e.symbol;
          }
          if (ts3.isIdentifier(e)) {
            return getResolvedSymbol(e);
          }
          if (ts3.isPropertyAccessExpression(e)) {
            var lhsType = getTypeOfExpression(e.expression);
            return ts3.isPrivateIdentifier(e.name) ? tryGetPrivateIdentifierPropertyOfType(lhsType, e.name) : getPropertyOfType(lhsType, e.name.escapedText);
          }
          return void 0;
          function tryGetPrivateIdentifierPropertyOfType(type2, id) {
            var lexicallyScopedSymbol = lookupSymbolForPrivateIdentifierDeclaration(id.escapedText, id);
            return lexicallyScopedSymbol && getPrivateIdentifierPropertyOfType(type2, lexicallyScopedSymbol);
          }
        }
        function getContextualTypeForAssignmentDeclaration(binaryExpression) {
          var _a, _b;
          var kind = ts3.getAssignmentDeclarationKind(binaryExpression);
          switch (kind) {
            case 0:
            case 4:
              var lhsSymbol = getSymbolForExpression(binaryExpression.left);
              var decl = lhsSymbol && lhsSymbol.valueDeclaration;
              if (decl && (ts3.isPropertyDeclaration(decl) || ts3.isPropertySignature(decl))) {
                var overallAnnotation = ts3.getEffectiveTypeAnnotationNode(decl);
                return overallAnnotation && instantiateType(getTypeFromTypeNode(overallAnnotation), getSymbolLinks(lhsSymbol).mapper) || decl.initializer && getTypeOfExpression(binaryExpression.left);
              }
              if (kind === 0) {
                return getTypeOfExpression(binaryExpression.left);
              }
              return getContextualTypeForThisPropertyAssignment(binaryExpression);
            case 5:
              if (isPossiblyAliasedThisProperty(binaryExpression, kind)) {
                return getContextualTypeForThisPropertyAssignment(binaryExpression);
              } else if (!binaryExpression.left.symbol) {
                return getTypeOfExpression(binaryExpression.left);
              } else {
                var decl_1 = binaryExpression.left.symbol.valueDeclaration;
                if (!decl_1) {
                  return void 0;
                }
                var lhs = ts3.cast(binaryExpression.left, ts3.isAccessExpression);
                var overallAnnotation = ts3.getEffectiveTypeAnnotationNode(decl_1);
                if (overallAnnotation) {
                  return getTypeFromTypeNode(overallAnnotation);
                } else if (ts3.isIdentifier(lhs.expression)) {
                  var id = lhs.expression;
                  var parentSymbol = resolveName(id, id.escapedText, 111551, void 0, id.escapedText, true);
                  if (parentSymbol) {
                    var annotated_1 = parentSymbol.valueDeclaration && ts3.getEffectiveTypeAnnotationNode(parentSymbol.valueDeclaration);
                    if (annotated_1) {
                      var nameStr = ts3.getElementOrPropertyAccessName(lhs);
                      if (nameStr !== void 0) {
                        return getTypeOfPropertyOfContextualType(getTypeFromTypeNode(annotated_1), nameStr);
                      }
                    }
                    return void 0;
                  }
                }
                return ts3.isInJSFile(decl_1) ? void 0 : getTypeOfExpression(binaryExpression.left);
              }
            case 1:
            case 6:
            case 3:
              var valueDeclaration = (_a = binaryExpression.left.symbol) === null || _a === void 0 ? void 0 : _a.valueDeclaration;
            case 2:
              valueDeclaration || (valueDeclaration = (_b = binaryExpression.symbol) === null || _b === void 0 ? void 0 : _b.valueDeclaration);
              var annotated = valueDeclaration && ts3.getEffectiveTypeAnnotationNode(valueDeclaration);
              return annotated ? getTypeFromTypeNode(annotated) : void 0;
            case 7:
            case 8:
            case 9:
              return ts3.Debug.fail("Does not apply");
            default:
              return ts3.Debug.assertNever(kind);
          }
        }
        function isPossiblyAliasedThisProperty(declaration, kind) {
          if (kind === void 0) {
            kind = ts3.getAssignmentDeclarationKind(declaration);
          }
          if (kind === 4) {
            return true;
          }
          if (!ts3.isInJSFile(declaration) || kind !== 5 || !ts3.isIdentifier(declaration.left.expression)) {
            return false;
          }
          var name = declaration.left.expression.escapedText;
          var symbol = resolveName(declaration.left, name, 111551, void 0, void 0, true, true);
          return ts3.isThisInitializedDeclaration(symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration);
        }
        function getContextualTypeForThisPropertyAssignment(binaryExpression) {
          if (!binaryExpression.symbol)
            return getTypeOfExpression(binaryExpression.left);
          if (binaryExpression.symbol.valueDeclaration) {
            var annotated = ts3.getEffectiveTypeAnnotationNode(binaryExpression.symbol.valueDeclaration);
            if (annotated) {
              var type2 = getTypeFromTypeNode(annotated);
              if (type2) {
                return type2;
              }
            }
          }
          var thisAccess = ts3.cast(binaryExpression.left, ts3.isAccessExpression);
          if (!ts3.isObjectLiteralMethod(ts3.getThisContainer(thisAccess.expression, false))) {
            return void 0;
          }
          var thisType = checkThisExpression(thisAccess.expression);
          var nameStr = ts3.getElementOrPropertyAccessName(thisAccess);
          return nameStr !== void 0 && getTypeOfPropertyOfContextualType(thisType, nameStr) || void 0;
        }
        function isCircularMappedProperty(symbol) {
          return !!(ts3.getCheckFlags(symbol) & 262144 && !symbol.type && findResolutionCycleStartIndex(symbol, 0) >= 0);
        }
        function getTypeOfPropertyOfContextualType(type2, name, nameType) {
          return mapType(type2, function(t) {
            var _a;
            if (isGenericMappedType(t) && !t.declaration.nameType) {
              var constraint = getConstraintTypeFromMappedType(t);
              var constraintOfConstraint = getBaseConstraintOfType(constraint) || constraint;
              var propertyNameType = nameType || getStringLiteralType(ts3.unescapeLeadingUnderscores(name));
              if (isTypeAssignableTo(propertyNameType, constraintOfConstraint)) {
                return substituteIndexedMappedType(t, propertyNameType);
              }
            } else if (t.flags & 3670016) {
              var prop = getPropertyOfType(t, name);
              if (prop) {
                return isCircularMappedProperty(prop) ? void 0 : getTypeOfSymbol(prop);
              }
              if (isTupleType(t)) {
                var restType = getRestTypeOfTupleType(t);
                if (restType && ts3.isNumericLiteralName(name) && +name >= 0) {
                  return restType;
                }
              }
              return (_a = findApplicableIndexInfo(getIndexInfosOfStructuredType(t), nameType || getStringLiteralType(ts3.unescapeLeadingUnderscores(name)))) === null || _a === void 0 ? void 0 : _a.type;
            }
            return void 0;
          }, true);
        }
        function getContextualTypeForObjectLiteralMethod(node, contextFlags) {
          ts3.Debug.assert(ts3.isObjectLiteralMethod(node));
          if (node.flags & 33554432) {
            return void 0;
          }
          return getContextualTypeForObjectLiteralElement(node, contextFlags);
        }
        function getContextualTypeForObjectLiteralElement(element, contextFlags) {
          var objectLiteral = element.parent;
          var propertyAssignmentType = ts3.isPropertyAssignment(element) && getContextualTypeForVariableLikeDeclaration(element);
          if (propertyAssignmentType) {
            return propertyAssignmentType;
          }
          var type2 = getApparentTypeOfContextualType(objectLiteral, contextFlags);
          if (type2) {
            if (hasBindableName(element)) {
              var symbol = getSymbolOfNode(element);
              return getTypeOfPropertyOfContextualType(type2, symbol.escapedName, getSymbolLinks(symbol).nameType);
            }
            if (element.name) {
              var nameType_2 = getLiteralTypeFromPropertyName(element.name);
              return mapType(type2, function(t) {
                var _a;
                return (_a = findApplicableIndexInfo(getIndexInfosOfStructuredType(t), nameType_2)) === null || _a === void 0 ? void 0 : _a.type;
              }, true);
            }
          }
          return void 0;
        }
        function getContextualTypeForElementExpression(arrayContextualType, index) {
          return arrayContextualType && (getTypeOfPropertyOfContextualType(arrayContextualType, "" + index) || mapType(arrayContextualType, function(t) {
            return getIteratedTypeOrElementType(1, t, undefinedType, void 0, false);
          }, true));
        }
        function getContextualTypeForConditionalOperand(node, contextFlags) {
          var conditional = node.parent;
          return node === conditional.whenTrue || node === conditional.whenFalse ? getContextualType(conditional, contextFlags) : void 0;
        }
        function getContextualTypeForChildJsxExpression(node, child) {
          var attributesType = getApparentTypeOfContextualType(node.openingElement.tagName);
          var jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
          if (!(attributesType && !isTypeAny(attributesType) && jsxChildrenPropertyName && jsxChildrenPropertyName !== "")) {
            return void 0;
          }
          var realChildren = ts3.getSemanticJsxChildren(node.children);
          var childIndex = realChildren.indexOf(child);
          var childFieldType = getTypeOfPropertyOfContextualType(attributesType, jsxChildrenPropertyName);
          return childFieldType && (realChildren.length === 1 ? childFieldType : mapType(childFieldType, function(t) {
            if (isArrayLikeType(t)) {
              return getIndexedAccessType(t, getNumberLiteralType(childIndex));
            } else {
              return t;
            }
          }, true));
        }
        function getContextualTypeForJsxExpression(node) {
          var exprParent = node.parent;
          return ts3.isJsxAttributeLike(exprParent) ? getContextualType(node) : ts3.isJsxElement(exprParent) ? getContextualTypeForChildJsxExpression(exprParent, node) : void 0;
        }
        function getContextualTypeForJsxAttribute(attribute) {
          if (ts3.isJsxAttribute(attribute)) {
            var attributesType = getApparentTypeOfContextualType(attribute.parent);
            if (!attributesType || isTypeAny(attributesType)) {
              return void 0;
            }
            return getTypeOfPropertyOfContextualType(attributesType, attribute.name.escapedText);
          } else {
            return getContextualType(attribute.parent);
          }
        }
        function isPossiblyDiscriminantValue(node) {
          switch (node.kind) {
            case 10:
            case 8:
            case 9:
            case 14:
            case 110:
            case 95:
            case 104:
            case 79:
            case 153:
              return true;
            case 206:
            case 212:
              return isPossiblyDiscriminantValue(node.expression);
            case 288:
              return !node.expression || isPossiblyDiscriminantValue(node.expression);
          }
          return false;
        }
        function discriminateContextualTypeByObjectMembers(node, contextualType) {
          return getMatchingUnionConstituentForObjectLiteral(contextualType, node) || discriminateTypeByDiscriminableItems(contextualType, ts3.concatenate(ts3.map(ts3.filter(node.properties, function(p) {
            return !!p.symbol && p.kind === 296 && isPossiblyDiscriminantValue(p.initializer) && isDiscriminantProperty(contextualType, p.symbol.escapedName);
          }), function(prop) {
            return [function() {
              return getContextFreeTypeOfExpression(prop.initializer);
            }, prop.symbol.escapedName];
          }), ts3.map(ts3.filter(getPropertiesOfType(contextualType), function(s) {
            var _a;
            return !!(s.flags & 16777216) && !!((_a = node === null || node === void 0 ? void 0 : node.symbol) === null || _a === void 0 ? void 0 : _a.members) && !node.symbol.members.has(s.escapedName) && isDiscriminantProperty(contextualType, s.escapedName);
          }), function(s) {
            return [function() {
              return undefinedType;
            }, s.escapedName];
          })), isTypeAssignableTo, contextualType);
        }
        function discriminateContextualTypeByJSXAttributes(node, contextualType) {
          return discriminateTypeByDiscriminableItems(contextualType, ts3.concatenate(ts3.map(ts3.filter(node.properties, function(p) {
            return !!p.symbol && p.kind === 285 && isDiscriminantProperty(contextualType, p.symbol.escapedName) && (!p.initializer || isPossiblyDiscriminantValue(p.initializer));
          }), function(prop) {
            return [!prop.initializer ? function() {
              return trueType;
            } : function() {
              return getContextFreeTypeOfExpression(prop.initializer);
            }, prop.symbol.escapedName];
          }), ts3.map(ts3.filter(getPropertiesOfType(contextualType), function(s) {
            var _a;
            return !!(s.flags & 16777216) && !!((_a = node === null || node === void 0 ? void 0 : node.symbol) === null || _a === void 0 ? void 0 : _a.members) && !node.symbol.members.has(s.escapedName) && isDiscriminantProperty(contextualType, s.escapedName);
          }), function(s) {
            return [function() {
              return undefinedType;
            }, s.escapedName];
          })), isTypeAssignableTo, contextualType);
        }
        function getApparentTypeOfContextualType(node, contextFlags) {
          var contextualType = ts3.isObjectLiteralMethod(node) ? getContextualTypeForObjectLiteralMethod(node, contextFlags) : getContextualType(node, contextFlags);
          var instantiatedType = instantiateContextualType(contextualType, node, contextFlags);
          if (instantiatedType && !(contextFlags && contextFlags & 2 && instantiatedType.flags & 8650752)) {
            var apparentType = mapType(instantiatedType, getApparentType, true);
            return apparentType.flags & 1048576 && ts3.isObjectLiteralExpression(node) ? discriminateContextualTypeByObjectMembers(node, apparentType) : apparentType.flags & 1048576 && ts3.isJsxAttributes(node) ? discriminateContextualTypeByJSXAttributes(node, apparentType) : apparentType;
          }
        }
        function instantiateContextualType(contextualType, node, contextFlags) {
          if (contextualType && maybeTypeOfKind(contextualType, 465829888)) {
            var inferenceContext = getInferenceContext(node);
            if (inferenceContext && ts3.some(inferenceContext.inferences, hasInferenceCandidates)) {
              if (contextFlags && contextFlags & 1) {
                return instantiateInstantiableTypes(contextualType, inferenceContext.nonFixingMapper);
              }
              if (inferenceContext.returnMapper) {
                var type2 = instantiateInstantiableTypes(contextualType, inferenceContext.returnMapper);
                return type2.flags & 1048576 && containsType(type2.types, regularFalseType) && containsType(type2.types, regularTrueType) ? filterType(type2, function(t) {
                  return t !== regularFalseType && t !== regularTrueType;
                }) : type2;
              }
            }
          }
          return contextualType;
        }
        function instantiateInstantiableTypes(type2, mapper) {
          if (type2.flags & 465829888) {
            return instantiateType(type2, mapper);
          }
          if (type2.flags & 1048576) {
            return getUnionType(ts3.map(type2.types, function(t) {
              return instantiateInstantiableTypes(t, mapper);
            }), 0);
          }
          if (type2.flags & 2097152) {
            return getIntersectionType(ts3.map(type2.types, function(t) {
              return instantiateInstantiableTypes(t, mapper);
            }));
          }
          return type2;
        }
        function getContextualType(node, contextFlags) {
          if (node.flags & 33554432) {
            return void 0;
          }
          if (node.contextualType) {
            return node.contextualType;
          }
          var parent = node.parent;
          switch (parent.kind) {
            case 254:
            case 164:
            case 167:
            case 166:
            case 203:
              return getContextualTypeForInitializerExpression(node, contextFlags);
            case 214:
            case 247:
              return getContextualTypeForReturnExpression(node);
            case 224:
              return getContextualTypeForYieldOperand(parent);
            case 218:
              return getContextualTypeForAwaitOperand(parent, contextFlags);
            case 208:
            case 209:
              return getContextualTypeForArgument(parent, node);
            case 211:
            case 229:
              return ts3.isConstTypeReference(parent.type) ? tryFindWhenConstTypeReference(parent) : getTypeFromTypeNode(parent.type);
            case 221:
              return getContextualTypeForBinaryOperand(node, contextFlags);
            case 296:
            case 297:
              return getContextualTypeForObjectLiteralElement(parent, contextFlags);
            case 298:
              return getContextualType(parent.parent, contextFlags);
            case 204: {
              var arrayLiteral = parent;
              var type2 = getApparentTypeOfContextualType(arrayLiteral, contextFlags);
              return getContextualTypeForElementExpression(type2, ts3.indexOfNode(arrayLiteral.elements, node));
            }
            case 222:
              return getContextualTypeForConditionalOperand(node, contextFlags);
            case 233:
              ts3.Debug.assert(parent.parent.kind === 223);
              return getContextualTypeForSubstitutionExpression(parent.parent, node);
            case 212: {
              var tag = ts3.isInJSFile(parent) ? ts3.getJSDocTypeTag(parent) : void 0;
              return !tag ? getContextualType(parent, contextFlags) : ts3.isJSDocTypeTag(tag) && ts3.isConstTypeReference(tag.typeExpression.type) ? tryFindWhenConstTypeReference(parent) : getTypeFromTypeNode(tag.typeExpression.type);
            }
            case 230:
              return getContextualType(parent, contextFlags);
            case 271:
              return tryGetTypeFromEffectiveTypeNode(parent);
            case 288:
              return getContextualTypeForJsxExpression(parent);
            case 285:
            case 287:
              return getContextualTypeForJsxAttribute(parent);
            case 280:
            case 279:
              return getContextualJsxElementAttributesType(parent, contextFlags);
          }
          return void 0;
          function tryFindWhenConstTypeReference(node2) {
            return getContextualType(node2);
          }
        }
        function getInferenceContext(node) {
          var ancestor = ts3.findAncestor(node, function(n) {
            return !!n.inferenceContext;
          });
          return ancestor && ancestor.inferenceContext;
        }
        function getContextualJsxElementAttributesType(node, contextFlags) {
          if (ts3.isJsxOpeningElement(node) && node.parent.contextualType && contextFlags !== 4) {
            return node.parent.contextualType;
          }
          return getContextualTypeForArgumentAtIndex(node, 0);
        }
        function getEffectiveFirstArgumentForJsxSignature(signature, node) {
          return getJsxReferenceKind(node) !== 0 ? getJsxPropsTypeFromCallSignature(signature, node) : getJsxPropsTypeFromClassType(signature, node);
        }
        function getJsxPropsTypeFromCallSignature(sig, context) {
          var propsType = getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType);
          propsType = getJsxManagedAttributesFromLocatedAttributes(context, getJsxNamespaceAt(context), propsType);
          var intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
          if (!isErrorType(intrinsicAttribs)) {
            propsType = intersectTypes(intrinsicAttribs, propsType);
          }
          return propsType;
        }
        function getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation) {
          if (sig.compositeSignatures) {
            var results = [];
            for (var _i = 0, _a = sig.compositeSignatures; _i < _a.length; _i++) {
              var signature = _a[_i];
              var instance = getReturnTypeOfSignature(signature);
              if (isTypeAny(instance)) {
                return instance;
              }
              var propType = getTypeOfPropertyOfType(instance, forcedLookupLocation);
              if (!propType) {
                return;
              }
              results.push(propType);
            }
            return getIntersectionType(results);
          }
          var instanceType = getReturnTypeOfSignature(sig);
          return isTypeAny(instanceType) ? instanceType : getTypeOfPropertyOfType(instanceType, forcedLookupLocation);
        }
        function getStaticTypeOfReferencedJsxConstructor(context) {
          if (isJsxIntrinsicIdentifier(context.tagName)) {
            var result2 = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(context);
            var fakeSignature = createSignatureForJSXIntrinsic(context, result2);
            return getOrCreateTypeFromSignature(fakeSignature);
          }
          var tagType = checkExpressionCached(context.tagName);
          if (tagType.flags & 128) {
            var result2 = getIntrinsicAttributesTypeFromStringLiteralType(tagType, context);
            if (!result2) {
              return errorType;
            }
            var fakeSignature = createSignatureForJSXIntrinsic(context, result2);
            return getOrCreateTypeFromSignature(fakeSignature);
          }
          return tagType;
        }
        function getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType) {
          var managedSym = getJsxLibraryManagedAttributes(ns);
          if (managedSym) {
            var declaredManagedType = getDeclaredTypeOfSymbol(managedSym);
            var ctorType = getStaticTypeOfReferencedJsxConstructor(context);
            if (managedSym.flags & 524288) {
              var params = getSymbolLinks(managedSym).typeParameters;
              if (ts3.length(params) >= 2) {
                var args = fillMissingTypeArguments([ctorType, attributesType], params, 2, ts3.isInJSFile(context));
                return getTypeAliasInstantiation(managedSym, args);
              }
            }
            if (ts3.length(declaredManagedType.typeParameters) >= 2) {
              var args = fillMissingTypeArguments([ctorType, attributesType], declaredManagedType.typeParameters, 2, ts3.isInJSFile(context));
              return createTypeReference(declaredManagedType, args);
            }
          }
          return attributesType;
        }
        function getJsxPropsTypeFromClassType(sig, context) {
          var ns = getJsxNamespaceAt(context);
          var forcedLookupLocation = getJsxElementPropertiesName(ns);
          var attributesType = forcedLookupLocation === void 0 ? getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType) : forcedLookupLocation === "" ? getReturnTypeOfSignature(sig) : getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation);
          if (!attributesType) {
            if (!!forcedLookupLocation && !!ts3.length(context.attributes.properties)) {
              error(context, ts3.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property, ts3.unescapeLeadingUnderscores(forcedLookupLocation));
            }
            return unknownType;
          }
          attributesType = getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType);
          if (isTypeAny(attributesType)) {
            return attributesType;
          } else {
            var apparentAttributesType = attributesType;
            var intrinsicClassAttribs = getJsxType(JsxNames.IntrinsicClassAttributes, context);
            if (!isErrorType(intrinsicClassAttribs)) {
              var typeParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(intrinsicClassAttribs.symbol);
              var hostClassType = getReturnTypeOfSignature(sig);
              apparentAttributesType = intersectTypes(typeParams ? createTypeReference(intrinsicClassAttribs, fillMissingTypeArguments([hostClassType], typeParams, getMinTypeArgumentCount(typeParams), ts3.isInJSFile(context))) : intrinsicClassAttribs, apparentAttributesType);
            }
            var intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
            if (!isErrorType(intrinsicAttribs)) {
              apparentAttributesType = intersectTypes(intrinsicAttribs, apparentAttributesType);
            }
            return apparentAttributesType;
          }
        }
        function getIntersectedSignatures(signatures) {
          return ts3.getStrictOptionValue(compilerOptions, "noImplicitAny") ? ts3.reduceLeft(signatures, function(left, right) {
            return left === right || !left ? left : compareTypeParametersIdentical(left.typeParameters, right.typeParameters) ? combineSignaturesOfIntersectionMembers(left, right) : void 0;
          }) : void 0;
        }
        function combineIntersectionThisParam(left, right, mapper) {
          if (!left || !right) {
            return left || right;
          }
          var thisType = getUnionType([getTypeOfSymbol(left), instantiateType(getTypeOfSymbol(right), mapper)]);
          return createSymbolWithType(left, thisType);
        }
        function combineIntersectionParameters(left, right, mapper) {
          var leftCount = getParameterCount(left);
          var rightCount = getParameterCount(right);
          var longest = leftCount >= rightCount ? left : right;
          var shorter = longest === left ? right : left;
          var longestCount = longest === left ? leftCount : rightCount;
          var eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
          var needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
          var params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
          for (var i = 0; i < longestCount; i++) {
            var longestParamType = tryGetTypeAtPosition(longest, i);
            if (longest === right) {
              longestParamType = instantiateType(longestParamType, mapper);
            }
            var shorterParamType = tryGetTypeAtPosition(shorter, i) || unknownType;
            if (shorter === right) {
              shorterParamType = instantiateType(shorterParamType, mapper);
            }
            var unionParamType = getUnionType([longestParamType, shorterParamType]);
            var isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i === longestCount - 1;
            var isOptional = i >= getMinArgumentCount(longest) && i >= getMinArgumentCount(shorter);
            var leftName = i >= leftCount ? void 0 : getParameterNameAtPosition(left, i);
            var rightName = i >= rightCount ? void 0 : getParameterNameAtPosition(right, i);
            var paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
            var paramSymbol = createSymbol(1 | (isOptional && !isRestParam ? 16777216 : 0), paramName || "arg".concat(i));
            paramSymbol.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
            params[i] = paramSymbol;
          }
          if (needsExtraRestElement) {
            var restParamSymbol = createSymbol(1, "args");
            restParamSymbol.type = createArrayType(getTypeAtPosition(shorter, longestCount));
            if (shorter === right) {
              restParamSymbol.type = instantiateType(restParamSymbol.type, mapper);
            }
            params[longestCount] = restParamSymbol;
          }
          return params;
        }
        function combineSignaturesOfIntersectionMembers(left, right) {
          var typeParams = left.typeParameters || right.typeParameters;
          var paramMapper;
          if (left.typeParameters && right.typeParameters) {
            paramMapper = createTypeMapper(right.typeParameters, left.typeParameters);
          }
          var declaration = left.declaration;
          var params = combineIntersectionParameters(left, right, paramMapper);
          var thisParam = combineIntersectionThisParam(left.thisParameter, right.thisParameter, paramMapper);
          var minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
          var result2 = createSignature(declaration, typeParams, thisParam, params, void 0, void 0, minArgCount, (left.flags | right.flags) & 39);
          result2.compositeKind = 2097152;
          result2.compositeSignatures = ts3.concatenate(left.compositeKind === 2097152 && left.compositeSignatures || [left], [right]);
          if (paramMapper) {
            result2.mapper = left.compositeKind === 2097152 && left.mapper && left.compositeSignatures ? combineTypeMappers(left.mapper, paramMapper) : paramMapper;
          }
          return result2;
        }
        function getContextualCallSignature(type2, node) {
          var signatures = getSignaturesOfType(type2, 0);
          var applicableByArity = ts3.filter(signatures, function(s) {
            return !isAritySmaller(s, node);
          });
          return applicableByArity.length === 1 ? applicableByArity[0] : getIntersectedSignatures(applicableByArity);
        }
        function isAritySmaller(signature, target) {
          var targetParameterCount = 0;
          for (; targetParameterCount < target.parameters.length; targetParameterCount++) {
            var param = target.parameters[targetParameterCount];
            if (param.initializer || param.questionToken || param.dotDotDotToken || isJSDocOptionalParameter(param)) {
              break;
            }
          }
          if (target.parameters.length && ts3.parameterIsThisKeyword(target.parameters[0])) {
            targetParameterCount--;
          }
          return !hasEffectiveRestParameter(signature) && getParameterCount(signature) < targetParameterCount;
        }
        function getContextualSignatureForFunctionLikeDeclaration(node) {
          return ts3.isFunctionExpressionOrArrowFunction(node) || ts3.isObjectLiteralMethod(node) ? getContextualSignature(node) : void 0;
        }
        function getContextualSignature(node) {
          ts3.Debug.assert(node.kind !== 169 || ts3.isObjectLiteralMethod(node));
          var typeTagSignature = getSignatureOfTypeTag(node);
          if (typeTagSignature) {
            return typeTagSignature;
          }
          var type2 = getApparentTypeOfContextualType(node, 1);
          if (!type2) {
            return void 0;
          }
          if (!(type2.flags & 1048576)) {
            return getContextualCallSignature(type2, node);
          }
          var signatureList;
          var types2 = type2.types;
          for (var _i = 0, types_19 = types2; _i < types_19.length; _i++) {
            var current = types_19[_i];
            var signature = getContextualCallSignature(current, node);
            if (signature) {
              if (!signatureList) {
                signatureList = [signature];
              } else if (!compareSignaturesIdentical(signatureList[0], signature, false, true, true, compareTypesIdentical)) {
                return void 0;
              } else {
                signatureList.push(signature);
              }
            }
          }
          if (signatureList) {
            return signatureList.length === 1 ? signatureList[0] : createUnionSignature(signatureList[0], signatureList);
          }
        }
        function checkSpreadExpression(node, checkMode) {
          if (languageVersion < 2) {
            checkExternalEmitHelpers(node, compilerOptions.downlevelIteration ? 1536 : 1024);
          }
          var arrayOrIterableType = checkExpression(node.expression, checkMode);
          return checkIteratedTypeOrElementType(33, arrayOrIterableType, undefinedType, node.expression);
        }
        function checkSyntheticExpression(node) {
          return node.isSpread ? getIndexedAccessType(node.type, numberType) : node.type;
        }
        function hasDefaultValue(node) {
          return node.kind === 203 && !!node.initializer || node.kind === 221 && node.operatorToken.kind === 63;
        }
        function checkArrayLiteral(node, checkMode, forceTuple) {
          var elements = node.elements;
          var elementCount = elements.length;
          var elementTypes = [];
          var elementFlags = [];
          var contextualType = getApparentTypeOfContextualType(node);
          var inDestructuringPattern = ts3.isAssignmentTarget(node);
          var inConstContext = isConstContext(node);
          var hasOmittedExpression = false;
          for (var i = 0; i < elementCount; i++) {
            var e = elements[i];
            if (e.kind === 225) {
              if (languageVersion < 2) {
                checkExternalEmitHelpers(e, compilerOptions.downlevelIteration ? 1536 : 1024);
              }
              var spreadType = checkExpression(e.expression, checkMode, forceTuple);
              if (isArrayLikeType(spreadType)) {
                elementTypes.push(spreadType);
                elementFlags.push(8);
              } else if (inDestructuringPattern) {
                var restElementType = getIndexTypeOfType(spreadType, numberType) || getIteratedTypeOrElementType(65, spreadType, undefinedType, void 0, false) || unknownType;
                elementTypes.push(restElementType);
                elementFlags.push(4);
              } else {
                elementTypes.push(checkIteratedTypeOrElementType(33, spreadType, undefinedType, e.expression));
                elementFlags.push(4);
              }
            } else if (exactOptionalPropertyTypes && e.kind === 227) {
              hasOmittedExpression = true;
              elementTypes.push(missingType);
              elementFlags.push(2);
            } else {
              var elementContextualType = getContextualTypeForElementExpression(contextualType, elementTypes.length);
              var type2 = checkExpressionForMutableLocation(e, checkMode, elementContextualType, forceTuple);
              elementTypes.push(addOptionality(type2, true, hasOmittedExpression));
              elementFlags.push(hasOmittedExpression ? 2 : 1);
              if (contextualType && someType(contextualType, isTupleLikeType) && checkMode && checkMode & 2 && !(checkMode & 4) && isContextSensitive(e)) {
                var inferenceContext = getInferenceContext(node);
                ts3.Debug.assert(inferenceContext);
                addIntraExpressionInferenceSite(inferenceContext, e, type2);
              }
            }
          }
          if (inDestructuringPattern) {
            return createTupleType(elementTypes, elementFlags);
          }
          if (forceTuple || inConstContext || contextualType && someType(contextualType, isTupleLikeType)) {
            return createArrayLiteralType(createTupleType(elementTypes, elementFlags, inConstContext));
          }
          return createArrayLiteralType(createArrayType(elementTypes.length ? getUnionType(ts3.sameMap(elementTypes, function(t, i2) {
            return elementFlags[i2] & 8 ? getIndexedAccessTypeOrUndefined(t, numberType) || anyType : t;
          }), 2) : strictNullChecks ? implicitNeverType : undefinedWideningType, inConstContext));
        }
        function createArrayLiteralType(type2) {
          if (!(ts3.getObjectFlags(type2) & 4)) {
            return type2;
          }
          var literalType = type2.literalType;
          if (!literalType) {
            literalType = type2.literalType = cloneTypeReference(type2);
            literalType.objectFlags |= 16384 | 131072;
          }
          return literalType;
        }
        function isNumericName(name) {
          switch (name.kind) {
            case 162:
              return isNumericComputedName(name);
            case 79:
              return ts3.isNumericLiteralName(name.escapedText);
            case 8:
            case 10:
              return ts3.isNumericLiteralName(name.text);
            default:
              return false;
          }
        }
        function isNumericComputedName(name) {
          return isTypeAssignableToKind(checkComputedPropertyName(name), 296);
        }
        function checkComputedPropertyName(node) {
          var links = getNodeLinks(node.expression);
          if (!links.resolvedType) {
            if ((ts3.isTypeLiteralNode(node.parent.parent) || ts3.isClassLike(node.parent.parent) || ts3.isInterfaceDeclaration(node.parent.parent)) && ts3.isBinaryExpression(node.expression) && node.expression.operatorToken.kind === 101 && node.parent.kind !== 172 && node.parent.kind !== 173) {
              return links.resolvedType = errorType;
            }
            links.resolvedType = checkExpression(node.expression);
            if (ts3.isPropertyDeclaration(node.parent) && !ts3.hasStaticModifier(node.parent) && ts3.isClassExpression(node.parent.parent)) {
              var container = ts3.getEnclosingBlockScopeContainer(node.parent.parent);
              var enclosingIterationStatement = getEnclosingIterationStatement(container);
              if (enclosingIterationStatement) {
                getNodeLinks(enclosingIterationStatement).flags |= 65536;
                getNodeLinks(node).flags |= 524288;
                getNodeLinks(node.parent.parent).flags |= 524288;
              }
            }
            if (links.resolvedType.flags & 98304 || !isTypeAssignableToKind(links.resolvedType, 402653316 | 296 | 12288) && !isTypeAssignableTo(links.resolvedType, stringNumberSymbolType)) {
              error(node, ts3.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any);
            }
          }
          return links.resolvedType;
        }
        function isSymbolWithNumericName(symbol) {
          var _a;
          var firstDecl = (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a[0];
          return ts3.isNumericLiteralName(symbol.escapedName) || firstDecl && ts3.isNamedDeclaration(firstDecl) && isNumericName(firstDecl.name);
        }
        function isSymbolWithSymbolName(symbol) {
          var _a;
          var firstDecl = (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a[0];
          return ts3.isKnownSymbol(symbol) || firstDecl && ts3.isNamedDeclaration(firstDecl) && ts3.isComputedPropertyName(firstDecl.name) && isTypeAssignableToKind(checkComputedPropertyName(firstDecl.name), 4096);
        }
        function getObjectLiteralIndexInfo(node, offset, properties, keyType) {
          var propTypes = [];
          for (var i = offset; i < properties.length; i++) {
            var prop = properties[i];
            if (keyType === stringType && !isSymbolWithSymbolName(prop) || keyType === numberType && isSymbolWithNumericName(prop) || keyType === esSymbolType && isSymbolWithSymbolName(prop)) {
              propTypes.push(getTypeOfSymbol(properties[i]));
            }
          }
          var unionType = propTypes.length ? getUnionType(propTypes, 2) : undefinedType;
          return createIndexInfo(keyType, unionType, isConstContext(node));
        }
        function getImmediateAliasedSymbol(symbol) {
          ts3.Debug.assert((symbol.flags & 2097152) !== 0, "Should only get Alias here.");
          var links = getSymbolLinks(symbol);
          if (!links.immediateTarget) {
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts3.Debug.fail();
            links.immediateTarget = getTargetOfAliasDeclaration(node, true);
          }
          return links.immediateTarget;
        }
        function checkObjectLiteral(node, checkMode) {
          var inDestructuringPattern = ts3.isAssignmentTarget(node);
          checkGrammarObjectLiteralExpression(node, inDestructuringPattern);
          var allPropertiesTable = strictNullChecks ? ts3.createSymbolTable() : void 0;
          var propertiesTable = ts3.createSymbolTable();
          var propertiesArray = [];
          var spread = emptyObjectType;
          var contextualType = getApparentTypeOfContextualType(node);
          var contextualTypeHasPattern = contextualType && contextualType.pattern && (contextualType.pattern.kind === 201 || contextualType.pattern.kind === 205);
          var inConstContext = isConstContext(node);
          var checkFlags = inConstContext ? 8 : 0;
          var isInJavascript = ts3.isInJSFile(node) && !ts3.isInJsonFile(node);
          var enumTag = ts3.getJSDocEnumTag(node);
          var isJSObjectLiteral = !contextualType && isInJavascript && !enumTag;
          var objectFlags = freshObjectLiteralFlag;
          var patternWithComputedProperties = false;
          var hasComputedStringProperty = false;
          var hasComputedNumberProperty = false;
          var hasComputedSymbolProperty = false;
          for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
            var elem = _a[_i];
            if (elem.name && ts3.isComputedPropertyName(elem.name)) {
              checkComputedPropertyName(elem.name);
            }
          }
          var offset = 0;
          for (var _b = 0, _c = node.properties; _b < _c.length; _b++) {
            var memberDecl = _c[_b];
            var member = getSymbolOfNode(memberDecl);
            var computedNameType = memberDecl.name && memberDecl.name.kind === 162 ? checkComputedPropertyName(memberDecl.name) : void 0;
            if (memberDecl.kind === 296 || memberDecl.kind === 297 || ts3.isObjectLiteralMethod(memberDecl)) {
              var type2 = memberDecl.kind === 296 ? checkPropertyAssignment(memberDecl, checkMode) : memberDecl.kind === 297 ? checkExpressionForMutableLocation(!inDestructuringPattern && memberDecl.objectAssignmentInitializer ? memberDecl.objectAssignmentInitializer : memberDecl.name, checkMode) : checkObjectLiteralMethod(memberDecl, checkMode);
              if (isInJavascript) {
                var jsDocType = getTypeForDeclarationFromJSDocComment(memberDecl);
                if (jsDocType) {
                  checkTypeAssignableTo(type2, jsDocType, memberDecl);
                  type2 = jsDocType;
                } else if (enumTag && enumTag.typeExpression) {
                  checkTypeAssignableTo(type2, getTypeFromTypeNode(enumTag.typeExpression), memberDecl);
                }
              }
              objectFlags |= ts3.getObjectFlags(type2) & 458752;
              var nameType = computedNameType && isTypeUsableAsPropertyName(computedNameType) ? computedNameType : void 0;
              var prop = nameType ? createSymbol(4 | member.flags, getPropertyNameFromType(nameType), checkFlags | 4096) : createSymbol(4 | member.flags, member.escapedName, checkFlags);
              if (nameType) {
                prop.nameType = nameType;
              }
              if (inDestructuringPattern) {
                var isOptional = memberDecl.kind === 296 && hasDefaultValue(memberDecl.initializer) || memberDecl.kind === 297 && memberDecl.objectAssignmentInitializer;
                if (isOptional) {
                  prop.flags |= 16777216;
                }
              } else if (contextualTypeHasPattern && !(ts3.getObjectFlags(contextualType) & 512)) {
                var impliedProp = getPropertyOfType(contextualType, member.escapedName);
                if (impliedProp) {
                  prop.flags |= impliedProp.flags & 16777216;
                } else if (!compilerOptions.suppressExcessPropertyErrors && !getIndexInfoOfType(contextualType, stringType)) {
                  error(memberDecl.name, ts3.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(member), typeToString(contextualType));
                }
              }
              prop.declarations = member.declarations;
              prop.parent = member.parent;
              if (member.valueDeclaration) {
                prop.valueDeclaration = member.valueDeclaration;
              }
              prop.type = type2;
              prop.target = member;
              member = prop;
              allPropertiesTable === null || allPropertiesTable === void 0 ? void 0 : allPropertiesTable.set(prop.escapedName, prop);
              if (contextualType && checkMode && checkMode & 2 && !(checkMode & 4) && (memberDecl.kind === 296 || memberDecl.kind === 169) && isContextSensitive(memberDecl)) {
                var inferenceContext = getInferenceContext(node);
                ts3.Debug.assert(inferenceContext);
                var inferenceNode = memberDecl.kind === 296 ? memberDecl.initializer : memberDecl;
                addIntraExpressionInferenceSite(inferenceContext, inferenceNode, type2);
              }
            } else if (memberDecl.kind === 298) {
              if (languageVersion < 2) {
                checkExternalEmitHelpers(memberDecl, 2);
              }
              if (propertiesArray.length > 0) {
                spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
                propertiesArray = [];
                propertiesTable = ts3.createSymbolTable();
                hasComputedStringProperty = false;
                hasComputedNumberProperty = false;
                hasComputedSymbolProperty = false;
              }
              var type2 = getReducedType(checkExpression(memberDecl.expression));
              if (isValidSpreadType(type2)) {
                var mergedType = tryMergeUnionOfObjectTypeAndEmptyObject(type2, inConstContext);
                if (allPropertiesTable) {
                  checkSpreadPropOverrides(mergedType, allPropertiesTable, memberDecl);
                }
                offset = propertiesArray.length;
                if (isErrorType(spread)) {
                  continue;
                }
                spread = getSpreadType(spread, mergedType, node.symbol, objectFlags, inConstContext);
              } else {
                error(memberDecl, ts3.Diagnostics.Spread_types_may_only_be_created_from_object_types);
                spread = errorType;
              }
              continue;
            } else {
              ts3.Debug.assert(memberDecl.kind === 172 || memberDecl.kind === 173);
              checkNodeDeferred(memberDecl);
            }
            if (computedNameType && !(computedNameType.flags & 8576)) {
              if (isTypeAssignableTo(computedNameType, stringNumberSymbolType)) {
                if (isTypeAssignableTo(computedNameType, numberType)) {
                  hasComputedNumberProperty = true;
                } else if (isTypeAssignableTo(computedNameType, esSymbolType)) {
                  hasComputedSymbolProperty = true;
                } else {
                  hasComputedStringProperty = true;
                }
                if (inDestructuringPattern) {
                  patternWithComputedProperties = true;
                }
              }
            } else {
              propertiesTable.set(member.escapedName, member);
            }
            propertiesArray.push(member);
          }
          if (contextualTypeHasPattern && node.parent.kind !== 298) {
            for (var _d = 0, _e = getPropertiesOfType(contextualType); _d < _e.length; _d++) {
              var prop = _e[_d];
              if (!propertiesTable.get(prop.escapedName) && !getPropertyOfType(spread, prop.escapedName)) {
                if (!(prop.flags & 16777216)) {
                  error(prop.valueDeclaration || prop.bindingElement, ts3.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value);
                }
                propertiesTable.set(prop.escapedName, prop);
                propertiesArray.push(prop);
              }
            }
          }
          if (isErrorType(spread)) {
            return errorType;
          }
          if (spread !== emptyObjectType) {
            if (propertiesArray.length > 0) {
              spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
              propertiesArray = [];
              propertiesTable = ts3.createSymbolTable();
              hasComputedStringProperty = false;
              hasComputedNumberProperty = false;
            }
            return mapType(spread, function(t) {
              return t === emptyObjectType ? createObjectLiteralType() : t;
            });
          }
          return createObjectLiteralType();
          function createObjectLiteralType() {
            var indexInfos = [];
            if (hasComputedStringProperty)
              indexInfos.push(getObjectLiteralIndexInfo(node, offset, propertiesArray, stringType));
            if (hasComputedNumberProperty)
              indexInfos.push(getObjectLiteralIndexInfo(node, offset, propertiesArray, numberType));
            if (hasComputedSymbolProperty)
              indexInfos.push(getObjectLiteralIndexInfo(node, offset, propertiesArray, esSymbolType));
            var result2 = createAnonymousType(node.symbol, propertiesTable, ts3.emptyArray, ts3.emptyArray, indexInfos);
            result2.objectFlags |= objectFlags | 128 | 131072;
            if (isJSObjectLiteral) {
              result2.objectFlags |= 4096;
            }
            if (patternWithComputedProperties) {
              result2.objectFlags |= 512;
            }
            if (inDestructuringPattern) {
              result2.pattern = node;
            }
            return result2;
          }
        }
        function isValidSpreadType(type2) {
          var t = removeDefinitelyFalsyTypes(mapType(type2, getBaseConstraintOrType));
          return !!(t.flags & (1 | 67108864 | 524288 | 58982400) || t.flags & 3145728 && ts3.every(t.types, isValidSpreadType));
        }
        function checkJsxSelfClosingElementDeferred(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node);
        }
        function checkJsxSelfClosingElement(node, _checkMode) {
          checkNodeDeferred(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function checkJsxElementDeferred(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node.openingElement);
          if (isJsxIntrinsicIdentifier(node.closingElement.tagName)) {
            getIntrinsicTagSymbol(node.closingElement);
          } else {
            checkExpression(node.closingElement.tagName);
          }
          checkJsxChildren(node);
        }
        function checkJsxElement(node, _checkMode) {
          checkNodeDeferred(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function checkJsxFragment(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node.openingFragment);
          var nodeSourceFile = ts3.getSourceFileOfNode(node);
          if (ts3.getJSXTransformEnabled(compilerOptions) && (compilerOptions.jsxFactory || nodeSourceFile.pragmas.has("jsx")) && !compilerOptions.jsxFragmentFactory && !nodeSourceFile.pragmas.has("jsxfrag")) {
            error(node, compilerOptions.jsxFactory ? ts3.Diagnostics.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option : ts3.Diagnostics.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments);
          }
          checkJsxChildren(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function isHyphenatedJsxName(name) {
          return ts3.stringContains(name, "-");
        }
        function isJsxIntrinsicIdentifier(tagName) {
          return tagName.kind === 79 && ts3.isIntrinsicJsxName(tagName.escapedText);
        }
        function checkJsxAttribute(node, checkMode) {
          return node.initializer ? checkExpressionForMutableLocation(node.initializer, checkMode) : trueType;
        }
        function createJsxAttributesTypeFromAttributesProperty(openingLikeElement, checkMode) {
          var attributes = openingLikeElement.attributes;
          var allAttributesTable = strictNullChecks ? ts3.createSymbolTable() : void 0;
          var attributesTable = ts3.createSymbolTable();
          var spread = emptyJsxObjectType;
          var hasSpreadAnyType = false;
          var typeToIntersect;
          var explicitlySpecifyChildrenAttribute = false;
          var objectFlags = 2048;
          var jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(openingLikeElement));
          for (var _i = 0, _a = attributes.properties; _i < _a.length; _i++) {
            var attributeDecl = _a[_i];
            var member = attributeDecl.symbol;
            if (ts3.isJsxAttribute(attributeDecl)) {
              var exprType = checkJsxAttribute(attributeDecl, checkMode);
              objectFlags |= ts3.getObjectFlags(exprType) & 458752;
              var attributeSymbol = createSymbol(4 | member.flags, member.escapedName);
              attributeSymbol.declarations = member.declarations;
              attributeSymbol.parent = member.parent;
              if (member.valueDeclaration) {
                attributeSymbol.valueDeclaration = member.valueDeclaration;
              }
              attributeSymbol.type = exprType;
              attributeSymbol.target = member;
              attributesTable.set(attributeSymbol.escapedName, attributeSymbol);
              allAttributesTable === null || allAttributesTable === void 0 ? void 0 : allAttributesTable.set(attributeSymbol.escapedName, attributeSymbol);
              if (attributeDecl.name.escapedText === jsxChildrenPropertyName) {
                explicitlySpecifyChildrenAttribute = true;
              }
            } else {
              ts3.Debug.assert(attributeDecl.kind === 287);
              if (attributesTable.size > 0) {
                spread = getSpreadType(spread, createJsxAttributesType(), attributes.symbol, objectFlags, false);
                attributesTable = ts3.createSymbolTable();
              }
              var exprType = getReducedType(checkExpressionCached(attributeDecl.expression, checkMode));
              if (isTypeAny(exprType)) {
                hasSpreadAnyType = true;
              }
              if (isValidSpreadType(exprType)) {
                spread = getSpreadType(spread, exprType, attributes.symbol, objectFlags, false);
                if (allAttributesTable) {
                  checkSpreadPropOverrides(exprType, allAttributesTable, attributeDecl);
                }
              } else {
                error(attributeDecl.expression, ts3.Diagnostics.Spread_types_may_only_be_created_from_object_types);
                typeToIntersect = typeToIntersect ? getIntersectionType([typeToIntersect, exprType]) : exprType;
              }
            }
          }
          if (!hasSpreadAnyType) {
            if (attributesTable.size > 0) {
              spread = getSpreadType(spread, createJsxAttributesType(), attributes.symbol, objectFlags, false);
            }
          }
          var parent = openingLikeElement.parent.kind === 278 ? openingLikeElement.parent : void 0;
          if (parent && parent.openingElement === openingLikeElement && parent.children.length > 0) {
            var childrenTypes = checkJsxChildren(parent, checkMode);
            if (!hasSpreadAnyType && jsxChildrenPropertyName && jsxChildrenPropertyName !== "") {
              if (explicitlySpecifyChildrenAttribute) {
                error(attributes, ts3.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten, ts3.unescapeLeadingUnderscores(jsxChildrenPropertyName));
              }
              var contextualType = getApparentTypeOfContextualType(openingLikeElement.attributes);
              var childrenContextualType = contextualType && getTypeOfPropertyOfContextualType(contextualType, jsxChildrenPropertyName);
              var childrenPropSymbol = createSymbol(4, jsxChildrenPropertyName);
              childrenPropSymbol.type = childrenTypes.length === 1 ? childrenTypes[0] : childrenContextualType && someType(childrenContextualType, isTupleLikeType) ? createTupleType(childrenTypes) : createArrayType(getUnionType(childrenTypes));
              childrenPropSymbol.valueDeclaration = ts3.factory.createPropertySignature(void 0, ts3.unescapeLeadingUnderscores(jsxChildrenPropertyName), void 0, void 0);
              ts3.setParent(childrenPropSymbol.valueDeclaration, attributes);
              childrenPropSymbol.valueDeclaration.symbol = childrenPropSymbol;
              var childPropMap = ts3.createSymbolTable();
              childPropMap.set(jsxChildrenPropertyName, childrenPropSymbol);
              spread = getSpreadType(spread, createAnonymousType(attributes.symbol, childPropMap, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray), attributes.symbol, objectFlags, false);
            }
          }
          if (hasSpreadAnyType) {
            return anyType;
          }
          if (typeToIntersect && spread !== emptyJsxObjectType) {
            return getIntersectionType([typeToIntersect, spread]);
          }
          return typeToIntersect || (spread === emptyJsxObjectType ? createJsxAttributesType() : spread);
          function createJsxAttributesType() {
            objectFlags |= freshObjectLiteralFlag;
            var result2 = createAnonymousType(attributes.symbol, attributesTable, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
            result2.objectFlags |= objectFlags | 128 | 131072;
            return result2;
          }
        }
        function checkJsxChildren(node, checkMode) {
          var childrenTypes = [];
          for (var _i = 0, _a = node.children; _i < _a.length; _i++) {
            var child = _a[_i];
            if (child.kind === 11) {
              if (!child.containsOnlyTriviaWhiteSpaces) {
                childrenTypes.push(stringType);
              }
            } else if (child.kind === 288 && !child.expression) {
              continue;
            } else {
              childrenTypes.push(checkExpressionForMutableLocation(child, checkMode));
            }
          }
          return childrenTypes;
        }
        function checkSpreadPropOverrides(type2, props, spread) {
          for (var _i = 0, _a = getPropertiesOfType(type2); _i < _a.length; _i++) {
            var right = _a[_i];
            if (!(right.flags & 16777216)) {
              var left = props.get(right.escapedName);
              if (left) {
                var diagnostic = error(left.valueDeclaration, ts3.Diagnostics._0_is_specified_more_than_once_so_this_usage_will_be_overwritten, ts3.unescapeLeadingUnderscores(left.escapedName));
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(spread, ts3.Diagnostics.This_spread_always_overwrites_this_property));
              }
            }
          }
        }
        function checkJsxAttributes(node, checkMode) {
          return createJsxAttributesTypeFromAttributesProperty(node.parent, checkMode);
        }
        function getJsxType(name, location) {
          var namespace = getJsxNamespaceAt(location);
          var exports2 = namespace && getExportsOfSymbol(namespace);
          var typeSymbol = exports2 && getSymbol(exports2, name, 788968);
          return typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType;
        }
        function getIntrinsicTagSymbol(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedSymbol) {
            var intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, node);
            if (!isErrorType(intrinsicElementsType)) {
              if (!ts3.isIdentifier(node.tagName))
                return ts3.Debug.fail();
              var intrinsicProp = getPropertyOfType(intrinsicElementsType, node.tagName.escapedText);
              if (intrinsicProp) {
                links.jsxFlags |= 1;
                return links.resolvedSymbol = intrinsicProp;
              }
              var indexSignatureType = getIndexTypeOfType(intrinsicElementsType, stringType);
              if (indexSignatureType) {
                links.jsxFlags |= 2;
                return links.resolvedSymbol = intrinsicElementsType.symbol;
              }
              error(node, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.idText(node.tagName), "JSX." + JsxNames.IntrinsicElements);
              return links.resolvedSymbol = unknownSymbol;
            } else {
              if (noImplicitAny) {
                error(node, ts3.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists, ts3.unescapeLeadingUnderscores(JsxNames.IntrinsicElements));
              }
              return links.resolvedSymbol = unknownSymbol;
            }
          }
          return links.resolvedSymbol;
        }
        function getJsxNamespaceContainerForImplicitImport(location) {
          var file = location && ts3.getSourceFileOfNode(location);
          var links = file && getNodeLinks(file);
          if (links && links.jsxImplicitImportContainer === false) {
            return void 0;
          }
          if (links && links.jsxImplicitImportContainer) {
            return links.jsxImplicitImportContainer;
          }
          var runtimeImportSpecifier = ts3.getJSXRuntimeImport(ts3.getJSXImplicitImportBase(compilerOptions, file), compilerOptions);
          if (!runtimeImportSpecifier) {
            return void 0;
          }
          var isClassic = ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Classic;
          var errorMessage = isClassic ? ts3.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : ts3.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
          var mod = resolveExternalModule(location, runtimeImportSpecifier, errorMessage, location);
          var result2 = mod && mod !== unknownSymbol ? getMergedSymbol(resolveSymbol(mod)) : void 0;
          if (links) {
            links.jsxImplicitImportContainer = result2 || false;
          }
          return result2;
        }
        function getJsxNamespaceAt(location) {
          var links = location && getNodeLinks(location);
          if (links && links.jsxNamespace) {
            return links.jsxNamespace;
          }
          if (!links || links.jsxNamespace !== false) {
            var resolvedNamespace = getJsxNamespaceContainerForImplicitImport(location);
            if (!resolvedNamespace || resolvedNamespace === unknownSymbol) {
              var namespaceName = getJsxNamespace(location);
              resolvedNamespace = resolveName(location, namespaceName, 1920, void 0, namespaceName, false);
            }
            if (resolvedNamespace) {
              var candidate = resolveSymbol(getSymbol(getExportsOfSymbol(resolveSymbol(resolvedNamespace)), JsxNames.JSX, 1920));
              if (candidate && candidate !== unknownSymbol) {
                if (links) {
                  links.jsxNamespace = candidate;
                }
                return candidate;
              }
            }
            if (links) {
              links.jsxNamespace = false;
            }
          }
          var s = resolveSymbol(getGlobalSymbol(JsxNames.JSX, 1920, void 0));
          if (s === unknownSymbol) {
            return void 0;
          }
          return s;
        }
        function getNameFromJsxElementAttributesContainer(nameOfAttribPropContainer, jsxNamespace) {
          var jsxElementAttribPropInterfaceSym = jsxNamespace && getSymbol(jsxNamespace.exports, nameOfAttribPropContainer, 788968);
          var jsxElementAttribPropInterfaceType = jsxElementAttribPropInterfaceSym && getDeclaredTypeOfSymbol(jsxElementAttribPropInterfaceSym);
          var propertiesOfJsxElementAttribPropInterface = jsxElementAttribPropInterfaceType && getPropertiesOfType(jsxElementAttribPropInterfaceType);
          if (propertiesOfJsxElementAttribPropInterface) {
            if (propertiesOfJsxElementAttribPropInterface.length === 0) {
              return "";
            } else if (propertiesOfJsxElementAttribPropInterface.length === 1) {
              return propertiesOfJsxElementAttribPropInterface[0].escapedName;
            } else if (propertiesOfJsxElementAttribPropInterface.length > 1 && jsxElementAttribPropInterfaceSym.declarations) {
              error(jsxElementAttribPropInterfaceSym.declarations[0], ts3.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property, ts3.unescapeLeadingUnderscores(nameOfAttribPropContainer));
            }
          }
          return void 0;
        }
        function getJsxLibraryManagedAttributes(jsxNamespace) {
          return jsxNamespace && getSymbol(jsxNamespace.exports, JsxNames.LibraryManagedAttributes, 788968);
        }
        function getJsxElementPropertiesName(jsxNamespace) {
          return getNameFromJsxElementAttributesContainer(JsxNames.ElementAttributesPropertyNameContainer, jsxNamespace);
        }
        function getJsxElementChildrenPropertyName(jsxNamespace) {
          return getNameFromJsxElementAttributesContainer(JsxNames.ElementChildrenAttributeNameContainer, jsxNamespace);
        }
        function getUninstantiatedJsxSignaturesOfType(elementType, caller) {
          if (elementType.flags & 4) {
            return [anySignature];
          } else if (elementType.flags & 128) {
            var intrinsicType = getIntrinsicAttributesTypeFromStringLiteralType(elementType, caller);
            if (!intrinsicType) {
              error(caller, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, elementType.value, "JSX." + JsxNames.IntrinsicElements);
              return ts3.emptyArray;
            } else {
              var fakeSignature = createSignatureForJSXIntrinsic(caller, intrinsicType);
              return [fakeSignature];
            }
          }
          var apparentElemType = getApparentType(elementType);
          var signatures = getSignaturesOfType(apparentElemType, 1);
          if (signatures.length === 0) {
            signatures = getSignaturesOfType(apparentElemType, 0);
          }
          if (signatures.length === 0 && apparentElemType.flags & 1048576) {
            signatures = getUnionSignatures(ts3.map(apparentElemType.types, function(t) {
              return getUninstantiatedJsxSignaturesOfType(t, caller);
            }));
          }
          return signatures;
        }
        function getIntrinsicAttributesTypeFromStringLiteralType(type2, location) {
          var intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, location);
          if (!isErrorType(intrinsicElementsType)) {
            var stringLiteralTypeName = type2.value;
            var intrinsicProp = getPropertyOfType(intrinsicElementsType, ts3.escapeLeadingUnderscores(stringLiteralTypeName));
            if (intrinsicProp) {
              return getTypeOfSymbol(intrinsicProp);
            }
            var indexSignatureType = getIndexTypeOfType(intrinsicElementsType, stringType);
            if (indexSignatureType) {
              return indexSignatureType;
            }
            return void 0;
          }
          return anyType;
        }
        function checkJsxReturnAssignableToAppropriateBound(refKind, elemInstanceType, openingLikeElement) {
          if (refKind === 1) {
            var sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
            if (sfcReturnConstraint) {
              checkTypeRelatedTo(elemInstanceType, sfcReturnConstraint, assignableRelation, openingLikeElement.tagName, ts3.Diagnostics.Its_return_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
            }
          } else if (refKind === 0) {
            var classConstraint = getJsxElementClassTypeAt(openingLikeElement);
            if (classConstraint) {
              checkTypeRelatedTo(elemInstanceType, classConstraint, assignableRelation, openingLikeElement.tagName, ts3.Diagnostics.Its_instance_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
            }
          } else {
            var sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
            var classConstraint = getJsxElementClassTypeAt(openingLikeElement);
            if (!sfcReturnConstraint || !classConstraint) {
              return;
            }
            var combined = getUnionType([sfcReturnConstraint, classConstraint]);
            checkTypeRelatedTo(elemInstanceType, combined, assignableRelation, openingLikeElement.tagName, ts3.Diagnostics.Its_element_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
          }
          function generateInitialErrorChain() {
            var componentName = ts3.getTextOfNode(openingLikeElement.tagName);
            return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics._0_cannot_be_used_as_a_JSX_component, componentName);
          }
        }
        function getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node) {
          ts3.Debug.assert(isJsxIntrinsicIdentifier(node.tagName));
          var links = getNodeLinks(node);
          if (!links.resolvedJsxElementAttributesType) {
            var symbol = getIntrinsicTagSymbol(node);
            if (links.jsxFlags & 1) {
              return links.resolvedJsxElementAttributesType = getTypeOfSymbol(symbol) || errorType;
            } else if (links.jsxFlags & 2) {
              return links.resolvedJsxElementAttributesType = getIndexTypeOfType(getJsxType(JsxNames.IntrinsicElements, node), stringType) || errorType;
            } else {
              return links.resolvedJsxElementAttributesType = errorType;
            }
          }
          return links.resolvedJsxElementAttributesType;
        }
        function getJsxElementClassTypeAt(location) {
          var type2 = getJsxType(JsxNames.ElementClass, location);
          if (isErrorType(type2))
            return void 0;
          return type2;
        }
        function getJsxElementTypeAt(location) {
          return getJsxType(JsxNames.Element, location);
        }
        function getJsxStatelessElementTypeAt(location) {
          var jsxElementType = getJsxElementTypeAt(location);
          if (jsxElementType) {
            return getUnionType([jsxElementType, nullType]);
          }
        }
        function getJsxIntrinsicTagNamesAt(location) {
          var intrinsics = getJsxType(JsxNames.IntrinsicElements, location);
          return intrinsics ? getPropertiesOfType(intrinsics) : ts3.emptyArray;
        }
        function checkJsxPreconditions(errorNode) {
          if ((compilerOptions.jsx || 0) === 0) {
            error(errorNode, ts3.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided);
          }
          if (getJsxElementTypeAt(errorNode) === void 0) {
            if (noImplicitAny) {
              error(errorNode, ts3.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);
            }
          }
        }
        function checkJsxOpeningLikeElementOrOpeningFragment(node) {
          var isNodeOpeningLikeElement = ts3.isJsxOpeningLikeElement(node);
          if (isNodeOpeningLikeElement) {
            checkGrammarJsxElement(node);
          }
          checkJsxPreconditions(node);
          if (!getJsxNamespaceContainerForImplicitImport(node)) {
            var jsxFactoryRefErr = diagnostics && compilerOptions.jsx === 2 ? ts3.Diagnostics.Cannot_find_name_0 : void 0;
            var jsxFactoryNamespace = getJsxNamespace(node);
            var jsxFactoryLocation = isNodeOpeningLikeElement ? node.tagName : node;
            var jsxFactorySym = void 0;
            if (!(ts3.isJsxOpeningFragment(node) && jsxFactoryNamespace === "null")) {
              jsxFactorySym = resolveName(jsxFactoryLocation, jsxFactoryNamespace, 111551, jsxFactoryRefErr, jsxFactoryNamespace, true);
            }
            if (jsxFactorySym) {
              jsxFactorySym.isReferenced = 67108863;
              if (jsxFactorySym.flags & 2097152 && !getTypeOnlyAliasDeclaration(jsxFactorySym)) {
                markAliasSymbolAsReferenced(jsxFactorySym);
              }
            }
            if (ts3.isJsxOpeningFragment(node)) {
              var file = ts3.getSourceFileOfNode(node);
              var localJsxNamespace = getLocalJsxNamespace(file);
              if (localJsxNamespace) {
                resolveName(jsxFactoryLocation, localJsxNamespace, 111551, jsxFactoryRefErr, localJsxNamespace, true);
              }
            }
          }
          if (isNodeOpeningLikeElement) {
            var jsxOpeningLikeNode = node;
            var sig = getResolvedSignature(jsxOpeningLikeNode);
            checkDeprecatedSignature(sig, node);
            checkJsxReturnAssignableToAppropriateBound(getJsxReferenceKind(jsxOpeningLikeNode), getReturnTypeOfSignature(sig), jsxOpeningLikeNode);
          }
        }
        function isKnownProperty(targetType, name, isComparingJsxAttributes) {
          if (targetType.flags & 524288) {
            if (getPropertyOfObjectType(targetType, name) || getApplicableIndexInfoForName(targetType, name) || isLateBoundName(name) && getIndexInfoOfType(targetType, stringType) || isComparingJsxAttributes && isHyphenatedJsxName(name)) {
              return true;
            }
          } else if (targetType.flags & 3145728 && isExcessPropertyCheckTarget(targetType)) {
            for (var _i = 0, _a = targetType.types; _i < _a.length; _i++) {
              var t = _a[_i];
              if (isKnownProperty(t, name, isComparingJsxAttributes)) {
                return true;
              }
            }
          }
          return false;
        }
        function isExcessPropertyCheckTarget(type2) {
          return !!(type2.flags & 524288 && !(ts3.getObjectFlags(type2) & 512) || type2.flags & 67108864 || type2.flags & 1048576 && ts3.some(type2.types, isExcessPropertyCheckTarget) || type2.flags & 2097152 && ts3.every(type2.types, isExcessPropertyCheckTarget));
        }
        function checkJsxExpression(node, checkMode) {
          checkGrammarJsxExpression(node);
          if (node.expression) {
            var type2 = checkExpression(node.expression, checkMode);
            if (node.dotDotDotToken && type2 !== anyType && !isArrayType(type2)) {
              error(node, ts3.Diagnostics.JSX_spread_child_must_be_an_array_type);
            }
            return type2;
          } else {
            return errorType;
          }
        }
        function getDeclarationNodeFlagsFromSymbol(s) {
          return s.valueDeclaration ? ts3.getCombinedNodeFlags(s.valueDeclaration) : 0;
        }
        function isPrototypeProperty(symbol) {
          if (symbol.flags & 8192 || ts3.getCheckFlags(symbol) & 4) {
            return true;
          }
          if (ts3.isInJSFile(symbol.valueDeclaration)) {
            var parent = symbol.valueDeclaration.parent;
            return parent && ts3.isBinaryExpression(parent) && ts3.getAssignmentDeclarationKind(parent) === 3;
          }
        }
        function checkPropertyAccessibility(node, isSuper, writing, type2, prop, reportError) {
          if (reportError === void 0) {
            reportError = true;
          }
          var errorNode = !reportError ? void 0 : node.kind === 161 ? node.right : node.kind === 200 ? node : node.kind === 203 && node.propertyName ? node.propertyName : node.name;
          return checkPropertyAccessibilityAtLocation(node, isSuper, writing, type2, prop, errorNode);
        }
        function checkPropertyAccessibilityAtLocation(location, isSuper, writing, containingType, prop, errorNode) {
          var flags = ts3.getDeclarationModifierFlagsFromSymbol(prop, writing);
          if (isSuper) {
            if (languageVersion < 2) {
              if (symbolHasNonMethodDeclaration(prop)) {
                if (errorNode) {
                  error(errorNode, ts3.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword);
                }
                return false;
              }
            }
            if (flags & 128) {
              if (errorNode) {
                error(errorNode, ts3.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression, symbolToString(prop), typeToString(getDeclaringClass(prop)));
              }
              return false;
            }
          }
          if (flags & 128 && symbolHasNonMethodDeclaration(prop) && (ts3.isThisProperty(location) || ts3.isThisInitializedObjectBindingExpression(location) || ts3.isObjectBindingPattern(location.parent) && ts3.isThisInitializedDeclaration(location.parent.parent))) {
            var declaringClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
            if (declaringClassDeclaration && isNodeUsedDuringClassInitialization(location)) {
              if (errorNode) {
                error(errorNode, ts3.Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor, symbolToString(prop), ts3.getTextOfIdentifierOrLiteral(declaringClassDeclaration.name));
              }
              return false;
            }
          }
          if (!(flags & 24)) {
            return true;
          }
          if (flags & 8) {
            var declaringClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
            if (!isNodeWithinClass(location, declaringClassDeclaration)) {
              if (errorNode) {
                error(errorNode, ts3.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1, symbolToString(prop), typeToString(getDeclaringClass(prop)));
              }
              return false;
            }
            return true;
          }
          if (isSuper) {
            return true;
          }
          var enclosingClass = forEachEnclosingClass(location, function(enclosingDeclaration) {
            var enclosingClass2 = getDeclaredTypeOfSymbol(getSymbolOfNode(enclosingDeclaration));
            return isClassDerivedFromDeclaringClasses(enclosingClass2, prop, writing);
          });
          if (!enclosingClass) {
            enclosingClass = getEnclosingClassFromThisParameter(location);
            enclosingClass = enclosingClass && isClassDerivedFromDeclaringClasses(enclosingClass, prop, writing);
            if (flags & 32 || !enclosingClass) {
              if (errorNode) {
                error(errorNode, ts3.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses, symbolToString(prop), typeToString(getDeclaringClass(prop) || containingType));
              }
              return false;
            }
          }
          if (flags & 32) {
            return true;
          }
          if (containingType.flags & 262144) {
            containingType = containingType.isThisType ? getConstraintOfTypeParameter(containingType) : getBaseConstraintOfType(containingType);
          }
          if (!containingType || !hasBaseType(containingType, enclosingClass)) {
            if (errorNode) {
              error(errorNode, ts3.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2, symbolToString(prop), typeToString(enclosingClass), typeToString(containingType));
            }
            return false;
          }
          return true;
        }
        function getEnclosingClassFromThisParameter(node) {
          var thisParameter = getThisParameterFromNodeContext(node);
          var thisType = (thisParameter === null || thisParameter === void 0 ? void 0 : thisParameter.type) && getTypeFromTypeNode(thisParameter.type);
          if (thisType && thisType.flags & 262144) {
            thisType = getConstraintOfTypeParameter(thisType);
          }
          if (thisType && ts3.getObjectFlags(thisType) & (3 | 4)) {
            return getTargetType(thisType);
          }
          return void 0;
        }
        function getThisParameterFromNodeContext(node) {
          var thisContainer = ts3.getThisContainer(node, false);
          return thisContainer && ts3.isFunctionLike(thisContainer) ? ts3.getThisParameter(thisContainer) : void 0;
        }
        function symbolHasNonMethodDeclaration(symbol) {
          return !!forEachProperty(symbol, function(prop) {
            return !(prop.flags & 8192);
          });
        }
        function checkNonNullExpression(node) {
          return checkNonNullType(checkExpression(node), node);
        }
        function isNullableType(type2) {
          return !!((strictNullChecks ? getFalsyFlags(type2) : type2.flags) & 98304);
        }
        function getNonNullableTypeIfNeeded(type2) {
          return isNullableType(type2) ? getNonNullableType(type2) : type2;
        }
        function reportObjectPossiblyNullOrUndefinedError(node, flags) {
          error(node, flags & 32768 ? flags & 65536 ? ts3.Diagnostics.Object_is_possibly_null_or_undefined : ts3.Diagnostics.Object_is_possibly_undefined : ts3.Diagnostics.Object_is_possibly_null);
        }
        function reportCannotInvokePossiblyNullOrUndefinedError(node, flags) {
          error(node, flags & 32768 ? flags & 65536 ? ts3.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined : ts3.Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined : ts3.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null);
        }
        function checkNonNullTypeWithReporter(type2, node, reportError) {
          if (strictNullChecks && type2.flags & 2) {
            error(node, ts3.Diagnostics.Object_is_of_type_unknown);
            return errorType;
          }
          var kind = (strictNullChecks ? getFalsyFlags(type2) : type2.flags) & 98304;
          if (kind) {
            reportError(node, kind);
            var t = getNonNullableType(type2);
            return t.flags & (98304 | 131072) ? errorType : t;
          }
          return type2;
        }
        function checkNonNullType(type2, node) {
          return checkNonNullTypeWithReporter(type2, node, reportObjectPossiblyNullOrUndefinedError);
        }
        function checkNonNullNonVoidType(type2, node) {
          var nonNullType = checkNonNullType(type2, node);
          if (nonNullType.flags & 16384) {
            error(node, ts3.Diagnostics.Object_is_possibly_undefined);
          }
          return nonNullType;
        }
        function checkPropertyAccessExpression(node, checkMode) {
          return node.flags & 32 ? checkPropertyAccessChain(node, checkMode) : checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullExpression(node.expression), node.name, checkMode);
        }
        function checkPropertyAccessChain(node, checkMode) {
          var leftType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(leftType, node.expression);
          return propagateOptionalTypeMarker(checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullType(nonOptionalType, node.expression), node.name, checkMode), node, nonOptionalType !== leftType);
        }
        function checkQualifiedName(node, checkMode) {
          var leftType = ts3.isPartOfTypeQuery(node) && ts3.isThisIdentifier(node.left) ? checkNonNullType(checkThisExpression(node.left), node.left) : checkNonNullExpression(node.left);
          return checkPropertyAccessExpressionOrQualifiedName(node, node.left, leftType, node.right, checkMode);
        }
        function isMethodAccessForCall(node) {
          while (node.parent.kind === 212) {
            node = node.parent;
          }
          return ts3.isCallOrNewExpression(node.parent) && node.parent.expression === node;
        }
        function lookupSymbolForPrivateIdentifierDeclaration(propName, location) {
          for (var containingClass = ts3.getContainingClass(location); !!containingClass; containingClass = ts3.getContainingClass(containingClass)) {
            var symbol = containingClass.symbol;
            var name = ts3.getSymbolNameForPrivateIdentifier(symbol, propName);
            var prop = symbol.members && symbol.members.get(name) || symbol.exports && symbol.exports.get(name);
            if (prop) {
              return prop;
            }
          }
        }
        function checkGrammarPrivateIdentifierExpression(privId) {
          if (!ts3.getContainingClass(privId)) {
            return grammarErrorOnNode(privId, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
          }
          if (!ts3.isForInStatement(privId.parent)) {
            if (!ts3.isExpressionNode(privId)) {
              return grammarErrorOnNode(privId, ts3.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression);
            }
            var isInOperation = ts3.isBinaryExpression(privId.parent) && privId.parent.operatorToken.kind === 101;
            if (!getSymbolForPrivateIdentifierExpression(privId) && !isInOperation) {
              return grammarErrorOnNode(privId, ts3.Diagnostics.Cannot_find_name_0, ts3.idText(privId));
            }
          }
          return false;
        }
        function checkPrivateIdentifierExpression(privId) {
          checkGrammarPrivateIdentifierExpression(privId);
          var symbol = getSymbolForPrivateIdentifierExpression(privId);
          if (symbol) {
            markPropertyAsReferenced(symbol, void 0, false);
          }
          return anyType;
        }
        function getSymbolForPrivateIdentifierExpression(privId) {
          if (!ts3.isExpressionNode(privId)) {
            return void 0;
          }
          var links = getNodeLinks(privId);
          if (links.resolvedSymbol === void 0) {
            links.resolvedSymbol = lookupSymbolForPrivateIdentifierDeclaration(privId.escapedText, privId);
          }
          return links.resolvedSymbol;
        }
        function getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) {
          return getPropertyOfType(leftType, lexicallyScopedIdentifier.escapedName);
        }
        function checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedIdentifier) {
          var propertyOnType;
          var properties = getPropertiesOfType(leftType);
          if (properties) {
            ts3.forEach(properties, function(symbol) {
              var decl = symbol.valueDeclaration;
              if (decl && ts3.isNamedDeclaration(decl) && ts3.isPrivateIdentifier(decl.name) && decl.name.escapedText === right.escapedText) {
                propertyOnType = symbol;
                return true;
              }
            });
          }
          var diagName = diagnosticName(right);
          if (propertyOnType) {
            var typeValueDecl = ts3.Debug.checkDefined(propertyOnType.valueDeclaration);
            var typeClass_1 = ts3.Debug.checkDefined(ts3.getContainingClass(typeValueDecl));
            if (lexicallyScopedIdentifier === null || lexicallyScopedIdentifier === void 0 ? void 0 : lexicallyScopedIdentifier.valueDeclaration) {
              var lexicalValueDecl = lexicallyScopedIdentifier.valueDeclaration;
              var lexicalClass = ts3.getContainingClass(lexicalValueDecl);
              ts3.Debug.assert(!!lexicalClass);
              if (ts3.findAncestor(lexicalClass, function(n) {
                return typeClass_1 === n;
              })) {
                var diagnostic = error(right, ts3.Diagnostics.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling, diagName, typeToString(leftType));
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(lexicalValueDecl, ts3.Diagnostics.The_shadowing_declaration_of_0_is_defined_here, diagName), ts3.createDiagnosticForNode(typeValueDecl, ts3.Diagnostics.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here, diagName));
                return true;
              }
            }
            error(right, ts3.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier, diagName, diagnosticName(typeClass_1.name || anon));
            return true;
          }
          return false;
        }
        function isThisPropertyAccessInConstructor(node, prop) {
          return (isConstructorDeclaredProperty(prop) || ts3.isThisProperty(node) && isAutoTypedProperty(prop)) && ts3.getThisContainer(node, true) === getDeclaringConstructor(prop);
        }
        function checkPropertyAccessExpressionOrQualifiedName(node, left, leftType, right, checkMode) {
          var parentSymbol = getNodeLinks(left).resolvedSymbol;
          var assignmentKind = ts3.getAssignmentTargetKind(node);
          var apparentType = getApparentType(assignmentKind !== 0 || isMethodAccessForCall(node) ? getWidenedType(leftType) : leftType);
          var isAnyLike = isTypeAny(apparentType) || apparentType === silentNeverType;
          var prop;
          if (ts3.isPrivateIdentifier(right)) {
            if (languageVersion < 99) {
              if (assignmentKind !== 0) {
                checkExternalEmitHelpers(node, 1048576);
              }
              if (assignmentKind !== 1) {
                checkExternalEmitHelpers(node, 524288);
              }
            }
            var lexicallyScopedSymbol = lookupSymbolForPrivateIdentifierDeclaration(right.escapedText, right);
            if (assignmentKind && lexicallyScopedSymbol && lexicallyScopedSymbol.valueDeclaration && ts3.isMethodDeclaration(lexicallyScopedSymbol.valueDeclaration)) {
              grammarErrorOnNode(right, ts3.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable, ts3.idText(right));
            }
            if (isAnyLike) {
              if (lexicallyScopedSymbol) {
                return isErrorType(apparentType) ? errorType : apparentType;
              }
              if (!ts3.getContainingClass(right)) {
                grammarErrorOnNode(right, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
                return anyType;
              }
            }
            prop = lexicallyScopedSymbol ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedSymbol) : void 0;
            if (!prop && checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedSymbol)) {
              return errorType;
            } else {
              var isSetonlyAccessor = prop && prop.flags & 65536 && !(prop.flags & 32768);
              if (isSetonlyAccessor && assignmentKind !== 1) {
                error(node, ts3.Diagnostics.Private_accessor_was_defined_without_a_getter);
              }
            }
          } else {
            if (isAnyLike) {
              if (ts3.isIdentifier(left) && parentSymbol) {
                markAliasReferenced(parentSymbol, node);
              }
              return isErrorType(apparentType) ? errorType : apparentType;
              ;
            }
            prop = getPropertyOfType(apparentType, right.escapedText);
          }
          if (ts3.isIdentifier(left) && parentSymbol && (compilerOptions.isolatedModules || !(prop && (isConstEnumOrConstEnumOnlyModule(prop) || prop.flags & 8 && node.parent.kind === 299)) || ts3.shouldPreserveConstEnums(compilerOptions) && isExportOrExportExpression(node))) {
            markAliasReferenced(parentSymbol, node);
          }
          var propType;
          if (!prop) {
            var indexInfo = !ts3.isPrivateIdentifier(right) && (assignmentKind === 0 || !isGenericObjectType(leftType) || ts3.isThisTypeParameter(leftType)) ? getApplicableIndexInfoForName(apparentType, right.escapedText) : void 0;
            if (!(indexInfo && indexInfo.type)) {
              var isUncheckedJS = isUncheckedJSSuggestion(node, leftType.symbol, true);
              if (!isUncheckedJS && isJSLiteralType(leftType)) {
                return anyType;
              }
              if (leftType.symbol === globalThisSymbol) {
                if (globalThisSymbol.exports.has(right.escapedText) && globalThisSymbol.exports.get(right.escapedText).flags & 418) {
                  error(right, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.unescapeLeadingUnderscores(right.escapedText), typeToString(leftType));
                } else if (noImplicitAny) {
                  error(right, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature, typeToString(leftType));
                }
                return anyType;
              }
              if (right.escapedText && !checkAndReportErrorForExtendingInterface(node)) {
                reportNonexistentProperty(right, ts3.isThisTypeParameter(leftType) ? apparentType : leftType, isUncheckedJS);
              }
              return errorType;
            }
            if (indexInfo.isReadonly && (ts3.isAssignmentTarget(node) || ts3.isDeleteTarget(node))) {
              error(node, ts3.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(apparentType));
            }
            propType = compilerOptions.noUncheckedIndexedAccess && !ts3.isAssignmentTarget(node) ? getUnionType([indexInfo.type, undefinedType]) : indexInfo.type;
            if (compilerOptions.noPropertyAccessFromIndexSignature && ts3.isPropertyAccessExpression(node)) {
              error(right, ts3.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0, ts3.unescapeLeadingUnderscores(right.escapedText));
            }
            if (indexInfo.declaration && ts3.getCombinedNodeFlags(indexInfo.declaration) & 268435456) {
              addDeprecatedSuggestion(right, [indexInfo.declaration], right.escapedText);
            }
          } else {
            if (isDeprecatedSymbol(prop) && isUncalledFunctionReference(node, prop) && prop.declarations) {
              addDeprecatedSuggestion(right, prop.declarations, right.escapedText);
            }
            checkPropertyNotUsedBeforeDeclaration(prop, node, right);
            markPropertyAsReferenced(prop, node, isSelfTypeAccess(left, parentSymbol));
            getNodeLinks(node).resolvedSymbol = prop;
            var writing = ts3.isWriteAccess(node);
            checkPropertyAccessibility(node, left.kind === 106, writing, apparentType, prop);
            if (isAssignmentToReadonlyEntity(node, prop, assignmentKind)) {
              error(right, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, ts3.idText(right));
              return errorType;
            }
            propType = isThisPropertyAccessInConstructor(node, prop) ? autoType : writing ? getWriteTypeOfSymbol(prop) : getTypeOfSymbol(prop);
          }
          return getFlowTypeOfAccessExpression(node, prop, propType, right, checkMode);
        }
        function isUncheckedJSSuggestion(node, suggestion, excludeClasses) {
          var file = ts3.getSourceFileOfNode(node);
          if (file) {
            if (compilerOptions.checkJs === void 0 && file.checkJsDirective === void 0 && (file.scriptKind === 1 || file.scriptKind === 2)) {
              var declarationFile = ts3.forEach(suggestion === null || suggestion === void 0 ? void 0 : suggestion.declarations, ts3.getSourceFileOfNode);
              return !(file !== declarationFile && !!declarationFile && isGlobalSourceFile(declarationFile)) && !(excludeClasses && suggestion && suggestion.flags & 32) && !(!!node && excludeClasses && ts3.isPropertyAccessExpression(node) && node.expression.kind === 108);
            }
          }
          return false;
        }
        function getFlowTypeOfAccessExpression(node, prop, propType, errorNode, checkMode) {
          var assignmentKind = ts3.getAssignmentTargetKind(node);
          if (assignmentKind === 1) {
            return removeMissingType(propType, !!(prop && prop.flags & 16777216));
          }
          if (prop && !(prop.flags & (3 | 4 | 98304)) && !(prop.flags & 8192 && propType.flags & 1048576) && !isDuplicatedCommonJSExport(prop.declarations)) {
            return propType;
          }
          if (propType === autoType) {
            return getFlowTypeOfProperty(node, prop);
          }
          propType = getNarrowableTypeForReference(propType, node, checkMode);
          var assumeUninitialized = false;
          if (strictNullChecks && strictPropertyInitialization && ts3.isAccessExpression(node) && node.expression.kind === 108) {
            var declaration = prop && prop.valueDeclaration;
            if (declaration && isPropertyWithoutInitializer(declaration)) {
              if (!ts3.isStatic(declaration)) {
                var flowContainer = getControlFlowContainer(node);
                if (flowContainer.kind === 171 && flowContainer.parent === declaration.parent && !(declaration.flags & 16777216)) {
                  assumeUninitialized = true;
                }
              }
            }
          } else if (strictNullChecks && prop && prop.valueDeclaration && ts3.isPropertyAccessExpression(prop.valueDeclaration) && ts3.getAssignmentDeclarationPropertyAccessKind(prop.valueDeclaration) && getControlFlowContainer(node) === getControlFlowContainer(prop.valueDeclaration)) {
            assumeUninitialized = true;
          }
          var flowType = getFlowTypeOfReference(node, propType, assumeUninitialized ? getOptionalType(propType) : propType);
          if (assumeUninitialized && !(getFalsyFlags(propType) & 32768) && getFalsyFlags(flowType) & 32768) {
            error(errorNode, ts3.Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(prop));
            return propType;
          }
          return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
        }
        function checkPropertyNotUsedBeforeDeclaration(prop, node, right) {
          var valueDeclaration = prop.valueDeclaration;
          if (!valueDeclaration || ts3.getSourceFileOfNode(node).isDeclarationFile) {
            return;
          }
          var diagnosticMessage;
          var declarationName = ts3.idText(right);
          if (isInPropertyInitializerOrClassStaticBlock(node) && !isOptionalPropertyDeclaration(valueDeclaration) && !(ts3.isAccessExpression(node) && ts3.isAccessExpression(node.expression)) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right) && !(ts3.isMethodDeclaration(valueDeclaration) && ts3.getCombinedModifierFlags(valueDeclaration) & 32) && (compilerOptions.useDefineForClassFields || !isPropertyDeclaredInAncestorClass(prop))) {
            diagnosticMessage = error(right, ts3.Diagnostics.Property_0_is_used_before_its_initialization, declarationName);
          } else if (valueDeclaration.kind === 257 && node.parent.kind !== 178 && !(valueDeclaration.flags & 16777216) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right)) {
            diagnosticMessage = error(right, ts3.Diagnostics.Class_0_used_before_its_declaration, declarationName);
          }
          if (diagnosticMessage) {
            ts3.addRelatedInfo(diagnosticMessage, ts3.createDiagnosticForNode(valueDeclaration, ts3.Diagnostics._0_is_declared_here, declarationName));
          }
        }
        function isInPropertyInitializerOrClassStaticBlock(node) {
          return !!ts3.findAncestor(node, function(node2) {
            switch (node2.kind) {
              case 167:
                return true;
              case 296:
              case 169:
              case 172:
              case 173:
              case 298:
              case 162:
              case 233:
              case 288:
              case 285:
              case 286:
              case 287:
              case 280:
              case 228:
              case 291:
                return false;
              case 214:
              case 238:
                return ts3.isBlock(node2.parent) && ts3.isClassStaticBlockDeclaration(node2.parent.parent) ? true : "quit";
              default:
                return ts3.isExpressionNode(node2) ? false : "quit";
            }
          });
        }
        function isPropertyDeclaredInAncestorClass(prop) {
          if (!(prop.parent.flags & 32)) {
            return false;
          }
          var classType = getTypeOfSymbol(prop.parent);
          while (true) {
            classType = classType.symbol && getSuperClass(classType);
            if (!classType) {
              return false;
            }
            var superProperty = getPropertyOfType(classType, prop.escapedName);
            if (superProperty && superProperty.valueDeclaration) {
              return true;
            }
          }
        }
        function getSuperClass(classType) {
          var x = getBaseTypes(classType);
          if (x.length === 0) {
            return void 0;
          }
          return getIntersectionType(x);
        }
        function reportNonexistentProperty(propNode, containingType, isUncheckedJS) {
          var errorInfo;
          var relatedInfo;
          if (!ts3.isPrivateIdentifier(propNode) && containingType.flags & 1048576 && !(containingType.flags & 131068)) {
            for (var _i = 0, _a = containingType.types; _i < _a.length; _i++) {
              var subtype = _a[_i];
              if (!getPropertyOfType(subtype, propNode.escapedText) && !getApplicableIndexInfoForName(subtype, propNode.escapedText)) {
                errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.declarationNameToString(propNode), typeToString(subtype));
                break;
              }
            }
          }
          if (typeHasStaticProperty(propNode.escapedText, containingType)) {
            var propName = ts3.declarationNameToString(propNode);
            var typeName = typeToString(containingType);
            errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, propName, typeName, typeName + "." + propName);
          } else {
            var promisedType = getPromisedTypeOfPromise(containingType);
            if (promisedType && getPropertyOfType(promisedType, propNode.escapedText)) {
              errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.declarationNameToString(propNode), typeToString(containingType));
              relatedInfo = ts3.createDiagnosticForNode(propNode, ts3.Diagnostics.Did_you_forget_to_use_await);
            } else {
              var missingProperty = ts3.declarationNameToString(propNode);
              var container = typeToString(containingType);
              var libSuggestion = getSuggestedLibForNonExistentProperty(missingProperty, containingType);
              if (libSuggestion !== void 0) {
                errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later, missingProperty, container, libSuggestion);
              } else {
                var suggestion = getSuggestedSymbolForNonexistentProperty(propNode, containingType);
                if (suggestion !== void 0) {
                  var suggestedName = ts3.symbolName(suggestion);
                  var message = isUncheckedJS ? ts3.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2 : ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2;
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, message, missingProperty, container, suggestedName);
                  relatedInfo = suggestion.valueDeclaration && ts3.createDiagnosticForNode(suggestion.valueDeclaration, ts3.Diagnostics._0_is_declared_here, suggestedName);
                } else {
                  var diagnostic = containerSeemsToBeEmptyDomElement(containingType) ? ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom : ts3.Diagnostics.Property_0_does_not_exist_on_type_1;
                  errorInfo = ts3.chainDiagnosticMessages(elaborateNeverIntersection(errorInfo, containingType), diagnostic, missingProperty, container);
                }
              }
            }
          }
          var resultDiagnostic = ts3.createDiagnosticForNodeFromMessageChain(propNode, errorInfo);
          if (relatedInfo) {
            ts3.addRelatedInfo(resultDiagnostic, relatedInfo);
          }
          addErrorOrSuggestion(!isUncheckedJS || errorInfo.code !== ts3.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code, resultDiagnostic);
        }
        function containerSeemsToBeEmptyDomElement(containingType) {
          return compilerOptions.lib && !compilerOptions.lib.includes("dom") && everyContainedType(containingType, function(type2) {
            return type2.symbol && /^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(ts3.unescapeLeadingUnderscores(type2.symbol.escapedName));
          }) && isEmptyObjectType(containingType);
        }
        function typeHasStaticProperty(propName, containingType) {
          var prop = containingType.symbol && getPropertyOfType(getTypeOfSymbol(containingType.symbol), propName);
          return prop !== void 0 && !!prop.valueDeclaration && ts3.isStatic(prop.valueDeclaration);
        }
        function getSuggestedLibForNonExistentName(name) {
          var missingName = diagnosticName(name);
          var allFeatures = ts3.getScriptTargetFeatures();
          var libTargets = ts3.getOwnKeys(allFeatures);
          for (var _i = 0, libTargets_1 = libTargets; _i < libTargets_1.length; _i++) {
            var libTarget = libTargets_1[_i];
            var containingTypes = ts3.getOwnKeys(allFeatures[libTarget]);
            if (containingTypes !== void 0 && ts3.contains(containingTypes, missingName)) {
              return libTarget;
            }
          }
        }
        function getSuggestedLibForNonExistentProperty(missingProperty, containingType) {
          var container = getApparentType(containingType).symbol;
          if (!container) {
            return void 0;
          }
          var allFeatures = ts3.getScriptTargetFeatures();
          var libTargets = ts3.getOwnKeys(allFeatures);
          for (var _i = 0, libTargets_2 = libTargets; _i < libTargets_2.length; _i++) {
            var libTarget = libTargets_2[_i];
            var featuresOfLib = allFeatures[libTarget];
            var featuresOfContainingType = featuresOfLib[ts3.symbolName(container)];
            if (featuresOfContainingType !== void 0 && ts3.contains(featuresOfContainingType, missingProperty)) {
              return libTarget;
            }
          }
        }
        function getSuggestedSymbolForNonexistentClassMember(name, baseType) {
          return getSpellingSuggestionForName(name, getPropertiesOfType(baseType), 106500);
        }
        function getSuggestedSymbolForNonexistentProperty(name, containingType) {
          var props = getPropertiesOfType(containingType);
          if (typeof name !== "string") {
            var parent_2 = name.parent;
            if (ts3.isPropertyAccessExpression(parent_2)) {
              props = ts3.filter(props, function(prop) {
                return isValidPropertyAccessForCompletions(parent_2, containingType, prop);
              });
            }
            name = ts3.idText(name);
          }
          return getSpellingSuggestionForName(name, props, 111551);
        }
        function getSuggestedSymbolForNonexistentJSXAttribute(name, containingType) {
          var strName = ts3.isString(name) ? name : ts3.idText(name);
          var properties = getPropertiesOfType(containingType);
          var jsxSpecific = strName === "for" ? ts3.find(properties, function(x) {
            return ts3.symbolName(x) === "htmlFor";
          }) : strName === "class" ? ts3.find(properties, function(x) {
            return ts3.symbolName(x) === "className";
          }) : void 0;
          return jsxSpecific !== null && jsxSpecific !== void 0 ? jsxSpecific : getSpellingSuggestionForName(strName, properties, 111551);
        }
        function getSuggestionForNonexistentProperty(name, containingType) {
          var suggestion = getSuggestedSymbolForNonexistentProperty(name, containingType);
          return suggestion && ts3.symbolName(suggestion);
        }
        function getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning) {
          ts3.Debug.assert(outerName !== void 0, "outername should always be defined");
          var result2 = resolveNameHelper(location, outerName, meaning, void 0, outerName, false, false, true, function(symbols, name, meaning2) {
            ts3.Debug.assertEqual(outerName, name, "name should equal outerName");
            var symbol = getSymbol(symbols, name, meaning2);
            if (symbol)
              return symbol;
            var candidates;
            if (symbols === globals) {
              var primitives = ts3.mapDefined(["string", "number", "boolean", "object", "bigint", "symbol"], function(s) {
                return symbols.has(s.charAt(0).toUpperCase() + s.slice(1)) ? createSymbol(524288, s) : void 0;
              });
              candidates = primitives.concat(ts3.arrayFrom(symbols.values()));
            } else {
              candidates = ts3.arrayFrom(symbols.values());
            }
            return getSpellingSuggestionForName(ts3.unescapeLeadingUnderscores(name), candidates, meaning2);
          });
          return result2;
        }
        function getSuggestionForNonexistentSymbol(location, outerName, meaning) {
          var symbolResult = getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning);
          return symbolResult && ts3.symbolName(symbolResult);
        }
        function getSuggestedSymbolForNonexistentModule(name, targetModule) {
          return targetModule.exports && getSpellingSuggestionForName(ts3.idText(name), getExportsOfModuleAsArray(targetModule), 2623475);
        }
        function getSuggestionForNonexistentExport(name, targetModule) {
          var suggestion = getSuggestedSymbolForNonexistentModule(name, targetModule);
          return suggestion && ts3.symbolName(suggestion);
        }
        function getSuggestionForNonexistentIndexSignature(objectType, expr, keyedType) {
          function hasProp(name) {
            var prop = getPropertyOfObjectType(objectType, name);
            if (prop) {
              var s = getSingleCallSignature(getTypeOfSymbol(prop));
              return !!s && getMinArgumentCount(s) >= 1 && isTypeAssignableTo(keyedType, getTypeAtPosition(s, 0));
            }
            return false;
          }
          ;
          var suggestedMethod = ts3.isAssignmentTarget(expr) ? "set" : "get";
          if (!hasProp(suggestedMethod)) {
            return void 0;
          }
          var suggestion = ts3.tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (suggestion === void 0) {
            suggestion = suggestedMethod;
          } else {
            suggestion += "." + suggestedMethod;
          }
          return suggestion;
        }
        function getSuggestedTypeForNonexistentStringLiteralType(source, target) {
          var candidates = target.types.filter(function(type2) {
            return !!(type2.flags & 128);
          });
          return ts3.getSpellingSuggestion(source.value, candidates, function(type2) {
            return type2.value;
          });
        }
        function getSpellingSuggestionForName(name, symbols, meaning) {
          return ts3.getSpellingSuggestion(name, symbols, getCandidateName);
          function getCandidateName(candidate) {
            var candidateName = ts3.symbolName(candidate);
            if (ts3.startsWith(candidateName, '"')) {
              return void 0;
            }
            if (candidate.flags & meaning) {
              return candidateName;
            }
            if (candidate.flags & 2097152) {
              var alias = tryResolveAlias(candidate);
              if (alias && alias.flags & meaning) {
                return candidateName;
              }
            }
            return void 0;
          }
        }
        function markPropertyAsReferenced(prop, nodeForCheckWriteOnly, isSelfTypeAccess2) {
          var valueDeclaration = prop && prop.flags & 106500 && prop.valueDeclaration;
          if (!valueDeclaration) {
            return;
          }
          var hasPrivateModifier = ts3.hasEffectiveModifier(valueDeclaration, 8);
          var hasPrivateIdentifier = prop.valueDeclaration && ts3.isNamedDeclaration(prop.valueDeclaration) && ts3.isPrivateIdentifier(prop.valueDeclaration.name);
          if (!hasPrivateModifier && !hasPrivateIdentifier) {
            return;
          }
          if (nodeForCheckWriteOnly && ts3.isWriteOnlyAccess(nodeForCheckWriteOnly) && !(prop.flags & 65536)) {
            return;
          }
          if (isSelfTypeAccess2) {
            var containingMethod = ts3.findAncestor(nodeForCheckWriteOnly, ts3.isFunctionLikeDeclaration);
            if (containingMethod && containingMethod.symbol === prop) {
              return;
            }
          }
          (ts3.getCheckFlags(prop) & 1 ? getSymbolLinks(prop).target : prop).isReferenced = 67108863;
        }
        function isSelfTypeAccess(name, parent) {
          return name.kind === 108 || !!parent && ts3.isEntityNameExpression(name) && parent === getResolvedSymbol(ts3.getFirstIdentifier(name));
        }
        function isValidPropertyAccess(node, propertyName) {
          switch (node.kind) {
            case 206:
              return isValidPropertyAccessWithType(node, node.expression.kind === 106, propertyName, getWidenedType(checkExpression(node.expression)));
            case 161:
              return isValidPropertyAccessWithType(node, false, propertyName, getWidenedType(checkExpression(node.left)));
            case 200:
              return isValidPropertyAccessWithType(node, false, propertyName, getTypeFromTypeNode(node));
          }
        }
        function isValidPropertyAccessForCompletions(node, type2, property) {
          return isPropertyAccessible(node, node.kind === 206 && node.expression.kind === 106, false, type2, property);
        }
        function isValidPropertyAccessWithType(node, isSuper, propertyName, type2) {
          if (isTypeAny(type2)) {
            return true;
          }
          var prop = getPropertyOfType(type2, propertyName);
          return !!prop && isPropertyAccessible(node, isSuper, false, type2, prop);
        }
        function isPropertyAccessible(node, isSuper, isWrite, containingType, property) {
          if (isTypeAny(containingType)) {
            return true;
          }
          if (property.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(property.valueDeclaration)) {
            var declClass_1 = ts3.getContainingClass(property.valueDeclaration);
            return !ts3.isOptionalChain(node) && !!ts3.findAncestor(node, function(parent) {
              return parent === declClass_1;
            });
          }
          return checkPropertyAccessibilityAtLocation(node, isSuper, isWrite, containingType, property);
        }
        function getForInVariableSymbol(node) {
          var initializer = node.initializer;
          if (initializer.kind === 255) {
            var variable = initializer.declarations[0];
            if (variable && !ts3.isBindingPattern(variable.name)) {
              return getSymbolOfNode(variable);
            }
          } else if (initializer.kind === 79) {
            return getResolvedSymbol(initializer);
          }
          return void 0;
        }
        function hasNumericPropertyNames(type2) {
          return getIndexInfosOfType(type2).length === 1 && !!getIndexInfoOfType(type2, numberType);
        }
        function isForInVariableForNumericPropertyNames(expr) {
          var e = ts3.skipParentheses(expr);
          if (e.kind === 79) {
            var symbol = getResolvedSymbol(e);
            if (symbol.flags & 3) {
              var child = expr;
              var node = expr.parent;
              while (node) {
                if (node.kind === 243 && child === node.statement && getForInVariableSymbol(node) === symbol && hasNumericPropertyNames(getTypeOfExpression(node.expression))) {
                  return true;
                }
                child = node;
                node = node.parent;
              }
            }
          }
          return false;
        }
        function checkIndexedAccess(node, checkMode) {
          return node.flags & 32 ? checkElementAccessChain(node, checkMode) : checkElementAccessExpression(node, checkNonNullExpression(node.expression), checkMode);
        }
        function checkElementAccessChain(node, checkMode) {
          var exprType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(exprType, node.expression);
          return propagateOptionalTypeMarker(checkElementAccessExpression(node, checkNonNullType(nonOptionalType, node.expression), checkMode), node, nonOptionalType !== exprType);
        }
        function checkElementAccessExpression(node, exprType, checkMode) {
          var objectType = ts3.getAssignmentTargetKind(node) !== 0 || isMethodAccessForCall(node) ? getWidenedType(exprType) : exprType;
          var indexExpression = node.argumentExpression;
          var indexType = checkExpression(indexExpression);
          if (isErrorType(objectType) || objectType === silentNeverType) {
            return objectType;
          }
          if (isConstEnumObjectType(objectType) && !ts3.isStringLiteralLike(indexExpression)) {
            error(indexExpression, ts3.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal);
            return errorType;
          }
          var effectiveIndexType = isForInVariableForNumericPropertyNames(indexExpression) ? numberType : indexType;
          var accessFlags = ts3.isAssignmentTarget(node) ? 4 | (isGenericObjectType(objectType) && !ts3.isThisTypeParameter(objectType) ? 2 : 0) : 32;
          var indexedAccessType = getIndexedAccessTypeOrUndefined(objectType, effectiveIndexType, accessFlags, node) || errorType;
          return checkIndexedAccessIndexType(getFlowTypeOfAccessExpression(node, getNodeLinks(node).resolvedSymbol, indexedAccessType, indexExpression, checkMode), node);
        }
        function callLikeExpressionMayHaveTypeArguments(node) {
          return ts3.isCallOrNewExpression(node) || ts3.isTaggedTemplateExpression(node) || ts3.isJsxOpeningLikeElement(node);
        }
        function resolveUntypedCall(node) {
          if (callLikeExpressionMayHaveTypeArguments(node)) {
            ts3.forEach(node.typeArguments, checkSourceElement);
          }
          if (node.kind === 210) {
            checkExpression(node.template);
          } else if (ts3.isJsxOpeningLikeElement(node)) {
            checkExpression(node.attributes);
          } else if (node.kind !== 165) {
            ts3.forEach(node.arguments, function(argument) {
              checkExpression(argument);
            });
          }
          return anySignature;
        }
        function resolveErrorCall(node) {
          resolveUntypedCall(node);
          return unknownSignature;
        }
        function reorderCandidates(signatures, result2, callChainFlags) {
          var lastParent;
          var lastSymbol;
          var cutoffIndex = 0;
          var index;
          var specializedIndex = -1;
          var spliceIndex;
          ts3.Debug.assert(!result2.length);
          for (var _i = 0, signatures_7 = signatures; _i < signatures_7.length; _i++) {
            var signature = signatures_7[_i];
            var symbol = signature.declaration && getSymbolOfNode(signature.declaration);
            var parent = signature.declaration && signature.declaration.parent;
            if (!lastSymbol || symbol === lastSymbol) {
              if (lastParent && parent === lastParent) {
                index = index + 1;
              } else {
                lastParent = parent;
                index = cutoffIndex;
              }
            } else {
              index = cutoffIndex = result2.length;
              lastParent = parent;
            }
            lastSymbol = symbol;
            if (signatureHasLiteralTypes(signature)) {
              specializedIndex++;
              spliceIndex = specializedIndex;
              cutoffIndex++;
            } else {
              spliceIndex = index;
            }
            result2.splice(spliceIndex, 0, callChainFlags ? getOptionalCallSignature(signature, callChainFlags) : signature);
          }
        }
        function isSpreadArgument(arg) {
          return !!arg && (arg.kind === 225 || arg.kind === 232 && arg.isSpread);
        }
        function getSpreadArgumentIndex(args) {
          return ts3.findIndex(args, isSpreadArgument);
        }
        function acceptsVoid(t) {
          return !!(t.flags & 16384);
        }
        function acceptsVoidUndefinedUnknownOrAny(t) {
          return !!(t.flags & (16384 | 32768 | 2 | 1));
        }
        function hasCorrectArity(node, args, signature, signatureHelpTrailingComma) {
          if (signatureHelpTrailingComma === void 0) {
            signatureHelpTrailingComma = false;
          }
          var argCount;
          var callIsIncomplete = false;
          var effectiveParameterCount = getParameterCount(signature);
          var effectiveMinimumArguments = getMinArgumentCount(signature);
          if (node.kind === 210) {
            argCount = args.length;
            if (node.template.kind === 223) {
              var lastSpan = ts3.last(node.template.templateSpans);
              callIsIncomplete = ts3.nodeIsMissing(lastSpan.literal) || !!lastSpan.literal.isUnterminated;
            } else {
              var templateLiteral = node.template;
              ts3.Debug.assert(templateLiteral.kind === 14);
              callIsIncomplete = !!templateLiteral.isUnterminated;
            }
          } else if (node.kind === 165) {
            argCount = getDecoratorArgumentCount(node, signature);
          } else if (ts3.isJsxOpeningLikeElement(node)) {
            callIsIncomplete = node.attributes.end === node.end;
            if (callIsIncomplete) {
              return true;
            }
            argCount = effectiveMinimumArguments === 0 ? args.length : 1;
            effectiveParameterCount = args.length === 0 ? effectiveParameterCount : 1;
            effectiveMinimumArguments = Math.min(effectiveMinimumArguments, 1);
          } else if (!node.arguments) {
            ts3.Debug.assert(node.kind === 209);
            return getMinArgumentCount(signature) === 0;
          } else {
            argCount = signatureHelpTrailingComma ? args.length + 1 : args.length;
            callIsIncomplete = node.arguments.end === node.end;
            var spreadArgIndex = getSpreadArgumentIndex(args);
            if (spreadArgIndex >= 0) {
              return spreadArgIndex >= getMinArgumentCount(signature) && (hasEffectiveRestParameter(signature) || spreadArgIndex < getParameterCount(signature));
            }
          }
          if (!hasEffectiveRestParameter(signature) && argCount > effectiveParameterCount) {
            return false;
          }
          if (callIsIncomplete || argCount >= effectiveMinimumArguments) {
            return true;
          }
          for (var i = argCount; i < effectiveMinimumArguments; i++) {
            var type2 = getTypeAtPosition(signature, i);
            if (filterType(type2, ts3.isInJSFile(node) && !strictNullChecks ? acceptsVoidUndefinedUnknownOrAny : acceptsVoid).flags & 131072) {
              return false;
            }
          }
          return true;
        }
        function hasCorrectTypeArgumentArity(signature, typeArguments) {
          var numTypeParameters = ts3.length(signature.typeParameters);
          var minTypeArgumentCount = getMinTypeArgumentCount(signature.typeParameters);
          return !ts3.some(typeArguments) || typeArguments.length >= minTypeArgumentCount && typeArguments.length <= numTypeParameters;
        }
        function getSingleCallSignature(type2) {
          return getSingleSignature(type2, 0, false);
        }
        function getSingleCallOrConstructSignature(type2) {
          return getSingleSignature(type2, 0, false) || getSingleSignature(type2, 1, false);
        }
        function getSingleSignature(type2, kind, allowMembers) {
          if (type2.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type2);
            if (allowMembers || resolved.properties.length === 0 && resolved.indexInfos.length === 0) {
              if (kind === 0 && resolved.callSignatures.length === 1 && resolved.constructSignatures.length === 0) {
                return resolved.callSignatures[0];
              }
              if (kind === 1 && resolved.constructSignatures.length === 1 && resolved.callSignatures.length === 0) {
                return resolved.constructSignatures[0];
              }
            }
          }
          return void 0;
        }
        function instantiateSignatureInContextOf(signature, contextualSignature, inferenceContext, compareTypes) {
          var context = createInferenceContext(signature.typeParameters, signature, 0, compareTypes);
          var restType = getEffectiveRestType(contextualSignature);
          var mapper = inferenceContext && (restType && restType.flags & 262144 ? inferenceContext.nonFixingMapper : inferenceContext.mapper);
          var sourceSignature = mapper ? instantiateSignature(contextualSignature, mapper) : contextualSignature;
          applyToParameterTypes(sourceSignature, signature, function(source, target) {
            inferTypes(context.inferences, source, target);
          });
          if (!inferenceContext) {
            applyToReturnTypes(contextualSignature, signature, function(source, target) {
              inferTypes(context.inferences, source, target, 128);
            });
          }
          return getSignatureInstantiation(signature, getInferredTypes(context), ts3.isInJSFile(contextualSignature.declaration));
        }
        function inferJsxTypeArguments(node, signature, checkMode, context) {
          var paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
          var checkAttrType = checkExpressionWithContextualType(node.attributes, paramType, context, checkMode);
          inferTypes(context.inferences, checkAttrType, paramType);
          return getInferredTypes(context);
        }
        function getThisArgumentType(thisArgumentNode) {
          if (!thisArgumentNode) {
            return voidType;
          }
          var thisArgumentType = checkExpression(thisArgumentNode);
          return ts3.isOptionalChainRoot(thisArgumentNode.parent) ? getNonNullableType(thisArgumentType) : ts3.isOptionalChain(thisArgumentNode.parent) ? removeOptionalTypeMarker(thisArgumentType) : thisArgumentType;
        }
        function inferTypeArguments(node, signature, args, checkMode, context) {
          if (ts3.isJsxOpeningLikeElement(node)) {
            return inferJsxTypeArguments(node, signature, checkMode, context);
          }
          if (node.kind !== 165) {
            var contextualType = getContextualType(node, ts3.every(signature.typeParameters, function(p) {
              return !!getDefaultFromTypeParameter(p);
            }) ? 8 : 0);
            if (contextualType) {
              var inferenceTargetType = getReturnTypeOfSignature(signature);
              if (couldContainTypeVariables(inferenceTargetType)) {
                var outerContext = getInferenceContext(node);
                var outerMapper = getMapperFromContext(cloneInferenceContext(outerContext, 1));
                var instantiatedType = instantiateType(contextualType, outerMapper);
                var contextualSignature = getSingleCallSignature(instantiatedType);
                var inferenceSourceType = contextualSignature && contextualSignature.typeParameters ? getOrCreateTypeFromSignature(getSignatureInstantiationWithoutFillingInTypeArguments(contextualSignature, contextualSignature.typeParameters)) : instantiatedType;
                inferTypes(context.inferences, inferenceSourceType, inferenceTargetType, 128);
                var returnContext = createInferenceContext(signature.typeParameters, signature, context.flags);
                var returnSourceType = instantiateType(contextualType, outerContext && outerContext.returnMapper);
                inferTypes(returnContext.inferences, returnSourceType, inferenceTargetType);
                context.returnMapper = ts3.some(returnContext.inferences, hasInferenceCandidates) ? getMapperFromContext(cloneInferredPartOfContext(returnContext)) : void 0;
              }
            }
          }
          var restType = getNonArrayRestType(signature);
          var argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
          if (restType && restType.flags & 262144) {
            var info = ts3.find(context.inferences, function(info2) {
              return info2.typeParameter === restType;
            });
            if (info) {
              info.impliedArity = ts3.findIndex(args, isSpreadArgument, argCount) < 0 ? args.length - argCount : void 0;
            }
          }
          var thisType = getThisTypeOfSignature(signature);
          if (thisType && couldContainTypeVariables(thisType)) {
            var thisArgumentNode = getThisArgumentOfCall(node);
            inferTypes(context.inferences, getThisArgumentType(thisArgumentNode), thisType);
          }
          for (var i = 0; i < argCount; i++) {
            var arg = args[i];
            if (arg.kind !== 227 && !(checkMode & 32 && hasSkipDirectInferenceFlag(arg))) {
              var paramType = getTypeAtPosition(signature, i);
              if (couldContainTypeVariables(paramType)) {
                var argType = checkExpressionWithContextualType(arg, paramType, context, checkMode);
                inferTypes(context.inferences, argType, paramType);
              }
            }
          }
          if (restType && couldContainTypeVariables(restType)) {
            var spreadType = getSpreadArgumentType(args, argCount, args.length, restType, context, checkMode);
            inferTypes(context.inferences, spreadType, restType);
          }
          return getInferredTypes(context);
        }
        function getMutableArrayOrTupleType(type2) {
          return type2.flags & 1048576 ? mapType(type2, getMutableArrayOrTupleType) : type2.flags & 1 || isMutableArrayOrTuple(getBaseConstraintOfType(type2) || type2) ? type2 : isTupleType(type2) ? createTupleType(getTypeArguments(type2), type2.target.elementFlags, false, type2.target.labeledElementDeclarations) : createTupleType([type2], [8]);
        }
        function getSpreadArgumentType(args, index, argCount, restType, context, checkMode) {
          if (index >= argCount - 1) {
            var arg = args[argCount - 1];
            if (isSpreadArgument(arg)) {
              return getMutableArrayOrTupleType(arg.kind === 232 ? arg.type : checkExpressionWithContextualType(arg.expression, restType, context, checkMode));
            }
          }
          var types2 = [];
          var flags = [];
          var names = [];
          for (var i = index; i < argCount; i++) {
            var arg = args[i];
            if (isSpreadArgument(arg)) {
              var spreadType = arg.kind === 232 ? arg.type : checkExpression(arg.expression);
              if (isArrayLikeType(spreadType)) {
                types2.push(spreadType);
                flags.push(8);
              } else {
                types2.push(checkIteratedTypeOrElementType(33, spreadType, undefinedType, arg.kind === 225 ? arg.expression : arg));
                flags.push(4);
              }
            } else {
              var contextualType = getIndexedAccessType(restType, getNumberLiteralType(i - index), 256);
              var argType = checkExpressionWithContextualType(arg, contextualType, context, checkMode);
              var hasPrimitiveContextualType = maybeTypeOfKind(contextualType, 131068 | 4194304 | 134217728 | 268435456);
              types2.push(hasPrimitiveContextualType ? getRegularTypeOfLiteralType(argType) : getWidenedLiteralType(argType));
              flags.push(1);
            }
            if (arg.kind === 232 && arg.tupleNameSource) {
              names.push(arg.tupleNameSource);
            }
          }
          return createTupleType(types2, flags, false, ts3.length(names) === ts3.length(types2) ? names : void 0);
        }
        function checkTypeArguments(signature, typeArgumentNodes, reportErrors, headMessage) {
          var isJavascript = ts3.isInJSFile(signature.declaration);
          var typeParameters = signature.typeParameters;
          var typeArgumentTypes = fillMissingTypeArguments(ts3.map(typeArgumentNodes, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), isJavascript);
          var mapper;
          for (var i = 0; i < typeArgumentNodes.length; i++) {
            ts3.Debug.assert(typeParameters[i] !== void 0, "Should not call checkTypeArguments with too many type arguments");
            var constraint = getConstraintOfTypeParameter(typeParameters[i]);
            if (constraint) {
              var errorInfo = reportErrors && headMessage ? function() {
                return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
              } : void 0;
              var typeArgumentHeadMessage = headMessage || ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;
              if (!mapper) {
                mapper = createTypeMapper(typeParameters, typeArgumentTypes);
              }
              var typeArgument = typeArgumentTypes[i];
              if (!checkTypeAssignableTo(typeArgument, getTypeWithThisArgument(instantiateType(constraint, mapper), typeArgument), reportErrors ? typeArgumentNodes[i] : void 0, typeArgumentHeadMessage, errorInfo)) {
                return void 0;
              }
            }
          }
          return typeArgumentTypes;
        }
        function getJsxReferenceKind(node) {
          if (isJsxIntrinsicIdentifier(node.tagName)) {
            return 2;
          }
          var tagType = getApparentType(checkExpression(node.tagName));
          if (ts3.length(getSignaturesOfType(tagType, 1))) {
            return 0;
          }
          if (ts3.length(getSignaturesOfType(tagType, 0))) {
            return 1;
          }
          return 2;
        }
        function checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors, containingMessageChain, errorOutputContainer) {
          var paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
          var attributesType = checkExpressionWithContextualType(node.attributes, paramType, void 0, checkMode);
          return checkTagNameDoesNotExpectTooManyArguments() && checkTypeRelatedToAndOptionallyElaborate(attributesType, paramType, relation, reportErrors ? node.tagName : void 0, node.attributes, void 0, containingMessageChain, errorOutputContainer);
          function checkTagNameDoesNotExpectTooManyArguments() {
            var _a;
            if (getJsxNamespaceContainerForImplicitImport(node)) {
              return true;
            }
            var tagType = ts3.isJsxOpeningElement(node) || ts3.isJsxSelfClosingElement(node) && !isJsxIntrinsicIdentifier(node.tagName) ? checkExpression(node.tagName) : void 0;
            if (!tagType) {
              return true;
            }
            var tagCallSignatures = getSignaturesOfType(tagType, 0);
            if (!ts3.length(tagCallSignatures)) {
              return true;
            }
            var factory = getJsxFactoryEntity(node);
            if (!factory) {
              return true;
            }
            var factorySymbol = resolveEntityName(factory, 111551, true, false, node);
            if (!factorySymbol) {
              return true;
            }
            var factoryType = getTypeOfSymbol(factorySymbol);
            var callSignatures = getSignaturesOfType(factoryType, 0);
            if (!ts3.length(callSignatures)) {
              return true;
            }
            var hasFirstParamSignatures = false;
            var maxParamCount = 0;
            for (var _i = 0, callSignatures_1 = callSignatures; _i < callSignatures_1.length; _i++) {
              var sig = callSignatures_1[_i];
              var firstparam = getTypeAtPosition(sig, 0);
              var signaturesOfParam = getSignaturesOfType(firstparam, 0);
              if (!ts3.length(signaturesOfParam))
                continue;
              for (var _b = 0, signaturesOfParam_1 = signaturesOfParam; _b < signaturesOfParam_1.length; _b++) {
                var paramSig = signaturesOfParam_1[_b];
                hasFirstParamSignatures = true;
                if (hasEffectiveRestParameter(paramSig)) {
                  return true;
                }
                var paramCount = getParameterCount(paramSig);
                if (paramCount > maxParamCount) {
                  maxParamCount = paramCount;
                }
              }
            }
            if (!hasFirstParamSignatures) {
              return true;
            }
            var absoluteMinArgCount = Infinity;
            for (var _c = 0, tagCallSignatures_1 = tagCallSignatures; _c < tagCallSignatures_1.length; _c++) {
              var tagSig = tagCallSignatures_1[_c];
              var tagRequiredArgCount = getMinArgumentCount(tagSig);
              if (tagRequiredArgCount < absoluteMinArgCount) {
                absoluteMinArgCount = tagRequiredArgCount;
              }
            }
            if (absoluteMinArgCount <= maxParamCount) {
              return true;
            }
            if (reportErrors) {
              var diag = ts3.createDiagnosticForNode(node.tagName, ts3.Diagnostics.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3, ts3.entityNameToString(node.tagName), absoluteMinArgCount, ts3.entityNameToString(factory), maxParamCount);
              var tagNameDeclaration = (_a = getSymbolAtLocation(node.tagName)) === null || _a === void 0 ? void 0 : _a.valueDeclaration;
              if (tagNameDeclaration) {
                ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(tagNameDeclaration, ts3.Diagnostics._0_is_declared_here, ts3.entityNameToString(node.tagName)));
              }
              if (errorOutputContainer && errorOutputContainer.skipLogging) {
                (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
              }
              if (!errorOutputContainer.skipLogging) {
                diagnostics.add(diag);
              }
            }
            return false;
          }
        }
        function getSignatureApplicabilityError(node, args, signature, relation, checkMode, reportErrors, containingMessageChain) {
          var errorOutputContainer = { errors: void 0, skipLogging: true };
          if (ts3.isJsxOpeningLikeElement(node)) {
            if (!checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors, containingMessageChain, errorOutputContainer)) {
              ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "jsx should have errors when reporting errors");
              return errorOutputContainer.errors || ts3.emptyArray;
            }
            return void 0;
          }
          var thisType = getThisTypeOfSignature(signature);
          if (thisType && thisType !== voidType && node.kind !== 209) {
            var thisArgumentNode = getThisArgumentOfCall(node);
            var thisArgumentType = getThisArgumentType(thisArgumentNode);
            var errorNode = reportErrors ? thisArgumentNode || node : void 0;
            var headMessage_1 = ts3.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;
            if (!checkTypeRelatedTo(thisArgumentType, thisType, relation, errorNode, headMessage_1, containingMessageChain, errorOutputContainer)) {
              ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "this parameter should have errors when reporting errors");
              return errorOutputContainer.errors || ts3.emptyArray;
            }
          }
          var headMessage = ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1;
          var restType = getNonArrayRestType(signature);
          var argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
          for (var i = 0; i < argCount; i++) {
            var arg = args[i];
            if (arg.kind !== 227) {
              var paramType = getTypeAtPosition(signature, i);
              var argType = checkExpressionWithContextualType(arg, paramType, void 0, checkMode);
              var checkArgType = checkMode & 4 ? getRegularTypeOfObjectLiteral(argType) : argType;
              if (!checkTypeRelatedToAndOptionallyElaborate(checkArgType, paramType, relation, reportErrors ? arg : void 0, arg, headMessage, containingMessageChain, errorOutputContainer)) {
                ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "parameter should have errors when reporting errors");
                maybeAddMissingAwaitInfo(arg, checkArgType, paramType);
                return errorOutputContainer.errors || ts3.emptyArray;
              }
            }
          }
          if (restType) {
            var spreadType = getSpreadArgumentType(args, argCount, args.length, restType, void 0, checkMode);
            var restArgCount = args.length - argCount;
            var errorNode = !reportErrors ? void 0 : restArgCount === 0 ? node : restArgCount === 1 ? args[argCount] : ts3.setTextRangePosEnd(createSyntheticExpression(node, spreadType), args[argCount].pos, args[args.length - 1].end);
            if (!checkTypeRelatedTo(spreadType, restType, relation, errorNode, headMessage, void 0, errorOutputContainer)) {
              ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "rest parameter should have errors when reporting errors");
              maybeAddMissingAwaitInfo(errorNode, spreadType, restType);
              return errorOutputContainer.errors || ts3.emptyArray;
            }
          }
          return void 0;
          function maybeAddMissingAwaitInfo(errorNode2, source, target) {
            if (errorNode2 && reportErrors && errorOutputContainer.errors && errorOutputContainer.errors.length) {
              if (getAwaitedTypeOfPromise(target)) {
                return;
              }
              var awaitedTypeOfSource = getAwaitedTypeOfPromise(source);
              if (awaitedTypeOfSource && isTypeRelatedTo(awaitedTypeOfSource, target, relation)) {
                ts3.addRelatedInfo(errorOutputContainer.errors[0], ts3.createDiagnosticForNode(errorNode2, ts3.Diagnostics.Did_you_forget_to_use_await));
              }
            }
          }
        }
        function getThisArgumentOfCall(node) {
          var expression = node.kind === 208 ? node.expression : node.kind === 210 ? node.tag : void 0;
          if (expression) {
            var callee = ts3.skipOuterExpressions(expression);
            if (ts3.isAccessExpression(callee)) {
              return callee.expression;
            }
          }
        }
        function createSyntheticExpression(parent, type2, isSpread, tupleNameSource) {
          var result2 = ts3.parseNodeFactory.createSyntheticExpression(type2, isSpread, tupleNameSource);
          ts3.setTextRange(result2, parent);
          ts3.setParent(result2, parent);
          return result2;
        }
        function getEffectiveCallArguments(node) {
          if (node.kind === 210) {
            var template = node.template;
            var args_3 = [createSyntheticExpression(template, getGlobalTemplateStringsArrayType())];
            if (template.kind === 223) {
              ts3.forEach(template.templateSpans, function(span) {
                args_3.push(span.expression);
              });
            }
            return args_3;
          }
          if (node.kind === 165) {
            return getEffectiveDecoratorArguments(node);
          }
          if (ts3.isJsxOpeningLikeElement(node)) {
            return node.attributes.properties.length > 0 || ts3.isJsxOpeningElement(node) && node.parent.children.length > 0 ? [node.attributes] : ts3.emptyArray;
          }
          var args = node.arguments || ts3.emptyArray;
          var spreadIndex = getSpreadArgumentIndex(args);
          if (spreadIndex >= 0) {
            var effectiveArgs_1 = args.slice(0, spreadIndex);
            var _loop_24 = function(i2) {
              var arg = args[i2];
              var spreadType = arg.kind === 225 && (flowLoopCount ? checkExpression(arg.expression) : checkExpressionCached(arg.expression));
              if (spreadType && isTupleType(spreadType)) {
                ts3.forEach(getTypeArguments(spreadType), function(t, i3) {
                  var _a;
                  var flags = spreadType.target.elementFlags[i3];
                  var syntheticArg = createSyntheticExpression(arg, flags & 4 ? createArrayType(t) : t, !!(flags & 12), (_a = spreadType.target.labeledElementDeclarations) === null || _a === void 0 ? void 0 : _a[i3]);
                  effectiveArgs_1.push(syntheticArg);
                });
              } else {
                effectiveArgs_1.push(arg);
              }
            };
            for (var i = spreadIndex; i < args.length; i++) {
              _loop_24(i);
            }
            return effectiveArgs_1;
          }
          return args;
        }
        function getEffectiveDecoratorArguments(node) {
          var parent = node.parent;
          var expr = node.expression;
          switch (parent.kind) {
            case 257:
            case 226:
              return [
                createSyntheticExpression(expr, getTypeOfSymbol(getSymbolOfNode(parent)))
              ];
            case 164:
              var func = parent.parent;
              return [
                createSyntheticExpression(expr, parent.parent.kind === 171 ? getTypeOfSymbol(getSymbolOfNode(func)) : errorType),
                createSyntheticExpression(expr, anyType),
                createSyntheticExpression(expr, numberType)
              ];
            case 167:
            case 169:
            case 172:
            case 173:
              var hasPropDesc = parent.kind !== 167 && languageVersion !== 0;
              return [
                createSyntheticExpression(expr, getParentTypeOfClassElement(parent)),
                createSyntheticExpression(expr, getClassElementPropertyKeyType(parent)),
                createSyntheticExpression(expr, hasPropDesc ? createTypedPropertyDescriptorType(getTypeOfNode(parent)) : anyType)
              ];
          }
          return ts3.Debug.fail();
        }
        function getDecoratorArgumentCount(node, signature) {
          switch (node.parent.kind) {
            case 257:
            case 226:
              return 1;
            case 167:
              return 2;
            case 169:
            case 172:
            case 173:
              return languageVersion === 0 || signature.parameters.length <= 2 ? 2 : 3;
            case 164:
              return 3;
            default:
              return ts3.Debug.fail();
          }
        }
        function getDiagnosticSpanForCallNode(node, doNotIncludeArguments) {
          var start;
          var length;
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (ts3.isPropertyAccessExpression(node.expression)) {
            var nameSpan = ts3.getErrorSpanForNode(sourceFile, node.expression.name);
            start = nameSpan.start;
            length = doNotIncludeArguments ? nameSpan.length : node.end - start;
          } else {
            var expressionSpan = ts3.getErrorSpanForNode(sourceFile, node.expression);
            start = expressionSpan.start;
            length = doNotIncludeArguments ? expressionSpan.length : node.end - start;
          }
          return { start, length, sourceFile };
        }
        function getDiagnosticForCallNode(node, message, arg0, arg1, arg2, arg3) {
          if (ts3.isCallExpression(node)) {
            var _a = getDiagnosticSpanForCallNode(node), sourceFile = _a.sourceFile, start = _a.start, length_6 = _a.length;
            return ts3.createFileDiagnostic(sourceFile, start, length_6, message, arg0, arg1, arg2, arg3);
          } else {
            return ts3.createDiagnosticForNode(node, message, arg0, arg1, arg2, arg3);
          }
        }
        function isPromiseResolveArityError(node) {
          if (!ts3.isCallExpression(node) || !ts3.isIdentifier(node.expression))
            return false;
          var symbol = resolveName(node.expression, node.expression.escapedText, 111551, void 0, void 0, false);
          var decl = symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration;
          if (!decl || !ts3.isParameter(decl) || !ts3.isFunctionExpressionOrArrowFunction(decl.parent) || !ts3.isNewExpression(decl.parent.parent) || !ts3.isIdentifier(decl.parent.parent.expression)) {
            return false;
          }
          var globalPromiseSymbol = getGlobalPromiseConstructorSymbol(false);
          if (!globalPromiseSymbol)
            return false;
          var constructorSymbol = getSymbolAtLocation(decl.parent.parent.expression, true);
          return constructorSymbol === globalPromiseSymbol;
        }
        function getArgumentArityError(node, signatures, args) {
          var _a;
          var spreadIndex = getSpreadArgumentIndex(args);
          if (spreadIndex > -1) {
            return ts3.createDiagnosticForNode(args[spreadIndex], ts3.Diagnostics.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);
          }
          var min = Number.POSITIVE_INFINITY;
          var max = Number.NEGATIVE_INFINITY;
          var maxBelow = Number.NEGATIVE_INFINITY;
          var minAbove = Number.POSITIVE_INFINITY;
          var closestSignature;
          for (var _i = 0, signatures_8 = signatures; _i < signatures_8.length; _i++) {
            var sig = signatures_8[_i];
            var minParameter = getMinArgumentCount(sig);
            var maxParameter = getParameterCount(sig);
            if (minParameter < min) {
              min = minParameter;
              closestSignature = sig;
            }
            max = Math.max(max, maxParameter);
            if (minParameter < args.length && minParameter > maxBelow)
              maxBelow = minParameter;
            if (args.length < maxParameter && maxParameter < minAbove)
              minAbove = maxParameter;
          }
          var hasRestParameter = ts3.some(signatures, hasEffectiveRestParameter);
          var parameterRange = hasRestParameter ? min : min < max ? min + "-" + max : min;
          var isVoidPromiseError = !hasRestParameter && parameterRange === 1 && args.length === 0 && isPromiseResolveArityError(node);
          if (isVoidPromiseError && ts3.isInJSFile(node)) {
            return getDiagnosticForCallNode(node, ts3.Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments);
          }
          var error2 = hasRestParameter ? ts3.Diagnostics.Expected_at_least_0_arguments_but_got_1 : isVoidPromiseError ? ts3.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise : ts3.Diagnostics.Expected_0_arguments_but_got_1;
          if (min < args.length && args.length < max) {
            return getDiagnosticForCallNode(node, ts3.Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments, args.length, maxBelow, minAbove);
          } else if (args.length < min) {
            var diagnostic = getDiagnosticForCallNode(node, error2, parameterRange, args.length);
            var parameter = (_a = closestSignature === null || closestSignature === void 0 ? void 0 : closestSignature.declaration) === null || _a === void 0 ? void 0 : _a.parameters[closestSignature.thisParameter ? args.length + 1 : args.length];
            if (parameter) {
              var parameterError = ts3.createDiagnosticForNode(parameter, ts3.isBindingPattern(parameter.name) ? ts3.Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided : ts3.isRestParameter(parameter) ? ts3.Diagnostics.Arguments_for_the_rest_parameter_0_were_not_provided : ts3.Diagnostics.An_argument_for_0_was_not_provided, !parameter.name ? args.length : !ts3.isBindingPattern(parameter.name) ? ts3.idText(ts3.getFirstIdentifier(parameter.name)) : void 0);
              return ts3.addRelatedInfo(diagnostic, parameterError);
            }
            return diagnostic;
          } else {
            var errorSpan = ts3.factory.createNodeArray(args.slice(max));
            var pos = ts3.first(errorSpan).pos;
            var end = ts3.last(errorSpan).end;
            if (end === pos) {
              end++;
            }
            ts3.setTextRangePosEnd(errorSpan, pos, end);
            return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), errorSpan, error2, parameterRange, args.length);
          }
        }
        function getTypeArgumentArityError(node, signatures, typeArguments) {
          var argCount = typeArguments.length;
          if (signatures.length === 1) {
            var sig = signatures[0];
            var min_1 = getMinTypeArgumentCount(sig.typeParameters);
            var max = ts3.length(sig.typeParameters);
            return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.Expected_0_type_arguments_but_got_1, min_1 < max ? min_1 + "-" + max : min_1, argCount);
          }
          var belowArgCount = -Infinity;
          var aboveArgCount = Infinity;
          for (var _i = 0, signatures_9 = signatures; _i < signatures_9.length; _i++) {
            var sig = signatures_9[_i];
            var min_2 = getMinTypeArgumentCount(sig.typeParameters);
            var max = ts3.length(sig.typeParameters);
            if (min_2 > argCount) {
              aboveArgCount = Math.min(aboveArgCount, min_2);
            } else if (max < argCount) {
              belowArgCount = Math.max(belowArgCount, max);
            }
          }
          if (belowArgCount !== -Infinity && aboveArgCount !== Infinity) {
            return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments, argCount, belowArgCount, aboveArgCount);
          }
          return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.Expected_0_type_arguments_but_got_1, belowArgCount === -Infinity ? aboveArgCount : belowArgCount, argCount);
        }
        function resolveCall(node, signatures, candidatesOutArray, checkMode, callChainFlags, fallbackError) {
          var isTaggedTemplate = node.kind === 210;
          var isDecorator = node.kind === 165;
          var isJsxOpeningOrSelfClosingElement = ts3.isJsxOpeningLikeElement(node);
          var reportErrors = !candidatesOutArray;
          var typeArguments;
          if (!isDecorator) {
            typeArguments = node.typeArguments;
            if (isTaggedTemplate || isJsxOpeningOrSelfClosingElement || node.expression.kind !== 106) {
              ts3.forEach(typeArguments, checkSourceElement);
            }
          }
          var candidates = candidatesOutArray || [];
          reorderCandidates(signatures, candidates, callChainFlags);
          if (!candidates.length) {
            if (reportErrors) {
              diagnostics.add(getDiagnosticForCallNode(node, ts3.Diagnostics.Call_target_does_not_contain_any_signatures));
            }
            return resolveErrorCall(node);
          }
          var args = getEffectiveCallArguments(node);
          var isSingleNonGenericCandidate = candidates.length === 1 && !candidates[0].typeParameters;
          var argCheckMode = !isDecorator && !isSingleNonGenericCandidate && ts3.some(args, isContextSensitive) ? 4 : 0;
          argCheckMode |= checkMode & 32;
          var candidatesForArgumentError;
          var candidateForArgumentArityError;
          var candidateForTypeArgumentError;
          var result2;
          var signatureHelpTrailingComma = !!(checkMode & 16) && node.kind === 208 && node.arguments.hasTrailingComma;
          if (candidates.length > 1) {
            result2 = chooseOverload(candidates, subtypeRelation, isSingleNonGenericCandidate, signatureHelpTrailingComma);
          }
          if (!result2) {
            result2 = chooseOverload(candidates, assignableRelation, isSingleNonGenericCandidate, signatureHelpTrailingComma);
          }
          if (result2) {
            return result2;
          }
          if (reportErrors) {
            if (candidatesForArgumentError) {
              if (candidatesForArgumentError.length === 1 || candidatesForArgumentError.length > 3) {
                var last_2 = candidatesForArgumentError[candidatesForArgumentError.length - 1];
                var chain_1;
                if (candidatesForArgumentError.length > 3) {
                  chain_1 = ts3.chainDiagnosticMessages(chain_1, ts3.Diagnostics.The_last_overload_gave_the_following_error);
                  chain_1 = ts3.chainDiagnosticMessages(chain_1, ts3.Diagnostics.No_overload_matches_this_call);
                }
                var diags = getSignatureApplicabilityError(node, args, last_2, assignableRelation, 0, true, function() {
                  return chain_1;
                });
                if (diags) {
                  for (var _i = 0, diags_1 = diags; _i < diags_1.length; _i++) {
                    var d = diags_1[_i];
                    if (last_2.declaration && candidatesForArgumentError.length > 3) {
                      ts3.addRelatedInfo(d, ts3.createDiagnosticForNode(last_2.declaration, ts3.Diagnostics.The_last_overload_is_declared_here));
                    }
                    addImplementationSuccessElaboration(last_2, d);
                    diagnostics.add(d);
                  }
                } else {
                  ts3.Debug.fail("No error for last overload signature");
                }
              } else {
                var allDiagnostics = [];
                var max = 0;
                var min_3 = Number.MAX_VALUE;
                var minIndex = 0;
                var i_1 = 0;
                var _loop_25 = function(c2) {
                  var chain_2 = function() {
                    return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Overload_0_of_1_2_gave_the_following_error, i_1 + 1, candidates.length, signatureToString(c2));
                  };
                  var diags_2 = getSignatureApplicabilityError(node, args, c2, assignableRelation, 0, true, chain_2);
                  if (diags_2) {
                    if (diags_2.length <= min_3) {
                      min_3 = diags_2.length;
                      minIndex = i_1;
                    }
                    max = Math.max(max, diags_2.length);
                    allDiagnostics.push(diags_2);
                  } else {
                    ts3.Debug.fail("No error for 3 or fewer overload signatures");
                  }
                  i_1++;
                };
                for (var _a = 0, candidatesForArgumentError_1 = candidatesForArgumentError; _a < candidatesForArgumentError_1.length; _a++) {
                  var c = candidatesForArgumentError_1[_a];
                  _loop_25(c);
                }
                var diags_3 = max > 1 ? allDiagnostics[minIndex] : ts3.flatten(allDiagnostics);
                ts3.Debug.assert(diags_3.length > 0, "No errors reported for 3 or fewer overload signatures");
                var chain = ts3.chainDiagnosticMessages(ts3.map(diags_3, ts3.createDiagnosticMessageChainFromDiagnostic), ts3.Diagnostics.No_overload_matches_this_call);
                var related = __spreadArray([], ts3.flatMap(diags_3, function(d2) {
                  return d2.relatedInformation;
                }), true);
                var diag = void 0;
                if (ts3.every(diags_3, function(d2) {
                  return d2.start === diags_3[0].start && d2.length === diags_3[0].length && d2.file === diags_3[0].file;
                })) {
                  var _b = diags_3[0], file = _b.file, start = _b.start, length_7 = _b.length;
                  diag = { file, start, length: length_7, code: chain.code, category: chain.category, messageText: chain, relatedInformation: related };
                } else {
                  diag = ts3.createDiagnosticForNodeFromMessageChain(node, chain, related);
                }
                addImplementationSuccessElaboration(candidatesForArgumentError[0], diag);
                diagnostics.add(diag);
              }
            } else if (candidateForArgumentArityError) {
              diagnostics.add(getArgumentArityError(node, [candidateForArgumentArityError], args));
            } else if (candidateForTypeArgumentError) {
              checkTypeArguments(candidateForTypeArgumentError, node.typeArguments, true, fallbackError);
            } else {
              var signaturesWithCorrectTypeArgumentArity = ts3.filter(signatures, function(s) {
                return hasCorrectTypeArgumentArity(s, typeArguments);
              });
              if (signaturesWithCorrectTypeArgumentArity.length === 0) {
                diagnostics.add(getTypeArgumentArityError(node, signatures, typeArguments));
              } else if (!isDecorator) {
                diagnostics.add(getArgumentArityError(node, signaturesWithCorrectTypeArgumentArity, args));
              } else if (fallbackError) {
                diagnostics.add(getDiagnosticForCallNode(node, fallbackError));
              }
            }
          }
          return getCandidateForOverloadFailure(node, candidates, args, !!candidatesOutArray, checkMode);
          function addImplementationSuccessElaboration(failed, diagnostic) {
            var _a2, _b2;
            var oldCandidatesForArgumentError = candidatesForArgumentError;
            var oldCandidateForArgumentArityError = candidateForArgumentArityError;
            var oldCandidateForTypeArgumentError = candidateForTypeArgumentError;
            var failedSignatureDeclarations = ((_b2 = (_a2 = failed.declaration) === null || _a2 === void 0 ? void 0 : _a2.symbol) === null || _b2 === void 0 ? void 0 : _b2.declarations) || ts3.emptyArray;
            var isOverload = failedSignatureDeclarations.length > 1;
            var implDecl = isOverload ? ts3.find(failedSignatureDeclarations, function(d2) {
              return ts3.isFunctionLikeDeclaration(d2) && ts3.nodeIsPresent(d2.body);
            }) : void 0;
            if (implDecl) {
              var candidate = getSignatureFromDeclaration(implDecl);
              var isSingleNonGenericCandidate_1 = !candidate.typeParameters;
              if (chooseOverload([candidate], assignableRelation, isSingleNonGenericCandidate_1)) {
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(implDecl, ts3.Diagnostics.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible));
              }
            }
            candidatesForArgumentError = oldCandidatesForArgumentError;
            candidateForArgumentArityError = oldCandidateForArgumentArityError;
            candidateForTypeArgumentError = oldCandidateForTypeArgumentError;
          }
          function chooseOverload(candidates2, relation, isSingleNonGenericCandidate2, signatureHelpTrailingComma2) {
            if (signatureHelpTrailingComma2 === void 0) {
              signatureHelpTrailingComma2 = false;
            }
            candidatesForArgumentError = void 0;
            candidateForArgumentArityError = void 0;
            candidateForTypeArgumentError = void 0;
            if (isSingleNonGenericCandidate2) {
              var candidate = candidates2[0];
              if (ts3.some(typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
                return void 0;
              }
              if (getSignatureApplicabilityError(node, args, candidate, relation, 0, false, void 0)) {
                candidatesForArgumentError = [candidate];
                return void 0;
              }
              return candidate;
            }
            for (var candidateIndex = 0; candidateIndex < candidates2.length; candidateIndex++) {
              var candidate = candidates2[candidateIndex];
              if (!hasCorrectTypeArgumentArity(candidate, typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
                continue;
              }
              var checkCandidate = void 0;
              var inferenceContext = void 0;
              if (candidate.typeParameters) {
                var typeArgumentTypes = void 0;
                if (ts3.some(typeArguments)) {
                  typeArgumentTypes = checkTypeArguments(candidate, typeArguments, false);
                  if (!typeArgumentTypes) {
                    candidateForTypeArgumentError = candidate;
                    continue;
                  }
                } else {
                  inferenceContext = createInferenceContext(candidate.typeParameters, candidate, ts3.isInJSFile(node) ? 2 : 0);
                  typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode | 8, inferenceContext);
                  argCheckMode |= inferenceContext.flags & 4 ? 8 : 0;
                }
                checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, ts3.isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
                if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
                  candidateForArgumentArityError = checkCandidate;
                  continue;
                }
              } else {
                checkCandidate = candidate;
              }
              if (getSignatureApplicabilityError(node, args, checkCandidate, relation, argCheckMode, false, void 0)) {
                (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
                continue;
              }
              if (argCheckMode) {
                argCheckMode = checkMode & 32;
                if (inferenceContext) {
                  var typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode, inferenceContext);
                  checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, ts3.isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
                  if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
                    candidateForArgumentArityError = checkCandidate;
                    continue;
                  }
                }
                if (getSignatureApplicabilityError(node, args, checkCandidate, relation, argCheckMode, false, void 0)) {
                  (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
                  continue;
                }
              }
              candidates2[candidateIndex] = checkCandidate;
              return checkCandidate;
            }
            return void 0;
          }
        }
        function getCandidateForOverloadFailure(node, candidates, args, hasCandidatesOutArray, checkMode) {
          ts3.Debug.assert(candidates.length > 0);
          checkNodeDeferred(node);
          return hasCandidatesOutArray || candidates.length === 1 || candidates.some(function(c) {
            return !!c.typeParameters;
          }) ? pickLongestCandidateSignature(node, candidates, args, checkMode) : createUnionOfSignaturesForOverloadFailure(candidates);
        }
        function createUnionOfSignaturesForOverloadFailure(candidates) {
          var thisParameters = ts3.mapDefined(candidates, function(c) {
            return c.thisParameter;
          });
          var thisParameter;
          if (thisParameters.length) {
            thisParameter = createCombinedSymbolFromTypes(thisParameters, thisParameters.map(getTypeOfParameter));
          }
          var _a = ts3.minAndMax(candidates, getNumNonRestParameters), minArgumentCount = _a.min, maxNonRestParam = _a.max;
          var parameters = [];
          var _loop_26 = function(i2) {
            var symbols = ts3.mapDefined(candidates, function(s) {
              return signatureHasRestParameter(s) ? i2 < s.parameters.length - 1 ? s.parameters[i2] : ts3.last(s.parameters) : i2 < s.parameters.length ? s.parameters[i2] : void 0;
            });
            ts3.Debug.assert(symbols.length !== 0);
            parameters.push(createCombinedSymbolFromTypes(symbols, ts3.mapDefined(candidates, function(candidate) {
              return tryGetTypeAtPosition(candidate, i2);
            })));
          };
          for (var i = 0; i < maxNonRestParam; i++) {
            _loop_26(i);
          }
          var restParameterSymbols = ts3.mapDefined(candidates, function(c) {
            return signatureHasRestParameter(c) ? ts3.last(c.parameters) : void 0;
          });
          var flags = 0;
          if (restParameterSymbols.length !== 0) {
            var type2 = createArrayType(getUnionType(ts3.mapDefined(candidates, tryGetRestTypeOfSignature), 2));
            parameters.push(createCombinedSymbolForOverloadFailure(restParameterSymbols, type2));
            flags |= 1;
          }
          if (candidates.some(signatureHasLiteralTypes)) {
            flags |= 2;
          }
          return createSignature(candidates[0].declaration, void 0, thisParameter, parameters, getIntersectionType(candidates.map(getReturnTypeOfSignature)), void 0, minArgumentCount, flags);
        }
        function getNumNonRestParameters(signature) {
          var numParams = signature.parameters.length;
          return signatureHasRestParameter(signature) ? numParams - 1 : numParams;
        }
        function createCombinedSymbolFromTypes(sources, types2) {
          return createCombinedSymbolForOverloadFailure(sources, getUnionType(types2, 2));
        }
        function createCombinedSymbolForOverloadFailure(sources, type2) {
          return createSymbolWithType(ts3.first(sources), type2);
        }
        function pickLongestCandidateSignature(node, candidates, args, checkMode) {
          var bestIndex = getLongestCandidateIndex(candidates, apparentArgumentCount === void 0 ? args.length : apparentArgumentCount);
          var candidate = candidates[bestIndex];
          var typeParameters = candidate.typeParameters;
          if (!typeParameters) {
            return candidate;
          }
          var typeArgumentNodes = callLikeExpressionMayHaveTypeArguments(node) ? node.typeArguments : void 0;
          var instantiated = typeArgumentNodes ? createSignatureInstantiation(candidate, getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, ts3.isInJSFile(node))) : inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args, checkMode);
          candidates[bestIndex] = instantiated;
          return instantiated;
        }
        function getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, isJs) {
          var typeArguments = typeArgumentNodes.map(getTypeOfNode);
          while (typeArguments.length > typeParameters.length) {
            typeArguments.pop();
          }
          while (typeArguments.length < typeParameters.length) {
            typeArguments.push(getDefaultFromTypeParameter(typeParameters[typeArguments.length]) || getConstraintOfTypeParameter(typeParameters[typeArguments.length]) || getDefaultTypeArgumentType(isJs));
          }
          return typeArguments;
        }
        function inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args, checkMode) {
          var inferenceContext = createInferenceContext(typeParameters, candidate, ts3.isInJSFile(node) ? 2 : 0);
          var typeArgumentTypes = inferTypeArguments(node, candidate, args, checkMode | 4 | 8, inferenceContext);
          return createSignatureInstantiation(candidate, typeArgumentTypes);
        }
        function getLongestCandidateIndex(candidates, argsCount) {
          var maxParamsIndex = -1;
          var maxParams = -1;
          for (var i = 0; i < candidates.length; i++) {
            var candidate = candidates[i];
            var paramCount = getParameterCount(candidate);
            if (hasEffectiveRestParameter(candidate) || paramCount >= argsCount) {
              return i;
            }
            if (paramCount > maxParams) {
              maxParams = paramCount;
              maxParamsIndex = i;
            }
          }
          return maxParamsIndex;
        }
        function resolveCallExpression(node, candidatesOutArray, checkMode) {
          if (node.expression.kind === 106) {
            var superType = checkSuperExpression(node.expression);
            if (isTypeAny(superType)) {
              for (var _i = 0, _a = node.arguments; _i < _a.length; _i++) {
                var arg = _a[_i];
                checkExpression(arg);
              }
              return anySignature;
            }
            if (!isErrorType(superType)) {
              var baseTypeNode = ts3.getEffectiveBaseTypeNode(ts3.getContainingClass(node));
              if (baseTypeNode) {
                var baseConstructors = getInstantiatedConstructorsForTypeArguments(superType, baseTypeNode.typeArguments, baseTypeNode);
                return resolveCall(node, baseConstructors, candidatesOutArray, checkMode, 0);
              }
            }
            return resolveUntypedCall(node);
          }
          var callChainFlags;
          var funcType = checkExpression(node.expression);
          if (ts3.isCallChain(node)) {
            var nonOptionalType = getOptionalExpressionType(funcType, node.expression);
            callChainFlags = nonOptionalType === funcType ? 0 : ts3.isOutermostOptionalChain(node) ? 16 : 8;
            funcType = nonOptionalType;
          } else {
            callChainFlags = 0;
          }
          funcType = checkNonNullTypeWithReporter(funcType, node.expression, reportCannotInvokePossiblyNullOrUndefinedError);
          if (funcType === silentNeverType) {
            return silentNeverSignature;
          }
          var apparentType = getApparentType(funcType);
          if (isErrorType(apparentType)) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
            if (!isErrorType(funcType) && node.typeArguments) {
              error(node, ts3.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
            }
            return resolveUntypedCall(node);
          }
          if (!callSignatures.length) {
            if (numConstructSignatures) {
              error(node, ts3.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
            } else {
              var relatedInformation = void 0;
              if (node.arguments.length === 1) {
                var text = ts3.getSourceFileOfNode(node).text;
                if (ts3.isLineBreak(text.charCodeAt(ts3.skipTrivia(text, node.expression.end, true) - 1))) {
                  relatedInformation = ts3.createDiagnosticForNode(node.expression, ts3.Diagnostics.Are_you_missing_a_semicolon);
                }
              }
              invocationError(node.expression, apparentType, 0, relatedInformation);
            }
            return resolveErrorCall(node);
          }
          if (checkMode & 8 && !node.typeArguments && callSignatures.some(isGenericFunctionReturningFunction)) {
            skippedGenericFunction(node, checkMode);
            return resolvingSignature;
          }
          if (callSignatures.some(function(sig) {
            return ts3.isInJSFile(sig.declaration) && !!ts3.getJSDocClassTag(sig.declaration);
          })) {
            error(node, ts3.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, callChainFlags);
        }
        function isGenericFunctionReturningFunction(signature) {
          return !!(signature.typeParameters && isFunctionType(getReturnTypeOfSignature(signature)));
        }
        function isUntypedFunctionCall(funcType, apparentFuncType, numCallSignatures, numConstructSignatures) {
          return isTypeAny(funcType) || isTypeAny(apparentFuncType) && !!(funcType.flags & 262144) || !numCallSignatures && !numConstructSignatures && !(apparentFuncType.flags & 1048576) && !(getReducedType(apparentFuncType).flags & 131072) && isTypeAssignableTo(funcType, globalFunctionType);
        }
        function resolveNewExpression(node, candidatesOutArray, checkMode) {
          if (node.arguments && languageVersion < 1) {
            var spreadIndex = getSpreadArgumentIndex(node.arguments);
            if (spreadIndex >= 0) {
              error(node.arguments[spreadIndex], ts3.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher);
            }
          }
          var expressionType = checkNonNullExpression(node.expression);
          if (expressionType === silentNeverType) {
            return silentNeverSignature;
          }
          expressionType = getApparentType(expressionType);
          if (isErrorType(expressionType)) {
            return resolveErrorCall(node);
          }
          if (isTypeAny(expressionType)) {
            if (node.typeArguments) {
              error(node, ts3.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
            }
            return resolveUntypedCall(node);
          }
          var constructSignatures = getSignaturesOfType(expressionType, 1);
          if (constructSignatures.length) {
            if (!isConstructorAccessible(node, constructSignatures[0])) {
              return resolveErrorCall(node);
            }
            if (someSignature(constructSignatures, function(signature2) {
              return !!(signature2.flags & 4);
            })) {
              error(node, ts3.Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
              return resolveErrorCall(node);
            }
            var valueDecl = expressionType.symbol && ts3.getClassLikeDeclarationOfSymbol(expressionType.symbol);
            if (valueDecl && ts3.hasSyntacticModifier(valueDecl, 128)) {
              error(node, ts3.Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
              return resolveErrorCall(node);
            }
            return resolveCall(node, constructSignatures, candidatesOutArray, checkMode, 0);
          }
          var callSignatures = getSignaturesOfType(expressionType, 0);
          if (callSignatures.length) {
            var signature = resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0);
            if (!noImplicitAny) {
              if (signature.declaration && !isJSConstructor(signature.declaration) && getReturnTypeOfSignature(signature) !== voidType) {
                error(node, ts3.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword);
              }
              if (getThisTypeOfSignature(signature) === voidType) {
                error(node, ts3.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void);
              }
            }
            return signature;
          }
          invocationError(node.expression, expressionType, 1);
          return resolveErrorCall(node);
        }
        function someSignature(signatures, f) {
          if (ts3.isArray(signatures)) {
            return ts3.some(signatures, function(signature) {
              return someSignature(signature, f);
            });
          }
          return signatures.compositeKind === 1048576 ? ts3.some(signatures.compositeSignatures, f) : f(signatures);
        }
        function typeHasProtectedAccessibleBase(target, type2) {
          var baseTypes = getBaseTypes(type2);
          if (!ts3.length(baseTypes)) {
            return false;
          }
          var firstBase = baseTypes[0];
          if (firstBase.flags & 2097152) {
            var types2 = firstBase.types;
            var mixinFlags = findMixins(types2);
            var i = 0;
            for (var _i = 0, _a = firstBase.types; _i < _a.length; _i++) {
              var intersectionMember = _a[_i];
              if (!mixinFlags[i]) {
                if (ts3.getObjectFlags(intersectionMember) & (1 | 2)) {
                  if (intersectionMember.symbol === target) {
                    return true;
                  }
                  if (typeHasProtectedAccessibleBase(target, intersectionMember)) {
                    return true;
                  }
                }
              }
              i++;
            }
            return false;
          }
          if (firstBase.symbol === target) {
            return true;
          }
          return typeHasProtectedAccessibleBase(target, firstBase);
        }
        function isConstructorAccessible(node, signature) {
          if (!signature || !signature.declaration) {
            return true;
          }
          var declaration = signature.declaration;
          var modifiers = ts3.getSelectedEffectiveModifierFlags(declaration, 24);
          if (!modifiers || declaration.kind !== 171) {
            return true;
          }
          var declaringClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(declaration.parent.symbol);
          var declaringClass = getDeclaredTypeOfSymbol(declaration.parent.symbol);
          if (!isNodeWithinClass(node, declaringClassDeclaration)) {
            var containingClass = ts3.getContainingClass(node);
            if (containingClass && modifiers & 16) {
              var containingType = getTypeOfNode(containingClass);
              if (typeHasProtectedAccessibleBase(declaration.parent.symbol, containingType)) {
                return true;
              }
            }
            if (modifiers & 8) {
              error(node, ts3.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
            }
            if (modifiers & 16) {
              error(node, ts3.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
            }
            return false;
          }
          return true;
        }
        function invocationErrorDetails(errorTarget, apparentType, kind) {
          var errorInfo;
          var isCall = kind === 0;
          var awaitedType = getAwaitedType(apparentType);
          var maybeMissingAwait = awaitedType && getSignaturesOfType(awaitedType, kind).length > 0;
          if (apparentType.flags & 1048576) {
            var types2 = apparentType.types;
            var hasSignatures = false;
            for (var _i = 0, types_20 = types2; _i < types_20.length; _i++) {
              var constituent = types_20[_i];
              var signatures = getSignaturesOfType(constituent, kind);
              if (signatures.length !== 0) {
                hasSignatures = true;
                if (errorInfo) {
                  break;
                }
              } else {
                if (!errorInfo) {
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Type_0_has_no_call_signatures : ts3.Diagnostics.Type_0_has_no_construct_signatures, typeToString(constituent));
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Not_all_constituents_of_type_0_are_callable : ts3.Diagnostics.Not_all_constituents_of_type_0_are_constructable, typeToString(apparentType));
                }
                if (hasSignatures) {
                  break;
                }
              }
            }
            if (!hasSignatures) {
              errorInfo = ts3.chainDiagnosticMessages(void 0, isCall ? ts3.Diagnostics.No_constituent_of_type_0_is_callable : ts3.Diagnostics.No_constituent_of_type_0_is_constructable, typeToString(apparentType));
            }
            if (!errorInfo) {
              errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other : ts3.Diagnostics.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other, typeToString(apparentType));
            }
          } else {
            errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Type_0_has_no_call_signatures : ts3.Diagnostics.Type_0_has_no_construct_signatures, typeToString(apparentType));
          }
          var headMessage = isCall ? ts3.Diagnostics.This_expression_is_not_callable : ts3.Diagnostics.This_expression_is_not_constructable;
          if (ts3.isCallExpression(errorTarget.parent) && errorTarget.parent.arguments.length === 0) {
            var resolvedSymbol = getNodeLinks(errorTarget).resolvedSymbol;
            if (resolvedSymbol && resolvedSymbol.flags & 32768) {
              headMessage = ts3.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without;
            }
          }
          return {
            messageChain: ts3.chainDiagnosticMessages(errorInfo, headMessage),
            relatedMessage: maybeMissingAwait ? ts3.Diagnostics.Did_you_forget_to_use_await : void 0
          };
        }
        function invocationError(errorTarget, apparentType, kind, relatedInformation) {
          var _a = invocationErrorDetails(errorTarget, apparentType, kind), messageChain = _a.messageChain, relatedInfo = _a.relatedMessage;
          var diagnostic = ts3.createDiagnosticForNodeFromMessageChain(errorTarget, messageChain);
          if (relatedInfo) {
            ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(errorTarget, relatedInfo));
          }
          if (ts3.isCallExpression(errorTarget.parent)) {
            var _b = getDiagnosticSpanForCallNode(errorTarget.parent, true), start = _b.start, length_8 = _b.length;
            diagnostic.start = start;
            diagnostic.length = length_8;
          }
          diagnostics.add(diagnostic);
          invocationErrorRecovery(apparentType, kind, relatedInformation ? ts3.addRelatedInfo(diagnostic, relatedInformation) : diagnostic);
        }
        function invocationErrorRecovery(apparentType, kind, diagnostic) {
          if (!apparentType.symbol) {
            return;
          }
          var importNode = getSymbolLinks(apparentType.symbol).originatingImport;
          if (importNode && !ts3.isImportCall(importNode)) {
            var sigs = getSignaturesOfType(getTypeOfSymbol(getSymbolLinks(apparentType.symbol).target), kind);
            if (!sigs || !sigs.length)
              return;
            ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(importNode, ts3.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead));
          }
        }
        function resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode) {
          var tagType = checkExpression(node.tag);
          var apparentType = getApparentType(tagType);
          if (isErrorType(apparentType)) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(tagType, apparentType, callSignatures.length, numConstructSignatures)) {
            return resolveUntypedCall(node);
          }
          if (!callSignatures.length) {
            if (ts3.isArrayLiteralExpression(node.parent)) {
              var diagnostic = ts3.createDiagnosticForNode(node.tag, ts3.Diagnostics.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);
              diagnostics.add(diagnostic);
              return resolveErrorCall(node);
            }
            invocationError(node.tag, apparentType, 0);
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0);
        }
        function getDiagnosticHeadMessageForDecoratorResolution(node) {
          switch (node.parent.kind) {
            case 257:
            case 226:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;
            case 164:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;
            case 167:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;
            case 169:
            case 172:
            case 173:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;
            default:
              return ts3.Debug.fail();
          }
        }
        function resolveDecorator(node, candidatesOutArray, checkMode) {
          var funcType = checkExpression(node.expression);
          var apparentType = getApparentType(funcType);
          if (isErrorType(apparentType)) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
            return resolveUntypedCall(node);
          }
          if (isPotentiallyUncalledDecorator(node, callSignatures)) {
            var nodeStr = ts3.getTextOfNode(node.expression, false);
            error(node, ts3.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0, nodeStr);
            return resolveErrorCall(node);
          }
          var headMessage = getDiagnosticHeadMessageForDecoratorResolution(node);
          if (!callSignatures.length) {
            var errorDetails = invocationErrorDetails(node.expression, apparentType, 0);
            var messageChain = ts3.chainDiagnosticMessages(errorDetails.messageChain, headMessage);
            var diag = ts3.createDiagnosticForNodeFromMessageChain(node.expression, messageChain);
            if (errorDetails.relatedMessage) {
              ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(node.expression, errorDetails.relatedMessage));
            }
            diagnostics.add(diag);
            invocationErrorRecovery(apparentType, 0, diag);
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0, headMessage);
        }
        function createSignatureForJSXIntrinsic(node, result2) {
          var namespace = getJsxNamespaceAt(node);
          var exports2 = namespace && getExportsOfSymbol(namespace);
          var typeSymbol = exports2 && getSymbol(exports2, JsxNames.Element, 788968);
          var returnNode = typeSymbol && nodeBuilder.symbolToEntityName(typeSymbol, 788968, node);
          var declaration = ts3.factory.createFunctionTypeNode(void 0, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "props", void 0, nodeBuilder.typeToTypeNode(result2, node))], returnNode ? ts3.factory.createTypeReferenceNode(returnNode, void 0) : ts3.factory.createKeywordTypeNode(130));
          var parameterSymbol = createSymbol(1, "props");
          parameterSymbol.type = result2;
          return createSignature(declaration, void 0, void 0, [parameterSymbol], typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType, void 0, 1, 0);
        }
        function resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode) {
          if (isJsxIntrinsicIdentifier(node.tagName)) {
            var result2 = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node);
            var fakeSignature = createSignatureForJSXIntrinsic(node, result2);
            checkTypeAssignableToAndOptionallyElaborate(checkExpressionWithContextualType(node.attributes, getEffectiveFirstArgumentForJsxSignature(fakeSignature, node), void 0, 0), result2, node.tagName, node.attributes);
            if (ts3.length(node.typeArguments)) {
              ts3.forEach(node.typeArguments, checkSourceElement);
              diagnostics.add(ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), node.typeArguments, ts3.Diagnostics.Expected_0_type_arguments_but_got_1, 0, ts3.length(node.typeArguments)));
            }
            return fakeSignature;
          }
          var exprTypes = checkExpression(node.tagName);
          var apparentType = getApparentType(exprTypes);
          if (isErrorType(apparentType)) {
            return resolveErrorCall(node);
          }
          var signatures = getUninstantiatedJsxSignaturesOfType(exprTypes, node);
          if (isUntypedFunctionCall(exprTypes, apparentType, signatures.length, 0)) {
            return resolveUntypedCall(node);
          }
          if (signatures.length === 0) {
            error(node.tagName, ts3.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures, ts3.getTextOfNode(node.tagName));
            return resolveErrorCall(node);
          }
          return resolveCall(node, signatures, candidatesOutArray, checkMode, 0);
        }
        function isPotentiallyUncalledDecorator(decorator, signatures) {
          return signatures.length && ts3.every(signatures, function(signature) {
            return signature.minArgumentCount === 0 && !signatureHasRestParameter(signature) && signature.parameters.length < getDecoratorArgumentCount(decorator, signature);
          });
        }
        function resolveSignature(node, candidatesOutArray, checkMode) {
          switch (node.kind) {
            case 208:
              return resolveCallExpression(node, candidatesOutArray, checkMode);
            case 209:
              return resolveNewExpression(node, candidatesOutArray, checkMode);
            case 210:
              return resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode);
            case 165:
              return resolveDecorator(node, candidatesOutArray, checkMode);
            case 280:
            case 279:
              return resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode);
          }
          throw ts3.Debug.assertNever(node, "Branch in 'resolveSignature' should be unreachable.");
        }
        function getResolvedSignature(node, candidatesOutArray, checkMode) {
          var links = getNodeLinks(node);
          var cached = links.resolvedSignature;
          if (cached && cached !== resolvingSignature && !candidatesOutArray) {
            return cached;
          }
          links.resolvedSignature = resolvingSignature;
          var result2 = resolveSignature(node, candidatesOutArray, checkMode || 0);
          if (result2 !== resolvingSignature) {
            links.resolvedSignature = flowLoopStart === flowLoopCount ? result2 : cached;
          }
          return result2;
        }
        function isJSConstructor(node) {
          var _a;
          if (!node || !ts3.isInJSFile(node)) {
            return false;
          }
          var func = ts3.isFunctionDeclaration(node) || ts3.isFunctionExpression(node) ? node : ts3.isVariableDeclaration(node) && node.initializer && ts3.isFunctionExpression(node.initializer) ? node.initializer : void 0;
          if (func) {
            if (ts3.getJSDocClassTag(node))
              return true;
            var symbol = getSymbolOfNode(func);
            return !!((_a = symbol === null || symbol === void 0 ? void 0 : symbol.members) === null || _a === void 0 ? void 0 : _a.size);
          }
          return false;
        }
        function mergeJSSymbols(target, source) {
          var _a, _b;
          if (source) {
            var links = getSymbolLinks(source);
            if (!links.inferredClassSymbol || !links.inferredClassSymbol.has(getSymbolId(target))) {
              var inferred = ts3.isTransientSymbol(target) ? target : cloneSymbol(target);
              inferred.exports = inferred.exports || ts3.createSymbolTable();
              inferred.members = inferred.members || ts3.createSymbolTable();
              inferred.flags |= source.flags & 32;
              if ((_a = source.exports) === null || _a === void 0 ? void 0 : _a.size) {
                mergeSymbolTable(inferred.exports, source.exports);
              }
              if ((_b = source.members) === null || _b === void 0 ? void 0 : _b.size) {
                mergeSymbolTable(inferred.members, source.members);
              }
              (links.inferredClassSymbol || (links.inferredClassSymbol = new ts3.Map())).set(getSymbolId(inferred), inferred);
              return inferred;
            }
            return links.inferredClassSymbol.get(getSymbolId(target));
          }
        }
        function getAssignedClassSymbol(decl) {
          var _a;
          var assignmentSymbol = decl && getSymbolOfExpando(decl, true);
          var prototype = (_a = assignmentSymbol === null || assignmentSymbol === void 0 ? void 0 : assignmentSymbol.exports) === null || _a === void 0 ? void 0 : _a.get("prototype");
          var init = (prototype === null || prototype === void 0 ? void 0 : prototype.valueDeclaration) && getAssignedJSPrototype(prototype.valueDeclaration);
          return init ? getSymbolOfNode(init) : void 0;
        }
        function getSymbolOfExpando(node, allowDeclaration) {
          if (!node.parent) {
            return void 0;
          }
          var name;
          var decl;
          if (ts3.isVariableDeclaration(node.parent) && node.parent.initializer === node) {
            if (!ts3.isInJSFile(node) && !(ts3.isVarConst(node.parent) && ts3.isFunctionLikeDeclaration(node))) {
              return void 0;
            }
            name = node.parent.name;
            decl = node.parent;
          } else if (ts3.isBinaryExpression(node.parent)) {
            var parentNode = node.parent;
            var parentNodeOperator = node.parent.operatorToken.kind;
            if (parentNodeOperator === 63 && (allowDeclaration || parentNode.right === node)) {
              name = parentNode.left;
              decl = name;
            } else if (parentNodeOperator === 56 || parentNodeOperator === 60) {
              if (ts3.isVariableDeclaration(parentNode.parent) && parentNode.parent.initializer === parentNode) {
                name = parentNode.parent.name;
                decl = parentNode.parent;
              } else if (ts3.isBinaryExpression(parentNode.parent) && parentNode.parent.operatorToken.kind === 63 && (allowDeclaration || parentNode.parent.right === parentNode)) {
                name = parentNode.parent.left;
                decl = name;
              }
              if (!name || !ts3.isBindableStaticNameExpression(name) || !ts3.isSameEntityName(name, parentNode.left)) {
                return void 0;
              }
            }
          } else if (allowDeclaration && ts3.isFunctionDeclaration(node)) {
            name = node.name;
            decl = node;
          }
          if (!decl || !name || !allowDeclaration && !ts3.getExpandoInitializer(node, ts3.isPrototypeAccess(name))) {
            return void 0;
          }
          return getSymbolOfNode(decl);
        }
        function getAssignedJSPrototype(node) {
          if (!node.parent) {
            return false;
          }
          var parent = node.parent;
          while (parent && parent.kind === 206) {
            parent = parent.parent;
          }
          if (parent && ts3.isBinaryExpression(parent) && ts3.isPrototypeAccess(parent.left) && parent.operatorToken.kind === 63) {
            var right = ts3.getInitializerOfBinaryExpression(parent);
            return ts3.isObjectLiteralExpression(right) && right;
          }
        }
        function checkCallExpression(node, checkMode) {
          var _a;
          checkGrammarTypeArguments(node, node.typeArguments);
          var signature = getResolvedSignature(node, void 0, checkMode);
          if (signature === resolvingSignature) {
            return nonInferrableType;
          }
          checkDeprecatedSignature(signature, node);
          if (node.expression.kind === 106) {
            return voidType;
          }
          if (node.kind === 209) {
            var declaration = signature.declaration;
            if (declaration && declaration.kind !== 171 && declaration.kind !== 175 && declaration.kind !== 180 && !ts3.isJSDocConstructSignature(declaration) && !isJSConstructor(declaration)) {
              if (noImplicitAny) {
                error(node, ts3.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type);
              }
              return anyType;
            }
          }
          if (ts3.isInJSFile(node) && isCommonJsRequire(node)) {
            return resolveExternalModuleTypeByLiteral(node.arguments[0]);
          }
          var returnType = getReturnTypeOfSignature(signature);
          if (returnType.flags & 12288 && isSymbolOrSymbolForCall(node)) {
            return getESSymbolLikeTypeForNode(ts3.walkUpParenthesizedExpressions(node.parent));
          }
          if (node.kind === 208 && !node.questionDotToken && node.parent.kind === 238 && returnType.flags & 16384 && getTypePredicateOfSignature(signature)) {
            if (!ts3.isDottedName(node.expression)) {
              error(node.expression, ts3.Diagnostics.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);
            } else if (!getEffectsSignature(node)) {
              var diagnostic = error(node.expression, ts3.Diagnostics.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);
              getTypeOfDottedName(node.expression, diagnostic);
            }
          }
          if (ts3.isInJSFile(node)) {
            var jsSymbol = getSymbolOfExpando(node, false);
            if ((_a = jsSymbol === null || jsSymbol === void 0 ? void 0 : jsSymbol.exports) === null || _a === void 0 ? void 0 : _a.size) {
              var jsAssignmentType = createAnonymousType(jsSymbol, jsSymbol.exports, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
              jsAssignmentType.objectFlags |= 4096;
              return getIntersectionType([returnType, jsAssignmentType]);
            }
          }
          return returnType;
        }
        function checkDeprecatedSignature(signature, node) {
          if (signature.declaration && signature.declaration.flags & 268435456) {
            var suggestionNode = getDeprecatedSuggestionNode(node);
            var name = ts3.tryGetPropertyAccessOrIdentifierToString(ts3.getInvokedExpression(node));
            addDeprecatedSuggestionWithSignature(suggestionNode, signature.declaration, name, signatureToString(signature));
          }
        }
        function getDeprecatedSuggestionNode(node) {
          node = ts3.skipParentheses(node);
          switch (node.kind) {
            case 208:
            case 165:
            case 209:
              return getDeprecatedSuggestionNode(node.expression);
            case 210:
              return getDeprecatedSuggestionNode(node.tag);
            case 280:
            case 279:
              return getDeprecatedSuggestionNode(node.tagName);
            case 207:
              return node.argumentExpression;
            case 206:
              return node.name;
            case 178:
              var typeReference = node;
              return ts3.isQualifiedName(typeReference.typeName) ? typeReference.typeName.right : typeReference;
            default:
              return node;
          }
        }
        function isSymbolOrSymbolForCall(node) {
          if (!ts3.isCallExpression(node))
            return false;
          var left = node.expression;
          if (ts3.isPropertyAccessExpression(left) && left.name.escapedText === "for") {
            left = left.expression;
          }
          if (!ts3.isIdentifier(left) || left.escapedText !== "Symbol") {
            return false;
          }
          var globalESSymbol = getGlobalESSymbolConstructorSymbol(false);
          if (!globalESSymbol) {
            return false;
          }
          return globalESSymbol === resolveName(left, "Symbol", 111551, void 0, void 0, false);
        }
        function checkImportCallExpression(node) {
          checkGrammarImportCallExpression(node);
          if (node.arguments.length === 0) {
            return createPromiseReturnType(node, anyType);
          }
          var specifier = node.arguments[0];
          var specifierType = checkExpressionCached(specifier);
          var optionsType = node.arguments.length > 1 ? checkExpressionCached(node.arguments[1]) : void 0;
          for (var i = 2; i < node.arguments.length; ++i) {
            checkExpressionCached(node.arguments[i]);
          }
          if (specifierType.flags & 32768 || specifierType.flags & 65536 || !isTypeAssignableTo(specifierType, stringType)) {
            error(specifier, ts3.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0, typeToString(specifierType));
          }
          if (optionsType) {
            var importCallOptionsType = getGlobalImportCallOptionsType(true);
            if (importCallOptionsType !== emptyObjectType) {
              checkTypeAssignableTo(optionsType, getNullableType(importCallOptionsType, 32768), node.arguments[1]);
            }
          }
          var moduleSymbol = resolveExternalModuleName(node, specifier);
          if (moduleSymbol) {
            var esModuleSymbol = resolveESModuleSymbol(moduleSymbol, specifier, true, false);
            if (esModuleSymbol) {
              return createPromiseReturnType(node, getTypeWithSyntheticDefaultOnly(getTypeOfSymbol(esModuleSymbol), esModuleSymbol, moduleSymbol, specifier) || getTypeWithSyntheticDefaultImportType(getTypeOfSymbol(esModuleSymbol), esModuleSymbol, moduleSymbol, specifier));
            }
          }
          return createPromiseReturnType(node, anyType);
        }
        function createDefaultPropertyWrapperForModule(symbol, originalSymbol, anonymousSymbol) {
          var memberTable = ts3.createSymbolTable();
          var newSymbol = createSymbol(2097152, "default");
          newSymbol.parent = originalSymbol;
          newSymbol.nameType = getStringLiteralType("default");
          newSymbol.aliasTarget = resolveSymbol(symbol);
          memberTable.set("default", newSymbol);
          return createAnonymousType(anonymousSymbol, memberTable, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        }
        function getTypeWithSyntheticDefaultOnly(type2, symbol, originalSymbol, moduleSpecifier) {
          var hasDefaultOnly = isOnlyImportedAsDefault(moduleSpecifier);
          if (hasDefaultOnly && type2 && !isErrorType(type2)) {
            var synthType = type2;
            if (!synthType.defaultOnlyType) {
              var type_5 = createDefaultPropertyWrapperForModule(symbol, originalSymbol);
              synthType.defaultOnlyType = type_5;
            }
            return synthType.defaultOnlyType;
          }
          return void 0;
        }
        function getTypeWithSyntheticDefaultImportType(type2, symbol, originalSymbol, moduleSpecifier) {
          var _a;
          if (allowSyntheticDefaultImports && type2 && !isErrorType(type2)) {
            var synthType = type2;
            if (!synthType.syntheticType) {
              var file = (_a = originalSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(ts3.isSourceFile);
              var hasSyntheticDefault = canHaveSyntheticDefault(file, originalSymbol, false, moduleSpecifier);
              if (hasSyntheticDefault) {
                var anonymousSymbol = createSymbol(2048, "__type");
                var defaultContainingObject = createDefaultPropertyWrapperForModule(symbol, originalSymbol, anonymousSymbol);
                anonymousSymbol.type = defaultContainingObject;
                synthType.syntheticType = isValidSpreadType(type2) ? getSpreadType(type2, defaultContainingObject, anonymousSymbol, 0, false) : defaultContainingObject;
              } else {
                synthType.syntheticType = type2;
              }
            }
            return synthType.syntheticType;
          }
          return type2;
        }
        function isCommonJsRequire(node) {
          if (!ts3.isRequireCall(node, true)) {
            return false;
          }
          if (!ts3.isIdentifier(node.expression))
            return ts3.Debug.fail();
          var resolvedRequire = resolveName(node.expression, node.expression.escapedText, 111551, void 0, void 0, true);
          if (resolvedRequire === requireSymbol) {
            return true;
          }
          if (resolvedRequire.flags & 2097152) {
            return false;
          }
          var targetDeclarationKind = resolvedRequire.flags & 16 ? 256 : resolvedRequire.flags & 3 ? 254 : 0;
          if (targetDeclarationKind !== 0) {
            var decl = ts3.getDeclarationOfKind(resolvedRequire, targetDeclarationKind);
            return !!decl && !!(decl.flags & 16777216);
          }
          return false;
        }
        function checkTaggedTemplateExpression(node) {
          if (!checkGrammarTaggedTemplateChain(node))
            checkGrammarTypeArguments(node, node.typeArguments);
          if (languageVersion < 2) {
            checkExternalEmitHelpers(node, 262144);
          }
          var signature = getResolvedSignature(node);
          checkDeprecatedSignature(signature, node);
          return getReturnTypeOfSignature(signature);
        }
        function checkAssertion(node) {
          if (node.kind === 211) {
            var file = ts3.getSourceFileOfNode(node);
            if (file && ts3.fileExtensionIsOneOf(file.fileName, [".cts", ".mts"])) {
              grammarErrorOnNode(node, ts3.Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead);
            }
          }
          return checkAssertionWorker(node, node.type, node.expression);
        }
        function isValidConstAssertionArgument(node) {
          switch (node.kind) {
            case 10:
            case 14:
            case 8:
            case 9:
            case 110:
            case 95:
            case 204:
            case 205:
            case 223:
              return true;
            case 212:
              return isValidConstAssertionArgument(node.expression);
            case 219:
              var op = node.operator;
              var arg = node.operand;
              return op === 40 && (arg.kind === 8 || arg.kind === 9) || op === 39 && arg.kind === 8;
            case 206:
            case 207:
              var expr = node.expression;
              var symbol = getTypeOfNode(expr).symbol;
              if (symbol && symbol.flags & 2097152) {
                symbol = resolveAlias(symbol);
              }
              return !!(symbol && symbol.flags & 384 && getEnumKind(symbol) === 1);
          }
          return false;
        }
        function checkAssertionWorker(errNode, type2, expression, checkMode) {
          var exprType = checkExpression(expression, checkMode);
          if (ts3.isConstTypeReference(type2)) {
            if (!isValidConstAssertionArgument(expression)) {
              error(expression, ts3.Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals);
            }
            return getRegularTypeOfLiteralType(exprType);
          }
          checkSourceElement(type2);
          exprType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(exprType));
          var targetType = getTypeFromTypeNode(type2);
          if (!isErrorType(targetType)) {
            addLazyDiagnostic(function() {
              var widenedType = getWidenedType(exprType);
              if (!isTypeComparableTo(targetType, widenedType)) {
                checkTypeComparableTo(exprType, targetType, errNode, ts3.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first);
              }
            });
          }
          return targetType;
        }
        function checkNonNullChain(node) {
          var leftType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(leftType, node.expression);
          return propagateOptionalTypeMarker(getNonNullableType(nonOptionalType), node, nonOptionalType !== leftType);
        }
        function checkNonNullAssertion(node) {
          return node.flags & 32 ? checkNonNullChain(node) : getNonNullableType(checkExpression(node.expression));
        }
        function checkExpressionWithTypeArguments(node) {
          checkGrammarExpressionWithTypeArguments(node);
          var exprType = node.kind === 228 ? checkExpression(node.expression) : ts3.isThisIdentifier(node.exprName) ? checkThisExpression(node.exprName) : checkExpression(node.exprName);
          var typeArguments = node.typeArguments;
          if (exprType === silentNeverType || isErrorType(exprType) || !ts3.some(typeArguments)) {
            return exprType;
          }
          var hasSomeApplicableSignature = false;
          var nonApplicableType;
          var result2 = getInstantiatedType(exprType);
          var errorType2 = hasSomeApplicableSignature ? nonApplicableType : exprType;
          if (errorType2) {
            diagnostics.add(ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable, typeToString(errorType2)));
          }
          return result2;
          function getInstantiatedType(type2) {
            var hasSignatures = false;
            var hasApplicableSignature = false;
            var result3 = getInstantiatedTypePart(type2);
            hasSomeApplicableSignature || (hasSomeApplicableSignature = hasApplicableSignature);
            if (hasSignatures && !hasApplicableSignature) {
              nonApplicableType !== null && nonApplicableType !== void 0 ? nonApplicableType : nonApplicableType = type2;
            }
            return result3;
            function getInstantiatedTypePart(type3) {
              if (type3.flags & 524288) {
                var resolved = resolveStructuredTypeMembers(type3);
                var callSignatures = getInstantiatedSignatures(resolved.callSignatures);
                var constructSignatures = getInstantiatedSignatures(resolved.constructSignatures);
                hasSignatures || (hasSignatures = resolved.callSignatures.length !== 0 || resolved.constructSignatures.length !== 0);
                hasApplicableSignature || (hasApplicableSignature = callSignatures.length !== 0 || constructSignatures.length !== 0);
                if (callSignatures !== resolved.callSignatures || constructSignatures !== resolved.constructSignatures) {
                  var result_11 = createAnonymousType(void 0, resolved.members, callSignatures, constructSignatures, resolved.indexInfos);
                  result_11.objectFlags |= 8388608;
                  result_11.node = node;
                  return result_11;
                }
              } else if (type3.flags & 58982400) {
                var constraint = getBaseConstraintOfType(type3);
                if (constraint) {
                  var instantiated = getInstantiatedTypePart(constraint);
                  if (instantiated !== constraint) {
                    return instantiated;
                  }
                }
              } else if (type3.flags & 1048576) {
                return mapType(type3, getInstantiatedType);
              } else if (type3.flags & 2097152) {
                return getIntersectionType(ts3.sameMap(type3.types, getInstantiatedTypePart));
              }
              return type3;
            }
          }
          function getInstantiatedSignatures(signatures) {
            var applicableSignatures = ts3.filter(signatures, function(sig) {
              return !!sig.typeParameters && hasCorrectTypeArgumentArity(sig, typeArguments);
            });
            return ts3.sameMap(applicableSignatures, function(sig) {
              var typeArgumentTypes = checkTypeArguments(sig, typeArguments, true);
              return typeArgumentTypes ? getSignatureInstantiation(sig, typeArgumentTypes, ts3.isInJSFile(sig.declaration)) : sig;
            });
          }
        }
        function checkMetaProperty(node) {
          checkGrammarMetaProperty(node);
          if (node.keywordToken === 103) {
            return checkNewTargetMetaProperty(node);
          }
          if (node.keywordToken === 100) {
            return checkImportMetaProperty(node);
          }
          return ts3.Debug.assertNever(node.keywordToken);
        }
        function checkMetaPropertyKeyword(node) {
          switch (node.keywordToken) {
            case 100:
              return getGlobalImportMetaExpressionType();
            case 103:
              var type2 = checkNewTargetMetaProperty(node);
              return isErrorType(type2) ? errorType : createNewTargetExpressionType(type2);
            default:
              ts3.Debug.assertNever(node.keywordToken);
          }
        }
        function checkNewTargetMetaProperty(node) {
          var container = ts3.getNewTargetContainer(node);
          if (!container) {
            error(node, ts3.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor, "new.target");
            return errorType;
          } else if (container.kind === 171) {
            var symbol = getSymbolOfNode(container.parent);
            return getTypeOfSymbol(symbol);
          } else {
            var symbol = getSymbolOfNode(container);
            return getTypeOfSymbol(symbol);
          }
        }
        function checkImportMetaProperty(node) {
          if (moduleKind === ts3.ModuleKind.Node16 || moduleKind === ts3.ModuleKind.NodeNext) {
            if (ts3.getSourceFileOfNode(node).impliedNodeFormat !== ts3.ModuleKind.ESNext) {
              error(node, ts3.Diagnostics.The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output);
            }
          } else if (moduleKind < ts3.ModuleKind.ES2020 && moduleKind !== ts3.ModuleKind.System) {
            error(node, ts3.Diagnostics.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext);
          }
          var file = ts3.getSourceFileOfNode(node);
          ts3.Debug.assert(!!(file.flags & 4194304), "Containing file is missing import meta node flag.");
          return node.name.escapedText === "meta" ? getGlobalImportMetaType() : errorType;
        }
        function getTypeOfParameter(symbol) {
          var type2 = getTypeOfSymbol(symbol);
          if (strictNullChecks) {
            var declaration = symbol.valueDeclaration;
            if (declaration && ts3.hasInitializer(declaration)) {
              return getOptionalType(type2);
            }
          }
          return type2;
        }
        function getTupleElementLabel(d) {
          ts3.Debug.assert(ts3.isIdentifier(d.name));
          return d.name.escapedText;
        }
        function getParameterNameAtPosition(signature, pos, overrideRestType) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            return signature.parameters[pos].escapedName;
          }
          var restParameter = signature.parameters[paramCount] || unknownSymbol;
          var restType = overrideRestType || getTypeOfSymbol(restParameter);
          if (isTupleType(restType)) {
            var associatedNames = restType.target.labeledElementDeclarations;
            var index = pos - paramCount;
            return associatedNames && getTupleElementLabel(associatedNames[index]) || restParameter.escapedName + "_" + index;
          }
          return restParameter.escapedName;
        }
        function getParameterIdentifierNameAtPosition(signature, pos) {
          var _a;
          if (((_a = signature.declaration) === null || _a === void 0 ? void 0 : _a.kind) === 317) {
            return void 0;
          }
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            var param = signature.parameters[pos];
            return isParameterDeclarationWithIdentifierName(param) ? [param.escapedName, false] : void 0;
          }
          var restParameter = signature.parameters[paramCount] || unknownSymbol;
          if (!isParameterDeclarationWithIdentifierName(restParameter)) {
            return void 0;
          }
          var restType = getTypeOfSymbol(restParameter);
          if (isTupleType(restType)) {
            var associatedNames = restType.target.labeledElementDeclarations;
            var index = pos - paramCount;
            var associatedName = associatedNames === null || associatedNames === void 0 ? void 0 : associatedNames[index];
            var isRestTupleElement = !!(associatedName === null || associatedName === void 0 ? void 0 : associatedName.dotDotDotToken);
            return associatedName ? [
              getTupleElementLabel(associatedName),
              isRestTupleElement
            ] : void 0;
          }
          if (pos === paramCount) {
            return [restParameter.escapedName, true];
          }
          return void 0;
        }
        function isParameterDeclarationWithIdentifierName(symbol) {
          return symbol.valueDeclaration && ts3.isParameter(symbol.valueDeclaration) && ts3.isIdentifier(symbol.valueDeclaration.name);
        }
        function isValidDeclarationForTupleLabel(d) {
          return d.kind === 197 || ts3.isParameter(d) && d.name && ts3.isIdentifier(d.name);
        }
        function getNameableDeclarationAtPosition(signature, pos) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            var decl = signature.parameters[pos].valueDeclaration;
            return decl && isValidDeclarationForTupleLabel(decl) ? decl : void 0;
          }
          var restParameter = signature.parameters[paramCount] || unknownSymbol;
          var restType = getTypeOfSymbol(restParameter);
          if (isTupleType(restType)) {
            var associatedNames = restType.target.labeledElementDeclarations;
            var index = pos - paramCount;
            return associatedNames && associatedNames[index];
          }
          return restParameter.valueDeclaration && isValidDeclarationForTupleLabel(restParameter.valueDeclaration) ? restParameter.valueDeclaration : void 0;
        }
        function getTypeAtPosition(signature, pos) {
          return tryGetTypeAtPosition(signature, pos) || anyType;
        }
        function tryGetTypeAtPosition(signature, pos) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            return getTypeOfParameter(signature.parameters[pos]);
          }
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[paramCount]);
            var index = pos - paramCount;
            if (!isTupleType(restType) || restType.target.hasRestElement || index < restType.target.fixedLength) {
              return getIndexedAccessType(restType, getNumberLiteralType(index));
            }
          }
          return void 0;
        }
        function getRestTypeAtPosition(source, pos) {
          var parameterCount = getParameterCount(source);
          var minArgumentCount = getMinArgumentCount(source);
          var restType = getEffectiveRestType(source);
          if (restType && pos >= parameterCount - 1) {
            return pos === parameterCount - 1 ? restType : createArrayType(getIndexedAccessType(restType, numberType));
          }
          var types2 = [];
          var flags = [];
          var names = [];
          for (var i = pos; i < parameterCount; i++) {
            if (!restType || i < parameterCount - 1) {
              types2.push(getTypeAtPosition(source, i));
              flags.push(i < minArgumentCount ? 1 : 2);
            } else {
              types2.push(restType);
              flags.push(8);
            }
            var name = getNameableDeclarationAtPosition(source, i);
            if (name) {
              names.push(name);
            }
          }
          return createTupleType(types2, flags, false, ts3.length(names) === ts3.length(types2) ? names : void 0);
        }
        function getParameterCount(signature) {
          var length = signature.parameters.length;
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[length - 1]);
            if (isTupleType(restType)) {
              return length + restType.target.fixedLength - (restType.target.hasRestElement ? 0 : 1);
            }
          }
          return length;
        }
        function getMinArgumentCount(signature, flags) {
          var strongArityForUntypedJS = flags & 1;
          var voidIsNonOptional = flags & 2;
          if (voidIsNonOptional || signature.resolvedMinArgumentCount === void 0) {
            var minArgumentCount = void 0;
            if (signatureHasRestParameter(signature)) {
              var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
              if (isTupleType(restType)) {
                var firstOptionalIndex = ts3.findIndex(restType.target.elementFlags, function(f) {
                  return !(f & 1);
                });
                var requiredCount = firstOptionalIndex < 0 ? restType.target.fixedLength : firstOptionalIndex;
                if (requiredCount > 0) {
                  minArgumentCount = signature.parameters.length - 1 + requiredCount;
                }
              }
            }
            if (minArgumentCount === void 0) {
              if (!strongArityForUntypedJS && signature.flags & 32) {
                return 0;
              }
              minArgumentCount = signature.minArgumentCount;
            }
            if (voidIsNonOptional) {
              return minArgumentCount;
            }
            for (var i = minArgumentCount - 1; i >= 0; i--) {
              var type2 = getTypeAtPosition(signature, i);
              if (filterType(type2, acceptsVoid).flags & 131072) {
                break;
              }
              minArgumentCount = i;
            }
            signature.resolvedMinArgumentCount = minArgumentCount;
          }
          return signature.resolvedMinArgumentCount;
        }
        function hasEffectiveRestParameter(signature) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            return !isTupleType(restType) || restType.target.hasRestElement;
          }
          return false;
        }
        function getEffectiveRestType(signature) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            if (!isTupleType(restType)) {
              return restType;
            }
            if (restType.target.hasRestElement) {
              return sliceTupleType(restType, restType.target.fixedLength);
            }
          }
          return void 0;
        }
        function getNonArrayRestType(signature) {
          var restType = getEffectiveRestType(signature);
          return restType && !isArrayType(restType) && !isTypeAny(restType) && (getReducedType(restType).flags & 131072) === 0 ? restType : void 0;
        }
        function getTypeOfFirstParameterOfSignature(signature) {
          return getTypeOfFirstParameterOfSignatureWithFallback(signature, neverType);
        }
        function getTypeOfFirstParameterOfSignatureWithFallback(signature, fallbackType) {
          return signature.parameters.length > 0 ? getTypeAtPosition(signature, 0) : fallbackType;
        }
        function inferFromAnnotatedParameters(signature, context, inferenceContext) {
          var len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          for (var i = 0; i < len; i++) {
            var declaration = signature.parameters[i].valueDeclaration;
            if (declaration.type) {
              var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
              if (typeNode) {
                inferTypes(inferenceContext.inferences, getTypeFromTypeNode(typeNode), getTypeAtPosition(context, i));
              }
            }
          }
          var restType = getEffectiveRestType(context);
          if (restType && restType.flags & 262144) {
            var instantiatedContext = instantiateSignature(context, inferenceContext.nonFixingMapper);
            assignContextualParameterTypes(signature, instantiatedContext);
            var restPos = getParameterCount(context) - 1;
            inferTypes(inferenceContext.inferences, getRestTypeAtPosition(signature, restPos), restType);
          }
        }
        function assignContextualParameterTypes(signature, context) {
          if (context.typeParameters) {
            if (!signature.typeParameters) {
              signature.typeParameters = context.typeParameters;
            } else {
              return;
            }
          }
          if (context.thisParameter) {
            var parameter = signature.thisParameter;
            if (!parameter || parameter.valueDeclaration && !parameter.valueDeclaration.type) {
              if (!parameter) {
                signature.thisParameter = createSymbolWithType(context.thisParameter, void 0);
              }
              assignParameterType(signature.thisParameter, getTypeOfSymbol(context.thisParameter));
            }
          }
          var len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          for (var i = 0; i < len; i++) {
            var parameter = signature.parameters[i];
            if (!ts3.getEffectiveTypeAnnotationNode(parameter.valueDeclaration)) {
              var contextualParameterType = tryGetTypeAtPosition(context, i);
              assignParameterType(parameter, contextualParameterType);
            }
          }
          if (signatureHasRestParameter(signature)) {
            var parameter = ts3.last(signature.parameters);
            if (parameter.valueDeclaration ? !ts3.getEffectiveTypeAnnotationNode(parameter.valueDeclaration) : !!(ts3.getCheckFlags(parameter) & 65536)) {
              var contextualParameterType = getRestTypeAtPosition(context, len);
              assignParameterType(parameter, contextualParameterType);
            }
          }
        }
        function assignNonContextualParameterTypes(signature) {
          if (signature.thisParameter) {
            assignParameterType(signature.thisParameter);
          }
          for (var _i = 0, _a = signature.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            assignParameterType(parameter);
          }
        }
        function assignParameterType(parameter, type2) {
          var links = getSymbolLinks(parameter);
          if (!links.type) {
            var declaration = parameter.valueDeclaration;
            links.type = type2 || (declaration ? getWidenedTypeForVariableLikeDeclaration(declaration, true) : getTypeOfSymbol(parameter));
            if (declaration && declaration.name.kind !== 79) {
              if (links.type === unknownType) {
                links.type = getTypeFromBindingPattern(declaration.name);
              }
              assignBindingElementTypes(declaration.name, links.type);
            }
          } else if (type2) {
            ts3.Debug.assertEqual(links.type, type2, "Parameter symbol already has a cached type which differs from newly assigned type");
          }
        }
        function assignBindingElementTypes(pattern, parentType) {
          for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (!ts3.isOmittedExpression(element)) {
              var type2 = getBindingElementTypeFromParentType(element, parentType);
              if (element.name.kind === 79) {
                getSymbolLinks(getSymbolOfNode(element)).type = type2;
              } else {
                assignBindingElementTypes(element.name, type2);
              }
            }
          }
        }
        function createPromiseType(promisedType) {
          var globalPromiseType = getGlobalPromiseType(true);
          if (globalPromiseType !== emptyGenericType) {
            promisedType = getAwaitedTypeNoAlias(unwrapAwaitedType(promisedType)) || unknownType;
            return createTypeReference(globalPromiseType, [promisedType]);
          }
          return unknownType;
        }
        function createPromiseLikeType(promisedType) {
          var globalPromiseLikeType = getGlobalPromiseLikeType(true);
          if (globalPromiseLikeType !== emptyGenericType) {
            promisedType = getAwaitedTypeNoAlias(unwrapAwaitedType(promisedType)) || unknownType;
            return createTypeReference(globalPromiseLikeType, [promisedType]);
          }
          return unknownType;
        }
        function createPromiseReturnType(func, promisedType) {
          var promiseType = createPromiseType(promisedType);
          if (promiseType === unknownType) {
            error(func, ts3.isImportCall(func) ? ts3.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option : ts3.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option);
            return errorType;
          } else if (!getGlobalPromiseConstructorSymbol(true)) {
            error(func, ts3.isImportCall(func) ? ts3.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option : ts3.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
          }
          return promiseType;
        }
        function createNewTargetExpressionType(targetType) {
          var symbol = createSymbol(0, "NewTargetExpression");
          var targetPropertySymbol = createSymbol(4, "target", 8);
          targetPropertySymbol.parent = symbol;
          targetPropertySymbol.type = targetType;
          var members = ts3.createSymbolTable([targetPropertySymbol]);
          symbol.members = members;
          return createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
        }
        function getReturnTypeFromBody(func, checkMode) {
          if (!func.body) {
            return errorType;
          }
          var functionFlags = ts3.getFunctionFlags(func);
          var isAsync = (functionFlags & 2) !== 0;
          var isGenerator = (functionFlags & 1) !== 0;
          var returnType;
          var yieldType;
          var nextType;
          var fallbackReturnType = voidType;
          if (func.body.kind !== 235) {
            returnType = checkExpressionCached(func.body, checkMode && checkMode & ~8);
            if (isAsync) {
              returnType = unwrapAwaitedType(checkAwaitedType(returnType, false, func, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member));
            }
          } else if (isGenerator) {
            var returnTypes = checkAndAggregateReturnExpressionTypes(func, checkMode);
            if (!returnTypes) {
              fallbackReturnType = neverType;
            } else if (returnTypes.length > 0) {
              returnType = getUnionType(returnTypes, 2);
            }
            var _a = checkAndAggregateYieldOperandTypes(func, checkMode), yieldTypes = _a.yieldTypes, nextTypes = _a.nextTypes;
            yieldType = ts3.some(yieldTypes) ? getUnionType(yieldTypes, 2) : void 0;
            nextType = ts3.some(nextTypes) ? getIntersectionType(nextTypes) : void 0;
          } else {
            var types2 = checkAndAggregateReturnExpressionTypes(func, checkMode);
            if (!types2) {
              return functionFlags & 2 ? createPromiseReturnType(func, neverType) : neverType;
            }
            if (types2.length === 0) {
              return functionFlags & 2 ? createPromiseReturnType(func, voidType) : voidType;
            }
            returnType = getUnionType(types2, 2);
          }
          if (returnType || yieldType || nextType) {
            if (yieldType)
              reportErrorsFromWidening(func, yieldType, 3);
            if (returnType)
              reportErrorsFromWidening(func, returnType, 1);
            if (nextType)
              reportErrorsFromWidening(func, nextType, 2);
            if (returnType && isUnitType(returnType) || yieldType && isUnitType(yieldType) || nextType && isUnitType(nextType)) {
              var contextualSignature = getContextualSignatureForFunctionLikeDeclaration(func);
              var contextualType = !contextualSignature ? void 0 : contextualSignature === getSignatureFromDeclaration(func) ? isGenerator ? void 0 : returnType : instantiateContextualType(getReturnTypeOfSignature(contextualSignature), func);
              if (isGenerator) {
                yieldType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(yieldType, contextualType, 0, isAsync);
                returnType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(returnType, contextualType, 1, isAsync);
                nextType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(nextType, contextualType, 2, isAsync);
              } else {
                returnType = getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(returnType, contextualType, isAsync);
              }
            }
            if (yieldType)
              yieldType = getWidenedType(yieldType);
            if (returnType)
              returnType = getWidenedType(returnType);
            if (nextType)
              nextType = getWidenedType(nextType);
          }
          if (isGenerator) {
            return createGeneratorReturnType(yieldType || neverType, returnType || fallbackReturnType, nextType || getContextualIterationType(2, func) || unknownType, isAsync);
          } else {
            return isAsync ? createPromiseType(returnType || fallbackReturnType) : returnType || fallbackReturnType;
          }
        }
        function createGeneratorReturnType(yieldType, returnType, nextType, isAsyncGenerator) {
          var resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
          var globalGeneratorType = resolver.getGlobalGeneratorType(false);
          yieldType = resolver.resolveIterationType(yieldType, void 0) || unknownType;
          returnType = resolver.resolveIterationType(returnType, void 0) || unknownType;
          nextType = resolver.resolveIterationType(nextType, void 0) || unknownType;
          if (globalGeneratorType === emptyGenericType) {
            var globalType = resolver.getGlobalIterableIteratorType(false);
            var iterationTypes = globalType !== emptyGenericType ? getIterationTypesOfGlobalIterableType(globalType, resolver) : void 0;
            var iterableIteratorReturnType = iterationTypes ? iterationTypes.returnType : anyType;
            var iterableIteratorNextType = iterationTypes ? iterationTypes.nextType : undefinedType;
            if (isTypeAssignableTo(returnType, iterableIteratorReturnType) && isTypeAssignableTo(iterableIteratorNextType, nextType)) {
              if (globalType !== emptyGenericType) {
                return createTypeFromGenericGlobalType(globalType, [yieldType]);
              }
              resolver.getGlobalIterableIteratorType(true);
              return emptyObjectType;
            }
            resolver.getGlobalGeneratorType(true);
            return emptyObjectType;
          }
          return createTypeFromGenericGlobalType(globalGeneratorType, [yieldType, returnType, nextType]);
        }
        function checkAndAggregateYieldOperandTypes(func, checkMode) {
          var yieldTypes = [];
          var nextTypes = [];
          var isAsync = (ts3.getFunctionFlags(func) & 2) !== 0;
          ts3.forEachYieldExpression(func.body, function(yieldExpression) {
            var yieldExpressionType = yieldExpression.expression ? checkExpression(yieldExpression.expression, checkMode) : undefinedWideningType;
            ts3.pushIfUnique(yieldTypes, getYieldedTypeOfYieldExpression(yieldExpression, yieldExpressionType, anyType, isAsync));
            var nextType;
            if (yieldExpression.asteriskToken) {
              var iterationTypes = getIterationTypesOfIterable(yieldExpressionType, isAsync ? 19 : 17, yieldExpression.expression);
              nextType = iterationTypes && iterationTypes.nextType;
            } else {
              nextType = getContextualType(yieldExpression);
            }
            if (nextType)
              ts3.pushIfUnique(nextTypes, nextType);
          });
          return { yieldTypes, nextTypes };
        }
        function getYieldedTypeOfYieldExpression(node, expressionType, sentType, isAsync) {
          var errorNode = node.expression || node;
          var yieldedType = node.asteriskToken ? checkIteratedTypeOrElementType(isAsync ? 19 : 17, expressionType, sentType, errorNode) : expressionType;
          return !isAsync ? yieldedType : getAwaitedType(yieldedType, errorNode, node.asteriskToken ? ts3.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member : ts3.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
        }
        function getFactsFromTypeofSwitch(start, end, witnesses, hasDefault) {
          var facts = 0;
          if (hasDefault) {
            for (var i = end; i < witnesses.length; i++) {
              facts |= typeofNEFacts.get(witnesses[i]) || 32768;
            }
            for (var i = start; i < end; i++) {
              facts &= ~(typeofNEFacts.get(witnesses[i]) || 0);
            }
            for (var i = 0; i < start; i++) {
              facts |= typeofNEFacts.get(witnesses[i]) || 32768;
            }
          } else {
            for (var i = start; i < end; i++) {
              facts |= typeofEQFacts.get(witnesses[i]) || 128;
            }
            for (var i = 0; i < start; i++) {
              facts &= ~(typeofEQFacts.get(witnesses[i]) || 0);
            }
          }
          return facts;
        }
        function isExhaustiveSwitchStatement(node) {
          var links = getNodeLinks(node);
          return links.isExhaustive !== void 0 ? links.isExhaustive : links.isExhaustive = computeExhaustiveSwitchStatement(node);
        }
        function computeExhaustiveSwitchStatement(node) {
          if (node.expression.kind === 216) {
            var operandType = getTypeOfExpression(node.expression.expression);
            var witnesses = getSwitchClauseTypeOfWitnesses(node, false);
            var notEqualFacts_1 = getFactsFromTypeofSwitch(0, 0, witnesses, true);
            var type_6 = getBaseConstraintOfType(operandType) || operandType;
            if (type_6.flags & 3) {
              return (556800 & notEqualFacts_1) === 556800;
            }
            return !!(filterType(type_6, function(t) {
              return (getTypeFacts(t) & notEqualFacts_1) === notEqualFacts_1;
            }).flags & 131072);
          }
          var type2 = getTypeOfExpression(node.expression);
          if (!isLiteralType(type2)) {
            return false;
          }
          var switchTypes = getSwitchClauseTypes(node);
          if (!switchTypes.length || ts3.some(switchTypes, isNeitherUnitTypeNorNever)) {
            return false;
          }
          return eachTypeContainedIn(mapType(type2, getRegularTypeOfLiteralType), switchTypes);
        }
        function functionHasImplicitReturn(func) {
          return func.endFlowNode && isReachableFlowNode(func.endFlowNode);
        }
        function checkAndAggregateReturnExpressionTypes(func, checkMode) {
          var functionFlags = ts3.getFunctionFlags(func);
          var aggregatedTypes = [];
          var hasReturnWithNoExpression = functionHasImplicitReturn(func);
          var hasReturnOfTypeNever = false;
          ts3.forEachReturnStatement(func.body, function(returnStatement) {
            var expr = returnStatement.expression;
            if (expr) {
              var type2 = checkExpressionCached(expr, checkMode && checkMode & ~8);
              if (functionFlags & 2) {
                type2 = unwrapAwaitedType(checkAwaitedType(type2, false, func, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member));
              }
              if (type2.flags & 131072) {
                hasReturnOfTypeNever = true;
              }
              ts3.pushIfUnique(aggregatedTypes, type2);
            } else {
              hasReturnWithNoExpression = true;
            }
          });
          if (aggregatedTypes.length === 0 && !hasReturnWithNoExpression && (hasReturnOfTypeNever || mayReturnNever(func))) {
            return void 0;
          }
          if (strictNullChecks && aggregatedTypes.length && hasReturnWithNoExpression && !(isJSConstructor(func) && aggregatedTypes.some(function(t) {
            return t.symbol === func.symbol;
          }))) {
            ts3.pushIfUnique(aggregatedTypes, undefinedType);
          }
          return aggregatedTypes;
        }
        function mayReturnNever(func) {
          switch (func.kind) {
            case 213:
            case 214:
              return true;
            case 169:
              return func.parent.kind === 205;
            default:
              return false;
          }
        }
        function checkAllCodePathsInNonVoidFunctionReturnOrThrow(func, returnType) {
          addLazyDiagnostic(checkAllCodePathsInNonVoidFunctionReturnOrThrowDiagnostics);
          return;
          function checkAllCodePathsInNonVoidFunctionReturnOrThrowDiagnostics() {
            var functionFlags = ts3.getFunctionFlags(func);
            var type2 = returnType && unwrapReturnType(returnType, functionFlags);
            if (type2 && maybeTypeOfKind(type2, 1 | 16384)) {
              return;
            }
            if (func.kind === 168 || ts3.nodeIsMissing(func.body) || func.body.kind !== 235 || !functionHasImplicitReturn(func)) {
              return;
            }
            var hasExplicitReturn = func.flags & 512;
            var errorNode = ts3.getEffectiveReturnTypeNode(func) || func;
            if (type2 && type2.flags & 131072) {
              error(errorNode, ts3.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);
            } else if (type2 && !hasExplicitReturn) {
              error(errorNode, ts3.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);
            } else if (type2 && strictNullChecks && !isTypeAssignableTo(undefinedType, type2)) {
              error(errorNode, ts3.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);
            } else if (compilerOptions.noImplicitReturns) {
              if (!type2) {
                if (!hasExplicitReturn) {
                  return;
                }
                var inferredReturnType = getReturnTypeOfSignature(getSignatureFromDeclaration(func));
                if (isUnwrappedReturnTypeVoidOrAny(func, inferredReturnType)) {
                  return;
                }
              }
              error(errorNode, ts3.Diagnostics.Not_all_code_paths_return_a_value);
            }
          }
        }
        function checkFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
          ts3.Debug.assert(node.kind !== 169 || ts3.isObjectLiteralMethod(node));
          checkNodeDeferred(node);
          if (ts3.isFunctionExpression(node)) {
            checkCollisionsForDeclarationName(node, node.name);
          }
          if (checkMode && checkMode & 4 && isContextSensitive(node)) {
            if (!ts3.getEffectiveReturnTypeNode(node) && !ts3.hasContextSensitiveParameters(node)) {
              var contextualSignature = getContextualSignature(node);
              if (contextualSignature && couldContainTypeVariables(getReturnTypeOfSignature(contextualSignature))) {
                var links = getNodeLinks(node);
                if (links.contextFreeType) {
                  return links.contextFreeType;
                }
                var returnType = getReturnTypeFromBody(node, checkMode);
                var returnOnlySignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, returnType, void 0, 0, 0);
                var returnOnlyType = createAnonymousType(node.symbol, emptySymbols, [returnOnlySignature], ts3.emptyArray, ts3.emptyArray);
                returnOnlyType.objectFlags |= 262144;
                return links.contextFreeType = returnOnlyType;
              }
            }
            return anyFunctionType;
          }
          var hasGrammarError = checkGrammarFunctionLikeDeclaration(node);
          if (!hasGrammarError && node.kind === 213) {
            checkGrammarForGenerator(node);
          }
          contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode);
          return getTypeOfSymbol(getSymbolOfNode(node));
        }
        function contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
          var links = getNodeLinks(node);
          if (!(links.flags & 1024)) {
            var contextualSignature = getContextualSignature(node);
            if (!(links.flags & 1024)) {
              links.flags |= 1024;
              var signature = ts3.firstOrUndefined(getSignaturesOfType(getTypeOfSymbol(getSymbolOfNode(node)), 0));
              if (!signature) {
                return;
              }
              if (isContextSensitive(node)) {
                if (contextualSignature) {
                  var inferenceContext = getInferenceContext(node);
                  if (checkMode && checkMode & 2) {
                    inferFromAnnotatedParameters(signature, contextualSignature, inferenceContext);
                  }
                  var instantiatedContextualSignature = inferenceContext ? instantiateSignature(contextualSignature, inferenceContext.mapper) : contextualSignature;
                  assignContextualParameterTypes(signature, instantiatedContextualSignature);
                } else {
                  assignNonContextualParameterTypes(signature);
                }
              }
              if (contextualSignature && !getReturnTypeFromAnnotation(node) && !signature.resolvedReturnType) {
                var returnType = getReturnTypeFromBody(node, checkMode);
                if (!signature.resolvedReturnType) {
                  signature.resolvedReturnType = returnType;
                }
              }
              checkSignatureDeclaration(node);
            }
          }
        }
        function checkFunctionExpressionOrObjectLiteralMethodDeferred(node) {
          ts3.Debug.assert(node.kind !== 169 || ts3.isObjectLiteralMethod(node));
          var functionFlags = ts3.getFunctionFlags(node);
          var returnType = getReturnTypeFromAnnotation(node);
          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType);
          if (node.body) {
            if (!ts3.getEffectiveReturnTypeNode(node)) {
              getReturnTypeOfSignature(getSignatureFromDeclaration(node));
            }
            if (node.body.kind === 235) {
              checkSourceElement(node.body);
            } else {
              var exprType = checkExpression(node.body);
              var returnOrPromisedType = returnType && unwrapReturnType(returnType, functionFlags);
              if (returnOrPromisedType) {
                if ((functionFlags & 3) === 2) {
                  var awaitedType = checkAwaitedType(exprType, false, node.body, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                  checkTypeAssignableToAndOptionallyElaborate(awaitedType, returnOrPromisedType, node.body, node.body);
                } else {
                  checkTypeAssignableToAndOptionallyElaborate(exprType, returnOrPromisedType, node.body, node.body);
                }
              }
            }
          }
        }
        function checkArithmeticOperandType(operand, type2, diagnostic, isAwaitValid) {
          if (isAwaitValid === void 0) {
            isAwaitValid = false;
          }
          if (!isTypeAssignableTo(type2, numberOrBigIntType)) {
            var awaitedType = isAwaitValid && getAwaitedTypeOfPromise(type2);
            errorAndMaybeSuggestAwait(operand, !!awaitedType && isTypeAssignableTo(awaitedType, numberOrBigIntType), diagnostic);
            return false;
          }
          return true;
        }
        function isReadonlyAssignmentDeclaration(d) {
          if (!ts3.isCallExpression(d)) {
            return false;
          }
          if (!ts3.isBindableObjectDefinePropertyCall(d)) {
            return false;
          }
          var objectLitType = checkExpressionCached(d.arguments[2]);
          var valueType = getTypeOfPropertyOfType(objectLitType, "value");
          if (valueType) {
            var writableProp = getPropertyOfType(objectLitType, "writable");
            var writableType = writableProp && getTypeOfSymbol(writableProp);
            if (!writableType || writableType === falseType || writableType === regularFalseType) {
              return true;
            }
            if (writableProp && writableProp.valueDeclaration && ts3.isPropertyAssignment(writableProp.valueDeclaration)) {
              var initializer = writableProp.valueDeclaration.initializer;
              var rawOriginalType = checkExpression(initializer);
              if (rawOriginalType === falseType || rawOriginalType === regularFalseType) {
                return true;
              }
            }
            return false;
          }
          var setProp = getPropertyOfType(objectLitType, "set");
          return !setProp;
        }
        function isReadonlySymbol(symbol) {
          return !!(ts3.getCheckFlags(symbol) & 8 || symbol.flags & 4 && ts3.getDeclarationModifierFlagsFromSymbol(symbol) & 64 || symbol.flags & 3 && getDeclarationNodeFlagsFromSymbol(symbol) & 2 || symbol.flags & 98304 && !(symbol.flags & 65536) || symbol.flags & 8 || ts3.some(symbol.declarations, isReadonlyAssignmentDeclaration));
        }
        function isAssignmentToReadonlyEntity(expr, symbol, assignmentKind) {
          var _a, _b;
          if (assignmentKind === 0) {
            return false;
          }
          if (isReadonlySymbol(symbol)) {
            if (symbol.flags & 4 && ts3.isAccessExpression(expr) && expr.expression.kind === 108) {
              var ctor = ts3.getContainingFunction(expr);
              if (!(ctor && (ctor.kind === 171 || isJSConstructor(ctor)))) {
                return true;
              }
              if (symbol.valueDeclaration) {
                var isAssignmentDeclaration_1 = ts3.isBinaryExpression(symbol.valueDeclaration);
                var isLocalPropertyDeclaration = ctor.parent === symbol.valueDeclaration.parent;
                var isLocalParameterProperty = ctor === symbol.valueDeclaration.parent;
                var isLocalThisPropertyAssignment = isAssignmentDeclaration_1 && ((_a = symbol.parent) === null || _a === void 0 ? void 0 : _a.valueDeclaration) === ctor.parent;
                var isLocalThisPropertyAssignmentConstructorFunction = isAssignmentDeclaration_1 && ((_b = symbol.parent) === null || _b === void 0 ? void 0 : _b.valueDeclaration) === ctor;
                var isWriteableSymbol = isLocalPropertyDeclaration || isLocalParameterProperty || isLocalThisPropertyAssignment || isLocalThisPropertyAssignmentConstructorFunction;
                return !isWriteableSymbol;
              }
            }
            return true;
          }
          if (ts3.isAccessExpression(expr)) {
            var node = ts3.skipParentheses(expr.expression);
            if (node.kind === 79) {
              var symbol_2 = getNodeLinks(node).resolvedSymbol;
              if (symbol_2.flags & 2097152) {
                var declaration = getDeclarationOfAliasSymbol(symbol_2);
                return !!declaration && declaration.kind === 268;
              }
            }
          }
          return false;
        }
        function checkReferenceExpression(expr, invalidReferenceMessage, invalidOptionalChainMessage) {
          var node = ts3.skipOuterExpressions(expr, 6 | 1);
          if (node.kind !== 79 && !ts3.isAccessExpression(node)) {
            error(expr, invalidReferenceMessage);
            return false;
          }
          if (node.flags & 32) {
            error(expr, invalidOptionalChainMessage);
            return false;
          }
          return true;
        }
        function checkDeleteExpression(node) {
          checkExpression(node.expression);
          var expr = ts3.skipParentheses(node.expression);
          if (!ts3.isAccessExpression(expr)) {
            error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference);
            return booleanType;
          }
          if (ts3.isPropertyAccessExpression(expr) && ts3.isPrivateIdentifier(expr.name)) {
            error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);
          }
          var links = getNodeLinks(expr);
          var symbol = getExportSymbolOfValueSymbolIfExported(links.resolvedSymbol);
          if (symbol) {
            if (isReadonlySymbol(symbol)) {
              error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property);
            }
            checkDeleteExpressionMustBeOptional(expr, symbol);
          }
          return booleanType;
        }
        function checkDeleteExpressionMustBeOptional(expr, symbol) {
          var type2 = getTypeOfSymbol(symbol);
          if (strictNullChecks && !(type2.flags & (3 | 131072)) && !(exactOptionalPropertyTypes ? symbol.flags & 16777216 : getFalsyFlags(type2) & 32768)) {
            error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_must_be_optional);
          }
        }
        function checkTypeOfExpression(node) {
          checkExpression(node.expression);
          return typeofType;
        }
        function checkVoidExpression(node) {
          checkExpression(node.expression);
          return undefinedWideningType;
        }
        function checkAwaitExpressionGrammar(node) {
          var container = ts3.getContainingFunctionOrClassStaticBlock(node);
          if (container && ts3.isClassStaticBlockDeclaration(container)) {
            error(node, ts3.Diagnostics.Await_expression_cannot_be_used_inside_a_class_static_block);
          } else if (!(node.flags & 32768)) {
            if (ts3.isInTopLevelContext(node)) {
              var sourceFile = ts3.getSourceFileOfNode(node);
              if (!hasParseDiagnostics(sourceFile)) {
                var span = void 0;
                if (!ts3.isEffectiveExternalModule(sourceFile, compilerOptions)) {
                  span !== null && span !== void 0 ? span : span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                  var diagnostic = ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module);
                  diagnostics.add(diagnostic);
                }
                switch (moduleKind) {
                  case ts3.ModuleKind.Node16:
                  case ts3.ModuleKind.NodeNext:
                    if (sourceFile.impliedNodeFormat === ts3.ModuleKind.CommonJS) {
                      span !== null && span !== void 0 ? span : span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                      diagnostics.add(ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));
                      break;
                    }
                  case ts3.ModuleKind.ES2022:
                  case ts3.ModuleKind.ESNext:
                  case ts3.ModuleKind.System:
                    if (languageVersion >= 4) {
                      break;
                    }
                  default:
                    span !== null && span !== void 0 ? span : span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                    diagnostics.add(ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher));
                    break;
                }
              }
            } else {
              var sourceFile = ts3.getSourceFileOfNode(node);
              if (!hasParseDiagnostics(sourceFile)) {
                var span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                var diagnostic = ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                if (container && container.kind !== 171 && (ts3.getFunctionFlags(container) & 2) === 0) {
                  var relatedInfo = ts3.createDiagnosticForNode(container, ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                  ts3.addRelatedInfo(diagnostic, relatedInfo);
                }
                diagnostics.add(diagnostic);
              }
            }
          }
          if (isInParameterInitializerBeforeContainingFunction(node)) {
            error(node, ts3.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer);
          }
        }
        function checkAwaitExpression(node) {
          addLazyDiagnostic(function() {
            return checkAwaitExpressionGrammar(node);
          });
          var operandType = checkExpression(node.expression);
          var awaitedType = checkAwaitedType(operandType, true, node, ts3.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
          if (awaitedType === operandType && !isErrorType(awaitedType) && !(operandType.flags & 3)) {
            addErrorOrSuggestion(false, ts3.createDiagnosticForNode(node, ts3.Diagnostics.await_has_no_effect_on_the_type_of_this_expression));
          }
          return awaitedType;
        }
        function checkPrefixUnaryExpression(node) {
          var operandType = checkExpression(node.operand);
          if (operandType === silentNeverType) {
            return silentNeverType;
          }
          switch (node.operand.kind) {
            case 8:
              switch (node.operator) {
                case 40:
                  return getFreshTypeOfLiteralType(getNumberLiteralType(-node.operand.text));
                case 39:
                  return getFreshTypeOfLiteralType(getNumberLiteralType(+node.operand.text));
              }
              break;
            case 9:
              if (node.operator === 40) {
                return getFreshTypeOfLiteralType(getBigIntLiteralType({
                  negative: true,
                  base10Value: ts3.parsePseudoBigInt(node.operand.text)
                }));
              }
          }
          switch (node.operator) {
            case 39:
            case 40:
            case 54:
              checkNonNullType(operandType, node.operand);
              if (maybeTypeOfKindConsideringBaseConstraint(operandType, 12288)) {
                error(node.operand, ts3.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, ts3.tokenToString(node.operator));
              }
              if (node.operator === 39) {
                if (maybeTypeOfKind(operandType, 2112)) {
                  error(node.operand, ts3.Diagnostics.Operator_0_cannot_be_applied_to_type_1, ts3.tokenToString(node.operator), typeToString(getBaseTypeOfLiteralType(operandType)));
                }
                return numberType;
              }
              return getUnaryResultType(operandType);
            case 53:
              checkTruthinessExpression(node.operand);
              var facts = getTypeFacts(operandType) & (4194304 | 8388608);
              return facts === 4194304 ? falseType : facts === 8388608 ? trueType : booleanType;
            case 45:
            case 46:
              var ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), ts3.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
              if (ok) {
                checkReferenceExpression(node.operand, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access);
              }
              return getUnaryResultType(operandType);
          }
          return errorType;
        }
        function checkPostfixUnaryExpression(node) {
          var operandType = checkExpression(node.operand);
          if (operandType === silentNeverType) {
            return silentNeverType;
          }
          var ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), ts3.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
          if (ok) {
            checkReferenceExpression(node.operand, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access);
          }
          return getUnaryResultType(operandType);
        }
        function getUnaryResultType(operandType) {
          if (maybeTypeOfKind(operandType, 2112)) {
            return isTypeAssignableToKind(operandType, 3) || maybeTypeOfKind(operandType, 296) ? numberOrBigIntType : bigintType;
          }
          return numberType;
        }
        function maybeTypeOfKindConsideringBaseConstraint(type2, kind) {
          if (maybeTypeOfKind(type2, kind)) {
            return true;
          }
          var baseConstraint = getBaseConstraintOrType(type2);
          return !!baseConstraint && maybeTypeOfKind(baseConstraint, kind);
        }
        function maybeTypeOfKind(type2, kind) {
          if (type2.flags & kind) {
            return true;
          }
          if (type2.flags & 3145728) {
            var types2 = type2.types;
            for (var _i = 0, types_21 = types2; _i < types_21.length; _i++) {
              var t = types_21[_i];
              if (maybeTypeOfKind(t, kind)) {
                return true;
              }
            }
          }
          return false;
        }
        function isTypeAssignableToKind(source, kind, strict) {
          if (source.flags & kind) {
            return true;
          }
          if (strict && source.flags & (3 | 16384 | 32768 | 65536)) {
            return false;
          }
          return !!(kind & 296) && isTypeAssignableTo(source, numberType) || !!(kind & 2112) && isTypeAssignableTo(source, bigintType) || !!(kind & 402653316) && isTypeAssignableTo(source, stringType) || !!(kind & 528) && isTypeAssignableTo(source, booleanType) || !!(kind & 16384) && isTypeAssignableTo(source, voidType) || !!(kind & 131072) && isTypeAssignableTo(source, neverType) || !!(kind & 65536) && isTypeAssignableTo(source, nullType) || !!(kind & 32768) && isTypeAssignableTo(source, undefinedType) || !!(kind & 4096) && isTypeAssignableTo(source, esSymbolType) || !!(kind & 67108864) && isTypeAssignableTo(source, nonPrimitiveType);
        }
        function allTypesAssignableToKind(source, kind, strict) {
          return source.flags & 1048576 ? ts3.every(source.types, function(subType) {
            return allTypesAssignableToKind(subType, kind, strict);
          }) : isTypeAssignableToKind(source, kind, strict);
        }
        function isConstEnumObjectType(type2) {
          return !!(ts3.getObjectFlags(type2) & 16) && !!type2.symbol && isConstEnumSymbol(type2.symbol);
        }
        function isConstEnumSymbol(symbol) {
          return (symbol.flags & 128) !== 0;
        }
        function checkInstanceOfExpression(left, right, leftType, rightType) {
          if (leftType === silentNeverType || rightType === silentNeverType) {
            return silentNeverType;
          }
          if (!isTypeAny(leftType) && allTypesAssignableToKind(leftType, 131068)) {
            error(left, ts3.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter);
          }
          if (!(isTypeAny(rightType) || typeHasCallOrConstructSignatures(rightType) || isTypeSubtypeOf(rightType, globalFunctionType))) {
            error(right, ts3.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type);
          }
          return booleanType;
        }
        function checkInExpression(left, right, leftType, rightType) {
          if (leftType === silentNeverType || rightType === silentNeverType) {
            return silentNeverType;
          }
          if (ts3.isPrivateIdentifier(left)) {
            if (languageVersion < 99) {
              checkExternalEmitHelpers(left, 2097152);
            }
            if (!getNodeLinks(left).resolvedSymbol && ts3.getContainingClass(left)) {
              var isUncheckedJS = isUncheckedJSSuggestion(left, rightType.symbol, true);
              reportNonexistentProperty(left, rightType, isUncheckedJS);
            }
          } else {
            leftType = checkNonNullType(leftType, left);
            if (!(allTypesAssignableToKind(leftType, 402653316 | 296 | 12288) || isTypeAssignableToKind(leftType, 4194304 | 134217728 | 268435456 | 262144))) {
              error(left, ts3.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or_symbol);
            }
          }
          rightType = checkNonNullType(rightType, right);
          var rightTypeConstraint = getConstraintOfType(rightType);
          if (!allTypesAssignableToKind(rightType, 67108864 | 58982400) || rightTypeConstraint && (isTypeAssignableToKind(rightType, 3145728) && !allTypesAssignableToKind(rightTypeConstraint, 67108864 | 58982400) || !maybeTypeOfKind(rightTypeConstraint, 67108864 | 58982400 | 524288))) {
            error(right, ts3.Diagnostics.The_right_hand_side_of_an_in_expression_must_not_be_a_primitive);
          }
          return booleanType;
        }
        function checkObjectLiteralAssignment(node, sourceType, rightIsThis) {
          var properties = node.properties;
          if (strictNullChecks && properties.length === 0) {
            return checkNonNullType(sourceType, node);
          }
          for (var i = 0; i < properties.length; i++) {
            checkObjectLiteralDestructuringPropertyAssignment(node, sourceType, i, properties, rightIsThis);
          }
          return sourceType;
        }
        function checkObjectLiteralDestructuringPropertyAssignment(node, objectLiteralType, propertyIndex, allProperties, rightIsThis) {
          if (rightIsThis === void 0) {
            rightIsThis = false;
          }
          var properties = node.properties;
          var property = properties[propertyIndex];
          if (property.kind === 296 || property.kind === 297) {
            var name = property.name;
            var exprType = getLiteralTypeFromPropertyName(name);
            if (isTypeUsableAsPropertyName(exprType)) {
              var text = getPropertyNameFromType(exprType);
              var prop = getPropertyOfType(objectLiteralType, text);
              if (prop) {
                markPropertyAsReferenced(prop, property, rightIsThis);
                checkPropertyAccessibility(property, false, true, objectLiteralType, prop);
              }
            }
            var elementType = getIndexedAccessType(objectLiteralType, exprType, 32, name);
            var type2 = getFlowTypeOfDestructuring(property, elementType);
            return checkDestructuringAssignment(property.kind === 297 ? property : property.initializer, type2);
          } else if (property.kind === 298) {
            if (propertyIndex < properties.length - 1) {
              error(property, ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            } else {
              if (languageVersion < 99) {
                checkExternalEmitHelpers(property, 4);
              }
              var nonRestNames = [];
              if (allProperties) {
                for (var _i = 0, allProperties_1 = allProperties; _i < allProperties_1.length; _i++) {
                  var otherProperty = allProperties_1[_i];
                  if (!ts3.isSpreadAssignment(otherProperty)) {
                    nonRestNames.push(otherProperty.name);
                  }
                }
              }
              var type2 = getRestType(objectLiteralType, nonRestNames, objectLiteralType.symbol);
              checkGrammarForDisallowedTrailingComma(allProperties, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
              return checkDestructuringAssignment(property.expression, type2);
            }
          } else {
            error(property, ts3.Diagnostics.Property_assignment_expected);
          }
        }
        function checkArrayLiteralAssignment(node, sourceType, checkMode) {
          var elements = node.elements;
          if (languageVersion < 2 && compilerOptions.downlevelIteration) {
            checkExternalEmitHelpers(node, 512);
          }
          var possiblyOutOfBoundsType = checkIteratedTypeOrElementType(65 | 128, sourceType, undefinedType, node) || errorType;
          var inBoundsType = compilerOptions.noUncheckedIndexedAccess ? void 0 : possiblyOutOfBoundsType;
          for (var i = 0; i < elements.length; i++) {
            var type2 = possiblyOutOfBoundsType;
            if (node.elements[i].kind === 225) {
              type2 = inBoundsType = inBoundsType !== null && inBoundsType !== void 0 ? inBoundsType : checkIteratedTypeOrElementType(65, sourceType, undefinedType, node) || errorType;
            }
            checkArrayLiteralDestructuringElementAssignment(node, sourceType, i, type2, checkMode);
          }
          return sourceType;
        }
        function checkArrayLiteralDestructuringElementAssignment(node, sourceType, elementIndex, elementType, checkMode) {
          var elements = node.elements;
          var element = elements[elementIndex];
          if (element.kind !== 227) {
            if (element.kind !== 225) {
              var indexType = getNumberLiteralType(elementIndex);
              if (isArrayLikeType(sourceType)) {
                var accessFlags = 32 | (hasDefaultValue(element) ? 16 : 0);
                var elementType_2 = getIndexedAccessTypeOrUndefined(sourceType, indexType, accessFlags, createSyntheticExpression(element, indexType)) || errorType;
                var assignedType = hasDefaultValue(element) ? getTypeWithFacts(elementType_2, 524288) : elementType_2;
                var type2 = getFlowTypeOfDestructuring(element, assignedType);
                return checkDestructuringAssignment(element, type2, checkMode);
              }
              return checkDestructuringAssignment(element, elementType, checkMode);
            }
            if (elementIndex < elements.length - 1) {
              error(element, ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            } else {
              var restExpression = element.expression;
              if (restExpression.kind === 221 && restExpression.operatorToken.kind === 63) {
                error(restExpression.operatorToken, ts3.Diagnostics.A_rest_element_cannot_have_an_initializer);
              } else {
                checkGrammarForDisallowedTrailingComma(node.elements, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
                var type2 = everyType(sourceType, isTupleType) ? mapType(sourceType, function(t) {
                  return sliceTupleType(t, elementIndex);
                }) : createArrayType(elementType);
                return checkDestructuringAssignment(restExpression, type2, checkMode);
              }
            }
          }
          return void 0;
        }
        function checkDestructuringAssignment(exprOrAssignment, sourceType, checkMode, rightIsThis) {
          var target;
          if (exprOrAssignment.kind === 297) {
            var prop = exprOrAssignment;
            if (prop.objectAssignmentInitializer) {
              if (strictNullChecks && !(getFalsyFlags(checkExpression(prop.objectAssignmentInitializer)) & 32768)) {
                sourceType = getTypeWithFacts(sourceType, 524288);
              }
              checkBinaryLikeExpression(prop.name, prop.equalsToken, prop.objectAssignmentInitializer, checkMode);
            }
            target = exprOrAssignment.name;
          } else {
            target = exprOrAssignment;
          }
          if (target.kind === 221 && target.operatorToken.kind === 63) {
            checkBinaryExpression(target, checkMode);
            target = target.left;
          }
          if (target.kind === 205) {
            return checkObjectLiteralAssignment(target, sourceType, rightIsThis);
          }
          if (target.kind === 204) {
            return checkArrayLiteralAssignment(target, sourceType, checkMode);
          }
          return checkReferenceAssignment(target, sourceType, checkMode);
        }
        function checkReferenceAssignment(target, sourceType, checkMode) {
          var targetType = checkExpression(target, checkMode);
          var error2 = target.parent.kind === 298 ? ts3.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access : ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access;
          var optionalError = target.parent.kind === 298 ? ts3.Diagnostics.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access : ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;
          if (checkReferenceExpression(target, error2, optionalError)) {
            checkTypeAssignableToAndOptionallyElaborate(sourceType, targetType, target, target);
          }
          if (ts3.isPrivateIdentifierPropertyAccessExpression(target)) {
            checkExternalEmitHelpers(target.parent, 1048576);
          }
          return sourceType;
        }
        function isSideEffectFree(node) {
          node = ts3.skipParentheses(node);
          switch (node.kind) {
            case 79:
            case 10:
            case 13:
            case 210:
            case 223:
            case 14:
            case 8:
            case 9:
            case 110:
            case 95:
            case 104:
            case 153:
            case 213:
            case 226:
            case 214:
            case 204:
            case 205:
            case 216:
            case 230:
            case 279:
            case 278:
              return true;
            case 222:
              return isSideEffectFree(node.whenTrue) && isSideEffectFree(node.whenFalse);
            case 221:
              if (ts3.isAssignmentOperator(node.operatorToken.kind)) {
                return false;
              }
              return isSideEffectFree(node.left) && isSideEffectFree(node.right);
            case 219:
            case 220:
              switch (node.operator) {
                case 53:
                case 39:
                case 40:
                case 54:
                  return true;
              }
              return false;
            case 217:
            case 211:
            case 229:
            default:
              return false;
          }
        }
        function isTypeEqualityComparableTo(source, target) {
          return (target.flags & 98304) !== 0 || isTypeComparableTo(source, target);
        }
        function createCheckBinaryExpression() {
          var trampoline = ts3.createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, foldState);
          return function(node, checkMode) {
            var result2 = trampoline(node, checkMode);
            ts3.Debug.assertIsDefined(result2);
            return result2;
          };
          function onEnter(node, state, checkMode) {
            if (state) {
              state.stackIndex++;
              state.skip = false;
              setLeftType(state, void 0);
              setLastResult(state, void 0);
            } else {
              state = {
                checkMode,
                skip: false,
                stackIndex: 0,
                typeStack: [void 0, void 0]
              };
            }
            if (ts3.isInJSFile(node) && ts3.getAssignedExpandoInitializer(node)) {
              state.skip = true;
              setLastResult(state, checkExpression(node.right, checkMode));
              return state;
            }
            checkGrammarNullishCoalesceWithLogicalExpression(node);
            var operator = node.operatorToken.kind;
            if (operator === 63 && (node.left.kind === 205 || node.left.kind === 204)) {
              state.skip = true;
              setLastResult(state, checkDestructuringAssignment(node.left, checkExpression(node.right, checkMode), checkMode, node.right.kind === 108));
              return state;
            }
            return state;
          }
          function onLeft(left, state, _node) {
            if (!state.skip) {
              return maybeCheckExpression(state, left);
            }
          }
          function onOperator(operatorToken, state, node) {
            if (!state.skip) {
              var leftType = getLastResult(state);
              ts3.Debug.assertIsDefined(leftType);
              setLeftType(state, leftType);
              setLastResult(state, void 0);
              var operator = operatorToken.kind;
              if (operator === 55 || operator === 56 || operator === 60) {
                if (operator === 55) {
                  var parent = ts3.walkUpParenthesizedExpressions(node.parent);
                  checkTestingKnownTruthyCallableOrAwaitableType(node.left, ts3.isIfStatement(parent) ? parent.thenStatement : void 0);
                }
                checkTruthinessOfType(leftType, node.left);
              }
            }
          }
          function onRight(right, state, _node) {
            if (!state.skip) {
              return maybeCheckExpression(state, right);
            }
          }
          function onExit(node, state) {
            var result2;
            if (state.skip) {
              result2 = getLastResult(state);
            } else {
              var leftType = getLeftType(state);
              ts3.Debug.assertIsDefined(leftType);
              var rightType = getLastResult(state);
              ts3.Debug.assertIsDefined(rightType);
              result2 = checkBinaryLikeExpressionWorker(node.left, node.operatorToken, node.right, leftType, rightType, node);
            }
            state.skip = false;
            setLeftType(state, void 0);
            setLastResult(state, void 0);
            state.stackIndex--;
            return result2;
          }
          function foldState(state, result2, _side) {
            setLastResult(state, result2);
            return state;
          }
          function maybeCheckExpression(state, node) {
            if (ts3.isBinaryExpression(node)) {
              return node;
            }
            setLastResult(state, checkExpression(node, state.checkMode));
          }
          function getLeftType(state) {
            return state.typeStack[state.stackIndex];
          }
          function setLeftType(state, type2) {
            state.typeStack[state.stackIndex] = type2;
          }
          function getLastResult(state) {
            return state.typeStack[state.stackIndex + 1];
          }
          function setLastResult(state, type2) {
            state.typeStack[state.stackIndex + 1] = type2;
          }
        }
        function checkGrammarNullishCoalesceWithLogicalExpression(node) {
          var left = node.left, operatorToken = node.operatorToken, right = node.right;
          if (operatorToken.kind === 60) {
            if (ts3.isBinaryExpression(left) && (left.operatorToken.kind === 56 || left.operatorToken.kind === 55)) {
              grammarErrorOnNode(left, ts3.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, ts3.tokenToString(left.operatorToken.kind), ts3.tokenToString(operatorToken.kind));
            }
            if (ts3.isBinaryExpression(right) && (right.operatorToken.kind === 56 || right.operatorToken.kind === 55)) {
              grammarErrorOnNode(right, ts3.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, ts3.tokenToString(right.operatorToken.kind), ts3.tokenToString(operatorToken.kind));
            }
          }
        }
        function checkBinaryLikeExpression(left, operatorToken, right, checkMode, errorNode) {
          var operator = operatorToken.kind;
          if (operator === 63 && (left.kind === 205 || left.kind === 204)) {
            return checkDestructuringAssignment(left, checkExpression(right, checkMode), checkMode, right.kind === 108);
          }
          var leftType;
          if (operator === 55 || operator === 56 || operator === 60) {
            leftType = checkTruthinessExpression(left, checkMode);
          } else {
            leftType = checkExpression(left, checkMode);
          }
          var rightType = checkExpression(right, checkMode);
          return checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, errorNode);
        }
        function checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, errorNode) {
          var operator = operatorToken.kind;
          switch (operator) {
            case 41:
            case 42:
            case 66:
            case 67:
            case 43:
            case 68:
            case 44:
            case 69:
            case 40:
            case 65:
            case 47:
            case 70:
            case 48:
            case 71:
            case 49:
            case 72:
            case 51:
            case 74:
            case 52:
            case 78:
            case 50:
            case 73:
              if (leftType === silentNeverType || rightType === silentNeverType) {
                return silentNeverType;
              }
              leftType = checkNonNullType(leftType, left);
              rightType = checkNonNullType(rightType, right);
              var suggestedOperator = void 0;
              if (leftType.flags & 528 && rightType.flags & 528 && (suggestedOperator = getSuggestedBooleanOperator(operatorToken.kind)) !== void 0) {
                error(errorNode || operatorToken, ts3.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead, ts3.tokenToString(operatorToken.kind), ts3.tokenToString(suggestedOperator));
                return numberType;
              } else {
                var leftOk = checkArithmeticOperandType(left, leftType, ts3.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true);
                var rightOk = checkArithmeticOperandType(right, rightType, ts3.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true);
                var resultType_1;
                if (isTypeAssignableToKind(leftType, 3) && isTypeAssignableToKind(rightType, 3) || !(maybeTypeOfKind(leftType, 2112) || maybeTypeOfKind(rightType, 2112))) {
                  resultType_1 = numberType;
                } else if (bothAreBigIntLike(leftType, rightType)) {
                  switch (operator) {
                    case 49:
                    case 72:
                      reportOperatorError();
                      break;
                    case 42:
                    case 67:
                      if (languageVersion < 3) {
                        error(errorNode, ts3.Diagnostics.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later);
                      }
                  }
                  resultType_1 = bigintType;
                } else {
                  reportOperatorError(bothAreBigIntLike);
                  resultType_1 = errorType;
                }
                if (leftOk && rightOk) {
                  checkAssignmentOperator(resultType_1);
                }
                return resultType_1;
              }
            case 39:
            case 64:
              if (leftType === silentNeverType || rightType === silentNeverType) {
                return silentNeverType;
              }
              if (!isTypeAssignableToKind(leftType, 402653316) && !isTypeAssignableToKind(rightType, 402653316)) {
                leftType = checkNonNullType(leftType, left);
                rightType = checkNonNullType(rightType, right);
              }
              var resultType = void 0;
              if (isTypeAssignableToKind(leftType, 296, true) && isTypeAssignableToKind(rightType, 296, true)) {
                resultType = numberType;
              } else if (isTypeAssignableToKind(leftType, 2112, true) && isTypeAssignableToKind(rightType, 2112, true)) {
                resultType = bigintType;
              } else if (isTypeAssignableToKind(leftType, 402653316, true) || isTypeAssignableToKind(rightType, 402653316, true)) {
                resultType = stringType;
              } else if (isTypeAny(leftType) || isTypeAny(rightType)) {
                resultType = isErrorType(leftType) || isErrorType(rightType) ? errorType : anyType;
              }
              if (resultType && !checkForDisallowedESSymbolOperand(operator)) {
                return resultType;
              }
              if (!resultType) {
                var closeEnoughKind_1 = 296 | 2112 | 402653316 | 3;
                reportOperatorError(function(left2, right2) {
                  return isTypeAssignableToKind(left2, closeEnoughKind_1) && isTypeAssignableToKind(right2, closeEnoughKind_1);
                });
                return anyType;
              }
              if (operator === 64) {
                checkAssignmentOperator(resultType);
              }
              return resultType;
            case 29:
            case 31:
            case 32:
            case 33:
              if (checkForDisallowedESSymbolOperand(operator)) {
                leftType = getBaseTypeOfLiteralType(checkNonNullType(leftType, left));
                rightType = getBaseTypeOfLiteralType(checkNonNullType(rightType, right));
                reportOperatorErrorUnless(function(left2, right2) {
                  return isTypeComparableTo(left2, right2) || isTypeComparableTo(right2, left2) || isTypeAssignableTo(left2, numberOrBigIntType) && isTypeAssignableTo(right2, numberOrBigIntType);
                });
              }
              return booleanType;
            case 34:
            case 35:
            case 36:
            case 37:
              reportOperatorErrorUnless(function(left2, right2) {
                return isTypeEqualityComparableTo(left2, right2) || isTypeEqualityComparableTo(right2, left2);
              });
              return booleanType;
            case 102:
              return checkInstanceOfExpression(left, right, leftType, rightType);
            case 101:
              return checkInExpression(left, right, leftType, rightType);
            case 55:
            case 76: {
              var resultType_2 = getTypeFacts(leftType) & 4194304 ? getUnionType([extractDefinitelyFalsyTypes(strictNullChecks ? leftType : getBaseTypeOfLiteralType(rightType)), rightType]) : leftType;
              if (operator === 76) {
                checkAssignmentOperator(rightType);
              }
              return resultType_2;
            }
            case 56:
            case 75: {
              var resultType_3 = getTypeFacts(leftType) & 8388608 ? getUnionType([removeDefinitelyFalsyTypes(leftType), rightType], 2) : leftType;
              if (operator === 75) {
                checkAssignmentOperator(rightType);
              }
              return resultType_3;
            }
            case 60:
            case 77: {
              var resultType_4 = getTypeFacts(leftType) & 262144 ? getUnionType([getNonNullableType(leftType), rightType], 2) : leftType;
              if (operator === 77) {
                checkAssignmentOperator(rightType);
              }
              return resultType_4;
            }
            case 63:
              var declKind = ts3.isBinaryExpression(left.parent) ? ts3.getAssignmentDeclarationKind(left.parent) : 0;
              checkAssignmentDeclaration(declKind, rightType);
              if (isAssignmentDeclaration(declKind)) {
                if (!(rightType.flags & 524288) || declKind !== 2 && declKind !== 6 && !isEmptyObjectType(rightType) && !isFunctionObjectType(rightType) && !(ts3.getObjectFlags(rightType) & 1)) {
                  checkAssignmentOperator(rightType);
                }
                return leftType;
              } else {
                checkAssignmentOperator(rightType);
                return getRegularTypeOfObjectLiteral(rightType);
              }
            case 27:
              if (!compilerOptions.allowUnreachableCode && isSideEffectFree(left) && !isEvalNode(right)) {
                var sf = ts3.getSourceFileOfNode(left);
                var sourceText = sf.text;
                var start_3 = ts3.skipTrivia(sourceText, left.pos);
                var isInDiag2657 = sf.parseDiagnostics.some(function(diag) {
                  if (diag.code !== ts3.Diagnostics.JSX_expressions_must_have_one_parent_element.code)
                    return false;
                  return ts3.textSpanContainsPosition(diag, start_3);
                });
                if (!isInDiag2657)
                  error(left, ts3.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects);
              }
              return rightType;
            default:
              return ts3.Debug.fail();
          }
          function bothAreBigIntLike(left2, right2) {
            return isTypeAssignableToKind(left2, 2112) && isTypeAssignableToKind(right2, 2112);
          }
          function checkAssignmentDeclaration(kind, rightType2) {
            if (kind === 2) {
              for (var _i = 0, _a = getPropertiesOfObjectType(rightType2); _i < _a.length; _i++) {
                var prop = _a[_i];
                var propType = getTypeOfSymbol(prop);
                if (propType.symbol && propType.symbol.flags & 32) {
                  var name = prop.escapedName;
                  var symbol = resolveName(prop.valueDeclaration, name, 788968, void 0, name, false);
                  if ((symbol === null || symbol === void 0 ? void 0 : symbol.declarations) && symbol.declarations.some(ts3.isJSDocTypedefTag)) {
                    addDuplicateDeclarationErrorsForSymbols(symbol, ts3.Diagnostics.Duplicate_identifier_0, ts3.unescapeLeadingUnderscores(name), prop);
                    addDuplicateDeclarationErrorsForSymbols(prop, ts3.Diagnostics.Duplicate_identifier_0, ts3.unescapeLeadingUnderscores(name), symbol);
                  }
                }
              }
            }
          }
          function isEvalNode(node) {
            return node.kind === 79 && node.escapedText === "eval";
          }
          function checkForDisallowedESSymbolOperand(operator2) {
            var offendingSymbolOperand = maybeTypeOfKindConsideringBaseConstraint(leftType, 12288) ? left : maybeTypeOfKindConsideringBaseConstraint(rightType, 12288) ? right : void 0;
            if (offendingSymbolOperand) {
              error(offendingSymbolOperand, ts3.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, ts3.tokenToString(operator2));
              return false;
            }
            return true;
          }
          function getSuggestedBooleanOperator(operator2) {
            switch (operator2) {
              case 51:
              case 74:
                return 56;
              case 52:
              case 78:
                return 37;
              case 50:
              case 73:
                return 55;
              default:
                return void 0;
            }
          }
          function checkAssignmentOperator(valueType) {
            if (ts3.isAssignmentOperator(operator)) {
              addLazyDiagnostic(checkAssignmentOperatorWorker);
            }
            function checkAssignmentOperatorWorker() {
              if (checkReferenceExpression(left, ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access) && (!ts3.isIdentifier(left) || ts3.unescapeLeadingUnderscores(left.escapedText) !== "exports")) {
                var headMessage = void 0;
                if (exactOptionalPropertyTypes && ts3.isPropertyAccessExpression(left) && maybeTypeOfKind(valueType, 32768)) {
                  var target = getTypeOfPropertyOfType(getTypeOfExpression(left.expression), left.name.escapedText);
                  if (isExactOptionalPropertyMismatch(valueType, target)) {
                    headMessage = ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target;
                  }
                }
                checkTypeAssignableToAndOptionallyElaborate(valueType, leftType, left, right, headMessage);
              }
            }
          }
          function isAssignmentDeclaration(kind) {
            var _a;
            switch (kind) {
              case 2:
                return true;
              case 1:
              case 5:
              case 6:
              case 3:
              case 4:
                var symbol = getSymbolOfNode(left);
                var init = ts3.getAssignedExpandoInitializer(right);
                return !!init && ts3.isObjectLiteralExpression(init) && !!((_a = symbol === null || symbol === void 0 ? void 0 : symbol.exports) === null || _a === void 0 ? void 0 : _a.size);
              default:
                return false;
            }
          }
          function reportOperatorErrorUnless(typesAreCompatible) {
            if (!typesAreCompatible(leftType, rightType)) {
              reportOperatorError(typesAreCompatible);
              return true;
            }
            return false;
          }
          function reportOperatorError(isRelated) {
            var _a;
            var wouldWorkWithAwait = false;
            var errNode = errorNode || operatorToken;
            if (isRelated) {
              var awaitedLeftType = getAwaitedTypeNoAlias(leftType);
              var awaitedRightType = getAwaitedTypeNoAlias(rightType);
              wouldWorkWithAwait = !(awaitedLeftType === leftType && awaitedRightType === rightType) && !!(awaitedLeftType && awaitedRightType) && isRelated(awaitedLeftType, awaitedRightType);
            }
            var effectiveLeft = leftType;
            var effectiveRight = rightType;
            if (!wouldWorkWithAwait && isRelated) {
              _a = getBaseTypesIfUnrelated(leftType, rightType, isRelated), effectiveLeft = _a[0], effectiveRight = _a[1];
            }
            var _b = getTypeNamesForErrorDisplay(effectiveLeft, effectiveRight), leftStr = _b[0], rightStr = _b[1];
            if (!tryGiveBetterPrimaryError(errNode, wouldWorkWithAwait, leftStr, rightStr)) {
              errorAndMaybeSuggestAwait(errNode, wouldWorkWithAwait, ts3.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2, ts3.tokenToString(operatorToken.kind), leftStr, rightStr);
            }
          }
          function tryGiveBetterPrimaryError(errNode, maybeMissingAwait, leftStr, rightStr) {
            var typeName;
            switch (operatorToken.kind) {
              case 36:
              case 34:
                typeName = "false";
                break;
              case 37:
              case 35:
                typeName = "true";
            }
            if (typeName) {
              return errorAndMaybeSuggestAwait(errNode, maybeMissingAwait, ts3.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap, typeName, leftStr, rightStr);
            }
            return void 0;
          }
        }
        function getBaseTypesIfUnrelated(leftType, rightType, isRelated) {
          var effectiveLeft = leftType;
          var effectiveRight = rightType;
          var leftBase = getBaseTypeOfLiteralType(leftType);
          var rightBase = getBaseTypeOfLiteralType(rightType);
          if (!isRelated(leftBase, rightBase)) {
            effectiveLeft = leftBase;
            effectiveRight = rightBase;
          }
          return [effectiveLeft, effectiveRight];
        }
        function checkYieldExpression(node) {
          addLazyDiagnostic(checkYieldExpressionGrammar);
          var func = ts3.getContainingFunction(node);
          if (!func)
            return anyType;
          var functionFlags = ts3.getFunctionFlags(func);
          if (!(functionFlags & 1)) {
            return anyType;
          }
          var isAsync = (functionFlags & 2) !== 0;
          if (node.asteriskToken) {
            if (isAsync && languageVersion < 99) {
              checkExternalEmitHelpers(node, 26624);
            }
            if (!isAsync && languageVersion < 2 && compilerOptions.downlevelIteration) {
              checkExternalEmitHelpers(node, 256);
            }
          }
          var returnType = getReturnTypeFromAnnotation(func);
          var iterationTypes = returnType && getIterationTypesOfGeneratorFunctionReturnType(returnType, isAsync);
          var signatureYieldType = iterationTypes && iterationTypes.yieldType || anyType;
          var signatureNextType = iterationTypes && iterationTypes.nextType || anyType;
          var resolvedSignatureNextType = isAsync ? getAwaitedType(signatureNextType) || anyType : signatureNextType;
          var yieldExpressionType = node.expression ? checkExpression(node.expression) : undefinedWideningType;
          var yieldedType = getYieldedTypeOfYieldExpression(node, yieldExpressionType, resolvedSignatureNextType, isAsync);
          if (returnType && yieldedType) {
            checkTypeAssignableToAndOptionallyElaborate(yieldedType, signatureYieldType, node.expression || node, node.expression);
          }
          if (node.asteriskToken) {
            var use = isAsync ? 19 : 17;
            return getIterationTypeOfIterable(use, 1, yieldExpressionType, node.expression) || anyType;
          } else if (returnType) {
            return getIterationTypeOfGeneratorFunctionReturnType(2, returnType, isAsync) || anyType;
          }
          var type2 = getContextualIterationType(2, func);
          if (!type2) {
            type2 = anyType;
            addLazyDiagnostic(function() {
              if (noImplicitAny && !ts3.expressionResultIsUnused(node)) {
                var contextualType = getContextualType(node);
                if (!contextualType || isTypeAny(contextualType)) {
                  error(node, ts3.Diagnostics.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation);
                }
              }
            });
          }
          return type2;
          function checkYieldExpressionGrammar() {
            if (!(node.flags & 8192)) {
              grammarErrorOnFirstToken(node, ts3.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body);
            }
            if (isInParameterInitializerBeforeContainingFunction(node)) {
              error(node, ts3.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer);
            }
          }
        }
        function checkConditionalExpression(node, checkMode) {
          checkTruthinessExpression(node.condition);
          checkTestingKnownTruthyCallableOrAwaitableType(node.condition, node.whenTrue);
          var type1 = checkExpression(node.whenTrue, checkMode);
          var type2 = checkExpression(node.whenFalse, checkMode);
          return getUnionType([type1, type2], 2);
        }
        function isTemplateLiteralContext(node) {
          var parent = node.parent;
          return ts3.isParenthesizedExpression(parent) && isTemplateLiteralContext(parent) || ts3.isElementAccessExpression(parent) && parent.argumentExpression === node;
        }
        function checkTemplateExpression(node) {
          var texts = [node.head.text];
          var types2 = [];
          for (var _i = 0, _a = node.templateSpans; _i < _a.length; _i++) {
            var span = _a[_i];
            var type2 = checkExpression(span.expression);
            if (maybeTypeOfKindConsideringBaseConstraint(type2, 12288)) {
              error(span.expression, ts3.Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String);
            }
            texts.push(span.literal.text);
            types2.push(isTypeAssignableTo(type2, templateConstraintType) ? type2 : stringType);
          }
          return isConstContext(node) || isTemplateLiteralContext(node) || someType(getContextualType(node) || unknownType, isTemplateLiteralContextualType) ? getTemplateLiteralType(texts, types2) : stringType;
        }
        function isTemplateLiteralContextualType(type2) {
          return !!(type2.flags & (128 | 134217728) || type2.flags & 58982400 && maybeTypeOfKind(getBaseConstraintOfType(type2) || unknownType, 402653316));
        }
        function getContextNode(node) {
          if (node.kind === 286 && !ts3.isJsxSelfClosingElement(node.parent)) {
            return node.parent.parent;
          }
          return node;
        }
        function checkExpressionWithContextualType(node, contextualType, inferenceContext, checkMode) {
          var context = getContextNode(node);
          var saveContextualType = context.contextualType;
          var saveInferenceContext = context.inferenceContext;
          try {
            context.contextualType = contextualType;
            context.inferenceContext = inferenceContext;
            var type2 = checkExpression(node, checkMode | 1 | (inferenceContext ? 2 : 0));
            if (inferenceContext && inferenceContext.intraExpressionInferenceSites) {
              inferenceContext.intraExpressionInferenceSites = void 0;
            }
            var result2 = maybeTypeOfKind(type2, 2944) && isLiteralOfContextualType(type2, instantiateContextualType(contextualType, node)) ? getRegularTypeOfLiteralType(type2) : type2;
            return result2;
          } finally {
            context.contextualType = saveContextualType;
            context.inferenceContext = saveInferenceContext;
          }
        }
        function checkExpressionCached(node, checkMode) {
          if (checkMode && checkMode !== 0) {
            return checkExpression(node, checkMode);
          }
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var saveFlowLoopStart = flowLoopStart;
            var saveFlowTypeCache = flowTypeCache;
            flowLoopStart = flowLoopCount;
            flowTypeCache = void 0;
            links.resolvedType = checkExpression(node, checkMode);
            flowTypeCache = saveFlowTypeCache;
            flowLoopStart = saveFlowLoopStart;
          }
          return links.resolvedType;
        }
        function isTypeAssertion(node) {
          node = ts3.skipParentheses(node, true);
          return node.kind === 211 || node.kind === 229 || ts3.isJSDocTypeAssertion(node);
        }
        function checkDeclarationInitializer(declaration, checkMode, contextualType) {
          var initializer = ts3.getEffectiveInitializer(declaration);
          var type2 = getQuickTypeOfExpression(initializer) || (contextualType ? checkExpressionWithContextualType(initializer, contextualType, void 0, checkMode || 0) : checkExpressionCached(initializer, checkMode));
          return ts3.isParameter(declaration) && declaration.name.kind === 202 && isTupleType(type2) && !type2.target.hasRestElement && getTypeReferenceArity(type2) < declaration.name.elements.length ? padTupleType(type2, declaration.name) : type2;
        }
        function padTupleType(type2, pattern) {
          var patternElements = pattern.elements;
          var elementTypes = getTypeArguments(type2).slice();
          var elementFlags = type2.target.elementFlags.slice();
          for (var i = getTypeReferenceArity(type2); i < patternElements.length; i++) {
            var e = patternElements[i];
            if (i < patternElements.length - 1 || !(e.kind === 203 && e.dotDotDotToken)) {
              elementTypes.push(!ts3.isOmittedExpression(e) && hasDefaultValue(e) ? getTypeFromBindingElement(e, false, false) : anyType);
              elementFlags.push(2);
              if (!ts3.isOmittedExpression(e) && !hasDefaultValue(e)) {
                reportImplicitAny(e, anyType);
              }
            }
          }
          return createTupleType(elementTypes, elementFlags, type2.target.readonly);
        }
        function widenTypeInferredFromInitializer(declaration, type2) {
          var widened = ts3.getCombinedNodeFlags(declaration) & 2 || ts3.isDeclarationReadonly(declaration) ? type2 : getWidenedLiteralType(type2);
          if (ts3.isInJSFile(declaration)) {
            if (isEmptyLiteralType(widened)) {
              reportImplicitAny(declaration, anyType);
              return anyType;
            } else if (isEmptyArrayLiteralType(widened)) {
              reportImplicitAny(declaration, anyArrayType);
              return anyArrayType;
            }
          }
          return widened;
        }
        function isLiteralOfContextualType(candidateType, contextualType) {
          if (contextualType) {
            if (contextualType.flags & 3145728) {
              var types2 = contextualType.types;
              return ts3.some(types2, function(t) {
                return isLiteralOfContextualType(candidateType, t);
              });
            }
            if (contextualType.flags & 58982400) {
              var constraint = getBaseConstraintOfType(contextualType) || unknownType;
              return maybeTypeOfKind(constraint, 4) && maybeTypeOfKind(candidateType, 128) || maybeTypeOfKind(constraint, 8) && maybeTypeOfKind(candidateType, 256) || maybeTypeOfKind(constraint, 64) && maybeTypeOfKind(candidateType, 2048) || maybeTypeOfKind(constraint, 4096) && maybeTypeOfKind(candidateType, 8192) || isLiteralOfContextualType(candidateType, constraint);
            }
            return !!(contextualType.flags & (128 | 4194304 | 134217728 | 268435456) && maybeTypeOfKind(candidateType, 128) || contextualType.flags & 256 && maybeTypeOfKind(candidateType, 256) || contextualType.flags & 2048 && maybeTypeOfKind(candidateType, 2048) || contextualType.flags & 512 && maybeTypeOfKind(candidateType, 512) || contextualType.flags & 8192 && maybeTypeOfKind(candidateType, 8192));
          }
          return false;
        }
        function isConstContext(node) {
          var parent = node.parent;
          return ts3.isAssertionExpression(parent) && ts3.isConstTypeReference(parent.type) || ts3.isJSDocTypeAssertion(parent) && ts3.isConstTypeReference(ts3.getJSDocTypeAssertionType(parent)) || (ts3.isParenthesizedExpression(parent) || ts3.isArrayLiteralExpression(parent) || ts3.isSpreadElement(parent)) && isConstContext(parent) || (ts3.isPropertyAssignment(parent) || ts3.isShorthandPropertyAssignment(parent) || ts3.isTemplateSpan(parent)) && isConstContext(parent.parent);
        }
        function checkExpressionForMutableLocation(node, checkMode, contextualType, forceTuple) {
          var type2 = checkExpression(node, checkMode, forceTuple);
          return isConstContext(node) || ts3.isCommonJsExportedExpression(node) ? getRegularTypeOfLiteralType(type2) : isTypeAssertion(node) ? type2 : getWidenedLiteralLikeTypeForContextualType(type2, instantiateContextualType(arguments.length === 2 ? getContextualType(node) : contextualType, node));
        }
        function checkPropertyAssignment(node, checkMode) {
          if (node.name.kind === 162) {
            checkComputedPropertyName(node.name);
          }
          return checkExpressionForMutableLocation(node.initializer, checkMode);
        }
        function checkObjectLiteralMethod(node, checkMode) {
          checkGrammarMethod(node);
          if (node.name.kind === 162) {
            checkComputedPropertyName(node.name);
          }
          var uninstantiatedType = checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
          return instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
        }
        function instantiateTypeWithSingleGenericCallSignature(node, type2, checkMode) {
          if (checkMode && checkMode & (2 | 8)) {
            var callSignature = getSingleSignature(type2, 0, true);
            var constructSignature = getSingleSignature(type2, 1, true);
            var signature = callSignature || constructSignature;
            if (signature && signature.typeParameters) {
              var contextualType = getApparentTypeOfContextualType(node, 2);
              if (contextualType) {
                var contextualSignature = getSingleSignature(getNonNullableType(contextualType), callSignature ? 0 : 1, false);
                if (contextualSignature && !contextualSignature.typeParameters) {
                  if (checkMode & 8) {
                    skippedGenericFunction(node, checkMode);
                    return anyFunctionType;
                  }
                  var context = getInferenceContext(node);
                  var returnType = context.signature && getReturnTypeOfSignature(context.signature);
                  var returnSignature = returnType && getSingleCallOrConstructSignature(returnType);
                  if (returnSignature && !returnSignature.typeParameters && !ts3.every(context.inferences, hasInferenceCandidates)) {
                    var uniqueTypeParameters = getUniqueTypeParameters(context, signature.typeParameters);
                    var instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, uniqueTypeParameters);
                    var inferences_3 = ts3.map(context.inferences, function(info) {
                      return createInferenceInfo(info.typeParameter);
                    });
                    applyToParameterTypes(instantiatedSignature, contextualSignature, function(source, target) {
                      inferTypes(inferences_3, source, target, 0, true);
                    });
                    if (ts3.some(inferences_3, hasInferenceCandidates)) {
                      applyToReturnTypes(instantiatedSignature, contextualSignature, function(source, target) {
                        inferTypes(inferences_3, source, target);
                      });
                      if (!hasOverlappingInferences(context.inferences, inferences_3)) {
                        mergeInferences(context.inferences, inferences_3);
                        context.inferredTypeParameters = ts3.concatenate(context.inferredTypeParameters, uniqueTypeParameters);
                        return getOrCreateTypeFromSignature(instantiatedSignature);
                      }
                    }
                  }
                  return getOrCreateTypeFromSignature(instantiateSignatureInContextOf(signature, contextualSignature, context));
                }
              }
            }
          }
          return type2;
        }
        function skippedGenericFunction(node, checkMode) {
          if (checkMode & 2) {
            var context = getInferenceContext(node);
            context.flags |= 4;
          }
        }
        function hasInferenceCandidates(info) {
          return !!(info.candidates || info.contraCandidates);
        }
        function hasOverlappingInferences(a, b) {
          for (var i = 0; i < a.length; i++) {
            if (hasInferenceCandidates(a[i]) && hasInferenceCandidates(b[i])) {
              return true;
            }
          }
          return false;
        }
        function mergeInferences(target, source) {
          for (var i = 0; i < target.length; i++) {
            if (!hasInferenceCandidates(target[i]) && hasInferenceCandidates(source[i])) {
              target[i] = source[i];
            }
          }
        }
        function getUniqueTypeParameters(context, typeParameters) {
          var result2 = [];
          var oldTypeParameters;
          var newTypeParameters;
          for (var _i = 0, typeParameters_2 = typeParameters; _i < typeParameters_2.length; _i++) {
            var tp = typeParameters_2[_i];
            var name = tp.symbol.escapedName;
            if (hasTypeParameterByName(context.inferredTypeParameters, name) || hasTypeParameterByName(result2, name)) {
              var newName = getUniqueTypeParameterName(ts3.concatenate(context.inferredTypeParameters, result2), name);
              var symbol = createSymbol(262144, newName);
              var newTypeParameter = createTypeParameter(symbol);
              newTypeParameter.target = tp;
              oldTypeParameters = ts3.append(oldTypeParameters, tp);
              newTypeParameters = ts3.append(newTypeParameters, newTypeParameter);
              result2.push(newTypeParameter);
            } else {
              result2.push(tp);
            }
          }
          if (newTypeParameters) {
            var mapper = createTypeMapper(oldTypeParameters, newTypeParameters);
            for (var _a = 0, newTypeParameters_1 = newTypeParameters; _a < newTypeParameters_1.length; _a++) {
              var tp = newTypeParameters_1[_a];
              tp.mapper = mapper;
            }
          }
          return result2;
        }
        function hasTypeParameterByName(typeParameters, name) {
          return ts3.some(typeParameters, function(tp) {
            return tp.symbol.escapedName === name;
          });
        }
        function getUniqueTypeParameterName(typeParameters, baseName) {
          var len = baseName.length;
          while (len > 1 && baseName.charCodeAt(len - 1) >= 48 && baseName.charCodeAt(len - 1) <= 57)
            len--;
          var s = baseName.slice(0, len);
          for (var index = 1; true; index++) {
            var augmentedName = s + index;
            if (!hasTypeParameterByName(typeParameters, augmentedName)) {
              return augmentedName;
            }
          }
        }
        function getReturnTypeOfSingleNonGenericCallSignature(funcType) {
          var signature = getSingleCallSignature(funcType);
          if (signature && !signature.typeParameters) {
            return getReturnTypeOfSignature(signature);
          }
        }
        function getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) {
          var funcType = checkExpression(expr.expression);
          var nonOptionalType = getOptionalExpressionType(funcType, expr.expression);
          var returnType = getReturnTypeOfSingleNonGenericCallSignature(funcType);
          return returnType && propagateOptionalTypeMarker(returnType, expr, nonOptionalType !== funcType);
        }
        function getTypeOfExpression(node) {
          var quickType = getQuickTypeOfExpression(node);
          if (quickType) {
            return quickType;
          }
          if (node.flags & 134217728 && flowTypeCache) {
            var cachedType = flowTypeCache[getNodeId(node)];
            if (cachedType) {
              return cachedType;
            }
          }
          var startInvocationCount = flowInvocationCount;
          var type2 = checkExpression(node);
          if (flowInvocationCount !== startInvocationCount) {
            var cache = flowTypeCache || (flowTypeCache = []);
            cache[getNodeId(node)] = type2;
            ts3.setNodeFlags(node, node.flags | 134217728);
          }
          return type2;
        }
        function getQuickTypeOfExpression(node) {
          var expr = ts3.skipParentheses(node, true);
          if (ts3.isJSDocTypeAssertion(expr)) {
            var type2 = ts3.getJSDocTypeAssertionType(expr);
            if (!ts3.isConstTypeReference(type2)) {
              return getTypeFromTypeNode(type2);
            }
          }
          expr = ts3.skipParentheses(node);
          if (ts3.isCallExpression(expr) && expr.expression.kind !== 106 && !ts3.isRequireCall(expr, true) && !isSymbolOrSymbolForCall(expr)) {
            var type2 = ts3.isCallChain(expr) ? getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) : getReturnTypeOfSingleNonGenericCallSignature(checkNonNullExpression(expr.expression));
            if (type2) {
              return type2;
            }
          } else if (ts3.isAssertionExpression(expr) && !ts3.isConstTypeReference(expr.type)) {
            return getTypeFromTypeNode(expr.type);
          } else if (node.kind === 8 || node.kind === 10 || node.kind === 110 || node.kind === 95) {
            return checkExpression(node);
          }
          return void 0;
        }
        function getContextFreeTypeOfExpression(node) {
          var links = getNodeLinks(node);
          if (links.contextFreeType) {
            return links.contextFreeType;
          }
          var saveContextualType = node.contextualType;
          node.contextualType = anyType;
          try {
            var type2 = links.contextFreeType = checkExpression(node, 4);
            return type2;
          } finally {
            node.contextualType = saveContextualType;
          }
        }
        function checkExpression(node, checkMode, forceTuple) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkExpression", { kind: node.kind, pos: node.pos, end: node.end, path: node.tracingPath });
          var saveCurrentNode = currentNode;
          currentNode = node;
          instantiationCount = 0;
          var uninstantiatedType = checkExpressionWorker(node, checkMode, forceTuple);
          var type2 = instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
          if (isConstEnumObjectType(type2)) {
            checkConstEnumAccess(node, type2);
          }
          currentNode = saveCurrentNode;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return type2;
        }
        function checkConstEnumAccess(node, type2) {
          var ok = node.parent.kind === 206 && node.parent.expression === node || node.parent.kind === 207 && node.parent.expression === node || ((node.kind === 79 || node.kind === 161) && isInRightSideOfImportOrExportAssignment(node) || node.parent.kind === 181 && node.parent.exprName === node) || node.parent.kind === 275;
          if (!ok) {
            error(node, ts3.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query);
          }
          if (compilerOptions.isolatedModules) {
            ts3.Debug.assert(!!(type2.symbol.flags & 128));
            var constEnumDeclaration = type2.symbol.valueDeclaration;
            if (constEnumDeclaration.flags & 16777216) {
              error(node, ts3.Diagnostics.Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided);
            }
          }
        }
        function checkParenthesizedExpression(node, checkMode) {
          if (ts3.hasJSDocNodes(node) && ts3.isJSDocTypeAssertion(node)) {
            var type2 = ts3.getJSDocTypeAssertionType(node);
            return checkAssertionWorker(type2, type2, node.expression, checkMode);
          }
          return checkExpression(node.expression, checkMode);
        }
        function checkExpressionWorker(node, checkMode, forceTuple) {
          var kind = node.kind;
          if (cancellationToken) {
            switch (kind) {
              case 226:
              case 213:
              case 214:
                cancellationToken.throwIfCancellationRequested();
            }
          }
          switch (kind) {
            case 79:
              return checkIdentifier(node, checkMode);
            case 80:
              return checkPrivateIdentifierExpression(node);
            case 108:
              return checkThisExpression(node);
            case 106:
              return checkSuperExpression(node);
            case 104:
              return nullWideningType;
            case 14:
            case 10:
              return getFreshTypeOfLiteralType(getStringLiteralType(node.text));
            case 8:
              checkGrammarNumericLiteral(node);
              return getFreshTypeOfLiteralType(getNumberLiteralType(+node.text));
            case 9:
              checkGrammarBigIntLiteral(node);
              return getFreshTypeOfLiteralType(getBigIntLiteralType({
                negative: false,
                base10Value: ts3.parsePseudoBigInt(node.text)
              }));
            case 110:
              return trueType;
            case 95:
              return falseType;
            case 223:
              return checkTemplateExpression(node);
            case 13:
              return globalRegExpType;
            case 204:
              return checkArrayLiteral(node, checkMode, forceTuple);
            case 205:
              return checkObjectLiteral(node, checkMode);
            case 206:
              return checkPropertyAccessExpression(node, checkMode);
            case 161:
              return checkQualifiedName(node, checkMode);
            case 207:
              return checkIndexedAccess(node, checkMode);
            case 208:
              if (node.expression.kind === 100) {
                return checkImportCallExpression(node);
              }
            case 209:
              return checkCallExpression(node, checkMode);
            case 210:
              return checkTaggedTemplateExpression(node);
            case 212:
              return checkParenthesizedExpression(node, checkMode);
            case 226:
              return checkClassExpression(node);
            case 213:
            case 214:
              return checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
            case 216:
              return checkTypeOfExpression(node);
            case 211:
            case 229:
              return checkAssertion(node);
            case 230:
              return checkNonNullAssertion(node);
            case 228:
              return checkExpressionWithTypeArguments(node);
            case 231:
              return checkMetaProperty(node);
            case 215:
              return checkDeleteExpression(node);
            case 217:
              return checkVoidExpression(node);
            case 218:
              return checkAwaitExpression(node);
            case 219:
              return checkPrefixUnaryExpression(node);
            case 220:
              return checkPostfixUnaryExpression(node);
            case 221:
              return checkBinaryExpression(node, checkMode);
            case 222:
              return checkConditionalExpression(node, checkMode);
            case 225:
              return checkSpreadExpression(node, checkMode);
            case 227:
              return undefinedWideningType;
            case 224:
              return checkYieldExpression(node);
            case 232:
              return checkSyntheticExpression(node);
            case 288:
              return checkJsxExpression(node, checkMode);
            case 278:
              return checkJsxElement(node, checkMode);
            case 279:
              return checkJsxSelfClosingElement(node, checkMode);
            case 282:
              return checkJsxFragment(node);
            case 286:
              return checkJsxAttributes(node, checkMode);
            case 280:
              ts3.Debug.fail("Shouldn't ever directly check a JsxOpeningElement");
          }
          return errorType;
        }
        function checkTypeParameter(node) {
          checkGrammarModifiers(node);
          if (node.expression) {
            grammarErrorOnFirstToken(node.expression, ts3.Diagnostics.Type_expected);
          }
          checkSourceElement(node.constraint);
          checkSourceElement(node.default);
          var typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node));
          getBaseConstraintOfType(typeParameter);
          if (!hasNonCircularTypeParameterDefault(typeParameter)) {
            error(node.default, ts3.Diagnostics.Type_parameter_0_has_a_circular_default, typeToString(typeParameter));
          }
          var constraintType = getConstraintOfTypeParameter(typeParameter);
          var defaultType = getDefaultFromTypeParameter(typeParameter);
          if (constraintType && defaultType) {
            checkTypeAssignableTo(defaultType, getTypeWithThisArgument(instantiateType(constraintType, makeUnaryTypeMapper(typeParameter, defaultType)), defaultType), node.default, ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
          }
          checkNodeDeferred(node);
          addLazyDiagnostic(function() {
            return checkTypeNameIsReserved(node.name, ts3.Diagnostics.Type_parameter_name_cannot_be_0);
          });
        }
        function checkTypeParameterDeferred(node) {
          if (ts3.isInterfaceDeclaration(node.parent) || ts3.isClassLike(node.parent) || ts3.isTypeAliasDeclaration(node.parent)) {
            var typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node));
            var modifiers = getVarianceModifiers(typeParameter);
            if (modifiers) {
              var symbol = getSymbolOfNode(node.parent);
              if (ts3.isTypeAliasDeclaration(node.parent) && !(ts3.getObjectFlags(getDeclaredTypeOfSymbol(symbol)) & (16 | 32))) {
                error(node, ts3.Diagnostics.Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types);
              } else if (modifiers === 32768 || modifiers === 65536) {
                var source = createMarkerType(symbol, typeParameter, modifiers === 65536 ? markerSubType : markerSuperType);
                var target = createMarkerType(symbol, typeParameter, modifiers === 65536 ? markerSuperType : markerSubType);
                var saveVarianceTypeParameter = typeParameter;
                varianceTypeParameter = typeParameter;
                checkTypeAssignableTo(source, target, node, ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation);
                varianceTypeParameter = saveVarianceTypeParameter;
              }
            }
          }
        }
        function checkParameter(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkVariableLikeDeclaration(node);
          var func = ts3.getContainingFunction(node);
          if (ts3.hasSyntacticModifier(node, 16476)) {
            if (!(func.kind === 171 && ts3.nodeIsPresent(func.body))) {
              error(node, ts3.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);
            }
            if (func.kind === 171 && ts3.isIdentifier(node.name) && node.name.escapedText === "constructor") {
              error(node.name, ts3.Diagnostics.constructor_cannot_be_used_as_a_parameter_property_name);
            }
          }
          if (node.questionToken && ts3.isBindingPattern(node.name) && func.body) {
            error(node, ts3.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature);
          }
          if (node.name && ts3.isIdentifier(node.name) && (node.name.escapedText === "this" || node.name.escapedText === "new")) {
            if (func.parameters.indexOf(node) !== 0) {
              error(node, ts3.Diagnostics.A_0_parameter_must_be_the_first_parameter, node.name.escapedText);
            }
            if (func.kind === 171 || func.kind === 175 || func.kind === 180) {
              error(node, ts3.Diagnostics.A_constructor_cannot_have_a_this_parameter);
            }
            if (func.kind === 214) {
              error(node, ts3.Diagnostics.An_arrow_function_cannot_have_a_this_parameter);
            }
            if (func.kind === 172 || func.kind === 173) {
              error(node, ts3.Diagnostics.get_and_set_accessors_cannot_declare_this_parameters);
            }
          }
          if (node.dotDotDotToken && !ts3.isBindingPattern(node.name) && !isTypeAssignableTo(getReducedType(getTypeOfSymbol(node.symbol)), anyReadonlyArrayType)) {
            error(node, ts3.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
          }
        }
        function checkTypePredicate(node) {
          var parent = getTypePredicateParent(node);
          if (!parent) {
            error(node, ts3.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
            return;
          }
          var signature = getSignatureFromDeclaration(parent);
          var typePredicate = getTypePredicateOfSignature(signature);
          if (!typePredicate) {
            return;
          }
          checkSourceElement(node.type);
          var parameterName = node.parameterName;
          if (typePredicate.kind === 0 || typePredicate.kind === 2) {
            getTypeFromThisTypeNode(parameterName);
          } else {
            if (typePredicate.parameterIndex >= 0) {
              if (signatureHasRestParameter(signature) && typePredicate.parameterIndex === signature.parameters.length - 1) {
                error(parameterName, ts3.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);
              } else {
                if (typePredicate.type) {
                  var leadingError = function() {
                    return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);
                  };
                  checkTypeAssignableTo(typePredicate.type, getTypeOfSymbol(signature.parameters[typePredicate.parameterIndex]), node.type, void 0, leadingError);
                }
              }
            } else if (parameterName) {
              var hasReportedError = false;
              for (var _i = 0, _a = parent.parameters; _i < _a.length; _i++) {
                var name = _a[_i].name;
                if (ts3.isBindingPattern(name) && checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, parameterName, typePredicate.parameterName)) {
                  hasReportedError = true;
                  break;
                }
              }
              if (!hasReportedError) {
                error(node.parameterName, ts3.Diagnostics.Cannot_find_parameter_0, typePredicate.parameterName);
              }
            }
          }
        }
        function getTypePredicateParent(node) {
          switch (node.parent.kind) {
            case 214:
            case 174:
            case 256:
            case 213:
            case 179:
            case 169:
            case 168:
              var parent = node.parent;
              if (node === parent.type) {
                return parent;
              }
          }
        }
        function checkIfTypePredicateVariableIsDeclaredInBindingPattern(pattern, predicateVariableNode, predicateVariableName) {
          for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (ts3.isOmittedExpression(element)) {
              continue;
            }
            var name = element.name;
            if (name.kind === 79 && name.escapedText === predicateVariableName) {
              error(predicateVariableNode, ts3.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern, predicateVariableName);
              return true;
            } else if (name.kind === 202 || name.kind === 201) {
              if (checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, predicateVariableNode, predicateVariableName)) {
                return true;
              }
            }
          }
        }
        function checkSignatureDeclaration(node) {
          if (node.kind === 176) {
            checkGrammarIndexSignature(node);
          } else if (node.kind === 179 || node.kind === 256 || node.kind === 180 || node.kind === 174 || node.kind === 171 || node.kind === 175) {
            checkGrammarFunctionLikeDeclaration(node);
          }
          var functionFlags = ts3.getFunctionFlags(node);
          if (!(functionFlags & 4)) {
            if ((functionFlags & 3) === 3 && languageVersion < 99) {
              checkExternalEmitHelpers(node, 6144);
            }
            if ((functionFlags & 3) === 2 && languageVersion < 4) {
              checkExternalEmitHelpers(node, 64);
            }
            if ((functionFlags & 3) !== 0 && languageVersion < 2) {
              checkExternalEmitHelpers(node, 128);
            }
          }
          checkTypeParameters(ts3.getEffectiveTypeParameterDeclarations(node));
          checkUnmatchedJSDocParameters(node);
          ts3.forEach(node.parameters, checkParameter);
          if (node.type) {
            checkSourceElement(node.type);
          }
          addLazyDiagnostic(checkSignatureDeclarationDiagnostics);
          function checkSignatureDeclarationDiagnostics() {
            checkCollisionWithArgumentsInGeneratedCode(node);
            var returnTypeNode = ts3.getEffectiveReturnTypeNode(node);
            if (noImplicitAny && !returnTypeNode) {
              switch (node.kind) {
                case 175:
                  error(node, ts3.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                  break;
                case 174:
                  error(node, ts3.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                  break;
              }
            }
            if (returnTypeNode) {
              var functionFlags_1 = ts3.getFunctionFlags(node);
              if ((functionFlags_1 & (4 | 1)) === 1) {
                var returnType = getTypeFromTypeNode(returnTypeNode);
                if (returnType === voidType) {
                  error(returnTypeNode, ts3.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                } else {
                  var generatorYieldType = getIterationTypeOfGeneratorFunctionReturnType(0, returnType, (functionFlags_1 & 2) !== 0) || anyType;
                  var generatorReturnType = getIterationTypeOfGeneratorFunctionReturnType(1, returnType, (functionFlags_1 & 2) !== 0) || generatorYieldType;
                  var generatorNextType = getIterationTypeOfGeneratorFunctionReturnType(2, returnType, (functionFlags_1 & 2) !== 0) || unknownType;
                  var generatorInstantiation = createGeneratorReturnType(generatorYieldType, generatorReturnType, generatorNextType, !!(functionFlags_1 & 2));
                  checkTypeAssignableTo(generatorInstantiation, returnType, returnTypeNode);
                }
              } else if ((functionFlags_1 & 3) === 2) {
                checkAsyncFunctionReturnType(node, returnTypeNode);
              }
            }
            if (node.kind !== 176 && node.kind !== 317) {
              registerForUnusedIdentifiersCheck(node);
            }
          }
        }
        function checkClassForDuplicateDeclarations(node) {
          var instanceNames = new ts3.Map();
          var staticNames = new ts3.Map();
          var privateIdentifiers = new ts3.Map();
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (member.kind === 171) {
              for (var _b = 0, _c = member.parameters; _b < _c.length; _b++) {
                var param = _c[_b];
                if (ts3.isParameterPropertyDeclaration(param, member) && !ts3.isBindingPattern(param.name)) {
                  addName(instanceNames, param.name, param.name.escapedText, 3);
                }
              }
            } else {
              var isStaticMember = ts3.isStatic(member);
              var name = member.name;
              if (!name) {
                continue;
              }
              var isPrivate = ts3.isPrivateIdentifier(name);
              var privateStaticFlags = isPrivate && isStaticMember ? 16 : 0;
              var names = isPrivate ? privateIdentifiers : isStaticMember ? staticNames : instanceNames;
              var memberName = name && ts3.getPropertyNameForPropertyNameNode(name);
              if (memberName) {
                switch (member.kind) {
                  case 172:
                    addName(names, name, memberName, 1 | privateStaticFlags);
                    break;
                  case 173:
                    addName(names, name, memberName, 2 | privateStaticFlags);
                    break;
                  case 167:
                    addName(names, name, memberName, 3 | privateStaticFlags);
                    break;
                  case 169:
                    addName(names, name, memberName, 8 | privateStaticFlags);
                    break;
                }
              }
            }
          }
          function addName(names2, location, name2, meaning) {
            var prev = names2.get(name2);
            if (prev) {
              if ((prev & 16) !== (meaning & 16)) {
                error(location, ts3.Diagnostics.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name, ts3.getTextOfNode(location));
              } else {
                var prevIsMethod = !!(prev & 8);
                var isMethod = !!(meaning & 8);
                if (prevIsMethod || isMethod) {
                  if (prevIsMethod !== isMethod) {
                    error(location, ts3.Diagnostics.Duplicate_identifier_0, ts3.getTextOfNode(location));
                  }
                } else if (prev & meaning & ~16) {
                  error(location, ts3.Diagnostics.Duplicate_identifier_0, ts3.getTextOfNode(location));
                } else {
                  names2.set(name2, prev | meaning);
                }
              }
            } else {
              names2.set(name2, meaning);
            }
          }
        }
        function checkClassForStaticPropertyNameConflicts(node) {
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            var memberNameNode = member.name;
            var isStaticMember = ts3.isStatic(member);
            if (isStaticMember && memberNameNode) {
              var memberName = ts3.getPropertyNameForPropertyNameNode(memberNameNode);
              switch (memberName) {
                case "name":
                case "length":
                case "caller":
                case "arguments":
                case "prototype":
                  var message = ts3.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1;
                  var className = getNameOfSymbolAsWritten(getSymbolOfNode(node));
                  error(memberNameNode, message, memberName, className);
                  break;
              }
            }
          }
        }
        function checkObjectTypeForDuplicateDeclarations(node) {
          var names = new ts3.Map();
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (member.kind === 166) {
              var memberName = void 0;
              var name = member.name;
              switch (name.kind) {
                case 10:
                case 8:
                  memberName = name.text;
                  break;
                case 79:
                  memberName = ts3.idText(name);
                  break;
                default:
                  continue;
              }
              if (names.get(memberName)) {
                error(ts3.getNameOfDeclaration(member.symbol.valueDeclaration), ts3.Diagnostics.Duplicate_identifier_0, memberName);
                error(member.name, ts3.Diagnostics.Duplicate_identifier_0, memberName);
              } else {
                names.set(memberName, true);
              }
            }
          }
        }
        function checkTypeForDuplicateIndexSignatures(node) {
          if (node.kind === 258) {
            var nodeSymbol = getSymbolOfNode(node);
            if (nodeSymbol.declarations && nodeSymbol.declarations.length > 0 && nodeSymbol.declarations[0] !== node) {
              return;
            }
          }
          var indexSymbol = getIndexSymbol(getSymbolOfNode(node));
          if (indexSymbol === null || indexSymbol === void 0 ? void 0 : indexSymbol.declarations) {
            var indexSignatureMap_1 = new ts3.Map();
            var _loop_27 = function(declaration2) {
              if (declaration2.parameters.length === 1 && declaration2.parameters[0].type) {
                forEachType(getTypeFromTypeNode(declaration2.parameters[0].type), function(type2) {
                  var entry = indexSignatureMap_1.get(getTypeId(type2));
                  if (entry) {
                    entry.declarations.push(declaration2);
                  } else {
                    indexSignatureMap_1.set(getTypeId(type2), { type: type2, declarations: [declaration2] });
                  }
                });
              }
            };
            for (var _i = 0, _a = indexSymbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              _loop_27(declaration);
            }
            indexSignatureMap_1.forEach(function(entry) {
              if (entry.declarations.length > 1) {
                for (var _i2 = 0, _a2 = entry.declarations; _i2 < _a2.length; _i2++) {
                  var declaration2 = _a2[_i2];
                  error(declaration2, ts3.Diagnostics.Duplicate_index_signature_for_type_0, typeToString(entry.type));
                }
              }
            });
          }
        }
        function checkPropertyDeclaration(node) {
          if (!checkGrammarDecoratorsAndModifiers(node) && !checkGrammarProperty(node))
            checkGrammarComputedPropertyName(node.name);
          checkVariableLikeDeclaration(node);
          setNodeLinksForPrivateIdentifierScope(node);
          if (ts3.hasSyntacticModifier(node, 128) && node.kind === 167 && node.initializer) {
            error(node, ts3.Diagnostics.Property_0_cannot_have_an_initializer_because_it_is_marked_abstract, ts3.declarationNameToString(node.name));
          }
        }
        function checkPropertySignature(node) {
          if (ts3.isPrivateIdentifier(node.name)) {
            error(node, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
          }
          return checkPropertyDeclaration(node);
        }
        function checkMethodDeclaration(node) {
          if (!checkGrammarMethod(node))
            checkGrammarComputedPropertyName(node.name);
          checkFunctionOrMethodDeclaration(node);
          if (ts3.hasSyntacticModifier(node, 128) && node.kind === 169 && node.body) {
            error(node, ts3.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts3.declarationNameToString(node.name));
          }
          if (ts3.isPrivateIdentifier(node.name) && !ts3.getContainingClass(node)) {
            error(node, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
          }
          setNodeLinksForPrivateIdentifierScope(node);
        }
        function setNodeLinksForPrivateIdentifierScope(node) {
          if (ts3.isPrivateIdentifier(node.name) && languageVersion < 99) {
            for (var lexicalScope = ts3.getEnclosingBlockScopeContainer(node); !!lexicalScope; lexicalScope = ts3.getEnclosingBlockScopeContainer(lexicalScope)) {
              getNodeLinks(lexicalScope).flags |= 67108864;
            }
            if (ts3.isClassExpression(node.parent)) {
              var enclosingIterationStatement = getEnclosingIterationStatement(node.parent);
              if (enclosingIterationStatement) {
                getNodeLinks(node.name).flags |= 524288;
                getNodeLinks(enclosingIterationStatement).flags |= 65536;
              }
            }
          }
        }
        function checkClassStaticBlockDeclaration(node) {
          checkGrammarDecoratorsAndModifiers(node);
          ts3.forEachChild(node, checkSourceElement);
        }
        function checkConstructorDeclaration(node) {
          checkSignatureDeclaration(node);
          if (!checkGrammarConstructorTypeParameters(node))
            checkGrammarConstructorTypeAnnotation(node);
          checkSourceElement(node.body);
          var symbol = getSymbolOfNode(node);
          var firstDeclaration = ts3.getDeclarationOfKind(symbol, node.kind);
          if (node === firstDeclaration) {
            checkFunctionOrConstructorSymbol(symbol);
          }
          if (ts3.nodeIsMissing(node.body)) {
            return;
          }
          addLazyDiagnostic(checkConstructorDeclarationDiagnostics);
          return;
          function isInstancePropertyWithInitializerOrPrivateIdentifierProperty(n) {
            if (ts3.isPrivateIdentifierClassElementDeclaration(n)) {
              return true;
            }
            return n.kind === 167 && !ts3.isStatic(n) && !!n.initializer;
          }
          function checkConstructorDeclarationDiagnostics() {
            var containingClassDecl = node.parent;
            if (ts3.getClassExtendsHeritageElement(containingClassDecl)) {
              captureLexicalThis(node.parent, containingClassDecl);
              var classExtendsNull = classDeclarationExtendsNull(containingClassDecl);
              var superCall = findFirstSuperCall(node.body);
              if (superCall) {
                if (classExtendsNull) {
                  error(superCall, ts3.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);
                }
                var superCallShouldBeRootLevel = (ts3.getEmitScriptTarget(compilerOptions) !== 99 || !useDefineForClassFields) && (ts3.some(node.parent.members, isInstancePropertyWithInitializerOrPrivateIdentifierProperty) || ts3.some(node.parameters, function(p) {
                  return ts3.hasSyntacticModifier(p, 16476);
                }));
                if (superCallShouldBeRootLevel) {
                  if (!superCallIsRootLevelInConstructor(superCall, node.body)) {
                    error(superCall, ts3.Diagnostics.A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers);
                  } else {
                    var superCallStatement = void 0;
                    for (var _i = 0, _a = node.body.statements; _i < _a.length; _i++) {
                      var statement = _a[_i];
                      if (ts3.isExpressionStatement(statement) && ts3.isSuperCall(ts3.skipOuterExpressions(statement.expression))) {
                        superCallStatement = statement;
                        break;
                      }
                      if (nodeImmediatelyReferencesSuperOrThis(statement)) {
                        break;
                      }
                    }
                    if (superCallStatement === void 0) {
                      error(node, ts3.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers);
                    }
                  }
                }
              } else if (!classExtendsNull) {
                error(node, ts3.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call);
              }
            }
          }
        }
        function superCallIsRootLevelInConstructor(superCall, body) {
          var superCallParent = ts3.walkUpParenthesizedExpressions(superCall.parent);
          return ts3.isExpressionStatement(superCallParent) && superCallParent.parent === body;
        }
        function nodeImmediatelyReferencesSuperOrThis(node) {
          if (node.kind === 106 || node.kind === 108) {
            return true;
          }
          if (ts3.isThisContainerOrFunctionBlock(node)) {
            return false;
          }
          return !!ts3.forEachChild(node, nodeImmediatelyReferencesSuperOrThis);
        }
        function checkAccessorDeclaration(node) {
          addLazyDiagnostic(checkAccessorDeclarationDiagnostics);
          checkSourceElement(node.body);
          setNodeLinksForPrivateIdentifierScope(node);
          function checkAccessorDeclarationDiagnostics() {
            if (!checkGrammarFunctionLikeDeclaration(node) && !checkGrammarAccessor(node))
              checkGrammarComputedPropertyName(node.name);
            checkDecorators(node);
            checkSignatureDeclaration(node);
            if (node.kind === 172) {
              if (!(node.flags & 16777216) && ts3.nodeIsPresent(node.body) && node.flags & 256) {
                if (!(node.flags & 512)) {
                  error(node.name, ts3.Diagnostics.A_get_accessor_must_return_a_value);
                }
              }
            }
            if (node.name.kind === 162) {
              checkComputedPropertyName(node.name);
            }
            if (hasBindableName(node)) {
              var symbol = getSymbolOfNode(node);
              var getter = ts3.getDeclarationOfKind(symbol, 172);
              var setter = ts3.getDeclarationOfKind(symbol, 173);
              if (getter && setter && !(getNodeCheckFlags(getter) & 1)) {
                getNodeLinks(getter).flags |= 1;
                var getterFlags = ts3.getEffectiveModifierFlags(getter);
                var setterFlags = ts3.getEffectiveModifierFlags(setter);
                if ((getterFlags & 128) !== (setterFlags & 128)) {
                  error(getter.name, ts3.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
                  error(setter.name, ts3.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
                }
                if (getterFlags & 16 && !(setterFlags & (16 | 8)) || getterFlags & 8 && !(setterFlags & 8)) {
                  error(getter.name, ts3.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter);
                  error(setter.name, ts3.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter);
                }
                var getterType = getAnnotatedAccessorType(getter);
                var setterType = getAnnotatedAccessorType(setter);
                if (getterType && setterType) {
                  checkTypeAssignableTo(getterType, setterType, getter, ts3.Diagnostics.The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type);
                }
              }
            }
            var returnType = getTypeOfAccessors(getSymbolOfNode(node));
            if (node.kind === 172) {
              checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType);
            }
          }
        }
        function checkMissingDeclaration(node) {
          checkDecorators(node);
        }
        function getEffectiveTypeArguments(node, typeParameters) {
          return fillMissingTypeArguments(ts3.map(node.typeArguments, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), ts3.isInJSFile(node));
        }
        function checkTypeArgumentConstraints(node, typeParameters) {
          var typeArguments;
          var mapper;
          var result2 = true;
          for (var i = 0; i < typeParameters.length; i++) {
            var constraint = getConstraintOfTypeParameter(typeParameters[i]);
            if (constraint) {
              if (!typeArguments) {
                typeArguments = getEffectiveTypeArguments(node, typeParameters);
                mapper = createTypeMapper(typeParameters, typeArguments);
              }
              result2 = result2 && checkTypeAssignableTo(typeArguments[i], instantiateType(constraint, mapper), node.typeArguments[i], ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
            }
          }
          return result2;
        }
        function getTypeParametersForTypeReference(node) {
          var type2 = getTypeFromTypeReference(node);
          if (!isErrorType(type2)) {
            var symbol = getNodeLinks(node).resolvedSymbol;
            if (symbol) {
              return symbol.flags & 524288 && getSymbolLinks(symbol).typeParameters || (ts3.getObjectFlags(type2) & 4 ? type2.target.localTypeParameters : void 0);
            }
          }
          return void 0;
        }
        function checkTypeReferenceNode(node) {
          checkGrammarTypeArguments(node, node.typeArguments);
          if (node.kind === 178 && node.typeName.jsdocDotPos !== void 0 && !ts3.isInJSFile(node) && !ts3.isInJSDoc(node)) {
            grammarErrorAtPos(node, node.typeName.jsdocDotPos, 1, ts3.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
          }
          ts3.forEach(node.typeArguments, checkSourceElement);
          var type2 = getTypeFromTypeReference(node);
          if (!isErrorType(type2)) {
            if (node.typeArguments) {
              addLazyDiagnostic(function() {
                var typeParameters = getTypeParametersForTypeReference(node);
                if (typeParameters) {
                  checkTypeArgumentConstraints(node, typeParameters);
                }
              });
            }
            var symbol = getNodeLinks(node).resolvedSymbol;
            if (symbol) {
              if (ts3.some(symbol.declarations, function(d) {
                return isTypeDeclaration(d) && !!(d.flags & 268435456);
              })) {
                addDeprecatedSuggestion(getDeprecatedSuggestionNode(node), symbol.declarations, symbol.escapedName);
              }
              if (type2.flags & 32 && symbol.flags & 8) {
                error(node, ts3.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, typeToString(type2));
              }
            }
          }
        }
        function getTypeArgumentConstraint(node) {
          var typeReferenceNode = ts3.tryCast(node.parent, ts3.isTypeReferenceType);
          if (!typeReferenceNode)
            return void 0;
          var typeParameters = getTypeParametersForTypeReference(typeReferenceNode);
          if (!typeParameters)
            return void 0;
          var constraint = getConstraintOfTypeParameter(typeParameters[typeReferenceNode.typeArguments.indexOf(node)]);
          return constraint && instantiateType(constraint, createTypeMapper(typeParameters, getEffectiveTypeArguments(typeReferenceNode, typeParameters)));
        }
        function checkTypeQuery(node) {
          getTypeFromTypeQueryNode(node);
        }
        function checkTypeLiteral(node) {
          ts3.forEach(node.members, checkSourceElement);
          addLazyDiagnostic(checkTypeLiteralDiagnostics);
          function checkTypeLiteralDiagnostics() {
            var type2 = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
            checkIndexConstraints(type2, type2.symbol);
            checkTypeForDuplicateIndexSignatures(node);
            checkObjectTypeForDuplicateDeclarations(node);
          }
        }
        function checkArrayType(node) {
          checkSourceElement(node.elementType);
        }
        function checkTupleType(node) {
          var elementTypes = node.elements;
          var seenOptionalElement = false;
          var seenRestElement = false;
          var hasNamedElement = ts3.some(elementTypes, ts3.isNamedTupleMember);
          for (var _i = 0, elementTypes_1 = elementTypes; _i < elementTypes_1.length; _i++) {
            var e = elementTypes_1[_i];
            if (e.kind !== 197 && hasNamedElement) {
              grammarErrorOnNode(e, ts3.Diagnostics.Tuple_members_must_all_have_names_or_all_not_have_names);
              break;
            }
            var flags = getTupleElementFlags(e);
            if (flags & 8) {
              var type2 = getTypeFromTypeNode(e.type);
              if (!isArrayLikeType(type2)) {
                error(e, ts3.Diagnostics.A_rest_element_type_must_be_an_array_type);
                break;
              }
              if (isArrayType(type2) || isTupleType(type2) && type2.target.combinedFlags & 4) {
                seenRestElement = true;
              }
            } else if (flags & 4) {
              if (seenRestElement) {
                grammarErrorOnNode(e, ts3.Diagnostics.A_rest_element_cannot_follow_another_rest_element);
                break;
              }
              seenRestElement = true;
            } else if (flags & 2) {
              if (seenRestElement) {
                grammarErrorOnNode(e, ts3.Diagnostics.An_optional_element_cannot_follow_a_rest_element);
                break;
              }
              seenOptionalElement = true;
            } else if (seenOptionalElement) {
              grammarErrorOnNode(e, ts3.Diagnostics.A_required_element_cannot_follow_an_optional_element);
              break;
            }
          }
          ts3.forEach(node.elements, checkSourceElement);
          getTypeFromTypeNode(node);
        }
        function checkUnionOrIntersectionType(node) {
          ts3.forEach(node.types, checkSourceElement);
          getTypeFromTypeNode(node);
        }
        function checkIndexedAccessIndexType(type2, accessNode) {
          if (!(type2.flags & 8388608)) {
            return type2;
          }
          var objectType = type2.objectType;
          var indexType = type2.indexType;
          if (isTypeAssignableTo(indexType, getIndexType(objectType, false))) {
            if (accessNode.kind === 207 && ts3.isAssignmentTarget(accessNode) && ts3.getObjectFlags(objectType) & 32 && getMappedTypeModifiers(objectType) & 1) {
              error(accessNode, ts3.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
            }
            return type2;
          }
          var apparentObjectType = getApparentType(objectType);
          if (getIndexInfoOfType(apparentObjectType, numberType) && isTypeAssignableToKind(indexType, 296)) {
            return type2;
          }
          if (isGenericObjectType(objectType)) {
            var propertyName_1 = getPropertyNameFromIndex(indexType, accessNode);
            if (propertyName_1) {
              var propertySymbol = forEachType(apparentObjectType, function(t) {
                return getPropertyOfType(t, propertyName_1);
              });
              if (propertySymbol && ts3.getDeclarationModifierFlagsFromSymbol(propertySymbol) & 24) {
                error(accessNode, ts3.Diagnostics.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter, ts3.unescapeLeadingUnderscores(propertyName_1));
                return errorType;
              }
            }
          }
          error(accessNode, ts3.Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(objectType));
          return errorType;
        }
        function checkIndexedAccessType(node) {
          checkSourceElement(node.objectType);
          checkSourceElement(node.indexType);
          checkIndexedAccessIndexType(getTypeFromIndexedAccessTypeNode(node), node);
        }
        function checkMappedType(node) {
          checkGrammarMappedType(node);
          checkSourceElement(node.typeParameter);
          checkSourceElement(node.nameType);
          checkSourceElement(node.type);
          if (!node.type) {
            reportImplicitAny(node, anyType);
          }
          var type2 = getTypeFromMappedTypeNode(node);
          var nameType = getNameTypeFromMappedType(type2);
          if (nameType) {
            checkTypeAssignableTo(nameType, keyofConstraintType, node.nameType);
          } else {
            var constraintType = getConstraintTypeFromMappedType(type2);
            checkTypeAssignableTo(constraintType, keyofConstraintType, ts3.getEffectiveConstraintOfTypeParameter(node.typeParameter));
          }
        }
        function checkGrammarMappedType(node) {
          var _a;
          if ((_a = node.members) === null || _a === void 0 ? void 0 : _a.length) {
            return grammarErrorOnNode(node.members[0], ts3.Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
          }
        }
        function checkThisType(node) {
          getTypeFromThisTypeNode(node);
        }
        function checkTypeOperator(node) {
          checkGrammarTypeOperatorNode(node);
          checkSourceElement(node.type);
        }
        function checkConditionalType(node) {
          ts3.forEachChild(node, checkSourceElement);
        }
        function checkInferType(node) {
          if (!ts3.findAncestor(node, function(n) {
            return n.parent && n.parent.kind === 189 && n.parent.extendsType === n;
          })) {
            grammarErrorOnNode(node, ts3.Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type);
          }
          checkSourceElement(node.typeParameter);
          var symbol = getSymbolOfNode(node.typeParameter);
          if (symbol.declarations && symbol.declarations.length > 1) {
            var links = getSymbolLinks(symbol);
            if (!links.typeParametersChecked) {
              links.typeParametersChecked = true;
              var typeParameter = getDeclaredTypeOfTypeParameter(symbol);
              var declarations = ts3.getDeclarationsOfKind(symbol, 163);
              if (!areTypeParametersIdentical(declarations, [typeParameter], function(decl) {
                return [decl];
              })) {
                var name = symbolToString(symbol);
                for (var _i = 0, declarations_4 = declarations; _i < declarations_4.length; _i++) {
                  var declaration = declarations_4[_i];
                  error(declaration.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_constraints, name);
                }
              }
            }
          }
          registerForUnusedIdentifiersCheck(node);
        }
        function checkTemplateLiteralType(node) {
          for (var _i = 0, _a = node.templateSpans; _i < _a.length; _i++) {
            var span = _a[_i];
            checkSourceElement(span.type);
            var type2 = getTypeFromTypeNode(span.type);
            checkTypeAssignableTo(type2, templateConstraintType, span.type);
          }
          getTypeFromTypeNode(node);
        }
        function checkImportType(node) {
          checkSourceElement(node.argument);
          if (node.assertions) {
            var override = ts3.getResolutionModeOverrideForClause(node.assertions.assertClause, grammarErrorOnNode);
            if (override) {
              if (!ts3.isNightly()) {
                grammarErrorOnNode(node.assertions.assertClause, ts3.Diagnostics.resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next);
              }
              if (ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.Node16 && ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeNext) {
                grammarErrorOnNode(node.assertions.assertClause, ts3.Diagnostics.resolution_mode_assertions_are_only_supported_when_moduleResolution_is_node16_or_nodenext);
              }
            }
          }
          getTypeFromTypeNode(node);
        }
        function checkNamedTupleMember(node) {
          if (node.dotDotDotToken && node.questionToken) {
            grammarErrorOnNode(node, ts3.Diagnostics.A_tuple_member_cannot_be_both_optional_and_rest);
          }
          if (node.type.kind === 185) {
            grammarErrorOnNode(node.type, ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type);
          }
          if (node.type.kind === 186) {
            grammarErrorOnNode(node.type, ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type);
          }
          checkSourceElement(node.type);
          getTypeFromTypeNode(node);
        }
        function isPrivateWithinAmbient(node) {
          return (ts3.hasEffectiveModifier(node, 8) || ts3.isPrivateIdentifierClassElementDeclaration(node)) && !!(node.flags & 16777216);
        }
        function getEffectiveDeclarationFlags(n, flagsToCheck) {
          var flags = ts3.getCombinedModifierFlags(n);
          if (n.parent.kind !== 258 && n.parent.kind !== 257 && n.parent.kind !== 226 && n.flags & 16777216) {
            if (!(flags & 2) && !(ts3.isModuleBlock(n.parent) && ts3.isModuleDeclaration(n.parent.parent) && ts3.isGlobalScopeAugmentation(n.parent.parent))) {
              flags |= 1;
            }
            flags |= 2;
          }
          return flags & flagsToCheck;
        }
        function checkFunctionOrConstructorSymbol(symbol) {
          addLazyDiagnostic(function() {
            return checkFunctionOrConstructorSymbolWorker(symbol);
          });
        }
        function checkFunctionOrConstructorSymbolWorker(symbol) {
          function getCanonicalOverload(overloads, implementation) {
            var implementationSharesContainerWithFirstOverload = implementation !== void 0 && implementation.parent === overloads[0].parent;
            return implementationSharesContainerWithFirstOverload ? implementation : overloads[0];
          }
          function checkFlagAgreementBetweenOverloads(overloads, implementation, flagsToCheck2, someOverloadFlags, allOverloadFlags) {
            var someButNotAllOverloadFlags = someOverloadFlags ^ allOverloadFlags;
            if (someButNotAllOverloadFlags !== 0) {
              var canonicalFlags_1 = getEffectiveDeclarationFlags(getCanonicalOverload(overloads, implementation), flagsToCheck2);
              ts3.forEach(overloads, function(o) {
                var deviation = getEffectiveDeclarationFlags(o, flagsToCheck2) ^ canonicalFlags_1;
                if (deviation & 1) {
                  error(ts3.getNameOfDeclaration(o), ts3.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported);
                } else if (deviation & 2) {
                  error(ts3.getNameOfDeclaration(o), ts3.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient);
                } else if (deviation & (8 | 16)) {
                  error(ts3.getNameOfDeclaration(o) || o, ts3.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected);
                } else if (deviation & 128) {
                  error(ts3.getNameOfDeclaration(o), ts3.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                }
              });
            }
          }
          function checkQuestionTokenAgreementBetweenOverloads(overloads, implementation, someHaveQuestionToken2, allHaveQuestionToken2) {
            if (someHaveQuestionToken2 !== allHaveQuestionToken2) {
              var canonicalHasQuestionToken_1 = ts3.hasQuestionToken(getCanonicalOverload(overloads, implementation));
              ts3.forEach(overloads, function(o) {
                var deviation = ts3.hasQuestionToken(o) !== canonicalHasQuestionToken_1;
                if (deviation) {
                  error(ts3.getNameOfDeclaration(o), ts3.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                }
              });
            }
          }
          var flagsToCheck = 1 | 2 | 8 | 16 | 128;
          var someNodeFlags = 0;
          var allNodeFlags = flagsToCheck;
          var someHaveQuestionToken = false;
          var allHaveQuestionToken = true;
          var hasOverloads = false;
          var bodyDeclaration;
          var lastSeenNonAmbientDeclaration;
          var previousDeclaration;
          var declarations = symbol.declarations;
          var isConstructor = (symbol.flags & 16384) !== 0;
          function reportImplementationExpectedError(node2) {
            if (node2.name && ts3.nodeIsMissing(node2.name)) {
              return;
            }
            var seen = false;
            var subsequentNode = ts3.forEachChild(node2.parent, function(c) {
              if (seen) {
                return c;
              } else {
                seen = c === node2;
              }
            });
            if (subsequentNode && subsequentNode.pos === node2.end) {
              if (subsequentNode.kind === node2.kind) {
                var errorNode_1 = subsequentNode.name || subsequentNode;
                var subsequentName = subsequentNode.name;
                if (node2.name && subsequentName && (ts3.isPrivateIdentifier(node2.name) && ts3.isPrivateIdentifier(subsequentName) && node2.name.escapedText === subsequentName.escapedText || ts3.isComputedPropertyName(node2.name) && ts3.isComputedPropertyName(subsequentName) || ts3.isPropertyNameLiteral(node2.name) && ts3.isPropertyNameLiteral(subsequentName) && ts3.getEscapedTextOfIdentifierOrLiteral(node2.name) === ts3.getEscapedTextOfIdentifierOrLiteral(subsequentName))) {
                  var reportError = (node2.kind === 169 || node2.kind === 168) && ts3.isStatic(node2) !== ts3.isStatic(subsequentNode);
                  if (reportError) {
                    var diagnostic = ts3.isStatic(node2) ? ts3.Diagnostics.Function_overload_must_be_static : ts3.Diagnostics.Function_overload_must_not_be_static;
                    error(errorNode_1, diagnostic);
                  }
                  return;
                }
                if (ts3.nodeIsPresent(subsequentNode.body)) {
                  error(errorNode_1, ts3.Diagnostics.Function_implementation_name_must_be_0, ts3.declarationNameToString(node2.name));
                  return;
                }
              }
            }
            var errorNode = node2.name || node2;
            if (isConstructor) {
              error(errorNode, ts3.Diagnostics.Constructor_implementation_is_missing);
            } else {
              if (ts3.hasSyntacticModifier(node2, 128)) {
                error(errorNode, ts3.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive);
              } else {
                error(errorNode, ts3.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
              }
            }
          }
          var duplicateFunctionDeclaration = false;
          var multipleConstructorImplementation = false;
          var hasNonAmbientClass = false;
          var functionDeclarations = [];
          if (declarations) {
            for (var _i = 0, declarations_5 = declarations; _i < declarations_5.length; _i++) {
              var current = declarations_5[_i];
              var node = current;
              var inAmbientContext = node.flags & 16777216;
              var inAmbientContextOrInterface = node.parent && (node.parent.kind === 258 || node.parent.kind === 182) || inAmbientContext;
              if (inAmbientContextOrInterface) {
                previousDeclaration = void 0;
              }
              if ((node.kind === 257 || node.kind === 226) && !inAmbientContext) {
                hasNonAmbientClass = true;
              }
              if (node.kind === 256 || node.kind === 169 || node.kind === 168 || node.kind === 171) {
                functionDeclarations.push(node);
                var currentNodeFlags = getEffectiveDeclarationFlags(node, flagsToCheck);
                someNodeFlags |= currentNodeFlags;
                allNodeFlags &= currentNodeFlags;
                someHaveQuestionToken = someHaveQuestionToken || ts3.hasQuestionToken(node);
                allHaveQuestionToken = allHaveQuestionToken && ts3.hasQuestionToken(node);
                var bodyIsPresent = ts3.nodeIsPresent(node.body);
                if (bodyIsPresent && bodyDeclaration) {
                  if (isConstructor) {
                    multipleConstructorImplementation = true;
                  } else {
                    duplicateFunctionDeclaration = true;
                  }
                } else if ((previousDeclaration === null || previousDeclaration === void 0 ? void 0 : previousDeclaration.parent) === node.parent && previousDeclaration.end !== node.pos) {
                  reportImplementationExpectedError(previousDeclaration);
                }
                if (bodyIsPresent) {
                  if (!bodyDeclaration) {
                    bodyDeclaration = node;
                  }
                } else {
                  hasOverloads = true;
                }
                previousDeclaration = node;
                if (!inAmbientContextOrInterface) {
                  lastSeenNonAmbientDeclaration = node;
                }
              }
            }
          }
          if (multipleConstructorImplementation) {
            ts3.forEach(functionDeclarations, function(declaration) {
              error(declaration, ts3.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
            });
          }
          if (duplicateFunctionDeclaration) {
            ts3.forEach(functionDeclarations, function(declaration) {
              error(ts3.getNameOfDeclaration(declaration) || declaration, ts3.Diagnostics.Duplicate_function_implementation);
            });
          }
          if (hasNonAmbientClass && !isConstructor && symbol.flags & 16 && declarations) {
            var relatedDiagnostics_1 = ts3.filter(declarations, function(d) {
              return d.kind === 257;
            }).map(function(d) {
              return ts3.createDiagnosticForNode(d, ts3.Diagnostics.Consider_adding_a_declare_modifier_to_this_class);
            });
            ts3.forEach(declarations, function(declaration) {
              var diagnostic = declaration.kind === 257 ? ts3.Diagnostics.Class_declaration_cannot_implement_overload_list_for_0 : declaration.kind === 256 ? ts3.Diagnostics.Function_with_bodies_can_only_merge_with_classes_that_are_ambient : void 0;
              if (diagnostic) {
                ts3.addRelatedInfo.apply(void 0, __spreadArray([error(ts3.getNameOfDeclaration(declaration) || declaration, diagnostic, ts3.symbolName(symbol))], relatedDiagnostics_1, false));
              }
            });
          }
          if (lastSeenNonAmbientDeclaration && !lastSeenNonAmbientDeclaration.body && !ts3.hasSyntacticModifier(lastSeenNonAmbientDeclaration, 128) && !lastSeenNonAmbientDeclaration.questionToken) {
            reportImplementationExpectedError(lastSeenNonAmbientDeclaration);
          }
          if (hasOverloads) {
            if (declarations) {
              checkFlagAgreementBetweenOverloads(declarations, bodyDeclaration, flagsToCheck, someNodeFlags, allNodeFlags);
              checkQuestionTokenAgreementBetweenOverloads(declarations, bodyDeclaration, someHaveQuestionToken, allHaveQuestionToken);
            }
            if (bodyDeclaration) {
              var signatures = getSignaturesOfSymbol(symbol);
              var bodySignature = getSignatureFromDeclaration(bodyDeclaration);
              for (var _a = 0, signatures_10 = signatures; _a < signatures_10.length; _a++) {
                var signature = signatures_10[_a];
                if (!isImplementationCompatibleWithOverload(bodySignature, signature)) {
                  ts3.addRelatedInfo(error(signature.declaration, ts3.Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature), ts3.createDiagnosticForNode(bodyDeclaration, ts3.Diagnostics.The_implementation_signature_is_declared_here));
                  break;
                }
              }
            }
          }
        }
        function checkExportsOnMergedDeclarations(node) {
          addLazyDiagnostic(function() {
            return checkExportsOnMergedDeclarationsWorker(node);
          });
        }
        function checkExportsOnMergedDeclarationsWorker(node) {
          var symbol = node.localSymbol;
          if (!symbol) {
            symbol = getSymbolOfNode(node);
            if (!symbol.exportSymbol) {
              return;
            }
          }
          if (ts3.getDeclarationOfKind(symbol, node.kind) !== node) {
            return;
          }
          var exportedDeclarationSpaces = 0;
          var nonExportedDeclarationSpaces = 0;
          var defaultExportedDeclarationSpaces = 0;
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var d = _a[_i];
            var declarationSpaces = getDeclarationSpaces(d);
            var effectiveDeclarationFlags = getEffectiveDeclarationFlags(d, 1 | 512);
            if (effectiveDeclarationFlags & 1) {
              if (effectiveDeclarationFlags & 512) {
                defaultExportedDeclarationSpaces |= declarationSpaces;
              } else {
                exportedDeclarationSpaces |= declarationSpaces;
              }
            } else {
              nonExportedDeclarationSpaces |= declarationSpaces;
            }
          }
          var nonDefaultExportedDeclarationSpaces = exportedDeclarationSpaces | nonExportedDeclarationSpaces;
          var commonDeclarationSpacesForExportsAndLocals = exportedDeclarationSpaces & nonExportedDeclarationSpaces;
          var commonDeclarationSpacesForDefaultAndNonDefault = defaultExportedDeclarationSpaces & nonDefaultExportedDeclarationSpaces;
          if (commonDeclarationSpacesForExportsAndLocals || commonDeclarationSpacesForDefaultAndNonDefault) {
            for (var _b = 0, _c = symbol.declarations; _b < _c.length; _b++) {
              var d = _c[_b];
              var declarationSpaces = getDeclarationSpaces(d);
              var name = ts3.getNameOfDeclaration(d);
              if (declarationSpaces & commonDeclarationSpacesForDefaultAndNonDefault) {
                error(name, ts3.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead, ts3.declarationNameToString(name));
              } else if (declarationSpaces & commonDeclarationSpacesForExportsAndLocals) {
                error(name, ts3.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local, ts3.declarationNameToString(name));
              }
            }
          }
          function getDeclarationSpaces(decl) {
            var d2 = decl;
            switch (d2.kind) {
              case 258:
              case 259:
              case 345:
              case 338:
              case 339:
                return 2;
              case 261:
                return ts3.isAmbientModule(d2) || ts3.getModuleInstanceState(d2) !== 0 ? 4 | 1 : 4;
              case 257:
              case 260:
              case 299:
                return 2 | 1;
              case 305:
                return 2 | 1 | 4;
              case 271:
              case 221:
                var node_2 = d2;
                var expression = ts3.isExportAssignment(node_2) ? node_2.expression : node_2.right;
                if (!ts3.isEntityNameExpression(expression)) {
                  return 1;
                }
                d2 = expression;
              case 265:
              case 268:
              case 267:
                var result_12 = 0;
                var target = resolveAlias(getSymbolOfNode(d2));
                ts3.forEach(target.declarations, function(d3) {
                  result_12 |= getDeclarationSpaces(d3);
                });
                return result_12;
              case 254:
              case 203:
              case 256:
              case 270:
              case 79:
                return 1;
              default:
                return ts3.Debug.failBadSyntaxKind(d2);
            }
          }
        }
        function getAwaitedTypeOfPromise(type2, errorNode, diagnosticMessage, arg0) {
          var promisedType = getPromisedTypeOfPromise(type2, errorNode);
          return promisedType && getAwaitedType(promisedType, errorNode, diagnosticMessage, arg0);
        }
        function getPromisedTypeOfPromise(type2, errorNode) {
          if (isTypeAny(type2)) {
            return void 0;
          }
          var typeAsPromise = type2;
          if (typeAsPromise.promisedTypeOfPromise) {
            return typeAsPromise.promisedTypeOfPromise;
          }
          if (isReferenceToType(type2, getGlobalPromiseType(false))) {
            return typeAsPromise.promisedTypeOfPromise = getTypeArguments(type2)[0];
          }
          if (allTypesAssignableToKind(type2, 131068 | 131072)) {
            return void 0;
          }
          var thenFunction = getTypeOfPropertyOfType(type2, "then");
          if (isTypeAny(thenFunction)) {
            return void 0;
          }
          var thenSignatures = thenFunction ? getSignaturesOfType(thenFunction, 0) : ts3.emptyArray;
          if (thenSignatures.length === 0) {
            if (errorNode) {
              error(errorNode, ts3.Diagnostics.A_promise_must_have_a_then_method);
            }
            return void 0;
          }
          var onfulfilledParameterType = getTypeWithFacts(getUnionType(ts3.map(thenSignatures, getTypeOfFirstParameterOfSignature)), 2097152);
          if (isTypeAny(onfulfilledParameterType)) {
            return void 0;
          }
          var onfulfilledParameterSignatures = getSignaturesOfType(onfulfilledParameterType, 0);
          if (onfulfilledParameterSignatures.length === 0) {
            if (errorNode) {
              error(errorNode, ts3.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);
            }
            return void 0;
          }
          return typeAsPromise.promisedTypeOfPromise = getUnionType(ts3.map(onfulfilledParameterSignatures, getTypeOfFirstParameterOfSignature), 2);
        }
        function checkAwaitedType(type2, withAlias, errorNode, diagnosticMessage, arg0) {
          var awaitedType = withAlias ? getAwaitedType(type2, errorNode, diagnosticMessage, arg0) : getAwaitedTypeNoAlias(type2, errorNode, diagnosticMessage, arg0);
          return awaitedType || errorType;
        }
        function isThenableType(type2) {
          if (allTypesAssignableToKind(type2, 131068 | 131072)) {
            return false;
          }
          var thenFunction = getTypeOfPropertyOfType(type2, "then");
          return !!thenFunction && getSignaturesOfType(getTypeWithFacts(thenFunction, 2097152), 0).length > 0;
        }
        function isAwaitedTypeInstantiation(type2) {
          var _a;
          if (type2.flags & 16777216) {
            var awaitedSymbol = getGlobalAwaitedSymbol(false);
            return !!awaitedSymbol && type2.aliasSymbol === awaitedSymbol && ((_a = type2.aliasTypeArguments) === null || _a === void 0 ? void 0 : _a.length) === 1;
          }
          return false;
        }
        function unwrapAwaitedType(type2) {
          return type2.flags & 1048576 ? mapType(type2, unwrapAwaitedType) : isAwaitedTypeInstantiation(type2) ? type2.aliasTypeArguments[0] : type2;
        }
        function createAwaitedTypeIfNeeded(type2) {
          if (isTypeAny(type2)) {
            return type2;
          }
          if (isAwaitedTypeInstantiation(type2)) {
            return type2;
          }
          if (isGenericObjectType(type2)) {
            var baseConstraint = getBaseConstraintOfType(type2);
            if (!baseConstraint || baseConstraint.flags & 3 || isEmptyObjectType(baseConstraint) || isThenableType(baseConstraint)) {
              var awaitedSymbol = getGlobalAwaitedSymbol(true);
              if (awaitedSymbol) {
                return getTypeAliasInstantiation(awaitedSymbol, [unwrapAwaitedType(type2)]);
              }
            }
          }
          ts3.Debug.assert(getPromisedTypeOfPromise(type2) === void 0, "type provided should not be a non-generic 'promise'-like.");
          return type2;
        }
        function getAwaitedType(type2, errorNode, diagnosticMessage, arg0) {
          var awaitedType = getAwaitedTypeNoAlias(type2, errorNode, diagnosticMessage, arg0);
          return awaitedType && createAwaitedTypeIfNeeded(awaitedType);
        }
        function getAwaitedTypeNoAlias(type2, errorNode, diagnosticMessage, arg0) {
          if (isTypeAny(type2)) {
            return type2;
          }
          if (isAwaitedTypeInstantiation(type2)) {
            return type2;
          }
          var typeAsAwaitable = type2;
          if (typeAsAwaitable.awaitedTypeOfType) {
            return typeAsAwaitable.awaitedTypeOfType;
          }
          if (type2.flags & 1048576) {
            var mapper = errorNode ? function(constituentType) {
              return getAwaitedTypeNoAlias(constituentType, errorNode, diagnosticMessage, arg0);
            } : getAwaitedTypeNoAlias;
            return typeAsAwaitable.awaitedTypeOfType = mapType(type2, mapper);
          }
          var promisedType = getPromisedTypeOfPromise(type2);
          if (promisedType) {
            if (type2.id === promisedType.id || awaitedTypeStack.lastIndexOf(promisedType.id) >= 0) {
              if (errorNode) {
                error(errorNode, ts3.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
              }
              return void 0;
            }
            awaitedTypeStack.push(type2.id);
            var awaitedType = getAwaitedTypeNoAlias(promisedType, errorNode, diagnosticMessage, arg0);
            awaitedTypeStack.pop();
            if (!awaitedType) {
              return void 0;
            }
            return typeAsAwaitable.awaitedTypeOfType = awaitedType;
          }
          if (isThenableType(type2)) {
            if (errorNode) {
              ts3.Debug.assertIsDefined(diagnosticMessage);
              error(errorNode, diagnosticMessage, arg0);
            }
            return void 0;
          }
          return typeAsAwaitable.awaitedTypeOfType = type2;
        }
        function checkAsyncFunctionReturnType(node, returnTypeNode) {
          var returnType = getTypeFromTypeNode(returnTypeNode);
          if (languageVersion >= 2) {
            if (isErrorType(returnType)) {
              return;
            }
            var globalPromiseType = getGlobalPromiseType(true);
            if (globalPromiseType !== emptyGenericType && !isReferenceToType(returnType, globalPromiseType)) {
              error(returnTypeNode, ts3.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0, typeToString(getAwaitedTypeNoAlias(returnType) || voidType));
              return;
            }
          } else {
            markTypeNodeAsReferenced(returnTypeNode);
            if (isErrorType(returnType)) {
              return;
            }
            var promiseConstructorName = ts3.getEntityNameFromTypeNode(returnTypeNode);
            if (promiseConstructorName === void 0) {
              error(returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, typeToString(returnType));
              return;
            }
            var promiseConstructorSymbol = resolveEntityName(promiseConstructorName, 111551, true);
            var promiseConstructorType = promiseConstructorSymbol ? getTypeOfSymbol(promiseConstructorSymbol) : errorType;
            if (isErrorType(promiseConstructorType)) {
              if (promiseConstructorName.kind === 79 && promiseConstructorName.escapedText === "Promise" && getTargetType(returnType) === getGlobalPromiseType(false)) {
                error(returnTypeNode, ts3.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
              } else {
                error(returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, ts3.entityNameToString(promiseConstructorName));
              }
              return;
            }
            var globalPromiseConstructorLikeType = getGlobalPromiseConstructorLikeType(true);
            if (globalPromiseConstructorLikeType === emptyObjectType) {
              error(returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, ts3.entityNameToString(promiseConstructorName));
              return;
            }
            if (!checkTypeAssignableTo(promiseConstructorType, globalPromiseConstructorLikeType, returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value)) {
              return;
            }
            var rootName = promiseConstructorName && ts3.getFirstIdentifier(promiseConstructorName);
            var collidingSymbol = getSymbol(node.locals, rootName.escapedText, 111551);
            if (collidingSymbol) {
              error(collidingSymbol.valueDeclaration, ts3.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions, ts3.idText(rootName), ts3.entityNameToString(promiseConstructorName));
              return;
            }
          }
          checkAwaitedType(returnType, false, node, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
        }
        function checkDecorator(node) {
          var signature = getResolvedSignature(node);
          checkDeprecatedSignature(signature, node);
          var returnType = getReturnTypeOfSignature(signature);
          if (returnType.flags & 1) {
            return;
          }
          var headMessage;
          var expectedReturnType;
          switch (node.parent.kind) {
            case 257:
              headMessage = ts3.Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
              var classSymbol = getSymbolOfNode(node.parent);
              var classConstructorType = getTypeOfSymbol(classSymbol);
              expectedReturnType = getUnionType([classConstructorType, voidType]);
              break;
            case 167:
            case 164:
              headMessage = ts3.Diagnostics.Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any;
              expectedReturnType = voidType;
              break;
            case 169:
            case 172:
            case 173:
              headMessage = ts3.Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
              var methodType = getTypeOfNode(node.parent);
              var descriptorType = createTypedPropertyDescriptorType(methodType);
              expectedReturnType = getUnionType([descriptorType, voidType]);
              break;
            default:
              return ts3.Debug.fail();
          }
          checkTypeAssignableTo(returnType, expectedReturnType, node, headMessage);
        }
        function markTypeNodeAsReferenced(node) {
          markEntityNameOrEntityExpressionAsReference(node && ts3.getEntityNameFromTypeNode(node), false);
        }
        function markEntityNameOrEntityExpressionAsReference(typeName, forDecoratorMetadata) {
          if (!typeName)
            return;
          var rootName = ts3.getFirstIdentifier(typeName);
          var meaning = (typeName.kind === 79 ? 788968 : 1920) | 2097152;
          var rootSymbol = resolveName(rootName, rootName.escapedText, meaning, void 0, void 0, true);
          if (rootSymbol && rootSymbol.flags & 2097152) {
            if (symbolIsValue(rootSymbol) && !isConstEnumOrConstEnumOnlyModule(resolveAlias(rootSymbol)) && !getTypeOnlyAliasDeclaration(rootSymbol)) {
              markAliasSymbolAsReferenced(rootSymbol);
            } else if (forDecoratorMetadata && compilerOptions.isolatedModules && ts3.getEmitModuleKind(compilerOptions) >= ts3.ModuleKind.ES2015 && !symbolIsValue(rootSymbol) && !ts3.some(rootSymbol.declarations, ts3.isTypeOnlyImportOrExportDeclaration)) {
              var diag = error(typeName, ts3.Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled);
              var aliasDeclaration = ts3.find(rootSymbol.declarations || ts3.emptyArray, isAliasSymbolDeclaration);
              if (aliasDeclaration) {
                ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(aliasDeclaration, ts3.Diagnostics._0_was_imported_here, ts3.idText(rootName)));
              }
            }
          }
        }
        function markDecoratorMedataDataTypeNodeAsReferenced(node) {
          var entityName = getEntityNameForDecoratorMetadata(node);
          if (entityName && ts3.isEntityName(entityName)) {
            markEntityNameOrEntityExpressionAsReference(entityName, true);
          }
        }
        function getEntityNameForDecoratorMetadata(node) {
          if (node) {
            switch (node.kind) {
              case 188:
              case 187:
                return getEntityNameForDecoratorMetadataFromTypeList(node.types);
              case 189:
                return getEntityNameForDecoratorMetadataFromTypeList([node.trueType, node.falseType]);
              case 191:
              case 197:
                return getEntityNameForDecoratorMetadata(node.type);
              case 178:
                return node.typeName;
            }
          }
        }
        function getEntityNameForDecoratorMetadataFromTypeList(types2) {
          var commonEntityName;
          for (var _i = 0, types_22 = types2; _i < types_22.length; _i++) {
            var typeNode = types_22[_i];
            while (typeNode.kind === 191 || typeNode.kind === 197) {
              typeNode = typeNode.type;
            }
            if (typeNode.kind === 143) {
              continue;
            }
            if (!strictNullChecks && (typeNode.kind === 196 && typeNode.literal.kind === 104 || typeNode.kind === 153)) {
              continue;
            }
            var individualEntityName = getEntityNameForDecoratorMetadata(typeNode);
            if (!individualEntityName) {
              return void 0;
            }
            if (commonEntityName) {
              if (!ts3.isIdentifier(commonEntityName) || !ts3.isIdentifier(individualEntityName) || commonEntityName.escapedText !== individualEntityName.escapedText) {
                return void 0;
              }
            } else {
              commonEntityName = individualEntityName;
            }
          }
          return commonEntityName;
        }
        function getParameterTypeNodeForDecoratorCheck(node) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(node);
          return ts3.isRestParameter(node) ? ts3.getRestParameterElementType(typeNode) : typeNode;
        }
        function checkDecorators(node) {
          if (!node.decorators) {
            return;
          }
          if (!ts3.nodeCanBeDecorated(node, node.parent, node.parent.parent)) {
            return;
          }
          if (!compilerOptions.experimentalDecorators) {
            error(node, ts3.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning);
          }
          var firstDecorator = node.decorators[0];
          checkExternalEmitHelpers(firstDecorator, 8);
          if (node.kind === 164) {
            checkExternalEmitHelpers(firstDecorator, 32);
          }
          if (compilerOptions.emitDecoratorMetadata) {
            checkExternalEmitHelpers(firstDecorator, 16);
            switch (node.kind) {
              case 257:
                var constructor = ts3.getFirstConstructorWithBody(node);
                if (constructor) {
                  for (var _i = 0, _a = constructor.parameters; _i < _a.length; _i++) {
                    var parameter = _a[_i];
                    markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                  }
                }
                break;
              case 172:
              case 173:
                var otherKind = node.kind === 172 ? 173 : 172;
                var otherAccessor = ts3.getDeclarationOfKind(getSymbolOfNode(node), otherKind);
                markDecoratorMedataDataTypeNodeAsReferenced(getAnnotatedAccessorTypeNode(node) || otherAccessor && getAnnotatedAccessorTypeNode(otherAccessor));
                break;
              case 169:
                for (var _b = 0, _c = node.parameters; _b < _c.length; _b++) {
                  var parameter = _c[_b];
                  markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                }
                markDecoratorMedataDataTypeNodeAsReferenced(ts3.getEffectiveReturnTypeNode(node));
                break;
              case 167:
                markDecoratorMedataDataTypeNodeAsReferenced(ts3.getEffectiveTypeAnnotationNode(node));
                break;
              case 164:
                markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(node));
                var containingSignature = node.parent;
                for (var _d = 0, _e = containingSignature.parameters; _d < _e.length; _d++) {
                  var parameter = _e[_d];
                  markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                }
                break;
            }
          }
          ts3.forEach(node.decorators, checkDecorator);
        }
        function checkFunctionDeclaration(node) {
          addLazyDiagnostic(checkFunctionDeclarationDiagnostics);
          function checkFunctionDeclarationDiagnostics() {
            checkFunctionOrMethodDeclaration(node);
            checkGrammarForGenerator(node);
            checkCollisionsForDeclarationName(node, node.name);
          }
        }
        function checkJSDocTypeAliasTag(node) {
          if (!node.typeExpression) {
            error(node.name, ts3.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags);
          }
          if (node.name) {
            checkTypeNameIsReserved(node.name, ts3.Diagnostics.Type_alias_name_cannot_be_0);
          }
          checkSourceElement(node.typeExpression);
          checkTypeParameters(ts3.getEffectiveTypeParameterDeclarations(node));
        }
        function checkJSDocTemplateTag(node) {
          checkSourceElement(node.constraint);
          for (var _i = 0, _a = node.typeParameters; _i < _a.length; _i++) {
            var tp = _a[_i];
            checkSourceElement(tp);
          }
        }
        function checkJSDocTypeTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocParameterTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocPropertyTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocFunctionType(node) {
          addLazyDiagnostic(checkJSDocFunctionTypeImplicitAny);
          checkSignatureDeclaration(node);
          function checkJSDocFunctionTypeImplicitAny() {
            if (!node.type && !ts3.isJSDocConstructSignature(node)) {
              reportImplicitAny(node, anyType);
            }
          }
        }
        function checkJSDocImplementsTag(node) {
          var classLike = ts3.getEffectiveJSDocHost(node);
          if (!classLike || !ts3.isClassDeclaration(classLike) && !ts3.isClassExpression(classLike)) {
            error(classLike, ts3.Diagnostics.JSDoc_0_is_not_attached_to_a_class, ts3.idText(node.tagName));
          }
        }
        function checkJSDocAugmentsTag(node) {
          var classLike = ts3.getEffectiveJSDocHost(node);
          if (!classLike || !ts3.isClassDeclaration(classLike) && !ts3.isClassExpression(classLike)) {
            error(classLike, ts3.Diagnostics.JSDoc_0_is_not_attached_to_a_class, ts3.idText(node.tagName));
            return;
          }
          var augmentsTags = ts3.getJSDocTags(classLike).filter(ts3.isJSDocAugmentsTag);
          ts3.Debug.assert(augmentsTags.length > 0);
          if (augmentsTags.length > 1) {
            error(augmentsTags[1], ts3.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);
          }
          var name = getIdentifierFromEntityNameExpression(node.class.expression);
          var extend3 = ts3.getClassExtendsHeritageElement(classLike);
          if (extend3) {
            var className = getIdentifierFromEntityNameExpression(extend3.expression);
            if (className && name.escapedText !== className.escapedText) {
              error(name, ts3.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause, ts3.idText(node.tagName), ts3.idText(name), ts3.idText(className));
            }
          }
        }
        function checkJSDocAccessibilityModifiers(node) {
          var host2 = ts3.getJSDocHost(node);
          if (host2 && ts3.isPrivateIdentifierClassElementDeclaration(host2)) {
            error(node, ts3.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
          }
        }
        function getIdentifierFromEntityNameExpression(node) {
          switch (node.kind) {
            case 79:
              return node;
            case 206:
              return node.name;
            default:
              return void 0;
          }
        }
        function checkFunctionOrMethodDeclaration(node) {
          var _a;
          checkDecorators(node);
          checkSignatureDeclaration(node);
          var functionFlags = ts3.getFunctionFlags(node);
          if (node.name && node.name.kind === 162) {
            checkComputedPropertyName(node.name);
          }
          if (hasBindableName(node)) {
            var symbol = getSymbolOfNode(node);
            var localSymbol = node.localSymbol || symbol;
            var firstDeclaration = (_a = localSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(function(declaration) {
              return declaration.kind === node.kind && !(declaration.flags & 262144);
            });
            if (node === firstDeclaration) {
              checkFunctionOrConstructorSymbol(localSymbol);
            }
            if (symbol.parent) {
              checkFunctionOrConstructorSymbol(symbol);
            }
          }
          var body = node.kind === 168 ? void 0 : node.body;
          checkSourceElement(body);
          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, getReturnTypeFromAnnotation(node));
          addLazyDiagnostic(checkFunctionOrMethodDeclarationDiagnostics);
          if (ts3.isInJSFile(node)) {
            var typeTag = ts3.getJSDocTypeTag(node);
            if (typeTag && typeTag.typeExpression && !getContextualCallSignature(getTypeFromTypeNode(typeTag.typeExpression), node)) {
              error(typeTag.typeExpression.type, ts3.Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature);
            }
          }
          function checkFunctionOrMethodDeclarationDiagnostics() {
            if (!ts3.getEffectiveReturnTypeNode(node)) {
              if (ts3.nodeIsMissing(body) && !isPrivateWithinAmbient(node)) {
                reportImplicitAny(node, anyType);
              }
              if (functionFlags & 1 && ts3.nodeIsPresent(body)) {
                getReturnTypeOfSignature(getSignatureFromDeclaration(node));
              }
            }
          }
        }
        function registerForUnusedIdentifiersCheck(node) {
          addLazyDiagnostic(registerForUnusedIdentifiersCheckDiagnostics);
          function registerForUnusedIdentifiersCheckDiagnostics() {
            var sourceFile = ts3.getSourceFileOfNode(node);
            var potentiallyUnusedIdentifiers = allPotentiallyUnusedIdentifiers.get(sourceFile.path);
            if (!potentiallyUnusedIdentifiers) {
              potentiallyUnusedIdentifiers = [];
              allPotentiallyUnusedIdentifiers.set(sourceFile.path, potentiallyUnusedIdentifiers);
            }
            potentiallyUnusedIdentifiers.push(node);
          }
        }
        function checkUnusedIdentifiers(potentiallyUnusedIdentifiers, addDiagnostic) {
          for (var _i = 0, potentiallyUnusedIdentifiers_1 = potentiallyUnusedIdentifiers; _i < potentiallyUnusedIdentifiers_1.length; _i++) {
            var node = potentiallyUnusedIdentifiers_1[_i];
            switch (node.kind) {
              case 257:
              case 226:
                checkUnusedClassMembers(node, addDiagnostic);
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 305:
              case 261:
              case 235:
              case 263:
              case 242:
              case 243:
              case 244:
                checkUnusedLocalsAndParameters(node, addDiagnostic);
                break;
              case 171:
              case 213:
              case 256:
              case 214:
              case 169:
              case 172:
              case 173:
                if (node.body) {
                  checkUnusedLocalsAndParameters(node, addDiagnostic);
                }
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 168:
              case 174:
              case 175:
              case 179:
              case 180:
              case 259:
              case 258:
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 190:
                checkUnusedInferTypeParameter(node, addDiagnostic);
                break;
              default:
                ts3.Debug.assertNever(node, "Node should not have been registered for unused identifiers check");
            }
          }
        }
        function errorUnusedLocal(declaration, name, addDiagnostic) {
          var node = ts3.getNameOfDeclaration(declaration) || declaration;
          var message = isTypeDeclaration(declaration) ? ts3.Diagnostics._0_is_declared_but_never_used : ts3.Diagnostics._0_is_declared_but_its_value_is_never_read;
          addDiagnostic(declaration, 0, ts3.createDiagnosticForNode(node, message, name));
        }
        function isIdentifierThatStartsWithUnderscore(node) {
          return ts3.isIdentifier(node) && ts3.idText(node).charCodeAt(0) === 95;
        }
        function checkUnusedClassMembers(node, addDiagnostic) {
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            switch (member.kind) {
              case 169:
              case 167:
              case 172:
              case 173:
                if (member.kind === 173 && member.symbol.flags & 32768) {
                  break;
                }
                var symbol = getSymbolOfNode(member);
                if (!symbol.isReferenced && (ts3.hasEffectiveModifier(member, 8) || ts3.isNamedDeclaration(member) && ts3.isPrivateIdentifier(member.name)) && !(member.flags & 16777216)) {
                  addDiagnostic(member, 0, ts3.createDiagnosticForNode(member.name, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, symbolToString(symbol)));
                }
                break;
              case 171:
                for (var _b = 0, _c = member.parameters; _b < _c.length; _b++) {
                  var parameter = _c[_b];
                  if (!parameter.symbol.isReferenced && ts3.hasSyntacticModifier(parameter, 8)) {
                    addDiagnostic(parameter, 0, ts3.createDiagnosticForNode(parameter.name, ts3.Diagnostics.Property_0_is_declared_but_its_value_is_never_read, ts3.symbolName(parameter.symbol)));
                  }
                }
                break;
              case 176:
              case 234:
              case 170:
                break;
              default:
                ts3.Debug.fail("Unexpected class member");
            }
          }
        }
        function checkUnusedInferTypeParameter(node, addDiagnostic) {
          var typeParameter = node.typeParameter;
          if (isTypeParameterUnused(typeParameter)) {
            addDiagnostic(node, 1, ts3.createDiagnosticForNode(node, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, ts3.idText(typeParameter.name)));
          }
        }
        function checkUnusedTypeParameters(node, addDiagnostic) {
          var declarations = getSymbolOfNode(node).declarations;
          if (!declarations || ts3.last(declarations) !== node)
            return;
          var typeParameters = ts3.getEffectiveTypeParameterDeclarations(node);
          var seenParentsWithEveryUnused = new ts3.Set();
          for (var _i = 0, typeParameters_3 = typeParameters; _i < typeParameters_3.length; _i++) {
            var typeParameter = typeParameters_3[_i];
            if (!isTypeParameterUnused(typeParameter))
              continue;
            var name = ts3.idText(typeParameter.name);
            var parent = typeParameter.parent;
            if (parent.kind !== 190 && parent.typeParameters.every(isTypeParameterUnused)) {
              if (ts3.tryAddToSet(seenParentsWithEveryUnused, parent)) {
                var sourceFile = ts3.getSourceFileOfNode(parent);
                var range = ts3.isJSDocTemplateTag(parent) ? ts3.rangeOfNode(parent) : ts3.rangeOfTypeParameters(sourceFile, parent.typeParameters);
                var only = parent.typeParameters.length === 1;
                var message = only ? ts3.Diagnostics._0_is_declared_but_its_value_is_never_read : ts3.Diagnostics.All_type_parameters_are_unused;
                var arg0 = only ? name : void 0;
                addDiagnostic(typeParameter, 1, ts3.createFileDiagnostic(sourceFile, range.pos, range.end - range.pos, message, arg0));
              }
            } else {
              addDiagnostic(typeParameter, 1, ts3.createDiagnosticForNode(typeParameter, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, name));
            }
          }
        }
        function isTypeParameterUnused(typeParameter) {
          return !(getMergedSymbol(typeParameter.symbol).isReferenced & 262144) && !isIdentifierThatStartsWithUnderscore(typeParameter.name);
        }
        function addToGroup(map2, key, value, getKey) {
          var keyString = String(getKey(key));
          var group = map2.get(keyString);
          if (group) {
            group[1].push(value);
          } else {
            map2.set(keyString, [key, [value]]);
          }
        }
        function tryGetRootParameterDeclaration(node) {
          return ts3.tryCast(ts3.getRootDeclaration(node), ts3.isParameter);
        }
        function isValidUnusedLocalDeclaration(declaration) {
          if (ts3.isBindingElement(declaration)) {
            if (ts3.isObjectBindingPattern(declaration.parent)) {
              return !!(declaration.propertyName && isIdentifierThatStartsWithUnderscore(declaration.name));
            }
            return isIdentifierThatStartsWithUnderscore(declaration.name);
          }
          return ts3.isAmbientModule(declaration) || (ts3.isVariableDeclaration(declaration) && ts3.isForInOrOfStatement(declaration.parent.parent) || isImportedDeclaration(declaration)) && isIdentifierThatStartsWithUnderscore(declaration.name);
        }
        function checkUnusedLocalsAndParameters(nodeWithLocals, addDiagnostic) {
          var unusedImports = new ts3.Map();
          var unusedDestructures = new ts3.Map();
          var unusedVariables = new ts3.Map();
          nodeWithLocals.locals.forEach(function(local) {
            if (local.flags & 262144 ? !(local.flags & 3 && !(local.isReferenced & 3)) : local.isReferenced || local.exportSymbol) {
              return;
            }
            if (local.declarations) {
              for (var _i = 0, _a = local.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (isValidUnusedLocalDeclaration(declaration)) {
                  continue;
                }
                if (isImportedDeclaration(declaration)) {
                  addToGroup(unusedImports, importClauseFromImported(declaration), declaration, getNodeId);
                } else if (ts3.isBindingElement(declaration) && ts3.isObjectBindingPattern(declaration.parent)) {
                  var lastElement = ts3.last(declaration.parent.elements);
                  if (declaration === lastElement || !ts3.last(declaration.parent.elements).dotDotDotToken) {
                    addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
                  }
                } else if (ts3.isVariableDeclaration(declaration)) {
                  addToGroup(unusedVariables, declaration.parent, declaration, getNodeId);
                } else {
                  var parameter = local.valueDeclaration && tryGetRootParameterDeclaration(local.valueDeclaration);
                  var name = local.valueDeclaration && ts3.getNameOfDeclaration(local.valueDeclaration);
                  if (parameter && name) {
                    if (!ts3.isParameterPropertyDeclaration(parameter, parameter.parent) && !ts3.parameterIsThisKeyword(parameter) && !isIdentifierThatStartsWithUnderscore(name)) {
                      if (ts3.isBindingElement(declaration) && ts3.isArrayBindingPattern(declaration.parent)) {
                        addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
                      } else {
                        addDiagnostic(parameter, 1, ts3.createDiagnosticForNode(name, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, ts3.symbolName(local)));
                      }
                    }
                  } else {
                    errorUnusedLocal(declaration, ts3.symbolName(local), addDiagnostic);
                  }
                }
              }
            }
          });
          unusedImports.forEach(function(_a) {
            var importClause = _a[0], unuseds = _a[1];
            var importDecl = importClause.parent;
            var nDeclarations = (importClause.name ? 1 : 0) + (importClause.namedBindings ? importClause.namedBindings.kind === 268 ? 1 : importClause.namedBindings.elements.length : 0);
            if (nDeclarations === unuseds.length) {
              addDiagnostic(importDecl, 0, unuseds.length === 1 ? ts3.createDiagnosticForNode(importDecl, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, ts3.idText(ts3.first(unuseds).name)) : ts3.createDiagnosticForNode(importDecl, ts3.Diagnostics.All_imports_in_import_declaration_are_unused));
            } else {
              for (var _i = 0, unuseds_1 = unuseds; _i < unuseds_1.length; _i++) {
                var unused = unuseds_1[_i];
                errorUnusedLocal(unused, ts3.idText(unused.name), addDiagnostic);
              }
            }
          });
          unusedDestructures.forEach(function(_a) {
            var bindingPattern = _a[0], bindingElements = _a[1];
            var kind = tryGetRootParameterDeclaration(bindingPattern.parent) ? 1 : 0;
            if (bindingPattern.elements.length === bindingElements.length) {
              if (bindingElements.length === 1 && bindingPattern.parent.kind === 254 && bindingPattern.parent.parent.kind === 255) {
                addToGroup(unusedVariables, bindingPattern.parent.parent, bindingPattern.parent, getNodeId);
              } else {
                addDiagnostic(bindingPattern, kind, bindingElements.length === 1 ? ts3.createDiagnosticForNode(bindingPattern, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(ts3.first(bindingElements).name)) : ts3.createDiagnosticForNode(bindingPattern, ts3.Diagnostics.All_destructured_elements_are_unused));
              }
            } else {
              for (var _i = 0, bindingElements_1 = bindingElements; _i < bindingElements_1.length; _i++) {
                var e = bindingElements_1[_i];
                addDiagnostic(e, kind, ts3.createDiagnosticForNode(e, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(e.name)));
              }
            }
          });
          unusedVariables.forEach(function(_a) {
            var declarationList = _a[0], declarations = _a[1];
            if (declarationList.declarations.length === declarations.length) {
              addDiagnostic(declarationList, 0, declarations.length === 1 ? ts3.createDiagnosticForNode(ts3.first(declarations).name, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(ts3.first(declarations).name)) : ts3.createDiagnosticForNode(declarationList.parent.kind === 237 ? declarationList.parent : declarationList, ts3.Diagnostics.All_variables_are_unused));
            } else {
              for (var _i = 0, declarations_6 = declarations; _i < declarations_6.length; _i++) {
                var decl = declarations_6[_i];
                addDiagnostic(decl, 0, ts3.createDiagnosticForNode(decl, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(decl.name)));
              }
            }
          });
        }
        function bindingNameText(name) {
          switch (name.kind) {
            case 79:
              return ts3.idText(name);
            case 202:
            case 201:
              return bindingNameText(ts3.cast(ts3.first(name.elements), ts3.isBindingElement).name);
            default:
              return ts3.Debug.assertNever(name);
          }
        }
        function isImportedDeclaration(node) {
          return node.kind === 267 || node.kind === 270 || node.kind === 268;
        }
        function importClauseFromImported(decl) {
          return decl.kind === 267 ? decl : decl.kind === 268 ? decl.parent : decl.parent.parent;
        }
        function checkBlock(node) {
          if (node.kind === 235) {
            checkGrammarStatementInAmbientContext(node);
          }
          if (ts3.isFunctionOrModuleBlock(node)) {
            var saveFlowAnalysisDisabled = flowAnalysisDisabled;
            ts3.forEach(node.statements, checkSourceElement);
            flowAnalysisDisabled = saveFlowAnalysisDisabled;
          } else {
            ts3.forEach(node.statements, checkSourceElement);
          }
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkCollisionWithArgumentsInGeneratedCode(node) {
          if (languageVersion >= 2 || !ts3.hasRestParameter(node) || node.flags & 16777216 || ts3.nodeIsMissing(node.body)) {
            return;
          }
          ts3.forEach(node.parameters, function(p) {
            if (p.name && !ts3.isBindingPattern(p.name) && p.name.escapedText === argumentsSymbol.escapedName) {
              errorSkippedOn("noEmit", p, ts3.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
            }
          });
        }
        function needCollisionCheckForIdentifier(node, identifier, name) {
          if ((identifier === null || identifier === void 0 ? void 0 : identifier.escapedText) !== name) {
            return false;
          }
          if (node.kind === 167 || node.kind === 166 || node.kind === 169 || node.kind === 168 || node.kind === 172 || node.kind === 173 || node.kind === 296) {
            return false;
          }
          if (node.flags & 16777216) {
            return false;
          }
          if (ts3.isImportClause(node) || ts3.isImportEqualsDeclaration(node) || ts3.isImportSpecifier(node)) {
            if (ts3.isTypeOnlyImportOrExportDeclaration(node)) {
              return false;
            }
          }
          var root = ts3.getRootDeclaration(node);
          if (ts3.isParameter(root) && ts3.nodeIsMissing(root.parent.body)) {
            return false;
          }
          return true;
        }
        function checkIfThisIsCapturedInEnclosingScope(node) {
          ts3.findAncestor(node, function(current) {
            if (getNodeCheckFlags(current) & 4) {
              var isDeclaration_1 = node.kind !== 79;
              if (isDeclaration_1) {
                error(ts3.getNameOfDeclaration(node), ts3.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference);
              } else {
                error(node, ts3.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference);
              }
              return true;
            }
            return false;
          });
        }
        function checkIfNewTargetIsCapturedInEnclosingScope(node) {
          ts3.findAncestor(node, function(current) {
            if (getNodeCheckFlags(current) & 8) {
              var isDeclaration_2 = node.kind !== 79;
              if (isDeclaration_2) {
                error(ts3.getNameOfDeclaration(node), ts3.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference);
              } else {
                error(node, ts3.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference);
              }
              return true;
            }
            return false;
          });
        }
        function checkCollisionWithRequireExportsInGeneratedCode(node, name) {
          if (moduleKind >= ts3.ModuleKind.ES2015 && !(moduleKind >= ts3.ModuleKind.Node16 && ts3.getSourceFileOfNode(node).impliedNodeFormat === ts3.ModuleKind.CommonJS)) {
            return;
          }
          if (!name || !needCollisionCheckForIdentifier(node, name, "require") && !needCollisionCheckForIdentifier(node, name, "exports")) {
            return;
          }
          if (ts3.isModuleDeclaration(node) && ts3.getModuleInstanceState(node) !== 1) {
            return;
          }
          var parent = getDeclarationContainer(node);
          if (parent.kind === 305 && ts3.isExternalOrCommonJsModule(parent)) {
            errorSkippedOn("noEmit", name, ts3.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, ts3.declarationNameToString(name), ts3.declarationNameToString(name));
          }
        }
        function checkCollisionWithGlobalPromiseInGeneratedCode(node, name) {
          if (!name || languageVersion >= 4 || !needCollisionCheckForIdentifier(node, name, "Promise")) {
            return;
          }
          if (ts3.isModuleDeclaration(node) && ts3.getModuleInstanceState(node) !== 1) {
            return;
          }
          var parent = getDeclarationContainer(node);
          if (parent.kind === 305 && ts3.isExternalOrCommonJsModule(parent) && parent.flags & 2048) {
            errorSkippedOn("noEmit", name, ts3.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions, ts3.declarationNameToString(name), ts3.declarationNameToString(name));
          }
        }
        function recordPotentialCollisionWithWeakMapSetInGeneratedCode(node, name) {
          if (languageVersion <= 8 && (needCollisionCheckForIdentifier(node, name, "WeakMap") || needCollisionCheckForIdentifier(node, name, "WeakSet"))) {
            potentialWeakMapSetCollisions.push(node);
          }
        }
        function checkWeakMapSetCollision(node) {
          var enclosingBlockScope = ts3.getEnclosingBlockScopeContainer(node);
          if (getNodeCheckFlags(enclosingBlockScope) & 67108864) {
            ts3.Debug.assert(ts3.isNamedDeclaration(node) && ts3.isIdentifier(node.name) && typeof node.name.escapedText === "string", "The target of a WeakMap/WeakSet collision check should be an identifier");
            errorSkippedOn("noEmit", node, ts3.Diagnostics.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel, node.name.escapedText);
          }
        }
        function recordPotentialCollisionWithReflectInGeneratedCode(node, name) {
          if (name && languageVersion >= 2 && languageVersion <= 8 && needCollisionCheckForIdentifier(node, name, "Reflect")) {
            potentialReflectCollisions.push(node);
          }
        }
        function checkReflectCollision(node) {
          var hasCollision = false;
          if (ts3.isClassExpression(node)) {
            for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
              var member = _a[_i];
              if (getNodeCheckFlags(member) & 134217728) {
                hasCollision = true;
                break;
              }
            }
          } else if (ts3.isFunctionExpression(node)) {
            if (getNodeCheckFlags(node) & 134217728) {
              hasCollision = true;
            }
          } else {
            var container = ts3.getEnclosingBlockScopeContainer(node);
            if (container && getNodeCheckFlags(container) & 134217728) {
              hasCollision = true;
            }
          }
          if (hasCollision) {
            ts3.Debug.assert(ts3.isNamedDeclaration(node) && ts3.isIdentifier(node.name), "The target of a Reflect collision check should be an identifier");
            errorSkippedOn("noEmit", node, ts3.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers, ts3.declarationNameToString(node.name), "Reflect");
          }
        }
        function checkCollisionsForDeclarationName(node, name) {
          if (!name)
            return;
          checkCollisionWithRequireExportsInGeneratedCode(node, name);
          checkCollisionWithGlobalPromiseInGeneratedCode(node, name);
          recordPotentialCollisionWithWeakMapSetInGeneratedCode(node, name);
          recordPotentialCollisionWithReflectInGeneratedCode(node, name);
          if (ts3.isClassLike(node)) {
            checkTypeNameIsReserved(name, ts3.Diagnostics.Class_name_cannot_be_0);
            if (!(node.flags & 16777216)) {
              checkClassNameCollisionWithObject(name);
            }
          } else if (ts3.isEnumDeclaration(node)) {
            checkTypeNameIsReserved(name, ts3.Diagnostics.Enum_name_cannot_be_0);
          }
        }
        function checkVarDeclaredNamesNotShadowed(node) {
          if ((ts3.getCombinedNodeFlags(node) & 3) !== 0 || ts3.isParameterDeclaration(node)) {
            return;
          }
          if (node.kind === 254 && !node.initializer) {
            return;
          }
          var symbol = getSymbolOfNode(node);
          if (symbol.flags & 1) {
            if (!ts3.isIdentifier(node.name))
              return ts3.Debug.fail();
            var localDeclarationSymbol = resolveName(node, node.name.escapedText, 3, void 0, void 0, false);
            if (localDeclarationSymbol && localDeclarationSymbol !== symbol && localDeclarationSymbol.flags & 2) {
              if (getDeclarationNodeFlagsFromSymbol(localDeclarationSymbol) & 3) {
                var varDeclList = ts3.getAncestor(localDeclarationSymbol.valueDeclaration, 255);
                var container = varDeclList.parent.kind === 237 && varDeclList.parent.parent ? varDeclList.parent.parent : void 0;
                var namesShareScope = container && (container.kind === 235 && ts3.isFunctionLike(container.parent) || container.kind === 262 || container.kind === 261 || container.kind === 305);
                if (!namesShareScope) {
                  var name = symbolToString(localDeclarationSymbol);
                  error(node, ts3.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1, name, name);
                }
              }
            }
          }
        }
        function convertAutoToAny(type2) {
          return type2 === autoType ? anyType : type2 === autoArrayType ? anyArrayType : type2;
        }
        function checkVariableLikeDeclaration(node) {
          var _a;
          checkDecorators(node);
          if (!ts3.isBindingElement(node)) {
            checkSourceElement(node.type);
          }
          if (!node.name) {
            return;
          }
          if (node.name.kind === 162) {
            checkComputedPropertyName(node.name);
            if (node.initializer) {
              checkExpressionCached(node.initializer);
            }
          }
          if (ts3.isBindingElement(node)) {
            if (ts3.isObjectBindingPattern(node.parent) && node.dotDotDotToken && languageVersion < 5) {
              checkExternalEmitHelpers(node, 4);
            }
            if (node.propertyName && node.propertyName.kind === 162) {
              checkComputedPropertyName(node.propertyName);
            }
            var parent = node.parent.parent;
            var parentCheckMode = node.dotDotDotToken ? 64 : 0;
            var parentType = getTypeForBindingElementParent(parent, parentCheckMode);
            var name = node.propertyName || node.name;
            if (parentType && !ts3.isBindingPattern(name)) {
              var exprType = getLiteralTypeFromPropertyName(name);
              if (isTypeUsableAsPropertyName(exprType)) {
                var nameText = getPropertyNameFromType(exprType);
                var property = getPropertyOfType(parentType, nameText);
                if (property) {
                  markPropertyAsReferenced(property, void 0, false);
                  checkPropertyAccessibility(node, !!parent.initializer && parent.initializer.kind === 106, false, parentType, property);
                }
              }
            }
          }
          if (ts3.isBindingPattern(node.name)) {
            if (node.name.kind === 202 && languageVersion < 2 && compilerOptions.downlevelIteration) {
              checkExternalEmitHelpers(node, 512);
            }
            ts3.forEach(node.name.elements, checkSourceElement);
          }
          if (node.initializer && ts3.isParameterDeclaration(node) && ts3.nodeIsMissing(ts3.getContainingFunction(node).body)) {
            error(node, ts3.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
            return;
          }
          if (ts3.isBindingPattern(node.name)) {
            var needCheckInitializer = node.initializer && node.parent.parent.kind !== 243;
            var needCheckWidenedType = node.name.elements.length === 0;
            if (needCheckInitializer || needCheckWidenedType) {
              var widenedType = getWidenedTypeForVariableLikeDeclaration(node);
              if (needCheckInitializer) {
                var initializerType = checkExpressionCached(node.initializer);
                if (strictNullChecks && needCheckWidenedType) {
                  checkNonNullNonVoidType(initializerType, node);
                } else {
                  checkTypeAssignableToAndOptionallyElaborate(initializerType, getWidenedTypeForVariableLikeDeclaration(node), node, node.initializer);
                }
              }
              if (needCheckWidenedType) {
                if (ts3.isArrayBindingPattern(node.name)) {
                  checkIteratedTypeOrElementType(65, widenedType, undefinedType, node);
                } else if (strictNullChecks) {
                  checkNonNullNonVoidType(widenedType, node);
                }
              }
            }
            return;
          }
          var symbol = getSymbolOfNode(node);
          if (symbol.flags & 2097152 && ts3.isVariableDeclarationInitializedToBareOrAccessedRequire(node.kind === 203 ? node.parent.parent : node)) {
            checkAliasSymbol(node);
            return;
          }
          var type2 = convertAutoToAny(getTypeOfSymbol(symbol));
          if (node === symbol.valueDeclaration) {
            var initializer = ts3.getEffectiveInitializer(node);
            if (initializer) {
              var isJSObjectLiteralInitializer = ts3.isInJSFile(node) && ts3.isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || ts3.isPrototypeAccess(node.name)) && !!((_a = symbol.exports) === null || _a === void 0 ? void 0 : _a.size);
              if (!isJSObjectLiteralInitializer && node.parent.parent.kind !== 243) {
                checkTypeAssignableToAndOptionallyElaborate(checkExpressionCached(initializer), type2, node, initializer, void 0);
              }
            }
            if (symbol.declarations && symbol.declarations.length > 1) {
              if (ts3.some(symbol.declarations, function(d) {
                return d !== node && ts3.isVariableLike(d) && !areDeclarationFlagsIdentical(d, node);
              })) {
                error(node.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts3.declarationNameToString(node.name));
              }
            }
          } else {
            var declarationType = convertAutoToAny(getWidenedTypeForVariableLikeDeclaration(node));
            if (!isErrorType(type2) && !isErrorType(declarationType) && !isTypeIdenticalTo(type2, declarationType) && !(symbol.flags & 67108864)) {
              errorNextVariableOrPropertyDeclarationMustHaveSameType(symbol.valueDeclaration, type2, node, declarationType);
            }
            if (node.initializer) {
              checkTypeAssignableToAndOptionallyElaborate(checkExpressionCached(node.initializer), declarationType, node, node.initializer, void 0);
            }
            if (symbol.valueDeclaration && !areDeclarationFlagsIdentical(node, symbol.valueDeclaration)) {
              error(node.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts3.declarationNameToString(node.name));
            }
          }
          if (node.kind !== 167 && node.kind !== 166) {
            checkExportsOnMergedDeclarations(node);
            if (node.kind === 254 || node.kind === 203) {
              checkVarDeclaredNamesNotShadowed(node);
            }
            checkCollisionsForDeclarationName(node, node.name);
          }
        }
        function errorNextVariableOrPropertyDeclarationMustHaveSameType(firstDeclaration, firstType, nextDeclaration, nextType) {
          var nextDeclarationName = ts3.getNameOfDeclaration(nextDeclaration);
          var message = nextDeclaration.kind === 167 || nextDeclaration.kind === 166 ? ts3.Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2 : ts3.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2;
          var declName = ts3.declarationNameToString(nextDeclarationName);
          var err = error(nextDeclarationName, message, declName, typeToString(firstType), typeToString(nextType));
          if (firstDeclaration) {
            ts3.addRelatedInfo(err, ts3.createDiagnosticForNode(firstDeclaration, ts3.Diagnostics._0_was_also_declared_here, declName));
          }
        }
        function areDeclarationFlagsIdentical(left, right) {
          if (left.kind === 164 && right.kind === 254 || left.kind === 254 && right.kind === 164) {
            return true;
          }
          if (ts3.hasQuestionToken(left) !== ts3.hasQuestionToken(right)) {
            return false;
          }
          var interestingFlags = 8 | 16 | 256 | 128 | 64 | 32;
          return ts3.getSelectedEffectiveModifierFlags(left, interestingFlags) === ts3.getSelectedEffectiveModifierFlags(right, interestingFlags);
        }
        function checkVariableDeclaration(node) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkVariableDeclaration", { kind: node.kind, pos: node.pos, end: node.end, path: node.tracingPath });
          checkGrammarVariableDeclaration(node);
          checkVariableLikeDeclaration(node);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function checkBindingElement(node) {
          checkGrammarBindingElement(node);
          return checkVariableLikeDeclaration(node);
        }
        function checkVariableStatement(node) {
          if (!checkGrammarDecoratorsAndModifiers(node) && !checkGrammarVariableDeclarationList(node.declarationList))
            checkGrammarForDisallowedLetOrConstStatement(node);
          ts3.forEach(node.declarationList.declarations, checkSourceElement);
        }
        function checkExpressionStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkExpression(node.expression);
        }
        function checkIfStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkTruthinessExpression(node.expression);
          checkTestingKnownTruthyCallableOrAwaitableType(node.expression, node.thenStatement);
          checkSourceElement(node.thenStatement);
          if (node.thenStatement.kind === 236) {
            error(node.thenStatement, ts3.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement);
          }
          checkSourceElement(node.elseStatement);
        }
        function checkTestingKnownTruthyCallableOrAwaitableType(condExpr, body) {
          if (!strictNullChecks)
            return;
          helper(condExpr, body);
          while (ts3.isBinaryExpression(condExpr) && condExpr.operatorToken.kind === 56) {
            condExpr = condExpr.left;
            helper(condExpr, body);
          }
          function helper(condExpr2, body2) {
            var location = ts3.isBinaryExpression(condExpr2) && (condExpr2.operatorToken.kind === 56 || condExpr2.operatorToken.kind === 55) ? condExpr2.right : condExpr2;
            if (ts3.isModuleExportsAccessExpression(location))
              return;
            var type2 = checkTruthinessExpression(location);
            var isPropertyExpressionCast = ts3.isPropertyAccessExpression(location) && isTypeAssertion(location.expression);
            if (getFalsyFlags(type2) || isPropertyExpressionCast)
              return;
            var callSignatures = getSignaturesOfType(type2, 0);
            var isPromise = !!getAwaitedTypeOfPromise(type2);
            if (callSignatures.length === 0 && !isPromise) {
              return;
            }
            var testedNode = ts3.isIdentifier(location) ? location : ts3.isPropertyAccessExpression(location) ? location.name : ts3.isBinaryExpression(location) && ts3.isIdentifier(location.right) ? location.right : void 0;
            var testedSymbol = testedNode && getSymbolAtLocation(testedNode);
            if (!testedSymbol && !isPromise) {
              return;
            }
            var isUsed = testedSymbol && ts3.isBinaryExpression(condExpr2.parent) && isSymbolUsedInBinaryExpressionChain(condExpr2.parent, testedSymbol) || testedSymbol && body2 && isSymbolUsedInConditionBody(condExpr2, body2, testedNode, testedSymbol);
            if (!isUsed) {
              if (isPromise) {
                errorAndMaybeSuggestAwait(location, true, ts3.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined, getTypeNameForErrorDisplay(type2));
              } else {
                error(location, ts3.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead);
              }
            }
          }
        }
        function isSymbolUsedInConditionBody(expr, body, testedNode, testedSymbol) {
          return !!ts3.forEachChild(body, function check(childNode) {
            if (ts3.isIdentifier(childNode)) {
              var childSymbol = getSymbolAtLocation(childNode);
              if (childSymbol && childSymbol === testedSymbol) {
                if (ts3.isIdentifier(expr) || ts3.isIdentifier(testedNode) && ts3.isBinaryExpression(testedNode.parent)) {
                  return true;
                }
                var testedExpression = testedNode.parent;
                var childExpression = childNode.parent;
                while (testedExpression && childExpression) {
                  if (ts3.isIdentifier(testedExpression) && ts3.isIdentifier(childExpression) || testedExpression.kind === 108 && childExpression.kind === 108) {
                    return getSymbolAtLocation(testedExpression) === getSymbolAtLocation(childExpression);
                  } else if (ts3.isPropertyAccessExpression(testedExpression) && ts3.isPropertyAccessExpression(childExpression)) {
                    if (getSymbolAtLocation(testedExpression.name) !== getSymbolAtLocation(childExpression.name)) {
                      return false;
                    }
                    childExpression = childExpression.expression;
                    testedExpression = testedExpression.expression;
                  } else if (ts3.isCallExpression(testedExpression) && ts3.isCallExpression(childExpression)) {
                    childExpression = childExpression.expression;
                    testedExpression = testedExpression.expression;
                  } else {
                    return false;
                  }
                }
              }
            }
            return ts3.forEachChild(childNode, check);
          });
        }
        function isSymbolUsedInBinaryExpressionChain(node, testedSymbol) {
          while (ts3.isBinaryExpression(node) && node.operatorToken.kind === 55) {
            var isUsed = ts3.forEachChild(node.right, function visit(child) {
              if (ts3.isIdentifier(child)) {
                var symbol = getSymbolAtLocation(child);
                if (symbol && symbol === testedSymbol) {
                  return true;
                }
              }
              return ts3.forEachChild(child, visit);
            });
            if (isUsed) {
              return true;
            }
            node = node.parent;
          }
          return false;
        }
        function checkDoStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkSourceElement(node.statement);
          checkTruthinessExpression(node.expression);
        }
        function checkWhileStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkTruthinessExpression(node.expression);
          checkSourceElement(node.statement);
        }
        function checkTruthinessOfType(type2, node) {
          if (type2.flags & 16384) {
            error(node, ts3.Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness);
          }
          return type2;
        }
        function checkTruthinessExpression(node, checkMode) {
          return checkTruthinessOfType(checkExpression(node, checkMode), node);
        }
        function checkForStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.initializer && node.initializer.kind === 255) {
              checkGrammarVariableDeclarationList(node.initializer);
            }
          }
          if (node.initializer) {
            if (node.initializer.kind === 255) {
              ts3.forEach(node.initializer.declarations, checkVariableDeclaration);
            } else {
              checkExpression(node.initializer);
            }
          }
          if (node.condition)
            checkTruthinessExpression(node.condition);
          if (node.incrementor)
            checkExpression(node.incrementor);
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForOfStatement(node) {
          checkGrammarForInOrForOfStatement(node);
          var container = ts3.getContainingFunctionOrClassStaticBlock(node);
          if (node.awaitModifier) {
            if (container && ts3.isClassStaticBlockDeclaration(container)) {
              grammarErrorOnNode(node.awaitModifier, ts3.Diagnostics.For_await_loops_cannot_be_used_inside_a_class_static_block);
            } else {
              var functionFlags = ts3.getFunctionFlags(container);
              if ((functionFlags & (4 | 2)) === 2 && languageVersion < 99) {
                checkExternalEmitHelpers(node, 16384);
              }
            }
          } else if (compilerOptions.downlevelIteration && languageVersion < 2) {
            checkExternalEmitHelpers(node, 256);
          }
          if (node.initializer.kind === 255) {
            checkForInOrForOfVariableDeclaration(node);
          } else {
            var varExpr = node.initializer;
            var iteratedType = checkRightHandSideOfForOf(node);
            if (varExpr.kind === 204 || varExpr.kind === 205) {
              checkDestructuringAssignment(varExpr, iteratedType || errorType);
            } else {
              var leftType = checkExpression(varExpr);
              checkReferenceExpression(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access);
              if (iteratedType) {
                checkTypeAssignableToAndOptionallyElaborate(iteratedType, leftType, varExpr, node.expression);
              }
            }
          }
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForInStatement(node) {
          checkGrammarForInOrForOfStatement(node);
          var rightType = getNonNullableTypeIfNeeded(checkExpression(node.expression));
          if (node.initializer.kind === 255) {
            var variable = node.initializer.declarations[0];
            if (variable && ts3.isBindingPattern(variable.name)) {
              error(variable.name, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
            }
            checkForInOrForOfVariableDeclaration(node);
          } else {
            var varExpr = node.initializer;
            var leftType = checkExpression(varExpr);
            if (varExpr.kind === 204 || varExpr.kind === 205) {
              error(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
            } else if (!isTypeAssignableTo(getIndexTypeOrString(rightType), leftType)) {
              error(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any);
            } else {
              checkReferenceExpression(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access);
            }
          }
          if (rightType === neverType || !isTypeAssignableToKind(rightType, 67108864 | 58982400)) {
            error(node.expression, ts3.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0, typeToString(rightType));
          }
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForInOrForOfVariableDeclaration(iterationStatement) {
          var variableDeclarationList = iterationStatement.initializer;
          if (variableDeclarationList.declarations.length >= 1) {
            var decl = variableDeclarationList.declarations[0];
            checkVariableDeclaration(decl);
          }
        }
        function checkRightHandSideOfForOf(statement) {
          var use = statement.awaitModifier ? 15 : 13;
          return checkIteratedTypeOrElementType(use, checkNonNullExpression(statement.expression), undefinedType, statement.expression);
        }
        function checkIteratedTypeOrElementType(use, inputType, sentType, errorNode) {
          if (isTypeAny(inputType)) {
            return inputType;
          }
          return getIteratedTypeOrElementType(use, inputType, sentType, errorNode, true) || anyType;
        }
        function getIteratedTypeOrElementType(use, inputType, sentType, errorNode, checkAssignability) {
          var allowAsyncIterables = (use & 2) !== 0;
          if (inputType === neverType) {
            reportTypeNotIterableError(errorNode, inputType, allowAsyncIterables);
            return void 0;
          }
          var uplevelIteration = languageVersion >= 2;
          var downlevelIteration = !uplevelIteration && compilerOptions.downlevelIteration;
          var possibleOutOfBounds = compilerOptions.noUncheckedIndexedAccess && !!(use & 128);
          if (uplevelIteration || downlevelIteration || allowAsyncIterables) {
            var iterationTypes = getIterationTypesOfIterable(inputType, use, uplevelIteration ? errorNode : void 0);
            if (checkAssignability) {
              if (iterationTypes) {
                var diagnostic = use & 8 ? ts3.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0 : use & 32 ? ts3.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0 : use & 64 ? ts3.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0 : use & 16 ? ts3.Diagnostics.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0 : void 0;
                if (diagnostic) {
                  checkTypeAssignableTo(sentType, iterationTypes.nextType, errorNode, diagnostic);
                }
              }
            }
            if (iterationTypes || uplevelIteration) {
              return possibleOutOfBounds ? includeUndefinedInIndexSignature(iterationTypes && iterationTypes.yieldType) : iterationTypes && iterationTypes.yieldType;
            }
          }
          var arrayType = inputType;
          var reportedError = false;
          var hasStringConstituent = false;
          if (use & 4) {
            if (arrayType.flags & 1048576) {
              var arrayTypes = inputType.types;
              var filteredTypes = ts3.filter(arrayTypes, function(t) {
                return !(t.flags & 402653316);
              });
              if (filteredTypes !== arrayTypes) {
                arrayType = getUnionType(filteredTypes, 2);
              }
            } else if (arrayType.flags & 402653316) {
              arrayType = neverType;
            }
            hasStringConstituent = arrayType !== inputType;
            if (hasStringConstituent) {
              if (languageVersion < 1) {
                if (errorNode) {
                  error(errorNode, ts3.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher);
                  reportedError = true;
                }
              }
              if (arrayType.flags & 131072) {
                return possibleOutOfBounds ? includeUndefinedInIndexSignature(stringType) : stringType;
              }
            }
          }
          if (!isArrayLikeType(arrayType)) {
            if (errorNode && !reportedError) {
              var allowsStrings = !!(use & 4) && !hasStringConstituent;
              var _a = getIterationDiagnosticDetails(allowsStrings, downlevelIteration), defaultDiagnostic = _a[0], maybeMissingAwait = _a[1];
              errorAndMaybeSuggestAwait(errorNode, maybeMissingAwait && !!getAwaitedTypeOfPromise(arrayType), defaultDiagnostic, typeToString(arrayType));
            }
            return hasStringConstituent ? possibleOutOfBounds ? includeUndefinedInIndexSignature(stringType) : stringType : void 0;
          }
          var arrayElementType = getIndexTypeOfType(arrayType, numberType);
          if (hasStringConstituent && arrayElementType) {
            if (arrayElementType.flags & 402653316 && !compilerOptions.noUncheckedIndexedAccess) {
              return stringType;
            }
            return getUnionType(possibleOutOfBounds ? [arrayElementType, stringType, undefinedType] : [arrayElementType, stringType], 2);
          }
          return use & 128 ? includeUndefinedInIndexSignature(arrayElementType) : arrayElementType;
          function getIterationDiagnosticDetails(allowsStrings2, downlevelIteration2) {
            var _a2;
            if (downlevelIteration2) {
              return allowsStrings2 ? [ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : [ts3.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true];
            }
            var yieldType = getIterationTypeOfIterable(use, 0, inputType, void 0);
            if (yieldType) {
              return [ts3.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, false];
            }
            if (isES2015OrLaterIterable((_a2 = inputType.symbol) === null || _a2 === void 0 ? void 0 : _a2.escapedName)) {
              return [ts3.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, true];
            }
            return allowsStrings2 ? [ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type, true] : [ts3.Diagnostics.Type_0_is_not_an_array_type, true];
          }
        }
        function isES2015OrLaterIterable(n) {
          switch (n) {
            case "Float32Array":
            case "Float64Array":
            case "Int16Array":
            case "Int32Array":
            case "Int8Array":
            case "NodeList":
            case "Uint16Array":
            case "Uint32Array":
            case "Uint8Array":
            case "Uint8ClampedArray":
              return true;
          }
          return false;
        }
        function getIterationTypeOfIterable(use, typeKind, inputType, errorNode) {
          if (isTypeAny(inputType)) {
            return void 0;
          }
          var iterationTypes = getIterationTypesOfIterable(inputType, use, errorNode);
          return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(typeKind)];
        }
        function createIterationTypes(yieldType, returnType, nextType) {
          if (yieldType === void 0) {
            yieldType = neverType;
          }
          if (returnType === void 0) {
            returnType = neverType;
          }
          if (nextType === void 0) {
            nextType = unknownType;
          }
          if (yieldType.flags & 67359327 && returnType.flags & (1 | 131072 | 2 | 16384 | 32768) && nextType.flags & (1 | 131072 | 2 | 16384 | 32768)) {
            var id = getTypeListId([yieldType, returnType, nextType]);
            var iterationTypes = iterationTypesCache.get(id);
            if (!iterationTypes) {
              iterationTypes = { yieldType, returnType, nextType };
              iterationTypesCache.set(id, iterationTypes);
            }
            return iterationTypes;
          }
          return { yieldType, returnType, nextType };
        }
        function combineIterationTypes(array) {
          var yieldTypes;
          var returnTypes;
          var nextTypes;
          for (var _i = 0, array_11 = array; _i < array_11.length; _i++) {
            var iterationTypes = array_11[_i];
            if (iterationTypes === void 0 || iterationTypes === noIterationTypes) {
              continue;
            }
            if (iterationTypes === anyIterationTypes) {
              return anyIterationTypes;
            }
            yieldTypes = ts3.append(yieldTypes, iterationTypes.yieldType);
            returnTypes = ts3.append(returnTypes, iterationTypes.returnType);
            nextTypes = ts3.append(nextTypes, iterationTypes.nextType);
          }
          if (yieldTypes || returnTypes || nextTypes) {
            return createIterationTypes(yieldTypes && getUnionType(yieldTypes), returnTypes && getUnionType(returnTypes), nextTypes && getIntersectionType(nextTypes));
          }
          return noIterationTypes;
        }
        function getCachedIterationTypes(type2, cacheKey) {
          return type2[cacheKey];
        }
        function setCachedIterationTypes(type2, cacheKey, cachedTypes) {
          return type2[cacheKey] = cachedTypes;
        }
        function getIterationTypesOfIterable(type2, use, errorNode) {
          if (isTypeAny(type2)) {
            return anyIterationTypes;
          }
          if (!(type2.flags & 1048576)) {
            var iterationTypes_1 = getIterationTypesOfIterableWorker(type2, use, errorNode);
            if (iterationTypes_1 === noIterationTypes) {
              if (errorNode) {
                reportTypeNotIterableError(errorNode, type2, !!(use & 2));
              }
              return void 0;
            }
            return iterationTypes_1;
          }
          var cacheKey = use & 2 ? "iterationTypesOfAsyncIterable" : "iterationTypesOfIterable";
          var cachedTypes = getCachedIterationTypes(type2, cacheKey);
          if (cachedTypes)
            return cachedTypes === noIterationTypes ? void 0 : cachedTypes;
          var allIterationTypes;
          for (var _i = 0, _a = type2.types; _i < _a.length; _i++) {
            var constituent = _a[_i];
            var iterationTypes_2 = getIterationTypesOfIterableWorker(constituent, use, errorNode);
            if (iterationTypes_2 === noIterationTypes) {
              if (errorNode) {
                reportTypeNotIterableError(errorNode, type2, !!(use & 2));
              }
              setCachedIterationTypes(type2, cacheKey, noIterationTypes);
              return void 0;
            } else {
              allIterationTypes = ts3.append(allIterationTypes, iterationTypes_2);
            }
          }
          var iterationTypes = allIterationTypes ? combineIterationTypes(allIterationTypes) : noIterationTypes;
          setCachedIterationTypes(type2, cacheKey, iterationTypes);
          return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
        }
        function getAsyncFromSyncIterationTypes(iterationTypes, errorNode) {
          if (iterationTypes === noIterationTypes)
            return noIterationTypes;
          if (iterationTypes === anyIterationTypes)
            return anyIterationTypes;
          var yieldType = iterationTypes.yieldType, returnType = iterationTypes.returnType, nextType = iterationTypes.nextType;
          if (errorNode) {
            getGlobalAwaitedSymbol(true);
          }
          return createIterationTypes(getAwaitedType(yieldType, errorNode) || anyType, getAwaitedType(returnType, errorNode) || anyType, nextType);
        }
        function getIterationTypesOfIterableWorker(type2, use, errorNode) {
          if (isTypeAny(type2)) {
            return anyIterationTypes;
          }
          if (use & 2) {
            var iterationTypes = getIterationTypesOfIterableCached(type2, asyncIterationTypesResolver) || getIterationTypesOfIterableFast(type2, asyncIterationTypesResolver);
            if (iterationTypes) {
              return use & 8 ? getAsyncFromSyncIterationTypes(iterationTypes, errorNode) : iterationTypes;
            }
          }
          if (use & 1) {
            var iterationTypes = getIterationTypesOfIterableCached(type2, syncIterationTypesResolver) || getIterationTypesOfIterableFast(type2, syncIterationTypesResolver);
            if (iterationTypes) {
              if (use & 2) {
                if (iterationTypes !== noIterationTypes) {
                  return setCachedIterationTypes(type2, "iterationTypesOfAsyncIterable", getAsyncFromSyncIterationTypes(iterationTypes, errorNode));
                }
              } else {
                return iterationTypes;
              }
            }
          }
          if (use & 2) {
            var iterationTypes = getIterationTypesOfIterableSlow(type2, asyncIterationTypesResolver, errorNode);
            if (iterationTypes !== noIterationTypes) {
              return iterationTypes;
            }
          }
          if (use & 1) {
            var iterationTypes = getIterationTypesOfIterableSlow(type2, syncIterationTypesResolver, errorNode);
            if (iterationTypes !== noIterationTypes) {
              if (use & 2) {
                return setCachedIterationTypes(type2, "iterationTypesOfAsyncIterable", iterationTypes ? getAsyncFromSyncIterationTypes(iterationTypes, errorNode) : noIterationTypes);
              } else {
                return iterationTypes;
              }
            }
          }
          return noIterationTypes;
        }
        function getIterationTypesOfIterableCached(type2, resolver) {
          return getCachedIterationTypes(type2, resolver.iterableCacheKey);
        }
        function getIterationTypesOfGlobalIterableType(globalType, resolver) {
          var globalIterationTypes = getIterationTypesOfIterableCached(globalType, resolver) || getIterationTypesOfIterableSlow(globalType, resolver, void 0);
          return globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes;
        }
        function getIterationTypesOfIterableFast(type2, resolver) {
          var globalType;
          if (isReferenceToType(type2, globalType = resolver.getGlobalIterableType(false)) || isReferenceToType(type2, globalType = resolver.getGlobalIterableIteratorType(false))) {
            var yieldType = getTypeArguments(type2)[0];
            var _a = getIterationTypesOfGlobalIterableType(globalType, resolver), returnType = _a.returnType, nextType = _a.nextType;
            return setCachedIterationTypes(type2, resolver.iterableCacheKey, createIterationTypes(resolver.resolveIterationType(yieldType, void 0) || yieldType, resolver.resolveIterationType(returnType, void 0) || returnType, nextType));
          }
          if (isReferenceToType(type2, resolver.getGlobalGeneratorType(false))) {
            var _b = getTypeArguments(type2), yieldType = _b[0], returnType = _b[1], nextType = _b[2];
            return setCachedIterationTypes(type2, resolver.iterableCacheKey, createIterationTypes(resolver.resolveIterationType(yieldType, void 0) || yieldType, resolver.resolveIterationType(returnType, void 0) || returnType, nextType));
          }
        }
        function getPropertyNameForKnownSymbolName(symbolName) {
          var ctorType = getGlobalESSymbolConstructorSymbol(false);
          var uniqueType = ctorType && getTypeOfPropertyOfType(getTypeOfSymbol(ctorType), ts3.escapeLeadingUnderscores(symbolName));
          return uniqueType && isTypeUsableAsPropertyName(uniqueType) ? getPropertyNameFromType(uniqueType) : "__@".concat(symbolName);
        }
        function getIterationTypesOfIterableSlow(type2, resolver, errorNode) {
          var _a;
          var method = getPropertyOfType(type2, getPropertyNameForKnownSymbolName(resolver.iteratorSymbolName));
          var methodType = method && !(method.flags & 16777216) ? getTypeOfSymbol(method) : void 0;
          if (isTypeAny(methodType)) {
            return setCachedIterationTypes(type2, resolver.iterableCacheKey, anyIterationTypes);
          }
          var signatures = methodType ? getSignaturesOfType(methodType, 0) : void 0;
          if (!ts3.some(signatures)) {
            return setCachedIterationTypes(type2, resolver.iterableCacheKey, noIterationTypes);
          }
          var iteratorType = getIntersectionType(ts3.map(signatures, getReturnTypeOfSignature));
          var iterationTypes = (_a = getIterationTypesOfIterator(iteratorType, resolver, errorNode)) !== null && _a !== void 0 ? _a : noIterationTypes;
          return setCachedIterationTypes(type2, resolver.iterableCacheKey, iterationTypes);
        }
        function reportTypeNotIterableError(errorNode, type2, allowAsyncIterables) {
          var message = allowAsyncIterables ? ts3.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator : ts3.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator;
          errorAndMaybeSuggestAwait(errorNode, !!getAwaitedTypeOfPromise(type2), message, typeToString(type2));
        }
        function getIterationTypesOfIterator(type2, resolver, errorNode) {
          if (isTypeAny(type2)) {
            return anyIterationTypes;
          }
          var iterationTypes = getIterationTypesOfIteratorCached(type2, resolver) || getIterationTypesOfIteratorFast(type2, resolver) || getIterationTypesOfIteratorSlow(type2, resolver, errorNode);
          return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
        }
        function getIterationTypesOfIteratorCached(type2, resolver) {
          return getCachedIterationTypes(type2, resolver.iteratorCacheKey);
        }
        function getIterationTypesOfIteratorFast(type2, resolver) {
          var globalType = resolver.getGlobalIterableIteratorType(false);
          if (isReferenceToType(type2, globalType)) {
            var yieldType = getTypeArguments(type2)[0];
            var globalIterationTypes = getIterationTypesOfIteratorCached(globalType, resolver) || getIterationTypesOfIteratorSlow(globalType, resolver, void 0);
            var _a = globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes, returnType = _a.returnType, nextType = _a.nextType;
            return setCachedIterationTypes(type2, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType, nextType));
          }
          if (isReferenceToType(type2, resolver.getGlobalIteratorType(false)) || isReferenceToType(type2, resolver.getGlobalGeneratorType(false))) {
            var _b = getTypeArguments(type2), yieldType = _b[0], returnType = _b[1], nextType = _b[2];
            return setCachedIterationTypes(type2, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType, nextType));
          }
        }
        function isIteratorResult(type2, kind) {
          var doneType = getTypeOfPropertyOfType(type2, "done") || falseType;
          return isTypeAssignableTo(kind === 0 ? falseType : trueType, doneType);
        }
        function isYieldIteratorResult(type2) {
          return isIteratorResult(type2, 0);
        }
        function isReturnIteratorResult(type2) {
          return isIteratorResult(type2, 1);
        }
        function getIterationTypesOfIteratorResult(type2) {
          if (isTypeAny(type2)) {
            return anyIterationTypes;
          }
          var cachedTypes = getCachedIterationTypes(type2, "iterationTypesOfIteratorResult");
          if (cachedTypes) {
            return cachedTypes;
          }
          if (isReferenceToType(type2, getGlobalIteratorYieldResultType(false))) {
            var yieldType_1 = getTypeArguments(type2)[0];
            return setCachedIterationTypes(type2, "iterationTypesOfIteratorResult", createIterationTypes(yieldType_1, void 0, void 0));
          }
          if (isReferenceToType(type2, getGlobalIteratorReturnResultType(false))) {
            var returnType_1 = getTypeArguments(type2)[0];
            return setCachedIterationTypes(type2, "iterationTypesOfIteratorResult", createIterationTypes(void 0, returnType_1, void 0));
          }
          var yieldIteratorResult = filterType(type2, isYieldIteratorResult);
          var yieldType = yieldIteratorResult !== neverType ? getTypeOfPropertyOfType(yieldIteratorResult, "value") : void 0;
          var returnIteratorResult = filterType(type2, isReturnIteratorResult);
          var returnType = returnIteratorResult !== neverType ? getTypeOfPropertyOfType(returnIteratorResult, "value") : void 0;
          if (!yieldType && !returnType) {
            return setCachedIterationTypes(type2, "iterationTypesOfIteratorResult", noIterationTypes);
          }
          return setCachedIterationTypes(type2, "iterationTypesOfIteratorResult", createIterationTypes(yieldType, returnType || voidType, void 0));
        }
        function getIterationTypesOfMethod(type2, resolver, methodName, errorNode) {
          var _a, _b, _c, _d;
          var method = getPropertyOfType(type2, methodName);
          if (!method && methodName !== "next") {
            return void 0;
          }
          var methodType = method && !(methodName === "next" && method.flags & 16777216) ? methodName === "next" ? getTypeOfSymbol(method) : getTypeWithFacts(getTypeOfSymbol(method), 2097152) : void 0;
          if (isTypeAny(methodType)) {
            return methodName === "next" ? anyIterationTypes : anyIterationTypesExceptNext;
          }
          var methodSignatures = methodType ? getSignaturesOfType(methodType, 0) : ts3.emptyArray;
          if (methodSignatures.length === 0) {
            if (errorNode) {
              var diagnostic = methodName === "next" ? resolver.mustHaveANextMethodDiagnostic : resolver.mustBeAMethodDiagnostic;
              error(errorNode, diagnostic, methodName);
            }
            return methodName === "next" ? anyIterationTypes : void 0;
          }
          if ((methodType === null || methodType === void 0 ? void 0 : methodType.symbol) && methodSignatures.length === 1) {
            var globalGeneratorType = resolver.getGlobalGeneratorType(false);
            var globalIteratorType = resolver.getGlobalIteratorType(false);
            var isGeneratorMethod = ((_b = (_a = globalGeneratorType.symbol) === null || _a === void 0 ? void 0 : _a.members) === null || _b === void 0 ? void 0 : _b.get(methodName)) === methodType.symbol;
            var isIteratorMethod = !isGeneratorMethod && ((_d = (_c = globalIteratorType.symbol) === null || _c === void 0 ? void 0 : _c.members) === null || _d === void 0 ? void 0 : _d.get(methodName)) === methodType.symbol;
            if (isGeneratorMethod || isIteratorMethod) {
              var globalType = isGeneratorMethod ? globalGeneratorType : globalIteratorType;
              var mapper = methodType.mapper;
              return createIterationTypes(getMappedType(globalType.typeParameters[0], mapper), getMappedType(globalType.typeParameters[1], mapper), methodName === "next" ? getMappedType(globalType.typeParameters[2], mapper) : void 0);
            }
          }
          var methodParameterTypes;
          var methodReturnTypes;
          for (var _i = 0, methodSignatures_1 = methodSignatures; _i < methodSignatures_1.length; _i++) {
            var signature = methodSignatures_1[_i];
            if (methodName !== "throw" && ts3.some(signature.parameters)) {
              methodParameterTypes = ts3.append(methodParameterTypes, getTypeAtPosition(signature, 0));
            }
            methodReturnTypes = ts3.append(methodReturnTypes, getReturnTypeOfSignature(signature));
          }
          var returnTypes;
          var nextType;
          if (methodName !== "throw") {
            var methodParameterType = methodParameterTypes ? getUnionType(methodParameterTypes) : unknownType;
            if (methodName === "next") {
              nextType = methodParameterType;
            } else if (methodName === "return") {
              var resolvedMethodParameterType = resolver.resolveIterationType(methodParameterType, errorNode) || anyType;
              returnTypes = ts3.append(returnTypes, resolvedMethodParameterType);
            }
          }
          var yieldType;
          var methodReturnType = methodReturnTypes ? getIntersectionType(methodReturnTypes) : neverType;
          var resolvedMethodReturnType = resolver.resolveIterationType(methodReturnType, errorNode) || anyType;
          var iterationTypes = getIterationTypesOfIteratorResult(resolvedMethodReturnType);
          if (iterationTypes === noIterationTypes) {
            if (errorNode) {
              error(errorNode, resolver.mustHaveAValueDiagnostic, methodName);
            }
            yieldType = anyType;
            returnTypes = ts3.append(returnTypes, anyType);
          } else {
            yieldType = iterationTypes.yieldType;
            returnTypes = ts3.append(returnTypes, iterationTypes.returnType);
          }
          return createIterationTypes(yieldType, getUnionType(returnTypes), nextType);
        }
        function getIterationTypesOfIteratorSlow(type2, resolver, errorNode) {
          var iterationTypes = combineIterationTypes([
            getIterationTypesOfMethod(type2, resolver, "next", errorNode),
            getIterationTypesOfMethod(type2, resolver, "return", errorNode),
            getIterationTypesOfMethod(type2, resolver, "throw", errorNode)
          ]);
          return setCachedIterationTypes(type2, resolver.iteratorCacheKey, iterationTypes);
        }
        function getIterationTypeOfGeneratorFunctionReturnType(kind, returnType, isAsyncGenerator) {
          if (isTypeAny(returnType)) {
            return void 0;
          }
          var iterationTypes = getIterationTypesOfGeneratorFunctionReturnType(returnType, isAsyncGenerator);
          return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(kind)];
        }
        function getIterationTypesOfGeneratorFunctionReturnType(type2, isAsyncGenerator) {
          if (isTypeAny(type2)) {
            return anyIterationTypes;
          }
          var use = isAsyncGenerator ? 2 : 1;
          var resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
          return getIterationTypesOfIterable(type2, use, void 0) || getIterationTypesOfIterator(type2, resolver, void 0);
        }
        function checkBreakOrContinueStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node))
            checkGrammarBreakOrContinueStatement(node);
        }
        function unwrapReturnType(returnType, functionFlags) {
          var isGenerator = !!(functionFlags & 1);
          var isAsync = !!(functionFlags & 2);
          return isGenerator ? getIterationTypeOfGeneratorFunctionReturnType(1, returnType, isAsync) || errorType : isAsync ? getAwaitedTypeNoAlias(returnType) || errorType : returnType;
        }
        function isUnwrappedReturnTypeVoidOrAny(func, returnType) {
          var unwrappedReturnType = unwrapReturnType(returnType, ts3.getFunctionFlags(func));
          return !!unwrappedReturnType && maybeTypeOfKind(unwrappedReturnType, 16384 | 3);
        }
        function checkReturnStatement(node) {
          var _a;
          if (checkGrammarStatementInAmbientContext(node)) {
            return;
          }
          var container = ts3.getContainingFunctionOrClassStaticBlock(node);
          if (container && ts3.isClassStaticBlockDeclaration(container)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block);
            return;
          }
          if (!container) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);
            return;
          }
          var signature = getSignatureFromDeclaration(container);
          var returnType = getReturnTypeOfSignature(signature);
          var functionFlags = ts3.getFunctionFlags(container);
          if (strictNullChecks || node.expression || returnType.flags & 131072) {
            var exprType = node.expression ? checkExpressionCached(node.expression) : undefinedType;
            if (container.kind === 173) {
              if (node.expression) {
                error(node, ts3.Diagnostics.Setters_cannot_return_a_value);
              }
            } else if (container.kind === 171) {
              if (node.expression && !checkTypeAssignableToAndOptionallyElaborate(exprType, returnType, node, node.expression)) {
                error(node, ts3.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);
              }
            } else if (getReturnTypeFromAnnotation(container)) {
              var unwrappedReturnType = (_a = unwrapReturnType(returnType, functionFlags)) !== null && _a !== void 0 ? _a : returnType;
              var unwrappedExprType = functionFlags & 2 ? checkAwaitedType(exprType, false, node, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : exprType;
              if (unwrappedReturnType) {
                checkTypeAssignableToAndOptionallyElaborate(unwrappedExprType, unwrappedReturnType, node, node.expression);
              }
            }
          } else if (container.kind !== 171 && compilerOptions.noImplicitReturns && !isUnwrappedReturnTypeVoidOrAny(container, returnType)) {
            error(node, ts3.Diagnostics.Not_all_code_paths_return_a_value);
          }
        }
        function checkWithStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.flags & 32768) {
              grammarErrorOnFirstToken(node, ts3.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block);
            }
          }
          checkExpression(node.expression);
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var start = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos).start;
            var end = node.statement.pos;
            grammarErrorAtPos(sourceFile, start, end - start, ts3.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any);
          }
        }
        function checkSwitchStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          var firstDefaultClause;
          var hasDuplicateDefaultClause = false;
          var expressionType = checkExpression(node.expression);
          var expressionIsLiteral = isLiteralType(expressionType);
          ts3.forEach(node.caseBlock.clauses, function(clause) {
            if (clause.kind === 290 && !hasDuplicateDefaultClause) {
              if (firstDefaultClause === void 0) {
                firstDefaultClause = clause;
              } else {
                grammarErrorOnNode(clause, ts3.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement);
                hasDuplicateDefaultClause = true;
              }
            }
            if (clause.kind === 289) {
              addLazyDiagnostic(createLazyCaseClauseDiagnostics(clause));
            }
            ts3.forEach(clause.statements, checkSourceElement);
            if (compilerOptions.noFallthroughCasesInSwitch && clause.fallthroughFlowNode && isReachableFlowNode(clause.fallthroughFlowNode)) {
              error(clause, ts3.Diagnostics.Fallthrough_case_in_switch);
            }
            function createLazyCaseClauseDiagnostics(clause2) {
              return function() {
                var caseType = checkExpression(clause2.expression);
                var caseIsLiteral = isLiteralType(caseType);
                var comparedExpressionType = expressionType;
                if (!caseIsLiteral || !expressionIsLiteral) {
                  caseType = caseIsLiteral ? getBaseTypeOfLiteralType(caseType) : caseType;
                  comparedExpressionType = getBaseTypeOfLiteralType(expressionType);
                }
                if (!isTypeEqualityComparableTo(comparedExpressionType, caseType)) {
                  checkTypeComparableTo(caseType, comparedExpressionType, clause2.expression, void 0);
                }
              };
            }
          });
          if (node.caseBlock.locals) {
            registerForUnusedIdentifiersCheck(node.caseBlock);
          }
        }
        function checkLabeledStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            ts3.findAncestor(node.parent, function(current) {
              if (ts3.isFunctionLike(current)) {
                return "quit";
              }
              if (current.kind === 250 && current.label.escapedText === node.label.escapedText) {
                grammarErrorOnNode(node.label, ts3.Diagnostics.Duplicate_label_0, ts3.getTextOfNode(node.label));
                return true;
              }
              return false;
            });
          }
          checkSourceElement(node.statement);
        }
        function checkThrowStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (ts3.isIdentifier(node.expression) && !node.expression.escapedText) {
              grammarErrorAfterFirstToken(node, ts3.Diagnostics.Line_break_not_permitted_here);
            }
          }
          if (node.expression) {
            checkExpression(node.expression);
          }
        }
        function checkTryStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkBlock(node.tryBlock);
          var catchClause = node.catchClause;
          if (catchClause) {
            if (catchClause.variableDeclaration) {
              var declaration = catchClause.variableDeclaration;
              var typeNode = ts3.getEffectiveTypeAnnotationNode(ts3.getRootDeclaration(declaration));
              if (typeNode) {
                var type2 = getTypeForVariableLikeDeclaration(declaration, false, 0);
                if (type2 && !(type2.flags & 3)) {
                  grammarErrorOnFirstToken(typeNode, ts3.Diagnostics.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified);
                }
              } else if (declaration.initializer) {
                grammarErrorOnFirstToken(declaration.initializer, ts3.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);
              } else {
                var blockLocals_1 = catchClause.block.locals;
                if (blockLocals_1) {
                  ts3.forEachKey(catchClause.locals, function(caughtName) {
                    var blockLocal = blockLocals_1.get(caughtName);
                    if ((blockLocal === null || blockLocal === void 0 ? void 0 : blockLocal.valueDeclaration) && (blockLocal.flags & 2) !== 0) {
                      grammarErrorOnNode(blockLocal.valueDeclaration, ts3.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause, caughtName);
                    }
                  });
                }
              }
            }
            checkBlock(catchClause.block);
          }
          if (node.finallyBlock) {
            checkBlock(node.finallyBlock);
          }
        }
        function checkIndexConstraints(type2, symbol, isStaticIndex) {
          var indexInfos = getIndexInfosOfType(type2);
          if (indexInfos.length === 0) {
            return;
          }
          for (var _i = 0, _a = getPropertiesOfObjectType(type2); _i < _a.length; _i++) {
            var prop = _a[_i];
            if (!(isStaticIndex && prop.flags & 4194304)) {
              checkIndexConstraintForProperty(type2, prop, getLiteralTypeFromProperty(prop, 8576, true), getNonMissingTypeOfSymbol(prop));
            }
          }
          var typeDeclaration = symbol.valueDeclaration;
          if (typeDeclaration && ts3.isClassLike(typeDeclaration)) {
            for (var _b = 0, _c = typeDeclaration.members; _b < _c.length; _b++) {
              var member = _c[_b];
              if (!ts3.isStatic(member) && !hasBindableName(member)) {
                var symbol_3 = getSymbolOfNode(member);
                checkIndexConstraintForProperty(type2, symbol_3, getTypeOfExpression(member.name.expression), getNonMissingTypeOfSymbol(symbol_3));
              }
            }
          }
          if (indexInfos.length > 1) {
            for (var _d = 0, indexInfos_8 = indexInfos; _d < indexInfos_8.length; _d++) {
              var info = indexInfos_8[_d];
              checkIndexConstraintForIndexSignature(type2, info);
            }
          }
        }
        function checkIndexConstraintForProperty(type2, prop, propNameType, propType) {
          var declaration = prop.valueDeclaration;
          var name = ts3.getNameOfDeclaration(declaration);
          if (name && ts3.isPrivateIdentifier(name)) {
            return;
          }
          var indexInfos = getApplicableIndexInfos(type2, propNameType);
          var interfaceDeclaration = ts3.getObjectFlags(type2) & 2 ? ts3.getDeclarationOfKind(type2.symbol, 258) : void 0;
          var localPropDeclaration = declaration && declaration.kind === 221 || name && name.kind === 162 || getParentOfSymbol(prop) === type2.symbol ? declaration : void 0;
          var _loop_28 = function(info2) {
            var localIndexDeclaration = info2.declaration && getParentOfSymbol(getSymbolOfNode(info2.declaration)) === type2.symbol ? info2.declaration : void 0;
            var errorNode = localPropDeclaration || localIndexDeclaration || (interfaceDeclaration && !ts3.some(getBaseTypes(type2), function(base) {
              return !!getPropertyOfObjectType(base, prop.escapedName) && !!getIndexTypeOfType(base, info2.keyType);
            }) ? interfaceDeclaration : void 0);
            if (errorNode && !isTypeAssignableTo(propType, info2.type)) {
              error(errorNode, ts3.Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3, symbolToString(prop), typeToString(propType), typeToString(info2.keyType), typeToString(info2.type));
            }
          };
          for (var _i = 0, indexInfos_9 = indexInfos; _i < indexInfos_9.length; _i++) {
            var info = indexInfos_9[_i];
            _loop_28(info);
          }
        }
        function checkIndexConstraintForIndexSignature(type2, checkInfo) {
          var declaration = checkInfo.declaration;
          var indexInfos = getApplicableIndexInfos(type2, checkInfo.keyType);
          var interfaceDeclaration = ts3.getObjectFlags(type2) & 2 ? ts3.getDeclarationOfKind(type2.symbol, 258) : void 0;
          var localCheckDeclaration = declaration && getParentOfSymbol(getSymbolOfNode(declaration)) === type2.symbol ? declaration : void 0;
          var _loop_29 = function(info2) {
            if (info2 === checkInfo)
              return "continue";
            var localIndexDeclaration = info2.declaration && getParentOfSymbol(getSymbolOfNode(info2.declaration)) === type2.symbol ? info2.declaration : void 0;
            var errorNode = localCheckDeclaration || localIndexDeclaration || (interfaceDeclaration && !ts3.some(getBaseTypes(type2), function(base) {
              return !!getIndexInfoOfType(base, checkInfo.keyType) && !!getIndexTypeOfType(base, info2.keyType);
            }) ? interfaceDeclaration : void 0);
            if (errorNode && !isTypeAssignableTo(checkInfo.type, info2.type)) {
              error(errorNode, ts3.Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3, typeToString(checkInfo.keyType), typeToString(checkInfo.type), typeToString(info2.keyType), typeToString(info2.type));
            }
          };
          for (var _i = 0, indexInfos_10 = indexInfos; _i < indexInfos_10.length; _i++) {
            var info = indexInfos_10[_i];
            _loop_29(info);
          }
        }
        function checkTypeNameIsReserved(name, message) {
          switch (name.escapedText) {
            case "any":
            case "unknown":
            case "never":
            case "number":
            case "bigint":
            case "boolean":
            case "string":
            case "symbol":
            case "void":
            case "object":
              error(name, message, name.escapedText);
          }
        }
        function checkClassNameCollisionWithObject(name) {
          if (languageVersion >= 1 && name.escapedText === "Object" && (moduleKind < ts3.ModuleKind.ES2015 || ts3.getSourceFileOfNode(name).impliedNodeFormat === ts3.ModuleKind.CommonJS)) {
            error(name, ts3.Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0, ts3.ModuleKind[moduleKind]);
          }
        }
        function checkUnmatchedJSDocParameters(node) {
          var jsdocParameters = ts3.filter(ts3.getJSDocTags(node), ts3.isJSDocParameterTag);
          if (!ts3.length(jsdocParameters))
            return;
          var isJs = ts3.isInJSFile(node);
          var parameters = new ts3.Set();
          var excludedParameters = new ts3.Set();
          ts3.forEach(node.parameters, function(_a, index) {
            var name = _a.name;
            if (ts3.isIdentifier(name)) {
              parameters.add(name.escapedText);
            }
            if (ts3.isBindingPattern(name)) {
              excludedParameters.add(index);
            }
          });
          var containsArguments = containsArgumentsReference(node);
          if (containsArguments) {
            var lastJSDocParam = ts3.lastOrUndefined(jsdocParameters);
            if (isJs && lastJSDocParam && ts3.isIdentifier(lastJSDocParam.name) && lastJSDocParam.typeExpression && lastJSDocParam.typeExpression.type && !parameters.has(lastJSDocParam.name.escapedText) && !isArrayType(getTypeFromTypeNode(lastJSDocParam.typeExpression.type))) {
              error(lastJSDocParam.name, ts3.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type, ts3.idText(lastJSDocParam.name));
            }
          } else {
            ts3.forEach(jsdocParameters, function(_a, index) {
              var name = _a.name;
              if (excludedParameters.has(index) || ts3.isIdentifier(name) && parameters.has(name.escapedText)) {
                return;
              }
              if (ts3.isQualifiedName(name)) {
                if (isJs) {
                  error(name, ts3.Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1, ts3.entityNameToString(name), ts3.entityNameToString(name.left));
                }
              } else {
                errorOrSuggestion(isJs, name, ts3.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name, ts3.idText(name));
              }
            });
          }
        }
        function checkTypeParameters(typeParameterDeclarations) {
          var seenDefault = false;
          if (typeParameterDeclarations) {
            for (var i = 0; i < typeParameterDeclarations.length; i++) {
              var node = typeParameterDeclarations[i];
              checkTypeParameter(node);
              addLazyDiagnostic(createCheckTypeParameterDiagnostic(node, i));
            }
          }
          function createCheckTypeParameterDiagnostic(node2, i2) {
            return function() {
              if (node2.default) {
                seenDefault = true;
                checkTypeParametersNotReferenced(node2.default, typeParameterDeclarations, i2);
              } else if (seenDefault) {
                error(node2, ts3.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);
              }
              for (var j = 0; j < i2; j++) {
                if (typeParameterDeclarations[j].symbol === node2.symbol) {
                  error(node2.name, ts3.Diagnostics.Duplicate_identifier_0, ts3.declarationNameToString(node2.name));
                }
              }
            };
          }
        }
        function checkTypeParametersNotReferenced(root, typeParameters, index) {
          visit(root);
          function visit(node) {
            if (node.kind === 178) {
              var type2 = getTypeFromTypeReference(node);
              if (type2.flags & 262144) {
                for (var i = index; i < typeParameters.length; i++) {
                  if (type2.symbol === getSymbolOfNode(typeParameters[i])) {
                    error(node, ts3.Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters);
                  }
                }
              }
            }
            ts3.forEachChild(node, visit);
          }
        }
        function checkTypeParameterListsIdentical(symbol) {
          if (symbol.declarations && symbol.declarations.length === 1) {
            return;
          }
          var links = getSymbolLinks(symbol);
          if (!links.typeParametersChecked) {
            links.typeParametersChecked = true;
            var declarations = getClassOrInterfaceDeclarationsOfSymbol(symbol);
            if (!declarations || declarations.length <= 1) {
              return;
            }
            var type2 = getDeclaredTypeOfSymbol(symbol);
            if (!areTypeParametersIdentical(declarations, type2.localTypeParameters, ts3.getEffectiveTypeParameterDeclarations)) {
              var name = symbolToString(symbol);
              for (var _i = 0, declarations_7 = declarations; _i < declarations_7.length; _i++) {
                var declaration = declarations_7[_i];
                error(declaration.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters, name);
              }
            }
          }
        }
        function areTypeParametersIdentical(declarations, targetParameters, getTypeParameterDeclarations) {
          var maxTypeArgumentCount = ts3.length(targetParameters);
          var minTypeArgumentCount = getMinTypeArgumentCount(targetParameters);
          for (var _i = 0, declarations_8 = declarations; _i < declarations_8.length; _i++) {
            var declaration = declarations_8[_i];
            var sourceParameters = getTypeParameterDeclarations(declaration);
            var numTypeParameters = sourceParameters.length;
            if (numTypeParameters < minTypeArgumentCount || numTypeParameters > maxTypeArgumentCount) {
              return false;
            }
            for (var i = 0; i < numTypeParameters; i++) {
              var source = sourceParameters[i];
              var target = targetParameters[i];
              if (source.name.escapedText !== target.symbol.escapedName) {
                return false;
              }
              var constraint = ts3.getEffectiveConstraintOfTypeParameter(source);
              var sourceConstraint = constraint && getTypeFromTypeNode(constraint);
              var targetConstraint = getConstraintOfTypeParameter(target);
              if (sourceConstraint && targetConstraint && !isTypeIdenticalTo(sourceConstraint, targetConstraint)) {
                return false;
              }
              var sourceDefault = source.default && getTypeFromTypeNode(source.default);
              var targetDefault = getDefaultFromTypeParameter(target);
              if (sourceDefault && targetDefault && !isTypeIdenticalTo(sourceDefault, targetDefault)) {
                return false;
              }
            }
          }
          return true;
        }
        function checkClassExpression(node) {
          checkClassLikeDeclaration(node);
          checkNodeDeferred(node);
          return getTypeOfSymbol(getSymbolOfNode(node));
        }
        function checkClassExpressionDeferred(node) {
          ts3.forEach(node.members, checkSourceElement);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkClassDeclaration(node) {
          if (ts3.some(node.decorators) && ts3.some(node.members, function(p) {
            return ts3.hasStaticModifier(p) && ts3.isPrivateIdentifierClassElementDeclaration(p);
          })) {
            grammarErrorOnNode(node.decorators[0], ts3.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator);
          }
          if (!node.name && !ts3.hasSyntacticModifier(node, 512)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name);
          }
          checkClassLikeDeclaration(node);
          ts3.forEach(node.members, checkSourceElement);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkClassLikeDeclaration(node) {
          checkGrammarClassLikeDeclaration(node);
          checkDecorators(node);
          checkCollisionsForDeclarationName(node, node.name);
          checkTypeParameters(ts3.getEffectiveTypeParameterDeclarations(node));
          checkExportsOnMergedDeclarations(node);
          var symbol = getSymbolOfNode(node);
          var type2 = getDeclaredTypeOfSymbol(symbol);
          var typeWithThis = getTypeWithThisArgument(type2);
          var staticType = getTypeOfSymbol(symbol);
          checkTypeParameterListsIdentical(symbol);
          checkFunctionOrConstructorSymbol(symbol);
          checkClassForDuplicateDeclarations(node);
          var nodeInAmbientContext = !!(node.flags & 16777216);
          if (!nodeInAmbientContext) {
            checkClassForStaticPropertyNameConflicts(node);
          }
          var baseTypeNode = ts3.getEffectiveBaseTypeNode(node);
          if (baseTypeNode) {
            ts3.forEach(baseTypeNode.typeArguments, checkSourceElement);
            if (languageVersion < 2) {
              checkExternalEmitHelpers(baseTypeNode.parent, 1);
            }
            var extendsNode = ts3.getClassExtendsHeritageElement(node);
            if (extendsNode && extendsNode !== baseTypeNode) {
              checkExpression(extendsNode.expression);
            }
            var baseTypes_2 = getBaseTypes(type2);
            if (baseTypes_2.length) {
              addLazyDiagnostic(function() {
                var baseType = baseTypes_2[0];
                var baseConstructorType = getBaseConstructorTypeOfClass(type2);
                var staticBaseType = getApparentType(baseConstructorType);
                checkBaseTypeAccessibility(staticBaseType, baseTypeNode);
                checkSourceElement(baseTypeNode.expression);
                if (ts3.some(baseTypeNode.typeArguments)) {
                  ts3.forEach(baseTypeNode.typeArguments, checkSourceElement);
                  for (var _i2 = 0, _a = getConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode); _i2 < _a.length; _i2++) {
                    var constructor = _a[_i2];
                    if (!checkTypeArgumentConstraints(baseTypeNode, constructor.typeParameters)) {
                      break;
                    }
                  }
                }
                var baseWithThis = getTypeWithThisArgument(baseType, type2.thisType);
                if (!checkTypeAssignableTo(typeWithThis, baseWithThis, void 0)) {
                  issueMemberSpecificError(node, typeWithThis, baseWithThis, ts3.Diagnostics.Class_0_incorrectly_extends_base_class_1);
                } else {
                  checkTypeAssignableTo(staticType, getTypeWithoutSignatures(staticBaseType), node.name || node, ts3.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1);
                }
                if (baseConstructorType.flags & 8650752) {
                  if (!isMixinConstructorType(staticType)) {
                    error(node.name || node, ts3.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any);
                  } else {
                    var constructSignatures = getSignaturesOfType(baseConstructorType, 1);
                    if (constructSignatures.some(function(signature) {
                      return signature.flags & 4;
                    }) && !ts3.hasSyntacticModifier(node, 128)) {
                      error(node.name || node, ts3.Diagnostics.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract);
                    }
                  }
                }
                if (!(staticBaseType.symbol && staticBaseType.symbol.flags & 32) && !(baseConstructorType.flags & 8650752)) {
                  var constructors = getInstantiatedConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode);
                  if (ts3.forEach(constructors, function(sig) {
                    return !isJSConstructor(sig.declaration) && !isTypeIdenticalTo(getReturnTypeOfSignature(sig), baseType);
                  })) {
                    error(baseTypeNode.expression, ts3.Diagnostics.Base_constructors_must_all_have_the_same_return_type);
                  }
                }
                checkKindsOfPropertyMemberOverrides(type2, baseType);
              });
            }
          }
          checkMembersForOverrideModifier(node, type2, typeWithThis, staticType);
          var implementedTypeNodes = ts3.getEffectiveImplementsTypeNodes(node);
          if (implementedTypeNodes) {
            for (var _i = 0, implementedTypeNodes_1 = implementedTypeNodes; _i < implementedTypeNodes_1.length; _i++) {
              var typeRefNode = implementedTypeNodes_1[_i];
              if (!ts3.isEntityNameExpression(typeRefNode.expression) || ts3.isOptionalChain(typeRefNode.expression)) {
                error(typeRefNode.expression, ts3.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments);
              }
              checkTypeReferenceNode(typeRefNode);
              addLazyDiagnostic(createImplementsDiagnostics(typeRefNode));
            }
          }
          addLazyDiagnostic(function() {
            checkIndexConstraints(type2, symbol);
            checkIndexConstraints(staticType, symbol, true);
            checkTypeForDuplicateIndexSignatures(node);
            checkPropertyInitialization(node);
          });
          function createImplementsDiagnostics(typeRefNode2) {
            return function() {
              var t = getReducedType(getTypeFromTypeNode(typeRefNode2));
              if (!isErrorType(t)) {
                if (isValidBaseType(t)) {
                  var genericDiag = t.symbol && t.symbol.flags & 32 ? ts3.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass : ts3.Diagnostics.Class_0_incorrectly_implements_interface_1;
                  var baseWithThis = getTypeWithThisArgument(t, type2.thisType);
                  if (!checkTypeAssignableTo(typeWithThis, baseWithThis, void 0)) {
                    issueMemberSpecificError(node, typeWithThis, baseWithThis, genericDiag);
                  }
                } else {
                  error(typeRefNode2, ts3.Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                }
              }
            };
          }
        }
        function checkMembersForOverrideModifier(node, type2, typeWithThis, staticType) {
          var baseTypeNode = ts3.getEffectiveBaseTypeNode(node);
          var baseTypes = baseTypeNode && getBaseTypes(type2);
          var baseWithThis = (baseTypes === null || baseTypes === void 0 ? void 0 : baseTypes.length) ? getTypeWithThisArgument(ts3.first(baseTypes), type2.thisType) : void 0;
          var baseStaticType = getBaseConstructorTypeOfClass(type2);
          var _loop_30 = function(member2) {
            if (ts3.hasAmbientModifier(member2)) {
              return "continue";
            }
            if (ts3.isConstructorDeclaration(member2)) {
              ts3.forEach(member2.parameters, function(param) {
                if (ts3.isParameterPropertyDeclaration(param, member2)) {
                  checkExistingMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type2, typeWithThis, param, true);
                }
              });
            }
            checkExistingMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type2, typeWithThis, member2, false);
          };
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            _loop_30(member);
          }
        }
        function checkExistingMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type2, typeWithThis, member, memberIsParameterProperty, reportErrors) {
          if (reportErrors === void 0) {
            reportErrors = true;
          }
          var declaredProp = member.name && getSymbolAtLocation(member.name) || getSymbolAtLocation(member);
          if (!declaredProp) {
            return 0;
          }
          return checkMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type2, typeWithThis, ts3.hasOverrideModifier(member), ts3.hasAbstractModifier(member), ts3.isStatic(member), memberIsParameterProperty, ts3.symbolName(declaredProp), reportErrors ? member : void 0);
        }
        function checkMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type2, typeWithThis, memberHasOverrideModifier, memberHasAbstractModifier, memberIsStatic, memberIsParameterProperty, memberName, errorNode) {
          var isJs = ts3.isInJSFile(node);
          var nodeInAmbientContext = !!(node.flags & 16777216);
          if (baseWithThis && (memberHasOverrideModifier || compilerOptions.noImplicitOverride)) {
            var memberEscapedName = ts3.escapeLeadingUnderscores(memberName);
            var thisType = memberIsStatic ? staticType : typeWithThis;
            var baseType = memberIsStatic ? baseStaticType : baseWithThis;
            var prop = getPropertyOfType(thisType, memberEscapedName);
            var baseProp = getPropertyOfType(baseType, memberEscapedName);
            var baseClassName = typeToString(baseWithThis);
            if (prop && !baseProp && memberHasOverrideModifier) {
              if (errorNode) {
                var suggestion = getSuggestedSymbolForNonexistentClassMember(memberName, baseType);
                suggestion ? error(errorNode, isJs ? ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1 : ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1, baseClassName, symbolToString(suggestion)) : error(errorNode, isJs ? ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0 : ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0, baseClassName);
              }
              return 2;
            } else if (prop && (baseProp === null || baseProp === void 0 ? void 0 : baseProp.declarations) && compilerOptions.noImplicitOverride && !nodeInAmbientContext) {
              var baseHasAbstract = ts3.some(baseProp.declarations, ts3.hasAbstractModifier);
              if (memberHasOverrideModifier) {
                return 0;
              }
              if (!baseHasAbstract) {
                if (errorNode) {
                  var diag = memberIsParameterProperty ? isJs ? ts3.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0 : isJs ? ts3.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;
                  error(errorNode, diag, baseClassName);
                }
                return 1;
              } else if (memberHasAbstractModifier && baseHasAbstract) {
                if (errorNode) {
                  error(errorNode, ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0, baseClassName);
                }
                return 1;
              }
            }
          } else if (memberHasOverrideModifier) {
            if (errorNode) {
              var className = typeToString(type2);
              error(errorNode, isJs ? ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class : ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class, className);
            }
            return 2;
          }
          return 0;
        }
        function issueMemberSpecificError(node, typeWithThis, baseWithThis, broadDiag) {
          var issuedMemberError = false;
          var _loop_31 = function(member2) {
            if (ts3.isStatic(member2)) {
              return "continue";
            }
            var declaredProp = member2.name && getSymbolAtLocation(member2.name) || getSymbolAtLocation(member2);
            if (declaredProp) {
              var prop = getPropertyOfType(typeWithThis, declaredProp.escapedName);
              var baseProp = getPropertyOfType(baseWithThis, declaredProp.escapedName);
              if (prop && baseProp) {
                var rootChain = function() {
                  return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2, symbolToString(declaredProp), typeToString(typeWithThis), typeToString(baseWithThis));
                };
                if (!checkTypeAssignableTo(getTypeOfSymbol(prop), getTypeOfSymbol(baseProp), member2.name || member2, void 0, rootChain)) {
                  issuedMemberError = true;
                }
              }
            }
          };
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            _loop_31(member);
          }
          if (!issuedMemberError) {
            checkTypeAssignableTo(typeWithThis, baseWithThis, node.name || node, broadDiag);
          }
        }
        function checkBaseTypeAccessibility(type2, node) {
          var signatures = getSignaturesOfType(type2, 1);
          if (signatures.length) {
            var declaration = signatures[0].declaration;
            if (declaration && ts3.hasEffectiveModifier(declaration, 8)) {
              var typeClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(type2.symbol);
              if (!isNodeWithinClass(node, typeClassDeclaration)) {
                error(node, ts3.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private, getFullyQualifiedName(type2.symbol));
              }
            }
          }
        }
        function getMemberOverrideModifierStatus(node, member) {
          if (!member.name) {
            return 0;
          }
          var symbol = getSymbolOfNode(node);
          var type2 = getDeclaredTypeOfSymbol(symbol);
          var typeWithThis = getTypeWithThisArgument(type2);
          var staticType = getTypeOfSymbol(symbol);
          var baseTypeNode = ts3.getEffectiveBaseTypeNode(node);
          var baseTypes = baseTypeNode && getBaseTypes(type2);
          var baseWithThis = (baseTypes === null || baseTypes === void 0 ? void 0 : baseTypes.length) ? getTypeWithThisArgument(ts3.first(baseTypes), type2.thisType) : void 0;
          var baseStaticType = getBaseConstructorTypeOfClass(type2);
          var memberHasOverrideModifier = member.parent ? ts3.hasOverrideModifier(member) : ts3.hasSyntacticModifier(member, 16384);
          var memberName = ts3.unescapeLeadingUnderscores(ts3.getTextOfPropertyName(member.name));
          return checkMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type2, typeWithThis, memberHasOverrideModifier, ts3.hasAbstractModifier(member), ts3.isStatic(member), false, memberName);
        }
        function getTargetSymbol(s) {
          return ts3.getCheckFlags(s) & 1 ? s.target : s;
        }
        function getClassOrInterfaceDeclarationsOfSymbol(symbol) {
          return ts3.filter(symbol.declarations, function(d) {
            return d.kind === 257 || d.kind === 258;
          });
        }
        function checkKindsOfPropertyMemberOverrides(type2, baseType) {
          var _a, _b;
          var baseProperties = getPropertiesOfType(baseType);
          basePropertyCheck:
            for (var _i = 0, baseProperties_1 = baseProperties; _i < baseProperties_1.length; _i++) {
              var baseProperty = baseProperties_1[_i];
              var base = getTargetSymbol(baseProperty);
              if (base.flags & 4194304) {
                continue;
              }
              var baseSymbol = getPropertyOfObjectType(type2, base.escapedName);
              if (!baseSymbol) {
                continue;
              }
              var derived = getTargetSymbol(baseSymbol);
              var baseDeclarationFlags = ts3.getDeclarationModifierFlagsFromSymbol(base);
              ts3.Debug.assert(!!derived, "derived should point to something, even if it is the base class' declaration.");
              if (derived === base) {
                var derivedClassDecl = ts3.getClassLikeDeclarationOfSymbol(type2.symbol);
                if (baseDeclarationFlags & 128 && (!derivedClassDecl || !ts3.hasSyntacticModifier(derivedClassDecl, 128))) {
                  for (var _c = 0, _d = getBaseTypes(type2); _c < _d.length; _c++) {
                    var otherBaseType = _d[_c];
                    if (otherBaseType === baseType)
                      continue;
                    var baseSymbol_1 = getPropertyOfObjectType(otherBaseType, base.escapedName);
                    var derivedElsewhere = baseSymbol_1 && getTargetSymbol(baseSymbol_1);
                    if (derivedElsewhere && derivedElsewhere !== base) {
                      continue basePropertyCheck;
                    }
                  }
                  if (derivedClassDecl.kind === 226) {
                    error(derivedClassDecl, ts3.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1, symbolToString(baseProperty), typeToString(baseType));
                  } else {
                    error(derivedClassDecl, ts3.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2, typeToString(type2), symbolToString(baseProperty), typeToString(baseType));
                  }
                }
              } else {
                var derivedDeclarationFlags = ts3.getDeclarationModifierFlagsFromSymbol(derived);
                if (baseDeclarationFlags & 8 || derivedDeclarationFlags & 8) {
                  continue;
                }
                var errorMessage = void 0;
                var basePropertyFlags = base.flags & 98308;
                var derivedPropertyFlags = derived.flags & 98308;
                if (basePropertyFlags && derivedPropertyFlags) {
                  if (baseDeclarationFlags & 128 && !(base.valueDeclaration && ts3.isPropertyDeclaration(base.valueDeclaration) && base.valueDeclaration.initializer) || base.valueDeclaration && base.valueDeclaration.parent.kind === 258 || derived.valueDeclaration && ts3.isBinaryExpression(derived.valueDeclaration)) {
                    continue;
                  }
                  var overriddenInstanceProperty = basePropertyFlags !== 4 && derivedPropertyFlags === 4;
                  var overriddenInstanceAccessor = basePropertyFlags === 4 && derivedPropertyFlags !== 4;
                  if (overriddenInstanceProperty || overriddenInstanceAccessor) {
                    var errorMessage_1 = overriddenInstanceProperty ? ts3.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property : ts3.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;
                    error(ts3.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage_1, symbolToString(base), typeToString(baseType), typeToString(type2));
                  } else if (useDefineForClassFields) {
                    var uninitialized = (_a = derived.declarations) === null || _a === void 0 ? void 0 : _a.find(function(d) {
                      return d.kind === 167 && !d.initializer;
                    });
                    if (uninitialized && !(derived.flags & 33554432) && !(baseDeclarationFlags & 128) && !(derivedDeclarationFlags & 128) && !((_b = derived.declarations) === null || _b === void 0 ? void 0 : _b.some(function(d) {
                      return !!(d.flags & 16777216);
                    }))) {
                      var constructor = findConstructorDeclaration(ts3.getClassLikeDeclarationOfSymbol(type2.symbol));
                      var propName = uninitialized.name;
                      if (uninitialized.exclamationToken || !constructor || !ts3.isIdentifier(propName) || !strictNullChecks || !isPropertyInitializedInConstructor(propName, type2, constructor)) {
                        var errorMessage_2 = ts3.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;
                        error(ts3.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage_2, symbolToString(base), typeToString(baseType));
                      }
                    }
                  }
                  continue;
                } else if (isPrototypeProperty(base)) {
                  if (isPrototypeProperty(derived) || derived.flags & 4) {
                    continue;
                  } else {
                    ts3.Debug.assert(!!(derived.flags & 98304));
                    errorMessage = ts3.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor;
                  }
                } else if (base.flags & 98304) {
                  errorMessage = ts3.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function;
                } else {
                  errorMessage = ts3.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;
                }
                error(ts3.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage, typeToString(baseType), symbolToString(base), typeToString(type2));
              }
            }
        }
        function getNonInterhitedProperties(type2, baseTypes, properties) {
          if (!ts3.length(baseTypes)) {
            return properties;
          }
          var seen = new ts3.Map();
          ts3.forEach(properties, function(p) {
            seen.set(p.escapedName, p);
          });
          for (var _i = 0, baseTypes_3 = baseTypes; _i < baseTypes_3.length; _i++) {
            var base = baseTypes_3[_i];
            var properties_5 = getPropertiesOfType(getTypeWithThisArgument(base, type2.thisType));
            for (var _a = 0, properties_4 = properties_5; _a < properties_4.length; _a++) {
              var prop = properties_4[_a];
              var existing = seen.get(prop.escapedName);
              if (existing && prop.parent === existing.parent) {
                seen.delete(prop.escapedName);
              }
            }
          }
          return ts3.arrayFrom(seen.values());
        }
        function checkInheritedPropertiesAreIdentical(type2, typeNode) {
          var baseTypes = getBaseTypes(type2);
          if (baseTypes.length < 2) {
            return true;
          }
          var seen = new ts3.Map();
          ts3.forEach(resolveDeclaredMembers(type2).declaredProperties, function(p) {
            seen.set(p.escapedName, { prop: p, containingType: type2 });
          });
          var ok = true;
          for (var _i = 0, baseTypes_4 = baseTypes; _i < baseTypes_4.length; _i++) {
            var base = baseTypes_4[_i];
            var properties = getPropertiesOfType(getTypeWithThisArgument(base, type2.thisType));
            for (var _a = 0, properties_6 = properties; _a < properties_6.length; _a++) {
              var prop = properties_6[_a];
              var existing = seen.get(prop.escapedName);
              if (!existing) {
                seen.set(prop.escapedName, { prop, containingType: base });
              } else {
                var isInheritedProperty = existing.containingType !== type2;
                if (isInheritedProperty && !isPropertyIdenticalTo(existing.prop, prop)) {
                  ok = false;
                  var typeName1 = typeToString(existing.containingType);
                  var typeName2 = typeToString(base);
                  var errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, symbolToString(prop), typeName1, typeName2);
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, typeToString(type2), typeName1, typeName2);
                  diagnostics.add(ts3.createDiagnosticForNodeFromMessageChain(typeNode, errorInfo));
                }
              }
            }
          }
          return ok;
        }
        function checkPropertyInitialization(node) {
          if (!strictNullChecks || !strictPropertyInitialization || node.flags & 16777216) {
            return;
          }
          var constructor = findConstructorDeclaration(node);
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (ts3.getEffectiveModifierFlags(member) & 2) {
              continue;
            }
            if (!ts3.isStatic(member) && isPropertyWithoutInitializer(member)) {
              var propName = member.name;
              if (ts3.isIdentifier(propName) || ts3.isPrivateIdentifier(propName) || ts3.isComputedPropertyName(propName)) {
                var type2 = getTypeOfSymbol(getSymbolOfNode(member));
                if (!(type2.flags & 3 || getFalsyFlags(type2) & 32768)) {
                  if (!constructor || !isPropertyInitializedInConstructor(propName, type2, constructor)) {
                    error(member.name, ts3.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor, ts3.declarationNameToString(propName));
                  }
                }
              }
            }
          }
        }
        function isPropertyWithoutInitializer(node) {
          return node.kind === 167 && !ts3.hasAbstractModifier(node) && !node.exclamationToken && !node.initializer;
        }
        function isPropertyInitializedInStaticBlocks(propName, propType, staticBlocks, startPos, endPos) {
          for (var _i = 0, staticBlocks_2 = staticBlocks; _i < staticBlocks_2.length; _i++) {
            var staticBlock = staticBlocks_2[_i];
            if (staticBlock.pos >= startPos && staticBlock.pos <= endPos) {
              var reference = ts3.factory.createPropertyAccessExpression(ts3.factory.createThis(), propName);
              ts3.setParent(reference.expression, reference);
              ts3.setParent(reference, staticBlock);
              reference.flowNode = staticBlock.returnFlowNode;
              var flowType = getFlowTypeOfReference(reference, propType, getOptionalType(propType));
              if (!(getFalsyFlags(flowType) & 32768)) {
                return true;
              }
            }
          }
          return false;
        }
        function isPropertyInitializedInConstructor(propName, propType, constructor) {
          var reference = ts3.isComputedPropertyName(propName) ? ts3.factory.createElementAccessExpression(ts3.factory.createThis(), propName.expression) : ts3.factory.createPropertyAccessExpression(ts3.factory.createThis(), propName);
          ts3.setParent(reference.expression, reference);
          ts3.setParent(reference, constructor);
          reference.flowNode = constructor.returnFlowNode;
          var flowType = getFlowTypeOfReference(reference, propType, getOptionalType(propType));
          return !(getFalsyFlags(flowType) & 32768);
        }
        function checkInterfaceDeclaration(node) {
          if (!checkGrammarDecoratorsAndModifiers(node))
            checkGrammarInterfaceDeclaration(node);
          checkTypeParameters(node.typeParameters);
          addLazyDiagnostic(function() {
            checkTypeNameIsReserved(node.name, ts3.Diagnostics.Interface_name_cannot_be_0);
            checkExportsOnMergedDeclarations(node);
            var symbol = getSymbolOfNode(node);
            checkTypeParameterListsIdentical(symbol);
            var firstInterfaceDecl = ts3.getDeclarationOfKind(symbol, 258);
            if (node === firstInterfaceDecl) {
              var type2 = getDeclaredTypeOfSymbol(symbol);
              var typeWithThis = getTypeWithThisArgument(type2);
              if (checkInheritedPropertiesAreIdentical(type2, node.name)) {
                for (var _i = 0, _a = getBaseTypes(type2); _i < _a.length; _i++) {
                  var baseType = _a[_i];
                  checkTypeAssignableTo(typeWithThis, getTypeWithThisArgument(baseType, type2.thisType), node.name, ts3.Diagnostics.Interface_0_incorrectly_extends_interface_1);
                }
                checkIndexConstraints(type2, symbol);
              }
            }
            checkObjectTypeForDuplicateDeclarations(node);
          });
          ts3.forEach(ts3.getInterfaceBaseTypeNodes(node), function(heritageElement) {
            if (!ts3.isEntityNameExpression(heritageElement.expression) || ts3.isOptionalChain(heritageElement.expression)) {
              error(heritageElement.expression, ts3.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments);
            }
            checkTypeReferenceNode(heritageElement);
          });
          ts3.forEach(node.members, checkSourceElement);
          addLazyDiagnostic(function() {
            checkTypeForDuplicateIndexSignatures(node);
            registerForUnusedIdentifiersCheck(node);
          });
        }
        function checkTypeAliasDeclaration(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkTypeNameIsReserved(node.name, ts3.Diagnostics.Type_alias_name_cannot_be_0);
          checkExportsOnMergedDeclarations(node);
          checkTypeParameters(node.typeParameters);
          if (node.type.kind === 138) {
            if (!intrinsicTypeKinds.has(node.name.escapedText) || ts3.length(node.typeParameters) !== 1) {
              error(node.type, ts3.Diagnostics.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types);
            }
          } else {
            checkSourceElement(node.type);
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function computeEnumMemberValues(node) {
          var nodeLinks2 = getNodeLinks(node);
          if (!(nodeLinks2.flags & 16384)) {
            nodeLinks2.flags |= 16384;
            var autoValue = 0;
            for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
              var member = _a[_i];
              var value = computeMemberValue(member, autoValue);
              getNodeLinks(member).enumMemberValue = value;
              autoValue = typeof value === "number" ? value + 1 : void 0;
            }
          }
        }
        function computeMemberValue(member, autoValue) {
          if (ts3.isComputedNonLiteralName(member.name)) {
            error(member.name, ts3.Diagnostics.Computed_property_names_are_not_allowed_in_enums);
          } else {
            var text = ts3.getTextOfPropertyName(member.name);
            if (ts3.isNumericLiteralName(text) && !ts3.isInfinityOrNaNString(text)) {
              error(member.name, ts3.Diagnostics.An_enum_member_cannot_have_a_numeric_name);
            }
          }
          if (member.initializer) {
            return computeConstantValue(member);
          }
          if (member.parent.flags & 16777216 && !ts3.isEnumConst(member.parent) && getEnumKind(getSymbolOfNode(member.parent)) === 0) {
            return void 0;
          }
          if (autoValue !== void 0) {
            return autoValue;
          }
          error(member.name, ts3.Diagnostics.Enum_member_must_have_initializer);
          return void 0;
        }
        function computeConstantValue(member) {
          var enumKind = getEnumKind(getSymbolOfNode(member.parent));
          var isConstEnum = ts3.isEnumConst(member.parent);
          var initializer = member.initializer;
          var value = enumKind === 1 && !isLiteralEnumMember(member) ? void 0 : evaluate(initializer);
          if (value !== void 0) {
            if (isConstEnum && typeof value === "number" && !isFinite(value)) {
              error(initializer, isNaN(value) ? ts3.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN : ts3.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);
            }
          } else if (enumKind === 1) {
            error(initializer, ts3.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members);
            return 0;
          } else if (isConstEnum) {
            error(initializer, ts3.Diagnostics.const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values);
          } else if (member.parent.flags & 16777216) {
            error(initializer, ts3.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression);
          } else {
            var source = checkExpression(initializer);
            if (!isTypeAssignableToKind(source, 296)) {
              error(initializer, ts3.Diagnostics.Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead, typeToString(source));
            } else {
              checkTypeAssignableTo(source, getDeclaredTypeOfSymbol(getSymbolOfNode(member.parent)), initializer, void 0);
            }
          }
          return value;
          function evaluate(expr) {
            switch (expr.kind) {
              case 219:
                var value_2 = evaluate(expr.operand);
                if (typeof value_2 === "number") {
                  switch (expr.operator) {
                    case 39:
                      return value_2;
                    case 40:
                      return -value_2;
                    case 54:
                      return ~value_2;
                  }
                }
                break;
              case 221:
                var left = evaluate(expr.left);
                var right = evaluate(expr.right);
                if (typeof left === "number" && typeof right === "number") {
                  switch (expr.operatorToken.kind) {
                    case 51:
                      return left | right;
                    case 50:
                      return left & right;
                    case 48:
                      return left >> right;
                    case 49:
                      return left >>> right;
                    case 47:
                      return left << right;
                    case 52:
                      return left ^ right;
                    case 41:
                      return left * right;
                    case 43:
                      return left / right;
                    case 39:
                      return left + right;
                    case 40:
                      return left - right;
                    case 44:
                      return left % right;
                    case 42:
                      return Math.pow(left, right);
                  }
                } else if (typeof left === "string" && typeof right === "string" && expr.operatorToken.kind === 39) {
                  return left + right;
                }
                break;
              case 10:
              case 14:
                return expr.text;
              case 8:
                checkGrammarNumericLiteral(expr);
                return +expr.text;
              case 212:
                return evaluate(expr.expression);
              case 79:
                var identifier = expr;
                if (ts3.isInfinityOrNaNString(identifier.escapedText)) {
                  return +identifier.escapedText;
                }
                return ts3.nodeIsMissing(expr) ? 0 : evaluateEnumMember(expr, getSymbolOfNode(member.parent), identifier.escapedText);
              case 207:
              case 206:
                if (isConstantMemberAccess(expr)) {
                  var type2 = getTypeOfExpression(expr.expression);
                  if (type2.symbol && type2.symbol.flags & 384) {
                    var name = void 0;
                    if (expr.kind === 206) {
                      name = expr.name.escapedText;
                    } else {
                      name = ts3.escapeLeadingUnderscores(ts3.cast(expr.argumentExpression, ts3.isLiteralExpression).text);
                    }
                    return evaluateEnumMember(expr, type2.symbol, name);
                  }
                }
                break;
            }
            return void 0;
          }
          function evaluateEnumMember(expr, enumSymbol, name) {
            var memberSymbol = enumSymbol.exports.get(name);
            if (memberSymbol) {
              var declaration = memberSymbol.valueDeclaration;
              if (declaration !== member) {
                if (declaration && isBlockScopedNameDeclaredBeforeUse(declaration, member) && ts3.isEnumDeclaration(declaration.parent)) {
                  return getEnumMemberValue(declaration);
                }
                error(expr, ts3.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums);
                return 0;
              } else {
                error(expr, ts3.Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(memberSymbol));
              }
            }
            return void 0;
          }
        }
        function isConstantMemberAccess(node) {
          var type2 = getTypeOfExpression(node);
          if (type2 === errorType) {
            return false;
          }
          return node.kind === 79 || node.kind === 206 && isConstantMemberAccess(node.expression) || node.kind === 207 && isConstantMemberAccess(node.expression) && ts3.isStringLiteralLike(node.argumentExpression);
        }
        function checkEnumDeclaration(node) {
          addLazyDiagnostic(function() {
            return checkEnumDeclarationWorker(node);
          });
        }
        function checkEnumDeclarationWorker(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkCollisionsForDeclarationName(node, node.name);
          checkExportsOnMergedDeclarations(node);
          node.members.forEach(checkEnumMember);
          computeEnumMemberValues(node);
          var enumSymbol = getSymbolOfNode(node);
          var firstDeclaration = ts3.getDeclarationOfKind(enumSymbol, node.kind);
          if (node === firstDeclaration) {
            if (enumSymbol.declarations && enumSymbol.declarations.length > 1) {
              var enumIsConst_1 = ts3.isEnumConst(node);
              ts3.forEach(enumSymbol.declarations, function(decl) {
                if (ts3.isEnumDeclaration(decl) && ts3.isEnumConst(decl) !== enumIsConst_1) {
                  error(ts3.getNameOfDeclaration(decl), ts3.Diagnostics.Enum_declarations_must_all_be_const_or_non_const);
                }
              });
            }
            var seenEnumMissingInitialInitializer_1 = false;
            ts3.forEach(enumSymbol.declarations, function(declaration) {
              if (declaration.kind !== 260) {
                return false;
              }
              var enumDeclaration = declaration;
              if (!enumDeclaration.members.length) {
                return false;
              }
              var firstEnumMember = enumDeclaration.members[0];
              if (!firstEnumMember.initializer) {
                if (seenEnumMissingInitialInitializer_1) {
                  error(firstEnumMember.name, ts3.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element);
                } else {
                  seenEnumMissingInitialInitializer_1 = true;
                }
              }
            });
          }
        }
        function checkEnumMember(node) {
          if (ts3.isPrivateIdentifier(node.name)) {
            error(node, ts3.Diagnostics.An_enum_member_cannot_be_named_with_a_private_identifier);
          }
        }
        function getFirstNonAmbientClassOrFunctionDeclaration(symbol) {
          var declarations = symbol.declarations;
          if (declarations) {
            for (var _i = 0, declarations_9 = declarations; _i < declarations_9.length; _i++) {
              var declaration = declarations_9[_i];
              if ((declaration.kind === 257 || declaration.kind === 256 && ts3.nodeIsPresent(declaration.body)) && !(declaration.flags & 16777216)) {
                return declaration;
              }
            }
          }
          return void 0;
        }
        function inSameLexicalScope(node1, node2) {
          var container1 = ts3.getEnclosingBlockScopeContainer(node1);
          var container2 = ts3.getEnclosingBlockScopeContainer(node2);
          if (isGlobalSourceFile(container1)) {
            return isGlobalSourceFile(container2);
          } else if (isGlobalSourceFile(container2)) {
            return false;
          } else {
            return container1 === container2;
          }
        }
        function checkModuleDeclaration(node) {
          if (node.body) {
            checkSourceElement(node.body);
            if (!ts3.isGlobalScopeAugmentation(node)) {
              registerForUnusedIdentifiersCheck(node);
            }
          }
          addLazyDiagnostic(checkModuleDeclarationDiagnostics);
          function checkModuleDeclarationDiagnostics() {
            var isGlobalAugmentation = ts3.isGlobalScopeAugmentation(node);
            var inAmbientContext = node.flags & 16777216;
            if (isGlobalAugmentation && !inAmbientContext) {
              error(node.name, ts3.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);
            }
            var isAmbientExternalModule = ts3.isAmbientModule(node);
            var contextErrorMessage = isAmbientExternalModule ? ts3.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file : ts3.Diagnostics.A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module;
            if (checkGrammarModuleElementContext(node, contextErrorMessage)) {
              return;
            }
            if (!checkGrammarDecoratorsAndModifiers(node)) {
              if (!inAmbientContext && node.name.kind === 10) {
                grammarErrorOnNode(node.name, ts3.Diagnostics.Only_ambient_modules_can_use_quoted_names);
              }
            }
            if (ts3.isIdentifier(node.name)) {
              checkCollisionsForDeclarationName(node, node.name);
            }
            checkExportsOnMergedDeclarations(node);
            var symbol = getSymbolOfNode(node);
            if (symbol.flags & 512 && !inAmbientContext && symbol.declarations && symbol.declarations.length > 1 && isInstantiatedModule(node, ts3.shouldPreserveConstEnums(compilerOptions))) {
              var firstNonAmbientClassOrFunc = getFirstNonAmbientClassOrFunctionDeclaration(symbol);
              if (firstNonAmbientClassOrFunc) {
                if (ts3.getSourceFileOfNode(node) !== ts3.getSourceFileOfNode(firstNonAmbientClassOrFunc)) {
                  error(node.name, ts3.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged);
                } else if (node.pos < firstNonAmbientClassOrFunc.pos) {
                  error(node.name, ts3.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged);
                }
              }
              var mergedClass = ts3.getDeclarationOfKind(symbol, 257);
              if (mergedClass && inSameLexicalScope(node, mergedClass)) {
                getNodeLinks(node).flags |= 32768;
              }
            }
            if (isAmbientExternalModule) {
              if (ts3.isExternalModuleAugmentation(node)) {
                var checkBody = isGlobalAugmentation || getSymbolOfNode(node).flags & 33554432;
                if (checkBody && node.body) {
                  for (var _i = 0, _a = node.body.statements; _i < _a.length; _i++) {
                    var statement = _a[_i];
                    checkModuleAugmentationElement(statement, isGlobalAugmentation);
                  }
                }
              } else if (isGlobalSourceFile(node.parent)) {
                if (isGlobalAugmentation) {
                  error(node.name, ts3.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
                } else if (ts3.isExternalModuleNameRelative(ts3.getTextOfIdentifierOrLiteral(node.name))) {
                  error(node.name, ts3.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name);
                }
              } else {
                if (isGlobalAugmentation) {
                  error(node.name, ts3.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
                } else {
                  error(node.name, ts3.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces);
                }
              }
            }
          }
        }
        function checkModuleAugmentationElement(node, isGlobalAugmentation) {
          var _a;
          switch (node.kind) {
            case 237:
              for (var _i = 0, _b = node.declarationList.declarations; _i < _b.length; _i++) {
                var decl = _b[_i];
                checkModuleAugmentationElement(decl, isGlobalAugmentation);
              }
              break;
            case 271:
            case 272:
              grammarErrorOnFirstToken(node, ts3.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);
              break;
            case 265:
            case 266:
              grammarErrorOnFirstToken(node, ts3.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);
              break;
            case 203:
            case 254:
              var name = node.name;
              if (ts3.isBindingPattern(name)) {
                for (var _c = 0, _d = name.elements; _c < _d.length; _c++) {
                  var el = _d[_c];
                  checkModuleAugmentationElement(el, isGlobalAugmentation);
                }
                break;
              }
            case 257:
            case 260:
            case 256:
            case 258:
            case 261:
            case 259:
              if (isGlobalAugmentation) {
                return;
              }
              var symbol = getSymbolOfNode(node);
              if (symbol) {
                var reportError = !(symbol.flags & 33554432);
                if (!reportError) {
                  reportError = !!((_a = symbol.parent) === null || _a === void 0 ? void 0 : _a.declarations) && ts3.isExternalModuleAugmentation(symbol.parent.declarations[0]);
                }
              }
              break;
          }
        }
        function getFirstNonModuleExportsIdentifier(node) {
          switch (node.kind) {
            case 79:
              return node;
            case 161:
              do {
                node = node.left;
              } while (node.kind !== 79);
              return node;
            case 206:
              do {
                if (ts3.isModuleExportsAccessExpression(node.expression) && !ts3.isPrivateIdentifier(node.name)) {
                  return node.name;
                }
                node = node.expression;
              } while (node.kind !== 79);
              return node;
          }
        }
        function checkExternalImportOrExportDeclaration(node) {
          var moduleName = ts3.getExternalModuleName(node);
          if (!moduleName || ts3.nodeIsMissing(moduleName)) {
            return false;
          }
          if (!ts3.isStringLiteral(moduleName)) {
            error(moduleName, ts3.Diagnostics.String_literal_expected);
            return false;
          }
          var inAmbientExternalModule = node.parent.kind === 262 && ts3.isAmbientModule(node.parent.parent);
          if (node.parent.kind !== 305 && !inAmbientExternalModule) {
            error(moduleName, node.kind === 272 ? ts3.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace : ts3.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module);
            return false;
          }
          if (inAmbientExternalModule && ts3.isExternalModuleNameRelative(moduleName.text)) {
            if (!isTopLevelInExternalModuleAugmentation(node)) {
              error(node, ts3.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name);
              return false;
            }
          }
          if (!ts3.isImportEqualsDeclaration(node) && node.assertClause) {
            var hasError = false;
            for (var _i = 0, _a = node.assertClause.elements; _i < _a.length; _i++) {
              var clause = _a[_i];
              if (!ts3.isStringLiteral(clause.value)) {
                hasError = true;
                error(clause.value, ts3.Diagnostics.Import_assertion_values_must_be_string_literal_expressions);
              }
            }
            return !hasError;
          }
          return true;
        }
        function checkAliasSymbol(node) {
          var symbol = getSymbolOfNode(node);
          var target = resolveAlias(symbol);
          if (target !== unknownSymbol) {
            symbol = getMergedSymbol(symbol.exportSymbol || symbol);
            var excludedMeanings = (symbol.flags & (111551 | 1048576) ? 111551 : 0) | (symbol.flags & 788968 ? 788968 : 0) | (symbol.flags & 1920 ? 1920 : 0);
            if (target.flags & excludedMeanings) {
              var message = node.kind === 275 ? ts3.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0 : ts3.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;
              error(node, message, symbolToString(symbol));
            }
            if (compilerOptions.isolatedModules && !ts3.isTypeOnlyImportOrExportDeclaration(node) && !(node.flags & 16777216)) {
              var typeOnlyAlias = getTypeOnlyAliasDeclaration(symbol);
              var isType = !(target.flags & 111551);
              if (isType || typeOnlyAlias) {
                switch (node.kind) {
                  case 267:
                  case 270:
                  case 265: {
                    if (compilerOptions.preserveValueImports) {
                      ts3.Debug.assertIsDefined(node.name, "An ImportClause with a symbol should have a name");
                      var message = isType ? ts3.Diagnostics._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled : ts3.Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled;
                      var name = ts3.idText(node.kind === 270 ? node.propertyName || node.name : node.name);
                      addTypeOnlyDeclarationRelatedInfo(error(node, message, name), isType ? void 0 : typeOnlyAlias, name);
                    }
                    if (isType && node.kind === 265 && ts3.hasEffectiveModifier(node, 1)) {
                      error(node, ts3.Diagnostics.Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided);
                    }
                    break;
                  }
                  case 275: {
                    if (ts3.getSourceFileOfNode(typeOnlyAlias) !== ts3.getSourceFileOfNode(node)) {
                      var message = isType ? ts3.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type : ts3.Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isolatedModules_is_enabled;
                      var name = ts3.idText(node.propertyName || node.name);
                      addTypeOnlyDeclarationRelatedInfo(error(node, message, name), isType ? void 0 : typeOnlyAlias, name);
                      return;
                    }
                  }
                }
              }
            }
            if (ts3.isImportSpecifier(node)) {
              var targetSymbol = checkDeprecatedAliasedSymbol(symbol, node);
              if (isDeprecatedAliasedSymbol(targetSymbol) && targetSymbol.declarations) {
                addDeprecatedSuggestion(node, targetSymbol.declarations, targetSymbol.escapedName);
              }
            }
          }
        }
        function isDeprecatedAliasedSymbol(symbol) {
          return !!symbol.declarations && ts3.every(symbol.declarations, function(d) {
            return !!(ts3.getCombinedNodeFlags(d) & 268435456);
          });
        }
        function checkDeprecatedAliasedSymbol(symbol, location) {
          if (!(symbol.flags & 2097152))
            return symbol;
          var targetSymbol = resolveAlias(symbol);
          if (targetSymbol === unknownSymbol)
            return targetSymbol;
          while (symbol.flags & 2097152) {
            var target = getImmediateAliasedSymbol(symbol);
            if (target) {
              if (target === targetSymbol)
                break;
              if (target.declarations && ts3.length(target.declarations)) {
                if (isDeprecatedAliasedSymbol(target)) {
                  addDeprecatedSuggestion(location, target.declarations, target.escapedName);
                  break;
                } else {
                  if (symbol === targetSymbol)
                    break;
                  symbol = target;
                }
              }
            } else {
              break;
            }
          }
          return targetSymbol;
        }
        function checkImportBinding(node) {
          checkCollisionsForDeclarationName(node, node.name);
          checkAliasSymbol(node);
          if (node.kind === 270 && ts3.idText(node.propertyName || node.name) === "default" && ts3.getESModuleInterop(compilerOptions) && moduleKind !== ts3.ModuleKind.System && (moduleKind < ts3.ModuleKind.ES2015 || ts3.getSourceFileOfNode(node).impliedNodeFormat === ts3.ModuleKind.CommonJS)) {
            checkExternalEmitHelpers(node, 131072);
          }
        }
        function checkAssertClause(declaration) {
          var _a;
          if (declaration.assertClause) {
            var validForTypeAssertions = ts3.isExclusivelyTypeOnlyImportOrExport(declaration);
            var override = ts3.getResolutionModeOverrideForClause(declaration.assertClause, validForTypeAssertions ? grammarErrorOnNode : void 0);
            if (validForTypeAssertions && override) {
              if (!ts3.isNightly()) {
                grammarErrorOnNode(declaration.assertClause, ts3.Diagnostics.resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next);
              }
              if (ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.Node16 && ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeNext) {
                return grammarErrorOnNode(declaration.assertClause, ts3.Diagnostics.resolution_mode_assertions_are_only_supported_when_moduleResolution_is_node16_or_nodenext);
              }
              return;
            }
            var mode = moduleKind === ts3.ModuleKind.NodeNext && declaration.moduleSpecifier && getUsageModeForExpression(declaration.moduleSpecifier);
            if (mode !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.ESNext) {
              return grammarErrorOnNode(declaration.assertClause, moduleKind === ts3.ModuleKind.NodeNext ? ts3.Diagnostics.Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls : ts3.Diagnostics.Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext);
            }
            if (ts3.isImportDeclaration(declaration) ? (_a = declaration.importClause) === null || _a === void 0 ? void 0 : _a.isTypeOnly : declaration.isTypeOnly) {
              return grammarErrorOnNode(declaration.assertClause, ts3.Diagnostics.Import_assertions_cannot_be_used_with_type_only_imports_or_exports);
            }
            if (override) {
              return grammarErrorOnNode(declaration.assertClause, ts3.Diagnostics.resolution_mode_can_only_be_set_for_type_only_imports);
            }
          }
        }
        function checkImportDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts3.isInJSFile(node) ? ts3.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : ts3.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts3.hasEffectiveModifiers(node)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.An_import_declaration_cannot_have_modifiers);
          }
          if (checkExternalImportOrExportDeclaration(node)) {
            var importClause = node.importClause;
            if (importClause && !checkGrammarImportClause(importClause)) {
              if (importClause.name) {
                checkImportBinding(importClause);
              }
              if (importClause.namedBindings) {
                if (importClause.namedBindings.kind === 268) {
                  checkImportBinding(importClause.namedBindings);
                  if (moduleKind !== ts3.ModuleKind.System && (moduleKind < ts3.ModuleKind.ES2015 || ts3.getSourceFileOfNode(node).impliedNodeFormat === ts3.ModuleKind.CommonJS) && ts3.getESModuleInterop(compilerOptions)) {
                    checkExternalEmitHelpers(node, 65536);
                  }
                } else {
                  var moduleExisted = resolveExternalModuleName(node, node.moduleSpecifier);
                  if (moduleExisted) {
                    ts3.forEach(importClause.namedBindings.elements, checkImportBinding);
                  }
                }
              }
            }
          }
          checkAssertClause(node);
        }
        function checkImportEqualsDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts3.isInJSFile(node) ? ts3.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : ts3.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
            return;
          }
          checkGrammarDecoratorsAndModifiers(node);
          if (ts3.isInternalModuleImportEqualsDeclaration(node) || checkExternalImportOrExportDeclaration(node)) {
            checkImportBinding(node);
            if (ts3.hasSyntacticModifier(node, 1)) {
              markExportAsReferenced(node);
            }
            if (node.moduleReference.kind !== 277) {
              var target = resolveAlias(getSymbolOfNode(node));
              if (target !== unknownSymbol) {
                if (target.flags & 111551) {
                  var moduleName = ts3.getFirstIdentifier(node.moduleReference);
                  if (!(resolveEntityName(moduleName, 111551 | 1920).flags & 1920)) {
                    error(moduleName, ts3.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name, ts3.declarationNameToString(moduleName));
                  }
                }
                if (target.flags & 788968) {
                  checkTypeNameIsReserved(node.name, ts3.Diagnostics.Import_name_cannot_be_0);
                }
              }
              if (node.isTypeOnly) {
                grammarErrorOnNode(node, ts3.Diagnostics.An_import_alias_cannot_use_import_type);
              }
            } else {
              if (moduleKind >= ts3.ModuleKind.ES2015 && ts3.getSourceFileOfNode(node).impliedNodeFormat === void 0 && !node.isTypeOnly && !(node.flags & 16777216)) {
                grammarErrorOnNode(node, ts3.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead);
              }
            }
          }
        }
        function checkExportDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts3.isInJSFile(node) ? ts3.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module : ts3.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts3.hasSyntacticModifiers(node)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.An_export_declaration_cannot_have_modifiers);
          }
          if (node.moduleSpecifier && node.exportClause && ts3.isNamedExports(node.exportClause) && ts3.length(node.exportClause.elements) && languageVersion === 0) {
            checkExternalEmitHelpers(node, 4194304);
          }
          checkGrammarExportDeclaration(node);
          if (!node.moduleSpecifier || checkExternalImportOrExportDeclaration(node)) {
            if (node.exportClause && !ts3.isNamespaceExport(node.exportClause)) {
              ts3.forEach(node.exportClause.elements, checkExportSpecifier);
              var inAmbientExternalModule = node.parent.kind === 262 && ts3.isAmbientModule(node.parent.parent);
              var inAmbientNamespaceDeclaration = !inAmbientExternalModule && node.parent.kind === 262 && !node.moduleSpecifier && node.flags & 16777216;
              if (node.parent.kind !== 305 && !inAmbientExternalModule && !inAmbientNamespaceDeclaration) {
                error(node, ts3.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace);
              }
            } else {
              var moduleSymbol = resolveExternalModuleName(node, node.moduleSpecifier);
              if (moduleSymbol && hasExportAssignmentSymbol(moduleSymbol)) {
                error(node.moduleSpecifier, ts3.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk, symbolToString(moduleSymbol));
              } else if (node.exportClause) {
                checkAliasSymbol(node.exportClause);
              }
              if (moduleKind !== ts3.ModuleKind.System && (moduleKind < ts3.ModuleKind.ES2015 || ts3.getSourceFileOfNode(node).impliedNodeFormat === ts3.ModuleKind.CommonJS)) {
                if (node.exportClause) {
                  if (ts3.getESModuleInterop(compilerOptions)) {
                    checkExternalEmitHelpers(node, 65536);
                  }
                } else {
                  checkExternalEmitHelpers(node, 32768);
                }
              }
            }
          }
          checkAssertClause(node);
        }
        function checkGrammarExportDeclaration(node) {
          var _a;
          if (node.isTypeOnly) {
            if (((_a = node.exportClause) === null || _a === void 0 ? void 0 : _a.kind) === 273) {
              return checkGrammarNamedImportsOrExports(node.exportClause);
            } else {
              return grammarErrorOnNode(node, ts3.Diagnostics.Only_named_exports_may_use_export_type);
            }
          }
          return false;
        }
        function checkGrammarModuleElementContext(node, errorMessage) {
          var isInAppropriateContext = node.parent.kind === 305 || node.parent.kind === 262 || node.parent.kind === 261;
          if (!isInAppropriateContext) {
            grammarErrorOnFirstToken(node, errorMessage);
          }
          return !isInAppropriateContext;
        }
        function importClauseContainsReferencedImport(importClause) {
          return ts3.forEachImportClauseDeclaration(importClause, function(declaration) {
            return !!getSymbolOfNode(declaration).isReferenced;
          });
        }
        function importClauseContainsConstEnumUsedAsValue(importClause) {
          return ts3.forEachImportClauseDeclaration(importClause, function(declaration) {
            return !!getSymbolLinks(getSymbolOfNode(declaration)).constEnumReferenced;
          });
        }
        function canConvertImportDeclarationToTypeOnly(statement) {
          return ts3.isImportDeclaration(statement) && statement.importClause && !statement.importClause.isTypeOnly && importClauseContainsReferencedImport(statement.importClause) && !isReferencedAliasDeclaration(statement.importClause, true) && !importClauseContainsConstEnumUsedAsValue(statement.importClause);
        }
        function canConvertImportEqualsDeclarationToTypeOnly(statement) {
          return ts3.isImportEqualsDeclaration(statement) && ts3.isExternalModuleReference(statement.moduleReference) && !statement.isTypeOnly && getSymbolOfNode(statement).isReferenced && !isReferencedAliasDeclaration(statement, false) && !getSymbolLinks(getSymbolOfNode(statement)).constEnumReferenced;
        }
        function checkImportsForTypeOnlyConversion(sourceFile) {
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (canConvertImportDeclarationToTypeOnly(statement) || canConvertImportEqualsDeclarationToTypeOnly(statement)) {
              error(statement, ts3.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error);
            }
          }
        }
        function checkExportSpecifier(node) {
          checkAliasSymbol(node);
          if (ts3.getEmitDeclarations(compilerOptions)) {
            collectLinkedAliases(node.propertyName || node.name, true);
          }
          if (!node.parent.parent.moduleSpecifier) {
            var exportedName = node.propertyName || node.name;
            var symbol = resolveName(exportedName, exportedName.escapedText, 111551 | 788968 | 1920 | 2097152, void 0, void 0, true);
            if (symbol && (symbol === undefinedSymbol || symbol === globalThisSymbol || symbol.declarations && isGlobalSourceFile(getDeclarationContainer(symbol.declarations[0])))) {
              error(exportedName, ts3.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, ts3.idText(exportedName));
            } else {
              markExportAsReferenced(node);
              var target = symbol && (symbol.flags & 2097152 ? resolveAlias(symbol) : symbol);
              if (!target || target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.propertyName || node.name);
              }
            }
          } else {
            if (ts3.getESModuleInterop(compilerOptions) && moduleKind !== ts3.ModuleKind.System && (moduleKind < ts3.ModuleKind.ES2015 || ts3.getSourceFileOfNode(node).impliedNodeFormat === ts3.ModuleKind.CommonJS) && ts3.idText(node.propertyName || node.name) === "default") {
              checkExternalEmitHelpers(node, 131072);
            }
          }
        }
        function checkExportAssignment(node) {
          var illegalContextMessage = node.isExportEquals ? ts3.Diagnostics.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration : ts3.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;
          if (checkGrammarModuleElementContext(node, illegalContextMessage)) {
            return;
          }
          var container = node.parent.kind === 305 ? node.parent : node.parent.parent;
          if (container.kind === 261 && !ts3.isAmbientModule(container)) {
            if (node.isExportEquals) {
              error(node, ts3.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace);
            } else {
              error(node, ts3.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
            }
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts3.hasEffectiveModifiers(node)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.An_export_assignment_cannot_have_modifiers);
          }
          var typeAnnotationNode = ts3.getEffectiveTypeAnnotationNode(node);
          if (typeAnnotationNode) {
            checkTypeAssignableTo(checkExpressionCached(node.expression), getTypeFromTypeNode(typeAnnotationNode), node.expression);
          }
          if (node.expression.kind === 79) {
            var id = node.expression;
            var sym = resolveEntityName(id, 67108863, true, true, node);
            if (sym) {
              markAliasReferenced(sym, id);
              var target = sym.flags & 2097152 ? resolveAlias(sym) : sym;
              if (target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.expression);
              }
            } else {
              checkExpressionCached(node.expression);
            }
            if (ts3.getEmitDeclarations(compilerOptions)) {
              collectLinkedAliases(node.expression, true);
            }
          } else {
            checkExpressionCached(node.expression);
          }
          checkExternalModuleExports(container);
          if (node.flags & 16777216 && !ts3.isEntityNameExpression(node.expression)) {
            grammarErrorOnNode(node.expression, ts3.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context);
          }
          if (node.isExportEquals && !(node.flags & 16777216)) {
            if (moduleKind >= ts3.ModuleKind.ES2015 && ts3.getSourceFileOfNode(node).impliedNodeFormat !== ts3.ModuleKind.CommonJS) {
              grammarErrorOnNode(node, ts3.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead);
            } else if (moduleKind === ts3.ModuleKind.System) {
              grammarErrorOnNode(node, ts3.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system);
            }
          }
        }
        function hasExportedMembers(moduleSymbol) {
          return ts3.forEachEntry(moduleSymbol.exports, function(_, id) {
            return id !== "export=";
          });
        }
        function checkExternalModuleExports(node) {
          var moduleSymbol = getSymbolOfNode(node);
          var links = getSymbolLinks(moduleSymbol);
          if (!links.exportsChecked) {
            var exportEqualsSymbol = moduleSymbol.exports.get("export=");
            if (exportEqualsSymbol && hasExportedMembers(moduleSymbol)) {
              var declaration = getDeclarationOfAliasSymbol(exportEqualsSymbol) || exportEqualsSymbol.valueDeclaration;
              if (declaration && !isTopLevelInExternalModuleAugmentation(declaration) && !ts3.isInJSFile(declaration)) {
                error(declaration, ts3.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements);
              }
            }
            var exports_3 = getExportsOfModule(moduleSymbol);
            if (exports_3) {
              exports_3.forEach(function(_a, id) {
                var declarations = _a.declarations, flags = _a.flags;
                if (id === "__export") {
                  return;
                }
                if (flags & (1920 | 384)) {
                  return;
                }
                var exportedDeclarationsCount = ts3.countWhere(declarations, ts3.and(isNotOverloadAndNotAccessor, ts3.not(ts3.isInterfaceDeclaration)));
                if (flags & 524288 && exportedDeclarationsCount <= 2) {
                  return;
                }
                if (exportedDeclarationsCount > 1) {
                  if (!isDuplicatedCommonJSExport(declarations)) {
                    for (var _i = 0, _b = declarations; _i < _b.length; _i++) {
                      var declaration2 = _b[_i];
                      if (isNotOverload(declaration2)) {
                        diagnostics.add(ts3.createDiagnosticForNode(declaration2, ts3.Diagnostics.Cannot_redeclare_exported_variable_0, ts3.unescapeLeadingUnderscores(id)));
                      }
                    }
                  }
                }
              });
            }
            links.exportsChecked = true;
          }
        }
        function isDuplicatedCommonJSExport(declarations) {
          return declarations && declarations.length > 1 && declarations.every(function(d) {
            return ts3.isInJSFile(d) && ts3.isAccessExpression(d) && (ts3.isExportsIdentifier(d.expression) || ts3.isModuleExportsAccessExpression(d.expression));
          });
        }
        function checkSourceElement(node) {
          if (node) {
            var saveCurrentNode = currentNode;
            currentNode = node;
            instantiationCount = 0;
            checkSourceElementWorker(node);
            currentNode = saveCurrentNode;
          }
        }
        function checkSourceElementWorker(node) {
          if (ts3.isInJSFile(node)) {
            ts3.forEach(node.jsDoc, function(_a) {
              var tags = _a.tags;
              return ts3.forEach(tags, checkSourceElement);
            });
          }
          var kind = node.kind;
          if (cancellationToken) {
            switch (kind) {
              case 261:
              case 257:
              case 258:
              case 256:
                cancellationToken.throwIfCancellationRequested();
            }
          }
          if (kind >= 237 && kind <= 253 && node.flowNode && !isReachableFlowNode(node.flowNode)) {
            errorOrSuggestion(compilerOptions.allowUnreachableCode === false, node, ts3.Diagnostics.Unreachable_code_detected);
          }
          switch (kind) {
            case 163:
              return checkTypeParameter(node);
            case 164:
              return checkParameter(node);
            case 167:
              return checkPropertyDeclaration(node);
            case 166:
              return checkPropertySignature(node);
            case 180:
            case 179:
            case 174:
            case 175:
            case 176:
              return checkSignatureDeclaration(node);
            case 169:
            case 168:
              return checkMethodDeclaration(node);
            case 170:
              return checkClassStaticBlockDeclaration(node);
            case 171:
              return checkConstructorDeclaration(node);
            case 172:
            case 173:
              return checkAccessorDeclaration(node);
            case 178:
              return checkTypeReferenceNode(node);
            case 177:
              return checkTypePredicate(node);
            case 181:
              return checkTypeQuery(node);
            case 182:
              return checkTypeLiteral(node);
            case 183:
              return checkArrayType(node);
            case 184:
              return checkTupleType(node);
            case 187:
            case 188:
              return checkUnionOrIntersectionType(node);
            case 191:
            case 185:
            case 186:
              return checkSourceElement(node.type);
            case 192:
              return checkThisType(node);
            case 193:
              return checkTypeOperator(node);
            case 189:
              return checkConditionalType(node);
            case 190:
              return checkInferType(node);
            case 198:
              return checkTemplateLiteralType(node);
            case 200:
              return checkImportType(node);
            case 197:
              return checkNamedTupleMember(node);
            case 328:
              return checkJSDocAugmentsTag(node);
            case 329:
              return checkJSDocImplementsTag(node);
            case 345:
            case 338:
            case 339:
              return checkJSDocTypeAliasTag(node);
            case 344:
              return checkJSDocTemplateTag(node);
            case 343:
              return checkJSDocTypeTag(node);
            case 340:
              return checkJSDocParameterTag(node);
            case 347:
              return checkJSDocPropertyTag(node);
            case 317:
              checkJSDocFunctionType(node);
            case 315:
            case 314:
            case 312:
            case 313:
            case 322:
              checkJSDocTypeIsInJsFile(node);
              ts3.forEachChild(node, checkSourceElement);
              return;
            case 318:
              checkJSDocVariadicType(node);
              return;
            case 309:
              return checkSourceElement(node.type);
            case 333:
            case 335:
            case 334:
              return checkJSDocAccessibilityModifiers(node);
            case 194:
              return checkIndexedAccessType(node);
            case 195:
              return checkMappedType(node);
            case 256:
              return checkFunctionDeclaration(node);
            case 235:
            case 262:
              return checkBlock(node);
            case 237:
              return checkVariableStatement(node);
            case 238:
              return checkExpressionStatement(node);
            case 239:
              return checkIfStatement(node);
            case 240:
              return checkDoStatement(node);
            case 241:
              return checkWhileStatement(node);
            case 242:
              return checkForStatement(node);
            case 243:
              return checkForInStatement(node);
            case 244:
              return checkForOfStatement(node);
            case 245:
            case 246:
              return checkBreakOrContinueStatement(node);
            case 247:
              return checkReturnStatement(node);
            case 248:
              return checkWithStatement(node);
            case 249:
              return checkSwitchStatement(node);
            case 250:
              return checkLabeledStatement(node);
            case 251:
              return checkThrowStatement(node);
            case 252:
              return checkTryStatement(node);
            case 254:
              return checkVariableDeclaration(node);
            case 203:
              return checkBindingElement(node);
            case 257:
              return checkClassDeclaration(node);
            case 258:
              return checkInterfaceDeclaration(node);
            case 259:
              return checkTypeAliasDeclaration(node);
            case 260:
              return checkEnumDeclaration(node);
            case 261:
              return checkModuleDeclaration(node);
            case 266:
              return checkImportDeclaration(node);
            case 265:
              return checkImportEqualsDeclaration(node);
            case 272:
              return checkExportDeclaration(node);
            case 271:
              return checkExportAssignment(node);
            case 236:
            case 253:
              checkGrammarStatementInAmbientContext(node);
              return;
            case 276:
              return checkMissingDeclaration(node);
          }
        }
        function checkJSDocTypeIsInJsFile(node) {
          if (!ts3.isInJSFile(node)) {
            grammarErrorOnNode(node, ts3.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
          }
        }
        function checkJSDocVariadicType(node) {
          checkJSDocTypeIsInJsFile(node);
          checkSourceElement(node.type);
          var parent = node.parent;
          if (ts3.isParameter(parent) && ts3.isJSDocFunctionType(parent.parent)) {
            if (ts3.last(parent.parent.parameters) !== parent) {
              error(node, ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
            }
            return;
          }
          if (!ts3.isJSDocTypeExpression(parent)) {
            error(node, ts3.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
          }
          var paramTag = node.parent.parent;
          if (!ts3.isJSDocParameterTag(paramTag)) {
            error(node, ts3.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
            return;
          }
          var param = ts3.getParameterSymbolFromJSDoc(paramTag);
          if (!param) {
            return;
          }
          var host2 = ts3.getHostSignatureFromJSDoc(paramTag);
          if (!host2 || ts3.last(host2.parameters).symbol !== param) {
            error(node, ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
          }
        }
        function getTypeFromJSDocVariadicType(node) {
          var type2 = getTypeFromTypeNode(node.type);
          var parent = node.parent;
          var paramTag = node.parent.parent;
          if (ts3.isJSDocTypeExpression(node.parent) && ts3.isJSDocParameterTag(paramTag)) {
            var host_1 = ts3.getHostSignatureFromJSDoc(paramTag);
            var isCallbackTag = ts3.isJSDocCallbackTag(paramTag.parent.parent);
            if (host_1 || isCallbackTag) {
              var lastParamDeclaration = isCallbackTag ? ts3.lastOrUndefined(paramTag.parent.parent.typeExpression.parameters) : ts3.lastOrUndefined(host_1.parameters);
              var symbol = ts3.getParameterSymbolFromJSDoc(paramTag);
              if (!lastParamDeclaration || symbol && lastParamDeclaration.symbol === symbol && ts3.isRestParameter(lastParamDeclaration)) {
                return createArrayType(type2);
              }
            }
          }
          if (ts3.isParameter(parent) && ts3.isJSDocFunctionType(parent.parent)) {
            return createArrayType(type2);
          }
          return addOptionality(type2);
        }
        function checkNodeDeferred(node) {
          var enclosingFile = ts3.getSourceFileOfNode(node);
          var links = getNodeLinks(enclosingFile);
          if (!(links.flags & 1)) {
            links.deferredNodes || (links.deferredNodes = new ts3.Set());
            links.deferredNodes.add(node);
          }
        }
        function checkDeferredNodes(context) {
          var links = getNodeLinks(context);
          if (links.deferredNodes) {
            links.deferredNodes.forEach(checkDeferredNode);
          }
        }
        function checkDeferredNode(node) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkDeferredNode", { kind: node.kind, pos: node.pos, end: node.end, path: node.tracingPath });
          var saveCurrentNode = currentNode;
          currentNode = node;
          instantiationCount = 0;
          switch (node.kind) {
            case 208:
            case 209:
            case 210:
            case 165:
            case 280:
              resolveUntypedCall(node);
              break;
            case 213:
            case 214:
            case 169:
            case 168:
              checkFunctionExpressionOrObjectLiteralMethodDeferred(node);
              break;
            case 172:
            case 173:
              checkAccessorDeclaration(node);
              break;
            case 226:
              checkClassExpressionDeferred(node);
              break;
            case 163:
              checkTypeParameterDeferred(node);
              break;
            case 279:
              checkJsxSelfClosingElementDeferred(node);
              break;
            case 278:
              checkJsxElementDeferred(node);
              break;
          }
          currentNode = saveCurrentNode;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function checkSourceFile(node) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkSourceFile", { path: node.path }, true);
          ts3.performance.mark("beforeCheck");
          checkSourceFileWorker(node);
          ts3.performance.mark("afterCheck");
          ts3.performance.measure("Check", "beforeCheck", "afterCheck");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function unusedIsError(kind, isAmbient) {
          if (isAmbient) {
            return false;
          }
          switch (kind) {
            case 0:
              return !!compilerOptions.noUnusedLocals;
            case 1:
              return !!compilerOptions.noUnusedParameters;
            default:
              return ts3.Debug.assertNever(kind);
          }
        }
        function getPotentiallyUnusedIdentifiers(sourceFile) {
          return allPotentiallyUnusedIdentifiers.get(sourceFile.path) || ts3.emptyArray;
        }
        function checkSourceFileWorker(node) {
          var links = getNodeLinks(node);
          if (!(links.flags & 1)) {
            if (ts3.skipTypeChecking(node, compilerOptions, host)) {
              return;
            }
            checkGrammarSourceFile(node);
            ts3.clear(potentialThisCollisions);
            ts3.clear(potentialNewTargetCollisions);
            ts3.clear(potentialWeakMapSetCollisions);
            ts3.clear(potentialReflectCollisions);
            ts3.forEach(node.statements, checkSourceElement);
            checkSourceElement(node.endOfFileToken);
            checkDeferredNodes(node);
            if (ts3.isExternalOrCommonJsModule(node)) {
              registerForUnusedIdentifiersCheck(node);
            }
            addLazyDiagnostic(function() {
              if (!node.isDeclarationFile && (compilerOptions.noUnusedLocals || compilerOptions.noUnusedParameters)) {
                checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(node), function(containingNode, kind, diag) {
                  if (!ts3.containsParseError(containingNode) && unusedIsError(kind, !!(containingNode.flags & 16777216))) {
                    diagnostics.add(diag);
                  }
                });
              }
            });
            if (compilerOptions.importsNotUsedAsValues === 2 && !node.isDeclarationFile && ts3.isExternalModule(node)) {
              checkImportsForTypeOnlyConversion(node);
            }
            if (ts3.isExternalOrCommonJsModule(node)) {
              checkExternalModuleExports(node);
            }
            if (potentialThisCollisions.length) {
              ts3.forEach(potentialThisCollisions, checkIfThisIsCapturedInEnclosingScope);
              ts3.clear(potentialThisCollisions);
            }
            if (potentialNewTargetCollisions.length) {
              ts3.forEach(potentialNewTargetCollisions, checkIfNewTargetIsCapturedInEnclosingScope);
              ts3.clear(potentialNewTargetCollisions);
            }
            if (potentialWeakMapSetCollisions.length) {
              ts3.forEach(potentialWeakMapSetCollisions, checkWeakMapSetCollision);
              ts3.clear(potentialWeakMapSetCollisions);
            }
            if (potentialReflectCollisions.length) {
              ts3.forEach(potentialReflectCollisions, checkReflectCollision);
              ts3.clear(potentialReflectCollisions);
            }
            links.flags |= 1;
          }
        }
        function getDiagnostics(sourceFile, ct) {
          try {
            cancellationToken = ct;
            return getDiagnosticsWorker(sourceFile);
          } finally {
            cancellationToken = void 0;
          }
        }
        function ensurePendingDiagnosticWorkComplete() {
          for (var _i = 0, deferredDiagnosticsCallbacks_1 = deferredDiagnosticsCallbacks; _i < deferredDiagnosticsCallbacks_1.length; _i++) {
            var cb = deferredDiagnosticsCallbacks_1[_i];
            cb();
          }
          deferredDiagnosticsCallbacks = [];
        }
        function checkSourceFileWithEagerDiagnostics(sourceFile) {
          ensurePendingDiagnosticWorkComplete();
          var oldAddLazyDiagnostics = addLazyDiagnostic;
          addLazyDiagnostic = function(cb) {
            return cb();
          };
          checkSourceFile(sourceFile);
          addLazyDiagnostic = oldAddLazyDiagnostics;
        }
        function getDiagnosticsWorker(sourceFile) {
          if (sourceFile) {
            ensurePendingDiagnosticWorkComplete();
            var previousGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
            var previousGlobalDiagnosticsSize = previousGlobalDiagnostics.length;
            checkSourceFileWithEagerDiagnostics(sourceFile);
            var semanticDiagnostics = diagnostics.getDiagnostics(sourceFile.fileName);
            var currentGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
            if (currentGlobalDiagnostics !== previousGlobalDiagnostics) {
              var deferredGlobalDiagnostics = ts3.relativeComplement(previousGlobalDiagnostics, currentGlobalDiagnostics, ts3.compareDiagnostics);
              return ts3.concatenate(deferredGlobalDiagnostics, semanticDiagnostics);
            } else if (previousGlobalDiagnosticsSize === 0 && currentGlobalDiagnostics.length > 0) {
              return ts3.concatenate(currentGlobalDiagnostics, semanticDiagnostics);
            }
            return semanticDiagnostics;
          }
          ts3.forEach(host.getSourceFiles(), checkSourceFileWithEagerDiagnostics);
          return diagnostics.getDiagnostics();
        }
        function getGlobalDiagnostics() {
          ensurePendingDiagnosticWorkComplete();
          return diagnostics.getGlobalDiagnostics();
        }
        function getSymbolsInScope(location, meaning) {
          if (location.flags & 33554432) {
            return [];
          }
          var symbols = ts3.createSymbolTable();
          var isStaticSymbol = false;
          populateSymbols();
          symbols.delete("this");
          return symbolsToArray(symbols);
          function populateSymbols() {
            while (location) {
              if (location.locals && !isGlobalSourceFile(location)) {
                copySymbols(location.locals, meaning);
              }
              switch (location.kind) {
                case 305:
                  if (!ts3.isExternalModule(location))
                    break;
                case 261:
                  copyLocallyVisibleExportSymbols(getSymbolOfNode(location).exports, meaning & 2623475);
                  break;
                case 260:
                  copySymbols(getSymbolOfNode(location).exports, meaning & 8);
                  break;
                case 226:
                  var className = location.name;
                  if (className) {
                    copySymbol(location.symbol, meaning);
                  }
                case 257:
                case 258:
                  if (!isStaticSymbol) {
                    copySymbols(getMembersOfSymbol(getSymbolOfNode(location)), meaning & 788968);
                  }
                  break;
                case 213:
                  var funcName = location.name;
                  if (funcName) {
                    copySymbol(location.symbol, meaning);
                  }
                  break;
              }
              if (ts3.introducesArgumentsExoticObject(location)) {
                copySymbol(argumentsSymbol, meaning);
              }
              isStaticSymbol = ts3.isStatic(location);
              location = location.parent;
            }
            copySymbols(globals, meaning);
          }
          function copySymbol(symbol, meaning2) {
            if (ts3.getCombinedLocalAndExportSymbolFlags(symbol) & meaning2) {
              var id = symbol.escapedName;
              if (!symbols.has(id)) {
                symbols.set(id, symbol);
              }
            }
          }
          function copySymbols(source, meaning2) {
            if (meaning2) {
              source.forEach(function(symbol) {
                copySymbol(symbol, meaning2);
              });
            }
          }
          function copyLocallyVisibleExportSymbols(source, meaning2) {
            if (meaning2) {
              source.forEach(function(symbol) {
                if (!ts3.getDeclarationOfKind(symbol, 275) && !ts3.getDeclarationOfKind(symbol, 274)) {
                  copySymbol(symbol, meaning2);
                }
              });
            }
          }
        }
        function isTypeDeclarationName(name) {
          return name.kind === 79 && isTypeDeclaration(name.parent) && ts3.getNameOfDeclaration(name.parent) === name;
        }
        function isTypeDeclaration(node) {
          switch (node.kind) {
            case 163:
            case 257:
            case 258:
            case 259:
            case 260:
            case 345:
            case 338:
            case 339:
              return true;
            case 267:
              return node.isTypeOnly;
            case 270:
            case 275:
              return node.parent.parent.isTypeOnly;
            default:
              return false;
          }
        }
        function isTypeReferenceIdentifier(node) {
          while (node.parent.kind === 161) {
            node = node.parent;
          }
          return node.parent.kind === 178;
        }
        function isHeritageClauseElementIdentifier(node) {
          while (node.parent.kind === 206) {
            node = node.parent;
          }
          return node.parent.kind === 228;
        }
        function forEachEnclosingClass(node, callback) {
          var result2;
          while (true) {
            node = ts3.getContainingClass(node);
            if (!node)
              break;
            if (result2 = callback(node))
              break;
          }
          return result2;
        }
        function isNodeUsedDuringClassInitialization(node) {
          return !!ts3.findAncestor(node, function(element) {
            if (ts3.isConstructorDeclaration(element) && ts3.nodeIsPresent(element.body) || ts3.isPropertyDeclaration(element)) {
              return true;
            } else if (ts3.isClassLike(element) || ts3.isFunctionLikeDeclaration(element)) {
              return "quit";
            }
            return false;
          });
        }
        function isNodeWithinClass(node, classDeclaration) {
          return !!forEachEnclosingClass(node, function(n) {
            return n === classDeclaration;
          });
        }
        function getLeftSideOfImportEqualsOrExportAssignment(nodeOnRightSide) {
          while (nodeOnRightSide.parent.kind === 161) {
            nodeOnRightSide = nodeOnRightSide.parent;
          }
          if (nodeOnRightSide.parent.kind === 265) {
            return nodeOnRightSide.parent.moduleReference === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
          }
          if (nodeOnRightSide.parent.kind === 271) {
            return nodeOnRightSide.parent.expression === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
          }
          return void 0;
        }
        function isInRightSideOfImportOrExportAssignment(node) {
          return getLeftSideOfImportEqualsOrExportAssignment(node) !== void 0;
        }
        function getSpecialPropertyAssignmentSymbolFromEntityName(entityName) {
          var specialPropertyAssignmentKind = ts3.getAssignmentDeclarationKind(entityName.parent.parent);
          switch (specialPropertyAssignmentKind) {
            case 1:
            case 3:
              return getSymbolOfNode(entityName.parent);
            case 4:
            case 2:
            case 5:
              return getSymbolOfNode(entityName.parent.parent);
          }
        }
        function isImportTypeQualifierPart(node) {
          var parent = node.parent;
          while (ts3.isQualifiedName(parent)) {
            node = parent;
            parent = parent.parent;
          }
          if (parent && parent.kind === 200 && parent.qualifier === node) {
            return parent;
          }
          return void 0;
        }
        function getSymbolOfNameOrPropertyAccessExpression(name) {
          if (ts3.isDeclarationName(name)) {
            return getSymbolOfNode(name.parent);
          }
          if (ts3.isInJSFile(name) && name.parent.kind === 206 && name.parent === name.parent.parent.left) {
            if (!ts3.isPrivateIdentifier(name) && !ts3.isJSDocMemberName(name)) {
              var specialPropertyAssignmentSymbol = getSpecialPropertyAssignmentSymbolFromEntityName(name);
              if (specialPropertyAssignmentSymbol) {
                return specialPropertyAssignmentSymbol;
              }
            }
          }
          if (name.parent.kind === 271 && ts3.isEntityNameExpression(name)) {
            var success = resolveEntityName(name, 111551 | 788968 | 1920 | 2097152, true);
            if (success && success !== unknownSymbol) {
              return success;
            }
          } else if (ts3.isEntityName(name) && isInRightSideOfImportOrExportAssignment(name)) {
            var importEqualsDeclaration = ts3.getAncestor(name, 265);
            ts3.Debug.assert(importEqualsDeclaration !== void 0);
            return getSymbolOfPartOfRightHandSideOfImportEquals(name, true);
          }
          if (ts3.isEntityName(name)) {
            var possibleImportNode = isImportTypeQualifierPart(name);
            if (possibleImportNode) {
              getTypeFromTypeNode(possibleImportNode);
              var sym = getNodeLinks(name).resolvedSymbol;
              return sym === unknownSymbol ? void 0 : sym;
            }
          }
          while (ts3.isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName(name)) {
            name = name.parent;
          }
          if (isHeritageClauseElementIdentifier(name)) {
            var meaning = 0;
            if (name.parent.kind === 228) {
              meaning = 788968;
              if (ts3.isExpressionWithTypeArgumentsInClassExtendsClause(name.parent)) {
                meaning |= 111551;
              }
            } else {
              meaning = 1920;
            }
            meaning |= 2097152;
            var entityNameSymbol = ts3.isEntityNameExpression(name) ? resolveEntityName(name, meaning) : void 0;
            if (entityNameSymbol) {
              return entityNameSymbol;
            }
          }
          if (name.parent.kind === 340) {
            return ts3.getParameterSymbolFromJSDoc(name.parent);
          }
          if (name.parent.kind === 163 && name.parent.parent.kind === 344) {
            ts3.Debug.assert(!ts3.isInJSFile(name));
            var typeParameter = ts3.getTypeParameterFromJsDoc(name.parent);
            return typeParameter && typeParameter.symbol;
          }
          if (ts3.isExpressionNode(name)) {
            if (ts3.nodeIsMissing(name)) {
              return void 0;
            }
            var isJSDoc_1 = ts3.findAncestor(name, ts3.or(ts3.isJSDocLinkLike, ts3.isJSDocNameReference, ts3.isJSDocMemberName));
            var meaning = isJSDoc_1 ? 788968 | 1920 | 111551 : 111551;
            if (name.kind === 79) {
              if (ts3.isJSXTagName(name) && isJsxIntrinsicIdentifier(name)) {
                var symbol = getIntrinsicTagSymbol(name.parent);
                return symbol === unknownSymbol ? void 0 : symbol;
              }
              var result2 = resolveEntityName(name, meaning, false, true, ts3.getHostSignatureFromJSDoc(name));
              if (!result2 && isJSDoc_1) {
                var container = ts3.findAncestor(name, ts3.or(ts3.isClassLike, ts3.isInterfaceDeclaration));
                if (container) {
                  return resolveJSDocMemberName(name, getSymbolOfNode(container));
                }
              }
              return result2;
            } else if (ts3.isPrivateIdentifier(name)) {
              return getSymbolForPrivateIdentifierExpression(name);
            } else if (name.kind === 206 || name.kind === 161) {
              var links = getNodeLinks(name);
              if (links.resolvedSymbol) {
                return links.resolvedSymbol;
              }
              if (name.kind === 206) {
                checkPropertyAccessExpression(name, 0);
              } else {
                checkQualifiedName(name, 0);
              }
              if (!links.resolvedSymbol && isJSDoc_1 && ts3.isQualifiedName(name)) {
                return resolveJSDocMemberName(name);
              }
              return links.resolvedSymbol;
            } else if (ts3.isJSDocMemberName(name)) {
              return resolveJSDocMemberName(name);
            }
          } else if (isTypeReferenceIdentifier(name)) {
            var meaning = name.parent.kind === 178 ? 788968 : 1920;
            var symbol = resolveEntityName(name, meaning, false, true);
            return symbol && symbol !== unknownSymbol ? symbol : getUnresolvedSymbolForEntityName(name);
          }
          if (name.parent.kind === 177) {
            return resolveEntityName(name, 1);
          }
          return void 0;
        }
        function resolveJSDocMemberName(name, container) {
          if (ts3.isEntityName(name)) {
            var meaning = 788968 | 1920 | 111551;
            var symbol = resolveEntityName(name, meaning, false, true, ts3.getHostSignatureFromJSDoc(name));
            if (!symbol && ts3.isIdentifier(name) && container) {
              symbol = getMergedSymbol(getSymbol(getExportsOfSymbol(container), name.escapedText, meaning));
            }
            if (symbol) {
              return symbol;
            }
          }
          var left = ts3.isIdentifier(name) ? container : resolveJSDocMemberName(name.left);
          var right = ts3.isIdentifier(name) ? name.escapedText : name.right.escapedText;
          if (left) {
            var proto = left.flags & 111551 && getPropertyOfType(getTypeOfSymbol(left), "prototype");
            var t = proto ? getTypeOfSymbol(proto) : getDeclaredTypeOfSymbol(left);
            return getPropertyOfType(t, right);
          }
        }
        function getSymbolAtLocation(node, ignoreErrors) {
          if (node.kind === 305) {
            return ts3.isExternalModule(node) ? getMergedSymbol(node.symbol) : void 0;
          }
          var parent = node.parent;
          var grandParent = parent.parent;
          if (node.flags & 33554432) {
            return void 0;
          }
          if (isDeclarationNameOrImportPropertyName(node)) {
            var parentSymbol = getSymbolOfNode(parent);
            return ts3.isImportOrExportSpecifier(node.parent) && node.parent.propertyName === node ? getImmediateAliasedSymbol(parentSymbol) : parentSymbol;
          } else if (ts3.isLiteralComputedPropertyDeclarationName(node)) {
            return getSymbolOfNode(parent.parent);
          }
          if (node.kind === 79) {
            if (isInRightSideOfImportOrExportAssignment(node)) {
              return getSymbolOfNameOrPropertyAccessExpression(node);
            } else if (parent.kind === 203 && grandParent.kind === 201 && node === parent.propertyName) {
              var typeOfPattern = getTypeOfNode(grandParent);
              var propertyDeclaration = getPropertyOfType(typeOfPattern, node.escapedText);
              if (propertyDeclaration) {
                return propertyDeclaration;
              }
            } else if (ts3.isMetaProperty(parent) && parent.name === node) {
              if (parent.keywordToken === 103 && ts3.idText(node) === "target") {
                return checkNewTargetMetaProperty(parent).symbol;
              }
              if (parent.keywordToken === 100 && ts3.idText(node) === "meta") {
                return getGlobalImportMetaExpressionType().members.get("meta");
              }
              return void 0;
            }
          }
          switch (node.kind) {
            case 79:
            case 80:
            case 206:
            case 161:
              if (!ts3.isThisInTypeQuery(node)) {
                return getSymbolOfNameOrPropertyAccessExpression(node);
              }
            case 108:
              var container = ts3.getThisContainer(node, false);
              if (ts3.isFunctionLike(container)) {
                var sig = getSignatureFromDeclaration(container);
                if (sig.thisParameter) {
                  return sig.thisParameter;
                }
              }
              if (ts3.isInExpressionContext(node)) {
                return checkExpression(node).symbol;
              }
            case 192:
              return getTypeFromThisTypeNode(node).symbol;
            case 106:
              return checkExpression(node).symbol;
            case 134:
              var constructorDeclaration = node.parent;
              if (constructorDeclaration && constructorDeclaration.kind === 171) {
                return constructorDeclaration.parent.symbol;
              }
              return void 0;
            case 10:
            case 14:
              if (ts3.isExternalModuleImportEqualsDeclaration(node.parent.parent) && ts3.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node || (node.parent.kind === 266 || node.parent.kind === 272) && node.parent.moduleSpecifier === node || (ts3.isInJSFile(node) && ts3.isRequireCall(node.parent, false) || ts3.isImportCall(node.parent)) || ts3.isLiteralTypeNode(node.parent) && ts3.isLiteralImportTypeNode(node.parent.parent) && node.parent.parent.argument === node.parent) {
                return resolveExternalModuleName(node, node, ignoreErrors);
              }
              if (ts3.isCallExpression(parent) && ts3.isBindableObjectDefinePropertyCall(parent) && parent.arguments[1] === node) {
                return getSymbolOfNode(parent);
              }
            case 8:
              var objectType = ts3.isElementAccessExpression(parent) ? parent.argumentExpression === node ? getTypeOfExpression(parent.expression) : void 0 : ts3.isLiteralTypeNode(parent) && ts3.isIndexedAccessTypeNode(grandParent) ? getTypeFromTypeNode(grandParent.objectType) : void 0;
              return objectType && getPropertyOfType(objectType, ts3.escapeLeadingUnderscores(node.text));
            case 88:
            case 98:
            case 38:
            case 84:
              return getSymbolOfNode(node.parent);
            case 200:
              return ts3.isLiteralImportTypeNode(node) ? getSymbolAtLocation(node.argument.literal, ignoreErrors) : void 0;
            case 93:
              return ts3.isExportAssignment(node.parent) ? ts3.Debug.checkDefined(node.parent.symbol) : void 0;
            case 100:
            case 103:
              return ts3.isMetaProperty(node.parent) ? checkMetaPropertyKeyword(node.parent).symbol : void 0;
            case 231:
              return checkExpression(node).symbol;
            default:
              return void 0;
          }
        }
        function getIndexInfosAtLocation(node) {
          if (ts3.isIdentifier(node) && ts3.isPropertyAccessExpression(node.parent) && node.parent.name === node) {
            var keyType_1 = getLiteralTypeFromPropertyName(node);
            var objectType = getTypeOfExpression(node.parent.expression);
            var objectTypes = objectType.flags & 1048576 ? objectType.types : [objectType];
            return ts3.flatMap(objectTypes, function(t) {
              return ts3.filter(getIndexInfosOfType(t), function(info) {
                return isApplicableIndexType(keyType_1, info.keyType);
              });
            });
          }
          return void 0;
        }
        function getShorthandAssignmentValueSymbol(location) {
          if (location && location.kind === 297) {
            return resolveEntityName(location.name, 111551 | 2097152);
          }
          return void 0;
        }
        function getExportSpecifierLocalTargetSymbol(node) {
          if (ts3.isExportSpecifier(node)) {
            return node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node) : resolveEntityName(node.propertyName || node.name, 111551 | 788968 | 1920 | 2097152);
          } else {
            return resolveEntityName(node, 111551 | 788968 | 1920 | 2097152);
          }
        }
        function getTypeOfNode(node) {
          if (ts3.isSourceFile(node) && !ts3.isExternalModule(node)) {
            return errorType;
          }
          if (node.flags & 33554432) {
            return errorType;
          }
          var classDecl = ts3.tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
          var classType = classDecl && getDeclaredTypeOfClassOrInterface(getSymbolOfNode(classDecl.class));
          if (ts3.isPartOfTypeNode(node)) {
            var typeFromTypeNode = getTypeFromTypeNode(node);
            return classType ? getTypeWithThisArgument(typeFromTypeNode, classType.thisType) : typeFromTypeNode;
          }
          if (ts3.isExpressionNode(node)) {
            return getRegularTypeOfExpression(node);
          }
          if (classType && !classDecl.isImplements) {
            var baseType = ts3.firstOrUndefined(getBaseTypes(classType));
            return baseType ? getTypeWithThisArgument(baseType, classType.thisType) : errorType;
          }
          if (isTypeDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            return getDeclaredTypeOfSymbol(symbol);
          }
          if (isTypeDeclarationName(node)) {
            var symbol = getSymbolAtLocation(node);
            return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
          }
          if (ts3.isDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            return symbol ? getTypeOfSymbol(symbol) : errorType;
          }
          if (isDeclarationNameOrImportPropertyName(node)) {
            var symbol = getSymbolAtLocation(node);
            if (symbol) {
              return getTypeOfSymbol(symbol);
            }
            return errorType;
          }
          if (ts3.isBindingPattern(node)) {
            return getTypeForVariableLikeDeclaration(node.parent, true, 0) || errorType;
          }
          if (isInRightSideOfImportOrExportAssignment(node)) {
            var symbol = getSymbolAtLocation(node);
            if (symbol) {
              var declaredType = getDeclaredTypeOfSymbol(symbol);
              return !isErrorType(declaredType) ? declaredType : getTypeOfSymbol(symbol);
            }
          }
          if (ts3.isMetaProperty(node.parent) && node.parent.keywordToken === node.kind) {
            return checkMetaPropertyKeyword(node.parent);
          }
          return errorType;
        }
        function getTypeOfAssignmentPattern(expr) {
          ts3.Debug.assert(expr.kind === 205 || expr.kind === 204);
          if (expr.parent.kind === 244) {
            var iteratedType = checkRightHandSideOfForOf(expr.parent);
            return checkDestructuringAssignment(expr, iteratedType || errorType);
          }
          if (expr.parent.kind === 221) {
            var iteratedType = getTypeOfExpression(expr.parent.right);
            return checkDestructuringAssignment(expr, iteratedType || errorType);
          }
          if (expr.parent.kind === 296) {
            var node_3 = ts3.cast(expr.parent.parent, ts3.isObjectLiteralExpression);
            var typeOfParentObjectLiteral = getTypeOfAssignmentPattern(node_3) || errorType;
            var propertyIndex = ts3.indexOfNode(node_3.properties, expr.parent);
            return checkObjectLiteralDestructuringPropertyAssignment(node_3, typeOfParentObjectLiteral, propertyIndex);
          }
          var node = ts3.cast(expr.parent, ts3.isArrayLiteralExpression);
          var typeOfArrayLiteral = getTypeOfAssignmentPattern(node) || errorType;
          var elementType = checkIteratedTypeOrElementType(65, typeOfArrayLiteral, undefinedType, expr.parent) || errorType;
          return checkArrayLiteralDestructuringElementAssignment(node, typeOfArrayLiteral, node.elements.indexOf(expr), elementType);
        }
        function getPropertySymbolOfDestructuringAssignment(location) {
          var typeOfObjectLiteral = getTypeOfAssignmentPattern(ts3.cast(location.parent.parent, ts3.isAssignmentPattern));
          return typeOfObjectLiteral && getPropertyOfType(typeOfObjectLiteral, location.escapedText);
        }
        function getRegularTypeOfExpression(expr) {
          if (ts3.isRightSideOfQualifiedNameOrPropertyAccess(expr)) {
            expr = expr.parent;
          }
          return getRegularTypeOfLiteralType(getTypeOfExpression(expr));
        }
        function getParentTypeOfClassElement(node) {
          var classSymbol = getSymbolOfNode(node.parent);
          return ts3.isStatic(node) ? getTypeOfSymbol(classSymbol) : getDeclaredTypeOfSymbol(classSymbol);
        }
        function getClassElementPropertyKeyType(element) {
          var name = element.name;
          switch (name.kind) {
            case 79:
              return getStringLiteralType(ts3.idText(name));
            case 8:
            case 10:
              return getStringLiteralType(name.text);
            case 162:
              var nameType = checkComputedPropertyName(name);
              return isTypeAssignableToKind(nameType, 12288) ? nameType : stringType;
            default:
              return ts3.Debug.fail("Unsupported property name.");
          }
        }
        function getAugmentedPropertiesOfType(type2) {
          type2 = getApparentType(type2);
          var propsByName = ts3.createSymbolTable(getPropertiesOfType(type2));
          var functionType = getSignaturesOfType(type2, 0).length ? globalCallableFunctionType : getSignaturesOfType(type2, 1).length ? globalNewableFunctionType : void 0;
          if (functionType) {
            ts3.forEach(getPropertiesOfType(functionType), function(p) {
              if (!propsByName.has(p.escapedName)) {
                propsByName.set(p.escapedName, p);
              }
            });
          }
          return getNamedMembers(propsByName);
        }
        function typeHasCallOrConstructSignatures(type2) {
          return ts3.typeHasCallOrConstructSignatures(type2, checker);
        }
        function getRootSymbols(symbol) {
          var roots = getImmediateRootSymbols(symbol);
          return roots ? ts3.flatMap(roots, getRootSymbols) : [symbol];
        }
        function getImmediateRootSymbols(symbol) {
          if (ts3.getCheckFlags(symbol) & 6) {
            return ts3.mapDefined(getSymbolLinks(symbol).containingType.types, function(type2) {
              return getPropertyOfType(type2, symbol.escapedName);
            });
          } else if (symbol.flags & 33554432) {
            var _a = symbol, leftSpread = _a.leftSpread, rightSpread = _a.rightSpread, syntheticOrigin = _a.syntheticOrigin;
            return leftSpread ? [leftSpread, rightSpread] : syntheticOrigin ? [syntheticOrigin] : ts3.singleElementArray(tryGetTarget(symbol));
          }
          return void 0;
        }
        function tryGetTarget(symbol) {
          var target;
          var next = symbol;
          while (next = getSymbolLinks(next).target) {
            target = next;
          }
          return target;
        }
        function isArgumentsLocalBinding(nodeIn) {
          if (ts3.isGeneratedIdentifier(nodeIn))
            return false;
          var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
          if (!node)
            return false;
          var parent = node.parent;
          if (!parent)
            return false;
          var isPropertyName = (ts3.isPropertyAccessExpression(parent) || ts3.isPropertyAssignment(parent)) && parent.name === node;
          return !isPropertyName && getReferencedValueSymbol(node) === argumentsSymbol;
        }
        function moduleExportsSomeValue(moduleReferenceExpression) {
          var moduleSymbol = resolveExternalModuleName(moduleReferenceExpression.parent, moduleReferenceExpression);
          if (!moduleSymbol || ts3.isShorthandAmbientModuleSymbol(moduleSymbol)) {
            return true;
          }
          var hasExportAssignment = hasExportAssignmentSymbol(moduleSymbol);
          moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
          var symbolLinks2 = getSymbolLinks(moduleSymbol);
          if (symbolLinks2.exportsSomeValue === void 0) {
            symbolLinks2.exportsSomeValue = hasExportAssignment ? !!(moduleSymbol.flags & 111551) : ts3.forEachEntry(getExportsOfModule(moduleSymbol), isValue);
          }
          return symbolLinks2.exportsSomeValue;
          function isValue(s) {
            s = resolveSymbol(s);
            return s && !!(s.flags & 111551);
          }
        }
        function isNameOfModuleOrEnumDeclaration(node) {
          return ts3.isModuleOrEnumDeclaration(node.parent) && node === node.parent.name;
        }
        function getReferencedExportContainer(nodeIn, prefixLocals) {
          var _a;
          var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
          if (node) {
            var symbol = getReferencedValueSymbol(node, isNameOfModuleOrEnumDeclaration(node));
            if (symbol) {
              if (symbol.flags & 1048576) {
                var exportSymbol = getMergedSymbol(symbol.exportSymbol);
                if (!prefixLocals && exportSymbol.flags & 944 && !(exportSymbol.flags & 3)) {
                  return void 0;
                }
                symbol = exportSymbol;
              }
              var parentSymbol_1 = getParentOfSymbol(symbol);
              if (parentSymbol_1) {
                if (parentSymbol_1.flags & 512 && ((_a = parentSymbol_1.valueDeclaration) === null || _a === void 0 ? void 0 : _a.kind) === 305) {
                  var symbolFile = parentSymbol_1.valueDeclaration;
                  var referenceFile = ts3.getSourceFileOfNode(node);
                  var symbolIsUmdExport = symbolFile !== referenceFile;
                  return symbolIsUmdExport ? void 0 : symbolFile;
                }
                return ts3.findAncestor(node.parent, function(n) {
                  return ts3.isModuleOrEnumDeclaration(n) && getSymbolOfNode(n) === parentSymbol_1;
                });
              }
            }
          }
        }
        function getReferencedImportDeclaration(nodeIn) {
          if (nodeIn.generatedImportReference) {
            return nodeIn.generatedImportReference;
          }
          var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
          if (node) {
            var symbol = getReferencedValueSymbol(node);
            if (isNonLocalAlias(symbol, 111551) && !getTypeOnlyAliasDeclaration(symbol)) {
              return getDeclarationOfAliasSymbol(symbol);
            }
          }
          return void 0;
        }
        function isSymbolOfDestructuredElementOfCatchBinding(symbol) {
          return symbol.valueDeclaration && ts3.isBindingElement(symbol.valueDeclaration) && ts3.walkUpBindingElementsAndPatterns(symbol.valueDeclaration).parent.kind === 292;
        }
        function isSymbolOfDeclarationWithCollidingName(symbol) {
          if (symbol.flags & 418 && symbol.valueDeclaration && !ts3.isSourceFile(symbol.valueDeclaration)) {
            var links = getSymbolLinks(symbol);
            if (links.isDeclarationWithCollidingName === void 0) {
              var container = ts3.getEnclosingBlockScopeContainer(symbol.valueDeclaration);
              if (ts3.isStatementWithLocals(container) || isSymbolOfDestructuredElementOfCatchBinding(symbol)) {
                var nodeLinks_1 = getNodeLinks(symbol.valueDeclaration);
                if (resolveName(container.parent, symbol.escapedName, 111551, void 0, void 0, false)) {
                  links.isDeclarationWithCollidingName = true;
                } else if (nodeLinks_1.flags & 262144) {
                  var isDeclaredInLoop = nodeLinks_1.flags & 524288;
                  var inLoopInitializer = ts3.isIterationStatement(container, false);
                  var inLoopBodyBlock = container.kind === 235 && ts3.isIterationStatement(container.parent, false);
                  links.isDeclarationWithCollidingName = !ts3.isBlockScopedContainerTopLevel(container) && (!isDeclaredInLoop || !inLoopInitializer && !inLoopBodyBlock);
                } else {
                  links.isDeclarationWithCollidingName = false;
                }
              }
            }
            return links.isDeclarationWithCollidingName;
          }
          return false;
        }
        function getReferencedDeclarationWithCollidingName(nodeIn) {
          if (!ts3.isGeneratedIdentifier(nodeIn)) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
            if (node) {
              var symbol = getReferencedValueSymbol(node);
              if (symbol && isSymbolOfDeclarationWithCollidingName(symbol)) {
                return symbol.valueDeclaration;
              }
            }
          }
          return void 0;
        }
        function isDeclarationWithCollidingName(nodeIn) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isDeclaration);
          if (node) {
            var symbol = getSymbolOfNode(node);
            if (symbol) {
              return isSymbolOfDeclarationWithCollidingName(symbol);
            }
          }
          return false;
        }
        function isValueAliasDeclaration(node) {
          switch (node.kind) {
            case 265:
              return isAliasResolvedToValue(getSymbolOfNode(node));
            case 267:
            case 268:
            case 270:
            case 275:
              var symbol = getSymbolOfNode(node);
              return !!symbol && isAliasResolvedToValue(symbol) && !getTypeOnlyAliasDeclaration(symbol);
            case 272:
              var exportClause = node.exportClause;
              return !!exportClause && (ts3.isNamespaceExport(exportClause) || ts3.some(exportClause.elements, isValueAliasDeclaration));
            case 271:
              return node.expression && node.expression.kind === 79 ? isAliasResolvedToValue(getSymbolOfNode(node)) : true;
          }
          return false;
        }
        function isTopLevelValueImportEqualsWithEntityName(nodeIn) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isImportEqualsDeclaration);
          if (node === void 0 || node.parent.kind !== 305 || !ts3.isInternalModuleImportEqualsDeclaration(node)) {
            return false;
          }
          var isValue = isAliasResolvedToValue(getSymbolOfNode(node));
          return isValue && node.moduleReference && !ts3.nodeIsMissing(node.moduleReference);
        }
        function isAliasResolvedToValue(symbol) {
          if (!symbol) {
            return false;
          }
          var target = getExportSymbolOfValueSymbolIfExported(resolveAlias(symbol));
          if (target === unknownSymbol) {
            return true;
          }
          return !!(target.flags & 111551) && (ts3.shouldPreserveConstEnums(compilerOptions) || !isConstEnumOrConstEnumOnlyModule(target));
        }
        function isConstEnumOrConstEnumOnlyModule(s) {
          return isConstEnumSymbol(s) || !!s.constEnumOnlyModule;
        }
        function isReferencedAliasDeclaration(node, checkChildren) {
          if (isAliasSymbolDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            var links = symbol && getSymbolLinks(symbol);
            if (links === null || links === void 0 ? void 0 : links.referenced) {
              return true;
            }
            var target = getSymbolLinks(symbol).aliasTarget;
            if (target && ts3.getEffectiveModifierFlags(node) & 1 && target.flags & 111551 && (ts3.shouldPreserveConstEnums(compilerOptions) || !isConstEnumOrConstEnumOnlyModule(target))) {
              return true;
            }
          }
          if (checkChildren) {
            return !!ts3.forEachChild(node, function(node2) {
              return isReferencedAliasDeclaration(node2, checkChildren);
            });
          }
          return false;
        }
        function isImplementationOfOverload(node) {
          if (ts3.nodeIsPresent(node.body)) {
            if (ts3.isGetAccessor(node) || ts3.isSetAccessor(node))
              return false;
            var symbol = getSymbolOfNode(node);
            var signaturesOfSymbol = getSignaturesOfSymbol(symbol);
            return signaturesOfSymbol.length > 1 || signaturesOfSymbol.length === 1 && signaturesOfSymbol[0].declaration !== node;
          }
          return false;
        }
        function isRequiredInitializedParameter(parameter) {
          return !!strictNullChecks && !isOptionalParameter(parameter) && !ts3.isJSDocParameterTag(parameter) && !!parameter.initializer && !ts3.hasSyntacticModifier(parameter, 16476);
        }
        function isOptionalUninitializedParameterProperty(parameter) {
          return strictNullChecks && isOptionalParameter(parameter) && !parameter.initializer && ts3.hasSyntacticModifier(parameter, 16476);
        }
        function isExpandoFunctionDeclaration(node) {
          var declaration = ts3.getParseTreeNode(node, ts3.isFunctionDeclaration);
          if (!declaration) {
            return false;
          }
          var symbol = getSymbolOfNode(declaration);
          if (!symbol || !(symbol.flags & 16)) {
            return false;
          }
          return !!ts3.forEachEntry(getExportsOfSymbol(symbol), function(p) {
            return p.flags & 111551 && p.valueDeclaration && ts3.isPropertyAccessExpression(p.valueDeclaration);
          });
        }
        function getPropertiesOfContainerFunction(node) {
          var declaration = ts3.getParseTreeNode(node, ts3.isFunctionDeclaration);
          if (!declaration) {
            return ts3.emptyArray;
          }
          var symbol = getSymbolOfNode(declaration);
          return symbol && getPropertiesOfType(getTypeOfSymbol(symbol)) || ts3.emptyArray;
        }
        function getNodeCheckFlags(node) {
          var _a;
          var nodeId = node.id || 0;
          if (nodeId < 0 || nodeId >= nodeLinks.length)
            return 0;
          return ((_a = nodeLinks[nodeId]) === null || _a === void 0 ? void 0 : _a.flags) || 0;
        }
        function getEnumMemberValue(node) {
          computeEnumMemberValues(node.parent);
          return getNodeLinks(node).enumMemberValue;
        }
        function canHaveConstantValue(node) {
          switch (node.kind) {
            case 299:
            case 206:
            case 207:
              return true;
          }
          return false;
        }
        function getConstantValue(node) {
          if (node.kind === 299) {
            return getEnumMemberValue(node);
          }
          var symbol = getNodeLinks(node).resolvedSymbol;
          if (symbol && symbol.flags & 8) {
            var member = symbol.valueDeclaration;
            if (ts3.isEnumConst(member.parent)) {
              return getEnumMemberValue(member);
            }
          }
          return void 0;
        }
        function isFunctionType(type2) {
          return !!(type2.flags & 524288) && getSignaturesOfType(type2, 0).length > 0;
        }
        function getTypeReferenceSerializationKind(typeNameIn, location) {
          var _a, _b;
          var typeName = ts3.getParseTreeNode(typeNameIn, ts3.isEntityName);
          if (!typeName)
            return ts3.TypeReferenceSerializationKind.Unknown;
          if (location) {
            location = ts3.getParseTreeNode(location);
            if (!location)
              return ts3.TypeReferenceSerializationKind.Unknown;
          }
          var isTypeOnly = false;
          if (ts3.isQualifiedName(typeName)) {
            var rootValueSymbol = resolveEntityName(ts3.getFirstIdentifier(typeName), 111551, true, true, location);
            isTypeOnly = !!((_a = rootValueSymbol === null || rootValueSymbol === void 0 ? void 0 : rootValueSymbol.declarations) === null || _a === void 0 ? void 0 : _a.every(ts3.isTypeOnlyImportOrExportDeclaration));
          }
          var valueSymbol = resolveEntityName(typeName, 111551, true, true, location);
          var resolvedSymbol = valueSymbol && valueSymbol.flags & 2097152 ? resolveAlias(valueSymbol) : valueSymbol;
          isTypeOnly || (isTypeOnly = !!((_b = valueSymbol === null || valueSymbol === void 0 ? void 0 : valueSymbol.declarations) === null || _b === void 0 ? void 0 : _b.every(ts3.isTypeOnlyImportOrExportDeclaration)));
          var typeSymbol = resolveEntityName(typeName, 788968, true, false, location);
          if (resolvedSymbol && resolvedSymbol === typeSymbol) {
            var globalPromiseSymbol = getGlobalPromiseConstructorSymbol(false);
            if (globalPromiseSymbol && resolvedSymbol === globalPromiseSymbol) {
              return ts3.TypeReferenceSerializationKind.Promise;
            }
            var constructorType = getTypeOfSymbol(resolvedSymbol);
            if (constructorType && isConstructorType(constructorType)) {
              return isTypeOnly ? ts3.TypeReferenceSerializationKind.TypeWithCallSignature : ts3.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue;
            }
          }
          if (!typeSymbol) {
            return isTypeOnly ? ts3.TypeReferenceSerializationKind.ObjectType : ts3.TypeReferenceSerializationKind.Unknown;
          }
          var type2 = getDeclaredTypeOfSymbol(typeSymbol);
          if (isErrorType(type2)) {
            return isTypeOnly ? ts3.TypeReferenceSerializationKind.ObjectType : ts3.TypeReferenceSerializationKind.Unknown;
          } else if (type2.flags & 3) {
            return ts3.TypeReferenceSerializationKind.ObjectType;
          } else if (isTypeAssignableToKind(type2, 16384 | 98304 | 131072)) {
            return ts3.TypeReferenceSerializationKind.VoidNullableOrNeverType;
          } else if (isTypeAssignableToKind(type2, 528)) {
            return ts3.TypeReferenceSerializationKind.BooleanType;
          } else if (isTypeAssignableToKind(type2, 296)) {
            return ts3.TypeReferenceSerializationKind.NumberLikeType;
          } else if (isTypeAssignableToKind(type2, 2112)) {
            return ts3.TypeReferenceSerializationKind.BigIntLikeType;
          } else if (isTypeAssignableToKind(type2, 402653316)) {
            return ts3.TypeReferenceSerializationKind.StringLikeType;
          } else if (isTupleType(type2)) {
            return ts3.TypeReferenceSerializationKind.ArrayLikeType;
          } else if (isTypeAssignableToKind(type2, 12288)) {
            return ts3.TypeReferenceSerializationKind.ESSymbolType;
          } else if (isFunctionType(type2)) {
            return ts3.TypeReferenceSerializationKind.TypeWithCallSignature;
          } else if (isArrayType(type2)) {
            return ts3.TypeReferenceSerializationKind.ArrayLikeType;
          } else {
            return ts3.TypeReferenceSerializationKind.ObjectType;
          }
        }
        function createTypeOfDeclaration(declarationIn, enclosingDeclaration, flags, tracker, addUndefined) {
          var declaration = ts3.getParseTreeNode(declarationIn, ts3.isVariableLikeOrAccessor);
          if (!declaration) {
            return ts3.factory.createToken(130);
          }
          var symbol = getSymbolOfNode(declaration);
          var type2 = symbol && !(symbol.flags & (2048 | 131072)) ? getWidenedLiteralType(getTypeOfSymbol(symbol)) : errorType;
          if (type2.flags & 8192 && type2.symbol === symbol) {
            flags |= 1048576;
          }
          if (addUndefined) {
            type2 = getOptionalType(type2);
          }
          return nodeBuilder.typeToTypeNode(type2, enclosingDeclaration, flags | 1024, tracker);
        }
        function createReturnTypeOfSignatureDeclaration(signatureDeclarationIn, enclosingDeclaration, flags, tracker) {
          var signatureDeclaration = ts3.getParseTreeNode(signatureDeclarationIn, ts3.isFunctionLike);
          if (!signatureDeclaration) {
            return ts3.factory.createToken(130);
          }
          var signature = getSignatureFromDeclaration(signatureDeclaration);
          return nodeBuilder.typeToTypeNode(getReturnTypeOfSignature(signature), enclosingDeclaration, flags | 1024, tracker);
        }
        function createTypeOfExpression(exprIn, enclosingDeclaration, flags, tracker) {
          var expr = ts3.getParseTreeNode(exprIn, ts3.isExpression);
          if (!expr) {
            return ts3.factory.createToken(130);
          }
          var type2 = getWidenedType(getRegularTypeOfExpression(expr));
          return nodeBuilder.typeToTypeNode(type2, enclosingDeclaration, flags | 1024, tracker);
        }
        function hasGlobalName(name) {
          return globals.has(ts3.escapeLeadingUnderscores(name));
        }
        function getReferencedValueSymbol(reference, startInDeclarationContainer) {
          var resolvedSymbol = getNodeLinks(reference).resolvedSymbol;
          if (resolvedSymbol) {
            return resolvedSymbol;
          }
          var location = reference;
          if (startInDeclarationContainer) {
            var parent = reference.parent;
            if (ts3.isDeclaration(parent) && reference === parent.name) {
              location = getDeclarationContainer(parent);
            }
          }
          return resolveName(location, reference.escapedText, 111551 | 1048576 | 2097152, void 0, void 0, true);
        }
        function getReferencedValueDeclaration(referenceIn) {
          if (!ts3.isGeneratedIdentifier(referenceIn)) {
            var reference = ts3.getParseTreeNode(referenceIn, ts3.isIdentifier);
            if (reference) {
              var symbol = getReferencedValueSymbol(reference);
              if (symbol) {
                return getExportSymbolOfValueSymbolIfExported(symbol).valueDeclaration;
              }
            }
          }
          return void 0;
        }
        function isLiteralConstDeclaration(node) {
          if (ts3.isDeclarationReadonly(node) || ts3.isVariableDeclaration(node) && ts3.isVarConst(node)) {
            return isFreshLiteralType(getTypeOfSymbol(getSymbolOfNode(node)));
          }
          return false;
        }
        function literalTypeToNode(type2, enclosing, tracker) {
          var enumResult = type2.flags & 1024 ? nodeBuilder.symbolToExpression(type2.symbol, 111551, enclosing, void 0, tracker) : type2 === trueType ? ts3.factory.createTrue() : type2 === falseType && ts3.factory.createFalse();
          if (enumResult)
            return enumResult;
          var literalValue = type2.value;
          return typeof literalValue === "object" ? ts3.factory.createBigIntLiteral(literalValue) : typeof literalValue === "number" ? ts3.factory.createNumericLiteral(literalValue) : ts3.factory.createStringLiteral(literalValue);
        }
        function createLiteralConstValue(node, tracker) {
          var type2 = getTypeOfSymbol(getSymbolOfNode(node));
          return literalTypeToNode(type2, node, tracker);
        }
        function getJsxFactoryEntity(location) {
          return location ? (getJsxNamespace(location), ts3.getSourceFileOfNode(location).localJsxFactory || _jsxFactoryEntity) : _jsxFactoryEntity;
        }
        function getJsxFragmentFactoryEntity(location) {
          if (location) {
            var file = ts3.getSourceFileOfNode(location);
            if (file) {
              if (file.localJsxFragmentFactory) {
                return file.localJsxFragmentFactory;
              }
              var jsxFragPragmas = file.pragmas.get("jsxfrag");
              var jsxFragPragma = ts3.isArray(jsxFragPragmas) ? jsxFragPragmas[0] : jsxFragPragmas;
              if (jsxFragPragma) {
                file.localJsxFragmentFactory = ts3.parseIsolatedEntityName(jsxFragPragma.arguments.factory, languageVersion);
                return file.localJsxFragmentFactory;
              }
            }
          }
          if (compilerOptions.jsxFragmentFactory) {
            return ts3.parseIsolatedEntityName(compilerOptions.jsxFragmentFactory, languageVersion);
          }
        }
        function createResolver() {
          var resolvedTypeReferenceDirectives = host.getResolvedTypeReferenceDirectives();
          var fileToDirective;
          if (resolvedTypeReferenceDirectives) {
            fileToDirective = new ts3.Map();
            resolvedTypeReferenceDirectives.forEach(function(resolvedDirective, key, mode) {
              if (!resolvedDirective || !resolvedDirective.resolvedFileName) {
                return;
              }
              var file = host.getSourceFile(resolvedDirective.resolvedFileName);
              if (file) {
                addReferencedFilesToTypeDirective(file, key, mode);
              }
            });
          }
          return {
            getReferencedExportContainer,
            getReferencedImportDeclaration,
            getReferencedDeclarationWithCollidingName,
            isDeclarationWithCollidingName,
            isValueAliasDeclaration: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn);
              return node ? isValueAliasDeclaration(node) : true;
            },
            hasGlobalName,
            isReferencedAliasDeclaration: function(nodeIn, checkChildren) {
              var node = ts3.getParseTreeNode(nodeIn);
              return node ? isReferencedAliasDeclaration(node, checkChildren) : true;
            },
            getNodeCheckFlags: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn);
              return node ? getNodeCheckFlags(node) : 0;
            },
            isTopLevelValueImportEqualsWithEntityName,
            isDeclarationVisible,
            isImplementationOfOverload,
            isRequiredInitializedParameter,
            isOptionalUninitializedParameterProperty,
            isExpandoFunctionDeclaration,
            getPropertiesOfContainerFunction,
            createTypeOfDeclaration,
            createReturnTypeOfSignatureDeclaration,
            createTypeOfExpression,
            createLiteralConstValue,
            isSymbolAccessible,
            isEntityNameVisible,
            getConstantValue: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn, canHaveConstantValue);
              return node ? getConstantValue(node) : void 0;
            },
            collectLinkedAliases,
            getReferencedValueDeclaration,
            getTypeReferenceSerializationKind,
            isOptionalParameter,
            moduleExportsSomeValue,
            isArgumentsLocalBinding,
            getExternalModuleFileFromDeclaration: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn, ts3.hasPossibleExternalModuleReference);
              return node && getExternalModuleFileFromDeclaration(node);
            },
            getTypeReferenceDirectivesForEntityName,
            getTypeReferenceDirectivesForSymbol,
            isLiteralConstDeclaration,
            isLateBound: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn, ts3.isDeclaration);
              var symbol = node && getSymbolOfNode(node);
              return !!(symbol && ts3.getCheckFlags(symbol) & 4096);
            },
            getJsxFactoryEntity,
            getJsxFragmentFactoryEntity,
            getAllAccessorDeclarations: function(accessor) {
              accessor = ts3.getParseTreeNode(accessor, ts3.isGetOrSetAccessorDeclaration);
              var otherKind = accessor.kind === 173 ? 172 : 173;
              var otherAccessor = ts3.getDeclarationOfKind(getSymbolOfNode(accessor), otherKind);
              var firstAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? otherAccessor : accessor;
              var secondAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? accessor : otherAccessor;
              var setAccessor = accessor.kind === 173 ? accessor : otherAccessor;
              var getAccessor = accessor.kind === 172 ? accessor : otherAccessor;
              return {
                firstAccessor,
                secondAccessor,
                setAccessor,
                getAccessor
              };
            },
            getSymbolOfExternalModuleSpecifier: function(moduleName) {
              return resolveExternalModuleNameWorker(moduleName, moduleName, void 0);
            },
            isBindingCapturedByNode: function(node, decl) {
              var parseNode = ts3.getParseTreeNode(node);
              var parseDecl = ts3.getParseTreeNode(decl);
              return !!parseNode && !!parseDecl && (ts3.isVariableDeclaration(parseDecl) || ts3.isBindingElement(parseDecl)) && isBindingCapturedByNode(parseNode, parseDecl);
            },
            getDeclarationStatementsForSourceFile: function(node, flags, tracker, bundled) {
              var n = ts3.getParseTreeNode(node);
              ts3.Debug.assert(n && n.kind === 305, "Non-sourcefile node passed into getDeclarationsForSourceFile");
              var sym = getSymbolOfNode(node);
              if (!sym) {
                return !node.locals ? [] : nodeBuilder.symbolTableToDeclarationStatements(node.locals, node, flags, tracker, bundled);
              }
              return !sym.exports ? [] : nodeBuilder.symbolTableToDeclarationStatements(sym.exports, node, flags, tracker, bundled);
            },
            isImportRequiredByAugmentation
          };
          function isImportRequiredByAugmentation(node) {
            var file = ts3.getSourceFileOfNode(node);
            if (!file.symbol)
              return false;
            var importTarget = getExternalModuleFileFromDeclaration(node);
            if (!importTarget)
              return false;
            if (importTarget === file)
              return false;
            var exports2 = getExportsOfModule(file.symbol);
            for (var _i = 0, _a = ts3.arrayFrom(exports2.values()); _i < _a.length; _i++) {
              var s = _a[_i];
              if (s.mergeId) {
                var merged = getMergedSymbol(s);
                if (merged.declarations) {
                  for (var _b = 0, _c = merged.declarations; _b < _c.length; _b++) {
                    var d = _c[_b];
                    var declFile = ts3.getSourceFileOfNode(d);
                    if (declFile === importTarget) {
                      return true;
                    }
                  }
                }
              }
            }
            return false;
          }
          function isInHeritageClause(node) {
            return node.parent && node.parent.kind === 228 && node.parent.parent && node.parent.parent.kind === 291;
          }
          function getTypeReferenceDirectivesForEntityName(node) {
            if (!fileToDirective) {
              return void 0;
            }
            var meaning = 788968 | 1920;
            if (node.kind === 79 && isInTypeQuery(node) || node.kind === 206 && !isInHeritageClause(node)) {
              meaning = 111551 | 1048576;
            }
            var symbol = resolveEntityName(node, meaning, true);
            return symbol && symbol !== unknownSymbol ? getTypeReferenceDirectivesForSymbol(symbol, meaning) : void 0;
          }
          function getTypeReferenceDirectivesForSymbol(symbol, meaning) {
            if (!fileToDirective || !isSymbolFromTypeDeclarationFile(symbol)) {
              return void 0;
            }
            var typeReferenceDirectives;
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              if (decl.symbol && decl.symbol.flags & meaning) {
                var file = ts3.getSourceFileOfNode(decl);
                var typeReferenceDirective = fileToDirective.get(file.path);
                if (typeReferenceDirective) {
                  (typeReferenceDirectives || (typeReferenceDirectives = [])).push(typeReferenceDirective);
                } else {
                  return void 0;
                }
              }
            }
            return typeReferenceDirectives;
          }
          function isSymbolFromTypeDeclarationFile(symbol) {
            if (!symbol.declarations) {
              return false;
            }
            var current = symbol;
            while (true) {
              var parent = getParentOfSymbol(current);
              if (parent) {
                current = parent;
              } else {
                break;
              }
            }
            if (current.valueDeclaration && current.valueDeclaration.kind === 305 && current.flags & 512) {
              return false;
            }
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              var file = ts3.getSourceFileOfNode(decl);
              if (fileToDirective.has(file.path)) {
                return true;
              }
            }
            return false;
          }
          function addReferencedFilesToTypeDirective(file, key, mode) {
            if (fileToDirective.has(file.path))
              return;
            fileToDirective.set(file.path, [key, mode]);
            for (var _i = 0, _a = file.referencedFiles; _i < _a.length; _i++) {
              var _b = _a[_i], fileName2 = _b.fileName, resolutionMode = _b.resolutionMode;
              var resolvedFile = ts3.resolveTripleslashReference(fileName2, file.fileName);
              var referencedFile = host.getSourceFile(resolvedFile);
              if (referencedFile) {
                addReferencedFilesToTypeDirective(referencedFile, key, resolutionMode || file.impliedNodeFormat);
              }
            }
          }
        }
        function getExternalModuleFileFromDeclaration(declaration) {
          var specifier = declaration.kind === 261 ? ts3.tryCast(declaration.name, ts3.isStringLiteral) : ts3.getExternalModuleName(declaration);
          var moduleSymbol = resolveExternalModuleNameWorker(specifier, specifier, void 0);
          if (!moduleSymbol) {
            return void 0;
          }
          return ts3.getDeclarationOfKind(moduleSymbol, 305);
        }
        function initializeTypeChecker() {
          for (var _i = 0, _a = host.getSourceFiles(); _i < _a.length; _i++) {
            var file = _a[_i];
            ts3.bindSourceFile(file, compilerOptions);
          }
          amalgamatedDuplicates = new ts3.Map();
          var augmentations;
          for (var _b = 0, _c = host.getSourceFiles(); _b < _c.length; _b++) {
            var file = _c[_b];
            if (file.redirectInfo) {
              continue;
            }
            if (!ts3.isExternalOrCommonJsModule(file)) {
              var fileGlobalThisSymbol = file.locals.get("globalThis");
              if (fileGlobalThisSymbol === null || fileGlobalThisSymbol === void 0 ? void 0 : fileGlobalThisSymbol.declarations) {
                for (var _d = 0, _e = fileGlobalThisSymbol.declarations; _d < _e.length; _d++) {
                  var declaration = _e[_d];
                  diagnostics.add(ts3.createDiagnosticForNode(declaration, ts3.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0, "globalThis"));
                }
              }
              mergeSymbolTable(globals, file.locals);
            }
            if (file.jsGlobalAugmentations) {
              mergeSymbolTable(globals, file.jsGlobalAugmentations);
            }
            if (file.patternAmbientModules && file.patternAmbientModules.length) {
              patternAmbientModules = ts3.concatenate(patternAmbientModules, file.patternAmbientModules);
            }
            if (file.moduleAugmentations.length) {
              (augmentations || (augmentations = [])).push(file.moduleAugmentations);
            }
            if (file.symbol && file.symbol.globalExports) {
              var source = file.symbol.globalExports;
              source.forEach(function(sourceSymbol, id) {
                if (!globals.has(id)) {
                  globals.set(id, sourceSymbol);
                }
              });
            }
          }
          if (augmentations) {
            for (var _f = 0, augmentations_1 = augmentations; _f < augmentations_1.length; _f++) {
              var list = augmentations_1[_f];
              for (var _g = 0, list_1 = list; _g < list_1.length; _g++) {
                var augmentation = list_1[_g];
                if (!ts3.isGlobalScopeAugmentation(augmentation.parent))
                  continue;
                mergeModuleAugmentation(augmentation);
              }
            }
          }
          addToSymbolTable(globals, builtinGlobals, ts3.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0);
          getSymbolLinks(undefinedSymbol).type = undefinedWideningType;
          getSymbolLinks(argumentsSymbol).type = getGlobalType("IArguments", 0, true);
          getSymbolLinks(unknownSymbol).type = errorType;
          getSymbolLinks(globalThisSymbol).type = createObjectType(16, globalThisSymbol);
          globalArrayType = getGlobalType("Array", 1, true);
          globalObjectType = getGlobalType("Object", 0, true);
          globalFunctionType = getGlobalType("Function", 0, true);
          globalCallableFunctionType = strictBindCallApply && getGlobalType("CallableFunction", 0, true) || globalFunctionType;
          globalNewableFunctionType = strictBindCallApply && getGlobalType("NewableFunction", 0, true) || globalFunctionType;
          globalStringType = getGlobalType("String", 0, true);
          globalNumberType = getGlobalType("Number", 0, true);
          globalBooleanType = getGlobalType("Boolean", 0, true);
          globalRegExpType = getGlobalType("RegExp", 0, true);
          anyArrayType = createArrayType(anyType);
          autoArrayType = createArrayType(autoType);
          if (autoArrayType === emptyObjectType) {
            autoArrayType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, ts3.emptyArray);
          }
          globalReadonlyArrayType = getGlobalTypeOrUndefined("ReadonlyArray", 1) || globalArrayType;
          anyReadonlyArrayType = globalReadonlyArrayType ? createTypeFromGenericGlobalType(globalReadonlyArrayType, [anyType]) : anyArrayType;
          globalThisType = getGlobalTypeOrUndefined("ThisType", 1);
          if (augmentations) {
            for (var _h = 0, augmentations_2 = augmentations; _h < augmentations_2.length; _h++) {
              var list = augmentations_2[_h];
              for (var _j = 0, list_2 = list; _j < list_2.length; _j++) {
                var augmentation = list_2[_j];
                if (ts3.isGlobalScopeAugmentation(augmentation.parent))
                  continue;
                mergeModuleAugmentation(augmentation);
              }
            }
          }
          amalgamatedDuplicates.forEach(function(_a2) {
            var firstFile = _a2.firstFile, secondFile = _a2.secondFile, conflictingSymbols = _a2.conflictingSymbols;
            if (conflictingSymbols.size < 8) {
              conflictingSymbols.forEach(function(_a3, symbolName) {
                var isBlockScoped = _a3.isBlockScoped, firstFileLocations = _a3.firstFileLocations, secondFileLocations = _a3.secondFileLocations;
                var message = isBlockScoped ? ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts3.Diagnostics.Duplicate_identifier_0;
                for (var _i2 = 0, firstFileLocations_1 = firstFileLocations; _i2 < firstFileLocations_1.length; _i2++) {
                  var node = firstFileLocations_1[_i2];
                  addDuplicateDeclarationError(node, message, symbolName, secondFileLocations);
                }
                for (var _b2 = 0, secondFileLocations_1 = secondFileLocations; _b2 < secondFileLocations_1.length; _b2++) {
                  var node = secondFileLocations_1[_b2];
                  addDuplicateDeclarationError(node, message, symbolName, firstFileLocations);
                }
              });
            } else {
              var list2 = ts3.arrayFrom(conflictingSymbols.keys()).join(", ");
              diagnostics.add(ts3.addRelatedInfo(ts3.createDiagnosticForNode(firstFile, ts3.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list2), ts3.createDiagnosticForNode(secondFile, ts3.Diagnostics.Conflicts_are_in_this_file)));
              diagnostics.add(ts3.addRelatedInfo(ts3.createDiagnosticForNode(secondFile, ts3.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list2), ts3.createDiagnosticForNode(firstFile, ts3.Diagnostics.Conflicts_are_in_this_file)));
            }
          });
          amalgamatedDuplicates = void 0;
        }
        function checkExternalEmitHelpers(location, helpers) {
          if ((requestedExternalEmitHelpers & helpers) !== helpers && compilerOptions.importHelpers) {
            var sourceFile = ts3.getSourceFileOfNode(location);
            if (ts3.isEffectiveExternalModule(sourceFile, compilerOptions) && !(location.flags & 16777216)) {
              var helpersModule = resolveHelpersModule(sourceFile, location);
              if (helpersModule !== unknownSymbol) {
                var uncheckedHelpers = helpers & ~requestedExternalEmitHelpers;
                for (var helper = 1; helper <= 4194304; helper <<= 1) {
                  if (uncheckedHelpers & helper) {
                    var name = getHelperName(helper);
                    var symbol = getSymbol(helpersModule.exports, ts3.escapeLeadingUnderscores(name), 111551);
                    if (!symbol) {
                      error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name);
                    } else if (helper & 524288) {
                      if (!ts3.some(getSignaturesOfSymbol(symbol), function(signature) {
                        return getParameterCount(signature) > 3;
                      })) {
                        error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name, 4);
                      }
                    } else if (helper & 1048576) {
                      if (!ts3.some(getSignaturesOfSymbol(symbol), function(signature) {
                        return getParameterCount(signature) > 4;
                      })) {
                        error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name, 5);
                      }
                    } else if (helper & 1024) {
                      if (!ts3.some(getSignaturesOfSymbol(symbol), function(signature) {
                        return getParameterCount(signature) > 2;
                      })) {
                        error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name, 3);
                      }
                    }
                  }
                }
              }
              requestedExternalEmitHelpers |= helpers;
            }
          }
        }
        function getHelperName(helper) {
          switch (helper) {
            case 1:
              return "__extends";
            case 2:
              return "__assign";
            case 4:
              return "__rest";
            case 8:
              return "__decorate";
            case 16:
              return "__metadata";
            case 32:
              return "__param";
            case 64:
              return "__awaiter";
            case 128:
              return "__generator";
            case 256:
              return "__values";
            case 512:
              return "__read";
            case 1024:
              return "__spreadArray";
            case 2048:
              return "__await";
            case 4096:
              return "__asyncGenerator";
            case 8192:
              return "__asyncDelegator";
            case 16384:
              return "__asyncValues";
            case 32768:
              return "__exportStar";
            case 65536:
              return "__importStar";
            case 131072:
              return "__importDefault";
            case 262144:
              return "__makeTemplateObject";
            case 524288:
              return "__classPrivateFieldGet";
            case 1048576:
              return "__classPrivateFieldSet";
            case 2097152:
              return "__classPrivateFieldIn";
            case 4194304:
              return "__createBinding";
            default:
              return ts3.Debug.fail("Unrecognized helper");
          }
        }
        function resolveHelpersModule(node, errorNode) {
          if (!externalHelpersModule) {
            externalHelpersModule = resolveExternalModule(node, ts3.externalHelpersModuleNameText, ts3.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found, errorNode) || unknownSymbol;
          }
          return externalHelpersModule;
        }
        function checkGrammarDecoratorsAndModifiers(node) {
          return checkGrammarDecorators(node) || checkGrammarModifiers(node);
        }
        function checkGrammarDecorators(node) {
          if (!node.decorators) {
            return false;
          }
          if (!ts3.nodeCanBeDecorated(node, node.parent, node.parent.parent)) {
            if (node.kind === 169 && !ts3.nodeIsPresent(node.body)) {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);
            } else {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.Decorators_are_not_valid_here);
            }
          } else if (node.kind === 172 || node.kind === 173) {
            var accessors = ts3.getAllAccessorDeclarations(node.parent.members, node);
            if (accessors.firstAccessor.decorators && node === accessors.secondAccessor) {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
            }
          }
          return false;
        }
        function checkGrammarModifiers(node) {
          var quickResult = reportObviousModifierErrors(node);
          if (quickResult !== void 0) {
            return quickResult;
          }
          var lastStatic, lastDeclare, lastAsync, lastOverride;
          var flags = 0;
          for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
            var modifier = _a[_i];
            if (modifier.kind !== 145) {
              if (node.kind === 166 || node.kind === 168) {
                return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_type_member, ts3.tokenToString(modifier.kind));
              }
              if (node.kind === 176 && (modifier.kind !== 124 || !ts3.isClassLike(node.parent))) {
                return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_an_index_signature, ts3.tokenToString(modifier.kind));
              }
            }
            if (modifier.kind !== 101 && modifier.kind !== 144) {
              if (node.kind === 163) {
                return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_type_parameter, ts3.tokenToString(modifier.kind));
              }
            }
            switch (modifier.kind) {
              case 85:
                if (node.kind !== 260) {
                  return grammarErrorOnNode(node, ts3.Diagnostics.A_class_member_cannot_have_the_0_keyword, ts3.tokenToString(85));
                }
                break;
              case 159:
                if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "override");
                } else if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "override", "declare");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "override", "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "override", "async");
                }
                flags |= 16384;
                lastOverride = modifier;
                break;
              case 123:
              case 122:
              case 121:
                var text = visibilityToString(ts3.modifierToFlag(modifier.kind));
                if (flags & 28) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.Accessibility_modifier_already_seen);
                } else if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "override");
                } else if (flags & 32) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "static");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "async");
                } else if (node.parent.kind === 262 || node.parent.kind === 305) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, text);
                } else if (flags & 128) {
                  if (modifier.kind === 121) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, text, "abstract");
                  } else {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "abstract");
                  }
                } else if (ts3.isPrivateIdentifierClassElementDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
                }
                flags |= ts3.modifierToFlag(modifier.kind);
                break;
              case 124:
                if (flags & 32) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "static");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
                } else if (node.parent.kind === 262 || node.parent.kind === 305) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
                } else if (node.kind === 164) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
                } else if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                } else if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "static", "override");
                }
                flags |= 32;
                lastStatic = modifier;
                break;
              case 145:
                if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "readonly");
                } else if (node.kind !== 167 && node.kind !== 166 && node.kind !== 176 && node.kind !== 164) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
                }
                flags |= 64;
                break;
              case 93:
                if (flags & 1) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "export");
                } else if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
                } else if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
                } else if (ts3.isClassLike(node.parent)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "export");
                } else if (node.kind === 164) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
                }
                flags |= 1;
                break;
              case 88:
                var container = node.parent.kind === 305 ? node.parent : node.parent.parent;
                if (container.kind === 261 && !ts3.isAmbientModule(container)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                } else if (!(flags & 1)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "default");
                }
                flags |= 512;
                break;
              case 135:
                if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "declare");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                } else if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "override");
                } else if (ts3.isClassLike(node.parent) && !ts3.isPropertyDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "declare");
                } else if (node.kind === 164) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
                } else if (node.parent.flags & 16777216 && node.parent.kind === 262) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
                } else if (ts3.isPrivateIdentifierClassElementDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "declare");
                }
                flags |= 2;
                lastDeclare = modifier;
                break;
              case 126:
                if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "abstract");
                }
                if (node.kind !== 257 && node.kind !== 180) {
                  if (node.kind !== 169 && node.kind !== 167 && node.kind !== 172 && node.kind !== 173) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
                  }
                  if (!(node.parent.kind === 257 && ts3.hasSyntacticModifier(node.parent, 128))) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);
                  }
                  if (flags & 32) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                  }
                  if (flags & 8) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
                  }
                  if (flags & 256 && lastAsync) {
                    return grammarErrorOnNode(lastAsync, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                  }
                  if (flags & 16384) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "abstract", "override");
                  }
                }
                if (ts3.isNamedDeclaration(node) && node.name.kind === 80) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "abstract");
                }
                flags |= 128;
                break;
              case 131:
                if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "async");
                } else if (flags & 2 || node.parent.flags & 16777216) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                } else if (node.kind === 164) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
                }
                if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                }
                flags |= 256;
                lastAsync = modifier;
                break;
              case 101:
              case 144:
                var inOutFlag = modifier.kind === 101 ? 32768 : 65536;
                var inOutText = modifier.kind === 101 ? "in" : "out";
                if (node.kind !== 163 || !(ts3.isInterfaceDeclaration(node.parent) || ts3.isClassLike(node.parent) || ts3.isTypeAliasDeclaration(node.parent))) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias, inOutText);
                }
                if (flags & inOutFlag) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, inOutText);
                }
                if (inOutFlag & 32768 && flags & 65536) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "in", "out");
                }
                flags |= inOutFlag;
                break;
            }
          }
          if (node.kind === 171) {
            if (flags & 32) {
              return grammarErrorOnNode(lastStatic, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static");
            }
            if (flags & 16384) {
              return grammarErrorOnNode(lastOverride, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "override");
            }
            if (flags & 256) {
              return grammarErrorOnNode(lastAsync, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async");
            }
            return false;
          } else if ((node.kind === 266 || node.kind === 265) && flags & 2) {
            return grammarErrorOnNode(lastDeclare, ts3.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare");
          } else if (node.kind === 164 && flags & 16476 && ts3.isBindingPattern(node.name)) {
            return grammarErrorOnNode(node, ts3.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern);
          } else if (node.kind === 164 && flags & 16476 && node.dotDotDotToken) {
            return grammarErrorOnNode(node, ts3.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter);
          }
          if (flags & 256) {
            return checkGrammarAsyncModifier(node, lastAsync);
          }
          return false;
        }
        function reportObviousModifierErrors(node) {
          return !node.modifiers ? false : shouldReportBadModifier(node) ? grammarErrorOnFirstToken(node, ts3.Diagnostics.Modifiers_cannot_appear_here) : void 0;
        }
        function shouldReportBadModifier(node) {
          switch (node.kind) {
            case 172:
            case 173:
            case 171:
            case 167:
            case 166:
            case 169:
            case 168:
            case 176:
            case 261:
            case 266:
            case 265:
            case 272:
            case 271:
            case 213:
            case 214:
            case 164:
            case 163:
              return false;
            default:
              if (node.parent.kind === 262 || node.parent.kind === 305) {
                return false;
              }
              switch (node.kind) {
                case 256:
                  return nodeHasAnyModifiersExcept(node, 131);
                case 257:
                case 180:
                  return nodeHasAnyModifiersExcept(node, 126);
                case 258:
                case 237:
                case 259:
                case 170:
                  return true;
                case 260:
                  return nodeHasAnyModifiersExcept(node, 85);
                default:
                  ts3.Debug.fail();
              }
          }
        }
        function nodeHasAnyModifiersExcept(node, allowedModifier) {
          return node.modifiers.length > 1 || node.modifiers[0].kind !== allowedModifier;
        }
        function checkGrammarAsyncModifier(node, asyncModifier) {
          switch (node.kind) {
            case 169:
            case 256:
            case 213:
            case 214:
              return false;
          }
          return grammarErrorOnNode(asyncModifier, ts3.Diagnostics._0_modifier_cannot_be_used_here, "async");
        }
        function checkGrammarForDisallowedTrailingComma(list, diag) {
          if (diag === void 0) {
            diag = ts3.Diagnostics.Trailing_comma_not_allowed;
          }
          if (list && list.hasTrailingComma) {
            return grammarErrorAtPos(list[0], list.end - ",".length, ",".length, diag);
          }
          return false;
        }
        function checkGrammarTypeParameterList(typeParameters, file) {
          if (typeParameters && typeParameters.length === 0) {
            var start = typeParameters.pos - "<".length;
            var end = ts3.skipTrivia(file.text, typeParameters.end) + ">".length;
            return grammarErrorAtPos(file, start, end - start, ts3.Diagnostics.Type_parameter_list_cannot_be_empty);
          }
          return false;
        }
        function checkGrammarParameterList(parameters) {
          var seenOptionalParameter = false;
          var parameterCount = parameters.length;
          for (var i = 0; i < parameterCount; i++) {
            var parameter = parameters[i];
            if (parameter.dotDotDotToken) {
              if (i !== parameterCount - 1) {
                return grammarErrorOnNode(parameter.dotDotDotToken, ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
              }
              if (!(parameter.flags & 16777216)) {
                checkGrammarForDisallowedTrailingComma(parameters, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
              }
              if (parameter.questionToken) {
                return grammarErrorOnNode(parameter.questionToken, ts3.Diagnostics.A_rest_parameter_cannot_be_optional);
              }
              if (parameter.initializer) {
                return grammarErrorOnNode(parameter.name, ts3.Diagnostics.A_rest_parameter_cannot_have_an_initializer);
              }
            } else if (isOptionalParameter(parameter)) {
              seenOptionalParameter = true;
              if (parameter.questionToken && parameter.initializer) {
                return grammarErrorOnNode(parameter.name, ts3.Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
              }
            } else if (seenOptionalParameter && !parameter.initializer) {
              return grammarErrorOnNode(parameter.name, ts3.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
            }
          }
        }
        function getNonSimpleParameters(parameters) {
          return ts3.filter(parameters, function(parameter) {
            return !!parameter.initializer || ts3.isBindingPattern(parameter.name) || ts3.isRestParameter(parameter);
          });
        }
        function checkGrammarForUseStrictSimpleParameterList(node) {
          if (languageVersion >= 3) {
            var useStrictDirective_1 = node.body && ts3.isBlock(node.body) && ts3.findUseStrictPrologue(node.body.statements);
            if (useStrictDirective_1) {
              var nonSimpleParameters = getNonSimpleParameters(node.parameters);
              if (ts3.length(nonSimpleParameters)) {
                ts3.forEach(nonSimpleParameters, function(parameter) {
                  ts3.addRelatedInfo(error(parameter, ts3.Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive), ts3.createDiagnosticForNode(useStrictDirective_1, ts3.Diagnostics.use_strict_directive_used_here));
                });
                var diagnostics_2 = nonSimpleParameters.map(function(parameter, index) {
                  return index === 0 ? ts3.createDiagnosticForNode(parameter, ts3.Diagnostics.Non_simple_parameter_declared_here) : ts3.createDiagnosticForNode(parameter, ts3.Diagnostics.and_here);
                });
                ts3.addRelatedInfo.apply(void 0, __spreadArray([error(useStrictDirective_1, ts3.Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list)], diagnostics_2, false));
                return true;
              }
            }
          }
          return false;
        }
        function checkGrammarFunctionLikeDeclaration(node) {
          var file = ts3.getSourceFileOfNode(node);
          return checkGrammarDecoratorsAndModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) || checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file) || ts3.isFunctionLikeDeclaration(node) && checkGrammarForUseStrictSimpleParameterList(node);
        }
        function checkGrammarClassLikeDeclaration(node) {
          var file = ts3.getSourceFileOfNode(node);
          return checkGrammarClassDeclarationHeritageClauses(node) || checkGrammarTypeParameterList(node.typeParameters, file);
        }
        function checkGrammarArrowFunction(node, file) {
          if (!ts3.isArrowFunction(node)) {
            return false;
          }
          if (node.typeParameters && !(ts3.length(node.typeParameters) > 1 || node.typeParameters.hasTrailingComma || node.typeParameters[0].constraint)) {
            if (file && ts3.fileExtensionIsOneOf(file.fileName, [".mts", ".cts"])) {
              grammarErrorOnNode(node.typeParameters[0], ts3.Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint);
            }
          }
          var equalsGreaterThanToken = node.equalsGreaterThanToken;
          var startLine = ts3.getLineAndCharacterOfPosition(file, equalsGreaterThanToken.pos).line;
          var endLine = ts3.getLineAndCharacterOfPosition(file, equalsGreaterThanToken.end).line;
          return startLine !== endLine && grammarErrorOnNode(equalsGreaterThanToken, ts3.Diagnostics.Line_terminator_not_permitted_before_arrow);
        }
        function checkGrammarIndexSignatureParameters(node) {
          var parameter = node.parameters[0];
          if (node.parameters.length !== 1) {
            if (parameter) {
              return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
            } else {
              return grammarErrorOnNode(node, ts3.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
            }
          }
          checkGrammarForDisallowedTrailingComma(node.parameters, ts3.Diagnostics.An_index_signature_cannot_have_a_trailing_comma);
          if (parameter.dotDotDotToken) {
            return grammarErrorOnNode(parameter.dotDotDotToken, ts3.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);
          }
          if (ts3.hasEffectiveModifiers(parameter)) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);
          }
          if (parameter.questionToken) {
            return grammarErrorOnNode(parameter.questionToken, ts3.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);
          }
          if (parameter.initializer) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);
          }
          if (!parameter.type) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);
          }
          var type2 = getTypeFromTypeNode(parameter.type);
          if (someType(type2, function(t) {
            return !!(t.flags & 8576);
          }) || isGenericType(type2)) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead);
          }
          if (!everyType(type2, isValidIndexKeyType)) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type);
          }
          if (!node.type) {
            return grammarErrorOnNode(node, ts3.Diagnostics.An_index_signature_must_have_a_type_annotation);
          }
          return false;
        }
        function checkGrammarIndexSignature(node) {
          return checkGrammarDecoratorsAndModifiers(node) || checkGrammarIndexSignatureParameters(node);
        }
        function checkGrammarForAtLeastOneTypeArgument(node, typeArguments) {
          if (typeArguments && typeArguments.length === 0) {
            var sourceFile = ts3.getSourceFileOfNode(node);
            var start = typeArguments.pos - "<".length;
            var end = ts3.skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
            return grammarErrorAtPos(sourceFile, start, end - start, ts3.Diagnostics.Type_argument_list_cannot_be_empty);
          }
          return false;
        }
        function checkGrammarTypeArguments(node, typeArguments) {
          return checkGrammarForDisallowedTrailingComma(typeArguments) || checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
        }
        function checkGrammarTaggedTemplateChain(node) {
          if (node.questionDotToken || node.flags & 32) {
            return grammarErrorOnNode(node.template, ts3.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain);
          }
          return false;
        }
        function checkGrammarHeritageClause(node) {
          var types2 = node.types;
          if (checkGrammarForDisallowedTrailingComma(types2)) {
            return true;
          }
          if (types2 && types2.length === 0) {
            var listType = ts3.tokenToString(node.token);
            return grammarErrorAtPos(node, types2.pos, 0, ts3.Diagnostics._0_list_cannot_be_empty, listType);
          }
          return ts3.some(types2, checkGrammarExpressionWithTypeArguments);
        }
        function checkGrammarExpressionWithTypeArguments(node) {
          if (ts3.isExpressionWithTypeArguments(node) && ts3.isImportKeyword(node.expression) && node.typeArguments) {
            return grammarErrorOnNode(node, ts3.Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);
          }
          return checkGrammarTypeArguments(node, node.typeArguments);
        }
        function checkGrammarClassDeclarationHeritageClauses(node) {
          var seenExtendsClause = false;
          var seenImplementsClause = false;
          if (!checkGrammarDecoratorsAndModifiers(node) && node.heritageClauses) {
            for (var _i = 0, _a = node.heritageClauses; _i < _a.length; _i++) {
              var heritageClause = _a[_i];
              if (heritageClause.token === 94) {
                if (seenExtendsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.extends_clause_already_seen);
                }
                if (seenImplementsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.extends_clause_must_precede_implements_clause);
                }
                if (heritageClause.types.length > 1) {
                  return grammarErrorOnFirstToken(heritageClause.types[1], ts3.Diagnostics.Classes_can_only_extend_a_single_class);
                }
                seenExtendsClause = true;
              } else {
                ts3.Debug.assert(heritageClause.token === 117);
                if (seenImplementsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.implements_clause_already_seen);
                }
                seenImplementsClause = true;
              }
              checkGrammarHeritageClause(heritageClause);
            }
          }
        }
        function checkGrammarInterfaceDeclaration(node) {
          var seenExtendsClause = false;
          if (node.heritageClauses) {
            for (var _i = 0, _a = node.heritageClauses; _i < _a.length; _i++) {
              var heritageClause = _a[_i];
              if (heritageClause.token === 94) {
                if (seenExtendsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.extends_clause_already_seen);
                }
                seenExtendsClause = true;
              } else {
                ts3.Debug.assert(heritageClause.token === 117);
                return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.Interface_declaration_cannot_have_implements_clause);
              }
              checkGrammarHeritageClause(heritageClause);
            }
          }
          return false;
        }
        function checkGrammarComputedPropertyName(node) {
          if (node.kind !== 162) {
            return false;
          }
          var computedPropertyName = node;
          if (computedPropertyName.expression.kind === 221 && computedPropertyName.expression.operatorToken.kind === 27) {
            return grammarErrorOnNode(computedPropertyName.expression, ts3.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
          }
          return false;
        }
        function checkGrammarForGenerator(node) {
          if (node.asteriskToken) {
            ts3.Debug.assert(node.kind === 256 || node.kind === 213 || node.kind === 169);
            if (node.flags & 16777216) {
              return grammarErrorOnNode(node.asteriskToken, ts3.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);
            }
            if (!node.body) {
              return grammarErrorOnNode(node.asteriskToken, ts3.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);
            }
          }
        }
        function checkGrammarForInvalidQuestionMark(questionToken, message) {
          return !!questionToken && grammarErrorOnNode(questionToken, message);
        }
        function checkGrammarForInvalidExclamationToken(exclamationToken, message) {
          return !!exclamationToken && grammarErrorOnNode(exclamationToken, message);
        }
        function checkGrammarObjectLiteralExpression(node, inDestructuring) {
          var seen = new ts3.Map();
          for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
            var prop = _a[_i];
            if (prop.kind === 298) {
              if (inDestructuring) {
                var expression = ts3.skipParentheses(prop.expression);
                if (ts3.isArrayLiteralExpression(expression) || ts3.isObjectLiteralExpression(expression)) {
                  return grammarErrorOnNode(prop.expression, ts3.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
                }
              }
              continue;
            }
            var name = prop.name;
            if (name.kind === 162) {
              checkGrammarComputedPropertyName(name);
            }
            if (prop.kind === 297 && !inDestructuring && prop.objectAssignmentInitializer) {
              grammarErrorOnNode(prop.equalsToken, ts3.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern);
            }
            if (name.kind === 80) {
              grammarErrorOnNode(name, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
            }
            if (prop.modifiers) {
              for (var _b = 0, _c = prop.modifiers; _b < _c.length; _b++) {
                var mod = _c[_b];
                if (mod.kind !== 131 || prop.kind !== 169) {
                  grammarErrorOnNode(mod, ts3.Diagnostics._0_modifier_cannot_be_used_here, ts3.getTextOfNode(mod));
                }
              }
            }
            var currentKind = void 0;
            switch (prop.kind) {
              case 297:
                checkGrammarForInvalidExclamationToken(prop.exclamationToken, ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
              case 296:
                checkGrammarForInvalidQuestionMark(prop.questionToken, ts3.Diagnostics.An_object_member_cannot_be_declared_optional);
                if (name.kind === 8) {
                  checkGrammarNumericLiteral(name);
                }
                currentKind = 4;
                break;
              case 169:
                currentKind = 8;
                break;
              case 172:
                currentKind = 1;
                break;
              case 173:
                currentKind = 2;
                break;
              default:
                throw ts3.Debug.assertNever(prop, "Unexpected syntax kind:" + prop.kind);
            }
            if (!inDestructuring) {
              var effectiveName = ts3.getPropertyNameForPropertyNameNode(name);
              if (effectiveName === void 0) {
                continue;
              }
              var existingKind = seen.get(effectiveName);
              if (!existingKind) {
                seen.set(effectiveName, currentKind);
              } else {
                if (currentKind & 8 && existingKind & 8) {
                  grammarErrorOnNode(name, ts3.Diagnostics.Duplicate_identifier_0, ts3.getTextOfNode(name));
                } else if (currentKind & 4 && existingKind & 4) {
                  grammarErrorOnNode(name, ts3.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name, ts3.getTextOfNode(name));
                } else if (currentKind & 3 && existingKind & 3) {
                  if (existingKind !== 3 && currentKind !== existingKind) {
                    seen.set(effectiveName, currentKind | existingKind);
                  } else {
                    return grammarErrorOnNode(name, ts3.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);
                  }
                } else {
                  return grammarErrorOnNode(name, ts3.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);
                }
              }
            }
          }
        }
        function checkGrammarJsxElement(node) {
          checkGrammarJsxName(node.tagName);
          checkGrammarTypeArguments(node, node.typeArguments);
          var seen = new ts3.Map();
          for (var _i = 0, _a = node.attributes.properties; _i < _a.length; _i++) {
            var attr = _a[_i];
            if (attr.kind === 287) {
              continue;
            }
            var name = attr.name, initializer = attr.initializer;
            if (!seen.get(name.escapedText)) {
              seen.set(name.escapedText, true);
            } else {
              return grammarErrorOnNode(name, ts3.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);
            }
            if (initializer && initializer.kind === 288 && !initializer.expression) {
              return grammarErrorOnNode(initializer, ts3.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression);
            }
          }
        }
        function checkGrammarJsxName(node) {
          if (ts3.isPropertyAccessExpression(node)) {
            var propName = node;
            do {
              var check_1 = checkGrammarJsxNestedIdentifier(propName.name);
              if (check_1) {
                return check_1;
              }
              propName = propName.expression;
            } while (ts3.isPropertyAccessExpression(propName));
            var check = checkGrammarJsxNestedIdentifier(propName);
            if (check) {
              return check;
            }
          }
          function checkGrammarJsxNestedIdentifier(name) {
            if (ts3.isIdentifier(name) && ts3.idText(name).indexOf(":") !== -1) {
              return grammarErrorOnNode(name, ts3.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names);
            }
          }
        }
        function checkGrammarJsxExpression(node) {
          if (node.expression && ts3.isCommaSequence(node.expression)) {
            return grammarErrorOnNode(node.expression, ts3.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array);
          }
        }
        function checkGrammarForInOrForOfStatement(forInOrOfStatement) {
          if (checkGrammarStatementInAmbientContext(forInOrOfStatement)) {
            return true;
          }
          if (forInOrOfStatement.kind === 244 && forInOrOfStatement.awaitModifier) {
            if (!(forInOrOfStatement.flags & 32768)) {
              var sourceFile = ts3.getSourceFileOfNode(forInOrOfStatement);
              if (ts3.isInTopLevelContext(forInOrOfStatement)) {
                if (!hasParseDiagnostics(sourceFile)) {
                  if (!ts3.isEffectiveExternalModule(sourceFile, compilerOptions)) {
                    diagnostics.add(ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module));
                  }
                  switch (moduleKind) {
                    case ts3.ModuleKind.Node16:
                    case ts3.ModuleKind.NodeNext:
                      if (sourceFile.impliedNodeFormat === ts3.ModuleKind.CommonJS) {
                        diagnostics.add(ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));
                        break;
                      }
                    case ts3.ModuleKind.ES2022:
                    case ts3.ModuleKind.ESNext:
                    case ts3.ModuleKind.System:
                      if (languageVersion >= 4) {
                        break;
                      }
                    default:
                      diagnostics.add(ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher));
                      break;
                  }
                }
              } else {
                if (!hasParseDiagnostics(sourceFile)) {
                  var diagnostic = ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                  var func = ts3.getContainingFunction(forInOrOfStatement);
                  if (func && func.kind !== 171) {
                    ts3.Debug.assert((ts3.getFunctionFlags(func) & 2) === 0, "Enclosing function should never be an async function.");
                    var relatedInfo = ts3.createDiagnosticForNode(func, ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                    ts3.addRelatedInfo(diagnostic, relatedInfo);
                  }
                  diagnostics.add(diagnostic);
                  return true;
                }
              }
              return false;
            }
          }
          if (ts3.isForOfStatement(forInOrOfStatement) && !(forInOrOfStatement.flags & 32768) && ts3.isIdentifier(forInOrOfStatement.initializer) && forInOrOfStatement.initializer.escapedText === "async") {
            grammarErrorOnNode(forInOrOfStatement.initializer, ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async);
            return false;
          }
          if (forInOrOfStatement.initializer.kind === 255) {
            var variableList = forInOrOfStatement.initializer;
            if (!checkGrammarVariableDeclarationList(variableList)) {
              var declarations = variableList.declarations;
              if (!declarations.length) {
                return false;
              }
              if (declarations.length > 1) {
                var diagnostic = forInOrOfStatement.kind === 243 ? ts3.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement : ts3.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;
                return grammarErrorOnFirstToken(variableList.declarations[1], diagnostic);
              }
              var firstDeclaration = declarations[0];
              if (firstDeclaration.initializer) {
                var diagnostic = forInOrOfStatement.kind === 243 ? ts3.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer : ts3.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;
                return grammarErrorOnNode(firstDeclaration.name, diagnostic);
              }
              if (firstDeclaration.type) {
                var diagnostic = forInOrOfStatement.kind === 243 ? ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation : ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;
                return grammarErrorOnNode(firstDeclaration, diagnostic);
              }
            }
          }
          return false;
        }
        function checkGrammarAccessor(accessor) {
          if (!(accessor.flags & 16777216) && accessor.parent.kind !== 182 && accessor.parent.kind !== 258) {
            if (languageVersion < 1) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);
            }
            if (languageVersion < 2 && ts3.isPrivateIdentifier(accessor.name)) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
            if (accessor.body === void 0 && !ts3.hasSyntacticModifier(accessor, 128)) {
              return grammarErrorAtPos(accessor, accessor.end - 1, ";".length, ts3.Diagnostics._0_expected, "{");
            }
          }
          if (accessor.body) {
            if (ts3.hasSyntacticModifier(accessor, 128)) {
              return grammarErrorOnNode(accessor, ts3.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);
            }
            if (accessor.parent.kind === 182 || accessor.parent.kind === 258) {
              return grammarErrorOnNode(accessor.body, ts3.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
            }
          }
          if (accessor.typeParameters) {
            return grammarErrorOnNode(accessor.name, ts3.Diagnostics.An_accessor_cannot_have_type_parameters);
          }
          if (!doesAccessorHaveCorrectParameterCount(accessor)) {
            return grammarErrorOnNode(accessor.name, accessor.kind === 172 ? ts3.Diagnostics.A_get_accessor_cannot_have_parameters : ts3.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);
          }
          if (accessor.kind === 173) {
            if (accessor.type) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);
            }
            var parameter = ts3.Debug.checkDefined(ts3.getSetAccessorValueParameter(accessor), "Return value does not match parameter count assertion.");
            if (parameter.dotDotDotToken) {
              return grammarErrorOnNode(parameter.dotDotDotToken, ts3.Diagnostics.A_set_accessor_cannot_have_rest_parameter);
            }
            if (parameter.questionToken) {
              return grammarErrorOnNode(parameter.questionToken, ts3.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);
            }
            if (parameter.initializer) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer);
            }
          }
          return false;
        }
        function doesAccessorHaveCorrectParameterCount(accessor) {
          return getAccessorThisParameter(accessor) || accessor.parameters.length === (accessor.kind === 172 ? 0 : 1);
        }
        function getAccessorThisParameter(accessor) {
          if (accessor.parameters.length === (accessor.kind === 172 ? 1 : 2)) {
            return ts3.getThisParameter(accessor);
          }
        }
        function checkGrammarTypeOperatorNode(node) {
          if (node.operator === 154) {
            if (node.type.kind !== 151) {
              return grammarErrorOnNode(node.type, ts3.Diagnostics._0_expected, ts3.tokenToString(151));
            }
            var parent = ts3.walkUpParenthesizedTypes(node.parent);
            if (ts3.isInJSFile(parent) && ts3.isJSDocTypeExpression(parent)) {
              var host_2 = ts3.getJSDocHost(parent);
              if (host_2) {
                parent = ts3.getSingleVariableOfVariableStatement(host_2) || host_2;
              }
            }
            switch (parent.kind) {
              case 254:
                var decl = parent;
                if (decl.name.kind !== 79) {
                  return grammarErrorOnNode(node, ts3.Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
                }
                if (!ts3.isVariableDeclarationInVariableStatement(decl)) {
                  return grammarErrorOnNode(node, ts3.Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);
                }
                if (!(decl.parent.flags & 2)) {
                  return grammarErrorOnNode(parent.name, ts3.Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);
                }
                break;
              case 167:
                if (!ts3.isStatic(parent) || !ts3.hasEffectiveReadonlyModifier(parent)) {
                  return grammarErrorOnNode(parent.name, ts3.Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);
                }
                break;
              case 166:
                if (!ts3.hasSyntacticModifier(parent, 64)) {
                  return grammarErrorOnNode(parent.name, ts3.Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);
                }
                break;
              default:
                return grammarErrorOnNode(node, ts3.Diagnostics.unique_symbol_types_are_not_allowed_here);
            }
          } else if (node.operator === 145) {
            if (node.type.kind !== 183 && node.type.kind !== 184) {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types, ts3.tokenToString(151));
            }
          }
        }
        function checkGrammarForInvalidDynamicName(node, message) {
          if (isNonBindableDynamicName(node)) {
            return grammarErrorOnNode(node, message);
          }
        }
        function checkGrammarMethod(node) {
          if (checkGrammarFunctionLikeDeclaration(node)) {
            return true;
          }
          if (node.kind === 169) {
            if (node.parent.kind === 205) {
              if (node.modifiers && !(node.modifiers.length === 1 && ts3.first(node.modifiers).kind === 131)) {
                return grammarErrorOnFirstToken(node, ts3.Diagnostics.Modifiers_cannot_appear_here);
              } else if (checkGrammarForInvalidQuestionMark(node.questionToken, ts3.Diagnostics.An_object_member_cannot_be_declared_optional)) {
                return true;
              } else if (checkGrammarForInvalidExclamationToken(node.exclamationToken, ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context)) {
                return true;
              } else if (node.body === void 0) {
                return grammarErrorAtPos(node, node.end - 1, ";".length, ts3.Diagnostics._0_expected, "{");
              }
            }
            if (checkGrammarForGenerator(node)) {
              return true;
            }
          }
          if (ts3.isClassLike(node.parent)) {
            if (languageVersion < 2 && ts3.isPrivateIdentifier(node.name)) {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
            if (node.flags & 16777216) {
              return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
            } else if (node.kind === 169 && !node.body) {
              return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
            }
          } else if (node.parent.kind === 258) {
            return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
          } else if (node.parent.kind === 182) {
            return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
          }
        }
        function checkGrammarBreakOrContinueStatement(node) {
          var current = node;
          while (current) {
            if (ts3.isFunctionLikeOrClassStaticBlockDeclaration(current)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.Jump_target_cannot_cross_function_boundary);
            }
            switch (current.kind) {
              case 250:
                if (node.label && current.label.escapedText === node.label.escapedText) {
                  var isMisplacedContinueLabel = node.kind === 245 && !ts3.isIterationStatement(current.statement, true);
                  if (isMisplacedContinueLabel) {
                    return grammarErrorOnNode(node, ts3.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement);
                  }
                  return false;
                }
                break;
              case 249:
                if (node.kind === 246 && !node.label) {
                  return false;
                }
                break;
              default:
                if (ts3.isIterationStatement(current, false) && !node.label) {
                  return false;
                }
                break;
            }
            current = current.parent;
          }
          if (node.label) {
            var message = node.kind === 246 ? ts3.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement : ts3.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;
            return grammarErrorOnNode(node, message);
          } else {
            var message = node.kind === 246 ? ts3.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement : ts3.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;
            return grammarErrorOnNode(node, message);
          }
        }
        function checkGrammarBindingElement(node) {
          if (node.dotDotDotToken) {
            var elements = node.parent.elements;
            if (node !== ts3.last(elements)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            }
            checkGrammarForDisallowedTrailingComma(elements, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
            if (node.propertyName) {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.A_rest_element_cannot_have_a_property_name);
            }
          }
          if (node.dotDotDotToken && node.initializer) {
            return grammarErrorAtPos(node, node.initializer.pos - 1, 1, ts3.Diagnostics.A_rest_element_cannot_have_an_initializer);
          }
        }
        function isStringOrNumberLiteralExpression(expr) {
          return ts3.isStringOrNumericLiteralLike(expr) || expr.kind === 219 && expr.operator === 40 && expr.operand.kind === 8;
        }
        function isBigIntLiteralExpression(expr) {
          return expr.kind === 9 || expr.kind === 219 && expr.operator === 40 && expr.operand.kind === 9;
        }
        function isSimpleLiteralEnumReference(expr) {
          if ((ts3.isPropertyAccessExpression(expr) || ts3.isElementAccessExpression(expr) && isStringOrNumberLiteralExpression(expr.argumentExpression)) && ts3.isEntityNameExpression(expr.expression)) {
            return !!(checkExpressionCached(expr).flags & 1024);
          }
        }
        function checkAmbientInitializer(node) {
          var initializer = node.initializer;
          if (initializer) {
            var isInvalidInitializer = !(isStringOrNumberLiteralExpression(initializer) || isSimpleLiteralEnumReference(initializer) || initializer.kind === 110 || initializer.kind === 95 || isBigIntLiteralExpression(initializer));
            var isConstOrReadonly = ts3.isDeclarationReadonly(node) || ts3.isVariableDeclaration(node) && ts3.isVarConst(node);
            if (isConstOrReadonly && !node.type) {
              if (isInvalidInitializer) {
                return grammarErrorOnNode(initializer, ts3.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);
              }
            } else {
              return grammarErrorOnNode(initializer, ts3.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
            if (!isConstOrReadonly || isInvalidInitializer) {
              return grammarErrorOnNode(initializer, ts3.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
          }
        }
        function checkGrammarVariableDeclaration(node) {
          if (node.parent.parent.kind !== 243 && node.parent.parent.kind !== 244) {
            if (node.flags & 16777216) {
              checkAmbientInitializer(node);
            } else if (!node.initializer) {
              if (ts3.isBindingPattern(node.name) && !ts3.isBindingPattern(node.parent)) {
                return grammarErrorOnNode(node, ts3.Diagnostics.A_destructuring_declaration_must_have_an_initializer);
              }
              if (ts3.isVarConst(node)) {
                return grammarErrorOnNode(node, ts3.Diagnostics.const_declarations_must_be_initialized);
              }
            }
          }
          if (node.exclamationToken && (node.parent.parent.kind !== 237 || !node.type || node.initializer || node.flags & 16777216)) {
            var message = node.initializer ? ts3.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : !node.type ? ts3.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations : ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context;
            return grammarErrorOnNode(node.exclamationToken, message);
          }
          if ((moduleKind < ts3.ModuleKind.ES2015 || ts3.getSourceFileOfNode(node).impliedNodeFormat === ts3.ModuleKind.CommonJS) && moduleKind !== ts3.ModuleKind.System && !(node.parent.parent.flags & 16777216) && ts3.hasSyntacticModifier(node.parent.parent, 1)) {
            checkESModuleMarker(node.name);
          }
          var checkLetConstNames = ts3.isLet(node) || ts3.isVarConst(node);
          return checkLetConstNames && checkGrammarNameInLetOrConstDeclarations(node.name);
        }
        function checkESModuleMarker(name) {
          if (name.kind === 79) {
            if (ts3.idText(name) === "__esModule") {
              return grammarErrorOnNodeSkippedOn("noEmit", name, ts3.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules);
            }
          } else {
            var elements = name.elements;
            for (var _i = 0, elements_2 = elements; _i < elements_2.length; _i++) {
              var element = elements_2[_i];
              if (!ts3.isOmittedExpression(element)) {
                return checkESModuleMarker(element.name);
              }
            }
          }
          return false;
        }
        function checkGrammarNameInLetOrConstDeclarations(name) {
          if (name.kind === 79) {
            if (name.originalKeywordKind === 119) {
              return grammarErrorOnNode(name, ts3.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations);
            }
          } else {
            var elements = name.elements;
            for (var _i = 0, elements_3 = elements; _i < elements_3.length; _i++) {
              var element = elements_3[_i];
              if (!ts3.isOmittedExpression(element)) {
                checkGrammarNameInLetOrConstDeclarations(element.name);
              }
            }
          }
          return false;
        }
        function checkGrammarVariableDeclarationList(declarationList) {
          var declarations = declarationList.declarations;
          if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
            return true;
          }
          if (!declarationList.declarations.length) {
            return grammarErrorAtPos(declarationList, declarations.pos, declarations.end - declarations.pos, ts3.Diagnostics.Variable_declaration_list_cannot_be_empty);
          }
          return false;
        }
        function allowLetAndConstDeclarations(parent) {
          switch (parent.kind) {
            case 239:
            case 240:
            case 241:
            case 248:
            case 242:
            case 243:
            case 244:
              return false;
            case 250:
              return allowLetAndConstDeclarations(parent.parent);
          }
          return true;
        }
        function checkGrammarForDisallowedLetOrConstStatement(node) {
          if (!allowLetAndConstDeclarations(node.parent)) {
            if (ts3.isLet(node.declarationList)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
            } else if (ts3.isVarConst(node.declarationList)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
            }
          }
        }
        function checkGrammarMetaProperty(node) {
          var escapedText = node.name.escapedText;
          switch (node.keywordToken) {
            case 103:
              if (escapedText !== "target") {
                return grammarErrorOnNode(node.name, ts3.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, node.name.escapedText, ts3.tokenToString(node.keywordToken), "target");
              }
              break;
            case 100:
              if (escapedText !== "meta") {
                return grammarErrorOnNode(node.name, ts3.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, node.name.escapedText, ts3.tokenToString(node.keywordToken), "meta");
              }
              break;
          }
        }
        function hasParseDiagnostics(sourceFile) {
          return sourceFile.parseDiagnostics.length > 0;
        }
        function grammarErrorOnFirstToken(node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
            diagnostics.add(ts3.createFileDiagnostic(sourceFile, span.start, span.length, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function grammarErrorAtPos(nodeForSourceFile, start, length, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(nodeForSourceFile);
          if (!hasParseDiagnostics(sourceFile)) {
            diagnostics.add(ts3.createFileDiagnostic(sourceFile, start, length, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function grammarErrorOnNodeSkippedOn(key, node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            errorSkippedOn(key, node, message, arg0, arg1, arg2);
            return true;
          }
          return false;
        }
        function grammarErrorOnNode(node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            diagnostics.add(ts3.createDiagnosticForNode(node, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function checkGrammarConstructorTypeParameters(node) {
          var jsdocTypeParameters = ts3.isInJSFile(node) ? ts3.getJSDocTypeParameterDeclarations(node) : void 0;
          var range = node.typeParameters || jsdocTypeParameters && ts3.firstOrUndefined(jsdocTypeParameters);
          if (range) {
            var pos = range.pos === range.end ? range.pos : ts3.skipTrivia(ts3.getSourceFileOfNode(node).text, range.pos);
            return grammarErrorAtPos(node, pos, range.end - pos, ts3.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration);
          }
        }
        function checkGrammarConstructorTypeAnnotation(node) {
          var type2 = ts3.getEffectiveReturnTypeNode(node);
          if (type2) {
            return grammarErrorOnNode(type2, ts3.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration);
          }
        }
        function checkGrammarProperty(node) {
          if (ts3.isComputedPropertyName(node.name) && ts3.isBinaryExpression(node.name.expression) && node.name.expression.operatorToken.kind === 101) {
            return grammarErrorOnNode(node.parent.members[0], ts3.Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
          }
          if (ts3.isClassLike(node.parent)) {
            if (ts3.isStringLiteral(node.name) && node.name.text === "constructor") {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.Classes_may_not_have_a_field_named_constructor);
            }
            if (checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (languageVersion < 2 && ts3.isPrivateIdentifier(node.name)) {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
          } else if (node.parent.kind === 258) {
            if (checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (node.initializer) {
              return grammarErrorOnNode(node.initializer, ts3.Diagnostics.An_interface_property_cannot_have_an_initializer);
            }
          } else if (ts3.isTypeLiteralNode(node.parent)) {
            if (checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (node.initializer) {
              return grammarErrorOnNode(node.initializer, ts3.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
            }
          }
          if (node.flags & 16777216) {
            checkAmbientInitializer(node);
          }
          if (ts3.isPropertyDeclaration(node) && node.exclamationToken && (!ts3.isClassLike(node.parent) || !node.type || node.initializer || node.flags & 16777216 || ts3.isStatic(node) || ts3.hasAbstractModifier(node))) {
            var message = node.initializer ? ts3.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : !node.type ? ts3.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations : ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context;
            return grammarErrorOnNode(node.exclamationToken, message);
          }
        }
        function checkGrammarTopLevelElementForRequiredDeclareModifier(node) {
          if (node.kind === 258 || node.kind === 259 || node.kind === 266 || node.kind === 265 || node.kind === 272 || node.kind === 271 || node.kind === 264 || ts3.hasSyntacticModifier(node, 2 | 1 | 512)) {
            return false;
          }
          return grammarErrorOnFirstToken(node, ts3.Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier);
        }
        function checkGrammarTopLevelElementsForRequiredDeclareModifier(file) {
          for (var _i = 0, _a = file.statements; _i < _a.length; _i++) {
            var decl = _a[_i];
            if (ts3.isDeclaration(decl) || decl.kind === 237) {
              if (checkGrammarTopLevelElementForRequiredDeclareModifier(decl)) {
                return true;
              }
            }
          }
          return false;
        }
        function checkGrammarSourceFile(node) {
          return !!(node.flags & 16777216) && checkGrammarTopLevelElementsForRequiredDeclareModifier(node);
        }
        function checkGrammarStatementInAmbientContext(node) {
          if (node.flags & 16777216) {
            var links = getNodeLinks(node);
            if (!links.hasReportedStatementInAmbientContext && (ts3.isFunctionLike(node.parent) || ts3.isAccessor(node.parent))) {
              return getNodeLinks(node).hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, ts3.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
            }
            if (node.parent.kind === 235 || node.parent.kind === 262 || node.parent.kind === 305) {
              var links_2 = getNodeLinks(node.parent);
              if (!links_2.hasReportedStatementInAmbientContext) {
                return links_2.hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, ts3.Diagnostics.Statements_are_not_allowed_in_ambient_contexts);
              }
            } else {
            }
          }
          return false;
        }
        function checkGrammarNumericLiteral(node) {
          if (node.numericLiteralFlags & 32) {
            var diagnosticMessage = void 0;
            if (languageVersion >= 1) {
              diagnosticMessage = ts3.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0;
            } else if (ts3.isChildOfNodeWithKind(node, 196)) {
              diagnosticMessage = ts3.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0;
            } else if (ts3.isChildOfNodeWithKind(node, 299)) {
              diagnosticMessage = ts3.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0;
            }
            if (diagnosticMessage) {
              var withMinus = ts3.isPrefixUnaryExpression(node.parent) && node.parent.operator === 40;
              var literal = (withMinus ? "-" : "") + "0o" + node.text;
              return grammarErrorOnNode(withMinus ? node.parent : node, diagnosticMessage, literal);
            }
          }
          checkNumericLiteralValueSize(node);
          return false;
        }
        function checkNumericLiteralValueSize(node) {
          var isFractional = ts3.getTextOfNode(node).indexOf(".") !== -1;
          var isScientific = node.numericLiteralFlags & 16;
          if (isFractional || isScientific) {
            return;
          }
          var value = +node.text;
          if (value <= Math.pow(2, 53) - 1) {
            return;
          }
          addErrorOrSuggestion(false, ts3.createDiagnosticForNode(node, ts3.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers));
        }
        function checkGrammarBigIntLiteral(node) {
          var literalType = ts3.isLiteralTypeNode(node.parent) || ts3.isPrefixUnaryExpression(node.parent) && ts3.isLiteralTypeNode(node.parent.parent);
          if (!literalType) {
            if (languageVersion < 7) {
              if (grammarErrorOnNode(node, ts3.Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020)) {
                return true;
              }
            }
          }
          return false;
        }
        function grammarErrorAfterFirstToken(node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
            diagnostics.add(ts3.createFileDiagnostic(sourceFile, ts3.textSpanEnd(span), 0, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function getAmbientModules() {
          if (!ambientModulesCache) {
            ambientModulesCache = [];
            globals.forEach(function(global2, sym) {
              if (ambientModuleSymbolRegex.test(sym)) {
                ambientModulesCache.push(global2);
              }
            });
          }
          return ambientModulesCache;
        }
        function checkGrammarImportClause(node) {
          var _a;
          if (node.isTypeOnly && node.name && node.namedBindings) {
            return grammarErrorOnNode(node, ts3.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both);
          }
          if (node.isTypeOnly && ((_a = node.namedBindings) === null || _a === void 0 ? void 0 : _a.kind) === 269) {
            return checkGrammarNamedImportsOrExports(node.namedBindings);
          }
          return false;
        }
        function checkGrammarNamedImportsOrExports(namedBindings) {
          return !!ts3.forEach(namedBindings.elements, function(specifier) {
            if (specifier.isTypeOnly) {
              return grammarErrorOnFirstToken(specifier, specifier.kind === 270 ? ts3.Diagnostics.The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement : ts3.Diagnostics.The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement);
            }
          });
        }
        function checkGrammarImportCallExpression(node) {
          if (moduleKind === ts3.ModuleKind.ES2015) {
            return grammarErrorOnNode(node, ts3.Diagnostics.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext);
          }
          if (node.typeArguments) {
            return grammarErrorOnNode(node, ts3.Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);
          }
          var nodeArguments = node.arguments;
          if (moduleKind !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.NodeNext) {
            checkGrammarForDisallowedTrailingComma(nodeArguments);
            if (nodeArguments.length > 1) {
              var assertionArgument = nodeArguments[1];
              return grammarErrorOnNode(assertionArgument, ts3.Diagnostics.Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext);
            }
          }
          if (nodeArguments.length === 0 || nodeArguments.length > 2) {
            return grammarErrorOnNode(node, ts3.Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments);
          }
          var spreadElement = ts3.find(nodeArguments, ts3.isSpreadElement);
          if (spreadElement) {
            return grammarErrorOnNode(spreadElement, ts3.Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element);
          }
          return false;
        }
        function findMatchingTypeReferenceOrTypeAliasReference(source, unionTarget) {
          var sourceObjectFlags = ts3.getObjectFlags(source);
          if (sourceObjectFlags & (4 | 16) && unionTarget.flags & 1048576) {
            return ts3.find(unionTarget.types, function(target) {
              if (target.flags & 524288) {
                var overlapObjFlags = sourceObjectFlags & ts3.getObjectFlags(target);
                if (overlapObjFlags & 4) {
                  return source.target === target.target;
                }
                if (overlapObjFlags & 16) {
                  return !!source.aliasSymbol && source.aliasSymbol === target.aliasSymbol;
                }
              }
              return false;
            });
          }
        }
        function findBestTypeForObjectLiteral(source, unionTarget) {
          if (ts3.getObjectFlags(source) & 128 && someType(unionTarget, isArrayLikeType)) {
            return ts3.find(unionTarget.types, function(t) {
              return !isArrayLikeType(t);
            });
          }
        }
        function findBestTypeForInvokable(source, unionTarget) {
          var signatureKind = 0;
          var hasSignatures = getSignaturesOfType(source, signatureKind).length > 0 || (signatureKind = 1, getSignaturesOfType(source, signatureKind).length > 0);
          if (hasSignatures) {
            return ts3.find(unionTarget.types, function(t) {
              return getSignaturesOfType(t, signatureKind).length > 0;
            });
          }
        }
        function findMostOverlappyType(source, unionTarget) {
          var bestMatch;
          if (!(source.flags & (131068 | 406847488))) {
            var matchingCount = 0;
            for (var _i = 0, _a = unionTarget.types; _i < _a.length; _i++) {
              var target = _a[_i];
              if (!(target.flags & (131068 | 406847488))) {
                var overlap = getIntersectionType([getIndexType(source), getIndexType(target)]);
                if (overlap.flags & 4194304) {
                  return target;
                } else if (isUnitType(overlap) || overlap.flags & 1048576) {
                  var len = overlap.flags & 1048576 ? ts3.countWhere(overlap.types, isUnitType) : 1;
                  if (len >= matchingCount) {
                    bestMatch = target;
                    matchingCount = len;
                  }
                }
              }
            }
          }
          return bestMatch;
        }
        function filterPrimitivesIfContainsNonPrimitive(type2) {
          if (maybeTypeOfKind(type2, 67108864)) {
            var result2 = filterType(type2, function(t) {
              return !(t.flags & 131068);
            });
            if (!(result2.flags & 131072)) {
              return result2;
            }
          }
          return type2;
        }
        function findMatchingDiscriminantType(source, target, isRelatedTo, skipPartial) {
          if (target.flags & 1048576 && source.flags & (2097152 | 524288)) {
            var match = getMatchingUnionConstituentForType(target, source);
            if (match) {
              return match;
            }
            var sourceProperties = getPropertiesOfType(source);
            if (sourceProperties) {
              var sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target);
              if (sourcePropertiesFiltered) {
                return discriminateTypeByDiscriminableItems(target, ts3.map(sourcePropertiesFiltered, function(p) {
                  return [function() {
                    return getTypeOfSymbol(p);
                  }, p.escapedName];
                }), isRelatedTo, void 0, skipPartial);
              }
            }
          }
          return void 0;
        }
      }
      ts3.createTypeChecker = createTypeChecker;
      function isNotAccessor(declaration) {
        return !ts3.isAccessor(declaration);
      }
      function isNotOverload(declaration) {
        return declaration.kind !== 256 && declaration.kind !== 169 || !!declaration.body;
      }
      function isDeclarationNameOrImportPropertyName(name) {
        switch (name.parent.kind) {
          case 270:
          case 275:
            return ts3.isIdentifier(name);
          default:
            return ts3.isDeclarationName(name);
        }
      }
      var JsxNames;
      (function(JsxNames2) {
        JsxNames2.JSX = "JSX";
        JsxNames2.IntrinsicElements = "IntrinsicElements";
        JsxNames2.ElementClass = "ElementClass";
        JsxNames2.ElementAttributesPropertyNameContainer = "ElementAttributesProperty";
        JsxNames2.ElementChildrenAttributeNameContainer = "ElementChildrenAttribute";
        JsxNames2.Element = "Element";
        JsxNames2.IntrinsicAttributes = "IntrinsicAttributes";
        JsxNames2.IntrinsicClassAttributes = "IntrinsicClassAttributes";
        JsxNames2.LibraryManagedAttributes = "LibraryManagedAttributes";
      })(JsxNames || (JsxNames = {}));
      function getIterationTypesKeyFromIterationTypeKind(typeKind) {
        switch (typeKind) {
          case 0:
            return "yieldType";
          case 1:
            return "returnType";
          case 2:
            return "nextType";
        }
      }
      function signatureHasRestParameter(s) {
        return !!(s.flags & 1);
      }
      ts3.signatureHasRestParameter = signatureHasRestParameter;
      function signatureHasLiteralTypes(s) {
        return !!(s.flags & 2);
      }
      ts3.signatureHasLiteralTypes = signatureHasLiteralTypes;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function visitNode(node, visitor, test, lift) {
        if (node === void 0 || visitor === void 0) {
          return node;
        }
        var visited = visitor(node);
        if (visited === node) {
          return node;
        }
        var visitedNode;
        if (visited === void 0) {
          return void 0;
        } else if (ts3.isArray(visited)) {
          visitedNode = (lift || extractSingleNode)(visited);
        } else {
          visitedNode = visited;
        }
        ts3.Debug.assertNode(visitedNode, test);
        return visitedNode;
      }
      ts3.visitNode = visitNode;
      function visitNodes(nodes, visitor, test, start, count) {
        if (nodes === void 0 || visitor === void 0) {
          return nodes;
        }
        var updated;
        var length = nodes.length;
        if (start === void 0 || start < 0) {
          start = 0;
        }
        if (count === void 0 || count > length - start) {
          count = length - start;
        }
        var hasTrailingComma;
        var pos = -1;
        var end = -1;
        if (start > 0 || count < length) {
          updated = [];
          hasTrailingComma = nodes.hasTrailingComma && start + count === length;
        }
        for (var i = 0; i < count; i++) {
          var node = nodes[i + start];
          var visited = node !== void 0 ? visitor(node) : void 0;
          if (updated !== void 0 || visited === void 0 || visited !== node) {
            if (updated === void 0) {
              updated = nodes.slice(0, i);
              hasTrailingComma = nodes.hasTrailingComma;
              pos = nodes.pos;
              end = nodes.end;
            }
            if (visited) {
              if (ts3.isArray(visited)) {
                for (var _i = 0, visited_1 = visited; _i < visited_1.length; _i++) {
                  var visitedNode = visited_1[_i];
                  void ts3.Debug.assertNode(visitedNode, test);
                  updated.push(visitedNode);
                }
              } else {
                void ts3.Debug.assertNode(visited, test);
                updated.push(visited);
              }
            }
          }
        }
        if (updated) {
          var updatedArray = ts3.factory.createNodeArray(updated, hasTrailingComma);
          ts3.setTextRangePosEnd(updatedArray, pos, end);
          return updatedArray;
        }
        return nodes;
      }
      ts3.visitNodes = visitNodes;
      function visitLexicalEnvironment(statements, visitor, context, start, ensureUseStrict, nodesVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        context.startLexicalEnvironment();
        statements = nodesVisitor(statements, visitor, ts3.isStatement, start);
        if (ensureUseStrict)
          statements = context.factory.ensureUseStrict(statements);
        return ts3.factory.mergeLexicalEnvironment(statements, context.endLexicalEnvironment());
      }
      ts3.visitLexicalEnvironment = visitLexicalEnvironment;
      function visitParameterList(nodes, visitor, context, nodesVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        var updated;
        context.startLexicalEnvironment();
        if (nodes) {
          context.setLexicalEnvironmentFlags(1, true);
          updated = nodesVisitor(nodes, visitor, ts3.isParameterDeclaration);
          if (context.getLexicalEnvironmentFlags() & 2 && ts3.getEmitScriptTarget(context.getCompilerOptions()) >= 2) {
            updated = addDefaultValueAssignmentsIfNeeded(updated, context);
          }
          context.setLexicalEnvironmentFlags(1, false);
        }
        context.suspendLexicalEnvironment();
        return updated;
      }
      ts3.visitParameterList = visitParameterList;
      function addDefaultValueAssignmentsIfNeeded(parameters, context) {
        var result2;
        for (var i = 0; i < parameters.length; i++) {
          var parameter = parameters[i];
          var updated = addDefaultValueAssignmentIfNeeded(parameter, context);
          if (result2 || updated !== parameter) {
            if (!result2)
              result2 = parameters.slice(0, i);
            result2[i] = updated;
          }
        }
        if (result2) {
          return ts3.setTextRange(context.factory.createNodeArray(result2, parameters.hasTrailingComma), parameters);
        }
        return parameters;
      }
      function addDefaultValueAssignmentIfNeeded(parameter, context) {
        return parameter.dotDotDotToken ? parameter : ts3.isBindingPattern(parameter.name) ? addDefaultValueAssignmentForBindingPattern(parameter, context) : parameter.initializer ? addDefaultValueAssignmentForInitializer(parameter, parameter.name, parameter.initializer, context) : parameter;
      }
      function addDefaultValueAssignmentForBindingPattern(parameter, context) {
        var factory = context.factory;
        context.addInitializationStatement(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
          factory.createVariableDeclaration(parameter.name, void 0, parameter.type, parameter.initializer ? factory.createConditionalExpression(factory.createStrictEquality(factory.getGeneratedNameForNode(parameter), factory.createVoidZero()), void 0, parameter.initializer, void 0, factory.getGeneratedNameForNode(parameter)) : factory.getGeneratedNameForNode(parameter))
        ])));
        return factory.updateParameterDeclaration(parameter, parameter.decorators, parameter.modifiers, parameter.dotDotDotToken, factory.getGeneratedNameForNode(parameter), parameter.questionToken, parameter.type, void 0);
      }
      function addDefaultValueAssignmentForInitializer(parameter, name, initializer, context) {
        var factory = context.factory;
        context.addInitializationStatement(factory.createIfStatement(factory.createTypeCheck(factory.cloneNode(name), "undefined"), ts3.setEmitFlags(ts3.setTextRange(factory.createBlock([
          factory.createExpressionStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createAssignment(ts3.setEmitFlags(factory.cloneNode(name), 48), ts3.setEmitFlags(initializer, 48 | ts3.getEmitFlags(initializer) | 1536)), parameter), 1536))
        ]), parameter), 1 | 32 | 384 | 1536)));
        return factory.updateParameterDeclaration(parameter, parameter.decorators, parameter.modifiers, parameter.dotDotDotToken, parameter.name, parameter.questionToken, parameter.type, void 0);
      }
      function visitFunctionBody(node, visitor, context, nodeVisitor) {
        if (nodeVisitor === void 0) {
          nodeVisitor = visitNode;
        }
        context.resumeLexicalEnvironment();
        var updated = nodeVisitor(node, visitor, ts3.isConciseBody);
        var declarations = context.endLexicalEnvironment();
        if (ts3.some(declarations)) {
          if (!updated) {
            return context.factory.createBlock(declarations);
          }
          var block = context.factory.converters.convertToFunctionBlock(updated);
          var statements = ts3.factory.mergeLexicalEnvironment(block.statements, declarations);
          return context.factory.updateBlock(block, statements);
        }
        return updated;
      }
      ts3.visitFunctionBody = visitFunctionBody;
      function visitIterationBody(body, visitor, context) {
        context.startBlockScope();
        var updated = visitNode(body, visitor, ts3.isStatement, context.factory.liftToBlock);
        var declarations = context.endBlockScope();
        if (ts3.some(declarations)) {
          if (ts3.isBlock(updated)) {
            declarations.push.apply(declarations, updated.statements);
            return context.factory.updateBlock(updated, declarations);
          }
          declarations.push(updated);
          return context.factory.createBlock(declarations);
        }
        return updated;
      }
      ts3.visitIterationBody = visitIterationBody;
      function visitEachChild(node, visitor, context, nodesVisitor, tokenVisitor, nodeVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        if (nodeVisitor === void 0) {
          nodeVisitor = visitNode;
        }
        if (node === void 0) {
          return void 0;
        }
        var kind = node.kind;
        if (kind > 0 && kind <= 160 || kind === 192) {
          return node;
        }
        var factory = context.factory;
        switch (kind) {
          case 79:
            ts3.Debug.type(node);
            return factory.updateIdentifier(node, nodesVisitor(node.typeArguments, visitor, ts3.isTypeNodeOrTypeParameterDeclaration));
          case 161:
            ts3.Debug.type(node);
            return factory.updateQualifiedName(node, nodeVisitor(node.left, visitor, ts3.isEntityName), nodeVisitor(node.right, visitor, ts3.isIdentifier));
          case 162:
            ts3.Debug.type(node);
            return factory.updateComputedPropertyName(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 163:
            ts3.Debug.type(node);
            return factory.updateTypeParameterDeclaration(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.constraint, visitor, ts3.isTypeNode), nodeVisitor(node.default, visitor, ts3.isTypeNode));
          case 164:
            ts3.Debug.type(node);
            return factory.updateParameterDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.dotDotDotToken, tokenVisitor, ts3.isDotDotDotToken), nodeVisitor(node.name, visitor, ts3.isBindingName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 165:
            ts3.Debug.type(node);
            return factory.updateDecorator(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 166:
            ts3.Debug.type(node);
            return factory.updatePropertySignature(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isToken), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 167:
            ts3.Debug.type(node);
            return factory.updatePropertyDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken || node.exclamationToken, tokenVisitor, ts3.isQuestionOrExclamationToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 168:
            ts3.Debug.type(node);
            return factory.updateMethodSignature(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 169:
            ts3.Debug.type(node);
            return factory.updateMethodDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 171:
            ts3.Debug.type(node);
            return factory.updateConstructorDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 172:
            ts3.Debug.type(node);
            return factory.updateGetAccessorDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 173:
            ts3.Debug.type(node);
            return factory.updateSetAccessorDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 170:
            ts3.Debug.type(node);
            context.startLexicalEnvironment();
            context.suspendLexicalEnvironment();
            return factory.updateClassStaticBlockDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 174:
            ts3.Debug.type(node);
            return factory.updateCallSignature(node, nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 175:
            ts3.Debug.type(node);
            return factory.updateConstructSignature(node, nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 176:
            ts3.Debug.type(node);
            return factory.updateIndexSignature(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 177:
            ts3.Debug.type(node);
            return factory.updateTypePredicateNode(node, nodeVisitor(node.assertsModifier, visitor, ts3.isAssertsKeyword), nodeVisitor(node.parameterName, visitor, ts3.isIdentifierOrThisTypeNode), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 178:
            ts3.Debug.type(node);
            return factory.updateTypeReferenceNode(node, nodeVisitor(node.typeName, visitor, ts3.isEntityName), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode));
          case 179:
            ts3.Debug.type(node);
            return factory.updateFunctionTypeNode(node, nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 180:
            ts3.Debug.type(node);
            return factory.updateConstructorTypeNode(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 181:
            ts3.Debug.type(node);
            return factory.updateTypeQueryNode(node, nodeVisitor(node.exprName, visitor, ts3.isEntityName), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode));
          case 182:
            ts3.Debug.type(node);
            return factory.updateTypeLiteralNode(node, nodesVisitor(node.members, visitor, ts3.isTypeElement));
          case 183:
            ts3.Debug.type(node);
            return factory.updateArrayTypeNode(node, nodeVisitor(node.elementType, visitor, ts3.isTypeNode));
          case 184:
            ts3.Debug.type(node);
            return factory.updateTupleTypeNode(node, nodesVisitor(node.elements, visitor, ts3.isTypeNode));
          case 185:
            ts3.Debug.type(node);
            return factory.updateOptionalTypeNode(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 186:
            ts3.Debug.type(node);
            return factory.updateRestTypeNode(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 187:
            ts3.Debug.type(node);
            return factory.updateUnionTypeNode(node, nodesVisitor(node.types, visitor, ts3.isTypeNode));
          case 188:
            ts3.Debug.type(node);
            return factory.updateIntersectionTypeNode(node, nodesVisitor(node.types, visitor, ts3.isTypeNode));
          case 189:
            ts3.Debug.type(node);
            return factory.updateConditionalTypeNode(node, nodeVisitor(node.checkType, visitor, ts3.isTypeNode), nodeVisitor(node.extendsType, visitor, ts3.isTypeNode), nodeVisitor(node.trueType, visitor, ts3.isTypeNode), nodeVisitor(node.falseType, visitor, ts3.isTypeNode));
          case 190:
            ts3.Debug.type(node);
            return factory.updateInferTypeNode(node, nodeVisitor(node.typeParameter, visitor, ts3.isTypeParameterDeclaration));
          case 200:
            ts3.Debug.type(node);
            return factory.updateImportTypeNode(node, nodeVisitor(node.argument, visitor, ts3.isTypeNode), nodeVisitor(node.assertions, visitor, ts3.isNode), nodeVisitor(node.qualifier, visitor, ts3.isEntityName), visitNodes(node.typeArguments, visitor, ts3.isTypeNode), node.isTypeOf);
          case 295:
            ts3.Debug.type(node);
            return factory.updateImportTypeAssertionContainer(node, nodeVisitor(node.assertClause, visitor, ts3.isNode), node.multiLine);
          case 197:
            ts3.Debug.type(node);
            return factory.updateNamedTupleMember(node, visitNode(node.dotDotDotToken, visitor, ts3.isDotDotDotToken), visitNode(node.name, visitor, ts3.isIdentifier), visitNode(node.questionToken, visitor, ts3.isQuestionToken), visitNode(node.type, visitor, ts3.isTypeNode));
          case 191:
            ts3.Debug.type(node);
            return factory.updateParenthesizedType(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 193:
            ts3.Debug.type(node);
            return factory.updateTypeOperatorNode(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 194:
            ts3.Debug.type(node);
            return factory.updateIndexedAccessTypeNode(node, nodeVisitor(node.objectType, visitor, ts3.isTypeNode), nodeVisitor(node.indexType, visitor, ts3.isTypeNode));
          case 195:
            ts3.Debug.type(node);
            return factory.updateMappedTypeNode(node, nodeVisitor(node.readonlyToken, tokenVisitor, ts3.isReadonlyKeywordOrPlusOrMinusToken), nodeVisitor(node.typeParameter, visitor, ts3.isTypeParameterDeclaration), nodeVisitor(node.nameType, visitor, ts3.isTypeNode), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionOrPlusOrMinusToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodesVisitor(node.members, visitor, ts3.isTypeElement));
          case 196:
            ts3.Debug.type(node);
            return factory.updateLiteralTypeNode(node, nodeVisitor(node.literal, visitor, ts3.isExpression));
          case 198:
            ts3.Debug.type(node);
            return factory.updateTemplateLiteralType(node, nodeVisitor(node.head, visitor, ts3.isTemplateHead), nodesVisitor(node.templateSpans, visitor, ts3.isTemplateLiteralTypeSpan));
          case 199:
            ts3.Debug.type(node);
            return factory.updateTemplateLiteralTypeSpan(node, nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.literal, visitor, ts3.isTemplateMiddleOrTemplateTail));
          case 201:
            ts3.Debug.type(node);
            return factory.updateObjectBindingPattern(node, nodesVisitor(node.elements, visitor, ts3.isBindingElement));
          case 202:
            ts3.Debug.type(node);
            return factory.updateArrayBindingPattern(node, nodesVisitor(node.elements, visitor, ts3.isArrayBindingElement));
          case 203:
            ts3.Debug.type(node);
            return factory.updateBindingElement(node, nodeVisitor(node.dotDotDotToken, tokenVisitor, ts3.isDotDotDotToken), nodeVisitor(node.propertyName, visitor, ts3.isPropertyName), nodeVisitor(node.name, visitor, ts3.isBindingName), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 204:
            ts3.Debug.type(node);
            return factory.updateArrayLiteralExpression(node, nodesVisitor(node.elements, visitor, ts3.isExpression));
          case 205:
            ts3.Debug.type(node);
            return factory.updateObjectLiteralExpression(node, nodesVisitor(node.properties, visitor, ts3.isObjectLiteralElementLike));
          case 206:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updatePropertyAccessChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.questionDotToken, tokenVisitor, ts3.isQuestionDotToken), nodeVisitor(node.name, visitor, ts3.isMemberName));
            }
            ts3.Debug.type(node);
            return factory.updatePropertyAccessExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.name, visitor, ts3.isMemberName));
          case 207:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updateElementAccessChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.questionDotToken, tokenVisitor, ts3.isQuestionDotToken), nodeVisitor(node.argumentExpression, visitor, ts3.isExpression));
            }
            ts3.Debug.type(node);
            return factory.updateElementAccessExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.argumentExpression, visitor, ts3.isExpression));
          case 208:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updateCallChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.questionDotToken, tokenVisitor, ts3.isQuestionDotToken), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodesVisitor(node.arguments, visitor, ts3.isExpression));
            }
            ts3.Debug.type(node);
            return factory.updateCallExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodesVisitor(node.arguments, visitor, ts3.isExpression));
          case 209:
            ts3.Debug.type(node);
            return factory.updateNewExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodesVisitor(node.arguments, visitor, ts3.isExpression));
          case 210:
            ts3.Debug.type(node);
            return factory.updateTaggedTemplateExpression(node, nodeVisitor(node.tag, visitor, ts3.isExpression), visitNodes(node.typeArguments, visitor, ts3.isTypeNode), nodeVisitor(node.template, visitor, ts3.isTemplateLiteral));
          case 211:
            ts3.Debug.type(node);
            return factory.updateTypeAssertion(node, nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 212:
            ts3.Debug.type(node);
            return factory.updateParenthesizedExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 213:
            ts3.Debug.type(node);
            return factory.updateFunctionExpression(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 214:
            ts3.Debug.type(node);
            return factory.updateArrowFunction(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.equalsGreaterThanToken, tokenVisitor, ts3.isEqualsGreaterThanToken), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 215:
            ts3.Debug.type(node);
            return factory.updateDeleteExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 216:
            ts3.Debug.type(node);
            return factory.updateTypeOfExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 217:
            ts3.Debug.type(node);
            return factory.updateVoidExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 218:
            ts3.Debug.type(node);
            return factory.updateAwaitExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 219:
            ts3.Debug.type(node);
            return factory.updatePrefixUnaryExpression(node, nodeVisitor(node.operand, visitor, ts3.isExpression));
          case 220:
            ts3.Debug.type(node);
            return factory.updatePostfixUnaryExpression(node, nodeVisitor(node.operand, visitor, ts3.isExpression));
          case 221:
            ts3.Debug.type(node);
            return factory.updateBinaryExpression(node, nodeVisitor(node.left, visitor, ts3.isExpression), nodeVisitor(node.operatorToken, tokenVisitor, ts3.isBinaryOperatorToken), nodeVisitor(node.right, visitor, ts3.isExpression));
          case 222:
            ts3.Debug.type(node);
            return factory.updateConditionalExpression(node, nodeVisitor(node.condition, visitor, ts3.isExpression), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodeVisitor(node.whenTrue, visitor, ts3.isExpression), nodeVisitor(node.colonToken, tokenVisitor, ts3.isColonToken), nodeVisitor(node.whenFalse, visitor, ts3.isExpression));
          case 223:
            ts3.Debug.type(node);
            return factory.updateTemplateExpression(node, nodeVisitor(node.head, visitor, ts3.isTemplateHead), nodesVisitor(node.templateSpans, visitor, ts3.isTemplateSpan));
          case 224:
            ts3.Debug.type(node);
            return factory.updateYieldExpression(node, nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 225:
            ts3.Debug.type(node);
            return factory.updateSpreadElement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 226:
            ts3.Debug.type(node);
            return factory.updateClassExpression(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts3.isHeritageClause), nodesVisitor(node.members, visitor, ts3.isClassElement));
          case 228:
            ts3.Debug.type(node);
            return factory.updateExpressionWithTypeArguments(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode));
          case 229:
            ts3.Debug.type(node);
            return factory.updateAsExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 230:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updateNonNullChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
            }
            ts3.Debug.type(node);
            return factory.updateNonNullExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 231:
            ts3.Debug.type(node);
            return factory.updateMetaProperty(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 233:
            ts3.Debug.type(node);
            return factory.updateTemplateSpan(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.literal, visitor, ts3.isTemplateMiddleOrTemplateTail));
          case 235:
            ts3.Debug.type(node);
            return factory.updateBlock(node, nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 237:
            ts3.Debug.type(node);
            return factory.updateVariableStatement(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.declarationList, visitor, ts3.isVariableDeclarationList));
          case 238:
            ts3.Debug.type(node);
            return factory.updateExpressionStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 239:
            ts3.Debug.type(node);
            return factory.updateIfStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.thenStatement, visitor, ts3.isStatement, factory.liftToBlock), nodeVisitor(node.elseStatement, visitor, ts3.isStatement, factory.liftToBlock));
          case 240:
            ts3.Debug.type(node);
            return factory.updateDoStatement(node, visitIterationBody(node.statement, visitor, context), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 241:
            ts3.Debug.type(node);
            return factory.updateWhileStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 242:
            ts3.Debug.type(node);
            return factory.updateForStatement(node, nodeVisitor(node.initializer, visitor, ts3.isForInitializer), nodeVisitor(node.condition, visitor, ts3.isExpression), nodeVisitor(node.incrementor, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 243:
            ts3.Debug.type(node);
            return factory.updateForInStatement(node, nodeVisitor(node.initializer, visitor, ts3.isForInitializer), nodeVisitor(node.expression, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 244:
            ts3.Debug.type(node);
            return factory.updateForOfStatement(node, nodeVisitor(node.awaitModifier, tokenVisitor, ts3.isAwaitKeyword), nodeVisitor(node.initializer, visitor, ts3.isForInitializer), nodeVisitor(node.expression, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 245:
            ts3.Debug.type(node);
            return factory.updateContinueStatement(node, nodeVisitor(node.label, visitor, ts3.isIdentifier));
          case 246:
            ts3.Debug.type(node);
            return factory.updateBreakStatement(node, nodeVisitor(node.label, visitor, ts3.isIdentifier));
          case 247:
            ts3.Debug.type(node);
            return factory.updateReturnStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 248:
            ts3.Debug.type(node);
            return factory.updateWithStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
          case 249:
            ts3.Debug.type(node);
            return factory.updateSwitchStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.caseBlock, visitor, ts3.isCaseBlock));
          case 250:
            ts3.Debug.type(node);
            return factory.updateLabeledStatement(node, nodeVisitor(node.label, visitor, ts3.isIdentifier), nodeVisitor(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
          case 251:
            ts3.Debug.type(node);
            return factory.updateThrowStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 252:
            ts3.Debug.type(node);
            return factory.updateTryStatement(node, nodeVisitor(node.tryBlock, visitor, ts3.isBlock), nodeVisitor(node.catchClause, visitor, ts3.isCatchClause), nodeVisitor(node.finallyBlock, visitor, ts3.isBlock));
          case 254:
            ts3.Debug.type(node);
            return factory.updateVariableDeclaration(node, nodeVisitor(node.name, visitor, ts3.isBindingName), nodeVisitor(node.exclamationToken, tokenVisitor, ts3.isExclamationToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 255:
            ts3.Debug.type(node);
            return factory.updateVariableDeclarationList(node, nodesVisitor(node.declarations, visitor, ts3.isVariableDeclaration));
          case 256:
            ts3.Debug.type(node);
            return factory.updateFunctionDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 257:
            ts3.Debug.type(node);
            return factory.updateClassDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts3.isHeritageClause), nodesVisitor(node.members, visitor, ts3.isClassElement));
          case 258:
            ts3.Debug.type(node);
            return factory.updateInterfaceDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts3.isHeritageClause), nodesVisitor(node.members, visitor, ts3.isTypeElement));
          case 259:
            ts3.Debug.type(node);
            return factory.updateTypeAliasDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 260:
            ts3.Debug.type(node);
            return factory.updateEnumDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.members, visitor, ts3.isEnumMember));
          case 261:
            ts3.Debug.type(node);
            return factory.updateModuleDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isModuleName), nodeVisitor(node.body, visitor, ts3.isModuleBody));
          case 262:
            ts3.Debug.type(node);
            return factory.updateModuleBlock(node, nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 263:
            ts3.Debug.type(node);
            return factory.updateCaseBlock(node, nodesVisitor(node.clauses, visitor, ts3.isCaseOrDefaultClause));
          case 264:
            ts3.Debug.type(node);
            return factory.updateNamespaceExportDeclaration(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 265:
            ts3.Debug.type(node);
            return factory.updateImportEqualsDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), node.isTypeOnly, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.moduleReference, visitor, ts3.isModuleReference));
          case 266:
            ts3.Debug.type(node);
            return factory.updateImportDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.importClause, visitor, ts3.isImportClause), nodeVisitor(node.moduleSpecifier, visitor, ts3.isExpression), nodeVisitor(node.assertClause, visitor, ts3.isAssertClause));
          case 293:
            ts3.Debug.type(node);
            return factory.updateAssertClause(node, nodesVisitor(node.elements, visitor, ts3.isAssertEntry), node.multiLine);
          case 294:
            ts3.Debug.type(node);
            return factory.updateAssertEntry(node, nodeVisitor(node.name, visitor, ts3.isAssertionKey), nodeVisitor(node.value, visitor, ts3.isExpressionNode));
          case 267:
            ts3.Debug.type(node);
            return factory.updateImportClause(node, node.isTypeOnly, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.namedBindings, visitor, ts3.isNamedImportBindings));
          case 268:
            ts3.Debug.type(node);
            return factory.updateNamespaceImport(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 274:
            ts3.Debug.type(node);
            return factory.updateNamespaceExport(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 269:
            ts3.Debug.type(node);
            return factory.updateNamedImports(node, nodesVisitor(node.elements, visitor, ts3.isImportSpecifier));
          case 270:
            ts3.Debug.type(node);
            return factory.updateImportSpecifier(node, node.isTypeOnly, nodeVisitor(node.propertyName, visitor, ts3.isIdentifier), nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 271:
            ts3.Debug.type(node);
            return factory.updateExportAssignment(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 272:
            ts3.Debug.type(node);
            return factory.updateExportDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), node.isTypeOnly, nodeVisitor(node.exportClause, visitor, ts3.isNamedExportBindings), nodeVisitor(node.moduleSpecifier, visitor, ts3.isExpression), nodeVisitor(node.assertClause, visitor, ts3.isAssertClause));
          case 273:
            ts3.Debug.type(node);
            return factory.updateNamedExports(node, nodesVisitor(node.elements, visitor, ts3.isExportSpecifier));
          case 275:
            ts3.Debug.type(node);
            return factory.updateExportSpecifier(node, node.isTypeOnly, nodeVisitor(node.propertyName, visitor, ts3.isIdentifier), nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 277:
            ts3.Debug.type(node);
            return factory.updateExternalModuleReference(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 278:
            ts3.Debug.type(node);
            return factory.updateJsxElement(node, nodeVisitor(node.openingElement, visitor, ts3.isJsxOpeningElement), nodesVisitor(node.children, visitor, ts3.isJsxChild), nodeVisitor(node.closingElement, visitor, ts3.isJsxClosingElement));
          case 279:
            ts3.Debug.type(node);
            return factory.updateJsxSelfClosingElement(node, nodeVisitor(node.tagName, visitor, ts3.isJsxTagNameExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodeVisitor(node.attributes, visitor, ts3.isJsxAttributes));
          case 280:
            ts3.Debug.type(node);
            return factory.updateJsxOpeningElement(node, nodeVisitor(node.tagName, visitor, ts3.isJsxTagNameExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodeVisitor(node.attributes, visitor, ts3.isJsxAttributes));
          case 281:
            ts3.Debug.type(node);
            return factory.updateJsxClosingElement(node, nodeVisitor(node.tagName, visitor, ts3.isJsxTagNameExpression));
          case 282:
            ts3.Debug.type(node);
            return factory.updateJsxFragment(node, nodeVisitor(node.openingFragment, visitor, ts3.isJsxOpeningFragment), nodesVisitor(node.children, visitor, ts3.isJsxChild), nodeVisitor(node.closingFragment, visitor, ts3.isJsxClosingFragment));
          case 285:
            ts3.Debug.type(node);
            return factory.updateJsxAttribute(node, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.initializer, visitor, ts3.isStringLiteralOrJsxExpression));
          case 286:
            ts3.Debug.type(node);
            return factory.updateJsxAttributes(node, nodesVisitor(node.properties, visitor, ts3.isJsxAttributeLike));
          case 287:
            ts3.Debug.type(node);
            return factory.updateJsxSpreadAttribute(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 288:
            ts3.Debug.type(node);
            return factory.updateJsxExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 289:
            ts3.Debug.type(node);
            return factory.updateCaseClause(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 290:
            ts3.Debug.type(node);
            return factory.updateDefaultClause(node, nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 291:
            ts3.Debug.type(node);
            return factory.updateHeritageClause(node, nodesVisitor(node.types, visitor, ts3.isExpressionWithTypeArguments));
          case 292:
            ts3.Debug.type(node);
            return factory.updateCatchClause(node, nodeVisitor(node.variableDeclaration, visitor, ts3.isVariableDeclaration), nodeVisitor(node.block, visitor, ts3.isBlock));
          case 296:
            ts3.Debug.type(node);
            return factory.updatePropertyAssignment(node, nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 297:
            ts3.Debug.type(node);
            return factory.updateShorthandPropertyAssignment(node, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.objectAssignmentInitializer, visitor, ts3.isExpression));
          case 298:
            ts3.Debug.type(node);
            return factory.updateSpreadAssignment(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 299:
            ts3.Debug.type(node);
            return factory.updateEnumMember(node, nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 305:
            ts3.Debug.type(node);
            return factory.updateSourceFile(node, visitLexicalEnvironment(node.statements, visitor, context));
          case 350:
            ts3.Debug.type(node);
            return factory.updatePartiallyEmittedExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 351:
            ts3.Debug.type(node);
            return factory.updateCommaListExpression(node, nodesVisitor(node.elements, visitor, ts3.isExpression));
          default:
            return node;
        }
      }
      ts3.visitEachChild = visitEachChild;
      function extractSingleNode(nodes) {
        ts3.Debug.assert(nodes.length <= 1, "Too many nodes written to output.");
        return ts3.singleOrUndefined(nodes);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createSourceMapGenerator(host, file, sourceRoot, sourcesDirectoryPath, generatorOptions) {
        var _a = generatorOptions.extendedDiagnostics ? ts3.performance.createTimer("Source Map", "beforeSourcemap", "afterSourcemap") : ts3.performance.nullTimer, enter = _a.enter, exit = _a.exit;
        var rawSources = [];
        var sources = [];
        var sourceToSourceIndexMap = new ts3.Map();
        var sourcesContent;
        var names = [];
        var nameToNameIndexMap;
        var mappingCharCodes = [];
        var mappings = "";
        var lastGeneratedLine = 0;
        var lastGeneratedCharacter = 0;
        var lastSourceIndex = 0;
        var lastSourceLine = 0;
        var lastSourceCharacter = 0;
        var lastNameIndex = 0;
        var hasLast = false;
        var pendingGeneratedLine = 0;
        var pendingGeneratedCharacter = 0;
        var pendingSourceIndex = 0;
        var pendingSourceLine = 0;
        var pendingSourceCharacter = 0;
        var pendingNameIndex = 0;
        var hasPending = false;
        var hasPendingSource = false;
        var hasPendingName = false;
        return {
          getSources: function() {
            return rawSources;
          },
          addSource,
          setSourceContent,
          addName,
          addMapping,
          appendSourceMap,
          toJSON,
          toString: function() {
            return JSON.stringify(toJSON());
          }
        };
        function addSource(fileName2) {
          enter();
          var source = ts3.getRelativePathToDirectoryOrUrl(sourcesDirectoryPath, fileName2, host.getCurrentDirectory(), host.getCanonicalFileName, true);
          var sourceIndex = sourceToSourceIndexMap.get(source);
          if (sourceIndex === void 0) {
            sourceIndex = sources.length;
            sources.push(source);
            rawSources.push(fileName2);
            sourceToSourceIndexMap.set(source, sourceIndex);
          }
          exit();
          return sourceIndex;
        }
        function setSourceContent(sourceIndex, content) {
          enter();
          if (content !== null) {
            if (!sourcesContent)
              sourcesContent = [];
            while (sourcesContent.length < sourceIndex) {
              sourcesContent.push(null);
            }
            sourcesContent[sourceIndex] = content;
          }
          exit();
        }
        function addName(name) {
          enter();
          if (!nameToNameIndexMap)
            nameToNameIndexMap = new ts3.Map();
          var nameIndex = nameToNameIndexMap.get(name);
          if (nameIndex === void 0) {
            nameIndex = names.length;
            names.push(name);
            nameToNameIndexMap.set(name, nameIndex);
          }
          exit();
          return nameIndex;
        }
        function isNewGeneratedPosition(generatedLine, generatedCharacter) {
          return !hasPending || pendingGeneratedLine !== generatedLine || pendingGeneratedCharacter !== generatedCharacter;
        }
        function isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter) {
          return sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0 && pendingSourceIndex === sourceIndex && (pendingSourceLine > sourceLine || pendingSourceLine === sourceLine && pendingSourceCharacter > sourceCharacter);
        }
        function addMapping(generatedLine, generatedCharacter, sourceIndex, sourceLine, sourceCharacter, nameIndex) {
          ts3.Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
          ts3.Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
          ts3.Debug.assert(sourceIndex === void 0 || sourceIndex >= 0, "sourceIndex cannot be negative");
          ts3.Debug.assert(sourceLine === void 0 || sourceLine >= 0, "sourceLine cannot be negative");
          ts3.Debug.assert(sourceCharacter === void 0 || sourceCharacter >= 0, "sourceCharacter cannot be negative");
          enter();
          if (isNewGeneratedPosition(generatedLine, generatedCharacter) || isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter)) {
            commitPendingMapping();
            pendingGeneratedLine = generatedLine;
            pendingGeneratedCharacter = generatedCharacter;
            hasPendingSource = false;
            hasPendingName = false;
            hasPending = true;
          }
          if (sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0) {
            pendingSourceIndex = sourceIndex;
            pendingSourceLine = sourceLine;
            pendingSourceCharacter = sourceCharacter;
            hasPendingSource = true;
            if (nameIndex !== void 0) {
              pendingNameIndex = nameIndex;
              hasPendingName = true;
            }
          }
          exit();
        }
        function appendSourceMap(generatedLine, generatedCharacter, map2, sourceMapPath, start, end) {
          ts3.Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
          ts3.Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
          enter();
          var sourceIndexToNewSourceIndexMap = [];
          var nameIndexToNewNameIndexMap;
          var mappingIterator = decodeMappings(map2.mappings);
          for (var iterResult = mappingIterator.next(); !iterResult.done; iterResult = mappingIterator.next()) {
            var raw = iterResult.value;
            if (end && (raw.generatedLine > end.line || raw.generatedLine === end.line && raw.generatedCharacter > end.character)) {
              break;
            }
            if (start && (raw.generatedLine < start.line || start.line === raw.generatedLine && raw.generatedCharacter < start.character)) {
              continue;
            }
            var newSourceIndex = void 0;
            var newSourceLine = void 0;
            var newSourceCharacter = void 0;
            var newNameIndex = void 0;
            if (raw.sourceIndex !== void 0) {
              newSourceIndex = sourceIndexToNewSourceIndexMap[raw.sourceIndex];
              if (newSourceIndex === void 0) {
                var rawPath = map2.sources[raw.sourceIndex];
                var relativePath = map2.sourceRoot ? ts3.combinePaths(map2.sourceRoot, rawPath) : rawPath;
                var combinedPath = ts3.combinePaths(ts3.getDirectoryPath(sourceMapPath), relativePath);
                sourceIndexToNewSourceIndexMap[raw.sourceIndex] = newSourceIndex = addSource(combinedPath);
                if (map2.sourcesContent && typeof map2.sourcesContent[raw.sourceIndex] === "string") {
                  setSourceContent(newSourceIndex, map2.sourcesContent[raw.sourceIndex]);
                }
              }
              newSourceLine = raw.sourceLine;
              newSourceCharacter = raw.sourceCharacter;
              if (map2.names && raw.nameIndex !== void 0) {
                if (!nameIndexToNewNameIndexMap)
                  nameIndexToNewNameIndexMap = [];
                newNameIndex = nameIndexToNewNameIndexMap[raw.nameIndex];
                if (newNameIndex === void 0) {
                  nameIndexToNewNameIndexMap[raw.nameIndex] = newNameIndex = addName(map2.names[raw.nameIndex]);
                }
              }
            }
            var rawGeneratedLine = raw.generatedLine - (start ? start.line : 0);
            var newGeneratedLine = rawGeneratedLine + generatedLine;
            var rawGeneratedCharacter = start && start.line === raw.generatedLine ? raw.generatedCharacter - start.character : raw.generatedCharacter;
            var newGeneratedCharacter = rawGeneratedLine === 0 ? rawGeneratedCharacter + generatedCharacter : rawGeneratedCharacter;
            addMapping(newGeneratedLine, newGeneratedCharacter, newSourceIndex, newSourceLine, newSourceCharacter, newNameIndex);
          }
          exit();
        }
        function shouldCommitMapping() {
          return !hasLast || lastGeneratedLine !== pendingGeneratedLine || lastGeneratedCharacter !== pendingGeneratedCharacter || lastSourceIndex !== pendingSourceIndex || lastSourceLine !== pendingSourceLine || lastSourceCharacter !== pendingSourceCharacter || lastNameIndex !== pendingNameIndex;
        }
        function appendMappingCharCode(charCode) {
          mappingCharCodes.push(charCode);
          if (mappingCharCodes.length >= 1024) {
            flushMappingBuffer();
          }
        }
        function commitPendingMapping() {
          if (!hasPending || !shouldCommitMapping()) {
            return;
          }
          enter();
          if (lastGeneratedLine < pendingGeneratedLine) {
            do {
              appendMappingCharCode(59);
              lastGeneratedLine++;
            } while (lastGeneratedLine < pendingGeneratedLine);
            lastGeneratedCharacter = 0;
          } else {
            ts3.Debug.assertEqual(lastGeneratedLine, pendingGeneratedLine, "generatedLine cannot backtrack");
            if (hasLast) {
              appendMappingCharCode(44);
            }
          }
          appendBase64VLQ(pendingGeneratedCharacter - lastGeneratedCharacter);
          lastGeneratedCharacter = pendingGeneratedCharacter;
          if (hasPendingSource) {
            appendBase64VLQ(pendingSourceIndex - lastSourceIndex);
            lastSourceIndex = pendingSourceIndex;
            appendBase64VLQ(pendingSourceLine - lastSourceLine);
            lastSourceLine = pendingSourceLine;
            appendBase64VLQ(pendingSourceCharacter - lastSourceCharacter);
            lastSourceCharacter = pendingSourceCharacter;
            if (hasPendingName) {
              appendBase64VLQ(pendingNameIndex - lastNameIndex);
              lastNameIndex = pendingNameIndex;
            }
          }
          hasLast = true;
          exit();
        }
        function flushMappingBuffer() {
          if (mappingCharCodes.length > 0) {
            mappings += String.fromCharCode.apply(void 0, mappingCharCodes);
            mappingCharCodes.length = 0;
          }
        }
        function toJSON() {
          commitPendingMapping();
          flushMappingBuffer();
          return {
            version: 3,
            file,
            sourceRoot,
            sources,
            names,
            mappings,
            sourcesContent
          };
        }
        function appendBase64VLQ(inValue) {
          if (inValue < 0) {
            inValue = (-inValue << 1) + 1;
          } else {
            inValue = inValue << 1;
          }
          do {
            var currentDigit = inValue & 31;
            inValue = inValue >> 5;
            if (inValue > 0) {
              currentDigit = currentDigit | 32;
            }
            appendMappingCharCode(base64FormatEncode(currentDigit));
          } while (inValue > 0);
        }
      }
      ts3.createSourceMapGenerator = createSourceMapGenerator;
      var sourceMapCommentRegExp = /^\/\/[@#] source[M]appingURL=(.+)\r?\n?$/;
      var whitespaceOrMapCommentRegExp = /^\s*(\/\/[@#] .*)?$/;
      function getLineInfo(text, lineStarts) {
        return {
          getLineCount: function() {
            return lineStarts.length;
          },
          getLineText: function(line) {
            return text.substring(lineStarts[line], lineStarts[line + 1]);
          }
        };
      }
      ts3.getLineInfo = getLineInfo;
      function tryGetSourceMappingURL(lineInfo) {
        for (var index = lineInfo.getLineCount() - 1; index >= 0; index--) {
          var line = lineInfo.getLineText(index);
          var comment = sourceMapCommentRegExp.exec(line);
          if (comment) {
            return ts3.trimStringEnd(comment[1]);
          } else if (!line.match(whitespaceOrMapCommentRegExp)) {
            break;
          }
        }
      }
      ts3.tryGetSourceMappingURL = tryGetSourceMappingURL;
      function isStringOrNull(x) {
        return typeof x === "string" || x === null;
      }
      function isRawSourceMap(x) {
        return x !== null && typeof x === "object" && x.version === 3 && typeof x.file === "string" && typeof x.mappings === "string" && ts3.isArray(x.sources) && ts3.every(x.sources, ts3.isString) && (x.sourceRoot === void 0 || x.sourceRoot === null || typeof x.sourceRoot === "string") && (x.sourcesContent === void 0 || x.sourcesContent === null || ts3.isArray(x.sourcesContent) && ts3.every(x.sourcesContent, isStringOrNull)) && (x.names === void 0 || x.names === null || ts3.isArray(x.names) && ts3.every(x.names, ts3.isString));
      }
      ts3.isRawSourceMap = isRawSourceMap;
      function tryParseRawSourceMap(text) {
        try {
          var parsed = JSON.parse(text);
          if (isRawSourceMap(parsed)) {
            return parsed;
          }
        } catch (_a) {
        }
        return void 0;
      }
      ts3.tryParseRawSourceMap = tryParseRawSourceMap;
      function decodeMappings(mappings) {
        var done = false;
        var pos = 0;
        var generatedLine = 0;
        var generatedCharacter = 0;
        var sourceIndex = 0;
        var sourceLine = 0;
        var sourceCharacter = 0;
        var nameIndex = 0;
        var error;
        return {
          get pos() {
            return pos;
          },
          get error() {
            return error;
          },
          get state() {
            return captureMapping(true, true);
          },
          next: function() {
            while (!done && pos < mappings.length) {
              var ch = mappings.charCodeAt(pos);
              if (ch === 59) {
                generatedLine++;
                generatedCharacter = 0;
                pos++;
                continue;
              }
              if (ch === 44) {
                pos++;
                continue;
              }
              var hasSource = false;
              var hasName = false;
              generatedCharacter += base64VLQFormatDecode();
              if (hasReportedError())
                return stopIterating();
              if (generatedCharacter < 0)
                return setErrorAndStopIterating("Invalid generatedCharacter found");
              if (!isSourceMappingSegmentEnd()) {
                hasSource = true;
                sourceIndex += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceIndex < 0)
                  return setErrorAndStopIterating("Invalid sourceIndex found");
                if (isSourceMappingSegmentEnd())
                  return setErrorAndStopIterating("Unsupported Format: No entries after sourceIndex");
                sourceLine += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceLine < 0)
                  return setErrorAndStopIterating("Invalid sourceLine found");
                if (isSourceMappingSegmentEnd())
                  return setErrorAndStopIterating("Unsupported Format: No entries after sourceLine");
                sourceCharacter += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceCharacter < 0)
                  return setErrorAndStopIterating("Invalid sourceCharacter found");
                if (!isSourceMappingSegmentEnd()) {
                  hasName = true;
                  nameIndex += base64VLQFormatDecode();
                  if (hasReportedError())
                    return stopIterating();
                  if (nameIndex < 0)
                    return setErrorAndStopIterating("Invalid nameIndex found");
                  if (!isSourceMappingSegmentEnd())
                    return setErrorAndStopIterating("Unsupported Error Format: Entries after nameIndex");
                }
              }
              return { value: captureMapping(hasSource, hasName), done };
            }
            return stopIterating();
          }
        };
        function captureMapping(hasSource, hasName) {
          return {
            generatedLine,
            generatedCharacter,
            sourceIndex: hasSource ? sourceIndex : void 0,
            sourceLine: hasSource ? sourceLine : void 0,
            sourceCharacter: hasSource ? sourceCharacter : void 0,
            nameIndex: hasName ? nameIndex : void 0
          };
        }
        function stopIterating() {
          done = true;
          return { value: void 0, done: true };
        }
        function setError(message) {
          if (error === void 0) {
            error = message;
          }
        }
        function setErrorAndStopIterating(message) {
          setError(message);
          return stopIterating();
        }
        function hasReportedError() {
          return error !== void 0;
        }
        function isSourceMappingSegmentEnd() {
          return pos === mappings.length || mappings.charCodeAt(pos) === 44 || mappings.charCodeAt(pos) === 59;
        }
        function base64VLQFormatDecode() {
          var moreDigits = true;
          var shiftCount = 0;
          var value = 0;
          for (; moreDigits; pos++) {
            if (pos >= mappings.length)
              return setError("Error in decoding base64VLQFormatDecode, past the mapping string"), -1;
            var currentByte = base64FormatDecode(mappings.charCodeAt(pos));
            if (currentByte === -1)
              return setError("Invalid character in VLQ"), -1;
            moreDigits = (currentByte & 32) !== 0;
            value = value | (currentByte & 31) << shiftCount;
            shiftCount += 5;
          }
          if ((value & 1) === 0) {
            value = value >> 1;
          } else {
            value = value >> 1;
            value = -value;
          }
          return value;
        }
      }
      ts3.decodeMappings = decodeMappings;
      function sameMapping(left, right) {
        return left === right || left.generatedLine === right.generatedLine && left.generatedCharacter === right.generatedCharacter && left.sourceIndex === right.sourceIndex && left.sourceLine === right.sourceLine && left.sourceCharacter === right.sourceCharacter && left.nameIndex === right.nameIndex;
      }
      ts3.sameMapping = sameMapping;
      function isSourceMapping(mapping) {
        return mapping.sourceIndex !== void 0 && mapping.sourceLine !== void 0 && mapping.sourceCharacter !== void 0;
      }
      ts3.isSourceMapping = isSourceMapping;
      function base64FormatEncode(value) {
        return value >= 0 && value < 26 ? 65 + value : value >= 26 && value < 52 ? 97 + value - 26 : value >= 52 && value < 62 ? 48 + value - 52 : value === 62 ? 43 : value === 63 ? 47 : ts3.Debug.fail("".concat(value, ": not a base64 value"));
      }
      function base64FormatDecode(ch) {
        return ch >= 65 && ch <= 90 ? ch - 65 : ch >= 97 && ch <= 122 ? ch - 97 + 26 : ch >= 48 && ch <= 57 ? ch - 48 + 52 : ch === 43 ? 62 : ch === 47 ? 63 : -1;
      }
      function isSourceMappedPosition(value) {
        return value.sourceIndex !== void 0 && value.sourcePosition !== void 0;
      }
      function sameMappedPosition(left, right) {
        return left.generatedPosition === right.generatedPosition && left.sourceIndex === right.sourceIndex && left.sourcePosition === right.sourcePosition;
      }
      function compareSourcePositions(left, right) {
        ts3.Debug.assert(left.sourceIndex === right.sourceIndex);
        return ts3.compareValues(left.sourcePosition, right.sourcePosition);
      }
      function compareGeneratedPositions(left, right) {
        return ts3.compareValues(left.generatedPosition, right.generatedPosition);
      }
      function getSourcePositionOfMapping(value) {
        return value.sourcePosition;
      }
      function getGeneratedPositionOfMapping(value) {
        return value.generatedPosition;
      }
      function createDocumentPositionMapper(host, map2, mapPath) {
        var mapDirectory = ts3.getDirectoryPath(mapPath);
        var sourceRoot = map2.sourceRoot ? ts3.getNormalizedAbsolutePath(map2.sourceRoot, mapDirectory) : mapDirectory;
        var generatedAbsoluteFilePath = ts3.getNormalizedAbsolutePath(map2.file, mapDirectory);
        var generatedFile = host.getSourceFileLike(generatedAbsoluteFilePath);
        var sourceFileAbsolutePaths = map2.sources.map(function(source) {
          return ts3.getNormalizedAbsolutePath(source, sourceRoot);
        });
        var sourceToSourceIndexMap = new ts3.Map(sourceFileAbsolutePaths.map(function(source, i) {
          return [host.getCanonicalFileName(source), i];
        }));
        var decodedMappings;
        var generatedMappings;
        var sourceMappings;
        return {
          getSourcePosition,
          getGeneratedPosition
        };
        function processMapping(mapping) {
          var generatedPosition = generatedFile !== void 0 ? ts3.getPositionOfLineAndCharacter(generatedFile, mapping.generatedLine, mapping.generatedCharacter, true) : -1;
          var source;
          var sourcePosition;
          if (isSourceMapping(mapping)) {
            var sourceFile = host.getSourceFileLike(sourceFileAbsolutePaths[mapping.sourceIndex]);
            source = map2.sources[mapping.sourceIndex];
            sourcePosition = sourceFile !== void 0 ? ts3.getPositionOfLineAndCharacter(sourceFile, mapping.sourceLine, mapping.sourceCharacter, true) : -1;
          }
          return {
            generatedPosition,
            source,
            sourceIndex: mapping.sourceIndex,
            sourcePosition,
            nameIndex: mapping.nameIndex
          };
        }
        function getDecodedMappings() {
          if (decodedMappings === void 0) {
            var decoder2 = decodeMappings(map2.mappings);
            var mappings = ts3.arrayFrom(decoder2, processMapping);
            if (decoder2.error !== void 0) {
              if (host.log) {
                host.log("Encountered error while decoding sourcemap: ".concat(decoder2.error));
              }
              decodedMappings = ts3.emptyArray;
            } else {
              decodedMappings = mappings;
            }
          }
          return decodedMappings;
        }
        function getSourceMappings(sourceIndex) {
          if (sourceMappings === void 0) {
            var lists = [];
            for (var _i = 0, _a = getDecodedMappings(); _i < _a.length; _i++) {
              var mapping = _a[_i];
              if (!isSourceMappedPosition(mapping))
                continue;
              var list = lists[mapping.sourceIndex];
              if (!list)
                lists[mapping.sourceIndex] = list = [];
              list.push(mapping);
            }
            sourceMappings = lists.map(function(list2) {
              return ts3.sortAndDeduplicate(list2, compareSourcePositions, sameMappedPosition);
            });
          }
          return sourceMappings[sourceIndex];
        }
        function getGeneratedMappings() {
          if (generatedMappings === void 0) {
            var list = [];
            for (var _i = 0, _a = getDecodedMappings(); _i < _a.length; _i++) {
              var mapping = _a[_i];
              list.push(mapping);
            }
            generatedMappings = ts3.sortAndDeduplicate(list, compareGeneratedPositions, sameMappedPosition);
          }
          return generatedMappings;
        }
        function getGeneratedPosition(loc) {
          var sourceIndex = sourceToSourceIndexMap.get(host.getCanonicalFileName(loc.fileName));
          if (sourceIndex === void 0)
            return loc;
          var sourceMappings2 = getSourceMappings(sourceIndex);
          if (!ts3.some(sourceMappings2))
            return loc;
          var targetIndex = ts3.binarySearchKey(sourceMappings2, loc.pos, getSourcePositionOfMapping, ts3.compareValues);
          if (targetIndex < 0) {
            targetIndex = ~targetIndex;
          }
          var mapping = sourceMappings2[targetIndex];
          if (mapping === void 0 || mapping.sourceIndex !== sourceIndex) {
            return loc;
          }
          return { fileName: generatedAbsoluteFilePath, pos: mapping.generatedPosition };
        }
        function getSourcePosition(loc) {
          var generatedMappings2 = getGeneratedMappings();
          if (!ts3.some(generatedMappings2))
            return loc;
          var targetIndex = ts3.binarySearchKey(generatedMappings2, loc.pos, getGeneratedPositionOfMapping, ts3.compareValues);
          if (targetIndex < 0) {
            targetIndex = ~targetIndex;
          }
          var mapping = generatedMappings2[targetIndex];
          if (mapping === void 0 || !isSourceMappedPosition(mapping)) {
            return loc;
          }
          return { fileName: sourceFileAbsolutePaths[mapping.sourceIndex], pos: mapping.sourcePosition };
        }
      }
      ts3.createDocumentPositionMapper = createDocumentPositionMapper;
      ts3.identitySourceMapConsumer = {
        getSourcePosition: ts3.identity,
        getGeneratedPosition: ts3.identity
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getOriginalNodeId(node) {
        node = ts3.getOriginalNode(node);
        return node ? ts3.getNodeId(node) : 0;
      }
      ts3.getOriginalNodeId = getOriginalNodeId;
      function containsDefaultReference(node) {
        if (!node)
          return false;
        if (!ts3.isNamedImports(node))
          return false;
        return ts3.some(node.elements, isNamedDefaultReference);
      }
      function isNamedDefaultReference(e) {
        return e.propertyName !== void 0 && e.propertyName.escapedText === "default";
      }
      function chainBundle(context, transformSourceFile) {
        return transformSourceFileOrBundle;
        function transformSourceFileOrBundle(node) {
          return node.kind === 305 ? transformSourceFile(node) : transformBundle(node);
        }
        function transformBundle(node) {
          return context.factory.createBundle(ts3.map(node.sourceFiles, transformSourceFile), node.prepends);
        }
      }
      ts3.chainBundle = chainBundle;
      function getExportNeedsImportStarHelper(node) {
        return !!ts3.getNamespaceDeclarationNode(node);
      }
      ts3.getExportNeedsImportStarHelper = getExportNeedsImportStarHelper;
      function getImportNeedsImportStarHelper(node) {
        if (!!ts3.getNamespaceDeclarationNode(node)) {
          return true;
        }
        var bindings = node.importClause && node.importClause.namedBindings;
        if (!bindings) {
          return false;
        }
        if (!ts3.isNamedImports(bindings))
          return false;
        var defaultRefCount = 0;
        for (var _i = 0, _a = bindings.elements; _i < _a.length; _i++) {
          var binding = _a[_i];
          if (isNamedDefaultReference(binding)) {
            defaultRefCount++;
          }
        }
        return defaultRefCount > 0 && defaultRefCount !== bindings.elements.length || !!(bindings.elements.length - defaultRefCount) && ts3.isDefaultImport(node);
      }
      ts3.getImportNeedsImportStarHelper = getImportNeedsImportStarHelper;
      function getImportNeedsImportDefaultHelper(node) {
        return !getImportNeedsImportStarHelper(node) && (ts3.isDefaultImport(node) || !!node.importClause && ts3.isNamedImports(node.importClause.namedBindings) && containsDefaultReference(node.importClause.namedBindings));
      }
      ts3.getImportNeedsImportDefaultHelper = getImportNeedsImportDefaultHelper;
      function collectExternalModuleInfo(context, sourceFile, resolver, compilerOptions) {
        var externalImports = [];
        var exportSpecifiers = ts3.createMultiMap();
        var exportedBindings = [];
        var uniqueExports = new ts3.Map();
        var exportedNames;
        var hasExportDefault = false;
        var exportEquals;
        var hasExportStarsToExportValues = false;
        var hasImportStar = false;
        var hasImportDefault = false;
        for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
          var node = _a[_i];
          switch (node.kind) {
            case 266:
              externalImports.push(node);
              if (!hasImportStar && getImportNeedsImportStarHelper(node)) {
                hasImportStar = true;
              }
              if (!hasImportDefault && getImportNeedsImportDefaultHelper(node)) {
                hasImportDefault = true;
              }
              break;
            case 265:
              if (node.moduleReference.kind === 277) {
                externalImports.push(node);
              }
              break;
            case 272:
              if (node.moduleSpecifier) {
                if (!node.exportClause) {
                  externalImports.push(node);
                  hasExportStarsToExportValues = true;
                } else {
                  externalImports.push(node);
                  if (ts3.isNamedExports(node.exportClause)) {
                    addExportedNamesForExportDeclaration(node);
                  } else {
                    var name = node.exportClause.name;
                    if (!uniqueExports.get(ts3.idText(name))) {
                      multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                      uniqueExports.set(ts3.idText(name), true);
                      exportedNames = ts3.append(exportedNames, name);
                    }
                    hasImportStar = true;
                  }
                }
              } else {
                addExportedNamesForExportDeclaration(node);
              }
              break;
            case 271:
              if (node.isExportEquals && !exportEquals) {
                exportEquals = node;
              }
              break;
            case 237:
              if (ts3.hasSyntacticModifier(node, 1)) {
                for (var _b = 0, _c = node.declarationList.declarations; _b < _c.length; _b++) {
                  var decl = _c[_b];
                  exportedNames = collectExportedVariableInfo(decl, uniqueExports, exportedNames);
                }
              }
              break;
            case 256:
              if (ts3.hasSyntacticModifier(node, 1)) {
                if (ts3.hasSyntacticModifier(node, 512)) {
                  if (!hasExportDefault) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), context.factory.getDeclarationName(node));
                    hasExportDefault = true;
                  }
                } else {
                  var name = node.name;
                  if (!uniqueExports.get(ts3.idText(name))) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                    uniqueExports.set(ts3.idText(name), true);
                    exportedNames = ts3.append(exportedNames, name);
                  }
                }
              }
              break;
            case 257:
              if (ts3.hasSyntacticModifier(node, 1)) {
                if (ts3.hasSyntacticModifier(node, 512)) {
                  if (!hasExportDefault) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), context.factory.getDeclarationName(node));
                    hasExportDefault = true;
                  }
                } else {
                  var name = node.name;
                  if (name && !uniqueExports.get(ts3.idText(name))) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                    uniqueExports.set(ts3.idText(name), true);
                    exportedNames = ts3.append(exportedNames, name);
                  }
                }
              }
              break;
          }
        }
        var externalHelpersImportDeclaration = ts3.createExternalHelpersImportDeclarationIfNeeded(context.factory, context.getEmitHelperFactory(), sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault);
        if (externalHelpersImportDeclaration) {
          externalImports.unshift(externalHelpersImportDeclaration);
        }
        return { externalImports, exportSpecifiers, exportEquals, hasExportStarsToExportValues, exportedBindings, exportedNames, externalHelpersImportDeclaration };
        function addExportedNamesForExportDeclaration(node2) {
          for (var _i2 = 0, _a2 = ts3.cast(node2.exportClause, ts3.isNamedExports).elements; _i2 < _a2.length; _i2++) {
            var specifier = _a2[_i2];
            if (!uniqueExports.get(ts3.idText(specifier.name))) {
              var name2 = specifier.propertyName || specifier.name;
              if (!node2.moduleSpecifier) {
                exportSpecifiers.add(ts3.idText(name2), specifier);
              }
              var decl2 = resolver.getReferencedImportDeclaration(name2) || resolver.getReferencedValueDeclaration(name2);
              if (decl2) {
                multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(decl2), specifier.name);
              }
              uniqueExports.set(ts3.idText(specifier.name), true);
              exportedNames = ts3.append(exportedNames, specifier.name);
            }
          }
        }
      }
      ts3.collectExternalModuleInfo = collectExternalModuleInfo;
      function collectExportedVariableInfo(decl, uniqueExports, exportedNames) {
        if (ts3.isBindingPattern(decl.name)) {
          for (var _i = 0, _a = decl.name.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (!ts3.isOmittedExpression(element)) {
              exportedNames = collectExportedVariableInfo(element, uniqueExports, exportedNames);
            }
          }
        } else if (!ts3.isGeneratedIdentifier(decl.name)) {
          var text = ts3.idText(decl.name);
          if (!uniqueExports.get(text)) {
            uniqueExports.set(text, true);
            exportedNames = ts3.append(exportedNames, decl.name);
          }
        }
        return exportedNames;
      }
      function multiMapSparseArrayAdd(map2, key, value) {
        var values = map2[key];
        if (values) {
          values.push(value);
        } else {
          map2[key] = values = [value];
        }
        return values;
      }
      function isSimpleCopiableExpression(expression) {
        return ts3.isStringLiteralLike(expression) || expression.kind === 8 || ts3.isKeyword(expression.kind) || ts3.isIdentifier(expression);
      }
      ts3.isSimpleCopiableExpression = isSimpleCopiableExpression;
      function isSimpleInlineableExpression(expression) {
        return !ts3.isIdentifier(expression) && isSimpleCopiableExpression(expression);
      }
      ts3.isSimpleInlineableExpression = isSimpleInlineableExpression;
      function isCompoundAssignment(kind) {
        return kind >= 64 && kind <= 78;
      }
      ts3.isCompoundAssignment = isCompoundAssignment;
      function getNonAssignmentOperatorForCompoundAssignment(kind) {
        switch (kind) {
          case 64:
            return 39;
          case 65:
            return 40;
          case 66:
            return 41;
          case 67:
            return 42;
          case 68:
            return 43;
          case 69:
            return 44;
          case 70:
            return 47;
          case 71:
            return 48;
          case 72:
            return 49;
          case 73:
            return 50;
          case 74:
            return 51;
          case 78:
            return 52;
          case 75:
            return 56;
          case 76:
            return 55;
          case 77:
            return 60;
        }
      }
      ts3.getNonAssignmentOperatorForCompoundAssignment = getNonAssignmentOperatorForCompoundAssignment;
      function getSuperCallFromStatement(statement) {
        if (!ts3.isExpressionStatement(statement)) {
          return void 0;
        }
        var expression = ts3.skipParentheses(statement.expression);
        return ts3.isSuperCall(expression) ? expression : void 0;
      }
      ts3.getSuperCallFromStatement = getSuperCallFromStatement;
      function findSuperStatementIndex(statements, indexAfterLastPrologueStatement) {
        for (var i = indexAfterLastPrologueStatement; i < statements.length; i += 1) {
          var statement = statements[i];
          if (getSuperCallFromStatement(statement)) {
            return i;
          }
        }
        return -1;
      }
      ts3.findSuperStatementIndex = findSuperStatementIndex;
      function getProperties(node, requireInitializer, isStatic) {
        return ts3.filter(node.members, function(m) {
          return isInitializedOrStaticProperty(m, requireInitializer, isStatic);
        });
      }
      ts3.getProperties = getProperties;
      function isStaticPropertyDeclarationOrClassStaticBlockDeclaration(element) {
        return isStaticPropertyDeclaration(element) || ts3.isClassStaticBlockDeclaration(element);
      }
      function getStaticPropertiesAndClassStaticBlock(node) {
        return ts3.filter(node.members, isStaticPropertyDeclarationOrClassStaticBlockDeclaration);
      }
      ts3.getStaticPropertiesAndClassStaticBlock = getStaticPropertiesAndClassStaticBlock;
      function isInitializedOrStaticProperty(member, requireInitializer, isStatic) {
        return ts3.isPropertyDeclaration(member) && (!!member.initializer || !requireInitializer) && ts3.hasStaticModifier(member) === isStatic;
      }
      function isStaticPropertyDeclaration(member) {
        return ts3.isPropertyDeclaration(member) && ts3.hasStaticModifier(member);
      }
      function isInitializedProperty(member) {
        return member.kind === 167 && member.initializer !== void 0;
      }
      ts3.isInitializedProperty = isInitializedProperty;
      function isNonStaticMethodOrAccessorWithPrivateName(member) {
        return !ts3.isStatic(member) && ts3.isMethodOrAccessor(member) && ts3.isPrivateIdentifier(member.name);
      }
      ts3.isNonStaticMethodOrAccessorWithPrivateName = isNonStaticMethodOrAccessorWithPrivateName;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var FlattenLevel;
      (function(FlattenLevel2) {
        FlattenLevel2[FlattenLevel2["All"] = 0] = "All";
        FlattenLevel2[FlattenLevel2["ObjectRest"] = 1] = "ObjectRest";
      })(FlattenLevel = ts3.FlattenLevel || (ts3.FlattenLevel = {}));
      function flattenDestructuringAssignment(node, visitor, context, level, needsValue, createAssignmentCallback) {
        var location = node;
        var value;
        if (ts3.isDestructuringAssignment(node)) {
          value = node.right;
          while (ts3.isEmptyArrayLiteral(node.left) || ts3.isEmptyObjectLiteral(node.left)) {
            if (ts3.isDestructuringAssignment(value)) {
              location = node = value;
              value = node.right;
            } else {
              return ts3.visitNode(value, visitor, ts3.isExpression);
            }
          }
        }
        var expressions;
        var flattenContext = {
          context,
          level,
          downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
          hoistTempVariables: true,
          emitExpression,
          emitBindingOrAssignment,
          createArrayBindingOrAssignmentPattern: function(elements) {
            return makeArrayAssignmentPattern(context.factory, elements);
          },
          createObjectBindingOrAssignmentPattern: function(elements) {
            return makeObjectAssignmentPattern(context.factory, elements);
          },
          createArrayBindingOrAssignmentElement: makeAssignmentElement,
          visitor
        };
        if (value) {
          value = ts3.visitNode(value, visitor, ts3.isExpression);
          if (ts3.isIdentifier(value) && bindingOrAssignmentElementAssignsToName(node, value.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node)) {
            value = ensureIdentifier(flattenContext, value, false, location);
          } else if (needsValue) {
            value = ensureIdentifier(flattenContext, value, true, location);
          } else if (ts3.nodeIsSynthesized(node)) {
            location = value;
          }
        }
        flattenBindingOrAssignmentElement(flattenContext, node, value, location, ts3.isDestructuringAssignment(node));
        if (value && needsValue) {
          if (!ts3.some(expressions)) {
            return value;
          }
          expressions.push(value);
        }
        return context.factory.inlineExpressions(expressions) || context.factory.createOmittedExpression();
        function emitExpression(expression) {
          expressions = ts3.append(expressions, expression);
        }
        function emitBindingOrAssignment(target, value2, location2, original) {
          ts3.Debug.assertNode(target, createAssignmentCallback ? ts3.isIdentifier : ts3.isExpression);
          var expression = createAssignmentCallback ? createAssignmentCallback(target, value2, location2) : ts3.setTextRange(context.factory.createAssignment(ts3.visitNode(target, visitor, ts3.isExpression), value2), location2);
          expression.original = original;
          emitExpression(expression);
        }
      }
      ts3.flattenDestructuringAssignment = flattenDestructuringAssignment;
      function bindingOrAssignmentElementAssignsToName(element, escapedName) {
        var target = ts3.getTargetOfBindingOrAssignmentElement(element);
        if (ts3.isBindingOrAssignmentPattern(target)) {
          return bindingOrAssignmentPatternAssignsToName(target, escapedName);
        } else if (ts3.isIdentifier(target)) {
          return target.escapedText === escapedName;
        }
        return false;
      }
      function bindingOrAssignmentPatternAssignsToName(pattern, escapedName) {
        var elements = ts3.getElementsOfBindingOrAssignmentPattern(pattern);
        for (var _i = 0, elements_4 = elements; _i < elements_4.length; _i++) {
          var element = elements_4[_i];
          if (bindingOrAssignmentElementAssignsToName(element, escapedName)) {
            return true;
          }
        }
        return false;
      }
      function bindingOrAssignmentElementContainsNonLiteralComputedName(element) {
        var propertyName = ts3.tryGetPropertyNameOfBindingOrAssignmentElement(element);
        if (propertyName && ts3.isComputedPropertyName(propertyName) && !ts3.isLiteralExpression(propertyName.expression)) {
          return true;
        }
        var target = ts3.getTargetOfBindingOrAssignmentElement(element);
        return !!target && ts3.isBindingOrAssignmentPattern(target) && bindingOrAssignmentPatternContainsNonLiteralComputedName(target);
      }
      function bindingOrAssignmentPatternContainsNonLiteralComputedName(pattern) {
        return !!ts3.forEach(ts3.getElementsOfBindingOrAssignmentPattern(pattern), bindingOrAssignmentElementContainsNonLiteralComputedName);
      }
      function flattenDestructuringBinding(node, visitor, context, level, rval, hoistTempVariables, skipInitializer) {
        if (hoistTempVariables === void 0) {
          hoistTempVariables = false;
        }
        var pendingExpressions;
        var pendingDeclarations = [];
        var declarations = [];
        var flattenContext = {
          context,
          level,
          downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
          hoistTempVariables,
          emitExpression,
          emitBindingOrAssignment,
          createArrayBindingOrAssignmentPattern: function(elements) {
            return makeArrayBindingPattern(context.factory, elements);
          },
          createObjectBindingOrAssignmentPattern: function(elements) {
            return makeObjectBindingPattern(context.factory, elements);
          },
          createArrayBindingOrAssignmentElement: function(name2) {
            return makeBindingElement(context.factory, name2);
          },
          visitor
        };
        if (ts3.isVariableDeclaration(node)) {
          var initializer = ts3.getInitializerOfBindingOrAssignmentElement(node);
          if (initializer && (ts3.isIdentifier(initializer) && bindingOrAssignmentElementAssignsToName(node, initializer.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node))) {
            initializer = ensureIdentifier(flattenContext, ts3.visitNode(initializer, flattenContext.visitor), false, initializer);
            node = context.factory.updateVariableDeclaration(node, node.name, void 0, void 0, initializer);
          }
        }
        flattenBindingOrAssignmentElement(flattenContext, node, rval, node, skipInitializer);
        if (pendingExpressions) {
          var temp = context.factory.createTempVariable(void 0);
          if (hoistTempVariables) {
            var value = context.factory.inlineExpressions(pendingExpressions);
            pendingExpressions = void 0;
            emitBindingOrAssignment(temp, value, void 0, void 0);
          } else {
            context.hoistVariableDeclaration(temp);
            var pendingDeclaration = ts3.last(pendingDeclarations);
            pendingDeclaration.pendingExpressions = ts3.append(pendingDeclaration.pendingExpressions, context.factory.createAssignment(temp, pendingDeclaration.value));
            ts3.addRange(pendingDeclaration.pendingExpressions, pendingExpressions);
            pendingDeclaration.value = temp;
          }
        }
        for (var _i = 0, pendingDeclarations_1 = pendingDeclarations; _i < pendingDeclarations_1.length; _i++) {
          var _a = pendingDeclarations_1[_i], pendingExpressions_1 = _a.pendingExpressions, name = _a.name, value = _a.value, location = _a.location, original = _a.original;
          var variable = context.factory.createVariableDeclaration(name, void 0, void 0, pendingExpressions_1 ? context.factory.inlineExpressions(ts3.append(pendingExpressions_1, value)) : value);
          variable.original = original;
          ts3.setTextRange(variable, location);
          declarations.push(variable);
        }
        return declarations;
        function emitExpression(value2) {
          pendingExpressions = ts3.append(pendingExpressions, value2);
        }
        function emitBindingOrAssignment(target, value2, location2, original2) {
          ts3.Debug.assertNode(target, ts3.isBindingName);
          if (pendingExpressions) {
            value2 = context.factory.inlineExpressions(ts3.append(pendingExpressions, value2));
            pendingExpressions = void 0;
          }
          pendingDeclarations.push({ pendingExpressions, name: target, value: value2, location: location2, original: original2 });
        }
      }
      ts3.flattenDestructuringBinding = flattenDestructuringBinding;
      function flattenBindingOrAssignmentElement(flattenContext, element, value, location, skipInitializer) {
        var bindingTarget = ts3.getTargetOfBindingOrAssignmentElement(element);
        if (!skipInitializer) {
          var initializer = ts3.visitNode(ts3.getInitializerOfBindingOrAssignmentElement(element), flattenContext.visitor, ts3.isExpression);
          if (initializer) {
            if (value) {
              value = createDefaultValueCheck(flattenContext, value, initializer, location);
              if (!ts3.isSimpleInlineableExpression(initializer) && ts3.isBindingOrAssignmentPattern(bindingTarget)) {
                value = ensureIdentifier(flattenContext, value, true, location);
              }
            } else {
              value = initializer;
            }
          } else if (!value) {
            value = flattenContext.context.factory.createVoidZero();
          }
        }
        if (ts3.isObjectBindingOrAssignmentPattern(bindingTarget)) {
          flattenObjectBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
        } else if (ts3.isArrayBindingOrAssignmentPattern(bindingTarget)) {
          flattenArrayBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
        } else {
          flattenContext.emitBindingOrAssignment(bindingTarget, value, location, element);
        }
      }
      function flattenObjectBindingOrAssignmentPattern(flattenContext, parent, pattern, value, location) {
        var elements = ts3.getElementsOfBindingOrAssignmentPattern(pattern);
        var numElements = elements.length;
        if (numElements !== 1) {
          var reuseIdentifierExpressions = !ts3.isDeclarationBindingElement(parent) || numElements !== 0;
          value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
        }
        var bindingElements;
        var computedTempVariables;
        for (var i = 0; i < numElements; i++) {
          var element = elements[i];
          if (!ts3.getRestIndicatorOfBindingOrAssignmentElement(element)) {
            var propertyName = ts3.getPropertyNameOfBindingOrAssignmentElement(element);
            if (flattenContext.level >= 1 && !(element.transformFlags & (16384 | 32768)) && !(ts3.getTargetOfBindingOrAssignmentElement(element).transformFlags & (16384 | 32768)) && !ts3.isComputedPropertyName(propertyName)) {
              bindingElements = ts3.append(bindingElements, ts3.visitNode(element, flattenContext.visitor));
            } else {
              if (bindingElements) {
                flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
                bindingElements = void 0;
              }
              var rhsValue = createDestructuringPropertyAccess(flattenContext, value, propertyName);
              if (ts3.isComputedPropertyName(propertyName)) {
                computedTempVariables = ts3.append(computedTempVariables, rhsValue.argumentExpression);
              }
              flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
            }
          } else if (i === numElements - 1) {
            if (bindingElements) {
              flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
              bindingElements = void 0;
            }
            var rhsValue = flattenContext.context.getEmitHelperFactory().createRestHelper(value, elements, computedTempVariables, pattern);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          }
        }
        if (bindingElements) {
          flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
        }
      }
      function flattenArrayBindingOrAssignmentPattern(flattenContext, parent, pattern, value, location) {
        var elements = ts3.getElementsOfBindingOrAssignmentPattern(pattern);
        var numElements = elements.length;
        if (flattenContext.level < 1 && flattenContext.downlevelIteration) {
          value = ensureIdentifier(flattenContext, ts3.setTextRange(flattenContext.context.getEmitHelperFactory().createReadHelper(value, numElements > 0 && ts3.getRestIndicatorOfBindingOrAssignmentElement(elements[numElements - 1]) ? void 0 : numElements), location), false, location);
        } else if (numElements !== 1 && (flattenContext.level < 1 || numElements === 0) || ts3.every(elements, ts3.isOmittedExpression)) {
          var reuseIdentifierExpressions = !ts3.isDeclarationBindingElement(parent) || numElements !== 0;
          value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
        }
        var bindingElements;
        var restContainingElements;
        for (var i = 0; i < numElements; i++) {
          var element = elements[i];
          if (flattenContext.level >= 1) {
            if (element.transformFlags & 32768 || flattenContext.hasTransformedPriorElement && !isSimpleBindingOrAssignmentElement(element)) {
              flattenContext.hasTransformedPriorElement = true;
              var temp = flattenContext.context.factory.createTempVariable(void 0);
              if (flattenContext.hoistTempVariables) {
                flattenContext.context.hoistVariableDeclaration(temp);
              }
              restContainingElements = ts3.append(restContainingElements, [temp, element]);
              bindingElements = ts3.append(bindingElements, flattenContext.createArrayBindingOrAssignmentElement(temp));
            } else {
              bindingElements = ts3.append(bindingElements, element);
            }
          } else if (ts3.isOmittedExpression(element)) {
            continue;
          } else if (!ts3.getRestIndicatorOfBindingOrAssignmentElement(element)) {
            var rhsValue = flattenContext.context.factory.createElementAccessExpression(value, i);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          } else if (i === numElements - 1) {
            var rhsValue = flattenContext.context.factory.createArraySliceCall(value, i);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          }
        }
        if (bindingElements) {
          flattenContext.emitBindingOrAssignment(flattenContext.createArrayBindingOrAssignmentPattern(bindingElements), value, location, pattern);
        }
        if (restContainingElements) {
          for (var _i = 0, restContainingElements_1 = restContainingElements; _i < restContainingElements_1.length; _i++) {
            var _a = restContainingElements_1[_i], id = _a[0], element = _a[1];
            flattenBindingOrAssignmentElement(flattenContext, element, id, element);
          }
        }
      }
      function isSimpleBindingOrAssignmentElement(element) {
        var target = ts3.getTargetOfBindingOrAssignmentElement(element);
        if (!target || ts3.isOmittedExpression(target))
          return true;
        var propertyName = ts3.tryGetPropertyNameOfBindingOrAssignmentElement(element);
        if (propertyName && !ts3.isPropertyNameLiteral(propertyName))
          return false;
        var initializer = ts3.getInitializerOfBindingOrAssignmentElement(element);
        if (initializer && !ts3.isSimpleInlineableExpression(initializer))
          return false;
        if (ts3.isBindingOrAssignmentPattern(target))
          return ts3.every(ts3.getElementsOfBindingOrAssignmentPattern(target), isSimpleBindingOrAssignmentElement);
        return ts3.isIdentifier(target);
      }
      function createDefaultValueCheck(flattenContext, value, defaultValue, location) {
        value = ensureIdentifier(flattenContext, value, true, location);
        return flattenContext.context.factory.createConditionalExpression(flattenContext.context.factory.createTypeCheck(value, "undefined"), void 0, defaultValue, void 0, value);
      }
      function createDestructuringPropertyAccess(flattenContext, value, propertyName) {
        if (ts3.isComputedPropertyName(propertyName)) {
          var argumentExpression = ensureIdentifier(flattenContext, ts3.visitNode(propertyName.expression, flattenContext.visitor), false, propertyName);
          return flattenContext.context.factory.createElementAccessExpression(value, argumentExpression);
        } else if (ts3.isStringOrNumericLiteralLike(propertyName)) {
          var argumentExpression = ts3.factory.cloneNode(propertyName);
          return flattenContext.context.factory.createElementAccessExpression(value, argumentExpression);
        } else {
          var name = flattenContext.context.factory.createIdentifier(ts3.idText(propertyName));
          return flattenContext.context.factory.createPropertyAccessExpression(value, name);
        }
      }
      function ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location) {
        if (ts3.isIdentifier(value) && reuseIdentifierExpressions) {
          return value;
        } else {
          var temp = flattenContext.context.factory.createTempVariable(void 0);
          if (flattenContext.hoistTempVariables) {
            flattenContext.context.hoistVariableDeclaration(temp);
            flattenContext.emitExpression(ts3.setTextRange(flattenContext.context.factory.createAssignment(temp, value), location));
          } else {
            flattenContext.emitBindingOrAssignment(temp, value, location, void 0);
          }
          return temp;
        }
      }
      function makeArrayBindingPattern(factory, elements) {
        ts3.Debug.assertEachNode(elements, ts3.isArrayBindingElement);
        return factory.createArrayBindingPattern(elements);
      }
      function makeArrayAssignmentPattern(factory, elements) {
        return factory.createArrayLiteralExpression(ts3.map(elements, factory.converters.convertToArrayAssignmentElement));
      }
      function makeObjectBindingPattern(factory, elements) {
        ts3.Debug.assertEachNode(elements, ts3.isBindingElement);
        return factory.createObjectBindingPattern(elements);
      }
      function makeObjectAssignmentPattern(factory, elements) {
        return factory.createObjectLiteralExpression(ts3.map(elements, factory.converters.convertToObjectAssignmentElement));
      }
      function makeBindingElement(factory, name) {
        return factory.createBindingElement(void 0, void 0, name);
      }
      function makeAssignmentElement(name) {
        return name;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ProcessLevel;
      (function(ProcessLevel2) {
        ProcessLevel2[ProcessLevel2["LiftRestriction"] = 0] = "LiftRestriction";
        ProcessLevel2[ProcessLevel2["All"] = 1] = "All";
      })(ProcessLevel = ts3.ProcessLevel || (ts3.ProcessLevel = {}));
      function processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, level) {
        var tag = ts3.visitNode(node.tag, visitor, ts3.isExpression);
        var templateArguments = [void 0];
        var cookedStrings = [];
        var rawStrings = [];
        var template = node.template;
        if (level === ProcessLevel.LiftRestriction && !ts3.hasInvalidEscape(template)) {
          return ts3.visitEachChild(node, visitor, context);
        }
        if (ts3.isNoSubstitutionTemplateLiteral(template)) {
          cookedStrings.push(createTemplateCooked(template));
          rawStrings.push(getRawLiteral(template, currentSourceFile));
        } else {
          cookedStrings.push(createTemplateCooked(template.head));
          rawStrings.push(getRawLiteral(template.head, currentSourceFile));
          for (var _i = 0, _a = template.templateSpans; _i < _a.length; _i++) {
            var templateSpan = _a[_i];
            cookedStrings.push(createTemplateCooked(templateSpan.literal));
            rawStrings.push(getRawLiteral(templateSpan.literal, currentSourceFile));
            templateArguments.push(ts3.visitNode(templateSpan.expression, visitor, ts3.isExpression));
          }
        }
        var helperCall = context.getEmitHelperFactory().createTemplateObjectHelper(ts3.factory.createArrayLiteralExpression(cookedStrings), ts3.factory.createArrayLiteralExpression(rawStrings));
        if (ts3.isExternalModule(currentSourceFile)) {
          var tempVar = ts3.factory.createUniqueName("templateObject");
          recordTaggedTemplateString(tempVar);
          templateArguments[0] = ts3.factory.createLogicalOr(tempVar, ts3.factory.createAssignment(tempVar, helperCall));
        } else {
          templateArguments[0] = helperCall;
        }
        return ts3.factory.createCallExpression(tag, void 0, templateArguments);
      }
      ts3.processTaggedTemplateExpression = processTaggedTemplateExpression;
      function createTemplateCooked(template) {
        return template.templateFlags ? ts3.factory.createVoidZero() : ts3.factory.createStringLiteral(template.text);
      }
      function getRawLiteral(node, currentSourceFile) {
        var text = node.rawText;
        if (text === void 0) {
          ts3.Debug.assertIsDefined(currentSourceFile, "Template literal node is missing 'rawText' and does not have a source file. Possibly bad transform.");
          text = ts3.getSourceTextOfNodeFromSourceFile(currentSourceFile, node);
          var isLast = node.kind === 14 || node.kind === 17;
          text = text.substring(1, text.length - (isLast ? 1 : 2));
        }
        text = text.replace(/\r\n?/g, "\n");
        return ts3.setTextRange(ts3.factory.createStringLiteral(text), node);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var USE_NEW_TYPE_METADATA_FORMAT = false;
      var TypeScriptSubstitutionFlags;
      (function(TypeScriptSubstitutionFlags2) {
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["ClassAliases"] = 1] = "ClassAliases";
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["NamespaceExports"] = 2] = "NamespaceExports";
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["NonQualifiedEnumMembers"] = 8] = "NonQualifiedEnumMembers";
      })(TypeScriptSubstitutionFlags || (TypeScriptSubstitutionFlags = {}));
      var ClassFacts;
      (function(ClassFacts2) {
        ClassFacts2[ClassFacts2["None"] = 0] = "None";
        ClassFacts2[ClassFacts2["HasStaticInitializedProperties"] = 1] = "HasStaticInitializedProperties";
        ClassFacts2[ClassFacts2["HasConstructorDecorators"] = 2] = "HasConstructorDecorators";
        ClassFacts2[ClassFacts2["HasMemberDecorators"] = 4] = "HasMemberDecorators";
        ClassFacts2[ClassFacts2["IsExportOfNamespace"] = 8] = "IsExportOfNamespace";
        ClassFacts2[ClassFacts2["IsNamedExternalExport"] = 16] = "IsNamedExternalExport";
        ClassFacts2[ClassFacts2["IsDefaultExternalExport"] = 32] = "IsDefaultExternalExport";
        ClassFacts2[ClassFacts2["IsDerivedClass"] = 64] = "IsDerivedClass";
        ClassFacts2[ClassFacts2["UseImmediatelyInvokedFunctionExpression"] = 128] = "UseImmediatelyInvokedFunctionExpression";
        ClassFacts2[ClassFacts2["HasAnyDecorators"] = 6] = "HasAnyDecorators";
        ClassFacts2[ClassFacts2["NeedsName"] = 5] = "NeedsName";
        ClassFacts2[ClassFacts2["MayNeedImmediatelyInvokedFunctionExpression"] = 7] = "MayNeedImmediatelyInvokedFunctionExpression";
        ClassFacts2[ClassFacts2["IsExported"] = 56] = "IsExported";
      })(ClassFacts || (ClassFacts = {}));
      function transformTypeScript(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var strictNullChecks = ts3.getStrictOptionValue(compilerOptions, "strictNullChecks");
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableSubstitution(206);
        context.enableSubstitution(207);
        var currentSourceFile;
        var currentNamespace;
        var currentNamespaceContainerName;
        var currentLexicalScope;
        var currentNameScope;
        var currentScopeFirstDeclarationsOfName;
        var currentClassHasParameterProperties;
        var enabledSubstitutions;
        var classAliases;
        var applicableSubstitutions;
        return transformSourceFileOrBundle;
        function transformSourceFileOrBundle(node) {
          if (node.kind === 306) {
            return transformBundle(node);
          }
          return transformSourceFile(node);
        }
        function transformBundle(node) {
          return factory.createBundle(node.sourceFiles.map(transformSourceFile), ts3.mapDefined(node.prepends, function(prepend) {
            if (prepend.kind === 308) {
              return ts3.createUnparsedSourceFile(prepend, "js");
            }
            return prepend;
          }));
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = saveStateAndInvoke(node, visitSourceFile);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          return visited;
        }
        function saveStateAndInvoke(node, f) {
          var savedCurrentScope = currentLexicalScope;
          var savedCurrentNameScope = currentNameScope;
          var savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
          var savedCurrentClassHasParameterProperties = currentClassHasParameterProperties;
          onBeforeVisitNode(node);
          var visited = f(node);
          if (currentLexicalScope !== savedCurrentScope) {
            currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
          }
          currentLexicalScope = savedCurrentScope;
          currentNameScope = savedCurrentNameScope;
          currentClassHasParameterProperties = savedCurrentClassHasParameterProperties;
          return visited;
        }
        function onBeforeVisitNode(node) {
          switch (node.kind) {
            case 305:
            case 263:
            case 262:
            case 235:
              currentLexicalScope = node;
              currentNameScope = void 0;
              currentScopeFirstDeclarationsOfName = void 0;
              break;
            case 257:
            case 256:
              if (ts3.hasSyntacticModifier(node, 2)) {
                break;
              }
              if (node.name) {
                recordEmittedDeclarationInScope(node);
              } else {
                ts3.Debug.assert(node.kind === 257 || ts3.hasSyntacticModifier(node, 512));
              }
              if (ts3.isClassDeclaration(node)) {
                currentNameScope = node;
              }
              break;
          }
        }
        function visitor(node) {
          return saveStateAndInvoke(node, visitorWorker);
        }
        function visitorWorker(node) {
          if (node.transformFlags & 1) {
            return visitTypeScript(node);
          }
          return node;
        }
        function sourceElementVisitor(node) {
          return saveStateAndInvoke(node, sourceElementVisitorWorker);
        }
        function sourceElementVisitorWorker(node) {
          switch (node.kind) {
            case 266:
            case 265:
            case 271:
            case 272:
              return visitElidableStatement(node);
            default:
              return visitorWorker(node);
          }
        }
        function visitElidableStatement(node) {
          var parsed = ts3.getParseTreeNode(node);
          if (parsed !== node) {
            if (node.transformFlags & 1) {
              return ts3.visitEachChild(node, visitor, context);
            }
            return node;
          }
          switch (node.kind) {
            case 266:
              return visitImportDeclaration(node);
            case 265:
              return visitImportEqualsDeclaration(node);
            case 271:
              return visitExportAssignment(node);
            case 272:
              return visitExportDeclaration(node);
            default:
              ts3.Debug.fail("Unhandled ellided statement");
          }
        }
        function namespaceElementVisitor(node) {
          return saveStateAndInvoke(node, namespaceElementVisitorWorker);
        }
        function namespaceElementVisitorWorker(node) {
          if (node.kind === 272 || node.kind === 266 || node.kind === 267 || node.kind === 265 && node.moduleReference.kind === 277) {
            return void 0;
          } else if (node.transformFlags & 1 || ts3.hasSyntacticModifier(node, 1)) {
            return visitTypeScript(node);
          }
          return node;
        }
        function classElementVisitor(node) {
          return saveStateAndInvoke(node, classElementVisitorWorker);
        }
        function classElementVisitorWorker(node) {
          switch (node.kind) {
            case 171:
              return visitConstructor(node);
            case 167:
              return visitPropertyDeclaration(node);
            case 176:
            case 172:
            case 173:
            case 169:
            case 170:
              return visitorWorker(node);
            case 234:
              return node;
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function modifierVisitor(node) {
          if (ts3.modifierToFlag(node.kind) & 116958) {
            return void 0;
          } else if (currentNamespace && node.kind === 93) {
            return void 0;
          }
          return node;
        }
        function visitTypeScript(node) {
          if (ts3.isStatement(node) && ts3.hasSyntacticModifier(node, 2)) {
            return factory.createNotEmittedStatement(node);
          }
          switch (node.kind) {
            case 93:
            case 88:
              return currentNamespace ? void 0 : node;
            case 123:
            case 121:
            case 122:
            case 126:
            case 159:
            case 85:
            case 135:
            case 145:
            case 101:
            case 144:
            case 183:
            case 184:
            case 185:
            case 186:
            case 182:
            case 177:
            case 163:
            case 130:
            case 155:
            case 133:
            case 150:
            case 147:
            case 143:
            case 114:
            case 151:
            case 180:
            case 179:
            case 181:
            case 178:
            case 187:
            case 188:
            case 189:
            case 191:
            case 192:
            case 193:
            case 194:
            case 195:
            case 196:
            case 176:
            case 165:
              return void 0;
            case 259:
              return factory.createNotEmittedStatement(node);
            case 167:
              return visitPropertyDeclaration(node);
            case 264:
              return void 0;
            case 171:
              return visitConstructor(node);
            case 258:
              return factory.createNotEmittedStatement(node);
            case 257:
              return visitClassDeclaration(node);
            case 226:
              return visitClassExpression(node);
            case 291:
              return visitHeritageClause(node);
            case 228:
              return visitExpressionWithTypeArguments(node);
            case 169:
              return visitMethodDeclaration(node);
            case 172:
              return visitGetAccessor(node);
            case 173:
              return visitSetAccessor(node);
            case 256:
              return visitFunctionDeclaration(node);
            case 213:
              return visitFunctionExpression(node);
            case 214:
              return visitArrowFunction(node);
            case 164:
              return visitParameter(node);
            case 212:
              return visitParenthesizedExpression(node);
            case 211:
            case 229:
              return visitAssertionExpression(node);
            case 208:
              return visitCallExpression(node);
            case 209:
              return visitNewExpression(node);
            case 210:
              return visitTaggedTemplateExpression(node);
            case 230:
              return visitNonNullExpression(node);
            case 260:
              return visitEnumDeclaration(node);
            case 237:
              return visitVariableStatement(node);
            case 254:
              return visitVariableDeclaration(node);
            case 261:
              return visitModuleDeclaration(node);
            case 265:
              return visitImportEqualsDeclaration(node);
            case 279:
              return visitJsxSelfClosingElement(node);
            case 280:
              return visitJsxJsxOpeningElement(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitSourceFile(node) {
          var alwaysStrict = ts3.getStrictOptionValue(compilerOptions, "alwaysStrict") && !(ts3.isExternalModule(node) && moduleKind >= ts3.ModuleKind.ES2015) && !ts3.isJsonSourceFile(node);
          return factory.updateSourceFile(node, ts3.visitLexicalEnvironment(node.statements, sourceElementVisitor, context, 0, alwaysStrict));
        }
        function getClassFacts(node, staticProperties) {
          var facts = 0;
          if (ts3.some(staticProperties))
            facts |= 1;
          var extendsClauseElement = ts3.getEffectiveBaseTypeNode(node);
          if (extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 104)
            facts |= 64;
          if (ts3.classOrConstructorParameterIsDecorated(node))
            facts |= 2;
          if (ts3.childIsDecorated(node))
            facts |= 4;
          if (isExportOfNamespace(node))
            facts |= 8;
          else if (isDefaultExternalModuleExport(node))
            facts |= 32;
          else if (isNamedExternalModuleExport(node))
            facts |= 16;
          if (languageVersion <= 1 && facts & 7)
            facts |= 128;
          return facts;
        }
        function hasTypeScriptClassSyntax(node) {
          return !!(node.transformFlags & 4096);
        }
        function isClassLikeDeclarationWithTypeScriptSyntax(node) {
          return ts3.some(node.decorators) || ts3.some(node.typeParameters) || ts3.some(node.heritageClauses, hasTypeScriptClassSyntax) || ts3.some(node.members, hasTypeScriptClassSyntax);
        }
        function visitClassDeclaration(node) {
          if (!isClassLikeDeclarationWithTypeScriptSyntax(node) && !(currentNamespace && ts3.hasSyntacticModifier(node, 1))) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var staticProperties = ts3.getProperties(node, true, true);
          var facts = getClassFacts(node, staticProperties);
          if (facts & 128) {
            context.startLexicalEnvironment();
          }
          var name = node.name || (facts & 5 ? factory.getGeneratedNameForNode(node) : void 0);
          var classStatement = facts & 2 ? createClassDeclarationHeadWithDecorators(node, name) : createClassDeclarationHeadWithoutDecorators(node, name, facts);
          var statements = [classStatement];
          addClassElementDecorationStatements(statements, node, false);
          addClassElementDecorationStatements(statements, node, true);
          addConstructorDecorationStatement(statements, node);
          if (facts & 128) {
            var closingBraceLocation = ts3.createTokenRange(ts3.skipTrivia(currentSourceFile.text, node.members.end), 19);
            var localName = factory.getInternalName(node);
            var outer = factory.createPartiallyEmittedExpression(localName);
            ts3.setTextRangeEnd(outer, closingBraceLocation.end);
            ts3.setEmitFlags(outer, 1536);
            var statement = factory.createReturnStatement(outer);
            ts3.setTextRangePos(statement, closingBraceLocation.pos);
            ts3.setEmitFlags(statement, 1536 | 384);
            statements.push(statement);
            ts3.insertStatementsAfterStandardPrologue(statements, context.endLexicalEnvironment());
            var iife = factory.createImmediatelyInvokedArrowFunction(statements);
            ts3.setEmitFlags(iife, 33554432);
            var varStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(factory.getLocalName(node, false, false), void 0, void 0, iife)
            ]));
            ts3.setOriginalNode(varStatement, node);
            ts3.setCommentRange(varStatement, node);
            ts3.setSourceMapRange(varStatement, ts3.moveRangePastDecorators(node));
            ts3.startOnNewLine(varStatement);
            statements = [varStatement];
          }
          if (facts & 8) {
            addExportMemberAssignment(statements, node);
          } else if (facts & 128 || facts & 2) {
            if (facts & 32) {
              statements.push(factory.createExportDefault(factory.getLocalName(node, false, true)));
            } else if (facts & 16) {
              statements.push(factory.createExternalModuleExport(factory.getLocalName(node, false, true)));
            }
          }
          if (statements.length > 1) {
            statements.push(factory.createEndOfDeclarationMarker(node));
            ts3.setEmitFlags(classStatement, ts3.getEmitFlags(classStatement) | 4194304);
          }
          return ts3.singleOrMany(statements);
        }
        function createClassDeclarationHeadWithoutDecorators(node, name, facts) {
          var modifiers = !(facts & 128) ? ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier) : void 0;
          var classDeclaration = factory.createClassDeclaration(void 0, modifiers, name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), transformClassMembers(node));
          var emitFlags = ts3.getEmitFlags(node);
          if (facts & 1) {
            emitFlags |= 32;
          }
          ts3.setTextRange(classDeclaration, node);
          ts3.setOriginalNode(classDeclaration, node);
          ts3.setEmitFlags(classDeclaration, emitFlags);
          return classDeclaration;
        }
        function createClassDeclarationHeadWithDecorators(node, name) {
          var location = ts3.moveRangePastDecorators(node);
          var classAlias = getClassAliasIfNeeded(node);
          var declName = languageVersion <= 2 ? factory.getInternalName(node, false, true) : factory.getLocalName(node, false, true);
          var heritageClauses = ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause);
          var members = transformClassMembers(node);
          var classExpression = factory.createClassExpression(void 0, void 0, name, void 0, heritageClauses, members);
          ts3.setOriginalNode(classExpression, node);
          ts3.setTextRange(classExpression, location);
          var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(declName, void 0, void 0, classAlias ? factory.createAssignment(classAlias, classExpression) : classExpression)
          ], 1));
          ts3.setOriginalNode(statement, node);
          ts3.setTextRange(statement, location);
          ts3.setCommentRange(statement, node);
          return statement;
        }
        function visitClassExpression(node) {
          if (!isClassLikeDeclarationWithTypeScriptSyntax(node)) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var classExpression = factory.createClassExpression(void 0, void 0, node.name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), transformClassMembers(node));
          ts3.setOriginalNode(classExpression, node);
          ts3.setTextRange(classExpression, node);
          return classExpression;
        }
        function transformClassMembers(node) {
          var members = [];
          var constructor = ts3.getFirstConstructorWithBody(node);
          var parametersWithPropertyAssignments = constructor && ts3.filter(constructor.parameters, function(p) {
            return ts3.isParameterPropertyDeclaration(p, constructor);
          });
          if (parametersWithPropertyAssignments) {
            for (var _i = 0, parametersWithPropertyAssignments_1 = parametersWithPropertyAssignments; _i < parametersWithPropertyAssignments_1.length; _i++) {
              var parameter = parametersWithPropertyAssignments_1[_i];
              if (ts3.isIdentifier(parameter.name)) {
                members.push(ts3.setOriginalNode(factory.createPropertyDeclaration(void 0, void 0, parameter.name, void 0, void 0, void 0), parameter));
              }
            }
          }
          ts3.addRange(members, ts3.visitNodes(node.members, classElementVisitor, ts3.isClassElement));
          return ts3.setTextRange(factory.createNodeArray(members), node.members);
        }
        function getDecoratedClassElements(node, isStatic) {
          return ts3.filter(node.members, isStatic ? function(m) {
            return isStaticDecoratedClassElement(m, node);
          } : function(m) {
            return isInstanceDecoratedClassElement(m, node);
          });
        }
        function isStaticDecoratedClassElement(member, parent) {
          return isDecoratedClassElement(member, true, parent);
        }
        function isInstanceDecoratedClassElement(member, parent) {
          return isDecoratedClassElement(member, false, parent);
        }
        function isDecoratedClassElement(member, isStaticElement, parent) {
          return ts3.nodeOrChildIsDecorated(member, parent) && isStaticElement === ts3.isStatic(member);
        }
        function getDecoratorsOfParameters(node) {
          var decorators;
          if (node) {
            var parameters = node.parameters;
            var firstParameterIsThis = parameters.length > 0 && ts3.parameterIsThisKeyword(parameters[0]);
            var firstParameterOffset = firstParameterIsThis ? 1 : 0;
            var numParameters = firstParameterIsThis ? parameters.length - 1 : parameters.length;
            for (var i = 0; i < numParameters; i++) {
              var parameter = parameters[i + firstParameterOffset];
              if (decorators || parameter.decorators) {
                if (!decorators) {
                  decorators = new Array(numParameters);
                }
                decorators[i] = parameter.decorators;
              }
            }
          }
          return decorators;
        }
        function getAllDecoratorsOfConstructor(node) {
          var decorators = node.decorators;
          var parameters = getDecoratorsOfParameters(ts3.getFirstConstructorWithBody(node));
          if (!decorators && !parameters) {
            return void 0;
          }
          return {
            decorators,
            parameters
          };
        }
        function getAllDecoratorsOfClassElement(node, member) {
          switch (member.kind) {
            case 172:
            case 173:
              return getAllDecoratorsOfAccessors(node, member);
            case 169:
              return getAllDecoratorsOfMethod(member);
            case 167:
              return getAllDecoratorsOfProperty(member);
            default:
              return void 0;
          }
        }
        function getAllDecoratorsOfAccessors(node, accessor) {
          if (!accessor.body) {
            return void 0;
          }
          var _a = ts3.getAllAccessorDeclarations(node.members, accessor), firstAccessor = _a.firstAccessor, secondAccessor = _a.secondAccessor, setAccessor = _a.setAccessor;
          var firstAccessorWithDecorators = firstAccessor.decorators ? firstAccessor : secondAccessor && secondAccessor.decorators ? secondAccessor : void 0;
          if (!firstAccessorWithDecorators || accessor !== firstAccessorWithDecorators) {
            return void 0;
          }
          var decorators = firstAccessorWithDecorators.decorators;
          var parameters = getDecoratorsOfParameters(setAccessor);
          if (!decorators && !parameters) {
            return void 0;
          }
          return { decorators, parameters };
        }
        function getAllDecoratorsOfMethod(method) {
          if (!method.body) {
            return void 0;
          }
          var decorators = method.decorators;
          var parameters = getDecoratorsOfParameters(method);
          if (!decorators && !parameters) {
            return void 0;
          }
          return { decorators, parameters };
        }
        function getAllDecoratorsOfProperty(property) {
          var decorators = property.decorators;
          if (!decorators) {
            return void 0;
          }
          return { decorators };
        }
        function transformAllDecoratorsOfDeclaration(node, container, allDecorators) {
          if (!allDecorators) {
            return void 0;
          }
          var decoratorExpressions = [];
          ts3.addRange(decoratorExpressions, ts3.map(allDecorators.decorators, transformDecorator));
          ts3.addRange(decoratorExpressions, ts3.flatMap(allDecorators.parameters, transformDecoratorsOfParameter));
          addTypeMetadata(node, container, decoratorExpressions);
          return decoratorExpressions;
        }
        function addClassElementDecorationStatements(statements, node, isStatic) {
          ts3.addRange(statements, ts3.map(generateClassElementDecorationExpressions(node, isStatic), expressionToStatement));
        }
        function generateClassElementDecorationExpressions(node, isStatic) {
          var members = getDecoratedClassElements(node, isStatic);
          var expressions;
          for (var _i = 0, members_8 = members; _i < members_8.length; _i++) {
            var member = members_8[_i];
            var expression = generateClassElementDecorationExpression(node, member);
            if (expression) {
              if (!expressions) {
                expressions = [expression];
              } else {
                expressions.push(expression);
              }
            }
          }
          return expressions;
        }
        function generateClassElementDecorationExpression(node, member) {
          var allDecorators = getAllDecoratorsOfClassElement(node, member);
          var decoratorExpressions = transformAllDecoratorsOfDeclaration(member, node, allDecorators);
          if (!decoratorExpressions) {
            return void 0;
          }
          var prefix = getClassMemberPrefix(node, member);
          var memberName = getExpressionForPropertyName(member, !ts3.hasSyntacticModifier(member, 2));
          var descriptor = languageVersion > 0 ? member.kind === 167 ? factory.createVoidZero() : factory.createNull() : void 0;
          var helper = emitHelpers().createDecorateHelper(decoratorExpressions, prefix, memberName, descriptor);
          ts3.setTextRange(helper, ts3.moveRangePastDecorators(member));
          ts3.setEmitFlags(helper, 1536);
          return helper;
        }
        function addConstructorDecorationStatement(statements, node) {
          var expression = generateConstructorDecorationExpression(node);
          if (expression) {
            statements.push(ts3.setOriginalNode(factory.createExpressionStatement(expression), node));
          }
        }
        function generateConstructorDecorationExpression(node) {
          var allDecorators = getAllDecoratorsOfConstructor(node);
          var decoratorExpressions = transformAllDecoratorsOfDeclaration(node, node, allDecorators);
          if (!decoratorExpressions) {
            return void 0;
          }
          var classAlias = classAliases && classAliases[ts3.getOriginalNodeId(node)];
          var localName = languageVersion <= 2 ? factory.getInternalName(node, false, true) : factory.getLocalName(node, false, true);
          var decorate = emitHelpers().createDecorateHelper(decoratorExpressions, localName);
          var expression = factory.createAssignment(localName, classAlias ? factory.createAssignment(classAlias, decorate) : decorate);
          ts3.setEmitFlags(expression, 1536);
          ts3.setSourceMapRange(expression, ts3.moveRangePastDecorators(node));
          return expression;
        }
        function transformDecorator(decorator) {
          return ts3.visitNode(decorator.expression, visitor, ts3.isExpression);
        }
        function transformDecoratorsOfParameter(decorators, parameterOffset) {
          var expressions;
          if (decorators) {
            expressions = [];
            for (var _i = 0, decorators_1 = decorators; _i < decorators_1.length; _i++) {
              var decorator = decorators_1[_i];
              var helper = emitHelpers().createParamHelper(transformDecorator(decorator), parameterOffset);
              ts3.setTextRange(helper, decorator.expression);
              ts3.setEmitFlags(helper, 1536);
              expressions.push(helper);
            }
          }
          return expressions;
        }
        function addTypeMetadata(node, container, decoratorExpressions) {
          if (USE_NEW_TYPE_METADATA_FORMAT) {
            addNewTypeMetadata(node, container, decoratorExpressions);
          } else {
            addOldTypeMetadata(node, container, decoratorExpressions);
          }
        }
        function addOldTypeMetadata(node, container, decoratorExpressions) {
          if (compilerOptions.emitDecoratorMetadata) {
            if (shouldAddTypeMetadata(node)) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:type", serializeTypeOfNode(node)));
            }
            if (shouldAddParamTypesMetadata(node)) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:paramtypes", serializeParameterTypesOfNode(node, container)));
            }
            if (shouldAddReturnTypeMetadata(node)) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:returntype", serializeReturnTypeOfNode(node)));
            }
          }
        }
        function addNewTypeMetadata(node, container, decoratorExpressions) {
          if (compilerOptions.emitDecoratorMetadata) {
            var properties = void 0;
            if (shouldAddTypeMetadata(node)) {
              (properties || (properties = [])).push(factory.createPropertyAssignment("type", factory.createArrowFunction(void 0, void 0, [], void 0, factory.createToken(38), serializeTypeOfNode(node))));
            }
            if (shouldAddParamTypesMetadata(node)) {
              (properties || (properties = [])).push(factory.createPropertyAssignment("paramTypes", factory.createArrowFunction(void 0, void 0, [], void 0, factory.createToken(38), serializeParameterTypesOfNode(node, container))));
            }
            if (shouldAddReturnTypeMetadata(node)) {
              (properties || (properties = [])).push(factory.createPropertyAssignment("returnType", factory.createArrowFunction(void 0, void 0, [], void 0, factory.createToken(38), serializeReturnTypeOfNode(node))));
            }
            if (properties) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:typeinfo", factory.createObjectLiteralExpression(properties, true)));
            }
          }
        }
        function shouldAddTypeMetadata(node) {
          var kind = node.kind;
          return kind === 169 || kind === 172 || kind === 173 || kind === 167;
        }
        function shouldAddReturnTypeMetadata(node) {
          return node.kind === 169;
        }
        function shouldAddParamTypesMetadata(node) {
          switch (node.kind) {
            case 257:
            case 226:
              return ts3.getFirstConstructorWithBody(node) !== void 0;
            case 169:
            case 172:
            case 173:
              return true;
          }
          return false;
        }
        function getAccessorTypeNode(node) {
          var accessors = resolver.getAllAccessorDeclarations(node);
          return accessors.setAccessor && ts3.getSetAccessorTypeAnnotationNode(accessors.setAccessor) || accessors.getAccessor && ts3.getEffectiveReturnTypeNode(accessors.getAccessor);
        }
        function serializeTypeOfNode(node) {
          switch (node.kind) {
            case 167:
            case 164:
              return serializeTypeNode(node.type);
            case 173:
            case 172:
              return serializeTypeNode(getAccessorTypeNode(node));
            case 257:
            case 226:
            case 169:
              return factory.createIdentifier("Function");
            default:
              return factory.createVoidZero();
          }
        }
        function serializeParameterTypesOfNode(node, container) {
          var valueDeclaration = ts3.isClassLike(node) ? ts3.getFirstConstructorWithBody(node) : ts3.isFunctionLike(node) && ts3.nodeIsPresent(node.body) ? node : void 0;
          var expressions = [];
          if (valueDeclaration) {
            var parameters = getParametersOfDecoratedDeclaration(valueDeclaration, container);
            var numParameters = parameters.length;
            for (var i = 0; i < numParameters; i++) {
              var parameter = parameters[i];
              if (i === 0 && ts3.isIdentifier(parameter.name) && parameter.name.escapedText === "this") {
                continue;
              }
              if (parameter.dotDotDotToken) {
                expressions.push(serializeTypeNode(ts3.getRestParameterElementType(parameter.type)));
              } else {
                expressions.push(serializeTypeOfNode(parameter));
              }
            }
          }
          return factory.createArrayLiteralExpression(expressions);
        }
        function getParametersOfDecoratedDeclaration(node, container) {
          if (container && node.kind === 172) {
            var setAccessor = ts3.getAllAccessorDeclarations(container.members, node).setAccessor;
            if (setAccessor) {
              return setAccessor.parameters;
            }
          }
          return node.parameters;
        }
        function serializeReturnTypeOfNode(node) {
          if (ts3.isFunctionLike(node) && node.type) {
            return serializeTypeNode(node.type);
          } else if (ts3.isAsyncFunction(node)) {
            return factory.createIdentifier("Promise");
          }
          return factory.createVoidZero();
        }
        function serializeTypeNode(node) {
          if (node === void 0) {
            return factory.createIdentifier("Object");
          }
          switch (node.kind) {
            case 114:
            case 153:
            case 143:
              return factory.createVoidZero();
            case 191:
              return serializeTypeNode(node.type);
            case 179:
            case 180:
              return factory.createIdentifier("Function");
            case 183:
            case 184:
              return factory.createIdentifier("Array");
            case 177:
            case 133:
              return factory.createIdentifier("Boolean");
            case 198:
            case 150:
              return factory.createIdentifier("String");
            case 148:
              return factory.createIdentifier("Object");
            case 196:
              switch (node.literal.kind) {
                case 10:
                case 14:
                  return factory.createIdentifier("String");
                case 219:
                case 8:
                  return factory.createIdentifier("Number");
                case 9:
                  return getGlobalBigIntNameWithFallback();
                case 110:
                case 95:
                  return factory.createIdentifier("Boolean");
                case 104:
                  return factory.createVoidZero();
                default:
                  return ts3.Debug.failBadSyntaxKind(node.literal);
              }
            case 147:
              return factory.createIdentifier("Number");
            case 158:
              return getGlobalBigIntNameWithFallback();
            case 151:
              return languageVersion < 2 ? getGlobalSymbolNameWithFallback() : factory.createIdentifier("Symbol");
            case 178:
              return serializeTypeReferenceNode(node);
            case 188:
            case 187:
              return serializeTypeList(node.types);
            case 189:
              return serializeTypeList([node.trueType, node.falseType]);
            case 193:
              if (node.operator === 145) {
                return serializeTypeNode(node.type);
              }
              break;
            case 181:
            case 194:
            case 195:
            case 182:
            case 130:
            case 155:
            case 192:
            case 200:
              break;
            case 312:
            case 313:
            case 317:
            case 318:
            case 319:
              break;
            case 314:
            case 315:
            case 316:
              return serializeTypeNode(node.type);
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
          return factory.createIdentifier("Object");
        }
        function serializeTypeList(types2) {
          var serializedUnion;
          for (var _i = 0, types_23 = types2; _i < types_23.length; _i++) {
            var typeNode = types_23[_i];
            while (typeNode.kind === 191) {
              typeNode = typeNode.type;
            }
            if (typeNode.kind === 143) {
              continue;
            }
            if (!strictNullChecks && (typeNode.kind === 196 && typeNode.literal.kind === 104 || typeNode.kind === 153)) {
              continue;
            }
            var serializedIndividual = serializeTypeNode(typeNode);
            if (ts3.isIdentifier(serializedIndividual) && serializedIndividual.escapedText === "Object") {
              return serializedIndividual;
            } else if (serializedUnion) {
              if (!ts3.isIdentifier(serializedUnion) || !ts3.isIdentifier(serializedIndividual) || serializedUnion.escapedText !== serializedIndividual.escapedText) {
                return factory.createIdentifier("Object");
              }
            } else {
              serializedUnion = serializedIndividual;
            }
          }
          return serializedUnion || factory.createVoidZero();
        }
        function serializeTypeReferenceNode(node) {
          var kind = resolver.getTypeReferenceSerializationKind(node.typeName, currentNameScope || currentLexicalScope);
          switch (kind) {
            case ts3.TypeReferenceSerializationKind.Unknown:
              if (ts3.findAncestor(node, function(n) {
                return n.parent && ts3.isConditionalTypeNode(n.parent) && (n.parent.trueType === n || n.parent.falseType === n);
              })) {
                return factory.createIdentifier("Object");
              }
              var serialized = serializeEntityNameAsExpressionFallback(node.typeName);
              var temp = factory.createTempVariable(hoistVariableDeclaration);
              return factory.createConditionalExpression(factory.createTypeCheck(factory.createAssignment(temp, serialized), "function"), void 0, temp, void 0, factory.createIdentifier("Object"));
            case ts3.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:
              return serializeEntityNameAsExpression(node.typeName);
            case ts3.TypeReferenceSerializationKind.VoidNullableOrNeverType:
              return factory.createVoidZero();
            case ts3.TypeReferenceSerializationKind.BigIntLikeType:
              return getGlobalBigIntNameWithFallback();
            case ts3.TypeReferenceSerializationKind.BooleanType:
              return factory.createIdentifier("Boolean");
            case ts3.TypeReferenceSerializationKind.NumberLikeType:
              return factory.createIdentifier("Number");
            case ts3.TypeReferenceSerializationKind.StringLikeType:
              return factory.createIdentifier("String");
            case ts3.TypeReferenceSerializationKind.ArrayLikeType:
              return factory.createIdentifier("Array");
            case ts3.TypeReferenceSerializationKind.ESSymbolType:
              return languageVersion < 2 ? getGlobalSymbolNameWithFallback() : factory.createIdentifier("Symbol");
            case ts3.TypeReferenceSerializationKind.TypeWithCallSignature:
              return factory.createIdentifier("Function");
            case ts3.TypeReferenceSerializationKind.Promise:
              return factory.createIdentifier("Promise");
            case ts3.TypeReferenceSerializationKind.ObjectType:
              return factory.createIdentifier("Object");
            default:
              return ts3.Debug.assertNever(kind);
          }
        }
        function createCheckedValue(left, right) {
          return factory.createLogicalAnd(factory.createStrictInequality(factory.createTypeOfExpression(left), factory.createStringLiteral("undefined")), right);
        }
        function serializeEntityNameAsExpressionFallback(node) {
          if (node.kind === 79) {
            var copied = serializeEntityNameAsExpression(node);
            return createCheckedValue(copied, copied);
          }
          if (node.left.kind === 79) {
            return createCheckedValue(serializeEntityNameAsExpression(node.left), serializeEntityNameAsExpression(node));
          }
          var left = serializeEntityNameAsExpressionFallback(node.left);
          var temp = factory.createTempVariable(hoistVariableDeclaration);
          return factory.createLogicalAnd(factory.createLogicalAnd(left.left, factory.createStrictInequality(factory.createAssignment(temp, left.right), factory.createVoidZero())), factory.createPropertyAccessExpression(temp, node.right));
        }
        function serializeEntityNameAsExpression(node) {
          switch (node.kind) {
            case 79:
              var name = ts3.setParent(ts3.setTextRange(ts3.parseNodeFactory.cloneNode(node), node), node.parent);
              name.original = void 0;
              ts3.setParent(name, ts3.getParseTreeNode(currentLexicalScope));
              return name;
            case 161:
              return serializeQualifiedNameAsExpression(node);
          }
        }
        function serializeQualifiedNameAsExpression(node) {
          return factory.createPropertyAccessExpression(serializeEntityNameAsExpression(node.left), node.right);
        }
        function getGlobalSymbolNameWithFallback() {
          return factory.createConditionalExpression(factory.createTypeCheck(factory.createIdentifier("Symbol"), "function"), void 0, factory.createIdentifier("Symbol"), void 0, factory.createIdentifier("Object"));
        }
        function getGlobalBigIntNameWithFallback() {
          return languageVersion < 99 ? factory.createConditionalExpression(factory.createTypeCheck(factory.createIdentifier("BigInt"), "function"), void 0, factory.createIdentifier("BigInt"), void 0, factory.createIdentifier("Object")) : factory.createIdentifier("BigInt");
        }
        function getExpressionForPropertyName(member, generateNameForComputedPropertyName) {
          var name = member.name;
          if (ts3.isPrivateIdentifier(name)) {
            return factory.createIdentifier("");
          } else if (ts3.isComputedPropertyName(name)) {
            return generateNameForComputedPropertyName && !ts3.isSimpleInlineableExpression(name.expression) ? factory.getGeneratedNameForNode(name) : name.expression;
          } else if (ts3.isIdentifier(name)) {
            return factory.createStringLiteral(ts3.idText(name));
          } else {
            return factory.cloneNode(name);
          }
        }
        function visitPropertyNameOfClassElement(member) {
          var name = member.name;
          if (ts3.isComputedPropertyName(name) && (!ts3.hasStaticModifier(member) && currentClassHasParameterProperties || ts3.some(member.decorators))) {
            var expression = ts3.visitNode(name.expression, visitor, ts3.isExpression);
            var innerExpression = ts3.skipPartiallyEmittedExpressions(expression);
            if (!ts3.isSimpleInlineableExpression(innerExpression)) {
              var generatedName = factory.getGeneratedNameForNode(name);
              hoistVariableDeclaration(generatedName);
              return factory.updateComputedPropertyName(name, factory.createAssignment(generatedName, expression));
            }
          }
          return ts3.visitNode(name, visitor, ts3.isPropertyName);
        }
        function visitHeritageClause(node) {
          if (node.token === 117) {
            return void 0;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitExpressionWithTypeArguments(node) {
          return factory.updateExpressionWithTypeArguments(node, ts3.visitNode(node.expression, visitor, ts3.isLeftHandSideExpression), void 0);
        }
        function shouldEmitFunctionLikeDeclaration(node) {
          return !ts3.nodeIsMissing(node.body);
        }
        function visitPropertyDeclaration(node) {
          if (node.flags & 16777216 || ts3.hasSyntacticModifier(node, 128)) {
            return void 0;
          }
          var updated = factory.updatePropertyDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), visitPropertyNameOfClassElement(node), void 0, void 0, ts3.visitNode(node.initializer, visitor));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitConstructor(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return void 0;
          }
          return factory.updateConstructorDeclaration(node, void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), transformConstructorBody(node.body, node));
        }
        function transformConstructorBody(body, constructor) {
          var parametersWithPropertyAssignments = constructor && ts3.filter(constructor.parameters, function(p) {
            return ts3.isParameterPropertyDeclaration(p, constructor);
          });
          if (!ts3.some(parametersWithPropertyAssignments)) {
            return ts3.visitFunctionBody(body, visitor, context);
          }
          var statements = [];
          resumeLexicalEnvironment();
          var prologueStatementCount = factory.copyPrologue(body.statements, statements, false, visitor);
          var superStatementIndex = ts3.findSuperStatementIndex(body.statements, prologueStatementCount);
          if (superStatementIndex >= 0) {
            ts3.addRange(statements, ts3.visitNodes(body.statements, visitor, ts3.isStatement, prologueStatementCount, superStatementIndex + 1 - prologueStatementCount));
          }
          var parameterPropertyAssignments = ts3.mapDefined(parametersWithPropertyAssignments, transformParameterWithPropertyAssignment);
          if (superStatementIndex >= 0) {
            ts3.addRange(statements, parameterPropertyAssignments);
          } else {
            statements = __spreadArray(__spreadArray(__spreadArray([], statements.slice(0, prologueStatementCount), true), parameterPropertyAssignments, true), statements.slice(prologueStatementCount), true);
          }
          ts3.addRange(statements, ts3.visitNodes(body.statements, visitor, ts3.isStatement, superStatementIndex + 1 + prologueStatementCount));
          statements = factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), body.statements), true);
          ts3.setTextRange(block, body);
          ts3.setOriginalNode(block, body);
          return block;
        }
        function transformParameterWithPropertyAssignment(node) {
          var name = node.name;
          if (!ts3.isIdentifier(name)) {
            return void 0;
          }
          var propertyName = ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent);
          ts3.setEmitFlags(propertyName, 1536 | 48);
          var localName = ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent);
          ts3.setEmitFlags(localName, 1536);
          return ts3.startOnNewLine(ts3.removeAllComments(ts3.setTextRange(ts3.setOriginalNode(factory.createExpressionStatement(factory.createAssignment(ts3.setTextRange(factory.createPropertyAccessExpression(factory.createThis(), propertyName), node.name), localName)), node), ts3.moveRangePos(node, -1))));
        }
        function visitMethodDeclaration(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return void 0;
          }
          var updated = factory.updateMethodDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, visitPropertyNameOfClassElement(node), void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function shouldEmitAccessorDeclaration(node) {
          return !(ts3.nodeIsMissing(node.body) && ts3.hasSyntacticModifier(node, 128));
        }
        function visitGetAccessor(node) {
          if (!shouldEmitAccessorDeclaration(node)) {
            return void 0;
          }
          var updated = factory.updateGetAccessorDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), visitPropertyNameOfClassElement(node), ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitSetAccessor(node) {
          if (!shouldEmitAccessorDeclaration(node)) {
            return void 0;
          }
          var updated = factory.updateSetAccessorDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), visitPropertyNameOfClassElement(node), ts3.visitParameterList(node.parameters, visitor, context), ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitFunctionDeclaration(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return factory.createNotEmittedStatement(node);
          }
          var updated = factory.updateFunctionDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          if (isExportOfNamespace(node)) {
            var statements = [updated];
            addExportMemberAssignment(statements, node);
            return statements;
          }
          return updated;
        }
        function visitFunctionExpression(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return factory.createOmittedExpression();
          }
          var updated = factory.updateFunctionExpression(node, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          return updated;
        }
        function visitArrowFunction(node) {
          var updated = factory.updateArrowFunction(node, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, ts3.visitFunctionBody(node.body, visitor, context));
          return updated;
        }
        function visitParameter(node) {
          if (ts3.parameterIsThisKeyword(node)) {
            return void 0;
          }
          var updated = factory.updateParameterDeclaration(node, void 0, void 0, node.dotDotDotToken, ts3.visitNode(node.name, visitor, ts3.isBindingName), void 0, void 0, ts3.visitNode(node.initializer, visitor, ts3.isExpression));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setTextRange(updated, ts3.moveRangePastModifiers(node));
            ts3.setSourceMapRange(updated, ts3.moveRangePastModifiers(node));
            ts3.setEmitFlags(updated.name, 32);
          }
          return updated;
        }
        function visitVariableStatement(node) {
          if (isExportOfNamespace(node)) {
            var variables = ts3.getInitializedVariables(node.declarationList);
            if (variables.length === 0) {
              return void 0;
            }
            return ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(ts3.map(variables, transformInitializedVariable))), node);
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformInitializedVariable(node) {
          var name = node.name;
          if (ts3.isBindingPattern(name)) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 0, false, createNamespaceExportExpression);
          } else {
            return ts3.setTextRange(factory.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(name), ts3.visitNode(node.initializer, visitor, ts3.isExpression)), node);
          }
        }
        function visitVariableDeclaration(node) {
          var updated = factory.updateVariableDeclaration(node, ts3.visitNode(node.name, visitor, ts3.isBindingName), void 0, void 0, ts3.visitNode(node.initializer, visitor, ts3.isExpression));
          if (node.type) {
            ts3.setTypeNode(updated.name, node.type);
          }
          return updated;
        }
        function visitParenthesizedExpression(node) {
          var innerExpression = ts3.skipOuterExpressions(node.expression, ~6);
          if (ts3.isAssertionExpression(innerExpression)) {
            var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
            return factory.createPartiallyEmittedExpression(expression, node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitAssertionExpression(node) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          return factory.createPartiallyEmittedExpression(expression, node);
        }
        function visitNonNullExpression(node) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isLeftHandSideExpression);
          return factory.createPartiallyEmittedExpression(expression, node);
        }
        function visitCallExpression(node) {
          return factory.updateCallExpression(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), void 0, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
        }
        function visitNewExpression(node) {
          return factory.updateNewExpression(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), void 0, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
        }
        function visitTaggedTemplateExpression(node) {
          return factory.updateTaggedTemplateExpression(node, ts3.visitNode(node.tag, visitor, ts3.isExpression), void 0, ts3.visitNode(node.template, visitor, ts3.isExpression));
        }
        function visitJsxSelfClosingElement(node) {
          return factory.updateJsxSelfClosingElement(node, ts3.visitNode(node.tagName, visitor, ts3.isJsxTagNameExpression), void 0, ts3.visitNode(node.attributes, visitor, ts3.isJsxAttributes));
        }
        function visitJsxJsxOpeningElement(node) {
          return factory.updateJsxOpeningElement(node, ts3.visitNode(node.tagName, visitor, ts3.isJsxTagNameExpression), void 0, ts3.visitNode(node.attributes, visitor, ts3.isJsxAttributes));
        }
        function shouldEmitEnumDeclaration(node) {
          return !ts3.isEnumConst(node) || ts3.shouldPreserveConstEnums(compilerOptions);
        }
        function visitEnumDeclaration(node) {
          if (!shouldEmitEnumDeclaration(node)) {
            return factory.createNotEmittedStatement(node);
          }
          var statements = [];
          var emitFlags = 2;
          var varAdded = addVarForEnumOrModuleDeclaration(statements, node);
          if (varAdded) {
            if (moduleKind !== ts3.ModuleKind.System || currentLexicalScope !== currentSourceFile) {
              emitFlags |= 512;
            }
          }
          var parameterName = getNamespaceParameterName(node);
          var containerName = getNamespaceContainerName(node);
          var exportName = ts3.hasSyntacticModifier(node, 1) ? factory.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true) : factory.getLocalName(node, false, true);
          var moduleArg = factory.createLogicalOr(exportName, factory.createAssignment(exportName, factory.createObjectLiteralExpression()));
          if (hasNamespaceQualifiedExportName(node)) {
            var localName = factory.getLocalName(node, false, true);
            moduleArg = factory.createAssignment(localName, moduleArg);
          }
          var enumStatement = factory.createExpressionStatement(factory.createCallExpression(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, parameterName)], void 0, transformEnumBody(node, containerName)), void 0, [moduleArg]));
          ts3.setOriginalNode(enumStatement, node);
          if (varAdded) {
            ts3.setSyntheticLeadingComments(enumStatement, void 0);
            ts3.setSyntheticTrailingComments(enumStatement, void 0);
          }
          ts3.setTextRange(enumStatement, node);
          ts3.addEmitFlags(enumStatement, emitFlags);
          statements.push(enumStatement);
          statements.push(factory.createEndOfDeclarationMarker(node));
          return statements;
        }
        function transformEnumBody(node, localName) {
          var savedCurrentNamespaceLocalName = currentNamespaceContainerName;
          currentNamespaceContainerName = localName;
          var statements = [];
          startLexicalEnvironment();
          var members = ts3.map(node.members, transformEnumMember);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          ts3.addRange(statements, members);
          currentNamespaceContainerName = savedCurrentNamespaceLocalName;
          return factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), node.members), true);
        }
        function transformEnumMember(member) {
          var name = getExpressionForPropertyName(member, false);
          var valueExpression = transformEnumMemberDeclarationValue(member);
          var innerAssignment = factory.createAssignment(factory.createElementAccessExpression(currentNamespaceContainerName, name), valueExpression);
          var outerAssignment = valueExpression.kind === 10 ? innerAssignment : factory.createAssignment(factory.createElementAccessExpression(currentNamespaceContainerName, innerAssignment), name);
          return ts3.setTextRange(factory.createExpressionStatement(ts3.setTextRange(outerAssignment, member)), member);
        }
        function transformEnumMemberDeclarationValue(member) {
          var value = resolver.getConstantValue(member);
          if (value !== void 0) {
            return typeof value === "string" ? factory.createStringLiteral(value) : factory.createNumericLiteral(value);
          } else {
            enableSubstitutionForNonQualifiedEnumMembers();
            if (member.initializer) {
              return ts3.visitNode(member.initializer, visitor, ts3.isExpression);
            } else {
              return factory.createVoidZero();
            }
          }
        }
        function shouldEmitModuleDeclaration(nodeIn) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isModuleDeclaration);
          if (!node) {
            return true;
          }
          return ts3.isInstantiatedModule(node, ts3.shouldPreserveConstEnums(compilerOptions));
        }
        function hasNamespaceQualifiedExportName(node) {
          return isExportOfNamespace(node) || isExternalModuleExport(node) && moduleKind !== ts3.ModuleKind.ES2015 && moduleKind !== ts3.ModuleKind.ES2020 && moduleKind !== ts3.ModuleKind.ES2022 && moduleKind !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.System;
        }
        function recordEmittedDeclarationInScope(node) {
          if (!currentScopeFirstDeclarationsOfName) {
            currentScopeFirstDeclarationsOfName = new ts3.Map();
          }
          var name = declaredNameInScope(node);
          if (!currentScopeFirstDeclarationsOfName.has(name)) {
            currentScopeFirstDeclarationsOfName.set(name, node);
          }
        }
        function isFirstEmittedDeclarationInScope(node) {
          if (currentScopeFirstDeclarationsOfName) {
            var name = declaredNameInScope(node);
            return currentScopeFirstDeclarationsOfName.get(name) === node;
          }
          return true;
        }
        function declaredNameInScope(node) {
          ts3.Debug.assertNode(node.name, ts3.isIdentifier);
          return node.name.escapedText;
        }
        function addVarForEnumOrModuleDeclaration(statements, node) {
          var statement = factory.createVariableStatement(ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), factory.createVariableDeclarationList([
            factory.createVariableDeclaration(factory.getLocalName(node, false, true))
          ], currentLexicalScope.kind === 305 ? 0 : 1));
          ts3.setOriginalNode(statement, node);
          recordEmittedDeclarationInScope(node);
          if (isFirstEmittedDeclarationInScope(node)) {
            if (node.kind === 260) {
              ts3.setSourceMapRange(statement.declarationList, node);
            } else {
              ts3.setSourceMapRange(statement, node);
            }
            ts3.setCommentRange(statement, node);
            ts3.addEmitFlags(statement, 1024 | 4194304);
            statements.push(statement);
            return true;
          } else {
            var mergeMarker = factory.createMergeDeclarationMarker(statement);
            ts3.setEmitFlags(mergeMarker, 1536 | 4194304);
            statements.push(mergeMarker);
            return false;
          }
        }
        function visitModuleDeclaration(node) {
          if (!shouldEmitModuleDeclaration(node)) {
            return factory.createNotEmittedStatement(node);
          }
          ts3.Debug.assertNode(node.name, ts3.isIdentifier, "A TypeScript namespace should have an Identifier name.");
          enableSubstitutionForNamespaceExports();
          var statements = [];
          var emitFlags = 2;
          var varAdded = addVarForEnumOrModuleDeclaration(statements, node);
          if (varAdded) {
            if (moduleKind !== ts3.ModuleKind.System || currentLexicalScope !== currentSourceFile) {
              emitFlags |= 512;
            }
          }
          var parameterName = getNamespaceParameterName(node);
          var containerName = getNamespaceContainerName(node);
          var exportName = ts3.hasSyntacticModifier(node, 1) ? factory.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true) : factory.getLocalName(node, false, true);
          var moduleArg = factory.createLogicalOr(exportName, factory.createAssignment(exportName, factory.createObjectLiteralExpression()));
          if (hasNamespaceQualifiedExportName(node)) {
            var localName = factory.getLocalName(node, false, true);
            moduleArg = factory.createAssignment(localName, moduleArg);
          }
          var moduleStatement = factory.createExpressionStatement(factory.createCallExpression(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, parameterName)], void 0, transformModuleBody(node, containerName)), void 0, [moduleArg]));
          ts3.setOriginalNode(moduleStatement, node);
          if (varAdded) {
            ts3.setSyntheticLeadingComments(moduleStatement, void 0);
            ts3.setSyntheticTrailingComments(moduleStatement, void 0);
          }
          ts3.setTextRange(moduleStatement, node);
          ts3.addEmitFlags(moduleStatement, emitFlags);
          statements.push(moduleStatement);
          statements.push(factory.createEndOfDeclarationMarker(node));
          return statements;
        }
        function transformModuleBody(node, namespaceLocalName) {
          var savedCurrentNamespaceContainerName = currentNamespaceContainerName;
          var savedCurrentNamespace = currentNamespace;
          var savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
          currentNamespaceContainerName = namespaceLocalName;
          currentNamespace = node;
          currentScopeFirstDeclarationsOfName = void 0;
          var statements = [];
          startLexicalEnvironment();
          var statementsLocation;
          var blockLocation;
          if (node.body) {
            if (node.body.kind === 262) {
              saveStateAndInvoke(node.body, function(body) {
                return ts3.addRange(statements, ts3.visitNodes(body.statements, namespaceElementVisitor, ts3.isStatement));
              });
              statementsLocation = node.body.statements;
              blockLocation = node.body;
            } else {
              var result2 = visitModuleDeclaration(node.body);
              if (result2) {
                if (ts3.isArray(result2)) {
                  ts3.addRange(statements, result2);
                } else {
                  statements.push(result2);
                }
              }
              var moduleBlock = getInnerMostModuleDeclarationFromDottedModule(node).body;
              statementsLocation = ts3.moveRangePos(moduleBlock.statements, -1);
            }
          }
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          currentNamespaceContainerName = savedCurrentNamespaceContainerName;
          currentNamespace = savedCurrentNamespace;
          currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), true);
          ts3.setTextRange(block, blockLocation);
          if (!node.body || node.body.kind !== 262) {
            ts3.setEmitFlags(block, ts3.getEmitFlags(block) | 1536);
          }
          return block;
        }
        function getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration) {
          if (moduleDeclaration.body.kind === 261) {
            var recursiveInnerModule = getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration.body);
            return recursiveInnerModule || moduleDeclaration.body;
          }
        }
        function visitImportDeclaration(node) {
          if (!node.importClause) {
            return node;
          }
          if (node.importClause.isTypeOnly) {
            return void 0;
          }
          var importClause = ts3.visitNode(node.importClause, visitImportClause, ts3.isImportClause);
          return importClause || compilerOptions.importsNotUsedAsValues === 1 || compilerOptions.importsNotUsedAsValues === 2 ? factory.updateImportDeclaration(node, void 0, void 0, importClause, node.moduleSpecifier, node.assertClause) : void 0;
        }
        function visitImportClause(node) {
          ts3.Debug.assert(!node.isTypeOnly);
          var name = shouldEmitAliasDeclaration(node) ? node.name : void 0;
          var namedBindings = ts3.visitNode(node.namedBindings, visitNamedImportBindings, ts3.isNamedImportBindings);
          return name || namedBindings ? factory.updateImportClause(node, false, name, namedBindings) : void 0;
        }
        function visitNamedImportBindings(node) {
          if (node.kind === 268) {
            return shouldEmitAliasDeclaration(node) ? node : void 0;
          } else {
            var allowEmpty = compilerOptions.preserveValueImports && (compilerOptions.importsNotUsedAsValues === 1 || compilerOptions.importsNotUsedAsValues === 2);
            var elements = ts3.visitNodes(node.elements, visitImportSpecifier, ts3.isImportSpecifier);
            return allowEmpty || ts3.some(elements) ? factory.updateNamedImports(node, elements) : void 0;
          }
        }
        function visitImportSpecifier(node) {
          return !node.isTypeOnly && shouldEmitAliasDeclaration(node) ? node : void 0;
        }
        function visitExportAssignment(node) {
          return resolver.isValueAliasDeclaration(node) ? ts3.visitEachChild(node, visitor, context) : void 0;
        }
        function visitExportDeclaration(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          if (!node.exportClause || ts3.isNamespaceExport(node.exportClause)) {
            return node;
          }
          var allowEmpty = !!node.moduleSpecifier && (compilerOptions.importsNotUsedAsValues === 1 || compilerOptions.importsNotUsedAsValues === 2);
          var exportClause = ts3.visitNode(node.exportClause, function(bindings) {
            return visitNamedExportBindings(bindings, allowEmpty);
          }, ts3.isNamedExportBindings);
          return exportClause ? factory.updateExportDeclaration(node, void 0, void 0, node.isTypeOnly, exportClause, node.moduleSpecifier, node.assertClause) : void 0;
        }
        function visitNamedExports(node, allowEmpty) {
          var elements = ts3.visitNodes(node.elements, visitExportSpecifier, ts3.isExportSpecifier);
          return allowEmpty || ts3.some(elements) ? factory.updateNamedExports(node, elements) : void 0;
        }
        function visitNamespaceExports(node) {
          return factory.updateNamespaceExport(node, ts3.visitNode(node.name, visitor, ts3.isIdentifier));
        }
        function visitNamedExportBindings(node, allowEmpty) {
          return ts3.isNamespaceExport(node) ? visitNamespaceExports(node) : visitNamedExports(node, allowEmpty);
        }
        function visitExportSpecifier(node) {
          return !node.isTypeOnly && resolver.isValueAliasDeclaration(node) ? node : void 0;
        }
        function shouldEmitImportEqualsDeclaration(node) {
          return shouldEmitAliasDeclaration(node) || !ts3.isExternalModule(currentSourceFile) && resolver.isTopLevelValueImportEqualsWithEntityName(node);
        }
        function visitImportEqualsDeclaration(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          if (ts3.isExternalModuleImportEqualsDeclaration(node)) {
            var isReferenced = shouldEmitAliasDeclaration(node);
            if (!isReferenced && compilerOptions.importsNotUsedAsValues === 1) {
              return ts3.setOriginalNode(ts3.setTextRange(factory.createImportDeclaration(void 0, void 0, void 0, node.moduleReference.expression, void 0), node), node);
            }
            return isReferenced ? ts3.visitEachChild(node, visitor, context) : void 0;
          }
          if (!shouldEmitImportEqualsDeclaration(node)) {
            return void 0;
          }
          var moduleReference = ts3.createExpressionFromEntityName(factory, node.moduleReference);
          ts3.setEmitFlags(moduleReference, 1536 | 2048);
          if (isNamedExternalModuleExport(node) || !isExportOfNamespace(node)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), factory.createVariableDeclarationList([
              ts3.setOriginalNode(factory.createVariableDeclaration(node.name, void 0, void 0, moduleReference), node)
            ])), node), node);
          } else {
            return ts3.setOriginalNode(createNamespaceExport(node.name, moduleReference, node), node);
          }
        }
        function isExportOfNamespace(node) {
          return currentNamespace !== void 0 && ts3.hasSyntacticModifier(node, 1);
        }
        function isExternalModuleExport(node) {
          return currentNamespace === void 0 && ts3.hasSyntacticModifier(node, 1);
        }
        function isNamedExternalModuleExport(node) {
          return isExternalModuleExport(node) && !ts3.hasSyntacticModifier(node, 512);
        }
        function isDefaultExternalModuleExport(node) {
          return isExternalModuleExport(node) && ts3.hasSyntacticModifier(node, 512);
        }
        function expressionToStatement(expression) {
          return factory.createExpressionStatement(expression);
        }
        function addExportMemberAssignment(statements, node) {
          var expression = factory.createAssignment(factory.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true), factory.getLocalName(node));
          ts3.setSourceMapRange(expression, ts3.createRange(node.name ? node.name.pos : node.pos, node.end));
          var statement = factory.createExpressionStatement(expression);
          ts3.setSourceMapRange(statement, ts3.createRange(-1, node.end));
          statements.push(statement);
        }
        function createNamespaceExport(exportName, exportValue, location) {
          return ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(factory.getNamespaceMemberName(currentNamespaceContainerName, exportName, false, true), exportValue)), location);
        }
        function createNamespaceExportExpression(exportName, exportValue, location) {
          return ts3.setTextRange(factory.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(exportName), exportValue), location);
        }
        function getNamespaceMemberNameWithSourceMapsAndWithoutComments(name) {
          return factory.getNamespaceMemberName(currentNamespaceContainerName, name, false, true);
        }
        function getNamespaceParameterName(node) {
          var name = factory.getGeneratedNameForNode(node);
          ts3.setSourceMapRange(name, node.name);
          return name;
        }
        function getNamespaceContainerName(node) {
          return factory.getGeneratedNameForNode(node);
        }
        function getClassAliasIfNeeded(node) {
          if (resolver.getNodeCheckFlags(node) & 16777216) {
            enableSubstitutionForClassAliases();
            var classAlias = factory.createUniqueName(node.name && !ts3.isGeneratedIdentifier(node.name) ? ts3.idText(node.name) : "default");
            classAliases[ts3.getOriginalNodeId(node)] = classAlias;
            hoistVariableDeclaration(classAlias);
            return classAlias;
          }
        }
        function getClassPrototype(node) {
          return factory.createPropertyAccessExpression(factory.getDeclarationName(node), "prototype");
        }
        function getClassMemberPrefix(node, member) {
          return ts3.isStatic(member) ? factory.getDeclarationName(node) : getClassPrototype(node);
        }
        function enableSubstitutionForNonQualifiedEnumMembers() {
          if ((enabledSubstitutions & 8) === 0) {
            enabledSubstitutions |= 8;
            context.enableSubstitution(79);
          }
        }
        function enableSubstitutionForClassAliases() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(79);
            classAliases = [];
          }
        }
        function enableSubstitutionForNamespaceExports() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(79);
            context.enableSubstitution(297);
            context.enableEmitNotification(261);
          }
        }
        function isTransformedModuleDeclaration(node) {
          return ts3.getOriginalNode(node).kind === 261;
        }
        function isTransformedEnumDeclaration(node) {
          return ts3.getOriginalNode(node).kind === 260;
        }
        function onEmitNode(hint, node, emitCallback) {
          var savedApplicableSubstitutions = applicableSubstitutions;
          var savedCurrentSourceFile = currentSourceFile;
          if (ts3.isSourceFile(node)) {
            currentSourceFile = node;
          }
          if (enabledSubstitutions & 2 && isTransformedModuleDeclaration(node)) {
            applicableSubstitutions |= 2;
          }
          if (enabledSubstitutions & 8 && isTransformedEnumDeclaration(node)) {
            applicableSubstitutions |= 8;
          }
          previousOnEmitNode(hint, node, emitCallback);
          applicableSubstitutions = savedApplicableSubstitutions;
          currentSourceFile = savedCurrentSourceFile;
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          } else if (ts3.isShorthandPropertyAssignment(node)) {
            return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          if (enabledSubstitutions & 2) {
            var name = node.name;
            var exportedName = trySubstituteNamespaceExportedName(name);
            if (exportedName) {
              if (node.objectAssignmentInitializer) {
                var initializer = factory.createAssignment(exportedName, node.objectAssignmentInitializer);
                return ts3.setTextRange(factory.createPropertyAssignment(name, initializer), node);
              }
              return ts3.setTextRange(factory.createPropertyAssignment(name, exportedName), node);
            }
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 79:
              return substituteExpressionIdentifier(node);
            case 206:
              return substitutePropertyAccessExpression(node);
            case 207:
              return substituteElementAccessExpression(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          return trySubstituteClassAlias(node) || trySubstituteNamespaceExportedName(node) || node;
        }
        function trySubstituteClassAlias(node) {
          if (enabledSubstitutions & 1) {
            if (resolver.getNodeCheckFlags(node) & 33554432) {
              var declaration = resolver.getReferencedValueDeclaration(node);
              if (declaration) {
                var classAlias = classAliases[declaration.id];
                if (classAlias) {
                  var clone_2 = factory.cloneNode(classAlias);
                  ts3.setSourceMapRange(clone_2, node);
                  ts3.setCommentRange(clone_2, node);
                  return clone_2;
                }
              }
            }
          }
          return void 0;
        }
        function trySubstituteNamespaceExportedName(node) {
          if (enabledSubstitutions & applicableSubstitutions && !ts3.isGeneratedIdentifier(node) && !ts3.isLocalName(node)) {
            var container = resolver.getReferencedExportContainer(node, false);
            if (container && container.kind !== 305) {
              var substitute = applicableSubstitutions & 2 && container.kind === 261 || applicableSubstitutions & 8 && container.kind === 260;
              if (substitute) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(container), node), node);
              }
            }
          }
          return void 0;
        }
        function substitutePropertyAccessExpression(node) {
          return substituteConstantValue(node);
        }
        function substituteElementAccessExpression(node) {
          return substituteConstantValue(node);
        }
        function safeMultiLineComment(value) {
          return value.replace(/\*\//g, "*_/");
        }
        function substituteConstantValue(node) {
          var constantValue = tryGetConstEnumValue(node);
          if (constantValue !== void 0) {
            ts3.setConstantValue(node, constantValue);
            var substitute = typeof constantValue === "string" ? factory.createStringLiteral(constantValue) : factory.createNumericLiteral(constantValue);
            if (!compilerOptions.removeComments) {
              var originalNode = ts3.getOriginalNode(node, ts3.isAccessExpression);
              ts3.addSyntheticTrailingComment(substitute, 3, " ".concat(safeMultiLineComment(ts3.getTextOfNode(originalNode)), " "));
            }
            return substitute;
          }
          return node;
        }
        function tryGetConstEnumValue(node) {
          if (compilerOptions.isolatedModules) {
            return void 0;
          }
          return ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node) ? resolver.getConstantValue(node) : void 0;
        }
        function shouldEmitAliasDeclaration(node) {
          return compilerOptions.preserveValueImports ? resolver.isValueAliasDeclaration(node) : resolver.isReferencedAliasDeclaration(node);
        }
      }
      ts3.transformTypeScript = transformTypeScript;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ClassPropertySubstitutionFlags;
      (function(ClassPropertySubstitutionFlags2) {
        ClassPropertySubstitutionFlags2[ClassPropertySubstitutionFlags2["ClassAliases"] = 1] = "ClassAliases";
        ClassPropertySubstitutionFlags2[ClassPropertySubstitutionFlags2["ClassStaticThisOrSuperReference"] = 2] = "ClassStaticThisOrSuperReference";
      })(ClassPropertySubstitutionFlags || (ClassPropertySubstitutionFlags = {}));
      var PrivateIdentifierKind;
      (function(PrivateIdentifierKind2) {
        PrivateIdentifierKind2["Field"] = "f";
        PrivateIdentifierKind2["Method"] = "m";
        PrivateIdentifierKind2["Accessor"] = "a";
      })(PrivateIdentifierKind = ts3.PrivateIdentifierKind || (ts3.PrivateIdentifierKind = {}));
      var ClassFacts;
      (function(ClassFacts2) {
        ClassFacts2[ClassFacts2["None"] = 0] = "None";
        ClassFacts2[ClassFacts2["ClassWasDecorated"] = 1] = "ClassWasDecorated";
        ClassFacts2[ClassFacts2["NeedsClassConstructorReference"] = 2] = "NeedsClassConstructorReference";
        ClassFacts2[ClassFacts2["NeedsClassSuperReference"] = 4] = "NeedsClassSuperReference";
        ClassFacts2[ClassFacts2["NeedsSubstitutionForThisInClassStaticField"] = 8] = "NeedsSubstitutionForThisInClassStaticField";
      })(ClassFacts || (ClassFacts = {}));
      function transformClassFields(context) {
        var factory = context.factory, hoistVariableDeclaration = context.hoistVariableDeclaration, endLexicalEnvironment = context.endLexicalEnvironment, startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, addBlockScopedVariable = context.addBlockScopedVariable;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var useDefineForClassFields = ts3.getUseDefineForClassFields(compilerOptions);
        var shouldTransformPrivateElementsOrClassStaticBlocks = languageVersion < 9;
        var shouldTransformThisInStaticInitializers = languageVersion < 9;
        var shouldTransformSuperInStaticInitializers = shouldTransformThisInStaticInitializers && languageVersion >= 2;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        var enabledSubstitutions;
        var classAliases;
        var pendingExpressions;
        var pendingStatements;
        var classLexicalEnvironmentStack = [];
        var classLexicalEnvironmentMap = new ts3.Map();
        var currentClassLexicalEnvironment;
        var currentComputedPropertyNameClassLexicalEnvironment;
        var currentStaticPropertyDeclarationOrStaticBlock;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          var options = context.getCompilerOptions();
          if (node.isDeclarationFile || useDefineForClassFields && ts3.getEmitScriptTarget(options) >= 9) {
            return node;
          }
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitorWorker(node, valueIsDiscarded) {
          if (node.transformFlags & 8388608) {
            switch (node.kind) {
              case 226:
              case 257:
                return visitClassLike(node);
              case 167:
                return visitPropertyDeclaration(node);
              case 237:
                return visitVariableStatement(node);
              case 80:
                return visitPrivateIdentifier(node);
              case 170:
                return visitClassStaticBlockDeclaration(node);
            }
          }
          if (node.transformFlags & 8388608 || node.transformFlags & 33554432 && shouldTransformSuperInStaticInitializers && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
            switch (node.kind) {
              case 219:
              case 220:
                return visitPreOrPostfixUnaryExpression(node, valueIsDiscarded);
              case 221:
                return visitBinaryExpression(node, valueIsDiscarded);
              case 208:
                return visitCallExpression(node);
              case 210:
                return visitTaggedTemplateExpression(node);
              case 206:
                return visitPropertyAccessExpression(node);
              case 207:
                return visitElementAccessExpression(node);
              case 238:
                return visitExpressionStatement(node);
              case 242:
                return visitForStatement(node);
              case 256:
              case 213:
              case 171:
              case 169:
              case 172:
              case 173: {
                var savedCurrentStaticPropertyDeclarationOrStaticBlock = currentStaticPropertyDeclarationOrStaticBlock;
                currentStaticPropertyDeclarationOrStaticBlock = void 0;
                var result2 = ts3.visitEachChild(node, visitor, context);
                currentStaticPropertyDeclarationOrStaticBlock = savedCurrentStaticPropertyDeclarationOrStaticBlock;
                return result2;
              }
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function discardedValueVisitor(node) {
          return visitorWorker(node, true);
        }
        function visitor(node) {
          return visitorWorker(node, false);
        }
        function heritageClauseVisitor(node) {
          switch (node.kind) {
            case 291:
              return ts3.visitEachChild(node, heritageClauseVisitor, context);
            case 228:
              return visitExpressionWithTypeArguments(node);
          }
          return visitor(node);
        }
        function visitorDestructuringTarget(node) {
          switch (node.kind) {
            case 205:
            case 204:
              return visitAssignmentPattern(node);
            default:
              return visitor(node);
          }
        }
        function visitPrivateIdentifier(node) {
          if (!shouldTransformPrivateElementsOrClassStaticBlocks) {
            return node;
          }
          if (ts3.isStatement(node.parent)) {
            return node;
          }
          return ts3.setOriginalNode(factory.createIdentifier(""), node);
        }
        function visitPrivateIdentifierInInExpression(node) {
          if (!shouldTransformPrivateElementsOrClassStaticBlocks) {
            return node;
          }
          var privId = node.left;
          ts3.Debug.assertNode(privId, ts3.isPrivateIdentifier);
          ts3.Debug.assert(node.operatorToken.kind === 101);
          var info = accessPrivateIdentifier(privId);
          if (info) {
            var receiver = ts3.visitNode(node.right, visitor, ts3.isExpression);
            return ts3.setOriginalNode(context.getEmitHelperFactory().createClassPrivateFieldInHelper(info.brandCheckIdentifier, receiver), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function classElementVisitor(node) {
          switch (node.kind) {
            case 171:
              return void 0;
            case 172:
            case 173:
            case 169:
              return visitMethodOrAccessorDeclaration(node);
            case 167:
              return visitPropertyDeclaration(node);
            case 162:
              return visitComputedPropertyName(node);
            case 234:
              return node;
            default:
              return visitor(node);
          }
        }
        function visitVariableStatement(node) {
          var savedPendingStatements = pendingStatements;
          pendingStatements = [];
          var visitedNode = ts3.visitEachChild(node, visitor, context);
          var statement = ts3.some(pendingStatements) ? __spreadArray([visitedNode], pendingStatements, true) : visitedNode;
          pendingStatements = savedPendingStatements;
          return statement;
        }
        function visitComputedPropertyName(name) {
          var node = ts3.visitEachChild(name, visitor, context);
          if (ts3.some(pendingExpressions)) {
            var expressions = pendingExpressions;
            expressions.push(node.expression);
            pendingExpressions = [];
            node = factory.updateComputedPropertyName(node, factory.inlineExpressions(expressions));
          }
          return node;
        }
        function visitMethodOrAccessorDeclaration(node) {
          ts3.Debug.assert(!ts3.some(node.decorators));
          if (!shouldTransformPrivateElementsOrClassStaticBlocks || !ts3.isPrivateIdentifier(node.name)) {
            return ts3.visitEachChild(node, classElementVisitor, context);
          }
          var info = accessPrivateIdentifier(node.name);
          ts3.Debug.assert(info, "Undeclared private name for property declaration.");
          if (!info.isValid) {
            return node;
          }
          var functionName = getHoistedFunctionName(node);
          if (functionName) {
            getPendingExpressions().push(factory.createAssignment(functionName, factory.createFunctionExpression(ts3.filter(node.modifiers, function(m) {
              return !ts3.isStaticModifier(m);
            }), node.asteriskToken, functionName, void 0, ts3.visitParameterList(node.parameters, classElementVisitor, context), void 0, ts3.visitFunctionBody(node.body, classElementVisitor, context))));
          }
          return void 0;
        }
        function getHoistedFunctionName(node) {
          ts3.Debug.assert(ts3.isPrivateIdentifier(node.name));
          var info = accessPrivateIdentifier(node.name);
          ts3.Debug.assert(info, "Undeclared private name for property declaration.");
          if (info.kind === "m") {
            return info.methodName;
          }
          if (info.kind === "a") {
            if (ts3.isGetAccessor(node)) {
              return info.getterName;
            }
            if (ts3.isSetAccessor(node)) {
              return info.setterName;
            }
          }
        }
        function visitPropertyDeclaration(node) {
          ts3.Debug.assert(!ts3.some(node.decorators));
          if (ts3.isPrivateIdentifier(node.name)) {
            if (!shouldTransformPrivateElementsOrClassStaticBlocks) {
              if (ts3.isStatic(node)) {
                return ts3.visitEachChild(node, visitor, context);
              }
              return factory.updatePropertyDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.name, void 0, void 0, void 0);
            }
            var info = accessPrivateIdentifier(node.name);
            ts3.Debug.assert(info, "Undeclared private name for property declaration.");
            if (!info.isValid) {
              return node;
            }
          }
          var expr = getPropertyNameExpressionIfNeeded(node.name, !!node.initializer || useDefineForClassFields);
          if (expr && !ts3.isSimpleInlineableExpression(expr)) {
            getPendingExpressions().push(expr);
          }
          if (ts3.isStatic(node) && !shouldTransformPrivateElementsOrClassStaticBlocks && !useDefineForClassFields) {
            var initializerStatement = transformPropertyOrClassStaticBlock(node, factory.createThis());
            if (initializerStatement) {
              var staticBlock = factory.createClassStaticBlockDeclaration(void 0, void 0, factory.createBlock([initializerStatement]));
              ts3.setOriginalNode(staticBlock, node);
              ts3.setCommentRange(staticBlock, node);
              ts3.setCommentRange(initializerStatement, { pos: -1, end: -1 });
              ts3.setSyntheticLeadingComments(initializerStatement, void 0);
              ts3.setSyntheticTrailingComments(initializerStatement, void 0);
              return staticBlock;
            }
          }
          return void 0;
        }
        function createPrivateIdentifierAccess(info, receiver) {
          return createPrivateIdentifierAccessHelper(info, ts3.visitNode(receiver, visitor, ts3.isExpression));
        }
        function createPrivateIdentifierAccessHelper(info, receiver) {
          ts3.setCommentRange(receiver, ts3.moveRangePos(receiver, -1));
          switch (info.kind) {
            case "a":
              return context.getEmitHelperFactory().createClassPrivateFieldGetHelper(receiver, info.brandCheckIdentifier, info.kind, info.getterName);
            case "m":
              return context.getEmitHelperFactory().createClassPrivateFieldGetHelper(receiver, info.brandCheckIdentifier, info.kind, info.methodName);
            case "f":
              return context.getEmitHelperFactory().createClassPrivateFieldGetHelper(receiver, info.brandCheckIdentifier, info.kind, info.variableName);
            default:
              ts3.Debug.assertNever(info, "Unknown private element type");
          }
        }
        function visitPropertyAccessExpression(node) {
          if (shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifier(node.name)) {
            var privateIdentifierInfo = accessPrivateIdentifier(node.name);
            if (privateIdentifierInfo) {
              return ts3.setTextRange(ts3.setOriginalNode(createPrivateIdentifierAccess(privateIdentifierInfo, node.expression), node), node);
            }
          }
          if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(node) && ts3.isIdentifier(node.name) && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
            var classConstructor = currentClassLexicalEnvironment.classConstructor, superClassReference = currentClassLexicalEnvironment.superClassReference, facts = currentClassLexicalEnvironment.facts;
            if (facts & 1) {
              return visitInvalidSuperProperty(node);
            }
            if (classConstructor && superClassReference) {
              var superProperty = factory.createReflectGetCall(superClassReference, factory.createStringLiteralFromNode(node.name), classConstructor);
              ts3.setOriginalNode(superProperty, node.expression);
              ts3.setTextRange(superProperty, node.expression);
              return superProperty;
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitElementAccessExpression(node) {
          if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(node) && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
            var classConstructor = currentClassLexicalEnvironment.classConstructor, superClassReference = currentClassLexicalEnvironment.superClassReference, facts = currentClassLexicalEnvironment.facts;
            if (facts & 1) {
              return visitInvalidSuperProperty(node);
            }
            if (classConstructor && superClassReference) {
              var superProperty = factory.createReflectGetCall(superClassReference, ts3.visitNode(node.argumentExpression, visitor, ts3.isExpression), classConstructor);
              ts3.setOriginalNode(superProperty, node.expression);
              ts3.setTextRange(superProperty, node.expression);
              return superProperty;
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitPreOrPostfixUnaryExpression(node, valueIsDiscarded) {
          if (node.operator === 45 || node.operator === 46) {
            if (shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifierPropertyAccessExpression(node.operand)) {
              var info = void 0;
              if (info = accessPrivateIdentifier(node.operand.name)) {
                var receiver = ts3.visitNode(node.operand.expression, visitor, ts3.isExpression);
                var _a = createCopiableReceiverExpr(receiver), readExpression = _a.readExpression, initializeExpression = _a.initializeExpression;
                var expression = createPrivateIdentifierAccess(info, readExpression);
                var temp = ts3.isPrefixUnaryExpression(node) || valueIsDiscarded ? void 0 : factory.createTempVariable(hoistVariableDeclaration);
                expression = ts3.expandPreOrPostfixIncrementOrDecrementExpression(factory, node, expression, hoistVariableDeclaration, temp);
                expression = createPrivateIdentifierAssignment(info, initializeExpression || readExpression, expression, 63);
                ts3.setOriginalNode(expression, node);
                ts3.setTextRange(expression, node);
                if (temp) {
                  expression = factory.createComma(expression, temp);
                  ts3.setTextRange(expression, node);
                }
                return expression;
              }
            } else if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(node.operand) && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
              var classConstructor = currentClassLexicalEnvironment.classConstructor, superClassReference = currentClassLexicalEnvironment.superClassReference, facts = currentClassLexicalEnvironment.facts;
              if (facts & 1) {
                var operand = visitInvalidSuperProperty(node.operand);
                return ts3.isPrefixUnaryExpression(node) ? factory.updatePrefixUnaryExpression(node, operand) : factory.updatePostfixUnaryExpression(node, operand);
              }
              if (classConstructor && superClassReference) {
                var setterName = void 0;
                var getterName = void 0;
                if (ts3.isPropertyAccessExpression(node.operand)) {
                  if (ts3.isIdentifier(node.operand.name)) {
                    getterName = setterName = factory.createStringLiteralFromNode(node.operand.name);
                  }
                } else {
                  if (ts3.isSimpleInlineableExpression(node.operand.argumentExpression)) {
                    getterName = setterName = node.operand.argumentExpression;
                  } else {
                    getterName = factory.createTempVariable(hoistVariableDeclaration);
                    setterName = factory.createAssignment(getterName, ts3.visitNode(node.operand.argumentExpression, visitor, ts3.isExpression));
                  }
                }
                if (setterName && getterName) {
                  var expression = factory.createReflectGetCall(superClassReference, getterName, classConstructor);
                  ts3.setTextRange(expression, node.operand);
                  var temp = valueIsDiscarded ? void 0 : factory.createTempVariable(hoistVariableDeclaration);
                  expression = ts3.expandPreOrPostfixIncrementOrDecrementExpression(factory, node, expression, hoistVariableDeclaration, temp);
                  expression = factory.createReflectSetCall(superClassReference, setterName, expression, classConstructor);
                  ts3.setOriginalNode(expression, node);
                  ts3.setTextRange(expression, node);
                  if (temp) {
                    expression = factory.createComma(expression, temp);
                    ts3.setTextRange(expression, node);
                  }
                  return expression;
                }
              }
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          return factory.updateForStatement(node, ts3.visitNode(node.initializer, discardedValueVisitor, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, discardedValueVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, visitor, context));
        }
        function visitExpressionStatement(node) {
          return factory.updateExpressionStatement(node, ts3.visitNode(node.expression, discardedValueVisitor, ts3.isExpression));
        }
        function createCopiableReceiverExpr(receiver) {
          var clone = ts3.nodeIsSynthesized(receiver) ? receiver : factory.cloneNode(receiver);
          if (ts3.isSimpleInlineableExpression(receiver)) {
            return { readExpression: clone, initializeExpression: void 0 };
          }
          var readExpression = factory.createTempVariable(hoistVariableDeclaration);
          var initializeExpression = factory.createAssignment(readExpression, clone);
          return { readExpression, initializeExpression };
        }
        function visitCallExpression(node) {
          if (shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifierPropertyAccessExpression(node.expression)) {
            var _a = factory.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion), thisArg = _a.thisArg, target = _a.target;
            if (ts3.isCallChain(node)) {
              return factory.updateCallChain(node, factory.createPropertyAccessChain(ts3.visitNode(target, visitor), node.questionDotToken, "call"), void 0, void 0, __spreadArray([ts3.visitNode(thisArg, visitor, ts3.isExpression)], ts3.visitNodes(node.arguments, visitor, ts3.isExpression), true));
            }
            return factory.updateCallExpression(node, factory.createPropertyAccessExpression(ts3.visitNode(target, visitor), "call"), void 0, __spreadArray([ts3.visitNode(thisArg, visitor, ts3.isExpression)], ts3.visitNodes(node.arguments, visitor, ts3.isExpression), true));
          }
          if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(node.expression) && currentStaticPropertyDeclarationOrStaticBlock && (currentClassLexicalEnvironment === null || currentClassLexicalEnvironment === void 0 ? void 0 : currentClassLexicalEnvironment.classConstructor)) {
            var invocation = factory.createFunctionCallCall(ts3.visitNode(node.expression, visitor, ts3.isExpression), currentClassLexicalEnvironment.classConstructor, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
            ts3.setOriginalNode(invocation, node);
            ts3.setTextRange(invocation, node);
            return invocation;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitTaggedTemplateExpression(node) {
          if (shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifierPropertyAccessExpression(node.tag)) {
            var _a = factory.createCallBinding(node.tag, hoistVariableDeclaration, languageVersion), thisArg = _a.thisArg, target = _a.target;
            return factory.updateTaggedTemplateExpression(node, factory.createCallExpression(factory.createPropertyAccessExpression(ts3.visitNode(target, visitor), "bind"), void 0, [ts3.visitNode(thisArg, visitor, ts3.isExpression)]), void 0, ts3.visitNode(node.template, visitor, ts3.isTemplateLiteral));
          }
          if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(node.tag) && currentStaticPropertyDeclarationOrStaticBlock && (currentClassLexicalEnvironment === null || currentClassLexicalEnvironment === void 0 ? void 0 : currentClassLexicalEnvironment.classConstructor)) {
            var invocation = factory.createFunctionBindCall(ts3.visitNode(node.tag, visitor, ts3.isExpression), currentClassLexicalEnvironment.classConstructor, []);
            ts3.setOriginalNode(invocation, node);
            ts3.setTextRange(invocation, node);
            return factory.updateTaggedTemplateExpression(node, invocation, void 0, ts3.visitNode(node.template, visitor, ts3.isTemplateLiteral));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformClassStaticBlockDeclaration(node) {
          if (shouldTransformPrivateElementsOrClassStaticBlocks) {
            if (currentClassLexicalEnvironment) {
              classLexicalEnvironmentMap.set(ts3.getOriginalNodeId(node), currentClassLexicalEnvironment);
            }
            startLexicalEnvironment();
            var savedCurrentStaticPropertyDeclarationOrStaticBlock = currentStaticPropertyDeclarationOrStaticBlock;
            currentStaticPropertyDeclarationOrStaticBlock = node;
            var statements = ts3.visitNodes(node.body.statements, visitor, ts3.isStatement);
            statements = factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
            currentStaticPropertyDeclarationOrStaticBlock = savedCurrentStaticPropertyDeclarationOrStaticBlock;
            var iife = factory.createImmediatelyInvokedArrowFunction(statements);
            ts3.setOriginalNode(iife, node);
            ts3.setTextRange(iife, node);
            ts3.addEmitFlags(iife, 2);
            return iife;
          }
        }
        function visitBinaryExpression(node, valueIsDiscarded) {
          if (ts3.isDestructuringAssignment(node)) {
            var savedPendingExpressions = pendingExpressions;
            pendingExpressions = void 0;
            node = factory.updateBinaryExpression(node, ts3.visitNode(node.left, visitorDestructuringTarget), node.operatorToken, ts3.visitNode(node.right, visitor));
            var expr = ts3.some(pendingExpressions) ? factory.inlineExpressions(ts3.compact(__spreadArray(__spreadArray([], pendingExpressions, true), [node], false))) : node;
            pendingExpressions = savedPendingExpressions;
            return expr;
          }
          if (ts3.isAssignmentExpression(node)) {
            if (shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifierPropertyAccessExpression(node.left)) {
              var info = accessPrivateIdentifier(node.left.name);
              if (info) {
                return ts3.setTextRange(ts3.setOriginalNode(createPrivateIdentifierAssignment(info, node.left.expression, node.right, node.operatorToken.kind), node), node);
              }
            } else if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(node.left) && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
              var classConstructor = currentClassLexicalEnvironment.classConstructor, superClassReference = currentClassLexicalEnvironment.superClassReference, facts = currentClassLexicalEnvironment.facts;
              if (facts & 1) {
                return factory.updateBinaryExpression(node, visitInvalidSuperProperty(node.left), node.operatorToken, ts3.visitNode(node.right, visitor, ts3.isExpression));
              }
              if (classConstructor && superClassReference) {
                var setterName = ts3.isElementAccessExpression(node.left) ? ts3.visitNode(node.left.argumentExpression, visitor, ts3.isExpression) : ts3.isIdentifier(node.left.name) ? factory.createStringLiteralFromNode(node.left.name) : void 0;
                if (setterName) {
                  var expression = ts3.visitNode(node.right, visitor, ts3.isExpression);
                  if (ts3.isCompoundAssignment(node.operatorToken.kind)) {
                    var getterName = setterName;
                    if (!ts3.isSimpleInlineableExpression(setterName)) {
                      getterName = factory.createTempVariable(hoistVariableDeclaration);
                      setterName = factory.createAssignment(getterName, setterName);
                    }
                    var superPropertyGet = factory.createReflectGetCall(superClassReference, getterName, classConstructor);
                    ts3.setOriginalNode(superPropertyGet, node.left);
                    ts3.setTextRange(superPropertyGet, node.left);
                    expression = factory.createBinaryExpression(superPropertyGet, ts3.getNonAssignmentOperatorForCompoundAssignment(node.operatorToken.kind), expression);
                    ts3.setTextRange(expression, node);
                  }
                  var temp = valueIsDiscarded ? void 0 : factory.createTempVariable(hoistVariableDeclaration);
                  if (temp) {
                    expression = factory.createAssignment(temp, expression);
                    ts3.setTextRange(temp, node);
                  }
                  expression = factory.createReflectSetCall(superClassReference, setterName, expression, classConstructor);
                  ts3.setOriginalNode(expression, node);
                  ts3.setTextRange(expression, node);
                  if (temp) {
                    expression = factory.createComma(expression, temp);
                    ts3.setTextRange(expression, node);
                  }
                  return expression;
                }
              }
            }
          }
          if (node.operatorToken.kind === 101 && ts3.isPrivateIdentifier(node.left)) {
            return visitPrivateIdentifierInInExpression(node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function createPrivateIdentifierAssignment(info, receiver, right, operator) {
          receiver = ts3.visitNode(receiver, visitor, ts3.isExpression);
          right = ts3.visitNode(right, visitor, ts3.isExpression);
          if (ts3.isCompoundAssignment(operator)) {
            var _a = createCopiableReceiverExpr(receiver), readExpression = _a.readExpression, initializeExpression = _a.initializeExpression;
            receiver = initializeExpression || readExpression;
            right = factory.createBinaryExpression(createPrivateIdentifierAccessHelper(info, readExpression), ts3.getNonAssignmentOperatorForCompoundAssignment(operator), right);
          }
          ts3.setCommentRange(receiver, ts3.moveRangePos(receiver, -1));
          switch (info.kind) {
            case "a":
              return context.getEmitHelperFactory().createClassPrivateFieldSetHelper(receiver, info.brandCheckIdentifier, right, info.kind, info.setterName);
            case "m":
              return context.getEmitHelperFactory().createClassPrivateFieldSetHelper(receiver, info.brandCheckIdentifier, right, info.kind, void 0);
            case "f":
              return context.getEmitHelperFactory().createClassPrivateFieldSetHelper(receiver, info.brandCheckIdentifier, right, info.kind, info.variableName);
            default:
              ts3.Debug.assertNever(info, "Unknown private element type");
          }
        }
        function visitClassLike(node) {
          if (!ts3.forEach(node.members, doesClassElementNeedTransform)) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var savedPendingExpressions = pendingExpressions;
          pendingExpressions = void 0;
          startClassLexicalEnvironment();
          if (shouldTransformPrivateElementsOrClassStaticBlocks) {
            var name = ts3.getNameOfDeclaration(node);
            if (name && ts3.isIdentifier(name)) {
              getPrivateIdentifierEnvironment().className = ts3.idText(name);
            }
            var privateInstanceMethodsAndAccessors = getPrivateInstanceMethodsAndAccessors(node);
            if (ts3.some(privateInstanceMethodsAndAccessors)) {
              getPrivateIdentifierEnvironment().weakSetName = createHoistedVariableForClass("instances", privateInstanceMethodsAndAccessors[0].name);
            }
          }
          var result2 = ts3.isClassDeclaration(node) ? visitClassDeclaration(node) : visitClassExpression(node);
          endClassLexicalEnvironment();
          pendingExpressions = savedPendingExpressions;
          return result2;
        }
        function doesClassElementNeedTransform(node) {
          return ts3.isPropertyDeclaration(node) || ts3.isClassStaticBlockDeclaration(node) || shouldTransformPrivateElementsOrClassStaticBlocks && node.name && ts3.isPrivateIdentifier(node.name);
        }
        function getPrivateInstanceMethodsAndAccessors(node) {
          return ts3.filter(node.members, ts3.isNonStaticMethodOrAccessorWithPrivateName);
        }
        function getClassFacts(node) {
          var facts = 0;
          var original = ts3.getOriginalNode(node);
          if (ts3.isClassDeclaration(original) && ts3.classOrConstructorParameterIsDecorated(original)) {
            facts |= 1;
          }
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (!ts3.isStatic(member))
              continue;
            if (member.name && ts3.isPrivateIdentifier(member.name) && shouldTransformPrivateElementsOrClassStaticBlocks) {
              facts |= 2;
            }
            if (ts3.isPropertyDeclaration(member) || ts3.isClassStaticBlockDeclaration(member)) {
              if (shouldTransformThisInStaticInitializers && member.transformFlags & 8192) {
                facts |= 8;
                if (!(facts & 1)) {
                  facts |= 2;
                }
              }
              if (shouldTransformSuperInStaticInitializers && member.transformFlags & 33554432) {
                if (!(facts & 1)) {
                  facts |= 2 | 4;
                }
              }
            }
          }
          return facts;
        }
        function visitExpressionWithTypeArguments(node) {
          var facts = (currentClassLexicalEnvironment === null || currentClassLexicalEnvironment === void 0 ? void 0 : currentClassLexicalEnvironment.facts) || 0;
          if (facts & 4) {
            var temp = factory.createTempVariable(hoistVariableDeclaration, true);
            getClassLexicalEnvironment().superClassReference = temp;
            return factory.updateExpressionWithTypeArguments(node, factory.createAssignment(temp, ts3.visitNode(node.expression, visitor, ts3.isExpression)), void 0);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitClassDeclaration(node) {
          var facts = getClassFacts(node);
          if (facts) {
            getClassLexicalEnvironment().facts = facts;
          }
          if (facts & 8) {
            enableSubstitutionForClassStaticThisOrSuperReference();
          }
          var pendingClassReferenceAssignment;
          if (facts & 2) {
            var temp = factory.createTempVariable(hoistVariableDeclaration, true);
            getClassLexicalEnvironment().classConstructor = factory.cloneNode(temp);
            pendingClassReferenceAssignment = factory.createAssignment(temp, factory.getInternalName(node));
          }
          var extendsClauseElement = ts3.getEffectiveBaseTypeNode(node);
          var isDerivedClass = !!(extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 104);
          var statements = [
            factory.updateClassDeclaration(node, void 0, node.modifiers, node.name, void 0, ts3.visitNodes(node.heritageClauses, heritageClauseVisitor, ts3.isHeritageClause), transformClassMembers(node, isDerivedClass))
          ];
          if (pendingClassReferenceAssignment) {
            getPendingExpressions().unshift(pendingClassReferenceAssignment);
          }
          if (ts3.some(pendingExpressions)) {
            statements.push(factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions)));
          }
          var staticProperties = ts3.getStaticPropertiesAndClassStaticBlock(node);
          if (ts3.some(staticProperties)) {
            addPropertyOrClassStaticBlockStatements(statements, staticProperties, factory.getInternalName(node));
          }
          return statements;
        }
        function visitClassExpression(node) {
          var facts = getClassFacts(node);
          if (facts) {
            getClassLexicalEnvironment().facts = facts;
          }
          if (facts & 8) {
            enableSubstitutionForClassStaticThisOrSuperReference();
          }
          var isDecoratedClassDeclaration = !!(facts & 1);
          var staticPropertiesOrClassStaticBlocks = ts3.getStaticPropertiesAndClassStaticBlock(node);
          var extendsClauseElement = ts3.getEffectiveBaseTypeNode(node);
          var isDerivedClass = !!(extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 104);
          var isClassWithConstructorReference = resolver.getNodeCheckFlags(node) & 16777216;
          var temp;
          function createClassTempVar() {
            var classCheckFlags = resolver.getNodeCheckFlags(node);
            var isClassWithConstructorReference2 = classCheckFlags & 16777216;
            var requiresBlockScopedVar = classCheckFlags & 524288;
            return factory.createTempVariable(requiresBlockScopedVar ? addBlockScopedVariable : hoistVariableDeclaration, !!isClassWithConstructorReference2);
          }
          if (facts & 2) {
            temp = createClassTempVar();
            getClassLexicalEnvironment().classConstructor = factory.cloneNode(temp);
          }
          var classExpression = factory.updateClassExpression(node, ts3.visitNodes(node.decorators, visitor, ts3.isDecorator), node.modifiers, node.name, void 0, ts3.visitNodes(node.heritageClauses, heritageClauseVisitor, ts3.isHeritageClause), transformClassMembers(node, isDerivedClass));
          var hasTransformableStatics = shouldTransformPrivateElementsOrClassStaticBlocks && ts3.some(staticPropertiesOrClassStaticBlocks, function(p) {
            return ts3.isClassStaticBlockDeclaration(p) || !!p.initializer || ts3.isPrivateIdentifier(p.name);
          });
          if (hasTransformableStatics || ts3.some(pendingExpressions)) {
            if (isDecoratedClassDeclaration) {
              ts3.Debug.assertIsDefined(pendingStatements, "Decorated classes transformed by TypeScript are expected to be within a variable declaration.");
              if (pendingStatements && pendingExpressions && ts3.some(pendingExpressions)) {
                pendingStatements.push(factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions)));
              }
              if (pendingStatements && ts3.some(staticPropertiesOrClassStaticBlocks)) {
                addPropertyOrClassStaticBlockStatements(pendingStatements, staticPropertiesOrClassStaticBlocks, factory.getInternalName(node));
              }
              if (temp) {
                return factory.inlineExpressions([factory.createAssignment(temp, classExpression), temp]);
              }
              return classExpression;
            } else {
              var expressions = [];
              temp || (temp = createClassTempVar());
              if (isClassWithConstructorReference) {
                enableSubstitutionForClassAliases();
                var alias = factory.cloneNode(temp);
                alias.autoGenerateFlags &= ~8;
                classAliases[ts3.getOriginalNodeId(node)] = alias;
              }
              ts3.setEmitFlags(classExpression, 65536 | ts3.getEmitFlags(classExpression));
              expressions.push(ts3.startOnNewLine(factory.createAssignment(temp, classExpression)));
              ts3.addRange(expressions, ts3.map(pendingExpressions, ts3.startOnNewLine));
              ts3.addRange(expressions, generateInitializedPropertyExpressionsOrClassStaticBlock(staticPropertiesOrClassStaticBlocks, temp));
              expressions.push(ts3.startOnNewLine(temp));
              return factory.inlineExpressions(expressions);
            }
          }
          return classExpression;
        }
        function visitClassStaticBlockDeclaration(node) {
          if (!shouldTransformPrivateElementsOrClassStaticBlocks) {
            return ts3.visitEachChild(node, classElementVisitor, context);
          }
          return void 0;
        }
        function transformClassMembers(node, isDerivedClass) {
          var members = [];
          if (shouldTransformPrivateElementsOrClassStaticBlocks) {
            for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
              var member = _a[_i];
              if (ts3.isPrivateIdentifierClassElementDeclaration(member)) {
                addPrivateIdentifierToEnvironment(member);
              }
            }
            if (ts3.some(getPrivateInstanceMethodsAndAccessors(node))) {
              createBrandCheckWeakSetForPrivateMethods();
            }
          }
          var constructor = transformConstructor(node, isDerivedClass);
          var visitedMembers = ts3.visitNodes(node.members, classElementVisitor, ts3.isClassElement);
          if (constructor) {
            members.push(constructor);
          }
          if (!shouldTransformPrivateElementsOrClassStaticBlocks && ts3.some(pendingExpressions)) {
            members.push(factory.createClassStaticBlockDeclaration(void 0, void 0, factory.createBlock([
              factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions))
            ])));
            pendingExpressions = void 0;
          }
          ts3.addRange(members, visitedMembers);
          return ts3.setTextRange(factory.createNodeArray(members), node.members);
        }
        function createBrandCheckWeakSetForPrivateMethods() {
          var weakSetName = getPrivateIdentifierEnvironment().weakSetName;
          ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
          getPendingExpressions().push(factory.createAssignment(weakSetName, factory.createNewExpression(factory.createIdentifier("WeakSet"), void 0, [])));
        }
        function isClassElementThatRequiresConstructorStatement(member) {
          if (ts3.isStatic(member) || ts3.hasSyntacticModifier(ts3.getOriginalNode(member), 128)) {
            return false;
          }
          if (useDefineForClassFields) {
            return languageVersion < 9;
          }
          return ts3.isInitializedProperty(member) || shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifierClassElementDeclaration(member);
        }
        function transformConstructor(node, isDerivedClass) {
          var constructor = ts3.visitNode(ts3.getFirstConstructorWithBody(node), visitor, ts3.isConstructorDeclaration);
          var elements = node.members.filter(isClassElementThatRequiresConstructorStatement);
          if (!ts3.some(elements)) {
            return constructor;
          }
          var parameters = ts3.visitParameterList(constructor ? constructor.parameters : void 0, visitor, context);
          var body = transformConstructorBody(node, constructor, isDerivedClass);
          if (!body) {
            return void 0;
          }
          return ts3.startOnNewLine(ts3.setOriginalNode(ts3.setTextRange(factory.createConstructorDeclaration(void 0, void 0, parameters !== null && parameters !== void 0 ? parameters : [], body), constructor || node), constructor));
        }
        function transformConstructorBody(node, constructor, isDerivedClass) {
          var _a;
          var properties = ts3.getProperties(node, false, false);
          if (!useDefineForClassFields) {
            properties = ts3.filter(properties, function(property) {
              return !!property.initializer || ts3.isPrivateIdentifier(property.name);
            });
          }
          var privateMethodsAndAccessors = getPrivateInstanceMethodsAndAccessors(node);
          var needsConstructorBody = ts3.some(properties) || ts3.some(privateMethodsAndAccessors);
          if (!constructor && !needsConstructorBody) {
            return ts3.visitFunctionBody(void 0, visitor, context);
          }
          resumeLexicalEnvironment();
          var needsSyntheticConstructor = !constructor && isDerivedClass;
          var indexOfFirstStatementAfterSuperAndPrologue = 0;
          var prologueStatementCount = 0;
          var superStatementIndex = -1;
          var statements = [];
          if ((_a = constructor === null || constructor === void 0 ? void 0 : constructor.body) === null || _a === void 0 ? void 0 : _a.statements) {
            prologueStatementCount = factory.copyPrologue(constructor.body.statements, statements, false, visitor);
            superStatementIndex = ts3.findSuperStatementIndex(constructor.body.statements, prologueStatementCount);
            if (superStatementIndex >= 0) {
              indexOfFirstStatementAfterSuperAndPrologue = superStatementIndex + 1;
              statements = __spreadArray(__spreadArray(__spreadArray([], statements.slice(0, prologueStatementCount), true), ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, prologueStatementCount, indexOfFirstStatementAfterSuperAndPrologue - prologueStatementCount), true), statements.slice(prologueStatementCount), true);
            } else if (prologueStatementCount >= 0) {
              indexOfFirstStatementAfterSuperAndPrologue = prologueStatementCount;
            }
          }
          if (needsSyntheticConstructor) {
            statements.push(factory.createExpressionStatement(factory.createCallExpression(factory.createSuper(), void 0, [factory.createSpreadElement(factory.createIdentifier("arguments"))])));
          }
          var parameterPropertyDeclarationCount = 0;
          if (constructor === null || constructor === void 0 ? void 0 : constructor.body) {
            if (useDefineForClassFields) {
              statements = statements.filter(function(statement2) {
                return !ts3.isParameterPropertyDeclaration(ts3.getOriginalNode(statement2), constructor);
              });
            } else {
              for (var _i = 0, _b = constructor.body.statements; _i < _b.length; _i++) {
                var statement = _b[_i];
                if (ts3.isParameterPropertyDeclaration(ts3.getOriginalNode(statement), constructor)) {
                  parameterPropertyDeclarationCount++;
                }
              }
              if (parameterPropertyDeclarationCount > 0) {
                var parameterProperties = ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, indexOfFirstStatementAfterSuperAndPrologue, parameterPropertyDeclarationCount);
                if (superStatementIndex >= 0) {
                  ts3.addRange(statements, parameterProperties);
                } else {
                  var superAndPrologueStatementCount = prologueStatementCount;
                  if (needsSyntheticConstructor)
                    superAndPrologueStatementCount++;
                  statements = __spreadArray(__spreadArray(__spreadArray([], statements.slice(0, superAndPrologueStatementCount), true), parameterProperties, true), statements.slice(superAndPrologueStatementCount), true);
                }
                indexOfFirstStatementAfterSuperAndPrologue += parameterPropertyDeclarationCount;
              }
            }
          }
          var receiver = factory.createThis();
          addMethodStatements(statements, privateMethodsAndAccessors, receiver);
          addPropertyOrClassStaticBlockStatements(statements, properties, receiver);
          if (constructor) {
            ts3.addRange(statements, ts3.visitNodes(constructor.body.statements, visitBodyStatement, ts3.isStatement, indexOfFirstStatementAfterSuperAndPrologue));
          }
          statements = factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          return ts3.setTextRange(factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), constructor ? constructor.body.statements : node.members), true), constructor ? constructor.body : void 0);
          function visitBodyStatement(statement2) {
            if (useDefineForClassFields && ts3.isParameterPropertyDeclaration(ts3.getOriginalNode(statement2), constructor)) {
              return void 0;
            }
            return visitor(statement2);
          }
        }
        function addPropertyOrClassStaticBlockStatements(statements, properties, receiver) {
          for (var _i = 0, properties_7 = properties; _i < properties_7.length; _i++) {
            var property = properties_7[_i];
            if (ts3.isStatic(property) && !shouldTransformPrivateElementsOrClassStaticBlocks && !useDefineForClassFields) {
              continue;
            }
            var statement = transformPropertyOrClassStaticBlock(property, receiver);
            if (!statement) {
              continue;
            }
            statements.push(statement);
          }
        }
        function transformPropertyOrClassStaticBlock(property, receiver) {
          var expression = ts3.isClassStaticBlockDeclaration(property) ? transformClassStaticBlockDeclaration(property) : transformProperty(property, receiver);
          if (!expression) {
            return void 0;
          }
          var statement = factory.createExpressionStatement(expression);
          ts3.setSourceMapRange(statement, ts3.moveRangePastModifiers(property));
          ts3.setCommentRange(statement, property);
          ts3.setOriginalNode(statement, property);
          ts3.setSyntheticLeadingComments(expression, void 0);
          ts3.setSyntheticTrailingComments(expression, void 0);
          return statement;
        }
        function generateInitializedPropertyExpressionsOrClassStaticBlock(propertiesOrClassStaticBlocks, receiver) {
          var expressions = [];
          for (var _i = 0, propertiesOrClassStaticBlocks_1 = propertiesOrClassStaticBlocks; _i < propertiesOrClassStaticBlocks_1.length; _i++) {
            var property = propertiesOrClassStaticBlocks_1[_i];
            var expression = ts3.isClassStaticBlockDeclaration(property) ? transformClassStaticBlockDeclaration(property) : transformProperty(property, receiver);
            if (!expression) {
              continue;
            }
            ts3.startOnNewLine(expression);
            ts3.setSourceMapRange(expression, ts3.moveRangePastModifiers(property));
            ts3.setCommentRange(expression, property);
            ts3.setOriginalNode(expression, property);
            expressions.push(expression);
          }
          return expressions;
        }
        function transformProperty(property, receiver) {
          var savedCurrentStaticPropertyDeclarationOrStaticBlock = currentStaticPropertyDeclarationOrStaticBlock;
          var transformed = transformPropertyWorker(property, receiver);
          if (transformed && ts3.hasStaticModifier(property) && (currentClassLexicalEnvironment === null || currentClassLexicalEnvironment === void 0 ? void 0 : currentClassLexicalEnvironment.facts)) {
            ts3.setOriginalNode(transformed, property);
            ts3.addEmitFlags(transformed, 2);
            classLexicalEnvironmentMap.set(ts3.getOriginalNodeId(transformed), currentClassLexicalEnvironment);
          }
          currentStaticPropertyDeclarationOrStaticBlock = savedCurrentStaticPropertyDeclarationOrStaticBlock;
          return transformed;
        }
        function transformPropertyWorker(property, receiver) {
          var _a;
          var emitAssignment = !useDefineForClassFields;
          var propertyName = ts3.isComputedPropertyName(property.name) && !ts3.isSimpleInlineableExpression(property.name.expression) ? factory.updateComputedPropertyName(property.name, factory.getGeneratedNameForNode(property.name)) : property.name;
          if (ts3.hasStaticModifier(property)) {
            currentStaticPropertyDeclarationOrStaticBlock = property;
          }
          if (shouldTransformPrivateElementsOrClassStaticBlocks && ts3.isPrivateIdentifier(propertyName)) {
            var privateIdentifierInfo = accessPrivateIdentifier(propertyName);
            if (privateIdentifierInfo) {
              if (privateIdentifierInfo.kind === "f") {
                if (!privateIdentifierInfo.isStatic) {
                  return createPrivateInstanceFieldInitializer(receiver, ts3.visitNode(property.initializer, visitor, ts3.isExpression), privateIdentifierInfo.brandCheckIdentifier);
                } else {
                  return createPrivateStaticFieldInitializer(privateIdentifierInfo.variableName, ts3.visitNode(property.initializer, visitor, ts3.isExpression));
                }
              } else {
                return void 0;
              }
            } else {
              ts3.Debug.fail("Undeclared private name for property declaration.");
            }
          }
          if ((ts3.isPrivateIdentifier(propertyName) || ts3.hasStaticModifier(property)) && !property.initializer) {
            return void 0;
          }
          var propertyOriginalNode = ts3.getOriginalNode(property);
          if (ts3.hasSyntacticModifier(propertyOriginalNode, 128)) {
            return void 0;
          }
          var initializer = property.initializer || emitAssignment ? (_a = ts3.visitNode(property.initializer, visitor, ts3.isExpression)) !== null && _a !== void 0 ? _a : factory.createVoidZero() : ts3.isParameterPropertyDeclaration(propertyOriginalNode, propertyOriginalNode.parent) && ts3.isIdentifier(propertyName) ? propertyName : factory.createVoidZero();
          if (emitAssignment || ts3.isPrivateIdentifier(propertyName)) {
            var memberAccess = ts3.createMemberAccessForPropertyName(factory, receiver, propertyName, propertyName);
            return factory.createAssignment(memberAccess, initializer);
          } else {
            var name = ts3.isComputedPropertyName(propertyName) ? propertyName.expression : ts3.isIdentifier(propertyName) ? factory.createStringLiteral(ts3.unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
            var descriptor = factory.createPropertyDescriptor({ value: initializer, configurable: true, writable: true, enumerable: true });
            return factory.createObjectDefinePropertyCall(receiver, name, descriptor);
          }
        }
        function enableSubstitutionForClassAliases() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(79);
            classAliases = [];
          }
        }
        function enableSubstitutionForClassStaticThisOrSuperReference() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(108);
            context.enableEmitNotification(256);
            context.enableEmitNotification(213);
            context.enableEmitNotification(171);
            context.enableEmitNotification(172);
            context.enableEmitNotification(173);
            context.enableEmitNotification(169);
            context.enableEmitNotification(167);
            context.enableEmitNotification(162);
          }
        }
        function addMethodStatements(statements, methods, receiver) {
          if (!shouldTransformPrivateElementsOrClassStaticBlocks || !ts3.some(methods)) {
            return;
          }
          var weakSetName = getPrivateIdentifierEnvironment().weakSetName;
          ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
          statements.push(factory.createExpressionStatement(createPrivateInstanceMethodInitializer(receiver, weakSetName)));
        }
        function visitInvalidSuperProperty(node) {
          return ts3.isPropertyAccessExpression(node) ? factory.updatePropertyAccessExpression(node, factory.createVoidZero(), node.name) : factory.updateElementAccessExpression(node, factory.createVoidZero(), ts3.visitNode(node.argumentExpression, visitor, ts3.isExpression));
        }
        function onEmitNode(hint, node, emitCallback) {
          var original = ts3.getOriginalNode(node);
          if (original.id) {
            var classLexicalEnvironment = classLexicalEnvironmentMap.get(original.id);
            if (classLexicalEnvironment) {
              var savedClassLexicalEnvironment = currentClassLexicalEnvironment;
              var savedCurrentComputedPropertyNameClassLexicalEnvironment = currentComputedPropertyNameClassLexicalEnvironment;
              currentClassLexicalEnvironment = classLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = classLexicalEnvironment;
              previousOnEmitNode(hint, node, emitCallback);
              currentClassLexicalEnvironment = savedClassLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = savedCurrentComputedPropertyNameClassLexicalEnvironment;
              return;
            }
          }
          switch (node.kind) {
            case 213:
              if (ts3.isArrowFunction(original) || ts3.getEmitFlags(node) & 262144) {
                break;
              }
            case 256:
            case 171: {
              var savedClassLexicalEnvironment = currentClassLexicalEnvironment;
              var savedCurrentComputedPropertyNameClassLexicalEnvironment = currentComputedPropertyNameClassLexicalEnvironment;
              currentClassLexicalEnvironment = void 0;
              currentComputedPropertyNameClassLexicalEnvironment = void 0;
              previousOnEmitNode(hint, node, emitCallback);
              currentClassLexicalEnvironment = savedClassLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = savedCurrentComputedPropertyNameClassLexicalEnvironment;
              return;
            }
            case 172:
            case 173:
            case 169:
            case 167: {
              var savedClassLexicalEnvironment = currentClassLexicalEnvironment;
              var savedCurrentComputedPropertyNameClassLexicalEnvironment = currentComputedPropertyNameClassLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = currentClassLexicalEnvironment;
              currentClassLexicalEnvironment = void 0;
              previousOnEmitNode(hint, node, emitCallback);
              currentClassLexicalEnvironment = savedClassLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = savedCurrentComputedPropertyNameClassLexicalEnvironment;
              return;
            }
            case 162: {
              var savedClassLexicalEnvironment = currentClassLexicalEnvironment;
              var savedCurrentComputedPropertyNameClassLexicalEnvironment = currentComputedPropertyNameClassLexicalEnvironment;
              currentClassLexicalEnvironment = currentComputedPropertyNameClassLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = void 0;
              previousOnEmitNode(hint, node, emitCallback);
              currentClassLexicalEnvironment = savedClassLexicalEnvironment;
              currentComputedPropertyNameClassLexicalEnvironment = savedCurrentComputedPropertyNameClassLexicalEnvironment;
              return;
            }
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 79:
              return substituteExpressionIdentifier(node);
            case 108:
              return substituteThisExpression(node);
          }
          return node;
        }
        function substituteThisExpression(node) {
          if (enabledSubstitutions & 2 && currentClassLexicalEnvironment) {
            var facts = currentClassLexicalEnvironment.facts, classConstructor = currentClassLexicalEnvironment.classConstructor;
            if (facts & 1) {
              return factory.createParenthesizedExpression(factory.createVoidZero());
            }
            if (classConstructor) {
              return ts3.setTextRange(ts3.setOriginalNode(factory.cloneNode(classConstructor), node), node);
            }
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          return trySubstituteClassAlias(node) || node;
        }
        function trySubstituteClassAlias(node) {
          if (enabledSubstitutions & 1) {
            if (resolver.getNodeCheckFlags(node) & 33554432) {
              var declaration = resolver.getReferencedValueDeclaration(node);
              if (declaration) {
                var classAlias = classAliases[declaration.id];
                if (classAlias) {
                  var clone_3 = factory.cloneNode(classAlias);
                  ts3.setSourceMapRange(clone_3, node);
                  ts3.setCommentRange(clone_3, node);
                  return clone_3;
                }
              }
            }
          }
          return void 0;
        }
        function getPropertyNameExpressionIfNeeded(name, shouldHoist) {
          if (ts3.isComputedPropertyName(name)) {
            var expression = ts3.visitNode(name.expression, visitor, ts3.isExpression);
            var innerExpression = ts3.skipPartiallyEmittedExpressions(expression);
            var inlinable = ts3.isSimpleInlineableExpression(innerExpression);
            var alreadyTransformed = ts3.isAssignmentExpression(innerExpression) && ts3.isGeneratedIdentifier(innerExpression.left);
            if (!alreadyTransformed && !inlinable && shouldHoist) {
              var generatedName = factory.getGeneratedNameForNode(name);
              if (resolver.getNodeCheckFlags(name) & 524288) {
                addBlockScopedVariable(generatedName);
              } else {
                hoistVariableDeclaration(generatedName);
              }
              return factory.createAssignment(generatedName, expression);
            }
            return inlinable || ts3.isIdentifier(innerExpression) ? void 0 : expression;
          }
        }
        function startClassLexicalEnvironment() {
          classLexicalEnvironmentStack.push(currentClassLexicalEnvironment);
          currentClassLexicalEnvironment = void 0;
        }
        function endClassLexicalEnvironment() {
          currentClassLexicalEnvironment = classLexicalEnvironmentStack.pop();
        }
        function getClassLexicalEnvironment() {
          return currentClassLexicalEnvironment || (currentClassLexicalEnvironment = {
            facts: 0,
            classConstructor: void 0,
            superClassReference: void 0,
            privateIdentifierEnvironment: void 0
          });
        }
        function getPrivateIdentifierEnvironment() {
          var lex = getClassLexicalEnvironment();
          lex.privateIdentifierEnvironment || (lex.privateIdentifierEnvironment = {
            className: "",
            identifiers: new ts3.Map()
          });
          return lex.privateIdentifierEnvironment;
        }
        function getPendingExpressions() {
          return pendingExpressions || (pendingExpressions = []);
        }
        function addPrivateIdentifierToEnvironment(node) {
          var _a;
          var text = ts3.getTextOfPropertyName(node.name);
          var lex = getClassLexicalEnvironment();
          var classConstructor = lex.classConstructor;
          var privateEnv = getPrivateIdentifierEnvironment();
          var weakSetName = privateEnv.weakSetName;
          var assignmentExpressions = [];
          var privateName = node.name.escapedText;
          var previousInfo = privateEnv.identifiers.get(privateName);
          var isValid = !isReservedPrivateName(node.name) && previousInfo === void 0;
          if (ts3.hasStaticModifier(node)) {
            ts3.Debug.assert(classConstructor, "weakSetName should be set in private identifier environment");
            if (ts3.isPropertyDeclaration(node)) {
              var variableName = createHoistedVariableForPrivateName(text, node);
              privateEnv.identifiers.set(privateName, {
                kind: "f",
                variableName,
                brandCheckIdentifier: classConstructor,
                isStatic: true,
                isValid
              });
            } else if (ts3.isMethodDeclaration(node)) {
              var functionName = createHoistedVariableForPrivateName(text, node);
              privateEnv.identifiers.set(privateName, {
                kind: "m",
                methodName: functionName,
                brandCheckIdentifier: classConstructor,
                isStatic: true,
                isValid
              });
            } else if (ts3.isGetAccessorDeclaration(node)) {
              var getterName = createHoistedVariableForPrivateName(text + "_get", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && previousInfo.isStatic && !previousInfo.getterName) {
                previousInfo.getterName = getterName;
              } else {
                privateEnv.identifiers.set(privateName, {
                  kind: "a",
                  getterName,
                  setterName: void 0,
                  brandCheckIdentifier: classConstructor,
                  isStatic: true,
                  isValid
                });
              }
            } else if (ts3.isSetAccessorDeclaration(node)) {
              var setterName = createHoistedVariableForPrivateName(text + "_set", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && previousInfo.isStatic && !previousInfo.setterName) {
                previousInfo.setterName = setterName;
              } else {
                privateEnv.identifiers.set(privateName, {
                  kind: "a",
                  getterName: void 0,
                  setterName,
                  brandCheckIdentifier: classConstructor,
                  isStatic: true,
                  isValid
                });
              }
            } else {
              ts3.Debug.assertNever(node, "Unknown class element type.");
            }
          } else if (ts3.isPropertyDeclaration(node)) {
            var weakMapName = createHoistedVariableForPrivateName(text, node);
            privateEnv.identifiers.set(privateName, {
              kind: "f",
              brandCheckIdentifier: weakMapName,
              isStatic: false,
              variableName: void 0,
              isValid
            });
            assignmentExpressions.push(factory.createAssignment(weakMapName, factory.createNewExpression(factory.createIdentifier("WeakMap"), void 0, [])));
          } else if (ts3.isMethodDeclaration(node)) {
            ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
            privateEnv.identifiers.set(privateName, {
              kind: "m",
              methodName: createHoistedVariableForPrivateName(text, node),
              brandCheckIdentifier: weakSetName,
              isStatic: false,
              isValid
            });
          } else if (ts3.isAccessor(node)) {
            ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
            if (ts3.isGetAccessor(node)) {
              var getterName = createHoistedVariableForPrivateName(text + "_get", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && !previousInfo.isStatic && !previousInfo.getterName) {
                previousInfo.getterName = getterName;
              } else {
                privateEnv.identifiers.set(privateName, {
                  kind: "a",
                  getterName,
                  setterName: void 0,
                  brandCheckIdentifier: weakSetName,
                  isStatic: false,
                  isValid
                });
              }
            } else {
              var setterName = createHoistedVariableForPrivateName(text + "_set", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && !previousInfo.isStatic && !previousInfo.setterName) {
                previousInfo.setterName = setterName;
              } else {
                privateEnv.identifiers.set(privateName, {
                  kind: "a",
                  getterName: void 0,
                  setterName,
                  brandCheckIdentifier: weakSetName,
                  isStatic: false,
                  isValid
                });
              }
            }
          } else {
            ts3.Debug.assertNever(node, "Unknown class element type.");
          }
          (_a = getPendingExpressions()).push.apply(_a, assignmentExpressions);
        }
        function createHoistedVariableForClass(name, node) {
          var className = getPrivateIdentifierEnvironment().className;
          var prefix = className ? "_".concat(className) : "";
          var identifier = factory.createUniqueName("".concat(prefix, "_").concat(name), 16);
          if (resolver.getNodeCheckFlags(node) & 524288) {
            addBlockScopedVariable(identifier);
          } else {
            hoistVariableDeclaration(identifier);
          }
          return identifier;
        }
        function createHoistedVariableForPrivateName(privateName, node) {
          return createHoistedVariableForClass(privateName.substring(1), node.name);
        }
        function accessPrivateIdentifier(name) {
          var _a;
          if (currentClassLexicalEnvironment === null || currentClassLexicalEnvironment === void 0 ? void 0 : currentClassLexicalEnvironment.privateIdentifierEnvironment) {
            var info = currentClassLexicalEnvironment.privateIdentifierEnvironment.identifiers.get(name.escapedText);
            if (info) {
              return info;
            }
          }
          for (var i = classLexicalEnvironmentStack.length - 1; i >= 0; --i) {
            var env = classLexicalEnvironmentStack[i];
            if (!env) {
              continue;
            }
            var info = (_a = env.privateIdentifierEnvironment) === null || _a === void 0 ? void 0 : _a.identifiers.get(name.escapedText);
            if (info) {
              return info;
            }
          }
          return void 0;
        }
        function wrapPrivateIdentifierForDestructuringTarget(node) {
          var parameter = factory.getGeneratedNameForNode(node);
          var info = accessPrivateIdentifier(node.name);
          if (!info) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var receiver = node.expression;
          if (ts3.isThisProperty(node) || ts3.isSuperProperty(node) || !ts3.isSimpleCopiableExpression(node.expression)) {
            receiver = factory.createTempVariable(hoistVariableDeclaration, true);
            getPendingExpressions().push(factory.createBinaryExpression(receiver, 63, ts3.visitNode(node.expression, visitor, ts3.isExpression)));
          }
          return factory.createAssignmentTargetWrapper(parameter, createPrivateIdentifierAssignment(info, receiver, parameter, 63));
        }
        function visitArrayAssignmentTarget(node) {
          var target = ts3.getTargetOfBindingOrAssignmentElement(node);
          if (target) {
            var wrapped = void 0;
            if (ts3.isPrivateIdentifierPropertyAccessExpression(target)) {
              wrapped = wrapPrivateIdentifierForDestructuringTarget(target);
            } else if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(target) && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
              var classConstructor = currentClassLexicalEnvironment.classConstructor, superClassReference = currentClassLexicalEnvironment.superClassReference, facts = currentClassLexicalEnvironment.facts;
              if (facts & 1) {
                wrapped = visitInvalidSuperProperty(target);
              } else if (classConstructor && superClassReference) {
                var name = ts3.isElementAccessExpression(target) ? ts3.visitNode(target.argumentExpression, visitor, ts3.isExpression) : ts3.isIdentifier(target.name) ? factory.createStringLiteralFromNode(target.name) : void 0;
                if (name) {
                  var temp = factory.createTempVariable(void 0);
                  wrapped = factory.createAssignmentTargetWrapper(temp, factory.createReflectSetCall(superClassReference, name, temp, classConstructor));
                }
              }
            }
            if (wrapped) {
              if (ts3.isAssignmentExpression(node)) {
                return factory.updateBinaryExpression(node, wrapped, node.operatorToken, ts3.visitNode(node.right, visitor, ts3.isExpression));
              } else if (ts3.isSpreadElement(node)) {
                return factory.updateSpreadElement(node, wrapped);
              } else {
                return wrapped;
              }
            }
          }
          return ts3.visitNode(node, visitorDestructuringTarget);
        }
        function visitObjectAssignmentTarget(node) {
          if (ts3.isObjectBindingOrAssignmentElement(node) && !ts3.isShorthandPropertyAssignment(node)) {
            var target = ts3.getTargetOfBindingOrAssignmentElement(node);
            var wrapped = void 0;
            if (target) {
              if (ts3.isPrivateIdentifierPropertyAccessExpression(target)) {
                wrapped = wrapPrivateIdentifierForDestructuringTarget(target);
              } else if (shouldTransformSuperInStaticInitializers && ts3.isSuperProperty(target) && currentStaticPropertyDeclarationOrStaticBlock && currentClassLexicalEnvironment) {
                var classConstructor = currentClassLexicalEnvironment.classConstructor, superClassReference = currentClassLexicalEnvironment.superClassReference, facts = currentClassLexicalEnvironment.facts;
                if (facts & 1) {
                  wrapped = visitInvalidSuperProperty(target);
                } else if (classConstructor && superClassReference) {
                  var name = ts3.isElementAccessExpression(target) ? ts3.visitNode(target.argumentExpression, visitor, ts3.isExpression) : ts3.isIdentifier(target.name) ? factory.createStringLiteralFromNode(target.name) : void 0;
                  if (name) {
                    var temp = factory.createTempVariable(void 0);
                    wrapped = factory.createAssignmentTargetWrapper(temp, factory.createReflectSetCall(superClassReference, name, temp, classConstructor));
                  }
                }
              }
            }
            if (ts3.isPropertyAssignment(node)) {
              var initializer = ts3.getInitializerOfBindingOrAssignmentElement(node);
              return factory.updatePropertyAssignment(node, ts3.visitNode(node.name, visitor, ts3.isPropertyName), wrapped ? initializer ? factory.createAssignment(wrapped, ts3.visitNode(initializer, visitor)) : wrapped : ts3.visitNode(node.initializer, visitorDestructuringTarget, ts3.isExpression));
            }
            if (ts3.isSpreadAssignment(node)) {
              return factory.updateSpreadAssignment(node, wrapped || ts3.visitNode(node.expression, visitorDestructuringTarget, ts3.isExpression));
            }
            ts3.Debug.assert(wrapped === void 0, "Should not have generated a wrapped target");
          }
          return ts3.visitNode(node, visitor);
        }
        function visitAssignmentPattern(node) {
          if (ts3.isArrayLiteralExpression(node)) {
            return factory.updateArrayLiteralExpression(node, ts3.visitNodes(node.elements, visitArrayAssignmentTarget, ts3.isExpression));
          } else {
            return factory.updateObjectLiteralExpression(node, ts3.visitNodes(node.properties, visitObjectAssignmentTarget, ts3.isObjectLiteralElementLike));
          }
        }
      }
      ts3.transformClassFields = transformClassFields;
      function createPrivateStaticFieldInitializer(variableName, initializer) {
        return ts3.factory.createAssignment(variableName, ts3.factory.createObjectLiteralExpression([
          ts3.factory.createPropertyAssignment("value", initializer || ts3.factory.createVoidZero())
        ]));
      }
      function createPrivateInstanceFieldInitializer(receiver, initializer, weakMapName) {
        return ts3.factory.createCallExpression(ts3.factory.createPropertyAccessExpression(weakMapName, "set"), void 0, [receiver, initializer || ts3.factory.createVoidZero()]);
      }
      function createPrivateInstanceMethodInitializer(receiver, weakSetName) {
        return ts3.factory.createCallExpression(ts3.factory.createPropertyAccessExpression(weakSetName, "add"), void 0, [receiver]);
      }
      function isReservedPrivateName(node) {
        return node.escapedText === "#constructor";
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ES2017SubstitutionFlags;
      (function(ES2017SubstitutionFlags2) {
        ES2017SubstitutionFlags2[ES2017SubstitutionFlags2["AsyncMethodsWithSuper"] = 1] = "AsyncMethodsWithSuper";
      })(ES2017SubstitutionFlags || (ES2017SubstitutionFlags = {}));
      var ContextFlags;
      (function(ContextFlags2) {
        ContextFlags2[ContextFlags2["NonTopLevel"] = 1] = "NonTopLevel";
        ContextFlags2[ContextFlags2["HasLexicalThis"] = 2] = "HasLexicalThis";
      })(ContextFlags || (ContextFlags = {}));
      function transformES2017(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var enabledSubstitutions;
        var enclosingSuperContainerFlags = 0;
        var enclosingFunctionParameterNames;
        var capturedSuperProperties;
        var hasSuperElementAccess;
        var substitutedSuperAccessors = [];
        var contextFlags = 0;
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          setContextFlag(1, false);
          setContextFlag(2, !ts3.isEffectiveStrictModeSourceFile(node, compilerOptions));
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function setContextFlag(flag, val) {
          contextFlags = val ? contextFlags | flag : contextFlags & ~flag;
        }
        function inContext(flags) {
          return (contextFlags & flags) !== 0;
        }
        function inTopLevelContext() {
          return !inContext(1);
        }
        function inHasLexicalThisContext() {
          return inContext(2);
        }
        function doWithContext(flags, cb, value) {
          var contextFlagsToSet = flags & ~contextFlags;
          if (contextFlagsToSet) {
            setContextFlag(contextFlagsToSet, true);
            var result2 = cb(value);
            setContextFlag(contextFlagsToSet, false);
            return result2;
          }
          return cb(value);
        }
        function visitDefault(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 256) === 0) {
            return node;
          }
          switch (node.kind) {
            case 131:
              return void 0;
            case 218:
              return visitAwaitExpression(node);
            case 169:
              return doWithContext(1 | 2, visitMethodDeclaration, node);
            case 256:
              return doWithContext(1 | 2, visitFunctionDeclaration, node);
            case 213:
              return doWithContext(1 | 2, visitFunctionExpression, node);
            case 214:
              return doWithContext(1, visitArrowFunction, node);
            case 206:
              if (capturedSuperProperties && ts3.isPropertyAccessExpression(node) && node.expression.kind === 106) {
                capturedSuperProperties.add(node.name.escapedText);
              }
              return ts3.visitEachChild(node, visitor, context);
            case 207:
              if (capturedSuperProperties && node.expression.kind === 106) {
                hasSuperElementAccess = true;
              }
              return ts3.visitEachChild(node, visitor, context);
            case 172:
            case 173:
            case 171:
            case 257:
            case 226:
              return doWithContext(1 | 2, visitDefault, node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function asyncBodyVisitor(node) {
          if (ts3.isNodeWithPossibleHoistedDeclaration(node)) {
            switch (node.kind) {
              case 237:
                return visitVariableStatementInAsyncBody(node);
              case 242:
                return visitForStatementInAsyncBody(node);
              case 243:
                return visitForInStatementInAsyncBody(node);
              case 244:
                return visitForOfStatementInAsyncBody(node);
              case 292:
                return visitCatchClauseInAsyncBody(node);
              case 235:
              case 249:
              case 263:
              case 289:
              case 290:
              case 252:
              case 240:
              case 241:
              case 239:
              case 248:
              case 250:
                return ts3.visitEachChild(node, asyncBodyVisitor, context);
              default:
                return ts3.Debug.assertNever(node, "Unhandled node.");
            }
          }
          return visitor(node);
        }
        function visitCatchClauseInAsyncBody(node) {
          var catchClauseNames = new ts3.Set();
          recordDeclarationName(node.variableDeclaration, catchClauseNames);
          var catchClauseUnshadowedNames;
          catchClauseNames.forEach(function(_, escapedName) {
            if (enclosingFunctionParameterNames.has(escapedName)) {
              if (!catchClauseUnshadowedNames) {
                catchClauseUnshadowedNames = new ts3.Set(enclosingFunctionParameterNames);
              }
              catchClauseUnshadowedNames.delete(escapedName);
            }
          });
          if (catchClauseUnshadowedNames) {
            var savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
            enclosingFunctionParameterNames = catchClauseUnshadowedNames;
            var result2 = ts3.visitEachChild(node, asyncBodyVisitor, context);
            enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
            return result2;
          } else {
            return ts3.visitEachChild(node, asyncBodyVisitor, context);
          }
        }
        function visitVariableStatementInAsyncBody(node) {
          if (isVariableDeclarationListWithCollidingName(node.declarationList)) {
            var expression = visitVariableDeclarationListWithCollidingNames(node.declarationList, false);
            return expression ? factory.createExpressionStatement(expression) : void 0;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForInStatementInAsyncBody(node) {
          return factory.updateForInStatement(node, isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(node.initializer, true) : ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, asyncBodyVisitor, context));
        }
        function visitForOfStatementInAsyncBody(node) {
          return factory.updateForOfStatement(node, ts3.visitNode(node.awaitModifier, visitor, ts3.isToken), isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(node.initializer, true) : ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, asyncBodyVisitor, context));
        }
        function visitForStatementInAsyncBody(node) {
          var initializer = node.initializer;
          return factory.updateForStatement(node, isVariableDeclarationListWithCollidingName(initializer) ? visitVariableDeclarationListWithCollidingNames(initializer, false) : ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, asyncBodyVisitor, context));
        }
        function visitAwaitExpression(node) {
          if (inTopLevelContext()) {
            return ts3.visitEachChild(node, visitor, context);
          }
          return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, ts3.visitNode(node.expression, visitor, ts3.isExpression)), node), node);
        }
        function visitMethodDeclaration(node) {
          return factory.updateMethodDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, node.name, void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function visitFunctionDeclaration(node) {
          return factory.updateFunctionDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function visitFunctionExpression(node) {
          return factory.updateFunctionExpression(node, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function visitArrowFunction(node) {
          return factory.updateArrowFunction(node, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function recordDeclarationName(_a, names) {
          var name = _a.name;
          if (ts3.isIdentifier(name)) {
            names.add(name.escapedText);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts3.isOmittedExpression(element)) {
                recordDeclarationName(element, names);
              }
            }
          }
        }
        function isVariableDeclarationListWithCollidingName(node) {
          return !!node && ts3.isVariableDeclarationList(node) && !(node.flags & 3) && node.declarations.some(collidesWithParameterName);
        }
        function visitVariableDeclarationListWithCollidingNames(node, hasReceiver) {
          hoistVariableDeclarationList(node);
          var variables = ts3.getInitializedVariables(node);
          if (variables.length === 0) {
            if (hasReceiver) {
              return ts3.visitNode(factory.converters.convertToAssignmentElementTarget(node.declarations[0].name), visitor, ts3.isExpression);
            }
            return void 0;
          }
          return factory.inlineExpressions(ts3.map(variables, transformInitializedVariable));
        }
        function hoistVariableDeclarationList(node) {
          ts3.forEach(node.declarations, hoistVariable);
        }
        function hoistVariable(_a) {
          var name = _a.name;
          if (ts3.isIdentifier(name)) {
            hoistVariableDeclaration(name);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts3.isOmittedExpression(element)) {
                hoistVariable(element);
              }
            }
          }
        }
        function transformInitializedVariable(node) {
          var converted = ts3.setSourceMapRange(factory.createAssignment(factory.converters.convertToAssignmentElementTarget(node.name), node.initializer), node);
          return ts3.visitNode(converted, visitor, ts3.isExpression);
        }
        function collidesWithParameterName(_a) {
          var name = _a.name;
          if (ts3.isIdentifier(name)) {
            return enclosingFunctionParameterNames.has(name.escapedText);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts3.isOmittedExpression(element) && collidesWithParameterName(element)) {
                return true;
              }
            }
          }
          return false;
        }
        function transformAsyncFunctionBody(node) {
          resumeLexicalEnvironment();
          var original = ts3.getOriginalNode(node, ts3.isFunctionLike);
          var nodeType = original.type;
          var promiseConstructor = languageVersion < 2 ? getPromiseConstructor(nodeType) : void 0;
          var isArrowFunction = node.kind === 214;
          var hasLexicalArguments = (resolver.getNodeCheckFlags(node) & 8192) !== 0;
          var savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
          enclosingFunctionParameterNames = new ts3.Set();
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            recordDeclarationName(parameter, enclosingFunctionParameterNames);
          }
          var savedCapturedSuperProperties = capturedSuperProperties;
          var savedHasSuperElementAccess = hasSuperElementAccess;
          if (!isArrowFunction) {
            capturedSuperProperties = new ts3.Set();
            hasSuperElementAccess = false;
          }
          var result2;
          if (!isArrowFunction) {
            var statements = [];
            var statementOffset = factory.copyPrologue(node.body.statements, statements, false, visitor);
            statements.push(factory.createReturnStatement(emitHelpers().createAwaiterHelper(inHasLexicalThisContext(), hasLexicalArguments, promiseConstructor, transformAsyncFunctionBodyWorker(node.body, statementOffset))));
            ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
            var emitSuperHelpers = languageVersion >= 2 && resolver.getNodeCheckFlags(node) & (4096 | 2048);
            if (emitSuperHelpers) {
              enableSubstitutionForAsyncMethodsWithSuper();
              if (capturedSuperProperties.size) {
                var variableStatement = createSuperAccessVariableStatement(factory, resolver, node, capturedSuperProperties);
                substitutedSuperAccessors[ts3.getNodeId(variableStatement)] = true;
                ts3.insertStatementsAfterStandardPrologue(statements, [variableStatement]);
              }
            }
            var block = factory.createBlock(statements, true);
            ts3.setTextRange(block, node.body);
            if (emitSuperHelpers && hasSuperElementAccess) {
              if (resolver.getNodeCheckFlags(node) & 4096) {
                ts3.addEmitHelper(block, ts3.advancedAsyncSuperHelper);
              } else if (resolver.getNodeCheckFlags(node) & 2048) {
                ts3.addEmitHelper(block, ts3.asyncSuperHelper);
              }
            }
            result2 = block;
          } else {
            var expression = emitHelpers().createAwaiterHelper(inHasLexicalThisContext(), hasLexicalArguments, promiseConstructor, transformAsyncFunctionBodyWorker(node.body));
            var declarations = endLexicalEnvironment();
            if (ts3.some(declarations)) {
              var block = factory.converters.convertToFunctionBlock(expression);
              result2 = factory.updateBlock(block, ts3.setTextRange(factory.createNodeArray(ts3.concatenate(declarations, block.statements)), block.statements));
            } else {
              result2 = expression;
            }
          }
          enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
          if (!isArrowFunction) {
            capturedSuperProperties = savedCapturedSuperProperties;
            hasSuperElementAccess = savedHasSuperElementAccess;
          }
          return result2;
        }
        function transformAsyncFunctionBodyWorker(body, start) {
          if (ts3.isBlock(body)) {
            return factory.updateBlock(body, ts3.visitNodes(body.statements, asyncBodyVisitor, ts3.isStatement, start));
          } else {
            return factory.converters.convertToFunctionBlock(ts3.visitNode(body, asyncBodyVisitor, ts3.isConciseBody));
          }
        }
        function getPromiseConstructor(type2) {
          var typeName = type2 && ts3.getEntityNameFromTypeNode(type2);
          if (typeName && ts3.isEntityName(typeName)) {
            var serializationKind = resolver.getTypeReferenceSerializationKind(typeName);
            if (serializationKind === ts3.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue || serializationKind === ts3.TypeReferenceSerializationKind.Unknown) {
              return typeName;
            }
          }
          return void 0;
        }
        function enableSubstitutionForAsyncMethodsWithSuper() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(208);
            context.enableSubstitution(206);
            context.enableSubstitution(207);
            context.enableEmitNotification(257);
            context.enableEmitNotification(169);
            context.enableEmitNotification(172);
            context.enableEmitNotification(173);
            context.enableEmitNotification(171);
            context.enableEmitNotification(237);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && isSuperContainer(node)) {
            var superContainerFlags = resolver.getNodeCheckFlags(node) & (2048 | 4096);
            if (superContainerFlags !== enclosingSuperContainerFlags) {
              var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
              enclosingSuperContainerFlags = superContainerFlags;
              previousOnEmitNode(hint, node, emitCallback);
              enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
              return;
            }
          } else if (enabledSubstitutions && substitutedSuperAccessors[ts3.getNodeId(node)]) {
            var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
            enclosingSuperContainerFlags = 0;
            previousOnEmitNode(hint, node, emitCallback);
            enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1 && enclosingSuperContainerFlags) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 206:
              return substitutePropertyAccessExpression(node);
            case 207:
              return substituteElementAccessExpression(node);
            case 208:
              return substituteCallExpression(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (node.expression.kind === 106) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createUniqueName("_super", 16 | 32), node.name), node);
          }
          return node;
        }
        function substituteElementAccessExpression(node) {
          if (node.expression.kind === 106) {
            return createSuperElementAccessInAsyncMethod(node.argumentExpression, node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          var expression = node.expression;
          if (ts3.isSuperProperty(expression)) {
            var argumentExpression = ts3.isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
            return factory.createCallExpression(factory.createPropertyAccessExpression(argumentExpression, "call"), void 0, __spreadArray([
              factory.createThis()
            ], node.arguments, true));
          }
          return node;
        }
        function isSuperContainer(node) {
          var kind = node.kind;
          return kind === 257 || kind === 171 || kind === 169 || kind === 172 || kind === 173;
        }
        function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
          if (enclosingSuperContainerFlags & 4096) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createCallExpression(factory.createUniqueName("_superIndex", 16 | 32), void 0, [argumentExpression]), "value"), location);
          } else {
            return ts3.setTextRange(factory.createCallExpression(factory.createUniqueName("_superIndex", 16 | 32), void 0, [argumentExpression]), location);
          }
        }
      }
      ts3.transformES2017 = transformES2017;
      function createSuperAccessVariableStatement(factory, resolver, node, names) {
        var hasBinding = (resolver.getNodeCheckFlags(node) & 4096) !== 0;
        var accessors = [];
        names.forEach(function(_, key) {
          var name = ts3.unescapeLeadingUnderscores(key);
          var getterAndSetter = [];
          getterAndSetter.push(factory.createPropertyAssignment("get", factory.createArrowFunction(void 0, void 0, [], void 0, void 0, ts3.setEmitFlags(factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createSuper(), 4), name), 4))));
          if (hasBinding) {
            getterAndSetter.push(factory.createPropertyAssignment("set", factory.createArrowFunction(void 0, void 0, [
              factory.createParameterDeclaration(void 0, void 0, void 0, "v", void 0, void 0, void 0)
            ], void 0, void 0, factory.createAssignment(ts3.setEmitFlags(factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createSuper(), 4), name), 4), factory.createIdentifier("v")))));
          }
          accessors.push(factory.createPropertyAssignment(name, factory.createObjectLiteralExpression(getterAndSetter)));
        });
        return factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
          factory.createVariableDeclaration(factory.createUniqueName("_super", 16 | 32), void 0, void 0, factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "create"), void 0, [
            factory.createNull(),
            factory.createObjectLiteralExpression(accessors, true)
          ]))
        ], 2));
      }
      ts3.createSuperAccessVariableStatement = createSuperAccessVariableStatement;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ESNextSubstitutionFlags;
      (function(ESNextSubstitutionFlags2) {
        ESNextSubstitutionFlags2[ESNextSubstitutionFlags2["AsyncMethodsWithSuper"] = 1] = "AsyncMethodsWithSuper";
      })(ESNextSubstitutionFlags || (ESNextSubstitutionFlags = {}));
      var HierarchyFacts;
      (function(HierarchyFacts2) {
        HierarchyFacts2[HierarchyFacts2["None"] = 0] = "None";
        HierarchyFacts2[HierarchyFacts2["HasLexicalThis"] = 1] = "HasLexicalThis";
        HierarchyFacts2[HierarchyFacts2["IterationContainer"] = 2] = "IterationContainer";
        HierarchyFacts2[HierarchyFacts2["AncestorFactsMask"] = 3] = "AncestorFactsMask";
        HierarchyFacts2[HierarchyFacts2["SourceFileIncludes"] = 1] = "SourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileExcludes"] = 2] = "SourceFileExcludes";
        HierarchyFacts2[HierarchyFacts2["StrictModeSourceFileIncludes"] = 0] = "StrictModeSourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["ClassOrFunctionIncludes"] = 1] = "ClassOrFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ClassOrFunctionExcludes"] = 2] = "ClassOrFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionIncludes"] = 0] = "ArrowFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionExcludes"] = 2] = "ArrowFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementIncludes"] = 2] = "IterationStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementExcludes"] = 0] = "IterationStatementExcludes";
      })(HierarchyFacts || (HierarchyFacts = {}));
      function transformES2018(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var exportedVariableStatement = false;
        var enabledSubstitutions;
        var enclosingFunctionFlags;
        var parametersWithPrecedingObjectRestOrSpread;
        var enclosingSuperContainerFlags = 0;
        var hierarchyFacts = 0;
        var currentSourceFile;
        var taggedTemplateStringDeclarations;
        var capturedSuperProperties;
        var hasSuperElementAccess;
        var substitutedSuperAccessors = [];
        return ts3.chainBundle(context, transformSourceFile);
        function affectsSubtree(excludeFacts, includeFacts) {
          return hierarchyFacts !== (hierarchyFacts & ~excludeFacts | includeFacts);
        }
        function enterSubtree(excludeFacts, includeFacts) {
          var ancestorFacts = hierarchyFacts;
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 3;
          return ancestorFacts;
        }
        function exitSubtree(ancestorFacts) {
          hierarchyFacts = ancestorFacts;
        }
        function recordTaggedTemplateString(temp) {
          taggedTemplateStringDeclarations = ts3.append(taggedTemplateStringDeclarations, factory.createVariableDeclaration(temp));
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = visitSourceFile(node);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          taggedTemplateStringDeclarations = void 0;
          return visited;
        }
        function visitor(node) {
          return visitorWorker(node, false);
        }
        function visitorWithUnusedExpressionResult(node) {
          return visitorWorker(node, true);
        }
        function visitorNoAsyncModifier(node) {
          if (node.kind === 131) {
            return void 0;
          }
          return node;
        }
        function doWithHierarchyFacts(cb, value, excludeFacts, includeFacts) {
          if (affectsSubtree(excludeFacts, includeFacts)) {
            var ancestorFacts = enterSubtree(excludeFacts, includeFacts);
            var result2 = cb(value);
            exitSubtree(ancestorFacts);
            return result2;
          }
          return cb(value);
        }
        function visitDefault(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitorWorker(node, expressionResultIsUnused) {
          if ((node.transformFlags & 128) === 0) {
            return node;
          }
          switch (node.kind) {
            case 218:
              return visitAwaitExpression(node);
            case 224:
              return visitYieldExpression(node);
            case 247:
              return visitReturnStatement(node);
            case 250:
              return visitLabeledStatement(node);
            case 205:
              return visitObjectLiteralExpression(node);
            case 221:
              return visitBinaryExpression(node, expressionResultIsUnused);
            case 351:
              return visitCommaListExpression(node, expressionResultIsUnused);
            case 292:
              return visitCatchClause(node);
            case 237:
              return visitVariableStatement(node);
            case 254:
              return visitVariableDeclaration(node);
            case 240:
            case 241:
            case 243:
              return doWithHierarchyFacts(visitDefault, node, 0, 2);
            case 244:
              return visitForOfStatement(node, void 0);
            case 242:
              return doWithHierarchyFacts(visitForStatement, node, 0, 2);
            case 217:
              return visitVoidExpression(node);
            case 171:
              return doWithHierarchyFacts(visitConstructorDeclaration, node, 2, 1);
            case 169:
              return doWithHierarchyFacts(visitMethodDeclaration, node, 2, 1);
            case 172:
              return doWithHierarchyFacts(visitGetAccessorDeclaration, node, 2, 1);
            case 173:
              return doWithHierarchyFacts(visitSetAccessorDeclaration, node, 2, 1);
            case 256:
              return doWithHierarchyFacts(visitFunctionDeclaration, node, 2, 1);
            case 213:
              return doWithHierarchyFacts(visitFunctionExpression, node, 2, 1);
            case 214:
              return doWithHierarchyFacts(visitArrowFunction, node, 2, 0);
            case 164:
              return visitParameter(node);
            case 238:
              return visitExpressionStatement(node);
            case 212:
              return visitParenthesizedExpression(node, expressionResultIsUnused);
            case 210:
              return visitTaggedTemplateExpression(node);
            case 206:
              if (capturedSuperProperties && ts3.isPropertyAccessExpression(node) && node.expression.kind === 106) {
                capturedSuperProperties.add(node.name.escapedText);
              }
              return ts3.visitEachChild(node, visitor, context);
            case 207:
              if (capturedSuperProperties && node.expression.kind === 106) {
                hasSuperElementAccess = true;
              }
              return ts3.visitEachChild(node, visitor, context);
            case 257:
            case 226:
              return doWithHierarchyFacts(visitDefault, node, 2, 1);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitAwaitExpression(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, emitHelpers().createAwaitHelper(ts3.visitNode(node.expression, visitor, ts3.isExpression))), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            if (node.asteriskToken) {
              var expression = ts3.visitNode(ts3.Debug.checkDefined(node.expression), visitor, ts3.isExpression);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, emitHelpers().createAwaitHelper(factory.updateYieldExpression(node, node.asteriskToken, ts3.setTextRange(emitHelpers().createAsyncDelegatorHelper(ts3.setTextRange(emitHelpers().createAsyncValuesHelper(expression), expression)), expression)))), node), node);
            }
            return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, createDownlevelAwait(node.expression ? ts3.visitNode(node.expression, visitor, ts3.isExpression) : factory.createVoidZero())), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitReturnStatement(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            return factory.updateReturnStatement(node, createDownlevelAwait(node.expression ? ts3.visitNode(node.expression, visitor, ts3.isExpression) : factory.createVoidZero()));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitLabeledStatement(node) {
          if (enclosingFunctionFlags & 2) {
            var statement = ts3.unwrapInnermostStatementOfLabel(node);
            if (statement.kind === 244 && statement.awaitModifier) {
              return visitForOfStatement(statement, node);
            }
            return factory.restoreEnclosingLabel(ts3.visitNode(statement, visitor, ts3.isStatement, factory.liftToBlock), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function chunkObjectLiteralElements(elements) {
          var chunkObject;
          var objects = [];
          for (var _i = 0, elements_5 = elements; _i < elements_5.length; _i++) {
            var e = elements_5[_i];
            if (e.kind === 298) {
              if (chunkObject) {
                objects.push(factory.createObjectLiteralExpression(chunkObject));
                chunkObject = void 0;
              }
              var target = e.expression;
              objects.push(ts3.visitNode(target, visitor, ts3.isExpression));
            } else {
              chunkObject = ts3.append(chunkObject, e.kind === 296 ? factory.createPropertyAssignment(e.name, ts3.visitNode(e.initializer, visitor, ts3.isExpression)) : ts3.visitNode(e, visitor, ts3.isObjectLiteralElementLike));
            }
          }
          if (chunkObject) {
            objects.push(factory.createObjectLiteralExpression(chunkObject));
          }
          return objects;
        }
        function visitObjectLiteralExpression(node) {
          if (node.transformFlags & 32768) {
            var objects = chunkObjectLiteralElements(node.properties);
            if (objects.length && objects[0].kind !== 205) {
              objects.unshift(factory.createObjectLiteralExpression());
            }
            var expression = objects[0];
            if (objects.length > 1) {
              for (var i = 1; i < objects.length; i++) {
                expression = emitHelpers().createAssignHelper([expression, objects[i]]);
              }
              return expression;
            } else {
              return emitHelpers().createAssignHelper(objects);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitExpressionStatement(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitParenthesizedExpression(node, expressionResultIsUnused) {
          return ts3.visitEachChild(node, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, context);
        }
        function visitSourceFile(node) {
          var ancestorFacts = enterSubtree(2, ts3.isEffectiveStrictModeSourceFile(node, compilerOptions) ? 0 : 1);
          exportedVariableStatement = false;
          var visited = ts3.visitEachChild(node, visitor, context);
          var statement = ts3.concatenate(visited.statements, taggedTemplateStringDeclarations && [
            factory.createVariableStatement(void 0, factory.createVariableDeclarationList(taggedTemplateStringDeclarations))
          ]);
          var result2 = factory.updateSourceFile(visited, ts3.setTextRange(factory.createNodeArray(statement), node.statements));
          exitSubtree(ancestorFacts);
          return result2;
        }
        function visitTaggedTemplateExpression(node) {
          return ts3.processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, ts3.ProcessLevel.LiftRestriction);
        }
        function visitBinaryExpression(node, expressionResultIsUnused) {
          if (ts3.isDestructuringAssignment(node) && node.left.transformFlags & 32768) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 1, !expressionResultIsUnused);
          }
          if (node.operatorToken.kind === 27) {
            return factory.updateBinaryExpression(node, ts3.visitNode(node.left, visitorWithUnusedExpressionResult, ts3.isExpression), node.operatorToken, ts3.visitNode(node.right, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCommaListExpression(node, expressionResultIsUnused) {
          if (expressionResultIsUnused) {
            return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
          }
          var result2;
          for (var i = 0; i < node.elements.length; i++) {
            var element = node.elements[i];
            var visited = ts3.visitNode(element, i < node.elements.length - 1 ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression);
            if (result2 || visited !== element) {
              result2 || (result2 = node.elements.slice(0, i));
              result2.push(visited);
            }
          }
          var elements = result2 ? ts3.setTextRange(factory.createNodeArray(result2), node.elements) : node.elements;
          return factory.updateCommaListExpression(node, elements);
        }
        function visitCatchClause(node) {
          if (node.variableDeclaration && ts3.isBindingPattern(node.variableDeclaration.name) && node.variableDeclaration.name.transformFlags & 32768) {
            var name = factory.getGeneratedNameForNode(node.variableDeclaration.name);
            var updatedDecl = factory.updateVariableDeclaration(node.variableDeclaration, node.variableDeclaration.name, void 0, void 0, name);
            var visitedBindings = ts3.flattenDestructuringBinding(updatedDecl, visitor, context, 1);
            var block = ts3.visitNode(node.block, visitor, ts3.isBlock);
            if (ts3.some(visitedBindings)) {
              block = factory.updateBlock(block, __spreadArray([
                factory.createVariableStatement(void 0, visitedBindings)
              ], block.statements, true));
            }
            return factory.updateCatchClause(node, factory.updateVariableDeclaration(node.variableDeclaration, name, void 0, void 0, void 0), block);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitVariableStatement(node) {
          if (ts3.hasSyntacticModifier(node, 1)) {
            var savedExportedVariableStatement = exportedVariableStatement;
            exportedVariableStatement = true;
            var visited = ts3.visitEachChild(node, visitor, context);
            exportedVariableStatement = savedExportedVariableStatement;
            return visited;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitVariableDeclaration(node) {
          if (exportedVariableStatement) {
            var savedExportedVariableStatement = exportedVariableStatement;
            exportedVariableStatement = false;
            var visited = visitVariableDeclarationWorker(node, true);
            exportedVariableStatement = savedExportedVariableStatement;
            return visited;
          }
          return visitVariableDeclarationWorker(node, false);
        }
        function visitVariableDeclarationWorker(node, exportedVariableStatement2) {
          if (ts3.isBindingPattern(node.name) && node.name.transformFlags & 32768) {
            return ts3.flattenDestructuringBinding(node, visitor, context, 1, void 0, exportedVariableStatement2);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          return factory.updateForStatement(node, ts3.visitNode(node.initializer, visitorWithUnusedExpressionResult, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitorWithUnusedExpressionResult, ts3.isExpression), ts3.visitIterationBody(node.statement, visitor, context));
        }
        function visitVoidExpression(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitForOfStatement(node, outermostLabeledStatement) {
          var ancestorFacts = enterSubtree(0, 2);
          if (node.initializer.transformFlags & 32768) {
            node = transformForOfStatementWithObjectRest(node);
          }
          var result2 = node.awaitModifier ? transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) : factory.restoreEnclosingLabel(ts3.visitEachChild(node, visitor, context), outermostLabeledStatement);
          exitSubtree(ancestorFacts);
          return result2;
        }
        function transformForOfStatementWithObjectRest(node) {
          var initializerWithoutParens = ts3.skipParentheses(node.initializer);
          if (ts3.isVariableDeclarationList(initializerWithoutParens) || ts3.isAssignmentPattern(initializerWithoutParens)) {
            var bodyLocation = void 0;
            var statementsLocation = void 0;
            var temp = factory.createTempVariable(void 0);
            var statements = [ts3.createForOfBindingStatement(factory, initializerWithoutParens, temp)];
            if (ts3.isBlock(node.statement)) {
              ts3.addRange(statements, node.statement.statements);
              bodyLocation = node.statement;
              statementsLocation = node.statement.statements;
            } else if (node.statement) {
              ts3.append(statements, node.statement);
              bodyLocation = node.statement;
              statementsLocation = node.statement;
            }
            return factory.updateForOfStatement(node, node.awaitModifier, ts3.setTextRange(factory.createVariableDeclarationList([
              ts3.setTextRange(factory.createVariableDeclaration(temp), node.initializer)
            ], 1), node.initializer), node.expression, ts3.setTextRange(factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), true), bodyLocation));
          }
          return node;
        }
        function convertForOfStatementHead(node, boundValue) {
          var binding = ts3.createForOfBindingStatement(factory, node.initializer, boundValue);
          var bodyLocation;
          var statementsLocation;
          var statements = [ts3.visitNode(binding, visitor, ts3.isStatement)];
          var statement = ts3.visitIterationBody(node.statement, visitor, context);
          if (ts3.isBlock(statement)) {
            ts3.addRange(statements, statement.statements);
            bodyLocation = statement;
            statementsLocation = statement.statements;
          } else {
            statements.push(statement);
          }
          return ts3.setEmitFlags(ts3.setTextRange(factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), true), bodyLocation), 48 | 384);
        }
        function createDownlevelAwait(expression) {
          return enclosingFunctionFlags & 1 ? factory.createYieldExpression(void 0, emitHelpers().createAwaitHelper(expression)) : factory.createAwaitExpression(expression);
        }
        function transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var iterator = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(expression) : factory.createTempVariable(void 0);
          var result2 = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(iterator) : factory.createTempVariable(void 0);
          var errorRecord = factory.createUniqueName("e");
          var catchVariable = factory.getGeneratedNameForNode(errorRecord);
          var returnMethod = factory.createTempVariable(void 0);
          var callValues = ts3.setTextRange(emitHelpers().createAsyncValuesHelper(expression), node.expression);
          var callNext = factory.createCallExpression(factory.createPropertyAccessExpression(iterator, "next"), void 0, []);
          var getDone = factory.createPropertyAccessExpression(result2, "done");
          var getValue = factory.createPropertyAccessExpression(result2, "value");
          var callReturn = factory.createFunctionCallCall(returnMethod, iterator, []);
          hoistVariableDeclaration(errorRecord);
          hoistVariableDeclaration(returnMethod);
          var initializer = ancestorFacts & 2 ? factory.inlineExpressions([factory.createAssignment(errorRecord, factory.createVoidZero()), callValues]) : callValues;
          var forStatement = ts3.setEmitFlags(ts3.setTextRange(factory.createForStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableDeclarationList([
            ts3.setTextRange(factory.createVariableDeclaration(iterator, void 0, void 0, initializer), node.expression),
            factory.createVariableDeclaration(result2)
          ]), node.expression), 2097152), factory.createComma(factory.createAssignment(result2, createDownlevelAwait(callNext)), factory.createLogicalNot(getDone)), void 0, convertForOfStatementHead(node, getValue)), node), 256);
          ts3.setOriginalNode(forStatement, node);
          return factory.createTryStatement(factory.createBlock([
            factory.restoreEnclosingLabel(forStatement, outermostLabeledStatement)
          ]), factory.createCatchClause(factory.createVariableDeclaration(catchVariable), ts3.setEmitFlags(factory.createBlock([
            factory.createExpressionStatement(factory.createAssignment(errorRecord, factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("error", catchVariable)
            ])))
          ]), 1)), factory.createBlock([
            factory.createTryStatement(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(factory.createLogicalAnd(factory.createLogicalAnd(result2, factory.createLogicalNot(getDone)), factory.createAssignment(returnMethod, factory.createPropertyAccessExpression(iterator, "return"))), factory.createExpressionStatement(createDownlevelAwait(callReturn))), 1)
            ]), void 0, ts3.setEmitFlags(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(errorRecord, factory.createThrowStatement(factory.createPropertyAccessExpression(errorRecord, "error"))), 1)
            ]), 1))
          ]));
        }
        function parameterVisitor(node) {
          ts3.Debug.assertNode(node, ts3.isParameter);
          return visitParameter(node);
        }
        function visitParameter(node) {
          if (parametersWithPrecedingObjectRestOrSpread === null || parametersWithPrecedingObjectRestOrSpread === void 0 ? void 0 : parametersWithPrecedingObjectRestOrSpread.has(node)) {
            return factory.updateParameterDeclaration(node, void 0, void 0, node.dotDotDotToken, ts3.isBindingPattern(node.name) ? factory.getGeneratedNameForNode(node) : node.name, void 0, void 0, void 0);
          }
          if (node.transformFlags & 32768) {
            return factory.updateParameterDeclaration(node, void 0, void 0, node.dotDotDotToken, factory.getGeneratedNameForNode(node), void 0, void 0, ts3.visitNode(node.initializer, visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function collectParametersWithPrecedingObjectRestOrSpread(node) {
          var parameters;
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            if (parameters) {
              parameters.add(parameter);
            } else if (parameter.transformFlags & 32768) {
              parameters = new ts3.Set();
            }
          }
          return parameters;
        }
        function visitConstructorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateConstructorDeclaration(node, void 0, node.modifiers, ts3.visitParameterList(node.parameters, parameterVisitor, context), transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function visitGetAccessorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateGetAccessorDeclaration(node, void 0, node.modifiers, ts3.visitNode(node.name, visitor, ts3.isPropertyName), ts3.visitParameterList(node.parameters, parameterVisitor, context), void 0, transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function visitSetAccessorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateSetAccessorDeclaration(node, void 0, node.modifiers, ts3.visitNode(node.name, visitor, ts3.isPropertyName), ts3.visitParameterList(node.parameters, parameterVisitor, context), transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function visitMethodDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateMethodDeclaration(node, void 0, enclosingFunctionFlags & 1 ? ts3.visitNodes(node.modifiers, visitorNoAsyncModifier, ts3.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, ts3.visitNode(node.name, visitor, ts3.isPropertyName), ts3.visitNode(void 0, visitor, ts3.isToken), void 0, ts3.visitParameterList(node.parameters, parameterVisitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function visitFunctionDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateFunctionDeclaration(node, void 0, enclosingFunctionFlags & 1 ? ts3.visitNodes(node.modifiers, visitorNoAsyncModifier, ts3.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, parameterVisitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function visitArrowFunction(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateArrowFunction(node, node.modifiers, void 0, ts3.visitParameterList(node.parameters, parameterVisitor, context), void 0, node.equalsGreaterThanToken, transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function visitFunctionExpression(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          var savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
          var updated = factory.updateFunctionExpression(node, enclosingFunctionFlags & 1 ? ts3.visitNodes(node.modifiers, visitorNoAsyncModifier, ts3.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, parameterVisitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
          return updated;
        }
        function transformAsyncGeneratorFunctionBody(node) {
          resumeLexicalEnvironment();
          var statements = [];
          var statementOffset = factory.copyPrologue(node.body.statements, statements, false, visitor);
          appendObjectRestAssignmentsIfNeeded(statements, node);
          var savedCapturedSuperProperties = capturedSuperProperties;
          var savedHasSuperElementAccess = hasSuperElementAccess;
          capturedSuperProperties = new ts3.Set();
          hasSuperElementAccess = false;
          var returnStatement = factory.createReturnStatement(emitHelpers().createAsyncGeneratorHelper(factory.createFunctionExpression(void 0, factory.createToken(41), node.name && factory.getGeneratedNameForNode(node.name), void 0, [], void 0, factory.updateBlock(node.body, ts3.visitLexicalEnvironment(node.body.statements, visitor, context, statementOffset))), !!(hierarchyFacts & 1)));
          var emitSuperHelpers = languageVersion >= 2 && resolver.getNodeCheckFlags(node) & (4096 | 2048);
          if (emitSuperHelpers) {
            enableSubstitutionForAsyncMethodsWithSuper();
            var variableStatement = ts3.createSuperAccessVariableStatement(factory, resolver, node, capturedSuperProperties);
            substitutedSuperAccessors[ts3.getNodeId(variableStatement)] = true;
            ts3.insertStatementsAfterStandardPrologue(statements, [variableStatement]);
          }
          statements.push(returnStatement);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var block = factory.updateBlock(node.body, statements);
          if (emitSuperHelpers && hasSuperElementAccess) {
            if (resolver.getNodeCheckFlags(node) & 4096) {
              ts3.addEmitHelper(block, ts3.advancedAsyncSuperHelper);
            } else if (resolver.getNodeCheckFlags(node) & 2048) {
              ts3.addEmitHelper(block, ts3.asyncSuperHelper);
            }
          }
          capturedSuperProperties = savedCapturedSuperProperties;
          hasSuperElementAccess = savedHasSuperElementAccess;
          return block;
        }
        function transformFunctionBody(node) {
          var _a;
          resumeLexicalEnvironment();
          var statementOffset = 0;
          var statements = [];
          var body = (_a = ts3.visitNode(node.body, visitor, ts3.isConciseBody)) !== null && _a !== void 0 ? _a : factory.createBlock([]);
          if (ts3.isBlock(body)) {
            statementOffset = factory.copyPrologue(body.statements, statements, false, visitor);
          }
          ts3.addRange(statements, appendObjectRestAssignmentsIfNeeded(void 0, node));
          var leadingStatements = endLexicalEnvironment();
          if (statementOffset > 0 || ts3.some(statements) || ts3.some(leadingStatements)) {
            var block = factory.converters.convertToFunctionBlock(body, true);
            ts3.insertStatementsAfterStandardPrologue(statements, leadingStatements);
            ts3.addRange(statements, block.statements.slice(statementOffset));
            return factory.updateBlock(block, ts3.setTextRange(factory.createNodeArray(statements), block.statements));
          }
          return body;
        }
        function appendObjectRestAssignmentsIfNeeded(statements, node) {
          var containsPrecedingObjectRestOrSpread = false;
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            if (containsPrecedingObjectRestOrSpread) {
              if (ts3.isBindingPattern(parameter.name)) {
                if (parameter.name.elements.length > 0) {
                  var declarations = ts3.flattenDestructuringBinding(parameter, visitor, context, 0, factory.getGeneratedNameForNode(parameter));
                  if (ts3.some(declarations)) {
                    var declarationList = factory.createVariableDeclarationList(declarations);
                    var statement = factory.createVariableStatement(void 0, declarationList);
                    ts3.setEmitFlags(statement, 1048576);
                    statements = ts3.append(statements, statement);
                  }
                } else if (parameter.initializer) {
                  var name = factory.getGeneratedNameForNode(parameter);
                  var initializer = ts3.visitNode(parameter.initializer, visitor, ts3.isExpression);
                  var assignment = factory.createAssignment(name, initializer);
                  var statement = factory.createExpressionStatement(assignment);
                  ts3.setEmitFlags(statement, 1048576);
                  statements = ts3.append(statements, statement);
                }
              } else if (parameter.initializer) {
                var name = factory.cloneNode(parameter.name);
                ts3.setTextRange(name, parameter.name);
                ts3.setEmitFlags(name, 48);
                var initializer = ts3.visitNode(parameter.initializer, visitor, ts3.isExpression);
                ts3.addEmitFlags(initializer, 48 | 1536);
                var assignment = factory.createAssignment(name, initializer);
                ts3.setTextRange(assignment, parameter);
                ts3.setEmitFlags(assignment, 1536);
                var block = factory.createBlock([factory.createExpressionStatement(assignment)]);
                ts3.setTextRange(block, parameter);
                ts3.setEmitFlags(block, 1 | 32 | 384 | 1536);
                var typeCheck = factory.createTypeCheck(factory.cloneNode(parameter.name), "undefined");
                var statement = factory.createIfStatement(typeCheck, block);
                ts3.startOnNewLine(statement);
                ts3.setTextRange(statement, parameter);
                ts3.setEmitFlags(statement, 384 | 32 | 1048576 | 1536);
                statements = ts3.append(statements, statement);
              }
            } else if (parameter.transformFlags & 32768) {
              containsPrecedingObjectRestOrSpread = true;
              var declarations = ts3.flattenDestructuringBinding(parameter, visitor, context, 1, factory.getGeneratedNameForNode(parameter), false, true);
              if (ts3.some(declarations)) {
                var declarationList = factory.createVariableDeclarationList(declarations);
                var statement = factory.createVariableStatement(void 0, declarationList);
                ts3.setEmitFlags(statement, 1048576);
                statements = ts3.append(statements, statement);
              }
            }
          }
          return statements;
        }
        function enableSubstitutionForAsyncMethodsWithSuper() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(208);
            context.enableSubstitution(206);
            context.enableSubstitution(207);
            context.enableEmitNotification(257);
            context.enableEmitNotification(169);
            context.enableEmitNotification(172);
            context.enableEmitNotification(173);
            context.enableEmitNotification(171);
            context.enableEmitNotification(237);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && isSuperContainer(node)) {
            var superContainerFlags = resolver.getNodeCheckFlags(node) & (2048 | 4096);
            if (superContainerFlags !== enclosingSuperContainerFlags) {
              var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
              enclosingSuperContainerFlags = superContainerFlags;
              previousOnEmitNode(hint, node, emitCallback);
              enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
              return;
            }
          } else if (enabledSubstitutions && substitutedSuperAccessors[ts3.getNodeId(node)]) {
            var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
            enclosingSuperContainerFlags = 0;
            previousOnEmitNode(hint, node, emitCallback);
            enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1 && enclosingSuperContainerFlags) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 206:
              return substitutePropertyAccessExpression(node);
            case 207:
              return substituteElementAccessExpression(node);
            case 208:
              return substituteCallExpression(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (node.expression.kind === 106) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createUniqueName("_super", 16 | 32), node.name), node);
          }
          return node;
        }
        function substituteElementAccessExpression(node) {
          if (node.expression.kind === 106) {
            return createSuperElementAccessInAsyncMethod(node.argumentExpression, node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          var expression = node.expression;
          if (ts3.isSuperProperty(expression)) {
            var argumentExpression = ts3.isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
            return factory.createCallExpression(factory.createPropertyAccessExpression(argumentExpression, "call"), void 0, __spreadArray([
              factory.createThis()
            ], node.arguments, true));
          }
          return node;
        }
        function isSuperContainer(node) {
          var kind = node.kind;
          return kind === 257 || kind === 171 || kind === 169 || kind === 172 || kind === 173;
        }
        function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
          if (enclosingSuperContainerFlags & 4096) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createCallExpression(factory.createIdentifier("_superIndex"), void 0, [argumentExpression]), "value"), location);
          } else {
            return ts3.setTextRange(factory.createCallExpression(factory.createIdentifier("_superIndex"), void 0, [argumentExpression]), location);
          }
        }
      }
      ts3.transformES2018 = transformES2018;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2019(context) {
        var factory = context.factory;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 64) === 0) {
            return node;
          }
          switch (node.kind) {
            case 292:
              return visitCatchClause(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitCatchClause(node) {
          if (!node.variableDeclaration) {
            return factory.updateCatchClause(node, factory.createVariableDeclaration(factory.createTempVariable(void 0)), ts3.visitNode(node.block, visitor, ts3.isBlock));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
      }
      ts3.transformES2019 = transformES2019;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2020(context) {
        var factory = context.factory, hoistVariableDeclaration = context.hoistVariableDeclaration;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 32) === 0) {
            return node;
          }
          switch (node.kind) {
            case 208: {
              var updated = visitNonOptionalCallExpression(node, false);
              ts3.Debug.assertNotNode(updated, ts3.isSyntheticReference);
              return updated;
            }
            case 206:
            case 207:
              if (ts3.isOptionalChain(node)) {
                var updated = visitOptionalExpression(node, false, false);
                ts3.Debug.assertNotNode(updated, ts3.isSyntheticReference);
                return updated;
              }
              return ts3.visitEachChild(node, visitor, context);
            case 221:
              if (node.operatorToken.kind === 60) {
                return transformNullishCoalescingExpression(node);
              }
              return ts3.visitEachChild(node, visitor, context);
            case 215:
              return visitDeleteExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function flattenChain(chain) {
          ts3.Debug.assertNotNode(chain, ts3.isNonNullChain);
          var links = [chain];
          while (!chain.questionDotToken && !ts3.isTaggedTemplateExpression(chain)) {
            chain = ts3.cast(ts3.skipPartiallyEmittedExpressions(chain.expression), ts3.isOptionalChain);
            ts3.Debug.assertNotNode(chain, ts3.isNonNullChain);
            links.unshift(chain);
          }
          return { expression: chain.expression, chain: links };
        }
        function visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete) {
          var expression = visitNonOptionalExpression(node.expression, captureThisArg, isDelete);
          if (ts3.isSyntheticReference(expression)) {
            return factory.createSyntheticReferenceExpression(factory.updateParenthesizedExpression(node, expression.expression), expression.thisArg);
          }
          return factory.updateParenthesizedExpression(node, expression);
        }
        function visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete) {
          if (ts3.isOptionalChain(node)) {
            return visitOptionalExpression(node, captureThisArg, isDelete);
          }
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          ts3.Debug.assertNotNode(expression, ts3.isSyntheticReference);
          var thisArg;
          if (captureThisArg) {
            if (!ts3.isSimpleCopiableExpression(expression)) {
              thisArg = factory.createTempVariable(hoistVariableDeclaration);
              expression = factory.createAssignment(thisArg, expression);
            } else {
              thisArg = expression;
            }
          }
          expression = node.kind === 206 ? factory.updatePropertyAccessExpression(node, expression, ts3.visitNode(node.name, visitor, ts3.isIdentifier)) : factory.updateElementAccessExpression(node, expression, ts3.visitNode(node.argumentExpression, visitor, ts3.isExpression));
          return thisArg ? factory.createSyntheticReferenceExpression(expression, thisArg) : expression;
        }
        function visitNonOptionalCallExpression(node, captureThisArg) {
          if (ts3.isOptionalChain(node)) {
            return visitOptionalExpression(node, captureThisArg, false);
          }
          if (ts3.isParenthesizedExpression(node.expression) && ts3.isOptionalChain(ts3.skipParentheses(node.expression))) {
            var expression = visitNonOptionalParenthesizedExpression(node.expression, true, false);
            var args = ts3.visitNodes(node.arguments, visitor, ts3.isExpression);
            if (ts3.isSyntheticReference(expression)) {
              return ts3.setTextRange(factory.createFunctionCallCall(expression.expression, expression.thisArg, args), node);
            }
            return factory.updateCallExpression(node, expression, void 0, args);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitNonOptionalExpression(node, captureThisArg, isDelete) {
          switch (node.kind) {
            case 212:
              return visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete);
            case 206:
            case 207:
              return visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete);
            case 208:
              return visitNonOptionalCallExpression(node, captureThisArg);
            default:
              return ts3.visitNode(node, visitor, ts3.isExpression);
          }
        }
        function visitOptionalExpression(node, captureThisArg, isDelete) {
          var _a = flattenChain(node), expression = _a.expression, chain = _a.chain;
          var left = visitNonOptionalExpression(ts3.skipPartiallyEmittedExpressions(expression), ts3.isCallChain(chain[0]), false);
          var leftThisArg = ts3.isSyntheticReference(left) ? left.thisArg : void 0;
          var capturedLeft = ts3.isSyntheticReference(left) ? left.expression : left;
          var leftExpression = factory.restoreOuterExpressions(expression, capturedLeft, 8);
          if (!ts3.isSimpleCopiableExpression(capturedLeft)) {
            capturedLeft = factory.createTempVariable(hoistVariableDeclaration);
            leftExpression = factory.createAssignment(capturedLeft, leftExpression);
          }
          var rightExpression = capturedLeft;
          var thisArg;
          for (var i = 0; i < chain.length; i++) {
            var segment = chain[i];
            switch (segment.kind) {
              case 206:
              case 207:
                if (i === chain.length - 1 && captureThisArg) {
                  if (!ts3.isSimpleCopiableExpression(rightExpression)) {
                    thisArg = factory.createTempVariable(hoistVariableDeclaration);
                    rightExpression = factory.createAssignment(thisArg, rightExpression);
                  } else {
                    thisArg = rightExpression;
                  }
                }
                rightExpression = segment.kind === 206 ? factory.createPropertyAccessExpression(rightExpression, ts3.visitNode(segment.name, visitor, ts3.isIdentifier)) : factory.createElementAccessExpression(rightExpression, ts3.visitNode(segment.argumentExpression, visitor, ts3.isExpression));
                break;
              case 208:
                if (i === 0 && leftThisArg) {
                  if (!ts3.isGeneratedIdentifier(leftThisArg)) {
                    leftThisArg = factory.cloneNode(leftThisArg);
                    ts3.addEmitFlags(leftThisArg, 1536);
                  }
                  rightExpression = factory.createFunctionCallCall(rightExpression, leftThisArg.kind === 106 ? factory.createThis() : leftThisArg, ts3.visitNodes(segment.arguments, visitor, ts3.isExpression));
                } else {
                  rightExpression = factory.createCallExpression(rightExpression, void 0, ts3.visitNodes(segment.arguments, visitor, ts3.isExpression));
                }
                break;
            }
            ts3.setOriginalNode(rightExpression, segment);
          }
          var target = isDelete ? factory.createConditionalExpression(createNotNullCondition(leftExpression, capturedLeft, true), void 0, factory.createTrue(), void 0, factory.createDeleteExpression(rightExpression)) : factory.createConditionalExpression(createNotNullCondition(leftExpression, capturedLeft, true), void 0, factory.createVoidZero(), void 0, rightExpression);
          ts3.setTextRange(target, node);
          return thisArg ? factory.createSyntheticReferenceExpression(target, thisArg) : target;
        }
        function createNotNullCondition(left, right, invert) {
          return factory.createBinaryExpression(factory.createBinaryExpression(left, factory.createToken(invert ? 36 : 37), factory.createNull()), factory.createToken(invert ? 56 : 55), factory.createBinaryExpression(right, factory.createToken(invert ? 36 : 37), factory.createVoidZero()));
        }
        function transformNullishCoalescingExpression(node) {
          var left = ts3.visitNode(node.left, visitor, ts3.isExpression);
          var right = left;
          if (!ts3.isSimpleCopiableExpression(left)) {
            right = factory.createTempVariable(hoistVariableDeclaration);
            left = factory.createAssignment(right, left);
          }
          return ts3.setTextRange(factory.createConditionalExpression(createNotNullCondition(left, right), void 0, right, void 0, ts3.visitNode(node.right, visitor, ts3.isExpression)), node);
        }
        function visitDeleteExpression(node) {
          return ts3.isOptionalChain(ts3.skipParentheses(node.expression)) ? ts3.setOriginalNode(visitNonOptionalExpression(node.expression, false, true), node) : factory.updateDeleteExpression(node, ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
      }
      ts3.transformES2020 = transformES2020;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2021(context) {
        var hoistVariableDeclaration = context.hoistVariableDeclaration, factory = context.factory;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 16) === 0) {
            return node;
          }
          switch (node.kind) {
            case 221:
              var binaryExpression = node;
              if (ts3.isLogicalOrCoalescingAssignmentExpression(binaryExpression)) {
                return transformLogicalAssignment(binaryExpression);
              }
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformLogicalAssignment(binaryExpression) {
          var operator = binaryExpression.operatorToken;
          var nonAssignmentOperator = ts3.getNonAssignmentOperatorForCompoundAssignment(operator.kind);
          var left = ts3.skipParentheses(ts3.visitNode(binaryExpression.left, visitor, ts3.isLeftHandSideExpression));
          var assignmentTarget = left;
          var right = ts3.skipParentheses(ts3.visitNode(binaryExpression.right, visitor, ts3.isExpression));
          if (ts3.isAccessExpression(left)) {
            var propertyAccessTargetSimpleCopiable = ts3.isSimpleCopiableExpression(left.expression);
            var propertyAccessTarget = propertyAccessTargetSimpleCopiable ? left.expression : factory.createTempVariable(hoistVariableDeclaration);
            var propertyAccessTargetAssignment = propertyAccessTargetSimpleCopiable ? left.expression : factory.createAssignment(propertyAccessTarget, left.expression);
            if (ts3.isPropertyAccessExpression(left)) {
              assignmentTarget = factory.createPropertyAccessExpression(propertyAccessTarget, left.name);
              left = factory.createPropertyAccessExpression(propertyAccessTargetAssignment, left.name);
            } else {
              var elementAccessArgumentSimpleCopiable = ts3.isSimpleCopiableExpression(left.argumentExpression);
              var elementAccessArgument = elementAccessArgumentSimpleCopiable ? left.argumentExpression : factory.createTempVariable(hoistVariableDeclaration);
              assignmentTarget = factory.createElementAccessExpression(propertyAccessTarget, elementAccessArgument);
              left = factory.createElementAccessExpression(propertyAccessTargetAssignment, elementAccessArgumentSimpleCopiable ? left.argumentExpression : factory.createAssignment(elementAccessArgument, left.argumentExpression));
            }
          }
          return factory.createBinaryExpression(left, nonAssignmentOperator, factory.createParenthesizedExpression(factory.createAssignment(assignmentTarget, right)));
        }
      }
      ts3.transformES2021 = transformES2021;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformESNext(context) {
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 4) === 0) {
            return node;
          }
          switch (node.kind) {
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
      }
      ts3.transformESNext = transformESNext;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformJsx(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory;
        var compilerOptions = context.getCompilerOptions();
        var currentSourceFile;
        var currentFileState;
        return ts3.chainBundle(context, transformSourceFile);
        function getCurrentFileNameExpression() {
          if (currentFileState.filenameDeclaration) {
            return currentFileState.filenameDeclaration.name;
          }
          var declaration = factory.createVariableDeclaration(factory.createUniqueName("_jsxFileName", 16 | 32), void 0, void 0, factory.createStringLiteral(currentSourceFile.fileName));
          currentFileState.filenameDeclaration = declaration;
          return currentFileState.filenameDeclaration.name;
        }
        function getJsxFactoryCalleePrimitive(isStaticChildren) {
          return compilerOptions.jsx === 5 ? "jsxDEV" : isStaticChildren ? "jsxs" : "jsx";
        }
        function getJsxFactoryCallee(isStaticChildren) {
          var type2 = getJsxFactoryCalleePrimitive(isStaticChildren);
          return getImplicitImportForName(type2);
        }
        function getImplicitJsxFragmentReference() {
          return getImplicitImportForName("Fragment");
        }
        function getImplicitImportForName(name) {
          var _a, _b;
          var importSource = name === "createElement" ? currentFileState.importSpecifier : ts3.getJSXRuntimeImport(currentFileState.importSpecifier, compilerOptions);
          var existing = (_b = (_a = currentFileState.utilizedImplicitRuntimeImports) === null || _a === void 0 ? void 0 : _a.get(importSource)) === null || _b === void 0 ? void 0 : _b.get(name);
          if (existing) {
            return existing.name;
          }
          if (!currentFileState.utilizedImplicitRuntimeImports) {
            currentFileState.utilizedImplicitRuntimeImports = new ts3.Map();
          }
          var specifierSourceImports = currentFileState.utilizedImplicitRuntimeImports.get(importSource);
          if (!specifierSourceImports) {
            specifierSourceImports = new ts3.Map();
            currentFileState.utilizedImplicitRuntimeImports.set(importSource, specifierSourceImports);
          }
          var generatedName = factory.createUniqueName("_".concat(name), 16 | 32 | 64);
          var specifier = factory.createImportSpecifier(false, factory.createIdentifier(name), generatedName);
          generatedName.generatedImportReference = specifier;
          specifierSourceImports.set(name, specifier);
          return generatedName;
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          currentFileState = {};
          currentFileState.importSpecifier = ts3.getJSXImplicitImportBase(compilerOptions, node);
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          var statements = visited.statements;
          if (currentFileState.filenameDeclaration) {
            statements = ts3.insertStatementAfterCustomPrologue(statements.slice(), factory.createVariableStatement(void 0, factory.createVariableDeclarationList([currentFileState.filenameDeclaration], 2)));
          }
          if (currentFileState.utilizedImplicitRuntimeImports) {
            for (var _i = 0, _a = ts3.arrayFrom(currentFileState.utilizedImplicitRuntimeImports.entries()); _i < _a.length; _i++) {
              var _b = _a[_i], importSource = _b[0], importSpecifiersMap = _b[1];
              if (ts3.isExternalModule(node)) {
                var importStatement = factory.createImportDeclaration(void 0, void 0, factory.createImportClause(false, void 0, factory.createNamedImports(ts3.arrayFrom(importSpecifiersMap.values()))), factory.createStringLiteral(importSource), void 0);
                ts3.setParentRecursive(importStatement, false);
                statements = ts3.insertStatementAfterCustomPrologue(statements.slice(), importStatement);
              } else if (ts3.isExternalOrCommonJsModule(node)) {
                var requireStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
                  factory.createVariableDeclaration(factory.createObjectBindingPattern(ts3.map(ts3.arrayFrom(importSpecifiersMap.values()), function(s) {
                    return factory.createBindingElement(void 0, s.propertyName, s.name);
                  })), void 0, void 0, factory.createCallExpression(factory.createIdentifier("require"), void 0, [factory.createStringLiteral(importSource)]))
                ], 2));
                ts3.setParentRecursive(requireStatement, false);
                statements = ts3.insertStatementAfterCustomPrologue(statements.slice(), requireStatement);
              } else {
              }
            }
          }
          if (statements !== visited.statements) {
            visited = factory.updateSourceFile(visited, statements);
          }
          currentFileState = void 0;
          return visited;
        }
        function visitor(node) {
          if (node.transformFlags & 2) {
            return visitorWorker(node);
          } else {
            return node;
          }
        }
        function visitorWorker(node) {
          switch (node.kind) {
            case 278:
              return visitJsxElement(node, false);
            case 279:
              return visitJsxSelfClosingElement(node, false);
            case 282:
              return visitJsxFragment(node, false);
            case 288:
              return visitJsxExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformJsxChildToExpression(node) {
          switch (node.kind) {
            case 11:
              return visitJsxText(node);
            case 288:
              return visitJsxExpression(node);
            case 278:
              return visitJsxElement(node, true);
            case 279:
              return visitJsxSelfClosingElement(node, true);
            case 282:
              return visitJsxFragment(node, true);
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function hasKeyAfterPropsSpread(node) {
          var spread = false;
          for (var _i = 0, _a = node.attributes.properties; _i < _a.length; _i++) {
            var elem = _a[_i];
            if (ts3.isJsxSpreadAttribute(elem)) {
              spread = true;
            } else if (spread && ts3.isJsxAttribute(elem) && elem.name.escapedText === "key") {
              return true;
            }
          }
          return false;
        }
        function shouldUseCreateElement(node) {
          return currentFileState.importSpecifier === void 0 || hasKeyAfterPropsSpread(node);
        }
        function visitJsxElement(node, isChild) {
          var tagTransform = shouldUseCreateElement(node.openingElement) ? visitJsxOpeningLikeElementCreateElement : visitJsxOpeningLikeElementJSX;
          return tagTransform(node.openingElement, node.children, isChild, node);
        }
        function visitJsxSelfClosingElement(node, isChild) {
          var tagTransform = shouldUseCreateElement(node) ? visitJsxOpeningLikeElementCreateElement : visitJsxOpeningLikeElementJSX;
          return tagTransform(node, void 0, isChild, node);
        }
        function visitJsxFragment(node, isChild) {
          var tagTransform = currentFileState.importSpecifier === void 0 ? visitJsxOpeningFragmentCreateElement : visitJsxOpeningFragmentJSX;
          return tagTransform(node.openingFragment, node.children, isChild, node);
        }
        function convertJsxChildrenToChildrenPropObject(children) {
          var prop = convertJsxChildrenToChildrenPropAssignment(children);
          return prop && factory.createObjectLiteralExpression([prop]);
        }
        function convertJsxChildrenToChildrenPropAssignment(children) {
          var nonWhitespaceChildren = ts3.getSemanticJsxChildren(children);
          if (ts3.length(nonWhitespaceChildren) === 1 && !nonWhitespaceChildren[0].dotDotDotToken) {
            var result_13 = transformJsxChildToExpression(nonWhitespaceChildren[0]);
            return result_13 && factory.createPropertyAssignment("children", result_13);
          }
          var result2 = ts3.mapDefined(children, transformJsxChildToExpression);
          return ts3.length(result2) ? factory.createPropertyAssignment("children", factory.createArrayLiteralExpression(result2)) : void 0;
        }
        function visitJsxOpeningLikeElementJSX(node, children, isChild, location) {
          var tagName = getTagName(node);
          var childrenProp = children && children.length ? convertJsxChildrenToChildrenPropAssignment(children) : void 0;
          var keyAttr = ts3.find(node.attributes.properties, function(p) {
            return !!p.name && ts3.isIdentifier(p.name) && p.name.escapedText === "key";
          });
          var attrs = keyAttr ? ts3.filter(node.attributes.properties, function(p) {
            return p !== keyAttr;
          }) : node.attributes.properties;
          var objectProperties = ts3.length(attrs) ? transformJsxAttributesToObjectProps(attrs, childrenProp) : factory.createObjectLiteralExpression(childrenProp ? [childrenProp] : ts3.emptyArray);
          return visitJsxOpeningLikeElementOrFragmentJSX(tagName, objectProperties, keyAttr, children || ts3.emptyArray, isChild, location);
        }
        function visitJsxOpeningLikeElementOrFragmentJSX(tagName, objectProperties, keyAttr, children, isChild, location) {
          var _a;
          var nonWhitespaceChildren = ts3.getSemanticJsxChildren(children);
          var isStaticChildren = ts3.length(nonWhitespaceChildren) > 1 || !!((_a = nonWhitespaceChildren[0]) === null || _a === void 0 ? void 0 : _a.dotDotDotToken);
          var args = [tagName, objectProperties];
          if (keyAttr) {
            args.push(transformJsxAttributeInitializer(keyAttr.initializer));
          }
          if (compilerOptions.jsx === 5) {
            var originalFile = ts3.getOriginalNode(currentSourceFile);
            if (originalFile && ts3.isSourceFile(originalFile)) {
              if (keyAttr === void 0) {
                args.push(factory.createVoidZero());
              }
              args.push(isStaticChildren ? factory.createTrue() : factory.createFalse());
              var lineCol = ts3.getLineAndCharacterOfPosition(originalFile, location.pos);
              args.push(factory.createObjectLiteralExpression([
                factory.createPropertyAssignment("fileName", getCurrentFileNameExpression()),
                factory.createPropertyAssignment("lineNumber", factory.createNumericLiteral(lineCol.line + 1)),
                factory.createPropertyAssignment("columnNumber", factory.createNumericLiteral(lineCol.character + 1))
              ]));
              args.push(factory.createThis());
            }
          }
          var element = ts3.setTextRange(factory.createCallExpression(getJsxFactoryCallee(isStaticChildren), void 0, args), location);
          if (isChild) {
            ts3.startOnNewLine(element);
          }
          return element;
        }
        function visitJsxOpeningLikeElementCreateElement(node, children, isChild, location) {
          var tagName = getTagName(node);
          var attrs = node.attributes.properties;
          var objectProperties = ts3.length(attrs) ? transformJsxAttributesToObjectProps(attrs) : factory.createNull();
          var callee = currentFileState.importSpecifier === void 0 ? ts3.createJsxFactoryExpression(factory, context.getEmitResolver().getJsxFactoryEntity(currentSourceFile), compilerOptions.reactNamespace, node) : getImplicitImportForName("createElement");
          var element = ts3.createExpressionForJsxElement(factory, callee, tagName, objectProperties, ts3.mapDefined(children, transformJsxChildToExpression), location);
          if (isChild) {
            ts3.startOnNewLine(element);
          }
          return element;
        }
        function visitJsxOpeningFragmentJSX(_node, children, isChild, location) {
          var childrenProps;
          if (children && children.length) {
            var result2 = convertJsxChildrenToChildrenPropObject(children);
            if (result2) {
              childrenProps = result2;
            }
          }
          return visitJsxOpeningLikeElementOrFragmentJSX(getImplicitJsxFragmentReference(), childrenProps || factory.createObjectLiteralExpression([]), void 0, children, isChild, location);
        }
        function visitJsxOpeningFragmentCreateElement(node, children, isChild, location) {
          var element = ts3.createExpressionForJsxFragment(factory, context.getEmitResolver().getJsxFactoryEntity(currentSourceFile), context.getEmitResolver().getJsxFragmentFactoryEntity(currentSourceFile), compilerOptions.reactNamespace, ts3.mapDefined(children, transformJsxChildToExpression), node, location);
          if (isChild) {
            ts3.startOnNewLine(element);
          }
          return element;
        }
        function transformJsxSpreadAttributeToSpreadAssignment(node) {
          return factory.createSpreadAssignment(ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
        function transformJsxAttributesToObjectProps(attrs, children) {
          var target = ts3.getEmitScriptTarget(compilerOptions);
          return target && target >= 5 ? factory.createObjectLiteralExpression(transformJsxAttributesToProps(attrs, children)) : transformJsxAttributesToExpression(attrs, children);
        }
        function transformJsxAttributesToProps(attrs, children) {
          var props = ts3.flatten(ts3.spanMap(attrs, ts3.isJsxSpreadAttribute, function(attrs2, isSpread) {
            return ts3.map(attrs2, function(attr) {
              return isSpread ? transformJsxSpreadAttributeToSpreadAssignment(attr) : transformJsxAttributeToObjectLiteralElement(attr);
            });
          }));
          if (children) {
            props.push(children);
          }
          return props;
        }
        function transformJsxAttributesToExpression(attrs, children) {
          var expressions = ts3.flatten(ts3.spanMap(attrs, ts3.isJsxSpreadAttribute, function(attrs2, isSpread) {
            return isSpread ? ts3.map(attrs2, transformJsxSpreadAttributeToExpression) : factory.createObjectLiteralExpression(ts3.map(attrs2, transformJsxAttributeToObjectLiteralElement));
          }));
          if (ts3.isJsxSpreadAttribute(attrs[0])) {
            expressions.unshift(factory.createObjectLiteralExpression());
          }
          if (children) {
            expressions.push(factory.createObjectLiteralExpression([children]));
          }
          return ts3.singleOrUndefined(expressions) || emitHelpers().createAssignHelper(expressions);
        }
        function transformJsxSpreadAttributeToExpression(node) {
          return ts3.visitNode(node.expression, visitor, ts3.isExpression);
        }
        function transformJsxAttributeToObjectLiteralElement(node) {
          var name = getAttributeName(node);
          var expression = transformJsxAttributeInitializer(node.initializer);
          return factory.createPropertyAssignment(name, expression);
        }
        function transformJsxAttributeInitializer(node) {
          if (node === void 0) {
            return factory.createTrue();
          } else if (node.kind === 10) {
            var singleQuote = node.singleQuote !== void 0 ? node.singleQuote : !ts3.isStringDoubleQuoted(node, currentSourceFile);
            var literal = factory.createStringLiteral(tryDecodeEntities(node.text) || node.text, singleQuote);
            return ts3.setTextRange(literal, node);
          } else if (node.kind === 288) {
            if (node.expression === void 0) {
              return factory.createTrue();
            }
            return ts3.visitNode(node.expression, visitor, ts3.isExpression);
          } else {
            return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function visitJsxText(node) {
          var fixed = fixupWhitespaceAndDecodeEntities(node.text);
          return fixed === void 0 ? void 0 : factory.createStringLiteral(fixed);
        }
        function fixupWhitespaceAndDecodeEntities(text) {
          var acc;
          var firstNonWhitespace = 0;
          var lastNonWhitespace = -1;
          for (var i = 0; i < text.length; i++) {
            var c = text.charCodeAt(i);
            if (ts3.isLineBreak(c)) {
              if (firstNonWhitespace !== -1 && lastNonWhitespace !== -1) {
                acc = addLineOfJsxText(acc, text.substr(firstNonWhitespace, lastNonWhitespace - firstNonWhitespace + 1));
              }
              firstNonWhitespace = -1;
            } else if (!ts3.isWhiteSpaceSingleLine(c)) {
              lastNonWhitespace = i;
              if (firstNonWhitespace === -1) {
                firstNonWhitespace = i;
              }
            }
          }
          return firstNonWhitespace !== -1 ? addLineOfJsxText(acc, text.substr(firstNonWhitespace)) : acc;
        }
        function addLineOfJsxText(acc, trimmedLine) {
          var decoded = decodeEntities(trimmedLine);
          return acc === void 0 ? decoded : acc + " " + decoded;
        }
        function decodeEntities(text) {
          return text.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g, function(match, _all, _number, _digits, decimal, hex, word) {
            if (decimal) {
              return ts3.utf16EncodeAsString(parseInt(decimal, 10));
            } else if (hex) {
              return ts3.utf16EncodeAsString(parseInt(hex, 16));
            } else {
              var ch = entities.get(word);
              return ch ? ts3.utf16EncodeAsString(ch) : match;
            }
          });
        }
        function tryDecodeEntities(text) {
          var decoded = decodeEntities(text);
          return decoded === text ? void 0 : decoded;
        }
        function getTagName(node) {
          if (node.kind === 278) {
            return getTagName(node.openingElement);
          } else {
            var name = node.tagName;
            if (ts3.isIdentifier(name) && ts3.isIntrinsicJsxName(name.escapedText)) {
              return factory.createStringLiteral(ts3.idText(name));
            } else {
              return ts3.createExpressionFromEntityName(factory, name);
            }
          }
        }
        function getAttributeName(node) {
          var name = node.name;
          var text = ts3.idText(name);
          if (/^[A-Za-z_]\w*$/.test(text)) {
            return name;
          } else {
            return factory.createStringLiteral(text);
          }
        }
        function visitJsxExpression(node) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          return node.dotDotDotToken ? factory.createSpreadElement(expression) : expression;
        }
      }
      ts3.transformJsx = transformJsx;
      var entities = new ts3.Map(ts3.getEntries({
        quot: 34,
        amp: 38,
        apos: 39,
        lt: 60,
        gt: 62,
        nbsp: 160,
        iexcl: 161,
        cent: 162,
        pound: 163,
        curren: 164,
        yen: 165,
        brvbar: 166,
        sect: 167,
        uml: 168,
        copy: 169,
        ordf: 170,
        laquo: 171,
        not: 172,
        shy: 173,
        reg: 174,
        macr: 175,
        deg: 176,
        plusmn: 177,
        sup2: 178,
        sup3: 179,
        acute: 180,
        micro: 181,
        para: 182,
        middot: 183,
        cedil: 184,
        sup1: 185,
        ordm: 186,
        raquo: 187,
        frac14: 188,
        frac12: 189,
        frac34: 190,
        iquest: 191,
        Agrave: 192,
        Aacute: 193,
        Acirc: 194,
        Atilde: 195,
        Auml: 196,
        Aring: 197,
        AElig: 198,
        Ccedil: 199,
        Egrave: 200,
        Eacute: 201,
        Ecirc: 202,
        Euml: 203,
        Igrave: 204,
        Iacute: 205,
        Icirc: 206,
        Iuml: 207,
        ETH: 208,
        Ntilde: 209,
        Ograve: 210,
        Oacute: 211,
        Ocirc: 212,
        Otilde: 213,
        Ouml: 214,
        times: 215,
        Oslash: 216,
        Ugrave: 217,
        Uacute: 218,
        Ucirc: 219,
        Uuml: 220,
        Yacute: 221,
        THORN: 222,
        szlig: 223,
        agrave: 224,
        aacute: 225,
        acirc: 226,
        atilde: 227,
        auml: 228,
        aring: 229,
        aelig: 230,
        ccedil: 231,
        egrave: 232,
        eacute: 233,
        ecirc: 234,
        euml: 235,
        igrave: 236,
        iacute: 237,
        icirc: 238,
        iuml: 239,
        eth: 240,
        ntilde: 241,
        ograve: 242,
        oacute: 243,
        ocirc: 244,
        otilde: 245,
        ouml: 246,
        divide: 247,
        oslash: 248,
        ugrave: 249,
        uacute: 250,
        ucirc: 251,
        uuml: 252,
        yacute: 253,
        thorn: 254,
        yuml: 255,
        OElig: 338,
        oelig: 339,
        Scaron: 352,
        scaron: 353,
        Yuml: 376,
        fnof: 402,
        circ: 710,
        tilde: 732,
        Alpha: 913,
        Beta: 914,
        Gamma: 915,
        Delta: 916,
        Epsilon: 917,
        Zeta: 918,
        Eta: 919,
        Theta: 920,
        Iota: 921,
        Kappa: 922,
        Lambda: 923,
        Mu: 924,
        Nu: 925,
        Xi: 926,
        Omicron: 927,
        Pi: 928,
        Rho: 929,
        Sigma: 931,
        Tau: 932,
        Upsilon: 933,
        Phi: 934,
        Chi: 935,
        Psi: 936,
        Omega: 937,
        alpha: 945,
        beta: 946,
        gamma: 947,
        delta: 948,
        epsilon: 949,
        zeta: 950,
        eta: 951,
        theta: 952,
        iota: 953,
        kappa: 954,
        lambda: 955,
        mu: 956,
        nu: 957,
        xi: 958,
        omicron: 959,
        pi: 960,
        rho: 961,
        sigmaf: 962,
        sigma: 963,
        tau: 964,
        upsilon: 965,
        phi: 966,
        chi: 967,
        psi: 968,
        omega: 969,
        thetasym: 977,
        upsih: 978,
        piv: 982,
        ensp: 8194,
        emsp: 8195,
        thinsp: 8201,
        zwnj: 8204,
        zwj: 8205,
        lrm: 8206,
        rlm: 8207,
        ndash: 8211,
        mdash: 8212,
        lsquo: 8216,
        rsquo: 8217,
        sbquo: 8218,
        ldquo: 8220,
        rdquo: 8221,
        bdquo: 8222,
        dagger: 8224,
        Dagger: 8225,
        bull: 8226,
        hellip: 8230,
        permil: 8240,
        prime: 8242,
        Prime: 8243,
        lsaquo: 8249,
        rsaquo: 8250,
        oline: 8254,
        frasl: 8260,
        euro: 8364,
        image: 8465,
        weierp: 8472,
        real: 8476,
        trade: 8482,
        alefsym: 8501,
        larr: 8592,
        uarr: 8593,
        rarr: 8594,
        darr: 8595,
        harr: 8596,
        crarr: 8629,
        lArr: 8656,
        uArr: 8657,
        rArr: 8658,
        dArr: 8659,
        hArr: 8660,
        forall: 8704,
        part: 8706,
        exist: 8707,
        empty: 8709,
        nabla: 8711,
        isin: 8712,
        notin: 8713,
        ni: 8715,
        prod: 8719,
        sum: 8721,
        minus: 8722,
        lowast: 8727,
        radic: 8730,
        prop: 8733,
        infin: 8734,
        ang: 8736,
        and: 8743,
        or: 8744,
        cap: 8745,
        cup: 8746,
        int: 8747,
        there4: 8756,
        sim: 8764,
        cong: 8773,
        asymp: 8776,
        ne: 8800,
        equiv: 8801,
        le: 8804,
        ge: 8805,
        sub: 8834,
        sup: 8835,
        nsub: 8836,
        sube: 8838,
        supe: 8839,
        oplus: 8853,
        otimes: 8855,
        perp: 8869,
        sdot: 8901,
        lceil: 8968,
        rceil: 8969,
        lfloor: 8970,
        rfloor: 8971,
        lang: 9001,
        rang: 9002,
        loz: 9674,
        spades: 9824,
        clubs: 9827,
        hearts: 9829,
        diams: 9830
      }));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2016(context) {
        var factory = context.factory, hoistVariableDeclaration = context.hoistVariableDeclaration;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 512) === 0) {
            return node;
          }
          switch (node.kind) {
            case 221:
              return visitBinaryExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitBinaryExpression(node) {
          switch (node.operatorToken.kind) {
            case 67:
              return visitExponentiationAssignmentExpression(node);
            case 42:
              return visitExponentiationExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitExponentiationAssignmentExpression(node) {
          var target;
          var value;
          var left = ts3.visitNode(node.left, visitor, ts3.isExpression);
          var right = ts3.visitNode(node.right, visitor, ts3.isExpression);
          if (ts3.isElementAccessExpression(left)) {
            var expressionTemp = factory.createTempVariable(hoistVariableDeclaration);
            var argumentExpressionTemp = factory.createTempVariable(hoistVariableDeclaration);
            target = ts3.setTextRange(factory.createElementAccessExpression(ts3.setTextRange(factory.createAssignment(expressionTemp, left.expression), left.expression), ts3.setTextRange(factory.createAssignment(argumentExpressionTemp, left.argumentExpression), left.argumentExpression)), left);
            value = ts3.setTextRange(factory.createElementAccessExpression(expressionTemp, argumentExpressionTemp), left);
          } else if (ts3.isPropertyAccessExpression(left)) {
            var expressionTemp = factory.createTempVariable(hoistVariableDeclaration);
            target = ts3.setTextRange(factory.createPropertyAccessExpression(ts3.setTextRange(factory.createAssignment(expressionTemp, left.expression), left.expression), left.name), left);
            value = ts3.setTextRange(factory.createPropertyAccessExpression(expressionTemp, left.name), left);
          } else {
            target = left;
            value = left;
          }
          return ts3.setTextRange(factory.createAssignment(target, ts3.setTextRange(factory.createGlobalMethodCall("Math", "pow", [value, right]), node)), node);
        }
        function visitExponentiationExpression(node) {
          var left = ts3.visitNode(node.left, visitor, ts3.isExpression);
          var right = ts3.visitNode(node.right, visitor, ts3.isExpression);
          return ts3.setTextRange(factory.createGlobalMethodCall("Math", "pow", [left, right]), node);
        }
      }
      ts3.transformES2016 = transformES2016;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ES2015SubstitutionFlags;
      (function(ES2015SubstitutionFlags2) {
        ES2015SubstitutionFlags2[ES2015SubstitutionFlags2["CapturedThis"] = 1] = "CapturedThis";
        ES2015SubstitutionFlags2[ES2015SubstitutionFlags2["BlockScopedBindings"] = 2] = "BlockScopedBindings";
      })(ES2015SubstitutionFlags || (ES2015SubstitutionFlags = {}));
      var LoopOutParameterFlags;
      (function(LoopOutParameterFlags2) {
        LoopOutParameterFlags2[LoopOutParameterFlags2["Body"] = 1] = "Body";
        LoopOutParameterFlags2[LoopOutParameterFlags2["Initializer"] = 2] = "Initializer";
      })(LoopOutParameterFlags || (LoopOutParameterFlags = {}));
      var CopyDirection;
      (function(CopyDirection2) {
        CopyDirection2[CopyDirection2["ToOriginal"] = 0] = "ToOriginal";
        CopyDirection2[CopyDirection2["ToOutParameter"] = 1] = "ToOutParameter";
      })(CopyDirection || (CopyDirection = {}));
      var Jump;
      (function(Jump2) {
        Jump2[Jump2["Break"] = 2] = "Break";
        Jump2[Jump2["Continue"] = 4] = "Continue";
        Jump2[Jump2["Return"] = 8] = "Return";
      })(Jump || (Jump = {}));
      var HierarchyFacts;
      (function(HierarchyFacts2) {
        HierarchyFacts2[HierarchyFacts2["None"] = 0] = "None";
        HierarchyFacts2[HierarchyFacts2["Function"] = 1] = "Function";
        HierarchyFacts2[HierarchyFacts2["ArrowFunction"] = 2] = "ArrowFunction";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBody"] = 4] = "AsyncFunctionBody";
        HierarchyFacts2[HierarchyFacts2["NonStaticClassElement"] = 8] = "NonStaticClassElement";
        HierarchyFacts2[HierarchyFacts2["CapturesThis"] = 16] = "CapturesThis";
        HierarchyFacts2[HierarchyFacts2["ExportedVariableStatement"] = 32] = "ExportedVariableStatement";
        HierarchyFacts2[HierarchyFacts2["TopLevel"] = 64] = "TopLevel";
        HierarchyFacts2[HierarchyFacts2["Block"] = 128] = "Block";
        HierarchyFacts2[HierarchyFacts2["IterationStatement"] = 256] = "IterationStatement";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlock"] = 512] = "IterationStatementBlock";
        HierarchyFacts2[HierarchyFacts2["IterationContainer"] = 1024] = "IterationContainer";
        HierarchyFacts2[HierarchyFacts2["ForStatement"] = 2048] = "ForStatement";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatement"] = 4096] = "ForInOrForOfStatement";
        HierarchyFacts2[HierarchyFacts2["ConstructorWithCapturedSuper"] = 8192] = "ConstructorWithCapturedSuper";
        HierarchyFacts2[HierarchyFacts2["StaticInitializer"] = 16384] = "StaticInitializer";
        HierarchyFacts2[HierarchyFacts2["AncestorFactsMask"] = 32767] = "AncestorFactsMask";
        HierarchyFacts2[HierarchyFacts2["BlockScopeIncludes"] = 0] = "BlockScopeIncludes";
        HierarchyFacts2[HierarchyFacts2["BlockScopeExcludes"] = 7104] = "BlockScopeExcludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileIncludes"] = 64] = "SourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileExcludes"] = 8064] = "SourceFileExcludes";
        HierarchyFacts2[HierarchyFacts2["FunctionIncludes"] = 65] = "FunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["FunctionExcludes"] = 32670] = "FunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBodyIncludes"] = 69] = "AsyncFunctionBodyIncludes";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBodyExcludes"] = 32662] = "AsyncFunctionBodyExcludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionIncludes"] = 66] = "ArrowFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionExcludes"] = 15232] = "ArrowFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["ConstructorIncludes"] = 73] = "ConstructorIncludes";
        HierarchyFacts2[HierarchyFacts2["ConstructorExcludes"] = 32662] = "ConstructorExcludes";
        HierarchyFacts2[HierarchyFacts2["DoOrWhileStatementIncludes"] = 1280] = "DoOrWhileStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["DoOrWhileStatementExcludes"] = 0] = "DoOrWhileStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["ForStatementIncludes"] = 3328] = "ForStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["ForStatementExcludes"] = 5056] = "ForStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatementIncludes"] = 5376] = "ForInOrForOfStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatementExcludes"] = 3008] = "ForInOrForOfStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["BlockIncludes"] = 128] = "BlockIncludes";
        HierarchyFacts2[HierarchyFacts2["BlockExcludes"] = 6976] = "BlockExcludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlockIncludes"] = 512] = "IterationStatementBlockIncludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlockExcludes"] = 7104] = "IterationStatementBlockExcludes";
        HierarchyFacts2[HierarchyFacts2["StaticInitializerIncludes"] = 16449] = "StaticInitializerIncludes";
        HierarchyFacts2[HierarchyFacts2["StaticInitializerExcludes"] = 32670] = "StaticInitializerExcludes";
        HierarchyFacts2[HierarchyFacts2["NewTarget"] = 32768] = "NewTarget";
        HierarchyFacts2[HierarchyFacts2["CapturedLexicalThis"] = 65536] = "CapturedLexicalThis";
        HierarchyFacts2[HierarchyFacts2["SubtreeFactsMask"] = -32768] = "SubtreeFactsMask";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionSubtreeExcludes"] = 0] = "ArrowFunctionSubtreeExcludes";
        HierarchyFacts2[HierarchyFacts2["FunctionSubtreeExcludes"] = 98304] = "FunctionSubtreeExcludes";
      })(HierarchyFacts || (HierarchyFacts = {}));
      var SpreadSegmentKind;
      (function(SpreadSegmentKind2) {
        SpreadSegmentKind2[SpreadSegmentKind2["None"] = 0] = "None";
        SpreadSegmentKind2[SpreadSegmentKind2["UnpackedSpread"] = 1] = "UnpackedSpread";
        SpreadSegmentKind2[SpreadSegmentKind2["PackedSpread"] = 2] = "PackedSpread";
      })(SpreadSegmentKind || (SpreadSegmentKind = {}));
      function createSpreadSegment(kind, expression) {
        return { kind, expression };
      }
      function transformES2015(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        var currentSourceFile;
        var currentText;
        var hierarchyFacts;
        var taggedTemplateStringDeclarations;
        function recordTaggedTemplateString(temp) {
          taggedTemplateStringDeclarations = ts3.append(taggedTemplateStringDeclarations, factory.createVariableDeclaration(temp));
        }
        var convertedLoopState;
        var enabledSubstitutions;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          currentText = node.text;
          var visited = visitSourceFile(node);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          currentText = void 0;
          taggedTemplateStringDeclarations = void 0;
          hierarchyFacts = 0;
          return visited;
        }
        function enterSubtree(excludeFacts, includeFacts) {
          var ancestorFacts = hierarchyFacts;
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 32767;
          return ancestorFacts;
        }
        function exitSubtree(ancestorFacts, excludeFacts, includeFacts) {
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & -32768 | ancestorFacts;
        }
        function isReturnVoidStatementInConstructorWithCapturedSuper(node) {
          return (hierarchyFacts & 8192) !== 0 && node.kind === 247 && !node.expression;
        }
        function isOrMayContainReturnCompletion(node) {
          return node.transformFlags & 2097152 && (ts3.isReturnStatement(node) || ts3.isIfStatement(node) || ts3.isWithStatement(node) || ts3.isSwitchStatement(node) || ts3.isCaseBlock(node) || ts3.isCaseClause(node) || ts3.isDefaultClause(node) || ts3.isTryStatement(node) || ts3.isCatchClause(node) || ts3.isLabeledStatement(node) || ts3.isIterationStatement(node, false) || ts3.isBlock(node));
        }
        function shouldVisitNode(node) {
          return (node.transformFlags & 1024) !== 0 || convertedLoopState !== void 0 || hierarchyFacts & 8192 && isOrMayContainReturnCompletion(node) || ts3.isIterationStatement(node, false) && shouldConvertIterationStatement(node) || (ts3.getEmitFlags(node) & 33554432) !== 0;
        }
        function visitor(node) {
          return shouldVisitNode(node) ? visitorWorker(node, false) : node;
        }
        function visitorWithUnusedExpressionResult(node) {
          return shouldVisitNode(node) ? visitorWorker(node, true) : node;
        }
        function classWrapperStatementVisitor(node) {
          if (shouldVisitNode(node)) {
            var original = ts3.getOriginalNode(node);
            if (ts3.isPropertyDeclaration(original) && ts3.hasStaticModifier(original)) {
              var ancestorFacts = enterSubtree(32670, 16449);
              var result2 = visitorWorker(node, false);
              exitSubtree(ancestorFacts, 98304, 0);
              return result2;
            }
            return visitorWorker(node, false);
          }
          return node;
        }
        function callExpressionVisitor(node) {
          if (node.kind === 106) {
            return visitSuperKeyword(true);
          }
          return visitor(node);
        }
        function visitorWorker(node, expressionResultIsUnused) {
          switch (node.kind) {
            case 124:
              return void 0;
            case 257:
              return visitClassDeclaration(node);
            case 226:
              return visitClassExpression(node);
            case 164:
              return visitParameter(node);
            case 256:
              return visitFunctionDeclaration(node);
            case 214:
              return visitArrowFunction(node);
            case 213:
              return visitFunctionExpression(node);
            case 254:
              return visitVariableDeclaration(node);
            case 79:
              return visitIdentifier(node);
            case 255:
              return visitVariableDeclarationList(node);
            case 249:
              return visitSwitchStatement(node);
            case 263:
              return visitCaseBlock(node);
            case 235:
              return visitBlock(node, false);
            case 246:
            case 245:
              return visitBreakOrContinueStatement(node);
            case 250:
              return visitLabeledStatement(node);
            case 240:
            case 241:
              return visitDoOrWhileStatement(node, void 0);
            case 242:
              return visitForStatement(node, void 0);
            case 243:
              return visitForInStatement(node, void 0);
            case 244:
              return visitForOfStatement(node, void 0);
            case 238:
              return visitExpressionStatement(node);
            case 205:
              return visitObjectLiteralExpression(node);
            case 292:
              return visitCatchClause(node);
            case 297:
              return visitShorthandPropertyAssignment(node);
            case 162:
              return visitComputedPropertyName(node);
            case 204:
              return visitArrayLiteralExpression(node);
            case 208:
              return visitCallExpression(node);
            case 209:
              return visitNewExpression(node);
            case 212:
              return visitParenthesizedExpression(node, expressionResultIsUnused);
            case 221:
              return visitBinaryExpression(node, expressionResultIsUnused);
            case 351:
              return visitCommaListExpression(node, expressionResultIsUnused);
            case 14:
            case 15:
            case 16:
            case 17:
              return visitTemplateLiteral(node);
            case 10:
              return visitStringLiteral(node);
            case 8:
              return visitNumericLiteral(node);
            case 210:
              return visitTaggedTemplateExpression(node);
            case 223:
              return visitTemplateExpression(node);
            case 224:
              return visitYieldExpression(node);
            case 225:
              return visitSpreadElement(node);
            case 106:
              return visitSuperKeyword(false);
            case 108:
              return visitThisKeyword(node);
            case 231:
              return visitMetaProperty(node);
            case 169:
              return visitMethodDeclaration(node);
            case 172:
            case 173:
              return visitAccessorDeclaration(node);
            case 237:
              return visitVariableStatement(node);
            case 247:
              return visitReturnStatement(node);
            case 217:
              return visitVoidExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitSourceFile(node) {
          var ancestorFacts = enterSubtree(8064, 64);
          var prologue = [];
          var statements = [];
          startLexicalEnvironment();
          var statementOffset = factory.copyPrologue(node.statements, prologue, false, visitor);
          ts3.addRange(statements, ts3.visitNodes(node.statements, visitor, ts3.isStatement, statementOffset));
          if (taggedTemplateStringDeclarations) {
            statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(taggedTemplateStringDeclarations)));
          }
          factory.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureThisForNodeIfNeeded(prologue, node);
          exitSubtree(ancestorFacts, 0, 0);
          return factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray(ts3.concatenate(prologue, statements)), node.statements));
        }
        function visitSwitchStatement(node) {
          if (convertedLoopState !== void 0) {
            var savedAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
            convertedLoopState.allowedNonLabeledJumps |= 2;
            var result2 = ts3.visitEachChild(node, visitor, context);
            convertedLoopState.allowedNonLabeledJumps = savedAllowedNonLabeledJumps;
            return result2;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCaseBlock(node) {
          var ancestorFacts = enterSubtree(7104, 0);
          var updated = ts3.visitEachChild(node, visitor, context);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function returnCapturedThis(node) {
          return ts3.setOriginalNode(factory.createReturnStatement(factory.createUniqueName("_this", 16 | 32)), node);
        }
        function visitReturnStatement(node) {
          if (convertedLoopState) {
            convertedLoopState.nonLocalJumps |= 8;
            if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
              node = returnCapturedThis(node);
            }
            return factory.createReturnStatement(factory.createObjectLiteralExpression([
              factory.createPropertyAssignment(factory.createIdentifier("value"), node.expression ? ts3.visitNode(node.expression, visitor, ts3.isExpression) : factory.createVoidZero())
            ]));
          } else if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
            return returnCapturedThis(node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitThisKeyword(node) {
          if (hierarchyFacts & 2 && !(hierarchyFacts & 16384)) {
            hierarchyFacts |= 65536;
          }
          if (convertedLoopState) {
            if (hierarchyFacts & 2) {
              convertedLoopState.containsLexicalThis = true;
              return node;
            }
            return convertedLoopState.thisName || (convertedLoopState.thisName = factory.createUniqueName("this"));
          }
          return node;
        }
        function visitVoidExpression(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitIdentifier(node) {
          if (!convertedLoopState) {
            return node;
          }
          if (resolver.isArgumentsLocalBinding(node)) {
            return convertedLoopState.argumentsName || (convertedLoopState.argumentsName = factory.createUniqueName("arguments"));
          }
          return node;
        }
        function visitBreakOrContinueStatement(node) {
          if (convertedLoopState) {
            var jump = node.kind === 246 ? 2 : 4;
            var canUseBreakOrContinue = node.label && convertedLoopState.labels && convertedLoopState.labels.get(ts3.idText(node.label)) || !node.label && convertedLoopState.allowedNonLabeledJumps & jump;
            if (!canUseBreakOrContinue) {
              var labelMarker = void 0;
              var label = node.label;
              if (!label) {
                if (node.kind === 246) {
                  convertedLoopState.nonLocalJumps |= 2;
                  labelMarker = "break";
                } else {
                  convertedLoopState.nonLocalJumps |= 4;
                  labelMarker = "continue";
                }
              } else {
                if (node.kind === 246) {
                  labelMarker = "break-".concat(label.escapedText);
                  setLabeledJump(convertedLoopState, true, ts3.idText(label), labelMarker);
                } else {
                  labelMarker = "continue-".concat(label.escapedText);
                  setLabeledJump(convertedLoopState, false, ts3.idText(label), labelMarker);
                }
              }
              var returnExpression = factory.createStringLiteral(labelMarker);
              if (convertedLoopState.loopOutParameters.length) {
                var outParams = convertedLoopState.loopOutParameters;
                var expr = void 0;
                for (var i = 0; i < outParams.length; i++) {
                  var copyExpr = copyOutParameter(outParams[i], 1);
                  if (i === 0) {
                    expr = copyExpr;
                  } else {
                    expr = factory.createBinaryExpression(expr, 27, copyExpr);
                  }
                }
                returnExpression = factory.createBinaryExpression(expr, 27, returnExpression);
              }
              return factory.createReturnStatement(returnExpression);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitClassDeclaration(node) {
          var variable = factory.createVariableDeclaration(factory.getLocalName(node, true), void 0, void 0, transformClassLikeDeclarationToExpression(node));
          ts3.setOriginalNode(variable, node);
          var statements = [];
          var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([variable]));
          ts3.setOriginalNode(statement, node);
          ts3.setTextRange(statement, node);
          ts3.startOnNewLine(statement);
          statements.push(statement);
          if (ts3.hasSyntacticModifier(node, 1)) {
            var exportStatement = ts3.hasSyntacticModifier(node, 512) ? factory.createExportDefault(factory.getLocalName(node)) : factory.createExternalModuleExport(factory.getLocalName(node));
            ts3.setOriginalNode(exportStatement, statement);
            statements.push(exportStatement);
          }
          var emitFlags = ts3.getEmitFlags(node);
          if ((emitFlags & 4194304) === 0) {
            statements.push(factory.createEndOfDeclarationMarker(node));
            ts3.setEmitFlags(statement, emitFlags | 4194304);
          }
          return ts3.singleOrMany(statements);
        }
        function visitClassExpression(node) {
          return transformClassLikeDeclarationToExpression(node);
        }
        function transformClassLikeDeclarationToExpression(node) {
          if (node.name) {
            enableSubstitutionsForBlockScopedBindings();
          }
          var extendsClauseElement = ts3.getClassExtendsHeritageElement(node);
          var classFunction = factory.createFunctionExpression(void 0, void 0, void 0, void 0, extendsClauseElement ? [factory.createParameterDeclaration(void 0, void 0, void 0, factory.createUniqueName("_super", 16 | 32))] : [], void 0, transformClassBody(node, extendsClauseElement));
          ts3.setEmitFlags(classFunction, ts3.getEmitFlags(node) & 65536 | 524288);
          var inner = factory.createPartiallyEmittedExpression(classFunction);
          ts3.setTextRangeEnd(inner, node.end);
          ts3.setEmitFlags(inner, 1536);
          var outer = factory.createPartiallyEmittedExpression(inner);
          ts3.setTextRangeEnd(outer, ts3.skipTrivia(currentText, node.pos));
          ts3.setEmitFlags(outer, 1536);
          var result2 = factory.createParenthesizedExpression(factory.createCallExpression(outer, void 0, extendsClauseElement ? [ts3.visitNode(extendsClauseElement.expression, visitor, ts3.isExpression)] : []));
          ts3.addSyntheticLeadingComment(result2, 3, "* @class ");
          return result2;
        }
        function transformClassBody(node, extendsClauseElement) {
          var statements = [];
          var name = factory.getInternalName(node);
          var constructorLikeName = ts3.isIdentifierANonContextualKeyword(name) ? factory.getGeneratedNameForNode(name) : name;
          startLexicalEnvironment();
          addExtendsHelperIfNeeded(statements, node, extendsClauseElement);
          addConstructor(statements, node, constructorLikeName, extendsClauseElement);
          addClassMembers(statements, node);
          var closingBraceLocation = ts3.createTokenRange(ts3.skipTrivia(currentText, node.members.end), 19);
          var outer = factory.createPartiallyEmittedExpression(constructorLikeName);
          ts3.setTextRangeEnd(outer, closingBraceLocation.end);
          ts3.setEmitFlags(outer, 1536);
          var statement = factory.createReturnStatement(outer);
          ts3.setTextRangePos(statement, closingBraceLocation.pos);
          ts3.setEmitFlags(statement, 1536 | 384);
          statements.push(statement);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), node.members), true);
          ts3.setEmitFlags(block, 1536);
          return block;
        }
        function addExtendsHelperIfNeeded(statements, node, extendsClauseElement) {
          if (extendsClauseElement) {
            statements.push(ts3.setTextRange(factory.createExpressionStatement(emitHelpers().createExtendsHelper(factory.getInternalName(node))), extendsClauseElement));
          }
        }
        function addConstructor(statements, node, name, extendsClauseElement) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(32662, 73);
          var constructor = ts3.getFirstConstructorWithBody(node);
          var hasSynthesizedSuper = hasSynthesizedDefaultSuperCall(constructor, extendsClauseElement !== void 0);
          var constructorFunction = factory.createFunctionDeclaration(void 0, void 0, void 0, name, void 0, transformConstructorParameters(constructor, hasSynthesizedSuper), void 0, transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper));
          ts3.setTextRange(constructorFunction, constructor || node);
          if (extendsClauseElement) {
            ts3.setEmitFlags(constructorFunction, 8);
          }
          statements.push(constructorFunction);
          exitSubtree(ancestorFacts, 98304, 0);
          convertedLoopState = savedConvertedLoopState;
        }
        function transformConstructorParameters(constructor, hasSynthesizedSuper) {
          return ts3.visitParameterList(constructor && !hasSynthesizedSuper ? constructor.parameters : void 0, visitor, context) || [];
        }
        function createDefaultConstructorBody(node, isDerivedClass) {
          var statements = [];
          resumeLexicalEnvironment();
          factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          if (isDerivedClass) {
            statements.push(factory.createReturnStatement(createDefaultSuperCallOrThis()));
          }
          var statementsArray = factory.createNodeArray(statements);
          ts3.setTextRange(statementsArray, node.members);
          var block = factory.createBlock(statementsArray, true);
          ts3.setTextRange(block, node);
          ts3.setEmitFlags(block, 1536);
          return block;
        }
        function transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper) {
          var isDerivedClass = !!extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 104;
          if (!constructor)
            return createDefaultConstructorBody(node, isDerivedClass);
          var prologue = [];
          var statements = [];
          resumeLexicalEnvironment();
          var existingPrologue = ts3.takeWhile(constructor.body.statements, ts3.isPrologueDirective);
          var _a = findSuperCallAndStatementIndex(constructor.body.statements, existingPrologue), superCall = _a.superCall, superStatementIndex = _a.superStatementIndex;
          var postSuperStatementsStart = superStatementIndex === -1 ? existingPrologue.length : superStatementIndex + 1;
          var statementOffset = postSuperStatementsStart;
          if (!hasSynthesizedSuper)
            statementOffset = factory.copyStandardPrologue(constructor.body.statements, prologue, statementOffset, false);
          if (!hasSynthesizedSuper)
            statementOffset = factory.copyCustomPrologue(constructor.body.statements, statements, statementOffset, visitor, void 0);
          var superCallExpression;
          if (hasSynthesizedSuper) {
            superCallExpression = createDefaultSuperCallOrThis();
          } else if (superCall) {
            superCallExpression = visitSuperCallInBody(superCall);
          }
          if (superCallExpression) {
            hierarchyFacts |= 8192;
          }
          addDefaultValueAssignmentsIfNeeded(prologue, constructor);
          addRestParameterIfNeeded(prologue, constructor, hasSynthesizedSuper);
          ts3.addRange(statements, ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, statementOffset));
          factory.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureNewTargetIfNeeded(prologue, constructor, false);
          if (isDerivedClass || superCallExpression) {
            if (superCallExpression && postSuperStatementsStart === constructor.body.statements.length && !(constructor.body.transformFlags & 8192)) {
              var superCall_1 = ts3.cast(ts3.cast(superCallExpression, ts3.isBinaryExpression).left, ts3.isCallExpression);
              var returnStatement = factory.createReturnStatement(superCallExpression);
              ts3.setCommentRange(returnStatement, ts3.getCommentRange(superCall_1));
              ts3.setEmitFlags(superCall_1, 1536);
              statements.push(returnStatement);
            } else {
              if (superStatementIndex <= existingPrologue.length) {
                insertCaptureThisForNode(statements, constructor, superCallExpression || createActualThis());
              } else {
                insertCaptureThisForNode(prologue, constructor, createActualThis());
                if (superCallExpression) {
                  insertSuperThisCaptureThisForNode(statements, superCallExpression);
                }
              }
              if (!isSufficientlyCoveredByReturnStatements(constructor.body)) {
                statements.push(factory.createReturnStatement(factory.createUniqueName("_this", 16 | 32)));
              }
            }
          } else {
            insertCaptureThisForNodeIfNeeded(prologue, constructor);
          }
          var body = factory.createBlock(ts3.setTextRange(factory.createNodeArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], existingPrologue, true), prologue, true), superStatementIndex <= existingPrologue.length ? ts3.emptyArray : ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, existingPrologue.length, superStatementIndex - existingPrologue.length), true), statements, true)), constructor.body.statements), true);
          ts3.setTextRange(body, constructor.body);
          return body;
        }
        function findSuperCallAndStatementIndex(originalBodyStatements, existingPrologue) {
          for (var i = existingPrologue.length; i < originalBodyStatements.length; i += 1) {
            var superCall = ts3.getSuperCallFromStatement(originalBodyStatements[i]);
            if (superCall) {
              return {
                superCall,
                superStatementIndex: i
              };
            }
          }
          return {
            superStatementIndex: -1
          };
        }
        function isSufficientlyCoveredByReturnStatements(statement) {
          if (statement.kind === 247) {
            return true;
          } else if (statement.kind === 239) {
            var ifStatement = statement;
            if (ifStatement.elseStatement) {
              return isSufficientlyCoveredByReturnStatements(ifStatement.thenStatement) && isSufficientlyCoveredByReturnStatements(ifStatement.elseStatement);
            }
          } else if (statement.kind === 235) {
            var lastStatement = ts3.lastOrUndefined(statement.statements);
            if (lastStatement && isSufficientlyCoveredByReturnStatements(lastStatement)) {
              return true;
            }
          }
          return false;
        }
        function createActualThis() {
          return ts3.setEmitFlags(factory.createThis(), 4);
        }
        function createDefaultSuperCallOrThis() {
          return factory.createLogicalOr(factory.createLogicalAnd(factory.createStrictInequality(factory.createUniqueName("_super", 16 | 32), factory.createNull()), factory.createFunctionApplyCall(factory.createUniqueName("_super", 16 | 32), createActualThis(), factory.createIdentifier("arguments"))), createActualThis());
        }
        function visitParameter(node) {
          if (node.dotDotDotToken) {
            return void 0;
          } else if (ts3.isBindingPattern(node.name)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createParameterDeclaration(void 0, void 0, void 0, factory.getGeneratedNameForNode(node), void 0, void 0, void 0), node), node);
          } else if (node.initializer) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createParameterDeclaration(void 0, void 0, void 0, node.name, void 0, void 0, void 0), node), node);
          } else {
            return node;
          }
        }
        function hasDefaultValueOrBindingPattern(node) {
          return node.initializer !== void 0 || ts3.isBindingPattern(node.name);
        }
        function addDefaultValueAssignmentsIfNeeded(statements, node) {
          if (!ts3.some(node.parameters, hasDefaultValueOrBindingPattern)) {
            return false;
          }
          var added = false;
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            var name = parameter.name, initializer = parameter.initializer, dotDotDotToken = parameter.dotDotDotToken;
            if (dotDotDotToken) {
              continue;
            }
            if (ts3.isBindingPattern(name)) {
              added = insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) || added;
            } else if (initializer) {
              insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer);
              added = true;
            }
          }
          return added;
        }
        function insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) {
          if (name.elements.length > 0) {
            ts3.insertStatementAfterCustomPrologue(statements, ts3.setEmitFlags(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(ts3.flattenDestructuringBinding(parameter, visitor, context, 0, factory.getGeneratedNameForNode(parameter)))), 1048576));
            return true;
          } else if (initializer) {
            ts3.insertStatementAfterCustomPrologue(statements, ts3.setEmitFlags(factory.createExpressionStatement(factory.createAssignment(factory.getGeneratedNameForNode(parameter), ts3.visitNode(initializer, visitor, ts3.isExpression))), 1048576));
            return true;
          }
          return false;
        }
        function insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer) {
          initializer = ts3.visitNode(initializer, visitor, ts3.isExpression);
          var statement = factory.createIfStatement(factory.createTypeCheck(factory.cloneNode(name), "undefined"), ts3.setEmitFlags(ts3.setTextRange(factory.createBlock([
            factory.createExpressionStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createAssignment(ts3.setEmitFlags(ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent), 48), ts3.setEmitFlags(initializer, 48 | ts3.getEmitFlags(initializer) | 1536)), parameter), 1536))
          ]), parameter), 1 | 32 | 384 | 1536));
          ts3.startOnNewLine(statement);
          ts3.setTextRange(statement, parameter);
          ts3.setEmitFlags(statement, 384 | 32 | 1048576 | 1536);
          ts3.insertStatementAfterCustomPrologue(statements, statement);
        }
        function shouldAddRestParameter(node, inConstructorWithSynthesizedSuper) {
          return !!(node && node.dotDotDotToken && !inConstructorWithSynthesizedSuper);
        }
        function addRestParameterIfNeeded(statements, node, inConstructorWithSynthesizedSuper) {
          var prologueStatements = [];
          var parameter = ts3.lastOrUndefined(node.parameters);
          if (!shouldAddRestParameter(parameter, inConstructorWithSynthesizedSuper)) {
            return false;
          }
          var declarationName = parameter.name.kind === 79 ? ts3.setParent(ts3.setTextRange(factory.cloneNode(parameter.name), parameter.name), parameter.name.parent) : factory.createTempVariable(void 0);
          ts3.setEmitFlags(declarationName, 48);
          var expressionName = parameter.name.kind === 79 ? factory.cloneNode(parameter.name) : declarationName;
          var restIndex = node.parameters.length - 1;
          var temp = factory.createLoopVariable();
          prologueStatements.push(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(declarationName, void 0, void 0, factory.createArrayLiteralExpression([]))
          ])), parameter), 1048576));
          var forStatement = factory.createForStatement(ts3.setTextRange(factory.createVariableDeclarationList([
            factory.createVariableDeclaration(temp, void 0, void 0, factory.createNumericLiteral(restIndex))
          ]), parameter), ts3.setTextRange(factory.createLessThan(temp, factory.createPropertyAccessExpression(factory.createIdentifier("arguments"), "length")), parameter), ts3.setTextRange(factory.createPostfixIncrement(temp), parameter), factory.createBlock([
            ts3.startOnNewLine(ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(factory.createElementAccessExpression(expressionName, restIndex === 0 ? temp : factory.createSubtract(temp, factory.createNumericLiteral(restIndex))), factory.createElementAccessExpression(factory.createIdentifier("arguments"), temp))), parameter))
          ]));
          ts3.setEmitFlags(forStatement, 1048576);
          ts3.startOnNewLine(forStatement);
          prologueStatements.push(forStatement);
          if (parameter.name.kind !== 79) {
            prologueStatements.push(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(ts3.flattenDestructuringBinding(parameter, visitor, context, 0, expressionName))), parameter), 1048576));
          }
          ts3.insertStatementsAfterCustomPrologue(statements, prologueStatements);
          return true;
        }
        function insertCaptureThisForNodeIfNeeded(statements, node) {
          if (hierarchyFacts & 65536 && node.kind !== 214) {
            insertCaptureThisForNode(statements, node, factory.createThis());
            return true;
          }
          return false;
        }
        function insertSuperThisCaptureThisForNode(statements, superExpression) {
          enableSubstitutionsForCapturedThis();
          var assignSuperExpression = factory.createExpressionStatement(factory.createBinaryExpression(factory.createThis(), 63, superExpression));
          ts3.insertStatementAfterCustomPrologue(statements, assignSuperExpression);
          ts3.setCommentRange(assignSuperExpression, ts3.getOriginalNode(superExpression).parent);
        }
        function insertCaptureThisForNode(statements, node, initializer) {
          enableSubstitutionsForCapturedThis();
          var captureThisStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(factory.createUniqueName("_this", 16 | 32), void 0, void 0, initializer)
          ]));
          ts3.setEmitFlags(captureThisStatement, 1536 | 1048576);
          ts3.setSourceMapRange(captureThisStatement, node);
          ts3.insertStatementAfterCustomPrologue(statements, captureThisStatement);
        }
        function insertCaptureNewTargetIfNeeded(statements, node, copyOnWrite) {
          if (hierarchyFacts & 32768) {
            var newTarget = void 0;
            switch (node.kind) {
              case 214:
                return statements;
              case 169:
              case 172:
              case 173:
                newTarget = factory.createVoidZero();
                break;
              case 171:
                newTarget = factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createThis(), 4), "constructor");
                break;
              case 256:
              case 213:
                newTarget = factory.createConditionalExpression(factory.createLogicalAnd(ts3.setEmitFlags(factory.createThis(), 4), factory.createBinaryExpression(ts3.setEmitFlags(factory.createThis(), 4), 102, factory.getLocalName(node))), void 0, factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createThis(), 4), "constructor"), void 0, factory.createVoidZero());
                break;
              default:
                return ts3.Debug.failBadSyntaxKind(node);
            }
            var captureNewTargetStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(factory.createUniqueName("_newTarget", 16 | 32), void 0, void 0, newTarget)
            ]));
            ts3.setEmitFlags(captureNewTargetStatement, 1536 | 1048576);
            if (copyOnWrite) {
              statements = statements.slice();
            }
            ts3.insertStatementAfterCustomPrologue(statements, captureNewTargetStatement);
          }
          return statements;
        }
        function addClassMembers(statements, node) {
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            switch (member.kind) {
              case 234:
                statements.push(transformSemicolonClassElementToStatement(member));
                break;
              case 169:
                statements.push(transformClassMethodDeclarationToStatement(getClassMemberPrefix(node, member), member, node));
                break;
              case 172:
              case 173:
                var accessors = ts3.getAllAccessorDeclarations(node.members, member);
                if (member === accessors.firstAccessor) {
                  statements.push(transformAccessorsToStatement(getClassMemberPrefix(node, member), accessors, node));
                }
                break;
              case 171:
              case 170:
                break;
              default:
                ts3.Debug.failBadSyntaxKind(member, currentSourceFile && currentSourceFile.fileName);
                break;
            }
          }
        }
        function transformSemicolonClassElementToStatement(member) {
          return ts3.setTextRange(factory.createEmptyStatement(), member);
        }
        function transformClassMethodDeclarationToStatement(receiver, member, container) {
          var commentRange = ts3.getCommentRange(member);
          var sourceMapRange = ts3.getSourceMapRange(member);
          var memberFunction = transformFunctionLikeToExpression(member, member, void 0, container);
          var propertyName = ts3.visitNode(member.name, visitor, ts3.isPropertyName);
          var e;
          if (!ts3.isPrivateIdentifier(propertyName) && ts3.getUseDefineForClassFields(context.getCompilerOptions())) {
            var name = ts3.isComputedPropertyName(propertyName) ? propertyName.expression : ts3.isIdentifier(propertyName) ? factory.createStringLiteral(ts3.unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
            e = factory.createObjectDefinePropertyCall(receiver, name, factory.createPropertyDescriptor({ value: memberFunction, enumerable: false, writable: true, configurable: true }));
          } else {
            var memberName = ts3.createMemberAccessForPropertyName(factory, receiver, propertyName, member.name);
            e = factory.createAssignment(memberName, memberFunction);
          }
          ts3.setEmitFlags(memberFunction, 1536);
          ts3.setSourceMapRange(memberFunction, sourceMapRange);
          var statement = ts3.setTextRange(factory.createExpressionStatement(e), member);
          ts3.setOriginalNode(statement, member);
          ts3.setCommentRange(statement, commentRange);
          ts3.setEmitFlags(statement, 48);
          return statement;
        }
        function transformAccessorsToStatement(receiver, accessors, container) {
          var statement = factory.createExpressionStatement(transformAccessorsToExpression(receiver, accessors, container, false));
          ts3.setEmitFlags(statement, 1536);
          ts3.setSourceMapRange(statement, ts3.getSourceMapRange(accessors.firstAccessor));
          return statement;
        }
        function transformAccessorsToExpression(receiver, _a, container, startsOnNewLine) {
          var firstAccessor = _a.firstAccessor, getAccessor = _a.getAccessor, setAccessor = _a.setAccessor;
          var target = ts3.setParent(ts3.setTextRange(factory.cloneNode(receiver), receiver), receiver.parent);
          ts3.setEmitFlags(target, 1536 | 32);
          ts3.setSourceMapRange(target, firstAccessor.name);
          var visitedAccessorName = ts3.visitNode(firstAccessor.name, visitor, ts3.isPropertyName);
          if (ts3.isPrivateIdentifier(visitedAccessorName)) {
            return ts3.Debug.failBadSyntaxKind(visitedAccessorName, "Encountered unhandled private identifier while transforming ES2015.");
          }
          var propertyName = ts3.createExpressionForPropertyName(factory, visitedAccessorName);
          ts3.setEmitFlags(propertyName, 1536 | 16);
          ts3.setSourceMapRange(propertyName, firstAccessor.name);
          var properties = [];
          if (getAccessor) {
            var getterFunction = transformFunctionLikeToExpression(getAccessor, void 0, void 0, container);
            ts3.setSourceMapRange(getterFunction, ts3.getSourceMapRange(getAccessor));
            ts3.setEmitFlags(getterFunction, 512);
            var getter = factory.createPropertyAssignment("get", getterFunction);
            ts3.setCommentRange(getter, ts3.getCommentRange(getAccessor));
            properties.push(getter);
          }
          if (setAccessor) {
            var setterFunction = transformFunctionLikeToExpression(setAccessor, void 0, void 0, container);
            ts3.setSourceMapRange(setterFunction, ts3.getSourceMapRange(setAccessor));
            ts3.setEmitFlags(setterFunction, 512);
            var setter = factory.createPropertyAssignment("set", setterFunction);
            ts3.setCommentRange(setter, ts3.getCommentRange(setAccessor));
            properties.push(setter);
          }
          properties.push(factory.createPropertyAssignment("enumerable", getAccessor || setAccessor ? factory.createFalse() : factory.createTrue()), factory.createPropertyAssignment("configurable", factory.createTrue()));
          var call = factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "defineProperty"), void 0, [
            target,
            propertyName,
            factory.createObjectLiteralExpression(properties, true)
          ]);
          if (startsOnNewLine) {
            ts3.startOnNewLine(call);
          }
          return call;
        }
        function visitArrowFunction(node) {
          if (node.transformFlags & 8192 && !(hierarchyFacts & 16384)) {
            hierarchyFacts |= 65536;
          }
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(15232, 66);
          var func = factory.createFunctionExpression(void 0, void 0, void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, transformFunctionBody(node));
          ts3.setTextRange(func, node);
          ts3.setOriginalNode(func, node);
          ts3.setEmitFlags(func, 8);
          exitSubtree(ancestorFacts, 0, 0);
          convertedLoopState = savedConvertedLoopState;
          return func;
        }
        function visitFunctionExpression(node) {
          var ancestorFacts = ts3.getEmitFlags(node) & 262144 ? enterSubtree(32662, 69) : enterSubtree(32670, 65);
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          var name = hierarchyFacts & 32768 ? factory.getLocalName(node) : node.name;
          exitSubtree(ancestorFacts, 98304, 0);
          convertedLoopState = savedConvertedLoopState;
          return factory.updateFunctionExpression(node, void 0, node.asteriskToken, name, void 0, parameters, void 0, body);
        }
        function visitFunctionDeclaration(node) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(32670, 65);
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          var name = hierarchyFacts & 32768 ? factory.getLocalName(node) : node.name;
          exitSubtree(ancestorFacts, 98304, 0);
          convertedLoopState = savedConvertedLoopState;
          return factory.updateFunctionDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, name, void 0, parameters, void 0, body);
        }
        function transformFunctionLikeToExpression(node, location, name, container) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = container && ts3.isClassLike(container) && !ts3.isStatic(node) ? enterSubtree(32670, 65 | 8) : enterSubtree(32670, 65);
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          if (hierarchyFacts & 32768 && !name && (node.kind === 256 || node.kind === 213)) {
            name = factory.getGeneratedNameForNode(node);
          }
          exitSubtree(ancestorFacts, 98304, 0);
          convertedLoopState = savedConvertedLoopState;
          return ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionExpression(void 0, node.asteriskToken, name, void 0, parameters, void 0, body), location), node);
        }
        function transformFunctionBody(node) {
          var multiLine = false;
          var singleLine = false;
          var statementsLocation;
          var closeBraceLocation;
          var prologue = [];
          var statements = [];
          var body = node.body;
          var statementOffset;
          resumeLexicalEnvironment();
          if (ts3.isBlock(body)) {
            statementOffset = factory.copyStandardPrologue(body.statements, prologue, 0, false);
            statementOffset = factory.copyCustomPrologue(body.statements, statements, statementOffset, visitor, ts3.isHoistedFunction);
            statementOffset = factory.copyCustomPrologue(body.statements, statements, statementOffset, visitor, ts3.isHoistedVariableStatement);
          }
          multiLine = addDefaultValueAssignmentsIfNeeded(statements, node) || multiLine;
          multiLine = addRestParameterIfNeeded(statements, node, false) || multiLine;
          if (ts3.isBlock(body)) {
            statementOffset = factory.copyCustomPrologue(body.statements, statements, statementOffset, visitor);
            statementsLocation = body.statements;
            ts3.addRange(statements, ts3.visitNodes(body.statements, visitor, ts3.isStatement, statementOffset));
            if (!multiLine && body.multiLine) {
              multiLine = true;
            }
          } else {
            ts3.Debug.assert(node.kind === 214);
            statementsLocation = ts3.moveRangeEnd(body, -1);
            var equalsGreaterThanToken = node.equalsGreaterThanToken;
            if (!ts3.nodeIsSynthesized(equalsGreaterThanToken) && !ts3.nodeIsSynthesized(body)) {
              if (ts3.rangeEndIsOnSameLineAsRangeStart(equalsGreaterThanToken, body, currentSourceFile)) {
                singleLine = true;
              } else {
                multiLine = true;
              }
            }
            var expression = ts3.visitNode(body, visitor, ts3.isExpression);
            var returnStatement = factory.createReturnStatement(expression);
            ts3.setTextRange(returnStatement, body);
            ts3.moveSyntheticComments(returnStatement, body);
            ts3.setEmitFlags(returnStatement, 384 | 32 | 1024);
            statements.push(returnStatement);
            closeBraceLocation = body;
          }
          factory.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureNewTargetIfNeeded(prologue, node, false);
          insertCaptureThisForNodeIfNeeded(prologue, node);
          if (ts3.some(prologue)) {
            multiLine = true;
          }
          statements.unshift.apply(statements, prologue);
          if (ts3.isBlock(body) && ts3.arrayIsEqualTo(statements, body.statements)) {
            return body;
          }
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), multiLine);
          ts3.setTextRange(block, node.body);
          if (!multiLine && singleLine) {
            ts3.setEmitFlags(block, 1);
          }
          if (closeBraceLocation) {
            ts3.setTokenSourceMapRange(block, 19, closeBraceLocation);
          }
          ts3.setOriginalNode(block, node.body);
          return block;
        }
        function visitBlock(node, isFunctionBody) {
          if (isFunctionBody) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var ancestorFacts = hierarchyFacts & 256 ? enterSubtree(7104, 512) : enterSubtree(6976, 128);
          var updated = ts3.visitEachChild(node, visitor, context);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitExpressionStatement(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitParenthesizedExpression(node, expressionResultIsUnused) {
          return ts3.visitEachChild(node, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, context);
        }
        function visitBinaryExpression(node, expressionResultIsUnused) {
          if (ts3.isDestructuringAssignment(node)) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 0, !expressionResultIsUnused);
          }
          if (node.operatorToken.kind === 27) {
            return factory.updateBinaryExpression(node, ts3.visitNode(node.left, visitorWithUnusedExpressionResult, ts3.isExpression), node.operatorToken, ts3.visitNode(node.right, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCommaListExpression(node, expressionResultIsUnused) {
          if (expressionResultIsUnused) {
            return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
          }
          var result2;
          for (var i = 0; i < node.elements.length; i++) {
            var element = node.elements[i];
            var visited = ts3.visitNode(element, i < node.elements.length - 1 ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression);
            if (result2 || visited !== element) {
              result2 || (result2 = node.elements.slice(0, i));
              result2.push(visited);
            }
          }
          var elements = result2 ? ts3.setTextRange(factory.createNodeArray(result2), node.elements) : node.elements;
          return factory.updateCommaListExpression(node, elements);
        }
        function isVariableStatementOfTypeScriptClassWrapper(node) {
          return node.declarationList.declarations.length === 1 && !!node.declarationList.declarations[0].initializer && !!(ts3.getEmitFlags(node.declarationList.declarations[0].initializer) & 33554432);
        }
        function visitVariableStatement(node) {
          var ancestorFacts = enterSubtree(0, ts3.hasSyntacticModifier(node, 1) ? 32 : 0);
          var updated;
          if (convertedLoopState && (node.declarationList.flags & 3) === 0 && !isVariableStatementOfTypeScriptClassWrapper(node)) {
            var assignments = void 0;
            for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              hoistVariableDeclarationDeclaredInConvertedLoop(convertedLoopState, decl);
              if (decl.initializer) {
                var assignment = void 0;
                if (ts3.isBindingPattern(decl.name)) {
                  assignment = ts3.flattenDestructuringAssignment(decl, visitor, context, 0);
                } else {
                  assignment = factory.createBinaryExpression(decl.name, 63, ts3.visitNode(decl.initializer, visitor, ts3.isExpression));
                  ts3.setTextRange(assignment, decl);
                }
                assignments = ts3.append(assignments, assignment);
              }
            }
            if (assignments) {
              updated = ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(assignments)), node);
            } else {
              updated = void 0;
            }
          } else {
            updated = ts3.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitVariableDeclarationList(node) {
          if (node.flags & 3 || node.transformFlags & 262144) {
            if (node.flags & 3) {
              enableSubstitutionsForBlockScopedBindings();
            }
            var declarations = ts3.flatMap(node.declarations, node.flags & 1 ? visitVariableDeclarationInLetDeclarationList : visitVariableDeclaration);
            var declarationList = factory.createVariableDeclarationList(declarations);
            ts3.setOriginalNode(declarationList, node);
            ts3.setTextRange(declarationList, node);
            ts3.setCommentRange(declarationList, node);
            if (node.transformFlags & 262144 && (ts3.isBindingPattern(node.declarations[0].name) || ts3.isBindingPattern(ts3.last(node.declarations).name))) {
              ts3.setSourceMapRange(declarationList, getRangeUnion(declarations));
            }
            return declarationList;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function getRangeUnion(declarations) {
          var pos = -1, end = -1;
          for (var _i = 0, declarations_10 = declarations; _i < declarations_10.length; _i++) {
            var node = declarations_10[_i];
            pos = pos === -1 ? node.pos : node.pos === -1 ? pos : Math.min(pos, node.pos);
            end = Math.max(end, node.end);
          }
          return ts3.createRange(pos, end);
        }
        function shouldEmitExplicitInitializerForLetDeclaration(node) {
          var flags = resolver.getNodeCheckFlags(node);
          var isCapturedInFunction = flags & 262144;
          var isDeclaredInLoop = flags & 524288;
          var emittedAsTopLevel = (hierarchyFacts & 64) !== 0 || isCapturedInFunction && isDeclaredInLoop && (hierarchyFacts & 512) !== 0;
          var emitExplicitInitializer = !emittedAsTopLevel && (hierarchyFacts & 4096) === 0 && (!resolver.isDeclarationWithCollidingName(node) || isDeclaredInLoop && !isCapturedInFunction && (hierarchyFacts & (2048 | 4096)) === 0);
          return emitExplicitInitializer;
        }
        function visitVariableDeclarationInLetDeclarationList(node) {
          var name = node.name;
          if (ts3.isBindingPattern(name)) {
            return visitVariableDeclaration(node);
          }
          if (!node.initializer && shouldEmitExplicitInitializerForLetDeclaration(node)) {
            return factory.updateVariableDeclaration(node, node.name, void 0, void 0, factory.createVoidZero());
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitVariableDeclaration(node) {
          var ancestorFacts = enterSubtree(32, 0);
          var updated;
          if (ts3.isBindingPattern(node.name)) {
            updated = ts3.flattenDestructuringBinding(node, visitor, context, 0, void 0, (ancestorFacts & 32) !== 0);
          } else {
            updated = ts3.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function recordLabel(node) {
          convertedLoopState.labels.set(ts3.idText(node.label), true);
        }
        function resetLabel(node) {
          convertedLoopState.labels.set(ts3.idText(node.label), false);
        }
        function visitLabeledStatement(node) {
          if (convertedLoopState && !convertedLoopState.labels) {
            convertedLoopState.labels = new ts3.Map();
          }
          var statement = ts3.unwrapInnermostStatementOfLabel(node, convertedLoopState && recordLabel);
          return ts3.isIterationStatement(statement, false) ? visitIterationStatement(statement, node) : factory.restoreEnclosingLabel(ts3.visitNode(statement, visitor, ts3.isStatement, factory.liftToBlock), node, convertedLoopState && resetLabel);
        }
        function visitIterationStatement(node, outermostLabeledStatement) {
          switch (node.kind) {
            case 240:
            case 241:
              return visitDoOrWhileStatement(node, outermostLabeledStatement);
            case 242:
              return visitForStatement(node, outermostLabeledStatement);
            case 243:
              return visitForInStatement(node, outermostLabeledStatement);
            case 244:
              return visitForOfStatement(node, outermostLabeledStatement);
          }
        }
        function visitIterationStatementWithFacts(excludeFacts, includeFacts, node, outermostLabeledStatement, convert) {
          var ancestorFacts = enterSubtree(excludeFacts, includeFacts);
          var updated = convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitDoOrWhileStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(0, 1280, node, outermostLabeledStatement);
        }
        function visitForStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(5056, 3328, node, outermostLabeledStatement);
        }
        function visitEachChildOfForStatement(node) {
          return factory.updateForStatement(node, ts3.visitNode(node.initializer, visitorWithUnusedExpressionResult, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitorWithUnusedExpressionResult, ts3.isExpression), ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
        }
        function visitForInStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(3008, 5376, node, outermostLabeledStatement);
        }
        function visitForOfStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(3008, 5376, node, outermostLabeledStatement, compilerOptions.downlevelIteration ? convertForOfStatementForIterable : convertForOfStatementForArray);
        }
        function convertForOfStatementHead(node, boundValue, convertedLoopBodyStatements) {
          var statements = [];
          var initializer = node.initializer;
          if (ts3.isVariableDeclarationList(initializer)) {
            if (node.initializer.flags & 3) {
              enableSubstitutionsForBlockScopedBindings();
            }
            var firstOriginalDeclaration = ts3.firstOrUndefined(initializer.declarations);
            if (firstOriginalDeclaration && ts3.isBindingPattern(firstOriginalDeclaration.name)) {
              var declarations = ts3.flattenDestructuringBinding(firstOriginalDeclaration, visitor, context, 0, boundValue);
              var declarationList = ts3.setTextRange(factory.createVariableDeclarationList(declarations), node.initializer);
              ts3.setOriginalNode(declarationList, node.initializer);
              ts3.setSourceMapRange(declarationList, ts3.createRange(declarations[0].pos, ts3.last(declarations).end));
              statements.push(factory.createVariableStatement(void 0, declarationList));
            } else {
              statements.push(ts3.setTextRange(factory.createVariableStatement(void 0, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableDeclarationList([
                factory.createVariableDeclaration(firstOriginalDeclaration ? firstOriginalDeclaration.name : factory.createTempVariable(void 0), void 0, void 0, boundValue)
              ]), ts3.moveRangePos(initializer, -1)), initializer)), ts3.moveRangeEnd(initializer, -1)));
            }
          } else {
            var assignment = factory.createAssignment(initializer, boundValue);
            if (ts3.isDestructuringAssignment(assignment)) {
              statements.push(factory.createExpressionStatement(visitBinaryExpression(assignment, true)));
            } else {
              ts3.setTextRangeEnd(assignment, initializer.end);
              statements.push(ts3.setTextRange(factory.createExpressionStatement(ts3.visitNode(assignment, visitor, ts3.isExpression)), ts3.moveRangeEnd(initializer, -1)));
            }
          }
          if (convertedLoopBodyStatements) {
            return createSyntheticBlockForConvertedStatements(ts3.addRange(statements, convertedLoopBodyStatements));
          } else {
            var statement = ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock);
            if (ts3.isBlock(statement)) {
              return factory.updateBlock(statement, ts3.setTextRange(factory.createNodeArray(ts3.concatenate(statements, statement.statements)), statement.statements));
            } else {
              statements.push(statement);
              return createSyntheticBlockForConvertedStatements(statements);
            }
          }
        }
        function createSyntheticBlockForConvertedStatements(statements) {
          return ts3.setEmitFlags(factory.createBlock(factory.createNodeArray(statements), true), 48 | 384);
        }
        function convertForOfStatementForArray(node, outermostLabeledStatement, convertedLoopBodyStatements) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var counter = factory.createLoopVariable();
          var rhsReference = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(expression) : factory.createTempVariable(void 0);
          ts3.setEmitFlags(expression, 48 | ts3.getEmitFlags(expression));
          var forStatement = ts3.setTextRange(factory.createForStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableDeclarationList([
            ts3.setTextRange(factory.createVariableDeclaration(counter, void 0, void 0, factory.createNumericLiteral(0)), ts3.moveRangePos(node.expression, -1)),
            ts3.setTextRange(factory.createVariableDeclaration(rhsReference, void 0, void 0, expression), node.expression)
          ]), node.expression), 2097152), ts3.setTextRange(factory.createLessThan(counter, factory.createPropertyAccessExpression(rhsReference, "length")), node.expression), ts3.setTextRange(factory.createPostfixIncrement(counter), node.expression), convertForOfStatementHead(node, factory.createElementAccessExpression(rhsReference, counter), convertedLoopBodyStatements)), node);
          ts3.setEmitFlags(forStatement, 256);
          ts3.setTextRange(forStatement, node);
          return factory.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel);
        }
        function convertForOfStatementForIterable(node, outermostLabeledStatement, convertedLoopBodyStatements, ancestorFacts) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var iterator = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(expression) : factory.createTempVariable(void 0);
          var result2 = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(iterator) : factory.createTempVariable(void 0);
          var errorRecord = factory.createUniqueName("e");
          var catchVariable = factory.getGeneratedNameForNode(errorRecord);
          var returnMethod = factory.createTempVariable(void 0);
          var values = ts3.setTextRange(emitHelpers().createValuesHelper(expression), node.expression);
          var next = factory.createCallExpression(factory.createPropertyAccessExpression(iterator, "next"), void 0, []);
          hoistVariableDeclaration(errorRecord);
          hoistVariableDeclaration(returnMethod);
          var initializer = ancestorFacts & 1024 ? factory.inlineExpressions([factory.createAssignment(errorRecord, factory.createVoidZero()), values]) : values;
          var forStatement = ts3.setEmitFlags(ts3.setTextRange(factory.createForStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableDeclarationList([
            ts3.setTextRange(factory.createVariableDeclaration(iterator, void 0, void 0, initializer), node.expression),
            factory.createVariableDeclaration(result2, void 0, void 0, next)
          ]), node.expression), 2097152), factory.createLogicalNot(factory.createPropertyAccessExpression(result2, "done")), factory.createAssignment(result2, next), convertForOfStatementHead(node, factory.createPropertyAccessExpression(result2, "value"), convertedLoopBodyStatements)), node), 256);
          return factory.createTryStatement(factory.createBlock([
            factory.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel)
          ]), factory.createCatchClause(factory.createVariableDeclaration(catchVariable), ts3.setEmitFlags(factory.createBlock([
            factory.createExpressionStatement(factory.createAssignment(errorRecord, factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("error", catchVariable)
            ])))
          ]), 1)), factory.createBlock([
            factory.createTryStatement(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(factory.createLogicalAnd(factory.createLogicalAnd(result2, factory.createLogicalNot(factory.createPropertyAccessExpression(result2, "done"))), factory.createAssignment(returnMethod, factory.createPropertyAccessExpression(iterator, "return"))), factory.createExpressionStatement(factory.createFunctionCallCall(returnMethod, iterator, []))), 1)
            ]), void 0, ts3.setEmitFlags(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(errorRecord, factory.createThrowStatement(factory.createPropertyAccessExpression(errorRecord, "error"))), 1)
            ]), 1))
          ]));
        }
        function visitObjectLiteralExpression(node) {
          var properties = node.properties;
          var numInitialProperties = -1, hasComputed = false;
          for (var i = 0; i < properties.length; i++) {
            var property = properties[i];
            if (property.transformFlags & 524288 && hierarchyFacts & 4 || (hasComputed = ts3.Debug.checkDefined(property.name).kind === 162)) {
              numInitialProperties = i;
              break;
            }
          }
          if (numInitialProperties < 0) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var temp = factory.createTempVariable(hoistVariableDeclaration);
          var expressions = [];
          var assignment = factory.createAssignment(temp, ts3.setEmitFlags(factory.createObjectLiteralExpression(ts3.visitNodes(properties, visitor, ts3.isObjectLiteralElementLike, 0, numInitialProperties), node.multiLine), hasComputed ? 65536 : 0));
          if (node.multiLine) {
            ts3.startOnNewLine(assignment);
          }
          expressions.push(assignment);
          addObjectLiteralMembers(expressions, node, temp, numInitialProperties);
          expressions.push(node.multiLine ? ts3.startOnNewLine(ts3.setParent(ts3.setTextRange(factory.cloneNode(temp), temp), temp.parent)) : temp);
          return factory.inlineExpressions(expressions);
        }
        function shouldConvertPartOfIterationStatement(node) {
          return (resolver.getNodeCheckFlags(node) & 131072) !== 0;
        }
        function shouldConvertInitializerOfForStatement(node) {
          return ts3.isForStatement(node) && !!node.initializer && shouldConvertPartOfIterationStatement(node.initializer);
        }
        function shouldConvertConditionOfForStatement(node) {
          return ts3.isForStatement(node) && !!node.condition && shouldConvertPartOfIterationStatement(node.condition);
        }
        function shouldConvertIncrementorOfForStatement(node) {
          return ts3.isForStatement(node) && !!node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
        }
        function shouldConvertIterationStatement(node) {
          return shouldConvertBodyOfIterationStatement(node) || shouldConvertInitializerOfForStatement(node);
        }
        function shouldConvertBodyOfIterationStatement(node) {
          return (resolver.getNodeCheckFlags(node) & 65536) !== 0;
        }
        function hoistVariableDeclarationDeclaredInConvertedLoop(state, node) {
          if (!state.hoistedLocalVariables) {
            state.hoistedLocalVariables = [];
          }
          visit(node.name);
          function visit(node2) {
            if (node2.kind === 79) {
              state.hoistedLocalVariables.push(node2);
            } else {
              for (var _i = 0, _a = node2.elements; _i < _a.length; _i++) {
                var element = _a[_i];
                if (!ts3.isOmittedExpression(element)) {
                  visit(element.name);
                }
              }
            }
          }
        }
        function convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert) {
          if (!shouldConvertIterationStatement(node)) {
            var saveAllowedNonLabeledJumps = void 0;
            if (convertedLoopState) {
              saveAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
              convertedLoopState.allowedNonLabeledJumps = 2 | 4;
            }
            var result2 = convert ? convert(node, outermostLabeledStatement, void 0, ancestorFacts) : factory.restoreEnclosingLabel(ts3.isForStatement(node) ? visitEachChildOfForStatement(node) : ts3.visitEachChild(node, visitor, context), outermostLabeledStatement, convertedLoopState && resetLabel);
            if (convertedLoopState) {
              convertedLoopState.allowedNonLabeledJumps = saveAllowedNonLabeledJumps;
            }
            return result2;
          }
          var currentState = createConvertedLoopState(node);
          var statements = [];
          var outerConvertedLoopState = convertedLoopState;
          convertedLoopState = currentState;
          var initializerFunction = shouldConvertInitializerOfForStatement(node) ? createFunctionForInitializerOfForStatement(node, currentState) : void 0;
          var bodyFunction = shouldConvertBodyOfIterationStatement(node) ? createFunctionForBodyOfIterationStatement(node, currentState, outerConvertedLoopState) : void 0;
          convertedLoopState = outerConvertedLoopState;
          if (initializerFunction)
            statements.push(initializerFunction.functionDeclaration);
          if (bodyFunction)
            statements.push(bodyFunction.functionDeclaration);
          addExtraDeclarationsForConvertedLoop(statements, currentState, outerConvertedLoopState);
          if (initializerFunction) {
            statements.push(generateCallToConvertedLoopInitializer(initializerFunction.functionName, initializerFunction.containsYield));
          }
          var loop;
          if (bodyFunction) {
            if (convert) {
              loop = convert(node, outermostLabeledStatement, bodyFunction.part, ancestorFacts);
            } else {
              var clone_4 = convertIterationStatementCore(node, initializerFunction, factory.createBlock(bodyFunction.part, true));
              loop = factory.restoreEnclosingLabel(clone_4, outermostLabeledStatement, convertedLoopState && resetLabel);
            }
          } else {
            var clone_5 = convertIterationStatementCore(node, initializerFunction, ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
            loop = factory.restoreEnclosingLabel(clone_5, outermostLabeledStatement, convertedLoopState && resetLabel);
          }
          statements.push(loop);
          return statements;
        }
        function convertIterationStatementCore(node, initializerFunction, convertedLoopBody) {
          switch (node.kind) {
            case 242:
              return convertForStatement(node, initializerFunction, convertedLoopBody);
            case 243:
              return convertForInStatement(node, convertedLoopBody);
            case 244:
              return convertForOfStatement(node, convertedLoopBody);
            case 240:
              return convertDoStatement(node, convertedLoopBody);
            case 241:
              return convertWhileStatement(node, convertedLoopBody);
            default:
              return ts3.Debug.failBadSyntaxKind(node, "IterationStatement expected");
          }
        }
        function convertForStatement(node, initializerFunction, convertedLoopBody) {
          var shouldConvertCondition = node.condition && shouldConvertPartOfIterationStatement(node.condition);
          var shouldConvertIncrementor = shouldConvertCondition || node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
          return factory.updateForStatement(node, ts3.visitNode(initializerFunction ? initializerFunction.part : node.initializer, visitorWithUnusedExpressionResult, ts3.isForInitializer), ts3.visitNode(shouldConvertCondition ? void 0 : node.condition, visitor, ts3.isExpression), ts3.visitNode(shouldConvertIncrementor ? void 0 : node.incrementor, visitorWithUnusedExpressionResult, ts3.isExpression), convertedLoopBody);
        }
        function convertForOfStatement(node, convertedLoopBody) {
          return factory.updateForOfStatement(node, void 0, ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), convertedLoopBody);
        }
        function convertForInStatement(node, convertedLoopBody) {
          return factory.updateForInStatement(node, ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), convertedLoopBody);
        }
        function convertDoStatement(node, convertedLoopBody) {
          return factory.updateDoStatement(node, convertedLoopBody, ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
        function convertWhileStatement(node, convertedLoopBody) {
          return factory.updateWhileStatement(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), convertedLoopBody);
        }
        function createConvertedLoopState(node) {
          var loopInitializer;
          switch (node.kind) {
            case 242:
            case 243:
            case 244:
              var initializer = node.initializer;
              if (initializer && initializer.kind === 255) {
                loopInitializer = initializer;
              }
              break;
          }
          var loopParameters = [];
          var loopOutParameters = [];
          if (loopInitializer && ts3.getCombinedNodeFlags(loopInitializer) & 3) {
            var hasCapturedBindingsInForHead = shouldConvertInitializerOfForStatement(node) || shouldConvertConditionOfForStatement(node) || shouldConvertIncrementorOfForStatement(node);
            for (var _i = 0, _a = loopInitializer.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              processLoopVariableDeclaration(node, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForHead);
            }
          }
          var currentState = { loopParameters, loopOutParameters };
          if (convertedLoopState) {
            if (convertedLoopState.argumentsName) {
              currentState.argumentsName = convertedLoopState.argumentsName;
            }
            if (convertedLoopState.thisName) {
              currentState.thisName = convertedLoopState.thisName;
            }
            if (convertedLoopState.hoistedLocalVariables) {
              currentState.hoistedLocalVariables = convertedLoopState.hoistedLocalVariables;
            }
          }
          return currentState;
        }
        function addExtraDeclarationsForConvertedLoop(statements, state, outerState) {
          var extraVariableDeclarations;
          if (state.argumentsName) {
            if (outerState) {
              outerState.argumentsName = state.argumentsName;
            } else {
              (extraVariableDeclarations || (extraVariableDeclarations = [])).push(factory.createVariableDeclaration(state.argumentsName, void 0, void 0, factory.createIdentifier("arguments")));
            }
          }
          if (state.thisName) {
            if (outerState) {
              outerState.thisName = state.thisName;
            } else {
              (extraVariableDeclarations || (extraVariableDeclarations = [])).push(factory.createVariableDeclaration(state.thisName, void 0, void 0, factory.createIdentifier("this")));
            }
          }
          if (state.hoistedLocalVariables) {
            if (outerState) {
              outerState.hoistedLocalVariables = state.hoistedLocalVariables;
            } else {
              if (!extraVariableDeclarations) {
                extraVariableDeclarations = [];
              }
              for (var _i = 0, _a = state.hoistedLocalVariables; _i < _a.length; _i++) {
                var identifier = _a[_i];
                extraVariableDeclarations.push(factory.createVariableDeclaration(identifier));
              }
            }
          }
          if (state.loopOutParameters.length) {
            if (!extraVariableDeclarations) {
              extraVariableDeclarations = [];
            }
            for (var _b = 0, _c = state.loopOutParameters; _b < _c.length; _b++) {
              var outParam = _c[_b];
              extraVariableDeclarations.push(factory.createVariableDeclaration(outParam.outParamName));
            }
          }
          if (state.conditionVariable) {
            if (!extraVariableDeclarations) {
              extraVariableDeclarations = [];
            }
            extraVariableDeclarations.push(factory.createVariableDeclaration(state.conditionVariable, void 0, void 0, factory.createFalse()));
          }
          if (extraVariableDeclarations) {
            statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(extraVariableDeclarations)));
          }
        }
        function createOutVariable(p) {
          return factory.createVariableDeclaration(p.originalName, void 0, void 0, p.outParamName);
        }
        function createFunctionForInitializerOfForStatement(node, currentState) {
          var functionName = factory.createUniqueName("_loop_init");
          var containsYield = (node.initializer.transformFlags & 524288) !== 0;
          var emitFlags = 0;
          if (currentState.containsLexicalThis)
            emitFlags |= 8;
          if (containsYield && hierarchyFacts & 4)
            emitFlags |= 262144;
          var statements = [];
          statements.push(factory.createVariableStatement(void 0, node.initializer));
          copyOutParameters(currentState.loopOutParameters, 2, 1, statements);
          var functionDeclaration = factory.createVariableStatement(void 0, ts3.setEmitFlags(factory.createVariableDeclarationList([
            factory.createVariableDeclaration(functionName, void 0, void 0, ts3.setEmitFlags(factory.createFunctionExpression(void 0, containsYield ? factory.createToken(41) : void 0, void 0, void 0, void 0, void 0, ts3.visitNode(factory.createBlock(statements, true), visitor, ts3.isBlock)), emitFlags))
          ]), 2097152));
          var part = factory.createVariableDeclarationList(ts3.map(currentState.loopOutParameters, createOutVariable));
          return { functionName, containsYield, functionDeclaration, part };
        }
        function createFunctionForBodyOfIterationStatement(node, currentState, outerState) {
          var functionName = factory.createUniqueName("_loop");
          startLexicalEnvironment();
          var statement = ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock);
          var lexicalEnvironment = endLexicalEnvironment();
          var statements = [];
          if (shouldConvertConditionOfForStatement(node) || shouldConvertIncrementorOfForStatement(node)) {
            currentState.conditionVariable = factory.createUniqueName("inc");
            if (node.incrementor) {
              statements.push(factory.createIfStatement(currentState.conditionVariable, factory.createExpressionStatement(ts3.visitNode(node.incrementor, visitor, ts3.isExpression)), factory.createExpressionStatement(factory.createAssignment(currentState.conditionVariable, factory.createTrue()))));
            } else {
              statements.push(factory.createIfStatement(factory.createLogicalNot(currentState.conditionVariable), factory.createExpressionStatement(factory.createAssignment(currentState.conditionVariable, factory.createTrue()))));
            }
            if (shouldConvertConditionOfForStatement(node)) {
              statements.push(factory.createIfStatement(factory.createPrefixUnaryExpression(53, ts3.visitNode(node.condition, visitor, ts3.isExpression)), ts3.visitNode(factory.createBreakStatement(), visitor, ts3.isStatement)));
            }
          }
          if (ts3.isBlock(statement)) {
            ts3.addRange(statements, statement.statements);
          } else {
            statements.push(statement);
          }
          copyOutParameters(currentState.loopOutParameters, 1, 1, statements);
          ts3.insertStatementsAfterStandardPrologue(statements, lexicalEnvironment);
          var loopBody = factory.createBlock(statements, true);
          if (ts3.isBlock(statement))
            ts3.setOriginalNode(loopBody, statement);
          var containsYield = (node.statement.transformFlags & 524288) !== 0;
          var emitFlags = 524288;
          if (currentState.containsLexicalThis)
            emitFlags |= 8;
          if (containsYield && (hierarchyFacts & 4) !== 0)
            emitFlags |= 262144;
          var functionDeclaration = factory.createVariableStatement(void 0, ts3.setEmitFlags(factory.createVariableDeclarationList([
            factory.createVariableDeclaration(functionName, void 0, void 0, ts3.setEmitFlags(factory.createFunctionExpression(void 0, containsYield ? factory.createToken(41) : void 0, void 0, void 0, currentState.loopParameters, void 0, loopBody), emitFlags))
          ]), 2097152));
          var part = generateCallToConvertedLoop(functionName, currentState, outerState, containsYield);
          return { functionName, containsYield, functionDeclaration, part };
        }
        function copyOutParameter(outParam, copyDirection) {
          var source = copyDirection === 0 ? outParam.outParamName : outParam.originalName;
          var target = copyDirection === 0 ? outParam.originalName : outParam.outParamName;
          return factory.createBinaryExpression(target, 63, source);
        }
        function copyOutParameters(outParams, partFlags, copyDirection, statements) {
          for (var _i = 0, outParams_1 = outParams; _i < outParams_1.length; _i++) {
            var outParam = outParams_1[_i];
            if (outParam.flags & partFlags) {
              statements.push(factory.createExpressionStatement(copyOutParameter(outParam, copyDirection)));
            }
          }
        }
        function generateCallToConvertedLoopInitializer(initFunctionExpressionName, containsYield) {
          var call = factory.createCallExpression(initFunctionExpressionName, void 0, []);
          var callResult = containsYield ? factory.createYieldExpression(factory.createToken(41), ts3.setEmitFlags(call, 8388608)) : call;
          return factory.createExpressionStatement(callResult);
        }
        function generateCallToConvertedLoop(loopFunctionExpressionName, state, outerState, containsYield) {
          var statements = [];
          var isSimpleLoop = !(state.nonLocalJumps & ~4) && !state.labeledNonLocalBreaks && !state.labeledNonLocalContinues;
          var call = factory.createCallExpression(loopFunctionExpressionName, void 0, ts3.map(state.loopParameters, function(p) {
            return p.name;
          }));
          var callResult = containsYield ? factory.createYieldExpression(factory.createToken(41), ts3.setEmitFlags(call, 8388608)) : call;
          if (isSimpleLoop) {
            statements.push(factory.createExpressionStatement(callResult));
            copyOutParameters(state.loopOutParameters, 1, 0, statements);
          } else {
            var loopResultName = factory.createUniqueName("state");
            var stateVariable = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([factory.createVariableDeclaration(loopResultName, void 0, void 0, callResult)]));
            statements.push(stateVariable);
            copyOutParameters(state.loopOutParameters, 1, 0, statements);
            if (state.nonLocalJumps & 8) {
              var returnStatement = void 0;
              if (outerState) {
                outerState.nonLocalJumps |= 8;
                returnStatement = factory.createReturnStatement(loopResultName);
              } else {
                returnStatement = factory.createReturnStatement(factory.createPropertyAccessExpression(loopResultName, "value"));
              }
              statements.push(factory.createIfStatement(factory.createTypeCheck(loopResultName, "object"), returnStatement));
            }
            if (state.nonLocalJumps & 2) {
              statements.push(factory.createIfStatement(factory.createStrictEquality(loopResultName, factory.createStringLiteral("break")), factory.createBreakStatement()));
            }
            if (state.labeledNonLocalBreaks || state.labeledNonLocalContinues) {
              var caseClauses = [];
              processLabeledJumps(state.labeledNonLocalBreaks, true, loopResultName, outerState, caseClauses);
              processLabeledJumps(state.labeledNonLocalContinues, false, loopResultName, outerState, caseClauses);
              statements.push(factory.createSwitchStatement(loopResultName, factory.createCaseBlock(caseClauses)));
            }
          }
          return statements;
        }
        function setLabeledJump(state, isBreak, labelText, labelMarker) {
          if (isBreak) {
            if (!state.labeledNonLocalBreaks) {
              state.labeledNonLocalBreaks = new ts3.Map();
            }
            state.labeledNonLocalBreaks.set(labelText, labelMarker);
          } else {
            if (!state.labeledNonLocalContinues) {
              state.labeledNonLocalContinues = new ts3.Map();
            }
            state.labeledNonLocalContinues.set(labelText, labelMarker);
          }
        }
        function processLabeledJumps(table, isBreak, loopResultName, outerLoop, caseClauses) {
          if (!table) {
            return;
          }
          table.forEach(function(labelMarker, labelText) {
            var statements = [];
            if (!outerLoop || outerLoop.labels && outerLoop.labels.get(labelText)) {
              var label = factory.createIdentifier(labelText);
              statements.push(isBreak ? factory.createBreakStatement(label) : factory.createContinueStatement(label));
            } else {
              setLabeledJump(outerLoop, isBreak, labelText, labelMarker);
              statements.push(factory.createReturnStatement(loopResultName));
            }
            caseClauses.push(factory.createCaseClause(factory.createStringLiteral(labelMarker), statements));
          });
        }
        function processLoopVariableDeclaration(container, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForHead) {
          var name = decl.name;
          if (ts3.isBindingPattern(name)) {
            for (var _i = 0, _a = name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts3.isOmittedExpression(element)) {
                processLoopVariableDeclaration(container, element, loopParameters, loopOutParameters, hasCapturedBindingsInForHead);
              }
            }
          } else {
            loopParameters.push(factory.createParameterDeclaration(void 0, void 0, void 0, name));
            var checkFlags = resolver.getNodeCheckFlags(decl);
            if (checkFlags & 4194304 || hasCapturedBindingsInForHead) {
              var outParamName = factory.createUniqueName("out_" + ts3.idText(name));
              var flags = 0;
              if (checkFlags & 4194304) {
                flags |= 1;
              }
              if (ts3.isForStatement(container)) {
                if (container.initializer && resolver.isBindingCapturedByNode(container.initializer, decl)) {
                  flags |= 2;
                }
                if (container.condition && resolver.isBindingCapturedByNode(container.condition, decl) || container.incrementor && resolver.isBindingCapturedByNode(container.incrementor, decl)) {
                  flags |= 1;
                }
              }
              loopOutParameters.push({ flags, originalName: name, outParamName });
            }
          }
        }
        function addObjectLiteralMembers(expressions, node, receiver, start) {
          var properties = node.properties;
          var numProperties = properties.length;
          for (var i = start; i < numProperties; i++) {
            var property = properties[i];
            switch (property.kind) {
              case 172:
              case 173:
                var accessors = ts3.getAllAccessorDeclarations(node.properties, property);
                if (property === accessors.firstAccessor) {
                  expressions.push(transformAccessorsToExpression(receiver, accessors, node, !!node.multiLine));
                }
                break;
              case 169:
                expressions.push(transformObjectLiteralMethodDeclarationToExpression(property, receiver, node, node.multiLine));
                break;
              case 296:
                expressions.push(transformPropertyAssignmentToExpression(property, receiver, node.multiLine));
                break;
              case 297:
                expressions.push(transformShorthandPropertyAssignmentToExpression(property, receiver, node.multiLine));
                break;
              default:
                ts3.Debug.failBadSyntaxKind(node);
                break;
            }
          }
        }
        function transformPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
          var expression = factory.createAssignment(ts3.createMemberAccessForPropertyName(factory, receiver, ts3.visitNode(property.name, visitor, ts3.isPropertyName)), ts3.visitNode(property.initializer, visitor, ts3.isExpression));
          ts3.setTextRange(expression, property);
          if (startsOnNewLine) {
            ts3.startOnNewLine(expression);
          }
          return expression;
        }
        function transformShorthandPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
          var expression = factory.createAssignment(ts3.createMemberAccessForPropertyName(factory, receiver, ts3.visitNode(property.name, visitor, ts3.isPropertyName)), factory.cloneNode(property.name));
          ts3.setTextRange(expression, property);
          if (startsOnNewLine) {
            ts3.startOnNewLine(expression);
          }
          return expression;
        }
        function transformObjectLiteralMethodDeclarationToExpression(method, receiver, container, startsOnNewLine) {
          var expression = factory.createAssignment(ts3.createMemberAccessForPropertyName(factory, receiver, ts3.visitNode(method.name, visitor, ts3.isPropertyName)), transformFunctionLikeToExpression(method, method, void 0, container));
          ts3.setTextRange(expression, method);
          if (startsOnNewLine) {
            ts3.startOnNewLine(expression);
          }
          return expression;
        }
        function visitCatchClause(node) {
          var ancestorFacts = enterSubtree(7104, 0);
          var updated;
          ts3.Debug.assert(!!node.variableDeclaration, "Catch clause variable should always be present when downleveling ES2015.");
          if (ts3.isBindingPattern(node.variableDeclaration.name)) {
            var temp = factory.createTempVariable(void 0);
            var newVariableDeclaration = factory.createVariableDeclaration(temp);
            ts3.setTextRange(newVariableDeclaration, node.variableDeclaration);
            var vars = ts3.flattenDestructuringBinding(node.variableDeclaration, visitor, context, 0, temp);
            var list = factory.createVariableDeclarationList(vars);
            ts3.setTextRange(list, node.variableDeclaration);
            var destructure = factory.createVariableStatement(void 0, list);
            updated = factory.updateCatchClause(node, newVariableDeclaration, addStatementToStartOfBlock(node.block, destructure));
          } else {
            updated = ts3.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function addStatementToStartOfBlock(block, statement) {
          var transformedStatements = ts3.visitNodes(block.statements, visitor, ts3.isStatement);
          return factory.updateBlock(block, __spreadArray([statement], transformedStatements, true));
        }
        function visitMethodDeclaration(node) {
          ts3.Debug.assert(!ts3.isComputedPropertyName(node.name));
          var functionExpression = transformFunctionLikeToExpression(node, ts3.moveRangePos(node, -1), void 0, void 0);
          ts3.setEmitFlags(functionExpression, 512 | ts3.getEmitFlags(functionExpression));
          return ts3.setTextRange(factory.createPropertyAssignment(node.name, functionExpression), node);
        }
        function visitAccessorDeclaration(node) {
          ts3.Debug.assert(!ts3.isComputedPropertyName(node.name));
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(32670, 65);
          var updated;
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          if (node.kind === 172) {
            updated = factory.updateGetAccessorDeclaration(node, node.decorators, node.modifiers, node.name, parameters, node.type, body);
          } else {
            updated = factory.updateSetAccessorDeclaration(node, node.decorators, node.modifiers, node.name, parameters, body);
          }
          exitSubtree(ancestorFacts, 98304, 0);
          convertedLoopState = savedConvertedLoopState;
          return updated;
        }
        function visitShorthandPropertyAssignment(node) {
          return ts3.setTextRange(factory.createPropertyAssignment(node.name, visitIdentifier(factory.cloneNode(node.name))), node);
        }
        function visitComputedPropertyName(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitArrayLiteralExpression(node) {
          if (ts3.some(node.elements, ts3.isSpreadElement)) {
            return transformAndSpreadElements(node.elements, false, !!node.multiLine, !!node.elements.hasTrailingComma);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCallExpression(node) {
          if (ts3.getEmitFlags(node) & 33554432) {
            return visitTypeScriptClassWrapper(node);
          }
          var expression = ts3.skipOuterExpressions(node.expression);
          if (expression.kind === 106 || ts3.isSuperProperty(expression) || ts3.some(node.arguments, ts3.isSpreadElement)) {
            return visitCallExpressionWithPotentialCapturedThisAssignment(node, true);
          }
          return factory.updateCallExpression(node, ts3.visitNode(node.expression, callExpressionVisitor, ts3.isExpression), void 0, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
        }
        function visitTypeScriptClassWrapper(node) {
          var body = ts3.cast(ts3.cast(ts3.skipOuterExpressions(node.expression), ts3.isArrowFunction).body, ts3.isBlock);
          var isVariableStatementWithInitializer = function(stmt) {
            return ts3.isVariableStatement(stmt) && !!ts3.first(stmt.declarationList.declarations).initializer;
          };
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var bodyStatements = ts3.visitNodes(body.statements, classWrapperStatementVisitor, ts3.isStatement);
          convertedLoopState = savedConvertedLoopState;
          var classStatements = ts3.filter(bodyStatements, isVariableStatementWithInitializer);
          var remainingStatements = ts3.filter(bodyStatements, function(stmt) {
            return !isVariableStatementWithInitializer(stmt);
          });
          var varStatement = ts3.cast(ts3.first(classStatements), ts3.isVariableStatement);
          var variable = varStatement.declarationList.declarations[0];
          var initializer = ts3.skipOuterExpressions(variable.initializer);
          var aliasAssignment = ts3.tryCast(initializer, ts3.isAssignmentExpression);
          if (!aliasAssignment && ts3.isBinaryExpression(initializer) && initializer.operatorToken.kind === 27) {
            aliasAssignment = ts3.tryCast(initializer.left, ts3.isAssignmentExpression);
          }
          var call = ts3.cast(aliasAssignment ? ts3.skipOuterExpressions(aliasAssignment.right) : initializer, ts3.isCallExpression);
          var func = ts3.cast(ts3.skipOuterExpressions(call.expression), ts3.isFunctionExpression);
          var funcStatements = func.body.statements;
          var classBodyStart = 0;
          var classBodyEnd = -1;
          var statements = [];
          if (aliasAssignment) {
            var extendsCall = ts3.tryCast(funcStatements[classBodyStart], ts3.isExpressionStatement);
            if (extendsCall) {
              statements.push(extendsCall);
              classBodyStart++;
            }
            statements.push(funcStatements[classBodyStart]);
            classBodyStart++;
            statements.push(factory.createExpressionStatement(factory.createAssignment(aliasAssignment.left, ts3.cast(variable.name, ts3.isIdentifier))));
          }
          while (!ts3.isReturnStatement(ts3.elementAt(funcStatements, classBodyEnd))) {
            classBodyEnd--;
          }
          ts3.addRange(statements, funcStatements, classBodyStart, classBodyEnd);
          if (classBodyEnd < -1) {
            ts3.addRange(statements, funcStatements, classBodyEnd + 1);
          }
          ts3.addRange(statements, remainingStatements);
          ts3.addRange(statements, classStatements, 1);
          return factory.restoreOuterExpressions(node.expression, factory.restoreOuterExpressions(variable.initializer, factory.restoreOuterExpressions(aliasAssignment && aliasAssignment.right, factory.updateCallExpression(call, factory.restoreOuterExpressions(call.expression, factory.updateFunctionExpression(func, void 0, void 0, void 0, void 0, func.parameters, void 0, factory.updateBlock(func.body, statements))), void 0, call.arguments))));
        }
        function visitSuperCallInBody(node) {
          return visitCallExpressionWithPotentialCapturedThisAssignment(node, false);
        }
        function visitCallExpressionWithPotentialCapturedThisAssignment(node, assignToCapturedThis) {
          if (node.transformFlags & 16384 || node.expression.kind === 106 || ts3.isSuperProperty(ts3.skipOuterExpressions(node.expression))) {
            var _a = factory.createCallBinding(node.expression, hoistVariableDeclaration), target = _a.target, thisArg = _a.thisArg;
            if (node.expression.kind === 106) {
              ts3.setEmitFlags(thisArg, 4);
            }
            var resultingCall = void 0;
            if (node.transformFlags & 16384) {
              resultingCall = factory.createFunctionApplyCall(ts3.visitNode(target, callExpressionVisitor, ts3.isExpression), node.expression.kind === 106 ? thisArg : ts3.visitNode(thisArg, visitor, ts3.isExpression), transformAndSpreadElements(node.arguments, true, false, false));
            } else {
              resultingCall = ts3.setTextRange(factory.createFunctionCallCall(ts3.visitNode(target, callExpressionVisitor, ts3.isExpression), node.expression.kind === 106 ? thisArg : ts3.visitNode(thisArg, visitor, ts3.isExpression), ts3.visitNodes(node.arguments, visitor, ts3.isExpression)), node);
            }
            if (node.expression.kind === 106) {
              var initializer = factory.createLogicalOr(resultingCall, createActualThis());
              resultingCall = assignToCapturedThis ? factory.createAssignment(factory.createUniqueName("_this", 16 | 32), initializer) : initializer;
            }
            return ts3.setOriginalNode(resultingCall, node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitNewExpression(node) {
          if (ts3.some(node.arguments, ts3.isSpreadElement)) {
            var _a = factory.createCallBinding(factory.createPropertyAccessExpression(node.expression, "bind"), hoistVariableDeclaration), target = _a.target, thisArg = _a.thisArg;
            return factory.createNewExpression(factory.createFunctionApplyCall(ts3.visitNode(target, visitor, ts3.isExpression), thisArg, transformAndSpreadElements(factory.createNodeArray(__spreadArray([factory.createVoidZero()], node.arguments, true)), true, false, false)), void 0, []);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndSpreadElements(elements, isArgumentList, multiLine, hasTrailingComma) {
          var numElements = elements.length;
          var segments = ts3.flatten(ts3.spanMap(elements, partitionSpread, function(partition, visitPartition, _start, end) {
            return visitPartition(partition, multiLine, hasTrailingComma && end === numElements);
          }));
          if (segments.length === 1) {
            var firstSegment = segments[0];
            if (isArgumentList && !compilerOptions.downlevelIteration || ts3.isPackedArrayLiteral(firstSegment.expression) || ts3.isCallToHelper(firstSegment.expression, "___spreadArray")) {
              return firstSegment.expression;
            }
          }
          var helpers = emitHelpers();
          var startsWithSpread = segments[0].kind !== 0;
          var expression = startsWithSpread ? factory.createArrayLiteralExpression() : segments[0].expression;
          for (var i = startsWithSpread ? 0 : 1; i < segments.length; i++) {
            var segment = segments[i];
            expression = helpers.createSpreadArrayHelper(expression, segment.expression, segment.kind === 1 && !isArgumentList);
          }
          return expression;
        }
        function partitionSpread(node) {
          return ts3.isSpreadElement(node) ? visitSpanOfSpreads : visitSpanOfNonSpreads;
        }
        function visitSpanOfSpreads(chunk) {
          return ts3.map(chunk, visitExpressionOfSpread);
        }
        function visitExpressionOfSpread(node) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var isCallToReadHelper = ts3.isCallToHelper(expression, "___read");
          var kind = isCallToReadHelper || ts3.isPackedArrayLiteral(expression) ? 2 : 1;
          if (compilerOptions.downlevelIteration && kind === 1 && !ts3.isArrayLiteralExpression(expression) && !isCallToReadHelper) {
            expression = emitHelpers().createReadHelper(expression, void 0);
            kind = 2;
          }
          return createSpreadSegment(kind, expression);
        }
        function visitSpanOfNonSpreads(chunk, multiLine, hasTrailingComma) {
          var expression = factory.createArrayLiteralExpression(ts3.visitNodes(factory.createNodeArray(chunk, hasTrailingComma), visitor, ts3.isExpression), multiLine);
          return createSpreadSegment(0, expression);
        }
        function visitSpreadElement(node) {
          return ts3.visitNode(node.expression, visitor, ts3.isExpression);
        }
        function visitTemplateLiteral(node) {
          return ts3.setTextRange(factory.createStringLiteral(node.text), node);
        }
        function visitStringLiteral(node) {
          if (node.hasExtendedUnicodeEscape) {
            return ts3.setTextRange(factory.createStringLiteral(node.text), node);
          }
          return node;
        }
        function visitNumericLiteral(node) {
          if (node.numericLiteralFlags & 384) {
            return ts3.setTextRange(factory.createNumericLiteral(node.text), node);
          }
          return node;
        }
        function visitTaggedTemplateExpression(node) {
          return ts3.processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, ts3.ProcessLevel.All);
        }
        function visitTemplateExpression(node) {
          var expression = factory.createStringLiteral(node.head.text);
          for (var _i = 0, _a = node.templateSpans; _i < _a.length; _i++) {
            var span = _a[_i];
            var args = [ts3.visitNode(span.expression, visitor, ts3.isExpression)];
            if (span.literal.text.length > 0) {
              args.push(factory.createStringLiteral(span.literal.text));
            }
            expression = factory.createCallExpression(factory.createPropertyAccessExpression(expression, "concat"), void 0, args);
          }
          return ts3.setTextRange(expression, node);
        }
        function visitSuperKeyword(isExpressionOfCall) {
          return hierarchyFacts & 8 && !isExpressionOfCall ? factory.createPropertyAccessExpression(factory.createUniqueName("_super", 16 | 32), "prototype") : factory.createUniqueName("_super", 16 | 32);
        }
        function visitMetaProperty(node) {
          if (node.keywordToken === 103 && node.name.escapedText === "target") {
            hierarchyFacts |= 32768;
            return factory.createUniqueName("_newTarget", 16 | 32);
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && ts3.isFunctionLike(node)) {
            var ancestorFacts = enterSubtree(32670, ts3.getEmitFlags(node) & 8 ? 65 | 16 : 65);
            previousOnEmitNode(hint, node, emitCallback);
            exitSubtree(ancestorFacts, 0, 0);
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function enableSubstitutionsForBlockScopedBindings() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(79);
          }
        }
        function enableSubstitutionsForCapturedThis() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(108);
            context.enableEmitNotification(171);
            context.enableEmitNotification(169);
            context.enableEmitNotification(172);
            context.enableEmitNotification(173);
            context.enableEmitNotification(214);
            context.enableEmitNotification(213);
            context.enableEmitNotification(256);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          if (ts3.isIdentifier(node)) {
            return substituteIdentifier(node);
          }
          return node;
        }
        function substituteIdentifier(node) {
          if (enabledSubstitutions & 2 && !ts3.isInternalName(node)) {
            var original = ts3.getParseTreeNode(node, ts3.isIdentifier);
            if (original && isNameOfDeclarationWithCollidingName(original)) {
              return ts3.setTextRange(factory.getGeneratedNameForNode(original), node);
            }
          }
          return node;
        }
        function isNameOfDeclarationWithCollidingName(node) {
          switch (node.parent.kind) {
            case 203:
            case 257:
            case 260:
            case 254:
              return node.parent.name === node && resolver.isDeclarationWithCollidingName(node.parent);
          }
          return false;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 79:
              return substituteExpressionIdentifier(node);
            case 108:
              return substituteThisKeyword(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (enabledSubstitutions & 2 && !ts3.isInternalName(node)) {
            var declaration = resolver.getReferencedDeclarationWithCollidingName(node);
            if (declaration && !(ts3.isClassLike(declaration) && isPartOfClassBody(declaration, node))) {
              return ts3.setTextRange(factory.getGeneratedNameForNode(ts3.getNameOfDeclaration(declaration)), node);
            }
          }
          return node;
        }
        function isPartOfClassBody(declaration, node) {
          var currentNode = ts3.getParseTreeNode(node);
          if (!currentNode || currentNode === declaration || currentNode.end <= declaration.pos || currentNode.pos >= declaration.end) {
            return false;
          }
          var blockScope = ts3.getEnclosingBlockScopeContainer(declaration);
          while (currentNode) {
            if (currentNode === blockScope || currentNode === declaration) {
              return false;
            }
            if (ts3.isClassElement(currentNode) && currentNode.parent === declaration) {
              return true;
            }
            currentNode = currentNode.parent;
          }
          return false;
        }
        function substituteThisKeyword(node) {
          if (enabledSubstitutions & 1 && hierarchyFacts & 16) {
            return ts3.setTextRange(factory.createUniqueName("_this", 16 | 32), node);
          }
          return node;
        }
        function getClassMemberPrefix(node, member) {
          return ts3.isStatic(member) ? factory.getInternalName(node) : factory.createPropertyAccessExpression(factory.getInternalName(node), "prototype");
        }
        function hasSynthesizedDefaultSuperCall(constructor, hasExtendsClause) {
          if (!constructor || !hasExtendsClause) {
            return false;
          }
          if (ts3.some(constructor.parameters)) {
            return false;
          }
          var statement = ts3.firstOrUndefined(constructor.body.statements);
          if (!statement || !ts3.nodeIsSynthesized(statement) || statement.kind !== 238) {
            return false;
          }
          var statementExpression = statement.expression;
          if (!ts3.nodeIsSynthesized(statementExpression) || statementExpression.kind !== 208) {
            return false;
          }
          var callTarget = statementExpression.expression;
          if (!ts3.nodeIsSynthesized(callTarget) || callTarget.kind !== 106) {
            return false;
          }
          var callArgument = ts3.singleOrUndefined(statementExpression.arguments);
          if (!callArgument || !ts3.nodeIsSynthesized(callArgument) || callArgument.kind !== 225) {
            return false;
          }
          var expression = callArgument.expression;
          return ts3.isIdentifier(expression) && expression.escapedText === "arguments";
        }
      }
      ts3.transformES2015 = transformES2015;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES5(context) {
        var factory = context.factory;
        var compilerOptions = context.getCompilerOptions();
        var previousOnEmitNode;
        var noSubstitution;
        if (compilerOptions.jsx === 1 || compilerOptions.jsx === 3) {
          previousOnEmitNode = context.onEmitNode;
          context.onEmitNode = onEmitNode;
          context.enableEmitNotification(280);
          context.enableEmitNotification(281);
          context.enableEmitNotification(279);
          noSubstitution = [];
        }
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableSubstitution(206);
        context.enableSubstitution(296);
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          switch (node.kind) {
            case 280:
            case 281:
            case 279:
              var tagName = node.tagName;
              noSubstitution[ts3.getOriginalNodeId(tagName)] = true;
              break;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          if (node.id && noSubstitution && noSubstitution[node.id]) {
            return previousOnSubstituteNode(hint, node);
          }
          node = previousOnSubstituteNode(hint, node);
          if (ts3.isPropertyAccessExpression(node)) {
            return substitutePropertyAccessExpression(node);
          } else if (ts3.isPropertyAssignment(node)) {
            return substitutePropertyAssignment(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (ts3.isPrivateIdentifier(node.name)) {
            return node;
          }
          var literalName = trySubstituteReservedName(node.name);
          if (literalName) {
            return ts3.setTextRange(factory.createElementAccessExpression(node.expression, literalName), node);
          }
          return node;
        }
        function substitutePropertyAssignment(node) {
          var literalName = ts3.isIdentifier(node.name) && trySubstituteReservedName(node.name);
          if (literalName) {
            return factory.updatePropertyAssignment(node, literalName, node.initializer);
          }
          return node;
        }
        function trySubstituteReservedName(name) {
          var token = name.originalKeywordKind || (ts3.nodeIsSynthesized(name) ? ts3.stringToToken(ts3.idText(name)) : void 0);
          if (token !== void 0 && token >= 81 && token <= 116) {
            return ts3.setTextRange(factory.createStringLiteralFromNode(name), name);
          }
          return void 0;
        }
      }
      ts3.transformES5 = transformES5;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var OpCode;
      (function(OpCode2) {
        OpCode2[OpCode2["Nop"] = 0] = "Nop";
        OpCode2[OpCode2["Statement"] = 1] = "Statement";
        OpCode2[OpCode2["Assign"] = 2] = "Assign";
        OpCode2[OpCode2["Break"] = 3] = "Break";
        OpCode2[OpCode2["BreakWhenTrue"] = 4] = "BreakWhenTrue";
        OpCode2[OpCode2["BreakWhenFalse"] = 5] = "BreakWhenFalse";
        OpCode2[OpCode2["Yield"] = 6] = "Yield";
        OpCode2[OpCode2["YieldStar"] = 7] = "YieldStar";
        OpCode2[OpCode2["Return"] = 8] = "Return";
        OpCode2[OpCode2["Throw"] = 9] = "Throw";
        OpCode2[OpCode2["Endfinally"] = 10] = "Endfinally";
      })(OpCode || (OpCode = {}));
      var BlockAction;
      (function(BlockAction2) {
        BlockAction2[BlockAction2["Open"] = 0] = "Open";
        BlockAction2[BlockAction2["Close"] = 1] = "Close";
      })(BlockAction || (BlockAction = {}));
      var CodeBlockKind;
      (function(CodeBlockKind2) {
        CodeBlockKind2[CodeBlockKind2["Exception"] = 0] = "Exception";
        CodeBlockKind2[CodeBlockKind2["With"] = 1] = "With";
        CodeBlockKind2[CodeBlockKind2["Switch"] = 2] = "Switch";
        CodeBlockKind2[CodeBlockKind2["Loop"] = 3] = "Loop";
        CodeBlockKind2[CodeBlockKind2["Labeled"] = 4] = "Labeled";
      })(CodeBlockKind || (CodeBlockKind = {}));
      var ExceptionBlockState;
      (function(ExceptionBlockState2) {
        ExceptionBlockState2[ExceptionBlockState2["Try"] = 0] = "Try";
        ExceptionBlockState2[ExceptionBlockState2["Catch"] = 1] = "Catch";
        ExceptionBlockState2[ExceptionBlockState2["Finally"] = 2] = "Finally";
        ExceptionBlockState2[ExceptionBlockState2["Done"] = 3] = "Done";
      })(ExceptionBlockState || (ExceptionBlockState = {}));
      var Instruction;
      (function(Instruction2) {
        Instruction2[Instruction2["Next"] = 0] = "Next";
        Instruction2[Instruction2["Throw"] = 1] = "Throw";
        Instruction2[Instruction2["Return"] = 2] = "Return";
        Instruction2[Instruction2["Break"] = 3] = "Break";
        Instruction2[Instruction2["Yield"] = 4] = "Yield";
        Instruction2[Instruction2["YieldStar"] = 5] = "YieldStar";
        Instruction2[Instruction2["Catch"] = 6] = "Catch";
        Instruction2[Instruction2["Endfinally"] = 7] = "Endfinally";
      })(Instruction || (Instruction = {}));
      function getInstructionName(instruction) {
        switch (instruction) {
          case 2:
            return "return";
          case 3:
            return "break";
          case 4:
            return "yield";
          case 5:
            return "yield*";
          case 7:
            return "endfinally";
          default:
            return void 0;
        }
      }
      function transformGenerators(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistFunctionDeclaration = context.hoistFunctionDeclaration, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var resolver = context.getEmitResolver();
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var renamedCatchVariables;
        var renamedCatchVariableDeclarations;
        var inGeneratorFunctionBody;
        var inStatementContainingYield;
        var blocks;
        var blockOffsets;
        var blockActions;
        var blockStack;
        var labelOffsets;
        var labelExpressions;
        var nextLabelId = 1;
        var operations;
        var operationArguments;
        var operationLocations;
        var state;
        var blockIndex = 0;
        var labelNumber = 0;
        var labelNumbers;
        var lastOperationWasAbrupt;
        var lastOperationWasCompletion;
        var clauses;
        var statements;
        var exceptionBlockStack;
        var currentExceptionBlock;
        var withBlockStack;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || (node.transformFlags & 2048) === 0) {
            return node;
          }
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitor(node) {
          var transformFlags = node.transformFlags;
          if (inStatementContainingYield) {
            return visitJavaScriptInStatementContainingYield(node);
          } else if (inGeneratorFunctionBody) {
            return visitJavaScriptInGeneratorFunctionBody(node);
          } else if (ts3.isFunctionLikeDeclaration(node) && node.asteriskToken) {
            return visitGenerator(node);
          } else if (transformFlags & 2048) {
            return ts3.visitEachChild(node, visitor, context);
          } else {
            return node;
          }
        }
        function visitJavaScriptInStatementContainingYield(node) {
          switch (node.kind) {
            case 240:
              return visitDoStatement(node);
            case 241:
              return visitWhileStatement(node);
            case 249:
              return visitSwitchStatement(node);
            case 250:
              return visitLabeledStatement(node);
            default:
              return visitJavaScriptInGeneratorFunctionBody(node);
          }
        }
        function visitJavaScriptInGeneratorFunctionBody(node) {
          switch (node.kind) {
            case 256:
              return visitFunctionDeclaration(node);
            case 213:
              return visitFunctionExpression(node);
            case 172:
            case 173:
              return visitAccessorDeclaration(node);
            case 237:
              return visitVariableStatement(node);
            case 242:
              return visitForStatement(node);
            case 243:
              return visitForInStatement(node);
            case 246:
              return visitBreakStatement(node);
            case 245:
              return visitContinueStatement(node);
            case 247:
              return visitReturnStatement(node);
            default:
              if (node.transformFlags & 524288) {
                return visitJavaScriptContainingYield(node);
              } else if (node.transformFlags & (2048 | 2097152)) {
                return ts3.visitEachChild(node, visitor, context);
              } else {
                return node;
              }
          }
        }
        function visitJavaScriptContainingYield(node) {
          switch (node.kind) {
            case 221:
              return visitBinaryExpression(node);
            case 351:
              return visitCommaListExpression(node);
            case 222:
              return visitConditionalExpression(node);
            case 224:
              return visitYieldExpression(node);
            case 204:
              return visitArrayLiteralExpression(node);
            case 205:
              return visitObjectLiteralExpression(node);
            case 207:
              return visitElementAccessExpression(node);
            case 208:
              return visitCallExpression(node);
            case 209:
              return visitNewExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitGenerator(node) {
          switch (node.kind) {
            case 256:
              return visitFunctionDeclaration(node);
            case 213:
              return visitFunctionExpression(node);
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function visitFunctionDeclaration(node) {
          if (node.asteriskToken) {
            node = ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionDeclaration(void 0, node.modifiers, void 0, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, transformGeneratorFunctionBody(node.body)), node), node);
          } else {
            var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
            var savedInStatementContainingYield = inStatementContainingYield;
            inGeneratorFunctionBody = false;
            inStatementContainingYield = false;
            node = ts3.visitEachChild(node, visitor, context);
            inGeneratorFunctionBody = savedInGeneratorFunctionBody;
            inStatementContainingYield = savedInStatementContainingYield;
          }
          if (inGeneratorFunctionBody) {
            hoistFunctionDeclaration(node);
            return void 0;
          } else {
            return node;
          }
        }
        function visitFunctionExpression(node) {
          if (node.asteriskToken) {
            node = ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionExpression(void 0, void 0, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, transformGeneratorFunctionBody(node.body)), node), node);
          } else {
            var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
            var savedInStatementContainingYield = inStatementContainingYield;
            inGeneratorFunctionBody = false;
            inStatementContainingYield = false;
            node = ts3.visitEachChild(node, visitor, context);
            inGeneratorFunctionBody = savedInGeneratorFunctionBody;
            inStatementContainingYield = savedInStatementContainingYield;
          }
          return node;
        }
        function visitAccessorDeclaration(node) {
          var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
          var savedInStatementContainingYield = inStatementContainingYield;
          inGeneratorFunctionBody = false;
          inStatementContainingYield = false;
          node = ts3.visitEachChild(node, visitor, context);
          inGeneratorFunctionBody = savedInGeneratorFunctionBody;
          inStatementContainingYield = savedInStatementContainingYield;
          return node;
        }
        function transformGeneratorFunctionBody(body) {
          var statements2 = [];
          var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
          var savedInStatementContainingYield = inStatementContainingYield;
          var savedBlocks = blocks;
          var savedBlockOffsets = blockOffsets;
          var savedBlockActions = blockActions;
          var savedBlockStack = blockStack;
          var savedLabelOffsets = labelOffsets;
          var savedLabelExpressions = labelExpressions;
          var savedNextLabelId = nextLabelId;
          var savedOperations = operations;
          var savedOperationArguments = operationArguments;
          var savedOperationLocations = operationLocations;
          var savedState = state;
          inGeneratorFunctionBody = true;
          inStatementContainingYield = false;
          blocks = void 0;
          blockOffsets = void 0;
          blockActions = void 0;
          blockStack = void 0;
          labelOffsets = void 0;
          labelExpressions = void 0;
          nextLabelId = 1;
          operations = void 0;
          operationArguments = void 0;
          operationLocations = void 0;
          state = factory.createTempVariable(void 0);
          resumeLexicalEnvironment();
          var statementOffset = factory.copyPrologue(body.statements, statements2, false, visitor);
          transformAndEmitStatements(body.statements, statementOffset);
          var buildResult = build();
          ts3.insertStatementsAfterStandardPrologue(statements2, endLexicalEnvironment());
          statements2.push(factory.createReturnStatement(buildResult));
          inGeneratorFunctionBody = savedInGeneratorFunctionBody;
          inStatementContainingYield = savedInStatementContainingYield;
          blocks = savedBlocks;
          blockOffsets = savedBlockOffsets;
          blockActions = savedBlockActions;
          blockStack = savedBlockStack;
          labelOffsets = savedLabelOffsets;
          labelExpressions = savedLabelExpressions;
          nextLabelId = savedNextLabelId;
          operations = savedOperations;
          operationArguments = savedOperationArguments;
          operationLocations = savedOperationLocations;
          state = savedState;
          return ts3.setTextRange(factory.createBlock(statements2, body.multiLine), body);
        }
        function visitVariableStatement(node) {
          if (node.transformFlags & 524288) {
            transformAndEmitVariableDeclarationList(node.declarationList);
            return void 0;
          } else {
            if (ts3.getEmitFlags(node) & 1048576) {
              return node;
            }
            for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              hoistVariableDeclaration(variable.name);
            }
            var variables = ts3.getInitializedVariables(node.declarationList);
            if (variables.length === 0) {
              return void 0;
            }
            return ts3.setSourceMapRange(factory.createExpressionStatement(factory.inlineExpressions(ts3.map(variables, transformInitializedVariable))), node);
          }
        }
        function visitBinaryExpression(node) {
          var assoc = ts3.getExpressionAssociativity(node);
          switch (assoc) {
            case 0:
              return visitLeftAssociativeBinaryExpression(node);
            case 1:
              return visitRightAssociativeBinaryExpression(node);
            default:
              return ts3.Debug.assertNever(assoc);
          }
        }
        function visitRightAssociativeBinaryExpression(node) {
          var left = node.left, right = node.right;
          if (containsYield(right)) {
            var target = void 0;
            switch (left.kind) {
              case 206:
                target = factory.updatePropertyAccessExpression(left, cacheExpression(ts3.visitNode(left.expression, visitor, ts3.isLeftHandSideExpression)), left.name);
                break;
              case 207:
                target = factory.updateElementAccessExpression(left, cacheExpression(ts3.visitNode(left.expression, visitor, ts3.isLeftHandSideExpression)), cacheExpression(ts3.visitNode(left.argumentExpression, visitor, ts3.isExpression)));
                break;
              default:
                target = ts3.visitNode(left, visitor, ts3.isExpression);
                break;
            }
            var operator = node.operatorToken.kind;
            if (ts3.isCompoundAssignment(operator)) {
              return ts3.setTextRange(factory.createAssignment(target, ts3.setTextRange(factory.createBinaryExpression(cacheExpression(target), ts3.getNonAssignmentOperatorForCompoundAssignment(operator), ts3.visitNode(right, visitor, ts3.isExpression)), node)), node);
            } else {
              return factory.updateBinaryExpression(node, target, node.operatorToken, ts3.visitNode(right, visitor, ts3.isExpression));
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitLeftAssociativeBinaryExpression(node) {
          if (containsYield(node.right)) {
            if (ts3.isLogicalOperator(node.operatorToken.kind)) {
              return visitLogicalBinaryExpression(node);
            } else if (node.operatorToken.kind === 27) {
              return visitCommaExpression(node);
            }
            return factory.updateBinaryExpression(node, cacheExpression(ts3.visitNode(node.left, visitor, ts3.isExpression)), node.operatorToken, ts3.visitNode(node.right, visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCommaExpression(node) {
          var pendingExpressions = [];
          visit(node.left);
          visit(node.right);
          return factory.inlineExpressions(pendingExpressions);
          function visit(node2) {
            if (ts3.isBinaryExpression(node2) && node2.operatorToken.kind === 27) {
              visit(node2.left);
              visit(node2.right);
            } else {
              if (containsYield(node2) && pendingExpressions.length > 0) {
                emitWorker(1, [factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions))]);
                pendingExpressions = [];
              }
              pendingExpressions.push(ts3.visitNode(node2, visitor, ts3.isExpression));
            }
          }
        }
        function visitCommaListExpression(node) {
          var pendingExpressions = [];
          for (var _i = 0, _a = node.elements; _i < _a.length; _i++) {
            var elem = _a[_i];
            if (ts3.isBinaryExpression(elem) && elem.operatorToken.kind === 27) {
              pendingExpressions.push(visitCommaExpression(elem));
            } else {
              if (containsYield(elem) && pendingExpressions.length > 0) {
                emitWorker(1, [factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions))]);
                pendingExpressions = [];
              }
              pendingExpressions.push(ts3.visitNode(elem, visitor, ts3.isExpression));
            }
          }
          return factory.inlineExpressions(pendingExpressions);
        }
        function visitLogicalBinaryExpression(node) {
          var resultLabel = defineLabel();
          var resultLocal = declareLocal();
          emitAssignment(resultLocal, ts3.visitNode(node.left, visitor, ts3.isExpression), node.left);
          if (node.operatorToken.kind === 55) {
            emitBreakWhenFalse(resultLabel, resultLocal, node.left);
          } else {
            emitBreakWhenTrue(resultLabel, resultLocal, node.left);
          }
          emitAssignment(resultLocal, ts3.visitNode(node.right, visitor, ts3.isExpression), node.right);
          markLabel(resultLabel);
          return resultLocal;
        }
        function visitConditionalExpression(node) {
          if (containsYield(node.whenTrue) || containsYield(node.whenFalse)) {
            var whenFalseLabel = defineLabel();
            var resultLabel = defineLabel();
            var resultLocal = declareLocal();
            emitBreakWhenFalse(whenFalseLabel, ts3.visitNode(node.condition, visitor, ts3.isExpression), node.condition);
            emitAssignment(resultLocal, ts3.visitNode(node.whenTrue, visitor, ts3.isExpression), node.whenTrue);
            emitBreak(resultLabel);
            markLabel(whenFalseLabel);
            emitAssignment(resultLocal, ts3.visitNode(node.whenFalse, visitor, ts3.isExpression), node.whenFalse);
            markLabel(resultLabel);
            return resultLocal;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          var resumeLabel = defineLabel();
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          if (node.asteriskToken) {
            var iterator = (ts3.getEmitFlags(node.expression) & 8388608) === 0 ? ts3.setTextRange(emitHelpers().createValuesHelper(expression), node) : expression;
            emitYieldStar(iterator, node);
          } else {
            emitYield(expression, node);
          }
          markLabel(resumeLabel);
          return createGeneratorResume(node);
        }
        function visitArrayLiteralExpression(node) {
          return visitElements(node.elements, void 0, void 0, node.multiLine);
        }
        function visitElements(elements, leadingElement, location, multiLine) {
          var numInitialElements = countInitialNodesWithoutYield(elements);
          var temp;
          if (numInitialElements > 0) {
            temp = declareLocal();
            var initialElements = ts3.visitNodes(elements, visitor, ts3.isExpression, 0, numInitialElements);
            emitAssignment(temp, factory.createArrayLiteralExpression(leadingElement ? __spreadArray([leadingElement], initialElements, true) : initialElements));
            leadingElement = void 0;
          }
          var expressions = ts3.reduceLeft(elements, reduceElement, [], numInitialElements);
          return temp ? factory.createArrayConcatCall(temp, [factory.createArrayLiteralExpression(expressions, multiLine)]) : ts3.setTextRange(factory.createArrayLiteralExpression(leadingElement ? __spreadArray([leadingElement], expressions, true) : expressions, multiLine), location);
          function reduceElement(expressions2, element) {
            if (containsYield(element) && expressions2.length > 0) {
              var hasAssignedTemp = temp !== void 0;
              if (!temp) {
                temp = declareLocal();
              }
              emitAssignment(temp, hasAssignedTemp ? factory.createArrayConcatCall(temp, [factory.createArrayLiteralExpression(expressions2, multiLine)]) : factory.createArrayLiteralExpression(leadingElement ? __spreadArray([leadingElement], expressions2, true) : expressions2, multiLine));
              leadingElement = void 0;
              expressions2 = [];
            }
            expressions2.push(ts3.visitNode(element, visitor, ts3.isExpression));
            return expressions2;
          }
        }
        function visitObjectLiteralExpression(node) {
          var properties = node.properties;
          var multiLine = node.multiLine;
          var numInitialProperties = countInitialNodesWithoutYield(properties);
          var temp = declareLocal();
          emitAssignment(temp, factory.createObjectLiteralExpression(ts3.visitNodes(properties, visitor, ts3.isObjectLiteralElementLike, 0, numInitialProperties), multiLine));
          var expressions = ts3.reduceLeft(properties, reduceProperty, [], numInitialProperties);
          expressions.push(multiLine ? ts3.startOnNewLine(ts3.setParent(ts3.setTextRange(factory.cloneNode(temp), temp), temp.parent)) : temp);
          return factory.inlineExpressions(expressions);
          function reduceProperty(expressions2, property) {
            if (containsYield(property) && expressions2.length > 0) {
              emitStatement(factory.createExpressionStatement(factory.inlineExpressions(expressions2)));
              expressions2 = [];
            }
            var expression = ts3.createExpressionForObjectLiteralElementLike(factory, node, property, temp);
            var visited = ts3.visitNode(expression, visitor, ts3.isExpression);
            if (visited) {
              if (multiLine) {
                ts3.startOnNewLine(visited);
              }
              expressions2.push(visited);
            }
            return expressions2;
          }
        }
        function visitElementAccessExpression(node) {
          if (containsYield(node.argumentExpression)) {
            return factory.updateElementAccessExpression(node, cacheExpression(ts3.visitNode(node.expression, visitor, ts3.isLeftHandSideExpression)), ts3.visitNode(node.argumentExpression, visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCallExpression(node) {
          if (!ts3.isImportCall(node) && ts3.forEach(node.arguments, containsYield)) {
            var _a = factory.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion, true), target = _a.target, thisArg = _a.thisArg;
            return ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionApplyCall(cacheExpression(ts3.visitNode(target, visitor, ts3.isLeftHandSideExpression)), thisArg, visitElements(node.arguments)), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitNewExpression(node) {
          if (ts3.forEach(node.arguments, containsYield)) {
            var _a = factory.createCallBinding(factory.createPropertyAccessExpression(node.expression, "bind"), hoistVariableDeclaration), target = _a.target, thisArg = _a.thisArg;
            return ts3.setOriginalNode(ts3.setTextRange(factory.createNewExpression(factory.createFunctionApplyCall(cacheExpression(ts3.visitNode(target, visitor, ts3.isExpression)), thisArg, visitElements(node.arguments, factory.createVoidZero())), void 0, []), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndEmitStatements(statements2, start) {
          if (start === void 0) {
            start = 0;
          }
          var numStatements = statements2.length;
          for (var i = start; i < numStatements; i++) {
            transformAndEmitStatement(statements2[i]);
          }
        }
        function transformAndEmitEmbeddedStatement(node) {
          if (ts3.isBlock(node)) {
            transformAndEmitStatements(node.statements);
          } else {
            transformAndEmitStatement(node);
          }
        }
        function transformAndEmitStatement(node) {
          var savedInStatementContainingYield = inStatementContainingYield;
          if (!inStatementContainingYield) {
            inStatementContainingYield = containsYield(node);
          }
          transformAndEmitStatementWorker(node);
          inStatementContainingYield = savedInStatementContainingYield;
        }
        function transformAndEmitStatementWorker(node) {
          switch (node.kind) {
            case 235:
              return transformAndEmitBlock(node);
            case 238:
              return transformAndEmitExpressionStatement(node);
            case 239:
              return transformAndEmitIfStatement(node);
            case 240:
              return transformAndEmitDoStatement(node);
            case 241:
              return transformAndEmitWhileStatement(node);
            case 242:
              return transformAndEmitForStatement(node);
            case 243:
              return transformAndEmitForInStatement(node);
            case 245:
              return transformAndEmitContinueStatement(node);
            case 246:
              return transformAndEmitBreakStatement(node);
            case 247:
              return transformAndEmitReturnStatement(node);
            case 248:
              return transformAndEmitWithStatement(node);
            case 249:
              return transformAndEmitSwitchStatement(node);
            case 250:
              return transformAndEmitLabeledStatement(node);
            case 251:
              return transformAndEmitThrowStatement(node);
            case 252:
              return transformAndEmitTryStatement(node);
            default:
              return emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitBlock(node) {
          if (containsYield(node)) {
            transformAndEmitStatements(node.statements);
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitExpressionStatement(node) {
          emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
        }
        function transformAndEmitVariableDeclarationList(node) {
          for (var _i = 0, _a = node.declarations; _i < _a.length; _i++) {
            var variable = _a[_i];
            var name = factory.cloneNode(variable.name);
            ts3.setCommentRange(name, variable.name);
            hoistVariableDeclaration(name);
          }
          var variables = ts3.getInitializedVariables(node);
          var numVariables = variables.length;
          var variablesWritten = 0;
          var pendingExpressions = [];
          while (variablesWritten < numVariables) {
            for (var i = variablesWritten; i < numVariables; i++) {
              var variable = variables[i];
              if (containsYield(variable.initializer) && pendingExpressions.length > 0) {
                break;
              }
              pendingExpressions.push(transformInitializedVariable(variable));
            }
            if (pendingExpressions.length) {
              emitStatement(factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions)));
              variablesWritten += pendingExpressions.length;
              pendingExpressions = [];
            }
          }
          return void 0;
        }
        function transformInitializedVariable(node) {
          return ts3.setSourceMapRange(factory.createAssignment(ts3.setSourceMapRange(factory.cloneNode(node.name), node.name), ts3.visitNode(node.initializer, visitor, ts3.isExpression)), node);
        }
        function transformAndEmitIfStatement(node) {
          if (containsYield(node)) {
            if (containsYield(node.thenStatement) || containsYield(node.elseStatement)) {
              var endLabel = defineLabel();
              var elseLabel = node.elseStatement ? defineLabel() : void 0;
              emitBreakWhenFalse(node.elseStatement ? elseLabel : endLabel, ts3.visitNode(node.expression, visitor, ts3.isExpression), node.expression);
              transformAndEmitEmbeddedStatement(node.thenStatement);
              if (node.elseStatement) {
                emitBreak(endLabel);
                markLabel(elseLabel);
                transformAndEmitEmbeddedStatement(node.elseStatement);
              }
              markLabel(endLabel);
            } else {
              emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
            }
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitDoStatement(node) {
          if (containsYield(node)) {
            var conditionLabel = defineLabel();
            var loopLabel = defineLabel();
            beginLoopBlock(conditionLabel);
            markLabel(loopLabel);
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(conditionLabel);
            emitBreakWhenTrue(loopLabel, ts3.visitNode(node.expression, visitor, ts3.isExpression));
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitDoStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
            node = ts3.visitEachChild(node, visitor, context);
            endLoopBlock();
            return node;
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformAndEmitWhileStatement(node) {
          if (containsYield(node)) {
            var loopLabel = defineLabel();
            var endLabel = beginLoopBlock(loopLabel);
            markLabel(loopLabel);
            emitBreakWhenFalse(endLabel, ts3.visitNode(node.expression, visitor, ts3.isExpression));
            transformAndEmitEmbeddedStatement(node.statement);
            emitBreak(loopLabel);
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitWhileStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
            node = ts3.visitEachChild(node, visitor, context);
            endLoopBlock();
            return node;
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformAndEmitForStatement(node) {
          if (containsYield(node)) {
            var conditionLabel = defineLabel();
            var incrementLabel = defineLabel();
            var endLabel = beginLoopBlock(incrementLabel);
            if (node.initializer) {
              var initializer = node.initializer;
              if (ts3.isVariableDeclarationList(initializer)) {
                transformAndEmitVariableDeclarationList(initializer);
              } else {
                emitStatement(ts3.setTextRange(factory.createExpressionStatement(ts3.visitNode(initializer, visitor, ts3.isExpression)), initializer));
              }
            }
            markLabel(conditionLabel);
            if (node.condition) {
              emitBreakWhenFalse(endLabel, ts3.visitNode(node.condition, visitor, ts3.isExpression));
            }
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(incrementLabel);
            if (node.incrementor) {
              emitStatement(ts3.setTextRange(factory.createExpressionStatement(ts3.visitNode(node.incrementor, visitor, ts3.isExpression)), node.incrementor));
            }
            emitBreak(conditionLabel);
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitForStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
          }
          var initializer = node.initializer;
          if (initializer && ts3.isVariableDeclarationList(initializer)) {
            for (var _i = 0, _a = initializer.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              hoistVariableDeclaration(variable.name);
            }
            var variables = ts3.getInitializedVariables(initializer);
            node = factory.updateForStatement(node, variables.length > 0 ? factory.inlineExpressions(ts3.map(variables, transformInitializedVariable)) : void 0, ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, visitor, context));
          } else {
            node = ts3.visitEachChild(node, visitor, context);
          }
          if (inStatementContainingYield) {
            endLoopBlock();
          }
          return node;
        }
        function transformAndEmitForInStatement(node) {
          if (containsYield(node)) {
            var keysArray = declareLocal();
            var key = declareLocal();
            var keysIndex = factory.createLoopVariable();
            var initializer = node.initializer;
            hoistVariableDeclaration(keysIndex);
            emitAssignment(keysArray, factory.createArrayLiteralExpression());
            emitStatement(factory.createForInStatement(key, ts3.visitNode(node.expression, visitor, ts3.isExpression), factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(keysArray, "push"), void 0, [key]))));
            emitAssignment(keysIndex, factory.createNumericLiteral(0));
            var conditionLabel = defineLabel();
            var incrementLabel = defineLabel();
            var endLabel = beginLoopBlock(incrementLabel);
            markLabel(conditionLabel);
            emitBreakWhenFalse(endLabel, factory.createLessThan(keysIndex, factory.createPropertyAccessExpression(keysArray, "length")));
            var variable = void 0;
            if (ts3.isVariableDeclarationList(initializer)) {
              for (var _i = 0, _a = initializer.declarations; _i < _a.length; _i++) {
                var variable_1 = _a[_i];
                hoistVariableDeclaration(variable_1.name);
              }
              variable = factory.cloneNode(initializer.declarations[0].name);
            } else {
              variable = ts3.visitNode(initializer, visitor, ts3.isExpression);
              ts3.Debug.assert(ts3.isLeftHandSideExpression(variable));
            }
            emitAssignment(variable, factory.createElementAccessExpression(keysArray, keysIndex));
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(incrementLabel);
            emitStatement(factory.createExpressionStatement(factory.createPostfixIncrement(keysIndex)));
            emitBreak(conditionLabel);
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitForInStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
          }
          var initializer = node.initializer;
          if (ts3.isVariableDeclarationList(initializer)) {
            for (var _i = 0, _a = initializer.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              hoistVariableDeclaration(variable.name);
            }
            node = factory.updateForInStatement(node, initializer.declarations[0].name, ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
          } else {
            node = ts3.visitEachChild(node, visitor, context);
          }
          if (inStatementContainingYield) {
            endLoopBlock();
          }
          return node;
        }
        function transformAndEmitContinueStatement(node) {
          var label = findContinueTarget(node.label ? ts3.idText(node.label) : void 0);
          if (label > 0) {
            emitBreak(label, node);
          } else {
            emitStatement(node);
          }
        }
        function visitContinueStatement(node) {
          if (inStatementContainingYield) {
            var label = findContinueTarget(node.label && ts3.idText(node.label));
            if (label > 0) {
              return createInlineBreak(label, node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndEmitBreakStatement(node) {
          var label = findBreakTarget(node.label ? ts3.idText(node.label) : void 0);
          if (label > 0) {
            emitBreak(label, node);
          } else {
            emitStatement(node);
          }
        }
        function visitBreakStatement(node) {
          if (inStatementContainingYield) {
            var label = findBreakTarget(node.label && ts3.idText(node.label));
            if (label > 0) {
              return createInlineBreak(label, node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndEmitReturnStatement(node) {
          emitReturn(ts3.visitNode(node.expression, visitor, ts3.isExpression), node);
        }
        function visitReturnStatement(node) {
          return createInlineReturn(ts3.visitNode(node.expression, visitor, ts3.isExpression), node);
        }
        function transformAndEmitWithStatement(node) {
          if (containsYield(node)) {
            beginWithBlock(cacheExpression(ts3.visitNode(node.expression, visitor, ts3.isExpression)));
            transformAndEmitEmbeddedStatement(node.statement);
            endWithBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitSwitchStatement(node) {
          if (containsYield(node.caseBlock)) {
            var caseBlock = node.caseBlock;
            var numClauses = caseBlock.clauses.length;
            var endLabel = beginSwitchBlock();
            var expression = cacheExpression(ts3.visitNode(node.expression, visitor, ts3.isExpression));
            var clauseLabels = [];
            var defaultClauseIndex = -1;
            for (var i = 0; i < numClauses; i++) {
              var clause = caseBlock.clauses[i];
              clauseLabels.push(defineLabel());
              if (clause.kind === 290 && defaultClauseIndex === -1) {
                defaultClauseIndex = i;
              }
            }
            var clausesWritten = 0;
            var pendingClauses = [];
            while (clausesWritten < numClauses) {
              var defaultClausesSkipped = 0;
              for (var i = clausesWritten; i < numClauses; i++) {
                var clause = caseBlock.clauses[i];
                if (clause.kind === 289) {
                  if (containsYield(clause.expression) && pendingClauses.length > 0) {
                    break;
                  }
                  pendingClauses.push(factory.createCaseClause(ts3.visitNode(clause.expression, visitor, ts3.isExpression), [
                    createInlineBreak(clauseLabels[i], clause.expression)
                  ]));
                } else {
                  defaultClausesSkipped++;
                }
              }
              if (pendingClauses.length) {
                emitStatement(factory.createSwitchStatement(expression, factory.createCaseBlock(pendingClauses)));
                clausesWritten += pendingClauses.length;
                pendingClauses = [];
              }
              if (defaultClausesSkipped > 0) {
                clausesWritten += defaultClausesSkipped;
                defaultClausesSkipped = 0;
              }
            }
            if (defaultClauseIndex >= 0) {
              emitBreak(clauseLabels[defaultClauseIndex]);
            } else {
              emitBreak(endLabel);
            }
            for (var i = 0; i < numClauses; i++) {
              markLabel(clauseLabels[i]);
              transformAndEmitStatements(caseBlock.clauses[i].statements);
            }
            endSwitchBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitSwitchStatement(node) {
          if (inStatementContainingYield) {
            beginScriptSwitchBlock();
          }
          node = ts3.visitEachChild(node, visitor, context);
          if (inStatementContainingYield) {
            endSwitchBlock();
          }
          return node;
        }
        function transformAndEmitLabeledStatement(node) {
          if (containsYield(node)) {
            beginLabeledBlock(ts3.idText(node.label));
            transformAndEmitEmbeddedStatement(node.statement);
            endLabeledBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitLabeledStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLabeledBlock(ts3.idText(node.label));
          }
          node = ts3.visitEachChild(node, visitor, context);
          if (inStatementContainingYield) {
            endLabeledBlock();
          }
          return node;
        }
        function transformAndEmitThrowStatement(node) {
          var _a;
          emitThrow(ts3.visitNode((_a = node.expression) !== null && _a !== void 0 ? _a : factory.createVoidZero(), visitor, ts3.isExpression), node);
        }
        function transformAndEmitTryStatement(node) {
          if (containsYield(node)) {
            beginExceptionBlock();
            transformAndEmitEmbeddedStatement(node.tryBlock);
            if (node.catchClause) {
              beginCatchBlock(node.catchClause.variableDeclaration);
              transformAndEmitEmbeddedStatement(node.catchClause.block);
            }
            if (node.finallyBlock) {
              beginFinallyBlock();
              transformAndEmitEmbeddedStatement(node.finallyBlock);
            }
            endExceptionBlock();
          } else {
            emitStatement(ts3.visitEachChild(node, visitor, context));
          }
        }
        function containsYield(node) {
          return !!node && (node.transformFlags & 524288) !== 0;
        }
        function countInitialNodesWithoutYield(nodes) {
          var numNodes = nodes.length;
          for (var i = 0; i < numNodes; i++) {
            if (containsYield(nodes[i])) {
              return i;
            }
          }
          return -1;
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          if (ts3.isIdentifier(node)) {
            return substituteExpressionIdentifier(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (!ts3.isGeneratedIdentifier(node) && renamedCatchVariables && renamedCatchVariables.has(ts3.idText(node))) {
            var original = ts3.getOriginalNode(node);
            if (ts3.isIdentifier(original) && original.parent) {
              var declaration = resolver.getReferencedValueDeclaration(original);
              if (declaration) {
                var name = renamedCatchVariableDeclarations[ts3.getOriginalNodeId(declaration)];
                if (name) {
                  var clone_6 = ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent);
                  ts3.setSourceMapRange(clone_6, node);
                  ts3.setCommentRange(clone_6, node);
                  return clone_6;
                }
              }
            }
          }
          return node;
        }
        function cacheExpression(node) {
          if (ts3.isGeneratedIdentifier(node) || ts3.getEmitFlags(node) & 4096) {
            return node;
          }
          var temp = factory.createTempVariable(hoistVariableDeclaration);
          emitAssignment(temp, node, node);
          return temp;
        }
        function declareLocal(name) {
          var temp = name ? factory.createUniqueName(name) : factory.createTempVariable(void 0);
          hoistVariableDeclaration(temp);
          return temp;
        }
        function defineLabel() {
          if (!labelOffsets) {
            labelOffsets = [];
          }
          var label = nextLabelId;
          nextLabelId++;
          labelOffsets[label] = -1;
          return label;
        }
        function markLabel(label) {
          ts3.Debug.assert(labelOffsets !== void 0, "No labels were defined.");
          labelOffsets[label] = operations ? operations.length : 0;
        }
        function beginBlock(block) {
          if (!blocks) {
            blocks = [];
            blockActions = [];
            blockOffsets = [];
            blockStack = [];
          }
          var index = blockActions.length;
          blockActions[index] = 0;
          blockOffsets[index] = operations ? operations.length : 0;
          blocks[index] = block;
          blockStack.push(block);
          return index;
        }
        function endBlock() {
          var block = peekBlock();
          if (block === void 0)
            return ts3.Debug.fail("beginBlock was never called.");
          var index = blockActions.length;
          blockActions[index] = 1;
          blockOffsets[index] = operations ? operations.length : 0;
          blocks[index] = block;
          blockStack.pop();
          return block;
        }
        function peekBlock() {
          return ts3.lastOrUndefined(blockStack);
        }
        function peekBlockKind() {
          var block = peekBlock();
          return block && block.kind;
        }
        function beginWithBlock(expression) {
          var startLabel = defineLabel();
          var endLabel = defineLabel();
          markLabel(startLabel);
          beginBlock({
            kind: 1,
            expression,
            startLabel,
            endLabel
          });
        }
        function endWithBlock() {
          ts3.Debug.assert(peekBlockKind() === 1);
          var block = endBlock();
          markLabel(block.endLabel);
        }
        function beginExceptionBlock() {
          var startLabel = defineLabel();
          var endLabel = defineLabel();
          markLabel(startLabel);
          beginBlock({
            kind: 0,
            state: 0,
            startLabel,
            endLabel
          });
          emitNop();
          return endLabel;
        }
        function beginCatchBlock(variable) {
          ts3.Debug.assert(peekBlockKind() === 0);
          var name;
          if (ts3.isGeneratedIdentifier(variable.name)) {
            name = variable.name;
            hoistVariableDeclaration(variable.name);
          } else {
            var text = ts3.idText(variable.name);
            name = declareLocal(text);
            if (!renamedCatchVariables) {
              renamedCatchVariables = new ts3.Map();
              renamedCatchVariableDeclarations = [];
              context.enableSubstitution(79);
            }
            renamedCatchVariables.set(text, true);
            renamedCatchVariableDeclarations[ts3.getOriginalNodeId(variable)] = name;
          }
          var exception2 = peekBlock();
          ts3.Debug.assert(exception2.state < 1);
          var endLabel = exception2.endLabel;
          emitBreak(endLabel);
          var catchLabel = defineLabel();
          markLabel(catchLabel);
          exception2.state = 1;
          exception2.catchVariable = name;
          exception2.catchLabel = catchLabel;
          emitAssignment(name, factory.createCallExpression(factory.createPropertyAccessExpression(state, "sent"), void 0, []));
          emitNop();
        }
        function beginFinallyBlock() {
          ts3.Debug.assert(peekBlockKind() === 0);
          var exception2 = peekBlock();
          ts3.Debug.assert(exception2.state < 2);
          var endLabel = exception2.endLabel;
          emitBreak(endLabel);
          var finallyLabel = defineLabel();
          markLabel(finallyLabel);
          exception2.state = 2;
          exception2.finallyLabel = finallyLabel;
        }
        function endExceptionBlock() {
          ts3.Debug.assert(peekBlockKind() === 0);
          var exception2 = endBlock();
          var state2 = exception2.state;
          if (state2 < 2) {
            emitBreak(exception2.endLabel);
          } else {
            emitEndfinally();
          }
          markLabel(exception2.endLabel);
          emitNop();
          exception2.state = 3;
        }
        function beginScriptLoopBlock() {
          beginBlock({
            kind: 3,
            isScript: true,
            breakLabel: -1,
            continueLabel: -1
          });
        }
        function beginLoopBlock(continueLabel) {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 3,
            isScript: false,
            breakLabel,
            continueLabel
          });
          return breakLabel;
        }
        function endLoopBlock() {
          ts3.Debug.assert(peekBlockKind() === 3);
          var block = endBlock();
          var breakLabel = block.breakLabel;
          if (!block.isScript) {
            markLabel(breakLabel);
          }
        }
        function beginScriptSwitchBlock() {
          beginBlock({
            kind: 2,
            isScript: true,
            breakLabel: -1
          });
        }
        function beginSwitchBlock() {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 2,
            isScript: false,
            breakLabel
          });
          return breakLabel;
        }
        function endSwitchBlock() {
          ts3.Debug.assert(peekBlockKind() === 2);
          var block = endBlock();
          var breakLabel = block.breakLabel;
          if (!block.isScript) {
            markLabel(breakLabel);
          }
        }
        function beginScriptLabeledBlock(labelText) {
          beginBlock({
            kind: 4,
            isScript: true,
            labelText,
            breakLabel: -1
          });
        }
        function beginLabeledBlock(labelText) {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 4,
            isScript: false,
            labelText,
            breakLabel
          });
        }
        function endLabeledBlock() {
          ts3.Debug.assert(peekBlockKind() === 4);
          var block = endBlock();
          if (!block.isScript) {
            markLabel(block.breakLabel);
          }
        }
        function supportsUnlabeledBreak(block) {
          return block.kind === 2 || block.kind === 3;
        }
        function supportsLabeledBreakOrContinue(block) {
          return block.kind === 4;
        }
        function supportsUnlabeledContinue(block) {
          return block.kind === 3;
        }
        function hasImmediateContainingLabeledBlock(labelText, start) {
          for (var j = start; j >= 0; j--) {
            var containingBlock = blockStack[j];
            if (supportsLabeledBreakOrContinue(containingBlock)) {
              if (containingBlock.labelText === labelText) {
                return true;
              }
            } else {
              break;
            }
          }
          return false;
        }
        function findBreakTarget(labelText) {
          if (blockStack) {
            if (labelText) {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsLabeledBreakOrContinue(block) && block.labelText === labelText) {
                  return block.breakLabel;
                } else if (supportsUnlabeledBreak(block) && hasImmediateContainingLabeledBlock(labelText, i - 1)) {
                  return block.breakLabel;
                }
              }
            } else {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsUnlabeledBreak(block)) {
                  return block.breakLabel;
                }
              }
            }
          }
          return 0;
        }
        function findContinueTarget(labelText) {
          if (blockStack) {
            if (labelText) {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsUnlabeledContinue(block) && hasImmediateContainingLabeledBlock(labelText, i - 1)) {
                  return block.continueLabel;
                }
              }
            } else {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsUnlabeledContinue(block)) {
                  return block.continueLabel;
                }
              }
            }
          }
          return 0;
        }
        function createLabel(label) {
          if (label !== void 0 && label > 0) {
            if (labelExpressions === void 0) {
              labelExpressions = [];
            }
            var expression = factory.createNumericLiteral(-1);
            if (labelExpressions[label] === void 0) {
              labelExpressions[label] = [expression];
            } else {
              labelExpressions[label].push(expression);
            }
            return expression;
          }
          return factory.createOmittedExpression();
        }
        function createInstruction(instruction) {
          var literal = factory.createNumericLiteral(instruction);
          ts3.addSyntheticTrailingComment(literal, 3, getInstructionName(instruction));
          return literal;
        }
        function createInlineBreak(label, location) {
          ts3.Debug.assertLessThan(0, label, "Invalid label");
          return ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), location);
        }
        function createInlineReturn(expression, location) {
          return ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression(expression ? [createInstruction(2), expression] : [createInstruction(2)])), location);
        }
        function createGeneratorResume(location) {
          return ts3.setTextRange(factory.createCallExpression(factory.createPropertyAccessExpression(state, "sent"), void 0, []), location);
        }
        function emitNop() {
          emitWorker(0);
        }
        function emitStatement(node) {
          if (node) {
            emitWorker(1, [node]);
          } else {
            emitNop();
          }
        }
        function emitAssignment(left, right, location) {
          emitWorker(2, [left, right], location);
        }
        function emitBreak(label, location) {
          emitWorker(3, [label], location);
        }
        function emitBreakWhenTrue(label, condition, location) {
          emitWorker(4, [label, condition], location);
        }
        function emitBreakWhenFalse(label, condition, location) {
          emitWorker(5, [label, condition], location);
        }
        function emitYieldStar(expression, location) {
          emitWorker(7, [expression], location);
        }
        function emitYield(expression, location) {
          emitWorker(6, [expression], location);
        }
        function emitReturn(expression, location) {
          emitWorker(8, [expression], location);
        }
        function emitThrow(expression, location) {
          emitWorker(9, [expression], location);
        }
        function emitEndfinally() {
          emitWorker(10);
        }
        function emitWorker(code, args, location) {
          if (operations === void 0) {
            operations = [];
            operationArguments = [];
            operationLocations = [];
          }
          if (labelOffsets === void 0) {
            markLabel(defineLabel());
          }
          var operationIndex = operations.length;
          operations[operationIndex] = code;
          operationArguments[operationIndex] = args;
          operationLocations[operationIndex] = location;
        }
        function build() {
          blockIndex = 0;
          labelNumber = 0;
          labelNumbers = void 0;
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          clauses = void 0;
          statements = void 0;
          exceptionBlockStack = void 0;
          currentExceptionBlock = void 0;
          withBlockStack = void 0;
          var buildResult = buildStatements();
          return emitHelpers().createGeneratorHelper(ts3.setEmitFlags(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, state)], void 0, factory.createBlock(buildResult, buildResult.length > 0)), 524288));
        }
        function buildStatements() {
          if (operations) {
            for (var operationIndex = 0; operationIndex < operations.length; operationIndex++) {
              writeOperation(operationIndex);
            }
            flushFinalLabel(operations.length);
          } else {
            flushFinalLabel(0);
          }
          if (clauses) {
            var labelExpression = factory.createPropertyAccessExpression(state, "label");
            var switchStatement = factory.createSwitchStatement(labelExpression, factory.createCaseBlock(clauses));
            return [ts3.startOnNewLine(switchStatement)];
          }
          if (statements) {
            return statements;
          }
          return [];
        }
        function flushLabel() {
          if (!statements) {
            return;
          }
          appendLabel(!lastOperationWasAbrupt);
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          labelNumber++;
        }
        function flushFinalLabel(operationIndex) {
          if (isFinalLabelReachable(operationIndex)) {
            tryEnterLabel(operationIndex);
            withBlockStack = void 0;
            writeReturn(void 0, void 0);
          }
          if (statements && clauses) {
            appendLabel(false);
          }
          updateLabelExpressions();
        }
        function isFinalLabelReachable(operationIndex) {
          if (!lastOperationWasCompletion) {
            return true;
          }
          if (!labelOffsets || !labelExpressions) {
            return false;
          }
          for (var label = 0; label < labelOffsets.length; label++) {
            if (labelOffsets[label] === operationIndex && labelExpressions[label]) {
              return true;
            }
          }
          return false;
        }
        function appendLabel(markLabelEnd) {
          if (!clauses) {
            clauses = [];
          }
          if (statements) {
            if (withBlockStack) {
              for (var i = withBlockStack.length - 1; i >= 0; i--) {
                var withBlock = withBlockStack[i];
                statements = [factory.createWithStatement(withBlock.expression, factory.createBlock(statements))];
              }
            }
            if (currentExceptionBlock) {
              var startLabel = currentExceptionBlock.startLabel, catchLabel = currentExceptionBlock.catchLabel, finallyLabel = currentExceptionBlock.finallyLabel, endLabel = currentExceptionBlock.endLabel;
              statements.unshift(factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(factory.createPropertyAccessExpression(state, "trys"), "push"), void 0, [
                factory.createArrayLiteralExpression([
                  createLabel(startLabel),
                  createLabel(catchLabel),
                  createLabel(finallyLabel),
                  createLabel(endLabel)
                ])
              ])));
              currentExceptionBlock = void 0;
            }
            if (markLabelEnd) {
              statements.push(factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(state, "label"), factory.createNumericLiteral(labelNumber + 1))));
            }
          }
          clauses.push(factory.createCaseClause(factory.createNumericLiteral(labelNumber), statements || []));
          statements = void 0;
        }
        function tryEnterLabel(operationIndex) {
          if (!labelOffsets) {
            return;
          }
          for (var label = 0; label < labelOffsets.length; label++) {
            if (labelOffsets[label] === operationIndex) {
              flushLabel();
              if (labelNumbers === void 0) {
                labelNumbers = [];
              }
              if (labelNumbers[labelNumber] === void 0) {
                labelNumbers[labelNumber] = [label];
              } else {
                labelNumbers[labelNumber].push(label);
              }
            }
          }
        }
        function updateLabelExpressions() {
          if (labelExpressions !== void 0 && labelNumbers !== void 0) {
            for (var labelNumber_1 = 0; labelNumber_1 < labelNumbers.length; labelNumber_1++) {
              var labels = labelNumbers[labelNumber_1];
              if (labels !== void 0) {
                for (var _i = 0, labels_1 = labels; _i < labels_1.length; _i++) {
                  var label = labels_1[_i];
                  var expressions = labelExpressions[label];
                  if (expressions !== void 0) {
                    for (var _a = 0, expressions_1 = expressions; _a < expressions_1.length; _a++) {
                      var expression = expressions_1[_a];
                      expression.text = String(labelNumber_1);
                    }
                  }
                }
              }
            }
          }
        }
        function tryEnterOrLeaveBlock(operationIndex) {
          if (blocks) {
            for (; blockIndex < blockActions.length && blockOffsets[blockIndex] <= operationIndex; blockIndex++) {
              var block = blocks[blockIndex];
              var blockAction = blockActions[blockIndex];
              switch (block.kind) {
                case 0:
                  if (blockAction === 0) {
                    if (!exceptionBlockStack) {
                      exceptionBlockStack = [];
                    }
                    if (!statements) {
                      statements = [];
                    }
                    exceptionBlockStack.push(currentExceptionBlock);
                    currentExceptionBlock = block;
                  } else if (blockAction === 1) {
                    currentExceptionBlock = exceptionBlockStack.pop();
                  }
                  break;
                case 1:
                  if (blockAction === 0) {
                    if (!withBlockStack) {
                      withBlockStack = [];
                    }
                    withBlockStack.push(block);
                  } else if (blockAction === 1) {
                    withBlockStack.pop();
                  }
                  break;
              }
            }
          }
        }
        function writeOperation(operationIndex) {
          tryEnterLabel(operationIndex);
          tryEnterOrLeaveBlock(operationIndex);
          if (lastOperationWasAbrupt) {
            return;
          }
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          var opcode = operations[operationIndex];
          if (opcode === 0) {
            return;
          } else if (opcode === 10) {
            return writeEndfinally();
          }
          var args = operationArguments[operationIndex];
          if (opcode === 1) {
            return writeStatement(args[0]);
          }
          var location = operationLocations[operationIndex];
          switch (opcode) {
            case 2:
              return writeAssign(args[0], args[1], location);
            case 3:
              return writeBreak(args[0], location);
            case 4:
              return writeBreakWhenTrue(args[0], args[1], location);
            case 5:
              return writeBreakWhenFalse(args[0], args[1], location);
            case 6:
              return writeYield(args[0], location);
            case 7:
              return writeYieldStar(args[0], location);
            case 8:
              return writeReturn(args[0], location);
            case 9:
              return writeThrow(args[0], location);
          }
        }
        function writeStatement(statement) {
          if (statement) {
            if (!statements) {
              statements = [statement];
            } else {
              statements.push(statement);
            }
          }
        }
        function writeAssign(left, right, operationLocation) {
          writeStatement(ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(left, right)), operationLocation));
        }
        function writeThrow(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          lastOperationWasCompletion = true;
          writeStatement(ts3.setTextRange(factory.createThrowStatement(expression), operationLocation));
        }
        function writeReturn(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          lastOperationWasCompletion = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression(expression ? [createInstruction(2), expression] : [createInstruction(2)])), operationLocation), 384));
        }
        function writeBreak(label, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384));
        }
        function writeBreakWhenTrue(label, condition, operationLocation) {
          writeStatement(ts3.setEmitFlags(factory.createIfStatement(condition, ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384)), 1));
        }
        function writeBreakWhenFalse(label, condition, operationLocation) {
          writeStatement(ts3.setEmitFlags(factory.createIfStatement(factory.createLogicalNot(condition), ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384)), 1));
        }
        function writeYield(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression(expression ? [createInstruction(4), expression] : [createInstruction(4)])), operationLocation), 384));
        }
        function writeYieldStar(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(5),
            expression
          ])), operationLocation), 384));
        }
        function writeEndfinally() {
          lastOperationWasAbrupt = true;
          writeStatement(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(7)
          ])));
        }
      }
      ts3.transformGenerators = transformGenerators;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformModule(context) {
        function getTransformModuleDelegate(moduleKind2) {
          switch (moduleKind2) {
            case ts3.ModuleKind.AMD:
              return transformAMDModule;
            case ts3.ModuleKind.UMD:
              return transformUMDModule;
            default:
              return transformCommonJSModule;
          }
        }
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, startLexicalEnvironment = context.startLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var host = context.getEmitHost();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(208);
        context.enableSubstitution(210);
        context.enableSubstitution(79);
        context.enableSubstitution(221);
        context.enableSubstitution(297);
        context.enableEmitNotification(305);
        var moduleInfoMap = [];
        var deferredExports = [];
        var currentSourceFile;
        var currentModuleInfo;
        var noSubstitution = [];
        var needUMDDynamicImportHelper;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || !(ts3.isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 4194304 || ts3.isJsonSourceFile(node) && ts3.hasJsonModuleEmitEnabled(compilerOptions) && ts3.outFile(compilerOptions))) {
            return node;
          }
          currentSourceFile = node;
          currentModuleInfo = ts3.collectExternalModuleInfo(context, node, resolver, compilerOptions);
          moduleInfoMap[ts3.getOriginalNodeId(node)] = currentModuleInfo;
          var transformModule2 = getTransformModuleDelegate(moduleKind);
          var updated = transformModule2(node);
          currentSourceFile = void 0;
          currentModuleInfo = void 0;
          needUMDDynamicImportHelper = false;
          return updated;
        }
        function shouldEmitUnderscoreUnderscoreESModule() {
          if (!currentModuleInfo.exportEquals && ts3.isExternalModule(currentSourceFile)) {
            return true;
          }
          return false;
        }
        function transformCommonJSModule(node) {
          startLexicalEnvironment();
          var statements = [];
          var ensureUseStrict = ts3.getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && ts3.isExternalModule(currentSourceFile);
          var statementOffset = factory.copyPrologue(node.statements, statements, ensureUseStrict && !ts3.isJsonSourceFile(node), topLevelVisitor);
          if (shouldEmitUnderscoreUnderscoreESModule()) {
            ts3.append(statements, createUnderscoreUnderscoreESModule());
          }
          if (ts3.length(currentModuleInfo.exportedNames)) {
            var chunkSize = 50;
            for (var i = 0; i < currentModuleInfo.exportedNames.length; i += chunkSize) {
              ts3.append(statements, factory.createExpressionStatement(ts3.reduceLeft(currentModuleInfo.exportedNames.slice(i, i + chunkSize), function(prev, nextId) {
                return factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.createIdentifier(ts3.idText(nextId))), prev);
              }, factory.createVoidZero())));
            }
          }
          ts3.append(statements, ts3.visitNode(currentModuleInfo.externalHelpersImportDeclaration, topLevelVisitor, ts3.isStatement));
          ts3.addRange(statements, ts3.visitNodes(node.statements, topLevelVisitor, ts3.isStatement, statementOffset));
          addExportEqualsIfNeeded(statements, false);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var updated = factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray(statements), node.statements));
          ts3.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function transformAMDModule(node) {
          var define2 = factory.createIdentifier("define");
          var moduleName = ts3.tryGetModuleNameFromFile(factory, node, host, compilerOptions);
          var jsonSourceFile = ts3.isJsonSourceFile(node) && node;
          var _a = collectAsynchronousDependencies(node, true), aliasedModuleNames = _a.aliasedModuleNames, unaliasedModuleNames = _a.unaliasedModuleNames, importAliasNames = _a.importAliasNames;
          var updated = factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray([
            factory.createExpressionStatement(factory.createCallExpression(define2, void 0, __spreadArray(__spreadArray([], moduleName ? [moduleName] : [], true), [
              factory.createArrayLiteralExpression(jsonSourceFile ? ts3.emptyArray : __spreadArray(__spreadArray([
                factory.createStringLiteral("require"),
                factory.createStringLiteral("exports")
              ], aliasedModuleNames, true), unaliasedModuleNames, true)),
              jsonSourceFile ? jsonSourceFile.statements.length ? jsonSourceFile.statements[0].expression : factory.createObjectLiteralExpression() : factory.createFunctionExpression(void 0, void 0, void 0, void 0, __spreadArray([
                factory.createParameterDeclaration(void 0, void 0, void 0, "require"),
                factory.createParameterDeclaration(void 0, void 0, void 0, "exports")
              ], importAliasNames, true), void 0, transformAsynchronousModuleBody(node))
            ], false)))
          ]), node.statements));
          ts3.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function transformUMDModule(node) {
          var _a = collectAsynchronousDependencies(node, false), aliasedModuleNames = _a.aliasedModuleNames, unaliasedModuleNames = _a.unaliasedModuleNames, importAliasNames = _a.importAliasNames;
          var moduleName = ts3.tryGetModuleNameFromFile(factory, node, host, compilerOptions);
          var umdHeader = factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, "factory")], void 0, ts3.setTextRange(factory.createBlock([
            factory.createIfStatement(factory.createLogicalAnd(factory.createTypeCheck(factory.createIdentifier("module"), "object"), factory.createTypeCheck(factory.createPropertyAccessExpression(factory.createIdentifier("module"), "exports"), "object")), factory.createBlock([
              factory.createVariableStatement(void 0, [
                factory.createVariableDeclaration("v", void 0, void 0, factory.createCallExpression(factory.createIdentifier("factory"), void 0, [
                  factory.createIdentifier("require"),
                  factory.createIdentifier("exports")
                ]))
              ]),
              ts3.setEmitFlags(factory.createIfStatement(factory.createStrictInequality(factory.createIdentifier("v"), factory.createIdentifier("undefined")), factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("module"), "exports"), factory.createIdentifier("v")))), 1)
            ]), factory.createIfStatement(factory.createLogicalAnd(factory.createTypeCheck(factory.createIdentifier("define"), "function"), factory.createPropertyAccessExpression(factory.createIdentifier("define"), "amd")), factory.createBlock([
              factory.createExpressionStatement(factory.createCallExpression(factory.createIdentifier("define"), void 0, __spreadArray(__spreadArray([], moduleName ? [moduleName] : [], true), [
                factory.createArrayLiteralExpression(__spreadArray(__spreadArray([
                  factory.createStringLiteral("require"),
                  factory.createStringLiteral("exports")
                ], aliasedModuleNames, true), unaliasedModuleNames, true)),
                factory.createIdentifier("factory")
              ], false)))
            ])))
          ], true), void 0));
          var updated = factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray([
            factory.createExpressionStatement(factory.createCallExpression(umdHeader, void 0, [
              factory.createFunctionExpression(void 0, void 0, void 0, void 0, __spreadArray([
                factory.createParameterDeclaration(void 0, void 0, void 0, "require"),
                factory.createParameterDeclaration(void 0, void 0, void 0, "exports")
              ], importAliasNames, true), void 0, transformAsynchronousModuleBody(node))
            ]))
          ]), node.statements));
          ts3.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function collectAsynchronousDependencies(node, includeNonAmdDependencies) {
          var aliasedModuleNames = [];
          var unaliasedModuleNames = [];
          var importAliasNames = [];
          for (var _i = 0, _a = node.amdDependencies; _i < _a.length; _i++) {
            var amdDependency = _a[_i];
            if (amdDependency.name) {
              aliasedModuleNames.push(factory.createStringLiteral(amdDependency.path));
              importAliasNames.push(factory.createParameterDeclaration(void 0, void 0, void 0, amdDependency.name));
            } else {
              unaliasedModuleNames.push(factory.createStringLiteral(amdDependency.path));
            }
          }
          for (var _b = 0, _c = currentModuleInfo.externalImports; _b < _c.length; _b++) {
            var importNode = _c[_b];
            var externalModuleName = ts3.getExternalModuleNameLiteral(factory, importNode, currentSourceFile, host, resolver, compilerOptions);
            var importAliasName = ts3.getLocalNameForExternalImport(factory, importNode, currentSourceFile);
            if (externalModuleName) {
              if (includeNonAmdDependencies && importAliasName) {
                ts3.setEmitFlags(importAliasName, 4);
                aliasedModuleNames.push(externalModuleName);
                importAliasNames.push(factory.createParameterDeclaration(void 0, void 0, void 0, importAliasName));
              } else {
                unaliasedModuleNames.push(externalModuleName);
              }
            }
          }
          return { aliasedModuleNames, unaliasedModuleNames, importAliasNames };
        }
        function getAMDImportExpressionForImport(node) {
          if (ts3.isImportEqualsDeclaration(node) || ts3.isExportDeclaration(node) || !ts3.getExternalModuleNameLiteral(factory, node, currentSourceFile, host, resolver, compilerOptions)) {
            return void 0;
          }
          var name = ts3.getLocalNameForExternalImport(factory, node, currentSourceFile);
          var expr = getHelperExpressionForImport(node, name);
          if (expr === name) {
            return void 0;
          }
          return factory.createExpressionStatement(factory.createAssignment(name, expr));
        }
        function transformAsynchronousModuleBody(node) {
          startLexicalEnvironment();
          var statements = [];
          var statementOffset = factory.copyPrologue(node.statements, statements, !compilerOptions.noImplicitUseStrict, topLevelVisitor);
          if (shouldEmitUnderscoreUnderscoreESModule()) {
            ts3.append(statements, createUnderscoreUnderscoreESModule());
          }
          if (ts3.length(currentModuleInfo.exportedNames)) {
            ts3.append(statements, factory.createExpressionStatement(ts3.reduceLeft(currentModuleInfo.exportedNames, function(prev, nextId) {
              return factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.createIdentifier(ts3.idText(nextId))), prev);
            }, factory.createVoidZero())));
          }
          ts3.append(statements, ts3.visitNode(currentModuleInfo.externalHelpersImportDeclaration, topLevelVisitor, ts3.isStatement));
          if (moduleKind === ts3.ModuleKind.AMD) {
            ts3.addRange(statements, ts3.mapDefined(currentModuleInfo.externalImports, getAMDImportExpressionForImport));
          }
          ts3.addRange(statements, ts3.visitNodes(node.statements, topLevelVisitor, ts3.isStatement, statementOffset));
          addExportEqualsIfNeeded(statements, true);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var body = factory.createBlock(statements, true);
          if (needUMDDynamicImportHelper) {
            ts3.addEmitHelper(body, dynamicImportUMDHelper);
          }
          return body;
        }
        function addExportEqualsIfNeeded(statements, emitAsReturn) {
          if (currentModuleInfo.exportEquals) {
            var expressionResult = ts3.visitNode(currentModuleInfo.exportEquals.expression, visitor);
            if (expressionResult) {
              if (emitAsReturn) {
                var statement = factory.createReturnStatement(expressionResult);
                ts3.setTextRange(statement, currentModuleInfo.exportEquals);
                ts3.setEmitFlags(statement, 384 | 1536);
                statements.push(statement);
              } else {
                var statement = factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("module"), "exports"), expressionResult));
                ts3.setTextRange(statement, currentModuleInfo.exportEquals);
                ts3.setEmitFlags(statement, 1536);
                statements.push(statement);
              }
            }
          }
        }
        function topLevelVisitor(node) {
          switch (node.kind) {
            case 266:
              return visitImportDeclaration(node);
            case 265:
              return visitImportEqualsDeclaration(node);
            case 272:
              return visitExportDeclaration(node);
            case 271:
              return visitExportAssignment(node);
            case 237:
              return visitVariableStatement(node);
            case 256:
              return visitFunctionDeclaration(node);
            case 257:
              return visitClassDeclaration(node);
            case 352:
              return visitMergeDeclarationMarker(node);
            case 353:
              return visitEndOfDeclarationMarker(node);
            default:
              return visitor(node);
          }
        }
        function visitorWorker(node, valueIsDiscarded) {
          if (!(node.transformFlags & (4194304 | 4096 | 67108864))) {
            return node;
          }
          switch (node.kind) {
            case 242:
              return visitForStatement(node);
            case 238:
              return visitExpressionStatement(node);
            case 212:
              return visitParenthesizedExpression(node, valueIsDiscarded);
            case 350:
              return visitPartiallyEmittedExpression(node, valueIsDiscarded);
            case 208:
              if (ts3.isImportCall(node) && currentSourceFile.impliedNodeFormat === void 0) {
                return visitImportCallExpression(node);
              }
              break;
            case 221:
              if (ts3.isDestructuringAssignment(node)) {
                return visitDestructuringAssignment(node, valueIsDiscarded);
              }
              break;
            case 219:
            case 220:
              return visitPreOrPostfixUnaryExpression(node, valueIsDiscarded);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          return visitorWorker(node, false);
        }
        function discardedValueVisitor(node) {
          return visitorWorker(node, true);
        }
        function destructuringNeedsFlattening(node) {
          if (ts3.isObjectLiteralExpression(node)) {
            for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
              var elem = _a[_i];
              switch (elem.kind) {
                case 296:
                  if (destructuringNeedsFlattening(elem.initializer)) {
                    return true;
                  }
                  break;
                case 297:
                  if (destructuringNeedsFlattening(elem.name)) {
                    return true;
                  }
                  break;
                case 298:
                  if (destructuringNeedsFlattening(elem.expression)) {
                    return true;
                  }
                  break;
                case 169:
                case 172:
                case 173:
                  return false;
                default:
                  ts3.Debug.assertNever(elem, "Unhandled object member kind");
              }
            }
          } else if (ts3.isArrayLiteralExpression(node)) {
            for (var _b = 0, _c = node.elements; _b < _c.length; _b++) {
              var elem = _c[_b];
              if (ts3.isSpreadElement(elem)) {
                if (destructuringNeedsFlattening(elem.expression)) {
                  return true;
                }
              } else if (destructuringNeedsFlattening(elem)) {
                return true;
              }
            }
          } else if (ts3.isIdentifier(node)) {
            return ts3.length(getExports(node)) > (ts3.isExportName(node) ? 1 : 0);
          }
          return false;
        }
        function visitDestructuringAssignment(node, valueIsDiscarded) {
          if (destructuringNeedsFlattening(node.left)) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 0, !valueIsDiscarded, createAllExportExpressions);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          return factory.updateForStatement(node, ts3.visitNode(node.initializer, discardedValueVisitor, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, discardedValueVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, visitor, context));
        }
        function visitExpressionStatement(node) {
          return factory.updateExpressionStatement(node, ts3.visitNode(node.expression, discardedValueVisitor, ts3.isExpression));
        }
        function visitParenthesizedExpression(node, valueIsDiscarded) {
          return factory.updateParenthesizedExpression(node, ts3.visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, ts3.isExpression));
        }
        function visitPartiallyEmittedExpression(node, valueIsDiscarded) {
          return factory.updatePartiallyEmittedExpression(node, ts3.visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, ts3.isExpression));
        }
        function visitPreOrPostfixUnaryExpression(node, valueIsDiscarded) {
          if ((node.operator === 45 || node.operator === 46) && ts3.isIdentifier(node.operand) && !ts3.isGeneratedIdentifier(node.operand) && !ts3.isLocalName(node.operand) && !ts3.isDeclarationNameOfEnumOrNamespace(node.operand)) {
            var exportedNames = getExports(node.operand);
            if (exportedNames) {
              var temp = void 0;
              var expression = ts3.visitNode(node.operand, visitor, ts3.isExpression);
              if (ts3.isPrefixUnaryExpression(node)) {
                expression = factory.updatePrefixUnaryExpression(node, expression);
              } else {
                expression = factory.updatePostfixUnaryExpression(node, expression);
                if (!valueIsDiscarded) {
                  temp = factory.createTempVariable(hoistVariableDeclaration);
                  expression = factory.createAssignment(temp, expression);
                  ts3.setTextRange(expression, node);
                }
                expression = factory.createComma(expression, factory.cloneNode(node.operand));
                ts3.setTextRange(expression, node);
              }
              for (var _i = 0, exportedNames_1 = exportedNames; _i < exportedNames_1.length; _i++) {
                var exportName = exportedNames_1[_i];
                noSubstitution[ts3.getNodeId(expression)] = true;
                expression = createExportExpression(exportName, expression);
                ts3.setTextRange(expression, node);
              }
              if (temp) {
                noSubstitution[ts3.getNodeId(expression)] = true;
                expression = factory.createComma(expression, temp);
                ts3.setTextRange(expression, node);
              }
              return expression;
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitImportCallExpression(node) {
          var externalModuleName = ts3.getExternalModuleNameLiteral(factory, node, currentSourceFile, host, resolver, compilerOptions);
          var firstArgument = ts3.visitNode(ts3.firstOrUndefined(node.arguments), visitor);
          var argument = externalModuleName && (!firstArgument || !ts3.isStringLiteral(firstArgument) || firstArgument.text !== externalModuleName.text) ? externalModuleName : firstArgument;
          var containsLexicalThis = !!(node.transformFlags & 8192);
          switch (compilerOptions.module) {
            case ts3.ModuleKind.AMD:
              return createImportCallExpressionAMD(argument, containsLexicalThis);
            case ts3.ModuleKind.UMD:
              return createImportCallExpressionUMD(argument !== null && argument !== void 0 ? argument : factory.createVoidZero(), containsLexicalThis);
            case ts3.ModuleKind.CommonJS:
            default:
              return createImportCallExpressionCommonJS(argument, containsLexicalThis);
          }
        }
        function createImportCallExpressionUMD(arg, containsLexicalThis) {
          needUMDDynamicImportHelper = true;
          if (ts3.isSimpleCopiableExpression(arg)) {
            var argClone = ts3.isGeneratedIdentifier(arg) ? arg : ts3.isStringLiteral(arg) ? factory.createStringLiteralFromNode(arg) : ts3.setEmitFlags(ts3.setTextRange(factory.cloneNode(arg), arg), 1536);
            return factory.createConditionalExpression(factory.createIdentifier("__syncRequire"), void 0, createImportCallExpressionCommonJS(arg, containsLexicalThis), void 0, createImportCallExpressionAMD(argClone, containsLexicalThis));
          } else {
            var temp = factory.createTempVariable(hoistVariableDeclaration);
            return factory.createComma(factory.createAssignment(temp, arg), factory.createConditionalExpression(factory.createIdentifier("__syncRequire"), void 0, createImportCallExpressionCommonJS(temp, containsLexicalThis), void 0, createImportCallExpressionAMD(temp, containsLexicalThis)));
          }
        }
        function createImportCallExpressionAMD(arg, containsLexicalThis) {
          var resolve = factory.createUniqueName("resolve");
          var reject = factory.createUniqueName("reject");
          var parameters = [
            factory.createParameterDeclaration(void 0, void 0, void 0, resolve),
            factory.createParameterDeclaration(void 0, void 0, void 0, reject)
          ];
          var body = factory.createBlock([
            factory.createExpressionStatement(factory.createCallExpression(factory.createIdentifier("require"), void 0, [factory.createArrayLiteralExpression([arg || factory.createOmittedExpression()]), resolve, reject]))
          ]);
          var func;
          if (languageVersion >= 2) {
            func = factory.createArrowFunction(void 0, void 0, parameters, void 0, void 0, body);
          } else {
            func = factory.createFunctionExpression(void 0, void 0, void 0, void 0, parameters, void 0, body);
            if (containsLexicalThis) {
              ts3.setEmitFlags(func, 8);
            }
          }
          var promise = factory.createNewExpression(factory.createIdentifier("Promise"), void 0, [func]);
          if (ts3.getESModuleInterop(compilerOptions)) {
            return factory.createCallExpression(factory.createPropertyAccessExpression(promise, factory.createIdentifier("then")), void 0, [emitHelpers().createImportStarCallbackHelper()]);
          }
          return promise;
        }
        function createImportCallExpressionCommonJS(arg, containsLexicalThis) {
          var promiseResolveCall = factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Promise"), "resolve"), void 0, []);
          var requireCall = factory.createCallExpression(factory.createIdentifier("require"), void 0, arg ? [arg] : []);
          if (ts3.getESModuleInterop(compilerOptions)) {
            requireCall = emitHelpers().createImportStarHelper(requireCall);
          }
          var func;
          if (languageVersion >= 2) {
            func = factory.createArrowFunction(void 0, void 0, [], void 0, void 0, requireCall);
          } else {
            func = factory.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, factory.createBlock([factory.createReturnStatement(requireCall)]));
            if (containsLexicalThis) {
              ts3.setEmitFlags(func, 8);
            }
          }
          return factory.createCallExpression(factory.createPropertyAccessExpression(promiseResolveCall, "then"), void 0, [func]);
        }
        function getHelperExpressionForExport(node, innerExpr) {
          if (!ts3.getESModuleInterop(compilerOptions) || ts3.getEmitFlags(node) & 67108864) {
            return innerExpr;
          }
          if (ts3.getExportNeedsImportStarHelper(node)) {
            return emitHelpers().createImportStarHelper(innerExpr);
          }
          return innerExpr;
        }
        function getHelperExpressionForImport(node, innerExpr) {
          if (!ts3.getESModuleInterop(compilerOptions) || ts3.getEmitFlags(node) & 67108864) {
            return innerExpr;
          }
          if (ts3.getImportNeedsImportStarHelper(node)) {
            return emitHelpers().createImportStarHelper(innerExpr);
          }
          if (ts3.getImportNeedsImportDefaultHelper(node)) {
            return emitHelpers().createImportDefaultHelper(innerExpr);
          }
          return innerExpr;
        }
        function visitImportDeclaration(node) {
          var statements;
          var namespaceDeclaration = ts3.getNamespaceDeclarationNode(node);
          if (moduleKind !== ts3.ModuleKind.AMD) {
            if (!node.importClause) {
              return ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createRequireCall(node)), node), node);
            } else {
              var variables = [];
              if (namespaceDeclaration && !ts3.isDefaultImport(node)) {
                variables.push(factory.createVariableDeclaration(factory.cloneNode(namespaceDeclaration.name), void 0, void 0, getHelperExpressionForImport(node, createRequireCall(node))));
              } else {
                variables.push(factory.createVariableDeclaration(factory.getGeneratedNameForNode(node), void 0, void 0, getHelperExpressionForImport(node, createRequireCall(node))));
                if (namespaceDeclaration && ts3.isDefaultImport(node)) {
                  variables.push(factory.createVariableDeclaration(factory.cloneNode(namespaceDeclaration.name), void 0, void 0, factory.getGeneratedNameForNode(node)));
                }
              }
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(variables, languageVersion >= 2 ? 2 : 0)), node), node));
            }
          } else if (namespaceDeclaration && ts3.isDefaultImport(node)) {
            statements = ts3.append(statements, factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              ts3.setOriginalNode(ts3.setTextRange(factory.createVariableDeclaration(factory.cloneNode(namespaceDeclaration.name), void 0, void 0, factory.getGeneratedNameForNode(node)), node), node)
            ], languageVersion >= 2 ? 2 : 0)));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function createRequireCall(importNode) {
          var moduleName = ts3.getExternalModuleNameLiteral(factory, importNode, currentSourceFile, host, resolver, compilerOptions);
          var args = [];
          if (moduleName) {
            args.push(moduleName);
          }
          return factory.createCallExpression(factory.createIdentifier("require"), void 0, args);
        }
        function visitImportEqualsDeclaration(node) {
          ts3.Debug.assert(ts3.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          if (moduleKind !== ts3.ModuleKind.AMD) {
            if (ts3.hasSyntacticModifier(node, 1)) {
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(node.name, createRequireCall(node))), node), node));
            } else {
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
                factory.createVariableDeclaration(factory.cloneNode(node.name), void 0, void 0, createRequireCall(node))
              ], languageVersion >= 2 ? 2 : 0)), node), node));
            }
          } else {
            if (ts3.hasSyntacticModifier(node, 1)) {
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(factory.getExportName(node), factory.getLocalName(node))), node), node));
            }
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportEqualsDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportEqualsDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitExportDeclaration(node) {
          if (!node.moduleSpecifier) {
            return void 0;
          }
          var generatedName = factory.getGeneratedNameForNode(node);
          if (node.exportClause && ts3.isNamedExports(node.exportClause)) {
            var statements = [];
            if (moduleKind !== ts3.ModuleKind.AMD) {
              statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
                factory.createVariableDeclaration(generatedName, void 0, void 0, createRequireCall(node))
              ])), node), node));
            }
            for (var _i = 0, _a = node.exportClause.elements; _i < _a.length; _i++) {
              var specifier = _a[_i];
              if (languageVersion === 0) {
                statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(emitHelpers().createCreateBindingHelper(generatedName, factory.createStringLiteralFromNode(specifier.propertyName || specifier.name), specifier.propertyName ? factory.createStringLiteralFromNode(specifier.name) : void 0)), specifier), specifier));
              } else {
                var exportNeedsImportDefault = !!ts3.getESModuleInterop(compilerOptions) && !(ts3.getEmitFlags(node) & 67108864) && ts3.idText(specifier.propertyName || specifier.name) === "default";
                var exportedValue = factory.createPropertyAccessExpression(exportNeedsImportDefault ? emitHelpers().createImportDefaultHelper(generatedName) : generatedName, specifier.propertyName || specifier.name);
                statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(factory.getExportName(specifier), exportedValue, void 0, true)), specifier), specifier));
              }
            }
            return ts3.singleOrMany(statements);
          } else if (node.exportClause) {
            var statements = [];
            statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(factory.cloneNode(node.exportClause.name), getHelperExpressionForExport(node, moduleKind !== ts3.ModuleKind.AMD ? createRequireCall(node) : ts3.isExportNamespaceAsDefaultDeclaration(node) ? generatedName : factory.createIdentifier(ts3.idText(node.exportClause.name))))), node), node));
            return ts3.singleOrMany(statements);
          } else {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(emitHelpers().createExportStarHelper(moduleKind !== ts3.ModuleKind.AMD ? createRequireCall(node) : generatedName)), node), node);
          }
        }
        function visitExportAssignment(node) {
          if (node.isExportEquals) {
            return void 0;
          }
          var statements;
          var original = node.original;
          if (original && hasAssociatedEndOfDeclarationMarker(original)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportStatement(deferredExports[id], factory.createIdentifier("default"), ts3.visitNode(node.expression, visitor), node, true);
          } else {
            statements = appendExportStatement(statements, factory.createIdentifier("default"), ts3.visitNode(node.expression, visitor), node, true);
          }
          return ts3.singleOrMany(statements);
        }
        function visitFunctionDeclaration(node) {
          var statements;
          if (ts3.hasSyntacticModifier(node, 1)) {
            statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionDeclaration(void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, factory.getDeclarationName(node, true, true), void 0, ts3.visitNodes(node.parameters, visitor), void 0, ts3.visitEachChild(node.body, visitor, context)), node), node));
          } else {
            statements = ts3.append(statements, ts3.visitEachChild(node, visitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitClassDeclaration(node) {
          var statements;
          if (ts3.hasSyntacticModifier(node, 1)) {
            statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createClassDeclaration(void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), factory.getDeclarationName(node, true, true), void 0, ts3.visitNodes(node.heritageClauses, visitor), ts3.visitNodes(node.members, visitor)), node), node));
          } else {
            statements = ts3.append(statements, ts3.visitEachChild(node, visitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitVariableStatement(node) {
          var statements;
          var variables;
          var expressions;
          if (ts3.hasSyntacticModifier(node, 1)) {
            var modifiers = void 0;
            var removeCommentsOnExpressions = false;
            for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              if (ts3.isIdentifier(variable.name) && ts3.isLocalName(variable.name)) {
                if (!modifiers) {
                  modifiers = ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier);
                }
                variables = ts3.append(variables, variable);
              } else if (variable.initializer) {
                if (!ts3.isBindingPattern(variable.name) && (ts3.isArrowFunction(variable.initializer) || ts3.isFunctionExpression(variable.initializer) || ts3.isClassExpression(variable.initializer))) {
                  var expression = factory.createAssignment(ts3.setTextRange(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), variable.name), variable.name), factory.createIdentifier(ts3.getTextOfIdentifierOrLiteral(variable.name)));
                  var updatedVariable = factory.createVariableDeclaration(variable.name, variable.exclamationToken, variable.type, ts3.visitNode(variable.initializer, visitor));
                  variables = ts3.append(variables, updatedVariable);
                  expressions = ts3.append(expressions, expression);
                  removeCommentsOnExpressions = true;
                } else {
                  expressions = ts3.append(expressions, transformInitializedVariable(variable));
                }
              }
            }
            if (variables) {
              statements = ts3.append(statements, factory.updateVariableStatement(node, modifiers, factory.updateVariableDeclarationList(node.declarationList, variables)));
            }
            if (expressions) {
              var statement = ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(expressions)), node), node);
              if (removeCommentsOnExpressions) {
                ts3.removeAllComments(statement);
              }
              statements = ts3.append(statements, statement);
            }
          } else {
            statements = ts3.append(statements, ts3.visitEachChild(node, visitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node);
          } else {
            statements = appendExportsOfVariableStatement(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function createAllExportExpressions(name, value, location) {
          var exportedNames = getExports(name);
          if (exportedNames) {
            var expression = ts3.isExportName(name) ? value : factory.createAssignment(name, value);
            for (var _i = 0, exportedNames_2 = exportedNames; _i < exportedNames_2.length; _i++) {
              var exportName = exportedNames_2[_i];
              ts3.setEmitFlags(expression, 4);
              expression = createExportExpression(exportName, expression, location);
            }
            return expression;
          }
          return factory.createAssignment(name, value);
        }
        function transformInitializedVariable(node) {
          if (ts3.isBindingPattern(node.name)) {
            return ts3.flattenDestructuringAssignment(ts3.visitNode(node, visitor), void 0, context, 0, false, createAllExportExpressions);
          } else {
            return factory.createAssignment(ts3.setTextRange(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), node.name), node.name), node.initializer ? ts3.visitNode(node.initializer, visitor) : factory.createVoidZero());
          }
        }
        function visitMergeDeclarationMarker(node) {
          if (hasAssociatedEndOfDeclarationMarker(node) && node.original.kind === 237) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node.original);
          }
          return node;
        }
        function hasAssociatedEndOfDeclarationMarker(node) {
          return (ts3.getEmitFlags(node) & 4194304) !== 0;
        }
        function visitEndOfDeclarationMarker(node) {
          var id = ts3.getOriginalNodeId(node);
          var statements = deferredExports[id];
          if (statements) {
            delete deferredExports[id];
            return ts3.append(statements, node);
          }
          return node;
        }
        function appendExportsOfImportDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          var importClause = decl.importClause;
          if (!importClause) {
            return statements;
          }
          if (importClause.name) {
            statements = appendExportsOfDeclaration(statements, importClause);
          }
          var namedBindings = importClause.namedBindings;
          if (namedBindings) {
            switch (namedBindings.kind) {
              case 268:
                statements = appendExportsOfDeclaration(statements, namedBindings);
                break;
              case 269:
                for (var _i = 0, _a = namedBindings.elements; _i < _a.length; _i++) {
                  var importBinding = _a[_i];
                  statements = appendExportsOfDeclaration(statements, importBinding, true);
                }
                break;
            }
          }
          return statements;
        }
        function appendExportsOfImportEqualsDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          return appendExportsOfDeclaration(statements, decl);
        }
        function appendExportsOfVariableStatement(statements, node) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
            var decl = _a[_i];
            statements = appendExportsOfBindingElement(statements, decl);
          }
          return statements;
        }
        function appendExportsOfBindingElement(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          if (ts3.isBindingPattern(decl.name)) {
            for (var _i = 0, _a = decl.name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts3.isOmittedExpression(element)) {
                statements = appendExportsOfBindingElement(statements, element);
              }
            }
          } else if (!ts3.isGeneratedIdentifier(decl.name)) {
            statements = appendExportsOfDeclaration(statements, decl);
          }
          return statements;
        }
        function appendExportsOfHoistedDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          if (ts3.hasSyntacticModifier(decl, 1)) {
            var exportName = ts3.hasSyntacticModifier(decl, 512) ? factory.createIdentifier("default") : factory.getDeclarationName(decl);
            statements = appendExportStatement(statements, exportName, factory.getLocalName(decl), decl);
          }
          if (decl.name) {
            statements = appendExportsOfDeclaration(statements, decl);
          }
          return statements;
        }
        function appendExportsOfDeclaration(statements, decl, liveBinding) {
          var name = factory.getDeclarationName(decl);
          var exportSpecifiers = currentModuleInfo.exportSpecifiers.get(ts3.idText(name));
          if (exportSpecifiers) {
            for (var _i = 0, exportSpecifiers_1 = exportSpecifiers; _i < exportSpecifiers_1.length; _i++) {
              var exportSpecifier = exportSpecifiers_1[_i];
              statements = appendExportStatement(statements, exportSpecifier.name, name, exportSpecifier.name, void 0, liveBinding);
            }
          }
          return statements;
        }
        function appendExportStatement(statements, exportName, expression, location, allowComments, liveBinding) {
          statements = ts3.append(statements, createExportStatement(exportName, expression, location, allowComments, liveBinding));
          return statements;
        }
        function createUnderscoreUnderscoreESModule() {
          var statement;
          if (languageVersion === 0) {
            statement = factory.createExpressionStatement(createExportExpression(factory.createIdentifier("__esModule"), factory.createTrue()));
          } else {
            statement = factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "defineProperty"), void 0, [
              factory.createIdentifier("exports"),
              factory.createStringLiteral("__esModule"),
              factory.createObjectLiteralExpression([
                factory.createPropertyAssignment("value", factory.createTrue())
              ])
            ]));
          }
          ts3.setEmitFlags(statement, 1048576);
          return statement;
        }
        function createExportStatement(name, value, location, allowComments, liveBinding) {
          var statement = ts3.setTextRange(factory.createExpressionStatement(createExportExpression(name, value, void 0, liveBinding)), location);
          ts3.startOnNewLine(statement);
          if (!allowComments) {
            ts3.setEmitFlags(statement, 1536);
          }
          return statement;
        }
        function createExportExpression(name, value, location, liveBinding) {
          return ts3.setTextRange(liveBinding && languageVersion !== 0 ? factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "defineProperty"), void 0, [
            factory.createIdentifier("exports"),
            factory.createStringLiteralFromNode(name),
            factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("enumerable", factory.createTrue()),
              factory.createPropertyAssignment("get", factory.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, factory.createBlock([factory.createReturnStatement(value)])))
            ])
          ]) : factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.cloneNode(name)), value), location);
        }
        function modifierVisitor(node) {
          switch (node.kind) {
            case 93:
            case 88:
              return void 0;
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (node.kind === 305) {
            currentSourceFile = node;
            currentModuleInfo = moduleInfoMap[ts3.getOriginalNodeId(currentSourceFile)];
            previousOnEmitNode(hint, node, emitCallback);
            currentSourceFile = void 0;
            currentModuleInfo = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (node.id && noSubstitution[node.id]) {
            return node;
          }
          if (hint === 1) {
            return substituteExpression(node);
          } else if (ts3.isShorthandPropertyAssignment(node)) {
            return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          var name = node.name;
          var exportedOrImportedName = substituteExpressionIdentifier(name);
          if (exportedOrImportedName !== name) {
            if (node.objectAssignmentInitializer) {
              var initializer = factory.createAssignment(exportedOrImportedName, node.objectAssignmentInitializer);
              return ts3.setTextRange(factory.createPropertyAssignment(name, initializer), node);
            }
            return ts3.setTextRange(factory.createPropertyAssignment(name, exportedOrImportedName), node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 79:
              return substituteExpressionIdentifier(node);
            case 208:
              return substituteCallExpression(node);
            case 210:
              return substituteTaggedTemplateExpression(node);
            case 221:
              return substituteBinaryExpression(node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          if (ts3.isIdentifier(node.expression)) {
            var expression = substituteExpressionIdentifier(node.expression);
            noSubstitution[ts3.getNodeId(expression)] = true;
            if (!ts3.isIdentifier(expression) && !(ts3.getEmitFlags(node.expression) & 4096)) {
              return ts3.addEmitFlags(factory.updateCallExpression(node, expression, void 0, node.arguments), 536870912);
            }
          }
          return node;
        }
        function substituteTaggedTemplateExpression(node) {
          if (ts3.isIdentifier(node.tag)) {
            var tag = substituteExpressionIdentifier(node.tag);
            noSubstitution[ts3.getNodeId(tag)] = true;
            if (!ts3.isIdentifier(tag) && !(ts3.getEmitFlags(node.tag) & 4096)) {
              return ts3.addEmitFlags(factory.updateTaggedTemplateExpression(node, tag, void 0, node.template), 536870912);
            }
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          var _a, _b;
          if (ts3.getEmitFlags(node) & 4096) {
            var externalHelpersModuleName = ts3.getExternalHelpersModuleName(currentSourceFile);
            if (externalHelpersModuleName) {
              return factory.createPropertyAccessExpression(externalHelpersModuleName, node);
            }
            return node;
          } else if (!(ts3.isGeneratedIdentifier(node) && !(node.autoGenerateFlags & 64)) && !ts3.isLocalName(node)) {
            var exportContainer = resolver.getReferencedExportContainer(node, ts3.isExportName(node));
            if (exportContainer && exportContainer.kind === 305) {
              return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.cloneNode(node)), node);
            }
            var importDeclaration = resolver.getReferencedImportDeclaration(node);
            if (importDeclaration) {
              if (ts3.isImportClause(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(importDeclaration.parent), factory.createIdentifier("default")), node);
              } else if (ts3.isImportSpecifier(importDeclaration)) {
                var name = importDeclaration.propertyName || importDeclaration.name;
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(((_b = (_a = importDeclaration.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.parent) || importDeclaration), factory.cloneNode(name)), node);
              }
            }
          }
          return node;
        }
        function substituteBinaryExpression(node) {
          if (ts3.isAssignmentOperator(node.operatorToken.kind) && ts3.isIdentifier(node.left) && !ts3.isGeneratedIdentifier(node.left) && !ts3.isLocalName(node.left) && !ts3.isDeclarationNameOfEnumOrNamespace(node.left)) {
            var exportedNames = getExports(node.left);
            if (exportedNames) {
              var expression = node;
              for (var _i = 0, exportedNames_3 = exportedNames; _i < exportedNames_3.length; _i++) {
                var exportName = exportedNames_3[_i];
                noSubstitution[ts3.getNodeId(expression)] = true;
                expression = createExportExpression(exportName, expression, node);
              }
              return expression;
            }
          }
          return node;
        }
        function getExports(name) {
          if (!ts3.isGeneratedIdentifier(name)) {
            var valueDeclaration = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
            if (valueDeclaration) {
              return currentModuleInfo && currentModuleInfo.exportedBindings[ts3.getOriginalNodeId(valueDeclaration)];
            }
          }
        }
      }
      ts3.transformModule = transformModule;
      var dynamicImportUMDHelper = {
        name: "typescript:dynamicimport-sync-require",
        scoped: true,
        text: '\n            var __syncRequire = typeof module === "object" && typeof module.exports === "object";'
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformSystemModule(context) {
        var factory = context.factory, startLexicalEnvironment = context.startLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var host = context.getEmitHost();
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(79);
        context.enableSubstitution(297);
        context.enableSubstitution(221);
        context.enableSubstitution(231);
        context.enableEmitNotification(305);
        var moduleInfoMap = [];
        var deferredExports = [];
        var exportFunctionsMap = [];
        var noSubstitutionMap = [];
        var contextObjectMap = [];
        var currentSourceFile;
        var moduleInfo;
        var exportFunction;
        var contextObject;
        var hoistedStatements;
        var enclosingBlockScopedContainer;
        var noSubstitution;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || !(ts3.isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 4194304)) {
            return node;
          }
          var id = ts3.getOriginalNodeId(node);
          currentSourceFile = node;
          enclosingBlockScopedContainer = node;
          moduleInfo = moduleInfoMap[id] = ts3.collectExternalModuleInfo(context, node, resolver, compilerOptions);
          exportFunction = factory.createUniqueName("exports");
          exportFunctionsMap[id] = exportFunction;
          contextObject = contextObjectMap[id] = factory.createUniqueName("context");
          var dependencyGroups = collectDependencyGroups(moduleInfo.externalImports);
          var moduleBodyBlock = createSystemModuleBody(node, dependencyGroups);
          var moduleBodyFunction = factory.createFunctionExpression(void 0, void 0, void 0, void 0, [
            factory.createParameterDeclaration(void 0, void 0, void 0, exportFunction),
            factory.createParameterDeclaration(void 0, void 0, void 0, contextObject)
          ], void 0, moduleBodyBlock);
          var moduleName = ts3.tryGetModuleNameFromFile(factory, node, host, compilerOptions);
          var dependencies = factory.createArrayLiteralExpression(ts3.map(dependencyGroups, function(dependencyGroup) {
            return dependencyGroup.name;
          }));
          var updated = ts3.setEmitFlags(factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray([
            factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("System"), "register"), void 0, moduleName ? [moduleName, dependencies, moduleBodyFunction] : [dependencies, moduleBodyFunction]))
          ]), node.statements)), 1024);
          if (!ts3.outFile(compilerOptions)) {
            ts3.moveEmitHelpers(updated, moduleBodyBlock, function(helper) {
              return !helper.scoped;
            });
          }
          if (noSubstitution) {
            noSubstitutionMap[id] = noSubstitution;
            noSubstitution = void 0;
          }
          currentSourceFile = void 0;
          moduleInfo = void 0;
          exportFunction = void 0;
          contextObject = void 0;
          hoistedStatements = void 0;
          enclosingBlockScopedContainer = void 0;
          return updated;
        }
        function collectDependencyGroups(externalImports) {
          var groupIndices = new ts3.Map();
          var dependencyGroups = [];
          for (var _i = 0, externalImports_1 = externalImports; _i < externalImports_1.length; _i++) {
            var externalImport = externalImports_1[_i];
            var externalModuleName = ts3.getExternalModuleNameLiteral(factory, externalImport, currentSourceFile, host, resolver, compilerOptions);
            if (externalModuleName) {
              var text = externalModuleName.text;
              var groupIndex = groupIndices.get(text);
              if (groupIndex !== void 0) {
                dependencyGroups[groupIndex].externalImports.push(externalImport);
              } else {
                groupIndices.set(text, dependencyGroups.length);
                dependencyGroups.push({
                  name: externalModuleName,
                  externalImports: [externalImport]
                });
              }
            }
          }
          return dependencyGroups;
        }
        function createSystemModuleBody(node, dependencyGroups) {
          var statements = [];
          startLexicalEnvironment();
          var ensureUseStrict = ts3.getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && ts3.isExternalModule(currentSourceFile);
          var statementOffset = factory.copyPrologue(node.statements, statements, ensureUseStrict, topLevelVisitor);
          statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration("__moduleName", void 0, void 0, factory.createLogicalAnd(contextObject, factory.createPropertyAccessExpression(contextObject, "id")))
          ])));
          ts3.visitNode(moduleInfo.externalHelpersImportDeclaration, topLevelVisitor, ts3.isStatement);
          var executeStatements = ts3.visitNodes(node.statements, topLevelVisitor, ts3.isStatement, statementOffset);
          ts3.addRange(statements, hoistedStatements);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var exportStarFunction = addExportStarIfNeeded(statements);
          var modifiers = node.transformFlags & 1048576 ? factory.createModifiersFromModifierFlags(256) : void 0;
          var moduleObject = factory.createObjectLiteralExpression([
            factory.createPropertyAssignment("setters", createSettersArray(exportStarFunction, dependencyGroups)),
            factory.createPropertyAssignment("execute", factory.createFunctionExpression(modifiers, void 0, void 0, void 0, [], void 0, factory.createBlock(executeStatements, true)))
          ], true);
          statements.push(factory.createReturnStatement(moduleObject));
          return factory.createBlock(statements, true);
        }
        function addExportStarIfNeeded(statements) {
          if (!moduleInfo.hasExportStarsToExportValues) {
            return;
          }
          if (!moduleInfo.exportedNames && moduleInfo.exportSpecifiers.size === 0) {
            var hasExportDeclarationWithExportClause = false;
            for (var _i = 0, _a = moduleInfo.externalImports; _i < _a.length; _i++) {
              var externalImport = _a[_i];
              if (externalImport.kind === 272 && externalImport.exportClause) {
                hasExportDeclarationWithExportClause = true;
                break;
              }
            }
            if (!hasExportDeclarationWithExportClause) {
              var exportStarFunction_1 = createExportStarFunction(void 0);
              statements.push(exportStarFunction_1);
              return exportStarFunction_1.name;
            }
          }
          var exportedNames = [];
          if (moduleInfo.exportedNames) {
            for (var _b = 0, _c = moduleInfo.exportedNames; _b < _c.length; _b++) {
              var exportedLocalName = _c[_b];
              if (exportedLocalName.escapedText === "default") {
                continue;
              }
              exportedNames.push(factory.createPropertyAssignment(factory.createStringLiteralFromNode(exportedLocalName), factory.createTrue()));
            }
          }
          var exportedNamesStorageRef = factory.createUniqueName("exportedNames");
          statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(exportedNamesStorageRef, void 0, void 0, factory.createObjectLiteralExpression(exportedNames, true))
          ])));
          var exportStarFunction = createExportStarFunction(exportedNamesStorageRef);
          statements.push(exportStarFunction);
          return exportStarFunction.name;
        }
        function createExportStarFunction(localNames) {
          var exportStarFunction = factory.createUniqueName("exportStar");
          var m = factory.createIdentifier("m");
          var n = factory.createIdentifier("n");
          var exports2 = factory.createIdentifier("exports");
          var condition = factory.createStrictInequality(n, factory.createStringLiteral("default"));
          if (localNames) {
            condition = factory.createLogicalAnd(condition, factory.createLogicalNot(factory.createCallExpression(factory.createPropertyAccessExpression(localNames, "hasOwnProperty"), void 0, [n])));
          }
          return factory.createFunctionDeclaration(void 0, void 0, void 0, exportStarFunction, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, m)], void 0, factory.createBlock([
            factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(exports2, void 0, void 0, factory.createObjectLiteralExpression([]))
            ])),
            factory.createForInStatement(factory.createVariableDeclarationList([
              factory.createVariableDeclaration(n)
            ]), m, factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(condition, factory.createExpressionStatement(factory.createAssignment(factory.createElementAccessExpression(exports2, n), factory.createElementAccessExpression(m, n)))), 1)
            ])),
            factory.createExpressionStatement(factory.createCallExpression(exportFunction, void 0, [exports2]))
          ], true));
        }
        function createSettersArray(exportStarFunction, dependencyGroups) {
          var setters = [];
          for (var _i = 0, dependencyGroups_1 = dependencyGroups; _i < dependencyGroups_1.length; _i++) {
            var group_2 = dependencyGroups_1[_i];
            var localName = ts3.forEach(group_2.externalImports, function(i) {
              return ts3.getLocalNameForExternalImport(factory, i, currentSourceFile);
            });
            var parameterName = localName ? factory.getGeneratedNameForNode(localName) : factory.createUniqueName("");
            var statements = [];
            for (var _a = 0, _b = group_2.externalImports; _a < _b.length; _a++) {
              var entry = _b[_a];
              var importVariableName = ts3.getLocalNameForExternalImport(factory, entry, currentSourceFile);
              switch (entry.kind) {
                case 266:
                  if (!entry.importClause) {
                    break;
                  }
                case 265:
                  ts3.Debug.assert(importVariableName !== void 0);
                  statements.push(factory.createExpressionStatement(factory.createAssignment(importVariableName, parameterName)));
                  break;
                case 272:
                  ts3.Debug.assert(importVariableName !== void 0);
                  if (entry.exportClause) {
                    if (ts3.isNamedExports(entry.exportClause)) {
                      var properties = [];
                      for (var _c = 0, _d = entry.exportClause.elements; _c < _d.length; _c++) {
                        var e = _d[_c];
                        properties.push(factory.createPropertyAssignment(factory.createStringLiteral(ts3.idText(e.name)), factory.createElementAccessExpression(parameterName, factory.createStringLiteral(ts3.idText(e.propertyName || e.name)))));
                      }
                      statements.push(factory.createExpressionStatement(factory.createCallExpression(exportFunction, void 0, [factory.createObjectLiteralExpression(properties, true)])));
                    } else {
                      statements.push(factory.createExpressionStatement(factory.createCallExpression(exportFunction, void 0, [
                        factory.createStringLiteral(ts3.idText(entry.exportClause.name)),
                        parameterName
                      ])));
                    }
                  } else {
                    statements.push(factory.createExpressionStatement(factory.createCallExpression(exportStarFunction, void 0, [parameterName])));
                  }
                  break;
              }
            }
            setters.push(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, parameterName)], void 0, factory.createBlock(statements, true)));
          }
          return factory.createArrayLiteralExpression(setters, true);
        }
        function topLevelVisitor(node) {
          switch (node.kind) {
            case 266:
              return visitImportDeclaration(node);
            case 265:
              return visitImportEqualsDeclaration(node);
            case 272:
              return visitExportDeclaration(node);
            case 271:
              return visitExportAssignment(node);
            default:
              return topLevelNestedVisitor(node);
          }
        }
        function visitImportDeclaration(node) {
          var statements;
          if (node.importClause) {
            hoistVariableDeclaration(ts3.getLocalNameForExternalImport(factory, node, currentSourceFile));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitExportDeclaration(node) {
          ts3.Debug.assertIsDefined(node);
          return void 0;
        }
        function visitImportEqualsDeclaration(node) {
          ts3.Debug.assert(ts3.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          hoistVariableDeclaration(ts3.getLocalNameForExternalImport(factory, node, currentSourceFile));
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportEqualsDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportEqualsDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitExportAssignment(node) {
          if (node.isExportEquals) {
            return void 0;
          }
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var original = node.original;
          if (original && hasAssociatedEndOfDeclarationMarker(original)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportStatement(deferredExports[id], factory.createIdentifier("default"), expression, true);
          } else {
            return createExportStatement(factory.createIdentifier("default"), expression, true);
          }
        }
        function visitFunctionDeclaration(node) {
          if (ts3.hasSyntacticModifier(node, 1)) {
            hoistedStatements = ts3.append(hoistedStatements, factory.updateFunctionDeclaration(node, node.decorators, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, factory.getDeclarationName(node, true, true), void 0, ts3.visitNodes(node.parameters, visitor, ts3.isParameterDeclaration), void 0, ts3.visitNode(node.body, visitor, ts3.isBlock)));
          } else {
            hoistedStatements = ts3.append(hoistedStatements, ts3.visitEachChild(node, visitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            hoistedStatements = appendExportsOfHoistedDeclaration(hoistedStatements, node);
          }
          return void 0;
        }
        function visitClassDeclaration(node) {
          var statements;
          var name = factory.getLocalName(node);
          hoistVariableDeclaration(name);
          statements = ts3.append(statements, ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(name, ts3.setTextRange(factory.createClassExpression(ts3.visitNodes(node.decorators, visitor, ts3.isDecorator), void 0, node.name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), ts3.visitNodes(node.members, visitor, ts3.isClassElement)), node))), node));
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitVariableStatement(node) {
          if (!shouldHoistVariableDeclarationList(node.declarationList)) {
            return ts3.visitNode(node, visitor, ts3.isStatement);
          }
          var expressions;
          var isExportedDeclaration = ts3.hasSyntacticModifier(node, 1);
          var isMarkedDeclaration = hasAssociatedEndOfDeclarationMarker(node);
          for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
            var variable = _a[_i];
            if (variable.initializer) {
              expressions = ts3.append(expressions, transformInitializedVariable(variable, isExportedDeclaration && !isMarkedDeclaration));
            } else {
              hoistBindingElement(variable);
            }
          }
          var statements;
          if (expressions) {
            statements = ts3.append(statements, ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(expressions)), node));
          }
          if (isMarkedDeclaration) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node, isExportedDeclaration);
          } else {
            statements = appendExportsOfVariableStatement(statements, node, false);
          }
          return ts3.singleOrMany(statements);
        }
        function hoistBindingElement(node) {
          if (ts3.isBindingPattern(node.name)) {
            for (var _i = 0, _a = node.name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts3.isOmittedExpression(element)) {
                hoistBindingElement(element);
              }
            }
          } else {
            hoistVariableDeclaration(factory.cloneNode(node.name));
          }
        }
        function shouldHoistVariableDeclarationList(node) {
          return (ts3.getEmitFlags(node) & 2097152) === 0 && (enclosingBlockScopedContainer.kind === 305 || (ts3.getOriginalNode(node).flags & 3) === 0);
        }
        function transformInitializedVariable(node, isExportedDeclaration) {
          var createAssignment = isExportedDeclaration ? createExportedVariableAssignment : createNonExportedVariableAssignment;
          return ts3.isBindingPattern(node.name) ? ts3.flattenDestructuringAssignment(node, visitor, context, 0, false, createAssignment) : node.initializer ? createAssignment(node.name, ts3.visitNode(node.initializer, visitor, ts3.isExpression)) : node.name;
        }
        function createExportedVariableAssignment(name, value, location) {
          return createVariableAssignment(name, value, location, true);
        }
        function createNonExportedVariableAssignment(name, value, location) {
          return createVariableAssignment(name, value, location, false);
        }
        function createVariableAssignment(name, value, location, isExportedDeclaration) {
          hoistVariableDeclaration(factory.cloneNode(name));
          return isExportedDeclaration ? createExportExpression(name, preventSubstitution(ts3.setTextRange(factory.createAssignment(name, value), location))) : preventSubstitution(ts3.setTextRange(factory.createAssignment(name, value), location));
        }
        function visitMergeDeclarationMarker(node) {
          if (hasAssociatedEndOfDeclarationMarker(node) && node.original.kind === 237) {
            var id = ts3.getOriginalNodeId(node);
            var isExportedDeclaration = ts3.hasSyntacticModifier(node.original, 1);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node.original, isExportedDeclaration);
          }
          return node;
        }
        function hasAssociatedEndOfDeclarationMarker(node) {
          return (ts3.getEmitFlags(node) & 4194304) !== 0;
        }
        function visitEndOfDeclarationMarker(node) {
          var id = ts3.getOriginalNodeId(node);
          var statements = deferredExports[id];
          if (statements) {
            delete deferredExports[id];
            return ts3.append(statements, node);
          } else {
            var original = ts3.getOriginalNode(node);
            if (ts3.isModuleOrEnumDeclaration(original)) {
              return ts3.append(appendExportsOfDeclaration(statements, original), node);
            }
          }
          return node;
        }
        function appendExportsOfImportDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var importClause = decl.importClause;
          if (!importClause) {
            return statements;
          }
          if (importClause.name) {
            statements = appendExportsOfDeclaration(statements, importClause);
          }
          var namedBindings = importClause.namedBindings;
          if (namedBindings) {
            switch (namedBindings.kind) {
              case 268:
                statements = appendExportsOfDeclaration(statements, namedBindings);
                break;
              case 269:
                for (var _i = 0, _a = namedBindings.elements; _i < _a.length; _i++) {
                  var importBinding = _a[_i];
                  statements = appendExportsOfDeclaration(statements, importBinding);
                }
                break;
            }
          }
          return statements;
        }
        function appendExportsOfImportEqualsDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          return appendExportsOfDeclaration(statements, decl);
        }
        function appendExportsOfVariableStatement(statements, node, exportSelf) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
            var decl = _a[_i];
            if (decl.initializer || exportSelf) {
              statements = appendExportsOfBindingElement(statements, decl, exportSelf);
            }
          }
          return statements;
        }
        function appendExportsOfBindingElement(statements, decl, exportSelf) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          if (ts3.isBindingPattern(decl.name)) {
            for (var _i = 0, _a = decl.name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts3.isOmittedExpression(element)) {
                statements = appendExportsOfBindingElement(statements, element, exportSelf);
              }
            }
          } else if (!ts3.isGeneratedIdentifier(decl.name)) {
            var excludeName = void 0;
            if (exportSelf) {
              statements = appendExportStatement(statements, decl.name, factory.getLocalName(decl));
              excludeName = ts3.idText(decl.name);
            }
            statements = appendExportsOfDeclaration(statements, decl, excludeName);
          }
          return statements;
        }
        function appendExportsOfHoistedDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var excludeName;
          if (ts3.hasSyntacticModifier(decl, 1)) {
            var exportName = ts3.hasSyntacticModifier(decl, 512) ? factory.createStringLiteral("default") : decl.name;
            statements = appendExportStatement(statements, exportName, factory.getLocalName(decl));
            excludeName = ts3.getTextOfIdentifierOrLiteral(exportName);
          }
          if (decl.name) {
            statements = appendExportsOfDeclaration(statements, decl, excludeName);
          }
          return statements;
        }
        function appendExportsOfDeclaration(statements, decl, excludeName) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var name = factory.getDeclarationName(decl);
          var exportSpecifiers = moduleInfo.exportSpecifiers.get(ts3.idText(name));
          if (exportSpecifiers) {
            for (var _i = 0, exportSpecifiers_2 = exportSpecifiers; _i < exportSpecifiers_2.length; _i++) {
              var exportSpecifier = exportSpecifiers_2[_i];
              if (exportSpecifier.name.escapedText !== excludeName) {
                statements = appendExportStatement(statements, exportSpecifier.name, name);
              }
            }
          }
          return statements;
        }
        function appendExportStatement(statements, exportName, expression, allowComments) {
          statements = ts3.append(statements, createExportStatement(exportName, expression, allowComments));
          return statements;
        }
        function createExportStatement(name, value, allowComments) {
          var statement = factory.createExpressionStatement(createExportExpression(name, value));
          ts3.startOnNewLine(statement);
          if (!allowComments) {
            ts3.setEmitFlags(statement, 1536);
          }
          return statement;
        }
        function createExportExpression(name, value) {
          var exportName = ts3.isIdentifier(name) ? factory.createStringLiteralFromNode(name) : name;
          ts3.setEmitFlags(value, ts3.getEmitFlags(value) | 1536);
          return ts3.setCommentRange(factory.createCallExpression(exportFunction, void 0, [exportName, value]), value);
        }
        function topLevelNestedVisitor(node) {
          switch (node.kind) {
            case 237:
              return visitVariableStatement(node);
            case 256:
              return visitFunctionDeclaration(node);
            case 257:
              return visitClassDeclaration(node);
            case 242:
              return visitForStatement(node, true);
            case 243:
              return visitForInStatement(node);
            case 244:
              return visitForOfStatement(node);
            case 240:
              return visitDoStatement(node);
            case 241:
              return visitWhileStatement(node);
            case 250:
              return visitLabeledStatement(node);
            case 248:
              return visitWithStatement(node);
            case 249:
              return visitSwitchStatement(node);
            case 263:
              return visitCaseBlock(node);
            case 289:
              return visitCaseClause(node);
            case 290:
              return visitDefaultClause(node);
            case 252:
              return visitTryStatement(node);
            case 292:
              return visitCatchClause(node);
            case 235:
              return visitBlock(node);
            case 352:
              return visitMergeDeclarationMarker(node);
            case 353:
              return visitEndOfDeclarationMarker(node);
            default:
              return visitor(node);
          }
        }
        function visitForStatement(node, isTopLevel) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateForStatement(node, ts3.visitNode(node.initializer, isTopLevel ? visitForInitializer : discardedValueVisitor, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, discardedValueVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, isTopLevel ? topLevelNestedVisitor : visitor, context));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitForInStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateForInStatement(node, visitForInitializer(node.initializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, topLevelNestedVisitor, context));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitForOfStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateForOfStatement(node, node.awaitModifier, visitForInitializer(node.initializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, topLevelNestedVisitor, context));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function shouldHoistForInitializer(node) {
          return ts3.isVariableDeclarationList(node) && shouldHoistVariableDeclarationList(node);
        }
        function visitForInitializer(node) {
          if (shouldHoistForInitializer(node)) {
            var expressions = void 0;
            for (var _i = 0, _a = node.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              expressions = ts3.append(expressions, transformInitializedVariable(variable, false));
              if (!variable.initializer) {
                hoistBindingElement(variable);
              }
            }
            return expressions ? factory.inlineExpressions(expressions) : factory.createOmittedExpression();
          } else {
            return ts3.visitNode(node, discardedValueVisitor, ts3.isExpression);
          }
        }
        function visitDoStatement(node) {
          return factory.updateDoStatement(node, ts3.visitIterationBody(node.statement, topLevelNestedVisitor, context), ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
        function visitWhileStatement(node) {
          return factory.updateWhileStatement(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, topLevelNestedVisitor, context));
        }
        function visitLabeledStatement(node) {
          return factory.updateLabeledStatement(node, node.label, ts3.visitNode(node.statement, topLevelNestedVisitor, ts3.isStatement, factory.liftToBlock));
        }
        function visitWithStatement(node) {
          return factory.updateWithStatement(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitNode(node.statement, topLevelNestedVisitor, ts3.isStatement, factory.liftToBlock));
        }
        function visitSwitchStatement(node) {
          return factory.updateSwitchStatement(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitNode(node.caseBlock, topLevelNestedVisitor, ts3.isCaseBlock));
        }
        function visitCaseBlock(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateCaseBlock(node, ts3.visitNodes(node.clauses, topLevelNestedVisitor, ts3.isCaseOrDefaultClause));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitCaseClause(node) {
          return factory.updateCaseClause(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitNodes(node.statements, topLevelNestedVisitor, ts3.isStatement));
        }
        function visitDefaultClause(node) {
          return ts3.visitEachChild(node, topLevelNestedVisitor, context);
        }
        function visitTryStatement(node) {
          return ts3.visitEachChild(node, topLevelNestedVisitor, context);
        }
        function visitCatchClause(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateCatchClause(node, node.variableDeclaration, ts3.visitNode(node.block, topLevelNestedVisitor, ts3.isBlock));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitBlock(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts3.visitEachChild(node, topLevelNestedVisitor, context);
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitorWorker(node, valueIsDiscarded) {
          if (!(node.transformFlags & (4096 | 4194304 | 67108864))) {
            return node;
          }
          switch (node.kind) {
            case 242:
              return visitForStatement(node, false);
            case 238:
              return visitExpressionStatement(node);
            case 212:
              return visitParenthesizedExpression(node, valueIsDiscarded);
            case 350:
              return visitPartiallyEmittedExpression(node, valueIsDiscarded);
            case 221:
              if (ts3.isDestructuringAssignment(node)) {
                return visitDestructuringAssignment(node, valueIsDiscarded);
              }
              break;
            case 208:
              if (ts3.isImportCall(node)) {
                return visitImportCallExpression(node);
              }
              break;
            case 219:
            case 220:
              return visitPrefixOrPostfixUnaryExpression(node, valueIsDiscarded);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          return visitorWorker(node, false);
        }
        function discardedValueVisitor(node) {
          return visitorWorker(node, true);
        }
        function visitExpressionStatement(node) {
          return factory.updateExpressionStatement(node, ts3.visitNode(node.expression, discardedValueVisitor, ts3.isExpression));
        }
        function visitParenthesizedExpression(node, valueIsDiscarded) {
          return factory.updateParenthesizedExpression(node, ts3.visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, ts3.isExpression));
        }
        function visitPartiallyEmittedExpression(node, valueIsDiscarded) {
          return factory.updatePartiallyEmittedExpression(node, ts3.visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, ts3.isExpression));
        }
        function visitImportCallExpression(node) {
          var externalModuleName = ts3.getExternalModuleNameLiteral(factory, node, currentSourceFile, host, resolver, compilerOptions);
          var firstArgument = ts3.visitNode(ts3.firstOrUndefined(node.arguments), visitor);
          var argument = externalModuleName && (!firstArgument || !ts3.isStringLiteral(firstArgument) || firstArgument.text !== externalModuleName.text) ? externalModuleName : firstArgument;
          return factory.createCallExpression(factory.createPropertyAccessExpression(contextObject, factory.createIdentifier("import")), void 0, argument ? [argument] : []);
        }
        function visitDestructuringAssignment(node, valueIsDiscarded) {
          if (hasExportedReferenceInDestructuringTarget(node.left)) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 0, !valueIsDiscarded);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function hasExportedReferenceInDestructuringTarget(node) {
          if (ts3.isAssignmentExpression(node, true)) {
            return hasExportedReferenceInDestructuringTarget(node.left);
          } else if (ts3.isSpreadElement(node)) {
            return hasExportedReferenceInDestructuringTarget(node.expression);
          } else if (ts3.isObjectLiteralExpression(node)) {
            return ts3.some(node.properties, hasExportedReferenceInDestructuringTarget);
          } else if (ts3.isArrayLiteralExpression(node)) {
            return ts3.some(node.elements, hasExportedReferenceInDestructuringTarget);
          } else if (ts3.isShorthandPropertyAssignment(node)) {
            return hasExportedReferenceInDestructuringTarget(node.name);
          } else if (ts3.isPropertyAssignment(node)) {
            return hasExportedReferenceInDestructuringTarget(node.initializer);
          } else if (ts3.isIdentifier(node)) {
            var container = resolver.getReferencedExportContainer(node);
            return container !== void 0 && container.kind === 305;
          } else {
            return false;
          }
        }
        function visitPrefixOrPostfixUnaryExpression(node, valueIsDiscarded) {
          if ((node.operator === 45 || node.operator === 46) && ts3.isIdentifier(node.operand) && !ts3.isGeneratedIdentifier(node.operand) && !ts3.isLocalName(node.operand) && !ts3.isDeclarationNameOfEnumOrNamespace(node.operand)) {
            var exportedNames = getExports(node.operand);
            if (exportedNames) {
              var temp = void 0;
              var expression = ts3.visitNode(node.operand, visitor, ts3.isExpression);
              if (ts3.isPrefixUnaryExpression(node)) {
                expression = factory.updatePrefixUnaryExpression(node, expression);
              } else {
                expression = factory.updatePostfixUnaryExpression(node, expression);
                if (!valueIsDiscarded) {
                  temp = factory.createTempVariable(hoistVariableDeclaration);
                  expression = factory.createAssignment(temp, expression);
                  ts3.setTextRange(expression, node);
                }
                expression = factory.createComma(expression, factory.cloneNode(node.operand));
                ts3.setTextRange(expression, node);
              }
              for (var _i = 0, exportedNames_4 = exportedNames; _i < exportedNames_4.length; _i++) {
                var exportName = exportedNames_4[_i];
                expression = createExportExpression(exportName, preventSubstitution(expression));
              }
              if (temp) {
                expression = factory.createComma(expression, temp);
                ts3.setTextRange(expression, node);
              }
              return expression;
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function modifierVisitor(node) {
          switch (node.kind) {
            case 93:
            case 88:
              return void 0;
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (node.kind === 305) {
            var id = ts3.getOriginalNodeId(node);
            currentSourceFile = node;
            moduleInfo = moduleInfoMap[id];
            exportFunction = exportFunctionsMap[id];
            noSubstitution = noSubstitutionMap[id];
            contextObject = contextObjectMap[id];
            if (noSubstitution) {
              delete noSubstitutionMap[id];
            }
            previousOnEmitNode(hint, node, emitCallback);
            currentSourceFile = void 0;
            moduleInfo = void 0;
            exportFunction = void 0;
            contextObject = void 0;
            noSubstitution = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (isSubstitutionPrevented(node)) {
            return node;
          }
          if (hint === 1) {
            return substituteExpression(node);
          } else if (hint === 4) {
            return substituteUnspecified(node);
          }
          return node;
        }
        function substituteUnspecified(node) {
          switch (node.kind) {
            case 297:
              return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          var _a, _b;
          var name = node.name;
          if (!ts3.isGeneratedIdentifier(name) && !ts3.isLocalName(name)) {
            var importDeclaration = resolver.getReferencedImportDeclaration(name);
            if (importDeclaration) {
              if (ts3.isImportClause(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAssignment(factory.cloneNode(name), factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(importDeclaration.parent), factory.createIdentifier("default"))), node);
              } else if (ts3.isImportSpecifier(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAssignment(factory.cloneNode(name), factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(((_b = (_a = importDeclaration.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.parent) || importDeclaration), factory.cloneNode(importDeclaration.propertyName || importDeclaration.name))), node);
              }
            }
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 79:
              return substituteExpressionIdentifier(node);
            case 221:
              return substituteBinaryExpression(node);
            case 231:
              return substituteMetaProperty(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          var _a, _b;
          if (ts3.getEmitFlags(node) & 4096) {
            var externalHelpersModuleName = ts3.getExternalHelpersModuleName(currentSourceFile);
            if (externalHelpersModuleName) {
              return factory.createPropertyAccessExpression(externalHelpersModuleName, node);
            }
            return node;
          }
          if (!ts3.isGeneratedIdentifier(node) && !ts3.isLocalName(node)) {
            var importDeclaration = resolver.getReferencedImportDeclaration(node);
            if (importDeclaration) {
              if (ts3.isImportClause(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(importDeclaration.parent), factory.createIdentifier("default")), node);
              } else if (ts3.isImportSpecifier(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(((_b = (_a = importDeclaration.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.parent) || importDeclaration), factory.cloneNode(importDeclaration.propertyName || importDeclaration.name)), node);
              }
            }
          }
          return node;
        }
        function substituteBinaryExpression(node) {
          if (ts3.isAssignmentOperator(node.operatorToken.kind) && ts3.isIdentifier(node.left) && !ts3.isGeneratedIdentifier(node.left) && !ts3.isLocalName(node.left) && !ts3.isDeclarationNameOfEnumOrNamespace(node.left)) {
            var exportedNames = getExports(node.left);
            if (exportedNames) {
              var expression = node;
              for (var _i = 0, exportedNames_5 = exportedNames; _i < exportedNames_5.length; _i++) {
                var exportName = exportedNames_5[_i];
                expression = createExportExpression(exportName, preventSubstitution(expression));
              }
              return expression;
            }
          }
          return node;
        }
        function substituteMetaProperty(node) {
          if (ts3.isImportMeta(node)) {
            return factory.createPropertyAccessExpression(contextObject, factory.createIdentifier("meta"));
          }
          return node;
        }
        function getExports(name) {
          var exportedNames;
          if (!ts3.isGeneratedIdentifier(name)) {
            var valueDeclaration = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
            if (valueDeclaration) {
              var exportContainer = resolver.getReferencedExportContainer(name, false);
              if (exportContainer && exportContainer.kind === 305) {
                exportedNames = ts3.append(exportedNames, factory.getDeclarationName(valueDeclaration));
              }
              exportedNames = ts3.addRange(exportedNames, moduleInfo && moduleInfo.exportedBindings[ts3.getOriginalNodeId(valueDeclaration)]);
            }
          }
          return exportedNames;
        }
        function preventSubstitution(node) {
          if (noSubstitution === void 0)
            noSubstitution = [];
          noSubstitution[ts3.getNodeId(node)] = true;
          return node;
        }
        function isSubstitutionPrevented(node) {
          return noSubstitution && node.id && noSubstitution[node.id];
        }
      }
      ts3.transformSystemModule = transformSystemModule;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformECMAScriptModule(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory;
        var host = context.getEmitHost();
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableEmitNotification(305);
        context.enableSubstitution(79);
        var helperNameSubstitutions;
        var currentSourceFile;
        var importRequireStatements;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          if (ts3.isExternalModule(node) || compilerOptions.isolatedModules) {
            currentSourceFile = node;
            importRequireStatements = void 0;
            var result2 = updateExternalModule(node);
            currentSourceFile = void 0;
            if (importRequireStatements) {
              result2 = factory.updateSourceFile(result2, ts3.setTextRange(factory.createNodeArray(ts3.insertStatementsAfterCustomPrologue(result2.statements.slice(), importRequireStatements)), result2.statements));
            }
            if (!ts3.isExternalModule(node) || ts3.some(result2.statements, ts3.isExternalModuleIndicator)) {
              return result2;
            }
            return factory.updateSourceFile(result2, ts3.setTextRange(factory.createNodeArray(__spreadArray(__spreadArray([], result2.statements, true), [ts3.createEmptyExports(factory)], false)), result2.statements));
          }
          return node;
        }
        function updateExternalModule(node) {
          var externalHelpersImportDeclaration = ts3.createExternalHelpersImportDeclarationIfNeeded(factory, emitHelpers(), node, compilerOptions);
          if (externalHelpersImportDeclaration) {
            var statements = [];
            var statementOffset = factory.copyPrologue(node.statements, statements);
            ts3.append(statements, externalHelpersImportDeclaration);
            ts3.addRange(statements, ts3.visitNodes(node.statements, visitor, ts3.isStatement, statementOffset));
            return factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray(statements), node.statements));
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitor(node) {
          switch (node.kind) {
            case 265:
              return ts3.getEmitScriptTarget(compilerOptions) >= ts3.ModuleKind.ES2020 ? visitImportEqualsDeclaration(node) : void 0;
            case 271:
              return visitExportAssignment(node);
            case 272:
              var exportDecl = node;
              return visitExportDeclaration(exportDecl);
          }
          return node;
        }
        function createRequireCall(importNode) {
          var moduleName = ts3.getExternalModuleNameLiteral(factory, importNode, ts3.Debug.checkDefined(currentSourceFile), host, resolver, compilerOptions);
          var args = [];
          if (moduleName) {
            args.push(moduleName);
          }
          if (!importRequireStatements) {
            var createRequireName = factory.createUniqueName("_createRequire", 16 | 32);
            var importStatement = factory.createImportDeclaration(void 0, void 0, factory.createImportClause(false, void 0, factory.createNamedImports([
              factory.createImportSpecifier(false, factory.createIdentifier("createRequire"), createRequireName)
            ])), factory.createStringLiteral("module"));
            var requireHelperName = factory.createUniqueName("__require", 16 | 32);
            var requireStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(requireHelperName, void 0, void 0, factory.createCallExpression(factory.cloneNode(createRequireName), void 0, [
                factory.createPropertyAccessExpression(factory.createMetaProperty(100, factory.createIdentifier("meta")), factory.createIdentifier("url"))
              ]))
            ], languageVersion >= 2 ? 2 : 0));
            importRequireStatements = [importStatement, requireStatement];
          }
          var name = importRequireStatements[1].declarationList.declarations[0].name;
          ts3.Debug.assertNode(name, ts3.isIdentifier);
          return factory.createCallExpression(factory.cloneNode(name), void 0, args);
        }
        function visitImportEqualsDeclaration(node) {
          ts3.Debug.assert(ts3.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(factory.cloneNode(node.name), void 0, void 0, createRequireCall(node))
          ], languageVersion >= 2 ? 2 : 0)), node), node));
          statements = appendExportsOfImportEqualsDeclaration(statements, node);
          return ts3.singleOrMany(statements);
        }
        function appendExportsOfImportEqualsDeclaration(statements, node) {
          if (ts3.hasSyntacticModifier(node, 1)) {
            statements = ts3.append(statements, factory.createExportDeclaration(void 0, void 0, node.isTypeOnly, factory.createNamedExports([factory.createExportSpecifier(false, void 0, ts3.idText(node.name))])));
          }
          return statements;
        }
        function visitExportAssignment(node) {
          return node.isExportEquals ? void 0 : node;
        }
        function visitExportDeclaration(node) {
          if (compilerOptions.module !== void 0 && compilerOptions.module > ts3.ModuleKind.ES2015) {
            return node;
          }
          if (!node.exportClause || !ts3.isNamespaceExport(node.exportClause) || !node.moduleSpecifier) {
            return node;
          }
          var oldIdentifier = node.exportClause.name;
          var synthName = factory.getGeneratedNameForNode(oldIdentifier);
          var importDecl = factory.createImportDeclaration(void 0, void 0, factory.createImportClause(false, void 0, factory.createNamespaceImport(synthName)), node.moduleSpecifier, node.assertClause);
          ts3.setOriginalNode(importDecl, node.exportClause);
          var exportDecl = ts3.isExportNamespaceAsDefaultDeclaration(node) ? factory.createExportDefault(synthName) : factory.createExportDeclaration(void 0, void 0, false, factory.createNamedExports([factory.createExportSpecifier(false, synthName, oldIdentifier)]));
          ts3.setOriginalNode(exportDecl, node);
          return [importDecl, exportDecl];
        }
        function onEmitNode(hint, node, emitCallback) {
          if (ts3.isSourceFile(node)) {
            if ((ts3.isExternalModule(node) || compilerOptions.isolatedModules) && compilerOptions.importHelpers) {
              helperNameSubstitutions = new ts3.Map();
            }
            previousOnEmitNode(hint, node, emitCallback);
            helperNameSubstitutions = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (helperNameSubstitutions && ts3.isIdentifier(node) && ts3.getEmitFlags(node) & 4096) {
            return substituteHelperName(node);
          }
          return node;
        }
        function substituteHelperName(node) {
          var name = ts3.idText(node);
          var substitution = helperNameSubstitutions.get(name);
          if (!substitution) {
            helperNameSubstitutions.set(name, substitution = factory.createUniqueName(name, 16 | 32));
          }
          return substitution;
        }
      }
      ts3.transformECMAScriptModule = transformECMAScriptModule;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformNodeModule(context) {
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        var esmTransform = ts3.transformECMAScriptModule(context);
        var esmOnSubstituteNode = context.onSubstituteNode;
        var esmOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = previousOnSubstituteNode;
        context.onEmitNode = previousOnEmitNode;
        var cjsTransform = ts3.transformModule(context);
        var cjsOnSubstituteNode = context.onSubstituteNode;
        var cjsOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(305);
        context.enableEmitNotification(305);
        var currentSourceFile;
        return transformSourceFileOrBundle;
        function onSubstituteNode(hint, node) {
          if (ts3.isSourceFile(node)) {
            currentSourceFile = node;
            return previousOnSubstituteNode(hint, node);
          } else {
            if (!currentSourceFile) {
              return previousOnSubstituteNode(hint, node);
            }
            if (currentSourceFile.impliedNodeFormat === ts3.ModuleKind.ESNext) {
              return esmOnSubstituteNode(hint, node);
            }
            return cjsOnSubstituteNode(hint, node);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (ts3.isSourceFile(node)) {
            currentSourceFile = node;
          }
          if (!currentSourceFile) {
            return previousOnEmitNode(hint, node, emitCallback);
          }
          if (currentSourceFile.impliedNodeFormat === ts3.ModuleKind.ESNext) {
            return esmOnEmitNode(hint, node, emitCallback);
          }
          return cjsOnEmitNode(hint, node, emitCallback);
        }
        function getModuleTransformForFile(file) {
          return file.impliedNodeFormat === ts3.ModuleKind.ESNext ? esmTransform : cjsTransform;
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var result2 = getModuleTransformForFile(node)(node);
          currentSourceFile = void 0;
          ts3.Debug.assert(ts3.isSourceFile(result2));
          return result2;
        }
        function transformSourceFileOrBundle(node) {
          return node.kind === 305 ? transformSourceFile(node) : transformBundle(node);
        }
        function transformBundle(node) {
          return context.factory.createBundle(ts3.map(node.sourceFiles, transformSourceFile), node.prepends);
        }
      }
      ts3.transformNodeModule = transformNodeModule;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function canProduceDiagnostics(node) {
        return ts3.isVariableDeclaration(node) || ts3.isPropertyDeclaration(node) || ts3.isPropertySignature(node) || ts3.isBindingElement(node) || ts3.isSetAccessor(node) || ts3.isGetAccessor(node) || ts3.isConstructSignatureDeclaration(node) || ts3.isCallSignatureDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isFunctionDeclaration(node) || ts3.isParameter(node) || ts3.isTypeParameterDeclaration(node) || ts3.isExpressionWithTypeArguments(node) || ts3.isImportEqualsDeclaration(node) || ts3.isTypeAliasDeclaration(node) || ts3.isConstructorDeclaration(node) || ts3.isIndexSignatureDeclaration(node) || ts3.isPropertyAccessExpression(node) || ts3.isJSDocTypeAlias(node);
      }
      ts3.canProduceDiagnostics = canProduceDiagnostics;
      function createGetSymbolAccessibilityDiagnosticForNodeName(node) {
        if (ts3.isSetAccessor(node) || ts3.isGetAccessor(node)) {
          return getAccessorNameVisibilityError;
        } else if (ts3.isMethodSignature(node) || ts3.isMethodDeclaration(node)) {
          return getMethodNameVisibilityError;
        } else {
          return createGetSymbolAccessibilityDiagnosticForNode(node);
        }
        function getAccessorNameVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (ts3.isStatic(node)) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
          } else if (node.parent.kind === 257) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
          } else {
            return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
          }
        }
        function getMethodNameVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (ts3.isStatic(node)) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1;
          } else if (node.parent.kind === 257) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1;
          } else {
            return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1;
          }
        }
      }
      ts3.createGetSymbolAccessibilityDiagnosticForNodeName = createGetSymbolAccessibilityDiagnosticForNodeName;
      function createGetSymbolAccessibilityDiagnosticForNode(node) {
        if (ts3.isVariableDeclaration(node) || ts3.isPropertyDeclaration(node) || ts3.isPropertySignature(node) || ts3.isPropertyAccessExpression(node) || ts3.isBindingElement(node) || ts3.isConstructorDeclaration(node)) {
          return getVariableDeclarationTypeVisibilityError;
        } else if (ts3.isSetAccessor(node) || ts3.isGetAccessor(node)) {
          return getAccessorDeclarationTypeVisibilityError;
        } else if (ts3.isConstructSignatureDeclaration(node) || ts3.isCallSignatureDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isFunctionDeclaration(node) || ts3.isIndexSignatureDeclaration(node)) {
          return getReturnTypeVisibilityError;
        } else if (ts3.isParameter(node)) {
          if (ts3.isParameterPropertyDeclaration(node, node.parent) && ts3.hasSyntacticModifier(node.parent, 8)) {
            return getVariableDeclarationTypeVisibilityError;
          }
          return getParameterDeclarationTypeVisibilityError;
        } else if (ts3.isTypeParameterDeclaration(node)) {
          return getTypeParameterConstraintVisibilityError;
        } else if (ts3.isExpressionWithTypeArguments(node)) {
          return getHeritageClauseVisibilityError;
        } else if (ts3.isImportEqualsDeclaration(node)) {
          return getImportEntityNameVisibilityError;
        } else if (ts3.isTypeAliasDeclaration(node) || ts3.isJSDocTypeAlias(node)) {
          return getTypeAliasDeclarationVisibilityError;
        } else {
          return ts3.Debug.assertNever(node, "Attempted to set a declaration diagnostic context for unhandled node kind: ".concat(ts3.SyntaxKind[node.kind]));
        }
        function getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (node.kind === 254 || node.kind === 203) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1;
          } else if (node.kind === 167 || node.kind === 206 || node.kind === 166 || node.kind === 164 && ts3.hasSyntacticModifier(node.parent, 8)) {
            if (ts3.isStatic(node)) {
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
            } else if (node.parent.kind === 257 || node.kind === 164) {
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
            } else {
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
            }
          }
        }
        function getVariableDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getAccessorDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage;
          if (node.kind === 173) {
            if (ts3.isStatic(node)) {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1;
            } else {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1;
            }
          } else {
            if (ts3.isStatic(node)) {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1;
            } else {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1;
            }
          }
          return {
            diagnosticMessage,
            errorNode: node.name,
            typeName: node.name
          };
        }
        function getReturnTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage;
          switch (node.kind) {
            case 175:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 174:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 176:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 169:
            case 168:
              if (ts3.isStatic(node)) {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0;
              } else if (node.parent.kind === 257) {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0;
              } else {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;
              }
              break;
            case 256:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts3.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;
              break;
            default:
              return ts3.Debug.fail("This is unknown kind for signature: " + node.kind);
          }
          return {
            diagnosticMessage,
            errorNode: node.name || node
          };
        }
        function getParameterDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          switch (node.parent.kind) {
            case 171:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;
            case 175:
            case 180:
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 174:
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 176:
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 169:
            case 168:
              if (ts3.isStatic(node.parent)) {
                return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
              } else if (node.parent.parent.kind === 257) {
                return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
              } else {
                return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
              }
            case 256:
            case 179:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;
            case 173:
            case 172:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_accessor_has_or_is_using_private_name_1;
            default:
              return ts3.Debug.fail("Unknown parent for parameter: ".concat(ts3.SyntaxKind[node.parent.kind]));
          }
        }
        function getTypeParameterConstraintVisibilityError() {
          var diagnosticMessage;
          switch (node.parent.kind) {
            case 257:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;
              break;
            case 258:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;
              break;
            case 195:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;
              break;
            case 180:
            case 175:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
              break;
            case 174:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
              break;
            case 169:
            case 168:
              if (ts3.isStatic(node.parent)) {
                diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
              } else if (node.parent.parent.kind === 257) {
                diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
              } else {
                diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
              }
              break;
            case 179:
            case 256:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;
              break;
            case 259:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;
              break;
            default:
              return ts3.Debug.fail("This is unknown parent for type parameter: " + node.parent.kind);
          }
          return {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          };
        }
        function getHeritageClauseVisibilityError() {
          var diagnosticMessage;
          if (ts3.isClassDeclaration(node.parent.parent)) {
            diagnosticMessage = ts3.isHeritageClause(node.parent) && node.parent.token === 117 ? ts3.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1 : node.parent.parent.name ? ts3.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1 : ts3.Diagnostics.extends_clause_of_exported_class_has_or_is_using_private_name_0;
          } else {
            diagnosticMessage = ts3.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1;
          }
          return {
            diagnosticMessage,
            errorNode: node,
            typeName: ts3.getNameOfDeclaration(node.parent.parent)
          };
        }
        function getImportEntityNameVisibilityError() {
          return {
            diagnosticMessage: ts3.Diagnostics.Import_declaration_0_is_using_private_name_1,
            errorNode: node,
            typeName: node.name
          };
        }
        function getTypeAliasDeclarationVisibilityError(symbolAccessibilityResult) {
          return {
            diagnosticMessage: symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2 : ts3.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,
            errorNode: ts3.isJSDocTypeAlias(node) ? ts3.Debug.checkDefined(node.typeExpression) : node.type,
            typeName: ts3.isJSDocTypeAlias(node) ? ts3.getNameOfDeclaration(node) : node.name
          };
        }
      }
      ts3.createGetSymbolAccessibilityDiagnosticForNode = createGetSymbolAccessibilityDiagnosticForNode;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getDeclarationDiagnostics(host, resolver, file) {
        var compilerOptions = host.getCompilerOptions();
        var result2 = ts3.transformNodes(resolver, host, ts3.factory, compilerOptions, file ? [file] : ts3.filter(host.getSourceFiles(), ts3.isSourceFileNotJson), [transformDeclarations], false);
        return result2.diagnostics;
      }
      ts3.getDeclarationDiagnostics = getDeclarationDiagnostics;
      function hasInternalAnnotation(range, currentSourceFile) {
        var comment = currentSourceFile.text.substring(range.pos, range.end);
        return ts3.stringContains(comment, "@internal");
      }
      function isInternalDeclaration(node, currentSourceFile) {
        var parseTreeNode = ts3.getParseTreeNode(node);
        if (parseTreeNode && parseTreeNode.kind === 164) {
          var paramIdx = parseTreeNode.parent.parameters.indexOf(parseTreeNode);
          var previousSibling = paramIdx > 0 ? parseTreeNode.parent.parameters[paramIdx - 1] : void 0;
          var text = currentSourceFile.text;
          var commentRanges = previousSibling ? ts3.concatenate(ts3.getTrailingCommentRanges(text, ts3.skipTrivia(text, previousSibling.end + 1, false, true)), ts3.getLeadingCommentRanges(text, node.pos)) : ts3.getTrailingCommentRanges(text, ts3.skipTrivia(text, node.pos, false, true));
          return commentRanges && commentRanges.length && hasInternalAnnotation(ts3.last(commentRanges), currentSourceFile);
        }
        var leadingCommentRanges = parseTreeNode && ts3.getLeadingCommentRangesOfNode(parseTreeNode, currentSourceFile);
        return !!ts3.forEach(leadingCommentRanges, function(range) {
          return hasInternalAnnotation(range, currentSourceFile);
        });
      }
      ts3.isInternalDeclaration = isInternalDeclaration;
      var declarationEmitNodeBuilderFlags = 1024 | 2048 | 4096 | 8 | 524288 | 4 | 1;
      function transformDeclarations(context) {
        var throwDiagnostic = function() {
          return ts3.Debug.fail("Diagnostic emitted without context");
        };
        var getSymbolAccessibilityDiagnostic = throwDiagnostic;
        var needsDeclare = true;
        var isBundledEmit = false;
        var resultHasExternalModuleIndicator = false;
        var needsScopeFixMarker = false;
        var resultHasScopeMarker = false;
        var enclosingDeclaration;
        var necessaryTypeReferences;
        var lateMarkedStatements;
        var lateStatementReplacementMap;
        var suppressNewDiagnosticContexts;
        var exportedModulesFromDeclarationEmit;
        var factory = context.factory;
        var host = context.getEmitHost();
        var symbolTracker = {
          trackSymbol,
          reportInaccessibleThisError,
          reportInaccessibleUniqueSymbolError,
          reportCyclicStructureError,
          reportPrivateInBaseOfClassExpression,
          reportLikelyUnsafeImportRequiredError,
          reportTruncationError,
          moduleResolverHost: host,
          trackReferencedAmbientModule,
          trackExternalModuleSymbolOfImportTypeNode,
          reportNonlocalAugmentation,
          reportNonSerializableProperty,
          reportImportTypeNodeResolutionModeOverride
        };
        var errorNameNode;
        var errorFallbackNode;
        var currentSourceFile;
        var refs;
        var libs;
        var emittedImports;
        var resolver = context.getEmitResolver();
        var options = context.getCompilerOptions();
        var noResolve = options.noResolve, stripInternal = options.stripInternal;
        return transformRoot;
        function recordTypeReferenceDirectivesIfNecessary(typeReferenceDirectives) {
          if (!typeReferenceDirectives) {
            return;
          }
          necessaryTypeReferences = necessaryTypeReferences || new ts3.Set();
          for (var _i = 0, typeReferenceDirectives_2 = typeReferenceDirectives; _i < typeReferenceDirectives_2.length; _i++) {
            var ref = typeReferenceDirectives_2[_i];
            necessaryTypeReferences.add(ref);
          }
        }
        function trackReferencedAmbientModule(node, symbol) {
          var directives = resolver.getTypeReferenceDirectivesForSymbol(symbol, 67108863);
          if (ts3.length(directives)) {
            return recordTypeReferenceDirectivesIfNecessary(directives);
          }
          var container = ts3.getSourceFileOfNode(node);
          refs.set(ts3.getOriginalNodeId(container), container);
        }
        function handleSymbolAccessibilityError(symbolAccessibilityResult) {
          if (symbolAccessibilityResult.accessibility === 0) {
            if (symbolAccessibilityResult && symbolAccessibilityResult.aliasesToMakeVisible) {
              if (!lateMarkedStatements) {
                lateMarkedStatements = symbolAccessibilityResult.aliasesToMakeVisible;
              } else {
                for (var _i = 0, _a = symbolAccessibilityResult.aliasesToMakeVisible; _i < _a.length; _i++) {
                  var ref = _a[_i];
                  ts3.pushIfUnique(lateMarkedStatements, ref);
                }
              }
            }
          } else {
            var errorInfo = getSymbolAccessibilityDiagnostic(symbolAccessibilityResult);
            if (errorInfo) {
              if (errorInfo.typeName) {
                context.addDiagnostic(ts3.createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, ts3.getTextOfNode(errorInfo.typeName), symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
              } else {
                context.addDiagnostic(ts3.createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
              }
              return true;
            }
          }
          return false;
        }
        function trackExternalModuleSymbolOfImportTypeNode(symbol) {
          if (!isBundledEmit) {
            (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
          }
        }
        function trackSymbol(symbol, enclosingDeclaration2, meaning) {
          if (symbol.flags & 262144)
            return false;
          var issuedDiagnostic = handleSymbolAccessibilityError(resolver.isSymbolAccessible(symbol, enclosingDeclaration2, meaning, true));
          recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForSymbol(symbol, meaning));
          return issuedDiagnostic;
        }
        function reportPrivateInBaseOfClassExpression(propertyName) {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected, propertyName));
          }
        }
        function errorDeclarationNameWithFallback() {
          return errorNameNode ? ts3.declarationNameToString(errorNameNode) : errorFallbackNode && ts3.getNameOfDeclaration(errorFallbackNode) ? ts3.declarationNameToString(ts3.getNameOfDeclaration(errorFallbackNode)) : errorFallbackNode && ts3.isExportAssignment(errorFallbackNode) ? errorFallbackNode.isExportEquals ? "export=" : "default" : "(Missing)";
        }
        function reportInaccessibleUniqueSymbolError() {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, errorDeclarationNameWithFallback(), "unique symbol"));
          }
        }
        function reportCyclicStructureError() {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary, errorDeclarationNameWithFallback()));
          }
        }
        function reportInaccessibleThisError() {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, errorDeclarationNameWithFallback(), "this"));
          }
        }
        function reportLikelyUnsafeImportRequiredError(specifier) {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary, errorDeclarationNameWithFallback(), specifier));
          }
        }
        function reportTruncationError() {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed));
          }
        }
        function reportNonlocalAugmentation(containingFile, parentSymbol, symbol) {
          var _a;
          var primaryDeclaration = (_a = parentSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(function(d) {
            return ts3.getSourceFileOfNode(d) === containingFile;
          });
          var augmentingDeclarations = ts3.filter(symbol.declarations, function(d) {
            return ts3.getSourceFileOfNode(d) !== containingFile;
          });
          if (augmentingDeclarations) {
            for (var _i = 0, augmentingDeclarations_1 = augmentingDeclarations; _i < augmentingDeclarations_1.length; _i++) {
              var augmentations = augmentingDeclarations_1[_i];
              context.addDiagnostic(ts3.addRelatedInfo(ts3.createDiagnosticForNode(augmentations, ts3.Diagnostics.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized), ts3.createDiagnosticForNode(primaryDeclaration, ts3.Diagnostics.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)));
            }
          }
        }
        function reportNonSerializableProperty(propertyName) {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized, propertyName));
          }
        }
        function reportImportTypeNodeResolutionModeOverride() {
          if (!ts3.isNightly() && (errorNameNode || errorFallbackNode)) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_type_of_this_expression_cannot_be_named_without_a_resolution_mode_assertion_which_is_an_unstable_feature_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next));
          }
        }
        function transformDeclarationsForJS(sourceFile, bundled) {
          var oldDiag = getSymbolAccessibilityDiagnostic;
          getSymbolAccessibilityDiagnostic = function(s) {
            return s.errorNode && ts3.canProduceDiagnostics(s.errorNode) ? ts3.createGetSymbolAccessibilityDiagnosticForNode(s.errorNode)(s) : {
              diagnosticMessage: s.errorModuleName ? ts3.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit : ts3.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit,
              errorNode: s.errorNode || sourceFile
            };
          };
          var result2 = resolver.getDeclarationStatementsForSourceFile(sourceFile, declarationEmitNodeBuilderFlags, symbolTracker, bundled);
          getSymbolAccessibilityDiagnostic = oldDiag;
          return result2;
        }
        function transformRoot(node) {
          if (node.kind === 305 && node.isDeclarationFile) {
            return node;
          }
          if (node.kind === 306) {
            isBundledEmit = true;
            refs = new ts3.Map();
            libs = new ts3.Map();
            var hasNoDefaultLib_1 = false;
            var bundle = factory.createBundle(ts3.map(node.sourceFiles, function(sourceFile) {
              if (sourceFile.isDeclarationFile)
                return void 0;
              hasNoDefaultLib_1 = hasNoDefaultLib_1 || sourceFile.hasNoDefaultLib;
              currentSourceFile = sourceFile;
              enclosingDeclaration = sourceFile;
              lateMarkedStatements = void 0;
              suppressNewDiagnosticContexts = false;
              lateStatementReplacementMap = new ts3.Map();
              getSymbolAccessibilityDiagnostic = throwDiagnostic;
              needsScopeFixMarker = false;
              resultHasScopeMarker = false;
              collectReferences(sourceFile, refs);
              collectLibs(sourceFile, libs);
              if (ts3.isExternalOrCommonJsModule(sourceFile) || ts3.isJsonSourceFile(sourceFile)) {
                resultHasExternalModuleIndicator = false;
                needsDeclare = false;
                var statements2 = ts3.isSourceFileJS(sourceFile) ? factory.createNodeArray(transformDeclarationsForJS(sourceFile, true)) : ts3.visitNodes(sourceFile.statements, visitDeclarationStatements);
                var newFile = factory.updateSourceFile(sourceFile, [factory.createModuleDeclaration([], [factory.createModifier(135)], factory.createStringLiteral(ts3.getResolvedExternalModuleName(context.getEmitHost(), sourceFile)), factory.createModuleBlock(ts3.setTextRange(factory.createNodeArray(transformAndReplaceLatePaintedStatements(statements2)), sourceFile.statements)))], true, [], [], false, []);
                return newFile;
              }
              needsDeclare = true;
              var updated2 = ts3.isSourceFileJS(sourceFile) ? factory.createNodeArray(transformDeclarationsForJS(sourceFile)) : ts3.visitNodes(sourceFile.statements, visitDeclarationStatements);
              return factory.updateSourceFile(sourceFile, transformAndReplaceLatePaintedStatements(updated2), true, [], [], false, []);
            }), ts3.mapDefined(node.prepends, function(prepend) {
              if (prepend.kind === 308) {
                var sourceFile = ts3.createUnparsedSourceFile(prepend, "dts", stripInternal);
                hasNoDefaultLib_1 = hasNoDefaultLib_1 || !!sourceFile.hasNoDefaultLib;
                collectReferences(sourceFile, refs);
                recordTypeReferenceDirectivesIfNecessary(ts3.map(sourceFile.typeReferenceDirectives, function(ref) {
                  return [ref.fileName, ref.resolutionMode];
                }));
                collectLibs(sourceFile, libs);
                return sourceFile;
              }
              return prepend;
            }));
            bundle.syntheticFileReferences = [];
            bundle.syntheticTypeReferences = getFileReferencesForUsedTypeReferences();
            bundle.syntheticLibReferences = getLibReferences();
            bundle.hasNoDefaultLib = hasNoDefaultLib_1;
            var outputFilePath_1 = ts3.getDirectoryPath(ts3.normalizeSlashes(ts3.getOutputPathsFor(node, host, true).declarationFilePath));
            var referenceVisitor_1 = mapReferencesIntoArray(bundle.syntheticFileReferences, outputFilePath_1);
            refs.forEach(referenceVisitor_1);
            return bundle;
          }
          needsDeclare = true;
          needsScopeFixMarker = false;
          resultHasScopeMarker = false;
          enclosingDeclaration = node;
          currentSourceFile = node;
          getSymbolAccessibilityDiagnostic = throwDiagnostic;
          isBundledEmit = false;
          resultHasExternalModuleIndicator = false;
          suppressNewDiagnosticContexts = false;
          lateMarkedStatements = void 0;
          lateStatementReplacementMap = new ts3.Map();
          necessaryTypeReferences = void 0;
          refs = collectReferences(currentSourceFile, new ts3.Map());
          libs = collectLibs(currentSourceFile, new ts3.Map());
          var references = [];
          var outputFilePath = ts3.getDirectoryPath(ts3.normalizeSlashes(ts3.getOutputPathsFor(node, host, true).declarationFilePath));
          var referenceVisitor = mapReferencesIntoArray(references, outputFilePath);
          var combinedStatements;
          if (ts3.isSourceFileJS(currentSourceFile)) {
            combinedStatements = factory.createNodeArray(transformDeclarationsForJS(node));
            refs.forEach(referenceVisitor);
            emittedImports = ts3.filter(combinedStatements, ts3.isAnyImportSyntax);
          } else {
            var statements = ts3.visitNodes(node.statements, visitDeclarationStatements);
            combinedStatements = ts3.setTextRange(factory.createNodeArray(transformAndReplaceLatePaintedStatements(statements)), node.statements);
            refs.forEach(referenceVisitor);
            emittedImports = ts3.filter(combinedStatements, ts3.isAnyImportSyntax);
            if (ts3.isExternalModule(node) && (!resultHasExternalModuleIndicator || needsScopeFixMarker && !resultHasScopeMarker)) {
              combinedStatements = ts3.setTextRange(factory.createNodeArray(__spreadArray(__spreadArray([], combinedStatements, true), [ts3.createEmptyExports(factory)], false)), combinedStatements);
            }
          }
          var updated = factory.updateSourceFile(node, combinedStatements, true, references, getFileReferencesForUsedTypeReferences(), node.hasNoDefaultLib, getLibReferences());
          updated.exportedModulesFromDeclarationEmit = exportedModulesFromDeclarationEmit;
          return updated;
          function getLibReferences() {
            return ts3.map(ts3.arrayFrom(libs.keys()), function(lib) {
              return { fileName: lib, pos: -1, end: -1 };
            });
          }
          function getFileReferencesForUsedTypeReferences() {
            return necessaryTypeReferences ? ts3.mapDefined(ts3.arrayFrom(necessaryTypeReferences.keys()), getFileReferenceForSpecifierModeTuple) : [];
          }
          function getFileReferenceForSpecifierModeTuple(_a) {
            var typeName = _a[0], mode = _a[1];
            if (emittedImports) {
              for (var _i = 0, emittedImports_1 = emittedImports; _i < emittedImports_1.length; _i++) {
                var importStatement = emittedImports_1[_i];
                if (ts3.isImportEqualsDeclaration(importStatement) && ts3.isExternalModuleReference(importStatement.moduleReference)) {
                  var expr = importStatement.moduleReference.expression;
                  if (ts3.isStringLiteralLike(expr) && expr.text === typeName) {
                    return void 0;
                  }
                } else if (ts3.isImportDeclaration(importStatement) && ts3.isStringLiteral(importStatement.moduleSpecifier) && importStatement.moduleSpecifier.text === typeName) {
                  return void 0;
                }
              }
            }
            return __assign({ fileName: typeName, pos: -1, end: -1 }, mode ? { resolutionMode: mode } : void 0);
          }
          function mapReferencesIntoArray(references2, outputFilePath2) {
            return function(file) {
              var declFileName;
              if (file.isDeclarationFile) {
                declFileName = file.fileName;
              } else {
                if (isBundledEmit && ts3.contains(node.sourceFiles, file))
                  return;
                var paths = ts3.getOutputPathsFor(file, host, true);
                declFileName = paths.declarationFilePath || paths.jsFilePath || file.fileName;
              }
              if (declFileName) {
                var specifier = ts3.moduleSpecifiers.getModuleSpecifier(options, currentSourceFile, ts3.toPath(outputFilePath2, host.getCurrentDirectory(), host.getCanonicalFileName), ts3.toPath(declFileName, host.getCurrentDirectory(), host.getCanonicalFileName), host);
                if (!ts3.pathIsRelative(specifier)) {
                  recordTypeReferenceDirectivesIfNecessary([[specifier, void 0]]);
                  return;
                }
                var fileName2 = ts3.getRelativePathToDirectoryOrUrl(outputFilePath2, declFileName, host.getCurrentDirectory(), host.getCanonicalFileName, false);
                if (ts3.startsWith(fileName2, "./") && ts3.hasExtension(fileName2)) {
                  fileName2 = fileName2.substring(2);
                }
                if (ts3.startsWith(fileName2, "node_modules/") || ts3.pathContainsNodeModules(fileName2)) {
                  return;
                }
                references2.push({ pos: -1, end: -1, fileName: fileName2 });
              }
            };
          }
        }
        function collectReferences(sourceFile, ret) {
          if (noResolve || !ts3.isUnparsedSource(sourceFile) && ts3.isSourceFileJS(sourceFile))
            return ret;
          ts3.forEach(sourceFile.referencedFiles, function(f) {
            var elem = host.getSourceFileFromReference(sourceFile, f);
            if (elem) {
              ret.set(ts3.getOriginalNodeId(elem), elem);
            }
          });
          return ret;
        }
        function collectLibs(sourceFile, ret) {
          ts3.forEach(sourceFile.libReferenceDirectives, function(ref) {
            var lib = host.getLibFileFromReference(ref);
            if (lib) {
              ret.set(ts3.toFileNameLowerCase(ref.fileName), true);
            }
          });
          return ret;
        }
        function filterBindingPatternInitializers(name) {
          if (name.kind === 79) {
            return name;
          } else {
            if (name.kind === 202) {
              return factory.updateArrayBindingPattern(name, ts3.visitNodes(name.elements, visitBindingElement));
            } else {
              return factory.updateObjectBindingPattern(name, ts3.visitNodes(name.elements, visitBindingElement));
            }
          }
          function visitBindingElement(elem) {
            if (elem.kind === 227) {
              return elem;
            }
            return factory.updateBindingElement(elem, elem.dotDotDotToken, elem.propertyName, filterBindingPatternInitializers(elem.name), shouldPrintWithInitializer(elem) ? elem.initializer : void 0);
          }
        }
        function ensureParameter(p, modifierMask, type2) {
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(p);
          }
          var newParam = factory.updateParameterDeclaration(p, void 0, maskModifiers(p, modifierMask), p.dotDotDotToken, filterBindingPatternInitializers(p.name), resolver.isOptionalParameter(p) ? p.questionToken || factory.createToken(57) : void 0, ensureType(p, type2 || p.type, true), ensureNoInitializer(p));
          if (!suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = oldDiag;
          }
          return newParam;
        }
        function shouldPrintWithInitializer(node) {
          return canHaveLiteralInitializer(node) && resolver.isLiteralConstDeclaration(ts3.getParseTreeNode(node));
        }
        function ensureNoInitializer(node) {
          if (shouldPrintWithInitializer(node)) {
            return resolver.createLiteralConstValue(ts3.getParseTreeNode(node), symbolTracker);
          }
          return void 0;
        }
        function ensureType(node, type2, ignorePrivate) {
          if (!ignorePrivate && ts3.hasEffectiveModifier(node, 8)) {
            return;
          }
          if (shouldPrintWithInitializer(node)) {
            return;
          }
          var shouldUseResolverType = node.kind === 164 && (resolver.isRequiredInitializedParameter(node) || resolver.isOptionalUninitializedParameterProperty(node));
          if (type2 && !shouldUseResolverType) {
            return ts3.visitNode(type2, visitDeclarationSubtree);
          }
          if (!ts3.getParseTreeNode(node)) {
            return type2 ? ts3.visitNode(type2, visitDeclarationSubtree) : factory.createKeywordTypeNode(130);
          }
          if (node.kind === 173) {
            return factory.createKeywordTypeNode(130);
          }
          errorNameNode = node.name;
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(node);
          }
          if (node.kind === 254 || node.kind === 203) {
            return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          }
          if (node.kind === 164 || node.kind === 167 || node.kind === 166) {
            if (!node.initializer)
              return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType));
            return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType) || resolver.createTypeOfExpression(node.initializer, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          }
          return cleanup(resolver.createReturnTypeOfSignatureDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          function cleanup(returnValue) {
            errorNameNode = void 0;
            if (!suppressNewDiagnosticContexts) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            return returnValue || factory.createKeywordTypeNode(130);
          }
        }
        function isDeclarationAndNotVisible(node) {
          node = ts3.getParseTreeNode(node);
          switch (node.kind) {
            case 256:
            case 261:
            case 258:
            case 257:
            case 259:
            case 260:
              return !resolver.isDeclarationVisible(node);
            case 254:
              return !getBindingNameVisible(node);
            case 265:
            case 266:
            case 272:
            case 271:
              return false;
            case 170:
              return true;
          }
          return false;
        }
        function shouldEmitFunctionProperties(input) {
          var _a;
          if (input.body) {
            return true;
          }
          var overloadSignatures = (_a = input.symbol.declarations) === null || _a === void 0 ? void 0 : _a.filter(function(decl) {
            return ts3.isFunctionDeclaration(decl) && !decl.body;
          });
          return !overloadSignatures || overloadSignatures.indexOf(input) === overloadSignatures.length - 1;
        }
        function getBindingNameVisible(elem) {
          if (ts3.isOmittedExpression(elem)) {
            return false;
          }
          if (ts3.isBindingPattern(elem.name)) {
            return ts3.some(elem.name.elements, getBindingNameVisible);
          } else {
            return resolver.isDeclarationVisible(elem);
          }
        }
        function updateParamsList(node, params, modifierMask) {
          if (ts3.hasEffectiveModifier(node, 8)) {
            return void 0;
          }
          var newParams = ts3.map(params, function(p) {
            return ensureParameter(p, modifierMask);
          });
          if (!newParams) {
            return void 0;
          }
          return factory.createNodeArray(newParams, params.hasTrailingComma);
        }
        function updateAccessorParamsList(input, isPrivate) {
          var newParams;
          if (!isPrivate) {
            var thisParameter = ts3.getThisParameter(input);
            if (thisParameter) {
              newParams = [ensureParameter(thisParameter)];
            }
          }
          if (ts3.isSetAccessorDeclaration(input)) {
            var newValueParameter = void 0;
            if (!isPrivate) {
              var valueParameter = ts3.getSetAccessorValueParameter(input);
              if (valueParameter) {
                var accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
                newValueParameter = ensureParameter(valueParameter, void 0, accessorType);
              }
            }
            if (!newValueParameter) {
              newValueParameter = factory.createParameterDeclaration(void 0, void 0, void 0, "value");
            }
            newParams = ts3.append(newParams, newValueParameter);
          }
          return factory.createNodeArray(newParams || ts3.emptyArray);
        }
        function ensureTypeParams(node, params) {
          return ts3.hasEffectiveModifier(node, 8) ? void 0 : ts3.visitNodes(params, visitDeclarationSubtree);
        }
        function isEnclosingDeclaration(node) {
          return ts3.isSourceFile(node) || ts3.isTypeAliasDeclaration(node) || ts3.isModuleDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isInterfaceDeclaration(node) || ts3.isFunctionLike(node) || ts3.isIndexSignatureDeclaration(node) || ts3.isMappedTypeNode(node);
        }
        function checkEntityNameVisibility(entityName, enclosingDeclaration2) {
          var visibilityResult = resolver.isEntityNameVisible(entityName, enclosingDeclaration2);
          handleSymbolAccessibilityError(visibilityResult);
          recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForEntityName(entityName));
        }
        function preserveJsDoc(updated, original) {
          if (ts3.hasJSDocNodes(updated) && ts3.hasJSDocNodes(original)) {
            updated.jsDoc = original.jsDoc;
          }
          return ts3.setCommentRange(updated, ts3.getCommentRange(original));
        }
        function rewriteModuleSpecifier(parent, input) {
          if (!input)
            return void 0;
          resultHasExternalModuleIndicator = resultHasExternalModuleIndicator || parent.kind !== 261 && parent.kind !== 200;
          if (ts3.isStringLiteralLike(input)) {
            if (isBundledEmit) {
              var newName = ts3.getExternalModuleNameFromDeclaration(context.getEmitHost(), resolver, parent);
              if (newName) {
                return factory.createStringLiteral(newName);
              }
            } else {
              var symbol = resolver.getSymbolOfExternalModuleSpecifier(input);
              if (symbol) {
                (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
              }
            }
          }
          return input;
        }
        function transformImportEqualsDeclaration(decl) {
          if (!resolver.isDeclarationVisible(decl))
            return;
          if (decl.moduleReference.kind === 277) {
            var specifier = ts3.getExternalModuleImportEqualsDeclarationExpression(decl);
            return factory.updateImportEqualsDeclaration(decl, void 0, decl.modifiers, decl.isTypeOnly, decl.name, factory.updateExternalModuleReference(decl.moduleReference, rewriteModuleSpecifier(decl, specifier)));
          } else {
            var oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(decl);
            checkEntityNameVisibility(decl.moduleReference, enclosingDeclaration);
            getSymbolAccessibilityDiagnostic = oldDiag;
            return decl;
          }
        }
        function transformImportDeclaration(decl) {
          if (!decl.importClause) {
            return factory.updateImportDeclaration(decl, void 0, decl.modifiers, decl.importClause, rewriteModuleSpecifier(decl, decl.moduleSpecifier), getResolutionModeOverrideForClauseInNightly(decl.assertClause));
          }
          var visibleDefaultBinding = decl.importClause && decl.importClause.name && resolver.isDeclarationVisible(decl.importClause) ? decl.importClause.name : void 0;
          if (!decl.importClause.namedBindings) {
            return visibleDefaultBinding && factory.updateImportDeclaration(decl, void 0, decl.modifiers, factory.updateImportClause(decl.importClause, decl.importClause.isTypeOnly, visibleDefaultBinding, void 0), rewriteModuleSpecifier(decl, decl.moduleSpecifier), getResolutionModeOverrideForClauseInNightly(decl.assertClause));
          }
          if (decl.importClause.namedBindings.kind === 268) {
            var namedBindings = resolver.isDeclarationVisible(decl.importClause.namedBindings) ? decl.importClause.namedBindings : void 0;
            return visibleDefaultBinding || namedBindings ? factory.updateImportDeclaration(decl, void 0, decl.modifiers, factory.updateImportClause(decl.importClause, decl.importClause.isTypeOnly, visibleDefaultBinding, namedBindings), rewriteModuleSpecifier(decl, decl.moduleSpecifier), getResolutionModeOverrideForClauseInNightly(decl.assertClause)) : void 0;
          }
          var bindingList = ts3.mapDefined(decl.importClause.namedBindings.elements, function(b) {
            return resolver.isDeclarationVisible(b) ? b : void 0;
          });
          if (bindingList && bindingList.length || visibleDefaultBinding) {
            return factory.updateImportDeclaration(decl, void 0, decl.modifiers, factory.updateImportClause(decl.importClause, decl.importClause.isTypeOnly, visibleDefaultBinding, bindingList && bindingList.length ? factory.updateNamedImports(decl.importClause.namedBindings, bindingList) : void 0), rewriteModuleSpecifier(decl, decl.moduleSpecifier), getResolutionModeOverrideForClauseInNightly(decl.assertClause));
          }
          if (resolver.isImportRequiredByAugmentation(decl)) {
            return factory.updateImportDeclaration(decl, void 0, decl.modifiers, void 0, rewriteModuleSpecifier(decl, decl.moduleSpecifier), getResolutionModeOverrideForClauseInNightly(decl.assertClause));
          }
        }
        function getResolutionModeOverrideForClauseInNightly(assertClause) {
          var mode = ts3.getResolutionModeOverrideForClause(assertClause);
          if (mode !== void 0) {
            if (!ts3.isNightly()) {
              context.addDiagnostic(ts3.createDiagnosticForNode(assertClause, ts3.Diagnostics.resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next));
            }
            return assertClause;
          }
          return void 0;
        }
        function transformAndReplaceLatePaintedStatements(statements) {
          while (ts3.length(lateMarkedStatements)) {
            var i = lateMarkedStatements.shift();
            if (!ts3.isLateVisibilityPaintedStatement(i)) {
              return ts3.Debug.fail("Late replaced statement was found which is not handled by the declaration transformer!: ".concat(ts3.SyntaxKind ? ts3.SyntaxKind[i.kind] : i.kind));
            }
            var priorNeedsDeclare = needsDeclare;
            needsDeclare = i.parent && ts3.isSourceFile(i.parent) && !(ts3.isExternalModule(i.parent) && isBundledEmit);
            var result2 = transformTopLevelDeclaration(i);
            needsDeclare = priorNeedsDeclare;
            lateStatementReplacementMap.set(ts3.getOriginalNodeId(i), result2);
          }
          return ts3.visitNodes(statements, visitLateVisibilityMarkedStatements);
          function visitLateVisibilityMarkedStatements(statement) {
            if (ts3.isLateVisibilityPaintedStatement(statement)) {
              var key = ts3.getOriginalNodeId(statement);
              if (lateStatementReplacementMap.has(key)) {
                var result3 = lateStatementReplacementMap.get(key);
                lateStatementReplacementMap.delete(key);
                if (result3) {
                  if (ts3.isArray(result3) ? ts3.some(result3, ts3.needsScopeMarker) : ts3.needsScopeMarker(result3)) {
                    needsScopeFixMarker = true;
                  }
                  if (ts3.isSourceFile(statement.parent) && (ts3.isArray(result3) ? ts3.some(result3, ts3.isExternalModuleIndicator) : ts3.isExternalModuleIndicator(result3))) {
                    resultHasExternalModuleIndicator = true;
                  }
                }
                return result3;
              }
            }
            return statement;
          }
        }
        function visitDeclarationSubtree(input) {
          if (shouldStripInternal(input))
            return;
          if (ts3.isDeclaration(input)) {
            if (isDeclarationAndNotVisible(input))
              return;
            if (ts3.hasDynamicName(input) && !resolver.isLateBound(ts3.getParseTreeNode(input))) {
              return;
            }
          }
          if (ts3.isFunctionLike(input) && resolver.isImplementationOfOverload(input))
            return;
          if (ts3.isSemicolonClassElement(input))
            return;
          var previousEnclosingDeclaration;
          if (isEnclosingDeclaration(input)) {
            previousEnclosingDeclaration = enclosingDeclaration;
            enclosingDeclaration = input;
          }
          var oldDiag = getSymbolAccessibilityDiagnostic;
          var canProduceDiagnostic = ts3.canProduceDiagnostics(input);
          var oldWithinObjectLiteralType = suppressNewDiagnosticContexts;
          var shouldEnterSuppressNewDiagnosticsContextContext = (input.kind === 182 || input.kind === 195) && input.parent.kind !== 259;
          if (ts3.isMethodDeclaration(input) || ts3.isMethodSignature(input)) {
            if (ts3.hasEffectiveModifier(input, 8)) {
              if (input.symbol && input.symbol.declarations && input.symbol.declarations[0] !== input)
                return;
              return cleanup(factory.createPropertyDeclaration(void 0, ensureModifiers(input), input.name, void 0, void 0, void 0));
            }
          }
          if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(input);
          }
          if (ts3.isTypeQueryNode(input)) {
            checkEntityNameVisibility(input.exprName, enclosingDeclaration);
          }
          if (shouldEnterSuppressNewDiagnosticsContextContext) {
            suppressNewDiagnosticContexts = true;
          }
          if (isProcessedComponent(input)) {
            switch (input.kind) {
              case 228: {
                if (ts3.isEntityName(input.expression) || ts3.isEntityNameExpression(input.expression)) {
                  checkEntityNameVisibility(input.expression, enclosingDeclaration);
                }
                var node = ts3.visitEachChild(input, visitDeclarationSubtree, context);
                return cleanup(factory.updateExpressionWithTypeArguments(node, node.expression, node.typeArguments));
              }
              case 178: {
                checkEntityNameVisibility(input.typeName, enclosingDeclaration);
                var node = ts3.visitEachChild(input, visitDeclarationSubtree, context);
                return cleanup(factory.updateTypeReferenceNode(node, node.typeName, node.typeArguments));
              }
              case 175:
                return cleanup(factory.updateConstructSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              case 171: {
                var ctor = factory.createConstructorDeclaration(void 0, ensureModifiers(input), updateParamsList(input, input.parameters, 0), void 0);
                return cleanup(ctor);
              }
              case 169: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                var sig = factory.createMethodDeclaration(void 0, ensureModifiers(input), void 0, input.name, input.questionToken, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type), void 0);
                return cleanup(sig);
              }
              case 172: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                var accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
                return cleanup(factory.updateGetAccessorDeclaration(input, void 0, ensureModifiers(input), input.name, updateAccessorParamsList(input, ts3.hasEffectiveModifier(input, 8)), ensureType(input, accessorType), void 0));
              }
              case 173: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updateSetAccessorDeclaration(input, void 0, ensureModifiers(input), input.name, updateAccessorParamsList(input, ts3.hasEffectiveModifier(input, 8)), void 0));
              }
              case 167:
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updatePropertyDeclaration(input, void 0, ensureModifiers(input), input.name, input.questionToken, ensureType(input, input.type), ensureNoInitializer(input)));
              case 166:
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updatePropertySignature(input, ensureModifiers(input), input.name, input.questionToken, ensureType(input, input.type)));
              case 168: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updateMethodSignature(input, ensureModifiers(input), input.name, input.questionToken, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              }
              case 174: {
                return cleanup(factory.updateCallSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              }
              case 176: {
                return cleanup(factory.updateIndexSignature(input, void 0, ensureModifiers(input), updateParamsList(input, input.parameters), ts3.visitNode(input.type, visitDeclarationSubtree) || factory.createKeywordTypeNode(130)));
              }
              case 254: {
                if (ts3.isBindingPattern(input.name)) {
                  return recreateBindingPattern(input.name);
                }
                shouldEnterSuppressNewDiagnosticsContextContext = true;
                suppressNewDiagnosticContexts = true;
                return cleanup(factory.updateVariableDeclaration(input, input.name, void 0, ensureType(input, input.type), ensureNoInitializer(input)));
              }
              case 163: {
                if (isPrivateMethodTypeParameter(input) && (input.default || input.constraint)) {
                  return cleanup(factory.updateTypeParameterDeclaration(input, input.modifiers, input.name, void 0, void 0));
                }
                return cleanup(ts3.visitEachChild(input, visitDeclarationSubtree, context));
              }
              case 189: {
                var checkType = ts3.visitNode(input.checkType, visitDeclarationSubtree);
                var extendsType = ts3.visitNode(input.extendsType, visitDeclarationSubtree);
                var oldEnclosingDecl = enclosingDeclaration;
                enclosingDeclaration = input.trueType;
                var trueType = ts3.visitNode(input.trueType, visitDeclarationSubtree);
                enclosingDeclaration = oldEnclosingDecl;
                var falseType = ts3.visitNode(input.falseType, visitDeclarationSubtree);
                return cleanup(factory.updateConditionalTypeNode(input, checkType, extendsType, trueType, falseType));
              }
              case 179: {
                return cleanup(factory.updateFunctionTypeNode(input, ts3.visitNodes(input.typeParameters, visitDeclarationSubtree), updateParamsList(input, input.parameters), ts3.visitNode(input.type, visitDeclarationSubtree)));
              }
              case 180: {
                return cleanup(factory.updateConstructorTypeNode(input, ensureModifiers(input), ts3.visitNodes(input.typeParameters, visitDeclarationSubtree), updateParamsList(input, input.parameters), ts3.visitNode(input.type, visitDeclarationSubtree)));
              }
              case 200: {
                if (!ts3.isLiteralImportTypeNode(input))
                  return cleanup(input);
                return cleanup(factory.updateImportTypeNode(input, factory.updateLiteralTypeNode(input.argument, rewriteModuleSpecifier(input, input.argument.literal)), input.assertions, input.qualifier, ts3.visitNodes(input.typeArguments, visitDeclarationSubtree, ts3.isTypeNode), input.isTypeOf));
              }
              default:
                ts3.Debug.assertNever(input, "Attempted to process unhandled node kind: ".concat(ts3.SyntaxKind[input.kind]));
            }
          }
          if (ts3.isTupleTypeNode(input) && ts3.getLineAndCharacterOfPosition(currentSourceFile, input.pos).line === ts3.getLineAndCharacterOfPosition(currentSourceFile, input.end).line) {
            ts3.setEmitFlags(input, 1);
          }
          return cleanup(ts3.visitEachChild(input, visitDeclarationSubtree, context));
          function cleanup(returnValue) {
            if (returnValue && canProduceDiagnostic && ts3.hasDynamicName(input)) {
              checkName(input);
            }
            if (isEnclosingDeclaration(input)) {
              enclosingDeclaration = previousEnclosingDeclaration;
            }
            if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            if (shouldEnterSuppressNewDiagnosticsContextContext) {
              suppressNewDiagnosticContexts = oldWithinObjectLiteralType;
            }
            if (returnValue === input) {
              return returnValue;
            }
            return returnValue && ts3.setOriginalNode(preserveJsDoc(returnValue, input), input);
          }
        }
        function isPrivateMethodTypeParameter(node) {
          return node.parent.kind === 169 && ts3.hasEffectiveModifier(node.parent, 8);
        }
        function visitDeclarationStatements(input) {
          if (!isPreservedDeclarationStatement(input)) {
            return;
          }
          if (shouldStripInternal(input))
            return;
          switch (input.kind) {
            case 272: {
              if (ts3.isSourceFile(input.parent)) {
                resultHasExternalModuleIndicator = true;
              }
              resultHasScopeMarker = true;
              return factory.updateExportDeclaration(input, void 0, input.modifiers, input.isTypeOnly, input.exportClause, rewriteModuleSpecifier(input, input.moduleSpecifier), ts3.getResolutionModeOverrideForClause(input.assertClause) ? input.assertClause : void 0);
            }
            case 271: {
              if (ts3.isSourceFile(input.parent)) {
                resultHasExternalModuleIndicator = true;
              }
              resultHasScopeMarker = true;
              if (input.expression.kind === 79) {
                return input;
              } else {
                var newId = factory.createUniqueName("_default", 16);
                getSymbolAccessibilityDiagnostic = function() {
                  return {
                    diagnosticMessage: ts3.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,
                    errorNode: input
                  };
                };
                errorFallbackNode = input;
                var varDecl = factory.createVariableDeclaration(newId, void 0, resolver.createTypeOfExpression(input.expression, input, declarationEmitNodeBuilderFlags, symbolTracker), void 0);
                errorFallbackNode = void 0;
                var statement = factory.createVariableStatement(needsDeclare ? [factory.createModifier(135)] : [], factory.createVariableDeclarationList([varDecl], 2));
                preserveJsDoc(statement, input);
                ts3.removeAllComments(input);
                return [statement, factory.updateExportAssignment(input, input.decorators, input.modifiers, newId)];
              }
            }
          }
          var result2 = transformTopLevelDeclaration(input);
          lateStatementReplacementMap.set(ts3.getOriginalNodeId(input), result2);
          return input;
        }
        function stripExportModifiers(statement) {
          if (ts3.isImportEqualsDeclaration(statement) || ts3.hasEffectiveModifier(statement, 512) || !ts3.canHaveModifiers(statement)) {
            return statement;
          }
          var modifiers = factory.createModifiersFromModifierFlags(ts3.getEffectiveModifierFlags(statement) & (125951 ^ 1));
          return factory.updateModifiers(statement, modifiers);
        }
        function transformTopLevelDeclaration(input) {
          if (lateMarkedStatements) {
            while (ts3.orderedRemoveItem(lateMarkedStatements, input))
              ;
          }
          if (shouldStripInternal(input))
            return;
          switch (input.kind) {
            case 265: {
              return transformImportEqualsDeclaration(input);
            }
            case 266: {
              return transformImportDeclaration(input);
            }
          }
          if (ts3.isDeclaration(input) && isDeclarationAndNotVisible(input))
            return;
          if (ts3.isFunctionLike(input) && resolver.isImplementationOfOverload(input))
            return;
          var previousEnclosingDeclaration;
          if (isEnclosingDeclaration(input)) {
            previousEnclosingDeclaration = enclosingDeclaration;
            enclosingDeclaration = input;
          }
          var canProdiceDiagnostic = ts3.canProduceDiagnostics(input);
          var oldDiag = getSymbolAccessibilityDiagnostic;
          if (canProdiceDiagnostic) {
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(input);
          }
          var previousNeedsDeclare = needsDeclare;
          switch (input.kind) {
            case 259:
              return cleanup(factory.updateTypeAliasDeclaration(input, void 0, ensureModifiers(input), input.name, ts3.visitNodes(input.typeParameters, visitDeclarationSubtree, ts3.isTypeParameterDeclaration), ts3.visitNode(input.type, visitDeclarationSubtree, ts3.isTypeNode)));
            case 258: {
              return cleanup(factory.updateInterfaceDeclaration(input, void 0, ensureModifiers(input), input.name, ensureTypeParams(input, input.typeParameters), transformHeritageClauses(input.heritageClauses), ts3.visitNodes(input.members, visitDeclarationSubtree)));
            }
            case 256: {
              var clean = cleanup(factory.updateFunctionDeclaration(input, void 0, ensureModifiers(input), void 0, input.name, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type), void 0));
              if (clean && resolver.isExpandoFunctionDeclaration(input) && shouldEmitFunctionProperties(input)) {
                var props = resolver.getPropertiesOfContainerFunction(input);
                var fakespace_1 = ts3.parseNodeFactory.createModuleDeclaration(void 0, void 0, clean.name || factory.createIdentifier("_default"), factory.createModuleBlock([]), 16);
                ts3.setParent(fakespace_1, enclosingDeclaration);
                fakespace_1.locals = ts3.createSymbolTable(props);
                fakespace_1.symbol = props[0].parent;
                var exportMappings_1 = [];
                var declarations = ts3.mapDefined(props, function(p) {
                  if (!p.valueDeclaration || !ts3.isPropertyAccessExpression(p.valueDeclaration)) {
                    return void 0;
                  }
                  getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(p.valueDeclaration);
                  var type2 = resolver.createTypeOfDeclaration(p.valueDeclaration, fakespace_1, declarationEmitNodeBuilderFlags, symbolTracker);
                  getSymbolAccessibilityDiagnostic = oldDiag;
                  var nameStr = ts3.unescapeLeadingUnderscores(p.escapedName);
                  var isNonContextualKeywordName = ts3.isStringANonContextualKeyword(nameStr);
                  var name = isNonContextualKeywordName ? factory.getGeneratedNameForNode(p.valueDeclaration) : factory.createIdentifier(nameStr);
                  if (isNonContextualKeywordName) {
                    exportMappings_1.push([name, nameStr]);
                  }
                  var varDecl2 = factory.createVariableDeclaration(name, void 0, type2, void 0);
                  return factory.createVariableStatement(isNonContextualKeywordName ? void 0 : [factory.createToken(93)], factory.createVariableDeclarationList([varDecl2]));
                });
                if (!exportMappings_1.length) {
                  declarations = ts3.mapDefined(declarations, function(declaration) {
                    return factory.updateModifiers(declaration, 0);
                  });
                } else {
                  declarations.push(factory.createExportDeclaration(void 0, void 0, false, factory.createNamedExports(ts3.map(exportMappings_1, function(_a) {
                    var gen = _a[0], exp = _a[1];
                    return factory.createExportSpecifier(false, gen, exp);
                  }))));
                }
                var namespaceDecl = factory.createModuleDeclaration(void 0, ensureModifiers(input), input.name, factory.createModuleBlock(declarations), 16);
                if (!ts3.hasEffectiveModifier(clean, 512)) {
                  return [clean, namespaceDecl];
                }
                var modifiers = factory.createModifiersFromModifierFlags(ts3.getEffectiveModifierFlags(clean) & ~513 | 2);
                var cleanDeclaration = factory.updateFunctionDeclaration(clean, void 0, modifiers, void 0, clean.name, clean.typeParameters, clean.parameters, clean.type, void 0);
                var namespaceDeclaration = factory.updateModuleDeclaration(namespaceDecl, void 0, modifiers, namespaceDecl.name, namespaceDecl.body);
                var exportDefaultDeclaration = factory.createExportAssignment(void 0, void 0, false, namespaceDecl.name);
                if (ts3.isSourceFile(input.parent)) {
                  resultHasExternalModuleIndicator = true;
                }
                resultHasScopeMarker = true;
                return [cleanDeclaration, namespaceDeclaration, exportDefaultDeclaration];
              } else {
                return clean;
              }
            }
            case 261: {
              needsDeclare = false;
              var inner = input.body;
              if (inner && inner.kind === 262) {
                var oldNeedsScopeFix = needsScopeFixMarker;
                var oldHasScopeFix = resultHasScopeMarker;
                resultHasScopeMarker = false;
                needsScopeFixMarker = false;
                var statements = ts3.visitNodes(inner.statements, visitDeclarationStatements);
                var lateStatements = transformAndReplaceLatePaintedStatements(statements);
                if (input.flags & 16777216) {
                  needsScopeFixMarker = false;
                }
                if (!ts3.isGlobalScopeAugmentation(input) && !hasScopeMarker(lateStatements) && !resultHasScopeMarker) {
                  if (needsScopeFixMarker) {
                    lateStatements = factory.createNodeArray(__spreadArray(__spreadArray([], lateStatements, true), [ts3.createEmptyExports(factory)], false));
                  } else {
                    lateStatements = ts3.visitNodes(lateStatements, stripExportModifiers);
                  }
                }
                var body = factory.updateModuleBlock(inner, lateStatements);
                needsDeclare = previousNeedsDeclare;
                needsScopeFixMarker = oldNeedsScopeFix;
                resultHasScopeMarker = oldHasScopeFix;
                var mods = ensureModifiers(input);
                return cleanup(factory.updateModuleDeclaration(input, void 0, mods, ts3.isExternalModuleAugmentation(input) ? rewriteModuleSpecifier(input, input.name) : input.name, body));
              } else {
                needsDeclare = previousNeedsDeclare;
                var mods = ensureModifiers(input);
                needsDeclare = false;
                ts3.visitNode(inner, visitDeclarationStatements);
                var id = ts3.getOriginalNodeId(inner);
                var body = lateStatementReplacementMap.get(id);
                lateStatementReplacementMap.delete(id);
                return cleanup(factory.updateModuleDeclaration(input, void 0, mods, input.name, body));
              }
            }
            case 257: {
              errorNameNode = input.name;
              errorFallbackNode = input;
              var modifiers = factory.createNodeArray(ensureModifiers(input));
              var typeParameters = ensureTypeParams(input, input.typeParameters);
              var ctor = ts3.getFirstConstructorWithBody(input);
              var parameterProperties = void 0;
              if (ctor) {
                var oldDiag_1 = getSymbolAccessibilityDiagnostic;
                parameterProperties = ts3.compact(ts3.flatMap(ctor.parameters, function(param) {
                  if (!ts3.hasSyntacticModifier(param, 16476) || shouldStripInternal(param))
                    return;
                  getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(param);
                  if (param.name.kind === 79) {
                    return preserveJsDoc(factory.createPropertyDeclaration(void 0, ensureModifiers(param), param.name, param.questionToken, ensureType(param, param.type), ensureNoInitializer(param)), param);
                  } else {
                    return walkBindingPattern(param.name);
                  }
                  function walkBindingPattern(pattern) {
                    var elems;
                    for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
                      var elem = _a[_i];
                      if (ts3.isOmittedExpression(elem))
                        continue;
                      if (ts3.isBindingPattern(elem.name)) {
                        elems = ts3.concatenate(elems, walkBindingPattern(elem.name));
                      }
                      elems = elems || [];
                      elems.push(factory.createPropertyDeclaration(void 0, ensureModifiers(param), elem.name, void 0, ensureType(elem, void 0), void 0));
                    }
                    return elems;
                  }
                }));
                getSymbolAccessibilityDiagnostic = oldDiag_1;
              }
              var hasPrivateIdentifier = ts3.some(input.members, function(member) {
                return !!member.name && ts3.isPrivateIdentifier(member.name);
              });
              var privateIdentifier = hasPrivateIdentifier ? [
                factory.createPropertyDeclaration(void 0, void 0, factory.createPrivateIdentifier("#private"), void 0, void 0, void 0)
              ] : void 0;
              var memberNodes = ts3.concatenate(ts3.concatenate(privateIdentifier, parameterProperties), ts3.visitNodes(input.members, visitDeclarationSubtree));
              var members = factory.createNodeArray(memberNodes);
              var extendsClause_1 = ts3.getEffectiveBaseTypeNode(input);
              if (extendsClause_1 && !ts3.isEntityNameExpression(extendsClause_1.expression) && extendsClause_1.expression.kind !== 104) {
                var oldId = input.name ? ts3.unescapeLeadingUnderscores(input.name.escapedText) : "default";
                var newId_1 = factory.createUniqueName("".concat(oldId, "_base"), 16);
                getSymbolAccessibilityDiagnostic = function() {
                  return {
                    diagnosticMessage: ts3.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,
                    errorNode: extendsClause_1,
                    typeName: input.name
                  };
                };
                var varDecl = factory.createVariableDeclaration(newId_1, void 0, resolver.createTypeOfExpression(extendsClause_1.expression, input, declarationEmitNodeBuilderFlags, symbolTracker), void 0);
                var statement = factory.createVariableStatement(needsDeclare ? [factory.createModifier(135)] : [], factory.createVariableDeclarationList([varDecl], 2));
                var heritageClauses = factory.createNodeArray(ts3.map(input.heritageClauses, function(clause) {
                  if (clause.token === 94) {
                    var oldDiag_2 = getSymbolAccessibilityDiagnostic;
                    getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(clause.types[0]);
                    var newClause = factory.updateHeritageClause(clause, ts3.map(clause.types, function(t) {
                      return factory.updateExpressionWithTypeArguments(t, newId_1, ts3.visitNodes(t.typeArguments, visitDeclarationSubtree));
                    }));
                    getSymbolAccessibilityDiagnostic = oldDiag_2;
                    return newClause;
                  }
                  return factory.updateHeritageClause(clause, ts3.visitNodes(factory.createNodeArray(ts3.filter(clause.types, function(t) {
                    return ts3.isEntityNameExpression(t.expression) || t.expression.kind === 104;
                  })), visitDeclarationSubtree));
                }));
                return [statement, cleanup(factory.updateClassDeclaration(input, void 0, modifiers, input.name, typeParameters, heritageClauses, members))];
              } else {
                var heritageClauses = transformHeritageClauses(input.heritageClauses);
                return cleanup(factory.updateClassDeclaration(input, void 0, modifiers, input.name, typeParameters, heritageClauses, members));
              }
            }
            case 237: {
              return cleanup(transformVariableStatement(input));
            }
            case 260: {
              return cleanup(factory.updateEnumDeclaration(input, void 0, factory.createNodeArray(ensureModifiers(input)), input.name, factory.createNodeArray(ts3.mapDefined(input.members, function(m) {
                if (shouldStripInternal(m))
                  return;
                var constValue = resolver.getConstantValue(m);
                return preserveJsDoc(factory.updateEnumMember(m, m.name, constValue !== void 0 ? typeof constValue === "string" ? factory.createStringLiteral(constValue) : factory.createNumericLiteral(constValue) : void 0), m);
              }))));
            }
          }
          return ts3.Debug.assertNever(input, "Unhandled top-level node in declaration emit: ".concat(ts3.SyntaxKind[input.kind]));
          function cleanup(node) {
            if (isEnclosingDeclaration(input)) {
              enclosingDeclaration = previousEnclosingDeclaration;
            }
            if (canProdiceDiagnostic) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            if (input.kind === 261) {
              needsDeclare = previousNeedsDeclare;
            }
            if (node === input) {
              return node;
            }
            errorFallbackNode = void 0;
            errorNameNode = void 0;
            return node && ts3.setOriginalNode(preserveJsDoc(node, input), input);
          }
        }
        function transformVariableStatement(input) {
          if (!ts3.forEach(input.declarationList.declarations, getBindingNameVisible))
            return;
          var nodes = ts3.visitNodes(input.declarationList.declarations, visitDeclarationSubtree);
          if (!ts3.length(nodes))
            return;
          return factory.updateVariableStatement(input, factory.createNodeArray(ensureModifiers(input)), factory.updateVariableDeclarationList(input.declarationList, nodes));
        }
        function recreateBindingPattern(d) {
          return ts3.flatten(ts3.mapDefined(d.elements, function(e) {
            return recreateBindingElement(e);
          }));
        }
        function recreateBindingElement(e) {
          if (e.kind === 227) {
            return;
          }
          if (e.name) {
            if (!getBindingNameVisible(e))
              return;
            if (ts3.isBindingPattern(e.name)) {
              return recreateBindingPattern(e.name);
            } else {
              return factory.createVariableDeclaration(e.name, void 0, ensureType(e, void 0), void 0);
            }
          }
        }
        function checkName(node) {
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNodeName(node);
          }
          errorNameNode = node.name;
          ts3.Debug.assert(resolver.isLateBound(ts3.getParseTreeNode(node)));
          var decl = node;
          var entityName = decl.name.expression;
          checkEntityNameVisibility(entityName, enclosingDeclaration);
          if (!suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = oldDiag;
          }
          errorNameNode = void 0;
        }
        function shouldStripInternal(node) {
          return !!stripInternal && !!node && isInternalDeclaration(node, currentSourceFile);
        }
        function isScopeMarker(node) {
          return ts3.isExportAssignment(node) || ts3.isExportDeclaration(node);
        }
        function hasScopeMarker(statements) {
          return ts3.some(statements, isScopeMarker);
        }
        function ensureModifiers(node) {
          var currentFlags = ts3.getEffectiveModifierFlags(node);
          var newFlags = ensureModifierFlags(node);
          if (currentFlags === newFlags) {
            return node.modifiers;
          }
          return factory.createModifiersFromModifierFlags(newFlags);
        }
        function ensureModifierFlags(node) {
          var mask = 125951 ^ (4 | 256 | 16384);
          var additions = needsDeclare && !isAlwaysType(node) ? 2 : 0;
          var parentIsFile = node.parent.kind === 305;
          if (!parentIsFile || isBundledEmit && parentIsFile && ts3.isExternalModule(node.parent)) {
            mask ^= 2;
            additions = 0;
          }
          return maskModifierFlags(node, mask, additions);
        }
        function getTypeAnnotationFromAllAccessorDeclarations(node, accessors) {
          var accessorType = getTypeAnnotationFromAccessor(node);
          if (!accessorType && node !== accessors.firstAccessor) {
            accessorType = getTypeAnnotationFromAccessor(accessors.firstAccessor);
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(accessors.firstAccessor);
          }
          if (!accessorType && accessors.secondAccessor && node !== accessors.secondAccessor) {
            accessorType = getTypeAnnotationFromAccessor(accessors.secondAccessor);
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(accessors.secondAccessor);
          }
          return accessorType;
        }
        function transformHeritageClauses(nodes) {
          return factory.createNodeArray(ts3.filter(ts3.map(nodes, function(clause) {
            return factory.updateHeritageClause(clause, ts3.visitNodes(factory.createNodeArray(ts3.filter(clause.types, function(t) {
              return ts3.isEntityNameExpression(t.expression) || clause.token === 94 && t.expression.kind === 104;
            })), visitDeclarationSubtree));
          }), function(clause) {
            return clause.types && !!clause.types.length;
          }));
        }
      }
      ts3.transformDeclarations = transformDeclarations;
      function isAlwaysType(node) {
        if (node.kind === 258) {
          return true;
        }
        return false;
      }
      function maskModifiers(node, modifierMask, modifierAdditions) {
        return ts3.factory.createModifiersFromModifierFlags(maskModifierFlags(node, modifierMask, modifierAdditions));
      }
      function maskModifierFlags(node, modifierMask, modifierAdditions) {
        if (modifierMask === void 0) {
          modifierMask = 125951 ^ 4;
        }
        if (modifierAdditions === void 0) {
          modifierAdditions = 0;
        }
        var flags = ts3.getEffectiveModifierFlags(node) & modifierMask | modifierAdditions;
        if (flags & 512 && !(flags & 1)) {
          flags ^= 1;
        }
        if (flags & 512 && flags & 2) {
          flags ^= 2;
        }
        return flags;
      }
      function getTypeAnnotationFromAccessor(accessor) {
        if (accessor) {
          return accessor.kind === 172 ? accessor.type : accessor.parameters.length > 0 ? accessor.parameters[0].type : void 0;
        }
      }
      function canHaveLiteralInitializer(node) {
        switch (node.kind) {
          case 167:
          case 166:
            return !ts3.hasEffectiveModifier(node, 8);
          case 164:
          case 254:
            return true;
        }
        return false;
      }
      function isPreservedDeclarationStatement(node) {
        switch (node.kind) {
          case 256:
          case 261:
          case 265:
          case 258:
          case 257:
          case 259:
          case 260:
          case 237:
          case 266:
          case 272:
          case 271:
            return true;
        }
        return false;
      }
      function isProcessedComponent(node) {
        switch (node.kind) {
          case 175:
          case 171:
          case 169:
          case 172:
          case 173:
          case 167:
          case 166:
          case 168:
          case 174:
          case 176:
          case 254:
          case 163:
          case 228:
          case 178:
          case 189:
          case 179:
          case 180:
          case 200:
            return true;
        }
        return false;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getModuleTransformer(moduleKind) {
        switch (moduleKind) {
          case ts3.ModuleKind.ESNext:
          case ts3.ModuleKind.ES2022:
          case ts3.ModuleKind.ES2020:
          case ts3.ModuleKind.ES2015:
            return ts3.transformECMAScriptModule;
          case ts3.ModuleKind.System:
            return ts3.transformSystemModule;
          case ts3.ModuleKind.Node16:
          case ts3.ModuleKind.NodeNext:
            return ts3.transformNodeModule;
          default:
            return ts3.transformModule;
        }
      }
      var TransformationState;
      (function(TransformationState2) {
        TransformationState2[TransformationState2["Uninitialized"] = 0] = "Uninitialized";
        TransformationState2[TransformationState2["Initialized"] = 1] = "Initialized";
        TransformationState2[TransformationState2["Completed"] = 2] = "Completed";
        TransformationState2[TransformationState2["Disposed"] = 3] = "Disposed";
      })(TransformationState || (TransformationState = {}));
      var SyntaxKindFeatureFlags;
      (function(SyntaxKindFeatureFlags2) {
        SyntaxKindFeatureFlags2[SyntaxKindFeatureFlags2["Substitution"] = 1] = "Substitution";
        SyntaxKindFeatureFlags2[SyntaxKindFeatureFlags2["EmitNotifications"] = 2] = "EmitNotifications";
      })(SyntaxKindFeatureFlags || (SyntaxKindFeatureFlags = {}));
      ts3.noTransformers = { scriptTransformers: ts3.emptyArray, declarationTransformers: ts3.emptyArray };
      function getTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles) {
        return {
          scriptTransformers: getScriptTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles),
          declarationTransformers: getDeclarationTransformers(customTransformers)
        };
      }
      ts3.getTransformers = getTransformers;
      function getScriptTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles) {
        if (emitOnlyDtsFiles)
          return ts3.emptyArray;
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var transformers = [];
        ts3.addRange(transformers, customTransformers && ts3.map(customTransformers.before, wrapScriptTransformerFactory));
        transformers.push(ts3.transformTypeScript);
        transformers.push(ts3.transformClassFields);
        if (ts3.getJSXTransformEnabled(compilerOptions)) {
          transformers.push(ts3.transformJsx);
        }
        if (languageVersion < 99) {
          transformers.push(ts3.transformESNext);
        }
        if (languageVersion < 8) {
          transformers.push(ts3.transformES2021);
        }
        if (languageVersion < 7) {
          transformers.push(ts3.transformES2020);
        }
        if (languageVersion < 6) {
          transformers.push(ts3.transformES2019);
        }
        if (languageVersion < 5) {
          transformers.push(ts3.transformES2018);
        }
        if (languageVersion < 4) {
          transformers.push(ts3.transformES2017);
        }
        if (languageVersion < 3) {
          transformers.push(ts3.transformES2016);
        }
        if (languageVersion < 2) {
          transformers.push(ts3.transformES2015);
          transformers.push(ts3.transformGenerators);
        }
        transformers.push(getModuleTransformer(moduleKind));
        if (languageVersion < 1) {
          transformers.push(ts3.transformES5);
        }
        ts3.addRange(transformers, customTransformers && ts3.map(customTransformers.after, wrapScriptTransformerFactory));
        return transformers;
      }
      function getDeclarationTransformers(customTransformers) {
        var transformers = [];
        transformers.push(ts3.transformDeclarations);
        ts3.addRange(transformers, customTransformers && ts3.map(customTransformers.afterDeclarations, wrapDeclarationTransformerFactory));
        return transformers;
      }
      function wrapCustomTransformer(transformer) {
        return function(node) {
          return ts3.isBundle(node) ? transformer.transformBundle(node) : transformer.transformSourceFile(node);
        };
      }
      function wrapCustomTransformerFactory(transformer, handleDefault) {
        return function(context) {
          var customTransformer = transformer(context);
          return typeof customTransformer === "function" ? handleDefault(context, customTransformer) : wrapCustomTransformer(customTransformer);
        };
      }
      function wrapScriptTransformerFactory(transformer) {
        return wrapCustomTransformerFactory(transformer, ts3.chainBundle);
      }
      function wrapDeclarationTransformerFactory(transformer) {
        return wrapCustomTransformerFactory(transformer, function(_, node) {
          return node;
        });
      }
      function noEmitSubstitution(_hint, node) {
        return node;
      }
      ts3.noEmitSubstitution = noEmitSubstitution;
      function noEmitNotification(hint, node, callback) {
        callback(hint, node);
      }
      ts3.noEmitNotification = noEmitNotification;
      function transformNodes(resolver, host, factory, options, nodes, transformers, allowDtsFiles) {
        var enabledSyntaxKindFeatures = new Array(355);
        var lexicalEnvironmentVariableDeclarations;
        var lexicalEnvironmentFunctionDeclarations;
        var lexicalEnvironmentStatements;
        var lexicalEnvironmentFlags = 0;
        var lexicalEnvironmentVariableDeclarationsStack = [];
        var lexicalEnvironmentFunctionDeclarationsStack = [];
        var lexicalEnvironmentStatementsStack = [];
        var lexicalEnvironmentFlagsStack = [];
        var lexicalEnvironmentStackOffset = 0;
        var lexicalEnvironmentSuspended = false;
        var blockScopedVariableDeclarationsStack = [];
        var blockScopeStackOffset = 0;
        var blockScopedVariableDeclarations;
        var emitHelpers;
        var onSubstituteNode = noEmitSubstitution;
        var onEmitNode = noEmitNotification;
        var state = 0;
        var diagnostics = [];
        var context = {
          factory,
          getCompilerOptions: function() {
            return options;
          },
          getEmitResolver: function() {
            return resolver;
          },
          getEmitHost: function() {
            return host;
          },
          getEmitHelperFactory: ts3.memoize(function() {
            return ts3.createEmitHelperFactory(context);
          }),
          startLexicalEnvironment,
          suspendLexicalEnvironment,
          resumeLexicalEnvironment,
          endLexicalEnvironment,
          setLexicalEnvironmentFlags,
          getLexicalEnvironmentFlags,
          hoistVariableDeclaration,
          hoistFunctionDeclaration,
          addInitializationStatement,
          startBlockScope,
          endBlockScope,
          addBlockScopedVariable,
          requestEmitHelper,
          readEmitHelpers,
          enableSubstitution,
          enableEmitNotification,
          isSubstitutionEnabled,
          isEmitNotificationEnabled,
          get onSubstituteNode() {
            return onSubstituteNode;
          },
          set onSubstituteNode(value) {
            ts3.Debug.assert(state < 1, "Cannot modify transformation hooks after initialization has completed.");
            ts3.Debug.assert(value !== void 0, "Value must not be 'undefined'");
            onSubstituteNode = value;
          },
          get onEmitNode() {
            return onEmitNode;
          },
          set onEmitNode(value) {
            ts3.Debug.assert(state < 1, "Cannot modify transformation hooks after initialization has completed.");
            ts3.Debug.assert(value !== void 0, "Value must not be 'undefined'");
            onEmitNode = value;
          },
          addDiagnostic: function(diag) {
            diagnostics.push(diag);
          }
        };
        for (var _i = 0, nodes_2 = nodes; _i < nodes_2.length; _i++) {
          var node = nodes_2[_i];
          ts3.disposeEmitNodes(ts3.getSourceFileOfNode(ts3.getParseTreeNode(node)));
        }
        ts3.performance.mark("beforeTransform");
        var transformersWithContext = transformers.map(function(t) {
          return t(context);
        });
        var transformation = function(node2) {
          for (var _i2 = 0, transformersWithContext_1 = transformersWithContext; _i2 < transformersWithContext_1.length; _i2++) {
            var transform = transformersWithContext_1[_i2];
            node2 = transform(node2);
          }
          return node2;
        };
        state = 1;
        var transformed = [];
        for (var _a = 0, nodes_3 = nodes; _a < nodes_3.length; _a++) {
          var node = nodes_3[_a];
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "transformNodes", node.kind === 305 ? { path: node.path } : { kind: node.kind, pos: node.pos, end: node.end });
          transformed.push((allowDtsFiles ? transformation : transformRoot)(node));
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        state = 2;
        ts3.performance.mark("afterTransform");
        ts3.performance.measure("transformTime", "beforeTransform", "afterTransform");
        return {
          transformed,
          substituteNode,
          emitNodeWithNotification,
          isEmitNotificationEnabled,
          dispose,
          diagnostics
        };
        function transformRoot(node2) {
          return node2 && (!ts3.isSourceFile(node2) || !node2.isDeclarationFile) ? transformation(node2) : node2;
        }
        function enableSubstitution(kind) {
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          enabledSyntaxKindFeatures[kind] |= 1;
        }
        function isSubstitutionEnabled(node2) {
          return (enabledSyntaxKindFeatures[node2.kind] & 1) !== 0 && (ts3.getEmitFlags(node2) & 4) === 0;
        }
        function substituteNode(hint, node2) {
          ts3.Debug.assert(state < 3, "Cannot substitute a node after the result is disposed.");
          return node2 && isSubstitutionEnabled(node2) && onSubstituteNode(hint, node2) || node2;
        }
        function enableEmitNotification(kind) {
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          enabledSyntaxKindFeatures[kind] |= 2;
        }
        function isEmitNotificationEnabled(node2) {
          return (enabledSyntaxKindFeatures[node2.kind] & 2) !== 0 || (ts3.getEmitFlags(node2) & 2) !== 0;
        }
        function emitNodeWithNotification(hint, node2, emitCallback) {
          ts3.Debug.assert(state < 3, "Cannot invoke TransformationResult callbacks after the result is disposed.");
          if (node2) {
            if (isEmitNotificationEnabled(node2)) {
              onEmitNode(hint, node2, emitCallback);
            } else {
              emitCallback(hint, node2);
            }
          }
        }
        function hoistVariableDeclaration(name) {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          var decl = ts3.setEmitFlags(factory.createVariableDeclaration(name), 64);
          if (!lexicalEnvironmentVariableDeclarations) {
            lexicalEnvironmentVariableDeclarations = [decl];
          } else {
            lexicalEnvironmentVariableDeclarations.push(decl);
          }
          if (lexicalEnvironmentFlags & 1) {
            lexicalEnvironmentFlags |= 2;
          }
        }
        function hoistFunctionDeclaration(func) {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.setEmitFlags(func, 1048576);
          if (!lexicalEnvironmentFunctionDeclarations) {
            lexicalEnvironmentFunctionDeclarations = [func];
          } else {
            lexicalEnvironmentFunctionDeclarations.push(func);
          }
        }
        function addInitializationStatement(node2) {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.setEmitFlags(node2, 1048576);
          if (!lexicalEnvironmentStatements) {
            lexicalEnvironmentStatements = [node2];
          } else {
            lexicalEnvironmentStatements.push(node2);
          }
        }
        function startLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
          lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentVariableDeclarations;
          lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFunctionDeclarations;
          lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentStatements;
          lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFlags;
          lexicalEnvironmentStackOffset++;
          lexicalEnvironmentVariableDeclarations = void 0;
          lexicalEnvironmentFunctionDeclarations = void 0;
          lexicalEnvironmentStatements = void 0;
          lexicalEnvironmentFlags = 0;
        }
        function suspendLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is already suspended.");
          lexicalEnvironmentSuspended = true;
        }
        function resumeLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(lexicalEnvironmentSuspended, "Lexical environment is not suspended.");
          lexicalEnvironmentSuspended = false;
        }
        function endLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
          var statements;
          if (lexicalEnvironmentVariableDeclarations || lexicalEnvironmentFunctionDeclarations || lexicalEnvironmentStatements) {
            if (lexicalEnvironmentFunctionDeclarations) {
              statements = __spreadArray([], lexicalEnvironmentFunctionDeclarations, true);
            }
            if (lexicalEnvironmentVariableDeclarations) {
              var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList(lexicalEnvironmentVariableDeclarations));
              ts3.setEmitFlags(statement, 1048576);
              if (!statements) {
                statements = [statement];
              } else {
                statements.push(statement);
              }
            }
            if (lexicalEnvironmentStatements) {
              if (!statements) {
                statements = __spreadArray([], lexicalEnvironmentStatements, true);
              } else {
                statements = __spreadArray(__spreadArray([], statements, true), lexicalEnvironmentStatements, true);
              }
            }
          }
          lexicalEnvironmentStackOffset--;
          lexicalEnvironmentVariableDeclarations = lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentFunctionDeclarations = lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentStatements = lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentFlags = lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset];
          if (lexicalEnvironmentStackOffset === 0) {
            lexicalEnvironmentVariableDeclarationsStack = [];
            lexicalEnvironmentFunctionDeclarationsStack = [];
            lexicalEnvironmentStatementsStack = [];
            lexicalEnvironmentFlagsStack = [];
          }
          return statements;
        }
        function setLexicalEnvironmentFlags(flags, value) {
          lexicalEnvironmentFlags = value ? lexicalEnvironmentFlags | flags : lexicalEnvironmentFlags & ~flags;
        }
        function getLexicalEnvironmentFlags() {
          return lexicalEnvironmentFlags;
        }
        function startBlockScope() {
          ts3.Debug.assert(state > 0, "Cannot start a block scope during initialization.");
          ts3.Debug.assert(state < 2, "Cannot start a block scope after transformation has completed.");
          blockScopedVariableDeclarationsStack[blockScopeStackOffset] = blockScopedVariableDeclarations;
          blockScopeStackOffset++;
          blockScopedVariableDeclarations = void 0;
        }
        function endBlockScope() {
          ts3.Debug.assert(state > 0, "Cannot end a block scope during initialization.");
          ts3.Debug.assert(state < 2, "Cannot end a block scope after transformation has completed.");
          var statements = ts3.some(blockScopedVariableDeclarations) ? [
            factory.createVariableStatement(void 0, factory.createVariableDeclarationList(blockScopedVariableDeclarations.map(function(identifier) {
              return factory.createVariableDeclaration(identifier);
            }), 1))
          ] : void 0;
          blockScopeStackOffset--;
          blockScopedVariableDeclarations = blockScopedVariableDeclarationsStack[blockScopeStackOffset];
          if (blockScopeStackOffset === 0) {
            blockScopedVariableDeclarationsStack = [];
          }
          return statements;
        }
        function addBlockScopedVariable(name) {
          ts3.Debug.assert(blockScopeStackOffset > 0, "Cannot add a block scoped variable outside of an iteration body.");
          (blockScopedVariableDeclarations || (blockScopedVariableDeclarations = [])).push(name);
        }
        function requestEmitHelper(helper) {
          ts3.Debug.assert(state > 0, "Cannot modify the transformation context during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          ts3.Debug.assert(!helper.scoped, "Cannot request a scoped emit helper.");
          if (helper.dependencies) {
            for (var _i2 = 0, _a2 = helper.dependencies; _i2 < _a2.length; _i2++) {
              var h = _a2[_i2];
              requestEmitHelper(h);
            }
          }
          emitHelpers = ts3.append(emitHelpers, helper);
        }
        function readEmitHelpers() {
          ts3.Debug.assert(state > 0, "Cannot modify the transformation context during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          var helpers = emitHelpers;
          emitHelpers = void 0;
          return helpers;
        }
        function dispose() {
          if (state < 3) {
            for (var _i2 = 0, nodes_4 = nodes; _i2 < nodes_4.length; _i2++) {
              var node2 = nodes_4[_i2];
              ts3.disposeEmitNodes(ts3.getSourceFileOfNode(ts3.getParseTreeNode(node2)));
            }
            lexicalEnvironmentVariableDeclarations = void 0;
            lexicalEnvironmentVariableDeclarationsStack = void 0;
            lexicalEnvironmentFunctionDeclarations = void 0;
            lexicalEnvironmentFunctionDeclarationsStack = void 0;
            onSubstituteNode = void 0;
            onEmitNode = void 0;
            emitHelpers = void 0;
            state = 3;
          }
        }
      }
      ts3.transformNodes = transformNodes;
      ts3.nullTransformationContext = {
        factory: ts3.factory,
        getCompilerOptions: function() {
          return {};
        },
        getEmitResolver: ts3.notImplemented,
        getEmitHost: ts3.notImplemented,
        getEmitHelperFactory: ts3.notImplemented,
        startLexicalEnvironment: ts3.noop,
        resumeLexicalEnvironment: ts3.noop,
        suspendLexicalEnvironment: ts3.noop,
        endLexicalEnvironment: ts3.returnUndefined,
        setLexicalEnvironmentFlags: ts3.noop,
        getLexicalEnvironmentFlags: function() {
          return 0;
        },
        hoistVariableDeclaration: ts3.noop,
        hoistFunctionDeclaration: ts3.noop,
        addInitializationStatement: ts3.noop,
        startBlockScope: ts3.noop,
        endBlockScope: ts3.returnUndefined,
        addBlockScopedVariable: ts3.noop,
        requestEmitHelper: ts3.noop,
        readEmitHelpers: ts3.notImplemented,
        enableSubstitution: ts3.noop,
        enableEmitNotification: ts3.noop,
        isSubstitutionEnabled: ts3.notImplemented,
        isEmitNotificationEnabled: ts3.notImplemented,
        onSubstituteNode: noEmitSubstitution,
        onEmitNode: noEmitNotification,
        addDiagnostic: ts3.noop
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var brackets = createBracketsMap();
      function isBuildInfoFile(file) {
        return ts3.fileExtensionIs(file, ".tsbuildinfo");
      }
      ts3.isBuildInfoFile = isBuildInfoFile;
      function forEachEmittedFile(host, action, sourceFilesOrTargetSourceFile, forceDtsEmit, onlyBuildInfo, includeBuildInfo) {
        if (forceDtsEmit === void 0) {
          forceDtsEmit = false;
        }
        var sourceFiles = ts3.isArray(sourceFilesOrTargetSourceFile) ? sourceFilesOrTargetSourceFile : ts3.getSourceFilesToEmit(host, sourceFilesOrTargetSourceFile, forceDtsEmit);
        var options = host.getCompilerOptions();
        if (ts3.outFile(options)) {
          var prepends = host.getPrependNodes();
          if (sourceFiles.length || prepends.length) {
            var bundle = ts3.factory.createBundle(sourceFiles, prepends);
            var result2 = action(getOutputPathsFor(bundle, host, forceDtsEmit), bundle);
            if (result2) {
              return result2;
            }
          }
        } else {
          if (!onlyBuildInfo) {
            for (var _a = 0, sourceFiles_1 = sourceFiles; _a < sourceFiles_1.length; _a++) {
              var sourceFile = sourceFiles_1[_a];
              var result2 = action(getOutputPathsFor(sourceFile, host, forceDtsEmit), sourceFile);
              if (result2) {
                return result2;
              }
            }
          }
          if (includeBuildInfo) {
            var buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
            if (buildInfoPath)
              return action({ buildInfoPath }, void 0);
          }
        }
      }
      ts3.forEachEmittedFile = forEachEmittedFile;
      function getTsBuildInfoEmitOutputFilePath(options) {
        var configFile = options.configFilePath;
        if (!ts3.isIncrementalCompilation(options))
          return void 0;
        if (options.tsBuildInfoFile)
          return options.tsBuildInfoFile;
        var outPath = ts3.outFile(options);
        var buildInfoExtensionLess;
        if (outPath) {
          buildInfoExtensionLess = ts3.removeFileExtension(outPath);
        } else {
          if (!configFile)
            return void 0;
          var configFileExtensionLess = ts3.removeFileExtension(configFile);
          buildInfoExtensionLess = options.outDir ? options.rootDir ? ts3.resolvePath(options.outDir, ts3.getRelativePathFromDirectory(options.rootDir, configFileExtensionLess, true)) : ts3.combinePaths(options.outDir, ts3.getBaseFileName(configFileExtensionLess)) : configFileExtensionLess;
        }
        return buildInfoExtensionLess + ".tsbuildinfo";
      }
      ts3.getTsBuildInfoEmitOutputFilePath = getTsBuildInfoEmitOutputFilePath;
      function getOutputPathsForBundle(options, forceDtsPaths) {
        var outPath = ts3.outFile(options);
        var jsFilePath = options.emitDeclarationOnly ? void 0 : outPath;
        var sourceMapFilePath = jsFilePath && getSourceMapFilePath(jsFilePath, options);
        var declarationFilePath = forceDtsPaths || ts3.getEmitDeclarations(options) ? ts3.removeFileExtension(outPath) + ".d.ts" : void 0;
        var declarationMapPath = declarationFilePath && ts3.getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
        var buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
        return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath };
      }
      ts3.getOutputPathsForBundle = getOutputPathsForBundle;
      function getOutputPathsFor(sourceFile, host, forceDtsPaths) {
        var options = host.getCompilerOptions();
        if (sourceFile.kind === 306) {
          return getOutputPathsForBundle(options, forceDtsPaths);
        } else {
          var ownOutputFilePath = ts3.getOwnEmitOutputFilePath(sourceFile.fileName, host, getOutputExtension(sourceFile.fileName, options));
          var isJsonFile = ts3.isJsonSourceFile(sourceFile);
          var isJsonEmittedToSameLocation = isJsonFile && ts3.comparePaths(sourceFile.fileName, ownOutputFilePath, host.getCurrentDirectory(), !host.useCaseSensitiveFileNames()) === 0;
          var jsFilePath = options.emitDeclarationOnly || isJsonEmittedToSameLocation ? void 0 : ownOutputFilePath;
          var sourceMapFilePath = !jsFilePath || ts3.isJsonSourceFile(sourceFile) ? void 0 : getSourceMapFilePath(jsFilePath, options);
          var declarationFilePath = forceDtsPaths || ts3.getEmitDeclarations(options) && !isJsonFile ? ts3.getDeclarationEmitOutputFilePath(sourceFile.fileName, host) : void 0;
          var declarationMapPath = declarationFilePath && ts3.getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
          return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath: void 0 };
        }
      }
      ts3.getOutputPathsFor = getOutputPathsFor;
      function getSourceMapFilePath(jsFilePath, options) {
        return options.sourceMap && !options.inlineSourceMap ? jsFilePath + ".map" : void 0;
      }
      function getOutputExtension(fileName2, options) {
        return ts3.fileExtensionIs(fileName2, ".json") ? ".json" : options.jsx === 1 && ts3.fileExtensionIsOneOf(fileName2, [".jsx", ".tsx"]) ? ".jsx" : ts3.fileExtensionIsOneOf(fileName2, [".mts", ".mjs"]) ? ".mjs" : ts3.fileExtensionIsOneOf(fileName2, [".cts", ".cjs"]) ? ".cjs" : ".js";
      }
      ts3.getOutputExtension = getOutputExtension;
      function getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, outputDir, getCommonSourceDirectory2) {
        return outputDir ? ts3.resolvePath(outputDir, ts3.getRelativePathFromDirectory(getCommonSourceDirectory2 ? getCommonSourceDirectory2() : getCommonSourceDirectoryOfConfig(configFile, ignoreCase), inputFileName, ignoreCase)) : inputFileName;
      }
      function getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2) {
        return ts3.changeExtension(getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, configFile.options.declarationDir || configFile.options.outDir, getCommonSourceDirectory2), ts3.getDeclarationEmitExtensionForPath(inputFileName));
      }
      ts3.getOutputDeclarationFileName = getOutputDeclarationFileName;
      function getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2) {
        if (configFile.options.emitDeclarationOnly)
          return void 0;
        var isJsonFile = ts3.fileExtensionIs(inputFileName, ".json");
        var outputFileName = ts3.changeExtension(getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, configFile.options.outDir, getCommonSourceDirectory2), getOutputExtension(inputFileName, configFile.options));
        return !isJsonFile || ts3.comparePaths(inputFileName, outputFileName, ts3.Debug.checkDefined(configFile.options.configFilePath), ignoreCase) !== 0 ? outputFileName : void 0;
      }
      function createAddOutput() {
        var outputs;
        return { addOutput, getOutputs };
        function addOutput(path2) {
          if (path2) {
            (outputs || (outputs = [])).push(path2);
          }
        }
        function getOutputs() {
          return outputs || ts3.emptyArray;
        }
      }
      function getSingleOutputFileNames(configFile, addOutput) {
        var _a = getOutputPathsForBundle(configFile.options, false), jsFilePath = _a.jsFilePath, sourceMapFilePath = _a.sourceMapFilePath, declarationFilePath = _a.declarationFilePath, declarationMapPath = _a.declarationMapPath, buildInfoPath = _a.buildInfoPath;
        addOutput(jsFilePath);
        addOutput(sourceMapFilePath);
        addOutput(declarationFilePath);
        addOutput(declarationMapPath);
        addOutput(buildInfoPath);
      }
      function getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput, getCommonSourceDirectory2) {
        if (ts3.isDeclarationFileName(inputFileName))
          return;
        var js = getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
        addOutput(js);
        if (ts3.fileExtensionIs(inputFileName, ".json"))
          return;
        if (js && configFile.options.sourceMap) {
          addOutput("".concat(js, ".map"));
        }
        if (ts3.getEmitDeclarations(configFile.options)) {
          var dts = getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
          addOutput(dts);
          if (configFile.options.declarationMap) {
            addOutput("".concat(dts, ".map"));
          }
        }
      }
      function getCommonSourceDirectory(options, emittedFiles, currentDirectory, getCanonicalFileName, checkSourceFilesBelongToPath) {
        var commonSourceDirectory;
        if (options.rootDir) {
          commonSourceDirectory = ts3.getNormalizedAbsolutePath(options.rootDir, currentDirectory);
          checkSourceFilesBelongToPath === null || checkSourceFilesBelongToPath === void 0 ? void 0 : checkSourceFilesBelongToPath(options.rootDir);
        } else if (options.composite && options.configFilePath) {
          commonSourceDirectory = ts3.getDirectoryPath(ts3.normalizeSlashes(options.configFilePath));
          checkSourceFilesBelongToPath === null || checkSourceFilesBelongToPath === void 0 ? void 0 : checkSourceFilesBelongToPath(commonSourceDirectory);
        } else {
          commonSourceDirectory = ts3.computeCommonSourceDirectoryOfFilenames(emittedFiles(), currentDirectory, getCanonicalFileName);
        }
        if (commonSourceDirectory && commonSourceDirectory[commonSourceDirectory.length - 1] !== ts3.directorySeparator) {
          commonSourceDirectory += ts3.directorySeparator;
        }
        return commonSourceDirectory;
      }
      ts3.getCommonSourceDirectory = getCommonSourceDirectory;
      function getCommonSourceDirectoryOfConfig(_a, ignoreCase) {
        var options = _a.options, fileNames = _a.fileNames;
        return getCommonSourceDirectory(options, function() {
          return ts3.filter(fileNames, function(file) {
            return !(options.noEmitForJsFiles && ts3.fileExtensionIsOneOf(file, ts3.supportedJSExtensionsFlat)) && !ts3.isDeclarationFileName(file);
          });
        }, ts3.getDirectoryPath(ts3.normalizeSlashes(ts3.Debug.checkDefined(options.configFilePath))), ts3.createGetCanonicalFileName(!ignoreCase));
      }
      ts3.getCommonSourceDirectoryOfConfig = getCommonSourceDirectoryOfConfig;
      function getAllProjectOutputs(configFile, ignoreCase) {
        var _a = createAddOutput(), addOutput = _a.addOutput, getOutputs = _a.getOutputs;
        if (ts3.outFile(configFile.options)) {
          getSingleOutputFileNames(configFile, addOutput);
        } else {
          var getCommonSourceDirectory_1 = ts3.memoize(function() {
            return getCommonSourceDirectoryOfConfig(configFile, ignoreCase);
          });
          for (var _b = 0, _c = configFile.fileNames; _b < _c.length; _b++) {
            var inputFileName = _c[_b];
            getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput, getCommonSourceDirectory_1);
          }
          addOutput(getTsBuildInfoEmitOutputFilePath(configFile.options));
        }
        return getOutputs();
      }
      ts3.getAllProjectOutputs = getAllProjectOutputs;
      function getOutputFileNames(commandLine, inputFileName, ignoreCase) {
        inputFileName = ts3.normalizePath(inputFileName);
        ts3.Debug.assert(ts3.contains(commandLine.fileNames, inputFileName), "Expected fileName to be present in command line");
        var _a = createAddOutput(), addOutput = _a.addOutput, getOutputs = _a.getOutputs;
        if (ts3.outFile(commandLine.options)) {
          getSingleOutputFileNames(commandLine, addOutput);
        } else {
          getOwnOutputFileNames(commandLine, inputFileName, ignoreCase, addOutput);
        }
        return getOutputs();
      }
      ts3.getOutputFileNames = getOutputFileNames;
      function getFirstProjectOutput(configFile, ignoreCase) {
        if (ts3.outFile(configFile.options)) {
          var jsFilePath = getOutputPathsForBundle(configFile.options, false).jsFilePath;
          return ts3.Debug.checkDefined(jsFilePath, "project ".concat(configFile.options.configFilePath, " expected to have at least one output"));
        }
        var getCommonSourceDirectory2 = ts3.memoize(function() {
          return getCommonSourceDirectoryOfConfig(configFile, ignoreCase);
        });
        for (var _a = 0, _b = configFile.fileNames; _a < _b.length; _a++) {
          var inputFileName = _b[_a];
          if (ts3.isDeclarationFileName(inputFileName))
            continue;
          var jsFilePath = getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
          if (jsFilePath)
            return jsFilePath;
          if (ts3.fileExtensionIs(inputFileName, ".json"))
            continue;
          if (ts3.getEmitDeclarations(configFile.options)) {
            return getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
          }
        }
        var buildInfoPath = getTsBuildInfoEmitOutputFilePath(configFile.options);
        if (buildInfoPath)
          return buildInfoPath;
        return ts3.Debug.fail("project ".concat(configFile.options.configFilePath, " expected to have at least one output"));
      }
      ts3.getFirstProjectOutput = getFirstProjectOutput;
      function emitFiles(resolver, host, targetSourceFile, _a, emitOnlyDtsFiles, onlyBuildInfo, forceDtsEmit) {
        var scriptTransformers = _a.scriptTransformers, declarationTransformers = _a.declarationTransformers;
        var compilerOptions = host.getCompilerOptions();
        var sourceMapDataList = compilerOptions.sourceMap || compilerOptions.inlineSourceMap || ts3.getAreDeclarationMapsEnabled(compilerOptions) ? [] : void 0;
        var emittedFilesList = compilerOptions.listEmittedFiles ? [] : void 0;
        var emitterDiagnostics = ts3.createDiagnosticCollection();
        var newLine = ts3.getNewLineCharacter(compilerOptions, function() {
          return host.getNewLine();
        });
        var writer = ts3.createTextWriter(newLine);
        var _b = ts3.performance.createTimer("printTime", "beforePrint", "afterPrint"), enter = _b.enter, exit = _b.exit;
        var bundleBuildInfo;
        var emitSkipped = false;
        var exportedModulesFromDeclarationEmit;
        enter();
        forEachEmittedFile(host, emitSourceFileOrBundle, ts3.getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit), forceDtsEmit, onlyBuildInfo, !targetSourceFile);
        exit();
        return {
          emitSkipped,
          diagnostics: emitterDiagnostics.getDiagnostics(),
          emittedFiles: emittedFilesList,
          sourceMaps: sourceMapDataList,
          exportedModulesFromDeclarationEmit
        };
        function emitSourceFileOrBundle(_a2, sourceFileOrBundle) {
          var jsFilePath = _a2.jsFilePath, sourceMapFilePath = _a2.sourceMapFilePath, declarationFilePath = _a2.declarationFilePath, declarationMapPath = _a2.declarationMapPath, buildInfoPath = _a2.buildInfoPath;
          var buildInfoDirectory;
          if (buildInfoPath && sourceFileOrBundle && ts3.isBundle(sourceFileOrBundle)) {
            buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
            bundleBuildInfo = {
              commonSourceDirectory: relativeToBuildInfo(host.getCommonSourceDirectory()),
              sourceFiles: sourceFileOrBundle.sourceFiles.map(function(file) {
                return relativeToBuildInfo(ts3.getNormalizedAbsolutePath(file.fileName, host.getCurrentDirectory()));
              })
            };
          }
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitJsFileOrBundle", { jsFilePath });
          emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitDeclarationFileOrBundle", { declarationFilePath });
          emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitBuildInfo", { buildInfoPath });
          emitBuildInfo(bundleBuildInfo, buildInfoPath);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          if (!emitSkipped && emittedFilesList) {
            if (!emitOnlyDtsFiles) {
              if (jsFilePath) {
                emittedFilesList.push(jsFilePath);
              }
              if (sourceMapFilePath) {
                emittedFilesList.push(sourceMapFilePath);
              }
              if (buildInfoPath) {
                emittedFilesList.push(buildInfoPath);
              }
            }
            if (declarationFilePath) {
              emittedFilesList.push(declarationFilePath);
            }
            if (declarationMapPath) {
              emittedFilesList.push(declarationMapPath);
            }
          }
          function relativeToBuildInfo(path2) {
            return ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(buildInfoDirectory, path2, host.getCanonicalFileName));
          }
        }
        function emitBuildInfo(bundle, buildInfoPath) {
          if (!buildInfoPath || targetSourceFile || emitSkipped)
            return;
          var program2 = host.getProgramBuildInfo();
          if (host.isEmitBlocked(buildInfoPath)) {
            emitSkipped = true;
            return;
          }
          var version = ts3.version;
          ts3.writeFile(host, emitterDiagnostics, buildInfoPath, getBuildInfoText({ bundle, program: program2, version }), false);
        }
        function emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo) {
          if (!sourceFileOrBundle || emitOnlyDtsFiles || !jsFilePath) {
            return;
          }
          if (jsFilePath && host.isEmitBlocked(jsFilePath) || compilerOptions.noEmit) {
            emitSkipped = true;
            return;
          }
          var transform = ts3.transformNodes(resolver, host, ts3.factory, compilerOptions, [sourceFileOrBundle], scriptTransformers, false);
          var printerOptions = {
            removeComments: compilerOptions.removeComments,
            newLine: compilerOptions.newLine,
            noEmitHelpers: compilerOptions.noEmitHelpers,
            module: compilerOptions.module,
            target: compilerOptions.target,
            sourceMap: compilerOptions.sourceMap,
            inlineSourceMap: compilerOptions.inlineSourceMap,
            inlineSources: compilerOptions.inlineSources,
            extendedDiagnostics: compilerOptions.extendedDiagnostics,
            writeBundleFileInfo: !!bundleBuildInfo,
            relativeToBuildInfo
          };
          var printer2 = createPrinter(printerOptions, {
            hasGlobalName: resolver.hasGlobalName,
            onEmitNode: transform.emitNodeWithNotification,
            isEmitNotificationEnabled: transform.isEmitNotificationEnabled,
            substituteNode: transform.substituteNode
          });
          ts3.Debug.assert(transform.transformed.length === 1, "Should only see one output from the transform");
          printSourceFileOrBundle(jsFilePath, sourceMapFilePath, transform.transformed[0], printer2, compilerOptions);
          transform.dispose();
          if (bundleBuildInfo)
            bundleBuildInfo.js = printer2.bundleFileInfo;
        }
        function emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo) {
          if (!sourceFileOrBundle)
            return;
          if (!declarationFilePath) {
            if (emitOnlyDtsFiles || compilerOptions.emitDeclarationOnly)
              emitSkipped = true;
            return;
          }
          var sourceFiles = ts3.isSourceFile(sourceFileOrBundle) ? [sourceFileOrBundle] : sourceFileOrBundle.sourceFiles;
          var filesForEmit = forceDtsEmit ? sourceFiles : ts3.filter(sourceFiles, ts3.isSourceFileNotJson);
          var inputListOrBundle = ts3.outFile(compilerOptions) ? [ts3.factory.createBundle(filesForEmit, !ts3.isSourceFile(sourceFileOrBundle) ? sourceFileOrBundle.prepends : void 0)] : filesForEmit;
          if (emitOnlyDtsFiles && !ts3.getEmitDeclarations(compilerOptions)) {
            filesForEmit.forEach(collectLinkedAliases);
          }
          var declarationTransform = ts3.transformNodes(resolver, host, ts3.factory, compilerOptions, inputListOrBundle, declarationTransformers, false);
          if (ts3.length(declarationTransform.diagnostics)) {
            for (var _a2 = 0, _b2 = declarationTransform.diagnostics; _a2 < _b2.length; _a2++) {
              var diagnostic = _b2[_a2];
              emitterDiagnostics.add(diagnostic);
            }
          }
          var printerOptions = {
            removeComments: compilerOptions.removeComments,
            newLine: compilerOptions.newLine,
            noEmitHelpers: true,
            module: compilerOptions.module,
            target: compilerOptions.target,
            sourceMap: compilerOptions.sourceMap,
            inlineSourceMap: compilerOptions.inlineSourceMap,
            extendedDiagnostics: compilerOptions.extendedDiagnostics,
            onlyPrintJsDocStyle: true,
            writeBundleFileInfo: !!bundleBuildInfo,
            recordInternalSection: !!bundleBuildInfo,
            relativeToBuildInfo
          };
          var declarationPrinter = createPrinter(printerOptions, {
            hasGlobalName: resolver.hasGlobalName,
            onEmitNode: declarationTransform.emitNodeWithNotification,
            isEmitNotificationEnabled: declarationTransform.isEmitNotificationEnabled,
            substituteNode: declarationTransform.substituteNode
          });
          var declBlocked = !!declarationTransform.diagnostics && !!declarationTransform.diagnostics.length || !!host.isEmitBlocked(declarationFilePath) || !!compilerOptions.noEmit;
          emitSkipped = emitSkipped || declBlocked;
          if (!declBlocked || forceDtsEmit) {
            ts3.Debug.assert(declarationTransform.transformed.length === 1, "Should only see one output from the decl transform");
            printSourceFileOrBundle(declarationFilePath, declarationMapPath, declarationTransform.transformed[0], declarationPrinter, {
              sourceMap: !forceDtsEmit && compilerOptions.declarationMap,
              sourceRoot: compilerOptions.sourceRoot,
              mapRoot: compilerOptions.mapRoot,
              extendedDiagnostics: compilerOptions.extendedDiagnostics
            });
            if (forceDtsEmit && declarationTransform.transformed[0].kind === 305) {
              var sourceFile = declarationTransform.transformed[0];
              exportedModulesFromDeclarationEmit = sourceFile.exportedModulesFromDeclarationEmit;
            }
          }
          declarationTransform.dispose();
          if (bundleBuildInfo)
            bundleBuildInfo.dts = declarationPrinter.bundleFileInfo;
        }
        function collectLinkedAliases(node) {
          if (ts3.isExportAssignment(node)) {
            if (node.expression.kind === 79) {
              resolver.collectLinkedAliases(node.expression, true);
            }
            return;
          } else if (ts3.isExportSpecifier(node)) {
            resolver.collectLinkedAliases(node.propertyName || node.name, true);
            return;
          }
          ts3.forEachChild(node, collectLinkedAliases);
        }
        function printSourceFileOrBundle(jsFilePath, sourceMapFilePath, sourceFileOrBundle, printer2, mapOptions) {
          var bundle = sourceFileOrBundle.kind === 306 ? sourceFileOrBundle : void 0;
          var sourceFile = sourceFileOrBundle.kind === 305 ? sourceFileOrBundle : void 0;
          var sourceFiles = bundle ? bundle.sourceFiles : [sourceFile];
          var sourceMapGenerator;
          if (shouldEmitSourceMaps(mapOptions, sourceFileOrBundle)) {
            sourceMapGenerator = ts3.createSourceMapGenerator(host, ts3.getBaseFileName(ts3.normalizeSlashes(jsFilePath)), getSourceRoot(mapOptions), getSourceMapDirectory(mapOptions, jsFilePath, sourceFile), mapOptions);
          }
          if (bundle) {
            printer2.writeBundle(bundle, writer, sourceMapGenerator);
          } else {
            printer2.writeFile(sourceFile, writer, sourceMapGenerator);
          }
          var sourceMapUrlPos;
          if (sourceMapGenerator) {
            if (sourceMapDataList) {
              sourceMapDataList.push({
                inputSourceFileNames: sourceMapGenerator.getSources(),
                sourceMap: sourceMapGenerator.toJSON()
              });
            }
            var sourceMappingURL = getSourceMappingURL(mapOptions, sourceMapGenerator, jsFilePath, sourceMapFilePath, sourceFile);
            if (sourceMappingURL) {
              if (!writer.isAtStartOfLine())
                writer.rawWrite(newLine);
              sourceMapUrlPos = writer.getTextPos();
              writer.writeComment("//# ".concat("sourceMappingURL", "=").concat(sourceMappingURL));
            }
            if (sourceMapFilePath) {
              var sourceMap = sourceMapGenerator.toString();
              ts3.writeFile(host, emitterDiagnostics, sourceMapFilePath, sourceMap, false, sourceFiles);
            }
          } else {
            writer.writeLine();
          }
          ts3.writeFile(host, emitterDiagnostics, jsFilePath, writer.getText(), !!compilerOptions.emitBOM, sourceFiles, { sourceMapUrlPos });
          writer.clear();
        }
        function shouldEmitSourceMaps(mapOptions, sourceFileOrBundle) {
          return (mapOptions.sourceMap || mapOptions.inlineSourceMap) && (sourceFileOrBundle.kind !== 305 || !ts3.fileExtensionIs(sourceFileOrBundle.fileName, ".json"));
        }
        function getSourceRoot(mapOptions) {
          var sourceRoot = ts3.normalizeSlashes(mapOptions.sourceRoot || "");
          return sourceRoot ? ts3.ensureTrailingDirectorySeparator(sourceRoot) : sourceRoot;
        }
        function getSourceMapDirectory(mapOptions, filePath, sourceFile) {
          if (mapOptions.sourceRoot)
            return host.getCommonSourceDirectory();
          if (mapOptions.mapRoot) {
            var sourceMapDir = ts3.normalizeSlashes(mapOptions.mapRoot);
            if (sourceFile) {
              sourceMapDir = ts3.getDirectoryPath(ts3.getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
            }
            if (ts3.getRootLength(sourceMapDir) === 0) {
              sourceMapDir = ts3.combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
            }
            return sourceMapDir;
          }
          return ts3.getDirectoryPath(ts3.normalizePath(filePath));
        }
        function getSourceMappingURL(mapOptions, sourceMapGenerator, filePath, sourceMapFilePath, sourceFile) {
          if (mapOptions.inlineSourceMap) {
            var sourceMapText = sourceMapGenerator.toString();
            var base64SourceMapText = ts3.base64encode(ts3.sys, sourceMapText);
            return "data:application/json;base64,".concat(base64SourceMapText);
          }
          var sourceMapFile = ts3.getBaseFileName(ts3.normalizeSlashes(ts3.Debug.checkDefined(sourceMapFilePath)));
          if (mapOptions.mapRoot) {
            var sourceMapDir = ts3.normalizeSlashes(mapOptions.mapRoot);
            if (sourceFile) {
              sourceMapDir = ts3.getDirectoryPath(ts3.getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
            }
            if (ts3.getRootLength(sourceMapDir) === 0) {
              sourceMapDir = ts3.combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
              return encodeURI(ts3.getRelativePathToDirectoryOrUrl(ts3.getDirectoryPath(ts3.normalizePath(filePath)), ts3.combinePaths(sourceMapDir, sourceMapFile), host.getCurrentDirectory(), host.getCanonicalFileName, true));
            } else {
              return encodeURI(ts3.combinePaths(sourceMapDir, sourceMapFile));
            }
          }
          return encodeURI(sourceMapFile);
        }
      }
      ts3.emitFiles = emitFiles;
      function getBuildInfoText(buildInfo) {
        return JSON.stringify(buildInfo);
      }
      ts3.getBuildInfoText = getBuildInfoText;
      function getBuildInfo(buildInfoText) {
        return JSON.parse(buildInfoText);
      }
      ts3.getBuildInfo = getBuildInfo;
      ts3.notImplementedResolver = {
        hasGlobalName: ts3.notImplemented,
        getReferencedExportContainer: ts3.notImplemented,
        getReferencedImportDeclaration: ts3.notImplemented,
        getReferencedDeclarationWithCollidingName: ts3.notImplemented,
        isDeclarationWithCollidingName: ts3.notImplemented,
        isValueAliasDeclaration: ts3.notImplemented,
        isReferencedAliasDeclaration: ts3.notImplemented,
        isTopLevelValueImportEqualsWithEntityName: ts3.notImplemented,
        getNodeCheckFlags: ts3.notImplemented,
        isDeclarationVisible: ts3.notImplemented,
        isLateBound: function(_node) {
          return false;
        },
        collectLinkedAliases: ts3.notImplemented,
        isImplementationOfOverload: ts3.notImplemented,
        isRequiredInitializedParameter: ts3.notImplemented,
        isOptionalUninitializedParameterProperty: ts3.notImplemented,
        isExpandoFunctionDeclaration: ts3.notImplemented,
        getPropertiesOfContainerFunction: ts3.notImplemented,
        createTypeOfDeclaration: ts3.notImplemented,
        createReturnTypeOfSignatureDeclaration: ts3.notImplemented,
        createTypeOfExpression: ts3.notImplemented,
        createLiteralConstValue: ts3.notImplemented,
        isSymbolAccessible: ts3.notImplemented,
        isEntityNameVisible: ts3.notImplemented,
        getConstantValue: ts3.notImplemented,
        getReferencedValueDeclaration: ts3.notImplemented,
        getTypeReferenceSerializationKind: ts3.notImplemented,
        isOptionalParameter: ts3.notImplemented,
        moduleExportsSomeValue: ts3.notImplemented,
        isArgumentsLocalBinding: ts3.notImplemented,
        getExternalModuleFileFromDeclaration: ts3.notImplemented,
        getTypeReferenceDirectivesForEntityName: ts3.notImplemented,
        getTypeReferenceDirectivesForSymbol: ts3.notImplemented,
        isLiteralConstDeclaration: ts3.notImplemented,
        getJsxFactoryEntity: ts3.notImplemented,
        getJsxFragmentFactoryEntity: ts3.notImplemented,
        getAllAccessorDeclarations: ts3.notImplemented,
        getSymbolOfExternalModuleSpecifier: ts3.notImplemented,
        isBindingCapturedByNode: ts3.notImplemented,
        getDeclarationStatementsForSourceFile: ts3.notImplemented,
        isImportRequiredByAugmentation: ts3.notImplemented
      };
      function createSourceFilesFromBundleBuildInfo(bundle, buildInfoDirectory, host) {
        var _a;
        var jsBundle = ts3.Debug.checkDefined(bundle.js);
        var prologueMap = ((_a = jsBundle.sources) === null || _a === void 0 ? void 0 : _a.prologues) && ts3.arrayToMap(jsBundle.sources.prologues, function(prologueInfo) {
          return prologueInfo.file;
        });
        return bundle.sourceFiles.map(function(fileName2, index) {
          var _a2, _b;
          var prologueInfo = prologueMap === null || prologueMap === void 0 ? void 0 : prologueMap.get(index);
          var statements = prologueInfo === null || prologueInfo === void 0 ? void 0 : prologueInfo.directives.map(function(directive) {
            var literal = ts3.setTextRange(ts3.factory.createStringLiteral(directive.expression.text), directive.expression);
            var statement = ts3.setTextRange(ts3.factory.createExpressionStatement(literal), directive);
            ts3.setParent(literal, statement);
            return statement;
          });
          var eofToken = ts3.factory.createToken(1);
          var sourceFile = ts3.factory.createSourceFile(statements !== null && statements !== void 0 ? statements : [], eofToken, 0);
          sourceFile.fileName = ts3.getRelativePathFromDirectory(host.getCurrentDirectory(), ts3.getNormalizedAbsolutePath(fileName2, buildInfoDirectory), !host.useCaseSensitiveFileNames());
          sourceFile.text = (_a2 = prologueInfo === null || prologueInfo === void 0 ? void 0 : prologueInfo.text) !== null && _a2 !== void 0 ? _a2 : "";
          ts3.setTextRangePosWidth(sourceFile, 0, (_b = prologueInfo === null || prologueInfo === void 0 ? void 0 : prologueInfo.text.length) !== null && _b !== void 0 ? _b : 0);
          ts3.setEachParent(sourceFile.statements, sourceFile);
          ts3.setTextRangePosWidth(eofToken, sourceFile.end, 0);
          ts3.setParent(eofToken, sourceFile);
          return sourceFile;
        });
      }
      function emitUsingBuildInfo(config, host, getCommandLine, customTransformers) {
        var _a = getOutputPathsForBundle(config.options, false), buildInfoPath = _a.buildInfoPath, jsFilePath = _a.jsFilePath, sourceMapFilePath = _a.sourceMapFilePath, declarationFilePath = _a.declarationFilePath, declarationMapPath = _a.declarationMapPath;
        var buildInfoText = host.readFile(ts3.Debug.checkDefined(buildInfoPath));
        if (!buildInfoText)
          return buildInfoPath;
        var jsFileText = host.readFile(ts3.Debug.checkDefined(jsFilePath));
        if (!jsFileText)
          return jsFilePath;
        var sourceMapText = sourceMapFilePath && host.readFile(sourceMapFilePath);
        if (sourceMapFilePath && !sourceMapText || config.options.inlineSourceMap)
          return sourceMapFilePath || "inline sourcemap decoding";
        var declarationText = declarationFilePath && host.readFile(declarationFilePath);
        if (declarationFilePath && !declarationText)
          return declarationFilePath;
        var declarationMapText = declarationMapPath && host.readFile(declarationMapPath);
        if (declarationMapPath && !declarationMapText || config.options.inlineSourceMap)
          return declarationMapPath || "inline sourcemap decoding";
        var buildInfo = getBuildInfo(buildInfoText);
        if (!buildInfo.bundle || !buildInfo.bundle.js || declarationText && !buildInfo.bundle.dts)
          return buildInfoPath;
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
        var ownPrependInput = ts3.createInputFiles(jsFileText, declarationText, sourceMapFilePath, sourceMapText, declarationMapPath, declarationMapText, jsFilePath, declarationFilePath, buildInfoPath, buildInfo, true);
        var outputFiles = [];
        var prependNodes = ts3.createPrependNodes(config.projectReferences, getCommandLine, function(f) {
          return host.readFile(f);
        });
        var sourceFilesForJsEmit = createSourceFilesFromBundleBuildInfo(buildInfo.bundle, buildInfoDirectory, host);
        var emitHost = {
          getPrependNodes: ts3.memoize(function() {
            return __spreadArray(__spreadArray([], prependNodes, true), [ownPrependInput], false);
          }),
          getCanonicalFileName: host.getCanonicalFileName,
          getCommonSourceDirectory: function() {
            return ts3.getNormalizedAbsolutePath(buildInfo.bundle.commonSourceDirectory, buildInfoDirectory);
          },
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          getNewLine: function() {
            return host.getNewLine();
          },
          getSourceFile: ts3.returnUndefined,
          getSourceFileByPath: ts3.returnUndefined,
          getSourceFiles: function() {
            return sourceFilesForJsEmit;
          },
          getLibFileFromReference: ts3.notImplemented,
          isSourceFileFromExternalLibrary: ts3.returnFalse,
          getResolvedProjectReferenceToRedirect: ts3.returnUndefined,
          getProjectReferenceRedirect: ts3.returnUndefined,
          isSourceOfProjectReferenceRedirect: ts3.returnFalse,
          writeFile: function(name, text, writeByteOrderMark) {
            switch (name) {
              case jsFilePath:
                if (jsFileText === text)
                  return;
                break;
              case sourceMapFilePath:
                if (sourceMapText === text)
                  return;
                break;
              case buildInfoPath:
                var newBuildInfo = getBuildInfo(text);
                newBuildInfo.program = buildInfo.program;
                var _a2 = buildInfo.bundle, js = _a2.js, dts = _a2.dts, sourceFiles = _a2.sourceFiles;
                newBuildInfo.bundle.js.sources = js.sources;
                if (dts) {
                  newBuildInfo.bundle.dts.sources = dts.sources;
                }
                newBuildInfo.bundle.sourceFiles = sourceFiles;
                outputFiles.push({ name, text: getBuildInfoText(newBuildInfo), writeByteOrderMark });
                return;
              case declarationFilePath:
                if (declarationText === text)
                  return;
                break;
              case declarationMapPath:
                if (declarationMapText === text)
                  return;
                break;
              default:
                ts3.Debug.fail("Unexpected path: ".concat(name));
            }
            outputFiles.push({ name, text, writeByteOrderMark });
          },
          isEmitBlocked: ts3.returnFalse,
          readFile: function(f) {
            return host.readFile(f);
          },
          fileExists: function(f) {
            return host.fileExists(f);
          },
          useCaseSensitiveFileNames: function() {
            return host.useCaseSensitiveFileNames();
          },
          getProgramBuildInfo: ts3.returnUndefined,
          getSourceFileFromReference: ts3.returnUndefined,
          redirectTargetsMap: ts3.createMultiMap(),
          getFileIncludeReasons: ts3.notImplemented
        };
        emitFiles(ts3.notImplementedResolver, emitHost, void 0, ts3.getTransformers(config.options, customTransformers));
        return outputFiles;
      }
      ts3.emitUsingBuildInfo = emitUsingBuildInfo;
      var PipelinePhase;
      (function(PipelinePhase2) {
        PipelinePhase2[PipelinePhase2["Notification"] = 0] = "Notification";
        PipelinePhase2[PipelinePhase2["Substitution"] = 1] = "Substitution";
        PipelinePhase2[PipelinePhase2["Comments"] = 2] = "Comments";
        PipelinePhase2[PipelinePhase2["SourceMaps"] = 3] = "SourceMaps";
        PipelinePhase2[PipelinePhase2["Emit"] = 4] = "Emit";
      })(PipelinePhase || (PipelinePhase = {}));
      function createPrinter(printerOptions, handlers) {
        if (printerOptions === void 0) {
          printerOptions = {};
        }
        if (handlers === void 0) {
          handlers = {};
        }
        var hasGlobalName = handlers.hasGlobalName, _a = handlers.onEmitNode, onEmitNode = _a === void 0 ? ts3.noEmitNotification : _a, isEmitNotificationEnabled = handlers.isEmitNotificationEnabled, _b = handlers.substituteNode, substituteNode = _b === void 0 ? ts3.noEmitSubstitution : _b, onBeforeEmitNode = handlers.onBeforeEmitNode, onAfterEmitNode = handlers.onAfterEmitNode, onBeforeEmitNodeArray = handlers.onBeforeEmitNodeArray, onAfterEmitNodeArray = handlers.onAfterEmitNodeArray, onBeforeEmitToken = handlers.onBeforeEmitToken, onAfterEmitToken = handlers.onAfterEmitToken;
        var extendedDiagnostics = !!printerOptions.extendedDiagnostics;
        var newLine = ts3.getNewLineCharacter(printerOptions);
        var moduleKind = ts3.getEmitModuleKind(printerOptions);
        var bundledHelpers = new ts3.Map();
        var currentSourceFile;
        var nodeIdToGeneratedName;
        var autoGeneratedIdToGeneratedName;
        var generatedNames;
        var tempFlagsStack;
        var tempFlags;
        var reservedNamesStack;
        var reservedNames;
        var preserveSourceNewlines = printerOptions.preserveSourceNewlines;
        var nextListElementPos;
        var writer;
        var ownWriter;
        var write = writeBase;
        var isOwnFileEmit;
        var bundleFileInfo = printerOptions.writeBundleFileInfo ? { sections: [] } : void 0;
        var relativeToBuildInfo = bundleFileInfo ? ts3.Debug.checkDefined(printerOptions.relativeToBuildInfo) : void 0;
        var recordInternalSection = printerOptions.recordInternalSection;
        var sourceFileTextPos = 0;
        var sourceFileTextKind = "text";
        var sourceMapsDisabled = true;
        var sourceMapGenerator;
        var sourceMapSource;
        var sourceMapSourceIndex = -1;
        var mostRecentlyAddedSourceMapSource;
        var mostRecentlyAddedSourceMapSourceIndex = -1;
        var containerPos = -1;
        var containerEnd = -1;
        var declarationListContainerEnd = -1;
        var currentLineMap;
        var detachedCommentsInfo;
        var hasWrittenComment = false;
        var commentsDisabled = !!printerOptions.removeComments;
        var lastSubstitution;
        var currentParenthesizerRule;
        var _c = ts3.performance.createTimerIf(extendedDiagnostics, "commentTime", "beforeComment", "afterComment"), enterComment = _c.enter, exitComment = _c.exit;
        var parenthesizer = ts3.factory.parenthesizer;
        var typeArgumentParenthesizerRuleSelector = {
          select: function(index) {
            return index === 0 ? parenthesizer.parenthesizeLeadingTypeArgument : void 0;
          }
        };
        var emitBinaryExpression = createEmitBinaryExpression();
        reset2();
        return {
          printNode,
          printList,
          printFile,
          printBundle,
          writeNode: writeNode2,
          writeList,
          writeFile,
          writeBundle,
          bundleFileInfo
        };
        function printNode(hint, node, sourceFile) {
          switch (hint) {
            case 0:
              ts3.Debug.assert(ts3.isSourceFile(node), "Expected a SourceFile node.");
              break;
            case 2:
              ts3.Debug.assert(ts3.isIdentifier(node), "Expected an Identifier node.");
              break;
            case 1:
              ts3.Debug.assert(ts3.isExpression(node), "Expected an Expression node.");
              break;
          }
          switch (node.kind) {
            case 305:
              return printFile(node);
            case 306:
              return printBundle(node);
            case 307:
              return printUnparsedSource(node);
          }
          writeNode2(hint, node, sourceFile, beginPrint());
          return endPrint();
        }
        function printList(format, nodes, sourceFile) {
          writeList(format, nodes, sourceFile, beginPrint());
          return endPrint();
        }
        function printBundle(bundle) {
          writeBundle(bundle, beginPrint(), void 0);
          return endPrint();
        }
        function printFile(sourceFile) {
          writeFile(sourceFile, beginPrint(), void 0);
          return endPrint();
        }
        function printUnparsedSource(unparsed) {
          writeUnparsedSource(unparsed, beginPrint());
          return endPrint();
        }
        function writeNode2(hint, node, sourceFile, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          print(hint, node, sourceFile);
          reset2();
          writer = previousWriter;
        }
        function writeList(format, nodes, sourceFile, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          if (sourceFile) {
            setSourceFile(sourceFile);
          }
          emitList(void 0, nodes, format);
          reset2();
          writer = previousWriter;
        }
        function getTextPosWithWriteLine() {
          return writer.getTextPosWithWriteLine ? writer.getTextPosWithWriteLine() : writer.getTextPos();
        }
        function updateOrPushBundleFileTextLike(pos, end, kind) {
          var last = ts3.lastOrUndefined(bundleFileInfo.sections);
          if (last && last.kind === kind) {
            last.end = end;
          } else {
            bundleFileInfo.sections.push({ pos, end, kind });
          }
        }
        function recordBundleFileInternalSectionStart(node) {
          if (recordInternalSection && bundleFileInfo && currentSourceFile && (ts3.isDeclaration(node) || ts3.isVariableStatement(node)) && ts3.isInternalDeclaration(node, currentSourceFile) && sourceFileTextKind !== "internal") {
            var prevSourceFileTextKind = sourceFileTextKind;
            recordBundleFileTextLikeSection(writer.getTextPos());
            sourceFileTextPos = getTextPosWithWriteLine();
            sourceFileTextKind = "internal";
            return prevSourceFileTextKind;
          }
          return void 0;
        }
        function recordBundleFileInternalSectionEnd(prevSourceFileTextKind) {
          if (prevSourceFileTextKind) {
            recordBundleFileTextLikeSection(writer.getTextPos());
            sourceFileTextPos = getTextPosWithWriteLine();
            sourceFileTextKind = prevSourceFileTextKind;
          }
        }
        function recordBundleFileTextLikeSection(end) {
          if (sourceFileTextPos < end) {
            updateOrPushBundleFileTextLike(sourceFileTextPos, end, sourceFileTextKind);
            return true;
          }
          return false;
        }
        function writeBundle(bundle, output, sourceMapGenerator2) {
          var _a2;
          isOwnFileEmit = false;
          var previousWriter = writer;
          setWriter(output, sourceMapGenerator2);
          emitShebangIfNeeded(bundle);
          emitPrologueDirectivesIfNeeded(bundle);
          emitHelpers(bundle);
          emitSyntheticTripleSlashReferencesIfNeeded(bundle);
          for (var _b2 = 0, _c2 = bundle.prepends; _b2 < _c2.length; _b2++) {
            var prepend = _c2[_b2];
            writeLine();
            var pos = writer.getTextPos();
            var savedSections = bundleFileInfo && bundleFileInfo.sections;
            if (savedSections)
              bundleFileInfo.sections = [];
            print(4, prepend, void 0);
            if (bundleFileInfo) {
              var newSections = bundleFileInfo.sections;
              bundleFileInfo.sections = savedSections;
              if (prepend.oldFileOfCurrentEmit)
                (_a2 = bundleFileInfo.sections).push.apply(_a2, newSections);
              else {
                newSections.forEach(function(section) {
                  return ts3.Debug.assert(ts3.isBundleFileTextLike(section));
                });
                bundleFileInfo.sections.push({
                  pos,
                  end: writer.getTextPos(),
                  kind: "prepend",
                  data: relativeToBuildInfo(prepend.fileName),
                  texts: newSections
                });
              }
            }
          }
          sourceFileTextPos = getTextPosWithWriteLine();
          for (var _d = 0, _e = bundle.sourceFiles; _d < _e.length; _d++) {
            var sourceFile = _e[_d];
            print(0, sourceFile, sourceFile);
          }
          if (bundleFileInfo && bundle.sourceFiles.length) {
            var end = writer.getTextPos();
            if (recordBundleFileTextLikeSection(end)) {
              var prologues = getPrologueDirectivesFromBundledSourceFiles(bundle);
              if (prologues) {
                if (!bundleFileInfo.sources)
                  bundleFileInfo.sources = {};
                bundleFileInfo.sources.prologues = prologues;
              }
              var helpers = getHelpersFromBundledSourceFiles(bundle);
              if (helpers) {
                if (!bundleFileInfo.sources)
                  bundleFileInfo.sources = {};
                bundleFileInfo.sources.helpers = helpers;
              }
            }
          }
          reset2();
          writer = previousWriter;
        }
        function writeUnparsedSource(unparsed, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          print(4, unparsed, void 0);
          reset2();
          writer = previousWriter;
        }
        function writeFile(sourceFile, output, sourceMapGenerator2) {
          isOwnFileEmit = true;
          var previousWriter = writer;
          setWriter(output, sourceMapGenerator2);
          emitShebangIfNeeded(sourceFile);
          emitPrologueDirectivesIfNeeded(sourceFile);
          print(0, sourceFile, sourceFile);
          reset2();
          writer = previousWriter;
        }
        function beginPrint() {
          return ownWriter || (ownWriter = ts3.createTextWriter(newLine));
        }
        function endPrint() {
          var text = ownWriter.getText();
          ownWriter.clear();
          return text;
        }
        function print(hint, node, sourceFile) {
          if (sourceFile) {
            setSourceFile(sourceFile);
          }
          pipelineEmit(hint, node, void 0);
        }
        function setSourceFile(sourceFile) {
          currentSourceFile = sourceFile;
          currentLineMap = void 0;
          detachedCommentsInfo = void 0;
          if (sourceFile) {
            setSourceMapSource(sourceFile);
          }
        }
        function setWriter(_writer, _sourceMapGenerator) {
          if (_writer && printerOptions.omitTrailingSemicolon) {
            _writer = ts3.getTrailingSemicolonDeferringWriter(_writer);
          }
          writer = _writer;
          sourceMapGenerator = _sourceMapGenerator;
          sourceMapsDisabled = !writer || !sourceMapGenerator;
        }
        function reset2() {
          nodeIdToGeneratedName = [];
          autoGeneratedIdToGeneratedName = [];
          generatedNames = new ts3.Set();
          tempFlagsStack = [];
          tempFlags = 0;
          reservedNamesStack = [];
          currentSourceFile = void 0;
          currentLineMap = void 0;
          detachedCommentsInfo = void 0;
          setWriter(void 0, void 0);
        }
        function getCurrentLineMap() {
          return currentLineMap || (currentLineMap = ts3.getLineStarts(ts3.Debug.checkDefined(currentSourceFile)));
        }
        function emit(node, parenthesizerRule) {
          if (node === void 0)
            return;
          var prevSourceFileTextKind = recordBundleFileInternalSectionStart(node);
          pipelineEmit(4, node, parenthesizerRule);
          recordBundleFileInternalSectionEnd(prevSourceFileTextKind);
        }
        function emitIdentifierName(node) {
          if (node === void 0)
            return;
          pipelineEmit(2, node, void 0);
        }
        function emitExpression(node, parenthesizerRule) {
          if (node === void 0)
            return;
          pipelineEmit(1, node, parenthesizerRule);
        }
        function emitJsxAttributeValue(node) {
          pipelineEmit(ts3.isStringLiteral(node) ? 6 : 4, node);
        }
        function beforeEmitNode(node) {
          if (preserveSourceNewlines && ts3.getEmitFlags(node) & 134217728) {
            preserveSourceNewlines = false;
          }
        }
        function afterEmitNode(savedPreserveSourceNewlines) {
          preserveSourceNewlines = savedPreserveSourceNewlines;
        }
        function pipelineEmit(emitHint, node, parenthesizerRule) {
          currentParenthesizerRule = parenthesizerRule;
          var pipelinePhase = getPipelinePhase(0, emitHint, node);
          pipelinePhase(emitHint, node);
          currentParenthesizerRule = void 0;
        }
        function shouldEmitComments(node) {
          return !commentsDisabled && !ts3.isSourceFile(node);
        }
        function shouldEmitSourceMaps(node) {
          return !sourceMapsDisabled && !ts3.isSourceFile(node) && !ts3.isInJsonFile(node) && !ts3.isUnparsedSource(node) && !ts3.isUnparsedPrepend(node);
        }
        function getPipelinePhase(phase, emitHint, node) {
          switch (phase) {
            case 0:
              if (onEmitNode !== ts3.noEmitNotification && (!isEmitNotificationEnabled || isEmitNotificationEnabled(node))) {
                return pipelineEmitWithNotification;
              }
            case 1:
              if (substituteNode !== ts3.noEmitSubstitution && (lastSubstitution = substituteNode(emitHint, node) || node) !== node) {
                if (currentParenthesizerRule) {
                  lastSubstitution = currentParenthesizerRule(lastSubstitution);
                }
                return pipelineEmitWithSubstitution;
              }
            case 2:
              if (shouldEmitComments(node)) {
                return pipelineEmitWithComments;
              }
            case 3:
              if (shouldEmitSourceMaps(node)) {
                return pipelineEmitWithSourceMaps;
              }
            case 4:
              return pipelineEmitWithHint;
            default:
              return ts3.Debug.assertNever(phase);
          }
        }
        function getNextPipelinePhase(currentPhase, emitHint, node) {
          return getPipelinePhase(currentPhase + 1, emitHint, node);
        }
        function pipelineEmitWithNotification(hint, node) {
          var pipelinePhase = getNextPipelinePhase(0, hint, node);
          onEmitNode(hint, node, pipelinePhase);
        }
        function pipelineEmitWithHint(hint, node) {
          onBeforeEmitNode === null || onBeforeEmitNode === void 0 ? void 0 : onBeforeEmitNode(node);
          if (preserveSourceNewlines) {
            var savedPreserveSourceNewlines = preserveSourceNewlines;
            beforeEmitNode(node);
            pipelineEmitWithHintWorker(hint, node);
            afterEmitNode(savedPreserveSourceNewlines);
          } else {
            pipelineEmitWithHintWorker(hint, node);
          }
          onAfterEmitNode === null || onAfterEmitNode === void 0 ? void 0 : onAfterEmitNode(node);
          currentParenthesizerRule = void 0;
        }
        function pipelineEmitWithHintWorker(hint, node, allowSnippets) {
          if (allowSnippets === void 0) {
            allowSnippets = true;
          }
          if (allowSnippets) {
            var snippet2 = ts3.getSnippetElement(node);
            if (snippet2) {
              return emitSnippetNode(hint, node, snippet2);
            }
          }
          if (hint === 0)
            return emitSourceFile(ts3.cast(node, ts3.isSourceFile));
          if (hint === 2)
            return emitIdentifier(ts3.cast(node, ts3.isIdentifier));
          if (hint === 6)
            return emitLiteral(ts3.cast(node, ts3.isStringLiteral), true);
          if (hint === 3)
            return emitMappedTypeParameter(ts3.cast(node, ts3.isTypeParameterDeclaration));
          if (hint === 5) {
            ts3.Debug.assertNode(node, ts3.isEmptyStatement);
            return emitEmptyStatement(true);
          }
          if (hint === 4) {
            switch (node.kind) {
              case 15:
              case 16:
              case 17:
                return emitLiteral(node, false);
              case 79:
                return emitIdentifier(node);
              case 80:
                return emitPrivateIdentifier(node);
              case 161:
                return emitQualifiedName(node);
              case 162:
                return emitComputedPropertyName(node);
              case 163:
                return emitTypeParameter(node);
              case 164:
                return emitParameter(node);
              case 165:
                return emitDecorator(node);
              case 166:
                return emitPropertySignature(node);
              case 167:
                return emitPropertyDeclaration(node);
              case 168:
                return emitMethodSignature(node);
              case 169:
                return emitMethodDeclaration(node);
              case 170:
                return emitClassStaticBlockDeclaration(node);
              case 171:
                return emitConstructor(node);
              case 172:
              case 173:
                return emitAccessorDeclaration(node);
              case 174:
                return emitCallSignature(node);
              case 175:
                return emitConstructSignature(node);
              case 176:
                return emitIndexSignature(node);
              case 177:
                return emitTypePredicate(node);
              case 178:
                return emitTypeReference(node);
              case 179:
                return emitFunctionType(node);
              case 180:
                return emitConstructorType(node);
              case 181:
                return emitTypeQuery(node);
              case 182:
                return emitTypeLiteral(node);
              case 183:
                return emitArrayType(node);
              case 184:
                return emitTupleType(node);
              case 185:
                return emitOptionalType(node);
              case 187:
                return emitUnionType(node);
              case 188:
                return emitIntersectionType(node);
              case 189:
                return emitConditionalType(node);
              case 190:
                return emitInferType(node);
              case 191:
                return emitParenthesizedType(node);
              case 228:
                return emitExpressionWithTypeArguments(node);
              case 192:
                return emitThisType();
              case 193:
                return emitTypeOperator(node);
              case 194:
                return emitIndexedAccessType(node);
              case 195:
                return emitMappedType(node);
              case 196:
                return emitLiteralType(node);
              case 197:
                return emitNamedTupleMember(node);
              case 198:
                return emitTemplateType(node);
              case 199:
                return emitTemplateTypeSpan(node);
              case 200:
                return emitImportTypeNode(node);
              case 201:
                return emitObjectBindingPattern(node);
              case 202:
                return emitArrayBindingPattern(node);
              case 203:
                return emitBindingElement(node);
              case 233:
                return emitTemplateSpan(node);
              case 234:
                return emitSemicolonClassElement();
              case 235:
                return emitBlock(node);
              case 237:
                return emitVariableStatement(node);
              case 236:
                return emitEmptyStatement(false);
              case 238:
                return emitExpressionStatement(node);
              case 239:
                return emitIfStatement(node);
              case 240:
                return emitDoStatement(node);
              case 241:
                return emitWhileStatement(node);
              case 242:
                return emitForStatement(node);
              case 243:
                return emitForInStatement(node);
              case 244:
                return emitForOfStatement(node);
              case 245:
                return emitContinueStatement(node);
              case 246:
                return emitBreakStatement(node);
              case 247:
                return emitReturnStatement(node);
              case 248:
                return emitWithStatement(node);
              case 249:
                return emitSwitchStatement(node);
              case 250:
                return emitLabeledStatement(node);
              case 251:
                return emitThrowStatement(node);
              case 252:
                return emitTryStatement(node);
              case 253:
                return emitDebuggerStatement(node);
              case 254:
                return emitVariableDeclaration(node);
              case 255:
                return emitVariableDeclarationList(node);
              case 256:
                return emitFunctionDeclaration(node);
              case 257:
                return emitClassDeclaration(node);
              case 258:
                return emitInterfaceDeclaration(node);
              case 259:
                return emitTypeAliasDeclaration(node);
              case 260:
                return emitEnumDeclaration(node);
              case 261:
                return emitModuleDeclaration(node);
              case 262:
                return emitModuleBlock(node);
              case 263:
                return emitCaseBlock(node);
              case 264:
                return emitNamespaceExportDeclaration(node);
              case 265:
                return emitImportEqualsDeclaration(node);
              case 266:
                return emitImportDeclaration(node);
              case 267:
                return emitImportClause(node);
              case 268:
                return emitNamespaceImport(node);
              case 274:
                return emitNamespaceExport(node);
              case 269:
                return emitNamedImports(node);
              case 270:
                return emitImportSpecifier(node);
              case 271:
                return emitExportAssignment(node);
              case 272:
                return emitExportDeclaration(node);
              case 273:
                return emitNamedExports(node);
              case 275:
                return emitExportSpecifier(node);
              case 293:
                return emitAssertClause(node);
              case 294:
                return emitAssertEntry(node);
              case 276:
                return;
              case 277:
                return emitExternalModuleReference(node);
              case 11:
                return emitJsxText(node);
              case 280:
              case 283:
                return emitJsxOpeningElementOrFragment(node);
              case 281:
              case 284:
                return emitJsxClosingElementOrFragment(node);
              case 285:
                return emitJsxAttribute(node);
              case 286:
                return emitJsxAttributes(node);
              case 287:
                return emitJsxSpreadAttribute(node);
              case 288:
                return emitJsxExpression(node);
              case 289:
                return emitCaseClause(node);
              case 290:
                return emitDefaultClause(node);
              case 291:
                return emitHeritageClause(node);
              case 292:
                return emitCatchClause(node);
              case 296:
                return emitPropertyAssignment(node);
              case 297:
                return emitShorthandPropertyAssignment(node);
              case 298:
                return emitSpreadAssignment(node);
              case 299:
                return emitEnumMember(node);
              case 300:
                return writeUnparsedNode(node);
              case 307:
              case 301:
                return emitUnparsedSourceOrPrepend(node);
              case 302:
              case 303:
                return emitUnparsedTextLike(node);
              case 304:
                return emitUnparsedSyntheticReference(node);
              case 305:
                return emitSourceFile(node);
              case 306:
                return ts3.Debug.fail("Bundles should be printed using printBundle");
              case 308:
                return ts3.Debug.fail("InputFiles should not be printed");
              case 309:
                return emitJSDocTypeExpression(node);
              case 310:
                return emitJSDocNameReference(node);
              case 312:
                return writePunctuation("*");
              case 313:
                return writePunctuation("?");
              case 314:
                return emitJSDocNullableType(node);
              case 315:
                return emitJSDocNonNullableType(node);
              case 316:
                return emitJSDocOptionalType(node);
              case 317:
                return emitJSDocFunctionType(node);
              case 186:
              case 318:
                return emitRestOrJSDocVariadicType(node);
              case 319:
                return;
              case 320:
                return emitJSDoc(node);
              case 322:
                return emitJSDocTypeLiteral(node);
              case 323:
                return emitJSDocSignature(node);
              case 327:
              case 332:
              case 337:
                return emitJSDocSimpleTag(node);
              case 328:
              case 329:
                return emitJSDocHeritageTag(node);
              case 330:
              case 331:
                return;
              case 333:
              case 334:
              case 335:
              case 336:
                return;
              case 338:
                return emitJSDocCallbackTag(node);
              case 340:
              case 347:
                return emitJSDocPropertyLikeTag(node);
              case 339:
              case 341:
              case 342:
              case 343:
                return emitJSDocSimpleTypedTag(node);
              case 344:
                return emitJSDocTemplateTag(node);
              case 345:
                return emitJSDocTypedefTag(node);
              case 346:
                return emitJSDocSeeTag(node);
              case 349:
              case 353:
              case 352:
                return;
            }
            if (ts3.isExpression(node)) {
              hint = 1;
              if (substituteNode !== ts3.noEmitSubstitution) {
                var substitute = substituteNode(hint, node) || node;
                if (substitute !== node) {
                  node = substitute;
                  if (currentParenthesizerRule) {
                    node = currentParenthesizerRule(node);
                  }
                }
              }
            }
          }
          if (hint === 1) {
            switch (node.kind) {
              case 8:
              case 9:
                return emitNumericOrBigIntLiteral(node);
              case 10:
              case 13:
              case 14:
                return emitLiteral(node, false);
              case 79:
                return emitIdentifier(node);
              case 80:
                return emitPrivateIdentifier(node);
              case 204:
                return emitArrayLiteralExpression(node);
              case 205:
                return emitObjectLiteralExpression(node);
              case 206:
                return emitPropertyAccessExpression(node);
              case 207:
                return emitElementAccessExpression(node);
              case 208:
                return emitCallExpression(node);
              case 209:
                return emitNewExpression(node);
              case 210:
                return emitTaggedTemplateExpression(node);
              case 211:
                return emitTypeAssertionExpression(node);
              case 212:
                return emitParenthesizedExpression(node);
              case 213:
                return emitFunctionExpression(node);
              case 214:
                return emitArrowFunction(node);
              case 215:
                return emitDeleteExpression(node);
              case 216:
                return emitTypeOfExpression(node);
              case 217:
                return emitVoidExpression(node);
              case 218:
                return emitAwaitExpression(node);
              case 219:
                return emitPrefixUnaryExpression(node);
              case 220:
                return emitPostfixUnaryExpression(node);
              case 221:
                return emitBinaryExpression(node);
              case 222:
                return emitConditionalExpression(node);
              case 223:
                return emitTemplateExpression(node);
              case 224:
                return emitYieldExpression(node);
              case 225:
                return emitSpreadElement(node);
              case 226:
                return emitClassExpression(node);
              case 227:
                return;
              case 229:
                return emitAsExpression(node);
              case 230:
                return emitNonNullExpression(node);
              case 228:
                return emitExpressionWithTypeArguments(node);
              case 231:
                return emitMetaProperty(node);
              case 232:
                return ts3.Debug.fail("SyntheticExpression should never be printed.");
              case 278:
                return emitJsxElement(node);
              case 279:
                return emitJsxSelfClosingElement(node);
              case 282:
                return emitJsxFragment(node);
              case 348:
                return ts3.Debug.fail("SyntaxList should not be printed");
              case 349:
                return;
              case 350:
                return emitPartiallyEmittedExpression(node);
              case 351:
                return emitCommaList(node);
              case 352:
              case 353:
                return;
              case 354:
                return ts3.Debug.fail("SyntheticReferenceExpression should not be printed");
            }
          }
          if (ts3.isKeyword(node.kind))
            return writeTokenNode(node, writeKeyword);
          if (ts3.isTokenKind(node.kind))
            return writeTokenNode(node, writePunctuation);
          ts3.Debug.fail("Unhandled SyntaxKind: ".concat(ts3.Debug.formatSyntaxKind(node.kind), "."));
        }
        function emitMappedTypeParameter(node) {
          emit(node.name);
          writeSpace();
          writeKeyword("in");
          writeSpace();
          emit(node.constraint);
        }
        function pipelineEmitWithSubstitution(hint, node) {
          var pipelinePhase = getNextPipelinePhase(1, hint, node);
          ts3.Debug.assertIsDefined(lastSubstitution);
          node = lastSubstitution;
          lastSubstitution = void 0;
          pipelinePhase(hint, node);
        }
        function getHelpersFromBundledSourceFiles(bundle) {
          var result2;
          if (moduleKind === ts3.ModuleKind.None || printerOptions.noEmitHelpers) {
            return void 0;
          }
          var bundledHelpers2 = new ts3.Map();
          for (var _a2 = 0, _b2 = bundle.sourceFiles; _a2 < _b2.length; _a2++) {
            var sourceFile = _b2[_a2];
            var shouldSkip = ts3.getExternalHelpersModuleName(sourceFile) !== void 0;
            var helpers = getSortedEmitHelpers(sourceFile);
            if (!helpers)
              continue;
            for (var _c2 = 0, helpers_5 = helpers; _c2 < helpers_5.length; _c2++) {
              var helper = helpers_5[_c2];
              if (!helper.scoped && !shouldSkip && !bundledHelpers2.get(helper.name)) {
                bundledHelpers2.set(helper.name, true);
                (result2 || (result2 = [])).push(helper.name);
              }
            }
          }
          return result2;
        }
        function emitHelpers(node) {
          var helpersEmitted = false;
          var bundle = node.kind === 306 ? node : void 0;
          if (bundle && moduleKind === ts3.ModuleKind.None) {
            return;
          }
          var numPrepends = bundle ? bundle.prepends.length : 0;
          var numNodes = bundle ? bundle.sourceFiles.length + numPrepends : 1;
          for (var i = 0; i < numNodes; i++) {
            var currentNode = bundle ? i < numPrepends ? bundle.prepends[i] : bundle.sourceFiles[i - numPrepends] : node;
            var sourceFile = ts3.isSourceFile(currentNode) ? currentNode : ts3.isUnparsedSource(currentNode) ? void 0 : currentSourceFile;
            var shouldSkip = printerOptions.noEmitHelpers || !!sourceFile && ts3.hasRecordedExternalHelpers(sourceFile);
            var shouldBundle = (ts3.isSourceFile(currentNode) || ts3.isUnparsedSource(currentNode)) && !isOwnFileEmit;
            var helpers = ts3.isUnparsedSource(currentNode) ? currentNode.helpers : getSortedEmitHelpers(currentNode);
            if (helpers) {
              for (var _a2 = 0, helpers_6 = helpers; _a2 < helpers_6.length; _a2++) {
                var helper = helpers_6[_a2];
                if (!helper.scoped) {
                  if (shouldSkip)
                    continue;
                  if (shouldBundle) {
                    if (bundledHelpers.get(helper.name)) {
                      continue;
                    }
                    bundledHelpers.set(helper.name, true);
                  }
                } else if (bundle) {
                  continue;
                }
                var pos = getTextPosWithWriteLine();
                if (typeof helper.text === "string") {
                  writeLines(helper.text);
                } else {
                  writeLines(helper.text(makeFileLevelOptimisticUniqueName));
                }
                if (bundleFileInfo)
                  bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "emitHelpers", data: helper.name });
                helpersEmitted = true;
              }
            }
          }
          return helpersEmitted;
        }
        function getSortedEmitHelpers(node) {
          var helpers = ts3.getEmitHelpers(node);
          return helpers && ts3.stableSort(helpers, ts3.compareEmitHelpers);
        }
        function emitNumericOrBigIntLiteral(node) {
          emitLiteral(node, false);
        }
        function emitLiteral(node, jsxAttributeEscape) {
          var text = getLiteralTextOfNode(node, printerOptions.neverAsciiEscape, jsxAttributeEscape);
          if ((printerOptions.sourceMap || printerOptions.inlineSourceMap) && (node.kind === 10 || ts3.isTemplateLiteralKind(node.kind))) {
            writeLiteral(text);
          } else {
            writeStringLiteral(text);
          }
        }
        function emitUnparsedSourceOrPrepend(unparsed) {
          for (var _a2 = 0, _b2 = unparsed.texts; _a2 < _b2.length; _a2++) {
            var text = _b2[_a2];
            writeLine();
            emit(text);
          }
        }
        function writeUnparsedNode(unparsed) {
          writer.rawWrite(unparsed.parent.text.substring(unparsed.pos, unparsed.end));
        }
        function emitUnparsedTextLike(unparsed) {
          var pos = getTextPosWithWriteLine();
          writeUnparsedNode(unparsed);
          if (bundleFileInfo) {
            updateOrPushBundleFileTextLike(pos, writer.getTextPos(), unparsed.kind === 302 ? "text" : "internal");
          }
        }
        function emitUnparsedSyntheticReference(unparsed) {
          var pos = getTextPosWithWriteLine();
          writeUnparsedNode(unparsed);
          if (bundleFileInfo) {
            var section = ts3.clone(unparsed.section);
            section.pos = pos;
            section.end = writer.getTextPos();
            bundleFileInfo.sections.push(section);
          }
        }
        function emitSnippetNode(hint, node, snippet2) {
          switch (snippet2.kind) {
            case 1:
              emitPlaceholder(hint, node, snippet2);
              break;
            case 0:
              emitTabStop(hint, node, snippet2);
              break;
          }
        }
        function emitPlaceholder(hint, node, snippet2) {
          nonEscapingWrite("${".concat(snippet2.order, ":"));
          pipelineEmitWithHintWorker(hint, node, false);
          nonEscapingWrite("}");
        }
        function emitTabStop(hint, node, snippet2) {
          ts3.Debug.assert(node.kind === 236, "A tab stop cannot be attached to a node of kind ".concat(ts3.Debug.formatSyntaxKind(node.kind), "."));
          ts3.Debug.assert(hint !== 5, "A tab stop cannot be attached to an embedded statement.");
          nonEscapingWrite("$".concat(snippet2.order));
        }
        function emitIdentifier(node) {
          var writeText = node.symbol ? writeSymbol : write;
          writeText(getTextOfNode(node, false), node.symbol);
          emitList(node, node.typeArguments, 53776);
        }
        function emitPrivateIdentifier(node) {
          var writeText = node.symbol ? writeSymbol : write;
          writeText(getTextOfNode(node, false), node.symbol);
        }
        function emitQualifiedName(node) {
          emitEntityName(node.left);
          writePunctuation(".");
          emit(node.right);
        }
        function emitEntityName(node) {
          if (node.kind === 79) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitComputedPropertyName(node) {
          writePunctuation("[");
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfComputedPropertyName);
          writePunctuation("]");
        }
        function emitTypeParameter(node) {
          emitModifiers(node, node.modifiers);
          emit(node.name);
          if (node.constraint) {
            writeSpace();
            writeKeyword("extends");
            writeSpace();
            emit(node.constraint);
          }
          if (node.default) {
            writeSpace();
            writeOperator("=");
            writeSpace();
            emit(node.default);
          }
        }
        function emitParameter(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.dotDotDotToken);
          emitNodeWithWriter(node.name, writeParameter);
          emit(node.questionToken);
          if (node.parent && node.parent.kind === 317 && !node.name) {
            emit(node.type);
          } else {
            emitTypeAnnotation(node.type);
          }
          emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name ? node.name.end : node.modifiers ? node.modifiers.end : node.decorators ? node.decorators.end : node.pos, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitDecorator(decorator) {
          writePunctuation("@");
          emitExpression(decorator.expression, parenthesizer.parenthesizeLeftSideOfAccess);
        }
        function emitPropertySignature(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitNodeWithWriter(node.name, writeProperty);
          emit(node.questionToken);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
        }
        function emitPropertyDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.name);
          emit(node.questionToken);
          emit(node.exclamationToken);
          emitTypeAnnotation(node.type);
          emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name.end, node);
          writeTrailingSemicolon();
        }
        function emitMethodSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.name);
          emit(node.questionToken);
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitMethodDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.asteriskToken);
          emit(node.name);
          emit(node.questionToken);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitClassStaticBlockDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("static");
          emitBlockFunctionBody(node.body);
        }
        function emitConstructor(node) {
          emitModifiers(node, node.modifiers);
          writeKeyword("constructor");
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitAccessorDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword(node.kind === 172 ? "get" : "set");
          writeSpace();
          emit(node.name);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitCallSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitConstructSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("new");
          writeSpace();
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitIndexSignature(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitParametersForIndexSignature(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
        }
        function emitTemplateTypeSpan(node) {
          emit(node.type);
          emit(node.literal);
        }
        function emitSemicolonClassElement() {
          writeTrailingSemicolon();
        }
        function emitTypePredicate(node) {
          if (node.assertsModifier) {
            emit(node.assertsModifier);
            writeSpace();
          }
          emit(node.parameterName);
          if (node.type) {
            writeSpace();
            writeKeyword("is");
            writeSpace();
            emit(node.type);
          }
        }
        function emitTypeReference(node) {
          emit(node.typeName);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitFunctionType(node) {
          pushNameGenerationScope(node);
          emitTypeParameters(node, node.typeParameters);
          emitParametersForArrow(node, node.parameters);
          writeSpace();
          writePunctuation("=>");
          writeSpace();
          emit(node.type);
          popNameGenerationScope(node);
        }
        function emitJSDocFunctionType(node) {
          writeKeyword("function");
          emitParameters(node, node.parameters);
          writePunctuation(":");
          emit(node.type);
        }
        function emitJSDocNullableType(node) {
          writePunctuation("?");
          emit(node.type);
        }
        function emitJSDocNonNullableType(node) {
          writePunctuation("!");
          emit(node.type);
        }
        function emitJSDocOptionalType(node) {
          emit(node.type);
          writePunctuation("=");
        }
        function emitConstructorType(node) {
          pushNameGenerationScope(node);
          emitModifiers(node, node.modifiers);
          writeKeyword("new");
          writeSpace();
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          writeSpace();
          writePunctuation("=>");
          writeSpace();
          emit(node.type);
          popNameGenerationScope(node);
        }
        function emitTypeQuery(node) {
          writeKeyword("typeof");
          writeSpace();
          emit(node.exprName);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitTypeLiteral(node) {
          writePunctuation("{");
          var flags = ts3.getEmitFlags(node) & 1 ? 768 : 32897;
          emitList(node, node.members, flags | 524288);
          writePunctuation("}");
        }
        function emitArrayType(node) {
          emit(node.elementType, parenthesizer.parenthesizeNonArrayTypeOfPostfixType);
          writePunctuation("[");
          writePunctuation("]");
        }
        function emitRestOrJSDocVariadicType(node) {
          writePunctuation("...");
          emit(node.type);
        }
        function emitTupleType(node) {
          emitTokenWithComment(22, node.pos, writePunctuation, node);
          var flags = ts3.getEmitFlags(node) & 1 ? 528 : 657;
          emitList(node, node.elements, flags | 524288, parenthesizer.parenthesizeElementTypeOfTupleType);
          emitTokenWithComment(23, node.elements.end, writePunctuation, node);
        }
        function emitNamedTupleMember(node) {
          emit(node.dotDotDotToken);
          emit(node.name);
          emit(node.questionToken);
          emitTokenWithComment(58, node.name.end, writePunctuation, node);
          writeSpace();
          emit(node.type);
        }
        function emitOptionalType(node) {
          emit(node.type, parenthesizer.parenthesizeTypeOfOptionalType);
          writePunctuation("?");
        }
        function emitUnionType(node) {
          emitList(node, node.types, 516, parenthesizer.parenthesizeConstituentTypeOfUnionType);
        }
        function emitIntersectionType(node) {
          emitList(node, node.types, 520, parenthesizer.parenthesizeConstituentTypeOfIntersectionType);
        }
        function emitConditionalType(node) {
          emit(node.checkType, parenthesizer.parenthesizeCheckTypeOfConditionalType);
          writeSpace();
          writeKeyword("extends");
          writeSpace();
          emit(node.extendsType, parenthesizer.parenthesizeExtendsTypeOfConditionalType);
          writeSpace();
          writePunctuation("?");
          writeSpace();
          emit(node.trueType);
          writeSpace();
          writePunctuation(":");
          writeSpace();
          emit(node.falseType);
        }
        function emitInferType(node) {
          writeKeyword("infer");
          writeSpace();
          emit(node.typeParameter);
        }
        function emitParenthesizedType(node) {
          writePunctuation("(");
          emit(node.type);
          writePunctuation(")");
        }
        function emitThisType() {
          writeKeyword("this");
        }
        function emitTypeOperator(node) {
          writeTokenText(node.operator, writeKeyword);
          writeSpace();
          var parenthesizerRule = node.operator === 145 ? parenthesizer.parenthesizeOperandOfReadonlyTypeOperator : parenthesizer.parenthesizeOperandOfTypeOperator;
          emit(node.type, parenthesizerRule);
        }
        function emitIndexedAccessType(node) {
          emit(node.objectType, parenthesizer.parenthesizeNonArrayTypeOfPostfixType);
          writePunctuation("[");
          emit(node.indexType);
          writePunctuation("]");
        }
        function emitMappedType(node) {
          var emitFlags = ts3.getEmitFlags(node);
          writePunctuation("{");
          if (emitFlags & 1) {
            writeSpace();
          } else {
            writeLine();
            increaseIndent();
          }
          if (node.readonlyToken) {
            emit(node.readonlyToken);
            if (node.readonlyToken.kind !== 145) {
              writeKeyword("readonly");
            }
            writeSpace();
          }
          writePunctuation("[");
          pipelineEmit(3, node.typeParameter);
          if (node.nameType) {
            writeSpace();
            writeKeyword("as");
            writeSpace();
            emit(node.nameType);
          }
          writePunctuation("]");
          if (node.questionToken) {
            emit(node.questionToken);
            if (node.questionToken.kind !== 57) {
              writePunctuation("?");
            }
          }
          writePunctuation(":");
          writeSpace();
          emit(node.type);
          writeTrailingSemicolon();
          if (emitFlags & 1) {
            writeSpace();
          } else {
            writeLine();
            decreaseIndent();
          }
          emitList(node, node.members, 2);
          writePunctuation("}");
        }
        function emitLiteralType(node) {
          emitExpression(node.literal);
        }
        function emitTemplateType(node) {
          emit(node.head);
          emitList(node, node.templateSpans, 262144);
        }
        function emitImportTypeNode(node) {
          if (node.isTypeOf) {
            writeKeyword("typeof");
            writeSpace();
          }
          writeKeyword("import");
          writePunctuation("(");
          emit(node.argument);
          if (node.assertions) {
            writePunctuation(",");
            writeSpace();
            writePunctuation("{");
            writeSpace();
            writeKeyword("assert");
            writePunctuation(":");
            writeSpace();
            var elements = node.assertions.assertClause.elements;
            emitList(node.assertions.assertClause, elements, 526226);
            writeSpace();
            writePunctuation("}");
          }
          writePunctuation(")");
          if (node.qualifier) {
            writePunctuation(".");
            emit(node.qualifier);
          }
          emitTypeArguments(node, node.typeArguments);
        }
        function emitObjectBindingPattern(node) {
          writePunctuation("{");
          emitList(node, node.elements, 525136);
          writePunctuation("}");
        }
        function emitArrayBindingPattern(node) {
          writePunctuation("[");
          emitList(node, node.elements, 524880);
          writePunctuation("]");
        }
        function emitBindingElement(node) {
          emit(node.dotDotDotToken);
          if (node.propertyName) {
            emit(node.propertyName);
            writePunctuation(":");
            writeSpace();
          }
          emit(node.name);
          emitInitializer(node.initializer, node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitArrayLiteralExpression(node) {
          var elements = node.elements;
          var preferNewLine = node.multiLine ? 65536 : 0;
          emitExpressionList(node, elements, 8914 | preferNewLine, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitObjectLiteralExpression(node) {
          ts3.forEach(node.properties, generateMemberNames);
          var indentedFlag = ts3.getEmitFlags(node) & 65536;
          if (indentedFlag) {
            increaseIndent();
          }
          var preferNewLine = node.multiLine ? 65536 : 0;
          var allowTrailingComma = currentSourceFile && currentSourceFile.languageVersion >= 1 && !ts3.isJsonSourceFile(currentSourceFile) ? 64 : 0;
          emitList(node, node.properties, 526226 | allowTrailingComma | preferNewLine);
          if (indentedFlag) {
            decreaseIndent();
          }
        }
        function emitPropertyAccessExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          var token = node.questionDotToken || ts3.setTextRangePosEnd(ts3.factory.createToken(24), node.expression.end, node.name.pos);
          var linesBeforeDot = getLinesBetweenNodes(node, node.expression, token);
          var linesAfterDot = getLinesBetweenNodes(node, token, node.name);
          writeLinesAndIndent(linesBeforeDot, false);
          var shouldEmitDotDot = token.kind !== 28 && mayNeedDotDotForPropertyAccess(node.expression) && !writer.hasTrailingComment() && !writer.hasTrailingWhitespace();
          if (shouldEmitDotDot) {
            writePunctuation(".");
          }
          if (node.questionDotToken) {
            emit(token);
          } else {
            emitTokenWithComment(token.kind, node.expression.end, writePunctuation, node);
          }
          writeLinesAndIndent(linesAfterDot, false);
          emit(node.name);
          decreaseIndentIf(linesBeforeDot, linesAfterDot);
        }
        function mayNeedDotDotForPropertyAccess(expression) {
          expression = ts3.skipPartiallyEmittedExpressions(expression);
          if (ts3.isNumericLiteral(expression)) {
            var text = getLiteralTextOfNode(expression, true, false);
            return !expression.numericLiteralFlags && !ts3.stringContains(text, ts3.tokenToString(24));
          } else if (ts3.isAccessExpression(expression)) {
            var constantValue = ts3.getConstantValue(expression);
            return typeof constantValue === "number" && isFinite(constantValue) && Math.floor(constantValue) === constantValue;
          }
        }
        function emitElementAccessExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          emit(node.questionDotToken);
          emitTokenWithComment(22, node.expression.end, writePunctuation, node);
          emitExpression(node.argumentExpression);
          emitTokenWithComment(23, node.argumentExpression.end, writePunctuation, node);
        }
        function emitCallExpression(node) {
          var indirectCall = ts3.getEmitFlags(node) & 536870912;
          if (indirectCall) {
            writePunctuation("(");
            writeLiteral("0");
            writePunctuation(",");
            writeSpace();
          }
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          if (indirectCall) {
            writePunctuation(")");
          }
          emit(node.questionDotToken);
          emitTypeArguments(node, node.typeArguments);
          emitExpressionList(node, node.arguments, 2576, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitNewExpression(node) {
          emitTokenWithComment(103, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfNew);
          emitTypeArguments(node, node.typeArguments);
          emitExpressionList(node, node.arguments, 18960, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitTaggedTemplateExpression(node) {
          var indirectCall = ts3.getEmitFlags(node) & 536870912;
          if (indirectCall) {
            writePunctuation("(");
            writeLiteral("0");
            writePunctuation(",");
            writeSpace();
          }
          emitExpression(node.tag, parenthesizer.parenthesizeLeftSideOfAccess);
          if (indirectCall) {
            writePunctuation(")");
          }
          emitTypeArguments(node, node.typeArguments);
          writeSpace();
          emitExpression(node.template);
        }
        function emitTypeAssertionExpression(node) {
          writePunctuation("<");
          emit(node.type);
          writePunctuation(">");
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitParenthesizedExpression(node) {
          var openParenPos = emitTokenWithComment(20, node.pos, writePunctuation, node);
          var indented = writeLineSeparatorsAndIndentBefore(node.expression, node);
          emitExpression(node.expression, void 0);
          writeLineSeparatorsAfter(node.expression, node);
          decreaseIndentIf(indented);
          emitTokenWithComment(21, node.expression ? node.expression.end : openParenPos, writePunctuation, node);
        }
        function emitFunctionExpression(node) {
          generateNameIfNeeded(node.name);
          emitFunctionDeclarationOrExpression(node);
        }
        function emitArrowFunction(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitSignatureAndBody(node, emitArrowFunctionHead);
        }
        function emitArrowFunctionHead(node) {
          emitTypeParameters(node, node.typeParameters);
          emitParametersForArrow(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeSpace();
          emit(node.equalsGreaterThanToken);
        }
        function emitDeleteExpression(node) {
          emitTokenWithComment(89, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitTypeOfExpression(node) {
          emitTokenWithComment(112, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitVoidExpression(node) {
          emitTokenWithComment(114, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitAwaitExpression(node) {
          emitTokenWithComment(132, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitPrefixUnaryExpression(node) {
          writeTokenText(node.operator, writeOperator);
          if (shouldEmitWhitespaceBeforeOperand(node)) {
            writeSpace();
          }
          emitExpression(node.operand, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function shouldEmitWhitespaceBeforeOperand(node) {
          var operand = node.operand;
          return operand.kind === 219 && (node.operator === 39 && (operand.operator === 39 || operand.operator === 45) || node.operator === 40 && (operand.operator === 40 || operand.operator === 46));
        }
        function emitPostfixUnaryExpression(node) {
          emitExpression(node.operand, parenthesizer.parenthesizeOperandOfPostfixUnary);
          writeTokenText(node.operator, writeOperator);
        }
        function createEmitBinaryExpression() {
          return ts3.createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, void 0);
          function onEnter(node, state) {
            if (state) {
              state.stackIndex++;
              state.preserveSourceNewlinesStack[state.stackIndex] = preserveSourceNewlines;
              state.containerPosStack[state.stackIndex] = containerPos;
              state.containerEndStack[state.stackIndex] = containerEnd;
              state.declarationListContainerEndStack[state.stackIndex] = declarationListContainerEnd;
              var emitComments_1 = state.shouldEmitCommentsStack[state.stackIndex] = shouldEmitComments(node);
              var emitSourceMaps = state.shouldEmitSourceMapsStack[state.stackIndex] = shouldEmitSourceMaps(node);
              onBeforeEmitNode === null || onBeforeEmitNode === void 0 ? void 0 : onBeforeEmitNode(node);
              if (emitComments_1)
                emitCommentsBeforeNode(node);
              if (emitSourceMaps)
                emitSourceMapsBeforeNode(node);
              beforeEmitNode(node);
            } else {
              state = {
                stackIndex: 0,
                preserveSourceNewlinesStack: [void 0],
                containerPosStack: [-1],
                containerEndStack: [-1],
                declarationListContainerEndStack: [-1],
                shouldEmitCommentsStack: [false],
                shouldEmitSourceMapsStack: [false]
              };
            }
            return state;
          }
          function onLeft(next, _workArea, parent) {
            return maybeEmitExpression(next, parent, "left");
          }
          function onOperator(operatorToken, _state, node) {
            var isCommaOperator = operatorToken.kind !== 27;
            var linesBeforeOperator = getLinesBetweenNodes(node, node.left, operatorToken);
            var linesAfterOperator = getLinesBetweenNodes(node, operatorToken, node.right);
            writeLinesAndIndent(linesBeforeOperator, isCommaOperator);
            emitLeadingCommentsOfPosition(operatorToken.pos);
            writeTokenNode(operatorToken, operatorToken.kind === 101 ? writeKeyword : writeOperator);
            emitTrailingCommentsOfPosition(operatorToken.end, true);
            writeLinesAndIndent(linesAfterOperator, true);
          }
          function onRight(next, _workArea, parent) {
            return maybeEmitExpression(next, parent, "right");
          }
          function onExit(node, state) {
            var linesBeforeOperator = getLinesBetweenNodes(node, node.left, node.operatorToken);
            var linesAfterOperator = getLinesBetweenNodes(node, node.operatorToken, node.right);
            decreaseIndentIf(linesBeforeOperator, linesAfterOperator);
            if (state.stackIndex > 0) {
              var savedPreserveSourceNewlines = state.preserveSourceNewlinesStack[state.stackIndex];
              var savedContainerPos = state.containerPosStack[state.stackIndex];
              var savedContainerEnd = state.containerEndStack[state.stackIndex];
              var savedDeclarationListContainerEnd = state.declarationListContainerEndStack[state.stackIndex];
              var shouldEmitComments_1 = state.shouldEmitCommentsStack[state.stackIndex];
              var shouldEmitSourceMaps_1 = state.shouldEmitSourceMapsStack[state.stackIndex];
              afterEmitNode(savedPreserveSourceNewlines);
              if (shouldEmitSourceMaps_1)
                emitSourceMapsAfterNode(node);
              if (shouldEmitComments_1)
                emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
              onAfterEmitNode === null || onAfterEmitNode === void 0 ? void 0 : onAfterEmitNode(node);
              state.stackIndex--;
            }
          }
          function maybeEmitExpression(next, parent, side) {
            var parenthesizerRule = side === "left" ? parenthesizer.getParenthesizeLeftSideOfBinaryForOperator(parent.operatorToken.kind) : parenthesizer.getParenthesizeRightSideOfBinaryForOperator(parent.operatorToken.kind);
            var pipelinePhase = getPipelinePhase(0, 1, next);
            if (pipelinePhase === pipelineEmitWithSubstitution) {
              ts3.Debug.assertIsDefined(lastSubstitution);
              next = parenthesizerRule(ts3.cast(lastSubstitution, ts3.isExpression));
              pipelinePhase = getNextPipelinePhase(1, 1, next);
              lastSubstitution = void 0;
            }
            if (pipelinePhase === pipelineEmitWithComments || pipelinePhase === pipelineEmitWithSourceMaps || pipelinePhase === pipelineEmitWithHint) {
              if (ts3.isBinaryExpression(next)) {
                return next;
              }
            }
            currentParenthesizerRule = parenthesizerRule;
            pipelinePhase(1, next);
          }
        }
        function emitConditionalExpression(node) {
          var linesBeforeQuestion = getLinesBetweenNodes(node, node.condition, node.questionToken);
          var linesAfterQuestion = getLinesBetweenNodes(node, node.questionToken, node.whenTrue);
          var linesBeforeColon = getLinesBetweenNodes(node, node.whenTrue, node.colonToken);
          var linesAfterColon = getLinesBetweenNodes(node, node.colonToken, node.whenFalse);
          emitExpression(node.condition, parenthesizer.parenthesizeConditionOfConditionalExpression);
          writeLinesAndIndent(linesBeforeQuestion, true);
          emit(node.questionToken);
          writeLinesAndIndent(linesAfterQuestion, true);
          emitExpression(node.whenTrue, parenthesizer.parenthesizeBranchOfConditionalExpression);
          decreaseIndentIf(linesBeforeQuestion, linesAfterQuestion);
          writeLinesAndIndent(linesBeforeColon, true);
          emit(node.colonToken);
          writeLinesAndIndent(linesAfterColon, true);
          emitExpression(node.whenFalse, parenthesizer.parenthesizeBranchOfConditionalExpression);
          decreaseIndentIf(linesBeforeColon, linesAfterColon);
        }
        function emitTemplateExpression(node) {
          emit(node.head);
          emitList(node, node.templateSpans, 262144);
        }
        function emitYieldExpression(node) {
          emitTokenWithComment(125, node.pos, writeKeyword, node);
          emit(node.asteriskToken);
          emitExpressionWithLeadingSpace(node.expression && parenthesizeExpressionForNoAsi(node.expression), parenthesizeExpressionForNoAsiAndDisallowedComma);
        }
        function emitSpreadElement(node) {
          emitTokenWithComment(25, node.pos, writePunctuation, node);
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitClassExpression(node) {
          generateNameIfNeeded(node.name);
          emitClassDeclarationOrExpression(node);
        }
        function emitExpressionWithTypeArguments(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitAsExpression(node) {
          emitExpression(node.expression, void 0);
          if (node.type) {
            writeSpace();
            writeKeyword("as");
            writeSpace();
            emit(node.type);
          }
        }
        function emitNonNullExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          writeOperator("!");
        }
        function emitMetaProperty(node) {
          writeToken(node.keywordToken, node.pos, writePunctuation);
          writePunctuation(".");
          emit(node.name);
        }
        function emitTemplateSpan(node) {
          emitExpression(node.expression);
          emit(node.literal);
        }
        function emitBlock(node) {
          emitBlockStatements(node, !node.multiLine && isEmptyBlock(node));
        }
        function emitBlockStatements(node, forceSingleLine) {
          emitTokenWithComment(18, node.pos, writePunctuation, node);
          var format = forceSingleLine || ts3.getEmitFlags(node) & 1 ? 768 : 129;
          emitList(node, node.statements, format);
          emitTokenWithComment(19, node.statements.end, writePunctuation, node, !!(format & 1));
        }
        function emitVariableStatement(node) {
          emitModifiers(node, node.modifiers);
          emit(node.declarationList);
          writeTrailingSemicolon();
        }
        function emitEmptyStatement(isEmbeddedStatement) {
          if (isEmbeddedStatement) {
            writePunctuation(";");
          } else {
            writeTrailingSemicolon();
          }
        }
        function emitExpressionStatement(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfExpressionStatement);
          if (!currentSourceFile || !ts3.isJsonSourceFile(currentSourceFile) || ts3.nodeIsSynthesized(node.expression)) {
            writeTrailingSemicolon();
          }
        }
        function emitIfStatement(node) {
          var openParenPos = emitTokenWithComment(99, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.thenStatement);
          if (node.elseStatement) {
            writeLineOrSpace(node, node.thenStatement, node.elseStatement);
            emitTokenWithComment(91, node.thenStatement.end, writeKeyword, node);
            if (node.elseStatement.kind === 239) {
              writeSpace();
              emit(node.elseStatement);
            } else {
              emitEmbeddedStatement(node, node.elseStatement);
            }
          }
        }
        function emitWhileClause(node, startPos) {
          var openParenPos = emitTokenWithComment(115, startPos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
        }
        function emitDoStatement(node) {
          emitTokenWithComment(90, node.pos, writeKeyword, node);
          emitEmbeddedStatement(node, node.statement);
          if (ts3.isBlock(node.statement) && !preserveSourceNewlines) {
            writeSpace();
          } else {
            writeLineOrSpace(node, node.statement, node.expression);
          }
          emitWhileClause(node, node.statement.end);
          writeTrailingSemicolon();
        }
        function emitWhileStatement(node) {
          emitWhileClause(node, node.pos);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForStatement(node) {
          var openParenPos = emitTokenWithComment(97, node.pos, writeKeyword, node);
          writeSpace();
          var pos = emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          pos = emitTokenWithComment(26, node.initializer ? node.initializer.end : pos, writePunctuation, node);
          emitExpressionWithLeadingSpace(node.condition);
          pos = emitTokenWithComment(26, node.condition ? node.condition.end : pos, writePunctuation, node);
          emitExpressionWithLeadingSpace(node.incrementor);
          emitTokenWithComment(21, node.incrementor ? node.incrementor.end : pos, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForInStatement(node) {
          var openParenPos = emitTokenWithComment(97, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          writeSpace();
          emitTokenWithComment(101, node.initializer.end, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForOfStatement(node) {
          var openParenPos = emitTokenWithComment(97, node.pos, writeKeyword, node);
          writeSpace();
          emitWithTrailingSpace(node.awaitModifier);
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          writeSpace();
          emitTokenWithComment(160, node.initializer.end, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForBinding(node) {
          if (node !== void 0) {
            if (node.kind === 255) {
              emit(node);
            } else {
              emitExpression(node);
            }
          }
        }
        function emitContinueStatement(node) {
          emitTokenWithComment(86, node.pos, writeKeyword, node);
          emitWithLeadingSpace(node.label);
          writeTrailingSemicolon();
        }
        function emitBreakStatement(node) {
          emitTokenWithComment(81, node.pos, writeKeyword, node);
          emitWithLeadingSpace(node.label);
          writeTrailingSemicolon();
        }
        function emitTokenWithComment(token, pos, writer2, contextNode, indentLeading) {
          var node = ts3.getParseTreeNode(contextNode);
          var isSimilarNode = node && node.kind === contextNode.kind;
          var startPos = pos;
          if (isSimilarNode && currentSourceFile) {
            pos = ts3.skipTrivia(currentSourceFile.text, pos);
          }
          if (isSimilarNode && contextNode.pos !== startPos) {
            var needsIndent = indentLeading && currentSourceFile && !ts3.positionsAreOnSameLine(startPos, pos, currentSourceFile);
            if (needsIndent) {
              increaseIndent();
            }
            emitLeadingCommentsOfPosition(startPos);
            if (needsIndent) {
              decreaseIndent();
            }
          }
          pos = writeTokenText(token, writer2, pos);
          if (isSimilarNode && contextNode.end !== pos) {
            var isJsxExprContext = contextNode.kind === 288;
            emitTrailingCommentsOfPosition(pos, !isJsxExprContext, isJsxExprContext);
          }
          return pos;
        }
        function commentWillEmitNewLine(node) {
          return node.kind === 2 || !!node.hasTrailingNewLine;
        }
        function willEmitLeadingNewLine(node) {
          if (!currentSourceFile)
            return false;
          if (ts3.some(ts3.getLeadingCommentRanges(currentSourceFile.text, node.pos), commentWillEmitNewLine))
            return true;
          if (ts3.some(ts3.getSyntheticLeadingComments(node), commentWillEmitNewLine))
            return true;
          if (ts3.isPartiallyEmittedExpression(node)) {
            if (node.pos !== node.expression.pos) {
              if (ts3.some(ts3.getTrailingCommentRanges(currentSourceFile.text, node.expression.pos), commentWillEmitNewLine))
                return true;
            }
            return willEmitLeadingNewLine(node.expression);
          }
          return false;
        }
        function parenthesizeExpressionForNoAsi(node) {
          if (!commentsDisabled && ts3.isPartiallyEmittedExpression(node) && willEmitLeadingNewLine(node)) {
            var parseNode = ts3.getParseTreeNode(node);
            if (parseNode && ts3.isParenthesizedExpression(parseNode)) {
              var parens = ts3.factory.createParenthesizedExpression(node.expression);
              ts3.setOriginalNode(parens, node);
              ts3.setTextRange(parens, parseNode);
              return parens;
            }
            return ts3.factory.createParenthesizedExpression(node);
          }
          return node;
        }
        function parenthesizeExpressionForNoAsiAndDisallowedComma(node) {
          return parenthesizeExpressionForNoAsi(parenthesizer.parenthesizeExpressionForDisallowedComma(node));
        }
        function emitReturnStatement(node) {
          emitTokenWithComment(105, node.pos, writeKeyword, node);
          emitExpressionWithLeadingSpace(node.expression && parenthesizeExpressionForNoAsi(node.expression), parenthesizeExpressionForNoAsi);
          writeTrailingSemicolon();
        }
        function emitWithStatement(node) {
          var openParenPos = emitTokenWithComment(116, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitSwitchStatement(node) {
          var openParenPos = emitTokenWithComment(107, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          writeSpace();
          emit(node.caseBlock);
        }
        function emitLabeledStatement(node) {
          emit(node.label);
          emitTokenWithComment(58, node.label.end, writePunctuation, node);
          writeSpace();
          emit(node.statement);
        }
        function emitThrowStatement(node) {
          emitTokenWithComment(109, node.pos, writeKeyword, node);
          emitExpressionWithLeadingSpace(parenthesizeExpressionForNoAsi(node.expression), parenthesizeExpressionForNoAsi);
          writeTrailingSemicolon();
        }
        function emitTryStatement(node) {
          emitTokenWithComment(111, node.pos, writeKeyword, node);
          writeSpace();
          emit(node.tryBlock);
          if (node.catchClause) {
            writeLineOrSpace(node, node.tryBlock, node.catchClause);
            emit(node.catchClause);
          }
          if (node.finallyBlock) {
            writeLineOrSpace(node, node.catchClause || node.tryBlock, node.finallyBlock);
            emitTokenWithComment(96, (node.catchClause || node.tryBlock).end, writeKeyword, node);
            writeSpace();
            emit(node.finallyBlock);
          }
        }
        function emitDebuggerStatement(node) {
          writeToken(87, node.pos, writeKeyword);
          writeTrailingSemicolon();
        }
        function emitVariableDeclaration(node) {
          var _a2, _b2, _c2, _d, _e;
          emit(node.name);
          emit(node.exclamationToken);
          emitTypeAnnotation(node.type);
          emitInitializer(node.initializer, (_e = (_b2 = (_a2 = node.type) === null || _a2 === void 0 ? void 0 : _a2.end) !== null && _b2 !== void 0 ? _b2 : (_d = (_c2 = node.name.emitNode) === null || _c2 === void 0 ? void 0 : _c2.typeNode) === null || _d === void 0 ? void 0 : _d.end) !== null && _e !== void 0 ? _e : node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitVariableDeclarationList(node) {
          writeKeyword(ts3.isLet(node) ? "let" : ts3.isVarConst(node) ? "const" : "var");
          writeSpace();
          emitList(node, node.declarations, 528);
        }
        function emitFunctionDeclaration(node) {
          emitFunctionDeclarationOrExpression(node);
        }
        function emitFunctionDeclarationOrExpression(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("function");
          emit(node.asteriskToken);
          writeSpace();
          emitIdentifierName(node.name);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitSignatureAndBody(node, emitSignatureHead2) {
          var body = node.body;
          if (body) {
            if (ts3.isBlock(body)) {
              var indentedFlag = ts3.getEmitFlags(node) & 65536;
              if (indentedFlag) {
                increaseIndent();
              }
              pushNameGenerationScope(node);
              ts3.forEach(node.parameters, generateNames);
              generateNames(node.body);
              emitSignatureHead2(node);
              emitBlockFunctionBody(body);
              popNameGenerationScope(node);
              if (indentedFlag) {
                decreaseIndent();
              }
            } else {
              emitSignatureHead2(node);
              writeSpace();
              emitExpression(body, parenthesizer.parenthesizeConciseBodyOfArrowFunction);
            }
          } else {
            emitSignatureHead2(node);
            writeTrailingSemicolon();
          }
        }
        function emitSignatureHead(node) {
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
        }
        function shouldEmitBlockFunctionBodyOnSingleLine(body) {
          if (ts3.getEmitFlags(body) & 1) {
            return true;
          }
          if (body.multiLine) {
            return false;
          }
          if (!ts3.nodeIsSynthesized(body) && currentSourceFile && !ts3.rangeIsOnSingleLine(body, currentSourceFile)) {
            return false;
          }
          if (getLeadingLineTerminatorCount(body, body.statements, 2) || getClosingLineTerminatorCount(body, body.statements, 2)) {
            return false;
          }
          var previousStatement;
          for (var _a2 = 0, _b2 = body.statements; _a2 < _b2.length; _a2++) {
            var statement = _b2[_a2];
            if (getSeparatingLineTerminatorCount(previousStatement, statement, 2) > 0) {
              return false;
            }
            previousStatement = statement;
          }
          return true;
        }
        function emitBlockFunctionBody(body) {
          onBeforeEmitNode === null || onBeforeEmitNode === void 0 ? void 0 : onBeforeEmitNode(body);
          writeSpace();
          writePunctuation("{");
          increaseIndent();
          var emitBlockFunctionBody2 = shouldEmitBlockFunctionBodyOnSingleLine(body) ? emitBlockFunctionBodyOnSingleLine : emitBlockFunctionBodyWorker;
          emitBodyWithDetachedComments(body, body.statements, emitBlockFunctionBody2);
          decreaseIndent();
          writeToken(19, body.statements.end, writePunctuation, body);
          onAfterEmitNode === null || onAfterEmitNode === void 0 ? void 0 : onAfterEmitNode(body);
        }
        function emitBlockFunctionBodyOnSingleLine(body) {
          emitBlockFunctionBodyWorker(body, true);
        }
        function emitBlockFunctionBodyWorker(body, emitBlockFunctionBodyOnSingleLine2) {
          var statementOffset = emitPrologueDirectives(body.statements);
          var pos = writer.getTextPos();
          emitHelpers(body);
          if (statementOffset === 0 && pos === writer.getTextPos() && emitBlockFunctionBodyOnSingleLine2) {
            decreaseIndent();
            emitList(body, body.statements, 768);
            increaseIndent();
          } else {
            emitList(body, body.statements, 1, void 0, statementOffset);
          }
        }
        function emitClassDeclaration(node) {
          emitClassDeclarationOrExpression(node);
        }
        function emitClassDeclarationOrExpression(node) {
          ts3.forEach(node.members, generateMemberNames);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("class");
          if (node.name) {
            writeSpace();
            emitIdentifierName(node.name);
          }
          var indentedFlag = ts3.getEmitFlags(node) & 65536;
          if (indentedFlag) {
            increaseIndent();
          }
          emitTypeParameters(node, node.typeParameters);
          emitList(node, node.heritageClauses, 0);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 129);
          writePunctuation("}");
          if (indentedFlag) {
            decreaseIndent();
          }
        }
        function emitInterfaceDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("interface");
          writeSpace();
          emit(node.name);
          emitTypeParameters(node, node.typeParameters);
          emitList(node, node.heritageClauses, 512);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 129);
          writePunctuation("}");
        }
        function emitTypeAliasDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("type");
          writeSpace();
          emit(node.name);
          emitTypeParameters(node, node.typeParameters);
          writeSpace();
          writePunctuation("=");
          writeSpace();
          emit(node.type);
          writeTrailingSemicolon();
        }
        function emitEnumDeclaration(node) {
          emitModifiers(node, node.modifiers);
          writeKeyword("enum");
          writeSpace();
          emit(node.name);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 145);
          writePunctuation("}");
        }
        function emitModuleDeclaration(node) {
          emitModifiers(node, node.modifiers);
          if (~node.flags & 1024) {
            writeKeyword(node.flags & 16 ? "namespace" : "module");
            writeSpace();
          }
          emit(node.name);
          var body = node.body;
          if (!body)
            return writeTrailingSemicolon();
          while (body && ts3.isModuleDeclaration(body)) {
            writePunctuation(".");
            emit(body.name);
            body = body.body;
          }
          writeSpace();
          emit(body);
        }
        function emitModuleBlock(node) {
          pushNameGenerationScope(node);
          ts3.forEach(node.statements, generateNames);
          emitBlockStatements(node, isEmptyBlock(node));
          popNameGenerationScope(node);
        }
        function emitCaseBlock(node) {
          emitTokenWithComment(18, node.pos, writePunctuation, node);
          emitList(node, node.clauses, 129);
          emitTokenWithComment(19, node.clauses.end, writePunctuation, node, true);
        }
        function emitImportEqualsDeclaration(node) {
          emitModifiers(node, node.modifiers);
          emitTokenWithComment(100, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
          writeSpace();
          if (node.isTypeOnly) {
            emitTokenWithComment(152, node.pos, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
          writeSpace();
          emitTokenWithComment(63, node.name.end, writePunctuation, node);
          writeSpace();
          emitModuleReference(node.moduleReference);
          writeTrailingSemicolon();
        }
        function emitModuleReference(node) {
          if (node.kind === 79) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitImportDeclaration(node) {
          emitModifiers(node, node.modifiers);
          emitTokenWithComment(100, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
          writeSpace();
          if (node.importClause) {
            emit(node.importClause);
            writeSpace();
            emitTokenWithComment(156, node.importClause.end, writeKeyword, node);
            writeSpace();
          }
          emitExpression(node.moduleSpecifier);
          if (node.assertClause) {
            emitWithLeadingSpace(node.assertClause);
          }
          writeTrailingSemicolon();
        }
        function emitImportClause(node) {
          if (node.isTypeOnly) {
            emitTokenWithComment(152, node.pos, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
          if (node.name && node.namedBindings) {
            emitTokenWithComment(27, node.name.end, writePunctuation, node);
            writeSpace();
          }
          emit(node.namedBindings);
        }
        function emitNamespaceImport(node) {
          var asPos = emitTokenWithComment(41, node.pos, writePunctuation, node);
          writeSpace();
          emitTokenWithComment(127, asPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
        }
        function emitNamedImports(node) {
          emitNamedImportsOrExports(node);
        }
        function emitImportSpecifier(node) {
          emitImportOrExportSpecifier(node);
        }
        function emitExportAssignment(node) {
          var nextPos = emitTokenWithComment(93, node.pos, writeKeyword, node);
          writeSpace();
          if (node.isExportEquals) {
            emitTokenWithComment(63, nextPos, writeOperator, node);
          } else {
            emitTokenWithComment(88, nextPos, writeKeyword, node);
          }
          writeSpace();
          emitExpression(node.expression, node.isExportEquals ? parenthesizer.getParenthesizeRightSideOfBinaryForOperator(63) : parenthesizer.parenthesizeExpressionOfExportDefault);
          writeTrailingSemicolon();
        }
        function emitExportDeclaration(node) {
          var nextPos = emitTokenWithComment(93, node.pos, writeKeyword, node);
          writeSpace();
          if (node.isTypeOnly) {
            nextPos = emitTokenWithComment(152, nextPos, writeKeyword, node);
            writeSpace();
          }
          if (node.exportClause) {
            emit(node.exportClause);
          } else {
            nextPos = emitTokenWithComment(41, nextPos, writePunctuation, node);
          }
          if (node.moduleSpecifier) {
            writeSpace();
            var fromPos = node.exportClause ? node.exportClause.end : nextPos;
            emitTokenWithComment(156, fromPos, writeKeyword, node);
            writeSpace();
            emitExpression(node.moduleSpecifier);
          }
          if (node.assertClause) {
            emitWithLeadingSpace(node.assertClause);
          }
          writeTrailingSemicolon();
        }
        function emitAssertClause(node) {
          emitTokenWithComment(129, node.pos, writeKeyword, node);
          writeSpace();
          var elements = node.elements;
          emitList(node, elements, 526226);
        }
        function emitAssertEntry(node) {
          emit(node.name);
          writePunctuation(":");
          writeSpace();
          var value = node.value;
          if ((ts3.getEmitFlags(value) & 512) === 0) {
            var commentRange = ts3.getCommentRange(value);
            emitTrailingCommentsOfPosition(commentRange.pos);
          }
          emit(value);
        }
        function emitNamespaceExportDeclaration(node) {
          var nextPos = emitTokenWithComment(93, node.pos, writeKeyword, node);
          writeSpace();
          nextPos = emitTokenWithComment(127, nextPos, writeKeyword, node);
          writeSpace();
          nextPos = emitTokenWithComment(142, nextPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
          writeTrailingSemicolon();
        }
        function emitNamespaceExport(node) {
          var asPos = emitTokenWithComment(41, node.pos, writePunctuation, node);
          writeSpace();
          emitTokenWithComment(127, asPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
        }
        function emitNamedExports(node) {
          emitNamedImportsOrExports(node);
        }
        function emitExportSpecifier(node) {
          emitImportOrExportSpecifier(node);
        }
        function emitNamedImportsOrExports(node) {
          writePunctuation("{");
          emitList(node, node.elements, 525136);
          writePunctuation("}");
        }
        function emitImportOrExportSpecifier(node) {
          if (node.isTypeOnly) {
            writeKeyword("type");
            writeSpace();
          }
          if (node.propertyName) {
            emit(node.propertyName);
            writeSpace();
            emitTokenWithComment(127, node.propertyName.end, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
        }
        function emitExternalModuleReference(node) {
          writeKeyword("require");
          writePunctuation("(");
          emitExpression(node.expression);
          writePunctuation(")");
        }
        function emitJsxElement(node) {
          emit(node.openingElement);
          emitList(node, node.children, 262144);
          emit(node.closingElement);
        }
        function emitJsxSelfClosingElement(node) {
          writePunctuation("<");
          emitJsxTagName(node.tagName);
          emitTypeArguments(node, node.typeArguments);
          writeSpace();
          emit(node.attributes);
          writePunctuation("/>");
        }
        function emitJsxFragment(node) {
          emit(node.openingFragment);
          emitList(node, node.children, 262144);
          emit(node.closingFragment);
        }
        function emitJsxOpeningElementOrFragment(node) {
          writePunctuation("<");
          if (ts3.isJsxOpeningElement(node)) {
            var indented = writeLineSeparatorsAndIndentBefore(node.tagName, node);
            emitJsxTagName(node.tagName);
            emitTypeArguments(node, node.typeArguments);
            if (node.attributes.properties && node.attributes.properties.length > 0) {
              writeSpace();
            }
            emit(node.attributes);
            writeLineSeparatorsAfter(node.attributes, node);
            decreaseIndentIf(indented);
          }
          writePunctuation(">");
        }
        function emitJsxText(node) {
          writer.writeLiteral(node.text);
        }
        function emitJsxClosingElementOrFragment(node) {
          writePunctuation("</");
          if (ts3.isJsxClosingElement(node)) {
            emitJsxTagName(node.tagName);
          }
          writePunctuation(">");
        }
        function emitJsxAttributes(node) {
          emitList(node, node.properties, 262656);
        }
        function emitJsxAttribute(node) {
          emit(node.name);
          emitNodeWithPrefix("=", writePunctuation, node.initializer, emitJsxAttributeValue);
        }
        function emitJsxSpreadAttribute(node) {
          writePunctuation("{...");
          emitExpression(node.expression);
          writePunctuation("}");
        }
        function hasTrailingCommentsAtPosition(pos) {
          var result2 = false;
          ts3.forEachTrailingCommentRange((currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.text) || "", pos + 1, function() {
            return result2 = true;
          });
          return result2;
        }
        function hasLeadingCommentsAtPosition(pos) {
          var result2 = false;
          ts3.forEachLeadingCommentRange((currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.text) || "", pos + 1, function() {
            return result2 = true;
          });
          return result2;
        }
        function hasCommentsAtPosition(pos) {
          return hasTrailingCommentsAtPosition(pos) || hasLeadingCommentsAtPosition(pos);
        }
        function emitJsxExpression(node) {
          var _a2;
          if (node.expression || !commentsDisabled && !ts3.nodeIsSynthesized(node) && hasCommentsAtPosition(node.pos)) {
            var isMultiline = currentSourceFile && !ts3.nodeIsSynthesized(node) && ts3.getLineAndCharacterOfPosition(currentSourceFile, node.pos).line !== ts3.getLineAndCharacterOfPosition(currentSourceFile, node.end).line;
            if (isMultiline) {
              writer.increaseIndent();
            }
            var end = emitTokenWithComment(18, node.pos, writePunctuation, node);
            emit(node.dotDotDotToken);
            emitExpression(node.expression);
            emitTokenWithComment(19, ((_a2 = node.expression) === null || _a2 === void 0 ? void 0 : _a2.end) || end, writePunctuation, node);
            if (isMultiline) {
              writer.decreaseIndent();
            }
          }
        }
        function emitJsxTagName(node) {
          if (node.kind === 79) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitCaseClause(node) {
          emitTokenWithComment(82, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
          emitCaseOrDefaultClauseRest(node, node.statements, node.expression.end);
        }
        function emitDefaultClause(node) {
          var pos = emitTokenWithComment(88, node.pos, writeKeyword, node);
          emitCaseOrDefaultClauseRest(node, node.statements, pos);
        }
        function emitCaseOrDefaultClauseRest(parentNode, statements, colonPos) {
          var emitAsSingleStatement = statements.length === 1 && (!currentSourceFile || ts3.nodeIsSynthesized(parentNode) || ts3.nodeIsSynthesized(statements[0]) || ts3.rangeStartPositionsAreOnSameLine(parentNode, statements[0], currentSourceFile));
          var format = 163969;
          if (emitAsSingleStatement) {
            writeToken(58, colonPos, writePunctuation, parentNode);
            writeSpace();
            format &= ~(1 | 128);
          } else {
            emitTokenWithComment(58, colonPos, writePunctuation, parentNode);
          }
          emitList(parentNode, statements, format);
        }
        function emitHeritageClause(node) {
          writeSpace();
          writeTokenText(node.token, writeKeyword);
          writeSpace();
          emitList(node, node.types, 528);
        }
        function emitCatchClause(node) {
          var openParenPos = emitTokenWithComment(83, node.pos, writeKeyword, node);
          writeSpace();
          if (node.variableDeclaration) {
            emitTokenWithComment(20, openParenPos, writePunctuation, node);
            emit(node.variableDeclaration);
            emitTokenWithComment(21, node.variableDeclaration.end, writePunctuation, node);
            writeSpace();
          }
          emit(node.block);
        }
        function emitPropertyAssignment(node) {
          emit(node.name);
          writePunctuation(":");
          writeSpace();
          var initializer = node.initializer;
          if ((ts3.getEmitFlags(initializer) & 512) === 0) {
            var commentRange = ts3.getCommentRange(initializer);
            emitTrailingCommentsOfPosition(commentRange.pos);
          }
          emitExpression(initializer, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitShorthandPropertyAssignment(node) {
          emit(node.name);
          if (node.objectAssignmentInitializer) {
            writeSpace();
            writePunctuation("=");
            writeSpace();
            emitExpression(node.objectAssignmentInitializer, parenthesizer.parenthesizeExpressionForDisallowedComma);
          }
        }
        function emitSpreadAssignment(node) {
          if (node.expression) {
            emitTokenWithComment(25, node.pos, writePunctuation, node);
            emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
          }
        }
        function emitEnumMember(node) {
          emit(node.name);
          emitInitializer(node.initializer, node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitJSDoc(node) {
          write("/**");
          if (node.comment) {
            var text = ts3.getTextOfJSDocComment(node.comment);
            if (text) {
              var lines = text.split(/\r\n?|\n/g);
              for (var _a2 = 0, lines_2 = lines; _a2 < lines_2.length; _a2++) {
                var line = lines_2[_a2];
                writeLine();
                writeSpace();
                writePunctuation("*");
                writeSpace();
                write(line);
              }
            }
          }
          if (node.tags) {
            if (node.tags.length === 1 && node.tags[0].kind === 343 && !node.comment) {
              writeSpace();
              emit(node.tags[0]);
            } else {
              emitList(node, node.tags, 33);
            }
          }
          writeSpace();
          write("*/");
        }
        function emitJSDocSimpleTypedTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocTypeExpression(tag.typeExpression);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocSeeTag(tag) {
          emitJSDocTagName(tag.tagName);
          emit(tag.name);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocNameReference(node) {
          writeSpace();
          writePunctuation("{");
          emit(node.name);
          writePunctuation("}");
        }
        function emitJSDocHeritageTag(tag) {
          emitJSDocTagName(tag.tagName);
          writeSpace();
          writePunctuation("{");
          emit(tag.class);
          writePunctuation("}");
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTemplateTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocTypeExpression(tag.constraint);
          writeSpace();
          emitList(tag, tag.typeParameters, 528);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTypedefTag(tag) {
          emitJSDocTagName(tag.tagName);
          if (tag.typeExpression) {
            if (tag.typeExpression.kind === 309) {
              emitJSDocTypeExpression(tag.typeExpression);
            } else {
              writeSpace();
              writePunctuation("{");
              write("Object");
              if (tag.typeExpression.isArrayType) {
                writePunctuation("[");
                writePunctuation("]");
              }
              writePunctuation("}");
            }
          }
          if (tag.fullName) {
            writeSpace();
            emit(tag.fullName);
          }
          emitJSDocComment(tag.comment);
          if (tag.typeExpression && tag.typeExpression.kind === 322) {
            emitJSDocTypeLiteral(tag.typeExpression);
          }
        }
        function emitJSDocCallbackTag(tag) {
          emitJSDocTagName(tag.tagName);
          if (tag.name) {
            writeSpace();
            emit(tag.name);
          }
          emitJSDocComment(tag.comment);
          emitJSDocSignature(tag.typeExpression);
        }
        function emitJSDocSimpleTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTypeLiteral(lit) {
          emitList(lit, ts3.factory.createNodeArray(lit.jsDocPropertyTags), 33);
        }
        function emitJSDocSignature(sig) {
          if (sig.typeParameters) {
            emitList(sig, ts3.factory.createNodeArray(sig.typeParameters), 33);
          }
          if (sig.parameters) {
            emitList(sig, ts3.factory.createNodeArray(sig.parameters), 33);
          }
          if (sig.type) {
            writeLine();
            writeSpace();
            writePunctuation("*");
            writeSpace();
            emit(sig.type);
          }
        }
        function emitJSDocPropertyLikeTag(param) {
          emitJSDocTagName(param.tagName);
          emitJSDocTypeExpression(param.typeExpression);
          writeSpace();
          if (param.isBracketed) {
            writePunctuation("[");
          }
          emit(param.name);
          if (param.isBracketed) {
            writePunctuation("]");
          }
          emitJSDocComment(param.comment);
        }
        function emitJSDocTagName(tagName) {
          writePunctuation("@");
          emit(tagName);
        }
        function emitJSDocComment(comment) {
          var text = ts3.getTextOfJSDocComment(comment);
          if (text) {
            writeSpace();
            write(text);
          }
        }
        function emitJSDocTypeExpression(typeExpression) {
          if (typeExpression) {
            writeSpace();
            writePunctuation("{");
            emit(typeExpression.type);
            writePunctuation("}");
          }
        }
        function emitSourceFile(node) {
          writeLine();
          var statements = node.statements;
          var shouldEmitDetachedComment = statements.length === 0 || !ts3.isPrologueDirective(statements[0]) || ts3.nodeIsSynthesized(statements[0]);
          if (shouldEmitDetachedComment) {
            emitBodyWithDetachedComments(node, statements, emitSourceFileWorker);
            return;
          }
          emitSourceFileWorker(node);
        }
        function emitSyntheticTripleSlashReferencesIfNeeded(node) {
          emitTripleSlashDirectives(!!node.hasNoDefaultLib, node.syntheticFileReferences || [], node.syntheticTypeReferences || [], node.syntheticLibReferences || []);
          for (var _a2 = 0, _b2 = node.prepends; _a2 < _b2.length; _a2++) {
            var prepend = _b2[_a2];
            if (ts3.isUnparsedSource(prepend) && prepend.syntheticReferences) {
              for (var _c2 = 0, _d = prepend.syntheticReferences; _c2 < _d.length; _c2++) {
                var ref = _d[_c2];
                emit(ref);
                writeLine();
              }
            }
          }
        }
        function emitTripleSlashDirectivesIfNeeded(node) {
          if (node.isDeclarationFile)
            emitTripleSlashDirectives(node.hasNoDefaultLib, node.referencedFiles, node.typeReferenceDirectives, node.libReferenceDirectives);
        }
        function emitTripleSlashDirectives(hasNoDefaultLib, files, types2, libs) {
          if (hasNoDefaultLib) {
            var pos = writer.getTextPos();
            writeComment('/// <reference no-default-lib="true"/>');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "no-default-lib" });
            writeLine();
          }
          if (currentSourceFile && currentSourceFile.moduleName) {
            writeComment('/// <amd-module name="'.concat(currentSourceFile.moduleName, '" />'));
            writeLine();
          }
          if (currentSourceFile && currentSourceFile.amdDependencies) {
            for (var _a2 = 0, _b2 = currentSourceFile.amdDependencies; _a2 < _b2.length; _a2++) {
              var dep = _b2[_a2];
              if (dep.name) {
                writeComment('/// <amd-dependency name="'.concat(dep.name, '" path="').concat(dep.path, '" />'));
              } else {
                writeComment('/// <amd-dependency path="'.concat(dep.path, '" />'));
              }
              writeLine();
            }
          }
          for (var _c2 = 0, files_2 = files; _c2 < files_2.length; _c2++) {
            var directive = files_2[_c2];
            var pos = writer.getTextPos();
            writeComment('/// <reference path="'.concat(directive.fileName, '" />'));
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "reference", data: directive.fileName });
            writeLine();
          }
          for (var _d = 0, types_24 = types2; _d < types_24.length; _d++) {
            var directive = types_24[_d];
            var pos = writer.getTextPos();
            var resolutionMode = directive.resolutionMode && directive.resolutionMode !== (currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.impliedNodeFormat) ? 'resolution-mode="'.concat(directive.resolutionMode === ts3.ModuleKind.ESNext ? "import" : "require", '"') : "";
            writeComment('/// <reference types="'.concat(directive.fileName, '" ').concat(resolutionMode, "/>"));
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: !directive.resolutionMode ? "type" : directive.resolutionMode === ts3.ModuleKind.ESNext ? "type-import" : "type-require", data: directive.fileName });
            writeLine();
          }
          for (var _e = 0, libs_1 = libs; _e < libs_1.length; _e++) {
            var directive = libs_1[_e];
            var pos = writer.getTextPos();
            writeComment('/// <reference lib="'.concat(directive.fileName, '" />'));
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "lib", data: directive.fileName });
            writeLine();
          }
        }
        function emitSourceFileWorker(node) {
          var statements = node.statements;
          pushNameGenerationScope(node);
          ts3.forEach(node.statements, generateNames);
          emitHelpers(node);
          var index = ts3.findIndex(statements, function(statement) {
            return !ts3.isPrologueDirective(statement);
          });
          emitTripleSlashDirectivesIfNeeded(node);
          emitList(node, statements, 1, void 0, index === -1 ? statements.length : index);
          popNameGenerationScope(node);
        }
        function emitPartiallyEmittedExpression(node) {
          var emitFlags = ts3.getEmitFlags(node);
          if (!(emitFlags & 512) && node.pos !== node.expression.pos) {
            emitTrailingCommentsOfPosition(node.expression.pos);
          }
          emitExpression(node.expression);
          if (!(emitFlags & 1024) && node.end !== node.expression.end) {
            emitLeadingCommentsOfPosition(node.expression.end);
          }
        }
        function emitCommaList(node) {
          emitExpressionList(node, node.elements, 528, void 0);
        }
        function emitPrologueDirectives(statements, sourceFile, seenPrologueDirectives, recordBundleFileSection) {
          var needsToSetSourceFile = !!sourceFile;
          for (var i = 0; i < statements.length; i++) {
            var statement = statements[i];
            if (ts3.isPrologueDirective(statement)) {
              var shouldEmitPrologueDirective = seenPrologueDirectives ? !seenPrologueDirectives.has(statement.expression.text) : true;
              if (shouldEmitPrologueDirective) {
                if (needsToSetSourceFile) {
                  needsToSetSourceFile = false;
                  setSourceFile(sourceFile);
                }
                writeLine();
                var pos = writer.getTextPos();
                emit(statement);
                if (recordBundleFileSection && bundleFileInfo)
                  bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue", data: statement.expression.text });
                if (seenPrologueDirectives) {
                  seenPrologueDirectives.add(statement.expression.text);
                }
              }
            } else {
              return i;
            }
          }
          return statements.length;
        }
        function emitUnparsedPrologues(prologues, seenPrologueDirectives) {
          for (var _a2 = 0, prologues_1 = prologues; _a2 < prologues_1.length; _a2++) {
            var prologue = prologues_1[_a2];
            if (!seenPrologueDirectives.has(prologue.data)) {
              writeLine();
              var pos = writer.getTextPos();
              emit(prologue);
              if (bundleFileInfo)
                bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue", data: prologue.data });
              if (seenPrologueDirectives) {
                seenPrologueDirectives.add(prologue.data);
              }
            }
          }
        }
        function emitPrologueDirectivesIfNeeded(sourceFileOrBundle) {
          if (ts3.isSourceFile(sourceFileOrBundle)) {
            emitPrologueDirectives(sourceFileOrBundle.statements, sourceFileOrBundle);
          } else {
            var seenPrologueDirectives = new ts3.Set();
            for (var _a2 = 0, _b2 = sourceFileOrBundle.prepends; _a2 < _b2.length; _a2++) {
              var prepend = _b2[_a2];
              emitUnparsedPrologues(prepend.prologues, seenPrologueDirectives);
            }
            for (var _c2 = 0, _d = sourceFileOrBundle.sourceFiles; _c2 < _d.length; _c2++) {
              var sourceFile = _d[_c2];
              emitPrologueDirectives(sourceFile.statements, sourceFile, seenPrologueDirectives, true);
            }
            setSourceFile(void 0);
          }
        }
        function getPrologueDirectivesFromBundledSourceFiles(bundle) {
          var seenPrologueDirectives = new ts3.Set();
          var prologues;
          for (var index = 0; index < bundle.sourceFiles.length; index++) {
            var sourceFile = bundle.sourceFiles[index];
            var directives = void 0;
            var end = 0;
            for (var _a2 = 0, _b2 = sourceFile.statements; _a2 < _b2.length; _a2++) {
              var statement = _b2[_a2];
              if (!ts3.isPrologueDirective(statement))
                break;
              if (seenPrologueDirectives.has(statement.expression.text))
                continue;
              seenPrologueDirectives.add(statement.expression.text);
              (directives || (directives = [])).push({
                pos: statement.pos,
                end: statement.end,
                expression: {
                  pos: statement.expression.pos,
                  end: statement.expression.end,
                  text: statement.expression.text
                }
              });
              end = end < statement.end ? statement.end : end;
            }
            if (directives)
              (prologues || (prologues = [])).push({ file: index, text: sourceFile.text.substring(0, end), directives });
          }
          return prologues;
        }
        function emitShebangIfNeeded(sourceFileOrBundle) {
          if (ts3.isSourceFile(sourceFileOrBundle) || ts3.isUnparsedSource(sourceFileOrBundle)) {
            var shebang = ts3.getShebang(sourceFileOrBundle.text);
            if (shebang) {
              writeComment(shebang);
              writeLine();
              return true;
            }
          } else {
            for (var _a2 = 0, _b2 = sourceFileOrBundle.prepends; _a2 < _b2.length; _a2++) {
              var prepend = _b2[_a2];
              ts3.Debug.assertNode(prepend, ts3.isUnparsedSource);
              if (emitShebangIfNeeded(prepend)) {
                return true;
              }
            }
            for (var _c2 = 0, _d = sourceFileOrBundle.sourceFiles; _c2 < _d.length; _c2++) {
              var sourceFile = _d[_c2];
              if (emitShebangIfNeeded(sourceFile)) {
                return true;
              }
            }
          }
        }
        function emitNodeWithWriter(node, writer2) {
          if (!node)
            return;
          var savedWrite = write;
          write = writer2;
          emit(node);
          write = savedWrite;
        }
        function emitModifiers(node, modifiers) {
          if (modifiers && modifiers.length) {
            emitList(node, modifiers, 262656);
            writeSpace();
          }
        }
        function emitTypeAnnotation(node) {
          if (node) {
            writePunctuation(":");
            writeSpace();
            emit(node);
          }
        }
        function emitInitializer(node, equalCommentStartPos, container, parenthesizerRule) {
          if (node) {
            writeSpace();
            emitTokenWithComment(63, equalCommentStartPos, writeOperator, container);
            writeSpace();
            emitExpression(node, parenthesizerRule);
          }
        }
        function emitNodeWithPrefix(prefix, prefixWriter, node, emit2) {
          if (node) {
            prefixWriter(prefix);
            emit2(node);
          }
        }
        function emitWithLeadingSpace(node) {
          if (node) {
            writeSpace();
            emit(node);
          }
        }
        function emitExpressionWithLeadingSpace(node, parenthesizerRule) {
          if (node) {
            writeSpace();
            emitExpression(node, parenthesizerRule);
          }
        }
        function emitWithTrailingSpace(node) {
          if (node) {
            emit(node);
            writeSpace();
          }
        }
        function emitEmbeddedStatement(parent, node) {
          if (ts3.isBlock(node) || ts3.getEmitFlags(parent) & 1) {
            writeSpace();
            emit(node);
          } else {
            writeLine();
            increaseIndent();
            if (ts3.isEmptyStatement(node)) {
              pipelineEmit(5, node);
            } else {
              emit(node);
            }
            decreaseIndent();
          }
        }
        function emitDecorators(parentNode, decorators) {
          emitList(parentNode, decorators, 2146305);
        }
        function emitTypeArguments(parentNode, typeArguments) {
          emitList(parentNode, typeArguments, 53776, typeArgumentParenthesizerRuleSelector);
        }
        function emitTypeParameters(parentNode, typeParameters) {
          if (ts3.isFunctionLike(parentNode) && parentNode.typeArguments) {
            return emitTypeArguments(parentNode, parentNode.typeArguments);
          }
          emitList(parentNode, typeParameters, 53776);
        }
        function emitParameters(parentNode, parameters) {
          emitList(parentNode, parameters, 2576);
        }
        function canEmitSimpleArrowHead(parentNode, parameters) {
          var parameter = ts3.singleOrUndefined(parameters);
          return parameter && parameter.pos === parentNode.pos && ts3.isArrowFunction(parentNode) && !parentNode.type && !ts3.some(parentNode.decorators) && !ts3.some(parentNode.modifiers) && !ts3.some(parentNode.typeParameters) && !ts3.some(parameter.decorators) && !ts3.some(parameter.modifiers) && !parameter.dotDotDotToken && !parameter.questionToken && !parameter.type && !parameter.initializer && ts3.isIdentifier(parameter.name);
        }
        function emitParametersForArrow(parentNode, parameters) {
          if (canEmitSimpleArrowHead(parentNode, parameters)) {
            emitList(parentNode, parameters, 2576 & ~2048);
          } else {
            emitParameters(parentNode, parameters);
          }
        }
        function emitParametersForIndexSignature(parentNode, parameters) {
          emitList(parentNode, parameters, 8848);
        }
        function writeDelimiter(format) {
          switch (format & 60) {
            case 0:
              break;
            case 16:
              writePunctuation(",");
              break;
            case 4:
              writeSpace();
              writePunctuation("|");
              break;
            case 32:
              writeSpace();
              writePunctuation("*");
              writeSpace();
              break;
            case 8:
              writeSpace();
              writePunctuation("&");
              break;
          }
        }
        function emitList(parentNode, children, format, parenthesizerRule, start, count) {
          emitNodeList(emit, parentNode, children, format, parenthesizerRule, start, count);
        }
        function emitExpressionList(parentNode, children, format, parenthesizerRule, start, count) {
          emitNodeList(emitExpression, parentNode, children, format, parenthesizerRule, start, count);
        }
        function emitNodeList(emit2, parentNode, children, format, parenthesizerRule, start, count) {
          if (start === void 0) {
            start = 0;
          }
          if (count === void 0) {
            count = children ? children.length - start : 0;
          }
          var isUndefined = children === void 0;
          if (isUndefined && format & 16384) {
            return;
          }
          var isEmpty = children === void 0 || start >= children.length || count === 0;
          if (isEmpty && format & 32768) {
            if (onBeforeEmitNodeArray) {
              onBeforeEmitNodeArray(children);
            }
            if (onAfterEmitNodeArray) {
              onAfterEmitNodeArray(children);
            }
            return;
          }
          if (format & 15360) {
            writePunctuation(getOpeningBracket(format));
            if (isEmpty && children) {
              emitTrailingCommentsOfPosition(children.pos, true);
            }
          }
          if (onBeforeEmitNodeArray) {
            onBeforeEmitNodeArray(children);
          }
          if (isEmpty) {
            if (format & 1 && !(preserveSourceNewlines && (!parentNode || currentSourceFile && ts3.rangeIsOnSingleLine(parentNode, currentSourceFile)))) {
              writeLine();
            } else if (format & 256 && !(format & 524288)) {
              writeSpace();
            }
          } else {
            ts3.Debug.type(children);
            var mayEmitInterveningComments = (format & 262144) === 0;
            var shouldEmitInterveningComments = mayEmitInterveningComments;
            var leadingLineTerminatorCount = getLeadingLineTerminatorCount(parentNode, children, format);
            if (leadingLineTerminatorCount) {
              writeLine(leadingLineTerminatorCount);
              shouldEmitInterveningComments = false;
            } else if (format & 256) {
              writeSpace();
            }
            if (format & 128) {
              increaseIndent();
            }
            var emitListItem = getEmitListItem(emit2, parenthesizerRule);
            var previousSibling = void 0;
            var previousSourceFileTextKind = void 0;
            var shouldDecreaseIndentAfterEmit = false;
            for (var i = 0; i < count; i++) {
              var child = children[start + i];
              if (format & 32) {
                writeLine();
                writeDelimiter(format);
              } else if (previousSibling) {
                if (format & 60 && previousSibling.end !== (parentNode ? parentNode.end : -1)) {
                  emitLeadingCommentsOfPosition(previousSibling.end);
                }
                writeDelimiter(format);
                recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
                var separatingLineTerminatorCount = getSeparatingLineTerminatorCount(previousSibling, child, format);
                if (separatingLineTerminatorCount > 0) {
                  if ((format & (3 | 128)) === 0) {
                    increaseIndent();
                    shouldDecreaseIndentAfterEmit = true;
                  }
                  writeLine(separatingLineTerminatorCount);
                  shouldEmitInterveningComments = false;
                } else if (previousSibling && format & 512) {
                  writeSpace();
                }
              }
              previousSourceFileTextKind = recordBundleFileInternalSectionStart(child);
              if (shouldEmitInterveningComments) {
                var commentRange = ts3.getCommentRange(child);
                emitTrailingCommentsOfPosition(commentRange.pos);
              } else {
                shouldEmitInterveningComments = mayEmitInterveningComments;
              }
              nextListElementPos = child.pos;
              emitListItem(child, emit2, parenthesizerRule, i);
              if (shouldDecreaseIndentAfterEmit) {
                decreaseIndent();
                shouldDecreaseIndentAfterEmit = false;
              }
              previousSibling = child;
            }
            var emitFlags = previousSibling ? ts3.getEmitFlags(previousSibling) : 0;
            var skipTrailingComments = commentsDisabled || !!(emitFlags & 1024);
            var hasTrailingComma = (children === null || children === void 0 ? void 0 : children.hasTrailingComma) && format & 64 && format & 16;
            if (hasTrailingComma) {
              if (previousSibling && !skipTrailingComments) {
                emitTokenWithComment(27, previousSibling.end, writePunctuation, previousSibling);
              } else {
                writePunctuation(",");
              }
            }
            if (previousSibling && (parentNode ? parentNode.end : -1) !== previousSibling.end && format & 60 && !skipTrailingComments) {
              emitLeadingCommentsOfPosition(hasTrailingComma && (children === null || children === void 0 ? void 0 : children.end) ? children.end : previousSibling.end);
            }
            if (format & 128) {
              decreaseIndent();
            }
            recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
            var closingLineTerminatorCount = getClosingLineTerminatorCount(parentNode, children, format);
            if (closingLineTerminatorCount) {
              writeLine(closingLineTerminatorCount);
            } else if (format & (2097152 | 256)) {
              writeSpace();
            }
          }
          if (onAfterEmitNodeArray) {
            onAfterEmitNodeArray(children);
          }
          if (format & 15360) {
            if (isEmpty && children) {
              emitLeadingCommentsOfPosition(children.end);
            }
            writePunctuation(getClosingBracket(format));
          }
        }
        function writeLiteral(s) {
          writer.writeLiteral(s);
        }
        function writeStringLiteral(s) {
          writer.writeStringLiteral(s);
        }
        function writeBase(s) {
          writer.write(s);
        }
        function writeSymbol(s, sym) {
          writer.writeSymbol(s, sym);
        }
        function writePunctuation(s) {
          writer.writePunctuation(s);
        }
        function writeTrailingSemicolon() {
          writer.writeTrailingSemicolon(";");
        }
        function writeKeyword(s) {
          writer.writeKeyword(s);
        }
        function writeOperator(s) {
          writer.writeOperator(s);
        }
        function writeParameter(s) {
          writer.writeParameter(s);
        }
        function writeComment(s) {
          writer.writeComment(s);
        }
        function writeSpace() {
          writer.writeSpace(" ");
        }
        function writeProperty(s) {
          writer.writeProperty(s);
        }
        function nonEscapingWrite(s) {
          if (writer.nonEscapingWrite) {
            writer.nonEscapingWrite(s);
          } else {
            writer.write(s);
          }
        }
        function writeLine(count) {
          if (count === void 0) {
            count = 1;
          }
          for (var i = 0; i < count; i++) {
            writer.writeLine(i > 0);
          }
        }
        function increaseIndent() {
          writer.increaseIndent();
        }
        function decreaseIndent() {
          writer.decreaseIndent();
        }
        function writeToken(token, pos, writer2, contextNode) {
          return !sourceMapsDisabled ? emitTokenWithSourceMap(contextNode, token, writer2, pos, writeTokenText) : writeTokenText(token, writer2, pos);
        }
        function writeTokenNode(node, writer2) {
          if (onBeforeEmitToken) {
            onBeforeEmitToken(node);
          }
          writer2(ts3.tokenToString(node.kind));
          if (onAfterEmitToken) {
            onAfterEmitToken(node);
          }
        }
        function writeTokenText(token, writer2, pos) {
          var tokenString = ts3.tokenToString(token);
          writer2(tokenString);
          return pos < 0 ? pos : pos + tokenString.length;
        }
        function writeLineOrSpace(parentNode, prevChildNode, nextChildNode) {
          if (ts3.getEmitFlags(parentNode) & 1) {
            writeSpace();
          } else if (preserveSourceNewlines) {
            var lines = getLinesBetweenNodes(parentNode, prevChildNode, nextChildNode);
            if (lines) {
              writeLine(lines);
            } else {
              writeSpace();
            }
          } else {
            writeLine();
          }
        }
        function writeLines(text) {
          var lines = text.split(/\r\n?|\n/g);
          var indentation = ts3.guessIndentation(lines);
          for (var _a2 = 0, lines_3 = lines; _a2 < lines_3.length; _a2++) {
            var lineText = lines_3[_a2];
            var line = indentation ? lineText.slice(indentation) : lineText;
            if (line.length) {
              writeLine();
              write(line);
            }
          }
        }
        function writeLinesAndIndent(lineCount, writeSpaceIfNotIndenting) {
          if (lineCount) {
            increaseIndent();
            writeLine(lineCount);
          } else if (writeSpaceIfNotIndenting) {
            writeSpace();
          }
        }
        function decreaseIndentIf(value1, value2) {
          if (value1) {
            decreaseIndent();
          }
          if (value2) {
            decreaseIndent();
          }
        }
        function getLeadingLineTerminatorCount(parentNode, children, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (format & 65536) {
              return 1;
            }
            var firstChild_1 = children[0];
            if (firstChild_1 === void 0) {
              return !parentNode || currentSourceFile && ts3.rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
            }
            if (firstChild_1.pos === nextListElementPos) {
              return 0;
            }
            if (firstChild_1.kind === 11) {
              return 0;
            }
            if (currentSourceFile && parentNode && !ts3.positionIsSynthesized(parentNode.pos) && !ts3.nodeIsSynthesized(firstChild_1) && (!firstChild_1.parent || ts3.getOriginalNode(firstChild_1.parent) === ts3.getOriginalNode(parentNode))) {
              if (preserveSourceNewlines) {
                return getEffectiveLines(function(includeComments) {
                  return ts3.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(firstChild_1.pos, parentNode.pos, currentSourceFile, includeComments);
                });
              }
              return ts3.rangeStartPositionsAreOnSameLine(parentNode, firstChild_1, currentSourceFile) ? 0 : 1;
            }
            if (synthesizedNodeStartsOnNewLine(firstChild_1, format)) {
              return 1;
            }
          }
          return format & 1 ? 1 : 0;
        }
        function getSeparatingLineTerminatorCount(previousNode, nextNode, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (previousNode === void 0 || nextNode === void 0) {
              return 0;
            }
            if (nextNode.kind === 11) {
              return 0;
            } else if (currentSourceFile && !ts3.nodeIsSynthesized(previousNode) && !ts3.nodeIsSynthesized(nextNode)) {
              if (preserveSourceNewlines && siblingNodePositionsAreComparable(previousNode, nextNode)) {
                return getEffectiveLines(function(includeComments) {
                  return ts3.getLinesBetweenRangeEndAndRangeStart(previousNode, nextNode, currentSourceFile, includeComments);
                });
              } else if (!preserveSourceNewlines && originalNodesHaveSameParent(previousNode, nextNode)) {
                return ts3.rangeEndIsOnSameLineAsRangeStart(previousNode, nextNode, currentSourceFile) ? 0 : 1;
              }
              return format & 65536 ? 1 : 0;
            } else if (synthesizedNodeStartsOnNewLine(previousNode, format) || synthesizedNodeStartsOnNewLine(nextNode, format)) {
              return 1;
            }
          } else if (ts3.getStartsOnNewLine(nextNode)) {
            return 1;
          }
          return format & 1 ? 1 : 0;
        }
        function getClosingLineTerminatorCount(parentNode, children, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (format & 65536) {
              return 1;
            }
            var lastChild = ts3.lastOrUndefined(children);
            if (lastChild === void 0) {
              return !parentNode || currentSourceFile && ts3.rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
            }
            if (currentSourceFile && parentNode && !ts3.positionIsSynthesized(parentNode.pos) && !ts3.nodeIsSynthesized(lastChild) && (!lastChild.parent || lastChild.parent === parentNode)) {
              if (preserveSourceNewlines) {
                var end_1 = ts3.isNodeArray(children) && !ts3.positionIsSynthesized(children.end) ? children.end : lastChild.end;
                return getEffectiveLines(function(includeComments) {
                  return ts3.getLinesBetweenPositionAndNextNonWhitespaceCharacter(end_1, parentNode.end, currentSourceFile, includeComments);
                });
              }
              return ts3.rangeEndPositionsAreOnSameLine(parentNode, lastChild, currentSourceFile) ? 0 : 1;
            }
            if (synthesizedNodeStartsOnNewLine(lastChild, format)) {
              return 1;
            }
          }
          if (format & 1 && !(format & 131072)) {
            return 1;
          }
          return 0;
        }
        function getEffectiveLines(getLineDifference) {
          ts3.Debug.assert(!!preserveSourceNewlines);
          var lines = getLineDifference(true);
          if (lines === 0) {
            return getLineDifference(false);
          }
          return lines;
        }
        function writeLineSeparatorsAndIndentBefore(node, parent) {
          var leadingNewlines = preserveSourceNewlines && getLeadingLineTerminatorCount(parent, [node], 0);
          if (leadingNewlines) {
            writeLinesAndIndent(leadingNewlines, false);
          }
          return !!leadingNewlines;
        }
        function writeLineSeparatorsAfter(node, parent) {
          var trailingNewlines = preserveSourceNewlines && getClosingLineTerminatorCount(parent, [node], 0);
          if (trailingNewlines) {
            writeLine(trailingNewlines);
          }
        }
        function synthesizedNodeStartsOnNewLine(node, format) {
          if (ts3.nodeIsSynthesized(node)) {
            var startsOnNewLine = ts3.getStartsOnNewLine(node);
            if (startsOnNewLine === void 0) {
              return (format & 65536) !== 0;
            }
            return startsOnNewLine;
          }
          return (format & 65536) !== 0;
        }
        function getLinesBetweenNodes(parent, node1, node2) {
          if (ts3.getEmitFlags(parent) & 131072) {
            return 0;
          }
          parent = skipSynthesizedParentheses(parent);
          node1 = skipSynthesizedParentheses(node1);
          node2 = skipSynthesizedParentheses(node2);
          if (ts3.getStartsOnNewLine(node2)) {
            return 1;
          }
          if (currentSourceFile && !ts3.nodeIsSynthesized(parent) && !ts3.nodeIsSynthesized(node1) && !ts3.nodeIsSynthesized(node2)) {
            if (preserveSourceNewlines) {
              return getEffectiveLines(function(includeComments) {
                return ts3.getLinesBetweenRangeEndAndRangeStart(node1, node2, currentSourceFile, includeComments);
              });
            }
            return ts3.rangeEndIsOnSameLineAsRangeStart(node1, node2, currentSourceFile) ? 0 : 1;
          }
          return 0;
        }
        function isEmptyBlock(block) {
          return block.statements.length === 0 && (!currentSourceFile || ts3.rangeEndIsOnSameLineAsRangeStart(block, block, currentSourceFile));
        }
        function skipSynthesizedParentheses(node) {
          while (node.kind === 212 && ts3.nodeIsSynthesized(node)) {
            node = node.expression;
          }
          return node;
        }
        function getTextOfNode(node, includeTrivia) {
          if (ts3.isGeneratedIdentifier(node)) {
            return generateName(node);
          }
          if (ts3.isStringLiteral(node) && node.textSourceNode) {
            return getTextOfNode(node.textSourceNode, includeTrivia);
          }
          var sourceFile = currentSourceFile;
          var canUseSourceFile = !!sourceFile && !!node.parent && !ts3.nodeIsSynthesized(node);
          if (ts3.isMemberName(node)) {
            if (!canUseSourceFile || ts3.getSourceFileOfNode(node) !== ts3.getOriginalNode(sourceFile)) {
              return ts3.idText(node);
            }
          } else {
            ts3.Debug.assertNode(node, ts3.isLiteralExpression);
            if (!canUseSourceFile) {
              return node.text;
            }
          }
          return ts3.getSourceTextOfNodeFromSourceFile(sourceFile, node, includeTrivia);
        }
        function getLiteralTextOfNode(node, neverAsciiEscape, jsxAttributeEscape) {
          if (node.kind === 10 && node.textSourceNode) {
            var textSourceNode = node.textSourceNode;
            if (ts3.isIdentifier(textSourceNode) || ts3.isNumericLiteral(textSourceNode)) {
              var text = ts3.isNumericLiteral(textSourceNode) ? textSourceNode.text : getTextOfNode(textSourceNode);
              return jsxAttributeEscape ? '"'.concat(ts3.escapeJsxAttributeString(text), '"') : neverAsciiEscape || ts3.getEmitFlags(node) & 16777216 ? '"'.concat(ts3.escapeString(text), '"') : '"'.concat(ts3.escapeNonAsciiString(text), '"');
            } else {
              return getLiteralTextOfNode(textSourceNode, neverAsciiEscape, jsxAttributeEscape);
            }
          }
          var flags = (neverAsciiEscape ? 1 : 0) | (jsxAttributeEscape ? 2 : 0) | (printerOptions.terminateUnterminatedLiterals ? 4 : 0) | (printerOptions.target && printerOptions.target === 99 ? 8 : 0);
          return ts3.getLiteralText(node, currentSourceFile, flags);
        }
        function pushNameGenerationScope(node) {
          if (node && ts3.getEmitFlags(node) & 524288) {
            return;
          }
          tempFlagsStack.push(tempFlags);
          tempFlags = 0;
          reservedNamesStack.push(reservedNames);
        }
        function popNameGenerationScope(node) {
          if (node && ts3.getEmitFlags(node) & 524288) {
            return;
          }
          tempFlags = tempFlagsStack.pop();
          reservedNames = reservedNamesStack.pop();
        }
        function reserveNameInNestedScopes(name) {
          if (!reservedNames || reservedNames === ts3.lastOrUndefined(reservedNamesStack)) {
            reservedNames = new ts3.Set();
          }
          reservedNames.add(name);
        }
        function generateNames(node) {
          if (!node)
            return;
          switch (node.kind) {
            case 235:
              ts3.forEach(node.statements, generateNames);
              break;
            case 250:
            case 248:
            case 240:
            case 241:
              generateNames(node.statement);
              break;
            case 239:
              generateNames(node.thenStatement);
              generateNames(node.elseStatement);
              break;
            case 242:
            case 244:
            case 243:
              generateNames(node.initializer);
              generateNames(node.statement);
              break;
            case 249:
              generateNames(node.caseBlock);
              break;
            case 263:
              ts3.forEach(node.clauses, generateNames);
              break;
            case 289:
            case 290:
              ts3.forEach(node.statements, generateNames);
              break;
            case 252:
              generateNames(node.tryBlock);
              generateNames(node.catchClause);
              generateNames(node.finallyBlock);
              break;
            case 292:
              generateNames(node.variableDeclaration);
              generateNames(node.block);
              break;
            case 237:
              generateNames(node.declarationList);
              break;
            case 255:
              ts3.forEach(node.declarations, generateNames);
              break;
            case 254:
            case 164:
            case 203:
            case 257:
              generateNameIfNeeded(node.name);
              break;
            case 256:
              generateNameIfNeeded(node.name);
              if (ts3.getEmitFlags(node) & 524288) {
                ts3.forEach(node.parameters, generateNames);
                generateNames(node.body);
              }
              break;
            case 201:
            case 202:
              ts3.forEach(node.elements, generateNames);
              break;
            case 266:
              generateNames(node.importClause);
              break;
            case 267:
              generateNameIfNeeded(node.name);
              generateNames(node.namedBindings);
              break;
            case 268:
              generateNameIfNeeded(node.name);
              break;
            case 274:
              generateNameIfNeeded(node.name);
              break;
            case 269:
              ts3.forEach(node.elements, generateNames);
              break;
            case 270:
              generateNameIfNeeded(node.propertyName || node.name);
              break;
          }
        }
        function generateMemberNames(node) {
          if (!node)
            return;
          switch (node.kind) {
            case 296:
            case 297:
            case 167:
            case 169:
            case 172:
            case 173:
              generateNameIfNeeded(node.name);
              break;
          }
        }
        function generateNameIfNeeded(name) {
          if (name) {
            if (ts3.isGeneratedIdentifier(name)) {
              generateName(name);
            } else if (ts3.isBindingPattern(name)) {
              generateNames(name);
            }
          }
        }
        function generateName(name) {
          if ((name.autoGenerateFlags & 7) === 4) {
            return generateNameCached(getNodeForGeneratedName(name), name.autoGenerateFlags);
          } else {
            var autoGenerateId = name.autoGenerateId;
            return autoGeneratedIdToGeneratedName[autoGenerateId] || (autoGeneratedIdToGeneratedName[autoGenerateId] = makeName(name));
          }
        }
        function generateNameCached(node, flags) {
          var nodeId = ts3.getNodeId(node);
          return nodeIdToGeneratedName[nodeId] || (nodeIdToGeneratedName[nodeId] = generateNameForNode(node, flags));
        }
        function isUniqueName(name) {
          return isFileLevelUniqueName(name) && !generatedNames.has(name) && !(reservedNames && reservedNames.has(name));
        }
        function isFileLevelUniqueName(name) {
          return currentSourceFile ? ts3.isFileLevelUniqueName(currentSourceFile, name, hasGlobalName) : true;
        }
        function isUniqueLocalName(name, container) {
          for (var node = container; ts3.isNodeDescendantOf(node, container); node = node.nextContainer) {
            if (node.locals) {
              var local = node.locals.get(ts3.escapeLeadingUnderscores(name));
              if (local && local.flags & (111551 | 1048576 | 2097152)) {
                return false;
              }
            }
          }
          return true;
        }
        function makeTempVariableName(flags, reservedInNestedScopes) {
          if (flags && !(tempFlags & flags)) {
            var name = flags === 268435456 ? "_i" : "_n";
            if (isUniqueName(name)) {
              tempFlags |= flags;
              if (reservedInNestedScopes) {
                reserveNameInNestedScopes(name);
              }
              return name;
            }
          }
          while (true) {
            var count = tempFlags & 268435455;
            tempFlags++;
            if (count !== 8 && count !== 13) {
              var name = count < 26 ? "_" + String.fromCharCode(97 + count) : "_" + (count - 26);
              if (isUniqueName(name)) {
                if (reservedInNestedScopes) {
                  reserveNameInNestedScopes(name);
                }
                return name;
              }
            }
          }
        }
        function makeUniqueName(baseName, checkFn, optimistic, scoped) {
          if (checkFn === void 0) {
            checkFn = isUniqueName;
          }
          if (optimistic) {
            if (checkFn(baseName)) {
              if (scoped) {
                reserveNameInNestedScopes(baseName);
              } else {
                generatedNames.add(baseName);
              }
              return baseName;
            }
          }
          if (baseName.charCodeAt(baseName.length - 1) !== 95) {
            baseName += "_";
          }
          var i = 1;
          while (true) {
            var generatedName = baseName + i;
            if (checkFn(generatedName)) {
              if (scoped) {
                reserveNameInNestedScopes(generatedName);
              } else {
                generatedNames.add(generatedName);
              }
              return generatedName;
            }
            i++;
          }
        }
        function makeFileLevelOptimisticUniqueName(name) {
          return makeUniqueName(name, isFileLevelUniqueName, true);
        }
        function generateNameForModuleOrEnum(node) {
          var name = getTextOfNode(node.name);
          return isUniqueLocalName(name, node) ? name : makeUniqueName(name);
        }
        function generateNameForImportOrExportDeclaration(node) {
          var expr = ts3.getExternalModuleName(node);
          var baseName = ts3.isStringLiteral(expr) ? ts3.makeIdentifierFromModuleName(expr.text) : "module";
          return makeUniqueName(baseName);
        }
        function generateNameForExportDefault() {
          return makeUniqueName("default");
        }
        function generateNameForClassExpression() {
          return makeUniqueName("class");
        }
        function generateNameForMethodOrAccessor(node) {
          if (ts3.isIdentifier(node.name)) {
            return generateNameCached(node.name);
          }
          return makeTempVariableName(0);
        }
        function generateNameForNode(node, flags) {
          switch (node.kind) {
            case 79:
              return makeUniqueName(getTextOfNode(node), isUniqueName, !!(flags & 16), !!(flags & 8));
            case 261:
            case 260:
              return generateNameForModuleOrEnum(node);
            case 266:
            case 272:
              return generateNameForImportOrExportDeclaration(node);
            case 256:
            case 257:
            case 271:
              return generateNameForExportDefault();
            case 226:
              return generateNameForClassExpression();
            case 169:
            case 172:
            case 173:
              return generateNameForMethodOrAccessor(node);
            case 162:
              return makeTempVariableName(0, true);
            default:
              return makeTempVariableName(0);
          }
        }
        function makeName(name) {
          switch (name.autoGenerateFlags & 7) {
            case 1:
              return makeTempVariableName(0, !!(name.autoGenerateFlags & 8));
            case 2:
              return makeTempVariableName(268435456, !!(name.autoGenerateFlags & 8));
            case 3:
              return makeUniqueName(ts3.idText(name), name.autoGenerateFlags & 32 ? isFileLevelUniqueName : isUniqueName, !!(name.autoGenerateFlags & 16), !!(name.autoGenerateFlags & 8));
          }
          return ts3.Debug.fail("Unsupported GeneratedIdentifierKind.");
        }
        function getNodeForGeneratedName(name) {
          var autoGenerateId = name.autoGenerateId;
          var node = name;
          var original = node.original;
          while (original) {
            node = original;
            if (ts3.isIdentifier(node) && !!(node.autoGenerateFlags & 4) && node.autoGenerateId !== autoGenerateId) {
              break;
            }
            original = node.original;
          }
          return node;
        }
        function pipelineEmitWithComments(hint, node) {
          var pipelinePhase = getNextPipelinePhase(2, hint, node);
          var savedContainerPos = containerPos;
          var savedContainerEnd = containerEnd;
          var savedDeclarationListContainerEnd = declarationListContainerEnd;
          emitCommentsBeforeNode(node);
          pipelinePhase(hint, node);
          emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
        }
        function emitCommentsBeforeNode(node) {
          var emitFlags = ts3.getEmitFlags(node);
          var commentRange = ts3.getCommentRange(node);
          emitLeadingCommentsOfNode(node, emitFlags, commentRange.pos, commentRange.end);
          if (emitFlags & 2048) {
            commentsDisabled = true;
          }
        }
        function emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd) {
          var emitFlags = ts3.getEmitFlags(node);
          var commentRange = ts3.getCommentRange(node);
          if (emitFlags & 2048) {
            commentsDisabled = false;
          }
          emitTrailingCommentsOfNode(node, emitFlags, commentRange.pos, commentRange.end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
          var typeNode = ts3.getTypeNode(node);
          if (typeNode) {
            emitTrailingCommentsOfNode(node, emitFlags, typeNode.pos, typeNode.end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
          }
        }
        function emitLeadingCommentsOfNode(node, emitFlags, pos, end) {
          enterComment();
          hasWrittenComment = false;
          var skipLeadingComments = pos < 0 || (emitFlags & 512) !== 0 || node.kind === 11;
          var skipTrailingComments = end < 0 || (emitFlags & 1024) !== 0 || node.kind === 11;
          if ((pos > 0 || end > 0) && pos !== end) {
            if (!skipLeadingComments) {
              emitLeadingComments(pos, node.kind !== 349);
            }
            if (!skipLeadingComments || pos >= 0 && (emitFlags & 512) !== 0) {
              containerPos = pos;
            }
            if (!skipTrailingComments || end >= 0 && (emitFlags & 1024) !== 0) {
              containerEnd = end;
              if (node.kind === 255) {
                declarationListContainerEnd = end;
              }
            }
          }
          ts3.forEach(ts3.getSyntheticLeadingComments(node), emitLeadingSynthesizedComment);
          exitComment();
        }
        function emitTrailingCommentsOfNode(node, emitFlags, pos, end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd) {
          enterComment();
          var skipTrailingComments = end < 0 || (emitFlags & 1024) !== 0 || node.kind === 11;
          ts3.forEach(ts3.getSyntheticTrailingComments(node), emitTrailingSynthesizedComment);
          if ((pos > 0 || end > 0) && pos !== end) {
            containerPos = savedContainerPos;
            containerEnd = savedContainerEnd;
            declarationListContainerEnd = savedDeclarationListContainerEnd;
            if (!skipTrailingComments && node.kind !== 349) {
              emitTrailingComments(end);
            }
          }
          exitComment();
        }
        function emitLeadingSynthesizedComment(comment) {
          if (comment.hasLeadingNewline || comment.kind === 2) {
            writer.writeLine();
          }
          writeSynthesizedComment(comment);
          if (comment.hasTrailingNewLine || comment.kind === 2) {
            writer.writeLine();
          } else {
            writer.writeSpace(" ");
          }
        }
        function emitTrailingSynthesizedComment(comment) {
          if (!writer.isAtStartOfLine()) {
            writer.writeSpace(" ");
          }
          writeSynthesizedComment(comment);
          if (comment.hasTrailingNewLine) {
            writer.writeLine();
          }
        }
        function writeSynthesizedComment(comment) {
          var text = formatSynthesizedComment(comment);
          var lineMap = comment.kind === 3 ? ts3.computeLineStarts(text) : void 0;
          ts3.writeCommentRange(text, lineMap, writer, 0, text.length, newLine);
        }
        function formatSynthesizedComment(comment) {
          return comment.kind === 3 ? "/*".concat(comment.text, "*/") : "//".concat(comment.text);
        }
        function emitBodyWithDetachedComments(node, detachedRange, emitCallback) {
          enterComment();
          var pos = detachedRange.pos, end = detachedRange.end;
          var emitFlags = ts3.getEmitFlags(node);
          var skipLeadingComments = pos < 0 || (emitFlags & 512) !== 0;
          var skipTrailingComments = commentsDisabled || end < 0 || (emitFlags & 1024) !== 0;
          if (!skipLeadingComments) {
            emitDetachedCommentsAndUpdateCommentsInfo(detachedRange);
          }
          exitComment();
          if (emitFlags & 2048 && !commentsDisabled) {
            commentsDisabled = true;
            emitCallback(node);
            commentsDisabled = false;
          } else {
            emitCallback(node);
          }
          enterComment();
          if (!skipTrailingComments) {
            emitLeadingComments(detachedRange.end, true);
            if (hasWrittenComment && !writer.isAtStartOfLine()) {
              writer.writeLine();
            }
          }
          exitComment();
        }
        function originalNodesHaveSameParent(nodeA, nodeB) {
          nodeA = ts3.getOriginalNode(nodeA);
          return nodeA.parent && nodeA.parent === ts3.getOriginalNode(nodeB).parent;
        }
        function siblingNodePositionsAreComparable(previousNode, nextNode) {
          if (nextNode.pos < previousNode.end) {
            return false;
          }
          previousNode = ts3.getOriginalNode(previousNode);
          nextNode = ts3.getOriginalNode(nextNode);
          var parent = previousNode.parent;
          if (!parent || parent !== nextNode.parent) {
            return false;
          }
          var parentNodeArray = ts3.getContainingNodeArray(previousNode);
          var prevNodeIndex = parentNodeArray === null || parentNodeArray === void 0 ? void 0 : parentNodeArray.indexOf(previousNode);
          return prevNodeIndex !== void 0 && prevNodeIndex > -1 && parentNodeArray.indexOf(nextNode) === prevNodeIndex + 1;
        }
        function emitLeadingComments(pos, isEmittedNode) {
          hasWrittenComment = false;
          if (isEmittedNode) {
            if (pos === 0 && (currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.isDeclarationFile)) {
              forEachLeadingCommentToEmit(pos, emitNonTripleSlashLeadingComment);
            } else {
              forEachLeadingCommentToEmit(pos, emitLeadingComment);
            }
          } else if (pos === 0) {
            forEachLeadingCommentToEmit(pos, emitTripleSlashLeadingComment);
          }
        }
        function emitTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (isTripleSlashComment(commentPos, commentEnd)) {
            emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
          }
        }
        function emitNonTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (!isTripleSlashComment(commentPos, commentEnd)) {
            emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
          }
        }
        function shouldWriteComment(text, pos) {
          if (printerOptions.onlyPrintJsDocStyle) {
            return ts3.isJSDocLikeText(text, pos) || ts3.isPinnedComment(text, pos);
          }
          return true;
        }
        function emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (!currentSourceFile || !shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          if (!hasWrittenComment) {
            ts3.emitNewLineBeforeLeadingCommentOfPosition(getCurrentLineMap(), writer, rangePos, commentPos);
            hasWrittenComment = true;
          }
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          } else if (kind === 3) {
            writer.writeSpace(" ");
          }
        }
        function emitLeadingCommentsOfPosition(pos) {
          if (commentsDisabled || pos === -1) {
            return;
          }
          emitLeadingComments(pos, true);
        }
        function emitTrailingComments(pos) {
          forEachTrailingCommentToEmit(pos, emitTrailingComment);
        }
        function emitTrailingComment(commentPos, commentEnd, _kind, hasTrailingNewLine) {
          if (!currentSourceFile || !shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          if (!writer.isAtStartOfLine()) {
            writer.writeSpace(" ");
          }
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          }
        }
        function emitTrailingCommentsOfPosition(pos, prefixSpace, forceNoNewline) {
          if (commentsDisabled) {
            return;
          }
          enterComment();
          forEachTrailingCommentToEmit(pos, prefixSpace ? emitTrailingComment : forceNoNewline ? emitTrailingCommentOfPositionNoNewline : emitTrailingCommentOfPosition);
          exitComment();
        }
        function emitTrailingCommentOfPositionNoNewline(commentPos, commentEnd, kind) {
          if (!currentSourceFile)
            return;
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (kind === 2) {
            writer.writeLine();
          }
        }
        function emitTrailingCommentOfPosition(commentPos, commentEnd, _kind, hasTrailingNewLine) {
          if (!currentSourceFile)
            return;
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          } else {
            writer.writeSpace(" ");
          }
        }
        function forEachLeadingCommentToEmit(pos, cb) {
          if (currentSourceFile && (containerPos === -1 || pos !== containerPos)) {
            if (hasDetachedComments(pos)) {
              forEachLeadingCommentWithoutDetachedComments(cb);
            } else {
              ts3.forEachLeadingCommentRange(currentSourceFile.text, pos, cb, pos);
            }
          }
        }
        function forEachTrailingCommentToEmit(end, cb) {
          if (currentSourceFile && (containerEnd === -1 || end !== containerEnd && end !== declarationListContainerEnd)) {
            ts3.forEachTrailingCommentRange(currentSourceFile.text, end, cb);
          }
        }
        function hasDetachedComments(pos) {
          return detachedCommentsInfo !== void 0 && ts3.last(detachedCommentsInfo).nodePos === pos;
        }
        function forEachLeadingCommentWithoutDetachedComments(cb) {
          if (!currentSourceFile)
            return;
          var pos = ts3.last(detachedCommentsInfo).detachedCommentEndPos;
          if (detachedCommentsInfo.length - 1) {
            detachedCommentsInfo.pop();
          } else {
            detachedCommentsInfo = void 0;
          }
          ts3.forEachLeadingCommentRange(currentSourceFile.text, pos, cb, pos);
        }
        function emitDetachedCommentsAndUpdateCommentsInfo(range) {
          var currentDetachedCommentInfo = currentSourceFile && ts3.emitDetachedComments(currentSourceFile.text, getCurrentLineMap(), writer, emitComment, range, newLine, commentsDisabled);
          if (currentDetachedCommentInfo) {
            if (detachedCommentsInfo) {
              detachedCommentsInfo.push(currentDetachedCommentInfo);
            } else {
              detachedCommentsInfo = [currentDetachedCommentInfo];
            }
          }
        }
        function emitComment(text, lineMap, writer2, commentPos, commentEnd, newLine2) {
          if (!currentSourceFile || !shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          emitPos(commentPos);
          ts3.writeCommentRange(text, lineMap, writer2, commentPos, commentEnd, newLine2);
          emitPos(commentEnd);
        }
        function isTripleSlashComment(commentPos, commentEnd) {
          return !!currentSourceFile && ts3.isRecognizedTripleSlashComment(currentSourceFile.text, commentPos, commentEnd);
        }
        function getParsedSourceMap(node) {
          if (node.parsedSourceMap === void 0 && node.sourceMapText !== void 0) {
            node.parsedSourceMap = ts3.tryParseRawSourceMap(node.sourceMapText) || false;
          }
          return node.parsedSourceMap || void 0;
        }
        function pipelineEmitWithSourceMaps(hint, node) {
          var pipelinePhase = getNextPipelinePhase(3, hint, node);
          emitSourceMapsBeforeNode(node);
          pipelinePhase(hint, node);
          emitSourceMapsAfterNode(node);
        }
        function emitSourceMapsBeforeNode(node) {
          var emitFlags = ts3.getEmitFlags(node);
          var sourceMapRange = ts3.getSourceMapRange(node);
          if (ts3.isUnparsedNode(node)) {
            ts3.Debug.assertIsDefined(node.parent, "UnparsedNodes must have parent pointers");
            var parsed = getParsedSourceMap(node.parent);
            if (parsed && sourceMapGenerator) {
              sourceMapGenerator.appendSourceMap(writer.getLine(), writer.getColumn(), parsed, node.parent.sourceMapPath, node.parent.getLineAndCharacterOfPosition(node.pos), node.parent.getLineAndCharacterOfPosition(node.end));
            }
          } else {
            var source = sourceMapRange.source || sourceMapSource;
            if (node.kind !== 349 && (emitFlags & 16) === 0 && sourceMapRange.pos >= 0) {
              emitSourcePos(sourceMapRange.source || sourceMapSource, skipSourceTrivia(source, sourceMapRange.pos));
            }
            if (emitFlags & 64) {
              sourceMapsDisabled = true;
            }
          }
        }
        function emitSourceMapsAfterNode(node) {
          var emitFlags = ts3.getEmitFlags(node);
          var sourceMapRange = ts3.getSourceMapRange(node);
          if (!ts3.isUnparsedNode(node)) {
            if (emitFlags & 64) {
              sourceMapsDisabled = false;
            }
            if (node.kind !== 349 && (emitFlags & 32) === 0 && sourceMapRange.end >= 0) {
              emitSourcePos(sourceMapRange.source || sourceMapSource, sourceMapRange.end);
            }
          }
        }
        function skipSourceTrivia(source, pos) {
          return source.skipTrivia ? source.skipTrivia(pos) : ts3.skipTrivia(source.text, pos);
        }
        function emitPos(pos) {
          if (sourceMapsDisabled || ts3.positionIsSynthesized(pos) || isJsonSourceMapSource(sourceMapSource)) {
            return;
          }
          var _a2 = ts3.getLineAndCharacterOfPosition(sourceMapSource, pos), sourceLine = _a2.line, sourceCharacter = _a2.character;
          sourceMapGenerator.addMapping(writer.getLine(), writer.getColumn(), sourceMapSourceIndex, sourceLine, sourceCharacter, void 0);
        }
        function emitSourcePos(source, pos) {
          if (source !== sourceMapSource) {
            var savedSourceMapSource = sourceMapSource;
            var savedSourceMapSourceIndex = sourceMapSourceIndex;
            setSourceMapSource(source);
            emitPos(pos);
            resetSourceMapSource(savedSourceMapSource, savedSourceMapSourceIndex);
          } else {
            emitPos(pos);
          }
        }
        function emitTokenWithSourceMap(node, token, writer2, tokenPos, emitCallback) {
          if (sourceMapsDisabled || node && ts3.isInJsonFile(node)) {
            return emitCallback(token, writer2, tokenPos);
          }
          var emitNode = node && node.emitNode;
          var emitFlags = emitNode && emitNode.flags || 0;
          var range = emitNode && emitNode.tokenSourceMapRanges && emitNode.tokenSourceMapRanges[token];
          var source = range && range.source || sourceMapSource;
          tokenPos = skipSourceTrivia(source, range ? range.pos : tokenPos);
          if ((emitFlags & 128) === 0 && tokenPos >= 0) {
            emitSourcePos(source, tokenPos);
          }
          tokenPos = emitCallback(token, writer2, tokenPos);
          if (range)
            tokenPos = range.end;
          if ((emitFlags & 256) === 0 && tokenPos >= 0) {
            emitSourcePos(source, tokenPos);
          }
          return tokenPos;
        }
        function setSourceMapSource(source) {
          if (sourceMapsDisabled) {
            return;
          }
          sourceMapSource = source;
          if (source === mostRecentlyAddedSourceMapSource) {
            sourceMapSourceIndex = mostRecentlyAddedSourceMapSourceIndex;
            return;
          }
          if (isJsonSourceMapSource(source)) {
            return;
          }
          sourceMapSourceIndex = sourceMapGenerator.addSource(source.fileName);
          if (printerOptions.inlineSources) {
            sourceMapGenerator.setSourceContent(sourceMapSourceIndex, source.text);
          }
          mostRecentlyAddedSourceMapSource = source;
          mostRecentlyAddedSourceMapSourceIndex = sourceMapSourceIndex;
        }
        function resetSourceMapSource(source, sourceIndex) {
          sourceMapSource = source;
          sourceMapSourceIndex = sourceIndex;
        }
        function isJsonSourceMapSource(sourceFile) {
          return ts3.fileExtensionIs(sourceFile.fileName, ".json");
        }
      }
      ts3.createPrinter = createPrinter;
      function createBracketsMap() {
        var brackets2 = [];
        brackets2[1024] = ["{", "}"];
        brackets2[2048] = ["(", ")"];
        brackets2[4096] = ["<", ">"];
        brackets2[8192] = ["[", "]"];
        return brackets2;
      }
      function getOpeningBracket(format) {
        return brackets[format & 15360][0];
      }
      function getClosingBracket(format) {
        return brackets[format & 15360][1];
      }
      var TempFlags;
      (function(TempFlags2) {
        TempFlags2[TempFlags2["Auto"] = 0] = "Auto";
        TempFlags2[TempFlags2["CountMask"] = 268435455] = "CountMask";
        TempFlags2[TempFlags2["_i"] = 268435456] = "_i";
      })(TempFlags || (TempFlags = {}));
      function emitListItemNoParenthesizer(node, emit, _parenthesizerRule, _index) {
        emit(node);
      }
      function emitListItemWithParenthesizerRuleSelector(node, emit, parenthesizerRuleSelector, index) {
        emit(node, parenthesizerRuleSelector.select(index));
      }
      function emitListItemWithParenthesizerRule(node, emit, parenthesizerRule, _index) {
        emit(node, parenthesizerRule);
      }
      function getEmitListItem(emit, parenthesizerRule) {
        return emit.length === 1 ? emitListItemNoParenthesizer : typeof parenthesizerRule === "object" ? emitListItemWithParenthesizerRuleSelector : emitListItemWithParenthesizerRule;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames) {
        if (!host.getDirectories || !host.readDirectory) {
          return void 0;
        }
        var cachedReadDirectoryResult = new ts3.Map();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return {
          useCaseSensitiveFileNames,
          fileExists,
          readFile: function(path2, encoding) {
            return host.readFile(path2, encoding);
          },
          directoryExists: host.directoryExists && directoryExists,
          getDirectories,
          readDirectory,
          createDirectory: host.createDirectory && createDirectory,
          writeFile: host.writeFile && writeFile,
          addOrDeleteFileOrDirectory,
          addOrDeleteFile,
          clearCache,
          realpath: host.realpath && realpath
        };
        function toPath(fileName2) {
          return ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
        }
        function getCachedFileSystemEntries(rootDirPath) {
          return cachedReadDirectoryResult.get(ts3.ensureTrailingDirectorySeparator(rootDirPath));
        }
        function getCachedFileSystemEntriesForBaseDir(path2) {
          return getCachedFileSystemEntries(ts3.getDirectoryPath(path2));
        }
        function getBaseNameOfFileName(fileName2) {
          return ts3.getBaseFileName(ts3.normalizePath(fileName2));
        }
        function createCachedFileSystemEntries(rootDir, rootDirPath) {
          var _a;
          if (!host.realpath || ts3.ensureTrailingDirectorySeparator(toPath(host.realpath(rootDir))) === rootDirPath) {
            var resultFromHost = {
              files: ts3.map(host.readDirectory(rootDir, void 0, void 0, ["*.*"]), getBaseNameOfFileName) || [],
              directories: host.getDirectories(rootDir) || []
            };
            cachedReadDirectoryResult.set(ts3.ensureTrailingDirectorySeparator(rootDirPath), resultFromHost);
            return resultFromHost;
          }
          if ((_a = host.directoryExists) === null || _a === void 0 ? void 0 : _a.call(host, rootDir)) {
            cachedReadDirectoryResult.set(rootDirPath, false);
            return false;
          }
          return void 0;
        }
        function tryReadDirectory(rootDir, rootDirPath) {
          rootDirPath = ts3.ensureTrailingDirectorySeparator(rootDirPath);
          var cachedResult = getCachedFileSystemEntries(rootDirPath);
          if (cachedResult) {
            return cachedResult;
          }
          try {
            return createCachedFileSystemEntries(rootDir, rootDirPath);
          } catch (_e) {
            ts3.Debug.assert(!cachedReadDirectoryResult.has(ts3.ensureTrailingDirectorySeparator(rootDirPath)));
            return void 0;
          }
        }
        function fileNameEqual(name1, name2) {
          return getCanonicalFileName(name1) === getCanonicalFileName(name2);
        }
        function hasEntry(entries, name) {
          return ts3.some(entries, function(file) {
            return fileNameEqual(file, name);
          });
        }
        function updateFileSystemEntry(entries, baseName, isValid) {
          if (hasEntry(entries, baseName)) {
            if (!isValid) {
              return ts3.filterMutate(entries, function(entry) {
                return !fileNameEqual(entry, baseName);
              });
            }
          } else if (isValid) {
            return entries.push(baseName);
          }
        }
        function writeFile(fileName2, data, writeByteOrderMark) {
          var path2 = toPath(fileName2);
          var result2 = getCachedFileSystemEntriesForBaseDir(path2);
          if (result2) {
            updateFilesOfFileSystemEntry(result2, getBaseNameOfFileName(fileName2), true);
          }
          return host.writeFile(fileName2, data, writeByteOrderMark);
        }
        function fileExists(fileName2) {
          var path2 = toPath(fileName2);
          var result2 = getCachedFileSystemEntriesForBaseDir(path2);
          return result2 && hasEntry(result2.files, getBaseNameOfFileName(fileName2)) || host.fileExists(fileName2);
        }
        function directoryExists(dirPath) {
          var path2 = toPath(dirPath);
          return cachedReadDirectoryResult.has(ts3.ensureTrailingDirectorySeparator(path2)) || host.directoryExists(dirPath);
        }
        function createDirectory(dirPath) {
          var path2 = toPath(dirPath);
          var result2 = getCachedFileSystemEntriesForBaseDir(path2);
          var baseFileName = getBaseNameOfFileName(dirPath);
          if (result2) {
            updateFileSystemEntry(result2.directories, baseFileName, true);
          }
          host.createDirectory(dirPath);
        }
        function getDirectories(rootDir) {
          var rootDirPath = toPath(rootDir);
          var result2 = tryReadDirectory(rootDir, rootDirPath);
          if (result2) {
            return result2.directories.slice();
          }
          return host.getDirectories(rootDir);
        }
        function readDirectory(rootDir, extensions, excludes, includes, depth) {
          var rootDirPath = toPath(rootDir);
          var rootResult = tryReadDirectory(rootDir, rootDirPath);
          var rootSymLinkResult;
          if (rootResult !== void 0) {
            return ts3.matchFiles(rootDir, extensions, excludes, includes, useCaseSensitiveFileNames, currentDirectory, depth, getFileSystemEntries, realpath);
          }
          return host.readDirectory(rootDir, extensions, excludes, includes, depth);
          function getFileSystemEntries(dir) {
            var path2 = toPath(dir);
            if (path2 === rootDirPath) {
              return rootResult || getFileSystemEntriesFromHost(dir, path2);
            }
            var result2 = tryReadDirectory(dir, path2);
            return result2 !== void 0 ? result2 || getFileSystemEntriesFromHost(dir, path2) : ts3.emptyFileSystemEntries;
          }
          function getFileSystemEntriesFromHost(dir, path2) {
            if (rootSymLinkResult && path2 === rootDirPath)
              return rootSymLinkResult;
            var result2 = {
              files: ts3.map(host.readDirectory(dir, void 0, void 0, ["*.*"]), getBaseNameOfFileName) || ts3.emptyArray,
              directories: host.getDirectories(dir) || ts3.emptyArray
            };
            if (path2 === rootDirPath)
              rootSymLinkResult = result2;
            return result2;
          }
        }
        function realpath(s) {
          return host.realpath ? host.realpath(s) : s;
        }
        function addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath) {
          var existingResult = getCachedFileSystemEntries(fileOrDirectoryPath);
          if (existingResult !== void 0) {
            clearCache();
            return void 0;
          }
          var parentResult = getCachedFileSystemEntriesForBaseDir(fileOrDirectoryPath);
          if (!parentResult) {
            return void 0;
          }
          if (!host.directoryExists) {
            clearCache();
            return void 0;
          }
          var baseName = getBaseNameOfFileName(fileOrDirectory);
          var fsQueryResult = {
            fileExists: host.fileExists(fileOrDirectoryPath),
            directoryExists: host.directoryExists(fileOrDirectoryPath)
          };
          if (fsQueryResult.directoryExists || hasEntry(parentResult.directories, baseName)) {
            clearCache();
          } else {
            updateFilesOfFileSystemEntry(parentResult, baseName, fsQueryResult.fileExists);
          }
          return fsQueryResult;
        }
        function addOrDeleteFile(fileName2, filePath, eventKind) {
          if (eventKind === ts3.FileWatcherEventKind.Changed) {
            return;
          }
          var parentResult = getCachedFileSystemEntriesForBaseDir(filePath);
          if (parentResult) {
            updateFilesOfFileSystemEntry(parentResult, getBaseNameOfFileName(fileName2), eventKind === ts3.FileWatcherEventKind.Created);
          }
        }
        function updateFilesOfFileSystemEntry(parentResult, baseName, fileExists2) {
          updateFileSystemEntry(parentResult.files, baseName, fileExists2);
        }
        function clearCache() {
          cachedReadDirectoryResult.clear();
        }
      }
      ts3.createCachedDirectoryStructureHost = createCachedDirectoryStructureHost;
      var ConfigFileProgramReloadLevel;
      (function(ConfigFileProgramReloadLevel2) {
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["None"] = 0] = "None";
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["Partial"] = 1] = "Partial";
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["Full"] = 2] = "Full";
      })(ConfigFileProgramReloadLevel = ts3.ConfigFileProgramReloadLevel || (ts3.ConfigFileProgramReloadLevel = {}));
      function updateSharedExtendedConfigFileWatcher(projectPath, options, extendedConfigFilesMap, createExtendedConfigFileWatch, toPath) {
        var _a;
        var extendedConfigs = ts3.arrayToMap(((_a = options === null || options === void 0 ? void 0 : options.configFile) === null || _a === void 0 ? void 0 : _a.extendedSourceFiles) || ts3.emptyArray, toPath);
        extendedConfigFilesMap.forEach(function(watcher, extendedConfigFilePath) {
          if (!extendedConfigs.has(extendedConfigFilePath)) {
            watcher.projects.delete(projectPath);
            watcher.close();
          }
        });
        extendedConfigs.forEach(function(extendedConfigFileName, extendedConfigFilePath) {
          var existing = extendedConfigFilesMap.get(extendedConfigFilePath);
          if (existing) {
            existing.projects.add(projectPath);
          } else {
            extendedConfigFilesMap.set(extendedConfigFilePath, {
              projects: new ts3.Set([projectPath]),
              watcher: createExtendedConfigFileWatch(extendedConfigFileName, extendedConfigFilePath),
              close: function() {
                var existing2 = extendedConfigFilesMap.get(extendedConfigFilePath);
                if (!existing2 || existing2.projects.size !== 0)
                  return;
                existing2.watcher.close();
                extendedConfigFilesMap.delete(extendedConfigFilePath);
              }
            });
          }
        });
      }
      ts3.updateSharedExtendedConfigFileWatcher = updateSharedExtendedConfigFileWatcher;
      function clearSharedExtendedConfigFileWatcher(projectPath, extendedConfigFilesMap) {
        extendedConfigFilesMap.forEach(function(watcher) {
          if (watcher.projects.delete(projectPath))
            watcher.close();
        });
      }
      ts3.clearSharedExtendedConfigFileWatcher = clearSharedExtendedConfigFileWatcher;
      function cleanExtendedConfigCache(extendedConfigCache, extendedConfigFilePath, toPath) {
        if (!extendedConfigCache.delete(extendedConfigFilePath))
          return;
        extendedConfigCache.forEach(function(_a, key) {
          var _b;
          var extendedResult = _a.extendedResult;
          if ((_b = extendedResult.extendedSourceFiles) === null || _b === void 0 ? void 0 : _b.some(function(extendedFile) {
            return toPath(extendedFile) === extendedConfigFilePath;
          })) {
            cleanExtendedConfigCache(extendedConfigCache, key, toPath);
          }
        });
      }
      ts3.cleanExtendedConfigCache = cleanExtendedConfigCache;
      function updatePackageJsonWatch(lookups, packageJsonWatches, createPackageJsonWatch) {
        var newMap = new ts3.Map(lookups);
        ts3.mutateMap(packageJsonWatches, newMap, {
          createNewValue: createPackageJsonWatch,
          onDeleteValue: ts3.closeFileWatcher
        });
      }
      ts3.updatePackageJsonWatch = updatePackageJsonWatch;
      function updateMissingFilePathsWatch(program2, missingFileWatches, createMissingFileWatch) {
        var missingFilePaths = program2.getMissingFilePaths();
        var newMissingFilePathMap = ts3.arrayToMap(missingFilePaths, ts3.identity, ts3.returnTrue);
        ts3.mutateMap(missingFileWatches, newMissingFilePathMap, {
          createNewValue: createMissingFileWatch,
          onDeleteValue: ts3.closeFileWatcher
        });
      }
      ts3.updateMissingFilePathsWatch = updateMissingFilePathsWatch;
      function updateWatchingWildcardDirectories(existingWatchedForWildcards, wildcardDirectories, watchDirectory) {
        ts3.mutateMap(existingWatchedForWildcards, wildcardDirectories, {
          createNewValue: createWildcardDirectoryWatcher,
          onDeleteValue: closeFileWatcherOf,
          onExistingValue: updateWildcardDirectoryWatcher
        });
        function createWildcardDirectoryWatcher(directory, flags) {
          return {
            watcher: watchDirectory(directory, flags),
            flags
          };
        }
        function updateWildcardDirectoryWatcher(existingWatcher, flags, directory) {
          if (existingWatcher.flags === flags) {
            return;
          }
          existingWatcher.watcher.close();
          existingWatchedForWildcards.set(directory, createWildcardDirectoryWatcher(directory, flags));
        }
      }
      ts3.updateWatchingWildcardDirectories = updateWatchingWildcardDirectories;
      function isIgnoredFileFromWildCardWatching(_a) {
        var watchedDirPath = _a.watchedDirPath, fileOrDirectory = _a.fileOrDirectory, fileOrDirectoryPath = _a.fileOrDirectoryPath, configFileName = _a.configFileName, options = _a.options, program2 = _a.program, extraFileExtensions = _a.extraFileExtensions, currentDirectory = _a.currentDirectory, useCaseSensitiveFileNames = _a.useCaseSensitiveFileNames, writeLog = _a.writeLog, toPath = _a.toPath;
        var newPath = ts3.removeIgnoredPath(fileOrDirectoryPath);
        if (!newPath) {
          writeLog("Project: ".concat(configFileName, " Detected ignored path: ").concat(fileOrDirectory));
          return true;
        }
        fileOrDirectoryPath = newPath;
        if (fileOrDirectoryPath === watchedDirPath)
          return false;
        if (ts3.hasExtension(fileOrDirectoryPath) && !ts3.isSupportedSourceFileName(fileOrDirectory, options, extraFileExtensions)) {
          writeLog("Project: ".concat(configFileName, " Detected file add/remove of non supported extension: ").concat(fileOrDirectory));
          return true;
        }
        if (ts3.isExcludedFile(fileOrDirectory, options.configFile.configFileSpecs, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), currentDirectory), useCaseSensitiveFileNames, currentDirectory)) {
          writeLog("Project: ".concat(configFileName, " Detected excluded file: ").concat(fileOrDirectory));
          return true;
        }
        if (!program2)
          return false;
        if (ts3.outFile(options) || options.outDir)
          return false;
        if (ts3.isDeclarationFileName(fileOrDirectoryPath)) {
          if (options.declarationDir)
            return false;
        } else if (!ts3.fileExtensionIsOneOf(fileOrDirectoryPath, ts3.supportedJSExtensionsFlat)) {
          return false;
        }
        var filePathWithoutExtension = ts3.removeFileExtension(fileOrDirectoryPath);
        var realProgram = ts3.isArray(program2) ? void 0 : isBuilderProgram(program2) ? program2.getProgramOrUndefined() : program2;
        var builderProgram = !realProgram && !ts3.isArray(program2) ? program2 : void 0;
        if (hasSourceFile(filePathWithoutExtension + ".ts") || hasSourceFile(filePathWithoutExtension + ".tsx")) {
          writeLog("Project: ".concat(configFileName, " Detected output file: ").concat(fileOrDirectory));
          return true;
        }
        return false;
        function hasSourceFile(file) {
          return realProgram ? !!realProgram.getSourceFileByPath(file) : builderProgram ? builderProgram.getState().fileInfos.has(file) : !!ts3.find(program2, function(rootFile) {
            return toPath(rootFile) === file;
          });
        }
      }
      ts3.isIgnoredFileFromWildCardWatching = isIgnoredFileFromWildCardWatching;
      function isBuilderProgram(program2) {
        return !!program2.getState;
      }
      function isEmittedFileOfProgram(program2, file) {
        if (!program2) {
          return false;
        }
        return program2.isEmittedFile(file);
      }
      ts3.isEmittedFileOfProgram = isEmittedFileOfProgram;
      var WatchLogLevel;
      (function(WatchLogLevel2) {
        WatchLogLevel2[WatchLogLevel2["None"] = 0] = "None";
        WatchLogLevel2[WatchLogLevel2["TriggerOnly"] = 1] = "TriggerOnly";
        WatchLogLevel2[WatchLogLevel2["Verbose"] = 2] = "Verbose";
      })(WatchLogLevel = ts3.WatchLogLevel || (ts3.WatchLogLevel = {}));
      function getWatchFactory(host, watchLogLevel, log, getDetailWatchInfo) {
        ts3.setSysLog(watchLogLevel === WatchLogLevel.Verbose ? log : ts3.noop);
        var plainInvokeFactory = {
          watchFile: function(file, callback, pollingInterval, options) {
            return host.watchFile(file, callback, pollingInterval, options);
          },
          watchDirectory: function(directory, callback, flags, options) {
            return host.watchDirectory(directory, callback, (flags & 1) !== 0, options);
          }
        };
        var triggerInvokingFactory = watchLogLevel !== WatchLogLevel.None ? {
          watchFile: createTriggerLoggingAddWatch("watchFile"),
          watchDirectory: createTriggerLoggingAddWatch("watchDirectory")
        } : void 0;
        var factory = watchLogLevel === WatchLogLevel.Verbose ? {
          watchFile: createFileWatcherWithLogging,
          watchDirectory: createDirectoryWatcherWithLogging
        } : triggerInvokingFactory || plainInvokeFactory;
        var excludeWatcherFactory = watchLogLevel === WatchLogLevel.Verbose ? createExcludeWatcherWithLogging : ts3.returnNoopFileWatcher;
        return {
          watchFile: createExcludeHandlingAddWatch("watchFile"),
          watchDirectory: createExcludeHandlingAddWatch("watchDirectory")
        };
        function createExcludeHandlingAddWatch(key) {
          return function(file, cb, flags, options, detailInfo1, detailInfo2) {
            var _a;
            return !ts3.matchesExclude(file, key === "watchFile" ? options === null || options === void 0 ? void 0 : options.excludeFiles : options === null || options === void 0 ? void 0 : options.excludeDirectories, useCaseSensitiveFileNames(), ((_a = host.getCurrentDirectory) === null || _a === void 0 ? void 0 : _a.call(host)) || "") ? factory[key].call(void 0, file, cb, flags, options, detailInfo1, detailInfo2) : excludeWatcherFactory(file, flags, options, detailInfo1, detailInfo2);
          };
        }
        function useCaseSensitiveFileNames() {
          return typeof host.useCaseSensitiveFileNames === "boolean" ? host.useCaseSensitiveFileNames : host.useCaseSensitiveFileNames();
        }
        function createExcludeWatcherWithLogging(file, flags, options, detailInfo1, detailInfo2) {
          log("ExcludeWatcher:: Added:: ".concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo)));
          return {
            close: function() {
              return log("ExcludeWatcher:: Close:: ".concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo)));
            }
          };
        }
        function createFileWatcherWithLogging(file, cb, flags, options, detailInfo1, detailInfo2) {
          log("FileWatcher:: Added:: ".concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo)));
          var watcher = triggerInvokingFactory.watchFile(file, cb, flags, options, detailInfo1, detailInfo2);
          return {
            close: function() {
              log("FileWatcher:: Close:: ".concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo)));
              watcher.close();
            }
          };
        }
        function createDirectoryWatcherWithLogging(file, cb, flags, options, detailInfo1, detailInfo2) {
          var watchInfo = "DirectoryWatcher:: Added:: ".concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
          log(watchInfo);
          var start = ts3.timestamp();
          var watcher = triggerInvokingFactory.watchDirectory(file, cb, flags, options, detailInfo1, detailInfo2);
          var elapsed = ts3.timestamp() - start;
          log("Elapsed:: ".concat(elapsed, "ms ").concat(watchInfo));
          return {
            close: function() {
              var watchInfo2 = "DirectoryWatcher:: Close:: ".concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
              log(watchInfo2);
              var start2 = ts3.timestamp();
              watcher.close();
              var elapsed2 = ts3.timestamp() - start2;
              log("Elapsed:: ".concat(elapsed2, "ms ").concat(watchInfo2));
            }
          };
        }
        function createTriggerLoggingAddWatch(key) {
          return function(file, cb, flags, options, detailInfo1, detailInfo2) {
            return plainInvokeFactory[key].call(void 0, file, function() {
              var args = [];
              for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
              }
              var triggerredInfo = "".concat(key === "watchFile" ? "FileWatcher" : "DirectoryWatcher", ":: Triggered with ").concat(args[0], " ").concat(args[1] !== void 0 ? args[1] : "", ":: ").concat(getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
              log(triggerredInfo);
              var start = ts3.timestamp();
              cb.call.apply(cb, __spreadArray([void 0], args, false));
              var elapsed = ts3.timestamp() - start;
              log("Elapsed:: ".concat(elapsed, "ms ").concat(triggerredInfo));
            }, flags, options, detailInfo1, detailInfo2);
          };
        }
        function getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2) {
          return "WatchInfo: ".concat(file, " ").concat(flags, " ").concat(JSON.stringify(options), " ").concat(getDetailWatchInfo2 ? getDetailWatchInfo2(detailInfo1, detailInfo2) : detailInfo2 === void 0 ? detailInfo1 : "".concat(detailInfo1, " ").concat(detailInfo2));
        }
      }
      ts3.getWatchFactory = getWatchFactory;
      function getFallbackOptions(options) {
        var fallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
        return {
          watchFile: fallbackPolling !== void 0 ? fallbackPolling : ts3.WatchFileKind.PriorityPollingInterval
        };
      }
      ts3.getFallbackOptions = getFallbackOptions;
      function closeFileWatcherOf(objWithWatcher) {
        objWithWatcher.watcher.close();
      }
      ts3.closeFileWatcherOf = closeFileWatcherOf;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function findConfigFile(searchPath, fileExists, configName) {
        if (configName === void 0) {
          configName = "tsconfig.json";
        }
        return ts3.forEachAncestorDirectory(searchPath, function(ancestor) {
          var fileName2 = ts3.combinePaths(ancestor, configName);
          return fileExists(fileName2) ? fileName2 : void 0;
        });
      }
      ts3.findConfigFile = findConfigFile;
      function resolveTripleslashReference(moduleName, containingFile) {
        var basePath = ts3.getDirectoryPath(containingFile);
        var referencedFileName = ts3.isRootedDiskPath(moduleName) ? moduleName : ts3.combinePaths(basePath, moduleName);
        return ts3.normalizePath(referencedFileName);
      }
      ts3.resolveTripleslashReference = resolveTripleslashReference;
      function computeCommonSourceDirectoryOfFilenames(fileNames, currentDirectory, getCanonicalFileName) {
        var commonPathComponents;
        var failed = ts3.forEach(fileNames, function(sourceFile) {
          var sourcePathComponents = ts3.getNormalizedPathComponents(sourceFile, currentDirectory);
          sourcePathComponents.pop();
          if (!commonPathComponents) {
            commonPathComponents = sourcePathComponents;
            return;
          }
          var n = Math.min(commonPathComponents.length, sourcePathComponents.length);
          for (var i = 0; i < n; i++) {
            if (getCanonicalFileName(commonPathComponents[i]) !== getCanonicalFileName(sourcePathComponents[i])) {
              if (i === 0) {
                return true;
              }
              commonPathComponents.length = i;
              break;
            }
          }
          if (sourcePathComponents.length < commonPathComponents.length) {
            commonPathComponents.length = sourcePathComponents.length;
          }
        });
        if (failed) {
          return "";
        }
        if (!commonPathComponents) {
          return currentDirectory;
        }
        return ts3.getPathFromPathComponents(commonPathComponents);
      }
      ts3.computeCommonSourceDirectoryOfFilenames = computeCommonSourceDirectoryOfFilenames;
      function createCompilerHost(options, setParentNodes) {
        return createCompilerHostWorker(options, setParentNodes);
      }
      ts3.createCompilerHost = createCompilerHost;
      function createCompilerHostWorker(options, setParentNodes, system) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var existingDirectories = new ts3.Map();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(system.useCaseSensitiveFileNames);
        var computeHash = ts3.maybeBind(system, system.createHash) || ts3.generateDjb2Hash;
        function getSourceFile(fileName2, languageVersionOrOptions, onError) {
          var text;
          try {
            ts3.performance.mark("beforeIORead");
            text = compilerHost.readFile(fileName2);
            ts3.performance.mark("afterIORead");
            ts3.performance.measure("I/O Read", "beforeIORead", "afterIORead");
          } catch (e) {
            if (onError) {
              onError(e.message);
            }
            text = "";
          }
          return text !== void 0 ? ts3.createSourceFile(fileName2, text, languageVersionOrOptions, setParentNodes) : void 0;
        }
        function directoryExists(directoryPath) {
          if (existingDirectories.has(directoryPath)) {
            return true;
          }
          if ((compilerHost.directoryExists || system.directoryExists)(directoryPath)) {
            existingDirectories.set(directoryPath, true);
            return true;
          }
          return false;
        }
        function writeFile(fileName2, data, writeByteOrderMark, onError) {
          try {
            ts3.performance.mark("beforeIOWrite");
            ts3.writeFileEnsuringDirectories(fileName2, data, writeByteOrderMark, function(path2, data2, writeByteOrderMark2) {
              return writeFileWorker(path2, data2, writeByteOrderMark2);
            }, function(path2) {
              return (compilerHost.createDirectory || system.createDirectory)(path2);
            }, function(path2) {
              return directoryExists(path2);
            });
            ts3.performance.mark("afterIOWrite");
            ts3.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
          } catch (e) {
            if (onError) {
              onError(e.message);
            }
          }
        }
        var outputFingerprints;
        function writeFileWorker(fileName2, data, writeByteOrderMark) {
          if (!ts3.isWatchSet(options) || !system.getModifiedTime) {
            system.writeFile(fileName2, data, writeByteOrderMark);
            return;
          }
          if (!outputFingerprints) {
            outputFingerprints = new ts3.Map();
          }
          var hash = computeHash(data);
          var mtimeBefore = system.getModifiedTime(fileName2);
          if (mtimeBefore) {
            var fingerprint = outputFingerprints.get(fileName2);
            if (fingerprint && fingerprint.byteOrderMark === writeByteOrderMark && fingerprint.hash === hash && fingerprint.mtime.getTime() === mtimeBefore.getTime()) {
              return;
            }
          }
          system.writeFile(fileName2, data, writeByteOrderMark);
          var mtimeAfter = system.getModifiedTime(fileName2) || ts3.missingFileModifiedTime;
          outputFingerprints.set(fileName2, {
            hash,
            byteOrderMark: writeByteOrderMark,
            mtime: mtimeAfter
          });
        }
        function getDefaultLibLocation() {
          return ts3.getDirectoryPath(ts3.normalizePath(system.getExecutingFilePath()));
        }
        var newLine = ts3.getNewLineCharacter(options, function() {
          return system.newLine;
        });
        var realpath = system.realpath && function(path2) {
          return system.realpath(path2);
        };
        var compilerHost = {
          getSourceFile,
          getDefaultLibLocation,
          getDefaultLibFileName: function(options2) {
            return ts3.combinePaths(getDefaultLibLocation(), ts3.getDefaultLibFileName(options2));
          },
          writeFile,
          getCurrentDirectory: ts3.memoize(function() {
            return system.getCurrentDirectory();
          }),
          useCaseSensitiveFileNames: function() {
            return system.useCaseSensitiveFileNames;
          },
          getCanonicalFileName,
          getNewLine: function() {
            return newLine;
          },
          fileExists: function(fileName2) {
            return system.fileExists(fileName2);
          },
          readFile: function(fileName2) {
            return system.readFile(fileName2);
          },
          trace: function(s) {
            return system.write(s + newLine);
          },
          directoryExists: function(directoryName) {
            return system.directoryExists(directoryName);
          },
          getEnvironmentVariable: function(name) {
            return system.getEnvironmentVariable ? system.getEnvironmentVariable(name) : "";
          },
          getDirectories: function(path2) {
            return system.getDirectories(path2);
          },
          realpath,
          readDirectory: function(path2, extensions, include, exclude, depth) {
            return system.readDirectory(path2, extensions, include, exclude, depth);
          },
          createDirectory: function(d) {
            return system.createDirectory(d);
          },
          createHash: ts3.maybeBind(system, system.createHash)
        };
        return compilerHost;
      }
      ts3.createCompilerHostWorker = createCompilerHostWorker;
      function changeCompilerHostLikeToUseCache(host, toPath, getSourceFile) {
        var originalReadFile = host.readFile;
        var originalFileExists = host.fileExists;
        var originalDirectoryExists = host.directoryExists;
        var originalCreateDirectory = host.createDirectory;
        var originalWriteFile = host.writeFile;
        var readFileCache = new ts3.Map();
        var fileExistsCache = new ts3.Map();
        var directoryExistsCache = new ts3.Map();
        var sourceFileCache = new ts3.Map();
        var readFileWithCache = function(fileName2) {
          var key = toPath(fileName2);
          var value = readFileCache.get(key);
          if (value !== void 0)
            return value !== false ? value : void 0;
          return setReadFileCache(key, fileName2);
        };
        var setReadFileCache = function(key, fileName2) {
          var newValue = originalReadFile.call(host, fileName2);
          readFileCache.set(key, newValue !== void 0 ? newValue : false);
          return newValue;
        };
        host.readFile = function(fileName2) {
          var key = toPath(fileName2);
          var value = readFileCache.get(key);
          if (value !== void 0)
            return value !== false ? value : void 0;
          if (!ts3.fileExtensionIs(fileName2, ".json") && !ts3.isBuildInfoFile(fileName2)) {
            return originalReadFile.call(host, fileName2);
          }
          return setReadFileCache(key, fileName2);
        };
        var getSourceFileWithCache = getSourceFile ? function(fileName2, languageVersion, onError, shouldCreateNewSourceFile) {
          var key = toPath(fileName2);
          var value = sourceFileCache.get(key);
          if (value)
            return value;
          var sourceFile = getSourceFile(fileName2, languageVersion, onError, shouldCreateNewSourceFile);
          if (sourceFile && (ts3.isDeclarationFileName(fileName2) || ts3.fileExtensionIs(fileName2, ".json"))) {
            sourceFileCache.set(key, sourceFile);
          }
          return sourceFile;
        } : void 0;
        host.fileExists = function(fileName2) {
          var key = toPath(fileName2);
          var value = fileExistsCache.get(key);
          if (value !== void 0)
            return value;
          var newValue = originalFileExists.call(host, fileName2);
          fileExistsCache.set(key, !!newValue);
          return newValue;
        };
        if (originalWriteFile) {
          host.writeFile = function(fileName2, data) {
            var rest = [];
            for (var _i = 2; _i < arguments.length; _i++) {
              rest[_i - 2] = arguments[_i];
            }
            var key = toPath(fileName2);
            fileExistsCache.delete(key);
            var value = readFileCache.get(key);
            if (value !== void 0 && value !== data) {
              readFileCache.delete(key);
              sourceFileCache.delete(key);
            } else if (getSourceFileWithCache) {
              var sourceFile = sourceFileCache.get(key);
              if (sourceFile && sourceFile.text !== data) {
                sourceFileCache.delete(key);
              }
            }
            originalWriteFile.call.apply(originalWriteFile, __spreadArray([host, fileName2, data], rest, false));
          };
        }
        if (originalDirectoryExists && originalCreateDirectory) {
          host.directoryExists = function(directory) {
            var key = toPath(directory);
            var value = directoryExistsCache.get(key);
            if (value !== void 0)
              return value;
            var newValue = originalDirectoryExists.call(host, directory);
            directoryExistsCache.set(key, !!newValue);
            return newValue;
          };
          host.createDirectory = function(directory) {
            var key = toPath(directory);
            directoryExistsCache.delete(key);
            originalCreateDirectory.call(host, directory);
          };
        }
        return {
          originalReadFile,
          originalFileExists,
          originalDirectoryExists,
          originalCreateDirectory,
          originalWriteFile,
          getSourceFileWithCache,
          readFileWithCache
        };
      }
      ts3.changeCompilerHostLikeToUseCache = changeCompilerHostLikeToUseCache;
      function getPreEmitDiagnostics(program2, sourceFile, cancellationToken) {
        var diagnostics;
        diagnostics = ts3.addRange(diagnostics, program2.getConfigFileParsingDiagnostics());
        diagnostics = ts3.addRange(diagnostics, program2.getOptionsDiagnostics(cancellationToken));
        diagnostics = ts3.addRange(diagnostics, program2.getSyntacticDiagnostics(sourceFile, cancellationToken));
        diagnostics = ts3.addRange(diagnostics, program2.getGlobalDiagnostics(cancellationToken));
        diagnostics = ts3.addRange(diagnostics, program2.getSemanticDiagnostics(sourceFile, cancellationToken));
        if (ts3.getEmitDeclarations(program2.getCompilerOptions())) {
          diagnostics = ts3.addRange(diagnostics, program2.getDeclarationDiagnostics(sourceFile, cancellationToken));
        }
        return ts3.sortAndDeduplicateDiagnostics(diagnostics || ts3.emptyArray);
      }
      ts3.getPreEmitDiagnostics = getPreEmitDiagnostics;
      function formatDiagnostics(diagnostics, host) {
        var output = "";
        for (var _i = 0, diagnostics_3 = diagnostics; _i < diagnostics_3.length; _i++) {
          var diagnostic = diagnostics_3[_i];
          output += formatDiagnostic(diagnostic, host);
        }
        return output;
      }
      ts3.formatDiagnostics = formatDiagnostics;
      function formatDiagnostic(diagnostic, host) {
        var errorMessage = "".concat(ts3.diagnosticCategoryName(diagnostic), " TS").concat(diagnostic.code, ": ").concat(flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine())).concat(host.getNewLine());
        if (diagnostic.file) {
          var _a = ts3.getLineAndCharacterOfPosition(diagnostic.file, diagnostic.start), line = _a.line, character = _a.character;
          var fileName2 = diagnostic.file.fileName;
          var relativeFileName = ts3.convertToRelativePath(fileName2, host.getCurrentDirectory(), function(fileName3) {
            return host.getCanonicalFileName(fileName3);
          });
          return "".concat(relativeFileName, "(").concat(line + 1, ",").concat(character + 1, "): ") + errorMessage;
        }
        return errorMessage;
      }
      ts3.formatDiagnostic = formatDiagnostic;
      var ForegroundColorEscapeSequences;
      (function(ForegroundColorEscapeSequences2) {
        ForegroundColorEscapeSequences2["Grey"] = "\x1B[90m";
        ForegroundColorEscapeSequences2["Red"] = "\x1B[91m";
        ForegroundColorEscapeSequences2["Yellow"] = "\x1B[93m";
        ForegroundColorEscapeSequences2["Blue"] = "\x1B[94m";
        ForegroundColorEscapeSequences2["Cyan"] = "\x1B[96m";
      })(ForegroundColorEscapeSequences = ts3.ForegroundColorEscapeSequences || (ts3.ForegroundColorEscapeSequences = {}));
      var gutterStyleSequence = "\x1B[7m";
      var gutterSeparator = " ";
      var resetEscapeSequence = "\x1B[0m";
      var ellipsis = "...";
      var halfIndent = "  ";
      var indent = "    ";
      function getCategoryFormat(category) {
        switch (category) {
          case ts3.DiagnosticCategory.Error:
            return ForegroundColorEscapeSequences.Red;
          case ts3.DiagnosticCategory.Warning:
            return ForegroundColorEscapeSequences.Yellow;
          case ts3.DiagnosticCategory.Suggestion:
            return ts3.Debug.fail("Should never get an Info diagnostic on the command line.");
          case ts3.DiagnosticCategory.Message:
            return ForegroundColorEscapeSequences.Blue;
        }
      }
      function formatColorAndReset(text, formatStyle) {
        return formatStyle + text + resetEscapeSequence;
      }
      ts3.formatColorAndReset = formatColorAndReset;
      function formatCodeSpan(file, start, length, indent2, squiggleColor, host) {
        var _a = ts3.getLineAndCharacterOfPosition(file, start), firstLine = _a.line, firstLineChar = _a.character;
        var _b = ts3.getLineAndCharacterOfPosition(file, start + length), lastLine = _b.line, lastLineChar = _b.character;
        var lastLineInFile = ts3.getLineAndCharacterOfPosition(file, file.text.length).line;
        var hasMoreThanFiveLines = lastLine - firstLine >= 4;
        var gutterWidth = (lastLine + 1 + "").length;
        if (hasMoreThanFiveLines) {
          gutterWidth = Math.max(ellipsis.length, gutterWidth);
        }
        var context = "";
        for (var i = firstLine; i <= lastLine; i++) {
          context += host.getNewLine();
          if (hasMoreThanFiveLines && firstLine + 1 < i && i < lastLine - 1) {
            context += indent2 + formatColorAndReset(ts3.padLeft(ellipsis, gutterWidth), gutterStyleSequence) + gutterSeparator + host.getNewLine();
            i = lastLine - 1;
          }
          var lineStart = ts3.getPositionOfLineAndCharacter(file, i, 0);
          var lineEnd = i < lastLineInFile ? ts3.getPositionOfLineAndCharacter(file, i + 1, 0) : file.text.length;
          var lineContent = file.text.slice(lineStart, lineEnd);
          lineContent = ts3.trimStringEnd(lineContent);
          lineContent = lineContent.replace(/\t/g, " ");
          context += indent2 + formatColorAndReset(ts3.padLeft(i + 1 + "", gutterWidth), gutterStyleSequence) + gutterSeparator;
          context += lineContent + host.getNewLine();
          context += indent2 + formatColorAndReset(ts3.padLeft("", gutterWidth), gutterStyleSequence) + gutterSeparator;
          context += squiggleColor;
          if (i === firstLine) {
            var lastCharForLine = i === lastLine ? lastLineChar : void 0;
            context += lineContent.slice(0, firstLineChar).replace(/\S/g, " ");
            context += lineContent.slice(firstLineChar, lastCharForLine).replace(/./g, "~");
          } else if (i === lastLine) {
            context += lineContent.slice(0, lastLineChar).replace(/./g, "~");
          } else {
            context += lineContent.replace(/./g, "~");
          }
          context += resetEscapeSequence;
        }
        return context;
      }
      function formatLocation(file, start, host, color) {
        if (color === void 0) {
          color = formatColorAndReset;
        }
        var _a = ts3.getLineAndCharacterOfPosition(file, start), firstLine = _a.line, firstLineChar = _a.character;
        var relativeFileName = host ? ts3.convertToRelativePath(file.fileName, host.getCurrentDirectory(), function(fileName2) {
          return host.getCanonicalFileName(fileName2);
        }) : file.fileName;
        var output = "";
        output += color(relativeFileName, ForegroundColorEscapeSequences.Cyan);
        output += ":";
        output += color("".concat(firstLine + 1), ForegroundColorEscapeSequences.Yellow);
        output += ":";
        output += color("".concat(firstLineChar + 1), ForegroundColorEscapeSequences.Yellow);
        return output;
      }
      ts3.formatLocation = formatLocation;
      function formatDiagnosticsWithColorAndContext(diagnostics, host) {
        var output = "";
        for (var _i = 0, diagnostics_4 = diagnostics; _i < diagnostics_4.length; _i++) {
          var diagnostic = diagnostics_4[_i];
          if (diagnostic.file) {
            var file = diagnostic.file, start = diagnostic.start;
            output += formatLocation(file, start, host);
            output += " - ";
          }
          output += formatColorAndReset(ts3.diagnosticCategoryName(diagnostic), getCategoryFormat(diagnostic.category));
          output += formatColorAndReset(" TS".concat(diagnostic.code, ": "), ForegroundColorEscapeSequences.Grey);
          output += flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine());
          if (diagnostic.file) {
            output += host.getNewLine();
            output += formatCodeSpan(diagnostic.file, diagnostic.start, diagnostic.length, "", getCategoryFormat(diagnostic.category), host);
          }
          if (diagnostic.relatedInformation) {
            output += host.getNewLine();
            for (var _a = 0, _b = diagnostic.relatedInformation; _a < _b.length; _a++) {
              var _c = _b[_a], file = _c.file, start = _c.start, length_9 = _c.length, messageText = _c.messageText;
              if (file) {
                output += host.getNewLine();
                output += halfIndent + formatLocation(file, start, host);
                output += formatCodeSpan(file, start, length_9, indent, ForegroundColorEscapeSequences.Cyan, host);
              }
              output += host.getNewLine();
              output += indent + flattenDiagnosticMessageText(messageText, host.getNewLine());
            }
          }
          output += host.getNewLine();
        }
        return output;
      }
      ts3.formatDiagnosticsWithColorAndContext = formatDiagnosticsWithColorAndContext;
      function flattenDiagnosticMessageText(diag, newLine, indent2) {
        if (indent2 === void 0) {
          indent2 = 0;
        }
        if (ts3.isString(diag)) {
          return diag;
        } else if (diag === void 0) {
          return "";
        }
        var result2 = "";
        if (indent2) {
          result2 += newLine;
          for (var i = 0; i < indent2; i++) {
            result2 += "  ";
          }
        }
        result2 += diag.messageText;
        indent2++;
        if (diag.next) {
          for (var _i = 0, _a = diag.next; _i < _a.length; _i++) {
            var kid = _a[_i];
            result2 += flattenDiagnosticMessageText(kid, newLine, indent2);
          }
        }
        return result2;
      }
      ts3.flattenDiagnosticMessageText = flattenDiagnosticMessageText;
      function loadWithTypeDirectiveCache(names, containingFile, redirectedReference, containingFileMode, loader2) {
        if (names.length === 0) {
          return [];
        }
        var resolutions = [];
        var cache = new ts3.Map();
        for (var _i = 0, names_2 = names; _i < names_2.length; _i++) {
          var name = names_2[_i];
          var result2 = void 0;
          var mode = getModeForFileReference(name, containingFileMode);
          var strName = ts3.isString(name) ? name : name.fileName.toLowerCase();
          var cacheKey = mode !== void 0 ? "".concat(mode, "|").concat(strName) : strName;
          if (cache.has(cacheKey)) {
            result2 = cache.get(cacheKey);
          } else {
            cache.set(cacheKey, result2 = loader2(strName, containingFile, redirectedReference, mode));
          }
          resolutions.push(result2);
        }
        return resolutions;
      }
      ts3.loadWithTypeDirectiveCache = loadWithTypeDirectiveCache;
      ;
      function getModeForFileReference(ref, containingFileMode) {
        return (ts3.isString(ref) ? containingFileMode : ref.resolutionMode) || containingFileMode;
      }
      ts3.getModeForFileReference = getModeForFileReference;
      function getModeForResolutionAtIndex(file, index) {
        if (file.impliedNodeFormat === void 0)
          return void 0;
        return getModeForUsageLocation(file, getModuleNameStringLiteralAt(file, index));
      }
      ts3.getModeForResolutionAtIndex = getModeForResolutionAtIndex;
      function isExclusivelyTypeOnlyImportOrExport(decl) {
        var _a;
        if (ts3.isExportDeclaration(decl)) {
          return decl.isTypeOnly;
        }
        if ((_a = decl.importClause) === null || _a === void 0 ? void 0 : _a.isTypeOnly) {
          return true;
        }
        return false;
      }
      ts3.isExclusivelyTypeOnlyImportOrExport = isExclusivelyTypeOnlyImportOrExport;
      function getModeForUsageLocation(file, usage) {
        var _a, _b;
        if (file.impliedNodeFormat === void 0)
          return void 0;
        if (ts3.isImportDeclaration(usage.parent) || ts3.isExportDeclaration(usage.parent)) {
          var isTypeOnly = isExclusivelyTypeOnlyImportOrExport(usage.parent);
          if (isTypeOnly) {
            var override = getResolutionModeOverrideForClause(usage.parent.assertClause);
            if (override) {
              return override;
            }
          }
        }
        if (usage.parent.parent && ts3.isImportTypeNode(usage.parent.parent)) {
          var override = getResolutionModeOverrideForClause((_a = usage.parent.parent.assertions) === null || _a === void 0 ? void 0 : _a.assertClause);
          if (override) {
            return override;
          }
        }
        if (file.impliedNodeFormat !== ts3.ModuleKind.ESNext) {
          return ts3.isImportCall(ts3.walkUpParenthesizedExpressions(usage.parent)) ? ts3.ModuleKind.ESNext : ts3.ModuleKind.CommonJS;
        }
        var exprParentParent = (_b = ts3.walkUpParenthesizedExpressions(usage.parent)) === null || _b === void 0 ? void 0 : _b.parent;
        return exprParentParent && ts3.isImportEqualsDeclaration(exprParentParent) ? ts3.ModuleKind.CommonJS : ts3.ModuleKind.ESNext;
      }
      ts3.getModeForUsageLocation = getModeForUsageLocation;
      function getResolutionModeOverrideForClause(clause, grammarErrorOnNode) {
        if (!clause)
          return void 0;
        if (ts3.length(clause.elements) !== 1) {
          grammarErrorOnNode === null || grammarErrorOnNode === void 0 ? void 0 : grammarErrorOnNode(clause, ts3.Diagnostics.Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require);
          return void 0;
        }
        var elem = clause.elements[0];
        if (!ts3.isStringLiteralLike(elem.name))
          return void 0;
        if (elem.name.text !== "resolution-mode") {
          grammarErrorOnNode === null || grammarErrorOnNode === void 0 ? void 0 : grammarErrorOnNode(elem.name, ts3.Diagnostics.resolution_mode_is_the_only_valid_key_for_type_import_assertions);
          return void 0;
        }
        if (!ts3.isStringLiteralLike(elem.value))
          return void 0;
        if (elem.value.text !== "import" && elem.value.text !== "require") {
          grammarErrorOnNode === null || grammarErrorOnNode === void 0 ? void 0 : grammarErrorOnNode(elem.value, ts3.Diagnostics.resolution_mode_should_be_either_require_or_import);
          return void 0;
        }
        return elem.value.text === "import" ? ts3.ModuleKind.ESNext : ts3.ModuleKind.CommonJS;
      }
      ts3.getResolutionModeOverrideForClause = getResolutionModeOverrideForClause;
      function loadWithModeAwareCache(names, containingFile, containingFileName, redirectedReference, loader2) {
        if (names.length === 0) {
          return [];
        }
        var resolutions = [];
        var cache = new ts3.Map();
        var i = 0;
        for (var _i = 0, names_3 = names; _i < names_3.length; _i++) {
          var name = names_3[_i];
          var result2 = void 0;
          var mode = getModeForResolutionAtIndex(containingFile, i);
          i++;
          var cacheKey = mode !== void 0 ? "".concat(mode, "|").concat(name) : name;
          if (cache.has(cacheKey)) {
            result2 = cache.get(cacheKey);
          } else {
            cache.set(cacheKey, result2 = loader2(name, mode, containingFileName, redirectedReference));
          }
          resolutions.push(result2);
        }
        return resolutions;
      }
      ts3.loadWithModeAwareCache = loadWithModeAwareCache;
      function forEachResolvedProjectReference(resolvedProjectReferences, cb) {
        return forEachProjectReference(void 0, resolvedProjectReferences, function(resolvedRef, parent) {
          return resolvedRef && cb(resolvedRef, parent);
        });
      }
      ts3.forEachResolvedProjectReference = forEachResolvedProjectReference;
      function forEachProjectReference(projectReferences, resolvedProjectReferences, cbResolvedRef, cbRef) {
        var seenResolvedRefs;
        return worker(projectReferences, resolvedProjectReferences, void 0);
        function worker(projectReferences2, resolvedProjectReferences2, parent) {
          if (cbRef) {
            var result2 = cbRef(projectReferences2, parent);
            if (result2)
              return result2;
          }
          return ts3.forEach(resolvedProjectReferences2, function(resolvedRef, index) {
            if (resolvedRef && (seenResolvedRefs === null || seenResolvedRefs === void 0 ? void 0 : seenResolvedRefs.has(resolvedRef.sourceFile.path))) {
              return void 0;
            }
            var result3 = cbResolvedRef(resolvedRef, parent, index);
            if (result3 || !resolvedRef)
              return result3;
            (seenResolvedRefs || (seenResolvedRefs = new ts3.Set())).add(resolvedRef.sourceFile.path);
            return worker(resolvedRef.commandLine.projectReferences, resolvedRef.references, resolvedRef);
          });
        }
      }
      ts3.inferredTypesContainingFile = "__inferred type names__.ts";
      function isReferencedFile(reason) {
        switch (reason === null || reason === void 0 ? void 0 : reason.kind) {
          case ts3.FileIncludeKind.Import:
          case ts3.FileIncludeKind.ReferenceFile:
          case ts3.FileIncludeKind.TypeReferenceDirective:
          case ts3.FileIncludeKind.LibReferenceDirective:
            return true;
          default:
            return false;
        }
      }
      ts3.isReferencedFile = isReferencedFile;
      function isReferenceFileLocation(location) {
        return location.pos !== void 0;
      }
      ts3.isReferenceFileLocation = isReferenceFileLocation;
      function getReferencedFileLocation(getSourceFileByPath, ref) {
        var _a, _b, _c;
        var _d, _e, _f, _g;
        var file = ts3.Debug.checkDefined(getSourceFileByPath(ref.file));
        var kind = ref.kind, index = ref.index;
        var pos, end, packageId, resolutionMode;
        switch (kind) {
          case ts3.FileIncludeKind.Import:
            var importLiteral = getModuleNameStringLiteralAt(file, index);
            packageId = (_e = (_d = file.resolvedModules) === null || _d === void 0 ? void 0 : _d.get(importLiteral.text, getModeForResolutionAtIndex(file, index))) === null || _e === void 0 ? void 0 : _e.packageId;
            if (importLiteral.pos === -1)
              return { file, packageId, text: importLiteral.text };
            pos = ts3.skipTrivia(file.text, importLiteral.pos);
            end = importLiteral.end;
            break;
          case ts3.FileIncludeKind.ReferenceFile:
            _a = file.referencedFiles[index], pos = _a.pos, end = _a.end;
            break;
          case ts3.FileIncludeKind.TypeReferenceDirective:
            _b = file.typeReferenceDirectives[index], pos = _b.pos, end = _b.end, resolutionMode = _b.resolutionMode;
            packageId = (_g = (_f = file.resolvedTypeReferenceDirectiveNames) === null || _f === void 0 ? void 0 : _f.get(ts3.toFileNameLowerCase(file.typeReferenceDirectives[index].fileName), resolutionMode || file.impliedNodeFormat)) === null || _g === void 0 ? void 0 : _g.packageId;
            break;
          case ts3.FileIncludeKind.LibReferenceDirective:
            _c = file.libReferenceDirectives[index], pos = _c.pos, end = _c.end;
            break;
          default:
            return ts3.Debug.assertNever(kind);
        }
        return { file, pos, end, packageId };
      }
      ts3.getReferencedFileLocation = getReferencedFileLocation;
      function isProgramUptoDate(program2, rootFileNames, newOptions, getSourceVersion, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences) {
        if (!program2 || (hasChangedAutomaticTypeDirectiveNames === null || hasChangedAutomaticTypeDirectiveNames === void 0 ? void 0 : hasChangedAutomaticTypeDirectiveNames()))
          return false;
        if (!ts3.arrayIsEqualTo(program2.getRootFileNames(), rootFileNames))
          return false;
        var seenResolvedRefs;
        if (!ts3.arrayIsEqualTo(program2.getProjectReferences(), projectReferences, projectReferenceUptoDate))
          return false;
        if (program2.getSourceFiles().some(sourceFileNotUptoDate))
          return false;
        if (program2.getMissingFilePaths().some(fileExists))
          return false;
        var currentOptions = program2.getCompilerOptions();
        if (!ts3.compareDataObjects(currentOptions, newOptions))
          return false;
        if (currentOptions.configFile && newOptions.configFile)
          return currentOptions.configFile.text === newOptions.configFile.text;
        return true;
        function sourceFileNotUptoDate(sourceFile) {
          return !sourceFileVersionUptoDate(sourceFile) || hasInvalidatedResolution(sourceFile.path);
        }
        function sourceFileVersionUptoDate(sourceFile) {
          return sourceFile.version === getSourceVersion(sourceFile.resolvedPath, sourceFile.fileName);
        }
        function projectReferenceUptoDate(oldRef, newRef, index) {
          return ts3.projectReferenceIsEqualTo(oldRef, newRef) && resolvedProjectReferenceUptoDate(program2.getResolvedProjectReferences()[index], oldRef);
        }
        function resolvedProjectReferenceUptoDate(oldResolvedRef, oldRef) {
          if (oldResolvedRef) {
            if (ts3.contains(seenResolvedRefs, oldResolvedRef))
              return true;
            var refPath_1 = resolveProjectReferencePath(oldRef);
            var newParsedCommandLine = getParsedCommandLine(refPath_1);
            if (!newParsedCommandLine)
              return false;
            if (oldResolvedRef.commandLine.options.configFile !== newParsedCommandLine.options.configFile)
              return false;
            if (!ts3.arrayIsEqualTo(oldResolvedRef.commandLine.fileNames, newParsedCommandLine.fileNames))
              return false;
            (seenResolvedRefs || (seenResolvedRefs = [])).push(oldResolvedRef);
            return !ts3.forEach(oldResolvedRef.references, function(childResolvedRef, index) {
              return !resolvedProjectReferenceUptoDate(childResolvedRef, oldResolvedRef.commandLine.projectReferences[index]);
            });
          }
          var refPath = resolveProjectReferencePath(oldRef);
          return !getParsedCommandLine(refPath);
        }
      }
      ts3.isProgramUptoDate = isProgramUptoDate;
      function getConfigFileParsingDiagnostics(configFileParseResult) {
        return configFileParseResult.options.configFile ? __spreadArray(__spreadArray([], configFileParseResult.options.configFile.parseDiagnostics, true), configFileParseResult.errors, true) : configFileParseResult.errors;
      }
      ts3.getConfigFileParsingDiagnostics = getConfigFileParsingDiagnostics;
      function getImpliedNodeFormatForFile(fileName2, packageJsonInfoCache, host, options) {
        switch (ts3.getEmitModuleResolutionKind(options)) {
          case ts3.ModuleResolutionKind.Node16:
          case ts3.ModuleResolutionKind.NodeNext:
            return ts3.fileExtensionIsOneOf(fileName2, [".d.mts", ".mts", ".mjs"]) ? ts3.ModuleKind.ESNext : ts3.fileExtensionIsOneOf(fileName2, [".d.cts", ".cts", ".cjs"]) ? ts3.ModuleKind.CommonJS : ts3.fileExtensionIsOneOf(fileName2, [".d.ts", ".ts", ".tsx", ".js", ".jsx"]) ? lookupFromPackageJson() : void 0;
          default:
            return void 0;
        }
        function lookupFromPackageJson() {
          var scope = ts3.getPackageScopeForPath(fileName2, packageJsonInfoCache, host, options);
          return (scope === null || scope === void 0 ? void 0 : scope.packageJsonContent.type) === "module" ? ts3.ModuleKind.ESNext : ts3.ModuleKind.CommonJS;
        }
      }
      ts3.getImpliedNodeFormatForFile = getImpliedNodeFormatForFile;
      ts3.plainJSErrors = new ts3.Set([
        ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0.code,
        ts3.Diagnostics.A_module_cannot_have_multiple_default_exports.code,
        ts3.Diagnostics.Another_export_default_is_here.code,
        ts3.Diagnostics.The_first_export_default_is_here.code,
        ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module.code,
        ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode.code,
        ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here.code,
        ts3.Diagnostics.constructor_is_a_reserved_word.code,
        ts3.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode.code,
        ts3.Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode.code,
        ts3.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode.code,
        ts3.Diagnostics.Invalid_use_of_0_in_strict_mode.code,
        ts3.Diagnostics.A_label_is_not_allowed_here.code,
        ts3.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode.code,
        ts3.Diagnostics.with_statements_are_not_allowed_in_strict_mode.code,
        ts3.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement.code,
        ts3.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement.code,
        ts3.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name.code,
        ts3.Diagnostics.A_class_member_cannot_have_the_0_keyword.code,
        ts3.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name.code,
        ts3.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement.code,
        ts3.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,
        ts3.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,
        ts3.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement.code,
        ts3.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration.code,
        ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context.code,
        ts3.Diagnostics.A_destructuring_declaration_must_have_an_initializer.code,
        ts3.Diagnostics.A_get_accessor_cannot_have_parameters.code,
        ts3.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern.code,
        ts3.Diagnostics.A_rest_element_cannot_have_a_property_name.code,
        ts3.Diagnostics.A_rest_element_cannot_have_an_initializer.code,
        ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern.code,
        ts3.Diagnostics.A_rest_parameter_cannot_have_an_initializer.code,
        ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list.code,
        ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma.code,
        ts3.Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block.code,
        ts3.Diagnostics.A_set_accessor_cannot_have_rest_parameter.code,
        ts3.Diagnostics.A_set_accessor_must_have_exactly_one_parameter.code,
        ts3.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module.code,
        ts3.Diagnostics.An_export_declaration_cannot_have_modifiers.code,
        ts3.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module.code,
        ts3.Diagnostics.An_import_declaration_cannot_have_modifiers.code,
        ts3.Diagnostics.An_object_member_cannot_be_declared_optional.code,
        ts3.Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element.code,
        ts3.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable.code,
        ts3.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause.code,
        ts3.Diagnostics.Catch_clause_variable_cannot_have_an_initializer.code,
        ts3.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator.code,
        ts3.Diagnostics.Classes_can_only_extend_a_single_class.code,
        ts3.Diagnostics.Classes_may_not_have_a_field_named_constructor.code,
        ts3.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code,
        ts3.Diagnostics.Duplicate_label_0.code,
        ts3.Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments.code,
        ts3.Diagnostics.For_await_loops_cannot_be_used_inside_a_class_static_block.code,
        ts3.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression.code,
        ts3.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name.code,
        ts3.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array.code,
        ts3.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names.code,
        ts3.Diagnostics.Jump_target_cannot_cross_function_boundary.code,
        ts3.Diagnostics.Line_terminator_not_permitted_before_arrow.code,
        ts3.Diagnostics.Modifiers_cannot_appear_here.code,
        ts3.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement.code,
        ts3.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement.code,
        ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies.code,
        ts3.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,
        ts3.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier.code,
        ts3.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain.code,
        ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async.code,
        ts3.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer.code,
        ts3.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer.code,
        ts3.Diagnostics.Trailing_comma_not_allowed.code,
        ts3.Diagnostics.Variable_declaration_list_cannot_be_empty.code,
        ts3.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses.code,
        ts3.Diagnostics._0_expected.code,
        ts3.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2.code,
        ts3.Diagnostics._0_list_cannot_be_empty.code,
        ts3.Diagnostics._0_modifier_already_seen.code,
        ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration.code,
        ts3.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element.code,
        ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter.code,
        ts3.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind.code,
        ts3.Diagnostics._0_modifier_cannot_be_used_here.code,
        ts3.Diagnostics._0_modifier_must_precede_1_modifier.code,
        ts3.Diagnostics.const_declarations_can_only_be_declared_inside_a_block.code,
        ts3.Diagnostics.const_declarations_must_be_initialized.code,
        ts3.Diagnostics.extends_clause_already_seen.code,
        ts3.Diagnostics.let_declarations_can_only_be_declared_inside_a_block.code,
        ts3.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations.code
      ]);
      function shouldProgramCreateNewSourceFiles(program2, newOptions) {
        if (!program2)
          return false;
        return ts3.optionsHaveChanges(program2.getCompilerOptions(), newOptions, ts3.sourceFileAffectingCompilerOptions);
      }
      function createCreateProgramOptions(rootNames, options, host, oldProgram, configFileParsingDiagnostics) {
        return {
          rootNames,
          options,
          host,
          oldProgram,
          configFileParsingDiagnostics
        };
      }
      function createProgram(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) {
        var _a, _b, _c, _d;
        var createProgramOptions = ts3.isArray(rootNamesOrOptions) ? createCreateProgramOptions(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) : rootNamesOrOptions;
        var rootNames = createProgramOptions.rootNames, options = createProgramOptions.options, configFileParsingDiagnostics = createProgramOptions.configFileParsingDiagnostics, projectReferences = createProgramOptions.projectReferences;
        var oldProgram = createProgramOptions.oldProgram;
        var processingDefaultLibFiles;
        var processingOtherFiles;
        var files;
        var symlinks;
        var commonSourceDirectory;
        var typeChecker;
        var classifiableNames;
        var ambientModuleNameToUnmodifiedFileName = new ts3.Map();
        var fileReasons = ts3.createMultiMap();
        var cachedBindAndCheckDiagnosticsForFile = {};
        var cachedDeclarationDiagnosticsForFile = {};
        var resolvedTypeReferenceDirectives = ts3.createModeAwareCache();
        var fileProcessingDiagnostics;
        var maxNodeModuleJsDepth = typeof options.maxNodeModuleJsDepth === "number" ? options.maxNodeModuleJsDepth : 0;
        var currentNodeModulesDepth = 0;
        var modulesWithElidedImports = new ts3.Map();
        var sourceFilesFoundSearchingNodeModules = new ts3.Map();
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "createProgram", { configFilePath: options.configFilePath, rootDir: options.rootDir }, true);
        ts3.performance.mark("beforeProgram");
        var host = createProgramOptions.host || createCompilerHost(options);
        var configParsingHost = parseConfigHostFromCompilerHostLike(host);
        var skipDefaultLib = options.noLib;
        var getDefaultLibraryFileName = ts3.memoize(function() {
          return host.getDefaultLibFileName(options);
        });
        var defaultLibraryPath = host.getDefaultLibLocation ? host.getDefaultLibLocation() : ts3.getDirectoryPath(getDefaultLibraryFileName());
        var programDiagnostics = ts3.createDiagnosticCollection();
        var currentDirectory = host.getCurrentDirectory();
        var supportedExtensions = ts3.getSupportedExtensions(options);
        var supportedExtensionsWithJsonIfResolveJsonModule = ts3.getSupportedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
        var hasEmitBlockingDiagnostics = new ts3.Map();
        var _compilerOptionsObjectLiteralSyntax;
        var moduleResolutionCache;
        var typeReferenceDirectiveResolutionCache;
        var actualResolveModuleNamesWorker;
        var hasInvalidatedResolution = host.hasInvalidatedResolution || ts3.returnFalse;
        if (host.resolveModuleNames) {
          actualResolveModuleNamesWorker = function(moduleNames, containingFile, containingFileName, reusedNames, redirectedReference) {
            return host.resolveModuleNames(ts3.Debug.checkEachDefined(moduleNames), containingFileName, reusedNames, redirectedReference, options, containingFile).map(function(resolved) {
              if (!resolved || resolved.extension !== void 0) {
                return resolved;
              }
              var withExtension = ts3.clone(resolved);
              withExtension.extension = ts3.extensionFromPath(resolved.resolvedFileName);
              return withExtension;
            });
          };
          moduleResolutionCache = (_a = host.getModuleResolutionCache) === null || _a === void 0 ? void 0 : _a.call(host);
        } else {
          moduleResolutionCache = ts3.createModuleResolutionCache(currentDirectory, getCanonicalFileName, options);
          var loader_1 = function(moduleName, resolverMode, containingFileName, redirectedReference) {
            return ts3.resolveModuleName(moduleName, containingFileName, options, host, moduleResolutionCache, redirectedReference, resolverMode).resolvedModule;
          };
          actualResolveModuleNamesWorker = function(moduleNames, containingFile, containingFileName, _reusedNames, redirectedReference) {
            return loadWithModeAwareCache(ts3.Debug.checkEachDefined(moduleNames), containingFile, containingFileName, redirectedReference, loader_1);
          };
        }
        var actualResolveTypeReferenceDirectiveNamesWorker;
        if (host.resolveTypeReferenceDirectives) {
          actualResolveTypeReferenceDirectiveNamesWorker = function(typeDirectiveNames, containingFile, redirectedReference, containingFileMode) {
            return host.resolveTypeReferenceDirectives(ts3.Debug.checkEachDefined(typeDirectiveNames), containingFile, redirectedReference, options, containingFileMode);
          };
        } else {
          typeReferenceDirectiveResolutionCache = ts3.createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, void 0, moduleResolutionCache === null || moduleResolutionCache === void 0 ? void 0 : moduleResolutionCache.getPackageJsonInfoCache());
          var loader_2 = function(typesRef, containingFile, redirectedReference, resolutionMode) {
            return ts3.resolveTypeReferenceDirective(typesRef, containingFile, options, host, redirectedReference, typeReferenceDirectiveResolutionCache, resolutionMode).resolvedTypeReferenceDirective;
          };
          actualResolveTypeReferenceDirectiveNamesWorker = function(typeReferenceDirectiveNames, containingFile, redirectedReference, containingFileMode) {
            return loadWithTypeDirectiveCache(ts3.Debug.checkEachDefined(typeReferenceDirectiveNames), containingFile, redirectedReference, containingFileMode, loader_2);
          };
        }
        var packageIdToSourceFile = new ts3.Map();
        var sourceFileToPackageName = new ts3.Map();
        var redirectTargetsMap = ts3.createMultiMap();
        var usesUriStyleNodeCoreModules = false;
        var filesByName = new ts3.Map();
        var missingFilePaths;
        var filesByNameIgnoreCase = host.useCaseSensitiveFileNames() ? new ts3.Map() : void 0;
        var resolvedProjectReferences;
        var projectReferenceRedirects;
        var mapFromFileToProjectReferenceRedirects;
        var mapFromToProjectReferenceRedirectSource;
        var useSourceOfProjectReferenceRedirect = !!((_b = host.useSourceOfProjectReferenceRedirect) === null || _b === void 0 ? void 0 : _b.call(host)) && !options.disableSourceOfProjectReferenceRedirect;
        var _e = updateHostForUseSourceOfProjectReferenceRedirect({
          compilerHost: host,
          getSymlinkCache,
          useSourceOfProjectReferenceRedirect,
          toPath,
          getResolvedProjectReferences,
          getSourceOfProjectReferenceRedirect,
          forEachResolvedProjectReference: forEachResolvedProjectReference2
        }), onProgramCreateComplete = _e.onProgramCreateComplete, fileExists = _e.fileExists, directoryExists = _e.directoryExists;
        var readFile = host.readFile.bind(host);
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "shouldProgramCreateNewSourceFiles", { hasOldProgram: !!oldProgram });
        var shouldCreateNewSourceFile = shouldProgramCreateNewSourceFiles(oldProgram, options);
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        var structureIsReused;
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "tryReuseStructureFromOldProgram", {});
        structureIsReused = tryReuseStructureFromOldProgram();
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        if (structureIsReused !== 2) {
          processingDefaultLibFiles = [];
          processingOtherFiles = [];
          if (projectReferences) {
            if (!resolvedProjectReferences) {
              resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
            }
            if (rootNames.length) {
              resolvedProjectReferences === null || resolvedProjectReferences === void 0 ? void 0 : resolvedProjectReferences.forEach(function(parsedRef, index) {
                if (!parsedRef)
                  return;
                var out = ts3.outFile(parsedRef.commandLine.options);
                if (useSourceOfProjectReferenceRedirect) {
                  if (out || ts3.getEmitModuleKind(parsedRef.commandLine.options) === ts3.ModuleKind.None) {
                    for (var _i2 = 0, _a2 = parsedRef.commandLine.fileNames; _i2 < _a2.length; _i2++) {
                      var fileName2 = _a2[_i2];
                      processProjectReferenceFile(fileName2, { kind: ts3.FileIncludeKind.SourceFromProjectReference, index });
                    }
                  }
                } else {
                  if (out) {
                    processProjectReferenceFile(ts3.changeExtension(out, ".d.ts"), { kind: ts3.FileIncludeKind.OutputFromProjectReference, index });
                  } else if (ts3.getEmitModuleKind(parsedRef.commandLine.options) === ts3.ModuleKind.None) {
                    var getCommonSourceDirectory_2 = ts3.memoize(function() {
                      return ts3.getCommonSourceDirectoryOfConfig(parsedRef.commandLine, !host.useCaseSensitiveFileNames());
                    });
                    for (var _b2 = 0, _c2 = parsedRef.commandLine.fileNames; _b2 < _c2.length; _b2++) {
                      var fileName2 = _c2[_b2];
                      if (!ts3.isDeclarationFileName(fileName2) && !ts3.fileExtensionIs(fileName2, ".json")) {
                        processProjectReferenceFile(ts3.getOutputDeclarationFileName(fileName2, parsedRef.commandLine, !host.useCaseSensitiveFileNames(), getCommonSourceDirectory_2), { kind: ts3.FileIncludeKind.OutputFromProjectReference, index });
                      }
                    }
                  }
                }
              });
            }
          }
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "processRootFiles", { count: rootNames.length });
          ts3.forEach(rootNames, function(name, index) {
            return processRootFile(name, false, false, { kind: ts3.FileIncludeKind.RootFile, index });
          });
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          var typeReferences = rootNames.length ? ts3.getAutomaticTypeDirectiveNames(options, host) : ts3.emptyArray;
          if (typeReferences.length) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "processTypeReferences", { count: typeReferences.length });
            var containingDirectory = options.configFilePath ? ts3.getDirectoryPath(options.configFilePath) : host.getCurrentDirectory();
            var containingFilename = ts3.combinePaths(containingDirectory, ts3.inferredTypesContainingFile);
            var resolutions = resolveTypeReferenceDirectiveNamesWorker(typeReferences, containingFilename);
            for (var i = 0; i < typeReferences.length; i++) {
              processTypeReferenceDirective(typeReferences[i], void 0, resolutions[i], { kind: ts3.FileIncludeKind.AutomaticTypeDirectiveFile, typeReference: typeReferences[i], packageId: (_c = resolutions[i]) === null || _c === void 0 ? void 0 : _c.packageId });
            }
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          }
          if (rootNames.length && !skipDefaultLib) {
            var defaultLibraryFileName = getDefaultLibraryFileName();
            if (!options.lib && defaultLibraryFileName) {
              processRootFile(defaultLibraryFileName, true, false, { kind: ts3.FileIncludeKind.LibFile });
            } else {
              ts3.forEach(options.lib, function(libFileName, index) {
                processRootFile(pathForLibFile(libFileName), true, false, { kind: ts3.FileIncludeKind.LibFile, index });
              });
            }
          }
          missingFilePaths = ts3.arrayFrom(ts3.mapDefinedIterator(filesByName.entries(), function(_a2) {
            var path2 = _a2[0], file = _a2[1];
            return file === void 0 ? path2 : void 0;
          }));
          files = ts3.stableSort(processingDefaultLibFiles, compareDefaultLibFiles).concat(processingOtherFiles);
          processingDefaultLibFiles = void 0;
          processingOtherFiles = void 0;
        }
        ts3.Debug.assert(!!missingFilePaths);
        if (oldProgram && host.onReleaseOldSourceFile) {
          var oldSourceFiles = oldProgram.getSourceFiles();
          for (var _i = 0, oldSourceFiles_1 = oldSourceFiles; _i < oldSourceFiles_1.length; _i++) {
            var oldSourceFile = oldSourceFiles_1[_i];
            var newFile = getSourceFileByPath(oldSourceFile.resolvedPath);
            if (shouldCreateNewSourceFile || !newFile || oldSourceFile.resolvedPath === oldSourceFile.path && newFile.resolvedPath !== oldSourceFile.path) {
              host.onReleaseOldSourceFile(oldSourceFile, oldProgram.getCompilerOptions(), !!getSourceFileByPath(oldSourceFile.path));
            }
          }
          if (!host.getParsedCommandLine) {
            oldProgram.forEachResolvedProjectReference(function(resolvedProjectReference) {
              if (!getResolvedProjectReferenceByPath(resolvedProjectReference.sourceFile.path)) {
                host.onReleaseOldSourceFile(resolvedProjectReference.sourceFile, oldProgram.getCompilerOptions(), false);
              }
            });
          }
        }
        if (oldProgram && host.onReleaseParsedCommandLine) {
          forEachProjectReference(oldProgram.getProjectReferences(), oldProgram.getResolvedProjectReferences(), function(oldResolvedRef, parent, index) {
            var oldReference = (parent === null || parent === void 0 ? void 0 : parent.commandLine.projectReferences[index]) || oldProgram.getProjectReferences()[index];
            var oldRefPath = resolveProjectReferencePath(oldReference);
            if (!(projectReferenceRedirects === null || projectReferenceRedirects === void 0 ? void 0 : projectReferenceRedirects.has(toPath(oldRefPath)))) {
              host.onReleaseParsedCommandLine(oldRefPath, oldResolvedRef, oldProgram.getCompilerOptions());
            }
          });
        }
        typeReferenceDirectiveResolutionCache = void 0;
        oldProgram = void 0;
        var program2 = {
          getRootFileNames: function() {
            return rootNames;
          },
          getSourceFile,
          getSourceFileByPath,
          getSourceFiles: function() {
            return files;
          },
          getMissingFilePaths: function() {
            return missingFilePaths;
          },
          getModuleResolutionCache: function() {
            return moduleResolutionCache;
          },
          getFilesByNameMap: function() {
            return filesByName;
          },
          getCompilerOptions: function() {
            return options;
          },
          getSyntacticDiagnostics,
          getOptionsDiagnostics,
          getGlobalDiagnostics,
          getSemanticDiagnostics,
          getCachedSemanticDiagnostics,
          getSuggestionDiagnostics,
          getDeclarationDiagnostics,
          getBindAndCheckDiagnostics,
          getProgramDiagnostics,
          getTypeChecker,
          getClassifiableNames,
          getCommonSourceDirectory,
          emit,
          getCurrentDirectory: function() {
            return currentDirectory;
          },
          getNodeCount: function() {
            return getTypeChecker().getNodeCount();
          },
          getIdentifierCount: function() {
            return getTypeChecker().getIdentifierCount();
          },
          getSymbolCount: function() {
            return getTypeChecker().getSymbolCount();
          },
          getTypeCount: function() {
            return getTypeChecker().getTypeCount();
          },
          getInstantiationCount: function() {
            return getTypeChecker().getInstantiationCount();
          },
          getRelationCacheSizes: function() {
            return getTypeChecker().getRelationCacheSizes();
          },
          getFileProcessingDiagnostics: function() {
            return fileProcessingDiagnostics;
          },
          getResolvedTypeReferenceDirectives: function() {
            return resolvedTypeReferenceDirectives;
          },
          isSourceFileFromExternalLibrary,
          isSourceFileDefaultLibrary,
          getSourceFileFromReference,
          getLibFileFromReference,
          sourceFileToPackageName,
          redirectTargetsMap,
          usesUriStyleNodeCoreModules,
          isEmittedFile,
          getConfigFileParsingDiagnostics: getConfigFileParsingDiagnostics2,
          getResolvedModuleWithFailedLookupLocationsFromCache,
          getProjectReferences,
          getResolvedProjectReferences,
          getProjectReferenceRedirect,
          getResolvedProjectReferenceToRedirect,
          getResolvedProjectReferenceByPath,
          forEachResolvedProjectReference: forEachResolvedProjectReference2,
          isSourceOfProjectReferenceRedirect,
          emitBuildInfo,
          fileExists,
          readFile,
          directoryExists,
          getSymlinkCache,
          realpath: (_d = host.realpath) === null || _d === void 0 ? void 0 : _d.bind(host),
          useCaseSensitiveFileNames: function() {
            return host.useCaseSensitiveFileNames();
          },
          getFileIncludeReasons: function() {
            return fileReasons;
          },
          structureIsReused,
          writeFile
        };
        onProgramCreateComplete();
        fileProcessingDiagnostics === null || fileProcessingDiagnostics === void 0 ? void 0 : fileProcessingDiagnostics.forEach(function(diagnostic) {
          switch (diagnostic.kind) {
            case 1:
              return programDiagnostics.add(createDiagnosticExplainingFile(diagnostic.file && getSourceFileByPath(diagnostic.file), diagnostic.fileProcessingReason, diagnostic.diagnostic, diagnostic.args || ts3.emptyArray));
            case 0:
              var _a2 = getReferencedFileLocation(getSourceFileByPath, diagnostic.reason), file = _a2.file, pos = _a2.pos, end = _a2.end;
              return programDiagnostics.add(ts3.createFileDiagnostic.apply(void 0, __spreadArray([file, ts3.Debug.checkDefined(pos), ts3.Debug.checkDefined(end) - pos, diagnostic.diagnostic], diagnostic.args || ts3.emptyArray, false)));
            default:
              ts3.Debug.assertNever(diagnostic);
          }
        });
        verifyCompilerOptions();
        ts3.performance.mark("afterProgram");
        ts3.performance.measure("Program", "beforeProgram", "afterProgram");
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        return program2;
        function addResolutionDiagnostics(list) {
          if (!list)
            return;
          for (var _i2 = 0, list_3 = list; _i2 < list_3.length; _i2++) {
            var elem = list_3[_i2];
            programDiagnostics.add(elem);
          }
        }
        function pullDiagnosticsFromCache(names, containingFile) {
          var _a2;
          if (!moduleResolutionCache)
            return;
          var containingFileName = ts3.getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory);
          var containingFileMode = !ts3.isString(containingFile) ? containingFile.impliedNodeFormat : void 0;
          var containingDir = ts3.getDirectoryPath(containingFileName);
          var redirectedReference = getRedirectReferenceForResolution(containingFile);
          var i2 = 0;
          for (var _i2 = 0, names_4 = names; _i2 < names_4.length; _i2++) {
            var n = names_4[_i2];
            var mode = typeof n === "string" ? getModeForResolutionAtIndex(containingFile, i2) : getModeForFileReference(n, containingFileMode);
            var name = typeof n === "string" ? n : n.fileName;
            i2++;
            if (ts3.isExternalModuleNameRelative(name))
              continue;
            var diags = (_a2 = moduleResolutionCache.getOrCreateCacheForModuleName(name, mode, redirectedReference).get(containingDir)) === null || _a2 === void 0 ? void 0 : _a2.resolutionDiagnostics;
            addResolutionDiagnostics(diags);
          }
        }
        function resolveModuleNamesWorker(moduleNames, containingFile, reusedNames) {
          if (!moduleNames.length)
            return ts3.emptyArray;
          var containingFileName = ts3.getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory);
          var redirectedReference = getRedirectReferenceForResolution(containingFile);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "resolveModuleNamesWorker", { containingFileName });
          ts3.performance.mark("beforeResolveModule");
          var result2 = actualResolveModuleNamesWorker(moduleNames, containingFile, containingFileName, reusedNames, redirectedReference);
          ts3.performance.mark("afterResolveModule");
          ts3.performance.measure("ResolveModule", "beforeResolveModule", "afterResolveModule");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          pullDiagnosticsFromCache(moduleNames, containingFile);
          return result2;
        }
        function resolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFile) {
          if (!typeDirectiveNames.length)
            return [];
          var containingFileName = !ts3.isString(containingFile) ? ts3.getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory) : containingFile;
          var redirectedReference = !ts3.isString(containingFile) ? getRedirectReferenceForResolution(containingFile) : void 0;
          var containingFileMode = !ts3.isString(containingFile) ? containingFile.impliedNodeFormat : void 0;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "resolveTypeReferenceDirectiveNamesWorker", { containingFileName });
          ts3.performance.mark("beforeResolveTypeReference");
          var result2 = actualResolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFileName, redirectedReference, containingFileMode);
          ts3.performance.mark("afterResolveTypeReference");
          ts3.performance.measure("ResolveTypeReference", "beforeResolveTypeReference", "afterResolveTypeReference");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function getRedirectReferenceForResolution(file) {
          var redirect = getResolvedProjectReferenceToRedirect(file.originalFileName);
          if (redirect || !ts3.isDeclarationFileName(file.originalFileName))
            return redirect;
          var resultFromDts = getRedirectReferenceForResolutionFromSourceOfProject(file.path);
          if (resultFromDts)
            return resultFromDts;
          if (!host.realpath || !options.preserveSymlinks || !ts3.stringContains(file.originalFileName, ts3.nodeModulesPathPart))
            return void 0;
          var realDeclarationPath = toPath(host.realpath(file.originalFileName));
          return realDeclarationPath === file.path ? void 0 : getRedirectReferenceForResolutionFromSourceOfProject(realDeclarationPath);
        }
        function getRedirectReferenceForResolutionFromSourceOfProject(filePath) {
          var source = getSourceOfProjectReferenceRedirect(filePath);
          if (ts3.isString(source))
            return getResolvedProjectReferenceToRedirect(source);
          if (!source)
            return void 0;
          return forEachResolvedProjectReference2(function(resolvedRef) {
            var out = ts3.outFile(resolvedRef.commandLine.options);
            if (!out)
              return void 0;
            return toPath(out) === filePath ? resolvedRef : void 0;
          });
        }
        function compareDefaultLibFiles(a, b) {
          return ts3.compareValues(getDefaultLibFilePriority(a), getDefaultLibFilePriority(b));
        }
        function getDefaultLibFilePriority(a) {
          if (ts3.containsPath(defaultLibraryPath, a.fileName, false)) {
            var basename = ts3.getBaseFileName(a.fileName);
            if (basename === "lib.d.ts" || basename === "lib.es6.d.ts")
              return 0;
            var name = ts3.removeSuffix(ts3.removePrefix(basename, "lib."), ".d.ts");
            var index = ts3.libs.indexOf(name);
            if (index !== -1)
              return index + 1;
          }
          return ts3.libs.length + 2;
        }
        function getResolvedModuleWithFailedLookupLocationsFromCache(moduleName, containingFile, mode) {
          return moduleResolutionCache && ts3.resolveModuleNameFromCache(moduleName, containingFile, moduleResolutionCache, mode);
        }
        function toPath(fileName2) {
          return ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
        }
        function getCommonSourceDirectory() {
          if (commonSourceDirectory === void 0) {
            var emittedFiles_1 = ts3.filter(files, function(file) {
              return ts3.sourceFileMayBeEmitted(file, program2);
            });
            commonSourceDirectory = ts3.getCommonSourceDirectory(options, function() {
              return ts3.mapDefined(emittedFiles_1, function(file) {
                return file.isDeclarationFile ? void 0 : file.fileName;
              });
            }, currentDirectory, getCanonicalFileName, function(commonSourceDirectory2) {
              return checkSourceFilesBelongToPath(emittedFiles_1, commonSourceDirectory2);
            });
          }
          return commonSourceDirectory;
        }
        function getClassifiableNames() {
          var _a2;
          if (!classifiableNames) {
            getTypeChecker();
            classifiableNames = new ts3.Set();
            for (var _i2 = 0, files_3 = files; _i2 < files_3.length; _i2++) {
              var sourceFile = files_3[_i2];
              (_a2 = sourceFile.classifiableNames) === null || _a2 === void 0 ? void 0 : _a2.forEach(function(value) {
                return classifiableNames.add(value);
              });
            }
          }
          return classifiableNames;
        }
        function resolveModuleNamesReusingOldState(moduleNames, file) {
          if (structureIsReused === 0 && !file.ambientModuleNames.length) {
            return resolveModuleNamesWorker(moduleNames, file, void 0);
          }
          var oldSourceFile2 = oldProgram && oldProgram.getSourceFile(file.fileName);
          if (oldSourceFile2 !== file && file.resolvedModules) {
            var result_14 = [];
            var i2 = 0;
            for (var _i2 = 0, moduleNames_1 = moduleNames; _i2 < moduleNames_1.length; _i2++) {
              var moduleName = moduleNames_1[_i2];
              var resolvedModule = file.resolvedModules.get(moduleName, getModeForResolutionAtIndex(file, i2));
              i2++;
              result_14.push(resolvedModule);
            }
            return result_14;
          }
          var unknownModuleNames;
          var result2;
          var reusedNames;
          var predictedToResolveToAmbientModuleMarker = {};
          for (var i2 = 0; i2 < moduleNames.length; i2++) {
            var moduleName = moduleNames[i2];
            if (file === oldSourceFile2 && !hasInvalidatedResolution(oldSourceFile2.path)) {
              var oldResolvedModule = ts3.getResolvedModule(oldSourceFile2, moduleName, getModeForResolutionAtIndex(oldSourceFile2, i2));
              if (oldResolvedModule) {
                if (ts3.isTraceEnabled(options, host)) {
                  ts3.trace(host, oldResolvedModule.packageId ? ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2, moduleName, ts3.getNormalizedAbsolutePath(file.originalFileName, currentDirectory), oldResolvedModule.resolvedFileName, oldResolvedModule.packageId && ts3.packageIdToString(oldResolvedModule.packageId));
                }
                (result2 || (result2 = new Array(moduleNames.length)))[i2] = oldResolvedModule;
                (reusedNames || (reusedNames = [])).push(moduleName);
                continue;
              }
            }
            var resolvesToAmbientModuleInNonModifiedFile = false;
            if (ts3.contains(file.ambientModuleNames, moduleName)) {
              resolvesToAmbientModuleInNonModifiedFile = true;
              if (ts3.isTraceEnabled(options, host)) {
                ts3.trace(host, ts3.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1, moduleName, ts3.getNormalizedAbsolutePath(file.originalFileName, currentDirectory));
              }
            } else {
              resolvesToAmbientModuleInNonModifiedFile = moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName, i2);
            }
            if (resolvesToAmbientModuleInNonModifiedFile) {
              (result2 || (result2 = new Array(moduleNames.length)))[i2] = predictedToResolveToAmbientModuleMarker;
            } else {
              (unknownModuleNames || (unknownModuleNames = [])).push(moduleName);
            }
          }
          var resolutions2 = unknownModuleNames && unknownModuleNames.length ? resolveModuleNamesWorker(unknownModuleNames, file, reusedNames) : ts3.emptyArray;
          if (!result2) {
            ts3.Debug.assert(resolutions2.length === moduleNames.length);
            return resolutions2;
          }
          var j = 0;
          for (var i2 = 0; i2 < result2.length; i2++) {
            if (result2[i2]) {
              if (result2[i2] === predictedToResolveToAmbientModuleMarker) {
                result2[i2] = void 0;
              }
            } else {
              result2[i2] = resolutions2[j];
              j++;
            }
          }
          ts3.Debug.assert(j === resolutions2.length);
          return result2;
          function moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName2, index) {
            if (index >= ts3.length(oldSourceFile2 === null || oldSourceFile2 === void 0 ? void 0 : oldSourceFile2.imports) + ts3.length(oldSourceFile2 === null || oldSourceFile2 === void 0 ? void 0 : oldSourceFile2.moduleAugmentations))
              return false;
            var resolutionToFile = ts3.getResolvedModule(oldSourceFile2, moduleName2, oldSourceFile2 && getModeForResolutionAtIndex(oldSourceFile2, index));
            var resolvedFile = resolutionToFile && oldProgram.getSourceFile(resolutionToFile.resolvedFileName);
            if (resolutionToFile && resolvedFile) {
              return false;
            }
            var unmodifiedFile = ambientModuleNameToUnmodifiedFileName.get(moduleName2);
            if (!unmodifiedFile) {
              return false;
            }
            if (ts3.isTraceEnabled(options, host)) {
              ts3.trace(host, ts3.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified, moduleName2, unmodifiedFile);
            }
            return true;
          }
        }
        function canReuseProjectReferences() {
          return !forEachProjectReference(oldProgram.getProjectReferences(), oldProgram.getResolvedProjectReferences(), function(oldResolvedRef, parent, index) {
            var newRef = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var newResolvedRef = parseProjectReferenceConfigFile(newRef);
            if (oldResolvedRef) {
              return !newResolvedRef || newResolvedRef.sourceFile !== oldResolvedRef.sourceFile || !ts3.arrayIsEqualTo(oldResolvedRef.commandLine.fileNames, newResolvedRef.commandLine.fileNames);
            } else {
              return newResolvedRef !== void 0;
            }
          }, function(oldProjectReferences, parent) {
            var newReferences = parent ? getResolvedProjectReferenceByPath(parent.sourceFile.path).commandLine.projectReferences : projectReferences;
            return !ts3.arrayIsEqualTo(oldProjectReferences, newReferences, ts3.projectReferenceIsEqualTo);
          });
        }
        function tryReuseStructureFromOldProgram() {
          var _a2;
          if (!oldProgram) {
            return 0;
          }
          var oldOptions = oldProgram.getCompilerOptions();
          if (ts3.changesAffectModuleResolution(oldOptions, options)) {
            return 0;
          }
          var oldRootNames = oldProgram.getRootFileNames();
          if (!ts3.arrayIsEqualTo(oldRootNames, rootNames)) {
            return 0;
          }
          if (!canReuseProjectReferences()) {
            return 0;
          }
          if (projectReferences) {
            resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
          }
          var newSourceFiles = [];
          var modifiedSourceFiles = [];
          structureIsReused = 2;
          if (oldProgram.getMissingFilePaths().some(function(missingFilePath) {
            return host.fileExists(missingFilePath);
          })) {
            return 0;
          }
          var oldSourceFiles2 = oldProgram.getSourceFiles();
          var SeenPackageName;
          (function(SeenPackageName2) {
            SeenPackageName2[SeenPackageName2["Exists"] = 0] = "Exists";
            SeenPackageName2[SeenPackageName2["Modified"] = 1] = "Modified";
          })(SeenPackageName || (SeenPackageName = {}));
          var seenPackageNames = new ts3.Map();
          for (var _i2 = 0, oldSourceFiles_2 = oldSourceFiles2; _i2 < oldSourceFiles_2.length; _i2++) {
            var oldSourceFile2 = oldSourceFiles_2[_i2];
            var newSourceFile = host.getSourceFileByPath ? host.getSourceFileByPath(oldSourceFile2.fileName, oldSourceFile2.resolvedPath, getCreateSourceFileOptions(oldSourceFile2.fileName, moduleResolutionCache, host, options), void 0, shouldCreateNewSourceFile) : host.getSourceFile(oldSourceFile2.fileName, getCreateSourceFileOptions(oldSourceFile2.fileName, moduleResolutionCache, host, options), void 0, shouldCreateNewSourceFile);
            if (!newSourceFile) {
              return 0;
            }
            ts3.Debug.assert(!newSourceFile.redirectInfo, "Host should not return a redirect source file from `getSourceFile`");
            var fileChanged = void 0;
            if (oldSourceFile2.redirectInfo) {
              if (newSourceFile !== oldSourceFile2.redirectInfo.unredirected) {
                return 0;
              }
              fileChanged = false;
              newSourceFile = oldSourceFile2;
            } else if (oldProgram.redirectTargetsMap.has(oldSourceFile2.path)) {
              if (newSourceFile !== oldSourceFile2) {
                return 0;
              }
              fileChanged = false;
            } else {
              fileChanged = newSourceFile !== oldSourceFile2;
            }
            newSourceFile.path = oldSourceFile2.path;
            newSourceFile.originalFileName = oldSourceFile2.originalFileName;
            newSourceFile.resolvedPath = oldSourceFile2.resolvedPath;
            newSourceFile.fileName = oldSourceFile2.fileName;
            var packageName = oldProgram.sourceFileToPackageName.get(oldSourceFile2.path);
            if (packageName !== void 0) {
              var prevKind = seenPackageNames.get(packageName);
              var newKind = fileChanged ? 1 : 0;
              if (prevKind !== void 0 && newKind === 1 || prevKind === 1) {
                return 0;
              }
              seenPackageNames.set(packageName, newKind);
            }
            if (fileChanged) {
              if (!ts3.arrayIsEqualTo(oldSourceFile2.libReferenceDirectives, newSourceFile.libReferenceDirectives, fileReferenceIsEqualTo)) {
                structureIsReused = 1;
              }
              if (oldSourceFile2.hasNoDefaultLib !== newSourceFile.hasNoDefaultLib) {
                structureIsReused = 1;
              }
              if (!ts3.arrayIsEqualTo(oldSourceFile2.referencedFiles, newSourceFile.referencedFiles, fileReferenceIsEqualTo)) {
                structureIsReused = 1;
              }
              collectExternalModuleReferences(newSourceFile);
              if (!ts3.arrayIsEqualTo(oldSourceFile2.imports, newSourceFile.imports, moduleNameIsEqualTo)) {
                structureIsReused = 1;
              }
              if (!ts3.arrayIsEqualTo(oldSourceFile2.moduleAugmentations, newSourceFile.moduleAugmentations, moduleNameIsEqualTo)) {
                structureIsReused = 1;
              }
              if ((oldSourceFile2.flags & 6291456) !== (newSourceFile.flags & 6291456)) {
                structureIsReused = 1;
              }
              if (!ts3.arrayIsEqualTo(oldSourceFile2.typeReferenceDirectives, newSourceFile.typeReferenceDirectives, fileReferenceIsEqualTo)) {
                structureIsReused = 1;
              }
              modifiedSourceFiles.push({ oldFile: oldSourceFile2, newFile: newSourceFile });
            } else if (hasInvalidatedResolution(oldSourceFile2.path)) {
              structureIsReused = 1;
              modifiedSourceFiles.push({ oldFile: oldSourceFile2, newFile: newSourceFile });
            }
            newSourceFiles.push(newSourceFile);
          }
          if (structureIsReused !== 2) {
            return structureIsReused;
          }
          var modifiedFiles = modifiedSourceFiles.map(function(f) {
            return f.oldFile;
          });
          for (var _b2 = 0, oldSourceFiles_3 = oldSourceFiles2; _b2 < oldSourceFiles_3.length; _b2++) {
            var oldFile = oldSourceFiles_3[_b2];
            if (!ts3.contains(modifiedFiles, oldFile)) {
              for (var _c2 = 0, _d2 = oldFile.ambientModuleNames; _c2 < _d2.length; _c2++) {
                var moduleName = _d2[_c2];
                ambientModuleNameToUnmodifiedFileName.set(moduleName, oldFile.fileName);
              }
            }
          }
          for (var _e2 = 0, modifiedSourceFiles_1 = modifiedSourceFiles; _e2 < modifiedSourceFiles_1.length; _e2++) {
            var _f = modifiedSourceFiles_1[_e2], oldSourceFile2 = _f.oldFile, newSourceFile = _f.newFile;
            var moduleNames = getModuleNames(newSourceFile);
            var resolutions2 = resolveModuleNamesReusingOldState(moduleNames, newSourceFile);
            var resolutionsChanged = ts3.hasChangesInResolutions(moduleNames, resolutions2, oldSourceFile2.resolvedModules, oldSourceFile2, ts3.moduleResolutionIsEqualTo);
            if (resolutionsChanged) {
              structureIsReused = 1;
              newSourceFile.resolvedModules = ts3.zipToModeAwareCache(newSourceFile, moduleNames, resolutions2);
            } else {
              newSourceFile.resolvedModules = oldSourceFile2.resolvedModules;
            }
            var typesReferenceDirectives = newSourceFile.typeReferenceDirectives;
            var typeReferenceResolutions = resolveTypeReferenceDirectiveNamesWorker(typesReferenceDirectives, newSourceFile);
            var typeReferenceResolutionsChanged = ts3.hasChangesInResolutions(typesReferenceDirectives, typeReferenceResolutions, oldSourceFile2.resolvedTypeReferenceDirectiveNames, oldSourceFile2, ts3.typeDirectiveIsEqualTo);
            if (typeReferenceResolutionsChanged) {
              structureIsReused = 1;
              newSourceFile.resolvedTypeReferenceDirectiveNames = ts3.zipToModeAwareCache(newSourceFile, typesReferenceDirectives, typeReferenceResolutions);
            } else {
              newSourceFile.resolvedTypeReferenceDirectiveNames = oldSourceFile2.resolvedTypeReferenceDirectiveNames;
            }
          }
          if (structureIsReused !== 2) {
            return structureIsReused;
          }
          if (ts3.changesAffectingProgramStructure(oldOptions, options) || ((_a2 = host.hasChangedAutomaticTypeDirectiveNames) === null || _a2 === void 0 ? void 0 : _a2.call(host))) {
            return 1;
          }
          missingFilePaths = oldProgram.getMissingFilePaths();
          ts3.Debug.assert(newSourceFiles.length === oldProgram.getSourceFiles().length);
          for (var _g = 0, newSourceFiles_1 = newSourceFiles; _g < newSourceFiles_1.length; _g++) {
            var newSourceFile = newSourceFiles_1[_g];
            filesByName.set(newSourceFile.path, newSourceFile);
          }
          var oldFilesByNameMap = oldProgram.getFilesByNameMap();
          oldFilesByNameMap.forEach(function(oldFile2, path2) {
            if (!oldFile2) {
              filesByName.set(path2, oldFile2);
              return;
            }
            if (oldFile2.path === path2) {
              if (oldProgram.isSourceFileFromExternalLibrary(oldFile2)) {
                sourceFilesFoundSearchingNodeModules.set(oldFile2.path, true);
              }
              return;
            }
            filesByName.set(path2, filesByName.get(oldFile2.path));
          });
          files = newSourceFiles;
          fileReasons = oldProgram.getFileIncludeReasons();
          fileProcessingDiagnostics = oldProgram.getFileProcessingDiagnostics();
          resolvedTypeReferenceDirectives = oldProgram.getResolvedTypeReferenceDirectives();
          sourceFileToPackageName = oldProgram.sourceFileToPackageName;
          redirectTargetsMap = oldProgram.redirectTargetsMap;
          usesUriStyleNodeCoreModules = oldProgram.usesUriStyleNodeCoreModules;
          return 2;
        }
        function getEmitHost(writeFileCallback) {
          return {
            getPrependNodes,
            getCanonicalFileName,
            getCommonSourceDirectory: program2.getCommonSourceDirectory,
            getCompilerOptions: program2.getCompilerOptions,
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            getNewLine: function() {
              return host.getNewLine();
            },
            getSourceFile: program2.getSourceFile,
            getSourceFileByPath: program2.getSourceFileByPath,
            getSourceFiles: program2.getSourceFiles,
            getLibFileFromReference: program2.getLibFileFromReference,
            isSourceFileFromExternalLibrary,
            getResolvedProjectReferenceToRedirect,
            getProjectReferenceRedirect,
            isSourceOfProjectReferenceRedirect,
            getSymlinkCache,
            writeFile: writeFileCallback || writeFile,
            isEmitBlocked,
            readFile: function(f) {
              return host.readFile(f);
            },
            fileExists: function(f) {
              var path2 = toPath(f);
              if (getSourceFileByPath(path2))
                return true;
              if (ts3.contains(missingFilePaths, path2))
                return false;
              return host.fileExists(f);
            },
            useCaseSensitiveFileNames: function() {
              return host.useCaseSensitiveFileNames();
            },
            getProgramBuildInfo: function() {
              return program2.getProgramBuildInfo && program2.getProgramBuildInfo();
            },
            getSourceFileFromReference: function(file, ref) {
              return program2.getSourceFileFromReference(file, ref);
            },
            redirectTargetsMap,
            getFileIncludeReasons: program2.getFileIncludeReasons
          };
        }
        function writeFile(fileName2, text, writeByteOrderMark, onError, sourceFiles, data) {
          host.writeFile(fileName2, text, writeByteOrderMark, onError, sourceFiles, data);
        }
        function emitBuildInfo(writeFileCallback) {
          ts3.Debug.assert(!ts3.outFile(options));
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitBuildInfo", {}, true);
          ts3.performance.mark("beforeEmit");
          var emitResult = ts3.emitFiles(ts3.notImplementedResolver, getEmitHost(writeFileCallback), void 0, ts3.noTransformers, false, true);
          ts3.performance.mark("afterEmit");
          ts3.performance.measure("Emit", "beforeEmit", "afterEmit");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return emitResult;
        }
        function getResolvedProjectReferences() {
          return resolvedProjectReferences;
        }
        function getProjectReferences() {
          return projectReferences;
        }
        function getPrependNodes() {
          return createPrependNodes(projectReferences, function(_ref, index) {
            var _a2;
            return (_a2 = resolvedProjectReferences[index]) === null || _a2 === void 0 ? void 0 : _a2.commandLine;
          }, function(fileName2) {
            var path2 = toPath(fileName2);
            var sourceFile = getSourceFileByPath(path2);
            return sourceFile ? sourceFile.text : filesByName.has(path2) ? void 0 : host.readFile(path2);
          });
        }
        function isSourceFileFromExternalLibrary(file) {
          return !!sourceFilesFoundSearchingNodeModules.get(file.path);
        }
        function isSourceFileDefaultLibrary(file) {
          if (!file.isDeclarationFile) {
            return false;
          }
          if (file.hasNoDefaultLib) {
            return true;
          }
          if (!options.noLib) {
            return false;
          }
          var equalityComparer = host.useCaseSensitiveFileNames() ? ts3.equateStringsCaseSensitive : ts3.equateStringsCaseInsensitive;
          if (!options.lib) {
            return equalityComparer(file.fileName, getDefaultLibraryFileName());
          } else {
            return ts3.some(options.lib, function(libFileName) {
              return equalityComparer(file.fileName, pathForLibFile(libFileName));
            });
          }
        }
        function getTypeChecker() {
          return typeChecker || (typeChecker = ts3.createTypeChecker(program2));
        }
        function emit(sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, transformers, forceDtsEmit) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emit", { path: sourceFile === null || sourceFile === void 0 ? void 0 : sourceFile.path }, true);
          var result2 = runWithCancellationToken(function() {
            return emitWorker(program2, sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, transformers, forceDtsEmit);
          });
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function isEmitBlocked(emitFileName) {
          return hasEmitBlockingDiagnostics.has(toPath(emitFileName));
        }
        function emitWorker(program3, sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit) {
          if (!forceDtsEmit) {
            var result2 = handleNoEmitOptions(program3, sourceFile, writeFileCallback, cancellationToken);
            if (result2)
              return result2;
          }
          var emitResolver = getTypeChecker().getEmitResolver(ts3.outFile(options) ? void 0 : sourceFile, cancellationToken);
          ts3.performance.mark("beforeEmit");
          var emitResult = ts3.emitFiles(emitResolver, getEmitHost(writeFileCallback), sourceFile, ts3.getTransformers(options, customTransformers, emitOnlyDtsFiles), emitOnlyDtsFiles, false, forceDtsEmit);
          ts3.performance.mark("afterEmit");
          ts3.performance.measure("Emit", "beforeEmit", "afterEmit");
          return emitResult;
        }
        function getSourceFile(fileName2) {
          return getSourceFileByPath(toPath(fileName2));
        }
        function getSourceFileByPath(path2) {
          return filesByName.get(path2) || void 0;
        }
        function getDiagnosticsHelper(sourceFile, getDiagnostics, cancellationToken) {
          if (sourceFile) {
            return getDiagnostics(sourceFile, cancellationToken);
          }
          return ts3.sortAndDeduplicateDiagnostics(ts3.flatMap(program2.getSourceFiles(), function(sourceFile2) {
            if (cancellationToken) {
              cancellationToken.throwIfCancellationRequested();
            }
            return getDiagnostics(sourceFile2, cancellationToken);
          }));
        }
        function getSyntacticDiagnostics(sourceFile, cancellationToken) {
          return getDiagnosticsHelper(sourceFile, getSyntacticDiagnosticsForFile, cancellationToken);
        }
        function getSemanticDiagnostics(sourceFile, cancellationToken) {
          return getDiagnosticsHelper(sourceFile, getSemanticDiagnosticsForFile, cancellationToken);
        }
        function getCachedSemanticDiagnostics(sourceFile) {
          var _a2;
          return sourceFile ? (_a2 = cachedBindAndCheckDiagnosticsForFile.perFile) === null || _a2 === void 0 ? void 0 : _a2.get(sourceFile.path) : cachedBindAndCheckDiagnosticsForFile.allDiagnostics;
        }
        function getBindAndCheckDiagnostics(sourceFile, cancellationToken) {
          return getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken);
        }
        function getProgramDiagnostics(sourceFile) {
          var _a2;
          if (ts3.skipTypeChecking(sourceFile, options, program2)) {
            return ts3.emptyArray;
          }
          var programDiagnosticsInFile = programDiagnostics.getDiagnostics(sourceFile.fileName);
          if (!((_a2 = sourceFile.commentDirectives) === null || _a2 === void 0 ? void 0 : _a2.length)) {
            return programDiagnosticsInFile;
          }
          return getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, programDiagnosticsInFile).diagnostics;
        }
        function getDeclarationDiagnostics(sourceFile, cancellationToken) {
          var options2 = program2.getCompilerOptions();
          if (!sourceFile || ts3.outFile(options2)) {
            return getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
          } else {
            return getDiagnosticsHelper(sourceFile, getDeclarationDiagnosticsForFile, cancellationToken);
          }
        }
        function getSyntacticDiagnosticsForFile(sourceFile) {
          if (ts3.isSourceFileJS(sourceFile)) {
            if (!sourceFile.additionalSyntacticDiagnostics) {
              sourceFile.additionalSyntacticDiagnostics = getJSSyntacticDiagnosticsForFile(sourceFile);
            }
            return ts3.concatenate(sourceFile.additionalSyntacticDiagnostics, sourceFile.parseDiagnostics);
          }
          return sourceFile.parseDiagnostics;
        }
        function runWithCancellationToken(func) {
          try {
            return func();
          } catch (e) {
            if (e instanceof ts3.OperationCanceledException) {
              typeChecker = void 0;
            }
            throw e;
          }
        }
        function getSemanticDiagnosticsForFile(sourceFile, cancellationToken) {
          return ts3.concatenate(filterSemanticDiagnostics(getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken), options), getProgramDiagnostics(sourceFile));
        }
        function getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken) {
          return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedBindAndCheckDiagnosticsForFile, getBindAndCheckDiagnosticsForFileNoCache);
        }
        function getBindAndCheckDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            if (ts3.skipTypeChecking(sourceFile, options, program2)) {
              return ts3.emptyArray;
            }
            var typeChecker2 = getTypeChecker();
            ts3.Debug.assert(!!sourceFile.bindDiagnostics);
            var isJs = sourceFile.scriptKind === 1 || sourceFile.scriptKind === 2;
            var isCheckJs = isJs && ts3.isCheckJsEnabledForFile(sourceFile, options);
            var isPlainJs = ts3.isPlainJsFile(sourceFile, options.checkJs);
            var isTsNoCheck = !!sourceFile.checkJsDirective && sourceFile.checkJsDirective.enabled === false;
            var includeBindAndCheckDiagnostics = !isTsNoCheck && (sourceFile.scriptKind === 3 || sourceFile.scriptKind === 4 || sourceFile.scriptKind === 5 || isPlainJs || isCheckJs || sourceFile.scriptKind === 7);
            var bindDiagnostics = includeBindAndCheckDiagnostics ? sourceFile.bindDiagnostics : ts3.emptyArray;
            var checkDiagnostics = includeBindAndCheckDiagnostics ? typeChecker2.getDiagnostics(sourceFile, cancellationToken) : ts3.emptyArray;
            if (isPlainJs) {
              bindDiagnostics = ts3.filter(bindDiagnostics, function(d) {
                return ts3.plainJSErrors.has(d.code);
              });
              checkDiagnostics = ts3.filter(checkDiagnostics, function(d) {
                return ts3.plainJSErrors.has(d.code);
              });
            }
            return getMergedBindAndCheckDiagnostics(sourceFile, includeBindAndCheckDiagnostics && !isPlainJs, bindDiagnostics, checkDiagnostics, isCheckJs ? sourceFile.jsDocDiagnostics : void 0);
          });
        }
        function getMergedBindAndCheckDiagnostics(sourceFile, includeBindAndCheckDiagnostics) {
          var _a2;
          var allDiagnostics = [];
          for (var _i2 = 2; _i2 < arguments.length; _i2++) {
            allDiagnostics[_i2 - 2] = arguments[_i2];
          }
          var flatDiagnostics = ts3.flatten(allDiagnostics);
          if (!includeBindAndCheckDiagnostics || !((_a2 = sourceFile.commentDirectives) === null || _a2 === void 0 ? void 0 : _a2.length)) {
            return flatDiagnostics;
          }
          var _b2 = getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, flatDiagnostics), diagnostics = _b2.diagnostics, directives = _b2.directives;
          for (var _c2 = 0, _d2 = directives.getUnusedExpectations(); _c2 < _d2.length; _c2++) {
            var errorExpectation = _d2[_c2];
            diagnostics.push(ts3.createDiagnosticForRange(sourceFile, errorExpectation.range, ts3.Diagnostics.Unused_ts_expect_error_directive));
          }
          return diagnostics;
        }
        function getDiagnosticsWithPrecedingDirectives(sourceFile, commentDirectives, flatDiagnostics) {
          var directives = ts3.createCommentDirectivesMap(sourceFile, commentDirectives);
          var diagnostics = flatDiagnostics.filter(function(diagnostic) {
            return markPrecedingCommentDirectiveLine(diagnostic, directives) === -1;
          });
          return { diagnostics, directives };
        }
        function getSuggestionDiagnostics(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            return getTypeChecker().getSuggestionDiagnostics(sourceFile, cancellationToken);
          });
        }
        function markPrecedingCommentDirectiveLine(diagnostic, directives) {
          var file = diagnostic.file, start = diagnostic.start;
          if (!file) {
            return -1;
          }
          var lineStarts = ts3.getLineStarts(file);
          var line = ts3.computeLineAndCharacterOfPosition(lineStarts, start).line - 1;
          while (line >= 0) {
            if (directives.markUsed(line)) {
              return line;
            }
            var lineText = file.text.slice(lineStarts[line], lineStarts[line + 1]).trim();
            if (lineText !== "" && !/^(\s*)\/\/(.*)$/.test(lineText)) {
              return -1;
            }
            line--;
          }
          return -1;
        }
        function getJSSyntacticDiagnosticsForFile(sourceFile) {
          return runWithCancellationToken(function() {
            var diagnostics = [];
            walk(sourceFile, sourceFile);
            ts3.forEachChildRecursively(sourceFile, walk, walkArray);
            return diagnostics;
            function walk(node, parent) {
              switch (parent.kind) {
                case 164:
                case 167:
                case 169:
                  if (parent.questionToken === node) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
                    return "skip";
                  }
                case 168:
                case 171:
                case 172:
                case 173:
                case 213:
                case 256:
                case 214:
                case 254:
                  if (parent.type === node) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Type_annotations_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
              }
              switch (node.kind) {
                case 267:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(parent, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "import type"));
                    return "skip";
                  }
                  break;
                case 272:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "export type"));
                    return "skip";
                  }
                  break;
                case 270:
                case 275:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, ts3.isImportSpecifier(node) ? "import...type" : "export...type"));
                    return "skip";
                  }
                  break;
                case 265:
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.import_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 271:
                  if (node.isExportEquals) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.export_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 291:
                  var heritageClause = node;
                  if (heritageClause.token === 117) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.implements_clauses_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 258:
                  var interfaceKeyword = ts3.tokenToString(118);
                  ts3.Debug.assertIsDefined(interfaceKeyword);
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, interfaceKeyword));
                  return "skip";
                case 261:
                  var moduleKeyword = node.flags & 16 ? ts3.tokenToString(142) : ts3.tokenToString(141);
                  ts3.Debug.assertIsDefined(moduleKeyword);
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, moduleKeyword));
                  return "skip";
                case 259:
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Type_aliases_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 260:
                  var enumKeyword = ts3.Debug.checkDefined(ts3.tokenToString(92));
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, enumKeyword));
                  return "skip";
                case 230:
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Non_null_assertions_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 229:
                  diagnostics.push(createDiagnosticForNode(node.type, ts3.Diagnostics.Type_assertion_expressions_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 211:
                  ts3.Debug.fail();
              }
            }
            function walkArray(nodes, parent) {
              if (parent.decorators === nodes && !options.experimentalDecorators) {
                diagnostics.push(createDiagnosticForNode(parent, ts3.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning));
              }
              switch (parent.kind) {
                case 257:
                case 226:
                case 169:
                case 171:
                case 172:
                case 173:
                case 213:
                case 256:
                case 214:
                  if (nodes === parent.typeParameters) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts3.Diagnostics.Type_parameter_declarations_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                case 237:
                  if (nodes === parent.modifiers) {
                    checkModifiers(parent.modifiers, parent.kind === 237);
                    return "skip";
                  }
                  break;
                case 167:
                  if (nodes === parent.modifiers) {
                    for (var _i2 = 0, _a2 = nodes; _i2 < _a2.length; _i2++) {
                      var modifier = _a2[_i2];
                      if (modifier.kind !== 124) {
                        diagnostics.push(createDiagnosticForNode(modifier, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, ts3.tokenToString(modifier.kind)));
                      }
                    }
                    return "skip";
                  }
                  break;
                case 164:
                  if (nodes === parent.modifiers) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts3.Diagnostics.Parameter_modifiers_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 208:
                case 209:
                case 228:
                case 279:
                case 280:
                case 210:
                  if (nodes === parent.typeArguments) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts3.Diagnostics.Type_arguments_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
              }
            }
            function checkModifiers(modifiers, isConstValid) {
              for (var _i2 = 0, modifiers_2 = modifiers; _i2 < modifiers_2.length; _i2++) {
                var modifier = modifiers_2[_i2];
                switch (modifier.kind) {
                  case 85:
                    if (isConstValid) {
                      continue;
                    }
                  case 123:
                  case 121:
                  case 122:
                  case 145:
                  case 135:
                  case 126:
                  case 159:
                  case 101:
                  case 144:
                    diagnostics.push(createDiagnosticForNode(modifier, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, ts3.tokenToString(modifier.kind)));
                    break;
                  case 124:
                  case 93:
                  case 88:
                }
              }
            }
            function createDiagnosticForNodeArray(nodes, message, arg0, arg1, arg2) {
              var start = nodes.pos;
              return ts3.createFileDiagnostic(sourceFile, start, nodes.end - start, message, arg0, arg1, arg2);
            }
            function createDiagnosticForNode(node, message, arg0, arg1, arg2) {
              return ts3.createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2);
            }
          });
        }
        function getDeclarationDiagnosticsWorker(sourceFile, cancellationToken) {
          return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedDeclarationDiagnosticsForFile, getDeclarationDiagnosticsForFileNoCache);
        }
        function getDeclarationDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            var resolver = getTypeChecker().getEmitResolver(sourceFile, cancellationToken);
            return ts3.getDeclarationDiagnostics(getEmitHost(ts3.noop), resolver, sourceFile) || ts3.emptyArray;
          });
        }
        function getAndCacheDiagnostics(sourceFile, cancellationToken, cache, getDiagnostics) {
          var _a2;
          var cachedResult = sourceFile ? (_a2 = cache.perFile) === null || _a2 === void 0 ? void 0 : _a2.get(sourceFile.path) : cache.allDiagnostics;
          if (cachedResult) {
            return cachedResult;
          }
          var result2 = getDiagnostics(sourceFile, cancellationToken);
          if (sourceFile) {
            (cache.perFile || (cache.perFile = new ts3.Map())).set(sourceFile.path, result2);
          } else {
            cache.allDiagnostics = result2;
          }
          return result2;
        }
        function getDeclarationDiagnosticsForFile(sourceFile, cancellationToken) {
          return sourceFile.isDeclarationFile ? [] : getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
        }
        function getOptionsDiagnostics() {
          return ts3.sortAndDeduplicateDiagnostics(ts3.concatenate(programDiagnostics.getGlobalDiagnostics(), getOptionsDiagnosticsOfConfigFile()));
        }
        function getOptionsDiagnosticsOfConfigFile() {
          if (!options.configFile)
            return ts3.emptyArray;
          var diagnostics = programDiagnostics.getDiagnostics(options.configFile.fileName);
          forEachResolvedProjectReference2(function(resolvedRef) {
            diagnostics = ts3.concatenate(diagnostics, programDiagnostics.getDiagnostics(resolvedRef.sourceFile.fileName));
          });
          return diagnostics;
        }
        function getGlobalDiagnostics() {
          return rootNames.length ? ts3.sortAndDeduplicateDiagnostics(getTypeChecker().getGlobalDiagnostics().slice()) : ts3.emptyArray;
        }
        function getConfigFileParsingDiagnostics2() {
          return configFileParsingDiagnostics || ts3.emptyArray;
        }
        function processRootFile(fileName2, isDefaultLib, ignoreNoDefaultLib, reason) {
          processSourceFile(ts3.normalizePath(fileName2), isDefaultLib, ignoreNoDefaultLib, void 0, reason);
        }
        function fileReferenceIsEqualTo(a, b) {
          return a.fileName === b.fileName;
        }
        function moduleNameIsEqualTo(a, b) {
          return a.kind === 79 ? b.kind === 79 && a.escapedText === b.escapedText : b.kind === 10 && a.text === b.text;
        }
        function createSyntheticImport(text, file) {
          var externalHelpersModuleReference = ts3.factory.createStringLiteral(text);
          var importDecl = ts3.factory.createImportDeclaration(void 0, void 0, void 0, externalHelpersModuleReference, void 0);
          ts3.addEmitFlags(importDecl, 67108864);
          ts3.setParent(externalHelpersModuleReference, importDecl);
          ts3.setParent(importDecl, file);
          externalHelpersModuleReference.flags &= ~8;
          importDecl.flags &= ~8;
          return externalHelpersModuleReference;
        }
        function collectExternalModuleReferences(file) {
          if (file.imports) {
            return;
          }
          var isJavaScriptFile = ts3.isSourceFileJS(file);
          var isExternalModuleFile = ts3.isExternalModule(file);
          var imports;
          var moduleAugmentations;
          var ambientModules;
          if ((options.isolatedModules || isExternalModuleFile) && !file.isDeclarationFile) {
            if (options.importHelpers) {
              imports = [createSyntheticImport(ts3.externalHelpersModuleNameText, file)];
            }
            var jsxImport = ts3.getJSXRuntimeImport(ts3.getJSXImplicitImportBase(options, file), options);
            if (jsxImport) {
              (imports || (imports = [])).push(createSyntheticImport(jsxImport, file));
            }
          }
          for (var _i2 = 0, _a2 = file.statements; _i2 < _a2.length; _i2++) {
            var node = _a2[_i2];
            collectModuleReferences(node, false);
          }
          if (file.flags & 2097152 || isJavaScriptFile) {
            collectDynamicImportOrRequireCalls(file);
          }
          file.imports = imports || ts3.emptyArray;
          file.moduleAugmentations = moduleAugmentations || ts3.emptyArray;
          file.ambientModuleNames = ambientModules || ts3.emptyArray;
          return;
          function collectModuleReferences(node2, inAmbientModule) {
            if (ts3.isAnyImportOrReExport(node2)) {
              var moduleNameExpr = ts3.getExternalModuleName(node2);
              if (moduleNameExpr && ts3.isStringLiteral(moduleNameExpr) && moduleNameExpr.text && (!inAmbientModule || !ts3.isExternalModuleNameRelative(moduleNameExpr.text))) {
                ts3.setParentRecursive(node2, false);
                imports = ts3.append(imports, moduleNameExpr);
                if (!usesUriStyleNodeCoreModules && currentNodeModulesDepth === 0 && !file.isDeclarationFile) {
                  usesUriStyleNodeCoreModules = ts3.startsWith(moduleNameExpr.text, "node:");
                }
              }
            } else if (ts3.isModuleDeclaration(node2)) {
              if (ts3.isAmbientModule(node2) && (inAmbientModule || ts3.hasSyntacticModifier(node2, 2) || file.isDeclarationFile)) {
                node2.name.parent = node2;
                var nameText = ts3.getTextOfIdentifierOrLiteral(node2.name);
                if (isExternalModuleFile || inAmbientModule && !ts3.isExternalModuleNameRelative(nameText)) {
                  (moduleAugmentations || (moduleAugmentations = [])).push(node2.name);
                } else if (!inAmbientModule) {
                  if (file.isDeclarationFile) {
                    (ambientModules || (ambientModules = [])).push(nameText);
                  }
                  var body = node2.body;
                  if (body) {
                    for (var _i3 = 0, _a3 = body.statements; _i3 < _a3.length; _i3++) {
                      var statement = _a3[_i3];
                      collectModuleReferences(statement, true);
                    }
                  }
                }
              }
            }
          }
          function collectDynamicImportOrRequireCalls(file2) {
            var r = /import|require/g;
            while (r.exec(file2.text) !== null) {
              var node2 = getNodeAtPosition(file2, r.lastIndex);
              if (isJavaScriptFile && ts3.isRequireCall(node2, true)) {
                ts3.setParentRecursive(node2, false);
                imports = ts3.append(imports, node2.arguments[0]);
              } else if (ts3.isImportCall(node2) && node2.arguments.length >= 1 && ts3.isStringLiteralLike(node2.arguments[0])) {
                ts3.setParentRecursive(node2, false);
                imports = ts3.append(imports, node2.arguments[0]);
              } else if (ts3.isLiteralImportTypeNode(node2)) {
                ts3.setParentRecursive(node2, false);
                imports = ts3.append(imports, node2.argument.literal);
              }
            }
          }
          function getNodeAtPosition(sourceFile, position) {
            var current = sourceFile;
            var getContainingChild = function(child2) {
              if (child2.pos <= position && (position < child2.end || position === child2.end && child2.kind === 1)) {
                return child2;
              }
            };
            while (true) {
              var child = isJavaScriptFile && ts3.hasJSDocNodes(current) && ts3.forEach(current.jsDoc, getContainingChild) || ts3.forEachChild(current, getContainingChild);
              if (!child) {
                return current;
              }
              current = child;
            }
          }
        }
        function getLibFileFromReference(ref) {
          var libName = ts3.toFileNameLowerCase(ref.fileName);
          var libFileName = ts3.libMap.get(libName);
          if (libFileName) {
            return getSourceFile(pathForLibFile(libFileName));
          }
        }
        function getSourceFileFromReference(referencingFile, ref) {
          return getSourceFileFromReferenceWorker(resolveTripleslashReference(ref.fileName, referencingFile.fileName), getSourceFile);
        }
        function getSourceFileFromReferenceWorker(fileName2, getSourceFile2, fail, reason) {
          if (ts3.hasExtension(fileName2)) {
            var canonicalFileName_1 = host.getCanonicalFileName(fileName2);
            if (!options.allowNonTsExtensions && !ts3.forEach(ts3.flatten(supportedExtensionsWithJsonIfResolveJsonModule), function(extension) {
              return ts3.fileExtensionIs(canonicalFileName_1, extension);
            })) {
              if (fail) {
                if (ts3.hasJSFileExtension(canonicalFileName_1)) {
                  fail(ts3.Diagnostics.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option, fileName2);
                } else {
                  fail(ts3.Diagnostics.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1, fileName2, "'" + ts3.flatten(supportedExtensions).join("', '") + "'");
                }
              }
              return void 0;
            }
            var sourceFile = getSourceFile2(fileName2);
            if (fail) {
              if (!sourceFile) {
                var redirect = getProjectReferenceRedirect(fileName2);
                if (redirect) {
                  fail(ts3.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, fileName2);
                } else {
                  fail(ts3.Diagnostics.File_0_not_found, fileName2);
                }
              } else if (isReferencedFile(reason) && canonicalFileName_1 === host.getCanonicalFileName(getSourceFileByPath(reason.file).fileName)) {
                fail(ts3.Diagnostics.A_file_cannot_have_a_reference_to_itself);
              }
            }
            return sourceFile;
          } else {
            var sourceFileNoExtension = options.allowNonTsExtensions && getSourceFile2(fileName2);
            if (sourceFileNoExtension)
              return sourceFileNoExtension;
            if (fail && options.allowNonTsExtensions) {
              fail(ts3.Diagnostics.File_0_not_found, fileName2);
              return void 0;
            }
            var sourceFileWithAddedExtension = ts3.forEach(supportedExtensions[0], function(extension) {
              return getSourceFile2(fileName2 + extension);
            });
            if (fail && !sourceFileWithAddedExtension)
              fail(ts3.Diagnostics.Could_not_resolve_the_path_0_with_the_extensions_Colon_1, fileName2, "'" + ts3.flatten(supportedExtensions).join("', '") + "'");
            return sourceFileWithAddedExtension;
          }
        }
        function processSourceFile(fileName2, isDefaultLib, ignoreNoDefaultLib, packageId, reason) {
          getSourceFileFromReferenceWorker(fileName2, function(fileName3) {
            return findSourceFile(fileName3, isDefaultLib, ignoreNoDefaultLib, reason, packageId);
          }, function(diagnostic) {
            var args = [];
            for (var _i2 = 1; _i2 < arguments.length; _i2++) {
              args[_i2 - 1] = arguments[_i2];
            }
            return addFilePreprocessingFileExplainingDiagnostic(void 0, reason, diagnostic, args);
          }, reason);
        }
        function processProjectReferenceFile(fileName2, reason) {
          return processSourceFile(fileName2, false, false, void 0, reason);
        }
        function reportFileNamesDifferOnlyInCasingError(fileName2, existingFile, reason) {
          var hasExistingReasonToReportErrorOn = !isReferencedFile(reason) && ts3.some(fileReasons.get(existingFile.path), isReferencedFile);
          if (hasExistingReasonToReportErrorOn) {
            addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, ts3.Diagnostics.Already_included_file_name_0_differs_from_file_name_1_only_in_casing, [existingFile.fileName, fileName2]);
          } else {
            addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, ts3.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing, [fileName2, existingFile.fileName]);
          }
        }
        function createRedirectSourceFile(redirectTarget, unredirected, fileName2, path2, resolvedPath, originalFileName) {
          var redirect = Object.create(redirectTarget);
          redirect.fileName = fileName2;
          redirect.path = path2;
          redirect.resolvedPath = resolvedPath;
          redirect.originalFileName = originalFileName;
          redirect.redirectInfo = { redirectTarget, unredirected };
          sourceFilesFoundSearchingNodeModules.set(path2, currentNodeModulesDepth > 0);
          Object.defineProperties(redirect, {
            id: {
              get: function() {
                return this.redirectInfo.redirectTarget.id;
              },
              set: function(value) {
                this.redirectInfo.redirectTarget.id = value;
              }
            },
            symbol: {
              get: function() {
                return this.redirectInfo.redirectTarget.symbol;
              },
              set: function(value) {
                this.redirectInfo.redirectTarget.symbol = value;
              }
            }
          });
          return redirect;
        }
        function findSourceFile(fileName2, isDefaultLib, ignoreNoDefaultLib, reason, packageId) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "findSourceFile", {
            fileName: fileName2,
            isDefaultLib: isDefaultLib || void 0,
            fileIncludeKind: ts3.FileIncludeKind[reason.kind]
          });
          var result2 = findSourceFileWorker(fileName2, isDefaultLib, ignoreNoDefaultLib, reason, packageId);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function getCreateSourceFileOptions(fileName2, moduleResolutionCache2, host2, options2) {
          var impliedNodeFormat = getImpliedNodeFormatForFile(toPath(fileName2), moduleResolutionCache2 === null || moduleResolutionCache2 === void 0 ? void 0 : moduleResolutionCache2.getPackageJsonInfoCache(), host2, options2);
          return {
            languageVersion: ts3.getEmitScriptTarget(options2),
            impliedNodeFormat,
            setExternalModuleIndicator: ts3.getSetExternalModuleIndicator(options2)
          };
        }
        function findSourceFileWorker(fileName2, isDefaultLib, ignoreNoDefaultLib, reason, packageId) {
          var path2 = toPath(fileName2);
          if (useSourceOfProjectReferenceRedirect) {
            var source = getSourceOfProjectReferenceRedirect(path2);
            if (!source && host.realpath && options.preserveSymlinks && ts3.isDeclarationFileName(fileName2) && ts3.stringContains(fileName2, ts3.nodeModulesPathPart)) {
              var realPath = toPath(host.realpath(fileName2));
              if (realPath !== path2)
                source = getSourceOfProjectReferenceRedirect(realPath);
            }
            if (source) {
              var file_1 = ts3.isString(source) ? findSourceFile(source, isDefaultLib, ignoreNoDefaultLib, reason, packageId) : void 0;
              if (file_1)
                addFileToFilesByName(file_1, path2, void 0);
              return file_1;
            }
          }
          var originalFileName = fileName2;
          if (filesByName.has(path2)) {
            var file_2 = filesByName.get(path2);
            addFileIncludeReason(file_2 || void 0, reason);
            if (file_2 && options.forceConsistentCasingInFileNames) {
              var checkedName = file_2.fileName;
              var isRedirect = toPath(checkedName) !== toPath(fileName2);
              if (isRedirect) {
                fileName2 = getProjectReferenceRedirect(fileName2) || fileName2;
              }
              var checkedAbsolutePath = ts3.getNormalizedAbsolutePathWithoutRoot(checkedName, currentDirectory);
              var inputAbsolutePath = ts3.getNormalizedAbsolutePathWithoutRoot(fileName2, currentDirectory);
              if (checkedAbsolutePath !== inputAbsolutePath) {
                reportFileNamesDifferOnlyInCasingError(fileName2, file_2, reason);
              }
            }
            if (file_2 && sourceFilesFoundSearchingNodeModules.get(file_2.path) && currentNodeModulesDepth === 0) {
              sourceFilesFoundSearchingNodeModules.set(file_2.path, false);
              if (!options.noResolve) {
                processReferencedFiles(file_2, isDefaultLib);
                processTypeReferenceDirectives(file_2);
              }
              if (!options.noLib) {
                processLibReferenceDirectives(file_2);
              }
              modulesWithElidedImports.set(file_2.path, false);
              processImportedModules(file_2);
            } else if (file_2 && modulesWithElidedImports.get(file_2.path)) {
              if (currentNodeModulesDepth < maxNodeModuleJsDepth) {
                modulesWithElidedImports.set(file_2.path, false);
                processImportedModules(file_2);
              }
            }
            return file_2 || void 0;
          }
          var redirectedPath;
          if (isReferencedFile(reason) && !useSourceOfProjectReferenceRedirect) {
            var redirectProject = getProjectReferenceRedirectProject(fileName2);
            if (redirectProject) {
              if (ts3.outFile(redirectProject.commandLine.options)) {
                return void 0;
              }
              var redirect = getProjectReferenceOutputName(redirectProject, fileName2);
              fileName2 = redirect;
              redirectedPath = toPath(redirect);
            }
          }
          var file = host.getSourceFile(fileName2, getCreateSourceFileOptions(fileName2, moduleResolutionCache, host, options), function(hostErrorMessage) {
            return addFilePreprocessingFileExplainingDiagnostic(void 0, reason, ts3.Diagnostics.Cannot_read_file_0_Colon_1, [fileName2, hostErrorMessage]);
          }, shouldCreateNewSourceFile);
          if (packageId) {
            var packageIdKey = ts3.packageIdToString(packageId);
            var fileFromPackageId = packageIdToSourceFile.get(packageIdKey);
            if (fileFromPackageId) {
              var dupFile = createRedirectSourceFile(fileFromPackageId, file, fileName2, path2, toPath(fileName2), originalFileName);
              redirectTargetsMap.add(fileFromPackageId.path, fileName2);
              addFileToFilesByName(dupFile, path2, redirectedPath);
              addFileIncludeReason(dupFile, reason);
              sourceFileToPackageName.set(path2, ts3.packageIdToPackageName(packageId));
              processingOtherFiles.push(dupFile);
              return dupFile;
            } else if (file) {
              packageIdToSourceFile.set(packageIdKey, file);
              sourceFileToPackageName.set(path2, ts3.packageIdToPackageName(packageId));
            }
          }
          addFileToFilesByName(file, path2, redirectedPath);
          if (file) {
            sourceFilesFoundSearchingNodeModules.set(path2, currentNodeModulesDepth > 0);
            file.fileName = fileName2;
            file.path = path2;
            file.resolvedPath = toPath(fileName2);
            file.originalFileName = originalFileName;
            addFileIncludeReason(file, reason);
            if (host.useCaseSensitiveFileNames()) {
              var pathLowerCase = ts3.toFileNameLowerCase(path2);
              var existingFile = filesByNameIgnoreCase.get(pathLowerCase);
              if (existingFile) {
                reportFileNamesDifferOnlyInCasingError(fileName2, existingFile, reason);
              } else {
                filesByNameIgnoreCase.set(pathLowerCase, file);
              }
            }
            skipDefaultLib = skipDefaultLib || file.hasNoDefaultLib && !ignoreNoDefaultLib;
            if (!options.noResolve) {
              processReferencedFiles(file, isDefaultLib);
              processTypeReferenceDirectives(file);
            }
            if (!options.noLib) {
              processLibReferenceDirectives(file);
            }
            processImportedModules(file);
            if (isDefaultLib) {
              processingDefaultLibFiles.push(file);
            } else {
              processingOtherFiles.push(file);
            }
          }
          return file;
        }
        function addFileIncludeReason(file, reason) {
          if (file)
            fileReasons.add(file.path, reason);
        }
        function addFileToFilesByName(file, path2, redirectedPath) {
          if (redirectedPath) {
            filesByName.set(redirectedPath, file);
            filesByName.set(path2, file || false);
          } else {
            filesByName.set(path2, file);
          }
        }
        function getProjectReferenceRedirect(fileName2) {
          var referencedProject = getProjectReferenceRedirectProject(fileName2);
          return referencedProject && getProjectReferenceOutputName(referencedProject, fileName2);
        }
        function getProjectReferenceRedirectProject(fileName2) {
          if (!resolvedProjectReferences || !resolvedProjectReferences.length || ts3.isDeclarationFileName(fileName2) || ts3.fileExtensionIs(fileName2, ".json")) {
            return void 0;
          }
          return getResolvedProjectReferenceToRedirect(fileName2);
        }
        function getProjectReferenceOutputName(referencedProject, fileName2) {
          var out = ts3.outFile(referencedProject.commandLine.options);
          return out ? ts3.changeExtension(out, ".d.ts") : ts3.getOutputDeclarationFileName(fileName2, referencedProject.commandLine, !host.useCaseSensitiveFileNames());
        }
        function getResolvedProjectReferenceToRedirect(fileName2) {
          if (mapFromFileToProjectReferenceRedirects === void 0) {
            mapFromFileToProjectReferenceRedirects = new ts3.Map();
            forEachResolvedProjectReference2(function(referencedProject) {
              if (toPath(options.configFilePath) !== referencedProject.sourceFile.path) {
                referencedProject.commandLine.fileNames.forEach(function(f) {
                  return mapFromFileToProjectReferenceRedirects.set(toPath(f), referencedProject.sourceFile.path);
                });
              }
            });
          }
          var referencedProjectPath = mapFromFileToProjectReferenceRedirects.get(toPath(fileName2));
          return referencedProjectPath && getResolvedProjectReferenceByPath(referencedProjectPath);
        }
        function forEachResolvedProjectReference2(cb) {
          return ts3.forEachResolvedProjectReference(resolvedProjectReferences, cb);
        }
        function getSourceOfProjectReferenceRedirect(path2) {
          if (!ts3.isDeclarationFileName(path2))
            return void 0;
          if (mapFromToProjectReferenceRedirectSource === void 0) {
            mapFromToProjectReferenceRedirectSource = new ts3.Map();
            forEachResolvedProjectReference2(function(resolvedRef) {
              var out = ts3.outFile(resolvedRef.commandLine.options);
              if (out) {
                var outputDts = ts3.changeExtension(out, ".d.ts");
                mapFromToProjectReferenceRedirectSource.set(toPath(outputDts), true);
              } else {
                var getCommonSourceDirectory_3 = ts3.memoize(function() {
                  return ts3.getCommonSourceDirectoryOfConfig(resolvedRef.commandLine, !host.useCaseSensitiveFileNames());
                });
                ts3.forEach(resolvedRef.commandLine.fileNames, function(fileName2) {
                  if (!ts3.isDeclarationFileName(fileName2) && !ts3.fileExtensionIs(fileName2, ".json")) {
                    var outputDts2 = ts3.getOutputDeclarationFileName(fileName2, resolvedRef.commandLine, !host.useCaseSensitiveFileNames(), getCommonSourceDirectory_3);
                    mapFromToProjectReferenceRedirectSource.set(toPath(outputDts2), fileName2);
                  }
                });
              }
            });
          }
          return mapFromToProjectReferenceRedirectSource.get(path2);
        }
        function isSourceOfProjectReferenceRedirect(fileName2) {
          return useSourceOfProjectReferenceRedirect && !!getResolvedProjectReferenceToRedirect(fileName2);
        }
        function getResolvedProjectReferenceByPath(projectReferencePath) {
          if (!projectReferenceRedirects) {
            return void 0;
          }
          return projectReferenceRedirects.get(projectReferencePath) || void 0;
        }
        function processReferencedFiles(file, isDefaultLib) {
          ts3.forEach(file.referencedFiles, function(ref, index) {
            processSourceFile(resolveTripleslashReference(ref.fileName, file.fileName), isDefaultLib, false, void 0, { kind: ts3.FileIncludeKind.ReferenceFile, file: file.path, index });
          });
        }
        function processTypeReferenceDirectives(file) {
          var typeDirectives = file.typeReferenceDirectives;
          if (!typeDirectives) {
            return;
          }
          var resolutions2 = resolveTypeReferenceDirectiveNamesWorker(typeDirectives, file);
          for (var index = 0; index < typeDirectives.length; index++) {
            var ref = file.typeReferenceDirectives[index];
            var resolvedTypeReferenceDirective = resolutions2[index];
            var fileName2 = ts3.toFileNameLowerCase(ref.fileName);
            ts3.setResolvedTypeReferenceDirective(file, fileName2, resolvedTypeReferenceDirective);
            var mode = ref.resolutionMode || file.impliedNodeFormat;
            if (mode && ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.Node16 && ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.NodeNext) {
              programDiagnostics.add(ts3.createDiagnosticForRange(file, ref, ts3.Diagnostics.resolution_mode_assertions_are_only_supported_when_moduleResolution_is_node16_or_nodenext));
            }
            processTypeReferenceDirective(fileName2, mode, resolvedTypeReferenceDirective, { kind: ts3.FileIncludeKind.TypeReferenceDirective, file: file.path, index });
          }
        }
        function processTypeReferenceDirective(typeReferenceDirective, mode, resolvedTypeReferenceDirective, reason) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "processTypeReferenceDirective", { directive: typeReferenceDirective, hasResolved: !!resolveModuleNamesReusingOldState, refKind: reason.kind, refPath: isReferencedFile(reason) ? reason.file : void 0 });
          processTypeReferenceDirectiveWorker(typeReferenceDirective, mode, resolvedTypeReferenceDirective, reason);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function processTypeReferenceDirectiveWorker(typeReferenceDirective, mode, resolvedTypeReferenceDirective, reason) {
          var previousResolution = resolvedTypeReferenceDirectives.get(typeReferenceDirective, mode);
          if (previousResolution && previousResolution.primary) {
            return;
          }
          var saveResolution = true;
          if (resolvedTypeReferenceDirective) {
            if (resolvedTypeReferenceDirective.isExternalLibraryImport)
              currentNodeModulesDepth++;
            if (resolvedTypeReferenceDirective.primary) {
              processSourceFile(resolvedTypeReferenceDirective.resolvedFileName, false, false, resolvedTypeReferenceDirective.packageId, reason);
            } else {
              if (previousResolution) {
                if (resolvedTypeReferenceDirective.resolvedFileName !== previousResolution.resolvedFileName) {
                  var otherFileText = host.readFile(resolvedTypeReferenceDirective.resolvedFileName);
                  var existingFile = getSourceFile(previousResolution.resolvedFileName);
                  if (otherFileText !== existingFile.text) {
                    addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, ts3.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict, [typeReferenceDirective, resolvedTypeReferenceDirective.resolvedFileName, previousResolution.resolvedFileName]);
                  }
                }
                saveResolution = false;
              } else {
                processSourceFile(resolvedTypeReferenceDirective.resolvedFileName, false, false, resolvedTypeReferenceDirective.packageId, reason);
              }
            }
            if (resolvedTypeReferenceDirective.isExternalLibraryImport)
              currentNodeModulesDepth--;
          } else {
            addFilePreprocessingFileExplainingDiagnostic(void 0, reason, ts3.Diagnostics.Cannot_find_type_definition_file_for_0, [typeReferenceDirective]);
          }
          if (saveResolution) {
            resolvedTypeReferenceDirectives.set(typeReferenceDirective, mode, resolvedTypeReferenceDirective);
          }
        }
        function pathForLibFile(libFileName) {
          var components = libFileName.split(".");
          var path2 = components[1];
          var i2 = 2;
          while (components[i2] && components[i2] !== "d") {
            path2 += (i2 === 2 ? "/" : "-") + components[i2];
            i2++;
          }
          var resolveFrom = ts3.combinePaths(currentDirectory, "__lib_node_modules_lookup_".concat(libFileName, "__.ts"));
          var localOverrideModuleResult = ts3.resolveModuleName("@typescript/lib-" + path2, resolveFrom, { moduleResolution: ts3.ModuleResolutionKind.NodeJs }, host, moduleResolutionCache);
          if (localOverrideModuleResult === null || localOverrideModuleResult === void 0 ? void 0 : localOverrideModuleResult.resolvedModule) {
            return localOverrideModuleResult.resolvedModule.resolvedFileName;
          }
          return ts3.combinePaths(defaultLibraryPath, libFileName);
        }
        function processLibReferenceDirectives(file) {
          ts3.forEach(file.libReferenceDirectives, function(libReference, index) {
            var libName = ts3.toFileNameLowerCase(libReference.fileName);
            var libFileName = ts3.libMap.get(libName);
            if (libFileName) {
              processRootFile(pathForLibFile(libFileName), true, true, { kind: ts3.FileIncludeKind.LibReferenceDirective, file: file.path, index });
            } else {
              var unqualifiedLibName = ts3.removeSuffix(ts3.removePrefix(libName, "lib."), ".d.ts");
              var suggestion = ts3.getSpellingSuggestion(unqualifiedLibName, ts3.libs, ts3.identity);
              var diagnostic = suggestion ? ts3.Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1 : ts3.Diagnostics.Cannot_find_lib_definition_for_0;
              (fileProcessingDiagnostics || (fileProcessingDiagnostics = [])).push({
                kind: 0,
                reason: { kind: ts3.FileIncludeKind.LibReferenceDirective, file: file.path, index },
                diagnostic,
                args: [libName, suggestion]
              });
            }
          });
        }
        function getCanonicalFileName(fileName2) {
          return host.getCanonicalFileName(fileName2);
        }
        function processImportedModules(file) {
          var _a2;
          collectExternalModuleReferences(file);
          if (file.imports.length || file.moduleAugmentations.length) {
            var moduleNames = getModuleNames(file);
            var resolutions2 = resolveModuleNamesReusingOldState(moduleNames, file);
            ts3.Debug.assert(resolutions2.length === moduleNames.length);
            var optionsForFile = (useSourceOfProjectReferenceRedirect ? (_a2 = getRedirectReferenceForResolution(file)) === null || _a2 === void 0 ? void 0 : _a2.commandLine.options : void 0) || options;
            for (var index = 0; index < moduleNames.length; index++) {
              var resolution = resolutions2[index];
              ts3.setResolvedModule(file, moduleNames[index], resolution, getModeForResolutionAtIndex(file, index));
              if (!resolution) {
                continue;
              }
              var isFromNodeModulesSearch = resolution.isExternalLibraryImport;
              var isJsFile = !ts3.resolutionExtensionIsTSOrJson(resolution.extension);
              var isJsFileFromNodeModules = isFromNodeModulesSearch && isJsFile;
              var resolvedFileName = resolution.resolvedFileName;
              if (isFromNodeModulesSearch) {
                currentNodeModulesDepth++;
              }
              var elideImport = isJsFileFromNodeModules && currentNodeModulesDepth > maxNodeModuleJsDepth;
              var shouldAddFile = resolvedFileName && !getResolutionDiagnostic(optionsForFile, resolution) && !optionsForFile.noResolve && index < file.imports.length && !elideImport && !(isJsFile && !ts3.getAllowJSCompilerOption(optionsForFile)) && (ts3.isInJSFile(file.imports[index]) || !(file.imports[index].flags & 8388608));
              if (elideImport) {
                modulesWithElidedImports.set(file.path, true);
              } else if (shouldAddFile) {
                findSourceFile(resolvedFileName, false, false, { kind: ts3.FileIncludeKind.Import, file: file.path, index }, resolution.packageId);
              }
              if (isFromNodeModulesSearch) {
                currentNodeModulesDepth--;
              }
            }
          } else {
            file.resolvedModules = void 0;
          }
        }
        function checkSourceFilesBelongToPath(sourceFiles, rootDirectory) {
          var allFilesBelongToPath = true;
          var absoluteRootDirectoryPath = host.getCanonicalFileName(ts3.getNormalizedAbsolutePath(rootDirectory, currentDirectory));
          for (var _i2 = 0, sourceFiles_2 = sourceFiles; _i2 < sourceFiles_2.length; _i2++) {
            var sourceFile = sourceFiles_2[_i2];
            if (!sourceFile.isDeclarationFile) {
              var absoluteSourceFilePath = host.getCanonicalFileName(ts3.getNormalizedAbsolutePath(sourceFile.fileName, currentDirectory));
              if (absoluteSourceFilePath.indexOf(absoluteRootDirectoryPath) !== 0) {
                addProgramDiagnosticExplainingFile(sourceFile, ts3.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files, [sourceFile.fileName, rootDirectory]);
                allFilesBelongToPath = false;
              }
            }
          }
          return allFilesBelongToPath;
        }
        function parseProjectReferenceConfigFile(ref) {
          if (!projectReferenceRedirects) {
            projectReferenceRedirects = new ts3.Map();
          }
          var refPath = resolveProjectReferencePath(ref);
          var sourceFilePath = toPath(refPath);
          var fromCache = projectReferenceRedirects.get(sourceFilePath);
          if (fromCache !== void 0) {
            return fromCache || void 0;
          }
          var commandLine;
          var sourceFile;
          if (host.getParsedCommandLine) {
            commandLine = host.getParsedCommandLine(refPath);
            if (!commandLine) {
              addFileToFilesByName(void 0, sourceFilePath, void 0);
              projectReferenceRedirects.set(sourceFilePath, false);
              return void 0;
            }
            sourceFile = ts3.Debug.checkDefined(commandLine.options.configFile);
            ts3.Debug.assert(!sourceFile.path || sourceFile.path === sourceFilePath);
            addFileToFilesByName(sourceFile, sourceFilePath, void 0);
          } else {
            var basePath = ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(refPath), host.getCurrentDirectory());
            sourceFile = host.getSourceFile(refPath, 100);
            addFileToFilesByName(sourceFile, sourceFilePath, void 0);
            if (sourceFile === void 0) {
              projectReferenceRedirects.set(sourceFilePath, false);
              return void 0;
            }
            commandLine = ts3.parseJsonSourceFileConfigFileContent(sourceFile, configParsingHost, basePath, void 0, refPath);
          }
          sourceFile.fileName = refPath;
          sourceFile.path = sourceFilePath;
          sourceFile.resolvedPath = sourceFilePath;
          sourceFile.originalFileName = refPath;
          var resolvedRef = { commandLine, sourceFile };
          projectReferenceRedirects.set(sourceFilePath, resolvedRef);
          if (commandLine.projectReferences) {
            resolvedRef.references = commandLine.projectReferences.map(parseProjectReferenceConfigFile);
          }
          return resolvedRef;
        }
        function verifyCompilerOptions() {
          if (options.strictPropertyInitialization && !ts3.getStrictOptionValue(options, "strictNullChecks")) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "strictPropertyInitialization", "strictNullChecks");
          }
          if (options.exactOptionalPropertyTypes && !ts3.getStrictOptionValue(options, "strictNullChecks")) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "exactOptionalPropertyTypes", "strictNullChecks");
          }
          if (options.isolatedModules) {
            if (options.out) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "isolatedModules");
            }
            if (options.outFile) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "outFile", "isolatedModules");
            }
          }
          if (options.inlineSourceMap) {
            if (options.sourceMap) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "sourceMap", "inlineSourceMap");
            }
            if (options.mapRoot) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "mapRoot", "inlineSourceMap");
            }
          }
          if (options.composite) {
            if (options.declaration === false) {
              createDiagnosticForOptionName(ts3.Diagnostics.Composite_projects_may_not_disable_declaration_emit, "declaration");
            }
            if (options.incremental === false) {
              createDiagnosticForOptionName(ts3.Diagnostics.Composite_projects_may_not_disable_incremental_compilation, "declaration");
            }
          }
          var outputFile = ts3.outFile(options);
          if (options.tsBuildInfoFile) {
            if (!ts3.isIncrementalCompilation(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "tsBuildInfoFile", "incremental", "composite");
            }
          } else if (options.incremental && !outputFile && !options.configFilePath) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified));
          }
          verifyProjectReferences();
          if (options.composite) {
            var rootPaths = new ts3.Set(rootNames.map(toPath));
            for (var _i2 = 0, files_4 = files; _i2 < files_4.length; _i2++) {
              var file = files_4[_i2];
              if (ts3.sourceFileMayBeEmitted(file, program2) && !rootPaths.has(file.path)) {
                addProgramDiagnosticExplainingFile(file, ts3.Diagnostics.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern, [file.fileName, options.configFilePath || ""]);
              }
            }
          }
          if (options.paths) {
            for (var key in options.paths) {
              if (!ts3.hasProperty(options.paths, key)) {
                continue;
              }
              if (!ts3.hasZeroOrOneAsteriskCharacter(key)) {
                createDiagnosticForOptionPaths(true, key, ts3.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, key);
              }
              if (ts3.isArray(options.paths[key])) {
                var len = options.paths[key].length;
                if (len === 0) {
                  createDiagnosticForOptionPaths(false, key, ts3.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array, key);
                }
                for (var i2 = 0; i2 < len; i2++) {
                  var subst = options.paths[key][i2];
                  var typeOfSubst = typeof subst;
                  if (typeOfSubst === "string") {
                    if (!ts3.hasZeroOrOneAsteriskCharacter(subst)) {
                      createDiagnosticForOptionPathKeyValue(key, i2, ts3.Diagnostics.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character, subst, key);
                    }
                    if (!options.baseUrl && !ts3.pathIsRelative(subst) && !ts3.pathIsAbsolute(subst)) {
                      createDiagnosticForOptionPathKeyValue(key, i2, ts3.Diagnostics.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash);
                    }
                  } else {
                    createDiagnosticForOptionPathKeyValue(key, i2, ts3.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2, subst, key, typeOfSubst);
                  }
                }
              } else {
                createDiagnosticForOptionPaths(false, key, ts3.Diagnostics.Substitutions_for_pattern_0_should_be_an_array, key);
              }
            }
          }
          if (!options.sourceMap && !options.inlineSourceMap) {
            if (options.inlineSources) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "inlineSources");
            }
            if (options.sourceRoot) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "sourceRoot");
            }
          }
          if (options.out && options.outFile) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "outFile");
          }
          if (options.mapRoot && !(options.sourceMap || options.declarationMap)) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "mapRoot", "sourceMap", "declarationMap");
          }
          if (options.declarationDir) {
            if (!ts3.getEmitDeclarations(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationDir", "declaration", "composite");
            }
            if (outputFile) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "declarationDir", options.out ? "out" : "outFile");
            }
          }
          if (options.declarationMap && !ts3.getEmitDeclarations(options)) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationMap", "declaration", "composite");
          }
          if (options.lib && options.noLib) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "lib", "noLib");
          }
          if (options.noImplicitUseStrict && ts3.getStrictOptionValue(options, "alwaysStrict")) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "noImplicitUseStrict", "alwaysStrict");
          }
          var languageVersion = ts3.getEmitScriptTarget(options);
          var firstNonAmbientExternalModuleSourceFile = ts3.find(files, function(f) {
            return ts3.isExternalModule(f) && !f.isDeclarationFile;
          });
          if (options.isolatedModules) {
            if (options.module === ts3.ModuleKind.None && languageVersion < 2) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher, "isolatedModules", "target");
            }
            if (options.preserveConstEnums === false) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled, "preserveConstEnums", "isolatedModules");
            }
            var firstNonExternalModuleSourceFile = ts3.find(files, function(f) {
              return !ts3.isExternalModule(f) && !ts3.isSourceFileJS(f) && !f.isDeclarationFile && f.scriptKind !== 6;
            });
            if (firstNonExternalModuleSourceFile) {
              var span = ts3.getErrorSpanForNode(firstNonExternalModuleSourceFile, firstNonExternalModuleSourceFile);
              programDiagnostics.add(ts3.createFileDiagnostic(firstNonExternalModuleSourceFile, span.start, span.length, ts3.Diagnostics._0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module, ts3.getBaseFileName(firstNonExternalModuleSourceFile.fileName)));
            }
          } else if (firstNonAmbientExternalModuleSourceFile && languageVersion < 2 && options.module === ts3.ModuleKind.None) {
            var span = ts3.getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, typeof firstNonAmbientExternalModuleSourceFile.externalModuleIndicator === "boolean" ? firstNonAmbientExternalModuleSourceFile : firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
            programDiagnostics.add(ts3.createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, ts3.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none));
          }
          if (outputFile && !options.emitDeclarationOnly) {
            if (options.module && !(options.module === ts3.ModuleKind.AMD || options.module === ts3.ModuleKind.System)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0, options.out ? "out" : "outFile", "module");
            } else if (options.module === void 0 && firstNonAmbientExternalModuleSourceFile) {
              var span = ts3.getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, typeof firstNonAmbientExternalModuleSourceFile.externalModuleIndicator === "boolean" ? firstNonAmbientExternalModuleSourceFile : firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
              programDiagnostics.add(ts3.createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, ts3.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system, options.out ? "out" : "outFile"));
            }
          }
          if (options.resolveJsonModule) {
            if (ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.NodeJs && ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.Node16 && ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.NodeNext) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy, "resolveJsonModule");
            } else if (!ts3.hasJsonModuleEmitEnabled(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext, "resolveJsonModule", "module");
            }
          }
          if (options.outDir || options.rootDir || options.sourceRoot || options.mapRoot) {
            var dir = getCommonSourceDirectory();
            if (options.outDir && dir === "" && files.some(function(file2) {
              return ts3.getRootLength(file2.fileName) > 1;
            })) {
              createDiagnosticForOptionName(ts3.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files, "outDir");
            }
          }
          if (options.useDefineForClassFields && languageVersion === 0) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_target_is_ES3, "useDefineForClassFields");
          }
          if (options.checkJs && !ts3.getAllowJSCompilerOption(options)) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "checkJs", "allowJs"));
          }
          if (options.emitDeclarationOnly) {
            if (!ts3.getEmitDeclarations(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "emitDeclarationOnly", "declaration", "composite");
            }
            if (options.noEmit) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "emitDeclarationOnly", "noEmit");
            }
          }
          if (options.emitDecoratorMetadata && !options.experimentalDecorators) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "emitDecoratorMetadata", "experimentalDecorators");
          }
          if (options.jsxFactory) {
            if (options.reactNamespace) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "reactNamespace", "jsxFactory");
            }
            if (options.jsx === 4 || options.jsx === 5) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFactory", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
            if (!ts3.parseIsolatedEntityName(options.jsxFactory, languageVersion)) {
              createOptionValueDiagnostic("jsxFactory", ts3.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFactory);
            }
          } else if (options.reactNamespace && !ts3.isIdentifierText(options.reactNamespace, languageVersion)) {
            createOptionValueDiagnostic("reactNamespace", ts3.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier, options.reactNamespace);
          }
          if (options.jsxFragmentFactory) {
            if (!options.jsxFactory) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "jsxFragmentFactory", "jsxFactory");
            }
            if (options.jsx === 4 || options.jsx === 5) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFragmentFactory", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
            if (!ts3.parseIsolatedEntityName(options.jsxFragmentFactory, languageVersion)) {
              createOptionValueDiagnostic("jsxFragmentFactory", ts3.Diagnostics.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFragmentFactory);
            }
          }
          if (options.reactNamespace) {
            if (options.jsx === 4 || options.jsx === 5) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "reactNamespace", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
          }
          if (options.jsxImportSource) {
            if (options.jsx === 2) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxImportSource", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
          }
          if (options.preserveValueImports && ts3.getEmitModuleKind(options) < ts3.ModuleKind.ES2015) {
            createOptionValueDiagnostic("importsNotUsedAsValues", ts3.Diagnostics.Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later);
          }
          if (!options.noEmit && !options.suppressOutputPathCheck) {
            var emitHost = getEmitHost();
            var emitFilesSeen_1 = new ts3.Set();
            ts3.forEachEmittedFile(emitHost, function(emitFileNames) {
              if (!options.emitDeclarationOnly) {
                verifyEmitFilePath(emitFileNames.jsFilePath, emitFilesSeen_1);
              }
              verifyEmitFilePath(emitFileNames.declarationFilePath, emitFilesSeen_1);
            });
          }
          function verifyEmitFilePath(emitFileName, emitFilesSeen) {
            if (emitFileName) {
              var emitFilePath = toPath(emitFileName);
              if (filesByName.has(emitFilePath)) {
                var chain = void 0;
                if (!options.configFilePath) {
                  chain = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig);
                }
                chain = ts3.chainDiagnosticMessages(chain, ts3.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file, emitFileName);
                blockEmittingOfFile(emitFileName, ts3.createCompilerDiagnosticFromMessageChain(chain));
              }
              var emitFileKey = !host.useCaseSensitiveFileNames() ? ts3.toFileNameLowerCase(emitFilePath) : emitFilePath;
              if (emitFilesSeen.has(emitFileKey)) {
                blockEmittingOfFile(emitFileName, ts3.createCompilerDiagnostic(ts3.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files, emitFileName));
              } else {
                emitFilesSeen.add(emitFileKey);
              }
            }
          }
        }
        function createDiagnosticExplainingFile(file, fileProcessingReason, diagnostic, args) {
          var _a2;
          var fileIncludeReasons;
          var relatedInfo;
          var locationReason = isReferencedFile(fileProcessingReason) ? fileProcessingReason : void 0;
          if (file)
            (_a2 = fileReasons.get(file.path)) === null || _a2 === void 0 ? void 0 : _a2.forEach(processReason);
          if (fileProcessingReason)
            processReason(fileProcessingReason);
          if (locationReason && (fileIncludeReasons === null || fileIncludeReasons === void 0 ? void 0 : fileIncludeReasons.length) === 1)
            fileIncludeReasons = void 0;
          var location = locationReason && getReferencedFileLocation(getSourceFileByPath, locationReason);
          var fileIncludeReasonDetails = fileIncludeReasons && ts3.chainDiagnosticMessages(fileIncludeReasons, ts3.Diagnostics.The_file_is_in_the_program_because_Colon);
          var redirectInfo = file && ts3.explainIfFileIsRedirect(file);
          var chain = ts3.chainDiagnosticMessages.apply(void 0, __spreadArray([redirectInfo ? fileIncludeReasonDetails ? __spreadArray([fileIncludeReasonDetails], redirectInfo, true) : redirectInfo : fileIncludeReasonDetails, diagnostic], args || ts3.emptyArray, false));
          return location && isReferenceFileLocation(location) ? ts3.createFileDiagnosticFromMessageChain(location.file, location.pos, location.end - location.pos, chain, relatedInfo) : ts3.createCompilerDiagnosticFromMessageChain(chain, relatedInfo);
          function processReason(reason) {
            (fileIncludeReasons || (fileIncludeReasons = [])).push(ts3.fileIncludeReasonToDiagnostics(program2, reason));
            if (!locationReason && isReferencedFile(reason)) {
              locationReason = reason;
            } else if (locationReason !== reason) {
              relatedInfo = ts3.append(relatedInfo, fileIncludeReasonToRelatedInformation(reason));
            }
            if (reason === fileProcessingReason)
              fileProcessingReason = void 0;
          }
        }
        function addFilePreprocessingFileExplainingDiagnostic(file, fileProcessingReason, diagnostic, args) {
          (fileProcessingDiagnostics || (fileProcessingDiagnostics = [])).push({
            kind: 1,
            file: file && file.path,
            fileProcessingReason,
            diagnostic,
            args
          });
        }
        function addProgramDiagnosticExplainingFile(file, diagnostic, args) {
          programDiagnostics.add(createDiagnosticExplainingFile(file, void 0, diagnostic, args));
        }
        function fileIncludeReasonToRelatedInformation(reason) {
          if (isReferencedFile(reason)) {
            var referenceLocation = getReferencedFileLocation(getSourceFileByPath, reason);
            var message_2;
            switch (reason.kind) {
              case ts3.FileIncludeKind.Import:
                message_2 = ts3.Diagnostics.File_is_included_via_import_here;
                break;
              case ts3.FileIncludeKind.ReferenceFile:
                message_2 = ts3.Diagnostics.File_is_included_via_reference_here;
                break;
              case ts3.FileIncludeKind.TypeReferenceDirective:
                message_2 = ts3.Diagnostics.File_is_included_via_type_library_reference_here;
                break;
              case ts3.FileIncludeKind.LibReferenceDirective:
                message_2 = ts3.Diagnostics.File_is_included_via_library_reference_here;
                break;
              default:
                ts3.Debug.assertNever(reason);
            }
            return isReferenceFileLocation(referenceLocation) ? ts3.createFileDiagnostic(referenceLocation.file, referenceLocation.pos, referenceLocation.end - referenceLocation.pos, message_2) : void 0;
          }
          if (!options.configFile)
            return void 0;
          var configFileNode;
          var message;
          switch (reason.kind) {
            case ts3.FileIncludeKind.RootFile:
              if (!options.configFile.configFileSpecs)
                return void 0;
              var fileName2 = ts3.getNormalizedAbsolutePath(rootNames[reason.index], currentDirectory);
              var matchedByFiles = ts3.getMatchedFileSpec(program2, fileName2);
              if (matchedByFiles) {
                configFileNode = ts3.getTsConfigPropArrayElementValue(options.configFile, "files", matchedByFiles);
                message = ts3.Diagnostics.File_is_matched_by_files_list_specified_here;
                break;
              }
              var matchedByInclude = ts3.getMatchedIncludeSpec(program2, fileName2);
              if (!matchedByInclude)
                return void 0;
              configFileNode = ts3.getTsConfigPropArrayElementValue(options.configFile, "include", matchedByInclude);
              message = ts3.Diagnostics.File_is_matched_by_include_pattern_specified_here;
              break;
            case ts3.FileIncludeKind.SourceFromProjectReference:
            case ts3.FileIncludeKind.OutputFromProjectReference:
              var referencedResolvedRef_1 = ts3.Debug.checkDefined(resolvedProjectReferences === null || resolvedProjectReferences === void 0 ? void 0 : resolvedProjectReferences[reason.index]);
              var referenceInfo = forEachProjectReference(projectReferences, resolvedProjectReferences, function(resolvedRef, parent, index2) {
                return resolvedRef === referencedResolvedRef_1 ? { sourceFile: (parent === null || parent === void 0 ? void 0 : parent.sourceFile) || options.configFile, index: index2 } : void 0;
              });
              if (!referenceInfo)
                return void 0;
              var sourceFile = referenceInfo.sourceFile, index = referenceInfo.index;
              var referencesSyntax = ts3.firstDefined(ts3.getTsConfigPropArray(sourceFile, "references"), function(property) {
                return ts3.isArrayLiteralExpression(property.initializer) ? property.initializer : void 0;
              });
              return referencesSyntax && referencesSyntax.elements.length > index ? ts3.createDiagnosticForNodeInSourceFile(sourceFile, referencesSyntax.elements[index], reason.kind === ts3.FileIncludeKind.OutputFromProjectReference ? ts3.Diagnostics.File_is_output_from_referenced_project_specified_here : ts3.Diagnostics.File_is_source_from_referenced_project_specified_here) : void 0;
            case ts3.FileIncludeKind.AutomaticTypeDirectiveFile:
              if (!options.types)
                return void 0;
              configFileNode = getOptionsSyntaxByArrayElementValue("types", reason.typeReference);
              message = ts3.Diagnostics.File_is_entry_point_of_type_library_specified_here;
              break;
            case ts3.FileIncludeKind.LibFile:
              if (reason.index !== void 0) {
                configFileNode = getOptionsSyntaxByArrayElementValue("lib", options.lib[reason.index]);
                message = ts3.Diagnostics.File_is_library_specified_here;
                break;
              }
              var target = ts3.forEachEntry(ts3.targetOptionDeclaration.type, function(value, key) {
                return value === ts3.getEmitScriptTarget(options) ? key : void 0;
              });
              configFileNode = target ? getOptionsSyntaxByValue("target", target) : void 0;
              message = ts3.Diagnostics.File_is_default_library_for_target_specified_here;
              break;
            default:
              ts3.Debug.assertNever(reason);
          }
          return configFileNode && ts3.createDiagnosticForNodeInSourceFile(options.configFile, configFileNode, message);
        }
        function verifyProjectReferences() {
          var buildInfoPath = !options.suppressOutputPathCheck ? ts3.getTsBuildInfoEmitOutputFilePath(options) : void 0;
          forEachProjectReference(projectReferences, resolvedProjectReferences, function(resolvedRef, parent, index) {
            var ref = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var parentFile = parent && parent.sourceFile;
            if (!resolvedRef) {
              createDiagnosticForReference(parentFile, index, ts3.Diagnostics.File_0_not_found, ref.path);
              return;
            }
            var options2 = resolvedRef.commandLine.options;
            if (!options2.composite || options2.noEmit) {
              var inputs = parent ? parent.commandLine.fileNames : rootNames;
              if (inputs.length) {
                if (!options2.composite)
                  createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true, ref.path);
                if (options2.noEmit)
                  createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Referenced_project_0_may_not_disable_emit, ref.path);
              }
            }
            if (ref.prepend) {
              var out = ts3.outFile(options2);
              if (out) {
                if (!host.fileExists(out)) {
                  createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Output_file_0_from_project_1_does_not_exist, out, ref.path);
                }
              } else {
                createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set, ref.path);
              }
            }
            if (!parent && buildInfoPath && buildInfoPath === ts3.getTsBuildInfoEmitOutputFilePath(options2)) {
              createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1, buildInfoPath, ref.path);
              hasEmitBlockingDiagnostics.set(toPath(buildInfoPath), true);
            }
          });
        }
        function createDiagnosticForOptionPathKeyValue(key, valueIndex, message, arg0, arg1, arg2) {
          var needCompilerDiagnostic = true;
          var pathsSyntax = getOptionPathsSyntax();
          for (var _i2 = 0, pathsSyntax_1 = pathsSyntax; _i2 < pathsSyntax_1.length; _i2++) {
            var pathProp = pathsSyntax_1[_i2];
            if (ts3.isObjectLiteralExpression(pathProp.initializer)) {
              for (var _a2 = 0, _b2 = ts3.getPropertyAssignment(pathProp.initializer, key); _a2 < _b2.length; _a2++) {
                var keyProps = _b2[_a2];
                var initializer = keyProps.initializer;
                if (ts3.isArrayLiteralExpression(initializer) && initializer.elements.length > valueIndex) {
                  programDiagnostics.add(ts3.createDiagnosticForNodeInSourceFile(options.configFile, initializer.elements[valueIndex], message, arg0, arg1, arg2));
                  needCompilerDiagnostic = false;
                }
              }
            }
          }
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0, arg1, arg2));
          }
        }
        function createDiagnosticForOptionPaths(onKey, key, message, arg0) {
          var needCompilerDiagnostic = true;
          var pathsSyntax = getOptionPathsSyntax();
          for (var _i2 = 0, pathsSyntax_2 = pathsSyntax; _i2 < pathsSyntax_2.length; _i2++) {
            var pathProp = pathsSyntax_2[_i2];
            if (ts3.isObjectLiteralExpression(pathProp.initializer) && createOptionDiagnosticInObjectLiteralSyntax(pathProp.initializer, onKey, key, void 0, message, arg0)) {
              needCompilerDiagnostic = false;
            }
          }
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0));
          }
        }
        function getOptionsSyntaxByName(name) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          return compilerOptionsObjectLiteralSyntax && ts3.getPropertyAssignment(compilerOptionsObjectLiteralSyntax, name);
        }
        function getOptionPathsSyntax() {
          return getOptionsSyntaxByName("paths") || ts3.emptyArray;
        }
        function getOptionsSyntaxByValue(name, value) {
          var syntaxByName = getOptionsSyntaxByName(name);
          return syntaxByName && ts3.firstDefined(syntaxByName, function(property) {
            return ts3.isStringLiteral(property.initializer) && property.initializer.text === value ? property.initializer : void 0;
          });
        }
        function getOptionsSyntaxByArrayElementValue(name, value) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          return compilerOptionsObjectLiteralSyntax && ts3.getPropertyArrayElementValue(compilerOptionsObjectLiteralSyntax, name, value);
        }
        function createDiagnosticForOptionName(message, option1, option2, option3) {
          createDiagnosticForOption(true, option1, option2, message, option1, option2, option3);
        }
        function createOptionValueDiagnostic(option1, message, arg0, arg1) {
          createDiagnosticForOption(false, option1, void 0, message, arg0, arg1);
        }
        function createDiagnosticForReference(sourceFile, index, message, arg0, arg1) {
          var referencesSyntax = ts3.firstDefined(ts3.getTsConfigPropArray(sourceFile || options.configFile, "references"), function(property) {
            return ts3.isArrayLiteralExpression(property.initializer) ? property.initializer : void 0;
          });
          if (referencesSyntax && referencesSyntax.elements.length > index) {
            programDiagnostics.add(ts3.createDiagnosticForNodeInSourceFile(sourceFile || options.configFile, referencesSyntax.elements[index], message, arg0, arg1));
          } else {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0, arg1));
          }
        }
        function createDiagnosticForOption(onKey, option1, option2, message, arg0, arg1, arg2) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          var needCompilerDiagnostic = !compilerOptionsObjectLiteralSyntax || !createOptionDiagnosticInObjectLiteralSyntax(compilerOptionsObjectLiteralSyntax, onKey, option1, option2, message, arg0, arg1, arg2);
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0, arg1, arg2));
          }
        }
        function getCompilerOptionsObjectLiteralSyntax() {
          if (_compilerOptionsObjectLiteralSyntax === void 0) {
            _compilerOptionsObjectLiteralSyntax = false;
            var jsonObjectLiteral = ts3.getTsConfigObjectLiteralExpression(options.configFile);
            if (jsonObjectLiteral) {
              for (var _i2 = 0, _a2 = ts3.getPropertyAssignment(jsonObjectLiteral, "compilerOptions"); _i2 < _a2.length; _i2++) {
                var prop = _a2[_i2];
                if (ts3.isObjectLiteralExpression(prop.initializer)) {
                  _compilerOptionsObjectLiteralSyntax = prop.initializer;
                  break;
                }
              }
            }
          }
          return _compilerOptionsObjectLiteralSyntax || void 0;
        }
        function createOptionDiagnosticInObjectLiteralSyntax(objectLiteral, onKey, key1, key2, message, arg0, arg1, arg2) {
          var props = ts3.getPropertyAssignment(objectLiteral, key1, key2);
          for (var _i2 = 0, props_3 = props; _i2 < props_3.length; _i2++) {
            var prop = props_3[_i2];
            programDiagnostics.add(ts3.createDiagnosticForNodeInSourceFile(options.configFile, onKey ? prop.name : prop.initializer, message, arg0, arg1, arg2));
          }
          return !!props.length;
        }
        function blockEmittingOfFile(emitFileName, diag) {
          hasEmitBlockingDiagnostics.set(toPath(emitFileName), true);
          programDiagnostics.add(diag);
        }
        function isEmittedFile(file) {
          if (options.noEmit) {
            return false;
          }
          var filePath = toPath(file);
          if (getSourceFileByPath(filePath)) {
            return false;
          }
          var out = ts3.outFile(options);
          if (out) {
            return isSameFile(filePath, out) || isSameFile(filePath, ts3.removeFileExtension(out) + ".d.ts");
          }
          if (options.declarationDir && ts3.containsPath(options.declarationDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames())) {
            return true;
          }
          if (options.outDir) {
            return ts3.containsPath(options.outDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames());
          }
          if (ts3.fileExtensionIsOneOf(filePath, ts3.supportedJSExtensionsFlat) || ts3.isDeclarationFileName(filePath)) {
            var filePathWithoutExtension = ts3.removeFileExtension(filePath);
            return !!getSourceFileByPath(filePathWithoutExtension + ".ts") || !!getSourceFileByPath(filePathWithoutExtension + ".tsx");
          }
          return false;
        }
        function isSameFile(file1, file2) {
          return ts3.comparePaths(file1, file2, currentDirectory, !host.useCaseSensitiveFileNames()) === 0;
        }
        function getSymlinkCache() {
          if (host.getSymlinkCache) {
            return host.getSymlinkCache();
          }
          if (!symlinks) {
            symlinks = ts3.createSymlinkCache(currentDirectory, getCanonicalFileName);
          }
          if (files && resolvedTypeReferenceDirectives && !symlinks.hasProcessedResolutions()) {
            symlinks.setSymlinksFromResolutions(files, resolvedTypeReferenceDirectives);
          }
          return symlinks;
        }
      }
      ts3.createProgram = createProgram;
      function updateHostForUseSourceOfProjectReferenceRedirect(host) {
        var setOfDeclarationDirectories;
        var originalFileExists = host.compilerHost.fileExists;
        var originalDirectoryExists = host.compilerHost.directoryExists;
        var originalGetDirectories = host.compilerHost.getDirectories;
        var originalRealpath = host.compilerHost.realpath;
        if (!host.useSourceOfProjectReferenceRedirect)
          return { onProgramCreateComplete: ts3.noop, fileExists };
        host.compilerHost.fileExists = fileExists;
        var directoryExists;
        if (originalDirectoryExists) {
          directoryExists = host.compilerHost.directoryExists = function(path2) {
            if (originalDirectoryExists.call(host.compilerHost, path2)) {
              handleDirectoryCouldBeSymlink(path2);
              return true;
            }
            if (!host.getResolvedProjectReferences())
              return false;
            if (!setOfDeclarationDirectories) {
              setOfDeclarationDirectories = new ts3.Set();
              host.forEachResolvedProjectReference(function(ref) {
                var out = ts3.outFile(ref.commandLine.options);
                if (out) {
                  setOfDeclarationDirectories.add(ts3.getDirectoryPath(host.toPath(out)));
                } else {
                  var declarationDir = ref.commandLine.options.declarationDir || ref.commandLine.options.outDir;
                  if (declarationDir) {
                    setOfDeclarationDirectories.add(host.toPath(declarationDir));
                  }
                }
              });
            }
            return fileOrDirectoryExistsUsingSource(path2, false);
          };
        }
        if (originalGetDirectories) {
          host.compilerHost.getDirectories = function(path2) {
            return !host.getResolvedProjectReferences() || originalDirectoryExists && originalDirectoryExists.call(host.compilerHost, path2) ? originalGetDirectories.call(host.compilerHost, path2) : [];
          };
        }
        if (originalRealpath) {
          host.compilerHost.realpath = function(s) {
            var _a;
            return ((_a = host.getSymlinkCache().getSymlinkedFiles()) === null || _a === void 0 ? void 0 : _a.get(host.toPath(s))) || originalRealpath.call(host.compilerHost, s);
          };
        }
        return { onProgramCreateComplete, fileExists, directoryExists };
        function onProgramCreateComplete() {
          host.compilerHost.fileExists = originalFileExists;
          host.compilerHost.directoryExists = originalDirectoryExists;
          host.compilerHost.getDirectories = originalGetDirectories;
        }
        function fileExists(file) {
          if (originalFileExists.call(host.compilerHost, file))
            return true;
          if (!host.getResolvedProjectReferences())
            return false;
          if (!ts3.isDeclarationFileName(file))
            return false;
          return fileOrDirectoryExistsUsingSource(file, true);
        }
        function fileExistsIfProjectReferenceDts(file) {
          var source = host.getSourceOfProjectReferenceRedirect(host.toPath(file));
          return source !== void 0 ? ts3.isString(source) ? originalFileExists.call(host.compilerHost, source) : true : void 0;
        }
        function directoryExistsIfProjectReferenceDeclDir(dir) {
          var dirPath = host.toPath(dir);
          var dirPathWithTrailingDirectorySeparator = "".concat(dirPath).concat(ts3.directorySeparator);
          return ts3.forEachKey(setOfDeclarationDirectories, function(declDirPath) {
            return dirPath === declDirPath || ts3.startsWith(declDirPath, dirPathWithTrailingDirectorySeparator) || ts3.startsWith(dirPath, "".concat(declDirPath, "/"));
          });
        }
        function handleDirectoryCouldBeSymlink(directory) {
          var _a;
          if (!host.getResolvedProjectReferences() || ts3.containsIgnoredPath(directory))
            return;
          if (!originalRealpath || !ts3.stringContains(directory, ts3.nodeModulesPathPart))
            return;
          var symlinkCache = host.getSymlinkCache();
          var directoryPath = ts3.ensureTrailingDirectorySeparator(host.toPath(directory));
          if ((_a = symlinkCache.getSymlinkedDirectories()) === null || _a === void 0 ? void 0 : _a.has(directoryPath))
            return;
          var real = ts3.normalizePath(originalRealpath.call(host.compilerHost, directory));
          var realPath;
          if (real === directory || (realPath = ts3.ensureTrailingDirectorySeparator(host.toPath(real))) === directoryPath) {
            symlinkCache.setSymlinkedDirectory(directoryPath, false);
            return;
          }
          symlinkCache.setSymlinkedDirectory(directory, {
            real: ts3.ensureTrailingDirectorySeparator(real),
            realPath
          });
        }
        function fileOrDirectoryExistsUsingSource(fileOrDirectory, isFile) {
          var _a;
          var fileOrDirectoryExistsUsingSource2 = isFile ? function(file) {
            return fileExistsIfProjectReferenceDts(file);
          } : function(dir) {
            return directoryExistsIfProjectReferenceDeclDir(dir);
          };
          var result2 = fileOrDirectoryExistsUsingSource2(fileOrDirectory);
          if (result2 !== void 0)
            return result2;
          var symlinkCache = host.getSymlinkCache();
          var symlinkedDirectories = symlinkCache.getSymlinkedDirectories();
          if (!symlinkedDirectories)
            return false;
          var fileOrDirectoryPath = host.toPath(fileOrDirectory);
          if (!ts3.stringContains(fileOrDirectoryPath, ts3.nodeModulesPathPart))
            return false;
          if (isFile && ((_a = symlinkCache.getSymlinkedFiles()) === null || _a === void 0 ? void 0 : _a.has(fileOrDirectoryPath)))
            return true;
          return ts3.firstDefinedIterator(symlinkedDirectories.entries(), function(_a2) {
            var directoryPath = _a2[0], symlinkedDirectory = _a2[1];
            if (!symlinkedDirectory || !ts3.startsWith(fileOrDirectoryPath, directoryPath))
              return void 0;
            var result3 = fileOrDirectoryExistsUsingSource2(fileOrDirectoryPath.replace(directoryPath, symlinkedDirectory.realPath));
            if (isFile && result3) {
              var absolutePath = ts3.getNormalizedAbsolutePath(fileOrDirectory, host.compilerHost.getCurrentDirectory());
              symlinkCache.setSymlinkedFile(fileOrDirectoryPath, "".concat(symlinkedDirectory.real).concat(absolutePath.replace(new RegExp(directoryPath, "i"), "")));
            }
            return result3;
          }) || false;
        }
      }
      ts3.emitSkippedWithNoDiagnostics = { diagnostics: ts3.emptyArray, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true };
      function handleNoEmitOptions(program2, sourceFile, writeFile, cancellationToken) {
        var options = program2.getCompilerOptions();
        if (options.noEmit) {
          program2.getSemanticDiagnostics(sourceFile, cancellationToken);
          return sourceFile || ts3.outFile(options) ? ts3.emitSkippedWithNoDiagnostics : program2.emitBuildInfo(writeFile, cancellationToken);
        }
        if (!options.noEmitOnError)
          return void 0;
        var diagnostics = __spreadArray(__spreadArray(__spreadArray(__spreadArray([], program2.getOptionsDiagnostics(cancellationToken), true), program2.getSyntacticDiagnostics(sourceFile, cancellationToken), true), program2.getGlobalDiagnostics(cancellationToken), true), program2.getSemanticDiagnostics(sourceFile, cancellationToken), true);
        if (diagnostics.length === 0 && ts3.getEmitDeclarations(program2.getCompilerOptions())) {
          diagnostics = program2.getDeclarationDiagnostics(void 0, cancellationToken);
        }
        if (!diagnostics.length)
          return void 0;
        var emittedFiles;
        if (!sourceFile && !ts3.outFile(options)) {
          var emitResult = program2.emitBuildInfo(writeFile, cancellationToken);
          if (emitResult.diagnostics)
            diagnostics = __spreadArray(__spreadArray([], diagnostics, true), emitResult.diagnostics, true);
          emittedFiles = emitResult.emittedFiles;
        }
        return { diagnostics, sourceMaps: void 0, emittedFiles, emitSkipped: true };
      }
      ts3.handleNoEmitOptions = handleNoEmitOptions;
      function filterSemanticDiagnostics(diagnostic, option) {
        return ts3.filter(diagnostic, function(d) {
          return !d.skippedOn || !option[d.skippedOn];
        });
      }
      ts3.filterSemanticDiagnostics = filterSemanticDiagnostics;
      function parseConfigHostFromCompilerHostLike(host, directoryStructureHost) {
        if (directoryStructureHost === void 0) {
          directoryStructureHost = host;
        }
        return {
          fileExists: function(f) {
            return directoryStructureHost.fileExists(f);
          },
          readDirectory: function(root, extensions, excludes, includes, depth) {
            ts3.Debug.assertIsDefined(directoryStructureHost.readDirectory, "'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'");
            return directoryStructureHost.readDirectory(root, extensions, excludes, includes, depth);
          },
          readFile: function(f) {
            return directoryStructureHost.readFile(f);
          },
          useCaseSensitiveFileNames: host.useCaseSensitiveFileNames(),
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          onUnRecoverableConfigFileDiagnostic: host.onUnRecoverableConfigFileDiagnostic || ts3.returnUndefined,
          trace: host.trace ? function(s) {
            return host.trace(s);
          } : void 0
        };
      }
      ts3.parseConfigHostFromCompilerHostLike = parseConfigHostFromCompilerHostLike;
      function createPrependNodes(projectReferences, getCommandLine, readFile) {
        if (!projectReferences)
          return ts3.emptyArray;
        var nodes;
        for (var i = 0; i < projectReferences.length; i++) {
          var ref = projectReferences[i];
          var resolvedRefOpts = getCommandLine(ref, i);
          if (ref.prepend && resolvedRefOpts && resolvedRefOpts.options) {
            var out = ts3.outFile(resolvedRefOpts.options);
            if (!out)
              continue;
            var _a = ts3.getOutputPathsForBundle(resolvedRefOpts.options, true), jsFilePath = _a.jsFilePath, sourceMapFilePath = _a.sourceMapFilePath, declarationFilePath = _a.declarationFilePath, declarationMapPath = _a.declarationMapPath, buildInfoPath = _a.buildInfoPath;
            var node = ts3.createInputFiles(readFile, jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath);
            (nodes || (nodes = [])).push(node);
          }
        }
        return nodes || ts3.emptyArray;
      }
      ts3.createPrependNodes = createPrependNodes;
      function resolveProjectReferencePath(hostOrRef, ref) {
        var passedInRef = ref ? ref : hostOrRef;
        return ts3.resolveConfigFileProjectName(passedInRef.path);
      }
      ts3.resolveProjectReferencePath = resolveProjectReferencePath;
      function getResolutionDiagnostic(options, _a) {
        var extension = _a.extension;
        switch (extension) {
          case ".ts":
          case ".d.ts":
            return void 0;
          case ".tsx":
            return needJsx();
          case ".jsx":
            return needJsx() || needAllowJs();
          case ".js":
            return needAllowJs();
          case ".json":
            return needResolveJsonModule();
        }
        function needJsx() {
          return options.jsx ? void 0 : ts3.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set;
        }
        function needAllowJs() {
          return ts3.getAllowJSCompilerOption(options) || !ts3.getStrictOptionValue(options, "noImplicitAny") ? void 0 : ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type;
        }
        function needResolveJsonModule() {
          return options.resolveJsonModule ? void 0 : ts3.Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used;
        }
      }
      ts3.getResolutionDiagnostic = getResolutionDiagnostic;
      function getModuleNames(_a) {
        var imports = _a.imports, moduleAugmentations = _a.moduleAugmentations;
        var res = imports.map(function(i) {
          return i.text;
        });
        for (var _i = 0, moduleAugmentations_1 = moduleAugmentations; _i < moduleAugmentations_1.length; _i++) {
          var aug = moduleAugmentations_1[_i];
          if (aug.kind === 10) {
            res.push(aug.text);
          }
        }
        return res;
      }
      function getModuleNameStringLiteralAt(_a, index) {
        var imports = _a.imports, moduleAugmentations = _a.moduleAugmentations;
        if (index < imports.length)
          return imports[index];
        var augIndex = imports.length;
        for (var _i = 0, moduleAugmentations_2 = moduleAugmentations; _i < moduleAugmentations_2.length; _i++) {
          var aug = moduleAugmentations_2[_i];
          if (aug.kind === 10) {
            if (index === augIndex)
              return aug;
            augIndex++;
          }
        }
        ts3.Debug.fail("should never ask for module name at index higher than possible module name");
      }
      ts3.getModuleNameStringLiteralAt = getModuleNameStringLiteralAt;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getFileEmitOutput(program2, sourceFile, emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit) {
        var outputFiles = [];
        var _a = program2.emit(sourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit), emitSkipped = _a.emitSkipped, diagnostics = _a.diagnostics, exportedModulesFromDeclarationEmit = _a.exportedModulesFromDeclarationEmit;
        return { outputFiles, emitSkipped, diagnostics, exportedModulesFromDeclarationEmit };
        function writeFile(fileName2, text, writeByteOrderMark) {
          outputFiles.push({ name: fileName2, writeByteOrderMark, text });
        }
      }
      ts3.getFileEmitOutput = getFileEmitOutput;
      var BuilderState;
      (function(BuilderState2) {
        function createManyToManyPathMap() {
          function create2(forward, reverse, deleted) {
            var map2 = {
              clone: function() {
                return create2(new ts3.Map(forward), new ts3.Map(reverse), deleted && new ts3.Set(deleted));
              },
              forEach: function(fn) {
                return forward.forEach(fn);
              },
              getKeys: function(v) {
                return reverse.get(v);
              },
              getValues: function(k) {
                return forward.get(k);
              },
              hasKey: function(k) {
                return forward.has(k);
              },
              keys: function() {
                return forward.keys();
              },
              deletedKeys: function() {
                return deleted;
              },
              deleteKey: function(k) {
                (deleted || (deleted = new ts3.Set())).add(k);
                var set2 = forward.get(k);
                if (!set2) {
                  return false;
                }
                set2.forEach(function(v) {
                  return deleteFromMultimap(reverse, v, k);
                });
                forward.delete(k);
                return true;
              },
              set: function(k, vSet) {
                deleted === null || deleted === void 0 ? void 0 : deleted.delete(k);
                var existingVSet = forward.get(k);
                forward.set(k, vSet);
                existingVSet === null || existingVSet === void 0 ? void 0 : existingVSet.forEach(function(v) {
                  if (!vSet.has(v)) {
                    deleteFromMultimap(reverse, v, k);
                  }
                });
                vSet.forEach(function(v) {
                  if (!(existingVSet === null || existingVSet === void 0 ? void 0 : existingVSet.has(v))) {
                    addToMultimap(reverse, v, k);
                  }
                });
                return map2;
              },
              clear: function() {
                forward.clear();
                reverse.clear();
                deleted === null || deleted === void 0 ? void 0 : deleted.clear();
              }
            };
            return map2;
          }
          return create2(new ts3.Map(), new ts3.Map(), void 0);
        }
        BuilderState2.createManyToManyPathMap = createManyToManyPathMap;
        function addToMultimap(map2, k, v) {
          var set2 = map2.get(k);
          if (!set2) {
            set2 = new ts3.Set();
            map2.set(k, set2);
          }
          set2.add(v);
        }
        function deleteFromMultimap(map2, k, v) {
          var set2 = map2.get(k);
          if (set2 === null || set2 === void 0 ? void 0 : set2.delete(v)) {
            if (!set2.size) {
              map2.delete(k);
            }
            return true;
          }
          return false;
        }
        function getReferencedFilesFromImportedModuleSymbol(symbol) {
          return ts3.mapDefined(symbol.declarations, function(declaration) {
            var _a;
            return (_a = ts3.getSourceFileOfNode(declaration)) === null || _a === void 0 ? void 0 : _a.resolvedPath;
          });
        }
        function getReferencedFilesFromImportLiteral(checker, importName) {
          var symbol = checker.getSymbolAtLocation(importName);
          return symbol && getReferencedFilesFromImportedModuleSymbol(symbol);
        }
        function getReferencedFileFromFileName(program2, fileName2, sourceFileDirectory, getCanonicalFileName) {
          return ts3.toPath(program2.getProjectReferenceRedirect(fileName2) || fileName2, sourceFileDirectory, getCanonicalFileName);
        }
        function getReferencedFiles(program2, sourceFile, getCanonicalFileName) {
          var referencedFiles;
          if (sourceFile.imports && sourceFile.imports.length > 0) {
            var checker = program2.getTypeChecker();
            for (var _i = 0, _a = sourceFile.imports; _i < _a.length; _i++) {
              var importName = _a[_i];
              var declarationSourceFilePaths = getReferencedFilesFromImportLiteral(checker, importName);
              declarationSourceFilePaths === null || declarationSourceFilePaths === void 0 ? void 0 : declarationSourceFilePaths.forEach(addReferencedFile);
            }
          }
          var sourceFileDirectory = ts3.getDirectoryPath(sourceFile.resolvedPath);
          if (sourceFile.referencedFiles && sourceFile.referencedFiles.length > 0) {
            for (var _b = 0, _c = sourceFile.referencedFiles; _b < _c.length; _b++) {
              var referencedFile = _c[_b];
              var referencedPath = getReferencedFileFromFileName(program2, referencedFile.fileName, sourceFileDirectory, getCanonicalFileName);
              addReferencedFile(referencedPath);
            }
          }
          if (sourceFile.resolvedTypeReferenceDirectiveNames) {
            sourceFile.resolvedTypeReferenceDirectiveNames.forEach(function(resolvedTypeReferenceDirective) {
              if (!resolvedTypeReferenceDirective) {
                return;
              }
              var fileName2 = resolvedTypeReferenceDirective.resolvedFileName;
              var typeFilePath = getReferencedFileFromFileName(program2, fileName2, sourceFileDirectory, getCanonicalFileName);
              addReferencedFile(typeFilePath);
            });
          }
          if (sourceFile.moduleAugmentations.length) {
            var checker = program2.getTypeChecker();
            for (var _d = 0, _e = sourceFile.moduleAugmentations; _d < _e.length; _d++) {
              var moduleName = _e[_d];
              if (!ts3.isStringLiteral(moduleName))
                continue;
              var symbol = checker.getSymbolAtLocation(moduleName);
              if (!symbol)
                continue;
              addReferenceFromAmbientModule(symbol);
            }
          }
          for (var _f = 0, _g = program2.getTypeChecker().getAmbientModules(); _f < _g.length; _f++) {
            var ambientModule = _g[_f];
            if (ambientModule.declarations && ambientModule.declarations.length > 1) {
              addReferenceFromAmbientModule(ambientModule);
            }
          }
          return referencedFiles;
          function addReferenceFromAmbientModule(symbol2) {
            if (!symbol2.declarations) {
              return;
            }
            for (var _i2 = 0, _a2 = symbol2.declarations; _i2 < _a2.length; _i2++) {
              var declaration = _a2[_i2];
              var declarationSourceFile = ts3.getSourceFileOfNode(declaration);
              if (declarationSourceFile && declarationSourceFile !== sourceFile) {
                addReferencedFile(declarationSourceFile.resolvedPath);
              }
            }
          }
          function addReferencedFile(referencedPath2) {
            (referencedFiles || (referencedFiles = new ts3.Set())).add(referencedPath2);
          }
        }
        function canReuseOldState(newReferencedMap, oldState) {
          return oldState && !oldState.referencedMap === !newReferencedMap;
        }
        BuilderState2.canReuseOldState = canReuseOldState;
        function create(newProgram, getCanonicalFileName, oldState, disableUseFileVersionAsSignature) {
          var fileInfos = new ts3.Map();
          var referencedMap = newProgram.getCompilerOptions().module !== ts3.ModuleKind.None ? createManyToManyPathMap() : void 0;
          var exportedModulesMap = referencedMap ? createManyToManyPathMap() : void 0;
          var hasCalledUpdateShapeSignature = new ts3.Set();
          var useOldState = canReuseOldState(referencedMap, oldState);
          newProgram.getTypeChecker();
          for (var _i = 0, _a = newProgram.getSourceFiles(); _i < _a.length; _i++) {
            var sourceFile = _a[_i];
            var version_2 = ts3.Debug.checkDefined(sourceFile.version, "Program intended to be used with Builder should have source files with versions set");
            var oldInfo = useOldState ? oldState.fileInfos.get(sourceFile.resolvedPath) : void 0;
            if (referencedMap) {
              var newReferences = getReferencedFiles(newProgram, sourceFile, getCanonicalFileName);
              if (newReferences) {
                referencedMap.set(sourceFile.resolvedPath, newReferences);
              }
              if (useOldState) {
                var exportedModules = oldState.exportedModulesMap.getValues(sourceFile.resolvedPath);
                if (exportedModules) {
                  exportedModulesMap.set(sourceFile.resolvedPath, exportedModules);
                }
              }
            }
            fileInfos.set(sourceFile.resolvedPath, { version: version_2, signature: oldInfo && oldInfo.signature, affectsGlobalScope: isFileAffectingGlobalScope(sourceFile) || void 0, impliedFormat: sourceFile.impliedNodeFormat });
          }
          return {
            fileInfos,
            referencedMap,
            exportedModulesMap,
            hasCalledUpdateShapeSignature,
            useFileVersionAsSignature: !disableUseFileVersionAsSignature && !useOldState
          };
        }
        BuilderState2.create = create;
        function releaseCache(state) {
          state.allFilesExcludingDefaultLibraryFile = void 0;
          state.allFileNames = void 0;
        }
        BuilderState2.releaseCache = releaseCache;
        function clone(state) {
          var _a, _b;
          return {
            fileInfos: new ts3.Map(state.fileInfos),
            referencedMap: (_a = state.referencedMap) === null || _a === void 0 ? void 0 : _a.clone(),
            exportedModulesMap: (_b = state.exportedModulesMap) === null || _b === void 0 ? void 0 : _b.clone(),
            hasCalledUpdateShapeSignature: new ts3.Set(state.hasCalledUpdateShapeSignature),
            useFileVersionAsSignature: state.useFileVersionAsSignature
          };
        }
        BuilderState2.clone = clone;
        function getFilesAffectedBy(state, programOfThisState, path2, cancellationToken, computeHash, cacheToUpdateSignature, exportedModulesMapCache) {
          var signatureCache = cacheToUpdateSignature || new ts3.Map();
          var sourceFile = programOfThisState.getSourceFileByPath(path2);
          if (!sourceFile) {
            return ts3.emptyArray;
          }
          if (!updateShapeSignature(state, programOfThisState, sourceFile, signatureCache, cancellationToken, computeHash, exportedModulesMapCache)) {
            return [sourceFile];
          }
          var result2 = (state.referencedMap ? getFilesAffectedByUpdatedShapeWhenModuleEmit : getFilesAffectedByUpdatedShapeWhenNonModuleEmit)(state, programOfThisState, sourceFile, signatureCache, cancellationToken, computeHash, exportedModulesMapCache);
          if (!cacheToUpdateSignature) {
            updateSignaturesFromCache(state, signatureCache);
          }
          return result2;
        }
        BuilderState2.getFilesAffectedBy = getFilesAffectedBy;
        function updateSignaturesFromCache(state, signatureCache) {
          signatureCache.forEach(function(signature, path2) {
            return updateSignatureOfFile(state, signature, path2);
          });
        }
        BuilderState2.updateSignaturesFromCache = updateSignaturesFromCache;
        function updateSignatureOfFile(state, signature, path2) {
          state.fileInfos.get(path2).signature = signature;
          state.hasCalledUpdateShapeSignature.add(path2);
        }
        BuilderState2.updateSignatureOfFile = updateSignatureOfFile;
        function updateShapeSignature(state, programOfThisState, sourceFile, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache, useFileVersionAsSignature) {
          if (useFileVersionAsSignature === void 0) {
            useFileVersionAsSignature = state.useFileVersionAsSignature;
          }
          ts3.Debug.assert(!!sourceFile);
          ts3.Debug.assert(!exportedModulesMapCache || !!state.exportedModulesMap, "Compute visible to outside map only if visibleToOutsideReferencedMap present in the state");
          if (state.hasCalledUpdateShapeSignature.has(sourceFile.resolvedPath) || cacheToUpdateSignature.has(sourceFile.resolvedPath)) {
            return false;
          }
          var info = state.fileInfos.get(sourceFile.resolvedPath);
          if (!info)
            return ts3.Debug.fail();
          var prevSignature = info.signature;
          var latestSignature;
          if (!sourceFile.isDeclarationFile && !useFileVersionAsSignature) {
            var emitOutput_1 = getFileEmitOutput(programOfThisState, sourceFile, true, cancellationToken, void 0, true);
            var firstDts_1 = ts3.firstOrUndefined(emitOutput_1.outputFiles);
            if (firstDts_1) {
              ts3.Debug.assert(ts3.isDeclarationFileName(firstDts_1.name), "File extension for signature expected to be dts", function() {
                return "Found: ".concat(ts3.getAnyExtensionFromPath(firstDts_1.name), " for ").concat(firstDts_1.name, ":: All output files: ").concat(JSON.stringify(emitOutput_1.outputFiles.map(function(f) {
                  return f.name;
                })));
              });
              latestSignature = (computeHash || ts3.generateDjb2Hash)(firstDts_1.text);
              if (exportedModulesMapCache && latestSignature !== prevSignature) {
                updateExportedModules(sourceFile, emitOutput_1.exportedModulesFromDeclarationEmit, exportedModulesMapCache);
              }
            }
          }
          if (latestSignature === void 0) {
            latestSignature = sourceFile.version;
            if (exportedModulesMapCache && latestSignature !== prevSignature) {
              var references = state.referencedMap ? state.referencedMap.getValues(sourceFile.resolvedPath) : void 0;
              if (references) {
                exportedModulesMapCache.set(sourceFile.resolvedPath, references);
              } else {
                exportedModulesMapCache.deleteKey(sourceFile.resolvedPath);
              }
            }
          }
          cacheToUpdateSignature.set(sourceFile.resolvedPath, latestSignature);
          return latestSignature !== prevSignature;
        }
        BuilderState2.updateShapeSignature = updateShapeSignature;
        function updateExportedModules(sourceFile, exportedModulesFromDeclarationEmit, exportedModulesMapCache) {
          if (!exportedModulesFromDeclarationEmit) {
            exportedModulesMapCache.deleteKey(sourceFile.resolvedPath);
            return;
          }
          var exportedModules;
          exportedModulesFromDeclarationEmit.forEach(function(symbol) {
            return addExportedModule(getReferencedFilesFromImportedModuleSymbol(symbol));
          });
          if (exportedModules) {
            exportedModulesMapCache.set(sourceFile.resolvedPath, exportedModules);
          } else {
            exportedModulesMapCache.deleteKey(sourceFile.resolvedPath);
          }
          function addExportedModule(exportedModulePaths) {
            if (exportedModulePaths === null || exportedModulePaths === void 0 ? void 0 : exportedModulePaths.length) {
              if (!exportedModules) {
                exportedModules = new ts3.Set();
              }
              exportedModulePaths.forEach(function(path2) {
                return exportedModules.add(path2);
              });
            }
          }
        }
        BuilderState2.updateExportedModules = updateExportedModules;
        function updateExportedFilesMapFromCache(state, exportedModulesMapCache) {
          var _a;
          if (exportedModulesMapCache) {
            ts3.Debug.assert(!!state.exportedModulesMap);
            (_a = exportedModulesMapCache.deletedKeys()) === null || _a === void 0 ? void 0 : _a.forEach(function(path2) {
              return state.exportedModulesMap.deleteKey(path2);
            });
            exportedModulesMapCache.forEach(function(exportedModules, path2) {
              return state.exportedModulesMap.set(path2, exportedModules);
            });
          }
        }
        BuilderState2.updateExportedFilesMapFromCache = updateExportedFilesMapFromCache;
        function getAllDependencies(state, programOfThisState, sourceFile) {
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (ts3.outFile(compilerOptions)) {
            return getAllFileNames(state, programOfThisState);
          }
          if (!state.referencedMap || isFileAffectingGlobalScope(sourceFile)) {
            return getAllFileNames(state, programOfThisState);
          }
          var seenMap = new ts3.Set();
          var queue = [sourceFile.resolvedPath];
          while (queue.length) {
            var path2 = queue.pop();
            if (!seenMap.has(path2)) {
              seenMap.add(path2);
              var references = state.referencedMap.getValues(path2);
              if (references) {
                var iterator = references.keys();
                for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
                  queue.push(iterResult.value);
                }
              }
            }
          }
          return ts3.arrayFrom(ts3.mapDefinedIterator(seenMap.keys(), function(path3) {
            var _a, _b;
            return (_b = (_a = programOfThisState.getSourceFileByPath(path3)) === null || _a === void 0 ? void 0 : _a.fileName) !== null && _b !== void 0 ? _b : path3;
          }));
        }
        BuilderState2.getAllDependencies = getAllDependencies;
        function getAllFileNames(state, programOfThisState) {
          if (!state.allFileNames) {
            var sourceFiles = programOfThisState.getSourceFiles();
            state.allFileNames = sourceFiles === ts3.emptyArray ? ts3.emptyArray : sourceFiles.map(function(file) {
              return file.fileName;
            });
          }
          return state.allFileNames;
        }
        function getReferencedByPaths(state, referencedFilePath) {
          var keys = state.referencedMap.getKeys(referencedFilePath);
          return keys ? ts3.arrayFrom(keys.keys()) : [];
        }
        BuilderState2.getReferencedByPaths = getReferencedByPaths;
        function containsOnlyAmbientModules(sourceFile) {
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (!ts3.isModuleWithStringLiteralName(statement)) {
              return false;
            }
          }
          return true;
        }
        function containsGlobalScopeAugmentation(sourceFile) {
          return ts3.some(sourceFile.moduleAugmentations, function(augmentation) {
            return ts3.isGlobalScopeAugmentation(augmentation.parent);
          });
        }
        function isFileAffectingGlobalScope(sourceFile) {
          return containsGlobalScopeAugmentation(sourceFile) || !ts3.isExternalOrCommonJsModule(sourceFile) && !ts3.isJsonSourceFile(sourceFile) && !containsOnlyAmbientModules(sourceFile);
        }
        function getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, firstSourceFile) {
          if (state.allFilesExcludingDefaultLibraryFile) {
            return state.allFilesExcludingDefaultLibraryFile;
          }
          var result2;
          if (firstSourceFile)
            addSourceFile(firstSourceFile);
          for (var _i = 0, _a = programOfThisState.getSourceFiles(); _i < _a.length; _i++) {
            var sourceFile = _a[_i];
            if (sourceFile !== firstSourceFile) {
              addSourceFile(sourceFile);
            }
          }
          state.allFilesExcludingDefaultLibraryFile = result2 || ts3.emptyArray;
          return state.allFilesExcludingDefaultLibraryFile;
          function addSourceFile(sourceFile2) {
            if (!programOfThisState.isSourceFileDefaultLibrary(sourceFile2)) {
              (result2 || (result2 = [])).push(sourceFile2);
            }
          }
        }
        BuilderState2.getAllFilesExcludingDefaultLibraryFile = getAllFilesExcludingDefaultLibraryFile;
        function getFilesAffectedByUpdatedShapeWhenNonModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape) {
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions && ts3.outFile(compilerOptions)) {
            return [sourceFileWithUpdatedShape];
          }
          return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
        }
        function getFilesAffectedByUpdatedShapeWhenModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache) {
          if (isFileAffectingGlobalScope(sourceFileWithUpdatedShape)) {
            return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
          }
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions && (compilerOptions.isolatedModules || ts3.outFile(compilerOptions))) {
            return [sourceFileWithUpdatedShape];
          }
          var seenFileNamesMap = new ts3.Map();
          seenFileNamesMap.set(sourceFileWithUpdatedShape.resolvedPath, sourceFileWithUpdatedShape);
          var queue = getReferencedByPaths(state, sourceFileWithUpdatedShape.resolvedPath);
          while (queue.length > 0) {
            var currentPath = queue.pop();
            if (!seenFileNamesMap.has(currentPath)) {
              var currentSourceFile = programOfThisState.getSourceFileByPath(currentPath);
              seenFileNamesMap.set(currentPath, currentSourceFile);
              if (currentSourceFile && updateShapeSignature(state, programOfThisState, currentSourceFile, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache)) {
                queue.push.apply(queue, getReferencedByPaths(state, currentSourceFile.resolvedPath));
              }
            }
          }
          return ts3.arrayFrom(ts3.mapDefinedIterator(seenFileNamesMap.values(), function(value) {
            return value;
          }));
        }
      })(BuilderState = ts3.BuilderState || (ts3.BuilderState = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var BuilderFileEmit;
      (function(BuilderFileEmit2) {
        BuilderFileEmit2[BuilderFileEmit2["DtsOnly"] = 0] = "DtsOnly";
        BuilderFileEmit2[BuilderFileEmit2["Full"] = 1] = "Full";
      })(BuilderFileEmit = ts3.BuilderFileEmit || (ts3.BuilderFileEmit = {}));
      function hasSameKeys(map1, map2) {
        return map1 === map2 || map1 !== void 0 && map2 !== void 0 && map1.size === map2.size && !ts3.forEachKey(map1, function(key) {
          return !map2.has(key);
        });
      }
      function createBuilderProgramState(newProgram, getCanonicalFileName, oldState, disableUseFileVersionAsSignature) {
        var state = ts3.BuilderState.create(newProgram, getCanonicalFileName, oldState, disableUseFileVersionAsSignature);
        state.program = newProgram;
        var compilerOptions = newProgram.getCompilerOptions();
        state.compilerOptions = compilerOptions;
        if (!ts3.outFile(compilerOptions)) {
          state.semanticDiagnosticsPerFile = new ts3.Map();
        }
        state.changedFilesSet = new ts3.Set();
        var useOldState = ts3.BuilderState.canReuseOldState(state.referencedMap, oldState);
        var oldCompilerOptions = useOldState ? oldState.compilerOptions : void 0;
        var canCopySemanticDiagnostics = useOldState && oldState.semanticDiagnosticsPerFile && !!state.semanticDiagnosticsPerFile && !ts3.compilerOptionsAffectSemanticDiagnostics(compilerOptions, oldCompilerOptions);
        if (useOldState) {
          if (!oldState.currentChangedFilePath) {
            var affectedSignatures = oldState.currentAffectedFilesSignatures;
            ts3.Debug.assert(!oldState.affectedFiles && (!affectedSignatures || !affectedSignatures.size), "Cannot reuse if only few affected files of currentChangedFile were iterated");
          }
          var changedFilesSet = oldState.changedFilesSet;
          if (canCopySemanticDiagnostics) {
            ts3.Debug.assert(!changedFilesSet || !ts3.forEachKey(changedFilesSet, function(path2) {
              return oldState.semanticDiagnosticsPerFile.has(path2);
            }), "Semantic diagnostics shouldnt be available for changed files");
          }
          changedFilesSet === null || changedFilesSet === void 0 ? void 0 : changedFilesSet.forEach(function(value) {
            return state.changedFilesSet.add(value);
          });
          if (!ts3.outFile(compilerOptions) && oldState.affectedFilesPendingEmit) {
            state.affectedFilesPendingEmit = oldState.affectedFilesPendingEmit.slice();
            state.affectedFilesPendingEmitKind = oldState.affectedFilesPendingEmitKind && new ts3.Map(oldState.affectedFilesPendingEmitKind);
            state.affectedFilesPendingEmitIndex = oldState.affectedFilesPendingEmitIndex;
            state.seenAffectedFiles = new ts3.Set();
          }
        }
        var referencedMap = state.referencedMap;
        var oldReferencedMap = useOldState ? oldState.referencedMap : void 0;
        var copyDeclarationFileDiagnostics = canCopySemanticDiagnostics && !compilerOptions.skipLibCheck === !oldCompilerOptions.skipLibCheck;
        var copyLibFileDiagnostics = copyDeclarationFileDiagnostics && !compilerOptions.skipDefaultLibCheck === !oldCompilerOptions.skipDefaultLibCheck;
        state.fileInfos.forEach(function(info, sourceFilePath) {
          var oldInfo;
          var newReferences;
          if (!useOldState || !(oldInfo = oldState.fileInfos.get(sourceFilePath)) || oldInfo.version !== info.version || !hasSameKeys(newReferences = referencedMap && referencedMap.getValues(sourceFilePath), oldReferencedMap && oldReferencedMap.getValues(sourceFilePath)) || newReferences && ts3.forEachKey(newReferences, function(path2) {
            return !state.fileInfos.has(path2) && oldState.fileInfos.has(path2);
          })) {
            state.changedFilesSet.add(sourceFilePath);
          } else if (canCopySemanticDiagnostics) {
            var sourceFile = newProgram.getSourceFileByPath(sourceFilePath);
            if (sourceFile.isDeclarationFile && !copyDeclarationFileDiagnostics)
              return;
            if (sourceFile.hasNoDefaultLib && !copyLibFileDiagnostics)
              return;
            var diagnostics = oldState.semanticDiagnosticsPerFile.get(sourceFilePath);
            if (diagnostics) {
              state.semanticDiagnosticsPerFile.set(sourceFilePath, oldState.hasReusableDiagnostic ? convertToDiagnostics(diagnostics, newProgram, getCanonicalFileName) : diagnostics);
              if (!state.semanticDiagnosticsFromOldState) {
                state.semanticDiagnosticsFromOldState = new ts3.Set();
              }
              state.semanticDiagnosticsFromOldState.add(sourceFilePath);
            }
          }
        });
        if (useOldState && ts3.forEachEntry(oldState.fileInfos, function(info, sourceFilePath) {
          return info.affectsGlobalScope && !state.fileInfos.has(sourceFilePath);
        })) {
          ts3.BuilderState.getAllFilesExcludingDefaultLibraryFile(state, newProgram, void 0).forEach(function(file) {
            return state.changedFilesSet.add(file.resolvedPath);
          });
        } else if (oldCompilerOptions && !ts3.outFile(compilerOptions) && ts3.compilerOptionsAffectEmit(compilerOptions, oldCompilerOptions)) {
          newProgram.getSourceFiles().forEach(function(f) {
            return addToAffectedFilesPendingEmit(state, f.resolvedPath, 1);
          });
          ts3.Debug.assert(!state.seenAffectedFiles || !state.seenAffectedFiles.size);
          state.seenAffectedFiles = state.seenAffectedFiles || new ts3.Set();
        }
        if (useOldState) {
          ts3.forEachEntry(oldState.fileInfos, function(info, sourceFilePath) {
            if (state.fileInfos.has(sourceFilePath) && state.fileInfos.get(sourceFilePath).impliedFormat !== info.impliedFormat) {
              state.changedFilesSet.add(sourceFilePath);
            }
          });
        }
        state.buildInfoEmitPending = !!state.changedFilesSet.size;
        return state;
      }
      function convertToDiagnostics(diagnostics, newProgram, getCanonicalFileName) {
        if (!diagnostics.length)
          return ts3.emptyArray;
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(ts3.getTsBuildInfoEmitOutputFilePath(newProgram.getCompilerOptions()), newProgram.getCurrentDirectory()));
        return diagnostics.map(function(diagnostic) {
          var result2 = convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath);
          result2.reportsUnnecessary = diagnostic.reportsUnnecessary;
          result2.reportsDeprecated = diagnostic.reportDeprecated;
          result2.source = diagnostic.source;
          result2.skippedOn = diagnostic.skippedOn;
          var relatedInformation = diagnostic.relatedInformation;
          result2.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map(function(r) {
            return convertToDiagnosticRelatedInformation(r, newProgram, toPath);
          }) : [] : void 0;
          return result2;
        });
        function toPath(path2) {
          return ts3.toPath(path2, buildInfoDirectory, getCanonicalFileName);
        }
      }
      function convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath) {
        var file = diagnostic.file;
        return __assign(__assign({}, diagnostic), { file: file ? newProgram.getSourceFileByPath(toPath(file)) : void 0 });
      }
      function releaseCache(state) {
        ts3.BuilderState.releaseCache(state);
        state.program = void 0;
      }
      function cloneBuilderProgramState(state) {
        var _a;
        var newState = ts3.BuilderState.clone(state);
        newState.semanticDiagnosticsPerFile = state.semanticDiagnosticsPerFile && new ts3.Map(state.semanticDiagnosticsPerFile);
        newState.changedFilesSet = new ts3.Set(state.changedFilesSet);
        newState.affectedFiles = state.affectedFiles;
        newState.affectedFilesIndex = state.affectedFilesIndex;
        newState.currentChangedFilePath = state.currentChangedFilePath;
        newState.currentAffectedFilesSignatures = state.currentAffectedFilesSignatures && new ts3.Map(state.currentAffectedFilesSignatures);
        newState.currentAffectedFilesExportedModulesMap = (_a = state.currentAffectedFilesExportedModulesMap) === null || _a === void 0 ? void 0 : _a.clone();
        newState.seenAffectedFiles = state.seenAffectedFiles && new ts3.Set(state.seenAffectedFiles);
        newState.cleanedDiagnosticsOfLibFiles = state.cleanedDiagnosticsOfLibFiles;
        newState.semanticDiagnosticsFromOldState = state.semanticDiagnosticsFromOldState && new ts3.Set(state.semanticDiagnosticsFromOldState);
        newState.program = state.program;
        newState.compilerOptions = state.compilerOptions;
        newState.affectedFilesPendingEmit = state.affectedFilesPendingEmit && state.affectedFilesPendingEmit.slice();
        newState.affectedFilesPendingEmitKind = state.affectedFilesPendingEmitKind && new ts3.Map(state.affectedFilesPendingEmitKind);
        newState.affectedFilesPendingEmitIndex = state.affectedFilesPendingEmitIndex;
        newState.seenEmittedFiles = state.seenEmittedFiles && new ts3.Map(state.seenEmittedFiles);
        newState.programEmitComplete = state.programEmitComplete;
        return newState;
      }
      function assertSourceFileOkWithoutNextAffectedCall(state, sourceFile) {
        ts3.Debug.assert(!sourceFile || !state.affectedFiles || state.affectedFiles[state.affectedFilesIndex - 1] !== sourceFile || !state.semanticDiagnosticsPerFile.has(sourceFile.resolvedPath));
      }
      function getNextAffectedFile(state, cancellationToken, computeHash, host) {
        var _a;
        while (true) {
          var affectedFiles = state.affectedFiles;
          if (affectedFiles) {
            var seenAffectedFiles = state.seenAffectedFiles;
            var affectedFilesIndex = state.affectedFilesIndex;
            while (affectedFilesIndex < affectedFiles.length) {
              var affectedFile = affectedFiles[affectedFilesIndex];
              if (!seenAffectedFiles.has(affectedFile.resolvedPath)) {
                state.affectedFilesIndex = affectedFilesIndex;
                handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, computeHash, host);
                return affectedFile;
              }
              affectedFilesIndex++;
            }
            state.changedFilesSet.delete(state.currentChangedFilePath);
            state.currentChangedFilePath = void 0;
            ts3.BuilderState.updateSignaturesFromCache(state, state.currentAffectedFilesSignatures);
            state.currentAffectedFilesSignatures.clear();
            ts3.BuilderState.updateExportedFilesMapFromCache(state, state.currentAffectedFilesExportedModulesMap);
            (_a = state.currentAffectedFilesExportedModulesMap) === null || _a === void 0 ? void 0 : _a.clear();
            state.affectedFiles = void 0;
          }
          var nextKey = state.changedFilesSet.keys().next();
          if (nextKey.done) {
            return void 0;
          }
          var program2 = ts3.Debug.checkDefined(state.program);
          var compilerOptions = program2.getCompilerOptions();
          if (ts3.outFile(compilerOptions)) {
            ts3.Debug.assert(!state.semanticDiagnosticsPerFile);
            return program2;
          }
          if (!state.currentAffectedFilesSignatures)
            state.currentAffectedFilesSignatures = new ts3.Map();
          if (state.exportedModulesMap) {
            state.currentAffectedFilesExportedModulesMap || (state.currentAffectedFilesExportedModulesMap = ts3.BuilderState.createManyToManyPathMap());
          }
          state.affectedFiles = ts3.BuilderState.getFilesAffectedBy(state, program2, nextKey.value, cancellationToken, computeHash, state.currentAffectedFilesSignatures, state.currentAffectedFilesExportedModulesMap);
          state.currentChangedFilePath = nextKey.value;
          state.affectedFilesIndex = 0;
          if (!state.seenAffectedFiles)
            state.seenAffectedFiles = new ts3.Set();
        }
      }
      function clearAffectedFilesPendingEmit(state) {
        state.affectedFilesPendingEmit = void 0;
        state.affectedFilesPendingEmitKind = void 0;
        state.affectedFilesPendingEmitIndex = void 0;
      }
      function getNextAffectedFilePendingEmit(state) {
        var affectedFilesPendingEmit = state.affectedFilesPendingEmit;
        if (affectedFilesPendingEmit) {
          var seenEmittedFiles = state.seenEmittedFiles || (state.seenEmittedFiles = new ts3.Map());
          for (var i = state.affectedFilesPendingEmitIndex; i < affectedFilesPendingEmit.length; i++) {
            var affectedFile = ts3.Debug.checkDefined(state.program).getSourceFileByPath(affectedFilesPendingEmit[i]);
            if (affectedFile) {
              var seenKind = seenEmittedFiles.get(affectedFile.resolvedPath);
              var emitKind = ts3.Debug.checkDefined(ts3.Debug.checkDefined(state.affectedFilesPendingEmitKind).get(affectedFile.resolvedPath));
              if (seenKind === void 0 || seenKind < emitKind) {
                state.affectedFilesPendingEmitIndex = i;
                return { affectedFile, emitKind };
              }
            }
          }
          clearAffectedFilesPendingEmit(state);
        }
        return void 0;
      }
      function removeDiagnosticsOfLibraryFiles(state) {
        if (!state.cleanedDiagnosticsOfLibFiles) {
          state.cleanedDiagnosticsOfLibFiles = true;
          var program_1 = ts3.Debug.checkDefined(state.program);
          var options_2 = program_1.getCompilerOptions();
          ts3.forEach(program_1.getSourceFiles(), function(f) {
            return program_1.isSourceFileDefaultLibrary(f) && !ts3.skipTypeChecking(f, options_2, program_1) && removeSemanticDiagnosticsOf(state, f.resolvedPath);
          });
        }
      }
      function handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, computeHash, host) {
        var _a;
        removeSemanticDiagnosticsOf(state, affectedFile.resolvedPath);
        if (state.allFilesExcludingDefaultLibraryFile === state.affectedFiles) {
          removeDiagnosticsOfLibraryFiles(state);
          ts3.BuilderState.updateShapeSignature(state, ts3.Debug.checkDefined(state.program), affectedFile, ts3.Debug.checkDefined(state.currentAffectedFilesSignatures), cancellationToken, computeHash, state.currentAffectedFilesExportedModulesMap);
          return;
        }
        ts3.Debug.assert(state.hasCalledUpdateShapeSignature.has(affectedFile.resolvedPath) || ((_a = state.currentAffectedFilesSignatures) === null || _a === void 0 ? void 0 : _a.has(affectedFile.resolvedPath)), "Signature not updated for affected file: ".concat(affectedFile.fileName));
        if (state.compilerOptions.assumeChangesOnlyAffectDirectDependencies)
          return;
        handleDtsMayChangeOfReferencingExportOfAffectedFile(state, affectedFile, cancellationToken, computeHash, host);
      }
      function handleDtsMayChangeOf(state, path2, cancellationToken, computeHash, host) {
        removeSemanticDiagnosticsOf(state, path2);
        if (!state.changedFilesSet.has(path2)) {
          var program2 = ts3.Debug.checkDefined(state.program);
          var sourceFile = program2.getSourceFileByPath(path2);
          if (sourceFile) {
            ts3.BuilderState.updateShapeSignature(state, program2, sourceFile, ts3.Debug.checkDefined(state.currentAffectedFilesSignatures), cancellationToken, computeHash, state.currentAffectedFilesExportedModulesMap, !host.disableUseFileVersionAsSignature);
            if (ts3.getEmitDeclarations(state.compilerOptions)) {
              addToAffectedFilesPendingEmit(state, path2, 0);
            }
          }
        }
      }
      function removeSemanticDiagnosticsOf(state, path2) {
        if (!state.semanticDiagnosticsFromOldState) {
          return true;
        }
        state.semanticDiagnosticsFromOldState.delete(path2);
        state.semanticDiagnosticsPerFile.delete(path2);
        return !state.semanticDiagnosticsFromOldState.size;
      }
      function isChangedSignature(state, path2) {
        var newSignature = ts3.Debug.checkDefined(state.currentAffectedFilesSignatures).get(path2);
        var oldSignature = ts3.Debug.checkDefined(state.fileInfos.get(path2)).signature;
        return newSignature !== oldSignature;
      }
      function forEachKeyOfExportedModulesMap(state, filePath, fn) {
        var keys = state.currentAffectedFilesExportedModulesMap.getKeys(filePath);
        var result2 = keys && ts3.forEachKey(keys, fn);
        if (result2)
          return result2;
        keys = state.exportedModulesMap.getKeys(filePath);
        return keys && ts3.forEachKey(keys, function(exportedFromPath) {
          var _a;
          return !state.currentAffectedFilesExportedModulesMap.hasKey(exportedFromPath) && !((_a = state.currentAffectedFilesExportedModulesMap.deletedKeys()) === null || _a === void 0 ? void 0 : _a.has(exportedFromPath)) ? fn(exportedFromPath) : void 0;
        });
      }
      function handleDtsMayChangeOfGlobalScope(state, filePath, cancellationToken, computeHash, host) {
        var _a;
        if (!((_a = state.fileInfos.get(filePath)) === null || _a === void 0 ? void 0 : _a.affectsGlobalScope))
          return false;
        ts3.BuilderState.getAllFilesExcludingDefaultLibraryFile(state, state.program, void 0).forEach(function(file) {
          return handleDtsMayChangeOf(state, file.resolvedPath, cancellationToken, computeHash, host);
        });
        removeDiagnosticsOfLibraryFiles(state);
        return true;
      }
      function handleDtsMayChangeOfReferencingExportOfAffectedFile(state, affectedFile, cancellationToken, computeHash, host) {
        if (!state.exportedModulesMap || !state.changedFilesSet.has(affectedFile.resolvedPath))
          return;
        if (!isChangedSignature(state, affectedFile.resolvedPath))
          return;
        if (state.compilerOptions.isolatedModules) {
          var seenFileNamesMap = new ts3.Map();
          seenFileNamesMap.set(affectedFile.resolvedPath, true);
          var queue = ts3.BuilderState.getReferencedByPaths(state, affectedFile.resolvedPath);
          while (queue.length > 0) {
            var currentPath = queue.pop();
            if (!seenFileNamesMap.has(currentPath)) {
              seenFileNamesMap.set(currentPath, true);
              if (handleDtsMayChangeOfGlobalScope(state, currentPath, cancellationToken, computeHash, host))
                return;
              handleDtsMayChangeOf(state, currentPath, cancellationToken, computeHash, host);
              if (isChangedSignature(state, currentPath)) {
                var currentSourceFile = ts3.Debug.checkDefined(state.program).getSourceFileByPath(currentPath);
                queue.push.apply(queue, ts3.BuilderState.getReferencedByPaths(state, currentSourceFile.resolvedPath));
              }
            }
          }
        }
        ts3.Debug.assert(!!state.currentAffectedFilesExportedModulesMap);
        var seenFileAndExportsOfFile = new ts3.Set();
        forEachKeyOfExportedModulesMap(state, affectedFile.resolvedPath, function(exportedFromPath) {
          if (handleDtsMayChangeOfGlobalScope(state, exportedFromPath, cancellationToken, computeHash, host))
            return true;
          var references = state.referencedMap.getKeys(exportedFromPath);
          return references && ts3.forEachKey(references, function(filePath) {
            return handleDtsMayChangeOfFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, cancellationToken, computeHash, host);
          });
        });
      }
      function handleDtsMayChangeOfFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, cancellationToken, computeHash, host) {
        var _a;
        if (!ts3.tryAddToSet(seenFileAndExportsOfFile, filePath))
          return void 0;
        if (handleDtsMayChangeOfGlobalScope(state, filePath, cancellationToken, computeHash, host))
          return true;
        handleDtsMayChangeOf(state, filePath, cancellationToken, computeHash, host);
        ts3.Debug.assert(!!state.currentAffectedFilesExportedModulesMap);
        forEachKeyOfExportedModulesMap(state, filePath, function(exportedFromPath) {
          return handleDtsMayChangeOfFileAndExportsOfFile(state, exportedFromPath, seenFileAndExportsOfFile, cancellationToken, computeHash, host);
        });
        (_a = state.referencedMap.getKeys(filePath)) === null || _a === void 0 ? void 0 : _a.forEach(function(referencingFilePath) {
          return !seenFileAndExportsOfFile.has(referencingFilePath) && handleDtsMayChangeOf(state, referencingFilePath, cancellationToken, computeHash, host);
        });
        return void 0;
      }
      function doneWithAffectedFile(state, affected, emitKind, isPendingEmit, isBuildInfoEmit) {
        if (isBuildInfoEmit) {
          state.buildInfoEmitPending = false;
        } else if (affected === state.program) {
          state.changedFilesSet.clear();
          state.programEmitComplete = true;
        } else {
          state.seenAffectedFiles.add(affected.resolvedPath);
          if (emitKind !== void 0) {
            (state.seenEmittedFiles || (state.seenEmittedFiles = new ts3.Map())).set(affected.resolvedPath, emitKind);
          }
          if (isPendingEmit) {
            state.affectedFilesPendingEmitIndex++;
            state.buildInfoEmitPending = true;
          } else {
            state.affectedFilesIndex++;
          }
        }
      }
      function toAffectedFileResult(state, result2, affected) {
        doneWithAffectedFile(state, affected);
        return { result: result2, affected };
      }
      function toAffectedFileEmitResult(state, result2, affected, emitKind, isPendingEmit, isBuildInfoEmit) {
        doneWithAffectedFile(state, affected, emitKind, isPendingEmit, isBuildInfoEmit);
        return { result: result2, affected };
      }
      function getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken) {
        return ts3.concatenate(getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken), ts3.Debug.checkDefined(state.program).getProgramDiagnostics(sourceFile));
      }
      function getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken) {
        var path2 = sourceFile.resolvedPath;
        if (state.semanticDiagnosticsPerFile) {
          var cachedDiagnostics = state.semanticDiagnosticsPerFile.get(path2);
          if (cachedDiagnostics) {
            return ts3.filterSemanticDiagnostics(cachedDiagnostics, state.compilerOptions);
          }
        }
        var diagnostics = ts3.Debug.checkDefined(state.program).getBindAndCheckDiagnostics(sourceFile, cancellationToken);
        if (state.semanticDiagnosticsPerFile) {
          state.semanticDiagnosticsPerFile.set(path2, diagnostics);
        }
        return ts3.filterSemanticDiagnostics(diagnostics, state.compilerOptions);
      }
      function getProgramBuildInfo(state, getCanonicalFileName) {
        if (ts3.outFile(state.compilerOptions))
          return void 0;
        var currentDirectory = ts3.Debug.checkDefined(state.program).getCurrentDirectory();
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(ts3.getTsBuildInfoEmitOutputFilePath(state.compilerOptions), currentDirectory));
        var fileNames = [];
        var fileNameToFileId = new ts3.Map();
        var fileIdsList;
        var fileNamesToFileIdListId;
        var fileInfos = ts3.arrayFrom(state.fileInfos.entries(), function(_a2) {
          var key2 = _a2[0], value2 = _a2[1];
          var fileId = toFileId(key2);
          ts3.Debug.assert(fileNames[fileId - 1] === relativeToBuildInfo(key2));
          var signature = state.currentAffectedFilesSignatures && state.currentAffectedFilesSignatures.get(key2);
          var actualSignature = signature !== null && signature !== void 0 ? signature : value2.signature;
          return value2.version === actualSignature ? value2.affectsGlobalScope || value2.impliedFormat ? { version: value2.version, signature: void 0, affectsGlobalScope: value2.affectsGlobalScope, impliedFormat: value2.impliedFormat } : value2.version : actualSignature !== void 0 ? signature === void 0 ? value2 : { version: value2.version, signature, affectsGlobalScope: value2.affectsGlobalScope, impliedFormat: value2.impliedFormat } : { version: value2.version, signature: false, affectsGlobalScope: value2.affectsGlobalScope, impliedFormat: value2.impliedFormat };
        });
        var referencedMap;
        if (state.referencedMap) {
          referencedMap = ts3.arrayFrom(state.referencedMap.keys()).sort(ts3.compareStringsCaseSensitive).map(function(key2) {
            return [
              toFileId(key2),
              toFileIdListId(state.referencedMap.getValues(key2))
            ];
          });
        }
        var exportedModulesMap;
        if (state.exportedModulesMap) {
          exportedModulesMap = ts3.mapDefined(ts3.arrayFrom(state.exportedModulesMap.keys()).sort(ts3.compareStringsCaseSensitive), function(key2) {
            var _a2;
            if (state.currentAffectedFilesExportedModulesMap) {
              if ((_a2 = state.currentAffectedFilesExportedModulesMap.deletedKeys()) === null || _a2 === void 0 ? void 0 : _a2.has(key2)) {
                return void 0;
              }
              var newValue = state.currentAffectedFilesExportedModulesMap.getValues(key2);
              if (newValue) {
                return [toFileId(key2), toFileIdListId(newValue)];
              }
            }
            return [toFileId(key2), toFileIdListId(state.exportedModulesMap.getValues(key2))];
          });
        }
        var semanticDiagnosticsPerFile;
        if (state.semanticDiagnosticsPerFile) {
          for (var _i = 0, _a = ts3.arrayFrom(state.semanticDiagnosticsPerFile.keys()).sort(ts3.compareStringsCaseSensitive); _i < _a.length; _i++) {
            var key = _a[_i];
            var value = state.semanticDiagnosticsPerFile.get(key);
            (semanticDiagnosticsPerFile || (semanticDiagnosticsPerFile = [])).push(value.length ? [
              toFileId(key),
              state.hasReusableDiagnostic ? value : convertToReusableDiagnostics(value, relativeToBuildInfo)
            ] : toFileId(key));
          }
        }
        var affectedFilesPendingEmit;
        if (state.affectedFilesPendingEmit) {
          var seenFiles = new ts3.Set();
          for (var _b = 0, _c = state.affectedFilesPendingEmit.slice(state.affectedFilesPendingEmitIndex).sort(ts3.compareStringsCaseSensitive); _b < _c.length; _b++) {
            var path2 = _c[_b];
            if (ts3.tryAddToSet(seenFiles, path2)) {
              (affectedFilesPendingEmit || (affectedFilesPendingEmit = [])).push([toFileId(path2), state.affectedFilesPendingEmitKind.get(path2)]);
            }
          }
        }
        return {
          fileNames,
          fileInfos,
          options: convertToProgramBuildInfoCompilerOptions(state.compilerOptions, relativeToBuildInfoEnsuringAbsolutePath),
          fileIdsList,
          referencedMap,
          exportedModulesMap,
          semanticDiagnosticsPerFile,
          affectedFilesPendingEmit
        };
        function relativeToBuildInfoEnsuringAbsolutePath(path3) {
          return relativeToBuildInfo(ts3.getNormalizedAbsolutePath(path3, currentDirectory));
        }
        function relativeToBuildInfo(path3) {
          return ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(buildInfoDirectory, path3, getCanonicalFileName));
        }
        function toFileId(path3) {
          var fileId = fileNameToFileId.get(path3);
          if (fileId === void 0) {
            fileNames.push(relativeToBuildInfo(path3));
            fileNameToFileId.set(path3, fileId = fileNames.length);
          }
          return fileId;
        }
        function toFileIdListId(set2) {
          var fileIds = ts3.arrayFrom(set2.keys(), toFileId).sort(ts3.compareValues);
          var key2 = fileIds.join();
          var fileIdListId = fileNamesToFileIdListId === null || fileNamesToFileIdListId === void 0 ? void 0 : fileNamesToFileIdListId.get(key2);
          if (fileIdListId === void 0) {
            (fileIdsList || (fileIdsList = [])).push(fileIds);
            (fileNamesToFileIdListId || (fileNamesToFileIdListId = new ts3.Map())).set(key2, fileIdListId = fileIdsList.length);
          }
          return fileIdListId;
        }
      }
      function convertToProgramBuildInfoCompilerOptions(options, relativeToBuildInfo) {
        var result2;
        var optionsNameMap = ts3.getOptionsNameMap().optionsNameMap;
        for (var _i = 0, _a = ts3.getOwnKeys(options).sort(ts3.compareStringsCaseSensitive); _i < _a.length; _i++) {
          var name = _a[_i];
          var optionKey = name.toLowerCase();
          var optionInfo = optionsNameMap.get(optionKey);
          if ((optionInfo === null || optionInfo === void 0 ? void 0 : optionInfo.affectsEmit) || (optionInfo === null || optionInfo === void 0 ? void 0 : optionInfo.affectsSemanticDiagnostics) || optionKey === "strict" || optionKey === "skiplibcheck" || optionKey === "skipdefaultlibcheck") {
            (result2 || (result2 = {}))[name] = convertToReusableCompilerOptionValue(optionInfo, options[name], relativeToBuildInfo);
          }
        }
        return result2;
      }
      function convertToReusableCompilerOptionValue(option, value, relativeToBuildInfo) {
        if (option) {
          if (option.type === "list") {
            var values = value;
            if (option.element.isFilePath && values.length) {
              return values.map(relativeToBuildInfo);
            }
          } else if (option.isFilePath) {
            return relativeToBuildInfo(value);
          }
        }
        return value;
      }
      function convertToReusableDiagnostics(diagnostics, relativeToBuildInfo) {
        ts3.Debug.assert(!!diagnostics.length);
        return diagnostics.map(function(diagnostic) {
          var result2 = convertToReusableDiagnosticRelatedInformation(diagnostic, relativeToBuildInfo);
          result2.reportsUnnecessary = diagnostic.reportsUnnecessary;
          result2.reportDeprecated = diagnostic.reportsDeprecated;
          result2.source = diagnostic.source;
          result2.skippedOn = diagnostic.skippedOn;
          var relatedInformation = diagnostic.relatedInformation;
          result2.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map(function(r) {
            return convertToReusableDiagnosticRelatedInformation(r, relativeToBuildInfo);
          }) : [] : void 0;
          return result2;
        });
      }
      function convertToReusableDiagnosticRelatedInformation(diagnostic, relativeToBuildInfo) {
        var file = diagnostic.file;
        return __assign(__assign({}, diagnostic), { file: file ? relativeToBuildInfo(file.resolvedPath) : void 0 });
      }
      var BuilderProgramKind;
      (function(BuilderProgramKind2) {
        BuilderProgramKind2[BuilderProgramKind2["SemanticDiagnosticsBuilderProgram"] = 0] = "SemanticDiagnosticsBuilderProgram";
        BuilderProgramKind2[BuilderProgramKind2["EmitAndSemanticDiagnosticsBuilderProgram"] = 1] = "EmitAndSemanticDiagnosticsBuilderProgram";
      })(BuilderProgramKind = ts3.BuilderProgramKind || (ts3.BuilderProgramKind = {}));
      function getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        var host;
        var newProgram;
        var oldProgram;
        if (newProgramOrRootNames === void 0) {
          ts3.Debug.assert(hostOrOptions === void 0);
          host = oldProgramOrHost;
          oldProgram = configFileParsingDiagnosticsOrOldProgram;
          ts3.Debug.assert(!!oldProgram);
          newProgram = oldProgram.getProgram();
        } else if (ts3.isArray(newProgramOrRootNames)) {
          oldProgram = configFileParsingDiagnosticsOrOldProgram;
          newProgram = ts3.createProgram({
            rootNames: newProgramOrRootNames,
            options: hostOrOptions,
            host: oldProgramOrHost,
            oldProgram: oldProgram && oldProgram.getProgramOrUndefined(),
            configFileParsingDiagnostics,
            projectReferences
          });
          host = oldProgramOrHost;
        } else {
          newProgram = newProgramOrRootNames;
          host = hostOrOptions;
          oldProgram = oldProgramOrHost;
          configFileParsingDiagnostics = configFileParsingDiagnosticsOrOldProgram;
        }
        return { host, newProgram, oldProgram, configFileParsingDiagnostics: configFileParsingDiagnostics || ts3.emptyArray };
      }
      ts3.getBuilderCreationParameters = getBuilderCreationParameters;
      function createBuilderProgram(kind, _a) {
        var newProgram = _a.newProgram, host = _a.host, oldProgram = _a.oldProgram, configFileParsingDiagnostics = _a.configFileParsingDiagnostics;
        var oldState = oldProgram && oldProgram.getState();
        if (oldState && newProgram === oldState.program && configFileParsingDiagnostics === newProgram.getConfigFileParsingDiagnostics()) {
          newProgram = void 0;
          oldState = void 0;
          return oldProgram;
        }
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var computeHash = ts3.maybeBind(host, host.createHash);
        var state = createBuilderProgramState(newProgram, getCanonicalFileName, oldState, host.disableUseFileVersionAsSignature);
        var backupState;
        newProgram.getProgramBuildInfo = function() {
          return getProgramBuildInfo(state, getCanonicalFileName);
        };
        newProgram = void 0;
        oldProgram = void 0;
        oldState = void 0;
        var getState = function() {
          return state;
        };
        var builderProgram = createRedirectedBuilderProgram(getState, configFileParsingDiagnostics);
        builderProgram.getState = getState;
        builderProgram.backupState = function() {
          ts3.Debug.assert(backupState === void 0);
          backupState = cloneBuilderProgramState(state);
        };
        builderProgram.restoreState = function() {
          state = ts3.Debug.checkDefined(backupState);
          backupState = void 0;
        };
        builderProgram.getAllDependencies = function(sourceFile) {
          return ts3.BuilderState.getAllDependencies(state, ts3.Debug.checkDefined(state.program), sourceFile);
        };
        builderProgram.getSemanticDiagnostics = getSemanticDiagnostics;
        builderProgram.emit = emit;
        builderProgram.releaseProgram = function() {
          releaseCache(state);
          backupState = void 0;
        };
        if (kind === BuilderProgramKind.SemanticDiagnosticsBuilderProgram) {
          builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
        } else if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
          builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
          builderProgram.emitNextAffectedFile = emitNextAffectedFile;
          builderProgram.emitBuildInfo = emitBuildInfo;
        } else {
          ts3.notImplemented();
        }
        return builderProgram;
        function emitBuildInfo(writeFile, cancellationToken) {
          if (state.buildInfoEmitPending) {
            var result2 = ts3.Debug.checkDefined(state.program).emitBuildInfo(writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken);
            state.buildInfoEmitPending = false;
            return result2;
          }
          return ts3.emitSkippedWithNoDiagnostics;
        }
        function emitNextAffectedFile(writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
          var affected = getNextAffectedFile(state, cancellationToken, computeHash, host);
          var emitKind = 1;
          var isPendingEmitFile = false;
          if (!affected) {
            if (!ts3.outFile(state.compilerOptions)) {
              var pendingAffectedFile = getNextAffectedFilePendingEmit(state);
              if (!pendingAffectedFile) {
                if (!state.buildInfoEmitPending) {
                  return void 0;
                }
                var affected_1 = ts3.Debug.checkDefined(state.program);
                return toAffectedFileEmitResult(state, affected_1.emitBuildInfo(writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken), affected_1, 1, false, true);
              }
              affected = pendingAffectedFile.affectedFile, emitKind = pendingAffectedFile.emitKind;
              isPendingEmitFile = true;
            } else {
              var program2 = ts3.Debug.checkDefined(state.program);
              if (state.programEmitComplete)
                return void 0;
              affected = program2;
            }
          }
          return toAffectedFileEmitResult(state, ts3.Debug.checkDefined(state.program).emit(affected === state.program ? void 0 : affected, affected !== state.program && ts3.getEmitDeclarations(state.compilerOptions) && !customTransformers ? getWriteFileUpdatingSignatureCallback(writeFile) : writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken, emitOnlyDtsFiles || emitKind === 0, customTransformers), affected, emitKind, isPendingEmitFile);
        }
        function getWriteFileUpdatingSignatureCallback(writeFile) {
          return function(fileName2, text, writeByteOrderMark, onError, sourceFiles, data) {
            var _a2;
            if (ts3.isDeclarationFileName(fileName2)) {
              ts3.Debug.assert((sourceFiles === null || sourceFiles === void 0 ? void 0 : sourceFiles.length) === 1);
              var file = sourceFiles[0];
              var info = state.fileInfos.get(file.resolvedPath);
              var signature = ((_a2 = state.currentAffectedFilesSignatures) === null || _a2 === void 0 ? void 0 : _a2.get(file.resolvedPath)) || info.signature;
              if (signature === file.version) {
                var newSignature = (computeHash || ts3.generateDjb2Hash)((data === null || data === void 0 ? void 0 : data.sourceMapUrlPos) !== void 0 ? text.substring(0, data.sourceMapUrlPos) : text);
                if (newSignature !== file.version) {
                  if (host.storeFilesChangingSignatureDuringEmit)
                    (state.filesChangingSignature || (state.filesChangingSignature = new ts3.Set())).add(file.resolvedPath);
                  if (state.exportedModulesMap)
                    ts3.BuilderState.updateExportedModules(file, file.exportedModulesFromDeclarationEmit, state.currentAffectedFilesExportedModulesMap || (state.currentAffectedFilesExportedModulesMap = ts3.BuilderState.createManyToManyPathMap()));
                  if (state.affectedFiles && state.affectedFilesIndex < state.affectedFiles.length) {
                    state.currentAffectedFilesSignatures.set(file.resolvedPath, newSignature);
                  } else {
                    info.signature = newSignature;
                    if (state.exportedModulesMap)
                      ts3.BuilderState.updateExportedFilesMapFromCache(state, state.currentAffectedFilesExportedModulesMap);
                  }
                }
              }
            }
            if (writeFile)
              writeFile(fileName2, text, writeByteOrderMark, onError, sourceFiles, data);
            else if (host.writeFile)
              host.writeFile(fileName2, text, writeByteOrderMark, onError, sourceFiles, data);
            else
              state.program.writeFile(fileName2, text, writeByteOrderMark, onError, sourceFiles, data);
          };
        }
        function emit(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
          var _a2;
          if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
            assertSourceFileOkWithoutNextAffectedCall(state, targetSourceFile);
          }
          var result2 = ts3.handleNoEmitOptions(builderProgram, targetSourceFile, writeFile, cancellationToken);
          if (result2)
            return result2;
          if (!targetSourceFile) {
            if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
              var sourceMaps = [];
              var emitSkipped = false;
              var diagnostics = void 0;
              var emittedFiles = [];
              var affectedEmitResult = void 0;
              while (affectedEmitResult = emitNextAffectedFile(writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers)) {
                emitSkipped = emitSkipped || affectedEmitResult.result.emitSkipped;
                diagnostics = ts3.addRange(diagnostics, affectedEmitResult.result.diagnostics);
                emittedFiles = ts3.addRange(emittedFiles, affectedEmitResult.result.emittedFiles);
                sourceMaps = ts3.addRange(sourceMaps, affectedEmitResult.result.sourceMaps);
              }
              return {
                emitSkipped,
                diagnostics: diagnostics || ts3.emptyArray,
                emittedFiles,
                sourceMaps
              };
            } else if ((_a2 = state.affectedFilesPendingEmitKind) === null || _a2 === void 0 ? void 0 : _a2.size) {
              ts3.Debug.assert(kind === BuilderProgramKind.SemanticDiagnosticsBuilderProgram);
              if (!emitOnlyDtsFiles || ts3.every(state.affectedFilesPendingEmit, function(path2, index) {
                return index < state.affectedFilesPendingEmitIndex || state.affectedFilesPendingEmitKind.get(path2) === 0;
              })) {
                clearAffectedFilesPendingEmit(state);
              }
            }
          }
          return ts3.Debug.checkDefined(state.program).emit(targetSourceFile, !ts3.outFile(state.compilerOptions) && ts3.getEmitDeclarations(state.compilerOptions) && !customTransformers ? getWriteFileUpdatingSignatureCallback(writeFile) : writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken, emitOnlyDtsFiles, customTransformers);
        }
        function getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile) {
          while (true) {
            var affected = getNextAffectedFile(state, cancellationToken, computeHash, host);
            if (!affected) {
              return void 0;
            } else if (affected === state.program) {
              return toAffectedFileResult(state, state.program.getSemanticDiagnostics(void 0, cancellationToken), affected);
            }
            if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram || state.compilerOptions.noEmit || state.compilerOptions.noEmitOnError) {
              addToAffectedFilesPendingEmit(state, affected.resolvedPath, 1);
            }
            if (ignoreSourceFile && ignoreSourceFile(affected)) {
              doneWithAffectedFile(state, affected);
              continue;
            }
            return toAffectedFileResult(state, getSemanticDiagnosticsOfFile(state, affected, cancellationToken), affected);
          }
        }
        function getSemanticDiagnostics(sourceFile, cancellationToken) {
          assertSourceFileOkWithoutNextAffectedCall(state, sourceFile);
          var compilerOptions = ts3.Debug.checkDefined(state.program).getCompilerOptions();
          if (ts3.outFile(compilerOptions)) {
            ts3.Debug.assert(!state.semanticDiagnosticsPerFile);
            return ts3.Debug.checkDefined(state.program).getSemanticDiagnostics(sourceFile, cancellationToken);
          }
          if (sourceFile) {
            return getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken);
          }
          while (getSemanticDiagnosticsOfNextAffectedFile(cancellationToken)) {
          }
          var diagnostics;
          for (var _i = 0, _a2 = ts3.Debug.checkDefined(state.program).getSourceFiles(); _i < _a2.length; _i++) {
            var sourceFile_1 = _a2[_i];
            diagnostics = ts3.addRange(diagnostics, getSemanticDiagnosticsOfFile(state, sourceFile_1, cancellationToken));
          }
          return diagnostics || ts3.emptyArray;
        }
      }
      ts3.createBuilderProgram = createBuilderProgram;
      function addToAffectedFilesPendingEmit(state, affectedFilePendingEmit, kind) {
        if (!state.affectedFilesPendingEmit)
          state.affectedFilesPendingEmit = [];
        if (!state.affectedFilesPendingEmitKind)
          state.affectedFilesPendingEmitKind = new ts3.Map();
        var existingKind = state.affectedFilesPendingEmitKind.get(affectedFilePendingEmit);
        state.affectedFilesPendingEmit.push(affectedFilePendingEmit);
        state.affectedFilesPendingEmitKind.set(affectedFilePendingEmit, existingKind || kind);
        if (state.affectedFilesPendingEmitIndex === void 0) {
          state.affectedFilesPendingEmitIndex = 0;
        }
      }
      function toBuilderStateFileInfo(fileInfo) {
        return ts3.isString(fileInfo) ? { version: fileInfo, signature: fileInfo, affectsGlobalScope: void 0, impliedFormat: void 0 } : ts3.isString(fileInfo.signature) ? fileInfo : { version: fileInfo.version, signature: fileInfo.signature === false ? void 0 : fileInfo.version, affectsGlobalScope: fileInfo.affectsGlobalScope, impliedFormat: fileInfo.impliedFormat };
      }
      ts3.toBuilderStateFileInfo = toBuilderStateFileInfo;
      function createBuildProgramUsingProgramBuildInfo(program2, buildInfoPath, host) {
        var _a;
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var filePaths = program2.fileNames.map(toPath);
        var filePathsSetList = (_a = program2.fileIdsList) === null || _a === void 0 ? void 0 : _a.map(function(fileIds) {
          return new ts3.Set(fileIds.map(toFilePath));
        });
        var fileInfos = new ts3.Map();
        program2.fileInfos.forEach(function(fileInfo, index) {
          return fileInfos.set(toFilePath(index + 1), toBuilderStateFileInfo(fileInfo));
        });
        var state = {
          fileInfos,
          compilerOptions: program2.options ? ts3.convertToOptionsWithAbsolutePaths(program2.options, toAbsolutePath) : {},
          referencedMap: toManyToManyPathMap(program2.referencedMap),
          exportedModulesMap: toManyToManyPathMap(program2.exportedModulesMap),
          semanticDiagnosticsPerFile: program2.semanticDiagnosticsPerFile && ts3.arrayToMap(program2.semanticDiagnosticsPerFile, function(value) {
            return toFilePath(ts3.isNumber(value) ? value : value[0]);
          }, function(value) {
            return ts3.isNumber(value) ? ts3.emptyArray : value[1];
          }),
          hasReusableDiagnostic: true,
          affectedFilesPendingEmit: ts3.map(program2.affectedFilesPendingEmit, function(value) {
            return toFilePath(value[0]);
          }),
          affectedFilesPendingEmitKind: program2.affectedFilesPendingEmit && ts3.arrayToMap(program2.affectedFilesPendingEmit, function(value) {
            return toFilePath(value[0]);
          }, function(value) {
            return value[1];
          }),
          affectedFilesPendingEmitIndex: program2.affectedFilesPendingEmit && 0
        };
        return {
          getState: function() {
            return state;
          },
          backupState: ts3.noop,
          restoreState: ts3.noop,
          getProgram: ts3.notImplemented,
          getProgramOrUndefined: ts3.returnUndefined,
          releaseProgram: ts3.noop,
          getCompilerOptions: function() {
            return state.compilerOptions;
          },
          getSourceFile: ts3.notImplemented,
          getSourceFiles: ts3.notImplemented,
          getOptionsDiagnostics: ts3.notImplemented,
          getGlobalDiagnostics: ts3.notImplemented,
          getConfigFileParsingDiagnostics: ts3.notImplemented,
          getSyntacticDiagnostics: ts3.notImplemented,
          getDeclarationDiagnostics: ts3.notImplemented,
          getSemanticDiagnostics: ts3.notImplemented,
          emit: ts3.notImplemented,
          getAllDependencies: ts3.notImplemented,
          getCurrentDirectory: ts3.notImplemented,
          emitNextAffectedFile: ts3.notImplemented,
          getSemanticDiagnosticsOfNextAffectedFile: ts3.notImplemented,
          emitBuildInfo: ts3.notImplemented,
          close: ts3.noop
        };
        function toPath(path2) {
          return ts3.toPath(path2, buildInfoDirectory, getCanonicalFileName);
        }
        function toAbsolutePath(path2) {
          return ts3.getNormalizedAbsolutePath(path2, buildInfoDirectory);
        }
        function toFilePath(fileId) {
          return filePaths[fileId - 1];
        }
        function toFilePathsSet(fileIdsListId) {
          return filePathsSetList[fileIdsListId - 1];
        }
        function toManyToManyPathMap(referenceMap) {
          if (!referenceMap) {
            return void 0;
          }
          var map2 = ts3.BuilderState.createManyToManyPathMap();
          referenceMap.forEach(function(_a2) {
            var fileId = _a2[0], fileIdListId = _a2[1];
            return map2.set(toFilePath(fileId), toFilePathsSet(fileIdListId));
          });
          return map2;
        }
      }
      ts3.createBuildProgramUsingProgramBuildInfo = createBuildProgramUsingProgramBuildInfo;
      function createRedirectedBuilderProgram(getState, configFileParsingDiagnostics) {
        return {
          getState: ts3.notImplemented,
          backupState: ts3.noop,
          restoreState: ts3.noop,
          getProgram,
          getProgramOrUndefined: function() {
            return getState().program;
          },
          releaseProgram: function() {
            return getState().program = void 0;
          },
          getCompilerOptions: function() {
            return getState().compilerOptions;
          },
          getSourceFile: function(fileName2) {
            return getProgram().getSourceFile(fileName2);
          },
          getSourceFiles: function() {
            return getProgram().getSourceFiles();
          },
          getOptionsDiagnostics: function(cancellationToken) {
            return getProgram().getOptionsDiagnostics(cancellationToken);
          },
          getGlobalDiagnostics: function(cancellationToken) {
            return getProgram().getGlobalDiagnostics(cancellationToken);
          },
          getConfigFileParsingDiagnostics: function() {
            return configFileParsingDiagnostics;
          },
          getSyntacticDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getSyntacticDiagnostics(sourceFile, cancellationToken);
          },
          getDeclarationDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getDeclarationDiagnostics(sourceFile, cancellationToken);
          },
          getSemanticDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getSemanticDiagnostics(sourceFile, cancellationToken);
          },
          emit: function(sourceFile, writeFile, cancellationToken, emitOnlyDts, customTransformers) {
            return getProgram().emit(sourceFile, writeFile, cancellationToken, emitOnlyDts, customTransformers);
          },
          emitBuildInfo: function(writeFile, cancellationToken) {
            return getProgram().emitBuildInfo(writeFile, cancellationToken);
          },
          getAllDependencies: ts3.notImplemented,
          getCurrentDirectory: function() {
            return getProgram().getCurrentDirectory();
          },
          close: ts3.noop
        };
        function getProgram() {
          return ts3.Debug.checkDefined(getState().program);
        }
      }
      ts3.createRedirectedBuilderProgram = createRedirectedBuilderProgram;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        return ts3.createBuilderProgram(ts3.BuilderProgramKind.SemanticDiagnosticsBuilderProgram, ts3.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
      }
      ts3.createSemanticDiagnosticsBuilderProgram = createSemanticDiagnosticsBuilderProgram;
      function createEmitAndSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        return ts3.createBuilderProgram(ts3.BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram, ts3.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
      }
      ts3.createEmitAndSemanticDiagnosticsBuilderProgram = createEmitAndSemanticDiagnosticsBuilderProgram;
      function createAbstractBuilder(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        var _a = ts3.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences), newProgram = _a.newProgram, newConfigFileParsingDiagnostics = _a.configFileParsingDiagnostics;
        return ts3.createRedirectedBuilderProgram(function() {
          return { program: newProgram, compilerOptions: newProgram.getCompilerOptions() };
        }, newConfigFileParsingDiagnostics);
      }
      ts3.createAbstractBuilder = createAbstractBuilder;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function removeIgnoredPath(path2) {
        if (ts3.endsWith(path2, "/node_modules/.staging")) {
          return ts3.removeSuffix(path2, "/.staging");
        }
        return ts3.some(ts3.ignoredPaths, function(searchPath) {
          return ts3.stringContains(path2, searchPath);
        }) ? void 0 : path2;
      }
      ts3.removeIgnoredPath = removeIgnoredPath;
      function canWatchDirectory(dirPath) {
        var rootLength = ts3.getRootLength(dirPath);
        if (dirPath.length === rootLength) {
          return false;
        }
        var nextDirectorySeparator = dirPath.indexOf(ts3.directorySeparator, rootLength);
        if (nextDirectorySeparator === -1) {
          return false;
        }
        var pathPartForUserCheck = dirPath.substring(rootLength, nextDirectorySeparator + 1);
        var isNonDirectorySeparatorRoot = rootLength > 1 || dirPath.charCodeAt(0) !== 47;
        if (isNonDirectorySeparatorRoot && dirPath.search(/[a-zA-Z]:/) !== 0 && pathPartForUserCheck.search(/[a-zA-z]\$\//) === 0) {
          nextDirectorySeparator = dirPath.indexOf(ts3.directorySeparator, nextDirectorySeparator + 1);
          if (nextDirectorySeparator === -1) {
            return false;
          }
          pathPartForUserCheck = dirPath.substring(rootLength + pathPartForUserCheck.length, nextDirectorySeparator + 1);
        }
        if (isNonDirectorySeparatorRoot && pathPartForUserCheck.search(/users\//i) !== 0) {
          return true;
        }
        for (var searchIndex = nextDirectorySeparator + 1, searchLevels = 2; searchLevels > 0; searchLevels--) {
          searchIndex = dirPath.indexOf(ts3.directorySeparator, searchIndex) + 1;
          if (searchIndex === 0) {
            return false;
          }
        }
        return true;
      }
      ts3.canWatchDirectory = canWatchDirectory;
      function createResolutionCache(resolutionHost, rootDirForResolution, logChangesWhenResolvingModule) {
        var filesWithChangedSetOfUnresolvedImports;
        var filesWithInvalidatedResolutions;
        var filesWithInvalidatedNonRelativeUnresolvedImports;
        var nonRelativeExternalModuleResolutions = ts3.createMultiMap();
        var resolutionsWithFailedLookups = [];
        var resolvedFileToResolution = ts3.createMultiMap();
        var hasChangedAutomaticTypeDirectiveNames = false;
        var failedLookupChecks;
        var startsWithPathChecks;
        var isInDirectoryChecks;
        var getCurrentDirectory = ts3.memoize(function() {
          return resolutionHost.getCurrentDirectory();
        });
        var cachedDirectoryStructureHost = resolutionHost.getCachedDirectoryStructureHost();
        var resolvedModuleNames = new ts3.Map();
        var perDirectoryResolvedModuleNames = ts3.createCacheWithRedirects();
        var nonRelativeModuleNameCache = ts3.createCacheWithRedirects();
        var moduleResolutionCache = ts3.createModuleResolutionCache(getCurrentDirectory(), resolutionHost.getCanonicalFileName, void 0, perDirectoryResolvedModuleNames, nonRelativeModuleNameCache);
        var resolvedTypeReferenceDirectives = new ts3.Map();
        var perDirectoryResolvedTypeReferenceDirectives = ts3.createCacheWithRedirects();
        var typeReferenceDirectiveResolutionCache = ts3.createTypeReferenceDirectiveResolutionCache(getCurrentDirectory(), resolutionHost.getCanonicalFileName, void 0, moduleResolutionCache.getPackageJsonInfoCache(), perDirectoryResolvedTypeReferenceDirectives);
        var failedLookupDefaultExtensions = [".ts", ".tsx", ".js", ".jsx", ".json"];
        var customFailedLookupPaths = new ts3.Map();
        var directoryWatchesOfFailedLookups = new ts3.Map();
        var rootDir = rootDirForResolution && ts3.removeTrailingDirectorySeparator(ts3.getNormalizedAbsolutePath(rootDirForResolution, getCurrentDirectory()));
        var rootPath = rootDir && resolutionHost.toPath(rootDir);
        var rootSplitLength = rootPath !== void 0 ? rootPath.split(ts3.directorySeparator).length : 0;
        var typeRootsWatches = new ts3.Map();
        return {
          getModuleResolutionCache: function() {
            return moduleResolutionCache;
          },
          startRecordingFilesWithChangedResolutions,
          finishRecordingFilesWithChangedResolutions,
          startCachingPerDirectoryResolution: clearPerDirectoryResolutions,
          finishCachingPerDirectoryResolution,
          resolveModuleNames,
          getResolvedModuleWithFailedLookupLocationsFromCache,
          resolveTypeReferenceDirectives,
          removeResolutionsFromProjectReferenceRedirects,
          removeResolutionsOfFile,
          hasChangedAutomaticTypeDirectiveNames: function() {
            return hasChangedAutomaticTypeDirectiveNames;
          },
          invalidateResolutionOfFile,
          invalidateResolutionsOfFailedLookupLocations,
          setFilesWithInvalidatedNonRelativeUnresolvedImports,
          createHasInvalidatedResolution,
          isFileWithInvalidatedNonRelativeUnresolvedImports,
          updateTypeRootsWatch,
          closeTypeRootsWatch,
          clear
        };
        function getResolvedModule(resolution) {
          return resolution.resolvedModule;
        }
        function getResolvedTypeReferenceDirective(resolution) {
          return resolution.resolvedTypeReferenceDirective;
        }
        function isInDirectoryPath(dir, file) {
          if (dir === void 0 || file.length <= dir.length) {
            return false;
          }
          return ts3.startsWith(file, dir) && file[dir.length] === ts3.directorySeparator;
        }
        function clear() {
          ts3.clearMap(directoryWatchesOfFailedLookups, ts3.closeFileWatcherOf);
          customFailedLookupPaths.clear();
          nonRelativeExternalModuleResolutions.clear();
          closeTypeRootsWatch();
          resolvedModuleNames.clear();
          resolvedTypeReferenceDirectives.clear();
          resolvedFileToResolution.clear();
          resolutionsWithFailedLookups.length = 0;
          failedLookupChecks = void 0;
          startsWithPathChecks = void 0;
          isInDirectoryChecks = void 0;
          clearPerDirectoryResolutions();
          hasChangedAutomaticTypeDirectiveNames = false;
        }
        function startRecordingFilesWithChangedResolutions() {
          filesWithChangedSetOfUnresolvedImports = [];
        }
        function finishRecordingFilesWithChangedResolutions() {
          var collected = filesWithChangedSetOfUnresolvedImports;
          filesWithChangedSetOfUnresolvedImports = void 0;
          return collected;
        }
        function isFileWithInvalidatedNonRelativeUnresolvedImports(path2) {
          if (!filesWithInvalidatedNonRelativeUnresolvedImports) {
            return false;
          }
          var value = filesWithInvalidatedNonRelativeUnresolvedImports.get(path2);
          return !!value && !!value.length;
        }
        function createHasInvalidatedResolution(forceAllFilesAsInvalidated) {
          invalidateResolutionsOfFailedLookupLocations();
          if (forceAllFilesAsInvalidated) {
            filesWithInvalidatedResolutions = void 0;
            return ts3.returnTrue;
          }
          var collected = filesWithInvalidatedResolutions;
          filesWithInvalidatedResolutions = void 0;
          return function(path2) {
            return !!collected && collected.has(path2) || isFileWithInvalidatedNonRelativeUnresolvedImports(path2);
          };
        }
        function clearPerDirectoryResolutions() {
          moduleResolutionCache.clear();
          typeReferenceDirectiveResolutionCache.clear();
          nonRelativeExternalModuleResolutions.forEach(watchFailedLookupLocationOfNonRelativeModuleResolutions);
          nonRelativeExternalModuleResolutions.clear();
        }
        function finishCachingPerDirectoryResolution() {
          filesWithInvalidatedNonRelativeUnresolvedImports = void 0;
          clearPerDirectoryResolutions();
          directoryWatchesOfFailedLookups.forEach(function(watcher, path2) {
            if (watcher.refCount === 0) {
              directoryWatchesOfFailedLookups.delete(path2);
              watcher.watcher.close();
            }
          });
          hasChangedAutomaticTypeDirectiveNames = false;
        }
        function resolveModuleName(moduleName, containingFile, compilerOptions, host, redirectedReference, _containingSourceFile, mode) {
          var _a;
          var primaryResult = ts3.resolveModuleName(moduleName, containingFile, compilerOptions, host, moduleResolutionCache, redirectedReference, mode);
          if (!resolutionHost.getGlobalCache) {
            return primaryResult;
          }
          var globalCache = resolutionHost.getGlobalCache();
          if (globalCache !== void 0 && !ts3.isExternalModuleNameRelative(moduleName) && !(primaryResult.resolvedModule && ts3.extensionIsTS(primaryResult.resolvedModule.extension))) {
            var _b = ts3.loadModuleFromGlobalCache(ts3.Debug.checkDefined(resolutionHost.globalCacheResolutionModuleName)(moduleName), resolutionHost.projectName, compilerOptions, host, globalCache, moduleResolutionCache), resolvedModule = _b.resolvedModule, failedLookupLocations = _b.failedLookupLocations;
            if (resolvedModule) {
              primaryResult.resolvedModule = resolvedModule;
              (_a = primaryResult.failedLookupLocations).push.apply(_a, failedLookupLocations);
              return primaryResult;
            }
          }
          return primaryResult;
        }
        function resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference, _containingSourceFile, resolutionMode) {
          return ts3.resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference, typeReferenceDirectiveResolutionCache, resolutionMode);
        }
        function resolveNamesWithLocalCache(_a) {
          var _b, _c, _d;
          var names = _a.names, containingFile = _a.containingFile, redirectedReference = _a.redirectedReference, cache = _a.cache, perDirectoryCacheWithRedirects = _a.perDirectoryCacheWithRedirects, loader2 = _a.loader, getResolutionWithResolvedFileName = _a.getResolutionWithResolvedFileName, shouldRetryResolution = _a.shouldRetryResolution, reusedNames = _a.reusedNames, logChanges = _a.logChanges, containingSourceFile = _a.containingSourceFile, containingSourceFileMode = _a.containingSourceFileMode;
          var path2 = resolutionHost.toPath(containingFile);
          var resolutionsInFile = cache.get(path2) || cache.set(path2, ts3.createModeAwareCache()).get(path2);
          var dirPath = ts3.getDirectoryPath(path2);
          var perDirectoryCache = perDirectoryCacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
          var perDirectoryResolution = perDirectoryCache.get(dirPath);
          if (!perDirectoryResolution) {
            perDirectoryResolution = ts3.createModeAwareCache();
            perDirectoryCache.set(dirPath, perDirectoryResolution);
          }
          var resolvedModules = [];
          var compilerOptions = resolutionHost.getCompilationSettings();
          var hasInvalidatedNonRelativeUnresolvedImport = logChanges && isFileWithInvalidatedNonRelativeUnresolvedImports(path2);
          var program2 = resolutionHost.getCurrentProgram();
          var oldRedirect = program2 && program2.getResolvedProjectReferenceToRedirect(containingFile);
          var unmatchedRedirects = oldRedirect ? !redirectedReference || redirectedReference.sourceFile.path !== oldRedirect.sourceFile.path : !!redirectedReference;
          var seenNamesInFile = ts3.createModeAwareCache();
          var i = 0;
          for (var _i = 0, names_5 = names; _i < names_5.length; _i++) {
            var entry = names_5[_i];
            var name = ts3.isString(entry) ? entry : entry.fileName.toLowerCase();
            var mode = !ts3.isString(entry) ? ts3.getModeForFileReference(entry, containingSourceFileMode) : containingSourceFile ? ts3.getModeForResolutionAtIndex(containingSourceFile, i) : void 0;
            i++;
            var resolution = resolutionsInFile.get(name, mode);
            if (!seenNamesInFile.has(name, mode) && unmatchedRedirects || !resolution || resolution.isInvalidated || hasInvalidatedNonRelativeUnresolvedImport && !ts3.isExternalModuleNameRelative(name) && shouldRetryResolution(resolution)) {
              var existingResolution = resolution;
              var resolutionInDirectory = perDirectoryResolution.get(name, mode);
              if (resolutionInDirectory) {
                resolution = resolutionInDirectory;
                var host = ((_b = resolutionHost.getCompilerHost) === null || _b === void 0 ? void 0 : _b.call(resolutionHost)) || resolutionHost;
                if (ts3.isTraceEnabled(compilerOptions, host)) {
                  var resolved = getResolutionWithResolvedFileName(resolution);
                  ts3.trace(host, loader2 === resolveModuleName ? (resolved === null || resolved === void 0 ? void 0 : resolved.resolvedFileName) ? resolved.packagetId ? ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4 : ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3 : ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved : (resolved === null || resolved === void 0 ? void 0 : resolved.resolvedFileName) ? resolved.packagetId ? ts3.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4 : ts3.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3 : ts3.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved, name, containingFile, ts3.getDirectoryPath(containingFile), resolved === null || resolved === void 0 ? void 0 : resolved.resolvedFileName, (resolved === null || resolved === void 0 ? void 0 : resolved.packagetId) && ts3.packageIdToString(resolved.packagetId));
                }
              } else {
                resolution = loader2(name, containingFile, compilerOptions, ((_c = resolutionHost.getCompilerHost) === null || _c === void 0 ? void 0 : _c.call(resolutionHost)) || resolutionHost, redirectedReference, containingSourceFile, mode);
                perDirectoryResolution.set(name, mode, resolution);
                if (resolutionHost.onDiscoveredSymlink && resolutionIsSymlink(resolution)) {
                  resolutionHost.onDiscoveredSymlink();
                }
              }
              resolutionsInFile.set(name, mode, resolution);
              watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, path2, getResolutionWithResolvedFileName);
              if (existingResolution) {
                stopWatchFailedLookupLocationOfResolution(existingResolution, path2, getResolutionWithResolvedFileName);
              }
              if (logChanges && filesWithChangedSetOfUnresolvedImports && !resolutionIsEqualTo(existingResolution, resolution)) {
                filesWithChangedSetOfUnresolvedImports.push(path2);
                logChanges = false;
              }
            } else {
              var host = ((_d = resolutionHost.getCompilerHost) === null || _d === void 0 ? void 0 : _d.call(resolutionHost)) || resolutionHost;
              if (ts3.isTraceEnabled(compilerOptions, host) && !seenNamesInFile.has(name, mode)) {
                var resolved = getResolutionWithResolvedFileName(resolution);
                ts3.trace(host, loader2 === resolveModuleName ? (resolved === null || resolved === void 0 ? void 0 : resolved.resolvedFileName) ? resolved.packagetId ? ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : ts3.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved : (resolved === null || resolved === void 0 ? void 0 : resolved.resolvedFileName) ? resolved.packagetId ? ts3.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : ts3.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : ts3.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved, name, containingFile, resolved === null || resolved === void 0 ? void 0 : resolved.resolvedFileName, (resolved === null || resolved === void 0 ? void 0 : resolved.packagetId) && ts3.packageIdToString(resolved.packagetId));
              }
            }
            ts3.Debug.assert(resolution !== void 0 && !resolution.isInvalidated);
            seenNamesInFile.set(name, mode, true);
            resolvedModules.push(getResolutionWithResolvedFileName(resolution));
          }
          resolutionsInFile.forEach(function(resolution2, name2, mode2) {
            if (!seenNamesInFile.has(name2, mode2) && !ts3.contains(reusedNames, name2)) {
              stopWatchFailedLookupLocationOfResolution(resolution2, path2, getResolutionWithResolvedFileName);
              resolutionsInFile.delete(name2, mode2);
            }
          });
          return resolvedModules;
          function resolutionIsEqualTo(oldResolution, newResolution) {
            if (oldResolution === newResolution) {
              return true;
            }
            if (!oldResolution || !newResolution) {
              return false;
            }
            var oldResult = getResolutionWithResolvedFileName(oldResolution);
            var newResult = getResolutionWithResolvedFileName(newResolution);
            if (oldResult === newResult) {
              return true;
            }
            if (!oldResult || !newResult) {
              return false;
            }
            return oldResult.resolvedFileName === newResult.resolvedFileName;
          }
        }
        function resolveTypeReferenceDirectives(typeDirectiveNames, containingFile, redirectedReference, containingFileMode) {
          return resolveNamesWithLocalCache({
            names: typeDirectiveNames,
            containingFile,
            redirectedReference,
            cache: resolvedTypeReferenceDirectives,
            perDirectoryCacheWithRedirects: perDirectoryResolvedTypeReferenceDirectives,
            loader: resolveTypeReferenceDirective,
            getResolutionWithResolvedFileName: getResolvedTypeReferenceDirective,
            shouldRetryResolution: function(resolution) {
              return resolution.resolvedTypeReferenceDirective === void 0;
            },
            containingSourceFileMode: containingFileMode
          });
        }
        function resolveModuleNames(moduleNames, containingFile, reusedNames, redirectedReference, containingSourceFile) {
          return resolveNamesWithLocalCache({
            names: moduleNames,
            containingFile,
            redirectedReference,
            cache: resolvedModuleNames,
            perDirectoryCacheWithRedirects: perDirectoryResolvedModuleNames,
            loader: resolveModuleName,
            getResolutionWithResolvedFileName: getResolvedModule,
            shouldRetryResolution: function(resolution) {
              return !resolution.resolvedModule || !ts3.resolutionExtensionIsTSOrJson(resolution.resolvedModule.extension);
            },
            reusedNames,
            logChanges: logChangesWhenResolvingModule,
            containingSourceFile
          });
        }
        function getResolvedModuleWithFailedLookupLocationsFromCache(moduleName, containingFile, resolutionMode) {
          var cache = resolvedModuleNames.get(resolutionHost.toPath(containingFile));
          if (!cache)
            return void 0;
          return cache.get(moduleName, resolutionMode);
        }
        function isNodeModulesAtTypesDirectory(dirPath) {
          return ts3.endsWith(dirPath, "/node_modules/@types");
        }
        function getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath) {
          if (isInDirectoryPath(rootPath, failedLookupLocationPath)) {
            failedLookupLocation = ts3.isRootedDiskPath(failedLookupLocation) ? ts3.normalizePath(failedLookupLocation) : ts3.getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory());
            var failedLookupPathSplit = failedLookupLocationPath.split(ts3.directorySeparator);
            var failedLookupSplit = failedLookupLocation.split(ts3.directorySeparator);
            ts3.Debug.assert(failedLookupSplit.length === failedLookupPathSplit.length, "FailedLookup: ".concat(failedLookupLocation, " failedLookupLocationPath: ").concat(failedLookupLocationPath));
            if (failedLookupPathSplit.length > rootSplitLength + 1) {
              return {
                dir: failedLookupSplit.slice(0, rootSplitLength + 1).join(ts3.directorySeparator),
                dirPath: failedLookupPathSplit.slice(0, rootSplitLength + 1).join(ts3.directorySeparator)
              };
            } else {
              return {
                dir: rootDir,
                dirPath: rootPath,
                nonRecursive: false
              };
            }
          }
          return getDirectoryToWatchFromFailedLookupLocationDirectory(ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory())), ts3.getDirectoryPath(failedLookupLocationPath));
        }
        function getDirectoryToWatchFromFailedLookupLocationDirectory(dir, dirPath) {
          while (ts3.pathContainsNodeModules(dirPath)) {
            dir = ts3.getDirectoryPath(dir);
            dirPath = ts3.getDirectoryPath(dirPath);
          }
          if (ts3.isNodeModulesDirectory(dirPath)) {
            return canWatchDirectory(ts3.getDirectoryPath(dirPath)) ? { dir, dirPath } : void 0;
          }
          var nonRecursive = true;
          var subDirectoryPath, subDirectory;
          if (rootPath !== void 0) {
            while (!isInDirectoryPath(dirPath, rootPath)) {
              var parentPath = ts3.getDirectoryPath(dirPath);
              if (parentPath === dirPath) {
                break;
              }
              nonRecursive = false;
              subDirectoryPath = dirPath;
              subDirectory = dir;
              dirPath = parentPath;
              dir = ts3.getDirectoryPath(dir);
            }
          }
          return canWatchDirectory(dirPath) ? { dir: subDirectory || dir, dirPath: subDirectoryPath || dirPath, nonRecursive } : void 0;
        }
        function isPathWithDefaultFailedLookupExtension(path2) {
          return ts3.fileExtensionIsOneOf(path2, failedLookupDefaultExtensions);
        }
        function watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, filePath, getResolutionWithResolvedFileName) {
          if (resolution.refCount) {
            resolution.refCount++;
            ts3.Debug.assertIsDefined(resolution.files);
          } else {
            resolution.refCount = 1;
            ts3.Debug.assert(ts3.length(resolution.files) === 0);
            if (ts3.isExternalModuleNameRelative(name)) {
              watchFailedLookupLocationOfResolution(resolution);
            } else {
              nonRelativeExternalModuleResolutions.add(name, resolution);
            }
            var resolved = getResolutionWithResolvedFileName(resolution);
            if (resolved && resolved.resolvedFileName) {
              resolvedFileToResolution.add(resolutionHost.toPath(resolved.resolvedFileName), resolution);
            }
          }
          (resolution.files || (resolution.files = [])).push(filePath);
        }
        function watchFailedLookupLocationOfResolution(resolution) {
          ts3.Debug.assert(!!resolution.refCount);
          var failedLookupLocations = resolution.failedLookupLocations;
          if (!failedLookupLocations.length)
            return;
          resolutionsWithFailedLookups.push(resolution);
          var setAtRoot = false;
          for (var _i = 0, failedLookupLocations_1 = failedLookupLocations; _i < failedLookupLocations_1.length; _i++) {
            var failedLookupLocation = failedLookupLocations_1[_i];
            var failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
            var toWatch = getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath);
            if (toWatch) {
              var dir = toWatch.dir, dirPath = toWatch.dirPath, nonRecursive = toWatch.nonRecursive;
              if (!isPathWithDefaultFailedLookupExtension(failedLookupLocationPath)) {
                var refCount = customFailedLookupPaths.get(failedLookupLocationPath) || 0;
                customFailedLookupPaths.set(failedLookupLocationPath, refCount + 1);
              }
              if (dirPath === rootPath) {
                ts3.Debug.assert(!nonRecursive);
                setAtRoot = true;
              } else {
                setDirectoryWatcher(dir, dirPath, nonRecursive);
              }
            }
          }
          if (setAtRoot) {
            setDirectoryWatcher(rootDir, rootPath, true);
          }
        }
        function watchFailedLookupLocationOfNonRelativeModuleResolutions(resolutions, name) {
          var program2 = resolutionHost.getCurrentProgram();
          if (!program2 || !program2.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(name)) {
            resolutions.forEach(watchFailedLookupLocationOfResolution);
          }
        }
        function setDirectoryWatcher(dir, dirPath, nonRecursive) {
          var dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
          if (dirWatcher) {
            ts3.Debug.assert(!!nonRecursive === !!dirWatcher.nonRecursive);
            dirWatcher.refCount++;
          } else {
            directoryWatchesOfFailedLookups.set(dirPath, { watcher: createDirectoryWatcher(dir, dirPath, nonRecursive), refCount: 1, nonRecursive });
          }
        }
        function stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName) {
          ts3.unorderedRemoveItem(ts3.Debug.checkDefined(resolution.files), filePath);
          resolution.refCount--;
          if (resolution.refCount) {
            return;
          }
          var resolved = getResolutionWithResolvedFileName(resolution);
          if (resolved && resolved.resolvedFileName) {
            resolvedFileToResolution.remove(resolutionHost.toPath(resolved.resolvedFileName), resolution);
          }
          if (!ts3.unorderedRemoveItem(resolutionsWithFailedLookups, resolution)) {
            return;
          }
          var failedLookupLocations = resolution.failedLookupLocations;
          var removeAtRoot = false;
          for (var _i = 0, failedLookupLocations_2 = failedLookupLocations; _i < failedLookupLocations_2.length; _i++) {
            var failedLookupLocation = failedLookupLocations_2[_i];
            var failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
            var toWatch = getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath);
            if (toWatch) {
              var dirPath = toWatch.dirPath;
              var refCount = customFailedLookupPaths.get(failedLookupLocationPath);
              if (refCount) {
                if (refCount === 1) {
                  customFailedLookupPaths.delete(failedLookupLocationPath);
                } else {
                  ts3.Debug.assert(refCount > 1);
                  customFailedLookupPaths.set(failedLookupLocationPath, refCount - 1);
                }
              }
              if (dirPath === rootPath) {
                removeAtRoot = true;
              } else {
                removeDirectoryWatcher(dirPath);
              }
            }
          }
          if (removeAtRoot) {
            removeDirectoryWatcher(rootPath);
          }
        }
        function removeDirectoryWatcher(dirPath) {
          var dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
          dirWatcher.refCount--;
        }
        function createDirectoryWatcher(directory, dirPath, nonRecursive) {
          return resolutionHost.watchDirectoryOfFailedLookupLocation(directory, function(fileOrDirectory) {
            var fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath);
          }, nonRecursive ? 0 : 1);
        }
        function removeResolutionsOfFileFromCache(cache, filePath, getResolutionWithResolvedFileName) {
          var resolutions = cache.get(filePath);
          if (resolutions) {
            resolutions.forEach(function(resolution) {
              return stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName);
            });
            cache.delete(filePath);
          }
        }
        function removeResolutionsFromProjectReferenceRedirects(filePath) {
          if (!ts3.fileExtensionIs(filePath, ".json"))
            return;
          var program2 = resolutionHost.getCurrentProgram();
          if (!program2)
            return;
          var resolvedProjectReference = program2.getResolvedProjectReferenceByPath(filePath);
          if (!resolvedProjectReference)
            return;
          resolvedProjectReference.commandLine.fileNames.forEach(function(f) {
            return removeResolutionsOfFile(resolutionHost.toPath(f));
          });
        }
        function removeResolutionsOfFile(filePath) {
          removeResolutionsOfFileFromCache(resolvedModuleNames, filePath, getResolvedModule);
          removeResolutionsOfFileFromCache(resolvedTypeReferenceDirectives, filePath, getResolvedTypeReferenceDirective);
        }
        function invalidateResolutions(resolutions, canInvalidate) {
          if (!resolutions)
            return false;
          var invalidated = false;
          for (var _i = 0, resolutions_1 = resolutions; _i < resolutions_1.length; _i++) {
            var resolution = resolutions_1[_i];
            if (resolution.isInvalidated || !canInvalidate(resolution))
              continue;
            resolution.isInvalidated = invalidated = true;
            for (var _a = 0, _b = ts3.Debug.checkDefined(resolution.files); _a < _b.length; _a++) {
              var containingFilePath = _b[_a];
              (filesWithInvalidatedResolutions || (filesWithInvalidatedResolutions = new ts3.Set())).add(containingFilePath);
              hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames || ts3.endsWith(containingFilePath, ts3.inferredTypesContainingFile);
            }
          }
          return invalidated;
        }
        function invalidateResolutionOfFile(filePath) {
          removeResolutionsOfFile(filePath);
          var prevHasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
          if (invalidateResolutions(resolvedFileToResolution.get(filePath), ts3.returnTrue) && hasChangedAutomaticTypeDirectiveNames && !prevHasChangedAutomaticTypeDirectiveNames) {
            resolutionHost.onChangedAutomaticTypeDirectiveNames();
          }
        }
        function setFilesWithInvalidatedNonRelativeUnresolvedImports(filesMap) {
          ts3.Debug.assert(filesWithInvalidatedNonRelativeUnresolvedImports === filesMap || filesWithInvalidatedNonRelativeUnresolvedImports === void 0);
          filesWithInvalidatedNonRelativeUnresolvedImports = filesMap;
        }
        function scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, isCreatingWatchedDirectory) {
          if (isCreatingWatchedDirectory) {
            (isInDirectoryChecks || (isInDirectoryChecks = [])).push(fileOrDirectoryPath);
          } else {
            var updatedPath = removeIgnoredPath(fileOrDirectoryPath);
            if (!updatedPath)
              return false;
            fileOrDirectoryPath = updatedPath;
            if (resolutionHost.fileIsOpen(fileOrDirectoryPath)) {
              return false;
            }
            var dirOfFileOrDirectory = ts3.getDirectoryPath(fileOrDirectoryPath);
            if (isNodeModulesAtTypesDirectory(fileOrDirectoryPath) || ts3.isNodeModulesDirectory(fileOrDirectoryPath) || isNodeModulesAtTypesDirectory(dirOfFileOrDirectory) || ts3.isNodeModulesDirectory(dirOfFileOrDirectory)) {
              (failedLookupChecks || (failedLookupChecks = [])).push(fileOrDirectoryPath);
              (startsWithPathChecks || (startsWithPathChecks = new ts3.Set())).add(fileOrDirectoryPath);
            } else {
              if (!isPathWithDefaultFailedLookupExtension(fileOrDirectoryPath) && !customFailedLookupPaths.has(fileOrDirectoryPath)) {
                return false;
              }
              if (ts3.isEmittedFileOfProgram(resolutionHost.getCurrentProgram(), fileOrDirectoryPath)) {
                return false;
              }
              (failedLookupChecks || (failedLookupChecks = [])).push(fileOrDirectoryPath);
              var packagePath = ts3.parseNodeModuleFromPath(fileOrDirectoryPath);
              if (packagePath)
                (startsWithPathChecks || (startsWithPathChecks = new ts3.Set())).add(packagePath);
            }
          }
          resolutionHost.scheduleInvalidateResolutionsOfFailedLookupLocations();
        }
        function invalidateResolutionsOfFailedLookupLocations() {
          if (!failedLookupChecks && !startsWithPathChecks && !isInDirectoryChecks) {
            return false;
          }
          var invalidated = invalidateResolutions(resolutionsWithFailedLookups, canInvalidateFailedLookupResolution);
          failedLookupChecks = void 0;
          startsWithPathChecks = void 0;
          isInDirectoryChecks = void 0;
          return invalidated;
        }
        function canInvalidateFailedLookupResolution(resolution) {
          return resolution.failedLookupLocations.some(function(location) {
            var locationPath = resolutionHost.toPath(location);
            return ts3.contains(failedLookupChecks, locationPath) || ts3.firstDefinedIterator((startsWithPathChecks === null || startsWithPathChecks === void 0 ? void 0 : startsWithPathChecks.keys()) || ts3.emptyIterator, function(fileOrDirectoryPath) {
              return ts3.startsWith(locationPath, fileOrDirectoryPath) ? true : void 0;
            }) || (isInDirectoryChecks === null || isInDirectoryChecks === void 0 ? void 0 : isInDirectoryChecks.some(function(fileOrDirectoryPath) {
              return isInDirectoryPath(fileOrDirectoryPath, locationPath);
            }));
          });
        }
        function closeTypeRootsWatch() {
          ts3.clearMap(typeRootsWatches, ts3.closeFileWatcher);
        }
        function getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath) {
          if (isInDirectoryPath(rootPath, typeRootPath)) {
            return rootPath;
          }
          var toWatch = getDirectoryToWatchFromFailedLookupLocationDirectory(typeRoot, typeRootPath);
          return toWatch && directoryWatchesOfFailedLookups.has(toWatch.dirPath) ? toWatch.dirPath : void 0;
        }
        function createTypeRootsWatch(typeRootPath, typeRoot) {
          return resolutionHost.watchTypeRootsDirectory(typeRoot, function(fileOrDirectory) {
            var fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            hasChangedAutomaticTypeDirectiveNames = true;
            resolutionHost.onChangedAutomaticTypeDirectiveNames();
            var dirPath = getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath);
            if (dirPath) {
              scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath);
            }
          }, 1);
        }
        function updateTypeRootsWatch() {
          var options = resolutionHost.getCompilationSettings();
          if (options.types) {
            closeTypeRootsWatch();
            return;
          }
          var typeRoots = ts3.getEffectiveTypeRoots(options, { directoryExists: directoryExistsForTypeRootWatch, getCurrentDirectory });
          if (typeRoots) {
            ts3.mutateMap(typeRootsWatches, ts3.arrayToMap(typeRoots, function(tr) {
              return resolutionHost.toPath(tr);
            }), {
              createNewValue: createTypeRootsWatch,
              onDeleteValue: ts3.closeFileWatcher
            });
          } else {
            closeTypeRootsWatch();
          }
        }
        function directoryExistsForTypeRootWatch(nodeTypesDirectory) {
          var dir = ts3.getDirectoryPath(ts3.getDirectoryPath(nodeTypesDirectory));
          var dirPath = resolutionHost.toPath(dir);
          return dirPath === rootPath || canWatchDirectory(dirPath);
        }
      }
      ts3.createResolutionCache = createResolutionCache;
      function resolutionIsSymlink(resolution) {
        var _a, _b;
        return !!(((_a = resolution.resolvedModule) === null || _a === void 0 ? void 0 : _a.originalPath) || ((_b = resolution.resolvedTypeReferenceDirective) === null || _b === void 0 ? void 0 : _b.originalPath));
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var moduleSpecifiers;
      (function(moduleSpecifiers_1) {
        var RelativePreference;
        (function(RelativePreference2) {
          RelativePreference2[RelativePreference2["Relative"] = 0] = "Relative";
          RelativePreference2[RelativePreference2["NonRelative"] = 1] = "NonRelative";
          RelativePreference2[RelativePreference2["Shortest"] = 2] = "Shortest";
          RelativePreference2[RelativePreference2["ExternalNonRelative"] = 3] = "ExternalNonRelative";
        })(RelativePreference || (RelativePreference = {}));
        var Ending;
        (function(Ending2) {
          Ending2[Ending2["Minimal"] = 0] = "Minimal";
          Ending2[Ending2["Index"] = 1] = "Index";
          Ending2[Ending2["JsExtension"] = 2] = "JsExtension";
        })(Ending || (Ending = {}));
        function getPreferences(host, _a, compilerOptions, importingSourceFile) {
          var importModuleSpecifierPreference = _a.importModuleSpecifierPreference, importModuleSpecifierEnding = _a.importModuleSpecifierEnding;
          return {
            relativePreference: importModuleSpecifierPreference === "relative" ? 0 : importModuleSpecifierPreference === "non-relative" ? 1 : importModuleSpecifierPreference === "project-relative" ? 3 : 2,
            ending: getEnding()
          };
          function getEnding() {
            switch (importModuleSpecifierEnding) {
              case "minimal":
                return 0;
              case "index":
                return 1;
              case "js":
                return 2;
              default:
                return usesJsExtensionOnImports(importingSourceFile) || isFormatRequiringExtensions(compilerOptions, importingSourceFile.path, host) ? 2 : ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeJs ? 1 : 0;
            }
          }
        }
        function getPreferencesForUpdate(compilerOptions, oldImportSpecifier, importingSourceFileName, host) {
          return {
            relativePreference: ts3.isExternalModuleNameRelative(oldImportSpecifier) ? 0 : 1,
            ending: ts3.hasJSFileExtension(oldImportSpecifier) || isFormatRequiringExtensions(compilerOptions, importingSourceFileName, host) ? 2 : ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeJs || ts3.endsWith(oldImportSpecifier, "index") ? 1 : 0
          };
        }
        function isFormatRequiringExtensions(compilerOptions, importingSourceFileName, host) {
          var _a;
          if (ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.Node16 && ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeNext) {
            return false;
          }
          return ts3.getImpliedNodeFormatForFile(importingSourceFileName, (_a = host.getPackageJsonInfoCache) === null || _a === void 0 ? void 0 : _a.call(host), getModuleResolutionHost(host), compilerOptions) !== ts3.ModuleKind.CommonJS;
        }
        function getModuleResolutionHost(host) {
          var _a;
          return {
            fileExists: host.fileExists,
            readFile: ts3.Debug.checkDefined(host.readFile),
            directoryExists: host.directoryExists,
            getCurrentDirectory: host.getCurrentDirectory,
            realpath: host.realpath,
            useCaseSensitiveFileNames: (_a = host.useCaseSensitiveFileNames) === null || _a === void 0 ? void 0 : _a.call(host)
          };
        }
        function updateModuleSpecifier(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, oldImportSpecifier, options) {
          if (options === void 0) {
            options = {};
          }
          var res = getModuleSpecifierWorker(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, getPreferencesForUpdate(compilerOptions, oldImportSpecifier, importingSourceFileName, host), {}, options);
          if (res === oldImportSpecifier)
            return void 0;
          return res;
        }
        moduleSpecifiers_1.updateModuleSpecifier = updateModuleSpecifier;
        function getModuleSpecifier(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, options) {
          if (options === void 0) {
            options = {};
          }
          return getModuleSpecifierWorker(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, getPreferences(host, {}, compilerOptions, importingSourceFile), {}, options);
        }
        moduleSpecifiers_1.getModuleSpecifier = getModuleSpecifier;
        function getNodeModulesPackageName(compilerOptions, importingSourceFile, nodeModulesFileName, host, preferences, options) {
          if (options === void 0) {
            options = {};
          }
          var info = getInfo(importingSourceFile.path, host);
          var modulePaths = getAllModulePaths(importingSourceFile.path, nodeModulesFileName, host, preferences, options);
          return ts3.firstDefined(modulePaths, function(modulePath) {
            return tryGetModuleNameAsNodeModule(modulePath, info, importingSourceFile, host, compilerOptions, preferences, true, options.overrideImportMode);
          });
        }
        moduleSpecifiers_1.getNodeModulesPackageName = getNodeModulesPackageName;
        function getModuleSpecifierWorker(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, preferences, userPreferences, options) {
          if (options === void 0) {
            options = {};
          }
          var info = getInfo(importingSourceFileName, host);
          var modulePaths = getAllModulePaths(importingSourceFileName, toFileName, host, userPreferences, options);
          return ts3.firstDefined(modulePaths, function(modulePath) {
            return tryGetModuleNameAsNodeModule(modulePath, info, importingSourceFile, host, compilerOptions, userPreferences, void 0, options.overrideImportMode);
          }) || getLocalModuleSpecifier(toFileName, info, compilerOptions, host, preferences);
        }
        function tryGetModuleSpecifiersFromCache(moduleSymbol, importingSourceFile, host, userPreferences, options) {
          if (options === void 0) {
            options = {};
          }
          return tryGetModuleSpecifiersFromCacheWorker(moduleSymbol, importingSourceFile, host, userPreferences, options)[0];
        }
        moduleSpecifiers_1.tryGetModuleSpecifiersFromCache = tryGetModuleSpecifiersFromCache;
        function tryGetModuleSpecifiersFromCacheWorker(moduleSymbol, importingSourceFile, host, userPreferences, options) {
          var _a;
          if (options === void 0) {
            options = {};
          }
          var moduleSourceFile = ts3.getSourceFileOfModule(moduleSymbol);
          if (!moduleSourceFile) {
            return ts3.emptyArray;
          }
          var cache = (_a = host.getModuleSpecifierCache) === null || _a === void 0 ? void 0 : _a.call(host);
          var cached = cache === null || cache === void 0 ? void 0 : cache.get(importingSourceFile.path, moduleSourceFile.path, userPreferences, options);
          return [cached === null || cached === void 0 ? void 0 : cached.moduleSpecifiers, moduleSourceFile, cached === null || cached === void 0 ? void 0 : cached.modulePaths, cache];
        }
        function getModuleSpecifiers(moduleSymbol, checker, compilerOptions, importingSourceFile, host, userPreferences, options) {
          if (options === void 0) {
            options = {};
          }
          return getModuleSpecifiersWithCacheInfo(moduleSymbol, checker, compilerOptions, importingSourceFile, host, userPreferences, options).moduleSpecifiers;
        }
        moduleSpecifiers_1.getModuleSpecifiers = getModuleSpecifiers;
        function getModuleSpecifiersWithCacheInfo(moduleSymbol, checker, compilerOptions, importingSourceFile, host, userPreferences, options) {
          if (options === void 0) {
            options = {};
          }
          var computedWithoutCache = false;
          var ambient = tryGetModuleNameFromAmbientModule(moduleSymbol, checker);
          if (ambient)
            return { moduleSpecifiers: [ambient], computedWithoutCache };
          var _a = tryGetModuleSpecifiersFromCacheWorker(moduleSymbol, importingSourceFile, host, userPreferences, options), specifiers = _a[0], moduleSourceFile = _a[1], modulePaths = _a[2], cache = _a[3];
          if (specifiers)
            return { moduleSpecifiers: specifiers, computedWithoutCache };
          if (!moduleSourceFile)
            return { moduleSpecifiers: ts3.emptyArray, computedWithoutCache };
          computedWithoutCache = true;
          modulePaths || (modulePaths = getAllModulePathsWorker(importingSourceFile.path, moduleSourceFile.originalFileName, host));
          var result2 = computeModuleSpecifiers(modulePaths, compilerOptions, importingSourceFile, host, userPreferences, options);
          cache === null || cache === void 0 ? void 0 : cache.set(importingSourceFile.path, moduleSourceFile.path, userPreferences, options, modulePaths, result2);
          return { moduleSpecifiers: result2, computedWithoutCache };
        }
        moduleSpecifiers_1.getModuleSpecifiersWithCacheInfo = getModuleSpecifiersWithCacheInfo;
        function computeModuleSpecifiers(modulePaths, compilerOptions, importingSourceFile, host, userPreferences, options) {
          if (options === void 0) {
            options = {};
          }
          var info = getInfo(importingSourceFile.path, host);
          var preferences = getPreferences(host, userPreferences, compilerOptions, importingSourceFile);
          var existingSpecifier = ts3.forEach(modulePaths, function(modulePath2) {
            return ts3.forEach(host.getFileIncludeReasons().get(ts3.toPath(modulePath2.path, host.getCurrentDirectory(), info.getCanonicalFileName)), function(reason) {
              if (reason.kind !== ts3.FileIncludeKind.Import || reason.file !== importingSourceFile.path)
                return void 0;
              if (importingSourceFile.impliedNodeFormat && importingSourceFile.impliedNodeFormat !== ts3.getModeForResolutionAtIndex(importingSourceFile, reason.index))
                return void 0;
              var specifier2 = ts3.getModuleNameStringLiteralAt(importingSourceFile, reason.index).text;
              return preferences.relativePreference !== 1 || !ts3.pathIsRelative(specifier2) ? specifier2 : void 0;
            });
          });
          if (existingSpecifier) {
            var moduleSpecifiers_2 = [existingSpecifier];
            return moduleSpecifiers_2;
          }
          var importedFileIsInNodeModules = ts3.some(modulePaths, function(p) {
            return p.isInNodeModules;
          });
          var nodeModulesSpecifiers;
          var pathsSpecifiers;
          var relativeSpecifiers;
          for (var _i = 0, modulePaths_1 = modulePaths; _i < modulePaths_1.length; _i++) {
            var modulePath = modulePaths_1[_i];
            var specifier = tryGetModuleNameAsNodeModule(modulePath, info, importingSourceFile, host, compilerOptions, userPreferences, void 0, options.overrideImportMode);
            nodeModulesSpecifiers = ts3.append(nodeModulesSpecifiers, specifier);
            if (specifier && modulePath.isRedirect) {
              return nodeModulesSpecifiers;
            }
            if (!specifier && !modulePath.isRedirect) {
              var local = getLocalModuleSpecifier(modulePath.path, info, compilerOptions, host, preferences);
              if (ts3.pathIsBareSpecifier(local)) {
                pathsSpecifiers = ts3.append(pathsSpecifiers, local);
              } else if (!importedFileIsInNodeModules || modulePath.isInNodeModules) {
                relativeSpecifiers = ts3.append(relativeSpecifiers, local);
              }
            }
          }
          return (pathsSpecifiers === null || pathsSpecifiers === void 0 ? void 0 : pathsSpecifiers.length) ? pathsSpecifiers : (nodeModulesSpecifiers === null || nodeModulesSpecifiers === void 0 ? void 0 : nodeModulesSpecifiers.length) ? nodeModulesSpecifiers : ts3.Debug.checkDefined(relativeSpecifiers);
        }
        function getInfo(importingSourceFileName, host) {
          var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : true);
          var sourceDirectory = ts3.getDirectoryPath(importingSourceFileName);
          return { getCanonicalFileName, importingSourceFileName, sourceDirectory };
        }
        function getLocalModuleSpecifier(moduleFileName, info, compilerOptions, host, _a) {
          var ending = _a.ending, relativePreference = _a.relativePreference;
          var baseUrl = compilerOptions.baseUrl, paths = compilerOptions.paths, rootDirs = compilerOptions.rootDirs;
          var sourceDirectory = info.sourceDirectory, getCanonicalFileName = info.getCanonicalFileName;
          var relativePath = rootDirs && tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, ending, compilerOptions) || removeExtensionAndIndexPostFix(ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(sourceDirectory, moduleFileName, getCanonicalFileName)), ending, compilerOptions);
          if (!baseUrl && !paths || relativePreference === 0) {
            return relativePath;
          }
          var baseDirectory = ts3.getNormalizedAbsolutePath(ts3.getPathsBasePath(compilerOptions, host) || baseUrl, host.getCurrentDirectory());
          var relativeToBaseUrl = getRelativePathIfInDirectory(moduleFileName, baseDirectory, getCanonicalFileName);
          if (!relativeToBaseUrl) {
            return relativePath;
          }
          var importRelativeToBaseUrl = removeExtensionAndIndexPostFix(relativeToBaseUrl, ending, compilerOptions);
          var fromPaths = paths && tryGetModuleNameFromPaths(ts3.removeFileExtension(relativeToBaseUrl), importRelativeToBaseUrl, paths);
          var nonRelative = fromPaths === void 0 && baseUrl !== void 0 ? importRelativeToBaseUrl : fromPaths;
          if (!nonRelative) {
            return relativePath;
          }
          if (relativePreference === 1) {
            return nonRelative;
          }
          if (relativePreference === 3) {
            var projectDirectory = compilerOptions.configFilePath ? ts3.toPath(ts3.getDirectoryPath(compilerOptions.configFilePath), host.getCurrentDirectory(), info.getCanonicalFileName) : info.getCanonicalFileName(host.getCurrentDirectory());
            var modulePath = ts3.toPath(moduleFileName, projectDirectory, getCanonicalFileName);
            var sourceIsInternal = ts3.startsWith(sourceDirectory, projectDirectory);
            var targetIsInternal = ts3.startsWith(modulePath, projectDirectory);
            if (sourceIsInternal && !targetIsInternal || !sourceIsInternal && targetIsInternal) {
              return nonRelative;
            }
            var nearestTargetPackageJson = getNearestAncestorDirectoryWithPackageJson(host, ts3.getDirectoryPath(modulePath));
            var nearestSourcePackageJson = getNearestAncestorDirectoryWithPackageJson(host, sourceDirectory);
            if (nearestSourcePackageJson !== nearestTargetPackageJson) {
              return nonRelative;
            }
            return relativePath;
          }
          if (relativePreference !== 2)
            ts3.Debug.assertNever(relativePreference);
          return isPathRelativeToParent(nonRelative) || countPathComponents(relativePath) < countPathComponents(nonRelative) ? relativePath : nonRelative;
        }
        function countPathComponents(path2) {
          var count = 0;
          for (var i = ts3.startsWith(path2, "./") ? 2 : 0; i < path2.length; i++) {
            if (path2.charCodeAt(i) === 47)
              count++;
          }
          return count;
        }
        moduleSpecifiers_1.countPathComponents = countPathComponents;
        function usesJsExtensionOnImports(_a) {
          var imports = _a.imports;
          return ts3.firstDefined(imports, function(_a2) {
            var text = _a2.text;
            return ts3.pathIsRelative(text) ? ts3.hasJSFileExtension(text) : void 0;
          }) || false;
        }
        function comparePathsByRedirectAndNumberOfDirectorySeparators(a, b) {
          return ts3.compareBooleans(b.isRedirect, a.isRedirect) || ts3.compareNumberOfDirectorySeparators(a.path, b.path);
        }
        function getNearestAncestorDirectoryWithPackageJson(host, fileName2) {
          if (host.getNearestAncestorDirectoryWithPackageJson) {
            return host.getNearestAncestorDirectoryWithPackageJson(fileName2);
          }
          return !!ts3.forEachAncestorDirectory(fileName2, function(directory) {
            return host.fileExists(ts3.combinePaths(directory, "package.json")) ? true : void 0;
          });
        }
        function forEachFileNameOfModule(importingFileName, importedFileName, host, preferSymlinks, cb) {
          var _a;
          var getCanonicalFileName = ts3.hostGetCanonicalFileName(host);
          var cwd = host.getCurrentDirectory();
          var referenceRedirect = host.isSourceOfProjectReferenceRedirect(importedFileName) ? host.getProjectReferenceRedirect(importedFileName) : void 0;
          var importedPath = ts3.toPath(importedFileName, cwd, getCanonicalFileName);
          var redirects = host.redirectTargetsMap.get(importedPath) || ts3.emptyArray;
          var importedFileNames = __spreadArray(__spreadArray(__spreadArray([], referenceRedirect ? [referenceRedirect] : ts3.emptyArray, true), [importedFileName], false), redirects, true);
          var targets = importedFileNames.map(function(f) {
            return ts3.getNormalizedAbsolutePath(f, cwd);
          });
          var shouldFilterIgnoredPaths = !ts3.every(targets, ts3.containsIgnoredPath);
          if (!preferSymlinks) {
            var result_15 = ts3.forEach(targets, function(p) {
              return !(shouldFilterIgnoredPaths && ts3.containsIgnoredPath(p)) && cb(p, referenceRedirect === p);
            });
            if (result_15)
              return result_15;
          }
          var symlinkedDirectories = (_a = host.getSymlinkCache) === null || _a === void 0 ? void 0 : _a.call(host).getSymlinkedDirectoriesByRealpath();
          var fullImportedFileName = ts3.getNormalizedAbsolutePath(importedFileName, cwd);
          var result2 = symlinkedDirectories && ts3.forEachAncestorDirectory(ts3.getDirectoryPath(fullImportedFileName), function(realPathDirectory) {
            var symlinkDirectories = symlinkedDirectories.get(ts3.ensureTrailingDirectorySeparator(ts3.toPath(realPathDirectory, cwd, getCanonicalFileName)));
            if (!symlinkDirectories)
              return void 0;
            if (ts3.startsWithDirectory(importingFileName, realPathDirectory, getCanonicalFileName)) {
              return false;
            }
            return ts3.forEach(targets, function(target) {
              if (!ts3.startsWithDirectory(target, realPathDirectory, getCanonicalFileName)) {
                return;
              }
              var relative = ts3.getRelativePathFromDirectory(realPathDirectory, target, getCanonicalFileName);
              for (var _i = 0, symlinkDirectories_1 = symlinkDirectories; _i < symlinkDirectories_1.length; _i++) {
                var symlinkDirectory = symlinkDirectories_1[_i];
                var option = ts3.resolvePath(symlinkDirectory, relative);
                var result_16 = cb(option, target === referenceRedirect);
                shouldFilterIgnoredPaths = true;
                if (result_16)
                  return result_16;
              }
            });
          });
          return result2 || (preferSymlinks ? ts3.forEach(targets, function(p) {
            return shouldFilterIgnoredPaths && ts3.containsIgnoredPath(p) ? void 0 : cb(p, p === referenceRedirect);
          }) : void 0);
        }
        moduleSpecifiers_1.forEachFileNameOfModule = forEachFileNameOfModule;
        function getAllModulePaths(importingFilePath, importedFileName, host, preferences, options) {
          var _a;
          if (options === void 0) {
            options = {};
          }
          var importedFilePath = ts3.toPath(importedFileName, host.getCurrentDirectory(), ts3.hostGetCanonicalFileName(host));
          var cache = (_a = host.getModuleSpecifierCache) === null || _a === void 0 ? void 0 : _a.call(host);
          if (cache) {
            var cached = cache.get(importingFilePath, importedFilePath, preferences, options);
            if (cached === null || cached === void 0 ? void 0 : cached.modulePaths)
              return cached.modulePaths;
          }
          var modulePaths = getAllModulePathsWorker(importingFilePath, importedFileName, host);
          if (cache) {
            cache.setModulePaths(importingFilePath, importedFilePath, preferences, options, modulePaths);
          }
          return modulePaths;
        }
        function getAllModulePathsWorker(importingFileName, importedFileName, host) {
          var getCanonicalFileName = ts3.hostGetCanonicalFileName(host);
          var allFileNames = new ts3.Map();
          var importedFileFromNodeModules = false;
          forEachFileNameOfModule(importingFileName, importedFileName, host, true, function(path2, isRedirect) {
            var isInNodeModules = ts3.pathContainsNodeModules(path2);
            allFileNames.set(path2, { path: getCanonicalFileName(path2), isRedirect, isInNodeModules });
            importedFileFromNodeModules = importedFileFromNodeModules || isInNodeModules;
          });
          var sortedPaths = [];
          var _loop_32 = function(directory2) {
            var directoryStart = ts3.ensureTrailingDirectorySeparator(directory2);
            var pathsInDirectory;
            allFileNames.forEach(function(_a, fileName2) {
              var path2 = _a.path, isRedirect = _a.isRedirect, isInNodeModules = _a.isInNodeModules;
              if (ts3.startsWith(path2, directoryStart)) {
                (pathsInDirectory || (pathsInDirectory = [])).push({ path: fileName2, isRedirect, isInNodeModules });
                allFileNames.delete(fileName2);
              }
            });
            if (pathsInDirectory) {
              if (pathsInDirectory.length > 1) {
                pathsInDirectory.sort(comparePathsByRedirectAndNumberOfDirectorySeparators);
              }
              sortedPaths.push.apply(sortedPaths, pathsInDirectory);
            }
            var newDirectory = ts3.getDirectoryPath(directory2);
            if (newDirectory === directory2)
              return out_directory_1 = directory2, "break";
            directory2 = newDirectory;
            out_directory_1 = directory2;
          };
          var out_directory_1;
          for (var directory = ts3.getDirectoryPath(importingFileName); allFileNames.size !== 0; ) {
            var state_10 = _loop_32(directory);
            directory = out_directory_1;
            if (state_10 === "break")
              break;
          }
          if (allFileNames.size) {
            var remainingPaths = ts3.arrayFrom(allFileNames.values());
            if (remainingPaths.length > 1)
              remainingPaths.sort(comparePathsByRedirectAndNumberOfDirectorySeparators);
            sortedPaths.push.apply(sortedPaths, remainingPaths);
          }
          return sortedPaths;
        }
        function tryGetModuleNameFromAmbientModule(moduleSymbol, checker) {
          var _a;
          var decl = (_a = moduleSymbol.declarations) === null || _a === void 0 ? void 0 : _a.find(function(d) {
            return ts3.isNonGlobalAmbientModule(d) && (!ts3.isExternalModuleAugmentation(d) || !ts3.isExternalModuleNameRelative(ts3.getTextOfIdentifierOrLiteral(d.name)));
          });
          if (decl) {
            return decl.name.text;
          }
          var ambientModuleDeclareCandidates = ts3.mapDefined(moduleSymbol.declarations, function(d) {
            var _a2, _b, _c, _d;
            if (!ts3.isModuleDeclaration(d))
              return;
            var topNamespace = getTopNamespace(d);
            if (!(((_a2 = topNamespace === null || topNamespace === void 0 ? void 0 : topNamespace.parent) === null || _a2 === void 0 ? void 0 : _a2.parent) && ts3.isModuleBlock(topNamespace.parent) && ts3.isAmbientModule(topNamespace.parent.parent) && ts3.isSourceFile(topNamespace.parent.parent.parent)))
              return;
            var exportAssignment = (_d = (_c = (_b = topNamespace.parent.parent.symbol.exports) === null || _b === void 0 ? void 0 : _b.get("export=")) === null || _c === void 0 ? void 0 : _c.valueDeclaration) === null || _d === void 0 ? void 0 : _d.expression;
            if (!exportAssignment)
              return;
            var exportSymbol = checker.getSymbolAtLocation(exportAssignment);
            if (!exportSymbol)
              return;
            var originalExportSymbol = (exportSymbol === null || exportSymbol === void 0 ? void 0 : exportSymbol.flags) & 2097152 ? checker.getAliasedSymbol(exportSymbol) : exportSymbol;
            if (originalExportSymbol === d.symbol)
              return topNamespace.parent.parent;
            function getTopNamespace(namespaceDeclaration) {
              while (namespaceDeclaration.flags & 4) {
                namespaceDeclaration = namespaceDeclaration.parent;
              }
              return namespaceDeclaration;
            }
          });
          var ambientModuleDeclare = ambientModuleDeclareCandidates[0];
          if (ambientModuleDeclare) {
            return ambientModuleDeclare.name.text;
          }
        }
        function tryGetModuleNameFromPaths(relativeToBaseUrlWithIndex, relativeToBaseUrl, paths) {
          for (var key in paths) {
            for (var _i = 0, _a = paths[key]; _i < _a.length; _i++) {
              var patternText_1 = _a[_i];
              var pattern = ts3.removeFileExtension(ts3.normalizePath(patternText_1));
              var indexOfStar = pattern.indexOf("*");
              if (indexOfStar !== -1) {
                var prefix = pattern.substr(0, indexOfStar);
                var suffix = pattern.substr(indexOfStar + 1);
                if (relativeToBaseUrl.length >= prefix.length + suffix.length && ts3.startsWith(relativeToBaseUrl, prefix) && ts3.endsWith(relativeToBaseUrl, suffix) || !suffix && relativeToBaseUrl === ts3.removeTrailingDirectorySeparator(prefix)) {
                  var matchedStar = relativeToBaseUrl.substr(prefix.length, relativeToBaseUrl.length - suffix.length - prefix.length);
                  return key.replace("*", matchedStar);
                }
              } else if (pattern === relativeToBaseUrl || pattern === relativeToBaseUrlWithIndex) {
                return key;
              }
            }
          }
        }
        var MatchingMode;
        (function(MatchingMode2) {
          MatchingMode2[MatchingMode2["Exact"] = 0] = "Exact";
          MatchingMode2[MatchingMode2["Directory"] = 1] = "Directory";
          MatchingMode2[MatchingMode2["Pattern"] = 2] = "Pattern";
        })(MatchingMode || (MatchingMode = {}));
        function tryGetModuleNameFromExports(options, targetFilePath, packageDirectory, packageName, exports2, conditions, mode) {
          if (mode === void 0) {
            mode = 0;
          }
          if (typeof exports2 === "string") {
            var pathOrPattern = ts3.getNormalizedAbsolutePath(ts3.combinePaths(packageDirectory, exports2), void 0);
            var extensionSwappedTarget = ts3.hasTSFileExtension(targetFilePath) ? ts3.removeFileExtension(targetFilePath) + tryGetJSExtensionForFile(targetFilePath, options) : void 0;
            switch (mode) {
              case 0:
                if (ts3.comparePaths(targetFilePath, pathOrPattern) === 0 || extensionSwappedTarget && ts3.comparePaths(extensionSwappedTarget, pathOrPattern) === 0) {
                  return { moduleFileToTry: packageName };
                }
                break;
              case 1:
                if (ts3.containsPath(pathOrPattern, targetFilePath)) {
                  var fragment = ts3.getRelativePathFromDirectory(pathOrPattern, targetFilePath, false);
                  return { moduleFileToTry: ts3.getNormalizedAbsolutePath(ts3.combinePaths(ts3.combinePaths(packageName, exports2), fragment), void 0) };
                }
                break;
              case 2:
                var starPos = pathOrPattern.indexOf("*");
                var leadingSlice = pathOrPattern.slice(0, starPos);
                var trailingSlice = pathOrPattern.slice(starPos + 1);
                if (ts3.startsWith(targetFilePath, leadingSlice) && ts3.endsWith(targetFilePath, trailingSlice)) {
                  var starReplacement = targetFilePath.slice(leadingSlice.length, targetFilePath.length - trailingSlice.length);
                  return { moduleFileToTry: packageName.replace("*", starReplacement) };
                }
                if (extensionSwappedTarget && ts3.startsWith(extensionSwappedTarget, leadingSlice) && ts3.endsWith(extensionSwappedTarget, trailingSlice)) {
                  var starReplacement = extensionSwappedTarget.slice(leadingSlice.length, extensionSwappedTarget.length - trailingSlice.length);
                  return { moduleFileToTry: packageName.replace("*", starReplacement) };
                }
                break;
            }
          } else if (Array.isArray(exports2)) {
            return ts3.forEach(exports2, function(e) {
              return tryGetModuleNameFromExports(options, targetFilePath, packageDirectory, packageName, e, conditions);
            });
          } else if (typeof exports2 === "object" && exports2 !== null) {
            if (ts3.allKeysStartWithDot(exports2)) {
              return ts3.forEach(ts3.getOwnKeys(exports2), function(k) {
                var subPackageName = ts3.getNormalizedAbsolutePath(ts3.combinePaths(packageName, k), void 0);
                var mode2 = ts3.endsWith(k, "/") ? 1 : ts3.stringContains(k, "*") ? 2 : 0;
                return tryGetModuleNameFromExports(options, targetFilePath, packageDirectory, subPackageName, exports2[k], conditions, mode2);
              });
            } else {
              for (var _i = 0, _a = ts3.getOwnKeys(exports2); _i < _a.length; _i++) {
                var key = _a[_i];
                if (key === "default" || conditions.indexOf(key) >= 0 || ts3.isApplicableVersionedTypesKey(conditions, key)) {
                  var subTarget = exports2[key];
                  var result2 = tryGetModuleNameFromExports(options, targetFilePath, packageDirectory, packageName, subTarget, conditions);
                  if (result2) {
                    return result2;
                  }
                }
              }
            }
          }
          return void 0;
        }
        function tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, ending, compilerOptions) {
          var normalizedTargetPath = getPathRelativeToRootDirs(moduleFileName, rootDirs, getCanonicalFileName);
          if (normalizedTargetPath === void 0) {
            return void 0;
          }
          var normalizedSourcePath = getPathRelativeToRootDirs(sourceDirectory, rootDirs, getCanonicalFileName);
          var relativePath = normalizedSourcePath !== void 0 ? ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(normalizedSourcePath, normalizedTargetPath, getCanonicalFileName)) : normalizedTargetPath;
          return ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs ? removeExtensionAndIndexPostFix(relativePath, ending, compilerOptions) : ts3.removeFileExtension(relativePath);
        }
        function tryGetModuleNameAsNodeModule(_a, _b, importingSourceFile, host, options, userPreferences, packageNameOnly, overrideMode) {
          var path2 = _a.path, isRedirect = _a.isRedirect;
          var getCanonicalFileName = _b.getCanonicalFileName, sourceDirectory = _b.sourceDirectory;
          if (!host.fileExists || !host.readFile) {
            return void 0;
          }
          var parts = ts3.getNodeModulePathParts(path2);
          if (!parts) {
            return void 0;
          }
          var moduleSpecifier = path2;
          var isPackageRootPath = false;
          if (!packageNameOnly) {
            var preferences = getPreferences(host, userPreferences, options, importingSourceFile);
            var packageRootIndex = parts.packageRootIndex;
            var moduleFileName = void 0;
            while (true) {
              var _c = tryDirectoryWithPackageJson(packageRootIndex), moduleFileToTry = _c.moduleFileToTry, packageRootPath = _c.packageRootPath, blockedByExports = _c.blockedByExports, verbatimFromExports = _c.verbatimFromExports;
              if (ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.Classic) {
                if (blockedByExports) {
                  return void 0;
                }
                if (verbatimFromExports) {
                  return moduleFileToTry;
                }
              }
              if (packageRootPath) {
                moduleSpecifier = packageRootPath;
                isPackageRootPath = true;
                break;
              }
              if (!moduleFileName)
                moduleFileName = moduleFileToTry;
              packageRootIndex = path2.indexOf(ts3.directorySeparator, packageRootIndex + 1);
              if (packageRootIndex === -1) {
                moduleSpecifier = removeExtensionAndIndexPostFix(moduleFileName, preferences.ending, options, host);
                break;
              }
            }
          }
          if (isRedirect && !isPackageRootPath) {
            return void 0;
          }
          var globalTypingsCacheLocation = host.getGlobalTypingsCacheLocation && host.getGlobalTypingsCacheLocation();
          var pathToTopLevelNodeModules = getCanonicalFileName(moduleSpecifier.substring(0, parts.topLevelNodeModulesIndex));
          if (!(ts3.startsWith(sourceDirectory, pathToTopLevelNodeModules) || globalTypingsCacheLocation && ts3.startsWith(getCanonicalFileName(globalTypingsCacheLocation), pathToTopLevelNodeModules))) {
            return void 0;
          }
          var nodeModulesDirectoryName = moduleSpecifier.substring(parts.topLevelPackageNameIndex + 1);
          var packageName = ts3.getPackageNameFromTypesPackageName(nodeModulesDirectoryName);
          return ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.Classic && packageName === nodeModulesDirectoryName ? void 0 : packageName;
          function tryDirectoryWithPackageJson(packageRootIndex2) {
            var _a2, _b2;
            var packageRootPath2 = path2.substring(0, packageRootIndex2);
            var packageJsonPath = ts3.combinePaths(packageRootPath2, "package.json");
            var moduleFileToTry2 = path2;
            var cachedPackageJson = (_b2 = (_a2 = host.getPackageJsonInfoCache) === null || _a2 === void 0 ? void 0 : _a2.call(host)) === null || _b2 === void 0 ? void 0 : _b2.getPackageJsonInfo(packageJsonPath);
            if (typeof cachedPackageJson === "object" || cachedPackageJson === void 0 && host.fileExists(packageJsonPath)) {
              var packageJsonContent = (cachedPackageJson === null || cachedPackageJson === void 0 ? void 0 : cachedPackageJson.packageJsonContent) || JSON.parse(host.readFile(packageJsonPath));
              if (ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(options) === ts3.ModuleResolutionKind.NodeNext) {
                var conditions = ["node", overrideMode || importingSourceFile.impliedNodeFormat === ts3.ModuleKind.ESNext ? "import" : "require", "types"];
                var fromExports = packageJsonContent.exports && typeof packageJsonContent.name === "string" ? tryGetModuleNameFromExports(options, path2, packageRootPath2, ts3.getPackageNameFromTypesPackageName(packageJsonContent.name), packageJsonContent.exports, conditions) : void 0;
                if (fromExports) {
                  var withJsExtension = !ts3.hasTSFileExtension(fromExports.moduleFileToTry) ? fromExports : { moduleFileToTry: ts3.removeFileExtension(fromExports.moduleFileToTry) + tryGetJSExtensionForFile(fromExports.moduleFileToTry, options) };
                  return __assign(__assign({}, withJsExtension), { verbatimFromExports: true });
                }
                if (packageJsonContent.exports) {
                  return { moduleFileToTry: path2, blockedByExports: true };
                }
              }
              var versionPaths = packageJsonContent.typesVersions ? ts3.getPackageJsonTypesVersionsPaths(packageJsonContent.typesVersions) : void 0;
              if (versionPaths) {
                var subModuleName = path2.slice(packageRootPath2.length + 1);
                var fromPaths = tryGetModuleNameFromPaths(ts3.removeFileExtension(subModuleName), removeExtensionAndIndexPostFix(subModuleName, 0, options), versionPaths.paths);
                if (fromPaths !== void 0) {
                  moduleFileToTry2 = ts3.combinePaths(packageRootPath2, fromPaths);
                }
              }
              var mainFileRelative = packageJsonContent.typings || packageJsonContent.types || packageJsonContent.main || "index.js";
              if (ts3.isString(mainFileRelative)) {
                var mainExportFile = ts3.toPath(mainFileRelative, packageRootPath2, getCanonicalFileName);
                if (ts3.removeFileExtension(mainExportFile) === ts3.removeFileExtension(getCanonicalFileName(moduleFileToTry2))) {
                  return { packageRootPath: packageRootPath2, moduleFileToTry: moduleFileToTry2 };
                }
              }
            } else {
              var fileName2 = getCanonicalFileName(moduleFileToTry2.substring(parts.packageRootIndex + 1));
              if (fileName2 === "index.d.ts" || fileName2 === "index.js" || fileName2 === "index.ts" || fileName2 === "index.tsx") {
                return { moduleFileToTry: moduleFileToTry2, packageRootPath: packageRootPath2 };
              }
            }
            return { moduleFileToTry: moduleFileToTry2 };
          }
        }
        function tryGetAnyFileFromPath(host, path2) {
          if (!host.fileExists)
            return;
          var extensions = ts3.flatten(ts3.getSupportedExtensions({ allowJs: true }, [{ extension: "node", isMixedContent: false }, { extension: "json", isMixedContent: false, scriptKind: 6 }]));
          for (var _i = 0, extensions_3 = extensions; _i < extensions_3.length; _i++) {
            var e = extensions_3[_i];
            var fullPath = path2 + e;
            if (host.fileExists(fullPath)) {
              return fullPath;
            }
          }
        }
        function getPathRelativeToRootDirs(path2, rootDirs, getCanonicalFileName) {
          return ts3.firstDefined(rootDirs, function(rootDir) {
            var relativePath = getRelativePathIfInDirectory(path2, rootDir, getCanonicalFileName);
            return relativePath !== void 0 && isPathRelativeToParent(relativePath) ? void 0 : relativePath;
          });
        }
        function removeExtensionAndIndexPostFix(fileName2, ending, options, host) {
          if (ts3.fileExtensionIsOneOf(fileName2, [".json", ".mjs", ".cjs"]))
            return fileName2;
          var noExtension = ts3.removeFileExtension(fileName2);
          if (fileName2 === noExtension)
            return fileName2;
          if (ts3.fileExtensionIsOneOf(fileName2, [".d.mts", ".mts", ".d.cts", ".cts"]))
            return noExtension + getJSExtensionForFile(fileName2, options);
          switch (ending) {
            case 0:
              var withoutIndex = ts3.removeSuffix(noExtension, "/index");
              if (host && withoutIndex !== noExtension && tryGetAnyFileFromPath(host, withoutIndex)) {
                return noExtension;
              }
              return withoutIndex;
            case 1:
              return noExtension;
            case 2:
              return noExtension + getJSExtensionForFile(fileName2, options);
            default:
              return ts3.Debug.assertNever(ending);
          }
        }
        function getJSExtensionForFile(fileName2, options) {
          var _a;
          return (_a = tryGetJSExtensionForFile(fileName2, options)) !== null && _a !== void 0 ? _a : ts3.Debug.fail("Extension ".concat(ts3.extensionFromPath(fileName2), " is unsupported:: FileName:: ").concat(fileName2));
        }
        function tryGetJSExtensionForFile(fileName2, options) {
          var ext = ts3.tryGetExtensionFromPath(fileName2);
          switch (ext) {
            case ".ts":
            case ".d.ts":
              return ".js";
            case ".tsx":
              return options.jsx === 1 ? ".jsx" : ".js";
            case ".js":
            case ".jsx":
            case ".json":
              return ext;
            case ".d.mts":
            case ".mts":
            case ".mjs":
              return ".mjs";
            case ".d.cts":
            case ".cts":
            case ".cjs":
              return ".cjs";
            default:
              return void 0;
          }
        }
        moduleSpecifiers_1.tryGetJSExtensionForFile = tryGetJSExtensionForFile;
        function getRelativePathIfInDirectory(path2, directoryPath, getCanonicalFileName) {
          var relativePath = ts3.getRelativePathToDirectoryOrUrl(directoryPath, path2, directoryPath, getCanonicalFileName, false);
          return ts3.isRootedDiskPath(relativePath) ? void 0 : relativePath;
        }
        function isPathRelativeToParent(path2) {
          return ts3.startsWith(path2, "..");
        }
      })(moduleSpecifiers = ts3.moduleSpecifiers || (ts3.moduleSpecifiers = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var sysFormatDiagnosticsHost = ts3.sys ? {
        getCurrentDirectory: function() {
          return ts3.sys.getCurrentDirectory();
        },
        getNewLine: function() {
          return ts3.sys.newLine;
        },
        getCanonicalFileName: ts3.createGetCanonicalFileName(ts3.sys.useCaseSensitiveFileNames)
      } : void 0;
      function createDiagnosticReporter(system, pretty) {
        var host = system === ts3.sys && sysFormatDiagnosticsHost ? sysFormatDiagnosticsHost : {
          getCurrentDirectory: function() {
            return system.getCurrentDirectory();
          },
          getNewLine: function() {
            return system.newLine;
          },
          getCanonicalFileName: ts3.createGetCanonicalFileName(system.useCaseSensitiveFileNames)
        };
        if (!pretty) {
          return function(diagnostic) {
            return system.write(ts3.formatDiagnostic(diagnostic, host));
          };
        }
        var diagnostics = new Array(1);
        return function(diagnostic) {
          diagnostics[0] = diagnostic;
          system.write(ts3.formatDiagnosticsWithColorAndContext(diagnostics, host) + host.getNewLine());
          diagnostics[0] = void 0;
        };
      }
      ts3.createDiagnosticReporter = createDiagnosticReporter;
      function clearScreenIfNotWatchingForFileChanges(system, diagnostic, options) {
        if (system.clearScreen && !options.preserveWatchOutput && !options.extendedDiagnostics && !options.diagnostics && ts3.contains(ts3.screenStartingMessageCodes, diagnostic.code)) {
          system.clearScreen();
          return true;
        }
        return false;
      }
      ts3.screenStartingMessageCodes = [
        ts3.Diagnostics.Starting_compilation_in_watch_mode.code,
        ts3.Diagnostics.File_change_detected_Starting_incremental_compilation.code
      ];
      function getPlainDiagnosticFollowingNewLines(diagnostic, newLine) {
        return ts3.contains(ts3.screenStartingMessageCodes, diagnostic.code) ? newLine + newLine : newLine;
      }
      function getLocaleTimeString(system) {
        return !system.now ? new Date().toLocaleTimeString() : system.now().toLocaleTimeString("en-US", { timeZone: "UTC" });
      }
      ts3.getLocaleTimeString = getLocaleTimeString;
      function createWatchStatusReporter(system, pretty) {
        return pretty ? function(diagnostic, newLine, options) {
          clearScreenIfNotWatchingForFileChanges(system, diagnostic, options);
          var output = "[".concat(ts3.formatColorAndReset(getLocaleTimeString(system), ts3.ForegroundColorEscapeSequences.Grey), "] ");
          output += "".concat(ts3.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine)).concat(newLine + newLine);
          system.write(output);
        } : function(diagnostic, newLine, options) {
          var output = "";
          if (!clearScreenIfNotWatchingForFileChanges(system, diagnostic, options)) {
            output += newLine;
          }
          output += "".concat(getLocaleTimeString(system), " - ");
          output += "".concat(ts3.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine)).concat(getPlainDiagnosticFollowingNewLines(diagnostic, newLine));
          system.write(output);
        };
      }
      ts3.createWatchStatusReporter = createWatchStatusReporter;
      function parseConfigFileWithSystem(configFileName, optionsToExtend, extendedConfigCache, watchOptionsToExtend, system, reportDiagnostic) {
        var host = system;
        host.onUnRecoverableConfigFileDiagnostic = function(diagnostic) {
          return reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic);
        };
        var result2 = ts3.getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend);
        host.onUnRecoverableConfigFileDiagnostic = void 0;
        return result2;
      }
      ts3.parseConfigFileWithSystem = parseConfigFileWithSystem;
      function getErrorCountForSummary(diagnostics) {
        return ts3.countWhere(diagnostics, function(diagnostic) {
          return diagnostic.category === ts3.DiagnosticCategory.Error;
        });
      }
      ts3.getErrorCountForSummary = getErrorCountForSummary;
      function getFilesInErrorForSummary(diagnostics) {
        var filesInError = ts3.filter(diagnostics, function(diagnostic) {
          return diagnostic.category === ts3.DiagnosticCategory.Error;
        }).map(function(errorDiagnostic) {
          if (errorDiagnostic.file === void 0)
            return;
          return "".concat(errorDiagnostic.file.fileName);
        });
        return filesInError.map(function(fileName2) {
          var diagnosticForFileName = ts3.find(diagnostics, function(diagnostic) {
            return diagnostic.file !== void 0 && diagnostic.file.fileName === fileName2;
          });
          if (diagnosticForFileName !== void 0) {
            var line = ts3.getLineAndCharacterOfPosition(diagnosticForFileName.file, diagnosticForFileName.start).line;
            return {
              fileName: fileName2,
              line: line + 1
            };
          }
        });
      }
      ts3.getFilesInErrorForSummary = getFilesInErrorForSummary;
      function getWatchErrorSummaryDiagnosticMessage(errorCount) {
        return errorCount === 1 ? ts3.Diagnostics.Found_1_error_Watching_for_file_changes : ts3.Diagnostics.Found_0_errors_Watching_for_file_changes;
      }
      ts3.getWatchErrorSummaryDiagnosticMessage = getWatchErrorSummaryDiagnosticMessage;
      function prettyPathForFileError(error, cwd) {
        var line = ts3.formatColorAndReset(":" + error.line, ts3.ForegroundColorEscapeSequences.Grey);
        if (ts3.pathIsAbsolute(error.fileName) && ts3.pathIsAbsolute(cwd)) {
          return ts3.getRelativePathFromDirectory(cwd, error.fileName, false) + line;
        }
        return error.fileName + line;
      }
      function getErrorSummaryText(errorCount, filesInError, newLine, host) {
        if (errorCount === 0)
          return "";
        var nonNilFiles = filesInError.filter(function(fileInError) {
          return fileInError !== void 0;
        });
        var distinctFileNamesWithLines = nonNilFiles.map(function(fileInError) {
          return "".concat(fileInError.fileName, ":").concat(fileInError.line);
        }).filter(function(value, index, self2) {
          return self2.indexOf(value) === index;
        });
        var firstFileReference = nonNilFiles[0] && prettyPathForFileError(nonNilFiles[0], host.getCurrentDirectory());
        var d = errorCount === 1 ? ts3.createCompilerDiagnostic(filesInError[0] !== void 0 ? ts3.Diagnostics.Found_1_error_in_1 : ts3.Diagnostics.Found_1_error, errorCount, firstFileReference) : ts3.createCompilerDiagnostic(distinctFileNamesWithLines.length === 0 ? ts3.Diagnostics.Found_0_errors : distinctFileNamesWithLines.length === 1 ? ts3.Diagnostics.Found_0_errors_in_the_same_file_starting_at_Colon_1 : ts3.Diagnostics.Found_0_errors_in_1_files, errorCount, distinctFileNamesWithLines.length === 1 ? firstFileReference : distinctFileNamesWithLines.length);
        var suffix = distinctFileNamesWithLines.length > 1 ? createTabularErrorsDisplay(nonNilFiles, host) : "";
        return "".concat(newLine).concat(ts3.flattenDiagnosticMessageText(d.messageText, newLine)).concat(newLine).concat(newLine).concat(suffix);
      }
      ts3.getErrorSummaryText = getErrorSummaryText;
      function createTabularErrorsDisplay(filesInError, host) {
        var distinctFiles = filesInError.filter(function(value, index, self2) {
          return index === self2.findIndex(function(file) {
            return (file === null || file === void 0 ? void 0 : file.fileName) === (value === null || value === void 0 ? void 0 : value.fileName);
          });
        });
        if (distinctFiles.length === 0)
          return "";
        var numberLength = function(num) {
          return Math.log(num) * Math.LOG10E + 1;
        };
        var fileToErrorCount = distinctFiles.map(function(file) {
          return [file, ts3.countWhere(filesInError, function(fileInError) {
            return fileInError.fileName === file.fileName;
          })];
        });
        var maxErrors = fileToErrorCount.reduce(function(acc, value) {
          return Math.max(acc, value[1] || 0);
        }, 0);
        var headerRow = ts3.Diagnostics.Errors_Files.message;
        var leftColumnHeadingLength = headerRow.split(" ")[0].length;
        var leftPaddingGoal = Math.max(leftColumnHeadingLength, numberLength(maxErrors));
        var headerPadding = Math.max(numberLength(maxErrors) - leftColumnHeadingLength, 0);
        var tabularData = "";
        tabularData += " ".repeat(headerPadding) + headerRow + "\n";
        fileToErrorCount.forEach(function(row) {
          var file = row[0], errorCount = row[1];
          var errorCountDigitsLength = Math.log(errorCount) * Math.LOG10E + 1 | 0;
          var leftPadding = errorCountDigitsLength < leftPaddingGoal ? " ".repeat(leftPaddingGoal - errorCountDigitsLength) : "";
          var fileRef = prettyPathForFileError(file, host.getCurrentDirectory());
          tabularData += "".concat(leftPadding).concat(errorCount, "  ").concat(fileRef, "\n");
        });
        return tabularData;
      }
      function isBuilderProgram(program2) {
        return !!program2.getState;
      }
      ts3.isBuilderProgram = isBuilderProgram;
      function listFiles(program2, write) {
        var options = program2.getCompilerOptions();
        if (options.explainFiles) {
          explainFiles(isBuilderProgram(program2) ? program2.getProgram() : program2, write);
        } else if (options.listFiles || options.listFilesOnly) {
          ts3.forEach(program2.getSourceFiles(), function(file) {
            write(file.fileName);
          });
        }
      }
      ts3.listFiles = listFiles;
      function explainFiles(program2, write) {
        var _a, _b;
        var reasons = program2.getFileIncludeReasons();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(program2.useCaseSensitiveFileNames());
        var relativeFileName = function(fileName2) {
          return ts3.convertToRelativePath(fileName2, program2.getCurrentDirectory(), getCanonicalFileName);
        };
        for (var _i = 0, _c = program2.getSourceFiles(); _i < _c.length; _i++) {
          var file = _c[_i];
          write("".concat(toFileName(file, relativeFileName)));
          (_a = reasons.get(file.path)) === null || _a === void 0 ? void 0 : _a.forEach(function(reason) {
            return write("  ".concat(fileIncludeReasonToDiagnostics(program2, reason, relativeFileName).messageText));
          });
          (_b = explainIfFileIsRedirect(file, relativeFileName)) === null || _b === void 0 ? void 0 : _b.forEach(function(d) {
            return write("  ".concat(d.messageText));
          });
        }
      }
      ts3.explainFiles = explainFiles;
      function explainIfFileIsRedirect(file, fileNameConvertor) {
        var result2;
        if (file.path !== file.resolvedPath) {
          (result2 || (result2 = [])).push(ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.File_is_output_of_project_reference_source_0, toFileName(file.originalFileName, fileNameConvertor)));
        }
        if (file.redirectInfo) {
          (result2 || (result2 = [])).push(ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.File_redirects_to_file_0, toFileName(file.redirectInfo.redirectTarget, fileNameConvertor)));
        }
        return result2;
      }
      ts3.explainIfFileIsRedirect = explainIfFileIsRedirect;
      function getMatchedFileSpec(program2, fileName2) {
        var _a;
        var configFile = program2.getCompilerOptions().configFile;
        if (!((_a = configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) === null || _a === void 0 ? void 0 : _a.validatedFilesSpec))
          return void 0;
        var getCanonicalFileName = ts3.createGetCanonicalFileName(program2.useCaseSensitiveFileNames());
        var filePath = getCanonicalFileName(fileName2);
        var basePath = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(configFile.fileName, program2.getCurrentDirectory()));
        return ts3.find(configFile.configFileSpecs.validatedFilesSpec, function(fileSpec) {
          return getCanonicalFileName(ts3.getNormalizedAbsolutePath(fileSpec, basePath)) === filePath;
        });
      }
      ts3.getMatchedFileSpec = getMatchedFileSpec;
      function getMatchedIncludeSpec(program2, fileName2) {
        var _a, _b;
        var configFile = program2.getCompilerOptions().configFile;
        if (!((_a = configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) === null || _a === void 0 ? void 0 : _a.validatedIncludeSpecs))
          return void 0;
        var isJsonFile = ts3.fileExtensionIs(fileName2, ".json");
        var basePath = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(configFile.fileName, program2.getCurrentDirectory()));
        var useCaseSensitiveFileNames = program2.useCaseSensitiveFileNames();
        return ts3.find((_b = configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) === null || _b === void 0 ? void 0 : _b.validatedIncludeSpecs, function(includeSpec) {
          if (isJsonFile && !ts3.endsWith(includeSpec, ".json"))
            return false;
          var pattern = ts3.getPatternFromSpec(includeSpec, basePath, "files");
          return !!pattern && ts3.getRegexFromPattern("(".concat(pattern, ")$"), useCaseSensitiveFileNames).test(fileName2);
        });
      }
      ts3.getMatchedIncludeSpec = getMatchedIncludeSpec;
      function fileIncludeReasonToDiagnostics(program2, reason, fileNameConvertor) {
        var _a, _b;
        var options = program2.getCompilerOptions();
        if (ts3.isReferencedFile(reason)) {
          var referenceLocation = ts3.getReferencedFileLocation(function(path2) {
            return program2.getSourceFileByPath(path2);
          }, reason);
          var referenceText = ts3.isReferenceFileLocation(referenceLocation) ? referenceLocation.file.text.substring(referenceLocation.pos, referenceLocation.end) : '"'.concat(referenceLocation.text, '"');
          var message = void 0;
          ts3.Debug.assert(ts3.isReferenceFileLocation(referenceLocation) || reason.kind === ts3.FileIncludeKind.Import, "Only synthetic references are imports");
          switch (reason.kind) {
            case ts3.FileIncludeKind.Import:
              if (ts3.isReferenceFileLocation(referenceLocation)) {
                message = referenceLocation.packageId ? ts3.Diagnostics.Imported_via_0_from_file_1_with_packageId_2 : ts3.Diagnostics.Imported_via_0_from_file_1;
              } else if (referenceLocation.text === ts3.externalHelpersModuleNameText) {
                message = referenceLocation.packageId ? ts3.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions : ts3.Diagnostics.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions;
              } else {
                message = referenceLocation.packageId ? ts3.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions : ts3.Diagnostics.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;
              }
              break;
            case ts3.FileIncludeKind.ReferenceFile:
              ts3.Debug.assert(!referenceLocation.packageId);
              message = ts3.Diagnostics.Referenced_via_0_from_file_1;
              break;
            case ts3.FileIncludeKind.TypeReferenceDirective:
              message = referenceLocation.packageId ? ts3.Diagnostics.Type_library_referenced_via_0_from_file_1_with_packageId_2 : ts3.Diagnostics.Type_library_referenced_via_0_from_file_1;
              break;
            case ts3.FileIncludeKind.LibReferenceDirective:
              ts3.Debug.assert(!referenceLocation.packageId);
              message = ts3.Diagnostics.Library_referenced_via_0_from_file_1;
              break;
            default:
              ts3.Debug.assertNever(reason);
          }
          return ts3.chainDiagnosticMessages(void 0, message, referenceText, toFileName(referenceLocation.file, fileNameConvertor), referenceLocation.packageId && ts3.packageIdToString(referenceLocation.packageId));
        }
        switch (reason.kind) {
          case ts3.FileIncludeKind.RootFile:
            if (!((_a = options.configFile) === null || _a === void 0 ? void 0 : _a.configFileSpecs))
              return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Root_file_specified_for_compilation);
            var fileName2 = ts3.getNormalizedAbsolutePath(program2.getRootFileNames()[reason.index], program2.getCurrentDirectory());
            var matchedByFiles = getMatchedFileSpec(program2, fileName2);
            if (matchedByFiles)
              return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Part_of_files_list_in_tsconfig_json);
            var matchedByInclude = getMatchedIncludeSpec(program2, fileName2);
            return matchedByInclude ? ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Matched_by_include_pattern_0_in_1, matchedByInclude, toFileName(options.configFile, fileNameConvertor)) : ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Root_file_specified_for_compilation);
          case ts3.FileIncludeKind.SourceFromProjectReference:
          case ts3.FileIncludeKind.OutputFromProjectReference:
            var isOutput = reason.kind === ts3.FileIncludeKind.OutputFromProjectReference;
            var referencedResolvedRef = ts3.Debug.checkDefined((_b = program2.getResolvedProjectReferences()) === null || _b === void 0 ? void 0 : _b[reason.index]);
            return ts3.chainDiagnosticMessages(void 0, ts3.outFile(options) ? isOutput ? ts3.Diagnostics.Output_from_referenced_project_0_included_because_1_specified : ts3.Diagnostics.Source_from_referenced_project_0_included_because_1_specified : isOutput ? ts3.Diagnostics.Output_from_referenced_project_0_included_because_module_is_specified_as_none : ts3.Diagnostics.Source_from_referenced_project_0_included_because_module_is_specified_as_none, toFileName(referencedResolvedRef.sourceFile.fileName, fileNameConvertor), options.outFile ? "--outFile" : "--out");
          case ts3.FileIncludeKind.AutomaticTypeDirectiveFile:
            return ts3.chainDiagnosticMessages(void 0, options.types ? reason.packageId ? ts3.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1 : ts3.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions : reason.packageId ? ts3.Diagnostics.Entry_point_for_implicit_type_library_0_with_packageId_1 : ts3.Diagnostics.Entry_point_for_implicit_type_library_0, reason.typeReference, reason.packageId && ts3.packageIdToString(reason.packageId));
          case ts3.FileIncludeKind.LibFile:
            if (reason.index !== void 0)
              return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Library_0_specified_in_compilerOptions, options.lib[reason.index]);
            var target = ts3.forEachEntry(ts3.targetOptionDeclaration.type, function(value, key) {
              return value === ts3.getEmitScriptTarget(options) ? key : void 0;
            });
            return ts3.chainDiagnosticMessages(void 0, target ? ts3.Diagnostics.Default_library_for_target_0 : ts3.Diagnostics.Default_library, target);
          default:
            ts3.Debug.assertNever(reason);
        }
      }
      ts3.fileIncludeReasonToDiagnostics = fileIncludeReasonToDiagnostics;
      function toFileName(file, fileNameConvertor) {
        var fileName2 = ts3.isString(file) ? file : file.fileName;
        return fileNameConvertor ? fileNameConvertor(fileName2) : fileName2;
      }
      function emitFilesAndReportErrors(program2, reportDiagnostic, write, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
        var isListFilesOnly = !!program2.getCompilerOptions().listFilesOnly;
        var allDiagnostics = program2.getConfigFileParsingDiagnostics().slice();
        var configFileParsingDiagnosticsLength = allDiagnostics.length;
        ts3.addRange(allDiagnostics, program2.getSyntacticDiagnostics(void 0, cancellationToken));
        if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
          ts3.addRange(allDiagnostics, program2.getOptionsDiagnostics(cancellationToken));
          if (!isListFilesOnly) {
            ts3.addRange(allDiagnostics, program2.getGlobalDiagnostics(cancellationToken));
            if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
              ts3.addRange(allDiagnostics, program2.getSemanticDiagnostics(void 0, cancellationToken));
            }
          }
        }
        var emitResult = isListFilesOnly ? { emitSkipped: true, diagnostics: ts3.emptyArray } : program2.emit(void 0, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers);
        var emittedFiles = emitResult.emittedFiles, emitDiagnostics = emitResult.diagnostics;
        ts3.addRange(allDiagnostics, emitDiagnostics);
        var diagnostics = ts3.sortAndDeduplicateDiagnostics(allDiagnostics);
        diagnostics.forEach(reportDiagnostic);
        if (write) {
          var currentDir_1 = program2.getCurrentDirectory();
          ts3.forEach(emittedFiles, function(file) {
            var filepath = ts3.getNormalizedAbsolutePath(file, currentDir_1);
            write("TSFILE: ".concat(filepath));
          });
          listFiles(program2, write);
        }
        if (reportSummary) {
          reportSummary(getErrorCountForSummary(diagnostics), getFilesInErrorForSummary(diagnostics));
        }
        return {
          emitResult,
          diagnostics
        };
      }
      ts3.emitFilesAndReportErrors = emitFilesAndReportErrors;
      function emitFilesAndReportErrorsAndGetExitStatus(program2, reportDiagnostic, write, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
        var _a = emitFilesAndReportErrors(program2, reportDiagnostic, write, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers), emitResult = _a.emitResult, diagnostics = _a.diagnostics;
        if (emitResult.emitSkipped && diagnostics.length > 0) {
          return ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped;
        } else if (diagnostics.length > 0) {
          return ts3.ExitStatus.DiagnosticsPresent_OutputsGenerated;
        }
        return ts3.ExitStatus.Success;
      }
      ts3.emitFilesAndReportErrorsAndGetExitStatus = emitFilesAndReportErrorsAndGetExitStatus;
      ts3.noopFileWatcher = { close: ts3.noop };
      ts3.returnNoopFileWatcher = function() {
        return ts3.noopFileWatcher;
      };
      function createWatchHost(system, reportWatchStatus) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var onWatchStatusChange = reportWatchStatus || createWatchStatusReporter(system);
        return {
          onWatchStatusChange,
          watchFile: ts3.maybeBind(system, system.watchFile) || ts3.returnNoopFileWatcher,
          watchDirectory: ts3.maybeBind(system, system.watchDirectory) || ts3.returnNoopFileWatcher,
          setTimeout: ts3.maybeBind(system, system.setTimeout) || ts3.noop,
          clearTimeout: ts3.maybeBind(system, system.clearTimeout) || ts3.noop
        };
      }
      ts3.createWatchHost = createWatchHost;
      ts3.WatchType = {
        ConfigFile: "Config file",
        ExtendedConfigFile: "Extended config file",
        SourceFile: "Source file",
        MissingFile: "Missing file",
        WildcardDirectory: "Wild card directory",
        FailedLookupLocations: "Failed Lookup Locations",
        TypeRoots: "Type roots",
        ConfigFileOfReferencedProject: "Config file of referened project",
        ExtendedConfigOfReferencedProject: "Extended config file of referenced project",
        WildcardDirectoryOfReferencedProject: "Wild card directory of referenced project",
        PackageJson: "package.json file"
      };
      function createWatchFactory(host, options) {
        var watchLogLevel = host.trace ? options.extendedDiagnostics ? ts3.WatchLogLevel.Verbose : options.diagnostics ? ts3.WatchLogLevel.TriggerOnly : ts3.WatchLogLevel.None : ts3.WatchLogLevel.None;
        var writeLog = watchLogLevel !== ts3.WatchLogLevel.None ? function(s) {
          return host.trace(s);
        } : ts3.noop;
        var result2 = ts3.getWatchFactory(host, watchLogLevel, writeLog);
        result2.writeLog = writeLog;
        return result2;
      }
      ts3.createWatchFactory = createWatchFactory;
      function createCompilerHostFromProgramHost(host, getCompilerOptions, directoryStructureHost) {
        if (directoryStructureHost === void 0) {
          directoryStructureHost = host;
        }
        var useCaseSensitiveFileNames = host.useCaseSensitiveFileNames();
        var hostGetNewLine = ts3.memoize(function() {
          return host.getNewLine();
        });
        return {
          getSourceFile: function(fileName2, languageVersionOrOptions, onError) {
            var text;
            try {
              ts3.performance.mark("beforeIORead");
              text = host.readFile(fileName2, getCompilerOptions().charset);
              ts3.performance.mark("afterIORead");
              ts3.performance.measure("I/O Read", "beforeIORead", "afterIORead");
            } catch (e) {
              if (onError) {
                onError(e.message);
              }
              text = "";
            }
            return text !== void 0 ? ts3.createSourceFile(fileName2, text, languageVersionOrOptions) : void 0;
          },
          getDefaultLibLocation: ts3.maybeBind(host, host.getDefaultLibLocation),
          getDefaultLibFileName: function(options) {
            return host.getDefaultLibFileName(options);
          },
          writeFile,
          getCurrentDirectory: ts3.memoize(function() {
            return host.getCurrentDirectory();
          }),
          useCaseSensitiveFileNames: function() {
            return useCaseSensitiveFileNames;
          },
          getCanonicalFileName: ts3.createGetCanonicalFileName(useCaseSensitiveFileNames),
          getNewLine: function() {
            return ts3.getNewLineCharacter(getCompilerOptions(), hostGetNewLine);
          },
          fileExists: function(f) {
            return host.fileExists(f);
          },
          readFile: function(f) {
            return host.readFile(f);
          },
          trace: ts3.maybeBind(host, host.trace),
          directoryExists: ts3.maybeBind(directoryStructureHost, directoryStructureHost.directoryExists),
          getDirectories: ts3.maybeBind(directoryStructureHost, directoryStructureHost.getDirectories),
          realpath: ts3.maybeBind(host, host.realpath),
          getEnvironmentVariable: ts3.maybeBind(host, host.getEnvironmentVariable) || function() {
            return "";
          },
          createHash: ts3.maybeBind(host, host.createHash),
          readDirectory: ts3.maybeBind(host, host.readDirectory),
          disableUseFileVersionAsSignature: host.disableUseFileVersionAsSignature,
          storeFilesChangingSignatureDuringEmit: host.storeFilesChangingSignatureDuringEmit
        };
        function writeFile(fileName2, text, writeByteOrderMark, onError) {
          try {
            ts3.performance.mark("beforeIOWrite");
            ts3.writeFileEnsuringDirectories(fileName2, text, writeByteOrderMark, function(path2, data, writeByteOrderMark2) {
              return host.writeFile(path2, data, writeByteOrderMark2);
            }, function(path2) {
              return host.createDirectory(path2);
            }, function(path2) {
              return host.directoryExists(path2);
            });
            ts3.performance.mark("afterIOWrite");
            ts3.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
          } catch (e) {
            if (onError) {
              onError(e.message);
            }
          }
        }
      }
      ts3.createCompilerHostFromProgramHost = createCompilerHostFromProgramHost;
      function setGetSourceFileAsHashVersioned(compilerHost, host) {
        var originalGetSourceFile = compilerHost.getSourceFile;
        var computeHash = ts3.maybeBind(host, host.createHash) || ts3.generateDjb2Hash;
        compilerHost.getSourceFile = function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          var result2 = originalGetSourceFile.call.apply(originalGetSourceFile, __spreadArray([compilerHost], args, false));
          if (result2) {
            result2.version = computeHash(result2.text);
          }
          return result2;
        };
      }
      ts3.setGetSourceFileAsHashVersioned = setGetSourceFileAsHashVersioned;
      function createProgramHost(system, createProgram) {
        var getDefaultLibLocation = ts3.memoize(function() {
          return ts3.getDirectoryPath(ts3.normalizePath(system.getExecutingFilePath()));
        });
        return {
          useCaseSensitiveFileNames: function() {
            return system.useCaseSensitiveFileNames;
          },
          getNewLine: function() {
            return system.newLine;
          },
          getCurrentDirectory: ts3.memoize(function() {
            return system.getCurrentDirectory();
          }),
          getDefaultLibLocation,
          getDefaultLibFileName: function(options) {
            return ts3.combinePaths(getDefaultLibLocation(), ts3.getDefaultLibFileName(options));
          },
          fileExists: function(path2) {
            return system.fileExists(path2);
          },
          readFile: function(path2, encoding) {
            return system.readFile(path2, encoding);
          },
          directoryExists: function(path2) {
            return system.directoryExists(path2);
          },
          getDirectories: function(path2) {
            return system.getDirectories(path2);
          },
          readDirectory: function(path2, extensions, exclude, include, depth) {
            return system.readDirectory(path2, extensions, exclude, include, depth);
          },
          realpath: ts3.maybeBind(system, system.realpath),
          getEnvironmentVariable: ts3.maybeBind(system, system.getEnvironmentVariable),
          trace: function(s) {
            return system.write(s + system.newLine);
          },
          createDirectory: function(path2) {
            return system.createDirectory(path2);
          },
          writeFile: function(path2, data, writeByteOrderMark) {
            return system.writeFile(path2, data, writeByteOrderMark);
          },
          createHash: ts3.maybeBind(system, system.createHash),
          createProgram: createProgram || ts3.createEmitAndSemanticDiagnosticsBuilderProgram,
          disableUseFileVersionAsSignature: system.disableUseFileVersionAsSignature,
          storeFilesChangingSignatureDuringEmit: system.storeFilesChangingSignatureDuringEmit
        };
      }
      ts3.createProgramHost = createProgramHost;
      function createWatchCompilerHost(system, createProgram, reportDiagnostic, reportWatchStatus) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var write = function(s) {
          return system.write(s + system.newLine);
        };
        var result2 = createProgramHost(system, createProgram);
        ts3.copyProperties(result2, createWatchHost(system, reportWatchStatus));
        result2.afterProgramCreate = function(builderProgram) {
          var compilerOptions = builderProgram.getCompilerOptions();
          var newLine = ts3.getNewLineCharacter(compilerOptions, function() {
            return system.newLine;
          });
          emitFilesAndReportErrors(builderProgram, reportDiagnostic, write, function(errorCount) {
            return result2.onWatchStatusChange(ts3.createCompilerDiagnostic(getWatchErrorSummaryDiagnosticMessage(errorCount), errorCount), newLine, compilerOptions, errorCount);
          });
        };
        return result2;
      }
      function reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic) {
        reportDiagnostic(diagnostic);
        system.exit(ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped);
      }
      function createWatchCompilerHostOfConfigFile(_a) {
        var configFileName = _a.configFileName, optionsToExtend = _a.optionsToExtend, watchOptionsToExtend = _a.watchOptionsToExtend, extraFileExtensions = _a.extraFileExtensions, system = _a.system, createProgram = _a.createProgram, reportDiagnostic = _a.reportDiagnostic, reportWatchStatus = _a.reportWatchStatus;
        var diagnosticReporter = reportDiagnostic || createDiagnosticReporter(system);
        var host = createWatchCompilerHost(system, createProgram, diagnosticReporter, reportWatchStatus);
        host.onUnRecoverableConfigFileDiagnostic = function(diagnostic) {
          return reportUnrecoverableDiagnostic(system, diagnosticReporter, diagnostic);
        };
        host.configFileName = configFileName;
        host.optionsToExtend = optionsToExtend;
        host.watchOptionsToExtend = watchOptionsToExtend;
        host.extraFileExtensions = extraFileExtensions;
        return host;
      }
      ts3.createWatchCompilerHostOfConfigFile = createWatchCompilerHostOfConfigFile;
      function createWatchCompilerHostOfFilesAndCompilerOptions(_a) {
        var rootFiles = _a.rootFiles, options = _a.options, watchOptions = _a.watchOptions, projectReferences = _a.projectReferences, system = _a.system, createProgram = _a.createProgram, reportDiagnostic = _a.reportDiagnostic, reportWatchStatus = _a.reportWatchStatus;
        var host = createWatchCompilerHost(system, createProgram, reportDiagnostic || createDiagnosticReporter(system), reportWatchStatus);
        host.rootFiles = rootFiles;
        host.options = options;
        host.watchOptions = watchOptions;
        host.projectReferences = projectReferences;
        return host;
      }
      ts3.createWatchCompilerHostOfFilesAndCompilerOptions = createWatchCompilerHostOfFilesAndCompilerOptions;
      function performIncrementalCompilation(input) {
        var system = input.system || ts3.sys;
        var host = input.host || (input.host = ts3.createIncrementalCompilerHost(input.options, system));
        var builderProgram = ts3.createIncrementalProgram(input);
        var exitStatus = emitFilesAndReportErrorsAndGetExitStatus(builderProgram, input.reportDiagnostic || createDiagnosticReporter(system), function(s) {
          return host.trace && host.trace(s);
        }, input.reportErrorSummary || input.options.pretty ? function(errorCount, filesInError) {
          return system.write(getErrorSummaryText(errorCount, filesInError, system.newLine, host));
        } : void 0);
        if (input.afterProgramEmitAndDiagnostics)
          input.afterProgramEmitAndDiagnostics(builderProgram);
        return exitStatus;
      }
      ts3.performIncrementalCompilation = performIncrementalCompilation;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function readBuilderProgram(compilerOptions, host) {
        if (ts3.outFile(compilerOptions))
          return void 0;
        var buildInfoPath = ts3.getTsBuildInfoEmitOutputFilePath(compilerOptions);
        if (!buildInfoPath)
          return void 0;
        var content = host.readFile(buildInfoPath);
        if (!content)
          return void 0;
        var buildInfo = ts3.getBuildInfo(content);
        if (buildInfo.version !== ts3.version)
          return void 0;
        if (!buildInfo.program)
          return void 0;
        return ts3.createBuildProgramUsingProgramBuildInfo(buildInfo.program, buildInfoPath, host);
      }
      ts3.readBuilderProgram = readBuilderProgram;
      function createIncrementalCompilerHost(options, system) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var host = ts3.createCompilerHostWorker(options, void 0, system);
        host.createHash = ts3.maybeBind(system, system.createHash);
        host.disableUseFileVersionAsSignature = system.disableUseFileVersionAsSignature;
        host.storeFilesChangingSignatureDuringEmit = system.storeFilesChangingSignatureDuringEmit;
        ts3.setGetSourceFileAsHashVersioned(host, system);
        ts3.changeCompilerHostLikeToUseCache(host, function(fileName2) {
          return ts3.toPath(fileName2, host.getCurrentDirectory(), host.getCanonicalFileName);
        });
        return host;
      }
      ts3.createIncrementalCompilerHost = createIncrementalCompilerHost;
      function createIncrementalProgram(_a) {
        var rootNames = _a.rootNames, options = _a.options, configFileParsingDiagnostics = _a.configFileParsingDiagnostics, projectReferences = _a.projectReferences, host = _a.host, createProgram = _a.createProgram;
        host = host || createIncrementalCompilerHost(options);
        createProgram = createProgram || ts3.createEmitAndSemanticDiagnosticsBuilderProgram;
        var oldProgram = readBuilderProgram(options, host);
        return createProgram(rootNames, options, host, oldProgram, configFileParsingDiagnostics, projectReferences);
      }
      ts3.createIncrementalProgram = createIncrementalProgram;
      function createWatchCompilerHost(rootFilesOrConfigFileName, options, system, createProgram, reportDiagnostic, reportWatchStatus, projectReferencesOrWatchOptionsToExtend, watchOptionsOrExtraFileExtensions) {
        if (ts3.isArray(rootFilesOrConfigFileName)) {
          return ts3.createWatchCompilerHostOfFilesAndCompilerOptions({
            rootFiles: rootFilesOrConfigFileName,
            options,
            watchOptions: watchOptionsOrExtraFileExtensions,
            projectReferences: projectReferencesOrWatchOptionsToExtend,
            system,
            createProgram,
            reportDiagnostic,
            reportWatchStatus
          });
        } else {
          return ts3.createWatchCompilerHostOfConfigFile({
            configFileName: rootFilesOrConfigFileName,
            optionsToExtend: options,
            watchOptionsToExtend: projectReferencesOrWatchOptionsToExtend,
            extraFileExtensions: watchOptionsOrExtraFileExtensions,
            system,
            createProgram,
            reportDiagnostic,
            reportWatchStatus
          });
        }
      }
      ts3.createWatchCompilerHost = createWatchCompilerHost;
      function createWatchProgram(host) {
        var builderProgram;
        var reloadLevel;
        var missingFilesMap;
        var packageJsonMap;
        var watchedWildcardDirectories;
        var timerToUpdateProgram;
        var timerToInvalidateFailedLookupResolutions;
        var parsedConfigs;
        var sharedExtendedConfigFileWatchers;
        var extendedConfigCache = host.extendedConfigCache;
        var changesAffectResolution = false;
        var reportFileChangeDetectedOnCreateProgram = false;
        var sourceFilesCache = new ts3.Map();
        var missingFilePathsRequestedForRelease;
        var hasChangedCompilerOptions = false;
        var useCaseSensitiveFileNames = host.useCaseSensitiveFileNames();
        var currentDirectory = host.getCurrentDirectory();
        var configFileName = host.configFileName, _a = host.optionsToExtend, optionsToExtendForConfigFile = _a === void 0 ? {} : _a, watchOptionsToExtend = host.watchOptionsToExtend, extraFileExtensions = host.extraFileExtensions, createProgram = host.createProgram;
        var rootFileNames = host.rootFiles, compilerOptions = host.options, watchOptions = host.watchOptions, projectReferences = host.projectReferences;
        var wildcardDirectories;
        var configFileParsingDiagnostics;
        var canConfigFileJsonReportNoInputFiles = false;
        var hasChangedConfigFileParsingErrors = false;
        var cachedDirectoryStructureHost = configFileName === void 0 ? void 0 : ts3.createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames);
        var directoryStructureHost = cachedDirectoryStructureHost || host;
        var parseConfigFileHost = ts3.parseConfigHostFromCompilerHostLike(host, directoryStructureHost);
        var newLine = updateNewLine();
        if (configFileName && host.configFileParsingResult) {
          setConfigFileParsingResult(host.configFileParsingResult);
          newLine = updateNewLine();
        }
        reportWatchDiagnostic(ts3.Diagnostics.Starting_compilation_in_watch_mode);
        if (configFileName && !host.configFileParsingResult) {
          newLine = ts3.getNewLineCharacter(optionsToExtendForConfigFile, function() {
            return host.getNewLine();
          });
          ts3.Debug.assert(!rootFileNames);
          parseConfigFile();
          newLine = updateNewLine();
        }
        var _b = ts3.createWatchFactory(host, compilerOptions), watchFile = _b.watchFile, watchDirectory = _b.watchDirectory, writeLog = _b.writeLog;
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        writeLog("Current directory: ".concat(currentDirectory, " CaseSensitiveFileNames: ").concat(useCaseSensitiveFileNames));
        var configFileWatcher;
        if (configFileName) {
          configFileWatcher = watchFile(configFileName, scheduleProgramReload, ts3.PollingInterval.High, watchOptions, ts3.WatchType.ConfigFile);
        }
        var compilerHost = ts3.createCompilerHostFromProgramHost(host, function() {
          return compilerOptions;
        }, directoryStructureHost);
        ts3.setGetSourceFileAsHashVersioned(compilerHost, host);
        var getNewSourceFile = compilerHost.getSourceFile;
        compilerHost.getSourceFile = function(fileName2) {
          var args = [];
          for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
          }
          return getVersionedSourceFileByPath.apply(void 0, __spreadArray([fileName2, toPath(fileName2)], args, false));
        };
        compilerHost.getSourceFileByPath = getVersionedSourceFileByPath;
        compilerHost.getNewLine = function() {
          return newLine;
        };
        compilerHost.fileExists = fileExists;
        compilerHost.onReleaseOldSourceFile = onReleaseOldSourceFile;
        compilerHost.onReleaseParsedCommandLine = onReleaseParsedCommandLine;
        compilerHost.toPath = toPath;
        compilerHost.getCompilationSettings = function() {
          return compilerOptions;
        };
        compilerHost.useSourceOfProjectReferenceRedirect = ts3.maybeBind(host, host.useSourceOfProjectReferenceRedirect);
        compilerHost.watchDirectoryOfFailedLookupLocation = function(dir, cb, flags) {
          return watchDirectory(dir, cb, flags, watchOptions, ts3.WatchType.FailedLookupLocations);
        };
        compilerHost.watchTypeRootsDirectory = function(dir, cb, flags) {
          return watchDirectory(dir, cb, flags, watchOptions, ts3.WatchType.TypeRoots);
        };
        compilerHost.getCachedDirectoryStructureHost = function() {
          return cachedDirectoryStructureHost;
        };
        compilerHost.scheduleInvalidateResolutionsOfFailedLookupLocations = scheduleInvalidateResolutionsOfFailedLookupLocations;
        compilerHost.onInvalidatedResolution = scheduleProgramUpdate;
        compilerHost.onChangedAutomaticTypeDirectiveNames = scheduleProgramUpdate;
        compilerHost.fileIsOpen = ts3.returnFalse;
        compilerHost.getCurrentProgram = getCurrentProgram;
        compilerHost.writeLog = writeLog;
        compilerHost.getParsedCommandLine = getParsedCommandLine;
        var resolutionCache = ts3.createResolutionCache(compilerHost, configFileName ? ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(configFileName, currentDirectory)) : currentDirectory, false);
        compilerHost.resolveModuleNames = host.resolveModuleNames ? function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return host.resolveModuleNames.apply(host, args);
        } : function(moduleNames, containingFile, reusedNames, redirectedReference, _options, sourceFile) {
          return resolutionCache.resolveModuleNames(moduleNames, containingFile, reusedNames, redirectedReference, sourceFile);
        };
        compilerHost.resolveTypeReferenceDirectives = host.resolveTypeReferenceDirectives ? function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return host.resolveTypeReferenceDirectives.apply(host, args);
        } : function(typeDirectiveNames, containingFile, redirectedReference, _options, containingFileMode) {
          return resolutionCache.resolveTypeReferenceDirectives(typeDirectiveNames, containingFile, redirectedReference, containingFileMode);
        };
        var userProvidedResolution = !!host.resolveModuleNames || !!host.resolveTypeReferenceDirectives;
        builderProgram = readBuilderProgram(compilerOptions, compilerHost);
        synchronizeProgram();
        watchConfigFileWildCardDirectories();
        if (configFileName)
          updateExtendedConfigFilesWatches(toPath(configFileName), compilerOptions, watchOptions, ts3.WatchType.ExtendedConfigFile);
        return configFileName ? { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, close } : { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, updateRootFileNames, close };
        function close() {
          clearInvalidateResolutionsOfFailedLookupLocations();
          resolutionCache.clear();
          ts3.clearMap(sourceFilesCache, function(value) {
            if (value && value.fileWatcher) {
              value.fileWatcher.close();
              value.fileWatcher = void 0;
            }
          });
          if (configFileWatcher) {
            configFileWatcher.close();
            configFileWatcher = void 0;
          }
          extendedConfigCache === null || extendedConfigCache === void 0 ? void 0 : extendedConfigCache.clear();
          extendedConfigCache = void 0;
          if (sharedExtendedConfigFileWatchers) {
            ts3.clearMap(sharedExtendedConfigFileWatchers, ts3.closeFileWatcherOf);
            sharedExtendedConfigFileWatchers = void 0;
          }
          if (watchedWildcardDirectories) {
            ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcherOf);
            watchedWildcardDirectories = void 0;
          }
          if (missingFilesMap) {
            ts3.clearMap(missingFilesMap, ts3.closeFileWatcher);
            missingFilesMap = void 0;
          }
          if (parsedConfigs) {
            ts3.clearMap(parsedConfigs, function(config) {
              var _a2;
              (_a2 = config.watcher) === null || _a2 === void 0 ? void 0 : _a2.close();
              config.watcher = void 0;
              if (config.watchedDirectories)
                ts3.clearMap(config.watchedDirectories, ts3.closeFileWatcherOf);
              config.watchedDirectories = void 0;
            });
            parsedConfigs = void 0;
          }
          if (packageJsonMap) {
            ts3.clearMap(packageJsonMap, ts3.closeFileWatcher);
            packageJsonMap = void 0;
          }
        }
        function getCurrentBuilderProgram() {
          return builderProgram;
        }
        function getCurrentProgram() {
          return builderProgram && builderProgram.getProgramOrUndefined();
        }
        function synchronizeProgram() {
          writeLog("Synchronizing program");
          clearInvalidateResolutionsOfFailedLookupLocations();
          var program2 = getCurrentBuilderProgram();
          if (hasChangedCompilerOptions) {
            newLine = updateNewLine();
            if (program2 && (changesAffectResolution || ts3.changesAffectModuleResolution(program2.getCompilerOptions(), compilerOptions))) {
              resolutionCache.clear();
            }
          }
          var hasInvalidatedResolution = resolutionCache.createHasInvalidatedResolution(userProvidedResolution || changesAffectResolution);
          if (ts3.isProgramUptoDate(getCurrentProgram(), rootFileNames, compilerOptions, getSourceVersion, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences)) {
            if (hasChangedConfigFileParsingErrors) {
              if (reportFileChangeDetectedOnCreateProgram) {
                reportWatchDiagnostic(ts3.Diagnostics.File_change_detected_Starting_incremental_compilation);
              }
              builderProgram = createProgram(void 0, void 0, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
              hasChangedConfigFileParsingErrors = false;
            }
          } else {
            if (reportFileChangeDetectedOnCreateProgram) {
              reportWatchDiagnostic(ts3.Diagnostics.File_change_detected_Starting_incremental_compilation);
            }
            createNewProgram(hasInvalidatedResolution);
          }
          changesAffectResolution = false;
          reportFileChangeDetectedOnCreateProgram = false;
          if (host.afterProgramCreate && program2 !== builderProgram) {
            host.afterProgramCreate(builderProgram);
          }
          return builderProgram;
        }
        function createNewProgram(hasInvalidatedResolution) {
          writeLog("CreatingProgramWith::");
          writeLog("  roots: ".concat(JSON.stringify(rootFileNames)));
          writeLog("  options: ".concat(JSON.stringify(compilerOptions)));
          if (projectReferences)
            writeLog("  projectReferences: ".concat(JSON.stringify(projectReferences)));
          var needsUpdateInTypeRootWatch = hasChangedCompilerOptions || !getCurrentProgram();
          hasChangedCompilerOptions = false;
          hasChangedConfigFileParsingErrors = false;
          resolutionCache.startCachingPerDirectoryResolution();
          compilerHost.hasInvalidatedResolution = hasInvalidatedResolution;
          compilerHost.hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
          builderProgram = createProgram(rootFileNames, compilerOptions, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
          var packageCacheEntries = ts3.map(resolutionCache.getModuleResolutionCache().getPackageJsonInfoCache().entries(), function(_a2) {
            var path2 = _a2[0], data = _a2[1];
            return [compilerHost.realpath ? toPath(compilerHost.realpath(path2)) : path2, data];
          });
          resolutionCache.finishCachingPerDirectoryResolution();
          ts3.updateMissingFilePathsWatch(builderProgram.getProgram(), missingFilesMap || (missingFilesMap = new ts3.Map()), watchMissingFilePath);
          ts3.updatePackageJsonWatch(packageCacheEntries, packageJsonMap || (packageJsonMap = new ts3.Map()), watchPackageJsonLookupPath);
          if (needsUpdateInTypeRootWatch) {
            resolutionCache.updateTypeRootsWatch();
          }
          if (missingFilePathsRequestedForRelease) {
            for (var _i = 0, missingFilePathsRequestedForRelease_1 = missingFilePathsRequestedForRelease; _i < missingFilePathsRequestedForRelease_1.length; _i++) {
              var missingFilePath = missingFilePathsRequestedForRelease_1[_i];
              if (!missingFilesMap.has(missingFilePath)) {
                sourceFilesCache.delete(missingFilePath);
              }
            }
            missingFilePathsRequestedForRelease = void 0;
          }
        }
        function updateRootFileNames(files) {
          ts3.Debug.assert(!configFileName, "Cannot update root file names with config file watch mode");
          rootFileNames = files;
          scheduleProgramUpdate();
        }
        function updateNewLine() {
          return ts3.getNewLineCharacter(compilerOptions || optionsToExtendForConfigFile, function() {
            return host.getNewLine();
          });
        }
        function toPath(fileName2) {
          return ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
        }
        function isFileMissingOnHost(hostSourceFile) {
          return typeof hostSourceFile === "boolean";
        }
        function isFilePresenceUnknownOnHost(hostSourceFile) {
          return typeof hostSourceFile.version === "boolean";
        }
        function fileExists(fileName2) {
          var path2 = toPath(fileName2);
          if (isFileMissingOnHost(sourceFilesCache.get(path2))) {
            return false;
          }
          return directoryStructureHost.fileExists(fileName2);
        }
        function getVersionedSourceFileByPath(fileName2, path2, languageVersionOrOptions, onError, shouldCreateNewSourceFile) {
          var hostSourceFile = sourceFilesCache.get(path2);
          if (isFileMissingOnHost(hostSourceFile)) {
            return void 0;
          }
          if (hostSourceFile === void 0 || shouldCreateNewSourceFile || isFilePresenceUnknownOnHost(hostSourceFile)) {
            var sourceFile = getNewSourceFile(fileName2, languageVersionOrOptions, onError);
            if (hostSourceFile) {
              if (sourceFile) {
                hostSourceFile.sourceFile = sourceFile;
                hostSourceFile.version = sourceFile.version;
                if (!hostSourceFile.fileWatcher) {
                  hostSourceFile.fileWatcher = watchFilePath(path2, fileName2, onSourceFileChange, ts3.PollingInterval.Low, watchOptions, ts3.WatchType.SourceFile);
                }
              } else {
                if (hostSourceFile.fileWatcher) {
                  hostSourceFile.fileWatcher.close();
                }
                sourceFilesCache.set(path2, false);
              }
            } else {
              if (sourceFile) {
                var fileWatcher = watchFilePath(path2, fileName2, onSourceFileChange, ts3.PollingInterval.Low, watchOptions, ts3.WatchType.SourceFile);
                sourceFilesCache.set(path2, { sourceFile, version: sourceFile.version, fileWatcher });
              } else {
                sourceFilesCache.set(path2, false);
              }
            }
            if (sourceFile) {
              sourceFile.impliedNodeFormat = ts3.getImpliedNodeFormatForFile(path2, resolutionCache.getModuleResolutionCache().getPackageJsonInfoCache(), compilerHost, compilerHost.getCompilationSettings());
            }
            return sourceFile;
          }
          return hostSourceFile.sourceFile;
        }
        function nextSourceFileVersion(path2) {
          var hostSourceFile = sourceFilesCache.get(path2);
          if (hostSourceFile !== void 0) {
            if (isFileMissingOnHost(hostSourceFile)) {
              sourceFilesCache.set(path2, { version: false });
            } else {
              hostSourceFile.version = false;
            }
          }
        }
        function getSourceVersion(path2) {
          var hostSourceFile = sourceFilesCache.get(path2);
          return !hostSourceFile || !hostSourceFile.version ? void 0 : hostSourceFile.version;
        }
        function onReleaseOldSourceFile(oldSourceFile, _oldOptions, hasSourceFileByPath) {
          var hostSourceFileInfo = sourceFilesCache.get(oldSourceFile.resolvedPath);
          if (hostSourceFileInfo !== void 0) {
            if (isFileMissingOnHost(hostSourceFileInfo)) {
              (missingFilePathsRequestedForRelease || (missingFilePathsRequestedForRelease = [])).push(oldSourceFile.path);
            } else if (hostSourceFileInfo.sourceFile === oldSourceFile) {
              if (hostSourceFileInfo.fileWatcher) {
                hostSourceFileInfo.fileWatcher.close();
              }
              sourceFilesCache.delete(oldSourceFile.resolvedPath);
              if (!hasSourceFileByPath) {
                resolutionCache.removeResolutionsOfFile(oldSourceFile.path);
              }
            }
          }
        }
        function reportWatchDiagnostic(message) {
          if (host.onWatchStatusChange) {
            host.onWatchStatusChange(ts3.createCompilerDiagnostic(message), newLine, compilerOptions || optionsToExtendForConfigFile);
          }
        }
        function hasChangedAutomaticTypeDirectiveNames() {
          return resolutionCache.hasChangedAutomaticTypeDirectiveNames();
        }
        function clearInvalidateResolutionsOfFailedLookupLocations() {
          if (!timerToInvalidateFailedLookupResolutions)
            return false;
          host.clearTimeout(timerToInvalidateFailedLookupResolutions);
          timerToInvalidateFailedLookupResolutions = void 0;
          return true;
        }
        function scheduleInvalidateResolutionsOfFailedLookupLocations() {
          if (!host.setTimeout || !host.clearTimeout) {
            return resolutionCache.invalidateResolutionsOfFailedLookupLocations();
          }
          var pending = clearInvalidateResolutionsOfFailedLookupLocations();
          writeLog("Scheduling invalidateFailedLookup".concat(pending ? ", Cancelled earlier one" : ""));
          timerToInvalidateFailedLookupResolutions = host.setTimeout(invalidateResolutionsOfFailedLookup, 250);
        }
        function invalidateResolutionsOfFailedLookup() {
          timerToInvalidateFailedLookupResolutions = void 0;
          if (resolutionCache.invalidateResolutionsOfFailedLookupLocations()) {
            scheduleProgramUpdate();
          }
        }
        function scheduleProgramUpdate() {
          if (!host.setTimeout || !host.clearTimeout) {
            return;
          }
          if (timerToUpdateProgram) {
            host.clearTimeout(timerToUpdateProgram);
          }
          writeLog("Scheduling update");
          timerToUpdateProgram = host.setTimeout(updateProgramWithWatchStatus, 250);
        }
        function scheduleProgramReload() {
          ts3.Debug.assert(!!configFileName);
          reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
          scheduleProgramUpdate();
        }
        function updateProgramWithWatchStatus() {
          timerToUpdateProgram = void 0;
          reportFileChangeDetectedOnCreateProgram = true;
          updateProgram();
        }
        function updateProgram() {
          switch (reloadLevel) {
            case ts3.ConfigFileProgramReloadLevel.Partial:
              ts3.perfLogger.logStartUpdateProgram("PartialConfigReload");
              reloadFileNamesFromConfigFile();
              break;
            case ts3.ConfigFileProgramReloadLevel.Full:
              ts3.perfLogger.logStartUpdateProgram("FullConfigReload");
              reloadConfigFile();
              break;
            default:
              ts3.perfLogger.logStartUpdateProgram("SynchronizeProgram");
              synchronizeProgram();
              break;
          }
          ts3.perfLogger.logStopUpdateProgram("Done");
          return getCurrentBuilderProgram();
        }
        function reloadFileNamesFromConfigFile() {
          writeLog("Reloading new file names and options");
          reloadLevel = ts3.ConfigFileProgramReloadLevel.None;
          rootFileNames = ts3.getFileNamesFromConfigSpecs(compilerOptions.configFile.configFileSpecs, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), currentDirectory), compilerOptions, parseConfigFileHost, extraFileExtensions);
          if (ts3.updateErrorForNoInputFiles(rootFileNames, ts3.getNormalizedAbsolutePath(configFileName, currentDirectory), compilerOptions.configFile.configFileSpecs, configFileParsingDiagnostics, canConfigFileJsonReportNoInputFiles)) {
            hasChangedConfigFileParsingErrors = true;
          }
          synchronizeProgram();
        }
        function reloadConfigFile() {
          writeLog("Reloading config file: ".concat(configFileName));
          reloadLevel = ts3.ConfigFileProgramReloadLevel.None;
          if (cachedDirectoryStructureHost) {
            cachedDirectoryStructureHost.clearCache();
          }
          parseConfigFile();
          hasChangedCompilerOptions = true;
          synchronizeProgram();
          watchConfigFileWildCardDirectories();
          updateExtendedConfigFilesWatches(toPath(configFileName), compilerOptions, watchOptions, ts3.WatchType.ExtendedConfigFile);
        }
        function parseConfigFile() {
          setConfigFileParsingResult(ts3.getParsedCommandLineOfConfigFile(configFileName, optionsToExtendForConfigFile, parseConfigFileHost, extendedConfigCache || (extendedConfigCache = new ts3.Map()), watchOptionsToExtend, extraFileExtensions));
        }
        function setConfigFileParsingResult(configFileParseResult) {
          rootFileNames = configFileParseResult.fileNames;
          compilerOptions = configFileParseResult.options;
          watchOptions = configFileParseResult.watchOptions;
          projectReferences = configFileParseResult.projectReferences;
          wildcardDirectories = configFileParseResult.wildcardDirectories;
          configFileParsingDiagnostics = ts3.getConfigFileParsingDiagnostics(configFileParseResult).slice();
          canConfigFileJsonReportNoInputFiles = ts3.canJsonReportNoInputFiles(configFileParseResult.raw);
          hasChangedConfigFileParsingErrors = true;
        }
        function getParsedCommandLine(configFileName2) {
          var configPath = toPath(configFileName2);
          var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(configPath);
          if (config) {
            if (!config.reloadLevel)
              return config.parsedCommandLine;
            if (config.parsedCommandLine && config.reloadLevel === ts3.ConfigFileProgramReloadLevel.Partial && !host.getParsedCommandLine) {
              writeLog("Reloading new file names and options");
              var fileNames = ts3.getFileNamesFromConfigSpecs(config.parsedCommandLine.options.configFile.configFileSpecs, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName2), currentDirectory), compilerOptions, parseConfigFileHost);
              config.parsedCommandLine = __assign(__assign({}, config.parsedCommandLine), { fileNames });
              config.reloadLevel = void 0;
              return config.parsedCommandLine;
            }
          }
          writeLog("Loading config file: ".concat(configFileName2));
          var parsedCommandLine = host.getParsedCommandLine ? host.getParsedCommandLine(configFileName2) : getParsedCommandLineFromConfigFileHost(configFileName2);
          if (config) {
            config.parsedCommandLine = parsedCommandLine;
            config.reloadLevel = void 0;
          } else {
            (parsedConfigs || (parsedConfigs = new ts3.Map())).set(configPath, config = { parsedCommandLine });
          }
          watchReferencedProject(configFileName2, configPath, config);
          return parsedCommandLine;
        }
        function getParsedCommandLineFromConfigFileHost(configFileName2) {
          var onUnRecoverableConfigFileDiagnostic = parseConfigFileHost.onUnRecoverableConfigFileDiagnostic;
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = ts3.noop;
          var parsedCommandLine = ts3.getParsedCommandLineOfConfigFile(configFileName2, void 0, parseConfigFileHost, extendedConfigCache || (extendedConfigCache = new ts3.Map()), watchOptionsToExtend);
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = onUnRecoverableConfigFileDiagnostic;
          return parsedCommandLine;
        }
        function onReleaseParsedCommandLine(fileName2) {
          var _a2;
          var path2 = toPath(fileName2);
          var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(path2);
          if (!config)
            return;
          parsedConfigs.delete(path2);
          if (config.watchedDirectories)
            ts3.clearMap(config.watchedDirectories, ts3.closeFileWatcherOf);
          (_a2 = config.watcher) === null || _a2 === void 0 ? void 0 : _a2.close();
          ts3.clearSharedExtendedConfigFileWatcher(path2, sharedExtendedConfigFileWatchers);
        }
        function watchFilePath(path2, file, callback, pollingInterval, options, watchType) {
          return watchFile(file, function(fileName2, eventKind) {
            return callback(fileName2, eventKind, path2);
          }, pollingInterval, options, watchType);
        }
        function onSourceFileChange(fileName2, eventKind, path2) {
          updateCachedSystemWithFile(fileName2, path2, eventKind);
          if (eventKind === ts3.FileWatcherEventKind.Deleted && sourceFilesCache.has(path2)) {
            resolutionCache.invalidateResolutionOfFile(path2);
          }
          nextSourceFileVersion(path2);
          scheduleProgramUpdate();
        }
        function updateCachedSystemWithFile(fileName2, path2, eventKind) {
          if (cachedDirectoryStructureHost) {
            cachedDirectoryStructureHost.addOrDeleteFile(fileName2, path2, eventKind);
          }
        }
        function watchMissingFilePath(missingFilePath) {
          return (parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.has(missingFilePath)) ? ts3.noopFileWatcher : watchFilePath(missingFilePath, missingFilePath, onMissingFileChange, ts3.PollingInterval.Medium, watchOptions, ts3.WatchType.MissingFile);
        }
        function watchPackageJsonLookupPath(packageJsonPath) {
          return sourceFilesCache.has(packageJsonPath) ? ts3.noopFileWatcher : watchFilePath(packageJsonPath, packageJsonPath, onPackageJsonChange, ts3.PollingInterval.High, watchOptions, ts3.WatchType.PackageJson);
        }
        function onPackageJsonChange(fileName2, eventKind, path2) {
          updateCachedSystemWithFile(fileName2, path2, eventKind);
          reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
          changesAffectResolution = true;
          scheduleProgramUpdate();
        }
        function onMissingFileChange(fileName2, eventKind, missingFilePath) {
          updateCachedSystemWithFile(fileName2, missingFilePath, eventKind);
          if (eventKind === ts3.FileWatcherEventKind.Created && missingFilesMap.has(missingFilePath)) {
            missingFilesMap.get(missingFilePath).close();
            missingFilesMap.delete(missingFilePath);
            nextSourceFileVersion(missingFilePath);
            scheduleProgramUpdate();
          }
        }
        function watchConfigFileWildCardDirectories() {
          if (wildcardDirectories) {
            ts3.updateWatchingWildcardDirectories(watchedWildcardDirectories || (watchedWildcardDirectories = new ts3.Map()), new ts3.Map(ts3.getEntries(wildcardDirectories)), watchWildcardDirectory);
          } else if (watchedWildcardDirectories) {
            ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcherOf);
          }
        }
        function watchWildcardDirectory(directory, flags) {
          return watchDirectory(directory, function(fileOrDirectory) {
            ts3.Debug.assert(!!configFileName);
            var fileOrDirectoryPath = toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            nextSourceFileVersion(fileOrDirectoryPath);
            if (ts3.isIgnoredFileFromWildCardWatching({
              watchedDirPath: toPath(directory),
              fileOrDirectory,
              fileOrDirectoryPath,
              configFileName,
              extraFileExtensions,
              options: compilerOptions,
              program: getCurrentBuilderProgram() || rootFileNames,
              currentDirectory,
              useCaseSensitiveFileNames,
              writeLog,
              toPath
            }))
              return;
            if (reloadLevel !== ts3.ConfigFileProgramReloadLevel.Full) {
              reloadLevel = ts3.ConfigFileProgramReloadLevel.Partial;
              scheduleProgramUpdate();
            }
          }, flags, watchOptions, ts3.WatchType.WildcardDirectory);
        }
        function updateExtendedConfigFilesWatches(forProjectPath, options, watchOptions2, watchType) {
          ts3.updateSharedExtendedConfigFileWatcher(forProjectPath, options, sharedExtendedConfigFileWatchers || (sharedExtendedConfigFileWatchers = new ts3.Map()), function(extendedConfigFileName, extendedConfigFilePath) {
            return watchFile(extendedConfigFileName, function(_fileName, eventKind) {
              var _a2;
              updateCachedSystemWithFile(extendedConfigFileName, extendedConfigFilePath, eventKind);
              if (extendedConfigCache)
                ts3.cleanExtendedConfigCache(extendedConfigCache, extendedConfigFilePath, toPath);
              var projects = (_a2 = sharedExtendedConfigFileWatchers.get(extendedConfigFilePath)) === null || _a2 === void 0 ? void 0 : _a2.projects;
              if (!(projects === null || projects === void 0 ? void 0 : projects.size))
                return;
              projects.forEach(function(projectPath) {
                if (toPath(configFileName) === projectPath) {
                  reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
                } else {
                  var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(projectPath);
                  if (config)
                    config.reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
                  resolutionCache.removeResolutionsFromProjectReferenceRedirects(projectPath);
                }
                scheduleProgramUpdate();
              });
            }, ts3.PollingInterval.High, watchOptions2, watchType);
          }, toPath);
        }
        function watchReferencedProject(configFileName2, configPath, commandLine) {
          var _a2, _b2, _c, _d, _e;
          commandLine.watcher || (commandLine.watcher = watchFile(configFileName2, function(_fileName, eventKind) {
            updateCachedSystemWithFile(configFileName2, configPath, eventKind);
            var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(configPath);
            if (config)
              config.reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
            resolutionCache.removeResolutionsFromProjectReferenceRedirects(configPath);
            scheduleProgramUpdate();
          }, ts3.PollingInterval.High, ((_a2 = commandLine.parsedCommandLine) === null || _a2 === void 0 ? void 0 : _a2.watchOptions) || watchOptions, ts3.WatchType.ConfigFileOfReferencedProject));
          if ((_b2 = commandLine.parsedCommandLine) === null || _b2 === void 0 ? void 0 : _b2.wildcardDirectories) {
            ts3.updateWatchingWildcardDirectories(commandLine.watchedDirectories || (commandLine.watchedDirectories = new ts3.Map()), new ts3.Map(ts3.getEntries((_c = commandLine.parsedCommandLine) === null || _c === void 0 ? void 0 : _c.wildcardDirectories)), function(directory, flags) {
              var _a3;
              return watchDirectory(directory, function(fileOrDirectory) {
                var fileOrDirectoryPath = toPath(fileOrDirectory);
                if (cachedDirectoryStructureHost) {
                  cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
                }
                nextSourceFileVersion(fileOrDirectoryPath);
                var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(configPath);
                if (!(config === null || config === void 0 ? void 0 : config.parsedCommandLine))
                  return;
                if (ts3.isIgnoredFileFromWildCardWatching({
                  watchedDirPath: toPath(directory),
                  fileOrDirectory,
                  fileOrDirectoryPath,
                  configFileName: configFileName2,
                  options: config.parsedCommandLine.options,
                  program: config.parsedCommandLine.fileNames,
                  currentDirectory,
                  useCaseSensitiveFileNames,
                  writeLog,
                  toPath
                }))
                  return;
                if (config.reloadLevel !== ts3.ConfigFileProgramReloadLevel.Full) {
                  config.reloadLevel = ts3.ConfigFileProgramReloadLevel.Partial;
                  scheduleProgramUpdate();
                }
              }, flags, ((_a3 = commandLine.parsedCommandLine) === null || _a3 === void 0 ? void 0 : _a3.watchOptions) || watchOptions, ts3.WatchType.WildcardDirectoryOfReferencedProject);
            });
          } else if (commandLine.watchedDirectories) {
            ts3.clearMap(commandLine.watchedDirectories, ts3.closeFileWatcherOf);
            commandLine.watchedDirectories = void 0;
          }
          updateExtendedConfigFilesWatches(configPath, (_d = commandLine.parsedCommandLine) === null || _d === void 0 ? void 0 : _d.options, ((_e = commandLine.parsedCommandLine) === null || _e === void 0 ? void 0 : _e.watchOptions) || watchOptions, ts3.WatchType.ExtendedConfigOfReferencedProject);
        }
      }
      ts3.createWatchProgram = createWatchProgram;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var UpToDateStatusType;
      (function(UpToDateStatusType2) {
        UpToDateStatusType2[UpToDateStatusType2["Unbuildable"] = 0] = "Unbuildable";
        UpToDateStatusType2[UpToDateStatusType2["UpToDate"] = 1] = "UpToDate";
        UpToDateStatusType2[UpToDateStatusType2["UpToDateWithUpstreamTypes"] = 2] = "UpToDateWithUpstreamTypes";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithPrepend"] = 3] = "OutOfDateWithPrepend";
        UpToDateStatusType2[UpToDateStatusType2["OutputMissing"] = 4] = "OutputMissing";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithSelf"] = 5] = "OutOfDateWithSelf";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithUpstream"] = 6] = "OutOfDateWithUpstream";
        UpToDateStatusType2[UpToDateStatusType2["UpstreamOutOfDate"] = 7] = "UpstreamOutOfDate";
        UpToDateStatusType2[UpToDateStatusType2["UpstreamBlocked"] = 8] = "UpstreamBlocked";
        UpToDateStatusType2[UpToDateStatusType2["ComputingUpstream"] = 9] = "ComputingUpstream";
        UpToDateStatusType2[UpToDateStatusType2["TsVersionOutputOfDate"] = 10] = "TsVersionOutputOfDate";
        UpToDateStatusType2[UpToDateStatusType2["ContainerOnly"] = 11] = "ContainerOnly";
      })(UpToDateStatusType = ts3.UpToDateStatusType || (ts3.UpToDateStatusType = {}));
      function resolveConfigFileProjectName(project) {
        if (ts3.fileExtensionIs(project, ".json")) {
          return project;
        }
        return ts3.combinePaths(project, "tsconfig.json");
      }
      ts3.resolveConfigFileProjectName = resolveConfigFileProjectName;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var minimumDate = new Date(-864e13);
      var maximumDate = new Date(864e13);
      var BuildResultFlags;
      (function(BuildResultFlags2) {
        BuildResultFlags2[BuildResultFlags2["None"] = 0] = "None";
        BuildResultFlags2[BuildResultFlags2["Success"] = 1] = "Success";
        BuildResultFlags2[BuildResultFlags2["DeclarationOutputUnchanged"] = 2] = "DeclarationOutputUnchanged";
        BuildResultFlags2[BuildResultFlags2["ConfigFileErrors"] = 4] = "ConfigFileErrors";
        BuildResultFlags2[BuildResultFlags2["SyntaxErrors"] = 8] = "SyntaxErrors";
        BuildResultFlags2[BuildResultFlags2["TypeErrors"] = 16] = "TypeErrors";
        BuildResultFlags2[BuildResultFlags2["DeclarationEmitErrors"] = 32] = "DeclarationEmitErrors";
        BuildResultFlags2[BuildResultFlags2["EmitErrors"] = 64] = "EmitErrors";
        BuildResultFlags2[BuildResultFlags2["AnyErrors"] = 124] = "AnyErrors";
      })(BuildResultFlags || (BuildResultFlags = {}));
      function getOrCreateValueFromConfigFileMap(configFileMap, resolved, createT) {
        var existingValue = configFileMap.get(resolved);
        var newValue;
        if (!existingValue) {
          newValue = createT();
          configFileMap.set(resolved, newValue);
        }
        return existingValue || newValue;
      }
      function getOrCreateValueMapFromConfigFileMap(configFileMap, resolved) {
        return getOrCreateValueFromConfigFileMap(configFileMap, resolved, function() {
          return new ts3.Map();
        });
      }
      function newer(date1, date2) {
        return date2 > date1 ? date2 : date1;
      }
      function isCircularBuildOrder(buildOrder) {
        return !!buildOrder && !!buildOrder.buildOrder;
      }
      ts3.isCircularBuildOrder = isCircularBuildOrder;
      function getBuildOrderFromAnyBuildOrder(anyBuildOrder) {
        return isCircularBuildOrder(anyBuildOrder) ? anyBuildOrder.buildOrder : anyBuildOrder;
      }
      ts3.getBuildOrderFromAnyBuildOrder = getBuildOrderFromAnyBuildOrder;
      function createBuilderStatusReporter(system, pretty) {
        return function(diagnostic) {
          var output = pretty ? "[".concat(ts3.formatColorAndReset(ts3.getLocaleTimeString(system), ts3.ForegroundColorEscapeSequences.Grey), "] ") : "".concat(ts3.getLocaleTimeString(system), " - ");
          output += "".concat(ts3.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine)).concat(system.newLine + system.newLine);
          system.write(output);
        };
      }
      ts3.createBuilderStatusReporter = createBuilderStatusReporter;
      function createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus) {
        var host = ts3.createProgramHost(system, createProgram);
        host.getModifiedTime = system.getModifiedTime ? function(path2) {
          return system.getModifiedTime(path2);
        } : ts3.returnUndefined;
        host.setModifiedTime = system.setModifiedTime ? function(path2, date) {
          return system.setModifiedTime(path2, date);
        } : ts3.noop;
        host.deleteFile = system.deleteFile ? function(path2) {
          return system.deleteFile(path2);
        } : ts3.noop;
        host.reportDiagnostic = reportDiagnostic || ts3.createDiagnosticReporter(system);
        host.reportSolutionBuilderStatus = reportSolutionBuilderStatus || createBuilderStatusReporter(system);
        host.now = ts3.maybeBind(system, system.now);
        return host;
      }
      function createSolutionBuilderHost(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus, reportErrorSummary2) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var host = createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus);
        host.reportErrorSummary = reportErrorSummary2;
        return host;
      }
      ts3.createSolutionBuilderHost = createSolutionBuilderHost;
      function createSolutionBuilderWithWatchHost(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus, reportWatchStatus2) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var host = createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus);
        var watchHost = ts3.createWatchHost(system, reportWatchStatus2);
        ts3.copyProperties(host, watchHost);
        return host;
      }
      ts3.createSolutionBuilderWithWatchHost = createSolutionBuilderWithWatchHost;
      function getCompilerOptionsOfBuildOptions(buildOptions) {
        var result2 = {};
        ts3.commonOptionsWithBuild.forEach(function(option) {
          if (ts3.hasProperty(buildOptions, option.name))
            result2[option.name] = buildOptions[option.name];
        });
        return result2;
      }
      function createSolutionBuilder(host, rootNames, defaultOptions) {
        return createSolutionBuilderWorker(false, host, rootNames, defaultOptions);
      }
      ts3.createSolutionBuilder = createSolutionBuilder;
      function createSolutionBuilderWithWatch(host, rootNames, defaultOptions, baseWatchOptions) {
        return createSolutionBuilderWorker(true, host, rootNames, defaultOptions, baseWatchOptions);
      }
      ts3.createSolutionBuilderWithWatch = createSolutionBuilderWithWatch;
      function createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
        var host = hostOrHostWithWatch;
        var hostWithWatch = hostOrHostWithWatch;
        var currentDirectory = host.getCurrentDirectory();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var baseCompilerOptions = getCompilerOptionsOfBuildOptions(options);
        var compilerHost = ts3.createCompilerHostFromProgramHost(host, function() {
          return state.projectCompilerOptions;
        });
        ts3.setGetSourceFileAsHashVersioned(compilerHost, host);
        compilerHost.getParsedCommandLine = function(fileName2) {
          return parseConfigFile(state, fileName2, toResolvedConfigFilePath(state, fileName2));
        };
        compilerHost.resolveModuleNames = ts3.maybeBind(host, host.resolveModuleNames);
        compilerHost.resolveTypeReferenceDirectives = ts3.maybeBind(host, host.resolveTypeReferenceDirectives);
        var moduleResolutionCache = !compilerHost.resolveModuleNames ? ts3.createModuleResolutionCache(currentDirectory, getCanonicalFileName) : void 0;
        var typeReferenceDirectiveResolutionCache = !compilerHost.resolveTypeReferenceDirectives ? ts3.createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, void 0, moduleResolutionCache === null || moduleResolutionCache === void 0 ? void 0 : moduleResolutionCache.getPackageJsonInfoCache()) : void 0;
        if (!compilerHost.resolveModuleNames) {
          var loader_3 = function(moduleName, resolverMode, containingFile, redirectedReference) {
            return ts3.resolveModuleName(moduleName, containingFile, state.projectCompilerOptions, compilerHost, moduleResolutionCache, redirectedReference, resolverMode).resolvedModule;
          };
          compilerHost.resolveModuleNames = function(moduleNames, containingFile, _reusedNames, redirectedReference, _options, containingSourceFile) {
            return ts3.loadWithModeAwareCache(ts3.Debug.checkEachDefined(moduleNames), ts3.Debug.checkDefined(containingSourceFile), containingFile, redirectedReference, loader_3);
          };
          compilerHost.getModuleResolutionCache = function() {
            return moduleResolutionCache;
          };
        }
        if (!compilerHost.resolveTypeReferenceDirectives) {
          var loader_4 = function(moduleName, containingFile, redirectedReference, containingFileMode) {
            return ts3.resolveTypeReferenceDirective(moduleName, containingFile, state.projectCompilerOptions, compilerHost, redirectedReference, state.typeReferenceDirectiveResolutionCache, containingFileMode).resolvedTypeReferenceDirective;
          };
          compilerHost.resolveTypeReferenceDirectives = function(typeReferenceDirectiveNames, containingFile, redirectedReference, _options, containingFileMode) {
            return ts3.loadWithTypeDirectiveCache(ts3.Debug.checkEachDefined(typeReferenceDirectiveNames), containingFile, redirectedReference, containingFileMode, loader_4);
          };
        }
        var _a = ts3.createWatchFactory(hostWithWatch, options), watchFile = _a.watchFile, watchDirectory = _a.watchDirectory, writeLog = _a.writeLog;
        var state = {
          host,
          hostWithWatch,
          currentDirectory,
          getCanonicalFileName,
          parseConfigFileHost: ts3.parseConfigHostFromCompilerHostLike(host),
          write: ts3.maybeBind(host, host.trace),
          options,
          baseCompilerOptions,
          rootNames,
          baseWatchOptions,
          resolvedConfigFilePaths: new ts3.Map(),
          configFileCache: new ts3.Map(),
          projectStatus: new ts3.Map(),
          buildInfoChecked: new ts3.Map(),
          extendedConfigCache: new ts3.Map(),
          builderPrograms: new ts3.Map(),
          diagnostics: new ts3.Map(),
          projectPendingBuild: new ts3.Map(),
          projectErrorsReported: new ts3.Map(),
          compilerHost,
          moduleResolutionCache,
          typeReferenceDirectiveResolutionCache,
          buildOrder: void 0,
          readFileWithCache: function(f) {
            return host.readFile(f);
          },
          projectCompilerOptions: baseCompilerOptions,
          cache: void 0,
          allProjectBuildPending: true,
          needsSummary: true,
          watchAllProjectsPending: watch,
          currentInvalidatedProject: void 0,
          watch,
          allWatchedWildcardDirectories: new ts3.Map(),
          allWatchedInputFiles: new ts3.Map(),
          allWatchedConfigFiles: new ts3.Map(),
          allWatchedExtendedConfigFiles: new ts3.Map(),
          allWatchedPackageJsonFiles: new ts3.Map(),
          lastCachedPackageJsonLookups: new ts3.Map(),
          timerToBuildInvalidatedProject: void 0,
          reportFileChangeDetected: false,
          watchFile,
          watchDirectory,
          writeLog
        };
        return state;
      }
      function toPath(state, fileName2) {
        return ts3.toPath(fileName2, state.currentDirectory, state.getCanonicalFileName);
      }
      function toResolvedConfigFilePath(state, fileName2) {
        var resolvedConfigFilePaths = state.resolvedConfigFilePaths;
        var path2 = resolvedConfigFilePaths.get(fileName2);
        if (path2 !== void 0)
          return path2;
        var resolvedPath = toPath(state, fileName2);
        resolvedConfigFilePaths.set(fileName2, resolvedPath);
        return resolvedPath;
      }
      function isParsedCommandLine(entry) {
        return !!entry.options;
      }
      function getCachedParsedConfigFile(state, configFilePath) {
        var value = state.configFileCache.get(configFilePath);
        return value && isParsedCommandLine(value) ? value : void 0;
      }
      function parseConfigFile(state, configFileName, configFilePath) {
        var configFileCache = state.configFileCache;
        var value = configFileCache.get(configFilePath);
        if (value) {
          return isParsedCommandLine(value) ? value : void 0;
        }
        var diagnostic;
        var parseConfigFileHost = state.parseConfigFileHost, baseCompilerOptions = state.baseCompilerOptions, baseWatchOptions = state.baseWatchOptions, extendedConfigCache = state.extendedConfigCache, host = state.host;
        var parsed;
        if (host.getParsedCommandLine) {
          parsed = host.getParsedCommandLine(configFileName);
          if (!parsed)
            diagnostic = ts3.createCompilerDiagnostic(ts3.Diagnostics.File_0_not_found, configFileName);
        } else {
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = function(d) {
            return diagnostic = d;
          };
          parsed = ts3.getParsedCommandLineOfConfigFile(configFileName, baseCompilerOptions, parseConfigFileHost, extendedConfigCache, baseWatchOptions);
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = ts3.noop;
        }
        configFileCache.set(configFilePath, parsed || diagnostic);
        return parsed;
      }
      function resolveProjectName(state, name) {
        return ts3.resolveConfigFileProjectName(ts3.resolvePath(state.currentDirectory, name));
      }
      function createBuildOrder(state, roots) {
        var temporaryMarks = new ts3.Map();
        var permanentMarks = new ts3.Map();
        var circularityReportStack = [];
        var buildOrder;
        var circularDiagnostics;
        for (var _i = 0, roots_1 = roots; _i < roots_1.length; _i++) {
          var root = roots_1[_i];
          visit(root);
        }
        return circularDiagnostics ? { buildOrder: buildOrder || ts3.emptyArray, circularDiagnostics } : buildOrder || ts3.emptyArray;
        function visit(configFileName, inCircularContext) {
          var projPath = toResolvedConfigFilePath(state, configFileName);
          if (permanentMarks.has(projPath))
            return;
          if (temporaryMarks.has(projPath)) {
            if (!inCircularContext) {
              (circularDiagnostics || (circularDiagnostics = [])).push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0, circularityReportStack.join("\r\n")));
            }
            return;
          }
          temporaryMarks.set(projPath, true);
          circularityReportStack.push(configFileName);
          var parsed = parseConfigFile(state, configFileName, projPath);
          if (parsed && parsed.projectReferences) {
            for (var _i2 = 0, _a = parsed.projectReferences; _i2 < _a.length; _i2++) {
              var ref = _a[_i2];
              var resolvedRefPath = resolveProjectName(state, ref.path);
              visit(resolvedRefPath, inCircularContext || ref.circular);
            }
          }
          circularityReportStack.pop();
          permanentMarks.set(projPath, true);
          (buildOrder || (buildOrder = [])).push(configFileName);
        }
      }
      function getBuildOrder(state) {
        return state.buildOrder || createStateBuildOrder(state);
      }
      function createStateBuildOrder(state) {
        var buildOrder = createBuildOrder(state, state.rootNames.map(function(f) {
          return resolveProjectName(state, f);
        }));
        state.resolvedConfigFilePaths.clear();
        var currentProjects = new ts3.Map(getBuildOrderFromAnyBuildOrder(buildOrder).map(function(resolved) {
          return [toResolvedConfigFilePath(state, resolved), true];
        }));
        var noopOnDelete = { onDeleteValue: ts3.noop };
        ts3.mutateMapSkippingNewValues(state.configFileCache, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.projectStatus, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.buildInfoChecked, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.builderPrograms, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.diagnostics, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.projectPendingBuild, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.projectErrorsReported, currentProjects, noopOnDelete);
        if (state.watch) {
          ts3.mutateMapSkippingNewValues(state.allWatchedConfigFiles, currentProjects, { onDeleteValue: ts3.closeFileWatcher });
          state.allWatchedExtendedConfigFiles.forEach(function(watcher) {
            watcher.projects.forEach(function(project) {
              if (!currentProjects.has(project)) {
                watcher.projects.delete(project);
              }
            });
            watcher.close();
          });
          ts3.mutateMapSkippingNewValues(state.allWatchedWildcardDirectories, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts3.closeFileWatcherOf);
          } });
          ts3.mutateMapSkippingNewValues(state.allWatchedInputFiles, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts3.closeFileWatcher);
          } });
          ts3.mutateMapSkippingNewValues(state.allWatchedPackageJsonFiles, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts3.closeFileWatcher);
          } });
        }
        return state.buildOrder = buildOrder;
      }
      function getBuildOrderFor(state, project, onlyReferences) {
        var resolvedProject = project && resolveProjectName(state, project);
        var buildOrderFromState = getBuildOrder(state);
        if (isCircularBuildOrder(buildOrderFromState))
          return buildOrderFromState;
        if (resolvedProject) {
          var projectPath_1 = toResolvedConfigFilePath(state, resolvedProject);
          var projectIndex = ts3.findIndex(buildOrderFromState, function(configFileName) {
            return toResolvedConfigFilePath(state, configFileName) === projectPath_1;
          });
          if (projectIndex === -1)
            return void 0;
        }
        var buildOrder = resolvedProject ? createBuildOrder(state, [resolvedProject]) : buildOrderFromState;
        ts3.Debug.assert(!isCircularBuildOrder(buildOrder));
        ts3.Debug.assert(!onlyReferences || resolvedProject !== void 0);
        ts3.Debug.assert(!onlyReferences || buildOrder[buildOrder.length - 1] === resolvedProject);
        return onlyReferences ? buildOrder.slice(0, buildOrder.length - 1) : buildOrder;
      }
      function enableCache(state) {
        if (state.cache) {
          disableCache(state);
        }
        var compilerHost = state.compilerHost, host = state.host;
        var originalReadFileWithCache = state.readFileWithCache;
        var originalGetSourceFile = compilerHost.getSourceFile;
        var _a = ts3.changeCompilerHostLikeToUseCache(host, function(fileName2) {
          return toPath(state, fileName2);
        }, function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return originalGetSourceFile.call.apply(originalGetSourceFile, __spreadArray([compilerHost], args, false));
        }), originalReadFile = _a.originalReadFile, originalFileExists = _a.originalFileExists, originalDirectoryExists = _a.originalDirectoryExists, originalCreateDirectory = _a.originalCreateDirectory, originalWriteFile = _a.originalWriteFile, getSourceFileWithCache = _a.getSourceFileWithCache, readFileWithCache = _a.readFileWithCache;
        state.readFileWithCache = readFileWithCache;
        compilerHost.getSourceFile = getSourceFileWithCache;
        state.cache = {
          originalReadFile,
          originalFileExists,
          originalDirectoryExists,
          originalCreateDirectory,
          originalWriteFile,
          originalReadFileWithCache,
          originalGetSourceFile
        };
      }
      function disableCache(state) {
        if (!state.cache)
          return;
        var cache = state.cache, host = state.host, compilerHost = state.compilerHost, extendedConfigCache = state.extendedConfigCache, moduleResolutionCache = state.moduleResolutionCache, typeReferenceDirectiveResolutionCache = state.typeReferenceDirectiveResolutionCache;
        host.readFile = cache.originalReadFile;
        host.fileExists = cache.originalFileExists;
        host.directoryExists = cache.originalDirectoryExists;
        host.createDirectory = cache.originalCreateDirectory;
        host.writeFile = cache.originalWriteFile;
        compilerHost.getSourceFile = cache.originalGetSourceFile;
        state.readFileWithCache = cache.originalReadFileWithCache;
        extendedConfigCache.clear();
        moduleResolutionCache === null || moduleResolutionCache === void 0 ? void 0 : moduleResolutionCache.clear();
        typeReferenceDirectiveResolutionCache === null || typeReferenceDirectiveResolutionCache === void 0 ? void 0 : typeReferenceDirectiveResolutionCache.clear();
        state.cache = void 0;
      }
      function clearProjectStatus(state, resolved) {
        state.projectStatus.delete(resolved);
        state.diagnostics.delete(resolved);
      }
      function addProjToQueue(_a, proj, reloadLevel) {
        var projectPendingBuild = _a.projectPendingBuild;
        var value = projectPendingBuild.get(proj);
        if (value === void 0) {
          projectPendingBuild.set(proj, reloadLevel);
        } else if (value < reloadLevel) {
          projectPendingBuild.set(proj, reloadLevel);
        }
      }
      function setupInitialBuild(state, cancellationToken) {
        if (!state.allProjectBuildPending)
          return;
        state.allProjectBuildPending = false;
        if (state.options.watch)
          reportWatchStatus(state, ts3.Diagnostics.Starting_compilation_in_watch_mode);
        enableCache(state);
        var buildOrder = getBuildOrderFromAnyBuildOrder(getBuildOrder(state));
        buildOrder.forEach(function(configFileName) {
          return state.projectPendingBuild.set(toResolvedConfigFilePath(state, configFileName), ts3.ConfigFileProgramReloadLevel.None);
        });
        if (cancellationToken) {
          cancellationToken.throwIfCancellationRequested();
        }
      }
      var InvalidatedProjectKind;
      (function(InvalidatedProjectKind2) {
        InvalidatedProjectKind2[InvalidatedProjectKind2["Build"] = 0] = "Build";
        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateBundle"] = 1] = "UpdateBundle";
        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateOutputFileStamps"] = 2] = "UpdateOutputFileStamps";
      })(InvalidatedProjectKind = ts3.InvalidatedProjectKind || (ts3.InvalidatedProjectKind = {}));
      function doneInvalidatedProject(state, projectPath) {
        state.projectPendingBuild.delete(projectPath);
        state.currentInvalidatedProject = void 0;
        return state.diagnostics.has(projectPath) ? ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped : ts3.ExitStatus.Success;
      }
      function createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder) {
        var updateOutputFileStampsPending = true;
        return {
          kind: InvalidatedProjectKind.UpdateOutputFileStamps,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          updateOutputFileStatmps: function() {
            updateOutputTimestamps(state, config, projectPath);
            updateOutputFileStampsPending = false;
          },
          done: function() {
            if (updateOutputFileStampsPending) {
              updateOutputTimestamps(state, config, projectPath);
            }
            return doneInvalidatedProject(state, projectPath);
          }
        };
      }
      var BuildStep;
      (function(BuildStep2) {
        BuildStep2[BuildStep2["CreateProgram"] = 0] = "CreateProgram";
        BuildStep2[BuildStep2["SyntaxDiagnostics"] = 1] = "SyntaxDiagnostics";
        BuildStep2[BuildStep2["SemanticDiagnostics"] = 2] = "SemanticDiagnostics";
        BuildStep2[BuildStep2["Emit"] = 3] = "Emit";
        BuildStep2[BuildStep2["EmitBundle"] = 4] = "EmitBundle";
        BuildStep2[BuildStep2["EmitBuildInfo"] = 5] = "EmitBuildInfo";
        BuildStep2[BuildStep2["BuildInvalidatedProjectOfBundle"] = 6] = "BuildInvalidatedProjectOfBundle";
        BuildStep2[BuildStep2["QueueReferencingProjects"] = 7] = "QueueReferencingProjects";
        BuildStep2[BuildStep2["Done"] = 8] = "Done";
      })(BuildStep || (BuildStep = {}));
      function createBuildOrUpdateInvalidedProject(kind, state, project, projectPath, projectIndex, config, buildOrder) {
        var step = kind === InvalidatedProjectKind.Build ? BuildStep.CreateProgram : BuildStep.EmitBundle;
        var program2;
        var buildResult;
        var invalidatedProjectOfBundle;
        return kind === InvalidatedProjectKind.Build ? {
          kind,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          getBuilderProgram: function() {
            return withProgramOrUndefined(ts3.identity);
          },
          getProgram: function() {
            return withProgramOrUndefined(function(program3) {
              return program3.getProgramOrUndefined();
            });
          },
          getSourceFile: function(fileName2) {
            return withProgramOrUndefined(function(program3) {
              return program3.getSourceFile(fileName2);
            });
          },
          getSourceFiles: function() {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getSourceFiles();
            });
          },
          getOptionsDiagnostics: function(cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getOptionsDiagnostics(cancellationToken);
            });
          },
          getGlobalDiagnostics: function(cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getGlobalDiagnostics(cancellationToken);
            });
          },
          getConfigFileParsingDiagnostics: function() {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getConfigFileParsingDiagnostics();
            });
          },
          getSyntacticDiagnostics: function(sourceFile, cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getSyntacticDiagnostics(sourceFile, cancellationToken);
            });
          },
          getAllDependencies: function(sourceFile) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getAllDependencies(sourceFile);
            });
          },
          getSemanticDiagnostics: function(sourceFile, cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getSemanticDiagnostics(sourceFile, cancellationToken);
            });
          },
          getSemanticDiagnosticsOfNextAffectedFile: function(cancellationToken, ignoreSourceFile) {
            return withProgramOrUndefined(function(program3) {
              return program3.getSemanticDiagnosticsOfNextAffectedFile && program3.getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile);
            });
          },
          emit: function(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
            if (targetSourceFile || emitOnlyDtsFiles) {
              return withProgramOrUndefined(function(program3) {
                var _a, _b;
                return program3.emit(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers || ((_b = (_a = state.host).getCustomTransformers) === null || _b === void 0 ? void 0 : _b.call(_a, project)));
              });
            }
            executeSteps(BuildStep.SemanticDiagnostics, cancellationToken);
            if (step === BuildStep.EmitBuildInfo) {
              return emitBuildInfo(writeFile, cancellationToken);
            }
            if (step !== BuildStep.Emit)
              return void 0;
            return emit(writeFile, cancellationToken, customTransformers);
          },
          done
        } : {
          kind,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          emit: function(writeFile, customTransformers) {
            if (step !== BuildStep.EmitBundle)
              return invalidatedProjectOfBundle;
            return emitBundle(writeFile, customTransformers);
          },
          done
        };
        function done(cancellationToken, writeFile, customTransformers) {
          executeSteps(BuildStep.Done, cancellationToken, writeFile, customTransformers);
          return doneInvalidatedProject(state, projectPath);
        }
        function withProgramOrUndefined(action) {
          executeSteps(BuildStep.CreateProgram);
          return program2 && action(program2);
        }
        function withProgramOrEmptyArray(action) {
          return withProgramOrUndefined(action) || ts3.emptyArray;
        }
        function createProgram() {
          var _a, _b;
          ts3.Debug.assert(program2 === void 0);
          if (state.options.dry) {
            reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_build_project_0, project);
            buildResult = BuildResultFlags.Success;
            step = BuildStep.QueueReferencingProjects;
            return;
          }
          if (state.options.verbose)
            reportStatus(state, ts3.Diagnostics.Building_project_0, project);
          if (config.fileNames.length === 0) {
            reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
            buildResult = BuildResultFlags.None;
            step = BuildStep.QueueReferencingProjects;
            return;
          }
          var host = state.host, compilerHost = state.compilerHost;
          state.projectCompilerOptions = config.options;
          (_a = state.moduleResolutionCache) === null || _a === void 0 ? void 0 : _a.update(config.options);
          (_b = state.typeReferenceDirectiveResolutionCache) === null || _b === void 0 ? void 0 : _b.update(config.options);
          program2 = host.createProgram(config.fileNames, config.options, compilerHost, getOldProgram(state, projectPath, config), ts3.getConfigFileParsingDiagnostics(config), config.projectReferences);
          if (state.watch) {
            state.lastCachedPackageJsonLookups.set(projectPath, state.moduleResolutionCache && ts3.map(state.moduleResolutionCache.getPackageJsonInfoCache().entries(), function(_a2) {
              var path2 = _a2[0], data = _a2[1];
              return [state.host.realpath && data ? toPath(state, state.host.realpath(path2)) : path2, data];
            }));
            state.builderPrograms.set(projectPath, program2);
          }
          step++;
        }
        function handleDiagnostics(diagnostics, errorFlags, errorType) {
          var _a;
          if (diagnostics.length) {
            _a = buildErrors(state, projectPath, program2, config, diagnostics, errorFlags, errorType), buildResult = _a.buildResult, step = _a.step;
          } else {
            step++;
          }
        }
        function getSyntaxDiagnostics(cancellationToken) {
          ts3.Debug.assertIsDefined(program2);
          handleDiagnostics(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], program2.getConfigFileParsingDiagnostics(), true), program2.getOptionsDiagnostics(cancellationToken), true), program2.getGlobalDiagnostics(cancellationToken), true), program2.getSyntacticDiagnostics(void 0, cancellationToken), true), BuildResultFlags.SyntaxErrors, "Syntactic");
        }
        function getSemanticDiagnostics(cancellationToken) {
          handleDiagnostics(ts3.Debug.checkDefined(program2).getSemanticDiagnostics(void 0, cancellationToken), BuildResultFlags.TypeErrors, "Semantic");
        }
        function emit(writeFileCallback, cancellationToken, customTransformers) {
          var _a;
          var _b, _c;
          ts3.Debug.assertIsDefined(program2);
          ts3.Debug.assert(step === BuildStep.Emit);
          program2.backupState();
          var declDiagnostics;
          var reportDeclarationDiagnostics = function(d) {
            return (declDiagnostics || (declDiagnostics = [])).push(d);
          };
          var outputFiles = [];
          var emitResult = ts3.emitFilesAndReportErrors(program2, reportDeclarationDiagnostics, void 0, void 0, function(name, text, writeByteOrderMark) {
            return outputFiles.push({ name, text, writeByteOrderMark });
          }, cancellationToken, false, customTransformers || ((_c = (_b = state.host).getCustomTransformers) === null || _c === void 0 ? void 0 : _c.call(_b, project))).emitResult;
          if (declDiagnostics) {
            program2.restoreState();
            _a = buildErrors(state, projectPath, program2, config, declDiagnostics, BuildResultFlags.DeclarationEmitErrors, "Declaration file"), buildResult = _a.buildResult, step = _a.step;
            return {
              emitSkipped: true,
              diagnostics: emitResult.diagnostics
            };
          }
          var host = state.host, compilerHost = state.compilerHost;
          var resultFlags = BuildResultFlags.DeclarationOutputUnchanged;
          var newestDeclarationFileContentChangedTime = minimumDate;
          var anyDtsChanged = false;
          var emitterDiagnostics = ts3.createDiagnosticCollection();
          var emittedOutputs = new ts3.Map();
          outputFiles.forEach(function(_a2) {
            var name = _a2.name, text = _a2.text, writeByteOrderMark = _a2.writeByteOrderMark;
            var priorChangeTime;
            if (!anyDtsChanged && ts3.isDeclarationFileName(name)) {
              if (host.fileExists(name) && state.readFileWithCache(name) === text) {
                priorChangeTime = host.getModifiedTime(name);
              } else {
                resultFlags &= ~BuildResultFlags.DeclarationOutputUnchanged;
                anyDtsChanged = true;
              }
            }
            emittedOutputs.set(toPath(state, name), name);
            ts3.writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
            if (priorChangeTime !== void 0) {
              newestDeclarationFileContentChangedTime = newer(priorChangeTime, newestDeclarationFileContentChangedTime);
            }
          });
          finishEmit(emitterDiagnostics, emittedOutputs, newestDeclarationFileContentChangedTime, anyDtsChanged, outputFiles.length ? outputFiles[0].name : ts3.getFirstProjectOutput(config, !host.useCaseSensitiveFileNames()), resultFlags);
          return emitResult;
        }
        function emitBuildInfo(writeFileCallback, cancellationToken) {
          ts3.Debug.assertIsDefined(program2);
          ts3.Debug.assert(step === BuildStep.EmitBuildInfo);
          var emitResult = program2.emitBuildInfo(writeFileCallback, cancellationToken);
          if (emitResult.diagnostics.length) {
            reportErrors(state, emitResult.diagnostics);
            state.diagnostics.set(projectPath, __spreadArray(__spreadArray([], state.diagnostics.get(projectPath), true), emitResult.diagnostics, true));
            buildResult = BuildResultFlags.EmitErrors & buildResult;
          }
          if (emitResult.emittedFiles && state.write) {
            emitResult.emittedFiles.forEach(function(name) {
              return listEmittedFile(state, config, name);
            });
          }
          afterProgramDone(state, program2, config);
          step = BuildStep.QueueReferencingProjects;
          return emitResult;
        }
        function finishEmit(emitterDiagnostics, emittedOutputs, priorNewestUpdateTime, newestDeclarationFileContentChangedTimeIsMaximumDate, oldestOutputFileName, resultFlags) {
          var _a;
          var emitDiagnostics = emitterDiagnostics.getDiagnostics();
          if (emitDiagnostics.length) {
            _a = buildErrors(state, projectPath, program2, config, emitDiagnostics, BuildResultFlags.EmitErrors, "Emit"), buildResult = _a.buildResult, step = _a.step;
            return emitDiagnostics;
          }
          if (state.write) {
            emittedOutputs.forEach(function(name) {
              return listEmittedFile(state, config, name);
            });
          }
          var newestDeclarationFileContentChangedTime = updateOutputTimestampsWorker(state, config, priorNewestUpdateTime, ts3.Diagnostics.Updating_unchanged_output_timestamps_of_project_0, emittedOutputs);
          state.diagnostics.delete(projectPath);
          state.projectStatus.set(projectPath, {
            type: ts3.UpToDateStatusType.UpToDate,
            newestDeclarationFileContentChangedTime: newestDeclarationFileContentChangedTimeIsMaximumDate ? maximumDate : newestDeclarationFileContentChangedTime,
            oldestOutputFileName
          });
          afterProgramDone(state, program2, config);
          step = BuildStep.QueueReferencingProjects;
          buildResult = resultFlags;
          return emitDiagnostics;
        }
        function emitBundle(writeFileCallback, customTransformers) {
          var _a, _b;
          ts3.Debug.assert(kind === InvalidatedProjectKind.UpdateBundle);
          if (state.options.dry) {
            reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_update_output_of_project_0, project);
            buildResult = BuildResultFlags.Success;
            step = BuildStep.QueueReferencingProjects;
            return void 0;
          }
          if (state.options.verbose)
            reportStatus(state, ts3.Diagnostics.Updating_output_of_project_0, project);
          var compilerHost = state.compilerHost;
          state.projectCompilerOptions = config.options;
          var outputFiles = ts3.emitUsingBuildInfo(config, compilerHost, function(ref) {
            var refName = resolveProjectName(state, ref.path);
            return parseConfigFile(state, refName, toResolvedConfigFilePath(state, refName));
          }, customTransformers || ((_b = (_a = state.host).getCustomTransformers) === null || _b === void 0 ? void 0 : _b.call(_a, project)));
          if (ts3.isString(outputFiles)) {
            reportStatus(state, ts3.Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1, project, relName(state, outputFiles));
            step = BuildStep.BuildInvalidatedProjectOfBundle;
            return invalidatedProjectOfBundle = createBuildOrUpdateInvalidedProject(InvalidatedProjectKind.Build, state, project, projectPath, projectIndex, config, buildOrder);
          }
          ts3.Debug.assert(!!outputFiles.length);
          var emitterDiagnostics = ts3.createDiagnosticCollection();
          var emittedOutputs = new ts3.Map();
          outputFiles.forEach(function(_a2) {
            var name = _a2.name, text = _a2.text, writeByteOrderMark = _a2.writeByteOrderMark;
            emittedOutputs.set(toPath(state, name), name);
            ts3.writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
          });
          var emitDiagnostics = finishEmit(emitterDiagnostics, emittedOutputs, minimumDate, false, outputFiles[0].name, BuildResultFlags.DeclarationOutputUnchanged);
          return { emitSkipped: false, diagnostics: emitDiagnostics };
        }
        function executeSteps(till, cancellationToken, writeFile, customTransformers) {
          while (step <= till && step < BuildStep.Done) {
            var currentStep = step;
            switch (step) {
              case BuildStep.CreateProgram:
                createProgram();
                break;
              case BuildStep.SyntaxDiagnostics:
                getSyntaxDiagnostics(cancellationToken);
                break;
              case BuildStep.SemanticDiagnostics:
                getSemanticDiagnostics(cancellationToken);
                break;
              case BuildStep.Emit:
                emit(writeFile, cancellationToken, customTransformers);
                break;
              case BuildStep.EmitBuildInfo:
                emitBuildInfo(writeFile, cancellationToken);
                break;
              case BuildStep.EmitBundle:
                emitBundle(writeFile, customTransformers);
                break;
              case BuildStep.BuildInvalidatedProjectOfBundle:
                ts3.Debug.checkDefined(invalidatedProjectOfBundle).done(cancellationToken, writeFile, customTransformers);
                step = BuildStep.Done;
                break;
              case BuildStep.QueueReferencingProjects:
                queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, ts3.Debug.checkDefined(buildResult));
                step++;
                break;
              case BuildStep.Done:
              default:
                ts3.assertType(step);
            }
            ts3.Debug.assert(step > currentStep);
          }
        }
      }
      function needsBuild(_a, status, config) {
        var options = _a.options;
        if (status.type !== ts3.UpToDateStatusType.OutOfDateWithPrepend || options.force)
          return true;
        return config.fileNames.length === 0 || !!ts3.getConfigFileParsingDiagnostics(config).length || !ts3.isIncrementalCompilation(config.options);
      }
      function getNextInvalidatedProject(state, buildOrder, reportQueue) {
        if (!state.projectPendingBuild.size)
          return void 0;
        if (isCircularBuildOrder(buildOrder))
          return void 0;
        if (state.currentInvalidatedProject) {
          return ts3.arrayIsEqualTo(state.currentInvalidatedProject.buildOrder, buildOrder) ? state.currentInvalidatedProject : void 0;
        }
        var options = state.options, projectPendingBuild = state.projectPendingBuild;
        for (var projectIndex = 0; projectIndex < buildOrder.length; projectIndex++) {
          var project = buildOrder[projectIndex];
          var projectPath = toResolvedConfigFilePath(state, project);
          var reloadLevel = state.projectPendingBuild.get(projectPath);
          if (reloadLevel === void 0)
            continue;
          if (reportQueue) {
            reportQueue = false;
            reportBuildQueue(state, buildOrder);
          }
          var config = parseConfigFile(state, project, projectPath);
          if (!config) {
            reportParseConfigFileDiagnostic(state, projectPath);
            projectPendingBuild.delete(projectPath);
            continue;
          }
          if (reloadLevel === ts3.ConfigFileProgramReloadLevel.Full) {
            watchConfigFile(state, project, projectPath, config);
            watchExtendedConfigFiles(state, projectPath, config);
            watchWildCardDirectories(state, project, projectPath, config);
            watchInputFiles(state, project, projectPath, config);
            watchPackageJsonFiles(state, project, projectPath, config);
          } else if (reloadLevel === ts3.ConfigFileProgramReloadLevel.Partial) {
            config.fileNames = ts3.getFileNamesFromConfigSpecs(config.options.configFile.configFileSpecs, ts3.getDirectoryPath(project), config.options, state.parseConfigFileHost);
            ts3.updateErrorForNoInputFiles(config.fileNames, project, config.options.configFile.configFileSpecs, config.errors, ts3.canJsonReportNoInputFiles(config.raw));
            watchInputFiles(state, project, projectPath, config);
            watchPackageJsonFiles(state, project, projectPath, config);
          }
          var status = getUpToDateStatus(state, config, projectPath);
          verboseReportProjectStatus(state, project, status);
          if (!options.force) {
            if (status.type === ts3.UpToDateStatusType.UpToDate) {
              reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
              projectPendingBuild.delete(projectPath);
              if (options.dry) {
                reportStatus(state, ts3.Diagnostics.Project_0_is_up_to_date, project);
              }
              continue;
            }
            if (status.type === ts3.UpToDateStatusType.UpToDateWithUpstreamTypes) {
              reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
              return createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder);
            }
          }
          if (status.type === ts3.UpToDateStatusType.UpstreamBlocked) {
            reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
            projectPendingBuild.delete(projectPath);
            if (options.verbose) {
              reportStatus(state, status.upstreamProjectBlocked ? ts3.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_was_not_built : ts3.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors, project, status.upstreamProjectName);
            }
            continue;
          }
          if (status.type === ts3.UpToDateStatusType.ContainerOnly) {
            reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
            projectPendingBuild.delete(projectPath);
            continue;
          }
          return createBuildOrUpdateInvalidedProject(needsBuild(state, status, config) ? InvalidatedProjectKind.Build : InvalidatedProjectKind.UpdateBundle, state, project, projectPath, projectIndex, config, buildOrder);
        }
        return void 0;
      }
      function listEmittedFile(_a, proj, file) {
        var write = _a.write;
        if (write && proj.options.listEmittedFiles) {
          write("TSFILE: ".concat(file));
        }
      }
      function getOldProgram(_a, proj, parsed) {
        var options = _a.options, builderPrograms = _a.builderPrograms, compilerHost = _a.compilerHost;
        if (options.force)
          return void 0;
        var value = builderPrograms.get(proj);
        if (value)
          return value;
        return ts3.readBuilderProgram(parsed.options, compilerHost);
      }
      function afterProgramDone(state, program2, config) {
        if (program2) {
          if (program2 && state.write)
            ts3.listFiles(program2, state.write);
          if (state.host.afterProgramEmitAndDiagnostics) {
            state.host.afterProgramEmitAndDiagnostics(program2);
          }
          program2.releaseProgram();
        } else if (state.host.afterEmitBundle) {
          state.host.afterEmitBundle(config);
        }
        state.projectCompilerOptions = state.baseCompilerOptions;
      }
      function buildErrors(state, resolvedPath, program2, config, diagnostics, buildResult, errorType) {
        var canEmitBuildInfo = !(buildResult & BuildResultFlags.SyntaxErrors) && program2 && !ts3.outFile(program2.getCompilerOptions());
        reportAndStoreErrors(state, resolvedPath, diagnostics);
        state.projectStatus.set(resolvedPath, { type: ts3.UpToDateStatusType.Unbuildable, reason: "".concat(errorType, " errors") });
        if (canEmitBuildInfo)
          return { buildResult, step: BuildStep.EmitBuildInfo };
        afterProgramDone(state, program2, config);
        return { buildResult, step: BuildStep.QueueReferencingProjects };
      }
      function checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName) {
        var tsconfigTime = ts3.getModifiedTime(state.host, configFile);
        if (oldestOutputFileTime < tsconfigTime) {
          return {
            type: ts3.UpToDateStatusType.OutOfDateWithSelf,
            outOfDateOutputFileName: oldestOutputFileName,
            newerInputFileName: configFile
          };
        }
      }
      function getUpToDateStatusWorker(state, project, resolvedPath) {
        var force = !!state.options.force;
        var newestInputFileName = void 0;
        var newestInputFileTime = minimumDate;
        var host = state.host;
        for (var _i = 0, _a = project.fileNames; _i < _a.length; _i++) {
          var inputFile = _a[_i];
          if (!host.fileExists(inputFile)) {
            return {
              type: ts3.UpToDateStatusType.Unbuildable,
              reason: "".concat(inputFile, " does not exist")
            };
          }
          if (!force) {
            var inputTime = ts3.getModifiedTime(host, inputFile);
            if (inputTime > newestInputFileTime) {
              newestInputFileName = inputFile;
              newestInputFileTime = inputTime;
            }
          }
        }
        if (!project.fileNames.length && !ts3.canJsonReportNoInputFiles(project.raw)) {
          return {
            type: ts3.UpToDateStatusType.ContainerOnly
          };
        }
        var outputs = ts3.getAllProjectOutputs(project, !host.useCaseSensitiveFileNames());
        var oldestOutputFileName = "(none)";
        var oldestOutputFileTime = maximumDate;
        var newestOutputFileName = "(none)";
        var newestOutputFileTime = minimumDate;
        var missingOutputFileName;
        var newestDeclarationFileContentChangedTime = minimumDate;
        var isOutOfDateWithInputs = false;
        if (!force) {
          for (var _b = 0, outputs_1 = outputs; _b < outputs_1.length; _b++) {
            var output = outputs_1[_b];
            if (!host.fileExists(output)) {
              missingOutputFileName = output;
              break;
            }
            var outputTime = ts3.getModifiedTime(host, output);
            if (outputTime < oldestOutputFileTime) {
              oldestOutputFileTime = outputTime;
              oldestOutputFileName = output;
            }
            if (outputTime < newestInputFileTime) {
              isOutOfDateWithInputs = true;
              break;
            }
            if (outputTime > newestOutputFileTime) {
              newestOutputFileTime = outputTime;
              newestOutputFileName = output;
            }
            if (ts3.isDeclarationFileName(output)) {
              var outputModifiedTime = ts3.getModifiedTime(host, output);
              newestDeclarationFileContentChangedTime = newer(newestDeclarationFileContentChangedTime, outputModifiedTime);
            }
          }
        }
        var pseudoUpToDate = false;
        var usesPrepend = false;
        var upstreamChangedProject;
        if (project.projectReferences) {
          state.projectStatus.set(resolvedPath, { type: ts3.UpToDateStatusType.ComputingUpstream });
          for (var _c = 0, _d = project.projectReferences; _c < _d.length; _c++) {
            var ref = _d[_c];
            usesPrepend = usesPrepend || !!ref.prepend;
            var resolvedRef = ts3.resolveProjectReferencePath(ref);
            var resolvedRefPath = toResolvedConfigFilePath(state, resolvedRef);
            var refStatus = getUpToDateStatus(state, parseConfigFile(state, resolvedRef, resolvedRefPath), resolvedRefPath);
            if (refStatus.type === ts3.UpToDateStatusType.ComputingUpstream || refStatus.type === ts3.UpToDateStatusType.ContainerOnly) {
              continue;
            }
            if (refStatus.type === ts3.UpToDateStatusType.Unbuildable || refStatus.type === ts3.UpToDateStatusType.UpstreamBlocked) {
              return {
                type: ts3.UpToDateStatusType.UpstreamBlocked,
                upstreamProjectName: ref.path,
                upstreamProjectBlocked: refStatus.type === ts3.UpToDateStatusType.UpstreamBlocked
              };
            }
            if (refStatus.type !== ts3.UpToDateStatusType.UpToDate) {
              return {
                type: ts3.UpToDateStatusType.UpstreamOutOfDate,
                upstreamProjectName: ref.path
              };
            }
            if (!force && !missingOutputFileName) {
              if (refStatus.newestInputFileTime && refStatus.newestInputFileTime <= oldestOutputFileTime) {
                continue;
              }
              if (refStatus.newestDeclarationFileContentChangedTime && refStatus.newestDeclarationFileContentChangedTime <= oldestOutputFileTime) {
                pseudoUpToDate = true;
                upstreamChangedProject = ref.path;
                continue;
              }
              ts3.Debug.assert(oldestOutputFileName !== void 0, "Should have an oldest output filename here");
              return {
                type: ts3.UpToDateStatusType.OutOfDateWithUpstream,
                outOfDateOutputFileName: oldestOutputFileName,
                newerProjectName: ref.path
              };
            }
          }
        }
        if (missingOutputFileName !== void 0) {
          return {
            type: ts3.UpToDateStatusType.OutputMissing,
            missingOutputFileName
          };
        }
        if (isOutOfDateWithInputs) {
          return {
            type: ts3.UpToDateStatusType.OutOfDateWithSelf,
            outOfDateOutputFileName: oldestOutputFileName,
            newerInputFileName: newestInputFileName
          };
        } else {
          var configStatus = checkConfigFileUpToDateStatus(state, project.options.configFilePath, oldestOutputFileTime, oldestOutputFileName);
          if (configStatus)
            return configStatus;
          var extendedConfigStatus = ts3.forEach(project.options.configFile.extendedSourceFiles || ts3.emptyArray, function(configFile) {
            return checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName);
          });
          if (extendedConfigStatus)
            return extendedConfigStatus;
          var dependentPackageFileStatus = ts3.forEach(state.lastCachedPackageJsonLookups.get(resolvedPath) || ts3.emptyArray, function(_a2) {
            var path2 = _a2[0];
            return checkConfigFileUpToDateStatus(state, path2, oldestOutputFileTime, oldestOutputFileName);
          });
          if (dependentPackageFileStatus)
            return dependentPackageFileStatus;
        }
        if (!force && !state.buildInfoChecked.has(resolvedPath)) {
          state.buildInfoChecked.set(resolvedPath, true);
          var buildInfoPath = ts3.getTsBuildInfoEmitOutputFilePath(project.options);
          if (buildInfoPath) {
            var value = state.readFileWithCache(buildInfoPath);
            var buildInfo = value && ts3.getBuildInfo(value);
            if (buildInfo && (buildInfo.bundle || buildInfo.program) && buildInfo.version !== ts3.version) {
              return {
                type: ts3.UpToDateStatusType.TsVersionOutputOfDate,
                version: buildInfo.version
              };
            }
          }
        }
        if (usesPrepend && pseudoUpToDate) {
          return {
            type: ts3.UpToDateStatusType.OutOfDateWithPrepend,
            outOfDateOutputFileName: oldestOutputFileName,
            newerProjectName: upstreamChangedProject
          };
        }
        return {
          type: pseudoUpToDate ? ts3.UpToDateStatusType.UpToDateWithUpstreamTypes : ts3.UpToDateStatusType.UpToDate,
          newestDeclarationFileContentChangedTime,
          newestInputFileTime,
          newestOutputFileTime,
          newestInputFileName,
          newestOutputFileName,
          oldestOutputFileName
        };
      }
      function getUpToDateStatus(state, project, resolvedPath) {
        if (project === void 0) {
          return { type: ts3.UpToDateStatusType.Unbuildable, reason: "File deleted mid-build" };
        }
        var prior = state.projectStatus.get(resolvedPath);
        if (prior !== void 0) {
          return prior;
        }
        var actual = getUpToDateStatusWorker(state, project, resolvedPath);
        state.projectStatus.set(resolvedPath, actual);
        return actual;
      }
      function updateOutputTimestampsWorker(state, proj, priorNewestUpdateTime, verboseMessage, skipOutputs) {
        if (proj.options.noEmit)
          return priorNewestUpdateTime;
        var host = state.host;
        var outputs = ts3.getAllProjectOutputs(proj, !host.useCaseSensitiveFileNames());
        if (!skipOutputs || outputs.length !== skipOutputs.size) {
          var reportVerbose = !!state.options.verbose;
          var now = host.now ? host.now() : new Date();
          for (var _i = 0, outputs_2 = outputs; _i < outputs_2.length; _i++) {
            var file = outputs_2[_i];
            if (skipOutputs && skipOutputs.has(toPath(state, file))) {
              continue;
            }
            if (reportVerbose) {
              reportVerbose = false;
              reportStatus(state, verboseMessage, proj.options.configFilePath);
            }
            if (ts3.isDeclarationFileName(file)) {
              priorNewestUpdateTime = newer(priorNewestUpdateTime, ts3.getModifiedTime(host, file));
            }
            host.setModifiedTime(file, now);
          }
        }
        return priorNewestUpdateTime;
      }
      function updateOutputTimestamps(state, proj, resolvedPath) {
        if (state.options.dry) {
          return reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0, proj.options.configFilePath);
        }
        var priorNewestUpdateTime = updateOutputTimestampsWorker(state, proj, minimumDate, ts3.Diagnostics.Updating_output_timestamps_of_project_0);
        state.projectStatus.set(resolvedPath, {
          type: ts3.UpToDateStatusType.UpToDate,
          newestDeclarationFileContentChangedTime: priorNewestUpdateTime,
          oldestOutputFileName: ts3.getFirstProjectOutput(proj, !state.host.useCaseSensitiveFileNames())
        });
      }
      function queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, buildResult) {
        if (buildResult & BuildResultFlags.AnyErrors)
          return;
        if (!config.options.composite)
          return;
        for (var index = projectIndex + 1; index < buildOrder.length; index++) {
          var nextProject = buildOrder[index];
          var nextProjectPath = toResolvedConfigFilePath(state, nextProject);
          if (state.projectPendingBuild.has(nextProjectPath))
            continue;
          var nextProjectConfig = parseConfigFile(state, nextProject, nextProjectPath);
          if (!nextProjectConfig || !nextProjectConfig.projectReferences)
            continue;
          for (var _i = 0, _a = nextProjectConfig.projectReferences; _i < _a.length; _i++) {
            var ref = _a[_i];
            var resolvedRefPath = resolveProjectName(state, ref.path);
            if (toResolvedConfigFilePath(state, resolvedRefPath) !== projectPath)
              continue;
            var status = state.projectStatus.get(nextProjectPath);
            if (status) {
              switch (status.type) {
                case ts3.UpToDateStatusType.UpToDate:
                  if (buildResult & BuildResultFlags.DeclarationOutputUnchanged) {
                    if (ref.prepend) {
                      state.projectStatus.set(nextProjectPath, {
                        type: ts3.UpToDateStatusType.OutOfDateWithPrepend,
                        outOfDateOutputFileName: status.oldestOutputFileName,
                        newerProjectName: project
                      });
                    } else {
                      status.type = ts3.UpToDateStatusType.UpToDateWithUpstreamTypes;
                    }
                    break;
                  }
                case ts3.UpToDateStatusType.UpToDateWithUpstreamTypes:
                case ts3.UpToDateStatusType.OutOfDateWithPrepend:
                  if (!(buildResult & BuildResultFlags.DeclarationOutputUnchanged)) {
                    state.projectStatus.set(nextProjectPath, {
                      type: ts3.UpToDateStatusType.OutOfDateWithUpstream,
                      outOfDateOutputFileName: status.type === ts3.UpToDateStatusType.OutOfDateWithPrepend ? status.outOfDateOutputFileName : status.oldestOutputFileName,
                      newerProjectName: project
                    });
                  }
                  break;
                case ts3.UpToDateStatusType.UpstreamBlocked:
                  if (toResolvedConfigFilePath(state, resolveProjectName(state, status.upstreamProjectName)) === projectPath) {
                    clearProjectStatus(state, nextProjectPath);
                  }
                  break;
              }
            }
            addProjToQueue(state, nextProjectPath, ts3.ConfigFileProgramReloadLevel.None);
            break;
          }
        }
      }
      function build(state, project, cancellationToken, writeFile, getCustomTransformers, onlyReferences) {
        var buildOrder = getBuildOrderFor(state, project, onlyReferences);
        if (!buildOrder)
          return ts3.ExitStatus.InvalidProject_OutputsSkipped;
        setupInitialBuild(state, cancellationToken);
        var reportQueue = true;
        var successfulProjects = 0;
        while (true) {
          var invalidatedProject = getNextInvalidatedProject(state, buildOrder, reportQueue);
          if (!invalidatedProject)
            break;
          reportQueue = false;
          invalidatedProject.done(cancellationToken, writeFile, getCustomTransformers === null || getCustomTransformers === void 0 ? void 0 : getCustomTransformers(invalidatedProject.project));
          if (!state.diagnostics.has(invalidatedProject.projectPath))
            successfulProjects++;
        }
        disableCache(state);
        reportErrorSummary(state, buildOrder);
        startWatching(state, buildOrder);
        return isCircularBuildOrder(buildOrder) ? ts3.ExitStatus.ProjectReferenceCycle_OutputsSkipped : !buildOrder.some(function(p) {
          return state.diagnostics.has(toResolvedConfigFilePath(state, p));
        }) ? ts3.ExitStatus.Success : successfulProjects ? ts3.ExitStatus.DiagnosticsPresent_OutputsGenerated : ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped;
      }
      function clean(state, project, onlyReferences) {
        var buildOrder = getBuildOrderFor(state, project, onlyReferences);
        if (!buildOrder)
          return ts3.ExitStatus.InvalidProject_OutputsSkipped;
        if (isCircularBuildOrder(buildOrder)) {
          reportErrors(state, buildOrder.circularDiagnostics);
          return ts3.ExitStatus.ProjectReferenceCycle_OutputsSkipped;
        }
        var options = state.options, host = state.host;
        var filesToDelete = options.dry ? [] : void 0;
        for (var _i = 0, buildOrder_1 = buildOrder; _i < buildOrder_1.length; _i++) {
          var proj = buildOrder_1[_i];
          var resolvedPath = toResolvedConfigFilePath(state, proj);
          var parsed = parseConfigFile(state, proj, resolvedPath);
          if (parsed === void 0) {
            reportParseConfigFileDiagnostic(state, resolvedPath);
            continue;
          }
          var outputs = ts3.getAllProjectOutputs(parsed, !host.useCaseSensitiveFileNames());
          if (!outputs.length)
            continue;
          var inputFileNames = new ts3.Set(parsed.fileNames.map(function(f) {
            return toPath(state, f);
          }));
          for (var _a = 0, outputs_3 = outputs; _a < outputs_3.length; _a++) {
            var output = outputs_3[_a];
            if (inputFileNames.has(toPath(state, output)))
              continue;
            if (host.fileExists(output)) {
              if (filesToDelete) {
                filesToDelete.push(output);
              } else {
                host.deleteFile(output);
                invalidateProject(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.None);
              }
            }
          }
        }
        if (filesToDelete) {
          reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0, filesToDelete.map(function(f) {
            return "\r\n * ".concat(f);
          }).join(""));
        }
        return ts3.ExitStatus.Success;
      }
      function invalidateProject(state, resolved, reloadLevel) {
        if (state.host.getParsedCommandLine && reloadLevel === ts3.ConfigFileProgramReloadLevel.Partial) {
          reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
        }
        if (reloadLevel === ts3.ConfigFileProgramReloadLevel.Full) {
          state.configFileCache.delete(resolved);
          state.buildOrder = void 0;
        }
        state.needsSummary = true;
        clearProjectStatus(state, resolved);
        addProjToQueue(state, resolved, reloadLevel);
        enableCache(state);
      }
      function invalidateProjectAndScheduleBuilds(state, resolvedPath, reloadLevel) {
        state.reportFileChangeDetected = true;
        invalidateProject(state, resolvedPath, reloadLevel);
        scheduleBuildInvalidatedProject(state);
      }
      function scheduleBuildInvalidatedProject(state) {
        var hostWithWatch = state.hostWithWatch;
        if (!hostWithWatch.setTimeout || !hostWithWatch.clearTimeout) {
          return;
        }
        if (state.timerToBuildInvalidatedProject) {
          hostWithWatch.clearTimeout(state.timerToBuildInvalidatedProject);
        }
        state.timerToBuildInvalidatedProject = hostWithWatch.setTimeout(buildNextInvalidatedProject, 250, state);
      }
      function buildNextInvalidatedProject(state) {
        state.timerToBuildInvalidatedProject = void 0;
        if (state.reportFileChangeDetected) {
          state.reportFileChangeDetected = false;
          state.projectErrorsReported.clear();
          reportWatchStatus(state, ts3.Diagnostics.File_change_detected_Starting_incremental_compilation);
        }
        var buildOrder = getBuildOrder(state);
        var invalidatedProject = getNextInvalidatedProject(state, buildOrder, false);
        if (invalidatedProject) {
          invalidatedProject.done();
          if (state.projectPendingBuild.size) {
            if (state.watch && !state.timerToBuildInvalidatedProject) {
              scheduleBuildInvalidatedProject(state);
            }
            return;
          }
        }
        disableCache(state);
        reportErrorSummary(state, buildOrder);
      }
      function watchConfigFile(state, resolved, resolvedPath, parsed) {
        if (!state.watch || state.allWatchedConfigFiles.has(resolvedPath))
          return;
        state.allWatchedConfigFiles.set(resolvedPath, state.watchFile(resolved, function() {
          invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.Full);
        }, ts3.PollingInterval.High, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.ConfigFile, resolved));
      }
      function watchExtendedConfigFiles(state, resolvedPath, parsed) {
        ts3.updateSharedExtendedConfigFileWatcher(resolvedPath, parsed === null || parsed === void 0 ? void 0 : parsed.options, state.allWatchedExtendedConfigFiles, function(extendedConfigFileName, extendedConfigFilePath) {
          return state.watchFile(extendedConfigFileName, function() {
            var _a;
            return (_a = state.allWatchedExtendedConfigFiles.get(extendedConfigFilePath)) === null || _a === void 0 ? void 0 : _a.projects.forEach(function(projectConfigFilePath) {
              return invalidateProjectAndScheduleBuilds(state, projectConfigFilePath, ts3.ConfigFileProgramReloadLevel.Full);
            });
          }, ts3.PollingInterval.High, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.ExtendedConfigFile);
        }, function(fileName2) {
          return toPath(state, fileName2);
        });
      }
      function watchWildCardDirectories(state, resolved, resolvedPath, parsed) {
        if (!state.watch)
          return;
        ts3.updateWatchingWildcardDirectories(getOrCreateValueMapFromConfigFileMap(state.allWatchedWildcardDirectories, resolvedPath), new ts3.Map(ts3.getEntries(parsed.wildcardDirectories)), function(dir, flags) {
          return state.watchDirectory(dir, function(fileOrDirectory) {
            var _a;
            if (ts3.isIgnoredFileFromWildCardWatching({
              watchedDirPath: toPath(state, dir),
              fileOrDirectory,
              fileOrDirectoryPath: toPath(state, fileOrDirectory),
              configFileName: resolved,
              currentDirectory: state.currentDirectory,
              options: parsed.options,
              program: state.builderPrograms.get(resolvedPath) || ((_a = getCachedParsedConfigFile(state, resolvedPath)) === null || _a === void 0 ? void 0 : _a.fileNames),
              useCaseSensitiveFileNames: state.parseConfigFileHost.useCaseSensitiveFileNames,
              writeLog: function(s) {
                return state.writeLog(s);
              },
              toPath: function(fileName2) {
                return toPath(state, fileName2);
              }
            }))
              return;
            invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.Partial);
          }, flags, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.WildcardDirectory, resolved);
        });
      }
      function watchInputFiles(state, resolved, resolvedPath, parsed) {
        if (!state.watch)
          return;
        ts3.mutateMap(getOrCreateValueMapFromConfigFileMap(state.allWatchedInputFiles, resolvedPath), ts3.arrayToMap(parsed.fileNames, function(fileName2) {
          return toPath(state, fileName2);
        }), {
          createNewValue: function(_path, input) {
            return state.watchFile(input, function() {
              return invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.None);
            }, ts3.PollingInterval.Low, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.SourceFile, resolved);
          },
          onDeleteValue: ts3.closeFileWatcher
        });
      }
      function watchPackageJsonFiles(state, resolved, resolvedPath, parsed) {
        if (!state.watch || !state.lastCachedPackageJsonLookups)
          return;
        ts3.mutateMap(getOrCreateValueMapFromConfigFileMap(state.allWatchedPackageJsonFiles, resolvedPath), new ts3.Map(state.lastCachedPackageJsonLookups.get(resolvedPath)), {
          createNewValue: function(path2, _input) {
            return state.watchFile(path2, function() {
              return invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.None);
            }, ts3.PollingInterval.High, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.PackageJson, resolved);
          },
          onDeleteValue: ts3.closeFileWatcher
        });
      }
      function startWatching(state, buildOrder) {
        if (!state.watchAllProjectsPending)
          return;
        state.watchAllProjectsPending = false;
        for (var _i = 0, _a = getBuildOrderFromAnyBuildOrder(buildOrder); _i < _a.length; _i++) {
          var resolved = _a[_i];
          var resolvedPath = toResolvedConfigFilePath(state, resolved);
          var cfg = parseConfigFile(state, resolved, resolvedPath);
          watchConfigFile(state, resolved, resolvedPath, cfg);
          watchExtendedConfigFiles(state, resolvedPath, cfg);
          if (cfg) {
            watchWildCardDirectories(state, resolved, resolvedPath, cfg);
            watchInputFiles(state, resolved, resolvedPath, cfg);
            watchPackageJsonFiles(state, resolved, resolvedPath, cfg);
          }
        }
      }
      function stopWatching(state) {
        ts3.clearMap(state.allWatchedConfigFiles, ts3.closeFileWatcher);
        ts3.clearMap(state.allWatchedExtendedConfigFiles, ts3.closeFileWatcherOf);
        ts3.clearMap(state.allWatchedWildcardDirectories, function(watchedWildcardDirectories) {
          return ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcherOf);
        });
        ts3.clearMap(state.allWatchedInputFiles, function(watchedWildcardDirectories) {
          return ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcher);
        });
        ts3.clearMap(state.allWatchedPackageJsonFiles, function(watchedPacageJsonFiles) {
          return ts3.clearMap(watchedPacageJsonFiles, ts3.closeFileWatcher);
        });
      }
      function createSolutionBuilderWorker(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
        var state = createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions);
        return {
          build: function(project, cancellationToken, writeFile, getCustomTransformers) {
            return build(state, project, cancellationToken, writeFile, getCustomTransformers);
          },
          clean: function(project) {
            return clean(state, project);
          },
          buildReferences: function(project, cancellationToken, writeFile, getCustomTransformers) {
            return build(state, project, cancellationToken, writeFile, getCustomTransformers, true);
          },
          cleanReferences: function(project) {
            return clean(state, project, true);
          },
          getNextInvalidatedProject: function(cancellationToken) {
            setupInitialBuild(state, cancellationToken);
            return getNextInvalidatedProject(state, getBuildOrder(state), false);
          },
          getBuildOrder: function() {
            return getBuildOrder(state);
          },
          getUpToDateStatusOfProject: function(project) {
            var configFileName = resolveProjectName(state, project);
            var configFilePath = toResolvedConfigFilePath(state, configFileName);
            return getUpToDateStatus(state, parseConfigFile(state, configFileName, configFilePath), configFilePath);
          },
          invalidateProject: function(configFilePath, reloadLevel) {
            return invalidateProject(state, configFilePath, reloadLevel || ts3.ConfigFileProgramReloadLevel.None);
          },
          buildNextInvalidatedProject: function() {
            return buildNextInvalidatedProject(state);
          },
          getAllParsedConfigs: function() {
            return ts3.arrayFrom(ts3.mapDefinedIterator(state.configFileCache.values(), function(config) {
              return isParsedCommandLine(config) ? config : void 0;
            }));
          },
          close: function() {
            return stopWatching(state);
          }
        };
      }
      function relName(state, path2) {
        return ts3.convertToRelativePath(path2, state.currentDirectory, function(f) {
          return state.getCanonicalFileName(f);
        });
      }
      function reportStatus(state, message) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        state.host.reportSolutionBuilderStatus(ts3.createCompilerDiagnostic.apply(void 0, __spreadArray([message], args, false)));
      }
      function reportWatchStatus(state, message) {
        var _a, _b;
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        (_b = (_a = state.hostWithWatch).onWatchStatusChange) === null || _b === void 0 ? void 0 : _b.call(_a, ts3.createCompilerDiagnostic.apply(void 0, __spreadArray([message], args, false)), state.host.getNewLine(), state.baseCompilerOptions);
      }
      function reportErrors(_a, errors) {
        var host = _a.host;
        errors.forEach(function(err) {
          return host.reportDiagnostic(err);
        });
      }
      function reportAndStoreErrors(state, proj, errors) {
        reportErrors(state, errors);
        state.projectErrorsReported.set(proj, true);
        if (errors.length) {
          state.diagnostics.set(proj, errors);
        }
      }
      function reportParseConfigFileDiagnostic(state, proj) {
        reportAndStoreErrors(state, proj, [state.configFileCache.get(proj)]);
      }
      function reportErrorSummary(state, buildOrder) {
        if (!state.needsSummary)
          return;
        state.needsSummary = false;
        var canReportSummary = state.watch || !!state.host.reportErrorSummary;
        var diagnostics = state.diagnostics;
        var totalErrors = 0;
        var filesInError = [];
        if (isCircularBuildOrder(buildOrder)) {
          reportBuildQueue(state, buildOrder.buildOrder);
          reportErrors(state, buildOrder.circularDiagnostics);
          if (canReportSummary)
            totalErrors += ts3.getErrorCountForSummary(buildOrder.circularDiagnostics);
          if (canReportSummary)
            filesInError = __spreadArray(__spreadArray([], filesInError, true), ts3.getFilesInErrorForSummary(buildOrder.circularDiagnostics), true);
        } else {
          buildOrder.forEach(function(project) {
            var projectPath = toResolvedConfigFilePath(state, project);
            if (!state.projectErrorsReported.has(projectPath)) {
              reportErrors(state, diagnostics.get(projectPath) || ts3.emptyArray);
            }
          });
          if (canReportSummary)
            diagnostics.forEach(function(singleProjectErrors) {
              return totalErrors += ts3.getErrorCountForSummary(singleProjectErrors);
            });
          if (canReportSummary)
            diagnostics.forEach(function(singleProjectErrors) {
              return __spreadArray(__spreadArray([], filesInError, true), ts3.getFilesInErrorForSummary(singleProjectErrors), true);
            });
        }
        if (state.watch) {
          reportWatchStatus(state, ts3.getWatchErrorSummaryDiagnosticMessage(totalErrors), totalErrors);
        } else if (state.host.reportErrorSummary) {
          state.host.reportErrorSummary(totalErrors, filesInError);
        }
      }
      function reportBuildQueue(state, buildQueue) {
        if (state.options.verbose) {
          reportStatus(state, ts3.Diagnostics.Projects_in_this_build_Colon_0, buildQueue.map(function(s) {
            return "\r\n    * " + relName(state, s);
          }).join(""));
        }
      }
      function reportUpToDateStatus(state, configFileName, status) {
        if (state.options.force && (status.type === ts3.UpToDateStatusType.UpToDate || status.type === ts3.UpToDateStatusType.UpToDateWithUpstreamTypes)) {
          return reportStatus(state, ts3.Diagnostics.Project_0_is_being_forcibly_rebuilt, relName(state, configFileName));
        }
        switch (status.type) {
          case ts3.UpToDateStatusType.OutOfDateWithSelf:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, relName(state, configFileName), relName(state, status.outOfDateOutputFileName), relName(state, status.newerInputFileName));
          case ts3.UpToDateStatusType.OutOfDateWithUpstream:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, relName(state, configFileName), relName(state, status.outOfDateOutputFileName), relName(state, status.newerProjectName));
          case ts3.UpToDateStatusType.OutputMissing:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist, relName(state, configFileName), relName(state, status.missingOutputFileName));
          case ts3.UpToDateStatusType.UpToDate:
            if (status.newestInputFileTime !== void 0) {
              return reportStatus(state, ts3.Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2, relName(state, configFileName), relName(state, status.newestInputFileName || ""), relName(state, status.oldestOutputFileName || ""));
            }
            break;
          case ts3.UpToDateStatusType.OutOfDateWithPrepend:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed, relName(state, configFileName), relName(state, status.newerProjectName));
          case ts3.UpToDateStatusType.UpToDateWithUpstreamTypes:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies, relName(state, configFileName));
          case ts3.UpToDateStatusType.UpstreamOutOfDate:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date, relName(state, configFileName), relName(state, status.upstreamProjectName));
          case ts3.UpToDateStatusType.UpstreamBlocked:
            return reportStatus(state, status.upstreamProjectBlocked ? ts3.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_was_not_built : ts3.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors, relName(state, configFileName), relName(state, status.upstreamProjectName));
          case ts3.UpToDateStatusType.Unbuildable:
            return reportStatus(state, ts3.Diagnostics.Failed_to_parse_file_0_Colon_1, relName(state, configFileName), status.reason);
          case ts3.UpToDateStatusType.TsVersionOutputOfDate:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2, relName(state, configFileName), status.version, ts3.version);
          case ts3.UpToDateStatusType.ContainerOnly:
          case ts3.UpToDateStatusType.ComputingUpstream:
            break;
          default:
            ts3.assertType(status);
        }
      }
      function verboseReportProjectStatus(state, configFileName, status) {
        if (state.options.verbose) {
          reportUpToDateStatus(state, configFileName, status);
        }
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var server;
      (function(server2) {
        server2.ActionSet = "action::set";
        server2.ActionInvalidate = "action::invalidate";
        server2.ActionPackageInstalled = "action::packageInstalled";
        server2.EventTypesRegistry = "event::typesRegistry";
        server2.EventBeginInstallTypes = "event::beginInstallTypes";
        server2.EventEndInstallTypes = "event::endInstallTypes";
        server2.EventInitializationFailed = "event::initializationFailed";
        var Arguments;
        (function(Arguments2) {
          Arguments2.GlobalCacheLocation = "--globalTypingsCacheLocation";
          Arguments2.LogFile = "--logFile";
          Arguments2.EnableTelemetry = "--enableTelemetry";
          Arguments2.TypingSafeListLocation = "--typingSafeListLocation";
          Arguments2.TypesMapLocation = "--typesMapLocation";
          Arguments2.NpmLocation = "--npmLocation";
          Arguments2.ValidateDefaultNpmLocation = "--validateDefaultNpmLocation";
        })(Arguments = server2.Arguments || (server2.Arguments = {}));
        function hasArgument(argumentName) {
          return ts3.sys.args.indexOf(argumentName) >= 0;
        }
        server2.hasArgument = hasArgument;
        function findArgument(argumentName) {
          var index = ts3.sys.args.indexOf(argumentName);
          return index >= 0 && index < ts3.sys.args.length - 1 ? ts3.sys.args[index + 1] : void 0;
        }
        server2.findArgument = findArgument;
        function nowString() {
          var d = new Date();
          return "".concat(ts3.padLeft(d.getHours().toString(), 2, "0"), ":").concat(ts3.padLeft(d.getMinutes().toString(), 2, "0"), ":").concat(ts3.padLeft(d.getSeconds().toString(), 2, "0"), ".").concat(ts3.padLeft(d.getMilliseconds().toString(), 3, "0"));
        }
        server2.nowString = nowString;
      })(server = ts3.server || (ts3.server = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var JsTyping;
      (function(JsTyping2) {
        function isTypingUpToDate(cachedTyping, availableTypingVersions) {
          var availableVersion = new ts3.Version(ts3.getProperty(availableTypingVersions, "ts".concat(ts3.versionMajorMinor)) || ts3.getProperty(availableTypingVersions, "latest"));
          return availableVersion.compareTo(cachedTyping.version) <= 0;
        }
        JsTyping2.isTypingUpToDate = isTypingUpToDate;
        var unprefixedNodeCoreModuleList = [
          "assert",
          "assert/strict",
          "async_hooks",
          "buffer",
          "child_process",
          "cluster",
          "console",
          "constants",
          "crypto",
          "dgram",
          "diagnostics_channel",
          "dns",
          "dns/promises",
          "domain",
          "events",
          "fs",
          "fs/promises",
          "http",
          "https",
          "http2",
          "inspector",
          "module",
          "net",
          "os",
          "path",
          "perf_hooks",
          "process",
          "punycode",
          "querystring",
          "readline",
          "repl",
          "stream",
          "stream/promises",
          "string_decoder",
          "timers",
          "timers/promises",
          "tls",
          "trace_events",
          "tty",
          "url",
          "util",
          "util/types",
          "v8",
          "vm",
          "wasi",
          "worker_threads",
          "zlib"
        ];
        JsTyping2.prefixedNodeCoreModuleList = unprefixedNodeCoreModuleList.map(function(name) {
          return "node:".concat(name);
        });
        JsTyping2.nodeCoreModuleList = __spreadArray(__spreadArray([], unprefixedNodeCoreModuleList, true), JsTyping2.prefixedNodeCoreModuleList, true);
        JsTyping2.nodeCoreModules = new ts3.Set(JsTyping2.nodeCoreModuleList);
        function nonRelativeModuleNameForTypingCache(moduleName) {
          return JsTyping2.nodeCoreModules.has(moduleName) ? "node" : moduleName;
        }
        JsTyping2.nonRelativeModuleNameForTypingCache = nonRelativeModuleNameForTypingCache;
        function loadSafeList(host, safeListPath) {
          var result2 = ts3.readConfigFile(safeListPath, function(path2) {
            return host.readFile(path2);
          });
          return new ts3.Map(ts3.getEntries(result2.config));
        }
        JsTyping2.loadSafeList = loadSafeList;
        function loadTypesMap(host, typesMapPath) {
          var result2 = ts3.readConfigFile(typesMapPath, function(path2) {
            return host.readFile(path2);
          });
          if (result2.config) {
            return new ts3.Map(ts3.getEntries(result2.config.simpleMap));
          }
          return void 0;
        }
        JsTyping2.loadTypesMap = loadTypesMap;
        function discoverTypings(host, log, fileNames, projectRootPath, safeList, packageNameToTypingLocation, typeAcquisition, unresolvedImports, typesRegistry) {
          if (!typeAcquisition || !typeAcquisition.enable) {
            return { cachedTypingPaths: [], newTypingNames: [], filesToWatch: [] };
          }
          var inferredTypings = new ts3.Map();
          fileNames = ts3.mapDefined(fileNames, function(fileName2) {
            var path2 = ts3.normalizePath(fileName2);
            if (ts3.hasJSFileExtension(path2)) {
              return path2;
            }
          });
          var filesToWatch = [];
          if (typeAcquisition.include)
            addInferredTypings(typeAcquisition.include, "Explicitly included types");
          var exclude = typeAcquisition.exclude || [];
          var possibleSearchDirs = new ts3.Set(fileNames.map(ts3.getDirectoryPath));
          possibleSearchDirs.add(projectRootPath);
          possibleSearchDirs.forEach(function(searchDir) {
            getTypingNames(searchDir, "bower.json", "bower_components", filesToWatch);
            getTypingNames(searchDir, "package.json", "node_modules", filesToWatch);
          });
          if (!typeAcquisition.disableFilenameBasedTypeAcquisition) {
            getTypingNamesFromSourceFileNames(fileNames);
          }
          if (unresolvedImports) {
            var module_1 = ts3.deduplicate(unresolvedImports.map(nonRelativeModuleNameForTypingCache), ts3.equateStringsCaseSensitive, ts3.compareStringsCaseSensitive);
            addInferredTypings(module_1, "Inferred typings from unresolved imports");
          }
          packageNameToTypingLocation.forEach(function(typing, name) {
            var registryEntry = typesRegistry.get(name);
            if (inferredTypings.has(name) && inferredTypings.get(name) === void 0 && registryEntry !== void 0 && isTypingUpToDate(typing, registryEntry)) {
              inferredTypings.set(name, typing.typingLocation);
            }
          });
          for (var _i = 0, exclude_1 = exclude; _i < exclude_1.length; _i++) {
            var excludeTypingName = exclude_1[_i];
            var didDelete = inferredTypings.delete(excludeTypingName);
            if (didDelete && log)
              log("Typing for ".concat(excludeTypingName, " is in exclude list, will be ignored."));
          }
          var newTypingNames = [];
          var cachedTypingPaths = [];
          inferredTypings.forEach(function(inferred, typing) {
            if (inferred !== void 0) {
              cachedTypingPaths.push(inferred);
            } else {
              newTypingNames.push(typing);
            }
          });
          var result2 = { cachedTypingPaths, newTypingNames, filesToWatch };
          if (log)
            log("Result: ".concat(JSON.stringify(result2)));
          return result2;
          function addInferredTyping(typingName) {
            if (!inferredTypings.has(typingName)) {
              inferredTypings.set(typingName, void 0);
            }
          }
          function addInferredTypings(typingNames, message) {
            if (log)
              log("".concat(message, ": ").concat(JSON.stringify(typingNames)));
            ts3.forEach(typingNames, addInferredTyping);
          }
          function getTypingNames(projectRootPath2, manifestName, modulesDirName, filesToWatch2) {
            var manifestPath = ts3.combinePaths(projectRootPath2, manifestName);
            var manifest;
            var manifestTypingNames;
            if (host.fileExists(manifestPath)) {
              filesToWatch2.push(manifestPath);
              manifest = ts3.readConfigFile(manifestPath, function(path2) {
                return host.readFile(path2);
              }).config;
              manifestTypingNames = ts3.flatMap([manifest.dependencies, manifest.devDependencies, manifest.optionalDependencies, manifest.peerDependencies], ts3.getOwnKeys);
              addInferredTypings(manifestTypingNames, "Typing names in '".concat(manifestPath, "' dependencies"));
            }
            var packagesFolderPath = ts3.combinePaths(projectRootPath2, modulesDirName);
            filesToWatch2.push(packagesFolderPath);
            if (!host.directoryExists(packagesFolderPath)) {
              return;
            }
            var packageNames = [];
            var dependencyManifestNames = manifestTypingNames ? manifestTypingNames.map(function(typingName) {
              return ts3.combinePaths(packagesFolderPath, typingName, manifestName);
            }) : host.readDirectory(packagesFolderPath, [".json"], void 0, void 0, 3).filter(function(manifestPath2) {
              if (ts3.getBaseFileName(manifestPath2) !== manifestName) {
                return false;
              }
              var pathComponents = ts3.getPathComponents(ts3.normalizePath(manifestPath2));
              var isScoped = pathComponents[pathComponents.length - 3][0] === "@";
              return isScoped && pathComponents[pathComponents.length - 4].toLowerCase() === modulesDirName || !isScoped && pathComponents[pathComponents.length - 3].toLowerCase() === modulesDirName;
            });
            if (log)
              log("Searching for typing names in ".concat(packagesFolderPath, "; all files: ").concat(JSON.stringify(dependencyManifestNames)));
            for (var _i2 = 0, dependencyManifestNames_1 = dependencyManifestNames; _i2 < dependencyManifestNames_1.length; _i2++) {
              var manifestPath_1 = dependencyManifestNames_1[_i2];
              var normalizedFileName = ts3.normalizePath(manifestPath_1);
              var result_1 = ts3.readConfigFile(normalizedFileName, function(path2) {
                return host.readFile(path2);
              });
              var manifest_1 = result_1.config;
              if (!manifest_1.name) {
                continue;
              }
              var ownTypes = manifest_1.types || manifest_1.typings;
              if (ownTypes) {
                var absolutePath = ts3.getNormalizedAbsolutePath(ownTypes, ts3.getDirectoryPath(normalizedFileName));
                if (host.fileExists(absolutePath)) {
                  if (log)
                    log("    Package '".concat(manifest_1.name, "' provides its own types."));
                  inferredTypings.set(manifest_1.name, absolutePath);
                } else {
                  if (log)
                    log("    Package '".concat(manifest_1.name, "' provides its own types but they are missing."));
                }
              } else {
                packageNames.push(manifest_1.name);
              }
            }
            addInferredTypings(packageNames, "    Found package names");
          }
          function getTypingNamesFromSourceFileNames(fileNames2) {
            var fromFileNames = ts3.mapDefined(fileNames2, function(j) {
              if (!ts3.hasJSFileExtension(j))
                return void 0;
              var inferredTypingName = ts3.removeFileExtension(ts3.getBaseFileName(j.toLowerCase()));
              var cleanedTypingName = ts3.removeMinAndVersionNumbers(inferredTypingName);
              return safeList.get(cleanedTypingName);
            });
            if (fromFileNames.length) {
              addInferredTypings(fromFileNames, "Inferred typings from file names");
            }
            var hasJsxFile = ts3.some(fileNames2, function(f) {
              return ts3.fileExtensionIs(f, ".jsx");
            });
            if (hasJsxFile) {
              if (log)
                log("Inferred 'react' typings due to presence of '.jsx' extension");
              addInferredTyping("react");
            }
          }
        }
        JsTyping2.discoverTypings = discoverTypings;
        var NameValidationResult;
        (function(NameValidationResult2) {
          NameValidationResult2[NameValidationResult2["Ok"] = 0] = "Ok";
          NameValidationResult2[NameValidationResult2["EmptyName"] = 1] = "EmptyName";
          NameValidationResult2[NameValidationResult2["NameTooLong"] = 2] = "NameTooLong";
          NameValidationResult2[NameValidationResult2["NameStartsWithDot"] = 3] = "NameStartsWithDot";
          NameValidationResult2[NameValidationResult2["NameStartsWithUnderscore"] = 4] = "NameStartsWithUnderscore";
          NameValidationResult2[NameValidationResult2["NameContainsNonURISafeCharacters"] = 5] = "NameContainsNonURISafeCharacters";
        })(NameValidationResult = JsTyping2.NameValidationResult || (JsTyping2.NameValidationResult = {}));
        var maxPackageNameLength = 214;
        function validatePackageName(packageName) {
          return validatePackageNameWorker(packageName, true);
        }
        JsTyping2.validatePackageName = validatePackageName;
        function validatePackageNameWorker(packageName, supportScopedPackage) {
          if (!packageName) {
            return 1;
          }
          if (packageName.length > maxPackageNameLength) {
            return 2;
          }
          if (packageName.charCodeAt(0) === 46) {
            return 3;
          }
          if (packageName.charCodeAt(0) === 95) {
            return 4;
          }
          if (supportScopedPackage) {
            var matches = /^@([^/]+)\/([^/]+)$/.exec(packageName);
            if (matches) {
              var scopeResult = validatePackageNameWorker(matches[1], false);
              if (scopeResult !== 0) {
                return { name: matches[1], isScopeName: true, result: scopeResult };
              }
              var packageResult = validatePackageNameWorker(matches[2], false);
              if (packageResult !== 0) {
                return { name: matches[2], isScopeName: false, result: packageResult };
              }
              return 0;
            }
          }
          if (encodeURIComponent(packageName) !== packageName) {
            return 5;
          }
          return 0;
        }
        function renderPackageNameValidationFailure(result2, typing) {
          return typeof result2 === "object" ? renderPackageNameValidationFailureWorker(typing, result2.result, result2.name, result2.isScopeName) : renderPackageNameValidationFailureWorker(typing, result2, typing, false);
        }
        JsTyping2.renderPackageNameValidationFailure = renderPackageNameValidationFailure;
        function renderPackageNameValidationFailureWorker(typing, result2, name, isScopeName) {
          var kind = isScopeName ? "Scope" : "Package";
          switch (result2) {
            case 1:
              return "'".concat(typing, "':: ").concat(kind, " name '").concat(name, "' cannot be empty");
            case 2:
              return "'".concat(typing, "':: ").concat(kind, " name '").concat(name, "' should be less than ").concat(maxPackageNameLength, " characters");
            case 3:
              return "'".concat(typing, "':: ").concat(kind, " name '").concat(name, "' cannot start with '.'");
            case 4:
              return "'".concat(typing, "':: ").concat(kind, " name '").concat(name, "' cannot start with '_'");
            case 5:
              return "'".concat(typing, "':: ").concat(kind, " name '").concat(name, "' contains non URI safe characters");
            case 0:
              return ts3.Debug.fail();
            default:
              throw ts3.Debug.assertNever(result2);
          }
        }
      })(JsTyping = ts3.JsTyping || (ts3.JsTyping = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ScriptSnapshot;
      (function(ScriptSnapshot2) {
        var StringScriptSnapshot = function() {
          function StringScriptSnapshot2(text) {
            this.text = text;
          }
          StringScriptSnapshot2.prototype.getText = function(start, end) {
            return start === 0 && end === this.text.length ? this.text : this.text.substring(start, end);
          };
          StringScriptSnapshot2.prototype.getLength = function() {
            return this.text.length;
          };
          StringScriptSnapshot2.prototype.getChangeRange = function() {
            return void 0;
          };
          return StringScriptSnapshot2;
        }();
        function fromString(text) {
          return new StringScriptSnapshot(text);
        }
        ScriptSnapshot2.fromString = fromString;
      })(ScriptSnapshot = ts3.ScriptSnapshot || (ts3.ScriptSnapshot = {}));
      var PackageJsonDependencyGroup;
      (function(PackageJsonDependencyGroup2) {
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["Dependencies"] = 1] = "Dependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["DevDependencies"] = 2] = "DevDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["PeerDependencies"] = 4] = "PeerDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["OptionalDependencies"] = 8] = "OptionalDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["All"] = 15] = "All";
      })(PackageJsonDependencyGroup = ts3.PackageJsonDependencyGroup || (ts3.PackageJsonDependencyGroup = {}));
      var PackageJsonAutoImportPreference;
      (function(PackageJsonAutoImportPreference2) {
        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["Off"] = 0] = "Off";
        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["On"] = 1] = "On";
        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["Auto"] = 2] = "Auto";
      })(PackageJsonAutoImportPreference = ts3.PackageJsonAutoImportPreference || (ts3.PackageJsonAutoImportPreference = {}));
      var LanguageServiceMode;
      (function(LanguageServiceMode2) {
        LanguageServiceMode2[LanguageServiceMode2["Semantic"] = 0] = "Semantic";
        LanguageServiceMode2[LanguageServiceMode2["PartialSemantic"] = 1] = "PartialSemantic";
        LanguageServiceMode2[LanguageServiceMode2["Syntactic"] = 2] = "Syntactic";
      })(LanguageServiceMode = ts3.LanguageServiceMode || (ts3.LanguageServiceMode = {}));
      ts3.emptyOptions = {};
      var SemanticClassificationFormat;
      (function(SemanticClassificationFormat2) {
        SemanticClassificationFormat2["Original"] = "original";
        SemanticClassificationFormat2["TwentyTwenty"] = "2020";
      })(SemanticClassificationFormat = ts3.SemanticClassificationFormat || (ts3.SemanticClassificationFormat = {}));
      var CompletionTriggerKind;
      (function(CompletionTriggerKind2) {
        CompletionTriggerKind2[CompletionTriggerKind2["Invoked"] = 1] = "Invoked";
        CompletionTriggerKind2[CompletionTriggerKind2["TriggerCharacter"] = 2] = "TriggerCharacter";
        CompletionTriggerKind2[CompletionTriggerKind2["TriggerForIncompleteCompletions"] = 3] = "TriggerForIncompleteCompletions";
      })(CompletionTriggerKind = ts3.CompletionTriggerKind || (ts3.CompletionTriggerKind = {}));
      var InlayHintKind;
      (function(InlayHintKind2) {
        InlayHintKind2["Type"] = "Type";
        InlayHintKind2["Parameter"] = "Parameter";
        InlayHintKind2["Enum"] = "Enum";
      })(InlayHintKind = ts3.InlayHintKind || (ts3.InlayHintKind = {}));
      var HighlightSpanKind;
      (function(HighlightSpanKind2) {
        HighlightSpanKind2["none"] = "none";
        HighlightSpanKind2["definition"] = "definition";
        HighlightSpanKind2["reference"] = "reference";
        HighlightSpanKind2["writtenReference"] = "writtenReference";
      })(HighlightSpanKind = ts3.HighlightSpanKind || (ts3.HighlightSpanKind = {}));
      var IndentStyle;
      (function(IndentStyle2) {
        IndentStyle2[IndentStyle2["None"] = 0] = "None";
        IndentStyle2[IndentStyle2["Block"] = 1] = "Block";
        IndentStyle2[IndentStyle2["Smart"] = 2] = "Smart";
      })(IndentStyle = ts3.IndentStyle || (ts3.IndentStyle = {}));
      var SemicolonPreference;
      (function(SemicolonPreference2) {
        SemicolonPreference2["Ignore"] = "ignore";
        SemicolonPreference2["Insert"] = "insert";
        SemicolonPreference2["Remove"] = "remove";
      })(SemicolonPreference = ts3.SemicolonPreference || (ts3.SemicolonPreference = {}));
      function getDefaultFormatCodeSettings(newLineCharacter) {
        return {
          indentSize: 4,
          tabSize: 4,
          newLineCharacter: newLineCharacter || "\n",
          convertTabsToSpaces: true,
          indentStyle: IndentStyle.Smart,
          insertSpaceAfterConstructor: false,
          insertSpaceAfterCommaDelimiter: true,
          insertSpaceAfterSemicolonInForStatements: true,
          insertSpaceBeforeAndAfterBinaryOperators: true,
          insertSpaceAfterKeywordsInControlFlowStatements: true,
          insertSpaceAfterFunctionKeywordForAnonymousFunctions: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces: true,
          insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces: false,
          insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces: false,
          insertSpaceBeforeFunctionParenthesis: false,
          placeOpenBraceOnNewLineForFunctions: false,
          placeOpenBraceOnNewLineForControlBlocks: false,
          semicolons: SemicolonPreference.Ignore,
          trimTrailingWhitespace: true
        };
      }
      ts3.getDefaultFormatCodeSettings = getDefaultFormatCodeSettings;
      ts3.testFormatSettings = getDefaultFormatCodeSettings("\n");
      var SymbolDisplayPartKind;
      (function(SymbolDisplayPartKind2) {
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["aliasName"] = 0] = "aliasName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["className"] = 1] = "className";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumName"] = 2] = "enumName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["fieldName"] = 3] = "fieldName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["interfaceName"] = 4] = "interfaceName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["keyword"] = 5] = "keyword";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["lineBreak"] = 6] = "lineBreak";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["numericLiteral"] = 7] = "numericLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["stringLiteral"] = 8] = "stringLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["localName"] = 9] = "localName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["methodName"] = 10] = "methodName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["moduleName"] = 11] = "moduleName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["operator"] = 12] = "operator";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["parameterName"] = 13] = "parameterName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["propertyName"] = 14] = "propertyName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["punctuation"] = 15] = "punctuation";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["space"] = 16] = "space";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["text"] = 17] = "text";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["typeParameterName"] = 18] = "typeParameterName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumMemberName"] = 19] = "enumMemberName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["functionName"] = 20] = "functionName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["regularExpressionLiteral"] = 21] = "regularExpressionLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["link"] = 22] = "link";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["linkName"] = 23] = "linkName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["linkText"] = 24] = "linkText";
      })(SymbolDisplayPartKind = ts3.SymbolDisplayPartKind || (ts3.SymbolDisplayPartKind = {}));
      var CompletionInfoFlags;
      (function(CompletionInfoFlags2) {
        CompletionInfoFlags2[CompletionInfoFlags2["None"] = 0] = "None";
        CompletionInfoFlags2[CompletionInfoFlags2["MayIncludeAutoImports"] = 1] = "MayIncludeAutoImports";
        CompletionInfoFlags2[CompletionInfoFlags2["IsImportStatementCompletion"] = 2] = "IsImportStatementCompletion";
        CompletionInfoFlags2[CompletionInfoFlags2["IsContinuation"] = 4] = "IsContinuation";
        CompletionInfoFlags2[CompletionInfoFlags2["ResolvedModuleSpecifiers"] = 8] = "ResolvedModuleSpecifiers";
        CompletionInfoFlags2[CompletionInfoFlags2["ResolvedModuleSpecifiersBeyondLimit"] = 16] = "ResolvedModuleSpecifiersBeyondLimit";
        CompletionInfoFlags2[CompletionInfoFlags2["MayIncludeMethodSnippets"] = 32] = "MayIncludeMethodSnippets";
      })(CompletionInfoFlags = ts3.CompletionInfoFlags || (ts3.CompletionInfoFlags = {}));
      var OutliningSpanKind;
      (function(OutliningSpanKind2) {
        OutliningSpanKind2["Comment"] = "comment";
        OutliningSpanKind2["Region"] = "region";
        OutliningSpanKind2["Code"] = "code";
        OutliningSpanKind2["Imports"] = "imports";
      })(OutliningSpanKind = ts3.OutliningSpanKind || (ts3.OutliningSpanKind = {}));
      var OutputFileType;
      (function(OutputFileType2) {
        OutputFileType2[OutputFileType2["JavaScript"] = 0] = "JavaScript";
        OutputFileType2[OutputFileType2["SourceMap"] = 1] = "SourceMap";
        OutputFileType2[OutputFileType2["Declaration"] = 2] = "Declaration";
      })(OutputFileType = ts3.OutputFileType || (ts3.OutputFileType = {}));
      var EndOfLineState;
      (function(EndOfLineState2) {
        EndOfLineState2[EndOfLineState2["None"] = 0] = "None";
        EndOfLineState2[EndOfLineState2["InMultiLineCommentTrivia"] = 1] = "InMultiLineCommentTrivia";
        EndOfLineState2[EndOfLineState2["InSingleQuoteStringLiteral"] = 2] = "InSingleQuoteStringLiteral";
        EndOfLineState2[EndOfLineState2["InDoubleQuoteStringLiteral"] = 3] = "InDoubleQuoteStringLiteral";
        EndOfLineState2[EndOfLineState2["InTemplateHeadOrNoSubstitutionTemplate"] = 4] = "InTemplateHeadOrNoSubstitutionTemplate";
        EndOfLineState2[EndOfLineState2["InTemplateMiddleOrTail"] = 5] = "InTemplateMiddleOrTail";
        EndOfLineState2[EndOfLineState2["InTemplateSubstitutionPosition"] = 6] = "InTemplateSubstitutionPosition";
      })(EndOfLineState = ts3.EndOfLineState || (ts3.EndOfLineState = {}));
      var TokenClass;
      (function(TokenClass2) {
        TokenClass2[TokenClass2["Punctuation"] = 0] = "Punctuation";
        TokenClass2[TokenClass2["Keyword"] = 1] = "Keyword";
        TokenClass2[TokenClass2["Operator"] = 2] = "Operator";
        TokenClass2[TokenClass2["Comment"] = 3] = "Comment";
        TokenClass2[TokenClass2["Whitespace"] = 4] = "Whitespace";
        TokenClass2[TokenClass2["Identifier"] = 5] = "Identifier";
        TokenClass2[TokenClass2["NumberLiteral"] = 6] = "NumberLiteral";
        TokenClass2[TokenClass2["BigIntLiteral"] = 7] = "BigIntLiteral";
        TokenClass2[TokenClass2["StringLiteral"] = 8] = "StringLiteral";
        TokenClass2[TokenClass2["RegExpLiteral"] = 9] = "RegExpLiteral";
      })(TokenClass = ts3.TokenClass || (ts3.TokenClass = {}));
      var ScriptElementKind;
      (function(ScriptElementKind2) {
        ScriptElementKind2["unknown"] = "";
        ScriptElementKind2["warning"] = "warning";
        ScriptElementKind2["keyword"] = "keyword";
        ScriptElementKind2["scriptElement"] = "script";
        ScriptElementKind2["moduleElement"] = "module";
        ScriptElementKind2["classElement"] = "class";
        ScriptElementKind2["localClassElement"] = "local class";
        ScriptElementKind2["interfaceElement"] = "interface";
        ScriptElementKind2["typeElement"] = "type";
        ScriptElementKind2["enumElement"] = "enum";
        ScriptElementKind2["enumMemberElement"] = "enum member";
        ScriptElementKind2["variableElement"] = "var";
        ScriptElementKind2["localVariableElement"] = "local var";
        ScriptElementKind2["functionElement"] = "function";
        ScriptElementKind2["localFunctionElement"] = "local function";
        ScriptElementKind2["memberFunctionElement"] = "method";
        ScriptElementKind2["memberGetAccessorElement"] = "getter";
        ScriptElementKind2["memberSetAccessorElement"] = "setter";
        ScriptElementKind2["memberVariableElement"] = "property";
        ScriptElementKind2["constructorImplementationElement"] = "constructor";
        ScriptElementKind2["callSignatureElement"] = "call";
        ScriptElementKind2["indexSignatureElement"] = "index";
        ScriptElementKind2["constructSignatureElement"] = "construct";
        ScriptElementKind2["parameterElement"] = "parameter";
        ScriptElementKind2["typeParameterElement"] = "type parameter";
        ScriptElementKind2["primitiveType"] = "primitive type";
        ScriptElementKind2["label"] = "label";
        ScriptElementKind2["alias"] = "alias";
        ScriptElementKind2["constElement"] = "const";
        ScriptElementKind2["letElement"] = "let";
        ScriptElementKind2["directory"] = "directory";
        ScriptElementKind2["externalModuleName"] = "external module name";
        ScriptElementKind2["jsxAttribute"] = "JSX attribute";
        ScriptElementKind2["string"] = "string";
        ScriptElementKind2["link"] = "link";
        ScriptElementKind2["linkName"] = "link name";
        ScriptElementKind2["linkText"] = "link text";
      })(ScriptElementKind = ts3.ScriptElementKind || (ts3.ScriptElementKind = {}));
      var ScriptElementKindModifier;
      (function(ScriptElementKindModifier2) {
        ScriptElementKindModifier2["none"] = "";
        ScriptElementKindModifier2["publicMemberModifier"] = "public";
        ScriptElementKindModifier2["privateMemberModifier"] = "private";
        ScriptElementKindModifier2["protectedMemberModifier"] = "protected";
        ScriptElementKindModifier2["exportedModifier"] = "export";
        ScriptElementKindModifier2["ambientModifier"] = "declare";
        ScriptElementKindModifier2["staticModifier"] = "static";
        ScriptElementKindModifier2["abstractModifier"] = "abstract";
        ScriptElementKindModifier2["optionalModifier"] = "optional";
        ScriptElementKindModifier2["deprecatedModifier"] = "deprecated";
        ScriptElementKindModifier2["dtsModifier"] = ".d.ts";
        ScriptElementKindModifier2["tsModifier"] = ".ts";
        ScriptElementKindModifier2["tsxModifier"] = ".tsx";
        ScriptElementKindModifier2["jsModifier"] = ".js";
        ScriptElementKindModifier2["jsxModifier"] = ".jsx";
        ScriptElementKindModifier2["jsonModifier"] = ".json";
        ScriptElementKindModifier2["dmtsModifier"] = ".d.mts";
        ScriptElementKindModifier2["mtsModifier"] = ".mts";
        ScriptElementKindModifier2["mjsModifier"] = ".mjs";
        ScriptElementKindModifier2["dctsModifier"] = ".d.cts";
        ScriptElementKindModifier2["ctsModifier"] = ".cts";
        ScriptElementKindModifier2["cjsModifier"] = ".cjs";
      })(ScriptElementKindModifier = ts3.ScriptElementKindModifier || (ts3.ScriptElementKindModifier = {}));
      var ClassificationTypeNames;
      (function(ClassificationTypeNames2) {
        ClassificationTypeNames2["comment"] = "comment";
        ClassificationTypeNames2["identifier"] = "identifier";
        ClassificationTypeNames2["keyword"] = "keyword";
        ClassificationTypeNames2["numericLiteral"] = "number";
        ClassificationTypeNames2["bigintLiteral"] = "bigint";
        ClassificationTypeNames2["operator"] = "operator";
        ClassificationTypeNames2["stringLiteral"] = "string";
        ClassificationTypeNames2["whiteSpace"] = "whitespace";
        ClassificationTypeNames2["text"] = "text";
        ClassificationTypeNames2["punctuation"] = "punctuation";
        ClassificationTypeNames2["className"] = "class name";
        ClassificationTypeNames2["enumName"] = "enum name";
        ClassificationTypeNames2["interfaceName"] = "interface name";
        ClassificationTypeNames2["moduleName"] = "module name";
        ClassificationTypeNames2["typeParameterName"] = "type parameter name";
        ClassificationTypeNames2["typeAliasName"] = "type alias name";
        ClassificationTypeNames2["parameterName"] = "parameter name";
        ClassificationTypeNames2["docCommentTagName"] = "doc comment tag name";
        ClassificationTypeNames2["jsxOpenTagName"] = "jsx open tag name";
        ClassificationTypeNames2["jsxCloseTagName"] = "jsx close tag name";
        ClassificationTypeNames2["jsxSelfClosingTagName"] = "jsx self closing tag name";
        ClassificationTypeNames2["jsxAttribute"] = "jsx attribute";
        ClassificationTypeNames2["jsxText"] = "jsx text";
        ClassificationTypeNames2["jsxAttributeStringLiteralValue"] = "jsx attribute string literal value";
      })(ClassificationTypeNames = ts3.ClassificationTypeNames || (ts3.ClassificationTypeNames = {}));
      var ClassificationType;
      (function(ClassificationType2) {
        ClassificationType2[ClassificationType2["comment"] = 1] = "comment";
        ClassificationType2[ClassificationType2["identifier"] = 2] = "identifier";
        ClassificationType2[ClassificationType2["keyword"] = 3] = "keyword";
        ClassificationType2[ClassificationType2["numericLiteral"] = 4] = "numericLiteral";
        ClassificationType2[ClassificationType2["operator"] = 5] = "operator";
        ClassificationType2[ClassificationType2["stringLiteral"] = 6] = "stringLiteral";
        ClassificationType2[ClassificationType2["regularExpressionLiteral"] = 7] = "regularExpressionLiteral";
        ClassificationType2[ClassificationType2["whiteSpace"] = 8] = "whiteSpace";
        ClassificationType2[ClassificationType2["text"] = 9] = "text";
        ClassificationType2[ClassificationType2["punctuation"] = 10] = "punctuation";
        ClassificationType2[ClassificationType2["className"] = 11] = "className";
        ClassificationType2[ClassificationType2["enumName"] = 12] = "enumName";
        ClassificationType2[ClassificationType2["interfaceName"] = 13] = "interfaceName";
        ClassificationType2[ClassificationType2["moduleName"] = 14] = "moduleName";
        ClassificationType2[ClassificationType2["typeParameterName"] = 15] = "typeParameterName";
        ClassificationType2[ClassificationType2["typeAliasName"] = 16] = "typeAliasName";
        ClassificationType2[ClassificationType2["parameterName"] = 17] = "parameterName";
        ClassificationType2[ClassificationType2["docCommentTagName"] = 18] = "docCommentTagName";
        ClassificationType2[ClassificationType2["jsxOpenTagName"] = 19] = "jsxOpenTagName";
        ClassificationType2[ClassificationType2["jsxCloseTagName"] = 20] = "jsxCloseTagName";
        ClassificationType2[ClassificationType2["jsxSelfClosingTagName"] = 21] = "jsxSelfClosingTagName";
        ClassificationType2[ClassificationType2["jsxAttribute"] = 22] = "jsxAttribute";
        ClassificationType2[ClassificationType2["jsxText"] = 23] = "jsxText";
        ClassificationType2[ClassificationType2["jsxAttributeStringLiteralValue"] = 24] = "jsxAttributeStringLiteralValue";
        ClassificationType2[ClassificationType2["bigintLiteral"] = 25] = "bigintLiteral";
      })(ClassificationType = ts3.ClassificationType || (ts3.ClassificationType = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.scanner = ts3.createScanner(99, true);
      var SemanticMeaning;
      (function(SemanticMeaning2) {
        SemanticMeaning2[SemanticMeaning2["None"] = 0] = "None";
        SemanticMeaning2[SemanticMeaning2["Value"] = 1] = "Value";
        SemanticMeaning2[SemanticMeaning2["Type"] = 2] = "Type";
        SemanticMeaning2[SemanticMeaning2["Namespace"] = 4] = "Namespace";
        SemanticMeaning2[SemanticMeaning2["All"] = 7] = "All";
      })(SemanticMeaning = ts3.SemanticMeaning || (ts3.SemanticMeaning = {}));
      function getMeaningFromDeclaration(node) {
        switch (node.kind) {
          case 254:
            return ts3.isInJSFile(node) && ts3.getJSDocEnumTag(node) ? 7 : 1;
          case 164:
          case 203:
          case 167:
          case 166:
          case 296:
          case 297:
          case 169:
          case 168:
          case 171:
          case 172:
          case 173:
          case 256:
          case 213:
          case 214:
          case 292:
          case 285:
            return 1;
          case 163:
          case 258:
          case 259:
          case 182:
            return 2;
          case 345:
            return node.name === void 0 ? 1 | 2 : 2;
          case 299:
          case 257:
            return 1 | 2;
          case 261:
            if (ts3.isAmbientModule(node)) {
              return 4 | 1;
            } else if (ts3.getModuleInstanceState(node) === 1) {
              return 4 | 1;
            } else {
              return 4;
            }
          case 260:
          case 269:
          case 270:
          case 265:
          case 266:
          case 271:
          case 272:
            return 7;
          case 305:
            return 4 | 1;
        }
        return 7;
      }
      ts3.getMeaningFromDeclaration = getMeaningFromDeclaration;
      function getMeaningFromLocation(node) {
        node = getAdjustedReferenceLocation(node);
        var parent = node.parent;
        if (node.kind === 305) {
          return 1;
        } else if (ts3.isExportAssignment(parent) || ts3.isExportSpecifier(parent) || ts3.isExternalModuleReference(parent) || ts3.isImportSpecifier(parent) || ts3.isImportClause(parent) || ts3.isImportEqualsDeclaration(parent) && node === parent.name) {
          return 7;
        } else if (isInRightSideOfInternalImportEqualsDeclaration(node)) {
          return getMeaningFromRightHandSideOfImportEquals(node);
        } else if (ts3.isDeclarationName(node)) {
          return getMeaningFromDeclaration(parent);
        } else if (ts3.isEntityName(node) && ts3.findAncestor(node, ts3.or(ts3.isJSDocNameReference, ts3.isJSDocLinkLike, ts3.isJSDocMemberName))) {
          return 7;
        } else if (isTypeReference(node)) {
          return 2;
        } else if (isNamespaceReference(node)) {
          return 4;
        } else if (ts3.isTypeParameterDeclaration(parent)) {
          ts3.Debug.assert(ts3.isJSDocTemplateTag(parent.parent));
          return 2;
        } else if (ts3.isLiteralTypeNode(parent)) {
          return 2 | 1;
        } else {
          return 1;
        }
      }
      ts3.getMeaningFromLocation = getMeaningFromLocation;
      function getMeaningFromRightHandSideOfImportEquals(node) {
        var name = node.kind === 161 ? node : ts3.isQualifiedName(node.parent) && node.parent.right === node ? node.parent : void 0;
        return name && name.parent.kind === 265 ? 7 : 4;
      }
      function isInRightSideOfInternalImportEqualsDeclaration(node) {
        while (node.parent.kind === 161) {
          node = node.parent;
        }
        return ts3.isInternalModuleImportEqualsDeclaration(node.parent) && node.parent.moduleReference === node;
      }
      ts3.isInRightSideOfInternalImportEqualsDeclaration = isInRightSideOfInternalImportEqualsDeclaration;
      function isNamespaceReference(node) {
        return isQualifiedNameNamespaceReference(node) || isPropertyAccessNamespaceReference(node);
      }
      function isQualifiedNameNamespaceReference(node) {
        var root = node;
        var isLastClause = true;
        if (root.parent.kind === 161) {
          while (root.parent && root.parent.kind === 161) {
            root = root.parent;
          }
          isLastClause = root.right === node;
        }
        return root.parent.kind === 178 && !isLastClause;
      }
      function isPropertyAccessNamespaceReference(node) {
        var root = node;
        var isLastClause = true;
        if (root.parent.kind === 206) {
          while (root.parent && root.parent.kind === 206) {
            root = root.parent;
          }
          isLastClause = root.name === node;
        }
        if (!isLastClause && root.parent.kind === 228 && root.parent.parent.kind === 291) {
          var decl = root.parent.parent.parent;
          return decl.kind === 257 && root.parent.parent.token === 117 || decl.kind === 258 && root.parent.parent.token === 94;
        }
        return false;
      }
      function isTypeReference(node) {
        if (ts3.isRightSideOfQualifiedNameOrPropertyAccess(node)) {
          node = node.parent;
        }
        switch (node.kind) {
          case 108:
            return !ts3.isExpressionNode(node);
          case 192:
            return true;
        }
        switch (node.parent.kind) {
          case 178:
            return true;
          case 200:
            return !node.parent.isTypeOf;
          case 228:
            return ts3.isPartOfTypeNode(node.parent);
        }
        return false;
      }
      function isCallExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isCallExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isCallExpressionTarget = isCallExpressionTarget;
      function isNewExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isNewExpressionTarget = isNewExpressionTarget;
      function isCallOrNewExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isCallOrNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isCallOrNewExpressionTarget = isCallOrNewExpressionTarget;
      function isTaggedTemplateTag(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isTaggedTemplateExpression, selectTagOfTaggedTemplateExpression, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isTaggedTemplateTag = isTaggedTemplateTag;
      function isDecoratorTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isDecorator, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isDecoratorTarget = isDecoratorTarget;
      function isJsxOpeningLikeElementTagName(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isJsxOpeningLikeElement, selectTagNameOfJsxOpeningLikeElement, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isJsxOpeningLikeElementTagName = isJsxOpeningLikeElementTagName;
      function selectExpressionOfCallOrNewExpressionOrDecorator(node) {
        return node.expression;
      }
      function selectTagOfTaggedTemplateExpression(node) {
        return node.tag;
      }
      function selectTagNameOfJsxOpeningLikeElement(node) {
        return node.tagName;
      }
      function isCalleeWorker(node, pred, calleeSelector, includeElementAccess, skipPastOuterExpressions) {
        var target = includeElementAccess ? climbPastPropertyOrElementAccess(node) : climbPastPropertyAccess(node);
        if (skipPastOuterExpressions) {
          target = ts3.skipOuterExpressions(target);
        }
        return !!target && !!target.parent && pred(target.parent) && calleeSelector(target.parent) === target;
      }
      function climbPastPropertyAccess(node) {
        return isRightSideOfPropertyAccess(node) ? node.parent : node;
      }
      ts3.climbPastPropertyAccess = climbPastPropertyAccess;
      function climbPastPropertyOrElementAccess(node) {
        return isRightSideOfPropertyAccess(node) || isArgumentExpressionOfElementAccess(node) ? node.parent : node;
      }
      ts3.climbPastPropertyOrElementAccess = climbPastPropertyOrElementAccess;
      function getTargetLabel(referenceNode, labelName) {
        while (referenceNode) {
          if (referenceNode.kind === 250 && referenceNode.label.escapedText === labelName) {
            return referenceNode.label;
          }
          referenceNode = referenceNode.parent;
        }
        return void 0;
      }
      ts3.getTargetLabel = getTargetLabel;
      function hasPropertyAccessExpressionWithName(node, funcName) {
        if (!ts3.isPropertyAccessExpression(node.expression)) {
          return false;
        }
        return node.expression.name.text === funcName;
      }
      ts3.hasPropertyAccessExpressionWithName = hasPropertyAccessExpressionWithName;
      function isJumpStatementTarget(node) {
        var _a;
        return ts3.isIdentifier(node) && ((_a = ts3.tryCast(node.parent, ts3.isBreakOrContinueStatement)) === null || _a === void 0 ? void 0 : _a.label) === node;
      }
      ts3.isJumpStatementTarget = isJumpStatementTarget;
      function isLabelOfLabeledStatement(node) {
        var _a;
        return ts3.isIdentifier(node) && ((_a = ts3.tryCast(node.parent, ts3.isLabeledStatement)) === null || _a === void 0 ? void 0 : _a.label) === node;
      }
      ts3.isLabelOfLabeledStatement = isLabelOfLabeledStatement;
      function isLabelName(node) {
        return isLabelOfLabeledStatement(node) || isJumpStatementTarget(node);
      }
      ts3.isLabelName = isLabelName;
      function isTagName(node) {
        var _a;
        return ((_a = ts3.tryCast(node.parent, ts3.isJSDocTag)) === null || _a === void 0 ? void 0 : _a.tagName) === node;
      }
      ts3.isTagName = isTagName;
      function isRightSideOfQualifiedName(node) {
        var _a;
        return ((_a = ts3.tryCast(node.parent, ts3.isQualifiedName)) === null || _a === void 0 ? void 0 : _a.right) === node;
      }
      ts3.isRightSideOfQualifiedName = isRightSideOfQualifiedName;
      function isRightSideOfPropertyAccess(node) {
        var _a;
        return ((_a = ts3.tryCast(node.parent, ts3.isPropertyAccessExpression)) === null || _a === void 0 ? void 0 : _a.name) === node;
      }
      ts3.isRightSideOfPropertyAccess = isRightSideOfPropertyAccess;
      function isArgumentExpressionOfElementAccess(node) {
        var _a;
        return ((_a = ts3.tryCast(node.parent, ts3.isElementAccessExpression)) === null || _a === void 0 ? void 0 : _a.argumentExpression) === node;
      }
      ts3.isArgumentExpressionOfElementAccess = isArgumentExpressionOfElementAccess;
      function isNameOfModuleDeclaration(node) {
        var _a;
        return ((_a = ts3.tryCast(node.parent, ts3.isModuleDeclaration)) === null || _a === void 0 ? void 0 : _a.name) === node;
      }
      ts3.isNameOfModuleDeclaration = isNameOfModuleDeclaration;
      function isNameOfFunctionDeclaration(node) {
        var _a;
        return ts3.isIdentifier(node) && ((_a = ts3.tryCast(node.parent, ts3.isFunctionLike)) === null || _a === void 0 ? void 0 : _a.name) === node;
      }
      ts3.isNameOfFunctionDeclaration = isNameOfFunctionDeclaration;
      function isLiteralNameOfPropertyDeclarationOrIndexAccess(node) {
        switch (node.parent.kind) {
          case 167:
          case 166:
          case 296:
          case 299:
          case 169:
          case 168:
          case 172:
          case 173:
          case 261:
            return ts3.getNameOfDeclaration(node.parent) === node;
          case 207:
            return node.parent.argumentExpression === node;
          case 162:
            return true;
          case 196:
            return node.parent.parent.kind === 194;
          default:
            return false;
        }
      }
      ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess = isLiteralNameOfPropertyDeclarationOrIndexAccess;
      function isExpressionOfExternalModuleImportEqualsDeclaration(node) {
        return ts3.isExternalModuleImportEqualsDeclaration(node.parent.parent) && ts3.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node;
      }
      ts3.isExpressionOfExternalModuleImportEqualsDeclaration = isExpressionOfExternalModuleImportEqualsDeclaration;
      function getContainerNode(node) {
        if (ts3.isJSDocTypeAlias(node)) {
          node = node.parent.parent;
        }
        while (true) {
          node = node.parent;
          if (!node) {
            return void 0;
          }
          switch (node.kind) {
            case 305:
            case 169:
            case 168:
            case 256:
            case 213:
            case 172:
            case 173:
            case 257:
            case 258:
            case 260:
            case 261:
              return node;
          }
        }
      }
      ts3.getContainerNode = getContainerNode;
      function getNodeKind(node) {
        switch (node.kind) {
          case 305:
            return ts3.isExternalModule(node) ? "module" : "script";
          case 261:
            return "module";
          case 257:
          case 226:
            return "class";
          case 258:
            return "interface";
          case 259:
          case 338:
          case 345:
            return "type";
          case 260:
            return "enum";
          case 254:
            return getKindOfVariableDeclaration(node);
          case 203:
            return getKindOfVariableDeclaration(ts3.getRootDeclaration(node));
          case 214:
          case 256:
          case 213:
            return "function";
          case 172:
            return "getter";
          case 173:
            return "setter";
          case 169:
          case 168:
            return "method";
          case 296:
            var initializer = node.initializer;
            return ts3.isFunctionLike(initializer) ? "method" : "property";
          case 167:
          case 166:
          case 297:
          case 298:
            return "property";
          case 176:
            return "index";
          case 175:
            return "construct";
          case 174:
            return "call";
          case 171:
          case 170:
            return "constructor";
          case 163:
            return "type parameter";
          case 299:
            return "enum member";
          case 164:
            return ts3.hasSyntacticModifier(node, 16476) ? "property" : "parameter";
          case 265:
          case 270:
          case 275:
          case 268:
          case 274:
            return "alias";
          case 221:
            var kind = ts3.getAssignmentDeclarationKind(node);
            var right = node.right;
            switch (kind) {
              case 7:
              case 8:
              case 9:
              case 0:
                return "";
              case 1:
              case 2:
                var rightKind = getNodeKind(right);
                return rightKind === "" ? "const" : rightKind;
              case 3:
                return ts3.isFunctionExpression(right) ? "method" : "property";
              case 4:
                return "property";
              case 5:
                return ts3.isFunctionExpression(right) ? "method" : "property";
              case 6:
                return "local class";
              default: {
                ts3.assertType(kind);
                return "";
              }
            }
          case 79:
            return ts3.isImportClause(node.parent) ? "alias" : "";
          case 271:
            var scriptKind = getNodeKind(node.expression);
            return scriptKind === "" ? "const" : scriptKind;
          default:
            return "";
        }
        function getKindOfVariableDeclaration(v) {
          return ts3.isVarConst(v) ? "const" : ts3.isLet(v) ? "let" : "var";
        }
      }
      ts3.getNodeKind = getNodeKind;
      function isThis(node) {
        switch (node.kind) {
          case 108:
            return true;
          case 79:
            return ts3.identifierIsThisKeyword(node) && node.parent.kind === 164;
          default:
            return false;
        }
      }
      ts3.isThis = isThis;
      var tripleSlashDirectivePrefixRegex = /^\/\/\/\s*</;
      function getLineStartPositionForPosition(position, sourceFile) {
        var lineStarts = ts3.getLineStarts(sourceFile);
        var line = sourceFile.getLineAndCharacterOfPosition(position).line;
        return lineStarts[line];
      }
      ts3.getLineStartPositionForPosition = getLineStartPositionForPosition;
      function rangeContainsRange(r1, r2) {
        return startEndContainsRange(r1.pos, r1.end, r2);
      }
      ts3.rangeContainsRange = rangeContainsRange;
      function rangeContainsRangeExclusive(r1, r2) {
        return rangeContainsPositionExclusive(r1, r2.pos) && rangeContainsPositionExclusive(r1, r2.end);
      }
      ts3.rangeContainsRangeExclusive = rangeContainsRangeExclusive;
      function rangeContainsPosition(r, pos) {
        return r.pos <= pos && pos <= r.end;
      }
      ts3.rangeContainsPosition = rangeContainsPosition;
      function rangeContainsPositionExclusive(r, pos) {
        return r.pos < pos && pos < r.end;
      }
      ts3.rangeContainsPositionExclusive = rangeContainsPositionExclusive;
      function startEndContainsRange(start, end, range) {
        return start <= range.pos && end >= range.end;
      }
      ts3.startEndContainsRange = startEndContainsRange;
      function rangeContainsStartEnd(range, start, end) {
        return range.pos <= start && range.end >= end;
      }
      ts3.rangeContainsStartEnd = rangeContainsStartEnd;
      function rangeOverlapsWithStartEnd(r1, start, end) {
        return startEndOverlapsWithStartEnd(r1.pos, r1.end, start, end);
      }
      ts3.rangeOverlapsWithStartEnd = rangeOverlapsWithStartEnd;
      function nodeOverlapsWithStartEnd(node, sourceFile, start, end) {
        return startEndOverlapsWithStartEnd(node.getStart(sourceFile), node.end, start, end);
      }
      ts3.nodeOverlapsWithStartEnd = nodeOverlapsWithStartEnd;
      function startEndOverlapsWithStartEnd(start1, end1, start2, end2) {
        var start = Math.max(start1, start2);
        var end = Math.min(end1, end2);
        return start < end;
      }
      ts3.startEndOverlapsWithStartEnd = startEndOverlapsWithStartEnd;
      function positionBelongsToNode(candidate, position, sourceFile) {
        ts3.Debug.assert(candidate.pos <= position);
        return position < candidate.end || !isCompletedNode(candidate, sourceFile);
      }
      ts3.positionBelongsToNode = positionBelongsToNode;
      function isCompletedNode(n, sourceFile) {
        if (n === void 0 || ts3.nodeIsMissing(n)) {
          return false;
        }
        switch (n.kind) {
          case 257:
          case 258:
          case 260:
          case 205:
          case 201:
          case 182:
          case 235:
          case 262:
          case 263:
          case 269:
          case 273:
            return nodeEndsWith(n, 19, sourceFile);
          case 292:
            return isCompletedNode(n.block, sourceFile);
          case 209:
            if (!n.arguments) {
              return true;
            }
          case 208:
          case 212:
          case 191:
            return nodeEndsWith(n, 21, sourceFile);
          case 179:
          case 180:
            return isCompletedNode(n.type, sourceFile);
          case 171:
          case 172:
          case 173:
          case 256:
          case 213:
          case 169:
          case 168:
          case 175:
          case 174:
          case 214:
            if (n.body) {
              return isCompletedNode(n.body, sourceFile);
            }
            if (n.type) {
              return isCompletedNode(n.type, sourceFile);
            }
            return hasChildOfKind(n, 21, sourceFile);
          case 261:
            return !!n.body && isCompletedNode(n.body, sourceFile);
          case 239:
            if (n.elseStatement) {
              return isCompletedNode(n.elseStatement, sourceFile);
            }
            return isCompletedNode(n.thenStatement, sourceFile);
          case 238:
            return isCompletedNode(n.expression, sourceFile) || hasChildOfKind(n, 26, sourceFile);
          case 204:
          case 202:
          case 207:
          case 162:
          case 184:
            return nodeEndsWith(n, 23, sourceFile);
          case 176:
            if (n.type) {
              return isCompletedNode(n.type, sourceFile);
            }
            return hasChildOfKind(n, 23, sourceFile);
          case 289:
          case 290:
            return false;
          case 242:
          case 243:
          case 244:
          case 241:
            return isCompletedNode(n.statement, sourceFile);
          case 240:
            return hasChildOfKind(n, 115, sourceFile) ? nodeEndsWith(n, 21, sourceFile) : isCompletedNode(n.statement, sourceFile);
          case 181:
            return isCompletedNode(n.exprName, sourceFile);
          case 216:
          case 215:
          case 217:
          case 224:
          case 225:
            var unaryWordExpression = n;
            return isCompletedNode(unaryWordExpression.expression, sourceFile);
          case 210:
            return isCompletedNode(n.template, sourceFile);
          case 223:
            var lastSpan = ts3.lastOrUndefined(n.templateSpans);
            return isCompletedNode(lastSpan, sourceFile);
          case 233:
            return ts3.nodeIsPresent(n.literal);
          case 272:
          case 266:
            return ts3.nodeIsPresent(n.moduleSpecifier);
          case 219:
            return isCompletedNode(n.operand, sourceFile);
          case 221:
            return isCompletedNode(n.right, sourceFile);
          case 222:
            return isCompletedNode(n.whenFalse, sourceFile);
          default:
            return true;
        }
      }
      function nodeEndsWith(n, expectedLastToken, sourceFile) {
        var children = n.getChildren(sourceFile);
        if (children.length) {
          var lastChild = ts3.last(children);
          if (lastChild.kind === expectedLastToken) {
            return true;
          } else if (lastChild.kind === 26 && children.length !== 1) {
            return children[children.length - 2].kind === expectedLastToken;
          }
        }
        return false;
      }
      function findListItemInfo(node) {
        var list = findContainingList(node);
        if (!list) {
          return void 0;
        }
        var children = list.getChildren();
        var listItemIndex = ts3.indexOfNode(children, node);
        return {
          listItemIndex,
          list
        };
      }
      ts3.findListItemInfo = findListItemInfo;
      function hasChildOfKind(n, kind, sourceFile) {
        return !!findChildOfKind(n, kind, sourceFile);
      }
      ts3.hasChildOfKind = hasChildOfKind;
      function findChildOfKind(n, kind, sourceFile) {
        return ts3.find(n.getChildren(sourceFile), function(c) {
          return c.kind === kind;
        });
      }
      ts3.findChildOfKind = findChildOfKind;
      function findContainingList(node) {
        var syntaxList = ts3.find(node.parent.getChildren(), function(c) {
          return ts3.isSyntaxList(c) && rangeContainsRange(c, node);
        });
        ts3.Debug.assert(!syntaxList || ts3.contains(syntaxList.getChildren(), node));
        return syntaxList;
      }
      ts3.findContainingList = findContainingList;
      function isDefaultModifier(node) {
        return node.kind === 88;
      }
      function isClassKeyword(node) {
        return node.kind === 84;
      }
      function isFunctionKeyword(node) {
        return node.kind === 98;
      }
      function getAdjustedLocationForClass(node) {
        if (ts3.isNamedDeclaration(node)) {
          return node.name;
        }
        if (ts3.isClassDeclaration(node)) {
          var defaultModifier = node.modifiers && ts3.find(node.modifiers, isDefaultModifier);
          if (defaultModifier)
            return defaultModifier;
        }
        if (ts3.isClassExpression(node)) {
          var classKeyword = ts3.find(node.getChildren(), isClassKeyword);
          if (classKeyword)
            return classKeyword;
        }
      }
      function getAdjustedLocationForFunction(node) {
        if (ts3.isNamedDeclaration(node)) {
          return node.name;
        }
        if (ts3.isFunctionDeclaration(node)) {
          var defaultModifier = ts3.find(node.modifiers, isDefaultModifier);
          if (defaultModifier)
            return defaultModifier;
        }
        if (ts3.isFunctionExpression(node)) {
          var functionKeyword = ts3.find(node.getChildren(), isFunctionKeyword);
          if (functionKeyword)
            return functionKeyword;
        }
      }
      function getAncestorTypeNode(node) {
        var lastTypeNode;
        ts3.findAncestor(node, function(a) {
          if (ts3.isTypeNode(a)) {
            lastTypeNode = a;
          }
          return !ts3.isQualifiedName(a.parent) && !ts3.isTypeNode(a.parent) && !ts3.isTypeElement(a.parent);
        });
        return lastTypeNode;
      }
      function getContextualTypeFromParentOrAncestorTypeNode(node, checker) {
        var contextualType = getContextualTypeFromParent(node, checker);
        if (contextualType)
          return contextualType;
        var ancestorTypeNode = getAncestorTypeNode(node);
        return ancestorTypeNode && checker.getTypeAtLocation(ancestorTypeNode);
      }
      ts3.getContextualTypeFromParentOrAncestorTypeNode = getContextualTypeFromParentOrAncestorTypeNode;
      function getAdjustedLocationForDeclaration(node, forRename) {
        if (!forRename) {
          switch (node.kind) {
            case 257:
            case 226:
              return getAdjustedLocationForClass(node);
            case 256:
            case 213:
              return getAdjustedLocationForFunction(node);
          }
        }
        if (ts3.isNamedDeclaration(node)) {
          return node.name;
        }
      }
      function getAdjustedLocationForImportDeclaration(node, forRename) {
        if (node.importClause) {
          if (node.importClause.name && node.importClause.namedBindings) {
            return;
          }
          if (node.importClause.name) {
            return node.importClause.name;
          }
          if (node.importClause.namedBindings) {
            if (ts3.isNamedImports(node.importClause.namedBindings)) {
              var onlyBinding = ts3.singleOrUndefined(node.importClause.namedBindings.elements);
              if (!onlyBinding) {
                return;
              }
              return onlyBinding.name;
            } else if (ts3.isNamespaceImport(node.importClause.namedBindings)) {
              return node.importClause.namedBindings.name;
            }
          }
        }
        if (!forRename) {
          return node.moduleSpecifier;
        }
      }
      function getAdjustedLocationForExportDeclaration(node, forRename) {
        if (node.exportClause) {
          if (ts3.isNamedExports(node.exportClause)) {
            var onlyBinding = ts3.singleOrUndefined(node.exportClause.elements);
            if (!onlyBinding) {
              return;
            }
            return node.exportClause.elements[0].name;
          } else if (ts3.isNamespaceExport(node.exportClause)) {
            return node.exportClause.name;
          }
        }
        if (!forRename) {
          return node.moduleSpecifier;
        }
      }
      function getAdjustedLocationForHeritageClause(node) {
        if (node.types.length === 1) {
          return node.types[0].expression;
        }
      }
      function getAdjustedLocation(node, forRename) {
        var parent = node.parent;
        if (ts3.isModifier(node) && (forRename || node.kind !== 88) ? ts3.contains(parent.modifiers, node) : node.kind === 84 ? ts3.isClassDeclaration(parent) || ts3.isClassExpression(node) : node.kind === 98 ? ts3.isFunctionDeclaration(parent) || ts3.isFunctionExpression(node) : node.kind === 118 ? ts3.isInterfaceDeclaration(parent) : node.kind === 92 ? ts3.isEnumDeclaration(parent) : node.kind === 152 ? ts3.isTypeAliasDeclaration(parent) : node.kind === 142 || node.kind === 141 ? ts3.isModuleDeclaration(parent) : node.kind === 100 ? ts3.isImportEqualsDeclaration(parent) : node.kind === 136 ? ts3.isGetAccessorDeclaration(parent) : node.kind === 149 && ts3.isSetAccessorDeclaration(parent)) {
          var location = getAdjustedLocationForDeclaration(parent, forRename);
          if (location) {
            return location;
          }
        }
        if ((node.kind === 113 || node.kind === 85 || node.kind === 119) && ts3.isVariableDeclarationList(parent) && parent.declarations.length === 1) {
          var decl = parent.declarations[0];
          if (ts3.isIdentifier(decl.name)) {
            return decl.name;
          }
        }
        if (node.kind === 152) {
          if (ts3.isImportClause(parent) && parent.isTypeOnly) {
            var location = getAdjustedLocationForImportDeclaration(parent.parent, forRename);
            if (location) {
              return location;
            }
          }
          if (ts3.isExportDeclaration(parent) && parent.isTypeOnly) {
            var location = getAdjustedLocationForExportDeclaration(parent, forRename);
            if (location) {
              return location;
            }
          }
        }
        if (node.kind === 127) {
          if (ts3.isImportSpecifier(parent) && parent.propertyName || ts3.isExportSpecifier(parent) && parent.propertyName || ts3.isNamespaceImport(parent) || ts3.isNamespaceExport(parent)) {
            return parent.name;
          }
          if (ts3.isExportDeclaration(parent) && parent.exportClause && ts3.isNamespaceExport(parent.exportClause)) {
            return parent.exportClause.name;
          }
        }
        if (node.kind === 100 && ts3.isImportDeclaration(parent)) {
          var location = getAdjustedLocationForImportDeclaration(parent, forRename);
          if (location) {
            return location;
          }
        }
        if (node.kind === 93) {
          if (ts3.isExportDeclaration(parent)) {
            var location = getAdjustedLocationForExportDeclaration(parent, forRename);
            if (location) {
              return location;
            }
          }
          if (ts3.isExportAssignment(parent)) {
            return ts3.skipOuterExpressions(parent.expression);
          }
        }
        if (node.kind === 146 && ts3.isExternalModuleReference(parent)) {
          return parent.expression;
        }
        if (node.kind === 156 && (ts3.isImportDeclaration(parent) || ts3.isExportDeclaration(parent)) && parent.moduleSpecifier) {
          return parent.moduleSpecifier;
        }
        if ((node.kind === 94 || node.kind === 117) && ts3.isHeritageClause(parent) && parent.token === node.kind) {
          var location = getAdjustedLocationForHeritageClause(parent);
          if (location) {
            return location;
          }
        }
        if (node.kind === 94) {
          if (ts3.isTypeParameterDeclaration(parent) && parent.constraint && ts3.isTypeReferenceNode(parent.constraint)) {
            return parent.constraint.typeName;
          }
          if (ts3.isConditionalTypeNode(parent) && ts3.isTypeReferenceNode(parent.extendsType)) {
            return parent.extendsType.typeName;
          }
        }
        if (node.kind === 137 && ts3.isInferTypeNode(parent)) {
          return parent.typeParameter.name;
        }
        if (node.kind === 101 && ts3.isTypeParameterDeclaration(parent) && ts3.isMappedTypeNode(parent.parent)) {
          return parent.name;
        }
        if (node.kind === 140 && ts3.isTypeOperatorNode(parent) && parent.operator === 140 && ts3.isTypeReferenceNode(parent.type)) {
          return parent.type.typeName;
        }
        if (node.kind === 145 && ts3.isTypeOperatorNode(parent) && parent.operator === 145 && ts3.isArrayTypeNode(parent.type) && ts3.isTypeReferenceNode(parent.type.elementType)) {
          return parent.type.elementType.typeName;
        }
        if (!forRename) {
          if (node.kind === 103 && ts3.isNewExpression(parent) || node.kind === 114 && ts3.isVoidExpression(parent) || node.kind === 112 && ts3.isTypeOfExpression(parent) || node.kind === 132 && ts3.isAwaitExpression(parent) || node.kind === 125 && ts3.isYieldExpression(parent) || node.kind === 89 && ts3.isDeleteExpression(parent)) {
            if (parent.expression) {
              return ts3.skipOuterExpressions(parent.expression);
            }
          }
          if ((node.kind === 101 || node.kind === 102) && ts3.isBinaryExpression(parent) && parent.operatorToken === node) {
            return ts3.skipOuterExpressions(parent.right);
          }
          if (node.kind === 127 && ts3.isAsExpression(parent) && ts3.isTypeReferenceNode(parent.type)) {
            return parent.type.typeName;
          }
          if (node.kind === 101 && ts3.isForInStatement(parent) || node.kind === 160 && ts3.isForOfStatement(parent)) {
            return ts3.skipOuterExpressions(parent.expression);
          }
        }
        return node;
      }
      function getAdjustedReferenceLocation(node) {
        return getAdjustedLocation(node, false);
      }
      ts3.getAdjustedReferenceLocation = getAdjustedReferenceLocation;
      function getAdjustedRenameLocation(node) {
        return getAdjustedLocation(node, true);
      }
      ts3.getAdjustedRenameLocation = getAdjustedRenameLocation;
      function getTouchingPropertyName(sourceFile, position) {
        return getTouchingToken(sourceFile, position, function(n) {
          return ts3.isPropertyNameLiteral(n) || ts3.isKeyword(n.kind) || ts3.isPrivateIdentifier(n);
        });
      }
      ts3.getTouchingPropertyName = getTouchingPropertyName;
      function getTouchingToken(sourceFile, position, includePrecedingTokenAtEndPosition) {
        return getTokenAtPositionWorker(sourceFile, position, false, includePrecedingTokenAtEndPosition, false);
      }
      ts3.getTouchingToken = getTouchingToken;
      function getTokenAtPosition(sourceFile, position) {
        return getTokenAtPositionWorker(sourceFile, position, true, void 0, false);
      }
      ts3.getTokenAtPosition = getTokenAtPosition;
      function getTokenAtPositionWorker(sourceFile, position, allowPositionInLeadingTrivia, includePrecedingTokenAtEndPosition, includeEndPosition) {
        var current = sourceFile;
        var foundToken;
        var _loop_1 = function() {
          var children = current.getChildren(sourceFile);
          var i = ts3.binarySearchKey(children, position, function(_, i2) {
            return i2;
          }, function(middle, _) {
            var start = allowPositionInLeadingTrivia ? children[middle].getFullStart() : children[middle].getStart(sourceFile, true);
            if (start > position) {
              return 1;
            }
            if (nodeContainsPosition(children[middle])) {
              if (children[middle - 1]) {
                if (nodeContainsPosition(children[middle - 1])) {
                  return 1;
                }
              }
              return 0;
            }
            if (includePrecedingTokenAtEndPosition && start === position && children[middle - 1] && children[middle - 1].getEnd() === position && nodeContainsPosition(children[middle - 1])) {
              return 1;
            }
            return -1;
          });
          if (foundToken) {
            return { value: foundToken };
          }
          if (i >= 0 && children[i]) {
            current = children[i];
            return "continue-outer";
          }
          return { value: current };
        };
        outer:
          while (true) {
            var state_1 = _loop_1();
            if (typeof state_1 === "object")
              return state_1.value;
            switch (state_1) {
              case "continue-outer":
                continue outer;
            }
          }
        function nodeContainsPosition(node) {
          var start = allowPositionInLeadingTrivia ? node.getFullStart() : node.getStart(sourceFile, true);
          if (start > position) {
            return false;
          }
          var end = node.getEnd();
          if (position < end || position === end && (node.kind === 1 || includeEndPosition)) {
            return true;
          } else if (includePrecedingTokenAtEndPosition && end === position) {
            var previousToken = findPrecedingToken(position, sourceFile, node);
            if (previousToken && includePrecedingTokenAtEndPosition(previousToken)) {
              foundToken = previousToken;
              return true;
            }
          }
          return false;
        }
      }
      function findFirstNonJsxWhitespaceToken(sourceFile, position) {
        var tokenAtPosition = getTokenAtPosition(sourceFile, position);
        while (isWhiteSpaceOnlyJsxText(tokenAtPosition)) {
          var nextToken = findNextToken(tokenAtPosition, tokenAtPosition.parent, sourceFile);
          if (!nextToken)
            return;
          tokenAtPosition = nextToken;
        }
        return tokenAtPosition;
      }
      ts3.findFirstNonJsxWhitespaceToken = findFirstNonJsxWhitespaceToken;
      function findTokenOnLeftOfPosition(file, position) {
        var tokenAtPosition = getTokenAtPosition(file, position);
        if (ts3.isToken(tokenAtPosition) && position > tokenAtPosition.getStart(file) && position < tokenAtPosition.getEnd()) {
          return tokenAtPosition;
        }
        return findPrecedingToken(position, file);
      }
      ts3.findTokenOnLeftOfPosition = findTokenOnLeftOfPosition;
      function findNextToken(previousToken, parent, sourceFile) {
        return find(parent);
        function find(n) {
          if (ts3.isToken(n) && n.pos === previousToken.end) {
            return n;
          }
          return ts3.firstDefined(n.getChildren(sourceFile), function(child) {
            var shouldDiveInChildNode = child.pos <= previousToken.pos && child.end > previousToken.end || child.pos === previousToken.end;
            return shouldDiveInChildNode && nodeHasTokens(child, sourceFile) ? find(child) : void 0;
          });
        }
      }
      ts3.findNextToken = findNextToken;
      function findPrecedingToken(position, sourceFile, startNode, excludeJsdoc) {
        var result2 = find(startNode || sourceFile);
        ts3.Debug.assert(!(result2 && isWhiteSpaceOnlyJsxText(result2)));
        return result2;
        function find(n) {
          if (isNonWhitespaceToken(n) && n.kind !== 1) {
            return n;
          }
          var children = n.getChildren(sourceFile);
          var i = ts3.binarySearchKey(children, position, function(_, i2) {
            return i2;
          }, function(middle, _) {
            if (position < children[middle].end) {
              if (!children[middle - 1] || position >= children[middle - 1].end) {
                return 0;
              }
              return 1;
            }
            return -1;
          });
          if (i >= 0 && children[i]) {
            var child = children[i];
            if (position < child.end) {
              var start = child.getStart(sourceFile, !excludeJsdoc);
              var lookInPreviousChild = start >= position || !nodeHasTokens(child, sourceFile) || isWhiteSpaceOnlyJsxText(child);
              if (lookInPreviousChild) {
                var candidate_1 = findRightmostChildNodeWithTokens(children, i, sourceFile, n.kind);
                return candidate_1 && findRightmostToken(candidate_1, sourceFile);
              } else {
                return find(child);
              }
            }
          }
          ts3.Debug.assert(startNode !== void 0 || n.kind === 305 || n.kind === 1 || ts3.isJSDocCommentContainingNode(n));
          var candidate = findRightmostChildNodeWithTokens(children, children.length, sourceFile, n.kind);
          return candidate && findRightmostToken(candidate, sourceFile);
        }
      }
      ts3.findPrecedingToken = findPrecedingToken;
      function isNonWhitespaceToken(n) {
        return ts3.isToken(n) && !isWhiteSpaceOnlyJsxText(n);
      }
      function findRightmostToken(n, sourceFile) {
        if (isNonWhitespaceToken(n)) {
          return n;
        }
        var children = n.getChildren(sourceFile);
        if (children.length === 0) {
          return n;
        }
        var candidate = findRightmostChildNodeWithTokens(children, children.length, sourceFile, n.kind);
        return candidate && findRightmostToken(candidate, sourceFile);
      }
      function findRightmostChildNodeWithTokens(children, exclusiveStartPosition, sourceFile, parentKind) {
        for (var i = exclusiveStartPosition - 1; i >= 0; i--) {
          var child = children[i];
          if (isWhiteSpaceOnlyJsxText(child)) {
            if (i === 0 && (parentKind === 11 || parentKind === 279)) {
              ts3.Debug.fail("`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");
            }
          } else if (nodeHasTokens(children[i], sourceFile)) {
            return children[i];
          }
        }
      }
      function isInString(sourceFile, position, previousToken) {
        if (previousToken === void 0) {
          previousToken = findPrecedingToken(position, sourceFile);
        }
        if (previousToken && ts3.isStringTextContainingNode(previousToken)) {
          var start = previousToken.getStart(sourceFile);
          var end = previousToken.getEnd();
          if (start < position && position < end) {
            return true;
          }
          if (position === end) {
            return !!previousToken.isUnterminated;
          }
        }
        return false;
      }
      ts3.isInString = isInString;
      function isInsideJsxElementOrAttribute(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        if (!token) {
          return false;
        }
        if (token.kind === 11) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 11) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 288) {
          return true;
        }
        if (token && token.kind === 19 && token.parent.kind === 288) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 281) {
          return true;
        }
        return false;
      }
      ts3.isInsideJsxElementOrAttribute = isInsideJsxElementOrAttribute;
      function isWhiteSpaceOnlyJsxText(node) {
        return ts3.isJsxText(node) && node.containsOnlyTriviaWhiteSpaces;
      }
      function isInTemplateString(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        return ts3.isTemplateLiteralKind(token.kind) && position > token.getStart(sourceFile);
      }
      ts3.isInTemplateString = isInTemplateString;
      function isInJSXText(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        if (ts3.isJsxText(token)) {
          return true;
        }
        if (token.kind === 18 && ts3.isJsxExpression(token.parent) && ts3.isJsxElement(token.parent.parent)) {
          return true;
        }
        if (token.kind === 29 && ts3.isJsxOpeningLikeElement(token.parent) && ts3.isJsxElement(token.parent.parent)) {
          return true;
        }
        return false;
      }
      ts3.isInJSXText = isInJSXText;
      function isInsideJsxElement(sourceFile, position) {
        function isInsideJsxElementTraversal(node) {
          while (node) {
            if (node.kind >= 279 && node.kind <= 288 || node.kind === 11 || node.kind === 29 || node.kind === 31 || node.kind === 79 || node.kind === 19 || node.kind === 18 || node.kind === 43) {
              node = node.parent;
            } else if (node.kind === 278) {
              if (position > node.getStart(sourceFile))
                return true;
              node = node.parent;
            } else {
              return false;
            }
          }
          return false;
        }
        return isInsideJsxElementTraversal(getTokenAtPosition(sourceFile, position));
      }
      ts3.isInsideJsxElement = isInsideJsxElement;
      function findPrecedingMatchingToken(token, matchingTokenKind, sourceFile) {
        var closeTokenText = ts3.tokenToString(token.kind);
        var matchingTokenText = ts3.tokenToString(matchingTokenKind);
        var tokenFullStart = token.getFullStart();
        var bestGuessIndex = sourceFile.text.lastIndexOf(matchingTokenText, tokenFullStart);
        if (bestGuessIndex === -1) {
          return void 0;
        }
        if (sourceFile.text.lastIndexOf(closeTokenText, tokenFullStart - 1) < bestGuessIndex) {
          var nodeAtGuess = findPrecedingToken(bestGuessIndex + 1, sourceFile);
          if (nodeAtGuess && nodeAtGuess.kind === matchingTokenKind) {
            return nodeAtGuess;
          }
        }
        var tokenKind = token.kind;
        var remainingMatchingTokens = 0;
        while (true) {
          var preceding = findPrecedingToken(token.getFullStart(), sourceFile);
          if (!preceding) {
            return void 0;
          }
          token = preceding;
          if (token.kind === matchingTokenKind) {
            if (remainingMatchingTokens === 0) {
              return token;
            }
            remainingMatchingTokens--;
          } else if (token.kind === tokenKind) {
            remainingMatchingTokens++;
          }
        }
      }
      ts3.findPrecedingMatchingToken = findPrecedingMatchingToken;
      function removeOptionality(type2, isOptionalExpression, isOptionalChain) {
        return isOptionalExpression ? type2.getNonNullableType() : isOptionalChain ? type2.getNonOptionalType() : type2;
      }
      ts3.removeOptionality = removeOptionality;
      function isPossiblyTypeArgumentPosition(token, sourceFile, checker) {
        var info = getPossibleTypeArgumentsInfo(token, sourceFile);
        return info !== void 0 && (ts3.isPartOfTypeNode(info.called) || getPossibleGenericSignatures(info.called, info.nTypeArguments, checker).length !== 0 || isPossiblyTypeArgumentPosition(info.called, sourceFile, checker));
      }
      ts3.isPossiblyTypeArgumentPosition = isPossiblyTypeArgumentPosition;
      function getPossibleGenericSignatures(called, typeArgumentCount, checker) {
        var type2 = checker.getTypeAtLocation(called);
        if (ts3.isOptionalChain(called.parent)) {
          type2 = removeOptionality(type2, ts3.isOptionalChainRoot(called.parent), true);
        }
        var signatures = ts3.isNewExpression(called.parent) ? type2.getConstructSignatures() : type2.getCallSignatures();
        return signatures.filter(function(candidate) {
          return !!candidate.typeParameters && candidate.typeParameters.length >= typeArgumentCount;
        });
      }
      ts3.getPossibleGenericSignatures = getPossibleGenericSignatures;
      function getPossibleTypeArgumentsInfo(tokenIn, sourceFile) {
        if (sourceFile.text.lastIndexOf("<", tokenIn ? tokenIn.pos : sourceFile.text.length) === -1) {
          return void 0;
        }
        var token = tokenIn;
        var remainingLessThanTokens = 0;
        var nTypeArguments = 0;
        while (token) {
          switch (token.kind) {
            case 29:
              token = findPrecedingToken(token.getFullStart(), sourceFile);
              if (token && token.kind === 28) {
                token = findPrecedingToken(token.getFullStart(), sourceFile);
              }
              if (!token || !ts3.isIdentifier(token))
                return void 0;
              if (!remainingLessThanTokens) {
                return ts3.isDeclarationName(token) ? void 0 : { called: token, nTypeArguments };
              }
              remainingLessThanTokens--;
              break;
            case 49:
              remainingLessThanTokens = 3;
              break;
            case 48:
              remainingLessThanTokens = 2;
              break;
            case 31:
              remainingLessThanTokens++;
              break;
            case 19:
              token = findPrecedingMatchingToken(token, 18, sourceFile);
              if (!token)
                return void 0;
              break;
            case 21:
              token = findPrecedingMatchingToken(token, 20, sourceFile);
              if (!token)
                return void 0;
              break;
            case 23:
              token = findPrecedingMatchingToken(token, 22, sourceFile);
              if (!token)
                return void 0;
              break;
            case 27:
              nTypeArguments++;
              break;
            case 38:
            case 79:
            case 10:
            case 8:
            case 9:
            case 110:
            case 95:
            case 112:
            case 94:
            case 140:
            case 24:
            case 51:
            case 57:
            case 58:
              break;
            default:
              if (ts3.isTypeNode(token)) {
                break;
              }
              return void 0;
          }
          token = findPrecedingToken(token.getFullStart(), sourceFile);
        }
        return void 0;
      }
      ts3.getPossibleTypeArgumentsInfo = getPossibleTypeArgumentsInfo;
      function isInComment(sourceFile, position, tokenAtPosition) {
        return ts3.formatting.getRangeOfEnclosingComment(sourceFile, position, void 0, tokenAtPosition);
      }
      ts3.isInComment = isInComment;
      function hasDocComment(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        return !!ts3.findAncestor(token, ts3.isJSDoc);
      }
      ts3.hasDocComment = hasDocComment;
      function nodeHasTokens(n, sourceFile) {
        return n.kind === 1 ? !!n.jsDoc : n.getWidth(sourceFile) !== 0;
      }
      function getNodeModifiers(node, excludeFlags) {
        if (excludeFlags === void 0) {
          excludeFlags = 0;
        }
        var result2 = [];
        var flags = ts3.isDeclaration(node) ? ts3.getCombinedNodeFlagsAlwaysIncludeJSDoc(node) & ~excludeFlags : 0;
        if (flags & 8)
          result2.push("private");
        if (flags & 16)
          result2.push("protected");
        if (flags & 4)
          result2.push("public");
        if (flags & 32 || ts3.isClassStaticBlockDeclaration(node))
          result2.push("static");
        if (flags & 128)
          result2.push("abstract");
        if (flags & 1)
          result2.push("export");
        if (flags & 8192)
          result2.push("deprecated");
        if (node.flags & 16777216)
          result2.push("declare");
        if (node.kind === 271)
          result2.push("export");
        return result2.length > 0 ? result2.join(",") : "";
      }
      ts3.getNodeModifiers = getNodeModifiers;
      function getTypeArgumentOrTypeParameterList(node) {
        if (node.kind === 178 || node.kind === 208) {
          return node.typeArguments;
        }
        if (ts3.isFunctionLike(node) || node.kind === 257 || node.kind === 258) {
          return node.typeParameters;
        }
        return void 0;
      }
      ts3.getTypeArgumentOrTypeParameterList = getTypeArgumentOrTypeParameterList;
      function isComment(kind) {
        return kind === 2 || kind === 3;
      }
      ts3.isComment = isComment;
      function isStringOrRegularExpressionOrTemplateLiteral(kind) {
        if (kind === 10 || kind === 13 || ts3.isTemplateLiteralKind(kind)) {
          return true;
        }
        return false;
      }
      ts3.isStringOrRegularExpressionOrTemplateLiteral = isStringOrRegularExpressionOrTemplateLiteral;
      function isPunctuation(kind) {
        return 18 <= kind && kind <= 78;
      }
      ts3.isPunctuation = isPunctuation;
      function isInsideTemplateLiteral(node, position, sourceFile) {
        return ts3.isTemplateLiteralKind(node.kind) && (node.getStart(sourceFile) < position && position < node.end) || !!node.isUnterminated && position === node.end;
      }
      ts3.isInsideTemplateLiteral = isInsideTemplateLiteral;
      function isAccessibilityModifier(kind) {
        switch (kind) {
          case 123:
          case 121:
          case 122:
            return true;
        }
        return false;
      }
      ts3.isAccessibilityModifier = isAccessibilityModifier;
      function cloneCompilerOptions(options) {
        var result2 = ts3.clone(options);
        ts3.setConfigFileInOptions(result2, options && options.configFile);
        return result2;
      }
      ts3.cloneCompilerOptions = cloneCompilerOptions;
      function isArrayLiteralOrObjectLiteralDestructuringPattern(node) {
        if (node.kind === 204 || node.kind === 205) {
          if (node.parent.kind === 221 && node.parent.left === node && node.parent.operatorToken.kind === 63) {
            return true;
          }
          if (node.parent.kind === 244 && node.parent.initializer === node) {
            return true;
          }
          if (isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.kind === 296 ? node.parent.parent : node.parent)) {
            return true;
          }
        }
        return false;
      }
      ts3.isArrayLiteralOrObjectLiteralDestructuringPattern = isArrayLiteralOrObjectLiteralDestructuringPattern;
      function isInReferenceComment(sourceFile, position) {
        return isInReferenceCommentWorker(sourceFile, position, true);
      }
      ts3.isInReferenceComment = isInReferenceComment;
      function isInNonReferenceComment(sourceFile, position) {
        return isInReferenceCommentWorker(sourceFile, position, false);
      }
      ts3.isInNonReferenceComment = isInNonReferenceComment;
      function isInReferenceCommentWorker(sourceFile, position, shouldBeReference) {
        var range = isInComment(sourceFile, position, void 0);
        return !!range && shouldBeReference === tripleSlashDirectivePrefixRegex.test(sourceFile.text.substring(range.pos, range.end));
      }
      function getReplacementSpanForContextToken(contextToken) {
        if (!contextToken)
          return void 0;
        switch (contextToken.kind) {
          case 10:
          case 14:
            return createTextSpanFromStringLiteralLikeContent(contextToken);
          default:
            return createTextSpanFromNode(contextToken);
        }
      }
      ts3.getReplacementSpanForContextToken = getReplacementSpanForContextToken;
      function createTextSpanFromNode(node, sourceFile, endNode) {
        return ts3.createTextSpanFromBounds(node.getStart(sourceFile), (endNode || node).getEnd());
      }
      ts3.createTextSpanFromNode = createTextSpanFromNode;
      function createTextSpanFromStringLiteralLikeContent(node) {
        if (node.isUnterminated)
          return void 0;
        return ts3.createTextSpanFromBounds(node.getStart() + 1, node.getEnd() - 1);
      }
      ts3.createTextSpanFromStringLiteralLikeContent = createTextSpanFromStringLiteralLikeContent;
      function createTextRangeFromNode(node, sourceFile) {
        return ts3.createRange(node.getStart(sourceFile), node.end);
      }
      ts3.createTextRangeFromNode = createTextRangeFromNode;
      function createTextSpanFromRange(range) {
        return ts3.createTextSpanFromBounds(range.pos, range.end);
      }
      ts3.createTextSpanFromRange = createTextSpanFromRange;
      function createTextRangeFromSpan(span) {
        return ts3.createRange(span.start, span.start + span.length);
      }
      ts3.createTextRangeFromSpan = createTextRangeFromSpan;
      function createTextChangeFromStartLength(start, length, newText) {
        return createTextChange(ts3.createTextSpan(start, length), newText);
      }
      ts3.createTextChangeFromStartLength = createTextChangeFromStartLength;
      function createTextChange(span, newText) {
        return { span, newText };
      }
      ts3.createTextChange = createTextChange;
      ts3.typeKeywords = [
        130,
        128,
        158,
        133,
        95,
        137,
        140,
        143,
        104,
        147,
        148,
        145,
        150,
        151,
        110,
        114,
        153,
        154,
        155
      ];
      function isTypeKeyword(kind) {
        return ts3.contains(ts3.typeKeywords, kind);
      }
      ts3.isTypeKeyword = isTypeKeyword;
      function isTypeKeywordToken(node) {
        return node.kind === 152;
      }
      ts3.isTypeKeywordToken = isTypeKeywordToken;
      function isTypeKeywordTokenOrIdentifier(node) {
        return isTypeKeywordToken(node) || ts3.isIdentifier(node) && node.text === "type";
      }
      ts3.isTypeKeywordTokenOrIdentifier = isTypeKeywordTokenOrIdentifier;
      function isExternalModuleSymbol(moduleSymbol) {
        return !!(moduleSymbol.flags & 1536) && moduleSymbol.name.charCodeAt(0) === 34;
      }
      ts3.isExternalModuleSymbol = isExternalModuleSymbol;
      function nodeSeenTracker() {
        var seen = [];
        return function(node) {
          var id = ts3.getNodeId(node);
          return !seen[id] && (seen[id] = true);
        };
      }
      ts3.nodeSeenTracker = nodeSeenTracker;
      function getSnapshotText(snap) {
        return snap.getText(0, snap.getLength());
      }
      ts3.getSnapshotText = getSnapshotText;
      function repeatString(str2, count) {
        var result2 = "";
        for (var i = 0; i < count; i++) {
          result2 += str2;
        }
        return result2;
      }
      ts3.repeatString = repeatString;
      function skipConstraint(type2) {
        return type2.isTypeParameter() ? type2.getConstraint() || type2 : type2;
      }
      ts3.skipConstraint = skipConstraint;
      function getNameFromPropertyName(name) {
        return name.kind === 162 ? ts3.isStringOrNumericLiteralLike(name.expression) ? name.expression.text : void 0 : ts3.isPrivateIdentifier(name) ? ts3.idText(name) : ts3.getTextOfIdentifierOrLiteral(name);
      }
      ts3.getNameFromPropertyName = getNameFromPropertyName;
      function programContainsModules(program2) {
        return program2.getSourceFiles().some(function(s) {
          return !s.isDeclarationFile && !program2.isSourceFileFromExternalLibrary(s) && !!(s.externalModuleIndicator || s.commonJsModuleIndicator);
        });
      }
      ts3.programContainsModules = programContainsModules;
      function programContainsEsModules(program2) {
        return program2.getSourceFiles().some(function(s) {
          return !s.isDeclarationFile && !program2.isSourceFileFromExternalLibrary(s) && !!s.externalModuleIndicator;
        });
      }
      ts3.programContainsEsModules = programContainsEsModules;
      function compilerOptionsIndicateEsModules(compilerOptions) {
        return !!compilerOptions.module || ts3.getEmitScriptTarget(compilerOptions) >= 2 || !!compilerOptions.noEmit;
      }
      ts3.compilerOptionsIndicateEsModules = compilerOptionsIndicateEsModules;
      function createModuleSpecifierResolutionHost(program2, host) {
        return {
          fileExists: function(fileName2) {
            return program2.fileExists(fileName2);
          },
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          readFile: ts3.maybeBind(host, host.readFile),
          useCaseSensitiveFileNames: ts3.maybeBind(host, host.useCaseSensitiveFileNames),
          getSymlinkCache: ts3.maybeBind(host, host.getSymlinkCache) || program2.getSymlinkCache,
          getModuleSpecifierCache: ts3.maybeBind(host, host.getModuleSpecifierCache),
          getPackageJsonInfoCache: function() {
            var _a;
            return (_a = program2.getModuleResolutionCache()) === null || _a === void 0 ? void 0 : _a.getPackageJsonInfoCache();
          },
          getGlobalTypingsCacheLocation: ts3.maybeBind(host, host.getGlobalTypingsCacheLocation),
          redirectTargetsMap: program2.redirectTargetsMap,
          getProjectReferenceRedirect: function(fileName2) {
            return program2.getProjectReferenceRedirect(fileName2);
          },
          isSourceOfProjectReferenceRedirect: function(fileName2) {
            return program2.isSourceOfProjectReferenceRedirect(fileName2);
          },
          getNearestAncestorDirectoryWithPackageJson: ts3.maybeBind(host, host.getNearestAncestorDirectoryWithPackageJson),
          getFileIncludeReasons: function() {
            return program2.getFileIncludeReasons();
          }
        };
      }
      ts3.createModuleSpecifierResolutionHost = createModuleSpecifierResolutionHost;
      function getModuleSpecifierResolverHost(program2, host) {
        return __assign(__assign({}, createModuleSpecifierResolutionHost(program2, host)), { getCommonSourceDirectory: function() {
          return program2.getCommonSourceDirectory();
        } });
      }
      ts3.getModuleSpecifierResolverHost = getModuleSpecifierResolverHost;
      function moduleResolutionRespectsExports(moduleResolution) {
        return moduleResolution >= ts3.ModuleResolutionKind.Node16 && moduleResolution <= ts3.ModuleResolutionKind.NodeNext;
      }
      ts3.moduleResolutionRespectsExports = moduleResolutionRespectsExports;
      function moduleResolutionUsesNodeModules(moduleResolution) {
        return moduleResolution === ts3.ModuleResolutionKind.NodeJs || moduleResolution >= ts3.ModuleResolutionKind.Node16 && moduleResolution <= ts3.ModuleResolutionKind.NodeNext;
      }
      ts3.moduleResolutionUsesNodeModules = moduleResolutionUsesNodeModules;
      function makeImportIfNecessary(defaultImport, namedImports, moduleSpecifier, quotePreference) {
        return defaultImport || namedImports && namedImports.length ? makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference) : void 0;
      }
      ts3.makeImportIfNecessary = makeImportIfNecessary;
      function makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference, isTypeOnly) {
        return ts3.factory.createImportDeclaration(void 0, void 0, defaultImport || namedImports ? ts3.factory.createImportClause(!!isTypeOnly, defaultImport, namedImports && namedImports.length ? ts3.factory.createNamedImports(namedImports) : void 0) : void 0, typeof moduleSpecifier === "string" ? makeStringLiteral(moduleSpecifier, quotePreference) : moduleSpecifier, void 0);
      }
      ts3.makeImport = makeImport;
      function makeStringLiteral(text, quotePreference) {
        return ts3.factory.createStringLiteral(text, quotePreference === 0);
      }
      ts3.makeStringLiteral = makeStringLiteral;
      var QuotePreference;
      (function(QuotePreference2) {
        QuotePreference2[QuotePreference2["Single"] = 0] = "Single";
        QuotePreference2[QuotePreference2["Double"] = 1] = "Double";
      })(QuotePreference = ts3.QuotePreference || (ts3.QuotePreference = {}));
      function quotePreferenceFromString(str2, sourceFile) {
        return ts3.isStringDoubleQuoted(str2, sourceFile) ? 1 : 0;
      }
      ts3.quotePreferenceFromString = quotePreferenceFromString;
      function getQuotePreference(sourceFile, preferences) {
        if (preferences.quotePreference && preferences.quotePreference !== "auto") {
          return preferences.quotePreference === "single" ? 0 : 1;
        } else {
          var firstModuleSpecifier = sourceFile.imports && ts3.find(sourceFile.imports, function(n) {
            return ts3.isStringLiteral(n) && !ts3.nodeIsSynthesized(n.parent);
          });
          return firstModuleSpecifier ? quotePreferenceFromString(firstModuleSpecifier, sourceFile) : 1;
        }
      }
      ts3.getQuotePreference = getQuotePreference;
      function getQuoteFromPreference(qp) {
        switch (qp) {
          case 0:
            return "'";
          case 1:
            return '"';
          default:
            return ts3.Debug.assertNever(qp);
        }
      }
      ts3.getQuoteFromPreference = getQuoteFromPreference;
      function symbolNameNoDefault(symbol) {
        var escaped = symbolEscapedNameNoDefault(symbol);
        return escaped === void 0 ? void 0 : ts3.unescapeLeadingUnderscores(escaped);
      }
      ts3.symbolNameNoDefault = symbolNameNoDefault;
      function symbolEscapedNameNoDefault(symbol) {
        if (symbol.escapedName !== "default") {
          return symbol.escapedName;
        }
        return ts3.firstDefined(symbol.declarations, function(decl) {
          var name = ts3.getNameOfDeclaration(decl);
          return name && name.kind === 79 ? name.escapedText : void 0;
        });
      }
      ts3.symbolEscapedNameNoDefault = symbolEscapedNameNoDefault;
      function isModuleSpecifierLike(node) {
        return ts3.isStringLiteralLike(node) && (ts3.isExternalModuleReference(node.parent) || ts3.isImportDeclaration(node.parent) || ts3.isRequireCall(node.parent, false) && node.parent.arguments[0] === node || ts3.isImportCall(node.parent) && node.parent.arguments[0] === node);
      }
      ts3.isModuleSpecifierLike = isModuleSpecifierLike;
      function isObjectBindingElementWithoutPropertyName(bindingElement) {
        return ts3.isBindingElement(bindingElement) && ts3.isObjectBindingPattern(bindingElement.parent) && ts3.isIdentifier(bindingElement.name) && !bindingElement.propertyName;
      }
      ts3.isObjectBindingElementWithoutPropertyName = isObjectBindingElementWithoutPropertyName;
      function getPropertySymbolFromBindingElement(checker, bindingElement) {
        var typeOfPattern = checker.getTypeAtLocation(bindingElement.parent);
        return typeOfPattern && checker.getPropertyOfType(typeOfPattern, bindingElement.name.text);
      }
      ts3.getPropertySymbolFromBindingElement = getPropertySymbolFromBindingElement;
      function getParentNodeInSpan(node, file, span) {
        if (!node)
          return void 0;
        while (node.parent) {
          if (ts3.isSourceFile(node.parent) || !spanContainsNode(span, node.parent, file)) {
            return node;
          }
          node = node.parent;
        }
      }
      ts3.getParentNodeInSpan = getParentNodeInSpan;
      function spanContainsNode(span, node, file) {
        return ts3.textSpanContainsPosition(span, node.getStart(file)) && node.getEnd() <= ts3.textSpanEnd(span);
      }
      function findModifier(node, kind) {
        return node.modifiers && ts3.find(node.modifiers, function(m) {
          return m.kind === kind;
        });
      }
      ts3.findModifier = findModifier;
      function insertImports(changes, sourceFile, imports, blankLineBetween) {
        var decl = ts3.isArray(imports) ? imports[0] : imports;
        var importKindPredicate = decl.kind === 237 ? ts3.isRequireVariableStatement : ts3.isAnyImportSyntax;
        var existingImportStatements = ts3.filter(sourceFile.statements, importKindPredicate);
        var sortedNewImports = ts3.isArray(imports) ? ts3.stableSort(imports, ts3.OrganizeImports.compareImportsOrRequireStatements) : [imports];
        if (!existingImportStatements.length) {
          changes.insertNodesAtTopOfFile(sourceFile, sortedNewImports, blankLineBetween);
        } else if (existingImportStatements && ts3.OrganizeImports.importsAreSorted(existingImportStatements)) {
          for (var _i = 0, sortedNewImports_1 = sortedNewImports; _i < sortedNewImports_1.length; _i++) {
            var newImport = sortedNewImports_1[_i];
            var insertionIndex = ts3.OrganizeImports.getImportDeclarationInsertionIndex(existingImportStatements, newImport);
            if (insertionIndex === 0) {
              var options = existingImportStatements[0] === sourceFile.statements[0] ? { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude } : {};
              changes.insertNodeBefore(sourceFile, existingImportStatements[0], newImport, false, options);
            } else {
              var prevImport = existingImportStatements[insertionIndex - 1];
              changes.insertNodeAfter(sourceFile, prevImport, newImport);
            }
          }
        } else {
          var lastExistingImport = ts3.lastOrUndefined(existingImportStatements);
          if (lastExistingImport) {
            changes.insertNodesAfter(sourceFile, lastExistingImport, sortedNewImports);
          } else {
            changes.insertNodesAtTopOfFile(sourceFile, sortedNewImports, blankLineBetween);
          }
        }
      }
      ts3.insertImports = insertImports;
      function getTypeKeywordOfTypeOnlyImport(importClause, sourceFile) {
        ts3.Debug.assert(importClause.isTypeOnly);
        return ts3.cast(importClause.getChildAt(0, sourceFile), isTypeKeywordToken);
      }
      ts3.getTypeKeywordOfTypeOnlyImport = getTypeKeywordOfTypeOnlyImport;
      function textSpansEqual(a, b) {
        return !!a && !!b && a.start === b.start && a.length === b.length;
      }
      ts3.textSpansEqual = textSpansEqual;
      function documentSpansEqual(a, b) {
        return a.fileName === b.fileName && textSpansEqual(a.textSpan, b.textSpan);
      }
      ts3.documentSpansEqual = documentSpansEqual;
      function forEachUnique(array, callback) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            if (array.indexOf(array[i]) === i) {
              var result2 = callback(array[i], i);
              if (result2) {
                return result2;
              }
            }
          }
        }
        return void 0;
      }
      ts3.forEachUnique = forEachUnique;
      function isTextWhiteSpaceLike(text, startPos, endPos) {
        for (var i = startPos; i < endPos; i++) {
          if (!ts3.isWhiteSpaceLike(text.charCodeAt(i))) {
            return false;
          }
        }
        return true;
      }
      ts3.isTextWhiteSpaceLike = isTextWhiteSpaceLike;
      function isFirstDeclarationOfSymbolParameter(symbol) {
        var declaration = symbol.declarations ? ts3.firstOrUndefined(symbol.declarations) : void 0;
        return !!ts3.findAncestor(declaration, function(n) {
          return ts3.isParameter(n) ? true : ts3.isBindingElement(n) || ts3.isObjectBindingPattern(n) || ts3.isArrayBindingPattern(n) ? false : "quit";
        });
      }
      ts3.isFirstDeclarationOfSymbolParameter = isFirstDeclarationOfSymbolParameter;
      var displayPartWriter = getDisplayPartWriter();
      function getDisplayPartWriter() {
        var absoluteMaximumLength = ts3.defaultMaximumTruncationLength * 10;
        var displayParts;
        var lineStart;
        var indent;
        var length;
        resetWriter();
        var unknownWrite = function(text) {
          return writeKind(text, ts3.SymbolDisplayPartKind.text);
        };
        return {
          displayParts: function() {
            var finalText = displayParts.length && displayParts[displayParts.length - 1].text;
            if (length > absoluteMaximumLength && finalText && finalText !== "...") {
              if (!ts3.isWhiteSpaceLike(finalText.charCodeAt(finalText.length - 1))) {
                displayParts.push(displayPart(" ", ts3.SymbolDisplayPartKind.space));
              }
              displayParts.push(displayPart("...", ts3.SymbolDisplayPartKind.punctuation));
            }
            return displayParts;
          },
          writeKeyword: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.keyword);
          },
          writeOperator: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.operator);
          },
          writePunctuation: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.punctuation);
          },
          writeTrailingSemicolon: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.punctuation);
          },
          writeSpace: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.space);
          },
          writeStringLiteral: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.stringLiteral);
          },
          writeParameter: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.parameterName);
          },
          writeProperty: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.propertyName);
          },
          writeLiteral: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.stringLiteral);
          },
          writeSymbol,
          writeLine,
          write: unknownWrite,
          writeComment: unknownWrite,
          getText: function() {
            return "";
          },
          getTextPos: function() {
            return 0;
          },
          getColumn: function() {
            return 0;
          },
          getLine: function() {
            return 0;
          },
          isAtStartOfLine: function() {
            return false;
          },
          hasTrailingWhitespace: function() {
            return false;
          },
          hasTrailingComment: function() {
            return false;
          },
          rawWrite: ts3.notImplemented,
          getIndent: function() {
            return indent;
          },
          increaseIndent: function() {
            indent++;
          },
          decreaseIndent: function() {
            indent--;
          },
          clear: resetWriter,
          trackSymbol: function() {
            return false;
          },
          reportInaccessibleThisError: ts3.noop,
          reportInaccessibleUniqueSymbolError: ts3.noop,
          reportPrivateInBaseOfClassExpression: ts3.noop
        };
        function writeIndent() {
          if (length > absoluteMaximumLength)
            return;
          if (lineStart) {
            var indentString2 = ts3.getIndentString(indent);
            if (indentString2) {
              length += indentString2.length;
              displayParts.push(displayPart(indentString2, ts3.SymbolDisplayPartKind.space));
            }
            lineStart = false;
          }
        }
        function writeKind(text, kind) {
          if (length > absoluteMaximumLength)
            return;
          writeIndent();
          length += text.length;
          displayParts.push(displayPart(text, kind));
        }
        function writeSymbol(text, symbol) {
          if (length > absoluteMaximumLength)
            return;
          writeIndent();
          length += text.length;
          displayParts.push(symbolPart(text, symbol));
        }
        function writeLine() {
          if (length > absoluteMaximumLength)
            return;
          length += 1;
          displayParts.push(lineBreakPart());
          lineStart = true;
        }
        function resetWriter() {
          displayParts = [];
          lineStart = true;
          indent = 0;
          length = 0;
        }
      }
      function symbolPart(text, symbol) {
        return displayPart(text, displayPartKind(symbol));
        function displayPartKind(symbol2) {
          var flags = symbol2.flags;
          if (flags & 3) {
            return isFirstDeclarationOfSymbolParameter(symbol2) ? ts3.SymbolDisplayPartKind.parameterName : ts3.SymbolDisplayPartKind.localName;
          }
          if (flags & 4)
            return ts3.SymbolDisplayPartKind.propertyName;
          if (flags & 32768)
            return ts3.SymbolDisplayPartKind.propertyName;
          if (flags & 65536)
            return ts3.SymbolDisplayPartKind.propertyName;
          if (flags & 8)
            return ts3.SymbolDisplayPartKind.enumMemberName;
          if (flags & 16)
            return ts3.SymbolDisplayPartKind.functionName;
          if (flags & 32)
            return ts3.SymbolDisplayPartKind.className;
          if (flags & 64)
            return ts3.SymbolDisplayPartKind.interfaceName;
          if (flags & 384)
            return ts3.SymbolDisplayPartKind.enumName;
          if (flags & 1536)
            return ts3.SymbolDisplayPartKind.moduleName;
          if (flags & 8192)
            return ts3.SymbolDisplayPartKind.methodName;
          if (flags & 262144)
            return ts3.SymbolDisplayPartKind.typeParameterName;
          if (flags & 524288)
            return ts3.SymbolDisplayPartKind.aliasName;
          if (flags & 2097152)
            return ts3.SymbolDisplayPartKind.aliasName;
          return ts3.SymbolDisplayPartKind.text;
        }
      }
      ts3.symbolPart = symbolPart;
      function displayPart(text, kind) {
        return { text, kind: ts3.SymbolDisplayPartKind[kind] };
      }
      ts3.displayPart = displayPart;
      function spacePart() {
        return displayPart(" ", ts3.SymbolDisplayPartKind.space);
      }
      ts3.spacePart = spacePart;
      function keywordPart(kind) {
        return displayPart(ts3.tokenToString(kind), ts3.SymbolDisplayPartKind.keyword);
      }
      ts3.keywordPart = keywordPart;
      function punctuationPart(kind) {
        return displayPart(ts3.tokenToString(kind), ts3.SymbolDisplayPartKind.punctuation);
      }
      ts3.punctuationPart = punctuationPart;
      function operatorPart(kind) {
        return displayPart(ts3.tokenToString(kind), ts3.SymbolDisplayPartKind.operator);
      }
      ts3.operatorPart = operatorPart;
      function parameterNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.parameterName);
      }
      ts3.parameterNamePart = parameterNamePart;
      function propertyNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.propertyName);
      }
      ts3.propertyNamePart = propertyNamePart;
      function textOrKeywordPart(text) {
        var kind = ts3.stringToToken(text);
        return kind === void 0 ? textPart(text) : keywordPart(kind);
      }
      ts3.textOrKeywordPart = textOrKeywordPart;
      function textPart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.text);
      }
      ts3.textPart = textPart;
      function typeAliasNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.aliasName);
      }
      ts3.typeAliasNamePart = typeAliasNamePart;
      function typeParameterNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.typeParameterName);
      }
      ts3.typeParameterNamePart = typeParameterNamePart;
      function linkTextPart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.linkText);
      }
      ts3.linkTextPart = linkTextPart;
      function linkNamePart(text, target) {
        return {
          text,
          kind: ts3.SymbolDisplayPartKind[ts3.SymbolDisplayPartKind.linkName],
          target: {
            fileName: ts3.getSourceFileOfNode(target).fileName,
            textSpan: createTextSpanFromNode(target)
          }
        };
      }
      ts3.linkNamePart = linkNamePart;
      function linkPart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.link);
      }
      ts3.linkPart = linkPart;
      function buildLinkParts(link, checker) {
        var _a;
        var prefix = ts3.isJSDocLink(link) ? "link" : ts3.isJSDocLinkCode(link) ? "linkcode" : "linkplain";
        var parts = [linkPart("{@".concat(prefix, " "))];
        if (!link.name) {
          if (link.text) {
            parts.push(linkTextPart(link.text));
          }
        } else {
          var symbol = checker === null || checker === void 0 ? void 0 : checker.getSymbolAtLocation(link.name);
          var suffix = findLinkNameEnd(link.text);
          var name = ts3.getTextOfNode(link.name) + link.text.slice(0, suffix);
          var text = skipSeparatorFromLinkText(link.text.slice(suffix));
          var decl = (symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration) || ((_a = symbol === null || symbol === void 0 ? void 0 : symbol.declarations) === null || _a === void 0 ? void 0 : _a[0]);
          if (decl) {
            parts.push(linkNamePart(name, decl));
            if (text)
              parts.push(linkTextPart(text));
          } else {
            parts.push(linkTextPart(name + (suffix || text.indexOf("://") === 0 ? "" : " ") + text));
          }
        }
        parts.push(linkPart("}"));
        return parts;
      }
      ts3.buildLinkParts = buildLinkParts;
      function skipSeparatorFromLinkText(text) {
        var pos = 0;
        if (text.charCodeAt(pos++) === 124) {
          while (pos < text.length && text.charCodeAt(pos) === 32)
            pos++;
          return text.slice(pos);
        }
        return text;
      }
      function findLinkNameEnd(text) {
        if (text.indexOf("()") === 0)
          return 2;
        if (text[0] !== "<")
          return 0;
        var brackets = 0;
        var i = 0;
        while (i < text.length) {
          if (text[i] === "<")
            brackets++;
          if (text[i] === ">")
            brackets--;
          i++;
          if (!brackets)
            return i;
        }
        return 0;
      }
      var carriageReturnLineFeed = "\r\n";
      function getNewLineOrDefaultFromHost(host, formatSettings) {
        var _a;
        return (formatSettings === null || formatSettings === void 0 ? void 0 : formatSettings.newLineCharacter) || ((_a = host.getNewLine) === null || _a === void 0 ? void 0 : _a.call(host)) || carriageReturnLineFeed;
      }
      ts3.getNewLineOrDefaultFromHost = getNewLineOrDefaultFromHost;
      function lineBreakPart() {
        return displayPart("\n", ts3.SymbolDisplayPartKind.lineBreak);
      }
      ts3.lineBreakPart = lineBreakPart;
      function mapToDisplayParts(writeDisplayParts) {
        try {
          writeDisplayParts(displayPartWriter);
          return displayPartWriter.displayParts();
        } finally {
          displayPartWriter.clear();
        }
      }
      ts3.mapToDisplayParts = mapToDisplayParts;
      function typeToDisplayParts(typechecker, type2, enclosingDeclaration, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        return mapToDisplayParts(function(writer) {
          typechecker.writeType(type2, enclosingDeclaration, flags | 1024 | 16384, writer);
        });
      }
      ts3.typeToDisplayParts = typeToDisplayParts;
      function symbolToDisplayParts(typeChecker, symbol, enclosingDeclaration, meaning, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        return mapToDisplayParts(function(writer) {
          typeChecker.writeSymbol(symbol, enclosingDeclaration, meaning, flags | 8, writer);
        });
      }
      ts3.symbolToDisplayParts = symbolToDisplayParts;
      function signatureToDisplayParts(typechecker, signature, enclosingDeclaration, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        flags |= 16384 | 1024 | 32 | 8192;
        return mapToDisplayParts(function(writer) {
          typechecker.writeSignature(signature, enclosingDeclaration, flags, void 0, writer);
        });
      }
      ts3.signatureToDisplayParts = signatureToDisplayParts;
      function nodeToDisplayParts(node, enclosingDeclaration) {
        var file = enclosingDeclaration.getSourceFile();
        return mapToDisplayParts(function(writer) {
          var printer2 = ts3.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
          printer2.writeNode(4, node, file, writer);
        });
      }
      ts3.nodeToDisplayParts = nodeToDisplayParts;
      function isImportOrExportSpecifierName(location) {
        return !!location.parent && ts3.isImportOrExportSpecifier(location.parent) && location.parent.propertyName === location;
      }
      ts3.isImportOrExportSpecifierName = isImportOrExportSpecifierName;
      function getScriptKind(fileName2, host) {
        return ts3.ensureScriptKind(fileName2, host.getScriptKind && host.getScriptKind(fileName2));
      }
      ts3.getScriptKind = getScriptKind;
      function getSymbolTarget(symbol, checker) {
        var next = symbol;
        while (isAliasSymbol(next) || isTransientSymbol(next) && next.target) {
          if (isTransientSymbol(next) && next.target) {
            next = next.target;
          } else {
            next = ts3.skipAlias(next, checker);
          }
        }
        return next;
      }
      ts3.getSymbolTarget = getSymbolTarget;
      function isTransientSymbol(symbol) {
        return (symbol.flags & 33554432) !== 0;
      }
      function isAliasSymbol(symbol) {
        return (symbol.flags & 2097152) !== 0;
      }
      function getUniqueSymbolId(symbol, checker) {
        return ts3.getSymbolId(ts3.skipAlias(symbol, checker));
      }
      ts3.getUniqueSymbolId = getUniqueSymbolId;
      function getFirstNonSpaceCharacterPosition(text, position) {
        while (ts3.isWhiteSpaceLike(text.charCodeAt(position))) {
          position += 1;
        }
        return position;
      }
      ts3.getFirstNonSpaceCharacterPosition = getFirstNonSpaceCharacterPosition;
      function getPrecedingNonSpaceCharacterPosition(text, position) {
        while (position > -1 && ts3.isWhiteSpaceSingleLine(text.charCodeAt(position))) {
          position -= 1;
        }
        return position + 1;
      }
      ts3.getPrecedingNonSpaceCharacterPosition = getPrecedingNonSpaceCharacterPosition;
      function getSynthesizedDeepClone(node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        var clone = node && getSynthesizedDeepCloneWorker(node);
        if (clone && !includeTrivia)
          suppressLeadingAndTrailingTrivia(clone);
        return clone;
      }
      ts3.getSynthesizedDeepClone = getSynthesizedDeepClone;
      function getSynthesizedDeepCloneWithReplacements(node, includeTrivia, replaceNode) {
        var clone = replaceNode(node);
        if (clone) {
          ts3.setOriginalNode(clone, node);
        } else {
          clone = getSynthesizedDeepCloneWorker(node, replaceNode);
        }
        if (clone && !includeTrivia)
          suppressLeadingAndTrailingTrivia(clone);
        return clone;
      }
      ts3.getSynthesizedDeepCloneWithReplacements = getSynthesizedDeepCloneWithReplacements;
      function getSynthesizedDeepCloneWorker(node, replaceNode) {
        var nodeClone = replaceNode ? function(n) {
          return getSynthesizedDeepCloneWithReplacements(n, true, replaceNode);
        } : getSynthesizedDeepClone;
        var nodesClone = replaceNode ? function(ns) {
          return ns && getSynthesizedDeepClonesWithReplacements(ns, true, replaceNode);
        } : function(ns) {
          return ns && getSynthesizedDeepClones(ns);
        };
        var visited = ts3.visitEachChild(node, nodeClone, ts3.nullTransformationContext, nodesClone, nodeClone);
        if (visited === node) {
          var clone_1 = ts3.isStringLiteral(node) ? ts3.setOriginalNode(ts3.factory.createStringLiteralFromNode(node), node) : ts3.isNumericLiteral(node) ? ts3.setOriginalNode(ts3.factory.createNumericLiteral(node.text, node.numericLiteralFlags), node) : ts3.factory.cloneNode(node);
          return ts3.setTextRange(clone_1, node);
        }
        visited.parent = void 0;
        return visited;
      }
      function getSynthesizedDeepClones(nodes, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        return nodes && ts3.factory.createNodeArray(nodes.map(function(n) {
          return getSynthesizedDeepClone(n, includeTrivia);
        }), nodes.hasTrailingComma);
      }
      ts3.getSynthesizedDeepClones = getSynthesizedDeepClones;
      function getSynthesizedDeepClonesWithReplacements(nodes, includeTrivia, replaceNode) {
        return ts3.factory.createNodeArray(nodes.map(function(n) {
          return getSynthesizedDeepCloneWithReplacements(n, includeTrivia, replaceNode);
        }), nodes.hasTrailingComma);
      }
      ts3.getSynthesizedDeepClonesWithReplacements = getSynthesizedDeepClonesWithReplacements;
      function suppressLeadingAndTrailingTrivia(node) {
        suppressLeadingTrivia(node);
        suppressTrailingTrivia(node);
      }
      ts3.suppressLeadingAndTrailingTrivia = suppressLeadingAndTrailingTrivia;
      function suppressLeadingTrivia(node) {
        addEmitFlagsRecursively(node, 512, getFirstChild);
      }
      ts3.suppressLeadingTrivia = suppressLeadingTrivia;
      function suppressTrailingTrivia(node) {
        addEmitFlagsRecursively(node, 1024, ts3.getLastChild);
      }
      ts3.suppressTrailingTrivia = suppressTrailingTrivia;
      function copyComments(sourceNode, targetNode) {
        var sourceFile = sourceNode.getSourceFile();
        var text = sourceFile.text;
        if (hasLeadingLineBreak(sourceNode, text)) {
          copyLeadingComments(sourceNode, targetNode, sourceFile);
        } else {
          copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile);
        }
        copyTrailingComments(sourceNode, targetNode, sourceFile);
      }
      ts3.copyComments = copyComments;
      function hasLeadingLineBreak(node, text) {
        var start = node.getFullStart();
        var end = node.getStart();
        for (var i = start; i < end; i++) {
          if (text.charCodeAt(i) === 10)
            return true;
        }
        return false;
      }
      function addEmitFlagsRecursively(node, flag, getChild) {
        ts3.addEmitFlags(node, flag);
        var child = getChild(node);
        if (child)
          addEmitFlagsRecursively(child, flag, getChild);
      }
      function getFirstChild(node) {
        return node.forEachChild(function(child) {
          return child;
        });
      }
      function getUniqueName(baseName, sourceFile) {
        var nameText = baseName;
        for (var i = 1; !ts3.isFileLevelUniqueName(sourceFile, nameText); i++) {
          nameText = "".concat(baseName, "_").concat(i);
        }
        return nameText;
      }
      ts3.getUniqueName = getUniqueName;
      function getRenameLocation(edits, renameFilename, name, preferLastLocation) {
        var delta = 0;
        var lastPos = -1;
        for (var _i = 0, edits_1 = edits; _i < edits_1.length; _i++) {
          var _a = edits_1[_i], fileName2 = _a.fileName, textChanges_2 = _a.textChanges;
          ts3.Debug.assert(fileName2 === renameFilename);
          for (var _b = 0, textChanges_1 = textChanges_2; _b < textChanges_1.length; _b++) {
            var change = textChanges_1[_b];
            var span = change.span, newText = change.newText;
            var index = indexInTextChange(newText, name);
            if (index !== -1) {
              lastPos = span.start + delta + index;
              if (!preferLastLocation) {
                return lastPos;
              }
            }
            delta += newText.length - span.length;
          }
        }
        ts3.Debug.assert(preferLastLocation);
        ts3.Debug.assert(lastPos >= 0);
        return lastPos;
      }
      ts3.getRenameLocation = getRenameLocation;
      function copyLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts3.forEachLeadingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts3.addSyntheticLeadingComment));
      }
      ts3.copyLeadingComments = copyLeadingComments;
      function copyTrailingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts3.forEachTrailingCommentRange(sourceFile.text, sourceNode.end, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts3.addSyntheticTrailingComment));
      }
      ts3.copyTrailingComments = copyTrailingComments;
      function copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts3.forEachTrailingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts3.addSyntheticLeadingComment));
      }
      ts3.copyTrailingAsLeadingComments = copyTrailingAsLeadingComments;
      function getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, cb) {
        return function(pos, end, kind, htnl) {
          if (kind === 3) {
            pos += 2;
            end -= 2;
          } else {
            pos += 2;
          }
          cb(targetNode, commentKind || kind, sourceFile.text.slice(pos, end), hasTrailingNewLine !== void 0 ? hasTrailingNewLine : htnl);
        };
      }
      function indexInTextChange(change, name) {
        if (ts3.startsWith(change, name))
          return 0;
        var idx2 = change.indexOf(" " + name);
        if (idx2 === -1)
          idx2 = change.indexOf("." + name);
        if (idx2 === -1)
          idx2 = change.indexOf('"' + name);
        return idx2 === -1 ? -1 : idx2 + 1;
      }
      function needsParentheses(expression) {
        return ts3.isBinaryExpression(expression) && expression.operatorToken.kind === 27 || ts3.isObjectLiteralExpression(expression) || ts3.isAsExpression(expression) && ts3.isObjectLiteralExpression(expression.expression);
      }
      ts3.needsParentheses = needsParentheses;
      function getContextualTypeFromParent(node, checker) {
        var parent = node.parent;
        switch (parent.kind) {
          case 209:
            return checker.getContextualType(parent);
          case 221: {
            var _a = parent, left = _a.left, operatorToken = _a.operatorToken, right = _a.right;
            return isEqualityOperatorKind(operatorToken.kind) ? checker.getTypeAtLocation(node === right ? left : right) : checker.getContextualType(node);
          }
          case 289:
            return parent.expression === node ? getSwitchedType(parent, checker) : void 0;
          default:
            return checker.getContextualType(node);
        }
      }
      ts3.getContextualTypeFromParent = getContextualTypeFromParent;
      function quote(sourceFile, preferences, text) {
        var quotePreference = getQuotePreference(sourceFile, preferences);
        var quoted = JSON.stringify(text);
        return quotePreference === 0 ? "'".concat(ts3.stripQuotes(quoted).replace(/'/g, "\\'").replace(/\\"/g, '"'), "'") : quoted;
      }
      ts3.quote = quote;
      function isEqualityOperatorKind(kind) {
        switch (kind) {
          case 36:
          case 34:
          case 37:
          case 35:
            return true;
          default:
            return false;
        }
      }
      ts3.isEqualityOperatorKind = isEqualityOperatorKind;
      function isStringLiteralOrTemplate(node) {
        switch (node.kind) {
          case 10:
          case 14:
          case 223:
          case 210:
            return true;
          default:
            return false;
        }
      }
      ts3.isStringLiteralOrTemplate = isStringLiteralOrTemplate;
      function hasIndexSignature(type2) {
        return !!type2.getStringIndexType() || !!type2.getNumberIndexType();
      }
      ts3.hasIndexSignature = hasIndexSignature;
      function getSwitchedType(caseClause, checker) {
        return checker.getTypeAtLocation(caseClause.parent.parent.expression);
      }
      ts3.getSwitchedType = getSwitchedType;
      ts3.ANONYMOUS = "anonymous function";
      function getTypeNodeIfAccessible(type2, enclosingScope, program2, host) {
        var checker = program2.getTypeChecker();
        var typeIsAccessible = true;
        var notAccessible = function() {
          return typeIsAccessible = false;
        };
        var res = checker.typeToTypeNode(type2, enclosingScope, 1, {
          trackSymbol: function(symbol, declaration, meaning) {
            typeIsAccessible = typeIsAccessible && checker.isSymbolAccessible(symbol, declaration, meaning, false).accessibility === 0;
            return !typeIsAccessible;
          },
          reportInaccessibleThisError: notAccessible,
          reportPrivateInBaseOfClassExpression: notAccessible,
          reportInaccessibleUniqueSymbolError: notAccessible,
          moduleResolverHost: getModuleSpecifierResolverHost(program2, host)
        });
        return typeIsAccessible ? res : void 0;
      }
      ts3.getTypeNodeIfAccessible = getTypeNodeIfAccessible;
      function syntaxRequiresTrailingCommaOrSemicolonOrASI(kind) {
        return kind === 174 || kind === 175 || kind === 176 || kind === 166 || kind === 168;
      }
      function syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(kind) {
        return kind === 256 || kind === 171 || kind === 169 || kind === 172 || kind === 173;
      }
      function syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(kind) {
        return kind === 261;
      }
      function syntaxRequiresTrailingSemicolonOrASI(kind) {
        return kind === 237 || kind === 238 || kind === 240 || kind === 245 || kind === 246 || kind === 247 || kind === 251 || kind === 253 || kind === 167 || kind === 259 || kind === 266 || kind === 265 || kind === 272 || kind === 264 || kind === 271;
      }
      ts3.syntaxRequiresTrailingSemicolonOrASI = syntaxRequiresTrailingSemicolonOrASI;
      ts3.syntaxMayBeASICandidate = ts3.or(syntaxRequiresTrailingCommaOrSemicolonOrASI, syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI, syntaxRequiresTrailingModuleBlockOrSemicolonOrASI, syntaxRequiresTrailingSemicolonOrASI);
      function nodeIsASICandidate(node, sourceFile) {
        var lastToken = node.getLastToken(sourceFile);
        if (lastToken && lastToken.kind === 26) {
          return false;
        }
        if (syntaxRequiresTrailingCommaOrSemicolonOrASI(node.kind)) {
          if (lastToken && lastToken.kind === 27) {
            return false;
          }
        } else if (syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(node.kind)) {
          var lastChild = ts3.last(node.getChildren(sourceFile));
          if (lastChild && ts3.isModuleBlock(lastChild)) {
            return false;
          }
        } else if (syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(node.kind)) {
          var lastChild = ts3.last(node.getChildren(sourceFile));
          if (lastChild && ts3.isFunctionBlock(lastChild)) {
            return false;
          }
        } else if (!syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
          return false;
        }
        if (node.kind === 240) {
          return true;
        }
        var topNode = ts3.findAncestor(node, function(ancestor) {
          return !ancestor.parent;
        });
        var nextToken = findNextToken(node, topNode, sourceFile);
        if (!nextToken || nextToken.kind === 19) {
          return true;
        }
        var startLine = sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
        var endLine = sourceFile.getLineAndCharacterOfPosition(nextToken.getStart(sourceFile)).line;
        return startLine !== endLine;
      }
      function positionIsASICandidate(pos, context, sourceFile) {
        var contextAncestor = ts3.findAncestor(context, function(ancestor) {
          if (ancestor.end !== pos) {
            return "quit";
          }
          return ts3.syntaxMayBeASICandidate(ancestor.kind);
        });
        return !!contextAncestor && nodeIsASICandidate(contextAncestor, sourceFile);
      }
      ts3.positionIsASICandidate = positionIsASICandidate;
      function probablyUsesSemicolons(sourceFile) {
        var withSemicolon = 0;
        var withoutSemicolon = 0;
        var nStatementsToObserve = 5;
        ts3.forEachChild(sourceFile, function visit(node) {
          if (syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
            var lastToken = node.getLastToken(sourceFile);
            if ((lastToken === null || lastToken === void 0 ? void 0 : lastToken.kind) === 26) {
              withSemicolon++;
            } else {
              withoutSemicolon++;
            }
          } else if (syntaxRequiresTrailingCommaOrSemicolonOrASI(node.kind)) {
            var lastToken = node.getLastToken(sourceFile);
            if ((lastToken === null || lastToken === void 0 ? void 0 : lastToken.kind) === 26) {
              withSemicolon++;
            } else if (lastToken && lastToken.kind !== 27) {
              var lastTokenLine = ts3.getLineAndCharacterOfPosition(sourceFile, lastToken.getStart(sourceFile)).line;
              var nextTokenLine = ts3.getLineAndCharacterOfPosition(sourceFile, ts3.getSpanOfTokenAtPosition(sourceFile, lastToken.end).start).line;
              if (lastTokenLine !== nextTokenLine) {
                withoutSemicolon++;
              }
            }
          }
          if (withSemicolon + withoutSemicolon >= nStatementsToObserve) {
            return true;
          }
          return ts3.forEachChild(node, visit);
        });
        if (withSemicolon === 0 && withoutSemicolon <= 1) {
          return true;
        }
        return withSemicolon / withoutSemicolon > 1 / nStatementsToObserve;
      }
      ts3.probablyUsesSemicolons = probablyUsesSemicolons;
      function tryGetDirectories(host, directoryName) {
        return tryIOAndConsumeErrors(host, host.getDirectories, directoryName) || [];
      }
      ts3.tryGetDirectories = tryGetDirectories;
      function tryReadDirectory(host, path2, extensions, exclude, include) {
        return tryIOAndConsumeErrors(host, host.readDirectory, path2, extensions, exclude, include) || ts3.emptyArray;
      }
      ts3.tryReadDirectory = tryReadDirectory;
      function tryFileExists(host, path2) {
        return tryIOAndConsumeErrors(host, host.fileExists, path2);
      }
      ts3.tryFileExists = tryFileExists;
      function tryDirectoryExists(host, path2) {
        return tryAndIgnoreErrors(function() {
          return ts3.directoryProbablyExists(path2, host);
        }) || false;
      }
      ts3.tryDirectoryExists = tryDirectoryExists;
      function tryAndIgnoreErrors(cb) {
        try {
          return cb();
        } catch (_a) {
          return void 0;
        }
      }
      ts3.tryAndIgnoreErrors = tryAndIgnoreErrors;
      function tryIOAndConsumeErrors(host, toApply) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        return tryAndIgnoreErrors(function() {
          return toApply && toApply.apply(host, args);
        });
      }
      ts3.tryIOAndConsumeErrors = tryIOAndConsumeErrors;
      function findPackageJsons(startDirectory, host, stopDirectory) {
        var paths = [];
        ts3.forEachAncestorDirectory(startDirectory, function(ancestor) {
          if (ancestor === stopDirectory) {
            return true;
          }
          var currentConfigPath = ts3.combinePaths(ancestor, "package.json");
          if (tryFileExists(host, currentConfigPath)) {
            paths.push(currentConfigPath);
          }
        });
        return paths;
      }
      ts3.findPackageJsons = findPackageJsons;
      function findPackageJson(directory, host) {
        var packageJson;
        ts3.forEachAncestorDirectory(directory, function(ancestor) {
          if (ancestor === "node_modules")
            return true;
          packageJson = ts3.findConfigFile(ancestor, function(f) {
            return tryFileExists(host, f);
          }, "package.json");
          if (packageJson) {
            return true;
          }
        });
        return packageJson;
      }
      ts3.findPackageJson = findPackageJson;
      function getPackageJsonsVisibleToFile(fileName2, host) {
        if (!host.fileExists) {
          return [];
        }
        var packageJsons = [];
        ts3.forEachAncestorDirectory(ts3.getDirectoryPath(fileName2), function(ancestor) {
          var packageJsonFileName = ts3.combinePaths(ancestor, "package.json");
          if (host.fileExists(packageJsonFileName)) {
            var info = createPackageJsonInfo(packageJsonFileName, host);
            if (info) {
              packageJsons.push(info);
            }
          }
        });
        return packageJsons;
      }
      ts3.getPackageJsonsVisibleToFile = getPackageJsonsVisibleToFile;
      function createPackageJsonInfo(fileName2, host) {
        if (!host.readFile) {
          return void 0;
        }
        var dependencyKeys = ["dependencies", "devDependencies", "optionalDependencies", "peerDependencies"];
        var stringContent = host.readFile(fileName2) || "";
        var content = tryParseJson(stringContent);
        var info = {};
        if (content) {
          for (var _i = 0, dependencyKeys_1 = dependencyKeys; _i < dependencyKeys_1.length; _i++) {
            var key = dependencyKeys_1[_i];
            var dependencies = content[key];
            if (!dependencies) {
              continue;
            }
            var dependencyMap = new ts3.Map();
            for (var packageName in dependencies) {
              dependencyMap.set(packageName, dependencies[packageName]);
            }
            info[key] = dependencyMap;
          }
        }
        var dependencyGroups = [
          [1, info.dependencies],
          [2, info.devDependencies],
          [8, info.optionalDependencies],
          [4, info.peerDependencies]
        ];
        return __assign(__assign({}, info), { parseable: !!content, fileName: fileName2, get, has: function(dependencyName, inGroups) {
          return !!get(dependencyName, inGroups);
        } });
        function get(dependencyName, inGroups) {
          if (inGroups === void 0) {
            inGroups = 15;
          }
          for (var _i2 = 0, dependencyGroups_1 = dependencyGroups; _i2 < dependencyGroups_1.length; _i2++) {
            var _a = dependencyGroups_1[_i2], group_1 = _a[0], deps = _a[1];
            if (deps && inGroups & group_1) {
              var dep = deps.get(dependencyName);
              if (dep !== void 0) {
                return dep;
              }
            }
          }
        }
      }
      ts3.createPackageJsonInfo = createPackageJsonInfo;
      function createPackageJsonImportFilter(fromFile, preferences, host) {
        var packageJsons = (host.getPackageJsonsVisibleToFile && host.getPackageJsonsVisibleToFile(fromFile.fileName) || getPackageJsonsVisibleToFile(fromFile.fileName, host)).filter(function(p) {
          return p.parseable;
        });
        var usesNodeCoreModules;
        return { allowsImportingAmbientModule, allowsImportingSourceFile, allowsImportingSpecifier };
        function moduleSpecifierIsCoveredByPackageJson(specifier) {
          var packageName = getNodeModuleRootSpecifier(specifier);
          for (var _i = 0, packageJsons_1 = packageJsons; _i < packageJsons_1.length; _i++) {
            var packageJson = packageJsons_1[_i];
            if (packageJson.has(packageName) || packageJson.has(ts3.getTypesPackageName(packageName))) {
              return true;
            }
          }
          return false;
        }
        function allowsImportingAmbientModule(moduleSymbol, moduleSpecifierResolutionHost) {
          if (!packageJsons.length || !moduleSymbol.valueDeclaration) {
            return true;
          }
          var declaringSourceFile = moduleSymbol.valueDeclaration.getSourceFile();
          var declaringNodeModuleName = getNodeModulesPackageNameFromFileName(declaringSourceFile.fileName, moduleSpecifierResolutionHost);
          if (typeof declaringNodeModuleName === "undefined") {
            return true;
          }
          var declaredModuleSpecifier = ts3.stripQuotes(moduleSymbol.getName());
          if (isAllowedCoreNodeModulesImport(declaredModuleSpecifier)) {
            return true;
          }
          return moduleSpecifierIsCoveredByPackageJson(declaringNodeModuleName) || moduleSpecifierIsCoveredByPackageJson(declaredModuleSpecifier);
        }
        function allowsImportingSourceFile(sourceFile, moduleSpecifierResolutionHost) {
          if (!packageJsons.length) {
            return true;
          }
          var moduleSpecifier = getNodeModulesPackageNameFromFileName(sourceFile.fileName, moduleSpecifierResolutionHost);
          if (!moduleSpecifier) {
            return true;
          }
          return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
        }
        function allowsImportingSpecifier(moduleSpecifier) {
          if (!packageJsons.length || isAllowedCoreNodeModulesImport(moduleSpecifier)) {
            return true;
          }
          if (ts3.pathIsRelative(moduleSpecifier) || ts3.isRootedDiskPath(moduleSpecifier)) {
            return true;
          }
          return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
        }
        function isAllowedCoreNodeModulesImport(moduleSpecifier) {
          if (ts3.isSourceFileJS(fromFile) && ts3.JsTyping.nodeCoreModules.has(moduleSpecifier)) {
            if (usesNodeCoreModules === void 0) {
              usesNodeCoreModules = consumesNodeCoreModules(fromFile);
            }
            if (usesNodeCoreModules) {
              return true;
            }
          }
          return false;
        }
        function getNodeModulesPackageNameFromFileName(importedFileName, moduleSpecifierResolutionHost) {
          if (!ts3.stringContains(importedFileName, "node_modules")) {
            return void 0;
          }
          var specifier = ts3.moduleSpecifiers.getNodeModulesPackageName(host.getCompilationSettings(), fromFile, importedFileName, moduleSpecifierResolutionHost, preferences);
          if (!specifier) {
            return void 0;
          }
          if (!ts3.pathIsRelative(specifier) && !ts3.isRootedDiskPath(specifier)) {
            return getNodeModuleRootSpecifier(specifier);
          }
        }
        function getNodeModuleRootSpecifier(fullSpecifier) {
          var components = ts3.getPathComponents(ts3.getPackageNameFromTypesPackageName(fullSpecifier)).slice(1);
          if (ts3.startsWith(components[0], "@")) {
            return "".concat(components[0], "/").concat(components[1]);
          }
          return components[0];
        }
      }
      ts3.createPackageJsonImportFilter = createPackageJsonImportFilter;
      function tryParseJson(text) {
        try {
          return JSON.parse(text);
        } catch (_a) {
          return void 0;
        }
      }
      function consumesNodeCoreModules(sourceFile) {
        return ts3.some(sourceFile.imports, function(_a) {
          var text = _a.text;
          return ts3.JsTyping.nodeCoreModules.has(text);
        });
      }
      ts3.consumesNodeCoreModules = consumesNodeCoreModules;
      function isInsideNodeModules(fileOrDirectory) {
        return ts3.contains(ts3.getPathComponents(fileOrDirectory), "node_modules");
      }
      ts3.isInsideNodeModules = isInsideNodeModules;
      function isDiagnosticWithLocation(diagnostic) {
        return diagnostic.file !== void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0;
      }
      ts3.isDiagnosticWithLocation = isDiagnosticWithLocation;
      function findDiagnosticForNode(node, sortedFileDiagnostics) {
        var span = createTextSpanFromNode(node);
        var index = ts3.binarySearchKey(sortedFileDiagnostics, span, ts3.identity, ts3.compareTextSpans);
        if (index >= 0) {
          var diagnostic = sortedFileDiagnostics[index];
          ts3.Debug.assertEqual(diagnostic.file, node.getSourceFile(), "Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile");
          return ts3.cast(diagnostic, isDiagnosticWithLocation);
        }
      }
      ts3.findDiagnosticForNode = findDiagnosticForNode;
      function getDiagnosticsWithinSpan(span, sortedFileDiagnostics) {
        var _a;
        var index = ts3.binarySearchKey(sortedFileDiagnostics, span.start, function(diag) {
          return diag.start;
        }, ts3.compareValues);
        if (index < 0) {
          index = ~index;
        }
        while (((_a = sortedFileDiagnostics[index - 1]) === null || _a === void 0 ? void 0 : _a.start) === span.start) {
          index--;
        }
        var result2 = [];
        var end = ts3.textSpanEnd(span);
        while (true) {
          var diagnostic = ts3.tryCast(sortedFileDiagnostics[index], isDiagnosticWithLocation);
          if (!diagnostic || diagnostic.start > end) {
            break;
          }
          if (ts3.textSpanContainsTextSpan(span, diagnostic)) {
            result2.push(diagnostic);
          }
          index++;
        }
        return result2;
      }
      ts3.getDiagnosticsWithinSpan = getDiagnosticsWithinSpan;
      function getRefactorContextSpan(_a) {
        var startPosition = _a.startPosition, endPosition = _a.endPosition;
        return ts3.createTextSpanFromBounds(startPosition, endPosition === void 0 ? startPosition : endPosition);
      }
      ts3.getRefactorContextSpan = getRefactorContextSpan;
      function getFixableErrorSpanExpression(sourceFile, span) {
        var token = getTokenAtPosition(sourceFile, span.start);
        var expression = ts3.findAncestor(token, function(node) {
          if (node.getStart(sourceFile) < span.start || node.getEnd() > ts3.textSpanEnd(span)) {
            return "quit";
          }
          return ts3.isExpression(node) && textSpansEqual(span, createTextSpanFromNode(node, sourceFile));
        });
        return expression;
      }
      ts3.getFixableErrorSpanExpression = getFixableErrorSpanExpression;
      function mapOneOrMany(valueOrArray, f, resultSelector) {
        if (resultSelector === void 0) {
          resultSelector = ts3.identity;
        }
        return valueOrArray ? ts3.isArray(valueOrArray) ? resultSelector(ts3.map(valueOrArray, f)) : f(valueOrArray, 0) : void 0;
      }
      ts3.mapOneOrMany = mapOneOrMany;
      function firstOrOnly(valueOrArray) {
        return ts3.isArray(valueOrArray) ? ts3.first(valueOrArray) : valueOrArray;
      }
      ts3.firstOrOnly = firstOrOnly;
      function getNamesForExportedSymbol(symbol, scriptTarget) {
        if (needsNameFromDeclaration(symbol)) {
          var fromDeclaration = getDefaultLikeExportNameFromDeclaration(symbol);
          if (fromDeclaration)
            return fromDeclaration;
          var fileNameCase = ts3.codefix.moduleSymbolToValidIdentifier(getSymbolParentOrFail(symbol), scriptTarget, false);
          var capitalized = ts3.codefix.moduleSymbolToValidIdentifier(getSymbolParentOrFail(symbol), scriptTarget, true);
          if (fileNameCase === capitalized)
            return fileNameCase;
          return [fileNameCase, capitalized];
        }
        return symbol.name;
      }
      ts3.getNamesForExportedSymbol = getNamesForExportedSymbol;
      function getNameForExportedSymbol(symbol, scriptTarget, preferCapitalized) {
        if (needsNameFromDeclaration(symbol)) {
          return getDefaultLikeExportNameFromDeclaration(symbol) || ts3.codefix.moduleSymbolToValidIdentifier(getSymbolParentOrFail(symbol), scriptTarget, !!preferCapitalized);
        }
        return symbol.name;
      }
      ts3.getNameForExportedSymbol = getNameForExportedSymbol;
      function needsNameFromDeclaration(symbol) {
        return !(symbol.flags & 33554432) && (symbol.escapedName === "export=" || symbol.escapedName === "default");
      }
      function getDefaultLikeExportNameFromDeclaration(symbol) {
        return ts3.firstDefined(symbol.declarations, function(d) {
          var _a;
          return ts3.isExportAssignment(d) ? (_a = ts3.tryCast(ts3.skipOuterExpressions(d.expression), ts3.isIdentifier)) === null || _a === void 0 ? void 0 : _a.text : void 0;
        });
      }
      function getSymbolParentOrFail(symbol) {
        var _a;
        return ts3.Debug.checkDefined(symbol.parent, "Symbol parent was undefined. Flags: ".concat(ts3.Debug.formatSymbolFlags(symbol.flags), ". ") + "Declarations: ".concat((_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.map(function(d) {
          var kind = ts3.Debug.formatSyntaxKind(d.kind);
          var inJS = ts3.isInJSFile(d);
          var expression = d.expression;
          return (inJS ? "[JS]" : "") + kind + (expression ? " (expression: ".concat(ts3.Debug.formatSyntaxKind(expression.kind), ")") : "");
        }).join(", "), "."));
      }
      function stringContainsAt(haystack, needle, startIndex) {
        var needleLength = needle.length;
        if (needleLength + startIndex > haystack.length) {
          return false;
        }
        for (var i = 0; i < needleLength; i++) {
          if (needle.charCodeAt(i) !== haystack.charCodeAt(i + startIndex))
            return false;
        }
        return true;
      }
      ts3.stringContainsAt = stringContainsAt;
      function startsWithUnderscore(name) {
        return name.charCodeAt(0) === 95;
      }
      ts3.startsWithUnderscore = startsWithUnderscore;
      function isGlobalDeclaration(declaration) {
        return !isNonGlobalDeclaration(declaration);
      }
      ts3.isGlobalDeclaration = isGlobalDeclaration;
      function isNonGlobalDeclaration(declaration) {
        var sourceFile = declaration.getSourceFile();
        if (!sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator) {
          return false;
        }
        return ts3.isInJSFile(declaration) || !ts3.findAncestor(declaration, ts3.isGlobalScopeAugmentation);
      }
      ts3.isNonGlobalDeclaration = isNonGlobalDeclaration;
      function isDeprecatedDeclaration(decl) {
        return !!(ts3.getCombinedNodeFlagsAlwaysIncludeJSDoc(decl) & 8192);
      }
      ts3.isDeprecatedDeclaration = isDeprecatedDeclaration;
      function shouldUseUriStyleNodeCoreModules(file, program2) {
        var decisionFromFile = ts3.firstDefined(file.imports, function(node) {
          if (ts3.JsTyping.nodeCoreModules.has(node.text)) {
            return ts3.startsWith(node.text, "node:");
          }
        });
        return decisionFromFile !== null && decisionFromFile !== void 0 ? decisionFromFile : program2.usesUriStyleNodeCoreModules;
      }
      ts3.shouldUseUriStyleNodeCoreModules = shouldUseUriStyleNodeCoreModules;
      function getNewLineKind(newLineCharacter) {
        return newLineCharacter === "\n" ? 1 : 0;
      }
      ts3.getNewLineKind = getNewLineKind;
      function diagnosticToString(diag) {
        return ts3.isArray(diag) ? ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(diag[0]), diag.slice(1)) : ts3.getLocaleSpecificMessage(diag);
      }
      ts3.diagnosticToString = diagnosticToString;
      function getFormatCodeSettingsForWriting(_a, sourceFile) {
        var options = _a.options;
        var shouldAutoDetectSemicolonPreference = !options.semicolons || options.semicolons === ts3.SemicolonPreference.Ignore;
        var shouldRemoveSemicolons = options.semicolons === ts3.SemicolonPreference.Remove || shouldAutoDetectSemicolonPreference && !probablyUsesSemicolons(sourceFile);
        return __assign(__assign({}, options), { semicolons: shouldRemoveSemicolons ? ts3.SemicolonPreference.Remove : ts3.SemicolonPreference.Ignore });
      }
      ts3.getFormatCodeSettingsForWriting = getFormatCodeSettingsForWriting;
      function jsxModeNeedsExplicitImport(jsx) {
        return jsx === 2 || jsx === 3;
      }
      ts3.jsxModeNeedsExplicitImport = jsxModeNeedsExplicitImport;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ImportKind;
      (function(ImportKind2) {
        ImportKind2[ImportKind2["Named"] = 0] = "Named";
        ImportKind2[ImportKind2["Default"] = 1] = "Default";
        ImportKind2[ImportKind2["Namespace"] = 2] = "Namespace";
        ImportKind2[ImportKind2["CommonJS"] = 3] = "CommonJS";
      })(ImportKind = ts3.ImportKind || (ts3.ImportKind = {}));
      var ExportKind;
      (function(ExportKind2) {
        ExportKind2[ExportKind2["Named"] = 0] = "Named";
        ExportKind2[ExportKind2["Default"] = 1] = "Default";
        ExportKind2[ExportKind2["ExportEquals"] = 2] = "ExportEquals";
        ExportKind2[ExportKind2["UMD"] = 3] = "UMD";
      })(ExportKind = ts3.ExportKind || (ts3.ExportKind = {}));
      function createCacheableExportInfoMap(host) {
        var exportInfoId = 1;
        var exportInfo = ts3.createMultiMap();
        var symbols = new ts3.Map();
        var packages = new ts3.Map();
        var usableByFileName;
        var cache = {
          isUsableByFile: function(importingFile) {
            return importingFile === usableByFileName;
          },
          isEmpty: function() {
            return !exportInfo.size;
          },
          clear: function() {
            exportInfo.clear();
            symbols.clear();
            usableByFileName = void 0;
          },
          add: function(importingFile, symbol, symbolTableKey, moduleSymbol, moduleFile, exportKind, isFromPackageJson, checker) {
            if (importingFile !== usableByFileName) {
              cache.clear();
              usableByFileName = importingFile;
            }
            var packageName;
            if (moduleFile) {
              var nodeModulesPathParts = ts3.getNodeModulePathParts(moduleFile.fileName);
              if (nodeModulesPathParts) {
                var topLevelNodeModulesIndex = nodeModulesPathParts.topLevelNodeModulesIndex, topLevelPackageNameIndex = nodeModulesPathParts.topLevelPackageNameIndex, packageRootIndex = nodeModulesPathParts.packageRootIndex;
                packageName = ts3.unmangleScopedPackageName(ts3.getPackageNameFromTypesPackageName(moduleFile.fileName.substring(topLevelPackageNameIndex + 1, packageRootIndex)));
                if (ts3.startsWith(importingFile, moduleFile.path.substring(0, topLevelNodeModulesIndex))) {
                  var prevDeepestNodeModulesPath = packages.get(packageName);
                  var nodeModulesPath = moduleFile.fileName.substring(0, topLevelPackageNameIndex + 1);
                  if (prevDeepestNodeModulesPath) {
                    var prevDeepestNodeModulesIndex = prevDeepestNodeModulesPath.indexOf(ts3.nodeModulesPathPart);
                    if (topLevelNodeModulesIndex > prevDeepestNodeModulesIndex) {
                      packages.set(packageName, nodeModulesPath);
                    }
                  } else {
                    packages.set(packageName, nodeModulesPath);
                  }
                }
              }
            }
            var isDefault = exportKind === 1;
            var namedSymbol = isDefault && ts3.getLocalSymbolForExportDefault(symbol) || symbol;
            var names = exportKind === 0 || ts3.isExternalModuleSymbol(namedSymbol) ? ts3.unescapeLeadingUnderscores(symbolTableKey) : ts3.getNamesForExportedSymbol(namedSymbol, void 0);
            var symbolName = typeof names === "string" ? names : names[0];
            var capitalizedSymbolName = typeof names === "string" ? void 0 : names[1];
            var moduleName = ts3.stripQuotes(moduleSymbol.name);
            var id = exportInfoId++;
            var target = ts3.skipAlias(symbol, checker);
            var storedSymbol = symbol.flags & 33554432 ? void 0 : symbol;
            var storedModuleSymbol = moduleSymbol.flags & 33554432 ? void 0 : moduleSymbol;
            if (!storedSymbol || !storedModuleSymbol)
              symbols.set(id, [symbol, moduleSymbol]);
            exportInfo.add(key(symbolName, symbol, ts3.isExternalModuleNameRelative(moduleName) ? void 0 : moduleName, checker), {
              id,
              symbolTableKey,
              symbolName,
              capitalizedSymbolName,
              moduleName,
              moduleFile,
              moduleFileName: moduleFile === null || moduleFile === void 0 ? void 0 : moduleFile.fileName,
              packageName,
              exportKind,
              targetFlags: target.flags,
              isFromPackageJson,
              symbol: storedSymbol,
              moduleSymbol: storedModuleSymbol
            });
          },
          get: function(importingFile, key2) {
            if (importingFile !== usableByFileName)
              return;
            var result2 = exportInfo.get(key2);
            return result2 === null || result2 === void 0 ? void 0 : result2.map(rehydrateCachedInfo);
          },
          search: function(importingFile, preferCapitalized, matches, action) {
            if (importingFile !== usableByFileName)
              return;
            exportInfo.forEach(function(info, key2) {
              var _a = parseKey(key2), symbolName = _a.symbolName, ambientModuleName = _a.ambientModuleName;
              var name = preferCapitalized && info[0].capitalizedSymbolName || symbolName;
              if (matches(name, info[0].targetFlags)) {
                var rehydrated = info.map(rehydrateCachedInfo);
                var filtered = rehydrated.filter(function(r, i) {
                  return isNotShadowedByDeeperNodeModulesPackage(r, info[i].packageName);
                });
                if (filtered.length) {
                  action(filtered, name, !!ambientModuleName, key2);
                }
              }
            });
          },
          releaseSymbols: function() {
            symbols.clear();
          },
          onFileChanged: function(oldSourceFile, newSourceFile, typeAcquisitionEnabled) {
            if (fileIsGlobalOnly(oldSourceFile) && fileIsGlobalOnly(newSourceFile)) {
              return false;
            }
            if (usableByFileName && usableByFileName !== newSourceFile.path || typeAcquisitionEnabled && ts3.consumesNodeCoreModules(oldSourceFile) !== ts3.consumesNodeCoreModules(newSourceFile) || !ts3.arrayIsEqualTo(oldSourceFile.moduleAugmentations, newSourceFile.moduleAugmentations) || !ambientModuleDeclarationsAreEqual(oldSourceFile, newSourceFile)) {
              cache.clear();
              return true;
            }
            usableByFileName = newSourceFile.path;
            return false;
          }
        };
        if (ts3.Debug.isDebugging) {
          Object.defineProperty(cache, "__cache", { get: function() {
            return exportInfo;
          } });
        }
        return cache;
        function rehydrateCachedInfo(info) {
          if (info.symbol && info.moduleSymbol)
            return info;
          var id = info.id, exportKind = info.exportKind, targetFlags = info.targetFlags, isFromPackageJson = info.isFromPackageJson, moduleFileName = info.moduleFileName;
          var _a = symbols.get(id) || ts3.emptyArray, cachedSymbol = _a[0], cachedModuleSymbol = _a[1];
          if (cachedSymbol && cachedModuleSymbol) {
            return {
              symbol: cachedSymbol,
              moduleSymbol: cachedModuleSymbol,
              moduleFileName,
              exportKind,
              targetFlags,
              isFromPackageJson
            };
          }
          var checker = (isFromPackageJson ? host.getPackageJsonAutoImportProvider() : host.getCurrentProgram()).getTypeChecker();
          var moduleSymbol = info.moduleSymbol || cachedModuleSymbol || ts3.Debug.checkDefined(info.moduleFile ? checker.getMergedSymbol(info.moduleFile.symbol) : checker.tryFindAmbientModule(info.moduleName));
          var symbol = info.symbol || cachedSymbol || ts3.Debug.checkDefined(exportKind === 2 ? checker.resolveExternalModuleSymbol(moduleSymbol) : checker.tryGetMemberInModuleExportsAndProperties(ts3.unescapeLeadingUnderscores(info.symbolTableKey), moduleSymbol), "Could not find symbol '".concat(info.symbolName, "' by key '").concat(info.symbolTableKey, "' in module ").concat(moduleSymbol.name));
          symbols.set(id, [symbol, moduleSymbol]);
          return {
            symbol,
            moduleSymbol,
            moduleFileName,
            exportKind,
            targetFlags,
            isFromPackageJson
          };
        }
        function key(importedName, symbol, ambientModuleName, checker) {
          var moduleKey = ambientModuleName || "";
          return "".concat(importedName, "|").concat(ts3.getSymbolId(ts3.skipAlias(symbol, checker)), "|").concat(moduleKey);
        }
        function parseKey(key2) {
          var symbolName = key2.substring(0, key2.indexOf("|"));
          var moduleKey = key2.substring(key2.lastIndexOf("|") + 1);
          var ambientModuleName = moduleKey === "" ? void 0 : moduleKey;
          return { symbolName, ambientModuleName };
        }
        function fileIsGlobalOnly(file) {
          return !file.commonJsModuleIndicator && !file.externalModuleIndicator && !file.moduleAugmentations && !file.ambientModuleNames;
        }
        function ambientModuleDeclarationsAreEqual(oldSourceFile, newSourceFile) {
          if (!ts3.arrayIsEqualTo(oldSourceFile.ambientModuleNames, newSourceFile.ambientModuleNames)) {
            return false;
          }
          var oldFileStatementIndex = -1;
          var newFileStatementIndex = -1;
          var _loop_2 = function(ambientModuleName2) {
            var isMatchingModuleDeclaration = function(node) {
              return ts3.isNonGlobalAmbientModule(node) && node.name.text === ambientModuleName2;
            };
            oldFileStatementIndex = ts3.findIndex(oldSourceFile.statements, isMatchingModuleDeclaration, oldFileStatementIndex + 1);
            newFileStatementIndex = ts3.findIndex(newSourceFile.statements, isMatchingModuleDeclaration, newFileStatementIndex + 1);
            if (oldSourceFile.statements[oldFileStatementIndex] !== newSourceFile.statements[newFileStatementIndex]) {
              return { value: false };
            }
          };
          for (var _i = 0, _a = newSourceFile.ambientModuleNames; _i < _a.length; _i++) {
            var ambientModuleName = _a[_i];
            var state_2 = _loop_2(ambientModuleName);
            if (typeof state_2 === "object")
              return state_2.value;
          }
          return true;
        }
        function isNotShadowedByDeeperNodeModulesPackage(info, packageName) {
          if (!packageName || !info.moduleFileName)
            return true;
          var typingsCacheLocation = host.getGlobalTypingsCacheLocation();
          if (typingsCacheLocation && ts3.startsWith(info.moduleFileName, typingsCacheLocation))
            return true;
          var packageDeepestNodeModulesPath = packages.get(packageName);
          return !packageDeepestNodeModulesPath || ts3.startsWith(info.moduleFileName, packageDeepestNodeModulesPath);
        }
      }
      ts3.createCacheableExportInfoMap = createCacheableExportInfoMap;
      function isImportableFile(program2, from, to, preferences, packageJsonFilter, moduleSpecifierResolutionHost, moduleSpecifierCache) {
        var _a;
        if (from === to)
          return false;
        var cachedResult = moduleSpecifierCache === null || moduleSpecifierCache === void 0 ? void 0 : moduleSpecifierCache.get(from.path, to.path, preferences, {});
        if ((cachedResult === null || cachedResult === void 0 ? void 0 : cachedResult.isBlockedByPackageJsonDependencies) !== void 0) {
          return !cachedResult.isBlockedByPackageJsonDependencies;
        }
        var getCanonicalFileName = ts3.hostGetCanonicalFileName(moduleSpecifierResolutionHost);
        var globalTypingsCache = (_a = moduleSpecifierResolutionHost.getGlobalTypingsCacheLocation) === null || _a === void 0 ? void 0 : _a.call(moduleSpecifierResolutionHost);
        var hasImportablePath = !!ts3.moduleSpecifiers.forEachFileNameOfModule(from.fileName, to.fileName, moduleSpecifierResolutionHost, false, function(toPath) {
          var toFile = program2.getSourceFile(toPath);
          return (toFile === to || !toFile) && isImportablePath(from.fileName, toPath, getCanonicalFileName, globalTypingsCache);
        });
        if (packageJsonFilter) {
          var isAutoImportable = hasImportablePath && packageJsonFilter.allowsImportingSourceFile(to, moduleSpecifierResolutionHost);
          moduleSpecifierCache === null || moduleSpecifierCache === void 0 ? void 0 : moduleSpecifierCache.setBlockedByPackageJsonDependencies(from.path, to.path, preferences, {}, !isAutoImportable);
          return isAutoImportable;
        }
        return hasImportablePath;
      }
      ts3.isImportableFile = isImportableFile;
      function isImportablePath(fromPath, toPath, getCanonicalFileName, globalCachePath) {
        var toNodeModules = ts3.forEachAncestorDirectory(toPath, function(ancestor) {
          return ts3.getBaseFileName(ancestor) === "node_modules" ? ancestor : void 0;
        });
        var toNodeModulesParent = toNodeModules && ts3.getDirectoryPath(getCanonicalFileName(toNodeModules));
        return toNodeModulesParent === void 0 || ts3.startsWith(getCanonicalFileName(fromPath), toNodeModulesParent) || !!globalCachePath && ts3.startsWith(getCanonicalFileName(globalCachePath), toNodeModulesParent);
      }
      function forEachExternalModuleToImportFrom(program2, host, useAutoImportProvider, cb) {
        var _a, _b;
        forEachExternalModule(program2.getTypeChecker(), program2.getSourceFiles(), function(module3, file) {
          return cb(module3, file, program2, false);
        });
        var autoImportProvider = useAutoImportProvider && ((_a = host.getPackageJsonAutoImportProvider) === null || _a === void 0 ? void 0 : _a.call(host));
        if (autoImportProvider) {
          var start = ts3.timestamp();
          forEachExternalModule(autoImportProvider.getTypeChecker(), autoImportProvider.getSourceFiles(), function(module3, file) {
            return cb(module3, file, autoImportProvider, true);
          });
          (_b = host.log) === null || _b === void 0 ? void 0 : _b.call(host, "forEachExternalModuleToImportFrom autoImportProvider: ".concat(ts3.timestamp() - start));
        }
      }
      ts3.forEachExternalModuleToImportFrom = forEachExternalModuleToImportFrom;
      function forEachExternalModule(checker, allSourceFiles, cb) {
        for (var _i = 0, _a = checker.getAmbientModules(); _i < _a.length; _i++) {
          var ambient = _a[_i];
          if (!ts3.stringContains(ambient.name, "*")) {
            cb(ambient, void 0);
          }
        }
        for (var _b = 0, allSourceFiles_1 = allSourceFiles; _b < allSourceFiles_1.length; _b++) {
          var sourceFile = allSourceFiles_1[_b];
          if (ts3.isExternalOrCommonJsModule(sourceFile)) {
            cb(checker.getMergedSymbol(sourceFile.symbol), sourceFile);
          }
        }
      }
      function getExportInfoMap(importingFile, host, program2, cancellationToken) {
        var _a, _b, _c, _d, _e;
        var start = ts3.timestamp();
        (_a = host.getPackageJsonAutoImportProvider) === null || _a === void 0 ? void 0 : _a.call(host);
        var cache = ((_b = host.getCachedExportInfoMap) === null || _b === void 0 ? void 0 : _b.call(host)) || createCacheableExportInfoMap({
          getCurrentProgram: function() {
            return program2;
          },
          getPackageJsonAutoImportProvider: function() {
            var _a2;
            return (_a2 = host.getPackageJsonAutoImportProvider) === null || _a2 === void 0 ? void 0 : _a2.call(host);
          },
          getGlobalTypingsCacheLocation: function() {
            var _a2;
            return (_a2 = host.getGlobalTypingsCacheLocation) === null || _a2 === void 0 ? void 0 : _a2.call(host);
          }
        });
        if (cache.isUsableByFile(importingFile.path)) {
          (_c = host.log) === null || _c === void 0 ? void 0 : _c.call(host, "getExportInfoMap: cache hit");
          return cache;
        }
        (_d = host.log) === null || _d === void 0 ? void 0 : _d.call(host, "getExportInfoMap: cache miss or empty; calculating new results");
        var compilerOptions = program2.getCompilerOptions();
        var moduleCount = 0;
        try {
          forEachExternalModuleToImportFrom(program2, host, true, function(moduleSymbol, moduleFile, program3, isFromPackageJson) {
            if (++moduleCount % 100 === 0)
              cancellationToken === null || cancellationToken === void 0 ? void 0 : cancellationToken.throwIfCancellationRequested();
            var seenExports = new ts3.Map();
            var checker = program3.getTypeChecker();
            var defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && isImportableSymbol(defaultInfo.symbol, checker)) {
              cache.add(importingFile.path, defaultInfo.symbol, defaultInfo.exportKind === 1 ? "default" : "export=", moduleSymbol, moduleFile, defaultInfo.exportKind, isFromPackageJson, checker);
            }
            checker.forEachExportAndPropertyOfModule(moduleSymbol, function(exported, key) {
              if (exported !== (defaultInfo === null || defaultInfo === void 0 ? void 0 : defaultInfo.symbol) && isImportableSymbol(exported, checker) && ts3.addToSeen(seenExports, key)) {
                cache.add(importingFile.path, exported, key, moduleSymbol, moduleFile, 0, isFromPackageJson, checker);
              }
            });
          });
        } catch (err) {
          cache.clear();
          throw err;
        }
        (_e = host.log) === null || _e === void 0 ? void 0 : _e.call(host, "getExportInfoMap: done in ".concat(ts3.timestamp() - start, " ms"));
        return cache;
      }
      ts3.getExportInfoMap = getExportInfoMap;
      function getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions) {
        var exported = getDefaultLikeExportWorker(moduleSymbol, checker);
        if (!exported)
          return void 0;
        var symbol = exported.symbol, exportKind = exported.exportKind;
        var info = getDefaultExportInfoWorker(symbol, checker, compilerOptions);
        return info && __assign({ symbol, exportKind }, info);
      }
      ts3.getDefaultLikeExportInfo = getDefaultLikeExportInfo;
      function isImportableSymbol(symbol, checker) {
        return !checker.isUndefinedSymbol(symbol) && !checker.isUnknownSymbol(symbol) && !ts3.isKnownSymbol(symbol) && !ts3.isPrivateIdentifierSymbol(symbol);
      }
      function getDefaultLikeExportWorker(moduleSymbol, checker) {
        var exportEquals = checker.resolveExternalModuleSymbol(moduleSymbol);
        if (exportEquals !== moduleSymbol)
          return { symbol: exportEquals, exportKind: 2 };
        var defaultExport = checker.tryGetMemberInModuleExports("default", moduleSymbol);
        if (defaultExport)
          return { symbol: defaultExport, exportKind: 1 };
      }
      function getDefaultExportInfoWorker(defaultExport, checker, compilerOptions) {
        var localSymbol = ts3.getLocalSymbolForExportDefault(defaultExport);
        if (localSymbol)
          return { symbolForMeaning: localSymbol, name: localSymbol.name };
        var name = getNameForExportDefault(defaultExport);
        if (name !== void 0)
          return { symbolForMeaning: defaultExport, name };
        if (defaultExport.flags & 2097152) {
          var aliased = checker.getImmediateAliasedSymbol(defaultExport);
          if (aliased && aliased.parent) {
            return getDefaultExportInfoWorker(aliased, checker, compilerOptions);
          }
        }
        if (defaultExport.escapedName !== "default" && defaultExport.escapedName !== "export=") {
          return { symbolForMeaning: defaultExport, name: defaultExport.getName() };
        }
        return { symbolForMeaning: defaultExport, name: ts3.getNameForExportedSymbol(defaultExport, compilerOptions.target) };
      }
      function getNameForExportDefault(symbol) {
        return symbol.declarations && ts3.firstDefined(symbol.declarations, function(declaration) {
          var _a;
          if (ts3.isExportAssignment(declaration)) {
            return (_a = ts3.tryCast(ts3.skipOuterExpressions(declaration.expression), ts3.isIdentifier)) === null || _a === void 0 ? void 0 : _a.text;
          } else if (ts3.isExportSpecifier(declaration)) {
            ts3.Debug.assert(declaration.name.text === "default", "Expected the specifier to be a default export");
            return declaration.propertyName && declaration.propertyName.text;
          }
        });
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createClassifier() {
        var scanner = ts3.createScanner(99, false);
        function getClassificationsForLine(text, lexState, syntacticClassifierAbsent) {
          return convertClassificationsToResult(getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent), text);
        }
        function getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent) {
          var token = 0;
          var lastNonTriviaToken = 0;
          var templateStack = [];
          var _a = getPrefixFromLexState(lexState), prefix = _a.prefix, pushTemplate = _a.pushTemplate;
          text = prefix + text;
          var offset = prefix.length;
          if (pushTemplate) {
            templateStack.push(15);
          }
          scanner.setText(text);
          var endOfLineState = 0;
          var spans = [];
          var angleBracketStack = 0;
          do {
            token = scanner.scan();
            if (!ts3.isTrivia(token)) {
              handleToken();
              lastNonTriviaToken = token;
            }
            var end = scanner.getTextPos();
            pushEncodedClassification(scanner.getTokenPos(), end, offset, classFromKind(token), spans);
            if (end >= text.length) {
              var end_1 = getNewEndOfLineState(scanner, token, ts3.lastOrUndefined(templateStack));
              if (end_1 !== void 0) {
                endOfLineState = end_1;
              }
            }
          } while (token !== 1);
          function handleToken() {
            switch (token) {
              case 43:
              case 68:
                if (!noRegexTable[lastNonTriviaToken] && scanner.reScanSlashToken() === 13) {
                  token = 13;
                }
                break;
              case 29:
                if (lastNonTriviaToken === 79) {
                  angleBracketStack++;
                }
                break;
              case 31:
                if (angleBracketStack > 0) {
                  angleBracketStack--;
                }
                break;
              case 130:
              case 150:
              case 147:
              case 133:
              case 151:
                if (angleBracketStack > 0 && !syntacticClassifierAbsent) {
                  token = 79;
                }
                break;
              case 15:
                templateStack.push(token);
                break;
              case 18:
                if (templateStack.length > 0) {
                  templateStack.push(token);
                }
                break;
              case 19:
                if (templateStack.length > 0) {
                  var lastTemplateStackToken = ts3.lastOrUndefined(templateStack);
                  if (lastTemplateStackToken === 15) {
                    token = scanner.reScanTemplateToken(false);
                    if (token === 17) {
                      templateStack.pop();
                    } else {
                      ts3.Debug.assertEqual(token, 16, "Should have been a template middle.");
                    }
                  } else {
                    ts3.Debug.assertEqual(lastTemplateStackToken, 18, "Should have been an open brace");
                    templateStack.pop();
                  }
                }
                break;
              default:
                if (!ts3.isKeyword(token)) {
                  break;
                }
                if (lastNonTriviaToken === 24) {
                  token = 79;
                } else if (ts3.isKeyword(lastNonTriviaToken) && ts3.isKeyword(token) && !canFollow(lastNonTriviaToken, token)) {
                  token = 79;
                }
            }
          }
          return { endOfLineState, spans };
        }
        return { getClassificationsForLine, getEncodedLexicalClassifications };
      }
      ts3.createClassifier = createClassifier;
      var noRegexTable = ts3.arrayToNumericMap([
        79,
        10,
        8,
        9,
        13,
        108,
        45,
        46,
        21,
        23,
        19,
        110,
        95
      ], function(token) {
        return token;
      }, function() {
        return true;
      });
      function getNewEndOfLineState(scanner, token, lastOnTemplateStack) {
        switch (token) {
          case 10: {
            if (!scanner.isUnterminated())
              return void 0;
            var tokenText = scanner.getTokenText();
            var lastCharIndex = tokenText.length - 1;
            var numBackslashes = 0;
            while (tokenText.charCodeAt(lastCharIndex - numBackslashes) === 92) {
              numBackslashes++;
            }
            if ((numBackslashes & 1) === 0)
              return void 0;
            return tokenText.charCodeAt(0) === 34 ? 3 : 2;
          }
          case 3:
            return scanner.isUnterminated() ? 1 : void 0;
          default:
            if (ts3.isTemplateLiteralKind(token)) {
              if (!scanner.isUnterminated()) {
                return void 0;
              }
              switch (token) {
                case 17:
                  return 5;
                case 14:
                  return 4;
                default:
                  return ts3.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #" + token);
              }
            }
            return lastOnTemplateStack === 15 ? 6 : void 0;
        }
      }
      function pushEncodedClassification(start, end, offset, classification, result2) {
        if (classification === 8) {
          return;
        }
        if (start === 0 && offset > 0) {
          start += offset;
        }
        var length = end - start;
        if (length > 0) {
          result2.push(start - offset, length, classification);
        }
      }
      function convertClassificationsToResult(classifications, text) {
        var entries = [];
        var dense = classifications.spans;
        var lastEnd = 0;
        for (var i = 0; i < dense.length; i += 3) {
          var start = dense[i];
          var length_1 = dense[i + 1];
          var type2 = dense[i + 2];
          if (lastEnd >= 0) {
            var whitespaceLength_1 = start - lastEnd;
            if (whitespaceLength_1 > 0) {
              entries.push({ length: whitespaceLength_1, classification: ts3.TokenClass.Whitespace });
            }
          }
          entries.push({ length: length_1, classification: convertClassification(type2) });
          lastEnd = start + length_1;
        }
        var whitespaceLength = text.length - lastEnd;
        if (whitespaceLength > 0) {
          entries.push({ length: whitespaceLength, classification: ts3.TokenClass.Whitespace });
        }
        return { entries, finalLexState: classifications.endOfLineState };
      }
      function convertClassification(type2) {
        switch (type2) {
          case 1:
            return ts3.TokenClass.Comment;
          case 3:
            return ts3.TokenClass.Keyword;
          case 4:
            return ts3.TokenClass.NumberLiteral;
          case 25:
            return ts3.TokenClass.BigIntLiteral;
          case 5:
            return ts3.TokenClass.Operator;
          case 6:
            return ts3.TokenClass.StringLiteral;
          case 8:
            return ts3.TokenClass.Whitespace;
          case 10:
            return ts3.TokenClass.Punctuation;
          case 2:
          case 11:
          case 12:
          case 13:
          case 14:
          case 15:
          case 16:
          case 9:
          case 17:
            return ts3.TokenClass.Identifier;
          default:
            return void 0;
        }
      }
      function canFollow(keyword1, keyword2) {
        if (!ts3.isAccessibilityModifier(keyword1)) {
          return true;
        }
        switch (keyword2) {
          case 136:
          case 149:
          case 134:
          case 124:
            return true;
          default:
            return false;
        }
      }
      function getPrefixFromLexState(lexState) {
        switch (lexState) {
          case 3:
            return { prefix: '"\\\n' };
          case 2:
            return { prefix: "'\\\n" };
          case 1:
            return { prefix: "/*\n" };
          case 4:
            return { prefix: "`\n" };
          case 5:
            return { prefix: "}\n", pushTemplate: true };
          case 6:
            return { prefix: "", pushTemplate: true };
          case 0:
            return { prefix: "" };
          default:
            return ts3.Debug.assertNever(lexState);
        }
      }
      function isBinaryExpressionOperatorToken(token) {
        switch (token) {
          case 41:
          case 43:
          case 44:
          case 39:
          case 40:
          case 47:
          case 48:
          case 49:
          case 29:
          case 31:
          case 32:
          case 33:
          case 102:
          case 101:
          case 127:
          case 34:
          case 35:
          case 36:
          case 37:
          case 50:
          case 52:
          case 51:
          case 55:
          case 56:
          case 74:
          case 73:
          case 78:
          case 70:
          case 71:
          case 72:
          case 64:
          case 65:
          case 66:
          case 68:
          case 69:
          case 63:
          case 27:
          case 60:
          case 75:
          case 76:
          case 77:
            return true;
          default:
            return false;
        }
      }
      function isPrefixUnaryExpressionOperatorToken(token) {
        switch (token) {
          case 39:
          case 40:
          case 54:
          case 53:
          case 45:
          case 46:
            return true;
          default:
            return false;
        }
      }
      function classFromKind(token) {
        if (ts3.isKeyword(token)) {
          return 3;
        } else if (isBinaryExpressionOperatorToken(token) || isPrefixUnaryExpressionOperatorToken(token)) {
          return 5;
        } else if (token >= 18 && token <= 78) {
          return 10;
        }
        switch (token) {
          case 8:
            return 4;
          case 9:
            return 25;
          case 10:
            return 6;
          case 13:
            return 7;
          case 7:
          case 3:
          case 2:
            return 1;
          case 5:
          case 4:
            return 8;
          case 79:
          default:
            if (ts3.isTemplateLiteralKind(token)) {
              return 6;
            }
            return 2;
        }
      }
      function getSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
        return convertClassificationsToSpans(getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span));
      }
      ts3.getSemanticClassifications = getSemanticClassifications;
      function checkForClassificationCancellation(cancellationToken, kind) {
        switch (kind) {
          case 261:
          case 257:
          case 258:
          case 256:
          case 226:
          case 213:
          case 214:
            cancellationToken.throwIfCancellationRequested();
        }
      }
      function getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
        var spans = [];
        sourceFile.forEachChild(function cb(node) {
          if (!node || !ts3.textSpanIntersectsWith(span, node.pos, node.getFullWidth())) {
            return;
          }
          checkForClassificationCancellation(cancellationToken, node.kind);
          if (ts3.isIdentifier(node) && !ts3.nodeIsMissing(node) && classifiableNames.has(node.escapedText)) {
            var symbol = typeChecker.getSymbolAtLocation(node);
            var type2 = symbol && classifySymbol(symbol, ts3.getMeaningFromLocation(node), typeChecker);
            if (type2) {
              pushClassification(node.getStart(sourceFile), node.getEnd(), type2);
            }
          }
          node.forEachChild(cb);
        });
        return { spans, endOfLineState: 0 };
        function pushClassification(start, end, type2) {
          var length = end - start;
          ts3.Debug.assert(length > 0, "Classification had non-positive length of ".concat(length));
          spans.push(start);
          spans.push(length);
          spans.push(type2);
        }
      }
      ts3.getEncodedSemanticClassifications = getEncodedSemanticClassifications;
      function classifySymbol(symbol, meaningAtPosition, checker) {
        var flags = symbol.getFlags();
        if ((flags & 2885600) === 0) {
          return void 0;
        } else if (flags & 32) {
          return 11;
        } else if (flags & 384) {
          return 12;
        } else if (flags & 524288) {
          return 16;
        } else if (flags & 1536) {
          return meaningAtPosition & 4 || meaningAtPosition & 1 && hasValueSideModule(symbol) ? 14 : void 0;
        } else if (flags & 2097152) {
          return classifySymbol(checker.getAliasedSymbol(symbol), meaningAtPosition, checker);
        } else if (meaningAtPosition & 2) {
          return flags & 64 ? 13 : flags & 262144 ? 15 : void 0;
        } else {
          return void 0;
        }
      }
      function hasValueSideModule(symbol) {
        return ts3.some(symbol.declarations, function(declaration) {
          return ts3.isModuleDeclaration(declaration) && ts3.getModuleInstanceState(declaration) === 1;
        });
      }
      function getClassificationTypeName(type2) {
        switch (type2) {
          case 1:
            return "comment";
          case 2:
            return "identifier";
          case 3:
            return "keyword";
          case 4:
            return "number";
          case 25:
            return "bigint";
          case 5:
            return "operator";
          case 6:
            return "string";
          case 8:
            return "whitespace";
          case 9:
            return "text";
          case 10:
            return "punctuation";
          case 11:
            return "class name";
          case 12:
            return "enum name";
          case 13:
            return "interface name";
          case 14:
            return "module name";
          case 15:
            return "type parameter name";
          case 16:
            return "type alias name";
          case 17:
            return "parameter name";
          case 18:
            return "doc comment tag name";
          case 19:
            return "jsx open tag name";
          case 20:
            return "jsx close tag name";
          case 21:
            return "jsx self closing tag name";
          case 22:
            return "jsx attribute";
          case 23:
            return "jsx text";
          case 24:
            return "jsx attribute string literal value";
          default:
            return void 0;
        }
      }
      function convertClassificationsToSpans(classifications) {
        ts3.Debug.assert(classifications.spans.length % 3 === 0);
        var dense = classifications.spans;
        var result2 = [];
        for (var i = 0; i < dense.length; i += 3) {
          result2.push({
            textSpan: ts3.createTextSpan(dense[i], dense[i + 1]),
            classificationType: getClassificationTypeName(dense[i + 2])
          });
        }
        return result2;
      }
      function getSyntacticClassifications(cancellationToken, sourceFile, span) {
        return convertClassificationsToSpans(getEncodedSyntacticClassifications(cancellationToken, sourceFile, span));
      }
      ts3.getSyntacticClassifications = getSyntacticClassifications;
      function getEncodedSyntacticClassifications(cancellationToken, sourceFile, span) {
        var spanStart = span.start;
        var spanLength = span.length;
        var triviaScanner = ts3.createScanner(99, false, sourceFile.languageVariant, sourceFile.text);
        var mergeConflictScanner = ts3.createScanner(99, false, sourceFile.languageVariant, sourceFile.text);
        var result2 = [];
        processElement(sourceFile);
        return { spans: result2, endOfLineState: 0 };
        function pushClassification(start, length, type2) {
          result2.push(start);
          result2.push(length);
          result2.push(type2);
        }
        function classifyLeadingTriviaAndGetTokenStart(token) {
          triviaScanner.setTextPos(token.pos);
          while (true) {
            var start = triviaScanner.getTextPos();
            if (!ts3.couldStartTrivia(sourceFile.text, start)) {
              return start;
            }
            var kind = triviaScanner.scan();
            var end = triviaScanner.getTextPos();
            var width = end - start;
            if (!ts3.isTrivia(kind)) {
              return start;
            }
            switch (kind) {
              case 4:
              case 5:
                continue;
              case 2:
              case 3:
                classifyComment(token, kind, start, width);
                triviaScanner.setTextPos(end);
                continue;
              case 7:
                var text = sourceFile.text;
                var ch = text.charCodeAt(start);
                if (ch === 60 || ch === 62) {
                  pushClassification(start, width, 1);
                  continue;
                }
                ts3.Debug.assert(ch === 124 || ch === 61);
                classifyDisabledMergeCode(text, start, end);
                break;
              case 6:
                break;
              default:
                ts3.Debug.assertNever(kind);
            }
          }
        }
        function classifyComment(token, kind, start, width) {
          if (kind === 3) {
            var docCommentAndDiagnostics = ts3.parseIsolatedJSDocComment(sourceFile.text, start, width);
            if (docCommentAndDiagnostics && docCommentAndDiagnostics.jsDoc) {
              ts3.setParent(docCommentAndDiagnostics.jsDoc, token);
              classifyJSDocComment(docCommentAndDiagnostics.jsDoc);
              return;
            }
          } else if (kind === 2) {
            if (tryClassifyTripleSlashComment(start, width)) {
              return;
            }
          }
          pushCommentRange(start, width);
        }
        function pushCommentRange(start, width) {
          pushClassification(start, width, 1);
        }
        function classifyJSDocComment(docComment) {
          var _a, _b, _c, _d, _e, _f, _g;
          var pos = docComment.pos;
          if (docComment.tags) {
            for (var _i = 0, _h = docComment.tags; _i < _h.length; _i++) {
              var tag = _h[_i];
              if (tag.pos !== pos) {
                pushCommentRange(pos, tag.pos - pos);
              }
              pushClassification(tag.pos, 1, 10);
              pushClassification(tag.tagName.pos, tag.tagName.end - tag.tagName.pos, 18);
              pos = tag.tagName.end;
              var commentStart = tag.tagName.end;
              switch (tag.kind) {
                case 340:
                  var param = tag;
                  processJSDocParameterTag(param);
                  commentStart = param.isNameFirst && ((_a = param.typeExpression) === null || _a === void 0 ? void 0 : _a.end) || param.name.end;
                  break;
                case 347:
                  var prop = tag;
                  commentStart = prop.isNameFirst && ((_b = prop.typeExpression) === null || _b === void 0 ? void 0 : _b.end) || prop.name.end;
                  break;
                case 344:
                  processJSDocTemplateTag(tag);
                  pos = tag.end;
                  commentStart = tag.typeParameters.end;
                  break;
                case 345:
                  var type2 = tag;
                  commentStart = ((_c = type2.typeExpression) === null || _c === void 0 ? void 0 : _c.kind) === 309 && ((_d = type2.fullName) === null || _d === void 0 ? void 0 : _d.end) || ((_e = type2.typeExpression) === null || _e === void 0 ? void 0 : _e.end) || commentStart;
                  break;
                case 338:
                  commentStart = tag.typeExpression.end;
                  break;
                case 343:
                  processElement(tag.typeExpression);
                  pos = tag.end;
                  commentStart = tag.typeExpression.end;
                  break;
                case 342:
                case 339:
                  commentStart = tag.typeExpression.end;
                  break;
                case 341:
                  processElement(tag.typeExpression);
                  pos = tag.end;
                  commentStart = ((_f = tag.typeExpression) === null || _f === void 0 ? void 0 : _f.end) || commentStart;
                  break;
                case 346:
                  commentStart = ((_g = tag.name) === null || _g === void 0 ? void 0 : _g.end) || commentStart;
                  break;
                case 328:
                case 329:
                  commentStart = tag.class.end;
                  break;
              }
              if (typeof tag.comment === "object") {
                pushCommentRange(tag.comment.pos, tag.comment.end - tag.comment.pos);
              } else if (typeof tag.comment === "string") {
                pushCommentRange(commentStart, tag.end - commentStart);
              }
            }
          }
          if (pos !== docComment.end) {
            pushCommentRange(pos, docComment.end - pos);
          }
          return;
          function processJSDocParameterTag(tag2) {
            if (tag2.isNameFirst) {
              pushCommentRange(pos, tag2.name.pos - pos);
              pushClassification(tag2.name.pos, tag2.name.end - tag2.name.pos, 17);
              pos = tag2.name.end;
            }
            if (tag2.typeExpression) {
              pushCommentRange(pos, tag2.typeExpression.pos - pos);
              processElement(tag2.typeExpression);
              pos = tag2.typeExpression.end;
            }
            if (!tag2.isNameFirst) {
              pushCommentRange(pos, tag2.name.pos - pos);
              pushClassification(tag2.name.pos, tag2.name.end - tag2.name.pos, 17);
              pos = tag2.name.end;
            }
          }
        }
        function tryClassifyTripleSlashComment(start, width) {
          var tripleSlashXMLCommentRegEx = /^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im;
          var attributeRegex = /(\s)(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img;
          var text = sourceFile.text.substr(start, width);
          var match = tripleSlashXMLCommentRegEx.exec(text);
          if (!match) {
            return false;
          }
          if (!match[3] || !(match[3] in ts3.commentPragmas)) {
            return false;
          }
          var pos = start;
          pushCommentRange(pos, match[1].length);
          pos += match[1].length;
          pushClassification(pos, match[2].length, 10);
          pos += match[2].length;
          pushClassification(pos, match[3].length, 21);
          pos += match[3].length;
          var attrText = match[4];
          var attrPos = pos;
          while (true) {
            var attrMatch = attributeRegex.exec(attrText);
            if (!attrMatch) {
              break;
            }
            var newAttrPos = pos + attrMatch.index + attrMatch[1].length;
            if (newAttrPos > attrPos) {
              pushCommentRange(attrPos, newAttrPos - attrPos);
              attrPos = newAttrPos;
            }
            pushClassification(attrPos, attrMatch[2].length, 22);
            attrPos += attrMatch[2].length;
            if (attrMatch[3].length) {
              pushCommentRange(attrPos, attrMatch[3].length);
              attrPos += attrMatch[3].length;
            }
            pushClassification(attrPos, attrMatch[4].length, 5);
            attrPos += attrMatch[4].length;
            if (attrMatch[5].length) {
              pushCommentRange(attrPos, attrMatch[5].length);
              attrPos += attrMatch[5].length;
            }
            pushClassification(attrPos, attrMatch[6].length, 24);
            attrPos += attrMatch[6].length;
          }
          pos += match[4].length;
          if (pos > attrPos) {
            pushCommentRange(attrPos, pos - attrPos);
          }
          if (match[5]) {
            pushClassification(pos, match[5].length, 10);
            pos += match[5].length;
          }
          var end = start + width;
          if (pos < end) {
            pushCommentRange(pos, end - pos);
          }
          return true;
        }
        function processJSDocTemplateTag(tag) {
          for (var _i = 0, _a = tag.getChildren(); _i < _a.length; _i++) {
            var child = _a[_i];
            processElement(child);
          }
        }
        function classifyDisabledMergeCode(text, start, end) {
          var i;
          for (i = start; i < end; i++) {
            if (ts3.isLineBreak(text.charCodeAt(i))) {
              break;
            }
          }
          pushClassification(start, i - start, 1);
          mergeConflictScanner.setTextPos(i);
          while (mergeConflictScanner.getTextPos() < end) {
            classifyDisabledCodeToken();
          }
        }
        function classifyDisabledCodeToken() {
          var start = mergeConflictScanner.getTextPos();
          var tokenKind = mergeConflictScanner.scan();
          var end = mergeConflictScanner.getTextPos();
          var type2 = classifyTokenType(tokenKind);
          if (type2) {
            pushClassification(start, end - start, type2);
          }
        }
        function tryClassifyNode(node) {
          if (ts3.isJSDoc(node)) {
            return true;
          }
          if (ts3.nodeIsMissing(node)) {
            return true;
          }
          var classifiedElementName = tryClassifyJsxElementName(node);
          if (!ts3.isToken(node) && node.kind !== 11 && classifiedElementName === void 0) {
            return false;
          }
          var tokenStart = node.kind === 11 ? node.pos : classifyLeadingTriviaAndGetTokenStart(node);
          var tokenWidth = node.end - tokenStart;
          ts3.Debug.assert(tokenWidth >= 0);
          if (tokenWidth > 0) {
            var type2 = classifiedElementName || classifyTokenType(node.kind, node);
            if (type2) {
              pushClassification(tokenStart, tokenWidth, type2);
            }
          }
          return true;
        }
        function tryClassifyJsxElementName(token) {
          switch (token.parent && token.parent.kind) {
            case 280:
              if (token.parent.tagName === token) {
                return 19;
              }
              break;
            case 281:
              if (token.parent.tagName === token) {
                return 20;
              }
              break;
            case 279:
              if (token.parent.tagName === token) {
                return 21;
              }
              break;
            case 285:
              if (token.parent.name === token) {
                return 22;
              }
              break;
          }
          return void 0;
        }
        function classifyTokenType(tokenKind, token) {
          if (ts3.isKeyword(tokenKind)) {
            return 3;
          }
          if (tokenKind === 29 || tokenKind === 31) {
            if (token && ts3.getTypeArgumentOrTypeParameterList(token.parent)) {
              return 10;
            }
          }
          if (ts3.isPunctuation(tokenKind)) {
            if (token) {
              var parent = token.parent;
              if (tokenKind === 63) {
                if (parent.kind === 254 || parent.kind === 167 || parent.kind === 164 || parent.kind === 285) {
                  return 5;
                }
              }
              if (parent.kind === 221 || parent.kind === 219 || parent.kind === 220 || parent.kind === 222) {
                return 5;
              }
            }
            return 10;
          } else if (tokenKind === 8) {
            return 4;
          } else if (tokenKind === 9) {
            return 25;
          } else if (tokenKind === 10) {
            return token && token.parent.kind === 285 ? 24 : 6;
          } else if (tokenKind === 13) {
            return 6;
          } else if (ts3.isTemplateLiteralKind(tokenKind)) {
            return 6;
          } else if (tokenKind === 11) {
            return 23;
          } else if (tokenKind === 79) {
            if (token) {
              switch (token.parent.kind) {
                case 257:
                  if (token.parent.name === token) {
                    return 11;
                  }
                  return;
                case 163:
                  if (token.parent.name === token) {
                    return 15;
                  }
                  return;
                case 258:
                  if (token.parent.name === token) {
                    return 13;
                  }
                  return;
                case 260:
                  if (token.parent.name === token) {
                    return 12;
                  }
                  return;
                case 261:
                  if (token.parent.name === token) {
                    return 14;
                  }
                  return;
                case 164:
                  if (token.parent.name === token) {
                    return ts3.isThisIdentifier(token) ? 3 : 17;
                  }
                  return;
              }
              if (ts3.isConstTypeReference(token.parent)) {
                return 3;
              }
            }
            return 2;
          }
        }
        function processElement(element) {
          if (!element) {
            return;
          }
          if (ts3.decodedTextSpanIntersectsWith(spanStart, spanLength, element.pos, element.getFullWidth())) {
            checkForClassificationCancellation(cancellationToken, element.kind);
            for (var _i = 0, _a = element.getChildren(sourceFile); _i < _a.length; _i++) {
              var child = _a[_i];
              if (!tryClassifyNode(child)) {
                processElement(child);
              }
            }
          }
        }
      }
      ts3.getEncodedSyntacticClassifications = getEncodedSyntacticClassifications;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var classifier;
      (function(classifier2) {
        var v2020;
        (function(v20202) {
          var TokenEncodingConsts;
          (function(TokenEncodingConsts2) {
            TokenEncodingConsts2[TokenEncodingConsts2["typeOffset"] = 8] = "typeOffset";
            TokenEncodingConsts2[TokenEncodingConsts2["modifierMask"] = 255] = "modifierMask";
          })(TokenEncodingConsts = v20202.TokenEncodingConsts || (v20202.TokenEncodingConsts = {}));
          var TokenType;
          (function(TokenType2) {
            TokenType2[TokenType2["class"] = 0] = "class";
            TokenType2[TokenType2["enum"] = 1] = "enum";
            TokenType2[TokenType2["interface"] = 2] = "interface";
            TokenType2[TokenType2["namespace"] = 3] = "namespace";
            TokenType2[TokenType2["typeParameter"] = 4] = "typeParameter";
            TokenType2[TokenType2["type"] = 5] = "type";
            TokenType2[TokenType2["parameter"] = 6] = "parameter";
            TokenType2[TokenType2["variable"] = 7] = "variable";
            TokenType2[TokenType2["enumMember"] = 8] = "enumMember";
            TokenType2[TokenType2["property"] = 9] = "property";
            TokenType2[TokenType2["function"] = 10] = "function";
            TokenType2[TokenType2["member"] = 11] = "member";
          })(TokenType = v20202.TokenType || (v20202.TokenType = {}));
          var TokenModifier;
          (function(TokenModifier2) {
            TokenModifier2[TokenModifier2["declaration"] = 0] = "declaration";
            TokenModifier2[TokenModifier2["static"] = 1] = "static";
            TokenModifier2[TokenModifier2["async"] = 2] = "async";
            TokenModifier2[TokenModifier2["readonly"] = 3] = "readonly";
            TokenModifier2[TokenModifier2["defaultLibrary"] = 4] = "defaultLibrary";
            TokenModifier2[TokenModifier2["local"] = 5] = "local";
          })(TokenModifier = v20202.TokenModifier || (v20202.TokenModifier = {}));
          function getSemanticClassifications(program2, cancellationToken, sourceFile, span) {
            var classifications = getEncodedSemanticClassifications(program2, cancellationToken, sourceFile, span);
            ts3.Debug.assert(classifications.spans.length % 3 === 0);
            var dense = classifications.spans;
            var result2 = [];
            for (var i = 0; i < dense.length; i += 3) {
              result2.push({
                textSpan: ts3.createTextSpan(dense[i], dense[i + 1]),
                classificationType: dense[i + 2]
              });
            }
            return result2;
          }
          v20202.getSemanticClassifications = getSemanticClassifications;
          function getEncodedSemanticClassifications(program2, cancellationToken, sourceFile, span) {
            return {
              spans: getSemanticTokens(program2, sourceFile, span, cancellationToken),
              endOfLineState: 0
            };
          }
          v20202.getEncodedSemanticClassifications = getEncodedSemanticClassifications;
          function getSemanticTokens(program2, sourceFile, span, cancellationToken) {
            var resultTokens = [];
            var collector = function(node, typeIdx, modifierSet) {
              resultTokens.push(node.getStart(sourceFile), node.getWidth(sourceFile), (typeIdx + 1 << 8) + modifierSet);
            };
            if (program2 && sourceFile) {
              collectTokens(program2, sourceFile, span, collector, cancellationToken);
            }
            return resultTokens;
          }
          function collectTokens(program2, sourceFile, span, collector, cancellationToken) {
            var typeChecker = program2.getTypeChecker();
            var inJSXElement = false;
            function visit(node) {
              switch (node.kind) {
                case 261:
                case 257:
                case 258:
                case 256:
                case 226:
                case 213:
                case 214:
                  cancellationToken.throwIfCancellationRequested();
              }
              if (!node || !ts3.textSpanIntersectsWith(span, node.pos, node.getFullWidth()) || node.getFullWidth() === 0) {
                return;
              }
              var prevInJSXElement = inJSXElement;
              if (ts3.isJsxElement(node) || ts3.isJsxSelfClosingElement(node)) {
                inJSXElement = true;
              }
              if (ts3.isJsxExpression(node)) {
                inJSXElement = false;
              }
              if (ts3.isIdentifier(node) && !inJSXElement && !inImportClause(node) && !ts3.isInfinityOrNaNString(node.escapedText)) {
                var symbol = typeChecker.getSymbolAtLocation(node);
                if (symbol) {
                  if (symbol.flags & 2097152) {
                    symbol = typeChecker.getAliasedSymbol(symbol);
                  }
                  var typeIdx = classifySymbol(symbol, ts3.getMeaningFromLocation(node));
                  if (typeIdx !== void 0) {
                    var modifierSet = 0;
                    if (node.parent) {
                      var parentIsDeclaration = ts3.isBindingElement(node.parent) || tokenFromDeclarationMapping.get(node.parent.kind) === typeIdx;
                      if (parentIsDeclaration && node.parent.name === node) {
                        modifierSet = 1 << 0;
                      }
                    }
                    if (typeIdx === 6 && isRightSideOfQualifiedNameOrPropertyAccess(node)) {
                      typeIdx = 9;
                    }
                    typeIdx = reclassifyByType(typeChecker, node, typeIdx);
                    var decl = symbol.valueDeclaration;
                    if (decl) {
                      var modifiers = ts3.getCombinedModifierFlags(decl);
                      var nodeFlags = ts3.getCombinedNodeFlags(decl);
                      if (modifiers & 32) {
                        modifierSet |= 1 << 1;
                      }
                      if (modifiers & 256) {
                        modifierSet |= 1 << 2;
                      }
                      if (typeIdx !== 0 && typeIdx !== 2) {
                        if (modifiers & 64 || nodeFlags & 2 || symbol.getFlags() & 8) {
                          modifierSet |= 1 << 3;
                        }
                      }
                      if ((typeIdx === 7 || typeIdx === 10) && isLocalDeclaration(decl, sourceFile)) {
                        modifierSet |= 1 << 5;
                      }
                      if (program2.isSourceFileDefaultLibrary(decl.getSourceFile())) {
                        modifierSet |= 1 << 4;
                      }
                    } else if (symbol.declarations && symbol.declarations.some(function(d) {
                      return program2.isSourceFileDefaultLibrary(d.getSourceFile());
                    })) {
                      modifierSet |= 1 << 4;
                    }
                    collector(node, typeIdx, modifierSet);
                  }
                }
              }
              ts3.forEachChild(node, visit);
              inJSXElement = prevInJSXElement;
            }
            visit(sourceFile);
          }
          function classifySymbol(symbol, meaning) {
            var flags = symbol.getFlags();
            if (flags & 32) {
              return 0;
            } else if (flags & 384) {
              return 1;
            } else if (flags & 524288) {
              return 5;
            } else if (flags & 64) {
              if (meaning & 2) {
                return 2;
              }
            } else if (flags & 262144) {
              return 4;
            }
            var decl = symbol.valueDeclaration || symbol.declarations && symbol.declarations[0];
            if (decl && ts3.isBindingElement(decl)) {
              decl = getDeclarationForBindingElement(decl);
            }
            return decl && tokenFromDeclarationMapping.get(decl.kind);
          }
          function reclassifyByType(typeChecker, node, typeIdx) {
            if (typeIdx === 7 || typeIdx === 9 || typeIdx === 6) {
              var type_1 = typeChecker.getTypeAtLocation(node);
              if (type_1) {
                var test = function(condition) {
                  return condition(type_1) || type_1.isUnion() && type_1.types.some(condition);
                };
                if (typeIdx !== 6 && test(function(t) {
                  return t.getConstructSignatures().length > 0;
                })) {
                  return 0;
                }
                if (test(function(t) {
                  return t.getCallSignatures().length > 0;
                }) && !test(function(t) {
                  return t.getProperties().length > 0;
                }) || isExpressionInCallExpression(node)) {
                  return typeIdx === 9 ? 11 : 10;
                }
              }
            }
            return typeIdx;
          }
          function isLocalDeclaration(decl, sourceFile) {
            if (ts3.isBindingElement(decl)) {
              decl = getDeclarationForBindingElement(decl);
            }
            if (ts3.isVariableDeclaration(decl)) {
              return (!ts3.isSourceFile(decl.parent.parent.parent) || ts3.isCatchClause(decl.parent)) && decl.getSourceFile() === sourceFile;
            } else if (ts3.isFunctionDeclaration(decl)) {
              return !ts3.isSourceFile(decl.parent) && decl.getSourceFile() === sourceFile;
            }
            return false;
          }
          function getDeclarationForBindingElement(element) {
            while (true) {
              if (ts3.isBindingElement(element.parent.parent)) {
                element = element.parent.parent;
              } else {
                return element.parent.parent;
              }
            }
          }
          function inImportClause(node) {
            var parent = node.parent;
            return parent && (ts3.isImportClause(parent) || ts3.isImportSpecifier(parent) || ts3.isNamespaceImport(parent));
          }
          function isExpressionInCallExpression(node) {
            while (isRightSideOfQualifiedNameOrPropertyAccess(node)) {
              node = node.parent;
            }
            return ts3.isCallExpression(node.parent) && node.parent.expression === node;
          }
          function isRightSideOfQualifiedNameOrPropertyAccess(node) {
            return ts3.isQualifiedName(node.parent) && node.parent.right === node || ts3.isPropertyAccessExpression(node.parent) && node.parent.name === node;
          }
          var tokenFromDeclarationMapping = new ts3.Map([
            [254, 7],
            [164, 6],
            [167, 9],
            [261, 3],
            [260, 1],
            [299, 8],
            [257, 0],
            [169, 11],
            [256, 10],
            [213, 10],
            [168, 11],
            [172, 9],
            [173, 9],
            [166, 9],
            [258, 2],
            [259, 5],
            [163, 4],
            [296, 9],
            [297, 9]
          ]);
        })(v2020 = classifier2.v2020 || (classifier2.v2020 = {}));
      })(classifier = ts3.classifier || (ts3.classifier = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var Completions;
      (function(Completions2) {
        var StringCompletions;
        (function(StringCompletions2) {
          function getStringLiteralCompletions(sourceFile, position, contextToken, options, host, program2, log, preferences) {
            if (ts3.isInReferenceComment(sourceFile, position)) {
              var entries = getTripleSlashReferenceCompletion(sourceFile, position, options, host);
              return entries && convertPathCompletions(entries);
            }
            if (ts3.isInString(sourceFile, position, contextToken)) {
              if (!contextToken || !ts3.isStringLiteralLike(contextToken))
                return void 0;
              var entries = getStringLiteralCompletionEntries(sourceFile, contextToken, position, program2.getTypeChecker(), options, host, preferences);
              return convertStringLiteralCompletions(entries, contextToken, sourceFile, host, program2, log, options, preferences);
            }
          }
          StringCompletions2.getStringLiteralCompletions = getStringLiteralCompletions;
          function convertStringLiteralCompletions(completion, contextToken, sourceFile, host, program2, log, options, preferences) {
            if (completion === void 0) {
              return void 0;
            }
            var optionalReplacementSpan = ts3.createTextSpanFromStringLiteralLikeContent(contextToken);
            switch (completion.kind) {
              case 0:
                return convertPathCompletions(completion.paths);
              case 1: {
                var entries = ts3.createSortedArray();
                Completions2.getCompletionEntriesFromSymbols(completion.symbols, entries, contextToken, contextToken, sourceFile, sourceFile, host, program2, 99, log, 4, preferences, options, void 0);
                return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: completion.hasIndexSignature, optionalReplacementSpan, entries };
              }
              case 2: {
                var entries = completion.types.map(function(type2) {
                  return {
                    name: type2.value,
                    kindModifiers: "",
                    kind: "string",
                    sortText: Completions2.SortText.LocationPriority,
                    replacementSpan: ts3.getReplacementSpanForContextToken(contextToken)
                  };
                });
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: completion.isNewIdentifier, optionalReplacementSpan, entries };
              }
              default:
                return ts3.Debug.assertNever(completion);
            }
          }
          function getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, checker, options, host, cancellationToken, preferences) {
            if (!contextToken || !ts3.isStringLiteralLike(contextToken))
              return void 0;
            var completions = getStringLiteralCompletionEntries(sourceFile, contextToken, position, checker, options, host, preferences);
            return completions && stringLiteralCompletionDetails(name, contextToken, completions, sourceFile, checker, cancellationToken);
          }
          StringCompletions2.getStringLiteralCompletionDetails = getStringLiteralCompletionDetails;
          function stringLiteralCompletionDetails(name, location, completion, sourceFile, checker, cancellationToken) {
            switch (completion.kind) {
              case 0: {
                var match = ts3.find(completion.paths, function(p) {
                  return p.name === name;
                });
                return match && Completions2.createCompletionDetails(name, kindModifiersFromExtension(match.extension), match.kind, [ts3.textPart(name)]);
              }
              case 1: {
                var match = ts3.find(completion.symbols, function(s) {
                  return s.name === name;
                });
                return match && Completions2.createCompletionDetailsForSymbol(match, checker, sourceFile, location, cancellationToken);
              }
              case 2:
                return ts3.find(completion.types, function(t) {
                  return t.value === name;
                }) ? Completions2.createCompletionDetails(name, "", "type", [ts3.textPart(name)]) : void 0;
              default:
                return ts3.Debug.assertNever(completion);
            }
          }
          function convertPathCompletions(pathCompletions) {
            var isGlobalCompletion = false;
            var isNewIdentifierLocation = true;
            var entries = pathCompletions.map(function(_a) {
              var name = _a.name, kind = _a.kind, span = _a.span, extension = _a.extension;
              return { name, kind, kindModifiers: kindModifiersFromExtension(extension), sortText: Completions2.SortText.LocationPriority, replacementSpan: span };
            });
            return { isGlobalCompletion, isMemberCompletion: false, isNewIdentifierLocation, entries };
          }
          function kindModifiersFromExtension(extension) {
            switch (extension) {
              case ".d.ts":
                return ".d.ts";
              case ".js":
                return ".js";
              case ".json":
                return ".json";
              case ".jsx":
                return ".jsx";
              case ".ts":
                return ".ts";
              case ".tsx":
                return ".tsx";
              case ".d.mts":
                return ".d.mts";
              case ".mjs":
                return ".mjs";
              case ".mts":
                return ".mts";
              case ".d.cts":
                return ".d.cts";
              case ".cjs":
                return ".cjs";
              case ".cts":
                return ".cts";
              case ".tsbuildinfo":
                return ts3.Debug.fail("Extension ".concat(".tsbuildinfo", " is unsupported."));
              case void 0:
                return "";
              default:
                return ts3.Debug.assertNever(extension);
            }
          }
          var StringLiteralCompletionKind;
          (function(StringLiteralCompletionKind2) {
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Paths"] = 0] = "Paths";
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Properties"] = 1] = "Properties";
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Types"] = 2] = "Types";
          })(StringLiteralCompletionKind || (StringLiteralCompletionKind = {}));
          function getStringLiteralCompletionEntries(sourceFile, node, position, typeChecker, compilerOptions, host, preferences) {
            var parent = walkUpParentheses(node.parent);
            switch (parent.kind) {
              case 196: {
                var grandParent = walkUpParentheses(parent.parent);
                switch (grandParent.kind) {
                  case 178: {
                    var typeReference_1 = grandParent;
                    var typeArgument = ts3.findAncestor(parent, function(n) {
                      return n.parent === typeReference_1;
                    });
                    if (typeArgument) {
                      return { kind: 2, types: getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(typeArgument)), isNewIdentifier: false };
                    }
                    return void 0;
                  }
                  case 194:
                    var _a = grandParent, indexType = _a.indexType, objectType = _a.objectType;
                    if (!ts3.rangeContainsPosition(indexType, position)) {
                      return void 0;
                    }
                    return stringLiteralCompletionsFromProperties(typeChecker.getTypeFromTypeNode(objectType));
                  case 200:
                    return { kind: 0, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker, preferences) };
                  case 187: {
                    if (!ts3.isTypeReferenceNode(grandParent.parent)) {
                      return void 0;
                    }
                    var alreadyUsedTypes_1 = getAlreadyUsedTypesInStringLiteralUnion(grandParent, parent);
                    var types2 = getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(grandParent)).filter(function(t) {
                      return !ts3.contains(alreadyUsedTypes_1, t.value);
                    });
                    return { kind: 2, types: types2, isNewIdentifier: false };
                  }
                  default:
                    return void 0;
                }
              }
              case 296:
                if (ts3.isObjectLiteralExpression(parent.parent) && parent.name === node) {
                  return stringLiteralCompletionsForObjectLiteral(typeChecker, parent.parent);
                }
                return fromContextualType();
              case 207: {
                var _b = parent, expression = _b.expression, argumentExpression = _b.argumentExpression;
                if (node === ts3.skipParentheses(argumentExpression)) {
                  return stringLiteralCompletionsFromProperties(typeChecker.getTypeAtLocation(expression));
                }
                return void 0;
              }
              case 208:
              case 209:
              case 285:
                if (!isRequireCallArgument(node) && !ts3.isImportCall(parent)) {
                  var argumentInfo = ts3.SignatureHelp.getArgumentInfoForCompletions(parent.kind === 285 ? parent.parent : node, position, sourceFile);
                  return argumentInfo ? getStringLiteralCompletionsFromSignature(argumentInfo.invocation, node, argumentInfo, typeChecker) : fromContextualType();
                }
              case 266:
              case 272:
              case 277:
                return { kind: 0, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker, preferences) };
              default:
                return fromContextualType();
            }
            function fromContextualType() {
              return { kind: 2, types: getStringLiteralTypes(ts3.getContextualTypeFromParent(node, typeChecker)), isNewIdentifier: false };
            }
          }
          function walkUpParentheses(node) {
            switch (node.kind) {
              case 191:
                return ts3.walkUpParenthesizedTypes(node);
              case 212:
                return ts3.walkUpParenthesizedExpressions(node);
              default:
                return node;
            }
          }
          function getAlreadyUsedTypesInStringLiteralUnion(union, current) {
            return ts3.mapDefined(union.types, function(type2) {
              return type2 !== current && ts3.isLiteralTypeNode(type2) && ts3.isStringLiteral(type2.literal) ? type2.literal.text : void 0;
            });
          }
          function getStringLiteralCompletionsFromSignature(call, arg, argumentInfo, checker) {
            var isNewIdentifier = false;
            var uniques = new ts3.Map();
            var candidates = [];
            var editingArgument = ts3.isJsxOpeningLikeElement(call) ? ts3.Debug.checkDefined(ts3.findAncestor(arg.parent, ts3.isJsxAttribute)) : arg;
            checker.getResolvedSignatureForStringLiteralCompletions(call, editingArgument, candidates);
            var types2 = ts3.flatMap(candidates, function(candidate) {
              if (!ts3.signatureHasRestParameter(candidate) && argumentInfo.argumentCount > candidate.parameters.length)
                return;
              var type2 = candidate.getTypeParameterAtPosition(argumentInfo.argumentIndex);
              if (ts3.isJsxOpeningLikeElement(call)) {
                var propType = checker.getTypeOfPropertyOfType(type2, editingArgument.name.text);
                if (propType) {
                  type2 = propType;
                }
              }
              isNewIdentifier = isNewIdentifier || !!(type2.flags & 4);
              return getStringLiteralTypes(type2, uniques);
            });
            return { kind: 2, types: types2, isNewIdentifier };
          }
          function stringLiteralCompletionsFromProperties(type2) {
            return type2 && {
              kind: 1,
              symbols: ts3.filter(type2.getApparentProperties(), function(prop) {
                return !(prop.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(prop.valueDeclaration));
              }),
              hasIndexSignature: ts3.hasIndexSignature(type2)
            };
          }
          function stringLiteralCompletionsForObjectLiteral(checker, objectLiteralExpression) {
            var contextualType = checker.getContextualType(objectLiteralExpression);
            if (!contextualType)
              return void 0;
            var completionsType = checker.getContextualType(objectLiteralExpression, 4);
            var symbols = Completions2.getPropertiesForObjectExpression(contextualType, completionsType, objectLiteralExpression, checker);
            return {
              kind: 1,
              symbols,
              hasIndexSignature: ts3.hasIndexSignature(contextualType)
            };
          }
          function getStringLiteralTypes(type2, uniques) {
            if (uniques === void 0) {
              uniques = new ts3.Map();
            }
            if (!type2)
              return ts3.emptyArray;
            type2 = ts3.skipConstraint(type2);
            return type2.isUnion() ? ts3.flatMap(type2.types, function(t) {
              return getStringLiteralTypes(t, uniques);
            }) : type2.isStringLiteral() && !(type2.flags & 1024) && ts3.addToSeen(uniques, type2.value) ? [type2] : ts3.emptyArray;
          }
          function nameAndKind(name, kind, extension) {
            return { name, kind, extension };
          }
          function directoryResult(name) {
            return nameAndKind(name, "directory", void 0);
          }
          function addReplacementSpans(text, textStart, names) {
            var span = getDirectoryFragmentTextSpan(text, textStart);
            var wholeSpan = text.length === 0 ? void 0 : ts3.createTextSpan(textStart, text.length);
            return names.map(function(_a) {
              var name = _a.name, kind = _a.kind, extension = _a.extension;
              return Math.max(name.indexOf(ts3.directorySeparator), name.indexOf(ts3.altDirectorySeparator)) !== -1 ? { name, kind, extension, span: wholeSpan } : { name, kind, extension, span };
            });
          }
          function getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker, preferences) {
            return addReplacementSpans(node.text, node.getStart(sourceFile) + 1, getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, compilerOptions, host, typeChecker, preferences));
          }
          function getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, compilerOptions, host, typeChecker, preferences) {
            var literalValue = ts3.normalizeSlashes(node.text);
            var scriptPath = sourceFile.path;
            var scriptDirectory = ts3.getDirectoryPath(scriptPath);
            return isPathRelativeToScript(literalValue) || !compilerOptions.baseUrl && (ts3.isRootedDiskPath(literalValue) || ts3.isUrl(literalValue)) ? getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath, getIncludeExtensionOption()) : getCompletionEntriesForNonRelativeModules(literalValue, scriptDirectory, compilerOptions, host, typeChecker);
            function getIncludeExtensionOption() {
              var mode = ts3.isStringLiteralLike(node) ? ts3.getModeForUsageLocation(sourceFile, node) : void 0;
              return preferences.importModuleSpecifierEnding === "js" || mode === ts3.ModuleKind.ESNext ? 2 : 0;
            }
          }
          function getExtensionOptions(compilerOptions, includeExtensionsOption) {
            if (includeExtensionsOption === void 0) {
              includeExtensionsOption = 0;
            }
            return { extensions: ts3.flatten(getSupportedExtensionsForModuleResolution(compilerOptions)), includeExtensionsOption };
          }
          function getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath, includeExtensions) {
            var extensionOptions = getExtensionOptions(compilerOptions, includeExtensions);
            if (compilerOptions.rootDirs) {
              return getCompletionEntriesForDirectoryFragmentWithRootDirs(compilerOptions.rootDirs, literalValue, scriptDirectory, extensionOptions, compilerOptions, host, scriptPath);
            } else {
              return getCompletionEntriesForDirectoryFragment(literalValue, scriptDirectory, extensionOptions, host, scriptPath);
            }
          }
          function isEmitResolutionKindUsingNodeModules(compilerOptions) {
            return ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs || ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeNext;
          }
          function isEmitModuleResolutionRespectingExportMaps(compilerOptions) {
            return ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Node16 || ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeNext;
          }
          function getSupportedExtensionsForModuleResolution(compilerOptions) {
            var extensions = ts3.getSupportedExtensions(compilerOptions);
            return isEmitResolutionKindUsingNodeModules(compilerOptions) ? ts3.getSupportedExtensionsWithJsonIfResolveJsonModule(compilerOptions, extensions) : extensions;
          }
          function getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase) {
            rootDirs = rootDirs.map(function(rootDirectory) {
              return ts3.normalizePath(ts3.isRootedDiskPath(rootDirectory) ? rootDirectory : ts3.combinePaths(basePath, rootDirectory));
            });
            var relativeDirectory = ts3.firstDefined(rootDirs, function(rootDirectory) {
              return ts3.containsPath(rootDirectory, scriptDirectory, basePath, ignoreCase) ? scriptDirectory.substr(rootDirectory.length) : void 0;
            });
            return ts3.deduplicate(__spreadArray(__spreadArray([], rootDirs.map(function(rootDirectory) {
              return ts3.combinePaths(rootDirectory, relativeDirectory);
            }), true), [scriptDirectory], false), ts3.equateStringsCaseSensitive, ts3.compareStringsCaseSensitive);
          }
          function getCompletionEntriesForDirectoryFragmentWithRootDirs(rootDirs, fragment, scriptDirectory, extensionOptions, compilerOptions, host, exclude) {
            var basePath = compilerOptions.project || host.getCurrentDirectory();
            var ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
            var baseDirectories = getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase);
            return ts3.flatMap(baseDirectories, function(baseDirectory) {
              return getCompletionEntriesForDirectoryFragment(fragment, baseDirectory, extensionOptions, host, exclude);
            });
          }
          var IncludeExtensionsOption;
          (function(IncludeExtensionsOption2) {
            IncludeExtensionsOption2[IncludeExtensionsOption2["Exclude"] = 0] = "Exclude";
            IncludeExtensionsOption2[IncludeExtensionsOption2["Include"] = 1] = "Include";
            IncludeExtensionsOption2[IncludeExtensionsOption2["ModuleSpecifierCompletion"] = 2] = "ModuleSpecifierCompletion";
          })(IncludeExtensionsOption || (IncludeExtensionsOption = {}));
          function getCompletionEntriesForDirectoryFragment(fragment, scriptPath, _a, host, exclude, result2) {
            var extensions = _a.extensions, includeExtensionsOption = _a.includeExtensionsOption;
            if (result2 === void 0) {
              result2 = [];
            }
            if (fragment === void 0) {
              fragment = "";
            }
            fragment = ts3.normalizeSlashes(fragment);
            if (!ts3.hasTrailingDirectorySeparator(fragment)) {
              fragment = ts3.getDirectoryPath(fragment);
            }
            if (fragment === "") {
              fragment = "." + ts3.directorySeparator;
            }
            fragment = ts3.ensureTrailingDirectorySeparator(fragment);
            var absolutePath = ts3.resolvePath(scriptPath, fragment);
            var baseDirectory = ts3.hasTrailingDirectorySeparator(absolutePath) ? absolutePath : ts3.getDirectoryPath(absolutePath);
            var ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
            if (!ts3.tryDirectoryExists(host, baseDirectory))
              return result2;
            var files = ts3.tryReadDirectory(host, baseDirectory, extensions, void 0, ["./*"]);
            if (files) {
              var foundFiles = new ts3.Map();
              for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var filePath = files_1[_i];
                filePath = ts3.normalizePath(filePath);
                if (exclude && ts3.comparePaths(filePath, exclude, scriptPath, ignoreCase) === 0) {
                  continue;
                }
                var foundFileName = void 0;
                var outputExtension = ts3.moduleSpecifiers.tryGetJSExtensionForFile(filePath, host.getCompilationSettings());
                if (includeExtensionsOption === 0 && !ts3.fileExtensionIsOneOf(filePath, [".json", ".mts", ".cts", ".d.mts", ".d.cts", ".mjs", ".cjs"])) {
                  foundFileName = ts3.removeFileExtension(ts3.getBaseFileName(filePath));
                  foundFiles.set(foundFileName, ts3.tryGetExtensionFromPath(filePath));
                } else if ((ts3.fileExtensionIsOneOf(filePath, [".mts", ".cts", ".d.mts", ".d.cts", ".mjs", ".cjs"]) || includeExtensionsOption === 2) && outputExtension) {
                  foundFileName = ts3.changeExtension(ts3.getBaseFileName(filePath), outputExtension);
                  foundFiles.set(foundFileName, outputExtension);
                } else {
                  foundFileName = ts3.getBaseFileName(filePath);
                  foundFiles.set(foundFileName, ts3.tryGetExtensionFromPath(filePath));
                }
              }
              foundFiles.forEach(function(ext, foundFile) {
                result2.push(nameAndKind(foundFile, "script", ext));
              });
            }
            var directories = ts3.tryGetDirectories(host, baseDirectory);
            if (directories) {
              for (var _b = 0, directories_1 = directories; _b < directories_1.length; _b++) {
                var directory = directories_1[_b];
                var directoryName = ts3.getBaseFileName(ts3.normalizePath(directory));
                if (directoryName !== "@types") {
                  result2.push(directoryResult(directoryName));
                }
              }
            }
            var packageJsonPath = ts3.findPackageJson(baseDirectory, host);
            if (packageJsonPath) {
              var packageJson = ts3.readJson(packageJsonPath, host);
              var typesVersions = packageJson.typesVersions;
              if (typeof typesVersions === "object") {
                var versionResult = ts3.getPackageJsonTypesVersionsPaths(typesVersions);
                var versionPaths = versionResult && versionResult.paths;
                var rest = absolutePath.slice(ts3.ensureTrailingDirectorySeparator(baseDirectory).length);
                if (versionPaths) {
                  addCompletionEntriesFromPaths(result2, rest, baseDirectory, extensions, versionPaths, host);
                }
              }
            }
            return result2;
          }
          function addCompletionEntriesFromPaths(result2, fragment, baseDirectory, fileExtensions, paths, host) {
            for (var path2 in paths) {
              if (!ts3.hasProperty(paths, path2))
                continue;
              var patterns = paths[path2];
              if (patterns) {
                var _loop_3 = function(name2, kind2, extension2) {
                  if (!result2.some(function(entry) {
                    return entry.name === name2;
                  })) {
                    result2.push(nameAndKind(name2, kind2, extension2));
                  }
                };
                for (var _i = 0, _a = getCompletionsForPathMapping(path2, patterns, fragment, baseDirectory, fileExtensions, host); _i < _a.length; _i++) {
                  var _b = _a[_i], name = _b.name, kind = _b.kind, extension = _b.extension;
                  _loop_3(name, kind, extension);
                }
              }
            }
          }
          function getCompletionEntriesForNonRelativeModules(fragment, scriptPath, compilerOptions, host, typeChecker) {
            var baseUrl = compilerOptions.baseUrl, paths = compilerOptions.paths;
            var result2 = [];
            var extensionOptions = getExtensionOptions(compilerOptions);
            if (baseUrl) {
              var projectDir = compilerOptions.project || host.getCurrentDirectory();
              var absolute = ts3.normalizePath(ts3.combinePaths(projectDir, baseUrl));
              getCompletionEntriesForDirectoryFragment(fragment, absolute, extensionOptions, host, void 0, result2);
              if (paths) {
                addCompletionEntriesFromPaths(result2, fragment, absolute, extensionOptions.extensions, paths, host);
              }
            }
            var fragmentDirectory = getFragmentDirectory(fragment);
            for (var _i = 0, _a = getAmbientModuleCompletions(fragment, fragmentDirectory, typeChecker); _i < _a.length; _i++) {
              var ambientName = _a[_i];
              result2.push(nameAndKind(ambientName, "external module name", void 0));
            }
            getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, fragmentDirectory, extensionOptions, result2);
            if (isEmitResolutionKindUsingNodeModules(compilerOptions)) {
              var foundGlobal = false;
              if (fragmentDirectory === void 0) {
                var _loop_4 = function(moduleName2) {
                  if (!result2.some(function(entry) {
                    return entry.name === moduleName2;
                  })) {
                    foundGlobal = true;
                    result2.push(nameAndKind(moduleName2, "external module name", void 0));
                  }
                };
                for (var _b = 0, _c = enumerateNodeModulesVisibleToScript(host, scriptPath); _b < _c.length; _b++) {
                  var moduleName = _c[_b];
                  _loop_4(moduleName);
                }
              }
              if (!foundGlobal) {
                var ancestorLookup = function(ancestor) {
                  var nodeModules = ts3.combinePaths(ancestor, "node_modules");
                  if (ts3.tryDirectoryExists(host, nodeModules)) {
                    getCompletionEntriesForDirectoryFragment(fragment, nodeModules, extensionOptions, host, void 0, result2);
                  }
                };
                if (fragmentDirectory && isEmitModuleResolutionRespectingExportMaps(compilerOptions)) {
                  var nodeModulesDirectoryLookup_1 = ancestorLookup;
                  ancestorLookup = function(ancestor) {
                    var components = ts3.getPathComponents(fragment);
                    components.shift();
                    var packagePath = components.shift();
                    if (!packagePath) {
                      return nodeModulesDirectoryLookup_1(ancestor);
                    }
                    if (ts3.startsWith(packagePath, "@")) {
                      var subName = components.shift();
                      if (!subName) {
                        return nodeModulesDirectoryLookup_1(ancestor);
                      }
                      packagePath = ts3.combinePaths(packagePath, subName);
                    }
                    var packageFile = ts3.combinePaths(ancestor, "node_modules", packagePath, "package.json");
                    if (ts3.tryFileExists(host, packageFile)) {
                      var packageJson = ts3.readJson(packageFile, host);
                      var exports2 = packageJson.exports;
                      if (exports2) {
                        if (typeof exports2 !== "object" || exports2 === null) {
                          return;
                        }
                        var keys = ts3.getOwnKeys(exports2);
                        var fragmentSubpath_1 = components.join("/");
                        var processedKeys = ts3.mapDefined(keys, function(k) {
                          if (k === ".")
                            return void 0;
                          if (!ts3.startsWith(k, "./"))
                            return void 0;
                          var subpath = k.substring(2);
                          if (!ts3.startsWith(subpath, fragmentSubpath_1))
                            return void 0;
                          if (!ts3.stringContains(subpath, "*")) {
                            return subpath;
                          }
                          return subpath.slice(0, subpath.indexOf("*"));
                        });
                        ts3.forEach(processedKeys, function(k) {
                          if (k) {
                            result2.push(nameAndKind(k, "external module name", void 0));
                          }
                        });
                        return;
                      }
                    }
                    return nodeModulesDirectoryLookup_1(ancestor);
                  };
                }
                ts3.forEachAncestorDirectory(scriptPath, ancestorLookup);
              }
            }
            return result2;
          }
          function getFragmentDirectory(fragment) {
            return containsSlash(fragment) ? ts3.hasTrailingDirectorySeparator(fragment) ? fragment : ts3.getDirectoryPath(fragment) : void 0;
          }
          function getCompletionsForPathMapping(path2, patterns, fragment, baseUrl, fileExtensions, host) {
            if (!ts3.endsWith(path2, "*")) {
              return !ts3.stringContains(path2, "*") ? justPathMappingName(path2) : ts3.emptyArray;
            }
            var pathPrefix = path2.slice(0, path2.length - 1);
            var remainingFragment = ts3.tryRemovePrefix(fragment, pathPrefix);
            return remainingFragment === void 0 ? justPathMappingName(pathPrefix) : ts3.flatMap(patterns, function(pattern) {
              return getModulesForPathsPattern(remainingFragment, baseUrl, pattern, fileExtensions, host);
            });
            function justPathMappingName(name) {
              return ts3.startsWith(name, fragment) ? [directoryResult(name)] : ts3.emptyArray;
            }
          }
          function getModulesForPathsPattern(fragment, baseUrl, pattern, fileExtensions, host) {
            if (!host.readDirectory) {
              return void 0;
            }
            var parsed = ts3.tryParsePattern(pattern);
            if (parsed === void 0 || ts3.isString(parsed)) {
              return void 0;
            }
            var normalizedPrefix = ts3.resolvePath(parsed.prefix);
            var normalizedPrefixDirectory = ts3.hasTrailingDirectorySeparator(parsed.prefix) ? normalizedPrefix : ts3.getDirectoryPath(normalizedPrefix);
            var normalizedPrefixBase = ts3.hasTrailingDirectorySeparator(parsed.prefix) ? "" : ts3.getBaseFileName(normalizedPrefix);
            var fragmentHasPath = containsSlash(fragment);
            var fragmentDirectory = fragmentHasPath ? ts3.hasTrailingDirectorySeparator(fragment) ? fragment : ts3.getDirectoryPath(fragment) : void 0;
            var expandedPrefixDirectory = fragmentHasPath ? ts3.combinePaths(normalizedPrefixDirectory, normalizedPrefixBase + fragmentDirectory) : normalizedPrefixDirectory;
            var normalizedSuffix = ts3.normalizePath(parsed.suffix);
            var baseDirectory = ts3.normalizePath(ts3.combinePaths(baseUrl, expandedPrefixDirectory));
            var completePrefix = fragmentHasPath ? baseDirectory : ts3.ensureTrailingDirectorySeparator(baseDirectory) + normalizedPrefixBase;
            var includeGlob = normalizedSuffix ? "**/*" : "./*";
            var matches = ts3.mapDefined(ts3.tryReadDirectory(host, baseDirectory, fileExtensions, void 0, [includeGlob]), function(match) {
              var extension = ts3.tryGetExtensionFromPath(match);
              var name = trimPrefixAndSuffix(match);
              return name === void 0 ? void 0 : nameAndKind(ts3.removeFileExtension(name), "script", extension);
            });
            var directories = ts3.mapDefined(ts3.tryGetDirectories(host, baseDirectory).map(function(d) {
              return ts3.combinePaths(baseDirectory, d);
            }), function(dir) {
              var name = trimPrefixAndSuffix(dir);
              return name === void 0 ? void 0 : directoryResult(name);
            });
            return __spreadArray(__spreadArray([], matches, true), directories, true);
            function trimPrefixAndSuffix(path2) {
              var inner = withoutStartAndEnd(ts3.normalizePath(path2), completePrefix, normalizedSuffix);
              return inner === void 0 ? void 0 : removeLeadingDirectorySeparator(inner);
            }
          }
          function withoutStartAndEnd(s, start, end) {
            return ts3.startsWith(s, start) && ts3.endsWith(s, end) ? s.slice(start.length, s.length - end.length) : void 0;
          }
          function removeLeadingDirectorySeparator(path2) {
            return path2[0] === ts3.directorySeparator ? path2.slice(1) : path2;
          }
          function getAmbientModuleCompletions(fragment, fragmentDirectory, checker) {
            var ambientModules = checker.getAmbientModules().map(function(sym) {
              return ts3.stripQuotes(sym.name);
            });
            var nonRelativeModuleNames = ambientModules.filter(function(moduleName) {
              return ts3.startsWith(moduleName, fragment);
            });
            if (fragmentDirectory !== void 0) {
              var moduleNameWithSeparator_1 = ts3.ensureTrailingDirectorySeparator(fragmentDirectory);
              return nonRelativeModuleNames.map(function(nonRelativeModuleName) {
                return ts3.removePrefix(nonRelativeModuleName, moduleNameWithSeparator_1);
              });
            }
            return nonRelativeModuleNames;
          }
          function getTripleSlashReferenceCompletion(sourceFile, position, compilerOptions, host) {
            var token = ts3.getTokenAtPosition(sourceFile, position);
            var commentRanges = ts3.getLeadingCommentRanges(sourceFile.text, token.pos);
            var range = commentRanges && ts3.find(commentRanges, function(commentRange) {
              return position >= commentRange.pos && position <= commentRange.end;
            });
            if (!range) {
              return void 0;
            }
            var text = sourceFile.text.slice(range.pos, position);
            var match = tripleSlashDirectiveFragmentRegex.exec(text);
            if (!match) {
              return void 0;
            }
            var prefix = match[1], kind = match[2], toComplete = match[3];
            var scriptPath = ts3.getDirectoryPath(sourceFile.path);
            var names = kind === "path" ? getCompletionEntriesForDirectoryFragment(toComplete, scriptPath, getExtensionOptions(compilerOptions, 1), host, sourceFile.path) : kind === "types" ? getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, getFragmentDirectory(toComplete), getExtensionOptions(compilerOptions)) : ts3.Debug.fail();
            return addReplacementSpans(toComplete, range.pos + prefix.length, names);
          }
          function getCompletionEntriesFromTypings(host, options, scriptPath, fragmentDirectory, extensionOptions, result2) {
            if (result2 === void 0) {
              result2 = [];
            }
            var seen = new ts3.Map();
            var typeRoots = ts3.tryAndIgnoreErrors(function() {
              return ts3.getEffectiveTypeRoots(options, host);
            }) || ts3.emptyArray;
            for (var _i = 0, typeRoots_1 = typeRoots; _i < typeRoots_1.length; _i++) {
              var root = typeRoots_1[_i];
              getCompletionEntriesFromDirectories(root);
            }
            for (var _a = 0, _b = ts3.findPackageJsons(scriptPath, host); _a < _b.length; _a++) {
              var packageJson = _b[_a];
              var typesDir = ts3.combinePaths(ts3.getDirectoryPath(packageJson), "node_modules/@types");
              getCompletionEntriesFromDirectories(typesDir);
            }
            return result2;
            function getCompletionEntriesFromDirectories(directory) {
              if (!ts3.tryDirectoryExists(host, directory))
                return;
              for (var _i2 = 0, _a2 = ts3.tryGetDirectories(host, directory); _i2 < _a2.length; _i2++) {
                var typeDirectoryName = _a2[_i2];
                var packageName = ts3.unmangleScopedPackageName(typeDirectoryName);
                if (options.types && !ts3.contains(options.types, packageName))
                  continue;
                if (fragmentDirectory === void 0) {
                  if (!seen.has(packageName)) {
                    result2.push(nameAndKind(packageName, "external module name", void 0));
                    seen.set(packageName, true);
                  }
                } else {
                  var baseDirectory = ts3.combinePaths(directory, typeDirectoryName);
                  var remainingFragment = ts3.tryRemoveDirectoryPrefix(fragmentDirectory, packageName, ts3.hostGetCanonicalFileName(host));
                  if (remainingFragment !== void 0) {
                    getCompletionEntriesForDirectoryFragment(remainingFragment, baseDirectory, extensionOptions, host, void 0, result2);
                  }
                }
              }
            }
          }
          function enumerateNodeModulesVisibleToScript(host, scriptPath) {
            if (!host.readFile || !host.fileExists)
              return ts3.emptyArray;
            var result2 = [];
            for (var _i = 0, _a = ts3.findPackageJsons(scriptPath, host); _i < _a.length; _i++) {
              var packageJson = _a[_i];
              var contents = ts3.readJson(packageJson, host);
              for (var _b = 0, nodeModulesDependencyKeys_1 = nodeModulesDependencyKeys; _b < nodeModulesDependencyKeys_1.length; _b++) {
                var key = nodeModulesDependencyKeys_1[_b];
                var dependencies = contents[key];
                if (!dependencies)
                  continue;
                for (var dep in dependencies) {
                  if (dependencies.hasOwnProperty(dep) && !ts3.startsWith(dep, "@types/")) {
                    result2.push(dep);
                  }
                }
              }
            }
            return result2;
          }
          function getDirectoryFragmentTextSpan(text, textStart) {
            var index = Math.max(text.lastIndexOf(ts3.directorySeparator), text.lastIndexOf(ts3.altDirectorySeparator));
            var offset = index !== -1 ? index + 1 : 0;
            var length = text.length - offset;
            return length === 0 || ts3.isIdentifierText(text.substr(offset, length), 99) ? void 0 : ts3.createTextSpan(textStart + offset, length);
          }
          function isPathRelativeToScript(path2) {
            if (path2 && path2.length >= 2 && path2.charCodeAt(0) === 46) {
              var slashIndex = path2.length >= 3 && path2.charCodeAt(1) === 46 ? 2 : 1;
              var slashCharCode = path2.charCodeAt(slashIndex);
              return slashCharCode === 47 || slashCharCode === 92;
            }
            return false;
          }
          var tripleSlashDirectiveFragmentRegex = /^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/;
          var nodeModulesDependencyKeys = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
          function containsSlash(fragment) {
            return ts3.stringContains(fragment, ts3.directorySeparator);
          }
          function isRequireCallArgument(node) {
            return ts3.isCallExpression(node.parent) && ts3.firstOrUndefined(node.parent.arguments) === node && ts3.isIdentifier(node.parent.expression) && node.parent.expression.escapedText === "require";
          }
        })(StringCompletions = Completions2.StringCompletions || (Completions2.StringCompletions = {}));
      })(Completions = ts3.Completions || (ts3.Completions = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var Completions;
      (function(Completions2) {
        Completions2.moduleSpecifierResolutionLimit = 100;
        Completions2.moduleSpecifierResolutionCacheAttemptLimit = 1e3;
        Completions2.SortText = {
          LocalDeclarationPriority: "10",
          LocationPriority: "11",
          OptionalMember: "12",
          MemberDeclaredBySpreadAssignment: "13",
          SuggestedClassMembers: "14",
          GlobalsOrKeywords: "15",
          AutoImportSuggestions: "16",
          ClassMemberSnippets: "17",
          JavascriptIdentifiers: "18",
          Deprecated: function(sortText) {
            return "z" + sortText;
          },
          ObjectLiteralProperty: function(presetSortText, symbolDisplayName) {
            return "".concat(presetSortText, "\0").concat(symbolDisplayName, "\0");
          },
          SortBelow: function(sortText) {
            return sortText + "1";
          }
        };
        var CompletionSource;
        (function(CompletionSource2) {
          CompletionSource2["ThisProperty"] = "ThisProperty/";
          CompletionSource2["ClassMemberSnippet"] = "ClassMemberSnippet/";
          CompletionSource2["TypeOnlyAlias"] = "TypeOnlyAlias/";
          CompletionSource2["ObjectLiteralMethodSnippet"] = "ObjectLiteralMethodSnippet/";
        })(CompletionSource = Completions2.CompletionSource || (Completions2.CompletionSource = {}));
        var SymbolOriginInfoKind;
        (function(SymbolOriginInfoKind2) {
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["ThisType"] = 1] = "ThisType";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMember"] = 2] = "SymbolMember";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Export"] = 4] = "Export";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Promise"] = 8] = "Promise";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Nullable"] = 16] = "Nullable";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["ResolvedExport"] = 32] = "ResolvedExport";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["TypeOnlyAlias"] = 64] = "TypeOnlyAlias";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["ObjectLiteralMethod"] = 128] = "ObjectLiteralMethod";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberNoExport"] = 2] = "SymbolMemberNoExport";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberExport"] = 6] = "SymbolMemberExport";
        })(SymbolOriginInfoKind || (SymbolOriginInfoKind = {}));
        function originIsThisType(origin) {
          return !!(origin.kind & 1);
        }
        function originIsSymbolMember(origin) {
          return !!(origin.kind & 2);
        }
        function originIsExport(origin) {
          return !!(origin && origin.kind & 4);
        }
        function originIsResolvedExport(origin) {
          return !!(origin && origin.kind === 32);
        }
        function originIncludesSymbolName(origin) {
          return originIsExport(origin) || originIsResolvedExport(origin);
        }
        function originIsPackageJsonImport(origin) {
          return (originIsExport(origin) || originIsResolvedExport(origin)) && !!origin.isFromPackageJson;
        }
        function originIsPromise(origin) {
          return !!(origin.kind & 8);
        }
        function originIsNullableMember(origin) {
          return !!(origin.kind & 16);
        }
        function originIsTypeOnlyAlias(origin) {
          return !!(origin && origin.kind & 64);
        }
        function originIsObjectLiteralMethod(origin) {
          return !!(origin && origin.kind & 128);
        }
        var KeywordCompletionFilters;
        (function(KeywordCompletionFilters2) {
          KeywordCompletionFilters2[KeywordCompletionFilters2["None"] = 0] = "None";
          KeywordCompletionFilters2[KeywordCompletionFilters2["All"] = 1] = "All";
          KeywordCompletionFilters2[KeywordCompletionFilters2["ClassElementKeywords"] = 2] = "ClassElementKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["InterfaceElementKeywords"] = 3] = "InterfaceElementKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["ConstructorParameterKeywords"] = 4] = "ConstructorParameterKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["FunctionLikeBodyKeywords"] = 5] = "FunctionLikeBodyKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeAssertionKeywords"] = 6] = "TypeAssertionKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeKeywords"] = 7] = "TypeKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeKeyword"] = 8] = "TypeKeyword";
          KeywordCompletionFilters2[KeywordCompletionFilters2["Last"] = 8] = "Last";
        })(KeywordCompletionFilters || (KeywordCompletionFilters = {}));
        var GlobalsSearch;
        (function(GlobalsSearch2) {
          GlobalsSearch2[GlobalsSearch2["Continue"] = 0] = "Continue";
          GlobalsSearch2[GlobalsSearch2["Success"] = 1] = "Success";
          GlobalsSearch2[GlobalsSearch2["Fail"] = 2] = "Fail";
        })(GlobalsSearch || (GlobalsSearch = {}));
        function resolvingModuleSpecifiers(logPrefix, host, resolver, program2, position, preferences, isForImportStatementCompletion, isValidTypeOnlyUseSite, cb) {
          var _a, _b, _c;
          var start = ts3.timestamp();
          var needsFullResolution = isForImportStatementCompletion || ts3.moduleResolutionRespectsExports(ts3.getEmitModuleResolutionKind(program2.getCompilerOptions()));
          var skippedAny = false;
          var ambientCount = 0;
          var resolvedCount = 0;
          var resolvedFromCacheCount = 0;
          var cacheAttemptCount = 0;
          var result2 = cb({
            tryResolve,
            skippedAny: function() {
              return skippedAny;
            },
            resolvedAny: function() {
              return resolvedCount > 0;
            },
            resolvedBeyondLimit: function() {
              return resolvedCount > Completions2.moduleSpecifierResolutionLimit;
            }
          });
          var hitRateMessage = cacheAttemptCount ? " (".concat((resolvedFromCacheCount / cacheAttemptCount * 100).toFixed(1), "% hit rate)") : "";
          (_a = host.log) === null || _a === void 0 ? void 0 : _a.call(host, "".concat(logPrefix, ": resolved ").concat(resolvedCount, " module specifiers, plus ").concat(ambientCount, " ambient and ").concat(resolvedFromCacheCount, " from cache").concat(hitRateMessage));
          (_b = host.log) === null || _b === void 0 ? void 0 : _b.call(host, "".concat(logPrefix, ": response is ").concat(skippedAny ? "incomplete" : "complete"));
          (_c = host.log) === null || _c === void 0 ? void 0 : _c.call(host, "".concat(logPrefix, ": ").concat(ts3.timestamp() - start));
          return result2;
          function tryResolve(exportInfo, symbolName, isFromAmbientModule) {
            if (isFromAmbientModule) {
              var result_1 = resolver.getModuleSpecifierForBestExportInfo(exportInfo, symbolName, position, isValidTypeOnlyUseSite);
              if (result_1) {
                ambientCount++;
              }
              return result_1 || "failed";
            }
            var shouldResolveModuleSpecifier = needsFullResolution || preferences.allowIncompleteCompletions && resolvedCount < Completions2.moduleSpecifierResolutionLimit;
            var shouldGetModuleSpecifierFromCache = !shouldResolveModuleSpecifier && preferences.allowIncompleteCompletions && cacheAttemptCount < Completions2.moduleSpecifierResolutionCacheAttemptLimit;
            var result3 = shouldResolveModuleSpecifier || shouldGetModuleSpecifierFromCache ? resolver.getModuleSpecifierForBestExportInfo(exportInfo, symbolName, position, isValidTypeOnlyUseSite, shouldGetModuleSpecifierFromCache) : void 0;
            if (!shouldResolveModuleSpecifier && !shouldGetModuleSpecifierFromCache || shouldGetModuleSpecifierFromCache && !result3) {
              skippedAny = true;
            }
            resolvedCount += (result3 === null || result3 === void 0 ? void 0 : result3.computedWithoutCacheCount) || 0;
            resolvedFromCacheCount += exportInfo.length - ((result3 === null || result3 === void 0 ? void 0 : result3.computedWithoutCacheCount) || 0);
            if (shouldGetModuleSpecifierFromCache) {
              cacheAttemptCount++;
            }
            return result3 || (needsFullResolution ? "failed" : "skipped");
          }
        }
        function getCompletionsAtPosition(host, program2, log, sourceFile, position, preferences, triggerCharacter, completionKind, cancellationToken, formatContext) {
          var _a;
          var previousToken = getRelevantTokens(position, sourceFile).previousToken;
          if (triggerCharacter && !ts3.isInString(sourceFile, position, previousToken) && !isValidTrigger(sourceFile, triggerCharacter, previousToken, position)) {
            return void 0;
          }
          if (triggerCharacter === " ") {
            if (preferences.includeCompletionsForImportStatements && preferences.includeCompletionsWithInsertText) {
              return { isGlobalCompletion: true, isMemberCompletion: false, isNewIdentifierLocation: true, isIncomplete: true, entries: [] };
            }
            return void 0;
          }
          var compilerOptions = program2.getCompilerOptions();
          var incompleteCompletionsCache = preferences.allowIncompleteCompletions ? (_a = host.getIncompleteCompletionsCache) === null || _a === void 0 ? void 0 : _a.call(host) : void 0;
          if (incompleteCompletionsCache && completionKind === 3 && previousToken && ts3.isIdentifier(previousToken)) {
            var incompleteContinuation = continuePreviousIncompleteResponse(incompleteCompletionsCache, sourceFile, previousToken, program2, host, preferences, cancellationToken);
            if (incompleteContinuation) {
              return incompleteContinuation;
            }
          } else {
            incompleteCompletionsCache === null || incompleteCompletionsCache === void 0 ? void 0 : incompleteCompletionsCache.clear();
          }
          var stringCompletions = Completions2.StringCompletions.getStringLiteralCompletions(sourceFile, position, previousToken, compilerOptions, host, program2, log, preferences);
          if (stringCompletions) {
            return stringCompletions;
          }
          if (previousToken && ts3.isBreakOrContinueStatement(previousToken.parent) && (previousToken.kind === 81 || previousToken.kind === 86 || previousToken.kind === 79)) {
            return getLabelCompletionAtPosition(previousToken.parent);
          }
          var completionData = getCompletionData(program2, log, sourceFile, compilerOptions, position, preferences, void 0, host, formatContext, cancellationToken);
          if (!completionData) {
            return void 0;
          }
          switch (completionData.kind) {
            case 0:
              var response = completionInfoFromData(sourceFile, host, program2, compilerOptions, log, completionData, preferences, formatContext, position);
              if (response === null || response === void 0 ? void 0 : response.isIncomplete) {
                incompleteCompletionsCache === null || incompleteCompletionsCache === void 0 ? void 0 : incompleteCompletionsCache.set(response);
              }
              return response;
            case 1:
              return jsdocCompletionInfo(ts3.JsDoc.getJSDocTagNameCompletions());
            case 2:
              return jsdocCompletionInfo(ts3.JsDoc.getJSDocTagCompletions());
            case 3:
              return jsdocCompletionInfo(ts3.JsDoc.getJSDocParameterNameCompletions(completionData.tag));
            case 4:
              return specificKeywordCompletionInfo(completionData.keywordCompletions, completionData.isNewIdentifierLocation);
            default:
              return ts3.Debug.assertNever(completionData);
          }
        }
        Completions2.getCompletionsAtPosition = getCompletionsAtPosition;
        function compareCompletionEntries(entryInArray, entryToInsert) {
          var _a, _b;
          var result2 = ts3.compareStringsCaseSensitiveUI(entryInArray.sortText, entryToInsert.sortText);
          if (result2 === 0) {
            result2 = ts3.compareStringsCaseSensitiveUI(entryInArray.name, entryToInsert.name);
          }
          if (result2 === 0 && ((_a = entryInArray.data) === null || _a === void 0 ? void 0 : _a.moduleSpecifier) && ((_b = entryToInsert.data) === null || _b === void 0 ? void 0 : _b.moduleSpecifier)) {
            result2 = ts3.compareNumberOfDirectorySeparators(entryInArray.data.moduleSpecifier, entryToInsert.data.moduleSpecifier);
          }
          if (result2 === 0) {
            return -1;
          }
          return result2;
        }
        function completionEntryDataIsResolved(data) {
          return !!(data === null || data === void 0 ? void 0 : data.moduleSpecifier);
        }
        function continuePreviousIncompleteResponse(cache, file, location, program2, host, preferences, cancellationToken) {
          var previousResponse = cache.get();
          if (!previousResponse)
            return void 0;
          var lowerCaseTokenText = location.text.toLowerCase();
          var exportMap = ts3.getExportInfoMap(file, host, program2, cancellationToken);
          var newEntries = resolvingModuleSpecifiers("continuePreviousIncompleteResponse", host, ts3.codefix.createImportSpecifierResolver(file, program2, host, preferences), program2, location.getStart(), preferences, false, ts3.isValidTypeOnlyAliasUseSite(location), function(context) {
            var entries = ts3.mapDefined(previousResponse.entries, function(entry) {
              var _a;
              if (!entry.hasAction || !entry.source || !entry.data || completionEntryDataIsResolved(entry.data)) {
                return entry;
              }
              if (!charactersFuzzyMatchInString(entry.name, lowerCaseTokenText)) {
                return void 0;
              }
              var origin = ts3.Debug.checkDefined(getAutoImportSymbolFromCompletionEntryData(entry.name, entry.data, program2, host)).origin;
              var info = exportMap.get(file.path, entry.data.exportMapKey);
              var result2 = info && context.tryResolve(info, entry.name, !ts3.isExternalModuleNameRelative(ts3.stripQuotes(origin.moduleSymbol.name)));
              if (result2 === "skipped")
                return entry;
              if (!result2 || result2 === "failed") {
                (_a = host.log) === null || _a === void 0 ? void 0 : _a.call(host, "Unexpected failure resolving auto import for '".concat(entry.name, "' from '").concat(entry.source, "'"));
                return void 0;
              }
              var newOrigin = __assign(__assign({}, origin), { kind: 32, moduleSpecifier: result2.moduleSpecifier });
              entry.data = originToCompletionEntryData(newOrigin);
              entry.source = getSourceFromOrigin(newOrigin);
              entry.sourceDisplay = [ts3.textPart(newOrigin.moduleSpecifier)];
              return entry;
            });
            if (!context.skippedAny()) {
              previousResponse.isIncomplete = void 0;
            }
            return entries;
          });
          previousResponse.entries = newEntries;
          previousResponse.flags = (previousResponse.flags || 0) | 4;
          return previousResponse;
        }
        function jsdocCompletionInfo(entries) {
          return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
        }
        function keywordToCompletionEntry(keyword) {
          return {
            name: ts3.tokenToString(keyword),
            kind: "keyword",
            kindModifiers: "",
            sortText: Completions2.SortText.GlobalsOrKeywords
          };
        }
        function specificKeywordCompletionInfo(entries, isNewIdentifierLocation) {
          return {
            isGlobalCompletion: false,
            isMemberCompletion: false,
            isNewIdentifierLocation,
            entries: entries.slice()
          };
        }
        function keywordCompletionData(keywordFilters, filterOutTsOnlyKeywords, isNewIdentifierLocation) {
          return {
            kind: 4,
            keywordCompletions: getKeywordCompletions(keywordFilters, filterOutTsOnlyKeywords),
            isNewIdentifierLocation
          };
        }
        function keywordFiltersFromSyntaxKind(keywordCompletion) {
          switch (keywordCompletion) {
            case 152:
              return 8;
            default:
              ts3.Debug.fail("Unknown mapping from SyntaxKind to KeywordCompletionFilters");
          }
        }
        function getOptionalReplacementSpan(location) {
          return (location === null || location === void 0 ? void 0 : location.kind) === 79 ? ts3.createTextSpanFromNode(location) : void 0;
        }
        function completionInfoFromData(sourceFile, host, program2, compilerOptions, log, completionData, preferences, formatContext, position) {
          var symbols = completionData.symbols, contextToken = completionData.contextToken, completionKind = completionData.completionKind, isInSnippetScope = completionData.isInSnippetScope, isNewIdentifierLocation = completionData.isNewIdentifierLocation, location = completionData.location, propertyAccessToConvert = completionData.propertyAccessToConvert, keywordFilters = completionData.keywordFilters, literals = completionData.literals, symbolToOriginInfoMap = completionData.symbolToOriginInfoMap, recommendedCompletion = completionData.recommendedCompletion, isJsxInitializer = completionData.isJsxInitializer, isTypeOnlyLocation = completionData.isTypeOnlyLocation, isJsxIdentifierExpected = completionData.isJsxIdentifierExpected, isRightOfOpenTag = completionData.isRightOfOpenTag, importCompletionNode = completionData.importCompletionNode, insideJsDocTagTypeExpression = completionData.insideJsDocTagTypeExpression, symbolToSortTextMap = completionData.symbolToSortTextMap, hasUnresolvedAutoImports = completionData.hasUnresolvedAutoImports;
          if (ts3.getLanguageVariant(sourceFile.scriptKind) === 1) {
            var completionInfo = getJsxClosingTagCompletion(location, sourceFile);
            if (completionInfo) {
              return completionInfo;
            }
          }
          var entries = ts3.createSortedArray();
          if (isUncheckedFile(sourceFile, compilerOptions)) {
            var uniqueNames = getCompletionEntriesFromSymbols(symbols, entries, void 0, contextToken, location, sourceFile, host, program2, ts3.getEmitScriptTarget(compilerOptions), log, completionKind, preferences, compilerOptions, formatContext, isTypeOnlyLocation, propertyAccessToConvert, isJsxIdentifierExpected, isJsxInitializer, importCompletionNode, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap, isJsxIdentifierExpected, isRightOfOpenTag);
            getJSCompletionEntries(sourceFile, location.pos, uniqueNames, ts3.getEmitScriptTarget(compilerOptions), entries);
          } else {
            if (!isNewIdentifierLocation && (!symbols || symbols.length === 0) && keywordFilters === 0) {
              return void 0;
            }
            getCompletionEntriesFromSymbols(symbols, entries, void 0, contextToken, location, sourceFile, host, program2, ts3.getEmitScriptTarget(compilerOptions), log, completionKind, preferences, compilerOptions, formatContext, isTypeOnlyLocation, propertyAccessToConvert, isJsxIdentifierExpected, isJsxInitializer, importCompletionNode, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap, isJsxIdentifierExpected, isRightOfOpenTag);
          }
          if (keywordFilters !== 0) {
            var entryNames_1 = new ts3.Set(entries.map(function(e) {
              return e.name;
            }));
            for (var _i = 0, _a = getKeywordCompletions(keywordFilters, !insideJsDocTagTypeExpression && ts3.isSourceFileJS(sourceFile)); _i < _a.length; _i++) {
              var keywordEntry = _a[_i];
              if (isTypeOnlyLocation && ts3.isTypeKeyword(ts3.stringToToken(keywordEntry.name)) || !entryNames_1.has(keywordEntry.name)) {
                ts3.insertSorted(entries, keywordEntry, compareCompletionEntries, true);
              }
            }
          }
          var entryNames = new ts3.Set(entries.map(function(e) {
            return e.name;
          }));
          for (var _b = 0, _c = getContextualKeywords(contextToken, position); _b < _c.length; _b++) {
            var keywordEntry = _c[_b];
            if (!entryNames.has(keywordEntry.name)) {
              ts3.insertSorted(entries, keywordEntry, compareCompletionEntries, true);
            }
          }
          for (var _d = 0, literals_1 = literals; _d < literals_1.length; _d++) {
            var literal = literals_1[_d];
            ts3.insertSorted(entries, createCompletionEntryForLiteral(sourceFile, preferences, literal), compareCompletionEntries, true);
          }
          return {
            flags: completionData.flags,
            isGlobalCompletion: isInSnippetScope,
            isIncomplete: preferences.allowIncompleteCompletions && hasUnresolvedAutoImports ? true : void 0,
            isMemberCompletion: isMemberCompletionKind(completionKind),
            isNewIdentifierLocation,
            optionalReplacementSpan: getOptionalReplacementSpan(location),
            entries
          };
        }
        function isUncheckedFile(sourceFile, compilerOptions) {
          return ts3.isSourceFileJS(sourceFile) && !ts3.isCheckJsEnabledForFile(sourceFile, compilerOptions);
        }
        function isMemberCompletionKind(kind) {
          switch (kind) {
            case 0:
            case 3:
            case 2:
              return true;
            default:
              return false;
          }
        }
        function getJsxClosingTagCompletion(location, sourceFile) {
          var jsxClosingElement = ts3.findAncestor(location, function(node) {
            switch (node.kind) {
              case 281:
                return true;
              case 43:
              case 31:
              case 79:
              case 206:
                return false;
              default:
                return "quit";
            }
          });
          if (jsxClosingElement) {
            var hasClosingAngleBracket = !!ts3.findChildOfKind(jsxClosingElement, 31, sourceFile);
            var tagName = jsxClosingElement.parent.openingElement.tagName;
            var closingTag = tagName.getText(sourceFile);
            var fullClosingTag = closingTag + (hasClosingAngleBracket ? "" : ">");
            var replacementSpan = ts3.createTextSpanFromNode(jsxClosingElement.tagName);
            var entry = {
              name: fullClosingTag,
              kind: "class",
              kindModifiers: void 0,
              sortText: Completions2.SortText.LocationPriority
            };
            return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: false, optionalReplacementSpan: replacementSpan, entries: [entry] };
          }
          return;
        }
        function getJSCompletionEntries(sourceFile, position, uniqueNames, target, entries) {
          ts3.getNameTable(sourceFile).forEach(function(pos, name) {
            if (pos === position) {
              return;
            }
            var realName = ts3.unescapeLeadingUnderscores(name);
            if (!uniqueNames.has(realName) && ts3.isIdentifierText(realName, target)) {
              uniqueNames.add(realName);
              ts3.insertSorted(entries, {
                name: realName,
                kind: "warning",
                kindModifiers: "",
                sortText: Completions2.SortText.JavascriptIdentifiers,
                isFromUncheckedFile: true
              }, compareCompletionEntries);
            }
          });
        }
        function completionNameForLiteral(sourceFile, preferences, literal) {
          return typeof literal === "object" ? ts3.pseudoBigIntToString(literal) + "n" : ts3.isString(literal) ? ts3.quote(sourceFile, preferences, literal) : JSON.stringify(literal);
        }
        function createCompletionEntryForLiteral(sourceFile, preferences, literal) {
          return { name: completionNameForLiteral(sourceFile, preferences, literal), kind: "string", kindModifiers: "", sortText: Completions2.SortText.LocationPriority };
        }
        function createCompletionEntry(symbol, sortText, replacementToken, contextToken, location, sourceFile, host, program2, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, importCompletionNode, useSemicolons, options, preferences, completionKind, formatContext, isJsxIdentifierExpected, isRightOfOpenTag) {
          var _a, _b;
          var insertText;
          var replacementSpan = ts3.getReplacementSpanForContextToken(replacementToken);
          var data;
          var isSnippet;
          var source = getSourceFromOrigin(origin);
          var sourceDisplay;
          var hasAction;
          var labelDetails;
          var typeChecker = program2.getTypeChecker();
          var insertQuestionDot = origin && originIsNullableMember(origin);
          var useBraces = origin && originIsSymbolMember(origin) || needsConvertPropertyAccess;
          if (origin && originIsThisType(origin)) {
            insertText = needsConvertPropertyAccess ? "this".concat(insertQuestionDot ? "?." : "", "[").concat(quotePropertyName(sourceFile, preferences, name), "]") : "this".concat(insertQuestionDot ? "?." : ".").concat(name);
          } else if ((useBraces || insertQuestionDot) && propertyAccessToConvert) {
            insertText = useBraces ? needsConvertPropertyAccess ? "[".concat(quotePropertyName(sourceFile, preferences, name), "]") : "[".concat(name, "]") : name;
            if (insertQuestionDot || propertyAccessToConvert.questionDotToken) {
              insertText = "?.".concat(insertText);
            }
            var dot = ts3.findChildOfKind(propertyAccessToConvert, 24, sourceFile) || ts3.findChildOfKind(propertyAccessToConvert, 28, sourceFile);
            if (!dot) {
              return void 0;
            }
            var end = ts3.startsWith(name, propertyAccessToConvert.name.text) ? propertyAccessToConvert.name.end : dot.end;
            replacementSpan = ts3.createTextSpanFromBounds(dot.getStart(sourceFile), end);
          }
          if (isJsxInitializer) {
            if (insertText === void 0)
              insertText = name;
            insertText = "{".concat(insertText, "}");
            if (typeof isJsxInitializer !== "boolean") {
              replacementSpan = ts3.createTextSpanFromNode(isJsxInitializer, sourceFile);
            }
          }
          if (origin && originIsPromise(origin) && propertyAccessToConvert) {
            if (insertText === void 0)
              insertText = name;
            var precedingToken = ts3.findPrecedingToken(propertyAccessToConvert.pos, sourceFile);
            var awaitText = "";
            if (precedingToken && ts3.positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
              awaitText = ";";
            }
            awaitText += "(await ".concat(propertyAccessToConvert.expression.getText(), ")");
            insertText = needsConvertPropertyAccess ? "".concat(awaitText).concat(insertText) : "".concat(awaitText).concat(insertQuestionDot ? "?." : ".").concat(insertText);
            replacementSpan = ts3.createTextSpanFromBounds(propertyAccessToConvert.getStart(sourceFile), propertyAccessToConvert.end);
          }
          if (originIsResolvedExport(origin)) {
            sourceDisplay = [ts3.textPart(origin.moduleSpecifier)];
            if (importCompletionNode) {
              _a = getInsertTextAndReplacementSpanForImportCompletion(name, importCompletionNode, contextToken, origin, useSemicolons, options, preferences), insertText = _a.insertText, replacementSpan = _a.replacementSpan;
              isSnippet = preferences.includeCompletionsWithSnippetText ? true : void 0;
            }
          }
          if ((origin === null || origin === void 0 ? void 0 : origin.kind) === 64) {
            hasAction = true;
          }
          if (preferences.includeCompletionsWithClassMemberSnippets && preferences.includeCompletionsWithInsertText && completionKind === 3 && isClassLikeMemberCompletion(symbol, location)) {
            var importAdder = void 0;
            _b = getEntryForMemberCompletion(host, program2, options, preferences, name, symbol, location, contextToken, formatContext), insertText = _b.insertText, isSnippet = _b.isSnippet, importAdder = _b.importAdder, replacementSpan = _b.replacementSpan;
            sortText = Completions2.SortText.ClassMemberSnippets;
            if (importAdder === null || importAdder === void 0 ? void 0 : importAdder.hasFixes()) {
              hasAction = true;
              source = CompletionSource.ClassMemberSnippet;
            }
          }
          if (origin && originIsObjectLiteralMethod(origin)) {
            insertText = origin.insertText, isSnippet = origin.isSnippet, labelDetails = origin.labelDetails;
            if (!preferences.useLabelDetailsInCompletionEntries) {
              name = name + labelDetails.detail;
              labelDetails = void 0;
            }
            source = CompletionSource.ObjectLiteralMethodSnippet;
            sortText = Completions2.SortText.SortBelow(sortText);
          }
          if (isJsxIdentifierExpected && !isRightOfOpenTag && preferences.includeCompletionsWithSnippetText && preferences.jsxAttributeCompletionStyle && preferences.jsxAttributeCompletionStyle !== "none") {
            var useBraces_1 = preferences.jsxAttributeCompletionStyle === "braces";
            var type2 = typeChecker.getTypeOfSymbolAtLocation(symbol, location);
            if (preferences.jsxAttributeCompletionStyle === "auto" && !(type2.flags & 528) && !(type2.flags & 1048576 && ts3.find(type2.types, function(type3) {
              return !!(type3.flags & 528);
            }))) {
              if (type2.flags & 402653316 || type2.flags & 1048576 && ts3.every(type2.types, function(type3) {
                return !!(type3.flags & (402653316 | 32768));
              })) {
                insertText = "".concat(ts3.escapeSnippetText(name), "=").concat(ts3.quote(sourceFile, preferences, "$1"));
                isSnippet = true;
              } else {
                useBraces_1 = true;
              }
            }
            if (useBraces_1) {
              insertText = "".concat(ts3.escapeSnippetText(name), "={$1}");
              isSnippet = true;
            }
          }
          if (insertText !== void 0 && !preferences.includeCompletionsWithInsertText) {
            return void 0;
          }
          if (originIsExport(origin) || originIsResolvedExport(origin)) {
            data = originToCompletionEntryData(origin);
            hasAction = !importCompletionNode;
          }
          return {
            name,
            kind: ts3.SymbolDisplay.getSymbolKind(typeChecker, symbol, location),
            kindModifiers: ts3.SymbolDisplay.getSymbolModifiers(typeChecker, symbol),
            sortText,
            source,
            hasAction: hasAction ? true : void 0,
            isRecommended: isRecommendedCompletionMatch(symbol, recommendedCompletion, typeChecker) || void 0,
            insertText,
            replacementSpan,
            sourceDisplay,
            labelDetails,
            isSnippet,
            isPackageJsonImport: originIsPackageJsonImport(origin) || void 0,
            isImportStatementCompletion: !!importCompletionNode || void 0,
            data
          };
        }
        function isClassLikeMemberCompletion(symbol, location) {
          if (ts3.isInJSFile(location)) {
            return false;
          }
          var memberFlags = 106500 & 900095;
          return !!(symbol.flags & memberFlags) && (ts3.isClassLike(location) || location.parent && location.parent.parent && ts3.isClassElement(location.parent) && location === location.parent.name && ts3.isClassLike(location.parent.parent) || location.parent && ts3.isSyntaxList(location) && ts3.isClassLike(location.parent));
        }
        function getEntryForMemberCompletion(host, program2, options, preferences, name, symbol, location, contextToken, formatContext) {
          var classLikeDeclaration = ts3.findAncestor(location, ts3.isClassLike);
          if (!classLikeDeclaration) {
            return { insertText: name };
          }
          var isSnippet;
          var replacementSpan;
          var insertText = name;
          var checker = program2.getTypeChecker();
          var sourceFile = location.getSourceFile();
          var printer2 = createSnippetPrinter({
            removeComments: true,
            module: options.module,
            target: options.target,
            omitTrailingSemicolon: false,
            newLine: ts3.getNewLineKind(ts3.getNewLineCharacter(options, ts3.maybeBind(host, host.getNewLine)))
          });
          var importAdder = ts3.codefix.createImportAdder(sourceFile, program2, preferences, host);
          var body;
          if (preferences.includeCompletionsWithSnippetText) {
            isSnippet = true;
            var emptyStmt = ts3.factory.createEmptyStatement();
            body = ts3.factory.createBlock([emptyStmt], true);
            ts3.setSnippetElement(emptyStmt, { kind: 0, order: 0 });
          } else {
            body = ts3.factory.createBlock([], true);
          }
          var modifiers = 0;
          var _a = getPresentModifiers(contextToken), presentModifiers = _a.modifiers, modifiersSpan = _a.span;
          var isAbstract = !!(presentModifiers & 128);
          var completionNodes = [];
          ts3.codefix.addNewNodeForMemberSymbol(symbol, classLikeDeclaration, sourceFile, { program: program2, host }, preferences, importAdder, function(node) {
            var requiredModifiers = 0;
            if (isAbstract) {
              requiredModifiers |= 128;
            }
            if (ts3.isClassElement(node) && checker.getMemberOverrideModifierStatus(classLikeDeclaration, node) === 1) {
              requiredModifiers |= 16384;
            }
            if (!completionNodes.length) {
              modifiers = node.modifierFlagsCache | requiredModifiers | presentModifiers;
            }
            node = ts3.factory.updateModifiers(node, modifiers);
            completionNodes.push(node);
          }, body, 2, isAbstract);
          if (completionNodes.length) {
            var format = 1 | 131072;
            replacementSpan = modifiersSpan;
            if (formatContext) {
              insertText = printer2.printAndFormatSnippetList(format, ts3.factory.createNodeArray(completionNodes), sourceFile, formatContext);
            } else {
              insertText = printer2.printSnippetList(format, ts3.factory.createNodeArray(completionNodes), sourceFile);
            }
          }
          return { insertText, isSnippet, importAdder, replacementSpan };
        }
        function getPresentModifiers(contextToken) {
          if (!contextToken) {
            return { modifiers: 0 };
          }
          var modifiers = 0;
          var span;
          var contextMod;
          if (contextMod = isModifierLike(contextToken)) {
            modifiers |= ts3.modifierToFlag(contextMod);
            span = ts3.createTextSpanFromNode(contextToken);
          }
          if (ts3.isPropertyDeclaration(contextToken.parent)) {
            modifiers |= ts3.modifiersToFlags(contextToken.parent.modifiers);
            span = ts3.createTextSpanFromNode(contextToken.parent);
          }
          return { modifiers, span };
        }
        function isModifierLike(node) {
          if (ts3.isModifier(node)) {
            return node.kind;
          }
          if (ts3.isIdentifier(node) && node.originalKeywordKind && ts3.isModifierKind(node.originalKeywordKind)) {
            return node.originalKeywordKind;
          }
          return void 0;
        }
        function getEntryForObjectLiteralMethodCompletion(symbol, name, enclosingDeclaration, program2, host, options, preferences, formatContext) {
          var isSnippet = preferences.includeCompletionsWithSnippetText || void 0;
          var insertText = name;
          var sourceFile = enclosingDeclaration.getSourceFile();
          var method = createObjectLiteralMethod(symbol, enclosingDeclaration, sourceFile, program2, host, preferences);
          if (!method) {
            return void 0;
          }
          var printer2 = createSnippetPrinter({
            removeComments: true,
            module: options.module,
            target: options.target,
            omitTrailingSemicolon: false,
            newLine: ts3.getNewLineKind(ts3.getNewLineCharacter(options, ts3.maybeBind(host, host.getNewLine)))
          });
          if (formatContext) {
            insertText = printer2.printAndFormatSnippetList(16 | 64, ts3.factory.createNodeArray([method], true), sourceFile, formatContext);
          } else {
            insertText = printer2.printSnippetList(16 | 64, ts3.factory.createNodeArray([method], true), sourceFile);
          }
          var signaturePrinter = ts3.createPrinter({
            removeComments: true,
            module: options.module,
            target: options.target,
            omitTrailingSemicolon: true
          });
          var methodSignature = ts3.factory.createMethodSignature(void 0, "", method.questionToken, method.typeParameters, method.parameters, method.type);
          var labelDetails = { detail: signaturePrinter.printNode(4, methodSignature, sourceFile) };
          return { isSnippet, insertText, labelDetails };
        }
        ;
        function createObjectLiteralMethod(symbol, enclosingDeclaration, sourceFile, program2, host, preferences) {
          var declarations = symbol.getDeclarations();
          if (!(declarations && declarations.length)) {
            return void 0;
          }
          var checker = program2.getTypeChecker();
          var declaration = declarations[0];
          var name = ts3.getSynthesizedDeepClone(ts3.getNameOfDeclaration(declaration), false);
          var type2 = checker.getWidenedType(checker.getTypeOfSymbolAtLocation(symbol, enclosingDeclaration));
          var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
          var builderFlags = quotePreference === 0 ? 268435456 : void 0;
          switch (declaration.kind) {
            case 166:
            case 167:
            case 168:
            case 169: {
              var effectiveType = type2.flags & 1048576 && type2.types.length < 10 ? checker.getUnionType(type2.types, 2) : type2;
              if (effectiveType.flags & 1048576) {
                var functionTypes = ts3.filter(effectiveType.types, function(type3) {
                  return checker.getSignaturesOfType(type3, 0).length > 0;
                });
                if (functionTypes.length === 1) {
                  effectiveType = functionTypes[0];
                } else {
                  return void 0;
                }
              }
              var signatures = checker.getSignaturesOfType(effectiveType, 0);
              if (signatures.length !== 1) {
                return void 0;
              }
              var typeNode = checker.typeToTypeNode(effectiveType, enclosingDeclaration, builderFlags, ts3.codefix.getNoopSymbolTrackerWithResolver({ program: program2, host }));
              if (!typeNode || !ts3.isFunctionTypeNode(typeNode)) {
                return void 0;
              }
              var body = void 0;
              if (preferences.includeCompletionsWithSnippetText) {
                var emptyStmt = ts3.factory.createEmptyStatement();
                body = ts3.factory.createBlock([emptyStmt], true);
                ts3.setSnippetElement(emptyStmt, { kind: 0, order: 0 });
              } else {
                body = ts3.factory.createBlock([], true);
              }
              var parameters = typeNode.parameters.map(function(typedParam) {
                return ts3.factory.createParameterDeclaration(void 0, void 0, typedParam.dotDotDotToken, typedParam.name, typedParam.questionToken, void 0, typedParam.initializer);
              });
              return ts3.factory.createMethodDeclaration(void 0, void 0, void 0, name, void 0, void 0, parameters, void 0, body);
            }
            default:
              return void 0;
          }
        }
        function createSnippetPrinter(printerOptions) {
          var escapes;
          var baseWriter = ts3.textChanges.createWriter(ts3.getNewLineCharacter(printerOptions));
          var printer2 = ts3.createPrinter(printerOptions, baseWriter);
          var writer = __assign(__assign({}, baseWriter), { write: function(s) {
            return escapingWrite(s, function() {
              return baseWriter.write(s);
            });
          }, nonEscapingWrite: baseWriter.write, writeLiteral: function(s) {
            return escapingWrite(s, function() {
              return baseWriter.writeLiteral(s);
            });
          }, writeStringLiteral: function(s) {
            return escapingWrite(s, function() {
              return baseWriter.writeStringLiteral(s);
            });
          }, writeSymbol: function(s, symbol) {
            return escapingWrite(s, function() {
              return baseWriter.writeSymbol(s, symbol);
            });
          }, writeParameter: function(s) {
            return escapingWrite(s, function() {
              return baseWriter.writeParameter(s);
            });
          }, writeComment: function(s) {
            return escapingWrite(s, function() {
              return baseWriter.writeComment(s);
            });
          }, writeProperty: function(s) {
            return escapingWrite(s, function() {
              return baseWriter.writeProperty(s);
            });
          } });
          return {
            printSnippetList,
            printAndFormatSnippetList
          };
          function escapingWrite(s, write) {
            var escaped = ts3.escapeSnippetText(s);
            if (escaped !== s) {
              var start = baseWriter.getTextPos();
              write();
              var end = baseWriter.getTextPos();
              escapes = ts3.append(escapes || (escapes = []), { newText: escaped, span: { start, length: end - start } });
            } else {
              write();
            }
          }
          function printSnippetList(format, list, sourceFile) {
            var unescaped = printUnescapedSnippetList(format, list, sourceFile);
            return escapes ? ts3.textChanges.applyChanges(unescaped, escapes) : unescaped;
          }
          function printUnescapedSnippetList(format, list, sourceFile) {
            escapes = void 0;
            writer.clear();
            printer2.writeList(format, list, sourceFile, writer);
            return writer.getText();
          }
          function printAndFormatSnippetList(format, list, sourceFile, formatContext) {
            var syntheticFile = {
              text: printUnescapedSnippetList(format, list, sourceFile),
              getLineAndCharacterOfPosition: function(pos) {
                return ts3.getLineAndCharacterOfPosition(this, pos);
              }
            };
            var formatOptions = ts3.getFormatCodeSettingsForWriting(formatContext, sourceFile);
            var changes = ts3.flatMap(list, function(node) {
              var nodeWithPos = ts3.textChanges.assignPositionsToNode(node);
              return ts3.formatting.formatNodeGivenIndentation(nodeWithPos, syntheticFile, sourceFile.languageVariant, 0, 0, __assign(__assign({}, formatContext), { options: formatOptions }));
            });
            var allChanges = escapes ? ts3.stableSort(ts3.concatenate(changes, escapes), function(a, b) {
              return ts3.compareTextSpans(a.span, b.span);
            }) : changes;
            return ts3.textChanges.applyChanges(syntheticFile.text, allChanges);
          }
        }
        function originToCompletionEntryData(origin) {
          var ambientModuleName = origin.fileName ? void 0 : ts3.stripQuotes(origin.moduleSymbol.name);
          var isPackageJsonImport = origin.isFromPackageJson ? true : void 0;
          if (originIsResolvedExport(origin)) {
            var resolvedData = {
              exportName: origin.exportName,
              moduleSpecifier: origin.moduleSpecifier,
              ambientModuleName,
              fileName: origin.fileName,
              isPackageJsonImport
            };
            return resolvedData;
          }
          var unresolvedData = {
            exportName: origin.exportName,
            exportMapKey: origin.exportMapKey,
            fileName: origin.fileName,
            ambientModuleName: origin.fileName ? void 0 : ts3.stripQuotes(origin.moduleSymbol.name),
            isPackageJsonImport: origin.isFromPackageJson ? true : void 0
          };
          return unresolvedData;
        }
        function completionEntryDataToSymbolOriginInfo(data, completionName, moduleSymbol) {
          var isDefaultExport = data.exportName === "default";
          var isFromPackageJson = !!data.isPackageJsonImport;
          if (completionEntryDataIsResolved(data)) {
            var resolvedOrigin = {
              kind: 32,
              exportName: data.exportName,
              moduleSpecifier: data.moduleSpecifier,
              symbolName: completionName,
              fileName: data.fileName,
              moduleSymbol,
              isDefaultExport,
              isFromPackageJson
            };
            return resolvedOrigin;
          }
          var unresolvedOrigin = {
            kind: 4,
            exportName: data.exportName,
            exportMapKey: data.exportMapKey,
            symbolName: completionName,
            fileName: data.fileName,
            moduleSymbol,
            isDefaultExport,
            isFromPackageJson
          };
          return unresolvedOrigin;
        }
        function getInsertTextAndReplacementSpanForImportCompletion(name, importCompletionNode, contextToken, origin, useSemicolons, options, preferences) {
          var _a, _b, _c;
          var sourceFile = importCompletionNode.getSourceFile();
          var replacementSpan = ts3.createTextSpanFromNode(ts3.findAncestor(importCompletionNode, ts3.or(ts3.isImportDeclaration, ts3.isImportEqualsDeclaration)) || importCompletionNode, sourceFile);
          var quotedModuleSpecifier = ts3.quote(sourceFile, preferences, origin.moduleSpecifier);
          var exportKind = origin.isDefaultExport ? 1 : origin.exportName === "export=" ? 2 : 0;
          var tabStop = preferences.includeCompletionsWithSnippetText ? "$1" : "";
          var importKind = ts3.codefix.getImportKind(sourceFile, exportKind, options, true);
          var isTopLevelTypeOnly = ((_b = (_a = ts3.tryCast(importCompletionNode, ts3.isImportDeclaration)) === null || _a === void 0 ? void 0 : _a.importClause) === null || _b === void 0 ? void 0 : _b.isTypeOnly) || ((_c = ts3.tryCast(importCompletionNode, ts3.isImportEqualsDeclaration)) === null || _c === void 0 ? void 0 : _c.isTypeOnly);
          var isImportSpecifierTypeOnly = couldBeTypeOnlyImportSpecifier(importCompletionNode, contextToken);
          var topLevelTypeOnlyText = isTopLevelTypeOnly ? " ".concat(ts3.tokenToString(152), " ") : " ";
          var importSpecifierTypeOnlyText = isImportSpecifierTypeOnly ? "".concat(ts3.tokenToString(152), " ") : "";
          var suffix = useSemicolons ? ";" : "";
          switch (importKind) {
            case 3:
              return { replacementSpan, insertText: "import".concat(topLevelTypeOnlyText).concat(ts3.escapeSnippetText(name)).concat(tabStop, " = require(").concat(quotedModuleSpecifier, ")").concat(suffix) };
            case 1:
              return { replacementSpan, insertText: "import".concat(topLevelTypeOnlyText).concat(ts3.escapeSnippetText(name)).concat(tabStop, " from ").concat(quotedModuleSpecifier).concat(suffix) };
            case 2:
              return { replacementSpan, insertText: "import".concat(topLevelTypeOnlyText, "* as ").concat(ts3.escapeSnippetText(name), " from ").concat(quotedModuleSpecifier).concat(suffix) };
            case 0:
              return { replacementSpan, insertText: "import".concat(topLevelTypeOnlyText, "{ ").concat(importSpecifierTypeOnlyText).concat(ts3.escapeSnippetText(name)).concat(tabStop, " } from ").concat(quotedModuleSpecifier).concat(suffix) };
          }
        }
        function quotePropertyName(sourceFile, preferences, name) {
          if (/^\d+$/.test(name)) {
            return name;
          }
          return ts3.quote(sourceFile, preferences, name);
        }
        function isRecommendedCompletionMatch(localSymbol, recommendedCompletion, checker) {
          return localSymbol === recommendedCompletion || !!(localSymbol.flags & 1048576) && checker.getExportSymbolOfSymbol(localSymbol) === recommendedCompletion;
        }
        function getSourceFromOrigin(origin) {
          if (originIsExport(origin)) {
            return ts3.stripQuotes(origin.moduleSymbol.name);
          }
          if (originIsResolvedExport(origin)) {
            return origin.moduleSpecifier;
          }
          if ((origin === null || origin === void 0 ? void 0 : origin.kind) === 1) {
            return CompletionSource.ThisProperty;
          }
          if ((origin === null || origin === void 0 ? void 0 : origin.kind) === 64) {
            return CompletionSource.TypeOnlyAlias;
          }
        }
        function getCompletionEntriesFromSymbols(symbols, entries, replacementToken, contextToken, location, sourceFile, host, program2, target, log, kind, preferences, compilerOptions, formatContext, isTypeOnlyLocation, propertyAccessToConvert, jsxIdentifierExpected, isJsxInitializer, importCompletionNode, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap, isJsxIdentifierExpected, isRightOfOpenTag) {
          var _a;
          var start = ts3.timestamp();
          var variableDeclaration = getVariableDeclaration(location);
          var useSemicolons = ts3.probablyUsesSemicolons(sourceFile);
          var typeChecker = program2.getTypeChecker();
          var uniques = new ts3.Map();
          for (var i = 0; i < symbols.length; i++) {
            var symbol = symbols[i];
            var origin = symbolToOriginInfoMap === null || symbolToOriginInfoMap === void 0 ? void 0 : symbolToOriginInfoMap[i];
            var info = getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, !!jsxIdentifierExpected);
            if (!info || uniques.get(info.name) && (!origin || !originIsObjectLiteralMethod(origin)) || kind === 1 && symbolToSortTextMap && !shouldIncludeSymbol(symbol, symbolToSortTextMap)) {
              continue;
            }
            var name = info.name, needsConvertPropertyAccess = info.needsConvertPropertyAccess;
            var originalSortText = (_a = symbolToSortTextMap === null || symbolToSortTextMap === void 0 ? void 0 : symbolToSortTextMap[ts3.getSymbolId(symbol)]) !== null && _a !== void 0 ? _a : Completions2.SortText.LocationPriority;
            var sortText = isDeprecated(symbol, typeChecker) ? Completions2.SortText.Deprecated(originalSortText) : originalSortText;
            var entry = createCompletionEntry(symbol, sortText, replacementToken, contextToken, location, sourceFile, host, program2, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, importCompletionNode, useSemicolons, compilerOptions, preferences, kind, formatContext, isJsxIdentifierExpected, isRightOfOpenTag);
            if (!entry) {
              continue;
            }
            var shouldShadowLaterSymbols = (!origin || originIsTypeOnlyAlias(origin)) && !(symbol.parent === void 0 && !ts3.some(symbol.declarations, function(d) {
              return d.getSourceFile() === location.getSourceFile();
            }));
            uniques.set(name, shouldShadowLaterSymbols);
            ts3.insertSorted(entries, entry, compareCompletionEntries, true);
          }
          log("getCompletionsAtPosition: getCompletionEntriesFromSymbols: " + (ts3.timestamp() - start));
          return {
            has: function(name2) {
              return uniques.has(name2);
            },
            add: function(name2) {
              return uniques.set(name2, true);
            }
          };
          function shouldIncludeSymbol(symbol2, symbolToSortTextMap2) {
            var allFlags = symbol2.flags;
            if (!ts3.isSourceFile(location)) {
              if (ts3.isExportAssignment(location.parent)) {
                return true;
              }
              if (variableDeclaration && symbol2.valueDeclaration === variableDeclaration) {
                return false;
              }
              var symbolOrigin = ts3.skipAlias(symbol2, typeChecker);
              if (!!sourceFile.externalModuleIndicator && !compilerOptions.allowUmdGlobalAccess && symbolToSortTextMap2[ts3.getSymbolId(symbol2)] === Completions2.SortText.GlobalsOrKeywords && (symbolToSortTextMap2[ts3.getSymbolId(symbolOrigin)] === Completions2.SortText.AutoImportSuggestions || symbolToSortTextMap2[ts3.getSymbolId(symbolOrigin)] === Completions2.SortText.LocationPriority)) {
                return false;
              }
              allFlags |= ts3.getCombinedLocalAndExportSymbolFlags(symbolOrigin);
              if (ts3.isInRightSideOfInternalImportEqualsDeclaration(location)) {
                return !!(allFlags & 1920);
              }
              if (isTypeOnlyLocation) {
                return symbolCanBeReferencedAtTypeLocation(symbol2, typeChecker);
              }
            }
            return !!(allFlags & 111551);
          }
        }
        Completions2.getCompletionEntriesFromSymbols = getCompletionEntriesFromSymbols;
        function getLabelCompletionAtPosition(node) {
          var entries = getLabelStatementCompletions(node);
          if (entries.length) {
            return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
          }
        }
        function getLabelStatementCompletions(node) {
          var entries = [];
          var uniques = new ts3.Map();
          var current = node;
          while (current) {
            if (ts3.isFunctionLike(current)) {
              break;
            }
            if (ts3.isLabeledStatement(current)) {
              var name = current.label.text;
              if (!uniques.has(name)) {
                uniques.set(name, true);
                entries.push({
                  name,
                  kindModifiers: "",
                  kind: "label",
                  sortText: Completions2.SortText.LocationPriority
                });
              }
            }
            current = current.parent;
          }
          return entries;
        }
        function getSymbolCompletionFromEntryId(program2, log, sourceFile, position, entryId, host, preferences) {
          if (entryId.data) {
            var autoImport = getAutoImportSymbolFromCompletionEntryData(entryId.name, entryId.data, program2, host);
            if (autoImport) {
              var _a = getRelevantTokens(position, sourceFile), contextToken_1 = _a.contextToken, previousToken_1 = _a.previousToken;
              return {
                type: "symbol",
                symbol: autoImport.symbol,
                location: ts3.getTouchingPropertyName(sourceFile, position),
                previousToken: previousToken_1,
                contextToken: contextToken_1,
                isJsxInitializer: false,
                isTypeOnlyLocation: false,
                origin: autoImport.origin
              };
            }
          }
          var compilerOptions = program2.getCompilerOptions();
          var completionData = getCompletionData(program2, log, sourceFile, compilerOptions, position, { includeCompletionsForModuleExports: true, includeCompletionsWithInsertText: true }, entryId, host, void 0);
          if (!completionData) {
            return { type: "none" };
          }
          if (completionData.kind !== 0) {
            return { type: "request", request: completionData };
          }
          var symbols = completionData.symbols, literals = completionData.literals, location = completionData.location, completionKind = completionData.completionKind, symbolToOriginInfoMap = completionData.symbolToOriginInfoMap, contextToken = completionData.contextToken, previousToken = completionData.previousToken, isJsxInitializer = completionData.isJsxInitializer, isTypeOnlyLocation = completionData.isTypeOnlyLocation;
          var literal = ts3.find(literals, function(l) {
            return completionNameForLiteral(sourceFile, preferences, l) === entryId.name;
          });
          if (literal !== void 0)
            return { type: "literal", literal };
          return ts3.firstDefined(symbols, function(symbol, index) {
            var origin = symbolToOriginInfoMap[index];
            var info = getCompletionEntryDisplayNameForSymbol(symbol, ts3.getEmitScriptTarget(compilerOptions), origin, completionKind, completionData.isJsxIdentifierExpected);
            return info && info.name === entryId.name && (entryId.source === CompletionSource.ClassMemberSnippet && symbol.flags & 106500 || entryId.source === CompletionSource.ObjectLiteralMethodSnippet && symbol.flags & (4 | 8192) || getSourceFromOrigin(origin) === entryId.source) ? { type: "symbol", symbol, location, origin, contextToken, previousToken, isJsxInitializer, isTypeOnlyLocation } : void 0;
          }) || { type: "none" };
        }
        function getCompletionEntryDetails(program2, log, sourceFile, position, entryId, host, formatContext, preferences, cancellationToken) {
          var typeChecker = program2.getTypeChecker();
          var compilerOptions = program2.getCompilerOptions();
          var name = entryId.name, source = entryId.source, data = entryId.data;
          var contextToken = ts3.findPrecedingToken(position, sourceFile);
          if (ts3.isInString(sourceFile, position, contextToken)) {
            return Completions2.StringCompletions.getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, typeChecker, compilerOptions, host, cancellationToken, preferences);
          }
          var symbolCompletion = getSymbolCompletionFromEntryId(program2, log, sourceFile, position, entryId, host, preferences);
          switch (symbolCompletion.type) {
            case "request": {
              var request = symbolCompletion.request;
              switch (request.kind) {
                case 1:
                  return ts3.JsDoc.getJSDocTagNameCompletionDetails(name);
                case 2:
                  return ts3.JsDoc.getJSDocTagCompletionDetails(name);
                case 3:
                  return ts3.JsDoc.getJSDocParameterNameCompletionDetails(name);
                case 4:
                  return ts3.some(request.keywordCompletions, function(c) {
                    return c.name === name;
                  }) ? createSimpleDetails(name, "keyword", ts3.SymbolDisplayPartKind.keyword) : void 0;
                default:
                  return ts3.Debug.assertNever(request);
              }
            }
            case "symbol": {
              var symbol = symbolCompletion.symbol, location = symbolCompletion.location, contextToken_2 = symbolCompletion.contextToken, origin = symbolCompletion.origin, previousToken = symbolCompletion.previousToken;
              var _a = getCompletionEntryCodeActionsAndSourceDisplay(name, location, contextToken_2, origin, symbol, program2, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences, data, source), codeActions = _a.codeActions, sourceDisplay = _a.sourceDisplay;
              return createCompletionDetailsForSymbol(symbol, typeChecker, sourceFile, location, cancellationToken, codeActions, sourceDisplay);
            }
            case "literal": {
              var literal = symbolCompletion.literal;
              return createSimpleDetails(completionNameForLiteral(sourceFile, preferences, literal), "string", typeof literal === "string" ? ts3.SymbolDisplayPartKind.stringLiteral : ts3.SymbolDisplayPartKind.numericLiteral);
            }
            case "none":
              return allKeywordsCompletions().some(function(c) {
                return c.name === name;
              }) ? createSimpleDetails(name, "keyword", ts3.SymbolDisplayPartKind.keyword) : void 0;
            default:
              ts3.Debug.assertNever(symbolCompletion);
          }
        }
        Completions2.getCompletionEntryDetails = getCompletionEntryDetails;
        function createSimpleDetails(name, kind, kind2) {
          return createCompletionDetails(name, "", kind, [ts3.displayPart(name, kind2)]);
        }
        function createCompletionDetailsForSymbol(symbol, checker, sourceFile, location, cancellationToken, codeActions, sourceDisplay) {
          var _a = checker.runWithCancellationToken(cancellationToken, function(checker2) {
            return ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker2, symbol, sourceFile, location, location, 7);
          }), displayParts = _a.displayParts, documentation = _a.documentation, symbolKind = _a.symbolKind, tags = _a.tags;
          return createCompletionDetails(symbol.name, ts3.SymbolDisplay.getSymbolModifiers(checker, symbol), symbolKind, displayParts, documentation, tags, codeActions, sourceDisplay);
        }
        Completions2.createCompletionDetailsForSymbol = createCompletionDetailsForSymbol;
        function createCompletionDetails(name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source) {
          return { name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source, sourceDisplay: source };
        }
        Completions2.createCompletionDetails = createCompletionDetails;
        function getCompletionEntryCodeActionsAndSourceDisplay(name, location, contextToken, origin, symbol, program2, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences, data, source) {
          if (data === null || data === void 0 ? void 0 : data.moduleSpecifier) {
            if (previousToken && getImportStatementCompletionInfo(contextToken || previousToken).replacementNode) {
              return { codeActions: void 0, sourceDisplay: [ts3.textPart(data.moduleSpecifier)] };
            }
          }
          if (source === CompletionSource.ClassMemberSnippet) {
            var importAdder = getEntryForMemberCompletion(host, program2, compilerOptions, preferences, name, symbol, location, contextToken, formatContext).importAdder;
            if (importAdder) {
              var changes = ts3.textChanges.ChangeTracker.with({ host, formatContext, preferences }, importAdder.writeFixes);
              return {
                sourceDisplay: void 0,
                codeActions: [{
                  changes,
                  description: ts3.diagnosticToString([ts3.Diagnostics.Includes_imports_of_types_referenced_by_0, name])
                }]
              };
            }
          }
          if (originIsTypeOnlyAlias(origin)) {
            var codeAction_1 = ts3.codefix.getPromoteTypeOnlyCompletionAction(sourceFile, origin.declaration.name, program2, host, formatContext, preferences);
            ts3.Debug.assertIsDefined(codeAction_1, "Expected to have a code action for promoting type-only alias");
            return { codeActions: [codeAction_1], sourceDisplay: void 0 };
          }
          if (!origin || !(originIsExport(origin) || originIsResolvedExport(origin))) {
            return { codeActions: void 0, sourceDisplay: void 0 };
          }
          var checker = origin.isFromPackageJson ? host.getPackageJsonAutoImportProvider().getTypeChecker() : program2.getTypeChecker();
          var moduleSymbol = origin.moduleSymbol;
          var targetSymbol = checker.getMergedSymbol(ts3.skipAlias(symbol.exportSymbol || symbol, checker));
          var isJsxOpeningTagName = (contextToken === null || contextToken === void 0 ? void 0 : contextToken.kind) === 29 && ts3.isJsxOpeningLikeElement(contextToken.parent);
          var _a = ts3.codefix.getImportCompletionAction(targetSymbol, moduleSymbol, sourceFile, ts3.getNameForExportedSymbol(symbol, ts3.getEmitScriptTarget(compilerOptions), isJsxOpeningTagName), isJsxOpeningTagName, host, program2, formatContext, previousToken && ts3.isIdentifier(previousToken) ? previousToken.getStart(sourceFile) : position, preferences), moduleSpecifier = _a.moduleSpecifier, codeAction = _a.codeAction;
          ts3.Debug.assert(!(data === null || data === void 0 ? void 0 : data.moduleSpecifier) || moduleSpecifier === data.moduleSpecifier);
          return { sourceDisplay: [ts3.textPart(moduleSpecifier)], codeActions: [codeAction] };
        }
        function getCompletionEntrySymbol(program2, log, sourceFile, position, entryId, host, preferences) {
          var completion = getSymbolCompletionFromEntryId(program2, log, sourceFile, position, entryId, host, preferences);
          return completion.type === "symbol" ? completion.symbol : void 0;
        }
        Completions2.getCompletionEntrySymbol = getCompletionEntrySymbol;
        var CompletionDataKind;
        (function(CompletionDataKind2) {
          CompletionDataKind2[CompletionDataKind2["Data"] = 0] = "Data";
          CompletionDataKind2[CompletionDataKind2["JsDocTagName"] = 1] = "JsDocTagName";
          CompletionDataKind2[CompletionDataKind2["JsDocTag"] = 2] = "JsDocTag";
          CompletionDataKind2[CompletionDataKind2["JsDocParameterName"] = 3] = "JsDocParameterName";
          CompletionDataKind2[CompletionDataKind2["Keywords"] = 4] = "Keywords";
        })(CompletionDataKind || (CompletionDataKind = {}));
        var CompletionKind;
        (function(CompletionKind2) {
          CompletionKind2[CompletionKind2["ObjectPropertyDeclaration"] = 0] = "ObjectPropertyDeclaration";
          CompletionKind2[CompletionKind2["Global"] = 1] = "Global";
          CompletionKind2[CompletionKind2["PropertyAccess"] = 2] = "PropertyAccess";
          CompletionKind2[CompletionKind2["MemberLike"] = 3] = "MemberLike";
          CompletionKind2[CompletionKind2["String"] = 4] = "String";
          CompletionKind2[CompletionKind2["None"] = 5] = "None";
        })(CompletionKind = Completions2.CompletionKind || (Completions2.CompletionKind = {}));
        function getRecommendedCompletion(previousToken, contextualType, checker) {
          return ts3.firstDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), function(type2) {
            var symbol = type2 && type2.symbol;
            return symbol && (symbol.flags & (8 | 384 | 32) && !ts3.isAbstractConstructorSymbol(symbol)) ? getFirstSymbolInChain(symbol, previousToken, checker) : void 0;
          });
        }
        function getContextualType(previousToken, position, sourceFile, checker) {
          var parent = previousToken.parent;
          switch (previousToken.kind) {
            case 79:
              return ts3.getContextualTypeFromParent(previousToken, checker);
            case 63:
              switch (parent.kind) {
                case 254:
                  return checker.getContextualType(parent.initializer);
                case 221:
                  return checker.getTypeAtLocation(parent.left);
                case 285:
                  return checker.getContextualTypeForJsxAttribute(parent);
                default:
                  return void 0;
              }
            case 103:
              return checker.getContextualType(parent);
            case 82:
              var caseClause = ts3.tryCast(parent, ts3.isCaseClause);
              return caseClause ? ts3.getSwitchedType(caseClause, checker) : void 0;
            case 18:
              return ts3.isJsxExpression(parent) && !ts3.isJsxElement(parent.parent) && !ts3.isJsxFragment(parent.parent) ? checker.getContextualTypeForJsxAttribute(parent.parent) : void 0;
            default:
              var argInfo = ts3.SignatureHelp.getArgumentInfoForCompletions(previousToken, position, sourceFile);
              return argInfo ? checker.getContextualTypeForArgumentAtIndex(argInfo.invocation, argInfo.argumentIndex + (previousToken.kind === 27 ? 1 : 0)) : ts3.isEqualityOperatorKind(previousToken.kind) && ts3.isBinaryExpression(parent) && ts3.isEqualityOperatorKind(parent.operatorToken.kind) ? checker.getTypeAtLocation(parent.left) : checker.getContextualType(previousToken);
          }
        }
        function getFirstSymbolInChain(symbol, enclosingDeclaration, checker) {
          var chain = checker.getAccessibleSymbolChain(symbol, enclosingDeclaration, 67108863, false);
          if (chain)
            return ts3.first(chain);
          return symbol.parent && (isModuleSymbol(symbol.parent) ? symbol : getFirstSymbolInChain(symbol.parent, enclosingDeclaration, checker));
        }
        function isModuleSymbol(symbol) {
          var _a;
          return !!((_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.some(function(d) {
            return d.kind === 305;
          }));
        }
        function getCompletionData(program2, log, sourceFile, compilerOptions, position, preferences, detailsEntryId, host, formatContext, cancellationToken) {
          var typeChecker = program2.getTypeChecker();
          var inUncheckedFile = isUncheckedFile(sourceFile, compilerOptions);
          var start = ts3.timestamp();
          var currentToken = ts3.getTokenAtPosition(sourceFile, position);
          log("getCompletionData: Get current token: " + (ts3.timestamp() - start));
          start = ts3.timestamp();
          var insideComment = ts3.isInComment(sourceFile, position, currentToken);
          log("getCompletionData: Is inside comment: " + (ts3.timestamp() - start));
          var insideJsDocTagTypeExpression = false;
          var isInSnippetScope = false;
          if (insideComment) {
            if (ts3.hasDocComment(sourceFile, position)) {
              if (sourceFile.text.charCodeAt(position - 1) === 64) {
                return { kind: 1 };
              } else {
                var lineStart = ts3.getLineStartPositionForPosition(position, sourceFile);
                if (!/[^\*|\s(/)]/.test(sourceFile.text.substring(lineStart, position))) {
                  return { kind: 2 };
                }
              }
            }
            var tag = getJsDocTagAtPosition(currentToken, position);
            if (tag) {
              if (tag.tagName.pos <= position && position <= tag.tagName.end) {
                return { kind: 1 };
              }
              var typeExpression = tryGetTypeExpressionFromTag(tag);
              if (typeExpression) {
                currentToken = ts3.getTokenAtPosition(sourceFile, position);
                if (!currentToken || !ts3.isDeclarationName(currentToken) && (currentToken.parent.kind !== 347 || currentToken.parent.name !== currentToken)) {
                  insideJsDocTagTypeExpression = isCurrentlyEditingNode(typeExpression);
                }
              }
              if (!insideJsDocTagTypeExpression && ts3.isJSDocParameterTag(tag) && (ts3.nodeIsMissing(tag.name) || tag.name.pos <= position && position <= tag.name.end)) {
                return { kind: 3, tag };
              }
            }
            if (!insideJsDocTagTypeExpression) {
              log("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");
              return void 0;
            }
          }
          start = ts3.timestamp();
          var isJsOnlyLocation = !insideJsDocTagTypeExpression && ts3.isSourceFileJS(sourceFile);
          var tokens = getRelevantTokens(position, sourceFile);
          var previousToken = tokens.previousToken;
          var contextToken = tokens.contextToken;
          log("getCompletionData: Get previous token: " + (ts3.timestamp() - start));
          var node = currentToken;
          var propertyAccessToConvert;
          var isRightOfDot = false;
          var isRightOfQuestionDot = false;
          var isRightOfOpenTag = false;
          var isStartingCloseTag = false;
          var isJsxInitializer = false;
          var isJsxIdentifierExpected = false;
          var importCompletionNode;
          var location = ts3.getTouchingPropertyName(sourceFile, position);
          var keywordFilters = 0;
          var isNewIdentifierLocation = false;
          var flags = 0;
          if (contextToken) {
            var importStatementCompletion = getImportStatementCompletionInfo(contextToken);
            isNewIdentifierLocation = importStatementCompletion.isNewIdentifierLocation;
            if (importStatementCompletion.keywordCompletion) {
              if (importStatementCompletion.isKeywordOnlyCompletion) {
                return {
                  kind: 4,
                  keywordCompletions: [keywordToCompletionEntry(importStatementCompletion.keywordCompletion)],
                  isNewIdentifierLocation
                };
              }
              keywordFilters = keywordFiltersFromSyntaxKind(importStatementCompletion.keywordCompletion);
            }
            if (importStatementCompletion.replacementNode && preferences.includeCompletionsForImportStatements && preferences.includeCompletionsWithInsertText) {
              importCompletionNode = importStatementCompletion.replacementNode;
              flags |= 2;
            }
            if (!importCompletionNode && isCompletionListBlocker(contextToken)) {
              log("Returning an empty list because completion was requested in an invalid position.");
              return keywordFilters ? keywordCompletionData(keywordFilters, isJsOnlyLocation, isNewIdentifierDefinitionLocation()) : void 0;
            }
            var parent = contextToken.parent;
            if (contextToken.kind === 24 || contextToken.kind === 28) {
              isRightOfDot = contextToken.kind === 24;
              isRightOfQuestionDot = contextToken.kind === 28;
              switch (parent.kind) {
                case 206:
                  propertyAccessToConvert = parent;
                  node = propertyAccessToConvert.expression;
                  var leftmostAccessExpression = ts3.getLeftmostAccessExpression(propertyAccessToConvert);
                  if (ts3.nodeIsMissing(leftmostAccessExpression) || (ts3.isCallExpression(node) || ts3.isFunctionLike(node)) && node.end === contextToken.pos && node.getChildCount(sourceFile) && ts3.last(node.getChildren(sourceFile)).kind !== 21) {
                    return void 0;
                  }
                  break;
                case 161:
                  node = parent.left;
                  break;
                case 261:
                  node = parent.name;
                  break;
                case 200:
                  node = parent;
                  break;
                case 231:
                  node = parent.getFirstToken(sourceFile);
                  ts3.Debug.assert(node.kind === 100 || node.kind === 103);
                  break;
                default:
                  return void 0;
              }
            } else if (!importCompletionNode && sourceFile.languageVariant === 1) {
              if (parent && parent.kind === 206) {
                contextToken = parent;
                parent = parent.parent;
              }
              if (currentToken.parent === location) {
                switch (currentToken.kind) {
                  case 31:
                    if (currentToken.parent.kind === 278 || currentToken.parent.kind === 280) {
                      location = currentToken;
                    }
                    break;
                  case 43:
                    if (currentToken.parent.kind === 279) {
                      location = currentToken;
                    }
                    break;
                }
              }
              switch (parent.kind) {
                case 281:
                  if (contextToken.kind === 43) {
                    isStartingCloseTag = true;
                    location = contextToken;
                  }
                  break;
                case 221:
                  if (!binaryExpressionMayBeOpenTag(parent)) {
                    break;
                  }
                case 279:
                case 278:
                case 280:
                  isJsxIdentifierExpected = true;
                  if (contextToken.kind === 29) {
                    isRightOfOpenTag = true;
                    location = contextToken;
                  }
                  break;
                case 288:
                case 287:
                  if (previousToken.kind === 19 && currentToken.kind === 31) {
                    isJsxIdentifierExpected = true;
                  }
                  break;
                case 285:
                  if (parent.initializer === previousToken && previousToken.end < position) {
                    isJsxIdentifierExpected = true;
                    break;
                  }
                  switch (previousToken.kind) {
                    case 63:
                      isJsxInitializer = true;
                      break;
                    case 79:
                      isJsxIdentifierExpected = true;
                      if (parent !== previousToken.parent && !parent.initializer && ts3.findChildOfKind(parent, 63, sourceFile)) {
                        isJsxInitializer = previousToken;
                      }
                  }
                  break;
              }
            }
          }
          var semanticStart = ts3.timestamp();
          var completionKind = 5;
          var isNonContextualObjectLiteral = false;
          var hasUnresolvedAutoImports = false;
          var symbols = [];
          var importSpecifierResolver;
          var symbolToOriginInfoMap = [];
          var symbolToSortTextMap = [];
          var seenPropertySymbols = new ts3.Map();
          var isTypeOnlyLocation = isTypeOnlyCompletion();
          var getModuleSpecifierResolutionHost = ts3.memoizeOne(function(isFromPackageJson) {
            return ts3.createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program2, host);
          });
          if (isRightOfDot || isRightOfQuestionDot) {
            getTypeScriptMemberSymbols();
          } else if (isRightOfOpenTag) {
            symbols = typeChecker.getJsxIntrinsicTagNamesAt(location);
            ts3.Debug.assertEachIsDefined(symbols, "getJsxIntrinsicTagNames() should all be defined");
            tryGetGlobalSymbols();
            completionKind = 1;
            keywordFilters = 0;
          } else if (isStartingCloseTag) {
            var tagName = contextToken.parent.parent.openingElement.tagName;
            var tagSymbol = typeChecker.getSymbolAtLocation(tagName);
            if (tagSymbol) {
              symbols = [tagSymbol];
            }
            completionKind = 1;
            keywordFilters = 0;
          } else {
            if (!tryGetGlobalSymbols()) {
              return keywordFilters ? keywordCompletionData(keywordFilters, isJsOnlyLocation, isNewIdentifierLocation) : void 0;
            }
          }
          log("getCompletionData: Semantic work: " + (ts3.timestamp() - semanticStart));
          var contextualType = previousToken && getContextualType(previousToken, position, sourceFile, typeChecker);
          var literals = ts3.mapDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), function(t) {
            return t.isLiteral() && !(t.flags & 1024) ? t.value : void 0;
          });
          var recommendedCompletion = previousToken && contextualType && getRecommendedCompletion(previousToken, contextualType, typeChecker);
          return {
            kind: 0,
            symbols,
            completionKind,
            isInSnippetScope,
            propertyAccessToConvert,
            isNewIdentifierLocation,
            location,
            keywordFilters,
            literals,
            symbolToOriginInfoMap,
            recommendedCompletion,
            previousToken,
            contextToken,
            isJsxInitializer,
            insideJsDocTagTypeExpression,
            symbolToSortTextMap,
            isTypeOnlyLocation,
            isJsxIdentifierExpected,
            isRightOfOpenTag,
            importCompletionNode,
            hasUnresolvedAutoImports,
            flags
          };
          function isTagWithTypeExpression(tag2) {
            switch (tag2.kind) {
              case 340:
              case 347:
              case 341:
              case 343:
              case 345:
                return true;
              case 344:
                return !!tag2.constraint;
              default:
                return false;
            }
          }
          function tryGetTypeExpressionFromTag(tag2) {
            if (isTagWithTypeExpression(tag2)) {
              var typeExpression2 = ts3.isJSDocTemplateTag(tag2) ? tag2.constraint : tag2.typeExpression;
              return typeExpression2 && typeExpression2.kind === 309 ? typeExpression2 : void 0;
            }
            return void 0;
          }
          function getTypeScriptMemberSymbols() {
            completionKind = 2;
            var isImportType = ts3.isLiteralImportTypeNode(node);
            var isTypeLocation = insideJsDocTagTypeExpression || isImportType && !node.isTypeOf || ts3.isPartOfTypeNode(node.parent) || ts3.isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker);
            var isRhsOfImportDeclaration = ts3.isInRightSideOfInternalImportEqualsDeclaration(node);
            if (ts3.isEntityName(node) || isImportType || ts3.isPropertyAccessExpression(node)) {
              var isNamespaceName = ts3.isModuleDeclaration(node.parent);
              if (isNamespaceName)
                isNewIdentifierLocation = true;
              var symbol = typeChecker.getSymbolAtLocation(node);
              if (symbol) {
                symbol = ts3.skipAlias(symbol, typeChecker);
                if (symbol.flags & (1536 | 384)) {
                  var exportedSymbols = typeChecker.getExportsOfModule(symbol);
                  ts3.Debug.assertEachIsDefined(exportedSymbols, "getExportsOfModule() should all be defined");
                  var isValidValueAccess_1 = function(symbol2) {
                    return typeChecker.isValidPropertyAccess(isImportType ? node : node.parent, symbol2.name);
                  };
                  var isValidTypeAccess_1 = function(symbol2) {
                    return symbolCanBeReferencedAtTypeLocation(symbol2, typeChecker);
                  };
                  var isValidAccess = isNamespaceName ? function(symbol2) {
                    var _a;
                    return !!(symbol2.flags & 1920) && !((_a = symbol2.declarations) === null || _a === void 0 ? void 0 : _a.every(function(d) {
                      return d.parent === node.parent;
                    }));
                  } : isRhsOfImportDeclaration ? function(symbol2) {
                    return isValidTypeAccess_1(symbol2) || isValidValueAccess_1(symbol2);
                  } : isTypeLocation ? isValidTypeAccess_1 : isValidValueAccess_1;
                  for (var _i = 0, exportedSymbols_1 = exportedSymbols; _i < exportedSymbols_1.length; _i++) {
                    var exportedSymbol = exportedSymbols_1[_i];
                    if (isValidAccess(exportedSymbol)) {
                      symbols.push(exportedSymbol);
                    }
                  }
                  if (!isTypeLocation && symbol.declarations && symbol.declarations.some(function(d) {
                    return d.kind !== 305 && d.kind !== 261 && d.kind !== 260;
                  })) {
                    var type2 = typeChecker.getTypeOfSymbolAtLocation(symbol, node).getNonOptionalType();
                    var insertQuestionDot = false;
                    if (type2.isNullableType()) {
                      var canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
                      if (canCorrectToQuestionDot || isRightOfQuestionDot) {
                        type2 = type2.getNonNullableType();
                        if (canCorrectToQuestionDot) {
                          insertQuestionDot = true;
                        }
                      }
                    }
                    addTypeProperties(type2, !!(node.flags & 32768), insertQuestionDot);
                  }
                  return;
                }
              }
            }
            if (!isTypeLocation) {
              typeChecker.tryGetThisTypeAt(node, false);
              var type2 = typeChecker.getTypeAtLocation(node).getNonOptionalType();
              var insertQuestionDot = false;
              if (type2.isNullableType()) {
                var canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
                if (canCorrectToQuestionDot || isRightOfQuestionDot) {
                  type2 = type2.getNonNullableType();
                  if (canCorrectToQuestionDot) {
                    insertQuestionDot = true;
                  }
                }
              }
              addTypeProperties(type2, !!(node.flags & 32768), insertQuestionDot);
            }
          }
          function addTypeProperties(type2, insertAwait, insertQuestionDot) {
            isNewIdentifierLocation = !!type2.getStringIndexType();
            if (isRightOfQuestionDot && ts3.some(type2.getCallSignatures())) {
              isNewIdentifierLocation = true;
            }
            var propertyAccess = node.kind === 200 ? node : node.parent;
            if (inUncheckedFile) {
              symbols.push.apply(symbols, ts3.filter(getPropertiesForCompletion(type2, typeChecker), function(s) {
                return typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type2, s);
              }));
            } else {
              for (var _i = 0, _a = type2.getApparentProperties(); _i < _a.length; _i++) {
                var symbol = _a[_i];
                if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type2, symbol)) {
                  addPropertySymbol(symbol, false, insertQuestionDot);
                }
              }
            }
            if (insertAwait && preferences.includeCompletionsWithInsertText) {
              var promiseType = typeChecker.getPromisedTypeOfPromise(type2);
              if (promiseType) {
                for (var _b = 0, _c = promiseType.getApparentProperties(); _b < _c.length; _b++) {
                  var symbol = _c[_b];
                  if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, promiseType, symbol)) {
                    addPropertySymbol(symbol, true, insertQuestionDot);
                  }
                }
              }
            }
          }
          function addPropertySymbol(symbol, insertAwait, insertQuestionDot) {
            var _a;
            var computedPropertyName = ts3.firstDefined(symbol.declarations, function(decl) {
              return ts3.tryCast(ts3.getNameOfDeclaration(decl), ts3.isComputedPropertyName);
            });
            if (computedPropertyName) {
              var leftMostName = getLeftMostName(computedPropertyName.expression);
              var nameSymbol = leftMostName && typeChecker.getSymbolAtLocation(leftMostName);
              var firstAccessibleSymbol = nameSymbol && getFirstSymbolInChain(nameSymbol, contextToken, typeChecker);
              if (firstAccessibleSymbol && ts3.addToSeen(seenPropertySymbols, ts3.getSymbolId(firstAccessibleSymbol))) {
                var index = symbols.length;
                symbols.push(firstAccessibleSymbol);
                var moduleSymbol = firstAccessibleSymbol.parent;
                if (!moduleSymbol || !ts3.isExternalModuleSymbol(moduleSymbol) || typeChecker.tryGetMemberInModuleExportsAndProperties(firstAccessibleSymbol.name, moduleSymbol) !== firstAccessibleSymbol) {
                  symbolToOriginInfoMap[index] = { kind: getNullableSymbolOriginInfoKind(2) };
                } else {
                  var fileName2 = ts3.isExternalModuleNameRelative(ts3.stripQuotes(moduleSymbol.name)) ? (_a = ts3.getSourceFileOfModule(moduleSymbol)) === null || _a === void 0 ? void 0 : _a.fileName : void 0;
                  var moduleSpecifier = ((importSpecifierResolver || (importSpecifierResolver = ts3.codefix.createImportSpecifierResolver(sourceFile, program2, host, preferences))).getModuleSpecifierForBestExportInfo([{
                    exportKind: 0,
                    moduleFileName: fileName2,
                    isFromPackageJson: false,
                    moduleSymbol,
                    symbol: firstAccessibleSymbol,
                    targetFlags: ts3.skipAlias(firstAccessibleSymbol, typeChecker).flags
                  }], firstAccessibleSymbol.name, position, ts3.isValidTypeOnlyAliasUseSite(location)) || {}).moduleSpecifier;
                  if (moduleSpecifier) {
                    var origin = {
                      kind: getNullableSymbolOriginInfoKind(6),
                      moduleSymbol,
                      isDefaultExport: false,
                      symbolName: firstAccessibleSymbol.name,
                      exportName: firstAccessibleSymbol.name,
                      fileName: fileName2,
                      moduleSpecifier
                    };
                    symbolToOriginInfoMap[index] = origin;
                  }
                }
              } else if (preferences.includeCompletionsWithInsertText) {
                addSymbolOriginInfo(symbol);
                addSymbolSortInfo(symbol);
                symbols.push(symbol);
              }
            } else {
              addSymbolOriginInfo(symbol);
              addSymbolSortInfo(symbol);
              symbols.push(symbol);
            }
            function addSymbolSortInfo(symbol2) {
              if (isStaticProperty(symbol2)) {
                symbolToSortTextMap[ts3.getSymbolId(symbol2)] = Completions2.SortText.LocalDeclarationPriority;
              }
            }
            function addSymbolOriginInfo(symbol2) {
              if (preferences.includeCompletionsWithInsertText) {
                if (insertAwait && ts3.addToSeen(seenPropertySymbols, ts3.getSymbolId(symbol2))) {
                  symbolToOriginInfoMap[symbols.length] = { kind: getNullableSymbolOriginInfoKind(8) };
                } else if (insertQuestionDot) {
                  symbolToOriginInfoMap[symbols.length] = { kind: 16 };
                }
              }
            }
            function getNullableSymbolOriginInfoKind(kind) {
              return insertQuestionDot ? kind | 16 : kind;
            }
          }
          function getLeftMostName(e) {
            return ts3.isIdentifier(e) ? e : ts3.isPropertyAccessExpression(e) ? getLeftMostName(e.expression) : void 0;
          }
          function tryGetGlobalSymbols() {
            var result2 = tryGetObjectTypeLiteralInTypeArgumentCompletionSymbols() || tryGetObjectLikeCompletionSymbols() || tryGetImportCompletionSymbols() || tryGetImportOrExportClauseCompletionSymbols() || tryGetLocalNamedExportCompletionSymbols() || tryGetConstructorCompletion() || tryGetClassLikeCompletionSymbols() || tryGetJsxCompletionSymbols() || (getGlobalCompletions(), 1);
            return result2 === 1;
          }
          function tryGetConstructorCompletion() {
            if (!tryGetConstructorLikeCompletionContainer(contextToken))
              return 0;
            completionKind = 5;
            isNewIdentifierLocation = true;
            keywordFilters = 4;
            return 1;
          }
          function tryGetJsxCompletionSymbols() {
            var jsxContainer = tryGetContainingJsxElement(contextToken);
            var attrsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes);
            if (!attrsType)
              return 0;
            var completionsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes, 4);
            symbols = ts3.concatenate(symbols, filterJsxAttributes(getPropertiesForObjectExpression(attrsType, completionsType, jsxContainer.attributes, typeChecker), jsxContainer.attributes.properties));
            setSortTextToOptionalMember();
            completionKind = 3;
            isNewIdentifierLocation = false;
            return 1;
          }
          function tryGetImportCompletionSymbols() {
            if (!importCompletionNode)
              return 0;
            isNewIdentifierLocation = true;
            collectAutoImports();
            return 1;
          }
          function getGlobalCompletions() {
            keywordFilters = tryGetFunctionLikeBodyCompletionContainer(contextToken) ? 5 : 1;
            completionKind = 1;
            isNewIdentifierLocation = isNewIdentifierDefinitionLocation();
            if (previousToken !== contextToken) {
              ts3.Debug.assert(!!previousToken, "Expected 'contextToken' to be defined when different from 'previousToken'.");
            }
            var adjustedPosition = previousToken !== contextToken ? previousToken.getStart() : position;
            var scopeNode = getScopeNode(contextToken, adjustedPosition, sourceFile) || sourceFile;
            isInSnippetScope = isSnippetScope(scopeNode);
            var symbolMeanings = (isTypeOnlyLocation ? 0 : 111551) | 788968 | 1920 | 2097152;
            var typeOnlyAliasNeedsPromotion = previousToken && !ts3.isValidTypeOnlyAliasUseSite(previousToken);
            symbols = ts3.concatenate(symbols, typeChecker.getSymbolsInScope(scopeNode, symbolMeanings));
            ts3.Debug.assertEachIsDefined(symbols, "getSymbolsInScope() should all be defined");
            for (var i = 0; i < symbols.length; i++) {
              var symbol = symbols[i];
              if (!typeChecker.isArgumentsSymbol(symbol) && !ts3.some(symbol.declarations, function(d) {
                return d.getSourceFile() === sourceFile;
              })) {
                symbolToSortTextMap[ts3.getSymbolId(symbol)] = Completions2.SortText.GlobalsOrKeywords;
              }
              if (typeOnlyAliasNeedsPromotion && !(symbol.flags & 111551)) {
                var typeOnlyAliasDeclaration = symbol.declarations && ts3.find(symbol.declarations, ts3.isTypeOnlyImportOrExportDeclaration);
                if (typeOnlyAliasDeclaration) {
                  var origin = { kind: 64, declaration: typeOnlyAliasDeclaration };
                  symbolToOriginInfoMap[i] = origin;
                }
              }
            }
            if (preferences.includeCompletionsWithInsertText && scopeNode.kind !== 305) {
              var thisType = typeChecker.tryGetThisTypeAt(scopeNode, false);
              if (thisType && !isProbablyGlobalType(thisType, sourceFile, typeChecker)) {
                for (var _i = 0, _a = getPropertiesForCompletion(thisType, typeChecker); _i < _a.length; _i++) {
                  var symbol = _a[_i];
                  symbolToOriginInfoMap[symbols.length] = { kind: 1 };
                  symbols.push(symbol);
                  symbolToSortTextMap[ts3.getSymbolId(symbol)] = Completions2.SortText.SuggestedClassMembers;
                }
              }
            }
            collectAutoImports();
            if (isTypeOnlyLocation) {
              keywordFilters = contextToken && ts3.isAssertionExpression(contextToken.parent) ? 6 : 7;
            }
          }
          function shouldOfferImportCompletions() {
            if (importCompletionNode)
              return true;
            if (isNonContextualObjectLiteral)
              return false;
            if (!preferences.includeCompletionsForModuleExports)
              return false;
            if (sourceFile.externalModuleIndicator || sourceFile.commonJsModuleIndicator)
              return true;
            if (ts3.compilerOptionsIndicateEsModules(program2.getCompilerOptions()))
              return true;
            return ts3.programContainsModules(program2);
          }
          function isSnippetScope(scopeNode) {
            switch (scopeNode.kind) {
              case 305:
              case 223:
              case 288:
              case 235:
                return true;
              default:
                return ts3.isStatement(scopeNode);
            }
          }
          function isTypeOnlyCompletion() {
            return insideJsDocTagTypeExpression || !!importCompletionNode && ts3.isTypeOnlyImportOrExportDeclaration(location.parent) || !isContextTokenValueLocation(contextToken) && (ts3.isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker) || ts3.isPartOfTypeNode(location) || isContextTokenTypeLocation(contextToken));
          }
          function isContextTokenValueLocation(contextToken2) {
            return contextToken2 && (contextToken2.kind === 112 && (contextToken2.parent.kind === 181 || ts3.isTypeOfExpression(contextToken2.parent)) || contextToken2.kind === 128 && contextToken2.parent.kind === 177);
          }
          function isContextTokenTypeLocation(contextToken2) {
            if (contextToken2) {
              var parentKind = contextToken2.parent.kind;
              switch (contextToken2.kind) {
                case 58:
                  return parentKind === 167 || parentKind === 166 || parentKind === 164 || parentKind === 254 || ts3.isFunctionLikeKind(parentKind);
                case 63:
                  return parentKind === 259;
                case 127:
                  return parentKind === 229;
                case 29:
                  return parentKind === 178 || parentKind === 211;
                case 94:
                  return parentKind === 163;
              }
            }
            return false;
          }
          function collectAutoImports() {
            var _a, _b;
            if (!shouldOfferImportCompletions())
              return;
            ts3.Debug.assert(!(detailsEntryId === null || detailsEntryId === void 0 ? void 0 : detailsEntryId.data), "Should not run 'collectAutoImports' when faster path is available via `data`");
            if (detailsEntryId && !detailsEntryId.source) {
              return;
            }
            flags |= 1;
            var isAfterTypeOnlyImportSpecifierModifier = previousToken === contextToken && importCompletionNode && couldBeTypeOnlyImportSpecifier(importCompletionNode, contextToken);
            var lowerCaseTokenText = isAfterTypeOnlyImportSpecifierModifier ? "" : previousToken && ts3.isIdentifier(previousToken) ? previousToken.text.toLowerCase() : "";
            var moduleSpecifierCache = (_a = host.getModuleSpecifierCache) === null || _a === void 0 ? void 0 : _a.call(host);
            var exportInfo = ts3.getExportInfoMap(sourceFile, host, program2, cancellationToken);
            var packageJsonAutoImportProvider = (_b = host.getPackageJsonAutoImportProvider) === null || _b === void 0 ? void 0 : _b.call(host);
            var packageJsonFilter = detailsEntryId ? void 0 : ts3.createPackageJsonImportFilter(sourceFile, preferences, host);
            resolvingModuleSpecifiers("collectAutoImports", host, importSpecifierResolver || (importSpecifierResolver = ts3.codefix.createImportSpecifierResolver(sourceFile, program2, host, preferences)), program2, position, preferences, !!importCompletionNode, ts3.isValidTypeOnlyAliasUseSite(location), function(context) {
              exportInfo.search(sourceFile.path, isRightOfOpenTag, function(symbolName, targetFlags) {
                if (!ts3.isIdentifierText(symbolName, ts3.getEmitScriptTarget(host.getCompilationSettings())))
                  return false;
                if (!detailsEntryId && ts3.isStringANonContextualKeyword(symbolName))
                  return false;
                if (!isTypeOnlyLocation && !importCompletionNode && !(targetFlags & 111551))
                  return false;
                if (isTypeOnlyLocation && !(targetFlags & (1536 | 788968)))
                  return false;
                var firstChar = symbolName.charCodeAt(0);
                if (isRightOfOpenTag && (firstChar < 65 || firstChar > 90))
                  return false;
                if (detailsEntryId)
                  return true;
                return charactersFuzzyMatchInString(symbolName, lowerCaseTokenText);
              }, function(info, symbolName, isFromAmbientModule, exportMapKey) {
                var _a2;
                if (detailsEntryId && !ts3.some(info, function(i) {
                  return detailsEntryId.source === ts3.stripQuotes(i.moduleSymbol.name);
                })) {
                  return;
                }
                var firstImportableExportInfo = ts3.find(info, isImportableExportInfo);
                if (!firstImportableExportInfo) {
                  return;
                }
                var result2 = context.tryResolve(info, symbolName, isFromAmbientModule) || {};
                if (result2 === "failed")
                  return;
                var exportInfo2 = firstImportableExportInfo, moduleSpecifier;
                if (result2 !== "skipped") {
                  _a2 = result2.exportInfo, exportInfo2 = _a2 === void 0 ? firstImportableExportInfo : _a2, moduleSpecifier = result2.moduleSpecifier;
                }
                var isDefaultExport = exportInfo2.exportKind === 1;
                var symbol = isDefaultExport && ts3.getLocalSymbolForExportDefault(exportInfo2.symbol) || exportInfo2.symbol;
                pushAutoImportSymbol(symbol, {
                  kind: moduleSpecifier ? 32 : 4,
                  moduleSpecifier,
                  symbolName,
                  exportMapKey,
                  exportName: exportInfo2.exportKind === 2 ? "export=" : exportInfo2.symbol.name,
                  fileName: exportInfo2.moduleFileName,
                  isDefaultExport,
                  moduleSymbol: exportInfo2.moduleSymbol,
                  isFromPackageJson: exportInfo2.isFromPackageJson
                });
              });
              hasUnresolvedAutoImports = context.skippedAny();
              flags |= context.resolvedAny() ? 8 : 0;
              flags |= context.resolvedBeyondLimit() ? 16 : 0;
            });
            function isImportableExportInfo(info) {
              var moduleFile = ts3.tryCast(info.moduleSymbol.valueDeclaration, ts3.isSourceFile);
              if (!moduleFile) {
                var moduleName = ts3.stripQuotes(info.moduleSymbol.name);
                if (ts3.JsTyping.nodeCoreModules.has(moduleName) && ts3.startsWith(moduleName, "node:") !== ts3.shouldUseUriStyleNodeCoreModules(sourceFile, program2)) {
                  return false;
                }
                return packageJsonFilter ? packageJsonFilter.allowsImportingAmbientModule(info.moduleSymbol, getModuleSpecifierResolutionHost(info.isFromPackageJson)) : true;
              }
              return ts3.isImportableFile(info.isFromPackageJson ? packageJsonAutoImportProvider : program2, sourceFile, moduleFile, preferences, packageJsonFilter, getModuleSpecifierResolutionHost(info.isFromPackageJson), moduleSpecifierCache);
            }
          }
          function pushAutoImportSymbol(symbol, origin) {
            var symbolId = ts3.getSymbolId(symbol);
            if (symbolToSortTextMap[symbolId] === Completions2.SortText.GlobalsOrKeywords) {
              return;
            }
            symbolToOriginInfoMap[symbols.length] = origin;
            symbolToSortTextMap[symbolId] = importCompletionNode ? Completions2.SortText.LocationPriority : Completions2.SortText.AutoImportSuggestions;
            symbols.push(symbol);
          }
          function collectObjectLiteralMethodSymbols(members, enclosingDeclaration) {
            if (ts3.isInJSFile(location)) {
              return;
            }
            members.forEach(function(member) {
              if (!isObjectLiteralMethodSymbol(member)) {
                return;
              }
              var displayName = getCompletionEntryDisplayNameForSymbol(member, ts3.getEmitScriptTarget(compilerOptions), void 0, 0, false);
              if (!displayName) {
                return;
              }
              var name = displayName.name;
              var entryProps = getEntryForObjectLiteralMethodCompletion(member, name, enclosingDeclaration, program2, host, compilerOptions, preferences, formatContext);
              if (!entryProps) {
                return;
              }
              var origin = __assign({ kind: 128 }, entryProps);
              flags |= 32;
              symbolToOriginInfoMap[symbols.length] = origin;
              symbols.push(member);
            });
          }
          function isObjectLiteralMethodSymbol(symbol) {
            if (!(symbol.flags & (4 | 8192))) {
              return false;
            }
            return true;
          }
          function getScopeNode(initialToken, position2, sourceFile2) {
            var scope = initialToken;
            while (scope && !ts3.positionBelongsToNode(scope, position2, sourceFile2)) {
              scope = scope.parent;
            }
            return scope;
          }
          function isCompletionListBlocker(contextToken2) {
            var start2 = ts3.timestamp();
            var result2 = isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) || isSolelyIdentifierDefinitionLocation(contextToken2) || isDotOfNumericLiteral(contextToken2) || isInJsxText(contextToken2) || ts3.isBigIntLiteral(contextToken2);
            log("getCompletionsAtPosition: isCompletionListBlocker: " + (ts3.timestamp() - start2));
            return result2;
          }
          function isInJsxText(contextToken2) {
            if (contextToken2.kind === 11) {
              return true;
            }
            if (contextToken2.kind === 31 && contextToken2.parent) {
              if (location === contextToken2.parent && (location.kind === 280 || location.kind === 279)) {
                return false;
              }
              if (contextToken2.parent.kind === 280) {
                return location.parent.kind !== 280;
              }
              if (contextToken2.parent.kind === 281 || contextToken2.parent.kind === 279) {
                return !!contextToken2.parent.parent && contextToken2.parent.parent.kind === 278;
              }
            }
            return false;
          }
          function isNewIdentifierDefinitionLocation() {
            if (contextToken) {
              var containingNodeKind = contextToken.parent.kind;
              var tokenKind = keywordForNode(contextToken);
              switch (tokenKind) {
                case 27:
                  return containingNodeKind === 208 || containingNodeKind === 171 || containingNodeKind === 209 || containingNodeKind === 204 || containingNodeKind === 221 || containingNodeKind === 179 || containingNodeKind === 205;
                case 20:
                  return containingNodeKind === 208 || containingNodeKind === 171 || containingNodeKind === 209 || containingNodeKind === 212 || containingNodeKind === 191;
                case 22:
                  return containingNodeKind === 204 || containingNodeKind === 176 || containingNodeKind === 162;
                case 141:
                case 142:
                case 100:
                  return true;
                case 24:
                  return containingNodeKind === 261;
                case 18:
                  return containingNodeKind === 257 || containingNodeKind === 205;
                case 63:
                  return containingNodeKind === 254 || containingNodeKind === 221;
                case 15:
                  return containingNodeKind === 223;
                case 16:
                  return containingNodeKind === 233;
                case 131:
                  return containingNodeKind === 169 || containingNodeKind === 297;
                case 41:
                  return containingNodeKind === 169;
              }
              if (isClassMemberCompletionKeyword(tokenKind)) {
                return true;
              }
            }
            return false;
          }
          function isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) {
            return (ts3.isRegularExpressionLiteral(contextToken2) || ts3.isStringTextContainingNode(contextToken2)) && (ts3.rangeContainsPositionExclusive(ts3.createTextRangeFromSpan(ts3.createTextSpanFromNode(contextToken2)), position) || position === contextToken2.end && (!!contextToken2.isUnterminated || ts3.isRegularExpressionLiteral(contextToken2)));
          }
          function tryGetObjectTypeLiteralInTypeArgumentCompletionSymbols() {
            var typeLiteralNode = tryGetTypeLiteralNode(contextToken);
            if (!typeLiteralNode)
              return 0;
            var intersectionTypeNode = ts3.isIntersectionTypeNode(typeLiteralNode.parent) ? typeLiteralNode.parent : void 0;
            var containerTypeNode = intersectionTypeNode || typeLiteralNode;
            var containerExpectedType = getConstraintOfTypeArgumentProperty(containerTypeNode, typeChecker);
            if (!containerExpectedType)
              return 0;
            var containerActualType = typeChecker.getTypeFromTypeNode(containerTypeNode);
            var members = getPropertiesForCompletion(containerExpectedType, typeChecker);
            var existingMembers = getPropertiesForCompletion(containerActualType, typeChecker);
            var existingMemberEscapedNames = new ts3.Set();
            existingMembers.forEach(function(s) {
              return existingMemberEscapedNames.add(s.escapedName);
            });
            symbols = ts3.concatenate(symbols, ts3.filter(members, function(s) {
              return !existingMemberEscapedNames.has(s.escapedName);
            }));
            completionKind = 0;
            isNewIdentifierLocation = true;
            return 1;
          }
          function tryGetObjectLikeCompletionSymbols() {
            var symbolsStartIndex = symbols.length;
            var objectLikeContainer = tryGetObjectLikeCompletionContainer(contextToken);
            if (!objectLikeContainer)
              return 0;
            completionKind = 0;
            var typeMembers;
            var existingMembers;
            if (objectLikeContainer.kind === 205) {
              var instantiatedType = tryGetObjectLiteralContextualType(objectLikeContainer, typeChecker);
              if (instantiatedType === void 0) {
                if (objectLikeContainer.flags & 33554432) {
                  return 2;
                }
                isNonContextualObjectLiteral = true;
                return 0;
              }
              var completionsType = typeChecker.getContextualType(objectLikeContainer, 4);
              var hasStringIndexType = (completionsType || instantiatedType).getStringIndexType();
              var hasNumberIndextype = (completionsType || instantiatedType).getNumberIndexType();
              isNewIdentifierLocation = !!hasStringIndexType || !!hasNumberIndextype;
              typeMembers = getPropertiesForObjectExpression(instantiatedType, completionsType, objectLikeContainer, typeChecker);
              existingMembers = objectLikeContainer.properties;
              if (typeMembers.length === 0) {
                if (!hasNumberIndextype) {
                  isNonContextualObjectLiteral = true;
                  return 0;
                }
              }
            } else {
              ts3.Debug.assert(objectLikeContainer.kind === 201);
              isNewIdentifierLocation = false;
              var rootDeclaration = ts3.getRootDeclaration(objectLikeContainer.parent);
              if (!ts3.isVariableLike(rootDeclaration))
                return ts3.Debug.fail("Root declaration is not variable-like.");
              var canGetType = ts3.hasInitializer(rootDeclaration) || !!ts3.getEffectiveTypeAnnotationNode(rootDeclaration) || rootDeclaration.parent.parent.kind === 244;
              if (!canGetType && rootDeclaration.kind === 164) {
                if (ts3.isExpression(rootDeclaration.parent)) {
                  canGetType = !!typeChecker.getContextualType(rootDeclaration.parent);
                } else if (rootDeclaration.parent.kind === 169 || rootDeclaration.parent.kind === 173) {
                  canGetType = ts3.isExpression(rootDeclaration.parent.parent) && !!typeChecker.getContextualType(rootDeclaration.parent.parent);
                }
              }
              if (canGetType) {
                var typeForObject_1 = typeChecker.getTypeAtLocation(objectLikeContainer);
                if (!typeForObject_1)
                  return 2;
                typeMembers = typeChecker.getPropertiesOfType(typeForObject_1).filter(function(propertySymbol) {
                  return typeChecker.isPropertyAccessible(objectLikeContainer, false, false, typeForObject_1, propertySymbol);
                });
                existingMembers = objectLikeContainer.elements;
              }
            }
            if (typeMembers && typeMembers.length > 0) {
              var filteredMembers = filterObjectMembersList(typeMembers, ts3.Debug.checkDefined(existingMembers));
              symbols = ts3.concatenate(symbols, filteredMembers);
              setSortTextToOptionalMember();
              if (objectLikeContainer.kind === 205 && preferences.includeCompletionsWithObjectLiteralMethodSnippets && preferences.includeCompletionsWithInsertText) {
                transformObjectLiteralMembersSortText(symbolsStartIndex);
                collectObjectLiteralMethodSymbols(filteredMembers, objectLikeContainer);
              }
            }
            return 1;
          }
          function tryGetImportOrExportClauseCompletionSymbols() {
            if (!contextToken)
              return 0;
            var namedImportsOrExports = contextToken.kind === 18 || contextToken.kind === 27 ? ts3.tryCast(contextToken.parent, ts3.isNamedImportsOrExports) : ts3.isTypeKeywordTokenOrIdentifier(contextToken) ? ts3.tryCast(contextToken.parent.parent, ts3.isNamedImportsOrExports) : void 0;
            if (!namedImportsOrExports)
              return 0;
            if (!ts3.isTypeKeywordTokenOrIdentifier(contextToken)) {
              keywordFilters = 8;
            }
            var moduleSpecifier = (namedImportsOrExports.kind === 269 ? namedImportsOrExports.parent.parent : namedImportsOrExports.parent).moduleSpecifier;
            if (!moduleSpecifier) {
              isNewIdentifierLocation = true;
              return namedImportsOrExports.kind === 269 ? 2 : 0;
            }
            var moduleSpecifierSymbol = typeChecker.getSymbolAtLocation(moduleSpecifier);
            if (!moduleSpecifierSymbol) {
              isNewIdentifierLocation = true;
              return 2;
            }
            completionKind = 3;
            isNewIdentifierLocation = false;
            var exports2 = typeChecker.getExportsAndPropertiesOfModule(moduleSpecifierSymbol);
            var existing = new ts3.Set(namedImportsOrExports.elements.filter(function(n) {
              return !isCurrentlyEditingNode(n);
            }).map(function(n) {
              return (n.propertyName || n.name).escapedText;
            }));
            var uniques = exports2.filter(function(e) {
              return e.escapedName !== "default" && !existing.has(e.escapedName);
            });
            symbols = ts3.concatenate(symbols, uniques);
            if (!uniques.length) {
              keywordFilters = 0;
            }
            return 1;
          }
          function tryGetLocalNamedExportCompletionSymbols() {
            var _a;
            var namedExports = contextToken && (contextToken.kind === 18 || contextToken.kind === 27) ? ts3.tryCast(contextToken.parent, ts3.isNamedExports) : void 0;
            if (!namedExports) {
              return 0;
            }
            var localsContainer = ts3.findAncestor(namedExports, ts3.or(ts3.isSourceFile, ts3.isModuleDeclaration));
            completionKind = 5;
            isNewIdentifierLocation = false;
            (_a = localsContainer.locals) === null || _a === void 0 ? void 0 : _a.forEach(function(symbol, name) {
              var _a2, _b;
              symbols.push(symbol);
              if ((_b = (_a2 = localsContainer.symbol) === null || _a2 === void 0 ? void 0 : _a2.exports) === null || _b === void 0 ? void 0 : _b.has(name)) {
                symbolToSortTextMap[ts3.getSymbolId(symbol)] = Completions2.SortText.OptionalMember;
              }
            });
            return 1;
          }
          function tryGetClassLikeCompletionSymbols() {
            var decl = tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position);
            if (!decl)
              return 0;
            completionKind = 3;
            isNewIdentifierLocation = true;
            keywordFilters = contextToken.kind === 41 ? 0 : ts3.isClassLike(decl) ? 2 : 3;
            if (!ts3.isClassLike(decl))
              return 1;
            var classElement = contextToken.kind === 26 ? contextToken.parent.parent : contextToken.parent;
            var classElementModifierFlags = ts3.isClassElement(classElement) ? ts3.getEffectiveModifierFlags(classElement) : 0;
            if (contextToken.kind === 79 && !isCurrentlyEditingNode(contextToken)) {
              switch (contextToken.getText()) {
                case "private":
                  classElementModifierFlags = classElementModifierFlags | 8;
                  break;
                case "static":
                  classElementModifierFlags = classElementModifierFlags | 32;
                  break;
                case "override":
                  classElementModifierFlags = classElementModifierFlags | 16384;
                  break;
              }
            }
            if (ts3.isClassStaticBlockDeclaration(classElement)) {
              classElementModifierFlags |= 32;
            }
            if (!(classElementModifierFlags & 8)) {
              var baseTypeNodes = ts3.isClassLike(decl) && classElementModifierFlags & 16384 ? ts3.singleElementArray(ts3.getEffectiveBaseTypeNode(decl)) : ts3.getAllSuperTypeNodes(decl);
              var baseSymbols = ts3.flatMap(baseTypeNodes, function(baseTypeNode) {
                var type2 = typeChecker.getTypeAtLocation(baseTypeNode);
                return classElementModifierFlags & 32 ? (type2 === null || type2 === void 0 ? void 0 : type2.symbol) && typeChecker.getPropertiesOfType(typeChecker.getTypeOfSymbolAtLocation(type2.symbol, decl)) : type2 && typeChecker.getPropertiesOfType(type2);
              });
              symbols = ts3.concatenate(symbols, filterClassMembersList(baseSymbols, decl.members, classElementModifierFlags));
            }
            return 1;
          }
          function isConstructorParameterCompletion(node2) {
            return !!node2.parent && ts3.isParameter(node2.parent) && ts3.isConstructorDeclaration(node2.parent.parent) && (ts3.isParameterPropertyModifier(node2.kind) || ts3.isDeclarationName(node2));
          }
          function tryGetConstructorLikeCompletionContainer(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 20:
                case 27:
                  return ts3.isConstructorDeclaration(contextToken2.parent) ? contextToken2.parent : void 0;
                default:
                  if (isConstructorParameterCompletion(contextToken2)) {
                    return parent2.parent;
                  }
              }
            }
            return void 0;
          }
          function tryGetFunctionLikeBodyCompletionContainer(contextToken2) {
            if (contextToken2) {
              var prev_1;
              var container = ts3.findAncestor(contextToken2.parent, function(node2) {
                if (ts3.isClassLike(node2)) {
                  return "quit";
                }
                if (ts3.isFunctionLikeDeclaration(node2) && prev_1 === node2.body) {
                  return true;
                }
                prev_1 = node2;
                return false;
              });
              return container && container;
            }
          }
          function tryGetContainingJsxElement(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 31:
                case 30:
                case 43:
                case 79:
                case 206:
                case 286:
                case 285:
                case 287:
                  if (parent2 && (parent2.kind === 279 || parent2.kind === 280)) {
                    if (contextToken2.kind === 31) {
                      var precedingToken = ts3.findPrecedingToken(contextToken2.pos, sourceFile, void 0);
                      if (!parent2.typeArguments || precedingToken && precedingToken.kind === 43)
                        break;
                    }
                    return parent2;
                  } else if (parent2.kind === 285) {
                    return parent2.parent.parent;
                  }
                  break;
                case 10:
                  if (parent2 && (parent2.kind === 285 || parent2.kind === 287)) {
                    return parent2.parent.parent;
                  }
                  break;
                case 19:
                  if (parent2 && parent2.kind === 288 && parent2.parent && parent2.parent.kind === 285) {
                    return parent2.parent.parent.parent;
                  }
                  if (parent2 && parent2.kind === 287) {
                    return parent2.parent.parent;
                  }
                  break;
              }
            }
            return void 0;
          }
          function isSolelyIdentifierDefinitionLocation(contextToken2) {
            var parent2 = contextToken2.parent;
            var containingNodeKind = parent2.kind;
            switch (contextToken2.kind) {
              case 27:
                return containingNodeKind === 254 || isVariableDeclarationListButNotTypeArgument(contextToken2) || containingNodeKind === 237 || containingNodeKind === 260 || isFunctionLikeButNotConstructor(containingNodeKind) || containingNodeKind === 258 || containingNodeKind === 202 || containingNodeKind === 259 || ts3.isClassLike(parent2) && !!parent2.typeParameters && parent2.typeParameters.end >= contextToken2.pos;
              case 24:
                return containingNodeKind === 202;
              case 58:
                return containingNodeKind === 203;
              case 22:
                return containingNodeKind === 202;
              case 20:
                return containingNodeKind === 292 || isFunctionLikeButNotConstructor(containingNodeKind);
              case 18:
                return containingNodeKind === 260;
              case 29:
                return containingNodeKind === 257 || containingNodeKind === 226 || containingNodeKind === 258 || containingNodeKind === 259 || ts3.isFunctionLikeKind(containingNodeKind);
              case 124:
                return containingNodeKind === 167 && !ts3.isClassLike(parent2.parent);
              case 25:
                return containingNodeKind === 164 || !!parent2.parent && parent2.parent.kind === 202;
              case 123:
              case 121:
              case 122:
                return containingNodeKind === 164 && !ts3.isConstructorDeclaration(parent2.parent);
              case 127:
                return containingNodeKind === 270 || containingNodeKind === 275 || containingNodeKind === 268;
              case 136:
              case 149:
                return !isFromObjectTypeDeclaration(contextToken2);
              case 79:
                if (containingNodeKind === 270 && contextToken2 === parent2.name && contextToken2.text === "type") {
                  return false;
                }
                break;
              case 84:
              case 92:
              case 118:
              case 98:
              case 113:
              case 100:
              case 119:
              case 85:
              case 137:
                return true;
              case 152:
                return containingNodeKind !== 270;
              case 41:
                return ts3.isFunctionLike(contextToken2.parent) && !ts3.isMethodDeclaration(contextToken2.parent);
            }
            if (isClassMemberCompletionKeyword(keywordForNode(contextToken2)) && isFromObjectTypeDeclaration(contextToken2)) {
              return false;
            }
            if (isConstructorParameterCompletion(contextToken2)) {
              if (!ts3.isIdentifier(contextToken2) || ts3.isParameterPropertyModifier(keywordForNode(contextToken2)) || isCurrentlyEditingNode(contextToken2)) {
                return false;
              }
            }
            switch (keywordForNode(contextToken2)) {
              case 126:
              case 84:
              case 85:
              case 135:
              case 92:
              case 98:
              case 118:
              case 119:
              case 121:
              case 122:
              case 123:
              case 124:
              case 113:
                return true;
              case 131:
                return ts3.isPropertyDeclaration(contextToken2.parent);
            }
            var ancestorClassLike = ts3.findAncestor(contextToken2.parent, ts3.isClassLike);
            if (ancestorClassLike && contextToken2 === previousToken && isPreviousPropertyDeclarationTerminated(contextToken2, position)) {
              return false;
            }
            var ancestorPropertyDeclaraion = ts3.getAncestor(contextToken2.parent, 167);
            if (ancestorPropertyDeclaraion && contextToken2 !== previousToken && ts3.isClassLike(previousToken.parent.parent) && position <= previousToken.end) {
              if (isPreviousPropertyDeclarationTerminated(contextToken2, previousToken.end)) {
                return false;
              } else if (contextToken2.kind !== 63 && (ts3.isInitializedProperty(ancestorPropertyDeclaraion) || ts3.hasType(ancestorPropertyDeclaraion))) {
                return true;
              }
            }
            return ts3.isDeclarationName(contextToken2) && !ts3.isShorthandPropertyAssignment(contextToken2.parent) && !ts3.isJsxAttribute(contextToken2.parent) && !(ts3.isClassLike(contextToken2.parent) && (contextToken2 !== previousToken || position > previousToken.end));
          }
          function isPreviousPropertyDeclarationTerminated(contextToken2, position2) {
            return contextToken2.kind !== 63 && (contextToken2.kind === 26 || !ts3.positionsAreOnSameLine(contextToken2.end, position2, sourceFile));
          }
          function isFunctionLikeButNotConstructor(kind) {
            return ts3.isFunctionLikeKind(kind) && kind !== 171;
          }
          function isDotOfNumericLiteral(contextToken2) {
            if (contextToken2.kind === 8) {
              var text = contextToken2.getFullText();
              return text.charAt(text.length - 1) === ".";
            }
            return false;
          }
          function isVariableDeclarationListButNotTypeArgument(node2) {
            return node2.parent.kind === 255 && !ts3.isPossiblyTypeArgumentPosition(node2, sourceFile, typeChecker);
          }
          function filterObjectMembersList(contextualMemberSymbols, existingMembers) {
            if (existingMembers.length === 0) {
              return contextualMemberSymbols;
            }
            var membersDeclaredBySpreadAssignment = new ts3.Set();
            var existingMemberNames = new ts3.Set();
            for (var _i = 0, existingMembers_1 = existingMembers; _i < existingMembers_1.length; _i++) {
              var m = existingMembers_1[_i];
              if (m.kind !== 296 && m.kind !== 297 && m.kind !== 203 && m.kind !== 169 && m.kind !== 172 && m.kind !== 173 && m.kind !== 298) {
                continue;
              }
              if (isCurrentlyEditingNode(m)) {
                continue;
              }
              var existingName = void 0;
              if (ts3.isSpreadAssignment(m)) {
                setMembersDeclaredBySpreadAssignment(m, membersDeclaredBySpreadAssignment);
              } else if (ts3.isBindingElement(m) && m.propertyName) {
                if (m.propertyName.kind === 79) {
                  existingName = m.propertyName.escapedText;
                }
              } else {
                var name = ts3.getNameOfDeclaration(m);
                existingName = name && ts3.isPropertyNameLiteral(name) ? ts3.getEscapedTextOfIdentifierOrLiteral(name) : void 0;
              }
              if (existingName !== void 0) {
                existingMemberNames.add(existingName);
              }
            }
            var filteredSymbols = contextualMemberSymbols.filter(function(m2) {
              return !existingMemberNames.has(m2.escapedName);
            });
            setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
            return filteredSymbols;
          }
          function setMembersDeclaredBySpreadAssignment(declaration, membersDeclaredBySpreadAssignment) {
            var expression = declaration.expression;
            var symbol = typeChecker.getSymbolAtLocation(expression);
            var type2 = symbol && typeChecker.getTypeOfSymbolAtLocation(symbol, expression);
            var properties = type2 && type2.properties;
            if (properties) {
              properties.forEach(function(property) {
                membersDeclaredBySpreadAssignment.add(property.name);
              });
            }
          }
          function setSortTextToOptionalMember() {
            symbols.forEach(function(m) {
              var _a;
              if (m.flags & 16777216) {
                var symbolId = ts3.getSymbolId(m);
                symbolToSortTextMap[symbolId] = (_a = symbolToSortTextMap[symbolId]) !== null && _a !== void 0 ? _a : Completions2.SortText.OptionalMember;
              }
            });
          }
          function setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, contextualMemberSymbols) {
            if (membersDeclaredBySpreadAssignment.size === 0) {
              return;
            }
            for (var _i = 0, contextualMemberSymbols_1 = contextualMemberSymbols; _i < contextualMemberSymbols_1.length; _i++) {
              var contextualMemberSymbol = contextualMemberSymbols_1[_i];
              if (membersDeclaredBySpreadAssignment.has(contextualMemberSymbol.name)) {
                symbolToSortTextMap[ts3.getSymbolId(contextualMemberSymbol)] = Completions2.SortText.MemberDeclaredBySpreadAssignment;
              }
            }
          }
          function transformObjectLiteralMembersSortText(start2) {
            var _a;
            for (var i = start2; i < symbols.length; i++) {
              var symbol = symbols[i];
              var symbolId = ts3.getSymbolId(symbol);
              var origin = symbolToOriginInfoMap === null || symbolToOriginInfoMap === void 0 ? void 0 : symbolToOriginInfoMap[i];
              var target = ts3.getEmitScriptTarget(compilerOptions);
              var displayName = getCompletionEntryDisplayNameForSymbol(symbol, target, origin, 0, false);
              if (displayName) {
                var originalSortText = (_a = symbolToSortTextMap[symbolId]) !== null && _a !== void 0 ? _a : Completions2.SortText.LocationPriority;
                var name = displayName.name;
                symbolToSortTextMap[symbolId] = Completions2.SortText.ObjectLiteralProperty(originalSortText, name);
              }
            }
          }
          function filterClassMembersList(baseSymbols, existingMembers, currentClassElementModifierFlags) {
            var existingMemberNames = new ts3.Set();
            for (var _i = 0, existingMembers_2 = existingMembers; _i < existingMembers_2.length; _i++) {
              var m = existingMembers_2[_i];
              if (m.kind !== 167 && m.kind !== 169 && m.kind !== 172 && m.kind !== 173) {
                continue;
              }
              if (isCurrentlyEditingNode(m)) {
                continue;
              }
              if (ts3.hasEffectiveModifier(m, 8)) {
                continue;
              }
              if (ts3.isStatic(m) !== !!(currentClassElementModifierFlags & 32)) {
                continue;
              }
              var existingName = ts3.getPropertyNameForPropertyNameNode(m.name);
              if (existingName) {
                existingMemberNames.add(existingName);
              }
            }
            return baseSymbols.filter(function(propertySymbol) {
              return !existingMemberNames.has(propertySymbol.escapedName) && !!propertySymbol.declarations && !(ts3.getDeclarationModifierFlagsFromSymbol(propertySymbol) & 8) && !(propertySymbol.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(propertySymbol.valueDeclaration));
            });
          }
          function filterJsxAttributes(symbols2, attributes) {
            var seenNames = new ts3.Set();
            var membersDeclaredBySpreadAssignment = new ts3.Set();
            for (var _i = 0, attributes_1 = attributes; _i < attributes_1.length; _i++) {
              var attr = attributes_1[_i];
              if (isCurrentlyEditingNode(attr)) {
                continue;
              }
              if (attr.kind === 285) {
                seenNames.add(attr.name.escapedText);
              } else if (ts3.isJsxSpreadAttribute(attr)) {
                setMembersDeclaredBySpreadAssignment(attr, membersDeclaredBySpreadAssignment);
              }
            }
            var filteredSymbols = symbols2.filter(function(a) {
              return !seenNames.has(a.escapedName);
            });
            setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
            return filteredSymbols;
          }
          function isCurrentlyEditingNode(node2) {
            return node2.getStart(sourceFile) <= position && position <= node2.getEnd();
          }
        }
        function tryGetObjectLikeCompletionContainer(contextToken) {
          if (contextToken) {
            var parent = contextToken.parent;
            switch (contextToken.kind) {
              case 18:
              case 27:
                if (ts3.isObjectLiteralExpression(parent) || ts3.isObjectBindingPattern(parent)) {
                  return parent;
                }
                break;
              case 41:
                return ts3.isMethodDeclaration(parent) ? ts3.tryCast(parent.parent, ts3.isObjectLiteralExpression) : void 0;
              case 79:
                return contextToken.text === "async" && ts3.isShorthandPropertyAssignment(contextToken.parent) ? contextToken.parent.parent : void 0;
            }
          }
          return void 0;
        }
        function getRelevantTokens(position, sourceFile) {
          var previousToken = ts3.findPrecedingToken(position, sourceFile);
          if (previousToken && position <= previousToken.end && (ts3.isMemberName(previousToken) || ts3.isKeyword(previousToken.kind))) {
            var contextToken = ts3.findPrecedingToken(previousToken.getFullStart(), sourceFile, void 0);
            return { contextToken, previousToken };
          }
          return { contextToken: previousToken, previousToken };
        }
        function getAutoImportSymbolFromCompletionEntryData(name, data, program2, host) {
          var containingProgram = data.isPackageJsonImport ? host.getPackageJsonAutoImportProvider() : program2;
          var checker = containingProgram.getTypeChecker();
          var moduleSymbol = data.ambientModuleName ? checker.tryFindAmbientModule(data.ambientModuleName) : data.fileName ? checker.getMergedSymbol(ts3.Debug.checkDefined(containingProgram.getSourceFile(data.fileName)).symbol) : void 0;
          if (!moduleSymbol)
            return void 0;
          var symbol = data.exportName === "export=" ? checker.resolveExternalModuleSymbol(moduleSymbol) : checker.tryGetMemberInModuleExportsAndProperties(data.exportName, moduleSymbol);
          if (!symbol)
            return void 0;
          var isDefaultExport = data.exportName === "default";
          symbol = isDefaultExport && ts3.getLocalSymbolForExportDefault(symbol) || symbol;
          return { symbol, origin: completionEntryDataToSymbolOriginInfo(data, name, moduleSymbol) };
        }
        function getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, jsxIdentifierExpected) {
          var name = originIncludesSymbolName(origin) ? origin.symbolName : symbol.name;
          if (name === void 0 || symbol.flags & 1536 && ts3.isSingleOrDoubleQuote(name.charCodeAt(0)) || ts3.isKnownSymbol(symbol)) {
            return void 0;
          }
          var validNameResult = { name, needsConvertPropertyAccess: false };
          if (ts3.isIdentifierText(name, target, jsxIdentifierExpected ? 1 : 0) || symbol.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(symbol.valueDeclaration)) {
            return validNameResult;
          }
          switch (kind) {
            case 3:
              return void 0;
            case 0:
              return { name: JSON.stringify(name), needsConvertPropertyAccess: false };
            case 2:
            case 1:
              return name.charCodeAt(0) === 32 ? void 0 : { name, needsConvertPropertyAccess: true };
            case 5:
            case 4:
              return validNameResult;
            default:
              ts3.Debug.assertNever(kind);
          }
        }
        var _keywordCompletions = [];
        var allKeywordsCompletions = ts3.memoize(function() {
          var res = [];
          for (var i = 81; i <= 160; i++) {
            res.push({
              name: ts3.tokenToString(i),
              kind: "keyword",
              kindModifiers: "",
              sortText: Completions2.SortText.GlobalsOrKeywords
            });
          }
          return res;
        });
        function getKeywordCompletions(keywordFilter, filterOutTsOnlyKeywords) {
          if (!filterOutTsOnlyKeywords)
            return getTypescriptKeywordCompletions(keywordFilter);
          var index = keywordFilter + 8 + 1;
          return _keywordCompletions[index] || (_keywordCompletions[index] = getTypescriptKeywordCompletions(keywordFilter).filter(function(entry) {
            return !isTypeScriptOnlyKeyword(ts3.stringToToken(entry.name));
          }));
        }
        function getTypescriptKeywordCompletions(keywordFilter) {
          return _keywordCompletions[keywordFilter] || (_keywordCompletions[keywordFilter] = allKeywordsCompletions().filter(function(entry) {
            var kind = ts3.stringToToken(entry.name);
            switch (keywordFilter) {
              case 0:
                return false;
              case 1:
                return isFunctionLikeBodyKeyword(kind) || kind === 135 || kind === 141 || kind === 152 || kind === 142 || kind === 126 || ts3.isTypeKeyword(kind) && kind !== 153;
              case 5:
                return isFunctionLikeBodyKeyword(kind);
              case 2:
                return isClassMemberCompletionKeyword(kind);
              case 3:
                return isInterfaceOrTypeLiteralCompletionKeyword(kind);
              case 4:
                return ts3.isParameterPropertyModifier(kind);
              case 6:
                return ts3.isTypeKeyword(kind) || kind === 85;
              case 7:
                return ts3.isTypeKeyword(kind);
              case 8:
                return kind === 152;
              default:
                return ts3.Debug.assertNever(keywordFilter);
            }
          }));
        }
        function isTypeScriptOnlyKeyword(kind) {
          switch (kind) {
            case 126:
            case 130:
            case 158:
            case 133:
            case 135:
            case 92:
            case 157:
            case 117:
            case 137:
            case 118:
            case 139:
            case 140:
            case 141:
            case 142:
            case 143:
            case 147:
            case 148:
            case 159:
            case 121:
            case 122:
            case 123:
            case 145:
            case 150:
            case 151:
            case 152:
            case 154:
            case 155:
              return true;
            default:
              return false;
          }
        }
        function isInterfaceOrTypeLiteralCompletionKeyword(kind) {
          return kind === 145;
        }
        function isClassMemberCompletionKeyword(kind) {
          switch (kind) {
            case 126:
            case 134:
            case 136:
            case 149:
            case 131:
            case 135:
            case 159:
              return true;
            default:
              return ts3.isClassMemberModifier(kind);
          }
        }
        function isFunctionLikeBodyKeyword(kind) {
          return kind === 131 || kind === 132 || kind === 127 || !ts3.isContextualKeyword(kind) && !isClassMemberCompletionKeyword(kind);
        }
        function keywordForNode(node) {
          return ts3.isIdentifier(node) ? node.originalKeywordKind || 0 : node.kind;
        }
        function getContextualKeywords(contextToken, position) {
          var entries = [];
          if (contextToken) {
            var file = contextToken.getSourceFile();
            var parent = contextToken.parent;
            var tokenLine = file.getLineAndCharacterOfPosition(contextToken.end).line;
            var currentLine = file.getLineAndCharacterOfPosition(position).line;
            if ((ts3.isImportDeclaration(parent) || ts3.isExportDeclaration(parent) && parent.moduleSpecifier) && contextToken === parent.moduleSpecifier && tokenLine === currentLine) {
              entries.push({
                name: ts3.tokenToString(129),
                kind: "keyword",
                kindModifiers: "",
                sortText: Completions2.SortText.GlobalsOrKeywords
              });
            }
          }
          return entries;
        }
        function getJsDocTagAtPosition(node, position) {
          return ts3.findAncestor(node, function(n) {
            return ts3.isJSDocTag(n) && ts3.rangeContainsPosition(n, position) ? true : ts3.isJSDoc(n) ? "quit" : false;
          });
        }
        function getPropertiesForObjectExpression(contextualType, completionsType, obj, checker) {
          var hasCompletionsType = completionsType && completionsType !== contextualType;
          var type2 = hasCompletionsType && !(completionsType.flags & 3) ? checker.getUnionType([contextualType, completionsType]) : contextualType;
          var properties = getApparentProperties(type2, obj, checker);
          return type2.isClass() && containsNonPublicProperties(properties) ? [] : hasCompletionsType ? ts3.filter(properties, hasDeclarationOtherThanSelf) : properties;
          function hasDeclarationOtherThanSelf(member) {
            if (!ts3.length(member.declarations))
              return true;
            return ts3.some(member.declarations, function(decl) {
              return decl.parent !== obj;
            });
          }
        }
        Completions2.getPropertiesForObjectExpression = getPropertiesForObjectExpression;
        function getApparentProperties(type2, node, checker) {
          if (!type2.isUnion())
            return type2.getApparentProperties();
          return checker.getAllPossiblePropertiesOfTypes(ts3.filter(type2.types, function(memberType) {
            return !(memberType.flags & 131068 || checker.isArrayLikeType(memberType) || checker.isTypeInvalidDueToUnionDiscriminant(memberType, node) || ts3.typeHasCallOrConstructSignatures(memberType, checker) || memberType.isClass() && containsNonPublicProperties(memberType.getApparentProperties()));
          }));
        }
        function containsNonPublicProperties(props) {
          return ts3.some(props, function(p) {
            return !!(ts3.getDeclarationModifierFlagsFromSymbol(p) & 24);
          });
        }
        function getPropertiesForCompletion(type2, checker) {
          return type2.isUnion() ? ts3.Debug.checkEachDefined(checker.getAllPossiblePropertiesOfTypes(type2.types), "getAllPossiblePropertiesOfTypes() should all be defined") : ts3.Debug.checkEachDefined(type2.getApparentProperties(), "getApparentProperties() should all be defined");
        }
        function tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position) {
          switch (location.kind) {
            case 348:
              return ts3.tryCast(location.parent, ts3.isObjectTypeDeclaration);
            case 1:
              var cls = ts3.tryCast(ts3.lastOrUndefined(ts3.cast(location.parent, ts3.isSourceFile).statements), ts3.isObjectTypeDeclaration);
              if (cls && !ts3.findChildOfKind(cls, 19, sourceFile)) {
                return cls;
              }
              break;
            case 79: {
              if (ts3.isPropertyDeclaration(location.parent) && location.parent.initializer === location) {
                return void 0;
              }
              if (isFromObjectTypeDeclaration(location)) {
                return ts3.findAncestor(location, ts3.isObjectTypeDeclaration);
              }
            }
          }
          if (!contextToken)
            return void 0;
          if (location.kind === 134 || ts3.isIdentifier(contextToken) && ts3.isPropertyDeclaration(contextToken.parent) && ts3.isClassLike(location)) {
            return ts3.findAncestor(contextToken, ts3.isClassLike);
          }
          switch (contextToken.kind) {
            case 63:
              return void 0;
            case 26:
            case 19:
              return isFromObjectTypeDeclaration(location) && location.parent.name === location ? location.parent.parent : ts3.tryCast(location, ts3.isObjectTypeDeclaration);
            case 18:
            case 27:
              return ts3.tryCast(contextToken.parent, ts3.isObjectTypeDeclaration);
            default:
              if (!isFromObjectTypeDeclaration(contextToken)) {
                if (ts3.getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line !== ts3.getLineAndCharacterOfPosition(sourceFile, position).line && ts3.isObjectTypeDeclaration(location)) {
                  return location;
                }
                return void 0;
              }
              var isValidKeyword = ts3.isClassLike(contextToken.parent.parent) ? isClassMemberCompletionKeyword : isInterfaceOrTypeLiteralCompletionKeyword;
              return isValidKeyword(contextToken.kind) || contextToken.kind === 41 || ts3.isIdentifier(contextToken) && isValidKeyword(ts3.stringToToken(contextToken.text)) ? contextToken.parent.parent : void 0;
          }
        }
        function tryGetTypeLiteralNode(node) {
          if (!node)
            return void 0;
          var parent = node.parent;
          switch (node.kind) {
            case 18:
              if (ts3.isTypeLiteralNode(parent)) {
                return parent;
              }
              break;
            case 26:
            case 27:
            case 79:
              if (parent.kind === 166 && ts3.isTypeLiteralNode(parent.parent)) {
                return parent.parent;
              }
              break;
          }
          return void 0;
        }
        function getConstraintOfTypeArgumentProperty(node, checker) {
          if (!node)
            return void 0;
          if (ts3.isTypeNode(node) && ts3.isTypeReferenceType(node.parent)) {
            return checker.getTypeArgumentConstraint(node);
          }
          var t = getConstraintOfTypeArgumentProperty(node.parent, checker);
          if (!t)
            return void 0;
          switch (node.kind) {
            case 166:
              return checker.getTypeOfPropertyOfContextualType(t, node.symbol.escapedName);
            case 188:
            case 182:
            case 187:
              return t;
          }
        }
        function isFromObjectTypeDeclaration(node) {
          return node.parent && ts3.isClassOrTypeElement(node.parent) && ts3.isObjectTypeDeclaration(node.parent.parent);
        }
        function isValidTrigger(sourceFile, triggerCharacter, contextToken, position) {
          switch (triggerCharacter) {
            case ".":
            case "@":
              return true;
            case '"':
            case "'":
            case "`":
              return !!contextToken && ts3.isStringLiteralOrTemplate(contextToken) && position === contextToken.getStart(sourceFile) + 1;
            case "#":
              return !!contextToken && ts3.isPrivateIdentifier(contextToken) && !!ts3.getContainingClass(contextToken);
            case "<":
              return !!contextToken && contextToken.kind === 29 && (!ts3.isBinaryExpression(contextToken.parent) || binaryExpressionMayBeOpenTag(contextToken.parent));
            case "/":
              return !!contextToken && (ts3.isStringLiteralLike(contextToken) ? !!ts3.tryGetImportFromModuleSpecifier(contextToken) : contextToken.kind === 43 && ts3.isJsxClosingElement(contextToken.parent));
            case " ":
              return !!contextToken && ts3.isImportKeyword(contextToken) && contextToken.parent.kind === 305;
            default:
              return ts3.Debug.assertNever(triggerCharacter);
          }
        }
        function binaryExpressionMayBeOpenTag(_a) {
          var left = _a.left;
          return ts3.nodeIsMissing(left);
        }
        function isProbablyGlobalType(type2, sourceFile, checker) {
          var selfSymbol = checker.resolveName("self", void 0, 111551, false);
          if (selfSymbol && checker.getTypeOfSymbolAtLocation(selfSymbol, sourceFile) === type2) {
            return true;
          }
          var globalSymbol = checker.resolveName("global", void 0, 111551, false);
          if (globalSymbol && checker.getTypeOfSymbolAtLocation(globalSymbol, sourceFile) === type2) {
            return true;
          }
          var globalThisSymbol = checker.resolveName("globalThis", void 0, 111551, false);
          if (globalThisSymbol && checker.getTypeOfSymbolAtLocation(globalThisSymbol, sourceFile) === type2) {
            return true;
          }
          return false;
        }
        function isStaticProperty(symbol) {
          return !!(symbol.valueDeclaration && ts3.getEffectiveModifierFlags(symbol.valueDeclaration) & 32 && ts3.isClassLike(symbol.valueDeclaration.parent));
        }
        function tryGetObjectLiteralContextualType(node, typeChecker) {
          var type2 = typeChecker.getContextualType(node);
          if (type2) {
            return type2;
          }
          var parent = ts3.walkUpParenthesizedExpressions(node.parent);
          if (ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 63 && node === parent.left) {
            return typeChecker.getTypeAtLocation(parent);
          }
          if (ts3.isExpression(parent)) {
            return typeChecker.getContextualType(parent);
          }
          return void 0;
        }
        function getImportStatementCompletionInfo(contextToken) {
          var keywordCompletion;
          var isKeywordOnlyCompletion = false;
          var candidate = getCandidate();
          return {
            isKeywordOnlyCompletion,
            keywordCompletion,
            isNewIdentifierLocation: !!(candidate || keywordCompletion === 152),
            replacementNode: candidate && ts3.rangeIsOnSingleLine(candidate, candidate.getSourceFile()) ? candidate : void 0
          };
          function getCandidate() {
            var parent = contextToken.parent;
            if (ts3.isImportEqualsDeclaration(parent)) {
              keywordCompletion = contextToken.kind === 152 ? void 0 : 152;
              return isModuleSpecifierMissingOrEmpty(parent.moduleReference) ? parent : void 0;
            }
            if (couldBeTypeOnlyImportSpecifier(parent, contextToken) && canCompleteFromNamedBindings(parent.parent)) {
              return parent;
            }
            if (ts3.isNamedImports(parent) || ts3.isNamespaceImport(parent)) {
              if (!parent.parent.isTypeOnly && (contextToken.kind === 18 || contextToken.kind === 100 || contextToken.kind === 27)) {
                keywordCompletion = 152;
              }
              if (canCompleteFromNamedBindings(parent)) {
                if (contextToken.kind === 19 || contextToken.kind === 79) {
                  isKeywordOnlyCompletion = true;
                  keywordCompletion = 156;
                } else {
                  return parent.parent.parent;
                }
              }
              return void 0;
            }
            if (ts3.isImportKeyword(contextToken) && ts3.isSourceFile(parent)) {
              keywordCompletion = 152;
              return contextToken;
            }
            if (ts3.isImportKeyword(contextToken) && ts3.isImportDeclaration(parent)) {
              keywordCompletion = 152;
              return isModuleSpecifierMissingOrEmpty(parent.moduleSpecifier) ? parent : void 0;
            }
            return void 0;
          }
        }
        function couldBeTypeOnlyImportSpecifier(importSpecifier, contextToken) {
          return ts3.isImportSpecifier(importSpecifier) && (importSpecifier.isTypeOnly || contextToken === importSpecifier.name && ts3.isTypeKeywordTokenOrIdentifier(contextToken));
        }
        function canCompleteFromNamedBindings(namedBindings) {
          return isModuleSpecifierMissingOrEmpty(namedBindings.parent.parent.moduleSpecifier) && (ts3.isNamespaceImport(namedBindings) || namedBindings.elements.length < 2) && !namedBindings.parent.name;
        }
        function isModuleSpecifierMissingOrEmpty(specifier) {
          var _a;
          if (ts3.nodeIsMissing(specifier))
            return true;
          return !((_a = ts3.tryCast(ts3.isExternalModuleReference(specifier) ? specifier.expression : specifier, ts3.isStringLiteralLike)) === null || _a === void 0 ? void 0 : _a.text);
        }
        function getVariableDeclaration(property) {
          var variableDeclaration = ts3.findAncestor(property, function(node) {
            return ts3.isFunctionBlock(node) || isArrowFunctionBody(node) || ts3.isBindingPattern(node) ? "quit" : ts3.isVariableDeclaration(node);
          });
          return variableDeclaration;
        }
        function isArrowFunctionBody(node) {
          return node.parent && ts3.isArrowFunction(node.parent) && node.parent.body === node;
        }
        ;
        function symbolCanBeReferencedAtTypeLocation(symbol, checker, seenModules) {
          if (seenModules === void 0) {
            seenModules = new ts3.Map();
          }
          return nonAliasCanBeReferencedAtTypeLocation(symbol) || nonAliasCanBeReferencedAtTypeLocation(ts3.skipAlias(symbol.exportSymbol || symbol, checker));
          function nonAliasCanBeReferencedAtTypeLocation(symbol2) {
            return !!(symbol2.flags & 788968) || checker.isUnknownSymbol(symbol2) || !!(symbol2.flags & 1536) && ts3.addToSeen(seenModules, ts3.getSymbolId(symbol2)) && checker.getExportsOfModule(symbol2).some(function(e) {
              return symbolCanBeReferencedAtTypeLocation(e, checker, seenModules);
            });
          }
        }
        function isDeprecated(symbol, checker) {
          var declarations = ts3.skipAlias(symbol, checker).declarations;
          return !!ts3.length(declarations) && ts3.every(declarations, ts3.isDeprecatedDeclaration);
        }
        function charactersFuzzyMatchInString(identifierString, lowercaseCharacters) {
          if (lowercaseCharacters.length === 0) {
            return true;
          }
          var matchedFirstCharacter = false;
          var prevChar;
          var characterIndex = 0;
          var len = identifierString.length;
          for (var strIndex = 0; strIndex < len; strIndex++) {
            var strChar = identifierString.charCodeAt(strIndex);
            var testChar = lowercaseCharacters.charCodeAt(characterIndex);
            if (strChar === testChar || strChar === toUpperCharCode(testChar)) {
              matchedFirstCharacter || (matchedFirstCharacter = prevChar === void 0 || 97 <= prevChar && prevChar <= 122 && 65 <= strChar && strChar <= 90 || prevChar === 95 && strChar !== 95);
              if (matchedFirstCharacter) {
                characterIndex++;
              }
              if (characterIndex === lowercaseCharacters.length) {
                return true;
              }
            }
            prevChar = strChar;
          }
          return false;
        }
        function toUpperCharCode(charCode) {
          if (97 <= charCode && charCode <= 122) {
            return charCode - 32;
          }
          return charCode;
        }
      })(Completions = ts3.Completions || (ts3.Completions = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var DocumentHighlights;
      (function(DocumentHighlights2) {
        function getDocumentHighlights(program2, cancellationToken, sourceFile, position, sourceFilesToSearch) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node.parent && (ts3.isJsxOpeningElement(node.parent) && node.parent.tagName === node || ts3.isJsxClosingElement(node.parent))) {
            var _a = node.parent.parent, openingElement = _a.openingElement, closingElement = _a.closingElement;
            var highlightSpans = [openingElement, closingElement].map(function(_a2) {
              var tagName = _a2.tagName;
              return getHighlightSpanForNode(tagName, sourceFile);
            });
            return [{ fileName: sourceFile.fileName, highlightSpans }];
          }
          return getSemanticDocumentHighlights(position, node, program2, cancellationToken, sourceFilesToSearch) || getSyntacticDocumentHighlights(node, sourceFile);
        }
        DocumentHighlights2.getDocumentHighlights = getDocumentHighlights;
        function getHighlightSpanForNode(node, sourceFile) {
          return {
            fileName: sourceFile.fileName,
            textSpan: ts3.createTextSpanFromNode(node, sourceFile),
            kind: "none"
          };
        }
        function getSemanticDocumentHighlights(position, node, program2, cancellationToken, sourceFilesToSearch) {
          var sourceFilesSet = new ts3.Set(sourceFilesToSearch.map(function(f) {
            return f.fileName;
          }));
          var referenceEntries = ts3.FindAllReferences.getReferenceEntriesForNode(position, node, program2, sourceFilesToSearch, cancellationToken, void 0, sourceFilesSet);
          if (!referenceEntries)
            return void 0;
          var map2 = ts3.arrayToMultiMap(referenceEntries.map(ts3.FindAllReferences.toHighlightSpan), function(e) {
            return e.fileName;
          }, function(e) {
            return e.span;
          });
          var getCanonicalFileName = ts3.createGetCanonicalFileName(program2.useCaseSensitiveFileNames());
          return ts3.mapDefined(ts3.arrayFrom(map2.entries()), function(_a) {
            var fileName2 = _a[0], highlightSpans = _a[1];
            if (!sourceFilesSet.has(fileName2)) {
              if (!program2.redirectTargetsMap.has(ts3.toPath(fileName2, program2.getCurrentDirectory(), getCanonicalFileName))) {
                return void 0;
              }
              var redirectTarget_1 = program2.getSourceFile(fileName2);
              var redirect = ts3.find(sourceFilesToSearch, function(f) {
                return !!f.redirectInfo && f.redirectInfo.redirectTarget === redirectTarget_1;
              });
              fileName2 = redirect.fileName;
              ts3.Debug.assert(sourceFilesSet.has(fileName2));
            }
            return { fileName: fileName2, highlightSpans };
          });
        }
        function getSyntacticDocumentHighlights(node, sourceFile) {
          var highlightSpans = getHighlightSpans(node, sourceFile);
          return highlightSpans && [{ fileName: sourceFile.fileName, highlightSpans }];
        }
        function getHighlightSpans(node, sourceFile) {
          switch (node.kind) {
            case 99:
            case 91:
              return ts3.isIfStatement(node.parent) ? getIfElseOccurrences(node.parent, sourceFile) : void 0;
            case 105:
              return useParent(node.parent, ts3.isReturnStatement, getReturnOccurrences);
            case 109:
              return useParent(node.parent, ts3.isThrowStatement, getThrowOccurrences);
            case 111:
            case 83:
            case 96:
              var tryStatement = node.kind === 83 ? node.parent.parent : node.parent;
              return useParent(tryStatement, ts3.isTryStatement, getTryCatchFinallyOccurrences);
            case 107:
              return useParent(node.parent, ts3.isSwitchStatement, getSwitchCaseDefaultOccurrences);
            case 82:
            case 88: {
              if (ts3.isDefaultClause(node.parent) || ts3.isCaseClause(node.parent)) {
                return useParent(node.parent.parent.parent, ts3.isSwitchStatement, getSwitchCaseDefaultOccurrences);
              }
              return void 0;
            }
            case 81:
            case 86:
              return useParent(node.parent, ts3.isBreakOrContinueStatement, getBreakOrContinueStatementOccurrences);
            case 97:
            case 115:
            case 90:
              return useParent(node.parent, function(n) {
                return ts3.isIterationStatement(n, true);
              }, getLoopBreakContinueOccurrences);
            case 134:
              return getFromAllDeclarations(ts3.isConstructorDeclaration, [134]);
            case 136:
            case 149:
              return getFromAllDeclarations(ts3.isAccessor, [136, 149]);
            case 132:
              return useParent(node.parent, ts3.isAwaitExpression, getAsyncAndAwaitOccurrences);
            case 131:
              return highlightSpans(getAsyncAndAwaitOccurrences(node));
            case 125:
              return highlightSpans(getYieldOccurrences(node));
            case 101:
              return void 0;
            default:
              return ts3.isModifierKind(node.kind) && (ts3.isDeclaration(node.parent) || ts3.isVariableStatement(node.parent)) ? highlightSpans(getModifierOccurrences(node.kind, node.parent)) : void 0;
          }
          function getFromAllDeclarations(nodeTest, keywords) {
            return useParent(node.parent, nodeTest, function(decl) {
              return ts3.mapDefined(decl.symbol.declarations, function(d) {
                return nodeTest(d) ? ts3.find(d.getChildren(sourceFile), function(c) {
                  return ts3.contains(keywords, c.kind);
                }) : void 0;
              });
            });
          }
          function useParent(node2, nodeTest, getNodes) {
            return nodeTest(node2) ? highlightSpans(getNodes(node2, sourceFile)) : void 0;
          }
          function highlightSpans(nodes) {
            return nodes && nodes.map(function(node2) {
              return getHighlightSpanForNode(node2, sourceFile);
            });
          }
        }
        function aggregateOwnedThrowStatements(node) {
          if (ts3.isThrowStatement(node)) {
            return [node];
          } else if (ts3.isTryStatement(node)) {
            return ts3.concatenate(node.catchClause ? aggregateOwnedThrowStatements(node.catchClause) : node.tryBlock && aggregateOwnedThrowStatements(node.tryBlock), node.finallyBlock && aggregateOwnedThrowStatements(node.finallyBlock));
          }
          return ts3.isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateOwnedThrowStatements);
        }
        function getThrowStatementOwner(throwStatement) {
          var child = throwStatement;
          while (child.parent) {
            var parent = child.parent;
            if (ts3.isFunctionBlock(parent) || parent.kind === 305) {
              return parent;
            }
            if (ts3.isTryStatement(parent) && parent.tryBlock === child && parent.catchClause) {
              return child;
            }
            child = parent;
          }
          return void 0;
        }
        function aggregateAllBreakAndContinueStatements(node) {
          return ts3.isBreakOrContinueStatement(node) ? [node] : ts3.isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateAllBreakAndContinueStatements);
        }
        function flatMapChildren(node, cb) {
          var result2 = [];
          node.forEachChild(function(child) {
            var value = cb(child);
            if (value !== void 0) {
              result2.push.apply(result2, ts3.toArray(value));
            }
          });
          return result2;
        }
        function ownsBreakOrContinueStatement(owner, statement) {
          var actualOwner = getBreakOrContinueOwner(statement);
          return !!actualOwner && actualOwner === owner;
        }
        function getBreakOrContinueOwner(statement) {
          return ts3.findAncestor(statement, function(node) {
            switch (node.kind) {
              case 249:
                if (statement.kind === 245) {
                  return false;
                }
              case 242:
              case 243:
              case 244:
              case 241:
              case 240:
                return !statement.label || isLabeledBy(node, statement.label.escapedText);
              default:
                return ts3.isFunctionLike(node) && "quit";
            }
          });
        }
        function getModifierOccurrences(modifier, declaration) {
          return ts3.mapDefined(getNodesToSearchForModifier(declaration, ts3.modifierToFlag(modifier)), function(node) {
            return ts3.findModifier(node, modifier);
          });
        }
        function getNodesToSearchForModifier(declaration, modifierFlag) {
          var container = declaration.parent;
          switch (container.kind) {
            case 262:
            case 305:
            case 235:
            case 289:
            case 290:
              if (modifierFlag & 128 && ts3.isClassDeclaration(declaration)) {
                return __spreadArray(__spreadArray([], declaration.members, true), [declaration], false);
              } else {
                return container.statements;
              }
            case 171:
            case 169:
            case 256:
              return __spreadArray(__spreadArray([], container.parameters, true), ts3.isClassLike(container.parent) ? container.parent.members : [], true);
            case 257:
            case 226:
            case 258:
            case 182:
              var nodes = container.members;
              if (modifierFlag & (28 | 64)) {
                var constructor = ts3.find(container.members, ts3.isConstructorDeclaration);
                if (constructor) {
                  return __spreadArray(__spreadArray([], nodes, true), constructor.parameters, true);
                }
              } else if (modifierFlag & 128) {
                return __spreadArray(__spreadArray([], nodes, true), [container], false);
              }
              return nodes;
            case 205:
              return void 0;
            default:
              ts3.Debug.assertNever(container, "Invalid container kind.");
          }
        }
        function pushKeywordIf(keywordList, token) {
          var expected = [];
          for (var _i = 2; _i < arguments.length; _i++) {
            expected[_i - 2] = arguments[_i];
          }
          if (token && ts3.contains(expected, token.kind)) {
            keywordList.push(token);
            return true;
          }
          return false;
        }
        function getLoopBreakContinueOccurrences(loopNode) {
          var keywords = [];
          if (pushKeywordIf(keywords, loopNode.getFirstToken(), 97, 115, 90)) {
            if (loopNode.kind === 240) {
              var loopTokens = loopNode.getChildren();
              for (var i = loopTokens.length - 1; i >= 0; i--) {
                if (pushKeywordIf(keywords, loopTokens[i], 115)) {
                  break;
                }
              }
            }
          }
          ts3.forEach(aggregateAllBreakAndContinueStatements(loopNode.statement), function(statement) {
            if (ownsBreakOrContinueStatement(loopNode, statement)) {
              pushKeywordIf(keywords, statement.getFirstToken(), 81, 86);
            }
          });
          return keywords;
        }
        function getBreakOrContinueStatementOccurrences(breakOrContinueStatement) {
          var owner = getBreakOrContinueOwner(breakOrContinueStatement);
          if (owner) {
            switch (owner.kind) {
              case 242:
              case 243:
              case 244:
              case 240:
              case 241:
                return getLoopBreakContinueOccurrences(owner);
              case 249:
                return getSwitchCaseDefaultOccurrences(owner);
            }
          }
          return void 0;
        }
        function getSwitchCaseDefaultOccurrences(switchStatement) {
          var keywords = [];
          pushKeywordIf(keywords, switchStatement.getFirstToken(), 107);
          ts3.forEach(switchStatement.caseBlock.clauses, function(clause) {
            pushKeywordIf(keywords, clause.getFirstToken(), 82, 88);
            ts3.forEach(aggregateAllBreakAndContinueStatements(clause), function(statement) {
              if (ownsBreakOrContinueStatement(switchStatement, statement)) {
                pushKeywordIf(keywords, statement.getFirstToken(), 81);
              }
            });
          });
          return keywords;
        }
        function getTryCatchFinallyOccurrences(tryStatement, sourceFile) {
          var keywords = [];
          pushKeywordIf(keywords, tryStatement.getFirstToken(), 111);
          if (tryStatement.catchClause) {
            pushKeywordIf(keywords, tryStatement.catchClause.getFirstToken(), 83);
          }
          if (tryStatement.finallyBlock) {
            var finallyKeyword = ts3.findChildOfKind(tryStatement, 96, sourceFile);
            pushKeywordIf(keywords, finallyKeyword, 96);
          }
          return keywords;
        }
        function getThrowOccurrences(throwStatement, sourceFile) {
          var owner = getThrowStatementOwner(throwStatement);
          if (!owner) {
            return void 0;
          }
          var keywords = [];
          ts3.forEach(aggregateOwnedThrowStatements(owner), function(throwStatement2) {
            keywords.push(ts3.findChildOfKind(throwStatement2, 109, sourceFile));
          });
          if (ts3.isFunctionBlock(owner)) {
            ts3.forEachReturnStatement(owner, function(returnStatement) {
              keywords.push(ts3.findChildOfKind(returnStatement, 105, sourceFile));
            });
          }
          return keywords;
        }
        function getReturnOccurrences(returnStatement, sourceFile) {
          var func = ts3.getContainingFunction(returnStatement);
          if (!func) {
            return void 0;
          }
          var keywords = [];
          ts3.forEachReturnStatement(ts3.cast(func.body, ts3.isBlock), function(returnStatement2) {
            keywords.push(ts3.findChildOfKind(returnStatement2, 105, sourceFile));
          });
          ts3.forEach(aggregateOwnedThrowStatements(func.body), function(throwStatement) {
            keywords.push(ts3.findChildOfKind(throwStatement, 109, sourceFile));
          });
          return keywords;
        }
        function getAsyncAndAwaitOccurrences(node) {
          var func = ts3.getContainingFunction(node);
          if (!func) {
            return void 0;
          }
          var keywords = [];
          if (func.modifiers) {
            func.modifiers.forEach(function(modifier) {
              pushKeywordIf(keywords, modifier, 131);
            });
          }
          ts3.forEachChild(func, function(child) {
            traverseWithoutCrossingFunction(child, function(node2) {
              if (ts3.isAwaitExpression(node2)) {
                pushKeywordIf(keywords, node2.getFirstToken(), 132);
              }
            });
          });
          return keywords;
        }
        function getYieldOccurrences(node) {
          var func = ts3.getContainingFunction(node);
          if (!func) {
            return void 0;
          }
          var keywords = [];
          ts3.forEachChild(func, function(child) {
            traverseWithoutCrossingFunction(child, function(node2) {
              if (ts3.isYieldExpression(node2)) {
                pushKeywordIf(keywords, node2.getFirstToken(), 125);
              }
            });
          });
          return keywords;
        }
        function traverseWithoutCrossingFunction(node, cb) {
          cb(node);
          if (!ts3.isFunctionLike(node) && !ts3.isClassLike(node) && !ts3.isInterfaceDeclaration(node) && !ts3.isModuleDeclaration(node) && !ts3.isTypeAliasDeclaration(node) && !ts3.isTypeNode(node)) {
            ts3.forEachChild(node, function(child) {
              return traverseWithoutCrossingFunction(child, cb);
            });
          }
        }
        function getIfElseOccurrences(ifStatement, sourceFile) {
          var keywords = getIfElseKeywords(ifStatement, sourceFile);
          var result2 = [];
          for (var i = 0; i < keywords.length; i++) {
            if (keywords[i].kind === 91 && i < keywords.length - 1) {
              var elseKeyword = keywords[i];
              var ifKeyword = keywords[i + 1];
              var shouldCombineElseAndIf = true;
              for (var j = ifKeyword.getStart(sourceFile) - 1; j >= elseKeyword.end; j--) {
                if (!ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(j))) {
                  shouldCombineElseAndIf = false;
                  break;
                }
              }
              if (shouldCombineElseAndIf) {
                result2.push({
                  fileName: sourceFile.fileName,
                  textSpan: ts3.createTextSpanFromBounds(elseKeyword.getStart(), ifKeyword.end),
                  kind: "reference"
                });
                i++;
                continue;
              }
            }
            result2.push(getHighlightSpanForNode(keywords[i], sourceFile));
          }
          return result2;
        }
        function getIfElseKeywords(ifStatement, sourceFile) {
          var keywords = [];
          while (ts3.isIfStatement(ifStatement.parent) && ifStatement.parent.elseStatement === ifStatement) {
            ifStatement = ifStatement.parent;
          }
          while (true) {
            var children = ifStatement.getChildren(sourceFile);
            pushKeywordIf(keywords, children[0], 99);
            for (var i = children.length - 1; i >= 0; i--) {
              if (pushKeywordIf(keywords, children[i], 91)) {
                break;
              }
            }
            if (!ifStatement.elseStatement || !ts3.isIfStatement(ifStatement.elseStatement)) {
              break;
            }
            ifStatement = ifStatement.elseStatement;
          }
          return keywords;
        }
        function isLabeledBy(node, labelName) {
          return !!ts3.findAncestor(node.parent, function(owner) {
            return !ts3.isLabeledStatement(owner) ? "quit" : owner.label.escapedText === labelName;
          });
        }
      })(DocumentHighlights = ts3.DocumentHighlights || (ts3.DocumentHighlights = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function isDocumentRegistryEntry(entry) {
        return !!entry.sourceFile;
      }
      function createDocumentRegistry(useCaseSensitiveFileNames, currentDirectory) {
        return createDocumentRegistryInternal(useCaseSensitiveFileNames, currentDirectory);
      }
      ts3.createDocumentRegistry = createDocumentRegistry;
      function createDocumentRegistryInternal(useCaseSensitiveFileNames, currentDirectory, externalCache) {
        if (currentDirectory === void 0) {
          currentDirectory = "";
        }
        var buckets = new ts3.Map();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(!!useCaseSensitiveFileNames);
        function reportStats() {
          var bucketInfoArray = ts3.arrayFrom(buckets.keys()).filter(function(name) {
            return name && name.charAt(0) === "_";
          }).map(function(name) {
            var entries = buckets.get(name);
            var sourceFiles = [];
            entries.forEach(function(entry, name2) {
              if (isDocumentRegistryEntry(entry)) {
                sourceFiles.push({
                  name: name2,
                  scriptKind: entry.sourceFile.scriptKind,
                  refCount: entry.languageServiceRefCount
                });
              } else {
                entry.forEach(function(value, scriptKind) {
                  return sourceFiles.push({ name: name2, scriptKind, refCount: value.languageServiceRefCount });
                });
              }
            });
            sourceFiles.sort(function(x, y) {
              return y.refCount - x.refCount;
            });
            return {
              bucket: name,
              sourceFiles
            };
          });
          return JSON.stringify(bucketInfoArray, void 0, 2);
        }
        function getCompilationSettings(settingsOrHost) {
          if (typeof settingsOrHost.getCompilationSettings === "function") {
            return settingsOrHost.getCompilationSettings();
          }
          return settingsOrHost;
        }
        function acquireDocument(fileName2, compilationSettings, scriptSnapshot, version, scriptKind) {
          var path2 = ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
          var key = getKeyForCompilationSettings(getCompilationSettings(compilationSettings));
          return acquireDocumentWithKey(fileName2, path2, compilationSettings, key, scriptSnapshot, version, scriptKind);
        }
        function acquireDocumentWithKey(fileName2, path2, compilationSettings, key, scriptSnapshot, version, scriptKind) {
          return acquireOrUpdateDocument(fileName2, path2, compilationSettings, key, scriptSnapshot, version, true, scriptKind);
        }
        function updateDocument(fileName2, compilationSettings, scriptSnapshot, version, scriptKind) {
          var path2 = ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
          var key = getKeyForCompilationSettings(getCompilationSettings(compilationSettings));
          return updateDocumentWithKey(fileName2, path2, compilationSettings, key, scriptSnapshot, version, scriptKind);
        }
        function updateDocumentWithKey(fileName2, path2, compilationSettings, key, scriptSnapshot, version, scriptKind) {
          return acquireOrUpdateDocument(fileName2, path2, getCompilationSettings(compilationSettings), key, scriptSnapshot, version, false, scriptKind);
        }
        function getDocumentRegistryEntry(bucketEntry, scriptKind) {
          var entry = isDocumentRegistryEntry(bucketEntry) ? bucketEntry : bucketEntry.get(ts3.Debug.checkDefined(scriptKind, "If there are more than one scriptKind's for same document the scriptKind should be provided"));
          ts3.Debug.assert(scriptKind === void 0 || !entry || entry.sourceFile.scriptKind === scriptKind, "Script kind should match provided ScriptKind:".concat(scriptKind, " and sourceFile.scriptKind: ").concat(entry === null || entry === void 0 ? void 0 : entry.sourceFile.scriptKind, ", !entry: ").concat(!entry));
          return entry;
        }
        function acquireOrUpdateDocument(fileName2, path2, compilationSettingsOrHost, key, scriptSnapshot, version, acquiring, scriptKind) {
          var _a, _b, _c, _d;
          scriptKind = ts3.ensureScriptKind(fileName2, scriptKind);
          var compilationSettings = getCompilationSettings(compilationSettingsOrHost);
          var host = compilationSettingsOrHost === compilationSettings ? void 0 : compilationSettingsOrHost;
          var scriptTarget = scriptKind === 6 ? 100 : ts3.getEmitScriptTarget(compilationSettings);
          var sourceFileOptions = {
            languageVersion: scriptTarget,
            impliedNodeFormat: host && ts3.getImpliedNodeFormatForFile(path2, (_d = (_c = (_b = (_a = host.getCompilerHost) === null || _a === void 0 ? void 0 : _a.call(host)) === null || _b === void 0 ? void 0 : _b.getModuleResolutionCache) === null || _c === void 0 ? void 0 : _c.call(_b)) === null || _d === void 0 ? void 0 : _d.getPackageJsonInfoCache(), host, compilationSettings),
            setExternalModuleIndicator: ts3.getSetExternalModuleIndicator(compilationSettings)
          };
          var oldBucketCount = buckets.size;
          var bucket = ts3.getOrUpdate(buckets, key, function() {
            return new ts3.Map();
          });
          if (ts3.tracing) {
            if (buckets.size > oldBucketCount) {
              ts3.tracing.instant("session", "createdDocumentRegistryBucket", { configFilePath: compilationSettings.configFilePath, key });
            }
            var otherBucketKey = !ts3.isDeclarationFileName(path2) && ts3.forEachEntry(buckets, function(bucket2, bucketKey) {
              return bucketKey !== key && bucket2.has(path2) && bucketKey;
            });
            if (otherBucketKey) {
              ts3.tracing.instant("session", "documentRegistryBucketOverlap", { path: path2, key1: otherBucketKey, key2: key });
            }
          }
          var bucketEntry = bucket.get(path2);
          var entry = bucketEntry && getDocumentRegistryEntry(bucketEntry, scriptKind);
          if (!entry && externalCache) {
            var sourceFile = externalCache.getDocument(key, path2);
            if (sourceFile) {
              ts3.Debug.assert(acquiring);
              entry = {
                sourceFile,
                languageServiceRefCount: 0
              };
              setBucketEntry();
            }
          }
          if (!entry) {
            var sourceFile = ts3.createLanguageServiceSourceFile(fileName2, scriptSnapshot, sourceFileOptions, version, false, scriptKind);
            if (externalCache) {
              externalCache.setDocument(key, path2, sourceFile);
            }
            entry = {
              sourceFile,
              languageServiceRefCount: 1
            };
            setBucketEntry();
          } else {
            if (entry.sourceFile.version !== version) {
              entry.sourceFile = ts3.updateLanguageServiceSourceFile(entry.sourceFile, scriptSnapshot, version, scriptSnapshot.getChangeRange(entry.sourceFile.scriptSnapshot));
              if (externalCache) {
                externalCache.setDocument(key, path2, entry.sourceFile);
              }
            }
            if (acquiring) {
              entry.languageServiceRefCount++;
            }
          }
          ts3.Debug.assert(entry.languageServiceRefCount !== 0);
          return entry.sourceFile;
          function setBucketEntry() {
            if (!bucketEntry) {
              bucket.set(path2, entry);
            } else if (isDocumentRegistryEntry(bucketEntry)) {
              var scriptKindMap = new ts3.Map();
              scriptKindMap.set(bucketEntry.sourceFile.scriptKind, bucketEntry);
              scriptKindMap.set(scriptKind, entry);
              bucket.set(path2, scriptKindMap);
            } else {
              bucketEntry.set(scriptKind, entry);
            }
          }
        }
        function releaseDocument(fileName2, compilationSettings, scriptKind) {
          var path2 = ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
          var key = getKeyForCompilationSettings(compilationSettings);
          return releaseDocumentWithKey(path2, key, scriptKind);
        }
        function releaseDocumentWithKey(path2, key, scriptKind) {
          var bucket = ts3.Debug.checkDefined(buckets.get(key));
          var bucketEntry = bucket.get(path2);
          var entry = getDocumentRegistryEntry(bucketEntry, scriptKind);
          entry.languageServiceRefCount--;
          ts3.Debug.assert(entry.languageServiceRefCount >= 0);
          if (entry.languageServiceRefCount === 0) {
            if (isDocumentRegistryEntry(bucketEntry)) {
              bucket.delete(path2);
            } else {
              bucketEntry.delete(scriptKind);
              if (bucketEntry.size === 1) {
                bucket.set(path2, ts3.firstDefinedIterator(bucketEntry.values(), ts3.identity));
              }
            }
          }
        }
        function getLanguageServiceRefCounts(path2, scriptKind) {
          return ts3.arrayFrom(buckets.entries(), function(_a) {
            var key = _a[0], bucket = _a[1];
            var bucketEntry = bucket.get(path2);
            var entry = bucketEntry && getDocumentRegistryEntry(bucketEntry, scriptKind);
            return [key, entry && entry.languageServiceRefCount];
          });
        }
        return {
          acquireDocument,
          acquireDocumentWithKey,
          updateDocument,
          updateDocumentWithKey,
          releaseDocument,
          releaseDocumentWithKey,
          getLanguageServiceRefCounts,
          reportStats,
          getKeyForCompilationSettings
        };
      }
      ts3.createDocumentRegistryInternal = createDocumentRegistryInternal;
      function compilerOptionValueToString(value) {
        var _a;
        if (value === null || typeof value !== "object") {
          return "" + value;
        }
        if (ts3.isArray(value)) {
          return "[".concat((_a = ts3.map(value, function(e) {
            return compilerOptionValueToString(e);
          })) === null || _a === void 0 ? void 0 : _a.join(","), "]");
        }
        var str2 = "{";
        for (var key in value) {
          if (ts3.hasOwnProperty.call(value, key)) {
            str2 += "".concat(key, ": ").concat(compilerOptionValueToString(value[key]));
          }
        }
        return str2 + "}";
      }
      function getKeyForCompilationSettings(settings) {
        return ts3.sourceFileAffectingCompilerOptions.map(function(option) {
          return compilerOptionValueToString(ts3.getCompilerOptionValue(settings, option));
        }).join("|") + (settings.pathsBasePath ? "|".concat(settings.pathsBasePath) : void 0);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var FindAllReferences;
      (function(FindAllReferences2) {
        function createImportTracker(sourceFiles, sourceFilesSet, checker, cancellationToken) {
          var allDirectImports = getDirectImportsMap(sourceFiles, checker, cancellationToken);
          return function(exportSymbol, exportInfo, isForRename) {
            var _a = getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, exportInfo, checker, cancellationToken), directImports = _a.directImports, indirectUsers = _a.indirectUsers;
            return __assign({ indirectUsers }, getSearchesFromDirectImports(directImports, exportSymbol, exportInfo.exportKind, checker, isForRename));
          };
        }
        FindAllReferences2.createImportTracker = createImportTracker;
        var ExportKind;
        (function(ExportKind2) {
          ExportKind2[ExportKind2["Named"] = 0] = "Named";
          ExportKind2[ExportKind2["Default"] = 1] = "Default";
          ExportKind2[ExportKind2["ExportEquals"] = 2] = "ExportEquals";
        })(ExportKind = FindAllReferences2.ExportKind || (FindAllReferences2.ExportKind = {}));
        var ImportExport;
        (function(ImportExport2) {
          ImportExport2[ImportExport2["Import"] = 0] = "Import";
          ImportExport2[ImportExport2["Export"] = 1] = "Export";
        })(ImportExport = FindAllReferences2.ImportExport || (FindAllReferences2.ImportExport = {}));
        function getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, _a, checker, cancellationToken) {
          var exportingModuleSymbol = _a.exportingModuleSymbol, exportKind = _a.exportKind;
          var markSeenDirectImport = ts3.nodeSeenTracker();
          var markSeenIndirectUser = ts3.nodeSeenTracker();
          var directImports = [];
          var isAvailableThroughGlobal = !!exportingModuleSymbol.globalExports;
          var indirectUserDeclarations = isAvailableThroughGlobal ? void 0 : [];
          handleDirectImports(exportingModuleSymbol);
          return { directImports, indirectUsers: getIndirectUsers() };
          function getIndirectUsers() {
            if (isAvailableThroughGlobal) {
              return sourceFiles;
            }
            if (exportingModuleSymbol.declarations) {
              for (var _i = 0, _a2 = exportingModuleSymbol.declarations; _i < _a2.length; _i++) {
                var decl = _a2[_i];
                if (ts3.isExternalModuleAugmentation(decl) && sourceFilesSet.has(decl.getSourceFile().fileName)) {
                  addIndirectUser(decl);
                }
              }
            }
            return indirectUserDeclarations.map(ts3.getSourceFileOfNode);
          }
          function handleDirectImports(exportingModuleSymbol2) {
            var theseDirectImports = getDirectImports(exportingModuleSymbol2);
            if (theseDirectImports) {
              for (var _i = 0, theseDirectImports_1 = theseDirectImports; _i < theseDirectImports_1.length; _i++) {
                var direct = theseDirectImports_1[_i];
                if (!markSeenDirectImport(direct)) {
                  continue;
                }
                if (cancellationToken)
                  cancellationToken.throwIfCancellationRequested();
                switch (direct.kind) {
                  case 208:
                    if (ts3.isImportCall(direct)) {
                      handleImportCall(direct);
                      break;
                    }
                    if (!isAvailableThroughGlobal) {
                      var parent = direct.parent;
                      if (exportKind === 2 && parent.kind === 254) {
                        var name = parent.name;
                        if (name.kind === 79) {
                          directImports.push(name);
                          break;
                        }
                      }
                    }
                    break;
                  case 79:
                    break;
                  case 265:
                    handleNamespaceImport(direct, direct.name, ts3.hasSyntacticModifier(direct, 1), false);
                    break;
                  case 266:
                    directImports.push(direct);
                    var namedBindings = direct.importClause && direct.importClause.namedBindings;
                    if (namedBindings && namedBindings.kind === 268) {
                      handleNamespaceImport(direct, namedBindings.name, false, true);
                    } else if (!isAvailableThroughGlobal && ts3.isDefaultImport(direct)) {
                      addIndirectUser(getSourceFileLikeForImportDeclaration(direct));
                    }
                    break;
                  case 272:
                    if (!direct.exportClause) {
                      handleDirectImports(getContainingModuleSymbol(direct, checker));
                    } else if (direct.exportClause.kind === 274) {
                      addIndirectUser(getSourceFileLikeForImportDeclaration(direct), true);
                    } else {
                      directImports.push(direct);
                    }
                    break;
                  case 200:
                    if (direct.isTypeOf && !direct.qualifier && isExported(direct)) {
                      addIndirectUser(direct.getSourceFile(), true);
                    }
                    directImports.push(direct);
                    break;
                  default:
                    ts3.Debug.failBadSyntaxKind(direct, "Unexpected import kind.");
                }
              }
            }
          }
          function handleImportCall(importCall) {
            var top = ts3.findAncestor(importCall, isAmbientModuleDeclaration) || importCall.getSourceFile();
            addIndirectUser(top, !!isExported(importCall, true));
          }
          function isExported(node, stopAtAmbientModule) {
            if (stopAtAmbientModule === void 0) {
              stopAtAmbientModule = false;
            }
            return ts3.findAncestor(node, function(node2) {
              if (stopAtAmbientModule && isAmbientModuleDeclaration(node2))
                return "quit";
              return ts3.some(node2.modifiers, function(mod) {
                return mod.kind === 93;
              });
            });
          }
          function handleNamespaceImport(importDeclaration, name, isReExport, alreadyAddedDirect) {
            if (exportKind === 2) {
              if (!alreadyAddedDirect)
                directImports.push(importDeclaration);
            } else if (!isAvailableThroughGlobal) {
              var sourceFileLike = getSourceFileLikeForImportDeclaration(importDeclaration);
              ts3.Debug.assert(sourceFileLike.kind === 305 || sourceFileLike.kind === 261);
              if (isReExport || findNamespaceReExports(sourceFileLike, name, checker)) {
                addIndirectUser(sourceFileLike, true);
              } else {
                addIndirectUser(sourceFileLike);
              }
            }
          }
          function addIndirectUser(sourceFileLike, addTransitiveDependencies) {
            if (addTransitiveDependencies === void 0) {
              addTransitiveDependencies = false;
            }
            ts3.Debug.assert(!isAvailableThroughGlobal);
            var isNew = markSeenIndirectUser(sourceFileLike);
            if (!isNew)
              return;
            indirectUserDeclarations.push(sourceFileLike);
            if (!addTransitiveDependencies)
              return;
            var moduleSymbol = checker.getMergedSymbol(sourceFileLike.symbol);
            if (!moduleSymbol)
              return;
            ts3.Debug.assert(!!(moduleSymbol.flags & 1536));
            var directImports2 = getDirectImports(moduleSymbol);
            if (directImports2) {
              for (var _i = 0, directImports_1 = directImports2; _i < directImports_1.length; _i++) {
                var directImport = directImports_1[_i];
                if (!ts3.isImportTypeNode(directImport)) {
                  addIndirectUser(getSourceFileLikeForImportDeclaration(directImport), true);
                }
              }
            }
          }
          function getDirectImports(moduleSymbol) {
            return allDirectImports.get(ts3.getSymbolId(moduleSymbol).toString());
          }
        }
        function getSearchesFromDirectImports(directImports, exportSymbol, exportKind, checker, isForRename) {
          var importSearches = [];
          var singleReferences = [];
          function addSearch(location, symbol) {
            importSearches.push([location, symbol]);
          }
          if (directImports) {
            for (var _i = 0, directImports_2 = directImports; _i < directImports_2.length; _i++) {
              var decl = directImports_2[_i];
              handleImport(decl);
            }
          }
          return { importSearches, singleReferences };
          function handleImport(decl2) {
            if (decl2.kind === 265) {
              if (isExternalModuleImportEquals(decl2)) {
                handleNamespaceImportLike(decl2.name);
              }
              return;
            }
            if (decl2.kind === 79) {
              handleNamespaceImportLike(decl2);
              return;
            }
            if (decl2.kind === 200) {
              if (decl2.qualifier) {
                var firstIdentifier = ts3.getFirstIdentifier(decl2.qualifier);
                if (firstIdentifier.escapedText === ts3.symbolName(exportSymbol)) {
                  singleReferences.push(firstIdentifier);
                }
              } else if (exportKind === 2) {
                singleReferences.push(decl2.argument.literal);
              }
              return;
            }
            if (decl2.moduleSpecifier.kind !== 10) {
              return;
            }
            if (decl2.kind === 272) {
              if (decl2.exportClause && ts3.isNamedExports(decl2.exportClause)) {
                searchForNamedImport(decl2.exportClause);
              }
              return;
            }
            var _a = decl2.importClause || { name: void 0, namedBindings: void 0 }, name = _a.name, namedBindings = _a.namedBindings;
            if (namedBindings) {
              switch (namedBindings.kind) {
                case 268:
                  handleNamespaceImportLike(namedBindings.name);
                  break;
                case 269:
                  if (exportKind === 0 || exportKind === 1) {
                    searchForNamedImport(namedBindings);
                  }
                  break;
                default:
                  ts3.Debug.assertNever(namedBindings);
              }
            }
            if (name && (exportKind === 1 || exportKind === 2) && (!isForRename || name.escapedText === ts3.symbolEscapedNameNoDefault(exportSymbol))) {
              var defaultImportAlias = checker.getSymbolAtLocation(name);
              addSearch(name, defaultImportAlias);
            }
          }
          function handleNamespaceImportLike(importName) {
            if (exportKind === 2 && (!isForRename || isNameMatch(importName.escapedText))) {
              addSearch(importName, checker.getSymbolAtLocation(importName));
            }
          }
          function searchForNamedImport(namedBindings) {
            if (!namedBindings) {
              return;
            }
            for (var _i2 = 0, _a = namedBindings.elements; _i2 < _a.length; _i2++) {
              var element = _a[_i2];
              var name = element.name, propertyName = element.propertyName;
              if (!isNameMatch((propertyName || name).escapedText)) {
                continue;
              }
              if (propertyName) {
                singleReferences.push(propertyName);
                if (!isForRename || name.escapedText === exportSymbol.escapedName) {
                  addSearch(name, checker.getSymbolAtLocation(name));
                }
              } else {
                var localSymbol = element.kind === 275 && element.propertyName ? checker.getExportSpecifierLocalTargetSymbol(element) : checker.getSymbolAtLocation(name);
                addSearch(name, localSymbol);
              }
            }
          }
          function isNameMatch(name) {
            return name === exportSymbol.escapedName || exportKind !== 0 && name === "default";
          }
        }
        function findNamespaceReExports(sourceFileLike, name, checker) {
          var namespaceImportSymbol = checker.getSymbolAtLocation(name);
          return !!forEachPossibleImportOrExportStatement(sourceFileLike, function(statement) {
            if (!ts3.isExportDeclaration(statement))
              return;
            var exportClause = statement.exportClause, moduleSpecifier = statement.moduleSpecifier;
            return !moduleSpecifier && exportClause && ts3.isNamedExports(exportClause) && exportClause.elements.some(function(element) {
              return checker.getExportSpecifierLocalTargetSymbol(element) === namespaceImportSymbol;
            });
          });
        }
        function findModuleReferences(program2, sourceFiles, searchModuleSymbol) {
          var refs = [];
          var checker = program2.getTypeChecker();
          for (var _i = 0, sourceFiles_1 = sourceFiles; _i < sourceFiles_1.length; _i++) {
            var referencingFile = sourceFiles_1[_i];
            var searchSourceFile = searchModuleSymbol.valueDeclaration;
            if ((searchSourceFile === null || searchSourceFile === void 0 ? void 0 : searchSourceFile.kind) === 305) {
              for (var _a = 0, _b = referencingFile.referencedFiles; _a < _b.length; _a++) {
                var ref = _b[_a];
                if (program2.getSourceFileFromReference(referencingFile, ref) === searchSourceFile) {
                  refs.push({ kind: "reference", referencingFile, ref });
                }
              }
              for (var _c = 0, _d = referencingFile.typeReferenceDirectives; _c < _d.length; _c++) {
                var ref = _d[_c];
                var referenced = program2.getResolvedTypeReferenceDirectives().get(ref.fileName, ref.resolutionMode || referencingFile.impliedNodeFormat);
                if (referenced !== void 0 && referenced.resolvedFileName === searchSourceFile.fileName) {
                  refs.push({ kind: "reference", referencingFile, ref });
                }
              }
            }
            forEachImport(referencingFile, function(_importDecl, moduleSpecifier) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol === searchModuleSymbol) {
                refs.push({ kind: "import", literal: moduleSpecifier });
              }
            });
          }
          return refs;
        }
        FindAllReferences2.findModuleReferences = findModuleReferences;
        function getDirectImportsMap(sourceFiles, checker, cancellationToken) {
          var map2 = new ts3.Map();
          for (var _i = 0, sourceFiles_2 = sourceFiles; _i < sourceFiles_2.length; _i++) {
            var sourceFile = sourceFiles_2[_i];
            if (cancellationToken)
              cancellationToken.throwIfCancellationRequested();
            forEachImport(sourceFile, function(importDecl, moduleSpecifier) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol) {
                var id = ts3.getSymbolId(moduleSymbol).toString();
                var imports = map2.get(id);
                if (!imports) {
                  map2.set(id, imports = []);
                }
                imports.push(importDecl);
              }
            });
          }
          return map2;
        }
        function forEachPossibleImportOrExportStatement(sourceFileLike, action) {
          return ts3.forEach(sourceFileLike.kind === 305 ? sourceFileLike.statements : sourceFileLike.body.statements, function(statement) {
            return action(statement) || isAmbientModuleDeclaration(statement) && ts3.forEach(statement.body && statement.body.statements, action);
          });
        }
        function forEachImport(sourceFile, action) {
          if (sourceFile.externalModuleIndicator || sourceFile.imports !== void 0) {
            for (var _i = 0, _a = sourceFile.imports; _i < _a.length; _i++) {
              var i = _a[_i];
              action(ts3.importFromModuleSpecifier(i), i);
            }
          } else {
            forEachPossibleImportOrExportStatement(sourceFile, function(statement) {
              switch (statement.kind) {
                case 272:
                case 266: {
                  var decl = statement;
                  if (decl.moduleSpecifier && ts3.isStringLiteral(decl.moduleSpecifier)) {
                    action(decl, decl.moduleSpecifier);
                  }
                  break;
                }
                case 265: {
                  var decl = statement;
                  if (isExternalModuleImportEquals(decl)) {
                    action(decl, decl.moduleReference.expression);
                  }
                  break;
                }
              }
            });
          }
        }
        function getImportOrExportSymbol(node, symbol, checker, comingFromExport) {
          return comingFromExport ? getExport() : getExport() || getImport();
          function getExport() {
            var _a;
            var parent = node.parent;
            var grandparent = parent.parent;
            if (symbol.exportSymbol) {
              if (parent.kind === 206) {
                return ((_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.some(function(d) {
                  return d === parent;
                })) && ts3.isBinaryExpression(grandparent) ? getSpecialPropertyExport(grandparent, false) : void 0;
              } else {
                return exportInfo(symbol.exportSymbol, getExportKindForDeclaration(parent));
              }
            } else {
              var exportNode = getExportNode(parent, node);
              if (exportNode && ts3.hasSyntacticModifier(exportNode, 1)) {
                if (ts3.isImportEqualsDeclaration(exportNode) && exportNode.moduleReference === node) {
                  if (comingFromExport) {
                    return void 0;
                  }
                  var lhsSymbol = checker.getSymbolAtLocation(exportNode.name);
                  return { kind: 0, symbol: lhsSymbol };
                } else {
                  return exportInfo(symbol, getExportKindForDeclaration(exportNode));
                }
              } else if (ts3.isNamespaceExport(parent)) {
                return exportInfo(symbol, 0);
              } else if (ts3.isExportAssignment(parent)) {
                return getExportAssignmentExport(parent);
              } else if (ts3.isExportAssignment(grandparent)) {
                return getExportAssignmentExport(grandparent);
              } else if (ts3.isBinaryExpression(parent)) {
                return getSpecialPropertyExport(parent, true);
              } else if (ts3.isBinaryExpression(grandparent)) {
                return getSpecialPropertyExport(grandparent, true);
              } else if (ts3.isJSDocTypedefTag(parent)) {
                return exportInfo(symbol, 0);
              }
            }
            function getExportAssignmentExport(ex) {
              if (!ex.symbol.parent)
                return void 0;
              var exportKind = ex.isExportEquals ? 2 : 1;
              return { kind: 1, symbol, exportInfo: { exportingModuleSymbol: ex.symbol.parent, exportKind } };
            }
            function getSpecialPropertyExport(node2, useLhsSymbol) {
              var kind;
              switch (ts3.getAssignmentDeclarationKind(node2)) {
                case 1:
                  kind = 0;
                  break;
                case 2:
                  kind = 2;
                  break;
                default:
                  return void 0;
              }
              var sym = useLhsSymbol ? checker.getSymbolAtLocation(ts3.getNameOfAccessExpression(ts3.cast(node2.left, ts3.isAccessExpression))) : symbol;
              return sym && exportInfo(sym, kind);
            }
          }
          function getImport() {
            var isImport = isNodeImport(node);
            if (!isImport)
              return void 0;
            var importedSymbol = checker.getImmediateAliasedSymbol(symbol);
            if (!importedSymbol)
              return void 0;
            importedSymbol = skipExportSpecifierSymbol(importedSymbol, checker);
            if (importedSymbol.escapedName === "export=") {
              importedSymbol = getExportEqualsLocalSymbol(importedSymbol, checker);
            }
            var importedName = ts3.symbolEscapedNameNoDefault(importedSymbol);
            if (importedName === void 0 || importedName === "default" || importedName === symbol.escapedName) {
              return { kind: 0, symbol: importedSymbol };
            }
          }
          function exportInfo(symbol2, kind) {
            var exportInfo2 = getExportInfo(symbol2, kind, checker);
            return exportInfo2 && { kind: 1, symbol: symbol2, exportInfo: exportInfo2 };
          }
          function getExportKindForDeclaration(node2) {
            return ts3.hasSyntacticModifier(node2, 512) ? 1 : 0;
          }
        }
        FindAllReferences2.getImportOrExportSymbol = getImportOrExportSymbol;
        function getExportEqualsLocalSymbol(importedSymbol, checker) {
          if (importedSymbol.flags & 2097152) {
            return ts3.Debug.checkDefined(checker.getImmediateAliasedSymbol(importedSymbol));
          }
          var decl = ts3.Debug.checkDefined(importedSymbol.valueDeclaration);
          if (ts3.isExportAssignment(decl)) {
            return ts3.Debug.checkDefined(decl.expression.symbol);
          } else if (ts3.isBinaryExpression(decl)) {
            return ts3.Debug.checkDefined(decl.right.symbol);
          } else if (ts3.isSourceFile(decl)) {
            return ts3.Debug.checkDefined(decl.symbol);
          }
          return ts3.Debug.fail();
        }
        function getExportNode(parent, node) {
          var declaration = ts3.isVariableDeclaration(parent) ? parent : ts3.isBindingElement(parent) ? ts3.walkUpBindingElementsAndPatterns(parent) : void 0;
          if (declaration) {
            return parent.name !== node ? void 0 : ts3.isCatchClause(declaration.parent) ? void 0 : ts3.isVariableStatement(declaration.parent.parent) ? declaration.parent.parent : void 0;
          } else {
            return parent;
          }
        }
        function isNodeImport(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 265:
              return parent.name === node && isExternalModuleImportEquals(parent);
            case 270:
              return !parent.propertyName;
            case 267:
            case 268:
              ts3.Debug.assert(parent.name === node);
              return true;
            case 203:
              return ts3.isInJSFile(node) && ts3.isVariableDeclarationInitializedToBareOrAccessedRequire(parent.parent.parent);
            default:
              return false;
          }
        }
        function getExportInfo(exportSymbol, exportKind, checker) {
          var moduleSymbol = exportSymbol.parent;
          if (!moduleSymbol)
            return void 0;
          var exportingModuleSymbol = checker.getMergedSymbol(moduleSymbol);
          return ts3.isExternalModuleSymbol(exportingModuleSymbol) ? { exportingModuleSymbol, exportKind } : void 0;
        }
        FindAllReferences2.getExportInfo = getExportInfo;
        function skipExportSpecifierSymbol(symbol, checker) {
          if (symbol.declarations) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (ts3.isExportSpecifier(declaration) && !declaration.propertyName && !declaration.parent.parent.moduleSpecifier) {
                return checker.getExportSpecifierLocalTargetSymbol(declaration);
              } else if (ts3.isPropertyAccessExpression(declaration) && ts3.isModuleExportsAccessExpression(declaration.expression) && !ts3.isPrivateIdentifier(declaration.name)) {
                return checker.getSymbolAtLocation(declaration);
              } else if (ts3.isShorthandPropertyAssignment(declaration) && ts3.isBinaryExpression(declaration.parent.parent) && ts3.getAssignmentDeclarationKind(declaration.parent.parent) === 2) {
                return checker.getExportSpecifierLocalTargetSymbol(declaration.name);
              }
            }
          }
          return symbol;
        }
        function getContainingModuleSymbol(importer, checker) {
          return checker.getMergedSymbol(getSourceFileLikeForImportDeclaration(importer).symbol);
        }
        function getSourceFileLikeForImportDeclaration(node) {
          if (node.kind === 208) {
            return node.getSourceFile();
          }
          var parent = node.parent;
          if (parent.kind === 305) {
            return parent;
          }
          ts3.Debug.assert(parent.kind === 262);
          return ts3.cast(parent.parent, isAmbientModuleDeclaration);
        }
        function isAmbientModuleDeclaration(node) {
          return node.kind === 261 && node.name.kind === 10;
        }
        function isExternalModuleImportEquals(eq) {
          return eq.moduleReference.kind === 277 && eq.moduleReference.expression.kind === 10;
        }
      })(FindAllReferences = ts3.FindAllReferences || (ts3.FindAllReferences = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var FindAllReferences;
      (function(FindAllReferences2) {
        var DefinitionKind;
        (function(DefinitionKind2) {
          DefinitionKind2[DefinitionKind2["Symbol"] = 0] = "Symbol";
          DefinitionKind2[DefinitionKind2["Label"] = 1] = "Label";
          DefinitionKind2[DefinitionKind2["Keyword"] = 2] = "Keyword";
          DefinitionKind2[DefinitionKind2["This"] = 3] = "This";
          DefinitionKind2[DefinitionKind2["String"] = 4] = "String";
          DefinitionKind2[DefinitionKind2["TripleSlashReference"] = 5] = "TripleSlashReference";
        })(DefinitionKind = FindAllReferences2.DefinitionKind || (FindAllReferences2.DefinitionKind = {}));
        var EntryKind;
        (function(EntryKind2) {
          EntryKind2[EntryKind2["Span"] = 0] = "Span";
          EntryKind2[EntryKind2["Node"] = 1] = "Node";
          EntryKind2[EntryKind2["StringLiteral"] = 2] = "StringLiteral";
          EntryKind2[EntryKind2["SearchedLocalFoundProperty"] = 3] = "SearchedLocalFoundProperty";
          EntryKind2[EntryKind2["SearchedPropertyFoundLocal"] = 4] = "SearchedPropertyFoundLocal";
        })(EntryKind = FindAllReferences2.EntryKind || (FindAllReferences2.EntryKind = {}));
        function nodeEntry(node, kind) {
          if (kind === void 0) {
            kind = 1;
          }
          return {
            kind,
            node: node.name || node,
            context: getContextNodeForNodeEntry(node)
          };
        }
        FindAllReferences2.nodeEntry = nodeEntry;
        function isContextWithStartAndEndNode(node) {
          return node && node.kind === void 0;
        }
        FindAllReferences2.isContextWithStartAndEndNode = isContextWithStartAndEndNode;
        function getContextNodeForNodeEntry(node) {
          if (ts3.isDeclaration(node)) {
            return getContextNode(node);
          }
          if (!node.parent)
            return void 0;
          if (!ts3.isDeclaration(node.parent) && !ts3.isExportAssignment(node.parent)) {
            if (ts3.isInJSFile(node)) {
              var binaryExpression = ts3.isBinaryExpression(node.parent) ? node.parent : ts3.isAccessExpression(node.parent) && ts3.isBinaryExpression(node.parent.parent) && node.parent.parent.left === node.parent ? node.parent.parent : void 0;
              if (binaryExpression && ts3.getAssignmentDeclarationKind(binaryExpression) !== 0) {
                return getContextNode(binaryExpression);
              }
            }
            if (ts3.isJsxOpeningElement(node.parent) || ts3.isJsxClosingElement(node.parent)) {
              return node.parent.parent;
            } else if (ts3.isJsxSelfClosingElement(node.parent) || ts3.isLabeledStatement(node.parent) || ts3.isBreakOrContinueStatement(node.parent)) {
              return node.parent;
            } else if (ts3.isStringLiteralLike(node)) {
              var validImport = ts3.tryGetImportFromModuleSpecifier(node);
              if (validImport) {
                var declOrStatement = ts3.findAncestor(validImport, function(node2) {
                  return ts3.isDeclaration(node2) || ts3.isStatement(node2) || ts3.isJSDocTag(node2);
                });
                return ts3.isDeclaration(declOrStatement) ? getContextNode(declOrStatement) : declOrStatement;
              }
            }
            var propertyName = ts3.findAncestor(node, ts3.isComputedPropertyName);
            return propertyName ? getContextNode(propertyName.parent) : void 0;
          }
          if (node.parent.name === node || ts3.isConstructorDeclaration(node.parent) || ts3.isExportAssignment(node.parent) || (ts3.isImportOrExportSpecifier(node.parent) || ts3.isBindingElement(node.parent)) && node.parent.propertyName === node || node.kind === 88 && ts3.hasSyntacticModifier(node.parent, 513)) {
            return getContextNode(node.parent);
          }
          return void 0;
        }
        function getContextNode(node) {
          if (!node)
            return void 0;
          switch (node.kind) {
            case 254:
              return !ts3.isVariableDeclarationList(node.parent) || node.parent.declarations.length !== 1 ? node : ts3.isVariableStatement(node.parent.parent) ? node.parent.parent : ts3.isForInOrOfStatement(node.parent.parent) ? getContextNode(node.parent.parent) : node.parent;
            case 203:
              return getContextNode(node.parent.parent);
            case 270:
              return node.parent.parent.parent;
            case 275:
            case 268:
              return node.parent.parent;
            case 267:
            case 274:
              return node.parent;
            case 221:
              return ts3.isExpressionStatement(node.parent) ? node.parent : node;
            case 244:
            case 243:
              return {
                start: node.initializer,
                end: node.expression
              };
            case 296:
            case 297:
              return ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent) ? getContextNode(ts3.findAncestor(node.parent, function(node2) {
                return ts3.isBinaryExpression(node2) || ts3.isForInOrOfStatement(node2);
              })) : node;
            default:
              return node;
          }
        }
        FindAllReferences2.getContextNode = getContextNode;
        function toContextSpan(textSpan, sourceFile, context) {
          if (!context)
            return void 0;
          var contextSpan = isContextWithStartAndEndNode(context) ? getTextSpan(context.start, sourceFile, context.end) : getTextSpan(context, sourceFile);
          return contextSpan.start !== textSpan.start || contextSpan.length !== textSpan.length ? { contextSpan } : void 0;
        }
        FindAllReferences2.toContextSpan = toContextSpan;
        var FindReferencesUse;
        (function(FindReferencesUse2) {
          FindReferencesUse2[FindReferencesUse2["Other"] = 0] = "Other";
          FindReferencesUse2[FindReferencesUse2["References"] = 1] = "References";
          FindReferencesUse2[FindReferencesUse2["Rename"] = 2] = "Rename";
        })(FindReferencesUse = FindAllReferences2.FindReferencesUse || (FindAllReferences2.FindReferencesUse = {}));
        function findReferencedSymbols(program2, cancellationToken, sourceFiles, sourceFile, position) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          var options = { use: 1 };
          var referencedSymbols = Core.getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options);
          var checker = program2.getTypeChecker();
          var adjustedNode = Core.getAdjustedNode(node, options);
          var symbol = isDefinitionForReference(adjustedNode) ? checker.getSymbolAtLocation(adjustedNode) : void 0;
          return !referencedSymbols || !referencedSymbols.length ? void 0 : ts3.mapDefined(referencedSymbols, function(_a) {
            var definition = _a.definition, references = _a.references;
            return definition && {
              definition: checker.runWithCancellationToken(cancellationToken, function(checker2) {
                return definitionToReferencedSymbolDefinitionInfo(definition, checker2, node);
              }),
              references: references.map(function(r) {
                return toReferencedSymbolEntry(r, symbol);
              })
            };
          });
        }
        FindAllReferences2.findReferencedSymbols = findReferencedSymbols;
        function isDefinitionForReference(node) {
          return node.kind === 88 || !!ts3.getDeclarationFromName(node) || ts3.isLiteralComputedPropertyDeclarationName(node) || node.kind === 134 && ts3.isConstructorDeclaration(node.parent);
        }
        function getImplementationsAtPosition(program2, cancellationToken, sourceFiles, sourceFile, position) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          var referenceEntries;
          var entries = getImplementationReferenceEntries(program2, cancellationToken, sourceFiles, node, position);
          if (node.parent.kind === 206 || node.parent.kind === 203 || node.parent.kind === 207 || node.kind === 106) {
            referenceEntries = entries && __spreadArray([], entries, true);
          } else {
            var queue = entries && __spreadArray([], entries, true);
            var seenNodes = new ts3.Map();
            while (queue && queue.length) {
              var entry = queue.shift();
              if (!ts3.addToSeen(seenNodes, ts3.getNodeId(entry.node))) {
                continue;
              }
              referenceEntries = ts3.append(referenceEntries, entry);
              var entries_1 = getImplementationReferenceEntries(program2, cancellationToken, sourceFiles, entry.node, entry.node.pos);
              if (entries_1) {
                queue.push.apply(queue, entries_1);
              }
            }
          }
          var checker = program2.getTypeChecker();
          return ts3.map(referenceEntries, function(entry2) {
            return toImplementationLocation(entry2, checker);
          });
        }
        FindAllReferences2.getImplementationsAtPosition = getImplementationsAtPosition;
        function getImplementationReferenceEntries(program2, cancellationToken, sourceFiles, node, position) {
          if (node.kind === 305) {
            return void 0;
          }
          var checker = program2.getTypeChecker();
          if (node.parent.kind === 297) {
            var result_2 = [];
            Core.getReferenceEntriesForShorthandPropertyAssignment(node, checker, function(node2) {
              return result_2.push(nodeEntry(node2));
            });
            return result_2;
          } else if (node.kind === 106 || ts3.isSuperProperty(node.parent)) {
            var symbol = checker.getSymbolAtLocation(node);
            return symbol.valueDeclaration && [nodeEntry(symbol.valueDeclaration)];
          } else {
            return getReferenceEntriesForNode(position, node, program2, sourceFiles, cancellationToken, { implementations: true, use: 1 });
          }
        }
        function findReferenceOrRenameEntries(program2, cancellationToken, sourceFiles, node, position, options, convertEntry) {
          return ts3.map(flattenEntries(Core.getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options)), function(entry) {
            return convertEntry(entry, node, program2.getTypeChecker());
          });
        }
        FindAllReferences2.findReferenceOrRenameEntries = findReferenceOrRenameEntries;
        function getReferenceEntriesForNode(position, node, program2, sourceFiles, cancellationToken, options, sourceFilesSet) {
          if (options === void 0) {
            options = {};
          }
          if (sourceFilesSet === void 0) {
            sourceFilesSet = new ts3.Set(sourceFiles.map(function(f) {
              return f.fileName;
            }));
          }
          return flattenEntries(Core.getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options, sourceFilesSet));
        }
        FindAllReferences2.getReferenceEntriesForNode = getReferenceEntriesForNode;
        function flattenEntries(referenceSymbols) {
          return referenceSymbols && ts3.flatMap(referenceSymbols, function(r) {
            return r.references;
          });
        }
        function definitionToReferencedSymbolDefinitionInfo(def, checker, originalNode) {
          var info = function() {
            switch (def.type) {
              case 0: {
                var symbol = def.symbol;
                var _a = getDefinitionKindAndDisplayParts(symbol, checker, originalNode), displayParts_1 = _a.displayParts, kind_1 = _a.kind;
                var name_1 = displayParts_1.map(function(p) {
                  return p.text;
                }).join("");
                var declaration = symbol.declarations && ts3.firstOrUndefined(symbol.declarations);
                var node = declaration ? ts3.getNameOfDeclaration(declaration) || declaration : originalNode;
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: name_1, kind: kind_1, displayParts: displayParts_1, context: getContextNode(declaration) });
              }
              case 1: {
                var node = def.node;
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: node.text, kind: "label", displayParts: [ts3.displayPart(node.text, ts3.SymbolDisplayPartKind.text)] });
              }
              case 2: {
                var node = def.node;
                var name_2 = ts3.tokenToString(node.kind);
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: name_2, kind: "keyword", displayParts: [{ text: name_2, kind: "keyword" }] });
              }
              case 3: {
                var node = def.node;
                var symbol = checker.getSymbolAtLocation(node);
                var displayParts_2 = symbol && ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, node.getSourceFile(), ts3.getContainerNode(node), node).displayParts || [ts3.textPart("this")];
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: "this", kind: "var", displayParts: displayParts_2 });
              }
              case 4: {
                var node = def.node;
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: node.text, kind: "var", displayParts: [ts3.displayPart(ts3.getTextOfNode(node), ts3.SymbolDisplayPartKind.stringLiteral)] });
              }
              case 5: {
                return {
                  textSpan: ts3.createTextSpanFromRange(def.reference),
                  sourceFile: def.file,
                  name: def.reference.fileName,
                  kind: "string",
                  displayParts: [ts3.displayPart('"'.concat(def.reference.fileName, '"'), ts3.SymbolDisplayPartKind.stringLiteral)]
                };
              }
              default:
                return ts3.Debug.assertNever(def);
            }
          }();
          var sourceFile = info.sourceFile, textSpan = info.textSpan, name = info.name, kind = info.kind, displayParts = info.displayParts, context = info.context;
          return __assign({ containerKind: "", containerName: "", fileName: sourceFile.fileName, kind, name, textSpan, displayParts }, toContextSpan(textSpan, sourceFile, context));
        }
        function getFileAndTextSpanFromNode(node) {
          var sourceFile = node.getSourceFile();
          return {
            sourceFile,
            textSpan: getTextSpan(ts3.isComputedPropertyName(node) ? node.expression : node, sourceFile)
          };
        }
        function getDefinitionKindAndDisplayParts(symbol, checker, node) {
          var meaning = Core.getIntersectingMeaningFromDeclarations(node, symbol);
          var enclosingDeclaration = symbol.declarations && ts3.firstOrUndefined(symbol.declarations) || node;
          var _a = ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, enclosingDeclaration.getSourceFile(), enclosingDeclaration, enclosingDeclaration, meaning), displayParts = _a.displayParts, symbolKind = _a.symbolKind;
          return { displayParts, kind: symbolKind };
        }
        function toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixText) {
          return __assign(__assign({}, entryToDocumentSpan(entry)), providePrefixAndSuffixText && getPrefixAndSuffixText(entry, originalNode, checker));
        }
        FindAllReferences2.toRenameLocation = toRenameLocation;
        function toReferencedSymbolEntry(entry, symbol) {
          var referenceEntry = toReferenceEntry(entry);
          if (!symbol)
            return referenceEntry;
          return __assign(__assign({}, referenceEntry), { isDefinition: entry.kind !== 0 && isDeclarationOfSymbol(entry.node, symbol) });
        }
        function toReferenceEntry(entry) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind === 0) {
            return __assign(__assign({}, documentSpan), { isWriteAccess: false });
          }
          var kind = entry.kind, node = entry.node;
          return __assign(__assign({}, documentSpan), { isWriteAccess: isWriteAccessForReference(node), isInString: kind === 2 ? true : void 0 });
        }
        FindAllReferences2.toReferenceEntry = toReferenceEntry;
        function entryToDocumentSpan(entry) {
          if (entry.kind === 0) {
            return { textSpan: entry.textSpan, fileName: entry.fileName };
          } else {
            var sourceFile = entry.node.getSourceFile();
            var textSpan = getTextSpan(entry.node, sourceFile);
            return __assign({ textSpan, fileName: sourceFile.fileName }, toContextSpan(textSpan, sourceFile, entry.context));
          }
        }
        function getPrefixAndSuffixText(entry, originalNode, checker) {
          if (entry.kind !== 0 && ts3.isIdentifier(originalNode)) {
            var node = entry.node, kind = entry.kind;
            var parent = node.parent;
            var name = originalNode.text;
            var isShorthandAssignment = ts3.isShorthandPropertyAssignment(parent);
            if (isShorthandAssignment || ts3.isObjectBindingElementWithoutPropertyName(parent) && parent.name === node && parent.dotDotDotToken === void 0) {
              var prefixColon = { prefixText: name + ": " };
              var suffixColon = { suffixText: ": " + name };
              if (kind === 3) {
                return prefixColon;
              }
              if (kind === 4) {
                return suffixColon;
              }
              if (isShorthandAssignment) {
                var grandParent = parent.parent;
                if (ts3.isObjectLiteralExpression(grandParent) && ts3.isBinaryExpression(grandParent.parent) && ts3.isModuleExportsAccessExpression(grandParent.parent.left)) {
                  return prefixColon;
                }
                return suffixColon;
              } else {
                return prefixColon;
              }
            } else if (ts3.isImportSpecifier(parent) && !parent.propertyName) {
              var originalSymbol = ts3.isExportSpecifier(originalNode.parent) ? checker.getExportSpecifierLocalTargetSymbol(originalNode.parent) : checker.getSymbolAtLocation(originalNode);
              return ts3.contains(originalSymbol.declarations, parent) ? { prefixText: name + " as " } : ts3.emptyOptions;
            } else if (ts3.isExportSpecifier(parent) && !parent.propertyName) {
              return originalNode === entry.node || checker.getSymbolAtLocation(originalNode) === checker.getSymbolAtLocation(entry.node) ? { prefixText: name + " as " } : { suffixText: " as " + name };
            }
          }
          return ts3.emptyOptions;
        }
        function toImplementationLocation(entry, checker) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind !== 0) {
            var node = entry.node;
            return __assign(__assign({}, documentSpan), implementationKindDisplayParts(node, checker));
          } else {
            return __assign(__assign({}, documentSpan), { kind: "", displayParts: [] });
          }
        }
        function implementationKindDisplayParts(node, checker) {
          var symbol = checker.getSymbolAtLocation(ts3.isDeclaration(node) && node.name ? node.name : node);
          if (symbol) {
            return getDefinitionKindAndDisplayParts(symbol, checker, node);
          } else if (node.kind === 205) {
            return {
              kind: "interface",
              displayParts: [ts3.punctuationPart(20), ts3.textPart("object literal"), ts3.punctuationPart(21)]
            };
          } else if (node.kind === 226) {
            return {
              kind: "local class",
              displayParts: [ts3.punctuationPart(20), ts3.textPart("anonymous local class"), ts3.punctuationPart(21)]
            };
          } else {
            return { kind: ts3.getNodeKind(node), displayParts: [] };
          }
        }
        function toHighlightSpan(entry) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind === 0) {
            return {
              fileName: documentSpan.fileName,
              span: {
                textSpan: documentSpan.textSpan,
                kind: "reference"
              }
            };
          }
          var writeAccess = isWriteAccessForReference(entry.node);
          var span = __assign({ textSpan: documentSpan.textSpan, kind: writeAccess ? "writtenReference" : "reference", isInString: entry.kind === 2 ? true : void 0 }, documentSpan.contextSpan && { contextSpan: documentSpan.contextSpan });
          return { fileName: documentSpan.fileName, span };
        }
        FindAllReferences2.toHighlightSpan = toHighlightSpan;
        function getTextSpan(node, sourceFile, endNode) {
          var start = node.getStart(sourceFile);
          var end = (endNode || node).getEnd();
          if (ts3.isStringLiteralLike(node) && end - start > 2) {
            ts3.Debug.assert(endNode === void 0);
            start += 1;
            end -= 1;
          }
          return ts3.createTextSpanFromBounds(start, end);
        }
        function getTextSpanOfEntry(entry) {
          return entry.kind === 0 ? entry.textSpan : getTextSpan(entry.node, entry.node.getSourceFile());
        }
        FindAllReferences2.getTextSpanOfEntry = getTextSpanOfEntry;
        function isWriteAccessForReference(node) {
          var decl = ts3.getDeclarationFromName(node);
          return !!decl && declarationIsWriteAccess(decl) || node.kind === 88 || ts3.isWriteAccess(node);
        }
        function isDeclarationOfSymbol(node, target) {
          var _a;
          if (!target)
            return false;
          var source = ts3.getDeclarationFromName(node) || (node.kind === 88 ? node.parent : ts3.isLiteralComputedPropertyDeclarationName(node) ? node.parent.parent : node.kind === 134 && ts3.isConstructorDeclaration(node.parent) ? node.parent.parent : void 0);
          var commonjsSource = source && ts3.isBinaryExpression(source) ? source.left : void 0;
          return !!(source && ((_a = target.declarations) === null || _a === void 0 ? void 0 : _a.some(function(d) {
            return d === source || d === commonjsSource;
          })));
        }
        function declarationIsWriteAccess(decl) {
          if (!!(decl.flags & 16777216))
            return true;
          switch (decl.kind) {
            case 221:
            case 203:
            case 257:
            case 226:
            case 88:
            case 260:
            case 299:
            case 275:
            case 267:
            case 265:
            case 270:
            case 258:
            case 338:
            case 345:
            case 285:
            case 261:
            case 264:
            case 268:
            case 274:
            case 164:
            case 297:
            case 259:
            case 163:
              return true;
            case 296:
              return !ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(decl.parent);
            case 256:
            case 213:
            case 171:
            case 169:
            case 172:
            case 173:
              return !!decl.body;
            case 254:
            case 167:
              return !!decl.initializer || ts3.isCatchClause(decl.parent);
            case 168:
            case 166:
            case 347:
            case 340:
              return false;
            default:
              return ts3.Debug.failBadSyntaxKind(decl);
          }
        }
        var Core;
        (function(Core2) {
          function getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options, sourceFilesSet) {
            var _a, _b;
            if (options === void 0) {
              options = {};
            }
            if (sourceFilesSet === void 0) {
              sourceFilesSet = new ts3.Set(sourceFiles.map(function(f) {
                return f.fileName;
              }));
            }
            node = getAdjustedNode(node, options);
            if (ts3.isSourceFile(node)) {
              var resolvedRef = ts3.GoToDefinition.getReferenceAtPosition(node, position, program2);
              if (!(resolvedRef === null || resolvedRef === void 0 ? void 0 : resolvedRef.file)) {
                return void 0;
              }
              var moduleSymbol = program2.getTypeChecker().getMergedSymbol(resolvedRef.file.symbol);
              if (moduleSymbol) {
                return getReferencedSymbolsForModule(program2, moduleSymbol, false, sourceFiles, sourceFilesSet);
              }
              var fileIncludeReasons = program2.getFileIncludeReasons();
              if (!fileIncludeReasons) {
                return void 0;
              }
              return [{
                definition: { type: 5, reference: resolvedRef.reference, file: node },
                references: getReferencesForNonModule(resolvedRef.file, fileIncludeReasons, program2) || ts3.emptyArray
              }];
            }
            if (!options.implementations) {
              var special = getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken);
              if (special) {
                return special;
              }
            }
            var checker = program2.getTypeChecker();
            var symbol = checker.getSymbolAtLocation(ts3.isConstructorDeclaration(node) && node.parent.name || node);
            if (!symbol) {
              if (!options.implementations && ts3.isStringLiteralLike(node)) {
                if (ts3.isModuleSpecifierLike(node)) {
                  var fileIncludeReasons = program2.getFileIncludeReasons();
                  var referencedFileName = (_b = (_a = node.getSourceFile().resolvedModules) === null || _a === void 0 ? void 0 : _a.get(node.text, ts3.getModeForUsageLocation(node.getSourceFile(), node))) === null || _b === void 0 ? void 0 : _b.resolvedFileName;
                  var referencedFile = referencedFileName ? program2.getSourceFile(referencedFileName) : void 0;
                  if (referencedFile) {
                    return [{ definition: { type: 4, node }, references: getReferencesForNonModule(referencedFile, fileIncludeReasons, program2) || ts3.emptyArray }];
                  }
                }
                return getReferencesForStringLiteral(node, sourceFiles, checker, cancellationToken);
              }
              return void 0;
            }
            if (symbol.escapedName === "export=") {
              return getReferencedSymbolsForModule(program2, symbol.parent, false, sourceFiles, sourceFilesSet);
            }
            var moduleReferences = getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program2, sourceFiles, cancellationToken, options, sourceFilesSet);
            if (moduleReferences && !(symbol.flags & 33554432)) {
              return moduleReferences;
            }
            var aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker);
            var moduleReferencesOfExportTarget = aliasedSymbol && getReferencedSymbolsForModuleIfDeclaredBySourceFile(aliasedSymbol, program2, sourceFiles, cancellationToken, options, sourceFilesSet);
            var references = getReferencedSymbolsForSymbol(symbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options);
            return mergeReferences(program2, moduleReferences, references, moduleReferencesOfExportTarget);
          }
          Core2.getReferencedSymbolsForNode = getReferencedSymbolsForNode;
          function getAdjustedNode(node, options) {
            if (options.use === 1) {
              node = ts3.getAdjustedReferenceLocation(node);
            } else if (options.use === 2) {
              node = ts3.getAdjustedRenameLocation(node);
            }
            return node;
          }
          Core2.getAdjustedNode = getAdjustedNode;
          function getReferencesForFileName(fileName2, program2, sourceFiles, sourceFilesSet) {
            var _a, _b;
            if (sourceFilesSet === void 0) {
              sourceFilesSet = new ts3.Set(sourceFiles.map(function(f) {
                return f.fileName;
              }));
            }
            var moduleSymbol = (_a = program2.getSourceFile(fileName2)) === null || _a === void 0 ? void 0 : _a.symbol;
            if (moduleSymbol) {
              return ((_b = getReferencedSymbolsForModule(program2, moduleSymbol, false, sourceFiles, sourceFilesSet)[0]) === null || _b === void 0 ? void 0 : _b.references) || ts3.emptyArray;
            }
            var fileIncludeReasons = program2.getFileIncludeReasons();
            var referencedFile = program2.getSourceFile(fileName2);
            return referencedFile && fileIncludeReasons && getReferencesForNonModule(referencedFile, fileIncludeReasons, program2) || ts3.emptyArray;
          }
          Core2.getReferencesForFileName = getReferencesForFileName;
          function getReferencesForNonModule(referencedFile, refFileMap, program2) {
            var entries;
            var references = refFileMap.get(referencedFile.path) || ts3.emptyArray;
            for (var _i = 0, references_1 = references; _i < references_1.length; _i++) {
              var ref = references_1[_i];
              if (ts3.isReferencedFile(ref)) {
                var referencingFile = program2.getSourceFileByPath(ref.file);
                var location = ts3.getReferencedFileLocation(program2.getSourceFileByPath, ref);
                if (ts3.isReferenceFileLocation(location)) {
                  entries = ts3.append(entries, {
                    kind: 0,
                    fileName: referencingFile.fileName,
                    textSpan: ts3.createTextSpanFromRange(location)
                  });
                }
              }
            }
            return entries;
          }
          function getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker) {
            if (node.parent && ts3.isNamespaceExportDeclaration(node.parent)) {
              var aliasedSymbol = checker.getAliasedSymbol(symbol);
              var targetSymbol = checker.getMergedSymbol(aliasedSymbol);
              if (aliasedSymbol !== targetSymbol) {
                return targetSymbol;
              }
            }
            return void 0;
          }
          function getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program2, sourceFiles, cancellationToken, options, sourceFilesSet) {
            var moduleSourceFile = symbol.flags & 1536 && symbol.declarations && ts3.find(symbol.declarations, ts3.isSourceFile);
            if (!moduleSourceFile)
              return void 0;
            var exportEquals = symbol.exports.get("export=");
            var moduleReferences = getReferencedSymbolsForModule(program2, symbol, !!exportEquals, sourceFiles, sourceFilesSet);
            if (!exportEquals || !sourceFilesSet.has(moduleSourceFile.fileName))
              return moduleReferences;
            var checker = program2.getTypeChecker();
            symbol = ts3.skipAlias(exportEquals, checker);
            return mergeReferences(program2, moduleReferences, getReferencedSymbolsForSymbol(symbol, void 0, sourceFiles, sourceFilesSet, checker, cancellationToken, options));
          }
          function mergeReferences(program2) {
            var referencesToMerge = [];
            for (var _i = 1; _i < arguments.length; _i++) {
              referencesToMerge[_i - 1] = arguments[_i];
            }
            var result2;
            for (var _a = 0, referencesToMerge_1 = referencesToMerge; _a < referencesToMerge_1.length; _a++) {
              var references = referencesToMerge_1[_a];
              if (!references || !references.length)
                continue;
              if (!result2) {
                result2 = references;
                continue;
              }
              var _loop_5 = function(entry2) {
                if (!entry2.definition || entry2.definition.type !== 0) {
                  result2.push(entry2);
                  return "continue";
                }
                var symbol = entry2.definition.symbol;
                var refIndex = ts3.findIndex(result2, function(ref) {
                  return !!ref.definition && ref.definition.type === 0 && ref.definition.symbol === symbol;
                });
                if (refIndex === -1) {
                  result2.push(entry2);
                  return "continue";
                }
                var reference = result2[refIndex];
                result2[refIndex] = {
                  definition: reference.definition,
                  references: reference.references.concat(entry2.references).sort(function(entry1, entry22) {
                    var entry1File = getSourceFileIndexOfEntry(program2, entry1);
                    var entry2File = getSourceFileIndexOfEntry(program2, entry22);
                    if (entry1File !== entry2File) {
                      return ts3.compareValues(entry1File, entry2File);
                    }
                    var entry1Span = getTextSpanOfEntry(entry1);
                    var entry2Span = getTextSpanOfEntry(entry22);
                    return entry1Span.start !== entry2Span.start ? ts3.compareValues(entry1Span.start, entry2Span.start) : ts3.compareValues(entry1Span.length, entry2Span.length);
                  })
                };
              };
              for (var _b = 0, references_2 = references; _b < references_2.length; _b++) {
                var entry = references_2[_b];
                _loop_5(entry);
              }
            }
            return result2;
          }
          function getSourceFileIndexOfEntry(program2, entry) {
            var sourceFile = entry.kind === 0 ? program2.getSourceFile(entry.fileName) : entry.node.getSourceFile();
            return program2.getSourceFiles().indexOf(sourceFile);
          }
          function getReferencedSymbolsForModule(program2, symbol, excludeImportTypeOfExportEquals, sourceFiles, sourceFilesSet) {
            ts3.Debug.assert(!!symbol.valueDeclaration);
            var references = ts3.mapDefined(FindAllReferences2.findModuleReferences(program2, sourceFiles, symbol), function(reference) {
              if (reference.kind === "import") {
                var parent = reference.literal.parent;
                if (ts3.isLiteralTypeNode(parent)) {
                  var importType = ts3.cast(parent.parent, ts3.isImportTypeNode);
                  if (excludeImportTypeOfExportEquals && !importType.qualifier) {
                    return void 0;
                  }
                }
                return nodeEntry(reference.literal);
              } else {
                return {
                  kind: 0,
                  fileName: reference.referencingFile.fileName,
                  textSpan: ts3.createTextSpanFromRange(reference.ref)
                };
              }
            });
            if (symbol.declarations) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var decl = _a[_i];
                switch (decl.kind) {
                  case 305:
                    break;
                  case 261:
                    if (sourceFilesSet.has(decl.getSourceFile().fileName)) {
                      references.push(nodeEntry(decl.name));
                    }
                    break;
                  default:
                    ts3.Debug.assert(!!(symbol.flags & 33554432), "Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.");
                }
              }
            }
            var exported = symbol.exports.get("export=");
            if (exported === null || exported === void 0 ? void 0 : exported.declarations) {
              for (var _b = 0, _c = exported.declarations; _b < _c.length; _b++) {
                var decl = _c[_b];
                var sourceFile = decl.getSourceFile();
                if (sourceFilesSet.has(sourceFile.fileName)) {
                  var node = ts3.isBinaryExpression(decl) && ts3.isPropertyAccessExpression(decl.left) ? decl.left.expression : ts3.isExportAssignment(decl) ? ts3.Debug.checkDefined(ts3.findChildOfKind(decl, 93, sourceFile)) : ts3.getNameOfDeclaration(decl) || decl;
                  references.push(nodeEntry(node));
                }
              }
            }
            return references.length ? [{ definition: { type: 0, symbol }, references }] : ts3.emptyArray;
          }
          function isReadonlyTypeOperator(node) {
            return node.kind === 145 && ts3.isTypeOperatorNode(node.parent) && node.parent.operator === 145;
          }
          function getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken) {
            if (ts3.isTypeKeyword(node.kind)) {
              if (node.kind === 114 && ts3.isVoidExpression(node.parent)) {
                return void 0;
              }
              if (node.kind === 145 && !isReadonlyTypeOperator(node)) {
                return void 0;
              }
              return getAllReferencesForKeyword(sourceFiles, node.kind, cancellationToken, node.kind === 145 ? isReadonlyTypeOperator : void 0);
            }
            if (ts3.isImportMeta(node.parent) && node.parent.name === node) {
              return getAllReferencesForImportMeta(sourceFiles, cancellationToken);
            }
            if (ts3.isStaticModifier(node) && ts3.isClassStaticBlockDeclaration(node.parent)) {
              return [{ definition: { type: 2, node }, references: [nodeEntry(node)] }];
            }
            if (ts3.isJumpStatementTarget(node)) {
              var labelDefinition = ts3.getTargetLabel(node.parent, node.text);
              return labelDefinition && getLabelReferencesInNode(labelDefinition.parent, labelDefinition);
            } else if (ts3.isLabelOfLabeledStatement(node)) {
              return getLabelReferencesInNode(node.parent, node);
            }
            if (ts3.isThis(node)) {
              return getReferencesForThisKeyword(node, sourceFiles, cancellationToken);
            }
            if (node.kind === 106) {
              return getReferencesForSuperKeyword(node);
            }
            return void 0;
          }
          function getReferencedSymbolsForSymbol(originalSymbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options) {
            var symbol = node && skipPastExportOrImportSpecifierOrUnion(originalSymbol, node, checker, !isForRenameWithPrefixAndSuffixText(options)) || originalSymbol;
            var searchMeaning = node ? getIntersectingMeaningFromDeclarations(node, symbol) : 7;
            var result2 = [];
            var state = new State2(sourceFiles, sourceFilesSet, node ? getSpecialSearchKind(node) : 0, checker, cancellationToken, searchMeaning, options, result2);
            var exportSpecifier = !isForRenameWithPrefixAndSuffixText(options) || !symbol.declarations ? void 0 : ts3.find(symbol.declarations, ts3.isExportSpecifier);
            if (exportSpecifier) {
              getReferencesAtExportSpecifier(exportSpecifier.name, symbol, exportSpecifier, state.createSearch(node, originalSymbol, void 0), state, true, true);
            } else if (node && node.kind === 88 && symbol.escapedName === "default" && symbol.parent) {
              addReference(node, symbol, state);
              searchForImportsOfExport(node, symbol, { exportingModuleSymbol: symbol.parent, exportKind: 1 }, state);
            } else {
              var search = state.createSearch(node, symbol, void 0, { allSearchSymbols: node ? populateSearchSymbolSet(symbol, node, checker, options.use === 2, !!options.providePrefixAndSuffixTextForRename, !!options.implementations) : [symbol] });
              getReferencesInContainerOrFiles(symbol, state, search);
            }
            return result2;
          }
          function getReferencesInContainerOrFiles(symbol, state, search) {
            var scope = getSymbolScope(symbol);
            if (scope) {
              getReferencesInContainer(scope, scope.getSourceFile(), search, state, !(ts3.isSourceFile(scope) && !ts3.contains(state.sourceFiles, scope)));
            } else {
              for (var _i = 0, _a = state.sourceFiles; _i < _a.length; _i++) {
                var sourceFile = _a[_i];
                state.cancellationToken.throwIfCancellationRequested();
                searchForName(sourceFile, search, state);
              }
            }
          }
          function getSpecialSearchKind(node) {
            switch (node.kind) {
              case 171:
              case 134:
                return 1;
              case 79:
                if (ts3.isClassLike(node.parent)) {
                  ts3.Debug.assert(node.parent.name === node);
                  return 2;
                }
              default:
                return 0;
            }
          }
          function skipPastExportOrImportSpecifierOrUnion(symbol, node, checker, useLocalSymbolForExportSpecifier) {
            var parent = node.parent;
            if (ts3.isExportSpecifier(parent) && useLocalSymbolForExportSpecifier) {
              return getLocalSymbolForExportSpecifier(node, symbol, parent, checker);
            }
            return ts3.firstDefined(symbol.declarations, function(decl) {
              if (!decl.parent) {
                if (symbol.flags & 33554432)
                  return void 0;
                ts3.Debug.fail("Unexpected symbol at ".concat(ts3.Debug.formatSyntaxKind(node.kind), ": ").concat(ts3.Debug.formatSymbol(symbol)));
              }
              return ts3.isTypeLiteralNode(decl.parent) && ts3.isUnionTypeNode(decl.parent.parent) ? checker.getPropertyOfType(checker.getTypeFromTypeNode(decl.parent.parent), symbol.name) : void 0;
            });
          }
          var SpecialSearchKind;
          (function(SpecialSearchKind2) {
            SpecialSearchKind2[SpecialSearchKind2["None"] = 0] = "None";
            SpecialSearchKind2[SpecialSearchKind2["Constructor"] = 1] = "Constructor";
            SpecialSearchKind2[SpecialSearchKind2["Class"] = 2] = "Class";
          })(SpecialSearchKind || (SpecialSearchKind = {}));
          function getNonModuleSymbolOfMergedModuleSymbol(symbol) {
            if (!(symbol.flags & (1536 | 33554432)))
              return void 0;
            var decl = symbol.declarations && ts3.find(symbol.declarations, function(d) {
              return !ts3.isSourceFile(d) && !ts3.isModuleDeclaration(d);
            });
            return decl && decl.symbol;
          }
          var State2 = function() {
            function State3(sourceFiles, sourceFilesSet, specialSearchKind, checker, cancellationToken, searchMeaning, options, result2) {
              this.sourceFiles = sourceFiles;
              this.sourceFilesSet = sourceFilesSet;
              this.specialSearchKind = specialSearchKind;
              this.checker = checker;
              this.cancellationToken = cancellationToken;
              this.searchMeaning = searchMeaning;
              this.options = options;
              this.result = result2;
              this.inheritsFromCache = new ts3.Map();
              this.markSeenContainingTypeReference = ts3.nodeSeenTracker();
              this.markSeenReExportRHS = ts3.nodeSeenTracker();
              this.symbolIdToReferences = [];
              this.sourceFileToSeenSymbols = [];
            }
            State3.prototype.includesSourceFile = function(sourceFile) {
              return this.sourceFilesSet.has(sourceFile.fileName);
            };
            State3.prototype.getImportSearches = function(exportSymbol, exportInfo) {
              if (!this.importTracker)
                this.importTracker = FindAllReferences2.createImportTracker(this.sourceFiles, this.sourceFilesSet, this.checker, this.cancellationToken);
              return this.importTracker(exportSymbol, exportInfo, this.options.use === 2);
            };
            State3.prototype.createSearch = function(location, symbol, comingFrom, searchOptions) {
              if (searchOptions === void 0) {
                searchOptions = {};
              }
              var _a = searchOptions.text, text = _a === void 0 ? ts3.stripQuotes(ts3.symbolName(ts3.getLocalSymbolForExportDefault(symbol) || getNonModuleSymbolOfMergedModuleSymbol(symbol) || symbol)) : _a, _b = searchOptions.allSearchSymbols, allSearchSymbols = _b === void 0 ? [symbol] : _b;
              var escapedText = ts3.escapeLeadingUnderscores(text);
              var parents = this.options.implementations && location ? getParentSymbolsOfPropertyAccess(location, symbol, this.checker) : void 0;
              return { symbol, comingFrom, text, escapedText, parents, allSearchSymbols, includes: function(sym) {
                return ts3.contains(allSearchSymbols, sym);
              } };
            };
            State3.prototype.referenceAdder = function(searchSymbol) {
              var symbolId = ts3.getSymbolId(searchSymbol);
              var references = this.symbolIdToReferences[symbolId];
              if (!references) {
                references = this.symbolIdToReferences[symbolId] = [];
                this.result.push({ definition: { type: 0, symbol: searchSymbol }, references });
              }
              return function(node, kind) {
                return references.push(nodeEntry(node, kind));
              };
            };
            State3.prototype.addStringOrCommentReference = function(fileName2, textSpan) {
              this.result.push({
                definition: void 0,
                references: [{ kind: 0, fileName: fileName2, textSpan }]
              });
            };
            State3.prototype.markSearchedSymbols = function(sourceFile, symbols) {
              var sourceId = ts3.getNodeId(sourceFile);
              var seenSymbols = this.sourceFileToSeenSymbols[sourceId] || (this.sourceFileToSeenSymbols[sourceId] = new ts3.Set());
              var anyNewSymbols = false;
              for (var _i = 0, symbols_1 = symbols; _i < symbols_1.length; _i++) {
                var sym = symbols_1[_i];
                anyNewSymbols = ts3.tryAddToSet(seenSymbols, ts3.getSymbolId(sym)) || anyNewSymbols;
              }
              return anyNewSymbols;
            };
            return State3;
          }();
          function searchForImportsOfExport(exportLocation, exportSymbol, exportInfo, state) {
            var _a = state.getImportSearches(exportSymbol, exportInfo), importSearches = _a.importSearches, singleReferences = _a.singleReferences, indirectUsers = _a.indirectUsers;
            if (singleReferences.length) {
              var addRef = state.referenceAdder(exportSymbol);
              for (var _i = 0, singleReferences_1 = singleReferences; _i < singleReferences_1.length; _i++) {
                var singleRef = singleReferences_1[_i];
                if (shouldAddSingleReference(singleRef, state))
                  addRef(singleRef);
              }
            }
            for (var _b = 0, importSearches_1 = importSearches; _b < importSearches_1.length; _b++) {
              var _c = importSearches_1[_b], importLocation = _c[0], importSymbol = _c[1];
              getReferencesInSourceFile(importLocation.getSourceFile(), state.createSearch(importLocation, importSymbol, 1), state);
            }
            if (indirectUsers.length) {
              var indirectSearch = void 0;
              switch (exportInfo.exportKind) {
                case 0:
                  indirectSearch = state.createSearch(exportLocation, exportSymbol, 1);
                  break;
                case 1:
                  indirectSearch = state.options.use === 2 ? void 0 : state.createSearch(exportLocation, exportSymbol, 1, { text: "default" });
                  break;
                case 2:
                  break;
              }
              if (indirectSearch) {
                for (var _d = 0, indirectUsers_1 = indirectUsers; _d < indirectUsers_1.length; _d++) {
                  var indirectUser = indirectUsers_1[_d];
                  searchForName(indirectUser, indirectSearch, state);
                }
              }
            }
          }
          function eachExportReference(sourceFiles, checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName, isDefaultExport, cb) {
            var importTracker = FindAllReferences2.createImportTracker(sourceFiles, new ts3.Set(sourceFiles.map(function(f) {
              return f.fileName;
            })), checker, cancellationToken);
            var _a = importTracker(exportSymbol, { exportKind: isDefaultExport ? 1 : 0, exportingModuleSymbol }, false), importSearches = _a.importSearches, indirectUsers = _a.indirectUsers, singleReferences = _a.singleReferences;
            for (var _i = 0, importSearches_2 = importSearches; _i < importSearches_2.length; _i++) {
              var importLocation = importSearches_2[_i][0];
              cb(importLocation);
            }
            for (var _b = 0, singleReferences_2 = singleReferences; _b < singleReferences_2.length; _b++) {
              var singleReference = singleReferences_2[_b];
              if (ts3.isIdentifier(singleReference) && ts3.isImportTypeNode(singleReference.parent)) {
                cb(singleReference);
              }
            }
            for (var _c = 0, indirectUsers_2 = indirectUsers; _c < indirectUsers_2.length; _c++) {
              var indirectUser = indirectUsers_2[_c];
              for (var _d = 0, _e = getPossibleSymbolReferenceNodes(indirectUser, isDefaultExport ? "default" : exportName); _d < _e.length; _d++) {
                var node = _e[_d];
                var symbol = checker.getSymbolAtLocation(node);
                var hasExportAssignmentDeclaration = ts3.some(symbol === null || symbol === void 0 ? void 0 : symbol.declarations, function(d) {
                  return ts3.tryCast(d, ts3.isExportAssignment) ? true : false;
                });
                if (ts3.isIdentifier(node) && !ts3.isImportOrExportSpecifier(node.parent) && (symbol === exportSymbol || hasExportAssignmentDeclaration)) {
                  cb(node);
                }
              }
            }
          }
          Core2.eachExportReference = eachExportReference;
          function shouldAddSingleReference(singleRef, state) {
            if (!hasMatchingMeaning(singleRef, state))
              return false;
            if (state.options.use !== 2)
              return true;
            if (!ts3.isIdentifier(singleRef))
              return false;
            return !(ts3.isImportOrExportSpecifier(singleRef.parent) && singleRef.escapedText === "default");
          }
          function searchForImportedSymbol(symbol, state) {
            if (!symbol.declarations)
              return;
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              var exportingFile = declaration.getSourceFile();
              getReferencesInSourceFile(exportingFile, state.createSearch(declaration, symbol, 0), state, state.includesSourceFile(exportingFile));
            }
          }
          function searchForName(sourceFile, search, state) {
            if (ts3.getNameTable(sourceFile).get(search.escapedText) !== void 0) {
              getReferencesInSourceFile(sourceFile, search, state);
            }
          }
          function getPropertySymbolOfDestructuringAssignment(location, checker) {
            return ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(location.parent.parent) ? checker.getPropertySymbolOfDestructuringAssignment(location) : void 0;
          }
          function getSymbolScope(symbol) {
            var declarations = symbol.declarations, flags = symbol.flags, parent = symbol.parent, valueDeclaration = symbol.valueDeclaration;
            if (valueDeclaration && (valueDeclaration.kind === 213 || valueDeclaration.kind === 226)) {
              return valueDeclaration;
            }
            if (!declarations) {
              return void 0;
            }
            if (flags & (4 | 8192)) {
              var privateDeclaration = ts3.find(declarations, function(d) {
                return ts3.hasEffectiveModifier(d, 8) || ts3.isPrivateIdentifierClassElementDeclaration(d);
              });
              if (privateDeclaration) {
                return ts3.getAncestor(privateDeclaration, 257);
              }
              return void 0;
            }
            if (declarations.some(ts3.isObjectBindingElementWithoutPropertyName)) {
              return void 0;
            }
            var exposedByParent = parent && !(symbol.flags & 262144);
            if (exposedByParent && !(ts3.isExternalModuleSymbol(parent) && !parent.globalExports)) {
              return void 0;
            }
            var scope;
            for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
              var declaration = declarations_1[_i];
              var container = ts3.getContainerNode(declaration);
              if (scope && scope !== container) {
                return void 0;
              }
              if (!container || container.kind === 305 && !ts3.isExternalOrCommonJsModule(container)) {
                return void 0;
              }
              scope = container;
              if (ts3.isFunctionExpression(scope)) {
                var next = void 0;
                while (next = ts3.getNextJSDocCommentLocation(scope)) {
                  scope = next;
                }
              }
            }
            return exposedByParent ? scope.getSourceFile() : scope;
          }
          function isSymbolReferencedInFile(definition, checker, sourceFile, searchContainer) {
            if (searchContainer === void 0) {
              searchContainer = sourceFile;
            }
            return eachSymbolReferenceInFile(definition, checker, sourceFile, function() {
              return true;
            }, searchContainer) || false;
          }
          Core2.isSymbolReferencedInFile = isSymbolReferencedInFile;
          function eachSymbolReferenceInFile(definition, checker, sourceFile, cb, searchContainer) {
            if (searchContainer === void 0) {
              searchContainer = sourceFile;
            }
            var symbol = ts3.isParameterPropertyDeclaration(definition.parent, definition.parent.parent) ? ts3.first(checker.getSymbolsOfParameterPropertyDeclaration(definition.parent, definition.text)) : checker.getSymbolAtLocation(definition);
            if (!symbol)
              return void 0;
            for (var _i = 0, _a = getPossibleSymbolReferenceNodes(sourceFile, symbol.name, searchContainer); _i < _a.length; _i++) {
              var token = _a[_i];
              if (!ts3.isIdentifier(token) || token === definition || token.escapedText !== definition.escapedText)
                continue;
              var referenceSymbol = checker.getSymbolAtLocation(token);
              if (referenceSymbol === symbol || checker.getShorthandAssignmentValueSymbol(token.parent) === symbol || ts3.isExportSpecifier(token.parent) && getLocalSymbolForExportSpecifier(token, referenceSymbol, token.parent, checker) === symbol) {
                var res = cb(token);
                if (res)
                  return res;
              }
            }
          }
          Core2.eachSymbolReferenceInFile = eachSymbolReferenceInFile;
          function getTopMostDeclarationNamesInFile(declarationName, sourceFile) {
            var candidates = ts3.filter(getPossibleSymbolReferenceNodes(sourceFile, declarationName), function(name) {
              return !!ts3.getDeclarationFromName(name);
            });
            return candidates.reduce(function(topMost, decl) {
              var depth = getDepth(decl);
              if (!ts3.some(topMost.declarationNames) || depth === topMost.depth) {
                topMost.declarationNames.push(decl);
                topMost.depth = depth;
              } else if (depth < topMost.depth) {
                topMost.declarationNames = [decl];
                topMost.depth = depth;
              }
              return topMost;
            }, { depth: Infinity, declarationNames: [] }).declarationNames;
            function getDepth(declaration) {
              var depth = 0;
              while (declaration) {
                declaration = ts3.getContainerNode(declaration);
                depth++;
              }
              return depth;
            }
          }
          Core2.getTopMostDeclarationNamesInFile = getTopMostDeclarationNamesInFile;
          function someSignatureUsage(signature, sourceFiles, checker, cb) {
            if (!signature.name || !ts3.isIdentifier(signature.name))
              return false;
            var symbol = ts3.Debug.checkDefined(checker.getSymbolAtLocation(signature.name));
            for (var _i = 0, sourceFiles_3 = sourceFiles; _i < sourceFiles_3.length; _i++) {
              var sourceFile = sourceFiles_3[_i];
              for (var _a = 0, _b = getPossibleSymbolReferenceNodes(sourceFile, symbol.name); _a < _b.length; _a++) {
                var name = _b[_a];
                if (!ts3.isIdentifier(name) || name === signature.name || name.escapedText !== signature.name.escapedText)
                  continue;
                var called = ts3.climbPastPropertyAccess(name);
                var call = ts3.isCallExpression(called.parent) && called.parent.expression === called ? called.parent : void 0;
                var referenceSymbol = checker.getSymbolAtLocation(name);
                if (referenceSymbol && checker.getRootSymbols(referenceSymbol).some(function(s) {
                  return s === symbol;
                })) {
                  if (cb(name, call)) {
                    return true;
                  }
                }
              }
            }
            return false;
          }
          Core2.someSignatureUsage = someSignatureUsage;
          function getPossibleSymbolReferenceNodes(sourceFile, symbolName, container) {
            if (container === void 0) {
              container = sourceFile;
            }
            return getPossibleSymbolReferencePositions(sourceFile, symbolName, container).map(function(pos) {
              return ts3.getTouchingPropertyName(sourceFile, pos);
            });
          }
          function getPossibleSymbolReferencePositions(sourceFile, symbolName, container) {
            if (container === void 0) {
              container = sourceFile;
            }
            var positions = [];
            if (!symbolName || !symbolName.length) {
              return positions;
            }
            var text = sourceFile.text;
            var sourceLength = text.length;
            var symbolNameLength = symbolName.length;
            var position = text.indexOf(symbolName, container.pos);
            while (position >= 0) {
              if (position > container.end)
                break;
              var endPosition = position + symbolNameLength;
              if ((position === 0 || !ts3.isIdentifierPart(text.charCodeAt(position - 1), 99)) && (endPosition === sourceLength || !ts3.isIdentifierPart(text.charCodeAt(endPosition), 99))) {
                positions.push(position);
              }
              position = text.indexOf(symbolName, position + symbolNameLength + 1);
            }
            return positions;
          }
          function getLabelReferencesInNode(container, targetLabel) {
            var sourceFile = container.getSourceFile();
            var labelName = targetLabel.text;
            var references = ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, labelName, container), function(node) {
              return node === targetLabel || ts3.isJumpStatementTarget(node) && ts3.getTargetLabel(node, labelName) === targetLabel ? nodeEntry(node) : void 0;
            });
            return [{ definition: { type: 1, node: targetLabel }, references }];
          }
          function isValidReferencePosition(node, searchSymbolName) {
            switch (node.kind) {
              case 80:
                if (ts3.isJSDocMemberName(node.parent)) {
                  return true;
                }
              case 79:
                return node.text.length === searchSymbolName.length;
              case 14:
              case 10: {
                var str2 = node;
                return (ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess(str2) || ts3.isNameOfModuleDeclaration(node) || ts3.isExpressionOfExternalModuleImportEqualsDeclaration(node) || ts3.isCallExpression(node.parent) && ts3.isBindableObjectDefinePropertyCall(node.parent) && node.parent.arguments[1] === node) && str2.text.length === searchSymbolName.length;
              }
              case 8:
                return ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess(node) && node.text.length === searchSymbolName.length;
              case 88:
                return "default".length === searchSymbolName.length;
              default:
                return false;
            }
          }
          function getAllReferencesForImportMeta(sourceFiles, cancellationToken) {
            var references = ts3.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, "meta", sourceFile), function(node) {
                var parent = node.parent;
                if (ts3.isImportMeta(parent)) {
                  return nodeEntry(parent);
                }
              });
            });
            return references.length ? [{ definition: { type: 2, node: references[0].node }, references }] : void 0;
          }
          function getAllReferencesForKeyword(sourceFiles, keywordKind, cancellationToken, filter) {
            var references = ts3.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, ts3.tokenToString(keywordKind), sourceFile), function(referenceLocation) {
                if (referenceLocation.kind === keywordKind && (!filter || filter(referenceLocation))) {
                  return nodeEntry(referenceLocation);
                }
              });
            });
            return references.length ? [{ definition: { type: 2, node: references[0].node }, references }] : void 0;
          }
          function getReferencesInSourceFile(sourceFile, search, state, addReferencesHere) {
            if (addReferencesHere === void 0) {
              addReferencesHere = true;
            }
            state.cancellationToken.throwIfCancellationRequested();
            return getReferencesInContainer(sourceFile, sourceFile, search, state, addReferencesHere);
          }
          function getReferencesInContainer(container, sourceFile, search, state, addReferencesHere) {
            if (!state.markSearchedSymbols(sourceFile, search.allSearchSymbols)) {
              return;
            }
            for (var _i = 0, _a = getPossibleSymbolReferencePositions(sourceFile, search.text, container); _i < _a.length; _i++) {
              var position = _a[_i];
              getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere);
            }
          }
          function hasMatchingMeaning(referenceLocation, state) {
            return !!(ts3.getMeaningFromLocation(referenceLocation) & state.searchMeaning);
          }
          function getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere) {
            var referenceLocation = ts3.getTouchingPropertyName(sourceFile, position);
            if (!isValidReferencePosition(referenceLocation, search.text)) {
              if (!state.options.implementations && (state.options.findInStrings && ts3.isInString(sourceFile, position) || state.options.findInComments && ts3.isInNonReferenceComment(sourceFile, position))) {
                state.addStringOrCommentReference(sourceFile.fileName, ts3.createTextSpan(position, search.text.length));
              }
              return;
            }
            if (!hasMatchingMeaning(referenceLocation, state))
              return;
            var referenceSymbol = state.checker.getSymbolAtLocation(referenceLocation);
            if (!referenceSymbol) {
              return;
            }
            var parent = referenceLocation.parent;
            if (ts3.isImportSpecifier(parent) && parent.propertyName === referenceLocation) {
              return;
            }
            if (ts3.isExportSpecifier(parent)) {
              ts3.Debug.assert(referenceLocation.kind === 79);
              getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, parent, search, state, addReferencesHere);
              return;
            }
            var relatedSymbol = getRelatedSymbol(search, referenceSymbol, referenceLocation, state);
            if (!relatedSymbol) {
              getReferenceForShorthandProperty(referenceSymbol, search, state);
              return;
            }
            switch (state.specialSearchKind) {
              case 0:
                if (addReferencesHere)
                  addReference(referenceLocation, relatedSymbol, state);
                break;
              case 1:
                addConstructorReferences(referenceLocation, sourceFile, search, state);
                break;
              case 2:
                addClassStaticThisReferences(referenceLocation, search, state);
                break;
              default:
                ts3.Debug.assertNever(state.specialSearchKind);
            }
            if (ts3.isInJSFile(referenceLocation) && referenceLocation.parent.kind === 203 && ts3.isVariableDeclarationInitializedToBareOrAccessedRequire(referenceLocation.parent.parent.parent)) {
              referenceSymbol = referenceLocation.parent.symbol;
              if (!referenceSymbol)
                return;
            }
            getImportOrExportReferences(referenceLocation, referenceSymbol, search, state);
          }
          function getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, search, state, addReferencesHere, alwaysGetReferences) {
            ts3.Debug.assert(!alwaysGetReferences || !!state.options.providePrefixAndSuffixTextForRename, "If alwaysGetReferences is true, then prefix/suffix text must be enabled");
            var parent = exportSpecifier.parent, propertyName = exportSpecifier.propertyName, name = exportSpecifier.name;
            var exportDeclaration = parent.parent;
            var localSymbol = getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, state.checker);
            if (!alwaysGetReferences && !search.includes(localSymbol)) {
              return;
            }
            if (!propertyName) {
              if (!(state.options.use === 2 && name.escapedText === "default")) {
                addRef();
              }
            } else if (referenceLocation === propertyName) {
              if (!exportDeclaration.moduleSpecifier) {
                addRef();
              }
              if (addReferencesHere && state.options.use !== 2 && state.markSeenReExportRHS(name)) {
                addReference(name, ts3.Debug.checkDefined(exportSpecifier.symbol), state);
              }
            } else {
              if (state.markSeenReExportRHS(referenceLocation)) {
                addRef();
              }
            }
            if (!isForRenameWithPrefixAndSuffixText(state.options) || alwaysGetReferences) {
              var isDefaultExport = referenceLocation.originalKeywordKind === 88 || exportSpecifier.name.originalKeywordKind === 88;
              var exportKind = isDefaultExport ? 1 : 0;
              var exportSymbol = ts3.Debug.checkDefined(exportSpecifier.symbol);
              var exportInfo = FindAllReferences2.getExportInfo(exportSymbol, exportKind, state.checker);
              if (exportInfo) {
                searchForImportsOfExport(referenceLocation, exportSymbol, exportInfo, state);
              }
            }
            if (search.comingFrom !== 1 && exportDeclaration.moduleSpecifier && !propertyName && !isForRenameWithPrefixAndSuffixText(state.options)) {
              var imported = state.checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
              if (imported)
                searchForImportedSymbol(imported, state);
            }
            function addRef() {
              if (addReferencesHere)
                addReference(referenceLocation, localSymbol, state);
            }
          }
          function getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, checker) {
            return isExportSpecifierAlias(referenceLocation, exportSpecifier) && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier) || referenceSymbol;
          }
          function isExportSpecifierAlias(referenceLocation, exportSpecifier) {
            var parent = exportSpecifier.parent, propertyName = exportSpecifier.propertyName, name = exportSpecifier.name;
            ts3.Debug.assert(propertyName === referenceLocation || name === referenceLocation);
            if (propertyName) {
              return propertyName === referenceLocation;
            } else {
              return !parent.parent.moduleSpecifier;
            }
          }
          function getImportOrExportReferences(referenceLocation, referenceSymbol, search, state) {
            var importOrExport = FindAllReferences2.getImportOrExportSymbol(referenceLocation, referenceSymbol, state.checker, search.comingFrom === 1);
            if (!importOrExport)
              return;
            var symbol = importOrExport.symbol;
            if (importOrExport.kind === 0) {
              if (!isForRenameWithPrefixAndSuffixText(state.options)) {
                searchForImportedSymbol(symbol, state);
              }
            } else {
              searchForImportsOfExport(referenceLocation, symbol, importOrExport.exportInfo, state);
            }
          }
          function getReferenceForShorthandProperty(_a, search, state) {
            var flags = _a.flags, valueDeclaration = _a.valueDeclaration;
            var shorthandValueSymbol = state.checker.getShorthandAssignmentValueSymbol(valueDeclaration);
            var name = valueDeclaration && ts3.getNameOfDeclaration(valueDeclaration);
            if (!(flags & 33554432) && name && search.includes(shorthandValueSymbol)) {
              addReference(name, shorthandValueSymbol, state);
            }
          }
          function addReference(referenceLocation, relatedSymbol, state) {
            var _a = "kind" in relatedSymbol ? relatedSymbol : { kind: void 0, symbol: relatedSymbol }, kind = _a.kind, symbol = _a.symbol;
            if (state.options.use === 2 && referenceLocation.kind === 88) {
              return;
            }
            var addRef = state.referenceAdder(symbol);
            if (state.options.implementations) {
              addImplementationReferences(referenceLocation, addRef, state);
            } else {
              addRef(referenceLocation, kind);
            }
          }
          function addConstructorReferences(referenceLocation, sourceFile, search, state) {
            if (ts3.isNewExpressionTarget(referenceLocation)) {
              addReference(referenceLocation, search.symbol, state);
            }
            var pusher = function() {
              return state.referenceAdder(search.symbol);
            };
            if (ts3.isClassLike(referenceLocation.parent)) {
              ts3.Debug.assert(referenceLocation.kind === 88 || referenceLocation.parent.name === referenceLocation);
              findOwnConstructorReferences(search.symbol, sourceFile, pusher());
            } else {
              var classExtending = tryGetClassByExtendingIdentifier(referenceLocation);
              if (classExtending) {
                findSuperConstructorAccesses(classExtending, pusher());
                findInheritedConstructorReferences(classExtending, state);
              }
            }
          }
          function addClassStaticThisReferences(referenceLocation, search, state) {
            addReference(referenceLocation, search.symbol, state);
            var classLike = referenceLocation.parent;
            if (state.options.use === 2 || !ts3.isClassLike(classLike))
              return;
            ts3.Debug.assert(classLike.name === referenceLocation);
            var addRef = state.referenceAdder(search.symbol);
            for (var _i = 0, _a = classLike.members; _i < _a.length; _i++) {
              var member = _a[_i];
              if (!(ts3.isMethodOrAccessor(member) && ts3.isStatic(member))) {
                continue;
              }
              if (member.body) {
                member.body.forEachChild(function cb(node) {
                  if (node.kind === 108) {
                    addRef(node);
                  } else if (!ts3.isFunctionLike(node) && !ts3.isClassLike(node)) {
                    node.forEachChild(cb);
                  }
                });
              }
            }
          }
          function findOwnConstructorReferences(classSymbol, sourceFile, addNode) {
            var constructorSymbol = getClassConstructorSymbol(classSymbol);
            if (constructorSymbol && constructorSymbol.declarations) {
              for (var _i = 0, _a = constructorSymbol.declarations; _i < _a.length; _i++) {
                var decl = _a[_i];
                var ctrKeyword = ts3.findChildOfKind(decl, 134, sourceFile);
                ts3.Debug.assert(decl.kind === 171 && !!ctrKeyword);
                addNode(ctrKeyword);
              }
            }
            if (classSymbol.exports) {
              classSymbol.exports.forEach(function(member) {
                var decl2 = member.valueDeclaration;
                if (decl2 && decl2.kind === 169) {
                  var body = decl2.body;
                  if (body) {
                    forEachDescendantOfKind(body, 108, function(thisKeyword) {
                      if (ts3.isNewExpressionTarget(thisKeyword)) {
                        addNode(thisKeyword);
                      }
                    });
                  }
                }
              });
            }
          }
          function getClassConstructorSymbol(classSymbol) {
            return classSymbol.members && classSymbol.members.get("__constructor");
          }
          function findSuperConstructorAccesses(classDeclaration, addNode) {
            var constructor = getClassConstructorSymbol(classDeclaration.symbol);
            if (!(constructor && constructor.declarations)) {
              return;
            }
            for (var _i = 0, _a = constructor.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              ts3.Debug.assert(decl.kind === 171);
              var body = decl.body;
              if (body) {
                forEachDescendantOfKind(body, 106, function(node) {
                  if (ts3.isCallExpressionTarget(node)) {
                    addNode(node);
                  }
                });
              }
            }
          }
          function hasOwnConstructor(classDeclaration) {
            return !!getClassConstructorSymbol(classDeclaration.symbol);
          }
          function findInheritedConstructorReferences(classDeclaration, state) {
            if (hasOwnConstructor(classDeclaration))
              return;
            var classSymbol = classDeclaration.symbol;
            var search = state.createSearch(void 0, classSymbol, void 0);
            getReferencesInContainerOrFiles(classSymbol, state, search);
          }
          function addImplementationReferences(refNode, addReference2, state) {
            if (ts3.isDeclarationName(refNode) && isImplementation(refNode.parent)) {
              addReference2(refNode);
              return;
            }
            if (refNode.kind !== 79) {
              return;
            }
            if (refNode.parent.kind === 297) {
              getReferenceEntriesForShorthandPropertyAssignment(refNode, state.checker, addReference2);
            }
            var containingClass = getContainingClassIfInHeritageClause(refNode);
            if (containingClass) {
              addReference2(containingClass);
              return;
            }
            var typeNode = ts3.findAncestor(refNode, function(a) {
              return !ts3.isQualifiedName(a.parent) && !ts3.isTypeNode(a.parent) && !ts3.isTypeElement(a.parent);
            });
            var typeHavingNode = typeNode.parent;
            if (ts3.hasType(typeHavingNode) && typeHavingNode.type === typeNode && state.markSeenContainingTypeReference(typeHavingNode)) {
              if (ts3.hasInitializer(typeHavingNode)) {
                addIfImplementation(typeHavingNode.initializer);
              } else if (ts3.isFunctionLike(typeHavingNode) && typeHavingNode.body) {
                var body = typeHavingNode.body;
                if (body.kind === 235) {
                  ts3.forEachReturnStatement(body, function(returnStatement) {
                    if (returnStatement.expression)
                      addIfImplementation(returnStatement.expression);
                  });
                } else {
                  addIfImplementation(body);
                }
              } else if (ts3.isAssertionExpression(typeHavingNode)) {
                addIfImplementation(typeHavingNode.expression);
              }
            }
            function addIfImplementation(e) {
              if (isImplementationExpression(e))
                addReference2(e);
            }
          }
          function getContainingClassIfInHeritageClause(node) {
            return ts3.isIdentifier(node) || ts3.isPropertyAccessExpression(node) ? getContainingClassIfInHeritageClause(node.parent) : ts3.isExpressionWithTypeArguments(node) ? ts3.tryCast(node.parent.parent, ts3.isClassLike) : void 0;
          }
          function isImplementationExpression(node) {
            switch (node.kind) {
              case 212:
                return isImplementationExpression(node.expression);
              case 214:
              case 213:
              case 205:
              case 226:
              case 204:
                return true;
              default:
                return false;
            }
          }
          function explicitlyInheritsFrom(symbol, parent, cachedResults, checker) {
            if (symbol === parent) {
              return true;
            }
            var key = ts3.getSymbolId(symbol) + "," + ts3.getSymbolId(parent);
            var cached = cachedResults.get(key);
            if (cached !== void 0) {
              return cached;
            }
            cachedResults.set(key, false);
            var inherits = !!symbol.declarations && symbol.declarations.some(function(declaration) {
              return ts3.getAllSuperTypeNodes(declaration).some(function(typeReference) {
                var type2 = checker.getTypeAtLocation(typeReference);
                return !!type2 && !!type2.symbol && explicitlyInheritsFrom(type2.symbol, parent, cachedResults, checker);
              });
            });
            cachedResults.set(key, inherits);
            return inherits;
          }
          function getReferencesForSuperKeyword(superKeyword) {
            var searchSpaceNode = ts3.getSuperContainer(superKeyword, false);
            if (!searchSpaceNode) {
              return void 0;
            }
            var staticFlag = 32;
            switch (searchSpaceNode.kind) {
              case 167:
              case 166:
              case 169:
              case 168:
              case 171:
              case 172:
              case 173:
                staticFlag &= ts3.getSyntacticModifierFlags(searchSpaceNode);
                searchSpaceNode = searchSpaceNode.parent;
                break;
              default:
                return void 0;
            }
            var sourceFile = searchSpaceNode.getSourceFile();
            var references = ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, "super", searchSpaceNode), function(node) {
              if (node.kind !== 106) {
                return;
              }
              var container = ts3.getSuperContainer(node, false);
              return container && ts3.isStatic(container) === !!staticFlag && container.parent.symbol === searchSpaceNode.symbol ? nodeEntry(node) : void 0;
            });
            return [{ definition: { type: 0, symbol: searchSpaceNode.symbol }, references }];
          }
          function isParameterName(node) {
            return node.kind === 79 && node.parent.kind === 164 && node.parent.name === node;
          }
          function getReferencesForThisKeyword(thisOrSuperKeyword, sourceFiles, cancellationToken) {
            var searchSpaceNode = ts3.getThisContainer(thisOrSuperKeyword, false);
            var staticFlag = 32;
            switch (searchSpaceNode.kind) {
              case 169:
              case 168:
                if (ts3.isObjectLiteralMethod(searchSpaceNode)) {
                  staticFlag &= ts3.getSyntacticModifierFlags(searchSpaceNode);
                  searchSpaceNode = searchSpaceNode.parent;
                  break;
                }
              case 167:
              case 166:
              case 171:
              case 172:
              case 173:
                staticFlag &= ts3.getSyntacticModifierFlags(searchSpaceNode);
                searchSpaceNode = searchSpaceNode.parent;
                break;
              case 305:
                if (ts3.isExternalModule(searchSpaceNode) || isParameterName(thisOrSuperKeyword)) {
                  return void 0;
                }
              case 256:
              case 213:
                break;
              default:
                return void 0;
            }
            var references = ts3.flatMap(searchSpaceNode.kind === 305 ? sourceFiles : [searchSpaceNode.getSourceFile()], function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return getPossibleSymbolReferenceNodes(sourceFile, "this", ts3.isSourceFile(searchSpaceNode) ? sourceFile : searchSpaceNode).filter(function(node) {
                if (!ts3.isThis(node)) {
                  return false;
                }
                var container = ts3.getThisContainer(node, false);
                switch (searchSpaceNode.kind) {
                  case 213:
                  case 256:
                    return searchSpaceNode.symbol === container.symbol;
                  case 169:
                  case 168:
                    return ts3.isObjectLiteralMethod(searchSpaceNode) && searchSpaceNode.symbol === container.symbol;
                  case 226:
                  case 257:
                  case 205:
                    return container.parent && searchSpaceNode.symbol === container.parent.symbol && ts3.isStatic(container) === !!staticFlag;
                  case 305:
                    return container.kind === 305 && !ts3.isExternalModule(container) && !isParameterName(node);
                }
              });
            }).map(function(n) {
              return nodeEntry(n);
            });
            var thisParameter = ts3.firstDefined(references, function(r) {
              return ts3.isParameter(r.node.parent) ? r.node : void 0;
            });
            return [{
              definition: { type: 3, node: thisParameter || thisOrSuperKeyword },
              references
            }];
          }
          function getReferencesForStringLiteral(node, sourceFiles, checker, cancellationToken) {
            var type2 = ts3.getContextualTypeFromParentOrAncestorTypeNode(node, checker);
            var references = ts3.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, node.text), function(ref) {
                if (ts3.isStringLiteralLike(ref) && ref.text === node.text) {
                  if (type2) {
                    var refType = ts3.getContextualTypeFromParentOrAncestorTypeNode(ref, checker);
                    if (type2 !== checker.getStringType() && type2 === refType) {
                      return nodeEntry(ref, 2);
                    }
                  } else {
                    return ts3.isNoSubstitutionTemplateLiteral(ref) && !ts3.rangeIsOnSingleLine(ref, sourceFile) ? void 0 : nodeEntry(ref, 2);
                  }
                }
              });
            });
            return [{
              definition: { type: 4, node },
              references
            }];
          }
          function populateSearchSymbolSet(symbol, location, checker, isForRename, providePrefixAndSuffixText, implementations) {
            var result2 = [];
            forEachRelatedSymbol(symbol, location, checker, isForRename, !(isForRename && providePrefixAndSuffixText), function(sym, root, base) {
              if (base) {
                if (isStaticSymbol(symbol) !== isStaticSymbol(base)) {
                  base = void 0;
                }
              }
              result2.push(base || root || sym);
            }, function() {
              return !implementations;
            });
            return result2;
          }
          function forEachRelatedSymbol(symbol, location, checker, isForRenamePopulateSearchSymbolSet, onlyIncludeBindingElementAtReferenceLocation, cbSymbol, allowBaseTypes) {
            var containingObjectLiteralElement = ts3.getContainingObjectLiteralElement(location);
            if (containingObjectLiteralElement) {
              var shorthandValueSymbol = checker.getShorthandAssignmentValueSymbol(location.parent);
              if (shorthandValueSymbol && isForRenamePopulateSearchSymbolSet) {
                return cbSymbol(shorthandValueSymbol, void 0, void 0, 3);
              }
              var contextualType = checker.getContextualType(containingObjectLiteralElement.parent);
              var res_1 = contextualType && ts3.firstDefined(ts3.getPropertySymbolsFromContextualType(containingObjectLiteralElement, checker, contextualType, true), function(sym) {
                return fromRoot(sym, 4);
              });
              if (res_1)
                return res_1;
              var propertySymbol = getPropertySymbolOfDestructuringAssignment(location, checker);
              var res1 = propertySymbol && cbSymbol(propertySymbol, void 0, void 0, 4);
              if (res1)
                return res1;
              var res2 = shorthandValueSymbol && cbSymbol(shorthandValueSymbol, void 0, void 0, 3);
              if (res2)
                return res2;
            }
            var aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(location, symbol, checker);
            if (aliasedSymbol) {
              var res_2 = cbSymbol(aliasedSymbol, void 0, void 0, 1);
              if (res_2)
                return res_2;
            }
            var res = fromRoot(symbol);
            if (res)
              return res;
            if (symbol.valueDeclaration && ts3.isParameterPropertyDeclaration(symbol.valueDeclaration, symbol.valueDeclaration.parent)) {
              var paramProps = checker.getSymbolsOfParameterPropertyDeclaration(ts3.cast(symbol.valueDeclaration, ts3.isParameter), symbol.name);
              ts3.Debug.assert(paramProps.length === 2 && !!(paramProps[0].flags & 1) && !!(paramProps[1].flags & 4));
              return fromRoot(symbol.flags & 1 ? paramProps[1] : paramProps[0]);
            }
            var exportSpecifier = ts3.getDeclarationOfKind(symbol, 275);
            if (!isForRenamePopulateSearchSymbolSet || exportSpecifier && !exportSpecifier.propertyName) {
              var localSymbol = exportSpecifier && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
              if (localSymbol) {
                var res_3 = cbSymbol(localSymbol, void 0, void 0, 1);
                if (res_3)
                  return res_3;
              }
            }
            if (!isForRenamePopulateSearchSymbolSet) {
              var bindingElementPropertySymbol = void 0;
              if (onlyIncludeBindingElementAtReferenceLocation) {
                bindingElementPropertySymbol = ts3.isObjectBindingElementWithoutPropertyName(location.parent) ? ts3.getPropertySymbolFromBindingElement(checker, location.parent) : void 0;
              } else {
                bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
              }
              return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4);
            }
            ts3.Debug.assert(isForRenamePopulateSearchSymbolSet);
            var includeOriginalSymbolOfBindingElement = onlyIncludeBindingElementAtReferenceLocation;
            if (includeOriginalSymbolOfBindingElement) {
              var bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
              return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4);
            }
            function fromRoot(sym, kind) {
              return ts3.firstDefined(checker.getRootSymbols(sym), function(rootSymbol) {
                return cbSymbol(sym, rootSymbol, void 0, kind) || (rootSymbol.parent && rootSymbol.parent.flags & (32 | 64) && allowBaseTypes(rootSymbol) ? getPropertySymbolsFromBaseTypes(rootSymbol.parent, rootSymbol.name, checker, function(base) {
                  return cbSymbol(sym, rootSymbol, base, kind);
                }) : void 0);
              });
            }
            function getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol2, checker2) {
              var bindingElement = ts3.getDeclarationOfKind(symbol2, 203);
              if (bindingElement && ts3.isObjectBindingElementWithoutPropertyName(bindingElement)) {
                return ts3.getPropertySymbolFromBindingElement(checker2, bindingElement);
              }
            }
          }
          function getPropertySymbolsFromBaseTypes(symbol, propertyName, checker, cb) {
            var seen = new ts3.Map();
            return recur(symbol);
            function recur(symbol2) {
              if (!(symbol2.flags & (32 | 64)) || !ts3.addToSeen(seen, ts3.getSymbolId(symbol2)))
                return;
              return ts3.firstDefined(symbol2.declarations, function(declaration) {
                return ts3.firstDefined(ts3.getAllSuperTypeNodes(declaration), function(typeReference) {
                  var type2 = checker.getTypeAtLocation(typeReference);
                  var propertySymbol = type2 && type2.symbol && checker.getPropertyOfType(type2, propertyName);
                  return type2 && propertySymbol && (ts3.firstDefined(checker.getRootSymbols(propertySymbol), cb) || recur(type2.symbol));
                });
              });
            }
          }
          function isStaticSymbol(symbol) {
            if (!symbol.valueDeclaration)
              return false;
            var modifierFlags = ts3.getEffectiveModifierFlags(symbol.valueDeclaration);
            return !!(modifierFlags & 32);
          }
          function getRelatedSymbol(search, referenceSymbol, referenceLocation, state) {
            var checker = state.checker;
            return forEachRelatedSymbol(referenceSymbol, referenceLocation, checker, false, state.options.use !== 2 || !!state.options.providePrefixAndSuffixTextForRename, function(sym, rootSymbol, baseSymbol, kind) {
              if (baseSymbol) {
                if (isStaticSymbol(referenceSymbol) !== isStaticSymbol(baseSymbol)) {
                  baseSymbol = void 0;
                }
              }
              return search.includes(baseSymbol || rootSymbol || sym) ? { symbol: rootSymbol && !(ts3.getCheckFlags(sym) & 6) ? rootSymbol : sym, kind } : void 0;
            }, function(rootSymbol) {
              return !(search.parents && !search.parents.some(function(parent) {
                return explicitlyInheritsFrom(rootSymbol.parent, parent, state.inheritsFromCache, checker);
              }));
            });
          }
          function getIntersectingMeaningFromDeclarations(node, symbol) {
            var meaning = ts3.getMeaningFromLocation(node);
            var declarations = symbol.declarations;
            if (declarations) {
              var lastIterationMeaning = void 0;
              do {
                lastIterationMeaning = meaning;
                for (var _i = 0, declarations_2 = declarations; _i < declarations_2.length; _i++) {
                  var declaration = declarations_2[_i];
                  var declarationMeaning = ts3.getMeaningFromDeclaration(declaration);
                  if (declarationMeaning & meaning) {
                    meaning |= declarationMeaning;
                  }
                }
              } while (meaning !== lastIterationMeaning);
            }
            return meaning;
          }
          Core2.getIntersectingMeaningFromDeclarations = getIntersectingMeaningFromDeclarations;
          function isImplementation(node) {
            return !!(node.flags & 16777216) ? !(ts3.isInterfaceDeclaration(node) || ts3.isTypeAliasDeclaration(node)) : ts3.isVariableLike(node) ? ts3.hasInitializer(node) : ts3.isFunctionLikeDeclaration(node) ? !!node.body : ts3.isClassLike(node) || ts3.isModuleOrEnumDeclaration(node);
          }
          function getReferenceEntriesForShorthandPropertyAssignment(node, checker, addReference2) {
            var refSymbol = checker.getSymbolAtLocation(node);
            var shorthandSymbol = checker.getShorthandAssignmentValueSymbol(refSymbol.valueDeclaration);
            if (shorthandSymbol) {
              for (var _i = 0, _a = shorthandSymbol.getDeclarations(); _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (ts3.getMeaningFromDeclaration(declaration) & 1) {
                  addReference2(declaration);
                }
              }
            }
          }
          Core2.getReferenceEntriesForShorthandPropertyAssignment = getReferenceEntriesForShorthandPropertyAssignment;
          function forEachDescendantOfKind(node, kind, action) {
            ts3.forEachChild(node, function(child) {
              if (child.kind === kind) {
                action(child);
              }
              forEachDescendantOfKind(child, kind, action);
            });
          }
          function tryGetClassByExtendingIdentifier(node) {
            return ts3.tryGetClassExtendingExpressionWithTypeArguments(ts3.climbPastPropertyAccess(node).parent);
          }
          function getParentSymbolsOfPropertyAccess(location, symbol, checker) {
            var propertyAccessExpression = ts3.isRightSideOfPropertyAccess(location) ? location.parent : void 0;
            var lhsType = propertyAccessExpression && checker.getTypeAtLocation(propertyAccessExpression.expression);
            var res = ts3.mapDefined(lhsType && (lhsType.isUnionOrIntersection() ? lhsType.types : lhsType.symbol === symbol.parent ? void 0 : [lhsType]), function(t) {
              return t.symbol && t.symbol.flags & (32 | 64) ? t.symbol : void 0;
            });
            return res.length === 0 ? void 0 : res;
          }
          function isForRenameWithPrefixAndSuffixText(options) {
            return options.use === 2 && options.providePrefixAndSuffixTextForRename;
          }
        })(Core = FindAllReferences2.Core || (FindAllReferences2.Core = {}));
      })(FindAllReferences = ts3.FindAllReferences || (ts3.FindAllReferences = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var CallHierarchy;
      (function(CallHierarchy2) {
        function isNamedExpression(node) {
          return (ts3.isFunctionExpression(node) || ts3.isClassExpression(node)) && ts3.isNamedDeclaration(node);
        }
        function isConstNamedExpression(node) {
          return (ts3.isFunctionExpression(node) || ts3.isArrowFunction(node) || ts3.isClassExpression(node)) && ts3.isVariableDeclaration(node.parent) && node === node.parent.initializer && ts3.isIdentifier(node.parent.name) && !!(ts3.getCombinedNodeFlags(node.parent) & 2);
        }
        function isPossibleCallHierarchyDeclaration(node) {
          return ts3.isSourceFile(node) || ts3.isModuleDeclaration(node) || ts3.isFunctionDeclaration(node) || ts3.isFunctionExpression(node) || ts3.isClassDeclaration(node) || ts3.isClassExpression(node) || ts3.isClassStaticBlockDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isGetAccessorDeclaration(node) || ts3.isSetAccessorDeclaration(node);
        }
        function isValidCallHierarchyDeclaration(node) {
          return ts3.isSourceFile(node) || ts3.isModuleDeclaration(node) && ts3.isIdentifier(node.name) || ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isClassStaticBlockDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isGetAccessorDeclaration(node) || ts3.isSetAccessorDeclaration(node) || isNamedExpression(node) || isConstNamedExpression(node);
        }
        function getCallHierarchyDeclarationReferenceNode(node) {
          if (ts3.isSourceFile(node))
            return node;
          if (ts3.isNamedDeclaration(node))
            return node.name;
          if (isConstNamedExpression(node))
            return node.parent.name;
          return ts3.Debug.checkDefined(node.modifiers && ts3.find(node.modifiers, isDefaultModifier));
        }
        function isDefaultModifier(node) {
          return node.kind === 88;
        }
        function getSymbolOfCallHierarchyDeclaration(typeChecker, node) {
          var location = getCallHierarchyDeclarationReferenceNode(node);
          return location && typeChecker.getSymbolAtLocation(location);
        }
        function getCallHierarchyItemName(program2, node) {
          if (ts3.isSourceFile(node)) {
            return { text: node.fileName, pos: 0, end: 0 };
          }
          if ((ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node)) && !ts3.isNamedDeclaration(node)) {
            var defaultModifier = node.modifiers && ts3.find(node.modifiers, isDefaultModifier);
            if (defaultModifier) {
              return { text: "default", pos: defaultModifier.getStart(), end: defaultModifier.getEnd() };
            }
          }
          if (ts3.isClassStaticBlockDeclaration(node)) {
            var sourceFile = node.getSourceFile();
            var pos = ts3.skipTrivia(sourceFile.text, ts3.moveRangePastModifiers(node).pos);
            var end = pos + 6;
            var typeChecker = program2.getTypeChecker();
            var symbol = typeChecker.getSymbolAtLocation(node.parent);
            var prefix = symbol ? "".concat(typeChecker.symbolToString(symbol, node.parent), " ") : "";
            return { text: "".concat(prefix, "static {}"), pos, end };
          }
          var declName = isConstNamedExpression(node) ? node.parent.name : ts3.Debug.checkDefined(ts3.getNameOfDeclaration(node), "Expected call hierarchy item to have a name");
          var text = ts3.isIdentifier(declName) ? ts3.idText(declName) : ts3.isStringOrNumericLiteralLike(declName) ? declName.text : ts3.isComputedPropertyName(declName) ? ts3.isStringOrNumericLiteralLike(declName.expression) ? declName.expression.text : void 0 : void 0;
          if (text === void 0) {
            var typeChecker = program2.getTypeChecker();
            var symbol = typeChecker.getSymbolAtLocation(declName);
            if (symbol) {
              text = typeChecker.symbolToString(symbol, node);
            }
          }
          if (text === void 0) {
            var printer_1 = ts3.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
            text = ts3.usingSingleLineStringWriter(function(writer) {
              return printer_1.writeNode(4, node, node.getSourceFile(), writer);
            });
          }
          return { text, pos: declName.getStart(), end: declName.getEnd() };
        }
        function getCallHierarchItemContainerName(node) {
          var _a, _b;
          if (isConstNamedExpression(node)) {
            if (ts3.isModuleBlock(node.parent.parent.parent.parent) && ts3.isIdentifier(node.parent.parent.parent.parent.parent.name)) {
              return node.parent.parent.parent.parent.parent.name.getText();
            }
            return;
          }
          switch (node.kind) {
            case 172:
            case 173:
            case 169:
              if (node.parent.kind === 205) {
                return (_a = ts3.getAssignedName(node.parent)) === null || _a === void 0 ? void 0 : _a.getText();
              }
              return (_b = ts3.getNameOfDeclaration(node.parent)) === null || _b === void 0 ? void 0 : _b.getText();
            case 256:
            case 257:
            case 261:
              if (ts3.isModuleBlock(node.parent) && ts3.isIdentifier(node.parent.parent.name)) {
                return node.parent.parent.name.getText();
              }
          }
        }
        function findImplementation(typeChecker, node) {
          if (node.body) {
            return node;
          }
          if (ts3.isConstructorDeclaration(node)) {
            return ts3.getFirstConstructorWithBody(node.parent);
          }
          if (ts3.isFunctionDeclaration(node) || ts3.isMethodDeclaration(node)) {
            var symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
            if (symbol && symbol.valueDeclaration && ts3.isFunctionLikeDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.body) {
              return symbol.valueDeclaration;
            }
            return void 0;
          }
          return node;
        }
        function findAllInitialDeclarations(typeChecker, node) {
          var symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
          var declarations;
          if (symbol && symbol.declarations) {
            var indices = ts3.indicesOf(symbol.declarations);
            var keys_1 = ts3.map(symbol.declarations, function(decl2) {
              return { file: decl2.getSourceFile().fileName, pos: decl2.pos };
            });
            indices.sort(function(a, b) {
              return ts3.compareStringsCaseSensitive(keys_1[a].file, keys_1[b].file) || keys_1[a].pos - keys_1[b].pos;
            });
            var sortedDeclarations = ts3.map(indices, function(i) {
              return symbol.declarations[i];
            });
            var lastDecl = void 0;
            for (var _i = 0, sortedDeclarations_1 = sortedDeclarations; _i < sortedDeclarations_1.length; _i++) {
              var decl = sortedDeclarations_1[_i];
              if (isValidCallHierarchyDeclaration(decl)) {
                if (!lastDecl || lastDecl.parent !== decl.parent || lastDecl.end !== decl.pos) {
                  declarations = ts3.append(declarations, decl);
                }
                lastDecl = decl;
              }
            }
          }
          return declarations;
        }
        function findImplementationOrAllInitialDeclarations(typeChecker, node) {
          var _a, _b, _c;
          if (ts3.isClassStaticBlockDeclaration(node)) {
            return node;
          }
          if (ts3.isFunctionLikeDeclaration(node)) {
            return (_b = (_a = findImplementation(typeChecker, node)) !== null && _a !== void 0 ? _a : findAllInitialDeclarations(typeChecker, node)) !== null && _b !== void 0 ? _b : node;
          }
          return (_c = findAllInitialDeclarations(typeChecker, node)) !== null && _c !== void 0 ? _c : node;
        }
        function resolveCallHierarchyDeclaration(program2, location) {
          var typeChecker = program2.getTypeChecker();
          var followingSymbol = false;
          while (true) {
            if (isValidCallHierarchyDeclaration(location)) {
              return findImplementationOrAllInitialDeclarations(typeChecker, location);
            }
            if (isPossibleCallHierarchyDeclaration(location)) {
              var ancestor = ts3.findAncestor(location, isValidCallHierarchyDeclaration);
              return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
            }
            if (ts3.isDeclarationName(location)) {
              if (isValidCallHierarchyDeclaration(location.parent)) {
                return findImplementationOrAllInitialDeclarations(typeChecker, location.parent);
              }
              if (isPossibleCallHierarchyDeclaration(location.parent)) {
                var ancestor = ts3.findAncestor(location.parent, isValidCallHierarchyDeclaration);
                return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
              }
              if (ts3.isVariableDeclaration(location.parent) && location.parent.initializer && isConstNamedExpression(location.parent.initializer)) {
                return location.parent.initializer;
              }
              return void 0;
            }
            if (ts3.isConstructorDeclaration(location)) {
              if (isValidCallHierarchyDeclaration(location.parent)) {
                return location.parent;
              }
              return void 0;
            }
            if (location.kind === 124 && ts3.isClassStaticBlockDeclaration(location.parent)) {
              location = location.parent;
              continue;
            }
            if (ts3.isVariableDeclaration(location) && location.initializer && isConstNamedExpression(location.initializer)) {
              return location.initializer;
            }
            if (!followingSymbol) {
              var symbol = typeChecker.getSymbolAtLocation(location);
              if (symbol) {
                if (symbol.flags & 2097152) {
                  symbol = typeChecker.getAliasedSymbol(symbol);
                }
                if (symbol.valueDeclaration) {
                  followingSymbol = true;
                  location = symbol.valueDeclaration;
                  continue;
                }
              }
            }
            return void 0;
          }
        }
        CallHierarchy2.resolveCallHierarchyDeclaration = resolveCallHierarchyDeclaration;
        function createCallHierarchyItem(program2, node) {
          var sourceFile = node.getSourceFile();
          var name = getCallHierarchyItemName(program2, node);
          var containerName = getCallHierarchItemContainerName(node);
          var kind = ts3.getNodeKind(node);
          var kindModifiers = ts3.getNodeModifiers(node);
          var span = ts3.createTextSpanFromBounds(ts3.skipTrivia(sourceFile.text, node.getFullStart(), false, true), node.getEnd());
          var selectionSpan = ts3.createTextSpanFromBounds(name.pos, name.end);
          return { file: sourceFile.fileName, kind, kindModifiers, name: name.text, containerName, span, selectionSpan };
        }
        CallHierarchy2.createCallHierarchyItem = createCallHierarchyItem;
        function isDefined(x) {
          return x !== void 0;
        }
        function convertEntryToCallSite(entry) {
          if (entry.kind === 1) {
            var node = entry.node;
            if (ts3.isCallOrNewExpressionTarget(node, true, true) || ts3.isTaggedTemplateTag(node, true, true) || ts3.isDecoratorTarget(node, true, true) || ts3.isJsxOpeningLikeElementTagName(node, true, true) || ts3.isRightSideOfPropertyAccess(node) || ts3.isArgumentExpressionOfElementAccess(node)) {
              var sourceFile = node.getSourceFile();
              var ancestor = ts3.findAncestor(node, isValidCallHierarchyDeclaration) || sourceFile;
              return { declaration: ancestor, range: ts3.createTextRangeFromNode(node, sourceFile) };
            }
          }
        }
        function getCallSiteGroupKey(entry) {
          return ts3.getNodeId(entry.declaration);
        }
        function createCallHierarchyIncomingCall(from, fromSpans) {
          return { from, fromSpans };
        }
        function convertCallSiteGroupToIncomingCall(program2, entries) {
          return createCallHierarchyIncomingCall(createCallHierarchyItem(program2, entries[0].declaration), ts3.map(entries, function(entry) {
            return ts3.createTextSpanFromRange(entry.range);
          }));
        }
        function getIncomingCalls(program2, declaration, cancellationToken) {
          if (ts3.isSourceFile(declaration) || ts3.isModuleDeclaration(declaration) || ts3.isClassStaticBlockDeclaration(declaration)) {
            return [];
          }
          var location = getCallHierarchyDeclarationReferenceNode(declaration);
          var calls = ts3.filter(ts3.FindAllReferences.findReferenceOrRenameEntries(program2, cancellationToken, program2.getSourceFiles(), location, 0, { use: 1 }, convertEntryToCallSite), isDefined);
          return calls ? ts3.group(calls, getCallSiteGroupKey, function(entries) {
            return convertCallSiteGroupToIncomingCall(program2, entries);
          }) : [];
        }
        CallHierarchy2.getIncomingCalls = getIncomingCalls;
        function createCallSiteCollector(program2, callSites) {
          function recordCallSite(node) {
            var target = ts3.isTaggedTemplateExpression(node) ? node.tag : ts3.isJsxOpeningLikeElement(node) ? node.tagName : ts3.isAccessExpression(node) ? node : ts3.isClassStaticBlockDeclaration(node) ? node : node.expression;
            var declaration = resolveCallHierarchyDeclaration(program2, target);
            if (declaration) {
              var range = ts3.createTextRangeFromNode(target, node.getSourceFile());
              if (ts3.isArray(declaration)) {
                for (var _i = 0, declaration_1 = declaration; _i < declaration_1.length; _i++) {
                  var decl = declaration_1[_i];
                  callSites.push({ declaration: decl, range });
                }
              } else {
                callSites.push({ declaration, range });
              }
            }
          }
          function collect(node) {
            if (!node)
              return;
            if (node.flags & 16777216) {
              return;
            }
            if (isValidCallHierarchyDeclaration(node)) {
              if (ts3.isClassLike(node)) {
                for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
                  var member = _a[_i];
                  if (member.name && ts3.isComputedPropertyName(member.name)) {
                    collect(member.name.expression);
                  }
                }
              }
              return;
            }
            switch (node.kind) {
              case 79:
              case 265:
              case 266:
              case 272:
              case 258:
              case 259:
                return;
              case 170:
                recordCallSite(node);
                return;
              case 211:
              case 229:
                collect(node.expression);
                return;
              case 254:
              case 164:
                collect(node.name);
                collect(node.initializer);
                return;
              case 208:
                recordCallSite(node);
                collect(node.expression);
                ts3.forEach(node.arguments, collect);
                return;
              case 209:
                recordCallSite(node);
                collect(node.expression);
                ts3.forEach(node.arguments, collect);
                return;
              case 210:
                recordCallSite(node);
                collect(node.tag);
                collect(node.template);
                return;
              case 280:
              case 279:
                recordCallSite(node);
                collect(node.tagName);
                collect(node.attributes);
                return;
              case 165:
                recordCallSite(node);
                collect(node.expression);
                return;
              case 206:
              case 207:
                recordCallSite(node);
                ts3.forEachChild(node, collect);
                break;
            }
            if (ts3.isPartOfTypeNode(node)) {
              return;
            }
            ts3.forEachChild(node, collect);
          }
          return collect;
        }
        function collectCallSitesOfSourceFile(node, collect) {
          ts3.forEach(node.statements, collect);
        }
        function collectCallSitesOfModuleDeclaration(node, collect) {
          if (!ts3.hasSyntacticModifier(node, 2) && node.body && ts3.isModuleBlock(node.body)) {
            ts3.forEach(node.body.statements, collect);
          }
        }
        function collectCallSitesOfFunctionLikeDeclaration(typeChecker, node, collect) {
          var implementation = findImplementation(typeChecker, node);
          if (implementation) {
            ts3.forEach(implementation.parameters, collect);
            collect(implementation.body);
          }
        }
        function collectCallSitesOfClassStaticBlockDeclaration(node, collect) {
          collect(node.body);
        }
        function collectCallSitesOfClassLikeDeclaration(node, collect) {
          ts3.forEach(node.decorators, collect);
          var heritage = ts3.getClassExtendsHeritageElement(node);
          if (heritage) {
            collect(heritage.expression);
          }
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            ts3.forEach(member.decorators, collect);
            if (ts3.isPropertyDeclaration(member)) {
              collect(member.initializer);
            } else if (ts3.isConstructorDeclaration(member) && member.body) {
              ts3.forEach(member.parameters, collect);
              collect(member.body);
            } else if (ts3.isClassStaticBlockDeclaration(member)) {
              collect(member);
            }
          }
        }
        function collectCallSites(program2, node) {
          var callSites = [];
          var collect = createCallSiteCollector(program2, callSites);
          switch (node.kind) {
            case 305:
              collectCallSitesOfSourceFile(node, collect);
              break;
            case 261:
              collectCallSitesOfModuleDeclaration(node, collect);
              break;
            case 256:
            case 213:
            case 214:
            case 169:
            case 172:
            case 173:
              collectCallSitesOfFunctionLikeDeclaration(program2.getTypeChecker(), node, collect);
              break;
            case 257:
            case 226:
              collectCallSitesOfClassLikeDeclaration(node, collect);
              break;
            case 170:
              collectCallSitesOfClassStaticBlockDeclaration(node, collect);
              break;
            default:
              ts3.Debug.assertNever(node);
          }
          return callSites;
        }
        function createCallHierarchyOutgoingCall(to, fromSpans) {
          return { to, fromSpans };
        }
        function convertCallSiteGroupToOutgoingCall(program2, entries) {
          return createCallHierarchyOutgoingCall(createCallHierarchyItem(program2, entries[0].declaration), ts3.map(entries, function(entry) {
            return ts3.createTextSpanFromRange(entry.range);
          }));
        }
        function getOutgoingCalls(program2, declaration) {
          if (declaration.flags & 16777216 || ts3.isMethodSignature(declaration)) {
            return [];
          }
          return ts3.group(collectCallSites(program2, declaration), getCallSiteGroupKey, function(entries) {
            return convertCallSiteGroupToOutgoingCall(program2, entries);
          });
        }
        CallHierarchy2.getOutgoingCalls = getOutgoingCalls;
      })(CallHierarchy = ts3.CallHierarchy || (ts3.CallHierarchy = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getEditsForFileRename(program2, oldFileOrDirPath, newFileOrDirPath, host, formatContext, preferences, sourceMapper) {
        var useCaseSensitiveFileNames = ts3.hostUsesCaseSensitiveFileNames(host);
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        var oldToNew = getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper);
        var newToOld = getPathUpdater(newFileOrDirPath, oldFileOrDirPath, getCanonicalFileName, sourceMapper);
        return ts3.textChanges.ChangeTracker.with({ host, formatContext, preferences }, function(changeTracker) {
          updateTsconfigFiles(program2, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, host.getCurrentDirectory(), useCaseSensitiveFileNames);
          updateImports(program2, changeTracker, oldToNew, newToOld, host, getCanonicalFileName);
        });
      }
      ts3.getEditsForFileRename = getEditsForFileRename;
      function getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper) {
        var canonicalOldPath = getCanonicalFileName(oldFileOrDirPath);
        return function(path2) {
          var originalPath = sourceMapper && sourceMapper.tryGetSourcePosition({ fileName: path2, pos: 0 });
          var updatedPath = getUpdatedPath(originalPath ? originalPath.fileName : path2);
          return originalPath ? updatedPath === void 0 ? void 0 : makeCorrespondingRelativeChange(originalPath.fileName, updatedPath, path2, getCanonicalFileName) : updatedPath;
        };
        function getUpdatedPath(pathToUpdate) {
          if (getCanonicalFileName(pathToUpdate) === canonicalOldPath)
            return newFileOrDirPath;
          var suffix = ts3.tryRemoveDirectoryPrefix(pathToUpdate, canonicalOldPath, getCanonicalFileName);
          return suffix === void 0 ? void 0 : newFileOrDirPath + "/" + suffix;
        }
      }
      ts3.getPathUpdater = getPathUpdater;
      function makeCorrespondingRelativeChange(a0, b0, a1, getCanonicalFileName) {
        var rel = ts3.getRelativePathFromFile(a0, b0, getCanonicalFileName);
        return combinePathsSafe(ts3.getDirectoryPath(a1), rel);
      }
      function updateTsconfigFiles(program2, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, currentDirectory, useCaseSensitiveFileNames) {
        var configFile = program2.getCompilerOptions().configFile;
        if (!configFile)
          return;
        var configDir = ts3.getDirectoryPath(configFile.fileName);
        var jsonObjectLiteral = ts3.getTsConfigObjectLiteralExpression(configFile);
        if (!jsonObjectLiteral)
          return;
        forEachProperty(jsonObjectLiteral, function(property, propertyName) {
          switch (propertyName) {
            case "files":
            case "include":
            case "exclude": {
              var foundExactMatch = updatePaths(property);
              if (foundExactMatch || propertyName !== "include" || !ts3.isArrayLiteralExpression(property.initializer))
                return;
              var includes = ts3.mapDefined(property.initializer.elements, function(e) {
                return ts3.isStringLiteral(e) ? e.text : void 0;
              });
              if (includes.length === 0)
                return;
              var matchers = ts3.getFileMatcherPatterns(configDir, [], includes, useCaseSensitiveFileNames, currentDirectory);
              if (ts3.getRegexFromPattern(ts3.Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames).test(oldFileOrDirPath) && !ts3.getRegexFromPattern(ts3.Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames).test(newFileOrDirPath)) {
                changeTracker.insertNodeAfter(configFile, ts3.last(property.initializer.elements), ts3.factory.createStringLiteral(relativePath(newFileOrDirPath)));
              }
              return;
            }
            case "compilerOptions":
              forEachProperty(property.initializer, function(property2, propertyName2) {
                var option = ts3.getOptionFromName(propertyName2);
                if (option && (option.isFilePath || option.type === "list" && option.element.isFilePath)) {
                  updatePaths(property2);
                } else if (propertyName2 === "paths") {
                  forEachProperty(property2.initializer, function(pathsProperty) {
                    if (!ts3.isArrayLiteralExpression(pathsProperty.initializer))
                      return;
                    for (var _i = 0, _a = pathsProperty.initializer.elements; _i < _a.length; _i++) {
                      var e = _a[_i];
                      tryUpdateString(e);
                    }
                  });
                }
              });
              return;
          }
        });
        function updatePaths(property) {
          var elements = ts3.isArrayLiteralExpression(property.initializer) ? property.initializer.elements : [property.initializer];
          var foundExactMatch = false;
          for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
            var element = elements_1[_i];
            foundExactMatch = tryUpdateString(element) || foundExactMatch;
          }
          return foundExactMatch;
        }
        function tryUpdateString(element) {
          if (!ts3.isStringLiteral(element))
            return false;
          var elementFileName = combinePathsSafe(configDir, element.text);
          var updated = oldToNew(elementFileName);
          if (updated !== void 0) {
            changeTracker.replaceRangeWithText(configFile, createStringRange(element, configFile), relativePath(updated));
            return true;
          }
          return false;
        }
        function relativePath(path2) {
          return ts3.getRelativePathFromDirectory(configDir, path2, !useCaseSensitiveFileNames);
        }
      }
      function updateImports(program2, changeTracker, oldToNew, newToOld, host, getCanonicalFileName) {
        var allFiles = program2.getSourceFiles();
        var _loop_6 = function(sourceFile2) {
          var newFromOld = oldToNew(sourceFile2.fileName);
          var newImportFromPath = newFromOld !== null && newFromOld !== void 0 ? newFromOld : sourceFile2.fileName;
          var newImportFromDirectory = ts3.getDirectoryPath(newImportFromPath);
          var oldFromNew = newToOld(sourceFile2.fileName);
          var oldImportFromPath = oldFromNew || sourceFile2.fileName;
          var oldImportFromDirectory = ts3.getDirectoryPath(oldImportFromPath);
          var importingSourceFileMoved = newFromOld !== void 0 || oldFromNew !== void 0;
          updateImportsWorker(sourceFile2, changeTracker, function(referenceText) {
            if (!ts3.pathIsRelative(referenceText))
              return void 0;
            var oldAbsolute = combinePathsSafe(oldImportFromDirectory, referenceText);
            var newAbsolute = oldToNew(oldAbsolute);
            return newAbsolute === void 0 ? void 0 : ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(newImportFromDirectory, newAbsolute, getCanonicalFileName));
          }, function(importLiteral) {
            var importedModuleSymbol = program2.getTypeChecker().getSymbolAtLocation(importLiteral);
            if ((importedModuleSymbol === null || importedModuleSymbol === void 0 ? void 0 : importedModuleSymbol.declarations) && importedModuleSymbol.declarations.some(function(d) {
              return ts3.isAmbientModule(d);
            }))
              return void 0;
            var toImport = oldFromNew !== void 0 ? getSourceFileToImportFromResolved(importLiteral, ts3.resolveModuleName(importLiteral.text, oldImportFromPath, program2.getCompilerOptions(), host), oldToNew, allFiles) : getSourceFileToImport(importedModuleSymbol, importLiteral, sourceFile2, program2, host, oldToNew);
            return toImport !== void 0 && (toImport.updated || importingSourceFileMoved && ts3.pathIsRelative(importLiteral.text)) ? ts3.moduleSpecifiers.updateModuleSpecifier(program2.getCompilerOptions(), sourceFile2, getCanonicalFileName(newImportFromPath), toImport.newFileName, ts3.createModuleSpecifierResolutionHost(program2, host), importLiteral.text) : void 0;
          });
        };
        for (var _i = 0, allFiles_1 = allFiles; _i < allFiles_1.length; _i++) {
          var sourceFile = allFiles_1[_i];
          _loop_6(sourceFile);
        }
      }
      function combineNormal(pathA, pathB) {
        return ts3.normalizePath(ts3.combinePaths(pathA, pathB));
      }
      function combinePathsSafe(pathA, pathB) {
        return ts3.ensurePathIsNonModuleName(combineNormal(pathA, pathB));
      }
      function getSourceFileToImport(importedModuleSymbol, importLiteral, importingSourceFile, program2, host, oldToNew) {
        if (importedModuleSymbol) {
          var oldFileName = ts3.find(importedModuleSymbol.declarations, ts3.isSourceFile).fileName;
          var newFileName = oldToNew(oldFileName);
          return newFileName === void 0 ? { newFileName: oldFileName, updated: false } : { newFileName, updated: true };
        } else {
          var mode = ts3.getModeForUsageLocation(importingSourceFile, importLiteral);
          var resolved = host.resolveModuleNames ? host.getResolvedModuleWithFailedLookupLocationsFromCache && host.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName, mode) : program2.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName, mode);
          return getSourceFileToImportFromResolved(importLiteral, resolved, oldToNew, program2.getSourceFiles());
        }
      }
      function getSourceFileToImportFromResolved(importLiteral, resolved, oldToNew, sourceFiles) {
        if (!resolved)
          return void 0;
        if (resolved.resolvedModule) {
          var result_3 = tryChange(resolved.resolvedModule.resolvedFileName);
          if (result_3)
            return result_3;
        }
        var result2 = ts3.forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJsonExisting) || ts3.pathIsRelative(importLiteral.text) && ts3.forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJson);
        if (result2)
          return result2;
        return resolved.resolvedModule && { newFileName: resolved.resolvedModule.resolvedFileName, updated: false };
        function tryChangeWithIgnoringPackageJsonExisting(oldFileName) {
          var newFileName = oldToNew(oldFileName);
          return newFileName && ts3.find(sourceFiles, function(src) {
            return src.fileName === newFileName;
          }) ? tryChangeWithIgnoringPackageJson(oldFileName) : void 0;
        }
        function tryChangeWithIgnoringPackageJson(oldFileName) {
          return !ts3.endsWith(oldFileName, "/package.json") ? tryChange(oldFileName) : void 0;
        }
        function tryChange(oldFileName) {
          var newFileName = oldToNew(oldFileName);
          return newFileName && { newFileName, updated: true };
        }
      }
      function updateImportsWorker(sourceFile, changeTracker, updateRef, updateImport) {
        for (var _i = 0, _a = sourceFile.referencedFiles || ts3.emptyArray; _i < _a.length; _i++) {
          var ref = _a[_i];
          var updated = updateRef(ref.fileName);
          if (updated !== void 0 && updated !== sourceFile.text.slice(ref.pos, ref.end))
            changeTracker.replaceRangeWithText(sourceFile, ref, updated);
        }
        for (var _b = 0, _c = sourceFile.imports; _b < _c.length; _b++) {
          var importStringLiteral = _c[_b];
          var updated = updateImport(importStringLiteral);
          if (updated !== void 0 && updated !== importStringLiteral.text)
            changeTracker.replaceRangeWithText(sourceFile, createStringRange(importStringLiteral, sourceFile), updated);
        }
      }
      function createStringRange(node, sourceFile) {
        return ts3.createRange(node.getStart(sourceFile) + 1, node.end - 1);
      }
      function forEachProperty(objectLiteral, cb) {
        if (!ts3.isObjectLiteralExpression(objectLiteral))
          return;
        for (var _i = 0, _a = objectLiteral.properties; _i < _a.length; _i++) {
          var property = _a[_i];
          if (ts3.isPropertyAssignment(property) && ts3.isStringLiteral(property.name)) {
            cb(property, property.name.text);
          }
        }
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var GoToDefinition;
      (function(GoToDefinition2) {
        function getDefinitionAtPosition(program2, sourceFile, position, searchOtherFilesOnly, stopAtAlias) {
          var _a;
          var _b;
          var resolvedRef = getReferenceAtPosition(sourceFile, position, program2);
          var fileReferenceDefinition = resolvedRef && [getDefinitionInfoForFileReference(resolvedRef.reference.fileName, resolvedRef.fileName, resolvedRef.unverified)] || ts3.emptyArray;
          if (resolvedRef === null || resolvedRef === void 0 ? void 0 : resolvedRef.file) {
            return fileReferenceDefinition;
          }
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var parent = node.parent;
          var typeChecker = program2.getTypeChecker();
          if (node.kind === 159 || ts3.isJSDocOverrideTag(node) && ts3.rangeContainsPosition(node.tagName, position)) {
            return getDefinitionFromOverriddenMember(typeChecker, node) || ts3.emptyArray;
          }
          if (ts3.isJumpStatementTarget(node)) {
            var label = ts3.getTargetLabel(node.parent, node.text);
            return label ? [createDefinitionInfoFromName(typeChecker, label, "label", node.text, void 0)] : void 0;
          }
          if (ts3.isStaticModifier(node) && ts3.isClassStaticBlockDeclaration(node.parent)) {
            var classDecl = node.parent.parent;
            var _c = getSymbol(classDecl, typeChecker, stopAtAlias), symbol_1 = _c.symbol, failedAliasResolution_1 = _c.failedAliasResolution;
            var staticBlocks = ts3.filter(classDecl.members, ts3.isClassStaticBlockDeclaration);
            var containerName_1 = symbol_1 ? typeChecker.symbolToString(symbol_1, classDecl) : "";
            var sourceFile_1 = node.getSourceFile();
            return ts3.map(staticBlocks, function(staticBlock) {
              var pos = ts3.moveRangePastModifiers(staticBlock).pos;
              pos = ts3.skipTrivia(sourceFile_1.text, pos);
              return createDefinitionInfoFromName(typeChecker, staticBlock, "constructor", "static {}", containerName_1, false, failedAliasResolution_1, { start: pos, length: "static".length });
            });
          }
          var _d = getSymbol(node, typeChecker, stopAtAlias), symbol = _d.symbol, failedAliasResolution = _d.failedAliasResolution;
          var fallbackNode = node;
          if (searchOtherFilesOnly && failedAliasResolution) {
            var importDeclaration = ts3.forEach(__spreadArray([node], (symbol === null || symbol === void 0 ? void 0 : symbol.declarations) || ts3.emptyArray, true), function(n) {
              return ts3.findAncestor(n, ts3.isAnyImportOrBareOrAccessedRequire);
            });
            var moduleSpecifier = importDeclaration && ts3.tryGetModuleSpecifierFromDeclaration(importDeclaration);
            if (moduleSpecifier) {
              _a = getSymbol(moduleSpecifier, typeChecker, stopAtAlias), symbol = _a.symbol, failedAliasResolution = _a.failedAliasResolution;
              fallbackNode = moduleSpecifier;
            }
          }
          if (!symbol && ts3.isModuleSpecifierLike(fallbackNode)) {
            var ref = (_b = sourceFile.resolvedModules) === null || _b === void 0 ? void 0 : _b.get(fallbackNode.text, ts3.getModeForUsageLocation(sourceFile, fallbackNode));
            if (ref) {
              return [{
                name: fallbackNode.text,
                fileName: ref.resolvedFileName,
                containerName: void 0,
                containerKind: void 0,
                kind: "script",
                textSpan: ts3.createTextSpan(0, 0),
                failedAliasResolution,
                isAmbient: ts3.isDeclarationFileName(ref.resolvedFileName),
                unverified: fallbackNode !== node
              }];
            }
          }
          if (!symbol) {
            return ts3.concatenate(fileReferenceDefinition, getDefinitionInfoForIndexSignatures(node, typeChecker));
          }
          if (searchOtherFilesOnly && ts3.every(symbol.declarations, function(d) {
            return d.getSourceFile().fileName === sourceFile.fileName;
          }))
            return void 0;
          var calledDeclaration = tryGetSignatureDeclaration(typeChecker, node);
          if (calledDeclaration && !(ts3.isJsxOpeningLikeElement(node.parent) && isConstructorLike(calledDeclaration))) {
            var sigInfo = createDefinitionFromSignatureDeclaration(typeChecker, calledDeclaration, failedAliasResolution);
            if (typeChecker.getRootSymbols(symbol).some(function(s) {
              return symbolMatchesSignature(s, calledDeclaration);
            })) {
              return [sigInfo];
            } else {
              var defs = getDefinitionFromSymbol(typeChecker, symbol, node, failedAliasResolution, calledDeclaration) || ts3.emptyArray;
              return node.kind === 106 ? __spreadArray([sigInfo], defs, true) : __spreadArray(__spreadArray([], defs, true), [sigInfo], false);
            }
          }
          if (node.parent.kind === 297) {
            var shorthandSymbol_1 = typeChecker.getShorthandAssignmentValueSymbol(symbol.valueDeclaration);
            var definitions = (shorthandSymbol_1 === null || shorthandSymbol_1 === void 0 ? void 0 : shorthandSymbol_1.declarations) ? shorthandSymbol_1.declarations.map(function(decl) {
              return createDefinitionInfo(decl, typeChecker, shorthandSymbol_1, node, false, failedAliasResolution);
            }) : ts3.emptyArray;
            return ts3.concatenate(definitions, getDefinitionFromObjectLiteralElement(typeChecker, node) || ts3.emptyArray);
          }
          if (ts3.isPropertyName(node) && ts3.isBindingElement(parent) && ts3.isObjectBindingPattern(parent.parent) && node === (parent.propertyName || parent.name)) {
            var name_3 = ts3.getNameFromPropertyName(node);
            var type2 = typeChecker.getTypeAtLocation(parent.parent);
            return name_3 === void 0 ? ts3.emptyArray : ts3.flatMap(type2.isUnion() ? type2.types : [type2], function(t) {
              var prop = t.getProperty(name_3);
              return prop && getDefinitionFromSymbol(typeChecker, prop, node);
            });
          }
          return ts3.concatenate(fileReferenceDefinition, getDefinitionFromObjectLiteralElement(typeChecker, node) || getDefinitionFromSymbol(typeChecker, symbol, node, failedAliasResolution));
        }
        GoToDefinition2.getDefinitionAtPosition = getDefinitionAtPosition;
        function symbolMatchesSignature(s, calledDeclaration) {
          return s === calledDeclaration.symbol || s === calledDeclaration.symbol.parent || ts3.isAssignmentExpression(calledDeclaration.parent) || !ts3.isCallLikeExpression(calledDeclaration.parent) && s === calledDeclaration.parent.symbol;
        }
        function getDefinitionFromObjectLiteralElement(typeChecker, node) {
          var element = ts3.getContainingObjectLiteralElement(node);
          if (element) {
            var contextualType = element && typeChecker.getContextualType(element.parent);
            if (contextualType) {
              return ts3.flatMap(ts3.getPropertySymbolsFromContextualType(element, typeChecker, contextualType, false), function(propertySymbol) {
                return getDefinitionFromSymbol(typeChecker, propertySymbol, node);
              });
            }
          }
        }
        function getDefinitionFromOverriddenMember(typeChecker, node) {
          var classElement = ts3.findAncestor(node, ts3.isClassElement);
          if (!(classElement && classElement.name))
            return;
          var baseDeclaration = ts3.findAncestor(classElement, ts3.isClassLike);
          if (!baseDeclaration)
            return;
          var baseTypeNode = ts3.getEffectiveBaseTypeNode(baseDeclaration);
          var baseType = baseTypeNode ? typeChecker.getTypeAtLocation(baseTypeNode) : void 0;
          if (!baseType)
            return;
          var name = ts3.unescapeLeadingUnderscores(ts3.getTextOfPropertyName(classElement.name));
          var symbol = ts3.hasStaticModifier(classElement) ? typeChecker.getPropertyOfType(typeChecker.getTypeOfSymbolAtLocation(baseType.symbol, baseDeclaration), name) : typeChecker.getPropertyOfType(baseType, name);
          if (!symbol)
            return;
          return getDefinitionFromSymbol(typeChecker, symbol, node);
        }
        function getReferenceAtPosition(sourceFile, position, program2) {
          var _a, _b;
          var referencePath = findReferenceInPosition(sourceFile.referencedFiles, position);
          if (referencePath) {
            var file = program2.getSourceFileFromReference(sourceFile, referencePath);
            return file && { reference: referencePath, fileName: file.fileName, file, unverified: false };
          }
          var typeReferenceDirective = findReferenceInPosition(sourceFile.typeReferenceDirectives, position);
          if (typeReferenceDirective) {
            var reference = program2.getResolvedTypeReferenceDirectives().get(typeReferenceDirective.fileName, typeReferenceDirective.resolutionMode || sourceFile.impliedNodeFormat);
            var file = reference && program2.getSourceFile(reference.resolvedFileName);
            return file && { reference: typeReferenceDirective, fileName: file.fileName, file, unverified: false };
          }
          var libReferenceDirective = findReferenceInPosition(sourceFile.libReferenceDirectives, position);
          if (libReferenceDirective) {
            var file = program2.getLibFileFromReference(libReferenceDirective);
            return file && { reference: libReferenceDirective, fileName: file.fileName, file, unverified: false };
          }
          if ((_a = sourceFile.resolvedModules) === null || _a === void 0 ? void 0 : _a.size()) {
            var node = ts3.getTouchingToken(sourceFile, position);
            if (ts3.isModuleSpecifierLike(node) && ts3.isExternalModuleNameRelative(node.text) && sourceFile.resolvedModules.has(node.text, ts3.getModeForUsageLocation(sourceFile, node))) {
              var verifiedFileName = (_b = sourceFile.resolvedModules.get(node.text, ts3.getModeForUsageLocation(sourceFile, node))) === null || _b === void 0 ? void 0 : _b.resolvedFileName;
              var fileName2 = verifiedFileName || ts3.resolvePath(ts3.getDirectoryPath(sourceFile.fileName), node.text);
              return {
                file: program2.getSourceFile(fileName2),
                fileName: fileName2,
                reference: {
                  pos: node.getStart(),
                  end: node.getEnd(),
                  fileName: node.text
                },
                unverified: !verifiedFileName
              };
            }
          }
          return void 0;
        }
        GoToDefinition2.getReferenceAtPosition = getReferenceAtPosition;
        function getTypeDefinitionAtPosition(typeChecker, sourceFile, position) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          if (ts3.isImportMeta(node.parent) && node.parent.name === node) {
            return definitionFromType(typeChecker.getTypeAtLocation(node.parent), typeChecker, node.parent, false);
          }
          var _a = getSymbol(node, typeChecker, false), symbol = _a.symbol, failedAliasResolution = _a.failedAliasResolution;
          if (!symbol)
            return void 0;
          var typeAtLocation = typeChecker.getTypeOfSymbolAtLocation(symbol, node);
          var returnType = tryGetReturnTypeOfFunction(symbol, typeAtLocation, typeChecker);
          var fromReturnType = returnType && definitionFromType(returnType, typeChecker, node, failedAliasResolution);
          var typeDefinitions = fromReturnType && fromReturnType.length !== 0 ? fromReturnType : definitionFromType(typeAtLocation, typeChecker, node, failedAliasResolution);
          return typeDefinitions.length ? typeDefinitions : !(symbol.flags & 111551) && symbol.flags & 788968 ? getDefinitionFromSymbol(typeChecker, ts3.skipAlias(symbol, typeChecker), node, failedAliasResolution) : void 0;
        }
        GoToDefinition2.getTypeDefinitionAtPosition = getTypeDefinitionAtPosition;
        function definitionFromType(type2, checker, node, failedAliasResolution) {
          return ts3.flatMap(type2.isUnion() && !(type2.flags & 32) ? type2.types : [type2], function(t) {
            return t.symbol && getDefinitionFromSymbol(checker, t.symbol, node, failedAliasResolution);
          });
        }
        function tryGetReturnTypeOfFunction(symbol, type2, checker) {
          if (type2.symbol === symbol || symbol.valueDeclaration && type2.symbol && ts3.isVariableDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.initializer === type2.symbol.valueDeclaration) {
            var sigs = type2.getCallSignatures();
            if (sigs.length === 1)
              return checker.getReturnTypeOfSignature(ts3.first(sigs));
          }
          return void 0;
        }
        function getDefinitionAndBoundSpan(program2, sourceFile, position) {
          var definitions = getDefinitionAtPosition(program2, sourceFile, position);
          if (!definitions || definitions.length === 0) {
            return void 0;
          }
          var comment = findReferenceInPosition(sourceFile.referencedFiles, position) || findReferenceInPosition(sourceFile.typeReferenceDirectives, position) || findReferenceInPosition(sourceFile.libReferenceDirectives, position);
          if (comment) {
            return { definitions, textSpan: ts3.createTextSpanFromRange(comment) };
          }
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          var textSpan = ts3.createTextSpan(node.getStart(), node.getWidth());
          return { definitions, textSpan };
        }
        GoToDefinition2.getDefinitionAndBoundSpan = getDefinitionAndBoundSpan;
        function getDefinitionInfoForIndexSignatures(node, checker) {
          return ts3.mapDefined(checker.getIndexInfosAtLocation(node), function(info) {
            return info.declaration && createDefinitionFromSignatureDeclaration(checker, info.declaration);
          });
        }
        function getSymbol(node, checker, stopAtAlias) {
          var symbol = checker.getSymbolAtLocation(node);
          var failedAliasResolution = false;
          if ((symbol === null || symbol === void 0 ? void 0 : symbol.declarations) && symbol.flags & 2097152 && !stopAtAlias && shouldSkipAlias(node, symbol.declarations[0])) {
            var aliased = checker.getAliasedSymbol(symbol);
            if (aliased.declarations) {
              return { symbol: aliased };
            } else {
              failedAliasResolution = true;
            }
          }
          return { symbol, failedAliasResolution };
        }
        function shouldSkipAlias(node, declaration) {
          if (node.kind !== 79) {
            return false;
          }
          if (node.parent === declaration) {
            return true;
          }
          if (declaration.kind === 268) {
            return false;
          }
          return true;
        }
        function isExpandoDeclaration(node) {
          if (!ts3.isAssignmentDeclaration(node))
            return false;
          var containingAssignment = ts3.findAncestor(node, function(p) {
            if (ts3.isAssignmentExpression(p))
              return true;
            if (!ts3.isAssignmentDeclaration(p))
              return "quit";
            return false;
          });
          return !!containingAssignment && ts3.getAssignmentDeclarationKind(containingAssignment) === 5;
        }
        function getDefinitionFromSymbol(typeChecker, symbol, node, failedAliasResolution, excludeDeclaration) {
          var filteredDeclarations = ts3.filter(symbol.declarations, function(d) {
            return d !== excludeDeclaration;
          });
          var withoutExpandos = ts3.filter(filteredDeclarations, function(d) {
            return !isExpandoDeclaration(d);
          });
          var results = ts3.some(withoutExpandos) ? withoutExpandos : filteredDeclarations;
          return getConstructSignatureDefinition() || getCallSignatureDefinition() || ts3.map(results, function(declaration) {
            return createDefinitionInfo(declaration, typeChecker, symbol, node, false, failedAliasResolution);
          });
          function getConstructSignatureDefinition() {
            if (symbol.flags & 32 && !(symbol.flags & (16 | 3)) && (ts3.isNewExpressionTarget(node) || node.kind === 134)) {
              var cls = ts3.find(filteredDeclarations, ts3.isClassLike) || ts3.Debug.fail("Expected declaration to have at least one class-like declaration");
              return getSignatureDefinition(cls.members, true);
            }
          }
          function getCallSignatureDefinition() {
            return ts3.isCallOrNewExpressionTarget(node) || ts3.isNameOfFunctionDeclaration(node) ? getSignatureDefinition(filteredDeclarations, false) : void 0;
          }
          function getSignatureDefinition(signatureDeclarations, selectConstructors) {
            if (!signatureDeclarations) {
              return void 0;
            }
            var declarations = signatureDeclarations.filter(selectConstructors ? ts3.isConstructorDeclaration : ts3.isFunctionLike);
            var declarationsWithBody = declarations.filter(function(d) {
              return !!d.body;
            });
            return declarations.length ? declarationsWithBody.length !== 0 ? declarationsWithBody.map(function(x) {
              return createDefinitionInfo(x, typeChecker, symbol, node);
            }) : [createDefinitionInfo(ts3.last(declarations), typeChecker, symbol, node, false, failedAliasResolution)] : void 0;
          }
        }
        function createDefinitionInfo(declaration, checker, symbol, node, unverified, failedAliasResolution) {
          var symbolName = checker.symbolToString(symbol);
          var symbolKind = ts3.SymbolDisplay.getSymbolKind(checker, symbol, node);
          var containerName = symbol.parent ? checker.symbolToString(symbol.parent, node) : "";
          return createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName, containerName, unverified, failedAliasResolution);
        }
        GoToDefinition2.createDefinitionInfo = createDefinitionInfo;
        function createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName, containerName, unverified, failedAliasResolution, textSpan) {
          var sourceFile = declaration.getSourceFile();
          if (!textSpan) {
            var name = ts3.getNameOfDeclaration(declaration) || declaration;
            textSpan = ts3.createTextSpanFromNode(name, sourceFile);
          }
          return __assign(__assign({
            fileName: sourceFile.fileName,
            textSpan,
            kind: symbolKind,
            name: symbolName,
            containerKind: void 0,
            containerName
          }, ts3.FindAllReferences.toContextSpan(textSpan, sourceFile, ts3.FindAllReferences.getContextNode(declaration))), { isLocal: !isDefinitionVisible(checker, declaration), isAmbient: !!(declaration.flags & 16777216), unverified, failedAliasResolution });
        }
        function isDefinitionVisible(checker, declaration) {
          if (checker.isDeclarationVisible(declaration))
            return true;
          if (!declaration.parent)
            return false;
          if (ts3.hasInitializer(declaration.parent) && declaration.parent.initializer === declaration)
            return isDefinitionVisible(checker, declaration.parent);
          switch (declaration.kind) {
            case 167:
            case 172:
            case 173:
            case 169:
              if (ts3.hasEffectiveModifier(declaration, 8))
                return false;
            case 171:
            case 296:
            case 297:
            case 205:
            case 226:
            case 214:
            case 213:
              return isDefinitionVisible(checker, declaration.parent);
            default:
              return false;
          }
        }
        function createDefinitionFromSignatureDeclaration(typeChecker, decl, failedAliasResolution) {
          return createDefinitionInfo(decl, typeChecker, decl.symbol, decl, false, failedAliasResolution);
        }
        function findReferenceInPosition(refs, pos) {
          return ts3.find(refs, function(ref) {
            return ts3.textRangeContainsPositionInclusive(ref, pos);
          });
        }
        GoToDefinition2.findReferenceInPosition = findReferenceInPosition;
        function getDefinitionInfoForFileReference(name, targetFileName, unverified) {
          return {
            fileName: targetFileName,
            textSpan: ts3.createTextSpanFromBounds(0, 0),
            kind: "script",
            name,
            containerName: void 0,
            containerKind: void 0,
            unverified
          };
        }
        function getAncestorCallLikeExpression(node) {
          var target = ts3.findAncestor(node, function(n) {
            return !ts3.isRightSideOfPropertyAccess(n);
          });
          var callLike = target === null || target === void 0 ? void 0 : target.parent;
          return callLike && ts3.isCallLikeExpression(callLike) && ts3.getInvokedExpression(callLike) === target ? callLike : void 0;
        }
        function tryGetSignatureDeclaration(typeChecker, node) {
          var callLike = getAncestorCallLikeExpression(node);
          var signature = callLike && typeChecker.getResolvedSignature(callLike);
          return ts3.tryCast(signature && signature.declaration, function(d) {
            return ts3.isFunctionLike(d) && !ts3.isFunctionTypeNode(d);
          });
        }
        function isConstructorLike(node) {
          switch (node.kind) {
            case 171:
            case 180:
            case 175:
              return true;
            default:
              return false;
          }
        }
      })(GoToDefinition = ts3.GoToDefinition || (ts3.GoToDefinition = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var JsDoc;
      (function(JsDoc2) {
        var jsDocTagNames = [
          "abstract",
          "access",
          "alias",
          "argument",
          "async",
          "augments",
          "author",
          "borrows",
          "callback",
          "class",
          "classdesc",
          "constant",
          "constructor",
          "constructs",
          "copyright",
          "default",
          "deprecated",
          "description",
          "emits",
          "enum",
          "event",
          "example",
          "exports",
          "extends",
          "external",
          "field",
          "file",
          "fileoverview",
          "fires",
          "function",
          "generator",
          "global",
          "hideconstructor",
          "host",
          "ignore",
          "implements",
          "inheritdoc",
          "inner",
          "instance",
          "interface",
          "kind",
          "lends",
          "license",
          "link",
          "listens",
          "member",
          "memberof",
          "method",
          "mixes",
          "module",
          "name",
          "namespace",
          "override",
          "package",
          "param",
          "private",
          "property",
          "protected",
          "public",
          "readonly",
          "requires",
          "returns",
          "see",
          "since",
          "static",
          "summary",
          "template",
          "this",
          "throws",
          "todo",
          "tutorial",
          "type",
          "typedef",
          "var",
          "variation",
          "version",
          "virtual",
          "yields"
        ];
        var jsDocTagNameCompletionEntries;
        var jsDocTagCompletionEntries;
        function getJsDocCommentsFromDeclarations(declarations, checker) {
          var parts = [];
          ts3.forEachUnique(declarations, function(declaration) {
            for (var _i = 0, _a = getCommentHavingNodes(declaration); _i < _a.length; _i++) {
              var jsdoc = _a[_i];
              if (jsdoc.comment === void 0 || ts3.isJSDoc(jsdoc) && declaration.kind !== 345 && declaration.kind !== 338 && jsdoc.tags && jsdoc.tags.some(function(t) {
                return t.kind === 345 || t.kind === 338;
              }) && !jsdoc.tags.some(function(t) {
                return t.kind === 340 || t.kind === 341;
              })) {
                continue;
              }
              var newparts = getDisplayPartsFromComment(jsdoc.comment, checker);
              if (!ts3.contains(parts, newparts, isIdenticalListOfDisplayParts)) {
                parts.push(newparts);
              }
            }
          });
          return ts3.flatten(ts3.intersperse(parts, [ts3.lineBreakPart()]));
        }
        JsDoc2.getJsDocCommentsFromDeclarations = getJsDocCommentsFromDeclarations;
        function isIdenticalListOfDisplayParts(parts1, parts2) {
          return ts3.arraysEqual(parts1, parts2, function(p1, p2) {
            return p1.kind === p2.kind && p1.text === p2.text;
          });
        }
        function getCommentHavingNodes(declaration) {
          switch (declaration.kind) {
            case 340:
            case 347:
              return [declaration];
            case 338:
            case 345:
              return [declaration, declaration.parent];
            default:
              return ts3.getJSDocCommentsAndTags(declaration);
          }
        }
        function getJsDocTagsFromDeclarations(declarations, checker) {
          var infos = [];
          ts3.forEachUnique(declarations, function(declaration) {
            var tags = ts3.getJSDocTags(declaration);
            if (tags.some(function(t) {
              return t.kind === 345 || t.kind === 338;
            }) && !tags.some(function(t) {
              return t.kind === 340 || t.kind === 341;
            })) {
              return;
            }
            for (var _i = 0, tags_1 = tags; _i < tags_1.length; _i++) {
              var tag = tags_1[_i];
              infos.push({ name: tag.tagName.text, text: getCommentDisplayParts(tag, checker) });
            }
          });
          return infos;
        }
        JsDoc2.getJsDocTagsFromDeclarations = getJsDocTagsFromDeclarations;
        function getDisplayPartsFromComment(comment, checker) {
          if (typeof comment === "string") {
            return [ts3.textPart(comment)];
          }
          return ts3.flatMap(comment, function(node) {
            return node.kind === 321 ? [ts3.textPart(node.text)] : ts3.buildLinkParts(node, checker);
          });
        }
        function getCommentDisplayParts(tag, checker) {
          var comment = tag.comment, kind = tag.kind;
          var namePart = getTagNameDisplayPart(kind);
          switch (kind) {
            case 329:
              return withNode(tag.class);
            case 328:
              return withNode(tag.class);
            case 344:
              var templateTag = tag;
              var displayParts_3 = [];
              if (templateTag.constraint) {
                displayParts_3.push(ts3.textPart(templateTag.constraint.getText()));
              }
              if (ts3.length(templateTag.typeParameters)) {
                if (ts3.length(displayParts_3)) {
                  displayParts_3.push(ts3.spacePart());
                }
                var lastTypeParameter_1 = templateTag.typeParameters[templateTag.typeParameters.length - 1];
                ts3.forEach(templateTag.typeParameters, function(tp) {
                  displayParts_3.push(namePart(tp.getText()));
                  if (lastTypeParameter_1 !== tp) {
                    displayParts_3.push.apply(displayParts_3, [ts3.punctuationPart(27), ts3.spacePart()]);
                  }
                });
              }
              if (comment) {
                displayParts_3.push.apply(displayParts_3, __spreadArray([ts3.spacePart()], getDisplayPartsFromComment(comment, checker), true));
              }
              return displayParts_3;
            case 343:
              return withNode(tag.typeExpression);
            case 345:
            case 338:
            case 347:
            case 340:
            case 346:
              var name = tag.name;
              return name ? withNode(name) : comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
            default:
              return comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
          }
          function withNode(node) {
            return addComment(node.getText());
          }
          function addComment(s) {
            if (comment) {
              if (s.match(/^https?$/)) {
                return __spreadArray([ts3.textPart(s)], getDisplayPartsFromComment(comment, checker), true);
              } else {
                return __spreadArray([namePart(s), ts3.spacePart()], getDisplayPartsFromComment(comment, checker), true);
              }
            } else {
              return [ts3.textPart(s)];
            }
          }
        }
        function getTagNameDisplayPart(kind) {
          switch (kind) {
            case 340:
              return ts3.parameterNamePart;
            case 347:
              return ts3.propertyNamePart;
            case 344:
              return ts3.typeParameterNamePart;
            case 345:
            case 338:
              return ts3.typeAliasNamePart;
            default:
              return ts3.textPart;
          }
        }
        function getJSDocTagNameCompletions() {
          return jsDocTagNameCompletionEntries || (jsDocTagNameCompletionEntries = ts3.map(jsDocTagNames, function(tagName) {
            return {
              name: tagName,
              kind: "keyword",
              kindModifiers: "",
              sortText: ts3.Completions.SortText.LocationPriority
            };
          }));
        }
        JsDoc2.getJSDocTagNameCompletions = getJSDocTagNameCompletions;
        JsDoc2.getJSDocTagNameCompletionDetails = getJSDocTagCompletionDetails;
        function getJSDocTagCompletions() {
          return jsDocTagCompletionEntries || (jsDocTagCompletionEntries = ts3.map(jsDocTagNames, function(tagName) {
            return {
              name: "@".concat(tagName),
              kind: "keyword",
              kindModifiers: "",
              sortText: ts3.Completions.SortText.LocationPriority
            };
          }));
        }
        JsDoc2.getJSDocTagCompletions = getJSDocTagCompletions;
        function getJSDocTagCompletionDetails(name) {
          return {
            name,
            kind: "",
            kindModifiers: "",
            displayParts: [ts3.textPart(name)],
            documentation: ts3.emptyArray,
            tags: void 0,
            codeActions: void 0
          };
        }
        JsDoc2.getJSDocTagCompletionDetails = getJSDocTagCompletionDetails;
        function getJSDocParameterNameCompletions(tag) {
          if (!ts3.isIdentifier(tag.name)) {
            return ts3.emptyArray;
          }
          var nameThusFar = tag.name.text;
          var jsdoc = tag.parent;
          var fn = jsdoc.parent;
          if (!ts3.isFunctionLike(fn))
            return [];
          return ts3.mapDefined(fn.parameters, function(param) {
            if (!ts3.isIdentifier(param.name))
              return void 0;
            var name = param.name.text;
            if (jsdoc.tags.some(function(t) {
              return t !== tag && ts3.isJSDocParameterTag(t) && ts3.isIdentifier(t.name) && t.name.escapedText === name;
            }) || nameThusFar !== void 0 && !ts3.startsWith(name, nameThusFar)) {
              return void 0;
            }
            return { name, kind: "parameter", kindModifiers: "", sortText: ts3.Completions.SortText.LocationPriority };
          });
        }
        JsDoc2.getJSDocParameterNameCompletions = getJSDocParameterNameCompletions;
        function getJSDocParameterNameCompletionDetails(name) {
          return {
            name,
            kind: "parameter",
            kindModifiers: "",
            displayParts: [ts3.textPart(name)],
            documentation: ts3.emptyArray,
            tags: void 0,
            codeActions: void 0
          };
        }
        JsDoc2.getJSDocParameterNameCompletionDetails = getJSDocParameterNameCompletionDetails;
        function getDocCommentTemplateAtPosition(newLine, sourceFile, position, options) {
          var tokenAtPos = ts3.getTokenAtPosition(sourceFile, position);
          var existingDocComment = ts3.findAncestor(tokenAtPos, ts3.isJSDoc);
          if (existingDocComment && (existingDocComment.comment !== void 0 || ts3.length(existingDocComment.tags))) {
            return void 0;
          }
          var tokenStart = tokenAtPos.getStart(sourceFile);
          if (!existingDocComment && tokenStart < position) {
            return void 0;
          }
          var commentOwnerInfo = getCommentOwnerInfo(tokenAtPos, options);
          if (!commentOwnerInfo) {
            return void 0;
          }
          var commentOwner = commentOwnerInfo.commentOwner, parameters = commentOwnerInfo.parameters, hasReturn2 = commentOwnerInfo.hasReturn;
          var commentOwnerJSDoc = ts3.hasJSDocNodes(commentOwner) && commentOwner.jsDoc ? ts3.lastOrUndefined(commentOwner.jsDoc) : void 0;
          if (commentOwner.getStart(sourceFile) < position || commentOwnerJSDoc && commentOwnerJSDoc !== existingDocComment) {
            return void 0;
          }
          var indentationStr = getIndentationStringAtPosition(sourceFile, position);
          var isJavaScriptFile = ts3.hasJSFileExtension(sourceFile.fileName);
          var tags = (parameters ? parameterDocComments(parameters || [], isJavaScriptFile, indentationStr, newLine) : "") + (hasReturn2 ? returnsDocComment(indentationStr, newLine) : "");
          var openComment = "/**";
          var closeComment = " */";
          if (tags) {
            var preamble = openComment + newLine + indentationStr + " * ";
            var endLine = tokenStart === position ? newLine + indentationStr : "";
            var result2 = preamble + newLine + tags + indentationStr + closeComment + endLine;
            return { newText: result2, caretOffset: preamble.length };
          }
          return { newText: openComment + closeComment, caretOffset: 3 };
        }
        JsDoc2.getDocCommentTemplateAtPosition = getDocCommentTemplateAtPosition;
        function getIndentationStringAtPosition(sourceFile, position) {
          var text = sourceFile.text;
          var lineStart = ts3.getLineStartPositionForPosition(position, sourceFile);
          var pos = lineStart;
          for (; pos <= position && ts3.isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++)
            ;
          return text.slice(lineStart, pos);
        }
        function parameterDocComments(parameters, isJavaScriptFile, indentationStr, newLine) {
          return parameters.map(function(_a, i) {
            var name = _a.name, dotDotDotToken = _a.dotDotDotToken;
            var paramName = name.kind === 79 ? name.text : "param" + i;
            var type2 = isJavaScriptFile ? dotDotDotToken ? "{...any} " : "{any} " : "";
            return "".concat(indentationStr, " * @param ").concat(type2).concat(paramName).concat(newLine);
          }).join("");
        }
        function returnsDocComment(indentationStr, newLine) {
          return "".concat(indentationStr, " * @returns").concat(newLine);
        }
        function getCommentOwnerInfo(tokenAtPos, options) {
          return ts3.forEachAncestor(tokenAtPos, function(n) {
            return getCommentOwnerInfoWorker(n, options);
          });
        }
        function getCommentOwnerInfoWorker(commentOwner, options) {
          switch (commentOwner.kind) {
            case 256:
            case 213:
            case 169:
            case 171:
            case 168:
            case 214:
              var host = commentOwner;
              return { commentOwner, parameters: host.parameters, hasReturn: hasReturn(host, options) };
            case 296:
              return getCommentOwnerInfoWorker(commentOwner.initializer, options);
            case 257:
            case 258:
            case 166:
            case 260:
            case 299:
            case 259:
              return { commentOwner };
            case 237: {
              var varStatement = commentOwner;
              var varDeclarations = varStatement.declarationList.declarations;
              var host_1 = varDeclarations.length === 1 && varDeclarations[0].initializer ? getRightHandSideOfAssignment(varDeclarations[0].initializer) : void 0;
              return host_1 ? { commentOwner, parameters: host_1.parameters, hasReturn: hasReturn(host_1, options) } : { commentOwner };
            }
            case 305:
              return "quit";
            case 261:
              return commentOwner.parent.kind === 261 ? void 0 : { commentOwner };
            case 238:
              return getCommentOwnerInfoWorker(commentOwner.expression, options);
            case 221: {
              var be = commentOwner;
              if (ts3.getAssignmentDeclarationKind(be) === 0) {
                return "quit";
              }
              return ts3.isFunctionLike(be.right) ? { commentOwner, parameters: be.right.parameters, hasReturn: hasReturn(be.right, options) } : { commentOwner };
            }
            case 167:
              var init = commentOwner.initializer;
              if (init && (ts3.isFunctionExpression(init) || ts3.isArrowFunction(init))) {
                return { commentOwner, parameters: init.parameters, hasReturn: hasReturn(init, options) };
              }
          }
        }
        function hasReturn(node, options) {
          return !!(options === null || options === void 0 ? void 0 : options.generateReturnInDocTemplate) && (ts3.isArrowFunction(node) && ts3.isExpression(node.body) || ts3.isFunctionLikeDeclaration(node) && node.body && ts3.isBlock(node.body) && !!ts3.forEachReturnStatement(node.body, function(n) {
            return n;
          }));
        }
        function getRightHandSideOfAssignment(rightHandSide) {
          while (rightHandSide.kind === 212) {
            rightHandSide = rightHandSide.expression;
          }
          switch (rightHandSide.kind) {
            case 213:
            case 214:
              return rightHandSide;
            case 226:
              return ts3.find(rightHandSide.members, ts3.isConstructorDeclaration);
          }
        }
      })(JsDoc = ts3.JsDoc || (ts3.JsDoc = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var NavigateTo;
      (function(NavigateTo2) {
        function getNavigateToItems(sourceFiles, checker, cancellationToken, searchValue, maxResultCount, excludeDtsFiles) {
          var patternMatcher = ts3.createPatternMatcher(searchValue);
          if (!patternMatcher)
            return ts3.emptyArray;
          var rawItems = [];
          var _loop_7 = function(sourceFile2) {
            cancellationToken.throwIfCancellationRequested();
            if (excludeDtsFiles && sourceFile2.isDeclarationFile) {
              return "continue";
            }
            sourceFile2.getNamedDeclarations().forEach(function(declarations, name) {
              getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, sourceFile2.fileName, rawItems);
            });
          };
          for (var _i = 0, sourceFiles_4 = sourceFiles; _i < sourceFiles_4.length; _i++) {
            var sourceFile = sourceFiles_4[_i];
            _loop_7(sourceFile);
          }
          rawItems.sort(compareNavigateToItems);
          return (maxResultCount === void 0 ? rawItems : rawItems.slice(0, maxResultCount)).map(createNavigateToItem);
        }
        NavigateTo2.getNavigateToItems = getNavigateToItems;
        function getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, fileName2, rawItems) {
          var match = patternMatcher.getMatchForLastSegmentOfPattern(name);
          if (!match) {
            return;
          }
          for (var _i = 0, declarations_3 = declarations; _i < declarations_3.length; _i++) {
            var declaration = declarations_3[_i];
            if (!shouldKeepItem(declaration, checker))
              continue;
            if (patternMatcher.patternContainsDots) {
              var fullMatch = patternMatcher.getFullMatch(getContainers(declaration), name);
              if (fullMatch) {
                rawItems.push({ name, fileName: fileName2, matchKind: fullMatch.kind, isCaseSensitive: fullMatch.isCaseSensitive, declaration });
              }
            } else {
              rawItems.push({ name, fileName: fileName2, matchKind: match.kind, isCaseSensitive: match.isCaseSensitive, declaration });
            }
          }
        }
        function shouldKeepItem(declaration, checker) {
          switch (declaration.kind) {
            case 267:
            case 270:
            case 265:
              var importer = checker.getSymbolAtLocation(declaration.name);
              var imported = checker.getAliasedSymbol(importer);
              return importer.escapedName !== imported.escapedName;
            default:
              return true;
          }
        }
        function tryAddSingleDeclarationName(declaration, containers) {
          var name = ts3.getNameOfDeclaration(declaration);
          return !!name && (pushLiteral(name, containers) || name.kind === 162 && tryAddComputedPropertyName(name.expression, containers));
        }
        function tryAddComputedPropertyName(expression, containers) {
          return pushLiteral(expression, containers) || ts3.isPropertyAccessExpression(expression) && (containers.push(expression.name.text), true) && tryAddComputedPropertyName(expression.expression, containers);
        }
        function pushLiteral(node, containers) {
          return ts3.isPropertyNameLiteral(node) && (containers.push(ts3.getTextOfIdentifierOrLiteral(node)), true);
        }
        function getContainers(declaration) {
          var containers = [];
          var name = ts3.getNameOfDeclaration(declaration);
          if (name && name.kind === 162 && !tryAddComputedPropertyName(name.expression, containers)) {
            return ts3.emptyArray;
          }
          containers.shift();
          var container = ts3.getContainerNode(declaration);
          while (container) {
            if (!tryAddSingleDeclarationName(container, containers)) {
              return ts3.emptyArray;
            }
            container = ts3.getContainerNode(container);
          }
          return containers.reverse();
        }
        function compareNavigateToItems(i1, i2) {
          return ts3.compareValues(i1.matchKind, i2.matchKind) || ts3.compareStringsCaseSensitiveUI(i1.name, i2.name);
        }
        function createNavigateToItem(rawItem) {
          var declaration = rawItem.declaration;
          var container = ts3.getContainerNode(declaration);
          var containerName = container && ts3.getNameOfDeclaration(container);
          return {
            name: rawItem.name,
            kind: ts3.getNodeKind(declaration),
            kindModifiers: ts3.getNodeModifiers(declaration),
            matchKind: ts3.PatternMatchKind[rawItem.matchKind],
            isCaseSensitive: rawItem.isCaseSensitive,
            fileName: rawItem.fileName,
            textSpan: ts3.createTextSpanFromNode(declaration),
            containerName: containerName ? containerName.text : "",
            containerKind: containerName ? ts3.getNodeKind(container) : ""
          };
        }
      })(NavigateTo = ts3.NavigateTo || (ts3.NavigateTo = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var NavigationBar;
      (function(NavigationBar2) {
        var _a;
        var whiteSpaceRegex = /\s+/g;
        var maxLength = 150;
        var curCancellationToken;
        var curSourceFile;
        var parentsStack = [];
        var parent;
        var trackedEs5ClassesStack = [];
        var trackedEs5Classes;
        var emptyChildItemArray = [];
        function getNavigationBarItems(sourceFile, cancellationToken) {
          curCancellationToken = cancellationToken;
          curSourceFile = sourceFile;
          try {
            return ts3.map(primaryNavBarMenuItems(rootNavigationBarNode(sourceFile)), convertToPrimaryNavBarMenuItem);
          } finally {
            reset2();
          }
        }
        NavigationBar2.getNavigationBarItems = getNavigationBarItems;
        function getNavigationTree(sourceFile, cancellationToken) {
          curCancellationToken = cancellationToken;
          curSourceFile = sourceFile;
          try {
            return convertToTree(rootNavigationBarNode(sourceFile));
          } finally {
            reset2();
          }
        }
        NavigationBar2.getNavigationTree = getNavigationTree;
        function reset2() {
          curSourceFile = void 0;
          curCancellationToken = void 0;
          parentsStack = [];
          parent = void 0;
          emptyChildItemArray = [];
        }
        function nodeText(node) {
          return cleanText(node.getText(curSourceFile));
        }
        function navigationBarNodeKind(n) {
          return n.node.kind;
        }
        function pushChild(parent2, child) {
          if (parent2.children) {
            parent2.children.push(child);
          } else {
            parent2.children = [child];
          }
        }
        function rootNavigationBarNode(sourceFile) {
          ts3.Debug.assert(!parentsStack.length);
          var root = { node: sourceFile, name: void 0, additionalNodes: void 0, parent: void 0, children: void 0, indent: 0 };
          parent = root;
          for (var _i = 0, _a2 = sourceFile.statements; _i < _a2.length; _i++) {
            var statement = _a2[_i];
            addChildrenRecursively(statement);
          }
          endNode();
          ts3.Debug.assert(!parent && !parentsStack.length);
          return root;
        }
        function addLeafNode(node, name) {
          pushChild(parent, emptyNavigationBarNode(node, name));
        }
        function emptyNavigationBarNode(node, name) {
          return {
            node,
            name: name || (ts3.isDeclaration(node) || ts3.isExpression(node) ? ts3.getNameOfDeclaration(node) : void 0),
            additionalNodes: void 0,
            parent,
            children: void 0,
            indent: parent.indent + 1
          };
        }
        function addTrackedEs5Class(name) {
          if (!trackedEs5Classes) {
            trackedEs5Classes = new ts3.Map();
          }
          trackedEs5Classes.set(name, true);
        }
        function endNestedNodes(depth) {
          for (var i = 0; i < depth; i++)
            endNode();
        }
        function startNestedNodes(targetNode, entityName) {
          var names = [];
          while (!ts3.isPropertyNameLiteral(entityName)) {
            var name = ts3.getNameOrArgument(entityName);
            var nameText = ts3.getElementOrPropertyAccessName(entityName);
            entityName = entityName.expression;
            if (nameText === "prototype" || ts3.isPrivateIdentifier(name))
              continue;
            names.push(name);
          }
          names.push(entityName);
          for (var i = names.length - 1; i > 0; i--) {
            var name = names[i];
            startNode(targetNode, name);
          }
          return [names.length - 1, names[0]];
        }
        function startNode(node, name) {
          var navNode = emptyNavigationBarNode(node, name);
          pushChild(parent, navNode);
          parentsStack.push(parent);
          trackedEs5ClassesStack.push(trackedEs5Classes);
          trackedEs5Classes = void 0;
          parent = navNode;
        }
        function endNode() {
          if (parent.children) {
            mergeChildren(parent.children, parent);
            sortChildren(parent.children);
          }
          parent = parentsStack.pop();
          trackedEs5Classes = trackedEs5ClassesStack.pop();
        }
        function addNodeWithRecursiveChild(node, child, name) {
          startNode(node, name);
          addChildrenRecursively(child);
          endNode();
        }
        function addNodeWithRecursiveInitializer(node) {
          if (node.initializer && isFunctionOrClassExpression(node.initializer)) {
            startNode(node);
            ts3.forEachChild(node.initializer, addChildrenRecursively);
            endNode();
          } else {
            addNodeWithRecursiveChild(node, node.initializer);
          }
        }
        function hasNavigationBarName(node) {
          return !ts3.hasDynamicName(node) || node.kind !== 221 && ts3.isPropertyAccessExpression(node.name.expression) && ts3.isIdentifier(node.name.expression.expression) && ts3.idText(node.name.expression.expression) === "Symbol";
        }
        function addChildrenRecursively(node) {
          var _a2;
          curCancellationToken.throwIfCancellationRequested();
          if (!node || ts3.isToken(node)) {
            return;
          }
          switch (node.kind) {
            case 171:
              var ctr = node;
              addNodeWithRecursiveChild(ctr, ctr.body);
              for (var _i = 0, _b = ctr.parameters; _i < _b.length; _i++) {
                var param = _b[_i];
                if (ts3.isParameterPropertyDeclaration(param, ctr)) {
                  addLeafNode(param);
                }
              }
              break;
            case 169:
            case 172:
            case 173:
            case 168:
              if (hasNavigationBarName(node)) {
                addNodeWithRecursiveChild(node, node.body);
              }
              break;
            case 167:
              if (hasNavigationBarName(node)) {
                addNodeWithRecursiveInitializer(node);
              }
              break;
            case 166:
              if (hasNavigationBarName(node)) {
                addLeafNode(node);
              }
              break;
            case 267:
              var importClause = node;
              if (importClause.name) {
                addLeafNode(importClause.name);
              }
              var namedBindings = importClause.namedBindings;
              if (namedBindings) {
                if (namedBindings.kind === 268) {
                  addLeafNode(namedBindings);
                } else {
                  for (var _c = 0, _d = namedBindings.elements; _c < _d.length; _c++) {
                    var element = _d[_c];
                    addLeafNode(element);
                  }
                }
              }
              break;
            case 297:
              addNodeWithRecursiveChild(node, node.name);
              break;
            case 298:
              var expression = node.expression;
              ts3.isIdentifier(expression) ? addLeafNode(node, expression) : addLeafNode(node);
              break;
            case 203:
            case 296:
            case 254: {
              var child = node;
              if (ts3.isBindingPattern(child.name)) {
                addChildrenRecursively(child.name);
              } else {
                addNodeWithRecursiveInitializer(child);
              }
              break;
            }
            case 256:
              var nameNode = node.name;
              if (nameNode && ts3.isIdentifier(nameNode)) {
                addTrackedEs5Class(nameNode.text);
              }
              addNodeWithRecursiveChild(node, node.body);
              break;
            case 214:
            case 213:
              addNodeWithRecursiveChild(node, node.body);
              break;
            case 260:
              startNode(node);
              for (var _e = 0, _f = node.members; _e < _f.length; _e++) {
                var member = _f[_e];
                if (!isComputedProperty(member)) {
                  addLeafNode(member);
                }
              }
              endNode();
              break;
            case 257:
            case 226:
            case 258:
              startNode(node);
              for (var _g = 0, _h = node.members; _g < _h.length; _g++) {
                var member = _h[_g];
                addChildrenRecursively(member);
              }
              endNode();
              break;
            case 261:
              addNodeWithRecursiveChild(node, getInteriorModule(node).body);
              break;
            case 271: {
              var expression_1 = node.expression;
              var child = ts3.isObjectLiteralExpression(expression_1) || ts3.isCallExpression(expression_1) ? expression_1 : ts3.isArrowFunction(expression_1) || ts3.isFunctionExpression(expression_1) ? expression_1.body : void 0;
              if (child) {
                startNode(node);
                addChildrenRecursively(child);
                endNode();
              } else {
                addLeafNode(node);
              }
              break;
            }
            case 275:
            case 265:
            case 176:
            case 174:
            case 175:
            case 259:
              addLeafNode(node);
              break;
            case 208:
            case 221: {
              var special = ts3.getAssignmentDeclarationKind(node);
              switch (special) {
                case 1:
                case 2:
                  addNodeWithRecursiveChild(node, node.right);
                  return;
                case 6:
                case 3: {
                  var binaryExpression = node;
                  var assignmentTarget = binaryExpression.left;
                  var prototypeAccess = special === 3 ? assignmentTarget.expression : assignmentTarget;
                  var depth = 0;
                  var className = void 0;
                  if (ts3.isIdentifier(prototypeAccess.expression)) {
                    addTrackedEs5Class(prototypeAccess.expression.text);
                    className = prototypeAccess.expression;
                  } else {
                    _a2 = startNestedNodes(binaryExpression, prototypeAccess.expression), depth = _a2[0], className = _a2[1];
                  }
                  if (special === 6) {
                    if (ts3.isObjectLiteralExpression(binaryExpression.right)) {
                      if (binaryExpression.right.properties.length > 0) {
                        startNode(binaryExpression, className);
                        ts3.forEachChild(binaryExpression.right, addChildrenRecursively);
                        endNode();
                      }
                    }
                  } else if (ts3.isFunctionExpression(binaryExpression.right) || ts3.isArrowFunction(binaryExpression.right)) {
                    addNodeWithRecursiveChild(node, binaryExpression.right, className);
                  } else {
                    startNode(binaryExpression, className);
                    addNodeWithRecursiveChild(node, binaryExpression.right, assignmentTarget.name);
                    endNode();
                  }
                  endNestedNodes(depth);
                  return;
                }
                case 7:
                case 9: {
                  var defineCall = node;
                  var className = special === 7 ? defineCall.arguments[0] : defineCall.arguments[0].expression;
                  var memberName = defineCall.arguments[1];
                  var _j = startNestedNodes(node, className), depth = _j[0], classNameIdentifier = _j[1];
                  startNode(node, classNameIdentifier);
                  startNode(node, ts3.setTextRange(ts3.factory.createIdentifier(memberName.text), memberName));
                  addChildrenRecursively(node.arguments[2]);
                  endNode();
                  endNode();
                  endNestedNodes(depth);
                  return;
                }
                case 5: {
                  var binaryExpression = node;
                  var assignmentTarget = binaryExpression.left;
                  var targetFunction = assignmentTarget.expression;
                  if (ts3.isIdentifier(targetFunction) && ts3.getElementOrPropertyAccessName(assignmentTarget) !== "prototype" && trackedEs5Classes && trackedEs5Classes.has(targetFunction.text)) {
                    if (ts3.isFunctionExpression(binaryExpression.right) || ts3.isArrowFunction(binaryExpression.right)) {
                      addNodeWithRecursiveChild(node, binaryExpression.right, targetFunction);
                    } else if (ts3.isBindableStaticAccessExpression(assignmentTarget)) {
                      startNode(binaryExpression, targetFunction);
                      addNodeWithRecursiveChild(binaryExpression.left, binaryExpression.right, ts3.getNameOrArgument(assignmentTarget));
                      endNode();
                    }
                    return;
                  }
                  break;
                }
                case 4:
                case 0:
                case 8:
                  break;
                default:
                  ts3.Debug.assertNever(special);
              }
            }
            default:
              if (ts3.hasJSDocNodes(node)) {
                ts3.forEach(node.jsDoc, function(jsDoc) {
                  ts3.forEach(jsDoc.tags, function(tag) {
                    if (ts3.isJSDocTypeAlias(tag)) {
                      addLeafNode(tag);
                    }
                  });
                });
              }
              ts3.forEachChild(node, addChildrenRecursively);
          }
        }
        function mergeChildren(children, node) {
          var nameToItems = new ts3.Map();
          ts3.filterMutate(children, function(child, index) {
            var declName = child.name || ts3.getNameOfDeclaration(child.node);
            var name = declName && nodeText(declName);
            if (!name) {
              return true;
            }
            var itemsWithSameName = nameToItems.get(name);
            if (!itemsWithSameName) {
              nameToItems.set(name, child);
              return true;
            }
            if (itemsWithSameName instanceof Array) {
              for (var _i = 0, itemsWithSameName_1 = itemsWithSameName; _i < itemsWithSameName_1.length; _i++) {
                var itemWithSameName = itemsWithSameName_1[_i];
                if (tryMerge(itemWithSameName, child, index, node)) {
                  return false;
                }
              }
              itemsWithSameName.push(child);
              return true;
            } else {
              var itemWithSameName = itemsWithSameName;
              if (tryMerge(itemWithSameName, child, index, node)) {
                return false;
              }
              nameToItems.set(name, [itemWithSameName, child]);
              return true;
            }
          });
        }
        var isEs5ClassMember = (_a = {}, _a[5] = true, _a[3] = true, _a[7] = true, _a[9] = true, _a[0] = false, _a[1] = false, _a[2] = false, _a[8] = false, _a[6] = true, _a[4] = false, _a);
        function tryMergeEs5Class(a, b, bIndex, parent2) {
          function isPossibleConstructor(node) {
            return ts3.isFunctionExpression(node) || ts3.isFunctionDeclaration(node) || ts3.isVariableDeclaration(node);
          }
          var bAssignmentDeclarationKind = ts3.isBinaryExpression(b.node) || ts3.isCallExpression(b.node) ? ts3.getAssignmentDeclarationKind(b.node) : 0;
          var aAssignmentDeclarationKind = ts3.isBinaryExpression(a.node) || ts3.isCallExpression(a.node) ? ts3.getAssignmentDeclarationKind(a.node) : 0;
          if (isEs5ClassMember[bAssignmentDeclarationKind] && isEs5ClassMember[aAssignmentDeclarationKind] || isPossibleConstructor(a.node) && isEs5ClassMember[bAssignmentDeclarationKind] || isPossibleConstructor(b.node) && isEs5ClassMember[aAssignmentDeclarationKind] || ts3.isClassDeclaration(a.node) && isSynthesized(a.node) && isEs5ClassMember[bAssignmentDeclarationKind] || ts3.isClassDeclaration(b.node) && isEs5ClassMember[aAssignmentDeclarationKind] || ts3.isClassDeclaration(a.node) && isSynthesized(a.node) && isPossibleConstructor(b.node) || ts3.isClassDeclaration(b.node) && isPossibleConstructor(a.node) && isSynthesized(a.node)) {
            var lastANode = a.additionalNodes && ts3.lastOrUndefined(a.additionalNodes) || a.node;
            if (!ts3.isClassDeclaration(a.node) && !ts3.isClassDeclaration(b.node) || isPossibleConstructor(a.node) || isPossibleConstructor(b.node)) {
              var ctorFunction = isPossibleConstructor(a.node) ? a.node : isPossibleConstructor(b.node) ? b.node : void 0;
              if (ctorFunction !== void 0) {
                var ctorNode = ts3.setTextRange(ts3.factory.createConstructorDeclaration(void 0, void 0, [], void 0), ctorFunction);
                var ctor = emptyNavigationBarNode(ctorNode);
                ctor.indent = a.indent + 1;
                ctor.children = a.node === ctorFunction ? a.children : b.children;
                a.children = a.node === ctorFunction ? ts3.concatenate([ctor], b.children || [b]) : ts3.concatenate(a.children || [__assign({}, a)], [ctor]);
              } else {
                if (a.children || b.children) {
                  a.children = ts3.concatenate(a.children || [__assign({}, a)], b.children || [b]);
                  if (a.children) {
                    mergeChildren(a.children, a);
                    sortChildren(a.children);
                  }
                }
              }
              lastANode = a.node = ts3.setTextRange(ts3.factory.createClassDeclaration(void 0, void 0, a.name || ts3.factory.createIdentifier("__class__"), void 0, void 0, []), a.node);
            } else {
              a.children = ts3.concatenate(a.children, b.children);
              if (a.children) {
                mergeChildren(a.children, a);
              }
            }
            var bNode = b.node;
            if (parent2.children[bIndex - 1].node.end === lastANode.end) {
              ts3.setTextRange(lastANode, { pos: lastANode.pos, end: bNode.end });
            } else {
              if (!a.additionalNodes)
                a.additionalNodes = [];
              a.additionalNodes.push(ts3.setTextRange(ts3.factory.createClassDeclaration(void 0, void 0, a.name || ts3.factory.createIdentifier("__class__"), void 0, void 0, []), b.node));
            }
            return true;
          }
          return bAssignmentDeclarationKind === 0 ? false : true;
        }
        function tryMerge(a, b, bIndex, parent2) {
          if (tryMergeEs5Class(a, b, bIndex, parent2)) {
            return true;
          }
          if (shouldReallyMerge(a.node, b.node, parent2)) {
            merge2(a, b);
            return true;
          }
          return false;
        }
        function shouldReallyMerge(a, b, parent2) {
          if (a.kind !== b.kind || a.parent !== b.parent && !(isOwnChild(a, parent2) && isOwnChild(b, parent2))) {
            return false;
          }
          switch (a.kind) {
            case 167:
            case 169:
            case 172:
            case 173:
              return ts3.isStatic(a) === ts3.isStatic(b);
            case 261:
              return areSameModule(a, b) && getFullyQualifiedModuleName(a) === getFullyQualifiedModuleName(b);
            default:
              return true;
          }
        }
        function isSynthesized(node) {
          return !!(node.flags & 8);
        }
        function isOwnChild(n, parent2) {
          var par = ts3.isModuleBlock(n.parent) ? n.parent.parent : n.parent;
          return par === parent2.node || ts3.contains(parent2.additionalNodes, par);
        }
        function areSameModule(a, b) {
          if (!a.body || !b.body) {
            return a.body === b.body;
          }
          return a.body.kind === b.body.kind && (a.body.kind !== 261 || areSameModule(a.body, b.body));
        }
        function merge2(target, source) {
          var _a2;
          target.additionalNodes = target.additionalNodes || [];
          target.additionalNodes.push(source.node);
          if (source.additionalNodes) {
            (_a2 = target.additionalNodes).push.apply(_a2, source.additionalNodes);
          }
          target.children = ts3.concatenate(target.children, source.children);
          if (target.children) {
            mergeChildren(target.children, target);
            sortChildren(target.children);
          }
        }
        function sortChildren(children) {
          children.sort(compareChildren);
        }
        function compareChildren(child1, child2) {
          return ts3.compareStringsCaseSensitiveUI(tryGetName(child1.node), tryGetName(child2.node)) || ts3.compareValues(navigationBarNodeKind(child1), navigationBarNodeKind(child2));
        }
        function tryGetName(node) {
          if (node.kind === 261) {
            return getModuleName(node);
          }
          var declName = ts3.getNameOfDeclaration(node);
          if (declName && ts3.isPropertyName(declName)) {
            var propertyName = ts3.getPropertyNameForPropertyNameNode(declName);
            return propertyName && ts3.unescapeLeadingUnderscores(propertyName);
          }
          switch (node.kind) {
            case 213:
            case 214:
            case 226:
              return getFunctionOrClassName(node);
            default:
              return void 0;
          }
        }
        function getItemName(node, name) {
          if (node.kind === 261) {
            return cleanText(getModuleName(node));
          }
          if (name) {
            var text = ts3.isIdentifier(name) ? name.text : ts3.isElementAccessExpression(name) ? "[".concat(nodeText(name.argumentExpression), "]") : nodeText(name);
            if (text.length > 0) {
              return cleanText(text);
            }
          }
          switch (node.kind) {
            case 305:
              var sourceFile = node;
              return ts3.isExternalModule(sourceFile) ? '"'.concat(ts3.escapeString(ts3.getBaseFileName(ts3.removeFileExtension(ts3.normalizePath(sourceFile.fileName)))), '"') : "<global>";
            case 271:
              return ts3.isExportAssignment(node) && node.isExportEquals ? "export=" : "default";
            case 214:
            case 256:
            case 213:
            case 257:
            case 226:
              if (ts3.getSyntacticModifierFlags(node) & 512) {
                return "default";
              }
              return getFunctionOrClassName(node);
            case 171:
              return "constructor";
            case 175:
              return "new()";
            case 174:
              return "()";
            case 176:
              return "[]";
            default:
              return "<unknown>";
          }
        }
        function primaryNavBarMenuItems(root) {
          var primaryNavBarMenuItems2 = [];
          function recur(item) {
            if (shouldAppearInPrimaryNavBarMenu(item)) {
              primaryNavBarMenuItems2.push(item);
              if (item.children) {
                for (var _i = 0, _a2 = item.children; _i < _a2.length; _i++) {
                  var child = _a2[_i];
                  recur(child);
                }
              }
            }
          }
          recur(root);
          return primaryNavBarMenuItems2;
          function shouldAppearInPrimaryNavBarMenu(item) {
            if (item.children) {
              return true;
            }
            switch (navigationBarNodeKind(item)) {
              case 257:
              case 226:
              case 260:
              case 258:
              case 261:
              case 305:
              case 259:
              case 345:
              case 338:
                return true;
              case 214:
              case 256:
              case 213:
                return isTopLevelFunctionDeclaration(item);
              default:
                return false;
            }
            function isTopLevelFunctionDeclaration(item2) {
              if (!item2.node.body) {
                return false;
              }
              switch (navigationBarNodeKind(item2.parent)) {
                case 262:
                case 305:
                case 169:
                case 171:
                  return true;
                default:
                  return false;
              }
            }
          }
        }
        function convertToTree(n) {
          return {
            text: getItemName(n.node, n.name),
            kind: ts3.getNodeKind(n.node),
            kindModifiers: getModifiers(n.node),
            spans: getSpans(n),
            nameSpan: n.name && getNodeSpan(n.name),
            childItems: ts3.map(n.children, convertToTree)
          };
        }
        function convertToPrimaryNavBarMenuItem(n) {
          return {
            text: getItemName(n.node, n.name),
            kind: ts3.getNodeKind(n.node),
            kindModifiers: getModifiers(n.node),
            spans: getSpans(n),
            childItems: ts3.map(n.children, convertToSecondaryNavBarMenuItem) || emptyChildItemArray,
            indent: n.indent,
            bolded: false,
            grayed: false
          };
          function convertToSecondaryNavBarMenuItem(n2) {
            return {
              text: getItemName(n2.node, n2.name),
              kind: ts3.getNodeKind(n2.node),
              kindModifiers: ts3.getNodeModifiers(n2.node),
              spans: getSpans(n2),
              childItems: emptyChildItemArray,
              indent: 0,
              bolded: false,
              grayed: false
            };
          }
        }
        function getSpans(n) {
          var spans = [getNodeSpan(n.node)];
          if (n.additionalNodes) {
            for (var _i = 0, _a2 = n.additionalNodes; _i < _a2.length; _i++) {
              var node = _a2[_i];
              spans.push(getNodeSpan(node));
            }
          }
          return spans;
        }
        function getModuleName(moduleDeclaration) {
          if (ts3.isAmbientModule(moduleDeclaration)) {
            return ts3.getTextOfNode(moduleDeclaration.name);
          }
          return getFullyQualifiedModuleName(moduleDeclaration);
        }
        function getFullyQualifiedModuleName(moduleDeclaration) {
          var result2 = [ts3.getTextOfIdentifierOrLiteral(moduleDeclaration.name)];
          while (moduleDeclaration.body && moduleDeclaration.body.kind === 261) {
            moduleDeclaration = moduleDeclaration.body;
            result2.push(ts3.getTextOfIdentifierOrLiteral(moduleDeclaration.name));
          }
          return result2.join(".");
        }
        function getInteriorModule(decl) {
          return decl.body && ts3.isModuleDeclaration(decl.body) ? getInteriorModule(decl.body) : decl;
        }
        function isComputedProperty(member) {
          return !member.name || member.name.kind === 162;
        }
        function getNodeSpan(node) {
          return node.kind === 305 ? ts3.createTextSpanFromRange(node) : ts3.createTextSpanFromNode(node, curSourceFile);
        }
        function getModifiers(node) {
          if (node.parent && node.parent.kind === 254) {
            node = node.parent;
          }
          return ts3.getNodeModifiers(node);
        }
        function getFunctionOrClassName(node) {
          var parent2 = node.parent;
          if (node.name && ts3.getFullWidth(node.name) > 0) {
            return cleanText(ts3.declarationNameToString(node.name));
          } else if (ts3.isVariableDeclaration(parent2)) {
            return cleanText(ts3.declarationNameToString(parent2.name));
          } else if (ts3.isBinaryExpression(parent2) && parent2.operatorToken.kind === 63) {
            return nodeText(parent2.left).replace(whiteSpaceRegex, "");
          } else if (ts3.isPropertyAssignment(parent2)) {
            return nodeText(parent2.name);
          } else if (ts3.getSyntacticModifierFlags(node) & 512) {
            return "default";
          } else if (ts3.isClassLike(node)) {
            return "<class>";
          } else if (ts3.isCallExpression(parent2)) {
            var name = getCalledExpressionName(parent2.expression);
            if (name !== void 0) {
              name = cleanText(name);
              if (name.length > maxLength) {
                return "".concat(name, " callback");
              }
              var args = cleanText(ts3.mapDefined(parent2.arguments, function(a) {
                return ts3.isStringLiteralLike(a) ? a.getText(curSourceFile) : void 0;
              }).join(", "));
              return "".concat(name, "(").concat(args, ") callback");
            }
          }
          return "<function>";
        }
        function getCalledExpressionName(expr) {
          if (ts3.isIdentifier(expr)) {
            return expr.text;
          } else if (ts3.isPropertyAccessExpression(expr)) {
            var left = getCalledExpressionName(expr.expression);
            var right = expr.name.text;
            return left === void 0 ? right : "".concat(left, ".").concat(right);
          } else {
            return void 0;
          }
        }
        function isFunctionOrClassExpression(node) {
          switch (node.kind) {
            case 214:
            case 213:
            case 226:
              return true;
            default:
              return false;
          }
        }
        function cleanText(text) {
          text = text.length > maxLength ? text.substring(0, maxLength) + "..." : text;
          return text.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g, "");
        }
      })(NavigationBar = ts3.NavigationBar || (ts3.NavigationBar = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var OrganizeImports;
      (function(OrganizeImports2) {
        function organizeImports(sourceFile, formatContext, host, program2, preferences, skipDestructiveCodeActions) {
          var changeTracker = ts3.textChanges.ChangeTracker.fromContext({ host, formatContext, preferences });
          var coalesceAndOrganizeImports = function(importGroup) {
            return ts3.stableSort(coalesceImports(removeUnusedImports(importGroup, sourceFile, program2, skipDestructiveCodeActions)), function(s1, s2) {
              return compareImportsOrRequireStatements(s1, s2);
            });
          };
          var topLevelImportGroupDecls = groupImportsByNewlineContiguous(sourceFile, sourceFile.statements.filter(ts3.isImportDeclaration));
          topLevelImportGroupDecls.forEach(function(importGroupDecl) {
            return organizeImportsWorker(importGroupDecl, coalesceAndOrganizeImports);
          });
          var topLevelExportDecls = sourceFile.statements.filter(ts3.isExportDeclaration);
          organizeImportsWorker(topLevelExportDecls, coalesceExports);
          for (var _i = 0, _a = sourceFile.statements.filter(ts3.isAmbientModule); _i < _a.length; _i++) {
            var ambientModule = _a[_i];
            if (!ambientModule.body)
              continue;
            var ambientModuleImportGroupDecls = groupImportsByNewlineContiguous(sourceFile, ambientModule.body.statements.filter(ts3.isImportDeclaration));
            ambientModuleImportGroupDecls.forEach(function(importGroupDecl) {
              return organizeImportsWorker(importGroupDecl, coalesceAndOrganizeImports);
            });
            var ambientModuleExportDecls = ambientModule.body.statements.filter(ts3.isExportDeclaration);
            organizeImportsWorker(ambientModuleExportDecls, coalesceExports);
          }
          return changeTracker.getChanges();
          function organizeImportsWorker(oldImportDecls, coalesce) {
            if (ts3.length(oldImportDecls) === 0) {
              return;
            }
            ts3.suppressLeadingTrivia(oldImportDecls[0]);
            var oldImportGroups = ts3.group(oldImportDecls, function(importDecl) {
              return getExternalModuleName(importDecl.moduleSpecifier);
            });
            var sortedImportGroups = ts3.stableSort(oldImportGroups, function(group1, group2) {
              return compareModuleSpecifiers(group1[0].moduleSpecifier, group2[0].moduleSpecifier);
            });
            var newImportDecls = ts3.flatMap(sortedImportGroups, function(importGroup) {
              return getExternalModuleName(importGroup[0].moduleSpecifier) ? coalesce(importGroup) : importGroup;
            });
            if (newImportDecls.length === 0) {
              changeTracker.deleteNodes(sourceFile, oldImportDecls, {
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include
              }, true);
            } else {
              var replaceOptions = {
                leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude,
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include,
                suffix: ts3.getNewLineOrDefaultFromHost(host, formatContext.options)
              };
              changeTracker.replaceNodeWithNodes(sourceFile, oldImportDecls[0], newImportDecls, replaceOptions);
              var hasTrailingComment = changeTracker.nodeHasTrailingComment(sourceFile, oldImportDecls[0], replaceOptions);
              changeTracker.deleteNodes(sourceFile, oldImportDecls.slice(1), {
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include
              }, hasTrailingComment);
            }
          }
        }
        OrganizeImports2.organizeImports = organizeImports;
        function groupImportsByNewlineContiguous(sourceFile, importDecls) {
          var scanner = ts3.createScanner(sourceFile.languageVersion, false, sourceFile.languageVariant);
          var groupImports = [];
          var groupIndex = 0;
          for (var _i = 0, importDecls_1 = importDecls; _i < importDecls_1.length; _i++) {
            var topLevelImportDecl = importDecls_1[_i];
            if (isNewGroup(sourceFile, topLevelImportDecl, scanner)) {
              groupIndex++;
            }
            if (!groupImports[groupIndex]) {
              groupImports[groupIndex] = [];
            }
            groupImports[groupIndex].push(topLevelImportDecl);
          }
          return groupImports;
        }
        function isNewGroup(sourceFile, topLevelImportDecl, scanner) {
          var startPos = topLevelImportDecl.getFullStart();
          var endPos = topLevelImportDecl.getStart();
          scanner.setText(sourceFile.text, startPos, endPos - startPos);
          var numberOfNewLines = 0;
          while (scanner.getTokenPos() < endPos) {
            var tokenKind = scanner.scan();
            if (tokenKind === 4) {
              numberOfNewLines++;
              if (numberOfNewLines >= 2) {
                return true;
              }
            }
          }
          return false;
        }
        function removeUnusedImports(oldImports, sourceFile, program2, skipDestructiveCodeActions) {
          if (skipDestructiveCodeActions) {
            return oldImports;
          }
          var typeChecker = program2.getTypeChecker();
          var compilerOptions = program2.getCompilerOptions();
          var jsxNamespace = typeChecker.getJsxNamespace(sourceFile);
          var jsxFragmentFactory = typeChecker.getJsxFragmentFactory(sourceFile);
          var jsxElementsPresent = !!(sourceFile.transformFlags & 2);
          var usedImports = [];
          for (var _i = 0, oldImports_1 = oldImports; _i < oldImports_1.length; _i++) {
            var importDecl = oldImports_1[_i];
            var importClause = importDecl.importClause, moduleSpecifier = importDecl.moduleSpecifier;
            if (!importClause) {
              usedImports.push(importDecl);
              continue;
            }
            var name = importClause.name, namedBindings = importClause.namedBindings;
            if (name && !isDeclarationUsed(name)) {
              name = void 0;
            }
            if (namedBindings) {
              if (ts3.isNamespaceImport(namedBindings)) {
                if (!isDeclarationUsed(namedBindings.name)) {
                  namedBindings = void 0;
                }
              } else {
                var newElements = namedBindings.elements.filter(function(e) {
                  return isDeclarationUsed(e.name);
                });
                if (newElements.length < namedBindings.elements.length) {
                  namedBindings = newElements.length ? ts3.factory.updateNamedImports(namedBindings, newElements) : void 0;
                }
              }
            }
            if (name || namedBindings) {
              usedImports.push(updateImportDeclarationAndClause(importDecl, name, namedBindings));
            } else if (hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier)) {
              if (sourceFile.isDeclarationFile) {
                usedImports.push(ts3.factory.createImportDeclaration(importDecl.decorators, importDecl.modifiers, void 0, moduleSpecifier, void 0));
              } else {
                usedImports.push(importDecl);
              }
            }
          }
          return usedImports;
          function isDeclarationUsed(identifier) {
            return jsxElementsPresent && (identifier.text === jsxNamespace || jsxFragmentFactory && identifier.text === jsxFragmentFactory) && ts3.jsxModeNeedsExplicitImport(compilerOptions.jsx) || ts3.FindAllReferences.Core.isSymbolReferencedInFile(identifier, typeChecker, sourceFile);
          }
        }
        function hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier) {
          var moduleSpecifierText = ts3.isStringLiteral(moduleSpecifier) && moduleSpecifier.text;
          return ts3.isString(moduleSpecifierText) && ts3.some(sourceFile.moduleAugmentations, function(moduleName) {
            return ts3.isStringLiteral(moduleName) && moduleName.text === moduleSpecifierText;
          });
        }
        function getExternalModuleName(specifier) {
          return specifier !== void 0 && ts3.isStringLiteralLike(specifier) ? specifier.text : void 0;
        }
        function coalesceImports(importGroup) {
          var _a;
          if (importGroup.length === 0) {
            return importGroup;
          }
          var _b = getCategorizedImports(importGroup), importWithoutClause = _b.importWithoutClause, typeOnlyImports = _b.typeOnlyImports, regularImports = _b.regularImports;
          var coalescedImports = [];
          if (importWithoutClause) {
            coalescedImports.push(importWithoutClause);
          }
          for (var _i = 0, _c = [regularImports, typeOnlyImports]; _i < _c.length; _i++) {
            var group_2 = _c[_i];
            var isTypeOnly = group_2 === typeOnlyImports;
            var defaultImports = group_2.defaultImports, namespaceImports = group_2.namespaceImports, namedImports = group_2.namedImports;
            if (!isTypeOnly && defaultImports.length === 1 && namespaceImports.length === 1 && namedImports.length === 0) {
              var defaultImport = defaultImports[0];
              coalescedImports.push(updateImportDeclarationAndClause(defaultImport, defaultImport.importClause.name, namespaceImports[0].importClause.namedBindings));
              continue;
            }
            var sortedNamespaceImports = ts3.stableSort(namespaceImports, function(i1, i2) {
              return compareIdentifiers(i1.importClause.namedBindings.name, i2.importClause.namedBindings.name);
            });
            for (var _d = 0, sortedNamespaceImports_1 = sortedNamespaceImports; _d < sortedNamespaceImports_1.length; _d++) {
              var namespaceImport = sortedNamespaceImports_1[_d];
              coalescedImports.push(updateImportDeclarationAndClause(namespaceImport, void 0, namespaceImport.importClause.namedBindings));
            }
            if (defaultImports.length === 0 && namedImports.length === 0) {
              continue;
            }
            var newDefaultImport = void 0;
            var newImportSpecifiers = [];
            if (defaultImports.length === 1) {
              newDefaultImport = defaultImports[0].importClause.name;
            } else {
              for (var _e = 0, defaultImports_1 = defaultImports; _e < defaultImports_1.length; _e++) {
                var defaultImport = defaultImports_1[_e];
                newImportSpecifiers.push(ts3.factory.createImportSpecifier(false, ts3.factory.createIdentifier("default"), defaultImport.importClause.name));
              }
            }
            newImportSpecifiers.push.apply(newImportSpecifiers, getNewImportSpecifiers(namedImports));
            var sortedImportSpecifiers = sortSpecifiers(newImportSpecifiers);
            var importDecl = defaultImports.length > 0 ? defaultImports[0] : namedImports[0];
            var newNamedImports = sortedImportSpecifiers.length === 0 ? newDefaultImport ? void 0 : ts3.factory.createNamedImports(ts3.emptyArray) : namedImports.length === 0 ? ts3.factory.createNamedImports(sortedImportSpecifiers) : ts3.factory.updateNamedImports(namedImports[0].importClause.namedBindings, sortedImportSpecifiers);
            if (isTypeOnly && newDefaultImport && newNamedImports) {
              coalescedImports.push(updateImportDeclarationAndClause(importDecl, newDefaultImport, void 0));
              coalescedImports.push(updateImportDeclarationAndClause((_a = namedImports[0]) !== null && _a !== void 0 ? _a : importDecl, void 0, newNamedImports));
            } else {
              coalescedImports.push(updateImportDeclarationAndClause(importDecl, newDefaultImport, newNamedImports));
            }
          }
          return coalescedImports;
        }
        OrganizeImports2.coalesceImports = coalesceImports;
        function getCategorizedImports(importGroup) {
          var importWithoutClause;
          var typeOnlyImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
          var regularImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
          for (var _i = 0, importGroup_1 = importGroup; _i < importGroup_1.length; _i++) {
            var importDeclaration = importGroup_1[_i];
            if (importDeclaration.importClause === void 0) {
              importWithoutClause = importWithoutClause || importDeclaration;
              continue;
            }
            var group_3 = importDeclaration.importClause.isTypeOnly ? typeOnlyImports : regularImports;
            var _a = importDeclaration.importClause, name = _a.name, namedBindings = _a.namedBindings;
            if (name) {
              group_3.defaultImports.push(importDeclaration);
            }
            if (namedBindings) {
              if (ts3.isNamespaceImport(namedBindings)) {
                group_3.namespaceImports.push(importDeclaration);
              } else {
                group_3.namedImports.push(importDeclaration);
              }
            }
          }
          return {
            importWithoutClause,
            typeOnlyImports,
            regularImports
          };
        }
        function coalesceExports(exportGroup) {
          if (exportGroup.length === 0) {
            return exportGroup;
          }
          var _a = getCategorizedExports(exportGroup), exportWithoutClause = _a.exportWithoutClause, namedExports = _a.namedExports, typeOnlyExports = _a.typeOnlyExports;
          var coalescedExports = [];
          if (exportWithoutClause) {
            coalescedExports.push(exportWithoutClause);
          }
          for (var _i = 0, _b = [namedExports, typeOnlyExports]; _i < _b.length; _i++) {
            var exportGroup_1 = _b[_i];
            if (exportGroup_1.length === 0) {
              continue;
            }
            var newExportSpecifiers = [];
            newExportSpecifiers.push.apply(newExportSpecifiers, ts3.flatMap(exportGroup_1, function(i) {
              return i.exportClause && ts3.isNamedExports(i.exportClause) ? i.exportClause.elements : ts3.emptyArray;
            }));
            var sortedExportSpecifiers = sortSpecifiers(newExportSpecifiers);
            var exportDecl = exportGroup_1[0];
            coalescedExports.push(ts3.factory.updateExportDeclaration(exportDecl, exportDecl.decorators, exportDecl.modifiers, exportDecl.isTypeOnly, exportDecl.exportClause && (ts3.isNamedExports(exportDecl.exportClause) ? ts3.factory.updateNamedExports(exportDecl.exportClause, sortedExportSpecifiers) : ts3.factory.updateNamespaceExport(exportDecl.exportClause, exportDecl.exportClause.name)), exportDecl.moduleSpecifier, exportDecl.assertClause));
          }
          return coalescedExports;
          function getCategorizedExports(exportGroup2) {
            var exportWithoutClause2;
            var namedExports2 = [];
            var typeOnlyExports2 = [];
            for (var _i2 = 0, exportGroup_2 = exportGroup2; _i2 < exportGroup_2.length; _i2++) {
              var exportDeclaration = exportGroup_2[_i2];
              if (exportDeclaration.exportClause === void 0) {
                exportWithoutClause2 = exportWithoutClause2 || exportDeclaration;
              } else if (exportDeclaration.isTypeOnly) {
                typeOnlyExports2.push(exportDeclaration);
              } else {
                namedExports2.push(exportDeclaration);
              }
            }
            return {
              exportWithoutClause: exportWithoutClause2,
              namedExports: namedExports2,
              typeOnlyExports: typeOnlyExports2
            };
          }
        }
        OrganizeImports2.coalesceExports = coalesceExports;
        function updateImportDeclarationAndClause(importDeclaration, name, namedBindings) {
          return ts3.factory.updateImportDeclaration(importDeclaration, importDeclaration.decorators, importDeclaration.modifiers, ts3.factory.updateImportClause(importDeclaration.importClause, importDeclaration.importClause.isTypeOnly, name, namedBindings), importDeclaration.moduleSpecifier, importDeclaration.assertClause);
        }
        function sortSpecifiers(specifiers) {
          return ts3.stableSort(specifiers, compareImportOrExportSpecifiers);
        }
        function compareImportOrExportSpecifiers(s1, s2) {
          return ts3.compareBooleans(s1.isTypeOnly, s2.isTypeOnly) || compareIdentifiers(s1.propertyName || s1.name, s2.propertyName || s2.name) || compareIdentifiers(s1.name, s2.name);
        }
        OrganizeImports2.compareImportOrExportSpecifiers = compareImportOrExportSpecifiers;
        function compareModuleSpecifiers(m1, m2) {
          var name1 = m1 === void 0 ? void 0 : getExternalModuleName(m1);
          var name2 = m2 === void 0 ? void 0 : getExternalModuleName(m2);
          return ts3.compareBooleans(name1 === void 0, name2 === void 0) || ts3.compareBooleans(ts3.isExternalModuleNameRelative(name1), ts3.isExternalModuleNameRelative(name2)) || ts3.compareStringsCaseInsensitive(name1, name2);
        }
        OrganizeImports2.compareModuleSpecifiers = compareModuleSpecifiers;
        function compareIdentifiers(s1, s2) {
          return ts3.compareStringsCaseInsensitive(s1.text, s2.text);
        }
        function getModuleSpecifierExpression(declaration) {
          var _a;
          switch (declaration.kind) {
            case 265:
              return (_a = ts3.tryCast(declaration.moduleReference, ts3.isExternalModuleReference)) === null || _a === void 0 ? void 0 : _a.expression;
            case 266:
              return declaration.moduleSpecifier;
            case 237:
              return declaration.declarationList.declarations[0].initializer.arguments[0];
          }
        }
        function importsAreSorted(imports) {
          return ts3.arrayIsSorted(imports, compareImportsOrRequireStatements);
        }
        OrganizeImports2.importsAreSorted = importsAreSorted;
        function importSpecifiersAreSorted(imports) {
          return ts3.arrayIsSorted(imports, compareImportOrExportSpecifiers);
        }
        OrganizeImports2.importSpecifiersAreSorted = importSpecifiersAreSorted;
        function getImportDeclarationInsertionIndex(sortedImports, newImport) {
          var index = ts3.binarySearch(sortedImports, newImport, ts3.identity, compareImportsOrRequireStatements);
          return index < 0 ? ~index : index;
        }
        OrganizeImports2.getImportDeclarationInsertionIndex = getImportDeclarationInsertionIndex;
        function getImportSpecifierInsertionIndex(sortedImports, newImport) {
          var index = ts3.binarySearch(sortedImports, newImport, ts3.identity, compareImportOrExportSpecifiers);
          return index < 0 ? ~index : index;
        }
        OrganizeImports2.getImportSpecifierInsertionIndex = getImportSpecifierInsertionIndex;
        function compareImportsOrRequireStatements(s1, s2) {
          return compareModuleSpecifiers(getModuleSpecifierExpression(s1), getModuleSpecifierExpression(s2)) || compareImportKind(s1, s2);
        }
        OrganizeImports2.compareImportsOrRequireStatements = compareImportsOrRequireStatements;
        function compareImportKind(s1, s2) {
          return ts3.compareValues(getImportKindOrder(s1), getImportKindOrder(s2));
        }
        function getImportKindOrder(s1) {
          var _a;
          switch (s1.kind) {
            case 266:
              if (!s1.importClause)
                return 0;
              if (s1.importClause.isTypeOnly)
                return 1;
              if (((_a = s1.importClause.namedBindings) === null || _a === void 0 ? void 0 : _a.kind) === 268)
                return 2;
              if (s1.importClause.name)
                return 3;
              return 4;
            case 265:
              return 5;
            case 237:
              return 6;
          }
        }
        function getNewImportSpecifiers(namedImports) {
          return ts3.flatMap(namedImports, function(namedImport) {
            return ts3.map(tryGetNamedBindingElements(namedImport), function(importSpecifier) {
              return importSpecifier.name && importSpecifier.propertyName && importSpecifier.name.escapedText === importSpecifier.propertyName.escapedText ? ts3.factory.updateImportSpecifier(importSpecifier, importSpecifier.isTypeOnly, void 0, importSpecifier.name) : importSpecifier;
            });
          });
        }
        function tryGetNamedBindingElements(namedImport) {
          var _a;
          return ((_a = namedImport.importClause) === null || _a === void 0 ? void 0 : _a.namedBindings) && ts3.isNamedImports(namedImport.importClause.namedBindings) ? namedImport.importClause.namedBindings.elements : void 0;
        }
      })(OrganizeImports = ts3.OrganizeImports || (ts3.OrganizeImports = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var OutliningElementsCollector;
      (function(OutliningElementsCollector2) {
        function collectElements(sourceFile, cancellationToken) {
          var res = [];
          addNodeOutliningSpans(sourceFile, cancellationToken, res);
          addRegionOutliningSpans(sourceFile, res);
          return res.sort(function(span1, span2) {
            return span1.textSpan.start - span2.textSpan.start;
          });
        }
        OutliningElementsCollector2.collectElements = collectElements;
        function addNodeOutliningSpans(sourceFile, cancellationToken, out) {
          var depthRemaining = 40;
          var current = 0;
          var statements = __spreadArray(__spreadArray([], sourceFile.statements, true), [sourceFile.endOfFileToken], false);
          var n = statements.length;
          while (current < n) {
            while (current < n && !ts3.isAnyImportSyntax(statements[current])) {
              visitNonImportNode(statements[current]);
              current++;
            }
            if (current === n)
              break;
            var firstImport = current;
            while (current < n && ts3.isAnyImportSyntax(statements[current])) {
              addOutliningForLeadingCommentsForNode(statements[current], sourceFile, cancellationToken, out);
              current++;
            }
            var lastImport = current - 1;
            if (lastImport !== firstImport) {
              out.push(createOutliningSpanFromBounds(ts3.findChildOfKind(statements[firstImport], 100, sourceFile).getStart(sourceFile), statements[lastImport].getEnd(), "imports"));
            }
          }
          function visitNonImportNode(n2) {
            var _a;
            if (depthRemaining === 0)
              return;
            cancellationToken.throwIfCancellationRequested();
            if (ts3.isDeclaration(n2) || ts3.isVariableStatement(n2) || ts3.isReturnStatement(n2) || ts3.isCallOrNewExpression(n2) || n2.kind === 1) {
              addOutliningForLeadingCommentsForNode(n2, sourceFile, cancellationToken, out);
            }
            if (ts3.isFunctionLike(n2) && ts3.isBinaryExpression(n2.parent) && ts3.isPropertyAccessExpression(n2.parent.left)) {
              addOutliningForLeadingCommentsForNode(n2.parent.left, sourceFile, cancellationToken, out);
            }
            if (ts3.isBlock(n2) || ts3.isModuleBlock(n2)) {
              addOutliningForLeadingCommentsForPos(n2.statements.end, sourceFile, cancellationToken, out);
            }
            if (ts3.isClassLike(n2) || ts3.isInterfaceDeclaration(n2)) {
              addOutliningForLeadingCommentsForPos(n2.members.end, sourceFile, cancellationToken, out);
            }
            var span = getOutliningSpanForNode(n2, sourceFile);
            if (span)
              out.push(span);
            depthRemaining--;
            if (ts3.isCallExpression(n2)) {
              depthRemaining++;
              visitNonImportNode(n2.expression);
              depthRemaining--;
              n2.arguments.forEach(visitNonImportNode);
              (_a = n2.typeArguments) === null || _a === void 0 ? void 0 : _a.forEach(visitNonImportNode);
            } else if (ts3.isIfStatement(n2) && n2.elseStatement && ts3.isIfStatement(n2.elseStatement)) {
              visitNonImportNode(n2.expression);
              visitNonImportNode(n2.thenStatement);
              depthRemaining++;
              visitNonImportNode(n2.elseStatement);
              depthRemaining--;
            } else {
              n2.forEachChild(visitNonImportNode);
            }
            depthRemaining++;
          }
        }
        function addRegionOutliningSpans(sourceFile, out) {
          var regions = [];
          var lineStarts = sourceFile.getLineStarts();
          for (var _i = 0, lineStarts_1 = lineStarts; _i < lineStarts_1.length; _i++) {
            var currentLineStart = lineStarts_1[_i];
            var lineEnd = sourceFile.getLineEndOfPosition(currentLineStart);
            var lineText = sourceFile.text.substring(currentLineStart, lineEnd);
            var result2 = isRegionDelimiter(lineText);
            if (!result2 || ts3.isInComment(sourceFile, currentLineStart)) {
              continue;
            }
            if (!result2[1]) {
              var span = ts3.createTextSpanFromBounds(sourceFile.text.indexOf("//", currentLineStart), lineEnd);
              regions.push(createOutliningSpan(span, "region", span, false, result2[2] || "#region"));
            } else {
              var region = regions.pop();
              if (region) {
                region.textSpan.length = lineEnd - region.textSpan.start;
                region.hintSpan.length = lineEnd - region.textSpan.start;
                out.push(region);
              }
            }
          }
        }
        var regionDelimiterRegExp = /^#(end)?region(?:\s+(.*))?(?:\r)?$/;
        function isRegionDelimiter(lineText) {
          lineText = ts3.trimStringStart(lineText);
          if (!ts3.startsWith(lineText, "//")) {
            return null;
          }
          lineText = ts3.trimString(lineText.slice(2));
          return regionDelimiterRegExp.exec(lineText);
        }
        function addOutliningForLeadingCommentsForPos(pos, sourceFile, cancellationToken, out) {
          var comments = ts3.getLeadingCommentRanges(sourceFile.text, pos);
          if (!comments)
            return;
          var firstSingleLineCommentStart = -1;
          var lastSingleLineCommentEnd = -1;
          var singleLineCommentCount = 0;
          var sourceText = sourceFile.getFullText();
          for (var _i = 0, comments_1 = comments; _i < comments_1.length; _i++) {
            var _a = comments_1[_i], kind = _a.kind, pos_1 = _a.pos, end = _a.end;
            cancellationToken.throwIfCancellationRequested();
            switch (kind) {
              case 2:
                var commentText = sourceText.slice(pos_1, end);
                if (isRegionDelimiter(commentText)) {
                  combineAndAddMultipleSingleLineComments();
                  singleLineCommentCount = 0;
                  break;
                }
                if (singleLineCommentCount === 0) {
                  firstSingleLineCommentStart = pos_1;
                }
                lastSingleLineCommentEnd = end;
                singleLineCommentCount++;
                break;
              case 3:
                combineAndAddMultipleSingleLineComments();
                out.push(createOutliningSpanFromBounds(pos_1, end, "comment"));
                singleLineCommentCount = 0;
                break;
              default:
                ts3.Debug.assertNever(kind);
            }
          }
          combineAndAddMultipleSingleLineComments();
          function combineAndAddMultipleSingleLineComments() {
            if (singleLineCommentCount > 1) {
              out.push(createOutliningSpanFromBounds(firstSingleLineCommentStart, lastSingleLineCommentEnd, "comment"));
            }
          }
        }
        function addOutliningForLeadingCommentsForNode(n, sourceFile, cancellationToken, out) {
          if (ts3.isJsxText(n))
            return;
          addOutliningForLeadingCommentsForPos(n.pos, sourceFile, cancellationToken, out);
        }
        function createOutliningSpanFromBounds(pos, end, kind) {
          return createOutliningSpan(ts3.createTextSpanFromBounds(pos, end), kind);
        }
        function getOutliningSpanForNode(n, sourceFile) {
          switch (n.kind) {
            case 235:
              if (ts3.isFunctionLike(n.parent)) {
                return functionSpan(n.parent, n, sourceFile);
              }
              switch (n.parent.kind) {
                case 240:
                case 243:
                case 244:
                case 242:
                case 239:
                case 241:
                case 248:
                case 292:
                  return spanForNode(n.parent);
                case 252:
                  var tryStatement = n.parent;
                  if (tryStatement.tryBlock === n) {
                    return spanForNode(n.parent);
                  } else if (tryStatement.finallyBlock === n) {
                    var node = ts3.findChildOfKind(tryStatement, 96, sourceFile);
                    if (node)
                      return spanForNode(node);
                  }
                default:
                  return createOutliningSpan(ts3.createTextSpanFromNode(n, sourceFile), "code");
              }
            case 262:
              return spanForNode(n.parent);
            case 257:
            case 226:
            case 258:
            case 260:
            case 263:
            case 182:
            case 201:
              return spanForNode(n);
            case 184:
              return spanForNode(n, false, !ts3.isTupleTypeNode(n.parent), 22);
            case 289:
            case 290:
              return spanForNodeArray(n.statements);
            case 205:
              return spanForObjectOrArrayLiteral(n);
            case 204:
              return spanForObjectOrArrayLiteral(n, 22);
            case 278:
              return spanForJSXElement(n);
            case 282:
              return spanForJSXFragment(n);
            case 279:
            case 280:
              return spanForJSXAttributes(n.attributes);
            case 223:
            case 14:
              return spanForTemplateLiteral(n);
            case 202:
              return spanForNode(n, false, !ts3.isBindingElement(n.parent), 22);
            case 214:
              return spanForArrowFunction(n);
            case 208:
              return spanForCallExpression(n);
            case 212:
              return spanForParenthesizedExpression(n);
          }
          function spanForCallExpression(node2) {
            if (!node2.arguments.length) {
              return void 0;
            }
            var openToken = ts3.findChildOfKind(node2, 20, sourceFile);
            var closeToken = ts3.findChildOfKind(node2, 21, sourceFile);
            if (!openToken || !closeToken || ts3.positionsAreOnSameLine(openToken.pos, closeToken.pos, sourceFile)) {
              return void 0;
            }
            return spanBetweenTokens(openToken, closeToken, node2, sourceFile, false, true);
          }
          function spanForArrowFunction(node2) {
            if (ts3.isBlock(node2.body) || ts3.isParenthesizedExpression(node2.body) || ts3.positionsAreOnSameLine(node2.body.getFullStart(), node2.body.getEnd(), sourceFile)) {
              return void 0;
            }
            var textSpan = ts3.createTextSpanFromBounds(node2.body.getFullStart(), node2.body.getEnd());
            return createOutliningSpan(textSpan, "code", ts3.createTextSpanFromNode(node2));
          }
          function spanForJSXElement(node2) {
            var textSpan = ts3.createTextSpanFromBounds(node2.openingElement.getStart(sourceFile), node2.closingElement.getEnd());
            var tagName = node2.openingElement.tagName.getText(sourceFile);
            var bannerText = "<" + tagName + ">...</" + tagName + ">";
            return createOutliningSpan(textSpan, "code", textSpan, false, bannerText);
          }
          function spanForJSXFragment(node2) {
            var textSpan = ts3.createTextSpanFromBounds(node2.openingFragment.getStart(sourceFile), node2.closingFragment.getEnd());
            var bannerText = "<>...</>";
            return createOutliningSpan(textSpan, "code", textSpan, false, bannerText);
          }
          function spanForJSXAttributes(node2) {
            if (node2.properties.length === 0) {
              return void 0;
            }
            return createOutliningSpanFromBounds(node2.getStart(sourceFile), node2.getEnd(), "code");
          }
          function spanForTemplateLiteral(node2) {
            if (node2.kind === 14 && node2.text.length === 0) {
              return void 0;
            }
            return createOutliningSpanFromBounds(node2.getStart(sourceFile), node2.getEnd(), "code");
          }
          function spanForObjectOrArrayLiteral(node2, open) {
            if (open === void 0) {
              open = 18;
            }
            return spanForNode(node2, false, !ts3.isArrayLiteralExpression(node2.parent) && !ts3.isCallExpression(node2.parent), open);
          }
          function spanForNode(hintSpanNode, autoCollapse, useFullStart, open, close) {
            if (autoCollapse === void 0) {
              autoCollapse = false;
            }
            if (useFullStart === void 0) {
              useFullStart = true;
            }
            if (open === void 0) {
              open = 18;
            }
            if (close === void 0) {
              close = open === 18 ? 19 : 23;
            }
            var openToken = ts3.findChildOfKind(n, open, sourceFile);
            var closeToken = ts3.findChildOfKind(n, close, sourceFile);
            return openToken && closeToken && spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart);
          }
          function spanForNodeArray(nodeArray) {
            return nodeArray.length ? createOutliningSpan(ts3.createTextSpanFromRange(nodeArray), "code") : void 0;
          }
          function spanForParenthesizedExpression(node2) {
            if (ts3.positionsAreOnSameLine(node2.getStart(), node2.getEnd(), sourceFile))
              return void 0;
            var textSpan = ts3.createTextSpanFromBounds(node2.getStart(), node2.getEnd());
            return createOutliningSpan(textSpan, "code", ts3.createTextSpanFromNode(node2));
          }
        }
        function functionSpan(node, body, sourceFile) {
          var openToken = tryGetFunctionOpenToken(node, body, sourceFile);
          var closeToken = ts3.findChildOfKind(body, 19, sourceFile);
          return openToken && closeToken && spanBetweenTokens(openToken, closeToken, node, sourceFile, node.kind !== 214);
        }
        function spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart) {
          if (autoCollapse === void 0) {
            autoCollapse = false;
          }
          if (useFullStart === void 0) {
            useFullStart = true;
          }
          var textSpan = ts3.createTextSpanFromBounds(useFullStart ? openToken.getFullStart() : openToken.getStart(sourceFile), closeToken.getEnd());
          return createOutliningSpan(textSpan, "code", ts3.createTextSpanFromNode(hintSpanNode, sourceFile), autoCollapse);
        }
        function createOutliningSpan(textSpan, kind, hintSpan, autoCollapse, bannerText) {
          if (hintSpan === void 0) {
            hintSpan = textSpan;
          }
          if (autoCollapse === void 0) {
            autoCollapse = false;
          }
          if (bannerText === void 0) {
            bannerText = "...";
          }
          return { textSpan, kind, hintSpan, bannerText, autoCollapse };
        }
        function tryGetFunctionOpenToken(node, body, sourceFile) {
          if (ts3.isNodeArrayMultiLine(node.parameters, sourceFile)) {
            var openParenToken = ts3.findChildOfKind(node, 20, sourceFile);
            if (openParenToken) {
              return openParenToken;
            }
          }
          return ts3.findChildOfKind(body, 18, sourceFile);
        }
      })(OutliningElementsCollector = ts3.OutliningElementsCollector || (ts3.OutliningElementsCollector = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var PatternMatchKind;
      (function(PatternMatchKind2) {
        PatternMatchKind2[PatternMatchKind2["exact"] = 0] = "exact";
        PatternMatchKind2[PatternMatchKind2["prefix"] = 1] = "prefix";
        PatternMatchKind2[PatternMatchKind2["substring"] = 2] = "substring";
        PatternMatchKind2[PatternMatchKind2["camelCase"] = 3] = "camelCase";
      })(PatternMatchKind = ts3.PatternMatchKind || (ts3.PatternMatchKind = {}));
      function createPatternMatch(kind, isCaseSensitive) {
        return {
          kind,
          isCaseSensitive
        };
      }
      function createPatternMatcher(pattern) {
        var stringToWordSpans = new ts3.Map();
        var dotSeparatedSegments = pattern.trim().split(".").map(function(p) {
          return createSegment(p.trim());
        });
        if (dotSeparatedSegments.some(function(segment) {
          return !segment.subWordTextChunks.length;
        }))
          return void 0;
        return {
          getFullMatch: function(containers, candidate) {
            return getFullMatch(containers, candidate, dotSeparatedSegments, stringToWordSpans);
          },
          getMatchForLastSegmentOfPattern: function(candidate) {
            return matchSegment(candidate, ts3.last(dotSeparatedSegments), stringToWordSpans);
          },
          patternContainsDots: dotSeparatedSegments.length > 1
        };
      }
      ts3.createPatternMatcher = createPatternMatcher;
      function getFullMatch(candidateContainers, candidate, dotSeparatedSegments, stringToWordSpans) {
        var candidateMatch = matchSegment(candidate, ts3.last(dotSeparatedSegments), stringToWordSpans);
        if (!candidateMatch) {
          return void 0;
        }
        if (dotSeparatedSegments.length - 1 > candidateContainers.length) {
          return void 0;
        }
        var bestMatch;
        for (var i = dotSeparatedSegments.length - 2, j = candidateContainers.length - 1; i >= 0; i -= 1, j -= 1) {
          bestMatch = betterMatch(bestMatch, matchSegment(candidateContainers[j], dotSeparatedSegments[i], stringToWordSpans));
        }
        return bestMatch;
      }
      function getWordSpans(word, stringToWordSpans) {
        var spans = stringToWordSpans.get(word);
        if (!spans) {
          stringToWordSpans.set(word, spans = breakIntoWordSpans(word));
        }
        return spans;
      }
      function matchTextChunk(candidate, chunk, stringToWordSpans) {
        var index = indexOfIgnoringCase(candidate, chunk.textLowerCase);
        if (index === 0) {
          return createPatternMatch(chunk.text.length === candidate.length ? PatternMatchKind.exact : PatternMatchKind.prefix, ts3.startsWith(candidate, chunk.text));
        }
        if (chunk.isLowerCase) {
          if (index === -1)
            return void 0;
          var wordSpans = getWordSpans(candidate, stringToWordSpans);
          for (var _i = 0, wordSpans_1 = wordSpans; _i < wordSpans_1.length; _i++) {
            var span = wordSpans_1[_i];
            if (partStartsWith(candidate, span, chunk.text, true)) {
              return createPatternMatch(PatternMatchKind.substring, partStartsWith(candidate, span, chunk.text, false));
            }
          }
          if (chunk.text.length < candidate.length && isUpperCaseLetter(candidate.charCodeAt(index))) {
            return createPatternMatch(PatternMatchKind.substring, false);
          }
        } else {
          if (candidate.indexOf(chunk.text) > 0) {
            return createPatternMatch(PatternMatchKind.substring, true);
          }
          if (chunk.characterSpans.length > 0) {
            var candidateParts = getWordSpans(candidate, stringToWordSpans);
            var isCaseSensitive = tryCamelCaseMatch(candidate, candidateParts, chunk, false) ? true : tryCamelCaseMatch(candidate, candidateParts, chunk, true) ? false : void 0;
            if (isCaseSensitive !== void 0) {
              return createPatternMatch(PatternMatchKind.camelCase, isCaseSensitive);
            }
          }
        }
      }
      function matchSegment(candidate, segment, stringToWordSpans) {
        if (every(segment.totalTextChunk.text, function(ch) {
          return ch !== 32 && ch !== 42;
        })) {
          var match = matchTextChunk(candidate, segment.totalTextChunk, stringToWordSpans);
          if (match)
            return match;
        }
        var subWordTextChunks = segment.subWordTextChunks;
        var bestMatch;
        for (var _i = 0, subWordTextChunks_1 = subWordTextChunks; _i < subWordTextChunks_1.length; _i++) {
          var subWordTextChunk = subWordTextChunks_1[_i];
          bestMatch = betterMatch(bestMatch, matchTextChunk(candidate, subWordTextChunk, stringToWordSpans));
        }
        return bestMatch;
      }
      function betterMatch(a, b) {
        return ts3.min(a, b, compareMatches);
      }
      function compareMatches(a, b) {
        return a === void 0 ? 1 : b === void 0 ? -1 : ts3.compareValues(a.kind, b.kind) || ts3.compareBooleans(!a.isCaseSensitive, !b.isCaseSensitive);
      }
      function partStartsWith(candidate, candidateSpan, pattern, ignoreCase, patternSpan) {
        if (patternSpan === void 0) {
          patternSpan = { start: 0, length: pattern.length };
        }
        return patternSpan.length <= candidateSpan.length && everyInRange(0, patternSpan.length, function(i) {
          return equalChars(pattern.charCodeAt(patternSpan.start + i), candidate.charCodeAt(candidateSpan.start + i), ignoreCase);
        });
      }
      function equalChars(ch1, ch2, ignoreCase) {
        return ignoreCase ? toLowerCase(ch1) === toLowerCase(ch2) : ch1 === ch2;
      }
      function tryCamelCaseMatch(candidate, candidateParts, chunk, ignoreCase) {
        var chunkCharacterSpans = chunk.characterSpans;
        var currentCandidate = 0;
        var currentChunkSpan = 0;
        var firstMatch;
        var contiguous;
        while (true) {
          if (currentChunkSpan === chunkCharacterSpans.length) {
            return true;
          } else if (currentCandidate === candidateParts.length) {
            return false;
          }
          var candidatePart = candidateParts[currentCandidate];
          var gotOneMatchThisCandidate = false;
          for (; currentChunkSpan < chunkCharacterSpans.length; currentChunkSpan++) {
            var chunkCharacterSpan = chunkCharacterSpans[currentChunkSpan];
            if (gotOneMatchThisCandidate) {
              if (!isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan - 1].start)) || !isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan].start))) {
                break;
              }
            }
            if (!partStartsWith(candidate, candidatePart, chunk.text, ignoreCase, chunkCharacterSpan)) {
              break;
            }
            gotOneMatchThisCandidate = true;
            firstMatch = firstMatch === void 0 ? currentCandidate : firstMatch;
            contiguous = contiguous === void 0 ? true : contiguous;
            candidatePart = ts3.createTextSpan(candidatePart.start + chunkCharacterSpan.length, candidatePart.length - chunkCharacterSpan.length);
          }
          if (!gotOneMatchThisCandidate && contiguous !== void 0) {
            contiguous = false;
          }
          currentCandidate++;
        }
      }
      function createSegment(text) {
        return {
          totalTextChunk: createTextChunk(text),
          subWordTextChunks: breakPatternIntoTextChunks(text)
        };
      }
      function isUpperCaseLetter(ch) {
        if (ch >= 65 && ch <= 90) {
          return true;
        }
        if (ch < 127 || !ts3.isUnicodeIdentifierStart(ch, 99)) {
          return false;
        }
        var str2 = String.fromCharCode(ch);
        return str2 === str2.toUpperCase();
      }
      function isLowerCaseLetter(ch) {
        if (ch >= 97 && ch <= 122) {
          return true;
        }
        if (ch < 127 || !ts3.isUnicodeIdentifierStart(ch, 99)) {
          return false;
        }
        var str2 = String.fromCharCode(ch);
        return str2 === str2.toLowerCase();
      }
      function indexOfIgnoringCase(str2, value) {
        var n = str2.length - value.length;
        var _loop_8 = function(start2) {
          if (every(value, function(valueChar, i) {
            return toLowerCase(str2.charCodeAt(i + start2)) === valueChar;
          })) {
            return { value: start2 };
          }
        };
        for (var start = 0; start <= n; start++) {
          var state_3 = _loop_8(start);
          if (typeof state_3 === "object")
            return state_3.value;
        }
        return -1;
      }
      function toLowerCase(ch) {
        if (ch >= 65 && ch <= 90) {
          return 97 + (ch - 65);
        }
        if (ch < 127) {
          return ch;
        }
        return String.fromCharCode(ch).toLowerCase().charCodeAt(0);
      }
      function isDigit(ch) {
        return ch >= 48 && ch <= 57;
      }
      function isWordChar(ch) {
        return isUpperCaseLetter(ch) || isLowerCaseLetter(ch) || isDigit(ch) || ch === 95 || ch === 36;
      }
      function breakPatternIntoTextChunks(pattern) {
        var result2 = [];
        var wordStart = 0;
        var wordLength = 0;
        for (var i = 0; i < pattern.length; i++) {
          var ch = pattern.charCodeAt(i);
          if (isWordChar(ch)) {
            if (wordLength === 0) {
              wordStart = i;
            }
            wordLength++;
          } else {
            if (wordLength > 0) {
              result2.push(createTextChunk(pattern.substr(wordStart, wordLength)));
              wordLength = 0;
            }
          }
        }
        if (wordLength > 0) {
          result2.push(createTextChunk(pattern.substr(wordStart, wordLength)));
        }
        return result2;
      }
      function createTextChunk(text) {
        var textLowerCase = text.toLowerCase();
        return {
          text,
          textLowerCase,
          isLowerCase: text === textLowerCase,
          characterSpans: breakIntoCharacterSpans(text)
        };
      }
      function breakIntoCharacterSpans(identifier) {
        return breakIntoSpans(identifier, false);
      }
      ts3.breakIntoCharacterSpans = breakIntoCharacterSpans;
      function breakIntoWordSpans(identifier) {
        return breakIntoSpans(identifier, true);
      }
      ts3.breakIntoWordSpans = breakIntoWordSpans;
      function breakIntoSpans(identifier, word) {
        var result2 = [];
        var wordStart = 0;
        for (var i = 1; i < identifier.length; i++) {
          var lastIsDigit = isDigit(identifier.charCodeAt(i - 1));
          var currentIsDigit = isDigit(identifier.charCodeAt(i));
          var hasTransitionFromLowerToUpper = transitionFromLowerToUpper(identifier, word, i);
          var hasTransitionFromUpperToLower = word && transitionFromUpperToLower(identifier, i, wordStart);
          if (charIsPunctuation(identifier.charCodeAt(i - 1)) || charIsPunctuation(identifier.charCodeAt(i)) || lastIsDigit !== currentIsDigit || hasTransitionFromLowerToUpper || hasTransitionFromUpperToLower) {
            if (!isAllPunctuation(identifier, wordStart, i)) {
              result2.push(ts3.createTextSpan(wordStart, i - wordStart));
            }
            wordStart = i;
          }
        }
        if (!isAllPunctuation(identifier, wordStart, identifier.length)) {
          result2.push(ts3.createTextSpan(wordStart, identifier.length - wordStart));
        }
        return result2;
      }
      function charIsPunctuation(ch) {
        switch (ch) {
          case 33:
          case 34:
          case 35:
          case 37:
          case 38:
          case 39:
          case 40:
          case 41:
          case 42:
          case 44:
          case 45:
          case 46:
          case 47:
          case 58:
          case 59:
          case 63:
          case 64:
          case 91:
          case 92:
          case 93:
          case 95:
          case 123:
          case 125:
            return true;
        }
        return false;
      }
      function isAllPunctuation(identifier, start, end) {
        return every(identifier, function(ch) {
          return charIsPunctuation(ch) && ch !== 95;
        }, start, end);
      }
      function transitionFromUpperToLower(identifier, index, wordStart) {
        return index !== wordStart && index + 1 < identifier.length && isUpperCaseLetter(identifier.charCodeAt(index)) && isLowerCaseLetter(identifier.charCodeAt(index + 1)) && every(identifier, isUpperCaseLetter, wordStart, index);
      }
      function transitionFromLowerToUpper(identifier, word, index) {
        var lastIsUpper = isUpperCaseLetter(identifier.charCodeAt(index - 1));
        var currentIsUpper = isUpperCaseLetter(identifier.charCodeAt(index));
        return currentIsUpper && (!word || !lastIsUpper);
      }
      function everyInRange(start, end, pred) {
        for (var i = start; i < end; i++) {
          if (!pred(i)) {
            return false;
          }
        }
        return true;
      }
      function every(s, pred, start, end) {
        if (start === void 0) {
          start = 0;
        }
        if (end === void 0) {
          end = s.length;
        }
        return everyInRange(start, end, function(i) {
          return pred(s.charCodeAt(i), i);
        });
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function preProcessFile(sourceText, readImportFiles, detectJavaScriptImports) {
        if (readImportFiles === void 0) {
          readImportFiles = true;
        }
        if (detectJavaScriptImports === void 0) {
          detectJavaScriptImports = false;
        }
        var pragmaContext = {
          languageVersion: 1,
          pragmas: void 0,
          checkJsDirective: void 0,
          referencedFiles: [],
          typeReferenceDirectives: [],
          libReferenceDirectives: [],
          amdDependencies: [],
          hasNoDefaultLib: void 0,
          moduleName: void 0
        };
        var importedFiles = [];
        var ambientExternalModules;
        var lastToken;
        var currentToken;
        var braceNesting = 0;
        var externalModule = false;
        function nextToken() {
          lastToken = currentToken;
          currentToken = ts3.scanner.scan();
          if (currentToken === 18) {
            braceNesting++;
          } else if (currentToken === 19) {
            braceNesting--;
          }
          return currentToken;
        }
        function getFileReference() {
          var fileName2 = ts3.scanner.getTokenValue();
          var pos = ts3.scanner.getTokenPos();
          return { fileName: fileName2, pos, end: pos + fileName2.length };
        }
        function recordAmbientExternalModule() {
          if (!ambientExternalModules) {
            ambientExternalModules = [];
          }
          ambientExternalModules.push({ ref: getFileReference(), depth: braceNesting });
        }
        function recordModuleName() {
          importedFiles.push(getFileReference());
          markAsExternalModuleIfTopLevel();
        }
        function markAsExternalModuleIfTopLevel() {
          if (braceNesting === 0) {
            externalModule = true;
          }
        }
        function tryConsumeDeclare() {
          var token = ts3.scanner.getToken();
          if (token === 135) {
            token = nextToken();
            if (token === 141) {
              token = nextToken();
              if (token === 10) {
                recordAmbientExternalModule();
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeImport() {
          if (lastToken === 24) {
            return false;
          }
          var token = ts3.scanner.getToken();
          if (token === 100) {
            token = nextToken();
            if (token === 20) {
              token = nextToken();
              if (token === 10 || token === 14) {
                recordModuleName();
                return true;
              }
            } else if (token === 10) {
              recordModuleName();
              return true;
            } else {
              if (token === 152) {
                var skipTypeKeyword = ts3.scanner.lookAhead(function() {
                  var token2 = ts3.scanner.scan();
                  return token2 !== 156 && (token2 === 41 || token2 === 18 || token2 === 79 || ts3.isKeyword(token2));
                });
                if (skipTypeKeyword) {
                  token = nextToken();
                }
              }
              if (token === 79 || ts3.isKeyword(token)) {
                token = nextToken();
                if (token === 156) {
                  token = nextToken();
                  if (token === 10) {
                    recordModuleName();
                    return true;
                  }
                } else if (token === 63) {
                  if (tryConsumeRequireCall(true)) {
                    return true;
                  }
                } else if (token === 27) {
                  token = nextToken();
                } else {
                  return true;
                }
              }
              if (token === 18) {
                token = nextToken();
                while (token !== 19 && token !== 1) {
                  token = nextToken();
                }
                if (token === 19) {
                  token = nextToken();
                  if (token === 156) {
                    token = nextToken();
                    if (token === 10) {
                      recordModuleName();
                    }
                  }
                }
              } else if (token === 41) {
                token = nextToken();
                if (token === 127) {
                  token = nextToken();
                  if (token === 79 || ts3.isKeyword(token)) {
                    token = nextToken();
                    if (token === 156) {
                      token = nextToken();
                      if (token === 10) {
                        recordModuleName();
                      }
                    }
                  }
                }
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeExport() {
          var token = ts3.scanner.getToken();
          if (token === 93) {
            markAsExternalModuleIfTopLevel();
            token = nextToken();
            if (token === 152) {
              var skipTypeKeyword = ts3.scanner.lookAhead(function() {
                var token2 = ts3.scanner.scan();
                return token2 === 41 || token2 === 18;
              });
              if (skipTypeKeyword) {
                token = nextToken();
              }
            }
            if (token === 18) {
              token = nextToken();
              while (token !== 19 && token !== 1) {
                token = nextToken();
              }
              if (token === 19) {
                token = nextToken();
                if (token === 156) {
                  token = nextToken();
                  if (token === 10) {
                    recordModuleName();
                  }
                }
              }
            } else if (token === 41) {
              token = nextToken();
              if (token === 156) {
                token = nextToken();
                if (token === 10) {
                  recordModuleName();
                }
              }
            } else if (token === 100) {
              token = nextToken();
              if (token === 152) {
                var skipTypeKeyword = ts3.scanner.lookAhead(function() {
                  var token2 = ts3.scanner.scan();
                  return token2 === 79 || ts3.isKeyword(token2);
                });
                if (skipTypeKeyword) {
                  token = nextToken();
                }
              }
              if (token === 79 || ts3.isKeyword(token)) {
                token = nextToken();
                if (token === 63) {
                  if (tryConsumeRequireCall(true)) {
                    return true;
                  }
                }
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeRequireCall(skipCurrentToken, allowTemplateLiterals) {
          if (allowTemplateLiterals === void 0) {
            allowTemplateLiterals = false;
          }
          var token = skipCurrentToken ? nextToken() : ts3.scanner.getToken();
          if (token === 146) {
            token = nextToken();
            if (token === 20) {
              token = nextToken();
              if (token === 10 || allowTemplateLiterals && token === 14) {
                recordModuleName();
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeDefine() {
          var token = ts3.scanner.getToken();
          if (token === 79 && ts3.scanner.getTokenValue() === "define") {
            token = nextToken();
            if (token !== 20) {
              return true;
            }
            token = nextToken();
            if (token === 10 || token === 14) {
              token = nextToken();
              if (token === 27) {
                token = nextToken();
              } else {
                return true;
              }
            }
            if (token !== 22) {
              return true;
            }
            token = nextToken();
            while (token !== 23 && token !== 1) {
              if (token === 10 || token === 14) {
                recordModuleName();
              }
              token = nextToken();
            }
            return true;
          }
          return false;
        }
        function processImports() {
          ts3.scanner.setText(sourceText);
          nextToken();
          while (true) {
            if (ts3.scanner.getToken() === 1) {
              break;
            }
            if (ts3.scanner.getToken() === 15) {
              var stack = [ts3.scanner.getToken()];
              var token = ts3.scanner.scan();
              loop:
                while (ts3.length(stack)) {
                  switch (token) {
                    case 1:
                      break loop;
                    case 100:
                      tryConsumeImport();
                      break;
                    case 15:
                      stack.push(token);
                      break;
                    case 18:
                      if (ts3.length(stack)) {
                        stack.push(token);
                      }
                      break;
                    case 19:
                      if (ts3.length(stack)) {
                        if (ts3.lastOrUndefined(stack) === 15) {
                          if (ts3.scanner.reScanTemplateToken(false) === 17) {
                            stack.pop();
                          }
                        } else {
                          stack.pop();
                        }
                      }
                      break;
                  }
                  token = ts3.scanner.scan();
                }
              nextToken();
            }
            if (tryConsumeDeclare() || tryConsumeImport() || tryConsumeExport() || detectJavaScriptImports && (tryConsumeRequireCall(false, true) || tryConsumeDefine())) {
              continue;
            } else {
              nextToken();
            }
          }
          ts3.scanner.setText(void 0);
        }
        if (readImportFiles) {
          processImports();
        }
        ts3.processCommentPragmas(pragmaContext, sourceText);
        ts3.processPragmasIntoFields(pragmaContext, ts3.noop);
        if (externalModule) {
          if (ambientExternalModules) {
            for (var _i = 0, ambientExternalModules_1 = ambientExternalModules; _i < ambientExternalModules_1.length; _i++) {
              var decl = ambientExternalModules_1[_i];
              importedFiles.push(decl.ref);
            }
          }
          return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: void 0 };
        } else {
          var ambientModuleNames = void 0;
          if (ambientExternalModules) {
            for (var _a = 0, ambientExternalModules_2 = ambientExternalModules; _a < ambientExternalModules_2.length; _a++) {
              var decl = ambientExternalModules_2[_a];
              if (decl.depth === 0) {
                if (!ambientModuleNames) {
                  ambientModuleNames = [];
                }
                ambientModuleNames.push(decl.ref.fileName);
              } else {
                importedFiles.push(decl.ref);
              }
            }
          }
          return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: ambientModuleNames };
        }
      }
      ts3.preProcessFile = preProcessFile;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var Rename;
      (function(Rename2) {
        function getRenameInfo(program2, sourceFile, position, options) {
          var node = ts3.getAdjustedRenameLocation(ts3.getTouchingPropertyName(sourceFile, position));
          if (nodeIsEligibleForRename(node)) {
            var renameInfo = getRenameInfoForNode(node, program2.getTypeChecker(), sourceFile, program2, options);
            if (renameInfo) {
              return renameInfo;
            }
          }
          return getRenameInfoError(ts3.Diagnostics.You_cannot_rename_this_element);
        }
        Rename2.getRenameInfo = getRenameInfo;
        function getRenameInfoForNode(node, typeChecker, sourceFile, program2, options) {
          var symbol = typeChecker.getSymbolAtLocation(node);
          if (!symbol) {
            if (ts3.isStringLiteralLike(node)) {
              var type2 = ts3.getContextualTypeFromParentOrAncestorTypeNode(node, typeChecker);
              if (type2 && (type2.flags & 128 || type2.flags & 1048576 && ts3.every(type2.types, function(type3) {
                return !!(type3.flags & 128);
              }))) {
                return getRenameInfoSuccess(node.text, node.text, "string", "", node, sourceFile);
              }
            } else if (ts3.isLabelName(node)) {
              var name = ts3.getTextOfNode(node);
              return getRenameInfoSuccess(name, name, "label", "", node, sourceFile);
            }
            return void 0;
          }
          var declarations = symbol.declarations;
          if (!declarations || declarations.length === 0)
            return;
          if (declarations.some(function(declaration) {
            return isDefinedInLibraryFile(program2, declaration);
          })) {
            return getRenameInfoError(ts3.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);
          }
          if (ts3.isIdentifier(node) && node.originalKeywordKind === 88 && symbol.parent && symbol.parent.flags & 1536) {
            return void 0;
          }
          if (ts3.isStringLiteralLike(node) && ts3.tryGetImportFromModuleSpecifier(node)) {
            return options && options.allowRenameOfImportPath ? getRenameInfoForModule(node, sourceFile, symbol) : void 0;
          }
          var kind = ts3.SymbolDisplay.getSymbolKind(typeChecker, symbol, node);
          var specifierName = ts3.isImportOrExportSpecifierName(node) || ts3.isStringOrNumericLiteralLike(node) && node.parent.kind === 162 ? ts3.stripQuotes(ts3.getTextOfIdentifierOrLiteral(node)) : void 0;
          var displayName = specifierName || typeChecker.symbolToString(symbol);
          var fullDisplayName = specifierName || typeChecker.getFullyQualifiedName(symbol);
          return getRenameInfoSuccess(displayName, fullDisplayName, kind, ts3.SymbolDisplay.getSymbolModifiers(typeChecker, symbol), node, sourceFile);
        }
        function isDefinedInLibraryFile(program2, declaration) {
          var sourceFile = declaration.getSourceFile();
          return program2.isSourceFileDefaultLibrary(sourceFile) && ts3.fileExtensionIs(sourceFile.fileName, ".d.ts");
        }
        function getRenameInfoForModule(node, sourceFile, moduleSymbol) {
          if (!ts3.isExternalModuleNameRelative(node.text)) {
            return getRenameInfoError(ts3.Diagnostics.You_cannot_rename_a_module_via_a_global_import);
          }
          var moduleSourceFile = moduleSymbol.declarations && ts3.find(moduleSymbol.declarations, ts3.isSourceFile);
          if (!moduleSourceFile)
            return void 0;
          var withoutIndex = ts3.endsWith(node.text, "/index") || ts3.endsWith(node.text, "/index.js") ? void 0 : ts3.tryRemoveSuffix(ts3.removeFileExtension(moduleSourceFile.fileName), "/index");
          var name = withoutIndex === void 0 ? moduleSourceFile.fileName : withoutIndex;
          var kind = withoutIndex === void 0 ? "module" : "directory";
          var indexAfterLastSlash = node.text.lastIndexOf("/") + 1;
          var triggerSpan = ts3.createTextSpan(node.getStart(sourceFile) + 1 + indexAfterLastSlash, node.text.length - indexAfterLastSlash);
          return {
            canRename: true,
            fileToRename: name,
            kind,
            displayName: name,
            fullDisplayName: name,
            kindModifiers: "",
            triggerSpan
          };
        }
        function getRenameInfoSuccess(displayName, fullDisplayName, kind, kindModifiers, node, sourceFile) {
          return {
            canRename: true,
            fileToRename: void 0,
            kind,
            displayName,
            fullDisplayName,
            kindModifiers,
            triggerSpan: createTriggerSpanForNode(node, sourceFile)
          };
        }
        function getRenameInfoError(diagnostic) {
          return { canRename: false, localizedErrorMessage: ts3.getLocaleSpecificMessage(diagnostic) };
        }
        function createTriggerSpanForNode(node, sourceFile) {
          var start = node.getStart(sourceFile);
          var width = node.getWidth(sourceFile);
          if (ts3.isStringLiteralLike(node)) {
            start += 1;
            width -= 2;
          }
          return ts3.createTextSpan(start, width);
        }
        function nodeIsEligibleForRename(node) {
          switch (node.kind) {
            case 79:
            case 80:
            case 10:
            case 14:
            case 108:
              return true;
            case 8:
              return ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess(node);
            default:
              return false;
          }
        }
        Rename2.nodeIsEligibleForRename = nodeIsEligibleForRename;
      })(Rename = ts3.Rename || (ts3.Rename = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SmartSelectionRange;
      (function(SmartSelectionRange2) {
        function getSmartSelectionRange(pos, sourceFile) {
          var _a;
          var selectionRange = {
            textSpan: ts3.createTextSpanFromBounds(sourceFile.getFullStart(), sourceFile.getEnd())
          };
          var parentNode = sourceFile;
          outer:
            while (true) {
              var children = getSelectionChildren(parentNode);
              if (!children.length)
                break;
              for (var i = 0; i < children.length; i++) {
                var prevNode = children[i - 1];
                var node = children[i];
                var nextNode = children[i + 1];
                if (ts3.getTokenPosOfNode(node, sourceFile, true) > pos) {
                  break outer;
                }
                var comment = ts3.singleOrUndefined(ts3.getTrailingCommentRanges(sourceFile.text, node.end));
                if (comment && comment.kind === 2) {
                  pushSelectionCommentRange(comment.pos, comment.end);
                }
                if (positionShouldSnapToNode(sourceFile, pos, node)) {
                  if (ts3.isBlock(node) || ts3.isTemplateSpan(node) || ts3.isTemplateHead(node) || ts3.isTemplateTail(node) || prevNode && ts3.isTemplateHead(prevNode) || ts3.isVariableDeclarationList(node) && ts3.isVariableStatement(parentNode) || ts3.isSyntaxList(node) && ts3.isVariableDeclarationList(parentNode) || ts3.isVariableDeclaration(node) && ts3.isSyntaxList(parentNode) && children.length === 1 || ts3.isJSDocTypeExpression(node) || ts3.isJSDocSignature(node) || ts3.isJSDocTypeLiteral(node)) {
                    parentNode = node;
                    break;
                  }
                  if (ts3.isTemplateSpan(parentNode) && nextNode && ts3.isTemplateMiddleOrTemplateTail(nextNode)) {
                    var start_1 = node.getFullStart() - "${".length;
                    var end_2 = nextNode.getStart() + "}".length;
                    pushSelectionRange(start_1, end_2);
                  }
                  var isBetweenMultiLineBookends = ts3.isSyntaxList(node) && isListOpener(prevNode) && isListCloser(nextNode) && !ts3.positionsAreOnSameLine(prevNode.getStart(), nextNode.getStart(), sourceFile);
                  var start = isBetweenMultiLineBookends ? prevNode.getEnd() : node.getStart();
                  var end = isBetweenMultiLineBookends ? nextNode.getStart() : getEndPos(sourceFile, node);
                  if (ts3.hasJSDocNodes(node) && ((_a = node.jsDoc) === null || _a === void 0 ? void 0 : _a.length)) {
                    pushSelectionRange(ts3.first(node.jsDoc).getStart(), end);
                  }
                  pushSelectionRange(start, end);
                  if (ts3.isStringLiteral(node) || ts3.isTemplateLiteral(node)) {
                    pushSelectionRange(start + 1, end - 1);
                  }
                  parentNode = node;
                  break;
                }
                if (i === children.length - 1) {
                  break outer;
                }
              }
            }
          return selectionRange;
          function pushSelectionRange(start2, end2) {
            if (start2 !== end2) {
              var textSpan = ts3.createTextSpanFromBounds(start2, end2);
              if (!selectionRange || !ts3.textSpansEqual(textSpan, selectionRange.textSpan) && ts3.textSpanIntersectsWithPosition(textSpan, pos)) {
                selectionRange = __assign({ textSpan }, selectionRange && { parent: selectionRange });
              }
            }
          }
          function pushSelectionCommentRange(start2, end2) {
            pushSelectionRange(start2, end2);
            var pos2 = start2;
            while (sourceFile.text.charCodeAt(pos2) === 47) {
              pos2++;
            }
            pushSelectionRange(pos2, end2);
          }
        }
        SmartSelectionRange2.getSmartSelectionRange = getSmartSelectionRange;
        function positionShouldSnapToNode(sourceFile, pos, node) {
          ts3.Debug.assert(node.pos <= pos);
          if (pos < node.end) {
            return true;
          }
          var nodeEnd = node.getEnd();
          if (nodeEnd === pos) {
            return ts3.getTouchingPropertyName(sourceFile, pos).pos < node.end;
          }
          return false;
        }
        var isImport = ts3.or(ts3.isImportDeclaration, ts3.isImportEqualsDeclaration);
        function getSelectionChildren(node) {
          if (ts3.isSourceFile(node)) {
            return groupChildren(node.getChildAt(0).getChildren(), isImport);
          }
          if (ts3.isMappedTypeNode(node)) {
            var _a = node.getChildren(), openBraceToken = _a[0], children = _a.slice(1);
            var closeBraceToken = ts3.Debug.checkDefined(children.pop());
            ts3.Debug.assertEqual(openBraceToken.kind, 18);
            ts3.Debug.assertEqual(closeBraceToken.kind, 19);
            var groupedWithPlusMinusTokens = groupChildren(children, function(child) {
              return child === node.readonlyToken || child.kind === 145 || child === node.questionToken || child.kind === 57;
            });
            var groupedWithBrackets = groupChildren(groupedWithPlusMinusTokens, function(_a2) {
              var kind = _a2.kind;
              return kind === 22 || kind === 163 || kind === 23;
            });
            return [
              openBraceToken,
              createSyntaxList(splitChildren(groupedWithBrackets, function(_a2) {
                var kind = _a2.kind;
                return kind === 58;
              })),
              closeBraceToken
            ];
          }
          if (ts3.isPropertySignature(node)) {
            var children = groupChildren(node.getChildren(), function(child) {
              return child === node.name || ts3.contains(node.modifiers, child);
            });
            return splitChildren(children, function(_a2) {
              var kind = _a2.kind;
              return kind === 58;
            });
          }
          if (ts3.isParameter(node)) {
            var groupedDotDotDotAndName_1 = groupChildren(node.getChildren(), function(child) {
              return child === node.dotDotDotToken || child === node.name;
            });
            var groupedWithQuestionToken = groupChildren(groupedDotDotDotAndName_1, function(child) {
              return child === groupedDotDotDotAndName_1[0] || child === node.questionToken;
            });
            return splitChildren(groupedWithQuestionToken, function(_a2) {
              var kind = _a2.kind;
              return kind === 63;
            });
          }
          if (ts3.isBindingElement(node)) {
            return splitChildren(node.getChildren(), function(_a2) {
              var kind = _a2.kind;
              return kind === 63;
            });
          }
          return node.getChildren();
        }
        function groupChildren(children, groupOn) {
          var result2 = [];
          var group;
          for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            if (groupOn(child)) {
              group = group || [];
              group.push(child);
            } else {
              if (group) {
                result2.push(createSyntaxList(group));
                group = void 0;
              }
              result2.push(child);
            }
          }
          if (group) {
            result2.push(createSyntaxList(group));
          }
          return result2;
        }
        function splitChildren(children, pivotOn, separateTrailingSemicolon) {
          if (separateTrailingSemicolon === void 0) {
            separateTrailingSemicolon = true;
          }
          if (children.length < 2) {
            return children;
          }
          var splitTokenIndex = ts3.findIndex(children, pivotOn);
          if (splitTokenIndex === -1) {
            return children;
          }
          var leftChildren = children.slice(0, splitTokenIndex);
          var splitToken = children[splitTokenIndex];
          var lastToken = ts3.last(children);
          var separateLastToken = separateTrailingSemicolon && lastToken.kind === 26;
          var rightChildren = children.slice(splitTokenIndex + 1, separateLastToken ? children.length - 1 : void 0);
          var result2 = ts3.compact([
            leftChildren.length ? createSyntaxList(leftChildren) : void 0,
            splitToken,
            rightChildren.length ? createSyntaxList(rightChildren) : void 0
          ]);
          return separateLastToken ? result2.concat(lastToken) : result2;
        }
        function createSyntaxList(children) {
          ts3.Debug.assertGreaterThanOrEqual(children.length, 1);
          return ts3.setTextRangePosEnd(ts3.parseNodeFactory.createSyntaxList(children), children[0].pos, ts3.last(children).end);
        }
        function isListOpener(token) {
          var kind = token && token.kind;
          return kind === 18 || kind === 22 || kind === 20 || kind === 280;
        }
        function isListCloser(token) {
          var kind = token && token.kind;
          return kind === 19 || kind === 23 || kind === 21 || kind === 281;
        }
        function getEndPos(sourceFile, node) {
          switch (node.kind) {
            case 340:
            case 338:
            case 347:
            case 345:
            case 342:
              return sourceFile.getLineEndOfPosition(node.getStart());
            default:
              return node.getEnd();
          }
        }
      })(SmartSelectionRange = ts3.SmartSelectionRange || (ts3.SmartSelectionRange = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SignatureHelp;
      (function(SignatureHelp2) {
        var InvocationKind;
        (function(InvocationKind2) {
          InvocationKind2[InvocationKind2["Call"] = 0] = "Call";
          InvocationKind2[InvocationKind2["TypeArgs"] = 1] = "TypeArgs";
          InvocationKind2[InvocationKind2["Contextual"] = 2] = "Contextual";
        })(InvocationKind || (InvocationKind = {}));
        function getSignatureHelpItems(program2, sourceFile, position, triggerReason, cancellationToken) {
          var typeChecker = program2.getTypeChecker();
          var startingToken = ts3.findTokenOnLeftOfPosition(sourceFile, position);
          if (!startingToken) {
            return void 0;
          }
          var onlyUseSyntacticOwners = !!triggerReason && triggerReason.kind === "characterTyped";
          if (onlyUseSyntacticOwners && (ts3.isInString(sourceFile, position, startingToken) || ts3.isInComment(sourceFile, position))) {
            return void 0;
          }
          var isManuallyInvoked = !!triggerReason && triggerReason.kind === "invoked";
          var argumentInfo = getContainingArgumentInfo(startingToken, position, sourceFile, typeChecker, isManuallyInvoked);
          if (!argumentInfo)
            return void 0;
          cancellationToken.throwIfCancellationRequested();
          var candidateInfo = getCandidateOrTypeInfo(argumentInfo, typeChecker, sourceFile, startingToken, onlyUseSyntacticOwners);
          cancellationToken.throwIfCancellationRequested();
          if (!candidateInfo) {
            return ts3.isSourceFileJS(sourceFile) ? createJSSignatureHelpItems(argumentInfo, program2, cancellationToken) : void 0;
          }
          return typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
            return candidateInfo.kind === 0 ? createSignatureHelpItems(candidateInfo.candidates, candidateInfo.resolvedSignature, argumentInfo, sourceFile, typeChecker2) : createTypeHelpItems(candidateInfo.symbol, argumentInfo, sourceFile, typeChecker2);
          });
        }
        SignatureHelp2.getSignatureHelpItems = getSignatureHelpItems;
        var CandidateOrTypeKind;
        (function(CandidateOrTypeKind2) {
          CandidateOrTypeKind2[CandidateOrTypeKind2["Candidate"] = 0] = "Candidate";
          CandidateOrTypeKind2[CandidateOrTypeKind2["Type"] = 1] = "Type";
        })(CandidateOrTypeKind || (CandidateOrTypeKind = {}));
        function getCandidateOrTypeInfo(_a, checker, sourceFile, startingToken, onlyUseSyntacticOwners) {
          var invocation = _a.invocation, argumentCount = _a.argumentCount;
          switch (invocation.kind) {
            case 0: {
              if (onlyUseSyntacticOwners && !isSyntacticOwner(startingToken, invocation.node, sourceFile)) {
                return void 0;
              }
              var candidates = [];
              var resolvedSignature = checker.getResolvedSignatureForSignatureHelp(invocation.node, candidates, argumentCount);
              return candidates.length === 0 ? void 0 : { kind: 0, candidates, resolvedSignature };
            }
            case 1: {
              var called = invocation.called;
              if (onlyUseSyntacticOwners && !containsPrecedingToken(startingToken, sourceFile, ts3.isIdentifier(called) ? called.parent : called)) {
                return void 0;
              }
              var candidates = ts3.getPossibleGenericSignatures(called, argumentCount, checker);
              if (candidates.length !== 0)
                return { kind: 0, candidates, resolvedSignature: ts3.first(candidates) };
              var symbol = checker.getSymbolAtLocation(called);
              return symbol && { kind: 1, symbol };
            }
            case 2:
              return { kind: 0, candidates: [invocation.signature], resolvedSignature: invocation.signature };
            default:
              return ts3.Debug.assertNever(invocation);
          }
        }
        function isSyntacticOwner(startingToken, node, sourceFile) {
          if (!ts3.isCallOrNewExpression(node))
            return false;
          var invocationChildren = node.getChildren(sourceFile);
          switch (startingToken.kind) {
            case 20:
              return ts3.contains(invocationChildren, startingToken);
            case 27: {
              var containingList = ts3.findContainingList(startingToken);
              return !!containingList && ts3.contains(invocationChildren, containingList);
            }
            case 29:
              return containsPrecedingToken(startingToken, sourceFile, node.expression);
            default:
              return false;
          }
        }
        function createJSSignatureHelpItems(argumentInfo, program2, cancellationToken) {
          if (argumentInfo.invocation.kind === 2)
            return void 0;
          var expression = getExpressionFromInvocation(argumentInfo.invocation);
          var name = ts3.isPropertyAccessExpression(expression) ? expression.name.text : void 0;
          var typeChecker = program2.getTypeChecker();
          return name === void 0 ? void 0 : ts3.firstDefined(program2.getSourceFiles(), function(sourceFile) {
            return ts3.firstDefined(sourceFile.getNamedDeclarations().get(name), function(declaration) {
              var type2 = declaration.symbol && typeChecker.getTypeOfSymbolAtLocation(declaration.symbol, declaration);
              var callSignatures = type2 && type2.getCallSignatures();
              if (callSignatures && callSignatures.length) {
                return typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
                  return createSignatureHelpItems(callSignatures, callSignatures[0], argumentInfo, sourceFile, typeChecker2, true);
                });
              }
            });
          });
        }
        function containsPrecedingToken(startingToken, sourceFile, container) {
          var pos = startingToken.getFullStart();
          var currentParent = startingToken.parent;
          while (currentParent) {
            var precedingToken = ts3.findPrecedingToken(pos, sourceFile, currentParent, true);
            if (precedingToken) {
              return ts3.rangeContainsRange(container, precedingToken);
            }
            currentParent = currentParent.parent;
          }
          return ts3.Debug.fail("Could not find preceding token");
        }
        function getArgumentInfoForCompletions(node, position, sourceFile) {
          var info = getImmediatelyContainingArgumentInfo(node, position, sourceFile);
          return !info || info.isTypeParameterList || info.invocation.kind !== 0 ? void 0 : { invocation: info.invocation.node, argumentCount: info.argumentCount, argumentIndex: info.argumentIndex };
        }
        SignatureHelp2.getArgumentInfoForCompletions = getArgumentInfoForCompletions;
        function getArgumentOrParameterListInfo(node, position, sourceFile) {
          var info = getArgumentOrParameterListAndIndex(node, sourceFile);
          if (!info)
            return void 0;
          var list = info.list, argumentIndex = info.argumentIndex;
          var argumentCount = getArgumentCount(list, ts3.isInString(sourceFile, position, node));
          if (argumentIndex !== 0) {
            ts3.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          var argumentsSpan = getApplicableSpanForArguments(list, sourceFile);
          return { list, argumentIndex, argumentCount, argumentsSpan };
        }
        function getArgumentOrParameterListAndIndex(node, sourceFile) {
          if (node.kind === 29 || node.kind === 20) {
            return { list: getChildListThatStartsWithOpenerToken(node.parent, node, sourceFile), argumentIndex: 0 };
          } else {
            var list = ts3.findContainingList(node);
            return list && { list, argumentIndex: getArgumentIndex(list, node) };
          }
        }
        function getImmediatelyContainingArgumentInfo(node, position, sourceFile) {
          var parent = node.parent;
          if (ts3.isCallOrNewExpression(parent)) {
            var invocation = parent;
            var info = getArgumentOrParameterListInfo(node, position, sourceFile);
            if (!info)
              return void 0;
            var list = info.list, argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
            var isTypeParameterList = !!parent.typeArguments && parent.typeArguments.pos === list.pos;
            return { isTypeParameterList, invocation: { kind: 0, node: invocation }, argumentsSpan, argumentIndex, argumentCount };
          } else if (ts3.isNoSubstitutionTemplateLiteral(node) && ts3.isTaggedTemplateExpression(parent)) {
            if (ts3.isInsideTemplateLiteral(node, position, sourceFile)) {
              return getArgumentListInfoForTemplate(parent, 0, sourceFile);
            }
            return void 0;
          } else if (ts3.isTemplateHead(node) && parent.parent.kind === 210) {
            var templateExpression = parent;
            var tagExpression = templateExpression.parent;
            ts3.Debug.assert(templateExpression.kind === 223);
            var argumentIndex = ts3.isInsideTemplateLiteral(node, position, sourceFile) ? 0 : 1;
            return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
          } else if (ts3.isTemplateSpan(parent) && ts3.isTaggedTemplateExpression(parent.parent.parent)) {
            var templateSpan = parent;
            var tagExpression = parent.parent.parent;
            if (ts3.isTemplateTail(node) && !ts3.isInsideTemplateLiteral(node, position, sourceFile)) {
              return void 0;
            }
            var spanIndex = templateSpan.parent.templateSpans.indexOf(templateSpan);
            var argumentIndex = getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile);
            return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
          } else if (ts3.isJsxOpeningLikeElement(parent)) {
            var attributeSpanStart = parent.attributes.pos;
            var attributeSpanEnd = ts3.skipTrivia(sourceFile.text, parent.attributes.end, false);
            return {
              isTypeParameterList: false,
              invocation: { kind: 0, node: parent },
              argumentsSpan: ts3.createTextSpan(attributeSpanStart, attributeSpanEnd - attributeSpanStart),
              argumentIndex: 0,
              argumentCount: 1
            };
          } else {
            var typeArgInfo = ts3.getPossibleTypeArgumentsInfo(node, sourceFile);
            if (typeArgInfo) {
              var called = typeArgInfo.called, nTypeArguments = typeArgInfo.nTypeArguments;
              var invocation = { kind: 1, called };
              var argumentsSpan = ts3.createTextSpanFromBounds(called.getStart(sourceFile), node.end);
              return { isTypeParameterList: true, invocation, argumentsSpan, argumentIndex: nTypeArguments, argumentCount: nTypeArguments + 1 };
            }
            return void 0;
          }
        }
        function getImmediatelyContainingArgumentOrContextualParameterInfo(node, position, sourceFile, checker) {
          return tryGetParameterInfo(node, position, sourceFile, checker) || getImmediatelyContainingArgumentInfo(node, position, sourceFile);
        }
        function getHighestBinary(b) {
          return ts3.isBinaryExpression(b.parent) ? getHighestBinary(b.parent) : b;
        }
        function countBinaryExpressionParameters(b) {
          return ts3.isBinaryExpression(b.left) ? countBinaryExpressionParameters(b.left) + 1 : 2;
        }
        function tryGetParameterInfo(startingToken, position, sourceFile, checker) {
          var info = getContextualSignatureLocationInfo(startingToken, sourceFile, position, checker);
          if (!info)
            return void 0;
          var contextualType = info.contextualType, argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
          var nonNullableContextualType = contextualType.getNonNullableType();
          var symbol = nonNullableContextualType.symbol;
          if (symbol === void 0)
            return void 0;
          var signature = ts3.lastOrUndefined(nonNullableContextualType.getCallSignatures());
          if (signature === void 0)
            return void 0;
          var invocation = { kind: 2, signature, node: startingToken, symbol: chooseBetterSymbol(symbol) };
          return { isTypeParameterList: false, invocation, argumentsSpan, argumentIndex, argumentCount };
        }
        function getContextualSignatureLocationInfo(startingToken, sourceFile, position, checker) {
          if (startingToken.kind !== 20 && startingToken.kind !== 27)
            return void 0;
          var parent = startingToken.parent;
          switch (parent.kind) {
            case 212:
            case 169:
            case 213:
            case 214:
              var info = getArgumentOrParameterListInfo(startingToken, position, sourceFile);
              if (!info)
                return void 0;
              var argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
              var contextualType = ts3.isMethodDeclaration(parent) ? checker.getContextualTypeForObjectLiteralElement(parent) : checker.getContextualType(parent);
              return contextualType && { contextualType, argumentIndex, argumentCount, argumentsSpan };
            case 221: {
              var highestBinary = getHighestBinary(parent);
              var contextualType_1 = checker.getContextualType(highestBinary);
              var argumentIndex_1 = startingToken.kind === 20 ? 0 : countBinaryExpressionParameters(parent) - 1;
              var argumentCount_1 = countBinaryExpressionParameters(highestBinary);
              return contextualType_1 && { contextualType: contextualType_1, argumentIndex: argumentIndex_1, argumentCount: argumentCount_1, argumentsSpan: ts3.createTextSpanFromNode(parent) };
            }
            default:
              return void 0;
          }
        }
        function chooseBetterSymbol(s) {
          return s.name === "__type" ? ts3.firstDefined(s.declarations, function(d) {
            return ts3.isFunctionTypeNode(d) ? d.parent.symbol : void 0;
          }) || s : s;
        }
        function getArgumentIndex(argumentsList, node) {
          var argumentIndex = 0;
          for (var _i = 0, _a = argumentsList.getChildren(); _i < _a.length; _i++) {
            var child = _a[_i];
            if (child === node) {
              break;
            }
            if (child.kind !== 27) {
              argumentIndex++;
            }
          }
          return argumentIndex;
        }
        function getArgumentCount(argumentsList, ignoreTrailingComma) {
          var listChildren = argumentsList.getChildren();
          var argumentCount = ts3.countWhere(listChildren, function(arg) {
            return arg.kind !== 27;
          });
          if (!ignoreTrailingComma && listChildren.length > 0 && ts3.last(listChildren).kind === 27) {
            argumentCount++;
          }
          return argumentCount;
        }
        function getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile) {
          ts3.Debug.assert(position >= node.getStart(), "Assumed 'position' could not occur before node.");
          if (ts3.isTemplateLiteralToken(node)) {
            if (ts3.isInsideTemplateLiteral(node, position, sourceFile)) {
              return 0;
            }
            return spanIndex + 2;
          }
          return spanIndex + 1;
        }
        function getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile) {
          var argumentCount = ts3.isNoSubstitutionTemplateLiteral(tagExpression.template) ? 1 : tagExpression.template.templateSpans.length + 1;
          if (argumentIndex !== 0) {
            ts3.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          return {
            isTypeParameterList: false,
            invocation: { kind: 0, node: tagExpression },
            argumentsSpan: getApplicableSpanForTaggedTemplate(tagExpression, sourceFile),
            argumentIndex,
            argumentCount
          };
        }
        function getApplicableSpanForArguments(argumentsList, sourceFile) {
          var applicableSpanStart = argumentsList.getFullStart();
          var applicableSpanEnd = ts3.skipTrivia(sourceFile.text, argumentsList.getEnd(), false);
          return ts3.createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
        }
        function getApplicableSpanForTaggedTemplate(taggedTemplate, sourceFile) {
          var template = taggedTemplate.template;
          var applicableSpanStart = template.getStart();
          var applicableSpanEnd = template.getEnd();
          if (template.kind === 223) {
            var lastSpan = ts3.last(template.templateSpans);
            if (lastSpan.literal.getFullWidth() === 0) {
              applicableSpanEnd = ts3.skipTrivia(sourceFile.text, applicableSpanEnd, false);
            }
          }
          return ts3.createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
        }
        function getContainingArgumentInfo(node, position, sourceFile, checker, isManuallyInvoked) {
          var _loop_9 = function(n2) {
            ts3.Debug.assert(ts3.rangeContainsRange(n2.parent, n2), "Not a subspan", function() {
              return "Child: ".concat(ts3.Debug.formatSyntaxKind(n2.kind), ", parent: ").concat(ts3.Debug.formatSyntaxKind(n2.parent.kind));
            });
            var argumentInfo = getImmediatelyContainingArgumentOrContextualParameterInfo(n2, position, sourceFile, checker);
            if (argumentInfo) {
              return { value: argumentInfo };
            }
          };
          for (var n = node; !ts3.isSourceFile(n) && (isManuallyInvoked || !ts3.isBlock(n)); n = n.parent) {
            var state_4 = _loop_9(n);
            if (typeof state_4 === "object")
              return state_4.value;
          }
          return void 0;
        }
        function getChildListThatStartsWithOpenerToken(parent, openerToken, sourceFile) {
          var children = parent.getChildren(sourceFile);
          var indexOfOpenerToken = children.indexOf(openerToken);
          ts3.Debug.assert(indexOfOpenerToken >= 0 && children.length > indexOfOpenerToken + 1);
          return children[indexOfOpenerToken + 1];
        }
        function getExpressionFromInvocation(invocation) {
          return invocation.kind === 0 ? ts3.getInvokedExpression(invocation.node) : invocation.called;
        }
        function getEnclosingDeclarationFromInvocation(invocation) {
          return invocation.kind === 0 ? invocation.node : invocation.kind === 1 ? invocation.called : invocation.node;
        }
        var signatureHelpNodeBuilderFlags = 8192 | 70221824 | 16384;
        function createSignatureHelpItems(candidates, resolvedSignature, _a, sourceFile, typeChecker, useFullPrefix) {
          var _b;
          var isTypeParameterList = _a.isTypeParameterList, argumentCount = _a.argumentCount, applicableSpan = _a.argumentsSpan, invocation = _a.invocation, argumentIndex = _a.argumentIndex;
          var enclosingDeclaration = getEnclosingDeclarationFromInvocation(invocation);
          var callTargetSymbol = invocation.kind === 2 ? invocation.symbol : typeChecker.getSymbolAtLocation(getExpressionFromInvocation(invocation)) || useFullPrefix && ((_b = resolvedSignature.declaration) === null || _b === void 0 ? void 0 : _b.symbol);
          var callTargetDisplayParts = callTargetSymbol ? ts3.symbolToDisplayParts(typeChecker, callTargetSymbol, useFullPrefix ? sourceFile : void 0, void 0) : ts3.emptyArray;
          var items = ts3.map(candidates, function(candidateSignature) {
            return getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, typeChecker, enclosingDeclaration, sourceFile);
          });
          if (argumentIndex !== 0) {
            ts3.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          var selectedItemIndex = 0;
          var itemsSeen = 0;
          for (var i = 0; i < items.length; i++) {
            var item = items[i];
            if (candidates[i] === resolvedSignature) {
              selectedItemIndex = itemsSeen;
              if (item.length > 1) {
                var count = 0;
                for (var _i = 0, item_1 = item; _i < item_1.length; _i++) {
                  var i_1 = item_1[_i];
                  if (i_1.isVariadic || i_1.parameters.length >= argumentCount) {
                    selectedItemIndex = itemsSeen + count;
                    break;
                  }
                  count++;
                }
              }
            }
            itemsSeen += item.length;
          }
          ts3.Debug.assert(selectedItemIndex !== -1);
          var help = { items: ts3.flatMapToMutable(items, ts3.identity), applicableSpan, selectedItemIndex, argumentIndex, argumentCount };
          var selected = help.items[selectedItemIndex];
          if (selected.isVariadic) {
            var firstRest = ts3.findIndex(selected.parameters, function(p) {
              return !!p.isRest;
            });
            if (-1 < firstRest && firstRest < selected.parameters.length - 1) {
              help.argumentIndex = selected.parameters.length;
            } else {
              help.argumentIndex = Math.min(help.argumentIndex, selected.parameters.length - 1);
            }
          }
          return help;
        }
        function createTypeHelpItems(symbol, _a, sourceFile, checker) {
          var argumentCount = _a.argumentCount, applicableSpan = _a.argumentsSpan, invocation = _a.invocation, argumentIndex = _a.argumentIndex;
          var typeParameters = checker.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
          if (!typeParameters)
            return void 0;
          var items = [getTypeHelpItem(symbol, typeParameters, checker, getEnclosingDeclarationFromInvocation(invocation), sourceFile)];
          return { items, applicableSpan, selectedItemIndex: 0, argumentIndex, argumentCount };
        }
        function getTypeHelpItem(symbol, typeParameters, checker, enclosingDeclaration, sourceFile) {
          var typeSymbolDisplay = ts3.symbolToDisplayParts(checker, symbol);
          var printer2 = ts3.createPrinter({ removeComments: true });
          var parameters = typeParameters.map(function(t) {
            return createSignatureHelpParameterForTypeParameter(t, checker, enclosingDeclaration, sourceFile, printer2);
          });
          var documentation = symbol.getDocumentationComment(checker);
          var tags = symbol.getJsDocTags(checker);
          var prefixDisplayParts = __spreadArray(__spreadArray([], typeSymbolDisplay, true), [ts3.punctuationPart(29)], false);
          return { isVariadic: false, prefixDisplayParts, suffixDisplayParts: [ts3.punctuationPart(31)], separatorDisplayParts, parameters, documentation, tags };
        }
        var separatorDisplayParts = [ts3.punctuationPart(27), ts3.spacePart()];
        function getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, checker, enclosingDeclaration, sourceFile) {
          var infos = (isTypeParameterList ? itemInfoForTypeParameters : itemInfoForParameters)(candidateSignature, checker, enclosingDeclaration, sourceFile);
          return ts3.map(infos, function(_a) {
            var isVariadic = _a.isVariadic, parameters = _a.parameters, prefix = _a.prefix, suffix = _a.suffix;
            var prefixDisplayParts = __spreadArray(__spreadArray([], callTargetDisplayParts, true), prefix, true);
            var suffixDisplayParts = __spreadArray(__spreadArray([], suffix, true), returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker), true);
            var documentation = candidateSignature.getDocumentationComment(checker);
            var tags = candidateSignature.getJsDocTags();
            return { isVariadic, prefixDisplayParts, suffixDisplayParts, separatorDisplayParts, parameters, documentation, tags };
          });
        }
        function returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker) {
          return ts3.mapToDisplayParts(function(writer) {
            writer.writePunctuation(":");
            writer.writeSpace(" ");
            var predicate = checker.getTypePredicateOfSignature(candidateSignature);
            if (predicate) {
              checker.writeTypePredicate(predicate, enclosingDeclaration, void 0, writer);
            } else {
              checker.writeType(checker.getReturnTypeOfSignature(candidateSignature), enclosingDeclaration, void 0, writer);
            }
          });
        }
        function itemInfoForTypeParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
          var typeParameters = (candidateSignature.target || candidateSignature).typeParameters;
          var printer2 = ts3.createPrinter({ removeComments: true });
          var parameters = (typeParameters || ts3.emptyArray).map(function(t) {
            return createSignatureHelpParameterForTypeParameter(t, checker, enclosingDeclaration, sourceFile, printer2);
          });
          var thisParameter = candidateSignature.thisParameter ? [checker.symbolToParameterDeclaration(candidateSignature.thisParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags)] : [];
          return checker.getExpandedParameters(candidateSignature).map(function(paramList) {
            var params = ts3.factory.createNodeArray(__spreadArray(__spreadArray([], thisParameter, true), ts3.map(paramList, function(param) {
              return checker.symbolToParameterDeclaration(param, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            }), true));
            var parameterParts = ts3.mapToDisplayParts(function(writer) {
              printer2.writeList(2576, params, sourceFile, writer);
            });
            return { isVariadic: false, parameters, prefix: [ts3.punctuationPart(29)], suffix: __spreadArray([ts3.punctuationPart(31)], parameterParts, true) };
          });
        }
        function itemInfoForParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
          var printer2 = ts3.createPrinter({ removeComments: true });
          var typeParameterParts = ts3.mapToDisplayParts(function(writer) {
            if (candidateSignature.typeParameters && candidateSignature.typeParameters.length) {
              var args = ts3.factory.createNodeArray(candidateSignature.typeParameters.map(function(p) {
                return checker.typeParameterToDeclaration(p, enclosingDeclaration, signatureHelpNodeBuilderFlags);
              }));
              printer2.writeList(53776, args, sourceFile, writer);
            }
          });
          var lists = checker.getExpandedParameters(candidateSignature);
          var isVariadic = !checker.hasEffectiveRestParameter(candidateSignature) ? function(_) {
            return false;
          } : lists.length === 1 ? function(_) {
            return true;
          } : function(pList) {
            return !!(pList.length && pList[pList.length - 1].checkFlags & 32768);
          };
          return lists.map(function(parameterList) {
            return {
              isVariadic: isVariadic(parameterList),
              parameters: parameterList.map(function(p) {
                return createSignatureHelpParameterForParameter(p, checker, enclosingDeclaration, sourceFile, printer2);
              }),
              prefix: __spreadArray(__spreadArray([], typeParameterParts, true), [ts3.punctuationPart(20)], false),
              suffix: [ts3.punctuationPart(21)]
            };
          });
        }
        function createSignatureHelpParameterForParameter(parameter, checker, enclosingDeclaration, sourceFile, printer2) {
          var displayParts = ts3.mapToDisplayParts(function(writer) {
            var param = checker.symbolToParameterDeclaration(parameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            printer2.writeNode(4, param, sourceFile, writer);
          });
          var isOptional = checker.isOptionalParameter(parameter.valueDeclaration);
          var isRest = !!(parameter.checkFlags & 32768);
          return { name: parameter.name, documentation: parameter.getDocumentationComment(checker), displayParts, isOptional, isRest };
        }
        function createSignatureHelpParameterForTypeParameter(typeParameter, checker, enclosingDeclaration, sourceFile, printer2) {
          var displayParts = ts3.mapToDisplayParts(function(writer) {
            var param = checker.typeParameterToDeclaration(typeParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            printer2.writeNode(4, param, sourceFile, writer);
          });
          return { name: typeParameter.symbol.name, documentation: typeParameter.symbol.getDocumentationComment(checker), displayParts, isOptional: false, isRest: false };
        }
      })(SignatureHelp = ts3.SignatureHelp || (ts3.SignatureHelp = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var InlayHints;
      (function(InlayHints2) {
        var maxHintsLength = 30;
        var leadingParameterNameCommentRegexFactory = function(name) {
          return new RegExp("^\\s?/\\*\\*?\\s?".concat(name, "\\s?\\*\\/\\s?$"));
        };
        function shouldShowParameterNameHints(preferences) {
          return preferences.includeInlayParameterNameHints === "literals" || preferences.includeInlayParameterNameHints === "all";
        }
        function shouldShowLiteralParameterNameHintsOnly(preferences) {
          return preferences.includeInlayParameterNameHints === "literals";
        }
        function provideInlayHints(context) {
          var file = context.file, program2 = context.program, span = context.span, cancellationToken = context.cancellationToken, preferences = context.preferences;
          var sourceFileText = file.text;
          var compilerOptions = program2.getCompilerOptions();
          var checker = program2.getTypeChecker();
          var result2 = [];
          visitor(file);
          return result2;
          function visitor(node) {
            if (!node || node.getFullWidth() === 0) {
              return;
            }
            switch (node.kind) {
              case 261:
              case 257:
              case 258:
              case 256:
              case 226:
              case 213:
              case 169:
              case 214:
                cancellationToken.throwIfCancellationRequested();
            }
            if (!ts3.textSpanIntersectsWith(span, node.pos, node.getFullWidth())) {
              return;
            }
            if (ts3.isTypeNode(node)) {
              return;
            }
            if (preferences.includeInlayVariableTypeHints && ts3.isVariableDeclaration(node)) {
              visitVariableLikeDeclaration(node);
            } else if (preferences.includeInlayPropertyDeclarationTypeHints && ts3.isPropertyDeclaration(node)) {
              visitVariableLikeDeclaration(node);
            } else if (preferences.includeInlayEnumMemberValueHints && ts3.isEnumMember(node)) {
              visitEnumMember(node);
            } else if (shouldShowParameterNameHints(preferences) && (ts3.isCallExpression(node) || ts3.isNewExpression(node))) {
              visitCallOrNewExpression(node);
            } else {
              if (preferences.includeInlayFunctionParameterTypeHints && ts3.isFunctionLikeDeclaration(node) && ts3.hasContextSensitiveParameters(node)) {
                visitFunctionLikeForParameterType(node);
              }
              if (preferences.includeInlayFunctionLikeReturnTypeHints && isSignatureSupportingReturnAnnotation(node)) {
                visitFunctionDeclarationLikeForReturnType(node);
              }
            }
            return ts3.forEachChild(node, visitor);
          }
          function isSignatureSupportingReturnAnnotation(node) {
            return ts3.isArrowFunction(node) || ts3.isFunctionExpression(node) || ts3.isFunctionDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isGetAccessorDeclaration(node);
          }
          function addParameterHints(text, position, isFirstVariadicArgument) {
            result2.push({
              text: "".concat(isFirstVariadicArgument ? "..." : "").concat(truncation(text, maxHintsLength), ":"),
              position,
              kind: "Parameter",
              whitespaceAfter: true
            });
          }
          function addTypeHints(text, position) {
            result2.push({
              text: ": ".concat(truncation(text, maxHintsLength)),
              position,
              kind: "Type",
              whitespaceBefore: true
            });
          }
          function addEnumMemberValueHints(text, position) {
            result2.push({
              text: "= ".concat(truncation(text, maxHintsLength)),
              position,
              kind: "Enum",
              whitespaceBefore: true
            });
          }
          function visitEnumMember(member) {
            if (member.initializer) {
              return;
            }
            var enumValue = checker.getConstantValue(member);
            if (enumValue !== void 0) {
              addEnumMemberValueHints(enumValue.toString(), member.end);
            }
          }
          function isModuleReferenceType(type2) {
            return type2.symbol && type2.symbol.flags & 1536;
          }
          function visitVariableLikeDeclaration(decl) {
            if (!decl.initializer || ts3.isBindingPattern(decl.name)) {
              return;
            }
            var effectiveTypeAnnotation = ts3.getEffectiveTypeAnnotationNode(decl);
            if (effectiveTypeAnnotation) {
              return;
            }
            var declarationType = checker.getTypeAtLocation(decl);
            if (isModuleReferenceType(declarationType)) {
              return;
            }
            var typeDisplayString = printTypeInSingleLine(declarationType);
            if (typeDisplayString) {
              addTypeHints(typeDisplayString, decl.name.end);
            }
          }
          function visitCallOrNewExpression(expr) {
            var args = expr.arguments;
            if (!args || !args.length) {
              return;
            }
            var candidates = [];
            var signature = checker.getResolvedSignatureForSignatureHelp(expr, candidates);
            if (!signature || !candidates.length) {
              return;
            }
            for (var i = 0; i < args.length; ++i) {
              var originalArg = args[i];
              var arg = ts3.skipParentheses(originalArg);
              if (shouldShowLiteralParameterNameHintsOnly(preferences) && !isHintableLiteral(arg)) {
                continue;
              }
              var identifierNameInfo = checker.getParameterIdentifierNameAtPosition(signature, i);
              if (identifierNameInfo) {
                var parameterName = identifierNameInfo[0], isFirstVariadicArgument = identifierNameInfo[1];
                var isParameterNameNotSameAsArgument = preferences.includeInlayParameterNameHintsWhenArgumentMatchesName || !identifierOrAccessExpressionPostfixMatchesParameterName(arg, parameterName);
                if (!isParameterNameNotSameAsArgument && !isFirstVariadicArgument) {
                  continue;
                }
                var name = ts3.unescapeLeadingUnderscores(parameterName);
                if (leadingCommentsContainsParameterName(arg, name)) {
                  continue;
                }
                addParameterHints(name, originalArg.getStart(), isFirstVariadicArgument);
              }
            }
          }
          function identifierOrAccessExpressionPostfixMatchesParameterName(expr, parameterName) {
            if (ts3.isIdentifier(expr)) {
              return expr.text === parameterName;
            }
            if (ts3.isPropertyAccessExpression(expr)) {
              return expr.name.text === parameterName;
            }
            return false;
          }
          function leadingCommentsContainsParameterName(node, name) {
            if (!ts3.isIdentifierText(name, compilerOptions.target, ts3.getLanguageVariant(file.scriptKind))) {
              return false;
            }
            var ranges = ts3.getLeadingCommentRanges(sourceFileText, node.pos);
            if (!(ranges === null || ranges === void 0 ? void 0 : ranges.length)) {
              return false;
            }
            var regex = leadingParameterNameCommentRegexFactory(name);
            return ts3.some(ranges, function(range) {
              return regex.test(sourceFileText.substring(range.pos, range.end));
            });
          }
          function isHintableLiteral(node) {
            switch (node.kind) {
              case 219: {
                var operand = node.operand;
                return ts3.isLiteralExpression(operand) || ts3.isIdentifier(operand) && ts3.isInfinityOrNaNString(operand.escapedText);
              }
              case 110:
              case 95:
              case 104:
              case 14:
              case 223:
                return true;
              case 79: {
                var name = node.escapedText;
                return isUndefined(name) || ts3.isInfinityOrNaNString(name);
              }
            }
            return ts3.isLiteralExpression(node);
          }
          function visitFunctionDeclarationLikeForReturnType(decl) {
            if (ts3.isArrowFunction(decl)) {
              if (!ts3.findChildOfKind(decl, 20, file)) {
                return;
              }
            }
            var effectiveTypeAnnotation = ts3.getEffectiveReturnTypeNode(decl);
            if (effectiveTypeAnnotation || !decl.body) {
              return;
            }
            var signature = checker.getSignatureFromDeclaration(decl);
            if (!signature) {
              return;
            }
            var returnType = checker.getReturnTypeOfSignature(signature);
            if (isModuleReferenceType(returnType)) {
              return;
            }
            var typeDisplayString = printTypeInSingleLine(returnType);
            if (!typeDisplayString) {
              return;
            }
            addTypeHints(typeDisplayString, getTypeAnnotationPosition(decl));
          }
          function getTypeAnnotationPosition(decl) {
            var closeParenToken = ts3.findChildOfKind(decl, 21, file);
            if (closeParenToken) {
              return closeParenToken.end;
            }
            return decl.parameters.end;
          }
          function visitFunctionLikeForParameterType(node) {
            var signature = checker.getSignatureFromDeclaration(node);
            if (!signature) {
              return;
            }
            for (var i = 0; i < node.parameters.length && i < signature.parameters.length; ++i) {
              var param = node.parameters[i];
              var effectiveTypeAnnotation = ts3.getEffectiveTypeAnnotationNode(param);
              if (effectiveTypeAnnotation) {
                continue;
              }
              var typeDisplayString = getParameterDeclarationTypeDisplayString(signature.parameters[i]);
              if (!typeDisplayString) {
                continue;
              }
              addTypeHints(typeDisplayString, param.questionToken ? param.questionToken.end : param.name.end);
            }
          }
          function getParameterDeclarationTypeDisplayString(symbol) {
            var valueDeclaration = symbol.valueDeclaration;
            if (!valueDeclaration || !ts3.isParameter(valueDeclaration)) {
              return void 0;
            }
            var signatureParamType = checker.getTypeOfSymbolAtLocation(symbol, valueDeclaration);
            if (isModuleReferenceType(signatureParamType)) {
              return void 0;
            }
            return printTypeInSingleLine(signatureParamType);
          }
          function truncation(text, maxLength) {
            if (text.length > maxLength) {
              return text.substr(0, maxLength - "...".length) + "...";
            }
            return text;
          }
          function printTypeInSingleLine(type2) {
            var flags = 70221824 | 1048576 | 16384;
            var options = { removeComments: true };
            var printer2 = ts3.createPrinter(options);
            return ts3.usingSingleLineStringWriter(function(writer) {
              var typeNode = checker.typeToTypeNode(type2, void 0, flags, writer);
              ts3.Debug.assertIsDefined(typeNode, "should always get typenode");
              printer2.writeNode(4, typeNode, file, writer);
            });
          }
          function isUndefined(name) {
            return name === "undefined";
          }
        }
        InlayHints2.provideInlayHints = provideInlayHints;
      })(InlayHints = ts3.InlayHints || (ts3.InlayHints = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var base64UrlRegExp = /^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+\/=]+)$)?/;
      function getSourceMapper(host) {
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var currentDirectory = host.getCurrentDirectory();
        var sourceFileLike = new ts3.Map();
        var documentPositionMappers = new ts3.Map();
        return { tryGetSourcePosition, tryGetGeneratedPosition, toLineColumnOffset, clearCache };
        function toPath(fileName2) {
          return ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
        }
        function getDocumentPositionMapper2(generatedFileName, sourceFileName) {
          var path2 = toPath(generatedFileName);
          var value = documentPositionMappers.get(path2);
          if (value)
            return value;
          var mapper;
          if (host.getDocumentPositionMapper) {
            mapper = host.getDocumentPositionMapper(generatedFileName, sourceFileName);
          } else if (host.readFile) {
            var file = getSourceFileLike(generatedFileName);
            mapper = file && ts3.getDocumentPositionMapper({ getSourceFileLike, getCanonicalFileName, log: function(s) {
              return host.log(s);
            } }, generatedFileName, ts3.getLineInfo(file.text, ts3.getLineStarts(file)), function(f) {
              return !host.fileExists || host.fileExists(f) ? host.readFile(f) : void 0;
            });
          }
          documentPositionMappers.set(path2, mapper || ts3.identitySourceMapConsumer);
          return mapper || ts3.identitySourceMapConsumer;
        }
        function tryGetSourcePosition(info) {
          if (!ts3.isDeclarationFileName(info.fileName))
            return void 0;
          var file = getSourceFile(info.fileName);
          if (!file)
            return void 0;
          var newLoc = getDocumentPositionMapper2(info.fileName).getSourcePosition(info);
          return !newLoc || newLoc === info ? void 0 : tryGetSourcePosition(newLoc) || newLoc;
        }
        function tryGetGeneratedPosition(info) {
          if (ts3.isDeclarationFileName(info.fileName))
            return void 0;
          var sourceFile = getSourceFile(info.fileName);
          if (!sourceFile)
            return void 0;
          var program2 = host.getProgram();
          if (program2.isSourceOfProjectReferenceRedirect(sourceFile.fileName)) {
            return void 0;
          }
          var options = program2.getCompilerOptions();
          var outPath = ts3.outFile(options);
          var declarationPath = outPath ? ts3.removeFileExtension(outPath) + ".d.ts" : ts3.getDeclarationEmitOutputFilePathWorker(info.fileName, program2.getCompilerOptions(), currentDirectory, program2.getCommonSourceDirectory(), getCanonicalFileName);
          if (declarationPath === void 0)
            return void 0;
          var newLoc = getDocumentPositionMapper2(declarationPath, info.fileName).getGeneratedPosition(info);
          return newLoc === info ? void 0 : newLoc;
        }
        function getSourceFile(fileName2) {
          var program2 = host.getProgram();
          if (!program2)
            return void 0;
          var path2 = toPath(fileName2);
          var file = program2.getSourceFileByPath(path2);
          return file && file.resolvedPath === path2 ? file : void 0;
        }
        function getOrCreateSourceFileLike(fileName2) {
          var path2 = toPath(fileName2);
          var fileFromCache = sourceFileLike.get(path2);
          if (fileFromCache !== void 0)
            return fileFromCache ? fileFromCache : void 0;
          if (!host.readFile || host.fileExists && !host.fileExists(path2)) {
            sourceFileLike.set(path2, false);
            return void 0;
          }
          var text = host.readFile(path2);
          var file = text ? createSourceFileLike(text) : false;
          sourceFileLike.set(path2, file);
          return file ? file : void 0;
        }
        function getSourceFileLike(fileName2) {
          return !host.getSourceFileLike ? getSourceFile(fileName2) || getOrCreateSourceFileLike(fileName2) : host.getSourceFileLike(fileName2);
        }
        function toLineColumnOffset(fileName2, position) {
          var file = getSourceFileLike(fileName2);
          return file.getLineAndCharacterOfPosition(position);
        }
        function clearCache() {
          sourceFileLike.clear();
          documentPositionMappers.clear();
        }
      }
      ts3.getSourceMapper = getSourceMapper;
      function getDocumentPositionMapper(host, generatedFileName, generatedFileLineInfo, readMapFile) {
        var mapFileName = ts3.tryGetSourceMappingURL(generatedFileLineInfo);
        if (mapFileName) {
          var match = base64UrlRegExp.exec(mapFileName);
          if (match) {
            if (match[1]) {
              var base64Object = match[1];
              return convertDocumentToSourceMapper(host, ts3.base64decode(ts3.sys, base64Object), generatedFileName);
            }
            mapFileName = void 0;
          }
        }
        var possibleMapLocations = [];
        if (mapFileName) {
          possibleMapLocations.push(mapFileName);
        }
        possibleMapLocations.push(generatedFileName + ".map");
        var originalMapFileName = mapFileName && ts3.getNormalizedAbsolutePath(mapFileName, ts3.getDirectoryPath(generatedFileName));
        for (var _i = 0, possibleMapLocations_1 = possibleMapLocations; _i < possibleMapLocations_1.length; _i++) {
          var location = possibleMapLocations_1[_i];
          var mapFileName_1 = ts3.getNormalizedAbsolutePath(location, ts3.getDirectoryPath(generatedFileName));
          var mapFileContents = readMapFile(mapFileName_1, originalMapFileName);
          if (ts3.isString(mapFileContents)) {
            return convertDocumentToSourceMapper(host, mapFileContents, mapFileName_1);
          }
          if (mapFileContents !== void 0) {
            return mapFileContents || void 0;
          }
        }
        return void 0;
      }
      ts3.getDocumentPositionMapper = getDocumentPositionMapper;
      function convertDocumentToSourceMapper(host, contents, mapFileName) {
        var map2 = ts3.tryParseRawSourceMap(contents);
        if (!map2 || !map2.sources || !map2.file || !map2.mappings) {
          return void 0;
        }
        if (map2.sourcesContent && map2.sourcesContent.some(ts3.isString))
          return void 0;
        return ts3.createDocumentPositionMapper(host, map2, mapFileName);
      }
      function createSourceFileLike(text, lineMap) {
        return {
          text,
          lineMap,
          getLineAndCharacterOfPosition: function(pos) {
            return ts3.computeLineAndCharacterOfPosition(ts3.getLineStarts(this), pos);
          }
        };
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var visitedNestedConvertibleFunctions = new ts3.Map();
      function computeSuggestionDiagnostics(sourceFile, program2, cancellationToken) {
        program2.getSemanticDiagnostics(sourceFile, cancellationToken);
        var diags = [];
        var checker = program2.getTypeChecker();
        var isCommonJSFile = sourceFile.impliedNodeFormat === ts3.ModuleKind.CommonJS || ts3.fileExtensionIsOneOf(sourceFile.fileName, [".cts", ".cjs"]);
        if (!isCommonJSFile && sourceFile.commonJsModuleIndicator && (ts3.programContainsEsModules(program2) || ts3.compilerOptionsIndicateEsModules(program2.getCompilerOptions())) && containsTopLevelCommonjs(sourceFile)) {
          diags.push(ts3.createDiagnosticForNode(getErrorNodeFromCommonJsIndicator(sourceFile.commonJsModuleIndicator), ts3.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module));
        }
        var isJsFile = ts3.isSourceFileJS(sourceFile);
        visitedNestedConvertibleFunctions.clear();
        check(sourceFile);
        if (ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions())) {
          for (var _i = 0, _a = sourceFile.imports; _i < _a.length; _i++) {
            var moduleSpecifier = _a[_i];
            var importNode = ts3.importFromModuleSpecifier(moduleSpecifier);
            var name = importNameForConvertToDefaultImport(importNode);
            if (!name)
              continue;
            var module_1 = ts3.getResolvedModule(sourceFile, moduleSpecifier.text, ts3.getModeForUsageLocation(sourceFile, moduleSpecifier));
            var resolvedFile = module_1 && program2.getSourceFile(module_1.resolvedFileName);
            if (resolvedFile && resolvedFile.externalModuleIndicator && resolvedFile.externalModuleIndicator !== true && ts3.isExportAssignment(resolvedFile.externalModuleIndicator) && resolvedFile.externalModuleIndicator.isExportEquals) {
              diags.push(ts3.createDiagnosticForNode(name, ts3.Diagnostics.Import_may_be_converted_to_a_default_import));
            }
          }
        }
        ts3.addRange(diags, sourceFile.bindSuggestionDiagnostics);
        ts3.addRange(diags, program2.getSuggestionDiagnostics(sourceFile, cancellationToken));
        return diags.sort(function(d1, d2) {
          return d1.start - d2.start;
        });
        function check(node) {
          if (isJsFile) {
            if (canBeConvertedToClass(node, checker)) {
              diags.push(ts3.createDiagnosticForNode(ts3.isVariableDeclaration(node.parent) ? node.parent.name : node, ts3.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));
            }
          } else {
            if (ts3.isVariableStatement(node) && node.parent === sourceFile && node.declarationList.flags & 2 && node.declarationList.declarations.length === 1) {
              var init = node.declarationList.declarations[0].initializer;
              if (init && ts3.isRequireCall(init, true)) {
                diags.push(ts3.createDiagnosticForNode(init, ts3.Diagnostics.require_call_may_be_converted_to_an_import));
              }
            }
            if (ts3.codefix.parameterShouldGetTypeFromJSDoc(node)) {
              diags.push(ts3.createDiagnosticForNode(node.name || node, ts3.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types));
            }
          }
          if (canBeConvertedToAsync(node)) {
            addConvertToAsyncFunctionDiagnostics(node, checker, diags);
          }
          node.forEachChild(check);
        }
      }
      ts3.computeSuggestionDiagnostics = computeSuggestionDiagnostics;
      function containsTopLevelCommonjs(sourceFile) {
        return sourceFile.statements.some(function(statement) {
          switch (statement.kind) {
            case 237:
              return statement.declarationList.declarations.some(function(decl) {
                return !!decl.initializer && ts3.isRequireCall(propertyAccessLeftHandSide(decl.initializer), true);
              });
            case 238: {
              var expression = statement.expression;
              if (!ts3.isBinaryExpression(expression))
                return ts3.isRequireCall(expression, true);
              var kind = ts3.getAssignmentDeclarationKind(expression);
              return kind === 1 || kind === 2;
            }
            default:
              return false;
          }
        });
      }
      function propertyAccessLeftHandSide(node) {
        return ts3.isPropertyAccessExpression(node) ? propertyAccessLeftHandSide(node.expression) : node;
      }
      function importNameForConvertToDefaultImport(node) {
        switch (node.kind) {
          case 266:
            var importClause = node.importClause, moduleSpecifier = node.moduleSpecifier;
            return importClause && !importClause.name && importClause.namedBindings && importClause.namedBindings.kind === 268 && ts3.isStringLiteral(moduleSpecifier) ? importClause.namedBindings.name : void 0;
          case 265:
            return node.name;
          default:
            return void 0;
        }
      }
      function addConvertToAsyncFunctionDiagnostics(node, checker, diags) {
        if (isConvertibleFunction(node, checker) && !visitedNestedConvertibleFunctions.has(getKeyFromNode(node))) {
          diags.push(ts3.createDiagnosticForNode(!node.name && ts3.isVariableDeclaration(node.parent) && ts3.isIdentifier(node.parent.name) ? node.parent.name : node, ts3.Diagnostics.This_may_be_converted_to_an_async_function));
        }
      }
      function isConvertibleFunction(node, checker) {
        return !ts3.isAsyncFunction(node) && node.body && ts3.isBlock(node.body) && hasReturnStatementWithPromiseHandler(node.body, checker) && returnsPromise(node, checker);
      }
      function returnsPromise(node, checker) {
        var signature = checker.getSignatureFromDeclaration(node);
        var returnType = signature ? checker.getReturnTypeOfSignature(signature) : void 0;
        return !!returnType && !!checker.getPromisedTypeOfPromise(returnType);
      }
      ts3.returnsPromise = returnsPromise;
      function getErrorNodeFromCommonJsIndicator(commonJsModuleIndicator) {
        return ts3.isBinaryExpression(commonJsModuleIndicator) ? commonJsModuleIndicator.left : commonJsModuleIndicator;
      }
      function hasReturnStatementWithPromiseHandler(body, checker) {
        return !!ts3.forEachReturnStatement(body, function(statement) {
          return isReturnStatementWithFixablePromiseHandler(statement, checker);
        });
      }
      function isReturnStatementWithFixablePromiseHandler(node, checker) {
        return ts3.isReturnStatement(node) && !!node.expression && isFixablePromiseHandler(node.expression, checker);
      }
      ts3.isReturnStatementWithFixablePromiseHandler = isReturnStatementWithFixablePromiseHandler;
      function isFixablePromiseHandler(node, checker) {
        if (!isPromiseHandler(node) || !hasSupportedNumberOfArguments(node) || !node.arguments.every(function(arg) {
          return isFixablePromiseArgument(arg, checker);
        })) {
          return false;
        }
        var currentNode = node.expression.expression;
        while (isPromiseHandler(currentNode) || ts3.isPropertyAccessExpression(currentNode)) {
          if (ts3.isCallExpression(currentNode)) {
            if (!hasSupportedNumberOfArguments(currentNode) || !currentNode.arguments.every(function(arg) {
              return isFixablePromiseArgument(arg, checker);
            })) {
              return false;
            }
            currentNode = currentNode.expression.expression;
          } else {
            currentNode = currentNode.expression;
          }
        }
        return true;
      }
      ts3.isFixablePromiseHandler = isFixablePromiseHandler;
      function isPromiseHandler(node) {
        return ts3.isCallExpression(node) && (ts3.hasPropertyAccessExpressionWithName(node, "then") || ts3.hasPropertyAccessExpressionWithName(node, "catch") || ts3.hasPropertyAccessExpressionWithName(node, "finally"));
      }
      function hasSupportedNumberOfArguments(node) {
        var name = node.expression.name.text;
        var maxArguments = name === "then" ? 2 : name === "catch" ? 1 : name === "finally" ? 1 : 0;
        if (node.arguments.length > maxArguments)
          return false;
        if (node.arguments.length < maxArguments)
          return true;
        return maxArguments === 1 || ts3.some(node.arguments, function(arg) {
          return arg.kind === 104 || ts3.isIdentifier(arg) && arg.text === "undefined";
        });
      }
      function isFixablePromiseArgument(arg, checker) {
        switch (arg.kind) {
          case 256:
          case 213:
            var functionFlags = ts3.getFunctionFlags(arg);
            if (functionFlags & 1) {
              return false;
            }
          case 214:
            visitedNestedConvertibleFunctions.set(getKeyFromNode(arg), true);
          case 104:
            return true;
          case 79:
          case 206: {
            var symbol = checker.getSymbolAtLocation(arg);
            if (!symbol) {
              return false;
            }
            return checker.isUndefinedSymbol(symbol) || ts3.some(ts3.skipAlias(symbol, checker).declarations, function(d) {
              return ts3.isFunctionLike(d) || ts3.hasInitializer(d) && !!d.initializer && ts3.isFunctionLike(d.initializer);
            });
          }
          default:
            return false;
        }
      }
      function getKeyFromNode(exp) {
        return "".concat(exp.pos.toString(), ":").concat(exp.end.toString());
      }
      function canBeConvertedToClass(node, checker) {
        var _a, _b, _c, _d;
        if (node.kind === 213) {
          if (ts3.isVariableDeclaration(node.parent) && ((_a = node.symbol.members) === null || _a === void 0 ? void 0 : _a.size)) {
            return true;
          }
          var symbol = checker.getSymbolOfExpando(node, false);
          return !!(symbol && (((_b = symbol.exports) === null || _b === void 0 ? void 0 : _b.size) || ((_c = symbol.members) === null || _c === void 0 ? void 0 : _c.size)));
        }
        if (node.kind === 256) {
          return !!((_d = node.symbol.members) === null || _d === void 0 ? void 0 : _d.size);
        }
        return false;
      }
      function canBeConvertedToAsync(node) {
        switch (node.kind) {
          case 256:
          case 169:
          case 213:
          case 214:
            return true;
          default:
            return false;
        }
      }
      ts3.canBeConvertedToAsync = canBeConvertedToAsync;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SymbolDisplay;
      (function(SymbolDisplay2) {
        var symbolDisplayNodeBuilderFlags = 8192 | 70221824 | 16384;
        function getSymbolKind(typeChecker, symbol, location) {
          var result2 = getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location);
          if (result2 !== "") {
            return result2;
          }
          var flags = ts3.getCombinedLocalAndExportSymbolFlags(symbol);
          if (flags & 32) {
            return ts3.getDeclarationOfKind(symbol, 226) ? "local class" : "class";
          }
          if (flags & 384)
            return "enum";
          if (flags & 524288)
            return "type";
          if (flags & 64)
            return "interface";
          if (flags & 262144)
            return "type parameter";
          if (flags & 8)
            return "enum member";
          if (flags & 2097152)
            return "alias";
          if (flags & 1536)
            return "module";
          return result2;
        }
        SymbolDisplay2.getSymbolKind = getSymbolKind;
        function getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) {
          var roots = typeChecker.getRootSymbols(symbol);
          if (roots.length === 1 && ts3.first(roots).flags & 8192 && typeChecker.getTypeOfSymbolAtLocation(symbol, location).getNonNullableType().getCallSignatures().length !== 0) {
            return "method";
          }
          if (typeChecker.isUndefinedSymbol(symbol)) {
            return "var";
          }
          if (typeChecker.isArgumentsSymbol(symbol)) {
            return "local var";
          }
          if (location.kind === 108 && ts3.isExpression(location) || ts3.isThisInTypeQuery(location)) {
            return "parameter";
          }
          var flags = ts3.getCombinedLocalAndExportSymbolFlags(symbol);
          if (flags & 3) {
            if (ts3.isFirstDeclarationOfSymbolParameter(symbol)) {
              return "parameter";
            } else if (symbol.valueDeclaration && ts3.isVarConst(symbol.valueDeclaration)) {
              return "const";
            } else if (ts3.forEach(symbol.declarations, ts3.isLet)) {
              return "let";
            }
            return isLocalVariableOrFunction(symbol) ? "local var" : "var";
          }
          if (flags & 16)
            return isLocalVariableOrFunction(symbol) ? "local function" : "function";
          if (flags & 32768)
            return "getter";
          if (flags & 65536)
            return "setter";
          if (flags & 8192)
            return "method";
          if (flags & 16384)
            return "constructor";
          if (flags & 4) {
            if (flags & 33554432 && symbol.checkFlags & 6) {
              var unionPropertyKind = ts3.forEach(typeChecker.getRootSymbols(symbol), function(rootSymbol) {
                var rootSymbolFlags = rootSymbol.getFlags();
                if (rootSymbolFlags & (98308 | 3)) {
                  return "property";
                }
              });
              if (!unionPropertyKind) {
                var typeOfUnionProperty = typeChecker.getTypeOfSymbolAtLocation(symbol, location);
                if (typeOfUnionProperty.getCallSignatures().length) {
                  return "method";
                }
                return "property";
              }
              return unionPropertyKind;
            }
            return "property";
          }
          return "";
        }
        function getNormalizedSymbolModifiers(symbol) {
          if (symbol.declarations && symbol.declarations.length) {
            var _a = symbol.declarations, declaration = _a[0], declarations = _a.slice(1);
            var excludeFlags = ts3.length(declarations) && ts3.isDeprecatedDeclaration(declaration) && ts3.some(declarations, function(d) {
              return !ts3.isDeprecatedDeclaration(d);
            }) ? 8192 : 0;
            var modifiers = ts3.getNodeModifiers(declaration, excludeFlags);
            if (modifiers) {
              return modifiers.split(",");
            }
          }
          return [];
        }
        function getSymbolModifiers(typeChecker, symbol) {
          if (!symbol) {
            return "";
          }
          var modifiers = new ts3.Set(getNormalizedSymbolModifiers(symbol));
          if (symbol.flags & 2097152) {
            var resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
            if (resolvedSymbol !== symbol) {
              ts3.forEach(getNormalizedSymbolModifiers(resolvedSymbol), function(modifier) {
                modifiers.add(modifier);
              });
            }
          }
          if (symbol.flags & 16777216) {
            modifiers.add("optional");
          }
          return modifiers.size > 0 ? ts3.arrayFrom(modifiers.values()).join(",") : "";
        }
        SymbolDisplay2.getSymbolModifiers = getSymbolModifiers;
        function getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, symbol, sourceFile, enclosingDeclaration, location, semanticMeaning, alias) {
          var _a;
          if (semanticMeaning === void 0) {
            semanticMeaning = ts3.getMeaningFromLocation(location);
          }
          var displayParts = [];
          var documentation = [];
          var tags = [];
          var symbolFlags = ts3.getCombinedLocalAndExportSymbolFlags(symbol);
          var symbolKind = semanticMeaning & 1 ? getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) : "";
          var hasAddedSymbolInfo = false;
          var isThisExpression = location.kind === 108 && ts3.isInExpressionContext(location) || ts3.isThisInTypeQuery(location);
          var type2;
          var printer2;
          var documentationFromAlias;
          var tagsFromAlias;
          var hasMultipleSignatures = false;
          if (location.kind === 108 && !isThisExpression) {
            return { displayParts: [ts3.keywordPart(108)], documentation: [], symbolKind: "primitive type", tags: void 0 };
          }
          if (symbolKind !== "" || symbolFlags & 32 || symbolFlags & 2097152) {
            if (symbolKind === "getter" || symbolKind === "setter") {
              var declaration = ts3.find(symbol.declarations, function(declaration2) {
                return declaration2.name === location;
              });
              if (declaration) {
                switch (declaration.kind) {
                  case 172:
                    symbolKind = "getter";
                    break;
                  case 173:
                    symbolKind = "setter";
                    break;
                  default:
                    ts3.Debug.assertNever(declaration);
                }
              } else {
                symbolKind = "property";
              }
            }
            var signature = void 0;
            type2 = isThisExpression ? typeChecker.getTypeAtLocation(location) : typeChecker.getTypeOfSymbolAtLocation(symbol, location);
            if (location.parent && location.parent.kind === 206) {
              var right = location.parent.name;
              if (right === location || right && right.getFullWidth() === 0) {
                location = location.parent;
              }
            }
            var callExpressionLike = void 0;
            if (ts3.isCallOrNewExpression(location)) {
              callExpressionLike = location;
            } else if (ts3.isCallExpressionTarget(location) || ts3.isNewExpressionTarget(location)) {
              callExpressionLike = location.parent;
            } else if (location.parent && (ts3.isJsxOpeningLikeElement(location.parent) || ts3.isTaggedTemplateExpression(location.parent)) && ts3.isFunctionLike(symbol.valueDeclaration)) {
              callExpressionLike = location.parent;
            }
            if (callExpressionLike) {
              signature = typeChecker.getResolvedSignature(callExpressionLike);
              var useConstructSignatures = callExpressionLike.kind === 209 || ts3.isCallExpression(callExpressionLike) && callExpressionLike.expression.kind === 106;
              var allSignatures = useConstructSignatures ? type2.getConstructSignatures() : type2.getCallSignatures();
              if (signature && !ts3.contains(allSignatures, signature.target) && !ts3.contains(allSignatures, signature)) {
                signature = allSignatures.length ? allSignatures[0] : void 0;
              }
              if (signature) {
                if (useConstructSignatures && symbolFlags & 32) {
                  symbolKind = "constructor";
                  addPrefixForAnyFunctionOrVar(type2.symbol, symbolKind);
                } else if (symbolFlags & 2097152) {
                  symbolKind = "alias";
                  pushSymbolKind(symbolKind);
                  displayParts.push(ts3.spacePart());
                  if (useConstructSignatures) {
                    if (signature.flags & 4) {
                      displayParts.push(ts3.keywordPart(126));
                      displayParts.push(ts3.spacePart());
                    }
                    displayParts.push(ts3.keywordPart(103));
                    displayParts.push(ts3.spacePart());
                  }
                  addFullSymbolName(symbol);
                } else {
                  addPrefixForAnyFunctionOrVar(symbol, symbolKind);
                }
                switch (symbolKind) {
                  case "JSX attribute":
                  case "property":
                  case "var":
                  case "const":
                  case "let":
                  case "parameter":
                  case "local var":
                    displayParts.push(ts3.punctuationPart(58));
                    displayParts.push(ts3.spacePart());
                    if (!(ts3.getObjectFlags(type2) & 16) && type2.symbol) {
                      ts3.addRange(displayParts, ts3.symbolToDisplayParts(typeChecker, type2.symbol, enclosingDeclaration, void 0, 4 | 1));
                      displayParts.push(ts3.lineBreakPart());
                    }
                    if (useConstructSignatures) {
                      if (signature.flags & 4) {
                        displayParts.push(ts3.keywordPart(126));
                        displayParts.push(ts3.spacePart());
                      }
                      displayParts.push(ts3.keywordPart(103));
                      displayParts.push(ts3.spacePart());
                    }
                    addSignatureDisplayParts(signature, allSignatures, 262144);
                    break;
                  default:
                    addSignatureDisplayParts(signature, allSignatures);
                }
                hasAddedSymbolInfo = true;
                hasMultipleSignatures = allSignatures.length > 1;
              }
            } else if (ts3.isNameOfFunctionDeclaration(location) && !(symbolFlags & 98304) || location.kind === 134 && location.parent.kind === 171) {
              var functionDeclaration_1 = location.parent;
              var locationIsSymbolDeclaration = symbol.declarations && ts3.find(symbol.declarations, function(declaration2) {
                return declaration2 === (location.kind === 134 ? functionDeclaration_1.parent : functionDeclaration_1);
              });
              if (locationIsSymbolDeclaration) {
                var allSignatures = functionDeclaration_1.kind === 171 ? type2.getNonNullableType().getConstructSignatures() : type2.getNonNullableType().getCallSignatures();
                if (!typeChecker.isImplementationOfOverload(functionDeclaration_1)) {
                  signature = typeChecker.getSignatureFromDeclaration(functionDeclaration_1);
                } else {
                  signature = allSignatures[0];
                }
                if (functionDeclaration_1.kind === 171) {
                  symbolKind = "constructor";
                  addPrefixForAnyFunctionOrVar(type2.symbol, symbolKind);
                } else {
                  addPrefixForAnyFunctionOrVar(functionDeclaration_1.kind === 174 && !(type2.symbol.flags & 2048 || type2.symbol.flags & 4096) ? type2.symbol : symbol, symbolKind);
                }
                if (signature) {
                  addSignatureDisplayParts(signature, allSignatures);
                }
                hasAddedSymbolInfo = true;
                hasMultipleSignatures = allSignatures.length > 1;
              }
            }
          }
          if (symbolFlags & 32 && !hasAddedSymbolInfo && !isThisExpression) {
            addAliasPrefixIfNecessary();
            if (ts3.getDeclarationOfKind(symbol, 226)) {
              pushSymbolKind("local class");
            } else {
              displayParts.push(ts3.keywordPart(84));
            }
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
          }
          if (symbolFlags & 64 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts3.keywordPart(118));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
          }
          if (symbolFlags & 524288 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts3.keywordPart(152));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
            displayParts.push(ts3.spacePart());
            displayParts.push(ts3.operatorPart(63));
            displayParts.push(ts3.spacePart());
            ts3.addRange(displayParts, ts3.typeToDisplayParts(typeChecker, ts3.isConstTypeReference(location.parent) ? typeChecker.getTypeAtLocation(location.parent) : typeChecker.getDeclaredTypeOfSymbol(symbol), enclosingDeclaration, 8388608));
          }
          if (symbolFlags & 384) {
            prefixNextMeaning();
            if (ts3.some(symbol.declarations, function(d) {
              return ts3.isEnumDeclaration(d) && ts3.isEnumConst(d);
            })) {
              displayParts.push(ts3.keywordPart(85));
              displayParts.push(ts3.spacePart());
            }
            displayParts.push(ts3.keywordPart(92));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
          }
          if (symbolFlags & 1536 && !isThisExpression) {
            prefixNextMeaning();
            var declaration = ts3.getDeclarationOfKind(symbol, 261);
            var isNamespace = declaration && declaration.name && declaration.name.kind === 79;
            displayParts.push(ts3.keywordPart(isNamespace ? 142 : 141));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
          }
          if (symbolFlags & 262144 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts3.punctuationPart(20));
            displayParts.push(ts3.textPart("type parameter"));
            displayParts.push(ts3.punctuationPart(21));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            if (symbol.parent) {
              addInPrefix();
              addFullSymbolName(symbol.parent, enclosingDeclaration);
              writeTypeParametersOfSymbol(symbol.parent, enclosingDeclaration);
            } else {
              var decl = ts3.getDeclarationOfKind(symbol, 163);
              if (decl === void 0)
                return ts3.Debug.fail();
              var declaration = decl.parent;
              if (declaration) {
                if (ts3.isFunctionLikeKind(declaration.kind)) {
                  addInPrefix();
                  var signature = typeChecker.getSignatureFromDeclaration(declaration);
                  if (declaration.kind === 175) {
                    displayParts.push(ts3.keywordPart(103));
                    displayParts.push(ts3.spacePart());
                  } else if (declaration.kind !== 174 && declaration.name) {
                    addFullSymbolName(declaration.symbol);
                  }
                  ts3.addRange(displayParts, ts3.signatureToDisplayParts(typeChecker, signature, sourceFile, 32));
                } else if (declaration.kind === 259) {
                  addInPrefix();
                  displayParts.push(ts3.keywordPart(152));
                  displayParts.push(ts3.spacePart());
                  addFullSymbolName(declaration.symbol);
                  writeTypeParametersOfSymbol(declaration.symbol, sourceFile);
                }
              }
            }
          }
          if (symbolFlags & 8) {
            symbolKind = "enum member";
            addPrefixForAnyFunctionOrVar(symbol, "enum member");
            var declaration = (_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a[0];
            if ((declaration === null || declaration === void 0 ? void 0 : declaration.kind) === 299) {
              var constantValue = typeChecker.getConstantValue(declaration);
              if (constantValue !== void 0) {
                displayParts.push(ts3.spacePart());
                displayParts.push(ts3.operatorPart(63));
                displayParts.push(ts3.spacePart());
                displayParts.push(ts3.displayPart(ts3.getTextOfConstantValue(constantValue), typeof constantValue === "number" ? ts3.SymbolDisplayPartKind.numericLiteral : ts3.SymbolDisplayPartKind.stringLiteral));
              }
            }
          }
          if (symbol.flags & 2097152) {
            prefixNextMeaning();
            if (!hasAddedSymbolInfo) {
              var resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
              if (resolvedSymbol !== symbol && resolvedSymbol.declarations && resolvedSymbol.declarations.length > 0) {
                var resolvedNode = resolvedSymbol.declarations[0];
                var declarationName = ts3.getNameOfDeclaration(resolvedNode);
                if (declarationName) {
                  var isExternalModuleDeclaration = ts3.isModuleWithStringLiteralName(resolvedNode) && ts3.hasSyntacticModifier(resolvedNode, 2);
                  var shouldUseAliasName = symbol.name !== "default" && !isExternalModuleDeclaration;
                  var resolvedInfo = getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, resolvedSymbol, ts3.getSourceFileOfNode(resolvedNode), resolvedNode, declarationName, semanticMeaning, shouldUseAliasName ? symbol : resolvedSymbol);
                  displayParts.push.apply(displayParts, resolvedInfo.displayParts);
                  displayParts.push(ts3.lineBreakPart());
                  documentationFromAlias = resolvedInfo.documentation;
                  tagsFromAlias = resolvedInfo.tags;
                } else {
                  documentationFromAlias = resolvedSymbol.getContextualDocumentationComment(resolvedNode, typeChecker);
                  tagsFromAlias = resolvedSymbol.getJsDocTags(typeChecker);
                }
              }
            }
            if (symbol.declarations) {
              switch (symbol.declarations[0].kind) {
                case 264:
                  displayParts.push(ts3.keywordPart(93));
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.keywordPart(142));
                  break;
                case 271:
                  displayParts.push(ts3.keywordPart(93));
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.keywordPart(symbol.declarations[0].isExportEquals ? 63 : 88));
                  break;
                case 275:
                  displayParts.push(ts3.keywordPart(93));
                  break;
                default:
                  displayParts.push(ts3.keywordPart(100));
              }
            }
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            ts3.forEach(symbol.declarations, function(declaration2) {
              if (declaration2.kind === 265) {
                var importEqualsDeclaration = declaration2;
                if (ts3.isExternalModuleImportEqualsDeclaration(importEqualsDeclaration)) {
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.operatorPart(63));
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.keywordPart(146));
                  displayParts.push(ts3.punctuationPart(20));
                  displayParts.push(ts3.displayPart(ts3.getTextOfNode(ts3.getExternalModuleImportEqualsDeclarationExpression(importEqualsDeclaration)), ts3.SymbolDisplayPartKind.stringLiteral));
                  displayParts.push(ts3.punctuationPart(21));
                } else {
                  var internalAliasSymbol = typeChecker.getSymbolAtLocation(importEqualsDeclaration.moduleReference);
                  if (internalAliasSymbol) {
                    displayParts.push(ts3.spacePart());
                    displayParts.push(ts3.operatorPart(63));
                    displayParts.push(ts3.spacePart());
                    addFullSymbolName(internalAliasSymbol, enclosingDeclaration);
                  }
                }
                return true;
              }
            });
          }
          if (!hasAddedSymbolInfo) {
            if (symbolKind !== "") {
              if (type2) {
                if (isThisExpression) {
                  prefixNextMeaning();
                  displayParts.push(ts3.keywordPart(108));
                } else {
                  addPrefixForAnyFunctionOrVar(symbol, symbolKind);
                }
                if (symbolKind === "property" || symbolKind === "getter" || symbolKind === "setter" || symbolKind === "JSX attribute" || symbolFlags & 3 || symbolKind === "local var" || isThisExpression) {
                  displayParts.push(ts3.punctuationPart(58));
                  displayParts.push(ts3.spacePart());
                  if (type2.symbol && type2.symbol.flags & 262144) {
                    var typeParameterParts = ts3.mapToDisplayParts(function(writer) {
                      var param = typeChecker.typeParameterToDeclaration(type2, enclosingDeclaration, symbolDisplayNodeBuilderFlags);
                      getPrinter().writeNode(4, param, ts3.getSourceFileOfNode(ts3.getParseTreeNode(enclosingDeclaration)), writer);
                    });
                    ts3.addRange(displayParts, typeParameterParts);
                  } else {
                    ts3.addRange(displayParts, ts3.typeToDisplayParts(typeChecker, type2, enclosingDeclaration));
                  }
                  if (symbol.target && symbol.target.tupleLabelDeclaration) {
                    var labelDecl = symbol.target.tupleLabelDeclaration;
                    ts3.Debug.assertNode(labelDecl.name, ts3.isIdentifier);
                    displayParts.push(ts3.spacePart());
                    displayParts.push(ts3.punctuationPart(20));
                    displayParts.push(ts3.textPart(ts3.idText(labelDecl.name)));
                    displayParts.push(ts3.punctuationPart(21));
                  }
                } else if (symbolFlags & 16 || symbolFlags & 8192 || symbolFlags & 16384 || symbolFlags & 131072 || symbolFlags & 98304 || symbolKind === "method") {
                  var allSignatures = type2.getNonNullableType().getCallSignatures();
                  if (allSignatures.length) {
                    addSignatureDisplayParts(allSignatures[0], allSignatures);
                    hasMultipleSignatures = allSignatures.length > 1;
                  }
                }
              }
            } else {
              symbolKind = getSymbolKind(typeChecker, symbol, location);
            }
          }
          if (documentation.length === 0 && !hasMultipleSignatures) {
            documentation = symbol.getContextualDocumentationComment(enclosingDeclaration, typeChecker);
          }
          if (documentation.length === 0 && symbolFlags & 4) {
            if (symbol.parent && symbol.declarations && ts3.forEach(symbol.parent.declarations, function(declaration2) {
              return declaration2.kind === 305;
            })) {
              for (var _i = 0, _b = symbol.declarations; _i < _b.length; _i++) {
                var declaration = _b[_i];
                if (!declaration.parent || declaration.parent.kind !== 221) {
                  continue;
                }
                var rhsSymbol = typeChecker.getSymbolAtLocation(declaration.parent.right);
                if (!rhsSymbol) {
                  continue;
                }
                documentation = rhsSymbol.getDocumentationComment(typeChecker);
                tags = rhsSymbol.getJsDocTags(typeChecker);
                if (documentation.length > 0) {
                  break;
                }
              }
            }
          }
          if (documentation.length === 0 && ts3.isIdentifier(location) && symbol.valueDeclaration && ts3.isBindingElement(symbol.valueDeclaration)) {
            var declaration = symbol.valueDeclaration;
            var parent = declaration.parent;
            if (ts3.isIdentifier(declaration.name) && ts3.isObjectBindingPattern(parent)) {
              var name_4 = ts3.getTextOfIdentifierOrLiteral(declaration.name);
              var objectType = typeChecker.getTypeAtLocation(parent);
              documentation = ts3.firstDefined(objectType.isUnion() ? objectType.types : [objectType], function(t) {
                var prop = t.getProperty(name_4);
                return prop ? prop.getDocumentationComment(typeChecker) : void 0;
              }) || ts3.emptyArray;
            }
          }
          if (tags.length === 0 && !hasMultipleSignatures) {
            tags = symbol.getContextualJsDocTags(enclosingDeclaration, typeChecker);
          }
          if (documentation.length === 0 && documentationFromAlias) {
            documentation = documentationFromAlias;
          }
          if (tags.length === 0 && tagsFromAlias) {
            tags = tagsFromAlias;
          }
          return { displayParts, documentation, symbolKind, tags: tags.length === 0 ? void 0 : tags };
          function getPrinter() {
            if (!printer2) {
              printer2 = ts3.createPrinter({ removeComments: true });
            }
            return printer2;
          }
          function prefixNextMeaning() {
            if (displayParts.length) {
              displayParts.push(ts3.lineBreakPart());
            }
            addAliasPrefixIfNecessary();
          }
          function addAliasPrefixIfNecessary() {
            if (alias) {
              pushSymbolKind("alias");
              displayParts.push(ts3.spacePart());
            }
          }
          function addInPrefix() {
            displayParts.push(ts3.spacePart());
            displayParts.push(ts3.keywordPart(101));
            displayParts.push(ts3.spacePart());
          }
          function addFullSymbolName(symbolToDisplay, enclosingDeclaration2) {
            if (alias && symbolToDisplay === symbol) {
              symbolToDisplay = alias;
            }
            var fullSymbolDisplayParts = ts3.symbolToDisplayParts(typeChecker, symbolToDisplay, enclosingDeclaration2 || sourceFile, void 0, 1 | 2 | 4);
            ts3.addRange(displayParts, fullSymbolDisplayParts);
            if (symbol.flags & 16777216) {
              displayParts.push(ts3.punctuationPart(57));
            }
          }
          function addPrefixForAnyFunctionOrVar(symbol2, symbolKind2) {
            prefixNextMeaning();
            if (symbolKind2) {
              pushSymbolKind(symbolKind2);
              if (symbol2 && !ts3.some(symbol2.declarations, function(d) {
                return ts3.isArrowFunction(d) || (ts3.isFunctionExpression(d) || ts3.isClassExpression(d)) && !d.name;
              })) {
                displayParts.push(ts3.spacePart());
                addFullSymbolName(symbol2);
              }
            }
          }
          function pushSymbolKind(symbolKind2) {
            switch (symbolKind2) {
              case "var":
              case "function":
              case "let":
              case "const":
              case "constructor":
                displayParts.push(ts3.textOrKeywordPart(symbolKind2));
                return;
              default:
                displayParts.push(ts3.punctuationPart(20));
                displayParts.push(ts3.textOrKeywordPart(symbolKind2));
                displayParts.push(ts3.punctuationPart(21));
                return;
            }
          }
          function addSignatureDisplayParts(signature2, allSignatures2, flags) {
            if (flags === void 0) {
              flags = 0;
            }
            ts3.addRange(displayParts, ts3.signatureToDisplayParts(typeChecker, signature2, enclosingDeclaration, flags | 32));
            if (allSignatures2.length > 1) {
              displayParts.push(ts3.spacePart());
              displayParts.push(ts3.punctuationPart(20));
              displayParts.push(ts3.operatorPart(39));
              displayParts.push(ts3.displayPart((allSignatures2.length - 1).toString(), ts3.SymbolDisplayPartKind.numericLiteral));
              displayParts.push(ts3.spacePart());
              displayParts.push(ts3.textPart(allSignatures2.length === 2 ? "overload" : "overloads"));
              displayParts.push(ts3.punctuationPart(21));
            }
            documentation = signature2.getDocumentationComment(typeChecker);
            tags = signature2.getJsDocTags();
            if (allSignatures2.length > 1 && documentation.length === 0 && tags.length === 0) {
              documentation = allSignatures2[0].getDocumentationComment(typeChecker);
              tags = allSignatures2[0].getJsDocTags();
            }
          }
          function writeTypeParametersOfSymbol(symbol2, enclosingDeclaration2) {
            var typeParameterParts2 = ts3.mapToDisplayParts(function(writer) {
              var params = typeChecker.symbolToTypeParameterDeclarations(symbol2, enclosingDeclaration2, symbolDisplayNodeBuilderFlags);
              getPrinter().writeList(53776, params, ts3.getSourceFileOfNode(ts3.getParseTreeNode(enclosingDeclaration2)), writer);
            });
            ts3.addRange(displayParts, typeParameterParts2);
          }
        }
        SymbolDisplay2.getSymbolDisplayPartsDocumentationAndSymbolKind = getSymbolDisplayPartsDocumentationAndSymbolKind;
        function isLocalVariableOrFunction(symbol) {
          if (symbol.parent) {
            return false;
          }
          return ts3.forEach(symbol.declarations, function(declaration) {
            if (declaration.kind === 213) {
              return true;
            }
            if (declaration.kind !== 254 && declaration.kind !== 256) {
              return false;
            }
            for (var parent = declaration.parent; !ts3.isFunctionBlock(parent); parent = parent.parent) {
              if (parent.kind === 305 || parent.kind === 262) {
                return false;
              }
            }
            return true;
          });
        }
      })(SymbolDisplay = ts3.SymbolDisplay || (ts3.SymbolDisplay = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transpileModule(input, transpileOptions) {
        var diagnostics = [];
        var options = transpileOptions.compilerOptions ? fixupCompilerOptions(transpileOptions.compilerOptions, diagnostics) : {};
        var defaultOptions = ts3.getDefaultCompilerOptions();
        for (var key in defaultOptions) {
          if (ts3.hasProperty(defaultOptions, key) && options[key] === void 0) {
            options[key] = defaultOptions[key];
          }
        }
        for (var _i = 0, transpileOptionValueCompilerOptions_1 = ts3.transpileOptionValueCompilerOptions; _i < transpileOptionValueCompilerOptions_1.length; _i++) {
          var option = transpileOptionValueCompilerOptions_1[_i];
          options[option.name] = option.transpileOptionValue;
        }
        options.suppressOutputPathCheck = true;
        options.allowNonTsExtensions = true;
        var newLine = ts3.getNewLineCharacter(options);
        var compilerHost = {
          getSourceFile: function(fileName2) {
            return fileName2 === ts3.normalizePath(inputFileName) ? sourceFile : void 0;
          },
          writeFile: function(name, text) {
            if (ts3.fileExtensionIs(name, ".map")) {
              ts3.Debug.assertEqual(sourceMapText, void 0, "Unexpected multiple source map outputs, file:", name);
              sourceMapText = text;
            } else {
              ts3.Debug.assertEqual(outputText, void 0, "Unexpected multiple outputs, file:", name);
              outputText = text;
            }
          },
          getDefaultLibFileName: function() {
            return "lib.d.ts";
          },
          useCaseSensitiveFileNames: function() {
            return false;
          },
          getCanonicalFileName: function(fileName2) {
            return fileName2;
          },
          getCurrentDirectory: function() {
            return "";
          },
          getNewLine: function() {
            return newLine;
          },
          fileExists: function(fileName2) {
            return fileName2 === inputFileName;
          },
          readFile: function() {
            return "";
          },
          directoryExists: function() {
            return true;
          },
          getDirectories: function() {
            return [];
          }
        };
        var inputFileName = transpileOptions.fileName || (transpileOptions.compilerOptions && transpileOptions.compilerOptions.jsx ? "module.tsx" : "module.ts");
        var sourceFile = ts3.createSourceFile(inputFileName, input, {
          languageVersion: ts3.getEmitScriptTarget(options),
          impliedNodeFormat: ts3.getImpliedNodeFormatForFile(ts3.toPath(inputFileName, "", compilerHost.getCanonicalFileName), void 0, compilerHost, options),
          setExternalModuleIndicator: ts3.getSetExternalModuleIndicator(options)
        });
        if (transpileOptions.moduleName) {
          sourceFile.moduleName = transpileOptions.moduleName;
        }
        if (transpileOptions.renamedDependencies) {
          sourceFile.renamedDependencies = new ts3.Map(ts3.getEntries(transpileOptions.renamedDependencies));
        }
        var outputText;
        var sourceMapText;
        var program2 = ts3.createProgram([inputFileName], options, compilerHost);
        if (transpileOptions.reportDiagnostics) {
          ts3.addRange(diagnostics, program2.getSyntacticDiagnostics(sourceFile));
          ts3.addRange(diagnostics, program2.getOptionsDiagnostics());
        }
        program2.emit(void 0, void 0, void 0, void 0, transpileOptions.transformers);
        if (outputText === void 0)
          return ts3.Debug.fail("Output generation failed");
        return { outputText, diagnostics, sourceMapText };
      }
      ts3.transpileModule = transpileModule;
      function transpile(input, compilerOptions, fileName2, diagnostics, moduleName) {
        var output = transpileModule(input, { compilerOptions, fileName: fileName2, reportDiagnostics: !!diagnostics, moduleName });
        ts3.addRange(diagnostics, output.diagnostics);
        return output.outputText;
      }
      ts3.transpile = transpile;
      var commandLineOptionsStringToEnum;
      function fixupCompilerOptions(options, diagnostics) {
        commandLineOptionsStringToEnum = commandLineOptionsStringToEnum || ts3.filter(ts3.optionDeclarations, function(o) {
          return typeof o.type === "object" && !ts3.forEachEntry(o.type, function(v) {
            return typeof v !== "number";
          });
        });
        options = ts3.cloneCompilerOptions(options);
        var _loop_10 = function(opt2) {
          if (!ts3.hasProperty(options, opt2.name)) {
            return "continue";
          }
          var value = options[opt2.name];
          if (ts3.isString(value)) {
            options[opt2.name] = ts3.parseCustomTypeOption(opt2, value, diagnostics);
          } else {
            if (!ts3.forEachEntry(opt2.type, function(v) {
              return v === value;
            })) {
              diagnostics.push(ts3.createCompilerDiagnosticForInvalidCustomType(opt2));
            }
          }
        };
        for (var _i = 0, commandLineOptionsStringToEnum_1 = commandLineOptionsStringToEnum; _i < commandLineOptionsStringToEnum_1.length; _i++) {
          var opt = commandLineOptionsStringToEnum_1[_i];
          _loop_10(opt);
        }
        return options;
      }
      ts3.fixupCompilerOptions = fixupCompilerOptions;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        var FormattingRequestKind;
        (function(FormattingRequestKind2) {
          FormattingRequestKind2[FormattingRequestKind2["FormatDocument"] = 0] = "FormatDocument";
          FormattingRequestKind2[FormattingRequestKind2["FormatSelection"] = 1] = "FormatSelection";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnEnter"] = 2] = "FormatOnEnter";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnSemicolon"] = 3] = "FormatOnSemicolon";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnOpeningCurlyBrace"] = 4] = "FormatOnOpeningCurlyBrace";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnClosingCurlyBrace"] = 5] = "FormatOnClosingCurlyBrace";
        })(FormattingRequestKind = formatting2.FormattingRequestKind || (formatting2.FormattingRequestKind = {}));
        var FormattingContext = function() {
          function FormattingContext2(sourceFile, formattingRequestKind, options) {
            this.sourceFile = sourceFile;
            this.formattingRequestKind = formattingRequestKind;
            this.options = options;
          }
          FormattingContext2.prototype.updateContext = function(currentRange, currentTokenParent, nextRange, nextTokenParent, commonParent) {
            this.currentTokenSpan = ts3.Debug.checkDefined(currentRange);
            this.currentTokenParent = ts3.Debug.checkDefined(currentTokenParent);
            this.nextTokenSpan = ts3.Debug.checkDefined(nextRange);
            this.nextTokenParent = ts3.Debug.checkDefined(nextTokenParent);
            this.contextNode = ts3.Debug.checkDefined(commonParent);
            this.contextNodeAllOnSameLine = void 0;
            this.nextNodeAllOnSameLine = void 0;
            this.tokensAreOnSameLine = void 0;
            this.contextNodeBlockIsOnOneLine = void 0;
            this.nextNodeBlockIsOnOneLine = void 0;
          };
          FormattingContext2.prototype.ContextNodeAllOnSameLine = function() {
            if (this.contextNodeAllOnSameLine === void 0) {
              this.contextNodeAllOnSameLine = this.NodeIsOnOneLine(this.contextNode);
            }
            return this.contextNodeAllOnSameLine;
          };
          FormattingContext2.prototype.NextNodeAllOnSameLine = function() {
            if (this.nextNodeAllOnSameLine === void 0) {
              this.nextNodeAllOnSameLine = this.NodeIsOnOneLine(this.nextTokenParent);
            }
            return this.nextNodeAllOnSameLine;
          };
          FormattingContext2.prototype.TokensAreOnSameLine = function() {
            if (this.tokensAreOnSameLine === void 0) {
              var startLine = this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line;
              var endLine = this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;
              this.tokensAreOnSameLine = startLine === endLine;
            }
            return this.tokensAreOnSameLine;
          };
          FormattingContext2.prototype.ContextNodeBlockIsOnOneLine = function() {
            if (this.contextNodeBlockIsOnOneLine === void 0) {
              this.contextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.contextNode);
            }
            return this.contextNodeBlockIsOnOneLine;
          };
          FormattingContext2.prototype.NextNodeBlockIsOnOneLine = function() {
            if (this.nextNodeBlockIsOnOneLine === void 0) {
              this.nextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.nextTokenParent);
            }
            return this.nextNodeBlockIsOnOneLine;
          };
          FormattingContext2.prototype.NodeIsOnOneLine = function(node) {
            var startLine = this.sourceFile.getLineAndCharacterOfPosition(node.getStart(this.sourceFile)).line;
            var endLine = this.sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
            return startLine === endLine;
          };
          FormattingContext2.prototype.BlockIsOnOneLine = function(node) {
            var openBrace = ts3.findChildOfKind(node, 18, this.sourceFile);
            var closeBrace = ts3.findChildOfKind(node, 19, this.sourceFile);
            if (openBrace && closeBrace) {
              var startLine = this.sourceFile.getLineAndCharacterOfPosition(openBrace.getEnd()).line;
              var endLine = this.sourceFile.getLineAndCharacterOfPosition(closeBrace.getStart(this.sourceFile)).line;
              return startLine === endLine;
            }
            return false;
          };
          return FormattingContext2;
        }();
        formatting2.FormattingContext = FormattingContext;
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        var standardScanner = ts3.createScanner(99, false, 0);
        var jsxScanner = ts3.createScanner(99, false, 1);
        var ScanAction;
        (function(ScanAction2) {
          ScanAction2[ScanAction2["Scan"] = 0] = "Scan";
          ScanAction2[ScanAction2["RescanGreaterThanToken"] = 1] = "RescanGreaterThanToken";
          ScanAction2[ScanAction2["RescanSlashToken"] = 2] = "RescanSlashToken";
          ScanAction2[ScanAction2["RescanTemplateToken"] = 3] = "RescanTemplateToken";
          ScanAction2[ScanAction2["RescanJsxIdentifier"] = 4] = "RescanJsxIdentifier";
          ScanAction2[ScanAction2["RescanJsxText"] = 5] = "RescanJsxText";
          ScanAction2[ScanAction2["RescanJsxAttributeValue"] = 6] = "RescanJsxAttributeValue";
        })(ScanAction || (ScanAction = {}));
        function getFormattingScanner(text, languageVariant, startPos, endPos, cb) {
          var scanner = languageVariant === 1 ? jsxScanner : standardScanner;
          scanner.setText(text);
          scanner.setTextPos(startPos);
          var wasNewLine = true;
          var leadingTrivia;
          var trailingTrivia;
          var savedPos;
          var lastScanAction;
          var lastTokenInfo;
          var res = cb({
            advance,
            readTokenInfo,
            readEOFTokenRange,
            isOnToken,
            isOnEOF,
            getCurrentLeadingTrivia: function() {
              return leadingTrivia;
            },
            lastTrailingTriviaWasNewLine: function() {
              return wasNewLine;
            },
            skipToEndOf,
            skipToStartOf,
            getStartPos: function() {
              var _a;
              return (_a = lastTokenInfo === null || lastTokenInfo === void 0 ? void 0 : lastTokenInfo.token.pos) !== null && _a !== void 0 ? _a : scanner.getTokenPos();
            }
          });
          lastTokenInfo = void 0;
          scanner.setText(void 0);
          return res;
          function advance() {
            lastTokenInfo = void 0;
            var isStarted = scanner.getStartPos() !== startPos;
            if (isStarted) {
              wasNewLine = !!trailingTrivia && ts3.last(trailingTrivia).kind === 4;
            } else {
              scanner.scan();
            }
            leadingTrivia = void 0;
            trailingTrivia = void 0;
            var pos = scanner.getStartPos();
            while (pos < endPos) {
              var t = scanner.getToken();
              if (!ts3.isTrivia(t)) {
                break;
              }
              scanner.scan();
              var item = {
                pos,
                end: scanner.getStartPos(),
                kind: t
              };
              pos = scanner.getStartPos();
              leadingTrivia = ts3.append(leadingTrivia, item);
            }
            savedPos = scanner.getStartPos();
          }
          function shouldRescanGreaterThanToken(node) {
            switch (node.kind) {
              case 33:
              case 71:
              case 72:
              case 49:
              case 48:
                return true;
            }
            return false;
          }
          function shouldRescanJsxIdentifier(node) {
            if (node.parent) {
              switch (node.parent.kind) {
                case 285:
                case 280:
                case 281:
                case 279:
                  return ts3.isKeyword(node.kind) || node.kind === 79;
              }
            }
            return false;
          }
          function shouldRescanJsxText(node) {
            return ts3.isJsxText(node);
          }
          function shouldRescanSlashToken(container) {
            return container.kind === 13;
          }
          function shouldRescanTemplateToken(container) {
            return container.kind === 16 || container.kind === 17;
          }
          function shouldRescanJsxAttributeValue(node) {
            return node.parent && ts3.isJsxAttribute(node.parent) && node.parent.initializer === node;
          }
          function startsWithSlashToken(t) {
            return t === 43 || t === 68;
          }
          function readTokenInfo(n) {
            ts3.Debug.assert(isOnToken());
            var expectedScanAction = shouldRescanGreaterThanToken(n) ? 1 : shouldRescanSlashToken(n) ? 2 : shouldRescanTemplateToken(n) ? 3 : shouldRescanJsxIdentifier(n) ? 4 : shouldRescanJsxText(n) ? 5 : shouldRescanJsxAttributeValue(n) ? 6 : 0;
            if (lastTokenInfo && expectedScanAction === lastScanAction) {
              return fixTokenKind(lastTokenInfo, n);
            }
            if (scanner.getStartPos() !== savedPos) {
              ts3.Debug.assert(lastTokenInfo !== void 0);
              scanner.setTextPos(savedPos);
              scanner.scan();
            }
            var currentToken = getNextToken(n, expectedScanAction);
            var token = formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), currentToken);
            if (trailingTrivia) {
              trailingTrivia = void 0;
            }
            while (scanner.getStartPos() < endPos) {
              currentToken = scanner.scan();
              if (!ts3.isTrivia(currentToken)) {
                break;
              }
              var trivia = formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), currentToken);
              if (!trailingTrivia) {
                trailingTrivia = [];
              }
              trailingTrivia.push(trivia);
              if (currentToken === 4) {
                scanner.scan();
                break;
              }
            }
            lastTokenInfo = { leadingTrivia, trailingTrivia, token };
            return fixTokenKind(lastTokenInfo, n);
          }
          function getNextToken(n, expectedScanAction) {
            var token = scanner.getToken();
            lastScanAction = 0;
            switch (expectedScanAction) {
              case 1:
                if (token === 31) {
                  lastScanAction = 1;
                  var newToken = scanner.reScanGreaterToken();
                  ts3.Debug.assert(n.kind === newToken);
                  return newToken;
                }
                break;
              case 2:
                if (startsWithSlashToken(token)) {
                  lastScanAction = 2;
                  var newToken = scanner.reScanSlashToken();
                  ts3.Debug.assert(n.kind === newToken);
                  return newToken;
                }
                break;
              case 3:
                if (token === 19) {
                  lastScanAction = 3;
                  return scanner.reScanTemplateToken(false);
                }
                break;
              case 4:
                lastScanAction = 4;
                return scanner.scanJsxIdentifier();
              case 5:
                lastScanAction = 5;
                return scanner.reScanJsxToken(false);
              case 6:
                lastScanAction = 6;
                return scanner.reScanJsxAttributeValue();
              case 0:
                break;
              default:
                ts3.Debug.assertNever(expectedScanAction);
            }
            return token;
          }
          function readEOFTokenRange() {
            ts3.Debug.assert(isOnEOF());
            return formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), 1);
          }
          function isOnToken() {
            var current = lastTokenInfo ? lastTokenInfo.token.kind : scanner.getToken();
            return current !== 1 && !ts3.isTrivia(current);
          }
          function isOnEOF() {
            var current = lastTokenInfo ? lastTokenInfo.token.kind : scanner.getToken();
            return current === 1;
          }
          function fixTokenKind(tokenInfo, container) {
            if (ts3.isToken(container) && tokenInfo.token.kind !== container.kind) {
              tokenInfo.token.kind = container.kind;
            }
            return tokenInfo;
          }
          function skipToEndOf(node) {
            scanner.setTextPos(node.end);
            savedPos = scanner.getStartPos();
            lastScanAction = void 0;
            lastTokenInfo = void 0;
            wasNewLine = false;
            leadingTrivia = void 0;
            trailingTrivia = void 0;
          }
          function skipToStartOf(node) {
            scanner.setTextPos(node.pos);
            savedPos = scanner.getStartPos();
            lastScanAction = void 0;
            lastTokenInfo = void 0;
            wasNewLine = false;
            leadingTrivia = void 0;
            trailingTrivia = void 0;
          }
        }
        formatting2.getFormattingScanner = getFormattingScanner;
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        formatting2.anyContext = ts3.emptyArray;
        var RuleAction;
        (function(RuleAction2) {
          RuleAction2[RuleAction2["StopProcessingSpaceActions"] = 1] = "StopProcessingSpaceActions";
          RuleAction2[RuleAction2["StopProcessingTokenActions"] = 2] = "StopProcessingTokenActions";
          RuleAction2[RuleAction2["InsertSpace"] = 4] = "InsertSpace";
          RuleAction2[RuleAction2["InsertNewLine"] = 8] = "InsertNewLine";
          RuleAction2[RuleAction2["DeleteSpace"] = 16] = "DeleteSpace";
          RuleAction2[RuleAction2["DeleteToken"] = 32] = "DeleteToken";
          RuleAction2[RuleAction2["InsertTrailingSemicolon"] = 64] = "InsertTrailingSemicolon";
          RuleAction2[RuleAction2["StopAction"] = 3] = "StopAction";
          RuleAction2[RuleAction2["ModifySpaceAction"] = 28] = "ModifySpaceAction";
          RuleAction2[RuleAction2["ModifyTokenAction"] = 96] = "ModifyTokenAction";
        })(RuleAction = formatting2.RuleAction || (formatting2.RuleAction = {}));
        var RuleFlags;
        (function(RuleFlags2) {
          RuleFlags2[RuleFlags2["None"] = 0] = "None";
          RuleFlags2[RuleFlags2["CanDeleteNewLines"] = 1] = "CanDeleteNewLines";
        })(RuleFlags = formatting2.RuleFlags || (formatting2.RuleFlags = {}));
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        function getAllRules() {
          var allTokens = [];
          for (var token = 0; token <= 160; token++) {
            if (token !== 1) {
              allTokens.push(token);
            }
          }
          function anyTokenExcept() {
            var tokens = [];
            for (var _i = 0; _i < arguments.length; _i++) {
              tokens[_i] = arguments[_i];
            }
            return { tokens: allTokens.filter(function(t) {
              return !tokens.some(function(t2) {
                return t2 === t;
              });
            }), isSpecific: false };
          }
          var anyToken = { tokens: allTokens, isSpecific: false };
          var anyTokenIncludingMultilineComments = tokenRangeFrom(__spreadArray(__spreadArray([], allTokens, true), [3], false));
          var anyTokenIncludingEOF = tokenRangeFrom(__spreadArray(__spreadArray([], allTokens, true), [1], false));
          var keywords = tokenRangeFromRange(81, 160);
          var binaryOperators = tokenRangeFromRange(29, 78);
          var binaryKeywordOperators = [101, 102, 160, 127, 139];
          var unaryPrefixOperators = [45, 46, 54, 53];
          var unaryPrefixExpressions = [
            8,
            9,
            79,
            20,
            22,
            18,
            108,
            103
          ];
          var unaryPreincrementExpressions = [79, 20, 108, 103];
          var unaryPostincrementExpressions = [79, 21, 23, 103];
          var unaryPredecrementExpressions = [79, 20, 108, 103];
          var unaryPostdecrementExpressions = [79, 21, 23, 103];
          var comments = [2, 3];
          var typeNames = __spreadArray([79], ts3.typeKeywords, true);
          var functionOpenBraceLeftTokenRange = anyTokenIncludingMultilineComments;
          var typeScriptOpenBraceLeftTokenRange = tokenRangeFrom([79, 3, 84, 93, 100]);
          var controlOpenBraceLeftTokenRange = tokenRangeFrom([21, 3, 90, 111, 96, 91]);
          var highPriorityCommonRules = [
            rule("IgnoreBeforeComment", anyToken, comments, formatting2.anyContext, 1),
            rule("IgnoreAfterLineComment", 2, anyToken, formatting2.anyContext, 1),
            rule("NotSpaceBeforeColon", anyToken, 58, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16),
            rule("SpaceAfterColon", 58, anyToken, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 4),
            rule("NoSpaceBeforeQuestionMark", anyToken, 57, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16),
            rule("SpaceAfterQuestionMarkInConditionalOperator", 57, anyToken, [isNonJsxSameLineTokenContext, isConditionalOperatorContext], 4),
            rule("NoSpaceAfterQuestionMark", 57, anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeDot", anyToken, [24, 28], [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterDot", [24, 28], anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBetweenImportParenInImportType", 100, 20, [isNonJsxSameLineTokenContext, isImportTypeContext], 16),
            rule("NoSpaceAfterUnaryPrefixOperator", unaryPrefixOperators, unaryPrefixExpressions, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("NoSpaceAfterUnaryPreincrementOperator", 45, unaryPreincrementExpressions, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterUnaryPredecrementOperator", 46, unaryPredecrementExpressions, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeUnaryPostincrementOperator", unaryPostincrementExpressions, 45, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16),
            rule("NoSpaceBeforeUnaryPostdecrementOperator", unaryPostdecrementExpressions, 46, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16),
            rule("SpaceAfterPostincrementWhenFollowedByAdd", 45, 39, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterAddWhenFollowedByUnaryPlus", 39, 39, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterAddWhenFollowedByPreincrement", 39, 45, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterPostdecrementWhenFollowedBySubtract", 46, 40, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterSubtractWhenFollowedByUnaryMinus", 40, 40, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterSubtractWhenFollowedByPredecrement", 40, 46, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("NoSpaceAfterCloseBrace", 19, [27, 26], [isNonJsxSameLineTokenContext], 16),
            rule("NewLineBeforeCloseBraceInBlockContext", anyTokenIncludingMultilineComments, 19, [isMultilineBlockContext], 8),
            rule("SpaceAfterCloseBrace", 19, anyTokenExcept(21), [isNonJsxSameLineTokenContext, isAfterCodeBlockContext], 4),
            rule("SpaceBetweenCloseBraceAndElse", 19, 91, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenCloseBraceAndWhile", 19, 115, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectContext], 16),
            rule("SpaceAfterConditionalClosingParen", 21, 22, [isControlDeclContext], 4),
            rule("NoSpaceBetweenFunctionKeywordAndStar", 98, 41, [isFunctionDeclarationOrFunctionExpressionContext], 16),
            rule("SpaceAfterStarInGeneratorDeclaration", 41, 79, [isFunctionDeclarationOrFunctionExpressionContext], 4),
            rule("SpaceAfterFunctionInFuncDecl", 98, anyToken, [isFunctionDeclContext], 4),
            rule("NewLineAfterOpenBraceInBlockContext", 18, anyToken, [isMultilineBlockContext], 8),
            rule("SpaceAfterGetSetInMember", [136, 149], 79, [isFunctionDeclContext], 4),
            rule("NoSpaceBetweenYieldKeywordAndStar", 125, 41, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 16),
            rule("SpaceBetweenYieldOrYieldStarAndOperand", [125, 41], anyToken, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 4),
            rule("NoSpaceBetweenReturnAndSemicolon", 105, 26, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterCertainKeywords", [113, 109, 103, 89, 105, 112, 132], anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterLetConstInVariableDeclaration", [119, 85], anyToken, [isNonJsxSameLineTokenContext, isStartOfVariableDeclarationList], 4),
            rule("NoSpaceBeforeOpenParenInFuncCall", anyToken, 20, [isNonJsxSameLineTokenContext, isFunctionCallOrNewContext, isPreviousTokenNotComma], 16),
            rule("SpaceBeforeBinaryKeywordOperator", anyToken, binaryKeywordOperators, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterBinaryKeywordOperator", binaryKeywordOperators, anyToken, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterVoidOperator", 114, anyToken, [isNonJsxSameLineTokenContext, isVoidOpContext], 4),
            rule("SpaceBetweenAsyncAndOpenParen", 131, 20, [isArrowFunctionContext, isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenAsyncAndFunctionKeyword", 131, [98, 79], [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenTagAndTemplateString", [79, 21], [14, 15], [isNonJsxSameLineTokenContext], 16),
            rule("SpaceBeforeJsxAttribute", anyToken, 79, [isNextTokenParentJsxAttribute, isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeSlashInJsxOpeningElement", anyToken, 43, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement", 43, 31, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeEqualInJsxAttribute", anyToken, 63, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterEqualInJsxAttribute", 63, anyToken, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterModuleImport", [141, 146], 20, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterCertainTypeScriptKeywords", [
              126,
              84,
              135,
              88,
              92,
              93,
              94,
              136,
              117,
              100,
              118,
              141,
              142,
              121,
              123,
              122,
              145,
              149,
              124,
              152,
              156,
              140,
              137
            ], anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCertainTypeScriptKeywords", anyToken, [94, 117, 156], [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterModuleName", 10, 18, [isModuleDeclContext], 4),
            rule("SpaceBeforeArrow", anyToken, 38, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterArrow", 38, anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterEllipsis", 25, 79, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOptionalParameters", 57, [21, 27], [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("NoSpaceBetweenEmptyInterfaceBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectTypeContext], 16),
            rule("NoSpaceBeforeOpenAngularBracket", typeNames, 29, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceBetweenCloseParenAndAngularBracket", 21, 29, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceAfterOpenAngularBracket", 29, anyToken, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceBeforeCloseAngularBracket", anyToken, 31, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceAfterCloseAngularBracket", 31, [20, 22, 31, 27], [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext, isNotFunctionDeclContext], 16),
            rule("SpaceBeforeAt", [21, 79], 59, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterAt", 59, anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterDecorator", anyToken, [
              126,
              79,
              93,
              88,
              84,
              124,
              123,
              121,
              122,
              136,
              149,
              22,
              41
            ], [isEndOfDecoratorContextOnSameLine], 4),
            rule("NoSpaceBeforeNonNullAssertionOperator", anyToken, 53, [isNonJsxSameLineTokenContext, isNonNullAssertionContext], 16),
            rule("NoSpaceAfterNewKeywordOnConstructorSignature", 103, 20, [isNonJsxSameLineTokenContext, isConstructorSignatureContext], 16),
            rule("SpaceLessThanAndNonJSXTypeAnnotation", 29, 29, [isNonJsxSameLineTokenContext], 4)
          ];
          var userConfigurableRules = [
            rule("SpaceAfterConstructor", 134, 20, [isOptionEnabled("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterConstructor", 134, 20, [isOptionDisabledOrUndefined("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterComma", 27, anyToken, [isOptionEnabled("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNextTokenNotCloseBracket, isNextTokenNotCloseParen], 4),
            rule("NoSpaceAfterComma", 27, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext], 16),
            rule("SpaceAfterAnonymousFunctionKeyword", [98, 41], 20, [isOptionEnabled("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 4),
            rule("NoSpaceAfterAnonymousFunctionKeyword", [98, 41], 20, [isOptionDisabledOrUndefined("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 16),
            rule("SpaceAfterKeywordInControl", keywords, 20, [isOptionEnabled("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 4),
            rule("NoSpaceAfterKeywordInControl", keywords, 20, [isOptionDisabledOrUndefined("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 16),
            rule("SpaceAfterOpenParen", 20, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCloseParen", anyToken, 21, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenOpenParens", 20, 20, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenParens", 20, 21, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOpenParen", 20, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseParen", anyToken, 21, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBracket", 22, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCloseBracket", anyToken, 23, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenBrackets", 22, 23, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOpenBracket", 22, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseBracket", anyToken, 23, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBrace", 18, anyToken, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4),
            rule("SpaceBeforeCloseBrace", anyToken, 19, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectContext], 16),
            rule("NoSpaceAfterOpenBrace", 18, anyToken, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseBrace", anyToken, 19, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceBetweenEmptyBraceBrackets", 18, 19, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterTemplateHeadAndMiddle", [15, 16], anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxTextContext], 4, 1),
            rule("SpaceBeforeTemplateMiddleAndTail", anyToken, [16, 17], [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterTemplateHeadAndMiddle", [15, 16], anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxTextContext], 16, 1),
            rule("NoSpaceBeforeTemplateMiddleAndTail", anyToken, [16, 17], [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBraceInJsxExpression", 18, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4),
            rule("SpaceBeforeCloseBraceInJsxExpression", anyToken, 19, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4),
            rule("NoSpaceAfterOpenBraceInJsxExpression", 18, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16),
            rule("NoSpaceBeforeCloseBraceInJsxExpression", anyToken, 19, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16),
            rule("SpaceAfterSemicolonInFor", 26, anyToken, [isOptionEnabled("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 4),
            rule("NoSpaceAfterSemicolonInFor", 26, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 16),
            rule("SpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("NoSpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16),
            rule("NoSpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16),
            rule("SpaceBeforeOpenParenInFuncDecl", anyToken, 20, [isOptionEnabled("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 4),
            rule("NoSpaceBeforeOpenParenInFuncDecl", anyToken, 20, [isOptionDisabledOrUndefined("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 16),
            rule("NewLineBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isBeforeMultilineBlockContext], 8, 1),
            rule("NewLineBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeMultilineBlockContext], 8, 1),
            rule("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isBeforeMultilineBlockContext], 8, 1),
            rule("SpaceAfterTypeAssertion", 31, anyToken, [isOptionEnabled("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 4),
            rule("NoSpaceAfterTypeAssertion", 31, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 16),
            rule("SpaceBeforeTypeAnnotation", anyToken, [57, 58], [isOptionEnabled("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 4),
            rule("NoSpaceBeforeTypeAnnotation", anyToken, [57, 58], [isOptionDisabledOrUndefined("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 16),
            rule("NoOptionalSemicolon", 26, anyTokenIncludingEOF, [optionEquals("semicolons", ts3.SemicolonPreference.Remove), isSemicolonDeletionContext], 32),
            rule("OptionalSemicolon", anyToken, anyTokenIncludingEOF, [optionEquals("semicolons", ts3.SemicolonPreference.Insert), isSemicolonInsertionContext], 64)
          ];
          var lowPriorityCommonRules = [
            rule("NoSpaceBeforeSemicolon", anyToken, 26, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("SpaceBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("NoSpaceBeforeComma", anyToken, 27, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeOpenBracket", anyTokenExcept(131, 82), 22, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterCloseBracket", 23, anyToken, [isNonJsxSameLineTokenContext, isNotBeforeBlockInFunctionDeclarationContext], 16),
            rule("SpaceAfterSemicolon", 26, anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenForAndAwaitKeyword", 97, 132, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenStatements", [21, 90, 91, 82], anyToken, [isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNotForContext], 4),
            rule("SpaceAfterTryCatchFinally", [111, 83, 96], 18, [isNonJsxSameLineTokenContext], 4)
          ];
          return __spreadArray(__spreadArray(__spreadArray([], highPriorityCommonRules, true), userConfigurableRules, true), lowPriorityCommonRules, true);
        }
        formatting2.getAllRules = getAllRules;
        function rule(debugName, left, right, context, action, flags) {
          if (flags === void 0) {
            flags = 0;
          }
          return { leftTokenRange: toTokenRange(left), rightTokenRange: toTokenRange(right), rule: { debugName, context, action, flags } };
        }
        function tokenRangeFrom(tokens) {
          return { tokens, isSpecific: true };
        }
        function toTokenRange(arg) {
          return typeof arg === "number" ? tokenRangeFrom([arg]) : ts3.isArray(arg) ? tokenRangeFrom(arg) : arg;
        }
        function tokenRangeFromRange(from, to, except) {
          if (except === void 0) {
            except = [];
          }
          var tokens = [];
          for (var token = from; token <= to; token++) {
            if (!ts3.contains(except, token)) {
              tokens.push(token);
            }
          }
          return tokenRangeFrom(tokens);
        }
        function optionEquals(optionName, optionValue) {
          return function(context) {
            return context.options && context.options[optionName] === optionValue;
          };
        }
        function isOptionEnabled(optionName) {
          return function(context) {
            return context.options && context.options.hasOwnProperty(optionName) && !!context.options[optionName];
          };
        }
        function isOptionDisabled(optionName) {
          return function(context) {
            return context.options && context.options.hasOwnProperty(optionName) && !context.options[optionName];
          };
        }
        function isOptionDisabledOrUndefined(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !context.options[optionName];
          };
        }
        function isOptionDisabledOrUndefinedOrTokensOnSameLine(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !context.options[optionName] || context.TokensAreOnSameLine();
          };
        }
        function isOptionEnabledOrUndefined(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !!context.options[optionName];
          };
        }
        function isForContext(context) {
          return context.contextNode.kind === 242;
        }
        function isNotForContext(context) {
          return !isForContext(context);
        }
        function isBinaryOpContext(context) {
          switch (context.contextNode.kind) {
            case 221:
              return context.contextNode.operatorToken.kind !== 27;
            case 222:
            case 189:
            case 229:
            case 275:
            case 270:
            case 177:
            case 187:
            case 188:
              return true;
            case 203:
            case 259:
            case 265:
            case 271:
            case 254:
            case 164:
            case 299:
            case 167:
            case 166:
              return context.currentTokenSpan.kind === 63 || context.nextTokenSpan.kind === 63;
            case 243:
            case 163:
              return context.currentTokenSpan.kind === 101 || context.nextTokenSpan.kind === 101 || context.currentTokenSpan.kind === 63 || context.nextTokenSpan.kind === 63;
            case 244:
              return context.currentTokenSpan.kind === 160 || context.nextTokenSpan.kind === 160;
          }
          return false;
        }
        function isNotBinaryOpContext(context) {
          return !isBinaryOpContext(context);
        }
        function isNotTypeAnnotationContext(context) {
          return !isTypeAnnotationContext(context);
        }
        function isTypeAnnotationContext(context) {
          var contextKind = context.contextNode.kind;
          return contextKind === 167 || contextKind === 166 || contextKind === 164 || contextKind === 254 || ts3.isFunctionLikeKind(contextKind);
        }
        function isConditionalOperatorContext(context) {
          return context.contextNode.kind === 222 || context.contextNode.kind === 189;
        }
        function isSameLineTokenOrBeforeBlockContext(context) {
          return context.TokensAreOnSameLine() || isBeforeBlockContext(context);
        }
        function isBraceWrappedContext(context) {
          return context.contextNode.kind === 201 || context.contextNode.kind === 195 || isSingleLineBlockContext(context);
        }
        function isBeforeMultilineBlockContext(context) {
          return isBeforeBlockContext(context) && !(context.NextNodeAllOnSameLine() || context.NextNodeBlockIsOnOneLine());
        }
        function isMultilineBlockContext(context) {
          return isBlockContext(context) && !(context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
        }
        function isSingleLineBlockContext(context) {
          return isBlockContext(context) && (context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
        }
        function isBlockContext(context) {
          return nodeIsBlockContext(context.contextNode);
        }
        function isBeforeBlockContext(context) {
          return nodeIsBlockContext(context.nextTokenParent);
        }
        function nodeIsBlockContext(node) {
          if (nodeIsTypeScriptDeclWithBlockContext(node)) {
            return true;
          }
          switch (node.kind) {
            case 235:
            case 263:
            case 205:
            case 262:
              return true;
          }
          return false;
        }
        function isFunctionDeclContext(context) {
          switch (context.contextNode.kind) {
            case 256:
            case 169:
            case 168:
            case 172:
            case 173:
            case 174:
            case 213:
            case 171:
            case 214:
            case 258:
              return true;
          }
          return false;
        }
        function isNotFunctionDeclContext(context) {
          return !isFunctionDeclContext(context);
        }
        function isFunctionDeclarationOrFunctionExpressionContext(context) {
          return context.contextNode.kind === 256 || context.contextNode.kind === 213;
        }
        function isTypeScriptDeclWithBlockContext(context) {
          return nodeIsTypeScriptDeclWithBlockContext(context.contextNode);
        }
        function nodeIsTypeScriptDeclWithBlockContext(node) {
          switch (node.kind) {
            case 257:
            case 226:
            case 258:
            case 260:
            case 182:
            case 261:
            case 272:
            case 273:
            case 266:
            case 269:
              return true;
          }
          return false;
        }
        function isAfterCodeBlockContext(context) {
          switch (context.currentTokenParent.kind) {
            case 257:
            case 261:
            case 260:
            case 292:
            case 262:
            case 249:
              return true;
            case 235: {
              var blockParent = context.currentTokenParent.parent;
              if (!blockParent || blockParent.kind !== 214 && blockParent.kind !== 213) {
                return true;
              }
            }
          }
          return false;
        }
        function isControlDeclContext(context) {
          switch (context.contextNode.kind) {
            case 239:
            case 249:
            case 242:
            case 243:
            case 244:
            case 241:
            case 252:
            case 240:
            case 248:
            case 292:
              return true;
            default:
              return false;
          }
        }
        function isObjectContext(context) {
          return context.contextNode.kind === 205;
        }
        function isFunctionCallContext(context) {
          return context.contextNode.kind === 208;
        }
        function isNewContext(context) {
          return context.contextNode.kind === 209;
        }
        function isFunctionCallOrNewContext(context) {
          return isFunctionCallContext(context) || isNewContext(context);
        }
        function isPreviousTokenNotComma(context) {
          return context.currentTokenSpan.kind !== 27;
        }
        function isNextTokenNotCloseBracket(context) {
          return context.nextTokenSpan.kind !== 23;
        }
        function isNextTokenNotCloseParen(context) {
          return context.nextTokenSpan.kind !== 21;
        }
        function isArrowFunctionContext(context) {
          return context.contextNode.kind === 214;
        }
        function isImportTypeContext(context) {
          return context.contextNode.kind === 200;
        }
        function isNonJsxSameLineTokenContext(context) {
          return context.TokensAreOnSameLine() && context.contextNode.kind !== 11;
        }
        function isNonJsxTextContext(context) {
          return context.contextNode.kind !== 11;
        }
        function isNonJsxElementOrFragmentContext(context) {
          return context.contextNode.kind !== 278 && context.contextNode.kind !== 282;
        }
        function isJsxExpressionContext(context) {
          return context.contextNode.kind === 288 || context.contextNode.kind === 287;
        }
        function isNextTokenParentJsxAttribute(context) {
          return context.nextTokenParent.kind === 285;
        }
        function isJsxAttributeContext(context) {
          return context.contextNode.kind === 285;
        }
        function isJsxSelfClosingElementContext(context) {
          return context.contextNode.kind === 279;
        }
        function isNotBeforeBlockInFunctionDeclarationContext(context) {
          return !isFunctionDeclContext(context) && !isBeforeBlockContext(context);
        }
        function isEndOfDecoratorContextOnSameLine(context) {
          return context.TokensAreOnSameLine() && !!context.contextNode.decorators && nodeIsInDecoratorContext(context.currentTokenParent) && !nodeIsInDecoratorContext(context.nextTokenParent);
        }
        function nodeIsInDecoratorContext(node) {
          while (ts3.isExpressionNode(node)) {
            node = node.parent;
          }
          return node.kind === 165;
        }
        function isStartOfVariableDeclarationList(context) {
          return context.currentTokenParent.kind === 255 && context.currentTokenParent.getStart(context.sourceFile) === context.currentTokenSpan.pos;
        }
        function isNotFormatOnEnter(context) {
          return context.formattingRequestKind !== 2;
        }
        function isModuleDeclContext(context) {
          return context.contextNode.kind === 261;
        }
        function isObjectTypeContext(context) {
          return context.contextNode.kind === 182;
        }
        function isConstructorSignatureContext(context) {
          return context.contextNode.kind === 175;
        }
        function isTypeArgumentOrParameterOrAssertion(token, parent) {
          if (token.kind !== 29 && token.kind !== 31) {
            return false;
          }
          switch (parent.kind) {
            case 178:
            case 211:
            case 259:
            case 257:
            case 226:
            case 258:
            case 256:
            case 213:
            case 214:
            case 169:
            case 168:
            case 174:
            case 175:
            case 208:
            case 209:
            case 228:
              return true;
            default:
              return false;
          }
        }
        function isTypeArgumentOrParameterOrAssertionContext(context) {
          return isTypeArgumentOrParameterOrAssertion(context.currentTokenSpan, context.currentTokenParent) || isTypeArgumentOrParameterOrAssertion(context.nextTokenSpan, context.nextTokenParent);
        }
        function isTypeAssertionContext(context) {
          return context.contextNode.kind === 211;
        }
        function isVoidOpContext(context) {
          return context.currentTokenSpan.kind === 114 && context.currentTokenParent.kind === 217;
        }
        function isYieldOrYieldStarWithOperand(context) {
          return context.contextNode.kind === 224 && context.contextNode.expression !== void 0;
        }
        function isNonNullAssertionContext(context) {
          return context.contextNode.kind === 230;
        }
        function isNotStatementConditionContext(context) {
          return !isStatementConditionContext(context);
        }
        function isStatementConditionContext(context) {
          switch (context.contextNode.kind) {
            case 239:
            case 242:
            case 243:
            case 244:
            case 240:
            case 241:
              return true;
            default:
              return false;
          }
        }
        function isSemicolonDeletionContext(context) {
          var nextTokenKind = context.nextTokenSpan.kind;
          var nextTokenStart = context.nextTokenSpan.pos;
          if (ts3.isTrivia(nextTokenKind)) {
            var nextRealToken = context.nextTokenParent === context.currentTokenParent ? ts3.findNextToken(context.currentTokenParent, ts3.findAncestor(context.currentTokenParent, function(a) {
              return !a.parent;
            }), context.sourceFile) : context.nextTokenParent.getFirstToken(context.sourceFile);
            if (!nextRealToken) {
              return true;
            }
            nextTokenKind = nextRealToken.kind;
            nextTokenStart = nextRealToken.getStart(context.sourceFile);
          }
          var startLine = context.sourceFile.getLineAndCharacterOfPosition(context.currentTokenSpan.pos).line;
          var endLine = context.sourceFile.getLineAndCharacterOfPosition(nextTokenStart).line;
          if (startLine === endLine) {
            return nextTokenKind === 19 || nextTokenKind === 1;
          }
          if (nextTokenKind === 234 || nextTokenKind === 26) {
            return false;
          }
          if (context.contextNode.kind === 258 || context.contextNode.kind === 259) {
            return !ts3.isPropertySignature(context.currentTokenParent) || !!context.currentTokenParent.type || nextTokenKind !== 20;
          }
          if (ts3.isPropertyDeclaration(context.currentTokenParent)) {
            return !context.currentTokenParent.initializer;
          }
          return context.currentTokenParent.kind !== 242 && context.currentTokenParent.kind !== 236 && context.currentTokenParent.kind !== 234 && nextTokenKind !== 22 && nextTokenKind !== 20 && nextTokenKind !== 39 && nextTokenKind !== 40 && nextTokenKind !== 43 && nextTokenKind !== 13 && nextTokenKind !== 27 && nextTokenKind !== 223 && nextTokenKind !== 15 && nextTokenKind !== 14 && nextTokenKind !== 24;
        }
        function isSemicolonInsertionContext(context) {
          return ts3.positionIsASICandidate(context.currentTokenSpan.end, context.currentTokenParent, context.sourceFile);
        }
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        function getFormatContext(options, host) {
          return { options, getRules: getRulesMap(), host };
        }
        formatting2.getFormatContext = getFormatContext;
        var rulesMapCache;
        function getRulesMap() {
          if (rulesMapCache === void 0) {
            rulesMapCache = createRulesMap(formatting2.getAllRules());
          }
          return rulesMapCache;
        }
        function getRuleActionExclusion(ruleAction) {
          var mask2 = 0;
          if (ruleAction & 1) {
            mask2 |= 28;
          }
          if (ruleAction & 2) {
            mask2 |= 96;
          }
          if (ruleAction & 28) {
            mask2 |= 28;
          }
          if (ruleAction & 96) {
            mask2 |= 96;
          }
          return mask2;
        }
        function createRulesMap(rules) {
          var map2 = buildMap(rules);
          return function(context) {
            var bucket = map2[getRuleBucketIndex(context.currentTokenSpan.kind, context.nextTokenSpan.kind)];
            if (bucket) {
              var rules_1 = [];
              var ruleActionMask = 0;
              for (var _i = 0, bucket_1 = bucket; _i < bucket_1.length; _i++) {
                var rule = bucket_1[_i];
                var acceptRuleActions = ~getRuleActionExclusion(ruleActionMask);
                if (rule.action & acceptRuleActions && ts3.every(rule.context, function(c) {
                  return c(context);
                })) {
                  rules_1.push(rule);
                  ruleActionMask |= rule.action;
                }
              }
              if (rules_1.length) {
                return rules_1;
              }
            }
          };
        }
        function buildMap(rules) {
          var map2 = new Array(mapRowLength * mapRowLength);
          var rulesBucketConstructionStateList = new Array(map2.length);
          for (var _i = 0, rules_2 = rules; _i < rules_2.length; _i++) {
            var rule = rules_2[_i];
            var specificRule = rule.leftTokenRange.isSpecific && rule.rightTokenRange.isSpecific;
            for (var _a = 0, _b = rule.leftTokenRange.tokens; _a < _b.length; _a++) {
              var left = _b[_a];
              for (var _c = 0, _d = rule.rightTokenRange.tokens; _c < _d.length; _c++) {
                var right = _d[_c];
                var index = getRuleBucketIndex(left, right);
                var rulesBucket = map2[index];
                if (rulesBucket === void 0) {
                  rulesBucket = map2[index] = [];
                }
                addRule(rulesBucket, rule.rule, specificRule, rulesBucketConstructionStateList, index);
              }
            }
          }
          return map2;
        }
        function getRuleBucketIndex(row, column) {
          ts3.Debug.assert(row <= 160 && column <= 160, "Must compute formatting context from tokens");
          return row * mapRowLength + column;
        }
        var maskBitSize = 5;
        var mask = 31;
        var mapRowLength = 160 + 1;
        var RulesPosition;
        (function(RulesPosition2) {
          RulesPosition2[RulesPosition2["StopRulesSpecific"] = 0] = "StopRulesSpecific";
          RulesPosition2[RulesPosition2["StopRulesAny"] = maskBitSize * 1] = "StopRulesAny";
          RulesPosition2[RulesPosition2["ContextRulesSpecific"] = maskBitSize * 2] = "ContextRulesSpecific";
          RulesPosition2[RulesPosition2["ContextRulesAny"] = maskBitSize * 3] = "ContextRulesAny";
          RulesPosition2[RulesPosition2["NoContextRulesSpecific"] = maskBitSize * 4] = "NoContextRulesSpecific";
          RulesPosition2[RulesPosition2["NoContextRulesAny"] = maskBitSize * 5] = "NoContextRulesAny";
        })(RulesPosition || (RulesPosition = {}));
        function addRule(rules, rule, specificTokens, constructionState, rulesBucketIndex) {
          var position = rule.action & 3 ? specificTokens ? RulesPosition.StopRulesSpecific : RulesPosition.StopRulesAny : rule.context !== formatting2.anyContext ? specificTokens ? RulesPosition.ContextRulesSpecific : RulesPosition.ContextRulesAny : specificTokens ? RulesPosition.NoContextRulesSpecific : RulesPosition.NoContextRulesAny;
          var state = constructionState[rulesBucketIndex] || 0;
          rules.splice(getInsertionIndex(state, position), 0, rule);
          constructionState[rulesBucketIndex] = increaseInsertionIndex(state, position);
        }
        function getInsertionIndex(indexBitmap, maskPosition) {
          var index = 0;
          for (var pos = 0; pos <= maskPosition; pos += maskBitSize) {
            index += indexBitmap & mask;
            indexBitmap >>= maskBitSize;
          }
          return index;
        }
        function increaseInsertionIndex(indexBitmap, maskPosition) {
          var value = (indexBitmap >> maskPosition & mask) + 1;
          ts3.Debug.assert((value & mask) === value, "Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules.");
          return indexBitmap & ~(mask << maskPosition) | value << maskPosition;
        }
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        function createTextRangeWithKind(pos, end, kind) {
          var textRangeWithKind = { pos, end, kind };
          if (ts3.Debug.isDebugging) {
            Object.defineProperty(textRangeWithKind, "__debugKind", {
              get: function() {
                return ts3.Debug.formatSyntaxKind(kind);
              }
            });
          }
          return textRangeWithKind;
        }
        formatting2.createTextRangeWithKind = createTextRangeWithKind;
        var Constants;
        (function(Constants2) {
          Constants2[Constants2["Unknown"] = -1] = "Unknown";
        })(Constants || (Constants = {}));
        function formatOnEnter(position, sourceFile, formatContext) {
          var line = sourceFile.getLineAndCharacterOfPosition(position).line;
          if (line === 0) {
            return [];
          }
          var endOfFormatSpan = ts3.getEndLinePosition(line, sourceFile);
          while (ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(endOfFormatSpan))) {
            endOfFormatSpan--;
          }
          if (ts3.isLineBreak(sourceFile.text.charCodeAt(endOfFormatSpan))) {
            endOfFormatSpan--;
          }
          var span = {
            pos: ts3.getStartPositionOfLine(line - 1, sourceFile),
            end: endOfFormatSpan + 1
          };
          return formatSpan(span, sourceFile, formatContext, 2);
        }
        formatting2.formatOnEnter = formatOnEnter;
        function formatOnSemicolon(position, sourceFile, formatContext) {
          var semicolon = findImmediatelyPrecedingTokenOfKind(position, 26, sourceFile);
          return formatNodeLines(findOutermostNodeWithinListLevel(semicolon), sourceFile, formatContext, 3);
        }
        formatting2.formatOnSemicolon = formatOnSemicolon;
        function formatOnOpeningCurly(position, sourceFile, formatContext) {
          var openingCurly = findImmediatelyPrecedingTokenOfKind(position, 18, sourceFile);
          if (!openingCurly) {
            return [];
          }
          var curlyBraceRange = openingCurly.parent;
          var outermostNode = findOutermostNodeWithinListLevel(curlyBraceRange);
          var textRange = {
            pos: ts3.getLineStartPositionForPosition(outermostNode.getStart(sourceFile), sourceFile),
            end: position
          };
          return formatSpan(textRange, sourceFile, formatContext, 4);
        }
        formatting2.formatOnOpeningCurly = formatOnOpeningCurly;
        function formatOnClosingCurly(position, sourceFile, formatContext) {
          var precedingToken = findImmediatelyPrecedingTokenOfKind(position, 19, sourceFile);
          return formatNodeLines(findOutermostNodeWithinListLevel(precedingToken), sourceFile, formatContext, 5);
        }
        formatting2.formatOnClosingCurly = formatOnClosingCurly;
        function formatDocument(sourceFile, formatContext) {
          var span = {
            pos: 0,
            end: sourceFile.text.length
          };
          return formatSpan(span, sourceFile, formatContext, 0);
        }
        formatting2.formatDocument = formatDocument;
        function formatSelection(start, end, sourceFile, formatContext) {
          var span = {
            pos: ts3.getLineStartPositionForPosition(start, sourceFile),
            end
          };
          return formatSpan(span, sourceFile, formatContext, 1);
        }
        formatting2.formatSelection = formatSelection;
        function findImmediatelyPrecedingTokenOfKind(end, expectedTokenKind, sourceFile) {
          var precedingToken = ts3.findPrecedingToken(end, sourceFile);
          return precedingToken && precedingToken.kind === expectedTokenKind && end === precedingToken.getEnd() ? precedingToken : void 0;
        }
        function findOutermostNodeWithinListLevel(node) {
          var current = node;
          while (current && current.parent && current.parent.end === node.end && !isListElement(current.parent, current)) {
            current = current.parent;
          }
          return current;
        }
        function isListElement(parent, node) {
          switch (parent.kind) {
            case 257:
            case 258:
              return ts3.rangeContainsRange(parent.members, node);
            case 261:
              var body = parent.body;
              return !!body && body.kind === 262 && ts3.rangeContainsRange(body.statements, node);
            case 305:
            case 235:
            case 262:
              return ts3.rangeContainsRange(parent.statements, node);
            case 292:
              return ts3.rangeContainsRange(parent.block.statements, node);
          }
          return false;
        }
        function findEnclosingNode(range, sourceFile) {
          return find(sourceFile);
          function find(n) {
            var candidate = ts3.forEachChild(n, function(c) {
              return ts3.startEndContainsRange(c.getStart(sourceFile), c.end, range) && c;
            });
            if (candidate) {
              var result2 = find(candidate);
              if (result2) {
                return result2;
              }
            }
            return n;
          }
        }
        function prepareRangeContainsErrorFunction(errors, originalRange) {
          if (!errors.length) {
            return rangeHasNoErrors;
          }
          var sorted = errors.filter(function(d) {
            return ts3.rangeOverlapsWithStartEnd(originalRange, d.start, d.start + d.length);
          }).sort(function(e1, e2) {
            return e1.start - e2.start;
          });
          if (!sorted.length) {
            return rangeHasNoErrors;
          }
          var index = 0;
          return function(r) {
            while (true) {
              if (index >= sorted.length) {
                return false;
              }
              var error = sorted[index];
              if (r.end <= error.start) {
                return false;
              }
              if (ts3.startEndOverlapsWithStartEnd(r.pos, r.end, error.start, error.start + error.length)) {
                return true;
              }
              index++;
            }
          };
          function rangeHasNoErrors() {
            return false;
          }
        }
        function getScanStartPosition(enclosingNode, originalRange, sourceFile) {
          var start = enclosingNode.getStart(sourceFile);
          if (start === originalRange.pos && enclosingNode.end === originalRange.end) {
            return start;
          }
          var precedingToken = ts3.findPrecedingToken(originalRange.pos, sourceFile);
          if (!precedingToken) {
            return enclosingNode.pos;
          }
          if (precedingToken.end >= originalRange.pos) {
            return enclosingNode.pos;
          }
          return precedingToken.end;
        }
        function getOwnOrInheritedDelta(n, options, sourceFile) {
          var previousLine = -1;
          var child;
          while (n) {
            var line = sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile)).line;
            if (previousLine !== -1 && line !== previousLine) {
              break;
            }
            if (formatting2.SmartIndenter.shouldIndentChildNode(options, n, child, sourceFile)) {
              return options.indentSize;
            }
            previousLine = line;
            child = n;
            n = n.parent;
          }
          return 0;
        }
        function formatNodeGivenIndentation(node, sourceFileLike, languageVariant, initialIndentation, delta, formatContext) {
          var range = { pos: node.pos, end: node.end };
          return formatting2.getFormattingScanner(sourceFileLike.text, languageVariant, range.pos, range.end, function(scanner) {
            return formatSpanWorker(range, node, initialIndentation, delta, scanner, formatContext, 1, function(_) {
              return false;
            }, sourceFileLike);
          });
        }
        formatting2.formatNodeGivenIndentation = formatNodeGivenIndentation;
        function formatNodeLines(node, sourceFile, formatContext, requestKind) {
          if (!node) {
            return [];
          }
          var span = {
            pos: ts3.getLineStartPositionForPosition(node.getStart(sourceFile), sourceFile),
            end: node.end
          };
          return formatSpan(span, sourceFile, formatContext, requestKind);
        }
        function formatSpan(originalRange, sourceFile, formatContext, requestKind) {
          var enclosingNode = findEnclosingNode(originalRange, sourceFile);
          return formatting2.getFormattingScanner(sourceFile.text, sourceFile.languageVariant, getScanStartPosition(enclosingNode, originalRange, sourceFile), originalRange.end, function(scanner) {
            return formatSpanWorker(originalRange, enclosingNode, formatting2.SmartIndenter.getIndentationForNode(enclosingNode, originalRange, sourceFile, formatContext.options), getOwnOrInheritedDelta(enclosingNode, formatContext.options, sourceFile), scanner, formatContext, requestKind, prepareRangeContainsErrorFunction(sourceFile.parseDiagnostics, originalRange), sourceFile);
          });
        }
        function formatSpanWorker(originalRange, enclosingNode, initialIndentation, delta, formattingScanner, _a, requestKind, rangeContainsError, sourceFile) {
          var _b;
          var options = _a.options, getRules = _a.getRules, host = _a.host;
          var formattingContext = new formatting2.FormattingContext(sourceFile, requestKind, options);
          var previousRange;
          var previousParent;
          var previousRangeStartLine;
          var lastIndentedLine;
          var indentationOnLastIndentedLine = -1;
          var edits = [];
          formattingScanner.advance();
          if (formattingScanner.isOnToken()) {
            var startLine = sourceFile.getLineAndCharacterOfPosition(enclosingNode.getStart(sourceFile)).line;
            var undecoratedStartLine = startLine;
            if (enclosingNode.decorators) {
              undecoratedStartLine = sourceFile.getLineAndCharacterOfPosition(ts3.getNonDecoratorTokenPosOfNode(enclosingNode, sourceFile)).line;
            }
            processNode(enclosingNode, enclosingNode, startLine, undecoratedStartLine, initialIndentation, delta);
          }
          if (!formattingScanner.isOnToken()) {
            var indentation = formatting2.SmartIndenter.nodeWillIndentChild(options, enclosingNode, void 0, sourceFile, false) ? initialIndentation + options.indentSize : initialIndentation;
            var leadingTrivia = formattingScanner.getCurrentLeadingTrivia();
            if (leadingTrivia) {
              indentTriviaItems(leadingTrivia, indentation, false, function(item) {
                return processRange(item, sourceFile.getLineAndCharacterOfPosition(item.pos), enclosingNode, enclosingNode, void 0);
              });
              if (options.trimTrailingWhitespace !== false) {
                trimTrailingWhitespacesForRemainingRange(leadingTrivia);
              }
            }
          }
          if (previousRange && formattingScanner.getStartPos() >= originalRange.end) {
            var tokenInfo = formattingScanner.isOnEOF() ? formattingScanner.readEOFTokenRange() : formattingScanner.isOnToken() ? formattingScanner.readTokenInfo(enclosingNode).token : void 0;
            if (tokenInfo) {
              var parent = ((_b = ts3.findPrecedingToken(tokenInfo.end, sourceFile, enclosingNode)) === null || _b === void 0 ? void 0 : _b.parent) || previousParent;
              processPair(tokenInfo, sourceFile.getLineAndCharacterOfPosition(tokenInfo.pos).line, parent, previousRange, previousRangeStartLine, previousParent, parent, void 0);
            }
          }
          return edits;
          function tryComputeIndentationForListItem(startPos, endPos, parentStartLine, range, inheritedIndentation) {
            if (ts3.rangeOverlapsWithStartEnd(range, startPos, endPos) || ts3.rangeContainsStartEnd(range, startPos, endPos)) {
              if (inheritedIndentation !== -1) {
                return inheritedIndentation;
              }
            } else {
              var startLine2 = sourceFile.getLineAndCharacterOfPosition(startPos).line;
              var startLinePosition = ts3.getLineStartPositionForPosition(startPos, sourceFile);
              var column = formatting2.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, startPos, sourceFile, options);
              if (startLine2 !== parentStartLine || startPos === column) {
                var baseIndentSize = formatting2.SmartIndenter.getBaseIndentation(options);
                return baseIndentSize > column ? baseIndentSize : column;
              }
            }
            return -1;
          }
          function computeIndentation(node, startLine2, inheritedIndentation, parent2, parentDynamicIndentation, effectiveParentStartLine) {
            var delta2 = formatting2.SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
            if (effectiveParentStartLine === startLine2) {
              return {
                indentation: startLine2 === lastIndentedLine ? indentationOnLastIndentedLine : parentDynamicIndentation.getIndentation(),
                delta: Math.min(options.indentSize, parentDynamicIndentation.getDelta(node) + delta2)
              };
            } else if (inheritedIndentation === -1) {
              if (node.kind === 20 && startLine2 === lastIndentedLine) {
                return { indentation: indentationOnLastIndentedLine, delta: parentDynamicIndentation.getDelta(node) };
              } else if (formatting2.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(parent2, node, startLine2, sourceFile) || formatting2.SmartIndenter.childIsUnindentedBranchOfConditionalExpression(parent2, node, startLine2, sourceFile) || formatting2.SmartIndenter.argumentStartsOnSameLineAsPreviousArgument(parent2, node, startLine2, sourceFile)) {
                return { indentation: parentDynamicIndentation.getIndentation(), delta: delta2 };
              } else {
                return { indentation: parentDynamicIndentation.getIndentation() + parentDynamicIndentation.getDelta(node), delta: delta2 };
              }
            } else {
              return { indentation: inheritedIndentation, delta: delta2 };
            }
          }
          function getFirstNonDecoratorTokenOfNode(node) {
            if (node.modifiers && node.modifiers.length) {
              return node.modifiers[0].kind;
            }
            switch (node.kind) {
              case 257:
                return 84;
              case 258:
                return 118;
              case 256:
                return 98;
              case 260:
                return 260;
              case 172:
                return 136;
              case 173:
                return 149;
              case 169:
                if (node.asteriskToken) {
                  return 41;
                }
              case 167:
              case 164:
                var name = ts3.getNameOfDeclaration(node);
                if (name) {
                  return name.kind;
                }
            }
          }
          function getDynamicIndentation(node, nodeStartLine, indentation2, delta2) {
            return {
              getIndentationForComment: function(kind, tokenIndentation, container) {
                switch (kind) {
                  case 19:
                  case 23:
                  case 21:
                    return indentation2 + getDelta(container);
                }
                return tokenIndentation !== -1 ? tokenIndentation : indentation2;
              },
              getIndentationForToken: function(line, kind, container, suppressDelta) {
                return !suppressDelta && shouldAddDelta(line, kind, container) ? indentation2 + getDelta(container) : indentation2;
              },
              getIndentation: function() {
                return indentation2;
              },
              getDelta,
              recomputeIndentation: function(lineAdded, parent2) {
                if (formatting2.SmartIndenter.shouldIndentChildNode(options, parent2, node, sourceFile)) {
                  indentation2 += lineAdded ? options.indentSize : -options.indentSize;
                  delta2 = formatting2.SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
                }
              }
            };
            function shouldAddDelta(line, kind, container) {
              switch (kind) {
                case 18:
                case 19:
                case 21:
                case 91:
                case 115:
                case 59:
                  return false;
                case 43:
                case 31:
                  switch (container.kind) {
                    case 280:
                    case 281:
                    case 279:
                    case 228:
                      return false;
                  }
                  break;
                case 22:
                case 23:
                  if (container.kind !== 195) {
                    return false;
                  }
                  break;
              }
              return nodeStartLine !== line && !(node.decorators && kind === getFirstNonDecoratorTokenOfNode(node));
            }
            function getDelta(child) {
              return formatting2.SmartIndenter.nodeWillIndentChild(options, node, child, sourceFile, true) ? delta2 : 0;
            }
          }
          function processNode(node, contextNode, nodeStartLine, undecoratedNodeStartLine, indentation2, delta2) {
            if (!ts3.rangeOverlapsWithStartEnd(originalRange, node.getStart(sourceFile), node.getEnd())) {
              return;
            }
            var nodeDynamicIndentation = getDynamicIndentation(node, nodeStartLine, indentation2, delta2);
            var childContextNode = contextNode;
            ts3.forEachChild(node, function(child) {
              processChildNode(child, -1, node, nodeDynamicIndentation, nodeStartLine, undecoratedNodeStartLine, false);
            }, function(nodes) {
              processChildNodes(nodes, node, nodeStartLine, nodeDynamicIndentation);
            });
            while (formattingScanner.isOnToken() && formattingScanner.getStartPos() < originalRange.end) {
              var tokenInfo2 = formattingScanner.readTokenInfo(node);
              if (tokenInfo2.token.end > Math.min(node.end, originalRange.end)) {
                break;
              }
              consumeTokenAndAdvanceScanner(tokenInfo2, node, nodeDynamicIndentation, node);
            }
            function processChildNode(child, inheritedIndentation, parent2, parentDynamicIndentation, parentStartLine, undecoratedParentStartLine, isListItem, isFirstListItem) {
              if (ts3.nodeIsMissing(child)) {
                return inheritedIndentation;
              }
              var childStartPos = child.getStart(sourceFile);
              var childStartLine = sourceFile.getLineAndCharacterOfPosition(childStartPos).line;
              var undecoratedChildStartLine = childStartLine;
              if (child.decorators) {
                undecoratedChildStartLine = sourceFile.getLineAndCharacterOfPosition(ts3.getNonDecoratorTokenPosOfNode(child, sourceFile)).line;
              }
              var childIndentationAmount = -1;
              if (isListItem && ts3.rangeContainsRange(originalRange, parent2)) {
                childIndentationAmount = tryComputeIndentationForListItem(childStartPos, child.end, parentStartLine, originalRange, inheritedIndentation);
                if (childIndentationAmount !== -1) {
                  inheritedIndentation = childIndentationAmount;
                }
              }
              if (!ts3.rangeOverlapsWithStartEnd(originalRange, child.pos, child.end)) {
                if (child.end < originalRange.pos) {
                  formattingScanner.skipToEndOf(child);
                }
                return inheritedIndentation;
              }
              if (child.getFullWidth() === 0) {
                return inheritedIndentation;
              }
              while (formattingScanner.isOnToken() && formattingScanner.getStartPos() < originalRange.end) {
                var tokenInfo3 = formattingScanner.readTokenInfo(node);
                if (tokenInfo3.token.end > originalRange.end) {
                  return inheritedIndentation;
                }
                if (tokenInfo3.token.end > childStartPos) {
                  if (tokenInfo3.token.pos > childStartPos) {
                    formattingScanner.skipToStartOf(child);
                  }
                  break;
                }
                consumeTokenAndAdvanceScanner(tokenInfo3, node, parentDynamicIndentation, node);
              }
              if (!formattingScanner.isOnToken() || formattingScanner.getStartPos() >= originalRange.end) {
                return inheritedIndentation;
              }
              if (ts3.isToken(child)) {
                var tokenInfo3 = formattingScanner.readTokenInfo(child);
                if (child.kind !== 11) {
                  ts3.Debug.assert(tokenInfo3.token.end === child.end, "Token end is child end");
                  consumeTokenAndAdvanceScanner(tokenInfo3, node, parentDynamicIndentation, child);
                  return inheritedIndentation;
                }
              }
              var effectiveParentStartLine = child.kind === 165 ? childStartLine : undecoratedParentStartLine;
              var childIndentation = computeIndentation(child, childStartLine, childIndentationAmount, node, parentDynamicIndentation, effectiveParentStartLine);
              processNode(child, childContextNode, childStartLine, undecoratedChildStartLine, childIndentation.indentation, childIndentation.delta);
              childContextNode = node;
              if (isFirstListItem && parent2.kind === 204 && inheritedIndentation === -1) {
                inheritedIndentation = childIndentation.indentation;
              }
              return inheritedIndentation;
            }
            function processChildNodes(nodes, parent2, parentStartLine, parentDynamicIndentation) {
              ts3.Debug.assert(ts3.isNodeArray(nodes));
              var listStartToken = getOpenTokenForList(parent2, nodes);
              var listDynamicIndentation = parentDynamicIndentation;
              var startLine2 = parentStartLine;
              if (!ts3.rangeOverlapsWithStartEnd(originalRange, nodes.pos, nodes.end)) {
                if (nodes.end < originalRange.pos) {
                  formattingScanner.skipToEndOf(nodes);
                }
                return;
              }
              if (listStartToken !== 0) {
                while (formattingScanner.isOnToken() && formattingScanner.getStartPos() < originalRange.end) {
                  var tokenInfo3 = formattingScanner.readTokenInfo(parent2);
                  if (tokenInfo3.token.end > nodes.pos) {
                    break;
                  } else if (tokenInfo3.token.kind === listStartToken) {
                    startLine2 = sourceFile.getLineAndCharacterOfPosition(tokenInfo3.token.pos).line;
                    consumeTokenAndAdvanceScanner(tokenInfo3, parent2, parentDynamicIndentation, parent2);
                    var indentationOnListStartToken = void 0;
                    if (indentationOnLastIndentedLine !== -1) {
                      indentationOnListStartToken = indentationOnLastIndentedLine;
                    } else {
                      var startLinePosition = ts3.getLineStartPositionForPosition(tokenInfo3.token.pos, sourceFile);
                      indentationOnListStartToken = formatting2.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, tokenInfo3.token.pos, sourceFile, options);
                    }
                    listDynamicIndentation = getDynamicIndentation(parent2, parentStartLine, indentationOnListStartToken, options.indentSize);
                  } else {
                    consumeTokenAndAdvanceScanner(tokenInfo3, parent2, parentDynamicIndentation, parent2);
                  }
                }
              }
              var inheritedIndentation = -1;
              for (var i = 0; i < nodes.length; i++) {
                var child = nodes[i];
                inheritedIndentation = processChildNode(child, inheritedIndentation, node, listDynamicIndentation, startLine2, startLine2, true, i === 0);
              }
              var listEndToken = getCloseTokenForOpenToken(listStartToken);
              if (listEndToken !== 0 && formattingScanner.isOnToken() && formattingScanner.getStartPos() < originalRange.end) {
                var tokenInfo3 = formattingScanner.readTokenInfo(parent2);
                if (tokenInfo3.token.kind === 27 && ts3.isCallLikeExpression(parent2)) {
                  var commaTokenLine = sourceFile.getLineAndCharacterOfPosition(tokenInfo3.token.pos).line;
                  if (startLine2 !== commaTokenLine) {
                    formattingScanner.advance();
                    tokenInfo3 = formattingScanner.isOnToken() ? formattingScanner.readTokenInfo(parent2) : void 0;
                  }
                }
                if (tokenInfo3 && tokenInfo3.token.kind === listEndToken && ts3.rangeContainsRange(parent2, tokenInfo3.token)) {
                  consumeTokenAndAdvanceScanner(tokenInfo3, parent2, listDynamicIndentation, parent2, true);
                }
              }
            }
            function consumeTokenAndAdvanceScanner(currentTokenInfo, parent2, dynamicIndentation, container, isListEndToken) {
              ts3.Debug.assert(ts3.rangeContainsRange(parent2, currentTokenInfo.token));
              var lastTriviaWasNewLine = formattingScanner.lastTrailingTriviaWasNewLine();
              var indentToken = false;
              if (currentTokenInfo.leadingTrivia) {
                processTrivia(currentTokenInfo.leadingTrivia, parent2, childContextNode, dynamicIndentation);
              }
              var lineAction = 0;
              var isTokenInRange = ts3.rangeContainsRange(originalRange, currentTokenInfo.token);
              var tokenStart = sourceFile.getLineAndCharacterOfPosition(currentTokenInfo.token.pos);
              if (isTokenInRange) {
                var rangeHasError = rangeContainsError(currentTokenInfo.token);
                var savePreviousRange = previousRange;
                lineAction = processRange(currentTokenInfo.token, tokenStart, parent2, childContextNode, dynamicIndentation);
                if (!rangeHasError) {
                  if (lineAction === 0) {
                    var prevEndLine = savePreviousRange && sourceFile.getLineAndCharacterOfPosition(savePreviousRange.end).line;
                    indentToken = lastTriviaWasNewLine && tokenStart.line !== prevEndLine;
                  } else {
                    indentToken = lineAction === 1;
                  }
                }
              }
              if (currentTokenInfo.trailingTrivia) {
                processTrivia(currentTokenInfo.trailingTrivia, parent2, childContextNode, dynamicIndentation);
              }
              if (indentToken) {
                var tokenIndentation = isTokenInRange && !rangeContainsError(currentTokenInfo.token) ? dynamicIndentation.getIndentationForToken(tokenStart.line, currentTokenInfo.token.kind, container, !!isListEndToken) : -1;
                var indentNextTokenOrTrivia = true;
                if (currentTokenInfo.leadingTrivia) {
                  var commentIndentation_1 = dynamicIndentation.getIndentationForComment(currentTokenInfo.token.kind, tokenIndentation, container);
                  indentNextTokenOrTrivia = indentTriviaItems(currentTokenInfo.leadingTrivia, commentIndentation_1, indentNextTokenOrTrivia, function(item) {
                    return insertIndentation(item.pos, commentIndentation_1, false);
                  });
                }
                if (tokenIndentation !== -1 && indentNextTokenOrTrivia) {
                  insertIndentation(currentTokenInfo.token.pos, tokenIndentation, lineAction === 1);
                  lastIndentedLine = tokenStart.line;
                  indentationOnLastIndentedLine = tokenIndentation;
                }
              }
              formattingScanner.advance();
              childContextNode = parent2;
            }
          }
          function indentTriviaItems(trivia, commentIndentation, indentNextTokenOrTrivia, indentSingleLine) {
            for (var _i = 0, trivia_1 = trivia; _i < trivia_1.length; _i++) {
              var triviaItem = trivia_1[_i];
              var triviaInRange = ts3.rangeContainsRange(originalRange, triviaItem);
              switch (triviaItem.kind) {
                case 3:
                  if (triviaInRange) {
                    indentMultilineComment(triviaItem, commentIndentation, !indentNextTokenOrTrivia);
                  }
                  indentNextTokenOrTrivia = false;
                  break;
                case 2:
                  if (indentNextTokenOrTrivia && triviaInRange) {
                    indentSingleLine(triviaItem);
                  }
                  indentNextTokenOrTrivia = false;
                  break;
                case 4:
                  indentNextTokenOrTrivia = true;
                  break;
              }
            }
            return indentNextTokenOrTrivia;
          }
          function processTrivia(trivia, parent2, contextNode, dynamicIndentation) {
            for (var _i = 0, trivia_2 = trivia; _i < trivia_2.length; _i++) {
              var triviaItem = trivia_2[_i];
              if (ts3.isComment(triviaItem.kind) && ts3.rangeContainsRange(originalRange, triviaItem)) {
                var triviaItemStart = sourceFile.getLineAndCharacterOfPosition(triviaItem.pos);
                processRange(triviaItem, triviaItemStart, parent2, contextNode, dynamicIndentation);
              }
            }
          }
          function processRange(range, rangeStart, parent2, contextNode, dynamicIndentation) {
            var rangeHasError = rangeContainsError(range);
            var lineAction = 0;
            if (!rangeHasError) {
              if (!previousRange) {
                var originalStart = sourceFile.getLineAndCharacterOfPosition(originalRange.pos);
                trimTrailingWhitespacesForLines(originalStart.line, rangeStart.line);
              } else {
                lineAction = processPair(range, rangeStart.line, parent2, previousRange, previousRangeStartLine, previousParent, contextNode, dynamicIndentation);
              }
            }
            previousRange = range;
            previousParent = parent2;
            previousRangeStartLine = rangeStart.line;
            return lineAction;
          }
          function processPair(currentItem, currentStartLine, currentParent, previousItem, previousStartLine, previousParent2, contextNode, dynamicIndentation) {
            formattingContext.updateContext(previousItem, previousParent2, currentItem, currentParent, contextNode);
            var rules = getRules(formattingContext);
            var trimTrailingWhitespaces = formattingContext.options.trimTrailingWhitespace !== false;
            var lineAction = 0;
            if (rules) {
              ts3.forEachRight(rules, function(rule) {
                lineAction = applyRuleEdits(rule, previousItem, previousStartLine, currentItem, currentStartLine);
                if (dynamicIndentation) {
                  switch (lineAction) {
                    case 2:
                      if (currentParent.getStart(sourceFile) === currentItem.pos) {
                        dynamicIndentation.recomputeIndentation(false, contextNode);
                      }
                      break;
                    case 1:
                      if (currentParent.getStart(sourceFile) === currentItem.pos) {
                        dynamicIndentation.recomputeIndentation(true, contextNode);
                      }
                      break;
                    default:
                      ts3.Debug.assert(lineAction === 0);
                  }
                }
                trimTrailingWhitespaces = trimTrailingWhitespaces && !(rule.action & 16) && rule.flags !== 1;
              });
            } else {
              trimTrailingWhitespaces = trimTrailingWhitespaces && currentItem.kind !== 1;
            }
            if (currentStartLine !== previousStartLine && trimTrailingWhitespaces) {
              trimTrailingWhitespacesForLines(previousStartLine, currentStartLine, previousItem);
            }
            return lineAction;
          }
          function insertIndentation(pos, indentation2, lineAdded) {
            var indentationString = getIndentationString(indentation2, options);
            if (lineAdded) {
              recordReplace(pos, 0, indentationString);
            } else {
              var tokenStart = sourceFile.getLineAndCharacterOfPosition(pos);
              var startLinePosition = ts3.getStartPositionOfLine(tokenStart.line, sourceFile);
              if (indentation2 !== characterToColumn(startLinePosition, tokenStart.character) || indentationIsDifferent(indentationString, startLinePosition)) {
                recordReplace(startLinePosition, tokenStart.character, indentationString);
              }
            }
          }
          function characterToColumn(startLinePosition, characterInLine) {
            var column = 0;
            for (var i = 0; i < characterInLine; i++) {
              if (sourceFile.text.charCodeAt(startLinePosition + i) === 9) {
                column += options.tabSize - column % options.tabSize;
              } else {
                column++;
              }
            }
            return column;
          }
          function indentationIsDifferent(indentationString, startLinePosition) {
            return indentationString !== sourceFile.text.substr(startLinePosition, indentationString.length);
          }
          function indentMultilineComment(commentRange, indentation2, firstLineIsIndented, indentFinalLine) {
            if (indentFinalLine === void 0) {
              indentFinalLine = true;
            }
            var startLine2 = sourceFile.getLineAndCharacterOfPosition(commentRange.pos).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(commentRange.end).line;
            if (startLine2 === endLine) {
              if (!firstLineIsIndented) {
                insertIndentation(commentRange.pos, indentation2, false);
              }
              return;
            }
            var parts = [];
            var startPos = commentRange.pos;
            for (var line = startLine2; line < endLine; line++) {
              var endOfLine = ts3.getEndLinePosition(line, sourceFile);
              parts.push({ pos: startPos, end: endOfLine });
              startPos = ts3.getStartPositionOfLine(line + 1, sourceFile);
            }
            if (indentFinalLine) {
              parts.push({ pos: startPos, end: commentRange.end });
            }
            if (parts.length === 0)
              return;
            var startLinePos = ts3.getStartPositionOfLine(startLine2, sourceFile);
            var nonWhitespaceColumnInFirstPart = formatting2.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(startLinePos, parts[0].pos, sourceFile, options);
            var startIndex = 0;
            if (firstLineIsIndented) {
              startIndex = 1;
              startLine2++;
            }
            var delta2 = indentation2 - nonWhitespaceColumnInFirstPart.column;
            for (var i = startIndex; i < parts.length; i++, startLine2++) {
              var startLinePos_1 = ts3.getStartPositionOfLine(startLine2, sourceFile);
              var nonWhitespaceCharacterAndColumn = i === 0 ? nonWhitespaceColumnInFirstPart : formatting2.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(parts[i].pos, parts[i].end, sourceFile, options);
              var newIndentation = nonWhitespaceCharacterAndColumn.column + delta2;
              if (newIndentation > 0) {
                var indentationString = getIndentationString(newIndentation, options);
                recordReplace(startLinePos_1, nonWhitespaceCharacterAndColumn.character, indentationString);
              } else {
                recordDelete(startLinePos_1, nonWhitespaceCharacterAndColumn.character);
              }
            }
          }
          function trimTrailingWhitespacesForLines(line1, line2, range) {
            for (var line = line1; line < line2; line++) {
              var lineStartPosition = ts3.getStartPositionOfLine(line, sourceFile);
              var lineEndPosition = ts3.getEndLinePosition(line, sourceFile);
              if (range && (ts3.isComment(range.kind) || ts3.isStringOrRegularExpressionOrTemplateLiteral(range.kind)) && range.pos <= lineEndPosition && range.end > lineEndPosition) {
                continue;
              }
              var whitespaceStart = getTrailingWhitespaceStartPosition(lineStartPosition, lineEndPosition);
              if (whitespaceStart !== -1) {
                ts3.Debug.assert(whitespaceStart === lineStartPosition || !ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(whitespaceStart - 1)));
                recordDelete(whitespaceStart, lineEndPosition + 1 - whitespaceStart);
              }
            }
          }
          function getTrailingWhitespaceStartPosition(start, end) {
            var pos = end;
            while (pos >= start && ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(pos))) {
              pos--;
            }
            if (pos !== end) {
              return pos + 1;
            }
            return -1;
          }
          function trimTrailingWhitespacesForRemainingRange(trivias) {
            var startPos = previousRange ? previousRange.end : originalRange.pos;
            for (var _i = 0, trivias_1 = trivias; _i < trivias_1.length; _i++) {
              var trivia = trivias_1[_i];
              if (ts3.isComment(trivia.kind)) {
                if (startPos < trivia.pos) {
                  trimTrailingWitespacesForPositions(startPos, trivia.pos - 1, previousRange);
                }
                startPos = trivia.end + 1;
              }
            }
            if (startPos < originalRange.end) {
              trimTrailingWitespacesForPositions(startPos, originalRange.end, previousRange);
            }
          }
          function trimTrailingWitespacesForPositions(startPos, endPos, previousRange2) {
            var startLine2 = sourceFile.getLineAndCharacterOfPosition(startPos).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(endPos).line;
            trimTrailingWhitespacesForLines(startLine2, endLine + 1, previousRange2);
          }
          function recordDelete(start, len) {
            if (len) {
              edits.push(ts3.createTextChangeFromStartLength(start, len, ""));
            }
          }
          function recordReplace(start, len, newText) {
            if (len || newText) {
              edits.push(ts3.createTextChangeFromStartLength(start, len, newText));
            }
          }
          function recordInsert(start, text) {
            if (text) {
              edits.push(ts3.createTextChangeFromStartLength(start, 0, text));
            }
          }
          function applyRuleEdits(rule, previousRange2, previousStartLine, currentRange, currentStartLine) {
            var onLaterLine = currentStartLine !== previousStartLine;
            switch (rule.action) {
              case 1:
                return 0;
              case 16:
                if (previousRange2.end !== currentRange.pos) {
                  recordDelete(previousRange2.end, currentRange.pos - previousRange2.end);
                  return onLaterLine ? 2 : 0;
                }
                break;
              case 32:
                recordDelete(previousRange2.pos, previousRange2.end - previousRange2.pos);
                break;
              case 8:
                if (rule.flags !== 1 && previousStartLine !== currentStartLine) {
                  return 0;
                }
                var lineDelta = currentStartLine - previousStartLine;
                if (lineDelta !== 1) {
                  recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, ts3.getNewLineOrDefaultFromHost(host, options));
                  return onLaterLine ? 0 : 1;
                }
                break;
              case 4:
                if (rule.flags !== 1 && previousStartLine !== currentStartLine) {
                  return 0;
                }
                var posDelta = currentRange.pos - previousRange2.end;
                if (posDelta !== 1 || sourceFile.text.charCodeAt(previousRange2.end) !== 32) {
                  recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, " ");
                  return onLaterLine ? 2 : 0;
                }
                break;
              case 64:
                recordInsert(previousRange2.end, ";");
            }
            return 0;
          }
        }
        var LineAction;
        (function(LineAction2) {
          LineAction2[LineAction2["None"] = 0] = "None";
          LineAction2[LineAction2["LineAdded"] = 1] = "LineAdded";
          LineAction2[LineAction2["LineRemoved"] = 2] = "LineRemoved";
        })(LineAction || (LineAction = {}));
        function getRangeOfEnclosingComment(sourceFile, position, precedingToken, tokenAtPosition) {
          if (tokenAtPosition === void 0) {
            tokenAtPosition = ts3.getTokenAtPosition(sourceFile, position);
          }
          var jsdoc = ts3.findAncestor(tokenAtPosition, ts3.isJSDoc);
          if (jsdoc)
            tokenAtPosition = jsdoc.parent;
          var tokenStart = tokenAtPosition.getStart(sourceFile);
          if (tokenStart <= position && position < tokenAtPosition.getEnd()) {
            return void 0;
          }
          precedingToken = precedingToken === null ? void 0 : precedingToken === void 0 ? ts3.findPrecedingToken(position, sourceFile) : precedingToken;
          var trailingRangesOfPreviousToken = precedingToken && ts3.getTrailingCommentRanges(sourceFile.text, precedingToken.end);
          var leadingCommentRangesOfNextToken = ts3.getLeadingCommentRangesOfNode(tokenAtPosition, sourceFile);
          var commentRanges = ts3.concatenate(trailingRangesOfPreviousToken, leadingCommentRangesOfNextToken);
          return commentRanges && ts3.find(commentRanges, function(range) {
            return ts3.rangeContainsPositionExclusive(range, position) || position === range.end && (range.kind === 2 || position === sourceFile.getFullWidth());
          });
        }
        formatting2.getRangeOfEnclosingComment = getRangeOfEnclosingComment;
        function getOpenTokenForList(node, list) {
          switch (node.kind) {
            case 171:
            case 256:
            case 213:
            case 169:
            case 168:
            case 214:
              if (node.typeParameters === list) {
                return 29;
              } else if (node.parameters === list) {
                return 20;
              }
              break;
            case 208:
            case 209:
              if (node.typeArguments === list) {
                return 29;
              } else if (node.arguments === list) {
                return 20;
              }
              break;
            case 178:
              if (node.typeArguments === list) {
                return 29;
              }
              break;
            case 182:
              return 18;
          }
          return 0;
        }
        function getCloseTokenForOpenToken(kind) {
          switch (kind) {
            case 20:
              return 21;
            case 29:
              return 31;
            case 18:
              return 19;
          }
          return 0;
        }
        var internedSizes;
        var internedTabsIndentation;
        var internedSpacesIndentation;
        function getIndentationString(indentation, options) {
          var resetInternedStrings = !internedSizes || (internedSizes.tabSize !== options.tabSize || internedSizes.indentSize !== options.indentSize);
          if (resetInternedStrings) {
            internedSizes = { tabSize: options.tabSize, indentSize: options.indentSize };
            internedTabsIndentation = internedSpacesIndentation = void 0;
          }
          if (!options.convertTabsToSpaces) {
            var tabs = Math.floor(indentation / options.tabSize);
            var spaces = indentation - tabs * options.tabSize;
            var tabString = void 0;
            if (!internedTabsIndentation) {
              internedTabsIndentation = [];
            }
            if (internedTabsIndentation[tabs] === void 0) {
              internedTabsIndentation[tabs] = tabString = ts3.repeatString("	", tabs);
            } else {
              tabString = internedTabsIndentation[tabs];
            }
            return spaces ? tabString + ts3.repeatString(" ", spaces) : tabString;
          } else {
            var spacesString = void 0;
            var quotient = Math.floor(indentation / options.indentSize);
            var remainder = indentation % options.indentSize;
            if (!internedSpacesIndentation) {
              internedSpacesIndentation = [];
            }
            if (internedSpacesIndentation[quotient] === void 0) {
              spacesString = ts3.repeatString(" ", options.indentSize * quotient);
              internedSpacesIndentation[quotient] = spacesString;
            } else {
              spacesString = internedSpacesIndentation[quotient];
            }
            return remainder ? spacesString + ts3.repeatString(" ", remainder) : spacesString;
          }
        }
        formatting2.getIndentationString = getIndentationString;
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        var SmartIndenter;
        (function(SmartIndenter2) {
          var Value;
          (function(Value2) {
            Value2[Value2["Unknown"] = -1] = "Unknown";
          })(Value || (Value = {}));
          function getIndentation(position, sourceFile, options, assumeNewLineBeforeCloseBrace) {
            if (assumeNewLineBeforeCloseBrace === void 0) {
              assumeNewLineBeforeCloseBrace = false;
            }
            if (position > sourceFile.text.length) {
              return getBaseIndentation(options);
            }
            if (options.indentStyle === ts3.IndentStyle.None) {
              return 0;
            }
            var precedingToken = ts3.findPrecedingToken(position, sourceFile, void 0, true);
            var enclosingCommentRange = formatting2.getRangeOfEnclosingComment(sourceFile, position, precedingToken || null);
            if (enclosingCommentRange && enclosingCommentRange.kind === 3) {
              return getCommentIndent(sourceFile, position, options, enclosingCommentRange);
            }
            if (!precedingToken) {
              return getBaseIndentation(options);
            }
            var precedingTokenIsLiteral = ts3.isStringOrRegularExpressionOrTemplateLiteral(precedingToken.kind);
            if (precedingTokenIsLiteral && precedingToken.getStart(sourceFile) <= position && position < precedingToken.end) {
              return 0;
            }
            var lineAtPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
            var currentToken = ts3.getTokenAtPosition(sourceFile, position);
            var isObjectLiteral = currentToken.kind === 18 && currentToken.parent.kind === 205;
            if (options.indentStyle === ts3.IndentStyle.Block || isObjectLiteral) {
              return getBlockIndent(sourceFile, position, options);
            }
            if (precedingToken.kind === 27 && precedingToken.parent.kind !== 221) {
              var actualIndentation = getActualIndentationForListItemBeforeComma(precedingToken, sourceFile, options);
              if (actualIndentation !== -1) {
                return actualIndentation;
              }
            }
            var containerList = getListByPosition(position, precedingToken.parent, sourceFile);
            if (containerList && !ts3.rangeContainsRange(containerList, precedingToken)) {
              var useTheSameBaseIndentation = [213, 214].indexOf(currentToken.parent.kind) !== -1;
              var indentSize = useTheSameBaseIndentation ? 0 : options.indentSize;
              return getActualIndentationForListStartLine(containerList, sourceFile, options) + indentSize;
            }
            return getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options);
          }
          SmartIndenter2.getIndentation = getIndentation;
          function getCommentIndent(sourceFile, position, options, enclosingCommentRange) {
            var previousLine = ts3.getLineAndCharacterOfPosition(sourceFile, position).line - 1;
            var commentStartLine = ts3.getLineAndCharacterOfPosition(sourceFile, enclosingCommentRange.pos).line;
            ts3.Debug.assert(commentStartLine >= 0);
            if (previousLine <= commentStartLine) {
              return findFirstNonWhitespaceColumn(ts3.getStartPositionOfLine(commentStartLine, sourceFile), position, sourceFile, options);
            }
            var startPositionOfLine = ts3.getStartPositionOfLine(previousLine, sourceFile);
            var _a = findFirstNonWhitespaceCharacterAndColumn(startPositionOfLine, position, sourceFile, options), column = _a.column, character = _a.character;
            if (column === 0) {
              return column;
            }
            var firstNonWhitespaceCharacterCode = sourceFile.text.charCodeAt(startPositionOfLine + character);
            return firstNonWhitespaceCharacterCode === 42 ? column - 1 : column;
          }
          function getBlockIndent(sourceFile, position, options) {
            var current = position;
            while (current > 0) {
              var char = sourceFile.text.charCodeAt(current);
              if (!ts3.isWhiteSpaceLike(char)) {
                break;
              }
              current--;
            }
            var lineStart = ts3.getLineStartPositionForPosition(current, sourceFile);
            return findFirstNonWhitespaceColumn(lineStart, current, sourceFile, options);
          }
          function getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options) {
            var previous;
            var current = precedingToken;
            while (current) {
              if (ts3.positionBelongsToNode(current, position, sourceFile) && shouldIndentChildNode(options, current, previous, sourceFile, true)) {
                var currentStart = getStartLineAndCharacterForNode(current, sourceFile);
                var nextTokenKind = nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile);
                var indentationDelta = nextTokenKind !== 0 ? assumeNewLineBeforeCloseBrace && nextTokenKind === 2 ? options.indentSize : 0 : lineAtPosition !== currentStart.line ? options.indentSize : 0;
                return getIndentationForNodeWorker(current, currentStart, void 0, indentationDelta, sourceFile, true, options);
              }
              var actualIndentation = getActualIndentationForListItem(current, sourceFile, options, true);
              if (actualIndentation !== -1) {
                return actualIndentation;
              }
              previous = current;
              current = current.parent;
            }
            return getBaseIndentation(options);
          }
          function getIndentationForNode(n, ignoreActualIndentationRange, sourceFile, options) {
            var start = sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));
            return getIndentationForNodeWorker(n, start, ignoreActualIndentationRange, 0, sourceFile, false, options);
          }
          SmartIndenter2.getIndentationForNode = getIndentationForNode;
          function getBaseIndentation(options) {
            return options.baseIndentSize || 0;
          }
          SmartIndenter2.getBaseIndentation = getBaseIndentation;
          function getIndentationForNodeWorker(current, currentStart, ignoreActualIndentationRange, indentationDelta, sourceFile, isNextChild, options) {
            var _a;
            var parent = current.parent;
            while (parent) {
              var useActualIndentation = true;
              if (ignoreActualIndentationRange) {
                var start = current.getStart(sourceFile);
                useActualIndentation = start < ignoreActualIndentationRange.pos || start > ignoreActualIndentationRange.end;
              }
              var containingListOrParentStart = getContainingListOrParentStart(parent, current, sourceFile);
              var parentAndChildShareLine = containingListOrParentStart.line === currentStart.line || childStartsOnTheSameLineWithElseInIfStatement(parent, current, currentStart.line, sourceFile);
              if (useActualIndentation) {
                var firstListChild = (_a = getContainingList(current, sourceFile)) === null || _a === void 0 ? void 0 : _a[0];
                var listIndentsChild = !!firstListChild && getStartLineAndCharacterForNode(firstListChild, sourceFile).line > containingListOrParentStart.line;
                var actualIndentation = getActualIndentationForListItem(current, sourceFile, options, listIndentsChild);
                if (actualIndentation !== -1) {
                  return actualIndentation + indentationDelta;
                }
                actualIndentation = getActualIndentationForNode(current, parent, currentStart, parentAndChildShareLine, sourceFile, options);
                if (actualIndentation !== -1) {
                  return actualIndentation + indentationDelta;
                }
              }
              if (shouldIndentChildNode(options, parent, current, sourceFile, isNextChild) && !parentAndChildShareLine) {
                indentationDelta += options.indentSize;
              }
              var useTrueStart = isArgumentAndStartLineOverlapsExpressionBeingCalled(parent, current, currentStart.line, sourceFile);
              current = parent;
              parent = current.parent;
              currentStart = useTrueStart ? sourceFile.getLineAndCharacterOfPosition(current.getStart(sourceFile)) : containingListOrParentStart;
            }
            return indentationDelta + getBaseIndentation(options);
          }
          function getContainingListOrParentStart(parent, child, sourceFile) {
            var containingList = getContainingList(child, sourceFile);
            var startPos = containingList ? containingList.pos : parent.getStart(sourceFile);
            return sourceFile.getLineAndCharacterOfPosition(startPos);
          }
          function getActualIndentationForListItemBeforeComma(commaToken, sourceFile, options) {
            var commaItemInfo = ts3.findListItemInfo(commaToken);
            if (commaItemInfo && commaItemInfo.listItemIndex > 0) {
              return deriveActualIndentationFromList(commaItemInfo.list.getChildren(), commaItemInfo.listItemIndex - 1, sourceFile, options);
            } else {
              return -1;
            }
          }
          function getActualIndentationForNode(current, parent, currentLineAndChar, parentAndChildShareLine, sourceFile, options) {
            var useActualIndentation = (ts3.isDeclaration(current) || ts3.isStatementButNotDeclaration(current)) && (parent.kind === 305 || !parentAndChildShareLine);
            if (!useActualIndentation) {
              return -1;
            }
            return findColumnForFirstNonWhitespaceCharacterInLine(currentLineAndChar, sourceFile, options);
          }
          var NextTokenKind;
          (function(NextTokenKind2) {
            NextTokenKind2[NextTokenKind2["Unknown"] = 0] = "Unknown";
            NextTokenKind2[NextTokenKind2["OpenBrace"] = 1] = "OpenBrace";
            NextTokenKind2[NextTokenKind2["CloseBrace"] = 2] = "CloseBrace";
          })(NextTokenKind || (NextTokenKind = {}));
          function nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile) {
            var nextToken = ts3.findNextToken(precedingToken, current, sourceFile);
            if (!nextToken) {
              return 0;
            }
            if (nextToken.kind === 18) {
              return 1;
            } else if (nextToken.kind === 19) {
              var nextTokenStartLine = getStartLineAndCharacterForNode(nextToken, sourceFile).line;
              return lineAtPosition === nextTokenStartLine ? 2 : 0;
            }
            return 0;
          }
          function getStartLineAndCharacterForNode(n, sourceFile) {
            return sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));
          }
          function isArgumentAndStartLineOverlapsExpressionBeingCalled(parent, child, childStartLine, sourceFile) {
            if (!(ts3.isCallExpression(parent) && ts3.contains(parent.arguments, child))) {
              return false;
            }
            var expressionOfCallExpressionEnd = parent.expression.getEnd();
            var expressionOfCallExpressionEndLine = ts3.getLineAndCharacterOfPosition(sourceFile, expressionOfCallExpressionEnd).line;
            return expressionOfCallExpressionEndLine === childStartLine;
          }
          SmartIndenter2.isArgumentAndStartLineOverlapsExpressionBeingCalled = isArgumentAndStartLineOverlapsExpressionBeingCalled;
          function childStartsOnTheSameLineWithElseInIfStatement(parent, child, childStartLine, sourceFile) {
            if (parent.kind === 239 && parent.elseStatement === child) {
              var elseKeyword = ts3.findChildOfKind(parent, 91, sourceFile);
              ts3.Debug.assert(elseKeyword !== void 0);
              var elseKeywordStartLine = getStartLineAndCharacterForNode(elseKeyword, sourceFile).line;
              return elseKeywordStartLine === childStartLine;
            }
            return false;
          }
          SmartIndenter2.childStartsOnTheSameLineWithElseInIfStatement = childStartsOnTheSameLineWithElseInIfStatement;
          function childIsUnindentedBranchOfConditionalExpression(parent, child, childStartLine, sourceFile) {
            if (ts3.isConditionalExpression(parent) && (child === parent.whenTrue || child === parent.whenFalse)) {
              var conditionEndLine = ts3.getLineAndCharacterOfPosition(sourceFile, parent.condition.end).line;
              if (child === parent.whenTrue) {
                return childStartLine === conditionEndLine;
              } else {
                var trueStartLine = getStartLineAndCharacterForNode(parent.whenTrue, sourceFile).line;
                var trueEndLine = ts3.getLineAndCharacterOfPosition(sourceFile, parent.whenTrue.end).line;
                return conditionEndLine === trueStartLine && trueEndLine === childStartLine;
              }
            }
            return false;
          }
          SmartIndenter2.childIsUnindentedBranchOfConditionalExpression = childIsUnindentedBranchOfConditionalExpression;
          function argumentStartsOnSameLineAsPreviousArgument(parent, child, childStartLine, sourceFile) {
            if (ts3.isCallOrNewExpression(parent)) {
              if (!parent.arguments)
                return false;
              var currentNode = ts3.find(parent.arguments, function(arg) {
                return arg.pos === child.pos;
              });
              if (!currentNode)
                return false;
              var currentIndex = parent.arguments.indexOf(currentNode);
              if (currentIndex === 0)
                return false;
              var previousNode = parent.arguments[currentIndex - 1];
              var lineOfPreviousNode = ts3.getLineAndCharacterOfPosition(sourceFile, previousNode.getEnd()).line;
              if (childStartLine === lineOfPreviousNode) {
                return true;
              }
            }
            return false;
          }
          SmartIndenter2.argumentStartsOnSameLineAsPreviousArgument = argumentStartsOnSameLineAsPreviousArgument;
          function getContainingList(node, sourceFile) {
            return node.parent && getListByRange(node.getStart(sourceFile), node.getEnd(), node.parent, sourceFile);
          }
          SmartIndenter2.getContainingList = getContainingList;
          function getListByPosition(pos, node, sourceFile) {
            return node && getListByRange(pos, pos, node, sourceFile);
          }
          function getListByRange(start, end, node, sourceFile) {
            switch (node.kind) {
              case 178:
                return getList(node.typeArguments);
              case 205:
                return getList(node.properties);
              case 204:
                return getList(node.elements);
              case 182:
                return getList(node.members);
              case 256:
              case 213:
              case 214:
              case 169:
              case 168:
              case 174:
              case 171:
              case 180:
              case 175:
                return getList(node.typeParameters) || getList(node.parameters);
              case 172:
                return getList(node.parameters);
              case 257:
              case 226:
              case 258:
              case 259:
              case 344:
                return getList(node.typeParameters);
              case 209:
              case 208:
                return getList(node.typeArguments) || getList(node.arguments);
              case 255:
                return getList(node.declarations);
              case 269:
              case 273:
                return getList(node.elements);
              case 201:
              case 202:
                return getList(node.elements);
            }
            function getList(list) {
              return list && ts3.rangeContainsStartEnd(getVisualListRange(node, list, sourceFile), start, end) ? list : void 0;
            }
          }
          function getVisualListRange(node, list, sourceFile) {
            var children = node.getChildren(sourceFile);
            for (var i = 1; i < children.length - 1; i++) {
              if (children[i].pos === list.pos && children[i].end === list.end) {
                return { pos: children[i - 1].end, end: children[i + 1].getStart(sourceFile) };
              }
            }
            return list;
          }
          function getActualIndentationForListStartLine(list, sourceFile, options) {
            if (!list) {
              return -1;
            }
            return findColumnForFirstNonWhitespaceCharacterInLine(sourceFile.getLineAndCharacterOfPosition(list.pos), sourceFile, options);
          }
          function getActualIndentationForListItem(node, sourceFile, options, listIndentsChild) {
            if (node.parent && node.parent.kind === 255) {
              return -1;
            }
            var containingList = getContainingList(node, sourceFile);
            if (containingList) {
              var index = containingList.indexOf(node);
              if (index !== -1) {
                var result2 = deriveActualIndentationFromList(containingList, index, sourceFile, options);
                if (result2 !== -1) {
                  return result2;
                }
              }
              return getActualIndentationForListStartLine(containingList, sourceFile, options) + (listIndentsChild ? options.indentSize : 0);
            }
            return -1;
          }
          function deriveActualIndentationFromList(list, index, sourceFile, options) {
            ts3.Debug.assert(index >= 0 && index < list.length);
            var node = list[index];
            var lineAndCharacter = getStartLineAndCharacterForNode(node, sourceFile);
            for (var i = index - 1; i >= 0; i--) {
              if (list[i].kind === 27) {
                continue;
              }
              var prevEndLine = sourceFile.getLineAndCharacterOfPosition(list[i].end).line;
              if (prevEndLine !== lineAndCharacter.line) {
                return findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options);
              }
              lineAndCharacter = getStartLineAndCharacterForNode(list[i], sourceFile);
            }
            return -1;
          }
          function findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options) {
            var lineStart = sourceFile.getPositionOfLineAndCharacter(lineAndCharacter.line, 0);
            return findFirstNonWhitespaceColumn(lineStart, lineStart + lineAndCharacter.character, sourceFile, options);
          }
          function findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options) {
            var character = 0;
            var column = 0;
            for (var pos = startPos; pos < endPos; pos++) {
              var ch = sourceFile.text.charCodeAt(pos);
              if (!ts3.isWhiteSpaceSingleLine(ch)) {
                break;
              }
              if (ch === 9) {
                column += options.tabSize + column % options.tabSize;
              } else {
                column++;
              }
              character++;
            }
            return { column, character };
          }
          SmartIndenter2.findFirstNonWhitespaceCharacterAndColumn = findFirstNonWhitespaceCharacterAndColumn;
          function findFirstNonWhitespaceColumn(startPos, endPos, sourceFile, options) {
            return findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options).column;
          }
          SmartIndenter2.findFirstNonWhitespaceColumn = findFirstNonWhitespaceColumn;
          function nodeWillIndentChild(settings, parent, child, sourceFile, indentByDefault) {
            var childKind = child ? child.kind : 0;
            switch (parent.kind) {
              case 238:
              case 257:
              case 226:
              case 258:
              case 260:
              case 259:
              case 204:
              case 235:
              case 262:
              case 205:
              case 182:
              case 195:
              case 184:
              case 263:
              case 290:
              case 289:
              case 212:
              case 206:
              case 208:
              case 209:
              case 237:
              case 271:
              case 247:
              case 222:
              case 202:
              case 201:
              case 280:
              case 283:
              case 279:
              case 288:
              case 168:
              case 174:
              case 175:
              case 164:
              case 179:
              case 180:
              case 191:
              case 210:
              case 218:
              case 273:
              case 269:
              case 275:
              case 270:
              case 167:
                return true;
              case 254:
              case 296:
              case 221:
                if (!settings.indentMultiLineObjectLiteralBeginningOnBlankLine && sourceFile && childKind === 205) {
                  return rangeIsOnOneLine(sourceFile, child);
                }
                if (parent.kind === 221 && sourceFile && child && childKind === 278) {
                  var parentStartLine = sourceFile.getLineAndCharacterOfPosition(ts3.skipTrivia(sourceFile.text, parent.pos)).line;
                  var childStartLine = sourceFile.getLineAndCharacterOfPosition(ts3.skipTrivia(sourceFile.text, child.pos)).line;
                  return parentStartLine !== childStartLine;
                }
                if (parent.kind !== 221) {
                  return true;
                }
                break;
              case 240:
              case 241:
              case 243:
              case 244:
              case 242:
              case 239:
              case 256:
              case 213:
              case 169:
              case 171:
              case 172:
              case 173:
                return childKind !== 235;
              case 214:
                if (sourceFile && childKind === 212) {
                  return rangeIsOnOneLine(sourceFile, child);
                }
                return childKind !== 235;
              case 272:
                return childKind !== 273;
              case 266:
                return childKind !== 267 || !!child.namedBindings && child.namedBindings.kind !== 269;
              case 278:
                return childKind !== 281;
              case 282:
                return childKind !== 284;
              case 188:
              case 187:
                if (childKind === 182 || childKind === 184) {
                  return false;
                }
                break;
            }
            return indentByDefault;
          }
          SmartIndenter2.nodeWillIndentChild = nodeWillIndentChild;
          function isControlFlowEndingStatement(kind, parent) {
            switch (kind) {
              case 247:
              case 251:
              case 245:
              case 246:
                return parent.kind !== 235;
              default:
                return false;
            }
          }
          function shouldIndentChildNode(settings, parent, child, sourceFile, isNextChild) {
            if (isNextChild === void 0) {
              isNextChild = false;
            }
            return nodeWillIndentChild(settings, parent, child, sourceFile, false) && !(isNextChild && child && isControlFlowEndingStatement(child.kind, parent));
          }
          SmartIndenter2.shouldIndentChildNode = shouldIndentChildNode;
          function rangeIsOnOneLine(sourceFile, range) {
            var rangeStart = ts3.skipTrivia(sourceFile.text, range.pos);
            var startLine = sourceFile.getLineAndCharacterOfPosition(rangeStart).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
            return startLine === endLine;
          }
        })(SmartIndenter = formatting2.SmartIndenter || (formatting2.SmartIndenter = {}));
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var textChanges;
      (function(textChanges_3) {
        function getPos(n) {
          var result2 = n.__pos;
          ts3.Debug.assert(typeof result2 === "number");
          return result2;
        }
        function setPos(n, pos) {
          ts3.Debug.assert(typeof pos === "number");
          n.__pos = pos;
        }
        function getEnd(n) {
          var result2 = n.__end;
          ts3.Debug.assert(typeof result2 === "number");
          return result2;
        }
        function setEnd(n, end) {
          ts3.Debug.assert(typeof end === "number");
          n.__end = end;
        }
        var LeadingTriviaOption;
        (function(LeadingTriviaOption2) {
          LeadingTriviaOption2[LeadingTriviaOption2["Exclude"] = 0] = "Exclude";
          LeadingTriviaOption2[LeadingTriviaOption2["IncludeAll"] = 1] = "IncludeAll";
          LeadingTriviaOption2[LeadingTriviaOption2["JSDoc"] = 2] = "JSDoc";
          LeadingTriviaOption2[LeadingTriviaOption2["StartLine"] = 3] = "StartLine";
        })(LeadingTriviaOption = textChanges_3.LeadingTriviaOption || (textChanges_3.LeadingTriviaOption = {}));
        var TrailingTriviaOption;
        (function(TrailingTriviaOption2) {
          TrailingTriviaOption2[TrailingTriviaOption2["Exclude"] = 0] = "Exclude";
          TrailingTriviaOption2[TrailingTriviaOption2["ExcludeWhitespace"] = 1] = "ExcludeWhitespace";
          TrailingTriviaOption2[TrailingTriviaOption2["Include"] = 2] = "Include";
        })(TrailingTriviaOption = textChanges_3.TrailingTriviaOption || (textChanges_3.TrailingTriviaOption = {}));
        function skipWhitespacesAndLineBreaks(text, start) {
          return ts3.skipTrivia(text, start, false, true);
        }
        function hasCommentsBeforeLineBreak(text, start) {
          var i = start;
          while (i < text.length) {
            var ch = text.charCodeAt(i);
            if (ts3.isWhiteSpaceSingleLine(ch)) {
              i++;
              continue;
            }
            return ch === 47;
          }
          return false;
        }
        var useNonAdjustedPositions = {
          leadingTriviaOption: LeadingTriviaOption.Exclude,
          trailingTriviaOption: TrailingTriviaOption.Exclude
        };
        var ChangeKind;
        (function(ChangeKind2) {
          ChangeKind2[ChangeKind2["Remove"] = 0] = "Remove";
          ChangeKind2[ChangeKind2["ReplaceWithSingleNode"] = 1] = "ReplaceWithSingleNode";
          ChangeKind2[ChangeKind2["ReplaceWithMultipleNodes"] = 2] = "ReplaceWithMultipleNodes";
          ChangeKind2[ChangeKind2["Text"] = 3] = "Text";
        })(ChangeKind || (ChangeKind = {}));
        function getAdjustedRange(sourceFile, startNode, endNode, options) {
          return { pos: getAdjustedStartPosition(sourceFile, startNode, options), end: getAdjustedEndPosition(sourceFile, endNode, options) };
        }
        function getAdjustedStartPosition(sourceFile, node, options, hasTrailingComment) {
          var _a, _b;
          if (hasTrailingComment === void 0) {
            hasTrailingComment = false;
          }
          var leadingTriviaOption = options.leadingTriviaOption;
          if (leadingTriviaOption === LeadingTriviaOption.Exclude) {
            return node.getStart(sourceFile);
          }
          if (leadingTriviaOption === LeadingTriviaOption.StartLine) {
            var startPos = node.getStart(sourceFile);
            var pos = ts3.getLineStartPositionForPosition(startPos, sourceFile);
            return ts3.rangeContainsPosition(node, pos) ? pos : startPos;
          }
          if (leadingTriviaOption === LeadingTriviaOption.JSDoc) {
            var JSDocComments = ts3.getJSDocCommentRanges(node, sourceFile.text);
            if (JSDocComments === null || JSDocComments === void 0 ? void 0 : JSDocComments.length) {
              return ts3.getLineStartPositionForPosition(JSDocComments[0].pos, sourceFile);
            }
          }
          var fullStart = node.getFullStart();
          var start = node.getStart(sourceFile);
          if (fullStart === start) {
            return start;
          }
          var fullStartLine = ts3.getLineStartPositionForPosition(fullStart, sourceFile);
          var startLine = ts3.getLineStartPositionForPosition(start, sourceFile);
          if (startLine === fullStartLine) {
            return leadingTriviaOption === LeadingTriviaOption.IncludeAll ? fullStart : start;
          }
          if (hasTrailingComment) {
            var comment = ((_a = ts3.getLeadingCommentRanges(sourceFile.text, fullStart)) === null || _a === void 0 ? void 0 : _a[0]) || ((_b = ts3.getTrailingCommentRanges(sourceFile.text, fullStart)) === null || _b === void 0 ? void 0 : _b[0]);
            if (comment) {
              return ts3.skipTrivia(sourceFile.text, comment.end, true, true);
            }
          }
          var nextLineStart = fullStart > 0 ? 1 : 0;
          var adjustedStartPosition = ts3.getStartPositionOfLine(ts3.getLineOfLocalPosition(sourceFile, fullStartLine) + nextLineStart, sourceFile);
          adjustedStartPosition = skipWhitespacesAndLineBreaks(sourceFile.text, adjustedStartPosition);
          return ts3.getStartPositionOfLine(ts3.getLineOfLocalPosition(sourceFile, adjustedStartPosition), sourceFile);
        }
        function getEndPositionOfMultilineTrailingComment(sourceFile, node, options) {
          var end = node.end;
          var trailingTriviaOption = options.trailingTriviaOption;
          if (trailingTriviaOption === TrailingTriviaOption.Include) {
            var comments = ts3.getTrailingCommentRanges(sourceFile.text, end);
            if (comments) {
              var nodeEndLine = ts3.getLineOfLocalPosition(sourceFile, node.end);
              for (var _i = 0, comments_2 = comments; _i < comments_2.length; _i++) {
                var comment = comments_2[_i];
                if (comment.kind === 2 || ts3.getLineOfLocalPosition(sourceFile, comment.pos) > nodeEndLine) {
                  break;
                }
                var commentEndLine = ts3.getLineOfLocalPosition(sourceFile, comment.end);
                if (commentEndLine > nodeEndLine) {
                  return ts3.skipTrivia(sourceFile.text, comment.end, true, true);
                }
              }
            }
          }
          return void 0;
        }
        function getAdjustedEndPosition(sourceFile, node, options) {
          var _a;
          var end = node.end;
          var trailingTriviaOption = options.trailingTriviaOption;
          if (trailingTriviaOption === TrailingTriviaOption.Exclude) {
            return end;
          }
          if (trailingTriviaOption === TrailingTriviaOption.ExcludeWhitespace) {
            var comments = ts3.concatenate(ts3.getTrailingCommentRanges(sourceFile.text, end), ts3.getLeadingCommentRanges(sourceFile.text, end));
            var realEnd = (_a = comments === null || comments === void 0 ? void 0 : comments[comments.length - 1]) === null || _a === void 0 ? void 0 : _a.end;
            if (realEnd) {
              return realEnd;
            }
            return end;
          }
          var multilineEndPosition = getEndPositionOfMultilineTrailingComment(sourceFile, node, options);
          if (multilineEndPosition) {
            return multilineEndPosition;
          }
          var newEnd = ts3.skipTrivia(sourceFile.text, end, true);
          return newEnd !== end && (trailingTriviaOption === TrailingTriviaOption.Include || ts3.isLineBreak(sourceFile.text.charCodeAt(newEnd - 1))) ? newEnd : end;
        }
        function isSeparator(node, candidate) {
          return !!candidate && !!node.parent && (candidate.kind === 27 || candidate.kind === 26 && node.parent.kind === 205);
        }
        function isThisTypeAnnotatable(containingFunction) {
          return ts3.isFunctionExpression(containingFunction) || ts3.isFunctionDeclaration(containingFunction);
        }
        textChanges_3.isThisTypeAnnotatable = isThisTypeAnnotatable;
        var ChangeTracker = function() {
          function ChangeTracker2(newLineCharacter, formatContext) {
            this.newLineCharacter = newLineCharacter;
            this.formatContext = formatContext;
            this.changes = [];
            this.newFiles = [];
            this.classesWithNodesInsertedAtStart = new ts3.Map();
            this.deletedNodes = [];
          }
          ChangeTracker2.fromContext = function(context) {
            return new ChangeTracker2(ts3.getNewLineOrDefaultFromHost(context.host, context.formatContext.options), context.formatContext);
          };
          ChangeTracker2.with = function(context, cb) {
            var tracker = ChangeTracker2.fromContext(context);
            cb(tracker);
            return tracker.getChanges();
          };
          ChangeTracker2.prototype.pushRaw = function(sourceFile, change) {
            ts3.Debug.assertEqual(sourceFile.fileName, change.fileName);
            for (var _i = 0, _a = change.textChanges; _i < _a.length; _i++) {
              var c = _a[_i];
              this.changes.push({
                kind: ChangeKind.Text,
                sourceFile,
                text: c.newText,
                range: ts3.createTextRangeFromSpan(c.span)
              });
            }
          };
          ChangeTracker2.prototype.deleteRange = function(sourceFile, range) {
            this.changes.push({ kind: ChangeKind.Remove, sourceFile, range });
          };
          ChangeTracker2.prototype.delete = function(sourceFile, node) {
            this.deletedNodes.push({ sourceFile, node });
          };
          ChangeTracker2.prototype.deleteNode = function(sourceFile, node, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            this.deleteRange(sourceFile, getAdjustedRange(sourceFile, node, node, options));
          };
          ChangeTracker2.prototype.deleteNodes = function(sourceFile, nodes, options, hasTrailingComment) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
              var node = nodes_1[_i];
              var pos = getAdjustedStartPosition(sourceFile, node, options, hasTrailingComment);
              var end = getAdjustedEndPosition(sourceFile, node, options);
              this.deleteRange(sourceFile, { pos, end });
              hasTrailingComment = !!getEndPositionOfMultilineTrailingComment(sourceFile, node, options);
            }
          };
          ChangeTracker2.prototype.deleteModifier = function(sourceFile, modifier) {
            this.deleteRange(sourceFile, { pos: modifier.getStart(sourceFile), end: ts3.skipTrivia(sourceFile.text, modifier.end, true) });
          };
          ChangeTracker2.prototype.deleteNodeRange = function(sourceFile, startNode, endNode, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            var startPosition = getAdjustedStartPosition(sourceFile, startNode, options);
            var endPosition = getAdjustedEndPosition(sourceFile, endNode, options);
            this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
          };
          ChangeTracker2.prototype.deleteNodeRangeExcludingEnd = function(sourceFile, startNode, afterEndNode, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            var startPosition = getAdjustedStartPosition(sourceFile, startNode, options);
            var endPosition = afterEndNode === void 0 ? sourceFile.text.length : getAdjustedStartPosition(sourceFile, afterEndNode, options);
            this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
          };
          ChangeTracker2.prototype.replaceRange = function(sourceFile, range, newNode, options) {
            if (options === void 0) {
              options = {};
            }
            this.changes.push({ kind: ChangeKind.ReplaceWithSingleNode, sourceFile, range, options, node: newNode });
          };
          ChangeTracker2.prototype.replaceNode = function(sourceFile, oldNode, newNode, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRange(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNode, options);
          };
          ChangeTracker2.prototype.replaceNodeRange = function(sourceFile, startNode, endNode, newNode, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRange(sourceFile, getAdjustedRange(sourceFile, startNode, endNode, options), newNode, options);
          };
          ChangeTracker2.prototype.replaceRangeWithNodes = function(sourceFile, range, newNodes, options) {
            if (options === void 0) {
              options = {};
            }
            this.changes.push({ kind: ChangeKind.ReplaceWithMultipleNodes, sourceFile, range, options, nodes: newNodes });
          };
          ChangeTracker2.prototype.replaceNodeWithNodes = function(sourceFile, oldNode, newNodes, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNodes, options);
          };
          ChangeTracker2.prototype.replaceNodeWithText = function(sourceFile, oldNode, text) {
            this.replaceRangeWithText(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, useNonAdjustedPositions), text);
          };
          ChangeTracker2.prototype.replaceNodeRangeWithNodes = function(sourceFile, startNode, endNode, newNodes, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, startNode, endNode, options), newNodes, options);
          };
          ChangeTracker2.prototype.nodeHasTrailingComment = function(sourceFile, oldNode, configurableEnd) {
            if (configurableEnd === void 0) {
              configurableEnd = useNonAdjustedPositions;
            }
            return !!getEndPositionOfMultilineTrailingComment(sourceFile, oldNode, configurableEnd);
          };
          ChangeTracker2.prototype.nextCommaToken = function(sourceFile, node) {
            var next = ts3.findNextToken(node, node.parent, sourceFile);
            return next && next.kind === 27 ? next : void 0;
          };
          ChangeTracker2.prototype.replacePropertyAssignment = function(sourceFile, oldNode, newNode) {
            var suffix = this.nextCommaToken(sourceFile, oldNode) ? "" : "," + this.newLineCharacter;
            this.replaceNode(sourceFile, oldNode, newNode, { suffix });
          };
          ChangeTracker2.prototype.insertNodeAt = function(sourceFile, pos, newNode, options) {
            if (options === void 0) {
              options = {};
            }
            this.replaceRange(sourceFile, ts3.createRange(pos), newNode, options);
          };
          ChangeTracker2.prototype.insertNodesAt = function(sourceFile, pos, newNodes, options) {
            if (options === void 0) {
              options = {};
            }
            this.replaceRangeWithNodes(sourceFile, ts3.createRange(pos), newNodes, options);
          };
          ChangeTracker2.prototype.insertNodeAtTopOfFile = function(sourceFile, newNode, blankLineBetween) {
            this.insertAtTopOfFile(sourceFile, newNode, blankLineBetween);
          };
          ChangeTracker2.prototype.insertNodesAtTopOfFile = function(sourceFile, newNodes, blankLineBetween) {
            this.insertAtTopOfFile(sourceFile, newNodes, blankLineBetween);
          };
          ChangeTracker2.prototype.insertAtTopOfFile = function(sourceFile, insert, blankLineBetween) {
            var pos = getInsertionPositionAtSourceFileTop(sourceFile);
            var options = {
              prefix: pos === 0 ? void 0 : this.newLineCharacter,
              suffix: (ts3.isLineBreak(sourceFile.text.charCodeAt(pos)) ? "" : this.newLineCharacter) + (blankLineBetween ? this.newLineCharacter : "")
            };
            if (ts3.isArray(insert)) {
              this.insertNodesAt(sourceFile, pos, insert, options);
            } else {
              this.insertNodeAt(sourceFile, pos, insert, options);
            }
          };
          ChangeTracker2.prototype.insertFirstParameter = function(sourceFile, parameters, newParam) {
            var p0 = ts3.firstOrUndefined(parameters);
            if (p0) {
              this.insertNodeBefore(sourceFile, p0, newParam);
            } else {
              this.insertNodeAt(sourceFile, parameters.pos, newParam);
            }
          };
          ChangeTracker2.prototype.insertNodeBefore = function(sourceFile, before, newNode, blankLineBetween, options) {
            if (blankLineBetween === void 0) {
              blankLineBetween = false;
            }
            if (options === void 0) {
              options = {};
            }
            this.insertNodeAt(sourceFile, getAdjustedStartPosition(sourceFile, before, options), newNode, this.getOptionsForInsertNodeBefore(before, newNode, blankLineBetween));
          };
          ChangeTracker2.prototype.insertModifierAt = function(sourceFile, pos, modifier, options) {
            if (options === void 0) {
              options = {};
            }
            this.insertNodeAt(sourceFile, pos, ts3.factory.createToken(modifier), options);
          };
          ChangeTracker2.prototype.insertModifierBefore = function(sourceFile, modifier, before) {
            return this.insertModifierAt(sourceFile, before.getStart(sourceFile), modifier, { suffix: " " });
          };
          ChangeTracker2.prototype.insertCommentBeforeLine = function(sourceFile, lineNumber, position, commentText) {
            var lineStartPosition = ts3.getStartPositionOfLine(lineNumber, sourceFile);
            var startPosition = ts3.getFirstNonSpaceCharacterPosition(sourceFile.text, lineStartPosition);
            var insertAtLineStart = isValidLocationToAddComment(sourceFile, startPosition);
            var token = ts3.getTouchingToken(sourceFile, insertAtLineStart ? startPosition : position);
            var indent = sourceFile.text.slice(lineStartPosition, startPosition);
            var text = "".concat(insertAtLineStart ? "" : this.newLineCharacter, "//").concat(commentText).concat(this.newLineCharacter).concat(indent);
            this.insertText(sourceFile, token.getStart(sourceFile), text);
          };
          ChangeTracker2.prototype.insertJsdocCommentBefore = function(sourceFile, node, tag) {
            var fnStart = node.getStart(sourceFile);
            if (node.jsDoc) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var jsdoc = _a[_i];
                this.deleteRange(sourceFile, {
                  pos: ts3.getLineStartPositionForPosition(jsdoc.getStart(sourceFile), sourceFile),
                  end: getAdjustedEndPosition(sourceFile, jsdoc, {})
                });
              }
            }
            var startPosition = ts3.getPrecedingNonSpaceCharacterPosition(sourceFile.text, fnStart - 1);
            var indent = sourceFile.text.slice(startPosition, fnStart);
            this.insertNodeAt(sourceFile, fnStart, tag, { suffix: this.newLineCharacter + indent });
          };
          ChangeTracker2.prototype.createJSDocText = function(sourceFile, node) {
            var comments = ts3.flatMap(node.jsDoc, function(jsDoc2) {
              return ts3.isString(jsDoc2.comment) ? ts3.factory.createJSDocText(jsDoc2.comment) : jsDoc2.comment;
            });
            var jsDoc = ts3.singleOrUndefined(node.jsDoc);
            return jsDoc && ts3.positionsAreOnSameLine(jsDoc.pos, jsDoc.end, sourceFile) && ts3.length(comments) === 0 ? void 0 : ts3.factory.createNodeArray(ts3.intersperse(comments, ts3.factory.createJSDocText("\n")));
          };
          ChangeTracker2.prototype.replaceJSDocComment = function(sourceFile, node, tags) {
            this.insertJsdocCommentBefore(sourceFile, updateJSDocHost(node), ts3.factory.createJSDocComment(this.createJSDocText(sourceFile, node), ts3.factory.createNodeArray(tags)));
          };
          ChangeTracker2.prototype.addJSDocTags = function(sourceFile, parent, newTags) {
            var oldTags = ts3.flatMapToMutable(parent.jsDoc, function(j) {
              return j.tags;
            });
            var unmergedNewTags = newTags.filter(function(newTag) {
              return !oldTags.some(function(tag, i) {
                var merged = tryMergeJsdocTags(tag, newTag);
                if (merged)
                  oldTags[i] = merged;
                return !!merged;
              });
            });
            this.replaceJSDocComment(sourceFile, parent, __spreadArray(__spreadArray([], oldTags, true), unmergedNewTags, true));
          };
          ChangeTracker2.prototype.filterJSDocTags = function(sourceFile, parent, predicate) {
            this.replaceJSDocComment(sourceFile, parent, ts3.filter(ts3.flatMapToMutable(parent.jsDoc, function(j) {
              return j.tags;
            }), predicate));
          };
          ChangeTracker2.prototype.replaceRangeWithText = function(sourceFile, range, text) {
            this.changes.push({ kind: ChangeKind.Text, sourceFile, range, text });
          };
          ChangeTracker2.prototype.insertText = function(sourceFile, pos, text) {
            this.replaceRangeWithText(sourceFile, ts3.createRange(pos), text);
          };
          ChangeTracker2.prototype.tryInsertTypeAnnotation = function(sourceFile, node, type2) {
            var _a;
            var endNode;
            if (ts3.isFunctionLike(node)) {
              endNode = ts3.findChildOfKind(node, 21, sourceFile);
              if (!endNode) {
                if (!ts3.isArrowFunction(node))
                  return false;
                endNode = ts3.first(node.parameters);
              }
            } else {
              endNode = (_a = node.kind === 254 ? node.exclamationToken : node.questionToken) !== null && _a !== void 0 ? _a : node.name;
            }
            this.insertNodeAt(sourceFile, endNode.end, type2, { prefix: ": " });
            return true;
          };
          ChangeTracker2.prototype.tryInsertThisTypeAnnotation = function(sourceFile, node, type2) {
            var start = ts3.findChildOfKind(node, 20, sourceFile).getStart(sourceFile) + 1;
            var suffix = node.parameters.length ? ", " : "";
            this.insertNodeAt(sourceFile, start, type2, { prefix: "this: ", suffix });
          };
          ChangeTracker2.prototype.insertTypeParameters = function(sourceFile, node, typeParameters) {
            var start = (ts3.findChildOfKind(node, 20, sourceFile) || ts3.first(node.parameters)).getStart(sourceFile);
            this.insertNodesAt(sourceFile, start, typeParameters, { prefix: "<", suffix: ">", joiner: ", " });
          };
          ChangeTracker2.prototype.getOptionsForInsertNodeBefore = function(before, inserted, blankLineBetween) {
            if (ts3.isStatement(before) || ts3.isClassElement(before)) {
              return { suffix: blankLineBetween ? this.newLineCharacter + this.newLineCharacter : this.newLineCharacter };
            } else if (ts3.isVariableDeclaration(before)) {
              return { suffix: ", " };
            } else if (ts3.isParameter(before)) {
              return ts3.isParameter(inserted) ? { suffix: ", " } : {};
            } else if (ts3.isStringLiteral(before) && ts3.isImportDeclaration(before.parent) || ts3.isNamedImports(before)) {
              return { suffix: ", " };
            } else if (ts3.isImportSpecifier(before)) {
              return { suffix: "," + (blankLineBetween ? this.newLineCharacter : " ") };
            }
            return ts3.Debug.failBadSyntaxKind(before);
          };
          ChangeTracker2.prototype.insertNodeAtConstructorStart = function(sourceFile, ctr, newStatement) {
            var firstStatement = ts3.firstOrUndefined(ctr.body.statements);
            if (!firstStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArray([newStatement], ctr.body.statements, true));
            } else {
              this.insertNodeBefore(sourceFile, firstStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.insertNodeAtConstructorStartAfterSuperCall = function(sourceFile, ctr, newStatement) {
            var superCallStatement = ts3.find(ctr.body.statements, function(stmt) {
              return ts3.isExpressionStatement(stmt) && ts3.isSuperCall(stmt.expression);
            });
            if (!superCallStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArray(__spreadArray([], ctr.body.statements, true), [newStatement], false));
            } else {
              this.insertNodeAfter(sourceFile, superCallStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.insertNodeAtConstructorEnd = function(sourceFile, ctr, newStatement) {
            var lastStatement = ts3.lastOrUndefined(ctr.body.statements);
            if (!lastStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArray(__spreadArray([], ctr.body.statements, true), [newStatement], false));
            } else {
              this.insertNodeAfter(sourceFile, lastStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.replaceConstructorBody = function(sourceFile, ctr, statements) {
            this.replaceNode(sourceFile, ctr.body, ts3.factory.createBlock(statements, true));
          };
          ChangeTracker2.prototype.insertNodeAtEndOfScope = function(sourceFile, scope, newNode) {
            var pos = getAdjustedStartPosition(sourceFile, scope.getLastToken(), {});
            this.insertNodeAt(sourceFile, pos, newNode, {
              prefix: ts3.isLineBreak(sourceFile.text.charCodeAt(scope.getLastToken().pos)) ? this.newLineCharacter : this.newLineCharacter + this.newLineCharacter,
              suffix: this.newLineCharacter
            });
          };
          ChangeTracker2.prototype.insertMemberAtStart = function(sourceFile, node, newElement) {
            this.insertNodeAtStartWorker(sourceFile, node, newElement);
          };
          ChangeTracker2.prototype.insertNodeAtObjectStart = function(sourceFile, obj, newElement) {
            this.insertNodeAtStartWorker(sourceFile, obj, newElement);
          };
          ChangeTracker2.prototype.insertNodeAtStartWorker = function(sourceFile, node, newElement) {
            var _a;
            var indentation = (_a = this.guessIndentationFromExistingMembers(sourceFile, node)) !== null && _a !== void 0 ? _a : this.computeIndentationForNewMember(sourceFile, node);
            this.insertNodeAt(sourceFile, getMembersOrProperties(node).pos, newElement, this.getInsertNodeAtStartInsertOptions(sourceFile, node, indentation));
          };
          ChangeTracker2.prototype.guessIndentationFromExistingMembers = function(sourceFile, node) {
            var indentation;
            var lastRange = node;
            for (var _i = 0, _a = getMembersOrProperties(node); _i < _a.length; _i++) {
              var member = _a[_i];
              if (ts3.rangeStartPositionsAreOnSameLine(lastRange, member, sourceFile)) {
                return void 0;
              }
              var memberStart = member.getStart(sourceFile);
              var memberIndentation = ts3.formatting.SmartIndenter.findFirstNonWhitespaceColumn(ts3.getLineStartPositionForPosition(memberStart, sourceFile), memberStart, sourceFile, this.formatContext.options);
              if (indentation === void 0) {
                indentation = memberIndentation;
              } else if (memberIndentation !== indentation) {
                return void 0;
              }
              lastRange = member;
            }
            return indentation;
          };
          ChangeTracker2.prototype.computeIndentationForNewMember = function(sourceFile, node) {
            var _a;
            var nodeStart = node.getStart(sourceFile);
            return ts3.formatting.SmartIndenter.findFirstNonWhitespaceColumn(ts3.getLineStartPositionForPosition(nodeStart, sourceFile), nodeStart, sourceFile, this.formatContext.options) + ((_a = this.formatContext.options.indentSize) !== null && _a !== void 0 ? _a : 4);
          };
          ChangeTracker2.prototype.getInsertNodeAtStartInsertOptions = function(sourceFile, node, indentation) {
            var members = getMembersOrProperties(node);
            var isEmpty = members.length === 0;
            var isFirstInsertion = ts3.addToSeen(this.classesWithNodesInsertedAtStart, ts3.getNodeId(node), { node, sourceFile });
            var insertTrailingComma = ts3.isObjectLiteralExpression(node) && (!ts3.isJsonSourceFile(sourceFile) || !isEmpty);
            var insertLeadingComma = ts3.isObjectLiteralExpression(node) && ts3.isJsonSourceFile(sourceFile) && isEmpty && !isFirstInsertion;
            return {
              indentation,
              prefix: (insertLeadingComma ? "," : "") + this.newLineCharacter,
              suffix: insertTrailingComma ? "," : ""
            };
          };
          ChangeTracker2.prototype.insertNodeAfterComma = function(sourceFile, after, newNode) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, this.nextCommaToken(sourceFile, after) || after, newNode);
            this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAfter = function(sourceFile, after, newNode) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, after, newNode);
            this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAtEndOfList = function(sourceFile, list, newNode) {
            this.insertNodeAt(sourceFile, list.end, newNode, { prefix: ", " });
          };
          ChangeTracker2.prototype.insertNodesAfter = function(sourceFile, after, newNodes) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, after, ts3.first(newNodes));
            this.insertNodesAt(sourceFile, endPosition, newNodes, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAfterWorker = function(sourceFile, after, newNode) {
            if (needSemicolonBetween(after, newNode)) {
              if (sourceFile.text.charCodeAt(after.end - 1) !== 59) {
                this.replaceRange(sourceFile, ts3.createRange(after.end), ts3.factory.createToken(26));
              }
            }
            var endPosition = getAdjustedEndPosition(sourceFile, after, {});
            return endPosition;
          };
          ChangeTracker2.prototype.getInsertNodeAfterOptions = function(sourceFile, after) {
            var options = this.getInsertNodeAfterOptionsWorker(after);
            return __assign(__assign({}, options), { prefix: after.end === sourceFile.end && ts3.isStatement(after) ? options.prefix ? "\n".concat(options.prefix) : "\n" : options.prefix });
          };
          ChangeTracker2.prototype.getInsertNodeAfterOptionsWorker = function(node) {
            switch (node.kind) {
              case 257:
              case 261:
                return { prefix: this.newLineCharacter, suffix: this.newLineCharacter };
              case 254:
              case 10:
              case 79:
                return { prefix: ", " };
              case 296:
                return { suffix: "," + this.newLineCharacter };
              case 93:
                return { prefix: " " };
              case 164:
                return {};
              default:
                ts3.Debug.assert(ts3.isStatement(node) || ts3.isClassOrTypeElement(node));
                return { suffix: this.newLineCharacter };
            }
          };
          ChangeTracker2.prototype.insertName = function(sourceFile, node, name) {
            ts3.Debug.assert(!node.name);
            if (node.kind === 214) {
              var arrow = ts3.findChildOfKind(node, 38, sourceFile);
              var lparen = ts3.findChildOfKind(node, 20, sourceFile);
              if (lparen) {
                this.insertNodesAt(sourceFile, lparen.getStart(sourceFile), [ts3.factory.createToken(98), ts3.factory.createIdentifier(name)], { joiner: " " });
                deleteNode(this, sourceFile, arrow);
              } else {
                this.insertText(sourceFile, ts3.first(node.parameters).getStart(sourceFile), "function ".concat(name, "("));
                this.replaceRange(sourceFile, arrow, ts3.factory.createToken(21));
              }
              if (node.body.kind !== 235) {
                this.insertNodesAt(sourceFile, node.body.getStart(sourceFile), [ts3.factory.createToken(18), ts3.factory.createToken(105)], { joiner: " ", suffix: " " });
                this.insertNodesAt(sourceFile, node.body.end, [ts3.factory.createToken(26), ts3.factory.createToken(19)], { joiner: " " });
              }
            } else {
              var pos = ts3.findChildOfKind(node, node.kind === 213 ? 98 : 84, sourceFile).end;
              this.insertNodeAt(sourceFile, pos, ts3.factory.createIdentifier(name), { prefix: " " });
            }
          };
          ChangeTracker2.prototype.insertExportModifier = function(sourceFile, node) {
            this.insertText(sourceFile, node.getStart(sourceFile), "export ");
          };
          ChangeTracker2.prototype.insertImportSpecifierAtIndex = function(sourceFile, importSpecifier, namedImports, index) {
            var prevSpecifier = namedImports.elements[index - 1];
            if (prevSpecifier) {
              this.insertNodeInListAfter(sourceFile, prevSpecifier, importSpecifier);
            } else {
              this.insertNodeBefore(sourceFile, namedImports.elements[0], importSpecifier, !ts3.positionsAreOnSameLine(namedImports.elements[0].getStart(), namedImports.parent.parent.getStart(), sourceFile));
            }
          };
          ChangeTracker2.prototype.insertNodeInListAfter = function(sourceFile, after, newNode, containingList) {
            if (containingList === void 0) {
              containingList = ts3.formatting.SmartIndenter.getContainingList(after, sourceFile);
            }
            if (!containingList) {
              ts3.Debug.fail("node is not a list element");
              return;
            }
            var index = ts3.indexOfNode(containingList, after);
            if (index < 0) {
              return;
            }
            var end = after.getEnd();
            if (index !== containingList.length - 1) {
              var nextToken = ts3.getTokenAtPosition(sourceFile, after.end);
              if (nextToken && isSeparator(after, nextToken)) {
                var nextNode = containingList[index + 1];
                var startPos = skipWhitespacesAndLineBreaks(sourceFile.text, nextNode.getFullStart());
                var suffix = "".concat(ts3.tokenToString(nextToken.kind)).concat(sourceFile.text.substring(nextToken.end, startPos));
                this.insertNodesAt(sourceFile, startPos, [newNode], { suffix });
              }
            } else {
              var afterStart = after.getStart(sourceFile);
              var afterStartLinePosition = ts3.getLineStartPositionForPosition(afterStart, sourceFile);
              var separator = void 0;
              var multilineList = false;
              if (containingList.length === 1) {
                separator = 27;
              } else {
                var tokenBeforeInsertPosition = ts3.findPrecedingToken(after.pos, sourceFile);
                separator = isSeparator(after, tokenBeforeInsertPosition) ? tokenBeforeInsertPosition.kind : 27;
                var afterMinusOneStartLinePosition = ts3.getLineStartPositionForPosition(containingList[index - 1].getStart(sourceFile), sourceFile);
                multilineList = afterMinusOneStartLinePosition !== afterStartLinePosition;
              }
              if (hasCommentsBeforeLineBreak(sourceFile.text, after.end)) {
                multilineList = true;
              }
              if (multilineList) {
                this.replaceRange(sourceFile, ts3.createRange(end), ts3.factory.createToken(separator));
                var indentation = ts3.formatting.SmartIndenter.findFirstNonWhitespaceColumn(afterStartLinePosition, afterStart, sourceFile, this.formatContext.options);
                var insertPos = ts3.skipTrivia(sourceFile.text, end, true, false);
                while (insertPos !== end && ts3.isLineBreak(sourceFile.text.charCodeAt(insertPos - 1))) {
                  insertPos--;
                }
                this.replaceRange(sourceFile, ts3.createRange(insertPos), newNode, { indentation, prefix: this.newLineCharacter });
              } else {
                this.replaceRange(sourceFile, ts3.createRange(end), newNode, { prefix: "".concat(ts3.tokenToString(separator), " ") });
              }
            }
          };
          ChangeTracker2.prototype.parenthesizeExpression = function(sourceFile, expression) {
            this.replaceRange(sourceFile, ts3.rangeOfNode(expression), ts3.factory.createParenthesizedExpression(expression));
          };
          ChangeTracker2.prototype.finishClassesWithNodesInsertedAtStart = function() {
            var _this = this;
            this.classesWithNodesInsertedAtStart.forEach(function(_a) {
              var node = _a.node, sourceFile = _a.sourceFile;
              var _b = getClassOrObjectBraceEnds(node, sourceFile), openBraceEnd = _b[0], closeBraceEnd = _b[1];
              if (openBraceEnd !== void 0 && closeBraceEnd !== void 0) {
                var isEmpty = getMembersOrProperties(node).length === 0;
                var isSingleLine = ts3.positionsAreOnSameLine(openBraceEnd, closeBraceEnd, sourceFile);
                if (isEmpty && isSingleLine && openBraceEnd !== closeBraceEnd - 1) {
                  _this.deleteRange(sourceFile, ts3.createRange(openBraceEnd, closeBraceEnd - 1));
                }
                if (isSingleLine) {
                  _this.insertText(sourceFile, closeBraceEnd - 1, _this.newLineCharacter);
                }
              }
            });
          };
          ChangeTracker2.prototype.finishDeleteDeclarations = function() {
            var _this = this;
            var deletedNodesInLists = new ts3.Set();
            var _loop_11 = function(sourceFile2, node2) {
              if (!this_1.deletedNodes.some(function(d) {
                return d.sourceFile === sourceFile2 && ts3.rangeContainsRangeExclusive(d.node, node2);
              })) {
                if (ts3.isArray(node2)) {
                  this_1.deleteRange(sourceFile2, ts3.rangeOfTypeParameters(sourceFile2, node2));
                } else {
                  deleteDeclaration.deleteDeclaration(this_1, deletedNodesInLists, sourceFile2, node2);
                }
              }
            };
            var this_1 = this;
            for (var _i = 0, _a = this.deletedNodes; _i < _a.length; _i++) {
              var _b = _a[_i], sourceFile = _b.sourceFile, node = _b.node;
              _loop_11(sourceFile, node);
            }
            deletedNodesInLists.forEach(function(node2) {
              var sourceFile2 = node2.getSourceFile();
              var list = ts3.formatting.SmartIndenter.getContainingList(node2, sourceFile2);
              if (node2 !== ts3.last(list))
                return;
              var lastNonDeletedIndex = ts3.findLastIndex(list, function(n) {
                return !deletedNodesInLists.has(n);
              }, list.length - 2);
              if (lastNonDeletedIndex !== -1) {
                _this.deleteRange(sourceFile2, { pos: list[lastNonDeletedIndex].end, end: startPositionToDeleteNodeInList(sourceFile2, list[lastNonDeletedIndex + 1]) });
              }
            });
          };
          ChangeTracker2.prototype.getChanges = function(validate) {
            this.finishDeleteDeclarations();
            this.finishClassesWithNodesInsertedAtStart();
            var changes = changesToText.getTextChangesFromChanges(this.changes, this.newLineCharacter, this.formatContext, validate);
            for (var _i = 0, _a = this.newFiles; _i < _a.length; _i++) {
              var _b = _a[_i], oldFile = _b.oldFile, fileName2 = _b.fileName, statements = _b.statements;
              changes.push(changesToText.newFileChanges(oldFile, fileName2, statements, this.newLineCharacter, this.formatContext));
            }
            return changes;
          };
          ChangeTracker2.prototype.createNewFile = function(oldFile, fileName2, statements) {
            this.newFiles.push({ oldFile, fileName: fileName2, statements });
          };
          return ChangeTracker2;
        }();
        textChanges_3.ChangeTracker = ChangeTracker;
        function updateJSDocHost(parent) {
          if (parent.kind !== 214) {
            return parent;
          }
          var jsDocNode = parent.parent.kind === 167 ? parent.parent : parent.parent.parent;
          jsDocNode.jsDoc = parent.jsDoc;
          jsDocNode.jsDocCache = parent.jsDocCache;
          return jsDocNode;
        }
        function tryMergeJsdocTags(oldTag, newTag) {
          if (oldTag.kind !== newTag.kind) {
            return void 0;
          }
          switch (oldTag.kind) {
            case 340: {
              var oldParam = oldTag;
              var newParam = newTag;
              return ts3.isIdentifier(oldParam.name) && ts3.isIdentifier(newParam.name) && oldParam.name.escapedText === newParam.name.escapedText ? ts3.factory.createJSDocParameterTag(void 0, newParam.name, false, newParam.typeExpression, newParam.isNameFirst, oldParam.comment) : void 0;
            }
            case 341:
              return ts3.factory.createJSDocReturnTag(void 0, newTag.typeExpression, oldTag.comment);
            case 343:
              return ts3.factory.createJSDocTypeTag(void 0, newTag.typeExpression, oldTag.comment);
          }
        }
        function startPositionToDeleteNodeInList(sourceFile, node) {
          return ts3.skipTrivia(sourceFile.text, getAdjustedStartPosition(sourceFile, node, { leadingTriviaOption: LeadingTriviaOption.IncludeAll }), false, true);
        }
        function getClassOrObjectBraceEnds(cls, sourceFile) {
          var open = ts3.findChildOfKind(cls, 18, sourceFile);
          var close = ts3.findChildOfKind(cls, 19, sourceFile);
          return [open === null || open === void 0 ? void 0 : open.end, close === null || close === void 0 ? void 0 : close.end];
        }
        function getMembersOrProperties(node) {
          return ts3.isObjectLiteralExpression(node) ? node.properties : node.members;
        }
        function getNewFileText(statements, scriptKind, newLineCharacter, formatContext) {
          return changesToText.newFileChangesWorker(void 0, scriptKind, statements, newLineCharacter, formatContext);
        }
        textChanges_3.getNewFileText = getNewFileText;
        var changesToText;
        (function(changesToText2) {
          function getTextChangesFromChanges(changes, newLineCharacter, formatContext, validate) {
            return ts3.mapDefined(ts3.group(changes, function(c) {
              return c.sourceFile.path;
            }), function(changesInFile) {
              var sourceFile = changesInFile[0].sourceFile;
              var normalized = ts3.stableSort(changesInFile, function(a, b) {
                return a.range.pos - b.range.pos || a.range.end - b.range.end;
              });
              var _loop_12 = function(i2) {
                ts3.Debug.assert(normalized[i2].range.end <= normalized[i2 + 1].range.pos, "Changes overlap", function() {
                  return "".concat(JSON.stringify(normalized[i2].range), " and ").concat(JSON.stringify(normalized[i2 + 1].range));
                });
              };
              for (var i = 0; i < normalized.length - 1; i++) {
                _loop_12(i);
              }
              var textChanges2 = ts3.mapDefined(normalized, function(c) {
                var span = ts3.createTextSpanFromRange(c.range);
                var newText = computeNewText(c, sourceFile, newLineCharacter, formatContext, validate);
                if (span.length === newText.length && ts3.stringContainsAt(sourceFile.text, newText, span.start)) {
                  return void 0;
                }
                return ts3.createTextChange(span, newText);
              });
              return textChanges2.length > 0 ? { fileName: sourceFile.fileName, textChanges: textChanges2 } : void 0;
            });
          }
          changesToText2.getTextChangesFromChanges = getTextChangesFromChanges;
          function newFileChanges(oldFile, fileName2, statements, newLineCharacter, formatContext) {
            var text = newFileChangesWorker(oldFile, ts3.getScriptKindFromFileName(fileName2), statements, newLineCharacter, formatContext);
            return { fileName: fileName2, textChanges: [ts3.createTextChange(ts3.createTextSpan(0, 0), text)], isNewFile: true };
          }
          changesToText2.newFileChanges = newFileChanges;
          function newFileChangesWorker(oldFile, scriptKind, statements, newLineCharacter, formatContext) {
            var nonFormattedText = statements.map(function(s) {
              return s === 4 ? "" : getNonformattedText(s, oldFile, newLineCharacter).text;
            }).join(newLineCharacter);
            var sourceFile = ts3.createSourceFile("any file name", nonFormattedText, 99, true, scriptKind);
            var changes = ts3.formatting.formatDocument(sourceFile, formatContext);
            return applyChanges(nonFormattedText, changes) + newLineCharacter;
          }
          changesToText2.newFileChangesWorker = newFileChangesWorker;
          function computeNewText(change, sourceFile, newLineCharacter, formatContext, validate) {
            var _a;
            if (change.kind === ChangeKind.Remove) {
              return "";
            }
            if (change.kind === ChangeKind.Text) {
              return change.text;
            }
            var _b = change.options, options = _b === void 0 ? {} : _b, pos = change.range.pos;
            var format = function(n) {
              return getFormattedTextOfNode(n, sourceFile, pos, options, newLineCharacter, formatContext, validate);
            };
            var text = change.kind === ChangeKind.ReplaceWithMultipleNodes ? change.nodes.map(function(n) {
              return ts3.removeSuffix(format(n), newLineCharacter);
            }).join(((_a = change.options) === null || _a === void 0 ? void 0 : _a.joiner) || newLineCharacter) : format(change.node);
            var noIndent = options.indentation !== void 0 || ts3.getLineStartPositionForPosition(pos, sourceFile) === pos ? text : text.replace(/^\s+/, "");
            return (options.prefix || "") + noIndent + (!options.suffix || ts3.endsWith(noIndent, options.suffix) ? "" : options.suffix);
          }
          function getFormattedTextOfNode(nodeIn, sourceFile, pos, _a, newLineCharacter, formatContext, validate) {
            var indentation = _a.indentation, prefix = _a.prefix, delta = _a.delta;
            var _b = getNonformattedText(nodeIn, sourceFile, newLineCharacter), node = _b.node, text = _b.text;
            if (validate)
              validate(node, text);
            var formatOptions = ts3.getFormatCodeSettingsForWriting(formatContext, sourceFile);
            var initialIndentation = indentation !== void 0 ? indentation : ts3.formatting.SmartIndenter.getIndentation(pos, sourceFile, formatOptions, prefix === newLineCharacter || ts3.getLineStartPositionForPosition(pos, sourceFile) === pos);
            if (delta === void 0) {
              delta = ts3.formatting.SmartIndenter.shouldIndentChildNode(formatOptions, nodeIn) ? formatOptions.indentSize || 0 : 0;
            }
            var file = {
              text,
              getLineAndCharacterOfPosition: function(pos2) {
                return ts3.getLineAndCharacterOfPosition(this, pos2);
              }
            };
            var changes = ts3.formatting.formatNodeGivenIndentation(node, file, sourceFile.languageVariant, initialIndentation, delta, __assign(__assign({}, formatContext), { options: formatOptions }));
            return applyChanges(text, changes);
          }
          function getNonformattedText(node, sourceFile, newLineCharacter) {
            var writer = createWriter(newLineCharacter);
            var newLine = ts3.getNewLineKind(newLineCharacter);
            ts3.createPrinter({
              newLine,
              neverAsciiEscape: true,
              preserveSourceNewlines: true,
              terminateUnterminatedLiterals: true
            }, writer).writeNode(4, node, sourceFile, writer);
            return { text: writer.getText(), node: assignPositionsToNode(node) };
          }
          changesToText2.getNonformattedText = getNonformattedText;
        })(changesToText || (changesToText = {}));
        function applyChanges(text, changes) {
          for (var i = changes.length - 1; i >= 0; i--) {
            var _a = changes[i], span = _a.span, newText = _a.newText;
            text = "".concat(text.substring(0, span.start)).concat(newText).concat(text.substring(ts3.textSpanEnd(span)));
          }
          return text;
        }
        textChanges_3.applyChanges = applyChanges;
        function isTrivia(s) {
          return ts3.skipTrivia(s, 0) === s.length;
        }
        var textChangesTransformationContext = __assign(__assign({}, ts3.nullTransformationContext), { factory: ts3.createNodeFactory(ts3.nullTransformationContext.factory.flags | 1, ts3.nullTransformationContext.factory.baseFactory) });
        function assignPositionsToNode(node) {
          var visited = ts3.visitEachChild(node, assignPositionsToNode, textChangesTransformationContext, assignPositionsToNodeArray, assignPositionsToNode);
          var newNode = ts3.nodeIsSynthesized(visited) ? visited : Object.create(visited);
          ts3.setTextRangePosEnd(newNode, getPos(node), getEnd(node));
          return newNode;
        }
        textChanges_3.assignPositionsToNode = assignPositionsToNode;
        function assignPositionsToNodeArray(nodes, visitor, test, start, count) {
          var visited = ts3.visitNodes(nodes, visitor, test, start, count);
          if (!visited) {
            return visited;
          }
          var nodeArray = visited === nodes ? ts3.factory.createNodeArray(visited.slice(0)) : visited;
          ts3.setTextRangePosEnd(nodeArray, getPos(nodes), getEnd(nodes));
          return nodeArray;
        }
        function createWriter(newLine) {
          var lastNonTriviaPosition = 0;
          var writer = ts3.createTextWriter(newLine);
          var onBeforeEmitNode = function(node) {
            if (node) {
              setPos(node, lastNonTriviaPosition);
            }
          };
          var onAfterEmitNode = function(node) {
            if (node) {
              setEnd(node, lastNonTriviaPosition);
            }
          };
          var onBeforeEmitNodeArray = function(nodes) {
            if (nodes) {
              setPos(nodes, lastNonTriviaPosition);
            }
          };
          var onAfterEmitNodeArray = function(nodes) {
            if (nodes) {
              setEnd(nodes, lastNonTriviaPosition);
            }
          };
          var onBeforeEmitToken = function(node) {
            if (node) {
              setPos(node, lastNonTriviaPosition);
            }
          };
          var onAfterEmitToken = function(node) {
            if (node) {
              setEnd(node, lastNonTriviaPosition);
            }
          };
          function setLastNonTriviaPosition(s, force) {
            if (force || !isTrivia(s)) {
              lastNonTriviaPosition = writer.getTextPos();
              var i = 0;
              while (ts3.isWhiteSpaceLike(s.charCodeAt(s.length - i - 1))) {
                i++;
              }
              lastNonTriviaPosition -= i;
            }
          }
          function write(s) {
            writer.write(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeComment(s) {
            writer.writeComment(s);
          }
          function writeKeyword(s) {
            writer.writeKeyword(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeOperator(s) {
            writer.writeOperator(s);
            setLastNonTriviaPosition(s, false);
          }
          function writePunctuation(s) {
            writer.writePunctuation(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeTrailingSemicolon(s) {
            writer.writeTrailingSemicolon(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeParameter(s) {
            writer.writeParameter(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeProperty(s) {
            writer.writeProperty(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeSpace(s) {
            writer.writeSpace(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeStringLiteral(s) {
            writer.writeStringLiteral(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeSymbol(s, sym) {
            writer.writeSymbol(s, sym);
            setLastNonTriviaPosition(s, false);
          }
          function writeLine(force) {
            writer.writeLine(force);
          }
          function increaseIndent() {
            writer.increaseIndent();
          }
          function decreaseIndent() {
            writer.decreaseIndent();
          }
          function getText() {
            return writer.getText();
          }
          function rawWrite(s) {
            writer.rawWrite(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeLiteral(s) {
            writer.writeLiteral(s);
            setLastNonTriviaPosition(s, true);
          }
          function getTextPos() {
            return writer.getTextPos();
          }
          function getLine2() {
            return writer.getLine();
          }
          function getColumn() {
            return writer.getColumn();
          }
          function getIndent() {
            return writer.getIndent();
          }
          function isAtStartOfLine() {
            return writer.isAtStartOfLine();
          }
          function clear() {
            writer.clear();
            lastNonTriviaPosition = 0;
          }
          return {
            onBeforeEmitNode,
            onAfterEmitNode,
            onBeforeEmitNodeArray,
            onAfterEmitNodeArray,
            onBeforeEmitToken,
            onAfterEmitToken,
            write,
            writeComment,
            writeKeyword,
            writeOperator,
            writePunctuation,
            writeTrailingSemicolon,
            writeParameter,
            writeProperty,
            writeSpace,
            writeStringLiteral,
            writeSymbol,
            writeLine,
            increaseIndent,
            decreaseIndent,
            getText,
            rawWrite,
            writeLiteral,
            getTextPos,
            getLine: getLine2,
            getColumn,
            getIndent,
            isAtStartOfLine,
            hasTrailingComment: function() {
              return writer.hasTrailingComment();
            },
            hasTrailingWhitespace: function() {
              return writer.hasTrailingWhitespace();
            },
            clear
          };
        }
        textChanges_3.createWriter = createWriter;
        function getInsertionPositionAtSourceFileTop(sourceFile) {
          var lastPrologue;
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var node = _a[_i];
            if (ts3.isPrologueDirective(node)) {
              lastPrologue = node;
            } else {
              break;
            }
          }
          var position = 0;
          var text = sourceFile.text;
          if (lastPrologue) {
            position = lastPrologue.end;
            advancePastLineBreak();
            return position;
          }
          var shebang = ts3.getShebang(text);
          if (shebang !== void 0) {
            position = shebang.length;
            advancePastLineBreak();
          }
          var ranges = ts3.getLeadingCommentRanges(text, position);
          if (!ranges)
            return position;
          var lastComment;
          var firstNodeLine;
          for (var _b = 0, ranges_1 = ranges; _b < ranges_1.length; _b++) {
            var range = ranges_1[_b];
            if (range.kind === 3) {
              if (ts3.isPinnedComment(text, range.pos)) {
                lastComment = { range, pinnedOrTripleSlash: true };
                continue;
              }
            } else if (ts3.isRecognizedTripleSlashComment(text, range.pos, range.end)) {
              lastComment = { range, pinnedOrTripleSlash: true };
              continue;
            }
            if (lastComment) {
              if (lastComment.pinnedOrTripleSlash)
                break;
              var commentLine = sourceFile.getLineAndCharacterOfPosition(range.pos).line;
              var lastCommentEndLine = sourceFile.getLineAndCharacterOfPosition(lastComment.range.end).line;
              if (commentLine >= lastCommentEndLine + 2)
                break;
            }
            if (sourceFile.statements.length) {
              if (firstNodeLine === void 0)
                firstNodeLine = sourceFile.getLineAndCharacterOfPosition(sourceFile.statements[0].getStart()).line;
              var commentEndLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
              if (firstNodeLine < commentEndLine + 2)
                break;
            }
            lastComment = { range, pinnedOrTripleSlash: false };
          }
          if (lastComment) {
            position = lastComment.range.end;
            advancePastLineBreak();
          }
          return position;
          function advancePastLineBreak() {
            if (position < text.length) {
              var charCode = text.charCodeAt(position);
              if (ts3.isLineBreak(charCode)) {
                position++;
                if (position < text.length && charCode === 13 && text.charCodeAt(position) === 10) {
                  position++;
                }
              }
            }
          }
        }
        function isValidLocationToAddComment(sourceFile, position) {
          return !ts3.isInComment(sourceFile, position) && !ts3.isInString(sourceFile, position) && !ts3.isInTemplateString(sourceFile, position) && !ts3.isInJSXText(sourceFile, position);
        }
        textChanges_3.isValidLocationToAddComment = isValidLocationToAddComment;
        function needSemicolonBetween(a, b) {
          return (ts3.isPropertySignature(a) || ts3.isPropertyDeclaration(a)) && ts3.isClassOrTypeElement(b) && b.name.kind === 162 || ts3.isStatementButNotDeclaration(a) && ts3.isStatementButNotDeclaration(b);
        }
        var deleteDeclaration;
        (function(deleteDeclaration_1) {
          function deleteDeclaration2(changes, deletedNodesInLists, sourceFile, node) {
            switch (node.kind) {
              case 164: {
                var oldFunction = node.parent;
                if (ts3.isArrowFunction(oldFunction) && oldFunction.parameters.length === 1 && !ts3.findChildOfKind(oldFunction, 20, sourceFile)) {
                  changes.replaceNodeWithText(sourceFile, node, "()");
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              }
              case 266:
              case 265:
                var isFirstImport = sourceFile.imports.length && node === ts3.first(sourceFile.imports).parent || node === ts3.find(sourceFile.statements, ts3.isAnyImportSyntax);
                deleteNode(changes, sourceFile, node, {
                  leadingTriviaOption: isFirstImport ? LeadingTriviaOption.Exclude : ts3.hasJSDocNodes(node) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine
                });
                break;
              case 203:
                var pattern = node.parent;
                var preserveComma = pattern.kind === 202 && node !== ts3.last(pattern.elements);
                if (preserveComma) {
                  deleteNode(changes, sourceFile, node);
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              case 254:
                deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node);
                break;
              case 163:
                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                break;
              case 270:
                var namedImports = node.parent;
                if (namedImports.elements.length === 1) {
                  deleteImportBinding(changes, sourceFile, namedImports);
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              case 268:
                deleteImportBinding(changes, sourceFile, node);
                break;
              case 26:
                deleteNode(changes, sourceFile, node, { trailingTriviaOption: TrailingTriviaOption.Exclude });
                break;
              case 98:
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: LeadingTriviaOption.Exclude });
                break;
              case 257:
              case 256:
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: ts3.hasJSDocNodes(node) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              default:
                if (!node.parent) {
                  deleteNode(changes, sourceFile, node);
                } else if (ts3.isImportClause(node.parent) && node.parent.name === node) {
                  deleteDefaultImport(changes, sourceFile, node.parent);
                } else if (ts3.isCallExpression(node.parent) && ts3.contains(node.parent.arguments, node)) {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                } else {
                  deleteNode(changes, sourceFile, node);
                }
            }
          }
          deleteDeclaration_1.deleteDeclaration = deleteDeclaration2;
          function deleteDefaultImport(changes, sourceFile, importClause) {
            if (!importClause.namedBindings) {
              deleteNode(changes, sourceFile, importClause.parent);
            } else {
              var start = importClause.name.getStart(sourceFile);
              var nextToken = ts3.getTokenAtPosition(sourceFile, importClause.name.end);
              if (nextToken && nextToken.kind === 27) {
                var end = ts3.skipTrivia(sourceFile.text, nextToken.end, false, true);
                changes.deleteRange(sourceFile, { pos: start, end });
              } else {
                deleteNode(changes, sourceFile, importClause.name);
              }
            }
          }
          function deleteImportBinding(changes, sourceFile, node) {
            if (node.parent.name) {
              var previousToken = ts3.Debug.checkDefined(ts3.getTokenAtPosition(sourceFile, node.pos - 1));
              changes.deleteRange(sourceFile, { pos: previousToken.getStart(sourceFile), end: node.end });
            } else {
              var importDecl = ts3.getAncestor(node, 266);
              deleteNode(changes, sourceFile, importDecl);
            }
          }
          function deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node) {
            var parent = node.parent;
            if (parent.kind === 292) {
              changes.deleteNodeRange(sourceFile, ts3.findChildOfKind(parent, 20, sourceFile), ts3.findChildOfKind(parent, 21, sourceFile));
              return;
            }
            if (parent.declarations.length !== 1) {
              deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
              return;
            }
            var gp = parent.parent;
            switch (gp.kind) {
              case 244:
              case 243:
                changes.replaceNode(sourceFile, node, ts3.factory.createObjectLiteralExpression());
                break;
              case 242:
                deleteNode(changes, sourceFile, parent);
                break;
              case 237:
                deleteNode(changes, sourceFile, gp, { leadingTriviaOption: ts3.hasJSDocNodes(gp) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              default:
                ts3.Debug.assertNever(gp);
            }
          }
        })(deleteDeclaration || (deleteDeclaration = {}));
        function deleteNode(changes, sourceFile, node, options) {
          if (options === void 0) {
            options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
          }
          var startPosition = getAdjustedStartPosition(sourceFile, node, options);
          var endPosition = getAdjustedEndPosition(sourceFile, node, options);
          changes.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
        }
        textChanges_3.deleteNode = deleteNode;
        function deleteNodeInList(changes, deletedNodesInLists, sourceFile, node) {
          var containingList = ts3.Debug.checkDefined(ts3.formatting.SmartIndenter.getContainingList(node, sourceFile));
          var index = ts3.indexOfNode(containingList, node);
          ts3.Debug.assert(index !== -1);
          if (containingList.length === 1) {
            deleteNode(changes, sourceFile, node);
            return;
          }
          ts3.Debug.assert(!deletedNodesInLists.has(node), "Deleting a node twice");
          deletedNodesInLists.add(node);
          changes.deleteRange(sourceFile, {
            pos: startPositionToDeleteNodeInList(sourceFile, node),
            end: index === containingList.length - 1 ? getAdjustedEndPosition(sourceFile, node, {}) : startPositionToDeleteNodeInList(sourceFile, containingList[index + 1])
          });
        }
      })(textChanges = ts3.textChanges || (ts3.textChanges = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodeToFixes = ts3.createMultiMap();
        var fixIdToRegistration = new ts3.Map();
        function createCodeFixActionWithoutFixAll(fixName, changes, description) {
          return createCodeFixActionWorker(fixName, ts3.diagnosticToString(description), changes, void 0, void 0);
        }
        codefix2.createCodeFixActionWithoutFixAll = createCodeFixActionWithoutFixAll;
        function createCodeFixAction(fixName, changes, description, fixId, fixAllDescription, command) {
          return createCodeFixActionWorker(fixName, ts3.diagnosticToString(description), changes, fixId, ts3.diagnosticToString(fixAllDescription), command);
        }
        codefix2.createCodeFixAction = createCodeFixAction;
        function createCodeFixActionMaybeFixAll(fixName, changes, description, fixId, fixAllDescription, command) {
          return createCodeFixActionWorker(fixName, ts3.diagnosticToString(description), changes, fixId, fixAllDescription && ts3.diagnosticToString(fixAllDescription), command);
        }
        codefix2.createCodeFixActionMaybeFixAll = createCodeFixActionMaybeFixAll;
        function createCodeFixActionWorker(fixName, description, changes, fixId, fixAllDescription, command) {
          return { fixName, description, changes, fixId, fixAllDescription, commands: command ? [command] : void 0 };
        }
        function registerCodeFix(reg) {
          for (var _i = 0, _a = reg.errorCodes; _i < _a.length; _i++) {
            var error = _a[_i];
            errorCodeToFixes.add(String(error), reg);
          }
          if (reg.fixIds) {
            for (var _b = 0, _c = reg.fixIds; _b < _c.length; _b++) {
              var fixId = _c[_b];
              ts3.Debug.assert(!fixIdToRegistration.has(fixId));
              fixIdToRegistration.set(fixId, reg);
            }
          }
        }
        codefix2.registerCodeFix = registerCodeFix;
        function getSupportedErrorCodes() {
          return ts3.arrayFrom(errorCodeToFixes.keys());
        }
        codefix2.getSupportedErrorCodes = getSupportedErrorCodes;
        function removeFixIdIfFixAllUnavailable(registration, diagnostics) {
          var errorCodes = registration.errorCodes;
          var maybeFixableDiagnostics = 0;
          for (var _i = 0, diagnostics_1 = diagnostics; _i < diagnostics_1.length; _i++) {
            var diag = diagnostics_1[_i];
            if (ts3.contains(errorCodes, diag.code))
              maybeFixableDiagnostics++;
            if (maybeFixableDiagnostics > 1)
              break;
          }
          var fixAllUnavailable = maybeFixableDiagnostics < 2;
          return function(_a) {
            var fixId = _a.fixId, fixAllDescription = _a.fixAllDescription, action = __rest(_a, ["fixId", "fixAllDescription"]);
            return fixAllUnavailable ? action : __assign(__assign({}, action), { fixId, fixAllDescription });
          };
        }
        function getFixes(context) {
          var diagnostics = getDiagnostics(context);
          var registrations = errorCodeToFixes.get(String(context.errorCode));
          return ts3.flatMap(registrations, function(f) {
            return ts3.map(f.getCodeActions(context), removeFixIdIfFixAllUnavailable(f, diagnostics));
          });
        }
        codefix2.getFixes = getFixes;
        function getAllFixes(context) {
          return fixIdToRegistration.get(ts3.cast(context.fixId, ts3.isString)).getAllCodeActions(context);
        }
        codefix2.getAllFixes = getAllFixes;
        function createCombinedCodeActions(changes, commands) {
          return { changes, commands };
        }
        codefix2.createCombinedCodeActions = createCombinedCodeActions;
        function createFileTextChanges(fileName2, textChanges) {
          return { fileName: fileName2, textChanges };
        }
        codefix2.createFileTextChanges = createFileTextChanges;
        function codeFixAll(context, errorCodes, use) {
          var commands = [];
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return eachDiagnostic(context, errorCodes, function(diag) {
              return use(t, diag, commands);
            });
          });
          return createCombinedCodeActions(changes, commands.length === 0 ? void 0 : commands);
        }
        codefix2.codeFixAll = codeFixAll;
        function eachDiagnostic(context, errorCodes, cb) {
          for (var _i = 0, _a = getDiagnostics(context); _i < _a.length; _i++) {
            var diag = _a[_i];
            if (ts3.contains(errorCodes, diag.code)) {
              cb(diag);
            }
          }
        }
        codefix2.eachDiagnostic = eachDiagnostic;
        function getDiagnostics(_a) {
          var program2 = _a.program, sourceFile = _a.sourceFile, cancellationToken = _a.cancellationToken;
          return __spreadArray(__spreadArray(__spreadArray([], program2.getSemanticDiagnostics(sourceFile, cancellationToken), true), program2.getSyntacticDiagnostics(sourceFile, cancellationToken), true), ts3.computeSuggestionDiagnostics(sourceFile, program2, cancellationToken), true);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor_1) {
        var refactors = new ts3.Map();
        function registerRefactor(name, refactor2) {
          refactors.set(name, refactor2);
        }
        refactor_1.registerRefactor = registerRefactor;
        function getApplicableRefactors(context) {
          return ts3.arrayFrom(ts3.flatMapIterator(refactors.values(), function(refactor2) {
            var _a;
            return context.cancellationToken && context.cancellationToken.isCancellationRequested() || !((_a = refactor2.kinds) === null || _a === void 0 ? void 0 : _a.some(function(kind) {
              return refactor_1.refactorKindBeginsWith(kind, context.kind);
            })) ? void 0 : refactor2.getAvailableActions(context);
          }));
        }
        refactor_1.getApplicableRefactors = getApplicableRefactors;
        function getEditsForRefactor(context, refactorName, actionName) {
          var refactor2 = refactors.get(refactorName);
          return refactor2 && refactor2.getEditsForAction(context, actionName);
        }
        refactor_1.getEditsForRefactor = getEditsForRefactor;
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addConvertToUnknownForNonOverlappingTypes";
        var errorCodes = [ts3.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToAddConvertToUnknownForNonOverlappingTypes(context) {
            var assertion = getAssertion(context.sourceFile, context.span.start);
            if (assertion === void 0)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, assertion);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_unknown_conversion_for_non_overlapping_types, fixId, ts3.Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var assertion = getAssertion(diag.file, diag.start);
              if (assertion) {
                makeChange(changes, diag.file, assertion);
              }
            });
          }
        });
        function makeChange(changeTracker, sourceFile, assertion) {
          var replacement = ts3.isAsExpression(assertion) ? ts3.factory.createAsExpression(assertion.expression, ts3.factory.createKeywordTypeNode(155)) : ts3.factory.createTypeAssertion(ts3.factory.createKeywordTypeNode(155), assertion.expression);
          changeTracker.replaceNode(sourceFile, assertion.expression, replacement);
        }
        function getAssertion(sourceFile, pos) {
          if (ts3.isInJSFile(sourceFile))
            return void 0;
          return ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, pos), function(n) {
            return ts3.isAsExpression(n) || ts3.isTypeAssertionExpression(n);
          });
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,
            ts3.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code
          ],
          getCodeActions: function getCodeActionsToAddEmptyExportDeclaration(context) {
            var sourceFile = context.sourceFile;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              var exportDeclaration = ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([]), void 0);
              changes2.insertNodeAtEndOfScope(sourceFile, sourceFile, exportDeclaration);
            });
            return [codefix2.createCodeFixActionWithoutFixAll("addEmptyExportDeclaration", changes, ts3.Diagnostics.Add_export_to_make_this_file_into_a_module)];
          }
        });
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingAsync";
        var errorCodes = [
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
          ts3.Diagnostics.Type_0_is_not_comparable_to_type_1.code
        ];
        codefix2.registerCodeFix({
          fixIds: [fixId],
          errorCodes,
          getCodeActions: function getCodeActionsToAddMissingAsync(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode, cancellationToken = context.cancellationToken, program2 = context.program, span = context.span;
            var diagnostic = ts3.find(program2.getTypeChecker().getDiagnostics(sourceFile, cancellationToken), getIsMatchingAsyncError(span, errorCode));
            var directSpan = diagnostic && diagnostic.relatedInformation && ts3.find(diagnostic.relatedInformation, function(r) {
              return r.code === ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
            });
            var decl = getFixableErrorSpanDeclaration(sourceFile, directSpan);
            if (!decl) {
              return;
            }
            var trackChanges = function(cb) {
              return ts3.textChanges.ChangeTracker.with(context, cb);
            };
            return [getFix(context, decl, trackChanges)];
          },
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var fixedDeclarations = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(t, diagnostic) {
              var span = diagnostic.relatedInformation && ts3.find(diagnostic.relatedInformation, function(r) {
                return r.code === ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
              });
              var decl = getFixableErrorSpanDeclaration(sourceFile, span);
              if (!decl) {
                return;
              }
              var trackChanges = function(cb) {
                return cb(t), [];
              };
              return getFix(context, decl, trackChanges, fixedDeclarations);
            });
          }
        });
        function getFix(context, decl, trackChanges, fixedDeclarations) {
          var changes = trackChanges(function(t) {
            return makeChange(t, context.sourceFile, decl, fixedDeclarations);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_async_modifier_to_containing_function, fixId, ts3.Diagnostics.Add_all_missing_async_modifiers);
        }
        function makeChange(changeTracker, sourceFile, insertionSite, fixedDeclarations) {
          if (fixedDeclarations) {
            if (fixedDeclarations.has(ts3.getNodeId(insertionSite))) {
              return;
            }
          }
          fixedDeclarations === null || fixedDeclarations === void 0 ? void 0 : fixedDeclarations.add(ts3.getNodeId(insertionSite));
          var cloneWithModifier = ts3.factory.updateModifiers(ts3.getSynthesizedDeepClone(insertionSite, true), ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(ts3.getSyntacticModifierFlags(insertionSite) | 256)));
          changeTracker.replaceNode(sourceFile, insertionSite, cloneWithModifier);
        }
        function getFixableErrorSpanDeclaration(sourceFile, span) {
          if (!span)
            return void 0;
          var token = ts3.getTokenAtPosition(sourceFile, span.start);
          var decl = ts3.findAncestor(token, function(node) {
            if (node.getStart(sourceFile) < span.start || node.getEnd() > ts3.textSpanEnd(span)) {
              return "quit";
            }
            return (ts3.isArrowFunction(node) || ts3.isMethodDeclaration(node) || ts3.isFunctionExpression(node) || ts3.isFunctionDeclaration(node)) && ts3.textSpansEqual(span, ts3.createTextSpanFromNode(node, sourceFile));
          });
          return decl;
        }
        function getIsMatchingAsyncError(span, errorCode) {
          return function(_a) {
            var start = _a.start, length = _a.length, relatedInformation = _a.relatedInformation, code = _a.code;
            return ts3.isNumber(start) && ts3.isNumber(length) && ts3.textSpansEqual({ start, length }, span) && code === errorCode && !!relatedInformation && ts3.some(relatedInformation, function(related) {
              return related.code === ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
            });
          };
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingAwait";
        var propertyAccessCode = ts3.Diagnostics.Property_0_does_not_exist_on_type_1.code;
        var callableConstructableErrorCodes = [
          ts3.Diagnostics.This_expression_is_not_callable.code,
          ts3.Diagnostics.This_expression_is_not_constructable.code
        ];
        var errorCodes = __spreadArray([
          ts3.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts3.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts3.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts3.Diagnostics.Operator_0_cannot_be_applied_to_type_1.code,
          ts3.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2.code,
          ts3.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap.code,
          ts3.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type.code,
          ts3.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts3.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts3.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code,
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          propertyAccessCode
        ], callableConstructableErrorCodes, true);
        codefix2.registerCodeFix({
          fixIds: [fixId],
          errorCodes,
          getCodeActions: function getCodeActionsToAddMissingAwait(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode, span = context.span, cancellationToken = context.cancellationToken, program2 = context.program;
            var expression = getAwaitErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program2);
            if (!expression) {
              return;
            }
            var checker = context.program.getTypeChecker();
            var trackChanges = function(cb) {
              return ts3.textChanges.ChangeTracker.with(context, cb);
            };
            return ts3.compact([
              getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges),
              getUseSiteFix(context, expression, errorCode, checker, trackChanges)
            ]);
          },
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
            var checker = context.program.getTypeChecker();
            var fixedDeclarations = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(t, diagnostic) {
              var expression = getAwaitErrorSpanExpression(sourceFile, diagnostic.code, diagnostic, cancellationToken, program2);
              if (!expression) {
                return;
              }
              var trackChanges = function(cb) {
                return cb(t), [];
              };
              return getDeclarationSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations) || getUseSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations);
            });
          }
        });
        function getAwaitErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program2) {
          var expression = ts3.getFixableErrorSpanExpression(sourceFile, span);
          return expression && isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program2) && isInsideAwaitableBody(expression) ? expression : void 0;
        }
        function getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
          var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
          var awaitableInitializers = findAwaitableInitializers(expression, sourceFile, cancellationToken, program2, checker);
          if (awaitableInitializers) {
            var initializerChanges = trackChanges(function(t) {
              ts3.forEach(awaitableInitializers.initializers, function(_a) {
                var expression2 = _a.expression;
                return makeChange(t, errorCode, sourceFile, checker, expression2, fixedDeclarations);
              });
              if (fixedDeclarations && awaitableInitializers.needsSecondPassForFixAll) {
                makeChange(t, errorCode, sourceFile, checker, expression, fixedDeclarations);
              }
            });
            return codefix2.createCodeFixActionWithoutFixAll("addMissingAwaitToInitializer", initializerChanges, awaitableInitializers.initializers.length === 1 ? [ts3.Diagnostics.Add_await_to_initializer_for_0, awaitableInitializers.initializers[0].declarationSymbol.name] : ts3.Diagnostics.Add_await_to_initializers);
          }
        }
        function getUseSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
          var changes = trackChanges(function(t) {
            return makeChange(t, errorCode, context.sourceFile, checker, expression, fixedDeclarations);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_await, fixId, ts3.Diagnostics.Fix_all_expressions_possibly_missing_await);
        }
        function isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program2) {
          var checker = program2.getTypeChecker();
          var diagnostics = checker.getDiagnostics(sourceFile, cancellationToken);
          return ts3.some(diagnostics, function(_a) {
            var start = _a.start, length = _a.length, relatedInformation = _a.relatedInformation, code = _a.code;
            return ts3.isNumber(start) && ts3.isNumber(length) && ts3.textSpansEqual({ start, length }, span) && code === errorCode && !!relatedInformation && ts3.some(relatedInformation, function(related) {
              return related.code === ts3.Diagnostics.Did_you_forget_to_use_await.code;
            });
          });
        }
        function findAwaitableInitializers(expression, sourceFile, cancellationToken, program2, checker) {
          var identifiers = getIdentifiersFromErrorSpanExpression(expression, checker);
          if (!identifiers) {
            return;
          }
          var isCompleteFix = identifiers.isCompleteFix;
          var initializers;
          var _loop_13 = function(identifier2) {
            var symbol = checker.getSymbolAtLocation(identifier2);
            if (!symbol) {
              return "continue";
            }
            var declaration = ts3.tryCast(symbol.valueDeclaration, ts3.isVariableDeclaration);
            var variableName = declaration && ts3.tryCast(declaration.name, ts3.isIdentifier);
            var variableStatement = ts3.getAncestor(declaration, 237);
            if (!declaration || !variableStatement || declaration.type || !declaration.initializer || variableStatement.getSourceFile() !== sourceFile || ts3.hasSyntacticModifier(variableStatement, 1) || !variableName || !isInsideAwaitableBody(declaration.initializer)) {
              isCompleteFix = false;
              return "continue";
            }
            var diagnostics = program2.getSemanticDiagnostics(sourceFile, cancellationToken);
            var isUsedElsewhere = ts3.FindAllReferences.Core.eachSymbolReferenceInFile(variableName, checker, sourceFile, function(reference) {
              return identifier2 !== reference && !symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker);
            });
            if (isUsedElsewhere) {
              isCompleteFix = false;
              return "continue";
            }
            (initializers || (initializers = [])).push({
              expression: declaration.initializer,
              declarationSymbol: symbol
            });
          };
          for (var _i = 0, _a = identifiers.identifiers; _i < _a.length; _i++) {
            var identifier = _a[_i];
            _loop_13(identifier);
          }
          return initializers && {
            initializers,
            needsSecondPassForFixAll: !isCompleteFix
          };
        }
        function getIdentifiersFromErrorSpanExpression(expression, checker) {
          if (ts3.isPropertyAccessExpression(expression.parent) && ts3.isIdentifier(expression.parent.expression)) {
            return { identifiers: [expression.parent.expression], isCompleteFix: true };
          }
          if (ts3.isIdentifier(expression)) {
            return { identifiers: [expression], isCompleteFix: true };
          }
          if (ts3.isBinaryExpression(expression)) {
            var sides = void 0;
            var isCompleteFix = true;
            for (var _i = 0, _a = [expression.left, expression.right]; _i < _a.length; _i++) {
              var side = _a[_i];
              var type2 = checker.getTypeAtLocation(side);
              if (checker.getPromisedTypeOfPromise(type2)) {
                if (!ts3.isIdentifier(side)) {
                  isCompleteFix = false;
                  continue;
                }
                (sides || (sides = [])).push(side);
              }
            }
            return sides && { identifiers: sides, isCompleteFix };
          }
        }
        function symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker) {
          var errorNode = ts3.isPropertyAccessExpression(reference.parent) ? reference.parent.name : ts3.isBinaryExpression(reference.parent) ? reference.parent : reference;
          var diagnostic = ts3.find(diagnostics, function(diagnostic2) {
            return diagnostic2.start === errorNode.getStart(sourceFile) && diagnostic2.start + diagnostic2.length === errorNode.getEnd();
          });
          return diagnostic && ts3.contains(errorCodes, diagnostic.code) || checker.getTypeAtLocation(errorNode).flags & 1;
        }
        function isInsideAwaitableBody(node) {
          return node.kind & 32768 || !!ts3.findAncestor(node, function(ancestor) {
            return ancestor.parent && ts3.isArrowFunction(ancestor.parent) && ancestor.parent.body === ancestor || ts3.isBlock(ancestor) && (ancestor.parent.kind === 256 || ancestor.parent.kind === 213 || ancestor.parent.kind === 214 || ancestor.parent.kind === 169);
          });
        }
        function makeChange(changeTracker, errorCode, sourceFile, checker, insertionSite, fixedDeclarations) {
          if (ts3.isBinaryExpression(insertionSite)) {
            for (var _i = 0, _a = [insertionSite.left, insertionSite.right]; _i < _a.length; _i++) {
              var side = _a[_i];
              if (fixedDeclarations && ts3.isIdentifier(side)) {
                var symbol = checker.getSymbolAtLocation(side);
                if (symbol && fixedDeclarations.has(ts3.getSymbolId(symbol))) {
                  continue;
                }
              }
              var type2 = checker.getTypeAtLocation(side);
              var newNode = checker.getPromisedTypeOfPromise(type2) ? ts3.factory.createAwaitExpression(side) : side;
              changeTracker.replaceNode(sourceFile, side, newNode);
            }
          } else if (errorCode === propertyAccessCode && ts3.isPropertyAccessExpression(insertionSite.parent)) {
            if (fixedDeclarations && ts3.isIdentifier(insertionSite.parent.expression)) {
              var symbol = checker.getSymbolAtLocation(insertionSite.parent.expression);
              if (symbol && fixedDeclarations.has(ts3.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite.parent.expression, ts3.factory.createParenthesizedExpression(ts3.factory.createAwaitExpression(insertionSite.parent.expression)));
            insertLeadingSemicolonIfNeeded(changeTracker, insertionSite.parent.expression, sourceFile);
          } else if (ts3.contains(callableConstructableErrorCodes, errorCode) && ts3.isCallOrNewExpression(insertionSite.parent)) {
            if (fixedDeclarations && ts3.isIdentifier(insertionSite)) {
              var symbol = checker.getSymbolAtLocation(insertionSite);
              if (symbol && fixedDeclarations.has(ts3.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite, ts3.factory.createParenthesizedExpression(ts3.factory.createAwaitExpression(insertionSite)));
            insertLeadingSemicolonIfNeeded(changeTracker, insertionSite, sourceFile);
          } else {
            if (fixedDeclarations && ts3.isVariableDeclaration(insertionSite.parent) && ts3.isIdentifier(insertionSite.parent.name)) {
              var symbol = checker.getSymbolAtLocation(insertionSite.parent.name);
              if (symbol && !ts3.tryAddToSet(fixedDeclarations, ts3.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite, ts3.factory.createAwaitExpression(insertionSite));
          }
        }
        function insertLeadingSemicolonIfNeeded(changeTracker, beforeNode, sourceFile) {
          var precedingToken = ts3.findPrecedingToken(beforeNode.pos, sourceFile);
          if (precedingToken && ts3.positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
            changeTracker.insertText(sourceFile, beforeNode.getStart(sourceFile), ";");
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingConst";
        var errorCodes = [
          ts3.Diagnostics.Cannot_find_name_0.code,
          ts3.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToAddMissingConst(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start, context.program);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_const_to_unresolved_variable, fixId, ts3.Diagnostics.Add_const_to_all_unresolved_variables)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedNodes = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start, context.program, fixedNodes);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos, program2, fixedNodes) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var forInitializer = ts3.findAncestor(token, function(node) {
            return ts3.isForInOrOfStatement(node.parent) ? node.parent.initializer === node : isPossiblyPartOfDestructuring(node) ? false : "quit";
          });
          if (forInitializer)
            return applyChange(changeTracker, forInitializer, sourceFile, fixedNodes);
          var parent = token.parent;
          if (ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 63 && ts3.isExpressionStatement(parent.parent)) {
            return applyChange(changeTracker, token, sourceFile, fixedNodes);
          }
          if (ts3.isArrayLiteralExpression(parent)) {
            var checker_1 = program2.getTypeChecker();
            if (!ts3.every(parent.elements, function(element) {
              return arrayElementCouldBeVariableDeclaration(element, checker_1);
            })) {
              return;
            }
            return applyChange(changeTracker, parent, sourceFile, fixedNodes);
          }
          var commaExpression = ts3.findAncestor(token, function(node) {
            return ts3.isExpressionStatement(node.parent) ? true : isPossiblyPartOfCommaSeperatedInitializer(node) ? false : "quit";
          });
          if (commaExpression) {
            var checker = program2.getTypeChecker();
            if (!expressionCouldBeVariableDeclaration(commaExpression, checker)) {
              return;
            }
            return applyChange(changeTracker, commaExpression, sourceFile, fixedNodes);
          }
        }
        function applyChange(changeTracker, initializer, sourceFile, fixedNodes) {
          if (!fixedNodes || ts3.tryAddToSet(fixedNodes, initializer)) {
            changeTracker.insertModifierBefore(sourceFile, 85, initializer);
          }
        }
        function isPossiblyPartOfDestructuring(node) {
          switch (node.kind) {
            case 79:
            case 204:
            case 205:
            case 296:
            case 297:
              return true;
            default:
              return false;
          }
        }
        function arrayElementCouldBeVariableDeclaration(expression, checker) {
          var identifier = ts3.isIdentifier(expression) ? expression : ts3.isAssignmentExpression(expression, true) && ts3.isIdentifier(expression.left) ? expression.left : void 0;
          return !!identifier && !checker.getSymbolAtLocation(identifier);
        }
        function isPossiblyPartOfCommaSeperatedInitializer(node) {
          switch (node.kind) {
            case 79:
            case 221:
            case 27:
              return true;
            default:
              return false;
          }
        }
        function expressionCouldBeVariableDeclaration(expression, checker) {
          if (!ts3.isBinaryExpression(expression)) {
            return false;
          }
          if (expression.operatorToken.kind === 27) {
            return ts3.every([expression.left, expression.right], function(expression2) {
              return expressionCouldBeVariableDeclaration(expression2, checker);
            });
          }
          return expression.operatorToken.kind === 63 && ts3.isIdentifier(expression.left) && !checker.getSymbolAtLocation(expression.left);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingDeclareProperty";
        var errorCodes = [
          ts3.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToAddMissingDeclareOnProperty(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Prefix_with_declare, fixId, ts3.Diagnostics.Prefix_all_incorrect_property_declarations_with_declare)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedNodes = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start, fixedNodes);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos, fixedNodes) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (!ts3.isIdentifier(token)) {
            return;
          }
          var declaration = token.parent;
          if (declaration.kind === 167 && (!fixedNodes || ts3.tryAddToSet(fixedNodes, declaration))) {
            changeTracker.insertModifierBefore(sourceFile, 135, declaration);
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingInvocationForDecorator";
        var errorCodes = [ts3.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToAddMissingInvocationForDecorator(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Call_decorator_expression, fixId, ts3.Diagnostics.Add_to_all_uncalled_decorators)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var decorator = ts3.findAncestor(token, ts3.isDecorator);
          ts3.Debug.assert(!!decorator, "Expected position to be owned by a decorator.");
          var replacement = ts3.factory.createCallExpression(decorator.expression, void 0, void 0);
          changeTracker.replaceNode(sourceFile, decorator.expression, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addNameToNamelessParameter";
        var errorCodes = [ts3.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToAddNameToNamelessParameter(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_parameter_name, fixId, ts3.Diagnostics.Add_names_to_all_parameters_without_names)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var param = token.parent;
          if (!ts3.isParameter(param)) {
            return ts3.Debug.fail("Tried to add a parameter name to a non-parameter: " + ts3.Debug.formatSyntaxKind(token.kind));
          }
          var i = param.parent.parameters.indexOf(param);
          ts3.Debug.assert(!param.type, "Tried to add a parameter name to a parameter that already had one.");
          ts3.Debug.assert(i > -1, "Parameter not found in parent parameter list.");
          var typeNode = ts3.factory.createTypeReferenceNode(param.name, void 0);
          var replacement = ts3.factory.createParameterDeclaration(void 0, param.modifiers, param.dotDotDotToken, "arg" + i, param.questionToken, param.dotDotDotToken ? ts3.factory.createArrayTypeNode(typeNode) : typeNode, param.initializer);
          changeTracker.replaceNode(sourceFile, param, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var addOptionalPropertyUndefined = "addOptionalPropertyUndefined";
        var errorCodes = [
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var typeChecker = context.program.getTypeChecker();
            var toAdd = getPropertiesToAdd(context.sourceFile, context.span, typeChecker);
            if (!toAdd.length) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return addUndefinedToOptionalProperty(t, toAdd);
            });
            return [codefix2.createCodeFixActionWithoutFixAll(addOptionalPropertyUndefined, changes, ts3.Diagnostics.Add_undefined_to_optional_property_type)];
          },
          fixIds: [addOptionalPropertyUndefined]
        });
        function getPropertiesToAdd(file, span, checker) {
          var _a, _b;
          var sourceTarget = getSourceTarget(ts3.getFixableErrorSpanExpression(file, span), checker);
          if (!sourceTarget) {
            return ts3.emptyArray;
          }
          var sourceNode = sourceTarget.source, targetNode = sourceTarget.target;
          var target = shouldUseParentTypeOfProperty(sourceNode, targetNode, checker) ? checker.getTypeAtLocation(targetNode.expression) : checker.getTypeAtLocation(targetNode);
          if ((_b = (_a = target.symbol) === null || _a === void 0 ? void 0 : _a.declarations) === null || _b === void 0 ? void 0 : _b.some(function(d) {
            return ts3.getSourceFileOfNode(d).fileName.match(/\.d\.ts$/);
          })) {
            return ts3.emptyArray;
          }
          return checker.getExactOptionalProperties(target);
        }
        function shouldUseParentTypeOfProperty(sourceNode, targetNode, checker) {
          return ts3.isPropertyAccessExpression(targetNode) && !!checker.getExactOptionalProperties(checker.getTypeAtLocation(targetNode.expression)).length && checker.getTypeAtLocation(sourceNode) === checker.getUndefinedType();
        }
        function getSourceTarget(errorNode, checker) {
          var _a;
          if (!errorNode) {
            return void 0;
          } else if (ts3.isBinaryExpression(errorNode.parent) && errorNode.parent.operatorToken.kind === 63) {
            return { source: errorNode.parent.right, target: errorNode.parent.left };
          } else if (ts3.isVariableDeclaration(errorNode.parent) && errorNode.parent.initializer) {
            return { source: errorNode.parent.initializer, target: errorNode.parent.name };
          } else if (ts3.isCallExpression(errorNode.parent)) {
            var n = checker.getSymbolAtLocation(errorNode.parent.expression);
            if (!(n === null || n === void 0 ? void 0 : n.valueDeclaration) || !ts3.isFunctionLikeKind(n.valueDeclaration.kind))
              return void 0;
            if (!ts3.isExpression(errorNode))
              return void 0;
            var i = errorNode.parent.arguments.indexOf(errorNode);
            if (i === -1)
              return void 0;
            var name = n.valueDeclaration.parameters[i].name;
            if (ts3.isIdentifier(name))
              return { source: errorNode, target: name };
          } else if (ts3.isPropertyAssignment(errorNode.parent) && ts3.isIdentifier(errorNode.parent.name) || ts3.isShorthandPropertyAssignment(errorNode.parent)) {
            var parentTarget = getSourceTarget(errorNode.parent.parent, checker);
            if (!parentTarget)
              return void 0;
            var prop = checker.getPropertyOfType(checker.getTypeAtLocation(parentTarget.target), errorNode.parent.name.text);
            var declaration = (_a = prop === null || prop === void 0 ? void 0 : prop.declarations) === null || _a === void 0 ? void 0 : _a[0];
            if (!declaration)
              return void 0;
            return {
              source: ts3.isPropertyAssignment(errorNode.parent) ? errorNode.parent.initializer : errorNode.parent.name,
              target: declaration
            };
          }
          return void 0;
        }
        function addUndefinedToOptionalProperty(changes, toAdd) {
          for (var _i = 0, toAdd_1 = toAdd; _i < toAdd_1.length; _i++) {
            var add = toAdd_1[_i];
            var d = add.valueDeclaration;
            if (d && (ts3.isPropertySignature(d) || ts3.isPropertyDeclaration(d)) && d.type) {
              var t = ts3.factory.createUnionTypeNode(__spreadArray(__spreadArray([], d.type.kind === 187 ? d.type.types : [d.type], true), [
                ts3.factory.createTypeReferenceNode("undefined")
              ], false));
              changes.replaceNode(d.getSourceFile(), d.type, t);
            }
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "annotateWithTypeFromJSDoc";
        var errorCodes = [ts3.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var decl = getDeclaration(context.sourceFile, context.span.start);
            if (!decl)
              return;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, decl);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Annotate_with_type_from_JSDoc, fixId, ts3.Diagnostics.Annotate_everything_with_types_from_JSDoc)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var decl = getDeclaration(diag.file, diag.start);
              if (decl)
                doChange(changes, diag.file, decl);
            });
          }
        });
        function getDeclaration(file, pos) {
          var name = ts3.getTokenAtPosition(file, pos);
          return ts3.tryCast(ts3.isParameter(name.parent) ? name.parent.parent : name.parent, parameterShouldGetTypeFromJSDoc);
        }
        function parameterShouldGetTypeFromJSDoc(node) {
          return isDeclarationWithType(node) && hasUsableJSDoc(node);
        }
        codefix2.parameterShouldGetTypeFromJSDoc = parameterShouldGetTypeFromJSDoc;
        function hasUsableJSDoc(decl) {
          return ts3.isFunctionLikeDeclaration(decl) ? decl.parameters.some(hasUsableJSDoc) || !decl.type && !!ts3.getJSDocReturnType(decl) : !decl.type && !!ts3.getJSDocType(decl);
        }
        function doChange(changes, sourceFile, decl) {
          if (ts3.isFunctionLikeDeclaration(decl) && (ts3.getJSDocReturnType(decl) || decl.parameters.some(function(p) {
            return !!ts3.getJSDocType(p);
          }))) {
            if (!decl.typeParameters) {
              var typeParameters = ts3.getJSDocTypeParameterDeclarations(decl);
              if (typeParameters.length)
                changes.insertTypeParameters(sourceFile, decl, typeParameters);
            }
            var needParens = ts3.isArrowFunction(decl) && !ts3.findChildOfKind(decl, 20, sourceFile);
            if (needParens)
              changes.insertNodeBefore(sourceFile, ts3.first(decl.parameters), ts3.factory.createToken(20));
            for (var _i = 0, _a = decl.parameters; _i < _a.length; _i++) {
              var param = _a[_i];
              if (!param.type) {
                var paramType = ts3.getJSDocType(param);
                if (paramType)
                  changes.tryInsertTypeAnnotation(sourceFile, param, transformJSDocType(paramType));
              }
            }
            if (needParens)
              changes.insertNodeAfter(sourceFile, ts3.last(decl.parameters), ts3.factory.createToken(21));
            if (!decl.type) {
              var returnType = ts3.getJSDocReturnType(decl);
              if (returnType)
                changes.tryInsertTypeAnnotation(sourceFile, decl, transformJSDocType(returnType));
            }
          } else {
            var jsdocType = ts3.Debug.checkDefined(ts3.getJSDocType(decl), "A JSDocType for this declaration should exist");
            ts3.Debug.assert(!decl.type, "The JSDocType decl should have a type");
            changes.tryInsertTypeAnnotation(sourceFile, decl, transformJSDocType(jsdocType));
          }
        }
        function isDeclarationWithType(node) {
          return ts3.isFunctionLikeDeclaration(node) || node.kind === 254 || node.kind === 166 || node.kind === 167;
        }
        function transformJSDocType(node) {
          switch (node.kind) {
            case 312:
            case 313:
              return ts3.factory.createTypeReferenceNode("any", ts3.emptyArray);
            case 316:
              return transformJSDocOptionalType(node);
            case 315:
              return transformJSDocType(node.type);
            case 314:
              return transformJSDocNullableType(node);
            case 318:
              return transformJSDocVariadicType(node);
            case 317:
              return transformJSDocFunctionType(node);
            case 178:
              return transformJSDocTypeReference(node);
            default:
              var visited = ts3.visitEachChild(node, transformJSDocType, ts3.nullTransformationContext);
              ts3.setEmitFlags(visited, 1);
              return visited;
          }
        }
        function transformJSDocOptionalType(node) {
          return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, transformJSDocType), ts3.factory.createTypeReferenceNode("undefined", ts3.emptyArray)]);
        }
        function transformJSDocNullableType(node) {
          return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, transformJSDocType), ts3.factory.createTypeReferenceNode("null", ts3.emptyArray)]);
        }
        function transformJSDocVariadicType(node) {
          return ts3.factory.createArrayTypeNode(ts3.visitNode(node.type, transformJSDocType));
        }
        function transformJSDocFunctionType(node) {
          var _a;
          return ts3.factory.createFunctionTypeNode(ts3.emptyArray, node.parameters.map(transformJSDocParameter), (_a = node.type) !== null && _a !== void 0 ? _a : ts3.factory.createKeywordTypeNode(130));
        }
        function transformJSDocParameter(node) {
          var index = node.parent.parameters.indexOf(node);
          var isRest = node.type.kind === 318 && index === node.parent.parameters.length - 1;
          var name = node.name || (isRest ? "rest" : "arg" + index);
          var dotdotdot = isRest ? ts3.factory.createToken(25) : node.dotDotDotToken;
          return ts3.factory.createParameterDeclaration(node.decorators, node.modifiers, dotdotdot, name, node.questionToken, ts3.visitNode(node.type, transformJSDocType), node.initializer);
        }
        function transformJSDocTypeReference(node) {
          var name = node.typeName;
          var args = node.typeArguments;
          if (ts3.isIdentifier(node.typeName)) {
            if (ts3.isJSDocIndexSignature(node)) {
              return transformJSDocIndexSignature(node);
            }
            var text = node.typeName.text;
            switch (node.typeName.text) {
              case "String":
              case "Boolean":
              case "Object":
              case "Number":
                text = text.toLowerCase();
                break;
              case "array":
              case "date":
              case "promise":
                text = text[0].toUpperCase() + text.slice(1);
                break;
            }
            name = ts3.factory.createIdentifier(text);
            if ((text === "Array" || text === "Promise") && !node.typeArguments) {
              args = ts3.factory.createNodeArray([ts3.factory.createTypeReferenceNode("any", ts3.emptyArray)]);
            } else {
              args = ts3.visitNodes(node.typeArguments, transformJSDocType);
            }
          }
          return ts3.factory.createTypeReferenceNode(name, args);
        }
        function transformJSDocIndexSignature(node) {
          var index = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, node.typeArguments[0].kind === 147 ? "n" : "s", void 0, ts3.factory.createTypeReferenceNode(node.typeArguments[0].kind === 147 ? "number" : "string", []), void 0);
          var indexSignature = ts3.factory.createTypeLiteralNode([ts3.factory.createIndexSignature(void 0, void 0, [index], node.typeArguments[1])]);
          ts3.setEmitFlags(indexSignature, 1);
          return indexSignature;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertFunctionToEs6Class";
        var errorCodes = [ts3.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start, context.program.getTypeChecker(), context.preferences, context.program.getCompilerOptions());
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_function_to_an_ES2015_class, fixId, ts3.Diagnostics.Convert_all_constructor_functions_to_classes)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              return doChange(changes, err.file, err.start, context.program.getTypeChecker(), context.preferences, context.program.getCompilerOptions());
            });
          }
        });
        function doChange(changes, sourceFile, position, checker, preferences, compilerOptions) {
          var ctorSymbol = checker.getSymbolAtLocation(ts3.getTokenAtPosition(sourceFile, position));
          if (!ctorSymbol || !ctorSymbol.valueDeclaration || !(ctorSymbol.flags & (16 | 3))) {
            return void 0;
          }
          var ctorDeclaration = ctorSymbol.valueDeclaration;
          if (ts3.isFunctionDeclaration(ctorDeclaration)) {
            changes.replaceNode(sourceFile, ctorDeclaration, createClassFromFunctionDeclaration(ctorDeclaration));
          } else if (ts3.isVariableDeclaration(ctorDeclaration)) {
            var classDeclaration = createClassFromVariableDeclaration(ctorDeclaration);
            if (!classDeclaration) {
              return void 0;
            }
            var ancestor = ctorDeclaration.parent.parent;
            if (ts3.isVariableDeclarationList(ctorDeclaration.parent) && ctorDeclaration.parent.declarations.length > 1) {
              changes.delete(sourceFile, ctorDeclaration);
              changes.insertNodeAfter(sourceFile, ancestor, classDeclaration);
            } else {
              changes.replaceNode(sourceFile, ancestor, classDeclaration);
            }
          }
          function createClassElementsFromSymbol(symbol) {
            var memberElements = [];
            if (symbol.exports) {
              symbol.exports.forEach(function(member) {
                if (member.name === "prototype" && member.declarations) {
                  var firstDeclaration = member.declarations[0];
                  if (member.declarations.length === 1 && ts3.isPropertyAccessExpression(firstDeclaration) && ts3.isBinaryExpression(firstDeclaration.parent) && firstDeclaration.parent.operatorToken.kind === 63 && ts3.isObjectLiteralExpression(firstDeclaration.parent.right)) {
                    var prototypes = firstDeclaration.parent.right;
                    createClassElement(prototypes.symbol, void 0, memberElements);
                  }
                } else {
                  createClassElement(member, [ts3.factory.createToken(124)], memberElements);
                }
              });
            }
            if (symbol.members) {
              symbol.members.forEach(function(member, key) {
                var _a, _b, _c, _d;
                if (key === "constructor" && member.valueDeclaration) {
                  var prototypeAssignment = (_d = (_c = (_b = (_a = symbol.exports) === null || _a === void 0 ? void 0 : _a.get("prototype")) === null || _b === void 0 ? void 0 : _b.declarations) === null || _c === void 0 ? void 0 : _c[0]) === null || _d === void 0 ? void 0 : _d.parent;
                  if (prototypeAssignment && ts3.isBinaryExpression(prototypeAssignment) && ts3.isObjectLiteralExpression(prototypeAssignment.right) && ts3.some(prototypeAssignment.right.properties, isConstructorAssignment)) {
                  } else {
                    changes.delete(sourceFile, member.valueDeclaration.parent);
                  }
                  return;
                }
                createClassElement(member, void 0, memberElements);
              });
            }
            return memberElements;
            function shouldConvertDeclaration(_target, source) {
              if (ts3.isAccessExpression(_target)) {
                if (ts3.isPropertyAccessExpression(_target) && isConstructorAssignment(_target))
                  return true;
                return ts3.isFunctionLike(source);
              } else {
                return ts3.every(_target.properties, function(property) {
                  if (ts3.isMethodDeclaration(property) || ts3.isGetOrSetAccessorDeclaration(property))
                    return true;
                  if (ts3.isPropertyAssignment(property) && ts3.isFunctionExpression(property.initializer) && !!property.name)
                    return true;
                  if (isConstructorAssignment(property))
                    return true;
                  return false;
                });
              }
            }
            function createClassElement(symbol2, modifiers, members) {
              if (!(symbol2.flags & 8192) && !(symbol2.flags & 4096)) {
                return;
              }
              var memberDeclaration = symbol2.valueDeclaration;
              var assignmentBinaryExpression = memberDeclaration.parent;
              var assignmentExpr = assignmentBinaryExpression.right;
              if (!shouldConvertDeclaration(memberDeclaration, assignmentExpr)) {
                return;
              }
              if (ts3.some(members, function(m) {
                var name2 = ts3.getNameOfDeclaration(m);
                if (name2 && ts3.isIdentifier(name2) && ts3.idText(name2) === ts3.symbolName(symbol2)) {
                  return true;
                }
                return false;
              })) {
                return;
              }
              var nodeToDelete = assignmentBinaryExpression.parent && assignmentBinaryExpression.parent.kind === 238 ? assignmentBinaryExpression.parent : assignmentBinaryExpression;
              changes.delete(sourceFile, nodeToDelete);
              if (!assignmentExpr) {
                members.push(ts3.factory.createPropertyDeclaration([], modifiers, symbol2.name, void 0, void 0, void 0));
                return;
              }
              if (ts3.isAccessExpression(memberDeclaration) && (ts3.isFunctionExpression(assignmentExpr) || ts3.isArrowFunction(assignmentExpr))) {
                var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
                var name = tryGetPropertyName(memberDeclaration, compilerOptions, quotePreference);
                if (name) {
                  createFunctionLikeExpressionMember(members, assignmentExpr, name);
                }
                return;
              } else if (ts3.isObjectLiteralExpression(assignmentExpr)) {
                ts3.forEach(assignmentExpr.properties, function(property) {
                  if (ts3.isMethodDeclaration(property) || ts3.isGetOrSetAccessorDeclaration(property)) {
                    members.push(property);
                  }
                  if (ts3.isPropertyAssignment(property) && ts3.isFunctionExpression(property.initializer)) {
                    createFunctionLikeExpressionMember(members, property.initializer, property.name);
                  }
                  if (isConstructorAssignment(property))
                    return;
                  return;
                });
                return;
              } else {
                if (ts3.isSourceFileJS(sourceFile))
                  return;
                if (!ts3.isPropertyAccessExpression(memberDeclaration))
                  return;
                var prop = ts3.factory.createPropertyDeclaration(void 0, modifiers, memberDeclaration.name, void 0, void 0, assignmentExpr);
                ts3.copyLeadingComments(assignmentBinaryExpression.parent, prop, sourceFile);
                members.push(prop);
                return;
              }
              function createFunctionLikeExpressionMember(members2, expression, name2) {
                if (ts3.isFunctionExpression(expression))
                  return createFunctionExpressionMember(members2, expression, name2);
                else
                  return createArrowFunctionExpressionMember(members2, expression, name2);
              }
              function createFunctionExpressionMember(members2, functionExpression, name2) {
                var fullModifiers = ts3.concatenate(modifiers, getModifierKindFromSource(functionExpression, 131));
                var method = ts3.factory.createMethodDeclaration(void 0, fullModifiers, void 0, name2, void 0, void 0, functionExpression.parameters, void 0, functionExpression.body);
                ts3.copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
                members2.push(method);
                return;
              }
              function createArrowFunctionExpressionMember(members2, arrowFunction, name2) {
                var arrowFunctionBody = arrowFunction.body;
                var bodyBlock;
                if (arrowFunctionBody.kind === 235) {
                  bodyBlock = arrowFunctionBody;
                } else {
                  bodyBlock = ts3.factory.createBlock([ts3.factory.createReturnStatement(arrowFunctionBody)]);
                }
                var fullModifiers = ts3.concatenate(modifiers, getModifierKindFromSource(arrowFunction, 131));
                var method = ts3.factory.createMethodDeclaration(void 0, fullModifiers, void 0, name2, void 0, void 0, arrowFunction.parameters, void 0, bodyBlock);
                ts3.copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
                members2.push(method);
              }
            }
          }
          function createClassFromVariableDeclaration(node) {
            var initializer = node.initializer;
            if (!initializer || !ts3.isFunctionExpression(initializer) || !ts3.isIdentifier(node.name)) {
              return void 0;
            }
            var memberElements = createClassElementsFromSymbol(node.symbol);
            if (initializer.body) {
              memberElements.unshift(ts3.factory.createConstructorDeclaration(void 0, void 0, initializer.parameters, initializer.body));
            }
            var modifiers = getModifierKindFromSource(node.parent.parent, 93);
            var cls = ts3.factory.createClassDeclaration(void 0, modifiers, node.name, void 0, void 0, memberElements);
            return cls;
          }
          function createClassFromFunctionDeclaration(node) {
            var memberElements = createClassElementsFromSymbol(ctorSymbol);
            if (node.body) {
              memberElements.unshift(ts3.factory.createConstructorDeclaration(void 0, void 0, node.parameters, node.body));
            }
            var modifiers = getModifierKindFromSource(node, 93);
            var cls = ts3.factory.createClassDeclaration(void 0, modifiers, node.name, void 0, void 0, memberElements);
            return cls;
          }
        }
        function getModifierKindFromSource(source, kind) {
          return ts3.filter(source.modifiers, function(modifier) {
            return modifier.kind === kind;
          });
        }
        function isConstructorAssignment(x) {
          if (!x.name)
            return false;
          if (ts3.isIdentifier(x.name) && x.name.text === "constructor")
            return true;
          return false;
        }
        function tryGetPropertyName(node, compilerOptions, quotePreference) {
          if (ts3.isPropertyAccessExpression(node)) {
            return node.name;
          }
          var propName = node.argumentExpression;
          if (ts3.isNumericLiteral(propName)) {
            return propName;
          }
          if (ts3.isStringLiteralLike(propName)) {
            return ts3.isIdentifierText(propName.text, ts3.getEmitScriptTarget(compilerOptions)) ? ts3.factory.createIdentifier(propName.text) : ts3.isNoSubstitutionTemplateLiteral(propName) ? ts3.factory.createStringLiteral(propName.text, quotePreference === 0) : propName;
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertToAsyncFunction";
        var errorCodes = [ts3.Diagnostics.This_may_be_converted_to_an_async_function.code];
        var codeActionSucceeded = true;
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            codeActionSucceeded = true;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return convertToAsyncFunction(t, context.sourceFile, context.span.start, context.program.getTypeChecker());
            });
            return codeActionSucceeded ? [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_async_function, fixId, ts3.Diagnostics.Convert_all_to_async_functions)] : [];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              return convertToAsyncFunction(changes, err.file, err.start, context.program.getTypeChecker());
            });
          }
        });
        var SynthBindingNameKind;
        (function(SynthBindingNameKind2) {
          SynthBindingNameKind2[SynthBindingNameKind2["Identifier"] = 0] = "Identifier";
          SynthBindingNameKind2[SynthBindingNameKind2["BindingPattern"] = 1] = "BindingPattern";
        })(SynthBindingNameKind || (SynthBindingNameKind = {}));
        function convertToAsyncFunction(changes, sourceFile, position, checker) {
          var tokenAtPosition = ts3.getTokenAtPosition(sourceFile, position);
          var functionToConvert;
          if (ts3.isIdentifier(tokenAtPosition) && ts3.isVariableDeclaration(tokenAtPosition.parent) && tokenAtPosition.parent.initializer && ts3.isFunctionLikeDeclaration(tokenAtPosition.parent.initializer)) {
            functionToConvert = tokenAtPosition.parent.initializer;
          } else {
            functionToConvert = ts3.tryCast(ts3.getContainingFunction(ts3.getTokenAtPosition(sourceFile, position)), ts3.canBeConvertedToAsync);
          }
          if (!functionToConvert) {
            return;
          }
          var synthNamesMap = new ts3.Map();
          var isInJavascript = ts3.isInJSFile(functionToConvert);
          var setOfExpressionsToReturn = getAllPromiseExpressionsToReturn(functionToConvert, checker);
          var functionToConvertRenamed = renameCollidingVarNames(functionToConvert, checker, synthNamesMap);
          if (!ts3.returnsPromise(functionToConvertRenamed, checker)) {
            return;
          }
          var returnStatements = functionToConvertRenamed.body && ts3.isBlock(functionToConvertRenamed.body) ? getReturnStatementsWithPromiseHandlers(functionToConvertRenamed.body, checker) : ts3.emptyArray;
          var transformer = { checker, synthNamesMap, setOfExpressionsToReturn, isInJSFile: isInJavascript };
          if (!returnStatements.length) {
            return;
          }
          var pos = functionToConvert.modifiers ? functionToConvert.modifiers.end : functionToConvert.decorators ? ts3.skipTrivia(sourceFile.text, functionToConvert.decorators.end) : functionToConvert.getStart(sourceFile);
          var options = functionToConvert.modifiers ? { prefix: " " } : { suffix: " " };
          changes.insertModifierAt(sourceFile, pos, 131, options);
          var _loop_14 = function(returnStatement2) {
            ts3.forEachChild(returnStatement2, function visit(node) {
              if (ts3.isCallExpression(node)) {
                var newNodes = transformExpression(node, node, transformer, false);
                if (hasFailed()) {
                  return true;
                }
                changes.replaceNodeWithNodes(sourceFile, returnStatement2, newNodes);
              } else if (!ts3.isFunctionLike(node)) {
                ts3.forEachChild(node, visit);
                if (hasFailed()) {
                  return true;
                }
              }
            });
            if (hasFailed()) {
              return { value: void 0 };
            }
          };
          for (var _i = 0, returnStatements_1 = returnStatements; _i < returnStatements_1.length; _i++) {
            var returnStatement = returnStatements_1[_i];
            var state_5 = _loop_14(returnStatement);
            if (typeof state_5 === "object")
              return state_5.value;
          }
        }
        function getReturnStatementsWithPromiseHandlers(body, checker) {
          var res = [];
          ts3.forEachReturnStatement(body, function(ret) {
            if (ts3.isReturnStatementWithFixablePromiseHandler(ret, checker))
              res.push(ret);
          });
          return res;
        }
        function getAllPromiseExpressionsToReturn(func, checker) {
          if (!func.body) {
            return new ts3.Set();
          }
          var setOfExpressionsToReturn = new ts3.Set();
          ts3.forEachChild(func.body, function visit(node) {
            if (isPromiseReturningCallExpression(node, checker, "then")) {
              setOfExpressionsToReturn.add(ts3.getNodeId(node));
              ts3.forEach(node.arguments, visit);
            } else if (isPromiseReturningCallExpression(node, checker, "catch") || isPromiseReturningCallExpression(node, checker, "finally")) {
              setOfExpressionsToReturn.add(ts3.getNodeId(node));
              ts3.forEachChild(node, visit);
            } else if (isPromiseTypedExpression(node, checker)) {
              setOfExpressionsToReturn.add(ts3.getNodeId(node));
            } else {
              ts3.forEachChild(node, visit);
            }
          });
          return setOfExpressionsToReturn;
        }
        function isPromiseReturningCallExpression(node, checker, name) {
          if (!ts3.isCallExpression(node))
            return false;
          var isExpressionOfName = ts3.hasPropertyAccessExpressionWithName(node, name);
          var nodeType = isExpressionOfName && checker.getTypeAtLocation(node);
          return !!(nodeType && checker.getPromisedTypeOfPromise(nodeType));
        }
        function isReferenceToType(type2, target) {
          return (ts3.getObjectFlags(type2) & 4) !== 0 && type2.target === target;
        }
        function getExplicitPromisedTypeOfPromiseReturningCallExpression(node, callback, checker) {
          if (node.expression.name.escapedText === "finally") {
            return void 0;
          }
          var promiseType = checker.getTypeAtLocation(node.expression.expression);
          if (isReferenceToType(promiseType, checker.getPromiseType()) || isReferenceToType(promiseType, checker.getPromiseLikeType())) {
            if (node.expression.name.escapedText === "then") {
              if (callback === ts3.elementAt(node.arguments, 0)) {
                return ts3.elementAt(node.typeArguments, 0);
              } else if (callback === ts3.elementAt(node.arguments, 1)) {
                return ts3.elementAt(node.typeArguments, 1);
              }
            } else {
              return ts3.elementAt(node.typeArguments, 0);
            }
          }
        }
        function isPromiseTypedExpression(node, checker) {
          if (!ts3.isExpression(node))
            return false;
          return !!checker.getPromisedTypeOfPromise(checker.getTypeAtLocation(node));
        }
        function renameCollidingVarNames(nodeToRename, checker, synthNamesMap) {
          var identsToRenameMap = new ts3.Map();
          var collidingSymbolMap = ts3.createMultiMap();
          ts3.forEachChild(nodeToRename, function visit(node) {
            if (!ts3.isIdentifier(node)) {
              ts3.forEachChild(node, visit);
              return;
            }
            var symbol = checker.getSymbolAtLocation(node);
            if (symbol) {
              var type2 = checker.getTypeAtLocation(node);
              var lastCallSignature = getLastCallSignature(type2, checker);
              var symbolIdString = ts3.getSymbolId(symbol).toString();
              if (lastCallSignature && !ts3.isParameter(node.parent) && !ts3.isFunctionLikeDeclaration(node.parent) && !synthNamesMap.has(symbolIdString)) {
                var firstParameter = ts3.firstOrUndefined(lastCallSignature.parameters);
                var ident = (firstParameter === null || firstParameter === void 0 ? void 0 : firstParameter.valueDeclaration) && ts3.isParameter(firstParameter.valueDeclaration) && ts3.tryCast(firstParameter.valueDeclaration.name, ts3.isIdentifier) || ts3.factory.createUniqueName("result", 16);
                var synthName = getNewNameIfConflict(ident, collidingSymbolMap);
                synthNamesMap.set(symbolIdString, synthName);
                collidingSymbolMap.add(ident.text, symbol);
              } else if (node.parent && (ts3.isParameter(node.parent) || ts3.isVariableDeclaration(node.parent) || ts3.isBindingElement(node.parent))) {
                var originalName = node.text;
                var collidingSymbols = collidingSymbolMap.get(originalName);
                if (collidingSymbols && collidingSymbols.some(function(prevSymbol) {
                  return prevSymbol !== symbol;
                })) {
                  var newName = getNewNameIfConflict(node, collidingSymbolMap);
                  identsToRenameMap.set(symbolIdString, newName.identifier);
                  synthNamesMap.set(symbolIdString, newName);
                  collidingSymbolMap.add(originalName, symbol);
                } else {
                  var identifier = ts3.getSynthesizedDeepClone(node);
                  synthNamesMap.set(symbolIdString, createSynthIdentifier(identifier));
                  collidingSymbolMap.add(originalName, symbol);
                }
              }
            }
          });
          return ts3.getSynthesizedDeepCloneWithReplacements(nodeToRename, true, function(original) {
            if (ts3.isBindingElement(original) && ts3.isIdentifier(original.name) && ts3.isObjectBindingPattern(original.parent)) {
              var symbol = checker.getSymbolAtLocation(original.name);
              var renameInfo = symbol && identsToRenameMap.get(String(ts3.getSymbolId(symbol)));
              if (renameInfo && renameInfo.text !== (original.name || original.propertyName).getText()) {
                return ts3.factory.createBindingElement(original.dotDotDotToken, original.propertyName || original.name, renameInfo, original.initializer);
              }
            } else if (ts3.isIdentifier(original)) {
              var symbol = checker.getSymbolAtLocation(original);
              var renameInfo = symbol && identsToRenameMap.get(String(ts3.getSymbolId(symbol)));
              if (renameInfo) {
                return ts3.factory.createIdentifier(renameInfo.text);
              }
            }
          });
        }
        function getNewNameIfConflict(name, originalNames) {
          var numVarsSameName = (originalNames.get(name.text) || ts3.emptyArray).length;
          var identifier = numVarsSameName === 0 ? name : ts3.factory.createIdentifier(name.text + "_" + numVarsSameName);
          return createSynthIdentifier(identifier);
        }
        function hasFailed() {
          return !codeActionSucceeded;
        }
        function silentFail() {
          codeActionSucceeded = false;
          return ts3.emptyArray;
        }
        function transformExpression(returnContextNode, node, transformer, hasContinuation, continuationArgName) {
          if (isPromiseReturningCallExpression(node, transformer.checker, "then")) {
            return transformThen(node, ts3.elementAt(node.arguments, 0), ts3.elementAt(node.arguments, 1), transformer, hasContinuation, continuationArgName);
          }
          if (isPromiseReturningCallExpression(node, transformer.checker, "catch")) {
            return transformCatch(node, ts3.elementAt(node.arguments, 0), transformer, hasContinuation, continuationArgName);
          }
          if (isPromiseReturningCallExpression(node, transformer.checker, "finally")) {
            return transformFinally(node, ts3.elementAt(node.arguments, 0), transformer, hasContinuation, continuationArgName);
          }
          if (ts3.isPropertyAccessExpression(node)) {
            return transformExpression(returnContextNode, node.expression, transformer, hasContinuation, continuationArgName);
          }
          var nodeType = transformer.checker.getTypeAtLocation(node);
          if (nodeType && transformer.checker.getPromisedTypeOfPromise(nodeType)) {
            ts3.Debug.assertNode(ts3.getOriginalNode(node).parent, ts3.isPropertyAccessExpression);
            return transformPromiseExpressionOfPropertyAccess(returnContextNode, node, transformer, hasContinuation, continuationArgName);
          }
          return silentFail();
        }
        function isNullOrUndefined(_a, node) {
          var checker = _a.checker;
          if (node.kind === 104)
            return true;
          if (ts3.isIdentifier(node) && !ts3.isGeneratedIdentifier(node) && ts3.idText(node) === "undefined") {
            var symbol = checker.getSymbolAtLocation(node);
            return !symbol || checker.isUndefinedSymbol(symbol);
          }
          return false;
        }
        function createUniqueSynthName(prevArgName) {
          var renamedPrevArg = ts3.factory.createUniqueName(prevArgName.identifier.text, 16);
          return createSynthIdentifier(renamedPrevArg);
        }
        function getPossibleNameForVarDecl(node, transformer, continuationArgName) {
          var possibleNameForVarDecl;
          if (continuationArgName && !shouldReturn(node, transformer)) {
            if (isSynthIdentifier(continuationArgName)) {
              possibleNameForVarDecl = continuationArgName;
              transformer.synthNamesMap.forEach(function(val, key) {
                if (val.identifier.text === continuationArgName.identifier.text) {
                  var newSynthName = createUniqueSynthName(continuationArgName);
                  transformer.synthNamesMap.set(key, newSynthName);
                }
              });
            } else {
              possibleNameForVarDecl = createSynthIdentifier(ts3.factory.createUniqueName("result", 16), continuationArgName.types);
            }
            declareSynthIdentifier(possibleNameForVarDecl);
          }
          return possibleNameForVarDecl;
        }
        function finishCatchOrFinallyTransform(node, transformer, tryStatement, possibleNameForVarDecl, continuationArgName) {
          var statements = [];
          var varDeclIdentifier;
          if (possibleNameForVarDecl && !shouldReturn(node, transformer)) {
            varDeclIdentifier = ts3.getSynthesizedDeepClone(declareSynthIdentifier(possibleNameForVarDecl));
            var typeArray = possibleNameForVarDecl.types;
            var unionType = transformer.checker.getUnionType(typeArray, 2);
            var unionTypeNode = transformer.isInJSFile ? void 0 : transformer.checker.typeToTypeNode(unionType, void 0, void 0);
            var varDecl = [ts3.factory.createVariableDeclaration(varDeclIdentifier, void 0, unionTypeNode)];
            var varDeclList = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList(varDecl, 1));
            statements.push(varDeclList);
          }
          statements.push(tryStatement);
          if (continuationArgName && varDeclIdentifier && isSynthBindingPattern(continuationArgName)) {
            statements.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
              ts3.factory.createVariableDeclaration(ts3.getSynthesizedDeepClone(declareSynthBindingPattern(continuationArgName)), void 0, void 0, varDeclIdentifier)
            ], 2)));
          }
          return statements;
        }
        function transformFinally(node, onFinally, transformer, hasContinuation, continuationArgName) {
          if (!onFinally || isNullOrUndefined(transformer, onFinally)) {
            return transformExpression(node, node.expression.expression, transformer, hasContinuation, continuationArgName);
          }
          var possibleNameForVarDecl = getPossibleNameForVarDecl(node, transformer, continuationArgName);
          var inlinedLeftHandSide = transformExpression(node, node.expression.expression, transformer, true, possibleNameForVarDecl);
          if (hasFailed())
            return silentFail();
          var inlinedCallback = transformCallbackArgument(onFinally, hasContinuation, void 0, void 0, node, transformer);
          if (hasFailed())
            return silentFail();
          var tryBlock = ts3.factory.createBlock(inlinedLeftHandSide);
          var finallyBlock = ts3.factory.createBlock(inlinedCallback);
          var tryStatement = ts3.factory.createTryStatement(tryBlock, void 0, finallyBlock);
          return finishCatchOrFinallyTransform(node, transformer, tryStatement, possibleNameForVarDecl, continuationArgName);
        }
        function transformCatch(node, onRejected, transformer, hasContinuation, continuationArgName) {
          if (!onRejected || isNullOrUndefined(transformer, onRejected)) {
            return transformExpression(node, node.expression.expression, transformer, hasContinuation, continuationArgName);
          }
          var inputArgName = getArgBindingName(onRejected, transformer);
          var possibleNameForVarDecl = getPossibleNameForVarDecl(node, transformer, continuationArgName);
          var inlinedLeftHandSide = transformExpression(node, node.expression.expression, transformer, true, possibleNameForVarDecl);
          if (hasFailed())
            return silentFail();
          var inlinedCallback = transformCallbackArgument(onRejected, hasContinuation, possibleNameForVarDecl, inputArgName, node, transformer);
          if (hasFailed())
            return silentFail();
          var tryBlock = ts3.factory.createBlock(inlinedLeftHandSide);
          var catchClause = ts3.factory.createCatchClause(inputArgName && ts3.getSynthesizedDeepClone(declareSynthBindingName(inputArgName)), ts3.factory.createBlock(inlinedCallback));
          var tryStatement = ts3.factory.createTryStatement(tryBlock, catchClause, void 0);
          return finishCatchOrFinallyTransform(node, transformer, tryStatement, possibleNameForVarDecl, continuationArgName);
        }
        function transformThen(node, onFulfilled, onRejected, transformer, hasContinuation, continuationArgName) {
          if (!onFulfilled || isNullOrUndefined(transformer, onFulfilled)) {
            return transformCatch(node, onRejected, transformer, hasContinuation, continuationArgName);
          }
          if (onRejected && !isNullOrUndefined(transformer, onRejected)) {
            return silentFail();
          }
          var inputArgName = getArgBindingName(onFulfilled, transformer);
          var inlinedLeftHandSide = transformExpression(node.expression.expression, node.expression.expression, transformer, true, inputArgName);
          if (hasFailed())
            return silentFail();
          var inlinedCallback = transformCallbackArgument(onFulfilled, hasContinuation, continuationArgName, inputArgName, node, transformer);
          if (hasFailed())
            return silentFail();
          return ts3.concatenate(inlinedLeftHandSide, inlinedCallback);
        }
        function transformPromiseExpressionOfPropertyAccess(returnContextNode, node, transformer, hasContinuation, continuationArgName) {
          if (shouldReturn(returnContextNode, transformer)) {
            var returnValue = ts3.getSynthesizedDeepClone(node);
            if (hasContinuation) {
              returnValue = ts3.factory.createAwaitExpression(returnValue);
            }
            return [ts3.factory.createReturnStatement(returnValue)];
          }
          return createVariableOrAssignmentOrExpressionStatement(continuationArgName, ts3.factory.createAwaitExpression(node), void 0);
        }
        function createVariableOrAssignmentOrExpressionStatement(variableName, rightHandSide, typeAnnotation) {
          if (!variableName || isEmptyBindingName(variableName)) {
            return [ts3.factory.createExpressionStatement(rightHandSide)];
          }
          if (isSynthIdentifier(variableName) && variableName.hasBeenDeclared) {
            return [ts3.factory.createExpressionStatement(ts3.factory.createAssignment(ts3.getSynthesizedDeepClone(referenceSynthIdentifier(variableName)), rightHandSide))];
          }
          return [
            ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
              ts3.factory.createVariableDeclaration(ts3.getSynthesizedDeepClone(declareSynthBindingName(variableName)), void 0, typeAnnotation, rightHandSide)
            ], 2))
          ];
        }
        function maybeAnnotateAndReturn(expressionToReturn, typeAnnotation) {
          if (typeAnnotation && expressionToReturn) {
            var name = ts3.factory.createUniqueName("result", 16);
            return __spreadArray(__spreadArray([], createVariableOrAssignmentOrExpressionStatement(createSynthIdentifier(name), expressionToReturn, typeAnnotation), true), [
              ts3.factory.createReturnStatement(name)
            ], false);
          }
          return [ts3.factory.createReturnStatement(expressionToReturn)];
        }
        function transformCallbackArgument(func, hasContinuation, continuationArgName, inputArgName, parent, transformer) {
          var _a;
          switch (func.kind) {
            case 104:
              break;
            case 206:
            case 79:
              if (!inputArgName) {
                break;
              }
              var synthCall = ts3.factory.createCallExpression(ts3.getSynthesizedDeepClone(func), void 0, isSynthIdentifier(inputArgName) ? [referenceSynthIdentifier(inputArgName)] : []);
              if (shouldReturn(parent, transformer)) {
                return maybeAnnotateAndReturn(synthCall, getExplicitPromisedTypeOfPromiseReturningCallExpression(parent, func, transformer.checker));
              }
              var type2 = transformer.checker.getTypeAtLocation(func);
              var callSignatures = transformer.checker.getSignaturesOfType(type2, 0);
              if (!callSignatures.length) {
                return silentFail();
              }
              var returnType = callSignatures[0].getReturnType();
              var varDeclOrAssignment = createVariableOrAssignmentOrExpressionStatement(continuationArgName, ts3.factory.createAwaitExpression(synthCall), getExplicitPromisedTypeOfPromiseReturningCallExpression(parent, func, transformer.checker));
              if (continuationArgName) {
                continuationArgName.types.push(transformer.checker.getAwaitedType(returnType) || returnType);
              }
              return varDeclOrAssignment;
            case 213:
            case 214: {
              var funcBody = func.body;
              var returnType_1 = (_a = getLastCallSignature(transformer.checker.getTypeAtLocation(func), transformer.checker)) === null || _a === void 0 ? void 0 : _a.getReturnType();
              if (ts3.isBlock(funcBody)) {
                var refactoredStmts = [];
                var seenReturnStatement = false;
                for (var _i = 0, _b = funcBody.statements; _i < _b.length; _i++) {
                  var statement = _b[_i];
                  if (ts3.isReturnStatement(statement)) {
                    seenReturnStatement = true;
                    if (ts3.isReturnStatementWithFixablePromiseHandler(statement, transformer.checker)) {
                      refactoredStmts = refactoredStmts.concat(transformReturnStatementWithFixablePromiseHandler(transformer, statement, hasContinuation, continuationArgName));
                    } else {
                      var possiblyAwaitedRightHandSide = returnType_1 && statement.expression ? getPossiblyAwaitedRightHandSide(transformer.checker, returnType_1, statement.expression) : statement.expression;
                      refactoredStmts.push.apply(refactoredStmts, maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, getExplicitPromisedTypeOfPromiseReturningCallExpression(parent, func, transformer.checker)));
                    }
                  } else if (hasContinuation && ts3.forEachReturnStatement(statement, ts3.returnTrue)) {
                    return silentFail();
                  } else {
                    refactoredStmts.push(statement);
                  }
                }
                return shouldReturn(parent, transformer) ? refactoredStmts.map(function(s) {
                  return ts3.getSynthesizedDeepClone(s);
                }) : removeReturns(refactoredStmts, continuationArgName, transformer, seenReturnStatement);
              } else {
                var inlinedStatements = ts3.isFixablePromiseHandler(funcBody, transformer.checker) ? transformReturnStatementWithFixablePromiseHandler(transformer, ts3.factory.createReturnStatement(funcBody), hasContinuation, continuationArgName) : ts3.emptyArray;
                if (inlinedStatements.length > 0) {
                  return inlinedStatements;
                }
                if (returnType_1) {
                  var possiblyAwaitedRightHandSide = getPossiblyAwaitedRightHandSide(transformer.checker, returnType_1, funcBody);
                  if (!shouldReturn(parent, transformer)) {
                    var transformedStatement = createVariableOrAssignmentOrExpressionStatement(continuationArgName, possiblyAwaitedRightHandSide, void 0);
                    if (continuationArgName) {
                      continuationArgName.types.push(transformer.checker.getAwaitedType(returnType_1) || returnType_1);
                    }
                    return transformedStatement;
                  } else {
                    return maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, getExplicitPromisedTypeOfPromiseReturningCallExpression(parent, func, transformer.checker));
                  }
                } else {
                  return silentFail();
                }
              }
            }
            default:
              return silentFail();
          }
          return ts3.emptyArray;
        }
        function getPossiblyAwaitedRightHandSide(checker, type2, expr) {
          var rightHandSide = ts3.getSynthesizedDeepClone(expr);
          return !!checker.getPromisedTypeOfPromise(type2) ? ts3.factory.createAwaitExpression(rightHandSide) : rightHandSide;
        }
        function getLastCallSignature(type2, checker) {
          var callSignatures = checker.getSignaturesOfType(type2, 0);
          return ts3.lastOrUndefined(callSignatures);
        }
        function removeReturns(stmts, prevArgName, transformer, seenReturnStatement) {
          var ret = [];
          for (var _i = 0, stmts_1 = stmts; _i < stmts_1.length; _i++) {
            var stmt = stmts_1[_i];
            if (ts3.isReturnStatement(stmt)) {
              if (stmt.expression) {
                var possiblyAwaitedExpression = isPromiseTypedExpression(stmt.expression, transformer.checker) ? ts3.factory.createAwaitExpression(stmt.expression) : stmt.expression;
                if (prevArgName === void 0) {
                  ret.push(ts3.factory.createExpressionStatement(possiblyAwaitedExpression));
                } else if (isSynthIdentifier(prevArgName) && prevArgName.hasBeenDeclared) {
                  ret.push(ts3.factory.createExpressionStatement(ts3.factory.createAssignment(referenceSynthIdentifier(prevArgName), possiblyAwaitedExpression)));
                } else {
                  ret.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(declareSynthBindingName(prevArgName), void 0, void 0, possiblyAwaitedExpression)], 2)));
                }
              }
            } else {
              ret.push(ts3.getSynthesizedDeepClone(stmt));
            }
          }
          if (!seenReturnStatement && prevArgName !== void 0) {
            ret.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(declareSynthBindingName(prevArgName), void 0, void 0, ts3.factory.createIdentifier("undefined"))], 2)));
          }
          return ret;
        }
        function transformReturnStatementWithFixablePromiseHandler(transformer, innerRetStmt, hasContinuation, continuationArgName) {
          var innerCbBody = [];
          ts3.forEachChild(innerRetStmt, function visit(node) {
            if (ts3.isCallExpression(node)) {
              var temp = transformExpression(node, node, transformer, hasContinuation, continuationArgName);
              innerCbBody = innerCbBody.concat(temp);
              if (innerCbBody.length > 0) {
                return;
              }
            } else if (!ts3.isFunctionLike(node)) {
              ts3.forEachChild(node, visit);
            }
          });
          return innerCbBody;
        }
        function getArgBindingName(funcNode, transformer) {
          var types2 = [];
          var name;
          if (ts3.isFunctionLikeDeclaration(funcNode)) {
            if (funcNode.parameters.length > 0) {
              var param = funcNode.parameters[0].name;
              name = getMappedBindingNameOrDefault(param);
            }
          } else if (ts3.isIdentifier(funcNode)) {
            name = getMapEntryOrDefault(funcNode);
          } else if (ts3.isPropertyAccessExpression(funcNode) && ts3.isIdentifier(funcNode.name)) {
            name = getMapEntryOrDefault(funcNode.name);
          }
          if (!name || "identifier" in name && name.identifier.text === "undefined") {
            return void 0;
          }
          return name;
          function getMappedBindingNameOrDefault(bindingName) {
            if (ts3.isIdentifier(bindingName))
              return getMapEntryOrDefault(bindingName);
            var elements = ts3.flatMap(bindingName.elements, function(element) {
              if (ts3.isOmittedExpression(element))
                return [];
              return [getMappedBindingNameOrDefault(element.name)];
            });
            return createSynthBindingPattern(bindingName, elements);
          }
          function getMapEntryOrDefault(identifier) {
            var originalNode = getOriginalNode(identifier);
            var symbol = getSymbol(originalNode);
            if (!symbol) {
              return createSynthIdentifier(identifier, types2);
            }
            var mapEntry = transformer.synthNamesMap.get(ts3.getSymbolId(symbol).toString());
            return mapEntry || createSynthIdentifier(identifier, types2);
          }
          function getSymbol(node) {
            return node.symbol ? node.symbol : transformer.checker.getSymbolAtLocation(node);
          }
          function getOriginalNode(node) {
            return node.original ? node.original : node;
          }
        }
        function isEmptyBindingName(bindingName) {
          if (!bindingName) {
            return true;
          }
          if (isSynthIdentifier(bindingName)) {
            return !bindingName.identifier.text;
          }
          return ts3.every(bindingName.elements, isEmptyBindingName);
        }
        function createSynthIdentifier(identifier, types2) {
          if (types2 === void 0) {
            types2 = [];
          }
          return { kind: 0, identifier, types: types2, hasBeenDeclared: false, hasBeenReferenced: false };
        }
        function createSynthBindingPattern(bindingPattern, elements, types2) {
          if (elements === void 0) {
            elements = ts3.emptyArray;
          }
          if (types2 === void 0) {
            types2 = [];
          }
          return { kind: 1, bindingPattern, elements, types: types2 };
        }
        function referenceSynthIdentifier(synthId) {
          synthId.hasBeenReferenced = true;
          return synthId.identifier;
        }
        function declareSynthBindingName(synthName) {
          return isSynthIdentifier(synthName) ? declareSynthIdentifier(synthName) : declareSynthBindingPattern(synthName);
        }
        function declareSynthBindingPattern(synthPattern) {
          for (var _i = 0, _a = synthPattern.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            declareSynthBindingName(element);
          }
          return synthPattern.bindingPattern;
        }
        function declareSynthIdentifier(synthId) {
          synthId.hasBeenDeclared = true;
          return synthId.identifier;
        }
        function isSynthIdentifier(bindingName) {
          return bindingName.kind === 0;
        }
        function isSynthBindingPattern(bindingName) {
          return bindingName.kind === 1;
        }
        function shouldReturn(expression, transformer) {
          return !!expression.original && transformer.setOfExpressionsToReturn.has(ts3.getNodeId(expression.original));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [ts3.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module.code],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, preferences = context.preferences;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              var moduleExportsChangedToDefault = convertFileToEsModule(sourceFile, program2.getTypeChecker(), changes2, ts3.getEmitScriptTarget(program2.getCompilerOptions()), ts3.getQuotePreference(sourceFile, preferences));
              if (moduleExportsChangedToDefault) {
                for (var _i = 0, _a = program2.getSourceFiles(); _i < _a.length; _i++) {
                  var importingFile = _a[_i];
                  fixImportOfModuleExports(importingFile, sourceFile, changes2, ts3.getQuotePreference(importingFile, preferences));
                }
              }
            });
            return [codefix2.createCodeFixActionWithoutFixAll("convertToEsModule", changes, ts3.Diagnostics.Convert_to_ES_module)];
          }
        });
        function fixImportOfModuleExports(importingFile, exportingFile, changes, quotePreference) {
          for (var _i = 0, _a = importingFile.imports; _i < _a.length; _i++) {
            var moduleSpecifier = _a[_i];
            var imported = ts3.getResolvedModule(importingFile, moduleSpecifier.text, ts3.getModeForUsageLocation(importingFile, moduleSpecifier));
            if (!imported || imported.resolvedFileName !== exportingFile.fileName) {
              continue;
            }
            var importNode = ts3.importFromModuleSpecifier(moduleSpecifier);
            switch (importNode.kind) {
              case 265:
                changes.replaceNode(importingFile, importNode, ts3.makeImport(importNode.name, void 0, moduleSpecifier, quotePreference));
                break;
              case 208:
                if (ts3.isRequireCall(importNode, false)) {
                  changes.replaceNode(importingFile, importNode, ts3.factory.createPropertyAccessExpression(ts3.getSynthesizedDeepClone(importNode), "default"));
                }
                break;
            }
          }
        }
        function convertFileToEsModule(sourceFile, checker, changes, target, quotePreference) {
          var identifiers = { original: collectFreeIdentifiers(sourceFile), additional: new ts3.Set() };
          var exports2 = collectExportRenames(sourceFile, checker, identifiers);
          convertExportsAccesses(sourceFile, exports2, changes);
          var moduleExportsChangedToDefault = false;
          var useSitesToUnqualify;
          for (var _i = 0, _a = ts3.filter(sourceFile.statements, ts3.isVariableStatement); _i < _a.length; _i++) {
            var statement = _a[_i];
            var newUseSites = convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
            if (newUseSites) {
              ts3.copyEntries(newUseSites, useSitesToUnqualify !== null && useSitesToUnqualify !== void 0 ? useSitesToUnqualify : useSitesToUnqualify = new ts3.Map());
            }
          }
          for (var _b = 0, _c = ts3.filter(sourceFile.statements, function(s) {
            return !ts3.isVariableStatement(s);
          }); _b < _c.length; _b++) {
            var statement = _c[_b];
            var moduleExportsChanged = convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports2, useSitesToUnqualify, quotePreference);
            moduleExportsChangedToDefault = moduleExportsChangedToDefault || moduleExportsChanged;
          }
          useSitesToUnqualify === null || useSitesToUnqualify === void 0 ? void 0 : useSitesToUnqualify.forEach(function(replacement, original) {
            changes.replaceNode(sourceFile, original, replacement);
          });
          return moduleExportsChangedToDefault;
        }
        function collectExportRenames(sourceFile, checker, identifiers) {
          var res = new ts3.Map();
          forEachExportReference(sourceFile, function(node) {
            var _a = node.name, text = _a.text, originalKeywordKind = _a.originalKeywordKind;
            if (!res.has(text) && (originalKeywordKind !== void 0 && ts3.isNonContextualKeyword(originalKeywordKind) || checker.resolveName(text, node, 111551, true))) {
              res.set(text, makeUniqueName("_".concat(text), identifiers));
            }
          });
          return res;
        }
        function convertExportsAccesses(sourceFile, exports2, changes) {
          forEachExportReference(sourceFile, function(node, isAssignmentLhs) {
            if (isAssignmentLhs) {
              return;
            }
            var text = node.name.text;
            changes.replaceNode(sourceFile, node, ts3.factory.createIdentifier(exports2.get(text) || text));
          });
        }
        function forEachExportReference(sourceFile, cb) {
          sourceFile.forEachChild(function recur(node) {
            if (ts3.isPropertyAccessExpression(node) && ts3.isExportsOrModuleExportsOrAlias(sourceFile, node.expression) && ts3.isIdentifier(node.name)) {
              var parent = node.parent;
              cb(node, ts3.isBinaryExpression(parent) && parent.left === node && parent.operatorToken.kind === 63);
            }
            node.forEachChild(recur);
          });
        }
        function convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports2, useSitesToUnqualify, quotePreference) {
          switch (statement.kind) {
            case 237:
              convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
              return false;
            case 238: {
              var expression = statement.expression;
              switch (expression.kind) {
                case 208: {
                  if (ts3.isRequireCall(expression, true)) {
                    changes.replaceNode(sourceFile, statement, ts3.makeImport(void 0, void 0, expression.arguments[0], quotePreference));
                  }
                  return false;
                }
                case 221: {
                  var operatorToken = expression.operatorToken;
                  return operatorToken.kind === 63 && convertAssignment(sourceFile, checker, expression, changes, exports2, useSitesToUnqualify);
                }
              }
            }
            default:
              return false;
          }
        }
        function convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference) {
          var declarationList = statement.declarationList;
          var foundImport = false;
          var converted = ts3.map(declarationList.declarations, function(decl) {
            var name = decl.name, initializer = decl.initializer;
            if (initializer) {
              if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, initializer)) {
                foundImport = true;
                return convertedImports([]);
              } else if (ts3.isRequireCall(initializer, true)) {
                foundImport = true;
                return convertSingleImport(name, initializer.arguments[0], checker, identifiers, target, quotePreference);
              } else if (ts3.isPropertyAccessExpression(initializer) && ts3.isRequireCall(initializer.expression, true)) {
                foundImport = true;
                return convertPropertyAccessImport(name, initializer.name.text, initializer.expression.arguments[0], identifiers, quotePreference);
              }
            }
            return convertedImports([ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([decl], declarationList.flags))]);
          });
          if (foundImport) {
            changes.replaceNodeWithNodes(sourceFile, statement, ts3.flatMap(converted, function(c) {
              return c.newImports;
            }));
            var combinedUseSites_1;
            ts3.forEach(converted, function(c) {
              if (c.useSitesToUnqualify) {
                ts3.copyEntries(c.useSitesToUnqualify, combinedUseSites_1 !== null && combinedUseSites_1 !== void 0 ? combinedUseSites_1 : combinedUseSites_1 = new ts3.Map());
              }
            });
            return combinedUseSites_1;
          }
        }
        function convertPropertyAccessImport(name, propertyName, moduleSpecifier, identifiers, quotePreference) {
          switch (name.kind) {
            case 201:
            case 202: {
              var tmp = makeUniqueName(propertyName, identifiers);
              return convertedImports([
                makeSingleImport(tmp, propertyName, moduleSpecifier, quotePreference),
                makeConst(void 0, name, ts3.factory.createIdentifier(tmp))
              ]);
            }
            case 79:
              return convertedImports([makeSingleImport(name.text, propertyName, moduleSpecifier, quotePreference)]);
            default:
              return ts3.Debug.assertNever(name, "Convert to ES module got invalid syntax form ".concat(name.kind));
          }
        }
        function convertAssignment(sourceFile, checker, assignment, changes, exports2, useSitesToUnqualify) {
          var left = assignment.left, right = assignment.right;
          if (!ts3.isPropertyAccessExpression(left)) {
            return false;
          }
          if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, left)) {
            if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, right)) {
              changes.delete(sourceFile, assignment.parent);
            } else {
              var replacement = ts3.isObjectLiteralExpression(right) ? tryChangeModuleExportsObject(right, useSitesToUnqualify) : ts3.isRequireCall(right, true) ? convertReExportAll(right.arguments[0], checker) : void 0;
              if (replacement) {
                changes.replaceNodeWithNodes(sourceFile, assignment.parent, replacement[0]);
                return replacement[1];
              } else {
                changes.replaceRangeWithText(sourceFile, ts3.createRange(left.getStart(sourceFile), right.pos), "export default");
                return true;
              }
            }
          } else if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, left.expression)) {
            convertNamedExport(sourceFile, assignment, changes, exports2);
          }
          return false;
        }
        function tryChangeModuleExportsObject(object2, useSitesToUnqualify) {
          var statements = ts3.mapAllOrFail(object2.properties, function(prop) {
            switch (prop.kind) {
              case 172:
              case 173:
              case 297:
              case 298:
                return void 0;
              case 296:
                return !ts3.isIdentifier(prop.name) ? void 0 : convertExportsDotXEquals_replaceNode(prop.name.text, prop.initializer, useSitesToUnqualify);
              case 169:
                return !ts3.isIdentifier(prop.name) ? void 0 : functionExpressionToDeclaration(prop.name.text, [ts3.factory.createToken(93)], prop, useSitesToUnqualify);
              default:
                ts3.Debug.assertNever(prop, "Convert to ES6 got invalid prop kind ".concat(prop.kind));
            }
          });
          return statements && [statements, false];
        }
        function convertNamedExport(sourceFile, assignment, changes, exports2) {
          var text = assignment.left.name.text;
          var rename = exports2.get(text);
          if (rename !== void 0) {
            var newNodes = [
              makeConst(void 0, rename, assignment.right),
              makeExportDeclaration([ts3.factory.createExportSpecifier(false, rename, text)])
            ];
            changes.replaceNodeWithNodes(sourceFile, assignment.parent, newNodes);
          } else {
            convertExportsPropertyAssignment(assignment, sourceFile, changes);
          }
        }
        function convertReExportAll(reExported, checker) {
          var moduleSpecifier = reExported.text;
          var moduleSymbol = checker.getSymbolAtLocation(reExported);
          var exports2 = moduleSymbol ? moduleSymbol.exports : ts3.emptyMap;
          return exports2.has("export=") ? [[reExportDefault(moduleSpecifier)], true] : !exports2.has("default") ? [[reExportStar(moduleSpecifier)], false] : exports2.size > 1 ? [[reExportStar(moduleSpecifier), reExportDefault(moduleSpecifier)], true] : [[reExportDefault(moduleSpecifier)], true];
        }
        function reExportStar(moduleSpecifier) {
          return makeExportDeclaration(void 0, moduleSpecifier);
        }
        function reExportDefault(moduleSpecifier) {
          return makeExportDeclaration([ts3.factory.createExportSpecifier(false, void 0, "default")], moduleSpecifier);
        }
        function convertExportsPropertyAssignment(_a, sourceFile, changes) {
          var left = _a.left, right = _a.right, parent = _a.parent;
          var name = left.name.text;
          if ((ts3.isFunctionExpression(right) || ts3.isArrowFunction(right) || ts3.isClassExpression(right)) && (!right.name || right.name.text === name)) {
            changes.replaceRange(sourceFile, { pos: left.getStart(sourceFile), end: right.getStart(sourceFile) }, ts3.factory.createToken(93), { suffix: " " });
            if (!right.name)
              changes.insertName(sourceFile, right, name);
            var semi = ts3.findChildOfKind(parent, 26, sourceFile);
            if (semi)
              changes.delete(sourceFile, semi);
          } else {
            changes.replaceNodeRangeWithNodes(sourceFile, left.expression, ts3.findChildOfKind(left, 24, sourceFile), [ts3.factory.createToken(93), ts3.factory.createToken(85)], { joiner: " ", suffix: " " });
          }
        }
        function convertExportsDotXEquals_replaceNode(name, exported, useSitesToUnqualify) {
          var modifiers = [ts3.factory.createToken(93)];
          switch (exported.kind) {
            case 213: {
              var expressionName = exported.name;
              if (expressionName && expressionName.text !== name) {
                return exportConst();
              }
            }
            case 214:
              return functionExpressionToDeclaration(name, modifiers, exported, useSitesToUnqualify);
            case 226:
              return classExpressionToDeclaration(name, modifiers, exported, useSitesToUnqualify);
            default:
              return exportConst();
          }
          function exportConst() {
            return makeConst(modifiers, ts3.factory.createIdentifier(name), replaceImportUseSites(exported, useSitesToUnqualify));
          }
        }
        function replaceImportUseSites(nodeOrNodes, useSitesToUnqualify) {
          if (!useSitesToUnqualify || !ts3.some(ts3.arrayFrom(useSitesToUnqualify.keys()), function(original) {
            return ts3.rangeContainsRange(nodeOrNodes, original);
          })) {
            return nodeOrNodes;
          }
          return ts3.isArray(nodeOrNodes) ? ts3.getSynthesizedDeepClonesWithReplacements(nodeOrNodes, true, replaceNode) : ts3.getSynthesizedDeepCloneWithReplacements(nodeOrNodes, true, replaceNode);
          function replaceNode(original) {
            if (original.kind === 206) {
              var replacement = useSitesToUnqualify.get(original);
              useSitesToUnqualify.delete(original);
              return replacement;
            }
          }
        }
        function convertSingleImport(name, moduleSpecifier, checker, identifiers, target, quotePreference) {
          switch (name.kind) {
            case 201: {
              var importSpecifiers = ts3.mapAllOrFail(name.elements, function(e) {
                return e.dotDotDotToken || e.initializer || e.propertyName && !ts3.isIdentifier(e.propertyName) || !ts3.isIdentifier(e.name) ? void 0 : makeImportSpecifier(e.propertyName && e.propertyName.text, e.name.text);
              });
              if (importSpecifiers) {
                return convertedImports([ts3.makeImport(void 0, importSpecifiers, moduleSpecifier, quotePreference)]);
              }
            }
            case 202: {
              var tmp = makeUniqueName(codefix2.moduleSpecifierToValidIdentifier(moduleSpecifier.text, target), identifiers);
              return convertedImports([
                ts3.makeImport(ts3.factory.createIdentifier(tmp), void 0, moduleSpecifier, quotePreference),
                makeConst(void 0, ts3.getSynthesizedDeepClone(name), ts3.factory.createIdentifier(tmp))
              ]);
            }
            case 79:
              return convertSingleIdentifierImport(name, moduleSpecifier, checker, identifiers, quotePreference);
            default:
              return ts3.Debug.assertNever(name, "Convert to ES module got invalid name kind ".concat(name.kind));
          }
        }
        function convertSingleIdentifierImport(name, moduleSpecifier, checker, identifiers, quotePreference) {
          var nameSymbol = checker.getSymbolAtLocation(name);
          var namedBindingsNames = new ts3.Map();
          var needDefaultImport = false;
          var useSitesToUnqualify;
          for (var _i = 0, _a = identifiers.original.get(name.text); _i < _a.length; _i++) {
            var use = _a[_i];
            if (checker.getSymbolAtLocation(use) !== nameSymbol || use === name) {
              continue;
            }
            var parent = use.parent;
            if (ts3.isPropertyAccessExpression(parent)) {
              var propertyName = parent.name.text;
              if (propertyName === "default") {
                needDefaultImport = true;
                var importDefaultName = use.getText();
                (useSitesToUnqualify !== null && useSitesToUnqualify !== void 0 ? useSitesToUnqualify : useSitesToUnqualify = new ts3.Map()).set(parent, ts3.factory.createIdentifier(importDefaultName));
              } else {
                ts3.Debug.assert(parent.expression === use, "Didn't expect expression === use");
                var idName = namedBindingsNames.get(propertyName);
                if (idName === void 0) {
                  idName = makeUniqueName(propertyName, identifiers);
                  namedBindingsNames.set(propertyName, idName);
                }
                (useSitesToUnqualify !== null && useSitesToUnqualify !== void 0 ? useSitesToUnqualify : useSitesToUnqualify = new ts3.Map()).set(parent, ts3.factory.createIdentifier(idName));
              }
            } else {
              needDefaultImport = true;
            }
          }
          var namedBindings = namedBindingsNames.size === 0 ? void 0 : ts3.arrayFrom(ts3.mapIterator(namedBindingsNames.entries(), function(_a2) {
            var propertyName2 = _a2[0], idName2 = _a2[1];
            return ts3.factory.createImportSpecifier(false, propertyName2 === idName2 ? void 0 : ts3.factory.createIdentifier(propertyName2), ts3.factory.createIdentifier(idName2));
          }));
          if (!namedBindings) {
            needDefaultImport = true;
          }
          return convertedImports([ts3.makeImport(needDefaultImport ? ts3.getSynthesizedDeepClone(name) : void 0, namedBindings, moduleSpecifier, quotePreference)], useSitesToUnqualify);
        }
        function makeUniqueName(name, identifiers) {
          while (identifiers.original.has(name) || identifiers.additional.has(name)) {
            name = "_".concat(name);
          }
          identifiers.additional.add(name);
          return name;
        }
        function collectFreeIdentifiers(file) {
          var map2 = ts3.createMultiMap();
          forEachFreeIdentifier(file, function(id) {
            return map2.add(id.text, id);
          });
          return map2;
        }
        function forEachFreeIdentifier(node, cb) {
          if (ts3.isIdentifier(node) && isFreeIdentifier(node))
            cb(node);
          node.forEachChild(function(child) {
            return forEachFreeIdentifier(child, cb);
          });
        }
        function isFreeIdentifier(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 206:
              return parent.name !== node;
            case 203:
              return parent.propertyName !== node;
            case 270:
              return parent.propertyName !== node;
            default:
              return true;
          }
        }
        function functionExpressionToDeclaration(name, additionalModifiers, fn, useSitesToUnqualify) {
          return ts3.factory.createFunctionDeclaration(ts3.getSynthesizedDeepClones(fn.decorators), ts3.concatenate(additionalModifiers, ts3.getSynthesizedDeepClones(fn.modifiers)), ts3.getSynthesizedDeepClone(fn.asteriskToken), name, ts3.getSynthesizedDeepClones(fn.typeParameters), ts3.getSynthesizedDeepClones(fn.parameters), ts3.getSynthesizedDeepClone(fn.type), ts3.factory.converters.convertToFunctionBlock(replaceImportUseSites(fn.body, useSitesToUnqualify)));
        }
        function classExpressionToDeclaration(name, additionalModifiers, cls, useSitesToUnqualify) {
          return ts3.factory.createClassDeclaration(ts3.getSynthesizedDeepClones(cls.decorators), ts3.concatenate(additionalModifiers, ts3.getSynthesizedDeepClones(cls.modifiers)), name, ts3.getSynthesizedDeepClones(cls.typeParameters), ts3.getSynthesizedDeepClones(cls.heritageClauses), replaceImportUseSites(cls.members, useSitesToUnqualify));
        }
        function makeSingleImport(localName, propertyName, moduleSpecifier, quotePreference) {
          return propertyName === "default" ? ts3.makeImport(ts3.factory.createIdentifier(localName), void 0, moduleSpecifier, quotePreference) : ts3.makeImport(void 0, [makeImportSpecifier(propertyName, localName)], moduleSpecifier, quotePreference);
        }
        function makeImportSpecifier(propertyName, name) {
          return ts3.factory.createImportSpecifier(false, propertyName !== void 0 && propertyName !== name ? ts3.factory.createIdentifier(propertyName) : void 0, ts3.factory.createIdentifier(name));
        }
        function makeConst(modifiers, name, init) {
          return ts3.factory.createVariableStatement(modifiers, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(name, void 0, void 0, init)], 2));
        }
        function makeExportDeclaration(exportSpecifiers, moduleSpecifier) {
          return ts3.factory.createExportDeclaration(void 0, void 0, false, exportSpecifiers && ts3.factory.createNamedExports(exportSpecifiers), moduleSpecifier === void 0 ? void 0 : ts3.factory.createStringLiteral(moduleSpecifier));
        }
        function convertedImports(newImports, useSitesToUnqualify) {
          return {
            newImports,
            useSitesToUnqualify
          };
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "correctQualifiedNameToIndexedAccessType";
        var errorCodes = [ts3.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var qualifiedName = getQualifiedName(context.sourceFile, context.span.start);
            if (!qualifiedName)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, qualifiedName);
            });
            var newText = "".concat(qualifiedName.left.text, '["').concat(qualifiedName.right.text, '"]');
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Rewrite_as_the_indexed_access_type_0, newText], fixId, ts3.Diagnostics.Rewrite_all_as_indexed_access_types)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var q = getQualifiedName(diag.file, diag.start);
              if (q) {
                doChange(changes, diag.file, q);
              }
            });
          }
        });
        function getQualifiedName(sourceFile, pos) {
          var qualifiedName = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, pos), ts3.isQualifiedName);
          ts3.Debug.assert(!!qualifiedName, "Expected position to be owned by a qualified name.");
          return ts3.isIdentifier(qualifiedName.left) ? qualifiedName : void 0;
        }
        function doChange(changeTracker, sourceFile, qualifiedName) {
          var rightText = qualifiedName.right.text;
          var replacement = ts3.factory.createIndexedAccessTypeNode(ts3.factory.createTypeReferenceNode(qualifiedName.left, void 0), ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(rightText)));
          changeTracker.replaceNode(sourceFile, qualifiedName, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts3.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type.code];
        var fixId = "convertToTypeOnlyExport";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToConvertToTypeOnlyExport(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return fixSingleExportDeclaration(t, getExportSpecifierForDiagnosticSpan(context.span, context.sourceFile), context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_type_only_export, fixId, ts3.Diagnostics.Convert_all_re_exported_types_to_type_only_exports)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function getAllCodeActionsToConvertToTypeOnlyExport(context) {
            var fixedExportDeclarations = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var exportSpecifier = getExportSpecifierForDiagnosticSpan(diag, context.sourceFile);
              if (exportSpecifier && ts3.addToSeen(fixedExportDeclarations, ts3.getNodeId(exportSpecifier.parent.parent))) {
                fixSingleExportDeclaration(changes, exportSpecifier, context);
              }
            });
          }
        });
        function getExportSpecifierForDiagnosticSpan(span, sourceFile) {
          return ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start).parent, ts3.isExportSpecifier);
        }
        function fixSingleExportDeclaration(changes, exportSpecifier, context) {
          if (!exportSpecifier) {
            return;
          }
          var exportClause = exportSpecifier.parent;
          var exportDeclaration = exportClause.parent;
          var typeExportSpecifiers = getTypeExportSpecifiers(exportSpecifier, context);
          if (typeExportSpecifiers.length === exportClause.elements.length) {
            changes.insertModifierBefore(context.sourceFile, 152, exportClause);
          } else {
            var valueExportDeclaration = ts3.factory.updateExportDeclaration(exportDeclaration, exportDeclaration.decorators, exportDeclaration.modifiers, false, ts3.factory.updateNamedExports(exportClause, ts3.filter(exportClause.elements, function(e) {
              return !ts3.contains(typeExportSpecifiers, e);
            })), exportDeclaration.moduleSpecifier, void 0);
            var typeExportDeclaration = ts3.factory.createExportDeclaration(void 0, void 0, true, ts3.factory.createNamedExports(typeExportSpecifiers), exportDeclaration.moduleSpecifier, void 0);
            changes.replaceNode(context.sourceFile, exportDeclaration, valueExportDeclaration, {
              leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll,
              trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude
            });
            changes.insertNodeAfter(context.sourceFile, exportDeclaration, typeExportDeclaration);
          }
        }
        function getTypeExportSpecifiers(originExportSpecifier, context) {
          var exportClause = originExportSpecifier.parent;
          if (exportClause.elements.length === 1) {
            return exportClause.elements;
          }
          var diagnostics = ts3.getDiagnosticsWithinSpan(ts3.createTextSpanFromNode(exportClause), context.program.getSemanticDiagnostics(context.sourceFile, context.cancellationToken));
          return ts3.filter(exportClause.elements, function(element) {
            var _a;
            return element === originExportSpecifier || ((_a = ts3.findDiagnosticForNode(element, diagnostics)) === null || _a === void 0 ? void 0 : _a.code) === errorCodes[0];
          });
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts3.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error.code];
        var fixId = "convertToTypeOnlyImport";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToConvertToTypeOnlyImport(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              var importDeclaration = getImportDeclarationForDiagnosticSpan(context.span, context.sourceFile);
              fixSingleImportDeclaration(t, importDeclaration, context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_type_only_import, fixId, ts3.Diagnostics.Convert_all_imports_not_used_as_a_value_to_type_only_imports)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function getAllCodeActionsToConvertToTypeOnlyImport(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var importDeclaration = getImportDeclarationForDiagnosticSpan(diag, context.sourceFile);
              fixSingleImportDeclaration(changes, importDeclaration, context);
            });
          }
        });
        function getImportDeclarationForDiagnosticSpan(span, sourceFile) {
          return ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start).parent, ts3.isImportDeclaration);
        }
        function fixSingleImportDeclaration(changes, importDeclaration, context) {
          if (!(importDeclaration === null || importDeclaration === void 0 ? void 0 : importDeclaration.importClause)) {
            return;
          }
          var importClause = importDeclaration.importClause;
          changes.insertText(context.sourceFile, importDeclaration.getStart() + "import".length, " type");
          if (importClause.name && importClause.namedBindings) {
            changes.deleteNodeRangeExcludingEnd(context.sourceFile, importClause.name, importDeclaration.importClause.namedBindings);
            changes.insertNodeBefore(context.sourceFile, importDeclaration, ts3.factory.updateImportDeclaration(importDeclaration, void 0, void 0, ts3.factory.createImportClause(true, importClause.name, void 0), importDeclaration.moduleSpecifier, void 0));
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertLiteralTypeToMappedType";
        var errorCodes = [ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToConvertLiteralTypeToMappedType(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var info = getInfo(sourceFile, span.start);
            if (!info) {
              return void 0;
            }
            var name = info.name, constraint = info.constraint;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Convert_0_to_1_in_0, constraint, name], fixId, ts3.Diagnostics.Convert_all_type_literals_to_mapped_type)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info) {
                doChange(changes, diag.file, info);
              }
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (ts3.isIdentifier(token)) {
            var propertySignature = ts3.cast(token.parent.parent, ts3.isPropertySignature);
            var propertyName = token.getText(sourceFile);
            return {
              container: ts3.cast(propertySignature.parent, ts3.isTypeLiteralNode),
              typeNode: propertySignature.type,
              constraint: propertyName,
              name: propertyName === "K" ? "P" : "K"
            };
          }
          return void 0;
        }
        function doChange(changes, sourceFile, _a) {
          var container = _a.container, typeNode = _a.typeNode, constraint = _a.constraint, name = _a.name;
          changes.replaceNode(sourceFile, container, ts3.factory.createMappedTypeNode(void 0, ts3.factory.createTypeParameterDeclaration(void 0, name, ts3.factory.createTypeReferenceNode(constraint)), void 0, void 0, typeNode, void 0));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts3.Diagnostics.Class_0_incorrectly_implements_interface_1.code,
          ts3.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code
        ];
        var fixId = "fixClassIncorrectlyImplementsInterface";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var classDeclaration = getClass(sourceFile, span.start);
            return ts3.mapDefined(ts3.getEffectiveImplementsTypeNodes(classDeclaration), function(implementedTypeNode) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, t, context.preferences);
              });
              return changes.length === 0 ? void 0 : codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Implement_interface_0, implementedTypeNode.getText(sourceFile)], fixId, ts3.Diagnostics.Implement_all_unimplemented_interfaces);
            });
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenClassDeclarations = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var classDeclaration = getClass(diag.file, diag.start);
              if (ts3.addToSeen(seenClassDeclarations, ts3.getNodeId(classDeclaration))) {
                for (var _i = 0, _a = ts3.getEffectiveImplementsTypeNodes(classDeclaration); _i < _a.length; _i++) {
                  var implementedTypeNode = _a[_i];
                  addMissingDeclarations(context, implementedTypeNode, diag.file, classDeclaration, changes, context.preferences);
                }
              }
            });
          }
        });
        function getClass(sourceFile, pos) {
          return ts3.Debug.checkDefined(ts3.getContainingClass(ts3.getTokenAtPosition(sourceFile, pos)), "There should be a containing class");
        }
        function symbolPointsToNonPrivateMember(symbol) {
          return !symbol.valueDeclaration || !(ts3.getEffectiveModifierFlags(symbol.valueDeclaration) & 8);
        }
        function addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, changeTracker, preferences) {
          var checker = context.program.getTypeChecker();
          var maybeHeritageClauseSymbol = getHeritageClauseSymbolTable(classDeclaration, checker);
          var implementedType = checker.getTypeAtLocation(implementedTypeNode);
          var implementedTypeSymbols = checker.getPropertiesOfType(implementedType);
          var nonPrivateAndNotExistedInHeritageClauseMembers = implementedTypeSymbols.filter(ts3.and(symbolPointsToNonPrivateMember, function(symbol) {
            return !maybeHeritageClauseSymbol.has(symbol.escapedName);
          }));
          var classType = checker.getTypeAtLocation(classDeclaration);
          var constructor = ts3.find(classDeclaration.members, function(m) {
            return ts3.isConstructorDeclaration(m);
          });
          if (!classType.getNumberIndexType()) {
            createMissingIndexSignatureDeclaration(implementedType, 1);
          }
          if (!classType.getStringIndexType()) {
            createMissingIndexSignatureDeclaration(implementedType, 0);
          }
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, preferences, context.host);
          codefix2.createMissingMemberNodes(classDeclaration, nonPrivateAndNotExistedInHeritageClauseMembers, sourceFile, context, preferences, importAdder, function(member) {
            return insertInterfaceMemberNode(sourceFile, classDeclaration, member);
          });
          importAdder.writeFixes(changeTracker);
          function createMissingIndexSignatureDeclaration(type2, kind) {
            var indexInfoOfKind = checker.getIndexInfoOfType(type2, kind);
            if (indexInfoOfKind) {
              insertInterfaceMemberNode(sourceFile, classDeclaration, checker.indexInfoToIndexSignatureDeclaration(indexInfoOfKind, classDeclaration, void 0, codefix2.getNoopSymbolTrackerWithResolver(context)));
            }
          }
          function insertInterfaceMemberNode(sourceFile2, cls, newElement) {
            if (constructor) {
              changeTracker.insertNodeAfter(sourceFile2, constructor, newElement);
            } else {
              changeTracker.insertMemberAtStart(sourceFile2, cls, newElement);
            }
          }
        }
        function getHeritageClauseSymbolTable(classDeclaration, checker) {
          var heritageClauseNode = ts3.getEffectiveBaseTypeNode(classDeclaration);
          if (!heritageClauseNode)
            return ts3.createSymbolTable();
          var heritageClauseType = checker.getTypeAtLocation(heritageClauseNode);
          var heritageClauseTypeSymbols = checker.getPropertiesOfType(heritageClauseType);
          return ts3.createSymbolTable(heritageClauseTypeSymbols.filter(symbolPointsToNonPrivateMember));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.importFixName = "import";
        var importFixId = "fixMissingImport";
        var errorCodes = [
          ts3.Diagnostics.Cannot_find_name_0.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
          ts3.Diagnostics.Cannot_find_namespace_0.code,
          ts3.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,
          ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code,
          ts3.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code,
          ts3.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, preferences = context.preferences, sourceFile = context.sourceFile, span = context.span, program2 = context.program;
            var info = getFixesInfo(context, errorCode, span.start, true);
            if (!info)
              return void 0;
            var fixes = info.fixes, symbolName = info.symbolName, errorIdentifierText = info.errorIdentifierText;
            var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
            return fixes.map(function(fix) {
              return codeActionForFix(context, sourceFile, symbolName, fix, symbolName !== errorIdentifierText, quotePreference, program2.getCompilerOptions());
            });
          },
          fixIds: [importFixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, preferences = context.preferences, host = context.host;
            var importAdder = createImportAdderWorker(sourceFile, program2, true, preferences, host);
            codefix2.eachDiagnostic(context, errorCodes, function(diag) {
              return importAdder.addImportFromDiagnostic(diag, context);
            });
            return codefix2.createCombinedCodeActions(ts3.textChanges.ChangeTracker.with(context, importAdder.writeFixes));
          }
        });
        function createImportAdder(sourceFile, program2, preferences, host) {
          return createImportAdderWorker(sourceFile, program2, false, preferences, host);
        }
        codefix2.createImportAdder = createImportAdder;
        function createImportAdderWorker(sourceFile, program2, useAutoImportProvider, preferences, host) {
          var compilerOptions = program2.getCompilerOptions();
          var addToNamespace = [];
          var importType = [];
          var addToExisting = new ts3.Map();
          var newImports = new ts3.Map();
          return { addImportFromDiagnostic, addImportFromExportedSymbol, writeFixes, hasFixes };
          function addImportFromDiagnostic(diagnostic, context) {
            var info = getFixesInfo(context, diagnostic.code, diagnostic.start, useAutoImportProvider);
            if (!info || !info.fixes.length)
              return;
            addImport(info);
          }
          function addImportFromExportedSymbol(exportedSymbol, isValidTypeOnlyUseSite) {
            var moduleSymbol = ts3.Debug.checkDefined(exportedSymbol.parent);
            var symbolName = ts3.getNameForExportedSymbol(exportedSymbol, ts3.getEmitScriptTarget(compilerOptions));
            var checker = program2.getTypeChecker();
            var symbol = checker.getMergedSymbol(ts3.skipAlias(exportedSymbol, checker));
            var exportInfo = getAllReExportingModules(sourceFile, symbol, moduleSymbol, symbolName, false, host, program2, preferences, useAutoImportProvider);
            var useRequire = shouldUseRequire(sourceFile, program2);
            var fix = getImportFixForSymbol(sourceFile, exportInfo, moduleSymbol, program2, void 0, !!isValidTypeOnlyUseSite, useRequire, host, preferences);
            if (fix) {
              addImport({ fixes: [fix], symbolName, errorIdentifierText: void 0 });
            }
          }
          function addImport(info) {
            var _a, _b;
            var fixes = info.fixes, symbolName = info.symbolName;
            var fix = ts3.first(fixes);
            switch (fix.kind) {
              case 0:
                addToNamespace.push(fix);
                break;
              case 1:
                importType.push(fix);
                break;
              case 2: {
                var importClauseOrBindingPattern = fix.importClauseOrBindingPattern, importKind = fix.importKind, addAsTypeOnly = fix.addAsTypeOnly;
                var key = String(ts3.getNodeId(importClauseOrBindingPattern));
                var entry = addToExisting.get(key);
                if (!entry) {
                  addToExisting.set(key, entry = { importClauseOrBindingPattern, defaultImport: void 0, namedImports: new ts3.Map() });
                }
                if (importKind === 0) {
                  var prevValue = entry === null || entry === void 0 ? void 0 : entry.namedImports.get(symbolName);
                  entry.namedImports.set(symbolName, reduceAddAsTypeOnlyValues(prevValue, addAsTypeOnly));
                } else {
                  ts3.Debug.assert(entry.defaultImport === void 0 || entry.defaultImport.name === symbolName, "(Add to Existing) Default import should be missing or match symbolName");
                  entry.defaultImport = {
                    name: symbolName,
                    addAsTypeOnly: reduceAddAsTypeOnlyValues((_a = entry.defaultImport) === null || _a === void 0 ? void 0 : _a.addAsTypeOnly, addAsTypeOnly)
                  };
                }
                break;
              }
              case 3: {
                var moduleSpecifier = fix.moduleSpecifier, importKind = fix.importKind, useRequire = fix.useRequire, addAsTypeOnly = fix.addAsTypeOnly;
                var entry = getNewImportEntry(moduleSpecifier, importKind, useRequire, addAsTypeOnly);
                ts3.Debug.assert(entry.useRequire === useRequire, "(Add new) Tried to add an `import` and a `require` for the same module");
                switch (importKind) {
                  case 1:
                    ts3.Debug.assert(entry.defaultImport === void 0 || entry.defaultImport.name === symbolName, "(Add new) Default import should be missing or match symbolName");
                    entry.defaultImport = { name: symbolName, addAsTypeOnly: reduceAddAsTypeOnlyValues((_b = entry.defaultImport) === null || _b === void 0 ? void 0 : _b.addAsTypeOnly, addAsTypeOnly) };
                    break;
                  case 0:
                    var prevValue = (entry.namedImports || (entry.namedImports = new ts3.Map())).get(symbolName);
                    entry.namedImports.set(symbolName, reduceAddAsTypeOnlyValues(prevValue, addAsTypeOnly));
                    break;
                  case 3:
                  case 2:
                    ts3.Debug.assert(entry.namespaceLikeImport === void 0 || entry.namespaceLikeImport.name === symbolName, "Namespacelike import shoudl be missing or match symbolName");
                    entry.namespaceLikeImport = { importKind, name: symbolName, addAsTypeOnly };
                    break;
                }
                break;
              }
              case 4:
                break;
              default:
                ts3.Debug.assertNever(fix, "fix wasn't never - got kind ".concat(fix.kind));
            }
            function reduceAddAsTypeOnlyValues(prevValue2, newValue) {
              return Math.max(prevValue2 !== null && prevValue2 !== void 0 ? prevValue2 : 0, newValue);
            }
            function getNewImportEntry(moduleSpecifier2, importKind2, useRequire2, addAsTypeOnly2) {
              var typeOnlyKey = newImportsKey(moduleSpecifier2, true);
              var nonTypeOnlyKey = newImportsKey(moduleSpecifier2, false);
              var typeOnlyEntry = newImports.get(typeOnlyKey);
              var nonTypeOnlyEntry = newImports.get(nonTypeOnlyKey);
              var newEntry = {
                defaultImport: void 0,
                namedImports: void 0,
                namespaceLikeImport: void 0,
                useRequire: useRequire2
              };
              if (importKind2 === 1 && addAsTypeOnly2 === 2) {
                if (typeOnlyEntry)
                  return typeOnlyEntry;
                newImports.set(typeOnlyKey, newEntry);
                return newEntry;
              }
              if (addAsTypeOnly2 === 1 && (typeOnlyEntry || nonTypeOnlyEntry)) {
                return typeOnlyEntry || nonTypeOnlyEntry;
              }
              if (nonTypeOnlyEntry) {
                return nonTypeOnlyEntry;
              }
              newImports.set(nonTypeOnlyKey, newEntry);
              return newEntry;
            }
            function newImportsKey(moduleSpecifier2, topLevelTypeOnly) {
              return "".concat(topLevelTypeOnly ? 1 : 0, "|").concat(moduleSpecifier2);
            }
          }
          function writeFixes(changeTracker) {
            var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
            for (var _i = 0, addToNamespace_1 = addToNamespace; _i < addToNamespace_1.length; _i++) {
              var fix = addToNamespace_1[_i];
              addNamespaceQualifier(changeTracker, sourceFile, fix);
            }
            for (var _a = 0, importType_1 = importType; _a < importType_1.length; _a++) {
              var fix = importType_1[_a];
              addImportType(changeTracker, sourceFile, fix, quotePreference);
            }
            addToExisting.forEach(function(_a2) {
              var importClauseOrBindingPattern = _a2.importClauseOrBindingPattern, defaultImport = _a2.defaultImport, namedImports = _a2.namedImports;
              doAddExistingFix(changeTracker, sourceFile, importClauseOrBindingPattern, defaultImport, ts3.arrayFrom(namedImports.entries(), function(_a3) {
                var name = _a3[0], addAsTypeOnly = _a3[1];
                return { addAsTypeOnly, name };
              }), compilerOptions);
            });
            var newDeclarations;
            newImports.forEach(function(_a2, key) {
              var useRequire = _a2.useRequire, defaultImport = _a2.defaultImport, namedImports = _a2.namedImports, namespaceLikeImport = _a2.namespaceLikeImport;
              var moduleSpecifier = key.slice(2);
              var getDeclarations = useRequire ? getNewRequires : getNewImports;
              var declarations = getDeclarations(moduleSpecifier, quotePreference, defaultImport, namedImports && ts3.arrayFrom(namedImports.entries(), function(_a3) {
                var name = _a3[0], addAsTypeOnly = _a3[1];
                return { addAsTypeOnly, name };
              }), namespaceLikeImport);
              newDeclarations = ts3.combine(newDeclarations, declarations);
            });
            if (newDeclarations) {
              ts3.insertImports(changeTracker, sourceFile, newDeclarations, true);
            }
          }
          function hasFixes() {
            return addToNamespace.length > 0 || importType.length > 0 || addToExisting.size > 0 || newImports.size > 0;
          }
        }
        function createImportSpecifierResolver(importingFile, program2, host, preferences) {
          var packageJsonImportFilter = ts3.createPackageJsonImportFilter(importingFile, preferences, host);
          var importMap = createExistingImportMap(program2.getTypeChecker(), importingFile, program2.getCompilerOptions());
          return { getModuleSpecifierForBestExportInfo };
          function getModuleSpecifierForBestExportInfo(exportInfo, symbolName, position, isValidTypeOnlyUseSite, fromCacheOnly) {
            var _a = getImportFixes(exportInfo, { symbolName, position }, isValidTypeOnlyUseSite, false, program2, importingFile, host, preferences, importMap, fromCacheOnly), fixes = _a.fixes, computedWithoutCacheCount = _a.computedWithoutCacheCount;
            var result2 = getBestFix(fixes, importingFile, program2, packageJsonImportFilter, host);
            return result2 && __assign(__assign({}, result2), { computedWithoutCacheCount });
          }
        }
        codefix2.createImportSpecifierResolver = createImportSpecifierResolver;
        var ImportFixKind;
        (function(ImportFixKind2) {
          ImportFixKind2[ImportFixKind2["UseNamespace"] = 0] = "UseNamespace";
          ImportFixKind2[ImportFixKind2["JsdocTypeImport"] = 1] = "JsdocTypeImport";
          ImportFixKind2[ImportFixKind2["AddToExisting"] = 2] = "AddToExisting";
          ImportFixKind2[ImportFixKind2["AddNew"] = 3] = "AddNew";
          ImportFixKind2[ImportFixKind2["PromoteTypeOnly"] = 4] = "PromoteTypeOnly";
        })(ImportFixKind || (ImportFixKind = {}));
        var AddAsTypeOnly;
        (function(AddAsTypeOnly2) {
          AddAsTypeOnly2[AddAsTypeOnly2["Allowed"] = 1] = "Allowed";
          AddAsTypeOnly2[AddAsTypeOnly2["Required"] = 2] = "Required";
          AddAsTypeOnly2[AddAsTypeOnly2["NotAllowed"] = 4] = "NotAllowed";
        })(AddAsTypeOnly || (AddAsTypeOnly = {}));
        function getImportCompletionAction(targetSymbol, moduleSymbol, sourceFile, symbolName, isJsxTagName, host, program2, formatContext, position, preferences) {
          var compilerOptions = program2.getCompilerOptions();
          var exportInfos = ts3.pathIsBareSpecifier(ts3.stripQuotes(moduleSymbol.name)) ? [getSymbolExportInfoForSymbol(targetSymbol, moduleSymbol, program2, host)] : getAllReExportingModules(sourceFile, targetSymbol, moduleSymbol, symbolName, isJsxTagName, host, program2, preferences, true);
          var useRequire = shouldUseRequire(sourceFile, program2);
          var isValidTypeOnlyUseSite = ts3.isValidTypeOnlyAliasUseSite(ts3.getTokenAtPosition(sourceFile, position));
          var fix = ts3.Debug.checkDefined(getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, program2, { symbolName, position }, isValidTypeOnlyUseSite, useRequire, host, preferences));
          return {
            moduleSpecifier: fix.moduleSpecifier,
            codeAction: codeFixActionToCodeAction(codeActionForFix({ host, formatContext, preferences }, sourceFile, symbolName, fix, false, ts3.getQuotePreference(sourceFile, preferences), compilerOptions))
          };
        }
        codefix2.getImportCompletionAction = getImportCompletionAction;
        function getPromoteTypeOnlyCompletionAction(sourceFile, symbolToken, program2, host, formatContext, preferences) {
          var compilerOptions = program2.getCompilerOptions();
          var symbolName = getSymbolName(sourceFile, program2.getTypeChecker(), symbolToken, compilerOptions);
          var fix = getTypeOnlyPromotionFix(sourceFile, symbolToken, symbolName, program2);
          var includeSymbolNameInDescription = symbolName !== symbolToken.text;
          return fix && codeFixActionToCodeAction(codeActionForFix({ host, formatContext, preferences }, sourceFile, symbolName, fix, includeSymbolNameInDescription, 1, compilerOptions));
        }
        codefix2.getPromoteTypeOnlyCompletionAction = getPromoteTypeOnlyCompletionAction;
        function getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, program2, useNamespaceInfo, isValidTypeOnlyUseSite, useRequire, host, preferences) {
          ts3.Debug.assert(exportInfos.some(function(info) {
            return info.moduleSymbol === moduleSymbol || info.symbol.parent === moduleSymbol;
          }), "Some exportInfo should match the specified moduleSymbol");
          var packageJsonImportFilter = ts3.createPackageJsonImportFilter(sourceFile, preferences, host);
          return getBestFix(getImportFixes(exportInfos, useNamespaceInfo, isValidTypeOnlyUseSite, useRequire, program2, sourceFile, host, preferences).fixes, sourceFile, program2, packageJsonImportFilter, host);
        }
        function codeFixActionToCodeAction(_a) {
          var description = _a.description, changes = _a.changes, commands = _a.commands;
          return { description, changes, commands };
        }
        function getSymbolExportInfoForSymbol(symbol, moduleSymbol, program2, host) {
          var _a, _b;
          var compilerOptions = program2.getCompilerOptions();
          var mainProgramInfo = getInfoWithChecker(program2.getTypeChecker(), false);
          if (mainProgramInfo) {
            return mainProgramInfo;
          }
          var autoImportProvider = (_b = (_a = host.getPackageJsonAutoImportProvider) === null || _a === void 0 ? void 0 : _a.call(host)) === null || _b === void 0 ? void 0 : _b.getTypeChecker();
          return ts3.Debug.checkDefined(autoImportProvider && getInfoWithChecker(autoImportProvider, true), "Could not find symbol in specified module for code actions");
          function getInfoWithChecker(checker, isFromPackageJson) {
            var defaultInfo = ts3.getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && ts3.skipAlias(defaultInfo.symbol, checker) === symbol) {
              return { symbol: defaultInfo.symbol, moduleSymbol, moduleFileName: void 0, exportKind: defaultInfo.exportKind, targetFlags: ts3.skipAlias(symbol, checker).flags, isFromPackageJson };
            }
            var named = checker.tryGetMemberInModuleExportsAndProperties(symbol.name, moduleSymbol);
            if (named && ts3.skipAlias(named, checker) === symbol) {
              return { symbol: named, moduleSymbol, moduleFileName: void 0, exportKind: 0, targetFlags: ts3.skipAlias(symbol, checker).flags, isFromPackageJson };
            }
          }
        }
        function getAllReExportingModules(importingFile, targetSymbol, exportingModuleSymbol, symbolName, isJsxTagName, host, program2, preferences, useAutoImportProvider) {
          var result2 = [];
          var compilerOptions = program2.getCompilerOptions();
          var getModuleSpecifierResolutionHost = ts3.memoizeOne(function(isFromPackageJson) {
            return ts3.createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program2, host);
          });
          ts3.forEachExternalModuleToImportFrom(program2, host, useAutoImportProvider, function(moduleSymbol, moduleFile, program3, isFromPackageJson) {
            var checker = program3.getTypeChecker();
            if (moduleFile && moduleSymbol !== exportingModuleSymbol && ts3.startsWith(importingFile.fileName, ts3.getDirectoryPath(moduleFile.fileName))) {
              return;
            }
            var defaultInfo = ts3.getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && (defaultInfo.name === symbolName || moduleSymbolToValidIdentifier(moduleSymbol, ts3.getEmitScriptTarget(compilerOptions), isJsxTagName) === symbolName) && ts3.skipAlias(defaultInfo.symbol, checker) === targetSymbol && isImportable(program3, moduleFile, isFromPackageJson)) {
              result2.push({ symbol: defaultInfo.symbol, moduleSymbol, moduleFileName: moduleFile === null || moduleFile === void 0 ? void 0 : moduleFile.fileName, exportKind: defaultInfo.exportKind, targetFlags: ts3.skipAlias(defaultInfo.symbol, checker).flags, isFromPackageJson });
            }
            for (var _i = 0, _a = checker.getExportsAndPropertiesOfModule(moduleSymbol); _i < _a.length; _i++) {
              var exported = _a[_i];
              if (exported.name === symbolName && checker.getMergedSymbol(ts3.skipAlias(exported, checker)) === targetSymbol && isImportable(program3, moduleFile, isFromPackageJson)) {
                result2.push({ symbol: exported, moduleSymbol, moduleFileName: moduleFile === null || moduleFile === void 0 ? void 0 : moduleFile.fileName, exportKind: 0, targetFlags: ts3.skipAlias(exported, checker).flags, isFromPackageJson });
              }
            }
          });
          return result2;
          function isImportable(program3, moduleFile, isFromPackageJson) {
            var _a;
            return !moduleFile || ts3.isImportableFile(program3, importingFile, moduleFile, preferences, void 0, getModuleSpecifierResolutionHost(isFromPackageJson), (_a = host.getModuleSpecifierCache) === null || _a === void 0 ? void 0 : _a.call(host));
          }
        }
        function getImportFixes(exportInfos, useNamespaceInfo, isValidTypeOnlyUseSite, useRequire, program2, sourceFile, host, preferences, importMap, fromCacheOnly) {
          if (importMap === void 0) {
            importMap = createExistingImportMap(program2.getTypeChecker(), sourceFile, program2.getCompilerOptions());
          }
          var checker = program2.getTypeChecker();
          var existingImports = ts3.flatMap(exportInfos, importMap.getImportsForExportInfo);
          var useNamespace = useNamespaceInfo && tryUseExistingNamespaceImport(existingImports, useNamespaceInfo.symbolName, useNamespaceInfo.position, checker);
          var addToExisting = tryAddToExistingImport(existingImports, isValidTypeOnlyUseSite, checker, program2.getCompilerOptions());
          if (addToExisting) {
            return {
              computedWithoutCacheCount: 0,
              fixes: __spreadArray(__spreadArray([], useNamespace ? [useNamespace] : ts3.emptyArray, true), [addToExisting], false)
            };
          }
          var _a = getFixesForAddImport(exportInfos, existingImports, program2, sourceFile, useNamespaceInfo === null || useNamespaceInfo === void 0 ? void 0 : useNamespaceInfo.position, isValidTypeOnlyUseSite, useRequire, host, preferences, fromCacheOnly), fixes = _a.fixes, _b = _a.computedWithoutCacheCount, computedWithoutCacheCount = _b === void 0 ? 0 : _b;
          return {
            computedWithoutCacheCount,
            fixes: __spreadArray(__spreadArray([], useNamespace ? [useNamespace] : ts3.emptyArray, true), fixes, true)
          };
        }
        function tryUseExistingNamespaceImport(existingImports, symbolName, position, checker) {
          return ts3.firstDefined(existingImports, function(_a) {
            var _b;
            var declaration = _a.declaration;
            var namespacePrefix = getNamespaceLikeImportText(declaration);
            var moduleSpecifier = (_b = ts3.tryGetModuleSpecifierFromDeclaration(declaration)) === null || _b === void 0 ? void 0 : _b.text;
            if (namespacePrefix && moduleSpecifier) {
              var moduleSymbol = getTargetModuleFromNamespaceLikeImport(declaration, checker);
              if (moduleSymbol && moduleSymbol.exports.has(ts3.escapeLeadingUnderscores(symbolName))) {
                return { kind: 0, namespacePrefix, position, moduleSpecifier };
              }
            }
          });
        }
        function getTargetModuleFromNamespaceLikeImport(declaration, checker) {
          var _a;
          switch (declaration.kind) {
            case 254:
              return checker.resolveExternalModuleName(declaration.initializer.arguments[0]);
            case 265:
              return checker.getAliasedSymbol(declaration.symbol);
            case 266:
              var namespaceImport = ts3.tryCast((_a = declaration.importClause) === null || _a === void 0 ? void 0 : _a.namedBindings, ts3.isNamespaceImport);
              return namespaceImport && checker.getAliasedSymbol(namespaceImport.symbol);
            default:
              return ts3.Debug.assertNever(declaration);
          }
        }
        function getNamespaceLikeImportText(declaration) {
          var _a, _b, _c;
          switch (declaration.kind) {
            case 254:
              return (_a = ts3.tryCast(declaration.name, ts3.isIdentifier)) === null || _a === void 0 ? void 0 : _a.text;
            case 265:
              return declaration.name.text;
            case 266:
              return (_c = ts3.tryCast((_b = declaration.importClause) === null || _b === void 0 ? void 0 : _b.namedBindings, ts3.isNamespaceImport)) === null || _c === void 0 ? void 0 : _c.name.text;
            default:
              return ts3.Debug.assertNever(declaration);
          }
        }
        function getAddAsTypeOnly(isValidTypeOnlyUseSite, isForNewImportDeclaration, symbol, targetFlags, checker, compilerOptions) {
          if (!isValidTypeOnlyUseSite) {
            return 4;
          }
          if (isForNewImportDeclaration && compilerOptions.importsNotUsedAsValues === 2) {
            return 2;
          }
          if (compilerOptions.isolatedModules && compilerOptions.preserveValueImports && (!(targetFlags & 111551) || !!checker.getTypeOnlyAliasDeclaration(symbol))) {
            return 2;
          }
          return 1;
        }
        function tryAddToExistingImport(existingImports, isValidTypeOnlyUseSite, checker, compilerOptions) {
          return ts3.firstDefined(existingImports, function(_a) {
            var declaration = _a.declaration, importKind = _a.importKind, symbol = _a.symbol, targetFlags = _a.targetFlags;
            if (importKind === 3 || importKind === 2 || declaration.kind === 265) {
              return void 0;
            }
            if (declaration.kind === 254) {
              return (importKind === 0 || importKind === 1) && declaration.name.kind === 201 ? { kind: 2, importClauseOrBindingPattern: declaration.name, importKind, moduleSpecifier: declaration.initializer.arguments[0].text, addAsTypeOnly: 4 } : void 0;
            }
            var importClause = declaration.importClause;
            if (!importClause || !ts3.isStringLiteralLike(declaration.moduleSpecifier))
              return void 0;
            var name = importClause.name, namedBindings = importClause.namedBindings;
            if (importClause.isTypeOnly && !(importKind === 0 && namedBindings))
              return void 0;
            var addAsTypeOnly = getAddAsTypeOnly(isValidTypeOnlyUseSite, false, symbol, targetFlags, checker, compilerOptions);
            if (importKind === 1 && (name || addAsTypeOnly === 2 && namedBindings))
              return void 0;
            if (importKind === 0 && (namedBindings === null || namedBindings === void 0 ? void 0 : namedBindings.kind) === 268)
              return void 0;
            return {
              kind: 2,
              importClauseOrBindingPattern: importClause,
              importKind,
              moduleSpecifier: declaration.moduleSpecifier.text,
              addAsTypeOnly
            };
          });
        }
        function createExistingImportMap(checker, importingFile, compilerOptions) {
          var importMap;
          for (var _i = 0, _a = importingFile.imports; _i < _a.length; _i++) {
            var moduleSpecifier = _a[_i];
            var i = ts3.importFromModuleSpecifier(moduleSpecifier);
            if (ts3.isVariableDeclarationInitializedToRequire(i.parent)) {
              var moduleSymbol = checker.resolveExternalModuleName(moduleSpecifier);
              if (moduleSymbol) {
                (importMap || (importMap = ts3.createMultiMap())).add(ts3.getSymbolId(moduleSymbol), i.parent);
              }
            } else if (i.kind === 266 || i.kind === 265) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol) {
                (importMap || (importMap = ts3.createMultiMap())).add(ts3.getSymbolId(moduleSymbol), i);
              }
            }
          }
          return {
            getImportsForExportInfo: function(_a2) {
              var moduleSymbol2 = _a2.moduleSymbol, exportKind = _a2.exportKind, targetFlags = _a2.targetFlags, symbol = _a2.symbol;
              if (!(targetFlags & 111551) && ts3.isSourceFileJS(importingFile))
                return ts3.emptyArray;
              var matchingDeclarations = importMap === null || importMap === void 0 ? void 0 : importMap.get(ts3.getSymbolId(moduleSymbol2));
              if (!matchingDeclarations)
                return ts3.emptyArray;
              var importKind = getImportKind(importingFile, exportKind, compilerOptions);
              return matchingDeclarations.map(function(declaration) {
                return { declaration, importKind, symbol, targetFlags };
              });
            }
          };
        }
        function shouldUseRequire(sourceFile, program2) {
          if (!ts3.isSourceFileJS(sourceFile)) {
            return false;
          }
          if (sourceFile.commonJsModuleIndicator && !sourceFile.externalModuleIndicator)
            return true;
          if (sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator)
            return false;
          var compilerOptions = program2.getCompilerOptions();
          if (compilerOptions.configFile) {
            return ts3.getEmitModuleKind(compilerOptions) < ts3.ModuleKind.ES2015;
          }
          for (var _i = 0, _a = program2.getSourceFiles(); _i < _a.length; _i++) {
            var otherFile = _a[_i];
            if (otherFile === sourceFile || !ts3.isSourceFileJS(otherFile) || program2.isSourceFileFromExternalLibrary(otherFile))
              continue;
            if (otherFile.commonJsModuleIndicator && !otherFile.externalModuleIndicator)
              return true;
            if (otherFile.externalModuleIndicator && !otherFile.commonJsModuleIndicator)
              return false;
          }
          return true;
        }
        function getNewImportFixes(program2, sourceFile, position, isValidTypeOnlyUseSite, useRequire, exportInfo, host, preferences, fromCacheOnly) {
          var isJs = ts3.isSourceFileJS(sourceFile);
          var compilerOptions = program2.getCompilerOptions();
          var moduleSpecifierResolutionHost = ts3.createModuleSpecifierResolutionHost(program2, host);
          var getChecker = ts3.memoizeOne(function(isFromPackageJson) {
            return isFromPackageJson ? host.getPackageJsonAutoImportProvider().getTypeChecker() : program2.getTypeChecker();
          });
          var rejectNodeModulesRelativePaths = ts3.moduleResolutionUsesNodeModules(ts3.getEmitModuleResolutionKind(compilerOptions));
          var getModuleSpecifiers = fromCacheOnly ? function(moduleSymbol) {
            return { moduleSpecifiers: ts3.moduleSpecifiers.tryGetModuleSpecifiersFromCache(moduleSymbol, sourceFile, moduleSpecifierResolutionHost, preferences), computedWithoutCache: false };
          } : function(moduleSymbol, checker) {
            return ts3.moduleSpecifiers.getModuleSpecifiersWithCacheInfo(moduleSymbol, checker, compilerOptions, sourceFile, moduleSpecifierResolutionHost, preferences);
          };
          var computedWithoutCacheCount = 0;
          var fixes = ts3.flatMap(exportInfo, function(exportInfo2, i) {
            var checker = getChecker(exportInfo2.isFromPackageJson);
            var _a = getModuleSpecifiers(exportInfo2.moduleSymbol, checker), computedWithoutCache = _a.computedWithoutCache, moduleSpecifiers = _a.moduleSpecifiers;
            var importedSymbolHasValueMeaning = !!(exportInfo2.targetFlags & 111551);
            var addAsTypeOnly = getAddAsTypeOnly(isValidTypeOnlyUseSite, true, exportInfo2.symbol, exportInfo2.targetFlags, checker, compilerOptions);
            computedWithoutCacheCount += computedWithoutCache ? 1 : 0;
            return ts3.mapDefined(moduleSpecifiers, function(moduleSpecifier) {
              return rejectNodeModulesRelativePaths && ts3.pathContainsNodeModules(moduleSpecifier) ? void 0 : !importedSymbolHasValueMeaning && isJs && position !== void 0 ? { kind: 1, moduleSpecifier, position, exportInfo: exportInfo2, isReExport: i > 0 } : {
                kind: 3,
                moduleSpecifier,
                importKind: getImportKind(sourceFile, exportInfo2.exportKind, compilerOptions),
                useRequire,
                addAsTypeOnly,
                exportInfo: exportInfo2,
                isReExport: i > 0
              };
            });
          });
          return { computedWithoutCacheCount, fixes };
        }
        function getFixesForAddImport(exportInfos, existingImports, program2, sourceFile, position, isValidTypeOnlyUseSite, useRequire, host, preferences, fromCacheOnly) {
          var existingDeclaration = ts3.firstDefined(existingImports, function(info) {
            return newImportInfoFromExistingSpecifier(info, isValidTypeOnlyUseSite, useRequire, program2.getTypeChecker(), program2.getCompilerOptions());
          });
          return existingDeclaration ? { fixes: [existingDeclaration] } : getNewImportFixes(program2, sourceFile, position, isValidTypeOnlyUseSite, useRequire, exportInfos, host, preferences, fromCacheOnly);
        }
        function newImportInfoFromExistingSpecifier(_a, isValidTypeOnlyUseSite, useRequire, checker, compilerOptions) {
          var _b;
          var declaration = _a.declaration, importKind = _a.importKind, symbol = _a.symbol, targetFlags = _a.targetFlags;
          var moduleSpecifier = (_b = ts3.tryGetModuleSpecifierFromDeclaration(declaration)) === null || _b === void 0 ? void 0 : _b.text;
          if (moduleSpecifier) {
            var addAsTypeOnly = useRequire ? 4 : getAddAsTypeOnly(isValidTypeOnlyUseSite, true, symbol, targetFlags, checker, compilerOptions);
            return { kind: 3, moduleSpecifier, importKind, addAsTypeOnly, useRequire };
          }
        }
        function getFixesInfo(context, errorCode, pos, useAutoImportProvider) {
          var symbolToken = ts3.getTokenAtPosition(context.sourceFile, pos);
          var info;
          if (errorCode === ts3.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code) {
            info = getFixesInfoForUMDImport(context, symbolToken);
          } else if (!ts3.isIdentifier(symbolToken)) {
            return void 0;
          } else if (errorCode === ts3.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code) {
            var symbolName_1 = getSymbolName(context.sourceFile, context.program.getTypeChecker(), symbolToken, context.program.getCompilerOptions());
            var fix = getTypeOnlyPromotionFix(context.sourceFile, symbolToken, symbolName_1, context.program);
            return fix && { fixes: [fix], symbolName: symbolName_1, errorIdentifierText: symbolToken.text };
          } else {
            info = getFixesInfoForNonUMDImport(context, symbolToken, useAutoImportProvider);
          }
          var packageJsonImportFilter = ts3.createPackageJsonImportFilter(context.sourceFile, context.preferences, context.host);
          return info && __assign(__assign({}, info), { fixes: sortFixes(info.fixes, context.sourceFile, context.program, packageJsonImportFilter, context.host) });
        }
        function sortFixes(fixes, sourceFile, program2, packageJsonImportFilter, host) {
          var _toPath = function(fileName2) {
            return ts3.toPath(fileName2, host.getCurrentDirectory(), ts3.hostGetCanonicalFileName(host));
          };
          return ts3.sort(fixes, function(a, b) {
            return ts3.compareValues(a.kind, b.kind) || compareModuleSpecifiers(a, b, sourceFile, program2, packageJsonImportFilter.allowsImportingSpecifier, _toPath);
          });
        }
        function getBestFix(fixes, sourceFile, program2, packageJsonImportFilter, host) {
          if (!ts3.some(fixes))
            return;
          if (fixes[0].kind === 0 || fixes[0].kind === 2) {
            return fixes[0];
          }
          return fixes.reduce(function(best, fix) {
            return compareModuleSpecifiers(fix, best, sourceFile, program2, packageJsonImportFilter.allowsImportingSpecifier, function(fileName2) {
              return ts3.toPath(fileName2, host.getCurrentDirectory(), ts3.hostGetCanonicalFileName(host));
            }) === -1 ? fix : best;
          });
        }
        function compareModuleSpecifiers(a, b, importingFile, program2, allowsImportingSpecifier, toPath) {
          if (a.kind !== 0 && b.kind !== 0) {
            return ts3.compareBooleans(allowsImportingSpecifier(b.moduleSpecifier), allowsImportingSpecifier(a.moduleSpecifier)) || compareNodeCoreModuleSpecifiers(a.moduleSpecifier, b.moduleSpecifier, importingFile, program2) || ts3.compareBooleans(isFixPossiblyReExportingImportingFile(a, importingFile, program2.getCompilerOptions(), toPath), isFixPossiblyReExportingImportingFile(b, importingFile, program2.getCompilerOptions(), toPath)) || ts3.compareNumberOfDirectorySeparators(a.moduleSpecifier, b.moduleSpecifier);
          }
          return 0;
        }
        function isFixPossiblyReExportingImportingFile(fix, importingFile, compilerOptions, toPath) {
          var _a;
          if (fix.isReExport && ((_a = fix.exportInfo) === null || _a === void 0 ? void 0 : _a.moduleFileName) && ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs && isIndexFileName(fix.exportInfo.moduleFileName)) {
            var reExportDir = toPath(ts3.getDirectoryPath(fix.exportInfo.moduleFileName));
            return ts3.startsWith(importingFile.path, reExportDir);
          }
          return false;
        }
        function isIndexFileName(fileName2) {
          return ts3.getBaseFileName(fileName2, [".js", ".jsx", ".d.ts", ".ts", ".tsx"], true) === "index";
        }
        function compareNodeCoreModuleSpecifiers(a, b, importingFile, program2) {
          if (ts3.startsWith(a, "node:") && !ts3.startsWith(b, "node:"))
            return ts3.shouldUseUriStyleNodeCoreModules(importingFile, program2) ? -1 : 1;
          if (ts3.startsWith(b, "node:") && !ts3.startsWith(a, "node:"))
            return ts3.shouldUseUriStyleNodeCoreModules(importingFile, program2) ? 1 : -1;
          return 0;
        }
        function getFixesInfoForUMDImport(_a, token) {
          var _b;
          var sourceFile = _a.sourceFile, program2 = _a.program, host = _a.host, preferences = _a.preferences;
          var checker = program2.getTypeChecker();
          var umdSymbol = getUmdSymbol(token, checker);
          if (!umdSymbol)
            return void 0;
          var symbol = checker.getAliasedSymbol(umdSymbol);
          var symbolName = umdSymbol.name;
          var exportInfo = [{ symbol: umdSymbol, moduleSymbol: symbol, moduleFileName: void 0, exportKind: 3, targetFlags: symbol.flags, isFromPackageJson: false }];
          var useRequire = shouldUseRequire(sourceFile, program2);
          var position = ts3.isIdentifier(token) ? token.getStart(sourceFile) : void 0;
          var fixes = getImportFixes(exportInfo, position ? { position, symbolName } : void 0, false, useRequire, program2, sourceFile, host, preferences).fixes;
          return { fixes, symbolName, errorIdentifierText: (_b = ts3.tryCast(token, ts3.isIdentifier)) === null || _b === void 0 ? void 0 : _b.text };
        }
        function getUmdSymbol(token, checker) {
          var umdSymbol = ts3.isIdentifier(token) ? checker.getSymbolAtLocation(token) : void 0;
          if (ts3.isUMDExportSymbol(umdSymbol))
            return umdSymbol;
          var parent = token.parent;
          return ts3.isJsxOpeningLikeElement(parent) && parent.tagName === token || ts3.isJsxOpeningFragment(parent) ? ts3.tryCast(checker.resolveName(checker.getJsxNamespace(parent), ts3.isJsxOpeningLikeElement(parent) ? token : parent, 111551, false), ts3.isUMDExportSymbol) : void 0;
        }
        function getImportKind(importingFile, exportKind, compilerOptions, forceImportKeyword) {
          switch (exportKind) {
            case 0:
              return 0;
            case 1:
              return 1;
            case 2:
              return getExportEqualsImportKind(importingFile, compilerOptions, !!forceImportKeyword);
            case 3:
              return getUmdImportKind(importingFile, compilerOptions, !!forceImportKeyword);
            default:
              return ts3.Debug.assertNever(exportKind);
          }
        }
        codefix2.getImportKind = getImportKind;
        function getUmdImportKind(importingFile, compilerOptions, forceImportKeyword) {
          if (ts3.getAllowSyntheticDefaultImports(compilerOptions)) {
            return 1;
          }
          var moduleKind = ts3.getEmitModuleKind(compilerOptions);
          switch (moduleKind) {
            case ts3.ModuleKind.AMD:
            case ts3.ModuleKind.CommonJS:
            case ts3.ModuleKind.UMD:
              if (ts3.isInJSFile(importingFile)) {
                return ts3.isExternalModule(importingFile) || forceImportKeyword ? 2 : 3;
              }
              return 3;
            case ts3.ModuleKind.System:
            case ts3.ModuleKind.ES2015:
            case ts3.ModuleKind.ES2020:
            case ts3.ModuleKind.ES2022:
            case ts3.ModuleKind.ESNext:
            case ts3.ModuleKind.None:
              return 2;
            case ts3.ModuleKind.Node16:
            case ts3.ModuleKind.NodeNext:
              return importingFile.impliedNodeFormat === ts3.ModuleKind.ESNext ? 2 : 3;
            default:
              return ts3.Debug.assertNever(moduleKind, "Unexpected moduleKind ".concat(moduleKind));
          }
        }
        function getFixesInfoForNonUMDImport(_a, symbolToken, useAutoImportProvider) {
          var sourceFile = _a.sourceFile, program2 = _a.program, cancellationToken = _a.cancellationToken, host = _a.host, preferences = _a.preferences;
          var checker = program2.getTypeChecker();
          var compilerOptions = program2.getCompilerOptions();
          var symbolName = getSymbolName(sourceFile, checker, symbolToken, compilerOptions);
          if (symbolName === "default") {
            return void 0;
          }
          var isValidTypeOnlyUseSite = ts3.isValidTypeOnlyAliasUseSite(symbolToken);
          var useRequire = shouldUseRequire(sourceFile, program2);
          var exportInfo = getExportInfos(symbolName, ts3.isJSXTagName(symbolToken), ts3.getMeaningFromLocation(symbolToken), cancellationToken, sourceFile, program2, useAutoImportProvider, host, preferences);
          var fixes = ts3.arrayFrom(ts3.flatMapIterator(exportInfo.entries(), function(_a2) {
            var _ = _a2[0], exportInfos = _a2[1];
            return getImportFixes(exportInfos, { symbolName, position: symbolToken.getStart(sourceFile) }, isValidTypeOnlyUseSite, useRequire, program2, sourceFile, host, preferences).fixes;
          }));
          return { fixes, symbolName, errorIdentifierText: symbolToken.text };
        }
        function getTypeOnlyPromotionFix(sourceFile, symbolToken, symbolName, program2) {
          var checker = program2.getTypeChecker();
          var symbol = checker.resolveName(symbolName, symbolToken, 111551, true);
          if (!symbol)
            return void 0;
          var typeOnlyAliasDeclaration = checker.getTypeOnlyAliasDeclaration(symbol);
          if (!typeOnlyAliasDeclaration || ts3.getSourceFileOfNode(typeOnlyAliasDeclaration) !== sourceFile)
            return void 0;
          return { kind: 4, typeOnlyAliasDeclaration };
        }
        function getSymbolName(sourceFile, checker, symbolToken, compilerOptions) {
          var parent = symbolToken.parent;
          if ((ts3.isJsxOpeningLikeElement(parent) || ts3.isJsxClosingElement(parent)) && parent.tagName === symbolToken && ts3.jsxModeNeedsExplicitImport(compilerOptions.jsx)) {
            var jsxNamespace = checker.getJsxNamespace(sourceFile);
            if (needsJsxNamespaceFix(jsxNamespace, symbolToken, checker)) {
              return jsxNamespace;
            }
          }
          return symbolToken.text;
        }
        function needsJsxNamespaceFix(jsxNamespace, symbolToken, checker) {
          if (ts3.isIntrinsicJsxName(symbolToken.text))
            return true;
          var namespaceSymbol = checker.resolveName(jsxNamespace, symbolToken, 111551, true);
          return !namespaceSymbol || ts3.some(namespaceSymbol.declarations, ts3.isTypeOnlyImportOrExportDeclaration) && !(namespaceSymbol.flags & 111551);
        }
        function getExportInfos(symbolName, isJsxTagName, currentTokenMeaning, cancellationToken, fromFile, program2, useAutoImportProvider, host, preferences) {
          var _a;
          var originalSymbolToExportInfos = ts3.createMultiMap();
          var packageJsonFilter = ts3.createPackageJsonImportFilter(fromFile, preferences, host);
          var moduleSpecifierCache = (_a = host.getModuleSpecifierCache) === null || _a === void 0 ? void 0 : _a.call(host);
          var getModuleSpecifierResolutionHost = ts3.memoizeOne(function(isFromPackageJson) {
            return ts3.createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program2, host);
          });
          function addSymbol(moduleSymbol, toFile, exportedSymbol, exportKind, program3, isFromPackageJson) {
            var moduleSpecifierResolutionHost = getModuleSpecifierResolutionHost(isFromPackageJson);
            if (toFile && ts3.isImportableFile(program3, fromFile, toFile, preferences, packageJsonFilter, moduleSpecifierResolutionHost, moduleSpecifierCache) || !toFile && packageJsonFilter.allowsImportingAmbientModule(moduleSymbol, moduleSpecifierResolutionHost)) {
              var checker = program3.getTypeChecker();
              originalSymbolToExportInfos.add(ts3.getUniqueSymbolId(exportedSymbol, checker).toString(), { symbol: exportedSymbol, moduleSymbol, moduleFileName: toFile === null || toFile === void 0 ? void 0 : toFile.fileName, exportKind, targetFlags: ts3.skipAlias(exportedSymbol, checker).flags, isFromPackageJson });
            }
          }
          ts3.forEachExternalModuleToImportFrom(program2, host, useAutoImportProvider, function(moduleSymbol, sourceFile, program3, isFromPackageJson) {
            var checker = program3.getTypeChecker();
            cancellationToken.throwIfCancellationRequested();
            var compilerOptions = program3.getCompilerOptions();
            var defaultInfo = ts3.getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && (defaultInfo.name === symbolName || moduleSymbolToValidIdentifier(moduleSymbol, ts3.getEmitScriptTarget(compilerOptions), isJsxTagName) === symbolName) && symbolHasMeaning(defaultInfo.symbolForMeaning, currentTokenMeaning)) {
              addSymbol(moduleSymbol, sourceFile, defaultInfo.symbol, defaultInfo.exportKind, program3, isFromPackageJson);
            }
            var exportSymbolWithIdenticalName = checker.tryGetMemberInModuleExportsAndProperties(symbolName, moduleSymbol);
            if (exportSymbolWithIdenticalName && symbolHasMeaning(exportSymbolWithIdenticalName, currentTokenMeaning)) {
              addSymbol(moduleSymbol, sourceFile, exportSymbolWithIdenticalName, 0, program3, isFromPackageJson);
            }
          });
          return originalSymbolToExportInfos;
        }
        function getExportEqualsImportKind(importingFile, compilerOptions, forceImportKeyword) {
          var allowSyntheticDefaults = ts3.getAllowSyntheticDefaultImports(compilerOptions);
          var isJS = ts3.isInJSFile(importingFile);
          if (!isJS && ts3.getEmitModuleKind(compilerOptions) >= ts3.ModuleKind.ES2015) {
            return allowSyntheticDefaults ? 1 : 2;
          }
          if (isJS) {
            return ts3.isExternalModule(importingFile) || forceImportKeyword ? allowSyntheticDefaults ? 1 : 2 : 3;
          }
          for (var _i = 0, _a = importingFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (ts3.isImportEqualsDeclaration(statement) && !ts3.nodeIsMissing(statement.moduleReference)) {
              return 3;
            }
          }
          return allowSyntheticDefaults ? 1 : 3;
        }
        function codeActionForFix(context, sourceFile, symbolName, fix, includeSymbolNameInDescription, quotePreference, compilerOptions) {
          var diag;
          var changes = ts3.textChanges.ChangeTracker.with(context, function(tracker) {
            diag = codeActionForFixWorker(tracker, sourceFile, symbolName, fix, includeSymbolNameInDescription, quotePreference, compilerOptions);
          });
          return codefix2.createCodeFixAction(codefix2.importFixName, changes, diag, importFixId, ts3.Diagnostics.Add_all_missing_imports);
        }
        function codeActionForFixWorker(changes, sourceFile, symbolName, fix, includeSymbolNameInDescription, quotePreference, compilerOptions) {
          switch (fix.kind) {
            case 0:
              addNamespaceQualifier(changes, sourceFile, fix);
              return [ts3.Diagnostics.Change_0_to_1, symbolName, "".concat(fix.namespacePrefix, ".").concat(symbolName)];
            case 1:
              addImportType(changes, sourceFile, fix, quotePreference);
              return [ts3.Diagnostics.Change_0_to_1, symbolName, getImportTypePrefix(fix.moduleSpecifier, quotePreference) + symbolName];
            case 2: {
              var importClauseOrBindingPattern = fix.importClauseOrBindingPattern, importKind = fix.importKind, addAsTypeOnly = fix.addAsTypeOnly, moduleSpecifier = fix.moduleSpecifier;
              doAddExistingFix(changes, sourceFile, importClauseOrBindingPattern, importKind === 1 ? { name: symbolName, addAsTypeOnly } : void 0, importKind === 0 ? [{ name: symbolName, addAsTypeOnly }] : ts3.emptyArray, compilerOptions);
              var moduleSpecifierWithoutQuotes = ts3.stripQuotes(moduleSpecifier);
              return includeSymbolNameInDescription ? [ts3.Diagnostics.Import_0_from_1, symbolName, moduleSpecifierWithoutQuotes] : [ts3.Diagnostics.Update_import_from_0, moduleSpecifierWithoutQuotes];
            }
            case 3: {
              var importKind = fix.importKind, moduleSpecifier = fix.moduleSpecifier, addAsTypeOnly = fix.addAsTypeOnly, useRequire = fix.useRequire;
              var getDeclarations = useRequire ? getNewRequires : getNewImports;
              var defaultImport = importKind === 1 ? { name: symbolName, addAsTypeOnly } : void 0;
              var namedImports = importKind === 0 ? [{ name: symbolName, addAsTypeOnly }] : void 0;
              var namespaceLikeImport = importKind === 2 || importKind === 3 ? { importKind, name: symbolName, addAsTypeOnly } : void 0;
              ts3.insertImports(changes, sourceFile, getDeclarations(moduleSpecifier, quotePreference, defaultImport, namedImports, namespaceLikeImport), true);
              return includeSymbolNameInDescription ? [ts3.Diagnostics.Import_0_from_1, symbolName, moduleSpecifier] : [ts3.Diagnostics.Add_import_from_0, moduleSpecifier];
            }
            case 4: {
              var typeOnlyAliasDeclaration = fix.typeOnlyAliasDeclaration;
              var promotedDeclaration = promoteFromTypeOnly(changes, typeOnlyAliasDeclaration, compilerOptions, sourceFile);
              return promotedDeclaration.kind === 270 ? [ts3.Diagnostics.Remove_type_from_import_of_0_from_1, symbolName, getModuleSpecifierText(promotedDeclaration.parent.parent)] : [ts3.Diagnostics.Remove_type_from_import_declaration_from_0, getModuleSpecifierText(promotedDeclaration)];
            }
            default:
              return ts3.Debug.assertNever(fix, "Unexpected fix kind ".concat(fix.kind));
          }
        }
        function getModuleSpecifierText(promotedDeclaration) {
          var _a, _b;
          return promotedDeclaration.kind === 265 ? ((_b = ts3.tryCast((_a = ts3.tryCast(promotedDeclaration.moduleReference, ts3.isExternalModuleReference)) === null || _a === void 0 ? void 0 : _a.expression, ts3.isStringLiteralLike)) === null || _b === void 0 ? void 0 : _b.text) || promotedDeclaration.moduleReference.getText() : ts3.cast(promotedDeclaration.parent.moduleSpecifier, ts3.isStringLiteral).text;
        }
        function promoteFromTypeOnly(changes, aliasDeclaration, compilerOptions, sourceFile) {
          var convertExistingToTypeOnly = compilerOptions.preserveValueImports && compilerOptions.isolatedModules;
          switch (aliasDeclaration.kind) {
            case 270:
              if (aliasDeclaration.isTypeOnly) {
                if (aliasDeclaration.parent.elements.length > 1 && ts3.OrganizeImports.importSpecifiersAreSorted(aliasDeclaration.parent.elements)) {
                  changes.delete(sourceFile, aliasDeclaration);
                  var newSpecifier = ts3.factory.updateImportSpecifier(aliasDeclaration, false, aliasDeclaration.propertyName, aliasDeclaration.name);
                  var insertionIndex = ts3.OrganizeImports.getImportSpecifierInsertionIndex(aliasDeclaration.parent.elements, newSpecifier);
                  changes.insertImportSpecifierAtIndex(sourceFile, newSpecifier, aliasDeclaration.parent, insertionIndex);
                } else {
                  changes.deleteRange(sourceFile, aliasDeclaration.getFirstToken());
                }
                return aliasDeclaration;
              } else {
                ts3.Debug.assert(aliasDeclaration.parent.parent.isTypeOnly);
                promoteImportClause(aliasDeclaration.parent.parent);
                return aliasDeclaration.parent.parent;
              }
            case 267:
              promoteImportClause(aliasDeclaration);
              return aliasDeclaration;
            case 268:
              promoteImportClause(aliasDeclaration.parent);
              return aliasDeclaration.parent;
            case 265:
              changes.deleteRange(sourceFile, aliasDeclaration.getChildAt(1));
              return aliasDeclaration;
            default:
              ts3.Debug.failBadSyntaxKind(aliasDeclaration);
          }
          function promoteImportClause(importClause) {
            changes.delete(sourceFile, ts3.getTypeKeywordOfTypeOnlyImport(importClause, sourceFile));
            if (convertExistingToTypeOnly) {
              var namedImports = ts3.tryCast(importClause.namedBindings, ts3.isNamedImports);
              if (namedImports && namedImports.elements.length > 1) {
                if (ts3.OrganizeImports.importSpecifiersAreSorted(namedImports.elements) && aliasDeclaration.kind === 270 && namedImports.elements.indexOf(aliasDeclaration) !== 0) {
                  changes.delete(sourceFile, aliasDeclaration);
                  changes.insertImportSpecifierAtIndex(sourceFile, aliasDeclaration, namedImports, 0);
                }
                for (var _i = 0, _a = namedImports.elements; _i < _a.length; _i++) {
                  var element = _a[_i];
                  if (element !== aliasDeclaration && !element.isTypeOnly) {
                    changes.insertModifierBefore(sourceFile, 152, element);
                  }
                }
              }
            }
          }
        }
        function doAddExistingFix(changes, sourceFile, clause, defaultImport, namedImports, compilerOptions) {
          var _a;
          if (clause.kind === 201) {
            if (defaultImport) {
              addElementToBindingPattern(clause, defaultImport.name, "default");
            }
            for (var _i = 0, namedImports_1 = namedImports; _i < namedImports_1.length; _i++) {
              var specifier = namedImports_1[_i];
              addElementToBindingPattern(clause, specifier.name, void 0);
            }
            return;
          }
          var promoteFromTypeOnly2 = clause.isTypeOnly && ts3.some(__spreadArray([defaultImport], namedImports, true), function(i) {
            return (i === null || i === void 0 ? void 0 : i.addAsTypeOnly) === 4;
          });
          var existingSpecifiers = clause.namedBindings && ((_a = ts3.tryCast(clause.namedBindings, ts3.isNamedImports)) === null || _a === void 0 ? void 0 : _a.elements);
          var convertExistingToTypeOnly = promoteFromTypeOnly2 && compilerOptions.preserveValueImports && compilerOptions.isolatedModules;
          if (defaultImport) {
            ts3.Debug.assert(!clause.name, "Cannot add a default import to an import clause that already has one");
            changes.insertNodeAt(sourceFile, clause.getStart(sourceFile), ts3.factory.createIdentifier(defaultImport.name), { suffix: ", " });
          }
          if (namedImports.length) {
            var newSpecifiers = ts3.stableSort(namedImports.map(function(namedImport) {
              return ts3.factory.createImportSpecifier((!clause.isTypeOnly || promoteFromTypeOnly2) && needsTypeOnly(namedImport), void 0, ts3.factory.createIdentifier(namedImport.name));
            }), ts3.OrganizeImports.compareImportOrExportSpecifiers);
            if ((existingSpecifiers === null || existingSpecifiers === void 0 ? void 0 : existingSpecifiers.length) && ts3.OrganizeImports.importSpecifiersAreSorted(existingSpecifiers)) {
              for (var _b = 0, newSpecifiers_1 = newSpecifiers; _b < newSpecifiers_1.length; _b++) {
                var spec = newSpecifiers_1[_b];
                var insertionIndex = convertExistingToTypeOnly && !spec.isTypeOnly ? 0 : ts3.OrganizeImports.getImportSpecifierInsertionIndex(existingSpecifiers, spec);
                changes.insertImportSpecifierAtIndex(sourceFile, spec, clause.namedBindings, insertionIndex);
              }
            } else if (existingSpecifiers === null || existingSpecifiers === void 0 ? void 0 : existingSpecifiers.length) {
              for (var _c = 0, newSpecifiers_2 = newSpecifiers; _c < newSpecifiers_2.length; _c++) {
                var spec = newSpecifiers_2[_c];
                changes.insertNodeInListAfter(sourceFile, ts3.last(existingSpecifiers), spec, existingSpecifiers);
              }
            } else {
              if (newSpecifiers.length) {
                var namedImports_2 = ts3.factory.createNamedImports(newSpecifiers);
                if (clause.namedBindings) {
                  changes.replaceNode(sourceFile, clause.namedBindings, namedImports_2);
                } else {
                  changes.insertNodeAfter(sourceFile, ts3.Debug.checkDefined(clause.name, "Import clause must have either named imports or a default import"), namedImports_2);
                }
              }
            }
          }
          if (promoteFromTypeOnly2) {
            changes.delete(sourceFile, ts3.getTypeKeywordOfTypeOnlyImport(clause, sourceFile));
            if (convertExistingToTypeOnly && existingSpecifiers) {
              for (var _d = 0, existingSpecifiers_1 = existingSpecifiers; _d < existingSpecifiers_1.length; _d++) {
                var specifier = existingSpecifiers_1[_d];
                changes.insertModifierBefore(sourceFile, 152, specifier);
              }
            }
          }
          function addElementToBindingPattern(bindingPattern, name, propertyName) {
            var element = ts3.factory.createBindingElement(void 0, propertyName, name);
            if (bindingPattern.elements.length) {
              changes.insertNodeInListAfter(sourceFile, ts3.last(bindingPattern.elements), element);
            } else {
              changes.replaceNode(sourceFile, bindingPattern, ts3.factory.createObjectBindingPattern([element]));
            }
          }
        }
        function addNamespaceQualifier(changes, sourceFile, _a) {
          var namespacePrefix = _a.namespacePrefix, position = _a.position;
          changes.insertText(sourceFile, position, namespacePrefix + ".");
        }
        function addImportType(changes, sourceFile, _a, quotePreference) {
          var moduleSpecifier = _a.moduleSpecifier, position = _a.position;
          changes.insertText(sourceFile, position, getImportTypePrefix(moduleSpecifier, quotePreference));
        }
        function getImportTypePrefix(moduleSpecifier, quotePreference) {
          var quote = ts3.getQuoteFromPreference(quotePreference);
          return "import(".concat(quote).concat(moduleSpecifier).concat(quote, ").");
        }
        function needsTypeOnly(_a) {
          var addAsTypeOnly = _a.addAsTypeOnly;
          return addAsTypeOnly === 2;
        }
        function getNewImports(moduleSpecifier, quotePreference, defaultImport, namedImports, namespaceLikeImport) {
          var quotedModuleSpecifier = ts3.makeStringLiteral(moduleSpecifier, quotePreference);
          var statements;
          if (defaultImport !== void 0 || (namedImports === null || namedImports === void 0 ? void 0 : namedImports.length)) {
            var topLevelTypeOnly_1 = (!defaultImport || needsTypeOnly(defaultImport)) && ts3.every(namedImports, needsTypeOnly);
            statements = ts3.combine(statements, ts3.makeImport(defaultImport && ts3.factory.createIdentifier(defaultImport.name), namedImports === null || namedImports === void 0 ? void 0 : namedImports.map(function(_a) {
              var addAsTypeOnly = _a.addAsTypeOnly, name = _a.name;
              return ts3.factory.createImportSpecifier(!topLevelTypeOnly_1 && addAsTypeOnly === 2, void 0, ts3.factory.createIdentifier(name));
            }), moduleSpecifier, quotePreference, topLevelTypeOnly_1));
          }
          if (namespaceLikeImport) {
            var declaration = namespaceLikeImport.importKind === 3 ? ts3.factory.createImportEqualsDeclaration(void 0, void 0, needsTypeOnly(namespaceLikeImport), ts3.factory.createIdentifier(namespaceLikeImport.name), ts3.factory.createExternalModuleReference(quotedModuleSpecifier)) : ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(needsTypeOnly(namespaceLikeImport), void 0, ts3.factory.createNamespaceImport(ts3.factory.createIdentifier(namespaceLikeImport.name))), quotedModuleSpecifier, void 0);
            statements = ts3.combine(statements, declaration);
          }
          return ts3.Debug.checkDefined(statements);
        }
        function getNewRequires(moduleSpecifier, quotePreference, defaultImport, namedImports, namespaceLikeImport) {
          var quotedModuleSpecifier = ts3.makeStringLiteral(moduleSpecifier, quotePreference);
          var statements;
          if (defaultImport || (namedImports === null || namedImports === void 0 ? void 0 : namedImports.length)) {
            var bindingElements = (namedImports === null || namedImports === void 0 ? void 0 : namedImports.map(function(_a) {
              var name = _a.name;
              return ts3.factory.createBindingElement(void 0, void 0, name);
            })) || [];
            if (defaultImport) {
              bindingElements.unshift(ts3.factory.createBindingElement(void 0, "default", defaultImport.name));
            }
            var declaration = createConstEqualsRequireDeclaration(ts3.factory.createObjectBindingPattern(bindingElements), quotedModuleSpecifier);
            statements = ts3.combine(statements, declaration);
          }
          if (namespaceLikeImport) {
            var declaration = createConstEqualsRequireDeclaration(namespaceLikeImport.name, quotedModuleSpecifier);
            statements = ts3.combine(statements, declaration);
          }
          return ts3.Debug.checkDefined(statements);
        }
        function createConstEqualsRequireDeclaration(name, quotedModuleSpecifier) {
          return ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
            ts3.factory.createVariableDeclaration(typeof name === "string" ? ts3.factory.createIdentifier(name) : name, void 0, void 0, ts3.factory.createCallExpression(ts3.factory.createIdentifier("require"), void 0, [quotedModuleSpecifier]))
          ], 2));
        }
        function symbolHasMeaning(_a, meaning) {
          var declarations = _a.declarations;
          return ts3.some(declarations, function(decl) {
            return !!(ts3.getMeaningFromDeclaration(decl) & meaning);
          });
        }
        function moduleSymbolToValidIdentifier(moduleSymbol, target, forceCapitalize) {
          return moduleSpecifierToValidIdentifier(ts3.removeFileExtension(ts3.stripQuotes(moduleSymbol.name)), target, forceCapitalize);
        }
        codefix2.moduleSymbolToValidIdentifier = moduleSymbolToValidIdentifier;
        function moduleSpecifierToValidIdentifier(moduleSpecifier, target, forceCapitalize) {
          var baseName = ts3.getBaseFileName(ts3.removeSuffix(moduleSpecifier, "/index"));
          var res = "";
          var lastCharWasValid = true;
          var firstCharCode = baseName.charCodeAt(0);
          if (ts3.isIdentifierStart(firstCharCode, target)) {
            res += String.fromCharCode(firstCharCode);
            if (forceCapitalize) {
              res = res.toUpperCase();
            }
          } else {
            lastCharWasValid = false;
          }
          for (var i = 1; i < baseName.length; i++) {
            var ch = baseName.charCodeAt(i);
            var isValid = ts3.isIdentifierPart(ch, target);
            if (isValid) {
              var char = String.fromCharCode(ch);
              if (!lastCharWasValid) {
                char = char.toUpperCase();
              }
              res += char;
            }
            lastCharWasValid = isValid;
          }
          return !ts3.isStringANonContextualKeyword(res) ? res || "_" : "_".concat(res);
        }
        codefix2.moduleSpecifierToValidIdentifier = moduleSpecifierToValidIdentifier;
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var _a;
        var fixName = "fixOverrideModifier";
        var fixAddOverrideId = "fixAddOverrideModifier";
        var fixRemoveOverrideId = "fixRemoveOverrideModifier";
        var errorCodes = [
          ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code,
          ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code,
          ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code,
          ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code,
          ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code,
          ts3.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,
          ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code,
          ts3.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,
          ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code
        ];
        var errorCodeFixIdMap = (_a = {}, _a[ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Add_override_modifier,
          fixId: fixAddOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Add_all_missing_override_modifiers
        }, _a[ts3.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Add_override_modifier,
          fixId: fixAddOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Add_all_missing_override_modifiers
        }, _a[ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code] = {
          descriptions: ts3.Diagnostics.Remove_override_modifier,
          fixId: fixRemoveOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        }, _a[ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code] = {
          descriptions: ts3.Diagnostics.Remove_override_modifier,
          fixId: fixRemoveOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Remove_override_modifier
        }, _a[ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Add_override_modifier,
          fixId: fixAddOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Add_all_missing_override_modifiers
        }, _a[ts3.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Add_override_modifier,
          fixId: fixAddOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Add_all_missing_override_modifiers
        }, _a[ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Add_override_modifier,
          fixId: fixAddOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        }, _a[ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Remove_override_modifier,
          fixId: fixRemoveOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        }, _a[ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code] = {
          descriptions: ts3.Diagnostics.Remove_override_modifier,
          fixId: fixRemoveOverrideId,
          fixAllDescriptions: ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        }, _a);
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToFixOverrideModifierIssues(context) {
            var errorCode = context.errorCode, span = context.span;
            var info = errorCodeFixIdMap[errorCode];
            if (!info)
              return ts3.emptyArray;
            var descriptions = info.descriptions, fixId = info.fixId, fixAllDescriptions = info.fixAllDescriptions;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              return dispatchChanges(changes2, context, errorCode, span.start);
            });
            return [
              codefix2.createCodeFixActionMaybeFixAll(fixName, changes, descriptions, fixId, fixAllDescriptions)
            ];
          },
          fixIds: [fixName, fixAddOverrideId, fixRemoveOverrideId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var code = diag.code, start = diag.start;
              var info = errorCodeFixIdMap[code];
              if (!info || info.fixId !== context.fixId) {
                return;
              }
              dispatchChanges(changes, context, code, start);
            });
          }
        });
        function dispatchChanges(changeTracker, context, errorCode, pos) {
          switch (errorCode) {
            case ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:
            case ts3.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
            case ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:
            case ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:
            case ts3.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
              return doAddOverrideModifierChange(changeTracker, context.sourceFile, pos);
            case ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:
            case ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code:
            case ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:
            case ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code:
              return doRemoveOverrideModifierChange(changeTracker, context.sourceFile, pos);
            default:
              ts3.Debug.fail("Unexpected error code: " + errorCode);
          }
        }
        function doAddOverrideModifierChange(changeTracker, sourceFile, pos) {
          var classElement = findContainerClassElementLike(sourceFile, pos);
          if (ts3.isSourceFileJS(sourceFile)) {
            changeTracker.addJSDocTags(sourceFile, classElement, [ts3.factory.createJSDocOverrideTag(ts3.factory.createIdentifier("override"))]);
            return;
          }
          var modifiers = classElement.modifiers || ts3.emptyArray;
          var staticModifier = ts3.find(modifiers, ts3.isStaticModifier);
          var abstractModifier = ts3.find(modifiers, ts3.isAbstractModifier);
          var accessibilityModifier = ts3.find(modifiers, function(m) {
            return ts3.isAccessibilityModifier(m.kind);
          });
          var modifierPos = abstractModifier ? abstractModifier.end : staticModifier ? staticModifier.end : accessibilityModifier ? accessibilityModifier.end : classElement.decorators ? ts3.skipTrivia(sourceFile.text, classElement.decorators.end) : classElement.getStart(sourceFile);
          var options = accessibilityModifier || staticModifier || abstractModifier ? { prefix: " " } : { suffix: " " };
          changeTracker.insertModifierAt(sourceFile, modifierPos, 159, options);
        }
        function doRemoveOverrideModifierChange(changeTracker, sourceFile, pos) {
          var classElement = findContainerClassElementLike(sourceFile, pos);
          if (ts3.isSourceFileJS(sourceFile)) {
            changeTracker.filterJSDocTags(sourceFile, classElement, ts3.not(ts3.isJSDocOverrideTag));
            return;
          }
          var overrideModifier = classElement.modifiers && ts3.find(classElement.modifiers, function(modifier) {
            return modifier.kind === 159;
          });
          ts3.Debug.assertIsDefined(overrideModifier);
          changeTracker.deleteModifier(sourceFile, overrideModifier);
        }
        function isClassElementLikeHasJSDoc(node) {
          switch (node.kind) {
            case 171:
            case 167:
            case 169:
            case 172:
            case 173:
              return true;
            case 164:
              return ts3.isParameterPropertyDeclaration(node, node.parent);
            default:
              return false;
          }
        }
        function findContainerClassElementLike(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var classElement = ts3.findAncestor(token, function(node) {
            if (ts3.isClassLike(node))
              return "quit";
            return isClassElementLikeHasJSDoc(node);
          });
          ts3.Debug.assert(classElement && isClassElementLikeHasJSDoc(classElement));
          return classElement;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixNoPropertyAccessFromIndexSignature";
        var errorCodes = [
          ts3.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span, preferences = context.preferences;
            var property = getPropertyAccessExpression(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, property, preferences);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Use_element_access_for_0, property.name.text], fixId, ts3.Diagnostics.Use_element_access_for_all_undeclared_properties)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, getPropertyAccessExpression(diag.file, diag.start), context.preferences);
            });
          }
        });
        function doChange(changes, sourceFile, node, preferences) {
          var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
          var argumentsExpression = ts3.factory.createStringLiteral(node.name.text, quotePreference === 0);
          changes.replaceNode(sourceFile, node, ts3.isPropertyAccessChain(node) ? ts3.factory.createElementAccessChain(node.expression, node.questionDotToken, argumentsExpression) : ts3.factory.createElementAccessExpression(node.expression, argumentsExpression));
        }
        function getPropertyAccessExpression(sourceFile, pos) {
          return ts3.cast(ts3.getTokenAtPosition(sourceFile, pos).parent, ts3.isPropertyAccessExpression);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixImplicitThis";
        var errorCodes = [ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToFixImplicitThis(context) {
            var sourceFile = context.sourceFile, program2 = context.program, span = context.span;
            var diagnostic;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              diagnostic = doChange(t, sourceFile, span.start, program2.getTypeChecker());
            });
            return diagnostic ? [codefix2.createCodeFixAction(fixId, changes, diagnostic, fixId, ts3.Diagnostics.Fix_all_implicit_this_errors)] : ts3.emptyArray;
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              doChange(changes, diag.file, diag.start, context.program.getTypeChecker());
            });
          }
        });
        function doChange(changes, sourceFile, pos, checker) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (!ts3.isThis(token))
            return void 0;
          var fn = ts3.getThisContainer(token, false);
          if (!ts3.isFunctionDeclaration(fn) && !ts3.isFunctionExpression(fn))
            return void 0;
          if (!ts3.isSourceFile(ts3.getThisContainer(fn, false))) {
            var fnKeyword = ts3.Debug.checkDefined(ts3.findChildOfKind(fn, 98, sourceFile));
            var name = fn.name;
            var body = ts3.Debug.checkDefined(fn.body);
            if (ts3.isFunctionExpression(fn)) {
              if (name && ts3.FindAllReferences.Core.isSymbolReferencedInFile(name, checker, sourceFile, body)) {
                return void 0;
              }
              changes.delete(sourceFile, fnKeyword);
              if (name) {
                changes.delete(sourceFile, name);
              }
              changes.insertText(sourceFile, body.pos, " =>");
              return [ts3.Diagnostics.Convert_function_expression_0_to_arrow_function, name ? name.text : ts3.ANONYMOUS];
            } else {
              changes.replaceNode(sourceFile, fnKeyword, ts3.factory.createToken(85));
              changes.insertText(sourceFile, name.end, " = ");
              changes.insertText(sourceFile, body.pos, " =>");
              return [ts3.Diagnostics.Convert_function_declaration_0_to_arrow_function, name.text];
            }
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixIncorrectNamedTupleSyntax";
        var errorCodes = [
          ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code,
          ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToFixIncorrectNamedTupleSyntax(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var namedTupleMember = getNamedTupleMember(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, namedTupleMember);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels, fixId, ts3.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels)];
          },
          fixIds: [fixId]
        });
        function getNamedTupleMember(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          return ts3.findAncestor(token, function(t) {
            return t.kind === 197;
          });
        }
        function doChange(changes, sourceFile, namedTupleMember) {
          if (!namedTupleMember) {
            return;
          }
          var unwrappedType = namedTupleMember.type;
          var sawOptional = false;
          var sawRest = false;
          while (unwrappedType.kind === 185 || unwrappedType.kind === 186 || unwrappedType.kind === 191) {
            if (unwrappedType.kind === 185) {
              sawOptional = true;
            } else if (unwrappedType.kind === 186) {
              sawRest = true;
            }
            unwrappedType = unwrappedType.type;
          }
          var updated = ts3.factory.updateNamedTupleMember(namedTupleMember, namedTupleMember.dotDotDotToken || (sawRest ? ts3.factory.createToken(25) : void 0), namedTupleMember.name, namedTupleMember.questionToken || (sawOptional ? ts3.factory.createToken(57) : void 0), unwrappedType);
          if (updated === namedTupleMember) {
            return;
          }
          changes.replaceNode(sourceFile, namedTupleMember, updated);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixSpelling";
        var errorCodes = [
          ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
          ts3.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
          ts3.Diagnostics.Could_not_find_name_0_Did_you_mean_1.code,
          ts3.Diagnostics.Cannot_find_namespace_0_Did_you_mean_1.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
          ts3.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2.code,
          ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,
          ts3.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,
          ts3.Diagnostics.No_overload_matches_this_call.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode;
            var info = getInfo(sourceFile, context.span.start, context, errorCode);
            if (!info)
              return void 0;
            var node = info.node, suggestedSymbol = info.suggestedSymbol;
            var target = ts3.getEmitScriptTarget(context.host.getCompilationSettings());
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, node, suggestedSymbol, target);
            });
            return [codefix2.createCodeFixAction("spelling", changes, [ts3.Diagnostics.Change_spelling_to_0, ts3.symbolName(suggestedSymbol)], fixId, ts3.Diagnostics.Fix_all_detected_spelling_errors)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, context, diag.code);
              var target = ts3.getEmitScriptTarget(context.host.getCompilationSettings());
              if (info)
                doChange(changes, context.sourceFile, info.node, info.suggestedSymbol, target);
            });
          }
        });
        function getInfo(sourceFile, pos, context, errorCode) {
          var node = ts3.getTokenAtPosition(sourceFile, pos);
          var parent = node.parent;
          if ((errorCode === ts3.Diagnostics.No_overload_matches_this_call.code || errorCode === ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code) && !ts3.isJsxAttribute(parent))
            return void 0;
          var checker = context.program.getTypeChecker();
          var suggestedSymbol;
          if (ts3.isPropertyAccessExpression(parent) && parent.name === node) {
            ts3.Debug.assert(ts3.isMemberName(node), "Expected an identifier for spelling (property access)");
            var containingType = checker.getTypeAtLocation(parent.expression);
            if (parent.flags & 32) {
              containingType = checker.getNonNullableType(containingType);
            }
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentProperty(node, containingType);
          } else if (ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 101 && parent.left === node && ts3.isPrivateIdentifier(node)) {
            var receiverType = checker.getTypeAtLocation(parent.right);
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentProperty(node, receiverType);
          } else if (ts3.isQualifiedName(parent) && parent.right === node) {
            var symbol = checker.getSymbolAtLocation(parent.left);
            if (symbol && symbol.flags & 1536) {
              suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(parent.right, symbol);
            }
          } else if (ts3.isImportSpecifier(parent) && parent.name === node) {
            ts3.Debug.assertNode(node, ts3.isIdentifier, "Expected an identifier for spelling (import)");
            var importDeclaration = ts3.findAncestor(node, ts3.isImportDeclaration);
            var resolvedSourceFile = getResolvedSourceFileFromImportDeclaration(sourceFile, context, importDeclaration);
            if (resolvedSourceFile && resolvedSourceFile.symbol) {
              suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(node, resolvedSourceFile.symbol);
            }
          } else if (ts3.isJsxAttribute(parent) && parent.name === node) {
            ts3.Debug.assertNode(node, ts3.isIdentifier, "Expected an identifier for JSX attribute");
            var tag = ts3.findAncestor(node, ts3.isJsxOpeningLikeElement);
            var props = checker.getContextualTypeForArgumentAtIndex(tag, 0);
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentJSXAttribute(node, props);
          } else if (ts3.hasSyntacticModifier(parent, 16384) && ts3.isClassElement(parent) && parent.name === node) {
            var baseDeclaration = ts3.findAncestor(node, ts3.isClassLike);
            var baseTypeNode = baseDeclaration ? ts3.getEffectiveBaseTypeNode(baseDeclaration) : void 0;
            var baseType = baseTypeNode ? checker.getTypeAtLocation(baseTypeNode) : void 0;
            if (baseType) {
              suggestedSymbol = checker.getSuggestedSymbolForNonexistentClassMember(ts3.getTextOfNode(node), baseType);
            }
          } else {
            var meaning = ts3.getMeaningFromLocation(node);
            var name = ts3.getTextOfNode(node);
            ts3.Debug.assert(name !== void 0, "name should be defined");
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentSymbol(node, name, convertSemanticMeaningToSymbolFlags(meaning));
          }
          return suggestedSymbol === void 0 ? void 0 : { node, suggestedSymbol };
        }
        function doChange(changes, sourceFile, node, suggestedSymbol, target) {
          var suggestion = ts3.symbolName(suggestedSymbol);
          if (!ts3.isIdentifierText(suggestion, target) && ts3.isPropertyAccessExpression(node.parent)) {
            var valDecl = suggestedSymbol.valueDeclaration;
            if (valDecl && ts3.isNamedDeclaration(valDecl) && ts3.isPrivateIdentifier(valDecl.name)) {
              changes.replaceNode(sourceFile, node, ts3.factory.createIdentifier(suggestion));
            } else {
              changes.replaceNode(sourceFile, node.parent, ts3.factory.createElementAccessExpression(node.parent.expression, ts3.factory.createStringLiteral(suggestion)));
            }
          } else {
            changes.replaceNode(sourceFile, node, ts3.factory.createIdentifier(suggestion));
          }
        }
        function convertSemanticMeaningToSymbolFlags(meaning) {
          var flags = 0;
          if (meaning & 4) {
            flags |= 1920;
          }
          if (meaning & 2) {
            flags |= 788968;
          }
          if (meaning & 1) {
            flags |= 111551;
          }
          return flags;
        }
        function getResolvedSourceFileFromImportDeclaration(sourceFile, context, importDeclaration) {
          if (!importDeclaration || !ts3.isStringLiteralLike(importDeclaration.moduleSpecifier))
            return void 0;
          var resolvedModule = ts3.getResolvedModule(sourceFile, importDeclaration.moduleSpecifier.text, ts3.getModeForUsageLocation(sourceFile, importDeclaration.moduleSpecifier));
          if (!resolvedModule)
            return void 0;
          return context.program.getSourceFile(resolvedModule.resolvedFileName);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "returnValueCorrect";
        var fixIdAddReturnStatement = "fixAddReturnStatement";
        var fixRemoveBracesFromArrowFunctionBody = "fixRemoveBracesFromArrowFunctionBody";
        var fixIdWrapTheBlockWithParen = "fixWrapTheBlockWithParen";
        var errorCodes = [
          ts3.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code
        ];
        var ProblemKind;
        (function(ProblemKind2) {
          ProblemKind2[ProblemKind2["MissingReturnStatement"] = 0] = "MissingReturnStatement";
          ProblemKind2[ProblemKind2["MissingParentheses"] = 1] = "MissingParentheses";
        })(ProblemKind || (ProblemKind = {}));
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixIdAddReturnStatement, fixRemoveBracesFromArrowFunctionBody, fixIdWrapTheBlockWithParen],
          getCodeActions: function getCodeActionsToCorrectReturnValue(context) {
            var program2 = context.program, sourceFile = context.sourceFile, start = context.span.start, errorCode = context.errorCode;
            var info = getInfo(program2.getTypeChecker(), sourceFile, start, errorCode);
            if (!info)
              return void 0;
            if (info.kind === ProblemKind.MissingReturnStatement) {
              return ts3.append([getActionForfixAddReturnStatement(context, info.expression, info.statement)], ts3.isArrowFunction(info.declaration) ? getActionForFixRemoveBracesFromArrowFunctionBody(context, info.declaration, info.expression, info.commentSource) : void 0);
            } else {
              return [getActionForfixWrapTheBlockWithParen(context, info.declaration, info.expression)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(context.program.getTypeChecker(), diag.file, diag.start, diag.code);
              if (!info)
                return void 0;
              switch (context.fixId) {
                case fixIdAddReturnStatement:
                  addReturnStatement(changes, diag.file, info.expression, info.statement);
                  break;
                case fixRemoveBracesFromArrowFunctionBody:
                  if (!ts3.isArrowFunction(info.declaration))
                    return void 0;
                  removeBlockBodyBrace(changes, diag.file, info.declaration, info.expression, info.commentSource, false);
                  break;
                case fixIdWrapTheBlockWithParen:
                  if (!ts3.isArrowFunction(info.declaration))
                    return void 0;
                  wrapBlockWithParen(changes, diag.file, info.declaration, info.expression);
                  break;
                default:
                  ts3.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function createObjectTypeFromLabeledExpression(checker, label, expression) {
          var member = checker.createSymbol(4, label.escapedText);
          member.type = checker.getTypeAtLocation(expression);
          var members = ts3.createSymbolTable([member]);
          return checker.createAnonymousType(void 0, members, [], [], []);
        }
        function getFixInfo(checker, declaration, expectType, isFunctionType) {
          if (!declaration.body || !ts3.isBlock(declaration.body) || ts3.length(declaration.body.statements) !== 1)
            return void 0;
          var firstStatement = ts3.first(declaration.body.statements);
          if (ts3.isExpressionStatement(firstStatement) && checkFixedAssignableTo(checker, declaration, checker.getTypeAtLocation(firstStatement.expression), expectType, isFunctionType)) {
            return {
              declaration,
              kind: ProblemKind.MissingReturnStatement,
              expression: firstStatement.expression,
              statement: firstStatement,
              commentSource: firstStatement.expression
            };
          } else if (ts3.isLabeledStatement(firstStatement) && ts3.isExpressionStatement(firstStatement.statement)) {
            var node = ts3.factory.createObjectLiteralExpression([ts3.factory.createPropertyAssignment(firstStatement.label, firstStatement.statement.expression)]);
            var nodeType = createObjectTypeFromLabeledExpression(checker, firstStatement.label, firstStatement.statement.expression);
            if (checkFixedAssignableTo(checker, declaration, nodeType, expectType, isFunctionType)) {
              return ts3.isArrowFunction(declaration) ? {
                declaration,
                kind: ProblemKind.MissingParentheses,
                expression: node,
                statement: firstStatement,
                commentSource: firstStatement.statement.expression
              } : {
                declaration,
                kind: ProblemKind.MissingReturnStatement,
                expression: node,
                statement: firstStatement,
                commentSource: firstStatement.statement.expression
              };
            }
          } else if (ts3.isBlock(firstStatement) && ts3.length(firstStatement.statements) === 1) {
            var firstBlockStatement = ts3.first(firstStatement.statements);
            if (ts3.isLabeledStatement(firstBlockStatement) && ts3.isExpressionStatement(firstBlockStatement.statement)) {
              var node = ts3.factory.createObjectLiteralExpression([ts3.factory.createPropertyAssignment(firstBlockStatement.label, firstBlockStatement.statement.expression)]);
              var nodeType = createObjectTypeFromLabeledExpression(checker, firstBlockStatement.label, firstBlockStatement.statement.expression);
              if (checkFixedAssignableTo(checker, declaration, nodeType, expectType, isFunctionType)) {
                return {
                  declaration,
                  kind: ProblemKind.MissingReturnStatement,
                  expression: node,
                  statement: firstStatement,
                  commentSource: firstBlockStatement
                };
              }
            }
          }
          return void 0;
        }
        function checkFixedAssignableTo(checker, declaration, exprType, type2, isFunctionType) {
          if (isFunctionType) {
            var sig = checker.getSignatureFromDeclaration(declaration);
            if (sig) {
              if (ts3.hasSyntacticModifier(declaration, 256)) {
                exprType = checker.createPromiseType(exprType);
              }
              var newSig = checker.createSignature(declaration, sig.typeParameters, sig.thisParameter, sig.parameters, exprType, void 0, sig.minArgumentCount, sig.flags);
              exprType = checker.createAnonymousType(void 0, ts3.createSymbolTable(), [newSig], [], []);
            } else {
              exprType = checker.getAnyType();
            }
          }
          return checker.isTypeAssignableTo(exprType, type2);
        }
        function getInfo(checker, sourceFile, position, errorCode) {
          var node = ts3.getTokenAtPosition(sourceFile, position);
          if (!node.parent)
            return void 0;
          var declaration = ts3.findAncestor(node.parent, ts3.isFunctionLikeDeclaration);
          switch (errorCode) {
            case ts3.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code:
              if (!declaration || !declaration.body || !declaration.type || !ts3.rangeContainsRange(declaration.type, node))
                return void 0;
              return getFixInfo(checker, declaration, checker.getTypeFromTypeNode(declaration.type), false);
            case ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:
              if (!declaration || !ts3.isCallExpression(declaration.parent) || !declaration.body)
                return void 0;
              var pos = declaration.parent.arguments.indexOf(declaration);
              var type2 = checker.getContextualTypeForArgumentAtIndex(declaration.parent, pos);
              if (!type2)
                return void 0;
              return getFixInfo(checker, declaration, type2, true);
            case ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code:
              if (!ts3.isDeclarationName(node) || !ts3.isVariableLike(node.parent) && !ts3.isJsxAttribute(node.parent))
                return void 0;
              var initializer = getVariableLikeInitializer(node.parent);
              if (!initializer || !ts3.isFunctionLikeDeclaration(initializer) || !initializer.body)
                return void 0;
              return getFixInfo(checker, initializer, checker.getTypeAtLocation(node.parent), true);
          }
          return void 0;
        }
        function getVariableLikeInitializer(declaration) {
          switch (declaration.kind) {
            case 254:
            case 164:
            case 203:
            case 167:
            case 296:
              return declaration.initializer;
            case 285:
              return declaration.initializer && (ts3.isJsxExpression(declaration.initializer) ? declaration.initializer.expression : void 0);
            case 297:
            case 166:
            case 299:
            case 347:
            case 340:
              return void 0;
          }
        }
        function addReturnStatement(changes, sourceFile, expression, statement) {
          ts3.suppressLeadingAndTrailingTrivia(expression);
          var probablyNeedSemi = ts3.probablyUsesSemicolons(sourceFile);
          changes.replaceNode(sourceFile, statement, ts3.factory.createReturnStatement(expression), {
            leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude,
            trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude,
            suffix: probablyNeedSemi ? ";" : void 0
          });
        }
        function removeBlockBodyBrace(changes, sourceFile, declaration, expression, commentSource, withParen) {
          var newBody = withParen || ts3.needsParentheses(expression) ? ts3.factory.createParenthesizedExpression(expression) : expression;
          ts3.suppressLeadingAndTrailingTrivia(commentSource);
          ts3.copyComments(commentSource, newBody);
          changes.replaceNode(sourceFile, declaration.body, newBody);
        }
        function wrapBlockWithParen(changes, sourceFile, declaration, expression) {
          changes.replaceNode(sourceFile, declaration.body, ts3.factory.createParenthesizedExpression(expression));
        }
        function getActionForfixAddReturnStatement(context, expression, statement) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return addReturnStatement(t, context.sourceFile, expression, statement);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_a_return_statement, fixIdAddReturnStatement, ts3.Diagnostics.Add_all_missing_return_statement);
        }
        function getActionForFixRemoveBracesFromArrowFunctionBody(context, declaration, expression, commentSource) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return removeBlockBodyBrace(t, context.sourceFile, declaration, expression, commentSource, false);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_braces_from_arrow_function_body, fixRemoveBracesFromArrowFunctionBody, ts3.Diagnostics.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues);
        }
        function getActionForfixWrapTheBlockWithParen(context, declaration, expression) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return wrapBlockWithParen(t, context.sourceFile, declaration, expression);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal, fixIdWrapTheBlockWithParen, ts3.Diagnostics.Wrap_all_object_literal_with_parentheses);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixMissingMember = "fixMissingMember";
        var fixMissingProperties = "fixMissingProperties";
        var fixMissingAttributes = "fixMissingAttributes";
        var fixMissingFunctionDeclaration = "fixMissingFunctionDeclaration";
        var errorCodes = [
          ts3.Diagnostics.Property_0_does_not_exist_on_type_1.code,
          ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
          ts3.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code,
          ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,
          ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code,
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          ts3.Diagnostics.Cannot_find_name_0.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var typeChecker = context.program.getTypeChecker();
            var info = getInfo(context.sourceFile, context.span.start, context.errorCode, typeChecker, context.program);
            if (!info) {
              return void 0;
            }
            if (info.kind === 3) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return addObjectLiteralProperties(t, context, info);
              });
              return [codefix2.createCodeFixAction(fixMissingProperties, changes, ts3.Diagnostics.Add_missing_properties, fixMissingProperties, ts3.Diagnostics.Add_all_missing_properties)];
            }
            if (info.kind === 4) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return addJsxAttributes(t, context, info);
              });
              return [codefix2.createCodeFixAction(fixMissingAttributes, changes, ts3.Diagnostics.Add_missing_attributes, fixMissingAttributes, ts3.Diagnostics.Add_all_missing_attributes)];
            }
            if (info.kind === 2) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return addFunctionDeclaration(t, context, info);
              });
              return [codefix2.createCodeFixAction(fixMissingFunctionDeclaration, changes, [ts3.Diagnostics.Add_missing_function_declaration_0, info.token.text], fixMissingFunctionDeclaration, ts3.Diagnostics.Add_all_missing_function_declarations)];
            }
            if (info.kind === 1) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return addEnumMemberDeclaration(t, context.program.getTypeChecker(), info);
              });
              return [codefix2.createCodeFixAction(fixMissingMember, changes, [ts3.Diagnostics.Add_missing_enum_member_0, info.token.text], fixMissingMember, ts3.Diagnostics.Add_all_missing_members)];
            }
            return ts3.concatenate(getActionsForMissingMethodDeclaration(context, info), getActionsForMissingMemberDeclaration(context, info));
          },
          fixIds: [fixMissingMember, fixMissingFunctionDeclaration, fixMissingProperties, fixMissingAttributes],
          getAllCodeActions: function(context) {
            var program2 = context.program, fixId = context.fixId;
            var checker = program2.getTypeChecker();
            var seen = new ts3.Map();
            var typeDeclToMembers = new ts3.Map();
            return codefix2.createCombinedCodeActions(ts3.textChanges.ChangeTracker.with(context, function(changes) {
              codefix2.eachDiagnostic(context, errorCodes, function(diag) {
                var info = getInfo(diag.file, diag.start, diag.code, checker, context.program);
                if (!info || !ts3.addToSeen(seen, ts3.getNodeId(info.parentDeclaration) + "#" + info.token.text)) {
                  return;
                }
                if (fixId === fixMissingFunctionDeclaration && info.kind === 2) {
                  addFunctionDeclaration(changes, context, info);
                } else if (fixId === fixMissingProperties && info.kind === 3) {
                  addObjectLiteralProperties(changes, context, info);
                } else if (fixId === fixMissingAttributes && info.kind === 4) {
                  addJsxAttributes(changes, context, info);
                } else {
                  if (info.kind === 1) {
                    addEnumMemberDeclaration(changes, checker, info);
                  }
                  if (info.kind === 0) {
                    var parentDeclaration = info.parentDeclaration, token_1 = info.token;
                    var infos = ts3.getOrUpdate(typeDeclToMembers, parentDeclaration, function() {
                      return [];
                    });
                    if (!infos.some(function(i) {
                      return i.token.text === token_1.text;
                    })) {
                      infos.push(info);
                    }
                  }
                }
              });
              typeDeclToMembers.forEach(function(infos, declaration) {
                var supers = ts3.isTypeLiteralNode(declaration) ? void 0 : codefix2.getAllSupers(declaration, checker);
                var _loop_15 = function(info2) {
                  if (supers === null || supers === void 0 ? void 0 : supers.some(function(superClassOrInterface) {
                    var superInfos = typeDeclToMembers.get(superClassOrInterface);
                    return !!superInfos && superInfos.some(function(_a) {
                      var token2 = _a.token;
                      return token2.text === info2.token.text;
                    });
                  }))
                    return "continue";
                  var parentDeclaration = info2.parentDeclaration, declSourceFile = info2.declSourceFile, modifierFlags = info2.modifierFlags, token = info2.token, call = info2.call, isJSFile = info2.isJSFile;
                  if (call && !ts3.isPrivateIdentifier(token)) {
                    addMethodDeclaration(context, changes, call, token, modifierFlags & 32, parentDeclaration, declSourceFile);
                  } else {
                    if (isJSFile && !ts3.isInterfaceDeclaration(parentDeclaration) && !ts3.isTypeLiteralNode(parentDeclaration)) {
                      addMissingMemberInJs(changes, declSourceFile, parentDeclaration, token, !!(modifierFlags & 32));
                    } else {
                      var typeNode = getTypeNode(checker, parentDeclaration, token);
                      addPropertyDeclaration(changes, declSourceFile, parentDeclaration, token.text, typeNode, modifierFlags & 32);
                    }
                  }
                };
                for (var _i = 0, infos_1 = infos; _i < infos_1.length; _i++) {
                  var info = infos_1[_i];
                  _loop_15(info);
                }
              });
            }));
          }
        });
        var InfoKind;
        (function(InfoKind2) {
          InfoKind2[InfoKind2["TypeLikeDeclaration"] = 0] = "TypeLikeDeclaration";
          InfoKind2[InfoKind2["Enum"] = 1] = "Enum";
          InfoKind2[InfoKind2["Function"] = 2] = "Function";
          InfoKind2[InfoKind2["ObjectLiteral"] = 3] = "ObjectLiteral";
          InfoKind2[InfoKind2["JsxAttributes"] = 4] = "JsxAttributes";
        })(InfoKind || (InfoKind = {}));
        function getInfo(sourceFile, tokenPos, errorCode, checker, program2) {
          var token = ts3.getTokenAtPosition(sourceFile, tokenPos);
          var parent = token.parent;
          if (errorCode === ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code) {
            if (!(token.kind === 18 && ts3.isObjectLiteralExpression(parent) && ts3.isCallExpression(parent.parent)))
              return void 0;
            var argIndex = ts3.findIndex(parent.parent.arguments, function(arg) {
              return arg === parent;
            });
            if (argIndex < 0)
              return void 0;
            var signature = ts3.singleOrUndefined(checker.getSignaturesOfType(checker.getTypeAtLocation(parent.parent.expression), 0));
            if (!(signature && signature.declaration && signature.parameters[argIndex]))
              return void 0;
            var param = signature.parameters[argIndex].valueDeclaration;
            if (!(param && ts3.isParameter(param) && ts3.isIdentifier(param.name)))
              return void 0;
            var properties = ts3.arrayFrom(checker.getUnmatchedProperties(checker.getTypeAtLocation(parent), checker.getParameterType(signature, argIndex), false, false));
            if (!ts3.length(properties))
              return void 0;
            return { kind: 3, token: param.name, properties, parentDeclaration: parent };
          }
          if (!ts3.isMemberName(token))
            return void 0;
          if (ts3.isIdentifier(token) && ts3.hasInitializer(parent) && parent.initializer && ts3.isObjectLiteralExpression(parent.initializer)) {
            var properties = ts3.arrayFrom(checker.getUnmatchedProperties(checker.getTypeAtLocation(parent.initializer), checker.getTypeAtLocation(token), false, false));
            if (!ts3.length(properties))
              return void 0;
            return { kind: 3, token, properties, parentDeclaration: parent.initializer };
          }
          if (ts3.isIdentifier(token) && ts3.isJsxOpeningLikeElement(token.parent)) {
            var target = ts3.getEmitScriptTarget(program2.getCompilerOptions());
            var attributes = getUnmatchedAttributes(checker, target, token.parent);
            if (!ts3.length(attributes))
              return void 0;
            return { kind: 4, token, attributes, parentDeclaration: token.parent };
          }
          if (ts3.isIdentifier(token) && ts3.isCallExpression(parent)) {
            return { kind: 2, token, call: parent, sourceFile, modifierFlags: 0, parentDeclaration: sourceFile };
          }
          if (!ts3.isPropertyAccessExpression(parent))
            return void 0;
          var leftExpressionType = ts3.skipConstraint(checker.getTypeAtLocation(parent.expression));
          var symbol = leftExpressionType.symbol;
          if (!symbol || !symbol.declarations)
            return void 0;
          if (ts3.isIdentifier(token) && ts3.isCallExpression(parent.parent)) {
            var moduleDeclaration = ts3.find(symbol.declarations, ts3.isModuleDeclaration);
            var moduleDeclarationSourceFile = moduleDeclaration === null || moduleDeclaration === void 0 ? void 0 : moduleDeclaration.getSourceFile();
            if (moduleDeclaration && moduleDeclarationSourceFile && !isSourceFileFromLibrary(program2, moduleDeclarationSourceFile)) {
              return { kind: 2, token, call: parent.parent, sourceFile, modifierFlags: 1, parentDeclaration: moduleDeclaration };
            }
            var moduleSourceFile = ts3.find(symbol.declarations, ts3.isSourceFile);
            if (sourceFile.commonJsModuleIndicator)
              return void 0;
            if (moduleSourceFile && !isSourceFileFromLibrary(program2, moduleSourceFile)) {
              return { kind: 2, token, call: parent.parent, sourceFile: moduleSourceFile, modifierFlags: 1, parentDeclaration: moduleSourceFile };
            }
          }
          var classDeclaration = ts3.find(symbol.declarations, ts3.isClassLike);
          if (!classDeclaration && ts3.isPrivateIdentifier(token))
            return void 0;
          var declaration = classDeclaration || ts3.find(symbol.declarations, function(d) {
            return ts3.isInterfaceDeclaration(d) || ts3.isTypeLiteralNode(d);
          });
          if (declaration && !isSourceFileFromLibrary(program2, declaration.getSourceFile())) {
            var makeStatic = !ts3.isTypeLiteralNode(declaration) && (leftExpressionType.target || leftExpressionType) !== checker.getDeclaredTypeOfSymbol(symbol);
            if (makeStatic && (ts3.isPrivateIdentifier(token) || ts3.isInterfaceDeclaration(declaration)))
              return void 0;
            var declSourceFile = declaration.getSourceFile();
            var modifierFlags = ts3.isTypeLiteralNode(declaration) ? 0 : (makeStatic ? 32 : 0) | (ts3.startsWithUnderscore(token.text) ? 8 : 0);
            var isJSFile = ts3.isSourceFileJS(declSourceFile);
            var call = ts3.tryCast(parent.parent, ts3.isCallExpression);
            return { kind: 0, token, call, modifierFlags, parentDeclaration: declaration, declSourceFile, isJSFile };
          }
          var enumDeclaration = ts3.find(symbol.declarations, ts3.isEnumDeclaration);
          if (enumDeclaration && !ts3.isPrivateIdentifier(token) && !isSourceFileFromLibrary(program2, enumDeclaration.getSourceFile())) {
            return { kind: 1, token, parentDeclaration: enumDeclaration };
          }
          return void 0;
        }
        function isSourceFileFromLibrary(program2, node) {
          return program2.isSourceFileFromExternalLibrary(node) || program2.isSourceFileDefaultLibrary(node);
        }
        function getActionsForMissingMemberDeclaration(context, info) {
          return info.isJSFile ? ts3.singleElementArray(createActionForAddMissingMemberInJavascriptFile(context, info)) : createActionsForAddMissingMemberInTypeScriptFile(context, info);
        }
        function createActionForAddMissingMemberInJavascriptFile(context, _a) {
          var parentDeclaration = _a.parentDeclaration, declSourceFile = _a.declSourceFile, modifierFlags = _a.modifierFlags, token = _a.token;
          if (ts3.isInterfaceDeclaration(parentDeclaration) || ts3.isTypeLiteralNode(parentDeclaration)) {
            return void 0;
          }
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return addMissingMemberInJs(t, declSourceFile, parentDeclaration, token, !!(modifierFlags & 32));
          });
          if (changes.length === 0) {
            return void 0;
          }
          var diagnostic = modifierFlags & 32 ? ts3.Diagnostics.Initialize_static_property_0 : ts3.isPrivateIdentifier(token) ? ts3.Diagnostics.Declare_a_private_field_named_0 : ts3.Diagnostics.Initialize_property_0_in_the_constructor;
          return codefix2.createCodeFixAction(fixMissingMember, changes, [diagnostic, token.text], fixMissingMember, ts3.Diagnostics.Add_all_missing_members);
        }
        function addMissingMemberInJs(changeTracker, sourceFile, classDeclaration, token, makeStatic) {
          var tokenName = token.text;
          if (makeStatic) {
            if (classDeclaration.kind === 226) {
              return;
            }
            var className = classDeclaration.name.getText();
            var staticInitialization = initializePropertyToUndefined(ts3.factory.createIdentifier(className), tokenName);
            changeTracker.insertNodeAfter(sourceFile, classDeclaration, staticInitialization);
          } else if (ts3.isPrivateIdentifier(token)) {
            var property = ts3.factory.createPropertyDeclaration(void 0, void 0, tokenName, void 0, void 0, void 0);
            var lastProp = getNodeToInsertPropertyAfter(classDeclaration);
            if (lastProp) {
              changeTracker.insertNodeAfter(sourceFile, lastProp, property);
            } else {
              changeTracker.insertMemberAtStart(sourceFile, classDeclaration, property);
            }
          } else {
            var classConstructor = ts3.getFirstConstructorWithBody(classDeclaration);
            if (!classConstructor) {
              return;
            }
            var propertyInitialization = initializePropertyToUndefined(ts3.factory.createThis(), tokenName);
            changeTracker.insertNodeAtConstructorEnd(sourceFile, classConstructor, propertyInitialization);
          }
        }
        function initializePropertyToUndefined(obj, propertyName) {
          return ts3.factory.createExpressionStatement(ts3.factory.createAssignment(ts3.factory.createPropertyAccessExpression(obj, propertyName), createUndefined()));
        }
        function createActionsForAddMissingMemberInTypeScriptFile(context, _a) {
          var parentDeclaration = _a.parentDeclaration, declSourceFile = _a.declSourceFile, modifierFlags = _a.modifierFlags, token = _a.token;
          var memberName = token.text;
          var isStatic = modifierFlags & 32;
          var typeNode = getTypeNode(context.program.getTypeChecker(), parentDeclaration, token);
          var addPropertyDeclarationChanges = function(modifierFlags2) {
            return ts3.textChanges.ChangeTracker.with(context, function(t) {
              return addPropertyDeclaration(t, declSourceFile, parentDeclaration, memberName, typeNode, modifierFlags2);
            });
          };
          var actions2 = [codefix2.createCodeFixAction(fixMissingMember, addPropertyDeclarationChanges(modifierFlags & 32), [isStatic ? ts3.Diagnostics.Declare_static_property_0 : ts3.Diagnostics.Declare_property_0, memberName], fixMissingMember, ts3.Diagnostics.Add_all_missing_members)];
          if (isStatic || ts3.isPrivateIdentifier(token)) {
            return actions2;
          }
          if (modifierFlags & 8) {
            actions2.unshift(codefix2.createCodeFixActionWithoutFixAll(fixMissingMember, addPropertyDeclarationChanges(8), [ts3.Diagnostics.Declare_private_property_0, memberName]));
          }
          actions2.push(createAddIndexSignatureAction(context, declSourceFile, parentDeclaration, token.text, typeNode));
          return actions2;
        }
        function getTypeNode(checker, node, token) {
          var typeNode;
          if (token.parent.parent.kind === 221) {
            var binaryExpression = token.parent.parent;
            var otherExpression = token.parent === binaryExpression.left ? binaryExpression.right : binaryExpression.left;
            var widenedType = checker.getWidenedType(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(otherExpression)));
            typeNode = checker.typeToTypeNode(widenedType, node, 1);
          } else {
            var contextualType = checker.getContextualType(token.parent);
            typeNode = contextualType ? checker.typeToTypeNode(contextualType, void 0, 1) : void 0;
          }
          return typeNode || ts3.factory.createKeywordTypeNode(130);
        }
        function addPropertyDeclaration(changeTracker, sourceFile, node, tokenName, typeNode, modifierFlags) {
          var modifiers = modifierFlags ? ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
          var property = ts3.isClassLike(node) ? ts3.factory.createPropertyDeclaration(void 0, modifiers, tokenName, void 0, typeNode, void 0) : ts3.factory.createPropertySignature(void 0, tokenName, void 0, typeNode);
          var lastProp = getNodeToInsertPropertyAfter(node);
          if (lastProp) {
            changeTracker.insertNodeAfter(sourceFile, lastProp, property);
          } else {
            changeTracker.insertMemberAtStart(sourceFile, node, property);
          }
        }
        function getNodeToInsertPropertyAfter(node) {
          var res;
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (!ts3.isPropertyDeclaration(member))
              break;
            res = member;
          }
          return res;
        }
        function createAddIndexSignatureAction(context, sourceFile, node, tokenName, typeNode) {
          var stringTypeNode = ts3.factory.createKeywordTypeNode(150);
          var indexingParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, stringTypeNode, void 0);
          var indexSignature = ts3.factory.createIndexSignature(void 0, void 0, [indexingParameter], typeNode);
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return t.insertMemberAtStart(sourceFile, node, indexSignature);
          });
          return codefix2.createCodeFixActionWithoutFixAll(fixMissingMember, changes, [ts3.Diagnostics.Add_index_signature_for_property_0, tokenName]);
        }
        function getActionsForMissingMethodDeclaration(context, info) {
          var parentDeclaration = info.parentDeclaration, declSourceFile = info.declSourceFile, modifierFlags = info.modifierFlags, token = info.token, call = info.call;
          if (call === void 0) {
            return void 0;
          }
          if (ts3.isPrivateIdentifier(token)) {
            return void 0;
          }
          var methodName = token.text;
          var addMethodDeclarationChanges = function(modifierFlags2) {
            return ts3.textChanges.ChangeTracker.with(context, function(t) {
              return addMethodDeclaration(context, t, call, token, modifierFlags2, parentDeclaration, declSourceFile);
            });
          };
          var actions2 = [codefix2.createCodeFixAction(fixMissingMember, addMethodDeclarationChanges(modifierFlags & 32), [modifierFlags & 32 ? ts3.Diagnostics.Declare_static_method_0 : ts3.Diagnostics.Declare_method_0, methodName], fixMissingMember, ts3.Diagnostics.Add_all_missing_members)];
          if (modifierFlags & 8) {
            actions2.unshift(codefix2.createCodeFixActionWithoutFixAll(fixMissingMember, addMethodDeclarationChanges(8), [ts3.Diagnostics.Declare_private_method_0, methodName]));
          }
          return actions2;
        }
        function addMethodDeclaration(context, changes, callExpression, name, modifierFlags, parentDeclaration, sourceFile) {
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, context.preferences, context.host);
          var kind = ts3.isClassLike(parentDeclaration) ? 169 : 168;
          var signatureDeclaration = codefix2.createSignatureDeclarationFromCallExpression(kind, context, importAdder, callExpression, name, modifierFlags, parentDeclaration);
          var containingMethodDeclaration = tryGetContainingMethodDeclaration(parentDeclaration, callExpression);
          if (containingMethodDeclaration) {
            changes.insertNodeAfter(sourceFile, containingMethodDeclaration, signatureDeclaration);
          } else {
            changes.insertMemberAtStart(sourceFile, parentDeclaration, signatureDeclaration);
          }
          importAdder.writeFixes(changes);
        }
        function addEnumMemberDeclaration(changes, checker, _a) {
          var token = _a.token, parentDeclaration = _a.parentDeclaration;
          var hasStringInitializer = ts3.some(parentDeclaration.members, function(member) {
            var type2 = checker.getTypeAtLocation(member);
            return !!(type2 && type2.flags & 402653316);
          });
          var enumMember = ts3.factory.createEnumMember(token, hasStringInitializer ? ts3.factory.createStringLiteral(token.text) : void 0);
          changes.replaceNode(parentDeclaration.getSourceFile(), parentDeclaration, ts3.factory.updateEnumDeclaration(parentDeclaration, parentDeclaration.decorators, parentDeclaration.modifiers, parentDeclaration.name, ts3.concatenate(parentDeclaration.members, ts3.singleElementArray(enumMember))), {
            leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll,
            trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude
          });
        }
        function addFunctionDeclaration(changes, context, info) {
          var importAdder = codefix2.createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
          var functionDeclaration = codefix2.createSignatureDeclarationFromCallExpression(256, context, importAdder, info.call, ts3.idText(info.token), info.modifierFlags, info.parentDeclaration);
          changes.insertNodeAtEndOfScope(info.sourceFile, info.parentDeclaration, functionDeclaration);
        }
        function addJsxAttributes(changes, context, info) {
          var importAdder = codefix2.createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
          var quotePreference = ts3.getQuotePreference(context.sourceFile, context.preferences);
          var checker = context.program.getTypeChecker();
          var jsxAttributesNode = info.parentDeclaration.attributes;
          var hasSpreadAttribute = ts3.some(jsxAttributesNode.properties, ts3.isJsxSpreadAttribute);
          var attrs = ts3.map(info.attributes, function(attr) {
            var value = tryGetValueFromType(context, checker, importAdder, quotePreference, checker.getTypeOfSymbol(attr));
            var name = ts3.factory.createIdentifier(attr.name);
            var jsxAttribute = ts3.factory.createJsxAttribute(name, ts3.factory.createJsxExpression(void 0, value));
            ts3.setParent(name, jsxAttribute);
            return jsxAttribute;
          });
          var jsxAttributes = ts3.factory.createJsxAttributes(hasSpreadAttribute ? __spreadArray(__spreadArray([], attrs, true), jsxAttributesNode.properties, true) : __spreadArray(__spreadArray([], jsxAttributesNode.properties, true), attrs, true));
          var options = { prefix: jsxAttributesNode.pos === jsxAttributesNode.end ? " " : void 0 };
          changes.replaceNode(context.sourceFile, jsxAttributesNode, jsxAttributes, options);
        }
        function addObjectLiteralProperties(changes, context, info) {
          var importAdder = codefix2.createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
          var quotePreference = ts3.getQuotePreference(context.sourceFile, context.preferences);
          var target = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
          var checker = context.program.getTypeChecker();
          var props = ts3.map(info.properties, function(prop) {
            var initializer = tryGetValueFromType(context, checker, importAdder, quotePreference, checker.getTypeOfSymbol(prop));
            return ts3.factory.createPropertyAssignment(ts3.createPropertyNameNodeForIdentifierOrLiteral(prop.name, target, quotePreference === 0), initializer);
          });
          var options = {
            leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude,
            trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude,
            indentation: info.indentation
          };
          changes.replaceNode(context.sourceFile, info.parentDeclaration, ts3.factory.createObjectLiteralExpression(__spreadArray(__spreadArray([], info.parentDeclaration.properties, true), props, true), true), options);
        }
        function tryGetValueFromType(context, checker, importAdder, quotePreference, type2) {
          if (type2.flags & 3) {
            return createUndefined();
          }
          if (type2.flags & (4 | 134217728)) {
            return ts3.factory.createStringLiteral("", quotePreference === 0);
          }
          if (type2.flags & 8) {
            return ts3.factory.createNumericLiteral(0);
          }
          if (type2.flags & 64) {
            return ts3.factory.createBigIntLiteral("0n");
          }
          if (type2.flags & 16) {
            return ts3.factory.createFalse();
          }
          if (type2.flags & 1056) {
            var enumMember = type2.symbol.exports ? ts3.firstOrUndefined(ts3.arrayFrom(type2.symbol.exports.values())) : type2.symbol;
            var name = checker.symbolToExpression(type2.symbol.parent ? type2.symbol.parent : type2.symbol, 111551, void 0, void 0);
            return enumMember === void 0 || name === void 0 ? ts3.factory.createNumericLiteral(0) : ts3.factory.createPropertyAccessExpression(name, checker.symbolToString(enumMember));
          }
          if (type2.flags & 256) {
            return ts3.factory.createNumericLiteral(type2.value);
          }
          if (type2.flags & 2048) {
            return ts3.factory.createBigIntLiteral(type2.value);
          }
          if (type2.flags & 128) {
            return ts3.factory.createStringLiteral(type2.value, quotePreference === 0);
          }
          if (type2.flags & 512) {
            return type2 === checker.getFalseType() || type2 === checker.getFalseType(true) ? ts3.factory.createFalse() : ts3.factory.createTrue();
          }
          if (type2.flags & 65536) {
            return ts3.factory.createNull();
          }
          if (type2.flags & 1048576) {
            var expression = ts3.firstDefined(type2.types, function(t) {
              return tryGetValueFromType(context, checker, importAdder, quotePreference, t);
            });
            return expression !== null && expression !== void 0 ? expression : createUndefined();
          }
          if (checker.isArrayLikeType(type2)) {
            return ts3.factory.createArrayLiteralExpression();
          }
          if (isObjectLiteralType(type2)) {
            var props = ts3.map(checker.getPropertiesOfType(type2), function(prop) {
              var initializer = prop.valueDeclaration ? tryGetValueFromType(context, checker, importAdder, quotePreference, checker.getTypeAtLocation(prop.valueDeclaration)) : createUndefined();
              return ts3.factory.createPropertyAssignment(prop.name, initializer);
            });
            return ts3.factory.createObjectLiteralExpression(props, true);
          }
          if (ts3.getObjectFlags(type2) & 16) {
            var decl = ts3.find(type2.symbol.declarations || ts3.emptyArray, ts3.or(ts3.isFunctionTypeNode, ts3.isMethodSignature, ts3.isMethodDeclaration));
            if (decl === void 0)
              return createUndefined();
            var signature = checker.getSignaturesOfType(type2, 0);
            if (signature === void 0)
              return createUndefined();
            var func = codefix2.createSignatureDeclarationFromSignature(213, context, quotePreference, signature[0], codefix2.createStubbedBody(ts3.Diagnostics.Function_not_implemented.message, quotePreference), void 0, void 0, void 0, void 0, importAdder);
            return func !== null && func !== void 0 ? func : createUndefined();
          }
          if (ts3.getObjectFlags(type2) & 1) {
            var classDeclaration = ts3.getClassLikeDeclarationOfSymbol(type2.symbol);
            if (classDeclaration === void 0 || ts3.hasAbstractModifier(classDeclaration))
              return createUndefined();
            var constructorDeclaration = ts3.getFirstConstructorWithBody(classDeclaration);
            if (constructorDeclaration && ts3.length(constructorDeclaration.parameters))
              return createUndefined();
            return ts3.factory.createNewExpression(ts3.factory.createIdentifier(type2.symbol.name), void 0, void 0);
          }
          return createUndefined();
        }
        function createUndefined() {
          return ts3.factory.createIdentifier("undefined");
        }
        function isObjectLiteralType(type2) {
          return type2.flags & 524288 && (ts3.getObjectFlags(type2) & 128 || type2.symbol && ts3.tryCast(ts3.singleOrUndefined(type2.symbol.declarations), ts3.isTypeLiteralNode));
        }
        function getUnmatchedAttributes(checker, target, source) {
          var attrsType = checker.getContextualType(source.attributes);
          if (attrsType === void 0)
            return ts3.emptyArray;
          var targetProps = attrsType.getProperties();
          if (!ts3.length(targetProps))
            return ts3.emptyArray;
          var seenNames = new ts3.Set();
          for (var _i = 0, _a = source.attributes.properties; _i < _a.length; _i++) {
            var sourceProp = _a[_i];
            if (ts3.isJsxAttribute(sourceProp)) {
              seenNames.add(sourceProp.name.escapedText);
            }
            if (ts3.isJsxSpreadAttribute(sourceProp)) {
              var type2 = checker.getTypeAtLocation(sourceProp.expression);
              for (var _b = 0, _c = type2.getProperties(); _b < _c.length; _b++) {
                var prop = _c[_b];
                seenNames.add(prop.escapedName);
              }
            }
          }
          return ts3.filter(targetProps, function(targetProp) {
            return ts3.isIdentifierText(targetProp.name, target, 1) && !(targetProp.flags & 16777216 || ts3.getCheckFlags(targetProp) & 48 || seenNames.has(targetProp.escapedName));
          });
        }
        function tryGetContainingMethodDeclaration(node, callExpression) {
          if (ts3.isTypeLiteralNode(node)) {
            return void 0;
          }
          var declaration = ts3.findAncestor(callExpression, function(n) {
            return ts3.isMethodDeclaration(n) || ts3.isConstructorDeclaration(n);
          });
          return declaration && declaration.parent === node ? declaration : void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingNewOperator";
        var errorCodes = [ts3.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return addMissingNewOperator(t, sourceFile, span);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_new_operator_to_call, fixId, ts3.Diagnostics.Add_missing_new_operator_to_all_calls)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return addMissingNewOperator(changes, context.sourceFile, diag);
            });
          }
        });
        function addMissingNewOperator(changes, sourceFile, span) {
          var call = ts3.cast(findAncestorMatchingSpan(sourceFile, span), ts3.isCallExpression);
          var newExpression = ts3.factory.createNewExpression(call.expression, call.typeArguments, call.arguments);
          changes.replaceNode(sourceFile, call, newExpression);
        }
        function findAncestorMatchingSpan(sourceFile, span) {
          var token = ts3.getTokenAtPosition(sourceFile, span.start);
          var end = ts3.textSpanEnd(span);
          while (token.end < end) {
            token = token.parent;
          }
          return token;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "fixCannotFindModule";
        var fixIdInstallTypesPackage = "installTypesPackage";
        var errorCodeCannotFindModule = ts3.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations.code;
        var errorCodes = [
          errorCodeCannotFindModule,
          ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToFixNotFoundModule(context) {
            var host = context.host, sourceFile = context.sourceFile, start = context.span.start;
            var packageName = tryGetImportedPackageName(sourceFile, start);
            if (packageName === void 0)
              return void 0;
            var typesPackageName = getTypesPackageNameToInstall(packageName, host, context.errorCode);
            return typesPackageName === void 0 ? [] : [codefix2.createCodeFixAction(fixName, [], [ts3.Diagnostics.Install_0, typesPackageName], fixIdInstallTypesPackage, ts3.Diagnostics.Install_all_missing_types_packages, getInstallCommand(sourceFile.fileName, typesPackageName))];
          },
          fixIds: [fixIdInstallTypesPackage],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(_changes, diag, commands) {
              var packageName = tryGetImportedPackageName(diag.file, diag.start);
              if (packageName === void 0)
                return void 0;
              switch (context.fixId) {
                case fixIdInstallTypesPackage: {
                  var pkg = getTypesPackageNameToInstall(packageName, context.host, diag.code);
                  if (pkg) {
                    commands.push(getInstallCommand(diag.file.fileName, pkg));
                  }
                  break;
                }
                default:
                  ts3.Debug.fail("Bad fixId: ".concat(context.fixId));
              }
            });
          }
        });
        function getInstallCommand(fileName2, packageName) {
          return { type: "install package", file: fileName2, packageName };
        }
        function tryGetImportedPackageName(sourceFile, pos) {
          var moduleSpecifierText = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, pos), ts3.isStringLiteral);
          if (!moduleSpecifierText)
            return void 0;
          var moduleName = moduleSpecifierText.text;
          var packageName = ts3.parsePackageName(moduleName).packageName;
          return ts3.isExternalModuleNameRelative(packageName) ? void 0 : packageName;
        }
        function getTypesPackageNameToInstall(packageName, host, diagCode) {
          var _a;
          return diagCode === errorCodeCannotFindModule ? ts3.JsTyping.nodeCoreModules.has(packageName) ? "@types/node" : void 0 : ((_a = host.isKnownTypesPackageName) === null || _a === void 0 ? void 0 : _a.call(host, packageName)) ? ts3.getTypesPackageName(packageName) : void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts3.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code,
          ts3.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code
        ];
        var fixId = "fixClassDoesntImplementInheritedAbstractMember";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToFixClassNotImplementingInheritedMembers(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return addMissingMembers(getClass(sourceFile, span.start), sourceFile, context, t, context.preferences);
            });
            return changes.length === 0 ? void 0 : [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Implement_inherited_abstract_class, fixId, ts3.Diagnostics.Implement_all_inherited_abstract_classes)];
          },
          fixIds: [fixId],
          getAllCodeActions: function getAllCodeActionsToFixClassDoesntImplementInheritedAbstractMember(context) {
            var seenClassDeclarations = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var classDeclaration = getClass(diag.file, diag.start);
              if (ts3.addToSeen(seenClassDeclarations, ts3.getNodeId(classDeclaration))) {
                addMissingMembers(classDeclaration, context.sourceFile, context, changes, context.preferences);
              }
            });
          }
        });
        function getClass(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          return ts3.cast(token.parent, ts3.isClassLike);
        }
        function addMissingMembers(classDeclaration, sourceFile, context, changeTracker, preferences) {
          var extendsNode = ts3.getEffectiveBaseTypeNode(classDeclaration);
          var checker = context.program.getTypeChecker();
          var instantiatedExtendsType = checker.getTypeAtLocation(extendsNode);
          var abstractAndNonPrivateExtendsSymbols = checker.getPropertiesOfType(instantiatedExtendsType).filter(symbolPointsToNonPrivateAndAbstractMember);
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, preferences, context.host);
          codefix2.createMissingMemberNodes(classDeclaration, abstractAndNonPrivateExtendsSymbols, sourceFile, context, preferences, importAdder, function(member) {
            return changeTracker.insertMemberAtStart(sourceFile, classDeclaration, member);
          });
          importAdder.writeFixes(changeTracker);
        }
        function symbolPointsToNonPrivateAndAbstractMember(symbol) {
          var flags = ts3.getSyntacticModifierFlags(ts3.first(symbol.getDeclarations()));
          return !(flags & 8) && !!(flags & 128);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "classSuperMustPrecedeThisAccess";
        var errorCodes = [ts3.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var nodes = getNodes(sourceFile, span.start);
            if (!nodes)
              return void 0;
            var constructor = nodes.constructor, superCall = nodes.superCall;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, constructor, superCall);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Make_super_call_the_first_statement_in_the_constructor, fixId, ts3.Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var seenClasses = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (!nodes)
                return;
              var constructor = nodes.constructor, superCall = nodes.superCall;
              if (ts3.addToSeen(seenClasses, ts3.getNodeId(constructor.parent))) {
                doChange(changes, sourceFile, constructor, superCall);
              }
            });
          }
        });
        function doChange(changes, sourceFile, constructor, superCall) {
          changes.insertNodeAtConstructorStart(sourceFile, constructor, superCall);
          changes.delete(sourceFile, superCall);
        }
        function getNodes(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (token.kind !== 108)
            return void 0;
          var constructor = ts3.getContainingFunction(token);
          var superCall = findSuperCall(constructor.body);
          return superCall && !superCall.expression.arguments.some(function(arg) {
            return ts3.isPropertyAccessExpression(arg) && arg.expression === token;
          }) ? { constructor, superCall } : void 0;
        }
        function findSuperCall(n) {
          return ts3.isExpressionStatement(n) && ts3.isSuperCall(n.expression) ? n : ts3.isFunctionLike(n) ? void 0 : ts3.forEachChild(n, findSuperCall);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "constructorForDerivedNeedSuperCall";
        var errorCodes = [ts3.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var ctr = getNode(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, ctr);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_super_call, fixId, ts3.Diagnostics.Add_all_missing_super_calls)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, context.sourceFile, getNode(diag.file, diag.start));
            });
          }
        });
        function getNode(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          ts3.Debug.assert(ts3.isConstructorDeclaration(token.parent), "token should be at the constructor declaration");
          return token.parent;
        }
        function doChange(changes, sourceFile, ctr) {
          var superCall = ts3.factory.createExpressionStatement(ts3.factory.createCallExpression(ts3.factory.createSuper(), void 0, ts3.emptyArray));
          changes.insertNodeAtConstructorStart(sourceFile, ctr, superCall);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "enableExperimentalDecorators";
        var errorCodes = [
          ts3.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToEnableExperimentalDecorators(context) {
            var configFile = context.program.getCompilerOptions().configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changeTracker) {
              return doChange(changeTracker, configFile);
            });
            return [codefix2.createCodeFixActionWithoutFixAll(fixId, changes, ts3.Diagnostics.Enable_the_experimentalDecorators_option_in_your_configuration_file)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes) {
              var configFile = context.program.getCompilerOptions().configFile;
              if (configFile === void 0) {
                return void 0;
              }
              doChange(changes, configFile);
            });
          }
        });
        function doChange(changeTracker, configFile) {
          codefix2.setJsonCompilerOptionValue(changeTracker, configFile, "experimentalDecorators", ts3.factory.createTrue());
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixID = "fixEnableJsxFlag";
        var errorCodes = [ts3.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToFixEnableJsxFlag(context) {
            var configFile = context.program.getCompilerOptions().configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changeTracker) {
              return doChange(changeTracker, configFile);
            });
            return [
              codefix2.createCodeFixActionWithoutFixAll(fixID, changes, ts3.Diagnostics.Enable_the_jsx_flag_in_your_configuration_file)
            ];
          },
          fixIds: [fixID],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes) {
              var configFile = context.program.getCompilerOptions().configFile;
              if (configFile === void 0) {
                return void 0;
              }
              doChange(changes, configFile);
            });
          }
        });
        function doChange(changeTracker, configFile) {
          codefix2.setJsonCompilerOptionValue(changeTracker, configFile, "jsx", ts3.factory.createStringLiteral("react"));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher.code,
            ts3.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher.code
          ],
          getCodeActions: function getCodeActionsToFixModuleAndTarget(context) {
            var compilerOptions = context.program.getCompilerOptions();
            var configFile = compilerOptions.configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var codeFixes = [];
            var moduleKind = ts3.getEmitModuleKind(compilerOptions);
            var moduleOutOfRange = moduleKind >= ts3.ModuleKind.ES2015 && moduleKind < ts3.ModuleKind.ESNext;
            if (moduleOutOfRange) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
                codefix2.setJsonCompilerOptionValue(changes2, configFile, "module", ts3.factory.createStringLiteral("esnext"));
              });
              codeFixes.push(codefix2.createCodeFixActionWithoutFixAll("fixModuleOption", changes, [ts3.Diagnostics.Set_the_module_option_in_your_configuration_file_to_0, "esnext"]));
            }
            var target = ts3.getEmitScriptTarget(compilerOptions);
            var targetOutOfRange = target < 4 || target > 99;
            if (targetOutOfRange) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(tracker) {
                var configObject = ts3.getTsConfigObjectLiteralExpression(configFile);
                if (!configObject)
                  return;
                var options = [["target", ts3.factory.createStringLiteral("es2017")]];
                if (moduleKind === ts3.ModuleKind.CommonJS) {
                  options.push(["module", ts3.factory.createStringLiteral("commonjs")]);
                }
                codefix2.setJsonCompilerOptionValues(tracker, configFile, options);
              });
              codeFixes.push(codefix2.createCodeFixActionWithoutFixAll("fixTargetOption", changes, [ts3.Diagnostics.Set_the_target_option_in_your_configuration_file_to_0, "es2017"]));
            }
            return codeFixes.length ? codeFixes : void 0;
          }
        });
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixPropertyAssignment";
        var errorCodes = [
          ts3.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var property = getProperty(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, property);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Change_0_to_1, "=", ":"], fixId, [ts3.Diagnostics.Switch_each_misused_0_to_1, "=", ":"])];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, getProperty(diag.file, diag.start));
            });
          }
        });
        function doChange(changes, sourceFile, node) {
          changes.replaceNode(sourceFile, node, ts3.factory.createPropertyAssignment(node.name, node.objectAssignmentInitializer));
        }
        function getProperty(sourceFile, pos) {
          return ts3.cast(ts3.getTokenAtPosition(sourceFile, pos).parent, ts3.isShorthandPropertyAssignment);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "extendsInterfaceBecomesImplements";
        var errorCodes = [ts3.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var nodes = getNodes(sourceFile, context.span.start);
            if (!nodes)
              return void 0;
            var extendsToken = nodes.extendsToken, heritageClauses = nodes.heritageClauses;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChanges(t, sourceFile, extendsToken, heritageClauses);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Change_extends_to_implements, fixId, ts3.Diagnostics.Change_all_extended_interfaces_to_implements)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (nodes)
                doChanges(changes, diag.file, nodes.extendsToken, nodes.heritageClauses);
            });
          }
        });
        function getNodes(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var heritageClauses = ts3.getContainingClass(token).heritageClauses;
          var extendsToken = heritageClauses[0].getFirstToken();
          return extendsToken.kind === 94 ? { extendsToken, heritageClauses } : void 0;
        }
        function doChanges(changes, sourceFile, extendsToken, heritageClauses) {
          changes.replaceNode(sourceFile, extendsToken, ts3.factory.createToken(117));
          if (heritageClauses.length === 2 && heritageClauses[0].token === 94 && heritageClauses[1].token === 117) {
            var implementsToken = heritageClauses[1].getFirstToken();
            var implementsFullStart = implementsToken.getFullStart();
            changes.replaceRange(sourceFile, { pos: implementsFullStart, end: implementsFullStart }, ts3.factory.createToken(27));
            var text = sourceFile.text;
            var end = implementsToken.end;
            while (end < text.length && ts3.isWhiteSpaceSingleLine(text.charCodeAt(end))) {
              end++;
            }
            changes.deleteRange(sourceFile, { pos: implementsToken.getStart(), end });
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "forgottenThisPropertyAccess";
        var didYouMeanStaticMemberCode = ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code;
        var errorCodes = [
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts3.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,
          didYouMeanStaticMemberCode
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context.errorCode);
            if (!info) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Add_0_to_unresolved_variable, info.className || "this"], fixId, ts3.Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, diag.code);
              if (info)
                doChange(changes, context.sourceFile, info);
            });
          }
        });
        function getInfo(sourceFile, pos, diagCode) {
          var node = ts3.getTokenAtPosition(sourceFile, pos);
          if (ts3.isIdentifier(node) || ts3.isPrivateIdentifier(node)) {
            return { node, className: diagCode === didYouMeanStaticMemberCode ? ts3.getContainingClass(node).name.text : void 0 };
          }
        }
        function doChange(changes, sourceFile, _a) {
          var node = _a.node, className = _a.className;
          ts3.suppressLeadingAndTrailingTrivia(node);
          changes.replaceNode(sourceFile, node, ts3.factory.createPropertyAccessExpression(className ? ts3.factory.createIdentifier(className) : ts3.factory.createThis(), node));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdExpression = "fixInvalidJsxCharacters_expression";
        var fixIdHtmlEntity = "fixInvalidJsxCharacters_htmlEntity";
        var errorCodes = [
          ts3.Diagnostics.Unexpected_token_Did_you_mean_or_gt.code,
          ts3.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixIdExpression, fixIdHtmlEntity],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, preferences = context.preferences, span = context.span;
            var changeToExpression = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, preferences, sourceFile, span.start, false);
            });
            var changeToHtmlEntity = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, preferences, sourceFile, span.start, true);
            });
            return [
              codefix2.createCodeFixAction(fixIdExpression, changeToExpression, ts3.Diagnostics.Wrap_invalid_character_in_an_expression_container, fixIdExpression, ts3.Diagnostics.Wrap_all_invalid_characters_in_an_expression_container),
              codefix2.createCodeFixAction(fixIdHtmlEntity, changeToHtmlEntity, ts3.Diagnostics.Convert_invalid_character_to_its_html_entity_code, fixIdHtmlEntity, ts3.Diagnostics.Convert_all_invalid_characters_to_HTML_entity_code)
            ];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diagnostic) {
              return doChange(changes, context.preferences, diagnostic.file, diagnostic.start, context.fixId === fixIdHtmlEntity);
            });
          }
        });
        var htmlEntity = {
          ">": "&gt;",
          "}": "&rbrace;"
        };
        function isValidCharacter(character) {
          return ts3.hasProperty(htmlEntity, character);
        }
        function doChange(changes, preferences, sourceFile, start, useHtmlEntity) {
          var character = sourceFile.getText()[start];
          if (!isValidCharacter(character)) {
            return;
          }
          var replacement = useHtmlEntity ? htmlEntity[character] : "{".concat(ts3.quote(sourceFile, preferences, character), "}");
          changes.replaceRangeWithText(sourceFile, { pos: start, end: start + 1 }, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var deleteUnmatchedParameter = "deleteUnmatchedParameter";
        var renameUnmatchedParameter = "renameUnmatchedParameter";
        var errorCodes = [
          ts3.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name.code
        ];
        codefix2.registerCodeFix({
          fixIds: [deleteUnmatchedParameter, renameUnmatchedParameter],
          errorCodes,
          getCodeActions: function getCodeActionsToFixUnmatchedParameter(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var actions2 = [];
            var info = getInfo(sourceFile, span.start);
            if (info) {
              ts3.append(actions2, getDeleteAction(context, info));
              ts3.append(actions2, getRenameAction(context, info));
              return actions2;
            }
            return void 0;
          },
          getAllCodeActions: function getAllCodeActionsToFixUnmatchedParameter(context) {
            var tagsToSignature = new ts3.Map();
            return codefix2.createCombinedCodeActions(ts3.textChanges.ChangeTracker.with(context, function(changes) {
              codefix2.eachDiagnostic(context, errorCodes, function(_a) {
                var file = _a.file, start = _a.start;
                var info = getInfo(file, start);
                if (info) {
                  tagsToSignature.set(info.signature, ts3.append(tagsToSignature.get(info.signature), info.jsDocParameterTag));
                }
              });
              tagsToSignature.forEach(function(tags, signature) {
                if (context.fixId === deleteUnmatchedParameter) {
                  var tagsSet_1 = new ts3.Set(tags);
                  changes.filterJSDocTags(signature.getSourceFile(), signature, function(t) {
                    return !tagsSet_1.has(t);
                  });
                }
              });
            }));
          }
        });
        function getDeleteAction(context, _a) {
          var name = _a.name, signature = _a.signature, jsDocParameterTag = _a.jsDocParameterTag;
          var changes = ts3.textChanges.ChangeTracker.with(context, function(changeTracker) {
            return changeTracker.filterJSDocTags(context.sourceFile, signature, function(t) {
              return t !== jsDocParameterTag;
            });
          });
          return codefix2.createCodeFixAction(deleteUnmatchedParameter, changes, [ts3.Diagnostics.Delete_unused_param_tag_0, name.getText(context.sourceFile)], deleteUnmatchedParameter, ts3.Diagnostics.Delete_all_unused_param_tags);
        }
        function getRenameAction(context, _a) {
          var name = _a.name, signature = _a.signature, jsDocParameterTag = _a.jsDocParameterTag;
          if (!ts3.length(signature.parameters))
            return void 0;
          var sourceFile = context.sourceFile;
          var tags = ts3.getJSDocTags(signature);
          var names = new ts3.Set();
          for (var _i = 0, tags_2 = tags; _i < tags_2.length; _i++) {
            var tag = tags_2[_i];
            if (ts3.isJSDocParameterTag(tag) && ts3.isIdentifier(tag.name)) {
              names.add(tag.name.escapedText);
            }
          }
          var parameterName = ts3.firstDefined(signature.parameters, function(p) {
            return ts3.isIdentifier(p.name) && !names.has(p.name.escapedText) ? p.name.getText(sourceFile) : void 0;
          });
          if (parameterName === void 0)
            return void 0;
          var newJSDocParameterTag = ts3.factory.updateJSDocParameterTag(jsDocParameterTag, jsDocParameterTag.tagName, ts3.factory.createIdentifier(parameterName), jsDocParameterTag.isBracketed, jsDocParameterTag.typeExpression, jsDocParameterTag.isNameFirst, jsDocParameterTag.comment);
          var changes = ts3.textChanges.ChangeTracker.with(context, function(changeTracker) {
            return changeTracker.replaceJSDocComment(sourceFile, signature, ts3.map(tags, function(t) {
              return t === jsDocParameterTag ? newJSDocParameterTag : t;
            }));
          });
          return codefix2.createCodeFixActionWithoutFixAll(renameUnmatchedParameter, changes, [ts3.Diagnostics.Rename_param_tag_name_0_to_1, name.getText(sourceFile), parameterName]);
        }
        function getInfo(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (token.parent && ts3.isJSDocParameterTag(token.parent) && ts3.isIdentifier(token.parent.name)) {
            var jsDocParameterTag = token.parent;
            var signature = ts3.getHostSignatureFromJSDoc(jsDocParameterTag);
            if (signature) {
              return { signature, name: token.parent.name, jsDocParameterTag };
            }
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnreferenceableDecoratorMetadata";
        var errorCodes = [ts3.Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var importDeclaration = getImportDeclaration(context.sourceFile, context.program, context.span.start);
            if (!importDeclaration)
              return;
            var namespaceChanges = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return importDeclaration.kind === 270 && doNamespaceImportChange(t, context.sourceFile, importDeclaration, context.program);
            });
            var typeOnlyChanges = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doTypeOnlyImportChange(t, context.sourceFile, importDeclaration, context.program);
            });
            var actions2;
            if (namespaceChanges.length) {
              actions2 = ts3.append(actions2, codefix2.createCodeFixActionWithoutFixAll(fixId, namespaceChanges, ts3.Diagnostics.Convert_named_imports_to_namespace_import));
            }
            if (typeOnlyChanges.length) {
              actions2 = ts3.append(actions2, codefix2.createCodeFixActionWithoutFixAll(fixId, typeOnlyChanges, ts3.Diagnostics.Convert_to_type_only_import));
            }
            return actions2;
          },
          fixIds: [fixId]
        });
        function getImportDeclaration(sourceFile, program2, start) {
          var identifier = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, start), ts3.isIdentifier);
          if (!identifier || identifier.parent.kind !== 178)
            return;
          var checker = program2.getTypeChecker();
          var symbol = checker.getSymbolAtLocation(identifier);
          return ts3.find((symbol === null || symbol === void 0 ? void 0 : symbol.declarations) || ts3.emptyArray, ts3.or(ts3.isImportClause, ts3.isImportSpecifier, ts3.isImportEqualsDeclaration));
        }
        function doTypeOnlyImportChange(changes, sourceFile, importDeclaration, program2) {
          if (importDeclaration.kind === 265) {
            changes.insertModifierBefore(sourceFile, 152, importDeclaration.name);
            return;
          }
          var importClause = importDeclaration.kind === 267 ? importDeclaration : importDeclaration.parent.parent;
          if (importClause.name && importClause.namedBindings) {
            return;
          }
          var checker = program2.getTypeChecker();
          var importsValue = !!ts3.forEachImportClauseDeclaration(importClause, function(decl) {
            if (ts3.skipAlias(decl.symbol, checker).flags & 111551)
              return true;
          });
          if (importsValue) {
            return;
          }
          changes.insertModifierBefore(sourceFile, 152, importClause);
        }
        function doNamespaceImportChange(changes, sourceFile, importDeclaration, program2) {
          ts3.refactor.doChangeNamedToNamespaceOrDefault(sourceFile, program2, changes, importDeclaration.parent);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "unusedIdentifier";
        var fixIdPrefix = "unusedIdentifier_prefix";
        var fixIdDelete = "unusedIdentifier_delete";
        var fixIdDeleteImports = "unusedIdentifier_deleteImports";
        var fixIdInfer = "unusedIdentifier_infer";
        var errorCodes = [
          ts3.Diagnostics._0_is_declared_but_its_value_is_never_read.code,
          ts3.Diagnostics._0_is_declared_but_never_used.code,
          ts3.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code,
          ts3.Diagnostics.All_imports_in_import_declaration_are_unused.code,
          ts3.Diagnostics.All_destructured_elements_are_unused.code,
          ts3.Diagnostics.All_variables_are_unused.code,
          ts3.Diagnostics.All_type_parameters_are_unused.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
            var checker = program2.getTypeChecker();
            var sourceFiles = program2.getSourceFiles();
            var token = ts3.getTokenAtPosition(sourceFile, context.span.start);
            if (ts3.isJSDocTemplateTag(token)) {
              return [createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t) {
                return t.delete(sourceFile, token);
              }), ts3.Diagnostics.Remove_template_tag)];
            }
            if (token.kind === 29) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return deleteTypeParameters(t, sourceFile, token);
              });
              return [createDeleteFix(changes, ts3.Diagnostics.Remove_type_parameters)];
            }
            var importDecl = tryGetFullImport(token);
            if (importDecl) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return t.delete(sourceFile, importDecl);
              });
              return [codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Remove_import_from_0, ts3.showModuleSpecifier(importDecl)], fixIdDeleteImports, ts3.Diagnostics.Delete_all_unused_imports)];
            } else if (isImport(token)) {
              var deletion = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return tryDeleteDeclaration(sourceFile, token, t, checker, sourceFiles, program2, cancellationToken, false);
              });
              if (deletion.length) {
                return [codefix2.createCodeFixAction(fixName, deletion, [ts3.Diagnostics.Remove_unused_declaration_for_Colon_0, token.getText(sourceFile)], fixIdDeleteImports, ts3.Diagnostics.Delete_all_unused_imports)];
              }
            }
            if (ts3.isObjectBindingPattern(token.parent) || ts3.isArrayBindingPattern(token.parent)) {
              if (ts3.isParameter(token.parent.parent)) {
                var elements = token.parent.elements;
                var diagnostic = [
                  elements.length > 1 ? ts3.Diagnostics.Remove_unused_declarations_for_Colon_0 : ts3.Diagnostics.Remove_unused_declaration_for_Colon_0,
                  ts3.map(elements, function(e) {
                    return e.getText(sourceFile);
                  }).join(", ")
                ];
                return [
                  createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t) {
                    return deleteDestructuringElements(t, sourceFile, token.parent);
                  }), diagnostic)
                ];
              }
              return [
                createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t) {
                  return t.delete(sourceFile, token.parent.parent);
                }), ts3.Diagnostics.Remove_unused_destructuring_declaration)
              ];
            }
            if (canDeleteEntireVariableStatement(sourceFile, token)) {
              return [
                createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t) {
                  return deleteEntireVariableStatement(t, sourceFile, token.parent);
                }), ts3.Diagnostics.Remove_variable_statement)
              ];
            }
            var result2 = [];
            if (token.kind === 137) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return changeInferToUnknown(t, sourceFile, token);
              });
              var name = ts3.cast(token.parent, ts3.isInferTypeNode).typeParameter.name.text;
              result2.push(codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Replace_infer_0_with_unknown, name], fixIdInfer, ts3.Diagnostics.Replace_all_unused_infer_with_unknown));
            } else {
              var deletion = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return tryDeleteDeclaration(sourceFile, token, t, checker, sourceFiles, program2, cancellationToken, false);
              });
              if (deletion.length) {
                var name = ts3.isComputedPropertyName(token.parent) ? token.parent : token;
                result2.push(createDeleteFix(deletion, [ts3.Diagnostics.Remove_unused_declaration_for_Colon_0, name.getText(sourceFile)]));
              }
            }
            var prefix = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return tryPrefixDeclaration(t, errorCode, sourceFile, token);
            });
            if (prefix.length) {
              result2.push(codefix2.createCodeFixAction(fixName, prefix, [ts3.Diagnostics.Prefix_0_with_an_underscore, token.getText(sourceFile)], fixIdPrefix, ts3.Diagnostics.Prefix_all_unused_declarations_with_where_possible));
            }
            return result2;
          },
          fixIds: [fixIdPrefix, fixIdDelete, fixIdDeleteImports, fixIdInfer],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
            var checker = program2.getTypeChecker();
            var sourceFiles = program2.getSourceFiles();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var token = ts3.getTokenAtPosition(sourceFile, diag.start);
              switch (context.fixId) {
                case fixIdPrefix:
                  tryPrefixDeclaration(changes, diag.code, sourceFile, token);
                  break;
                case fixIdDeleteImports: {
                  var importDecl = tryGetFullImport(token);
                  if (importDecl) {
                    changes.delete(sourceFile, importDecl);
                  } else if (isImport(token)) {
                    tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program2, cancellationToken, true);
                  }
                  break;
                }
                case fixIdDelete: {
                  if (token.kind === 137 || isImport(token)) {
                    break;
                  } else if (ts3.isJSDocTemplateTag(token)) {
                    changes.delete(sourceFile, token);
                  } else if (token.kind === 29) {
                    deleteTypeParameters(changes, sourceFile, token);
                  } else if (ts3.isObjectBindingPattern(token.parent)) {
                    if (token.parent.parent.initializer) {
                      break;
                    } else if (!ts3.isParameter(token.parent.parent) || isNotProvidedArguments(token.parent.parent, checker, sourceFiles)) {
                      changes.delete(sourceFile, token.parent.parent);
                    }
                  } else if (ts3.isArrayBindingPattern(token.parent.parent) && token.parent.parent.parent.initializer) {
                    break;
                  } else if (canDeleteEntireVariableStatement(sourceFile, token)) {
                    deleteEntireVariableStatement(changes, sourceFile, token.parent);
                  } else {
                    tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program2, cancellationToken, true);
                  }
                  break;
                }
                case fixIdInfer:
                  if (token.kind === 137) {
                    changeInferToUnknown(changes, sourceFile, token);
                  }
                  break;
                default:
                  ts3.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function changeInferToUnknown(changes, sourceFile, token) {
          changes.replaceNode(sourceFile, token.parent, ts3.factory.createKeywordTypeNode(155));
        }
        function createDeleteFix(changes, diag) {
          return codefix2.createCodeFixAction(fixName, changes, diag, fixIdDelete, ts3.Diagnostics.Delete_all_unused_declarations);
        }
        function deleteTypeParameters(changes, sourceFile, token) {
          changes.delete(sourceFile, ts3.Debug.checkDefined(ts3.cast(token.parent, ts3.isDeclarationWithTypeParameterChildren).typeParameters, "The type parameter to delete should exist"));
        }
        function isImport(token) {
          return token.kind === 100 || token.kind === 79 && (token.parent.kind === 270 || token.parent.kind === 267);
        }
        function tryGetFullImport(token) {
          return token.kind === 100 ? ts3.tryCast(token.parent, ts3.isImportDeclaration) : void 0;
        }
        function canDeleteEntireVariableStatement(sourceFile, token) {
          return ts3.isVariableDeclarationList(token.parent) && ts3.first(token.parent.getChildren(sourceFile)) === token;
        }
        function deleteEntireVariableStatement(changes, sourceFile, node) {
          changes.delete(sourceFile, node.parent.kind === 237 ? node.parent : node);
        }
        function deleteDestructuringElements(changes, sourceFile, node) {
          ts3.forEach(node.elements, function(n) {
            return changes.delete(sourceFile, n);
          });
        }
        function tryPrefixDeclaration(changes, errorCode, sourceFile, token) {
          if (errorCode === ts3.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code)
            return;
          if (token.kind === 137) {
            token = ts3.cast(token.parent, ts3.isInferTypeNode).typeParameter.name;
          }
          if (ts3.isIdentifier(token) && canPrefix(token)) {
            changes.replaceNode(sourceFile, token, ts3.factory.createIdentifier("_".concat(token.text)));
            if (ts3.isParameter(token.parent)) {
              ts3.getJSDocParameterTags(token.parent).forEach(function(tag) {
                if (ts3.isIdentifier(tag.name)) {
                  changes.replaceNode(sourceFile, tag.name, ts3.factory.createIdentifier("_".concat(tag.name.text)));
                }
              });
            }
          }
        }
        function canPrefix(token) {
          switch (token.parent.kind) {
            case 164:
            case 163:
              return true;
            case 254: {
              var varDecl = token.parent;
              switch (varDecl.parent.parent.kind) {
                case 244:
                case 243:
                  return true;
              }
            }
          }
          return false;
        }
        function tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program2, cancellationToken, isFixAll) {
          tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, program2, cancellationToken, isFixAll);
          if (ts3.isIdentifier(token)) {
            ts3.FindAllReferences.Core.eachSymbolReferenceInFile(token, checker, sourceFile, function(ref) {
              if (ts3.isPropertyAccessExpression(ref.parent) && ref.parent.name === ref)
                ref = ref.parent;
              if (!isFixAll && mayDeleteExpression(ref)) {
                changes.delete(sourceFile, ref.parent.parent);
              }
            });
          }
        }
        function tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, program2, cancellationToken, isFixAll) {
          var parent = token.parent;
          if (ts3.isParameter(parent)) {
            tryDeleteParameter(changes, sourceFile, parent, checker, sourceFiles, program2, cancellationToken, isFixAll);
          } else if (!(isFixAll && ts3.isIdentifier(token) && ts3.FindAllReferences.Core.isSymbolReferencedInFile(token, checker, sourceFile))) {
            var node = ts3.isImportClause(parent) ? token : ts3.isComputedPropertyName(parent) ? parent.parent : parent;
            ts3.Debug.assert(node !== sourceFile, "should not delete whole source file");
            changes.delete(sourceFile, node);
          }
        }
        function tryDeleteParameter(changes, sourceFile, parameter, checker, sourceFiles, program2, cancellationToken, isFixAll) {
          if (isFixAll === void 0) {
            isFixAll = false;
          }
          if (mayDeleteParameter(checker, sourceFile, parameter, sourceFiles, program2, cancellationToken, isFixAll)) {
            if (parameter.modifiers && parameter.modifiers.length > 0 && (!ts3.isIdentifier(parameter.name) || ts3.FindAllReferences.Core.isSymbolReferencedInFile(parameter.name, checker, sourceFile))) {
              parameter.modifiers.forEach(function(modifier) {
                return changes.deleteModifier(sourceFile, modifier);
              });
            } else if (!parameter.initializer && isNotProvidedArguments(parameter, checker, sourceFiles)) {
              changes.delete(sourceFile, parameter);
            }
          }
        }
        function isNotProvidedArguments(parameter, checker, sourceFiles) {
          var index = parameter.parent.parameters.indexOf(parameter);
          return !ts3.FindAllReferences.Core.someSignatureUsage(parameter.parent, sourceFiles, checker, function(_, call) {
            return !call || call.arguments.length > index;
          });
        }
        function mayDeleteParameter(checker, sourceFile, parameter, sourceFiles, program2, cancellationToken, isFixAll) {
          var parent = parameter.parent;
          switch (parent.kind) {
            case 169:
            case 171:
              var index = parent.parameters.indexOf(parameter);
              var referent = ts3.isMethodDeclaration(parent) ? parent.name : parent;
              var entries = ts3.FindAllReferences.Core.getReferencedSymbolsForNode(parent.pos, referent, program2, sourceFiles, cancellationToken);
              if (entries) {
                for (var _i = 0, entries_2 = entries; _i < entries_2.length; _i++) {
                  var entry = entries_2[_i];
                  for (var _a = 0, _b = entry.references; _a < _b.length; _a++) {
                    var reference = _b[_a];
                    if (reference.kind === 1) {
                      var isSuperCall_1 = ts3.isSuperKeyword(reference.node) && ts3.isCallExpression(reference.node.parent) && reference.node.parent.arguments.length > index;
                      var isSuperMethodCall = ts3.isPropertyAccessExpression(reference.node.parent) && ts3.isSuperKeyword(reference.node.parent.expression) && ts3.isCallExpression(reference.node.parent.parent) && reference.node.parent.parent.arguments.length > index;
                      var isOverriddenMethod = (ts3.isMethodDeclaration(reference.node.parent) || ts3.isMethodSignature(reference.node.parent)) && reference.node.parent !== parameter.parent && reference.node.parent.parameters.length > index;
                      if (isSuperCall_1 || isSuperMethodCall || isOverriddenMethod)
                        return false;
                    }
                  }
                }
              }
              return true;
            case 256: {
              if (parent.name && isCallbackLike(checker, sourceFile, parent.name)) {
                return isLastParameter(parent, parameter, isFixAll);
              }
              return true;
            }
            case 213:
            case 214:
              return isLastParameter(parent, parameter, isFixAll);
            case 173:
              return false;
            case 172:
              return true;
            default:
              return ts3.Debug.failBadSyntaxKind(parent);
          }
        }
        function isCallbackLike(checker, sourceFile, name) {
          return !!ts3.FindAllReferences.Core.eachSymbolReferenceInFile(name, checker, sourceFile, function(reference) {
            return ts3.isIdentifier(reference) && ts3.isCallExpression(reference.parent) && reference.parent.arguments.indexOf(reference) >= 0;
          });
        }
        function isLastParameter(func, parameter, isFixAll) {
          var parameters = func.parameters;
          var index = parameters.indexOf(parameter);
          ts3.Debug.assert(index !== -1, "The parameter should already be in the list");
          return isFixAll ? parameters.slice(index + 1).every(function(p) {
            return ts3.isIdentifier(p.name) && !p.symbol.isReferenced;
          }) : index === parameters.length - 1;
        }
        function mayDeleteExpression(node) {
          return (ts3.isBinaryExpression(node.parent) && node.parent.left === node || (ts3.isPostfixUnaryExpression(node.parent) || ts3.isPrefixUnaryExpression(node.parent)) && node.parent.operand === node) && ts3.isExpressionStatement(node.parent.parent);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnreachableCode";
        var errorCodes = [ts3.Diagnostics.Unreachable_code_detected.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var syntacticDiagnostics = context.program.getSyntacticDiagnostics(context.sourceFile, context.cancellationToken);
            if (syntacticDiagnostics.length)
              return;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start, context.span.length, context.errorCode);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_unreachable_code, fixId, ts3.Diagnostics.Remove_all_unreachable_code)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start, diag.length, diag.code);
            });
          }
        });
        function doChange(changes, sourceFile, start, length, errorCode) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          var statement = ts3.findAncestor(token, ts3.isStatement);
          if (statement.getStart(sourceFile) !== token.getStart(sourceFile)) {
            var logData = JSON.stringify({
              statementKind: ts3.Debug.formatSyntaxKind(statement.kind),
              tokenKind: ts3.Debug.formatSyntaxKind(token.kind),
              errorCode,
              start,
              length
            });
            ts3.Debug.fail("Token and statement should start at the same point. " + logData);
          }
          var container = (ts3.isBlock(statement.parent) ? statement.parent : statement).parent;
          if (!ts3.isBlock(statement.parent) || statement === ts3.first(statement.parent.statements)) {
            switch (container.kind) {
              case 239:
                if (container.elseStatement) {
                  if (ts3.isBlock(statement.parent)) {
                    break;
                  } else {
                    changes.replaceNode(sourceFile, statement, ts3.factory.createBlock(ts3.emptyArray));
                  }
                  return;
                }
              case 241:
              case 242:
                changes.delete(sourceFile, container);
                return;
            }
          }
          if (ts3.isBlock(statement.parent)) {
            var end_3 = start + length;
            var lastStatement = ts3.Debug.checkDefined(lastWhere(ts3.sliceAfter(statement.parent.statements, statement), function(s) {
              return s.pos < end_3;
            }), "Some statement should be last");
            changes.deleteNodeRange(sourceFile, statement, lastStatement);
          } else {
            changes.delete(sourceFile, statement);
          }
        }
        function lastWhere(a, pred) {
          var last;
          for (var _i = 0, a_1 = a; _i < a_1.length; _i++) {
            var value = a_1[_i];
            if (!pred(value))
              break;
            last = value;
          }
          return last;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnusedLabel";
        var errorCodes = [ts3.Diagnostics.Unused_label.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_unused_label, fixId, ts3.Diagnostics.Remove_all_unused_labels)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start);
            });
          }
        });
        function doChange(changes, sourceFile, start) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          var labeledStatement = ts3.cast(token.parent, ts3.isLabeledStatement);
          var pos = token.getStart(sourceFile);
          var statementPos = labeledStatement.statement.getStart(sourceFile);
          var end = ts3.positionsAreOnSameLine(pos, statementPos, sourceFile) ? statementPos : ts3.skipTrivia(sourceFile.text, ts3.findChildOfKind(labeledStatement, 58, sourceFile).end, true);
          changes.deleteRange(sourceFile, { pos, end });
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdPlain = "fixJSDocTypes_plain";
        var fixIdNullable = "fixJSDocTypes_nullable";
        var errorCodes = [ts3.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var checker = context.program.getTypeChecker();
            var info = getInfo(sourceFile, context.span.start, checker);
            if (!info)
              return void 0;
            var typeNode = info.typeNode, type2 = info.type;
            var original = typeNode.getText(sourceFile);
            var actions2 = [fix(type2, fixIdPlain, ts3.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];
            if (typeNode.kind === 314) {
              actions2.push(fix(checker.getNullableType(type2, 32768), fixIdNullable, ts3.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types));
            }
            return actions2;
            function fix(type3, fixId, fixAllDescription) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return doChange(t, sourceFile, typeNode, type3, checker);
              });
              return codefix2.createCodeFixAction("jdocTypes", changes, [ts3.Diagnostics.Change_0_to_1, original, checker.typeToString(type3)], fixId, fixAllDescription);
            }
          },
          fixIds: [fixIdPlain, fixIdNullable],
          getAllCodeActions: function(context) {
            var fixId = context.fixId, program2 = context.program, sourceFile = context.sourceFile;
            var checker = program2.getTypeChecker();
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              var info = getInfo(err.file, err.start, checker);
              if (!info)
                return;
              var typeNode = info.typeNode, type2 = info.type;
              var fixedType = typeNode.kind === 314 && fixId === fixIdNullable ? checker.getNullableType(type2, 32768) : type2;
              doChange(changes, sourceFile, typeNode, fixedType, checker);
            });
          }
        });
        function doChange(changes, sourceFile, oldTypeNode, newType, checker) {
          changes.replaceNode(sourceFile, oldTypeNode, checker.typeToTypeNode(newType, oldTypeNode, void 0));
        }
        function getInfo(sourceFile, pos, checker) {
          var decl = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, pos), isTypeContainer);
          var typeNode = decl && decl.type;
          return typeNode && { typeNode, type: checker.getTypeFromTypeNode(typeNode) };
        }
        function isTypeContainer(node) {
          switch (node.kind) {
            case 229:
            case 174:
            case 175:
            case 256:
            case 172:
            case 176:
            case 195:
            case 169:
            case 168:
            case 164:
            case 167:
            case 166:
            case 173:
            case 259:
            case 211:
            case 254:
              return true;
            default:
              return false;
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixMissingCallParentheses";
        var errorCodes = [
          ts3.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var callName = getCallName(sourceFile, span.start);
            if (!callName)
              return;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, callName);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_call_parentheses, fixId, ts3.Diagnostics.Add_all_missing_call_parentheses)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var callName = getCallName(diag.file, diag.start);
              if (callName)
                doChange(changes, diag.file, callName);
            });
          }
        });
        function doChange(changes, sourceFile, name) {
          changes.replaceNodeWithText(sourceFile, name, "".concat(name.text, "()"));
        }
        function getCallName(sourceFile, start) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          if (ts3.isPropertyAccessExpression(token.parent)) {
            var current = token.parent;
            while (ts3.isPropertyAccessExpression(current.parent)) {
              current = current.parent;
            }
            return current.name;
          }
          if (ts3.isIdentifier(token)) {
            return token;
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixAwaitInSyncFunction";
        var errorCodes = [
          ts3.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
          ts3.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var nodes = getNodes(sourceFile, span.start);
            if (!nodes)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, nodes);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_async_modifier_to_containing_function, fixId, ts3.Diagnostics.Add_all_missing_async_modifiers)];
          },
          fixIds: [fixId],
          getAllCodeActions: function getAllCodeActionsToFixAwaitInSyncFunction(context) {
            var seen = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (!nodes || !ts3.addToSeen(seen, ts3.getNodeId(nodes.insertBefore)))
                return;
              doChange(changes, context.sourceFile, nodes);
            });
          }
        });
        function getReturnType(expr) {
          if (expr.type) {
            return expr.type;
          }
          if (ts3.isVariableDeclaration(expr.parent) && expr.parent.type && ts3.isFunctionTypeNode(expr.parent.type)) {
            return expr.parent.type.type;
          }
        }
        function getNodes(sourceFile, start) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          var containingFunction = ts3.getContainingFunction(token);
          if (!containingFunction) {
            return;
          }
          var insertBefore;
          switch (containingFunction.kind) {
            case 169:
              insertBefore = containingFunction.name;
              break;
            case 256:
            case 213:
              insertBefore = ts3.findChildOfKind(containingFunction, 98, sourceFile);
              break;
            case 214:
              var kind = containingFunction.typeParameters ? 29 : 20;
              insertBefore = ts3.findChildOfKind(containingFunction, kind, sourceFile) || ts3.first(containingFunction.parameters);
              break;
            default:
              return;
          }
          return insertBefore && {
            insertBefore,
            returnType: getReturnType(containingFunction)
          };
        }
        function doChange(changes, sourceFile, _a) {
          var insertBefore = _a.insertBefore, returnType = _a.returnType;
          if (returnType) {
            var entityName = ts3.getEntityNameFromTypeNode(returnType);
            if (!entityName || entityName.kind !== 79 || entityName.text !== "Promise") {
              changes.replaceNode(sourceFile, returnType, ts3.factory.createTypeReferenceNode("Promise", ts3.factory.createNodeArray([returnType])));
            }
          }
          changes.insertModifierBefore(sourceFile, 131, insertBefore);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts3.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code,
          ts3.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code
        ];
        var fixId = "fixPropertyOverrideAccessor";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var edits = doChange(context.sourceFile, context.span.start, context.span.length, context.errorCode, context);
            if (edits) {
              return [codefix2.createCodeFixAction(fixId, edits, ts3.Diagnostics.Generate_get_and_set_accessors, fixId, ts3.Diagnostics.Generate_get_and_set_accessors_for_all_overriding_properties)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var edits = doChange(diag.file, diag.start, diag.length, diag.code, context);
              if (edits) {
                for (var _i = 0, edits_2 = edits; _i < edits_2.length; _i++) {
                  var edit = edits_2[_i];
                  changes.pushRaw(context.sourceFile, edit);
                }
              }
            });
          }
        });
        function doChange(file, start, length, code, context) {
          var startPosition;
          var endPosition;
          if (code === ts3.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code) {
            startPosition = start;
            endPosition = start + length;
          } else if (code === ts3.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code) {
            var checker = context.program.getTypeChecker();
            var node = ts3.getTokenAtPosition(file, start).parent;
            ts3.Debug.assert(ts3.isAccessor(node), "error span of fixPropertyOverrideAccessor should only be on an accessor");
            var containingClass = node.parent;
            ts3.Debug.assert(ts3.isClassLike(containingClass), "erroneous accessors should only be inside classes");
            var base = ts3.singleOrUndefined(codefix2.getAllSupers(containingClass, checker));
            if (!base)
              return [];
            var name = ts3.unescapeLeadingUnderscores(ts3.getTextOfPropertyName(node.name));
            var baseProp = checker.getPropertyOfType(checker.getTypeAtLocation(base), name);
            if (!baseProp || !baseProp.valueDeclaration)
              return [];
            startPosition = baseProp.valueDeclaration.pos;
            endPosition = baseProp.valueDeclaration.end;
            file = ts3.getSourceFileOfNode(baseProp.valueDeclaration);
          } else {
            ts3.Debug.fail("fixPropertyOverrideAccessor codefix got unexpected error code " + code);
          }
          return codefix2.generateAccessorFromProperty(file, context.program, startPosition, endPosition, context, ts3.Diagnostics.Generate_get_and_set_accessors.message);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "inferFromUsage";
        var errorCodes = [
          ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,
          ts3.Diagnostics.Variable_0_implicitly_has_an_1_type.code,
          ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code,
          ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,
          ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,
          ts3.Diagnostics.Member_0_implicitly_has_an_1_type.code,
          ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,
          ts3.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, start = context.span.start, errorCode = context.errorCode, cancellationToken = context.cancellationToken, host = context.host, preferences = context.preferences;
            var token = ts3.getTokenAtPosition(sourceFile, start);
            var declaration;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              declaration = doChange(changes2, sourceFile, token, errorCode, program2, cancellationToken, ts3.returnTrue, host, preferences);
            });
            var name = declaration && ts3.getNameOfDeclaration(declaration);
            return !name || changes.length === 0 ? void 0 : [codefix2.createCodeFixAction(fixId, changes, [getDiagnostic(errorCode, token), ts3.getTextOfNode(name)], fixId, ts3.Diagnostics.Infer_all_types_from_usage)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken, host = context.host, preferences = context.preferences;
            var markSeen = ts3.nodeSeenTracker();
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              doChange(changes, sourceFile, ts3.getTokenAtPosition(err.file, err.start), err.code, program2, cancellationToken, markSeen, host, preferences);
            });
          }
        });
        function getDiagnostic(errorCode, token) {
          switch (errorCode) {
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.isSetAccessorDeclaration(ts3.getContainingFunction(token)) ? ts3.Diagnostics.Infer_type_of_0_from_usage : ts3.Diagnostics.Infer_parameter_types_from_usage;
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Infer_parameter_types_from_usage;
            case ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
              return ts3.Diagnostics.Infer_this_type_of_0_from_usage;
            default:
              return ts3.Diagnostics.Infer_type_of_0_from_usage;
          }
        }
        function mapSuggestionDiagnostic(errorCode) {
          switch (errorCode) {
            case ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;
            case ts3.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Variable_0_implicitly_has_an_1_type.code;
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code;
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;
            case ts3.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;
            case ts3.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Member_0_implicitly_has_an_1_type.code;
          }
          return errorCode;
        }
        function doChange(changes, sourceFile, token, errorCode, program2, cancellationToken, markSeen, host, preferences) {
          if (!ts3.isParameterPropertyModifier(token.kind) && token.kind !== 79 && token.kind !== 25 && token.kind !== 108) {
            return void 0;
          }
          var parent = token.parent;
          var importAdder = codefix2.createImportAdder(sourceFile, program2, preferences, host);
          errorCode = mapSuggestionDiagnostic(errorCode);
          switch (errorCode) {
            case ts3.Diagnostics.Member_0_implicitly_has_an_1_type.code:
            case ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:
              if (ts3.isVariableDeclaration(parent) && markSeen(parent) || ts3.isPropertyDeclaration(parent) || ts3.isPropertySignature(parent)) {
                annotateVariableDeclaration(changes, importAdder, sourceFile, parent, program2, host, cancellationToken);
                importAdder.writeFixes(changes);
                return parent;
              }
              if (ts3.isPropertyAccessExpression(parent)) {
                var type2 = inferTypeForVariableFromUsage(parent.name, program2, cancellationToken);
                var typeNode = ts3.getTypeNodeIfAccessible(type2, parent, program2, host);
                if (typeNode) {
                  var typeTag = ts3.factory.createJSDocTypeTag(void 0, ts3.factory.createJSDocTypeExpression(typeNode), void 0);
                  changes.addJSDocTags(sourceFile, ts3.cast(parent.parent.parent, ts3.isExpressionStatement), [typeTag]);
                }
                importAdder.writeFixes(changes);
                return parent;
              }
              return void 0;
            case ts3.Diagnostics.Variable_0_implicitly_has_an_1_type.code: {
              var symbol = program2.getTypeChecker().getSymbolAtLocation(token);
              if (symbol && symbol.valueDeclaration && ts3.isVariableDeclaration(symbol.valueDeclaration) && markSeen(symbol.valueDeclaration)) {
                annotateVariableDeclaration(changes, importAdder, ts3.getSourceFileOfNode(symbol.valueDeclaration), symbol.valueDeclaration, program2, host, cancellationToken);
                importAdder.writeFixes(changes);
                return symbol.valueDeclaration;
              }
              return void 0;
            }
          }
          var containingFunction = ts3.getContainingFunction(token);
          if (containingFunction === void 0) {
            return void 0;
          }
          var declaration;
          switch (errorCode) {
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
              if (ts3.isSetAccessorDeclaration(containingFunction)) {
                annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program2, host, cancellationToken);
                declaration = containingFunction;
                break;
              }
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
              if (markSeen(containingFunction)) {
                var param = ts3.cast(parent, ts3.isParameter);
                annotateParameters(changes, importAdder, sourceFile, param, containingFunction, program2, host, cancellationToken);
                declaration = param;
              }
              break;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:
            case ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:
              if (ts3.isGetAccessorDeclaration(containingFunction) && ts3.isIdentifier(containingFunction.name)) {
                annotate(changes, importAdder, sourceFile, containingFunction, inferTypeForVariableFromUsage(containingFunction.name, program2, cancellationToken), program2, host);
                declaration = containingFunction;
              }
              break;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:
              if (ts3.isSetAccessorDeclaration(containingFunction)) {
                annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program2, host, cancellationToken);
                declaration = containingFunction;
              }
              break;
            case ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
              if (ts3.textChanges.isThisTypeAnnotatable(containingFunction) && markSeen(containingFunction)) {
                annotateThis(changes, sourceFile, containingFunction, program2, host, cancellationToken);
                declaration = containingFunction;
              }
              break;
            default:
              return ts3.Debug.fail(String(errorCode));
          }
          importAdder.writeFixes(changes);
          return declaration;
        }
        function annotateVariableDeclaration(changes, importAdder, sourceFile, declaration, program2, host, cancellationToken) {
          if (ts3.isIdentifier(declaration.name)) {
            annotate(changes, importAdder, sourceFile, declaration, inferTypeForVariableFromUsage(declaration.name, program2, cancellationToken), program2, host);
          }
        }
        function annotateParameters(changes, importAdder, sourceFile, parameterDeclaration, containingFunction, program2, host, cancellationToken) {
          if (!ts3.isIdentifier(parameterDeclaration.name)) {
            return;
          }
          var parameterInferences = inferTypeForParametersFromUsage(containingFunction, sourceFile, program2, cancellationToken);
          ts3.Debug.assert(containingFunction.parameters.length === parameterInferences.length, "Parameter count and inference count should match");
          if (ts3.isInJSFile(containingFunction)) {
            annotateJSDocParameters(changes, sourceFile, parameterInferences, program2, host);
          } else {
            var needParens = ts3.isArrowFunction(containingFunction) && !ts3.findChildOfKind(containingFunction, 20, sourceFile);
            if (needParens)
              changes.insertNodeBefore(sourceFile, ts3.first(containingFunction.parameters), ts3.factory.createToken(20));
            for (var _i = 0, parameterInferences_1 = parameterInferences; _i < parameterInferences_1.length; _i++) {
              var _a = parameterInferences_1[_i], declaration = _a.declaration, type2 = _a.type;
              if (declaration && !declaration.type && !declaration.initializer) {
                annotate(changes, importAdder, sourceFile, declaration, type2, program2, host);
              }
            }
            if (needParens)
              changes.insertNodeAfter(sourceFile, ts3.last(containingFunction.parameters), ts3.factory.createToken(21));
          }
        }
        function annotateThis(changes, sourceFile, containingFunction, program2, host, cancellationToken) {
          var references = getFunctionReferences(containingFunction, sourceFile, program2, cancellationToken);
          if (!references || !references.length) {
            return;
          }
          var thisInference = inferTypeFromReferences(program2, references, cancellationToken).thisParameter();
          var typeNode = ts3.getTypeNodeIfAccessible(thisInference, containingFunction, program2, host);
          if (!typeNode) {
            return;
          }
          if (ts3.isInJSFile(containingFunction)) {
            annotateJSDocThis(changes, sourceFile, containingFunction, typeNode);
          } else {
            changes.tryInsertThisTypeAnnotation(sourceFile, containingFunction, typeNode);
          }
        }
        function annotateJSDocThis(changes, sourceFile, containingFunction, typeNode) {
          changes.addJSDocTags(sourceFile, containingFunction, [
            ts3.factory.createJSDocThisTag(void 0, ts3.factory.createJSDocTypeExpression(typeNode))
          ]);
        }
        function annotateSetAccessor(changes, importAdder, sourceFile, setAccessorDeclaration, program2, host, cancellationToken) {
          var param = ts3.firstOrUndefined(setAccessorDeclaration.parameters);
          if (param && ts3.isIdentifier(setAccessorDeclaration.name) && ts3.isIdentifier(param.name)) {
            var type2 = inferTypeForVariableFromUsage(setAccessorDeclaration.name, program2, cancellationToken);
            if (type2 === program2.getTypeChecker().getAnyType()) {
              type2 = inferTypeForVariableFromUsage(param.name, program2, cancellationToken);
            }
            if (ts3.isInJSFile(setAccessorDeclaration)) {
              annotateJSDocParameters(changes, sourceFile, [{ declaration: param, type: type2 }], program2, host);
            } else {
              annotate(changes, importAdder, sourceFile, param, type2, program2, host);
            }
          }
        }
        function annotate(changes, importAdder, sourceFile, declaration, type2, program2, host) {
          var typeNode = ts3.getTypeNodeIfAccessible(type2, declaration, program2, host);
          if (typeNode) {
            if (ts3.isInJSFile(sourceFile) && declaration.kind !== 166) {
              var parent = ts3.isVariableDeclaration(declaration) ? ts3.tryCast(declaration.parent.parent, ts3.isVariableStatement) : declaration;
              if (!parent) {
                return;
              }
              var typeExpression = ts3.factory.createJSDocTypeExpression(typeNode);
              var typeTag = ts3.isGetAccessorDeclaration(declaration) ? ts3.factory.createJSDocReturnTag(void 0, typeExpression, void 0) : ts3.factory.createJSDocTypeTag(void 0, typeExpression, void 0);
              changes.addJSDocTags(sourceFile, parent, [typeTag]);
            } else if (!tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, sourceFile, changes, importAdder, ts3.getEmitScriptTarget(program2.getCompilerOptions()))) {
              changes.tryInsertTypeAnnotation(sourceFile, declaration, typeNode);
            }
          }
        }
        function tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, sourceFile, changes, importAdder, scriptTarget) {
          var importableReference = codefix2.tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
          if (importableReference && changes.tryInsertTypeAnnotation(sourceFile, declaration, importableReference.typeNode)) {
            ts3.forEach(importableReference.symbols, function(s) {
              return importAdder.addImportFromExportedSymbol(s, true);
            });
            return true;
          }
          return false;
        }
        function annotateJSDocParameters(changes, sourceFile, parameterInferences, program2, host) {
          var signature = parameterInferences.length && parameterInferences[0].declaration.parent;
          if (!signature) {
            return;
          }
          var inferences = ts3.mapDefined(parameterInferences, function(inference) {
            var param = inference.declaration;
            if (param.initializer || ts3.getJSDocType(param) || !ts3.isIdentifier(param.name)) {
              return;
            }
            var typeNode = inference.type && ts3.getTypeNodeIfAccessible(inference.type, param, program2, host);
            if (typeNode) {
              var name = ts3.factory.cloneNode(param.name);
              ts3.setEmitFlags(name, 1536 | 2048);
              return { name: ts3.factory.cloneNode(param.name), param, isOptional: !!inference.isOptional, typeNode };
            }
          });
          if (!inferences.length) {
            return;
          }
          if (ts3.isArrowFunction(signature) || ts3.isFunctionExpression(signature)) {
            var needParens = ts3.isArrowFunction(signature) && !ts3.findChildOfKind(signature, 20, sourceFile);
            if (needParens) {
              changes.insertNodeBefore(sourceFile, ts3.first(signature.parameters), ts3.factory.createToken(20));
            }
            ts3.forEach(inferences, function(_a) {
              var typeNode = _a.typeNode, param = _a.param;
              var typeTag = ts3.factory.createJSDocTypeTag(void 0, ts3.factory.createJSDocTypeExpression(typeNode));
              var jsDoc = ts3.factory.createJSDocComment(void 0, [typeTag]);
              changes.insertNodeAt(sourceFile, param.getStart(sourceFile), jsDoc, { suffix: " " });
            });
            if (needParens) {
              changes.insertNodeAfter(sourceFile, ts3.last(signature.parameters), ts3.factory.createToken(21));
            }
          } else {
            var paramTags = ts3.map(inferences, function(_a) {
              var name = _a.name, typeNode = _a.typeNode, isOptional = _a.isOptional;
              return ts3.factory.createJSDocParameterTag(void 0, name, !!isOptional, ts3.factory.createJSDocTypeExpression(typeNode), false, void 0);
            });
            changes.addJSDocTags(sourceFile, signature, paramTags);
          }
        }
        function getReferences(token, program2, cancellationToken) {
          return ts3.mapDefined(ts3.FindAllReferences.getReferenceEntriesForNode(-1, token, program2, program2.getSourceFiles(), cancellationToken), function(entry) {
            return entry.kind !== 0 ? ts3.tryCast(entry.node, ts3.isIdentifier) : void 0;
          });
        }
        function inferTypeForVariableFromUsage(token, program2, cancellationToken) {
          var references = getReferences(token, program2, cancellationToken);
          return inferTypeFromReferences(program2, references, cancellationToken).single();
        }
        function inferTypeForParametersFromUsage(func, sourceFile, program2, cancellationToken) {
          var references = getFunctionReferences(func, sourceFile, program2, cancellationToken);
          return references && inferTypeFromReferences(program2, references, cancellationToken).parameters(func) || func.parameters.map(function(p) {
            return {
              declaration: p,
              type: ts3.isIdentifier(p.name) ? inferTypeForVariableFromUsage(p.name, program2, cancellationToken) : program2.getTypeChecker().getAnyType()
            };
          });
        }
        function getFunctionReferences(containingFunction, sourceFile, program2, cancellationToken) {
          var searchToken;
          switch (containingFunction.kind) {
            case 171:
              searchToken = ts3.findChildOfKind(containingFunction, 134, sourceFile);
              break;
            case 214:
            case 213:
              var parent = containingFunction.parent;
              searchToken = (ts3.isVariableDeclaration(parent) || ts3.isPropertyDeclaration(parent)) && ts3.isIdentifier(parent.name) ? parent.name : containingFunction.name;
              break;
            case 256:
            case 169:
            case 168:
              searchToken = containingFunction.name;
              break;
          }
          if (!searchToken) {
            return void 0;
          }
          return getReferences(searchToken, program2, cancellationToken);
        }
        function inferTypeFromReferences(program2, references, cancellationToken) {
          var checker = program2.getTypeChecker();
          var builtinConstructors = {
            string: function() {
              return checker.getStringType();
            },
            number: function() {
              return checker.getNumberType();
            },
            Array: function(t) {
              return checker.createArrayType(t);
            },
            Promise: function(t) {
              return checker.createPromiseType(t);
            }
          };
          var builtins = [
            checker.getStringType(),
            checker.getNumberType(),
            checker.createArrayType(checker.getAnyType()),
            checker.createPromiseType(checker.getAnyType())
          ];
          return {
            single,
            parameters,
            thisParameter
          };
          function createEmptyUsage() {
            return {
              isNumber: void 0,
              isString: void 0,
              isNumberOrString: void 0,
              candidateTypes: void 0,
              properties: void 0,
              calls: void 0,
              constructs: void 0,
              numberIndex: void 0,
              stringIndex: void 0,
              candidateThisTypes: void 0,
              inferredTypes: void 0
            };
          }
          function combineUsages(usages) {
            var combinedProperties = new ts3.Map();
            for (var _i = 0, usages_1 = usages; _i < usages_1.length; _i++) {
              var u = usages_1[_i];
              if (u.properties) {
                u.properties.forEach(function(p, name) {
                  if (!combinedProperties.has(name)) {
                    combinedProperties.set(name, []);
                  }
                  combinedProperties.get(name).push(p);
                });
              }
            }
            var properties = new ts3.Map();
            combinedProperties.forEach(function(ps, name) {
              properties.set(name, combineUsages(ps));
            });
            return {
              isNumber: usages.some(function(u2) {
                return u2.isNumber;
              }),
              isString: usages.some(function(u2) {
                return u2.isString;
              }),
              isNumberOrString: usages.some(function(u2) {
                return u2.isNumberOrString;
              }),
              candidateTypes: ts3.flatMap(usages, function(u2) {
                return u2.candidateTypes;
              }),
              properties,
              calls: ts3.flatMap(usages, function(u2) {
                return u2.calls;
              }),
              constructs: ts3.flatMap(usages, function(u2) {
                return u2.constructs;
              }),
              numberIndex: ts3.forEach(usages, function(u2) {
                return u2.numberIndex;
              }),
              stringIndex: ts3.forEach(usages, function(u2) {
                return u2.stringIndex;
              }),
              candidateThisTypes: ts3.flatMap(usages, function(u2) {
                return u2.candidateThisTypes;
              }),
              inferredTypes: void 0
            };
          }
          function single() {
            return combineTypes(inferTypesFromReferencesSingle(references));
          }
          function parameters(declaration) {
            if (references.length === 0 || !declaration.parameters) {
              return void 0;
            }
            var usage = createEmptyUsage();
            for (var _i = 0, references_3 = references; _i < references_3.length; _i++) {
              var reference = references_3[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            var calls = __spreadArray(__spreadArray([], usage.constructs || [], true), usage.calls || [], true);
            return declaration.parameters.map(function(parameter, parameterIndex) {
              var types2 = [];
              var isRest = ts3.isRestParameter(parameter);
              var isOptional = false;
              for (var _i2 = 0, calls_1 = calls; _i2 < calls_1.length; _i2++) {
                var call = calls_1[_i2];
                if (call.argumentTypes.length <= parameterIndex) {
                  isOptional = ts3.isInJSFile(declaration);
                  types2.push(checker.getUndefinedType());
                } else if (isRest) {
                  for (var i = parameterIndex; i < call.argumentTypes.length; i++) {
                    types2.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[i]));
                  }
                } else {
                  types2.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[parameterIndex]));
                }
              }
              if (ts3.isIdentifier(parameter.name)) {
                var inferred = inferTypesFromReferencesSingle(getReferences(parameter.name, program2, cancellationToken));
                types2.push.apply(types2, isRest ? ts3.mapDefined(inferred, checker.getElementTypeOfArrayType) : inferred);
              }
              var type2 = combineTypes(types2);
              return {
                type: isRest ? checker.createArrayType(type2) : type2,
                isOptional: isOptional && !isRest,
                declaration: parameter
              };
            });
          }
          function thisParameter() {
            var usage = createEmptyUsage();
            for (var _i = 0, references_4 = references; _i < references_4.length; _i++) {
              var reference = references_4[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            return combineTypes(usage.candidateThisTypes || ts3.emptyArray);
          }
          function inferTypesFromReferencesSingle(references2) {
            var usage = createEmptyUsage();
            for (var _i = 0, references_5 = references2; _i < references_5.length; _i++) {
              var reference = references_5[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            return inferTypes(usage);
          }
          function calculateUsageOfNode(node, usage) {
            while (ts3.isRightSideOfQualifiedNameOrPropertyAccess(node)) {
              node = node.parent;
            }
            switch (node.parent.kind) {
              case 238:
                inferTypeFromExpressionStatement(node, usage);
                break;
              case 220:
                usage.isNumber = true;
                break;
              case 219:
                inferTypeFromPrefixUnaryExpression(node.parent, usage);
                break;
              case 221:
                inferTypeFromBinaryExpression(node, node.parent, usage);
                break;
              case 289:
              case 290:
                inferTypeFromSwitchStatementLabel(node.parent, usage);
                break;
              case 208:
              case 209:
                if (node.parent.expression === node) {
                  inferTypeFromCallExpression(node.parent, usage);
                } else {
                  inferTypeFromContextualType(node, usage);
                }
                break;
              case 206:
                inferTypeFromPropertyAccessExpression(node.parent, usage);
                break;
              case 207:
                inferTypeFromPropertyElementExpression(node.parent, node, usage);
                break;
              case 296:
              case 297:
                inferTypeFromPropertyAssignment(node.parent, usage);
                break;
              case 167:
                inferTypeFromPropertyDeclaration(node.parent, usage);
                break;
              case 254: {
                var _a = node.parent, name = _a.name, initializer = _a.initializer;
                if (node === name) {
                  if (initializer) {
                    addCandidateType(usage, checker.getTypeAtLocation(initializer));
                  }
                  break;
                }
              }
              default:
                return inferTypeFromContextualType(node, usage);
            }
          }
          function inferTypeFromContextualType(node, usage) {
            if (ts3.isExpressionNode(node)) {
              addCandidateType(usage, checker.getContextualType(node));
            }
          }
          function inferTypeFromExpressionStatement(node, usage) {
            addCandidateType(usage, ts3.isCallExpression(node) ? checker.getVoidType() : checker.getAnyType());
          }
          function inferTypeFromPrefixUnaryExpression(node, usage) {
            switch (node.operator) {
              case 45:
              case 46:
              case 40:
              case 54:
                usage.isNumber = true;
                break;
              case 39:
                usage.isNumberOrString = true;
                break;
            }
          }
          function inferTypeFromBinaryExpression(node, parent, usage) {
            switch (parent.operatorToken.kind) {
              case 42:
              case 41:
              case 43:
              case 44:
              case 47:
              case 48:
              case 49:
              case 50:
              case 51:
              case 52:
              case 65:
              case 67:
              case 66:
              case 68:
              case 69:
              case 73:
              case 74:
              case 78:
              case 70:
              case 72:
              case 71:
              case 40:
              case 29:
              case 32:
              case 31:
              case 33:
                var operandType = checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left);
                if (operandType.flags & 1056) {
                  addCandidateType(usage, operandType);
                } else {
                  usage.isNumber = true;
                }
                break;
              case 64:
              case 39:
                var otherOperandType = checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left);
                if (otherOperandType.flags & 1056) {
                  addCandidateType(usage, otherOperandType);
                } else if (otherOperandType.flags & 296) {
                  usage.isNumber = true;
                } else if (otherOperandType.flags & 402653316) {
                  usage.isString = true;
                } else if (otherOperandType.flags & 1) {
                } else {
                  usage.isNumberOrString = true;
                }
                break;
              case 63:
              case 34:
              case 36:
              case 37:
              case 35:
                addCandidateType(usage, checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left));
                break;
              case 101:
                if (node === parent.left) {
                  usage.isString = true;
                }
                break;
              case 56:
              case 60:
                if (node === parent.left && (node.parent.parent.kind === 254 || ts3.isAssignmentExpression(node.parent.parent, true))) {
                  addCandidateType(usage, checker.getTypeAtLocation(parent.right));
                }
                break;
              case 55:
              case 27:
              case 102:
                break;
            }
          }
          function inferTypeFromSwitchStatementLabel(parent, usage) {
            addCandidateType(usage, checker.getTypeAtLocation(parent.parent.parent.expression));
          }
          function inferTypeFromCallExpression(parent, usage) {
            var call = {
              argumentTypes: [],
              return_: createEmptyUsage()
            };
            if (parent.arguments) {
              for (var _i = 0, _a = parent.arguments; _i < _a.length; _i++) {
                var argument = _a[_i];
                call.argumentTypes.push(checker.getTypeAtLocation(argument));
              }
            }
            calculateUsageOfNode(parent, call.return_);
            if (parent.kind === 208) {
              (usage.calls || (usage.calls = [])).push(call);
            } else {
              (usage.constructs || (usage.constructs = [])).push(call);
            }
          }
          function inferTypeFromPropertyAccessExpression(parent, usage) {
            var name = ts3.escapeLeadingUnderscores(parent.name.text);
            if (!usage.properties) {
              usage.properties = new ts3.Map();
            }
            var propertyUsage = usage.properties.get(name) || createEmptyUsage();
            calculateUsageOfNode(parent, propertyUsage);
            usage.properties.set(name, propertyUsage);
          }
          function inferTypeFromPropertyElementExpression(parent, node, usage) {
            if (node === parent.argumentExpression) {
              usage.isNumberOrString = true;
              return;
            } else {
              var indexType = checker.getTypeAtLocation(parent.argumentExpression);
              var indexUsage = createEmptyUsage();
              calculateUsageOfNode(parent, indexUsage);
              if (indexType.flags & 296) {
                usage.numberIndex = indexUsage;
              } else {
                usage.stringIndex = indexUsage;
              }
            }
          }
          function inferTypeFromPropertyAssignment(assignment, usage) {
            var nodeWithRealType = ts3.isVariableDeclaration(assignment.parent.parent) ? assignment.parent.parent : assignment.parent;
            addCandidateThisType(usage, checker.getTypeAtLocation(nodeWithRealType));
          }
          function inferTypeFromPropertyDeclaration(declaration, usage) {
            addCandidateThisType(usage, checker.getTypeAtLocation(declaration.parent));
          }
          function removeLowPriorityInferences(inferences, priorities) {
            var toRemove = [];
            for (var _i = 0, inferences_1 = inferences; _i < inferences_1.length; _i++) {
              var i = inferences_1[_i];
              for (var _a = 0, priorities_1 = priorities; _a < priorities_1.length; _a++) {
                var _b = priorities_1[_a], high = _b.high, low = _b.low;
                if (high(i)) {
                  ts3.Debug.assert(!low(i), "Priority can't have both low and high");
                  toRemove.push(low);
                }
              }
            }
            return inferences.filter(function(i2) {
              return toRemove.every(function(f) {
                return !f(i2);
              });
            });
          }
          function combineFromUsage(usage) {
            return combineTypes(inferTypes(usage));
          }
          function combineTypes(inferences) {
            if (!inferences.length)
              return checker.getAnyType();
            var stringNumber = checker.getUnionType([checker.getStringType(), checker.getNumberType()]);
            var priorities = [
              {
                high: function(t) {
                  return t === checker.getStringType() || t === checker.getNumberType();
                },
                low: function(t) {
                  return t === stringNumber;
                }
              },
              {
                high: function(t) {
                  return !(t.flags & (1 | 16384));
                },
                low: function(t) {
                  return !!(t.flags & (1 | 16384));
                }
              },
              {
                high: function(t) {
                  return !(t.flags & (98304 | 1 | 16384)) && !(ts3.getObjectFlags(t) & 16);
                },
                low: function(t) {
                  return !!(ts3.getObjectFlags(t) & 16);
                }
              }
            ];
            var good = removeLowPriorityInferences(inferences, priorities);
            var anons = good.filter(function(i) {
              return ts3.getObjectFlags(i) & 16;
            });
            if (anons.length) {
              good = good.filter(function(i) {
                return !(ts3.getObjectFlags(i) & 16);
              });
              good.push(combineAnonymousTypes(anons));
            }
            return checker.getWidenedType(checker.getUnionType(good.map(checker.getBaseTypeOfLiteralType), 2));
          }
          function combineAnonymousTypes(anons) {
            if (anons.length === 1) {
              return anons[0];
            }
            var calls = [];
            var constructs = [];
            var stringIndices = [];
            var numberIndices = [];
            var stringIndexReadonly = false;
            var numberIndexReadonly = false;
            var props = ts3.createMultiMap();
            for (var _i = 0, anons_1 = anons; _i < anons_1.length; _i++) {
              var anon = anons_1[_i];
              for (var _a = 0, _b = checker.getPropertiesOfType(anon); _a < _b.length; _a++) {
                var p = _b[_a];
                props.add(p.name, p.valueDeclaration ? checker.getTypeOfSymbolAtLocation(p, p.valueDeclaration) : checker.getAnyType());
              }
              calls.push.apply(calls, checker.getSignaturesOfType(anon, 0));
              constructs.push.apply(constructs, checker.getSignaturesOfType(anon, 1));
              var stringIndexInfo = checker.getIndexInfoOfType(anon, 0);
              if (stringIndexInfo) {
                stringIndices.push(stringIndexInfo.type);
                stringIndexReadonly = stringIndexReadonly || stringIndexInfo.isReadonly;
              }
              var numberIndexInfo = checker.getIndexInfoOfType(anon, 1);
              if (numberIndexInfo) {
                numberIndices.push(numberIndexInfo.type);
                numberIndexReadonly = numberIndexReadonly || numberIndexInfo.isReadonly;
              }
            }
            var members = ts3.mapEntries(props, function(name, types2) {
              var isOptional = types2.length < anons.length ? 16777216 : 0;
              var s = checker.createSymbol(4 | isOptional, name);
              s.type = checker.getUnionType(types2);
              return [name, s];
            });
            var indexInfos = [];
            if (stringIndices.length)
              indexInfos.push(checker.createIndexInfo(checker.getStringType(), checker.getUnionType(stringIndices), stringIndexReadonly));
            if (numberIndices.length)
              indexInfos.push(checker.createIndexInfo(checker.getNumberType(), checker.getUnionType(numberIndices), numberIndexReadonly));
            return checker.createAnonymousType(anons[0].symbol, members, calls, constructs, indexInfos);
          }
          function inferTypes(usage) {
            var _a, _b, _c;
            var types2 = [];
            if (usage.isNumber) {
              types2.push(checker.getNumberType());
            }
            if (usage.isString) {
              types2.push(checker.getStringType());
            }
            if (usage.isNumberOrString) {
              types2.push(checker.getUnionType([checker.getStringType(), checker.getNumberType()]));
            }
            if (usage.numberIndex) {
              types2.push(checker.createArrayType(combineFromUsage(usage.numberIndex)));
            }
            if (((_a = usage.properties) === null || _a === void 0 ? void 0 : _a.size) || ((_b = usage.constructs) === null || _b === void 0 ? void 0 : _b.length) || usage.stringIndex) {
              types2.push(inferStructuralType(usage));
            }
            var candidateTypes = (usage.candidateTypes || []).map(function(t) {
              return checker.getBaseTypeOfLiteralType(t);
            });
            var callsType = ((_c = usage.calls) === null || _c === void 0 ? void 0 : _c.length) ? inferStructuralType(usage) : void 0;
            if (callsType && candidateTypes) {
              types2.push(checker.getUnionType(__spreadArray([callsType], candidateTypes, true), 2));
            } else {
              if (callsType) {
                types2.push(callsType);
              }
              if (ts3.length(candidateTypes)) {
                types2.push.apply(types2, candidateTypes);
              }
            }
            types2.push.apply(types2, inferNamedTypesFromProperties(usage));
            return types2;
          }
          function inferStructuralType(usage) {
            var members = new ts3.Map();
            if (usage.properties) {
              usage.properties.forEach(function(u, name) {
                var symbol = checker.createSymbol(4, name);
                symbol.type = combineFromUsage(u);
                members.set(name, symbol);
              });
            }
            var callSignatures = usage.calls ? [getSignatureFromCalls(usage.calls)] : [];
            var constructSignatures = usage.constructs ? [getSignatureFromCalls(usage.constructs)] : [];
            var indexInfos = usage.stringIndex ? [checker.createIndexInfo(checker.getStringType(), combineFromUsage(usage.stringIndex), false)] : [];
            return checker.createAnonymousType(void 0, members, callSignatures, constructSignatures, indexInfos);
          }
          function inferNamedTypesFromProperties(usage) {
            if (!usage.properties || !usage.properties.size)
              return [];
            var types2 = builtins.filter(function(t) {
              return allPropertiesAreAssignableToUsage(t, usage);
            });
            if (0 < types2.length && types2.length < 3) {
              return types2.map(function(t) {
                return inferInstantiationFromUsage(t, usage);
              });
            }
            return [];
          }
          function allPropertiesAreAssignableToUsage(type2, usage) {
            if (!usage.properties)
              return false;
            return !ts3.forEachEntry(usage.properties, function(propUsage, name) {
              var source = checker.getTypeOfPropertyOfType(type2, name);
              if (!source) {
                return true;
              }
              if (propUsage.calls) {
                var sigs = checker.getSignaturesOfType(source, 0);
                return !sigs.length || !checker.isTypeAssignableTo(source, getFunctionFromCalls(propUsage.calls));
              } else {
                return !checker.isTypeAssignableTo(source, combineFromUsage(propUsage));
              }
            });
          }
          function inferInstantiationFromUsage(type2, usage) {
            if (!(ts3.getObjectFlags(type2) & 4) || !usage.properties) {
              return type2;
            }
            var generic = type2.target;
            var singleTypeParameter = ts3.singleOrUndefined(generic.typeParameters);
            if (!singleTypeParameter)
              return type2;
            var types2 = [];
            usage.properties.forEach(function(propUsage, name) {
              var genericPropertyType = checker.getTypeOfPropertyOfType(generic, name);
              ts3.Debug.assert(!!genericPropertyType, "generic should have all the properties of its reference.");
              types2.push.apply(types2, inferTypeParameters(genericPropertyType, combineFromUsage(propUsage), singleTypeParameter));
            });
            return builtinConstructors[type2.symbol.escapedName](combineTypes(types2));
          }
          function inferTypeParameters(genericType, usageType, typeParameter) {
            if (genericType === typeParameter) {
              return [usageType];
            } else if (genericType.flags & 3145728) {
              return ts3.flatMap(genericType.types, function(t) {
                return inferTypeParameters(t, usageType, typeParameter);
              });
            } else if (ts3.getObjectFlags(genericType) & 4 && ts3.getObjectFlags(usageType) & 4) {
              var genericArgs = checker.getTypeArguments(genericType);
              var usageArgs = checker.getTypeArguments(usageType);
              var types2 = [];
              if (genericArgs && usageArgs) {
                for (var i = 0; i < genericArgs.length; i++) {
                  if (usageArgs[i]) {
                    types2.push.apply(types2, inferTypeParameters(genericArgs[i], usageArgs[i], typeParameter));
                  }
                }
              }
              return types2;
            }
            var genericSigs = checker.getSignaturesOfType(genericType, 0);
            var usageSigs = checker.getSignaturesOfType(usageType, 0);
            if (genericSigs.length === 1 && usageSigs.length === 1) {
              return inferFromSignatures(genericSigs[0], usageSigs[0], typeParameter);
            }
            return [];
          }
          function inferFromSignatures(genericSig, usageSig, typeParameter) {
            var types2 = [];
            for (var i = 0; i < genericSig.parameters.length; i++) {
              var genericParam = genericSig.parameters[i];
              var usageParam = usageSig.parameters[i];
              var isRest = genericSig.declaration && ts3.isRestParameter(genericSig.declaration.parameters[i]);
              if (!usageParam) {
                break;
              }
              var genericParamType = genericParam.valueDeclaration ? checker.getTypeOfSymbolAtLocation(genericParam, genericParam.valueDeclaration) : checker.getAnyType();
              var elementType = isRest && checker.getElementTypeOfArrayType(genericParamType);
              if (elementType) {
                genericParamType = elementType;
              }
              var targetType = usageParam.type || (usageParam.valueDeclaration ? checker.getTypeOfSymbolAtLocation(usageParam, usageParam.valueDeclaration) : checker.getAnyType());
              types2.push.apply(types2, inferTypeParameters(genericParamType, targetType, typeParameter));
            }
            var genericReturn = checker.getReturnTypeOfSignature(genericSig);
            var usageReturn = checker.getReturnTypeOfSignature(usageSig);
            types2.push.apply(types2, inferTypeParameters(genericReturn, usageReturn, typeParameter));
            return types2;
          }
          function getFunctionFromCalls(calls) {
            return checker.createAnonymousType(void 0, ts3.createSymbolTable(), [getSignatureFromCalls(calls)], ts3.emptyArray, ts3.emptyArray);
          }
          function getSignatureFromCalls(calls) {
            var parameters2 = [];
            var length = Math.max.apply(Math, calls.map(function(c) {
              return c.argumentTypes.length;
            }));
            var _loop_16 = function(i2) {
              var symbol = checker.createSymbol(1, ts3.escapeLeadingUnderscores("arg".concat(i2)));
              symbol.type = combineTypes(calls.map(function(call) {
                return call.argumentTypes[i2] || checker.getUndefinedType();
              }));
              if (calls.some(function(call) {
                return call.argumentTypes[i2] === void 0;
              })) {
                symbol.flags |= 16777216;
              }
              parameters2.push(symbol);
            };
            for (var i = 0; i < length; i++) {
              _loop_16(i);
            }
            var returnType = combineFromUsage(combineUsages(calls.map(function(call) {
              return call.return_;
            })));
            return checker.createSignature(void 0, void 0, void 0, parameters2, returnType, void 0, length, 0);
          }
          function addCandidateType(usage, type2) {
            if (type2 && !(type2.flags & 1) && !(type2.flags & 131072)) {
              (usage.candidateTypes || (usage.candidateTypes = [])).push(type2);
            }
          }
          function addCandidateThisType(usage, type2) {
            if (type2 && !(type2.flags & 1) && !(type2.flags & 131072)) {
              (usage.candidateThisTypes || (usage.candidateThisTypes = [])).push(type2);
            }
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixReturnTypeInAsyncFunction";
        var errorCodes = [
          ts3.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function getCodeActionsToFixReturnTypeInAsyncFunction(context) {
            var sourceFile = context.sourceFile, program2 = context.program, span = context.span;
            var checker = program2.getTypeChecker();
            var info = getInfo(sourceFile, program2.getTypeChecker(), span.start);
            if (!info) {
              return void 0;
            }
            var returnTypeNode = info.returnTypeNode, returnType = info.returnType, promisedTypeNode = info.promisedTypeNode, promisedType = info.promisedType;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, returnTypeNode, promisedTypeNode);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [
              ts3.Diagnostics.Replace_0_with_Promise_1,
              checker.typeToString(returnType),
              checker.typeToString(promisedType)
            ], fixId, ts3.Diagnostics.Fix_all_incorrect_return_type_of_an_async_functions)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, context.program.getTypeChecker(), diag.start);
              if (info) {
                doChange(changes, diag.file, info.returnTypeNode, info.promisedTypeNode);
              }
            });
          }
        });
        function getInfo(sourceFile, checker, pos) {
          if (ts3.isInJSFile(sourceFile)) {
            return void 0;
          }
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var func = ts3.findAncestor(token, ts3.isFunctionLikeDeclaration);
          var returnTypeNode = func === null || func === void 0 ? void 0 : func.type;
          if (!returnTypeNode) {
            return void 0;
          }
          var returnType = checker.getTypeFromTypeNode(returnTypeNode);
          var promisedType = checker.getAwaitedType(returnType) || checker.getVoidType();
          var promisedTypeNode = checker.typeToTypeNode(promisedType, returnTypeNode, void 0);
          if (promisedTypeNode) {
            return { returnTypeNode, returnType, promisedTypeNode, promisedType };
          }
        }
        function doChange(changes, sourceFile, returnTypeNode, promisedTypeNode) {
          changes.replaceNode(sourceFile, returnTypeNode, ts3.factory.createTypeReferenceNode("Promise", [promisedTypeNode]));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "disableJsDiagnostics";
        var fixId = "disableJsDiagnostics";
        var errorCodes = ts3.mapDefined(Object.keys(ts3.Diagnostics), function(key) {
          var diag = ts3.Diagnostics[key];
          return diag.category === ts3.DiagnosticCategory.Error ? diag.code : void 0;
        });
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToDisableJsDiagnostics(context) {
            var sourceFile = context.sourceFile, program2 = context.program, span = context.span, host = context.host, formatContext = context.formatContext;
            if (!ts3.isInJSFile(sourceFile) || !ts3.isCheckJsEnabledForFile(sourceFile, program2.getCompilerOptions())) {
              return void 0;
            }
            var newLineCharacter = sourceFile.checkJsDirective ? "" : ts3.getNewLineOrDefaultFromHost(host, formatContext.options);
            var fixes = [
              codefix2.createCodeFixActionWithoutFixAll(fixName, [codefix2.createFileTextChanges(sourceFile.fileName, [
                ts3.createTextChange(sourceFile.checkJsDirective ? ts3.createTextSpanFromBounds(sourceFile.checkJsDirective.pos, sourceFile.checkJsDirective.end) : ts3.createTextSpan(0, 0), "// @ts-nocheck".concat(newLineCharacter))
              ])], ts3.Diagnostics.Disable_checking_for_this_file)
            ];
            if (ts3.textChanges.isValidLocationToAddComment(sourceFile, span.start)) {
              fixes.unshift(codefix2.createCodeFixAction(fixName, ts3.textChanges.ChangeTracker.with(context, function(t) {
                return makeChange(t, sourceFile, span.start);
              }), ts3.Diagnostics.Ignore_this_error_message, fixId, ts3.Diagnostics.Add_ts_ignore_to_all_error_messages));
            }
            return fixes;
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenLines = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              if (ts3.textChanges.isValidLocationToAddComment(diag.file, diag.start)) {
                makeChange(changes, diag.file, diag.start, seenLines);
              }
            });
          }
        });
        function makeChange(changes, sourceFile, position, seenLines) {
          var lineNumber = ts3.getLineAndCharacterOfPosition(sourceFile, position).line;
          if (!seenLines || ts3.tryAddToSet(seenLines, lineNumber)) {
            changes.insertCommentBeforeLine(sourceFile, lineNumber, position, " @ts-ignore");
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        function createMissingMemberNodes(classDeclaration, possiblyMissingSymbols, sourceFile, context, preferences, importAdder, addClassElement) {
          var classMembers = classDeclaration.symbol.members;
          for (var _i = 0, possiblyMissingSymbols_1 = possiblyMissingSymbols; _i < possiblyMissingSymbols_1.length; _i++) {
            var symbol = possiblyMissingSymbols_1[_i];
            if (!classMembers.has(symbol.escapedName)) {
              addNewNodeForMemberSymbol(symbol, classDeclaration, sourceFile, context, preferences, importAdder, addClassElement, void 0);
            }
          }
        }
        codefix2.createMissingMemberNodes = createMissingMemberNodes;
        function getNoopSymbolTrackerWithResolver(context) {
          return {
            trackSymbol: function() {
              return false;
            },
            moduleResolverHost: ts3.getModuleSpecifierResolverHost(context.program, context.host)
          };
        }
        codefix2.getNoopSymbolTrackerWithResolver = getNoopSymbolTrackerWithResolver;
        var PreserveOptionalFlags;
        (function(PreserveOptionalFlags2) {
          PreserveOptionalFlags2[PreserveOptionalFlags2["Method"] = 1] = "Method";
          PreserveOptionalFlags2[PreserveOptionalFlags2["Property"] = 2] = "Property";
          PreserveOptionalFlags2[PreserveOptionalFlags2["All"] = 3] = "All";
        })(PreserveOptionalFlags = codefix2.PreserveOptionalFlags || (codefix2.PreserveOptionalFlags = {}));
        function addNewNodeForMemberSymbol(symbol, enclosingDeclaration, sourceFile, context, preferences, importAdder, addClassElement, body, preserveOptional, isAmbient) {
          if (preserveOptional === void 0) {
            preserveOptional = 3;
          }
          if (isAmbient === void 0) {
            isAmbient = false;
          }
          var declarations = symbol.getDeclarations();
          if (!(declarations && declarations.length)) {
            return void 0;
          }
          var checker = context.program.getTypeChecker();
          var scriptTarget = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
          var declaration = declarations[0];
          var name = ts3.getSynthesizedDeepClone(ts3.getNameOfDeclaration(declaration), false);
          var visibilityModifier = createVisibilityModifier(ts3.getEffectiveModifierFlags(declaration));
          var modifiers = visibilityModifier ? ts3.factory.createNodeArray([visibilityModifier]) : void 0;
          var type2 = checker.getWidenedType(checker.getTypeOfSymbolAtLocation(symbol, enclosingDeclaration));
          var optional = !!(symbol.flags & 16777216);
          var ambient = !!(enclosingDeclaration.flags & 16777216) || isAmbient;
          var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
          switch (declaration.kind) {
            case 166:
            case 167:
              var flags = quotePreference === 0 ? 268435456 : void 0;
              var typeNode = checker.typeToTypeNode(type2, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
              if (importAdder) {
                var importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
                if (importableReference) {
                  typeNode = importableReference.typeNode;
                  importSymbols(importAdder, importableReference.symbols);
                }
              }
              addClassElement(ts3.factory.createPropertyDeclaration(void 0, modifiers, name, optional && preserveOptional & 2 ? ts3.factory.createToken(57) : void 0, typeNode, void 0));
              break;
            case 172:
            case 173: {
              var typeNode_1 = checker.typeToTypeNode(type2, enclosingDeclaration, void 0, getNoopSymbolTrackerWithResolver(context));
              var allAccessors = ts3.getAllAccessorDeclarations(declarations, declaration);
              var orderedAccessors = allAccessors.secondAccessor ? [allAccessors.firstAccessor, allAccessors.secondAccessor] : [allAccessors.firstAccessor];
              if (importAdder) {
                var importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode_1, scriptTarget);
                if (importableReference) {
                  typeNode_1 = importableReference.typeNode;
                  importSymbols(importAdder, importableReference.symbols);
                }
              }
              for (var _i = 0, orderedAccessors_1 = orderedAccessors; _i < orderedAccessors_1.length; _i++) {
                var accessor = orderedAccessors_1[_i];
                if (ts3.isGetAccessorDeclaration(accessor)) {
                  addClassElement(ts3.factory.createGetAccessorDeclaration(void 0, modifiers, name, ts3.emptyArray, typeNode_1, ambient ? void 0 : body || createStubbedMethodBody(quotePreference)));
                } else {
                  ts3.Debug.assertNode(accessor, ts3.isSetAccessorDeclaration, "The counterpart to a getter should be a setter");
                  var parameter = ts3.getSetAccessorValueParameter(accessor);
                  var parameterName = parameter && ts3.isIdentifier(parameter.name) ? ts3.idText(parameter.name) : void 0;
                  addClassElement(ts3.factory.createSetAccessorDeclaration(void 0, modifiers, name, createDummyParameters(1, [parameterName], [typeNode_1], 1, false), ambient ? void 0 : body || createStubbedMethodBody(quotePreference)));
                }
              }
              break;
            }
            case 168:
            case 169:
              var signatures = checker.getSignaturesOfType(type2, 0);
              if (!ts3.some(signatures)) {
                break;
              }
              if (declarations.length === 1) {
                ts3.Debug.assert(signatures.length === 1, "One declaration implies one signature");
                var signature = signatures[0];
                outputMethod(quotePreference, signature, modifiers, name, ambient ? void 0 : body || createStubbedMethodBody(quotePreference));
                break;
              }
              for (var _a = 0, signatures_1 = signatures; _a < signatures_1.length; _a++) {
                var signature = signatures_1[_a];
                outputMethod(quotePreference, signature, ts3.getSynthesizedDeepClones(modifiers, false), ts3.getSynthesizedDeepClone(name, false));
              }
              if (!ambient) {
                if (declarations.length > signatures.length) {
                  var signature = checker.getSignatureFromDeclaration(declarations[declarations.length - 1]);
                  outputMethod(quotePreference, signature, modifiers, name, body || createStubbedMethodBody(quotePreference));
                } else {
                  ts3.Debug.assert(declarations.length === signatures.length, "Declarations and signatures should match count");
                  addClassElement(createMethodImplementingSignatures(checker, context, enclosingDeclaration, signatures, name, optional && !!(preserveOptional & 1), modifiers, quotePreference, body));
                }
              }
              break;
          }
          function outputMethod(quotePreference2, signature2, modifiers2, name2, body2) {
            var method = createSignatureDeclarationFromSignature(169, context, quotePreference2, signature2, body2, name2, modifiers2, optional && !!(preserveOptional & 1), enclosingDeclaration, importAdder);
            if (method)
              addClassElement(method);
          }
        }
        codefix2.addNewNodeForMemberSymbol = addNewNodeForMemberSymbol;
        function createSignatureDeclarationFromSignature(kind, context, quotePreference, signature, body, name, modifiers, optional, enclosingDeclaration, importAdder) {
          var program2 = context.program;
          var checker = program2.getTypeChecker();
          var scriptTarget = ts3.getEmitScriptTarget(program2.getCompilerOptions());
          var flags = 1 | 256 | 524288 | (quotePreference === 0 ? 268435456 : 0);
          var signatureDeclaration = checker.signatureToSignatureDeclaration(signature, kind, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
          if (!signatureDeclaration) {
            return void 0;
          }
          var typeParameters = signatureDeclaration.typeParameters;
          var parameters = signatureDeclaration.parameters;
          var type2 = signatureDeclaration.type;
          if (importAdder) {
            if (typeParameters) {
              var newTypeParameters = ts3.sameMap(typeParameters, function(typeParameterDecl) {
                var constraint = typeParameterDecl.constraint;
                var defaultType = typeParameterDecl.default;
                if (constraint) {
                  var importableReference2 = tryGetAutoImportableReferenceFromTypeNode(constraint, scriptTarget);
                  if (importableReference2) {
                    constraint = importableReference2.typeNode;
                    importSymbols(importAdder, importableReference2.symbols);
                  }
                }
                if (defaultType) {
                  var importableReference2 = tryGetAutoImportableReferenceFromTypeNode(defaultType, scriptTarget);
                  if (importableReference2) {
                    defaultType = importableReference2.typeNode;
                    importSymbols(importAdder, importableReference2.symbols);
                  }
                }
                return ts3.factory.updateTypeParameterDeclaration(typeParameterDecl, typeParameterDecl.modifiers, typeParameterDecl.name, constraint, defaultType);
              });
              if (typeParameters !== newTypeParameters) {
                typeParameters = ts3.setTextRange(ts3.factory.createNodeArray(newTypeParameters, typeParameters.hasTrailingComma), typeParameters);
              }
            }
            var newParameters = ts3.sameMap(parameters, function(parameterDecl) {
              var importableReference2 = tryGetAutoImportableReferenceFromTypeNode(parameterDecl.type, scriptTarget);
              var type3 = parameterDecl.type;
              if (importableReference2) {
                type3 = importableReference2.typeNode;
                importSymbols(importAdder, importableReference2.symbols);
              }
              return ts3.factory.updateParameterDeclaration(parameterDecl, parameterDecl.decorators, parameterDecl.modifiers, parameterDecl.dotDotDotToken, parameterDecl.name, parameterDecl.questionToken, type3, parameterDecl.initializer);
            });
            if (parameters !== newParameters) {
              parameters = ts3.setTextRange(ts3.factory.createNodeArray(newParameters, parameters.hasTrailingComma), parameters);
            }
            if (type2) {
              var importableReference = tryGetAutoImportableReferenceFromTypeNode(type2, scriptTarget);
              if (importableReference) {
                type2 = importableReference.typeNode;
                importSymbols(importAdder, importableReference.symbols);
              }
            }
          }
          var questionToken = optional ? ts3.factory.createToken(57) : void 0;
          var asteriskToken = signatureDeclaration.asteriskToken;
          if (ts3.isFunctionExpression(signatureDeclaration)) {
            return ts3.factory.updateFunctionExpression(signatureDeclaration, modifiers, signatureDeclaration.asteriskToken, ts3.tryCast(name, ts3.isIdentifier), typeParameters, parameters, type2, body !== null && body !== void 0 ? body : signatureDeclaration.body);
          }
          if (ts3.isArrowFunction(signatureDeclaration)) {
            return ts3.factory.updateArrowFunction(signatureDeclaration, modifiers, typeParameters, parameters, type2, signatureDeclaration.equalsGreaterThanToken, body !== null && body !== void 0 ? body : signatureDeclaration.body);
          }
          if (ts3.isMethodDeclaration(signatureDeclaration)) {
            return ts3.factory.updateMethodDeclaration(signatureDeclaration, void 0, modifiers, asteriskToken, name !== null && name !== void 0 ? name : ts3.factory.createIdentifier(""), questionToken, typeParameters, parameters, type2, body);
          }
          return void 0;
        }
        codefix2.createSignatureDeclarationFromSignature = createSignatureDeclarationFromSignature;
        function createSignatureDeclarationFromCallExpression(kind, context, importAdder, call, name, modifierFlags, contextNode) {
          var quotePreference = ts3.getQuotePreference(context.sourceFile, context.preferences);
          var scriptTarget = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
          var tracker = getNoopSymbolTrackerWithResolver(context);
          var checker = context.program.getTypeChecker();
          var isJs = ts3.isInJSFile(contextNode);
          var typeArguments = call.typeArguments, args = call.arguments, parent = call.parent;
          var contextualType = isJs ? void 0 : checker.getContextualType(call);
          var names = ts3.map(args, function(arg) {
            return ts3.isIdentifier(arg) ? arg.text : ts3.isPropertyAccessExpression(arg) && ts3.isIdentifier(arg.name) ? arg.name.text : void 0;
          });
          var types2 = isJs ? [] : ts3.map(args, function(arg) {
            return typeToAutoImportableTypeNode(checker, importAdder, checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(arg)), contextNode, scriptTarget, void 0, tracker);
          });
          var modifiers = modifierFlags ? ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
          var asteriskToken = ts3.isYieldExpression(parent) ? ts3.factory.createToken(41) : void 0;
          var typeParameters = isJs || typeArguments === void 0 ? void 0 : ts3.map(typeArguments, function(_, i) {
            return ts3.factory.createTypeParameterDeclaration(void 0, 84 + typeArguments.length - 1 <= 90 ? String.fromCharCode(84 + i) : "T".concat(i));
          });
          var parameters = createDummyParameters(args.length, names, types2, void 0, isJs);
          var type2 = isJs || contextualType === void 0 ? void 0 : checker.typeToTypeNode(contextualType, contextNode, void 0, tracker);
          switch (kind) {
            case 169:
              return ts3.factory.createMethodDeclaration(void 0, modifiers, asteriskToken, name, void 0, typeParameters, parameters, type2, createStubbedMethodBody(quotePreference));
            case 168:
              return ts3.factory.createMethodSignature(modifiers, name, void 0, typeParameters, parameters, type2);
            case 256:
              return ts3.factory.createFunctionDeclaration(void 0, modifiers, asteriskToken, name, typeParameters, parameters, type2, createStubbedBody(ts3.Diagnostics.Function_not_implemented.message, quotePreference));
            default:
              ts3.Debug.fail("Unexpected kind");
          }
        }
        codefix2.createSignatureDeclarationFromCallExpression = createSignatureDeclarationFromCallExpression;
        function typeToAutoImportableTypeNode(checker, importAdder, type2, contextNode, scriptTarget, flags, tracker) {
          var typeNode = checker.typeToTypeNode(type2, contextNode, flags, tracker);
          if (typeNode && ts3.isImportTypeNode(typeNode)) {
            var importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
            if (importableReference) {
              importSymbols(importAdder, importableReference.symbols);
              typeNode = importableReference.typeNode;
            }
          }
          return ts3.getSynthesizedDeepClone(typeNode);
        }
        codefix2.typeToAutoImportableTypeNode = typeToAutoImportableTypeNode;
        function createDummyParameters(argCount, names, types2, minArgumentCount, inJs) {
          var parameters = [];
          for (var i = 0; i < argCount; i++) {
            var newParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, names && names[i] || "arg".concat(i), minArgumentCount !== void 0 && i >= minArgumentCount ? ts3.factory.createToken(57) : void 0, inJs ? void 0 : types2 && types2[i] || ts3.factory.createKeywordTypeNode(155), void 0);
            parameters.push(newParameter);
          }
          return parameters;
        }
        function createMethodImplementingSignatures(checker, context, enclosingDeclaration, signatures, name, optional, modifiers, quotePreference, body) {
          var maxArgsSignature = signatures[0];
          var minArgumentCount = signatures[0].minArgumentCount;
          var someSigHasRestParameter = false;
          for (var _i = 0, signatures_2 = signatures; _i < signatures_2.length; _i++) {
            var sig = signatures_2[_i];
            minArgumentCount = Math.min(sig.minArgumentCount, minArgumentCount);
            if (ts3.signatureHasRestParameter(sig)) {
              someSigHasRestParameter = true;
            }
            if (sig.parameters.length >= maxArgsSignature.parameters.length && (!ts3.signatureHasRestParameter(sig) || ts3.signatureHasRestParameter(maxArgsSignature))) {
              maxArgsSignature = sig;
            }
          }
          var maxNonRestArgs = maxArgsSignature.parameters.length - (ts3.signatureHasRestParameter(maxArgsSignature) ? 1 : 0);
          var maxArgsParameterSymbolNames = maxArgsSignature.parameters.map(function(symbol) {
            return symbol.name;
          });
          var parameters = createDummyParameters(maxNonRestArgs, maxArgsParameterSymbolNames, void 0, minArgumentCount, false);
          if (someSigHasRestParameter) {
            var restParameter = ts3.factory.createParameterDeclaration(void 0, void 0, ts3.factory.createToken(25), maxArgsParameterSymbolNames[maxNonRestArgs] || "rest", maxNonRestArgs >= minArgumentCount ? ts3.factory.createToken(57) : void 0, ts3.factory.createArrayTypeNode(ts3.factory.createKeywordTypeNode(155)), void 0);
            parameters.push(restParameter);
          }
          return createStubbedMethod(modifiers, name, optional, void 0, parameters, getReturnTypeFromSignatures(signatures, checker, context, enclosingDeclaration), quotePreference, body);
        }
        function getReturnTypeFromSignatures(signatures, checker, context, enclosingDeclaration) {
          if (ts3.length(signatures)) {
            var type2 = checker.getUnionType(ts3.map(signatures, checker.getReturnTypeOfSignature));
            return checker.typeToTypeNode(type2, enclosingDeclaration, void 0, getNoopSymbolTrackerWithResolver(context));
          }
        }
        function createStubbedMethod(modifiers, name, optional, typeParameters, parameters, returnType, quotePreference, body) {
          return ts3.factory.createMethodDeclaration(void 0, modifiers, void 0, name, optional ? ts3.factory.createToken(57) : void 0, typeParameters, parameters, returnType, body || createStubbedMethodBody(quotePreference));
        }
        function createStubbedMethodBody(quotePreference) {
          return createStubbedBody(ts3.Diagnostics.Method_not_implemented.message, quotePreference);
        }
        function createStubbedBody(text, quotePreference) {
          return ts3.factory.createBlock([ts3.factory.createThrowStatement(ts3.factory.createNewExpression(ts3.factory.createIdentifier("Error"), void 0, [ts3.factory.createStringLiteral(text, quotePreference === 0)]))], true);
        }
        codefix2.createStubbedBody = createStubbedBody;
        function createVisibilityModifier(flags) {
          if (flags & 4) {
            return ts3.factory.createToken(123);
          } else if (flags & 16) {
            return ts3.factory.createToken(122);
          }
          return void 0;
        }
        function setJsonCompilerOptionValues(changeTracker, configFile, options) {
          var tsconfigObjectLiteral = ts3.getTsConfigObjectLiteralExpression(configFile);
          if (!tsconfigObjectLiteral)
            return void 0;
          var compilerOptionsProperty = findJsonProperty(tsconfigObjectLiteral, "compilerOptions");
          if (compilerOptionsProperty === void 0) {
            changeTracker.insertNodeAtObjectStart(configFile, tsconfigObjectLiteral, createJsonPropertyAssignment("compilerOptions", ts3.factory.createObjectLiteralExpression(options.map(function(_a2) {
              var optionName2 = _a2[0], optionValue2 = _a2[1];
              return createJsonPropertyAssignment(optionName2, optionValue2);
            }), true)));
            return;
          }
          var compilerOptions = compilerOptionsProperty.initializer;
          if (!ts3.isObjectLiteralExpression(compilerOptions)) {
            return;
          }
          for (var _i = 0, options_1 = options; _i < options_1.length; _i++) {
            var _a = options_1[_i], optionName = _a[0], optionValue = _a[1];
            var optionProperty = findJsonProperty(compilerOptions, optionName);
            if (optionProperty === void 0) {
              changeTracker.insertNodeAtObjectStart(configFile, compilerOptions, createJsonPropertyAssignment(optionName, optionValue));
            } else {
              changeTracker.replaceNode(configFile, optionProperty.initializer, optionValue);
            }
          }
        }
        codefix2.setJsonCompilerOptionValues = setJsonCompilerOptionValues;
        function setJsonCompilerOptionValue(changeTracker, configFile, optionName, optionValue) {
          setJsonCompilerOptionValues(changeTracker, configFile, [[optionName, optionValue]]);
        }
        codefix2.setJsonCompilerOptionValue = setJsonCompilerOptionValue;
        function createJsonPropertyAssignment(name, initializer) {
          return ts3.factory.createPropertyAssignment(ts3.factory.createStringLiteral(name), initializer);
        }
        codefix2.createJsonPropertyAssignment = createJsonPropertyAssignment;
        function findJsonProperty(obj, name) {
          return ts3.find(obj.properties, function(p) {
            return ts3.isPropertyAssignment(p) && !!p.name && ts3.isStringLiteral(p.name) && p.name.text === name;
          });
        }
        codefix2.findJsonProperty = findJsonProperty;
        function tryGetAutoImportableReferenceFromTypeNode(importTypeNode, scriptTarget) {
          var symbols;
          var typeNode = ts3.visitNode(importTypeNode, visit);
          if (symbols && typeNode) {
            return { typeNode, symbols };
          }
          function visit(node) {
            var _a;
            if (ts3.isLiteralImportTypeNode(node) && node.qualifier) {
              var firstIdentifier = ts3.getFirstIdentifier(node.qualifier);
              var name = ts3.getNameForExportedSymbol(firstIdentifier.symbol, scriptTarget);
              var qualifier = name !== firstIdentifier.text ? replaceFirstIdentifierOfEntityName(node.qualifier, ts3.factory.createIdentifier(name)) : node.qualifier;
              symbols = ts3.append(symbols, firstIdentifier.symbol);
              var typeArguments = (_a = node.typeArguments) === null || _a === void 0 ? void 0 : _a.map(visit);
              return ts3.factory.createTypeReferenceNode(qualifier, typeArguments);
            }
            return ts3.visitEachChild(node, visit, ts3.nullTransformationContext);
          }
        }
        codefix2.tryGetAutoImportableReferenceFromTypeNode = tryGetAutoImportableReferenceFromTypeNode;
        function replaceFirstIdentifierOfEntityName(name, newIdentifier) {
          if (name.kind === 79) {
            return newIdentifier;
          }
          return ts3.factory.createQualifiedName(replaceFirstIdentifierOfEntityName(name.left, newIdentifier), name.right);
        }
        function importSymbols(importAdder, symbols) {
          symbols.forEach(function(s) {
            return importAdder.addImportFromExportedSymbol(s, true);
          });
        }
        codefix2.importSymbols = importSymbols;
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        function generateAccessorFromProperty(file, program2, start, end, context, _actionName) {
          var fieldInfo = getAccessorConvertiblePropertyAtPosition(file, program2, start, end);
          if (!fieldInfo || ts3.refactor.isRefactorErrorInfo(fieldInfo))
            return void 0;
          var changeTracker = ts3.textChanges.ChangeTracker.fromContext(context);
          var isStatic = fieldInfo.isStatic, isReadonly = fieldInfo.isReadonly, fieldName = fieldInfo.fieldName, accessorName = fieldInfo.accessorName, originalName = fieldInfo.originalName, type2 = fieldInfo.type, container = fieldInfo.container, declaration = fieldInfo.declaration;
          ts3.suppressLeadingAndTrailingTrivia(fieldName);
          ts3.suppressLeadingAndTrailingTrivia(accessorName);
          ts3.suppressLeadingAndTrailingTrivia(declaration);
          ts3.suppressLeadingAndTrailingTrivia(container);
          var accessorModifiers;
          var fieldModifiers;
          if (ts3.isClassLike(container)) {
            var modifierFlags = ts3.getEffectiveModifierFlags(declaration);
            if (ts3.isSourceFileJS(file)) {
              var modifiers = ts3.createModifiers(modifierFlags);
              accessorModifiers = modifiers;
              fieldModifiers = modifiers;
            } else {
              accessorModifiers = ts3.createModifiers(prepareModifierFlagsForAccessor(modifierFlags));
              fieldModifiers = ts3.createModifiers(prepareModifierFlagsForField(modifierFlags));
            }
          }
          updateFieldDeclaration(changeTracker, file, declaration, type2, fieldName, fieldModifiers);
          var getAccessor = generateGetAccessor(fieldName, accessorName, type2, accessorModifiers, isStatic, container);
          ts3.suppressLeadingAndTrailingTrivia(getAccessor);
          insertAccessor(changeTracker, file, getAccessor, declaration, container);
          if (isReadonly) {
            var constructor = ts3.getFirstConstructorWithBody(container);
            if (constructor) {
              updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName.text, originalName);
            }
          } else {
            var setAccessor = generateSetAccessor(fieldName, accessorName, type2, accessorModifiers, isStatic, container);
            ts3.suppressLeadingAndTrailingTrivia(setAccessor);
            insertAccessor(changeTracker, file, setAccessor, declaration, container);
          }
          return changeTracker.getChanges();
        }
        codefix2.generateAccessorFromProperty = generateAccessorFromProperty;
        function isConvertibleName(name) {
          return ts3.isIdentifier(name) || ts3.isStringLiteral(name);
        }
        function isAcceptedDeclaration(node) {
          return ts3.isParameterPropertyDeclaration(node, node.parent) || ts3.isPropertyDeclaration(node) || ts3.isPropertyAssignment(node);
        }
        function createPropertyName(name, originalName) {
          return ts3.isIdentifier(originalName) ? ts3.factory.createIdentifier(name) : ts3.factory.createStringLiteral(name);
        }
        function createAccessorAccessExpression(fieldName, isStatic, container) {
          var leftHead = isStatic ? container.name : ts3.factory.createThis();
          return ts3.isIdentifier(fieldName) ? ts3.factory.createPropertyAccessExpression(leftHead, fieldName) : ts3.factory.createElementAccessExpression(leftHead, ts3.factory.createStringLiteralFromNode(fieldName));
        }
        function prepareModifierFlagsForAccessor(modifierFlags) {
          modifierFlags &= ~64;
          modifierFlags &= ~8;
          if (!(modifierFlags & 16)) {
            modifierFlags |= 4;
          }
          return modifierFlags;
        }
        function prepareModifierFlagsForField(modifierFlags) {
          modifierFlags &= ~4;
          modifierFlags &= ~16;
          modifierFlags |= 8;
          return modifierFlags;
        }
        function getAccessorConvertiblePropertyAtPosition(file, program2, start, end, considerEmptySpans) {
          if (considerEmptySpans === void 0) {
            considerEmptySpans = true;
          }
          var node = ts3.getTokenAtPosition(file, start);
          var cursorRequest = start === end && considerEmptySpans;
          var declaration = ts3.findAncestor(node.parent, isAcceptedDeclaration);
          var meaning = 28 | 32 | 64;
          if (!declaration || !(ts3.nodeOverlapsWithStartEnd(declaration.name, file, start, end) || cursorRequest)) {
            return {
              error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_property_for_which_to_generate_accessor)
            };
          }
          if (!isConvertibleName(declaration.name)) {
            return {
              error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Name_is_not_valid)
            };
          }
          if ((ts3.getEffectiveModifierFlags(declaration) | meaning) !== meaning) {
            return {
              error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_property_with_modifier)
            };
          }
          var name = declaration.name.text;
          var startWithUnderscore = ts3.startsWithUnderscore(name);
          var fieldName = createPropertyName(startWithUnderscore ? name : ts3.getUniqueName("_".concat(name), file), declaration.name);
          var accessorName = createPropertyName(startWithUnderscore ? ts3.getUniqueName(name.substring(1), file) : name, declaration.name);
          return {
            isStatic: ts3.hasStaticModifier(declaration),
            isReadonly: ts3.hasEffectiveReadonlyModifier(declaration),
            type: getDeclarationType(declaration, program2),
            container: declaration.kind === 164 ? declaration.parent.parent : declaration.parent,
            originalName: declaration.name.text,
            declaration,
            fieldName,
            accessorName,
            renameAccessor: startWithUnderscore
          };
        }
        codefix2.getAccessorConvertiblePropertyAtPosition = getAccessorConvertiblePropertyAtPosition;
        function generateGetAccessor(fieldName, accessorName, type2, modifiers, isStatic, container) {
          return ts3.factory.createGetAccessorDeclaration(void 0, modifiers, accessorName, void 0, type2, ts3.factory.createBlock([
            ts3.factory.createReturnStatement(createAccessorAccessExpression(fieldName, isStatic, container))
          ], true));
        }
        function generateSetAccessor(fieldName, accessorName, type2, modifiers, isStatic, container) {
          return ts3.factory.createSetAccessorDeclaration(void 0, modifiers, accessorName, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, ts3.factory.createIdentifier("value"), void 0, type2)], ts3.factory.createBlock([
            ts3.factory.createExpressionStatement(ts3.factory.createAssignment(createAccessorAccessExpression(fieldName, isStatic, container), ts3.factory.createIdentifier("value")))
          ], true));
        }
        function updatePropertyDeclaration(changeTracker, file, declaration, type2, fieldName, modifiers) {
          var property = ts3.factory.updatePropertyDeclaration(declaration, declaration.decorators, modifiers, fieldName, declaration.questionToken || declaration.exclamationToken, type2, declaration.initializer);
          changeTracker.replaceNode(file, declaration, property);
        }
        function updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName) {
          var assignment = ts3.factory.updatePropertyAssignment(declaration, fieldName, declaration.initializer);
          changeTracker.replacePropertyAssignment(file, declaration, assignment);
        }
        function updateFieldDeclaration(changeTracker, file, declaration, type2, fieldName, modifiers) {
          if (ts3.isPropertyDeclaration(declaration)) {
            updatePropertyDeclaration(changeTracker, file, declaration, type2, fieldName, modifiers);
          } else if (ts3.isPropertyAssignment(declaration)) {
            updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName);
          } else {
            changeTracker.replaceNode(file, declaration, ts3.factory.updateParameterDeclaration(declaration, declaration.decorators, modifiers, declaration.dotDotDotToken, ts3.cast(fieldName, ts3.isIdentifier), declaration.questionToken, declaration.type, declaration.initializer));
          }
        }
        function insertAccessor(changeTracker, file, accessor, declaration, container) {
          ts3.isParameterPropertyDeclaration(declaration, declaration.parent) ? changeTracker.insertMemberAtStart(file, container, accessor) : ts3.isPropertyAssignment(declaration) ? changeTracker.insertNodeAfterComma(file, declaration, accessor) : changeTracker.insertNodeAfter(file, declaration, accessor);
        }
        function updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName, originalName) {
          if (!constructor.body)
            return;
          constructor.body.forEachChild(function recur(node) {
            if (ts3.isElementAccessExpression(node) && node.expression.kind === 108 && ts3.isStringLiteral(node.argumentExpression) && node.argumentExpression.text === originalName && ts3.isWriteAccess(node)) {
              changeTracker.replaceNode(file, node.argumentExpression, ts3.factory.createStringLiteral(fieldName));
            }
            if (ts3.isPropertyAccessExpression(node) && node.expression.kind === 108 && node.name.text === originalName && ts3.isWriteAccess(node)) {
              changeTracker.replaceNode(file, node.name, ts3.factory.createIdentifier(fieldName));
            }
            if (!ts3.isFunctionLike(node) && !ts3.isClassLike(node)) {
              node.forEachChild(recur);
            }
          });
        }
        function getDeclarationType(declaration, program2) {
          var typeNode = ts3.getTypeAnnotationNode(declaration);
          if (ts3.isPropertyDeclaration(declaration) && typeNode && declaration.questionToken) {
            var typeChecker = program2.getTypeChecker();
            var type2 = typeChecker.getTypeFromTypeNode(typeNode);
            if (!typeChecker.isTypeAssignableTo(typeChecker.getUndefinedType(), type2)) {
              var types2 = ts3.isUnionTypeNode(typeNode) ? typeNode.types : [typeNode];
              return ts3.factory.createUnionTypeNode(__spreadArray(__spreadArray([], types2, true), [ts3.factory.createKeywordTypeNode(153)], false));
            }
          }
          return typeNode;
        }
        function getAllSupers(decl, checker) {
          var res = [];
          while (decl) {
            var superElement = ts3.getClassExtendsHeritageElement(decl);
            var superSymbol = superElement && checker.getSymbolAtLocation(superElement.expression);
            if (!superSymbol)
              break;
            var symbol = superSymbol.flags & 2097152 ? checker.getAliasedSymbol(superSymbol) : superSymbol;
            var superDecl = symbol.declarations && ts3.find(symbol.declarations, ts3.isClassLike);
            if (!superDecl)
              break;
            res.push(superDecl);
            decl = superDecl;
          }
          return res;
        }
        codefix2.getAllSupers = getAllSupers;
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "invalidImportSyntax";
        function getCodeFixesForImportDeclaration(context, node) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          var namespace = ts3.getNamespaceDeclarationNode(node);
          var opts = context.program.getCompilerOptions();
          var variations = [];
          variations.push(createAction(context, sourceFile, node, ts3.makeImport(namespace.name, void 0, node.moduleSpecifier, ts3.getQuotePreference(sourceFile, context.preferences))));
          if (ts3.getEmitModuleKind(opts) === ts3.ModuleKind.CommonJS) {
            variations.push(createAction(context, sourceFile, node, ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, namespace.name, ts3.factory.createExternalModuleReference(node.moduleSpecifier))));
          }
          return variations;
        }
        function createAction(context, sourceFile, node, replacement) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return t.replaceNode(sourceFile, node, replacement);
          });
          return codefix2.createCodeFixActionWithoutFixAll(fixName, changes, [ts3.Diagnostics.Replace_import_with_0, changes[0].textChanges[0].newText]);
        }
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.This_expression_is_not_callable.code,
            ts3.Diagnostics.This_expression_is_not_constructable.code
          ],
          getCodeActions: getActionsForUsageOfInvalidImport
        });
        function getActionsForUsageOfInvalidImport(context) {
          var sourceFile = context.sourceFile;
          var targetKind = ts3.Diagnostics.This_expression_is_not_callable.code === context.errorCode ? 208 : 209;
          var node = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, context.span.start), function(a) {
            return a.kind === targetKind;
          });
          if (!node) {
            return [];
          }
          var expr = node.expression;
          return getImportCodeFixesForExpression(context, expr);
        }
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
            ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code,
            ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
            ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,
            ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1.code,
            ts3.Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3.code,
            ts3.Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3.code,
            ts3.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,
            ts3.Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code,
            ts3.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,
            ts3.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code
          ],
          getCodeActions: getActionsForInvalidImportLocation
        });
        function getActionsForInvalidImportLocation(context) {
          var sourceFile = context.sourceFile;
          var node = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, context.span.start), function(a) {
            return a.getStart() === context.span.start && a.getEnd() === context.span.start + context.span.length;
          });
          if (!node) {
            return [];
          }
          return getImportCodeFixesForExpression(context, node);
        }
        function getImportCodeFixesForExpression(context, expr) {
          var type2 = context.program.getTypeChecker().getTypeAtLocation(expr);
          if (!(type2.symbol && type2.symbol.originatingImport)) {
            return [];
          }
          var fixes = [];
          var relatedImport = type2.symbol.originatingImport;
          if (!ts3.isImportCall(relatedImport)) {
            ts3.addRange(fixes, getCodeFixesForImportDeclaration(context, relatedImport));
          }
          if (ts3.isExpression(expr) && !(ts3.isNamedDeclaration(expr.parent) && expr.parent.name === expr)) {
            var sourceFile_2 = context.sourceFile;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return t.replaceNode(sourceFile_2, expr, ts3.factory.createPropertyAccessExpression(expr, "default"), {});
            });
            fixes.push(codefix2.createCodeFixActionWithoutFixAll(fixName, changes, ts3.Diagnostics.Use_synthetic_default_member));
          }
          return fixes;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "strictClassInitialization";
        var fixIdAddDefiniteAssignmentAssertions = "addMissingPropertyDefiniteAssignmentAssertions";
        var fixIdAddUndefinedType = "addMissingPropertyUndefinedType";
        var fixIdAddInitializer = "addMissingPropertyInitializer";
        var errorCodes = [ts3.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsForStrictClassInitializationErrors(context) {
            var info = getInfo(context.sourceFile, context.span.start);
            if (!info)
              return;
            var result2 = [];
            ts3.append(result2, getActionForAddMissingUndefinedType(context, info));
            ts3.append(result2, getActionForAddMissingDefiniteAssignmentAssertion(context, info));
            ts3.append(result2, getActionForAddMissingInitializer(context, info));
            return result2;
          },
          fixIds: [fixIdAddDefiniteAssignmentAssertions, fixIdAddUndefinedType, fixIdAddInitializer],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (!info)
                return;
              switch (context.fixId) {
                case fixIdAddDefiniteAssignmentAssertions:
                  addDefiniteAssignmentAssertion(changes, diag.file, info.prop);
                  break;
                case fixIdAddUndefinedType:
                  addUndefinedType(changes, diag.file, info);
                  break;
                case fixIdAddInitializer:
                  var checker = context.program.getTypeChecker();
                  var initializer = getInitializer(checker, info.prop);
                  if (!initializer)
                    return;
                  addInitializer(changes, diag.file, info.prop, initializer);
                  break;
                default:
                  ts3.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (ts3.isIdentifier(token) && ts3.isPropertyDeclaration(token.parent)) {
            var type2 = ts3.getEffectiveTypeAnnotationNode(token.parent);
            if (type2) {
              return { type: type2, prop: token.parent, isJs: ts3.isInJSFile(token.parent) };
            }
          }
          return void 0;
        }
        function getActionForAddMissingDefiniteAssignmentAssertion(context, info) {
          if (info.isJs)
            return void 0;
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return addDefiniteAssignmentAssertion(t, context.sourceFile, info.prop);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Add_definite_assignment_assertion_to_property_0, info.prop.getText()], fixIdAddDefiniteAssignmentAssertions, ts3.Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties);
        }
        function addDefiniteAssignmentAssertion(changeTracker, propertyDeclarationSourceFile, propertyDeclaration) {
          ts3.suppressLeadingAndTrailingTrivia(propertyDeclaration);
          var property = ts3.factory.updatePropertyDeclaration(propertyDeclaration, propertyDeclaration.decorators, propertyDeclaration.modifiers, propertyDeclaration.name, ts3.factory.createToken(53), propertyDeclaration.type, propertyDeclaration.initializer);
          changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
        }
        function getActionForAddMissingUndefinedType(context, info) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return addUndefinedType(t, context.sourceFile, info);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Add_undefined_type_to_property_0, info.prop.name.getText()], fixIdAddUndefinedType, ts3.Diagnostics.Add_undefined_type_to_all_uninitialized_properties);
        }
        function addUndefinedType(changeTracker, sourceFile, info) {
          var undefinedTypeNode = ts3.factory.createKeywordTypeNode(153);
          var types2 = ts3.isUnionTypeNode(info.type) ? info.type.types.concat(undefinedTypeNode) : [info.type, undefinedTypeNode];
          var unionTypeNode = ts3.factory.createUnionTypeNode(types2);
          if (info.isJs) {
            changeTracker.addJSDocTags(sourceFile, info.prop, [ts3.factory.createJSDocTypeTag(void 0, ts3.factory.createJSDocTypeExpression(unionTypeNode))]);
          } else {
            changeTracker.replaceNode(sourceFile, info.type, unionTypeNode);
          }
        }
        function getActionForAddMissingInitializer(context, info) {
          if (info.isJs)
            return void 0;
          var checker = context.program.getTypeChecker();
          var initializer = getInitializer(checker, info.prop);
          if (!initializer)
            return void 0;
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
            return addInitializer(t, context.sourceFile, info.prop, initializer);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Add_initializer_to_property_0, info.prop.name.getText()], fixIdAddInitializer, ts3.Diagnostics.Add_initializers_to_all_uninitialized_properties);
        }
        function addInitializer(changeTracker, propertyDeclarationSourceFile, propertyDeclaration, initializer) {
          ts3.suppressLeadingAndTrailingTrivia(propertyDeclaration);
          var property = ts3.factory.updatePropertyDeclaration(propertyDeclaration, propertyDeclaration.decorators, propertyDeclaration.modifiers, propertyDeclaration.name, propertyDeclaration.questionToken, propertyDeclaration.type, initializer);
          changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
        }
        function getInitializer(checker, propertyDeclaration) {
          return getDefaultValueFromType(checker, checker.getTypeFromTypeNode(propertyDeclaration.type));
        }
        function getDefaultValueFromType(checker, type2) {
          if (type2.flags & 512) {
            return type2 === checker.getFalseType() || type2 === checker.getFalseType(true) ? ts3.factory.createFalse() : ts3.factory.createTrue();
          } else if (type2.isStringLiteral()) {
            return ts3.factory.createStringLiteral(type2.value);
          } else if (type2.isNumberLiteral()) {
            return ts3.factory.createNumericLiteral(type2.value);
          } else if (type2.flags & 2048) {
            return ts3.factory.createBigIntLiteral(type2.value);
          } else if (type2.isUnion()) {
            return ts3.firstDefined(type2.types, function(t) {
              return getDefaultValueFromType(checker, t);
            });
          } else if (type2.isClass()) {
            var classDeclaration = ts3.getClassLikeDeclarationOfSymbol(type2.symbol);
            if (!classDeclaration || ts3.hasSyntacticModifier(classDeclaration, 128))
              return void 0;
            var constructorDeclaration = ts3.getFirstConstructorWithBody(classDeclaration);
            if (constructorDeclaration && constructorDeclaration.parameters.length)
              return void 0;
            return ts3.factory.createNewExpression(ts3.factory.createIdentifier(type2.symbol.name), void 0, void 0);
          } else if (checker.isArrayLikeType(type2)) {
            return ts3.factory.createArrayLiteralExpression();
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "requireInTs";
        var errorCodes = [ts3.Diagnostics.require_call_may_be_converted_to_an_import.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var info = getInfo(context.sourceFile, context.program, context.span.start);
            if (!info) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_require_to_import, fixId, ts3.Diagnostics.Convert_all_require_to_import)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, context.program, diag.start);
              if (info) {
                doChange(changes, context.sourceFile, info);
              }
            });
          }
        });
        function doChange(changes, sourceFile, info) {
          var allowSyntheticDefaults = info.allowSyntheticDefaults, defaultImportName = info.defaultImportName, namedImports = info.namedImports, statement = info.statement, required = info.required;
          changes.replaceNode(sourceFile, statement, defaultImportName && !allowSyntheticDefaults ? ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, defaultImportName, ts3.factory.createExternalModuleReference(required)) : ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, defaultImportName, namedImports), required, void 0));
        }
        function getInfo(sourceFile, program2, pos) {
          var parent = ts3.getTokenAtPosition(sourceFile, pos).parent;
          if (!ts3.isRequireCall(parent, true)) {
            throw ts3.Debug.failBadSyntaxKind(parent);
          }
          var decl = ts3.cast(parent.parent, ts3.isVariableDeclaration);
          var defaultImportName = ts3.tryCast(decl.name, ts3.isIdentifier);
          var namedImports = ts3.isObjectBindingPattern(decl.name) ? tryCreateNamedImportsFromObjectBindingPattern(decl.name) : void 0;
          if (defaultImportName || namedImports) {
            return {
              allowSyntheticDefaults: ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions()),
              defaultImportName,
              namedImports,
              statement: ts3.cast(decl.parent.parent, ts3.isVariableStatement),
              required: ts3.first(parent.arguments)
            };
          }
        }
        function tryCreateNamedImportsFromObjectBindingPattern(node) {
          var importSpecifiers = [];
          for (var _i = 0, _a = node.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (!ts3.isIdentifier(element.name) || element.initializer) {
              return void 0;
            }
            importSpecifiers.push(ts3.factory.createImportSpecifier(false, ts3.tryCast(element.propertyName, ts3.isIdentifier), element.name));
          }
          if (importSpecifiers.length) {
            return ts3.factory.createNamedImports(importSpecifiers);
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "useDefaultImport";
        var errorCodes = [ts3.Diagnostics.Import_may_be_converted_to_a_default_import.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, start = context.span.start;
            var info = getInfo(sourceFile, start);
            if (!info)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info, context.preferences);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_default_import, fixId, ts3.Diagnostics.Convert_all_to_default_imports)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info)
                doChange(changes, diag.file, info, context.preferences);
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var name = ts3.getTokenAtPosition(sourceFile, pos);
          if (!ts3.isIdentifier(name))
            return void 0;
          var parent = name.parent;
          if (ts3.isImportEqualsDeclaration(parent) && ts3.isExternalModuleReference(parent.moduleReference)) {
            return { importNode: parent, name, moduleSpecifier: parent.moduleReference.expression };
          } else if (ts3.isNamespaceImport(parent)) {
            var importNode = parent.parent.parent;
            return { importNode, name, moduleSpecifier: importNode.moduleSpecifier };
          }
        }
        function doChange(changes, sourceFile, info, preferences) {
          changes.replaceNode(sourceFile, info.importNode, ts3.makeImport(info.name, void 0, info.moduleSpecifier, ts3.getQuotePreference(sourceFile, preferences)));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "useBigintLiteral";
        var errorCodes = [
          ts3.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToUseBigintLiteral(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_a_bigint_numeric_literal, fixId, ts3.Diagnostics.Convert_all_to_bigint_numeric_literals)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, span) {
          var numericLiteral = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start), ts3.isNumericLiteral);
          if (!numericLiteral) {
            return;
          }
          var newText = numericLiteral.getText(sourceFile) + "n";
          changeTracker.replaceNode(sourceFile, numericLiteral, ts3.factory.createBigIntLiteral(newText));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdAddMissingTypeof = "fixAddModuleReferTypeMissingTypeof";
        var fixId = fixIdAddMissingTypeof;
        var errorCodes = [ts3.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToAddMissingTypeof(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var importType = getImportTypeNode(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, importType);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_typeof, fixId, ts3.Diagnostics.Add_missing_typeof)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, context.sourceFile, getImportTypeNode(diag.file, diag.start));
            });
          }
        });
        function getImportTypeNode(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          ts3.Debug.assert(token.kind === 100, "This token should be an ImportKeyword");
          ts3.Debug.assert(token.parent.kind === 200, "Token parent should be an ImportType");
          return token.parent;
        }
        function doChange(changes, sourceFile, importType) {
          var newTypeNode = ts3.factory.updateImportTypeNode(importType, importType.argument, importType.qualifier, importType.typeArguments, true);
          changes.replaceNode(sourceFile, importType, newTypeNode);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixID = "wrapJsxInFragment";
        var errorCodes = [ts3.Diagnostics.JSX_expressions_must_have_one_parent_element.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToWrapJsxInFragment(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var node = findNodeToFix(sourceFile, span.start);
            if (!node)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, node);
            });
            return [codefix2.createCodeFixAction(fixID, changes, ts3.Diagnostics.Wrap_in_JSX_fragment, fixID, ts3.Diagnostics.Wrap_all_unparented_JSX_in_JSX_fragment)];
          },
          fixIds: [fixID],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var node = findNodeToFix(context.sourceFile, diag.start);
              if (!node)
                return void 0;
              doChange(changes, context.sourceFile, node);
            });
          }
        });
        function findNodeToFix(sourceFile, pos) {
          var lessThanToken = ts3.getTokenAtPosition(sourceFile, pos);
          var firstJsxElementOrOpenElement = lessThanToken.parent;
          var binaryExpr = firstJsxElementOrOpenElement.parent;
          if (!ts3.isBinaryExpression(binaryExpr)) {
            binaryExpr = binaryExpr.parent;
            if (!ts3.isBinaryExpression(binaryExpr))
              return void 0;
          }
          if (!ts3.nodeIsMissing(binaryExpr.operatorToken))
            return void 0;
          return binaryExpr;
        }
        function doChange(changeTracker, sf, node) {
          var jsx = flattenInvalidBinaryExpr(node);
          if (jsx)
            changeTracker.replaceNode(sf, node, ts3.factory.createJsxFragment(ts3.factory.createJsxOpeningFragment(), jsx, ts3.factory.createJsxJsxClosingFragment()));
        }
        function flattenInvalidBinaryExpr(node) {
          var children = [];
          var current = node;
          while (true) {
            if (ts3.isBinaryExpression(current) && ts3.nodeIsMissing(current.operatorToken) && current.operatorToken.kind === 27) {
              children.push(current.left);
              if (ts3.isJsxChild(current.right)) {
                children.push(current.right);
                return children;
              } else if (ts3.isBinaryExpression(current.right)) {
                current = current.right;
                continue;
              } else
                return void 0;
            } else
              return void 0;
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixConvertToMappedObjectType";
        var errorCodes = [ts3.Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToConvertToMappedTypeObject(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var info = getInfo(sourceFile, span.start);
            if (!info)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            var name = ts3.idText(info.container.name);
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Convert_0_to_mapped_object_type, name], fixId, [ts3.Diagnostics.Convert_0_to_mapped_object_type, name])];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info)
                doChange(changes, diag.file, info);
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var indexSignature = ts3.tryCast(token.parent.parent, ts3.isIndexSignatureDeclaration);
          if (!indexSignature)
            return void 0;
          var container = ts3.isInterfaceDeclaration(indexSignature.parent) ? indexSignature.parent : ts3.tryCast(indexSignature.parent.parent, ts3.isTypeAliasDeclaration);
          if (!container)
            return void 0;
          return { indexSignature, container };
        }
        function createTypeAliasFromInterface(declaration, type2) {
          return ts3.factory.createTypeAliasDeclaration(declaration.decorators, declaration.modifiers, declaration.name, declaration.typeParameters, type2);
        }
        function doChange(changes, sourceFile, _a) {
          var indexSignature = _a.indexSignature, container = _a.container;
          var members = ts3.isInterfaceDeclaration(container) ? container.members : container.type.members;
          var otherMembers = members.filter(function(member) {
            return !ts3.isIndexSignatureDeclaration(member);
          });
          var parameter = ts3.first(indexSignature.parameters);
          var mappedTypeParameter = ts3.factory.createTypeParameterDeclaration(void 0, ts3.cast(parameter.name, ts3.isIdentifier), parameter.type);
          var mappedIntersectionType = ts3.factory.createMappedTypeNode(ts3.hasEffectiveReadonlyModifier(indexSignature) ? ts3.factory.createModifier(145) : void 0, mappedTypeParameter, void 0, indexSignature.questionToken, indexSignature.type, void 0);
          var intersectionType = ts3.factory.createIntersectionTypeNode(__spreadArray(__spreadArray(__spreadArray([], ts3.getAllSuperTypeNodes(container), true), [
            mappedIntersectionType
          ], false), otherMembers.length ? [ts3.factory.createTypeLiteralNode(otherMembers)] : ts3.emptyArray, true));
          changes.replaceNode(sourceFile, container, createTypeAliasFromInterface(container, intersectionType));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "removeAccidentalCallParentheses";
        var errorCodes = [
          ts3.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var callExpression = ts3.findAncestor(ts3.getTokenAtPosition(context.sourceFile, context.span.start), ts3.isCallExpression);
            if (!callExpression) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              t.deleteRange(context.sourceFile, { pos: callExpression.expression.end, end: callExpression.end });
            });
            return [codefix2.createCodeFixActionWithoutFixAll(fixId, changes, ts3.Diagnostics.Remove_parentheses)];
          },
          fixIds: [fixId]
        });
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "removeUnnecessaryAwait";
        var errorCodes = [
          ts3.Diagnostics.await_has_no_effect_on_the_type_of_this_expression.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToRemoveUnnecessaryAwait(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_unnecessary_await, fixId, ts3.Diagnostics.Remove_all_unnecessary_uses_of_await)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, span) {
          var awaitKeyword = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start), function(node) {
            return node.kind === 132;
          });
          var awaitExpression = awaitKeyword && ts3.tryCast(awaitKeyword.parent, ts3.isAwaitExpression);
          if (!awaitExpression) {
            return;
          }
          var expressionToReplace = awaitExpression;
          var hasSurroundingParens = ts3.isParenthesizedExpression(awaitExpression.parent);
          if (hasSurroundingParens) {
            var leftMostExpression = ts3.getLeftmostExpression(awaitExpression.expression, false);
            if (ts3.isIdentifier(leftMostExpression)) {
              var precedingToken = ts3.findPrecedingToken(awaitExpression.parent.pos, sourceFile);
              if (precedingToken && precedingToken.kind !== 103) {
                expressionToReplace = awaitExpression.parent;
              }
            }
          }
          changeTracker.replaceNode(sourceFile, expressionToReplace, awaitExpression.expression);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts3.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code];
        var fixId = "splitTypeOnlyImport";
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function getCodeActionsToSplitTypeOnlyImport(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return splitTypeOnlyImport(t, getImportDeclaration(context.sourceFile, context.span), context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Split_into_two_separate_import_declarations, fixId, ts3.Diagnostics.Split_all_invalid_type_only_imports)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, error) {
              splitTypeOnlyImport(changes, getImportDeclaration(context.sourceFile, error), context);
            });
          }
        });
        function getImportDeclaration(sourceFile, span) {
          return ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, span.start), ts3.isImportDeclaration);
        }
        function splitTypeOnlyImport(changes, importDeclaration, context) {
          if (!importDeclaration) {
            return;
          }
          var importClause = ts3.Debug.checkDefined(importDeclaration.importClause);
          changes.replaceNode(context.sourceFile, importDeclaration, ts3.factory.updateImportDeclaration(importDeclaration, importDeclaration.decorators, importDeclaration.modifiers, ts3.factory.updateImportClause(importClause, importClause.isTypeOnly, importClause.name, void 0), importDeclaration.moduleSpecifier, importDeclaration.assertClause));
          changes.insertNodeAfter(context.sourceFile, importDeclaration, ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.updateImportClause(importClause, importClause.isTypeOnly, void 0, importClause.namedBindings), importDeclaration.moduleSpecifier, importDeclaration.assertClause));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixConvertConstToLet";
        var errorCodes = [ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function getCodeActionsToConvertConstToLet(context) {
            var sourceFile = context.sourceFile, span = context.span, program2 = context.program;
            var range = getConstTokenRange(sourceFile, span.start, program2);
            if (range === void 0)
              return;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, range);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_const_to_let, fixId, ts3.Diagnostics.Convert_const_to_let)];
          },
          fixIds: [fixId]
        });
        function getConstTokenRange(sourceFile, pos, program2) {
          var _a;
          var checker = program2.getTypeChecker();
          var symbol = checker.getSymbolAtLocation(ts3.getTokenAtPosition(sourceFile, pos));
          var declaration = ts3.tryCast((_a = symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration) === null || _a === void 0 ? void 0 : _a.parent, ts3.isVariableDeclarationList);
          if (declaration === void 0)
            return;
          var constToken = ts3.findChildOfKind(declaration, 85, sourceFile);
          if (constToken === void 0)
            return;
          return ts3.createRange(constToken.pos, constToken.end);
        }
        function doChange(changes, sourceFile, range) {
          changes.replaceRangeWithText(sourceFile, range, "let");
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixExpectedComma";
        var expectedErrorCode = ts3.Diagnostics._0_expected.code;
        var errorCodes = [expectedErrorCode];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context.errorCode);
            if (!info)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Change_0_to_1, ";", ","], fixId, [ts3.Diagnostics.Change_0_to_1, ";", ","])];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, diag.code);
              if (info)
                doChange(changes, context.sourceFile, info);
            });
          }
        });
        function getInfo(sourceFile, pos, _) {
          var node = ts3.getTokenAtPosition(sourceFile, pos);
          return node.kind === 26 && node.parent && (ts3.isObjectLiteralExpression(node.parent) || ts3.isArrayLiteralExpression(node.parent)) ? { node } : void 0;
        }
        function doChange(changes, sourceFile, _a) {
          var node = _a.node;
          var newNode = ts3.factory.createToken(27);
          changes.replaceNode(sourceFile, node, newNode);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "addVoidToPromise";
        var fixId = "addVoidToPromise";
        var errorCodes = [
          ts3.Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments.code,
          ts3.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span, context.program);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixName, changes, ts3.Diagnostics.Add_void_to_Promise_resolved_without_a_value, fixId, ts3.Diagnostics.Add_void_to_all_Promises_resolved_without_a_value)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag, context.program, new ts3.Set());
            });
          }
        });
        function makeChange(changes, sourceFile, span, program2, seen) {
          var node = ts3.getTokenAtPosition(sourceFile, span.start);
          if (!ts3.isIdentifier(node) || !ts3.isCallExpression(node.parent) || node.parent.expression !== node || node.parent.arguments.length !== 0)
            return;
          var checker = program2.getTypeChecker();
          var symbol = checker.getSymbolAtLocation(node);
          var decl = symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration;
          if (!decl || !ts3.isParameter(decl) || !ts3.isNewExpression(decl.parent.parent))
            return;
          if (seen === null || seen === void 0 ? void 0 : seen.has(decl))
            return;
          seen === null || seen === void 0 ? void 0 : seen.add(decl);
          var typeArguments = getEffectiveTypeArguments(decl.parent.parent);
          if (ts3.some(typeArguments)) {
            var typeArgument = typeArguments[0];
            var needsParens = !ts3.isUnionTypeNode(typeArgument) && !ts3.isParenthesizedTypeNode(typeArgument) && ts3.isParenthesizedTypeNode(ts3.factory.createUnionTypeNode([typeArgument, ts3.factory.createKeywordTypeNode(114)]).types[0]);
            if (needsParens) {
              changes.insertText(sourceFile, typeArgument.pos, "(");
            }
            changes.insertText(sourceFile, typeArgument.end, needsParens ? ") | void" : " | void");
          } else {
            var signature = checker.getResolvedSignature(node.parent);
            var parameter = signature === null || signature === void 0 ? void 0 : signature.parameters[0];
            var parameterType = parameter && checker.getTypeOfSymbolAtLocation(parameter, decl.parent.parent);
            if (ts3.isInJSFile(decl)) {
              if (!parameterType || parameterType.flags & 3) {
                changes.insertText(sourceFile, decl.parent.parent.end, ")");
                changes.insertText(sourceFile, ts3.skipTrivia(sourceFile.text, decl.parent.parent.pos), "/** @type {Promise<void>} */(");
              }
            } else {
              if (!parameterType || parameterType.flags & 2) {
                changes.insertText(sourceFile, decl.parent.parent.expression.end, "<void>");
              }
            }
          }
        }
        function getEffectiveTypeArguments(node) {
          var _a;
          if (ts3.isInJSFile(node)) {
            if (ts3.isParenthesizedExpression(node.parent)) {
              var jsDocType = (_a = ts3.getJSDocTypeTag(node.parent)) === null || _a === void 0 ? void 0 : _a.typeExpression.type;
              if (jsDocType && ts3.isTypeReferenceNode(jsDocType) && ts3.isIdentifier(jsDocType.typeName) && ts3.idText(jsDocType.typeName) === "Promise") {
                return jsDocType.typeArguments;
              }
            }
          } else {
            return node.typeArguments;
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Convert export";
        var defaultToNamedAction = {
          name: "Convert default export to named export",
          description: ts3.Diagnostics.Convert_default_export_to_named_export.message,
          kind: "refactor.rewrite.export.named"
        };
        var namedToDefaultAction = {
          name: "Convert named export to default export",
          description: ts3.Diagnostics.Convert_named_export_to_default_export.message,
          kind: "refactor.rewrite.export.default"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [
            defaultToNamedAction.kind,
            namedToDefaultAction.kind
          ],
          getAvailableActions: function getRefactorActionsToConvertBetweenNamedAndDefaultExports(context) {
            var info = getInfo(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              var action = info.wasDefault ? defaultToNamedAction : namedToDefaultAction;
              return [{ name: refactorName, description: action.description, actions: [action] }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [
                { name: refactorName, description: ts3.Diagnostics.Convert_default_export_to_named_export.message, actions: [
                  __assign(__assign({}, defaultToNamedAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, namedToDefaultAction), { notApplicableReason: info.error })
                ] }
              ];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function getRefactorEditsToConvertBetweenNamedAndDefaultExports(context, actionName) {
            ts3.Debug.assert(actionName === defaultToNamedAction.name || actionName === namedToDefaultAction.name, "Unexpected action name");
            var info = getInfo(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program, info, t, context.cancellationToken);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        ;
        function getInfo(context, considerPartialSpans) {
          if (considerPartialSpans === void 0) {
            considerPartialSpans = true;
          }
          var file = context.file, program2 = context.program;
          var span = ts3.getRefactorContextSpan(context);
          var token = ts3.getTokenAtPosition(file, span.start);
          var exportNode = !!(token.parent && ts3.getSyntacticModifierFlags(token.parent) & 1) && considerPartialSpans ? token.parent : ts3.getParentNodeInSpan(token, file, span);
          if (!exportNode || !ts3.isSourceFile(exportNode.parent) && !(ts3.isModuleBlock(exportNode.parent) && ts3.isAmbientModule(exportNode.parent.parent))) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_export_statement) };
          }
          var exportingModuleSymbol = ts3.isSourceFile(exportNode.parent) ? exportNode.parent.symbol : exportNode.parent.parent.symbol;
          var flags = ts3.getSyntacticModifierFlags(exportNode) || (ts3.isExportAssignment(exportNode) && !exportNode.isExportEquals ? 513 : 0);
          var wasDefault = !!(flags & 512);
          if (!(flags & 1) || !wasDefault && exportingModuleSymbol.exports.has("default")) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.This_file_already_has_a_default_export) };
          }
          var checker = program2.getTypeChecker();
          var noSymbolError = function(id) {
            return ts3.isIdentifier(id) && checker.getSymbolAtLocation(id) ? void 0 : { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_named_export) };
          };
          switch (exportNode.kind) {
            case 256:
            case 257:
            case 258:
            case 260:
            case 259:
            case 261: {
              var node = exportNode;
              if (!node.name)
                return void 0;
              return noSymbolError(node.name) || { exportNode: node, exportName: node.name, wasDefault, exportingModuleSymbol };
            }
            case 237: {
              var vs = exportNode;
              if (!(vs.declarationList.flags & 2) || vs.declarationList.declarations.length !== 1) {
                return void 0;
              }
              var decl = ts3.first(vs.declarationList.declarations);
              if (!decl.initializer)
                return void 0;
              ts3.Debug.assert(!wasDefault, "Can't have a default flag here");
              return noSymbolError(decl.name) || { exportNode: vs, exportName: decl.name, wasDefault, exportingModuleSymbol };
            }
            case 271: {
              var node = exportNode;
              if (node.isExportEquals)
                return void 0;
              return noSymbolError(node.expression) || { exportNode: node, exportName: node.expression, wasDefault, exportingModuleSymbol };
            }
            default:
              return void 0;
          }
        }
        function doChange(exportingSourceFile, program2, info, changes, cancellationToken) {
          changeExport(exportingSourceFile, info, changes, program2.getTypeChecker());
          changeImports(program2, info, changes, cancellationToken);
        }
        function changeExport(exportingSourceFile, _a, changes, checker) {
          var wasDefault = _a.wasDefault, exportNode = _a.exportNode, exportName = _a.exportName;
          if (wasDefault) {
            if (ts3.isExportAssignment(exportNode) && !exportNode.isExportEquals) {
              var exp = exportNode.expression;
              var spec = makeExportSpecifier(exp.text, exp.text);
              changes.replaceNode(exportingSourceFile, exportNode, ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([spec])));
            } else {
              changes.delete(exportingSourceFile, ts3.Debug.checkDefined(ts3.findModifier(exportNode, 88), "Should find a default keyword in modifier list"));
            }
          } else {
            var exportKeyword = ts3.Debug.checkDefined(ts3.findModifier(exportNode, 93), "Should find an export keyword in modifier list");
            switch (exportNode.kind) {
              case 256:
              case 257:
              case 258:
                changes.insertNodeAfter(exportingSourceFile, exportKeyword, ts3.factory.createToken(88));
                break;
              case 237:
                var decl = ts3.first(exportNode.declarationList.declarations);
                if (!ts3.FindAllReferences.Core.isSymbolReferencedInFile(exportName, checker, exportingSourceFile) && !decl.type) {
                  changes.replaceNode(exportingSourceFile, exportNode, ts3.factory.createExportDefault(ts3.Debug.checkDefined(decl.initializer, "Initializer was previously known to be present")));
                  break;
                }
              case 260:
              case 259:
              case 261:
                changes.deleteModifier(exportingSourceFile, exportKeyword);
                changes.insertNodeAfter(exportingSourceFile, exportNode, ts3.factory.createExportDefault(ts3.factory.createIdentifier(exportName.text)));
                break;
              default:
                ts3.Debug.fail("Unexpected exportNode kind ".concat(exportNode.kind));
            }
          }
        }
        function changeImports(program2, _a, changes, cancellationToken) {
          var wasDefault = _a.wasDefault, exportName = _a.exportName, exportingModuleSymbol = _a.exportingModuleSymbol;
          var checker = program2.getTypeChecker();
          var exportSymbol = ts3.Debug.checkDefined(checker.getSymbolAtLocation(exportName), "Export name should resolve to a symbol");
          ts3.FindAllReferences.Core.eachExportReference(program2.getSourceFiles(), checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName.text, wasDefault, function(ref) {
            var importingSourceFile = ref.getSourceFile();
            if (wasDefault) {
              changeDefaultToNamedImport(importingSourceFile, ref, changes, exportName.text);
            } else {
              changeNamedToDefaultImport(importingSourceFile, ref, changes);
            }
          });
        }
        function changeDefaultToNamedImport(importingSourceFile, ref, changes, exportName) {
          var parent = ref.parent;
          switch (parent.kind) {
            case 206:
              changes.replaceNode(importingSourceFile, ref, ts3.factory.createIdentifier(exportName));
              break;
            case 270:
            case 275: {
              var spec = parent;
              changes.replaceNode(importingSourceFile, spec, makeImportSpecifier(exportName, spec.name.text));
              break;
            }
            case 267: {
              var clause = parent;
              ts3.Debug.assert(clause.name === ref, "Import clause name should match provided ref");
              var spec = makeImportSpecifier(exportName, ref.text);
              var namedBindings = clause.namedBindings;
              if (!namedBindings) {
                changes.replaceNode(importingSourceFile, ref, ts3.factory.createNamedImports([spec]));
              } else if (namedBindings.kind === 268) {
                changes.deleteRange(importingSourceFile, { pos: ref.getStart(importingSourceFile), end: namedBindings.getStart(importingSourceFile) });
                var quotePreference = ts3.isStringLiteral(clause.parent.moduleSpecifier) ? ts3.quotePreferenceFromString(clause.parent.moduleSpecifier, importingSourceFile) : 1;
                var newImport = ts3.makeImport(void 0, [makeImportSpecifier(exportName, ref.text)], clause.parent.moduleSpecifier, quotePreference);
                changes.insertNodeAfter(importingSourceFile, clause.parent, newImport);
              } else {
                changes.delete(importingSourceFile, ref);
                changes.insertNodeAtEndOfList(importingSourceFile, namedBindings.elements, spec);
              }
              break;
            }
            case 200:
              var importTypeNode = parent;
              changes.replaceNode(importingSourceFile, parent, ts3.factory.createImportTypeNode(importTypeNode.argument, ts3.factory.createIdentifier(exportName), importTypeNode.typeArguments, importTypeNode.isTypeOf));
              break;
            default:
              ts3.Debug.failBadSyntaxKind(parent);
          }
        }
        function changeNamedToDefaultImport(importingSourceFile, ref, changes) {
          var parent = ref.parent;
          switch (parent.kind) {
            case 206:
              changes.replaceNode(importingSourceFile, ref, ts3.factory.createIdentifier("default"));
              break;
            case 270: {
              var defaultImport = ts3.factory.createIdentifier(parent.name.text);
              if (parent.parent.elements.length === 1) {
                changes.replaceNode(importingSourceFile, parent.parent, defaultImport);
              } else {
                changes.delete(importingSourceFile, parent);
                changes.insertNodeBefore(importingSourceFile, parent.parent, defaultImport);
              }
              break;
            }
            case 275: {
              changes.replaceNode(importingSourceFile, parent, makeExportSpecifier("default", parent.name.text));
              break;
            }
            default:
              ts3.Debug.assertNever(parent, "Unexpected parent kind ".concat(parent.kind));
          }
        }
        function makeImportSpecifier(propertyName, name) {
          return ts3.factory.createImportSpecifier(false, propertyName === name ? void 0 : ts3.factory.createIdentifier(propertyName), ts3.factory.createIdentifier(name));
        }
        function makeExportSpecifier(propertyName, name) {
          return ts3.factory.createExportSpecifier(false, propertyName === name ? void 0 : ts3.factory.createIdentifier(propertyName), ts3.factory.createIdentifier(name));
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var _a;
        var refactorName = "Convert import";
        var actions2 = (_a = {}, _a[0] = {
          name: "Convert namespace import to named imports",
          description: ts3.Diagnostics.Convert_namespace_import_to_named_imports.message,
          kind: "refactor.rewrite.import.named"
        }, _a[2] = {
          name: "Convert named imports to namespace import",
          description: ts3.Diagnostics.Convert_named_imports_to_namespace_import.message,
          kind: "refactor.rewrite.import.namespace"
        }, _a[1] = {
          name: "Convert named imports to default import",
          description: ts3.Diagnostics.Convert_named_imports_to_default_import.message,
          kind: "refactor.rewrite.import.default"
        }, _a);
        refactor2.registerRefactor(refactorName, {
          kinds: ts3.getOwnValues(actions2).map(function(a) {
            return a.kind;
          }),
          getAvailableActions: function getRefactorActionsToConvertBetweenNamedAndNamespacedImports(context) {
            var info = getImportConversionInfo(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              var action = actions2[info.convertTo];
              return [{ name: refactorName, description: action.description, actions: [action] }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return ts3.getOwnValues(actions2).map(function(action2) {
                return {
                  name: refactorName,
                  description: action2.description,
                  actions: [__assign(__assign({}, action2), { notApplicableReason: info.error })]
                };
              });
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function getRefactorEditsToConvertBetweenNamedAndNamespacedImports(context, actionName) {
            ts3.Debug.assert(ts3.some(ts3.getOwnValues(actions2), function(action) {
              return action.name === actionName;
            }), "Unexpected action name");
            var info = getImportConversionInfo(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program, t, info);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getImportConversionInfo(context, considerPartialSpans) {
          if (considerPartialSpans === void 0) {
            considerPartialSpans = true;
          }
          var file = context.file;
          var span = ts3.getRefactorContextSpan(context);
          var token = ts3.getTokenAtPosition(file, span.start);
          var importDecl = considerPartialSpans ? ts3.findAncestor(token, ts3.isImportDeclaration) : ts3.getParentNodeInSpan(token, file, span);
          if (!importDecl || !ts3.isImportDeclaration(importDecl))
            return { error: "Selection is not an import declaration." };
          var end = span.start + span.length;
          var nextToken = ts3.findNextToken(importDecl, importDecl.parent, file);
          if (nextToken && end > nextToken.getStart())
            return void 0;
          var importClause = importDecl.importClause;
          if (!importClause) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_import_clause) };
          }
          if (!importClause.namedBindings) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_namespace_import_or_named_imports) };
          }
          if (importClause.namedBindings.kind === 268) {
            return { convertTo: 0, import: importClause.namedBindings };
          }
          var shouldUseDefault = getShouldUseDefault(context.program, importClause);
          return shouldUseDefault ? { convertTo: 1, import: importClause.namedBindings } : { convertTo: 2, import: importClause.namedBindings };
        }
        function getShouldUseDefault(program2, importClause) {
          return ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions()) && isExportEqualsModule(importClause.parent.moduleSpecifier, program2.getTypeChecker());
        }
        function doChange(sourceFile, program2, changes, info) {
          var checker = program2.getTypeChecker();
          if (info.convertTo === 0) {
            doChangeNamespaceToNamed(sourceFile, checker, changes, info.import, ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions()));
          } else {
            doChangeNamedToNamespaceOrDefault(sourceFile, program2, changes, info.import, info.convertTo === 1);
          }
        }
        function doChangeNamespaceToNamed(sourceFile, checker, changes, toConvert, allowSyntheticDefaultImports) {
          var usedAsNamespaceOrDefault = false;
          var nodesToReplace = [];
          var conflictingNames = new ts3.Map();
          ts3.FindAllReferences.Core.eachSymbolReferenceInFile(toConvert.name, checker, sourceFile, function(id) {
            if (!ts3.isPropertyAccessOrQualifiedName(id.parent)) {
              usedAsNamespaceOrDefault = true;
            } else {
              var exportName2 = getRightOfPropertyAccessOrQualifiedName(id.parent).text;
              if (checker.resolveName(exportName2, id, 67108863, true)) {
                conflictingNames.set(exportName2, true);
              }
              ts3.Debug.assert(getLeftOfPropertyAccessOrQualifiedName(id.parent) === id, "Parent expression should match id");
              nodesToReplace.push(id.parent);
            }
          });
          var exportNameToImportName = new ts3.Map();
          for (var _i = 0, nodesToReplace_1 = nodesToReplace; _i < nodesToReplace_1.length; _i++) {
            var propertyAccessOrQualifiedName = nodesToReplace_1[_i];
            var exportName = getRightOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName).text;
            var importName = exportNameToImportName.get(exportName);
            if (importName === void 0) {
              exportNameToImportName.set(exportName, importName = conflictingNames.has(exportName) ? ts3.getUniqueName(exportName, sourceFile) : exportName);
            }
            changes.replaceNode(sourceFile, propertyAccessOrQualifiedName, ts3.factory.createIdentifier(importName));
          }
          var importSpecifiers = [];
          exportNameToImportName.forEach(function(name, propertyName) {
            importSpecifiers.push(ts3.factory.createImportSpecifier(false, name === propertyName ? void 0 : ts3.factory.createIdentifier(propertyName), ts3.factory.createIdentifier(name)));
          });
          var importDecl = toConvert.parent.parent;
          if (usedAsNamespaceOrDefault && !allowSyntheticDefaultImports) {
            changes.insertNodeAfter(sourceFile, importDecl, updateImport(importDecl, void 0, importSpecifiers));
          } else {
            changes.replaceNode(sourceFile, importDecl, updateImport(importDecl, usedAsNamespaceOrDefault ? ts3.factory.createIdentifier(toConvert.name.text) : void 0, importSpecifiers));
          }
        }
        function getRightOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName) {
          return ts3.isPropertyAccessExpression(propertyAccessOrQualifiedName) ? propertyAccessOrQualifiedName.name : propertyAccessOrQualifiedName.right;
        }
        function getLeftOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName) {
          return ts3.isPropertyAccessExpression(propertyAccessOrQualifiedName) ? propertyAccessOrQualifiedName.expression : propertyAccessOrQualifiedName.left;
        }
        function doChangeNamedToNamespaceOrDefault(sourceFile, program2, changes, toConvert, shouldUseDefault) {
          if (shouldUseDefault === void 0) {
            shouldUseDefault = getShouldUseDefault(program2, toConvert.parent);
          }
          var checker = program2.getTypeChecker();
          var importDecl = toConvert.parent.parent;
          var moduleSpecifier = importDecl.moduleSpecifier;
          var toConvertSymbols = new ts3.Set();
          toConvert.elements.forEach(function(namedImport) {
            var symbol = checker.getSymbolAtLocation(namedImport.name);
            if (symbol) {
              toConvertSymbols.add(symbol);
            }
          });
          var preferredName = moduleSpecifier && ts3.isStringLiteral(moduleSpecifier) ? ts3.codefix.moduleSpecifierToValidIdentifier(moduleSpecifier.text, 99) : "module";
          function hasNamespaceNameConflict(namedImport) {
            return !!ts3.FindAllReferences.Core.eachSymbolReferenceInFile(namedImport.name, checker, sourceFile, function(id) {
              var symbol = checker.resolveName(preferredName, id, 67108863, true);
              if (symbol) {
                if (toConvertSymbols.has(symbol)) {
                  return ts3.isExportSpecifier(id.parent);
                }
                return true;
              }
              return false;
            });
          }
          var namespaceNameConflicts = toConvert.elements.some(hasNamespaceNameConflict);
          var namespaceImportName = namespaceNameConflicts ? ts3.getUniqueName(preferredName, sourceFile) : preferredName;
          var neededNamedImports = new ts3.Set();
          var _loop_17 = function(element2) {
            var propertyName = (element2.propertyName || element2.name).text;
            ts3.FindAllReferences.Core.eachSymbolReferenceInFile(element2.name, checker, sourceFile, function(id) {
              var access = ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier(namespaceImportName), propertyName);
              if (ts3.isShorthandPropertyAssignment(id.parent)) {
                changes.replaceNode(sourceFile, id.parent, ts3.factory.createPropertyAssignment(id.text, access));
              } else if (ts3.isExportSpecifier(id.parent)) {
                neededNamedImports.add(element2);
              } else {
                changes.replaceNode(sourceFile, id, access);
              }
            });
          };
          for (var _i = 0, _a2 = toConvert.elements; _i < _a2.length; _i++) {
            var element = _a2[_i];
            _loop_17(element);
          }
          changes.replaceNode(sourceFile, toConvert, shouldUseDefault ? ts3.factory.createIdentifier(namespaceImportName) : ts3.factory.createNamespaceImport(ts3.factory.createIdentifier(namespaceImportName)));
          if (neededNamedImports.size) {
            var newNamedImports = ts3.arrayFrom(neededNamedImports.values()).map(function(element2) {
              return ts3.factory.createImportSpecifier(element2.isTypeOnly, element2.propertyName && ts3.factory.createIdentifier(element2.propertyName.text), ts3.factory.createIdentifier(element2.name.text));
            });
            changes.insertNodeAfter(sourceFile, toConvert.parent.parent, updateImport(importDecl, void 0, newNamedImports));
          }
        }
        refactor2.doChangeNamedToNamespaceOrDefault = doChangeNamedToNamespaceOrDefault;
        function isExportEqualsModule(moduleSpecifier, checker) {
          var externalModule = checker.resolveExternalModuleName(moduleSpecifier);
          if (!externalModule)
            return false;
          var exportEquals = checker.resolveExternalModuleSymbol(externalModule);
          return externalModule !== exportEquals;
        }
        function updateImport(old, defaultImportName, elements) {
          return ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, defaultImportName, elements && elements.length ? ts3.factory.createNamedImports(elements) : void 0), old.moduleSpecifier, void 0);
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertToOptionalChainExpression;
        (function(convertToOptionalChainExpression2) {
          var refactorName = "Convert to optional chain expression";
          var convertToOptionalChainExpressionMessage = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_optional_chain_expression);
          var toOptionalChainAction = {
            name: refactorName,
            description: convertToOptionalChainExpressionMessage,
            kind: "refactor.rewrite.expression.optionalChain"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [toOptionalChainAction.kind],
            getEditsForAction: getRefactorEditsToConvertToOptionalChain,
            getAvailableActions: getRefactorActionsToConvertToOptionalChain
          });
          function getRefactorActionsToConvertToOptionalChain(context) {
            var info = getInfo(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: convertToOptionalChainExpressionMessage,
                actions: [toOptionalChainAction]
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: convertToOptionalChainExpressionMessage,
                actions: [__assign(__assign({}, toOptionalChainAction), { notApplicableReason: info.error })]
              }];
            }
            return ts3.emptyArray;
          }
          function getRefactorEditsToConvertToOptionalChain(context, actionName) {
            var info = getInfo(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program.getTypeChecker(), t, info, actionName);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
          ;
          function isValidExpression(node) {
            return ts3.isBinaryExpression(node) || ts3.isConditionalExpression(node);
          }
          function isValidStatement(node) {
            return ts3.isExpressionStatement(node) || ts3.isReturnStatement(node) || ts3.isVariableStatement(node);
          }
          function isValidExpressionOrStatement(node) {
            return isValidExpression(node) || isValidStatement(node);
          }
          function getInfo(context, considerEmptySpans) {
            if (considerEmptySpans === void 0) {
              considerEmptySpans = true;
            }
            var file = context.file, program2 = context.program;
            var span = ts3.getRefactorContextSpan(context);
            var forEmptySpan = span.length === 0;
            if (forEmptySpan && !considerEmptySpans)
              return void 0;
            var startToken = ts3.getTokenAtPosition(file, span.start);
            var endToken = ts3.findTokenOnLeftOfPosition(file, span.start + span.length);
            var adjustedSpan = ts3.createTextSpanFromBounds(startToken.pos, endToken && endToken.end >= startToken.pos ? endToken.getEnd() : startToken.getEnd());
            var parent = forEmptySpan ? getValidParentNodeOfEmptySpan(startToken) : getValidParentNodeContainingSpan(startToken, adjustedSpan);
            var expression = parent && isValidExpressionOrStatement(parent) ? getExpression(parent) : void 0;
            if (!expression)
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_convertible_access_expression) };
            var checker = program2.getTypeChecker();
            return ts3.isConditionalExpression(expression) ? getConditionalInfo(expression, checker) : getBinaryInfo(expression);
          }
          function getConditionalInfo(expression, checker) {
            var condition = expression.condition;
            var finalExpression = getFinalExpressionInChain(expression.whenTrue);
            if (!finalExpression || checker.isNullableType(checker.getTypeAtLocation(finalExpression))) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_convertible_access_expression) };
            }
            if ((ts3.isPropertyAccessExpression(condition) || ts3.isIdentifier(condition)) && getMatchingStart(condition, finalExpression.expression)) {
              return { finalExpression, occurrences: [condition], expression };
            } else if (ts3.isBinaryExpression(condition)) {
              var occurrences = getOccurrencesInExpression(finalExpression.expression, condition);
              return occurrences ? { finalExpression, occurrences, expression } : { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_matching_access_expressions) };
            }
          }
          function getBinaryInfo(expression) {
            if (expression.operatorToken.kind !== 55) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_logical_AND_access_chains) };
            }
            ;
            var finalExpression = getFinalExpressionInChain(expression.right);
            if (!finalExpression)
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_convertible_access_expression) };
            var occurrences = getOccurrencesInExpression(finalExpression.expression, expression.left);
            return occurrences ? { finalExpression, occurrences, expression } : { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_matching_access_expressions) };
          }
          function getOccurrencesInExpression(matchTo, expression) {
            var occurrences = [];
            while (ts3.isBinaryExpression(expression) && expression.operatorToken.kind === 55) {
              var match = getMatchingStart(ts3.skipParentheses(matchTo), ts3.skipParentheses(expression.right));
              if (!match) {
                break;
              }
              occurrences.push(match);
              matchTo = match;
              expression = expression.left;
            }
            var finalMatch = getMatchingStart(matchTo, expression);
            if (finalMatch) {
              occurrences.push(finalMatch);
            }
            return occurrences.length > 0 ? occurrences : void 0;
          }
          function getMatchingStart(chain, subchain) {
            if (!ts3.isIdentifier(subchain) && !ts3.isPropertyAccessExpression(subchain) && !ts3.isElementAccessExpression(subchain)) {
              return void 0;
            }
            return chainStartsWith(chain, subchain) ? subchain : void 0;
          }
          function chainStartsWith(chain, subchain) {
            while (ts3.isCallExpression(chain) || ts3.isPropertyAccessExpression(chain) || ts3.isElementAccessExpression(chain)) {
              if (getTextOfChainNode(chain) === getTextOfChainNode(subchain))
                break;
              chain = chain.expression;
            }
            while (ts3.isPropertyAccessExpression(chain) && ts3.isPropertyAccessExpression(subchain) || ts3.isElementAccessExpression(chain) && ts3.isElementAccessExpression(subchain)) {
              if (getTextOfChainNode(chain) !== getTextOfChainNode(subchain))
                return false;
              chain = chain.expression;
              subchain = subchain.expression;
            }
            return ts3.isIdentifier(chain) && ts3.isIdentifier(subchain) && chain.getText() === subchain.getText();
          }
          function getTextOfChainNode(node) {
            if (ts3.isIdentifier(node) || ts3.isStringOrNumericLiteralLike(node)) {
              return node.getText();
            }
            if (ts3.isPropertyAccessExpression(node)) {
              return getTextOfChainNode(node.name);
            }
            if (ts3.isElementAccessExpression(node)) {
              return getTextOfChainNode(node.argumentExpression);
            }
            return void 0;
          }
          function getValidParentNodeContainingSpan(node, span) {
            while (node.parent) {
              if (isValidExpressionOrStatement(node) && span.length !== 0 && node.end >= span.start + span.length) {
                return node;
              }
              node = node.parent;
            }
            return void 0;
          }
          function getValidParentNodeOfEmptySpan(node) {
            while (node.parent) {
              if (isValidExpressionOrStatement(node) && !isValidExpressionOrStatement(node.parent)) {
                return node;
              }
              node = node.parent;
            }
            return void 0;
          }
          function getExpression(node) {
            if (isValidExpression(node)) {
              return node;
            }
            if (ts3.isVariableStatement(node)) {
              var variable = ts3.getSingleVariableOfVariableStatement(node);
              var initializer = variable === null || variable === void 0 ? void 0 : variable.initializer;
              return initializer && isValidExpression(initializer) ? initializer : void 0;
            }
            return node.expression && isValidExpression(node.expression) ? node.expression : void 0;
          }
          function getFinalExpressionInChain(node) {
            node = ts3.skipParentheses(node);
            if (ts3.isBinaryExpression(node)) {
              return getFinalExpressionInChain(node.left);
            } else if ((ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node) || ts3.isCallExpression(node)) && !ts3.isOptionalChain(node)) {
              return node;
            }
            return void 0;
          }
          function convertOccurrences(checker, toConvert, occurrences) {
            if (ts3.isPropertyAccessExpression(toConvert) || ts3.isElementAccessExpression(toConvert) || ts3.isCallExpression(toConvert)) {
              var chain = convertOccurrences(checker, toConvert.expression, occurrences);
              var lastOccurrence = occurrences.length > 0 ? occurrences[occurrences.length - 1] : void 0;
              var isOccurrence = (lastOccurrence === null || lastOccurrence === void 0 ? void 0 : lastOccurrence.getText()) === toConvert.expression.getText();
              if (isOccurrence)
                occurrences.pop();
              if (ts3.isCallExpression(toConvert)) {
                return isOccurrence ? ts3.factory.createCallChain(chain, ts3.factory.createToken(28), toConvert.typeArguments, toConvert.arguments) : ts3.factory.createCallChain(chain, toConvert.questionDotToken, toConvert.typeArguments, toConvert.arguments);
              } else if (ts3.isPropertyAccessExpression(toConvert)) {
                return isOccurrence ? ts3.factory.createPropertyAccessChain(chain, ts3.factory.createToken(28), toConvert.name) : ts3.factory.createPropertyAccessChain(chain, toConvert.questionDotToken, toConvert.name);
              } else if (ts3.isElementAccessExpression(toConvert)) {
                return isOccurrence ? ts3.factory.createElementAccessChain(chain, ts3.factory.createToken(28), toConvert.argumentExpression) : ts3.factory.createElementAccessChain(chain, toConvert.questionDotToken, toConvert.argumentExpression);
              }
            }
            return toConvert;
          }
          function doChange(sourceFile, checker, changes, info, _actionName) {
            var finalExpression = info.finalExpression, occurrences = info.occurrences, expression = info.expression;
            var firstOccurrence = occurrences[occurrences.length - 1];
            var convertedChain = convertOccurrences(checker, finalExpression, occurrences);
            if (convertedChain && (ts3.isPropertyAccessExpression(convertedChain) || ts3.isElementAccessExpression(convertedChain) || ts3.isCallExpression(convertedChain))) {
              if (ts3.isBinaryExpression(expression)) {
                changes.replaceNodeRange(sourceFile, firstOccurrence, finalExpression, convertedChain);
              } else if (ts3.isConditionalExpression(expression)) {
                changes.replaceNode(sourceFile, expression, ts3.factory.createBinaryExpression(convertedChain, ts3.factory.createToken(60), expression.whenFalse));
              }
            }
          }
        })(convertToOptionalChainExpression = refactor2.convertToOptionalChainExpression || (refactor2.convertToOptionalChainExpression = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var addOrRemoveBracesToArrowFunction;
        (function(addOrRemoveBracesToArrowFunction2) {
          var refactorName = "Convert overload list to single signature";
          var refactorDescription = ts3.Diagnostics.Convert_overload_list_to_single_signature.message;
          var functionOverloadAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.function.overloadList"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [functionOverloadAction.kind],
            getEditsForAction: getRefactorEditsToConvertOverloadsToOneSignature,
            getAvailableActions: getRefactorActionsToConvertOverloadsToOneSignature
          });
          function getRefactorActionsToConvertOverloadsToOneSignature(context) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program;
            var info = getConvertableOverloadListAtPosition(file, startPosition, program2);
            if (!info)
              return ts3.emptyArray;
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: [functionOverloadAction]
            }];
          }
          function getRefactorEditsToConvertOverloadsToOneSignature(context) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program;
            var signatureDecls = getConvertableOverloadListAtPosition(file, startPosition, program2);
            if (!signatureDecls)
              return void 0;
            var checker = program2.getTypeChecker();
            var lastDeclaration = signatureDecls[signatureDecls.length - 1];
            var updated = lastDeclaration;
            switch (lastDeclaration.kind) {
              case 168: {
                updated = ts3.factory.updateMethodSignature(lastDeclaration, lastDeclaration.modifiers, lastDeclaration.name, lastDeclaration.questionToken, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type);
                break;
              }
              case 169: {
                updated = ts3.factory.updateMethodDeclaration(lastDeclaration, lastDeclaration.decorators, lastDeclaration.modifiers, lastDeclaration.asteriskToken, lastDeclaration.name, lastDeclaration.questionToken, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type, lastDeclaration.body);
                break;
              }
              case 174: {
                updated = ts3.factory.updateCallSignature(lastDeclaration, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type);
                break;
              }
              case 171: {
                updated = ts3.factory.updateConstructorDeclaration(lastDeclaration, lastDeclaration.decorators, lastDeclaration.modifiers, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.body);
                break;
              }
              case 175: {
                updated = ts3.factory.updateConstructSignature(lastDeclaration, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type);
                break;
              }
              case 256: {
                updated = ts3.factory.updateFunctionDeclaration(lastDeclaration, lastDeclaration.decorators, lastDeclaration.modifiers, lastDeclaration.asteriskToken, lastDeclaration.name, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type, lastDeclaration.body);
                break;
              }
              default:
                return ts3.Debug.failBadSyntaxKind(lastDeclaration, "Unhandled signature kind in overload list conversion refactoring");
            }
            if (updated === lastDeclaration) {
              return;
            }
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
              t.replaceNodeRange(file, signatureDecls[0], signatureDecls[signatureDecls.length - 1], updated);
            });
            return { renameFilename: void 0, renameLocation: void 0, edits };
            function getNewParametersForCombinedSignature(signatureDeclarations) {
              var lastSig = signatureDeclarations[signatureDeclarations.length - 1];
              if (ts3.isFunctionLikeDeclaration(lastSig) && lastSig.body) {
                signatureDeclarations = signatureDeclarations.slice(0, signatureDeclarations.length - 1);
              }
              return ts3.factory.createNodeArray([
                ts3.factory.createParameterDeclaration(void 0, void 0, ts3.factory.createToken(25), "args", void 0, ts3.factory.createUnionTypeNode(ts3.map(signatureDeclarations, convertSignatureParametersToTuple)))
              ]);
            }
            function convertSignatureParametersToTuple(decl) {
              var members = ts3.map(decl.parameters, convertParameterToNamedTupleMember);
              return ts3.setEmitFlags(ts3.factory.createTupleTypeNode(members), ts3.some(members, function(m) {
                return !!ts3.length(ts3.getSyntheticLeadingComments(m));
              }) ? 0 : 1);
            }
            function convertParameterToNamedTupleMember(p) {
              ts3.Debug.assert(ts3.isIdentifier(p.name));
              var result2 = ts3.setTextRange(ts3.factory.createNamedTupleMember(p.dotDotDotToken, p.name, p.questionToken, p.type || ts3.factory.createKeywordTypeNode(130)), p);
              var parameterDocComment = p.symbol && p.symbol.getDocumentationComment(checker);
              if (parameterDocComment) {
                var newComment = ts3.displayPartsToString(parameterDocComment);
                if (newComment.length) {
                  ts3.setSyntheticLeadingComments(result2, [{
                    text: "*\n".concat(newComment.split("\n").map(function(c) {
                      return " * ".concat(c);
                    }).join("\n"), "\n "),
                    kind: 3,
                    pos: -1,
                    end: -1,
                    hasTrailingNewLine: true,
                    hasLeadingNewline: true
                  }]);
                }
              }
              return result2;
            }
          }
          function isConvertableSignatureDeclaration(d) {
            switch (d.kind) {
              case 168:
              case 169:
              case 174:
              case 171:
              case 175:
              case 256:
                return true;
            }
            return false;
          }
          function getConvertableOverloadListAtPosition(file, startPosition, program2) {
            var node = ts3.getTokenAtPosition(file, startPosition);
            var containingDecl = ts3.findAncestor(node, isConvertableSignatureDeclaration);
            if (!containingDecl) {
              return;
            }
            var checker = program2.getTypeChecker();
            var signatureSymbol = containingDecl.symbol;
            if (!signatureSymbol) {
              return;
            }
            var decls = signatureSymbol.declarations;
            if (ts3.length(decls) <= 1) {
              return;
            }
            if (!ts3.every(decls, function(d) {
              return ts3.getSourceFileOfNode(d) === file;
            })) {
              return;
            }
            if (!isConvertableSignatureDeclaration(decls[0])) {
              return;
            }
            var kindOne = decls[0].kind;
            if (!ts3.every(decls, function(d) {
              return d.kind === kindOne;
            })) {
              return;
            }
            var signatureDecls = decls;
            if (ts3.some(signatureDecls, function(d) {
              return !!d.typeParameters || ts3.some(d.parameters, function(p) {
                return !!p.decorators || !!p.modifiers || !ts3.isIdentifier(p.name);
              });
            })) {
              return;
            }
            var signatures = ts3.mapDefined(signatureDecls, function(d) {
              return checker.getSignatureFromDeclaration(d);
            });
            if (ts3.length(signatures) !== ts3.length(decls)) {
              return;
            }
            var returnOne = checker.getReturnTypeOfSignature(signatures[0]);
            if (!ts3.every(signatures, function(s) {
              return checker.getReturnTypeOfSignature(s) === returnOne;
            })) {
              return;
            }
            return signatureDecls;
          }
        })(addOrRemoveBracesToArrowFunction = refactor2.addOrRemoveBracesToArrowFunction || (refactor2.addOrRemoveBracesToArrowFunction = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var extractSymbol;
        (function(extractSymbol2) {
          var refactorName = "Extract Symbol";
          var extractConstantAction = {
            name: "Extract Constant",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_constant),
            kind: "refactor.extract.constant"
          };
          var extractFunctionAction = {
            name: "Extract Function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_function),
            kind: "refactor.extract.function"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [
              extractConstantAction.kind,
              extractFunctionAction.kind
            ],
            getEditsForAction: getRefactorEditsToExtractSymbol,
            getAvailableActions: getRefactorActionsToExtractSymbol
          });
          function getRefactorActionsToExtractSymbol(context) {
            var requestedRefactor = context.kind;
            var rangeToExtract = getRangeToExtract(context.file, ts3.getRefactorContextSpan(context), context.triggerReason === "invoked");
            var targetRange = rangeToExtract.targetRange;
            if (targetRange === void 0) {
              if (!rangeToExtract.errors || rangeToExtract.errors.length === 0 || !context.preferences.provideRefactorNotApplicableReason) {
                return ts3.emptyArray;
              }
              var errors = [];
              if (refactor2.refactorKindBeginsWith(extractFunctionAction.kind, requestedRefactor)) {
                errors.push({
                  name: refactorName,
                  description: extractFunctionAction.description,
                  actions: [__assign(__assign({}, extractFunctionAction), { notApplicableReason: getStringError(rangeToExtract.errors) })]
                });
              }
              if (refactor2.refactorKindBeginsWith(extractConstantAction.kind, requestedRefactor)) {
                errors.push({
                  name: refactorName,
                  description: extractConstantAction.description,
                  actions: [__assign(__assign({}, extractConstantAction), { notApplicableReason: getStringError(rangeToExtract.errors) })]
                });
              }
              return errors;
            }
            var extractions = getPossibleExtractions(targetRange, context);
            if (extractions === void 0) {
              return ts3.emptyArray;
            }
            var functionActions = [];
            var usedFunctionNames = new ts3.Map();
            var innermostErrorFunctionAction;
            var constantActions = [];
            var usedConstantNames = new ts3.Map();
            var innermostErrorConstantAction;
            var i = 0;
            for (var _i = 0, extractions_1 = extractions; _i < extractions_1.length; _i++) {
              var _a = extractions_1[_i], functionExtraction = _a.functionExtraction, constantExtraction = _a.constantExtraction;
              var description = functionExtraction.description;
              if (refactor2.refactorKindBeginsWith(extractFunctionAction.kind, requestedRefactor)) {
                if (functionExtraction.errors.length === 0) {
                  if (!usedFunctionNames.has(description)) {
                    usedFunctionNames.set(description, true);
                    functionActions.push({
                      description,
                      name: "function_scope_".concat(i),
                      kind: extractFunctionAction.kind
                    });
                  }
                } else if (!innermostErrorFunctionAction) {
                  innermostErrorFunctionAction = {
                    description,
                    name: "function_scope_".concat(i),
                    notApplicableReason: getStringError(functionExtraction.errors),
                    kind: extractFunctionAction.kind
                  };
                }
              }
              if (refactor2.refactorKindBeginsWith(extractConstantAction.kind, requestedRefactor)) {
                if (constantExtraction.errors.length === 0) {
                  var description_1 = constantExtraction.description;
                  if (!usedConstantNames.has(description_1)) {
                    usedConstantNames.set(description_1, true);
                    constantActions.push({
                      description: description_1,
                      name: "constant_scope_".concat(i),
                      kind: extractConstantAction.kind
                    });
                  }
                } else if (!innermostErrorConstantAction) {
                  innermostErrorConstantAction = {
                    description,
                    name: "constant_scope_".concat(i),
                    notApplicableReason: getStringError(constantExtraction.errors),
                    kind: extractConstantAction.kind
                  };
                }
              }
              i++;
            }
            var infos = [];
            if (functionActions.length) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_function),
                actions: functionActions
              });
            } else if (context.preferences.provideRefactorNotApplicableReason && innermostErrorFunctionAction) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_function),
                actions: [innermostErrorFunctionAction]
              });
            }
            if (constantActions.length) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_constant),
                actions: constantActions
              });
            } else if (context.preferences.provideRefactorNotApplicableReason && innermostErrorConstantAction) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_constant),
                actions: [innermostErrorConstantAction]
              });
            }
            return infos.length ? infos : ts3.emptyArray;
            function getStringError(errors2) {
              var error = errors2[0].messageText;
              if (typeof error !== "string") {
                error = error.messageText;
              }
              return error;
            }
          }
          extractSymbol2.getRefactorActionsToExtractSymbol = getRefactorActionsToExtractSymbol;
          function getRefactorEditsToExtractSymbol(context, actionName) {
            var rangeToExtract = getRangeToExtract(context.file, ts3.getRefactorContextSpan(context));
            var targetRange = rangeToExtract.targetRange;
            var parsedFunctionIndexMatch = /^function_scope_(\d+)$/.exec(actionName);
            if (parsedFunctionIndexMatch) {
              var index = +parsedFunctionIndexMatch[1];
              ts3.Debug.assert(isFinite(index), "Expected to parse a finite number from the function scope index");
              return getFunctionExtractionAtIndex(targetRange, context, index);
            }
            var parsedConstantIndexMatch = /^constant_scope_(\d+)$/.exec(actionName);
            if (parsedConstantIndexMatch) {
              var index = +parsedConstantIndexMatch[1];
              ts3.Debug.assert(isFinite(index), "Expected to parse a finite number from the constant scope index");
              return getConstantExtractionAtIndex(targetRange, context, index);
            }
            ts3.Debug.fail("Unrecognized action name");
          }
          extractSymbol2.getRefactorEditsToExtractSymbol = getRefactorEditsToExtractSymbol;
          var Messages;
          (function(Messages2) {
            function createMessage(message) {
              return { message, code: 0, category: ts3.DiagnosticCategory.Message, key: message };
            }
            Messages2.cannotExtractRange = createMessage("Cannot extract range.");
            Messages2.cannotExtractImport = createMessage("Cannot extract import statement.");
            Messages2.cannotExtractSuper = createMessage("Cannot extract super call.");
            Messages2.cannotExtractJSDoc = createMessage("Cannot extract JSDoc.");
            Messages2.cannotExtractEmpty = createMessage("Cannot extract empty range.");
            Messages2.expressionExpected = createMessage("expression expected.");
            Messages2.uselessConstantType = createMessage("No reason to extract constant of type.");
            Messages2.statementOrExpressionExpected = createMessage("Statement or expression expected.");
            Messages2.cannotExtractRangeContainingConditionalBreakOrContinueStatements = createMessage("Cannot extract range containing conditional break or continue statements.");
            Messages2.cannotExtractRangeContainingConditionalReturnStatement = createMessage("Cannot extract range containing conditional return statement.");
            Messages2.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange = createMessage("Cannot extract range containing labeled break or continue with target outside of the range.");
            Messages2.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators = createMessage("Cannot extract range containing writes to references located outside of the target range in generators.");
            Messages2.typeWillNotBeVisibleInTheNewScope = createMessage("Type will not visible in the new scope.");
            Messages2.functionWillNotBeVisibleInTheNewScope = createMessage("Function will not visible in the new scope.");
            Messages2.cannotExtractIdentifier = createMessage("Select more than a single identifier.");
            Messages2.cannotExtractExportedEntity = createMessage("Cannot extract exported declaration");
            Messages2.cannotWriteInExpression = createMessage("Cannot write back side-effects when extracting an expression");
            Messages2.cannotExtractReadonlyPropertyInitializerOutsideConstructor = createMessage("Cannot move initialization of read-only class property outside of the constructor");
            Messages2.cannotExtractAmbientBlock = createMessage("Cannot extract code from ambient contexts");
            Messages2.cannotAccessVariablesFromNestedScopes = createMessage("Cannot access variables from nested scopes");
            Messages2.cannotExtractToJSClass = createMessage("Cannot extract constant to a class scope in JS");
            Messages2.cannotExtractToExpressionArrowFunction = createMessage("Cannot extract constant to an arrow function without a block");
            Messages2.cannotExtractFunctionsContainingThisToMethod = createMessage("Cannot extract functions containing this to method");
          })(Messages = extractSymbol2.Messages || (extractSymbol2.Messages = {}));
          var RangeFacts;
          (function(RangeFacts2) {
            RangeFacts2[RangeFacts2["None"] = 0] = "None";
            RangeFacts2[RangeFacts2["HasReturn"] = 1] = "HasReturn";
            RangeFacts2[RangeFacts2["IsGenerator"] = 2] = "IsGenerator";
            RangeFacts2[RangeFacts2["IsAsyncFunction"] = 4] = "IsAsyncFunction";
            RangeFacts2[RangeFacts2["UsesThis"] = 8] = "UsesThis";
            RangeFacts2[RangeFacts2["UsesThisInFunction"] = 16] = "UsesThisInFunction";
            RangeFacts2[RangeFacts2["InStaticRegion"] = 32] = "InStaticRegion";
          })(RangeFacts || (RangeFacts = {}));
          function getRangeToExtract(sourceFile, span, invoked) {
            if (invoked === void 0) {
              invoked = true;
            }
            var length = span.length;
            if (length === 0 && !invoked) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractEmpty)] };
            }
            var cursorRequest = length === 0 && invoked;
            var startToken = ts3.findFirstNonJsxWhitespaceToken(sourceFile, span.start);
            var endToken = ts3.findTokenOnLeftOfPosition(sourceFile, ts3.textSpanEnd(span));
            var adjustedSpan = startToken && endToken && invoked ? getAdjustedSpanFromNodes(startToken, endToken, sourceFile) : span;
            var start = cursorRequest ? getExtractableParent(startToken) : ts3.getParentNodeInSpan(startToken, sourceFile, adjustedSpan);
            var end = cursorRequest ? start : ts3.getParentNodeInSpan(endToken, sourceFile, adjustedSpan);
            var declarations = [];
            var rangeFacts = RangeFacts.None;
            var thisNode;
            if (!start || !end) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            if (start.flags & 8388608) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractJSDoc)] };
            }
            if (start.parent !== end.parent) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            if (start !== end) {
              if (!isBlockLike(start.parent)) {
                return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
              }
              var statements = [];
              for (var _i = 0, _a = start.parent.statements; _i < _a.length; _i++) {
                var statement = _a[_i];
                if (statement === start || statements.length) {
                  var errors_1 = checkNode(statement);
                  if (errors_1) {
                    return { errors: errors_1 };
                  }
                  statements.push(statement);
                }
                if (statement === end) {
                  break;
                }
              }
              if (!statements.length) {
                return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
              }
              return { targetRange: { range: statements, facts: rangeFacts, declarations, thisNode } };
            }
            if (ts3.isReturnStatement(start) && !start.expression) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            var node = refineNode(start);
            var errors = checkRootNode(node) || checkNode(node);
            if (errors) {
              return { errors };
            }
            return { targetRange: { range: getStatementOrExpressionRange(node), facts: rangeFacts, declarations, thisNode } };
            function refineNode(node2) {
              if (ts3.isReturnStatement(node2)) {
                if (node2.expression) {
                  return node2.expression;
                }
              } else if (ts3.isVariableStatement(node2) || ts3.isVariableDeclarationList(node2)) {
                var declarations_5 = ts3.isVariableStatement(node2) ? node2.declarationList.declarations : node2.declarations;
                var numInitializers = 0;
                var lastInitializer = void 0;
                for (var _i2 = 0, declarations_4 = declarations_5; _i2 < declarations_4.length; _i2++) {
                  var declaration = declarations_4[_i2];
                  if (declaration.initializer) {
                    numInitializers++;
                    lastInitializer = declaration.initializer;
                  }
                }
                if (numInitializers === 1) {
                  return lastInitializer;
                }
              } else if (ts3.isVariableDeclaration(node2)) {
                if (node2.initializer) {
                  return node2.initializer;
                }
              }
              return node2;
            }
            function checkRootNode(node2) {
              if (ts3.isIdentifier(ts3.isExpressionStatement(node2) ? node2.expression : node2)) {
                return [ts3.createDiagnosticForNode(node2, Messages.cannotExtractIdentifier)];
              }
              return void 0;
            }
            function checkForStaticContext(nodeToCheck, containingClass) {
              var current = nodeToCheck;
              while (current !== containingClass) {
                if (current.kind === 167) {
                  if (ts3.isStatic(current)) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                  break;
                } else if (current.kind === 164) {
                  var ctorOrMethod = ts3.getContainingFunction(current);
                  if (ctorOrMethod.kind === 171) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                  break;
                } else if (current.kind === 169) {
                  if (ts3.isStatic(current)) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                }
                current = current.parent;
              }
            }
            function checkNode(nodeToCheck) {
              var PermittedJumps;
              (function(PermittedJumps2) {
                PermittedJumps2[PermittedJumps2["None"] = 0] = "None";
                PermittedJumps2[PermittedJumps2["Break"] = 1] = "Break";
                PermittedJumps2[PermittedJumps2["Continue"] = 2] = "Continue";
                PermittedJumps2[PermittedJumps2["Return"] = 4] = "Return";
              })(PermittedJumps || (PermittedJumps = {}));
              ts3.Debug.assert(nodeToCheck.pos <= nodeToCheck.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)");
              ts3.Debug.assert(!ts3.positionIsSynthesized(nodeToCheck.pos), "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)");
              if (!ts3.isStatement(nodeToCheck) && !(ts3.isExpressionNode(nodeToCheck) && isExtractableExpression(nodeToCheck)) && !isStringLiteralJsxAttribute(nodeToCheck)) {
                return [ts3.createDiagnosticForNode(nodeToCheck, Messages.statementOrExpressionExpected)];
              }
              if (nodeToCheck.flags & 16777216) {
                return [ts3.createDiagnosticForNode(nodeToCheck, Messages.cannotExtractAmbientBlock)];
              }
              var containingClass = ts3.getContainingClass(nodeToCheck);
              if (containingClass) {
                checkForStaticContext(nodeToCheck, containingClass);
              }
              var errors2;
              var permittedJumps = 4;
              var seenLabels;
              visit(nodeToCheck);
              if (rangeFacts & RangeFacts.UsesThis) {
                var container = ts3.getThisContainer(nodeToCheck, false);
                if (container.kind === 256 || container.kind === 169 && container.parent.kind === 205 || container.kind === 213) {
                  rangeFacts |= RangeFacts.UsesThisInFunction;
                }
              }
              return errors2;
              function visit(node2) {
                if (errors2) {
                  return true;
                }
                if (ts3.isDeclaration(node2)) {
                  var declaringNode = node2.kind === 254 ? node2.parent.parent : node2;
                  if (ts3.hasSyntacticModifier(declaringNode, 1)) {
                    (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
                    return true;
                  }
                  declarations.push(node2.symbol);
                }
                switch (node2.kind) {
                  case 266:
                    (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractImport));
                    return true;
                  case 271:
                    (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
                    return true;
                  case 106:
                    if (node2.parent.kind === 208) {
                      var containingClass_1 = ts3.getContainingClass(node2);
                      if (containingClass_1 === void 0 || containingClass_1.pos < span.start || containingClass_1.end >= span.start + span.length) {
                        (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractSuper));
                        return true;
                      }
                    } else {
                      rangeFacts |= RangeFacts.UsesThis;
                      thisNode = node2;
                    }
                    break;
                  case 214:
                    ts3.forEachChild(node2, function check(n) {
                      if (ts3.isThis(n)) {
                        rangeFacts |= RangeFacts.UsesThis;
                        thisNode = node2;
                      } else if (ts3.isClassLike(n) || ts3.isFunctionLike(n) && !ts3.isArrowFunction(n)) {
                        return false;
                      } else {
                        ts3.forEachChild(n, check);
                      }
                    });
                  case 257:
                  case 256:
                    if (ts3.isSourceFile(node2.parent) && node2.parent.externalModuleIndicator === void 0) {
                      (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.functionWillNotBeVisibleInTheNewScope));
                    }
                  case 226:
                  case 213:
                  case 169:
                  case 171:
                  case 172:
                  case 173:
                    return false;
                }
                var savedPermittedJumps = permittedJumps;
                switch (node2.kind) {
                  case 239:
                    permittedJumps = 0;
                    break;
                  case 252:
                    permittedJumps = 0;
                    break;
                  case 235:
                    if (node2.parent && node2.parent.kind === 252 && node2.parent.finallyBlock === node2) {
                      permittedJumps = 4;
                    }
                    break;
                  case 290:
                  case 289:
                    permittedJumps |= 1;
                    break;
                  default:
                    if (ts3.isIterationStatement(node2, false)) {
                      permittedJumps |= 1 | 2;
                    }
                    break;
                }
                switch (node2.kind) {
                  case 192:
                  case 108:
                    rangeFacts |= RangeFacts.UsesThis;
                    thisNode = node2;
                    break;
                  case 250: {
                    var label = node2.label;
                    (seenLabels || (seenLabels = [])).push(label.escapedText);
                    ts3.forEachChild(node2, visit);
                    seenLabels.pop();
                    break;
                  }
                  case 246:
                  case 245: {
                    var label = node2.label;
                    if (label) {
                      if (!ts3.contains(seenLabels, label.escapedText)) {
                        (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange));
                      }
                    } else {
                      if (!(permittedJumps & (node2.kind === 246 ? 1 : 2))) {
                        (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalBreakOrContinueStatements));
                      }
                    }
                    break;
                  }
                  case 218:
                    rangeFacts |= RangeFacts.IsAsyncFunction;
                    break;
                  case 224:
                    rangeFacts |= RangeFacts.IsGenerator;
                    break;
                  case 247:
                    if (permittedJumps & 4) {
                      rangeFacts |= RangeFacts.HasReturn;
                    } else {
                      (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalReturnStatement));
                    }
                    break;
                  default:
                    ts3.forEachChild(node2, visit);
                    break;
                }
                permittedJumps = savedPermittedJumps;
              }
            }
          }
          extractSymbol2.getRangeToExtract = getRangeToExtract;
          function getAdjustedSpanFromNodes(startNode, endNode, sourceFile) {
            var start = startNode.getStart(sourceFile);
            var end = endNode.getEnd();
            if (sourceFile.text.charCodeAt(end) === 59) {
              end++;
            }
            return { start, length: end - start };
          }
          function getStatementOrExpressionRange(node) {
            if (ts3.isStatement(node)) {
              return [node];
            }
            if (ts3.isExpressionNode(node)) {
              return ts3.isExpressionStatement(node.parent) ? [node.parent] : node;
            }
            if (isStringLiteralJsxAttribute(node)) {
              return node;
            }
            return void 0;
          }
          function isScope(node) {
            return ts3.isArrowFunction(node) ? ts3.isFunctionBody(node.body) : ts3.isFunctionLikeDeclaration(node) || ts3.isSourceFile(node) || ts3.isModuleBlock(node) || ts3.isClassLike(node);
          }
          function collectEnclosingScopes(range) {
            var current = isReadonlyArray(range.range) ? ts3.first(range.range) : range.range;
            if (range.facts & RangeFacts.UsesThis && !(range.facts & RangeFacts.UsesThisInFunction)) {
              var containingClass = ts3.getContainingClass(current);
              if (containingClass) {
                var containingFunction = ts3.findAncestor(current, ts3.isFunctionLikeDeclaration);
                return containingFunction ? [containingFunction, containingClass] : [containingClass];
              }
            }
            var scopes = [];
            while (true) {
              current = current.parent;
              if (current.kind === 164) {
                current = ts3.findAncestor(current, function(parent) {
                  return ts3.isFunctionLikeDeclaration(parent);
                }).parent;
              }
              if (isScope(current)) {
                scopes.push(current);
                if (current.kind === 305) {
                  return scopes;
                }
              }
            }
          }
          function getFunctionExtractionAtIndex(targetRange, context, requestedChangesIndex) {
            var _a = getPossibleExtractionsWorker(targetRange, context), scopes = _a.scopes, _b = _a.readsAndWrites, target = _b.target, usagesPerScope = _b.usagesPerScope, functionErrorsPerScope = _b.functionErrorsPerScope, exposedVariableDeclarations = _b.exposedVariableDeclarations;
            ts3.Debug.assert(!functionErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
            context.cancellationToken.throwIfCancellationRequested();
            return extractFunctionInScope(target, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], exposedVariableDeclarations, targetRange, context);
          }
          function getConstantExtractionAtIndex(targetRange, context, requestedChangesIndex) {
            var _a = getPossibleExtractionsWorker(targetRange, context), scopes = _a.scopes, _b = _a.readsAndWrites, target = _b.target, usagesPerScope = _b.usagesPerScope, constantErrorsPerScope = _b.constantErrorsPerScope, exposedVariableDeclarations = _b.exposedVariableDeclarations;
            ts3.Debug.assert(!constantErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
            ts3.Debug.assert(exposedVariableDeclarations.length === 0, "Extract constant accepted a range containing a variable declaration?");
            context.cancellationToken.throwIfCancellationRequested();
            var expression = ts3.isExpression(target) ? target : target.statements[0].expression;
            return extractConstantInScope(expression, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], targetRange.facts, context);
          }
          function getPossibleExtractions(targetRange, context) {
            var _a = getPossibleExtractionsWorker(targetRange, context), scopes = _a.scopes, _b = _a.readsAndWrites, functionErrorsPerScope = _b.functionErrorsPerScope, constantErrorsPerScope = _b.constantErrorsPerScope;
            var extractions = scopes.map(function(scope, i) {
              var functionDescriptionPart = getDescriptionForFunctionInScope(scope);
              var constantDescriptionPart = getDescriptionForConstantInScope(scope);
              var scopeDescription = ts3.isFunctionLikeDeclaration(scope) ? getDescriptionForFunctionLikeDeclaration(scope) : ts3.isClassLike(scope) ? getDescriptionForClassLikeDeclaration(scope) : getDescriptionForModuleLikeDeclaration(scope);
              var functionDescription;
              var constantDescription;
              if (scopeDescription === 1) {
                functionDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "global"]);
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "global"]);
              } else if (scopeDescription === 0) {
                functionDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "module"]);
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "module"]);
              } else {
                functionDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1), [functionDescriptionPart, scopeDescription]);
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1), [constantDescriptionPart, scopeDescription]);
              }
              if (i === 0 && !ts3.isClassLike(scope)) {
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_enclosing_scope), [constantDescriptionPart]);
              }
              return {
                functionExtraction: {
                  description: functionDescription,
                  errors: functionErrorsPerScope[i]
                },
                constantExtraction: {
                  description: constantDescription,
                  errors: constantErrorsPerScope[i]
                }
              };
            });
            return extractions;
          }
          function getPossibleExtractionsWorker(targetRange, context) {
            var sourceFile = context.file;
            var scopes = collectEnclosingScopes(targetRange);
            var enclosingTextRange = getEnclosingTextRange(targetRange, sourceFile);
            var readsAndWrites = collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, context.program.getTypeChecker(), context.cancellationToken);
            return { scopes, readsAndWrites };
          }
          function getDescriptionForFunctionInScope(scope) {
            return ts3.isFunctionLikeDeclaration(scope) ? "inner function" : ts3.isClassLike(scope) ? "method" : "function";
          }
          function getDescriptionForConstantInScope(scope) {
            return ts3.isClassLike(scope) ? "readonly field" : "constant";
          }
          function getDescriptionForFunctionLikeDeclaration(scope) {
            switch (scope.kind) {
              case 171:
                return "constructor";
              case 213:
              case 256:
                return scope.name ? "function '".concat(scope.name.text, "'") : ts3.ANONYMOUS;
              case 214:
                return "arrow function";
              case 169:
                return "method '".concat(scope.name.getText(), "'");
              case 172:
                return "'get ".concat(scope.name.getText(), "'");
              case 173:
                return "'set ".concat(scope.name.getText(), "'");
              default:
                throw ts3.Debug.assertNever(scope, "Unexpected scope kind ".concat(scope.kind));
            }
          }
          function getDescriptionForClassLikeDeclaration(scope) {
            return scope.kind === 257 ? scope.name ? "class '".concat(scope.name.text, "'") : "anonymous class declaration" : scope.name ? "class expression '".concat(scope.name.text, "'") : "anonymous class expression";
          }
          function getDescriptionForModuleLikeDeclaration(scope) {
            return scope.kind === 262 ? "namespace '".concat(scope.parent.name.getText(), "'") : scope.externalModuleIndicator ? 0 : 1;
          }
          var SpecialScope;
          (function(SpecialScope2) {
            SpecialScope2[SpecialScope2["Module"] = 0] = "Module";
            SpecialScope2[SpecialScope2["Global"] = 1] = "Global";
          })(SpecialScope || (SpecialScope = {}));
          function extractFunctionInScope(node, scope, _a, exposedVariableDeclarations, range, context) {
            var usagesInScope = _a.usages, typeParameterUsages = _a.typeParameterUsages, substitutions = _a.substitutions;
            var checker = context.program.getTypeChecker();
            var scriptTarget = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
            var importAdder = ts3.codefix.createImportAdder(context.file, context.program, context.preferences, context.host);
            var file = scope.getSourceFile();
            var functionNameText = ts3.getUniqueName(ts3.isClassLike(scope) ? "newMethod" : "newFunction", file);
            var isJS = ts3.isInJSFile(scope);
            var functionName = ts3.factory.createIdentifier(functionNameText);
            var returnType;
            var parameters = [];
            var callArguments = [];
            var writes;
            usagesInScope.forEach(function(usage, name) {
              var typeNode;
              if (!isJS) {
                var type2 = checker.getTypeOfSymbolAtLocation(usage.symbol, usage.node);
                type2 = checker.getBaseTypeOfLiteralType(type2);
                typeNode = ts3.codefix.typeToAutoImportableTypeNode(checker, importAdder, type2, scope, scriptTarget, 1);
              }
              var paramDecl = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, name, void 0, typeNode);
              parameters.push(paramDecl);
              if (usage.usage === 2) {
                (writes || (writes = [])).push(usage);
              }
              callArguments.push(ts3.factory.createIdentifier(name));
            });
            var typeParametersAndDeclarations = ts3.arrayFrom(typeParameterUsages.values()).map(function(type2) {
              return { type: type2, declaration: getFirstDeclaration(type2) };
            });
            var sortedTypeParametersAndDeclarations = typeParametersAndDeclarations.sort(compareTypesByDeclarationOrder);
            var typeParameters = sortedTypeParametersAndDeclarations.length === 0 ? void 0 : sortedTypeParametersAndDeclarations.map(function(t) {
              return t.declaration;
            });
            var callTypeArguments = typeParameters !== void 0 ? typeParameters.map(function(decl) {
              return ts3.factory.createTypeReferenceNode(decl.name, void 0);
            }) : void 0;
            if (ts3.isExpression(node) && !isJS) {
              var contextualType = checker.getContextualType(node);
              returnType = checker.typeToTypeNode(contextualType, scope, 1);
            }
            var _b = transformFunctionBody(node, exposedVariableDeclarations, writes, substitutions, !!(range.facts & RangeFacts.HasReturn)), body = _b.body, returnValueProperty = _b.returnValueProperty;
            ts3.suppressLeadingAndTrailingTrivia(body);
            var newFunction;
            var callThis = !!(range.facts & RangeFacts.UsesThisInFunction);
            if (ts3.isClassLike(scope)) {
              var modifiers = isJS ? [] : [ts3.factory.createModifier(121)];
              if (range.facts & RangeFacts.InStaticRegion) {
                modifiers.push(ts3.factory.createModifier(124));
              }
              if (range.facts & RangeFacts.IsAsyncFunction) {
                modifiers.push(ts3.factory.createModifier(131));
              }
              newFunction = ts3.factory.createMethodDeclaration(void 0, modifiers.length ? modifiers : void 0, range.facts & RangeFacts.IsGenerator ? ts3.factory.createToken(41) : void 0, functionName, void 0, typeParameters, parameters, returnType, body);
            } else {
              if (callThis) {
                parameters.unshift(ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, checker.typeToTypeNode(checker.getTypeAtLocation(range.thisNode), scope, 1), void 0));
              }
              newFunction = ts3.factory.createFunctionDeclaration(void 0, range.facts & RangeFacts.IsAsyncFunction ? [ts3.factory.createToken(131)] : void 0, range.facts & RangeFacts.IsGenerator ? ts3.factory.createToken(41) : void 0, functionName, typeParameters, parameters, returnType, body);
            }
            var changeTracker = ts3.textChanges.ChangeTracker.fromContext(context);
            var minInsertionPos = (isReadonlyArray(range.range) ? ts3.last(range.range) : range.range).end;
            var nodeToInsertBefore = getNodeToInsertFunctionBefore(minInsertionPos, scope);
            if (nodeToInsertBefore) {
              changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newFunction, true);
            } else {
              changeTracker.insertNodeAtEndOfScope(context.file, scope, newFunction);
            }
            importAdder.writeFixes(changeTracker);
            var newNodes = [];
            var called = getCalledExpression(scope, range, functionNameText);
            if (callThis) {
              callArguments.unshift(ts3.factory.createIdentifier("this"));
            }
            var call = ts3.factory.createCallExpression(callThis ? ts3.factory.createPropertyAccessExpression(called, "call") : called, callTypeArguments, callArguments);
            if (range.facts & RangeFacts.IsGenerator) {
              call = ts3.factory.createYieldExpression(ts3.factory.createToken(41), call);
            }
            if (range.facts & RangeFacts.IsAsyncFunction) {
              call = ts3.factory.createAwaitExpression(call);
            }
            if (isInJSXContent(node)) {
              call = ts3.factory.createJsxExpression(void 0, call);
            }
            if (exposedVariableDeclarations.length && !writes) {
              ts3.Debug.assert(!returnValueProperty, "Expected no returnValueProperty");
              ts3.Debug.assert(!(range.facts & RangeFacts.HasReturn), "Expected RangeFacts.HasReturn flag to be unset");
              if (exposedVariableDeclarations.length === 1) {
                var variableDeclaration = exposedVariableDeclarations[0];
                newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(ts3.getSynthesizedDeepClone(variableDeclaration.name), void 0, ts3.getSynthesizedDeepClone(variableDeclaration.type), call)], variableDeclaration.parent.flags)));
              } else {
                var bindingElements = [];
                var typeElements = [];
                var commonNodeFlags = exposedVariableDeclarations[0].parent.flags;
                var sawExplicitType = false;
                for (var _i = 0, exposedVariableDeclarations_1 = exposedVariableDeclarations; _i < exposedVariableDeclarations_1.length; _i++) {
                  var variableDeclaration = exposedVariableDeclarations_1[_i];
                  bindingElements.push(ts3.factory.createBindingElement(void 0, void 0, ts3.getSynthesizedDeepClone(variableDeclaration.name)));
                  var variableType = checker.typeToTypeNode(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(variableDeclaration)), scope, 1);
                  typeElements.push(ts3.factory.createPropertySignature(void 0, variableDeclaration.symbol.name, void 0, variableType));
                  sawExplicitType = sawExplicitType || variableDeclaration.type !== void 0;
                  commonNodeFlags = commonNodeFlags & variableDeclaration.parent.flags;
                }
                var typeLiteral = sawExplicitType ? ts3.factory.createTypeLiteralNode(typeElements) : void 0;
                if (typeLiteral) {
                  ts3.setEmitFlags(typeLiteral, 1);
                }
                newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(ts3.factory.createObjectBindingPattern(bindingElements), void 0, typeLiteral, call)], commonNodeFlags)));
              }
            } else if (exposedVariableDeclarations.length || writes) {
              if (exposedVariableDeclarations.length) {
                for (var _c = 0, exposedVariableDeclarations_2 = exposedVariableDeclarations; _c < exposedVariableDeclarations_2.length; _c++) {
                  var variableDeclaration = exposedVariableDeclarations_2[_c];
                  var flags = variableDeclaration.parent.flags;
                  if (flags & 2) {
                    flags = flags & ~2 | 1;
                  }
                  newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(variableDeclaration.symbol.name, void 0, getTypeDeepCloneUnionUndefined(variableDeclaration.type))], flags)));
                }
              }
              if (returnValueProperty) {
                newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(returnValueProperty, void 0, getTypeDeepCloneUnionUndefined(returnType))], 1)));
              }
              var assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
              if (returnValueProperty) {
                assignments.unshift(ts3.factory.createShorthandPropertyAssignment(returnValueProperty));
              }
              if (assignments.length === 1) {
                ts3.Debug.assert(!returnValueProperty, "Shouldn't have returnValueProperty here");
                newNodes.push(ts3.factory.createExpressionStatement(ts3.factory.createAssignment(assignments[0].name, call)));
                if (range.facts & RangeFacts.HasReturn) {
                  newNodes.push(ts3.factory.createReturnStatement());
                }
              } else {
                newNodes.push(ts3.factory.createExpressionStatement(ts3.factory.createAssignment(ts3.factory.createObjectLiteralExpression(assignments), call)));
                if (returnValueProperty) {
                  newNodes.push(ts3.factory.createReturnStatement(ts3.factory.createIdentifier(returnValueProperty)));
                }
              }
            } else {
              if (range.facts & RangeFacts.HasReturn) {
                newNodes.push(ts3.factory.createReturnStatement(call));
              } else if (isReadonlyArray(range.range)) {
                newNodes.push(ts3.factory.createExpressionStatement(call));
              } else {
                newNodes.push(call);
              }
            }
            if (isReadonlyArray(range.range)) {
              changeTracker.replaceNodeRangeWithNodes(context.file, ts3.first(range.range), ts3.last(range.range), newNodes);
            } else {
              changeTracker.replaceNodeWithNodes(context.file, range.range, newNodes);
            }
            var edits = changeTracker.getChanges();
            var renameRange = isReadonlyArray(range.range) ? ts3.first(range.range) : range.range;
            var renameFilename = renameRange.getSourceFile().fileName;
            var renameLocation = ts3.getRenameLocation(edits, renameFilename, functionNameText, false);
            return { renameFilename, renameLocation, edits };
            function getTypeDeepCloneUnionUndefined(typeNode) {
              if (typeNode === void 0) {
                return void 0;
              }
              var clone = ts3.getSynthesizedDeepClone(typeNode);
              var withoutParens = clone;
              while (ts3.isParenthesizedTypeNode(withoutParens)) {
                withoutParens = withoutParens.type;
              }
              return ts3.isUnionTypeNode(withoutParens) && ts3.find(withoutParens.types, function(t) {
                return t.kind === 153;
              }) ? clone : ts3.factory.createUnionTypeNode([clone, ts3.factory.createKeywordTypeNode(153)]);
            }
          }
          function extractConstantInScope(node, scope, _a, rangeFacts, context) {
            var _b;
            var substitutions = _a.substitutions;
            var checker = context.program.getTypeChecker();
            var file = scope.getSourceFile();
            var localNameText = ts3.isPropertyAccessExpression(node) && !ts3.isClassLike(scope) && !checker.resolveName(node.name.text, node, 111551, false) && !ts3.isPrivateIdentifier(node.name) && !ts3.isKeyword(node.name.originalKeywordKind) ? node.name.text : ts3.getUniqueName(ts3.isClassLike(scope) ? "newProperty" : "newLocal", file);
            var isJS = ts3.isInJSFile(scope);
            var variableType = isJS || !checker.isContextSensitive(node) ? void 0 : checker.typeToTypeNode(checker.getContextualType(node), scope, 1);
            var initializer = transformConstantInitializer(ts3.skipParentheses(node), substitutions);
            _b = transformFunctionInitializerAndType(variableType, initializer), variableType = _b.variableType, initializer = _b.initializer;
            ts3.suppressLeadingAndTrailingTrivia(initializer);
            var changeTracker = ts3.textChanges.ChangeTracker.fromContext(context);
            if (ts3.isClassLike(scope)) {
              ts3.Debug.assert(!isJS, "Cannot extract to a JS class");
              var modifiers = [];
              modifiers.push(ts3.factory.createModifier(121));
              if (rangeFacts & RangeFacts.InStaticRegion) {
                modifiers.push(ts3.factory.createModifier(124));
              }
              modifiers.push(ts3.factory.createModifier(145));
              var newVariable = ts3.factory.createPropertyDeclaration(void 0, modifiers, localNameText, void 0, variableType, initializer);
              var localReference = ts3.factory.createPropertyAccessExpression(rangeFacts & RangeFacts.InStaticRegion ? ts3.factory.createIdentifier(scope.name.getText()) : ts3.factory.createThis(), ts3.factory.createIdentifier(localNameText));
              if (isInJSXContent(node)) {
                localReference = ts3.factory.createJsxExpression(void 0, localReference);
              }
              var maxInsertionPos = node.pos;
              var nodeToInsertBefore = getNodeToInsertPropertyBefore(maxInsertionPos, scope);
              changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newVariable, true);
              changeTracker.replaceNode(context.file, node, localReference);
            } else {
              var newVariableDeclaration = ts3.factory.createVariableDeclaration(localNameText, void 0, variableType, initializer);
              var oldVariableDeclaration = getContainingVariableDeclarationIfInList(node, scope);
              if (oldVariableDeclaration) {
                changeTracker.insertNodeBefore(context.file, oldVariableDeclaration, newVariableDeclaration);
                var localReference = ts3.factory.createIdentifier(localNameText);
                changeTracker.replaceNode(context.file, node, localReference);
              } else if (node.parent.kind === 238 && scope === ts3.findAncestor(node, isScope)) {
                var newVariableStatement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([newVariableDeclaration], 2));
                changeTracker.replaceNode(context.file, node.parent, newVariableStatement);
              } else {
                var newVariableStatement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([newVariableDeclaration], 2));
                var nodeToInsertBefore = getNodeToInsertConstantBefore(node, scope);
                if (nodeToInsertBefore.pos === 0) {
                  changeTracker.insertNodeAtTopOfFile(context.file, newVariableStatement, false);
                } else {
                  changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newVariableStatement, false);
                }
                if (node.parent.kind === 238) {
                  changeTracker.delete(context.file, node.parent);
                } else {
                  var localReference = ts3.factory.createIdentifier(localNameText);
                  if (isInJSXContent(node)) {
                    localReference = ts3.factory.createJsxExpression(void 0, localReference);
                  }
                  changeTracker.replaceNode(context.file, node, localReference);
                }
              }
            }
            var edits = changeTracker.getChanges();
            var renameFilename = node.getSourceFile().fileName;
            var renameLocation = ts3.getRenameLocation(edits, renameFilename, localNameText, true);
            return { renameFilename, renameLocation, edits };
            function transformFunctionInitializerAndType(variableType2, initializer2) {
              if (variableType2 === void 0)
                return { variableType: variableType2, initializer: initializer2 };
              if (!ts3.isFunctionExpression(initializer2) && !ts3.isArrowFunction(initializer2) || !!initializer2.typeParameters)
                return { variableType: variableType2, initializer: initializer2 };
              var functionType = checker.getTypeAtLocation(node);
              var functionSignature = ts3.singleOrUndefined(checker.getSignaturesOfType(functionType, 0));
              if (!functionSignature)
                return { variableType: variableType2, initializer: initializer2 };
              if (!!functionSignature.getTypeParameters())
                return { variableType: variableType2, initializer: initializer2 };
              var parameters = [];
              var hasAny = false;
              for (var _i = 0, _a2 = initializer2.parameters; _i < _a2.length; _i++) {
                var p = _a2[_i];
                if (p.type) {
                  parameters.push(p);
                } else {
                  var paramType = checker.getTypeAtLocation(p);
                  if (paramType === checker.getAnyType())
                    hasAny = true;
                  parameters.push(ts3.factory.updateParameterDeclaration(p, p.decorators, p.modifiers, p.dotDotDotToken, p.name, p.questionToken, p.type || checker.typeToTypeNode(paramType, scope, 1), p.initializer));
                }
              }
              if (hasAny)
                return { variableType: variableType2, initializer: initializer2 };
              variableType2 = void 0;
              if (ts3.isArrowFunction(initializer2)) {
                initializer2 = ts3.factory.updateArrowFunction(initializer2, node.modifiers, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1), initializer2.equalsGreaterThanToken, initializer2.body);
              } else {
                if (functionSignature && !!functionSignature.thisParameter) {
                  var firstParameter = ts3.firstOrUndefined(parameters);
                  if (!firstParameter || ts3.isIdentifier(firstParameter.name) && firstParameter.name.escapedText !== "this") {
                    var thisType = checker.getTypeOfSymbolAtLocation(functionSignature.thisParameter, node);
                    parameters.splice(0, 0, ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, checker.typeToTypeNode(thisType, scope, 1)));
                  }
                }
                initializer2 = ts3.factory.updateFunctionExpression(initializer2, node.modifiers, initializer2.asteriskToken, initializer2.name, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1), initializer2.body);
              }
              return { variableType: variableType2, initializer: initializer2 };
            }
          }
          function getContainingVariableDeclarationIfInList(node, scope) {
            var prevNode;
            while (node !== void 0 && node !== scope) {
              if (ts3.isVariableDeclaration(node) && node.initializer === prevNode && ts3.isVariableDeclarationList(node.parent) && node.parent.declarations.length > 1) {
                return node;
              }
              prevNode = node;
              node = node.parent;
            }
          }
          function getFirstDeclaration(type2) {
            var firstDeclaration;
            var symbol = type2.symbol;
            if (symbol && symbol.declarations) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (firstDeclaration === void 0 || declaration.pos < firstDeclaration.pos) {
                  firstDeclaration = declaration;
                }
              }
            }
            return firstDeclaration;
          }
          function compareTypesByDeclarationOrder(_a, _b) {
            var type1 = _a.type, declaration1 = _a.declaration;
            var type2 = _b.type, declaration2 = _b.declaration;
            return ts3.compareProperties(declaration1, declaration2, "pos", ts3.compareValues) || ts3.compareStringsCaseSensitive(type1.symbol ? type1.symbol.getName() : "", type2.symbol ? type2.symbol.getName() : "") || ts3.compareValues(type1.id, type2.id);
          }
          function getCalledExpression(scope, range, functionNameText) {
            var functionReference = ts3.factory.createIdentifier(functionNameText);
            if (ts3.isClassLike(scope)) {
              var lhs = range.facts & RangeFacts.InStaticRegion ? ts3.factory.createIdentifier(scope.name.text) : ts3.factory.createThis();
              return ts3.factory.createPropertyAccessExpression(lhs, functionReference);
            } else {
              return functionReference;
            }
          }
          function transformFunctionBody(body, exposedVariableDeclarations, writes, substitutions, hasReturn) {
            var hasWritesOrVariableDeclarations = writes !== void 0 || exposedVariableDeclarations.length > 0;
            if (ts3.isBlock(body) && !hasWritesOrVariableDeclarations && substitutions.size === 0) {
              return { body: ts3.factory.createBlock(body.statements, true), returnValueProperty: void 0 };
            }
            var returnValueProperty;
            var ignoreReturns = false;
            var statements = ts3.factory.createNodeArray(ts3.isBlock(body) ? body.statements.slice(0) : [ts3.isStatement(body) ? body : ts3.factory.createReturnStatement(ts3.skipParentheses(body))]);
            if (hasWritesOrVariableDeclarations || substitutions.size) {
              var rewrittenStatements = ts3.visitNodes(statements, visitor).slice();
              if (hasWritesOrVariableDeclarations && !hasReturn && ts3.isStatement(body)) {
                var assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
                if (assignments.length === 1) {
                  rewrittenStatements.push(ts3.factory.createReturnStatement(assignments[0].name));
                } else {
                  rewrittenStatements.push(ts3.factory.createReturnStatement(ts3.factory.createObjectLiteralExpression(assignments)));
                }
              }
              return { body: ts3.factory.createBlock(rewrittenStatements, true), returnValueProperty };
            } else {
              return { body: ts3.factory.createBlock(statements, true), returnValueProperty: void 0 };
            }
            function visitor(node) {
              if (!ignoreReturns && ts3.isReturnStatement(node) && hasWritesOrVariableDeclarations) {
                var assignments2 = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
                if (node.expression) {
                  if (!returnValueProperty) {
                    returnValueProperty = "__return";
                  }
                  assignments2.unshift(ts3.factory.createPropertyAssignment(returnValueProperty, ts3.visitNode(node.expression, visitor)));
                }
                if (assignments2.length === 1) {
                  return ts3.factory.createReturnStatement(assignments2[0].name);
                } else {
                  return ts3.factory.createReturnStatement(ts3.factory.createObjectLiteralExpression(assignments2));
                }
              } else {
                var oldIgnoreReturns = ignoreReturns;
                ignoreReturns = ignoreReturns || ts3.isFunctionLikeDeclaration(node) || ts3.isClassLike(node);
                var substitution = substitutions.get(ts3.getNodeId(node).toString());
                var result2 = substitution ? ts3.getSynthesizedDeepClone(substitution) : ts3.visitEachChild(node, visitor, ts3.nullTransformationContext);
                ignoreReturns = oldIgnoreReturns;
                return result2;
              }
            }
          }
          function transformConstantInitializer(initializer, substitutions) {
            return substitutions.size ? visitor(initializer) : initializer;
            function visitor(node) {
              var substitution = substitutions.get(ts3.getNodeId(node).toString());
              return substitution ? ts3.getSynthesizedDeepClone(substitution) : ts3.visitEachChild(node, visitor, ts3.nullTransformationContext);
            }
          }
          function getStatementsOrClassElements(scope) {
            if (ts3.isFunctionLikeDeclaration(scope)) {
              var body = scope.body;
              if (ts3.isBlock(body)) {
                return body.statements;
              }
            } else if (ts3.isModuleBlock(scope) || ts3.isSourceFile(scope)) {
              return scope.statements;
            } else if (ts3.isClassLike(scope)) {
              return scope.members;
            } else {
              ts3.assertType(scope);
            }
            return ts3.emptyArray;
          }
          function getNodeToInsertFunctionBefore(minPos, scope) {
            return ts3.find(getStatementsOrClassElements(scope), function(child) {
              return child.pos >= minPos && ts3.isFunctionLikeDeclaration(child) && !ts3.isConstructorDeclaration(child);
            });
          }
          function getNodeToInsertPropertyBefore(maxPos, scope) {
            var members = scope.members;
            ts3.Debug.assert(members.length > 0, "Found no members");
            var prevMember;
            var allProperties = true;
            for (var _i = 0, members_1 = members; _i < members_1.length; _i++) {
              var member = members_1[_i];
              if (member.pos > maxPos) {
                return prevMember || members[0];
              }
              if (allProperties && !ts3.isPropertyDeclaration(member)) {
                if (prevMember !== void 0) {
                  return member;
                }
                allProperties = false;
              }
              prevMember = member;
            }
            if (prevMember === void 0)
              return ts3.Debug.fail();
            return prevMember;
          }
          function getNodeToInsertConstantBefore(node, scope) {
            ts3.Debug.assert(!ts3.isClassLike(scope));
            var prevScope;
            for (var curr = node; curr !== scope; curr = curr.parent) {
              if (isScope(curr)) {
                prevScope = curr;
              }
            }
            for (var curr = (prevScope || node).parent; ; curr = curr.parent) {
              if (isBlockLike(curr)) {
                var prevStatement = void 0;
                for (var _i = 0, _a = curr.statements; _i < _a.length; _i++) {
                  var statement = _a[_i];
                  if (statement.pos > node.pos) {
                    break;
                  }
                  prevStatement = statement;
                }
                if (!prevStatement && ts3.isCaseClause(curr)) {
                  ts3.Debug.assert(ts3.isSwitchStatement(curr.parent.parent), "Grandparent isn't a switch statement");
                  return curr.parent.parent;
                }
                return ts3.Debug.checkDefined(prevStatement, "prevStatement failed to get set");
              }
              ts3.Debug.assert(curr !== scope, "Didn't encounter a block-like before encountering scope");
            }
          }
          function getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes) {
            var variableAssignments = ts3.map(exposedVariableDeclarations, function(v) {
              return ts3.factory.createShorthandPropertyAssignment(v.symbol.name);
            });
            var writeAssignments = ts3.map(writes, function(w) {
              return ts3.factory.createShorthandPropertyAssignment(w.symbol.name);
            });
            return variableAssignments === void 0 ? writeAssignments : writeAssignments === void 0 ? variableAssignments : variableAssignments.concat(writeAssignments);
          }
          function isReadonlyArray(v) {
            return ts3.isArray(v);
          }
          function getEnclosingTextRange(targetRange, sourceFile) {
            return isReadonlyArray(targetRange.range) ? { pos: ts3.first(targetRange.range).getStart(sourceFile), end: ts3.last(targetRange.range).getEnd() } : targetRange.range;
          }
          var Usage;
          (function(Usage2) {
            Usage2[Usage2["Read"] = 1] = "Read";
            Usage2[Usage2["Write"] = 2] = "Write";
          })(Usage || (Usage = {}));
          function collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, checker, cancellationToken) {
            var allTypeParameterUsages = new ts3.Map();
            var usagesPerScope = [];
            var substitutionsPerScope = [];
            var functionErrorsPerScope = [];
            var constantErrorsPerScope = [];
            var visibleDeclarationsInExtractedRange = [];
            var exposedVariableSymbolSet = new ts3.Map();
            var exposedVariableDeclarations = [];
            var firstExposedNonVariableDeclaration;
            var expression = !isReadonlyArray(targetRange.range) ? targetRange.range : targetRange.range.length === 1 && ts3.isExpressionStatement(targetRange.range[0]) ? targetRange.range[0].expression : void 0;
            var expressionDiagnostic;
            if (expression === void 0) {
              var statements = targetRange.range;
              var start = ts3.first(statements).getStart();
              var end = ts3.last(statements).end;
              expressionDiagnostic = ts3.createFileDiagnostic(sourceFile, start, end - start, Messages.expressionExpected);
            } else if (checker.getTypeAtLocation(expression).flags & (16384 | 131072)) {
              expressionDiagnostic = ts3.createDiagnosticForNode(expression, Messages.uselessConstantType);
            }
            for (var _i = 0, scopes_1 = scopes; _i < scopes_1.length; _i++) {
              var scope = scopes_1[_i];
              usagesPerScope.push({ usages: new ts3.Map(), typeParameterUsages: new ts3.Map(), substitutions: new ts3.Map() });
              substitutionsPerScope.push(new ts3.Map());
              functionErrorsPerScope.push([]);
              var constantErrors = [];
              if (expressionDiagnostic) {
                constantErrors.push(expressionDiagnostic);
              }
              if (ts3.isClassLike(scope) && ts3.isInJSFile(scope)) {
                constantErrors.push(ts3.createDiagnosticForNode(scope, Messages.cannotExtractToJSClass));
              }
              if (ts3.isArrowFunction(scope) && !ts3.isBlock(scope.body)) {
                constantErrors.push(ts3.createDiagnosticForNode(scope, Messages.cannotExtractToExpressionArrowFunction));
              }
              constantErrorsPerScope.push(constantErrors);
            }
            var seenUsages = new ts3.Map();
            var target = isReadonlyArray(targetRange.range) ? ts3.factory.createBlock(targetRange.range) : targetRange.range;
            var unmodifiedNode = isReadonlyArray(targetRange.range) ? ts3.first(targetRange.range) : targetRange.range;
            var inGenericContext = isInGenericContext(unmodifiedNode);
            collectUsages(target);
            if (inGenericContext && !isReadonlyArray(targetRange.range) && !ts3.isJsxAttribute(targetRange.range)) {
              var contextualType = checker.getContextualType(targetRange.range);
              recordTypeParameterUsages(contextualType);
            }
            if (allTypeParameterUsages.size > 0) {
              var seenTypeParameterUsages = new ts3.Map();
              var i_2 = 0;
              for (var curr = unmodifiedNode; curr !== void 0 && i_2 < scopes.length; curr = curr.parent) {
                if (curr === scopes[i_2]) {
                  seenTypeParameterUsages.forEach(function(typeParameter2, id) {
                    usagesPerScope[i_2].typeParameterUsages.set(id, typeParameter2);
                  });
                  i_2++;
                }
                if (ts3.isDeclarationWithTypeParameters(curr)) {
                  for (var _a = 0, _b = ts3.getEffectiveTypeParameterDeclarations(curr); _a < _b.length; _a++) {
                    var typeParameterDecl = _b[_a];
                    var typeParameter = checker.getTypeAtLocation(typeParameterDecl);
                    if (allTypeParameterUsages.has(typeParameter.id.toString())) {
                      seenTypeParameterUsages.set(typeParameter.id.toString(), typeParameter);
                    }
                  }
                }
              }
              ts3.Debug.assert(i_2 === scopes.length, "Should have iterated all scopes");
            }
            if (visibleDeclarationsInExtractedRange.length) {
              var containingLexicalScopeOfExtraction = ts3.isBlockScope(scopes[0], scopes[0].parent) ? scopes[0] : ts3.getEnclosingBlockScopeContainer(scopes[0]);
              ts3.forEachChild(containingLexicalScopeOfExtraction, checkForUsedDeclarations);
            }
            var _loop_18 = function(i2) {
              var scopeUsages = usagesPerScope[i2];
              if (i2 > 0 && (scopeUsages.usages.size > 0 || scopeUsages.typeParameterUsages.size > 0)) {
                var errorNode = isReadonlyArray(targetRange.range) ? targetRange.range[0] : targetRange.range;
                constantErrorsPerScope[i2].push(ts3.createDiagnosticForNode(errorNode, Messages.cannotAccessVariablesFromNestedScopes));
              }
              if (targetRange.facts & RangeFacts.UsesThisInFunction && ts3.isClassLike(scopes[i2])) {
                functionErrorsPerScope[i2].push(ts3.createDiagnosticForNode(targetRange.thisNode, Messages.cannotExtractFunctionsContainingThisToMethod));
              }
              var hasWrite = false;
              var readonlyClassPropertyWrite;
              usagesPerScope[i2].usages.forEach(function(value) {
                if (value.usage === 2) {
                  hasWrite = true;
                  if (value.symbol.flags & 106500 && value.symbol.valueDeclaration && ts3.hasEffectiveModifier(value.symbol.valueDeclaration, 64)) {
                    readonlyClassPropertyWrite = value.symbol.valueDeclaration;
                  }
                }
              });
              ts3.Debug.assert(isReadonlyArray(targetRange.range) || exposedVariableDeclarations.length === 0, "No variable declarations expected if something was extracted");
              if (hasWrite && !isReadonlyArray(targetRange.range)) {
                var diag = ts3.createDiagnosticForNode(targetRange.range, Messages.cannotWriteInExpression);
                functionErrorsPerScope[i2].push(diag);
                constantErrorsPerScope[i2].push(diag);
              } else if (readonlyClassPropertyWrite && i2 > 0) {
                var diag = ts3.createDiagnosticForNode(readonlyClassPropertyWrite, Messages.cannotExtractReadonlyPropertyInitializerOutsideConstructor);
                functionErrorsPerScope[i2].push(diag);
                constantErrorsPerScope[i2].push(diag);
              } else if (firstExposedNonVariableDeclaration) {
                var diag = ts3.createDiagnosticForNode(firstExposedNonVariableDeclaration, Messages.cannotExtractExportedEntity);
                functionErrorsPerScope[i2].push(diag);
                constantErrorsPerScope[i2].push(diag);
              }
            };
            for (var i = 0; i < scopes.length; i++) {
              _loop_18(i);
            }
            return { target, usagesPerScope, functionErrorsPerScope, constantErrorsPerScope, exposedVariableDeclarations };
            function isInGenericContext(node) {
              return !!ts3.findAncestor(node, function(n) {
                return ts3.isDeclarationWithTypeParameters(n) && ts3.getEffectiveTypeParameterDeclarations(n).length !== 0;
              });
            }
            function recordTypeParameterUsages(type2) {
              var symbolWalker = checker.getSymbolWalker(function() {
                return cancellationToken.throwIfCancellationRequested(), true;
              });
              var visitedTypes = symbolWalker.walkType(type2).visitedTypes;
              for (var _i2 = 0, visitedTypes_1 = visitedTypes; _i2 < visitedTypes_1.length; _i2++) {
                var visitedType = visitedTypes_1[_i2];
                if (visitedType.isTypeParameter()) {
                  allTypeParameterUsages.set(visitedType.id.toString(), visitedType);
                }
              }
            }
            function collectUsages(node, valueUsage) {
              if (valueUsage === void 0) {
                valueUsage = 1;
              }
              if (inGenericContext) {
                var type2 = checker.getTypeAtLocation(node);
                recordTypeParameterUsages(type2);
              }
              if (ts3.isDeclaration(node) && node.symbol) {
                visibleDeclarationsInExtractedRange.push(node);
              }
              if (ts3.isAssignmentExpression(node)) {
                collectUsages(node.left, 2);
                collectUsages(node.right);
              } else if (ts3.isUnaryExpressionWithWrite(node)) {
                collectUsages(node.operand, 2);
              } else if (ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node)) {
                ts3.forEachChild(node, collectUsages);
              } else if (ts3.isIdentifier(node)) {
                if (!node.parent) {
                  return;
                }
                if (ts3.isQualifiedName(node.parent) && node !== node.parent.left) {
                  return;
                }
                if (ts3.isPropertyAccessExpression(node.parent) && node !== node.parent.expression) {
                  return;
                }
                recordUsage(node, valueUsage, ts3.isPartOfTypeNode(node));
              } else {
                ts3.forEachChild(node, collectUsages);
              }
            }
            function recordUsage(n, usage, isTypeNode) {
              var symbolId = recordUsagebySymbol(n, usage, isTypeNode);
              if (symbolId) {
                for (var i2 = 0; i2 < scopes.length; i2++) {
                  var substitution = substitutionsPerScope[i2].get(symbolId);
                  if (substitution) {
                    usagesPerScope[i2].substitutions.set(ts3.getNodeId(n).toString(), substitution);
                  }
                }
              }
            }
            function recordUsagebySymbol(identifier, usage, isTypeName) {
              var symbol = getSymbolReferencedByIdentifier(identifier);
              if (!symbol) {
                return void 0;
              }
              var symbolId = ts3.getSymbolId(symbol).toString();
              var lastUsage = seenUsages.get(symbolId);
              if (lastUsage && lastUsage >= usage) {
                return symbolId;
              }
              seenUsages.set(symbolId, usage);
              if (lastUsage) {
                for (var _i2 = 0, usagesPerScope_1 = usagesPerScope; _i2 < usagesPerScope_1.length; _i2++) {
                  var perScope = usagesPerScope_1[_i2];
                  var prevEntry = perScope.usages.get(identifier.text);
                  if (prevEntry) {
                    perScope.usages.set(identifier.text, { usage, symbol, node: identifier });
                  }
                }
                return symbolId;
              }
              var decls = symbol.getDeclarations();
              var declInFile = decls && ts3.find(decls, function(d) {
                return d.getSourceFile() === sourceFile;
              });
              if (!declInFile) {
                return void 0;
              }
              if (ts3.rangeContainsStartEnd(enclosingTextRange, declInFile.getStart(), declInFile.end)) {
                return void 0;
              }
              if (targetRange.facts & RangeFacts.IsGenerator && usage === 2) {
                var diag = ts3.createDiagnosticForNode(identifier, Messages.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators);
                for (var _a2 = 0, functionErrorsPerScope_1 = functionErrorsPerScope; _a2 < functionErrorsPerScope_1.length; _a2++) {
                  var errors = functionErrorsPerScope_1[_a2];
                  errors.push(diag);
                }
                for (var _b2 = 0, constantErrorsPerScope_1 = constantErrorsPerScope; _b2 < constantErrorsPerScope_1.length; _b2++) {
                  var errors = constantErrorsPerScope_1[_b2];
                  errors.push(diag);
                }
              }
              for (var i2 = 0; i2 < scopes.length; i2++) {
                var scope2 = scopes[i2];
                var resolvedSymbol = checker.resolveName(symbol.name, scope2, symbol.flags, false);
                if (resolvedSymbol === symbol) {
                  continue;
                }
                if (!substitutionsPerScope[i2].has(symbolId)) {
                  var substitution = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.exportSymbol || symbol, scope2, isTypeName);
                  if (substitution) {
                    substitutionsPerScope[i2].set(symbolId, substitution);
                  } else if (isTypeName) {
                    if (!(symbol.flags & 262144)) {
                      var diag = ts3.createDiagnosticForNode(identifier, Messages.typeWillNotBeVisibleInTheNewScope);
                      functionErrorsPerScope[i2].push(diag);
                      constantErrorsPerScope[i2].push(diag);
                    }
                  } else {
                    usagesPerScope[i2].usages.set(identifier.text, { usage, symbol, node: identifier });
                  }
                }
              }
              return symbolId;
            }
            function checkForUsedDeclarations(node) {
              if (node === targetRange.range || isReadonlyArray(targetRange.range) && targetRange.range.indexOf(node) >= 0) {
                return;
              }
              var sym = ts3.isIdentifier(node) ? getSymbolReferencedByIdentifier(node) : checker.getSymbolAtLocation(node);
              if (sym) {
                var decl = ts3.find(visibleDeclarationsInExtractedRange, function(d) {
                  return d.symbol === sym;
                });
                if (decl) {
                  if (ts3.isVariableDeclaration(decl)) {
                    var idString = decl.symbol.id.toString();
                    if (!exposedVariableSymbolSet.has(idString)) {
                      exposedVariableDeclarations.push(decl);
                      exposedVariableSymbolSet.set(idString, true);
                    }
                  } else {
                    firstExposedNonVariableDeclaration = firstExposedNonVariableDeclaration || decl;
                  }
                }
              }
              ts3.forEachChild(node, checkForUsedDeclarations);
            }
            function getSymbolReferencedByIdentifier(identifier) {
              return identifier.parent && ts3.isShorthandPropertyAssignment(identifier.parent) && identifier.parent.name === identifier ? checker.getShorthandAssignmentValueSymbol(identifier.parent) : checker.getSymbolAtLocation(identifier);
            }
            function tryReplaceWithQualifiedNameOrPropertyAccess(symbol, scopeDecl, isTypeNode) {
              if (!symbol) {
                return void 0;
              }
              var decls = symbol.getDeclarations();
              if (decls && decls.some(function(d) {
                return d.parent === scopeDecl;
              })) {
                return ts3.factory.createIdentifier(symbol.name);
              }
              var prefix = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.parent, scopeDecl, isTypeNode);
              if (prefix === void 0) {
                return void 0;
              }
              return isTypeNode ? ts3.factory.createQualifiedName(prefix, ts3.factory.createIdentifier(symbol.name)) : ts3.factory.createPropertyAccessExpression(prefix, symbol.name);
            }
          }
          function getExtractableParent(node) {
            return ts3.findAncestor(node, function(node2) {
              return node2.parent && isExtractableExpression(node2) && !ts3.isBinaryExpression(node2.parent);
            });
          }
          function isExtractableExpression(node) {
            var parent = node.parent;
            switch (parent.kind) {
              case 299:
                return false;
            }
            switch (node.kind) {
              case 10:
                return parent.kind !== 266 && parent.kind !== 270;
              case 225:
              case 201:
              case 203:
                return false;
              case 79:
                return parent.kind !== 203 && parent.kind !== 270 && parent.kind !== 275;
            }
            return true;
          }
          function isBlockLike(node) {
            switch (node.kind) {
              case 235:
              case 305:
              case 262:
              case 289:
                return true;
              default:
                return false;
            }
          }
          function isInJSXContent(node) {
            return isStringLiteralJsxAttribute(node) || (ts3.isJsxElement(node) || ts3.isJsxSelfClosingElement(node) || ts3.isJsxFragment(node)) && (ts3.isJsxElement(node.parent) || ts3.isJsxFragment(node.parent));
          }
          function isStringLiteralJsxAttribute(node) {
            return ts3.isStringLiteral(node) && node.parent && ts3.isJsxAttribute(node.parent);
          }
        })(extractSymbol = refactor2.extractSymbol || (refactor2.extractSymbol = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Extract type";
        var extractToTypeAliasAction = {
          name: "Extract to type alias",
          description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_type_alias),
          kind: "refactor.extract.type"
        };
        var extractToInterfaceAction = {
          name: "Extract to interface",
          description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_interface),
          kind: "refactor.extract.interface"
        };
        var extractToTypeDefAction = {
          name: "Extract to typedef",
          description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_typedef),
          kind: "refactor.extract.typedef"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [
            extractToTypeAliasAction.kind,
            extractToInterfaceAction.kind,
            extractToTypeDefAction.kind
          ],
          getAvailableActions: function getRefactorActionsToExtractType(context) {
            var info = getRangeToExtract(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_type),
                actions: info.isJS ? [extractToTypeDefAction] : ts3.append([extractToTypeAliasAction], info.typeElements && extractToInterfaceAction)
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_type),
                actions: [
                  __assign(__assign({}, extractToTypeDefAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, extractToTypeAliasAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, extractToInterfaceAction), { notApplicableReason: info.error })
                ]
              }];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function getRefactorEditsToExtractType(context, actionName) {
            var file = context.file;
            var info = getRangeToExtract(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected to find a range to extract");
            var name = ts3.getUniqueName("NewType", file);
            var edits = ts3.textChanges.ChangeTracker.with(context, function(changes) {
              switch (actionName) {
                case extractToTypeAliasAction.name:
                  ts3.Debug.assert(!info.isJS, "Invalid actionName/JS combo");
                  return doTypeAliasChange(changes, file, name, info);
                case extractToTypeDefAction.name:
                  ts3.Debug.assert(info.isJS, "Invalid actionName/JS combo");
                  return doTypedefChange(changes, file, name, info);
                case extractToInterfaceAction.name:
                  ts3.Debug.assert(!info.isJS && !!info.typeElements, "Invalid actionName/JS combo");
                  return doInterfaceChange(changes, file, name, info);
                default:
                  ts3.Debug.fail("Unexpected action name");
              }
            });
            var renameFilename = file.fileName;
            var renameLocation = ts3.getRenameLocation(edits, renameFilename, name, false);
            return { edits, renameFilename, renameLocation };
          }
        });
        function getRangeToExtract(context, considerEmptySpans) {
          if (considerEmptySpans === void 0) {
            considerEmptySpans = true;
          }
          var file = context.file, startPosition = context.startPosition;
          var isJS = ts3.isSourceFileJS(file);
          var current = ts3.getTokenAtPosition(file, startPosition);
          var range = ts3.createTextRangeFromSpan(ts3.getRefactorContextSpan(context));
          var cursorRequest = range.pos === range.end && considerEmptySpans;
          var selection = ts3.findAncestor(current, function(node) {
            return node.parent && ts3.isTypeNode(node) && !rangeContainsSkipTrivia(range, node.parent, file) && (cursorRequest || ts3.nodeOverlapsWithStartEnd(current, file, range.pos, range.end));
          });
          if (!selection || !ts3.isTypeNode(selection))
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Selection_is_not_a_valid_type_node) };
          var checker = context.program.getTypeChecker();
          var firstStatement = ts3.Debug.checkDefined(ts3.findAncestor(selection, ts3.isStatement), "Should find a statement");
          var typeParameters = collectTypeParameters(checker, selection, firstStatement, file);
          if (!typeParameters)
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.No_type_could_be_extracted_from_this_type_node) };
          var typeElements = flattenTypeLiteralNodeReference(checker, selection);
          return { isJS, selection, firstStatement, typeParameters, typeElements };
        }
        function flattenTypeLiteralNodeReference(checker, node) {
          if (!node)
            return void 0;
          if (ts3.isIntersectionTypeNode(node)) {
            var result2 = [];
            var seen_1 = new ts3.Map();
            for (var _i = 0, _a = node.types; _i < _a.length; _i++) {
              var type2 = _a[_i];
              var flattenedTypeMembers = flattenTypeLiteralNodeReference(checker, type2);
              if (!flattenedTypeMembers || !flattenedTypeMembers.every(function(type3) {
                return type3.name && ts3.addToSeen(seen_1, ts3.getNameFromPropertyName(type3.name));
              })) {
                return void 0;
              }
              ts3.addRange(result2, flattenedTypeMembers);
            }
            return result2;
          } else if (ts3.isParenthesizedTypeNode(node)) {
            return flattenTypeLiteralNodeReference(checker, node.type);
          } else if (ts3.isTypeLiteralNode(node)) {
            return node.members;
          }
          return void 0;
        }
        function rangeContainsSkipTrivia(r1, node, file) {
          return ts3.rangeContainsStartEnd(r1, ts3.skipTrivia(file.text, node.pos), node.end);
        }
        function collectTypeParameters(checker, selection, statement, file) {
          var result2 = [];
          return visitor(selection) ? void 0 : result2;
          function visitor(node) {
            if (ts3.isTypeReferenceNode(node)) {
              if (ts3.isIdentifier(node.typeName)) {
                var typeName = node.typeName;
                var symbol = checker.resolveName(typeName.text, typeName, 262144, true);
                for (var _i = 0, _a = (symbol === null || symbol === void 0 ? void 0 : symbol.declarations) || ts3.emptyArray; _i < _a.length; _i++) {
                  var decl = _a[_i];
                  if (ts3.isTypeParameterDeclaration(decl) && decl.getSourceFile() === file) {
                    if (decl.name.escapedText === typeName.escapedText && rangeContainsSkipTrivia(decl, selection, file)) {
                      return true;
                    }
                    if (rangeContainsSkipTrivia(statement, decl, file) && !rangeContainsSkipTrivia(selection, decl, file)) {
                      ts3.pushIfUnique(result2, decl);
                      break;
                    }
                  }
                }
              }
            } else if (ts3.isInferTypeNode(node)) {
              var conditionalTypeNode = ts3.findAncestor(node, function(n) {
                return ts3.isConditionalTypeNode(n) && rangeContainsSkipTrivia(n.extendsType, node, file);
              });
              if (!conditionalTypeNode || !rangeContainsSkipTrivia(selection, conditionalTypeNode, file)) {
                return true;
              }
            } else if (ts3.isTypePredicateNode(node) || ts3.isThisTypeNode(node)) {
              var functionLikeNode = ts3.findAncestor(node.parent, ts3.isFunctionLike);
              if (functionLikeNode && functionLikeNode.type && rangeContainsSkipTrivia(functionLikeNode.type, node, file) && !rangeContainsSkipTrivia(selection, functionLikeNode, file)) {
                return true;
              }
            } else if (ts3.isTypeQueryNode(node)) {
              if (ts3.isIdentifier(node.exprName)) {
                var symbol = checker.resolveName(node.exprName.text, node.exprName, 111551, false);
                if ((symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration) && rangeContainsSkipTrivia(statement, symbol.valueDeclaration, file) && !rangeContainsSkipTrivia(selection, symbol.valueDeclaration, file)) {
                  return true;
                }
              } else {
                if (ts3.isThisIdentifier(node.exprName.left) && !rangeContainsSkipTrivia(selection, node.parent, file)) {
                  return true;
                }
              }
            }
            if (file && ts3.isTupleTypeNode(node) && ts3.getLineAndCharacterOfPosition(file, node.pos).line === ts3.getLineAndCharacterOfPosition(file, node.end).line) {
              ts3.setEmitFlags(node, 1);
            }
            return ts3.forEachChild(node, visitor);
          }
        }
        function doTypeAliasChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters;
          var newTypeNode = ts3.factory.createTypeAliasDeclaration(void 0, void 0, name, typeParameters.map(function(id) {
            return ts3.factory.updateTypeParameterDeclaration(id, id.modifiers, id.name, id.constraint, void 0);
          }), selection);
          changes.insertNodeBefore(file, firstStatement, ts3.ignoreSourceNewlines(newTypeNode), true);
          changes.replaceNode(file, selection, ts3.factory.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts3.factory.createTypeReferenceNode(id.name, void 0);
          })), { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.ExcludeWhitespace });
        }
        function doInterfaceChange(changes, file, name, info) {
          var _a;
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters, typeElements = info.typeElements;
          var newTypeNode = ts3.factory.createInterfaceDeclaration(void 0, void 0, name, typeParameters, void 0, typeElements);
          ts3.setTextRange(newTypeNode, (_a = typeElements[0]) === null || _a === void 0 ? void 0 : _a.parent);
          changes.insertNodeBefore(file, firstStatement, ts3.ignoreSourceNewlines(newTypeNode), true);
          changes.replaceNode(file, selection, ts3.factory.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts3.factory.createTypeReferenceNode(id.name, void 0);
          })), { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.ExcludeWhitespace });
        }
        function doTypedefChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters;
          ts3.setEmitFlags(selection, 1536 | 2048);
          var node = ts3.factory.createJSDocTypedefTag(ts3.factory.createIdentifier("typedef"), ts3.factory.createJSDocTypeExpression(selection), ts3.factory.createIdentifier(name));
          var templates = [];
          ts3.forEach(typeParameters, function(typeParameter) {
            var constraint = ts3.getEffectiveConstraintOfTypeParameter(typeParameter);
            var parameter = ts3.factory.createTypeParameterDeclaration(void 0, typeParameter.name);
            var template = ts3.factory.createJSDocTemplateTag(ts3.factory.createIdentifier("template"), constraint && ts3.cast(constraint, ts3.isJSDocTypeExpression), [parameter]);
            templates.push(template);
          });
          changes.insertNodeBefore(file, firstStatement, ts3.factory.createJSDocComment(void 0, ts3.factory.createNodeArray(ts3.concatenate(templates, [node]))), true);
          changes.replaceNode(file, selection, ts3.factory.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts3.factory.createTypeReferenceNode(id.name, void 0);
          })));
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var generateGetAccessorAndSetAccessor;
        (function(generateGetAccessorAndSetAccessor2) {
          var actionName = "Generate 'get' and 'set' accessors";
          var actionDescription = ts3.Diagnostics.Generate_get_and_set_accessors.message;
          var generateGetSetAction = {
            name: actionName,
            description: actionDescription,
            kind: "refactor.rewrite.property.generateAccessors"
          };
          refactor2.registerRefactor(actionName, {
            kinds: [generateGetSetAction.kind],
            getEditsForAction: function getRefactorActionsToGenerateGetAndSetAccessors(context, actionName2) {
              if (!context.endPosition)
                return void 0;
              var info = ts3.codefix.getAccessorConvertiblePropertyAtPosition(context.file, context.program, context.startPosition, context.endPosition);
              ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
              var edits = ts3.codefix.generateAccessorFromProperty(context.file, context.program, context.startPosition, context.endPosition, context, actionName2);
              if (!edits)
                return void 0;
              var renameFilename = context.file.fileName;
              var nameNeedRename = info.renameAccessor ? info.accessorName : info.fieldName;
              var renameLocationOffset = ts3.isIdentifier(nameNeedRename) ? 0 : -1;
              var renameLocation = renameLocationOffset + ts3.getRenameLocation(edits, renameFilename, nameNeedRename.text, ts3.isParameter(info.declaration));
              return { renameFilename, renameLocation, edits };
            },
            getAvailableActions: function(context) {
              if (!context.endPosition)
                return ts3.emptyArray;
              var info = ts3.codefix.getAccessorConvertiblePropertyAtPosition(context.file, context.program, context.startPosition, context.endPosition, context.triggerReason === "invoked");
              if (!info)
                return ts3.emptyArray;
              if (!refactor2.isRefactorErrorInfo(info)) {
                return [{
                  name: actionName,
                  description: actionDescription,
                  actions: [generateGetSetAction]
                }];
              }
              if (context.preferences.provideRefactorNotApplicableReason) {
                return [{
                  name: actionName,
                  description: actionDescription,
                  actions: [__assign(__assign({}, generateGetSetAction), { notApplicableReason: info.error })]
                }];
              }
              return ts3.emptyArray;
            }
          });
        })(generateGetAccessorAndSetAccessor = refactor2.generateGetAccessorAndSetAccessor || (refactor2.generateGetAccessorAndSetAccessor = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        ;
        function isRefactorErrorInfo(info) {
          return info.error !== void 0;
        }
        refactor2.isRefactorErrorInfo = isRefactorErrorInfo;
        function refactorKindBeginsWith(known, requested) {
          if (!requested)
            return true;
          return known.substr(0, requested.length) === requested;
        }
        refactor2.refactorKindBeginsWith = refactorKindBeginsWith;
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Move to a new file";
        var description = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Move_to_a_new_file);
        var moveToNewFileAction = {
          name: refactorName,
          description,
          kind: "refactor.move.newFile"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [moveToNewFileAction.kind],
          getAvailableActions: function getRefactorActionsToMoveToNewFile(context) {
            var statements = getStatementsToMove(context);
            if (context.preferences.allowTextChangesInNewFiles && statements) {
              return [{ name: refactorName, description, actions: [moveToNewFileAction] }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description,
                actions: [__assign(__assign({}, moveToNewFileAction), { notApplicableReason: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Selection_is_not_a_valid_statement_or_statements) })]
              }];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function getRefactorEditsToMoveToNewFile(context, actionName) {
            ts3.Debug.assert(actionName === refactorName, "Wrong refactor invoked");
            var statements = ts3.Debug.checkDefined(getStatementsToMove(context));
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program, statements, t, context.host, context.preferences);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getRangeToMove(context) {
          var file = context.file;
          var range = ts3.createTextRangeFromSpan(ts3.getRefactorContextSpan(context));
          var statements = file.statements;
          var startNodeIndex = ts3.findIndex(statements, function(s) {
            return s.end > range.pos;
          });
          if (startNodeIndex === -1)
            return void 0;
          var startStatement = statements[startNodeIndex];
          if (ts3.isNamedDeclaration(startStatement) && startStatement.name && ts3.rangeContainsRange(startStatement.name, range)) {
            return { toMove: [statements[startNodeIndex]], afterLast: statements[startNodeIndex + 1] };
          }
          if (range.pos > startStatement.getStart(file))
            return void 0;
          var afterEndNodeIndex = ts3.findIndex(statements, function(s) {
            return s.end > range.end;
          }, startNodeIndex);
          if (afterEndNodeIndex !== -1 && (afterEndNodeIndex === 0 || statements[afterEndNodeIndex].getStart(file) < range.end))
            return void 0;
          return {
            toMove: statements.slice(startNodeIndex, afterEndNodeIndex === -1 ? statements.length : afterEndNodeIndex),
            afterLast: afterEndNodeIndex === -1 ? void 0 : statements[afterEndNodeIndex]
          };
        }
        function doChange(oldFile, program2, toMove, changes, host, preferences) {
          var checker = program2.getTypeChecker();
          var usage = getUsageInfo(oldFile, toMove.all, checker);
          var currentDirectory = ts3.getDirectoryPath(oldFile.fileName);
          var extension = ts3.extensionFromPath(oldFile.fileName);
          var newModuleName = makeUniqueModuleName(getNewModuleName(usage.movedSymbols), extension, currentDirectory, host);
          var newFileNameWithExtension = newModuleName + extension;
          changes.createNewFile(oldFile, ts3.combinePaths(currentDirectory, newFileNameWithExtension), getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program2, newModuleName, preferences));
          addNewFileToTsconfig(program2, changes, oldFile.fileName, newFileNameWithExtension, ts3.hostGetCanonicalFileName(host));
        }
        function getStatementsToMove(context) {
          var rangeToMove = getRangeToMove(context);
          if (rangeToMove === void 0)
            return void 0;
          var all = [];
          var ranges = [];
          var toMove = rangeToMove.toMove, afterLast = rangeToMove.afterLast;
          ts3.getRangesWhere(toMove, isAllowedStatementToMove, function(start, afterEndIndex) {
            for (var i = start; i < afterEndIndex; i++)
              all.push(toMove[i]);
            ranges.push({ first: toMove[start], afterLast });
          });
          return all.length === 0 ? void 0 : { all, ranges };
        }
        function isAllowedStatementToMove(statement) {
          return !isPureImport(statement) && !ts3.isPrologueDirective(statement);
          ;
        }
        function isPureImport(node) {
          switch (node.kind) {
            case 266:
              return true;
            case 265:
              return !ts3.hasSyntacticModifier(node, 1);
            case 237:
              return node.declarationList.declarations.every(function(d) {
                return !!d.initializer && ts3.isRequireCall(d.initializer, true);
              });
            default:
              return false;
          }
        }
        function addNewFileToTsconfig(program2, changes, oldFileName, newFileNameWithExtension, getCanonicalFileName) {
          var cfg = program2.getCompilerOptions().configFile;
          if (!cfg)
            return;
          var newFileAbsolutePath = ts3.normalizePath(ts3.combinePaths(oldFileName, "..", newFileNameWithExtension));
          var newFilePath = ts3.getRelativePathFromFile(cfg.fileName, newFileAbsolutePath, getCanonicalFileName);
          var cfgObject = cfg.statements[0] && ts3.tryCast(cfg.statements[0].expression, ts3.isObjectLiteralExpression);
          var filesProp = cfgObject && ts3.find(cfgObject.properties, function(prop) {
            return ts3.isPropertyAssignment(prop) && ts3.isStringLiteral(prop.name) && prop.name.text === "files";
          });
          if (filesProp && ts3.isArrayLiteralExpression(filesProp.initializer)) {
            changes.insertNodeInListAfter(cfg, ts3.last(filesProp.initializer.elements), ts3.factory.createStringLiteral(newFilePath), filesProp.initializer.elements);
          }
        }
        function getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program2, newModuleName, preferences) {
          var checker = program2.getTypeChecker();
          var prologueDirectives = ts3.takeWhile(oldFile.statements, ts3.isPrologueDirective);
          if (!oldFile.externalModuleIndicator && !oldFile.commonJsModuleIndicator) {
            deleteMovedStatements(oldFile, toMove.ranges, changes);
            return __spreadArray(__spreadArray([], prologueDirectives, true), toMove.all, true);
          }
          var useEsModuleSyntax = !!oldFile.externalModuleIndicator;
          var quotePreference = ts3.getQuotePreference(oldFile, preferences);
          var importsFromNewFile = createOldFileImportsFromNewFile(usage.oldFileImportsFromNewFile, newModuleName, useEsModuleSyntax, quotePreference);
          if (importsFromNewFile) {
            ts3.insertImports(changes, oldFile, importsFromNewFile, true);
          }
          deleteUnusedOldImports(oldFile, toMove.all, changes, usage.unusedImportsFromOldFile, checker);
          deleteMovedStatements(oldFile, toMove.ranges, changes);
          updateImportsInOtherFiles(changes, program2, oldFile, usage.movedSymbols, newModuleName);
          var imports = getNewFileImportsAndAddExportInOldFile(oldFile, usage.oldImportsNeededByNewFile, usage.newFileImportsFromOldFile, changes, checker, useEsModuleSyntax, quotePreference);
          var body = addExports(oldFile, toMove.all, usage.oldFileImportsFromNewFile, useEsModuleSyntax);
          if (imports.length && body.length) {
            return __spreadArray(__spreadArray(__spreadArray(__spreadArray([], prologueDirectives, true), imports, true), [
              4
            ], false), body, true);
          }
          return __spreadArray(__spreadArray(__spreadArray([], prologueDirectives, true), imports, true), body, true);
        }
        function deleteMovedStatements(sourceFile, moved, changes) {
          for (var _i = 0, moved_1 = moved; _i < moved_1.length; _i++) {
            var _a = moved_1[_i], first_1 = _a.first, afterLast = _a.afterLast;
            changes.deleteNodeRangeExcludingEnd(sourceFile, first_1, afterLast);
          }
        }
        function deleteUnusedOldImports(oldFile, toMove, changes, toDelete, checker) {
          for (var _i = 0, _a = oldFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (ts3.contains(toMove, statement))
              continue;
            forEachImportInStatement(statement, function(i) {
              return deleteUnusedImports(oldFile, i, changes, function(name) {
                return toDelete.has(checker.getSymbolAtLocation(name));
              });
            });
          }
        }
        function updateImportsInOtherFiles(changes, program2, oldFile, movedSymbols, newModuleName) {
          var checker = program2.getTypeChecker();
          var _loop_19 = function(sourceFile2) {
            if (sourceFile2 === oldFile)
              return "continue";
            var _loop_20 = function(statement2) {
              forEachImportInStatement(statement2, function(importNode) {
                if (checker.getSymbolAtLocation(moduleSpecifierFromImport(importNode)) !== oldFile.symbol)
                  return;
                var shouldMove = function(name) {
                  var symbol = ts3.isBindingElement(name.parent) ? ts3.getPropertySymbolFromBindingElement(checker, name.parent) : ts3.skipAlias(checker.getSymbolAtLocation(name), checker);
                  return !!symbol && movedSymbols.has(symbol);
                };
                deleteUnusedImports(sourceFile2, importNode, changes, shouldMove);
                var newModuleSpecifier = ts3.combinePaths(ts3.getDirectoryPath(moduleSpecifierFromImport(importNode).text), newModuleName);
                var newImportDeclaration = filterImport(importNode, ts3.factory.createStringLiteral(newModuleSpecifier), shouldMove);
                if (newImportDeclaration)
                  changes.insertNodeAfter(sourceFile2, statement2, newImportDeclaration);
                var ns = getNamespaceLikeImport(importNode);
                if (ns)
                  updateNamespaceLikeImport(changes, sourceFile2, checker, movedSymbols, newModuleName, newModuleSpecifier, ns, importNode);
              });
            };
            for (var _b = 0, _c = sourceFile2.statements; _b < _c.length; _b++) {
              var statement = _c[_b];
              _loop_20(statement);
            }
          };
          for (var _i = 0, _a = program2.getSourceFiles(); _i < _a.length; _i++) {
            var sourceFile = _a[_i];
            _loop_19(sourceFile);
          }
        }
        function getNamespaceLikeImport(node) {
          switch (node.kind) {
            case 266:
              return node.importClause && node.importClause.namedBindings && node.importClause.namedBindings.kind === 268 ? node.importClause.namedBindings.name : void 0;
            case 265:
              return node.name;
            case 254:
              return ts3.tryCast(node.name, ts3.isIdentifier);
            default:
              return ts3.Debug.assertNever(node, "Unexpected node kind ".concat(node.kind));
          }
        }
        function updateNamespaceLikeImport(changes, sourceFile, checker, movedSymbols, newModuleName, newModuleSpecifier, oldImportId, oldImportNode) {
          var preferredNewNamespaceName = ts3.codefix.moduleSpecifierToValidIdentifier(newModuleName, 99);
          var needUniqueName = false;
          var toChange = [];
          ts3.FindAllReferences.Core.eachSymbolReferenceInFile(oldImportId, checker, sourceFile, function(ref2) {
            if (!ts3.isPropertyAccessExpression(ref2.parent))
              return;
            needUniqueName = needUniqueName || !!checker.resolveName(preferredNewNamespaceName, ref2, 67108863, true);
            if (movedSymbols.has(checker.getSymbolAtLocation(ref2.parent.name))) {
              toChange.push(ref2);
            }
          });
          if (toChange.length) {
            var newNamespaceName = needUniqueName ? ts3.getUniqueName(preferredNewNamespaceName, sourceFile) : preferredNewNamespaceName;
            for (var _i = 0, toChange_1 = toChange; _i < toChange_1.length; _i++) {
              var ref = toChange_1[_i];
              changes.replaceNode(sourceFile, ref, ts3.factory.createIdentifier(newNamespaceName));
            }
            changes.insertNodeAfter(sourceFile, oldImportNode, updateNamespaceLikeImportNode(oldImportNode, newModuleName, newModuleSpecifier));
          }
        }
        function updateNamespaceLikeImportNode(node, newNamespaceName, newModuleSpecifier) {
          var newNamespaceId = ts3.factory.createIdentifier(newNamespaceName);
          var newModuleString = ts3.factory.createStringLiteral(newModuleSpecifier);
          switch (node.kind) {
            case 266:
              return ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamespaceImport(newNamespaceId)), newModuleString, void 0);
            case 265:
              return ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, newNamespaceId, ts3.factory.createExternalModuleReference(newModuleString));
            case 254:
              return ts3.factory.createVariableDeclaration(newNamespaceId, void 0, void 0, createRequireCall(newModuleString));
            default:
              return ts3.Debug.assertNever(node, "Unexpected node kind ".concat(node.kind));
          }
        }
        function moduleSpecifierFromImport(i) {
          return i.kind === 266 ? i.moduleSpecifier : i.kind === 265 ? i.moduleReference.expression : i.initializer.arguments[0];
        }
        function forEachImportInStatement(statement, cb) {
          if (ts3.isImportDeclaration(statement)) {
            if (ts3.isStringLiteral(statement.moduleSpecifier))
              cb(statement);
          } else if (ts3.isImportEqualsDeclaration(statement)) {
            if (ts3.isExternalModuleReference(statement.moduleReference) && ts3.isStringLiteralLike(statement.moduleReference.expression)) {
              cb(statement);
            }
          } else if (ts3.isVariableStatement(statement)) {
            for (var _i = 0, _a = statement.declarationList.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              if (decl.initializer && ts3.isRequireCall(decl.initializer, true)) {
                cb(decl);
              }
            }
          }
        }
        function createOldFileImportsFromNewFile(newFileNeedExport, newFileNameWithExtension, useEs6Imports, quotePreference) {
          var defaultImport;
          var imports = [];
          newFileNeedExport.forEach(function(symbol) {
            if (symbol.escapedName === "default") {
              defaultImport = ts3.factory.createIdentifier(ts3.symbolNameNoDefault(symbol));
            } else {
              imports.push(symbol.name);
            }
          });
          return makeImportOrRequire(defaultImport, imports, newFileNameWithExtension, useEs6Imports, quotePreference);
        }
        function makeImportOrRequire(defaultImport, imports, path2, useEs6Imports, quotePreference) {
          path2 = ts3.ensurePathIsNonModuleName(path2);
          if (useEs6Imports) {
            var specifiers = imports.map(function(i) {
              return ts3.factory.createImportSpecifier(false, void 0, ts3.factory.createIdentifier(i));
            });
            return ts3.makeImportIfNecessary(defaultImport, specifiers, path2, quotePreference);
          } else {
            ts3.Debug.assert(!defaultImport, "No default import should exist");
            var bindingElements = imports.map(function(i) {
              return ts3.factory.createBindingElement(void 0, void 0, i);
            });
            return bindingElements.length ? makeVariableStatement(ts3.factory.createObjectBindingPattern(bindingElements), void 0, createRequireCall(ts3.factory.createStringLiteral(path2))) : void 0;
          }
        }
        function makeVariableStatement(name, type2, initializer, flags) {
          if (flags === void 0) {
            flags = 2;
          }
          return ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(name, void 0, type2, initializer)], flags));
        }
        function createRequireCall(moduleSpecifier) {
          return ts3.factory.createCallExpression(ts3.factory.createIdentifier("require"), void 0, [moduleSpecifier]);
        }
        function addExports(sourceFile, toMove, needExport, useEs6Exports) {
          return ts3.flatMap(toMove, function(statement) {
            if (isTopLevelDeclarationStatement(statement) && !isExported(sourceFile, statement, useEs6Exports) && forEachTopLevelDeclaration(statement, function(d) {
              return needExport.has(ts3.Debug.checkDefined(d.symbol));
            })) {
              var exports2 = addExport(statement, useEs6Exports);
              if (exports2)
                return exports2;
            }
            return statement;
          });
        }
        function deleteUnusedImports(sourceFile, importDecl, changes, isUnused) {
          switch (importDecl.kind) {
            case 266:
              deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused);
              break;
            case 265:
              if (isUnused(importDecl.name)) {
                changes.delete(sourceFile, importDecl);
              }
              break;
            case 254:
              deleteUnusedImportsInVariableDeclaration(sourceFile, importDecl, changes, isUnused);
              break;
            default:
              ts3.Debug.assertNever(importDecl, "Unexpected import decl kind ".concat(importDecl.kind));
          }
        }
        function deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused) {
          if (!importDecl.importClause)
            return;
          var _a = importDecl.importClause, name = _a.name, namedBindings = _a.namedBindings;
          var defaultUnused = !name || isUnused(name);
          var namedBindingsUnused = !namedBindings || (namedBindings.kind === 268 ? isUnused(namedBindings.name) : namedBindings.elements.length !== 0 && namedBindings.elements.every(function(e) {
            return isUnused(e.name);
          }));
          if (defaultUnused && namedBindingsUnused) {
            changes.delete(sourceFile, importDecl);
          } else {
            if (name && defaultUnused) {
              changes.delete(sourceFile, name);
            }
            if (namedBindings) {
              if (namedBindingsUnused) {
                changes.replaceNode(sourceFile, importDecl.importClause, ts3.factory.updateImportClause(importDecl.importClause, importDecl.importClause.isTypeOnly, name, void 0));
              } else if (namedBindings.kind === 269) {
                for (var _i = 0, _b = namedBindings.elements; _i < _b.length; _i++) {
                  var element = _b[_i];
                  if (isUnused(element.name))
                    changes.delete(sourceFile, element);
                }
              }
            }
          }
        }
        function deleteUnusedImportsInVariableDeclaration(sourceFile, varDecl, changes, isUnused) {
          var name = varDecl.name;
          switch (name.kind) {
            case 79:
              if (isUnused(name)) {
                changes.delete(sourceFile, name);
              }
              break;
            case 202:
              break;
            case 201:
              if (name.elements.every(function(e) {
                return ts3.isIdentifier(e.name) && isUnused(e.name);
              })) {
                changes.delete(sourceFile, ts3.isVariableDeclarationList(varDecl.parent) && varDecl.parent.declarations.length === 1 ? varDecl.parent.parent : varDecl);
              } else {
                for (var _i = 0, _a = name.elements; _i < _a.length; _i++) {
                  var element = _a[_i];
                  if (ts3.isIdentifier(element.name) && isUnused(element.name)) {
                    changes.delete(sourceFile, element.name);
                  }
                }
              }
              break;
          }
        }
        function getNewFileImportsAndAddExportInOldFile(oldFile, importsToCopy, newFileImportsFromOldFile, changes, checker, useEsModuleSyntax, quotePreference) {
          var copiedOldImports = [];
          for (var _i = 0, _a = oldFile.statements; _i < _a.length; _i++) {
            var oldStatement = _a[_i];
            forEachImportInStatement(oldStatement, function(i) {
              ts3.append(copiedOldImports, filterImport(i, moduleSpecifierFromImport(i), function(name) {
                return importsToCopy.has(checker.getSymbolAtLocation(name));
              }));
            });
          }
          var oldFileDefault;
          var oldFileNamedImports = [];
          var markSeenTop = ts3.nodeSeenTracker();
          newFileImportsFromOldFile.forEach(function(symbol) {
            if (!symbol.declarations) {
              return;
            }
            for (var _i2 = 0, _a2 = symbol.declarations; _i2 < _a2.length; _i2++) {
              var decl = _a2[_i2];
              if (!isTopLevelDeclaration(decl))
                continue;
              var name = nameOfTopLevelDeclaration(decl);
              if (!name)
                continue;
              var top = getTopLevelDeclarationStatement(decl);
              if (markSeenTop(top)) {
                addExportToChanges(oldFile, top, name, changes, useEsModuleSyntax);
              }
              if (ts3.hasSyntacticModifier(decl, 512)) {
                oldFileDefault = name;
              } else {
                oldFileNamedImports.push(name.text);
              }
            }
          });
          ts3.append(copiedOldImports, makeImportOrRequire(oldFileDefault, oldFileNamedImports, ts3.removeFileExtension(ts3.getBaseFileName(oldFile.fileName)), useEsModuleSyntax, quotePreference));
          return copiedOldImports;
        }
        function makeUniqueModuleName(moduleName, extension, inDirectory, host) {
          var newModuleName = moduleName;
          for (var i = 1; ; i++) {
            var name = ts3.combinePaths(inDirectory, newModuleName + extension);
            if (!host.fileExists(name))
              return newModuleName;
            newModuleName = "".concat(moduleName, ".").concat(i);
          }
        }
        function getNewModuleName(movedSymbols) {
          return movedSymbols.forEachEntry(ts3.symbolNameNoDefault) || "newFile";
        }
        function getUsageInfo(oldFile, toMove, checker) {
          var movedSymbols = new SymbolSet();
          var oldImportsNeededByNewFile = new SymbolSet();
          var newFileImportsFromOldFile = new SymbolSet();
          var containsJsx = ts3.find(toMove, function(statement2) {
            return !!(statement2.transformFlags & 2);
          });
          var jsxNamespaceSymbol = getJsxNamespaceSymbol(containsJsx);
          if (jsxNamespaceSymbol) {
            oldImportsNeededByNewFile.add(jsxNamespaceSymbol);
          }
          for (var _i = 0, toMove_1 = toMove; _i < toMove_1.length; _i++) {
            var statement = toMove_1[_i];
            forEachTopLevelDeclaration(statement, function(decl) {
              movedSymbols.add(ts3.Debug.checkDefined(ts3.isExpressionStatement(decl) ? checker.getSymbolAtLocation(decl.expression.left) : decl.symbol, "Need a symbol here"));
            });
          }
          for (var _a = 0, toMove_2 = toMove; _a < toMove_2.length; _a++) {
            var statement = toMove_2[_a];
            forEachReference(statement, checker, function(symbol) {
              if (!symbol.declarations)
                return;
              for (var _i2 = 0, _a2 = symbol.declarations; _i2 < _a2.length; _i2++) {
                var decl = _a2[_i2];
                if (isInImport(decl)) {
                  oldImportsNeededByNewFile.add(symbol);
                } else if (isTopLevelDeclaration(decl) && sourceFileOfTopLevelDeclaration(decl) === oldFile && !movedSymbols.has(symbol)) {
                  newFileImportsFromOldFile.add(symbol);
                }
              }
            });
          }
          var unusedImportsFromOldFile = oldImportsNeededByNewFile.clone();
          var oldFileImportsFromNewFile = new SymbolSet();
          for (var _b = 0, _c = oldFile.statements; _b < _c.length; _b++) {
            var statement = _c[_b];
            if (ts3.contains(toMove, statement))
              continue;
            if (jsxNamespaceSymbol && !!(statement.transformFlags & 2)) {
              unusedImportsFromOldFile.delete(jsxNamespaceSymbol);
            }
            forEachReference(statement, checker, function(symbol) {
              if (movedSymbols.has(symbol))
                oldFileImportsFromNewFile.add(symbol);
              unusedImportsFromOldFile.delete(symbol);
            });
          }
          return { movedSymbols, newFileImportsFromOldFile, oldFileImportsFromNewFile, oldImportsNeededByNewFile, unusedImportsFromOldFile };
          function getJsxNamespaceSymbol(containsJsx2) {
            if (containsJsx2 === void 0) {
              return void 0;
            }
            var jsxNamespace = checker.getJsxNamespace(containsJsx2);
            var jsxNamespaceSymbol2 = checker.resolveName(jsxNamespace, containsJsx2, 1920, true);
            return !!jsxNamespaceSymbol2 && ts3.some(jsxNamespaceSymbol2.declarations, isInImport) ? jsxNamespaceSymbol2 : void 0;
          }
        }
        function isInImport(decl) {
          switch (decl.kind) {
            case 265:
            case 270:
            case 267:
            case 268:
              return true;
            case 254:
              return isVariableDeclarationInImport(decl);
            case 203:
              return ts3.isVariableDeclaration(decl.parent.parent) && isVariableDeclarationInImport(decl.parent.parent);
            default:
              return false;
          }
        }
        function isVariableDeclarationInImport(decl) {
          return ts3.isSourceFile(decl.parent.parent.parent) && !!decl.initializer && ts3.isRequireCall(decl.initializer, true);
        }
        function filterImport(i, moduleSpecifier, keep) {
          switch (i.kind) {
            case 266: {
              var clause = i.importClause;
              if (!clause)
                return void 0;
              var defaultImport = clause.name && keep(clause.name) ? clause.name : void 0;
              var namedBindings = clause.namedBindings && filterNamedBindings(clause.namedBindings, keep);
              return defaultImport || namedBindings ? ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, defaultImport, namedBindings), moduleSpecifier, void 0) : void 0;
            }
            case 265:
              return keep(i.name) ? i : void 0;
            case 254: {
              var name = filterBindingName(i.name, keep);
              return name ? makeVariableStatement(name, i.type, createRequireCall(moduleSpecifier), i.parent.flags) : void 0;
            }
            default:
              return ts3.Debug.assertNever(i, "Unexpected import kind ".concat(i.kind));
          }
        }
        function filterNamedBindings(namedBindings, keep) {
          if (namedBindings.kind === 268) {
            return keep(namedBindings.name) ? namedBindings : void 0;
          } else {
            var newElements = namedBindings.elements.filter(function(e) {
              return keep(e.name);
            });
            return newElements.length ? ts3.factory.createNamedImports(newElements) : void 0;
          }
        }
        function filterBindingName(name, keep) {
          switch (name.kind) {
            case 79:
              return keep(name) ? name : void 0;
            case 202:
              return name;
            case 201: {
              var newElements = name.elements.filter(function(prop) {
                return prop.propertyName || !ts3.isIdentifier(prop.name) || keep(prop.name);
              });
              return newElements.length ? ts3.factory.createObjectBindingPattern(newElements) : void 0;
            }
          }
        }
        function forEachReference(node, checker, onReference) {
          node.forEachChild(function cb(node2) {
            if (ts3.isIdentifier(node2) && !ts3.isDeclarationName(node2)) {
              var sym = checker.getSymbolAtLocation(node2);
              if (sym)
                onReference(sym);
            } else {
              node2.forEachChild(cb);
            }
          });
        }
        var SymbolSet = function() {
          function SymbolSet2() {
            this.map = new ts3.Map();
          }
          SymbolSet2.prototype.add = function(symbol) {
            this.map.set(String(ts3.getSymbolId(symbol)), symbol);
          };
          SymbolSet2.prototype.has = function(symbol) {
            return this.map.has(String(ts3.getSymbolId(symbol)));
          };
          SymbolSet2.prototype.delete = function(symbol) {
            this.map.delete(String(ts3.getSymbolId(symbol)));
          };
          SymbolSet2.prototype.forEach = function(cb) {
            this.map.forEach(cb);
          };
          SymbolSet2.prototype.forEachEntry = function(cb) {
            return ts3.forEachEntry(this.map, cb);
          };
          SymbolSet2.prototype.clone = function() {
            var clone = new SymbolSet2();
            ts3.copyEntries(this.map, clone.map);
            return clone;
          };
          return SymbolSet2;
        }();
        function isTopLevelDeclaration(node) {
          return isNonVariableTopLevelDeclaration(node) && ts3.isSourceFile(node.parent) || ts3.isVariableDeclaration(node) && ts3.isSourceFile(node.parent.parent.parent);
        }
        function sourceFileOfTopLevelDeclaration(node) {
          return ts3.isVariableDeclaration(node) ? node.parent.parent.parent : node.parent;
        }
        function isTopLevelDeclarationStatement(node) {
          ts3.Debug.assert(ts3.isSourceFile(node.parent), "Node parent should be a SourceFile");
          return isNonVariableTopLevelDeclaration(node) || ts3.isVariableStatement(node);
        }
        function isNonVariableTopLevelDeclaration(node) {
          switch (node.kind) {
            case 256:
            case 257:
            case 261:
            case 260:
            case 259:
            case 258:
            case 265:
              return true;
            default:
              return false;
          }
        }
        function forEachTopLevelDeclaration(statement, cb) {
          switch (statement.kind) {
            case 256:
            case 257:
            case 261:
            case 260:
            case 259:
            case 258:
            case 265:
              return cb(statement);
            case 237:
              return ts3.firstDefined(statement.declarationList.declarations, function(decl) {
                return forEachTopLevelDeclarationInBindingName(decl.name, cb);
              });
            case 238: {
              var expression = statement.expression;
              return ts3.isBinaryExpression(expression) && ts3.getAssignmentDeclarationKind(expression) === 1 ? cb(statement) : void 0;
            }
          }
        }
        function forEachTopLevelDeclarationInBindingName(name, cb) {
          switch (name.kind) {
            case 79:
              return cb(ts3.cast(name.parent, function(x) {
                return ts3.isVariableDeclaration(x) || ts3.isBindingElement(x);
              }));
            case 202:
            case 201:
              return ts3.firstDefined(name.elements, function(em) {
                return ts3.isOmittedExpression(em) ? void 0 : forEachTopLevelDeclarationInBindingName(em.name, cb);
              });
            default:
              return ts3.Debug.assertNever(name, "Unexpected name kind ".concat(name.kind));
          }
        }
        function nameOfTopLevelDeclaration(d) {
          return ts3.isExpressionStatement(d) ? ts3.tryCast(d.expression.left.name, ts3.isIdentifier) : ts3.tryCast(d.name, ts3.isIdentifier);
        }
        function getTopLevelDeclarationStatement(d) {
          switch (d.kind) {
            case 254:
              return d.parent.parent;
            case 203:
              return getTopLevelDeclarationStatement(ts3.cast(d.parent.parent, function(p) {
                return ts3.isVariableDeclaration(p) || ts3.isBindingElement(p);
              }));
            default:
              return d;
          }
        }
        function addExportToChanges(sourceFile, decl, name, changes, useEs6Exports) {
          if (isExported(sourceFile, decl, useEs6Exports, name))
            return;
          if (useEs6Exports) {
            if (!ts3.isExpressionStatement(decl))
              changes.insertExportModifier(sourceFile, decl);
          } else {
            var names = getNamesToExportInCommonJS(decl);
            if (names.length !== 0)
              changes.insertNodesAfter(sourceFile, decl, names.map(createExportAssignment));
          }
        }
        function isExported(sourceFile, decl, useEs6Exports, name) {
          var _a;
          if (useEs6Exports) {
            return !ts3.isExpressionStatement(decl) && ts3.hasSyntacticModifier(decl, 1) || !!(name && ((_a = sourceFile.symbol.exports) === null || _a === void 0 ? void 0 : _a.has(name.escapedText)));
          }
          return getNamesToExportInCommonJS(decl).some(function(name2) {
            return sourceFile.symbol.exports.has(ts3.escapeLeadingUnderscores(name2));
          });
        }
        function addExport(decl, useEs6Exports) {
          return useEs6Exports ? [addEs6Export(decl)] : addCommonjsExport(decl);
        }
        function addEs6Export(d) {
          var modifiers = ts3.concatenate([ts3.factory.createModifier(93)], d.modifiers);
          switch (d.kind) {
            case 256:
              return ts3.factory.updateFunctionDeclaration(d, d.decorators, modifiers, d.asteriskToken, d.name, d.typeParameters, d.parameters, d.type, d.body);
            case 257:
              return ts3.factory.updateClassDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
            case 237:
              return ts3.factory.updateVariableStatement(d, modifiers, d.declarationList);
            case 261:
              return ts3.factory.updateModuleDeclaration(d, d.decorators, modifiers, d.name, d.body);
            case 260:
              return ts3.factory.updateEnumDeclaration(d, d.decorators, modifiers, d.name, d.members);
            case 259:
              return ts3.factory.updateTypeAliasDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.type);
            case 258:
              return ts3.factory.updateInterfaceDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
            case 265:
              return ts3.factory.updateImportEqualsDeclaration(d, d.decorators, modifiers, d.isTypeOnly, d.name, d.moduleReference);
            case 238:
              return ts3.Debug.fail();
            default:
              return ts3.Debug.assertNever(d, "Unexpected declaration kind ".concat(d.kind));
          }
        }
        function addCommonjsExport(decl) {
          return __spreadArray([decl], getNamesToExportInCommonJS(decl).map(createExportAssignment), true);
        }
        function getNamesToExportInCommonJS(decl) {
          switch (decl.kind) {
            case 256:
            case 257:
              return [decl.name.text];
            case 237:
              return ts3.mapDefined(decl.declarationList.declarations, function(d) {
                return ts3.isIdentifier(d.name) ? d.name.text : void 0;
              });
            case 261:
            case 260:
            case 259:
            case 258:
            case 265:
              return ts3.emptyArray;
            case 238:
              return ts3.Debug.fail("Can't export an ExpressionStatement");
            default:
              return ts3.Debug.assertNever(decl, "Unexpected decl kind ".concat(decl.kind));
          }
        }
        function createExportAssignment(name) {
          return ts3.factory.createExpressionStatement(ts3.factory.createBinaryExpression(ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier("exports"), ts3.factory.createIdentifier(name)), 63, ts3.factory.createIdentifier(name)));
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var addOrRemoveBracesToArrowFunction;
        (function(addOrRemoveBracesToArrowFunction2) {
          var refactorName = "Add or remove braces in an arrow function";
          var refactorDescription = ts3.Diagnostics.Add_or_remove_braces_in_an_arrow_function.message;
          var addBracesAction = {
            name: "Add braces to arrow function",
            description: ts3.Diagnostics.Add_braces_to_arrow_function.message,
            kind: "refactor.rewrite.arrow.braces.add"
          };
          var removeBracesAction = {
            name: "Remove braces from arrow function",
            description: ts3.Diagnostics.Remove_braces_from_arrow_function.message,
            kind: "refactor.rewrite.arrow.braces.remove"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [removeBracesAction.kind],
            getEditsForAction: getRefactorEditsToRemoveFunctionBraces,
            getAvailableActions: getRefactorActionsToRemoveFunctionBraces
          });
          function getRefactorActionsToRemoveFunctionBraces(context) {
            var file = context.file, startPosition = context.startPosition, triggerReason = context.triggerReason;
            var info = getConvertibleArrowFunctionAtPosition(file, startPosition, triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [
                  info.addBraces ? addBracesAction : removeBracesAction
                ]
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [
                  __assign(__assign({}, addBracesAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, removeBracesAction), { notApplicableReason: info.error })
                ]
              }];
            }
            return ts3.emptyArray;
          }
          function getRefactorEditsToRemoveFunctionBraces(context, actionName) {
            var file = context.file, startPosition = context.startPosition;
            var info = getConvertibleArrowFunctionAtPosition(file, startPosition);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var expression = info.expression, returnStatement = info.returnStatement, func = info.func;
            var body;
            if (actionName === addBracesAction.name) {
              var returnStatement_1 = ts3.factory.createReturnStatement(expression);
              body = ts3.factory.createBlock([returnStatement_1], true);
              ts3.copyLeadingComments(expression, returnStatement_1, file, 3, true);
            } else if (actionName === removeBracesAction.name && returnStatement) {
              var actualExpression = expression || ts3.factory.createVoidZero();
              body = ts3.needsParentheses(actualExpression) ? ts3.factory.createParenthesizedExpression(actualExpression) : actualExpression;
              ts3.copyTrailingAsLeadingComments(returnStatement, body, file, 3, false);
              ts3.copyLeadingComments(returnStatement, body, file, 3, false);
              ts3.copyTrailingComments(returnStatement, body, file, 3, false);
            } else {
              ts3.Debug.fail("invalid action");
            }
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
              t.replaceNode(file, func.body, body);
            });
            return { renameFilename: void 0, renameLocation: void 0, edits };
          }
          function getConvertibleArrowFunctionAtPosition(file, startPosition, considerFunctionBodies, kind) {
            if (considerFunctionBodies === void 0) {
              considerFunctionBodies = true;
            }
            var node = ts3.getTokenAtPosition(file, startPosition);
            var func = ts3.getContainingFunction(node);
            if (!func) {
              return {
                error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_a_containing_arrow_function)
              };
            }
            if (!ts3.isArrowFunction(func)) {
              return {
                error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Containing_function_is_not_an_arrow_function)
              };
            }
            if (!ts3.rangeContainsRange(func, node) || ts3.rangeContainsRange(func.body, node) && !considerFunctionBodies) {
              return void 0;
            }
            if (refactor2.refactorKindBeginsWith(addBracesAction.kind, kind) && ts3.isExpression(func.body)) {
              return { func, addBraces: true, expression: func.body };
            } else if (refactor2.refactorKindBeginsWith(removeBracesAction.kind, kind) && ts3.isBlock(func.body) && func.body.statements.length === 1) {
              var firstStatement = ts3.first(func.body.statements);
              if (ts3.isReturnStatement(firstStatement)) {
                return { func, addBraces: false, expression: firstStatement.expression, returnStatement: firstStatement };
              }
            }
            return void 0;
          }
        })(addOrRemoveBracesToArrowFunction = refactor2.addOrRemoveBracesToArrowFunction || (refactor2.addOrRemoveBracesToArrowFunction = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertParamsToDestructuredObject;
        (function(convertParamsToDestructuredObject2) {
          var refactorName = "Convert parameters to destructured object";
          var minimumParameterLength = 1;
          var refactorDescription = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_parameters_to_destructured_object);
          var toDestructuredAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.parameters.toDestructured"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [toDestructuredAction.kind],
            getEditsForAction: getRefactorEditsToConvertParametersToDestructuredObject,
            getAvailableActions: getRefactorActionsToConvertParametersToDestructuredObject
          });
          function getRefactorActionsToConvertParametersToDestructuredObject(context) {
            var file = context.file, startPosition = context.startPosition;
            var isJSFile = ts3.isSourceFileJS(file);
            if (isJSFile)
              return ts3.emptyArray;
            var functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, context.program.getTypeChecker());
            if (!functionDeclaration)
              return ts3.emptyArray;
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: [toDestructuredAction]
            }];
          }
          function getRefactorEditsToConvertParametersToDestructuredObject(context, actionName) {
            ts3.Debug.assert(actionName === refactorName, "Unexpected action name");
            var file = context.file, startPosition = context.startPosition, program2 = context.program, cancellationToken = context.cancellationToken, host = context.host;
            var functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, program2.getTypeChecker());
            if (!functionDeclaration || !cancellationToken)
              return void 0;
            var groupedReferences = getGroupedReferences(functionDeclaration, program2, cancellationToken);
            if (groupedReferences.valid) {
              var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return doChange(file, program2, host, t, functionDeclaration, groupedReferences);
              });
              return { renameFilename: void 0, renameLocation: void 0, edits };
            }
            return { edits: [] };
          }
          function doChange(sourceFile, program2, host, changes, functionDeclaration, groupedReferences) {
            var signature = groupedReferences.signature;
            var newFunctionDeclarationParams = ts3.map(createNewParameters(functionDeclaration, program2, host), function(param) {
              return ts3.getSynthesizedDeepClone(param);
            });
            if (signature) {
              var newSignatureParams = ts3.map(createNewParameters(signature, program2, host), function(param) {
                return ts3.getSynthesizedDeepClone(param);
              });
              replaceParameters(signature, newSignatureParams);
            }
            replaceParameters(functionDeclaration, newFunctionDeclarationParams);
            var functionCalls = ts3.sortAndDeduplicate(groupedReferences.functionCalls, function(a, b) {
              return ts3.compareValues(a.pos, b.pos);
            });
            for (var _i = 0, functionCalls_1 = functionCalls; _i < functionCalls_1.length; _i++) {
              var call = functionCalls_1[_i];
              if (call.arguments && call.arguments.length) {
                var newArgument = ts3.getSynthesizedDeepClone(createNewArgument(functionDeclaration, call.arguments), true);
                changes.replaceNodeRange(ts3.getSourceFileOfNode(call), ts3.first(call.arguments), ts3.last(call.arguments), newArgument, { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include });
              }
            }
            function replaceParameters(declarationOrSignature, parameterDeclarations) {
              changes.replaceNodeRangeWithNodes(sourceFile, ts3.first(declarationOrSignature.parameters), ts3.last(declarationOrSignature.parameters), parameterDeclarations, {
                joiner: ", ",
                indentation: 0,
                leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll,
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include
              });
            }
          }
          function getGroupedReferences(functionDeclaration, program2, cancellationToken) {
            var functionNames = getFunctionNames(functionDeclaration);
            var classNames = ts3.isConstructorDeclaration(functionDeclaration) ? getClassNames(functionDeclaration) : [];
            var names = ts3.deduplicate(__spreadArray(__spreadArray([], functionNames, true), classNames, true), ts3.equateValues);
            var checker = program2.getTypeChecker();
            var references = ts3.flatMap(names, function(name) {
              return ts3.FindAllReferences.getReferenceEntriesForNode(-1, name, program2, program2.getSourceFiles(), cancellationToken);
            });
            var groupedReferences = groupReferences(references);
            if (!ts3.every(groupedReferences.declarations, function(decl) {
              return ts3.contains(names, decl);
            })) {
              groupedReferences.valid = false;
            }
            return groupedReferences;
            function groupReferences(referenceEntries) {
              var classReferences = { accessExpressions: [], typeUsages: [] };
              var groupedReferences2 = { functionCalls: [], declarations: [], classReferences, valid: true };
              var functionSymbols = ts3.map(functionNames, getSymbolTargetAtLocation);
              var classSymbols = ts3.map(classNames, getSymbolTargetAtLocation);
              var isConstructor = ts3.isConstructorDeclaration(functionDeclaration);
              var contextualSymbols = ts3.map(functionNames, function(name) {
                return getSymbolForContextualType(name, checker);
              });
              for (var _i = 0, referenceEntries_1 = referenceEntries; _i < referenceEntries_1.length; _i++) {
                var entry = referenceEntries_1[_i];
                if (entry.kind === 0) {
                  groupedReferences2.valid = false;
                  continue;
                }
                if (ts3.contains(contextualSymbols, getSymbolTargetAtLocation(entry.node))) {
                  if (isValidMethodSignature(entry.node.parent)) {
                    groupedReferences2.signature = entry.node.parent;
                    continue;
                  }
                  var call = entryToFunctionCall(entry);
                  if (call) {
                    groupedReferences2.functionCalls.push(call);
                    continue;
                  }
                }
                var contextualSymbol = getSymbolForContextualType(entry.node, checker);
                if (contextualSymbol && ts3.contains(contextualSymbols, contextualSymbol)) {
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                }
                if (ts3.contains(functionSymbols, getSymbolTargetAtLocation(entry.node)) || ts3.isNewExpressionTarget(entry.node)) {
                  var importOrExportReference = entryToImportOrExport(entry);
                  if (importOrExportReference) {
                    continue;
                  }
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                  var call = entryToFunctionCall(entry);
                  if (call) {
                    groupedReferences2.functionCalls.push(call);
                    continue;
                  }
                }
                if (isConstructor && ts3.contains(classSymbols, getSymbolTargetAtLocation(entry.node))) {
                  var importOrExportReference = entryToImportOrExport(entry);
                  if (importOrExportReference) {
                    continue;
                  }
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                  var accessExpression = entryToAccessExpression(entry);
                  if (accessExpression) {
                    classReferences.accessExpressions.push(accessExpression);
                    continue;
                  }
                  if (ts3.isClassDeclaration(functionDeclaration.parent)) {
                    var type2 = entryToType(entry);
                    if (type2) {
                      classReferences.typeUsages.push(type2);
                      continue;
                    }
                  }
                }
                groupedReferences2.valid = false;
              }
              return groupedReferences2;
            }
            function getSymbolTargetAtLocation(node) {
              var symbol = checker.getSymbolAtLocation(node);
              return symbol && ts3.getSymbolTarget(symbol, checker);
            }
          }
          function getSymbolForContextualType(node, checker) {
            var element = ts3.getContainingObjectLiteralElement(node);
            if (element) {
              var contextualType = checker.getContextualTypeForObjectLiteralElement(element);
              var symbol = contextualType === null || contextualType === void 0 ? void 0 : contextualType.getSymbol();
              if (symbol && !(ts3.getCheckFlags(symbol) & 6)) {
                return symbol;
              }
            }
          }
          function entryToImportOrExport(entry) {
            var node = entry.node;
            if (ts3.isImportSpecifier(node.parent) || ts3.isImportClause(node.parent) || ts3.isImportEqualsDeclaration(node.parent) || ts3.isNamespaceImport(node.parent)) {
              return node;
            }
            if (ts3.isExportSpecifier(node.parent) || ts3.isExportAssignment(node.parent)) {
              return node;
            }
            return void 0;
          }
          function entryToDeclaration(entry) {
            if (ts3.isDeclaration(entry.node.parent)) {
              return entry.node;
            }
            return void 0;
          }
          function entryToFunctionCall(entry) {
            if (entry.node.parent) {
              var functionReference = entry.node;
              var parent = functionReference.parent;
              switch (parent.kind) {
                case 208:
                case 209:
                  var callOrNewExpression = ts3.tryCast(parent, ts3.isCallOrNewExpression);
                  if (callOrNewExpression && callOrNewExpression.expression === functionReference) {
                    return callOrNewExpression;
                  }
                  break;
                case 206:
                  var propertyAccessExpression = ts3.tryCast(parent, ts3.isPropertyAccessExpression);
                  if (propertyAccessExpression && propertyAccessExpression.parent && propertyAccessExpression.name === functionReference) {
                    var callOrNewExpression_1 = ts3.tryCast(propertyAccessExpression.parent, ts3.isCallOrNewExpression);
                    if (callOrNewExpression_1 && callOrNewExpression_1.expression === propertyAccessExpression) {
                      return callOrNewExpression_1;
                    }
                  }
                  break;
                case 207:
                  var elementAccessExpression = ts3.tryCast(parent, ts3.isElementAccessExpression);
                  if (elementAccessExpression && elementAccessExpression.parent && elementAccessExpression.argumentExpression === functionReference) {
                    var callOrNewExpression_2 = ts3.tryCast(elementAccessExpression.parent, ts3.isCallOrNewExpression);
                    if (callOrNewExpression_2 && callOrNewExpression_2.expression === elementAccessExpression) {
                      return callOrNewExpression_2;
                    }
                  }
                  break;
              }
            }
            return void 0;
          }
          function entryToAccessExpression(entry) {
            if (entry.node.parent) {
              var reference = entry.node;
              var parent = reference.parent;
              switch (parent.kind) {
                case 206:
                  var propertyAccessExpression = ts3.tryCast(parent, ts3.isPropertyAccessExpression);
                  if (propertyAccessExpression && propertyAccessExpression.expression === reference) {
                    return propertyAccessExpression;
                  }
                  break;
                case 207:
                  var elementAccessExpression = ts3.tryCast(parent, ts3.isElementAccessExpression);
                  if (elementAccessExpression && elementAccessExpression.expression === reference) {
                    return elementAccessExpression;
                  }
                  break;
              }
            }
            return void 0;
          }
          function entryToType(entry) {
            var reference = entry.node;
            if (ts3.getMeaningFromLocation(reference) === 2 || ts3.isExpressionWithTypeArgumentsInClassExtendsClause(reference.parent)) {
              return reference;
            }
            return void 0;
          }
          function getFunctionDeclarationAtPosition(file, startPosition, checker) {
            var node = ts3.getTouchingToken(file, startPosition);
            var functionDeclaration = ts3.getContainingFunctionDeclaration(node);
            if (isTopLevelJSDoc(node))
              return void 0;
            if (functionDeclaration && isValidFunctionDeclaration(functionDeclaration, checker) && ts3.rangeContainsRange(functionDeclaration, node) && !(functionDeclaration.body && ts3.rangeContainsRange(functionDeclaration.body, node)))
              return functionDeclaration;
            return void 0;
          }
          function isTopLevelJSDoc(node) {
            var containingJSDoc = ts3.findAncestor(node, ts3.isJSDocNode);
            if (containingJSDoc) {
              var containingNonJSDoc = ts3.findAncestor(containingJSDoc, function(n) {
                return !ts3.isJSDocNode(n);
              });
              return !!containingNonJSDoc && ts3.isFunctionLikeDeclaration(containingNonJSDoc);
            }
            return false;
          }
          function isValidMethodSignature(node) {
            return ts3.isMethodSignature(node) && (ts3.isInterfaceDeclaration(node.parent) || ts3.isTypeLiteralNode(node.parent));
          }
          function isValidFunctionDeclaration(functionDeclaration, checker) {
            var _a;
            if (!isValidParameterNodeArray(functionDeclaration.parameters, checker))
              return false;
            switch (functionDeclaration.kind) {
              case 256:
                return hasNameOrDefault(functionDeclaration) && isSingleImplementation(functionDeclaration, checker);
              case 169:
                if (ts3.isObjectLiteralExpression(functionDeclaration.parent)) {
                  var contextualSymbol = getSymbolForContextualType(functionDeclaration.name, checker);
                  return ((_a = contextualSymbol === null || contextualSymbol === void 0 ? void 0 : contextualSymbol.declarations) === null || _a === void 0 ? void 0 : _a.length) === 1 && isSingleImplementation(functionDeclaration, checker);
                }
                return isSingleImplementation(functionDeclaration, checker);
              case 171:
                if (ts3.isClassDeclaration(functionDeclaration.parent)) {
                  return hasNameOrDefault(functionDeclaration.parent) && isSingleImplementation(functionDeclaration, checker);
                } else {
                  return isValidVariableDeclaration(functionDeclaration.parent.parent) && isSingleImplementation(functionDeclaration, checker);
                }
              case 213:
              case 214:
                return isValidVariableDeclaration(functionDeclaration.parent);
            }
            return false;
          }
          function isSingleImplementation(functionDeclaration, checker) {
            return !!functionDeclaration.body && !checker.isImplementationOfOverload(functionDeclaration);
          }
          function hasNameOrDefault(functionOrClassDeclaration) {
            if (!functionOrClassDeclaration.name) {
              var defaultKeyword = ts3.findModifier(functionOrClassDeclaration, 88);
              return !!defaultKeyword;
            }
            return true;
          }
          function isValidParameterNodeArray(parameters, checker) {
            return getRefactorableParametersLength(parameters) >= minimumParameterLength && ts3.every(parameters, function(paramDecl) {
              return isValidParameterDeclaration(paramDecl, checker);
            });
          }
          function isValidParameterDeclaration(parameterDeclaration, checker) {
            if (ts3.isRestParameter(parameterDeclaration)) {
              var type2 = checker.getTypeAtLocation(parameterDeclaration);
              if (!checker.isArrayType(type2) && !checker.isTupleType(type2))
                return false;
            }
            return !parameterDeclaration.modifiers && !parameterDeclaration.decorators && ts3.isIdentifier(parameterDeclaration.name);
          }
          function isValidVariableDeclaration(node) {
            return ts3.isVariableDeclaration(node) && ts3.isVarConst(node) && ts3.isIdentifier(node.name) && !node.type;
          }
          function hasThisParameter(parameters) {
            return parameters.length > 0 && ts3.isThis(parameters[0].name);
          }
          function getRefactorableParametersLength(parameters) {
            if (hasThisParameter(parameters)) {
              return parameters.length - 1;
            }
            return parameters.length;
          }
          function getRefactorableParameters(parameters) {
            if (hasThisParameter(parameters)) {
              parameters = ts3.factory.createNodeArray(parameters.slice(1), parameters.hasTrailingComma);
            }
            return parameters;
          }
          function createPropertyOrShorthandAssignment(name, initializer) {
            if (ts3.isIdentifier(initializer) && ts3.getTextOfIdentifierOrLiteral(initializer) === name) {
              return ts3.factory.createShorthandPropertyAssignment(name);
            }
            return ts3.factory.createPropertyAssignment(name, initializer);
          }
          function createNewArgument(functionDeclaration, functionArguments) {
            var parameters = getRefactorableParameters(functionDeclaration.parameters);
            var hasRestParameter = ts3.isRestParameter(ts3.last(parameters));
            var nonRestArguments = hasRestParameter ? functionArguments.slice(0, parameters.length - 1) : functionArguments;
            var properties = ts3.map(nonRestArguments, function(arg, i) {
              var parameterName = getParameterName(parameters[i]);
              var property = createPropertyOrShorthandAssignment(parameterName, arg);
              ts3.suppressLeadingAndTrailingTrivia(property.name);
              if (ts3.isPropertyAssignment(property))
                ts3.suppressLeadingAndTrailingTrivia(property.initializer);
              ts3.copyComments(arg, property);
              return property;
            });
            if (hasRestParameter && functionArguments.length >= parameters.length) {
              var restArguments = functionArguments.slice(parameters.length - 1);
              var restProperty = ts3.factory.createPropertyAssignment(getParameterName(ts3.last(parameters)), ts3.factory.createArrayLiteralExpression(restArguments));
              properties.push(restProperty);
            }
            var objectLiteral = ts3.factory.createObjectLiteralExpression(properties, false);
            return objectLiteral;
          }
          function createNewParameters(functionDeclaration, program2, host) {
            var checker = program2.getTypeChecker();
            var refactorableParameters = getRefactorableParameters(functionDeclaration.parameters);
            var bindingElements = ts3.map(refactorableParameters, createBindingElementFromParameterDeclaration);
            var objectParameterName = ts3.factory.createObjectBindingPattern(bindingElements);
            var objectParameterType = createParameterTypeNode(refactorableParameters);
            var objectInitializer;
            if (ts3.every(refactorableParameters, isOptionalParameter)) {
              objectInitializer = ts3.factory.createObjectLiteralExpression();
            }
            var objectParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, objectParameterName, void 0, objectParameterType, objectInitializer);
            if (hasThisParameter(functionDeclaration.parameters)) {
              var thisParameter = functionDeclaration.parameters[0];
              var newThisParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, thisParameter.name, void 0, thisParameter.type);
              ts3.suppressLeadingAndTrailingTrivia(newThisParameter.name);
              ts3.copyComments(thisParameter.name, newThisParameter.name);
              if (thisParameter.type) {
                ts3.suppressLeadingAndTrailingTrivia(newThisParameter.type);
                ts3.copyComments(thisParameter.type, newThisParameter.type);
              }
              return ts3.factory.createNodeArray([newThisParameter, objectParameter]);
            }
            return ts3.factory.createNodeArray([objectParameter]);
            function createBindingElementFromParameterDeclaration(parameterDeclaration) {
              var element = ts3.factory.createBindingElement(void 0, void 0, getParameterName(parameterDeclaration), ts3.isRestParameter(parameterDeclaration) && isOptionalParameter(parameterDeclaration) ? ts3.factory.createArrayLiteralExpression() : parameterDeclaration.initializer);
              ts3.suppressLeadingAndTrailingTrivia(element);
              if (parameterDeclaration.initializer && element.initializer) {
                ts3.copyComments(parameterDeclaration.initializer, element.initializer);
              }
              return element;
            }
            function createParameterTypeNode(parameters) {
              var members = ts3.map(parameters, createPropertySignatureFromParameterDeclaration);
              var typeNode = ts3.addEmitFlags(ts3.factory.createTypeLiteralNode(members), 1);
              return typeNode;
            }
            function createPropertySignatureFromParameterDeclaration(parameterDeclaration) {
              var parameterType = parameterDeclaration.type;
              if (!parameterType && (parameterDeclaration.initializer || ts3.isRestParameter(parameterDeclaration))) {
                parameterType = getTypeNode(parameterDeclaration);
              }
              var propertySignature = ts3.factory.createPropertySignature(void 0, getParameterName(parameterDeclaration), isOptionalParameter(parameterDeclaration) ? ts3.factory.createToken(57) : parameterDeclaration.questionToken, parameterType);
              ts3.suppressLeadingAndTrailingTrivia(propertySignature);
              ts3.copyComments(parameterDeclaration.name, propertySignature.name);
              if (parameterDeclaration.type && propertySignature.type) {
                ts3.copyComments(parameterDeclaration.type, propertySignature.type);
              }
              return propertySignature;
            }
            function getTypeNode(node) {
              var type2 = checker.getTypeAtLocation(node);
              return ts3.getTypeNodeIfAccessible(type2, node, program2, host);
            }
            function isOptionalParameter(parameterDeclaration) {
              if (ts3.isRestParameter(parameterDeclaration)) {
                var type2 = checker.getTypeAtLocation(parameterDeclaration);
                return !checker.isTupleType(type2);
              }
              return checker.isOptionalParameter(parameterDeclaration);
            }
          }
          function getParameterName(paramDeclaration) {
            return ts3.getTextOfIdentifierOrLiteral(paramDeclaration.name);
          }
          function getClassNames(constructorDeclaration) {
            switch (constructorDeclaration.parent.kind) {
              case 257:
                var classDeclaration = constructorDeclaration.parent;
                if (classDeclaration.name)
                  return [classDeclaration.name];
                var defaultModifier = ts3.Debug.checkDefined(ts3.findModifier(classDeclaration, 88), "Nameless class declaration should be a default export");
                return [defaultModifier];
              case 226:
                var classExpression = constructorDeclaration.parent;
                var variableDeclaration = constructorDeclaration.parent.parent;
                var className = classExpression.name;
                if (className)
                  return [className, variableDeclaration.name];
                return [variableDeclaration.name];
            }
          }
          function getFunctionNames(functionDeclaration) {
            switch (functionDeclaration.kind) {
              case 256:
                if (functionDeclaration.name)
                  return [functionDeclaration.name];
                var defaultModifier = ts3.Debug.checkDefined(ts3.findModifier(functionDeclaration, 88), "Nameless function declaration should be a default export");
                return [defaultModifier];
              case 169:
                return [functionDeclaration.name];
              case 171:
                var ctrKeyword = ts3.Debug.checkDefined(ts3.findChildOfKind(functionDeclaration, 134, functionDeclaration.getSourceFile()), "Constructor declaration should have constructor keyword");
                if (functionDeclaration.parent.kind === 226) {
                  var variableDeclaration = functionDeclaration.parent.parent;
                  return [variableDeclaration.name, ctrKeyword];
                }
                return [ctrKeyword];
              case 214:
                return [functionDeclaration.parent.name];
              case 213:
                if (functionDeclaration.name)
                  return [functionDeclaration.name, functionDeclaration.parent.name];
                return [functionDeclaration.parent.name];
              default:
                return ts3.Debug.assertNever(functionDeclaration, "Unexpected function declaration kind ".concat(functionDeclaration.kind));
            }
          }
        })(convertParamsToDestructuredObject = refactor2.convertParamsToDestructuredObject || (refactor2.convertParamsToDestructuredObject = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertStringOrTemplateLiteral;
        (function(convertStringOrTemplateLiteral2) {
          var refactorName = "Convert to template string";
          var refactorDescription = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_template_string);
          var convertStringAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.string"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [convertStringAction.kind],
            getEditsForAction: getRefactorEditsToConvertToTemplateString,
            getAvailableActions: getRefactorActionsToConvertToTemplateString
          });
          function getRefactorActionsToConvertToTemplateString(context) {
            var file = context.file, startPosition = context.startPosition;
            var node = getNodeOrParentOfParentheses(file, startPosition);
            var maybeBinary = getParentBinaryExpression(node);
            var refactorInfo = { name: refactorName, description: refactorDescription, actions: [] };
            if (ts3.isBinaryExpression(maybeBinary) && treeToArray(maybeBinary).isValidConcatenation) {
              refactorInfo.actions.push(convertStringAction);
              return [refactorInfo];
            } else if (context.preferences.provideRefactorNotApplicableReason) {
              refactorInfo.actions.push(__assign(__assign({}, convertStringAction), { notApplicableReason: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_string_concatenation) }));
              return [refactorInfo];
            }
            return ts3.emptyArray;
          }
          function getNodeOrParentOfParentheses(file, startPosition) {
            var node = ts3.getTokenAtPosition(file, startPosition);
            var nestedBinary = getParentBinaryExpression(node);
            var isNonStringBinary = !treeToArray(nestedBinary).isValidConcatenation;
            if (isNonStringBinary && ts3.isParenthesizedExpression(nestedBinary.parent) && ts3.isBinaryExpression(nestedBinary.parent.parent)) {
              return nestedBinary.parent.parent;
            }
            return node;
          }
          function getRefactorEditsToConvertToTemplateString(context, actionName) {
            var file = context.file, startPosition = context.startPosition;
            var node = getNodeOrParentOfParentheses(file, startPosition);
            switch (actionName) {
              case refactorDescription:
                return { edits: getEditsForToTemplateLiteral(context, node) };
              default:
                return ts3.Debug.fail("invalid action");
            }
          }
          function getEditsForToTemplateLiteral(context, node) {
            var maybeBinary = getParentBinaryExpression(node);
            var file = context.file;
            var templateLiteral = nodesToTemplate(treeToArray(maybeBinary), file);
            var trailingCommentRanges = ts3.getTrailingCommentRanges(file.text, maybeBinary.end);
            if (trailingCommentRanges) {
              var lastComment = trailingCommentRanges[trailingCommentRanges.length - 1];
              var trailingRange_1 = { pos: trailingCommentRanges[0].pos, end: lastComment.end };
              return ts3.textChanges.ChangeTracker.with(context, function(t) {
                t.deleteRange(file, trailingRange_1);
                t.replaceNode(file, maybeBinary, templateLiteral);
              });
            } else {
              return ts3.textChanges.ChangeTracker.with(context, function(t) {
                return t.replaceNode(file, maybeBinary, templateLiteral);
              });
            }
          }
          function isNotEqualsOperator(node) {
            return node.operatorToken.kind !== 63;
          }
          function getParentBinaryExpression(expr) {
            var container = ts3.findAncestor(expr.parent, function(n) {
              switch (n.kind) {
                case 206:
                case 207:
                  return false;
                case 223:
                case 221:
                  return !(ts3.isBinaryExpression(n.parent) && isNotEqualsOperator(n.parent));
                default:
                  return "quit";
              }
            });
            return container || expr;
          }
          function treeToArray(current) {
            var loop = function(current2) {
              if (!ts3.isBinaryExpression(current2)) {
                return {
                  nodes: [current2],
                  operators: [],
                  validOperators: true,
                  hasString: ts3.isStringLiteral(current2) || ts3.isNoSubstitutionTemplateLiteral(current2)
                };
              }
              var _a2 = loop(current2.left), nodes2 = _a2.nodes, operators2 = _a2.operators, leftHasString = _a2.hasString, leftOperatorValid = _a2.validOperators;
              if (!(leftHasString || ts3.isStringLiteral(current2.right) || ts3.isTemplateExpression(current2.right))) {
                return { nodes: [current2], operators: [], hasString: false, validOperators: true };
              }
              var currentOperatorValid = current2.operatorToken.kind === 39;
              var validOperators2 = leftOperatorValid && currentOperatorValid;
              nodes2.push(current2.right);
              operators2.push(current2.operatorToken);
              return { nodes: nodes2, operators: operators2, hasString: true, validOperators: validOperators2 };
            };
            var _a = loop(current), nodes = _a.nodes, operators = _a.operators, validOperators = _a.validOperators, hasString = _a.hasString;
            return { nodes, operators, isValidConcatenation: validOperators && hasString };
          }
          var copyTrailingOperatorComments = function(operators, file) {
            return function(index, targetNode) {
              if (index < operators.length) {
                ts3.copyTrailingComments(operators[index], targetNode, file, 3, false);
              }
            };
          };
          var copyCommentFromMultiNode = function(nodes, file, copyOperatorComments) {
            return function(indexes, targetNode) {
              while (indexes.length > 0) {
                var index = indexes.shift();
                ts3.copyTrailingComments(nodes[index], targetNode, file, 3, false);
                copyOperatorComments(index, targetNode);
              }
            };
          };
          function escapeRawStringForTemplate(s) {
            return s.replace(/\\.|[$`]/g, function(m) {
              return m[0] === "\\" ? m : "\\" + m;
            });
          }
          function getRawTextOfTemplate(node) {
            var rightShaving = ts3.isTemplateHead(node) || ts3.isTemplateMiddle(node) ? -2 : -1;
            return ts3.getTextOfNode(node).slice(1, rightShaving);
          }
          function concatConsecutiveString(index, nodes) {
            var indexes = [];
            var text = "", rawText = "";
            while (index < nodes.length) {
              var node = nodes[index];
              if (ts3.isStringLiteralLike(node)) {
                text += node.text;
                rawText += escapeRawStringForTemplate(ts3.getTextOfNode(node).slice(1, -1));
                indexes.push(index);
                index++;
              } else if (ts3.isTemplateExpression(node)) {
                text += node.head.text;
                rawText += getRawTextOfTemplate(node.head);
                break;
              } else {
                break;
              }
            }
            return [index, text, rawText, indexes];
          }
          function nodesToTemplate(_a, file) {
            var nodes = _a.nodes, operators = _a.operators;
            var copyOperatorComments = copyTrailingOperatorComments(operators, file);
            var copyCommentFromStringLiterals = copyCommentFromMultiNode(nodes, file, copyOperatorComments);
            var _b = concatConsecutiveString(0, nodes), begin = _b[0], headText = _b[1], rawHeadText = _b[2], headIndexes = _b[3];
            if (begin === nodes.length) {
              var noSubstitutionTemplateLiteral = ts3.factory.createNoSubstitutionTemplateLiteral(headText, rawHeadText);
              copyCommentFromStringLiterals(headIndexes, noSubstitutionTemplateLiteral);
              return noSubstitutionTemplateLiteral;
            }
            var templateSpans = [];
            var templateHead = ts3.factory.createTemplateHead(headText, rawHeadText);
            copyCommentFromStringLiterals(headIndexes, templateHead);
            var _loop_21 = function(i2) {
              var currentNode = getExpressionFromParenthesesOrExpression(nodes[i2]);
              copyOperatorComments(i2, currentNode);
              var _c = concatConsecutiveString(i2 + 1, nodes), newIndex = _c[0], subsequentText = _c[1], rawSubsequentText = _c[2], stringIndexes = _c[3];
              i2 = newIndex - 1;
              var isLast = i2 === nodes.length - 1;
              if (ts3.isTemplateExpression(currentNode)) {
                var spans = ts3.map(currentNode.templateSpans, function(span, index) {
                  copyExpressionComments(span);
                  var isLastSpan = index === currentNode.templateSpans.length - 1;
                  var text = span.literal.text + (isLastSpan ? subsequentText : "");
                  var rawText = getRawTextOfTemplate(span.literal) + (isLastSpan ? rawSubsequentText : "");
                  return ts3.factory.createTemplateSpan(span.expression, isLast && isLastSpan ? ts3.factory.createTemplateTail(text, rawText) : ts3.factory.createTemplateMiddle(text, rawText));
                });
                templateSpans.push.apply(templateSpans, spans);
              } else {
                var templatePart = isLast ? ts3.factory.createTemplateTail(subsequentText, rawSubsequentText) : ts3.factory.createTemplateMiddle(subsequentText, rawSubsequentText);
                copyCommentFromStringLiterals(stringIndexes, templatePart);
                templateSpans.push(ts3.factory.createTemplateSpan(currentNode, templatePart));
              }
              out_i_1 = i2;
            };
            var out_i_1;
            for (var i = begin; i < nodes.length; i++) {
              _loop_21(i);
              i = out_i_1;
            }
            return ts3.factory.createTemplateExpression(templateHead, templateSpans);
          }
          function copyExpressionComments(node) {
            var file = node.getSourceFile();
            ts3.copyTrailingComments(node, node.expression, file, 3, false);
            ts3.copyTrailingAsLeadingComments(node.expression, node.expression, file, 3, false);
          }
          function getExpressionFromParenthesesOrExpression(node) {
            if (ts3.isParenthesizedExpression(node)) {
              copyExpressionComments(node);
              node = node.expression;
            }
            return node;
          }
        })(convertStringOrTemplateLiteral = refactor2.convertStringOrTemplateLiteral || (refactor2.convertStringOrTemplateLiteral = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertArrowFunctionOrFunctionExpression;
        (function(convertArrowFunctionOrFunctionExpression2) {
          var refactorName = "Convert arrow function or function expression";
          var refactorDescription = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_arrow_function_or_function_expression);
          var toAnonymousFunctionAction = {
            name: "Convert to anonymous function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_anonymous_function),
            kind: "refactor.rewrite.function.anonymous"
          };
          var toNamedFunctionAction = {
            name: "Convert to named function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_named_function),
            kind: "refactor.rewrite.function.named"
          };
          var toArrowFunctionAction = {
            name: "Convert to arrow function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_arrow_function),
            kind: "refactor.rewrite.function.arrow"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [
              toAnonymousFunctionAction.kind,
              toNamedFunctionAction.kind,
              toArrowFunctionAction.kind
            ],
            getEditsForAction: getRefactorEditsToConvertFunctionExpressions,
            getAvailableActions: getRefactorActionsToConvertFunctionExpressions
          });
          function getRefactorActionsToConvertFunctionExpressions(context) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program, kind = context.kind;
            var info = getFunctionInfo(file, startPosition, program2);
            if (!info)
              return ts3.emptyArray;
            var selectedVariableDeclaration = info.selectedVariableDeclaration, func = info.func;
            var possibleActions = [];
            var errors = [];
            if (refactor2.refactorKindBeginsWith(toNamedFunctionAction.kind, kind)) {
              var error = selectedVariableDeclaration || ts3.isArrowFunction(func) && ts3.isVariableDeclaration(func.parent) ? void 0 : ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_convert_to_named_function);
              if (error) {
                errors.push(__assign(__assign({}, toNamedFunctionAction), { notApplicableReason: error }));
              } else {
                possibleActions.push(toNamedFunctionAction);
              }
            }
            if (refactor2.refactorKindBeginsWith(toAnonymousFunctionAction.kind, kind)) {
              var error = !selectedVariableDeclaration && ts3.isArrowFunction(func) ? void 0 : ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_convert_to_anonymous_function);
              if (error) {
                errors.push(__assign(__assign({}, toAnonymousFunctionAction), { notApplicableReason: error }));
              } else {
                possibleActions.push(toAnonymousFunctionAction);
              }
            }
            if (refactor2.refactorKindBeginsWith(toArrowFunctionAction.kind, kind)) {
              var error = ts3.isFunctionExpression(func) ? void 0 : ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_convert_to_arrow_function);
              if (error) {
                errors.push(__assign(__assign({}, toArrowFunctionAction), { notApplicableReason: error }));
              } else {
                possibleActions.push(toArrowFunctionAction);
              }
            }
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: possibleActions.length === 0 && context.preferences.provideRefactorNotApplicableReason ? errors : possibleActions
            }];
          }
          function getRefactorEditsToConvertFunctionExpressions(context, actionName) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program;
            var info = getFunctionInfo(file, startPosition, program2);
            if (!info)
              return void 0;
            var func = info.func;
            var edits = [];
            switch (actionName) {
              case toAnonymousFunctionAction.name:
                edits.push.apply(edits, getEditInfoForConvertToAnonymousFunction(context, func));
                break;
              case toNamedFunctionAction.name:
                var variableInfo = getVariableInfo(func);
                if (!variableInfo)
                  return void 0;
                edits.push.apply(edits, getEditInfoForConvertToNamedFunction(context, func, variableInfo));
                break;
              case toArrowFunctionAction.name:
                if (!ts3.isFunctionExpression(func))
                  return void 0;
                edits.push.apply(edits, getEditInfoForConvertToArrowFunction(context, func));
                break;
              default:
                return ts3.Debug.fail("invalid action");
            }
            return { renameFilename: void 0, renameLocation: void 0, edits };
          }
          function containingThis(node) {
            var containsThis = false;
            node.forEachChild(function checkThis(child) {
              if (ts3.isThis(child)) {
                containsThis = true;
                return;
              }
              if (!ts3.isClassLike(child) && !ts3.isFunctionDeclaration(child) && !ts3.isFunctionExpression(child)) {
                ts3.forEachChild(child, checkThis);
              }
            });
            return containsThis;
          }
          function getFunctionInfo(file, startPosition, program2) {
            var token = ts3.getTokenAtPosition(file, startPosition);
            var typeChecker = program2.getTypeChecker();
            var func = tryGetFunctionFromVariableDeclaration(file, typeChecker, token.parent);
            if (func && !containingThis(func.body) && !typeChecker.containsArgumentsReference(func)) {
              return { selectedVariableDeclaration: true, func };
            }
            var maybeFunc = ts3.getContainingFunction(token);
            if (maybeFunc && (ts3.isFunctionExpression(maybeFunc) || ts3.isArrowFunction(maybeFunc)) && !ts3.rangeContainsRange(maybeFunc.body, token) && !containingThis(maybeFunc.body) && !typeChecker.containsArgumentsReference(maybeFunc)) {
              if (ts3.isFunctionExpression(maybeFunc) && isFunctionReferencedInFile(file, typeChecker, maybeFunc))
                return void 0;
              return { selectedVariableDeclaration: false, func: maybeFunc };
            }
            return void 0;
          }
          function isSingleVariableDeclaration(parent) {
            return ts3.isVariableDeclaration(parent) || ts3.isVariableDeclarationList(parent) && parent.declarations.length === 1;
          }
          function tryGetFunctionFromVariableDeclaration(sourceFile, typeChecker, parent) {
            if (!isSingleVariableDeclaration(parent)) {
              return void 0;
            }
            var variableDeclaration = ts3.isVariableDeclaration(parent) ? parent : ts3.first(parent.declarations);
            var initializer = variableDeclaration.initializer;
            if (initializer && (ts3.isArrowFunction(initializer) || ts3.isFunctionExpression(initializer) && !isFunctionReferencedInFile(sourceFile, typeChecker, initializer))) {
              return initializer;
            }
            return void 0;
          }
          function convertToBlock(body) {
            if (ts3.isExpression(body)) {
              var returnStatement = ts3.factory.createReturnStatement(body);
              var file = body.getSourceFile();
              ts3.suppressLeadingAndTrailingTrivia(returnStatement);
              ts3.copyTrailingAsLeadingComments(body, returnStatement, file, void 0, true);
              return ts3.factory.createBlock([returnStatement], true);
            } else {
              return body;
            }
          }
          function getVariableInfo(func) {
            var variableDeclaration = func.parent;
            if (!ts3.isVariableDeclaration(variableDeclaration) || !ts3.isVariableDeclarationInVariableStatement(variableDeclaration))
              return void 0;
            var variableDeclarationList = variableDeclaration.parent;
            var statement = variableDeclarationList.parent;
            if (!ts3.isVariableDeclarationList(variableDeclarationList) || !ts3.isVariableStatement(statement) || !ts3.isIdentifier(variableDeclaration.name))
              return void 0;
            return { variableDeclaration, variableDeclarationList, statement, name: variableDeclaration.name };
          }
          function getEditInfoForConvertToAnonymousFunction(context, func) {
            var file = context.file;
            var body = convertToBlock(func.body);
            var newNode = ts3.factory.createFunctionExpression(func.modifiers, func.asteriskToken, void 0, func.typeParameters, func.parameters, func.type, body);
            return ts3.textChanges.ChangeTracker.with(context, function(t) {
              return t.replaceNode(file, func, newNode);
            });
          }
          function getEditInfoForConvertToNamedFunction(context, func, variableInfo) {
            var file = context.file;
            var body = convertToBlock(func.body);
            var variableDeclaration = variableInfo.variableDeclaration, variableDeclarationList = variableInfo.variableDeclarationList, statement = variableInfo.statement, name = variableInfo.name;
            ts3.suppressLeadingTrivia(statement);
            var modifiersFlags = ts3.getCombinedModifierFlags(variableDeclaration) & 1 | ts3.getEffectiveModifierFlags(func);
            var modifiers = ts3.factory.createModifiersFromModifierFlags(modifiersFlags);
            var newNode = ts3.factory.createFunctionDeclaration(func.decorators, ts3.length(modifiers) ? modifiers : void 0, func.asteriskToken, name, func.typeParameters, func.parameters, func.type, body);
            if (variableDeclarationList.declarations.length === 1) {
              return ts3.textChanges.ChangeTracker.with(context, function(t) {
                return t.replaceNode(file, statement, newNode);
              });
            } else {
              return ts3.textChanges.ChangeTracker.with(context, function(t) {
                t.delete(file, variableDeclaration);
                t.insertNodeAfter(file, statement, newNode);
              });
            }
          }
          function getEditInfoForConvertToArrowFunction(context, func) {
            var file = context.file;
            var statements = func.body.statements;
            var head = statements[0];
            var body;
            if (canBeConvertedToExpression(func.body, head)) {
              body = head.expression;
              ts3.suppressLeadingAndTrailingTrivia(body);
              ts3.copyComments(head, body);
            } else {
              body = func.body;
            }
            var newNode = ts3.factory.createArrowFunction(func.modifiers, func.typeParameters, func.parameters, func.type, ts3.factory.createToken(38), body);
            return ts3.textChanges.ChangeTracker.with(context, function(t) {
              return t.replaceNode(file, func, newNode);
            });
          }
          function canBeConvertedToExpression(body, head) {
            return body.statements.length === 1 && (ts3.isReturnStatement(head) && !!head.expression);
          }
          function isFunctionReferencedInFile(sourceFile, typeChecker, node) {
            return !!node.name && ts3.FindAllReferences.Core.isSymbolReferencedInFile(node.name, typeChecker, sourceFile);
          }
        })(convertArrowFunctionOrFunctionExpression = refactor2.convertArrowFunctionOrFunctionExpression || (refactor2.convertArrowFunctionOrFunctionExpression = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var inferFunctionReturnType;
        (function(inferFunctionReturnType2) {
          var refactorName = "Infer function return type";
          var refactorDescription = ts3.Diagnostics.Infer_function_return_type.message;
          var inferReturnTypeAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.function.returnType"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [inferReturnTypeAction.kind],
            getEditsForAction: getRefactorEditsToInferReturnType,
            getAvailableActions: getRefactorActionsToInferReturnType
          });
          function getRefactorEditsToInferReturnType(context) {
            var info = getInfo(context);
            if (info && !refactor2.isRefactorErrorInfo(info)) {
              var edits = ts3.textChanges.ChangeTracker.with(context, function(t) {
                return doChange(context.file, t, info.declaration, info.returnTypeNode);
              });
              return { renameFilename: void 0, renameLocation: void 0, edits };
            }
            return void 0;
          }
          function getRefactorActionsToInferReturnType(context) {
            var info = getInfo(context);
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [inferReturnTypeAction]
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [__assign(__assign({}, inferReturnTypeAction), { notApplicableReason: info.error })]
              }];
            }
            return ts3.emptyArray;
          }
          function doChange(sourceFile, changes, declaration, typeNode) {
            var closeParen = ts3.findChildOfKind(declaration, 21, sourceFile);
            var needParens = ts3.isArrowFunction(declaration) && closeParen === void 0;
            var endNode = needParens ? ts3.first(declaration.parameters) : closeParen;
            if (endNode) {
              if (needParens) {
                changes.insertNodeBefore(sourceFile, endNode, ts3.factory.createToken(20));
                changes.insertNodeAfter(sourceFile, endNode, ts3.factory.createToken(21));
              }
              changes.insertNodeAt(sourceFile, endNode.end, typeNode, { prefix: ": " });
            }
          }
          function getInfo(context) {
            if (ts3.isInJSFile(context.file) || !refactor2.refactorKindBeginsWith(inferReturnTypeAction.kind, context.kind))
              return;
            var token = ts3.getTokenAtPosition(context.file, context.startPosition);
            var declaration = ts3.findAncestor(token, function(n) {
              return ts3.isBlock(n) || n.parent && ts3.isArrowFunction(n.parent) && (n.kind === 38 || n.parent.body === n) ? "quit" : isConvertibleDeclaration(n);
            });
            if (!declaration || !declaration.body || declaration.type) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Return_type_must_be_inferred_from_a_function) };
            }
            var typeChecker = context.program.getTypeChecker();
            var returnType = tryGetReturnType(typeChecker, declaration);
            if (!returnType) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_determine_function_return_type) };
            }
            var returnTypeNode = typeChecker.typeToTypeNode(returnType, declaration, 1);
            if (returnTypeNode) {
              return { declaration, returnTypeNode };
            }
          }
          function isConvertibleDeclaration(node) {
            switch (node.kind) {
              case 256:
              case 213:
              case 214:
              case 169:
                return true;
              default:
                return false;
            }
          }
          function tryGetReturnType(typeChecker, node) {
            if (typeChecker.isImplementationOfOverload(node)) {
              var signatures = typeChecker.getTypeAtLocation(node).getCallSignatures();
              if (signatures.length > 1) {
                return typeChecker.getUnionType(ts3.mapDefined(signatures, function(s) {
                  return s.getReturnType();
                }));
              }
            }
            var signature = typeChecker.getSignatureFromDeclaration(node);
            if (signature) {
              return typeChecker.getReturnTypeOfSignature(signature);
            }
          }
        })(inferFunctionReturnType = refactor2.inferFunctionReturnType || (refactor2.inferFunctionReturnType = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.servicesVersion = "0.8";
      function createNode(kind, pos, end, parent) {
        var node = ts3.isNodeKind(kind) ? new NodeObject(kind, pos, end) : kind === 79 ? new IdentifierObject(79, pos, end) : kind === 80 ? new PrivateIdentifierObject(80, pos, end) : new TokenObject(kind, pos, end);
        node.parent = parent;
        node.flags = parent.flags & 50720768;
        return node;
      }
      var NodeObject = function() {
        function NodeObject2(kind, pos, end) {
          this.pos = pos;
          this.end = end;
          this.flags = 0;
          this.modifierFlagsCache = 0;
          this.transformFlags = 0;
          this.parent = void 0;
          this.kind = kind;
        }
        NodeObject2.prototype.assertHasRealPosition = function(message) {
          ts3.Debug.assert(!ts3.positionIsSynthesized(this.pos) && !ts3.positionIsSynthesized(this.end), message || "Node must have a real position for this operation");
        };
        NodeObject2.prototype.getSourceFile = function() {
          return ts3.getSourceFileOfNode(this);
        };
        NodeObject2.prototype.getStart = function(sourceFile, includeJsDocComment) {
          this.assertHasRealPosition();
          return ts3.getTokenPosOfNode(this, sourceFile, includeJsDocComment);
        };
        NodeObject2.prototype.getFullStart = function() {
          this.assertHasRealPosition();
          return this.pos;
        };
        NodeObject2.prototype.getEnd = function() {
          this.assertHasRealPosition();
          return this.end;
        };
        NodeObject2.prototype.getWidth = function(sourceFile) {
          this.assertHasRealPosition();
          return this.getEnd() - this.getStart(sourceFile);
        };
        NodeObject2.prototype.getFullWidth = function() {
          this.assertHasRealPosition();
          return this.end - this.pos;
        };
        NodeObject2.prototype.getLeadingTriviaWidth = function(sourceFile) {
          this.assertHasRealPosition();
          return this.getStart(sourceFile) - this.pos;
        };
        NodeObject2.prototype.getFullText = function(sourceFile) {
          this.assertHasRealPosition();
          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
        };
        NodeObject2.prototype.getText = function(sourceFile) {
          this.assertHasRealPosition();
          if (!sourceFile) {
            sourceFile = this.getSourceFile();
          }
          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
        };
        NodeObject2.prototype.getChildCount = function(sourceFile) {
          return this.getChildren(sourceFile).length;
        };
        NodeObject2.prototype.getChildAt = function(index, sourceFile) {
          return this.getChildren(sourceFile)[index];
        };
        NodeObject2.prototype.getChildren = function(sourceFile) {
          this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine");
          return this._children || (this._children = createChildren(this, sourceFile));
        };
        NodeObject2.prototype.getFirstToken = function(sourceFile) {
          this.assertHasRealPosition();
          var children = this.getChildren(sourceFile);
          if (!children.length) {
            return void 0;
          }
          var child = ts3.find(children, function(kid) {
            return kid.kind < 309 || kid.kind > 347;
          });
          return child.kind < 161 ? child : child.getFirstToken(sourceFile);
        };
        NodeObject2.prototype.getLastToken = function(sourceFile) {
          this.assertHasRealPosition();
          var children = this.getChildren(sourceFile);
          var child = ts3.lastOrUndefined(children);
          if (!child) {
            return void 0;
          }
          return child.kind < 161 ? child : child.getLastToken(sourceFile);
        };
        NodeObject2.prototype.forEachChild = function(cbNode, cbNodeArray) {
          return ts3.forEachChild(this, cbNode, cbNodeArray);
        };
        return NodeObject2;
      }();
      function createChildren(node, sourceFile) {
        if (!ts3.isNodeKind(node.kind)) {
          return ts3.emptyArray;
        }
        var children = [];
        if (ts3.isJSDocCommentContainingNode(node)) {
          node.forEachChild(function(child) {
            children.push(child);
          });
          return children;
        }
        ts3.scanner.setText((sourceFile || node.getSourceFile()).text);
        var pos = node.pos;
        var processNode = function(child) {
          addSyntheticNodes(children, pos, child.pos, node);
          children.push(child);
          pos = child.end;
        };
        var processNodes = function(nodes) {
          addSyntheticNodes(children, pos, nodes.pos, node);
          children.push(createSyntaxList(nodes, node));
          pos = nodes.end;
        };
        ts3.forEach(node.jsDoc, processNode);
        pos = node.pos;
        node.forEachChild(processNode, processNodes);
        addSyntheticNodes(children, pos, node.end, node);
        ts3.scanner.setText(void 0);
        return children;
      }
      function addSyntheticNodes(nodes, pos, end, parent) {
        ts3.scanner.setTextPos(pos);
        while (pos < end) {
          var token = ts3.scanner.scan();
          var textPos = ts3.scanner.getTextPos();
          if (textPos <= end) {
            if (token === 79) {
              ts3.Debug.fail("Did not expect ".concat(ts3.Debug.formatSyntaxKind(parent.kind), " to have an Identifier in its trivia"));
            }
            nodes.push(createNode(token, pos, textPos, parent));
          }
          pos = textPos;
          if (token === 1) {
            break;
          }
        }
      }
      function createSyntaxList(nodes, parent) {
        var list = createNode(348, nodes.pos, nodes.end, parent);
        list._children = [];
        var pos = nodes.pos;
        for (var _i = 0, nodes_2 = nodes; _i < nodes_2.length; _i++) {
          var node = nodes_2[_i];
          addSyntheticNodes(list._children, pos, node.pos, parent);
          list._children.push(node);
          pos = node.end;
        }
        addSyntheticNodes(list._children, pos, nodes.end, parent);
        return list;
      }
      var TokenOrIdentifierObject = function() {
        function TokenOrIdentifierObject2(pos, end) {
          this.pos = pos;
          this.end = end;
          this.flags = 0;
          this.modifierFlagsCache = 0;
          this.transformFlags = 0;
          this.parent = void 0;
        }
        TokenOrIdentifierObject2.prototype.getSourceFile = function() {
          return ts3.getSourceFileOfNode(this);
        };
        TokenOrIdentifierObject2.prototype.getStart = function(sourceFile, includeJsDocComment) {
          return ts3.getTokenPosOfNode(this, sourceFile, includeJsDocComment);
        };
        TokenOrIdentifierObject2.prototype.getFullStart = function() {
          return this.pos;
        };
        TokenOrIdentifierObject2.prototype.getEnd = function() {
          return this.end;
        };
        TokenOrIdentifierObject2.prototype.getWidth = function(sourceFile) {
          return this.getEnd() - this.getStart(sourceFile);
        };
        TokenOrIdentifierObject2.prototype.getFullWidth = function() {
          return this.end - this.pos;
        };
        TokenOrIdentifierObject2.prototype.getLeadingTriviaWidth = function(sourceFile) {
          return this.getStart(sourceFile) - this.pos;
        };
        TokenOrIdentifierObject2.prototype.getFullText = function(sourceFile) {
          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
        };
        TokenOrIdentifierObject2.prototype.getText = function(sourceFile) {
          if (!sourceFile) {
            sourceFile = this.getSourceFile();
          }
          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
        };
        TokenOrIdentifierObject2.prototype.getChildCount = function() {
          return this.getChildren().length;
        };
        TokenOrIdentifierObject2.prototype.getChildAt = function(index) {
          return this.getChildren()[index];
        };
        TokenOrIdentifierObject2.prototype.getChildren = function() {
          return this.kind === 1 ? this.jsDoc || ts3.emptyArray : ts3.emptyArray;
        };
        TokenOrIdentifierObject2.prototype.getFirstToken = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.getLastToken = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.forEachChild = function() {
          return void 0;
        };
        return TokenOrIdentifierObject2;
      }();
      var SymbolObject = function() {
        function SymbolObject2(flags, name) {
          this.flags = flags;
          this.escapedName = name;
        }
        SymbolObject2.prototype.getFlags = function() {
          return this.flags;
        };
        Object.defineProperty(SymbolObject2.prototype, "name", {
          get: function() {
            return ts3.symbolName(this);
          },
          enumerable: false,
          configurable: true
        });
        SymbolObject2.prototype.getEscapedName = function() {
          return this.escapedName;
        };
        SymbolObject2.prototype.getName = function() {
          return this.name;
        };
        SymbolObject2.prototype.getDeclarations = function() {
          return this.declarations;
        };
        SymbolObject2.prototype.getDocumentationComment = function(checker) {
          if (!this.documentationComment) {
            this.documentationComment = ts3.emptyArray;
            if (!this.declarations && this.target && this.target.tupleLabelDeclaration) {
              var labelDecl = this.target.tupleLabelDeclaration;
              this.documentationComment = getDocumentationComment([labelDecl], checker);
            } else {
              this.documentationComment = getDocumentationComment(this.declarations, checker);
            }
          }
          return this.documentationComment;
        };
        SymbolObject2.prototype.getContextualDocumentationComment = function(context, checker) {
          switch (context === null || context === void 0 ? void 0 : context.kind) {
            case 172:
              if (!this.contextualGetAccessorDocumentationComment) {
                this.contextualGetAccessorDocumentationComment = getDocumentationComment(ts3.filter(this.declarations, ts3.isGetAccessor), checker);
              }
              return this.contextualGetAccessorDocumentationComment;
            case 173:
              if (!this.contextualSetAccessorDocumentationComment) {
                this.contextualSetAccessorDocumentationComment = getDocumentationComment(ts3.filter(this.declarations, ts3.isSetAccessor), checker);
              }
              return this.contextualSetAccessorDocumentationComment;
            default:
              return this.getDocumentationComment(checker);
          }
        };
        SymbolObject2.prototype.getJsDocTags = function(checker) {
          if (this.tags === void 0) {
            this.tags = getJsDocTagsOfDeclarations(this.declarations, checker);
          }
          return this.tags;
        };
        SymbolObject2.prototype.getContextualJsDocTags = function(context, checker) {
          switch (context === null || context === void 0 ? void 0 : context.kind) {
            case 172:
              if (!this.contextualGetAccessorTags) {
                this.contextualGetAccessorTags = getJsDocTagsOfDeclarations(ts3.filter(this.declarations, ts3.isGetAccessor), checker);
              }
              return this.contextualGetAccessorTags;
            case 173:
              if (!this.contextualSetAccessorTags) {
                this.contextualSetAccessorTags = getJsDocTagsOfDeclarations(ts3.filter(this.declarations, ts3.isSetAccessor), checker);
              }
              return this.contextualSetAccessorTags;
            default:
              return this.getJsDocTags(checker);
          }
        };
        return SymbolObject2;
      }();
      var TokenObject = function(_super) {
        __extends(TokenObject2, _super);
        function TokenObject2(kind, pos, end) {
          var _this = _super.call(this, pos, end) || this;
          _this.kind = kind;
          return _this;
        }
        return TokenObject2;
      }(TokenOrIdentifierObject);
      var IdentifierObject = function(_super) {
        __extends(IdentifierObject2, _super);
        function IdentifierObject2(_kind, pos, end) {
          var _this = _super.call(this, pos, end) || this;
          _this.kind = 79;
          return _this;
        }
        Object.defineProperty(IdentifierObject2.prototype, "text", {
          get: function() {
            return ts3.idText(this);
          },
          enumerable: false,
          configurable: true
        });
        return IdentifierObject2;
      }(TokenOrIdentifierObject);
      IdentifierObject.prototype.kind = 79;
      var PrivateIdentifierObject = function(_super) {
        __extends(PrivateIdentifierObject2, _super);
        function PrivateIdentifierObject2(_kind, pos, end) {
          return _super.call(this, pos, end) || this;
        }
        Object.defineProperty(PrivateIdentifierObject2.prototype, "text", {
          get: function() {
            return ts3.idText(this);
          },
          enumerable: false,
          configurable: true
        });
        return PrivateIdentifierObject2;
      }(TokenOrIdentifierObject);
      PrivateIdentifierObject.prototype.kind = 80;
      var TypeObject = function() {
        function TypeObject2(checker, flags) {
          this.checker = checker;
          this.flags = flags;
        }
        TypeObject2.prototype.getFlags = function() {
          return this.flags;
        };
        TypeObject2.prototype.getSymbol = function() {
          return this.symbol;
        };
        TypeObject2.prototype.getProperties = function() {
          return this.checker.getPropertiesOfType(this);
        };
        TypeObject2.prototype.getProperty = function(propertyName) {
          return this.checker.getPropertyOfType(this, propertyName);
        };
        TypeObject2.prototype.getApparentProperties = function() {
          return this.checker.getAugmentedPropertiesOfType(this);
        };
        TypeObject2.prototype.getCallSignatures = function() {
          return this.checker.getSignaturesOfType(this, 0);
        };
        TypeObject2.prototype.getConstructSignatures = function() {
          return this.checker.getSignaturesOfType(this, 1);
        };
        TypeObject2.prototype.getStringIndexType = function() {
          return this.checker.getIndexTypeOfType(this, 0);
        };
        TypeObject2.prototype.getNumberIndexType = function() {
          return this.checker.getIndexTypeOfType(this, 1);
        };
        TypeObject2.prototype.getBaseTypes = function() {
          return this.isClassOrInterface() ? this.checker.getBaseTypes(this) : void 0;
        };
        TypeObject2.prototype.isNullableType = function() {
          return this.checker.isNullableType(this);
        };
        TypeObject2.prototype.getNonNullableType = function() {
          return this.checker.getNonNullableType(this);
        };
        TypeObject2.prototype.getNonOptionalType = function() {
          return this.checker.getNonOptionalType(this);
        };
        TypeObject2.prototype.getConstraint = function() {
          return this.checker.getBaseConstraintOfType(this);
        };
        TypeObject2.prototype.getDefault = function() {
          return this.checker.getDefaultFromTypeParameter(this);
        };
        TypeObject2.prototype.isUnion = function() {
          return !!(this.flags & 1048576);
        };
        TypeObject2.prototype.isIntersection = function() {
          return !!(this.flags & 2097152);
        };
        TypeObject2.prototype.isUnionOrIntersection = function() {
          return !!(this.flags & 3145728);
        };
        TypeObject2.prototype.isLiteral = function() {
          return !!(this.flags & 384);
        };
        TypeObject2.prototype.isStringLiteral = function() {
          return !!(this.flags & 128);
        };
        TypeObject2.prototype.isNumberLiteral = function() {
          return !!(this.flags & 256);
        };
        TypeObject2.prototype.isTypeParameter = function() {
          return !!(this.flags & 262144);
        };
        TypeObject2.prototype.isClassOrInterface = function() {
          return !!(ts3.getObjectFlags(this) & 3);
        };
        TypeObject2.prototype.isClass = function() {
          return !!(ts3.getObjectFlags(this) & 1);
        };
        TypeObject2.prototype.isIndexType = function() {
          return !!(this.flags & 4194304);
        };
        Object.defineProperty(TypeObject2.prototype, "typeArguments", {
          get: function() {
            if (ts3.getObjectFlags(this) & 4) {
              return this.checker.getTypeArguments(this);
            }
            return void 0;
          },
          enumerable: false,
          configurable: true
        });
        return TypeObject2;
      }();
      var SignatureObject = function() {
        function SignatureObject2(checker, flags) {
          this.checker = checker;
          this.flags = flags;
        }
        SignatureObject2.prototype.getDeclaration = function() {
          return this.declaration;
        };
        SignatureObject2.prototype.getTypeParameters = function() {
          return this.typeParameters;
        };
        SignatureObject2.prototype.getParameters = function() {
          return this.parameters;
        };
        SignatureObject2.prototype.getReturnType = function() {
          return this.checker.getReturnTypeOfSignature(this);
        };
        SignatureObject2.prototype.getTypeParameterAtPosition = function(pos) {
          var type2 = this.checker.getParameterType(this, pos);
          if (type2.isIndexType() && ts3.isThisTypeParameter(type2.type)) {
            var constraint = type2.type.getConstraint();
            if (constraint) {
              return this.checker.getIndexType(constraint);
            }
          }
          return type2;
        };
        SignatureObject2.prototype.getDocumentationComment = function() {
          return this.documentationComment || (this.documentationComment = getDocumentationComment(ts3.singleElementArray(this.declaration), this.checker));
        };
        SignatureObject2.prototype.getJsDocTags = function() {
          return this.jsDocTags || (this.jsDocTags = getJsDocTagsOfDeclarations(ts3.singleElementArray(this.declaration), this.checker));
        };
        return SignatureObject2;
      }();
      function hasJSDocInheritDocTag(node) {
        return ts3.getJSDocTags(node).some(function(tag) {
          return tag.tagName.text === "inheritDoc";
        });
      }
      function getJsDocTagsOfDeclarations(declarations, checker) {
        if (!declarations)
          return ts3.emptyArray;
        var tags = ts3.JsDoc.getJsDocTagsFromDeclarations(declarations, checker);
        if (checker && (tags.length === 0 || declarations.some(hasJSDocInheritDocTag))) {
          var seenSymbols_1 = new ts3.Set();
          var _loop_22 = function(declaration2) {
            var inheritedTags = findBaseOfDeclaration(checker, declaration2, function(symbol) {
              var _a;
              if (!seenSymbols_1.has(symbol)) {
                seenSymbols_1.add(symbol);
                if (declaration2.kind === 172 || declaration2.kind === 173) {
                  return symbol.getContextualJsDocTags(declaration2, checker);
                }
                return ((_a = symbol.declarations) === null || _a === void 0 ? void 0 : _a.length) === 1 ? symbol.getJsDocTags() : void 0;
              }
            });
            if (inheritedTags) {
              tags = __spreadArray(__spreadArray([], inheritedTags, true), tags, true);
            }
          };
          for (var _i = 0, declarations_6 = declarations; _i < declarations_6.length; _i++) {
            var declaration = declarations_6[_i];
            _loop_22(declaration);
          }
        }
        return tags;
      }
      function getDocumentationComment(declarations, checker) {
        if (!declarations)
          return ts3.emptyArray;
        var doc = ts3.JsDoc.getJsDocCommentsFromDeclarations(declarations, checker);
        if (checker && (doc.length === 0 || declarations.some(hasJSDocInheritDocTag))) {
          var seenSymbols_2 = new ts3.Set();
          var _loop_23 = function(declaration2) {
            var inheritedDocs = findBaseOfDeclaration(checker, declaration2, function(symbol) {
              if (!seenSymbols_2.has(symbol)) {
                seenSymbols_2.add(symbol);
                if (declaration2.kind === 172 || declaration2.kind === 173) {
                  return symbol.getContextualDocumentationComment(declaration2, checker);
                }
                return symbol.getDocumentationComment(checker);
              }
            });
            if (inheritedDocs)
              doc = doc.length === 0 ? inheritedDocs.slice() : inheritedDocs.concat(ts3.lineBreakPart(), doc);
          };
          for (var _i = 0, declarations_7 = declarations; _i < declarations_7.length; _i++) {
            var declaration = declarations_7[_i];
            _loop_23(declaration);
          }
        }
        return doc;
      }
      function findBaseOfDeclaration(checker, declaration, cb) {
        var _a;
        if (ts3.hasStaticModifier(declaration))
          return;
        var classOrInterfaceDeclaration = ((_a = declaration.parent) === null || _a === void 0 ? void 0 : _a.kind) === 171 ? declaration.parent.parent : declaration.parent;
        if (!classOrInterfaceDeclaration)
          return;
        return ts3.firstDefined(ts3.getAllSuperTypeNodes(classOrInterfaceDeclaration), function(superTypeNode) {
          var symbol = checker.getPropertyOfType(checker.getTypeAtLocation(superTypeNode), declaration.symbol.name);
          return symbol ? cb(symbol) : void 0;
        });
      }
      var SourceFileObject = function(_super) {
        __extends(SourceFileObject2, _super);
        function SourceFileObject2(kind, pos, end) {
          var _this = _super.call(this, kind, pos, end) || this;
          _this.kind = 305;
          return _this;
        }
        SourceFileObject2.prototype.update = function(newText, textChangeRange) {
          return ts3.updateSourceFile(this, newText, textChangeRange);
        };
        SourceFileObject2.prototype.getLineAndCharacterOfPosition = function(position) {
          return ts3.getLineAndCharacterOfPosition(this, position);
        };
        SourceFileObject2.prototype.getLineStarts = function() {
          return ts3.getLineStarts(this);
        };
        SourceFileObject2.prototype.getPositionOfLineAndCharacter = function(line, character, allowEdits) {
          return ts3.computePositionOfLineAndCharacter(ts3.getLineStarts(this), line, character, this.text, allowEdits);
        };
        SourceFileObject2.prototype.getLineEndOfPosition = function(pos) {
          var line = this.getLineAndCharacterOfPosition(pos).line;
          var lineStarts = this.getLineStarts();
          var lastCharPos;
          if (line + 1 >= lineStarts.length) {
            lastCharPos = this.getEnd();
          }
          if (!lastCharPos) {
            lastCharPos = lineStarts[line + 1] - 1;
          }
          var fullText = this.getFullText();
          return fullText[lastCharPos] === "\n" && fullText[lastCharPos - 1] === "\r" ? lastCharPos - 1 : lastCharPos;
        };
        SourceFileObject2.prototype.getNamedDeclarations = function() {
          if (!this.namedDeclarations) {
            this.namedDeclarations = this.computeNamedDeclarations();
          }
          return this.namedDeclarations;
        };
        SourceFileObject2.prototype.computeNamedDeclarations = function() {
          var result2 = ts3.createMultiMap();
          this.forEachChild(visit);
          return result2;
          function addDeclaration(declaration) {
            var name = getDeclarationName(declaration);
            if (name) {
              result2.add(name, declaration);
            }
          }
          function getDeclarations(name) {
            var declarations = result2.get(name);
            if (!declarations) {
              result2.set(name, declarations = []);
            }
            return declarations;
          }
          function getDeclarationName(declaration) {
            var name = ts3.getNonAssignedNameOfDeclaration(declaration);
            return name && (ts3.isComputedPropertyName(name) && ts3.isPropertyAccessExpression(name.expression) ? name.expression.name.text : ts3.isPropertyName(name) ? ts3.getNameFromPropertyName(name) : void 0);
          }
          function visit(node) {
            switch (node.kind) {
              case 256:
              case 213:
              case 169:
              case 168:
                var functionDeclaration = node;
                var declarationName = getDeclarationName(functionDeclaration);
                if (declarationName) {
                  var declarations = getDeclarations(declarationName);
                  var lastDeclaration = ts3.lastOrUndefined(declarations);
                  if (lastDeclaration && functionDeclaration.parent === lastDeclaration.parent && functionDeclaration.symbol === lastDeclaration.symbol) {
                    if (functionDeclaration.body && !lastDeclaration.body) {
                      declarations[declarations.length - 1] = functionDeclaration;
                    }
                  } else {
                    declarations.push(functionDeclaration);
                  }
                }
                ts3.forEachChild(node, visit);
                break;
              case 257:
              case 226:
              case 258:
              case 259:
              case 260:
              case 261:
              case 265:
              case 275:
              case 270:
              case 267:
              case 268:
              case 172:
              case 173:
              case 182:
                addDeclaration(node);
                ts3.forEachChild(node, visit);
                break;
              case 164:
                if (!ts3.hasSyntacticModifier(node, 16476)) {
                  break;
                }
              case 254:
              case 203: {
                var decl = node;
                if (ts3.isBindingPattern(decl.name)) {
                  ts3.forEachChild(decl.name, visit);
                  break;
                }
                if (decl.initializer) {
                  visit(decl.initializer);
                }
              }
              case 299:
              case 167:
              case 166:
                addDeclaration(node);
                break;
              case 272:
                var exportDeclaration = node;
                if (exportDeclaration.exportClause) {
                  if (ts3.isNamedExports(exportDeclaration.exportClause)) {
                    ts3.forEach(exportDeclaration.exportClause.elements, visit);
                  } else {
                    visit(exportDeclaration.exportClause.name);
                  }
                }
                break;
              case 266:
                var importClause = node.importClause;
                if (importClause) {
                  if (importClause.name) {
                    addDeclaration(importClause.name);
                  }
                  if (importClause.namedBindings) {
                    if (importClause.namedBindings.kind === 268) {
                      addDeclaration(importClause.namedBindings);
                    } else {
                      ts3.forEach(importClause.namedBindings.elements, visit);
                    }
                  }
                }
                break;
              case 221:
                if (ts3.getAssignmentDeclarationKind(node) !== 0) {
                  addDeclaration(node);
                }
              default:
                ts3.forEachChild(node, visit);
            }
          }
        };
        return SourceFileObject2;
      }(NodeObject);
      var SourceMapSourceObject = function() {
        function SourceMapSourceObject2(fileName2, text, skipTrivia) {
          this.fileName = fileName2;
          this.text = text;
          this.skipTrivia = skipTrivia;
        }
        SourceMapSourceObject2.prototype.getLineAndCharacterOfPosition = function(pos) {
          return ts3.getLineAndCharacterOfPosition(this, pos);
        };
        return SourceMapSourceObject2;
      }();
      function getServicesObjectAllocator() {
        return {
          getNodeConstructor: function() {
            return NodeObject;
          },
          getTokenConstructor: function() {
            return TokenObject;
          },
          getIdentifierConstructor: function() {
            return IdentifierObject;
          },
          getPrivateIdentifierConstructor: function() {
            return PrivateIdentifierObject;
          },
          getSourceFileConstructor: function() {
            return SourceFileObject;
          },
          getSymbolConstructor: function() {
            return SymbolObject;
          },
          getTypeConstructor: function() {
            return TypeObject;
          },
          getSignatureConstructor: function() {
            return SignatureObject;
          },
          getSourceMapSourceConstructor: function() {
            return SourceMapSourceObject;
          }
        };
      }
      function toEditorSettings(optionsAsMap) {
        var allPropertiesAreCamelCased = true;
        for (var key in optionsAsMap) {
          if (ts3.hasProperty(optionsAsMap, key) && !isCamelCase(key)) {
            allPropertiesAreCamelCased = false;
            break;
          }
        }
        if (allPropertiesAreCamelCased) {
          return optionsAsMap;
        }
        var settings = {};
        for (var key in optionsAsMap) {
          if (ts3.hasProperty(optionsAsMap, key)) {
            var newKey = isCamelCase(key) ? key : key.charAt(0).toLowerCase() + key.substr(1);
            settings[newKey] = optionsAsMap[key];
          }
        }
        return settings;
      }
      ts3.toEditorSettings = toEditorSettings;
      function isCamelCase(s) {
        return !s.length || s.charAt(0) === s.charAt(0).toLowerCase();
      }
      function displayPartsToString(displayParts) {
        if (displayParts) {
          return ts3.map(displayParts, function(displayPart) {
            return displayPart.text;
          }).join("");
        }
        return "";
      }
      ts3.displayPartsToString = displayPartsToString;
      function getDefaultCompilerOptions() {
        return {
          target: 1,
          jsx: 1
        };
      }
      ts3.getDefaultCompilerOptions = getDefaultCompilerOptions;
      function getSupportedCodeFixes() {
        return ts3.codefix.getSupportedErrorCodes();
      }
      ts3.getSupportedCodeFixes = getSupportedCodeFixes;
      var HostCache = function() {
        function HostCache2(host, getCanonicalFileName) {
          this.host = host;
          this.currentDirectory = host.getCurrentDirectory();
          this.fileNameToEntry = new ts3.Map();
          var rootFileNames = host.getScriptFileNames();
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("session", "initializeHostCache", { count: rootFileNames.length });
          for (var _i = 0, rootFileNames_1 = rootFileNames; _i < rootFileNames_1.length; _i++) {
            var fileName2 = rootFileNames_1[_i];
            this.createEntry(fileName2, ts3.toPath(fileName2, this.currentDirectory, getCanonicalFileName));
          }
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        HostCache2.prototype.createEntry = function(fileName2, path2) {
          var entry;
          var scriptSnapshot = this.host.getScriptSnapshot(fileName2);
          if (scriptSnapshot) {
            entry = {
              hostFileName: fileName2,
              version: this.host.getScriptVersion(fileName2),
              scriptSnapshot,
              scriptKind: ts3.getScriptKind(fileName2, this.host)
            };
          } else {
            entry = fileName2;
          }
          this.fileNameToEntry.set(path2, entry);
          return entry;
        };
        HostCache2.prototype.getEntryByPath = function(path2) {
          return this.fileNameToEntry.get(path2);
        };
        HostCache2.prototype.getHostFileInformation = function(path2) {
          var entry = this.fileNameToEntry.get(path2);
          return !ts3.isString(entry) ? entry : void 0;
        };
        HostCache2.prototype.getOrCreateEntryByPath = function(fileName2, path2) {
          var info = this.getEntryByPath(path2) || this.createEntry(fileName2, path2);
          return ts3.isString(info) ? void 0 : info;
        };
        HostCache2.prototype.getRootFileNames = function() {
          var names = [];
          this.fileNameToEntry.forEach(function(entry) {
            if (ts3.isString(entry)) {
              names.push(entry);
            } else {
              names.push(entry.hostFileName);
            }
          });
          return names;
        };
        HostCache2.prototype.getScriptSnapshot = function(path2) {
          var file = this.getHostFileInformation(path2);
          return file && file.scriptSnapshot;
        };
        return HostCache2;
      }();
      var SyntaxTreeCache = function() {
        function SyntaxTreeCache2(host) {
          this.host = host;
        }
        SyntaxTreeCache2.prototype.getCurrentSourceFile = function(fileName2) {
          var _a, _b, _c, _d, _e, _f, _g, _h;
          var scriptSnapshot = this.host.getScriptSnapshot(fileName2);
          if (!scriptSnapshot) {
            throw new Error("Could not find file: '" + fileName2 + "'.");
          }
          var scriptKind = ts3.getScriptKind(fileName2, this.host);
          var version = this.host.getScriptVersion(fileName2);
          var sourceFile;
          if (this.currentFileName !== fileName2) {
            var options = {
              languageVersion: 99,
              impliedNodeFormat: ts3.getImpliedNodeFormatForFile(ts3.toPath(fileName2, this.host.getCurrentDirectory(), ((_c = (_b = (_a = this.host).getCompilerHost) === null || _b === void 0 ? void 0 : _b.call(_a)) === null || _c === void 0 ? void 0 : _c.getCanonicalFileName) || ts3.hostGetCanonicalFileName(this.host)), (_h = (_g = (_f = (_e = (_d = this.host).getCompilerHost) === null || _e === void 0 ? void 0 : _e.call(_d)) === null || _f === void 0 ? void 0 : _f.getModuleResolutionCache) === null || _g === void 0 ? void 0 : _g.call(_f)) === null || _h === void 0 ? void 0 : _h.getPackageJsonInfoCache(), this.host, this.host.getCompilationSettings()),
              setExternalModuleIndicator: ts3.getSetExternalModuleIndicator(this.host.getCompilationSettings())
            };
            sourceFile = createLanguageServiceSourceFile(fileName2, scriptSnapshot, options, version, true, scriptKind);
          } else if (this.currentFileVersion !== version) {
            var editRange = scriptSnapshot.getChangeRange(this.currentFileScriptSnapshot);
            sourceFile = updateLanguageServiceSourceFile(this.currentSourceFile, scriptSnapshot, version, editRange);
          }
          if (sourceFile) {
            this.currentFileVersion = version;
            this.currentFileName = fileName2;
            this.currentFileScriptSnapshot = scriptSnapshot;
            this.currentSourceFile = sourceFile;
          }
          return this.currentSourceFile;
        };
        return SyntaxTreeCache2;
      }();
      function setSourceFileFields(sourceFile, scriptSnapshot, version) {
        sourceFile.version = version;
        sourceFile.scriptSnapshot = scriptSnapshot;
      }
      function createLanguageServiceSourceFile(fileName2, scriptSnapshot, scriptTargetOrOptions, version, setNodeParents, scriptKind) {
        var sourceFile = ts3.createSourceFile(fileName2, ts3.getSnapshotText(scriptSnapshot), scriptTargetOrOptions, setNodeParents, scriptKind);
        setSourceFileFields(sourceFile, scriptSnapshot, version);
        return sourceFile;
      }
      ts3.createLanguageServiceSourceFile = createLanguageServiceSourceFile;
      function updateLanguageServiceSourceFile(sourceFile, scriptSnapshot, version, textChangeRange, aggressiveChecks) {
        if (textChangeRange) {
          if (version !== sourceFile.version) {
            var newText = void 0;
            var prefix = textChangeRange.span.start !== 0 ? sourceFile.text.substr(0, textChangeRange.span.start) : "";
            var suffix = ts3.textSpanEnd(textChangeRange.span) !== sourceFile.text.length ? sourceFile.text.substr(ts3.textSpanEnd(textChangeRange.span)) : "";
            if (textChangeRange.newLength === 0) {
              newText = prefix && suffix ? prefix + suffix : prefix || suffix;
            } else {
              var changedText = scriptSnapshot.getText(textChangeRange.span.start, textChangeRange.span.start + textChangeRange.newLength);
              newText = prefix && suffix ? prefix + changedText + suffix : prefix ? prefix + changedText : changedText + suffix;
            }
            var newSourceFile = ts3.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
            setSourceFileFields(newSourceFile, scriptSnapshot, version);
            newSourceFile.nameTable = void 0;
            if (sourceFile !== newSourceFile && sourceFile.scriptSnapshot) {
              if (sourceFile.scriptSnapshot.dispose) {
                sourceFile.scriptSnapshot.dispose();
              }
              sourceFile.scriptSnapshot = void 0;
            }
            return newSourceFile;
          }
        }
        var options = {
          languageVersion: sourceFile.languageVersion,
          impliedNodeFormat: sourceFile.impliedNodeFormat,
          setExternalModuleIndicator: sourceFile.setExternalModuleIndicator
        };
        return createLanguageServiceSourceFile(sourceFile.fileName, scriptSnapshot, options, version, true, sourceFile.scriptKind);
      }
      ts3.updateLanguageServiceSourceFile = updateLanguageServiceSourceFile;
      var NoopCancellationToken = {
        isCancellationRequested: ts3.returnFalse,
        throwIfCancellationRequested: ts3.noop
      };
      var CancellationTokenObject = function() {
        function CancellationTokenObject2(cancellationToken) {
          this.cancellationToken = cancellationToken;
        }
        CancellationTokenObject2.prototype.isCancellationRequested = function() {
          return this.cancellationToken.isCancellationRequested();
        };
        CancellationTokenObject2.prototype.throwIfCancellationRequested = function() {
          if (this.isCancellationRequested()) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("session", "cancellationThrown", { kind: "CancellationTokenObject" });
            throw new ts3.OperationCanceledException();
          }
        };
        return CancellationTokenObject2;
      }();
      var ThrottledCancellationToken = function() {
        function ThrottledCancellationToken2(hostCancellationToken, throttleWaitMilliseconds) {
          if (throttleWaitMilliseconds === void 0) {
            throttleWaitMilliseconds = 20;
          }
          this.hostCancellationToken = hostCancellationToken;
          this.throttleWaitMilliseconds = throttleWaitMilliseconds;
          this.lastCancellationCheckTime = 0;
        }
        ThrottledCancellationToken2.prototype.isCancellationRequested = function() {
          var time = ts3.timestamp();
          var duration = Math.abs(time - this.lastCancellationCheckTime);
          if (duration >= this.throttleWaitMilliseconds) {
            this.lastCancellationCheckTime = time;
            return this.hostCancellationToken.isCancellationRequested();
          }
          return false;
        };
        ThrottledCancellationToken2.prototype.throwIfCancellationRequested = function() {
          if (this.isCancellationRequested()) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("session", "cancellationThrown", { kind: "ThrottledCancellationToken" });
            throw new ts3.OperationCanceledException();
          }
        };
        return ThrottledCancellationToken2;
      }();
      ts3.ThrottledCancellationToken = ThrottledCancellationToken;
      var invalidOperationsInPartialSemanticMode = [
        "getSemanticDiagnostics",
        "getSuggestionDiagnostics",
        "getCompilerOptionsDiagnostics",
        "getSemanticClassifications",
        "getEncodedSemanticClassifications",
        "getCodeFixesAtPosition",
        "getCombinedCodeFix",
        "applyCodeActionCommand",
        "organizeImports",
        "getEditsForFileRename",
        "getEmitOutput",
        "getApplicableRefactors",
        "getEditsForRefactor",
        "prepareCallHierarchy",
        "provideCallHierarchyIncomingCalls",
        "provideCallHierarchyOutgoingCalls",
        "provideInlayHints"
      ];
      var invalidOperationsInSyntacticMode = __spreadArray(__spreadArray([], invalidOperationsInPartialSemanticMode, true), [
        "getCompletionsAtPosition",
        "getCompletionEntryDetails",
        "getCompletionEntrySymbol",
        "getSignatureHelpItems",
        "getQuickInfoAtPosition",
        "getDefinitionAtPosition",
        "getDefinitionAndBoundSpan",
        "getImplementationAtPosition",
        "getTypeDefinitionAtPosition",
        "getReferencesAtPosition",
        "findReferences",
        "getOccurrencesAtPosition",
        "getDocumentHighlights",
        "getNavigateToItems",
        "getRenameInfo",
        "findRenameLocations",
        "getApplicableRefactors"
      ], false);
      function createLanguageService(host, documentRegistry, syntaxOnlyOrLanguageServiceMode) {
        var _a;
        var _b;
        if (documentRegistry === void 0) {
          documentRegistry = ts3.createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory());
        }
        var languageServiceMode;
        if (syntaxOnlyOrLanguageServiceMode === void 0) {
          languageServiceMode = ts3.LanguageServiceMode.Semantic;
        } else if (typeof syntaxOnlyOrLanguageServiceMode === "boolean") {
          languageServiceMode = syntaxOnlyOrLanguageServiceMode ? ts3.LanguageServiceMode.Syntactic : ts3.LanguageServiceMode.Semantic;
        } else {
          languageServiceMode = syntaxOnlyOrLanguageServiceMode;
        }
        var syntaxTreeCache = new SyntaxTreeCache(host);
        var program2;
        var lastProjectVersion;
        var lastTypesRootVersion = 0;
        var cancellationToken = host.getCancellationToken ? new CancellationTokenObject(host.getCancellationToken()) : NoopCancellationToken;
        var currentDirectory = host.getCurrentDirectory();
        ts3.maybeSetLocalizedDiagnosticMessages((_b = host.getLocalizedDiagnosticMessages) === null || _b === void 0 ? void 0 : _b.bind(host));
        function log(message) {
          if (host.log) {
            host.log(message);
          }
        }
        var useCaseSensitiveFileNames = ts3.hostUsesCaseSensitiveFileNames(host);
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        var sourceMapper = ts3.getSourceMapper({
          useCaseSensitiveFileNames: function() {
            return useCaseSensitiveFileNames;
          },
          getCurrentDirectory: function() {
            return currentDirectory;
          },
          getProgram,
          fileExists: ts3.maybeBind(host, host.fileExists),
          readFile: ts3.maybeBind(host, host.readFile),
          getDocumentPositionMapper: ts3.maybeBind(host, host.getDocumentPositionMapper),
          getSourceFileLike: ts3.maybeBind(host, host.getSourceFileLike),
          log
        });
        function getValidSourceFile(fileName2) {
          var sourceFile = program2.getSourceFile(fileName2);
          if (!sourceFile) {
            var error = new Error("Could not find source file: '".concat(fileName2, "'."));
            error.ProgramFiles = program2.getSourceFiles().map(function(f) {
              return f.fileName;
            });
            throw error;
          }
          return sourceFile;
        }
        function synchronizeHostData() {
          var _a2, _b2, _c;
          ts3.Debug.assert(languageServiceMode !== ts3.LanguageServiceMode.Syntactic);
          if (host.getProjectVersion) {
            var hostProjectVersion = host.getProjectVersion();
            if (hostProjectVersion) {
              if (lastProjectVersion === hostProjectVersion && !((_a2 = host.hasChangedAutomaticTypeDirectiveNames) === null || _a2 === void 0 ? void 0 : _a2.call(host))) {
                return;
              }
              lastProjectVersion = hostProjectVersion;
            }
          }
          var typeRootsVersion = host.getTypeRootsVersion ? host.getTypeRootsVersion() : 0;
          if (lastTypesRootVersion !== typeRootsVersion) {
            log("TypeRoots version has changed; provide new program");
            program2 = void 0;
            lastTypesRootVersion = typeRootsVersion;
          }
          var hostCache = new HostCache(host, getCanonicalFileName);
          var rootFileNames = hostCache.getRootFileNames();
          var newSettings = host.getCompilationSettings() || getDefaultCompilerOptions();
          var hasInvalidatedResolution = host.hasInvalidatedResolution || ts3.returnFalse;
          var hasChangedAutomaticTypeDirectiveNames = ts3.maybeBind(host, host.hasChangedAutomaticTypeDirectiveNames);
          var projectReferences = (_b2 = host.getProjectReferences) === null || _b2 === void 0 ? void 0 : _b2.call(host);
          var parsedCommandLines;
          var parseConfigHost = {
            useCaseSensitiveFileNames,
            fileExists,
            readFile,
            readDirectory,
            trace: ts3.maybeBind(host, host.trace),
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            onUnRecoverableConfigFileDiagnostic: ts3.noop
          };
          if (ts3.isProgramUptoDate(program2, rootFileNames, newSettings, function(_path, fileName2) {
            return host.getScriptVersion(fileName2);
          }, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences)) {
            return;
          }
          var compilerHost = {
            getSourceFile: getOrCreateSourceFile,
            getSourceFileByPath: getOrCreateSourceFileByPath,
            getCancellationToken: function() {
              return cancellationToken;
            },
            getCanonicalFileName,
            useCaseSensitiveFileNames: function() {
              return useCaseSensitiveFileNames;
            },
            getNewLine: function() {
              return ts3.getNewLineCharacter(newSettings, function() {
                return ts3.getNewLineOrDefaultFromHost(host);
              });
            },
            getDefaultLibFileName: function(options2) {
              return host.getDefaultLibFileName(options2);
            },
            writeFile: ts3.noop,
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            fileExists,
            readFile,
            getSymlinkCache: ts3.maybeBind(host, host.getSymlinkCache),
            realpath: ts3.maybeBind(host, host.realpath),
            directoryExists: function(directoryName) {
              return ts3.directoryProbablyExists(directoryName, host);
            },
            getDirectories: function(path2) {
              return host.getDirectories ? host.getDirectories(path2) : [];
            },
            readDirectory,
            onReleaseOldSourceFile,
            onReleaseParsedCommandLine,
            hasInvalidatedResolution,
            hasChangedAutomaticTypeDirectiveNames,
            trace: parseConfigHost.trace,
            resolveModuleNames: ts3.maybeBind(host, host.resolveModuleNames),
            getModuleResolutionCache: ts3.maybeBind(host, host.getModuleResolutionCache),
            resolveTypeReferenceDirectives: ts3.maybeBind(host, host.resolveTypeReferenceDirectives),
            useSourceOfProjectReferenceRedirect: ts3.maybeBind(host, host.useSourceOfProjectReferenceRedirect),
            getParsedCommandLine
          };
          (_c = host.setCompilerHost) === null || _c === void 0 ? void 0 : _c.call(host, compilerHost);
          var documentRegistryBucketKey = documentRegistry.getKeyForCompilationSettings(newSettings);
          var options = {
            rootNames: rootFileNames,
            options: newSettings,
            host: compilerHost,
            oldProgram: program2,
            projectReferences
          };
          program2 = ts3.createProgram(options);
          hostCache = void 0;
          parsedCommandLines = void 0;
          sourceMapper.clearCache();
          program2.getTypeChecker();
          return;
          function getParsedCommandLine(fileName2) {
            var path2 = ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
            var existing = parsedCommandLines === null || parsedCommandLines === void 0 ? void 0 : parsedCommandLines.get(path2);
            if (existing !== void 0)
              return existing || void 0;
            var result2 = host.getParsedCommandLine ? host.getParsedCommandLine(fileName2) : getParsedCommandLineOfConfigFileUsingSourceFile(fileName2);
            (parsedCommandLines || (parsedCommandLines = new ts3.Map())).set(path2, result2 || false);
            return result2;
          }
          function getParsedCommandLineOfConfigFileUsingSourceFile(configFileName) {
            var result2 = getOrCreateSourceFile(configFileName, 100);
            if (!result2)
              return void 0;
            result2.path = ts3.toPath(configFileName, currentDirectory, getCanonicalFileName);
            result2.resolvedPath = result2.path;
            result2.originalFileName = result2.fileName;
            return ts3.parseJsonSourceFileConfigFileContent(result2, parseConfigHost, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), currentDirectory), void 0, ts3.getNormalizedAbsolutePath(configFileName, currentDirectory));
          }
          function onReleaseParsedCommandLine(configFileName, oldResolvedRef, oldOptions) {
            var _a3;
            if (host.getParsedCommandLine) {
              (_a3 = host.onReleaseParsedCommandLine) === null || _a3 === void 0 ? void 0 : _a3.call(host, configFileName, oldResolvedRef, oldOptions);
            } else if (oldResolvedRef) {
              onReleaseOldSourceFile(oldResolvedRef.sourceFile, oldOptions);
            }
          }
          function fileExists(fileName2) {
            var path2 = ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
            var entry = hostCache && hostCache.getEntryByPath(path2);
            return entry ? !ts3.isString(entry) : !!host.fileExists && host.fileExists(fileName2);
          }
          function readFile(fileName2) {
            var path2 = ts3.toPath(fileName2, currentDirectory, getCanonicalFileName);
            var entry = hostCache && hostCache.getEntryByPath(path2);
            if (entry) {
              return ts3.isString(entry) ? void 0 : ts3.getSnapshotText(entry.scriptSnapshot);
            }
            return host.readFile && host.readFile(fileName2);
          }
          function readDirectory(path2, extensions, exclude, include, depth) {
            ts3.Debug.checkDefined(host.readDirectory, "'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'");
            return host.readDirectory(path2, extensions, exclude, include, depth);
          }
          function onReleaseOldSourceFile(oldSourceFile, oldOptions) {
            var oldSettingsKey = documentRegistry.getKeyForCompilationSettings(oldOptions);
            documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, oldSettingsKey, oldSourceFile.scriptKind);
          }
          function getOrCreateSourceFile(fileName2, languageVersion, onError, shouldCreateNewSourceFile) {
            return getOrCreateSourceFileByPath(fileName2, ts3.toPath(fileName2, currentDirectory, getCanonicalFileName), languageVersion, onError, shouldCreateNewSourceFile);
          }
          function getOrCreateSourceFileByPath(fileName2, path2, _languageVersion, _onError, shouldCreateNewSourceFile) {
            ts3.Debug.assert(hostCache !== void 0, "getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");
            var hostFileInformation = hostCache && hostCache.getOrCreateEntryByPath(fileName2, path2);
            if (!hostFileInformation) {
              return void 0;
            }
            if (!shouldCreateNewSourceFile) {
              var oldSourceFile = program2 && program2.getSourceFileByPath(path2);
              if (oldSourceFile) {
                if (hostFileInformation.scriptKind === oldSourceFile.scriptKind) {
                  return documentRegistry.updateDocumentWithKey(fileName2, path2, host, documentRegistryBucketKey, hostFileInformation.scriptSnapshot, hostFileInformation.version, hostFileInformation.scriptKind);
                } else {
                  documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, documentRegistry.getKeyForCompilationSettings(program2.getCompilerOptions()), oldSourceFile.scriptKind);
                }
              }
            }
            return documentRegistry.acquireDocumentWithKey(fileName2, path2, host, documentRegistryBucketKey, hostFileInformation.scriptSnapshot, hostFileInformation.version, hostFileInformation.scriptKind);
          }
        }
        function getProgram() {
          if (languageServiceMode === ts3.LanguageServiceMode.Syntactic) {
            ts3.Debug.assert(program2 === void 0);
            return void 0;
          }
          synchronizeHostData();
          return program2;
        }
        function getAutoImportProvider() {
          var _a2;
          return (_a2 = host.getPackageJsonAutoImportProvider) === null || _a2 === void 0 ? void 0 : _a2.call(host);
        }
        function cleanupSemanticCache() {
          program2 = void 0;
        }
        function dispose() {
          if (program2) {
            var key_1 = documentRegistry.getKeyForCompilationSettings(program2.getCompilerOptions());
            ts3.forEach(program2.getSourceFiles(), function(f) {
              return documentRegistry.releaseDocumentWithKey(f.resolvedPath, key_1, f.scriptKind);
            });
            program2 = void 0;
          }
          host = void 0;
        }
        function getSyntacticDiagnostics(fileName2) {
          synchronizeHostData();
          return program2.getSyntacticDiagnostics(getValidSourceFile(fileName2), cancellationToken).slice();
        }
        function getSemanticDiagnostics(fileName2) {
          synchronizeHostData();
          var targetSourceFile = getValidSourceFile(fileName2);
          var semanticDiagnostics = program2.getSemanticDiagnostics(targetSourceFile, cancellationToken);
          if (!ts3.getEmitDeclarations(program2.getCompilerOptions())) {
            return semanticDiagnostics.slice();
          }
          var declarationDiagnostics = program2.getDeclarationDiagnostics(targetSourceFile, cancellationToken);
          return __spreadArray(__spreadArray([], semanticDiagnostics, true), declarationDiagnostics, true);
        }
        function getSuggestionDiagnostics(fileName2) {
          synchronizeHostData();
          return ts3.computeSuggestionDiagnostics(getValidSourceFile(fileName2), program2, cancellationToken);
        }
        function getCompilerOptionsDiagnostics() {
          synchronizeHostData();
          return __spreadArray(__spreadArray([], program2.getOptionsDiagnostics(cancellationToken), true), program2.getGlobalDiagnostics(cancellationToken), true);
        }
        function getCompletionsAtPosition(fileName2, position, options, formattingSettings) {
          if (options === void 0) {
            options = ts3.emptyOptions;
          }
          var fullPreferences = __assign(__assign({}, ts3.identity(options)), { includeCompletionsForModuleExports: options.includeCompletionsForModuleExports || options.includeExternalModuleExports, includeCompletionsWithInsertText: options.includeCompletionsWithInsertText || options.includeInsertTextCompletions });
          synchronizeHostData();
          return ts3.Completions.getCompletionsAtPosition(host, program2, log, getValidSourceFile(fileName2), position, fullPreferences, options.triggerCharacter, options.triggerKind, cancellationToken, formattingSettings && ts3.formatting.getFormatContext(formattingSettings, host));
        }
        function getCompletionEntryDetails(fileName2, position, name, formattingOptions, source, preferences, data) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          return ts3.Completions.getCompletionEntryDetails(program2, log, getValidSourceFile(fileName2), position, { name, source, data }, host, formattingOptions && ts3.formatting.getFormatContext(formattingOptions, host), preferences, cancellationToken);
        }
        function getCompletionEntrySymbol(fileName2, position, name, source, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          return ts3.Completions.getCompletionEntrySymbol(program2, log, getValidSourceFile(fileName2), position, { name, source }, host, preferences);
        }
        function getQuickInfoAtPosition(fileName2, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var typeChecker = program2.getTypeChecker();
          var nodeForQuickInfo = getNodeForQuickInfo(node);
          var symbol = getSymbolAtLocationForQuickInfo(nodeForQuickInfo, typeChecker);
          if (!symbol || typeChecker.isUnknownSymbol(symbol)) {
            var type_2 = shouldGetType(sourceFile, nodeForQuickInfo, position) ? typeChecker.getTypeAtLocation(nodeForQuickInfo) : void 0;
            return type_2 && {
              kind: "",
              kindModifiers: "",
              textSpan: ts3.createTextSpanFromNode(nodeForQuickInfo, sourceFile),
              displayParts: typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
                return ts3.typeToDisplayParts(typeChecker2, type_2, ts3.getContainerNode(nodeForQuickInfo));
              }),
              documentation: type_2.symbol ? type_2.symbol.getDocumentationComment(typeChecker) : void 0,
              tags: type_2.symbol ? type_2.symbol.getJsDocTags(typeChecker) : void 0
            };
          }
          var _a2 = typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
            return ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker2, symbol, sourceFile, ts3.getContainerNode(nodeForQuickInfo), nodeForQuickInfo);
          }), symbolKind = _a2.symbolKind, displayParts = _a2.displayParts, documentation = _a2.documentation, tags = _a2.tags;
          return {
            kind: symbolKind,
            kindModifiers: ts3.SymbolDisplay.getSymbolModifiers(typeChecker, symbol),
            textSpan: ts3.createTextSpanFromNode(nodeForQuickInfo, sourceFile),
            displayParts,
            documentation,
            tags
          };
        }
        function getNodeForQuickInfo(node) {
          if (ts3.isNewExpression(node.parent) && node.pos === node.parent.pos) {
            return node.parent.expression;
          }
          if (ts3.isNamedTupleMember(node.parent) && node.pos === node.parent.pos) {
            return node.parent;
          }
          if (ts3.isImportMeta(node.parent) && node.parent.name === node) {
            return node.parent;
          }
          return node;
        }
        function shouldGetType(sourceFile, node, position) {
          switch (node.kind) {
            case 79:
              return !ts3.isLabelName(node) && !ts3.isTagName(node) && !ts3.isConstTypeReference(node.parent);
            case 206:
            case 161:
              return !ts3.isInComment(sourceFile, position);
            case 108:
            case 192:
            case 106:
            case 197:
              return true;
            case 231:
              return ts3.isImportMeta(node);
            default:
              return false;
          }
        }
        function getDefinitionAtPosition(fileName2, position, searchOtherFilesOnly, stopAtAlias) {
          synchronizeHostData();
          return ts3.GoToDefinition.getDefinitionAtPosition(program2, getValidSourceFile(fileName2), position, searchOtherFilesOnly, stopAtAlias);
        }
        function getDefinitionAndBoundSpan(fileName2, position) {
          synchronizeHostData();
          return ts3.GoToDefinition.getDefinitionAndBoundSpan(program2, getValidSourceFile(fileName2), position);
        }
        function getTypeDefinitionAtPosition(fileName2, position) {
          synchronizeHostData();
          return ts3.GoToDefinition.getTypeDefinitionAtPosition(program2.getTypeChecker(), getValidSourceFile(fileName2), position);
        }
        function getImplementationAtPosition(fileName2, position) {
          synchronizeHostData();
          return ts3.FindAllReferences.getImplementationsAtPosition(program2, cancellationToken, program2.getSourceFiles(), getValidSourceFile(fileName2), position);
        }
        function getOccurrencesAtPosition(fileName2, position) {
          return ts3.flatMap(getDocumentHighlights(fileName2, position, [fileName2]), function(entry) {
            return entry.highlightSpans.map(function(highlightSpan) {
              return __assign(__assign({ fileName: entry.fileName, textSpan: highlightSpan.textSpan, isWriteAccess: highlightSpan.kind === "writtenReference" }, highlightSpan.isInString && { isInString: true }), highlightSpan.contextSpan && { contextSpan: highlightSpan.contextSpan });
            });
          });
        }
        function getDocumentHighlights(fileName2, position, filesToSearch) {
          var normalizedFileName = ts3.normalizePath(fileName2);
          ts3.Debug.assert(filesToSearch.some(function(f) {
            return ts3.normalizePath(f) === normalizedFileName;
          }));
          synchronizeHostData();
          var sourceFilesToSearch = ts3.mapDefined(filesToSearch, function(fileName3) {
            return program2.getSourceFile(fileName3);
          });
          var sourceFile = getValidSourceFile(fileName2);
          return ts3.DocumentHighlights.getDocumentHighlights(program2, cancellationToken, sourceFile, position, sourceFilesToSearch);
        }
        function findRenameLocations(fileName2, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          var node = ts3.getAdjustedRenameLocation(ts3.getTouchingPropertyName(sourceFile, position));
          if (!ts3.Rename.nodeIsEligibleForRename(node))
            return void 0;
          if (ts3.isIdentifier(node) && (ts3.isJsxOpeningElement(node.parent) || ts3.isJsxClosingElement(node.parent)) && ts3.isIntrinsicJsxName(node.escapedText)) {
            var _a2 = node.parent.parent, openingElement = _a2.openingElement, closingElement = _a2.closingElement;
            return [openingElement, closingElement].map(function(node2) {
              var textSpan = ts3.createTextSpanFromNode(node2.tagName, sourceFile);
              return __assign({ fileName: sourceFile.fileName, textSpan }, ts3.FindAllReferences.toContextSpan(textSpan, sourceFile, node2.parent));
            });
          } else {
            return getReferencesWorker(node, position, { findInStrings, findInComments, providePrefixAndSuffixTextForRename, use: 2 }, function(entry, originalNode, checker) {
              return ts3.FindAllReferences.toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixTextForRename || false);
            });
          }
        }
        function getReferencesAtPosition(fileName2, position) {
          synchronizeHostData();
          return getReferencesWorker(ts3.getTouchingPropertyName(getValidSourceFile(fileName2), position), position, { use: 1 }, ts3.FindAllReferences.toReferenceEntry);
        }
        function getReferencesWorker(node, position, options, cb) {
          synchronizeHostData();
          var sourceFiles = options && options.use === 2 ? program2.getSourceFiles().filter(function(sourceFile) {
            return !program2.isSourceFileDefaultLibrary(sourceFile);
          }) : program2.getSourceFiles();
          return ts3.FindAllReferences.findReferenceOrRenameEntries(program2, cancellationToken, sourceFiles, node, position, options, cb);
        }
        function findReferences(fileName2, position) {
          synchronizeHostData();
          return ts3.FindAllReferences.findReferencedSymbols(program2, cancellationToken, program2.getSourceFiles(), getValidSourceFile(fileName2), position);
        }
        function getFileReferences(fileName2) {
          synchronizeHostData();
          return ts3.FindAllReferences.Core.getReferencesForFileName(fileName2, program2, program2.getSourceFiles()).map(ts3.FindAllReferences.toReferenceEntry);
        }
        function getNavigateToItems(searchValue, maxResultCount, fileName2, excludeDtsFiles) {
          if (excludeDtsFiles === void 0) {
            excludeDtsFiles = false;
          }
          synchronizeHostData();
          var sourceFiles = fileName2 ? [getValidSourceFile(fileName2)] : program2.getSourceFiles();
          return ts3.NavigateTo.getNavigateToItems(sourceFiles, program2.getTypeChecker(), cancellationToken, searchValue, maxResultCount, excludeDtsFiles);
        }
        function getEmitOutput(fileName2, emitOnlyDtsFiles, forceDtsEmit) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          var customTransformers = host.getCustomTransformers && host.getCustomTransformers();
          return ts3.getFileEmitOutput(program2, sourceFile, !!emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit);
        }
        function getSignatureHelpItems(fileName2, position, _a2) {
          var _b2 = _a2 === void 0 ? ts3.emptyOptions : _a2, triggerReason = _b2.triggerReason;
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          return ts3.SignatureHelp.getSignatureHelpItems(program2, sourceFile, position, triggerReason, cancellationToken);
        }
        function getNonBoundSourceFile(fileName2) {
          return syntaxTreeCache.getCurrentSourceFile(fileName2);
        }
        function getNameOrDottedNameSpan(fileName2, startPos, _endPos) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var node = ts3.getTouchingPropertyName(sourceFile, startPos);
          if (node === sourceFile) {
            return void 0;
          }
          switch (node.kind) {
            case 206:
            case 161:
            case 10:
            case 95:
            case 110:
            case 104:
            case 106:
            case 108:
            case 192:
            case 79:
              break;
            default:
              return void 0;
          }
          var nodeForStartPos = node;
          while (true) {
            if (ts3.isRightSideOfPropertyAccess(nodeForStartPos) || ts3.isRightSideOfQualifiedName(nodeForStartPos)) {
              nodeForStartPos = nodeForStartPos.parent;
            } else if (ts3.isNameOfModuleDeclaration(nodeForStartPos)) {
              if (nodeForStartPos.parent.parent.kind === 261 && nodeForStartPos.parent.parent.body === nodeForStartPos.parent) {
                nodeForStartPos = nodeForStartPos.parent.parent.name;
              } else {
                break;
              }
            } else {
              break;
            }
          }
          return ts3.createTextSpanFromBounds(nodeForStartPos.getStart(), node.getEnd());
        }
        function getBreakpointStatementAtPosition(fileName2, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          return ts3.BreakpointResolver.spanInSourceFileAtLocation(sourceFile, position);
        }
        function getNavigationBarItems(fileName2) {
          return ts3.NavigationBar.getNavigationBarItems(syntaxTreeCache.getCurrentSourceFile(fileName2), cancellationToken);
        }
        function getNavigationTree(fileName2) {
          return ts3.NavigationBar.getNavigationTree(syntaxTreeCache.getCurrentSourceFile(fileName2), cancellationToken);
        }
        function getSemanticClassifications(fileName2, span, format) {
          synchronizeHostData();
          var responseFormat = format || "original";
          if (responseFormat === "2020") {
            return ts3.classifier.v2020.getSemanticClassifications(program2, cancellationToken, getValidSourceFile(fileName2), span);
          } else {
            return ts3.getSemanticClassifications(program2.getTypeChecker(), cancellationToken, getValidSourceFile(fileName2), program2.getClassifiableNames(), span);
          }
        }
        function getEncodedSemanticClassifications(fileName2, span, format) {
          synchronizeHostData();
          var responseFormat = format || "original";
          if (responseFormat === "original") {
            return ts3.getEncodedSemanticClassifications(program2.getTypeChecker(), cancellationToken, getValidSourceFile(fileName2), program2.getClassifiableNames(), span);
          } else {
            return ts3.classifier.v2020.getEncodedSemanticClassifications(program2, cancellationToken, getValidSourceFile(fileName2), span);
          }
        }
        function getSyntacticClassifications(fileName2, span) {
          return ts3.getSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName2), span);
        }
        function getEncodedSyntacticClassifications(fileName2, span) {
          return ts3.getEncodedSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName2), span);
        }
        function getOutliningSpans(fileName2) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          return ts3.OutliningElementsCollector.collectElements(sourceFile, cancellationToken);
        }
        var braceMatching = new ts3.Map(ts3.getEntries((_a = {}, _a[18] = 19, _a[20] = 21, _a[22] = 23, _a[31] = 29, _a)));
        braceMatching.forEach(function(value, key) {
          return braceMatching.set(value.toString(), Number(key));
        });
        function getBraceMatchingAtPosition(fileName2, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var token = ts3.getTouchingToken(sourceFile, position);
          var matchKind = token.getStart(sourceFile) === position ? braceMatching.get(token.kind.toString()) : void 0;
          var match = matchKind && ts3.findChildOfKind(token.parent, matchKind, sourceFile);
          return match ? [ts3.createTextSpanFromNode(token, sourceFile), ts3.createTextSpanFromNode(match, sourceFile)].sort(function(a, b) {
            return a.start - b.start;
          }) : ts3.emptyArray;
        }
        function getIndentationAtPosition(fileName2, position, editorOptions) {
          var start = ts3.timestamp();
          var settings = toEditorSettings(editorOptions);
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          log("getIndentationAtPosition: getCurrentSourceFile: " + (ts3.timestamp() - start));
          start = ts3.timestamp();
          var result2 = ts3.formatting.SmartIndenter.getIndentation(position, sourceFile, settings);
          log("getIndentationAtPosition: computeIndentation  : " + (ts3.timestamp() - start));
          return result2;
        }
        function getFormattingEditsForRange(fileName2, start, end, options) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          return ts3.formatting.formatSelection(start, end, sourceFile, ts3.formatting.getFormatContext(toEditorSettings(options), host));
        }
        function getFormattingEditsForDocument(fileName2, options) {
          return ts3.formatting.formatDocument(syntaxTreeCache.getCurrentSourceFile(fileName2), ts3.formatting.getFormatContext(toEditorSettings(options), host));
        }
        function getFormattingEditsAfterKeystroke(fileName2, position, key, options) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var formatContext = ts3.formatting.getFormatContext(toEditorSettings(options), host);
          if (!ts3.isInComment(sourceFile, position)) {
            switch (key) {
              case "{":
                return ts3.formatting.formatOnOpeningCurly(position, sourceFile, formatContext);
              case "}":
                return ts3.formatting.formatOnClosingCurly(position, sourceFile, formatContext);
              case ";":
                return ts3.formatting.formatOnSemicolon(position, sourceFile, formatContext);
              case "\n":
                return ts3.formatting.formatOnEnter(position, sourceFile, formatContext);
            }
          }
          return [];
        }
        function getCodeFixesAtPosition(fileName2, start, end, errorCodes, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          var span = ts3.createTextSpanFromBounds(start, end);
          var formatContext = ts3.formatting.getFormatContext(formatOptions, host);
          return ts3.flatMap(ts3.deduplicate(errorCodes, ts3.equateValues, ts3.compareValues), function(errorCode) {
            cancellationToken.throwIfCancellationRequested();
            return ts3.codefix.getFixes({ errorCode, sourceFile, span, program: program2, host, cancellationToken, formatContext, preferences });
          });
        }
        function getCombinedCodeFix(scope, fixId, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          ts3.Debug.assert(scope.type === "file");
          var sourceFile = getValidSourceFile(scope.fileName);
          var formatContext = ts3.formatting.getFormatContext(formatOptions, host);
          return ts3.codefix.getAllFixes({ fixId, sourceFile, program: program2, host, cancellationToken, formatContext, preferences });
        }
        function organizeImports(args, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          ts3.Debug.assert(args.type === "file");
          var sourceFile = getValidSourceFile(args.fileName);
          var formatContext = ts3.formatting.getFormatContext(formatOptions, host);
          return ts3.OrganizeImports.organizeImports(sourceFile, formatContext, host, program2, preferences, args.skipDestructiveCodeActions);
        }
        function getEditsForFileRename(oldFilePath, newFilePath, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          return ts3.getEditsForFileRename(getProgram(), oldFilePath, newFilePath, host, ts3.formatting.getFormatContext(formatOptions, host), preferences, sourceMapper);
        }
        function applyCodeActionCommand(fileName2, actionOrFormatSettingsOrUndefined) {
          var action = typeof fileName2 === "string" ? actionOrFormatSettingsOrUndefined : fileName2;
          return ts3.isArray(action) ? Promise.all(action.map(function(a) {
            return applySingleCodeActionCommand(a);
          })) : applySingleCodeActionCommand(action);
        }
        function applySingleCodeActionCommand(action) {
          var getPath = function(path2) {
            return ts3.toPath(path2, currentDirectory, getCanonicalFileName);
          };
          ts3.Debug.assertEqual(action.type, "install package");
          return host.installPackage ? host.installPackage({ fileName: getPath(action.file), packageName: action.packageName }) : Promise.reject("Host does not implement `installPackage`");
        }
        function getDocCommentTemplateAtPosition(fileName2, position, options) {
          return ts3.JsDoc.getDocCommentTemplateAtPosition(ts3.getNewLineOrDefaultFromHost(host), syntaxTreeCache.getCurrentSourceFile(fileName2), position, options);
        }
        function isValidBraceCompletionAtPosition(fileName2, position, openingBrace) {
          if (openingBrace === 60) {
            return false;
          }
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          if (ts3.isInString(sourceFile, position)) {
            return false;
          }
          if (ts3.isInsideJsxElementOrAttribute(sourceFile, position)) {
            return openingBrace === 123;
          }
          if (ts3.isInTemplateString(sourceFile, position)) {
            return false;
          }
          switch (openingBrace) {
            case 39:
            case 34:
            case 96:
              return !ts3.isInComment(sourceFile, position);
          }
          return true;
        }
        function getJsxClosingTagAtPosition(fileName2, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var token = ts3.findPrecedingToken(position, sourceFile);
          if (!token)
            return void 0;
          var element = token.kind === 31 && ts3.isJsxOpeningElement(token.parent) ? token.parent.parent : ts3.isJsxText(token) && ts3.isJsxElement(token.parent) ? token.parent : void 0;
          if (element && isUnclosedTag(element)) {
            return { newText: "</".concat(element.openingElement.tagName.getText(sourceFile), ">") };
          }
          var fragment = token.kind === 31 && ts3.isJsxOpeningFragment(token.parent) ? token.parent.parent : ts3.isJsxText(token) && ts3.isJsxFragment(token.parent) ? token.parent : void 0;
          if (fragment && isUnclosedFragment(fragment)) {
            return { newText: "</>" };
          }
        }
        function getLinesForRange(sourceFile, textRange) {
          return {
            lineStarts: sourceFile.getLineStarts(),
            firstLine: sourceFile.getLineAndCharacterOfPosition(textRange.pos).line,
            lastLine: sourceFile.getLineAndCharacterOfPosition(textRange.end).line
          };
        }
        function toggleLineComment(fileName2, textRange, insertComment) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var textChanges = [];
          var _a2 = getLinesForRange(sourceFile, textRange), lineStarts = _a2.lineStarts, firstLine = _a2.firstLine, lastLine = _a2.lastLine;
          var isCommenting = insertComment || false;
          var leftMostPosition = Number.MAX_VALUE;
          var lineTextStarts = new ts3.Map();
          var firstNonWhitespaceCharacterRegex = new RegExp(/\S/);
          var isJsx = ts3.isInsideJsxElement(sourceFile, lineStarts[firstLine]);
          var openComment = isJsx ? "{/*" : "//";
          for (var i = firstLine; i <= lastLine; i++) {
            var lineText = sourceFile.text.substring(lineStarts[i], sourceFile.getLineEndOfPosition(lineStarts[i]));
            var regExec = firstNonWhitespaceCharacterRegex.exec(lineText);
            if (regExec) {
              leftMostPosition = Math.min(leftMostPosition, regExec.index);
              lineTextStarts.set(i.toString(), regExec.index);
              if (lineText.substr(regExec.index, openComment.length) !== openComment) {
                isCommenting = insertComment === void 0 || insertComment;
              }
            }
          }
          for (var i = firstLine; i <= lastLine; i++) {
            if (firstLine !== lastLine && lineStarts[i] === textRange.end) {
              continue;
            }
            var lineTextStart = lineTextStarts.get(i.toString());
            if (lineTextStart !== void 0) {
              if (isJsx) {
                textChanges.push.apply(textChanges, toggleMultilineComment(fileName2, { pos: lineStarts[i] + leftMostPosition, end: sourceFile.getLineEndOfPosition(lineStarts[i]) }, isCommenting, isJsx));
              } else if (isCommenting) {
                textChanges.push({
                  newText: openComment,
                  span: {
                    length: 0,
                    start: lineStarts[i] + leftMostPosition
                  }
                });
              } else if (sourceFile.text.substr(lineStarts[i] + lineTextStart, openComment.length) === openComment) {
                textChanges.push({
                  newText: "",
                  span: {
                    length: openComment.length,
                    start: lineStarts[i] + lineTextStart
                  }
                });
              }
            }
          }
          return textChanges;
        }
        function toggleMultilineComment(fileName2, textRange, insertComment, isInsideJsx) {
          var _a2;
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var textChanges = [];
          var text = sourceFile.text;
          var hasComment = false;
          var isCommenting = insertComment || false;
          var positions = [];
          var pos = textRange.pos;
          var isJsx = isInsideJsx !== void 0 ? isInsideJsx : ts3.isInsideJsxElement(sourceFile, pos);
          var openMultiline = isJsx ? "{/*" : "/*";
          var closeMultiline = isJsx ? "*/}" : "*/";
          var openMultilineRegex = isJsx ? "\\{\\/\\*" : "\\/\\*";
          var closeMultilineRegex = isJsx ? "\\*\\/\\}" : "\\*\\/";
          while (pos <= textRange.end) {
            var offset = text.substr(pos, openMultiline.length) === openMultiline ? openMultiline.length : 0;
            var commentRange = ts3.isInComment(sourceFile, pos + offset);
            if (commentRange) {
              if (isJsx) {
                commentRange.pos--;
                commentRange.end++;
              }
              positions.push(commentRange.pos);
              if (commentRange.kind === 3) {
                positions.push(commentRange.end);
              }
              hasComment = true;
              pos = commentRange.end + 1;
            } else {
              var newPos = text.substring(pos, textRange.end).search("(".concat(openMultilineRegex, ")|(").concat(closeMultilineRegex, ")"));
              isCommenting = insertComment !== void 0 ? insertComment : isCommenting || !ts3.isTextWhiteSpaceLike(text, pos, newPos === -1 ? textRange.end : pos + newPos);
              pos = newPos === -1 ? textRange.end + 1 : pos + newPos + closeMultiline.length;
            }
          }
          if (isCommenting || !hasComment) {
            if (((_a2 = ts3.isInComment(sourceFile, textRange.pos)) === null || _a2 === void 0 ? void 0 : _a2.kind) !== 2) {
              ts3.insertSorted(positions, textRange.pos, ts3.compareValues);
            }
            ts3.insertSorted(positions, textRange.end, ts3.compareValues);
            var firstPos = positions[0];
            if (text.substr(firstPos, openMultiline.length) !== openMultiline) {
              textChanges.push({
                newText: openMultiline,
                span: {
                  length: 0,
                  start: firstPos
                }
              });
            }
            for (var i = 1; i < positions.length - 1; i++) {
              if (text.substr(positions[i] - closeMultiline.length, closeMultiline.length) !== closeMultiline) {
                textChanges.push({
                  newText: closeMultiline,
                  span: {
                    length: 0,
                    start: positions[i]
                  }
                });
              }
              if (text.substr(positions[i], openMultiline.length) !== openMultiline) {
                textChanges.push({
                  newText: openMultiline,
                  span: {
                    length: 0,
                    start: positions[i]
                  }
                });
              }
            }
            if (textChanges.length % 2 !== 0) {
              textChanges.push({
                newText: closeMultiline,
                span: {
                  length: 0,
                  start: positions[positions.length - 1]
                }
              });
            }
          } else {
            for (var _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
              var pos_2 = positions_1[_i];
              var from = pos_2 - closeMultiline.length > 0 ? pos_2 - closeMultiline.length : 0;
              var offset = text.substr(from, closeMultiline.length) === closeMultiline ? closeMultiline.length : 0;
              textChanges.push({
                newText: "",
                span: {
                  length: openMultiline.length,
                  start: pos_2 - offset
                }
              });
            }
          }
          return textChanges;
        }
        function commentSelection(fileName2, textRange) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var _a2 = getLinesForRange(sourceFile, textRange), firstLine = _a2.firstLine, lastLine = _a2.lastLine;
          return firstLine === lastLine && textRange.pos !== textRange.end ? toggleMultilineComment(fileName2, textRange, true) : toggleLineComment(fileName2, textRange, true);
        }
        function uncommentSelection(fileName2, textRange) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var textChanges = [];
          var pos = textRange.pos;
          var end = textRange.end;
          if (pos === end) {
            end += ts3.isInsideJsxElement(sourceFile, pos) ? 2 : 1;
          }
          for (var i = pos; i <= end; i++) {
            var commentRange = ts3.isInComment(sourceFile, i);
            if (commentRange) {
              switch (commentRange.kind) {
                case 2:
                  textChanges.push.apply(textChanges, toggleLineComment(fileName2, { end: commentRange.end, pos: commentRange.pos + 1 }, false));
                  break;
                case 3:
                  textChanges.push.apply(textChanges, toggleMultilineComment(fileName2, { end: commentRange.end, pos: commentRange.pos + 1 }, false));
              }
              i = commentRange.end + 1;
            }
          }
          return textChanges;
        }
        function isUnclosedTag(_a2) {
          var openingElement = _a2.openingElement, closingElement = _a2.closingElement, parent = _a2.parent;
          return !ts3.tagNamesAreEquivalent(openingElement.tagName, closingElement.tagName) || ts3.isJsxElement(parent) && ts3.tagNamesAreEquivalent(openingElement.tagName, parent.openingElement.tagName) && isUnclosedTag(parent);
        }
        function isUnclosedFragment(_a2) {
          var closingFragment = _a2.closingFragment, parent = _a2.parent;
          return !!(closingFragment.flags & 131072) || ts3.isJsxFragment(parent) && isUnclosedFragment(parent);
        }
        function getSpanOfEnclosingComment(fileName2, position, onlyMultiLine) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName2);
          var range = ts3.formatting.getRangeOfEnclosingComment(sourceFile, position);
          return range && (!onlyMultiLine || range.kind === 3) ? ts3.createTextSpanFromRange(range) : void 0;
        }
        function getTodoComments(fileName2, descriptors) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          cancellationToken.throwIfCancellationRequested();
          var fileContents = sourceFile.text;
          var result2 = [];
          if (descriptors.length > 0 && !isNodeModulesFile(sourceFile.fileName)) {
            var regExp = getTodoCommentsRegExp();
            var matchArray = void 0;
            while (matchArray = regExp.exec(fileContents)) {
              cancellationToken.throwIfCancellationRequested();
              var firstDescriptorCaptureIndex = 3;
              ts3.Debug.assert(matchArray.length === descriptors.length + firstDescriptorCaptureIndex);
              var preamble = matchArray[1];
              var matchPosition = matchArray.index + preamble.length;
              if (!ts3.isInComment(sourceFile, matchPosition)) {
                continue;
              }
              var descriptor = void 0;
              for (var i = 0; i < descriptors.length; i++) {
                if (matchArray[i + firstDescriptorCaptureIndex]) {
                  descriptor = descriptors[i];
                }
              }
              if (descriptor === void 0)
                return ts3.Debug.fail();
              if (isLetterOrDigit(fileContents.charCodeAt(matchPosition + descriptor.text.length))) {
                continue;
              }
              var message = matchArray[2];
              result2.push({ descriptor, message, position: matchPosition });
            }
          }
          return result2;
          function escapeRegExp(str2) {
            return str2.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
          }
          function getTodoCommentsRegExp() {
            var singleLineCommentStart = /(?:\/\/+\s*)/.source;
            var multiLineCommentStart = /(?:\/\*+\s*)/.source;
            var anyNumberOfSpacesAndAsterisksAtStartOfLine = /(?:^(?:\s|\*)*)/.source;
            var preamble2 = "(" + anyNumberOfSpacesAndAsterisksAtStartOfLine + "|" + singleLineCommentStart + "|" + multiLineCommentStart + ")";
            var literals = "(?:" + ts3.map(descriptors, function(d) {
              return "(" + escapeRegExp(d.text) + ")";
            }).join("|") + ")";
            var endOfLineOrEndOfComment = /(?:$|\*\/)/.source;
            var messageRemainder = /(?:.*?)/.source;
            var messagePortion = "(" + literals + messageRemainder + ")";
            var regExpString = preamble2 + messagePortion + endOfLineOrEndOfComment;
            return new RegExp(regExpString, "gim");
          }
          function isLetterOrDigit(char) {
            return char >= 97 && char <= 122 || char >= 65 && char <= 90 || char >= 48 && char <= 57;
          }
          function isNodeModulesFile(path2) {
            return ts3.stringContains(path2, "/node_modules/");
          }
        }
        function getRenameInfo(fileName2, position, options) {
          synchronizeHostData();
          return ts3.Rename.getRenameInfo(program2, getValidSourceFile(fileName2), position, options);
        }
        function getRefactorContext(file, positionOrRange, preferences, formatOptions, triggerReason, kind) {
          var _a2 = typeof positionOrRange === "number" ? [positionOrRange, void 0] : [positionOrRange.pos, positionOrRange.end], startPosition = _a2[0], endPosition = _a2[1];
          return {
            file,
            startPosition,
            endPosition,
            program: getProgram(),
            host,
            formatContext: ts3.formatting.getFormatContext(formatOptions, host),
            cancellationToken,
            preferences,
            triggerReason,
            kind
          };
        }
        function getInlayHintsContext(file, span, preferences) {
          return {
            file,
            program: getProgram(),
            host,
            span,
            preferences,
            cancellationToken
          };
        }
        function getSmartSelectionRange(fileName2, position) {
          return ts3.SmartSelectionRange.getSmartSelectionRange(position, syntaxTreeCache.getCurrentSourceFile(fileName2));
        }
        function getApplicableRefactors(fileName2, positionOrRange, preferences, triggerReason, kind) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var file = getValidSourceFile(fileName2);
          return ts3.refactor.getApplicableRefactors(getRefactorContext(file, positionOrRange, preferences, ts3.emptyOptions, triggerReason, kind));
        }
        function getEditsForRefactor(fileName2, formatOptions, positionOrRange, refactorName, actionName, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var file = getValidSourceFile(fileName2);
          return ts3.refactor.getEditsForRefactor(getRefactorContext(file, positionOrRange, preferences, formatOptions), refactorName, actionName);
        }
        function toLineColumnOffset(fileName2, position) {
          if (position === 0) {
            return { line: 0, character: 0 };
          }
          return sourceMapper.toLineColumnOffset(fileName2, position);
        }
        function prepareCallHierarchy(fileName2, position) {
          synchronizeHostData();
          var declarations = ts3.CallHierarchy.resolveCallHierarchyDeclaration(program2, ts3.getTouchingPropertyName(getValidSourceFile(fileName2), position));
          return declarations && ts3.mapOneOrMany(declarations, function(declaration) {
            return ts3.CallHierarchy.createCallHierarchyItem(program2, declaration);
          });
        }
        function provideCallHierarchyIncomingCalls(fileName2, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          var declaration = ts3.firstOrOnly(ts3.CallHierarchy.resolveCallHierarchyDeclaration(program2, position === 0 ? sourceFile : ts3.getTouchingPropertyName(sourceFile, position)));
          return declaration ? ts3.CallHierarchy.getIncomingCalls(program2, declaration, cancellationToken) : [];
        }
        function provideCallHierarchyOutgoingCalls(fileName2, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          var declaration = ts3.firstOrOnly(ts3.CallHierarchy.resolveCallHierarchyDeclaration(program2, position === 0 ? sourceFile : ts3.getTouchingPropertyName(sourceFile, position)));
          return declaration ? ts3.CallHierarchy.getOutgoingCalls(program2, declaration) : [];
        }
        function provideInlayHints(fileName2, span, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName2);
          return ts3.InlayHints.provideInlayHints(getInlayHintsContext(sourceFile, span, preferences));
        }
        var ls = {
          dispose,
          cleanupSemanticCache,
          getSyntacticDiagnostics,
          getSemanticDiagnostics,
          getSuggestionDiagnostics,
          getCompilerOptionsDiagnostics,
          getSyntacticClassifications,
          getSemanticClassifications,
          getEncodedSyntacticClassifications,
          getEncodedSemanticClassifications,
          getCompletionsAtPosition,
          getCompletionEntryDetails,
          getCompletionEntrySymbol,
          getSignatureHelpItems,
          getQuickInfoAtPosition,
          getDefinitionAtPosition,
          getDefinitionAndBoundSpan,
          getImplementationAtPosition,
          getTypeDefinitionAtPosition,
          getReferencesAtPosition,
          findReferences,
          getFileReferences,
          getOccurrencesAtPosition,
          getDocumentHighlights,
          getNameOrDottedNameSpan,
          getBreakpointStatementAtPosition,
          getNavigateToItems,
          getRenameInfo,
          getSmartSelectionRange,
          findRenameLocations,
          getNavigationBarItems,
          getNavigationTree,
          getOutliningSpans,
          getTodoComments,
          getBraceMatchingAtPosition,
          getIndentationAtPosition,
          getFormattingEditsForRange,
          getFormattingEditsForDocument,
          getFormattingEditsAfterKeystroke,
          getDocCommentTemplateAtPosition,
          isValidBraceCompletionAtPosition,
          getJsxClosingTagAtPosition,
          getSpanOfEnclosingComment,
          getCodeFixesAtPosition,
          getCombinedCodeFix,
          applyCodeActionCommand,
          organizeImports,
          getEditsForFileRename,
          getEmitOutput,
          getNonBoundSourceFile,
          getProgram,
          getAutoImportProvider,
          getApplicableRefactors,
          getEditsForRefactor,
          toLineColumnOffset,
          getSourceMapper: function() {
            return sourceMapper;
          },
          clearSourceMapperCache: function() {
            return sourceMapper.clearCache();
          },
          prepareCallHierarchy,
          provideCallHierarchyIncomingCalls,
          provideCallHierarchyOutgoingCalls,
          toggleLineComment,
          toggleMultilineComment,
          commentSelection,
          uncommentSelection,
          provideInlayHints
        };
        switch (languageServiceMode) {
          case ts3.LanguageServiceMode.Semantic:
            break;
          case ts3.LanguageServiceMode.PartialSemantic:
            invalidOperationsInPartialSemanticMode.forEach(function(key) {
              return ls[key] = function() {
                throw new Error("LanguageService Operation: ".concat(key, " not allowed in LanguageServiceMode.PartialSemantic"));
              };
            });
            break;
          case ts3.LanguageServiceMode.Syntactic:
            invalidOperationsInSyntacticMode.forEach(function(key) {
              return ls[key] = function() {
                throw new Error("LanguageService Operation: ".concat(key, " not allowed in LanguageServiceMode.Syntactic"));
              };
            });
            break;
          default:
            ts3.Debug.assertNever(languageServiceMode);
        }
        return ls;
      }
      ts3.createLanguageService = createLanguageService;
      function getNameTable(sourceFile) {
        if (!sourceFile.nameTable) {
          initializeNameTable(sourceFile);
        }
        return sourceFile.nameTable;
      }
      ts3.getNameTable = getNameTable;
      function initializeNameTable(sourceFile) {
        var nameTable = sourceFile.nameTable = new ts3.Map();
        sourceFile.forEachChild(function walk(node) {
          if (ts3.isIdentifier(node) && !ts3.isTagName(node) && node.escapedText || ts3.isStringOrNumericLiteralLike(node) && literalIsName(node)) {
            var text = ts3.getEscapedTextOfIdentifierOrLiteral(node);
            nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
          } else if (ts3.isPrivateIdentifier(node)) {
            var text = node.escapedText;
            nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
          }
          ts3.forEachChild(node, walk);
          if (ts3.hasJSDocNodes(node)) {
            for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
              var jsDoc = _a[_i];
              ts3.forEachChild(jsDoc, walk);
            }
          }
        });
      }
      function literalIsName(node) {
        return ts3.isDeclarationName(node) || node.parent.kind === 277 || isArgumentOfElementAccessExpression(node) || ts3.isLiteralComputedPropertyDeclarationName(node);
      }
      function getContainingObjectLiteralElement(node) {
        var element = getContainingObjectLiteralElementWorker(node);
        return element && (ts3.isObjectLiteralExpression(element.parent) || ts3.isJsxAttributes(element.parent)) ? element : void 0;
      }
      ts3.getContainingObjectLiteralElement = getContainingObjectLiteralElement;
      function getContainingObjectLiteralElementWorker(node) {
        switch (node.kind) {
          case 10:
          case 14:
          case 8:
            if (node.parent.kind === 162) {
              return ts3.isObjectLiteralElement(node.parent.parent) ? node.parent.parent : void 0;
            }
          case 79:
            return ts3.isObjectLiteralElement(node.parent) && (node.parent.parent.kind === 205 || node.parent.parent.kind === 286) && node.parent.name === node ? node.parent : void 0;
        }
        return void 0;
      }
      function getSymbolAtLocationForQuickInfo(node, checker) {
        var object2 = getContainingObjectLiteralElement(node);
        if (object2) {
          var contextualType = checker.getContextualType(object2.parent);
          var properties = contextualType && getPropertySymbolsFromContextualType(object2, checker, contextualType, false);
          if (properties && properties.length === 1) {
            return ts3.first(properties);
          }
        }
        return checker.getSymbolAtLocation(node);
      }
      function getPropertySymbolsFromContextualType(node, checker, contextualType, unionSymbolOk) {
        var name = ts3.getNameFromPropertyName(node.name);
        if (!name)
          return ts3.emptyArray;
        if (!contextualType.isUnion()) {
          var symbol = contextualType.getProperty(name);
          return symbol ? [symbol] : ts3.emptyArray;
        }
        var discriminatedPropertySymbols = ts3.mapDefined(contextualType.types, function(t) {
          return (ts3.isObjectLiteralExpression(node.parent) || ts3.isJsxAttributes(node.parent)) && checker.isTypeInvalidDueToUnionDiscriminant(t, node.parent) ? void 0 : t.getProperty(name);
        });
        if (unionSymbolOk && (discriminatedPropertySymbols.length === 0 || discriminatedPropertySymbols.length === contextualType.types.length)) {
          var symbol = contextualType.getProperty(name);
          if (symbol)
            return [symbol];
        }
        if (discriminatedPropertySymbols.length === 0) {
          return ts3.mapDefined(contextualType.types, function(t) {
            return t.getProperty(name);
          });
        }
        return discriminatedPropertySymbols;
      }
      ts3.getPropertySymbolsFromContextualType = getPropertySymbolsFromContextualType;
      function isArgumentOfElementAccessExpression(node) {
        return node && node.parent && node.parent.kind === 207 && node.parent.argumentExpression === node;
      }
      function getDefaultLibFilePath(options) {
        if (typeof __dirname !== "undefined") {
          return __dirname + ts3.directorySeparator + ts3.getDefaultLibFileName(options);
        }
        throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ");
      }
      ts3.getDefaultLibFilePath = getDefaultLibFilePath;
      ts3.setObjectAllocator(getServicesObjectAllocator());
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var BreakpointResolver;
      (function(BreakpointResolver2) {
        function spanInSourceFileAtLocation(sourceFile, position) {
          if (sourceFile.isDeclarationFile) {
            return void 0;
          }
          var tokenAtLocation = ts3.getTokenAtPosition(sourceFile, position);
          var lineOfPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
          if (sourceFile.getLineAndCharacterOfPosition(tokenAtLocation.getStart(sourceFile)).line > lineOfPosition) {
            var preceding = ts3.findPrecedingToken(tokenAtLocation.pos, sourceFile);
            if (!preceding || sourceFile.getLineAndCharacterOfPosition(preceding.getEnd()).line !== lineOfPosition) {
              return void 0;
            }
            tokenAtLocation = preceding;
          }
          if (tokenAtLocation.flags & 16777216) {
            return void 0;
          }
          return spanInNode(tokenAtLocation);
          function textSpan(startNode, endNode) {
            var start = startNode.decorators ? ts3.skipTrivia(sourceFile.text, startNode.decorators.end) : startNode.getStart(sourceFile);
            return ts3.createTextSpanFromBounds(start, (endNode || startNode).getEnd());
          }
          function textSpanEndingAtNextToken(startNode, previousTokenToFindNextEndToken) {
            return textSpan(startNode, ts3.findNextToken(previousTokenToFindNextEndToken, previousTokenToFindNextEndToken.parent, sourceFile));
          }
          function spanInNodeIfStartsOnSameLine(node, otherwiseOnNode) {
            if (node && lineOfPosition === sourceFile.getLineAndCharacterOfPosition(node.getStart(sourceFile)).line) {
              return spanInNode(node);
            }
            return spanInNode(otherwiseOnNode);
          }
          function spanInNodeArray(nodeArray) {
            return ts3.createTextSpanFromBounds(ts3.skipTrivia(sourceFile.text, nodeArray.pos), nodeArray.end);
          }
          function spanInPreviousNode(node) {
            return spanInNode(ts3.findPrecedingToken(node.pos, sourceFile));
          }
          function spanInNextNode(node) {
            return spanInNode(ts3.findNextToken(node, node.parent, sourceFile));
          }
          function spanInNode(node) {
            if (node) {
              var parent = node.parent;
              switch (node.kind) {
                case 237:
                  return spanInVariableDeclaration(node.declarationList.declarations[0]);
                case 254:
                case 167:
                case 166:
                  return spanInVariableDeclaration(node);
                case 164:
                  return spanInParameterDeclaration(node);
                case 256:
                case 169:
                case 168:
                case 172:
                case 173:
                case 171:
                case 213:
                case 214:
                  return spanInFunctionDeclaration(node);
                case 235:
                  if (ts3.isFunctionBlock(node)) {
                    return spanInFunctionBlock(node);
                  }
                case 262:
                  return spanInBlock(node);
                case 292:
                  return spanInBlock(node.block);
                case 238:
                  return textSpan(node.expression);
                case 247:
                  return textSpan(node.getChildAt(0), node.expression);
                case 241:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 240:
                  return spanInNode(node.statement);
                case 253:
                  return textSpan(node.getChildAt(0));
                case 239:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 250:
                  return spanInNode(node.statement);
                case 246:
                case 245:
                  return textSpan(node.getChildAt(0), node.label);
                case 242:
                  return spanInForStatement(node);
                case 243:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 244:
                  return spanInInitializerOfForLike(node);
                case 249:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 289:
                case 290:
                  return spanInNode(node.statements[0]);
                case 252:
                  return spanInBlock(node.tryBlock);
                case 251:
                  return textSpan(node, node.expression);
                case 271:
                  return textSpan(node, node.expression);
                case 265:
                  return textSpan(node, node.moduleReference);
                case 266:
                  return textSpan(node, node.moduleSpecifier);
                case 272:
                  return textSpan(node, node.moduleSpecifier);
                case 261:
                  if (ts3.getModuleInstanceState(node) !== 1) {
                    return void 0;
                  }
                case 257:
                case 260:
                case 299:
                case 203:
                  return textSpan(node);
                case 248:
                  return spanInNode(node.statement);
                case 165:
                  return spanInNodeArray(parent.decorators);
                case 201:
                case 202:
                  return spanInBindingPattern(node);
                case 258:
                case 259:
                  return void 0;
                case 26:
                case 1:
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(node.pos, sourceFile));
                case 27:
                  return spanInPreviousNode(node);
                case 18:
                  return spanInOpenBraceToken(node);
                case 19:
                  return spanInCloseBraceToken(node);
                case 23:
                  return spanInCloseBracketToken(node);
                case 20:
                  return spanInOpenParenToken(node);
                case 21:
                  return spanInCloseParenToken(node);
                case 58:
                  return spanInColonToken(node);
                case 31:
                case 29:
                  return spanInGreaterThanOrLessThanToken(node);
                case 115:
                  return spanInWhileKeyword(node);
                case 91:
                case 83:
                case 96:
                  return spanInNextNode(node);
                case 160:
                  return spanInOfKeyword(node);
                default:
                  if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node)) {
                    return spanInArrayLiteralOrObjectLiteralDestructuringPattern(node);
                  }
                  if ((node.kind === 79 || node.kind === 225 || node.kind === 296 || node.kind === 297) && ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(parent)) {
                    return textSpan(node);
                  }
                  if (node.kind === 221) {
                    var _a = node, left = _a.left, operatorToken = _a.operatorToken;
                    if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(left)) {
                      return spanInArrayLiteralOrObjectLiteralDestructuringPattern(left);
                    }
                    if (operatorToken.kind === 63 && ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent)) {
                      return textSpan(node);
                    }
                    if (operatorToken.kind === 27) {
                      return spanInNode(left);
                    }
                  }
                  if (ts3.isExpressionNode(node)) {
                    switch (parent.kind) {
                      case 240:
                        return spanInPreviousNode(node);
                      case 165:
                        return spanInNode(node.parent);
                      case 242:
                      case 244:
                        return textSpan(node);
                      case 221:
                        if (node.parent.operatorToken.kind === 27) {
                          return textSpan(node);
                        }
                        break;
                      case 214:
                        if (node.parent.body === node) {
                          return textSpan(node);
                        }
                        break;
                    }
                  }
                  switch (node.parent.kind) {
                    case 296:
                      if (node.parent.name === node && !ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.parent)) {
                        return spanInNode(node.parent.initializer);
                      }
                      break;
                    case 211:
                      if (node.parent.type === node) {
                        return spanInNextNode(node.parent.type);
                      }
                      break;
                    case 254:
                    case 164: {
                      var _b = node.parent, initializer = _b.initializer, type2 = _b.type;
                      if (initializer === node || type2 === node || ts3.isAssignmentOperator(node.kind)) {
                        return spanInPreviousNode(node);
                      }
                      break;
                    }
                    case 221: {
                      var left = node.parent.left;
                      if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(left) && node !== left) {
                        return spanInPreviousNode(node);
                      }
                      break;
                    }
                    default:
                      if (ts3.isFunctionLike(node.parent) && node.parent.type === node) {
                        return spanInPreviousNode(node);
                      }
                  }
                  return spanInNode(node.parent);
              }
            }
            function textSpanFromVariableDeclaration(variableDeclaration) {
              if (ts3.isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] === variableDeclaration) {
                return textSpan(ts3.findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent), variableDeclaration);
              } else {
                return textSpan(variableDeclaration);
              }
            }
            function spanInVariableDeclaration(variableDeclaration) {
              if (variableDeclaration.parent.parent.kind === 243) {
                return spanInNode(variableDeclaration.parent.parent);
              }
              var parent2 = variableDeclaration.parent;
              if (ts3.isBindingPattern(variableDeclaration.name)) {
                return spanInBindingPattern(variableDeclaration.name);
              }
              if (variableDeclaration.initializer || ts3.hasSyntacticModifier(variableDeclaration, 1) || parent2.parent.kind === 244) {
                return textSpanFromVariableDeclaration(variableDeclaration);
              }
              if (ts3.isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] !== variableDeclaration) {
                return spanInNode(ts3.findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent));
              }
            }
            function canHaveSpanInParameterDeclaration(parameter) {
              return !!parameter.initializer || parameter.dotDotDotToken !== void 0 || ts3.hasSyntacticModifier(parameter, 4 | 8);
            }
            function spanInParameterDeclaration(parameter) {
              if (ts3.isBindingPattern(parameter.name)) {
                return spanInBindingPattern(parameter.name);
              } else if (canHaveSpanInParameterDeclaration(parameter)) {
                return textSpan(parameter);
              } else {
                var functionDeclaration = parameter.parent;
                var indexOfParameter = functionDeclaration.parameters.indexOf(parameter);
                ts3.Debug.assert(indexOfParameter !== -1);
                if (indexOfParameter !== 0) {
                  return spanInParameterDeclaration(functionDeclaration.parameters[indexOfParameter - 1]);
                } else {
                  return spanInNode(functionDeclaration.body);
                }
              }
            }
            function canFunctionHaveSpanInWholeDeclaration(functionDeclaration) {
              return ts3.hasSyntacticModifier(functionDeclaration, 1) || functionDeclaration.parent.kind === 257 && functionDeclaration.kind !== 171;
            }
            function spanInFunctionDeclaration(functionDeclaration) {
              if (!functionDeclaration.body) {
                return void 0;
              }
              if (canFunctionHaveSpanInWholeDeclaration(functionDeclaration)) {
                return textSpan(functionDeclaration);
              }
              return spanInNode(functionDeclaration.body);
            }
            function spanInFunctionBlock(block) {
              var nodeForSpanInBlock = block.statements.length ? block.statements[0] : block.getLastToken();
              if (canFunctionHaveSpanInWholeDeclaration(block.parent)) {
                return spanInNodeIfStartsOnSameLine(block.parent, nodeForSpanInBlock);
              }
              return spanInNode(nodeForSpanInBlock);
            }
            function spanInBlock(block) {
              switch (block.parent.kind) {
                case 261:
                  if (ts3.getModuleInstanceState(block.parent) !== 1) {
                    return void 0;
                  }
                case 241:
                case 239:
                case 243:
                  return spanInNodeIfStartsOnSameLine(block.parent, block.statements[0]);
                case 242:
                case 244:
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(block.pos, sourceFile, block.parent), block.statements[0]);
              }
              return spanInNode(block.statements[0]);
            }
            function spanInInitializerOfForLike(forLikeStatement) {
              if (forLikeStatement.initializer.kind === 255) {
                var variableDeclarationList = forLikeStatement.initializer;
                if (variableDeclarationList.declarations.length > 0) {
                  return spanInNode(variableDeclarationList.declarations[0]);
                }
              } else {
                return spanInNode(forLikeStatement.initializer);
              }
            }
            function spanInForStatement(forStatement) {
              if (forStatement.initializer) {
                return spanInInitializerOfForLike(forStatement);
              }
              if (forStatement.condition) {
                return textSpan(forStatement.condition);
              }
              if (forStatement.incrementor) {
                return textSpan(forStatement.incrementor);
              }
            }
            function spanInBindingPattern(bindingPattern) {
              var firstBindingElement = ts3.forEach(bindingPattern.elements, function(element) {
                return element.kind !== 227 ? element : void 0;
              });
              if (firstBindingElement) {
                return spanInNode(firstBindingElement);
              }
              if (bindingPattern.parent.kind === 203) {
                return textSpan(bindingPattern.parent);
              }
              return textSpanFromVariableDeclaration(bindingPattern.parent);
            }
            function spanInArrayLiteralOrObjectLiteralDestructuringPattern(node2) {
              ts3.Debug.assert(node2.kind !== 202 && node2.kind !== 201);
              var elements = node2.kind === 204 ? node2.elements : node2.properties;
              var firstBindingElement = ts3.forEach(elements, function(element) {
                return element.kind !== 227 ? element : void 0;
              });
              if (firstBindingElement) {
                return spanInNode(firstBindingElement);
              }
              return textSpan(node2.parent.kind === 221 ? node2.parent : node2);
            }
            function spanInOpenBraceToken(node2) {
              switch (node2.parent.kind) {
                case 260:
                  var enumDeclaration = node2.parent;
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(node2.pos, sourceFile, node2.parent), enumDeclaration.members.length ? enumDeclaration.members[0] : enumDeclaration.getLastToken(sourceFile));
                case 257:
                  var classDeclaration = node2.parent;
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(node2.pos, sourceFile, node2.parent), classDeclaration.members.length ? classDeclaration.members[0] : classDeclaration.getLastToken(sourceFile));
                case 263:
                  return spanInNodeIfStartsOnSameLine(node2.parent.parent, node2.parent.clauses[0]);
              }
              return spanInNode(node2.parent);
            }
            function spanInCloseBraceToken(node2) {
              switch (node2.parent.kind) {
                case 262:
                  if (ts3.getModuleInstanceState(node2.parent.parent) !== 1) {
                    return void 0;
                  }
                case 260:
                case 257:
                  return textSpan(node2);
                case 235:
                  if (ts3.isFunctionBlock(node2.parent)) {
                    return textSpan(node2);
                  }
                case 292:
                  return spanInNode(ts3.lastOrUndefined(node2.parent.statements));
                case 263:
                  var caseBlock = node2.parent;
                  var lastClause = ts3.lastOrUndefined(caseBlock.clauses);
                  if (lastClause) {
                    return spanInNode(ts3.lastOrUndefined(lastClause.statements));
                  }
                  return void 0;
                case 201:
                  var bindingPattern = node2.parent;
                  return spanInNode(ts3.lastOrUndefined(bindingPattern.elements) || bindingPattern);
                default:
                  if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
                    var objectLiteral = node2.parent;
                    return textSpan(ts3.lastOrUndefined(objectLiteral.properties) || objectLiteral);
                  }
                  return spanInNode(node2.parent);
              }
            }
            function spanInCloseBracketToken(node2) {
              switch (node2.parent.kind) {
                case 202:
                  var bindingPattern = node2.parent;
                  return textSpan(ts3.lastOrUndefined(bindingPattern.elements) || bindingPattern);
                default:
                  if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
                    var arrayLiteral = node2.parent;
                    return textSpan(ts3.lastOrUndefined(arrayLiteral.elements) || arrayLiteral);
                  }
                  return spanInNode(node2.parent);
              }
            }
            function spanInOpenParenToken(node2) {
              if (node2.parent.kind === 240 || node2.parent.kind === 208 || node2.parent.kind === 209) {
                return spanInPreviousNode(node2);
              }
              if (node2.parent.kind === 212) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInCloseParenToken(node2) {
              switch (node2.parent.kind) {
                case 213:
                case 256:
                case 214:
                case 169:
                case 168:
                case 172:
                case 173:
                case 171:
                case 241:
                case 240:
                case 242:
                case 244:
                case 208:
                case 209:
                case 212:
                  return spanInPreviousNode(node2);
                default:
                  return spanInNode(node2.parent);
              }
            }
            function spanInColonToken(node2) {
              if (ts3.isFunctionLike(node2.parent) || node2.parent.kind === 296 || node2.parent.kind === 164) {
                return spanInPreviousNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInGreaterThanOrLessThanToken(node2) {
              if (node2.parent.kind === 211) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInWhileKeyword(node2) {
              if (node2.parent.kind === 240) {
                return textSpanEndingAtNextToken(node2, node2.parent.expression);
              }
              return spanInNode(node2.parent);
            }
            function spanInOfKeyword(node2) {
              if (node2.parent.kind === 244) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
          }
        }
        BreakpointResolver2.spanInSourceFileAtLocation = spanInSourceFileAtLocation;
      })(BreakpointResolver = ts3.BreakpointResolver || (ts3.BreakpointResolver = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transform(source, transformers, compilerOptions) {
        var diagnostics = [];
        compilerOptions = ts3.fixupCompilerOptions(compilerOptions, diagnostics);
        var nodes = ts3.isArray(source) ? source : [source];
        var result2 = ts3.transformNodes(void 0, void 0, ts3.factory, compilerOptions, nodes, transformers, true);
        result2.diagnostics = ts3.concatenate(result2.diagnostics, diagnostics);
        return result2;
      }
      ts3.transform = transform;
    })(ts2 || (ts2 = {}));
    var debugObjectHost = function() {
      return this;
    }();
    var ts2;
    (function(ts3) {
      function logInternalError(logger, err) {
        if (logger) {
          logger.log("*INTERNAL ERROR* - Exception in typescript services: " + err.message);
        }
      }
      var ScriptSnapshotShimAdapter = function() {
        function ScriptSnapshotShimAdapter2(scriptSnapshotShim) {
          this.scriptSnapshotShim = scriptSnapshotShim;
        }
        ScriptSnapshotShimAdapter2.prototype.getText = function(start, end) {
          return this.scriptSnapshotShim.getText(start, end);
        };
        ScriptSnapshotShimAdapter2.prototype.getLength = function() {
          return this.scriptSnapshotShim.getLength();
        };
        ScriptSnapshotShimAdapter2.prototype.getChangeRange = function(oldSnapshot) {
          var oldSnapshotShim = oldSnapshot;
          var encoded = this.scriptSnapshotShim.getChangeRange(oldSnapshotShim.scriptSnapshotShim);
          if (encoded === null) {
            return null;
          }
          var decoded = JSON.parse(encoded);
          return ts3.createTextChangeRange(ts3.createTextSpan(decoded.span.start, decoded.span.length), decoded.newLength);
        };
        ScriptSnapshotShimAdapter2.prototype.dispose = function() {
          if ("dispose" in this.scriptSnapshotShim) {
            this.scriptSnapshotShim.dispose();
          }
        };
        return ScriptSnapshotShimAdapter2;
      }();
      var LanguageServiceShimHostAdapter = function() {
        function LanguageServiceShimHostAdapter2(shimHost) {
          var _this = this;
          this.shimHost = shimHost;
          this.loggingEnabled = false;
          this.tracingEnabled = false;
          if ("getModuleResolutionsForFile" in this.shimHost) {
            this.resolveModuleNames = function(moduleNames, containingFile) {
              var resolutionsInFile = JSON.parse(_this.shimHost.getModuleResolutionsForFile(containingFile));
              return ts3.map(moduleNames, function(name) {
                var result2 = ts3.getProperty(resolutionsInFile, name);
                return result2 ? { resolvedFileName: result2, extension: ts3.extensionFromPath(result2), isExternalLibraryImport: false } : void 0;
              });
            };
          }
          if ("directoryExists" in this.shimHost) {
            this.directoryExists = function(directoryName) {
              return _this.shimHost.directoryExists(directoryName);
            };
          }
          if ("getTypeReferenceDirectiveResolutionsForFile" in this.shimHost) {
            this.resolveTypeReferenceDirectives = function(typeDirectiveNames, containingFile) {
              var typeDirectivesForFile = JSON.parse(_this.shimHost.getTypeReferenceDirectiveResolutionsForFile(containingFile));
              return ts3.map(typeDirectiveNames, function(name) {
                return ts3.getProperty(typeDirectivesForFile, ts3.isString(name) ? name : name.fileName.toLowerCase());
              });
            };
          }
        }
        LanguageServiceShimHostAdapter2.prototype.log = function(s) {
          if (this.loggingEnabled) {
            this.shimHost.log(s);
          }
        };
        LanguageServiceShimHostAdapter2.prototype.trace = function(s) {
          if (this.tracingEnabled) {
            this.shimHost.trace(s);
          }
        };
        LanguageServiceShimHostAdapter2.prototype.error = function(s) {
          this.shimHost.error(s);
        };
        LanguageServiceShimHostAdapter2.prototype.getProjectVersion = function() {
          if (!this.shimHost.getProjectVersion) {
            return void 0;
          }
          return this.shimHost.getProjectVersion();
        };
        LanguageServiceShimHostAdapter2.prototype.getTypeRootsVersion = function() {
          if (!this.shimHost.getTypeRootsVersion) {
            return 0;
          }
          return this.shimHost.getTypeRootsVersion();
        };
        LanguageServiceShimHostAdapter2.prototype.useCaseSensitiveFileNames = function() {
          return this.shimHost.useCaseSensitiveFileNames ? this.shimHost.useCaseSensitiveFileNames() : false;
        };
        LanguageServiceShimHostAdapter2.prototype.getCompilationSettings = function() {
          var settingsJson = this.shimHost.getCompilationSettings();
          if (settingsJson === null || settingsJson === "") {
            throw Error("LanguageServiceShimHostAdapter.getCompilationSettings: empty compilationSettings");
          }
          var compilerOptions = JSON.parse(settingsJson);
          compilerOptions.allowNonTsExtensions = true;
          return compilerOptions;
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptFileNames = function() {
          var encoded = this.shimHost.getScriptFileNames();
          return JSON.parse(encoded);
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptSnapshot = function(fileName2) {
          var scriptSnapshot = this.shimHost.getScriptSnapshot(fileName2);
          return scriptSnapshot && new ScriptSnapshotShimAdapter(scriptSnapshot);
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptKind = function(fileName2) {
          if ("getScriptKind" in this.shimHost) {
            return this.shimHost.getScriptKind(fileName2);
          } else {
            return 0;
          }
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptVersion = function(fileName2) {
          return this.shimHost.getScriptVersion(fileName2);
        };
        LanguageServiceShimHostAdapter2.prototype.getLocalizedDiagnosticMessages = function() {
          var diagnosticMessagesJson = this.shimHost.getLocalizedDiagnosticMessages();
          if (diagnosticMessagesJson === null || diagnosticMessagesJson === "") {
            return null;
          }
          try {
            return JSON.parse(diagnosticMessagesJson);
          } catch (e) {
            this.log(e.description || "diagnosticMessages.generated.json has invalid JSON format");
            return null;
          }
        };
        LanguageServiceShimHostAdapter2.prototype.getCancellationToken = function() {
          var hostCancellationToken = this.shimHost.getCancellationToken();
          return new ts3.ThrottledCancellationToken(hostCancellationToken);
        };
        LanguageServiceShimHostAdapter2.prototype.getCurrentDirectory = function() {
          return this.shimHost.getCurrentDirectory();
        };
        LanguageServiceShimHostAdapter2.prototype.getDirectories = function(path2) {
          return JSON.parse(this.shimHost.getDirectories(path2));
        };
        LanguageServiceShimHostAdapter2.prototype.getDefaultLibFileName = function(options) {
          return this.shimHost.getDefaultLibFileName(JSON.stringify(options));
        };
        LanguageServiceShimHostAdapter2.prototype.readDirectory = function(path2, extensions, exclude, include, depth) {
          var pattern = ts3.getFileMatcherPatterns(path2, exclude, include, this.shimHost.useCaseSensitiveFileNames(), this.shimHost.getCurrentDirectory());
          return JSON.parse(this.shimHost.readDirectory(path2, JSON.stringify(extensions), JSON.stringify(pattern.basePaths), pattern.excludePattern, pattern.includeFilePattern, pattern.includeDirectoryPattern, depth));
        };
        LanguageServiceShimHostAdapter2.prototype.readFile = function(path2, encoding) {
          return this.shimHost.readFile(path2, encoding);
        };
        LanguageServiceShimHostAdapter2.prototype.fileExists = function(path2) {
          return this.shimHost.fileExists(path2);
        };
        return LanguageServiceShimHostAdapter2;
      }();
      ts3.LanguageServiceShimHostAdapter = LanguageServiceShimHostAdapter;
      var CoreServicesShimHostAdapter = function() {
        function CoreServicesShimHostAdapter2(shimHost) {
          var _this = this;
          this.shimHost = shimHost;
          this.useCaseSensitiveFileNames = this.shimHost.useCaseSensitiveFileNames ? this.shimHost.useCaseSensitiveFileNames() : false;
          if ("directoryExists" in this.shimHost) {
            this.directoryExists = function(directoryName) {
              return _this.shimHost.directoryExists(directoryName);
            };
          } else {
            this.directoryExists = void 0;
          }
          if ("realpath" in this.shimHost) {
            this.realpath = function(path2) {
              return _this.shimHost.realpath(path2);
            };
          } else {
            this.realpath = void 0;
          }
        }
        CoreServicesShimHostAdapter2.prototype.readDirectory = function(rootDir, extensions, exclude, include, depth) {
          var pattern = ts3.getFileMatcherPatterns(rootDir, exclude, include, this.shimHost.useCaseSensitiveFileNames(), this.shimHost.getCurrentDirectory());
          return JSON.parse(this.shimHost.readDirectory(rootDir, JSON.stringify(extensions), JSON.stringify(pattern.basePaths), pattern.excludePattern, pattern.includeFilePattern, pattern.includeDirectoryPattern, depth));
        };
        CoreServicesShimHostAdapter2.prototype.fileExists = function(fileName2) {
          return this.shimHost.fileExists(fileName2);
        };
        CoreServicesShimHostAdapter2.prototype.readFile = function(fileName2) {
          return this.shimHost.readFile(fileName2);
        };
        CoreServicesShimHostAdapter2.prototype.getDirectories = function(path2) {
          return JSON.parse(this.shimHost.getDirectories(path2));
        };
        return CoreServicesShimHostAdapter2;
      }();
      ts3.CoreServicesShimHostAdapter = CoreServicesShimHostAdapter;
      function simpleForwardCall(logger, actionDescription, action, logPerformance) {
        var start;
        if (logPerformance) {
          logger.log(actionDescription);
          start = ts3.timestamp();
        }
        var result2 = action();
        if (logPerformance) {
          var end = ts3.timestamp();
          logger.log("".concat(actionDescription, " completed in ").concat(end - start, " msec"));
          if (ts3.isString(result2)) {
            var str2 = result2;
            if (str2.length > 128) {
              str2 = str2.substring(0, 128) + "...";
            }
            logger.log("  result.length=".concat(str2.length, ", result='").concat(JSON.stringify(str2), "'"));
          }
        }
        return result2;
      }
      function forwardJSONCall(logger, actionDescription, action, logPerformance) {
        return forwardCall(logger, actionDescription, true, action, logPerformance);
      }
      function forwardCall(logger, actionDescription, returnJson, action, logPerformance) {
        try {
          var result2 = simpleForwardCall(logger, actionDescription, action, logPerformance);
          return returnJson ? JSON.stringify({ result: result2 }) : result2;
        } catch (err) {
          if (err instanceof ts3.OperationCanceledException) {
            return JSON.stringify({ canceled: true });
          }
          logInternalError(logger, err);
          err.description = actionDescription;
          return JSON.stringify({ error: err });
        }
      }
      var ShimBase = function() {
        function ShimBase2(factory) {
          this.factory = factory;
          factory.registerShim(this);
        }
        ShimBase2.prototype.dispose = function(_dummy) {
          this.factory.unregisterShim(this);
        };
        return ShimBase2;
      }();
      function realizeDiagnostics(diagnostics, newLine) {
        return diagnostics.map(function(d) {
          return realizeDiagnostic(d, newLine);
        });
      }
      ts3.realizeDiagnostics = realizeDiagnostics;
      function realizeDiagnostic(diagnostic, newLine) {
        return {
          message: ts3.flattenDiagnosticMessageText(diagnostic.messageText, newLine),
          start: diagnostic.start,
          length: diagnostic.length,
          category: ts3.diagnosticCategoryName(diagnostic),
          code: diagnostic.code,
          reportsUnnecessary: diagnostic.reportsUnnecessary,
          reportsDeprecated: diagnostic.reportsDeprecated
        };
      }
      var LanguageServiceShimObject = function(_super) {
        __extends(LanguageServiceShimObject2, _super);
        function LanguageServiceShimObject2(factory, host, languageService) {
          var _this = _super.call(this, factory) || this;
          _this.host = host;
          _this.languageService = languageService;
          _this.logPerformance = false;
          _this.logger = _this.host;
          return _this;
        }
        LanguageServiceShimObject2.prototype.forwardJSONCall = function(actionDescription, action) {
          return forwardJSONCall(this.logger, actionDescription, action, this.logPerformance);
        };
        LanguageServiceShimObject2.prototype.dispose = function(dummy) {
          this.logger.log("dispose()");
          this.languageService.dispose();
          this.languageService = null;
          if (debugObjectHost && debugObjectHost.CollectGarbage) {
            debugObjectHost.CollectGarbage();
            this.logger.log("CollectGarbage()");
          }
          this.logger = null;
          _super.prototype.dispose.call(this, dummy);
        };
        LanguageServiceShimObject2.prototype.refresh = function(throwOnError) {
          this.forwardJSONCall("refresh(".concat(throwOnError, ")"), function() {
            return null;
          });
        };
        LanguageServiceShimObject2.prototype.cleanupSemanticCache = function() {
          var _this = this;
          this.forwardJSONCall("cleanupSemanticCache()", function() {
            _this.languageService.cleanupSemanticCache();
            return null;
          });
        };
        LanguageServiceShimObject2.prototype.realizeDiagnostics = function(diagnostics) {
          var newLine = ts3.getNewLineOrDefaultFromHost(this.host);
          return realizeDiagnostics(diagnostics, newLine);
        };
        LanguageServiceShimObject2.prototype.getSyntacticClassifications = function(fileName2, start, length) {
          var _this = this;
          return this.forwardJSONCall("getSyntacticClassifications('".concat(fileName2, "', ").concat(start, ", ").concat(length, ")"), function() {
            return _this.languageService.getSyntacticClassifications(fileName2, ts3.createTextSpan(start, length));
          });
        };
        LanguageServiceShimObject2.prototype.getSemanticClassifications = function(fileName2, start, length) {
          var _this = this;
          return this.forwardJSONCall("getSemanticClassifications('".concat(fileName2, "', ").concat(start, ", ").concat(length, ")"), function() {
            return _this.languageService.getSemanticClassifications(fileName2, ts3.createTextSpan(start, length));
          });
        };
        LanguageServiceShimObject2.prototype.getEncodedSyntacticClassifications = function(fileName2, start, length) {
          var _this = this;
          return this.forwardJSONCall("getEncodedSyntacticClassifications('".concat(fileName2, "', ").concat(start, ", ").concat(length, ")"), function() {
            return convertClassifications(_this.languageService.getEncodedSyntacticClassifications(fileName2, ts3.createTextSpan(start, length)));
          });
        };
        LanguageServiceShimObject2.prototype.getEncodedSemanticClassifications = function(fileName2, start, length) {
          var _this = this;
          return this.forwardJSONCall("getEncodedSemanticClassifications('".concat(fileName2, "', ").concat(start, ", ").concat(length, ")"), function() {
            return convertClassifications(_this.languageService.getEncodedSemanticClassifications(fileName2, ts3.createTextSpan(start, length)));
          });
        };
        LanguageServiceShimObject2.prototype.getSyntacticDiagnostics = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getSyntacticDiagnostics('".concat(fileName2, "')"), function() {
            var diagnostics = _this.languageService.getSyntacticDiagnostics(fileName2);
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getSemanticDiagnostics = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getSemanticDiagnostics('".concat(fileName2, "')"), function() {
            var diagnostics = _this.languageService.getSemanticDiagnostics(fileName2);
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getSuggestionDiagnostics = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getSuggestionDiagnostics('".concat(fileName2, "')"), function() {
            return _this.realizeDiagnostics(_this.languageService.getSuggestionDiagnostics(fileName2));
          });
        };
        LanguageServiceShimObject2.prototype.getCompilerOptionsDiagnostics = function() {
          var _this = this;
          return this.forwardJSONCall("getCompilerOptionsDiagnostics()", function() {
            var diagnostics = _this.languageService.getCompilerOptionsDiagnostics();
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getQuickInfoAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getQuickInfoAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getQuickInfoAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getNameOrDottedNameSpan = function(fileName2, startPos, endPos) {
          var _this = this;
          return this.forwardJSONCall("getNameOrDottedNameSpan('".concat(fileName2, "', ").concat(startPos, ", ").concat(endPos, ")"), function() {
            return _this.languageService.getNameOrDottedNameSpan(fileName2, startPos, endPos);
          });
        };
        LanguageServiceShimObject2.prototype.getBreakpointStatementAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getBreakpointStatementAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getBreakpointStatementAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getSignatureHelpItems = function(fileName2, position, options) {
          var _this = this;
          return this.forwardJSONCall("getSignatureHelpItems('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getSignatureHelpItems(fileName2, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getDefinitionAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getDefinitionAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getDefinitionAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getDefinitionAndBoundSpan = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getDefinitionAndBoundSpan('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getDefinitionAndBoundSpan(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getTypeDefinitionAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getTypeDefinitionAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getTypeDefinitionAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getImplementationAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getImplementationAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getImplementationAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getRenameInfo = function(fileName2, position, options) {
          var _this = this;
          return this.forwardJSONCall("getRenameInfo('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getRenameInfo(fileName2, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getSmartSelectionRange = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getSmartSelectionRange('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getSmartSelectionRange(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.findRenameLocations = function(fileName2, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename) {
          var _this = this;
          return this.forwardJSONCall("findRenameLocations('".concat(fileName2, "', ").concat(position, ", ").concat(findInStrings, ", ").concat(findInComments, ", ").concat(providePrefixAndSuffixTextForRename, ")"), function() {
            return _this.languageService.findRenameLocations(fileName2, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename);
          });
        };
        LanguageServiceShimObject2.prototype.getBraceMatchingAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getBraceMatchingAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getBraceMatchingAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.isValidBraceCompletionAtPosition = function(fileName2, position, openingBrace) {
          var _this = this;
          return this.forwardJSONCall("isValidBraceCompletionAtPosition('".concat(fileName2, "', ").concat(position, ", ").concat(openingBrace, ")"), function() {
            return _this.languageService.isValidBraceCompletionAtPosition(fileName2, position, openingBrace);
          });
        };
        LanguageServiceShimObject2.prototype.getSpanOfEnclosingComment = function(fileName2, position, onlyMultiLine) {
          var _this = this;
          return this.forwardJSONCall("getSpanOfEnclosingComment('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getSpanOfEnclosingComment(fileName2, position, onlyMultiLine);
          });
        };
        LanguageServiceShimObject2.prototype.getIndentationAtPosition = function(fileName2, position, options) {
          var _this = this;
          return this.forwardJSONCall("getIndentationAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getIndentationAtPosition(fileName2, position, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getReferencesAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getReferencesAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getReferencesAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.findReferences = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("findReferences('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.findReferences(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getFileReferences = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getFileReferences('".concat(fileName2, ")"), function() {
            return _this.languageService.getFileReferences(fileName2);
          });
        };
        LanguageServiceShimObject2.prototype.getOccurrencesAtPosition = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("getOccurrencesAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getOccurrencesAtPosition(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.getDocumentHighlights = function(fileName2, position, filesToSearch) {
          var _this = this;
          return this.forwardJSONCall("getDocumentHighlights('".concat(fileName2, "', ").concat(position, ")"), function() {
            var results = _this.languageService.getDocumentHighlights(fileName2, position, JSON.parse(filesToSearch));
            var normalizedName = ts3.toFileNameLowerCase(ts3.normalizeSlashes(fileName2));
            return ts3.filter(results, function(r) {
              return ts3.toFileNameLowerCase(ts3.normalizeSlashes(r.fileName)) === normalizedName;
            });
          });
        };
        LanguageServiceShimObject2.prototype.getCompletionsAtPosition = function(fileName2, position, preferences, formattingSettings) {
          var _this = this;
          return this.forwardJSONCall("getCompletionsAtPosition('".concat(fileName2, "', ").concat(position, ", ").concat(preferences, ", ").concat(formattingSettings, ")"), function() {
            return _this.languageService.getCompletionsAtPosition(fileName2, position, preferences, formattingSettings);
          });
        };
        LanguageServiceShimObject2.prototype.getCompletionEntryDetails = function(fileName2, position, entryName, formatOptions, source, preferences, data) {
          var _this = this;
          return this.forwardJSONCall("getCompletionEntryDetails('".concat(fileName2, "', ").concat(position, ", '").concat(entryName, "')"), function() {
            var localOptions = formatOptions === void 0 ? void 0 : JSON.parse(formatOptions);
            return _this.languageService.getCompletionEntryDetails(fileName2, position, entryName, localOptions, source, preferences, data);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsForRange = function(fileName2, start, end, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsForRange('".concat(fileName2, "', ").concat(start, ", ").concat(end, ")"), function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsForRange(fileName2, start, end, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsForDocument = function(fileName2, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsForDocument('".concat(fileName2, "')"), function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsForDocument(fileName2, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsAfterKeystroke = function(fileName2, position, key, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsAfterKeystroke('".concat(fileName2, "', ").concat(position, ", '").concat(key, "')"), function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsAfterKeystroke(fileName2, position, key, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getDocCommentTemplateAtPosition = function(fileName2, position, options) {
          var _this = this;
          return this.forwardJSONCall("getDocCommentTemplateAtPosition('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.getDocCommentTemplateAtPosition(fileName2, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigateToItems = function(searchValue, maxResultCount, fileName2) {
          var _this = this;
          return this.forwardJSONCall("getNavigateToItems('".concat(searchValue, "', ").concat(maxResultCount, ", ").concat(fileName2, ")"), function() {
            return _this.languageService.getNavigateToItems(searchValue, maxResultCount, fileName2);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigationBarItems = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getNavigationBarItems('".concat(fileName2, "')"), function() {
            return _this.languageService.getNavigationBarItems(fileName2);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigationTree = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getNavigationTree('".concat(fileName2, "')"), function() {
            return _this.languageService.getNavigationTree(fileName2);
          });
        };
        LanguageServiceShimObject2.prototype.getOutliningSpans = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getOutliningSpans('".concat(fileName2, "')"), function() {
            return _this.languageService.getOutliningSpans(fileName2);
          });
        };
        LanguageServiceShimObject2.prototype.getTodoComments = function(fileName2, descriptors) {
          var _this = this;
          return this.forwardJSONCall("getTodoComments('".concat(fileName2, "')"), function() {
            return _this.languageService.getTodoComments(fileName2, JSON.parse(descriptors));
          });
        };
        LanguageServiceShimObject2.prototype.prepareCallHierarchy = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("prepareCallHierarchy('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.prepareCallHierarchy(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideCallHierarchyIncomingCalls = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("provideCallHierarchyIncomingCalls('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.provideCallHierarchyIncomingCalls(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideCallHierarchyOutgoingCalls = function(fileName2, position) {
          var _this = this;
          return this.forwardJSONCall("provideCallHierarchyOutgoingCalls('".concat(fileName2, "', ").concat(position, ")"), function() {
            return _this.languageService.provideCallHierarchyOutgoingCalls(fileName2, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideInlayHints = function(fileName2, span, preference) {
          var _this = this;
          return this.forwardJSONCall("provideInlayHints('".concat(fileName2, "', '").concat(JSON.stringify(span), "', ").concat(JSON.stringify(preference), ")"), function() {
            return _this.languageService.provideInlayHints(fileName2, span, preference);
          });
        };
        LanguageServiceShimObject2.prototype.getEmitOutput = function(fileName2) {
          var _this = this;
          return this.forwardJSONCall("getEmitOutput('".concat(fileName2, "')"), function() {
            var _a = _this.languageService.getEmitOutput(fileName2), diagnostics = _a.diagnostics, rest = __rest(_a, ["diagnostics"]);
            return __assign(__assign({}, rest), { diagnostics: _this.realizeDiagnostics(diagnostics) });
          });
        };
        LanguageServiceShimObject2.prototype.getEmitOutputObject = function(fileName2) {
          var _this = this;
          return forwardCall(this.logger, "getEmitOutput('".concat(fileName2, "')"), false, function() {
            return _this.languageService.getEmitOutput(fileName2);
          }, this.logPerformance);
        };
        LanguageServiceShimObject2.prototype.toggleLineComment = function(fileName2, textRange) {
          var _this = this;
          return this.forwardJSONCall("toggleLineComment('".concat(fileName2, "', '").concat(JSON.stringify(textRange), "')"), function() {
            return _this.languageService.toggleLineComment(fileName2, textRange);
          });
        };
        LanguageServiceShimObject2.prototype.toggleMultilineComment = function(fileName2, textRange) {
          var _this = this;
          return this.forwardJSONCall("toggleMultilineComment('".concat(fileName2, "', '").concat(JSON.stringify(textRange), "')"), function() {
            return _this.languageService.toggleMultilineComment(fileName2, textRange);
          });
        };
        LanguageServiceShimObject2.prototype.commentSelection = function(fileName2, textRange) {
          var _this = this;
          return this.forwardJSONCall("commentSelection('".concat(fileName2, "', '").concat(JSON.stringify(textRange), "')"), function() {
            return _this.languageService.commentSelection(fileName2, textRange);
          });
        };
        LanguageServiceShimObject2.prototype.uncommentSelection = function(fileName2, textRange) {
          var _this = this;
          return this.forwardJSONCall("uncommentSelection('".concat(fileName2, "', '").concat(JSON.stringify(textRange), "')"), function() {
            return _this.languageService.uncommentSelection(fileName2, textRange);
          });
        };
        return LanguageServiceShimObject2;
      }(ShimBase);
      function convertClassifications(classifications) {
        return { spans: classifications.spans.join(","), endOfLineState: classifications.endOfLineState };
      }
      var ClassifierShimObject = function(_super) {
        __extends(ClassifierShimObject2, _super);
        function ClassifierShimObject2(factory, logger) {
          var _this = _super.call(this, factory) || this;
          _this.logger = logger;
          _this.logPerformance = false;
          _this.classifier = ts3.createClassifier();
          return _this;
        }
        ClassifierShimObject2.prototype.getEncodedLexicalClassifications = function(text, lexState, syntacticClassifierAbsent) {
          var _this = this;
          if (syntacticClassifierAbsent === void 0) {
            syntacticClassifierAbsent = false;
          }
          return forwardJSONCall(this.logger, "getEncodedLexicalClassifications", function() {
            return convertClassifications(_this.classifier.getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent));
          }, this.logPerformance);
        };
        ClassifierShimObject2.prototype.getClassificationsForLine = function(text, lexState, classifyKeywordsInGenerics) {
          if (classifyKeywordsInGenerics === void 0) {
            classifyKeywordsInGenerics = false;
          }
          var classification = this.classifier.getClassificationsForLine(text, lexState, classifyKeywordsInGenerics);
          var result2 = "";
          for (var _i = 0, _a = classification.entries; _i < _a.length; _i++) {
            var item = _a[_i];
            result2 += item.length + "\n";
            result2 += item.classification + "\n";
          }
          result2 += classification.finalLexState;
          return result2;
        };
        return ClassifierShimObject2;
      }(ShimBase);
      var CoreServicesShimObject = function(_super) {
        __extends(CoreServicesShimObject2, _super);
        function CoreServicesShimObject2(factory, logger, host) {
          var _this = _super.call(this, factory) || this;
          _this.logger = logger;
          _this.host = host;
          _this.logPerformance = false;
          return _this;
        }
        CoreServicesShimObject2.prototype.forwardJSONCall = function(actionDescription, action) {
          return forwardJSONCall(this.logger, actionDescription, action, this.logPerformance);
        };
        CoreServicesShimObject2.prototype.resolveModuleName = function(fileName2, moduleName, compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("resolveModuleName('".concat(fileName2, "')"), function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            var result2 = ts3.resolveModuleName(moduleName, ts3.normalizeSlashes(fileName2), compilerOptions, _this.host);
            var resolvedFileName = result2.resolvedModule ? result2.resolvedModule.resolvedFileName : void 0;
            if (result2.resolvedModule && result2.resolvedModule.extension !== ".ts" && result2.resolvedModule.extension !== ".tsx" && result2.resolvedModule.extension !== ".d.ts") {
              resolvedFileName = void 0;
            }
            return {
              resolvedFileName,
              failedLookupLocations: result2.failedLookupLocations
            };
          });
        };
        CoreServicesShimObject2.prototype.resolveTypeReferenceDirective = function(fileName2, typeReferenceDirective, compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("resolveTypeReferenceDirective(".concat(fileName2, ")"), function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            var result2 = ts3.resolveTypeReferenceDirective(typeReferenceDirective, ts3.normalizeSlashes(fileName2), compilerOptions, _this.host);
            return {
              resolvedFileName: result2.resolvedTypeReferenceDirective ? result2.resolvedTypeReferenceDirective.resolvedFileName : void 0,
              primary: result2.resolvedTypeReferenceDirective ? result2.resolvedTypeReferenceDirective.primary : true,
              failedLookupLocations: result2.failedLookupLocations
            };
          });
        };
        CoreServicesShimObject2.prototype.getPreProcessedFileInfo = function(fileName2, sourceTextSnapshot) {
          var _this = this;
          return this.forwardJSONCall("getPreProcessedFileInfo('".concat(fileName2, "')"), function() {
            var result2 = ts3.preProcessFile(ts3.getSnapshotText(sourceTextSnapshot), true, true);
            return {
              referencedFiles: _this.convertFileReferences(result2.referencedFiles),
              importedFiles: _this.convertFileReferences(result2.importedFiles),
              ambientExternalModules: result2.ambientExternalModules,
              isLibFile: result2.isLibFile,
              typeReferenceDirectives: _this.convertFileReferences(result2.typeReferenceDirectives),
              libReferenceDirectives: _this.convertFileReferences(result2.libReferenceDirectives)
            };
          });
        };
        CoreServicesShimObject2.prototype.getAutomaticTypeDirectiveNames = function(compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("getAutomaticTypeDirectiveNames('".concat(compilerOptionsJson, "')"), function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            return ts3.getAutomaticTypeDirectiveNames(compilerOptions, _this.host);
          });
        };
        CoreServicesShimObject2.prototype.convertFileReferences = function(refs) {
          if (!refs) {
            return void 0;
          }
          var result2 = [];
          for (var _i = 0, refs_1 = refs; _i < refs_1.length; _i++) {
            var ref = refs_1[_i];
            result2.push({
              path: ts3.normalizeSlashes(ref.fileName),
              position: ref.pos,
              length: ref.end - ref.pos
            });
          }
          return result2;
        };
        CoreServicesShimObject2.prototype.getTSConfigFileInfo = function(fileName2, sourceTextSnapshot) {
          var _this = this;
          return this.forwardJSONCall("getTSConfigFileInfo('".concat(fileName2, "')"), function() {
            var result2 = ts3.parseJsonText(fileName2, ts3.getSnapshotText(sourceTextSnapshot));
            var normalizedFileName = ts3.normalizeSlashes(fileName2);
            var configFile = ts3.parseJsonSourceFileConfigFileContent(result2, _this.host, ts3.getDirectoryPath(normalizedFileName), {}, normalizedFileName);
            return {
              options: configFile.options,
              typeAcquisition: configFile.typeAcquisition,
              files: configFile.fileNames,
              raw: configFile.raw,
              errors: realizeDiagnostics(__spreadArray(__spreadArray([], result2.parseDiagnostics, true), configFile.errors, true), "\r\n")
            };
          });
        };
        CoreServicesShimObject2.prototype.getDefaultCompilationSettings = function() {
          return this.forwardJSONCall("getDefaultCompilationSettings()", function() {
            return ts3.getDefaultCompilerOptions();
          });
        };
        CoreServicesShimObject2.prototype.discoverTypings = function(discoverTypingsJson) {
          var _this = this;
          var getCanonicalFileName = ts3.createGetCanonicalFileName(false);
          return this.forwardJSONCall("discoverTypings()", function() {
            var info = JSON.parse(discoverTypingsJson);
            if (_this.safeList === void 0) {
              _this.safeList = ts3.JsTyping.loadSafeList(_this.host, ts3.toPath(info.safeListPath, info.safeListPath, getCanonicalFileName));
            }
            return ts3.JsTyping.discoverTypings(_this.host, function(msg) {
              return _this.logger.log(msg);
            }, info.fileNames, ts3.toPath(info.projectRootPath, info.projectRootPath, getCanonicalFileName), _this.safeList, info.packageNameToTypingLocation, info.typeAcquisition, info.unresolvedImports, info.typesRegistry);
          });
        };
        return CoreServicesShimObject2;
      }(ShimBase);
      var TypeScriptServicesFactory = function() {
        function TypeScriptServicesFactory2() {
          this._shims = [];
        }
        TypeScriptServicesFactory2.prototype.getServicesVersion = function() {
          return ts3.servicesVersion;
        };
        TypeScriptServicesFactory2.prototype.createLanguageServiceShim = function(host) {
          try {
            if (this.documentRegistry === void 0) {
              this.documentRegistry = ts3.createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory());
            }
            var hostAdapter = new LanguageServiceShimHostAdapter(host);
            var languageService = ts3.createLanguageService(hostAdapter, this.documentRegistry, false);
            return new LanguageServiceShimObject(this, host, languageService);
          } catch (err) {
            logInternalError(host, err);
            throw err;
          }
        };
        TypeScriptServicesFactory2.prototype.createClassifierShim = function(logger) {
          try {
            return new ClassifierShimObject(this, logger);
          } catch (err) {
            logInternalError(logger, err);
            throw err;
          }
        };
        TypeScriptServicesFactory2.prototype.createCoreServicesShim = function(host) {
          try {
            var adapter = new CoreServicesShimHostAdapter(host);
            return new CoreServicesShimObject(this, host, adapter);
          } catch (err) {
            logInternalError(host, err);
            throw err;
          }
        };
        TypeScriptServicesFactory2.prototype.close = function() {
          ts3.clear(this._shims);
          this.documentRegistry = void 0;
        };
        TypeScriptServicesFactory2.prototype.registerShim = function(shim) {
          this._shims.push(shim);
        };
        TypeScriptServicesFactory2.prototype.unregisterShim = function(shim) {
          for (var i = 0; i < this._shims.length; i++) {
            if (this._shims[i] === shim) {
              delete this._shims[i];
              return;
            }
          }
          throw new Error("Invalid operation");
        };
        return TypeScriptServicesFactory2;
      }();
      ts3.TypeScriptServicesFactory = TypeScriptServicesFactory;
    })(ts2 || (ts2 = {}));
    (function() {
      if (typeof globalThis === "object")
        return;
      try {
        Object.defineProperty(Object.prototype, "__magic__", {
          get: function() {
            return this;
          },
          configurable: true
        });
        __magic__.globalThis = __magic__;
        if (typeof globalThis === "undefined") {
          window.globalThis = window;
        }
        delete Object.prototype.__magic__;
      } catch (error) {
        window.globalThis = window;
      }
    })();
    if (typeof process === "undefined" || process.browser) {
      globalThis.TypeScript = globalThis.TypeScript || {};
      globalThis.TypeScript.Services = globalThis.TypeScript.Services || {};
      globalThis.TypeScript.Services.TypeScriptServicesFactory = ts2.TypeScriptServicesFactory;
      globalThis.toolsVersion = ts2.versionMajorMinor;
    }
    if (typeof module2 !== "undefined" && module2.exports) {
      module2.exports = ts2;
    }
    var ts2;
    (function(ts3) {
      var factoryDeprecation = { since: "4.0", warnAfter: "4.1", message: "Use the appropriate method on 'ts.factory' or the 'factory' supplied by your transformation context instead." };
      ts3.createNodeArray = ts3.Debug.deprecate(ts3.factory.createNodeArray, factoryDeprecation);
      ts3.createNumericLiteral = ts3.Debug.deprecate(ts3.factory.createNumericLiteral, factoryDeprecation);
      ts3.createBigIntLiteral = ts3.Debug.deprecate(ts3.factory.createBigIntLiteral, factoryDeprecation);
      ts3.createStringLiteral = ts3.Debug.deprecate(ts3.factory.createStringLiteral, factoryDeprecation);
      ts3.createStringLiteralFromNode = ts3.Debug.deprecate(ts3.factory.createStringLiteralFromNode, factoryDeprecation);
      ts3.createRegularExpressionLiteral = ts3.Debug.deprecate(ts3.factory.createRegularExpressionLiteral, factoryDeprecation);
      ts3.createLoopVariable = ts3.Debug.deprecate(ts3.factory.createLoopVariable, factoryDeprecation);
      ts3.createUniqueName = ts3.Debug.deprecate(ts3.factory.createUniqueName, factoryDeprecation);
      ts3.createPrivateIdentifier = ts3.Debug.deprecate(ts3.factory.createPrivateIdentifier, factoryDeprecation);
      ts3.createSuper = ts3.Debug.deprecate(ts3.factory.createSuper, factoryDeprecation);
      ts3.createThis = ts3.Debug.deprecate(ts3.factory.createThis, factoryDeprecation);
      ts3.createNull = ts3.Debug.deprecate(ts3.factory.createNull, factoryDeprecation);
      ts3.createTrue = ts3.Debug.deprecate(ts3.factory.createTrue, factoryDeprecation);
      ts3.createFalse = ts3.Debug.deprecate(ts3.factory.createFalse, factoryDeprecation);
      ts3.createModifier = ts3.Debug.deprecate(ts3.factory.createModifier, factoryDeprecation);
      ts3.createModifiersFromModifierFlags = ts3.Debug.deprecate(ts3.factory.createModifiersFromModifierFlags, factoryDeprecation);
      ts3.createQualifiedName = ts3.Debug.deprecate(ts3.factory.createQualifiedName, factoryDeprecation);
      ts3.updateQualifiedName = ts3.Debug.deprecate(ts3.factory.updateQualifiedName, factoryDeprecation);
      ts3.createComputedPropertyName = ts3.Debug.deprecate(ts3.factory.createComputedPropertyName, factoryDeprecation);
      ts3.updateComputedPropertyName = ts3.Debug.deprecate(ts3.factory.updateComputedPropertyName, factoryDeprecation);
      ts3.createTypeParameterDeclaration = ts3.Debug.deprecate(ts3.factory.createTypeParameterDeclaration, factoryDeprecation);
      ts3.updateTypeParameterDeclaration = ts3.Debug.deprecate(ts3.factory.updateTypeParameterDeclaration, factoryDeprecation);
      ts3.createParameter = ts3.Debug.deprecate(ts3.factory.createParameterDeclaration, factoryDeprecation);
      ts3.updateParameter = ts3.Debug.deprecate(ts3.factory.updateParameterDeclaration, factoryDeprecation);
      ts3.createDecorator = ts3.Debug.deprecate(ts3.factory.createDecorator, factoryDeprecation);
      ts3.updateDecorator = ts3.Debug.deprecate(ts3.factory.updateDecorator, factoryDeprecation);
      ts3.createProperty = ts3.Debug.deprecate(ts3.factory.createPropertyDeclaration, factoryDeprecation);
      ts3.updateProperty = ts3.Debug.deprecate(ts3.factory.updatePropertyDeclaration, factoryDeprecation);
      ts3.createMethod = ts3.Debug.deprecate(ts3.factory.createMethodDeclaration, factoryDeprecation);
      ts3.updateMethod = ts3.Debug.deprecate(ts3.factory.updateMethodDeclaration, factoryDeprecation);
      ts3.createConstructor = ts3.Debug.deprecate(ts3.factory.createConstructorDeclaration, factoryDeprecation);
      ts3.updateConstructor = ts3.Debug.deprecate(ts3.factory.updateConstructorDeclaration, factoryDeprecation);
      ts3.createGetAccessor = ts3.Debug.deprecate(ts3.factory.createGetAccessorDeclaration, factoryDeprecation);
      ts3.updateGetAccessor = ts3.Debug.deprecate(ts3.factory.updateGetAccessorDeclaration, factoryDeprecation);
      ts3.createSetAccessor = ts3.Debug.deprecate(ts3.factory.createSetAccessorDeclaration, factoryDeprecation);
      ts3.updateSetAccessor = ts3.Debug.deprecate(ts3.factory.updateSetAccessorDeclaration, factoryDeprecation);
      ts3.createCallSignature = ts3.Debug.deprecate(ts3.factory.createCallSignature, factoryDeprecation);
      ts3.updateCallSignature = ts3.Debug.deprecate(ts3.factory.updateCallSignature, factoryDeprecation);
      ts3.createConstructSignature = ts3.Debug.deprecate(ts3.factory.createConstructSignature, factoryDeprecation);
      ts3.updateConstructSignature = ts3.Debug.deprecate(ts3.factory.updateConstructSignature, factoryDeprecation);
      ts3.updateIndexSignature = ts3.Debug.deprecate(ts3.factory.updateIndexSignature, factoryDeprecation);
      ts3.createKeywordTypeNode = ts3.Debug.deprecate(ts3.factory.createKeywordTypeNode, factoryDeprecation);
      ts3.createTypePredicateNodeWithModifier = ts3.Debug.deprecate(ts3.factory.createTypePredicateNode, factoryDeprecation);
      ts3.updateTypePredicateNodeWithModifier = ts3.Debug.deprecate(ts3.factory.updateTypePredicateNode, factoryDeprecation);
      ts3.createTypeReferenceNode = ts3.Debug.deprecate(ts3.factory.createTypeReferenceNode, factoryDeprecation);
      ts3.updateTypeReferenceNode = ts3.Debug.deprecate(ts3.factory.updateTypeReferenceNode, factoryDeprecation);
      ts3.createFunctionTypeNode = ts3.Debug.deprecate(ts3.factory.createFunctionTypeNode, factoryDeprecation);
      ts3.updateFunctionTypeNode = ts3.Debug.deprecate(ts3.factory.updateFunctionTypeNode, factoryDeprecation);
      ts3.createConstructorTypeNode = ts3.Debug.deprecate(function(typeParameters, parameters, type2) {
        return ts3.factory.createConstructorTypeNode(void 0, typeParameters, parameters, type2);
      }, factoryDeprecation);
      ts3.updateConstructorTypeNode = ts3.Debug.deprecate(function(node, typeParameters, parameters, type2) {
        return ts3.factory.updateConstructorTypeNode(node, node.modifiers, typeParameters, parameters, type2);
      }, factoryDeprecation);
      ts3.createTypeQueryNode = ts3.Debug.deprecate(ts3.factory.createTypeQueryNode, factoryDeprecation);
      ts3.updateTypeQueryNode = ts3.Debug.deprecate(ts3.factory.updateTypeQueryNode, factoryDeprecation);
      ts3.createTypeLiteralNode = ts3.Debug.deprecate(ts3.factory.createTypeLiteralNode, factoryDeprecation);
      ts3.updateTypeLiteralNode = ts3.Debug.deprecate(ts3.factory.updateTypeLiteralNode, factoryDeprecation);
      ts3.createArrayTypeNode = ts3.Debug.deprecate(ts3.factory.createArrayTypeNode, factoryDeprecation);
      ts3.updateArrayTypeNode = ts3.Debug.deprecate(ts3.factory.updateArrayTypeNode, factoryDeprecation);
      ts3.createTupleTypeNode = ts3.Debug.deprecate(ts3.factory.createTupleTypeNode, factoryDeprecation);
      ts3.updateTupleTypeNode = ts3.Debug.deprecate(ts3.factory.updateTupleTypeNode, factoryDeprecation);
      ts3.createOptionalTypeNode = ts3.Debug.deprecate(ts3.factory.createOptionalTypeNode, factoryDeprecation);
      ts3.updateOptionalTypeNode = ts3.Debug.deprecate(ts3.factory.updateOptionalTypeNode, factoryDeprecation);
      ts3.createRestTypeNode = ts3.Debug.deprecate(ts3.factory.createRestTypeNode, factoryDeprecation);
      ts3.updateRestTypeNode = ts3.Debug.deprecate(ts3.factory.updateRestTypeNode, factoryDeprecation);
      ts3.createUnionTypeNode = ts3.Debug.deprecate(ts3.factory.createUnionTypeNode, factoryDeprecation);
      ts3.updateUnionTypeNode = ts3.Debug.deprecate(ts3.factory.updateUnionTypeNode, factoryDeprecation);
      ts3.createIntersectionTypeNode = ts3.Debug.deprecate(ts3.factory.createIntersectionTypeNode, factoryDeprecation);
      ts3.updateIntersectionTypeNode = ts3.Debug.deprecate(ts3.factory.updateIntersectionTypeNode, factoryDeprecation);
      ts3.createConditionalTypeNode = ts3.Debug.deprecate(ts3.factory.createConditionalTypeNode, factoryDeprecation);
      ts3.updateConditionalTypeNode = ts3.Debug.deprecate(ts3.factory.updateConditionalTypeNode, factoryDeprecation);
      ts3.createInferTypeNode = ts3.Debug.deprecate(ts3.factory.createInferTypeNode, factoryDeprecation);
      ts3.updateInferTypeNode = ts3.Debug.deprecate(ts3.factory.updateInferTypeNode, factoryDeprecation);
      ts3.createImportTypeNode = ts3.Debug.deprecate(ts3.factory.createImportTypeNode, factoryDeprecation);
      ts3.updateImportTypeNode = ts3.Debug.deprecate(ts3.factory.updateImportTypeNode, factoryDeprecation);
      ts3.createParenthesizedType = ts3.Debug.deprecate(ts3.factory.createParenthesizedType, factoryDeprecation);
      ts3.updateParenthesizedType = ts3.Debug.deprecate(ts3.factory.updateParenthesizedType, factoryDeprecation);
      ts3.createThisTypeNode = ts3.Debug.deprecate(ts3.factory.createThisTypeNode, factoryDeprecation);
      ts3.updateTypeOperatorNode = ts3.Debug.deprecate(ts3.factory.updateTypeOperatorNode, factoryDeprecation);
      ts3.createIndexedAccessTypeNode = ts3.Debug.deprecate(ts3.factory.createIndexedAccessTypeNode, factoryDeprecation);
      ts3.updateIndexedAccessTypeNode = ts3.Debug.deprecate(ts3.factory.updateIndexedAccessTypeNode, factoryDeprecation);
      ts3.createMappedTypeNode = ts3.Debug.deprecate(ts3.factory.createMappedTypeNode, factoryDeprecation);
      ts3.updateMappedTypeNode = ts3.Debug.deprecate(ts3.factory.updateMappedTypeNode, factoryDeprecation);
      ts3.createLiteralTypeNode = ts3.Debug.deprecate(ts3.factory.createLiteralTypeNode, factoryDeprecation);
      ts3.updateLiteralTypeNode = ts3.Debug.deprecate(ts3.factory.updateLiteralTypeNode, factoryDeprecation);
      ts3.createObjectBindingPattern = ts3.Debug.deprecate(ts3.factory.createObjectBindingPattern, factoryDeprecation);
      ts3.updateObjectBindingPattern = ts3.Debug.deprecate(ts3.factory.updateObjectBindingPattern, factoryDeprecation);
      ts3.createArrayBindingPattern = ts3.Debug.deprecate(ts3.factory.createArrayBindingPattern, factoryDeprecation);
      ts3.updateArrayBindingPattern = ts3.Debug.deprecate(ts3.factory.updateArrayBindingPattern, factoryDeprecation);
      ts3.createBindingElement = ts3.Debug.deprecate(ts3.factory.createBindingElement, factoryDeprecation);
      ts3.updateBindingElement = ts3.Debug.deprecate(ts3.factory.updateBindingElement, factoryDeprecation);
      ts3.createArrayLiteral = ts3.Debug.deprecate(ts3.factory.createArrayLiteralExpression, factoryDeprecation);
      ts3.updateArrayLiteral = ts3.Debug.deprecate(ts3.factory.updateArrayLiteralExpression, factoryDeprecation);
      ts3.createObjectLiteral = ts3.Debug.deprecate(ts3.factory.createObjectLiteralExpression, factoryDeprecation);
      ts3.updateObjectLiteral = ts3.Debug.deprecate(ts3.factory.updateObjectLiteralExpression, factoryDeprecation);
      ts3.createPropertyAccess = ts3.Debug.deprecate(ts3.factory.createPropertyAccessExpression, factoryDeprecation);
      ts3.updatePropertyAccess = ts3.Debug.deprecate(ts3.factory.updatePropertyAccessExpression, factoryDeprecation);
      ts3.createPropertyAccessChain = ts3.Debug.deprecate(ts3.factory.createPropertyAccessChain, factoryDeprecation);
      ts3.updatePropertyAccessChain = ts3.Debug.deprecate(ts3.factory.updatePropertyAccessChain, factoryDeprecation);
      ts3.createElementAccess = ts3.Debug.deprecate(ts3.factory.createElementAccessExpression, factoryDeprecation);
      ts3.updateElementAccess = ts3.Debug.deprecate(ts3.factory.updateElementAccessExpression, factoryDeprecation);
      ts3.createElementAccessChain = ts3.Debug.deprecate(ts3.factory.createElementAccessChain, factoryDeprecation);
      ts3.updateElementAccessChain = ts3.Debug.deprecate(ts3.factory.updateElementAccessChain, factoryDeprecation);
      ts3.createCall = ts3.Debug.deprecate(ts3.factory.createCallExpression, factoryDeprecation);
      ts3.updateCall = ts3.Debug.deprecate(ts3.factory.updateCallExpression, factoryDeprecation);
      ts3.createCallChain = ts3.Debug.deprecate(ts3.factory.createCallChain, factoryDeprecation);
      ts3.updateCallChain = ts3.Debug.deprecate(ts3.factory.updateCallChain, factoryDeprecation);
      ts3.createNew = ts3.Debug.deprecate(ts3.factory.createNewExpression, factoryDeprecation);
      ts3.updateNew = ts3.Debug.deprecate(ts3.factory.updateNewExpression, factoryDeprecation);
      ts3.createTypeAssertion = ts3.Debug.deprecate(ts3.factory.createTypeAssertion, factoryDeprecation);
      ts3.updateTypeAssertion = ts3.Debug.deprecate(ts3.factory.updateTypeAssertion, factoryDeprecation);
      ts3.createParen = ts3.Debug.deprecate(ts3.factory.createParenthesizedExpression, factoryDeprecation);
      ts3.updateParen = ts3.Debug.deprecate(ts3.factory.updateParenthesizedExpression, factoryDeprecation);
      ts3.createFunctionExpression = ts3.Debug.deprecate(ts3.factory.createFunctionExpression, factoryDeprecation);
      ts3.updateFunctionExpression = ts3.Debug.deprecate(ts3.factory.updateFunctionExpression, factoryDeprecation);
      ts3.createDelete = ts3.Debug.deprecate(ts3.factory.createDeleteExpression, factoryDeprecation);
      ts3.updateDelete = ts3.Debug.deprecate(ts3.factory.updateDeleteExpression, factoryDeprecation);
      ts3.createTypeOf = ts3.Debug.deprecate(ts3.factory.createTypeOfExpression, factoryDeprecation);
      ts3.updateTypeOf = ts3.Debug.deprecate(ts3.factory.updateTypeOfExpression, factoryDeprecation);
      ts3.createVoid = ts3.Debug.deprecate(ts3.factory.createVoidExpression, factoryDeprecation);
      ts3.updateVoid = ts3.Debug.deprecate(ts3.factory.updateVoidExpression, factoryDeprecation);
      ts3.createAwait = ts3.Debug.deprecate(ts3.factory.createAwaitExpression, factoryDeprecation);
      ts3.updateAwait = ts3.Debug.deprecate(ts3.factory.updateAwaitExpression, factoryDeprecation);
      ts3.createPrefix = ts3.Debug.deprecate(ts3.factory.createPrefixUnaryExpression, factoryDeprecation);
      ts3.updatePrefix = ts3.Debug.deprecate(ts3.factory.updatePrefixUnaryExpression, factoryDeprecation);
      ts3.createPostfix = ts3.Debug.deprecate(ts3.factory.createPostfixUnaryExpression, factoryDeprecation);
      ts3.updatePostfix = ts3.Debug.deprecate(ts3.factory.updatePostfixUnaryExpression, factoryDeprecation);
      ts3.createBinary = ts3.Debug.deprecate(ts3.factory.createBinaryExpression, factoryDeprecation);
      ts3.updateConditional = ts3.Debug.deprecate(ts3.factory.updateConditionalExpression, factoryDeprecation);
      ts3.createTemplateExpression = ts3.Debug.deprecate(ts3.factory.createTemplateExpression, factoryDeprecation);
      ts3.updateTemplateExpression = ts3.Debug.deprecate(ts3.factory.updateTemplateExpression, factoryDeprecation);
      ts3.createTemplateHead = ts3.Debug.deprecate(ts3.factory.createTemplateHead, factoryDeprecation);
      ts3.createTemplateMiddle = ts3.Debug.deprecate(ts3.factory.createTemplateMiddle, factoryDeprecation);
      ts3.createTemplateTail = ts3.Debug.deprecate(ts3.factory.createTemplateTail, factoryDeprecation);
      ts3.createNoSubstitutionTemplateLiteral = ts3.Debug.deprecate(ts3.factory.createNoSubstitutionTemplateLiteral, factoryDeprecation);
      ts3.updateYield = ts3.Debug.deprecate(ts3.factory.updateYieldExpression, factoryDeprecation);
      ts3.createSpread = ts3.Debug.deprecate(ts3.factory.createSpreadElement, factoryDeprecation);
      ts3.updateSpread = ts3.Debug.deprecate(ts3.factory.updateSpreadElement, factoryDeprecation);
      ts3.createOmittedExpression = ts3.Debug.deprecate(ts3.factory.createOmittedExpression, factoryDeprecation);
      ts3.createAsExpression = ts3.Debug.deprecate(ts3.factory.createAsExpression, factoryDeprecation);
      ts3.updateAsExpression = ts3.Debug.deprecate(ts3.factory.updateAsExpression, factoryDeprecation);
      ts3.createNonNullExpression = ts3.Debug.deprecate(ts3.factory.createNonNullExpression, factoryDeprecation);
      ts3.updateNonNullExpression = ts3.Debug.deprecate(ts3.factory.updateNonNullExpression, factoryDeprecation);
      ts3.createNonNullChain = ts3.Debug.deprecate(ts3.factory.createNonNullChain, factoryDeprecation);
      ts3.updateNonNullChain = ts3.Debug.deprecate(ts3.factory.updateNonNullChain, factoryDeprecation);
      ts3.createMetaProperty = ts3.Debug.deprecate(ts3.factory.createMetaProperty, factoryDeprecation);
      ts3.updateMetaProperty = ts3.Debug.deprecate(ts3.factory.updateMetaProperty, factoryDeprecation);
      ts3.createTemplateSpan = ts3.Debug.deprecate(ts3.factory.createTemplateSpan, factoryDeprecation);
      ts3.updateTemplateSpan = ts3.Debug.deprecate(ts3.factory.updateTemplateSpan, factoryDeprecation);
      ts3.createSemicolonClassElement = ts3.Debug.deprecate(ts3.factory.createSemicolonClassElement, factoryDeprecation);
      ts3.createBlock = ts3.Debug.deprecate(ts3.factory.createBlock, factoryDeprecation);
      ts3.updateBlock = ts3.Debug.deprecate(ts3.factory.updateBlock, factoryDeprecation);
      ts3.createVariableStatement = ts3.Debug.deprecate(ts3.factory.createVariableStatement, factoryDeprecation);
      ts3.updateVariableStatement = ts3.Debug.deprecate(ts3.factory.updateVariableStatement, factoryDeprecation);
      ts3.createEmptyStatement = ts3.Debug.deprecate(ts3.factory.createEmptyStatement, factoryDeprecation);
      ts3.createExpressionStatement = ts3.Debug.deprecate(ts3.factory.createExpressionStatement, factoryDeprecation);
      ts3.updateExpressionStatement = ts3.Debug.deprecate(ts3.factory.updateExpressionStatement, factoryDeprecation);
      ts3.createStatement = ts3.Debug.deprecate(ts3.factory.createExpressionStatement, factoryDeprecation);
      ts3.updateStatement = ts3.Debug.deprecate(ts3.factory.updateExpressionStatement, factoryDeprecation);
      ts3.createIf = ts3.Debug.deprecate(ts3.factory.createIfStatement, factoryDeprecation);
      ts3.updateIf = ts3.Debug.deprecate(ts3.factory.updateIfStatement, factoryDeprecation);
      ts3.createDo = ts3.Debug.deprecate(ts3.factory.createDoStatement, factoryDeprecation);
      ts3.updateDo = ts3.Debug.deprecate(ts3.factory.updateDoStatement, factoryDeprecation);
      ts3.createWhile = ts3.Debug.deprecate(ts3.factory.createWhileStatement, factoryDeprecation);
      ts3.updateWhile = ts3.Debug.deprecate(ts3.factory.updateWhileStatement, factoryDeprecation);
      ts3.createFor = ts3.Debug.deprecate(ts3.factory.createForStatement, factoryDeprecation);
      ts3.updateFor = ts3.Debug.deprecate(ts3.factory.updateForStatement, factoryDeprecation);
      ts3.createForIn = ts3.Debug.deprecate(ts3.factory.createForInStatement, factoryDeprecation);
      ts3.updateForIn = ts3.Debug.deprecate(ts3.factory.updateForInStatement, factoryDeprecation);
      ts3.createForOf = ts3.Debug.deprecate(ts3.factory.createForOfStatement, factoryDeprecation);
      ts3.updateForOf = ts3.Debug.deprecate(ts3.factory.updateForOfStatement, factoryDeprecation);
      ts3.createContinue = ts3.Debug.deprecate(ts3.factory.createContinueStatement, factoryDeprecation);
      ts3.updateContinue = ts3.Debug.deprecate(ts3.factory.updateContinueStatement, factoryDeprecation);
      ts3.createBreak = ts3.Debug.deprecate(ts3.factory.createBreakStatement, factoryDeprecation);
      ts3.updateBreak = ts3.Debug.deprecate(ts3.factory.updateBreakStatement, factoryDeprecation);
      ts3.createReturn = ts3.Debug.deprecate(ts3.factory.createReturnStatement, factoryDeprecation);
      ts3.updateReturn = ts3.Debug.deprecate(ts3.factory.updateReturnStatement, factoryDeprecation);
      ts3.createWith = ts3.Debug.deprecate(ts3.factory.createWithStatement, factoryDeprecation);
      ts3.updateWith = ts3.Debug.deprecate(ts3.factory.updateWithStatement, factoryDeprecation);
      ts3.createSwitch = ts3.Debug.deprecate(ts3.factory.createSwitchStatement, factoryDeprecation);
      ts3.updateSwitch = ts3.Debug.deprecate(ts3.factory.updateSwitchStatement, factoryDeprecation);
      ts3.createLabel = ts3.Debug.deprecate(ts3.factory.createLabeledStatement, factoryDeprecation);
      ts3.updateLabel = ts3.Debug.deprecate(ts3.factory.updateLabeledStatement, factoryDeprecation);
      ts3.createThrow = ts3.Debug.deprecate(ts3.factory.createThrowStatement, factoryDeprecation);
      ts3.updateThrow = ts3.Debug.deprecate(ts3.factory.updateThrowStatement, factoryDeprecation);
      ts3.createTry = ts3.Debug.deprecate(ts3.factory.createTryStatement, factoryDeprecation);
      ts3.updateTry = ts3.Debug.deprecate(ts3.factory.updateTryStatement, factoryDeprecation);
      ts3.createDebuggerStatement = ts3.Debug.deprecate(ts3.factory.createDebuggerStatement, factoryDeprecation);
      ts3.createVariableDeclarationList = ts3.Debug.deprecate(ts3.factory.createVariableDeclarationList, factoryDeprecation);
      ts3.updateVariableDeclarationList = ts3.Debug.deprecate(ts3.factory.updateVariableDeclarationList, factoryDeprecation);
      ts3.createFunctionDeclaration = ts3.Debug.deprecate(ts3.factory.createFunctionDeclaration, factoryDeprecation);
      ts3.updateFunctionDeclaration = ts3.Debug.deprecate(ts3.factory.updateFunctionDeclaration, factoryDeprecation);
      ts3.createClassDeclaration = ts3.Debug.deprecate(ts3.factory.createClassDeclaration, factoryDeprecation);
      ts3.updateClassDeclaration = ts3.Debug.deprecate(ts3.factory.updateClassDeclaration, factoryDeprecation);
      ts3.createInterfaceDeclaration = ts3.Debug.deprecate(ts3.factory.createInterfaceDeclaration, factoryDeprecation);
      ts3.updateInterfaceDeclaration = ts3.Debug.deprecate(ts3.factory.updateInterfaceDeclaration, factoryDeprecation);
      ts3.createTypeAliasDeclaration = ts3.Debug.deprecate(ts3.factory.createTypeAliasDeclaration, factoryDeprecation);
      ts3.updateTypeAliasDeclaration = ts3.Debug.deprecate(ts3.factory.updateTypeAliasDeclaration, factoryDeprecation);
      ts3.createEnumDeclaration = ts3.Debug.deprecate(ts3.factory.createEnumDeclaration, factoryDeprecation);
      ts3.updateEnumDeclaration = ts3.Debug.deprecate(ts3.factory.updateEnumDeclaration, factoryDeprecation);
      ts3.createModuleDeclaration = ts3.Debug.deprecate(ts3.factory.createModuleDeclaration, factoryDeprecation);
      ts3.updateModuleDeclaration = ts3.Debug.deprecate(ts3.factory.updateModuleDeclaration, factoryDeprecation);
      ts3.createModuleBlock = ts3.Debug.deprecate(ts3.factory.createModuleBlock, factoryDeprecation);
      ts3.updateModuleBlock = ts3.Debug.deprecate(ts3.factory.updateModuleBlock, factoryDeprecation);
      ts3.createCaseBlock = ts3.Debug.deprecate(ts3.factory.createCaseBlock, factoryDeprecation);
      ts3.updateCaseBlock = ts3.Debug.deprecate(ts3.factory.updateCaseBlock, factoryDeprecation);
      ts3.createNamespaceExportDeclaration = ts3.Debug.deprecate(ts3.factory.createNamespaceExportDeclaration, factoryDeprecation);
      ts3.updateNamespaceExportDeclaration = ts3.Debug.deprecate(ts3.factory.updateNamespaceExportDeclaration, factoryDeprecation);
      ts3.createImportEqualsDeclaration = ts3.Debug.deprecate(ts3.factory.createImportEqualsDeclaration, factoryDeprecation);
      ts3.updateImportEqualsDeclaration = ts3.Debug.deprecate(ts3.factory.updateImportEqualsDeclaration, factoryDeprecation);
      ts3.createImportDeclaration = ts3.Debug.deprecate(ts3.factory.createImportDeclaration, factoryDeprecation);
      ts3.updateImportDeclaration = ts3.Debug.deprecate(ts3.factory.updateImportDeclaration, factoryDeprecation);
      ts3.createNamespaceImport = ts3.Debug.deprecate(ts3.factory.createNamespaceImport, factoryDeprecation);
      ts3.updateNamespaceImport = ts3.Debug.deprecate(ts3.factory.updateNamespaceImport, factoryDeprecation);
      ts3.createNamedImports = ts3.Debug.deprecate(ts3.factory.createNamedImports, factoryDeprecation);
      ts3.updateNamedImports = ts3.Debug.deprecate(ts3.factory.updateNamedImports, factoryDeprecation);
      ts3.createImportSpecifier = ts3.Debug.deprecate(ts3.factory.createImportSpecifier, factoryDeprecation);
      ts3.updateImportSpecifier = ts3.Debug.deprecate(ts3.factory.updateImportSpecifier, factoryDeprecation);
      ts3.createExportAssignment = ts3.Debug.deprecate(ts3.factory.createExportAssignment, factoryDeprecation);
      ts3.updateExportAssignment = ts3.Debug.deprecate(ts3.factory.updateExportAssignment, factoryDeprecation);
      ts3.createNamedExports = ts3.Debug.deprecate(ts3.factory.createNamedExports, factoryDeprecation);
      ts3.updateNamedExports = ts3.Debug.deprecate(ts3.factory.updateNamedExports, factoryDeprecation);
      ts3.createExportSpecifier = ts3.Debug.deprecate(ts3.factory.createExportSpecifier, factoryDeprecation);
      ts3.updateExportSpecifier = ts3.Debug.deprecate(ts3.factory.updateExportSpecifier, factoryDeprecation);
      ts3.createExternalModuleReference = ts3.Debug.deprecate(ts3.factory.createExternalModuleReference, factoryDeprecation);
      ts3.updateExternalModuleReference = ts3.Debug.deprecate(ts3.factory.updateExternalModuleReference, factoryDeprecation);
      ts3.createJSDocTypeExpression = ts3.Debug.deprecate(ts3.factory.createJSDocTypeExpression, factoryDeprecation);
      ts3.createJSDocTypeTag = ts3.Debug.deprecate(ts3.factory.createJSDocTypeTag, factoryDeprecation);
      ts3.createJSDocReturnTag = ts3.Debug.deprecate(ts3.factory.createJSDocReturnTag, factoryDeprecation);
      ts3.createJSDocThisTag = ts3.Debug.deprecate(ts3.factory.createJSDocThisTag, factoryDeprecation);
      ts3.createJSDocComment = ts3.Debug.deprecate(ts3.factory.createJSDocComment, factoryDeprecation);
      ts3.createJSDocParameterTag = ts3.Debug.deprecate(ts3.factory.createJSDocParameterTag, factoryDeprecation);
      ts3.createJSDocClassTag = ts3.Debug.deprecate(ts3.factory.createJSDocClassTag, factoryDeprecation);
      ts3.createJSDocAugmentsTag = ts3.Debug.deprecate(ts3.factory.createJSDocAugmentsTag, factoryDeprecation);
      ts3.createJSDocEnumTag = ts3.Debug.deprecate(ts3.factory.createJSDocEnumTag, factoryDeprecation);
      ts3.createJSDocTemplateTag = ts3.Debug.deprecate(ts3.factory.createJSDocTemplateTag, factoryDeprecation);
      ts3.createJSDocTypedefTag = ts3.Debug.deprecate(ts3.factory.createJSDocTypedefTag, factoryDeprecation);
      ts3.createJSDocCallbackTag = ts3.Debug.deprecate(ts3.factory.createJSDocCallbackTag, factoryDeprecation);
      ts3.createJSDocSignature = ts3.Debug.deprecate(ts3.factory.createJSDocSignature, factoryDeprecation);
      ts3.createJSDocPropertyTag = ts3.Debug.deprecate(ts3.factory.createJSDocPropertyTag, factoryDeprecation);
      ts3.createJSDocTypeLiteral = ts3.Debug.deprecate(ts3.factory.createJSDocTypeLiteral, factoryDeprecation);
      ts3.createJSDocImplementsTag = ts3.Debug.deprecate(ts3.factory.createJSDocImplementsTag, factoryDeprecation);
      ts3.createJSDocAuthorTag = ts3.Debug.deprecate(ts3.factory.createJSDocAuthorTag, factoryDeprecation);
      ts3.createJSDocPublicTag = ts3.Debug.deprecate(ts3.factory.createJSDocPublicTag, factoryDeprecation);
      ts3.createJSDocPrivateTag = ts3.Debug.deprecate(ts3.factory.createJSDocPrivateTag, factoryDeprecation);
      ts3.createJSDocProtectedTag = ts3.Debug.deprecate(ts3.factory.createJSDocProtectedTag, factoryDeprecation);
      ts3.createJSDocReadonlyTag = ts3.Debug.deprecate(ts3.factory.createJSDocReadonlyTag, factoryDeprecation);
      ts3.createJSDocTag = ts3.Debug.deprecate(ts3.factory.createJSDocUnknownTag, factoryDeprecation);
      ts3.createJsxElement = ts3.Debug.deprecate(ts3.factory.createJsxElement, factoryDeprecation);
      ts3.updateJsxElement = ts3.Debug.deprecate(ts3.factory.updateJsxElement, factoryDeprecation);
      ts3.createJsxSelfClosingElement = ts3.Debug.deprecate(ts3.factory.createJsxSelfClosingElement, factoryDeprecation);
      ts3.updateJsxSelfClosingElement = ts3.Debug.deprecate(ts3.factory.updateJsxSelfClosingElement, factoryDeprecation);
      ts3.createJsxOpeningElement = ts3.Debug.deprecate(ts3.factory.createJsxOpeningElement, factoryDeprecation);
      ts3.updateJsxOpeningElement = ts3.Debug.deprecate(ts3.factory.updateJsxOpeningElement, factoryDeprecation);
      ts3.createJsxClosingElement = ts3.Debug.deprecate(ts3.factory.createJsxClosingElement, factoryDeprecation);
      ts3.updateJsxClosingElement = ts3.Debug.deprecate(ts3.factory.updateJsxClosingElement, factoryDeprecation);
      ts3.createJsxFragment = ts3.Debug.deprecate(ts3.factory.createJsxFragment, factoryDeprecation);
      ts3.createJsxText = ts3.Debug.deprecate(ts3.factory.createJsxText, factoryDeprecation);
      ts3.updateJsxText = ts3.Debug.deprecate(ts3.factory.updateJsxText, factoryDeprecation);
      ts3.createJsxOpeningFragment = ts3.Debug.deprecate(ts3.factory.createJsxOpeningFragment, factoryDeprecation);
      ts3.createJsxJsxClosingFragment = ts3.Debug.deprecate(ts3.factory.createJsxJsxClosingFragment, factoryDeprecation);
      ts3.updateJsxFragment = ts3.Debug.deprecate(ts3.factory.updateJsxFragment, factoryDeprecation);
      ts3.createJsxAttribute = ts3.Debug.deprecate(ts3.factory.createJsxAttribute, factoryDeprecation);
      ts3.updateJsxAttribute = ts3.Debug.deprecate(ts3.factory.updateJsxAttribute, factoryDeprecation);
      ts3.createJsxAttributes = ts3.Debug.deprecate(ts3.factory.createJsxAttributes, factoryDeprecation);
      ts3.updateJsxAttributes = ts3.Debug.deprecate(ts3.factory.updateJsxAttributes, factoryDeprecation);
      ts3.createJsxSpreadAttribute = ts3.Debug.deprecate(ts3.factory.createJsxSpreadAttribute, factoryDeprecation);
      ts3.updateJsxSpreadAttribute = ts3.Debug.deprecate(ts3.factory.updateJsxSpreadAttribute, factoryDeprecation);
      ts3.createJsxExpression = ts3.Debug.deprecate(ts3.factory.createJsxExpression, factoryDeprecation);
      ts3.updateJsxExpression = ts3.Debug.deprecate(ts3.factory.updateJsxExpression, factoryDeprecation);
      ts3.createCaseClause = ts3.Debug.deprecate(ts3.factory.createCaseClause, factoryDeprecation);
      ts3.updateCaseClause = ts3.Debug.deprecate(ts3.factory.updateCaseClause, factoryDeprecation);
      ts3.createDefaultClause = ts3.Debug.deprecate(ts3.factory.createDefaultClause, factoryDeprecation);
      ts3.updateDefaultClause = ts3.Debug.deprecate(ts3.factory.updateDefaultClause, factoryDeprecation);
      ts3.createHeritageClause = ts3.Debug.deprecate(ts3.factory.createHeritageClause, factoryDeprecation);
      ts3.updateHeritageClause = ts3.Debug.deprecate(ts3.factory.updateHeritageClause, factoryDeprecation);
      ts3.createCatchClause = ts3.Debug.deprecate(ts3.factory.createCatchClause, factoryDeprecation);
      ts3.updateCatchClause = ts3.Debug.deprecate(ts3.factory.updateCatchClause, factoryDeprecation);
      ts3.createPropertyAssignment = ts3.Debug.deprecate(ts3.factory.createPropertyAssignment, factoryDeprecation);
      ts3.updatePropertyAssignment = ts3.Debug.deprecate(ts3.factory.updatePropertyAssignment, factoryDeprecation);
      ts3.createShorthandPropertyAssignment = ts3.Debug.deprecate(ts3.factory.createShorthandPropertyAssignment, factoryDeprecation);
      ts3.updateShorthandPropertyAssignment = ts3.Debug.deprecate(ts3.factory.updateShorthandPropertyAssignment, factoryDeprecation);
      ts3.createSpreadAssignment = ts3.Debug.deprecate(ts3.factory.createSpreadAssignment, factoryDeprecation);
      ts3.updateSpreadAssignment = ts3.Debug.deprecate(ts3.factory.updateSpreadAssignment, factoryDeprecation);
      ts3.createEnumMember = ts3.Debug.deprecate(ts3.factory.createEnumMember, factoryDeprecation);
      ts3.updateEnumMember = ts3.Debug.deprecate(ts3.factory.updateEnumMember, factoryDeprecation);
      ts3.updateSourceFileNode = ts3.Debug.deprecate(ts3.factory.updateSourceFile, factoryDeprecation);
      ts3.createNotEmittedStatement = ts3.Debug.deprecate(ts3.factory.createNotEmittedStatement, factoryDeprecation);
      ts3.createPartiallyEmittedExpression = ts3.Debug.deprecate(ts3.factory.createPartiallyEmittedExpression, factoryDeprecation);
      ts3.updatePartiallyEmittedExpression = ts3.Debug.deprecate(ts3.factory.updatePartiallyEmittedExpression, factoryDeprecation);
      ts3.createCommaList = ts3.Debug.deprecate(ts3.factory.createCommaListExpression, factoryDeprecation);
      ts3.updateCommaList = ts3.Debug.deprecate(ts3.factory.updateCommaListExpression, factoryDeprecation);
      ts3.createBundle = ts3.Debug.deprecate(ts3.factory.createBundle, factoryDeprecation);
      ts3.updateBundle = ts3.Debug.deprecate(ts3.factory.updateBundle, factoryDeprecation);
      ts3.createImmediatelyInvokedFunctionExpression = ts3.Debug.deprecate(ts3.factory.createImmediatelyInvokedFunctionExpression, factoryDeprecation);
      ts3.createImmediatelyInvokedArrowFunction = ts3.Debug.deprecate(ts3.factory.createImmediatelyInvokedArrowFunction, factoryDeprecation);
      ts3.createVoidZero = ts3.Debug.deprecate(ts3.factory.createVoidZero, factoryDeprecation);
      ts3.createExportDefault = ts3.Debug.deprecate(ts3.factory.createExportDefault, factoryDeprecation);
      ts3.createExternalModuleExport = ts3.Debug.deprecate(ts3.factory.createExternalModuleExport, factoryDeprecation);
      ts3.createNamespaceExport = ts3.Debug.deprecate(ts3.factory.createNamespaceExport, factoryDeprecation);
      ts3.updateNamespaceExport = ts3.Debug.deprecate(ts3.factory.updateNamespaceExport, factoryDeprecation);
      ts3.createToken = ts3.Debug.deprecate(function createToken(kind) {
        return ts3.factory.createToken(kind);
      }, factoryDeprecation);
      ts3.createIdentifier = ts3.Debug.deprecate(function createIdentifier(text) {
        return ts3.factory.createIdentifier(text, void 0, void 0);
      }, factoryDeprecation);
      ts3.createTempVariable = ts3.Debug.deprecate(function createTempVariable(recordTempVariable) {
        return ts3.factory.createTempVariable(recordTempVariable, void 0);
      }, factoryDeprecation);
      ts3.getGeneratedNameForNode = ts3.Debug.deprecate(function getGeneratedNameForNode(node) {
        return ts3.factory.getGeneratedNameForNode(node, void 0);
      }, factoryDeprecation);
      ts3.createOptimisticUniqueName = ts3.Debug.deprecate(function createOptimisticUniqueName(text) {
        return ts3.factory.createUniqueName(text, 16);
      }, factoryDeprecation);
      ts3.createFileLevelUniqueName = ts3.Debug.deprecate(function createFileLevelUniqueName(text) {
        return ts3.factory.createUniqueName(text, 16 | 32);
      }, factoryDeprecation);
      ts3.createIndexSignature = ts3.Debug.deprecate(function createIndexSignature(decorators, modifiers, parameters, type2) {
        return ts3.factory.createIndexSignature(decorators, modifiers, parameters, type2);
      }, factoryDeprecation);
      ts3.createTypePredicateNode = ts3.Debug.deprecate(function createTypePredicateNode(parameterName, type2) {
        return ts3.factory.createTypePredicateNode(void 0, parameterName, type2);
      }, factoryDeprecation);
      ts3.updateTypePredicateNode = ts3.Debug.deprecate(function updateTypePredicateNode(node, parameterName, type2) {
        return ts3.factory.updateTypePredicateNode(node, void 0, parameterName, type2);
      }, factoryDeprecation);
      ts3.createLiteral = ts3.Debug.deprecate(function createLiteral(value) {
        if (typeof value === "number") {
          return ts3.factory.createNumericLiteral(value);
        }
        if (typeof value === "object" && "base10Value" in value) {
          return ts3.factory.createBigIntLiteral(value);
        }
        if (typeof value === "boolean") {
          return value ? ts3.factory.createTrue() : ts3.factory.createFalse();
        }
        if (typeof value === "string") {
          return ts3.factory.createStringLiteral(value, void 0);
        }
        return ts3.factory.createStringLiteralFromNode(value);
      }, { since: "4.0", warnAfter: "4.1", message: "Use `factory.createStringLiteral`, `factory.createStringLiteralFromNode`, `factory.createNumericLiteral`, `factory.createBigIntLiteral`, `factory.createTrue`, `factory.createFalse`, or the factory supplied by your transformation context instead." });
      ts3.createMethodSignature = ts3.Debug.deprecate(function createMethodSignature(typeParameters, parameters, type2, name, questionToken) {
        return ts3.factory.createMethodSignature(void 0, name, questionToken, typeParameters, parameters, type2);
      }, factoryDeprecation);
      ts3.updateMethodSignature = ts3.Debug.deprecate(function updateMethodSignature(node, typeParameters, parameters, type2, name, questionToken) {
        return ts3.factory.updateMethodSignature(node, node.modifiers, name, questionToken, typeParameters, parameters, type2);
      }, factoryDeprecation);
      ts3.createTypeOperatorNode = ts3.Debug.deprecate(function createTypeOperatorNode(operatorOrType, type2) {
        var operator;
        if (type2) {
          operator = operatorOrType;
        } else {
          type2 = operatorOrType;
          operator = 140;
        }
        return ts3.factory.createTypeOperatorNode(operator, type2);
      }, factoryDeprecation);
      ts3.createTaggedTemplate = ts3.Debug.deprecate(function createTaggedTemplate(tag, typeArgumentsOrTemplate, template) {
        var typeArguments;
        if (template) {
          typeArguments = typeArgumentsOrTemplate;
        } else {
          template = typeArgumentsOrTemplate;
        }
        return ts3.factory.createTaggedTemplateExpression(tag, typeArguments, template);
      }, factoryDeprecation);
      ts3.updateTaggedTemplate = ts3.Debug.deprecate(function updateTaggedTemplate(node, tag, typeArgumentsOrTemplate, template) {
        var typeArguments;
        if (template) {
          typeArguments = typeArgumentsOrTemplate;
        } else {
          template = typeArgumentsOrTemplate;
        }
        return ts3.factory.updateTaggedTemplateExpression(node, tag, typeArguments, template);
      }, factoryDeprecation);
      ts3.updateBinary = ts3.Debug.deprecate(function updateBinary(node, left, right, operator) {
        if (operator === void 0) {
          operator = node.operatorToken;
        }
        if (typeof operator === "number") {
          operator = operator === node.operatorToken.kind ? node.operatorToken : ts3.factory.createToken(operator);
        }
        return ts3.factory.updateBinaryExpression(node, left, operator, right);
      }, factoryDeprecation);
      ts3.createConditional = ts3.Debug.deprecate(function createConditional(condition, questionTokenOrWhenTrue, whenTrueOrWhenFalse, colonToken, whenFalse) {
        return arguments.length === 5 ? ts3.factory.createConditionalExpression(condition, questionTokenOrWhenTrue, whenTrueOrWhenFalse, colonToken, whenFalse) : arguments.length === 3 ? ts3.factory.createConditionalExpression(condition, ts3.factory.createToken(57), questionTokenOrWhenTrue, ts3.factory.createToken(58), whenTrueOrWhenFalse) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.createYield = ts3.Debug.deprecate(function createYield(asteriskTokenOrExpression, expression) {
        var asteriskToken;
        if (expression) {
          asteriskToken = asteriskTokenOrExpression;
        } else {
          expression = asteriskTokenOrExpression;
        }
        return ts3.factory.createYieldExpression(asteriskToken, expression);
      }, factoryDeprecation);
      ts3.createClassExpression = ts3.Debug.deprecate(function createClassExpression(modifiers, name, typeParameters, heritageClauses, members) {
        return ts3.factory.createClassExpression(void 0, modifiers, name, typeParameters, heritageClauses, members);
      }, factoryDeprecation);
      ts3.updateClassExpression = ts3.Debug.deprecate(function updateClassExpression(node, modifiers, name, typeParameters, heritageClauses, members) {
        return ts3.factory.updateClassExpression(node, void 0, modifiers, name, typeParameters, heritageClauses, members);
      }, factoryDeprecation);
      ts3.createPropertySignature = ts3.Debug.deprecate(function createPropertySignature(modifiers, name, questionToken, type2, initializer) {
        var node = ts3.factory.createPropertySignature(modifiers, name, questionToken, type2);
        node.initializer = initializer;
        return node;
      }, factoryDeprecation);
      ts3.updatePropertySignature = ts3.Debug.deprecate(function updatePropertySignature(node, modifiers, name, questionToken, type2, initializer) {
        var updated = ts3.factory.updatePropertySignature(node, modifiers, name, questionToken, type2);
        if (node.initializer !== initializer) {
          if (updated === node) {
            updated = ts3.factory.cloneNode(node);
          }
          updated.initializer = initializer;
        }
        return updated;
      }, factoryDeprecation);
      ts3.createExpressionWithTypeArguments = ts3.Debug.deprecate(function createExpressionWithTypeArguments(typeArguments, expression) {
        return ts3.factory.createExpressionWithTypeArguments(expression, typeArguments);
      }, factoryDeprecation);
      ts3.updateExpressionWithTypeArguments = ts3.Debug.deprecate(function updateExpressionWithTypeArguments(node, typeArguments, expression) {
        return ts3.factory.updateExpressionWithTypeArguments(node, expression, typeArguments);
      }, factoryDeprecation);
      ts3.createArrowFunction = ts3.Debug.deprecate(function createArrowFunction(modifiers, typeParameters, parameters, type2, equalsGreaterThanTokenOrBody, body) {
        return arguments.length === 6 ? ts3.factory.createArrowFunction(modifiers, typeParameters, parameters, type2, equalsGreaterThanTokenOrBody, body) : arguments.length === 5 ? ts3.factory.createArrowFunction(modifiers, typeParameters, parameters, type2, void 0, equalsGreaterThanTokenOrBody) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.updateArrowFunction = ts3.Debug.deprecate(function updateArrowFunction(node, modifiers, typeParameters, parameters, type2, equalsGreaterThanTokenOrBody, body) {
        return arguments.length === 7 ? ts3.factory.updateArrowFunction(node, modifiers, typeParameters, parameters, type2, equalsGreaterThanTokenOrBody, body) : arguments.length === 6 ? ts3.factory.updateArrowFunction(node, modifiers, typeParameters, parameters, type2, node.equalsGreaterThanToken, equalsGreaterThanTokenOrBody) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.createVariableDeclaration = ts3.Debug.deprecate(function createVariableDeclaration(name, exclamationTokenOrType, typeOrInitializer, initializer) {
        return arguments.length === 4 ? ts3.factory.createVariableDeclaration(name, exclamationTokenOrType, typeOrInitializer, initializer) : arguments.length >= 1 && arguments.length <= 3 ? ts3.factory.createVariableDeclaration(name, void 0, exclamationTokenOrType, typeOrInitializer) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.updateVariableDeclaration = ts3.Debug.deprecate(function updateVariableDeclaration(node, name, exclamationTokenOrType, typeOrInitializer, initializer) {
        return arguments.length === 5 ? ts3.factory.updateVariableDeclaration(node, name, exclamationTokenOrType, typeOrInitializer, initializer) : arguments.length === 4 ? ts3.factory.updateVariableDeclaration(node, name, node.exclamationToken, exclamationTokenOrType, typeOrInitializer) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.createImportClause = ts3.Debug.deprecate(function createImportClause(name, namedBindings, isTypeOnly) {
        if (isTypeOnly === void 0) {
          isTypeOnly = false;
        }
        return ts3.factory.createImportClause(isTypeOnly, name, namedBindings);
      }, factoryDeprecation);
      ts3.updateImportClause = ts3.Debug.deprecate(function updateImportClause(node, name, namedBindings, isTypeOnly) {
        return ts3.factory.updateImportClause(node, isTypeOnly, name, namedBindings);
      }, factoryDeprecation);
      ts3.createExportDeclaration = ts3.Debug.deprecate(function createExportDeclaration(decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly) {
        if (isTypeOnly === void 0) {
          isTypeOnly = false;
        }
        return ts3.factory.createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier);
      }, factoryDeprecation);
      ts3.updateExportDeclaration = ts3.Debug.deprecate(function updateExportDeclaration(node, decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly) {
        return ts3.factory.updateExportDeclaration(node, decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier, node.assertClause);
      }, factoryDeprecation);
      ts3.createJSDocParamTag = ts3.Debug.deprecate(function createJSDocParamTag(name, isBracketed, typeExpression, comment) {
        return ts3.factory.createJSDocParameterTag(void 0, name, isBracketed, typeExpression, false, comment ? ts3.factory.createNodeArray([ts3.factory.createJSDocText(comment)]) : void 0);
      }, factoryDeprecation);
      ts3.createComma = ts3.Debug.deprecate(function createComma(left, right) {
        return ts3.factory.createComma(left, right);
      }, factoryDeprecation);
      ts3.createLessThan = ts3.Debug.deprecate(function createLessThan(left, right) {
        return ts3.factory.createLessThan(left, right);
      }, factoryDeprecation);
      ts3.createAssignment = ts3.Debug.deprecate(function createAssignment(left, right) {
        return ts3.factory.createAssignment(left, right);
      }, factoryDeprecation);
      ts3.createStrictEquality = ts3.Debug.deprecate(function createStrictEquality(left, right) {
        return ts3.factory.createStrictEquality(left, right);
      }, factoryDeprecation);
      ts3.createStrictInequality = ts3.Debug.deprecate(function createStrictInequality(left, right) {
        return ts3.factory.createStrictInequality(left, right);
      }, factoryDeprecation);
      ts3.createAdd = ts3.Debug.deprecate(function createAdd(left, right) {
        return ts3.factory.createAdd(left, right);
      }, factoryDeprecation);
      ts3.createSubtract = ts3.Debug.deprecate(function createSubtract(left, right) {
        return ts3.factory.createSubtract(left, right);
      }, factoryDeprecation);
      ts3.createLogicalAnd = ts3.Debug.deprecate(function createLogicalAnd(left, right) {
        return ts3.factory.createLogicalAnd(left, right);
      }, factoryDeprecation);
      ts3.createLogicalOr = ts3.Debug.deprecate(function createLogicalOr(left, right) {
        return ts3.factory.createLogicalOr(left, right);
      }, factoryDeprecation);
      ts3.createPostfixIncrement = ts3.Debug.deprecate(function createPostfixIncrement(operand) {
        return ts3.factory.createPostfixIncrement(operand);
      }, factoryDeprecation);
      ts3.createLogicalNot = ts3.Debug.deprecate(function createLogicalNot(operand) {
        return ts3.factory.createLogicalNot(operand);
      }, factoryDeprecation);
      ts3.createNode = ts3.Debug.deprecate(function createNode(kind, pos, end) {
        if (pos === void 0) {
          pos = 0;
        }
        if (end === void 0) {
          end = 0;
        }
        return ts3.setTextRangePosEnd(kind === 305 ? ts3.parseBaseNodeFactory.createBaseSourceFileNode(kind) : kind === 79 ? ts3.parseBaseNodeFactory.createBaseIdentifierNode(kind) : kind === 80 ? ts3.parseBaseNodeFactory.createBasePrivateIdentifierNode(kind) : !ts3.isNodeKind(kind) ? ts3.parseBaseNodeFactory.createBaseTokenNode(kind) : ts3.parseBaseNodeFactory.createBaseNode(kind), pos, end);
      }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory` method instead." });
      ts3.getMutableClone = ts3.Debug.deprecate(function getMutableClone(node) {
        var clone = ts3.factory.cloneNode(node);
        ts3.setTextRange(clone, node);
        ts3.setParent(clone, node.parent);
        return clone;
      }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory.update...` method instead, use `setCommentRange` or `setSourceMapRange`, and avoid setting `parent`." });
      ts3.isTypeAssertion = ts3.Debug.deprecate(function isTypeAssertion(node) {
        return node.kind === 211;
      }, {
        since: "4.0",
        warnAfter: "4.1",
        message: "Use `isTypeAssertionExpression` instead."
      });
      ts3.isIdentifierOrPrivateIdentifier = ts3.Debug.deprecate(function isIdentifierOrPrivateIdentifier(node) {
        return ts3.isMemberName(node);
      }, {
        since: "4.2",
        warnAfter: "4.3",
        message: "Use `isMemberName` instead."
      });
    })(ts2 || (ts2 = {}));
  }
});

// node_modules/.pnpm/heap@0.2.7/node_modules/heap/lib/heap.js
var require_heap = __commonJS({
  "node_modules/.pnpm/heap@0.2.7/node_modules/heap/lib/heap.js"(exports, module2) {
    (function() {
      var Heap, defaultCmp, floor, heapify, heappop, heappush, heappushpop, heapreplace, insort, min, nlargest, nsmallest, updateItem, _siftdown, _siftup;
      floor = Math.floor, min = Math.min;
      defaultCmp = function(x, y) {
        if (x < y) {
          return -1;
        }
        if (x > y) {
          return 1;
        }
        return 0;
      };
      insort = function(a, x, lo, hi, cmp) {
        var mid;
        if (lo == null) {
          lo = 0;
        }
        if (cmp == null) {
          cmp = defaultCmp;
        }
        if (lo < 0) {
          throw new Error("lo must be non-negative");
        }
        if (hi == null) {
          hi = a.length;
        }
        while (lo < hi) {
          mid = floor((lo + hi) / 2);
          if (cmp(x, a[mid]) < 0) {
            hi = mid;
          } else {
            lo = mid + 1;
          }
        }
        return [].splice.apply(a, [lo, lo - lo].concat(x)), x;
      };
      heappush = function(array, item, cmp) {
        if (cmp == null) {
          cmp = defaultCmp;
        }
        array.push(item);
        return _siftdown(array, 0, array.length - 1, cmp);
      };
      heappop = function(array, cmp) {
        var lastelt, returnitem;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        lastelt = array.pop();
        if (array.length) {
          returnitem = array[0];
          array[0] = lastelt;
          _siftup(array, 0, cmp);
        } else {
          returnitem = lastelt;
        }
        return returnitem;
      };
      heapreplace = function(array, item, cmp) {
        var returnitem;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        returnitem = array[0];
        array[0] = item;
        _siftup(array, 0, cmp);
        return returnitem;
      };
      heappushpop = function(array, item, cmp) {
        var _ref;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        if (array.length && cmp(array[0], item) < 0) {
          _ref = [array[0], item], item = _ref[0], array[0] = _ref[1];
          _siftup(array, 0, cmp);
        }
        return item;
      };
      heapify = function(array, cmp) {
        var i, _i, _j, _len, _ref, _ref1, _results, _results1;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        _ref1 = function() {
          _results1 = [];
          for (var _j2 = 0, _ref2 = floor(array.length / 2); 0 <= _ref2 ? _j2 < _ref2 : _j2 > _ref2; 0 <= _ref2 ? _j2++ : _j2--) {
            _results1.push(_j2);
          }
          return _results1;
        }.apply(this).reverse();
        _results = [];
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          i = _ref1[_i];
          _results.push(_siftup(array, i, cmp));
        }
        return _results;
      };
      updateItem = function(array, item, cmp) {
        var pos;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        pos = array.indexOf(item);
        if (pos === -1) {
          return;
        }
        _siftdown(array, 0, pos, cmp);
        return _siftup(array, pos, cmp);
      };
      nlargest = function(array, n, cmp) {
        var elem, result2, _i, _len, _ref;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        result2 = array.slice(0, n);
        if (!result2.length) {
          return result2;
        }
        heapify(result2, cmp);
        _ref = array.slice(n);
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          elem = _ref[_i];
          heappushpop(result2, elem, cmp);
        }
        return result2.sort(cmp).reverse();
      };
      nsmallest = function(array, n, cmp) {
        var elem, i, los, result2, _i, _j, _len, _ref, _ref1, _results;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        if (n * 10 <= array.length) {
          result2 = array.slice(0, n).sort(cmp);
          if (!result2.length) {
            return result2;
          }
          los = result2[result2.length - 1];
          _ref = array.slice(n);
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            elem = _ref[_i];
            if (cmp(elem, los) < 0) {
              insort(result2, elem, 0, null, cmp);
              result2.pop();
              los = result2[result2.length - 1];
            }
          }
          return result2;
        }
        heapify(array, cmp);
        _results = [];
        for (i = _j = 0, _ref1 = min(n, array.length); 0 <= _ref1 ? _j < _ref1 : _j > _ref1; i = 0 <= _ref1 ? ++_j : --_j) {
          _results.push(heappop(array, cmp));
        }
        return _results;
      };
      _siftdown = function(array, startpos, pos, cmp) {
        var newitem, parent, parentpos;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        newitem = array[pos];
        while (pos > startpos) {
          parentpos = pos - 1 >> 1;
          parent = array[parentpos];
          if (cmp(newitem, parent) < 0) {
            array[pos] = parent;
            pos = parentpos;
            continue;
          }
          break;
        }
        return array[pos] = newitem;
      };
      _siftup = function(array, pos, cmp) {
        var childpos, endpos, newitem, rightpos, startpos;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        endpos = array.length;
        startpos = pos;
        newitem = array[pos];
        childpos = 2 * pos + 1;
        while (childpos < endpos) {
          rightpos = childpos + 1;
          if (rightpos < endpos && !(cmp(array[childpos], array[rightpos]) < 0)) {
            childpos = rightpos;
          }
          array[pos] = array[childpos];
          pos = childpos;
          childpos = 2 * pos + 1;
        }
        array[pos] = newitem;
        return _siftdown(array, startpos, pos, cmp);
      };
      Heap = function() {
        Heap2.push = heappush;
        Heap2.pop = heappop;
        Heap2.replace = heapreplace;
        Heap2.pushpop = heappushpop;
        Heap2.heapify = heapify;
        Heap2.updateItem = updateItem;
        Heap2.nlargest = nlargest;
        Heap2.nsmallest = nsmallest;
        function Heap2(cmp) {
          this.cmp = cmp != null ? cmp : defaultCmp;
          this.nodes = [];
        }
        Heap2.prototype.push = function(x) {
          return heappush(this.nodes, x, this.cmp);
        };
        Heap2.prototype.pop = function() {
          return heappop(this.nodes, this.cmp);
        };
        Heap2.prototype.peek = function() {
          return this.nodes[0];
        };
        Heap2.prototype.contains = function(x) {
          return this.nodes.indexOf(x) !== -1;
        };
        Heap2.prototype.replace = function(x) {
          return heapreplace(this.nodes, x, this.cmp);
        };
        Heap2.prototype.pushpop = function(x) {
          return heappushpop(this.nodes, x, this.cmp);
        };
        Heap2.prototype.heapify = function() {
          return heapify(this.nodes, this.cmp);
        };
        Heap2.prototype.updateItem = function(x) {
          return updateItem(this.nodes, x, this.cmp);
        };
        Heap2.prototype.clear = function() {
          return this.nodes = [];
        };
        Heap2.prototype.empty = function() {
          return this.nodes.length === 0;
        };
        Heap2.prototype.size = function() {
          return this.nodes.length;
        };
        Heap2.prototype.clone = function() {
          var heap;
          heap = new Heap2();
          heap.nodes = this.nodes.slice(0);
          return heap;
        };
        Heap2.prototype.toArray = function() {
          return this.nodes.slice(0);
        };
        Heap2.prototype.insert = Heap2.prototype.push;
        Heap2.prototype.top = Heap2.prototype.peek;
        Heap2.prototype.front = Heap2.prototype.peek;
        Heap2.prototype.has = Heap2.prototype.contains;
        Heap2.prototype.copy = Heap2.prototype.clone;
        return Heap2;
      }();
      (function(root, factory) {
        if (typeof define === "function" && define.amd) {
          return define([], factory);
        } else if (typeof exports === "object") {
          return module2.exports = factory();
        } else {
          return root.Heap = factory();
        }
      })(this, function() {
        return Heap;
      });
    }).call(exports);
  }
});

// node_modules/.pnpm/heap@0.2.7/node_modules/heap/index.js
var require_heap2 = __commonJS({
  "node_modules/.pnpm/heap@0.2.7/node_modules/heap/index.js"(exports, module2) {
    module2.exports = require_heap();
  }
});

// node_modules/.pnpm/difflib@0.2.4/node_modules/difflib/lib/difflib.js
var require_difflib = __commonJS({
  "node_modules/.pnpm/difflib@0.2.4/node_modules/difflib/lib/difflib.js"(exports) {
    (function() {
      var Differ, Heap, IS_CHARACTER_JUNK, IS_LINE_JUNK, SequenceMatcher, assert, contextDiff, floor, getCloseMatches, max, min, ndiff, restore, unifiedDiff, _any, _arrayCmp, _calculateRatio, _countLeading, _formatRangeContext, _formatRangeUnified, _has, __indexOf = [].indexOf || function(item) {
        for (var i = 0, l = this.length; i < l; i++) {
          if (i in this && this[i] === item)
            return i;
        }
        return -1;
      };
      floor = Math.floor, max = Math.max, min = Math.min;
      Heap = require_heap2();
      assert = require("assert");
      _calculateRatio = function(matches, length) {
        if (length) {
          return 2 * matches / length;
        } else {
          return 1;
        }
      };
      _arrayCmp = function(a, b) {
        var i, la, lb, _i, _ref, _ref1;
        _ref = [a.length, b.length], la = _ref[0], lb = _ref[1];
        for (i = _i = 0, _ref1 = min(la, lb); 0 <= _ref1 ? _i < _ref1 : _i > _ref1; i = 0 <= _ref1 ? ++_i : --_i) {
          if (a[i] < b[i]) {
            return -1;
          }
          if (a[i] > b[i]) {
            return 1;
          }
        }
        return la - lb;
      };
      _has = function(obj, key) {
        return Object.prototype.hasOwnProperty.call(obj, key);
      };
      _any = function(items) {
        var item, _i, _len;
        for (_i = 0, _len = items.length; _i < _len; _i++) {
          item = items[_i];
          if (item) {
            return true;
          }
        }
        return false;
      };
      SequenceMatcher = function() {
        SequenceMatcher2.name = "SequenceMatcher";
        function SequenceMatcher2(isjunk, a, b, autojunk) {
          this.isjunk = isjunk;
          if (a == null) {
            a = "";
          }
          if (b == null) {
            b = "";
          }
          this.autojunk = autojunk != null ? autojunk : true;
          this.a = this.b = null;
          this.setSeqs(a, b);
        }
        SequenceMatcher2.prototype.setSeqs = function(a, b) {
          this.setSeq1(a);
          return this.setSeq2(b);
        };
        SequenceMatcher2.prototype.setSeq1 = function(a) {
          if (a === this.a) {
            return;
          }
          this.a = a;
          return this.matchingBlocks = this.opcodes = null;
        };
        SequenceMatcher2.prototype.setSeq2 = function(b) {
          if (b === this.b) {
            return;
          }
          this.b = b;
          this.matchingBlocks = this.opcodes = null;
          this.fullbcount = null;
          return this._chainB();
        };
        SequenceMatcher2.prototype._chainB = function() {
          var b, b2j, elt, i, idxs, indices, isjunk, junk, n, ntest, popular, _i, _j, _len, _len1, _ref;
          b = this.b;
          this.b2j = b2j = {};
          for (i = _i = 0, _len = b.length; _i < _len; i = ++_i) {
            elt = b[i];
            indices = _has(b2j, elt) ? b2j[elt] : b2j[elt] = [];
            indices.push(i);
          }
          junk = {};
          isjunk = this.isjunk;
          if (isjunk) {
            _ref = Object.keys(b2j);
            for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
              elt = _ref[_j];
              if (isjunk(elt)) {
                junk[elt] = true;
                delete b2j[elt];
              }
            }
          }
          popular = {};
          n = b.length;
          if (this.autojunk && n >= 200) {
            ntest = floor(n / 100) + 1;
            for (elt in b2j) {
              idxs = b2j[elt];
              if (idxs.length > ntest) {
                popular[elt] = true;
                delete b2j[elt];
              }
            }
          }
          this.isbjunk = function(b2) {
            return _has(junk, b2);
          };
          return this.isbpopular = function(b2) {
            return _has(popular, b2);
          };
        };
        SequenceMatcher2.prototype.findLongestMatch = function(alo, ahi, blo, bhi) {
          var a, b, b2j, besti, bestj, bestsize, i, isbjunk, j, j2len, k, newj2len, _i, _j, _len, _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
          _ref = [this.a, this.b, this.b2j, this.isbjunk], a = _ref[0], b = _ref[1], b2j = _ref[2], isbjunk = _ref[3];
          _ref1 = [alo, blo, 0], besti = _ref1[0], bestj = _ref1[1], bestsize = _ref1[2];
          j2len = {};
          for (i = _i = alo; alo <= ahi ? _i < ahi : _i > ahi; i = alo <= ahi ? ++_i : --_i) {
            newj2len = {};
            _ref2 = _has(b2j, a[i]) ? b2j[a[i]] : [];
            for (_j = 0, _len = _ref2.length; _j < _len; _j++) {
              j = _ref2[_j];
              if (j < blo) {
                continue;
              }
              if (j >= bhi) {
                break;
              }
              k = newj2len[j] = (j2len[j - 1] || 0) + 1;
              if (k > bestsize) {
                _ref3 = [i - k + 1, j - k + 1, k], besti = _ref3[0], bestj = _ref3[1], bestsize = _ref3[2];
              }
            }
            j2len = newj2len;
          }
          while (besti > alo && bestj > blo && !isbjunk(b[bestj - 1]) && a[besti - 1] === b[bestj - 1]) {
            _ref4 = [besti - 1, bestj - 1, bestsize + 1], besti = _ref4[0], bestj = _ref4[1], bestsize = _ref4[2];
          }
          while (besti + bestsize < ahi && bestj + bestsize < bhi && !isbjunk(b[bestj + bestsize]) && a[besti + bestsize] === b[bestj + bestsize]) {
            bestsize++;
          }
          while (besti > alo && bestj > blo && isbjunk(b[bestj - 1]) && a[besti - 1] === b[bestj - 1]) {
            _ref5 = [besti - 1, bestj - 1, bestsize + 1], besti = _ref5[0], bestj = _ref5[1], bestsize = _ref5[2];
          }
          while (besti + bestsize < ahi && bestj + bestsize < bhi && isbjunk(b[bestj + bestsize]) && a[besti + bestsize] === b[bestj + bestsize]) {
            bestsize++;
          }
          return [besti, bestj, bestsize];
        };
        SequenceMatcher2.prototype.getMatchingBlocks = function() {
          var ahi, alo, bhi, blo, i, i1, i2, j, j1, j2, k, k1, k2, la, lb, matchingBlocks, nonAdjacent, queue, x, _i, _len, _ref, _ref1, _ref2, _ref3, _ref4;
          if (this.matchingBlocks) {
            return this.matchingBlocks;
          }
          _ref = [this.a.length, this.b.length], la = _ref[0], lb = _ref[1];
          queue = [[0, la, 0, lb]];
          matchingBlocks = [];
          while (queue.length) {
            _ref1 = queue.pop(), alo = _ref1[0], ahi = _ref1[1], blo = _ref1[2], bhi = _ref1[3];
            _ref2 = x = this.findLongestMatch(alo, ahi, blo, bhi), i = _ref2[0], j = _ref2[1], k = _ref2[2];
            if (k) {
              matchingBlocks.push(x);
              if (alo < i && blo < j) {
                queue.push([alo, i, blo, j]);
              }
              if (i + k < ahi && j + k < bhi) {
                queue.push([i + k, ahi, j + k, bhi]);
              }
            }
          }
          matchingBlocks.sort(_arrayCmp);
          i1 = j1 = k1 = 0;
          nonAdjacent = [];
          for (_i = 0, _len = matchingBlocks.length; _i < _len; _i++) {
            _ref3 = matchingBlocks[_i], i2 = _ref3[0], j2 = _ref3[1], k2 = _ref3[2];
            if (i1 + k1 === i2 && j1 + k1 === j2) {
              k1 += k2;
            } else {
              if (k1) {
                nonAdjacent.push([i1, j1, k1]);
              }
              _ref4 = [i2, j2, k2], i1 = _ref4[0], j1 = _ref4[1], k1 = _ref4[2];
            }
          }
          if (k1) {
            nonAdjacent.push([i1, j1, k1]);
          }
          nonAdjacent.push([la, lb, 0]);
          return this.matchingBlocks = nonAdjacent;
        };
        SequenceMatcher2.prototype.getOpcodes = function() {
          var ai, answer, bj, i, j, size, tag, _i, _len, _ref, _ref1, _ref2;
          if (this.opcodes) {
            return this.opcodes;
          }
          i = j = 0;
          this.opcodes = answer = [];
          _ref = this.getMatchingBlocks();
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            _ref1 = _ref[_i], ai = _ref1[0], bj = _ref1[1], size = _ref1[2];
            tag = "";
            if (i < ai && j < bj) {
              tag = "replace";
            } else if (i < ai) {
              tag = "delete";
            } else if (j < bj) {
              tag = "insert";
            }
            if (tag) {
              answer.push([tag, i, ai, j, bj]);
            }
            _ref2 = [ai + size, bj + size], i = _ref2[0], j = _ref2[1];
            if (size) {
              answer.push(["equal", ai, i, bj, j]);
            }
          }
          return answer;
        };
        SequenceMatcher2.prototype.getGroupedOpcodes = function(n) {
          var codes, group, groups, i1, i2, j1, j2, nn, tag, _i, _len, _ref, _ref1, _ref2, _ref3;
          if (n == null) {
            n = 3;
          }
          codes = this.getOpcodes();
          if (!codes.length) {
            codes = [["equal", 0, 1, 0, 1]];
          }
          if (codes[0][0] === "equal") {
            _ref = codes[0], tag = _ref[0], i1 = _ref[1], i2 = _ref[2], j1 = _ref[3], j2 = _ref[4];
            codes[0] = [tag, max(i1, i2 - n), i2, max(j1, j2 - n), j2];
          }
          if (codes[codes.length - 1][0] === "equal") {
            _ref1 = codes[codes.length - 1], tag = _ref1[0], i1 = _ref1[1], i2 = _ref1[2], j1 = _ref1[3], j2 = _ref1[4];
            codes[codes.length - 1] = [tag, i1, min(i2, i1 + n), j1, min(j2, j1 + n)];
          }
          nn = n + n;
          groups = [];
          group = [];
          for (_i = 0, _len = codes.length; _i < _len; _i++) {
            _ref2 = codes[_i], tag = _ref2[0], i1 = _ref2[1], i2 = _ref2[2], j1 = _ref2[3], j2 = _ref2[4];
            if (tag === "equal" && i2 - i1 > nn) {
              group.push([tag, i1, min(i2, i1 + n), j1, min(j2, j1 + n)]);
              groups.push(group);
              group = [];
              _ref3 = [max(i1, i2 - n), max(j1, j2 - n)], i1 = _ref3[0], j1 = _ref3[1];
            }
            group.push([tag, i1, i2, j1, j2]);
          }
          if (group.length && !(group.length === 1 && group[0][0] === "equal")) {
            groups.push(group);
          }
          return groups;
        };
        SequenceMatcher2.prototype.ratio = function() {
          var match, matches, _i, _len, _ref;
          matches = 0;
          _ref = this.getMatchingBlocks();
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            match = _ref[_i];
            matches += match[2];
          }
          return _calculateRatio(matches, this.a.length + this.b.length);
        };
        SequenceMatcher2.prototype.quickRatio = function() {
          var avail, elt, fullbcount, matches, numb, _i, _j, _len, _len1, _ref, _ref1;
          if (!this.fullbcount) {
            this.fullbcount = fullbcount = {};
            _ref = this.b;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              elt = _ref[_i];
              fullbcount[elt] = (fullbcount[elt] || 0) + 1;
            }
          }
          fullbcount = this.fullbcount;
          avail = {};
          matches = 0;
          _ref1 = this.a;
          for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
            elt = _ref1[_j];
            if (_has(avail, elt)) {
              numb = avail[elt];
            } else {
              numb = fullbcount[elt] || 0;
            }
            avail[elt] = numb - 1;
            if (numb > 0) {
              matches++;
            }
          }
          return _calculateRatio(matches, this.a.length + this.b.length);
        };
        SequenceMatcher2.prototype.realQuickRatio = function() {
          var la, lb, _ref;
          _ref = [this.a.length, this.b.length], la = _ref[0], lb = _ref[1];
          return _calculateRatio(min(la, lb), la + lb);
        };
        return SequenceMatcher2;
      }();
      getCloseMatches = function(word, possibilities, n, cutoff) {
        var result2, s, score, x, _i, _j, _len, _len1, _ref, _results;
        if (n == null) {
          n = 3;
        }
        if (cutoff == null) {
          cutoff = 0.6;
        }
        if (!(n > 0)) {
          throw new Error("n must be > 0: (" + n + ")");
        }
        if (!(0 <= cutoff && cutoff <= 1)) {
          throw new Error("cutoff must be in [0.0, 1.0]: (" + cutoff + ")");
        }
        result2 = [];
        s = new SequenceMatcher();
        s.setSeq2(word);
        for (_i = 0, _len = possibilities.length; _i < _len; _i++) {
          x = possibilities[_i];
          s.setSeq1(x);
          if (s.realQuickRatio() >= cutoff && s.quickRatio() >= cutoff && s.ratio() >= cutoff) {
            result2.push([s.ratio(), x]);
          }
        }
        result2 = Heap.nlargest(result2, n, _arrayCmp);
        _results = [];
        for (_j = 0, _len1 = result2.length; _j < _len1; _j++) {
          _ref = result2[_j], score = _ref[0], x = _ref[1];
          _results.push(x);
        }
        return _results;
      };
      _countLeading = function(line, ch) {
        var i, n, _ref;
        _ref = [0, line.length], i = _ref[0], n = _ref[1];
        while (i < n && line[i] === ch) {
          i++;
        }
        return i;
      };
      Differ = function() {
        Differ2.name = "Differ";
        function Differ2(linejunk, charjunk) {
          this.linejunk = linejunk;
          this.charjunk = charjunk;
        }
        Differ2.prototype.compare = function(a, b) {
          var ahi, alo, bhi, blo, cruncher, g, line, lines, tag, _i, _j, _len, _len1, _ref, _ref1;
          cruncher = new SequenceMatcher(this.linejunk, a, b);
          lines = [];
          _ref = cruncher.getOpcodes();
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            _ref1 = _ref[_i], tag = _ref1[0], alo = _ref1[1], ahi = _ref1[2], blo = _ref1[3], bhi = _ref1[4];
            switch (tag) {
              case "replace":
                g = this._fancyReplace(a, alo, ahi, b, blo, bhi);
                break;
              case "delete":
                g = this._dump("-", a, alo, ahi);
                break;
              case "insert":
                g = this._dump("+", b, blo, bhi);
                break;
              case "equal":
                g = this._dump(" ", a, alo, ahi);
                break;
              default:
                throw new Error("unknow tag (" + tag + ")");
            }
            for (_j = 0, _len1 = g.length; _j < _len1; _j++) {
              line = g[_j];
              lines.push(line);
            }
          }
          return lines;
        };
        Differ2.prototype._dump = function(tag, x, lo, hi) {
          var i, _i, _results;
          _results = [];
          for (i = _i = lo; lo <= hi ? _i < hi : _i > hi; i = lo <= hi ? ++_i : --_i) {
            _results.push("" + tag + " " + x[i]);
          }
          return _results;
        };
        Differ2.prototype._plainReplace = function(a, alo, ahi, b, blo, bhi) {
          var first, g, line, lines, second, _i, _j, _len, _len1, _ref;
          assert(alo < ahi && blo < bhi);
          if (bhi - blo < ahi - alo) {
            first = this._dump("+", b, blo, bhi);
            second = this._dump("-", a, alo, ahi);
          } else {
            first = this._dump("-", a, alo, ahi);
            second = this._dump("+", b, blo, bhi);
          }
          lines = [];
          _ref = [first, second];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            g = _ref[_i];
            for (_j = 0, _len1 = g.length; _j < _len1; _j++) {
              line = g[_j];
              lines.push(line);
            }
          }
          return lines;
        };
        Differ2.prototype._fancyReplace = function(a, alo, ahi, b, blo, bhi) {
          var aelt, ai, ai1, ai2, atags, belt, bestRatio, besti, bestj, bj, bj1, bj2, btags, cruncher, cutoff, eqi, eqj, i, j, la, lb, line, lines, tag, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _n, _o, _ref, _ref1, _ref10, _ref11, _ref12, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
          _ref = [0.74, 0.75], bestRatio = _ref[0], cutoff = _ref[1];
          cruncher = new SequenceMatcher(this.charjunk);
          _ref1 = [null, null], eqi = _ref1[0], eqj = _ref1[1];
          lines = [];
          for (j = _i = blo; blo <= bhi ? _i < bhi : _i > bhi; j = blo <= bhi ? ++_i : --_i) {
            bj = b[j];
            cruncher.setSeq2(bj);
            for (i = _j = alo; alo <= ahi ? _j < ahi : _j > ahi; i = alo <= ahi ? ++_j : --_j) {
              ai = a[i];
              if (ai === bj) {
                if (eqi === null) {
                  _ref2 = [i, j], eqi = _ref2[0], eqj = _ref2[1];
                }
                continue;
              }
              cruncher.setSeq1(ai);
              if (cruncher.realQuickRatio() > bestRatio && cruncher.quickRatio() > bestRatio && cruncher.ratio() > bestRatio) {
                _ref3 = [cruncher.ratio(), i, j], bestRatio = _ref3[0], besti = _ref3[1], bestj = _ref3[2];
              }
            }
          }
          if (bestRatio < cutoff) {
            if (eqi === null) {
              _ref4 = this._plainReplace(a, alo, ahi, b, blo, bhi);
              for (_k = 0, _len = _ref4.length; _k < _len; _k++) {
                line = _ref4[_k];
                lines.push(line);
              }
              return lines;
            }
            _ref5 = [eqi, eqj, 1], besti = _ref5[0], bestj = _ref5[1], bestRatio = _ref5[2];
          } else {
            eqi = null;
          }
          _ref6 = this._fancyHelper(a, alo, besti, b, blo, bestj);
          for (_l = 0, _len1 = _ref6.length; _l < _len1; _l++) {
            line = _ref6[_l];
            lines.push(line);
          }
          _ref7 = [a[besti], b[bestj]], aelt = _ref7[0], belt = _ref7[1];
          if (eqi === null) {
            atags = btags = "";
            cruncher.setSeqs(aelt, belt);
            _ref8 = cruncher.getOpcodes();
            for (_m = 0, _len2 = _ref8.length; _m < _len2; _m++) {
              _ref9 = _ref8[_m], tag = _ref9[0], ai1 = _ref9[1], ai2 = _ref9[2], bj1 = _ref9[3], bj2 = _ref9[4];
              _ref10 = [ai2 - ai1, bj2 - bj1], la = _ref10[0], lb = _ref10[1];
              switch (tag) {
                case "replace":
                  atags += Array(la + 1).join("^");
                  btags += Array(lb + 1).join("^");
                  break;
                case "delete":
                  atags += Array(la + 1).join("-");
                  break;
                case "insert":
                  btags += Array(lb + 1).join("+");
                  break;
                case "equal":
                  atags += Array(la + 1).join(" ");
                  btags += Array(lb + 1).join(" ");
                  break;
                default:
                  throw new Error("unknow tag (" + tag + ")");
              }
            }
            _ref11 = this._qformat(aelt, belt, atags, btags);
            for (_n = 0, _len3 = _ref11.length; _n < _len3; _n++) {
              line = _ref11[_n];
              lines.push(line);
            }
          } else {
            lines.push("  " + aelt);
          }
          _ref12 = this._fancyHelper(a, besti + 1, ahi, b, bestj + 1, bhi);
          for (_o = 0, _len4 = _ref12.length; _o < _len4; _o++) {
            line = _ref12[_o];
            lines.push(line);
          }
          return lines;
        };
        Differ2.prototype._fancyHelper = function(a, alo, ahi, b, blo, bhi) {
          var g;
          g = [];
          if (alo < ahi) {
            if (blo < bhi) {
              g = this._fancyReplace(a, alo, ahi, b, blo, bhi);
            } else {
              g = this._dump("-", a, alo, ahi);
            }
          } else if (blo < bhi) {
            g = this._dump("+", b, blo, bhi);
          }
          return g;
        };
        Differ2.prototype._qformat = function(aline, bline, atags, btags) {
          var common2, lines;
          lines = [];
          common2 = min(_countLeading(aline, "	"), _countLeading(bline, "	"));
          common2 = min(common2, _countLeading(atags.slice(0, common2), " "));
          common2 = min(common2, _countLeading(btags.slice(0, common2), " "));
          atags = atags.slice(common2).replace(/\s+$/, "");
          btags = btags.slice(common2).replace(/\s+$/, "");
          lines.push("- " + aline);
          if (atags.length) {
            lines.push("? " + Array(common2 + 1).join("	") + atags + "\n");
          }
          lines.push("+ " + bline);
          if (btags.length) {
            lines.push("? " + Array(common2 + 1).join("	") + btags + "\n");
          }
          return lines;
        };
        return Differ2;
      }();
      IS_LINE_JUNK = function(line, pat) {
        if (pat == null) {
          pat = /^\s*#?\s*$/;
        }
        return pat.test(line);
      };
      IS_CHARACTER_JUNK = function(ch, ws) {
        if (ws == null) {
          ws = " 	";
        }
        return __indexOf.call(ws, ch) >= 0;
      };
      _formatRangeUnified = function(start, stop) {
        var beginning, length;
        beginning = start + 1;
        length = stop - start;
        if (length === 1) {
          return "" + beginning;
        }
        if (!length) {
          beginning--;
        }
        return "" + beginning + "," + length;
      };
      unifiedDiff = function(a, b, _arg) {
        var file1Range, file2Range, first, fromdate, fromfile, fromfiledate, group, i1, i2, j1, j2, last, line, lines, lineterm, n, started, tag, todate, tofile, tofiledate, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
        _ref = _arg != null ? _arg : {}, fromfile = _ref.fromfile, tofile = _ref.tofile, fromfiledate = _ref.fromfiledate, tofiledate = _ref.tofiledate, n = _ref.n, lineterm = _ref.lineterm;
        if (fromfile == null) {
          fromfile = "";
        }
        if (tofile == null) {
          tofile = "";
        }
        if (fromfiledate == null) {
          fromfiledate = "";
        }
        if (tofiledate == null) {
          tofiledate = "";
        }
        if (n == null) {
          n = 3;
        }
        if (lineterm == null) {
          lineterm = "\n";
        }
        lines = [];
        started = false;
        _ref1 = new SequenceMatcher(null, a, b).getGroupedOpcodes();
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          group = _ref1[_i];
          if (!started) {
            started = true;
            fromdate = fromfiledate ? "	" + fromfiledate : "";
            todate = tofiledate ? "	" + tofiledate : "";
            lines.push("--- " + fromfile + fromdate + lineterm);
            lines.push("+++ " + tofile + todate + lineterm);
          }
          _ref2 = [group[0], group[group.length - 1]], first = _ref2[0], last = _ref2[1];
          file1Range = _formatRangeUnified(first[1], last[2]);
          file2Range = _formatRangeUnified(first[3], last[4]);
          lines.push("@@ -" + file1Range + " +" + file2Range + " @@" + lineterm);
          for (_j = 0, _len1 = group.length; _j < _len1; _j++) {
            _ref3 = group[_j], tag = _ref3[0], i1 = _ref3[1], i2 = _ref3[2], j1 = _ref3[3], j2 = _ref3[4];
            if (tag === "equal") {
              _ref4 = a.slice(i1, i2);
              for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
                line = _ref4[_k];
                lines.push(" " + line);
              }
              continue;
            }
            if (tag === "replace" || tag === "delete") {
              _ref5 = a.slice(i1, i2);
              for (_l = 0, _len3 = _ref5.length; _l < _len3; _l++) {
                line = _ref5[_l];
                lines.push("-" + line);
              }
            }
            if (tag === "replace" || tag === "insert") {
              _ref6 = b.slice(j1, j2);
              for (_m = 0, _len4 = _ref6.length; _m < _len4; _m++) {
                line = _ref6[_m];
                lines.push("+" + line);
              }
            }
          }
        }
        return lines;
      };
      _formatRangeContext = function(start, stop) {
        var beginning, length;
        beginning = start + 1;
        length = stop - start;
        if (!length) {
          beginning--;
        }
        if (length <= 1) {
          return "" + beginning;
        }
        return "" + beginning + "," + (beginning + length - 1);
      };
      contextDiff = function(a, b, _arg) {
        var file1Range, file2Range, first, fromdate, fromfile, fromfiledate, group, i1, i2, j1, j2, last, line, lines, lineterm, n, prefix, started, tag, todate, tofile, tofiledate, _, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
        _ref = _arg != null ? _arg : {}, fromfile = _ref.fromfile, tofile = _ref.tofile, fromfiledate = _ref.fromfiledate, tofiledate = _ref.tofiledate, n = _ref.n, lineterm = _ref.lineterm;
        if (fromfile == null) {
          fromfile = "";
        }
        if (tofile == null) {
          tofile = "";
        }
        if (fromfiledate == null) {
          fromfiledate = "";
        }
        if (tofiledate == null) {
          tofiledate = "";
        }
        if (n == null) {
          n = 3;
        }
        if (lineterm == null) {
          lineterm = "\n";
        }
        prefix = {
          insert: "+ ",
          "delete": "- ",
          replace: "! ",
          equal: "  "
        };
        started = false;
        lines = [];
        _ref1 = new SequenceMatcher(null, a, b).getGroupedOpcodes();
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          group = _ref1[_i];
          if (!started) {
            started = true;
            fromdate = fromfiledate ? "	" + fromfiledate : "";
            todate = tofiledate ? "	" + tofiledate : "";
            lines.push("*** " + fromfile + fromdate + lineterm);
            lines.push("--- " + tofile + todate + lineterm);
            _ref2 = [group[0], group[group.length - 1]], first = _ref2[0], last = _ref2[1];
            lines.push("***************" + lineterm);
            file1Range = _formatRangeContext(first[1], last[2]);
            lines.push("*** " + file1Range + " ****" + lineterm);
            if (_any(function() {
              var _j2, _len12, _ref32, _results;
              _results = [];
              for (_j2 = 0, _len12 = group.length; _j2 < _len12; _j2++) {
                _ref32 = group[_j2], tag = _ref32[0], _ = _ref32[1], _ = _ref32[2], _ = _ref32[3], _ = _ref32[4];
                _results.push(tag === "replace" || tag === "delete");
              }
              return _results;
            }())) {
              for (_j = 0, _len1 = group.length; _j < _len1; _j++) {
                _ref3 = group[_j], tag = _ref3[0], i1 = _ref3[1], i2 = _ref3[2], _ = _ref3[3], _ = _ref3[4];
                if (tag !== "insert") {
                  _ref4 = a.slice(i1, i2);
                  for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
                    line = _ref4[_k];
                    lines.push(prefix[tag] + line);
                  }
                }
              }
            }
            file2Range = _formatRangeContext(first[3], last[4]);
            lines.push("--- " + file2Range + " ----" + lineterm);
            if (_any(function() {
              var _l2, _len32, _ref52, _results;
              _results = [];
              for (_l2 = 0, _len32 = group.length; _l2 < _len32; _l2++) {
                _ref52 = group[_l2], tag = _ref52[0], _ = _ref52[1], _ = _ref52[2], _ = _ref52[3], _ = _ref52[4];
                _results.push(tag === "replace" || tag === "insert");
              }
              return _results;
            }())) {
              for (_l = 0, _len3 = group.length; _l < _len3; _l++) {
                _ref5 = group[_l], tag = _ref5[0], _ = _ref5[1], _ = _ref5[2], j1 = _ref5[3], j2 = _ref5[4];
                if (tag !== "delete") {
                  _ref6 = b.slice(j1, j2);
                  for (_m = 0, _len4 = _ref6.length; _m < _len4; _m++) {
                    line = _ref6[_m];
                    lines.push(prefix[tag] + line);
                  }
                }
              }
            }
          }
        }
        return lines;
      };
      ndiff = function(a, b, linejunk, charjunk) {
        if (charjunk == null) {
          charjunk = IS_CHARACTER_JUNK;
        }
        return new Differ(linejunk, charjunk).compare(a, b);
      };
      restore = function(delta, which) {
        var line, lines, prefixes, tag, _i, _len, _ref;
        tag = {
          1: "- ",
          2: "+ "
        }[which];
        if (!tag) {
          throw new Error("unknow delta choice (must be 1 or 2): " + which);
        }
        prefixes = ["  ", tag];
        lines = [];
        for (_i = 0, _len = delta.length; _i < _len; _i++) {
          line = delta[_i];
          if (_ref = line.slice(0, 2), __indexOf.call(prefixes, _ref) >= 0) {
            lines.push(line.slice(2));
          }
        }
        return lines;
      };
      exports._arrayCmp = _arrayCmp;
      exports.SequenceMatcher = SequenceMatcher;
      exports.getCloseMatches = getCloseMatches;
      exports._countLeading = _countLeading;
      exports.Differ = Differ;
      exports.IS_LINE_JUNK = IS_LINE_JUNK;
      exports.IS_CHARACTER_JUNK = IS_CHARACTER_JUNK;
      exports._formatRangeUnified = _formatRangeUnified;
      exports.unifiedDiff = unifiedDiff;
      exports._formatRangeContext = _formatRangeContext;
      exports.contextDiff = contextDiff;
      exports.ndiff = ndiff;
      exports.restore = restore;
    }).call(exports);
  }
});

// node_modules/.pnpm/difflib@0.2.4/node_modules/difflib/index.js
var require_difflib2 = __commonJS({
  "node_modules/.pnpm/difflib@0.2.4/node_modules/difflib/index.js"(exports, module2) {
    module2.exports = require_difflib();
  }
});

// node_modules/.pnpm/json-diff@0.9.0/node_modules/json-diff/lib/util.js
var require_util2 = __commonJS({
  "node_modules/.pnpm/json-diff@0.9.0/node_modules/json-diff/lib/util.js"(exports, module2) {
    var extendedTypeOf = function(obj) {
      const result2 = typeof obj;
      if (obj == null) {
        return "null";
      } else if (result2 === "object" && obj.constructor === Array) {
        return "array";
      } else {
        return result2;
      }
    };
    var roundObj = function(data, precision) {
      const type2 = typeof data;
      if (type2 === "array") {
        return data.map((x) => roundObj(x, precision));
      } else if (type2 === "object") {
        for (const key in data) {
          data[key] = roundObj(data[key], precision);
        }
        return data;
      } else if (type2 === "number" && Number.isFinite(data) && !Number.isInteger(data)) {
        return +data.toFixed(precision);
      } else {
        return data;
      }
    };
    module2.exports = { extendedTypeOf, roundObj };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/value/is.js
var require_is = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/value/is.js"(exports, module2) {
    "use strict";
    var _undefined = void 0;
    module2.exports = function(value) {
      return value !== _undefined && value !== null;
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/object/is.js
var require_is2 = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/object/is.js"(exports, module2) {
    "use strict";
    var isValue = require_is();
    var possibleTypes = { "object": true, "function": true, "undefined": true };
    module2.exports = function(value) {
      if (!isValue(value))
        return false;
      return hasOwnProperty.call(possibleTypes, typeof value);
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/prototype/is.js
var require_is3 = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/prototype/is.js"(exports, module2) {
    "use strict";
    var isObject2 = require_is2();
    module2.exports = function(value) {
      if (!isObject2(value))
        return false;
      try {
        if (!value.constructor)
          return false;
        return value.constructor.prototype === value;
      } catch (error) {
        return false;
      }
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/function/is.js
var require_is4 = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/function/is.js"(exports, module2) {
    "use strict";
    var isPrototype = require_is3();
    module2.exports = function(value) {
      if (typeof value !== "function")
        return false;
      if (!hasOwnProperty.call(value, "length"))
        return false;
      try {
        if (typeof value.length !== "number")
          return false;
        if (typeof value.call !== "function")
          return false;
        if (typeof value.apply !== "function")
          return false;
      } catch (error) {
        return false;
      }
      return !isPrototype(value);
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/plain-function/is.js
var require_is5 = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/plain-function/is.js"(exports, module2) {
    "use strict";
    var isFunction = require_is4();
    var classRe = /^\s*class[\s{/}]/;
    var functionToString = Function.prototype.toString;
    module2.exports = function(value) {
      if (!isFunction(value))
        return false;
      if (classRe.test(functionToString.call(value)))
        return false;
      return true;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/assign/is-implemented.js
var require_is_implemented = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/assign/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      var assign3 = Object.assign, obj;
      if (typeof assign3 !== "function")
        return false;
      obj = { foo: "raz" };
      assign3(obj, { bar: "dwa" }, { trzy: "trzy" });
      return obj.foo + obj.bar + obj.trzy === "razdwatrzy";
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/keys/is-implemented.js
var require_is_implemented2 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/keys/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      try {
        Object.keys("primitive");
        return true;
      } catch (e) {
        return false;
      }
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/noop.js
var require_noop = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/noop.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-value.js
var require_is_value = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-value.js"(exports, module2) {
    "use strict";
    var _undefined = require_noop()();
    module2.exports = function(val) {
      return val !== _undefined && val !== null;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/keys/shim.js
var require_shim = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/keys/shim.js"(exports, module2) {
    "use strict";
    var isValue = require_is_value();
    var keys = Object.keys;
    module2.exports = function(object2) {
      return keys(isValue(object2) ? Object(object2) : object2);
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/keys/index.js
var require_keys = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/keys/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented2()() ? Object.keys : require_shim();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/valid-value.js
var require_valid_value = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/valid-value.js"(exports, module2) {
    "use strict";
    var isValue = require_is_value();
    module2.exports = function(value) {
      if (!isValue(value))
        throw new TypeError("Cannot use null or undefined");
      return value;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/assign/shim.js
var require_shim2 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/assign/shim.js"(exports, module2) {
    "use strict";
    var keys = require_keys();
    var value = require_valid_value();
    var max = Math.max;
    module2.exports = function(dest, src) {
      var error, i, length = max(arguments.length, 2), assign3;
      dest = Object(value(dest));
      assign3 = function(key) {
        try {
          dest[key] = src[key];
        } catch (e) {
          if (!error)
            error = e;
        }
      };
      for (i = 1; i < length; ++i) {
        src = arguments[i];
        keys(src).forEach(assign3);
      }
      if (error !== void 0)
        throw error;
      return dest;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/assign/index.js
var require_assign = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/assign/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented()() ? Object.assign : require_shim2();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/normalize-options.js
var require_normalize_options = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/normalize-options.js"(exports, module2) {
    "use strict";
    var isValue = require_is_value();
    var forEach = Array.prototype.forEach;
    var create = Object.create;
    var process2 = function(src, obj) {
      var key;
      for (key in src)
        obj[key] = src[key];
    };
    module2.exports = function(opts1) {
      var result2 = create(null);
      forEach.call(arguments, function(options) {
        if (!isValue(options))
          return;
        process2(Object(options), result2);
      });
      return result2;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/contains/is-implemented.js
var require_is_implemented3 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/contains/is-implemented.js"(exports, module2) {
    "use strict";
    var str2 = "razdwatrzy";
    module2.exports = function() {
      if (typeof str2.contains !== "function")
        return false;
      return str2.contains("dwa") === true && str2.contains("foo") === false;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/contains/shim.js
var require_shim3 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/contains/shim.js"(exports, module2) {
    "use strict";
    var indexOf = String.prototype.indexOf;
    module2.exports = function(searchString) {
      return indexOf.call(this, searchString, arguments[1]) > -1;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/contains/index.js
var require_contains = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/contains/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented3()() ? String.prototype.contains : require_shim3();
  }
});

// node_modules/.pnpm/d@1.0.1/node_modules/d/index.js
var require_d = __commonJS({
  "node_modules/.pnpm/d@1.0.1/node_modules/d/index.js"(exports, module2) {
    "use strict";
    var isValue = require_is();
    var isPlainFunction = require_is5();
    var assign3 = require_assign();
    var normalizeOpts = require_normalize_options();
    var contains = require_contains();
    var d = module2.exports = function(dscr, value) {
      var c, e, w, options, desc;
      if (arguments.length < 2 || typeof dscr !== "string") {
        options = value;
        value = dscr;
        dscr = null;
      } else {
        options = arguments[2];
      }
      if (isValue(dscr)) {
        c = contains.call(dscr, "c");
        e = contains.call(dscr, "e");
        w = contains.call(dscr, "w");
      } else {
        c = w = true;
        e = false;
      }
      desc = { value, configurable: c, enumerable: e, writable: w };
      return !options ? desc : assign3(normalizeOpts(options), desc);
    };
    d.gs = function(dscr, get, set2) {
      var c, e, options, desc;
      if (typeof dscr !== "string") {
        options = set2;
        set2 = get;
        get = dscr;
        dscr = null;
      } else {
        options = arguments[3];
      }
      if (!isValue(get)) {
        get = void 0;
      } else if (!isPlainFunction(get)) {
        options = get;
        get = set2 = void 0;
      } else if (!isValue(set2)) {
        set2 = void 0;
      } else if (!isPlainFunction(set2)) {
        options = set2;
        set2 = void 0;
      }
      if (isValue(dscr)) {
        c = contains.call(dscr, "c");
        e = contains.call(dscr, "e");
      } else {
        c = true;
        e = false;
      }
      desc = { get, set: set2, configurable: c, enumerable: e };
      return !options ? desc : assign3(normalizeOpts(options), desc);
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/valid-callable.js
var require_valid_callable = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/valid-callable.js"(exports, module2) {
    "use strict";
    module2.exports = function(fn) {
      if (typeof fn !== "function")
        throw new TypeError(fn + " is not a function");
      return fn;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/_iterate.js
var require_iterate = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/_iterate.js"(exports, module2) {
    "use strict";
    var callable = require_valid_callable();
    var value = require_valid_value();
    var bind = Function.prototype.bind;
    var call = Function.prototype.call;
    var keys = Object.keys;
    var objPropertyIsEnumerable = Object.prototype.propertyIsEnumerable;
    module2.exports = function(method, defVal) {
      return function(obj, cb) {
        var list, thisArg = arguments[2], compareFn = arguments[3];
        obj = Object(value(obj));
        callable(cb);
        list = keys(obj);
        if (compareFn) {
          list.sort(typeof compareFn === "function" ? bind.call(compareFn, obj) : void 0);
        }
        if (typeof method !== "function")
          method = list[method];
        return call.call(method, list, function(key, index) {
          if (!objPropertyIsEnumerable.call(obj, key))
            return defVal;
          return call.call(cb, thisArg, obj[key], key, obj, index);
        });
      };
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/for-each.js
var require_for_each = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/for-each.js"(exports, module2) {
    "use strict";
    module2.exports = require_iterate()("forEach");
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/map.js
var require_map = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/map.js"(exports, module2) {
    "use strict";
    var callable = require_valid_callable();
    var forEach = require_for_each();
    var call = Function.prototype.call;
    module2.exports = function(obj, cb) {
      var result2 = {}, thisArg = arguments[2];
      callable(cb);
      forEach(obj, function(value, key, targetObj, index) {
        result2[key] = call.call(cb, thisArg, value, key, targetObj, index);
      });
      return result2;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/primitive-set.js
var require_primitive_set = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/primitive-set.js"(exports, module2) {
    "use strict";
    var forEach = Array.prototype.forEach;
    var create = Object.create;
    module2.exports = function(arg) {
      var set2 = create(null);
      forEach.call(arguments, function(name) {
        set2[name] = true;
      });
      return set2;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/set-prototype-of/is-implemented.js
var require_is_implemented4 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/set-prototype-of/is-implemented.js"(exports, module2) {
    "use strict";
    var create = Object.create;
    var getPrototypeOf = Object.getPrototypeOf;
    var plainObject = {};
    module2.exports = function() {
      var setPrototypeOf = Object.setPrototypeOf, customCreate = arguments[0] || create;
      if (typeof setPrototypeOf !== "function")
        return false;
      return getPrototypeOf(setPrototypeOf(customCreate(null), plainObject)) === plainObject;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-object.js
var require_is_object = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-object.js"(exports, module2) {
    "use strict";
    var isValue = require_is_value();
    var map2 = { function: true, object: true };
    module2.exports = function(value) {
      return isValue(value) && map2[typeof value] || false;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/create.js
var require_create = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/create.js"(exports, module2) {
    "use strict";
    var create = Object.create;
    var shim;
    if (!require_is_implemented4()()) {
      shim = require_shim4();
    }
    module2.exports = function() {
      var nullObject, polyProps, desc;
      if (!shim)
        return create;
      if (shim.level !== 1)
        return create;
      nullObject = {};
      polyProps = {};
      desc = { configurable: false, enumerable: false, writable: true, value: void 0 };
      Object.getOwnPropertyNames(Object.prototype).forEach(function(name) {
        if (name === "__proto__") {
          polyProps[name] = {
            configurable: true,
            enumerable: false,
            writable: true,
            value: void 0
          };
          return;
        }
        polyProps[name] = desc;
      });
      Object.defineProperties(nullObject, polyProps);
      Object.defineProperty(shim, "nullPolyfill", {
        configurable: false,
        enumerable: false,
        writable: false,
        value: nullObject
      });
      return function(prototype, props) {
        return create(prototype === null ? nullObject : prototype, props);
      };
    }();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/set-prototype-of/shim.js
var require_shim4 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/set-prototype-of/shim.js"(exports, module2) {
    "use strict";
    var isObject2 = require_is_object();
    var value = require_valid_value();
    var objIsPrototypeOf = Object.prototype.isPrototypeOf;
    var defineProperty = Object.defineProperty;
    var nullDesc = { configurable: true, enumerable: false, writable: true, value: void 0 };
    var validate;
    validate = function(obj, prototype) {
      value(obj);
      if (prototype === null || isObject2(prototype))
        return obj;
      throw new TypeError("Prototype must be null or an object");
    };
    module2.exports = function(status) {
      var fn, set2;
      if (!status)
        return null;
      if (status.level === 2) {
        if (status.set) {
          set2 = status.set;
          fn = function(obj, prototype) {
            set2.call(validate(obj, prototype), prototype);
            return obj;
          };
        } else {
          fn = function(obj, prototype) {
            validate(obj, prototype).__proto__ = prototype;
            return obj;
          };
        }
      } else {
        fn = function self2(obj, prototype) {
          var isNullBase;
          validate(obj, prototype);
          isNullBase = objIsPrototypeOf.call(self2.nullPolyfill, obj);
          if (isNullBase)
            delete self2.nullPolyfill.__proto__;
          if (prototype === null)
            prototype = self2.nullPolyfill;
          obj.__proto__ = prototype;
          if (isNullBase)
            defineProperty(self2.nullPolyfill, "__proto__", nullDesc);
          return obj;
        };
      }
      return Object.defineProperty(fn, "level", {
        configurable: false,
        enumerable: false,
        writable: false,
        value: status.level
      });
    }(function() {
      var tmpObj1 = /* @__PURE__ */ Object.create(null), tmpObj2 = {}, set2, desc = Object.getOwnPropertyDescriptor(Object.prototype, "__proto__");
      if (desc) {
        try {
          set2 = desc.set;
          set2.call(tmpObj1, tmpObj2);
        } catch (ignore) {
        }
        if (Object.getPrototypeOf(tmpObj1) === tmpObj2)
          return { set: set2, level: 2 };
      }
      tmpObj1.__proto__ = tmpObj2;
      if (Object.getPrototypeOf(tmpObj1) === tmpObj2)
        return { level: 2 };
      tmpObj1 = {};
      tmpObj1.__proto__ = tmpObj2;
      if (Object.getPrototypeOf(tmpObj1) === tmpObj2)
        return { level: 1 };
      return false;
    }());
    require_create();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/set-prototype-of/index.js
var require_set_prototype_of = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/set-prototype-of/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented4()() ? Object.setPrototypeOf : require_shim4();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/sign/is-implemented.js
var require_is_implemented5 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/sign/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      var sign = Math.sign;
      if (typeof sign !== "function")
        return false;
      return sign(10) === 1 && sign(-20) === -1;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/sign/shim.js
var require_shim5 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/sign/shim.js"(exports, module2) {
    "use strict";
    module2.exports = function(value) {
      value = Number(value);
      if (isNaN(value) || value === 0)
        return value;
      return value > 0 ? 1 : -1;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/sign/index.js
var require_sign = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/sign/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented5()() ? Math.sign : require_shim5();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/to-integer.js
var require_to_integer = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/to-integer.js"(exports, module2) {
    "use strict";
    var sign = require_sign();
    var abs = Math.abs;
    var floor = Math.floor;
    module2.exports = function(value) {
      if (isNaN(value))
        return 0;
      value = Number(value);
      if (value === 0 || !isFinite(value))
        return value;
      return sign(value) * floor(abs(value));
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/to-pos-integer.js
var require_to_pos_integer = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/to-pos-integer.js"(exports, module2) {
    "use strict";
    var toInteger = require_to_integer();
    var max = Math.max;
    module2.exports = function(value) {
      return max(0, toInteger(value));
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/resolve-length.js
var require_resolve_length = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/resolve-length.js"(exports, module2) {
    "use strict";
    var toPosInt = require_to_pos_integer();
    module2.exports = function(optsLength, fnLength, isAsync) {
      var length;
      if (isNaN(optsLength)) {
        length = fnLength;
        if (!(length >= 0))
          return 1;
        if (isAsync && length)
          return length - 1;
        return length;
      }
      if (optsLength === false)
        return false;
      return toPosInt(optsLength);
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/registered-extensions.js
var require_registered_extensions = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/registered-extensions.js"() {
    "use strict";
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/error/custom.js
var require_custom = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/error/custom.js"(exports, module2) {
    "use strict";
    var assign3 = require_assign();
    var isObject2 = require_is_object();
    var isValue = require_is_value();
    var captureStackTrace = Error.captureStackTrace;
    module2.exports = function(message) {
      var err = new Error(message), code = arguments[1], ext = arguments[2];
      if (!isValue(ext)) {
        if (isObject2(code)) {
          ext = code;
          code = null;
        }
      }
      if (isValue(ext))
        assign3(err, ext);
      if (isValue(code))
        err.code = code;
      if (captureStackTrace)
        captureStackTrace(err, module2.exports);
      return err;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/mixin.js
var require_mixin = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/mixin.js"(exports, module2) {
    "use strict";
    var value = require_valid_value();
    var defineProperty = Object.defineProperty;
    var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
    var getOwnPropertyNames = Object.getOwnPropertyNames;
    var getOwnPropertySymbols = Object.getOwnPropertySymbols;
    module2.exports = function(target, source) {
      var error, sourceObject = Object(value(source));
      target = Object(value(target));
      getOwnPropertyNames(sourceObject).forEach(function(name) {
        try {
          defineProperty(target, name, getOwnPropertyDescriptor(source, name));
        } catch (e) {
          error = e;
        }
      });
      if (typeof getOwnPropertySymbols === "function") {
        getOwnPropertySymbols(sourceObject).forEach(function(symbol) {
          try {
            defineProperty(target, symbol, getOwnPropertyDescriptor(source, symbol));
          } catch (e) {
            error = e;
          }
        });
      }
      if (error !== void 0)
        throw error;
      return target;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/_define-length.js
var require_define_length = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/_define-length.js"(exports, module2) {
    "use strict";
    var toPosInt = require_to_pos_integer();
    var test = function(arg1, arg2) {
      return arg2;
    };
    var desc;
    var defineProperty;
    var generate;
    var mixin;
    try {
      Object.defineProperty(test, "length", {
        configurable: true,
        writable: false,
        enumerable: false,
        value: 1
      });
    } catch (ignore) {
    }
    if (test.length === 1) {
      desc = { configurable: true, writable: false, enumerable: false };
      defineProperty = Object.defineProperty;
      module2.exports = function(fn, length) {
        length = toPosInt(length);
        if (fn.length === length)
          return fn;
        desc.value = length;
        return defineProperty(fn, "length", desc);
      };
    } else {
      mixin = require_mixin();
      generate = function() {
        var cache = [];
        return function(length) {
          var args, i = 0;
          if (cache[length])
            return cache[length];
          args = [];
          while (length--)
            args.push("a" + (++i).toString(36));
          return new Function("fn", "return function (" + args.join(", ") + ") { return fn.apply(this, arguments); };");
        };
      }();
      module2.exports = function(src, length) {
        var target;
        length = toPosInt(length);
        if (src.length === length)
          return src;
        target = generate(length)(src);
        try {
          mixin(target, src);
        } catch (ignore) {
        }
        return target;
      };
    }
  }
});

// node_modules/.pnpm/event-emitter@0.3.5/node_modules/event-emitter/index.js
var require_event_emitter = __commonJS({
  "node_modules/.pnpm/event-emitter@0.3.5/node_modules/event-emitter/index.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var callable = require_valid_callable();
    var apply = Function.prototype.apply;
    var call = Function.prototype.call;
    var create = Object.create;
    var defineProperty = Object.defineProperty;
    var defineProperties = Object.defineProperties;
    var hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var descriptor = { configurable: true, enumerable: false, writable: true };
    var on;
    var once;
    var off;
    var emit;
    var methods;
    var descriptors;
    var base;
    on = function(type2, listener) {
      var data;
      callable(listener);
      if (!hasOwnProperty2.call(this, "__ee__")) {
        data = descriptor.value = create(null);
        defineProperty(this, "__ee__", descriptor);
        descriptor.value = null;
      } else {
        data = this.__ee__;
      }
      if (!data[type2])
        data[type2] = listener;
      else if (typeof data[type2] === "object")
        data[type2].push(listener);
      else
        data[type2] = [data[type2], listener];
      return this;
    };
    once = function(type2, listener) {
      var once2, self2;
      callable(listener);
      self2 = this;
      on.call(this, type2, once2 = function() {
        off.call(self2, type2, once2);
        apply.call(listener, this, arguments);
      });
      once2.__eeOnceListener__ = listener;
      return this;
    };
    off = function(type2, listener) {
      var data, listeners, candidate, i;
      callable(listener);
      if (!hasOwnProperty2.call(this, "__ee__"))
        return this;
      data = this.__ee__;
      if (!data[type2])
        return this;
      listeners = data[type2];
      if (typeof listeners === "object") {
        for (i = 0; candidate = listeners[i]; ++i) {
          if (candidate === listener || candidate.__eeOnceListener__ === listener) {
            if (listeners.length === 2)
              data[type2] = listeners[i ? 0 : 1];
            else
              listeners.splice(i, 1);
          }
        }
      } else {
        if (listeners === listener || listeners.__eeOnceListener__ === listener) {
          delete data[type2];
        }
      }
      return this;
    };
    emit = function(type2) {
      var i, l, listener, listeners, args;
      if (!hasOwnProperty2.call(this, "__ee__"))
        return;
      listeners = this.__ee__[type2];
      if (!listeners)
        return;
      if (typeof listeners === "object") {
        l = arguments.length;
        args = new Array(l - 1);
        for (i = 1; i < l; ++i)
          args[i - 1] = arguments[i];
        listeners = listeners.slice();
        for (i = 0; listener = listeners[i]; ++i) {
          apply.call(listener, this, args);
        }
      } else {
        switch (arguments.length) {
          case 1:
            call.call(listeners, this);
            break;
          case 2:
            call.call(listeners, this, arguments[1]);
            break;
          case 3:
            call.call(listeners, this, arguments[1], arguments[2]);
            break;
          default:
            l = arguments.length;
            args = new Array(l - 1);
            for (i = 1; i < l; ++i) {
              args[i - 1] = arguments[i];
            }
            apply.call(listeners, this, args);
        }
      }
    };
    methods = {
      on,
      once,
      off,
      emit
    };
    descriptors = {
      on: d(on),
      once: d(once),
      off: d(off),
      emit: d(emit)
    };
    base = defineProperties({}, descriptors);
    module2.exports = exports = function(o) {
      return o == null ? create(base) : defineProperties(Object(o), descriptors);
    };
    exports.methods = methods;
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/from/is-implemented.js
var require_is_implemented6 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/from/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      var from = Array.from, arr, result2;
      if (typeof from !== "function")
        return false;
      arr = ["raz", "dwa"];
      result2 = from(arr);
      return Boolean(result2 && result2 !== arr && result2[1] === "dwa");
    };
  }
});

// node_modules/.pnpm/ext@1.6.0/node_modules/ext/global-this/is-implemented.js
var require_is_implemented7 = __commonJS({
  "node_modules/.pnpm/ext@1.6.0/node_modules/ext/global-this/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      if (typeof globalThis !== "object")
        return false;
      if (!globalThis)
        return false;
      return globalThis.Array === Array;
    };
  }
});

// node_modules/.pnpm/ext@1.6.0/node_modules/ext/global-this/implementation.js
var require_implementation = __commonJS({
  "node_modules/.pnpm/ext@1.6.0/node_modules/ext/global-this/implementation.js"(exports, module2) {
    var naiveFallback = function() {
      if (typeof self === "object" && self)
        return self;
      if (typeof window === "object" && window)
        return window;
      throw new Error("Unable to resolve global `this`");
    };
    module2.exports = function() {
      if (this)
        return this;
      try {
        Object.defineProperty(Object.prototype, "__global__", {
          get: function() {
            return this;
          },
          configurable: true
        });
      } catch (error) {
        return naiveFallback();
      }
      try {
        if (!__global__)
          return naiveFallback();
        return __global__;
      } finally {
        delete Object.prototype.__global__;
      }
    }();
  }
});

// node_modules/.pnpm/ext@1.6.0/node_modules/ext/global-this/index.js
var require_global_this = __commonJS({
  "node_modules/.pnpm/ext@1.6.0/node_modules/ext/global-this/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented7()() ? globalThis : require_implementation();
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/is-implemented.js
var require_is_implemented8 = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/is-implemented.js"(exports, module2) {
    "use strict";
    var global2 = require_global_this();
    var validTypes = { object: true, symbol: true };
    module2.exports = function() {
      var Symbol2 = global2.Symbol;
      var symbol;
      if (typeof Symbol2 !== "function")
        return false;
      symbol = Symbol2("test symbol");
      try {
        String(symbol);
      } catch (e) {
        return false;
      }
      if (!validTypes[typeof Symbol2.iterator])
        return false;
      if (!validTypes[typeof Symbol2.toPrimitive])
        return false;
      if (!validTypes[typeof Symbol2.toStringTag])
        return false;
      return true;
    };
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/is-symbol.js
var require_is_symbol = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/is-symbol.js"(exports, module2) {
    "use strict";
    module2.exports = function(value) {
      if (!value)
        return false;
      if (typeof value === "symbol")
        return true;
      if (!value.constructor)
        return false;
      if (value.constructor.name !== "Symbol")
        return false;
      return value[value.constructor.toStringTag] === "Symbol";
    };
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/validate-symbol.js
var require_validate_symbol = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/validate-symbol.js"(exports, module2) {
    "use strict";
    var isSymbol = require_is_symbol();
    module2.exports = function(value) {
      if (!isSymbol(value))
        throw new TypeError(value + " is not a symbol");
      return value;
    };
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/lib/private/generate-name.js
var require_generate_name = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/lib/private/generate-name.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var create = Object.create;
    var defineProperty = Object.defineProperty;
    var objPrototype = Object.prototype;
    var created = create(null);
    module2.exports = function(desc) {
      var postfix = 0, name, ie11BugWorkaround;
      while (created[desc + (postfix || "")])
        ++postfix;
      desc += postfix || "";
      created[desc] = true;
      name = "@@" + desc;
      defineProperty(objPrototype, name, d.gs(null, function(value) {
        if (ie11BugWorkaround)
          return;
        ie11BugWorkaround = true;
        defineProperty(this, name, d(value));
        ie11BugWorkaround = false;
      }));
      return name;
    };
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/lib/private/setup/standard-symbols.js
var require_standard_symbols = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/lib/private/setup/standard-symbols.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var NativeSymbol = require_global_this().Symbol;
    module2.exports = function(SymbolPolyfill) {
      return Object.defineProperties(SymbolPolyfill, {
        hasInstance: d("", NativeSymbol && NativeSymbol.hasInstance || SymbolPolyfill("hasInstance")),
        isConcatSpreadable: d("", NativeSymbol && NativeSymbol.isConcatSpreadable || SymbolPolyfill("isConcatSpreadable")),
        iterator: d("", NativeSymbol && NativeSymbol.iterator || SymbolPolyfill("iterator")),
        match: d("", NativeSymbol && NativeSymbol.match || SymbolPolyfill("match")),
        replace: d("", NativeSymbol && NativeSymbol.replace || SymbolPolyfill("replace")),
        search: d("", NativeSymbol && NativeSymbol.search || SymbolPolyfill("search")),
        species: d("", NativeSymbol && NativeSymbol.species || SymbolPolyfill("species")),
        split: d("", NativeSymbol && NativeSymbol.split || SymbolPolyfill("split")),
        toPrimitive: d("", NativeSymbol && NativeSymbol.toPrimitive || SymbolPolyfill("toPrimitive")),
        toStringTag: d("", NativeSymbol && NativeSymbol.toStringTag || SymbolPolyfill("toStringTag")),
        unscopables: d("", NativeSymbol && NativeSymbol.unscopables || SymbolPolyfill("unscopables"))
      });
    };
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/lib/private/setup/symbol-registry.js
var require_symbol_registry = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/lib/private/setup/symbol-registry.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var validateSymbol = require_validate_symbol();
    var registry = /* @__PURE__ */ Object.create(null);
    module2.exports = function(SymbolPolyfill) {
      return Object.defineProperties(SymbolPolyfill, {
        for: d(function(key) {
          if (registry[key])
            return registry[key];
          return registry[key] = SymbolPolyfill(String(key));
        }),
        keyFor: d(function(symbol) {
          var key;
          validateSymbol(symbol);
          for (key in registry) {
            if (registry[key] === symbol)
              return key;
          }
          return void 0;
        })
      });
    };
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/polyfill.js
var require_polyfill = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/polyfill.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var validateSymbol = require_validate_symbol();
    var NativeSymbol = require_global_this().Symbol;
    var generateName = require_generate_name();
    var setupStandardSymbols = require_standard_symbols();
    var setupSymbolRegistry = require_symbol_registry();
    var create = Object.create;
    var defineProperties = Object.defineProperties;
    var defineProperty = Object.defineProperty;
    var SymbolPolyfill;
    var HiddenSymbol;
    var isNativeSafe;
    if (typeof NativeSymbol === "function") {
      try {
        String(NativeSymbol());
        isNativeSafe = true;
      } catch (ignore) {
      }
    } else {
      NativeSymbol = null;
    }
    HiddenSymbol = function Symbol2(description) {
      if (this instanceof HiddenSymbol)
        throw new TypeError("Symbol is not a constructor");
      return SymbolPolyfill(description);
    };
    module2.exports = SymbolPolyfill = function Symbol2(description) {
      var symbol;
      if (this instanceof Symbol2)
        throw new TypeError("Symbol is not a constructor");
      if (isNativeSafe)
        return NativeSymbol(description);
      symbol = create(HiddenSymbol.prototype);
      description = description === void 0 ? "" : String(description);
      return defineProperties(symbol, {
        __description__: d("", description),
        __name__: d("", generateName(description))
      });
    };
    setupStandardSymbols(SymbolPolyfill);
    setupSymbolRegistry(SymbolPolyfill);
    defineProperties(HiddenSymbol.prototype, {
      constructor: d(SymbolPolyfill),
      toString: d("", function() {
        return this.__name__;
      })
    });
    defineProperties(SymbolPolyfill.prototype, {
      toString: d(function() {
        return "Symbol (" + validateSymbol(this).__description__ + ")";
      }),
      valueOf: d(function() {
        return validateSymbol(this);
      })
    });
    defineProperty(SymbolPolyfill.prototype, SymbolPolyfill.toPrimitive, d("", function() {
      var symbol = validateSymbol(this);
      if (typeof symbol === "symbol")
        return symbol;
      return symbol.toString();
    }));
    defineProperty(SymbolPolyfill.prototype, SymbolPolyfill.toStringTag, d("c", "Symbol"));
    defineProperty(HiddenSymbol.prototype, SymbolPolyfill.toStringTag, d("c", SymbolPolyfill.prototype[SymbolPolyfill.toStringTag]));
    defineProperty(HiddenSymbol.prototype, SymbolPolyfill.toPrimitive, d("c", SymbolPolyfill.prototype[SymbolPolyfill.toPrimitive]));
  }
});

// node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/index.js
var require_es6_symbol = __commonJS({
  "node_modules/.pnpm/es6-symbol@3.1.3/node_modules/es6-symbol/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented8()() ? require_global_this().Symbol : require_polyfill();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/is-arguments.js
var require_is_arguments = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/is-arguments.js"(exports, module2) {
    "use strict";
    var objToString = Object.prototype.toString;
    var id = objToString.call(function() {
      return arguments;
    }());
    module2.exports = function(value) {
      return objToString.call(value) === id;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/is-function.js
var require_is_function = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/is-function.js"(exports, module2) {
    "use strict";
    var objToString = Object.prototype.toString;
    var isFunctionStringTag = RegExp.prototype.test.bind(/^[object [A-Za-z0-9]*Function]$/);
    module2.exports = function(value) {
      return typeof value === "function" && isFunctionStringTag(objToString.call(value));
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/is-string.js
var require_is_string = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/is-string.js"(exports, module2) {
    "use strict";
    var objToString = Object.prototype.toString;
    var id = objToString.call("");
    module2.exports = function(value) {
      return typeof value === "string" || value && typeof value === "object" && (value instanceof String || objToString.call(value) === id) || false;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/from/shim.js
var require_shim6 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/from/shim.js"(exports, module2) {
    "use strict";
    var iteratorSymbol = require_es6_symbol().iterator;
    var isArguments = require_is_arguments();
    var isFunction = require_is_function();
    var toPosInt = require_to_pos_integer();
    var callable = require_valid_callable();
    var validValue = require_valid_value();
    var isValue = require_is_value();
    var isString = require_is_string();
    var isArray = Array.isArray;
    var call = Function.prototype.call;
    var desc = { configurable: true, enumerable: true, writable: true, value: null };
    var defineProperty = Object.defineProperty;
    module2.exports = function(arrayLike) {
      var mapFn = arguments[1], thisArg = arguments[2], Context, i, j, arr, length, code, iterator, result2, getIterator, value;
      arrayLike = Object(validValue(arrayLike));
      if (isValue(mapFn))
        callable(mapFn);
      if (!this || this === Array || !isFunction(this)) {
        if (!mapFn) {
          if (isArguments(arrayLike)) {
            length = arrayLike.length;
            if (length !== 1)
              return Array.apply(null, arrayLike);
            arr = new Array(1);
            arr[0] = arrayLike[0];
            return arr;
          }
          if (isArray(arrayLike)) {
            arr = new Array(length = arrayLike.length);
            for (i = 0; i < length; ++i)
              arr[i] = arrayLike[i];
            return arr;
          }
        }
        arr = [];
      } else {
        Context = this;
      }
      if (!isArray(arrayLike)) {
        if ((getIterator = arrayLike[iteratorSymbol]) !== void 0) {
          iterator = callable(getIterator).call(arrayLike);
          if (Context)
            arr = new Context();
          result2 = iterator.next();
          i = 0;
          while (!result2.done) {
            value = mapFn ? call.call(mapFn, thisArg, result2.value, i) : result2.value;
            if (Context) {
              desc.value = value;
              defineProperty(arr, i, desc);
            } else {
              arr[i] = value;
            }
            result2 = iterator.next();
            ++i;
          }
          length = i;
        } else if (isString(arrayLike)) {
          length = arrayLike.length;
          if (Context)
            arr = new Context();
          for (i = 0, j = 0; i < length; ++i) {
            value = arrayLike[i];
            if (i + 1 < length) {
              code = value.charCodeAt(0);
              if (code >= 55296 && code <= 56319)
                value += arrayLike[++i];
            }
            value = mapFn ? call.call(mapFn, thisArg, value, j) : value;
            if (Context) {
              desc.value = value;
              defineProperty(arr, j, desc);
            } else {
              arr[j] = value;
            }
            ++j;
          }
          length = j;
        }
      }
      if (length === void 0) {
        length = toPosInt(arrayLike.length);
        if (Context)
          arr = new Context(length);
        for (i = 0; i < length; ++i) {
          value = mapFn ? call.call(mapFn, thisArg, arrayLike[i], i) : arrayLike[i];
          if (Context) {
            desc.value = value;
            defineProperty(arr, i, desc);
          } else {
            arr[i] = value;
          }
        }
      }
      if (Context) {
        desc.value = null;
        arr.length = length;
      }
      return arr;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/from/index.js
var require_from = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/from/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented6()() ? Array.from : require_shim6();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/to-array.js
var require_to_array = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/to-array.js"(exports, module2) {
    "use strict";
    var from = require_from();
    var isArray = Array.isArray;
    module2.exports = function(arrayLike) {
      return isArray(arrayLike) ? arrayLike : from(arrayLike);
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/resolve-resolve.js
var require_resolve_resolve = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/resolve-resolve.js"(exports, module2) {
    "use strict";
    var toArray2 = require_to_array();
    var isValue = require_is_value();
    var callable = require_valid_callable();
    var slice = Array.prototype.slice;
    var resolveArgs;
    resolveArgs = function(args) {
      return this.map(function(resolve, i) {
        return resolve ? resolve(args[i]) : args[i];
      }).concat(slice.call(args, this.length));
    };
    module2.exports = function(resolvers) {
      resolvers = toArray2(resolvers);
      resolvers.forEach(function(resolve) {
        if (isValue(resolve))
          callable(resolve);
      });
      return resolveArgs.bind(resolvers);
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/resolve-normalize.js
var require_resolve_normalize = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/resolve-normalize.js"(exports, module2) {
    "use strict";
    var callable = require_valid_callable();
    module2.exports = function(userNormalizer) {
      var normalizer;
      if (typeof userNormalizer === "function")
        return { set: userNormalizer, get: userNormalizer };
      normalizer = { get: callable(userNormalizer.get) };
      if (userNormalizer.set !== void 0) {
        normalizer.set = callable(userNormalizer.set);
        if (userNormalizer.delete)
          normalizer.delete = callable(userNormalizer.delete);
        if (userNormalizer.clear)
          normalizer.clear = callable(userNormalizer.clear);
        return normalizer;
      }
      normalizer.set = normalizer.get;
      return normalizer;
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/configure-map.js
var require_configure_map = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/configure-map.js"(exports, module2) {
    "use strict";
    var customError = require_custom();
    var defineLength = require_define_length();
    var d = require_d();
    var ee = require_event_emitter().methods;
    var resolveResolve = require_resolve_resolve();
    var resolveNormalize = require_resolve_normalize();
    var apply = Function.prototype.apply;
    var call = Function.prototype.call;
    var create = Object.create;
    var defineProperties = Object.defineProperties;
    var on = ee.on;
    var emit = ee.emit;
    module2.exports = function(original, length, options) {
      var cache = create(null), conf, memLength, get, set2, del, clear, extDel, extGet, extHas, normalizer, getListeners, setListeners, deleteListeners, memoized, resolve;
      if (length !== false)
        memLength = length;
      else if (isNaN(original.length))
        memLength = 1;
      else
        memLength = original.length;
      if (options.normalizer) {
        normalizer = resolveNormalize(options.normalizer);
        get = normalizer.get;
        set2 = normalizer.set;
        del = normalizer.delete;
        clear = normalizer.clear;
      }
      if (options.resolvers != null)
        resolve = resolveResolve(options.resolvers);
      if (get) {
        memoized = defineLength(function(arg) {
          var id, result2, args = arguments;
          if (resolve)
            args = resolve(args);
          id = get(args);
          if (id !== null) {
            if (hasOwnProperty.call(cache, id)) {
              if (getListeners)
                conf.emit("get", id, args, this);
              return cache[id];
            }
          }
          if (args.length === 1)
            result2 = call.call(original, this, args[0]);
          else
            result2 = apply.call(original, this, args);
          if (id === null) {
            id = get(args);
            if (id !== null)
              throw customError("Circular invocation", "CIRCULAR_INVOCATION");
            id = set2(args);
          } else if (hasOwnProperty.call(cache, id)) {
            throw customError("Circular invocation", "CIRCULAR_INVOCATION");
          }
          cache[id] = result2;
          if (setListeners)
            conf.emit("set", id, null, result2);
          return result2;
        }, memLength);
      } else if (length === 0) {
        memoized = function() {
          var result2;
          if (hasOwnProperty.call(cache, "data")) {
            if (getListeners)
              conf.emit("get", "data", arguments, this);
            return cache.data;
          }
          if (arguments.length)
            result2 = apply.call(original, this, arguments);
          else
            result2 = call.call(original, this);
          if (hasOwnProperty.call(cache, "data")) {
            throw customError("Circular invocation", "CIRCULAR_INVOCATION");
          }
          cache.data = result2;
          if (setListeners)
            conf.emit("set", "data", null, result2);
          return result2;
        };
      } else {
        memoized = function(arg) {
          var result2, args = arguments, id;
          if (resolve)
            args = resolve(arguments);
          id = String(args[0]);
          if (hasOwnProperty.call(cache, id)) {
            if (getListeners)
              conf.emit("get", id, args, this);
            return cache[id];
          }
          if (args.length === 1)
            result2 = call.call(original, this, args[0]);
          else
            result2 = apply.call(original, this, args);
          if (hasOwnProperty.call(cache, id)) {
            throw customError("Circular invocation", "CIRCULAR_INVOCATION");
          }
          cache[id] = result2;
          if (setListeners)
            conf.emit("set", id, null, result2);
          return result2;
        };
      }
      conf = {
        original,
        memoized,
        profileName: options.profileName,
        get: function(args) {
          if (resolve)
            args = resolve(args);
          if (get)
            return get(args);
          return String(args[0]);
        },
        has: function(id) {
          return hasOwnProperty.call(cache, id);
        },
        delete: function(id) {
          var result2;
          if (!hasOwnProperty.call(cache, id))
            return;
          if (del)
            del(id);
          result2 = cache[id];
          delete cache[id];
          if (deleteListeners)
            conf.emit("delete", id, result2);
        },
        clear: function() {
          var oldCache = cache;
          if (clear)
            clear();
          cache = create(null);
          conf.emit("clear", oldCache);
        },
        on: function(type2, listener) {
          if (type2 === "get")
            getListeners = true;
          else if (type2 === "set")
            setListeners = true;
          else if (type2 === "delete")
            deleteListeners = true;
          return on.call(this, type2, listener);
        },
        emit,
        updateEnv: function() {
          original = conf.original;
        }
      };
      if (get) {
        extDel = defineLength(function(arg) {
          var id, args = arguments;
          if (resolve)
            args = resolve(args);
          id = get(args);
          if (id === null)
            return;
          conf.delete(id);
        }, memLength);
      } else if (length === 0) {
        extDel = function() {
          return conf.delete("data");
        };
      } else {
        extDel = function(arg) {
          if (resolve)
            arg = resolve(arguments)[0];
          return conf.delete(arg);
        };
      }
      extGet = defineLength(function() {
        var id, args = arguments;
        if (length === 0)
          return cache.data;
        if (resolve)
          args = resolve(args);
        if (get)
          id = get(args);
        else
          id = String(args[0]);
        return cache[id];
      });
      extHas = defineLength(function() {
        var id, args = arguments;
        if (length === 0)
          return conf.has("data");
        if (resolve)
          args = resolve(args);
        if (get)
          id = get(args);
        else
          id = String(args[0]);
        if (id === null)
          return false;
        return conf.has(id);
      });
      defineProperties(memoized, {
        __memoized__: d(true),
        delete: d(extDel),
        clear: d(conf.clear),
        _get: d(extGet),
        _has: d(extHas)
      });
      return conf;
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/plain.js
var require_plain = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/plain.js"(exports, module2) {
    "use strict";
    var callable = require_valid_callable();
    var forEach = require_for_each();
    var extensions = require_registered_extensions();
    var configure = require_configure_map();
    var resolveLength = require_resolve_length();
    module2.exports = function self2(fn) {
      var options, length, conf;
      callable(fn);
      options = Object(arguments[1]);
      if (options.async && options.promise) {
        throw new Error("Options 'async' and 'promise' cannot be used together");
      }
      if (hasOwnProperty.call(fn, "__memoized__") && !options.force)
        return fn;
      length = resolveLength(options.length, fn.length, options.async && extensions.async);
      conf = configure(fn, length, options);
      forEach(extensions, function(extFn, name) {
        if (options[name])
          extFn(options[name], conf, options);
      });
      if (self2.__profiler__)
        self2.__profiler__(conf);
      conf.updateEnv();
      return conf.memoized;
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/primitive.js
var require_primitive = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/primitive.js"(exports, module2) {
    "use strict";
    module2.exports = function(args) {
      var id, i, length = args.length;
      if (!length)
        return "";
      id = String(args[i = 0]);
      while (--length)
        id += "" + args[++i];
      return id;
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get-primitive-fixed.js
var require_get_primitive_fixed = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get-primitive-fixed.js"(exports, module2) {
    "use strict";
    module2.exports = function(length) {
      if (!length) {
        return function() {
          return "";
        };
      }
      return function(args) {
        var id = String(args[0]), i = 0, currentLength = length;
        while (--currentLength) {
          id += "" + args[++i];
        }
        return id;
      };
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/is-nan/is-implemented.js
var require_is_implemented9 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/is-nan/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      var numberIsNaN = Number.isNaN;
      if (typeof numberIsNaN !== "function")
        return false;
      return !numberIsNaN({}) && numberIsNaN(NaN) && !numberIsNaN(34);
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/is-nan/shim.js
var require_shim7 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/is-nan/shim.js"(exports, module2) {
    "use strict";
    module2.exports = function(value) {
      return value !== value;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/is-nan/index.js
var require_is_nan = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/number/is-nan/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented9()() ? Number.isNaN : require_shim7();
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/e-index-of.js
var require_e_index_of = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/e-index-of.js"(exports, module2) {
    "use strict";
    var numberIsNaN = require_is_nan();
    var toPosInt = require_to_pos_integer();
    var value = require_valid_value();
    var indexOf = Array.prototype.indexOf;
    var objHasOwnProperty = Object.prototype.hasOwnProperty;
    var abs = Math.abs;
    var floor = Math.floor;
    module2.exports = function(searchElement) {
      var i, length, fromIndex, val;
      if (!numberIsNaN(searchElement))
        return indexOf.apply(this, arguments);
      length = toPosInt(value(this).length);
      fromIndex = arguments[1];
      if (isNaN(fromIndex))
        fromIndex = 0;
      else if (fromIndex >= 0)
        fromIndex = floor(fromIndex);
      else
        fromIndex = toPosInt(this.length) - floor(abs(fromIndex));
      for (i = fromIndex; i < length; ++i) {
        if (objHasOwnProperty.call(this, i)) {
          val = this[i];
          if (numberIsNaN(val))
            return i;
        }
      }
      return -1;
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get.js
var require_get = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get.js"(exports, module2) {
    "use strict";
    var indexOf = require_e_index_of();
    var create = Object.create;
    module2.exports = function() {
      var lastId = 0, map2 = [], cache = create(null);
      return {
        get: function(args) {
          var index = 0, set2 = map2, i, length = args.length;
          if (length === 0)
            return set2[length] || null;
          if (set2 = set2[length]) {
            while (index < length - 1) {
              i = indexOf.call(set2[0], args[index]);
              if (i === -1)
                return null;
              set2 = set2[1][i];
              ++index;
            }
            i = indexOf.call(set2[0], args[index]);
            if (i === -1)
              return null;
            return set2[1][i] || null;
          }
          return null;
        },
        set: function(args) {
          var index = 0, set2 = map2, i, length = args.length;
          if (length === 0) {
            set2[length] = ++lastId;
          } else {
            if (!set2[length]) {
              set2[length] = [[], []];
            }
            set2 = set2[length];
            while (index < length - 1) {
              i = indexOf.call(set2[0], args[index]);
              if (i === -1) {
                i = set2[0].push(args[index]) - 1;
                set2[1].push([[], []]);
              }
              set2 = set2[1][i];
              ++index;
            }
            i = indexOf.call(set2[0], args[index]);
            if (i === -1) {
              i = set2[0].push(args[index]) - 1;
            }
            set2[1][i] = ++lastId;
          }
          cache[lastId] = args;
          return lastId;
        },
        delete: function(id) {
          var index = 0, set2 = map2, i, args = cache[id], length = args.length, path2 = [];
          if (length === 0) {
            delete set2[length];
          } else if (set2 = set2[length]) {
            while (index < length - 1) {
              i = indexOf.call(set2[0], args[index]);
              if (i === -1) {
                return;
              }
              path2.push(set2, i);
              set2 = set2[1][i];
              ++index;
            }
            i = indexOf.call(set2[0], args[index]);
            if (i === -1) {
              return;
            }
            id = set2[1][i];
            set2[0].splice(i, 1);
            set2[1].splice(i, 1);
            while (!set2[0].length && path2.length) {
              i = path2.pop();
              set2 = path2.pop();
              set2[0].splice(i, 1);
              set2[1].splice(i, 1);
            }
          }
          delete cache[id];
        },
        clear: function() {
          map2 = [];
          cache = create(null);
        }
      };
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get-1.js
var require_get_1 = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get-1.js"(exports, module2) {
    "use strict";
    var indexOf = require_e_index_of();
    module2.exports = function() {
      var lastId = 0, argsMap = [], cache = [];
      return {
        get: function(args) {
          var index = indexOf.call(argsMap, args[0]);
          return index === -1 ? null : cache[index];
        },
        set: function(args) {
          argsMap.push(args[0]);
          cache.push(++lastId);
          return lastId;
        },
        delete: function(id) {
          var index = indexOf.call(cache, id);
          if (index !== -1) {
            argsMap.splice(index, 1);
            cache.splice(index, 1);
          }
        },
        clear: function() {
          argsMap = [];
          cache = [];
        }
      };
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get-fixed.js
var require_get_fixed = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/normalizers/get-fixed.js"(exports, module2) {
    "use strict";
    var indexOf = require_e_index_of();
    var create = Object.create;
    module2.exports = function(length) {
      var lastId = 0, map2 = [[], []], cache = create(null);
      return {
        get: function(args) {
          var index = 0, set2 = map2, i;
          while (index < length - 1) {
            i = indexOf.call(set2[0], args[index]);
            if (i === -1)
              return null;
            set2 = set2[1][i];
            ++index;
          }
          i = indexOf.call(set2[0], args[index]);
          if (i === -1)
            return null;
          return set2[1][i] || null;
        },
        set: function(args) {
          var index = 0, set2 = map2, i;
          while (index < length - 1) {
            i = indexOf.call(set2[0], args[index]);
            if (i === -1) {
              i = set2[0].push(args[index]) - 1;
              set2[1].push([[], []]);
            }
            set2 = set2[1][i];
            ++index;
          }
          i = indexOf.call(set2[0], args[index]);
          if (i === -1) {
            i = set2[0].push(args[index]) - 1;
          }
          set2[1][i] = ++lastId;
          cache[lastId] = args;
          return lastId;
        },
        delete: function(id) {
          var index = 0, set2 = map2, i, path2 = [], args = cache[id];
          while (index < length - 1) {
            i = indexOf.call(set2[0], args[index]);
            if (i === -1) {
              return;
            }
            path2.push(set2, i);
            set2 = set2[1][i];
            ++index;
          }
          i = indexOf.call(set2[0], args[index]);
          if (i === -1) {
            return;
          }
          id = set2[1][i];
          set2[0].splice(i, 1);
          set2[1].splice(i, 1);
          while (!set2[0].length && path2.length) {
            i = path2.pop();
            set2 = path2.pop();
            set2[0].splice(i, 1);
            set2[1].splice(i, 1);
          }
          delete cache[id];
        },
        clear: function() {
          map2 = [[], []];
          cache = create(null);
        }
      };
    };
  }
});

// node_modules/.pnpm/next-tick@1.1.0/node_modules/next-tick/index.js
var require_next_tick = __commonJS({
  "node_modules/.pnpm/next-tick@1.1.0/node_modules/next-tick/index.js"(exports, module2) {
    "use strict";
    var ensureCallable = function(fn) {
      if (typeof fn !== "function")
        throw new TypeError(fn + " is not a function");
      return fn;
    };
    var byObserver = function(Observer) {
      var node = document.createTextNode(""), queue, currentQueue, i = 0;
      new Observer(function() {
        var callback;
        if (!queue) {
          if (!currentQueue)
            return;
          queue = currentQueue;
        } else if (currentQueue) {
          queue = currentQueue.concat(queue);
        }
        currentQueue = queue;
        queue = null;
        if (typeof currentQueue === "function") {
          callback = currentQueue;
          currentQueue = null;
          callback();
          return;
        }
        node.data = i = ++i % 2;
        while (currentQueue) {
          callback = currentQueue.shift();
          if (!currentQueue.length)
            currentQueue = null;
          callback();
        }
      }).observe(node, { characterData: true });
      return function(fn) {
        ensureCallable(fn);
        if (queue) {
          if (typeof queue === "function")
            queue = [queue, fn];
          else
            queue.push(fn);
          return;
        }
        queue = fn;
        node.data = i = ++i % 2;
      };
    };
    module2.exports = function() {
      if (typeof process === "object" && process && typeof process.nextTick === "function") {
        return process.nextTick;
      }
      if (typeof queueMicrotask === "function") {
        return function(cb) {
          queueMicrotask(ensureCallable(cb));
        };
      }
      if (typeof document === "object" && document) {
        if (typeof MutationObserver === "function")
          return byObserver(MutationObserver);
        if (typeof WebKitMutationObserver === "function")
          return byObserver(WebKitMutationObserver);
      }
      if (typeof setImmediate === "function") {
        return function(cb) {
          setImmediate(ensureCallable(cb));
        };
      }
      if (typeof setTimeout === "function" || typeof setTimeout === "object") {
        return function(cb) {
          setTimeout(ensureCallable(cb), 0);
        };
      }
      return null;
    }();
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/async.js
var require_async = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/async.js"() {
    "use strict";
    var aFrom = require_from();
    var objectMap = require_map();
    var mixin = require_mixin();
    var defineLength = require_define_length();
    var nextTick = require_next_tick();
    var slice = Array.prototype.slice;
    var apply = Function.prototype.apply;
    var create = Object.create;
    require_registered_extensions().async = function(tbi, conf) {
      var waiting = create(null), cache = create(null), base = conf.memoized, original = conf.original, currentCallback, currentContext, currentArgs;
      conf.memoized = defineLength(function(arg) {
        var args = arguments, last = args[args.length - 1];
        if (typeof last === "function") {
          currentCallback = last;
          args = slice.call(args, 0, -1);
        }
        return base.apply(currentContext = this, currentArgs = args);
      }, base);
      try {
        mixin(conf.memoized, base);
      } catch (ignore) {
      }
      conf.on("get", function(id) {
        var cb, context, args;
        if (!currentCallback)
          return;
        if (waiting[id]) {
          if (typeof waiting[id] === "function")
            waiting[id] = [waiting[id], currentCallback];
          else
            waiting[id].push(currentCallback);
          currentCallback = null;
          return;
        }
        cb = currentCallback;
        context = currentContext;
        args = currentArgs;
        currentCallback = currentContext = currentArgs = null;
        nextTick(function() {
          var data;
          if (hasOwnProperty.call(cache, id)) {
            data = cache[id];
            conf.emit("getasync", id, args, context);
            apply.call(cb, data.context, data.args);
          } else {
            currentCallback = cb;
            currentContext = context;
            currentArgs = args;
            base.apply(context, args);
          }
        });
      });
      conf.original = function() {
        var args, cb, origCb, result2;
        if (!currentCallback)
          return apply.call(original, this, arguments);
        args = aFrom(arguments);
        cb = function self2(err) {
          var cb2, args2, id = self2.id;
          if (id == null) {
            nextTick(apply.bind(self2, this, arguments));
            return void 0;
          }
          delete self2.id;
          cb2 = waiting[id];
          delete waiting[id];
          if (!cb2) {
            return void 0;
          }
          args2 = aFrom(arguments);
          if (conf.has(id)) {
            if (err) {
              conf.delete(id);
            } else {
              cache[id] = { context: this, args: args2 };
              conf.emit("setasync", id, typeof cb2 === "function" ? 1 : cb2.length);
            }
          }
          if (typeof cb2 === "function") {
            result2 = apply.call(cb2, this, args2);
          } else {
            cb2.forEach(function(cb3) {
              result2 = apply.call(cb3, this, args2);
            }, this);
          }
          return result2;
        };
        origCb = currentCallback;
        currentCallback = currentContext = currentArgs = null;
        args.push(cb);
        result2 = apply.call(original, this, args);
        cb.cb = origCb;
        currentCallback = cb;
        return result2;
      };
      conf.on("set", function(id) {
        if (!currentCallback) {
          conf.delete(id);
          return;
        }
        if (waiting[id]) {
          if (typeof waiting[id] === "function")
            waiting[id] = [waiting[id], currentCallback.cb];
          else
            waiting[id].push(currentCallback.cb);
        } else {
          waiting[id] = currentCallback.cb;
        }
        delete currentCallback.cb;
        currentCallback.id = id;
        currentCallback = null;
      });
      conf.on("delete", function(id) {
        var result2;
        if (hasOwnProperty.call(waiting, id))
          return;
        if (!cache[id])
          return;
        result2 = cache[id];
        delete cache[id];
        conf.emit("deleteasync", id, slice.call(result2.args, 1));
      });
      conf.on("clear", function() {
        var oldCache = cache;
        cache = create(null);
        conf.emit("clearasync", objectMap(oldCache, function(data) {
          return slice.call(data.args, 1);
        }));
      });
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-callable.js
var require_is_callable = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-callable.js"(exports, module2) {
    "use strict";
    module2.exports = function(obj) {
      return typeof obj === "function";
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/validate-stringifiable.js
var require_validate_stringifiable = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/validate-stringifiable.js"(exports, module2) {
    "use strict";
    var isCallable = require_is_callable();
    module2.exports = function(stringifiable) {
      try {
        if (stringifiable && isCallable(stringifiable.toString))
          return stringifiable.toString();
        return String(stringifiable);
      } catch (e) {
        throw new TypeError("Passed argument cannot be stringifed");
      }
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/validate-stringifiable-value.js
var require_validate_stringifiable_value = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/validate-stringifiable-value.js"(exports, module2) {
    "use strict";
    var ensureValue = require_valid_value();
    var stringifiable = require_validate_stringifiable();
    module2.exports = function(value) {
      return stringifiable(ensureValue(value));
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/safe-to-string.js
var require_safe_to_string = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/safe-to-string.js"(exports, module2) {
    "use strict";
    var isCallable = require_is_callable();
    module2.exports = function(value) {
      try {
        if (value && isCallable(value.toString))
          return value.toString();
        return String(value);
      } catch (e) {
        return "<Non-coercible to string value>";
      }
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/to-short-string-representation.js
var require_to_short_string_representation = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/to-short-string-representation.js"(exports, module2) {
    "use strict";
    var safeToString = require_safe_to_string();
    var reNewLine = /[\n\r\u2028\u2029]/g;
    module2.exports = function(value) {
      var string2 = safeToString(value);
      if (string2.length > 100)
        string2 = string2.slice(0, 99) + "\u2026";
      string2 = string2.replace(reNewLine, function(char) {
        return JSON.stringify(char).slice(1, -1);
      });
      return string2;
    };
  }
});

// node_modules/.pnpm/is-promise@2.2.2/node_modules/is-promise/index.js
var require_is_promise = __commonJS({
  "node_modules/.pnpm/is-promise@2.2.2/node_modules/is-promise/index.js"(exports, module2) {
    module2.exports = isPromise;
    module2.exports.default = isPromise;
    function isPromise(obj) {
      return !!obj && (typeof obj === "object" || typeof obj === "function") && typeof obj.then === "function";
    }
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/promise.js
var require_promise = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/promise.js"() {
    "use strict";
    var objectMap = require_map();
    var primitiveSet = require_primitive_set();
    var ensureString = require_validate_stringifiable_value();
    var toShortString = require_to_short_string_representation();
    var isPromise = require_is_promise();
    var nextTick = require_next_tick();
    var create = Object.create;
    var supportedModes = primitiveSet("then", "then:finally", "done", "done:finally");
    require_registered_extensions().promise = function(mode, conf) {
      var waiting = create(null), cache = create(null), promises = create(null);
      if (mode === true) {
        mode = null;
      } else {
        mode = ensureString(mode);
        if (!supportedModes[mode]) {
          throw new TypeError("'" + toShortString(mode) + "' is not valid promise mode");
        }
      }
      conf.on("set", function(id, ignore, promise) {
        var isFailed = false;
        if (!isPromise(promise)) {
          cache[id] = promise;
          conf.emit("setasync", id, 1);
          return;
        }
        waiting[id] = 1;
        promises[id] = promise;
        var onSuccess = function(result2) {
          var count = waiting[id];
          if (isFailed) {
            throw new Error("Memoizee error: Detected unordered then|done & finally resolution, which in turn makes proper detection of success/failure impossible (when in 'done:finally' mode)\nConsider to rely on 'then' or 'done' mode instead.");
          }
          if (!count)
            return;
          delete waiting[id];
          cache[id] = result2;
          conf.emit("setasync", id, count);
        };
        var onFailure = function() {
          isFailed = true;
          if (!waiting[id])
            return;
          delete waiting[id];
          delete promises[id];
          conf.delete(id);
        };
        var resolvedMode = mode;
        if (!resolvedMode)
          resolvedMode = "then";
        if (resolvedMode === "then") {
          var nextTickFailure = function() {
            nextTick(onFailure);
          };
          promise = promise.then(function(result2) {
            nextTick(onSuccess.bind(this, result2));
          }, nextTickFailure);
          if (typeof promise.finally === "function") {
            promise.finally(nextTickFailure);
          }
        } else if (resolvedMode === "done") {
          if (typeof promise.done !== "function") {
            throw new Error("Memoizee error: Retrieved promise does not implement 'done' in 'done' mode");
          }
          promise.done(onSuccess, onFailure);
        } else if (resolvedMode === "done:finally") {
          if (typeof promise.done !== "function") {
            throw new Error("Memoizee error: Retrieved promise does not implement 'done' in 'done:finally' mode");
          }
          if (typeof promise.finally !== "function") {
            throw new Error("Memoizee error: Retrieved promise does not implement 'finally' in 'done:finally' mode");
          }
          promise.done(onSuccess);
          promise.finally(onFailure);
        }
      });
      conf.on("get", function(id, args, context) {
        var promise;
        if (waiting[id]) {
          ++waiting[id];
          return;
        }
        promise = promises[id];
        var emit = function() {
          conf.emit("getasync", id, args, context);
        };
        if (isPromise(promise)) {
          if (typeof promise.done === "function")
            promise.done(emit);
          else {
            promise.then(function() {
              nextTick(emit);
            });
          }
        } else {
          emit();
        }
      });
      conf.on("delete", function(id) {
        delete promises[id];
        if (waiting[id]) {
          delete waiting[id];
          return;
        }
        if (!hasOwnProperty.call(cache, id))
          return;
        var result2 = cache[id];
        delete cache[id];
        conf.emit("deleteasync", id, [result2]);
      });
      conf.on("clear", function() {
        var oldCache = cache;
        cache = create(null);
        waiting = create(null);
        promises = create(null);
        conf.emit("clearasync", objectMap(oldCache, function(data) {
          return [data];
        }));
      });
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/dispose.js
var require_dispose = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/dispose.js"() {
    "use strict";
    var callable = require_valid_callable();
    var forEach = require_for_each();
    var extensions = require_registered_extensions();
    var apply = Function.prototype.apply;
    extensions.dispose = function(dispose, conf, options) {
      var del;
      callable(dispose);
      if (options.async && extensions.async || options.promise && extensions.promise) {
        conf.on("deleteasync", del = function(id, resultArray) {
          apply.call(dispose, null, resultArray);
        });
        conf.on("clearasync", function(cache) {
          forEach(cache, function(result2, id) {
            del(id, result2);
          });
        });
        return;
      }
      conf.on("delete", del = function(id, result2) {
        dispose(result2);
      });
      conf.on("clear", function(cache) {
        forEach(cache, function(result2, id) {
          del(id, result2);
        });
      });
    };
  }
});

// node_modules/.pnpm/timers-ext@0.1.7/node_modules/timers-ext/max-timeout.js
var require_max_timeout = __commonJS({
  "node_modules/.pnpm/timers-ext@0.1.7/node_modules/timers-ext/max-timeout.js"(exports, module2) {
    "use strict";
    module2.exports = 2147483647;
  }
});

// node_modules/.pnpm/timers-ext@0.1.7/node_modules/timers-ext/valid-timeout.js
var require_valid_timeout = __commonJS({
  "node_modules/.pnpm/timers-ext@0.1.7/node_modules/timers-ext/valid-timeout.js"(exports, module2) {
    "use strict";
    var toPosInt = require_to_pos_integer();
    var maxTimeout = require_max_timeout();
    module2.exports = function(value) {
      value = toPosInt(value);
      if (value > maxTimeout)
        throw new TypeError(value + " exceeds maximum possible timeout");
      return value;
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/max-age.js
var require_max_age = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/max-age.js"() {
    "use strict";
    var aFrom = require_from();
    var forEach = require_for_each();
    var nextTick = require_next_tick();
    var isPromise = require_is_promise();
    var timeout = require_valid_timeout();
    var extensions = require_registered_extensions();
    var noop = Function.prototype;
    var max = Math.max;
    var min = Math.min;
    var create = Object.create;
    extensions.maxAge = function(maxAge, conf, options) {
      var timeouts, postfix, preFetchAge, preFetchTimeouts;
      maxAge = timeout(maxAge);
      if (!maxAge)
        return;
      timeouts = create(null);
      postfix = options.async && extensions.async || options.promise && extensions.promise ? "async" : "";
      conf.on("set" + postfix, function(id) {
        timeouts[id] = setTimeout(function() {
          conf.delete(id);
        }, maxAge);
        if (typeof timeouts[id].unref === "function")
          timeouts[id].unref();
        if (!preFetchTimeouts)
          return;
        if (preFetchTimeouts[id]) {
          if (preFetchTimeouts[id] !== "nextTick")
            clearTimeout(preFetchTimeouts[id]);
        }
        preFetchTimeouts[id] = setTimeout(function() {
          delete preFetchTimeouts[id];
        }, preFetchAge);
        if (typeof preFetchTimeouts[id].unref === "function")
          preFetchTimeouts[id].unref();
      });
      conf.on("delete" + postfix, function(id) {
        clearTimeout(timeouts[id]);
        delete timeouts[id];
        if (!preFetchTimeouts)
          return;
        if (preFetchTimeouts[id] !== "nextTick")
          clearTimeout(preFetchTimeouts[id]);
        delete preFetchTimeouts[id];
      });
      if (options.preFetch) {
        if (options.preFetch === true || isNaN(options.preFetch)) {
          preFetchAge = 0.333;
        } else {
          preFetchAge = max(min(Number(options.preFetch), 1), 0);
        }
        if (preFetchAge) {
          preFetchTimeouts = {};
          preFetchAge = (1 - preFetchAge) * maxAge;
          conf.on("get" + postfix, function(id, args, context) {
            if (!preFetchTimeouts[id]) {
              preFetchTimeouts[id] = "nextTick";
              nextTick(function() {
                var result2;
                if (preFetchTimeouts[id] !== "nextTick")
                  return;
                delete preFetchTimeouts[id];
                conf.delete(id);
                if (options.async) {
                  args = aFrom(args);
                  args.push(noop);
                }
                result2 = conf.memoized.apply(context, args);
                if (options.promise) {
                  if (isPromise(result2)) {
                    if (typeof result2.done === "function")
                      result2.done(noop, noop);
                    else
                      result2.then(noop, noop);
                  }
                }
              });
            }
          });
        }
      }
      conf.on("clear" + postfix, function() {
        forEach(timeouts, function(id) {
          clearTimeout(id);
        });
        timeouts = {};
        if (preFetchTimeouts) {
          forEach(preFetchTimeouts, function(id) {
            if (id !== "nextTick")
              clearTimeout(id);
          });
          preFetchTimeouts = {};
        }
      });
    };
  }
});

// node_modules/.pnpm/lru-queue@0.1.0/node_modules/lru-queue/index.js
var require_lru_queue = __commonJS({
  "node_modules/.pnpm/lru-queue@0.1.0/node_modules/lru-queue/index.js"(exports, module2) {
    "use strict";
    var toPosInt = require_to_pos_integer();
    var create = Object.create;
    var hasOwnProperty2 = Object.prototype.hasOwnProperty;
    module2.exports = function(limit) {
      var size = 0, base = 1, queue = create(null), map2 = create(null), index = 0, del;
      limit = toPosInt(limit);
      return {
        hit: function(id) {
          var oldIndex = map2[id], nuIndex = ++index;
          queue[nuIndex] = id;
          map2[id] = nuIndex;
          if (!oldIndex) {
            ++size;
            if (size <= limit)
              return;
            id = queue[base];
            del(id);
            return id;
          }
          delete queue[oldIndex];
          if (base !== oldIndex)
            return;
          while (!hasOwnProperty2.call(queue, ++base))
            continue;
        },
        delete: del = function(id) {
          var oldIndex = map2[id];
          if (!oldIndex)
            return;
          delete queue[oldIndex];
          delete map2[id];
          --size;
          if (base !== oldIndex)
            return;
          if (!size) {
            index = 0;
            base = 1;
            return;
          }
          while (!hasOwnProperty2.call(queue, ++base))
            continue;
        },
        clear: function() {
          size = 0;
          base = 1;
          queue = create(null);
          map2 = create(null);
          index = 0;
        }
      };
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/max.js
var require_max = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/max.js"() {
    "use strict";
    var toPosInteger = require_to_pos_integer();
    var lruQueue = require_lru_queue();
    var extensions = require_registered_extensions();
    extensions.max = function(max, conf, options) {
      var postfix, queue, hit;
      max = toPosInteger(max);
      if (!max)
        return;
      queue = lruQueue(max);
      postfix = options.async && extensions.async || options.promise && extensions.promise ? "async" : "";
      conf.on("set" + postfix, hit = function(id) {
        id = queue.hit(id);
        if (id === void 0)
          return;
        conf.delete(id);
      });
      conf.on("get" + postfix, hit);
      conf.on("delete" + postfix, queue.delete);
      conf.on("clear" + postfix, queue.clear);
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/ref-counter.js
var require_ref_counter = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/ext/ref-counter.js"() {
    "use strict";
    var d = require_d();
    var extensions = require_registered_extensions();
    var create = Object.create;
    var defineProperties = Object.defineProperties;
    extensions.refCounter = function(ignore, conf, options) {
      var cache, postfix;
      cache = create(null);
      postfix = options.async && extensions.async || options.promise && extensions.promise ? "async" : "";
      conf.on("set" + postfix, function(id, length) {
        cache[id] = length || 1;
      });
      conf.on("get" + postfix, function(id) {
        ++cache[id];
      });
      conf.on("delete" + postfix, function(id) {
        delete cache[id];
      });
      conf.on("clear" + postfix, function() {
        cache = {};
      });
      defineProperties(conf.memoized, {
        deleteRef: d(function() {
          var id = conf.get(arguments);
          if (id === null)
            return null;
          if (!cache[id])
            return null;
          if (!--cache[id]) {
            conf.delete(id);
            return true;
          }
          return false;
        }),
        getRefCount: d(function() {
          var id = conf.get(arguments);
          if (id === null)
            return 0;
          if (!cache[id])
            return 0;
          return cache[id];
        })
      });
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/index.js
var require_memoizee = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/index.js"(exports, module2) {
    "use strict";
    var normalizeOpts = require_normalize_options();
    var resolveLength = require_resolve_length();
    var plain = require_plain();
    module2.exports = function(fn) {
      var options = normalizeOpts(arguments[1]), length;
      if (!options.normalizer) {
        length = options.length = resolveLength(options.length, fn.length, options.async);
        if (length !== 0) {
          if (options.primitive) {
            if (length === false) {
              options.normalizer = require_primitive();
            } else if (length > 1) {
              options.normalizer = require_get_primitive_fixed()(length);
            }
          } else if (length === false)
            options.normalizer = require_get()();
          else if (length === 1)
            options.normalizer = require_get_1()();
          else
            options.normalizer = require_get_fixed()(length);
        }
      }
      if (options.async)
        require_async();
      if (options.promise)
        require_promise();
      if (options.dispose)
        require_dispose();
      if (options.maxAge)
        require_max_age();
      if (options.max)
        require_max();
      if (options.refCounter)
        require_ref_counter();
      return plain(fn, options);
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/string/coerce.js
var require_coerce = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/string/coerce.js"(exports, module2) {
    "use strict";
    var isValue = require_is();
    var isObject2 = require_is2();
    var objectToString = Object.prototype.toString;
    module2.exports = function(value) {
      if (!isValue(value))
        return null;
      if (isObject2(value)) {
        var valueToString = value.toString;
        if (typeof valueToString !== "function")
          return null;
        if (valueToString === objectToString)
          return null;
      }
      try {
        return "" + value;
      } catch (error) {
        return null;
      }
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/lib/safe-to-string.js
var require_safe_to_string2 = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/lib/safe-to-string.js"(exports, module2) {
    "use strict";
    module2.exports = function(value) {
      try {
        return value.toString();
      } catch (error) {
        try {
          return String(value);
        } catch (error2) {
          return null;
        }
      }
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/lib/to-short-string.js
var require_to_short_string = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/lib/to-short-string.js"(exports, module2) {
    "use strict";
    var safeToString = require_safe_to_string2();
    var reNewLine = /[\n\r\u2028\u2029]/g;
    module2.exports = function(value) {
      var string2 = safeToString(value);
      if (string2 === null)
        return "<Non-coercible to string value>";
      if (string2.length > 100)
        string2 = string2.slice(0, 99) + "\u2026";
      string2 = string2.replace(reNewLine, function(char) {
        switch (char) {
          case "\n":
            return "\\n";
          case "\r":
            return "\\r";
          case "\u2028":
            return "\\u2028";
          case "\u2029":
            return "\\u2029";
          default:
            throw new Error("Unexpected character");
        }
      });
      return string2;
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/lib/resolve-exception.js
var require_resolve_exception = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/lib/resolve-exception.js"(exports, module2) {
    "use strict";
    var isValue = require_is();
    var isObject2 = require_is2();
    var stringCoerce = require_coerce();
    var toShortString = require_to_short_string();
    var resolveMessage = function(message, value) {
      return message.replace("%v", toShortString(value));
    };
    module2.exports = function(value, defaultMessage, inputOptions) {
      if (!isObject2(inputOptions))
        throw new TypeError(resolveMessage(defaultMessage, value));
      if (!isValue(value)) {
        if ("default" in inputOptions)
          return inputOptions["default"];
        if (inputOptions.isOptional)
          return null;
      }
      var errorMessage = stringCoerce(inputOptions.errorMessage);
      if (!isValue(errorMessage))
        errorMessage = defaultMessage;
      throw new TypeError(resolveMessage(errorMessage, value));
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/value/ensure.js
var require_ensure = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/value/ensure.js"(exports, module2) {
    "use strict";
    var resolveException = require_resolve_exception();
    var is = require_is();
    module2.exports = function(value) {
      if (is(value))
        return value;
      return resolveException(value, "Cannot use %v", arguments[1]);
    };
  }
});

// node_modules/.pnpm/d@1.0.1/node_modules/d/lazy.js
var require_lazy = __commonJS({
  "node_modules/.pnpm/d@1.0.1/node_modules/d/lazy.js"(exports, module2) {
    "use strict";
    var isPlainFunction = require_is5();
    var ensureValue = require_ensure();
    var isValue = require_is();
    var map2 = require_map();
    var contains = require_contains();
    var call = Function.prototype.call;
    var defineProperty = Object.defineProperty;
    var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
    var getPrototypeOf = Object.getPrototypeOf;
    var hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var cacheDesc = { configurable: false, enumerable: false, writable: false, value: null };
    var define2;
    define2 = function(name, options) {
      var value, dgs, cacheName, desc, writable = false, resolvable, flat;
      options = Object(ensureValue(options));
      cacheName = options.cacheName;
      flat = options.flat;
      if (!isValue(cacheName))
        cacheName = name;
      delete options.cacheName;
      value = options.value;
      resolvable = isPlainFunction(value);
      delete options.value;
      dgs = { configurable: Boolean(options.configurable), enumerable: Boolean(options.enumerable) };
      if (name !== cacheName) {
        dgs.get = function() {
          if (hasOwnProperty2.call(this, cacheName))
            return this[cacheName];
          cacheDesc.value = resolvable ? call.call(value, this, options) : value;
          cacheDesc.writable = writable;
          defineProperty(this, cacheName, cacheDesc);
          cacheDesc.value = null;
          if (desc)
            defineProperty(this, name, desc);
          return this[cacheName];
        };
      } else if (!flat) {
        dgs.get = function self2() {
          var ownDesc;
          if (hasOwnProperty2.call(this, name)) {
            ownDesc = getOwnPropertyDescriptor(this, name);
            if (ownDesc) {
              if (ownDesc.hasOwnProperty("value"))
                return ownDesc.value;
              if (typeof ownDesc.get === "function" && ownDesc.get !== self2) {
                return ownDesc.get.call(this);
              }
              return value;
            }
          }
          desc.value = resolvable ? call.call(value, this, options) : value;
          defineProperty(this, name, desc);
          desc.value = null;
          return this[name];
        };
      } else {
        dgs.get = function self2() {
          var base = this, ownDesc;
          if (hasOwnProperty2.call(this, name)) {
            ownDesc = getOwnPropertyDescriptor(this, name);
            if (ownDesc.hasOwnProperty("value"))
              return ownDesc.value;
            if (typeof ownDesc.get === "function" && ownDesc.get !== self2) {
              return ownDesc.get.call(this);
            }
          }
          while (!hasOwnProperty2.call(base, name))
            base = getPrototypeOf(base);
          desc.value = resolvable ? call.call(value, base, options) : value;
          defineProperty(base, name, desc);
          desc.value = null;
          return base[name];
        };
      }
      dgs.set = function(value2) {
        if (hasOwnProperty2.call(this, name)) {
          throw new TypeError("Cannot assign to lazy defined '" + name + "' property of " + this);
        }
        dgs.get.call(this);
        this[cacheName] = value2;
      };
      if (options.desc) {
        desc = {
          configurable: contains.call(options.desc, "c"),
          enumerable: contains.call(options.desc, "e")
        };
        if (cacheName === name) {
          desc.writable = contains.call(options.desc, "w");
          desc.value = null;
        } else {
          writable = contains.call(options.desc, "w");
          desc.get = dgs.get;
          desc.set = dgs.set;
        }
        delete options.desc;
      } else if (cacheName === name) {
        desc = {
          configurable: Boolean(options.configurable),
          enumerable: Boolean(options.enumerable),
          writable: Boolean(options.writable),
          value: null
        };
      }
      delete options.configurable;
      delete options.enumerable;
      delete options.writable;
      return dgs;
    };
    module2.exports = function(props) {
      return map2(props, function(desc, name) {
        return define2(name, desc);
      });
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/methods.js
var require_methods = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/lib/methods.js"(exports, module2) {
    "use strict";
    var forEach = require_for_each();
    var normalizeOpts = require_normalize_options();
    var callable = require_valid_callable();
    var lazy = require_lazy();
    var resolveLength = require_resolve_length();
    var extensions = require_registered_extensions();
    module2.exports = function(memoize) {
      return function(props) {
        forEach(props, function(desc) {
          var fn = callable(desc.value), length;
          desc.value = function(options) {
            if (options.getNormalizer) {
              options = normalizeOpts(options);
              if (length === void 0) {
                length = resolveLength(options.length, fn.length, options.async && extensions.async);
              }
              options.normalizer = options.getNormalizer(length);
              delete options.getNormalizer;
            }
            return memoize(fn.bind(this), options);
          };
        });
        return lazy(props);
      };
    };
  }
});

// node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/methods.js
var require_methods2 = __commonJS({
  "node_modules/.pnpm/memoizee@0.4.15/node_modules/memoizee/methods.js"(exports, module2) {
    "use strict";
    module2.exports = require_methods()(require_memoizee());
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/first-key.js
var require_first_key = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/first-key.js"(exports, module2) {
    "use strict";
    var value = require_valid_value();
    var objPropertyIsEnumerable = Object.prototype.propertyIsEnumerable;
    module2.exports = function(obj) {
      var i;
      value(obj);
      for (i in obj) {
        if (objPropertyIsEnumerable.call(obj, i))
          return i;
      }
      return null;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/for-each-right.js
var require_for_each_right = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/for-each-right.js"(exports, module2) {
    "use strict";
    var toPosInt = require_to_pos_integer();
    var callable = require_valid_callable();
    var value = require_valid_value();
    var objHasOwnProperty = Object.prototype.hasOwnProperty;
    var call = Function.prototype.call;
    module2.exports = function(cb) {
      var i, self2, thisArg;
      self2 = Object(value(this));
      callable(cb);
      thisArg = arguments[1];
      for (i = toPosInt(self2.length) - 1; i >= 0; --i) {
        if (objHasOwnProperty.call(self2, i))
          call.call(cb, thisArg, self2[i], i, self2);
      }
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/uniq.js
var require_uniq = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/uniq.js"(exports, module2) {
    "use strict";
    var indexOf = require_e_index_of();
    var filter = Array.prototype.filter;
    var isFirst;
    isFirst = function(value, index) {
      return indexOf.call(this, value) === index;
    };
    module2.exports = function() {
      return filter.call(this, isFirst, this);
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/sgr.js
var require_sgr = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/sgr.js"(exports, module2) {
    "use strict";
    var assign3 = require_assign();
    var includes = require_contains();
    var forOwn = require_for_each();
    var onlyKey = require_first_key();
    var forEachRight = require_for_each_right();
    var uniq = require_uniq();
    var CSI = "\x1B[";
    var sgr = function(code) {
      return CSI + code + "m";
    };
    sgr.CSI = CSI;
    var mods = assign3({
      bold: { _bold: [1, 22] },
      italic: { _italic: [3, 23] },
      underline: { _underline: [4, 24] },
      blink: { _blink: [5, 25] },
      inverse: { _inverse: [7, 27] },
      strike: { _strike: [9, 29] }
    }, ["black", "red", "green", "yellow", "blue", "magenta", "cyan", "white"].reduce(function(obj, color, index) {
      obj[color] = { _fg: [30 + index, 39] };
      obj[color + "Bright"] = { _fg: [90 + index, 39] };
      obj["bg" + color[0].toUpperCase() + color.slice(1)] = { _bg: [40 + index, 49] };
      obj["bg" + color[0].toUpperCase() + color.slice(1) + "Bright"] = { _bg: [100 + index, 49] };
      return obj;
    }, {}));
    sgr.mods = mods;
    sgr.openers = {};
    sgr.closers = {};
    forOwn(mods, function(mod) {
      var modPair = mod[onlyKey(mod)];
      sgr.openers[modPair[0]] = modPair;
      sgr.closers[modPair[1]] = modPair;
    });
    sgr.openStyle = function(openedMods, code) {
      openedMods.push(sgr.openers[code]);
    };
    sgr.closeStyle = function(openedMods, code) {
      forEachRight.call(openedMods, function(modPair, index) {
        if (modPair[1] === code) {
          openedMods.splice(index, 1);
        }
      });
    };
    sgr.prepend = function(currentMods) {
      return currentMods.map(function(modPair) {
        return sgr(modPair[0]);
      });
    };
    sgr.complete = function(openedMods, closerCodes) {
      closerCodes.forEach(function(code) {
        sgr.closeStyle(openedMods, code);
      });
      openedMods = openedMods.reverse();
      openedMods = openedMods.map(function(modPair) {
        return modPair[1];
      });
      openedMods = uniq.call(openedMods);
      return openedMods.map(sgr);
    };
    var hasCSI = function(str2) {
      return includes.call(str2, CSI);
    };
    sgr.hasCSI = hasCSI;
    var extractCode = function(csi) {
      var code = csi.slice(2, -1);
      code = Number(code);
      return code;
    };
    sgr.extractCode = extractCode;
    module2.exports = sgr;
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/supports-color.js
var require_supports_color = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/supports-color.js"(exports, module2) {
    "use strict";
    var state = null;
    var enableColor = function() {
      state = true;
    };
    var disableColor = function() {
      state = false;
    };
    var autoDetectSupport = function() {
      state = null;
    };
    var isColorSupported = function() {
      return state === null ? !process.env.NO_COLOR : state;
    };
    module2.exports = {
      enableColor,
      disableColor,
      autoDetectSupport,
      isColorSupported
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/xterm-colors.js
var require_xterm_colors = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/xterm-colors.js"(exports, module2) {
    "use strict";
    module2.exports = [
      "000000",
      "800000",
      "008000",
      "808000",
      "000080",
      "800080",
      "008080",
      "c0c0c0",
      "808080",
      "ff0000",
      "00ff00",
      "ffff00",
      "0000ff",
      "ff00ff",
      "00ffff",
      "ffffff",
      "000000",
      "00005f",
      "000087",
      "0000af",
      "0000d7",
      "0000ff",
      "005f00",
      "005f5f",
      "005f87",
      "005faf",
      "005fd7",
      "005fff",
      "008700",
      "00875f",
      "008787",
      "0087af",
      "0087d7",
      "0087ff",
      "00af00",
      "00af5f",
      "00af87",
      "00afaf",
      "00afd7",
      "00afff",
      "00d700",
      "00d75f",
      "00d787",
      "00d7af",
      "00d7d7",
      "00d7ff",
      "00ff00",
      "00ff5f",
      "00ff87",
      "00ffaf",
      "00ffd7",
      "00ffff",
      "5f0000",
      "5f005f",
      "5f0087",
      "5f00af",
      "5f00d7",
      "5f00ff",
      "5f5f00",
      "5f5f5f",
      "5f5f87",
      "5f5faf",
      "5f5fd7",
      "5f5fff",
      "5f8700",
      "5f875f",
      "5f8787",
      "5f87af",
      "5f87d7",
      "5f87ff",
      "5faf00",
      "5faf5f",
      "5faf87",
      "5fafaf",
      "5fafd7",
      "5fafff",
      "5fd700",
      "5fd75f",
      "5fd787",
      "5fd7af",
      "5fd7d7",
      "5fd7ff",
      "5fff00",
      "5fff5f",
      "5fff87",
      "5fffaf",
      "5fffd7",
      "5fffff",
      "870000",
      "87005f",
      "870087",
      "8700af",
      "8700d7",
      "8700ff",
      "875f00",
      "875f5f",
      "875f87",
      "875faf",
      "875fd7",
      "875fff",
      "878700",
      "87875f",
      "878787",
      "8787af",
      "8787d7",
      "8787ff",
      "87af00",
      "87af5f",
      "87af87",
      "87afaf",
      "87afd7",
      "87afff",
      "87d700",
      "87d75f",
      "87d787",
      "87d7af",
      "87d7d7",
      "87d7ff",
      "87ff00",
      "87ff5f",
      "87ff87",
      "87ffaf",
      "87ffd7",
      "87ffff",
      "af0000",
      "af005f",
      "af0087",
      "af00af",
      "af00d7",
      "af00ff",
      "af5f00",
      "af5f5f",
      "af5f87",
      "af5faf",
      "af5fd7",
      "af5fff",
      "af8700",
      "af875f",
      "af8787",
      "af87af",
      "af87d7",
      "af87ff",
      "afaf00",
      "afaf5f",
      "afaf87",
      "afafaf",
      "afafd7",
      "afafff",
      "afd700",
      "afd75f",
      "afd787",
      "afd7af",
      "afd7d7",
      "afd7ff",
      "afff00",
      "afff5f",
      "afff87",
      "afffaf",
      "afffd7",
      "afffff",
      "d70000",
      "d7005f",
      "d70087",
      "d700af",
      "d700d7",
      "d700ff",
      "d75f00",
      "d75f5f",
      "d75f87",
      "d75faf",
      "d75fd7",
      "d75fff",
      "d78700",
      "d7875f",
      "d78787",
      "d787af",
      "d787d7",
      "d787ff",
      "d7af00",
      "d7af5f",
      "d7af87",
      "d7afaf",
      "d7afd7",
      "d7afff",
      "d7d700",
      "d7d75f",
      "d7d787",
      "d7d7af",
      "d7d7d7",
      "d7d7ff",
      "d7ff00",
      "d7ff5f",
      "d7ff87",
      "d7ffaf",
      "d7ffd7",
      "d7ffff",
      "ff0000",
      "ff005f",
      "ff0087",
      "ff00af",
      "ff00d7",
      "ff00ff",
      "ff5f00",
      "ff5f5f",
      "ff5f87",
      "ff5faf",
      "ff5fd7",
      "ff5fff",
      "ff8700",
      "ff875f",
      "ff8787",
      "ff87af",
      "ff87d7",
      "ff87ff",
      "ffaf00",
      "ffaf5f",
      "ffaf87",
      "ffafaf",
      "ffafd7",
      "ffafff",
      "ffd700",
      "ffd75f",
      "ffd787",
      "ffd7af",
      "ffd7d7",
      "ffd7ff",
      "ffff00",
      "ffff5f",
      "ffff87",
      "ffffaf",
      "ffffd7",
      "ffffff",
      "080808",
      "121212",
      "1c1c1c",
      "262626",
      "303030",
      "3a3a3a",
      "444444",
      "4e4e4e",
      "585858",
      "626262",
      "6c6c6c",
      "767676",
      "808080",
      "8a8a8a",
      "949494",
      "9e9e9e",
      "a8a8a8",
      "b2b2b2",
      "bcbcbc",
      "c6c6c6",
      "d0d0d0",
      "dadada",
      "e4e4e4",
      "eeeeee"
    ];
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/xterm-match.js
var require_xterm_match = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/lib/xterm-match.js"(exports, module2) {
    "use strict";
    var push = Array.prototype.push;
    var reduce = Array.prototype.reduce;
    var abs = Math.abs;
    var colors;
    var match;
    var result2;
    var i;
    colors = require_xterm_colors().map(function(color) {
      return {
        r: parseInt(color.slice(0, 2), 16),
        g: parseInt(color.slice(2, 4), 16),
        b: parseInt(color.slice(4), 16)
      };
    });
    match = colors.slice(0, 16);
    module2.exports = result2 = [];
    i = 0;
    while (i < 8) {
      result2.push(30 + i++);
    }
    i = 0;
    while (i < 8) {
      result2.push(90 + i++);
    }
    push.apply(result2, colors.slice(16).map(function(data) {
      var index, diff2 = Infinity;
      match.every(function(innerMatch, currentIndex) {
        var ndiff = reduce.call("rgb", function(currentDiff, channel) {
          currentDiff += abs(innerMatch[channel] - data[channel]);
          return currentDiff;
        }, 0);
        if (ndiff < diff2) {
          index = currentIndex;
          diff2 = ndiff;
        }
        return ndiff;
      });
      return result2[index];
    }));
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/bare.js
var require_bare = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/bare.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var assign3 = require_assign();
    var forEach = require_for_each();
    var map2 = require_map();
    var primitiveSet = require_primitive_set();
    var setPrototypeOf = require_set_prototype_of();
    var memoize = require_memoizee();
    var memoizeMethods = require_methods2();
    var sgr = require_sgr();
    var supportsColor = require_supports_color();
    var mods = sgr.mods;
    var join = Array.prototype.join;
    var defineProperty = Object.defineProperty;
    var max = Math.max;
    var min = Math.min;
    var variantModes = primitiveSet("_fg", "_bg");
    var xtermMatch = process.platform === "win32" ? require_xterm_match() : null;
    var getFn;
    var memoized = memoize(function(scope, mod) {
      return defineProperty(getFn(), "_cliColorData", d(assign3({}, scope._cliColorData, mod)));
    });
    var proto = Object.create(Function.prototype, assign3(map2(mods, function(mod) {
      return d.gs(function() {
        return memoized(this, mod);
      });
    }), memoizeMethods({
      xterm: d(function(code) {
        code = isNaN(code) ? 255 : min(max(code, 0), 255);
        return defineProperty(getFn(), "_cliColorData", d(assign3({}, this._cliColorData, {
          _fg: [xtermMatch ? xtermMatch[code] : "38;5;" + code, 39]
        })));
      }),
      bgXterm: d(function(code) {
        code = isNaN(code) ? 255 : min(max(code, 0), 255);
        return defineProperty(getFn(), "_cliColorData", d(assign3({}, this._cliColorData, {
          _bg: [xtermMatch ? xtermMatch[code] + 10 : "48;5;" + code, 49]
        })));
      })
    })));
    var getEndRe = memoize(function(code) {
      return new RegExp("\x1B\\[" + code + "m", "g");
    }, {
      primitive: true
    });
    getFn = function() {
      return setPrototypeOf(function self2() {
        var start = "", end = "", msg = join.call(arguments, " "), conf = self2._cliColorData, hasAnsi = sgr.hasCSI(msg);
        forEach(conf, function(mod, key) {
          end = sgr(mod[1]) + end;
          start += sgr(mod[0]);
          if (hasAnsi) {
            msg = msg.replace(getEndRe(mod[1]), variantModes[key] ? sgr(mod[0]) : "");
          }
        }, null, true);
        if (!supportsColor.isColorSupported())
          return msg;
        return start + msg + end;
      }, proto);
    };
    module2.exports = Object.defineProperties(getFn(), {
      xtermSupported: d(!xtermMatch),
      _cliColorData: d("", {})
    });
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/window-size.js
var require_window_size = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/window-size.js"(exports) {
    "use strict";
    var d = require_d();
    Object.defineProperties(exports, {
      width: d.gs("ce", function() {
        return process.stdout.columns || 0;
      }),
      height: d.gs("ce", function() {
        return process.stdout.rows || 0;
      })
    });
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/erase.js
var require_erase = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/erase.js"(exports, module2) {
    "use strict";
    module2.exports = {
      screen: "\x1B[2J",
      screenLeft: "\x1B[1J",
      screenRight: "\x1B[J",
      line: "\x1B[2K",
      lineLeft: "\x1B[1K",
      lineRight: "\x1B[K"
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/trunc/is-implemented.js
var require_is_implemented10 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/trunc/is-implemented.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      var trunc = Math.trunc;
      if (typeof trunc !== "function")
        return false;
      return trunc(13.67) === 13 && trunc(-13.67) === -13;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/trunc/shim.js
var require_shim8 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/trunc/shim.js"(exports, module2) {
    "use strict";
    var floor = Math.floor;
    module2.exports = function(value) {
      if (isNaN(value))
        return NaN;
      value = Number(value);
      if (value === 0)
        return value;
      if (value === Infinity)
        return Infinity;
      if (value === -Infinity)
        return -Infinity;
      if (value > 0)
        return floor(value);
      return -floor(-value);
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/trunc/index.js
var require_trunc = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/math/trunc/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented10()() ? Math.trunc : require_shim8();
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/move.js
var require_move = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/move.js"(exports, module2) {
    "use strict";
    var d = require_d();
    var trunc = require_trunc();
    var up;
    var down;
    var right;
    var left;
    var abs = Math.abs;
    var floor = Math.floor;
    var max = Math.max;
    var getMove = function(control) {
      return function(num) {
        num = isNaN(num) ? 0 : max(floor(num), 0);
        return num ? "\x1B[" + num + control : "";
      };
    };
    module2.exports = Object.defineProperties(function(x, y) {
      x = isNaN(x) ? 0 : floor(x);
      y = isNaN(y) ? 0 : floor(y);
      return (x > 0 ? right(x) : left(-x)) + (y > 0 ? down(y) : up(-y));
    }, {
      up: d(up = getMove("A")),
      down: d(down = getMove("B")),
      right: d(right = getMove("C")),
      left: d(left = getMove("D")),
      to: d(function(x, y) {
        x = isNaN(x) ? 1 : max(floor(x), 0) + 1;
        y = isNaN(y) ? 1 : max(floor(y), 0) + 1;
        return "\x1B[" + y + ";" + x + "H";
      }),
      lines: d(function(n) {
        var dir;
        n = trunc(n) || 0;
        dir = n >= 0 ? "B" : "A";
        n = floor(abs(n));
        return "\x1B[" + n + dir + "\x1B[1G";
      }),
      top: d("\x1B[5000F"),
      bottom: d("\x1B[5000B"),
      lineBegin: d("\x1B[5000D"),
      lineEnd: d("\x1B[5000C")
    });
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/beep.js
var require_beep = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/beep.js"(exports, module2) {
    "use strict";
    module2.exports = "\x07";
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/generate.js
var require_generate = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/generate.js"(exports, module2) {
    "use strict";
    var toPosInt = require_to_pos_integer();
    var value = require_valid_value();
    var slice = Array.prototype.slice;
    module2.exports = function(length) {
      var arr, currentLength;
      length = toPosInt(value(length));
      if (length === 0)
        return [];
      arr = arguments.length < 2 ? [void 0] : slice.call(arguments, 1, 1 + length);
      while ((currentLength = arr.length) < length) {
        arr = arr.concat(arr.slice(0, length - currentLength));
      }
      return arr;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-array-like.js
var require_is_array_like = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/is-array-like.js"(exports, module2) {
    "use strict";
    var isFunction = require_is_function();
    var isObject2 = require_is_object();
    var isValue = require_is_value();
    module2.exports = function(value) {
      return isValue(value) && typeof value.length === "number" && (isObject2(value) && !isFunction(value) || typeof value === "string") || false;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/iterable/is.js
var require_is6 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/iterable/is.js"(exports, module2) {
    "use strict";
    var iteratorSymbol = require_es6_symbol().iterator;
    var isValue = require_is_value();
    var isArrayLike = require_is_array_like();
    module2.exports = function(value) {
      if (!isValue(value))
        return false;
      if (typeof value[iteratorSymbol] === "function")
        return true;
      return isArrayLike(value);
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/iterable/validate-object.js
var require_validate_object = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/iterable/validate-object.js"(exports, module2) {
    "use strict";
    var isObject2 = require_is_object();
    var is = require_is6();
    module2.exports = function(value) {
      if (is(value) && isObject2(value))
        return value;
      throw new TypeError(value + " is not an iterable or array-like object");
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/repeat/is-implemented.js
var require_is_implemented11 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/repeat/is-implemented.js"(exports, module2) {
    "use strict";
    var str2 = "foo";
    module2.exports = function() {
      if (typeof str2.repeat !== "function")
        return false;
      return str2.repeat(2) === "foofoo";
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/repeat/shim.js
var require_shim9 = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/repeat/shim.js"(exports, module2) {
    "use strict";
    var value = require_valid_value();
    var toInteger = require_to_integer();
    module2.exports = function(count) {
      var str2 = String(value(this)), result2;
      count = toInteger(count);
      if (count < 0)
        throw new RangeError("Count must be >= 0");
      if (!isFinite(count))
        throw new RangeError("Count must be < \u221E");
      result2 = "";
      while (count) {
        if (count % 2)
          result2 += str2;
        if (count > 1)
          str2 += str2;
        count >>= 1;
      }
      return result2;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/repeat/index.js
var require_repeat = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/string/#/repeat/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_is_implemented11()() ? String.prototype.repeat : require_shim9();
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/regex-ansi.js
var require_regex_ansi = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/regex-ansi.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      return new RegExp("[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)|(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))", "g");
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/strip.js
var require_strip = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/strip.js"(exports, module2) {
    "use strict";
    var stringifiable = require_validate_stringifiable();
    var r = require_regex_ansi()();
    module2.exports = function(str2) {
      return stringifiable(str2).replace(r, "");
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/get-stripped-length.js
var require_get_stripped_length = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/get-stripped-length.js"(exports, module2) {
    "use strict";
    var strip = require_strip();
    module2.exports = function(str2) {
      return strip(str2).length;
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/columns.js
var require_columns = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/columns.js"(exports, module2) {
    "use strict";
    var generate = require_generate();
    var from = require_from();
    var iterable = require_validate_object();
    var isValue = require_is_value();
    var stringifiable = require_validate_stringifiable();
    var repeat2 = require_repeat();
    var getStrippedLength = require_get_stripped_length();
    var push = Array.prototype.push;
    module2.exports = function(inputRows) {
      var options = Object(arguments[1]), colsMeta = [], colsOptions = options.columns || [], rows = [];
      from(iterable(inputRows), function(row) {
        var rowRows = [[]];
        from(iterable(row), function(cellStr, columnIndex) {
          var cellRows = stringifiable(cellStr).split("\n");
          while (cellRows.length > rowRows.length)
            rowRows.push(generate(columnIndex, ""));
          cellRows.forEach(function(cellRow, rowRowIndex) {
            rowRows[rowRowIndex][columnIndex] = cellRow;
          });
        });
        push.apply(rows, rowRows);
      });
      return rows.map(function(row) {
        return from(iterable(row), function(str2, index) {
          var col = colsMeta[index], strLength;
          if (!col)
            col = colsMeta[index] = { width: 0 };
          str2 = stringifiable(str2);
          strLength = getStrippedLength(str2);
          if (strLength > col.width)
            col.width = strLength;
          return { str: str2, length: strLength };
        });
      }).map(function(row) {
        return row.map(function(item, index) {
          var pad, align = "left", colOptions = colsOptions && colsOptions[index];
          align = colOptions && colOptions.align === "right" ? "right" : "left";
          pad = repeat2.call(" ", colsMeta[index].width - item.length);
          if (align === "left")
            return item.str + pad;
          return pad + item.str;
        }).join(isValue(options.sep) ? options.sep : " | ");
      }).join("\n") + "\n";
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/slice.js
var require_slice = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/slice.js"(exports, module2) {
    "use strict";
    var reAnsi = require_regex_ansi();
    var stringifiable = require_validate_stringifiable_value();
    var length = require_get_stripped_length();
    var sgr = require_sgr();
    var max = Math.max;
    var Token = function(token) {
      this.token = token;
    };
    var tokenize = function(str2) {
      var match = reAnsi().exec(str2);
      if (!match) {
        return [str2];
      }
      var index = match.index, head, prehead, tail;
      if (index === 0) {
        head = match[0];
        tail = str2.slice(head.length);
        return [new Token(head)].concat(tokenize(tail));
      }
      prehead = str2.slice(0, index);
      head = match[0];
      tail = str2.slice(index + head.length);
      return [prehead, new Token(head)].concat(tokenize(tail));
    };
    var isChunkInSlice = function(chunk, index, begin, end) {
      var endIndex = chunk.length + index;
      if (begin > endIndex)
        return false;
      if (end < index)
        return false;
      return true;
    };
    var sliceSeq = function(seq2, begin, end) {
      var sliced = seq2.reduce(function(state, chunk) {
        var index = state.index;
        if (chunk instanceof Token) {
          var code = sgr.extractCode(chunk.token);
          if (index <= begin) {
            if (code in sgr.openers) {
              sgr.openStyle(state.preOpeners, code);
            }
            if (code in sgr.closers) {
              sgr.closeStyle(state.preOpeners, code);
            }
          } else if (index < end) {
            if (code in sgr.openers) {
              sgr.openStyle(state.inOpeners, code);
              state.seq.push(chunk);
            } else if (code in sgr.closers) {
              state.inClosers.push(code);
              state.seq.push(chunk);
            }
          }
        } else {
          var nextChunk = "";
          if (isChunkInSlice(chunk, index, begin, end)) {
            var relBegin = Math.max(begin - index, 0), relEnd = Math.min(end - index, chunk.length);
            nextChunk = chunk.slice(relBegin, relEnd);
          }
          state.seq.push(nextChunk);
          state.index = index + chunk.length;
        }
        return state;
      }, {
        index: 0,
        seq: [],
        preOpeners: [],
        inOpeners: [],
        inClosers: []
      });
      sliced.seq = [].concat(sgr.prepend(sliced.preOpeners), sliced.seq, sgr.complete([].concat(sliced.preOpeners, sliced.inOpeners), sliced.inClosers));
      return sliced.seq;
    };
    module2.exports = function(str2) {
      var seq2, begin = Number(arguments[1]), end = Number(arguments[2]), len;
      str2 = stringifiable(str2);
      len = length(str2);
      if (isNaN(begin)) {
        begin = 0;
      }
      if (isNaN(end)) {
        end = len;
      }
      if (begin < 0) {
        begin = max(len + begin, 0);
      }
      if (end < 0) {
        end = max(len + end, 0);
      }
      seq2 = tokenize(str2);
      seq2 = sliceSeq(seq2, begin, end);
      return seq2.map(function(chunk) {
        if (chunk instanceof Token) {
          return chunk.token;
        }
        return chunk;
      }).join("");
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/#/compose.js
var require_compose = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/function/#/compose.js"(exports, module2) {
    "use strict";
    var isValue = require_is_value();
    var callable = require_valid_callable();
    var aFrom = require_from();
    var apply = Function.prototype.apply;
    var call = Function.prototype.call;
    var callFn = function(arg, fn) {
      return call.call(fn, this, arg);
    };
    module2.exports = function(fnIgnored) {
      var fns, first;
      var args = aFrom(arguments);
      fns = isValue(this) ? [this].concat(args) : args;
      fns.forEach(callable);
      fns = fns.reverse();
      first = fns[0];
      fns = fns.slice(1);
      return function(argIgnored) {
        return fns.reduce(callFn, apply.call(first, this, arguments));
      };
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/throbber.js
var require_throbber = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/throbber.js"(exports, module2) {
    "use strict";
    var compose = require_compose();
    var callable = require_valid_callable();
    var d = require_d();
    var validTimeout = require_valid_timeout();
    var chars = "-\\|/";
    var l = chars.length;
    var ThrobberIterator;
    ThrobberIterator = function() {
    };
    Object.defineProperties(ThrobberIterator.prototype, {
      index: d(-1),
      running: d(false),
      next: d(function() {
        var str2 = this.running ? "\b" : "";
        if (!this.running)
          this.running = true;
        return str2 + chars[this.index = (this.index + 1) % l];
      }),
      reset: d(function() {
        if (!this.running)
          return "";
        this.index = -1;
        this.running = false;
        return "\b";
      })
    });
    module2.exports = exports = function(write, interval) {
      var format = arguments[2], token, iterator = new ThrobberIterator();
      callable(write);
      interval = validTimeout(interval);
      if (format !== void 0)
        write = compose.call(write, callable(format));
      return {
        start: function() {
          if (token)
            return;
          token = setInterval(function() {
            write(iterator.next());
          }, interval);
        },
        restart: function() {
          this.stop();
          this.start();
        },
        stop: function() {
          if (!token)
            return;
          clearInterval(token);
          token = null;
          write(iterator.reset());
        }
      };
    };
    Object.defineProperty(exports, "Iterator", d(ThrobberIterator));
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/reset.js
var require_reset = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/reset.js"(exports, module2) {
    "use strict";
    module2.exports = "\x1B[2J\x1B[0;0H";
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/valid-object.js
var require_valid_object = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/valid-object.js"(exports, module2) {
    "use strict";
    var isObject2 = require_is_object();
    module2.exports = function(value) {
      if (!isObject2(value))
        throw new TypeError(value + " is not an Object");
      return value;
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/clear.js
var require_clear = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/array/#/clear.js"(exports, module2) {
    "use strict";
    var value = require_valid_value();
    module2.exports = function() {
      value(this).length = 0;
      return this;
    };
  }
});

// node_modules/.pnpm/type@1.2.0/node_modules/type/plain-function/ensure.js
var require_ensure2 = __commonJS({
  "node_modules/.pnpm/type@1.2.0/node_modules/type/plain-function/ensure.js"(exports, module2) {
    "use strict";
    var resolveException = require_resolve_exception();
    var is = require_is5();
    module2.exports = function(value) {
      if (is(value))
        return value;
      return resolveException(value, "%v is not a plain function", arguments[1]);
    };
  }
});

// node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/copy.js
var require_copy = __commonJS({
  "node_modules/.pnpm/es5-ext@0.10.61/node_modules/es5-ext/object/copy.js"(exports, module2) {
    "use strict";
    var aFrom = require_from();
    var assign3 = require_assign();
    var value = require_valid_value();
    module2.exports = function(obj) {
      var copy = Object(value(obj)), propertyNames = arguments[1], options = Object(arguments[2]);
      if (copy !== obj && !propertyNames)
        return copy;
      var result2 = {};
      if (propertyNames) {
        aFrom(propertyNames, function(propertyName) {
          if (options.ensure || propertyName in obj)
            result2[propertyName] = obj[propertyName];
        });
      } else {
        assign3(result2, obj);
      }
      return result2;
    };
  }
});

// node_modules/.pnpm/d@1.0.1/node_modules/d/auto-bind.js
var require_auto_bind = __commonJS({
  "node_modules/.pnpm/d@1.0.1/node_modules/d/auto-bind.js"(exports, module2) {
    "use strict";
    var isValue = require_is();
    var ensureValue = require_ensure();
    var ensurePlainFunction = require_ensure2();
    var copy = require_copy();
    var normalizeOptions = require_normalize_options();
    var map2 = require_map();
    var bind = Function.prototype.bind;
    var defineProperty = Object.defineProperty;
    var hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var define2;
    define2 = function(name, desc, options) {
      var value = ensureValue(desc) && ensurePlainFunction(desc.value), dgs;
      dgs = copy(desc);
      delete dgs.writable;
      delete dgs.value;
      dgs.get = function() {
        if (!options.overwriteDefinition && hasOwnProperty2.call(this, name))
          return value;
        desc.value = bind.call(value, options.resolveContext ? options.resolveContext(this) : this);
        defineProperty(this, name, desc);
        return this[name];
      };
      return dgs;
    };
    module2.exports = function(props) {
      var options = normalizeOptions(arguments[1]);
      if (isValue(options.resolveContext))
        ensurePlainFunction(options.resolveContext);
      return map2(props, function(desc, name) {
        return define2(name, desc, options);
      });
    };
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/index.js
var require_es6_iterator = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/index.js"(exports, module2) {
    "use strict";
    var clear = require_clear();
    var assign3 = require_assign();
    var callable = require_valid_callable();
    var value = require_valid_value();
    var d = require_d();
    var autoBind = require_auto_bind();
    var Symbol2 = require_es6_symbol();
    var defineProperty = Object.defineProperty;
    var defineProperties = Object.defineProperties;
    var Iterator;
    module2.exports = Iterator = function(list, context) {
      if (!(this instanceof Iterator))
        throw new TypeError("Constructor requires 'new'");
      defineProperties(this, {
        __list__: d("w", value(list)),
        __context__: d("w", context),
        __nextIndex__: d("w", 0)
      });
      if (!context)
        return;
      callable(context.on);
      context.on("_add", this._onAdd);
      context.on("_delete", this._onDelete);
      context.on("_clear", this._onClear);
    };
    delete Iterator.prototype.constructor;
    defineProperties(Iterator.prototype, assign3({
      _next: d(function() {
        var i;
        if (!this.__list__)
          return void 0;
        if (this.__redo__) {
          i = this.__redo__.shift();
          if (i !== void 0)
            return i;
        }
        if (this.__nextIndex__ < this.__list__.length)
          return this.__nextIndex__++;
        this._unBind();
        return void 0;
      }),
      next: d(function() {
        return this._createResult(this._next());
      }),
      _createResult: d(function(i) {
        if (i === void 0)
          return { done: true, value: void 0 };
        return { done: false, value: this._resolve(i) };
      }),
      _resolve: d(function(i) {
        return this.__list__[i];
      }),
      _unBind: d(function() {
        this.__list__ = null;
        delete this.__redo__;
        if (!this.__context__)
          return;
        this.__context__.off("_add", this._onAdd);
        this.__context__.off("_delete", this._onDelete);
        this.__context__.off("_clear", this._onClear);
        this.__context__ = null;
      }),
      toString: d(function() {
        return "[object " + (this[Symbol2.toStringTag] || "Object") + "]";
      })
    }, autoBind({
      _onAdd: d(function(index) {
        if (index >= this.__nextIndex__)
          return;
        ++this.__nextIndex__;
        if (!this.__redo__) {
          defineProperty(this, "__redo__", d("c", [index]));
          return;
        }
        this.__redo__.forEach(function(redo, i) {
          if (redo >= index)
            this.__redo__[i] = ++redo;
        }, this);
        this.__redo__.push(index);
      }),
      _onDelete: d(function(index) {
        var i;
        if (index >= this.__nextIndex__)
          return;
        --this.__nextIndex__;
        if (!this.__redo__)
          return;
        i = this.__redo__.indexOf(index);
        if (i !== -1)
          this.__redo__.splice(i, 1);
        this.__redo__.forEach(function(redo, j) {
          if (redo > index)
            this.__redo__[j] = --redo;
        }, this);
      }),
      _onClear: d(function() {
        if (this.__redo__)
          clear.call(this.__redo__);
        this.__nextIndex__ = 0;
      })
    })));
    defineProperty(Iterator.prototype, Symbol2.iterator, d(function() {
      return this;
    }));
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/array.js
var require_array2 = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/array.js"(exports, module2) {
    "use strict";
    var setPrototypeOf = require_set_prototype_of();
    var contains = require_contains();
    var d = require_d();
    var Symbol2 = require_es6_symbol();
    var Iterator = require_es6_iterator();
    var defineProperty = Object.defineProperty;
    var ArrayIterator;
    ArrayIterator = module2.exports = function(arr, kind) {
      if (!(this instanceof ArrayIterator))
        throw new TypeError("Constructor requires 'new'");
      Iterator.call(this, arr);
      if (!kind)
        kind = "value";
      else if (contains.call(kind, "key+value"))
        kind = "key+value";
      else if (contains.call(kind, "key"))
        kind = "key";
      else
        kind = "value";
      defineProperty(this, "__kind__", d("", kind));
    };
    if (setPrototypeOf)
      setPrototypeOf(ArrayIterator, Iterator);
    delete ArrayIterator.prototype.constructor;
    ArrayIterator.prototype = Object.create(Iterator.prototype, {
      _resolve: d(function(i) {
        if (this.__kind__ === "value")
          return this.__list__[i];
        if (this.__kind__ === "key+value")
          return [i, this.__list__[i]];
        return i;
      })
    });
    defineProperty(ArrayIterator.prototype, Symbol2.toStringTag, d("c", "Array Iterator"));
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/string.js
var require_string2 = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/string.js"(exports, module2) {
    "use strict";
    var setPrototypeOf = require_set_prototype_of();
    var d = require_d();
    var Symbol2 = require_es6_symbol();
    var Iterator = require_es6_iterator();
    var defineProperty = Object.defineProperty;
    var StringIterator;
    StringIterator = module2.exports = function(str2) {
      if (!(this instanceof StringIterator))
        throw new TypeError("Constructor requires 'new'");
      str2 = String(str2);
      Iterator.call(this, str2);
      defineProperty(this, "__length__", d("", str2.length));
    };
    if (setPrototypeOf)
      setPrototypeOf(StringIterator, Iterator);
    delete StringIterator.prototype.constructor;
    StringIterator.prototype = Object.create(Iterator.prototype, {
      _next: d(function() {
        if (!this.__list__)
          return void 0;
        if (this.__nextIndex__ < this.__length__)
          return this.__nextIndex__++;
        this._unBind();
        return void 0;
      }),
      _resolve: d(function(i) {
        var char = this.__list__[i], code;
        if (this.__nextIndex__ === this.__length__)
          return char;
        code = char.charCodeAt(0);
        if (code >= 55296 && code <= 56319)
          return char + this.__list__[this.__nextIndex__++];
        return char;
      })
    });
    defineProperty(StringIterator.prototype, Symbol2.toStringTag, d("c", "String Iterator"));
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/is-iterable.js
var require_is_iterable = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/is-iterable.js"(exports, module2) {
    "use strict";
    var isArguments = require_is_arguments();
    var isValue = require_is_value();
    var isString = require_is_string();
    var iteratorSymbol = require_es6_symbol().iterator;
    var isArray = Array.isArray;
    module2.exports = function(value) {
      if (!isValue(value))
        return false;
      if (isArray(value))
        return true;
      if (isString(value))
        return true;
      if (isArguments(value))
        return true;
      return typeof value[iteratorSymbol] === "function";
    };
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/valid-iterable.js
var require_valid_iterable = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/valid-iterable.js"(exports, module2) {
    "use strict";
    var isIterable = require_is_iterable();
    module2.exports = function(value) {
      if (!isIterable(value))
        throw new TypeError(value + " is not iterable");
      return value;
    };
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/get.js
var require_get2 = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/get.js"(exports, module2) {
    "use strict";
    var isArguments = require_is_arguments();
    var isString = require_is_string();
    var ArrayIterator = require_array2();
    var StringIterator = require_string2();
    var iterable = require_valid_iterable();
    var iteratorSymbol = require_es6_symbol().iterator;
    module2.exports = function(obj) {
      if (typeof iterable(obj)[iteratorSymbol] === "function")
        return obj[iteratorSymbol]();
      if (isArguments(obj))
        return new ArrayIterator(obj);
      if (isString(obj))
        return new StringIterator(obj);
      return new ArrayIterator(obj);
    };
  }
});

// node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/for-of.js
var require_for_of = __commonJS({
  "node_modules/.pnpm/es6-iterator@2.0.3/node_modules/es6-iterator/for-of.js"(exports, module2) {
    "use strict";
    var isArguments = require_is_arguments();
    var callable = require_valid_callable();
    var isString = require_is_string();
    var get = require_get2();
    var isArray = Array.isArray;
    var call = Function.prototype.call;
    var some = Array.prototype.some;
    module2.exports = function(iterable, cb) {
      var mode, thisArg = arguments[2], result2, doBreak, broken, i, length, char, code;
      if (isArray(iterable) || isArguments(iterable))
        mode = "array";
      else if (isString(iterable))
        mode = "string";
      else
        iterable = get(iterable);
      callable(cb);
      doBreak = function() {
        broken = true;
      };
      if (mode === "array") {
        some.call(iterable, function(value) {
          call.call(cb, thisArg, value, doBreak);
          return broken;
        });
        return;
      }
      if (mode === "string") {
        length = iterable.length;
        for (i = 0; i < length; ++i) {
          char = iterable[i];
          if (i + 1 < length) {
            code = char.charCodeAt(0);
            if (code >= 55296 && code <= 56319)
              char += iterable[++i];
          }
          call.call(cb, thisArg, char, doBreak);
          if (broken)
            break;
        }
        return;
      }
      result2 = iterable.next();
      while (!result2.done) {
        call.call(cb, thisArg, result2.value, doBreak);
        if (broken)
          return;
        result2 = iterable.next();
      }
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/art.js
var require_art = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/art.js"(exports, module2) {
    "use strict";
    var object2 = require_valid_object();
    var stringifiable = require_validate_stringifiable_value();
    var forOf = require_for_of();
    module2.exports = function(text, style) {
      var result2 = "";
      text = stringifiable(text);
      object2(style);
      forOf(text, function(char) {
        result2 += style[char] || char;
      });
      return result2;
    };
  }
});

// node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/index.js
var require_cli_color = __commonJS({
  "node_modules/.pnpm/cli-color@2.0.2/node_modules/cli-color/index.js"(exports, module2) {
    "use strict";
    var d = require_d();
    module2.exports = Object.defineProperties(require_bare(), {
      windowSize: d(require_window_size()),
      erase: d(require_erase()),
      move: d(require_move()),
      beep: d(require_beep()),
      columns: d(require_columns()),
      strip: d(require_strip()),
      getStrippedLength: d(require_get_stripped_length()),
      slice: d(require_slice()),
      throbber: d(require_throbber()),
      reset: d(require_reset()),
      art: d(require_art())
    });
  }
});

// node_modules/.pnpm/json-diff@0.9.0/node_modules/json-diff/lib/colorize.js
var require_colorize = __commonJS({
  "node_modules/.pnpm/json-diff@0.9.0/node_modules/json-diff/lib/colorize.js"(exports, module2) {
    var color = require_cli_color();
    var { extendedTypeOf } = require_util2();
    var Theme = {
      " "(s) {
        return s;
      },
      "+": color.green,
      "-": color.red
    };
    var subcolorizeToCallback = function(options, key, diff2, output, color2, indent) {
      let subvalue;
      const prefix = key ? `${key}: ` : "";
      const subindent = indent + "  ";
      const outputElisions = (n) => {
        let maxElisions = options.maxElisions === void 0 ? Infinity : options.maxElisions;
        if (n < maxElisions) {
          for (let i = 0; i < n; i++) {
            output(" ", subindent + "...");
          }
        } else {
          output(" ", subindent + `... (${n} entries)`);
        }
      };
      switch (extendedTypeOf(diff2)) {
        case "object":
          if ("__old" in diff2 && "__new" in diff2 && Object.keys(diff2).length === 2) {
            subcolorizeToCallback(options, key, diff2.__old, output, "-", indent);
            return subcolorizeToCallback(options, key, diff2.__new, output, "+", indent);
          } else {
            output(color2, `${indent}${prefix}{`);
            for (const subkey of Object.keys(diff2)) {
              let m;
              subvalue = diff2[subkey];
              if (m = subkey.match(/^(.*)__deleted$/)) {
                subcolorizeToCallback(options, m[1], subvalue, output, "-", subindent);
              } else if (m = subkey.match(/^(.*)__added$/)) {
                subcolorizeToCallback(options, m[1], subvalue, output, "+", subindent);
              } else {
                subcolorizeToCallback(options, subkey, subvalue, output, color2, subindent);
              }
            }
            return output(color2, `${indent}}`);
          }
        case "array": {
          output(color2, `${indent}${prefix}[`);
          let looksLikeDiff = true;
          for (const item of diff2) {
            if (extendedTypeOf(item) !== "array" || !(item.length === 2 || item.length === 1 && item[0] === " ") || !(typeof item[0] === "string") || item[0].length !== 1 || ![" ", "-", "+", "~"].includes(item[0])) {
              looksLikeDiff = false;
            }
          }
          if (looksLikeDiff) {
            let op;
            let elisionCount = 0;
            for ([op, subvalue] of diff2) {
              if (op === " " && subvalue == null) {
                elisionCount++;
              } else {
                if (elisionCount > 0) {
                  outputElisions(elisionCount);
                }
                elisionCount = 0;
                if (![" ", "~", "+", "-"].includes(op)) {
                  throw new Error(`Unexpected op '${op}' in ${JSON.stringify(diff2, null, 2)}`);
                }
                if (op === "~") {
                  op = " ";
                }
                subcolorizeToCallback(options, "", subvalue, output, op, subindent);
              }
            }
            if (elisionCount > 0) {
              outputElisions(elisionCount);
            }
          } else {
            for (subvalue of diff2) {
              subcolorizeToCallback(options, "", subvalue, output, color2, subindent);
            }
          }
          return output(color2, `${indent}]`);
        }
        default:
          if (diff2 === 0 || diff2 === null || diff2 === false || diff2 === "" || diff2) {
            return output(color2, indent + prefix + JSON.stringify(diff2));
          }
      }
    };
    var colorizeToCallback = (diff2, options, output) => subcolorizeToCallback(options, "", diff2, output, " ", "");
    var colorizeToArray = function(diff2, options = {}) {
      const output = [];
      colorizeToCallback(diff2, options, (color2, line) => output.push(`${color2}${line}`));
      return output;
    };
    var colorize = function(diff2, options = {}) {
      const output = [];
      colorizeToCallback(diff2, options, function(color2, line) {
        if (options.color != null ? options.color : true) {
          return output.push(((options.theme != null ? options.theme[color2] : void 0) != null ? options.theme != null ? options.theme[color2] : void 0 : Theme[color2])(`${color2}${line}`) + "\n");
        } else {
          return output.push(`${color2}${line}
`);
        }
      });
      return output.join("");
    };
    module2.exports = { colorize, colorizeToArray, colorizeToCallback };
  }
});

// node_modules/.pnpm/json-diff@0.9.0/node_modules/json-diff/lib/index.js
var require_lib5 = __commonJS({
  "node_modules/.pnpm/json-diff@0.9.0/node_modules/json-diff/lib/index.js"(exports, module2) {
    var { SequenceMatcher } = require_difflib2();
    var { extendedTypeOf, roundObj } = require_util2();
    var { colorize } = require_colorize();
    var JsonDiff = class {
      constructor(options) {
        options.outputKeys = options.outputKeys || [];
        this.options = options;
      }
      isScalar(obj) {
        return typeof obj !== "object" || obj === null;
      }
      objectDiff(obj1, obj2) {
        let result2 = {};
        let score = 0;
        let equal = true;
        for (const [key, value] of Object.entries(obj1)) {
          if (!this.options.outputNewOnly) {
            let postfix = "__deleted";
            if (!(key in obj2)) {
              result2[`${key}${postfix}`] = value;
              score -= 30;
              equal = false;
            }
          }
        }
        for (const [key, value] of Object.entries(obj2)) {
          let postfix = !this.options.outputNewOnly ? "__added" : "";
          if (!(key in obj1)) {
            result2[`${key}${postfix}`] = value;
            score -= 30;
            equal = false;
          }
        }
        for (const [key, value1] of Object.entries(obj1)) {
          if (key in obj2) {
            score += 20;
            const value2 = obj2[key];
            const change = this.diff(value1, value2);
            if (!change.equal) {
              result2[key] = change.result;
              equal = false;
            } else if (this.options.full || this.options.outputKeys.includes(key)) {
              result2[key] = value1;
            }
            score += Math.min(20, Math.max(-10, change.score / 5));
          }
        }
        if (equal) {
          score = 100 * Math.max(Object.keys(obj1).length, 0.5);
          if (!this.options.full) {
            result2 = void 0;
          }
        } else {
          score = Math.max(0, score);
        }
        return { score, result: result2, equal };
      }
      findMatchingObject(item, index, fuzzyOriginals) {
        let bestMatch = null;
        for (const [key, { item: candidate, index: matchIndex }] of Object.entries(fuzzyOriginals)) {
          if (key !== "__next") {
            const indexDistance = Math.abs(matchIndex - index);
            if (extendedTypeOf(item) === extendedTypeOf(candidate)) {
              const { score } = this.diff(item, candidate);
              if (!bestMatch || score > bestMatch.score || score === bestMatch.score && indexDistance < bestMatch.indexDistance) {
                bestMatch = { score, key, indexDistance };
              }
            }
          }
        }
        return bestMatch;
      }
      scalarize(array, originals, fuzzyOriginals) {
        const fuzzyMatches = [];
        if (fuzzyOriginals) {
          const keyScores = {};
          for (let index = 0; index < array.length; index++) {
            const item = array[index];
            if (this.isScalar(item)) {
              continue;
            }
            const bestMatch = this.findMatchingObject(item, index, fuzzyOriginals);
            if (bestMatch && (!keyScores[bestMatch.key] || bestMatch.score > keyScores[bestMatch.key].score)) {
              keyScores[bestMatch.key] = { score: bestMatch.score, index };
            }
          }
          for (const [key, match] of Object.entries(keyScores)) {
            fuzzyMatches[match.index] = key;
          }
        }
        const result2 = [];
        for (let index = 0; index < array.length; index++) {
          const item = array[index];
          if (this.isScalar(item)) {
            result2.push(item);
          } else {
            const key = fuzzyMatches[index] || "__$!SCALAR" + originals.__next++;
            originals[key] = { item, index };
            result2.push(key);
          }
        }
        return result2;
      }
      isScalarized(item, originals) {
        return typeof item === "string" && item in originals;
      }
      descalarize(item, originals) {
        if (this.isScalarized(item, originals)) {
          return originals[item].item;
        } else {
          return item;
        }
      }
      arrayDiff(obj1, obj2) {
        const originals1 = { __next: 1 };
        const seq1 = this.scalarize(obj1, originals1);
        const originals2 = { __next: originals1.__next };
        const seq2 = this.scalarize(obj2, originals2, originals1);
        if (this.options.sort) {
          seq1.sort();
          seq2.sort();
        }
        const opcodes = new SequenceMatcher(null, seq1, seq2).getOpcodes();
        let result2 = [];
        let score = 0;
        let equal = true;
        for (const [op, i1, i2, j1, j2] of opcodes) {
          let i, j;
          let asc, end;
          let asc1, end1;
          let asc2, end2;
          if (!(op === "equal" || this.options.keysOnly && op === "replace")) {
            equal = false;
          }
          switch (op) {
            case "equal":
              for (i = i1, end = i2, asc = i1 <= end; asc ? i < end : i > end; asc ? i++ : i--) {
                const item = seq1[i];
                if (this.isScalarized(item, originals1)) {
                  if (!this.isScalarized(item, originals2)) {
                    throw new Error(`internal bug: isScalarized(item, originals1) != isScalarized(item, originals2) for item ${JSON.stringify(item)}`);
                  }
                  const item1 = this.descalarize(item, originals1);
                  const item2 = this.descalarize(item, originals2);
                  const change = this.diff(item1, item2);
                  if (!change.equal) {
                    result2.push(["~", change.result]);
                    equal = false;
                  } else {
                    if (this.options.full || this.options.keepUnchangedValues) {
                      result2.push([" ", item1]);
                    } else {
                      result2.push([" "]);
                    }
                  }
                } else {
                  if (this.options.full || this.options.keepUnchangedValues) {
                    result2.push([" ", item]);
                  } else {
                    result2.push([" "]);
                  }
                }
                score += 10;
              }
              break;
            case "delete":
              for (i = i1, end1 = i2, asc1 = i1 <= end1; asc1 ? i < end1 : i > end1; asc1 ? i++ : i--) {
                result2.push(["-", this.descalarize(seq1[i], originals1)]);
                score -= 5;
              }
              break;
            case "insert":
              for (j = j1, end2 = j2, asc2 = j1 <= end2; asc2 ? j < end2 : j > end2; asc2 ? j++ : j--) {
                result2.push(["+", this.descalarize(seq2[j], originals2)]);
                score -= 5;
              }
              break;
            case "replace":
              if (!this.options.keysOnly) {
                let asc3, end3;
                let asc4, end4;
                for (i = i1, end3 = i2, asc3 = i1 <= end3; asc3 ? i < end3 : i > end3; asc3 ? i++ : i--) {
                  result2.push(["-", this.descalarize(seq1[i], originals1)]);
                  score -= 5;
                }
                for (j = j1, end4 = j2, asc4 = j1 <= end4; asc4 ? j < end4 : j > end4; asc4 ? j++ : j--) {
                  result2.push(["+", this.descalarize(seq2[j], originals2)]);
                  score -= 5;
                }
              } else {
                let asc5, end5;
                for (i = i1, end5 = i2, asc5 = i1 <= end5; asc5 ? i < end5 : i > end5; asc5 ? i++ : i--) {
                  const change = this.diff(this.descalarize(seq1[i], originals1), this.descalarize(seq2[i - i1 + j1], originals2));
                  if (!change.equal) {
                    result2.push(["~", change.result]);
                    equal = false;
                  } else {
                    result2.push([" "]);
                  }
                }
              }
              break;
          }
        }
        if (equal || opcodes.length === 0) {
          if (!this.options.full) {
            result2 = void 0;
          } else {
            result2 = obj1;
          }
          score = 100;
        } else {
          score = Math.max(0, score);
        }
        return { score, result: result2, equal };
      }
      diff(obj1, obj2) {
        const type1 = extendedTypeOf(obj1);
        const type2 = extendedTypeOf(obj2);
        if (type1 === type2) {
          switch (type1) {
            case "object":
              return this.objectDiff(obj1, obj2);
            case "array":
              return this.arrayDiff(obj1, obj2);
          }
        }
        let score = 100;
        let result2 = obj1;
        let equal;
        if (!this.options.keysOnly) {
          equal = obj1 === obj2;
          if (!equal) {
            score = 0;
            if (this.options.outputNewOnly) {
              result2 = obj2;
            } else {
              result2 = { __old: obj1, __new: obj2 };
            }
          } else if (!this.options.full) {
            result2 = void 0;
          }
        } else {
          equal = true;
          result2 = void 0;
        }
        return { score, result: result2, equal };
      }
    };
    function diff2(obj1, obj2, options = {}) {
      if (options.precision !== void 0) {
        obj1 = roundObj(obj1, options.precision);
        obj2 = roundObj(obj2, options.precision);
      }
      return new JsonDiff(options).diff(obj1, obj2).result;
    }
    function diffString(obj1, obj2, options = {}) {
      return colorize(diff2(obj1, obj2, options), options);
    }
    module2.exports = { diff: diff2, diffString };
  }
});

// node_modules/.pnpm/nanoclone@0.2.1/node_modules/nanoclone/index.js
var require_nanoclone = __commonJS({
  "node_modules/.pnpm/nanoclone@0.2.1/node_modules/nanoclone/index.js"(exports, module2) {
    "use strict";
    var map2;
    try {
      map2 = Map;
    } catch (_) {
    }
    var set2;
    try {
      set2 = Set;
    } catch (_) {
    }
    function baseClone(src, circulars, clones) {
      if (!src || typeof src !== "object" || typeof src === "function") {
        return src;
      }
      if (src.nodeType && "cloneNode" in src) {
        return src.cloneNode(true);
      }
      if (src instanceof Date) {
        return new Date(src.getTime());
      }
      if (src instanceof RegExp) {
        return new RegExp(src);
      }
      if (Array.isArray(src)) {
        return src.map(clone);
      }
      if (map2 && src instanceof map2) {
        return new Map(Array.from(src.entries()));
      }
      if (set2 && src instanceof set2) {
        return new Set(Array.from(src.values()));
      }
      if (src instanceof Object) {
        circulars.push(src);
        var obj = Object.create(src);
        clones.push(obj);
        for (var key in src) {
          var idx2 = circulars.findIndex(function(i) {
            return i === src[key];
          });
          obj[key] = idx2 > -1 ? clones[idx2] : baseClone(src[key], circulars, clones);
        }
        return obj;
      }
      return src;
    }
    function clone(src) {
      return baseClone(src, [], []);
    }
    module2.exports = clone;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/printValue.js
var require_printValue = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/printValue.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = printValue;
    var toString2 = Object.prototype.toString;
    var errorToString = Error.prototype.toString;
    var regExpToString = RegExp.prototype.toString;
    var symbolToString = typeof Symbol !== "undefined" ? Symbol.prototype.toString : () => "";
    var SYMBOL_REGEXP = /^Symbol\((.*)\)(.*)$/;
    function printNumber(val) {
      if (val != +val)
        return "NaN";
      const isNegativeZero2 = val === 0 && 1 / val < 0;
      return isNegativeZero2 ? "-0" : "" + val;
    }
    function printSimpleValue(val, quoteStrings = false) {
      if (val == null || val === true || val === false)
        return "" + val;
      const typeOf = typeof val;
      if (typeOf === "number")
        return printNumber(val);
      if (typeOf === "string")
        return quoteStrings ? `"${val}"` : val;
      if (typeOf === "function")
        return "[Function " + (val.name || "anonymous") + "]";
      if (typeOf === "symbol")
        return symbolToString.call(val).replace(SYMBOL_REGEXP, "Symbol($1)");
      const tag = toString2.call(val).slice(8, -1);
      if (tag === "Date")
        return isNaN(val.getTime()) ? "" + val : val.toISOString(val);
      if (tag === "Error" || val instanceof Error)
        return "[" + errorToString.call(val) + "]";
      if (tag === "RegExp")
        return regExpToString.call(val);
      return null;
    }
    function printValue(value, quoteStrings) {
      let result2 = printSimpleValue(value, quoteStrings);
      if (result2 !== null)
        return result2;
      return JSON.stringify(value, function(key, value2) {
        let result3 = printSimpleValue(this[key], quoteStrings);
        if (result3 !== null)
          return result3;
        return value2;
      }, 2);
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/locale.js
var require_locale = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/locale.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.string = exports.object = exports.number = exports.mixed = exports.default = exports.date = exports.boolean = exports.array = void 0;
    var _printValue = _interopRequireDefault(require_printValue());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var mixed2 = {
      default: "${path} is invalid",
      required: "${path} is a required field",
      oneOf: "${path} must be one of the following values: ${values}",
      notOneOf: "${path} must not be one of the following values: ${values}",
      notType: ({
        path: path2,
        type: type2,
        value,
        originalValue
      }) => {
        let isCast = originalValue != null && originalValue !== value;
        let msg = `${path2} must be a \`${type2}\` type, but the final value was: \`${(0, _printValue.default)(value, true)}\`` + (isCast ? ` (cast from the value \`${(0, _printValue.default)(originalValue, true)}\`).` : ".");
        if (value === null) {
          msg += `
 If "null" is intended as an empty value be sure to mark the schema as \`.nullable()\``;
        }
        return msg;
      },
      defined: "${path} must be defined"
    };
    exports.mixed = mixed2;
    var string2 = {
      length: "${path} must be exactly ${length} characters",
      min: "${path} must be at least ${min} characters",
      max: "${path} must be at most ${max} characters",
      matches: '${path} must match the following: "${regex}"',
      email: "${path} must be a valid email",
      url: "${path} must be a valid URL",
      uuid: "${path} must be a valid UUID",
      trim: "${path} must be a trimmed string",
      lowercase: "${path} must be a lowercase string",
      uppercase: "${path} must be a upper case string"
    };
    exports.string = string2;
    var number = {
      min: "${path} must be greater than or equal to ${min}",
      max: "${path} must be less than or equal to ${max}",
      lessThan: "${path} must be less than ${less}",
      moreThan: "${path} must be greater than ${more}",
      positive: "${path} must be a positive number",
      negative: "${path} must be a negative number",
      integer: "${path} must be an integer"
    };
    exports.number = number;
    var date = {
      min: "${path} field must be later than ${min}",
      max: "${path} field must be at earlier than ${max}"
    };
    exports.date = date;
    var boolean2 = {
      isValue: "${path} field must be ${value}"
    };
    exports.boolean = boolean2;
    var object2 = {
      noUnknown: "${path} field has unspecified keys: ${unknown}"
    };
    exports.object = object2;
    var array = {
      min: "${path} field must have at least ${min} items",
      max: "${path} field must have less than or equal to ${max} items",
      length: "${path} must have ${length} items"
    };
    exports.array = array;
    var _default2 = Object.assign(/* @__PURE__ */ Object.create(null), {
      mixed: mixed2,
      string: string2,
      number,
      date,
      object: object2,
      array,
      boolean: boolean2
    });
    exports.default = _default2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseHas.js
var require_baseHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseHas.js"(exports, module2) {
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function baseHas(object2, key) {
      return object2 != null && hasOwnProperty2.call(object2, key);
    }
    module2.exports = baseHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArray.js
var require_isArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArray.js"(exports, module2) {
    var isArray = Array.isArray;
    module2.exports = isArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_freeGlobal.js
var require_freeGlobal = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_freeGlobal.js"(exports, module2) {
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
    module2.exports = freeGlobal;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_root.js
var require_root = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_root.js"(exports, module2) {
    var freeGlobal = require_freeGlobal();
    var freeSelf = typeof self == "object" && self && self.Object === Object && self;
    var root = freeGlobal || freeSelf || Function("return this")();
    module2.exports = root;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Symbol.js
var require_Symbol = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Symbol.js"(exports, module2) {
    var root = require_root();
    var Symbol2 = root.Symbol;
    module2.exports = Symbol2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getRawTag.js
var require_getRawTag = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getRawTag.js"(exports, module2) {
    var Symbol2 = require_Symbol();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var nativeObjectToString = objectProto.toString;
    var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
    function getRawTag(value) {
      var isOwn = hasOwnProperty2.call(value, symToStringTag), tag = value[symToStringTag];
      try {
        value[symToStringTag] = void 0;
        var unmasked = true;
      } catch (e) {
      }
      var result2 = nativeObjectToString.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag] = tag;
        } else {
          delete value[symToStringTag];
        }
      }
      return result2;
    }
    module2.exports = getRawTag;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_objectToString.js
var require_objectToString = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_objectToString.js"(exports, module2) {
    var objectProto = Object.prototype;
    var nativeObjectToString = objectProto.toString;
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }
    module2.exports = objectToString;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseGetTag.js
var require_baseGetTag = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseGetTag.js"(exports, module2) {
    var Symbol2 = require_Symbol();
    var getRawTag = require_getRawTag();
    var objectToString = require_objectToString();
    var nullTag = "[object Null]";
    var undefinedTag = "[object Undefined]";
    var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
    function baseGetTag(value) {
      if (value == null) {
        return value === void 0 ? undefinedTag : nullTag;
      }
      return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
    }
    module2.exports = baseGetTag;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isObjectLike.js
var require_isObjectLike = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isObjectLike.js"(exports, module2) {
    function isObjectLike(value) {
      return value != null && typeof value == "object";
    }
    module2.exports = isObjectLike;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isSymbol.js
var require_isSymbol = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isSymbol.js"(exports, module2) {
    var baseGetTag = require_baseGetTag();
    var isObjectLike = require_isObjectLike();
    var symbolTag = "[object Symbol]";
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
    }
    module2.exports = isSymbol;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isKey.js
var require_isKey = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isKey.js"(exports, module2) {
    var isArray = require_isArray();
    var isSymbol = require_isSymbol();
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
    var reIsPlainProp = /^\w*$/;
    function isKey(value, object2) {
      if (isArray(value)) {
        return false;
      }
      var type2 = typeof value;
      if (type2 == "number" || type2 == "symbol" || type2 == "boolean" || value == null || isSymbol(value)) {
        return true;
      }
      return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object2 != null && value in Object(object2);
    }
    module2.exports = isKey;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isObject.js
var require_isObject = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isObject.js"(exports, module2) {
    function isObject2(value) {
      var type2 = typeof value;
      return value != null && (type2 == "object" || type2 == "function");
    }
    module2.exports = isObject2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isFunction.js
var require_isFunction = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isFunction.js"(exports, module2) {
    var baseGetTag = require_baseGetTag();
    var isObject2 = require_isObject();
    var asyncTag = "[object AsyncFunction]";
    var funcTag = "[object Function]";
    var genTag = "[object GeneratorFunction]";
    var proxyTag = "[object Proxy]";
    function isFunction(value) {
      if (!isObject2(value)) {
        return false;
      }
      var tag = baseGetTag(value);
      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
    }
    module2.exports = isFunction;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_coreJsData.js
var require_coreJsData = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_coreJsData.js"(exports, module2) {
    var root = require_root();
    var coreJsData = root["__core-js_shared__"];
    module2.exports = coreJsData;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isMasked.js
var require_isMasked = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isMasked.js"(exports, module2) {
    var coreJsData = require_coreJsData();
    var maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }();
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    module2.exports = isMasked;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_toSource.js
var require_toSource = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_toSource.js"(exports, module2) {
    var funcProto = Function.prototype;
    var funcToString = funcProto.toString;
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch (e) {
        }
        try {
          return func + "";
        } catch (e) {
        }
      }
      return "";
    }
    module2.exports = toSource;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsNative.js
var require_baseIsNative = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsNative.js"(exports, module2) {
    var isFunction = require_isFunction();
    var isMasked = require_isMasked();
    var isObject2 = require_isObject();
    var toSource = require_toSource();
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var funcProto = Function.prototype;
    var objectProto = Object.prototype;
    var funcToString = funcProto.toString;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
    function baseIsNative(value) {
      if (!isObject2(value) || isMasked(value)) {
        return false;
      }
      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    module2.exports = baseIsNative;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getValue.js
var require_getValue = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getValue.js"(exports, module2) {
    function getValue(object2, key) {
      return object2 == null ? void 0 : object2[key];
    }
    module2.exports = getValue;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getNative.js
var require_getNative = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getNative.js"(exports, module2) {
    var baseIsNative = require_baseIsNative();
    var getValue = require_getValue();
    function getNative(object2, key) {
      var value = getValue(object2, key);
      return baseIsNative(value) ? value : void 0;
    }
    module2.exports = getNative;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeCreate.js
var require_nativeCreate = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeCreate.js"(exports, module2) {
    var getNative = require_getNative();
    var nativeCreate = getNative(Object, "create");
    module2.exports = nativeCreate;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashClear.js
var require_hashClear = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashClear.js"(exports, module2) {
    var nativeCreate = require_nativeCreate();
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
      this.size = 0;
    }
    module2.exports = hashClear;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashDelete.js
var require_hashDelete = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashDelete.js"(exports, module2) {
    function hashDelete(key) {
      var result2 = this.has(key) && delete this.__data__[key];
      this.size -= result2 ? 1 : 0;
      return result2;
    }
    module2.exports = hashDelete;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashGet.js
var require_hashGet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashGet.js"(exports, module2) {
    var nativeCreate = require_nativeCreate();
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result2 = data[key];
        return result2 === HASH_UNDEFINED ? void 0 : result2;
      }
      return hasOwnProperty2.call(data, key) ? data[key] : void 0;
    }
    module2.exports = hashGet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashHas.js
var require_hashHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashHas.js"(exports, module2) {
    var nativeCreate = require_nativeCreate();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? data[key] !== void 0 : hasOwnProperty2.call(data, key);
    }
    module2.exports = hashHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashSet.js
var require_hashSet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hashSet.js"(exports, module2) {
    var nativeCreate = require_nativeCreate();
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    function hashSet(key, value) {
      var data = this.__data__;
      this.size += this.has(key) ? 0 : 1;
      data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value;
      return this;
    }
    module2.exports = hashSet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Hash.js
var require_Hash = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Hash.js"(exports, module2) {
    var hashClear = require_hashClear();
    var hashDelete = require_hashDelete();
    var hashGet = require_hashGet();
    var hashHas = require_hashHas();
    var hashSet = require_hashSet();
    function Hash(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype["delete"] = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    module2.exports = Hash;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheClear.js
var require_listCacheClear = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheClear.js"(exports, module2) {
    function listCacheClear() {
      this.__data__ = [];
      this.size = 0;
    }
    module2.exports = listCacheClear;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/eq.js
var require_eq = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/eq.js"(exports, module2) {
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    module2.exports = eq;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assocIndexOf.js
var require_assocIndexOf = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assocIndexOf.js"(exports, module2) {
    var eq = require_eq();
    function assocIndexOf(array, key) {
      var length = array.length;
      while (length--) {
        if (eq(array[length][0], key)) {
          return length;
        }
      }
      return -1;
    }
    module2.exports = assocIndexOf;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheDelete.js
var require_listCacheDelete = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheDelete.js"(exports, module2) {
    var assocIndexOf = require_assocIndexOf();
    var arrayProto = Array.prototype;
    var splice = arrayProto.splice;
    function listCacheDelete(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice.call(data, index, 1);
      }
      --this.size;
      return true;
    }
    module2.exports = listCacheDelete;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheGet.js
var require_listCacheGet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheGet.js"(exports, module2) {
    var assocIndexOf = require_assocIndexOf();
    function listCacheGet(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    module2.exports = listCacheGet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheHas.js
var require_listCacheHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheHas.js"(exports, module2) {
    var assocIndexOf = require_assocIndexOf();
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }
    module2.exports = listCacheHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheSet.js
var require_listCacheSet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_listCacheSet.js"(exports, module2) {
    var assocIndexOf = require_assocIndexOf();
    function listCacheSet(key, value) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0) {
        ++this.size;
        data.push([key, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }
    module2.exports = listCacheSet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_ListCache.js
var require_ListCache = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_ListCache.js"(exports, module2) {
    var listCacheClear = require_listCacheClear();
    var listCacheDelete = require_listCacheDelete();
    var listCacheGet = require_listCacheGet();
    var listCacheHas = require_listCacheHas();
    var listCacheSet = require_listCacheSet();
    function ListCache(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype["delete"] = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    module2.exports = ListCache;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Map.js
var require_Map = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Map.js"(exports, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var Map2 = getNative(root, "Map");
    module2.exports = Map2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheClear.js
var require_mapCacheClear = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheClear.js"(exports, module2) {
    var Hash = require_Hash();
    var ListCache = require_ListCache();
    var Map2 = require_Map();
    function mapCacheClear() {
      this.size = 0;
      this.__data__ = {
        "hash": new Hash(),
        "map": new (Map2 || ListCache)(),
        "string": new Hash()
      };
    }
    module2.exports = mapCacheClear;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isKeyable.js
var require_isKeyable = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isKeyable.js"(exports, module2) {
    function isKeyable(value) {
      var type2 = typeof value;
      return type2 == "string" || type2 == "number" || type2 == "symbol" || type2 == "boolean" ? value !== "__proto__" : value === null;
    }
    module2.exports = isKeyable;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getMapData.js
var require_getMapData = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getMapData.js"(exports, module2) {
    var isKeyable = require_isKeyable();
    function getMapData(map2, key) {
      var data = map2.__data__;
      return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    module2.exports = getMapData;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheDelete.js
var require_mapCacheDelete = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheDelete.js"(exports, module2) {
    var getMapData = require_getMapData();
    function mapCacheDelete(key) {
      var result2 = getMapData(this, key)["delete"](key);
      this.size -= result2 ? 1 : 0;
      return result2;
    }
    module2.exports = mapCacheDelete;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheGet.js
var require_mapCacheGet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheGet.js"(exports, module2) {
    var getMapData = require_getMapData();
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }
    module2.exports = mapCacheGet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheHas.js
var require_mapCacheHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheHas.js"(exports, module2) {
    var getMapData = require_getMapData();
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }
    module2.exports = mapCacheHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheSet.js
var require_mapCacheSet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapCacheSet.js"(exports, module2) {
    var getMapData = require_getMapData();
    function mapCacheSet(key, value) {
      var data = getMapData(this, key), size = data.size;
      data.set(key, value);
      this.size += data.size == size ? 0 : 1;
      return this;
    }
    module2.exports = mapCacheSet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_MapCache.js
var require_MapCache = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_MapCache.js"(exports, module2) {
    var mapCacheClear = require_mapCacheClear();
    var mapCacheDelete = require_mapCacheDelete();
    var mapCacheGet = require_mapCacheGet();
    var mapCacheHas = require_mapCacheHas();
    var mapCacheSet = require_mapCacheSet();
    function MapCache(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype["delete"] = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    module2.exports = MapCache;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/memoize.js
var require_memoize = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/memoize.js"(exports, module2) {
    var MapCache = require_MapCache();
    var FUNC_ERROR_TEXT = "Expected a function";
    function memoize(func, resolver) {
      if (typeof func != "function" || resolver != null && typeof resolver != "function") {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      var memoized = function() {
        var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
        if (cache.has(key)) {
          return cache.get(key);
        }
        var result2 = func.apply(this, args);
        memoized.cache = cache.set(key, result2) || cache;
        return result2;
      };
      memoized.cache = new (memoize.Cache || MapCache)();
      return memoized;
    }
    memoize.Cache = MapCache;
    module2.exports = memoize;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_memoizeCapped.js
var require_memoizeCapped = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_memoizeCapped.js"(exports, module2) {
    var memoize = require_memoize();
    var MAX_MEMOIZE_SIZE = 500;
    function memoizeCapped(func) {
      var result2 = memoize(func, function(key) {
        if (cache.size === MAX_MEMOIZE_SIZE) {
          cache.clear();
        }
        return key;
      });
      var cache = result2.cache;
      return result2;
    }
    module2.exports = memoizeCapped;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stringToPath.js
var require_stringToPath = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stringToPath.js"(exports, module2) {
    var memoizeCapped = require_memoizeCapped();
    var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reEscapeChar = /\\(\\)?/g;
    var stringToPath = memoizeCapped(function(string2) {
      var result2 = [];
      if (string2.charCodeAt(0) === 46) {
        result2.push("");
      }
      string2.replace(rePropName, function(match, number, quote, subString) {
        result2.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
      });
      return result2;
    });
    module2.exports = stringToPath;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayMap.js
var require_arrayMap = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayMap.js"(exports, module2) {
    function arrayMap(array, iteratee) {
      var index = -1, length = array == null ? 0 : array.length, result2 = Array(length);
      while (++index < length) {
        result2[index] = iteratee(array[index], index, array);
      }
      return result2;
    }
    module2.exports = arrayMap;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseToString.js
var require_baseToString = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseToString.js"(exports, module2) {
    var Symbol2 = require_Symbol();
    var arrayMap = require_arrayMap();
    var isArray = require_isArray();
    var isSymbol = require_isSymbol();
    var INFINITY = 1 / 0;
    var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
    var symbolToString = symbolProto ? symbolProto.toString : void 0;
    function baseToString(value) {
      if (typeof value == "string") {
        return value;
      }
      if (isArray(value)) {
        return arrayMap(value, baseToString) + "";
      }
      if (isSymbol(value)) {
        return symbolToString ? symbolToString.call(value) : "";
      }
      var result2 = value + "";
      return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
    }
    module2.exports = baseToString;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/toString.js
var require_toString = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/toString.js"(exports, module2) {
    var baseToString = require_baseToString();
    function toString2(value) {
      return value == null ? "" : baseToString(value);
    }
    module2.exports = toString2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_castPath.js
var require_castPath = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_castPath.js"(exports, module2) {
    var isArray = require_isArray();
    var isKey = require_isKey();
    var stringToPath = require_stringToPath();
    var toString2 = require_toString();
    function castPath(value, object2) {
      if (isArray(value)) {
        return value;
      }
      return isKey(value, object2) ? [value] : stringToPath(toString2(value));
    }
    module2.exports = castPath;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsArguments.js
var require_baseIsArguments = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsArguments.js"(exports, module2) {
    var baseGetTag = require_baseGetTag();
    var isObjectLike = require_isObjectLike();
    var argsTag = "[object Arguments]";
    function baseIsArguments(value) {
      return isObjectLike(value) && baseGetTag(value) == argsTag;
    }
    module2.exports = baseIsArguments;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArguments.js
var require_isArguments = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArguments.js"(exports, module2) {
    var baseIsArguments = require_baseIsArguments();
    var isObjectLike = require_isObjectLike();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var propertyIsEnumerable = objectProto.propertyIsEnumerable;
    var isArguments = baseIsArguments(function() {
      return arguments;
    }()) ? baseIsArguments : function(value) {
      return isObjectLike(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
    };
    module2.exports = isArguments;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isIndex.js
var require_isIndex = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isIndex.js"(exports, module2) {
    var MAX_SAFE_INTEGER = 9007199254740991;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    function isIndex(value, length) {
      var type2 = typeof value;
      length = length == null ? MAX_SAFE_INTEGER : length;
      return !!length && (type2 == "number" || type2 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
    }
    module2.exports = isIndex;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isLength.js
var require_isLength = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isLength.js"(exports, module2) {
    var MAX_SAFE_INTEGER = 9007199254740991;
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    module2.exports = isLength;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_toKey.js
var require_toKey = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_toKey.js"(exports, module2) {
    var isSymbol = require_isSymbol();
    var INFINITY = 1 / 0;
    function toKey(value) {
      if (typeof value == "string" || isSymbol(value)) {
        return value;
      }
      var result2 = value + "";
      return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
    }
    module2.exports = toKey;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasPath.js
var require_hasPath = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasPath.js"(exports, module2) {
    var castPath = require_castPath();
    var isArguments = require_isArguments();
    var isArray = require_isArray();
    var isIndex = require_isIndex();
    var isLength = require_isLength();
    var toKey = require_toKey();
    function hasPath(object2, path2, hasFunc) {
      path2 = castPath(path2, object2);
      var index = -1, length = path2.length, result2 = false;
      while (++index < length) {
        var key = toKey(path2[index]);
        if (!(result2 = object2 != null && hasFunc(object2, key))) {
          break;
        }
        object2 = object2[key];
      }
      if (result2 || ++index != length) {
        return result2;
      }
      length = object2 == null ? 0 : object2.length;
      return !!length && isLength(length) && isIndex(key, length) && (isArray(object2) || isArguments(object2));
    }
    module2.exports = hasPath;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/has.js
var require_has = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/has.js"(exports, module2) {
    var baseHas = require_baseHas();
    var hasPath = require_hasPath();
    function has(object2, path2) {
      return object2 != null && hasPath(object2, path2, baseHas);
    }
    module2.exports = has;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/isSchema.js
var require_isSchema = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/isSchema.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    var isSchema = (obj) => obj && obj.__isYupSchema__;
    var _default2 = isSchema;
    exports.default = _default2;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/Condition.js
var require_Condition = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/Condition.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    var _has = _interopRequireDefault(require_has());
    var _isSchema = _interopRequireDefault(require_isSchema());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var Condition = class {
      constructor(refs, options) {
        this.fn = void 0;
        this.refs = refs;
        this.refs = refs;
        if (typeof options === "function") {
          this.fn = options;
          return;
        }
        if (!(0, _has.default)(options, "is"))
          throw new TypeError("`is:` is required for `when()` conditions");
        if (!options.then && !options.otherwise)
          throw new TypeError("either `then:` or `otherwise:` is required for `when()` conditions");
        let {
          is,
          then,
          otherwise
        } = options;
        let check = typeof is === "function" ? is : (...values) => values.every((value) => value === is);
        this.fn = function(...args) {
          let options2 = args.pop();
          let schema2 = args.pop();
          let branch = check(...args) ? then : otherwise;
          if (!branch)
            return void 0;
          if (typeof branch === "function")
            return branch(schema2);
          return schema2.concat(branch.resolve(options2));
        };
      }
      resolve(base, options) {
        let values = this.refs.map((ref) => ref.getValue(options == null ? void 0 : options.value, options == null ? void 0 : options.parent, options == null ? void 0 : options.context));
        let schema2 = this.fn.apply(base, values.concat(base, options));
        if (schema2 === void 0 || schema2 === base)
          return base;
        if (!(0, _isSchema.default)(schema2))
          throw new TypeError("conditions must return a schema object");
        return schema2.resolve(options);
      }
    };
    var _default2 = Condition;
    exports.default = _default2;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/toArray.js
var require_toArray = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/toArray.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = toArray2;
    function toArray2(value) {
      return value == null ? [] : [].concat(value);
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/ValidationError.js
var require_ValidationError = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/ValidationError.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    var _printValue = _interopRequireDefault(require_printValue());
    var _toArray = _interopRequireDefault(require_toArray());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _extends() {
      _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }
    var strReg = /\$\{\s*(\w+)\s*\}/g;
    var ValidationError = class extends Error {
      static formatError(message, params) {
        const path2 = params.label || params.path || "this";
        if (path2 !== params.path)
          params = _extends({}, params, {
            path: path2
          });
        if (typeof message === "string")
          return message.replace(strReg, (_, key) => (0, _printValue.default)(params[key]));
        if (typeof message === "function")
          return message(params);
        return message;
      }
      static isError(err) {
        return err && err.name === "ValidationError";
      }
      constructor(errorOrErrors, value, field, type2) {
        super();
        this.value = void 0;
        this.path = void 0;
        this.type = void 0;
        this.errors = void 0;
        this.params = void 0;
        this.inner = void 0;
        this.name = "ValidationError";
        this.value = value;
        this.path = field;
        this.type = type2;
        this.errors = [];
        this.inner = [];
        (0, _toArray.default)(errorOrErrors).forEach((err) => {
          if (ValidationError.isError(err)) {
            this.errors.push(...err.errors);
            this.inner = this.inner.concat(err.inner.length ? err.inner : err);
          } else {
            this.errors.push(err);
          }
        });
        this.message = this.errors.length > 1 ? `${this.errors.length} errors occurred` : this.errors[0];
        if (Error.captureStackTrace)
          Error.captureStackTrace(this, ValidationError);
      }
    };
    exports.default = ValidationError;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/runTests.js
var require_runTests = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/runTests.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = runTests;
    var _ValidationError = _interopRequireDefault(require_ValidationError());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var once = (cb) => {
      let fired = false;
      return (...args) => {
        if (fired)
          return;
        fired = true;
        cb(...args);
      };
    };
    function runTests(options, cb) {
      let {
        endEarly,
        tests,
        args,
        value,
        errors,
        sort,
        path: path2
      } = options;
      let callback = once(cb);
      let count = tests.length;
      const nestedErrors = [];
      errors = errors ? errors : [];
      if (!count)
        return errors.length ? callback(new _ValidationError.default(errors, value, path2)) : callback(null, value);
      for (let i = 0; i < tests.length; i++) {
        const test = tests[i];
        test(args, function finishTestRun(err) {
          if (err) {
            if (!_ValidationError.default.isError(err)) {
              return callback(err, value);
            }
            if (endEarly) {
              err.value = value;
              return callback(err, value);
            }
            nestedErrors.push(err);
          }
          if (--count <= 0) {
            if (nestedErrors.length) {
              if (sort)
                nestedErrors.sort(sort);
              if (errors.length)
                nestedErrors.push(...errors);
              errors = nestedErrors;
            }
            if (errors.length) {
              callback(new _ValidationError.default(errors, value, path2), value);
              return;
            }
            callback(null, value);
          }
        });
      }
    }
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_defineProperty.js
var require_defineProperty = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_defineProperty.js"(exports, module2) {
    var getNative = require_getNative();
    var defineProperty = function() {
      try {
        var func = getNative(Object, "defineProperty");
        func({}, "", {});
        return func;
      } catch (e) {
      }
    }();
    module2.exports = defineProperty;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssignValue.js
var require_baseAssignValue = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssignValue.js"(exports, module2) {
    var defineProperty = require_defineProperty();
    function baseAssignValue(object2, key, value) {
      if (key == "__proto__" && defineProperty) {
        defineProperty(object2, key, {
          "configurable": true,
          "enumerable": true,
          "value": value,
          "writable": true
        });
      } else {
        object2[key] = value;
      }
    }
    module2.exports = baseAssignValue;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createBaseFor.js
var require_createBaseFor = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createBaseFor.js"(exports, module2) {
    function createBaseFor(fromRight) {
      return function(object2, iteratee, keysFunc) {
        var index = -1, iterable = Object(object2), props = keysFunc(object2), length = props.length;
        while (length--) {
          var key = props[fromRight ? length : ++index];
          if (iteratee(iterable[key], key, iterable) === false) {
            break;
          }
        }
        return object2;
      };
    }
    module2.exports = createBaseFor;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseFor.js
var require_baseFor = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseFor.js"(exports, module2) {
    var createBaseFor = require_createBaseFor();
    var baseFor = createBaseFor();
    module2.exports = baseFor;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseTimes.js
var require_baseTimes = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseTimes.js"(exports, module2) {
    function baseTimes(n, iteratee) {
      var index = -1, result2 = Array(n);
      while (++index < n) {
        result2[index] = iteratee(index);
      }
      return result2;
    }
    module2.exports = baseTimes;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/stubFalse.js
var require_stubFalse = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/stubFalse.js"(exports, module2) {
    function stubFalse() {
      return false;
    }
    module2.exports = stubFalse;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isBuffer.js
var require_isBuffer = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isBuffer.js"(exports, module2) {
    var root = require_root();
    var stubFalse = require_stubFalse();
    var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var Buffer2 = moduleExports ? root.Buffer : void 0;
    var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
    var isBuffer = nativeIsBuffer || stubFalse;
    module2.exports = isBuffer;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsTypedArray.js
var require_baseIsTypedArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsTypedArray.js"(exports, module2) {
    var baseGetTag = require_baseGetTag();
    var isLength = require_isLength();
    var isObjectLike = require_isObjectLike();
    var argsTag = "[object Arguments]";
    var arrayTag = "[object Array]";
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var errorTag = "[object Error]";
    var funcTag = "[object Function]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var objectTag = "[object Object]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var weakMapTag = "[object WeakMap]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
    }
    module2.exports = baseIsTypedArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseUnary.js
var require_baseUnary = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseUnary.js"(exports, module2) {
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    module2.exports = baseUnary;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nodeUtil.js
var require_nodeUtil = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nodeUtil.js"(exports, module2) {
    var freeGlobal = require_freeGlobal();
    var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal.process;
    var nodeUtil = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e) {
      }
    }();
    module2.exports = nodeUtil;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isTypedArray.js
var require_isTypedArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isTypedArray.js"(exports, module2) {
    var baseIsTypedArray = require_baseIsTypedArray();
    var baseUnary = require_baseUnary();
    var nodeUtil = require_nodeUtil();
    var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    module2.exports = isTypedArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayLikeKeys.js
var require_arrayLikeKeys = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayLikeKeys.js"(exports, module2) {
    var baseTimes = require_baseTimes();
    var isArguments = require_isArguments();
    var isArray = require_isArray();
    var isBuffer = require_isBuffer();
    var isIndex = require_isIndex();
    var isTypedArray = require_isTypedArray();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function arrayLikeKeys(value, inherited) {
      var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String) : [], length = result2.length;
      for (var key in value) {
        if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
          result2.push(key);
        }
      }
      return result2;
    }
    module2.exports = arrayLikeKeys;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isPrototype.js
var require_isPrototype = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isPrototype.js"(exports, module2) {
    var objectProto = Object.prototype;
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    module2.exports = isPrototype;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_overArg.js
var require_overArg = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_overArg.js"(exports, module2) {
    function overArg(func, transform) {
      return function(arg) {
        return func(transform(arg));
      };
    }
    module2.exports = overArg;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeKeys.js
var require_nativeKeys = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeKeys.js"(exports, module2) {
    var overArg = require_overArg();
    var nativeKeys = overArg(Object.keys, Object);
    module2.exports = nativeKeys;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseKeys.js
var require_baseKeys = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseKeys.js"(exports, module2) {
    var isPrototype = require_isPrototype();
    var nativeKeys = require_nativeKeys();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function baseKeys(object2) {
      if (!isPrototype(object2)) {
        return nativeKeys(object2);
      }
      var result2 = [];
      for (var key in Object(object2)) {
        if (hasOwnProperty2.call(object2, key) && key != "constructor") {
          result2.push(key);
        }
      }
      return result2;
    }
    module2.exports = baseKeys;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArrayLike.js
var require_isArrayLike = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArrayLike.js"(exports, module2) {
    var isFunction = require_isFunction();
    var isLength = require_isLength();
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    module2.exports = isArrayLike;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/keys.js
var require_keys2 = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/keys.js"(exports, module2) {
    var arrayLikeKeys = require_arrayLikeKeys();
    var baseKeys = require_baseKeys();
    var isArrayLike = require_isArrayLike();
    function keys(object2) {
      return isArrayLike(object2) ? arrayLikeKeys(object2) : baseKeys(object2);
    }
    module2.exports = keys;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseForOwn.js
var require_baseForOwn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseForOwn.js"(exports, module2) {
    var baseFor = require_baseFor();
    var keys = require_keys2();
    function baseForOwn(object2, iteratee) {
      return object2 && baseFor(object2, iteratee, keys);
    }
    module2.exports = baseForOwn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackClear.js
var require_stackClear = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackClear.js"(exports, module2) {
    var ListCache = require_ListCache();
    function stackClear() {
      this.__data__ = new ListCache();
      this.size = 0;
    }
    module2.exports = stackClear;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackDelete.js
var require_stackDelete = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackDelete.js"(exports, module2) {
    function stackDelete(key) {
      var data = this.__data__, result2 = data["delete"](key);
      this.size = data.size;
      return result2;
    }
    module2.exports = stackDelete;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackGet.js
var require_stackGet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackGet.js"(exports, module2) {
    function stackGet(key) {
      return this.__data__.get(key);
    }
    module2.exports = stackGet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackHas.js
var require_stackHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackHas.js"(exports, module2) {
    function stackHas(key) {
      return this.__data__.has(key);
    }
    module2.exports = stackHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackSet.js
var require_stackSet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stackSet.js"(exports, module2) {
    var ListCache = require_ListCache();
    var Map2 = require_Map();
    var MapCache = require_MapCache();
    var LARGE_ARRAY_SIZE = 200;
    function stackSet(key, value) {
      var data = this.__data__;
      if (data instanceof ListCache) {
        var pairs2 = data.__data__;
        if (!Map2 || pairs2.length < LARGE_ARRAY_SIZE - 1) {
          pairs2.push([key, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache(pairs2);
      }
      data.set(key, value);
      this.size = data.size;
      return this;
    }
    module2.exports = stackSet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Stack.js
var require_Stack = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Stack.js"(exports, module2) {
    var ListCache = require_ListCache();
    var stackClear = require_stackClear();
    var stackDelete = require_stackDelete();
    var stackGet = require_stackGet();
    var stackHas = require_stackHas();
    var stackSet = require_stackSet();
    function Stack(entries) {
      var data = this.__data__ = new ListCache(entries);
      this.size = data.size;
    }
    Stack.prototype.clear = stackClear;
    Stack.prototype["delete"] = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;
    module2.exports = Stack;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setCacheAdd.js
var require_setCacheAdd = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setCacheAdd.js"(exports, module2) {
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    function setCacheAdd(value) {
      this.__data__.set(value, HASH_UNDEFINED);
      return this;
    }
    module2.exports = setCacheAdd;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setCacheHas.js
var require_setCacheHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setCacheHas.js"(exports, module2) {
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    module2.exports = setCacheHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_SetCache.js
var require_SetCache = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_SetCache.js"(exports, module2) {
    var MapCache = require_MapCache();
    var setCacheAdd = require_setCacheAdd();
    var setCacheHas = require_setCacheHas();
    function SetCache(values) {
      var index = -1, length = values == null ? 0 : values.length;
      this.__data__ = new MapCache();
      while (++index < length) {
        this.add(values[index]);
      }
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    module2.exports = SetCache;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arraySome.js
var require_arraySome = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arraySome.js"(exports, module2) {
    function arraySome(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (predicate(array[index], index, array)) {
          return true;
        }
      }
      return false;
    }
    module2.exports = arraySome;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cacheHas.js
var require_cacheHas = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cacheHas.js"(exports, module2) {
    function cacheHas(cache, key) {
      return cache.has(key);
    }
    module2.exports = cacheHas;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_equalArrays.js
var require_equalArrays = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_equalArrays.js"(exports, module2) {
    var SetCache = require_SetCache();
    var arraySome = require_arraySome();
    var cacheHas = require_cacheHas();
    var COMPARE_PARTIAL_FLAG = 1;
    var COMPARE_UNORDERED_FLAG = 2;
    function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      var arrStacked = stack.get(array);
      var othStacked = stack.get(other);
      if (arrStacked && othStacked) {
        return arrStacked == other && othStacked == array;
      }
      var index = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : void 0;
      stack.set(array, other);
      stack.set(other, array);
      while (++index < arrLength) {
        var arrValue = array[index], othValue = other[index];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== void 0) {
          if (compared) {
            continue;
          }
          result2 = false;
          break;
        }
        if (seen) {
          if (!arraySome(other, function(othValue2, othIndex) {
            if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
            result2 = false;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
          result2 = false;
          break;
        }
      }
      stack["delete"](array);
      stack["delete"](other);
      return result2;
    }
    module2.exports = equalArrays;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Uint8Array.js
var require_Uint8Array = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Uint8Array.js"(exports, module2) {
    var root = require_root();
    var Uint8Array2 = root.Uint8Array;
    module2.exports = Uint8Array2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapToArray.js
var require_mapToArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_mapToArray.js"(exports, module2) {
    function mapToArray(map2) {
      var index = -1, result2 = Array(map2.size);
      map2.forEach(function(value, key) {
        result2[++index] = [key, value];
      });
      return result2;
    }
    module2.exports = mapToArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setToArray.js
var require_setToArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setToArray.js"(exports, module2) {
    function setToArray(set2) {
      var index = -1, result2 = Array(set2.size);
      set2.forEach(function(value) {
        result2[++index] = value;
      });
      return result2;
    }
    module2.exports = setToArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_equalByTag.js
var require_equalByTag = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_equalByTag.js"(exports, module2) {
    var Symbol2 = require_Symbol();
    var Uint8Array2 = require_Uint8Array();
    var eq = require_eq();
    var equalArrays = require_equalArrays();
    var mapToArray = require_mapToArray();
    var setToArray = require_setToArray();
    var COMPARE_PARTIAL_FLAG = 1;
    var COMPARE_UNORDERED_FLAG = 2;
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var errorTag = "[object Error]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var symbolTag = "[object Symbol]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
    var symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
    function equalByTag(object2, other, tag, bitmask, customizer, equalFunc, stack) {
      switch (tag) {
        case dataViewTag:
          if (object2.byteLength != other.byteLength || object2.byteOffset != other.byteOffset) {
            return false;
          }
          object2 = object2.buffer;
          other = other.buffer;
        case arrayBufferTag:
          if (object2.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object2), new Uint8Array2(other))) {
            return false;
          }
          return true;
        case boolTag:
        case dateTag:
        case numberTag:
          return eq(+object2, +other);
        case errorTag:
          return object2.name == other.name && object2.message == other.message;
        case regexpTag:
        case stringTag:
          return object2 == other + "";
        case mapTag:
          var convert = mapToArray;
        case setTag:
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
          convert || (convert = setToArray);
          if (object2.size != other.size && !isPartial) {
            return false;
          }
          var stacked = stack.get(object2);
          if (stacked) {
            return stacked == other;
          }
          bitmask |= COMPARE_UNORDERED_FLAG;
          stack.set(object2, other);
          var result2 = equalArrays(convert(object2), convert(other), bitmask, customizer, equalFunc, stack);
          stack["delete"](object2);
          return result2;
        case symbolTag:
          if (symbolValueOf) {
            return symbolValueOf.call(object2) == symbolValueOf.call(other);
          }
      }
      return false;
    }
    module2.exports = equalByTag;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayPush.js
var require_arrayPush = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayPush.js"(exports, module2) {
    function arrayPush(array, values) {
      var index = -1, length = values.length, offset = array.length;
      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }
    module2.exports = arrayPush;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseGetAllKeys.js
var require_baseGetAllKeys = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseGetAllKeys.js"(exports, module2) {
    var arrayPush = require_arrayPush();
    var isArray = require_isArray();
    function baseGetAllKeys(object2, keysFunc, symbolsFunc) {
      var result2 = keysFunc(object2);
      return isArray(object2) ? result2 : arrayPush(result2, symbolsFunc(object2));
    }
    module2.exports = baseGetAllKeys;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayFilter.js
var require_arrayFilter = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayFilter.js"(exports, module2) {
    function arrayFilter(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result2[resIndex++] = value;
        }
      }
      return result2;
    }
    module2.exports = arrayFilter;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/stubArray.js
var require_stubArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/stubArray.js"(exports, module2) {
    function stubArray() {
      return [];
    }
    module2.exports = stubArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getSymbols.js
var require_getSymbols = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getSymbols.js"(exports, module2) {
    var arrayFilter = require_arrayFilter();
    var stubArray = require_stubArray();
    var objectProto = Object.prototype;
    var propertyIsEnumerable = objectProto.propertyIsEnumerable;
    var nativeGetSymbols = Object.getOwnPropertySymbols;
    var getSymbols = !nativeGetSymbols ? stubArray : function(object2) {
      if (object2 == null) {
        return [];
      }
      object2 = Object(object2);
      return arrayFilter(nativeGetSymbols(object2), function(symbol) {
        return propertyIsEnumerable.call(object2, symbol);
      });
    };
    module2.exports = getSymbols;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getAllKeys.js
var require_getAllKeys = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getAllKeys.js"(exports, module2) {
    var baseGetAllKeys = require_baseGetAllKeys();
    var getSymbols = require_getSymbols();
    var keys = require_keys2();
    function getAllKeys(object2) {
      return baseGetAllKeys(object2, keys, getSymbols);
    }
    module2.exports = getAllKeys;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_equalObjects.js
var require_equalObjects = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_equalObjects.js"(exports, module2) {
    var getAllKeys = require_getAllKeys();
    var COMPARE_PARTIAL_FLAG = 1;
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function equalObjects(object2, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object2), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
          return false;
        }
      }
      var objStacked = stack.get(object2);
      var othStacked = stack.get(other);
      if (objStacked && othStacked) {
        return objStacked == other && othStacked == object2;
      }
      var result2 = true;
      stack.set(object2, other);
      stack.set(other, object2);
      var skipCtor = isPartial;
      while (++index < objLength) {
        key = objProps[index];
        var objValue = object2[key], othValue = other[key];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, objValue, key, other, object2, stack) : customizer(objValue, othValue, key, object2, other, stack);
        }
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
          result2 = false;
          break;
        }
        skipCtor || (skipCtor = key == "constructor");
      }
      if (result2 && !skipCtor) {
        var objCtor = object2.constructor, othCtor = other.constructor;
        if (objCtor != othCtor && ("constructor" in object2 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
          result2 = false;
        }
      }
      stack["delete"](object2);
      stack["delete"](other);
      return result2;
    }
    module2.exports = equalObjects;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_DataView.js
var require_DataView = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_DataView.js"(exports, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var DataView = getNative(root, "DataView");
    module2.exports = DataView;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Promise.js
var require_Promise = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Promise.js"(exports, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var Promise2 = getNative(root, "Promise");
    module2.exports = Promise2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Set.js
var require_Set = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_Set.js"(exports, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var Set2 = getNative(root, "Set");
    module2.exports = Set2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_WeakMap.js
var require_WeakMap = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_WeakMap.js"(exports, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var WeakMap2 = getNative(root, "WeakMap");
    module2.exports = WeakMap2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getTag.js
var require_getTag = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getTag.js"(exports, module2) {
    var DataView = require_DataView();
    var Map2 = require_Map();
    var Promise2 = require_Promise();
    var Set2 = require_Set();
    var WeakMap2 = require_WeakMap();
    var baseGetTag = require_baseGetTag();
    var toSource = require_toSource();
    var mapTag = "[object Map]";
    var objectTag = "[object Object]";
    var promiseTag = "[object Promise]";
    var setTag = "[object Set]";
    var weakMapTag = "[object WeakMap]";
    var dataViewTag = "[object DataView]";
    var dataViewCtorString = toSource(DataView);
    var mapCtorString = toSource(Map2);
    var promiseCtorString = toSource(Promise2);
    var setCtorString = toSource(Set2);
    var weakMapCtorString = toSource(WeakMap2);
    var getTag = baseGetTag;
    if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
      getTag = function(value) {
        var result2 = baseGetTag(value), Ctor = result2 == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString:
              return dataViewTag;
            case mapCtorString:
              return mapTag;
            case promiseCtorString:
              return promiseTag;
            case setCtorString:
              return setTag;
            case weakMapCtorString:
              return weakMapTag;
          }
        }
        return result2;
      };
    }
    module2.exports = getTag;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsEqualDeep.js
var require_baseIsEqualDeep = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsEqualDeep.js"(exports, module2) {
    var Stack = require_Stack();
    var equalArrays = require_equalArrays();
    var equalByTag = require_equalByTag();
    var equalObjects = require_equalObjects();
    var getTag = require_getTag();
    var isArray = require_isArray();
    var isBuffer = require_isBuffer();
    var isTypedArray = require_isTypedArray();
    var COMPARE_PARTIAL_FLAG = 1;
    var argsTag = "[object Arguments]";
    var arrayTag = "[object Array]";
    var objectTag = "[object Object]";
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function baseIsEqualDeep(object2, other, bitmask, customizer, equalFunc, stack) {
      var objIsArr = isArray(object2), othIsArr = isArray(other), objTag = objIsArr ? arrayTag : getTag(object2), othTag = othIsArr ? arrayTag : getTag(other);
      objTag = objTag == argsTag ? objectTag : objTag;
      othTag = othTag == argsTag ? objectTag : othTag;
      var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
      if (isSameTag && isBuffer(object2)) {
        if (!isBuffer(other)) {
          return false;
        }
        objIsArr = true;
        objIsObj = false;
      }
      if (isSameTag && !objIsObj) {
        stack || (stack = new Stack());
        return objIsArr || isTypedArray(object2) ? equalArrays(object2, other, bitmask, customizer, equalFunc, stack) : equalByTag(object2, other, objTag, bitmask, customizer, equalFunc, stack);
      }
      if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty2.call(object2, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object2.value() : object2, othUnwrapped = othIsWrapped ? other.value() : other;
          stack || (stack = new Stack());
          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack());
      return equalObjects(object2, other, bitmask, customizer, equalFunc, stack);
    }
    module2.exports = baseIsEqualDeep;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsEqual.js
var require_baseIsEqual = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsEqual.js"(exports, module2) {
    var baseIsEqualDeep = require_baseIsEqualDeep();
    var isObjectLike = require_isObjectLike();
    function baseIsEqual(value, other, bitmask, customizer, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
    }
    module2.exports = baseIsEqual;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsMatch.js
var require_baseIsMatch = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsMatch.js"(exports, module2) {
    var Stack = require_Stack();
    var baseIsEqual = require_baseIsEqual();
    var COMPARE_PARTIAL_FLAG = 1;
    var COMPARE_UNORDERED_FLAG = 2;
    function baseIsMatch(object2, source, matchData, customizer) {
      var index = matchData.length, length = index, noCustomizer = !customizer;
      if (object2 == null) {
        return !length;
      }
      object2 = Object(object2);
      while (index--) {
        var data = matchData[index];
        if (noCustomizer && data[2] ? data[1] !== object2[data[0]] : !(data[0] in object2)) {
          return false;
        }
      }
      while (++index < length) {
        data = matchData[index];
        var key = data[0], objValue = object2[key], srcValue = data[1];
        if (noCustomizer && data[2]) {
          if (objValue === void 0 && !(key in object2)) {
            return false;
          }
        } else {
          var stack = new Stack();
          if (customizer) {
            var result2 = customizer(objValue, srcValue, key, object2, source, stack);
          }
          if (!(result2 === void 0 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result2)) {
            return false;
          }
        }
      }
      return true;
    }
    module2.exports = baseIsMatch;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isStrictComparable.js
var require_isStrictComparable = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isStrictComparable.js"(exports, module2) {
    var isObject2 = require_isObject();
    function isStrictComparable(value) {
      return value === value && !isObject2(value);
    }
    module2.exports = isStrictComparable;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getMatchData.js
var require_getMatchData = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getMatchData.js"(exports, module2) {
    var isStrictComparable = require_isStrictComparable();
    var keys = require_keys2();
    function getMatchData(object2) {
      var result2 = keys(object2), length = result2.length;
      while (length--) {
        var key = result2[length], value = object2[key];
        result2[length] = [key, value, isStrictComparable(value)];
      }
      return result2;
    }
    module2.exports = getMatchData;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_matchesStrictComparable.js
var require_matchesStrictComparable = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_matchesStrictComparable.js"(exports, module2) {
    function matchesStrictComparable(key, srcValue) {
      return function(object2) {
        if (object2 == null) {
          return false;
        }
        return object2[key] === srcValue && (srcValue !== void 0 || key in Object(object2));
      };
    }
    module2.exports = matchesStrictComparable;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMatches.js
var require_baseMatches = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMatches.js"(exports, module2) {
    var baseIsMatch = require_baseIsMatch();
    var getMatchData = require_getMatchData();
    var matchesStrictComparable = require_matchesStrictComparable();
    function baseMatches(source) {
      var matchData = getMatchData(source);
      if (matchData.length == 1 && matchData[0][2]) {
        return matchesStrictComparable(matchData[0][0], matchData[0][1]);
      }
      return function(object2) {
        return object2 === source || baseIsMatch(object2, source, matchData);
      };
    }
    module2.exports = baseMatches;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseGet.js
var require_baseGet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseGet.js"(exports, module2) {
    var castPath = require_castPath();
    var toKey = require_toKey();
    function baseGet(object2, path2) {
      path2 = castPath(path2, object2);
      var index = 0, length = path2.length;
      while (object2 != null && index < length) {
        object2 = object2[toKey(path2[index++])];
      }
      return index && index == length ? object2 : void 0;
    }
    module2.exports = baseGet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/get.js
var require_get3 = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/get.js"(exports, module2) {
    var baseGet = require_baseGet();
    function get(object2, path2, defaultValue) {
      var result2 = object2 == null ? void 0 : baseGet(object2, path2);
      return result2 === void 0 ? defaultValue : result2;
    }
    module2.exports = get;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseHasIn.js
var require_baseHasIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseHasIn.js"(exports, module2) {
    function baseHasIn(object2, key) {
      return object2 != null && key in Object(object2);
    }
    module2.exports = baseHasIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/hasIn.js
var require_hasIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/hasIn.js"(exports, module2) {
    var baseHasIn = require_baseHasIn();
    var hasPath = require_hasPath();
    function hasIn(object2, path2) {
      return object2 != null && hasPath(object2, path2, baseHasIn);
    }
    module2.exports = hasIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMatchesProperty.js
var require_baseMatchesProperty = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMatchesProperty.js"(exports, module2) {
    var baseIsEqual = require_baseIsEqual();
    var get = require_get3();
    var hasIn = require_hasIn();
    var isKey = require_isKey();
    var isStrictComparable = require_isStrictComparable();
    var matchesStrictComparable = require_matchesStrictComparable();
    var toKey = require_toKey();
    var COMPARE_PARTIAL_FLAG = 1;
    var COMPARE_UNORDERED_FLAG = 2;
    function baseMatchesProperty(path2, srcValue) {
      if (isKey(path2) && isStrictComparable(srcValue)) {
        return matchesStrictComparable(toKey(path2), srcValue);
      }
      return function(object2) {
        var objValue = get(object2, path2);
        return objValue === void 0 && objValue === srcValue ? hasIn(object2, path2) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
      };
    }
    module2.exports = baseMatchesProperty;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/identity.js
var require_identity = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/identity.js"(exports, module2) {
    function identity(value) {
      return value;
    }
    module2.exports = identity;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseProperty.js
var require_baseProperty = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseProperty.js"(exports, module2) {
    function baseProperty(key) {
      return function(object2) {
        return object2 == null ? void 0 : object2[key];
      };
    }
    module2.exports = baseProperty;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePropertyDeep.js
var require_basePropertyDeep = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePropertyDeep.js"(exports, module2) {
    var baseGet = require_baseGet();
    function basePropertyDeep(path2) {
      return function(object2) {
        return baseGet(object2, path2);
      };
    }
    module2.exports = basePropertyDeep;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/property.js
var require_property = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/property.js"(exports, module2) {
    var baseProperty = require_baseProperty();
    var basePropertyDeep = require_basePropertyDeep();
    var isKey = require_isKey();
    var toKey = require_toKey();
    function property(path2) {
      return isKey(path2) ? baseProperty(toKey(path2)) : basePropertyDeep(path2);
    }
    module2.exports = property;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIteratee.js
var require_baseIteratee = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIteratee.js"(exports, module2) {
    var baseMatches = require_baseMatches();
    var baseMatchesProperty = require_baseMatchesProperty();
    var identity = require_identity();
    var isArray = require_isArray();
    var property = require_property();
    function baseIteratee(value) {
      if (typeof value == "function") {
        return value;
      }
      if (value == null) {
        return identity;
      }
      if (typeof value == "object") {
        return isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
      }
      return property(value);
    }
    module2.exports = baseIteratee;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/mapValues.js
var require_mapValues = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/mapValues.js"(exports, module2) {
    var baseAssignValue = require_baseAssignValue();
    var baseForOwn = require_baseForOwn();
    var baseIteratee = require_baseIteratee();
    function mapValues(object2, iteratee) {
      var result2 = {};
      iteratee = baseIteratee(iteratee, 3);
      baseForOwn(object2, function(value, key, object3) {
        baseAssignValue(result2, key, iteratee(value, key, object3));
      });
      return result2;
    }
    module2.exports = mapValues;
  }
});

// node_modules/.pnpm/property-expr@2.0.5/node_modules/property-expr/index.js
var require_property_expr = __commonJS({
  "node_modules/.pnpm/property-expr@2.0.5/node_modules/property-expr/index.js"(exports, module2) {
    "use strict";
    function Cache(maxSize) {
      this._maxSize = maxSize;
      this.clear();
    }
    Cache.prototype.clear = function() {
      this._size = 0;
      this._values = /* @__PURE__ */ Object.create(null);
    };
    Cache.prototype.get = function(key) {
      return this._values[key];
    };
    Cache.prototype.set = function(key, value) {
      this._size >= this._maxSize && this.clear();
      if (!(key in this._values))
        this._size++;
      return this._values[key] = value;
    };
    var SPLIT_REGEX = /[^.^\]^[]+|(?=\[\]|\.\.)/g;
    var DIGIT_REGEX = /^\d+$/;
    var LEAD_DIGIT_REGEX = /^\d/;
    var SPEC_CHAR_REGEX = /[~`!#$%\^&*+=\-\[\]\\';,/{}|\\":<>\?]/g;
    var CLEAN_QUOTES_REGEX = /^\s*(['"]?)(.*?)(\1)\s*$/;
    var MAX_CACHE_SIZE = 512;
    var pathCache = new Cache(MAX_CACHE_SIZE);
    var setCache = new Cache(MAX_CACHE_SIZE);
    var getCache = new Cache(MAX_CACHE_SIZE);
    module2.exports = {
      Cache,
      split,
      normalizePath,
      setter: function(path2) {
        var parts = normalizePath(path2);
        return setCache.get(path2) || setCache.set(path2, function setter(obj, value) {
          var index = 0;
          var len = parts.length;
          var data = obj;
          while (index < len - 1) {
            var part = parts[index];
            if (part === "__proto__" || part === "constructor" || part === "prototype") {
              return obj;
            }
            data = data[parts[index++]];
          }
          data[parts[index]] = value;
        });
      },
      getter: function(path2, safe) {
        var parts = normalizePath(path2);
        return getCache.get(path2) || getCache.set(path2, function getter(data) {
          var index = 0, len = parts.length;
          while (index < len) {
            if (data != null || !safe)
              data = data[parts[index++]];
            else
              return;
          }
          return data;
        });
      },
      join: function(segments) {
        return segments.reduce(function(path2, part) {
          return path2 + (isQuoted(part) || DIGIT_REGEX.test(part) ? "[" + part + "]" : (path2 ? "." : "") + part);
        }, "");
      },
      forEach: function(path2, cb, thisArg) {
        forEach(Array.isArray(path2) ? path2 : split(path2), cb, thisArg);
      }
    };
    function normalizePath(path2) {
      return pathCache.get(path2) || pathCache.set(path2, split(path2).map(function(part) {
        return part.replace(CLEAN_QUOTES_REGEX, "$2");
      }));
    }
    function split(path2) {
      return path2.match(SPLIT_REGEX) || [""];
    }
    function forEach(parts, iter, thisArg) {
      var len = parts.length, part, idx2, isArray, isBracket;
      for (idx2 = 0; idx2 < len; idx2++) {
        part = parts[idx2];
        if (part) {
          if (shouldBeQuoted(part)) {
            part = '"' + part + '"';
          }
          isBracket = isQuoted(part);
          isArray = !isBracket && /^\d+$/.test(part);
          iter.call(thisArg, part, isBracket, isArray, idx2, parts);
        }
      }
    }
    function isQuoted(str2) {
      return typeof str2 === "string" && str2 && ["'", '"'].indexOf(str2.charAt(0)) !== -1;
    }
    function hasLeadingNumber(part) {
      return part.match(LEAD_DIGIT_REGEX) && !part.match(DIGIT_REGEX);
    }
    function hasSpecialChars(part) {
      return SPEC_CHAR_REGEX.test(part);
    }
    function shouldBeQuoted(part) {
      return !isQuoted(part) && (hasLeadingNumber(part) || hasSpecialChars(part));
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/Reference.js
var require_Reference = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/Reference.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _propertyExpr = require_property_expr();
    var prefixes = {
      context: "$",
      value: "."
    };
    function create(key, options) {
      return new Reference(key, options);
    }
    var Reference = class {
      constructor(key, options = {}) {
        this.key = void 0;
        this.isContext = void 0;
        this.isValue = void 0;
        this.isSibling = void 0;
        this.path = void 0;
        this.getter = void 0;
        this.map = void 0;
        if (typeof key !== "string")
          throw new TypeError("ref must be a string, got: " + key);
        this.key = key.trim();
        if (key === "")
          throw new TypeError("ref must be a non-empty string");
        this.isContext = this.key[0] === prefixes.context;
        this.isValue = this.key[0] === prefixes.value;
        this.isSibling = !this.isContext && !this.isValue;
        let prefix = this.isContext ? prefixes.context : this.isValue ? prefixes.value : "";
        this.path = this.key.slice(prefix.length);
        this.getter = this.path && (0, _propertyExpr.getter)(this.path, true);
        this.map = options.map;
      }
      getValue(value, parent, context) {
        let result2 = this.isContext ? context : this.isValue ? value : parent;
        if (this.getter)
          result2 = this.getter(result2 || {});
        if (this.map)
          result2 = this.map(result2);
        return result2;
      }
      cast(value, options) {
        return this.getValue(value, options == null ? void 0 : options.parent, options == null ? void 0 : options.context);
      }
      resolve() {
        return this;
      }
      describe() {
        return {
          type: "ref",
          key: this.key
        };
      }
      toString() {
        return `Ref(${this.key})`;
      }
      static isRef(value) {
        return value && value.__isYupRef;
      }
    };
    exports.default = Reference;
    Reference.prototype.__isYupRef = true;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/createValidation.js
var require_createValidation = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/createValidation.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = createValidation;
    var _mapValues = _interopRequireDefault(require_mapValues());
    var _ValidationError = _interopRequireDefault(require_ValidationError());
    var _Reference = _interopRequireDefault(require_Reference());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _extends() {
      _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {};
      var sourceKeys = Object.keys(source);
      var key, i;
      for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0)
          continue;
        target[key] = source[key];
      }
      return target;
    }
    function createValidation(config) {
      function validate(_ref, cb) {
        let {
          value,
          path: path2 = "",
          label,
          options,
          originalValue,
          sync
        } = _ref, rest = _objectWithoutPropertiesLoose(_ref, ["value", "path", "label", "options", "originalValue", "sync"]);
        const {
          name,
          test,
          params,
          message
        } = config;
        let {
          parent,
          context
        } = options;
        function resolve(item) {
          return _Reference.default.isRef(item) ? item.getValue(value, parent, context) : item;
        }
        function createError(overrides = {}) {
          const nextParams = (0, _mapValues.default)(_extends({
            value,
            originalValue,
            label,
            path: overrides.path || path2
          }, params, overrides.params), resolve);
          const error = new _ValidationError.default(_ValidationError.default.formatError(overrides.message || message, nextParams), value, nextParams.path, overrides.type || name);
          error.params = nextParams;
          return error;
        }
        let ctx = _extends({
          path: path2,
          parent,
          type: name,
          createError,
          resolve,
          options,
          originalValue
        }, rest);
        if (!sync) {
          try {
            Promise.resolve(test.call(ctx, value, ctx)).then((validOrError) => {
              if (_ValidationError.default.isError(validOrError))
                cb(validOrError);
              else if (!validOrError)
                cb(createError());
              else
                cb(null, validOrError);
            }).catch(cb);
          } catch (err) {
            cb(err);
          }
          return;
        }
        let result2;
        try {
          var _ref2;
          result2 = test.call(ctx, value, ctx);
          if (typeof ((_ref2 = result2) == null ? void 0 : _ref2.then) === "function") {
            throw new Error(`Validation test of type: "${ctx.type}" returned a Promise during a synchronous validate. This test will finish after the validate call has returned`);
          }
        } catch (err) {
          cb(err);
          return;
        }
        if (_ValidationError.default.isError(result2))
          cb(result2);
        else if (!result2)
          cb(createError());
        else
          cb(null, result2);
      }
      validate.OPTIONS = config;
      return validate;
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/reach.js
var require_reach = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/reach.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    exports.getIn = getIn;
    var _propertyExpr = require_property_expr();
    var trim = (part) => part.substr(0, part.length - 1).substr(1);
    function getIn(schema2, path2, value, context = value) {
      let parent, lastPart, lastPartDebug;
      if (!path2)
        return {
          parent,
          parentPath: path2,
          schema: schema2
        };
      (0, _propertyExpr.forEach)(path2, (_part, isBracket, isArray) => {
        let part = isBracket ? trim(_part) : _part;
        schema2 = schema2.resolve({
          context,
          parent,
          value
        });
        if (schema2.innerType) {
          let idx2 = isArray ? parseInt(part, 10) : 0;
          if (value && idx2 >= value.length) {
            throw new Error(`Yup.reach cannot resolve an array item at index: ${_part}, in the path: ${path2}. because there is no value at that index. `);
          }
          parent = value;
          value = value && value[idx2];
          schema2 = schema2.innerType;
        }
        if (!isArray) {
          if (!schema2.fields || !schema2.fields[part])
            throw new Error(`The schema does not contain the path: ${path2}. (failed at: ${lastPartDebug} which is a type: "${schema2._type}")`);
          parent = value;
          value = value && value[part];
          schema2 = schema2.fields[part];
        }
        lastPart = part;
        lastPartDebug = isBracket ? "[" + _part + "]" : "." + _part;
      });
      return {
        schema: schema2,
        parent,
        parentPath: lastPart
      };
    }
    var reach = (obj, path2, value, context) => getIn(obj, path2, value, context).schema;
    var _default2 = reach;
    exports.default = _default2;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/ReferenceSet.js
var require_ReferenceSet = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/ReferenceSet.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    var _Reference = _interopRequireDefault(require_Reference());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var ReferenceSet = class {
      constructor() {
        this.list = void 0;
        this.refs = void 0;
        this.list = /* @__PURE__ */ new Set();
        this.refs = /* @__PURE__ */ new Map();
      }
      get size() {
        return this.list.size + this.refs.size;
      }
      describe() {
        const description = [];
        for (const item of this.list)
          description.push(item);
        for (const [, ref] of this.refs)
          description.push(ref.describe());
        return description;
      }
      toArray() {
        return Array.from(this.list).concat(Array.from(this.refs.values()));
      }
      resolveAll(resolve) {
        return this.toArray().reduce((acc, e) => acc.concat(_Reference.default.isRef(e) ? resolve(e) : e), []);
      }
      add(value) {
        _Reference.default.isRef(value) ? this.refs.set(value.key, value) : this.list.add(value);
      }
      delete(value) {
        _Reference.default.isRef(value) ? this.refs.delete(value.key) : this.list.delete(value);
      }
      clone() {
        const next = new ReferenceSet();
        next.list = new Set(this.list);
        next.refs = new Map(this.refs);
        return next;
      }
      merge(newItems, removeItems) {
        const next = this.clone();
        newItems.list.forEach((value) => next.add(value));
        newItems.refs.forEach((value) => next.add(value));
        removeItems.list.forEach((value) => next.delete(value));
        removeItems.refs.forEach((value) => next.delete(value));
        return next;
      }
    };
    exports.default = ReferenceSet;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/schema.js
var require_schema2 = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/schema.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    var _nanoclone = _interopRequireDefault(require_nanoclone());
    var _locale = require_locale();
    var _Condition = _interopRequireDefault(require_Condition());
    var _runTests = _interopRequireDefault(require_runTests());
    var _createValidation = _interopRequireDefault(require_createValidation());
    var _printValue = _interopRequireDefault(require_printValue());
    var _Reference = _interopRequireDefault(require_Reference());
    var _reach = require_reach();
    var _ValidationError = _interopRequireDefault(require_ValidationError());
    var _ReferenceSet = _interopRequireDefault(require_ReferenceSet());
    var _toArray = _interopRequireDefault(require_toArray());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _extends() {
      _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }
    var BaseSchema = class {
      constructor(options) {
        this.deps = [];
        this.tests = void 0;
        this.transforms = void 0;
        this.conditions = [];
        this._mutate = void 0;
        this._typeError = void 0;
        this._whitelist = new _ReferenceSet.default();
        this._blacklist = new _ReferenceSet.default();
        this.exclusiveTests = /* @__PURE__ */ Object.create(null);
        this.spec = void 0;
        this.tests = [];
        this.transforms = [];
        this.withMutation(() => {
          this.typeError(_locale.mixed.notType);
        });
        this.type = (options == null ? void 0 : options.type) || "mixed";
        this.spec = _extends({
          strip: false,
          strict: false,
          abortEarly: true,
          recursive: true,
          nullable: false,
          presence: "optional"
        }, options == null ? void 0 : options.spec);
      }
      get _type() {
        return this.type;
      }
      _typeCheck(_value) {
        return true;
      }
      clone(spec) {
        if (this._mutate) {
          if (spec)
            Object.assign(this.spec, spec);
          return this;
        }
        const next = Object.create(Object.getPrototypeOf(this));
        next.type = this.type;
        next._typeError = this._typeError;
        next._whitelistError = this._whitelistError;
        next._blacklistError = this._blacklistError;
        next._whitelist = this._whitelist.clone();
        next._blacklist = this._blacklist.clone();
        next.exclusiveTests = _extends({}, this.exclusiveTests);
        next.deps = [...this.deps];
        next.conditions = [...this.conditions];
        next.tests = [...this.tests];
        next.transforms = [...this.transforms];
        next.spec = (0, _nanoclone.default)(_extends({}, this.spec, spec));
        return next;
      }
      label(label) {
        let next = this.clone();
        next.spec.label = label;
        return next;
      }
      meta(...args) {
        if (args.length === 0)
          return this.spec.meta;
        let next = this.clone();
        next.spec.meta = Object.assign(next.spec.meta || {}, args[0]);
        return next;
      }
      withMutation(fn) {
        let before = this._mutate;
        this._mutate = true;
        let result2 = fn(this);
        this._mutate = before;
        return result2;
      }
      concat(schema2) {
        if (!schema2 || schema2 === this)
          return this;
        if (schema2.type !== this.type && this.type !== "mixed")
          throw new TypeError(`You cannot \`concat()\` schema's of different types: ${this.type} and ${schema2.type}`);
        let base = this;
        let combined = schema2.clone();
        const mergedSpec = _extends({}, base.spec, combined.spec);
        combined.spec = mergedSpec;
        combined._typeError || (combined._typeError = base._typeError);
        combined._whitelistError || (combined._whitelistError = base._whitelistError);
        combined._blacklistError || (combined._blacklistError = base._blacklistError);
        combined._whitelist = base._whitelist.merge(schema2._whitelist, schema2._blacklist);
        combined._blacklist = base._blacklist.merge(schema2._blacklist, schema2._whitelist);
        combined.tests = base.tests;
        combined.exclusiveTests = base.exclusiveTests;
        combined.withMutation((next) => {
          schema2.tests.forEach((fn) => {
            next.test(fn.OPTIONS);
          });
        });
        combined.transforms = [...base.transforms, ...combined.transforms];
        return combined;
      }
      isType(v) {
        if (this.spec.nullable && v === null)
          return true;
        return this._typeCheck(v);
      }
      resolve(options) {
        let schema2 = this;
        if (schema2.conditions.length) {
          let conditions = schema2.conditions;
          schema2 = schema2.clone();
          schema2.conditions = [];
          schema2 = conditions.reduce((schema3, condition) => condition.resolve(schema3, options), schema2);
          schema2 = schema2.resolve(options);
        }
        return schema2;
      }
      cast(value, options = {}) {
        let resolvedSchema = this.resolve(_extends({
          value
        }, options));
        let result2 = resolvedSchema._cast(value, options);
        if (value !== void 0 && options.assert !== false && resolvedSchema.isType(result2) !== true) {
          let formattedValue = (0, _printValue.default)(value);
          let formattedResult = (0, _printValue.default)(result2);
          throw new TypeError(`The value of ${options.path || "field"} could not be cast to a value that satisfies the schema type: "${resolvedSchema._type}". 

attempted value: ${formattedValue} 
` + (formattedResult !== formattedValue ? `result of cast: ${formattedResult}` : ""));
        }
        return result2;
      }
      _cast(rawValue, _options) {
        let value = rawValue === void 0 ? rawValue : this.transforms.reduce((value2, fn) => fn.call(this, value2, rawValue, this), rawValue);
        if (value === void 0) {
          value = this.getDefault();
        }
        return value;
      }
      _validate(_value, options = {}, cb) {
        let {
          sync,
          path: path2,
          from = [],
          originalValue = _value,
          strict = this.spec.strict,
          abortEarly = this.spec.abortEarly
        } = options;
        let value = _value;
        if (!strict) {
          value = this._cast(value, _extends({
            assert: false
          }, options));
        }
        let args = {
          value,
          path: path2,
          options,
          originalValue,
          schema: this,
          label: this.spec.label,
          sync,
          from
        };
        let initialTests = [];
        if (this._typeError)
          initialTests.push(this._typeError);
        let finalTests = [];
        if (this._whitelistError)
          finalTests.push(this._whitelistError);
        if (this._blacklistError)
          finalTests.push(this._blacklistError);
        (0, _runTests.default)({
          args,
          value,
          path: path2,
          sync,
          tests: initialTests,
          endEarly: abortEarly
        }, (err) => {
          if (err)
            return void cb(err, value);
          (0, _runTests.default)({
            tests: this.tests.concat(finalTests),
            args,
            path: path2,
            sync,
            value,
            endEarly: abortEarly
          }, cb);
        });
      }
      validate(value, options, maybeCb) {
        let schema2 = this.resolve(_extends({}, options, {
          value
        }));
        return typeof maybeCb === "function" ? schema2._validate(value, options, maybeCb) : new Promise((resolve, reject) => schema2._validate(value, options, (err, value2) => {
          if (err)
            reject(err);
          else
            resolve(value2);
        }));
      }
      validateSync(value, options) {
        let schema2 = this.resolve(_extends({}, options, {
          value
        }));
        let result2;
        schema2._validate(value, _extends({}, options, {
          sync: true
        }), (err, value2) => {
          if (err)
            throw err;
          result2 = value2;
        });
        return result2;
      }
      isValid(value, options) {
        return this.validate(value, options).then(() => true, (err) => {
          if (_ValidationError.default.isError(err))
            return false;
          throw err;
        });
      }
      isValidSync(value, options) {
        try {
          this.validateSync(value, options);
          return true;
        } catch (err) {
          if (_ValidationError.default.isError(err))
            return false;
          throw err;
        }
      }
      _getDefault() {
        let defaultValue = this.spec.default;
        if (defaultValue == null) {
          return defaultValue;
        }
        return typeof defaultValue === "function" ? defaultValue.call(this) : (0, _nanoclone.default)(defaultValue);
      }
      getDefault(options) {
        let schema2 = this.resolve(options || {});
        return schema2._getDefault();
      }
      default(def) {
        if (arguments.length === 0) {
          return this._getDefault();
        }
        let next = this.clone({
          default: def
        });
        return next;
      }
      strict(isStrict = true) {
        let next = this.clone();
        next.spec.strict = isStrict;
        return next;
      }
      _isPresent(value) {
        return value != null;
      }
      defined(message = _locale.mixed.defined) {
        return this.test({
          message,
          name: "defined",
          exclusive: true,
          test(value) {
            return value !== void 0;
          }
        });
      }
      required(message = _locale.mixed.required) {
        return this.clone({
          presence: "required"
        }).withMutation((s) => s.test({
          message,
          name: "required",
          exclusive: true,
          test(value) {
            return this.schema._isPresent(value);
          }
        }));
      }
      notRequired() {
        let next = this.clone({
          presence: "optional"
        });
        next.tests = next.tests.filter((test) => test.OPTIONS.name !== "required");
        return next;
      }
      nullable(isNullable = true) {
        let next = this.clone({
          nullable: isNullable !== false
        });
        return next;
      }
      transform(fn) {
        let next = this.clone();
        next.transforms.push(fn);
        return next;
      }
      test(...args) {
        let opts;
        if (args.length === 1) {
          if (typeof args[0] === "function") {
            opts = {
              test: args[0]
            };
          } else {
            opts = args[0];
          }
        } else if (args.length === 2) {
          opts = {
            name: args[0],
            test: args[1]
          };
        } else {
          opts = {
            name: args[0],
            message: args[1],
            test: args[2]
          };
        }
        if (opts.message === void 0)
          opts.message = _locale.mixed.default;
        if (typeof opts.test !== "function")
          throw new TypeError("`test` is a required parameters");
        let next = this.clone();
        let validate = (0, _createValidation.default)(opts);
        let isExclusive = opts.exclusive || opts.name && next.exclusiveTests[opts.name] === true;
        if (opts.exclusive) {
          if (!opts.name)
            throw new TypeError("Exclusive tests must provide a unique `name` identifying the test");
        }
        if (opts.name)
          next.exclusiveTests[opts.name] = !!opts.exclusive;
        next.tests = next.tests.filter((fn) => {
          if (fn.OPTIONS.name === opts.name) {
            if (isExclusive)
              return false;
            if (fn.OPTIONS.test === validate.OPTIONS.test)
              return false;
          }
          return true;
        });
        next.tests.push(validate);
        return next;
      }
      when(keys, options) {
        if (!Array.isArray(keys) && typeof keys !== "string") {
          options = keys;
          keys = ".";
        }
        let next = this.clone();
        let deps = (0, _toArray.default)(keys).map((key) => new _Reference.default(key));
        deps.forEach((dep) => {
          if (dep.isSibling)
            next.deps.push(dep.key);
        });
        next.conditions.push(new _Condition.default(deps, options));
        return next;
      }
      typeError(message) {
        let next = this.clone();
        next._typeError = (0, _createValidation.default)({
          message,
          name: "typeError",
          test(value) {
            if (value !== void 0 && !this.schema.isType(value))
              return this.createError({
                params: {
                  type: this.schema._type
                }
              });
            return true;
          }
        });
        return next;
      }
      oneOf(enums, message = _locale.mixed.oneOf) {
        let next = this.clone();
        enums.forEach((val) => {
          next._whitelist.add(val);
          next._blacklist.delete(val);
        });
        next._whitelistError = (0, _createValidation.default)({
          message,
          name: "oneOf",
          test(value) {
            if (value === void 0)
              return true;
            let valids = this.schema._whitelist;
            let resolved = valids.resolveAll(this.resolve);
            return resolved.includes(value) ? true : this.createError({
              params: {
                values: valids.toArray().join(", "),
                resolved
              }
            });
          }
        });
        return next;
      }
      notOneOf(enums, message = _locale.mixed.notOneOf) {
        let next = this.clone();
        enums.forEach((val) => {
          next._blacklist.add(val);
          next._whitelist.delete(val);
        });
        next._blacklistError = (0, _createValidation.default)({
          message,
          name: "notOneOf",
          test(value) {
            let invalids = this.schema._blacklist;
            let resolved = invalids.resolveAll(this.resolve);
            if (resolved.includes(value))
              return this.createError({
                params: {
                  values: invalids.toArray().join(", "),
                  resolved
                }
              });
            return true;
          }
        });
        return next;
      }
      strip(strip = true) {
        let next = this.clone();
        next.spec.strip = strip;
        return next;
      }
      describe() {
        const next = this.clone();
        const {
          label,
          meta
        } = next.spec;
        const description = {
          meta,
          label,
          type: next.type,
          oneOf: next._whitelist.describe(),
          notOneOf: next._blacklist.describe(),
          tests: next.tests.map((fn) => ({
            name: fn.OPTIONS.name,
            params: fn.OPTIONS.params
          })).filter((n, idx2, list) => list.findIndex((c) => c.name === n.name) === idx2)
        };
        return description;
      }
    };
    exports.default = BaseSchema;
    BaseSchema.prototype.__isYupSchema__ = true;
    for (const method of ["validate", "validateSync"])
      BaseSchema.prototype[`${method}At`] = function(path2, value, options = {}) {
        const {
          parent,
          parentPath,
          schema: schema2
        } = (0, _reach.getIn)(this, path2, value, options.context);
        return schema2[method](parent && parent[parentPath], _extends({}, options, {
          parent,
          path: path2
        }));
      };
    for (const alias of ["equals", "is"])
      BaseSchema.prototype[alias] = BaseSchema.prototype.oneOf;
    for (const alias of ["not", "nope"])
      BaseSchema.prototype[alias] = BaseSchema.prototype.notOneOf;
    BaseSchema.prototype.optional = BaseSchema.prototype.notRequired;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/mixed.js
var require_mixed = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/mixed.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var Mixed = _schema.default;
    var _default2 = Mixed;
    exports.default = _default2;
    function create() {
      return new Mixed();
    }
    create.prototype = Mixed.prototype;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/isAbsent.js
var require_isAbsent = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/isAbsent.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;
    var isAbsent = (value) => value == null;
    var _default2 = isAbsent;
    exports.default = _default2;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/boolean.js
var require_boolean2 = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/boolean.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _schema = _interopRequireDefault(require_schema2());
    var _locale = require_locale();
    var _isAbsent = _interopRequireDefault(require_isAbsent());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function create() {
      return new BooleanSchema();
    }
    var BooleanSchema = class extends _schema.default {
      constructor() {
        super({
          type: "boolean"
        });
        this.withMutation(() => {
          this.transform(function(value) {
            if (!this.isType(value)) {
              if (/^(true|1)$/i.test(String(value)))
                return true;
              if (/^(false|0)$/i.test(String(value)))
                return false;
            }
            return value;
          });
        });
      }
      _typeCheck(v) {
        if (v instanceof Boolean)
          v = v.valueOf();
        return typeof v === "boolean";
      }
      isTrue(message = _locale.boolean.isValue) {
        return this.test({
          message,
          name: "is-value",
          exclusive: true,
          params: {
            value: "true"
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value === true;
          }
        });
      }
      isFalse(message = _locale.boolean.isValue) {
        return this.test({
          message,
          name: "is-value",
          exclusive: true,
          params: {
            value: "false"
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value === false;
          }
        });
      }
    };
    exports.default = BooleanSchema;
    create.prototype = BooleanSchema.prototype;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/string.js
var require_string3 = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/string.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _locale = require_locale();
    var _isAbsent = _interopRequireDefault(require_isAbsent());
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var rEmail = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i;
    var rUrl = /^((https?|ftp):)?\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i;
    var rUUID = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;
    var isTrimmed = (value) => (0, _isAbsent.default)(value) || value === value.trim();
    var objStringTag = {}.toString();
    function create() {
      return new StringSchema();
    }
    var StringSchema = class extends _schema.default {
      constructor() {
        super({
          type: "string"
        });
        this.withMutation(() => {
          this.transform(function(value) {
            if (this.isType(value))
              return value;
            if (Array.isArray(value))
              return value;
            const strValue = value != null && value.toString ? value.toString() : value;
            if (strValue === objStringTag)
              return value;
            return strValue;
          });
        });
      }
      _typeCheck(value) {
        if (value instanceof String)
          value = value.valueOf();
        return typeof value === "string";
      }
      _isPresent(value) {
        return super._isPresent(value) && !!value.length;
      }
      length(length, message = _locale.string.length) {
        return this.test({
          message,
          name: "length",
          exclusive: true,
          params: {
            length
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value.length === this.resolve(length);
          }
        });
      }
      min(min, message = _locale.string.min) {
        return this.test({
          message,
          name: "min",
          exclusive: true,
          params: {
            min
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value.length >= this.resolve(min);
          }
        });
      }
      max(max, message = _locale.string.max) {
        return this.test({
          name: "max",
          exclusive: true,
          message,
          params: {
            max
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value.length <= this.resolve(max);
          }
        });
      }
      matches(regex, options) {
        let excludeEmptyString = false;
        let message;
        let name;
        if (options) {
          if (typeof options === "object") {
            ({
              excludeEmptyString = false,
              message,
              name
            } = options);
          } else {
            message = options;
          }
        }
        return this.test({
          name: name || "matches",
          message: message || _locale.string.matches,
          params: {
            regex
          },
          test: (value) => (0, _isAbsent.default)(value) || value === "" && excludeEmptyString || value.search(regex) !== -1
        });
      }
      email(message = _locale.string.email) {
        return this.matches(rEmail, {
          name: "email",
          message,
          excludeEmptyString: true
        });
      }
      url(message = _locale.string.url) {
        return this.matches(rUrl, {
          name: "url",
          message,
          excludeEmptyString: true
        });
      }
      uuid(message = _locale.string.uuid) {
        return this.matches(rUUID, {
          name: "uuid",
          message,
          excludeEmptyString: false
        });
      }
      ensure() {
        return this.default("").transform((val) => val === null ? "" : val);
      }
      trim(message = _locale.string.trim) {
        return this.transform((val) => val != null ? val.trim() : val).test({
          message,
          name: "trim",
          test: isTrimmed
        });
      }
      lowercase(message = _locale.string.lowercase) {
        return this.transform((value) => !(0, _isAbsent.default)(value) ? value.toLowerCase() : value).test({
          message,
          name: "string_case",
          exclusive: true,
          test: (value) => (0, _isAbsent.default)(value) || value === value.toLowerCase()
        });
      }
      uppercase(message = _locale.string.uppercase) {
        return this.transform((value) => !(0, _isAbsent.default)(value) ? value.toUpperCase() : value).test({
          message,
          name: "string_case",
          exclusive: true,
          test: (value) => (0, _isAbsent.default)(value) || value === value.toUpperCase()
        });
      }
    };
    exports.default = StringSchema;
    create.prototype = StringSchema.prototype;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/number.js
var require_number2 = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/number.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _locale = require_locale();
    var _isAbsent = _interopRequireDefault(require_isAbsent());
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var isNaN2 = (value) => value != +value;
    function create() {
      return new NumberSchema();
    }
    var NumberSchema = class extends _schema.default {
      constructor() {
        super({
          type: "number"
        });
        this.withMutation(() => {
          this.transform(function(value) {
            let parsed = value;
            if (typeof parsed === "string") {
              parsed = parsed.replace(/\s/g, "");
              if (parsed === "")
                return NaN;
              parsed = +parsed;
            }
            if (this.isType(parsed))
              return parsed;
            return parseFloat(parsed);
          });
        });
      }
      _typeCheck(value) {
        if (value instanceof Number)
          value = value.valueOf();
        return typeof value === "number" && !isNaN2(value);
      }
      min(min, message = _locale.number.min) {
        return this.test({
          message,
          name: "min",
          exclusive: true,
          params: {
            min
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value >= this.resolve(min);
          }
        });
      }
      max(max, message = _locale.number.max) {
        return this.test({
          message,
          name: "max",
          exclusive: true,
          params: {
            max
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value <= this.resolve(max);
          }
        });
      }
      lessThan(less, message = _locale.number.lessThan) {
        return this.test({
          message,
          name: "max",
          exclusive: true,
          params: {
            less
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value < this.resolve(less);
          }
        });
      }
      moreThan(more, message = _locale.number.moreThan) {
        return this.test({
          message,
          name: "min",
          exclusive: true,
          params: {
            more
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value > this.resolve(more);
          }
        });
      }
      positive(msg = _locale.number.positive) {
        return this.moreThan(0, msg);
      }
      negative(msg = _locale.number.negative) {
        return this.lessThan(0, msg);
      }
      integer(message = _locale.number.integer) {
        return this.test({
          name: "integer",
          message,
          test: (val) => (0, _isAbsent.default)(val) || Number.isInteger(val)
        });
      }
      truncate() {
        return this.transform((value) => !(0, _isAbsent.default)(value) ? value | 0 : value);
      }
      round(method) {
        var _method;
        let avail = ["ceil", "floor", "round", "trunc"];
        method = ((_method = method) == null ? void 0 : _method.toLowerCase()) || "round";
        if (method === "trunc")
          return this.truncate();
        if (avail.indexOf(method.toLowerCase()) === -1)
          throw new TypeError("Only valid options for round() are: " + avail.join(", "));
        return this.transform((value) => !(0, _isAbsent.default)(value) ? Math[method](value) : value);
      }
    };
    exports.default = NumberSchema;
    create.prototype = NumberSchema.prototype;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/isodate.js
var require_isodate = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/isodate.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = parseIsoDate;
    var isoReg = /^(\d{4}|[+\-]\d{6})(?:-?(\d{2})(?:-?(\d{2}))?)?(?:[ T]?(\d{2}):?(\d{2})(?::?(\d{2})(?:[,\.](\d{1,}))?)?(?:(Z)|([+\-])(\d{2})(?::?(\d{2}))?)?)?$/;
    function parseIsoDate(date) {
      var numericKeys = [1, 4, 5, 6, 7, 10, 11], minutesOffset = 0, timestamp2, struct;
      if (struct = isoReg.exec(date)) {
        for (var i = 0, k; k = numericKeys[i]; ++i)
          struct[k] = +struct[k] || 0;
        struct[2] = (+struct[2] || 1) - 1;
        struct[3] = +struct[3] || 1;
        struct[7] = struct[7] ? String(struct[7]).substr(0, 3) : 0;
        if ((struct[8] === void 0 || struct[8] === "") && (struct[9] === void 0 || struct[9] === ""))
          timestamp2 = +new Date(struct[1], struct[2], struct[3], struct[4], struct[5], struct[6], struct[7]);
        else {
          if (struct[8] !== "Z" && struct[9] !== void 0) {
            minutesOffset = struct[10] * 60 + struct[11];
            if (struct[9] === "+")
              minutesOffset = 0 - minutesOffset;
          }
          timestamp2 = Date.UTC(struct[1], struct[2], struct[3], struct[4], struct[5] + minutesOffset, struct[6], struct[7]);
        }
      } else
        timestamp2 = Date.parse ? Date.parse(date) : NaN;
      return timestamp2;
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/date.js
var require_date = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/date.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _isodate = _interopRequireDefault(require_isodate());
    var _locale = require_locale();
    var _isAbsent = _interopRequireDefault(require_isAbsent());
    var _Reference = _interopRequireDefault(require_Reference());
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var invalidDate = new Date("");
    var isDate = (obj) => Object.prototype.toString.call(obj) === "[object Date]";
    function create() {
      return new DateSchema();
    }
    var DateSchema = class extends _schema.default {
      constructor() {
        super({
          type: "date"
        });
        this.withMutation(() => {
          this.transform(function(value) {
            if (this.isType(value))
              return value;
            value = (0, _isodate.default)(value);
            return !isNaN(value) ? new Date(value) : invalidDate;
          });
        });
      }
      _typeCheck(v) {
        return isDate(v) && !isNaN(v.getTime());
      }
      prepareParam(ref, name) {
        let param;
        if (!_Reference.default.isRef(ref)) {
          let cast = this.cast(ref);
          if (!this._typeCheck(cast))
            throw new TypeError(`\`${name}\` must be a Date or a value that can be \`cast()\` to a Date`);
          param = cast;
        } else {
          param = ref;
        }
        return param;
      }
      min(min, message = _locale.date.min) {
        let limit = this.prepareParam(min, "min");
        return this.test({
          message,
          name: "min",
          exclusive: true,
          params: {
            min
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value >= this.resolve(limit);
          }
        });
      }
      max(max, message = _locale.date.max) {
        let limit = this.prepareParam(max, "max");
        return this.test({
          message,
          name: "max",
          exclusive: true,
          params: {
            max
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value <= this.resolve(limit);
          }
        });
      }
    };
    exports.default = DateSchema;
    DateSchema.INVALID_DATE = invalidDate;
    create.prototype = DateSchema.prototype;
    create.INVALID_DATE = invalidDate;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayReduce.js
var require_arrayReduce = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayReduce.js"(exports, module2) {
    function arrayReduce(array, iteratee, accumulator, initAccum) {
      var index = -1, length = array == null ? 0 : array.length;
      if (initAccum && length) {
        accumulator = array[++index];
      }
      while (++index < length) {
        accumulator = iteratee(accumulator, array[index], index, array);
      }
      return accumulator;
    }
    module2.exports = arrayReduce;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePropertyOf.js
var require_basePropertyOf = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePropertyOf.js"(exports, module2) {
    function basePropertyOf(object2) {
      return function(key) {
        return object2 == null ? void 0 : object2[key];
      };
    }
    module2.exports = basePropertyOf;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_deburrLetter.js
var require_deburrLetter = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_deburrLetter.js"(exports, module2) {
    var basePropertyOf = require_basePropertyOf();
    var deburredLetters = {
      "\xC0": "A",
      "\xC1": "A",
      "\xC2": "A",
      "\xC3": "A",
      "\xC4": "A",
      "\xC5": "A",
      "\xE0": "a",
      "\xE1": "a",
      "\xE2": "a",
      "\xE3": "a",
      "\xE4": "a",
      "\xE5": "a",
      "\xC7": "C",
      "\xE7": "c",
      "\xD0": "D",
      "\xF0": "d",
      "\xC8": "E",
      "\xC9": "E",
      "\xCA": "E",
      "\xCB": "E",
      "\xE8": "e",
      "\xE9": "e",
      "\xEA": "e",
      "\xEB": "e",
      "\xCC": "I",
      "\xCD": "I",
      "\xCE": "I",
      "\xCF": "I",
      "\xEC": "i",
      "\xED": "i",
      "\xEE": "i",
      "\xEF": "i",
      "\xD1": "N",
      "\xF1": "n",
      "\xD2": "O",
      "\xD3": "O",
      "\xD4": "O",
      "\xD5": "O",
      "\xD6": "O",
      "\xD8": "O",
      "\xF2": "o",
      "\xF3": "o",
      "\xF4": "o",
      "\xF5": "o",
      "\xF6": "o",
      "\xF8": "o",
      "\xD9": "U",
      "\xDA": "U",
      "\xDB": "U",
      "\xDC": "U",
      "\xF9": "u",
      "\xFA": "u",
      "\xFB": "u",
      "\xFC": "u",
      "\xDD": "Y",
      "\xFD": "y",
      "\xFF": "y",
      "\xC6": "Ae",
      "\xE6": "ae",
      "\xDE": "Th",
      "\xFE": "th",
      "\xDF": "ss",
      "\u0100": "A",
      "\u0102": "A",
      "\u0104": "A",
      "\u0101": "a",
      "\u0103": "a",
      "\u0105": "a",
      "\u0106": "C",
      "\u0108": "C",
      "\u010A": "C",
      "\u010C": "C",
      "\u0107": "c",
      "\u0109": "c",
      "\u010B": "c",
      "\u010D": "c",
      "\u010E": "D",
      "\u0110": "D",
      "\u010F": "d",
      "\u0111": "d",
      "\u0112": "E",
      "\u0114": "E",
      "\u0116": "E",
      "\u0118": "E",
      "\u011A": "E",
      "\u0113": "e",
      "\u0115": "e",
      "\u0117": "e",
      "\u0119": "e",
      "\u011B": "e",
      "\u011C": "G",
      "\u011E": "G",
      "\u0120": "G",
      "\u0122": "G",
      "\u011D": "g",
      "\u011F": "g",
      "\u0121": "g",
      "\u0123": "g",
      "\u0124": "H",
      "\u0126": "H",
      "\u0125": "h",
      "\u0127": "h",
      "\u0128": "I",
      "\u012A": "I",
      "\u012C": "I",
      "\u012E": "I",
      "\u0130": "I",
      "\u0129": "i",
      "\u012B": "i",
      "\u012D": "i",
      "\u012F": "i",
      "\u0131": "i",
      "\u0134": "J",
      "\u0135": "j",
      "\u0136": "K",
      "\u0137": "k",
      "\u0138": "k",
      "\u0139": "L",
      "\u013B": "L",
      "\u013D": "L",
      "\u013F": "L",
      "\u0141": "L",
      "\u013A": "l",
      "\u013C": "l",
      "\u013E": "l",
      "\u0140": "l",
      "\u0142": "l",
      "\u0143": "N",
      "\u0145": "N",
      "\u0147": "N",
      "\u014A": "N",
      "\u0144": "n",
      "\u0146": "n",
      "\u0148": "n",
      "\u014B": "n",
      "\u014C": "O",
      "\u014E": "O",
      "\u0150": "O",
      "\u014D": "o",
      "\u014F": "o",
      "\u0151": "o",
      "\u0154": "R",
      "\u0156": "R",
      "\u0158": "R",
      "\u0155": "r",
      "\u0157": "r",
      "\u0159": "r",
      "\u015A": "S",
      "\u015C": "S",
      "\u015E": "S",
      "\u0160": "S",
      "\u015B": "s",
      "\u015D": "s",
      "\u015F": "s",
      "\u0161": "s",
      "\u0162": "T",
      "\u0164": "T",
      "\u0166": "T",
      "\u0163": "t",
      "\u0165": "t",
      "\u0167": "t",
      "\u0168": "U",
      "\u016A": "U",
      "\u016C": "U",
      "\u016E": "U",
      "\u0170": "U",
      "\u0172": "U",
      "\u0169": "u",
      "\u016B": "u",
      "\u016D": "u",
      "\u016F": "u",
      "\u0171": "u",
      "\u0173": "u",
      "\u0174": "W",
      "\u0175": "w",
      "\u0176": "Y",
      "\u0177": "y",
      "\u0178": "Y",
      "\u0179": "Z",
      "\u017B": "Z",
      "\u017D": "Z",
      "\u017A": "z",
      "\u017C": "z",
      "\u017E": "z",
      "\u0132": "IJ",
      "\u0133": "ij",
      "\u0152": "Oe",
      "\u0153": "oe",
      "\u0149": "'n",
      "\u017F": "s"
    };
    var deburrLetter = basePropertyOf(deburredLetters);
    module2.exports = deburrLetter;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/deburr.js
var require_deburr = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/deburr.js"(exports, module2) {
    var deburrLetter = require_deburrLetter();
    var toString2 = require_toString();
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var rsComboMarksRange = "\\u0300-\\u036f";
    var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
    var rsComboSymbolsRange = "\\u20d0-\\u20ff";
    var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
    var rsCombo = "[" + rsComboRange + "]";
    var reComboMark = RegExp(rsCombo, "g");
    function deburr(string2) {
      string2 = toString2(string2);
      return string2 && string2.replace(reLatin, deburrLetter).replace(reComboMark, "");
    }
    module2.exports = deburr;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiWords.js
var require_asciiWords = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiWords.js"(exports, module2) {
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    function asciiWords(string2) {
      return string2.match(reAsciiWord) || [];
    }
    module2.exports = asciiWords;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicodeWord.js
var require_hasUnicodeWord = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicodeWord.js"(exports, module2) {
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    function hasUnicodeWord(string2) {
      return reHasUnicodeWord.test(string2);
    }
    module2.exports = hasUnicodeWord;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeWords.js
var require_unicodeWords = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeWords.js"(exports, module2) {
    var rsAstralRange = "\\ud800-\\udfff";
    var rsComboMarksRange = "\\u0300-\\u036f";
    var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
    var rsComboSymbolsRange = "\\u20d0-\\u20ff";
    var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
    var rsDingbatRange = "\\u2700-\\u27bf";
    var rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff";
    var rsMathOpRange = "\\xac\\xb1\\xd7\\xf7";
    var rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf";
    var rsPunctuationRange = "\\u2000-\\u206f";
    var rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000";
    var rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde";
    var rsVarRange = "\\ufe0e\\ufe0f";
    var rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]";
    var rsBreak = "[" + rsBreakRange + "]";
    var rsCombo = "[" + rsComboRange + "]";
    var rsDigits = "\\d+";
    var rsDingbat = "[" + rsDingbatRange + "]";
    var rsLower = "[" + rsLowerRange + "]";
    var rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]";
    var rsFitz = "\\ud83c[\\udffb-\\udfff]";
    var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
    var rsNonAstral = "[^" + rsAstralRange + "]";
    var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
    var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
    var rsUpper = "[" + rsUpperRange + "]";
    var rsZWJ = "\\u200d";
    var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")";
    var rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")";
    var rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?";
    var rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?";
    var reOptMod = rsModifier + "?";
    var rsOptVar = "[" + rsVarRange + "]?";
    var rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
    var rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])";
    var rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])";
    var rsSeq = rsOptVar + reOptMod + rsOptJoin;
    var rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq;
    var reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    function unicodeWords(string2) {
      return string2.match(reUnicodeWord) || [];
    }
    module2.exports = unicodeWords;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/words.js
var require_words = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/words.js"(exports, module2) {
    var asciiWords = require_asciiWords();
    var hasUnicodeWord = require_hasUnicodeWord();
    var toString2 = require_toString();
    var unicodeWords = require_unicodeWords();
    function words(string2, pattern, guard) {
      string2 = toString2(string2);
      pattern = guard ? void 0 : pattern;
      if (pattern === void 0) {
        return hasUnicodeWord(string2) ? unicodeWords(string2) : asciiWords(string2);
      }
      return string2.match(pattern) || [];
    }
    module2.exports = words;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCompounder.js
var require_createCompounder = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCompounder.js"(exports, module2) {
    var arrayReduce = require_arrayReduce();
    var deburr = require_deburr();
    var words = require_words();
    var rsApos = "['\u2019]";
    var reApos = RegExp(rsApos, "g");
    function createCompounder(callback) {
      return function(string2) {
        return arrayReduce(words(deburr(string2).replace(reApos, "")), callback, "");
      };
    }
    module2.exports = createCompounder;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/snakeCase.js
var require_snakeCase = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/snakeCase.js"(exports, module2) {
    var createCompounder = require_createCompounder();
    var snakeCase = createCompounder(function(result2, word, index) {
      return result2 + (index ? "_" : "") + word.toLowerCase();
    });
    module2.exports = snakeCase;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSlice.js
var require_baseSlice = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSlice.js"(exports, module2) {
    function baseSlice(array, start, end) {
      var index = -1, length = array.length;
      if (start < 0) {
        start = -start > length ? 0 : length + start;
      }
      end = end > length ? length : end;
      if (end < 0) {
        end += length;
      }
      length = start > end ? 0 : end - start >>> 0;
      start >>>= 0;
      var result2 = Array(length);
      while (++index < length) {
        result2[index] = array[index + start];
      }
      return result2;
    }
    module2.exports = baseSlice;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_castSlice.js
var require_castSlice = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_castSlice.js"(exports, module2) {
    var baseSlice = require_baseSlice();
    function castSlice(array, start, end) {
      var length = array.length;
      end = end === void 0 ? length : end;
      return !start && end >= length ? array : baseSlice(array, start, end);
    }
    module2.exports = castSlice;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicode.js
var require_hasUnicode = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicode.js"(exports, module2) {
    var rsAstralRange = "\\ud800-\\udfff";
    var rsComboMarksRange = "\\u0300-\\u036f";
    var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
    var rsComboSymbolsRange = "\\u20d0-\\u20ff";
    var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
    var rsVarRange = "\\ufe0e\\ufe0f";
    var rsZWJ = "\\u200d";
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    function hasUnicode(string2) {
      return reHasUnicode.test(string2);
    }
    module2.exports = hasUnicode;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiToArray.js
var require_asciiToArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiToArray.js"(exports, module2) {
    function asciiToArray(string2) {
      return string2.split("");
    }
    module2.exports = asciiToArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeToArray.js
var require_unicodeToArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeToArray.js"(exports, module2) {
    var rsAstralRange = "\\ud800-\\udfff";
    var rsComboMarksRange = "\\u0300-\\u036f";
    var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
    var rsComboSymbolsRange = "\\u20d0-\\u20ff";
    var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
    var rsVarRange = "\\ufe0e\\ufe0f";
    var rsAstral = "[" + rsAstralRange + "]";
    var rsCombo = "[" + rsComboRange + "]";
    var rsFitz = "\\ud83c[\\udffb-\\udfff]";
    var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
    var rsNonAstral = "[^" + rsAstralRange + "]";
    var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
    var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
    var rsZWJ = "\\u200d";
    var reOptMod = rsModifier + "?";
    var rsOptVar = "[" + rsVarRange + "]?";
    var rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
    var rsSeq = rsOptVar + reOptMod + rsOptJoin;
    var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    function unicodeToArray(string2) {
      return string2.match(reUnicode) || [];
    }
    module2.exports = unicodeToArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stringToArray.js
var require_stringToArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stringToArray.js"(exports, module2) {
    var asciiToArray = require_asciiToArray();
    var hasUnicode = require_hasUnicode();
    var unicodeToArray = require_unicodeToArray();
    function stringToArray(string2) {
      return hasUnicode(string2) ? unicodeToArray(string2) : asciiToArray(string2);
    }
    module2.exports = stringToArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCaseFirst.js
var require_createCaseFirst = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCaseFirst.js"(exports, module2) {
    var castSlice = require_castSlice();
    var hasUnicode = require_hasUnicode();
    var stringToArray = require_stringToArray();
    var toString2 = require_toString();
    function createCaseFirst(methodName) {
      return function(string2) {
        string2 = toString2(string2);
        var strSymbols = hasUnicode(string2) ? stringToArray(string2) : void 0;
        var chr = strSymbols ? strSymbols[0] : string2.charAt(0);
        var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string2.slice(1);
        return chr[methodName]() + trailing;
      };
    }
    module2.exports = createCaseFirst;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/upperFirst.js
var require_upperFirst = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/upperFirst.js"(exports, module2) {
    var createCaseFirst = require_createCaseFirst();
    var upperFirst = createCaseFirst("toUpperCase");
    module2.exports = upperFirst;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/capitalize.js
var require_capitalize = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/capitalize.js"(exports, module2) {
    var toString2 = require_toString();
    var upperFirst = require_upperFirst();
    function capitalize(string2) {
      return upperFirst(toString2(string2).toLowerCase());
    }
    module2.exports = capitalize;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/camelCase.js
var require_camelCase = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/camelCase.js"(exports, module2) {
    var capitalize = require_capitalize();
    var createCompounder = require_createCompounder();
    var camelCase = createCompounder(function(result2, word, index) {
      word = word.toLowerCase();
      return result2 + (index ? capitalize(word) : word);
    });
    module2.exports = camelCase;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/mapKeys.js
var require_mapKeys = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/mapKeys.js"(exports, module2) {
    var baseAssignValue = require_baseAssignValue();
    var baseForOwn = require_baseForOwn();
    var baseIteratee = require_baseIteratee();
    function mapKeys(object2, iteratee) {
      var result2 = {};
      iteratee = baseIteratee(iteratee, 3);
      baseForOwn(object2, function(value, key, object3) {
        baseAssignValue(result2, iteratee(value, key, object3), value);
      });
      return result2;
    }
    module2.exports = mapKeys;
  }
});

// node_modules/.pnpm/toposort@2.0.2/node_modules/toposort/index.js
var require_toposort = __commonJS({
  "node_modules/.pnpm/toposort@2.0.2/node_modules/toposort/index.js"(exports, module2) {
    module2.exports = function(edges) {
      return toposort(uniqueNodes(edges), edges);
    };
    module2.exports.array = toposort;
    function toposort(nodes, edges) {
      var cursor = nodes.length, sorted = new Array(cursor), visited = {}, i = cursor, outgoingEdges = makeOutgoingEdges(edges), nodesHash = makeNodesHash(nodes);
      edges.forEach(function(edge) {
        if (!nodesHash.has(edge[0]) || !nodesHash.has(edge[1])) {
          throw new Error("Unknown node. There is an unknown node in the supplied edges.");
        }
      });
      while (i--) {
        if (!visited[i])
          visit(nodes[i], i, /* @__PURE__ */ new Set());
      }
      return sorted;
      function visit(node, i2, predecessors) {
        if (predecessors.has(node)) {
          var nodeRep;
          try {
            nodeRep = ", node was:" + JSON.stringify(node);
          } catch (e) {
            nodeRep = "";
          }
          throw new Error("Cyclic dependency" + nodeRep);
        }
        if (!nodesHash.has(node)) {
          throw new Error("Found unknown node. Make sure to provided all involved nodes. Unknown node: " + JSON.stringify(node));
        }
        if (visited[i2])
          return;
        visited[i2] = true;
        var outgoing = outgoingEdges.get(node) || /* @__PURE__ */ new Set();
        outgoing = Array.from(outgoing);
        if (i2 = outgoing.length) {
          predecessors.add(node);
          do {
            var child = outgoing[--i2];
            visit(child, nodesHash.get(child), predecessors);
          } while (i2);
          predecessors.delete(node);
        }
        sorted[--cursor] = node;
      }
    }
    function uniqueNodes(arr) {
      var res = /* @__PURE__ */ new Set();
      for (var i = 0, len = arr.length; i < len; i++) {
        var edge = arr[i];
        res.add(edge[0]);
        res.add(edge[1]);
      }
      return Array.from(res);
    }
    function makeOutgoingEdges(arr) {
      var edges = /* @__PURE__ */ new Map();
      for (var i = 0, len = arr.length; i < len; i++) {
        var edge = arr[i];
        if (!edges.has(edge[0]))
          edges.set(edge[0], /* @__PURE__ */ new Set());
        if (!edges.has(edge[1]))
          edges.set(edge[1], /* @__PURE__ */ new Set());
        edges.get(edge[0]).add(edge[1]);
      }
      return edges;
    }
    function makeNodesHash(arr) {
      var res = /* @__PURE__ */ new Map();
      for (var i = 0, len = arr.length; i < len; i++) {
        res.set(arr[i], i);
      }
      return res;
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/sortFields.js
var require_sortFields = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/sortFields.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = sortFields;
    var _has = _interopRequireDefault(require_has());
    var _toposort = _interopRequireDefault(require_toposort());
    var _propertyExpr = require_property_expr();
    var _Reference = _interopRequireDefault(require_Reference());
    var _isSchema = _interopRequireDefault(require_isSchema());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function sortFields(fields, excludedEdges = []) {
      let edges = [];
      let nodes = /* @__PURE__ */ new Set();
      let excludes = new Set(excludedEdges.map(([a, b]) => `${a}-${b}`));
      function addNode(depPath, key) {
        let node = (0, _propertyExpr.split)(depPath)[0];
        nodes.add(node);
        if (!excludes.has(`${key}-${node}`))
          edges.push([key, node]);
      }
      for (const key in fields)
        if ((0, _has.default)(fields, key)) {
          let value = fields[key];
          nodes.add(key);
          if (_Reference.default.isRef(value) && value.isSibling)
            addNode(value.path, key);
          else if ((0, _isSchema.default)(value) && "deps" in value)
            value.deps.forEach((path2) => addNode(path2, key));
        }
      return _toposort.default.array(Array.from(nodes), edges).reverse();
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/sortByKeyOrder.js
var require_sortByKeyOrder = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/util/sortByKeyOrder.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = sortByKeyOrder;
    function findIndex(arr, err) {
      let idx2 = Infinity;
      arr.some((key, ii) => {
        var _err$path;
        if (((_err$path = err.path) == null ? void 0 : _err$path.indexOf(key)) !== -1) {
          idx2 = ii;
          return true;
        }
      });
      return idx2;
    }
    function sortByKeyOrder(keys) {
      return (a, b) => {
        return findIndex(keys, a) - findIndex(keys, b);
      };
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/object.js
var require_object = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/object.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _has = _interopRequireDefault(require_has());
    var _snakeCase = _interopRequireDefault(require_snakeCase());
    var _camelCase = _interopRequireDefault(require_camelCase());
    var _mapKeys = _interopRequireDefault(require_mapKeys());
    var _mapValues = _interopRequireDefault(require_mapValues());
    var _propertyExpr = require_property_expr();
    var _locale = require_locale();
    var _sortFields = _interopRequireDefault(require_sortFields());
    var _sortByKeyOrder = _interopRequireDefault(require_sortByKeyOrder());
    var _runTests = _interopRequireDefault(require_runTests());
    var _ValidationError = _interopRequireDefault(require_ValidationError());
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _extends() {
      _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }
    var isObject2 = (obj) => Object.prototype.toString.call(obj) === "[object Object]";
    function unknown(ctx, value) {
      let known = Object.keys(ctx.fields);
      return Object.keys(value).filter((key) => known.indexOf(key) === -1);
    }
    var defaultSort = (0, _sortByKeyOrder.default)([]);
    var ObjectSchema = class extends _schema.default {
      constructor(spec) {
        super({
          type: "object"
        });
        this.fields = /* @__PURE__ */ Object.create(null);
        this._sortErrors = defaultSort;
        this._nodes = [];
        this._excludedEdges = [];
        this.withMutation(() => {
          this.transform(function coerce(value) {
            if (typeof value === "string") {
              try {
                value = JSON.parse(value);
              } catch (err) {
                value = null;
              }
            }
            if (this.isType(value))
              return value;
            return null;
          });
          if (spec) {
            this.shape(spec);
          }
        });
      }
      _typeCheck(value) {
        return isObject2(value) || typeof value === "function";
      }
      _cast(_value, options = {}) {
        var _options$stripUnknown;
        let value = super._cast(_value, options);
        if (value === void 0)
          return this.getDefault();
        if (!this._typeCheck(value))
          return value;
        let fields = this.fields;
        let strip = (_options$stripUnknown = options.stripUnknown) != null ? _options$stripUnknown : this.spec.noUnknown;
        let props = this._nodes.concat(Object.keys(value).filter((v) => this._nodes.indexOf(v) === -1));
        let intermediateValue = {};
        let innerOptions = _extends({}, options, {
          parent: intermediateValue,
          __validating: options.__validating || false
        });
        let isChanged = false;
        for (const prop of props) {
          let field = fields[prop];
          let exists = (0, _has.default)(value, prop);
          if (field) {
            let fieldValue;
            let inputValue = value[prop];
            innerOptions.path = (options.path ? `${options.path}.` : "") + prop;
            field = field.resolve({
              value: inputValue,
              context: options.context,
              parent: intermediateValue
            });
            let fieldSpec = "spec" in field ? field.spec : void 0;
            let strict = fieldSpec == null ? void 0 : fieldSpec.strict;
            if (fieldSpec == null ? void 0 : fieldSpec.strip) {
              isChanged = isChanged || prop in value;
              continue;
            }
            fieldValue = !options.__validating || !strict ? field.cast(value[prop], innerOptions) : value[prop];
            if (fieldValue !== void 0) {
              intermediateValue[prop] = fieldValue;
            }
          } else if (exists && !strip) {
            intermediateValue[prop] = value[prop];
          }
          if (intermediateValue[prop] !== value[prop]) {
            isChanged = true;
          }
        }
        return isChanged ? intermediateValue : value;
      }
      _validate(_value, opts = {}, callback) {
        let errors = [];
        let {
          sync,
          from = [],
          originalValue = _value,
          abortEarly = this.spec.abortEarly,
          recursive = this.spec.recursive
        } = opts;
        from = [{
          schema: this,
          value: originalValue
        }, ...from];
        opts.__validating = true;
        opts.originalValue = originalValue;
        opts.from = from;
        super._validate(_value, opts, (err, value) => {
          if (err) {
            if (!_ValidationError.default.isError(err) || abortEarly) {
              return void callback(err, value);
            }
            errors.push(err);
          }
          if (!recursive || !isObject2(value)) {
            callback(errors[0] || null, value);
            return;
          }
          originalValue = originalValue || value;
          let tests = this._nodes.map((key) => (_, cb) => {
            let path2 = key.indexOf(".") === -1 ? (opts.path ? `${opts.path}.` : "") + key : `${opts.path || ""}["${key}"]`;
            let field = this.fields[key];
            if (field && "validate" in field) {
              field.validate(value[key], _extends({}, opts, {
                path: path2,
                from,
                strict: true,
                parent: value,
                originalValue: originalValue[key]
              }), cb);
              return;
            }
            cb(null);
          });
          (0, _runTests.default)({
            sync,
            tests,
            value,
            errors,
            endEarly: abortEarly,
            sort: this._sortErrors,
            path: opts.path
          }, callback);
        });
      }
      clone(spec) {
        const next = super.clone(spec);
        next.fields = _extends({}, this.fields);
        next._nodes = this._nodes;
        next._excludedEdges = this._excludedEdges;
        next._sortErrors = this._sortErrors;
        return next;
      }
      concat(schema2) {
        let next = super.concat(schema2);
        let nextFields = next.fields;
        for (let [field, schemaOrRef] of Object.entries(this.fields)) {
          const target = nextFields[field];
          if (target === void 0) {
            nextFields[field] = schemaOrRef;
          } else if (target instanceof _schema.default && schemaOrRef instanceof _schema.default) {
            nextFields[field] = schemaOrRef.concat(target);
          }
        }
        return next.withMutation(() => next.shape(nextFields, this._excludedEdges));
      }
      getDefaultFromShape() {
        let dft = {};
        this._nodes.forEach((key) => {
          const field = this.fields[key];
          dft[key] = "default" in field ? field.getDefault() : void 0;
        });
        return dft;
      }
      _getDefault() {
        if ("default" in this.spec) {
          return super._getDefault();
        }
        if (!this._nodes.length) {
          return void 0;
        }
        return this.getDefaultFromShape();
      }
      shape(additions, excludes = []) {
        let next = this.clone();
        let fields = Object.assign(next.fields, additions);
        next.fields = fields;
        next._sortErrors = (0, _sortByKeyOrder.default)(Object.keys(fields));
        if (excludes.length) {
          if (!Array.isArray(excludes[0]))
            excludes = [excludes];
          next._excludedEdges = [...next._excludedEdges, ...excludes];
        }
        next._nodes = (0, _sortFields.default)(fields, next._excludedEdges);
        return next;
      }
      pick(keys) {
        const picked = {};
        for (const key of keys) {
          if (this.fields[key])
            picked[key] = this.fields[key];
        }
        return this.clone().withMutation((next) => {
          next.fields = {};
          return next.shape(picked);
        });
      }
      omit(keys) {
        const next = this.clone();
        const fields = next.fields;
        next.fields = {};
        for (const key of keys) {
          delete fields[key];
        }
        return next.withMutation(() => next.shape(fields));
      }
      from(from, to, alias) {
        let fromGetter = (0, _propertyExpr.getter)(from, true);
        return this.transform((obj) => {
          if (obj == null)
            return obj;
          let newObj = obj;
          if ((0, _has.default)(obj, from)) {
            newObj = _extends({}, obj);
            if (!alias)
              delete newObj[from];
            newObj[to] = fromGetter(obj);
          }
          return newObj;
        });
      }
      noUnknown(noAllow = true, message = _locale.object.noUnknown) {
        if (typeof noAllow === "string") {
          message = noAllow;
          noAllow = true;
        }
        let next = this.test({
          name: "noUnknown",
          exclusive: true,
          message,
          test(value) {
            if (value == null)
              return true;
            const unknownKeys = unknown(this.schema, value);
            return !noAllow || unknownKeys.length === 0 || this.createError({
              params: {
                unknown: unknownKeys.join(", ")
              }
            });
          }
        });
        next.spec.noUnknown = noAllow;
        return next;
      }
      unknown(allow = true, message = _locale.object.noUnknown) {
        return this.noUnknown(!allow, message);
      }
      transformKeys(fn) {
        return this.transform((obj) => obj && (0, _mapKeys.default)(obj, (_, key) => fn(key)));
      }
      camelCase() {
        return this.transformKeys(_camelCase.default);
      }
      snakeCase() {
        return this.transformKeys(_snakeCase.default);
      }
      constantCase() {
        return this.transformKeys((key) => (0, _snakeCase.default)(key).toUpperCase());
      }
      describe() {
        let base = super.describe();
        base.fields = (0, _mapValues.default)(this.fields, (value) => value.describe());
        return base;
      }
    };
    exports.default = ObjectSchema;
    function create(spec) {
      return new ObjectSchema(spec);
    }
    create.prototype = ObjectSchema.prototype;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/array.js
var require_array3 = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/array.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _isAbsent = _interopRequireDefault(require_isAbsent());
    var _isSchema = _interopRequireDefault(require_isSchema());
    var _printValue = _interopRequireDefault(require_printValue());
    var _locale = require_locale();
    var _runTests = _interopRequireDefault(require_runTests());
    var _ValidationError = _interopRequireDefault(require_ValidationError());
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _extends() {
      _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }
    function create(type2) {
      return new ArraySchema(type2);
    }
    var ArraySchema = class extends _schema.default {
      constructor(type2) {
        super({
          type: "array"
        });
        this.innerType = void 0;
        this.innerType = type2;
        this.withMutation(() => {
          this.transform(function(values) {
            if (typeof values === "string")
              try {
                values = JSON.parse(values);
              } catch (err) {
                values = null;
              }
            return this.isType(values) ? values : null;
          });
        });
      }
      _typeCheck(v) {
        return Array.isArray(v);
      }
      get _subType() {
        return this.innerType;
      }
      _cast(_value, _opts) {
        const value = super._cast(_value, _opts);
        if (!this._typeCheck(value) || !this.innerType)
          return value;
        let isChanged = false;
        const castArray = value.map((v, idx2) => {
          const castElement = this.innerType.cast(v, _extends({}, _opts, {
            path: `${_opts.path || ""}[${idx2}]`
          }));
          if (castElement !== v) {
            isChanged = true;
          }
          return castElement;
        });
        return isChanged ? castArray : value;
      }
      _validate(_value, options = {}, callback) {
        var _options$abortEarly, _options$recursive;
        let errors = [];
        let sync = options.sync;
        let path2 = options.path;
        let innerType = this.innerType;
        let endEarly = (_options$abortEarly = options.abortEarly) != null ? _options$abortEarly : this.spec.abortEarly;
        let recursive = (_options$recursive = options.recursive) != null ? _options$recursive : this.spec.recursive;
        let originalValue = options.originalValue != null ? options.originalValue : _value;
        super._validate(_value, options, (err, value) => {
          if (err) {
            if (!_ValidationError.default.isError(err) || endEarly) {
              return void callback(err, value);
            }
            errors.push(err);
          }
          if (!recursive || !innerType || !this._typeCheck(value)) {
            callback(errors[0] || null, value);
            return;
          }
          originalValue = originalValue || value;
          let tests = new Array(value.length);
          for (let idx2 = 0; idx2 < value.length; idx2++) {
            let item = value[idx2];
            let path3 = `${options.path || ""}[${idx2}]`;
            let innerOptions = _extends({}, options, {
              path: path3,
              strict: true,
              parent: value,
              index: idx2,
              originalValue: originalValue[idx2]
            });
            tests[idx2] = (_, cb) => innerType.validate(item, innerOptions, cb);
          }
          (0, _runTests.default)({
            sync,
            path: path2,
            value,
            errors,
            endEarly,
            tests
          }, callback);
        });
      }
      clone(spec) {
        const next = super.clone(spec);
        next.innerType = this.innerType;
        return next;
      }
      concat(schema2) {
        let next = super.concat(schema2);
        next.innerType = this.innerType;
        if (schema2.innerType)
          next.innerType = next.innerType ? next.innerType.concat(schema2.innerType) : schema2.innerType;
        return next;
      }
      of(schema2) {
        let next = this.clone();
        if (!(0, _isSchema.default)(schema2))
          throw new TypeError("`array.of()` sub-schema must be a valid yup schema not: " + (0, _printValue.default)(schema2));
        next.innerType = schema2;
        return next;
      }
      length(length, message = _locale.array.length) {
        return this.test({
          message,
          name: "length",
          exclusive: true,
          params: {
            length
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value.length === this.resolve(length);
          }
        });
      }
      min(min, message) {
        message = message || _locale.array.min;
        return this.test({
          message,
          name: "min",
          exclusive: true,
          params: {
            min
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value.length >= this.resolve(min);
          }
        });
      }
      max(max, message) {
        message = message || _locale.array.max;
        return this.test({
          message,
          name: "max",
          exclusive: true,
          params: {
            max
          },
          test(value) {
            return (0, _isAbsent.default)(value) || value.length <= this.resolve(max);
          }
        });
      }
      ensure() {
        return this.default(() => []).transform((val, original) => {
          if (this._typeCheck(val))
            return val;
          return original == null ? [] : [].concat(original);
        });
      }
      compact(rejector) {
        let reject = !rejector ? (v) => !!v : (v, i, a) => !rejector(v, i, a);
        return this.transform((values) => values != null ? values.filter(reject) : values);
      }
      describe() {
        let base = super.describe();
        if (this.innerType)
          base.innerType = this.innerType.describe();
        return base;
      }
      nullable(isNullable = true) {
        return super.nullable(isNullable);
      }
      defined() {
        return super.defined();
      }
      required(msg) {
        return super.required(msg);
      }
    };
    exports.default = ArraySchema;
    create.prototype = ArraySchema.prototype;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/Lazy.js
var require_Lazy = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/Lazy.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.create = create;
    exports.default = void 0;
    var _isSchema = _interopRequireDefault(require_isSchema());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function create(builder) {
      return new Lazy(builder);
    }
    var Lazy = class {
      constructor(builder) {
        this.type = "lazy";
        this.__isYupSchema__ = true;
        this.__inputType = void 0;
        this.__outputType = void 0;
        this._resolve = (value, options = {}) => {
          let schema2 = this.builder(value, options);
          if (!(0, _isSchema.default)(schema2))
            throw new TypeError("lazy() functions must return a valid schema");
          return schema2.resolve(options);
        };
        this.builder = builder;
      }
      resolve(options) {
        return this._resolve(options.value, options);
      }
      cast(value, options) {
        return this._resolve(value, options).cast(value, options);
      }
      validate(value, options, maybeCb) {
        return this._resolve(value, options).validate(value, options, maybeCb);
      }
      validateSync(value, options) {
        return this._resolve(value, options).validateSync(value, options);
      }
      validateAt(path2, value, options) {
        return this._resolve(value, options).validateAt(path2, value, options);
      }
      validateSyncAt(path2, value, options) {
        return this._resolve(value, options).validateSyncAt(path2, value, options);
      }
      describe() {
        return null;
      }
      isValid(value, options) {
        return this._resolve(value, options).isValid(value, options);
      }
      isValidSync(value, options) {
        return this._resolve(value, options).isValidSync(value, options);
      }
    };
    var _default2 = Lazy;
    exports.default = _default2;
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/setLocale.js
var require_setLocale = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/setLocale.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = setLocale;
    var _locale = _interopRequireDefault(require_locale());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function setLocale(custom) {
      Object.keys(custom).forEach((type2) => {
        Object.keys(custom[type2]).forEach((method) => {
          _locale.default[type2][method] = custom[type2][method];
        });
      });
    }
  }
});

// node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/index.js
var require_lib6 = __commonJS({
  "node_modules/.pnpm/yup@0.32.11/node_modules/yup/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    Object.defineProperty(exports, "ArraySchema", {
      enumerable: true,
      get: function() {
        return _array.default;
      }
    });
    Object.defineProperty(exports, "BaseSchema", {
      enumerable: true,
      get: function() {
        return _schema.default;
      }
    });
    Object.defineProperty(exports, "BooleanSchema", {
      enumerable: true,
      get: function() {
        return _boolean.default;
      }
    });
    Object.defineProperty(exports, "DateSchema", {
      enumerable: true,
      get: function() {
        return _date.default;
      }
    });
    Object.defineProperty(exports, "MixedSchema", {
      enumerable: true,
      get: function() {
        return _mixed.default;
      }
    });
    Object.defineProperty(exports, "NumberSchema", {
      enumerable: true,
      get: function() {
        return _number.default;
      }
    });
    Object.defineProperty(exports, "ObjectSchema", {
      enumerable: true,
      get: function() {
        return _object.default;
      }
    });
    Object.defineProperty(exports, "StringSchema", {
      enumerable: true,
      get: function() {
        return _string.default;
      }
    });
    Object.defineProperty(exports, "ValidationError", {
      enumerable: true,
      get: function() {
        return _ValidationError.default;
      }
    });
    exports.addMethod = addMethod;
    Object.defineProperty(exports, "array", {
      enumerable: true,
      get: function() {
        return _array.create;
      }
    });
    Object.defineProperty(exports, "bool", {
      enumerable: true,
      get: function() {
        return _boolean.create;
      }
    });
    Object.defineProperty(exports, "boolean", {
      enumerable: true,
      get: function() {
        return _boolean.create;
      }
    });
    Object.defineProperty(exports, "date", {
      enumerable: true,
      get: function() {
        return _date.create;
      }
    });
    Object.defineProperty(exports, "isSchema", {
      enumerable: true,
      get: function() {
        return _isSchema.default;
      }
    });
    Object.defineProperty(exports, "lazy", {
      enumerable: true,
      get: function() {
        return _Lazy.create;
      }
    });
    Object.defineProperty(exports, "mixed", {
      enumerable: true,
      get: function() {
        return _mixed.create;
      }
    });
    Object.defineProperty(exports, "number", {
      enumerable: true,
      get: function() {
        return _number.create;
      }
    });
    Object.defineProperty(exports, "object", {
      enumerable: true,
      get: function() {
        return _object.create;
      }
    });
    Object.defineProperty(exports, "reach", {
      enumerable: true,
      get: function() {
        return _reach.default;
      }
    });
    Object.defineProperty(exports, "ref", {
      enumerable: true,
      get: function() {
        return _Reference.create;
      }
    });
    Object.defineProperty(exports, "setLocale", {
      enumerable: true,
      get: function() {
        return _setLocale.default;
      }
    });
    Object.defineProperty(exports, "string", {
      enumerable: true,
      get: function() {
        return _string.create;
      }
    });
    var _mixed = _interopRequireWildcard(require_mixed());
    var _boolean = _interopRequireWildcard(require_boolean2());
    var _string = _interopRequireWildcard(require_string3());
    var _number = _interopRequireWildcard(require_number2());
    var _date = _interopRequireWildcard(require_date());
    var _object = _interopRequireWildcard(require_object());
    var _array = _interopRequireWildcard(require_array3());
    var _Reference = require_Reference();
    var _Lazy = require_Lazy();
    var _ValidationError = _interopRequireDefault(require_ValidationError());
    var _reach = _interopRequireDefault(require_reach());
    var _isSchema = _interopRequireDefault(require_isSchema());
    var _setLocale = _interopRequireDefault(require_setLocale());
    var _schema = _interopRequireDefault(require_schema2());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _getRequireWildcardCache(nodeInterop) {
      if (typeof WeakMap !== "function")
        return null;
      var cacheBabelInterop = /* @__PURE__ */ new WeakMap();
      var cacheNodeInterop = /* @__PURE__ */ new WeakMap();
      return (_getRequireWildcardCache = function(nodeInterop2) {
        return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
      })(nodeInterop);
    }
    function _interopRequireWildcard(obj, nodeInterop) {
      if (!nodeInterop && obj && obj.__esModule) {
        return obj;
      }
      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return { default: obj };
      }
      var cache = _getRequireWildcardCache(nodeInterop);
      if (cache && cache.has(obj)) {
        return cache.get(obj);
      }
      var newObj = {};
      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
      for (var key in obj) {
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
          if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
      newObj.default = obj;
      if (cache) {
        cache.set(obj, newObj);
      }
      return newObj;
    }
    function addMethod(schemaType, name, fn) {
      if (!schemaType || !(0, _isSchema.default)(schemaType.prototype))
        throw new TypeError("You must provide a yup schema constructor function");
      if (typeof name !== "string")
        throw new TypeError("A Method name must be provided");
      if (typeof fn !== "function")
        throw new TypeError("Method function must be provided");
      schemaType.prototype[name] = fn;
    }
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getPrototype.js
var require_getPrototype = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getPrototype.js"(exports, module2) {
    var overArg = require_overArg();
    var getPrototype = overArg(Object.getPrototypeOf, Object);
    module2.exports = getPrototype;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isPlainObject.js
var require_isPlainObject = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isPlainObject.js"(exports, module2) {
    var baseGetTag = require_baseGetTag();
    var getPrototype = require_getPrototype();
    var isObjectLike = require_isObjectLike();
    var objectTag = "[object Object]";
    var funcProto = Function.prototype;
    var objectProto = Object.prototype;
    var funcToString = funcProto.toString;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var objectCtorString = funcToString.call(Object);
    function isPlainObject(value) {
      if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
        return false;
      }
      var proto = getPrototype(value);
      if (proto === null) {
        return true;
      }
      var Ctor = hasOwnProperty2.call(proto, "constructor") && proto.constructor;
      return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
    }
    module2.exports = isPlainObject;
  }
});

// node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/defaultStyle.js
var require_defaultStyle = __commonJS({
  "node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/defaultStyle.js"(exports, module2) {
    module2.exports = function() {
      return {
        "pretty-error": {
          display: "block",
          marginLeft: "2"
        },
        "pretty-error > header": {
          display: "block"
        },
        "pretty-error > header > title > kind": {
          background: "red",
          color: "bright-white"
        },
        "pretty-error > header > title > wrapper": {
          marginRight: "1",
          color: "grey"
        },
        "pretty-error > header > colon": {
          color: "grey",
          marginRight: 1
        },
        "pretty-error > header > message": {
          color: "bright-white"
        },
        "pretty-error > trace": {
          display: "block",
          marginTop: 1
        },
        "pretty-error > trace > item": {
          display: "block",
          marginBottom: 1,
          marginLeft: 2,
          bullet: '"<grey>-</grey>"'
        },
        "pretty-error > trace > item > header": {
          display: "block"
        },
        "pretty-error > trace > item > header > pointer > file": {
          color: "bright-yellow"
        },
        "pretty-error > trace > item > header > pointer > colon": {
          color: "grey"
        },
        "pretty-error > trace > item > header > pointer > line": {
          color: "bright-yellow",
          marginRight: 1
        },
        "pretty-error > trace > item > header > what": {
          color: "white"
        },
        "pretty-error > trace > item > footer": {
          display: "block"
        },
        "pretty-error > trace > item > footer > addr": {
          display: "block",
          color: "grey"
        },
        "pretty-error > trace > item > footer > extra": {
          display: "block",
          color: "grey"
        }
      };
    };
  }
});

// node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/ParsedError.js
var require_ParsedError = __commonJS({
  "node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/ParsedError.js"(exports, module2) {
    var ParsedError;
    var fn;
    var i;
    var len;
    var prop;
    var ref;
    var sysPath;
    sysPath = require("path");
    module2.exports = ParsedError = function() {
      function ParsedError2(error) {
        this.error = error;
        this._parse();
      }
      ParsedError2.prototype._parse = function() {
        var m;
        this._trace = [];
        this._kind = "Error";
        this._wrapper = "";
        if (this.error.wrapper != null) {
          this._wrapper = String(this.error.wrapper);
        }
        if (typeof this.error !== "object") {
          this._message = String(this.error);
        } else {
          this._stack = this.error.stack;
          if (this.error.kind != null) {
            this._kind = String(this.error.kind);
          } else if (typeof this._stack === "string") {
            if (m = this._stack.match(/^([a-zA-Z0-9\_\$]+):\ /)) {
              this._kind = m[1];
            }
          }
          this._message = this.error.message != null && String(this.error.message) || "";
          if (typeof this._stack === "string") {
            this._parseStack();
          }
        }
      };
      ParsedError2.prototype._parseStack = function() {
        var i2, len2, line, message, messageLines, reachedTrace, ref2;
        messageLines = [];
        reachedTrace = false;
        ref2 = this._stack.split("\n");
        for (i2 = 0, len2 = ref2.length; i2 < len2; i2++) {
          line = ref2[i2];
          if (line.trim() === "") {
            continue;
          }
          if (reachedTrace) {
            this._trace.push(this._parseTraceItem(line));
          } else {
            if (line.match(/^\s*at\s.+/)) {
              reachedTrace = true;
              this._trace.push(this._parseTraceItem(line));
            } else if (!this._message.split("\n".indexOf(line))) {
              messageLines.push(line);
            }
          }
        }
        message = messageLines.join("\n");
        if (message.substr(0, this._kind.length) === this._kind) {
          message = message.substr(this._kind.length, message.length).replace(/^\:\s+/, "");
        }
        if (message.length) {
          this._message = this._message.length ? [this._message, message].join("\n") : message;
        }
      };
      ParsedError2.prototype._parseTraceItem = function(text) {
        var addr, col, d, dir, file, jsCol, jsLine, line, m, original, packageName, packages, path2, r, remaining, shortenedAddr, shortenedPath, what;
        text = text.trim();
        if (text === "") {
          return;
        }
        if (!text.match(/^at\ /)) {
          return text;
        }
        text = text.replace(/^at /, "");
        if (text === "Error (<anonymous>)" || text === "Error (<anonymous>:null:null)") {
          return;
        }
        original = text;
        what = null;
        addr = null;
        path2 = null;
        dir = null;
        file = null;
        line = null;
        col = null;
        jsLine = null;
        jsCol = null;
        shortenedPath = null;
        shortenedAddr = null;
        packageName = "[current]";
        if (m = text.match(/\(([^\)]+)\)$/)) {
          addr = m[1].trim();
        }
        if (addr != null) {
          what = text.substr(0, text.length - addr.length - 2);
          what = what.trim();
        }
        if (addr == null) {
          addr = text.trim();
        }
        addr = this._fixPath(addr);
        remaining = addr;
        if (m = remaining.match(/\,\ <js>:(\d+):(\d+)$/)) {
          jsLine = m[1];
          jsCol = m[2];
          remaining = remaining.substr(0, remaining.length - m[0].length);
        }
        if (m = remaining.match(/:(\d+):(\d+)$/)) {
          line = m[1];
          col = m[2];
          remaining = remaining.substr(0, remaining.length - m[0].length);
          path2 = remaining;
        }
        if (path2 != null) {
          file = sysPath.basename(path2);
          dir = sysPath.dirname(path2);
          if (dir === ".") {
            dir = "";
          }
          path2 = this._fixPath(path2);
          file = this._fixPath(file);
          dir = this._fixPath(dir);
        }
        if (dir != null) {
          d = dir.replace(/[\\]{1,2}/g, "/");
          if (m = d.match(/node_modules\/([^\/]+)(?!.*node_modules.*)/)) {
            packageName = m[1];
          }
        }
        if (jsLine == null) {
          jsLine = line;
          jsCol = col;
        }
        if (path2 != null) {
          r = this._rectifyPath(path2);
          shortenedPath = r.path;
          shortenedAddr = shortenedPath + addr.substr(path2.length, addr.length);
          packages = r.packages;
        }
        return {
          original,
          what,
          addr,
          path: path2,
          dir,
          file,
          line: parseInt(line),
          col: parseInt(col),
          jsLine: parseInt(jsLine),
          jsCol: parseInt(jsCol),
          packageName,
          shortenedPath,
          shortenedAddr,
          packages: packages || []
        };
      };
      ParsedError2.prototype._getMessage = function() {
        return this._message;
      };
      ParsedError2.prototype._getKind = function() {
        return this._kind;
      };
      ParsedError2.prototype._getWrapper = function() {
        return this._wrapper;
      };
      ParsedError2.prototype._getStack = function() {
        return this._stack;
      };
      ParsedError2.prototype._getArguments = function() {
        return this.error["arguments"];
      };
      ParsedError2.prototype._getType = function() {
        return this.error.type;
      };
      ParsedError2.prototype._getTrace = function() {
        return this._trace;
      };
      ParsedError2.prototype._fixPath = function(path2) {
        return path2.replace(/[\\]{1,2}/g, "/");
      };
      ParsedError2.prototype._rectifyPath = function(path2, nameForCurrentPackage) {
        var m, packages, parts, remaining, rest;
        path2 = String(path2);
        remaining = path2;
        if (!(m = path2.match(/^(.+?)\/node_modules\/(.+)$/))) {
          return {
            path: path2,
            packages: []
          };
        }
        parts = [];
        packages = [];
        if (typeof nameForCurrentPackage === "string") {
          parts.push("[" + nameForCurrentPackage + "]");
          packages.push("[" + nameForCurrentPackage + "]");
        } else {
          parts.push("[" + m[1].match(/([^\/]+)$/)[1] + "]");
          packages.push(m[1].match(/([^\/]+)$/)[1]);
        }
        rest = m[2];
        while (m = rest.match(/([^\/]+)\/node_modules\/(.+)$/)) {
          parts.push("[" + m[1] + "]");
          packages.push(m[1]);
          rest = m[2];
        }
        if (m = rest.match(/([^\/]+)\/(.+)$/)) {
          parts.push("[" + m[1] + "]");
          packages.push(m[1]);
          rest = m[2];
        }
        parts.push(rest);
        return {
          path: parts.join("/"),
          packages
        };
      };
      return ParsedError2;
    }();
    ref = ["message", "kind", "arguments", "type", "stack", "trace", "wrapper"];
    fn = function() {
      var methodName;
      methodName = "_get" + prop[0].toUpperCase() + prop.substr(1, prop.length);
      return Object.defineProperty(ParsedError.prototype, prop, {
        get: function() {
          return this[methodName]();
        }
      });
    };
    for (i = 0, len = ref.length; i < len; i++) {
      prop = ref[i];
      fn();
    }
  }
});

// node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/nodePaths.js
var require_nodePaths = __commonJS({
  "node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/nodePaths.js"(exports, module2) {
    module2.exports = ["_debugger.js", "_http_agent.js", "_http_client.js", "_http_common.js", "_http_incoming.js", "_http_outgoing.js", "_http_server.js", "_linklist.js", "_stream_duplex.js", "_stream_passthrough.js", "_stream_readable.js", "_stream_transform.js", "_stream_writable.js", "_tls_legacy.js", "_tls_wrap.js", "assert.js", "buffer.js", "child_process.js", "cluster.js", "console.js", "constants.js", "crypto.js", "dgram.js", "dns.js", "domain.js", "events.js", "freelist.js", "fs.js", "http.js", "https.js", "module.js", "net.js", "os.js", "path.js", "punycode.js", "querystring.js", "readline.js", "repl.js", "smalloc.js", "stream.js", "string_decoder.js", "sys.js", "timers.js", "tls.js", "tty.js", "url.js", "util.js", "vm.js", "zlib.js", "node.js"];
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/decode.json
var require_decode = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/decode.json"(exports, module2) {
    module2.exports = { "0": 65533, "128": 8364, "130": 8218, "131": 402, "132": 8222, "133": 8230, "134": 8224, "135": 8225, "136": 710, "137": 8240, "138": 352, "139": 8249, "140": 338, "142": 381, "145": 8216, "146": 8217, "147": 8220, "148": 8221, "149": 8226, "150": 8211, "151": 8212, "152": 732, "153": 8482, "154": 353, "155": 8250, "156": 339, "158": 382, "159": 376 };
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/decode_codepoint.js
var require_decode_codepoint = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/decode_codepoint.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var decode_json_1 = __importDefault(require_decode());
    var fromCodePoint = String.fromCodePoint || function(codePoint) {
      var output = "";
      if (codePoint > 65535) {
        codePoint -= 65536;
        output += String.fromCharCode(codePoint >>> 10 & 1023 | 55296);
        codePoint = 56320 | codePoint & 1023;
      }
      output += String.fromCharCode(codePoint);
      return output;
    };
    function decodeCodePoint(codePoint) {
      if (codePoint >= 55296 && codePoint <= 57343 || codePoint > 1114111) {
        return "\uFFFD";
      }
      if (codePoint in decode_json_1.default) {
        codePoint = decode_json_1.default[codePoint];
      }
      return fromCodePoint(codePoint);
    }
    exports.default = decodeCodePoint;
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/entities.json
var require_entities = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/entities.json"(exports, module2) {
    module2.exports = { Aacute: "\xC1", aacute: "\xE1", Abreve: "\u0102", abreve: "\u0103", ac: "\u223E", acd: "\u223F", acE: "\u223E\u0333", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", Acy: "\u0410", acy: "\u0430", AElig: "\xC6", aelig: "\xE6", af: "\u2061", Afr: "\u{1D504}", afr: "\u{1D51E}", Agrave: "\xC0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", Alpha: "\u0391", alpha: "\u03B1", Amacr: "\u0100", amacr: "\u0101", amalg: "\u2A3F", amp: "&", AMP: "&", andand: "\u2A55", And: "\u2A53", and: "\u2227", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angmsd: "\u2221", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", Aogon: "\u0104", aogon: "\u0105", Aopf: "\u{1D538}", aopf: "\u{1D552}", apacir: "\u2A6F", ap: "\u2248", apE: "\u2A70", ape: "\u224A", apid: "\u224B", apos: "'", ApplyFunction: "\u2061", approx: "\u2248", approxeq: "\u224A", Aring: "\xC5", aring: "\xE5", Ascr: "\u{1D49C}", ascr: "\u{1D4B6}", Assign: "\u2254", ast: "*", asymp: "\u2248", asympeq: "\u224D", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", Backslash: "\u2216", Barv: "\u2AE7", barvee: "\u22BD", barwed: "\u2305", Barwed: "\u2306", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", Bcy: "\u0411", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", Because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", Bernoullis: "\u212C", Beta: "\u0392", beta: "\u03B2", beth: "\u2136", between: "\u226C", Bfr: "\u{1D505}", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bNot: "\u2AED", bnot: "\u2310", Bopf: "\u{1D539}", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxbox: "\u29C9", boxdl: "\u2510", boxdL: "\u2555", boxDl: "\u2556", boxDL: "\u2557", boxdr: "\u250C", boxdR: "\u2552", boxDr: "\u2553", boxDR: "\u2554", boxh: "\u2500", boxH: "\u2550", boxhd: "\u252C", boxHd: "\u2564", boxhD: "\u2565", boxHD: "\u2566", boxhu: "\u2534", boxHu: "\u2567", boxhU: "\u2568", boxHU: "\u2569", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxul: "\u2518", boxuL: "\u255B", boxUl: "\u255C", boxUL: "\u255D", boxur: "\u2514", boxuR: "\u2558", boxUr: "\u2559", boxUR: "\u255A", boxv: "\u2502", boxV: "\u2551", boxvh: "\u253C", boxvH: "\u256A", boxVh: "\u256B", boxVH: "\u256C", boxvl: "\u2524", boxvL: "\u2561", boxVl: "\u2562", boxVL: "\u2563", boxvr: "\u251C", boxvR: "\u255E", boxVr: "\u255F", boxVR: "\u2560", bprime: "\u2035", breve: "\u02D8", Breve: "\u02D8", brvbar: "\xA6", bscr: "\u{1D4B7}", Bscr: "\u212C", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsolb: "\u29C5", bsol: "\\", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", Bumpeq: "\u224E", bumpeq: "\u224F", Cacute: "\u0106", cacute: "\u0107", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", cap: "\u2229", Cap: "\u22D2", capcup: "\u2A47", capdot: "\u2A40", CapitalDifferentialD: "\u2145", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", Cayleys: "\u212D", ccaps: "\u2A4D", Ccaron: "\u010C", ccaron: "\u010D", Ccedil: "\xC7", ccedil: "\xE7", Ccirc: "\u0108", ccirc: "\u0109", Cconint: "\u2230", ccups: "\u2A4C", ccupssm: "\u2A50", Cdot: "\u010A", cdot: "\u010B", cedil: "\xB8", Cedilla: "\xB8", cemptyv: "\u29B2", cent: "\xA2", centerdot: "\xB7", CenterDot: "\xB7", cfr: "\u{1D520}", Cfr: "\u212D", CHcy: "\u0427", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", Chi: "\u03A7", chi: "\u03C7", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", CircleDot: "\u2299", circledR: "\xAE", circledS: "\u24C8", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", cir: "\u25CB", cirE: "\u29C3", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", clubs: "\u2663", clubsuit: "\u2663", colon: ":", Colon: "\u2237", Colone: "\u2A74", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", Congruent: "\u2261", conint: "\u222E", Conint: "\u222F", ContourIntegral: "\u222E", copf: "\u{1D554}", Copf: "\u2102", coprod: "\u2210", Coproduct: "\u2210", copy: "\xA9", COPY: "\xA9", copysr: "\u2117", CounterClockwiseContourIntegral: "\u2233", crarr: "\u21B5", cross: "\u2717", Cross: "\u2A2F", Cscr: "\u{1D49E}", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cupbrcap: "\u2A48", cupcap: "\u2A46", CupCap: "\u224D", cup: "\u222A", Cup: "\u22D3", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dagger: "\u2020", Dagger: "\u2021", daleth: "\u2138", darr: "\u2193", Darr: "\u21A1", dArr: "\u21D3", dash: "\u2010", Dashv: "\u2AE4", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", Dcaron: "\u010E", dcaron: "\u010F", Dcy: "\u0414", dcy: "\u0434", ddagger: "\u2021", ddarr: "\u21CA", DD: "\u2145", dd: "\u2146", DDotrahd: "\u2911", ddotseq: "\u2A77", deg: "\xB0", Del: "\u2207", Delta: "\u0394", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", Dfr: "\u{1D507}", dfr: "\u{1D521}", dHar: "\u2965", dharl: "\u21C3", dharr: "\u21C2", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", diam: "\u22C4", diamond: "\u22C4", Diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", DifferentialD: "\u2146", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", DJcy: "\u0402", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", Dopf: "\u{1D53B}", dopf: "\u{1D555}", Dot: "\xA8", dot: "\u02D9", DotDot: "\u20DC", doteq: "\u2250", doteqdot: "\u2251", DotEqual: "\u2250", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrowBar: "\u2913", downarrow: "\u2193", DownArrow: "\u2193", Downarrow: "\u21D3", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVectorBar: "\u2956", DownLeftVector: "\u21BD", DownRightTeeVector: "\u295F", DownRightVectorBar: "\u2957", DownRightVector: "\u21C1", DownTeeArrow: "\u21A7", DownTee: "\u22A4", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", Dscr: "\u{1D49F}", dscr: "\u{1D4B9}", DScy: "\u0405", dscy: "\u0455", dsol: "\u29F6", Dstrok: "\u0110", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", DZcy: "\u040F", dzcy: "\u045F", dzigrarr: "\u27FF", Eacute: "\xC9", eacute: "\xE9", easter: "\u2A6E", Ecaron: "\u011A", ecaron: "\u011B", Ecirc: "\xCA", ecirc: "\xEA", ecir: "\u2256", ecolon: "\u2255", Ecy: "\u042D", ecy: "\u044D", eDDot: "\u2A77", Edot: "\u0116", edot: "\u0117", eDot: "\u2251", ee: "\u2147", efDot: "\u2252", Efr: "\u{1D508}", efr: "\u{1D522}", eg: "\u2A9A", Egrave: "\xC8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", Element: "\u2208", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", Emacr: "\u0112", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", EmptySmallSquare: "\u25FB", emptyv: "\u2205", EmptyVerySmallSquare: "\u25AB", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", ENG: "\u014A", eng: "\u014B", ensp: "\u2002", Eogon: "\u0118", eogon: "\u0119", Eopf: "\u{1D53C}", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", Epsilon: "\u0395", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", Equal: "\u2A75", equals: "=", EqualTilde: "\u2242", equest: "\u225F", Equilibrium: "\u21CC", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erarr: "\u2971", erDot: "\u2253", escr: "\u212F", Escr: "\u2130", esdot: "\u2250", Esim: "\u2A73", esim: "\u2242", Eta: "\u0397", eta: "\u03B7", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", Exists: "\u2203", expectation: "\u2130", exponentiale: "\u2147", ExponentialE: "\u2147", fallingdotseq: "\u2252", Fcy: "\u0424", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", Ffr: "\u{1D509}", ffr: "\u{1D523}", filig: "\uFB01", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", Fopf: "\u{1D53D}", fopf: "\u{1D557}", forall: "\u2200", ForAll: "\u2200", fork: "\u22D4", forkv: "\u2AD9", Fouriertrf: "\u2131", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", Fscr: "\u2131", gacute: "\u01F5", Gamma: "\u0393", gamma: "\u03B3", Gammad: "\u03DC", gammad: "\u03DD", gap: "\u2A86", Gbreve: "\u011E", gbreve: "\u011F", Gcedil: "\u0122", Gcirc: "\u011C", gcirc: "\u011D", Gcy: "\u0413", gcy: "\u0433", Gdot: "\u0120", gdot: "\u0121", ge: "\u2265", gE: "\u2267", gEl: "\u2A8C", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", gescc: "\u2AA9", ges: "\u2A7E", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", Gfr: "\u{1D50A}", gfr: "\u{1D524}", gg: "\u226B", Gg: "\u22D9", ggg: "\u22D9", gimel: "\u2137", GJcy: "\u0403", gjcy: "\u0453", gla: "\u2AA5", gl: "\u2277", glE: "\u2A92", glj: "\u2AA4", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gnE: "\u2269", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", Gopf: "\u{1D53E}", gopf: "\u{1D558}", grave: "`", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", gtcc: "\u2AA7", gtcir: "\u2A7A", gt: ">", GT: ">", Gt: "\u226B", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", Hacek: "\u02C7", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", HARDcy: "\u042A", hardcy: "\u044A", harrcir: "\u2948", harr: "\u2194", hArr: "\u21D4", harrw: "\u21AD", Hat: "^", hbar: "\u210F", Hcirc: "\u0124", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", Hfr: "\u210C", HilbertSpace: "\u210B", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", Hopf: "\u210D", horbar: "\u2015", HorizontalLine: "\u2500", hscr: "\u{1D4BD}", Hscr: "\u210B", hslash: "\u210F", Hstrok: "\u0126", hstrok: "\u0127", HumpDownHump: "\u224E", HumpEqual: "\u224F", hybull: "\u2043", hyphen: "\u2010", Iacute: "\xCD", iacute: "\xED", ic: "\u2063", Icirc: "\xCE", icirc: "\xEE", Icy: "\u0418", icy: "\u0438", Idot: "\u0130", IEcy: "\u0415", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", Ifr: "\u2111", Igrave: "\xCC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", IJlig: "\u0132", ijlig: "\u0133", Imacr: "\u012A", imacr: "\u012B", image: "\u2111", ImaginaryI: "\u2148", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", Im: "\u2111", imof: "\u22B7", imped: "\u01B5", Implies: "\u21D2", incare: "\u2105", in: "\u2208", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", intcal: "\u22BA", int: "\u222B", Int: "\u222C", integers: "\u2124", Integral: "\u222B", intercal: "\u22BA", Intersection: "\u22C2", intlarhk: "\u2A17", intprod: "\u2A3C", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", IOcy: "\u0401", iocy: "\u0451", Iogon: "\u012E", iogon: "\u012F", Iopf: "\u{1D540}", iopf: "\u{1D55A}", Iota: "\u0399", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", iscr: "\u{1D4BE}", Iscr: "\u2110", isin: "\u2208", isindot: "\u22F5", isinE: "\u22F9", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", Itilde: "\u0128", itilde: "\u0129", Iukcy: "\u0406", iukcy: "\u0456", Iuml: "\xCF", iuml: "\xEF", Jcirc: "\u0134", jcirc: "\u0135", Jcy: "\u0419", jcy: "\u0439", Jfr: "\u{1D50D}", jfr: "\u{1D527}", jmath: "\u0237", Jopf: "\u{1D541}", jopf: "\u{1D55B}", Jscr: "\u{1D4A5}", jscr: "\u{1D4BF}", Jsercy: "\u0408", jsercy: "\u0458", Jukcy: "\u0404", jukcy: "\u0454", Kappa: "\u039A", kappa: "\u03BA", kappav: "\u03F0", Kcedil: "\u0136", kcedil: "\u0137", Kcy: "\u041A", kcy: "\u043A", Kfr: "\u{1D50E}", kfr: "\u{1D528}", kgreen: "\u0138", KHcy: "\u0425", khcy: "\u0445", KJcy: "\u040C", kjcy: "\u045C", Kopf: "\u{1D542}", kopf: "\u{1D55C}", Kscr: "\u{1D4A6}", kscr: "\u{1D4C0}", lAarr: "\u21DA", Lacute: "\u0139", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", Lambda: "\u039B", lambda: "\u03BB", lang: "\u27E8", Lang: "\u27EA", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", Laplacetrf: "\u2112", laquo: "\xAB", larrb: "\u21E4", larrbfs: "\u291F", larr: "\u2190", Larr: "\u219E", lArr: "\u21D0", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", latail: "\u2919", lAtail: "\u291B", lat: "\u2AAB", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lBarr: "\u290E", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", Lcaron: "\u013D", lcaron: "\u013E", Lcedil: "\u013B", lcedil: "\u013C", lceil: "\u2308", lcub: "{", Lcy: "\u041B", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", lE: "\u2266", LeftAngleBracket: "\u27E8", LeftArrowBar: "\u21E4", leftarrow: "\u2190", LeftArrow: "\u2190", Leftarrow: "\u21D0", LeftArrowRightArrow: "\u21C6", leftarrowtail: "\u21A2", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVectorBar: "\u2959", LeftDownVector: "\u21C3", LeftFloor: "\u230A", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", LeftRightArrow: "\u2194", Leftrightarrow: "\u21D4", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", LeftRightVector: "\u294E", LeftTeeArrow: "\u21A4", LeftTee: "\u22A3", LeftTeeVector: "\u295A", leftthreetimes: "\u22CB", LeftTriangleBar: "\u29CF", LeftTriangle: "\u22B2", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVectorBar: "\u2958", LeftUpVector: "\u21BF", LeftVectorBar: "\u2952", LeftVector: "\u21BC", lEg: "\u2A8B", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", lescc: "\u2AA8", les: "\u2A7D", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", lessgtr: "\u2276", LessLess: "\u2AA1", lesssim: "\u2272", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", lfisht: "\u297C", lfloor: "\u230A", Lfr: "\u{1D50F}", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lHar: "\u2962", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", LJcy: "\u0409", ljcy: "\u0459", llarr: "\u21C7", ll: "\u226A", Ll: "\u22D8", llcorner: "\u231E", Lleftarrow: "\u21DA", llhard: "\u296B", lltri: "\u25FA", Lmidot: "\u013F", lmidot: "\u0140", lmoustache: "\u23B0", lmoust: "\u23B0", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lnE: "\u2268", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", LongLeftArrow: "\u27F5", Longleftarrow: "\u27F8", longleftrightarrow: "\u27F7", LongLeftRightArrow: "\u27F7", Longleftrightarrow: "\u27FA", longmapsto: "\u27FC", longrightarrow: "\u27F6", LongRightArrow: "\u27F6", Longrightarrow: "\u27F9", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", Lopf: "\u{1D543}", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", Lscr: "\u2112", lsh: "\u21B0", Lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", Lstrok: "\u0141", lstrok: "\u0142", ltcc: "\u2AA6", ltcir: "\u2A79", lt: "<", LT: "<", Lt: "\u226A", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", ltrPar: "\u2996", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", Map: "\u2905", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", Mcy: "\u041C", mcy: "\u043C", mdash: "\u2014", mDDot: "\u223A", measuredangle: "\u2221", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", midast: "*", midcir: "\u2AF0", mid: "\u2223", middot: "\xB7", minusb: "\u229F", minus: "\u2212", minusd: "\u2238", minusdu: "\u2A2A", MinusPlus: "\u2213", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", Mopf: "\u{1D544}", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", Mscr: "\u2133", mstpos: "\u223E", Mu: "\u039C", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nabla: "\u2207", Nacute: "\u0143", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natural: "\u266E", naturals: "\u2115", natur: "\u266E", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", Ncaron: "\u0147", ncaron: "\u0148", Ncedil: "\u0145", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", Ncy: "\u041D", ncy: "\u043D", ndash: "\u2013", nearhk: "\u2924", nearr: "\u2197", neArr: "\u21D7", nearrow: "\u2197", ne: "\u2260", nedot: "\u2250\u0338", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: "\n", nexist: "\u2204", nexists: "\u2204", Nfr: "\u{1D511}", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", nGg: "\u22D9\u0338", ngsim: "\u2275", nGt: "\u226B\u20D2", ngt: "\u226F", ngtr: "\u226F", nGtv: "\u226B\u0338", nharr: "\u21AE", nhArr: "\u21CE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", NJcy: "\u040A", njcy: "\u045A", nlarr: "\u219A", nlArr: "\u21CD", nldr: "\u2025", nlE: "\u2266\u0338", nle: "\u2270", nleftarrow: "\u219A", nLeftarrow: "\u21CD", nleftrightarrow: "\u21AE", nLeftrightarrow: "\u21CE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nLl: "\u22D8\u0338", nlsim: "\u2274", nLt: "\u226A\u20D2", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nLtv: "\u226A\u0338", nmid: "\u2224", NoBreak: "\u2060", NonBreakingSpace: "\xA0", nopf: "\u{1D55F}", Nopf: "\u2115", Not: "\u2AEC", not: "\xAC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", notin: "\u2209", notindot: "\u22F5\u0338", notinE: "\u22F9\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangle: "\u22EB", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", nparallel: "\u2226", npar: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", nprec: "\u2280", npreceq: "\u2AAF\u0338", npre: "\u2AAF\u0338", nrarrc: "\u2933\u0338", nrarr: "\u219B", nrArr: "\u21CF", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nRightarrow: "\u21CF", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", Nscr: "\u{1D4A9}", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", Ntilde: "\xD1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", Nu: "\u039D", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvDash: "\u22AD", nVdash: "\u22AE", nVDash: "\u22AF", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvHarr: "\u2904", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwarhk: "\u2923", nwarr: "\u2196", nwArr: "\u21D6", nwarrow: "\u2196", nwnear: "\u2927", Oacute: "\xD3", oacute: "\xF3", oast: "\u229B", Ocirc: "\xD4", ocirc: "\xF4", ocir: "\u229A", Ocy: "\u041E", ocy: "\u043E", odash: "\u229D", Odblac: "\u0150", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", OElig: "\u0152", oelig: "\u0153", ofcir: "\u29BF", Ofr: "\u{1D512}", ofr: "\u{1D52C}", ogon: "\u02DB", Ograve: "\xD2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", Omacr: "\u014C", omacr: "\u014D", Omega: "\u03A9", omega: "\u03C9", Omicron: "\u039F", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", Oopf: "\u{1D546}", oopf: "\u{1D560}", opar: "\u29B7", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", operp: "\u29B9", oplus: "\u2295", orarr: "\u21BB", Or: "\u2A54", or: "\u2228", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oS: "\u24C8", Oscr: "\u{1D4AA}", oscr: "\u2134", Oslash: "\xD8", oslash: "\xF8", osol: "\u2298", Otilde: "\xD5", otilde: "\xF5", otimesas: "\u2A36", Otimes: "\u2A37", otimes: "\u2297", Ouml: "\xD6", ouml: "\xF6", ovbar: "\u233D", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", para: "\xB6", parallel: "\u2225", par: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", PartialD: "\u2202", Pcy: "\u041F", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", Pfr: "\u{1D513}", pfr: "\u{1D52D}", Phi: "\u03A6", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", Pi: "\u03A0", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plus: "+", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", PlusMinus: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", Poincareplane: "\u210C", pointint: "\u2A15", popf: "\u{1D561}", Popf: "\u2119", pound: "\xA3", prap: "\u2AB7", Pr: "\u2ABB", pr: "\u227A", prcue: "\u227C", precapprox: "\u2AB7", prec: "\u227A", preccurlyeq: "\u227C", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", pre: "\u2AAF", prE: "\u2AB3", precsim: "\u227E", prime: "\u2032", Prime: "\u2033", primes: "\u2119", prnap: "\u2AB9", prnE: "\u2AB5", prnsim: "\u22E8", prod: "\u220F", Product: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", Proportional: "\u221D", Proportion: "\u2237", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", Pscr: "\u{1D4AB}", pscr: "\u{1D4C5}", Psi: "\u03A8", psi: "\u03C8", puncsp: "\u2008", Qfr: "\u{1D514}", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", Qopf: "\u211A", qprime: "\u2057", Qscr: "\u{1D4AC}", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quot: '"', QUOT: '"', rAarr: "\u21DB", race: "\u223D\u0331", Racute: "\u0154", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", Rang: "\u27EB", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarr: "\u2192", Rarr: "\u21A0", rArr: "\u21D2", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", Rarrtl: "\u2916", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", rAtail: "\u291C", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rBarr: "\u290F", RBarr: "\u2910", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", Rcaron: "\u0158", rcaron: "\u0159", Rcedil: "\u0156", rcedil: "\u0157", rceil: "\u2309", rcub: "}", Rcy: "\u0420", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", Re: "\u211C", rect: "\u25AD", reg: "\xAE", REG: "\xAE", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", Rfr: "\u211C", rHar: "\u2964", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", Rho: "\u03A1", rho: "\u03C1", rhov: "\u03F1", RightAngleBracket: "\u27E9", RightArrowBar: "\u21E5", rightarrow: "\u2192", RightArrow: "\u2192", Rightarrow: "\u21D2", RightArrowLeftArrow: "\u21C4", rightarrowtail: "\u21A3", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVectorBar: "\u2955", RightDownVector: "\u21C2", RightFloor: "\u230B", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", RightTeeArrow: "\u21A6", RightTee: "\u22A2", RightTeeVector: "\u295B", rightthreetimes: "\u22CC", RightTriangleBar: "\u29D0", RightTriangle: "\u22B3", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVectorBar: "\u2954", RightUpVector: "\u21BE", RightVectorBar: "\u2953", RightVector: "\u21C0", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoustache: "\u23B1", rmoust: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", Ropf: "\u211D", roplus: "\u2A2E", rotimes: "\u2A35", RoundImplies: "\u2970", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", Rrightarrow: "\u21DB", rsaquo: "\u203A", rscr: "\u{1D4C7}", Rscr: "\u211B", rsh: "\u21B1", Rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", RuleDelayed: "\u29F4", ruluhar: "\u2968", rx: "\u211E", Sacute: "\u015A", sacute: "\u015B", sbquo: "\u201A", scap: "\u2AB8", Scaron: "\u0160", scaron: "\u0161", Sc: "\u2ABC", sc: "\u227B", sccue: "\u227D", sce: "\u2AB0", scE: "\u2AB4", Scedil: "\u015E", scedil: "\u015F", Scirc: "\u015C", scirc: "\u015D", scnap: "\u2ABA", scnE: "\u2AB6", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", Scy: "\u0421", scy: "\u0441", sdotb: "\u22A1", sdot: "\u22C5", sdote: "\u2A66", searhk: "\u2925", searr: "\u2198", seArr: "\u21D8", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", Sfr: "\u{1D516}", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", SHCHcy: "\u0429", shchcy: "\u0449", SHcy: "\u0428", shcy: "\u0448", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", shortmid: "\u2223", shortparallel: "\u2225", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", shy: "\xAD", Sigma: "\u03A3", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", SmallCircle: "\u2218", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", SOFTcy: "\u042C", softcy: "\u044C", solbar: "\u233F", solb: "\u29C4", sol: "/", Sopf: "\u{1D54A}", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", Sqrt: "\u221A", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", square: "\u25A1", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", squarf: "\u25AA", squ: "\u25A1", squf: "\u25AA", srarr: "\u2192", Sscr: "\u{1D4AE}", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", Star: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", Sub: "\u22D0", subdot: "\u2ABD", subE: "\u2AC5", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", Subset: "\u22D0", subseteq: "\u2286", subseteqq: "\u2AC5", SubsetEqual: "\u2286", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succapprox: "\u2AB8", succ: "\u227B", succcurlyeq: "\u227D", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", SuchThat: "\u220B", sum: "\u2211", Sum: "\u2211", sung: "\u266A", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", sup: "\u2283", Sup: "\u22D1", supdot: "\u2ABE", supdsub: "\u2AD8", supE: "\u2AC6", supe: "\u2287", supedot: "\u2AC4", Superset: "\u2283", SupersetEqual: "\u2287", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", Supset: "\u22D1", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swarhk: "\u2926", swarr: "\u2199", swArr: "\u21D9", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", Tab: "	", target: "\u2316", Tau: "\u03A4", tau: "\u03C4", tbrk: "\u23B4", Tcaron: "\u0164", tcaron: "\u0165", Tcedil: "\u0162", tcedil: "\u0163", Tcy: "\u0422", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", Tfr: "\u{1D517}", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", Therefore: "\u2234", Theta: "\u0398", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", THORN: "\xDE", thorn: "\xFE", tilde: "\u02DC", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", timesbar: "\u2A31", timesb: "\u22A0", times: "\xD7", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", topbot: "\u2336", topcir: "\u2AF1", top: "\u22A4", Topf: "\u{1D54B}", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", TRADE: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", TripleDot: "\u20DB", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", Tscr: "\u{1D4AF}", tscr: "\u{1D4C9}", TScy: "\u0426", tscy: "\u0446", TSHcy: "\u040B", tshcy: "\u045B", Tstrok: "\u0166", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", Uacute: "\xDA", uacute: "\xFA", uarr: "\u2191", Uarr: "\u219F", uArr: "\u21D1", Uarrocir: "\u2949", Ubrcy: "\u040E", ubrcy: "\u045E", Ubreve: "\u016C", ubreve: "\u016D", Ucirc: "\xDB", ucirc: "\xFB", Ucy: "\u0423", ucy: "\u0443", udarr: "\u21C5", Udblac: "\u0170", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", Ufr: "\u{1D518}", ufr: "\u{1D532}", Ugrave: "\xD9", ugrave: "\xF9", uHar: "\u2963", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", Umacr: "\u016A", umacr: "\u016B", uml: "\xA8", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", uogon: "\u0173", Uopf: "\u{1D54C}", uopf: "\u{1D566}", UpArrowBar: "\u2912", uparrow: "\u2191", UpArrow: "\u2191", Uparrow: "\u21D1", UpArrowDownArrow: "\u21C5", updownarrow: "\u2195", UpDownArrow: "\u2195", Updownarrow: "\u21D5", UpEquilibrium: "\u296E", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", upsi: "\u03C5", Upsi: "\u03D2", upsih: "\u03D2", Upsilon: "\u03A5", upsilon: "\u03C5", UpTeeArrow: "\u21A5", UpTee: "\u22A5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", Uring: "\u016E", uring: "\u016F", urtri: "\u25F9", Uscr: "\u{1D4B0}", uscr: "\u{1D4CA}", utdot: "\u22F0", Utilde: "\u0168", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", Uuml: "\xDC", uuml: "\xFC", uwangle: "\u29A7", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", vArr: "\u21D5", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vBar: "\u2AE8", Vbar: "\u2AEB", vBarv: "\u2AE9", Vcy: "\u0412", vcy: "\u0432", vdash: "\u22A2", vDash: "\u22A8", Vdash: "\u22A9", VDash: "\u22AB", Vdashl: "\u2AE6", veebar: "\u22BB", vee: "\u2228", Vee: "\u22C1", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", Verbar: "\u2016", vert: "|", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", Vopf: "\u{1D54D}", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", Vscr: "\u{1D4B1}", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", Vvdash: "\u22AA", vzigzag: "\u299A", Wcirc: "\u0174", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", Wedge: "\u22C0", wedgeq: "\u2259", weierp: "\u2118", Wfr: "\u{1D51A}", wfr: "\u{1D534}", Wopf: "\u{1D54E}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", Wscr: "\u{1D4B2}", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", Xfr: "\u{1D51B}", xfr: "\u{1D535}", xharr: "\u27F7", xhArr: "\u27FA", Xi: "\u039E", xi: "\u03BE", xlarr: "\u27F5", xlArr: "\u27F8", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", Xopf: "\u{1D54F}", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrarr: "\u27F6", xrArr: "\u27F9", Xscr: "\u{1D4B3}", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", Yacute: "\xDD", yacute: "\xFD", YAcy: "\u042F", yacy: "\u044F", Ycirc: "\u0176", ycirc: "\u0177", Ycy: "\u042B", ycy: "\u044B", yen: "\xA5", Yfr: "\u{1D51C}", yfr: "\u{1D536}", YIcy: "\u0407", yicy: "\u0457", Yopf: "\u{1D550}", yopf: "\u{1D56A}", Yscr: "\u{1D4B4}", yscr: "\u{1D4CE}", YUcy: "\u042E", yucy: "\u044E", yuml: "\xFF", Yuml: "\u0178", Zacute: "\u0179", zacute: "\u017A", Zcaron: "\u017D", zcaron: "\u017E", Zcy: "\u0417", zcy: "\u0437", Zdot: "\u017B", zdot: "\u017C", zeetrf: "\u2128", ZeroWidthSpace: "\u200B", Zeta: "\u0396", zeta: "\u03B6", zfr: "\u{1D537}", Zfr: "\u2128", ZHcy: "\u0416", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", Zopf: "\u2124", Zscr: "\u{1D4B5}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" };
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/legacy.json
var require_legacy = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/legacy.json"(exports, module2) {
    module2.exports = { Aacute: "\xC1", aacute: "\xE1", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", AElig: "\xC6", aelig: "\xE6", Agrave: "\xC0", agrave: "\xE0", amp: "&", AMP: "&", Aring: "\xC5", aring: "\xE5", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", brvbar: "\xA6", Ccedil: "\xC7", ccedil: "\xE7", cedil: "\xB8", cent: "\xA2", copy: "\xA9", COPY: "\xA9", curren: "\xA4", deg: "\xB0", divide: "\xF7", Eacute: "\xC9", eacute: "\xE9", Ecirc: "\xCA", ecirc: "\xEA", Egrave: "\xC8", egrave: "\xE8", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", frac12: "\xBD", frac14: "\xBC", frac34: "\xBE", gt: ">", GT: ">", Iacute: "\xCD", iacute: "\xED", Icirc: "\xCE", icirc: "\xEE", iexcl: "\xA1", Igrave: "\xCC", igrave: "\xEC", iquest: "\xBF", Iuml: "\xCF", iuml: "\xEF", laquo: "\xAB", lt: "<", LT: "<", macr: "\xAF", micro: "\xB5", middot: "\xB7", nbsp: "\xA0", not: "\xAC", Ntilde: "\xD1", ntilde: "\xF1", Oacute: "\xD3", oacute: "\xF3", Ocirc: "\xD4", ocirc: "\xF4", Ograve: "\xD2", ograve: "\xF2", ordf: "\xAA", ordm: "\xBA", Oslash: "\xD8", oslash: "\xF8", Otilde: "\xD5", otilde: "\xF5", Ouml: "\xD6", ouml: "\xF6", para: "\xB6", plusmn: "\xB1", pound: "\xA3", quot: '"', QUOT: '"', raquo: "\xBB", reg: "\xAE", REG: "\xAE", sect: "\xA7", shy: "\xAD", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", szlig: "\xDF", THORN: "\xDE", thorn: "\xFE", times: "\xD7", Uacute: "\xDA", uacute: "\xFA", Ucirc: "\xDB", ucirc: "\xFB", Ugrave: "\xD9", ugrave: "\xF9", uml: "\xA8", Uuml: "\xDC", uuml: "\xFC", Yacute: "\xDD", yacute: "\xFD", yen: "\xA5", yuml: "\xFF" };
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/xml.json
var require_xml = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/maps/xml.json"(exports, module2) {
    module2.exports = { amp: "&", apos: "'", gt: ">", lt: "<", quot: '"' };
  }
});

// node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/Tokenizer.js
var require_Tokenizer = __commonJS({
  "node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/Tokenizer.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var decode_codepoint_1 = __importDefault(require_decode_codepoint());
    var entities_json_1 = __importDefault(require_entities());
    var legacy_json_1 = __importDefault(require_legacy());
    var xml_json_1 = __importDefault(require_xml());
    function whitespace(c) {
      return c === " " || c === "\n" || c === "	" || c === "\f" || c === "\r";
    }
    function isASCIIAlpha(c) {
      return c >= "a" && c <= "z" || c >= "A" && c <= "Z";
    }
    function ifElseState(upper, SUCCESS, FAILURE) {
      var lower = upper.toLowerCase();
      if (upper === lower) {
        return function(t, c) {
          if (c === lower) {
            t._state = SUCCESS;
          } else {
            t._state = FAILURE;
            t._index--;
          }
        };
      }
      return function(t, c) {
        if (c === lower || c === upper) {
          t._state = SUCCESS;
        } else {
          t._state = FAILURE;
          t._index--;
        }
      };
    }
    function consumeSpecialNameChar(upper, NEXT_STATE) {
      var lower = upper.toLowerCase();
      return function(t, c) {
        if (c === lower || c === upper) {
          t._state = NEXT_STATE;
        } else {
          t._state = 3;
          t._index--;
        }
      };
    }
    var stateBeforeCdata1 = ifElseState("C", 24, 16);
    var stateBeforeCdata2 = ifElseState("D", 25, 16);
    var stateBeforeCdata3 = ifElseState("A", 26, 16);
    var stateBeforeCdata4 = ifElseState("T", 27, 16);
    var stateBeforeCdata5 = ifElseState("A", 28, 16);
    var stateBeforeScript1 = consumeSpecialNameChar("R", 35);
    var stateBeforeScript2 = consumeSpecialNameChar("I", 36);
    var stateBeforeScript3 = consumeSpecialNameChar("P", 37);
    var stateBeforeScript4 = consumeSpecialNameChar("T", 38);
    var stateAfterScript1 = ifElseState("R", 40, 1);
    var stateAfterScript2 = ifElseState("I", 41, 1);
    var stateAfterScript3 = ifElseState("P", 42, 1);
    var stateAfterScript4 = ifElseState("T", 43, 1);
    var stateBeforeStyle1 = consumeSpecialNameChar("Y", 45);
    var stateBeforeStyle2 = consumeSpecialNameChar("L", 46);
    var stateBeforeStyle3 = consumeSpecialNameChar("E", 47);
    var stateAfterStyle1 = ifElseState("Y", 49, 1);
    var stateAfterStyle2 = ifElseState("L", 50, 1);
    var stateAfterStyle3 = ifElseState("E", 51, 1);
    var stateBeforeSpecialT = consumeSpecialNameChar("I", 54);
    var stateBeforeTitle1 = consumeSpecialNameChar("T", 55);
    var stateBeforeTitle2 = consumeSpecialNameChar("L", 56);
    var stateBeforeTitle3 = consumeSpecialNameChar("E", 57);
    var stateAfterSpecialTEnd = ifElseState("I", 58, 1);
    var stateAfterTitle1 = ifElseState("T", 59, 1);
    var stateAfterTitle2 = ifElseState("L", 60, 1);
    var stateAfterTitle3 = ifElseState("E", 61, 1);
    var stateBeforeEntity = ifElseState("#", 63, 64);
    var stateBeforeNumericEntity = ifElseState("X", 66, 65);
    var Tokenizer = function() {
      function Tokenizer2(options, cbs) {
        var _a;
        this._state = 1;
        this.buffer = "";
        this.sectionStart = 0;
        this._index = 0;
        this.bufferOffset = 0;
        this.baseState = 1;
        this.special = 1;
        this.running = true;
        this.ended = false;
        this.cbs = cbs;
        this.xmlMode = !!(options === null || options === void 0 ? void 0 : options.xmlMode);
        this.decodeEntities = (_a = options === null || options === void 0 ? void 0 : options.decodeEntities) !== null && _a !== void 0 ? _a : true;
      }
      Tokenizer2.prototype.reset = function() {
        this._state = 1;
        this.buffer = "";
        this.sectionStart = 0;
        this._index = 0;
        this.bufferOffset = 0;
        this.baseState = 1;
        this.special = 1;
        this.running = true;
        this.ended = false;
      };
      Tokenizer2.prototype.write = function(chunk) {
        if (this.ended)
          this.cbs.onerror(Error(".write() after done!"));
        this.buffer += chunk;
        this.parse();
      };
      Tokenizer2.prototype.end = function(chunk) {
        if (this.ended)
          this.cbs.onerror(Error(".end() after done!"));
        if (chunk)
          this.write(chunk);
        this.ended = true;
        if (this.running)
          this.finish();
      };
      Tokenizer2.prototype.pause = function() {
        this.running = false;
      };
      Tokenizer2.prototype.resume = function() {
        this.running = true;
        if (this._index < this.buffer.length) {
          this.parse();
        }
        if (this.ended) {
          this.finish();
        }
      };
      Tokenizer2.prototype.getAbsoluteIndex = function() {
        return this.bufferOffset + this._index;
      };
      Tokenizer2.prototype.stateText = function(c) {
        if (c === "<") {
          if (this._index > this.sectionStart) {
            this.cbs.ontext(this.getSection());
          }
          this._state = 2;
          this.sectionStart = this._index;
        } else if (this.decodeEntities && c === "&" && (this.special === 1 || this.special === 4)) {
          if (this._index > this.sectionStart) {
            this.cbs.ontext(this.getSection());
          }
          this.baseState = 1;
          this._state = 62;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.isTagStartChar = function(c) {
        return isASCIIAlpha(c) || this.xmlMode && !whitespace(c) && c !== "/" && c !== ">";
      };
      Tokenizer2.prototype.stateBeforeTagName = function(c) {
        if (c === "/") {
          this._state = 5;
        } else if (c === "<") {
          this.cbs.ontext(this.getSection());
          this.sectionStart = this._index;
        } else if (c === ">" || this.special !== 1 || whitespace(c)) {
          this._state = 1;
        } else if (c === "!") {
          this._state = 15;
          this.sectionStart = this._index + 1;
        } else if (c === "?") {
          this._state = 17;
          this.sectionStart = this._index + 1;
        } else if (!this.isTagStartChar(c)) {
          this._state = 1;
        } else {
          this._state = !this.xmlMode && (c === "s" || c === "S") ? 32 : !this.xmlMode && (c === "t" || c === "T") ? 52 : 3;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInTagName = function(c) {
        if (c === "/" || c === ">" || whitespace(c)) {
          this.emitToken("onopentagname");
          this._state = 8;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateBeforeClosingTagName = function(c) {
        if (whitespace(c)) {
        } else if (c === ">") {
          this._state = 1;
        } else if (this.special !== 1) {
          if (this.special !== 4 && (c === "s" || c === "S")) {
            this._state = 33;
          } else if (this.special === 4 && (c === "t" || c === "T")) {
            this._state = 53;
          } else {
            this._state = 1;
            this._index--;
          }
        } else if (!this.isTagStartChar(c)) {
          this._state = 20;
          this.sectionStart = this._index;
        } else {
          this._state = 6;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInClosingTagName = function(c) {
        if (c === ">" || whitespace(c)) {
          this.emitToken("onclosetag");
          this._state = 7;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateAfterClosingTagName = function(c) {
        if (c === ">") {
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateBeforeAttributeName = function(c) {
        if (c === ">") {
          this.cbs.onopentagend();
          this._state = 1;
          this.sectionStart = this._index + 1;
        } else if (c === "/") {
          this._state = 4;
        } else if (!whitespace(c)) {
          this._state = 9;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInSelfClosingTag = function(c) {
        if (c === ">") {
          this.cbs.onselfclosingtag();
          this._state = 1;
          this.sectionStart = this._index + 1;
          this.special = 1;
        } else if (!whitespace(c)) {
          this._state = 8;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateInAttributeName = function(c) {
        if (c === "=" || c === "/" || c === ">" || whitespace(c)) {
          this.cbs.onattribname(this.getSection());
          this.sectionStart = -1;
          this._state = 10;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateAfterAttributeName = function(c) {
        if (c === "=") {
          this._state = 11;
        } else if (c === "/" || c === ">") {
          this.cbs.onattribend(void 0);
          this._state = 8;
          this._index--;
        } else if (!whitespace(c)) {
          this.cbs.onattribend(void 0);
          this._state = 9;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateBeforeAttributeValue = function(c) {
        if (c === '"') {
          this._state = 12;
          this.sectionStart = this._index + 1;
        } else if (c === "'") {
          this._state = 13;
          this.sectionStart = this._index + 1;
        } else if (!whitespace(c)) {
          this._state = 14;
          this.sectionStart = this._index;
          this._index--;
        }
      };
      Tokenizer2.prototype.handleInAttributeValue = function(c, quote) {
        if (c === quote) {
          this.emitToken("onattribdata");
          this.cbs.onattribend(quote);
          this._state = 8;
        } else if (this.decodeEntities && c === "&") {
          this.emitToken("onattribdata");
          this.baseState = this._state;
          this._state = 62;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInAttributeValueDoubleQuotes = function(c) {
        this.handleInAttributeValue(c, '"');
      };
      Tokenizer2.prototype.stateInAttributeValueSingleQuotes = function(c) {
        this.handleInAttributeValue(c, "'");
      };
      Tokenizer2.prototype.stateInAttributeValueNoQuotes = function(c) {
        if (whitespace(c) || c === ">") {
          this.emitToken("onattribdata");
          this.cbs.onattribend(null);
          this._state = 8;
          this._index--;
        } else if (this.decodeEntities && c === "&") {
          this.emitToken("onattribdata");
          this.baseState = this._state;
          this._state = 62;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateBeforeDeclaration = function(c) {
        this._state = c === "[" ? 23 : c === "-" ? 18 : 16;
      };
      Tokenizer2.prototype.stateInDeclaration = function(c) {
        if (c === ">") {
          this.cbs.ondeclaration(this.getSection());
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateInProcessingInstruction = function(c) {
        if (c === ">") {
          this.cbs.onprocessinginstruction(this.getSection());
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateBeforeComment = function(c) {
        if (c === "-") {
          this._state = 19;
          this.sectionStart = this._index + 1;
        } else {
          this._state = 16;
        }
      };
      Tokenizer2.prototype.stateInComment = function(c) {
        if (c === "-")
          this._state = 21;
      };
      Tokenizer2.prototype.stateInSpecialComment = function(c) {
        if (c === ">") {
          this.cbs.oncomment(this.buffer.substring(this.sectionStart, this._index));
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateAfterComment1 = function(c) {
        if (c === "-") {
          this._state = 22;
        } else {
          this._state = 19;
        }
      };
      Tokenizer2.prototype.stateAfterComment2 = function(c) {
        if (c === ">") {
          this.cbs.oncomment(this.buffer.substring(this.sectionStart, this._index - 2));
          this._state = 1;
          this.sectionStart = this._index + 1;
        } else if (c !== "-") {
          this._state = 19;
        }
      };
      Tokenizer2.prototype.stateBeforeCdata6 = function(c) {
        if (c === "[") {
          this._state = 29;
          this.sectionStart = this._index + 1;
        } else {
          this._state = 16;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateInCdata = function(c) {
        if (c === "]")
          this._state = 30;
      };
      Tokenizer2.prototype.stateAfterCdata1 = function(c) {
        if (c === "]")
          this._state = 31;
        else
          this._state = 29;
      };
      Tokenizer2.prototype.stateAfterCdata2 = function(c) {
        if (c === ">") {
          this.cbs.oncdata(this.buffer.substring(this.sectionStart, this._index - 2));
          this._state = 1;
          this.sectionStart = this._index + 1;
        } else if (c !== "]") {
          this._state = 29;
        }
      };
      Tokenizer2.prototype.stateBeforeSpecialS = function(c) {
        if (c === "c" || c === "C") {
          this._state = 34;
        } else if (c === "t" || c === "T") {
          this._state = 44;
        } else {
          this._state = 3;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateBeforeSpecialSEnd = function(c) {
        if (this.special === 2 && (c === "c" || c === "C")) {
          this._state = 39;
        } else if (this.special === 3 && (c === "t" || c === "T")) {
          this._state = 48;
        } else
          this._state = 1;
      };
      Tokenizer2.prototype.stateBeforeSpecialLast = function(c, special) {
        if (c === "/" || c === ">" || whitespace(c)) {
          this.special = special;
        }
        this._state = 3;
        this._index--;
      };
      Tokenizer2.prototype.stateAfterSpecialLast = function(c, sectionStartOffset) {
        if (c === ">" || whitespace(c)) {
          this.special = 1;
          this._state = 6;
          this.sectionStart = this._index - sectionStartOffset;
          this._index--;
        } else
          this._state = 1;
      };
      Tokenizer2.prototype.parseFixedEntity = function(map2) {
        if (map2 === void 0) {
          map2 = this.xmlMode ? xml_json_1.default : entities_json_1.default;
        }
        if (this.sectionStart + 1 < this._index) {
          var entity = this.buffer.substring(this.sectionStart + 1, this._index);
          if (Object.prototype.hasOwnProperty.call(map2, entity)) {
            this.emitPartial(map2[entity]);
            this.sectionStart = this._index + 1;
          }
        }
      };
      Tokenizer2.prototype.parseLegacyEntity = function() {
        var start = this.sectionStart + 1;
        var limit = Math.min(this._index - start, 6);
        while (limit >= 2) {
          var entity = this.buffer.substr(start, limit);
          if (Object.prototype.hasOwnProperty.call(legacy_json_1.default, entity)) {
            this.emitPartial(legacy_json_1.default[entity]);
            this.sectionStart += limit + 1;
            return;
          }
          limit--;
        }
      };
      Tokenizer2.prototype.stateInNamedEntity = function(c) {
        if (c === ";") {
          this.parseFixedEntity();
          if (this.baseState === 1 && this.sectionStart + 1 < this._index && !this.xmlMode) {
            this.parseLegacyEntity();
          }
          this._state = this.baseState;
        } else if ((c < "0" || c > "9") && !isASCIIAlpha(c)) {
          if (this.xmlMode || this.sectionStart + 1 === this._index) {
          } else if (this.baseState !== 1) {
            if (c !== "=") {
              this.parseFixedEntity(legacy_json_1.default);
            }
          } else {
            this.parseLegacyEntity();
          }
          this._state = this.baseState;
          this._index--;
        }
      };
      Tokenizer2.prototype.decodeNumericEntity = function(offset, base, strict) {
        var sectionStart = this.sectionStart + offset;
        if (sectionStart !== this._index) {
          var entity = this.buffer.substring(sectionStart, this._index);
          var parsed = parseInt(entity, base);
          this.emitPartial(decode_codepoint_1.default(parsed));
          this.sectionStart = strict ? this._index + 1 : this._index;
        }
        this._state = this.baseState;
      };
      Tokenizer2.prototype.stateInNumericEntity = function(c) {
        if (c === ";") {
          this.decodeNumericEntity(2, 10, true);
        } else if (c < "0" || c > "9") {
          if (!this.xmlMode) {
            this.decodeNumericEntity(2, 10, false);
          } else {
            this._state = this.baseState;
          }
          this._index--;
        }
      };
      Tokenizer2.prototype.stateInHexEntity = function(c) {
        if (c === ";") {
          this.decodeNumericEntity(3, 16, true);
        } else if ((c < "a" || c > "f") && (c < "A" || c > "F") && (c < "0" || c > "9")) {
          if (!this.xmlMode) {
            this.decodeNumericEntity(3, 16, false);
          } else {
            this._state = this.baseState;
          }
          this._index--;
        }
      };
      Tokenizer2.prototype.cleanup = function() {
        if (this.sectionStart < 0) {
          this.buffer = "";
          this.bufferOffset += this._index;
          this._index = 0;
        } else if (this.running) {
          if (this._state === 1) {
            if (this.sectionStart !== this._index) {
              this.cbs.ontext(this.buffer.substr(this.sectionStart));
            }
            this.buffer = "";
            this.bufferOffset += this._index;
            this._index = 0;
          } else if (this.sectionStart === this._index) {
            this.buffer = "";
            this.bufferOffset += this._index;
            this._index = 0;
          } else {
            this.buffer = this.buffer.substr(this.sectionStart);
            this._index -= this.sectionStart;
            this.bufferOffset += this.sectionStart;
          }
          this.sectionStart = 0;
        }
      };
      Tokenizer2.prototype.parse = function() {
        while (this._index < this.buffer.length && this.running) {
          var c = this.buffer.charAt(this._index);
          if (this._state === 1) {
            this.stateText(c);
          } else if (this._state === 12) {
            this.stateInAttributeValueDoubleQuotes(c);
          } else if (this._state === 9) {
            this.stateInAttributeName(c);
          } else if (this._state === 19) {
            this.stateInComment(c);
          } else if (this._state === 20) {
            this.stateInSpecialComment(c);
          } else if (this._state === 8) {
            this.stateBeforeAttributeName(c);
          } else if (this._state === 3) {
            this.stateInTagName(c);
          } else if (this._state === 6) {
            this.stateInClosingTagName(c);
          } else if (this._state === 2) {
            this.stateBeforeTagName(c);
          } else if (this._state === 10) {
            this.stateAfterAttributeName(c);
          } else if (this._state === 13) {
            this.stateInAttributeValueSingleQuotes(c);
          } else if (this._state === 11) {
            this.stateBeforeAttributeValue(c);
          } else if (this._state === 5) {
            this.stateBeforeClosingTagName(c);
          } else if (this._state === 7) {
            this.stateAfterClosingTagName(c);
          } else if (this._state === 32) {
            this.stateBeforeSpecialS(c);
          } else if (this._state === 21) {
            this.stateAfterComment1(c);
          } else if (this._state === 14) {
            this.stateInAttributeValueNoQuotes(c);
          } else if (this._state === 4) {
            this.stateInSelfClosingTag(c);
          } else if (this._state === 16) {
            this.stateInDeclaration(c);
          } else if (this._state === 15) {
            this.stateBeforeDeclaration(c);
          } else if (this._state === 22) {
            this.stateAfterComment2(c);
          } else if (this._state === 18) {
            this.stateBeforeComment(c);
          } else if (this._state === 33) {
            this.stateBeforeSpecialSEnd(c);
          } else if (this._state === 53) {
            stateAfterSpecialTEnd(this, c);
          } else if (this._state === 39) {
            stateAfterScript1(this, c);
          } else if (this._state === 40) {
            stateAfterScript2(this, c);
          } else if (this._state === 41) {
            stateAfterScript3(this, c);
          } else if (this._state === 34) {
            stateBeforeScript1(this, c);
          } else if (this._state === 35) {
            stateBeforeScript2(this, c);
          } else if (this._state === 36) {
            stateBeforeScript3(this, c);
          } else if (this._state === 37) {
            stateBeforeScript4(this, c);
          } else if (this._state === 38) {
            this.stateBeforeSpecialLast(c, 2);
          } else if (this._state === 42) {
            stateAfterScript4(this, c);
          } else if (this._state === 43) {
            this.stateAfterSpecialLast(c, 6);
          } else if (this._state === 44) {
            stateBeforeStyle1(this, c);
          } else if (this._state === 29) {
            this.stateInCdata(c);
          } else if (this._state === 45) {
            stateBeforeStyle2(this, c);
          } else if (this._state === 46) {
            stateBeforeStyle3(this, c);
          } else if (this._state === 47) {
            this.stateBeforeSpecialLast(c, 3);
          } else if (this._state === 48) {
            stateAfterStyle1(this, c);
          } else if (this._state === 49) {
            stateAfterStyle2(this, c);
          } else if (this._state === 50) {
            stateAfterStyle3(this, c);
          } else if (this._state === 51) {
            this.stateAfterSpecialLast(c, 5);
          } else if (this._state === 52) {
            stateBeforeSpecialT(this, c);
          } else if (this._state === 54) {
            stateBeforeTitle1(this, c);
          } else if (this._state === 55) {
            stateBeforeTitle2(this, c);
          } else if (this._state === 56) {
            stateBeforeTitle3(this, c);
          } else if (this._state === 57) {
            this.stateBeforeSpecialLast(c, 4);
          } else if (this._state === 58) {
            stateAfterTitle1(this, c);
          } else if (this._state === 59) {
            stateAfterTitle2(this, c);
          } else if (this._state === 60) {
            stateAfterTitle3(this, c);
          } else if (this._state === 61) {
            this.stateAfterSpecialLast(c, 5);
          } else if (this._state === 17) {
            this.stateInProcessingInstruction(c);
          } else if (this._state === 64) {
            this.stateInNamedEntity(c);
          } else if (this._state === 23) {
            stateBeforeCdata1(this, c);
          } else if (this._state === 62) {
            stateBeforeEntity(this, c);
          } else if (this._state === 24) {
            stateBeforeCdata2(this, c);
          } else if (this._state === 25) {
            stateBeforeCdata3(this, c);
          } else if (this._state === 30) {
            this.stateAfterCdata1(c);
          } else if (this._state === 31) {
            this.stateAfterCdata2(c);
          } else if (this._state === 26) {
            stateBeforeCdata4(this, c);
          } else if (this._state === 27) {
            stateBeforeCdata5(this, c);
          } else if (this._state === 28) {
            this.stateBeforeCdata6(c);
          } else if (this._state === 66) {
            this.stateInHexEntity(c);
          } else if (this._state === 65) {
            this.stateInNumericEntity(c);
          } else if (this._state === 63) {
            stateBeforeNumericEntity(this, c);
          } else {
            this.cbs.onerror(Error("unknown _state"), this._state);
          }
          this._index++;
        }
        this.cleanup();
      };
      Tokenizer2.prototype.finish = function() {
        if (this.sectionStart < this._index) {
          this.handleTrailingData();
        }
        this.cbs.onend();
      };
      Tokenizer2.prototype.handleTrailingData = function() {
        var data = this.buffer.substr(this.sectionStart);
        if (this._state === 29 || this._state === 30 || this._state === 31) {
          this.cbs.oncdata(data);
        } else if (this._state === 19 || this._state === 21 || this._state === 22) {
          this.cbs.oncomment(data);
        } else if (this._state === 64 && !this.xmlMode) {
          this.parseLegacyEntity();
          if (this.sectionStart < this._index) {
            this._state = this.baseState;
            this.handleTrailingData();
          }
        } else if (this._state === 65 && !this.xmlMode) {
          this.decodeNumericEntity(2, 10, false);
          if (this.sectionStart < this._index) {
            this._state = this.baseState;
            this.handleTrailingData();
          }
        } else if (this._state === 66 && !this.xmlMode) {
          this.decodeNumericEntity(3, 16, false);
          if (this.sectionStart < this._index) {
            this._state = this.baseState;
            this.handleTrailingData();
          }
        } else if (this._state !== 3 && this._state !== 8 && this._state !== 11 && this._state !== 10 && this._state !== 9 && this._state !== 13 && this._state !== 12 && this._state !== 14 && this._state !== 6) {
          this.cbs.ontext(data);
        }
      };
      Tokenizer2.prototype.getSection = function() {
        return this.buffer.substring(this.sectionStart, this._index);
      };
      Tokenizer2.prototype.emitToken = function(name) {
        this.cbs[name](this.getSection());
        this.sectionStart = -1;
      };
      Tokenizer2.prototype.emitPartial = function(value) {
        if (this.baseState !== 1) {
          this.cbs.onattribdata(value);
        } else {
          this.cbs.ontext(value);
        }
      };
      return Tokenizer2;
    }();
    exports.default = Tokenizer;
  }
});

// node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/Parser.js
var require_Parser = __commonJS({
  "node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/Parser.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Parser = void 0;
    var Tokenizer_1 = __importDefault(require_Tokenizer());
    var formTags = /* @__PURE__ */ new Set([
      "input",
      "option",
      "optgroup",
      "select",
      "button",
      "datalist",
      "textarea"
    ]);
    var pTag = /* @__PURE__ */ new Set(["p"]);
    var openImpliesClose = {
      tr: /* @__PURE__ */ new Set(["tr", "th", "td"]),
      th: /* @__PURE__ */ new Set(["th"]),
      td: /* @__PURE__ */ new Set(["thead", "th", "td"]),
      body: /* @__PURE__ */ new Set(["head", "link", "script"]),
      li: /* @__PURE__ */ new Set(["li"]),
      p: pTag,
      h1: pTag,
      h2: pTag,
      h3: pTag,
      h4: pTag,
      h5: pTag,
      h6: pTag,
      select: formTags,
      input: formTags,
      output: formTags,
      button: formTags,
      datalist: formTags,
      textarea: formTags,
      option: /* @__PURE__ */ new Set(["option"]),
      optgroup: /* @__PURE__ */ new Set(["optgroup", "option"]),
      dd: /* @__PURE__ */ new Set(["dt", "dd"]),
      dt: /* @__PURE__ */ new Set(["dt", "dd"]),
      address: pTag,
      article: pTag,
      aside: pTag,
      blockquote: pTag,
      details: pTag,
      div: pTag,
      dl: pTag,
      fieldset: pTag,
      figcaption: pTag,
      figure: pTag,
      footer: pTag,
      form: pTag,
      header: pTag,
      hr: pTag,
      main: pTag,
      nav: pTag,
      ol: pTag,
      pre: pTag,
      section: pTag,
      table: pTag,
      ul: pTag,
      rt: /* @__PURE__ */ new Set(["rt", "rp"]),
      rp: /* @__PURE__ */ new Set(["rt", "rp"]),
      tbody: /* @__PURE__ */ new Set(["thead", "tbody"]),
      tfoot: /* @__PURE__ */ new Set(["thead", "tbody"])
    };
    var voidElements = /* @__PURE__ */ new Set([
      "area",
      "base",
      "basefont",
      "br",
      "col",
      "command",
      "embed",
      "frame",
      "hr",
      "img",
      "input",
      "isindex",
      "keygen",
      "link",
      "meta",
      "param",
      "source",
      "track",
      "wbr"
    ]);
    var foreignContextElements = /* @__PURE__ */ new Set(["math", "svg"]);
    var htmlIntegrationElements = /* @__PURE__ */ new Set([
      "mi",
      "mo",
      "mn",
      "ms",
      "mtext",
      "annotation-xml",
      "foreignObject",
      "desc",
      "title"
    ]);
    var reNameEnd = /\s|\//;
    var Parser = function() {
      function Parser2(cbs, options) {
        if (options === void 0) {
          options = {};
        }
        var _a, _b, _c, _d, _e;
        this.startIndex = 0;
        this.endIndex = null;
        this.tagname = "";
        this.attribname = "";
        this.attribvalue = "";
        this.attribs = null;
        this.stack = [];
        this.foreignContext = [];
        this.options = options;
        this.cbs = cbs !== null && cbs !== void 0 ? cbs : {};
        this.lowerCaseTagNames = (_a = options.lowerCaseTags) !== null && _a !== void 0 ? _a : !options.xmlMode;
        this.lowerCaseAttributeNames = (_b = options.lowerCaseAttributeNames) !== null && _b !== void 0 ? _b : !options.xmlMode;
        this.tokenizer = new ((_c = options.Tokenizer) !== null && _c !== void 0 ? _c : Tokenizer_1.default)(this.options, this);
        (_e = (_d = this.cbs).onparserinit) === null || _e === void 0 ? void 0 : _e.call(_d, this);
      }
      Parser2.prototype.updatePosition = function(initialOffset) {
        if (this.endIndex === null) {
          if (this.tokenizer.sectionStart <= initialOffset) {
            this.startIndex = 0;
          } else {
            this.startIndex = this.tokenizer.sectionStart - initialOffset;
          }
        } else {
          this.startIndex = this.endIndex + 1;
        }
        this.endIndex = this.tokenizer.getAbsoluteIndex();
      };
      Parser2.prototype.ontext = function(data) {
        var _a, _b;
        this.updatePosition(1);
        this.endIndex--;
        (_b = (_a = this.cbs).ontext) === null || _b === void 0 ? void 0 : _b.call(_a, data);
      };
      Parser2.prototype.onopentagname = function(name) {
        var _a, _b;
        if (this.lowerCaseTagNames) {
          name = name.toLowerCase();
        }
        this.tagname = name;
        if (!this.options.xmlMode && Object.prototype.hasOwnProperty.call(openImpliesClose, name)) {
          var el = void 0;
          while (this.stack.length > 0 && openImpliesClose[name].has(el = this.stack[this.stack.length - 1])) {
            this.onclosetag(el);
          }
        }
        if (this.options.xmlMode || !voidElements.has(name)) {
          this.stack.push(name);
          if (foreignContextElements.has(name)) {
            this.foreignContext.push(true);
          } else if (htmlIntegrationElements.has(name)) {
            this.foreignContext.push(false);
          }
        }
        (_b = (_a = this.cbs).onopentagname) === null || _b === void 0 ? void 0 : _b.call(_a, name);
        if (this.cbs.onopentag)
          this.attribs = {};
      };
      Parser2.prototype.onopentagend = function() {
        var _a, _b;
        this.updatePosition(1);
        if (this.attribs) {
          (_b = (_a = this.cbs).onopentag) === null || _b === void 0 ? void 0 : _b.call(_a, this.tagname, this.attribs);
          this.attribs = null;
        }
        if (!this.options.xmlMode && this.cbs.onclosetag && voidElements.has(this.tagname)) {
          this.cbs.onclosetag(this.tagname);
        }
        this.tagname = "";
      };
      Parser2.prototype.onclosetag = function(name) {
        this.updatePosition(1);
        if (this.lowerCaseTagNames) {
          name = name.toLowerCase();
        }
        if (foreignContextElements.has(name) || htmlIntegrationElements.has(name)) {
          this.foreignContext.pop();
        }
        if (this.stack.length && (this.options.xmlMode || !voidElements.has(name))) {
          var pos = this.stack.lastIndexOf(name);
          if (pos !== -1) {
            if (this.cbs.onclosetag) {
              pos = this.stack.length - pos;
              while (pos--) {
                this.cbs.onclosetag(this.stack.pop());
              }
            } else
              this.stack.length = pos;
          } else if (name === "p" && !this.options.xmlMode) {
            this.onopentagname(name);
            this.closeCurrentTag();
          }
        } else if (!this.options.xmlMode && (name === "br" || name === "p")) {
          this.onopentagname(name);
          this.closeCurrentTag();
        }
      };
      Parser2.prototype.onselfclosingtag = function() {
        if (this.options.xmlMode || this.options.recognizeSelfClosing || this.foreignContext[this.foreignContext.length - 1]) {
          this.closeCurrentTag();
        } else {
          this.onopentagend();
        }
      };
      Parser2.prototype.closeCurrentTag = function() {
        var _a, _b;
        var name = this.tagname;
        this.onopentagend();
        if (this.stack[this.stack.length - 1] === name) {
          (_b = (_a = this.cbs).onclosetag) === null || _b === void 0 ? void 0 : _b.call(_a, name);
          this.stack.pop();
        }
      };
      Parser2.prototype.onattribname = function(name) {
        if (this.lowerCaseAttributeNames) {
          name = name.toLowerCase();
        }
        this.attribname = name;
      };
      Parser2.prototype.onattribdata = function(value) {
        this.attribvalue += value;
      };
      Parser2.prototype.onattribend = function(quote) {
        var _a, _b;
        (_b = (_a = this.cbs).onattribute) === null || _b === void 0 ? void 0 : _b.call(_a, this.attribname, this.attribvalue, quote);
        if (this.attribs && !Object.prototype.hasOwnProperty.call(this.attribs, this.attribname)) {
          this.attribs[this.attribname] = this.attribvalue;
        }
        this.attribname = "";
        this.attribvalue = "";
      };
      Parser2.prototype.getInstructionName = function(value) {
        var idx2 = value.search(reNameEnd);
        var name = idx2 < 0 ? value : value.substr(0, idx2);
        if (this.lowerCaseTagNames) {
          name = name.toLowerCase();
        }
        return name;
      };
      Parser2.prototype.ondeclaration = function(value) {
        if (this.cbs.onprocessinginstruction) {
          var name_1 = this.getInstructionName(value);
          this.cbs.onprocessinginstruction("!" + name_1, "!" + value);
        }
      };
      Parser2.prototype.onprocessinginstruction = function(value) {
        if (this.cbs.onprocessinginstruction) {
          var name_2 = this.getInstructionName(value);
          this.cbs.onprocessinginstruction("?" + name_2, "?" + value);
        }
      };
      Parser2.prototype.oncomment = function(value) {
        var _a, _b, _c, _d;
        this.updatePosition(4);
        (_b = (_a = this.cbs).oncomment) === null || _b === void 0 ? void 0 : _b.call(_a, value);
        (_d = (_c = this.cbs).oncommentend) === null || _d === void 0 ? void 0 : _d.call(_c);
      };
      Parser2.prototype.oncdata = function(value) {
        var _a, _b, _c, _d, _e, _f;
        this.updatePosition(1);
        if (this.options.xmlMode || this.options.recognizeCDATA) {
          (_b = (_a = this.cbs).oncdatastart) === null || _b === void 0 ? void 0 : _b.call(_a);
          (_d = (_c = this.cbs).ontext) === null || _d === void 0 ? void 0 : _d.call(_c, value);
          (_f = (_e = this.cbs).oncdataend) === null || _f === void 0 ? void 0 : _f.call(_e);
        } else {
          this.oncomment("[CDATA[" + value + "]]");
        }
      };
      Parser2.prototype.onerror = function(err) {
        var _a, _b;
        (_b = (_a = this.cbs).onerror) === null || _b === void 0 ? void 0 : _b.call(_a, err);
      };
      Parser2.prototype.onend = function() {
        var _a, _b;
        if (this.cbs.onclosetag) {
          for (var i = this.stack.length; i > 0; this.cbs.onclosetag(this.stack[--i]))
            ;
        }
        (_b = (_a = this.cbs).onend) === null || _b === void 0 ? void 0 : _b.call(_a);
      };
      Parser2.prototype.reset = function() {
        var _a, _b, _c, _d;
        (_b = (_a = this.cbs).onreset) === null || _b === void 0 ? void 0 : _b.call(_a);
        this.tokenizer.reset();
        this.tagname = "";
        this.attribname = "";
        this.attribs = null;
        this.stack = [];
        (_d = (_c = this.cbs).onparserinit) === null || _d === void 0 ? void 0 : _d.call(_c, this);
      };
      Parser2.prototype.parseComplete = function(data) {
        this.reset();
        this.end(data);
      };
      Parser2.prototype.write = function(chunk) {
        this.tokenizer.write(chunk);
      };
      Parser2.prototype.end = function(chunk) {
        this.tokenizer.end(chunk);
      };
      Parser2.prototype.pause = function() {
        this.tokenizer.pause();
      };
      Parser2.prototype.resume = function() {
        this.tokenizer.resume();
      };
      Parser2.prototype.parseChunk = function(chunk) {
        this.write(chunk);
      };
      Parser2.prototype.done = function(chunk) {
        this.end(chunk);
      };
      return Parser2;
    }();
    exports.Parser = Parser;
  }
});

// node_modules/.pnpm/domelementtype@2.3.0/node_modules/domelementtype/lib/index.js
var require_lib7 = __commonJS({
  "node_modules/.pnpm/domelementtype@2.3.0/node_modules/domelementtype/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Doctype = exports.CDATA = exports.Tag = exports.Style = exports.Script = exports.Comment = exports.Directive = exports.Text = exports.Root = exports.isTag = exports.ElementType = void 0;
    var ElementType;
    (function(ElementType2) {
      ElementType2["Root"] = "root";
      ElementType2["Text"] = "text";
      ElementType2["Directive"] = "directive";
      ElementType2["Comment"] = "comment";
      ElementType2["Script"] = "script";
      ElementType2["Style"] = "style";
      ElementType2["Tag"] = "tag";
      ElementType2["CDATA"] = "cdata";
      ElementType2["Doctype"] = "doctype";
    })(ElementType = exports.ElementType || (exports.ElementType = {}));
    function isTag(elem) {
      return elem.type === ElementType.Tag || elem.type === ElementType.Script || elem.type === ElementType.Style;
    }
    exports.isTag = isTag;
    exports.Root = ElementType.Root;
    exports.Text = ElementType.Text;
    exports.Directive = ElementType.Directive;
    exports.Comment = ElementType.Comment;
    exports.Script = ElementType.Script;
    exports.Style = ElementType.Style;
    exports.Tag = ElementType.Tag;
    exports.CDATA = ElementType.CDATA;
    exports.Doctype = ElementType.Doctype;
  }
});

// node_modules/.pnpm/domhandler@4.3.1/node_modules/domhandler/lib/node.js
var require_node = __commonJS({
  "node_modules/.pnpm/domhandler@4.3.1/node_modules/domhandler/lib/node.js"(exports) {
    "use strict";
    var __extends = exports && exports.__extends || function() {
      var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
          d2.__proto__ = b2;
        } || function(d2, b2) {
          for (var p in b2)
            if (Object.prototype.hasOwnProperty.call(b2, p))
              d2[p] = b2[p];
        };
        return extendStatics(d, b);
      };
      return function(d, b) {
        if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() {
          this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
      };
    }();
    var __assign = exports && exports.__assign || function() {
      __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p))
              t[p] = s[p];
        }
        return t;
      };
      return __assign.apply(this, arguments);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.cloneNode = exports.hasChildren = exports.isDocument = exports.isDirective = exports.isComment = exports.isText = exports.isCDATA = exports.isTag = exports.Element = exports.Document = exports.NodeWithChildren = exports.ProcessingInstruction = exports.Comment = exports.Text = exports.DataNode = exports.Node = void 0;
    var domelementtype_1 = require_lib7();
    var nodeTypes = /* @__PURE__ */ new Map([
      [domelementtype_1.ElementType.Tag, 1],
      [domelementtype_1.ElementType.Script, 1],
      [domelementtype_1.ElementType.Style, 1],
      [domelementtype_1.ElementType.Directive, 1],
      [domelementtype_1.ElementType.Text, 3],
      [domelementtype_1.ElementType.CDATA, 4],
      [domelementtype_1.ElementType.Comment, 8],
      [domelementtype_1.ElementType.Root, 9]
    ]);
    var Node = function() {
      function Node2(type2) {
        this.type = type2;
        this.parent = null;
        this.prev = null;
        this.next = null;
        this.startIndex = null;
        this.endIndex = null;
      }
      Object.defineProperty(Node2.prototype, "nodeType", {
        get: function() {
          var _a;
          return (_a = nodeTypes.get(this.type)) !== null && _a !== void 0 ? _a : 1;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Node2.prototype, "parentNode", {
        get: function() {
          return this.parent;
        },
        set: function(parent) {
          this.parent = parent;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Node2.prototype, "previousSibling", {
        get: function() {
          return this.prev;
        },
        set: function(prev) {
          this.prev = prev;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Node2.prototype, "nextSibling", {
        get: function() {
          return this.next;
        },
        set: function(next) {
          this.next = next;
        },
        enumerable: false,
        configurable: true
      });
      Node2.prototype.cloneNode = function(recursive) {
        if (recursive === void 0) {
          recursive = false;
        }
        return cloneNode(this, recursive);
      };
      return Node2;
    }();
    exports.Node = Node;
    var DataNode = function(_super) {
      __extends(DataNode2, _super);
      function DataNode2(type2, data) {
        var _this = _super.call(this, type2) || this;
        _this.data = data;
        return _this;
      }
      Object.defineProperty(DataNode2.prototype, "nodeValue", {
        get: function() {
          return this.data;
        },
        set: function(data) {
          this.data = data;
        },
        enumerable: false,
        configurable: true
      });
      return DataNode2;
    }(Node);
    exports.DataNode = DataNode;
    var Text = function(_super) {
      __extends(Text2, _super);
      function Text2(data) {
        return _super.call(this, domelementtype_1.ElementType.Text, data) || this;
      }
      return Text2;
    }(DataNode);
    exports.Text = Text;
    var Comment = function(_super) {
      __extends(Comment2, _super);
      function Comment2(data) {
        return _super.call(this, domelementtype_1.ElementType.Comment, data) || this;
      }
      return Comment2;
    }(DataNode);
    exports.Comment = Comment;
    var ProcessingInstruction = function(_super) {
      __extends(ProcessingInstruction2, _super);
      function ProcessingInstruction2(name, data) {
        var _this = _super.call(this, domelementtype_1.ElementType.Directive, data) || this;
        _this.name = name;
        return _this;
      }
      return ProcessingInstruction2;
    }(DataNode);
    exports.ProcessingInstruction = ProcessingInstruction;
    var NodeWithChildren = function(_super) {
      __extends(NodeWithChildren2, _super);
      function NodeWithChildren2(type2, children) {
        var _this = _super.call(this, type2) || this;
        _this.children = children;
        return _this;
      }
      Object.defineProperty(NodeWithChildren2.prototype, "firstChild", {
        get: function() {
          var _a;
          return (_a = this.children[0]) !== null && _a !== void 0 ? _a : null;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(NodeWithChildren2.prototype, "lastChild", {
        get: function() {
          return this.children.length > 0 ? this.children[this.children.length - 1] : null;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(NodeWithChildren2.prototype, "childNodes", {
        get: function() {
          return this.children;
        },
        set: function(children) {
          this.children = children;
        },
        enumerable: false,
        configurable: true
      });
      return NodeWithChildren2;
    }(Node);
    exports.NodeWithChildren = NodeWithChildren;
    var Document = function(_super) {
      __extends(Document2, _super);
      function Document2(children) {
        return _super.call(this, domelementtype_1.ElementType.Root, children) || this;
      }
      return Document2;
    }(NodeWithChildren);
    exports.Document = Document;
    var Element = function(_super) {
      __extends(Element2, _super);
      function Element2(name, attribs, children, type2) {
        if (children === void 0) {
          children = [];
        }
        if (type2 === void 0) {
          type2 = name === "script" ? domelementtype_1.ElementType.Script : name === "style" ? domelementtype_1.ElementType.Style : domelementtype_1.ElementType.Tag;
        }
        var _this = _super.call(this, type2, children) || this;
        _this.name = name;
        _this.attribs = attribs;
        return _this;
      }
      Object.defineProperty(Element2.prototype, "tagName", {
        get: function() {
          return this.name;
        },
        set: function(name) {
          this.name = name;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Element2.prototype, "attributes", {
        get: function() {
          var _this = this;
          return Object.keys(this.attribs).map(function(name) {
            var _a, _b;
            return {
              name,
              value: _this.attribs[name],
              namespace: (_a = _this["x-attribsNamespace"]) === null || _a === void 0 ? void 0 : _a[name],
              prefix: (_b = _this["x-attribsPrefix"]) === null || _b === void 0 ? void 0 : _b[name]
            };
          });
        },
        enumerable: false,
        configurable: true
      });
      return Element2;
    }(NodeWithChildren);
    exports.Element = Element;
    function isTag(node) {
      return (0, domelementtype_1.isTag)(node);
    }
    exports.isTag = isTag;
    function isCDATA(node) {
      return node.type === domelementtype_1.ElementType.CDATA;
    }
    exports.isCDATA = isCDATA;
    function isText(node) {
      return node.type === domelementtype_1.ElementType.Text;
    }
    exports.isText = isText;
    function isComment(node) {
      return node.type === domelementtype_1.ElementType.Comment;
    }
    exports.isComment = isComment;
    function isDirective(node) {
      return node.type === domelementtype_1.ElementType.Directive;
    }
    exports.isDirective = isDirective;
    function isDocument(node) {
      return node.type === domelementtype_1.ElementType.Root;
    }
    exports.isDocument = isDocument;
    function hasChildren(node) {
      return Object.prototype.hasOwnProperty.call(node, "children");
    }
    exports.hasChildren = hasChildren;
    function cloneNode(node, recursive) {
      if (recursive === void 0) {
        recursive = false;
      }
      var result2;
      if (isText(node)) {
        result2 = new Text(node.data);
      } else if (isComment(node)) {
        result2 = new Comment(node.data);
      } else if (isTag(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_1 = new Element(node.name, __assign({}, node.attribs), children);
        children.forEach(function(child) {
          return child.parent = clone_1;
        });
        if (node.namespace != null) {
          clone_1.namespace = node.namespace;
        }
        if (node["x-attribsNamespace"]) {
          clone_1["x-attribsNamespace"] = __assign({}, node["x-attribsNamespace"]);
        }
        if (node["x-attribsPrefix"]) {
          clone_1["x-attribsPrefix"] = __assign({}, node["x-attribsPrefix"]);
        }
        result2 = clone_1;
      } else if (isCDATA(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_2 = new NodeWithChildren(domelementtype_1.ElementType.CDATA, children);
        children.forEach(function(child) {
          return child.parent = clone_2;
        });
        result2 = clone_2;
      } else if (isDocument(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_3 = new Document(children);
        children.forEach(function(child) {
          return child.parent = clone_3;
        });
        if (node["x-mode"]) {
          clone_3["x-mode"] = node["x-mode"];
        }
        result2 = clone_3;
      } else if (isDirective(node)) {
        var instruction = new ProcessingInstruction(node.name, node.data);
        if (node["x-name"] != null) {
          instruction["x-name"] = node["x-name"];
          instruction["x-publicId"] = node["x-publicId"];
          instruction["x-systemId"] = node["x-systemId"];
        }
        result2 = instruction;
      } else {
        throw new Error("Not implemented yet: ".concat(node.type));
      }
      result2.startIndex = node.startIndex;
      result2.endIndex = node.endIndex;
      if (node.sourceCodeLocation != null) {
        result2.sourceCodeLocation = node.sourceCodeLocation;
      }
      return result2;
    }
    exports.cloneNode = cloneNode;
    function cloneChildren(childs) {
      var children = childs.map(function(child) {
        return cloneNode(child, true);
      });
      for (var i = 1; i < children.length; i++) {
        children[i].prev = children[i - 1];
        children[i - 1].next = children[i];
      }
      return children;
    }
  }
});

// node_modules/.pnpm/domhandler@4.3.1/node_modules/domhandler/lib/index.js
var require_lib8 = __commonJS({
  "node_modules/.pnpm/domhandler@4.3.1/node_modules/domhandler/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DomHandler = void 0;
    var domelementtype_1 = require_lib7();
    var node_1 = require_node();
    __exportStar(require_node(), exports);
    var reWhitespace = /\s+/g;
    var defaultOpts = {
      normalizeWhitespace: false,
      withStartIndices: false,
      withEndIndices: false,
      xmlMode: false
    };
    var DomHandler = function() {
      function DomHandler2(callback, options, elementCB) {
        this.dom = [];
        this.root = new node_1.Document(this.dom);
        this.done = false;
        this.tagStack = [this.root];
        this.lastNode = null;
        this.parser = null;
        if (typeof options === "function") {
          elementCB = options;
          options = defaultOpts;
        }
        if (typeof callback === "object") {
          options = callback;
          callback = void 0;
        }
        this.callback = callback !== null && callback !== void 0 ? callback : null;
        this.options = options !== null && options !== void 0 ? options : defaultOpts;
        this.elementCB = elementCB !== null && elementCB !== void 0 ? elementCB : null;
      }
      DomHandler2.prototype.onparserinit = function(parser) {
        this.parser = parser;
      };
      DomHandler2.prototype.onreset = function() {
        this.dom = [];
        this.root = new node_1.Document(this.dom);
        this.done = false;
        this.tagStack = [this.root];
        this.lastNode = null;
        this.parser = null;
      };
      DomHandler2.prototype.onend = function() {
        if (this.done)
          return;
        this.done = true;
        this.parser = null;
        this.handleCallback(null);
      };
      DomHandler2.prototype.onerror = function(error) {
        this.handleCallback(error);
      };
      DomHandler2.prototype.onclosetag = function() {
        this.lastNode = null;
        var elem = this.tagStack.pop();
        if (this.options.withEndIndices) {
          elem.endIndex = this.parser.endIndex;
        }
        if (this.elementCB)
          this.elementCB(elem);
      };
      DomHandler2.prototype.onopentag = function(name, attribs) {
        var type2 = this.options.xmlMode ? domelementtype_1.ElementType.Tag : void 0;
        var element = new node_1.Element(name, attribs, void 0, type2);
        this.addNode(element);
        this.tagStack.push(element);
      };
      DomHandler2.prototype.ontext = function(data) {
        var normalizeWhitespace = this.options.normalizeWhitespace;
        var lastNode = this.lastNode;
        if (lastNode && lastNode.type === domelementtype_1.ElementType.Text) {
          if (normalizeWhitespace) {
            lastNode.data = (lastNode.data + data).replace(reWhitespace, " ");
          } else {
            lastNode.data += data;
          }
          if (this.options.withEndIndices) {
            lastNode.endIndex = this.parser.endIndex;
          }
        } else {
          if (normalizeWhitespace) {
            data = data.replace(reWhitespace, " ");
          }
          var node = new node_1.Text(data);
          this.addNode(node);
          this.lastNode = node;
        }
      };
      DomHandler2.prototype.oncomment = function(data) {
        if (this.lastNode && this.lastNode.type === domelementtype_1.ElementType.Comment) {
          this.lastNode.data += data;
          return;
        }
        var node = new node_1.Comment(data);
        this.addNode(node);
        this.lastNode = node;
      };
      DomHandler2.prototype.oncommentend = function() {
        this.lastNode = null;
      };
      DomHandler2.prototype.oncdatastart = function() {
        var text = new node_1.Text("");
        var node = new node_1.NodeWithChildren(domelementtype_1.ElementType.CDATA, [text]);
        this.addNode(node);
        text.parent = node;
        this.lastNode = text;
      };
      DomHandler2.prototype.oncdataend = function() {
        this.lastNode = null;
      };
      DomHandler2.prototype.onprocessinginstruction = function(name, data) {
        var node = new node_1.ProcessingInstruction(name, data);
        this.addNode(node);
      };
      DomHandler2.prototype.handleCallback = function(error) {
        if (typeof this.callback === "function") {
          this.callback(error, this.dom);
        } else if (error) {
          throw error;
        }
      };
      DomHandler2.prototype.addNode = function(node) {
        var parent = this.tagStack[this.tagStack.length - 1];
        var previousSibling = parent.children[parent.children.length - 1];
        if (this.options.withStartIndices) {
          node.startIndex = this.parser.startIndex;
        }
        if (this.options.withEndIndices) {
          node.endIndex = this.parser.endIndex;
        }
        parent.children.push(node);
        if (previousSibling) {
          node.prev = previousSibling;
          previousSibling.next = node;
        }
        node.parent = parent;
        this.lastNode = null;
      };
      return DomHandler2;
    }();
    exports.DomHandler = DomHandler;
    exports.default = DomHandler;
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/decode.js
var require_decode2 = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/decode.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.decodeHTML = exports.decodeHTMLStrict = exports.decodeXML = void 0;
    var entities_json_1 = __importDefault(require_entities());
    var legacy_json_1 = __importDefault(require_legacy());
    var xml_json_1 = __importDefault(require_xml());
    var decode_codepoint_1 = __importDefault(require_decode_codepoint());
    var strictEntityRe = /&(?:[a-zA-Z0-9]+|#[xX][\da-fA-F]+|#\d+);/g;
    exports.decodeXML = getStrictDecoder(xml_json_1.default);
    exports.decodeHTMLStrict = getStrictDecoder(entities_json_1.default);
    function getStrictDecoder(map2) {
      var replace = getReplacer(map2);
      return function(str2) {
        return String(str2).replace(strictEntityRe, replace);
      };
    }
    var sorter = function(a, b) {
      return a < b ? 1 : -1;
    };
    exports.decodeHTML = function() {
      var legacy = Object.keys(legacy_json_1.default).sort(sorter);
      var keys = Object.keys(entities_json_1.default).sort(sorter);
      for (var i = 0, j = 0; i < keys.length; i++) {
        if (legacy[j] === keys[i]) {
          keys[i] += ";?";
          j++;
        } else {
          keys[i] += ";";
        }
      }
      var re = new RegExp("&(?:" + keys.join("|") + "|#[xX][\\da-fA-F]+;?|#\\d+;?)", "g");
      var replace = getReplacer(entities_json_1.default);
      function replacer(str2) {
        if (str2.substr(-1) !== ";")
          str2 += ";";
        return replace(str2);
      }
      return function(str2) {
        return String(str2).replace(re, replacer);
      };
    }();
    function getReplacer(map2) {
      return function replace(str2) {
        if (str2.charAt(1) === "#") {
          var secondChar = str2.charAt(2);
          if (secondChar === "X" || secondChar === "x") {
            return decode_codepoint_1.default(parseInt(str2.substr(3), 16));
          }
          return decode_codepoint_1.default(parseInt(str2.substr(2), 10));
        }
        return map2[str2.slice(1, -1)] || str2;
      };
    }
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/encode.js
var require_encode = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/encode.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.escapeUTF8 = exports.escape = exports.encodeNonAsciiHTML = exports.encodeHTML = exports.encodeXML = void 0;
    var xml_json_1 = __importDefault(require_xml());
    var inverseXML = getInverseObj(xml_json_1.default);
    var xmlReplacer = getInverseReplacer(inverseXML);
    exports.encodeXML = getASCIIEncoder(inverseXML);
    var entities_json_1 = __importDefault(require_entities());
    var inverseHTML = getInverseObj(entities_json_1.default);
    var htmlReplacer = getInverseReplacer(inverseHTML);
    exports.encodeHTML = getInverse(inverseHTML, htmlReplacer);
    exports.encodeNonAsciiHTML = getASCIIEncoder(inverseHTML);
    function getInverseObj(obj) {
      return Object.keys(obj).sort().reduce(function(inverse, name) {
        inverse[obj[name]] = "&" + name + ";";
        return inverse;
      }, {});
    }
    function getInverseReplacer(inverse) {
      var single = [];
      var multiple = [];
      for (var _i = 0, _a = Object.keys(inverse); _i < _a.length; _i++) {
        var k = _a[_i];
        if (k.length === 1) {
          single.push("\\" + k);
        } else {
          multiple.push(k);
        }
      }
      single.sort();
      for (var start = 0; start < single.length - 1; start++) {
        var end = start;
        while (end < single.length - 1 && single[end].charCodeAt(1) + 1 === single[end + 1].charCodeAt(1)) {
          end += 1;
        }
        var count = 1 + end - start;
        if (count < 3)
          continue;
        single.splice(start, count, single[start] + "-" + single[end]);
      }
      multiple.unshift("[" + single.join("") + "]");
      return new RegExp(multiple.join("|"), "g");
    }
    var reNonASCII = /(?:[\x80-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/g;
    var getCodePoint = String.prototype.codePointAt != null ? function(str2) {
      return str2.codePointAt(0);
    } : function(c) {
      return (c.charCodeAt(0) - 55296) * 1024 + c.charCodeAt(1) - 56320 + 65536;
    };
    function singleCharReplacer(c) {
      return "&#x" + (c.length > 1 ? getCodePoint(c) : c.charCodeAt(0)).toString(16).toUpperCase() + ";";
    }
    function getInverse(inverse, re) {
      return function(data) {
        return data.replace(re, function(name) {
          return inverse[name];
        }).replace(reNonASCII, singleCharReplacer);
      };
    }
    var reEscapeChars = new RegExp(xmlReplacer.source + "|" + reNonASCII.source, "g");
    function escape(data) {
      return data.replace(reEscapeChars, singleCharReplacer);
    }
    exports.escape = escape;
    function escapeUTF8(data) {
      return data.replace(xmlReplacer, singleCharReplacer);
    }
    exports.escapeUTF8 = escapeUTF8;
    function getASCIIEncoder(obj) {
      return function(data) {
        return data.replace(reEscapeChars, function(c) {
          return obj[c] || singleCharReplacer(c);
        });
      };
    }
  }
});

// node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/index.js
var require_lib9 = __commonJS({
  "node_modules/.pnpm/entities@2.2.0/node_modules/entities/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.decodeXMLStrict = exports.decodeHTML5Strict = exports.decodeHTML4Strict = exports.decodeHTML5 = exports.decodeHTML4 = exports.decodeHTMLStrict = exports.decodeHTML = exports.decodeXML = exports.encodeHTML5 = exports.encodeHTML4 = exports.escapeUTF8 = exports.escape = exports.encodeNonAsciiHTML = exports.encodeHTML = exports.encodeXML = exports.encode = exports.decodeStrict = exports.decode = void 0;
    var decode_1 = require_decode2();
    var encode_1 = require_encode();
    function decode(data, level) {
      return (!level || level <= 0 ? decode_1.decodeXML : decode_1.decodeHTML)(data);
    }
    exports.decode = decode;
    function decodeStrict(data, level) {
      return (!level || level <= 0 ? decode_1.decodeXML : decode_1.decodeHTMLStrict)(data);
    }
    exports.decodeStrict = decodeStrict;
    function encode(data, level) {
      return (!level || level <= 0 ? encode_1.encodeXML : encode_1.encodeHTML)(data);
    }
    exports.encode = encode;
    var encode_2 = require_encode();
    Object.defineProperty(exports, "encodeXML", { enumerable: true, get: function() {
      return encode_2.encodeXML;
    } });
    Object.defineProperty(exports, "encodeHTML", { enumerable: true, get: function() {
      return encode_2.encodeHTML;
    } });
    Object.defineProperty(exports, "encodeNonAsciiHTML", { enumerable: true, get: function() {
      return encode_2.encodeNonAsciiHTML;
    } });
    Object.defineProperty(exports, "escape", { enumerable: true, get: function() {
      return encode_2.escape;
    } });
    Object.defineProperty(exports, "escapeUTF8", { enumerable: true, get: function() {
      return encode_2.escapeUTF8;
    } });
    Object.defineProperty(exports, "encodeHTML4", { enumerable: true, get: function() {
      return encode_2.encodeHTML;
    } });
    Object.defineProperty(exports, "encodeHTML5", { enumerable: true, get: function() {
      return encode_2.encodeHTML;
    } });
    var decode_2 = require_decode2();
    Object.defineProperty(exports, "decodeXML", { enumerable: true, get: function() {
      return decode_2.decodeXML;
    } });
    Object.defineProperty(exports, "decodeHTML", { enumerable: true, get: function() {
      return decode_2.decodeHTML;
    } });
    Object.defineProperty(exports, "decodeHTMLStrict", { enumerable: true, get: function() {
      return decode_2.decodeHTMLStrict;
    } });
    Object.defineProperty(exports, "decodeHTML4", { enumerable: true, get: function() {
      return decode_2.decodeHTML;
    } });
    Object.defineProperty(exports, "decodeHTML5", { enumerable: true, get: function() {
      return decode_2.decodeHTML;
    } });
    Object.defineProperty(exports, "decodeHTML4Strict", { enumerable: true, get: function() {
      return decode_2.decodeHTMLStrict;
    } });
    Object.defineProperty(exports, "decodeHTML5Strict", { enumerable: true, get: function() {
      return decode_2.decodeHTMLStrict;
    } });
    Object.defineProperty(exports, "decodeXMLStrict", { enumerable: true, get: function() {
      return decode_2.decodeXML;
    } });
  }
});

// node_modules/.pnpm/dom-serializer@1.4.1/node_modules/dom-serializer/lib/foreignNames.js
var require_foreignNames = __commonJS({
  "node_modules/.pnpm/dom-serializer@1.4.1/node_modules/dom-serializer/lib/foreignNames.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.attributeNames = exports.elementNames = void 0;
    exports.elementNames = /* @__PURE__ */ new Map([
      ["altglyph", "altGlyph"],
      ["altglyphdef", "altGlyphDef"],
      ["altglyphitem", "altGlyphItem"],
      ["animatecolor", "animateColor"],
      ["animatemotion", "animateMotion"],
      ["animatetransform", "animateTransform"],
      ["clippath", "clipPath"],
      ["feblend", "feBlend"],
      ["fecolormatrix", "feColorMatrix"],
      ["fecomponenttransfer", "feComponentTransfer"],
      ["fecomposite", "feComposite"],
      ["feconvolvematrix", "feConvolveMatrix"],
      ["fediffuselighting", "feDiffuseLighting"],
      ["fedisplacementmap", "feDisplacementMap"],
      ["fedistantlight", "feDistantLight"],
      ["fedropshadow", "feDropShadow"],
      ["feflood", "feFlood"],
      ["fefunca", "feFuncA"],
      ["fefuncb", "feFuncB"],
      ["fefuncg", "feFuncG"],
      ["fefuncr", "feFuncR"],
      ["fegaussianblur", "feGaussianBlur"],
      ["feimage", "feImage"],
      ["femerge", "feMerge"],
      ["femergenode", "feMergeNode"],
      ["femorphology", "feMorphology"],
      ["feoffset", "feOffset"],
      ["fepointlight", "fePointLight"],
      ["fespecularlighting", "feSpecularLighting"],
      ["fespotlight", "feSpotLight"],
      ["fetile", "feTile"],
      ["feturbulence", "feTurbulence"],
      ["foreignobject", "foreignObject"],
      ["glyphref", "glyphRef"],
      ["lineargradient", "linearGradient"],
      ["radialgradient", "radialGradient"],
      ["textpath", "textPath"]
    ]);
    exports.attributeNames = /* @__PURE__ */ new Map([
      ["definitionurl", "definitionURL"],
      ["attributename", "attributeName"],
      ["attributetype", "attributeType"],
      ["basefrequency", "baseFrequency"],
      ["baseprofile", "baseProfile"],
      ["calcmode", "calcMode"],
      ["clippathunits", "clipPathUnits"],
      ["diffuseconstant", "diffuseConstant"],
      ["edgemode", "edgeMode"],
      ["filterunits", "filterUnits"],
      ["glyphref", "glyphRef"],
      ["gradienttransform", "gradientTransform"],
      ["gradientunits", "gradientUnits"],
      ["kernelmatrix", "kernelMatrix"],
      ["kernelunitlength", "kernelUnitLength"],
      ["keypoints", "keyPoints"],
      ["keysplines", "keySplines"],
      ["keytimes", "keyTimes"],
      ["lengthadjust", "lengthAdjust"],
      ["limitingconeangle", "limitingConeAngle"],
      ["markerheight", "markerHeight"],
      ["markerunits", "markerUnits"],
      ["markerwidth", "markerWidth"],
      ["maskcontentunits", "maskContentUnits"],
      ["maskunits", "maskUnits"],
      ["numoctaves", "numOctaves"],
      ["pathlength", "pathLength"],
      ["patterncontentunits", "patternContentUnits"],
      ["patterntransform", "patternTransform"],
      ["patternunits", "patternUnits"],
      ["pointsatx", "pointsAtX"],
      ["pointsaty", "pointsAtY"],
      ["pointsatz", "pointsAtZ"],
      ["preservealpha", "preserveAlpha"],
      ["preserveaspectratio", "preserveAspectRatio"],
      ["primitiveunits", "primitiveUnits"],
      ["refx", "refX"],
      ["refy", "refY"],
      ["repeatcount", "repeatCount"],
      ["repeatdur", "repeatDur"],
      ["requiredextensions", "requiredExtensions"],
      ["requiredfeatures", "requiredFeatures"],
      ["specularconstant", "specularConstant"],
      ["specularexponent", "specularExponent"],
      ["spreadmethod", "spreadMethod"],
      ["startoffset", "startOffset"],
      ["stddeviation", "stdDeviation"],
      ["stitchtiles", "stitchTiles"],
      ["surfacescale", "surfaceScale"],
      ["systemlanguage", "systemLanguage"],
      ["tablevalues", "tableValues"],
      ["targetx", "targetX"],
      ["targety", "targetY"],
      ["textlength", "textLength"],
      ["viewbox", "viewBox"],
      ["viewtarget", "viewTarget"],
      ["xchannelselector", "xChannelSelector"],
      ["ychannelselector", "yChannelSelector"],
      ["zoomandpan", "zoomAndPan"]
    ]);
  }
});

// node_modules/.pnpm/dom-serializer@1.4.1/node_modules/dom-serializer/lib/index.js
var require_lib10 = __commonJS({
  "node_modules/.pnpm/dom-serializer@1.4.1/node_modules/dom-serializer/lib/index.js"(exports) {
    "use strict";
    var __assign = exports && exports.__assign || function() {
      __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p))
              t[p] = s[p];
        }
        return t;
      };
      return __assign.apply(this, arguments);
    };
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var ElementType = __importStar(require_lib7());
    var entities_1 = require_lib9();
    var foreignNames_1 = require_foreignNames();
    var unencodedElements = /* @__PURE__ */ new Set([
      "style",
      "script",
      "xmp",
      "iframe",
      "noembed",
      "noframes",
      "plaintext",
      "noscript"
    ]);
    function formatAttributes(attributes, opts) {
      if (!attributes)
        return;
      return Object.keys(attributes).map(function(key) {
        var _a, _b;
        var value = (_a = attributes[key]) !== null && _a !== void 0 ? _a : "";
        if (opts.xmlMode === "foreign") {
          key = (_b = foreignNames_1.attributeNames.get(key)) !== null && _b !== void 0 ? _b : key;
        }
        if (!opts.emptyAttrs && !opts.xmlMode && value === "") {
          return key;
        }
        return key + '="' + (opts.decodeEntities !== false ? entities_1.encodeXML(value) : value.replace(/"/g, "&quot;")) + '"';
      }).join(" ");
    }
    var singleTag = /* @__PURE__ */ new Set([
      "area",
      "base",
      "basefont",
      "br",
      "col",
      "command",
      "embed",
      "frame",
      "hr",
      "img",
      "input",
      "isindex",
      "keygen",
      "link",
      "meta",
      "param",
      "source",
      "track",
      "wbr"
    ]);
    function render(node, options) {
      if (options === void 0) {
        options = {};
      }
      var nodes = "length" in node ? node : [node];
      var output = "";
      for (var i = 0; i < nodes.length; i++) {
        output += renderNode(nodes[i], options);
      }
      return output;
    }
    exports.default = render;
    function renderNode(node, options) {
      switch (node.type) {
        case ElementType.Root:
          return render(node.children, options);
        case ElementType.Directive:
        case ElementType.Doctype:
          return renderDirective(node);
        case ElementType.Comment:
          return renderComment(node);
        case ElementType.CDATA:
          return renderCdata(node);
        case ElementType.Script:
        case ElementType.Style:
        case ElementType.Tag:
          return renderTag(node, options);
        case ElementType.Text:
          return renderText(node, options);
      }
    }
    var foreignModeIntegrationPoints = /* @__PURE__ */ new Set([
      "mi",
      "mo",
      "mn",
      "ms",
      "mtext",
      "annotation-xml",
      "foreignObject",
      "desc",
      "title"
    ]);
    var foreignElements = /* @__PURE__ */ new Set(["svg", "math"]);
    function renderTag(elem, opts) {
      var _a;
      if (opts.xmlMode === "foreign") {
        elem.name = (_a = foreignNames_1.elementNames.get(elem.name)) !== null && _a !== void 0 ? _a : elem.name;
        if (elem.parent && foreignModeIntegrationPoints.has(elem.parent.name)) {
          opts = __assign(__assign({}, opts), { xmlMode: false });
        }
      }
      if (!opts.xmlMode && foreignElements.has(elem.name)) {
        opts = __assign(__assign({}, opts), { xmlMode: "foreign" });
      }
      var tag = "<" + elem.name;
      var attribs = formatAttributes(elem.attribs, opts);
      if (attribs) {
        tag += " " + attribs;
      }
      if (elem.children.length === 0 && (opts.xmlMode ? opts.selfClosingTags !== false : opts.selfClosingTags && singleTag.has(elem.name))) {
        if (!opts.xmlMode)
          tag += " ";
        tag += "/>";
      } else {
        tag += ">";
        if (elem.children.length > 0) {
          tag += render(elem.children, opts);
        }
        if (opts.xmlMode || !singleTag.has(elem.name)) {
          tag += "</" + elem.name + ">";
        }
      }
      return tag;
    }
    function renderDirective(elem) {
      return "<" + elem.data + ">";
    }
    function renderText(elem, opts) {
      var data = elem.data || "";
      if (opts.decodeEntities !== false && !(!opts.xmlMode && elem.parent && unencodedElements.has(elem.parent.name))) {
        data = entities_1.encodeXML(data);
      }
      return data;
    }
    function renderCdata(elem) {
      return "<![CDATA[" + elem.children[0].data + "]]>";
    }
    function renderComment(elem) {
      return "<!--" + elem.data + "-->";
    }
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/stringify.js
var require_stringify = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/stringify.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.innerText = exports.textContent = exports.getText = exports.getInnerHTML = exports.getOuterHTML = void 0;
    var domhandler_1 = require_lib8();
    var dom_serializer_1 = __importDefault(require_lib10());
    var domelementtype_1 = require_lib7();
    function getOuterHTML(node, options) {
      return (0, dom_serializer_1.default)(node, options);
    }
    exports.getOuterHTML = getOuterHTML;
    function getInnerHTML(node, options) {
      return (0, domhandler_1.hasChildren)(node) ? node.children.map(function(node2) {
        return getOuterHTML(node2, options);
      }).join("") : "";
    }
    exports.getInnerHTML = getInnerHTML;
    function getText(node) {
      if (Array.isArray(node))
        return node.map(getText).join("");
      if ((0, domhandler_1.isTag)(node))
        return node.name === "br" ? "\n" : getText(node.children);
      if ((0, domhandler_1.isCDATA)(node))
        return getText(node.children);
      if ((0, domhandler_1.isText)(node))
        return node.data;
      return "";
    }
    exports.getText = getText;
    function textContent(node) {
      if (Array.isArray(node))
        return node.map(textContent).join("");
      if ((0, domhandler_1.hasChildren)(node) && !(0, domhandler_1.isComment)(node)) {
        return textContent(node.children);
      }
      if ((0, domhandler_1.isText)(node))
        return node.data;
      return "";
    }
    exports.textContent = textContent;
    function innerText(node) {
      if (Array.isArray(node))
        return node.map(innerText).join("");
      if ((0, domhandler_1.hasChildren)(node) && (node.type === domelementtype_1.ElementType.Tag || (0, domhandler_1.isCDATA)(node))) {
        return innerText(node.children);
      }
      if ((0, domhandler_1.isText)(node))
        return node.data;
      return "";
    }
    exports.innerText = innerText;
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/traversal.js
var require_traversal = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/traversal.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.prevElementSibling = exports.nextElementSibling = exports.getName = exports.hasAttrib = exports.getAttributeValue = exports.getSiblings = exports.getParent = exports.getChildren = void 0;
    var domhandler_1 = require_lib8();
    var emptyArray = [];
    function getChildren(elem) {
      var _a;
      return (_a = elem.children) !== null && _a !== void 0 ? _a : emptyArray;
    }
    exports.getChildren = getChildren;
    function getParent(elem) {
      return elem.parent || null;
    }
    exports.getParent = getParent;
    function getSiblings(elem) {
      var _a, _b;
      var parent = getParent(elem);
      if (parent != null)
        return getChildren(parent);
      var siblings = [elem];
      var prev = elem.prev, next = elem.next;
      while (prev != null) {
        siblings.unshift(prev);
        _a = prev, prev = _a.prev;
      }
      while (next != null) {
        siblings.push(next);
        _b = next, next = _b.next;
      }
      return siblings;
    }
    exports.getSiblings = getSiblings;
    function getAttributeValue(elem, name) {
      var _a;
      return (_a = elem.attribs) === null || _a === void 0 ? void 0 : _a[name];
    }
    exports.getAttributeValue = getAttributeValue;
    function hasAttrib(elem, name) {
      return elem.attribs != null && Object.prototype.hasOwnProperty.call(elem.attribs, name) && elem.attribs[name] != null;
    }
    exports.hasAttrib = hasAttrib;
    function getName(elem) {
      return elem.name;
    }
    exports.getName = getName;
    function nextElementSibling(elem) {
      var _a;
      var next = elem.next;
      while (next !== null && !(0, domhandler_1.isTag)(next))
        _a = next, next = _a.next;
      return next;
    }
    exports.nextElementSibling = nextElementSibling;
    function prevElementSibling(elem) {
      var _a;
      var prev = elem.prev;
      while (prev !== null && !(0, domhandler_1.isTag)(prev))
        _a = prev, prev = _a.prev;
      return prev;
    }
    exports.prevElementSibling = prevElementSibling;
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/manipulation.js
var require_manipulation = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/manipulation.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.prepend = exports.prependChild = exports.append = exports.appendChild = exports.replaceElement = exports.removeElement = void 0;
    function removeElement(elem) {
      if (elem.prev)
        elem.prev.next = elem.next;
      if (elem.next)
        elem.next.prev = elem.prev;
      if (elem.parent) {
        var childs = elem.parent.children;
        childs.splice(childs.lastIndexOf(elem), 1);
      }
    }
    exports.removeElement = removeElement;
    function replaceElement(elem, replacement) {
      var prev = replacement.prev = elem.prev;
      if (prev) {
        prev.next = replacement;
      }
      var next = replacement.next = elem.next;
      if (next) {
        next.prev = replacement;
      }
      var parent = replacement.parent = elem.parent;
      if (parent) {
        var childs = parent.children;
        childs[childs.lastIndexOf(elem)] = replacement;
      }
    }
    exports.replaceElement = replaceElement;
    function appendChild(elem, child) {
      removeElement(child);
      child.next = null;
      child.parent = elem;
      if (elem.children.push(child) > 1) {
        var sibling = elem.children[elem.children.length - 2];
        sibling.next = child;
        child.prev = sibling;
      } else {
        child.prev = null;
      }
    }
    exports.appendChild = appendChild;
    function append(elem, next) {
      removeElement(next);
      var parent = elem.parent;
      var currNext = elem.next;
      next.next = currNext;
      next.prev = elem;
      elem.next = next;
      next.parent = parent;
      if (currNext) {
        currNext.prev = next;
        if (parent) {
          var childs = parent.children;
          childs.splice(childs.lastIndexOf(currNext), 0, next);
        }
      } else if (parent) {
        parent.children.push(next);
      }
    }
    exports.append = append;
    function prependChild(elem, child) {
      removeElement(child);
      child.parent = elem;
      child.prev = null;
      if (elem.children.unshift(child) !== 1) {
        var sibling = elem.children[1];
        sibling.prev = child;
        child.next = sibling;
      } else {
        child.next = null;
      }
    }
    exports.prependChild = prependChild;
    function prepend(elem, prev) {
      removeElement(prev);
      var parent = elem.parent;
      if (parent) {
        var childs = parent.children;
        childs.splice(childs.indexOf(elem), 0, prev);
      }
      if (elem.prev) {
        elem.prev.next = prev;
      }
      prev.parent = parent;
      prev.prev = elem.prev;
      prev.next = elem;
      elem.prev = prev;
    }
    exports.prepend = prepend;
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/querying.js
var require_querying = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/querying.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.findAll = exports.existsOne = exports.findOne = exports.findOneChild = exports.find = exports.filter = void 0;
    var domhandler_1 = require_lib8();
    function filter(test, node, recurse, limit) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (limit === void 0) {
        limit = Infinity;
      }
      if (!Array.isArray(node))
        node = [node];
      return find(test, node, recurse, limit);
    }
    exports.filter = filter;
    function find(test, nodes, recurse, limit) {
      var result2 = [];
      for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
        var elem = nodes_1[_i];
        if (test(elem)) {
          result2.push(elem);
          if (--limit <= 0)
            break;
        }
        if (recurse && (0, domhandler_1.hasChildren)(elem) && elem.children.length > 0) {
          var children = find(test, elem.children, recurse, limit);
          result2.push.apply(result2, children);
          limit -= children.length;
          if (limit <= 0)
            break;
        }
      }
      return result2;
    }
    exports.find = find;
    function findOneChild(test, nodes) {
      return nodes.find(test);
    }
    exports.findOneChild = findOneChild;
    function findOne(test, nodes, recurse) {
      if (recurse === void 0) {
        recurse = true;
      }
      var elem = null;
      for (var i = 0; i < nodes.length && !elem; i++) {
        var checked = nodes[i];
        if (!(0, domhandler_1.isTag)(checked)) {
          continue;
        } else if (test(checked)) {
          elem = checked;
        } else if (recurse && checked.children.length > 0) {
          elem = findOne(test, checked.children);
        }
      }
      return elem;
    }
    exports.findOne = findOne;
    function existsOne(test, nodes) {
      return nodes.some(function(checked) {
        return (0, domhandler_1.isTag)(checked) && (test(checked) || checked.children.length > 0 && existsOne(test, checked.children));
      });
    }
    exports.existsOne = existsOne;
    function findAll(test, nodes) {
      var _a;
      var result2 = [];
      var stack = nodes.filter(domhandler_1.isTag);
      var elem;
      while (elem = stack.shift()) {
        var children = (_a = elem.children) === null || _a === void 0 ? void 0 : _a.filter(domhandler_1.isTag);
        if (children && children.length > 0) {
          stack.unshift.apply(stack, children);
        }
        if (test(elem))
          result2.push(elem);
      }
      return result2;
    }
    exports.findAll = findAll;
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/legacy.js
var require_legacy2 = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/legacy.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getElementsByTagType = exports.getElementsByTagName = exports.getElementById = exports.getElements = exports.testElement = void 0;
    var domhandler_1 = require_lib8();
    var querying_1 = require_querying();
    var Checks = {
      tag_name: function(name) {
        if (typeof name === "function") {
          return function(elem) {
            return (0, domhandler_1.isTag)(elem) && name(elem.name);
          };
        } else if (name === "*") {
          return domhandler_1.isTag;
        }
        return function(elem) {
          return (0, domhandler_1.isTag)(elem) && elem.name === name;
        };
      },
      tag_type: function(type2) {
        if (typeof type2 === "function") {
          return function(elem) {
            return type2(elem.type);
          };
        }
        return function(elem) {
          return elem.type === type2;
        };
      },
      tag_contains: function(data) {
        if (typeof data === "function") {
          return function(elem) {
            return (0, domhandler_1.isText)(elem) && data(elem.data);
          };
        }
        return function(elem) {
          return (0, domhandler_1.isText)(elem) && elem.data === data;
        };
      }
    };
    function getAttribCheck(attrib, value) {
      if (typeof value === "function") {
        return function(elem) {
          return (0, domhandler_1.isTag)(elem) && value(elem.attribs[attrib]);
        };
      }
      return function(elem) {
        return (0, domhandler_1.isTag)(elem) && elem.attribs[attrib] === value;
      };
    }
    function combineFuncs(a, b) {
      return function(elem) {
        return a(elem) || b(elem);
      };
    }
    function compileTest(options) {
      var funcs = Object.keys(options).map(function(key) {
        var value = options[key];
        return Object.prototype.hasOwnProperty.call(Checks, key) ? Checks[key](value) : getAttribCheck(key, value);
      });
      return funcs.length === 0 ? null : funcs.reduce(combineFuncs);
    }
    function testElement(options, node) {
      var test = compileTest(options);
      return test ? test(node) : true;
    }
    exports.testElement = testElement;
    function getElements(options, nodes, recurse, limit) {
      if (limit === void 0) {
        limit = Infinity;
      }
      var test = compileTest(options);
      return test ? (0, querying_1.filter)(test, nodes, recurse, limit) : [];
    }
    exports.getElements = getElements;
    function getElementById(id, nodes, recurse) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (!Array.isArray(nodes))
        nodes = [nodes];
      return (0, querying_1.findOne)(getAttribCheck("id", id), nodes, recurse);
    }
    exports.getElementById = getElementById;
    function getElementsByTagName(tagName, nodes, recurse, limit) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (limit === void 0) {
        limit = Infinity;
      }
      return (0, querying_1.filter)(Checks.tag_name(tagName), nodes, recurse, limit);
    }
    exports.getElementsByTagName = getElementsByTagName;
    function getElementsByTagType(type2, nodes, recurse, limit) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (limit === void 0) {
        limit = Infinity;
      }
      return (0, querying_1.filter)(Checks.tag_type(type2), nodes, recurse, limit);
    }
    exports.getElementsByTagType = getElementsByTagType;
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/helpers.js
var require_helpers = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/helpers.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.uniqueSort = exports.compareDocumentPosition = exports.removeSubsets = void 0;
    var domhandler_1 = require_lib8();
    function removeSubsets(nodes) {
      var idx2 = nodes.length;
      while (--idx2 >= 0) {
        var node = nodes[idx2];
        if (idx2 > 0 && nodes.lastIndexOf(node, idx2 - 1) >= 0) {
          nodes.splice(idx2, 1);
          continue;
        }
        for (var ancestor = node.parent; ancestor; ancestor = ancestor.parent) {
          if (nodes.includes(ancestor)) {
            nodes.splice(idx2, 1);
            break;
          }
        }
      }
      return nodes;
    }
    exports.removeSubsets = removeSubsets;
    function compareDocumentPosition(nodeA, nodeB) {
      var aParents = [];
      var bParents = [];
      if (nodeA === nodeB) {
        return 0;
      }
      var current = (0, domhandler_1.hasChildren)(nodeA) ? nodeA : nodeA.parent;
      while (current) {
        aParents.unshift(current);
        current = current.parent;
      }
      current = (0, domhandler_1.hasChildren)(nodeB) ? nodeB : nodeB.parent;
      while (current) {
        bParents.unshift(current);
        current = current.parent;
      }
      var maxIdx = Math.min(aParents.length, bParents.length);
      var idx2 = 0;
      while (idx2 < maxIdx && aParents[idx2] === bParents[idx2]) {
        idx2++;
      }
      if (idx2 === 0) {
        return 1;
      }
      var sharedParent = aParents[idx2 - 1];
      var siblings = sharedParent.children;
      var aSibling = aParents[idx2];
      var bSibling = bParents[idx2];
      if (siblings.indexOf(aSibling) > siblings.indexOf(bSibling)) {
        if (sharedParent === nodeB) {
          return 4 | 16;
        }
        return 4;
      }
      if (sharedParent === nodeA) {
        return 2 | 8;
      }
      return 2;
    }
    exports.compareDocumentPosition = compareDocumentPosition;
    function uniqueSort(nodes) {
      nodes = nodes.filter(function(node, i, arr) {
        return !arr.includes(node, i + 1);
      });
      nodes.sort(function(a, b) {
        var relative = compareDocumentPosition(a, b);
        if (relative & 2) {
          return -1;
        } else if (relative & 4) {
          return 1;
        }
        return 0;
      });
      return nodes;
    }
    exports.uniqueSort = uniqueSort;
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/feeds.js
var require_feeds = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/feeds.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getFeed = void 0;
    var stringify_1 = require_stringify();
    var legacy_1 = require_legacy2();
    function getFeed(doc) {
      var feedRoot = getOneElement(isValidFeed, doc);
      return !feedRoot ? null : feedRoot.name === "feed" ? getAtomFeed(feedRoot) : getRssFeed(feedRoot);
    }
    exports.getFeed = getFeed;
    function getAtomFeed(feedRoot) {
      var _a;
      var childs = feedRoot.children;
      var feed = {
        type: "atom",
        items: (0, legacy_1.getElementsByTagName)("entry", childs).map(function(item) {
          var _a2;
          var children = item.children;
          var entry = { media: getMediaElements(children) };
          addConditionally(entry, "id", "id", children);
          addConditionally(entry, "title", "title", children);
          var href2 = (_a2 = getOneElement("link", children)) === null || _a2 === void 0 ? void 0 : _a2.attribs.href;
          if (href2) {
            entry.link = href2;
          }
          var description = fetch("summary", children) || fetch("content", children);
          if (description) {
            entry.description = description;
          }
          var pubDate = fetch("updated", children);
          if (pubDate) {
            entry.pubDate = new Date(pubDate);
          }
          return entry;
        })
      };
      addConditionally(feed, "id", "id", childs);
      addConditionally(feed, "title", "title", childs);
      var href = (_a = getOneElement("link", childs)) === null || _a === void 0 ? void 0 : _a.attribs.href;
      if (href) {
        feed.link = href;
      }
      addConditionally(feed, "description", "subtitle", childs);
      var updated = fetch("updated", childs);
      if (updated) {
        feed.updated = new Date(updated);
      }
      addConditionally(feed, "author", "email", childs, true);
      return feed;
    }
    function getRssFeed(feedRoot) {
      var _a, _b;
      var childs = (_b = (_a = getOneElement("channel", feedRoot.children)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : [];
      var feed = {
        type: feedRoot.name.substr(0, 3),
        id: "",
        items: (0, legacy_1.getElementsByTagName)("item", feedRoot.children).map(function(item) {
          var children = item.children;
          var entry = { media: getMediaElements(children) };
          addConditionally(entry, "id", "guid", children);
          addConditionally(entry, "title", "title", children);
          addConditionally(entry, "link", "link", children);
          addConditionally(entry, "description", "description", children);
          var pubDate = fetch("pubDate", children);
          if (pubDate)
            entry.pubDate = new Date(pubDate);
          return entry;
        })
      };
      addConditionally(feed, "title", "title", childs);
      addConditionally(feed, "link", "link", childs);
      addConditionally(feed, "description", "description", childs);
      var updated = fetch("lastBuildDate", childs);
      if (updated) {
        feed.updated = new Date(updated);
      }
      addConditionally(feed, "author", "managingEditor", childs, true);
      return feed;
    }
    var MEDIA_KEYS_STRING = ["url", "type", "lang"];
    var MEDIA_KEYS_INT = [
      "fileSize",
      "bitrate",
      "framerate",
      "samplingrate",
      "channels",
      "duration",
      "height",
      "width"
    ];
    function getMediaElements(where) {
      return (0, legacy_1.getElementsByTagName)("media:content", where).map(function(elem) {
        var attribs = elem.attribs;
        var media = {
          medium: attribs.medium,
          isDefault: !!attribs.isDefault
        };
        for (var _i = 0, MEDIA_KEYS_STRING_1 = MEDIA_KEYS_STRING; _i < MEDIA_KEYS_STRING_1.length; _i++) {
          var attrib = MEDIA_KEYS_STRING_1[_i];
          if (attribs[attrib]) {
            media[attrib] = attribs[attrib];
          }
        }
        for (var _a = 0, MEDIA_KEYS_INT_1 = MEDIA_KEYS_INT; _a < MEDIA_KEYS_INT_1.length; _a++) {
          var attrib = MEDIA_KEYS_INT_1[_a];
          if (attribs[attrib]) {
            media[attrib] = parseInt(attribs[attrib], 10);
          }
        }
        if (attribs.expression) {
          media.expression = attribs.expression;
        }
        return media;
      });
    }
    function getOneElement(tagName, node) {
      return (0, legacy_1.getElementsByTagName)(tagName, node, true, 1)[0];
    }
    function fetch(tagName, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      return (0, stringify_1.textContent)((0, legacy_1.getElementsByTagName)(tagName, where, recurse, 1)).trim();
    }
    function addConditionally(obj, prop, tagName, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      var val = fetch(tagName, where, recurse);
      if (val)
        obj[prop] = val;
    }
    function isValidFeed(value) {
      return value === "rss" || value === "feed" || value === "rdf:RDF";
    }
  }
});

// node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/index.js
var require_lib11 = __commonJS({
  "node_modules/.pnpm/domutils@2.8.0/node_modules/domutils/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.hasChildren = exports.isDocument = exports.isComment = exports.isText = exports.isCDATA = exports.isTag = void 0;
    __exportStar(require_stringify(), exports);
    __exportStar(require_traversal(), exports);
    __exportStar(require_manipulation(), exports);
    __exportStar(require_querying(), exports);
    __exportStar(require_legacy2(), exports);
    __exportStar(require_helpers(), exports);
    __exportStar(require_feeds(), exports);
    var domhandler_1 = require_lib8();
    Object.defineProperty(exports, "isTag", { enumerable: true, get: function() {
      return domhandler_1.isTag;
    } });
    Object.defineProperty(exports, "isCDATA", { enumerable: true, get: function() {
      return domhandler_1.isCDATA;
    } });
    Object.defineProperty(exports, "isText", { enumerable: true, get: function() {
      return domhandler_1.isText;
    } });
    Object.defineProperty(exports, "isComment", { enumerable: true, get: function() {
      return domhandler_1.isComment;
    } });
    Object.defineProperty(exports, "isDocument", { enumerable: true, get: function() {
      return domhandler_1.isDocument;
    } });
    Object.defineProperty(exports, "hasChildren", { enumerable: true, get: function() {
      return domhandler_1.hasChildren;
    } });
  }
});

// node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/FeedHandler.js
var require_FeedHandler = __commonJS({
  "node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/FeedHandler.js"(exports) {
    "use strict";
    var __extends = exports && exports.__extends || function() {
      var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
          d2.__proto__ = b2;
        } || function(d2, b2) {
          for (var p in b2)
            if (Object.prototype.hasOwnProperty.call(b2, p))
              d2[p] = b2[p];
        };
        return extendStatics(d, b);
      };
      return function(d, b) {
        if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() {
          this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
      };
    }();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.parseFeed = exports.FeedHandler = void 0;
    var domhandler_1 = __importDefault(require_lib8());
    var DomUtils = __importStar(require_lib11());
    var Parser_1 = require_Parser();
    var FeedItemMediaMedium;
    (function(FeedItemMediaMedium2) {
      FeedItemMediaMedium2[FeedItemMediaMedium2["image"] = 0] = "image";
      FeedItemMediaMedium2[FeedItemMediaMedium2["audio"] = 1] = "audio";
      FeedItemMediaMedium2[FeedItemMediaMedium2["video"] = 2] = "video";
      FeedItemMediaMedium2[FeedItemMediaMedium2["document"] = 3] = "document";
      FeedItemMediaMedium2[FeedItemMediaMedium2["executable"] = 4] = "executable";
    })(FeedItemMediaMedium || (FeedItemMediaMedium = {}));
    var FeedItemMediaExpression;
    (function(FeedItemMediaExpression2) {
      FeedItemMediaExpression2[FeedItemMediaExpression2["sample"] = 0] = "sample";
      FeedItemMediaExpression2[FeedItemMediaExpression2["full"] = 1] = "full";
      FeedItemMediaExpression2[FeedItemMediaExpression2["nonstop"] = 2] = "nonstop";
    })(FeedItemMediaExpression || (FeedItemMediaExpression = {}));
    var FeedHandler = function(_super) {
      __extends(FeedHandler2, _super);
      function FeedHandler2(callback, options) {
        var _this = this;
        if (typeof callback === "object") {
          callback = void 0;
          options = callback;
        }
        _this = _super.call(this, callback, options) || this;
        return _this;
      }
      FeedHandler2.prototype.onend = function() {
        var _a, _b;
        var feedRoot = getOneElement(isValidFeed, this.dom);
        if (!feedRoot) {
          this.handleCallback(new Error("couldn't find root of feed"));
          return;
        }
        var feed = {};
        if (feedRoot.name === "feed") {
          var childs = feedRoot.children;
          feed.type = "atom";
          addConditionally(feed, "id", "id", childs);
          addConditionally(feed, "title", "title", childs);
          var href = getAttribute("href", getOneElement("link", childs));
          if (href) {
            feed.link = href;
          }
          addConditionally(feed, "description", "subtitle", childs);
          var updated = fetch("updated", childs);
          if (updated) {
            feed.updated = new Date(updated);
          }
          addConditionally(feed, "author", "email", childs, true);
          feed.items = getElements("entry", childs).map(function(item) {
            var entry = {};
            var children = item.children;
            addConditionally(entry, "id", "id", children);
            addConditionally(entry, "title", "title", children);
            var href2 = getAttribute("href", getOneElement("link", children));
            if (href2) {
              entry.link = href2;
            }
            var description = fetch("summary", children) || fetch("content", children);
            if (description) {
              entry.description = description;
            }
            var pubDate = fetch("updated", children);
            if (pubDate) {
              entry.pubDate = new Date(pubDate);
            }
            entry.media = getMediaElements(children);
            return entry;
          });
        } else {
          var childs = (_b = (_a = getOneElement("channel", feedRoot.children)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : [];
          feed.type = feedRoot.name.substr(0, 3);
          feed.id = "";
          addConditionally(feed, "title", "title", childs);
          addConditionally(feed, "link", "link", childs);
          addConditionally(feed, "description", "description", childs);
          var updated = fetch("lastBuildDate", childs);
          if (updated) {
            feed.updated = new Date(updated);
          }
          addConditionally(feed, "author", "managingEditor", childs, true);
          feed.items = getElements("item", feedRoot.children).map(function(item) {
            var entry = {};
            var children = item.children;
            addConditionally(entry, "id", "guid", children);
            addConditionally(entry, "title", "title", children);
            addConditionally(entry, "link", "link", children);
            addConditionally(entry, "description", "description", children);
            var pubDate = fetch("pubDate", children);
            if (pubDate)
              entry.pubDate = new Date(pubDate);
            entry.media = getMediaElements(children);
            return entry;
          });
        }
        this.feed = feed;
        this.handleCallback(null);
      };
      return FeedHandler2;
    }(domhandler_1.default);
    exports.FeedHandler = FeedHandler;
    function getMediaElements(where) {
      return getElements("media:content", where).map(function(elem) {
        var media = {
          medium: elem.attribs.medium,
          isDefault: !!elem.attribs.isDefault
        };
        if (elem.attribs.url) {
          media.url = elem.attribs.url;
        }
        if (elem.attribs.fileSize) {
          media.fileSize = parseInt(elem.attribs.fileSize, 10);
        }
        if (elem.attribs.type) {
          media.type = elem.attribs.type;
        }
        if (elem.attribs.expression) {
          media.expression = elem.attribs.expression;
        }
        if (elem.attribs.bitrate) {
          media.bitrate = parseInt(elem.attribs.bitrate, 10);
        }
        if (elem.attribs.framerate) {
          media.framerate = parseInt(elem.attribs.framerate, 10);
        }
        if (elem.attribs.samplingrate) {
          media.samplingrate = parseInt(elem.attribs.samplingrate, 10);
        }
        if (elem.attribs.channels) {
          media.channels = parseInt(elem.attribs.channels, 10);
        }
        if (elem.attribs.duration) {
          media.duration = parseInt(elem.attribs.duration, 10);
        }
        if (elem.attribs.height) {
          media.height = parseInt(elem.attribs.height, 10);
        }
        if (elem.attribs.width) {
          media.width = parseInt(elem.attribs.width, 10);
        }
        if (elem.attribs.lang) {
          media.lang = elem.attribs.lang;
        }
        return media;
      });
    }
    function getElements(tagName, where) {
      return DomUtils.getElementsByTagName(tagName, where, true);
    }
    function getOneElement(tagName, node) {
      return DomUtils.getElementsByTagName(tagName, node, true, 1)[0];
    }
    function fetch(tagName, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      return DomUtils.getText(DomUtils.getElementsByTagName(tagName, where, recurse, 1)).trim();
    }
    function getAttribute(name, elem) {
      if (!elem) {
        return null;
      }
      var attribs = elem.attribs;
      return attribs[name];
    }
    function addConditionally(obj, prop, what, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      var tmp = fetch(what, where, recurse);
      if (tmp)
        obj[prop] = tmp;
    }
    function isValidFeed(value) {
      return value === "rss" || value === "feed" || value === "rdf:RDF";
    }
    function parseFeed(feed, options) {
      if (options === void 0) {
        options = { xmlMode: true };
      }
      var handler = new FeedHandler(options);
      new Parser_1.Parser(handler, options).end(feed);
      return handler.feed;
    }
    exports.parseFeed = parseFeed;
  }
});

// node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/index.js
var require_lib12 = __commonJS({
  "node_modules/.pnpm/htmlparser2@6.1.0/node_modules/htmlparser2/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.RssHandler = exports.DefaultHandler = exports.DomUtils = exports.ElementType = exports.Tokenizer = exports.createDomStream = exports.parseDOM = exports.parseDocument = exports.DomHandler = exports.Parser = void 0;
    var Parser_1 = require_Parser();
    Object.defineProperty(exports, "Parser", { enumerable: true, get: function() {
      return Parser_1.Parser;
    } });
    var domhandler_1 = require_lib8();
    Object.defineProperty(exports, "DomHandler", { enumerable: true, get: function() {
      return domhandler_1.DomHandler;
    } });
    Object.defineProperty(exports, "DefaultHandler", { enumerable: true, get: function() {
      return domhandler_1.DomHandler;
    } });
    function parseDocument(data, options) {
      var handler = new domhandler_1.DomHandler(void 0, options);
      new Parser_1.Parser(handler, options).end(data);
      return handler.root;
    }
    exports.parseDocument = parseDocument;
    function parseDOM(data, options) {
      return parseDocument(data, options).children;
    }
    exports.parseDOM = parseDOM;
    function createDomStream(cb, options, elementCb) {
      var handler = new domhandler_1.DomHandler(cb, options, elementCb);
      return new Parser_1.Parser(handler, options);
    }
    exports.createDomStream = createDomStream;
    var Tokenizer_1 = require_Tokenizer();
    Object.defineProperty(exports, "Tokenizer", { enumerable: true, get: function() {
      return __importDefault(Tokenizer_1).default;
    } });
    var ElementType = __importStar(require_lib7());
    exports.ElementType = ElementType;
    __exportStar(require_FeedHandler(), exports);
    exports.DomUtils = __importStar(require_lib11());
    var FeedHandler_1 = require_FeedHandler();
    Object.defineProperty(exports, "RssHandler", { enumerable: true, get: function() {
      return FeedHandler_1.FeedHandler;
    } });
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/array.js
var require_array4 = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/array.js"(exports, module2) {
    var array;
    module2.exports = array = {
      from: function(r) {
        return Array.prototype.slice.call(r);
      },
      simpleClone: function(a) {
        return a.slice(0);
      },
      shallowEqual: function(a1, a2) {
        var i, val, _i, _len;
        if (!(Array.isArray(a1) && Array.isArray(a2) && a1.length === a2.length)) {
          return false;
        }
        for (i = _i = 0, _len = a1.length; _i < _len; i = ++_i) {
          val = a1[i];
          if (a2[i] !== val) {
            return false;
          }
        }
        return true;
      },
      pluck: function(a, i) {
        var index, value, _i, _len;
        if (a.length < 1) {
          return a;
        }
        for (index = _i = 0, _len = a.length; _i < _len; index = ++_i) {
          value = a[index];
          if (index > i) {
            a[index - 1] = a[index];
          }
        }
        a.length = a.length - 1;
        return a;
      },
      pluckItem: function(a, item) {
        var index, removed, value, _i, _len;
        if (a.length < 1) {
          return a;
        }
        removed = 0;
        for (index = _i = 0, _len = a.length; _i < _len; index = ++_i) {
          value = a[index];
          if (value === item) {
            removed++;
            continue;
          }
          if (removed !== 0) {
            a[index - removed] = a[index];
          }
        }
        if (removed > 0) {
          a.length = a.length - removed;
        }
        return a;
      },
      pluckOneItem: function(a, item) {
        var index, reached, value, _i, _len;
        if (a.length < 1) {
          return a;
        }
        reached = false;
        for (index = _i = 0, _len = a.length; _i < _len; index = ++_i) {
          value = a[index];
          if (!reached) {
            if (value === item) {
              reached = true;
              continue;
            }
          } else {
            a[index - 1] = a[index];
          }
        }
        if (reached) {
          a.length = a.length - 1;
        }
        return a;
      },
      pluckByCallback: function(a, cb) {
        var index, removed, value, _i, _len;
        if (a.length < 1) {
          return a;
        }
        removed = 0;
        for (index = _i = 0, _len = a.length; _i < _len; index = ++_i) {
          value = a[index];
          if (cb(value, index)) {
            removed++;
            continue;
          }
          if (removed !== 0) {
            a[index - removed] = a[index];
          }
        }
        if (removed > 0) {
          a.length = a.length - removed;
        }
        return a;
      },
      pluckMultiple: function(array2, indexesToRemove) {
        var i, removedSoFar, _i, _len;
        if (array2.length < 1) {
          return array2;
        }
        removedSoFar = 0;
        indexesToRemove.sort();
        for (_i = 0, _len = indexesToRemove.length; _i < _len; _i++) {
          i = indexesToRemove[_i];
          this.pluck(array2, i - removedSoFar);
          removedSoFar++;
        }
        return array2;
      },
      injectByCallback: function(a, toInject, shouldInject) {
        var i, len, val, valA, valB, _i, _len;
        valA = null;
        valB = null;
        len = a.length;
        if (len < 1) {
          a.push(toInject);
          return a;
        }
        for (i = _i = 0, _len = a.length; _i < _len; i = ++_i) {
          val = a[i];
          valA = valB;
          valB = val;
          if (shouldInject(valA, valB, toInject)) {
            return a.splice(i, 0, toInject);
          }
        }
        a.push(toInject);
        return a;
      },
      injectInIndex: function(a, index, toInject) {
        var i, len, toPut, toPutNext;
        len = a.length;
        i = index;
        if (len < 1) {
          a.push(toInject);
          return a;
        }
        toPut = toInject;
        toPutNext = null;
        for (; i <= len; i++) {
          toPutNext = a[i];
          a[i] = toPut;
          toPut = toPutNext;
        }
        ;
        return null;
      }
    };
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/classic.js
var require_classic = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/classic.js"(exports, module2) {
    var classic;
    var __slice = [].slice;
    module2.exports = classic = {};
    classic.implement = function() {
      var classProto, classReference, desc, member, mixin, mixins, _i, _j, _len;
      mixins = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), classReference = arguments[_i++];
      for (_j = 0, _len = mixins.length; _j < _len; _j++) {
        mixin = mixins[_j];
        classProto = classReference.prototype;
        for (member in mixin.prototype) {
          if (!Object.getOwnPropertyDescriptor(classProto, member)) {
            desc = Object.getOwnPropertyDescriptor(mixin.prototype, member);
            Object.defineProperty(classProto, member, desc);
          }
        }
      }
      return classReference;
    };
    classic.mix = function() {
      var classProto, classReference, desc, member, mixin, mixins, _i, _j, _len;
      mixins = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), classReference = arguments[_i++];
      classProto = classReference.prototype;
      classReference.__mixinCloners = [];
      classReference.__applyClonersFor = function(instance, args) {
        var cloner, _j2, _len2, _ref;
        if (args == null) {
          args = null;
        }
        _ref = classReference.__mixinCloners;
        for (_j2 = 0, _len2 = _ref.length; _j2 < _len2; _j2++) {
          cloner = _ref[_j2];
          cloner.apply(instance, args);
        }
      };
      classReference.__mixinInitializers = [];
      classReference.__initMixinsFor = function(instance, args) {
        var initializer, _j2, _len2, _ref;
        if (args == null) {
          args = null;
        }
        _ref = classReference.__mixinInitializers;
        for (_j2 = 0, _len2 = _ref.length; _j2 < _len2; _j2++) {
          initializer = _ref[_j2];
          initializer.apply(instance, args);
        }
      };
      classReference.__mixinQuitters = [];
      classReference.__applyQuittersFor = function(instance, args) {
        var quitter, _j2, _len2, _ref;
        if (args == null) {
          args = null;
        }
        _ref = classReference.__mixinQuitters;
        for (_j2 = 0, _len2 = _ref.length; _j2 < _len2; _j2++) {
          quitter = _ref[_j2];
          quitter.apply(instance, args);
        }
      };
      for (_j = 0, _len = mixins.length; _j < _len; _j++) {
        mixin = mixins[_j];
        if (!(mixin.constructor instanceof Function)) {
          throw Error("Mixin should be a function");
        }
        for (member in mixin.prototype) {
          if (member.substr(0, 11) === "__initMixin") {
            classReference.__mixinInitializers.push(mixin.prototype[member]);
            continue;
          } else if (member.substr(0, 11) === "__clonerFor") {
            classReference.__mixinCloners.push(mixin.prototype[member]);
            continue;
          } else if (member.substr(0, 12) === "__quitterFor") {
            classReference.__mixinQuitters.push(mixin.prototype[member]);
            continue;
          }
          if (!Object.getOwnPropertyDescriptor(classProto, member)) {
            desc = Object.getOwnPropertyDescriptor(mixin.prototype, member);
            Object.defineProperty(classProto, member, desc);
          }
        }
      }
      return classReference;
    };
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/_common.js
var require_common = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/_common.js"(exports, module2) {
    var common2;
    module2.exports = common2 = {
      isBareObject: function(o) {
        if (o != null && o.constructor === Object) {
          return true;
        }
        return false;
      },
      typeOf: function(item) {
        var _ref;
        if (item === null) {
          return "null";
        }
        if (typeof item !== "object") {
          return typeof item;
        }
        if (Array.isArray(item)) {
          return "array";
        }
        if (item.nodeName) {
          if (item.nodeType === 1) {
            return "element";
          }
          if (item.nodeType === 3) {
            return (_ref = /\S/.test(item.nodeValue)) != null ? _ref : {
              "textnode": "whitespace"
            };
          }
        } else if (typeof item.length === "number") {
          if (item.callee) {
            return "arguments";
          }
        }
        return typeof item;
      },
      clone: function(item, includePrototype) {
        if (includePrototype == null) {
          includePrototype = false;
        }
        switch (common2.typeOf(item)) {
          case "array":
            return common2._cloneArray(item, includePrototype);
          case "object":
            return common2._cloneObject(item, includePrototype);
          default:
            return item;
        }
      },
      _cloneObject: function(o, includePrototype) {
        var clone, key;
        if (includePrototype == null) {
          includePrototype = false;
        }
        if (common2.isBareObject(o)) {
          clone = {};
          for (key in o) {
            clone[key] = common2.clone(o[key], includePrototype);
          }
          return clone;
        } else {
          if (!includePrototype) {
            return o;
          }
          if (o instanceof Function) {
            return o;
          }
          clone = Object.create(o.constructor.prototype);
          for (key in o) {
            if (o.hasOwnProperty(key)) {
              clone[key] = common2.clone(o[key], includePrototype);
            }
          }
          return clone;
        }
      },
      _cloneArray: function(a, includePrototype) {
        var clone, i;
        if (includePrototype == null) {
          includePrototype = false;
        }
        i = a.length;
        clone = new Array(i);
        while (i--) {
          clone[i] = common2.clone(a[i], includePrototype);
        }
        return clone;
      }
    };
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/object.js
var require_object2 = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/object.js"(exports, module2) {
    var object2;
    var _common;
    var __hasProp = {}.hasOwnProperty;
    _common = require_common();
    module2.exports = object2 = {
      isBareObject: _common.isBareObject.bind(_common),
      isInstance: function(what) {
        return !this.isBareObject(what);
      },
      typeOf: _common.typeOf.bind(_common),
      clone: _common.clone.bind(_common),
      empty: function(o) {
        var prop;
        for (prop in o) {
          if (o.hasOwnProperty(prop)) {
            delete o[prop];
          }
        }
        return o;
      },
      fastEmpty: function(o) {
        var property;
        for (property in o) {
          delete o[property];
        }
        return o;
      },
      overrideOnto: function(base, newValues) {
        var key, newVal, oldVal;
        if (!this.isBareObject(newValues) || !this.isBareObject(base)) {
          return base;
        }
        for (key in base) {
          oldVal = base[key];
          newVal = newValues[key];
          if (newVal === void 0) {
            continue;
          }
          if (typeof newVal !== "object" || this.isInstance(newVal)) {
            base[key] = this.clone(newVal);
          } else {
            if (typeof oldVal !== "object" || this.isInstance(oldVal)) {
              base[key] = this.clone(newVal);
            } else {
              this.overrideOnto(oldVal, newVal);
            }
          }
        }
        return base;
      },
      override: function(base, newValues) {
        return this.overrideOnto(this.clone(base), newValues);
      },
      append: function(base, toAppend) {
        return this.appendOnto(this.clone(base), toAppend);
      },
      appendOnto: function(base, toAppend) {
        var key, newVal, oldVal;
        if (!this.isBareObject(toAppend) || !this.isBareObject(base)) {
          return base;
        }
        for (key in toAppend) {
          if (!__hasProp.call(toAppend, key))
            continue;
          newVal = toAppend[key];
          if (newVal === void 0) {
            continue;
          }
          if (typeof newVal !== "object" || this.isInstance(newVal)) {
            base[key] = newVal;
          } else {
            oldVal = base[key];
            if (typeof oldVal !== "object" || this.isInstance(oldVal)) {
              base[key] = this.clone(newVal);
            } else {
              this.appendOnto(oldVal, newVal);
            }
          }
        }
        return base;
      },
      groupProps: function(obj, groups) {
        var def, defs, grouped, key, name, shouldAdd, val, _i, _len;
        grouped = {};
        for (name in groups) {
          defs = groups[name];
          grouped[name] = {};
        }
        grouped["rest"] = {};
        top:
          for (key in obj) {
            val = obj[key];
            shouldAdd = false;
            for (name in groups) {
              defs = groups[name];
              if (!Array.isArray(defs)) {
                defs = [defs];
              }
              for (_i = 0, _len = defs.length; _i < _len; _i++) {
                def = defs[_i];
                if (typeof def === "string") {
                  if (key === def) {
                    shouldAdd = true;
                  }
                } else if (def instanceof RegExp) {
                  if (def.test(key)) {
                    shouldAdd = true;
                  }
                } else if (def instanceof Function) {
                  if (def(key)) {
                    shouldAdd = true;
                  }
                } else {
                  throw Error("Group definitions must either						be strings, regexes, or functions.");
                }
                if (shouldAdd) {
                  grouped[name][key] = val;
                  continue top;
                }
              }
            }
            grouped["rest"][key] = val;
          }
        return grouped;
      }
    };
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/string.js
var require_string4 = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/string.js"(exports, module2) {
    module2.exports = {
      pad: function(n, width, z) {
        if (z == null) {
          z = "0";
        }
        n = n + "";
        if (n.length >= width) {
          return n;
        } else {
          return new Array(width - n.length + 1).join(z) + n;
        }
      }
    };
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/Emitter.js
var require_Emitter = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/Emitter.js"(exports, module2) {
    var Emitter;
    var array;
    array = require_array4();
    module2.exports = Emitter = function() {
      function Emitter2() {
        this._listeners = {};
        this._listenersForAnyEvent = [];
        this._disabledEmitters = {};
      }
      Emitter2.prototype.on = function(eventName, listener) {
        if (this._listeners[eventName] == null) {
          this._listeners[eventName] = [];
        }
        this._listeners[eventName].push(listener);
        return this;
      };
      Emitter2.prototype.once = function(eventName, listener) {
        var cb, ran, _this = this;
        ran = false;
        cb = function() {
          if (ran) {
            return;
          }
          ran = true;
          listener();
          return setTimeout(function() {
            return _this.removeEvent(eventName, cb);
          }, 0);
        };
        this.on(eventName, cb);
        return this;
      };
      Emitter2.prototype.onAnyEvent = function(listener) {
        this._listenersForAnyEvent.push(listener);
        return this;
      };
      Emitter2.prototype.removeEvent = function(eventName, listener) {
        if (this._listeners[eventName] == null) {
          return this;
        }
        array.pluckOneItem(this._listeners[eventName], listener);
        return this;
      };
      Emitter2.prototype.removeListeners = function(eventName) {
        if (this._listeners[eventName] == null) {
          return this;
        }
        this._listeners[eventName].length = 0;
        return this;
      };
      Emitter2.prototype.removeAllListeners = function() {
        var listeners, name, _ref;
        _ref = this._listeners;
        for (name in _ref) {
          listeners = _ref[name];
          listeners.length = 0;
        }
        return this;
      };
      Emitter2.prototype._emit = function(eventName, data) {
        var listener, _i, _j, _len, _len1, _ref, _ref1;
        _ref = this._listenersForAnyEvent;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          listener = _ref[_i];
          listener.call(this, data, eventName);
        }
        if (this._listeners[eventName] == null) {
          return;
        }
        _ref1 = this._listeners[eventName];
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          listener = _ref1[_j];
          listener.call(this, data);
        }
      };
      Emitter2.prototype._throttleEmitterMethod = function(fnName, time) {
        var lastCallArgs, originalFn, pend, pending, runIt, timer, _this = this;
        if (time == null) {
          time = 1e3;
        }
        originalFn = this[fnName];
        if (typeof originalFn !== "function") {
          throw Error("this class does not have a method called '" + fnName + "'");
        }
        lastCallArgs = null;
        pending = false;
        timer = null;
        this[fnName] = function() {
          lastCallArgs = arguments;
          return pend();
        };
        pend = function() {
          if (pending) {
            clearTimeout(timer);
          }
          timer = setTimeout(runIt, time);
          return pending = true;
        };
        return runIt = function() {
          pending = false;
          return originalFn.apply(_this, lastCallArgs);
        };
      };
      Emitter2.prototype._disableEmitter = function(fnName) {
        if (this._disabledEmitters[fnName] != null) {
          throw Error("" + fnName + " is already a disabled emitter");
        }
        this._disabledEmitters[fnName] = this[fnName];
        return this[fnName] = function() {
        };
      };
      Emitter2.prototype._enableEmitter = function(fnName) {
        var fn;
        fn = this._disabledEmitters[fnName];
        if (fn == null) {
          throw Error("" + fnName + " is not a disabled emitter");
        }
        this[fnName] = fn;
        return delete this._disabledEmitters[fnName];
      };
      return Emitter2;
    }();
  }
});

// node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/utila.js
var require_utila = __commonJS({
  "node_modules/.pnpm/utila@0.4.0/node_modules/utila/lib/utila.js"(exports, module2) {
    var utila;
    module2.exports = utila = {
      array: require_array4(),
      classic: require_classic(),
      object: require_object2(),
      string: require_string4(),
      Emitter: require_Emitter()
    };
  }
});

// node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/objectToSaneObject.js
var require_objectToSaneObject = __commonJS({
  "node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/objectToSaneObject.js"(exports, module2) {
    var object2;
    var self2;
    var hasProp = {}.hasOwnProperty;
    object2 = require_utila().object;
    module2.exports = self2 = {
      sanitize: function(val) {
        return self2._toChildren(val);
      },
      _toChildren: function(val) {
        var ref;
        if (object2.isBareObject(val)) {
          return self2._objectToChildren(val);
        } else if (Array.isArray(val)) {
          return self2._arrayToChildren(val);
        } else if (val === null || typeof val === "undefined") {
          return [];
        } else if ((ref = typeof val) === "string" || ref === "number") {
          return [String(val)];
        } else {
          throw Error("not a valid child node: `" + val);
        }
      },
      _objectToChildren: function(o) {
        var a, cur, key, val;
        a = [];
        for (key in o) {
          if (!hasProp.call(o, key))
            continue;
          val = o[key];
          cur = {};
          cur[key] = self2.sanitize(val);
          a.push(cur);
        }
        return a;
      },
      _arrayToChildren: function(a) {
        var i, len, ret, v;
        ret = [];
        for (i = 0, len = a.length; i < len; i++) {
          v = a[i];
          ret.push(self2._toNode(v));
        }
        return ret;
      },
      _toNode: function(o) {
        var key, keys, obj, ref;
        if ((ref = typeof o) === "string" || ref === "number") {
          return String(o);
        } else if (object2.isBareObject(o)) {
          keys = Object.keys(o);
          if (keys.length !== 1) {
            throw Error("a node must only have one key as tag name");
          }
          key = keys[0];
          obj = {};
          obj[key] = self2._toChildren(o[key]);
          return obj;
        } else {
          throw Error("not a valid node: `" + o + "`");
        }
      }
    };
  }
});

// node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/saneObjectToDom.js
var require_saneObjectToDom = __commonJS({
  "node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/saneObjectToDom.js"(exports, module2) {
    var self2;
    var hasProp = {}.hasOwnProperty;
    module2.exports = self2 = {
      convert: function(obj) {
        return self2._arrayToChildren(obj);
      },
      _arrayToChildren: function(a, parent) {
        var children, j, len, node, prev, v;
        if (parent == null) {
          parent = null;
        }
        children = [];
        prev = null;
        for (j = 0, len = a.length; j < len; j++) {
          v = a[j];
          if (typeof v === "string") {
            node = self2._getTextNodeFor(v);
          } else {
            node = self2._objectToNode(v, parent);
            node.prev = null;
            node.next = null;
            node.parent = parent;
            if (prev != null) {
              node.prev = prev;
              prev.next = node;
            }
            prev = node;
          }
          children.push(node);
        }
        return children;
      },
      _objectToNode: function(o) {
        var attribs, children, i, k, key, name, node, ref, v, val;
        i = 0;
        for (k in o) {
          if (!hasProp.call(o, k))
            continue;
          v = o[k];
          if (i > 0) {
            throw Error("_objectToNode() only accepts an object with one key/value");
          }
          key = k;
          val = v;
          i++;
        }
        node = {};
        if (typeof key !== "string") {
          throw Error("_objectToNode()'s key must be a string of tag name and classes");
        }
        if (typeof val === "string") {
          children = [self2._getTextNodeFor(val)];
        } else if (Array.isArray(val)) {
          children = self2._arrayToChildren(val, node);
        } else {
          inspect(o);
          throw Error("_objectToNode()'s key's value must only be a string or an array");
        }
        node.type = "tag";
        ref = self2._parseTag(key), name = ref.name, attribs = ref.attribs;
        node.name = name;
        node.attribs = attribs;
        node.children = children;
        return node;
      },
      _getTextNodeFor: function(s) {
        return {
          type: "text",
          data: s
        };
      },
      _nameRx: /^[a-zA-Z\-\_]{1}[a-zA-Z0-9\-\_]*$/,
      _parseTag: function(k) {
        var attribs, classes, cls, id, m, name, parts;
        if (!k.match(/^[a-zA-Z0-9\#\-\_\.\[\]\"\'\=\,\s]+$/) || k.match(/^[0-9]+/)) {
          throw Error("cannot parse tag `" + k + "`");
        }
        attribs = {};
        parts = {
          name: "",
          attribs
        };
        if (m = k.match(/^([^\.#]+)/)) {
          name = m[1];
          if (!name.match(self2._nameRx)) {
            throw Error("tag name `" + name + "` is not valid");
          }
          parts.name = name;
          k = k.substr(name.length, k.length);
        }
        if (m = k.match(/^#([a-zA-Z0-9\-]+)/)) {
          id = m[1];
          if (!id.match(self2._nameRx)) {
            throw Error("tag id `" + id + "` is not valid");
          }
          attribs.id = id;
          k = k.substr(id.length + 1, k.length);
        }
        classes = [];
        while (m = k.match(/\.([a-zA-Z0-9\-\_]+)/)) {
          cls = m[1];
          if (!cls.match(self2._nameRx)) {
            throw Error("tag class `" + cls + "` is not valid");
          }
          classes.push(cls);
          k = k.replace("." + cls, "");
        }
        if (classes.length) {
          attribs["class"] = classes.join(" ");
        }
        return parts;
      }
    };
  }
});

// node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/domToMarkup.js
var require_domToMarkup = __commonJS({
  "node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/domToMarkup.js"() {
  }
});

// node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/domConverter.js
var require_domConverter = __commonJS({
  "node_modules/.pnpm/dom-converter@0.2.0/node_modules/dom-converter/lib/domConverter.js"(exports, module2) {
    var domToMarkup;
    var object2;
    var objectToSaneObject;
    var saneObjectToDom;
    var self2;
    objectToSaneObject = require_objectToSaneObject();
    saneObjectToDom = require_saneObjectToDom();
    domToMarkup = require_domToMarkup();
    object2 = require_utila().object;
    module2.exports = self2 = {
      objectToDom: function(o) {
        o = self2._object2SaneObject(o);
        return saneObjectToDom.convert(o);
      },
      object2markup: function(o) {
        var dom;
        dom = self2.objectToDom(o);
        return domToMarkup.convert(dom);
      },
      domToMarkup: function(dom) {
        return domToMarkup.convert(dom);
      },
      _object2SaneObject: function(o) {
        if (!Array.isArray(o)) {
          if (!object2.isBareObject(o)) {
            throw Error("toDom() only accepts arrays and bare objects as input");
          }
        }
        return objectToSaneObject.sanitize(o);
      }
    };
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assignMergeValue.js
var require_assignMergeValue = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assignMergeValue.js"(exports, module2) {
    var baseAssignValue = require_baseAssignValue();
    var eq = require_eq();
    function assignMergeValue(object2, key, value) {
      if (value !== void 0 && !eq(object2[key], value) || value === void 0 && !(key in object2)) {
        baseAssignValue(object2, key, value);
      }
    }
    module2.exports = assignMergeValue;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneBuffer.js
var require_cloneBuffer = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneBuffer.js"(exports, module2) {
    var root = require_root();
    var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var Buffer2 = moduleExports ? root.Buffer : void 0;
    var allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : void 0;
    function cloneBuffer(buffer, isDeep) {
      if (isDeep) {
        return buffer.slice();
      }
      var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
      buffer.copy(result2);
      return result2;
    }
    module2.exports = cloneBuffer;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneArrayBuffer.js
var require_cloneArrayBuffer = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneArrayBuffer.js"(exports, module2) {
    var Uint8Array2 = require_Uint8Array();
    function cloneArrayBuffer(arrayBuffer) {
      var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
      new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
      return result2;
    }
    module2.exports = cloneArrayBuffer;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneTypedArray.js
var require_cloneTypedArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneTypedArray.js"(exports, module2) {
    var cloneArrayBuffer = require_cloneArrayBuffer();
    function cloneTypedArray(typedArray, isDeep) {
      var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
      return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
    }
    module2.exports = cloneTypedArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copyArray.js
var require_copyArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copyArray.js"(exports, module2) {
    function copyArray(source, array) {
      var index = -1, length = source.length;
      array || (array = Array(length));
      while (++index < length) {
        array[index] = source[index];
      }
      return array;
    }
    module2.exports = copyArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseCreate.js
var require_baseCreate = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseCreate.js"(exports, module2) {
    var isObject2 = require_isObject();
    var objectCreate = Object.create;
    var baseCreate = function() {
      function object2() {
      }
      return function(proto) {
        if (!isObject2(proto)) {
          return {};
        }
        if (objectCreate) {
          return objectCreate(proto);
        }
        object2.prototype = proto;
        var result2 = new object2();
        object2.prototype = void 0;
        return result2;
      };
    }();
    module2.exports = baseCreate;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_initCloneObject.js
var require_initCloneObject = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_initCloneObject.js"(exports, module2) {
    var baseCreate = require_baseCreate();
    var getPrototype = require_getPrototype();
    var isPrototype = require_isPrototype();
    function initCloneObject(object2) {
      return typeof object2.constructor == "function" && !isPrototype(object2) ? baseCreate(getPrototype(object2)) : {};
    }
    module2.exports = initCloneObject;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArrayLikeObject.js
var require_isArrayLikeObject = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isArrayLikeObject.js"(exports, module2) {
    var isArrayLike = require_isArrayLike();
    var isObjectLike = require_isObjectLike();
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    module2.exports = isArrayLikeObject;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_safeGet.js
var require_safeGet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_safeGet.js"(exports, module2) {
    function safeGet(object2, key) {
      if (key === "constructor" && typeof object2[key] === "function") {
        return;
      }
      if (key == "__proto__") {
        return;
      }
      return object2[key];
    }
    module2.exports = safeGet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assignValue.js
var require_assignValue = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assignValue.js"(exports, module2) {
    var baseAssignValue = require_baseAssignValue();
    var eq = require_eq();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function assignValue(object2, key, value) {
      var objValue = object2[key];
      if (!(hasOwnProperty2.call(object2, key) && eq(objValue, value)) || value === void 0 && !(key in object2)) {
        baseAssignValue(object2, key, value);
      }
    }
    module2.exports = assignValue;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copyObject.js
var require_copyObject = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copyObject.js"(exports, module2) {
    var assignValue = require_assignValue();
    var baseAssignValue = require_baseAssignValue();
    function copyObject(source, props, object2, customizer) {
      var isNew = !object2;
      object2 || (object2 = {});
      var index = -1, length = props.length;
      while (++index < length) {
        var key = props[index];
        var newValue = customizer ? customizer(object2[key], source[key], key, object2, source) : void 0;
        if (newValue === void 0) {
          newValue = source[key];
        }
        if (isNew) {
          baseAssignValue(object2, key, newValue);
        } else {
          assignValue(object2, key, newValue);
        }
      }
      return object2;
    }
    module2.exports = copyObject;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeKeysIn.js
var require_nativeKeysIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeKeysIn.js"(exports, module2) {
    function nativeKeysIn(object2) {
      var result2 = [];
      if (object2 != null) {
        for (var key in Object(object2)) {
          result2.push(key);
        }
      }
      return result2;
    }
    module2.exports = nativeKeysIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseKeysIn.js
var require_baseKeysIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseKeysIn.js"(exports, module2) {
    var isObject2 = require_isObject();
    var isPrototype = require_isPrototype();
    var nativeKeysIn = require_nativeKeysIn();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function baseKeysIn(object2) {
      if (!isObject2(object2)) {
        return nativeKeysIn(object2);
      }
      var isProto = isPrototype(object2), result2 = [];
      for (var key in object2) {
        if (!(key == "constructor" && (isProto || !hasOwnProperty2.call(object2, key)))) {
          result2.push(key);
        }
      }
      return result2;
    }
    module2.exports = baseKeysIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/keysIn.js
var require_keysIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/keysIn.js"(exports, module2) {
    var arrayLikeKeys = require_arrayLikeKeys();
    var baseKeysIn = require_baseKeysIn();
    var isArrayLike = require_isArrayLike();
    function keysIn(object2) {
      return isArrayLike(object2) ? arrayLikeKeys(object2, true) : baseKeysIn(object2);
    }
    module2.exports = keysIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/toPlainObject.js
var require_toPlainObject = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/toPlainObject.js"(exports, module2) {
    var copyObject = require_copyObject();
    var keysIn = require_keysIn();
    function toPlainObject(value) {
      return copyObject(value, keysIn(value));
    }
    module2.exports = toPlainObject;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMergeDeep.js
var require_baseMergeDeep = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMergeDeep.js"(exports, module2) {
    var assignMergeValue = require_assignMergeValue();
    var cloneBuffer = require_cloneBuffer();
    var cloneTypedArray = require_cloneTypedArray();
    var copyArray = require_copyArray();
    var initCloneObject = require_initCloneObject();
    var isArguments = require_isArguments();
    var isArray = require_isArray();
    var isArrayLikeObject = require_isArrayLikeObject();
    var isBuffer = require_isBuffer();
    var isFunction = require_isFunction();
    var isObject2 = require_isObject();
    var isPlainObject = require_isPlainObject();
    var isTypedArray = require_isTypedArray();
    var safeGet = require_safeGet();
    var toPlainObject = require_toPlainObject();
    function baseMergeDeep(object2, source, key, srcIndex, mergeFunc, customizer, stack) {
      var objValue = safeGet(object2, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
      if (stacked) {
        assignMergeValue(object2, key, stacked);
        return;
      }
      var newValue = customizer ? customizer(objValue, srcValue, key + "", object2, source, stack) : void 0;
      var isCommon = newValue === void 0;
      if (isCommon) {
        var isArr = isArray(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
        newValue = srcValue;
        if (isArr || isBuff || isTyped) {
          if (isArray(objValue)) {
            newValue = objValue;
          } else if (isArrayLikeObject(objValue)) {
            newValue = copyArray(objValue);
          } else if (isBuff) {
            isCommon = false;
            newValue = cloneBuffer(srcValue, true);
          } else if (isTyped) {
            isCommon = false;
            newValue = cloneTypedArray(srcValue, true);
          } else {
            newValue = [];
          }
        } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
          newValue = objValue;
          if (isArguments(objValue)) {
            newValue = toPlainObject(objValue);
          } else if (!isObject2(objValue) || isFunction(objValue)) {
            newValue = initCloneObject(srcValue);
          }
        } else {
          isCommon = false;
        }
      }
      if (isCommon) {
        stack.set(srcValue, newValue);
        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
        stack["delete"](srcValue);
      }
      assignMergeValue(object2, key, newValue);
    }
    module2.exports = baseMergeDeep;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMerge.js
var require_baseMerge = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseMerge.js"(exports, module2) {
    var Stack = require_Stack();
    var assignMergeValue = require_assignMergeValue();
    var baseFor = require_baseFor();
    var baseMergeDeep = require_baseMergeDeep();
    var isObject2 = require_isObject();
    var keysIn = require_keysIn();
    var safeGet = require_safeGet();
    function baseMerge(object2, source, srcIndex, customizer, stack) {
      if (object2 === source) {
        return;
      }
      baseFor(source, function(srcValue, key) {
        stack || (stack = new Stack());
        if (isObject2(srcValue)) {
          baseMergeDeep(object2, source, key, srcIndex, baseMerge, customizer, stack);
        } else {
          var newValue = customizer ? customizer(safeGet(object2, key), srcValue, key + "", object2, source, stack) : void 0;
          if (newValue === void 0) {
            newValue = srcValue;
          }
          assignMergeValue(object2, key, newValue);
        }
      }, keysIn);
    }
    module2.exports = baseMerge;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_apply.js
var require_apply = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_apply.js"(exports, module2) {
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    module2.exports = apply;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_overRest.js
var require_overRest = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_overRest.js"(exports, module2) {
    var apply = require_apply();
    var nativeMax = Math.max;
    function overRest(func, start, transform) {
      start = nativeMax(start === void 0 ? func.length - 1 : start, 0);
      return function() {
        var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
        while (++index < length) {
          array[index] = args[start + index];
        }
        index = -1;
        var otherArgs = Array(start + 1);
        while (++index < start) {
          otherArgs[index] = args[index];
        }
        otherArgs[start] = transform(array);
        return apply(func, this, otherArgs);
      };
    }
    module2.exports = overRest;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/constant.js
var require_constant = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/constant.js"(exports, module2) {
    function constant(value) {
      return function() {
        return value;
      };
    }
    module2.exports = constant;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSetToString.js
var require_baseSetToString = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSetToString.js"(exports, module2) {
    var constant = require_constant();
    var defineProperty = require_defineProperty();
    var identity = require_identity();
    var baseSetToString = !defineProperty ? identity : function(func, string2) {
      return defineProperty(func, "toString", {
        "configurable": true,
        "enumerable": false,
        "value": constant(string2),
        "writable": true
      });
    };
    module2.exports = baseSetToString;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_shortOut.js
var require_shortOut = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_shortOut.js"(exports, module2) {
    var HOT_COUNT = 800;
    var HOT_SPAN = 16;
    var nativeNow = Date.now;
    function shortOut(func) {
      var count = 0, lastCalled = 0;
      return function() {
        var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
        lastCalled = stamp;
        if (remaining > 0) {
          if (++count >= HOT_COUNT) {
            return arguments[0];
          }
        } else {
          count = 0;
        }
        return func.apply(void 0, arguments);
      };
    }
    module2.exports = shortOut;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setToString.js
var require_setToString = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setToString.js"(exports, module2) {
    var baseSetToString = require_baseSetToString();
    var shortOut = require_shortOut();
    var setToString = shortOut(baseSetToString);
    module2.exports = setToString;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseRest.js
var require_baseRest = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseRest.js"(exports, module2) {
    var identity = require_identity();
    var overRest = require_overRest();
    var setToString = require_setToString();
    function baseRest(func, start) {
      return setToString(overRest(func, start, identity), func + "");
    }
    module2.exports = baseRest;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isIterateeCall.js
var require_isIterateeCall = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_isIterateeCall.js"(exports, module2) {
    var eq = require_eq();
    var isArrayLike = require_isArrayLike();
    var isIndex = require_isIndex();
    var isObject2 = require_isObject();
    function isIterateeCall(value, index, object2) {
      if (!isObject2(object2)) {
        return false;
      }
      var type2 = typeof index;
      if (type2 == "number" ? isArrayLike(object2) && isIndex(index, object2.length) : type2 == "string" && index in object2) {
        return eq(object2[index], value);
      }
      return false;
    }
    module2.exports = isIterateeCall;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createAssigner.js
var require_createAssigner = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createAssigner.js"(exports, module2) {
    var baseRest = require_baseRest();
    var isIterateeCall = require_isIterateeCall();
    function createAssigner(assigner) {
      return baseRest(function(object2, sources) {
        var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
        customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          customizer = length < 3 ? void 0 : customizer;
          length = 1;
        }
        object2 = Object(object2);
        while (++index < length) {
          var source = sources[index];
          if (source) {
            assigner(object2, source, index, customizer);
          }
        }
        return object2;
      });
    }
    module2.exports = createAssigner;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/merge.js
var require_merge = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/merge.js"(exports, module2) {
    var baseMerge = require_baseMerge();
    var createAssigner = require_createAssigner();
    var merge2 = createAssigner(function(object2, source, srcIndex) {
      baseMerge(object2, source, srcIndex);
    });
    module2.exports = merge2;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayEach.js
var require_arrayEach = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayEach.js"(exports, module2) {
    function arrayEach(array, iteratee) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (iteratee(array[index], index, array) === false) {
          break;
        }
      }
      return array;
    }
    module2.exports = arrayEach;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssign.js
var require_baseAssign = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssign.js"(exports, module2) {
    var copyObject = require_copyObject();
    var keys = require_keys2();
    function baseAssign(object2, source) {
      return object2 && copyObject(source, keys(source), object2);
    }
    module2.exports = baseAssign;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssignIn.js
var require_baseAssignIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssignIn.js"(exports, module2) {
    var copyObject = require_copyObject();
    var keysIn = require_keysIn();
    function baseAssignIn(object2, source) {
      return object2 && copyObject(source, keysIn(source), object2);
    }
    module2.exports = baseAssignIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copySymbols.js
var require_copySymbols = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copySymbols.js"(exports, module2) {
    var copyObject = require_copyObject();
    var getSymbols = require_getSymbols();
    function copySymbols(source, object2) {
      return copyObject(source, getSymbols(source), object2);
    }
    module2.exports = copySymbols;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getSymbolsIn.js
var require_getSymbolsIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getSymbolsIn.js"(exports, module2) {
    var arrayPush = require_arrayPush();
    var getPrototype = require_getPrototype();
    var getSymbols = require_getSymbols();
    var stubArray = require_stubArray();
    var nativeGetSymbols = Object.getOwnPropertySymbols;
    var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object2) {
      var result2 = [];
      while (object2) {
        arrayPush(result2, getSymbols(object2));
        object2 = getPrototype(object2);
      }
      return result2;
    };
    module2.exports = getSymbolsIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copySymbolsIn.js
var require_copySymbolsIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_copySymbolsIn.js"(exports, module2) {
    var copyObject = require_copyObject();
    var getSymbolsIn = require_getSymbolsIn();
    function copySymbolsIn(source, object2) {
      return copyObject(source, getSymbolsIn(source), object2);
    }
    module2.exports = copySymbolsIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getAllKeysIn.js
var require_getAllKeysIn = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getAllKeysIn.js"(exports, module2) {
    var baseGetAllKeys = require_baseGetAllKeys();
    var getSymbolsIn = require_getSymbolsIn();
    var keysIn = require_keysIn();
    function getAllKeysIn(object2) {
      return baseGetAllKeys(object2, keysIn, getSymbolsIn);
    }
    module2.exports = getAllKeysIn;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_initCloneArray.js
var require_initCloneArray = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_initCloneArray.js"(exports, module2) {
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function initCloneArray(array) {
      var length = array.length, result2 = new array.constructor(length);
      if (length && typeof array[0] == "string" && hasOwnProperty2.call(array, "index")) {
        result2.index = array.index;
        result2.input = array.input;
      }
      return result2;
    }
    module2.exports = initCloneArray;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneDataView.js
var require_cloneDataView = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneDataView.js"(exports, module2) {
    var cloneArrayBuffer = require_cloneArrayBuffer();
    function cloneDataView(dataView, isDeep) {
      var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
      return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
    }
    module2.exports = cloneDataView;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneRegExp.js
var require_cloneRegExp = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneRegExp.js"(exports, module2) {
    var reFlags = /\w*$/;
    function cloneRegExp(regexp) {
      var result2 = new regexp.constructor(regexp.source, reFlags.exec(regexp));
      result2.lastIndex = regexp.lastIndex;
      return result2;
    }
    module2.exports = cloneRegExp;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneSymbol.js
var require_cloneSymbol = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_cloneSymbol.js"(exports, module2) {
    var Symbol2 = require_Symbol();
    var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
    var symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
    function cloneSymbol(symbol) {
      return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
    }
    module2.exports = cloneSymbol;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_initCloneByTag.js
var require_initCloneByTag = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_initCloneByTag.js"(exports, module2) {
    var cloneArrayBuffer = require_cloneArrayBuffer();
    var cloneDataView = require_cloneDataView();
    var cloneRegExp = require_cloneRegExp();
    var cloneSymbol = require_cloneSymbol();
    var cloneTypedArray = require_cloneTypedArray();
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var symbolTag = "[object Symbol]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    function initCloneByTag(object2, tag, isDeep) {
      var Ctor = object2.constructor;
      switch (tag) {
        case arrayBufferTag:
          return cloneArrayBuffer(object2);
        case boolTag:
        case dateTag:
          return new Ctor(+object2);
        case dataViewTag:
          return cloneDataView(object2, isDeep);
        case float32Tag:
        case float64Tag:
        case int8Tag:
        case int16Tag:
        case int32Tag:
        case uint8Tag:
        case uint8ClampedTag:
        case uint16Tag:
        case uint32Tag:
          return cloneTypedArray(object2, isDeep);
        case mapTag:
          return new Ctor();
        case numberTag:
        case stringTag:
          return new Ctor(object2);
        case regexpTag:
          return cloneRegExp(object2);
        case setTag:
          return new Ctor();
        case symbolTag:
          return cloneSymbol(object2);
      }
    }
    module2.exports = initCloneByTag;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsMap.js
var require_baseIsMap = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsMap.js"(exports, module2) {
    var getTag = require_getTag();
    var isObjectLike = require_isObjectLike();
    var mapTag = "[object Map]";
    function baseIsMap(value) {
      return isObjectLike(value) && getTag(value) == mapTag;
    }
    module2.exports = baseIsMap;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isMap.js
var require_isMap = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isMap.js"(exports, module2) {
    var baseIsMap = require_baseIsMap();
    var baseUnary = require_baseUnary();
    var nodeUtil = require_nodeUtil();
    var nodeIsMap = nodeUtil && nodeUtil.isMap;
    var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
    module2.exports = isMap;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsSet.js
var require_baseIsSet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseIsSet.js"(exports, module2) {
    var getTag = require_getTag();
    var isObjectLike = require_isObjectLike();
    var setTag = "[object Set]";
    function baseIsSet(value) {
      return isObjectLike(value) && getTag(value) == setTag;
    }
    module2.exports = baseIsSet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isSet.js
var require_isSet = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isSet.js"(exports, module2) {
    var baseIsSet = require_baseIsSet();
    var baseUnary = require_baseUnary();
    var nodeUtil = require_nodeUtil();
    var nodeIsSet = nodeUtil && nodeUtil.isSet;
    var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
    module2.exports = isSet;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseClone.js
var require_baseClone = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseClone.js"(exports, module2) {
    var Stack = require_Stack();
    var arrayEach = require_arrayEach();
    var assignValue = require_assignValue();
    var baseAssign = require_baseAssign();
    var baseAssignIn = require_baseAssignIn();
    var cloneBuffer = require_cloneBuffer();
    var copyArray = require_copyArray();
    var copySymbols = require_copySymbols();
    var copySymbolsIn = require_copySymbolsIn();
    var getAllKeys = require_getAllKeys();
    var getAllKeysIn = require_getAllKeysIn();
    var getTag = require_getTag();
    var initCloneArray = require_initCloneArray();
    var initCloneByTag = require_initCloneByTag();
    var initCloneObject = require_initCloneObject();
    var isArray = require_isArray();
    var isBuffer = require_isBuffer();
    var isMap = require_isMap();
    var isObject2 = require_isObject();
    var isSet = require_isSet();
    var keys = require_keys2();
    var keysIn = require_keysIn();
    var CLONE_DEEP_FLAG = 1;
    var CLONE_FLAT_FLAG = 2;
    var CLONE_SYMBOLS_FLAG = 4;
    var argsTag = "[object Arguments]";
    var arrayTag = "[object Array]";
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var errorTag = "[object Error]";
    var funcTag = "[object Function]";
    var genTag = "[object GeneratorFunction]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var objectTag = "[object Object]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var symbolTag = "[object Symbol]";
    var weakMapTag = "[object WeakMap]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    var cloneableTags = {};
    cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
    cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
    function baseClone(value, bitmask, customizer, key, object2, stack) {
      var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
      if (customizer) {
        result2 = object2 ? customizer(value, key, object2, stack) : customizer(value);
      }
      if (result2 !== void 0) {
        return result2;
      }
      if (!isObject2(value)) {
        return value;
      }
      var isArr = isArray(value);
      if (isArr) {
        result2 = initCloneArray(value);
        if (!isDeep) {
          return copyArray(value, result2);
        }
      } else {
        var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
        if (isBuffer(value)) {
          return cloneBuffer(value, isDeep);
        }
        if (tag == objectTag || tag == argsTag || isFunc && !object2) {
          result2 = isFlat || isFunc ? {} : initCloneObject(value);
          if (!isDeep) {
            return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
          }
        } else {
          if (!cloneableTags[tag]) {
            return object2 ? value : {};
          }
          result2 = initCloneByTag(value, tag, isDeep);
        }
      }
      stack || (stack = new Stack());
      var stacked = stack.get(value);
      if (stacked) {
        return stacked;
      }
      stack.set(value, result2);
      if (isSet(value)) {
        value.forEach(function(subValue) {
          result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
        });
      } else if (isMap(value)) {
        value.forEach(function(subValue, key2) {
          result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
        });
      }
      var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
      var props = isArr ? void 0 : keysFunc(value);
      arrayEach(props || value, function(subValue, key2) {
        if (props) {
          key2 = subValue;
          subValue = value[key2];
        }
        assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
      });
      return result2;
    }
    module2.exports = baseClone;
  }
});

// node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/cloneDeep.js
var require_cloneDeep = __commonJS({
  "node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/cloneDeep.js"(exports, module2) {
    var baseClone = require_baseClone();
    var CLONE_DEEP_FLAG = 1;
    var CLONE_SYMBOLS_FLAG = 4;
    function cloneDeep(value) {
      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
    }
    module2.exports = cloneDeep;
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/tools.js
var require_tools = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/tools.js"(exports, module2) {
    "use strict";
    var cloneDeep;
    var htmlparser;
    var isPlainObject;
    var merge2;
    var _objectToDom;
    var self2;
    htmlparser = require_lib12();
    var _require = require_domConverter();
    _objectToDom = _require.objectToDom;
    merge2 = require_merge();
    cloneDeep = require_cloneDeep();
    isPlainObject = require_isPlainObject();
    module2.exports = self2 = {
      repeatString: function repeatString(str2, times) {
        var i, j, output, ref;
        output = "";
        for (i = j = 0, ref = times; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
          output += str2;
        }
        return output;
      },
      cloneAndMergeDeep: function cloneAndMergeDeep(base, toAppend) {
        return merge2(cloneDeep(base), toAppend);
      },
      toDom: function toDom(subject) {
        if (typeof subject === "string") {
          return self2.stringToDom(subject);
        } else if (isPlainObject(subject)) {
          return self2._objectToDom(subject);
        } else {
          throw Error("tools.toDom() only supports strings and objects");
        }
      },
      stringToDom: function stringToDom(string2) {
        var handler, parser;
        handler = new htmlparser.DomHandler();
        parser = new htmlparser.Parser(handler);
        parser.write(string2);
        parser.end();
        return handler.dom;
      },
      _fixQuotesInDom: function _fixQuotesInDom(input) {
        var j, len, node;
        if (Array.isArray(input)) {
          for (j = 0, len = input.length; j < len; j++) {
            node = input[j];
            self2._fixQuotesInDom(node);
          }
          return input;
        }
        node = input;
        if (node.type === "text") {
          return node.data = self2._quoteNodeText(node.data);
        } else {
          return self2._fixQuotesInDom(node.children);
        }
      },
      objectToDom: function objectToDom(o) {
        if (!Array.isArray(o)) {
          if (!isPlainObject(o)) {
            throw Error("objectToDom() only accepts a bare object or an array");
          }
        }
        return self2._fixQuotesInDom(_objectToDom(o));
      },
      quote: function quote(str2) {
        return String(str2).replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\ /g, "&sp;").replace(/\n/g, "<br />");
      },
      _quoteNodeText: function _quoteNodeText(text) {
        return String(text).replace(/\&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\ /g, "&sp;").replace(/\n/g, "&nl;");
      },
      getCols: function getCols() {
        var cols, tty;
        tty = require("tty");
        cols = function() {
          try {
            if (tty.isatty(1) && tty.isatty(2)) {
              if (process.stdout.getWindowSize) {
                return process.stdout.getWindowSize(1)[0];
              } else if (tty.getWindowSize) {
                return tty.getWindowSize()[1];
              } else if (process.stdout.columns) {
                return process.stdout.columns;
              }
            }
          } catch (error) {
          }
        }();
        if (typeof cols === "number" && cols > 30) {
          return cols;
        } else {
          return 80;
        }
      }
    };
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/ansiPainter/tags.js
var require_tags = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/ansiPainter/tags.js"(exports, module2) {
    "use strict";
    var color;
    var colors;
    var i;
    var len;
    var tags;
    module2.exports = tags = {
      "none": {
        color: "none",
        bg: "none"
      },
      "bg-none": {
        color: "inherit",
        bg: "none"
      },
      "color-none": {
        color: "none",
        bg: "inherit"
      }
    };
    colors = ["black", "red", "green", "yellow", "blue", "magenta", "cyan", "white", "grey", "bright-red", "bright-green", "bright-yellow", "bright-blue", "bright-magenta", "bright-cyan", "bright-white"];
    for (i = 0, len = colors.length; i < len; i++) {
      color = colors[i];
      tags[color] = {
        color,
        bg: "inherit"
      };
      tags["color-".concat(color)] = {
        color,
        bg: "inherit"
      };
      tags["bg-".concat(color)] = {
        color: "inherit",
        bg: color
      };
    }
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/ansiPainter/styles.js
var require_styles3 = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/ansiPainter/styles.js"(exports, module2) {
    "use strict";
    var codes;
    var styles;
    module2.exports = styles = {};
    styles.codes = codes = {
      "none": 0,
      "black": 30,
      "red": 31,
      "green": 32,
      "yellow": 33,
      "blue": 34,
      "magenta": 35,
      "cyan": 36,
      "white": 37,
      "grey": 90,
      "bright-red": 91,
      "bright-green": 92,
      "bright-yellow": 93,
      "bright-blue": 94,
      "bright-magenta": 95,
      "bright-cyan": 96,
      "bright-white": 97,
      "bg-black": 40,
      "bg-red": 41,
      "bg-green": 42,
      "bg-yellow": 43,
      "bg-blue": 44,
      "bg-magenta": 45,
      "bg-cyan": 46,
      "bg-white": 47,
      "bg-grey": 100,
      "bg-bright-red": 101,
      "bg-bright-green": 102,
      "bg-bright-yellow": 103,
      "bg-bright-blue": 104,
      "bg-bright-magenta": 105,
      "bg-bright-cyan": 106,
      "bg-bright-white": 107
    };
    styles.color = function(str2) {
      var code;
      if (str2 === "none") {
        return "";
      }
      code = codes[str2];
      if (code == null) {
        throw Error("Unknown color `".concat(str2, "`"));
      }
      return "\x1B[" + code + "m";
    };
    styles.bg = function(str2) {
      var code;
      if (str2 === "none") {
        return "";
      }
      code = codes["bg-" + str2];
      if (code == null) {
        throw Error("Unknown bg color `".concat(str2, "`"));
      }
      return "\x1B[" + code + "m";
    };
    styles.none = function(str2) {
      return "\x1B[" + codes.none + "m";
    };
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/AnsiPainter.js
var require_AnsiPainter = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/AnsiPainter.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var AnsiPainter;
    var styles;
    var tags;
    var tools;
    var hasProp = {}.hasOwnProperty;
    tools = require_tools();
    tags = require_tags();
    styles = require_styles3();
    module2.exports = AnsiPainter = function() {
      var self2;
      var AnsiPainter2 = /* @__PURE__ */ function() {
        function AnsiPainter3() {
          _classCallCheck(this, AnsiPainter3);
        }
        _createClass(AnsiPainter3, [{
          key: "paint",
          value: function paint(s) {
            return this._replaceSpecialStrings(this._renderDom(this._parse(s)));
          }
        }, {
          key: "_replaceSpecialStrings",
          value: function _replaceSpecialStrings(str2) {
            return str2.replace(/&sp;/g, " ").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, '"').replace(/&amp;/g, "&");
          }
        }, {
          key: "_parse",
          value: function _parse(string2) {
            var injectFakeRoot = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            if (injectFakeRoot) {
              string2 = "<none>" + string2 + "</none>";
            }
            return tools.toDom(string2);
          }
        }, {
          key: "_renderDom",
          value: function _renderDom(dom) {
            var parentStyles;
            parentStyles = {
              bg: "none",
              color: "none"
            };
            return this._renderChildren(dom, parentStyles);
          }
        }, {
          key: "_renderChildren",
          value: function _renderChildren(children, parentStyles) {
            var child, n, ret;
            ret = "";
            for (n in children) {
              if (!hasProp.call(children, n))
                continue;
              child = children[n];
              ret += this._renderNode(child, parentStyles);
            }
            return ret;
          }
        }, {
          key: "_renderNode",
          value: function _renderNode(node, parentStyles) {
            if (node.type === "text") {
              return this._renderTextNode(node, parentStyles);
            } else {
              return this._renderTag(node, parentStyles);
            }
          }
        }, {
          key: "_renderTextNode",
          value: function _renderTextNode(node, parentStyles) {
            return this._wrapInStyle(node.data, parentStyles);
          }
        }, {
          key: "_wrapInStyle",
          value: function _wrapInStyle(str2, style) {
            return styles.color(style.color) + styles.bg(style.bg) + str2 + styles.none();
          }
        }, {
          key: "_renderTag",
          value: function _renderTag(node, parentStyles) {
            var currentStyles, tagStyles;
            tagStyles = this._getStylesForTagName(node.name);
            currentStyles = this._mixStyles(parentStyles, tagStyles);
            return this._renderChildren(node.children, currentStyles);
          }
        }, {
          key: "_mixStyles",
          value: function _mixStyles() {
            var final, i, key, len, style, val;
            final = {};
            for (var _len = arguments.length, styles2 = new Array(_len), _key = 0; _key < _len; _key++) {
              styles2[_key] = arguments[_key];
            }
            for (i = 0, len = styles2.length; i < len; i++) {
              style = styles2[i];
              for (key in style) {
                if (!hasProp.call(style, key))
                  continue;
                val = style[key];
                if (final[key] == null || val !== "inherit") {
                  final[key] = val;
                }
              }
            }
            return final;
          }
        }, {
          key: "_getStylesForTagName",
          value: function _getStylesForTagName(name) {
            if (tags[name] == null) {
              throw Error("Unknown tag name `".concat(name, "`"));
            }
            return tags[name];
          }
        }], [{
          key: "getInstance",
          value: function getInstance() {
            if (self2._instance == null) {
              self2._instance = new self2();
            }
            return self2._instance;
          }
        }, {
          key: "paint",
          value: function paint(str2) {
            return self2.getInstance().paint(str2);
          }
        }, {
          key: "strip",
          value: function strip(s) {
            return s.replace(/\x1b\[[0-9]+m/g, "");
          }
        }]);
        return AnsiPainter3;
      }();
      ;
      AnsiPainter2.tags = tags;
      self2 = AnsiPainter2;
      return AnsiPainter2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styleApplier/_common.js
var require_common2 = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styleApplier/_common.js"(exports, module2) {
    "use strict";
    var AnsiPainter;
    var _common;
    AnsiPainter = require_AnsiPainter();
    module2.exports = _common = {
      getStyleTagsFor: function getStyleTagsFor(style) {
        var i, len, ret, tag, tagName, tagsToAdd;
        tagsToAdd = [];
        if (style.color != null) {
          tagName = "color-" + style.color;
          if (AnsiPainter.tags[tagName] == null) {
            throw Error("Unknown color `".concat(style.color, "`"));
          }
          tagsToAdd.push(tagName);
        }
        if (style.background != null) {
          tagName = "bg-" + style.background;
          if (AnsiPainter.tags[tagName] == null) {
            throw Error("Unknown background `".concat(style.background, "`"));
          }
          tagsToAdd.push(tagName);
        }
        ret = {
          before: "",
          after: ""
        };
        for (i = 0, len = tagsToAdd.length; i < len; i++) {
          tag = tagsToAdd[i];
          ret.before = "<".concat(tag, ">") + ret.before;
          ret.after = ret.after + "</".concat(tag, ">");
        }
        return ret;
      }
    };
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styleApplier/inline.js
var require_inline = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styleApplier/inline.js"(exports, module2) {
    "use strict";
    var _common;
    var inlineStyleApplier;
    var self2;
    var tools;
    tools = require_tools();
    _common = require_common2();
    module2.exports = inlineStyleApplier = self2 = {
      applyTo: function applyTo(el, style) {
        var ret;
        ret = _common.getStyleTagsFor(style);
        if (style.marginLeft != null) {
          ret.before = tools.repeatString("&sp;", parseInt(style.marginLeft)) + ret.before;
        }
        if (style.marginRight != null) {
          ret.after += tools.repeatString("&sp;", parseInt(style.marginRight));
        }
        if (style.paddingLeft != null) {
          ret.before += tools.repeatString("&sp;", parseInt(style.paddingLeft));
        }
        if (style.paddingRight != null) {
          ret.after = tools.repeatString("&sp;", parseInt(style.paddingRight)) + ret.after;
        }
        return ret;
      }
    };
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styleApplier/block.js
var require_block = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styleApplier/block.js"(exports, module2) {
    "use strict";
    var _common;
    var blockStyleApplier;
    var merge2;
    var self2;
    _common = require_common2();
    merge2 = require_merge();
    module2.exports = blockStyleApplier = self2 = {
      applyTo: function applyTo(el, style) {
        var config, ret;
        ret = _common.getStyleTagsFor(style);
        ret.blockConfig = config = {};
        this._margins(style, config);
        this._bullet(style, config);
        this._dims(style, config);
        return ret;
      },
      _margins: function _margins(style, config) {
        if (style.marginLeft != null) {
          merge2(config, {
            linePrependor: {
              options: {
                amount: parseInt(style.marginLeft)
              }
            }
          });
        }
        if (style.marginRight != null) {
          merge2(config, {
            lineAppendor: {
              options: {
                amount: parseInt(style.marginRight)
              }
            }
          });
        }
        if (style.marginTop != null) {
          merge2(config, {
            blockPrependor: {
              options: {
                amount: parseInt(style.marginTop)
              }
            }
          });
        }
        if (style.marginBottom != null) {
          merge2(config, {
            blockAppendor: {
              options: {
                amount: parseInt(style.marginBottom)
              }
            }
          });
        }
      },
      _bullet: function _bullet(style, config) {
        var after, before, bullet, conf;
        if (style.bullet != null && style.bullet.enabled) {
          bullet = style.bullet;
          conf = {};
          conf.alignment = style.bullet.alignment;
          var _common$getStyleTagsF = _common.getStyleTagsFor({
            color: bullet.color,
            background: bullet.background
          });
          before = _common$getStyleTagsF.before;
          after = _common$getStyleTagsF.after;
          conf.char = before + bullet.char + after;
          merge2(config, {
            linePrependor: {
              options: {
                bullet: conf
              }
            }
          });
        }
      },
      _dims: function _dims(style, config) {
        var w;
        if (style.width != null) {
          w = parseInt(style.width);
          config.width = w;
        }
      }
    };
  }
});

// node_modules/.pnpm/boolbase@1.0.0/node_modules/boolbase/index.js
var require_boolbase = __commonJS({
  "node_modules/.pnpm/boolbase@1.0.0/node_modules/boolbase/index.js"(exports, module2) {
    module2.exports = {
      trueFunc: function trueFunc() {
        return true;
      },
      falseFunc: function falseFunc() {
        return false;
      }
    };
  }
});

// node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/types.js
var require_types3 = __commonJS({
  "node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/types.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AttributeAction = exports.IgnoreCaseMode = exports.SelectorType = void 0;
    var SelectorType;
    (function(SelectorType2) {
      SelectorType2["Attribute"] = "attribute";
      SelectorType2["Pseudo"] = "pseudo";
      SelectorType2["PseudoElement"] = "pseudo-element";
      SelectorType2["Tag"] = "tag";
      SelectorType2["Universal"] = "universal";
      SelectorType2["Adjacent"] = "adjacent";
      SelectorType2["Child"] = "child";
      SelectorType2["Descendant"] = "descendant";
      SelectorType2["Parent"] = "parent";
      SelectorType2["Sibling"] = "sibling";
      SelectorType2["ColumnCombinator"] = "column-combinator";
    })(SelectorType = exports.SelectorType || (exports.SelectorType = {}));
    exports.IgnoreCaseMode = {
      Unknown: null,
      QuirksMode: "quirks",
      IgnoreCase: true,
      CaseSensitive: false
    };
    var AttributeAction;
    (function(AttributeAction2) {
      AttributeAction2["Any"] = "any";
      AttributeAction2["Element"] = "element";
      AttributeAction2["End"] = "end";
      AttributeAction2["Equals"] = "equals";
      AttributeAction2["Exists"] = "exists";
      AttributeAction2["Hyphen"] = "hyphen";
      AttributeAction2["Not"] = "not";
      AttributeAction2["Start"] = "start";
    })(AttributeAction = exports.AttributeAction || (exports.AttributeAction = {}));
  }
});

// node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/parse.js
var require_parse = __commonJS({
  "node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/parse.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.parse = exports.isTraversal = void 0;
    var types_1 = require_types3();
    var reName = /^[^\\#]?(?:\\(?:[\da-f]{1,6}\s?|.)|[\w\-\u00b0-\uFFFF])+/;
    var reEscape = /\\([\da-f]{1,6}\s?|(\s)|.)/gi;
    var actionTypes = /* @__PURE__ */ new Map([
      [126, types_1.AttributeAction.Element],
      [94, types_1.AttributeAction.Start],
      [36, types_1.AttributeAction.End],
      [42, types_1.AttributeAction.Any],
      [33, types_1.AttributeAction.Not],
      [124, types_1.AttributeAction.Hyphen]
    ]);
    var unpackPseudos = /* @__PURE__ */ new Set([
      "has",
      "not",
      "matches",
      "is",
      "where",
      "host",
      "host-context"
    ]);
    function isTraversal(selector) {
      switch (selector.type) {
        case types_1.SelectorType.Adjacent:
        case types_1.SelectorType.Child:
        case types_1.SelectorType.Descendant:
        case types_1.SelectorType.Parent:
        case types_1.SelectorType.Sibling:
        case types_1.SelectorType.ColumnCombinator:
          return true;
        default:
          return false;
      }
    }
    exports.isTraversal = isTraversal;
    var stripQuotesFromPseudos = /* @__PURE__ */ new Set(["contains", "icontains"]);
    function funescape(_, escaped, escapedWhitespace) {
      var high = parseInt(escaped, 16) - 65536;
      return high !== high || escapedWhitespace ? escaped : high < 0 ? String.fromCharCode(high + 65536) : String.fromCharCode(high >> 10 | 55296, high & 1023 | 56320);
    }
    function unescapeCSS(str2) {
      return str2.replace(reEscape, funescape);
    }
    function isQuote(c) {
      return c === 39 || c === 34;
    }
    function isWhitespace2(c) {
      return c === 32 || c === 9 || c === 10 || c === 12 || c === 13;
    }
    function parse(selector) {
      var subselects = [];
      var endIndex = parseSelector(subselects, "".concat(selector), 0);
      if (endIndex < selector.length) {
        throw new Error("Unmatched selector: ".concat(selector.slice(endIndex)));
      }
      return subselects;
    }
    exports.parse = parse;
    function parseSelector(subselects, selector, selectorIndex) {
      var tokens = [];
      function getName(offset) {
        var match = selector.slice(selectorIndex + offset).match(reName);
        if (!match) {
          throw new Error("Expected name, found ".concat(selector.slice(selectorIndex)));
        }
        var name = match[0];
        selectorIndex += offset + name.length;
        return unescapeCSS(name);
      }
      function stripWhitespace(offset) {
        selectorIndex += offset;
        while (selectorIndex < selector.length && isWhitespace2(selector.charCodeAt(selectorIndex))) {
          selectorIndex++;
        }
      }
      function readValueWithParenthesis() {
        selectorIndex += 1;
        var start = selectorIndex;
        var counter = 1;
        for (; counter > 0 && selectorIndex < selector.length; selectorIndex++) {
          if (selector.charCodeAt(selectorIndex) === 40 && !isEscaped(selectorIndex)) {
            counter++;
          } else if (selector.charCodeAt(selectorIndex) === 41 && !isEscaped(selectorIndex)) {
            counter--;
          }
        }
        if (counter) {
          throw new Error("Parenthesis not matched");
        }
        return unescapeCSS(selector.slice(start, selectorIndex - 1));
      }
      function isEscaped(pos) {
        var slashCount = 0;
        while (selector.charCodeAt(--pos) === 92)
          slashCount++;
        return (slashCount & 1) === 1;
      }
      function ensureNotTraversal() {
        if (tokens.length > 0 && isTraversal(tokens[tokens.length - 1])) {
          throw new Error("Did not expect successive traversals.");
        }
      }
      function addTraversal(type2) {
        if (tokens.length > 0 && tokens[tokens.length - 1].type === types_1.SelectorType.Descendant) {
          tokens[tokens.length - 1].type = type2;
          return;
        }
        ensureNotTraversal();
        tokens.push({ type: type2 });
      }
      function addSpecialAttribute(name, action2) {
        tokens.push({
          type: types_1.SelectorType.Attribute,
          name,
          action: action2,
          value: getName(1),
          namespace: null,
          ignoreCase: "quirks"
        });
      }
      function finalizeSubselector() {
        if (tokens.length && tokens[tokens.length - 1].type === types_1.SelectorType.Descendant) {
          tokens.pop();
        }
        if (tokens.length === 0) {
          throw new Error("Empty sub-selector");
        }
        subselects.push(tokens);
      }
      stripWhitespace(0);
      if (selector.length === selectorIndex) {
        return selectorIndex;
      }
      loop:
        while (selectorIndex < selector.length) {
          var firstChar = selector.charCodeAt(selectorIndex);
          switch (firstChar) {
            case 32:
            case 9:
            case 10:
            case 12:
            case 13: {
              if (tokens.length === 0 || tokens[0].type !== types_1.SelectorType.Descendant) {
                ensureNotTraversal();
                tokens.push({ type: types_1.SelectorType.Descendant });
              }
              stripWhitespace(1);
              break;
            }
            case 62: {
              addTraversal(types_1.SelectorType.Child);
              stripWhitespace(1);
              break;
            }
            case 60: {
              addTraversal(types_1.SelectorType.Parent);
              stripWhitespace(1);
              break;
            }
            case 126: {
              addTraversal(types_1.SelectorType.Sibling);
              stripWhitespace(1);
              break;
            }
            case 43: {
              addTraversal(types_1.SelectorType.Adjacent);
              stripWhitespace(1);
              break;
            }
            case 46: {
              addSpecialAttribute("class", types_1.AttributeAction.Element);
              break;
            }
            case 35: {
              addSpecialAttribute("id", types_1.AttributeAction.Equals);
              break;
            }
            case 91: {
              stripWhitespace(1);
              var name_1 = void 0;
              var namespace = null;
              if (selector.charCodeAt(selectorIndex) === 124) {
                name_1 = getName(1);
              } else if (selector.startsWith("*|", selectorIndex)) {
                namespace = "*";
                name_1 = getName(2);
              } else {
                name_1 = getName(0);
                if (selector.charCodeAt(selectorIndex) === 124 && selector.charCodeAt(selectorIndex + 1) !== 61) {
                  namespace = name_1;
                  name_1 = getName(1);
                }
              }
              stripWhitespace(0);
              var action = types_1.AttributeAction.Exists;
              var possibleAction = actionTypes.get(selector.charCodeAt(selectorIndex));
              if (possibleAction) {
                action = possibleAction;
                if (selector.charCodeAt(selectorIndex + 1) !== 61) {
                  throw new Error("Expected `=`");
                }
                stripWhitespace(2);
              } else if (selector.charCodeAt(selectorIndex) === 61) {
                action = types_1.AttributeAction.Equals;
                stripWhitespace(1);
              }
              var value = "";
              var ignoreCase = null;
              if (action !== "exists") {
                if (isQuote(selector.charCodeAt(selectorIndex))) {
                  var quote = selector.charCodeAt(selectorIndex);
                  var sectionEnd = selectorIndex + 1;
                  while (sectionEnd < selector.length && (selector.charCodeAt(sectionEnd) !== quote || isEscaped(sectionEnd))) {
                    sectionEnd += 1;
                  }
                  if (selector.charCodeAt(sectionEnd) !== quote) {
                    throw new Error("Attribute value didn't end");
                  }
                  value = unescapeCSS(selector.slice(selectorIndex + 1, sectionEnd));
                  selectorIndex = sectionEnd + 1;
                } else {
                  var valueStart = selectorIndex;
                  while (selectorIndex < selector.length && (!isWhitespace2(selector.charCodeAt(selectorIndex)) && selector.charCodeAt(selectorIndex) !== 93 || isEscaped(selectorIndex))) {
                    selectorIndex += 1;
                  }
                  value = unescapeCSS(selector.slice(valueStart, selectorIndex));
                }
                stripWhitespace(0);
                var forceIgnore = selector.charCodeAt(selectorIndex) | 32;
                if (forceIgnore === 115) {
                  ignoreCase = false;
                  stripWhitespace(1);
                } else if (forceIgnore === 105) {
                  ignoreCase = true;
                  stripWhitespace(1);
                }
              }
              if (selector.charCodeAt(selectorIndex) !== 93) {
                throw new Error("Attribute selector didn't terminate");
              }
              selectorIndex += 1;
              var attributeSelector = {
                type: types_1.SelectorType.Attribute,
                name: name_1,
                action,
                value,
                namespace,
                ignoreCase
              };
              tokens.push(attributeSelector);
              break;
            }
            case 58: {
              if (selector.charCodeAt(selectorIndex + 1) === 58) {
                tokens.push({
                  type: types_1.SelectorType.PseudoElement,
                  name: getName(2).toLowerCase(),
                  data: selector.charCodeAt(selectorIndex) === 40 ? readValueWithParenthesis() : null
                });
                continue;
              }
              var name_2 = getName(1).toLowerCase();
              var data = null;
              if (selector.charCodeAt(selectorIndex) === 40) {
                if (unpackPseudos.has(name_2)) {
                  if (isQuote(selector.charCodeAt(selectorIndex + 1))) {
                    throw new Error("Pseudo-selector ".concat(name_2, " cannot be quoted"));
                  }
                  data = [];
                  selectorIndex = parseSelector(data, selector, selectorIndex + 1);
                  if (selector.charCodeAt(selectorIndex) !== 41) {
                    throw new Error("Missing closing parenthesis in :".concat(name_2, " (").concat(selector, ")"));
                  }
                  selectorIndex += 1;
                } else {
                  data = readValueWithParenthesis();
                  if (stripQuotesFromPseudos.has(name_2)) {
                    var quot = data.charCodeAt(0);
                    if (quot === data.charCodeAt(data.length - 1) && isQuote(quot)) {
                      data = data.slice(1, -1);
                    }
                  }
                  data = unescapeCSS(data);
                }
              }
              tokens.push({ type: types_1.SelectorType.Pseudo, name: name_2, data });
              break;
            }
            case 44: {
              finalizeSubselector();
              tokens = [];
              stripWhitespace(1);
              break;
            }
            default: {
              if (selector.startsWith("/*", selectorIndex)) {
                var endIndex = selector.indexOf("*/", selectorIndex + 2);
                if (endIndex < 0) {
                  throw new Error("Comment was not terminated");
                }
                selectorIndex = endIndex + 2;
                if (tokens.length === 0) {
                  stripWhitespace(0);
                }
                break;
              }
              var namespace = null;
              var name_3 = void 0;
              if (firstChar === 42) {
                selectorIndex += 1;
                name_3 = "*";
              } else if (firstChar === 124) {
                name_3 = "";
                if (selector.charCodeAt(selectorIndex + 1) === 124) {
                  addTraversal(types_1.SelectorType.ColumnCombinator);
                  stripWhitespace(2);
                  break;
                }
              } else if (reName.test(selector.slice(selectorIndex))) {
                name_3 = getName(0);
              } else {
                break loop;
              }
              if (selector.charCodeAt(selectorIndex) === 124 && selector.charCodeAt(selectorIndex + 1) !== 124) {
                namespace = name_3;
                if (selector.charCodeAt(selectorIndex + 1) === 42) {
                  name_3 = "*";
                  selectorIndex += 2;
                } else {
                  name_3 = getName(1);
                }
              }
              tokens.push(name_3 === "*" ? { type: types_1.SelectorType.Universal, namespace } : { type: types_1.SelectorType.Tag, name: name_3, namespace });
            }
          }
        }
      finalizeSubselector();
      return selectorIndex;
    }
  }
});

// node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/stringify.js
var require_stringify2 = __commonJS({
  "node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/stringify.js"(exports) {
    "use strict";
    var __spreadArray = exports && exports.__spreadArray || function(to, from, pack) {
      if (pack || arguments.length === 2)
        for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
            if (!ar)
              ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
          }
        }
      return to.concat(ar || Array.prototype.slice.call(from));
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.stringify = void 0;
    var types_1 = require_types3();
    var attribValChars = ["\\", '"'];
    var pseudoValChars = __spreadArray(__spreadArray([], attribValChars, true), ["(", ")"], false);
    var charsToEscapeInAttributeValue = new Set(attribValChars.map(function(c) {
      return c.charCodeAt(0);
    }));
    var charsToEscapeInPseudoValue = new Set(pseudoValChars.map(function(c) {
      return c.charCodeAt(0);
    }));
    var charsToEscapeInName = new Set(__spreadArray(__spreadArray([], pseudoValChars, true), [
      "~",
      "^",
      "$",
      "*",
      "+",
      "!",
      "|",
      ":",
      "[",
      "]",
      " ",
      "."
    ], false).map(function(c) {
      return c.charCodeAt(0);
    }));
    function stringify(selector) {
      return selector.map(function(token) {
        return token.map(stringifyToken).join("");
      }).join(", ");
    }
    exports.stringify = stringify;
    function stringifyToken(token, index, arr) {
      switch (token.type) {
        case types_1.SelectorType.Child:
          return index === 0 ? "> " : " > ";
        case types_1.SelectorType.Parent:
          return index === 0 ? "< " : " < ";
        case types_1.SelectorType.Sibling:
          return index === 0 ? "~ " : " ~ ";
        case types_1.SelectorType.Adjacent:
          return index === 0 ? "+ " : " + ";
        case types_1.SelectorType.Descendant:
          return " ";
        case types_1.SelectorType.ColumnCombinator:
          return index === 0 ? "|| " : " || ";
        case types_1.SelectorType.Universal:
          return token.namespace === "*" && index + 1 < arr.length && "name" in arr[index + 1] ? "" : "".concat(getNamespace(token.namespace), "*");
        case types_1.SelectorType.Tag:
          return getNamespacedName(token);
        case types_1.SelectorType.PseudoElement:
          return "::".concat(escapeName(token.name, charsToEscapeInName)).concat(token.data === null ? "" : "(".concat(escapeName(token.data, charsToEscapeInPseudoValue), ")"));
        case types_1.SelectorType.Pseudo:
          return ":".concat(escapeName(token.name, charsToEscapeInName)).concat(token.data === null ? "" : "(".concat(typeof token.data === "string" ? escapeName(token.data, charsToEscapeInPseudoValue) : stringify(token.data), ")"));
        case types_1.SelectorType.Attribute: {
          if (token.name === "id" && token.action === types_1.AttributeAction.Equals && token.ignoreCase === "quirks" && !token.namespace) {
            return "#".concat(escapeName(token.value, charsToEscapeInName));
          }
          if (token.name === "class" && token.action === types_1.AttributeAction.Element && token.ignoreCase === "quirks" && !token.namespace) {
            return ".".concat(escapeName(token.value, charsToEscapeInName));
          }
          var name_1 = getNamespacedName(token);
          if (token.action === types_1.AttributeAction.Exists) {
            return "[".concat(name_1, "]");
          }
          return "[".concat(name_1).concat(getActionValue(token.action), '="').concat(escapeName(token.value, charsToEscapeInAttributeValue), '"').concat(token.ignoreCase === null ? "" : token.ignoreCase ? " i" : " s", "]");
        }
      }
    }
    function getActionValue(action) {
      switch (action) {
        case types_1.AttributeAction.Equals:
          return "";
        case types_1.AttributeAction.Element:
          return "~";
        case types_1.AttributeAction.Start:
          return "^";
        case types_1.AttributeAction.End:
          return "$";
        case types_1.AttributeAction.Any:
          return "*";
        case types_1.AttributeAction.Not:
          return "!";
        case types_1.AttributeAction.Hyphen:
          return "|";
        case types_1.AttributeAction.Exists:
          throw new Error("Shouldn't be here");
      }
    }
    function getNamespacedName(token) {
      return "".concat(getNamespace(token.namespace)).concat(escapeName(token.name, charsToEscapeInName));
    }
    function getNamespace(namespace) {
      return namespace !== null ? "".concat(namespace === "*" ? "*" : escapeName(namespace, charsToEscapeInName), "|") : "";
    }
    function escapeName(str2, charsToEscape) {
      var lastIdx = 0;
      var ret = "";
      for (var i = 0; i < str2.length; i++) {
        if (charsToEscape.has(str2.charCodeAt(i))) {
          ret += "".concat(str2.slice(lastIdx, i), "\\").concat(str2.charAt(i));
          lastIdx = i + 1;
        }
      }
      return ret.length > 0 ? ret + str2.slice(lastIdx) : str2;
    }
  }
});

// node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/index.js
var require_commonjs = __commonJS({
  "node_modules/.pnpm/css-what@6.1.0/node_modules/css-what/lib/commonjs/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.stringify = exports.parse = exports.isTraversal = void 0;
    __exportStar(require_types3(), exports);
    var parse_1 = require_parse();
    Object.defineProperty(exports, "isTraversal", { enumerable: true, get: function() {
      return parse_1.isTraversal;
    } });
    Object.defineProperty(exports, "parse", { enumerable: true, get: function() {
      return parse_1.parse;
    } });
    var stringify_1 = require_stringify2();
    Object.defineProperty(exports, "stringify", { enumerable: true, get: function() {
      return stringify_1.stringify;
    } });
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/procedure.js
var require_procedure = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/procedure.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isTraversal = exports.procedure = void 0;
    exports.procedure = {
      universal: 50,
      tag: 30,
      attribute: 1,
      pseudo: 0,
      "pseudo-element": 0,
      "column-combinator": -1,
      descendant: -1,
      child: -1,
      parent: -1,
      sibling: -1,
      adjacent: -1,
      _flexibleDescendant: -1
    };
    function isTraversal(t) {
      return exports.procedure[t.type] < 0;
    }
    exports.isTraversal = isTraversal;
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/sort.js
var require_sort2 = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/sort.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var css_what_1 = require_commonjs();
    var procedure_1 = require_procedure();
    var attributes = {
      exists: 10,
      equals: 8,
      not: 7,
      start: 6,
      end: 6,
      any: 5,
      hyphen: 4,
      element: 4
    };
    function sortByProcedure(arr) {
      var procs = arr.map(getProcedure);
      for (var i = 1; i < arr.length; i++) {
        var procNew = procs[i];
        if (procNew < 0)
          continue;
        for (var j = i - 1; j >= 0 && procNew < procs[j]; j--) {
          var token = arr[j + 1];
          arr[j + 1] = arr[j];
          arr[j] = token;
          procs[j + 1] = procs[j];
          procs[j] = procNew;
        }
      }
    }
    exports.default = sortByProcedure;
    function getProcedure(token) {
      var proc = procedure_1.procedure[token.type];
      if (token.type === css_what_1.SelectorType.Attribute) {
        proc = attributes[token.action];
        if (proc === attributes.equals && token.name === "id") {
          proc = 9;
        }
        if (token.ignoreCase) {
          proc >>= 1;
        }
      } else if (token.type === css_what_1.SelectorType.Pseudo) {
        if (!token.data) {
          proc = 3;
        } else if (token.name === "has" || token.name === "contains") {
          proc = 0;
        } else if (Array.isArray(token.data)) {
          proc = 0;
          for (var i = 0; i < token.data.length; i++) {
            if (token.data[i].length !== 1)
              continue;
            var cur = getProcedure(token.data[i][0]);
            if (cur === 0) {
              proc = 0;
              break;
            }
            if (cur > proc)
              proc = cur;
          }
          if (token.data.length > 1 && proc > 0)
            proc -= 1;
        } else {
          proc = 1;
        }
      }
      return proc;
    }
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/attributes.js
var require_attributes = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/attributes.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.attributeRules = void 0;
    var boolbase_1 = require_boolbase();
    var reChars = /[-[\]{}()*+?.,\\^$|#\s]/g;
    function escapeRegex(value) {
      return value.replace(reChars, "\\$&");
    }
    var caseInsensitiveAttributes = /* @__PURE__ */ new Set([
      "accept",
      "accept-charset",
      "align",
      "alink",
      "axis",
      "bgcolor",
      "charset",
      "checked",
      "clear",
      "codetype",
      "color",
      "compact",
      "declare",
      "defer",
      "dir",
      "direction",
      "disabled",
      "enctype",
      "face",
      "frame",
      "hreflang",
      "http-equiv",
      "lang",
      "language",
      "link",
      "media",
      "method",
      "multiple",
      "nohref",
      "noresize",
      "noshade",
      "nowrap",
      "readonly",
      "rel",
      "rev",
      "rules",
      "scope",
      "scrolling",
      "selected",
      "shape",
      "target",
      "text",
      "type",
      "valign",
      "valuetype",
      "vlink"
    ]);
    function shouldIgnoreCase(selector, options) {
      return typeof selector.ignoreCase === "boolean" ? selector.ignoreCase : selector.ignoreCase === "quirks" ? !!options.quirksMode : !options.xmlMode && caseInsensitiveAttributes.has(selector.name);
    }
    exports.attributeRules = {
      equals: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        if (shouldIgnoreCase(data, options)) {
          value = value.toLowerCase();
          return function(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && attr.length === value.length && attr.toLowerCase() === value && next(elem);
          };
        }
        return function(elem) {
          return adapter.getAttributeValue(elem, name) === value && next(elem);
        };
      },
      hyphen: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        var len = value.length;
        if (shouldIgnoreCase(data, options)) {
          value = value.toLowerCase();
          return function hyphenIC(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && (attr.length === len || attr.charAt(len) === "-") && attr.substr(0, len).toLowerCase() === value && next(elem);
          };
        }
        return function hyphen(elem) {
          var attr = adapter.getAttributeValue(elem, name);
          return attr != null && (attr.length === len || attr.charAt(len) === "-") && attr.substr(0, len) === value && next(elem);
        };
      },
      element: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name, value = data.value;
        if (/\s/.test(value)) {
          return boolbase_1.falseFunc;
        }
        var regex = new RegExp("(?:^|\\s)".concat(escapeRegex(value), "(?:$|\\s)"), shouldIgnoreCase(data, options) ? "i" : "");
        return function element(elem) {
          var attr = adapter.getAttributeValue(elem, name);
          return attr != null && attr.length >= value.length && regex.test(attr) && next(elem);
        };
      },
      exists: function(next, _a, _b) {
        var name = _a.name;
        var adapter = _b.adapter;
        return function(elem) {
          return adapter.hasAttrib(elem, name) && next(elem);
        };
      },
      start: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        var len = value.length;
        if (len === 0) {
          return boolbase_1.falseFunc;
        }
        if (shouldIgnoreCase(data, options)) {
          value = value.toLowerCase();
          return function(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && attr.length >= len && attr.substr(0, len).toLowerCase() === value && next(elem);
          };
        }
        return function(elem) {
          var _a;
          return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.startsWith(value)) && next(elem);
        };
      },
      end: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        var len = -value.length;
        if (len === 0) {
          return boolbase_1.falseFunc;
        }
        if (shouldIgnoreCase(data, options)) {
          value = value.toLowerCase();
          return function(elem) {
            var _a;
            return ((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.substr(len).toLowerCase()) === value && next(elem);
          };
        }
        return function(elem) {
          var _a;
          return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.endsWith(value)) && next(elem);
        };
      },
      any: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name, value = data.value;
        if (value === "") {
          return boolbase_1.falseFunc;
        }
        if (shouldIgnoreCase(data, options)) {
          var regex_1 = new RegExp(escapeRegex(value), "i");
          return function anyIC(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && attr.length >= value.length && regex_1.test(attr) && next(elem);
          };
        }
        return function(elem) {
          var _a;
          return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.includes(value)) && next(elem);
        };
      },
      not: function(next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        if (value === "") {
          return function(elem) {
            return !!adapter.getAttributeValue(elem, name) && next(elem);
          };
        } else if (shouldIgnoreCase(data, options)) {
          value = value.toLowerCase();
          return function(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return (attr == null || attr.length !== value.length || attr.toLowerCase() !== value) && next(elem);
          };
        }
        return function(elem) {
          return adapter.getAttributeValue(elem, name) !== value && next(elem);
        };
      }
    };
  }
});

// node_modules/.pnpm/nth-check@2.1.1/node_modules/nth-check/lib/parse.js
var require_parse2 = __commonJS({
  "node_modules/.pnpm/nth-check@2.1.1/node_modules/nth-check/lib/parse.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.parse = void 0;
    var whitespace = /* @__PURE__ */ new Set([9, 10, 12, 13, 32]);
    var ZERO = "0".charCodeAt(0);
    var NINE = "9".charCodeAt(0);
    function parse(formula) {
      formula = formula.trim().toLowerCase();
      if (formula === "even") {
        return [2, 0];
      } else if (formula === "odd") {
        return [2, 1];
      }
      var idx2 = 0;
      var a = 0;
      var sign = readSign();
      var number = readNumber();
      if (idx2 < formula.length && formula.charAt(idx2) === "n") {
        idx2++;
        a = sign * (number !== null && number !== void 0 ? number : 1);
        skipWhitespace();
        if (idx2 < formula.length) {
          sign = readSign();
          skipWhitespace();
          number = readNumber();
        } else {
          sign = number = 0;
        }
      }
      if (number === null || idx2 < formula.length) {
        throw new Error("n-th rule couldn't be parsed ('".concat(formula, "')"));
      }
      return [a, sign * number];
      function readSign() {
        if (formula.charAt(idx2) === "-") {
          idx2++;
          return -1;
        }
        if (formula.charAt(idx2) === "+") {
          idx2++;
        }
        return 1;
      }
      function readNumber() {
        var start = idx2;
        var value = 0;
        while (idx2 < formula.length && formula.charCodeAt(idx2) >= ZERO && formula.charCodeAt(idx2) <= NINE) {
          value = value * 10 + (formula.charCodeAt(idx2) - ZERO);
          idx2++;
        }
        return idx2 === start ? null : value;
      }
      function skipWhitespace() {
        while (idx2 < formula.length && whitespace.has(formula.charCodeAt(idx2))) {
          idx2++;
        }
      }
    }
    exports.parse = parse;
  }
});

// node_modules/.pnpm/nth-check@2.1.1/node_modules/nth-check/lib/compile.js
var require_compile = __commonJS({
  "node_modules/.pnpm/nth-check@2.1.1/node_modules/nth-check/lib/compile.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.generate = exports.compile = void 0;
    var boolbase_1 = __importDefault(require_boolbase());
    function compile(parsed) {
      var a = parsed[0];
      var b = parsed[1] - 1;
      if (b < 0 && a <= 0)
        return boolbase_1.default.falseFunc;
      if (a === -1)
        return function(index) {
          return index <= b;
        };
      if (a === 0)
        return function(index) {
          return index === b;
        };
      if (a === 1)
        return b < 0 ? boolbase_1.default.trueFunc : function(index) {
          return index >= b;
        };
      var absA = Math.abs(a);
      var bMod = (b % absA + absA) % absA;
      return a > 1 ? function(index) {
        return index >= b && index % absA === bMod;
      } : function(index) {
        return index <= b && index % absA === bMod;
      };
    }
    exports.compile = compile;
    function generate(parsed) {
      var a = parsed[0];
      var b = parsed[1] - 1;
      var n = 0;
      if (a < 0) {
        var aPos_1 = -a;
        var minValue_1 = (b % aPos_1 + aPos_1) % aPos_1;
        return function() {
          var val = minValue_1 + aPos_1 * n++;
          return val > b ? null : val;
        };
      }
      if (a === 0)
        return b < 0 ? function() {
          return null;
        } : function() {
          return n++ === 0 ? b : null;
        };
      if (b < 0) {
        b += a * Math.ceil(-b / a);
      }
      return function() {
        return a * n++ + b;
      };
    }
    exports.generate = generate;
  }
});

// node_modules/.pnpm/nth-check@2.1.1/node_modules/nth-check/lib/index.js
var require_lib13 = __commonJS({
  "node_modules/.pnpm/nth-check@2.1.1/node_modules/nth-check/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.sequence = exports.generate = exports.compile = exports.parse = void 0;
    var parse_js_1 = require_parse2();
    Object.defineProperty(exports, "parse", { enumerable: true, get: function() {
      return parse_js_1.parse;
    } });
    var compile_js_1 = require_compile();
    Object.defineProperty(exports, "compile", { enumerable: true, get: function() {
      return compile_js_1.compile;
    } });
    Object.defineProperty(exports, "generate", { enumerable: true, get: function() {
      return compile_js_1.generate;
    } });
    function nthCheck(formula) {
      return (0, compile_js_1.compile)((0, parse_js_1.parse)(formula));
    }
    exports.default = nthCheck;
    function sequence(formula) {
      return (0, compile_js_1.generate)((0, parse_js_1.parse)(formula));
    }
    exports.sequence = sequence;
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/filters.js
var require_filters = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/filters.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.filters = void 0;
    var nth_check_1 = __importDefault(require_lib13());
    var boolbase_1 = require_boolbase();
    function getChildFunc(next, adapter) {
      return function(elem) {
        var parent = adapter.getParent(elem);
        return parent != null && adapter.isTag(parent) && next(elem);
      };
    }
    exports.filters = {
      contains: function(next, text, _a) {
        var adapter = _a.adapter;
        return function contains(elem) {
          return next(elem) && adapter.getText(elem).includes(text);
        };
      },
      icontains: function(next, text, _a) {
        var adapter = _a.adapter;
        var itext = text.toLowerCase();
        return function icontains(elem) {
          return next(elem) && adapter.getText(elem).toLowerCase().includes(itext);
        };
      },
      "nth-child": function(next, rule, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var func = (0, nth_check_1.default)(rule);
        if (func === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthChild(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i = 0; i < siblings.length; i++) {
            if (equals(elem, siblings[i]))
              break;
            if (adapter.isTag(siblings[i])) {
              pos++;
            }
          }
          return func(pos) && next(elem);
        };
      },
      "nth-last-child": function(next, rule, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var func = (0, nth_check_1.default)(rule);
        if (func === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthLastChild(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i = siblings.length - 1; i >= 0; i--) {
            if (equals(elem, siblings[i]))
              break;
            if (adapter.isTag(siblings[i])) {
              pos++;
            }
          }
          return func(pos) && next(elem);
        };
      },
      "nth-of-type": function(next, rule, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var func = (0, nth_check_1.default)(rule);
        if (func === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthOfType(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i = 0; i < siblings.length; i++) {
            var currentSibling = siblings[i];
            if (equals(elem, currentSibling))
              break;
            if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === adapter.getName(elem)) {
              pos++;
            }
          }
          return func(pos) && next(elem);
        };
      },
      "nth-last-of-type": function(next, rule, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var func = (0, nth_check_1.default)(rule);
        if (func === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthLastOfType(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i = siblings.length - 1; i >= 0; i--) {
            var currentSibling = siblings[i];
            if (equals(elem, currentSibling))
              break;
            if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === adapter.getName(elem)) {
              pos++;
            }
          }
          return func(pos) && next(elem);
        };
      },
      root: function(next, _rule, _a) {
        var adapter = _a.adapter;
        return function(elem) {
          var parent = adapter.getParent(elem);
          return (parent == null || !adapter.isTag(parent)) && next(elem);
        };
      },
      scope: function(next, rule, options, context) {
        var equals = options.equals;
        if (!context || context.length === 0) {
          return exports.filters.root(next, rule, options);
        }
        if (context.length === 1) {
          return function(elem) {
            return equals(context[0], elem) && next(elem);
          };
        }
        return function(elem) {
          return context.includes(elem) && next(elem);
        };
      },
      hover: dynamicStatePseudo("isHovered"),
      visited: dynamicStatePseudo("isVisited"),
      active: dynamicStatePseudo("isActive")
    };
    function dynamicStatePseudo(name) {
      return function dynamicPseudo(next, _rule, _a) {
        var adapter = _a.adapter;
        var func = adapter[name];
        if (typeof func !== "function") {
          return boolbase_1.falseFunc;
        }
        return function active(elem) {
          return func(elem) && next(elem);
        };
      };
    }
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/pseudos.js
var require_pseudos = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/pseudos.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.verifyPseudoArgs = exports.pseudos = void 0;
    exports.pseudos = {
      empty: function(elem, _a) {
        var adapter = _a.adapter;
        return !adapter.getChildren(elem).some(function(elem2) {
          return adapter.isTag(elem2) || adapter.getText(elem2) !== "";
        });
      },
      "first-child": function(elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var firstChild = adapter.getSiblings(elem).find(function(elem2) {
          return adapter.isTag(elem2);
        });
        return firstChild != null && equals(elem, firstChild);
      },
      "last-child": function(elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var siblings = adapter.getSiblings(elem);
        for (var i = siblings.length - 1; i >= 0; i--) {
          if (equals(elem, siblings[i]))
            return true;
          if (adapter.isTag(siblings[i]))
            break;
        }
        return false;
      },
      "first-of-type": function(elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var siblings = adapter.getSiblings(elem);
        var elemName = adapter.getName(elem);
        for (var i = 0; i < siblings.length; i++) {
          var currentSibling = siblings[i];
          if (equals(elem, currentSibling))
            return true;
          if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === elemName) {
            break;
          }
        }
        return false;
      },
      "last-of-type": function(elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var siblings = adapter.getSiblings(elem);
        var elemName = adapter.getName(elem);
        for (var i = siblings.length - 1; i >= 0; i--) {
          var currentSibling = siblings[i];
          if (equals(elem, currentSibling))
            return true;
          if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === elemName) {
            break;
          }
        }
        return false;
      },
      "only-of-type": function(elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var elemName = adapter.getName(elem);
        return adapter.getSiblings(elem).every(function(sibling) {
          return equals(elem, sibling) || !adapter.isTag(sibling) || adapter.getName(sibling) !== elemName;
        });
      },
      "only-child": function(elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        return adapter.getSiblings(elem).every(function(sibling) {
          return equals(elem, sibling) || !adapter.isTag(sibling);
        });
      }
    };
    function verifyPseudoArgs(func, name, subselect) {
      if (subselect === null) {
        if (func.length > 2) {
          throw new Error("pseudo-selector :".concat(name, " requires an argument"));
        }
      } else if (func.length === 2) {
        throw new Error("pseudo-selector :".concat(name, " doesn't have any arguments"));
      }
    }
    exports.verifyPseudoArgs = verifyPseudoArgs;
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/aliases.js
var require_aliases = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/aliases.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.aliases = void 0;
    exports.aliases = {
      "any-link": ":is(a, area, link)[href]",
      link: ":any-link:not(:visited)",
      disabled: ":is(\n        :is(button, input, select, textarea, optgroup, option)[disabled],\n        optgroup[disabled] > option,\n        fieldset[disabled]:not(fieldset[disabled] legend:first-of-type *)\n    )",
      enabled: ":not(:disabled)",
      checked: ":is(:is(input[type=radio], input[type=checkbox])[checked], option:selected)",
      required: ":is(input, select, textarea)[required]",
      optional: ":is(input, select, textarea):not([required])",
      selected: "option:is([selected], select:not([multiple]):not(:has(> option[selected])) > :first-of-type)",
      checkbox: "[type=checkbox]",
      file: "[type=file]",
      password: "[type=password]",
      radio: "[type=radio]",
      reset: "[type=reset]",
      image: "[type=image]",
      submit: "[type=submit]",
      parent: ":not(:empty)",
      header: ":is(h1, h2, h3, h4, h5, h6)",
      button: ":is(button, input[type=button])",
      input: ":is(input, textarea, select, button)",
      text: "input:is(:not([type!='']), [type=text])"
    };
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/subselects.js
var require_subselects = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/subselects.js"(exports) {
    "use strict";
    var __spreadArray = exports && exports.__spreadArray || function(to, from, pack) {
      if (pack || arguments.length === 2)
        for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
            if (!ar)
              ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
          }
        }
      return to.concat(ar || Array.prototype.slice.call(from));
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.subselects = exports.getNextSiblings = exports.ensureIsTag = exports.PLACEHOLDER_ELEMENT = void 0;
    var boolbase_1 = require_boolbase();
    var procedure_1 = require_procedure();
    exports.PLACEHOLDER_ELEMENT = {};
    function ensureIsTag(next, adapter) {
      if (next === boolbase_1.falseFunc)
        return boolbase_1.falseFunc;
      return function(elem) {
        return adapter.isTag(elem) && next(elem);
      };
    }
    exports.ensureIsTag = ensureIsTag;
    function getNextSiblings(elem, adapter) {
      var siblings = adapter.getSiblings(elem);
      if (siblings.length <= 1)
        return [];
      var elemIndex = siblings.indexOf(elem);
      if (elemIndex < 0 || elemIndex === siblings.length - 1)
        return [];
      return siblings.slice(elemIndex + 1).filter(adapter.isTag);
    }
    exports.getNextSiblings = getNextSiblings;
    var is = function(next, token, options, context, compileToken) {
      var opts = {
        xmlMode: !!options.xmlMode,
        adapter: options.adapter,
        equals: options.equals
      };
      var func = compileToken(token, opts, context);
      return function(elem) {
        return func(elem) && next(elem);
      };
    };
    exports.subselects = {
      is,
      matches: is,
      where: is,
      not: function(next, token, options, context, compileToken) {
        var opts = {
          xmlMode: !!options.xmlMode,
          adapter: options.adapter,
          equals: options.equals
        };
        var func = compileToken(token, opts, context);
        if (func === boolbase_1.falseFunc)
          return next;
        if (func === boolbase_1.trueFunc)
          return boolbase_1.falseFunc;
        return function not(elem) {
          return !func(elem) && next(elem);
        };
      },
      has: function(next, subselect, options, _context, compileToken) {
        var adapter = options.adapter;
        var opts = {
          xmlMode: !!options.xmlMode,
          adapter,
          equals: options.equals
        };
        var context = subselect.some(function(s) {
          return s.some(procedure_1.isTraversal);
        }) ? [exports.PLACEHOLDER_ELEMENT] : void 0;
        var compiled = compileToken(subselect, opts, context);
        if (compiled === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (compiled === boolbase_1.trueFunc) {
          return function(elem) {
            return adapter.getChildren(elem).some(adapter.isTag) && next(elem);
          };
        }
        var hasElement = ensureIsTag(compiled, adapter);
        var _a = compiled.shouldTestNextSiblings, shouldTestNextSiblings = _a === void 0 ? false : _a;
        if (context) {
          return function(elem) {
            context[0] = elem;
            var childs = adapter.getChildren(elem);
            var nextElements = shouldTestNextSiblings ? __spreadArray(__spreadArray([], childs, true), getNextSiblings(elem, adapter), true) : childs;
            return next(elem) && adapter.existsOne(hasElement, nextElements);
          };
        }
        return function(elem) {
          return next(elem) && adapter.existsOne(hasElement, adapter.getChildren(elem));
        };
      }
    };
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/index.js
var require_pseudo_selectors = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/pseudo-selectors/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.compilePseudoSelector = exports.aliases = exports.pseudos = exports.filters = void 0;
    var boolbase_1 = require_boolbase();
    var css_what_1 = require_commonjs();
    var filters_1 = require_filters();
    Object.defineProperty(exports, "filters", { enumerable: true, get: function() {
      return filters_1.filters;
    } });
    var pseudos_1 = require_pseudos();
    Object.defineProperty(exports, "pseudos", { enumerable: true, get: function() {
      return pseudos_1.pseudos;
    } });
    var aliases_1 = require_aliases();
    Object.defineProperty(exports, "aliases", { enumerable: true, get: function() {
      return aliases_1.aliases;
    } });
    var subselects_1 = require_subselects();
    function compilePseudoSelector(next, selector, options, context, compileToken) {
      var name = selector.name, data = selector.data;
      if (Array.isArray(data)) {
        return subselects_1.subselects[name](next, data, options, context, compileToken);
      }
      if (name in aliases_1.aliases) {
        if (data != null) {
          throw new Error("Pseudo ".concat(name, " doesn't have any arguments"));
        }
        var alias = (0, css_what_1.parse)(aliases_1.aliases[name]);
        return subselects_1.subselects.is(next, alias, options, context, compileToken);
      }
      if (name in filters_1.filters) {
        return filters_1.filters[name](next, data, options, context);
      }
      if (name in pseudos_1.pseudos) {
        var pseudo_1 = pseudos_1.pseudos[name];
        (0, pseudos_1.verifyPseudoArgs)(pseudo_1, name, data);
        return pseudo_1 === boolbase_1.falseFunc ? boolbase_1.falseFunc : next === boolbase_1.trueFunc ? function(elem) {
          return pseudo_1(elem, options, data);
        } : function(elem) {
          return pseudo_1(elem, options, data) && next(elem);
        };
      }
      throw new Error("unmatched pseudo-class :".concat(name));
    }
    exports.compilePseudoSelector = compilePseudoSelector;
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/general.js
var require_general = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/general.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.compileGeneralSelector = void 0;
    var attributes_1 = require_attributes();
    var pseudo_selectors_1 = require_pseudo_selectors();
    var css_what_1 = require_commonjs();
    function compileGeneralSelector(next, selector, options, context, compileToken) {
      var adapter = options.adapter, equals = options.equals;
      switch (selector.type) {
        case css_what_1.SelectorType.PseudoElement: {
          throw new Error("Pseudo-elements are not supported by css-select");
        }
        case css_what_1.SelectorType.ColumnCombinator: {
          throw new Error("Column combinators are not yet supported by css-select");
        }
        case css_what_1.SelectorType.Attribute: {
          if (selector.namespace != null) {
            throw new Error("Namespaced attributes are not yet supported by css-select");
          }
          if (!options.xmlMode || options.lowerCaseAttributeNames) {
            selector.name = selector.name.toLowerCase();
          }
          return attributes_1.attributeRules[selector.action](next, selector, options);
        }
        case css_what_1.SelectorType.Pseudo: {
          return (0, pseudo_selectors_1.compilePseudoSelector)(next, selector, options, context, compileToken);
        }
        case css_what_1.SelectorType.Tag: {
          if (selector.namespace != null) {
            throw new Error("Namespaced tag names are not yet supported by css-select");
          }
          var name_1 = selector.name;
          if (!options.xmlMode || options.lowerCaseTags) {
            name_1 = name_1.toLowerCase();
          }
          return function tag(elem) {
            return adapter.getName(elem) === name_1 && next(elem);
          };
        }
        case css_what_1.SelectorType.Descendant: {
          if (options.cacheResults === false || typeof WeakSet === "undefined") {
            return function descendant(elem) {
              var current = elem;
              while (current = adapter.getParent(current)) {
                if (adapter.isTag(current) && next(current)) {
                  return true;
                }
              }
              return false;
            };
          }
          var isFalseCache_1 = /* @__PURE__ */ new WeakSet();
          return function cachedDescendant(elem) {
            var current = elem;
            while (current = adapter.getParent(current)) {
              if (!isFalseCache_1.has(current)) {
                if (adapter.isTag(current) && next(current)) {
                  return true;
                }
                isFalseCache_1.add(current);
              }
            }
            return false;
          };
        }
        case "_flexibleDescendant": {
          return function flexibleDescendant(elem) {
            var current = elem;
            do {
              if (adapter.isTag(current) && next(current))
                return true;
            } while (current = adapter.getParent(current));
            return false;
          };
        }
        case css_what_1.SelectorType.Parent: {
          return function parent(elem) {
            return adapter.getChildren(elem).some(function(elem2) {
              return adapter.isTag(elem2) && next(elem2);
            });
          };
        }
        case css_what_1.SelectorType.Child: {
          return function child(elem) {
            var parent = adapter.getParent(elem);
            return parent != null && adapter.isTag(parent) && next(parent);
          };
        }
        case css_what_1.SelectorType.Sibling: {
          return function sibling(elem) {
            var siblings = adapter.getSiblings(elem);
            for (var i = 0; i < siblings.length; i++) {
              var currentSibling = siblings[i];
              if (equals(elem, currentSibling))
                break;
              if (adapter.isTag(currentSibling) && next(currentSibling)) {
                return true;
              }
            }
            return false;
          };
        }
        case css_what_1.SelectorType.Adjacent: {
          if (adapter.prevElementSibling) {
            return function adjacent(elem) {
              var previous = adapter.prevElementSibling(elem);
              return previous != null && next(previous);
            };
          }
          return function adjacent(elem) {
            var siblings = adapter.getSiblings(elem);
            var lastElement;
            for (var i = 0; i < siblings.length; i++) {
              var currentSibling = siblings[i];
              if (equals(elem, currentSibling))
                break;
              if (adapter.isTag(currentSibling)) {
                lastElement = currentSibling;
              }
            }
            return !!lastElement && next(lastElement);
          };
        }
        case css_what_1.SelectorType.Universal: {
          if (selector.namespace != null && selector.namespace !== "*") {
            throw new Error("Namespaced universal selectors are not yet supported by css-select");
          }
          return next;
        }
      }
    }
    exports.compileGeneralSelector = compileGeneralSelector;
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/compile.js
var require_compile2 = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/compile.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.compileToken = exports.compileUnsafe = exports.compile = void 0;
    var css_what_1 = require_commonjs();
    var boolbase_1 = require_boolbase();
    var sort_1 = __importDefault(require_sort2());
    var procedure_1 = require_procedure();
    var general_1 = require_general();
    var subselects_1 = require_subselects();
    function compile(selector, options, context) {
      var next = compileUnsafe(selector, options, context);
      return (0, subselects_1.ensureIsTag)(next, options.adapter);
    }
    exports.compile = compile;
    function compileUnsafe(selector, options, context) {
      var token = typeof selector === "string" ? (0, css_what_1.parse)(selector) : selector;
      return compileToken(token, options, context);
    }
    exports.compileUnsafe = compileUnsafe;
    function includesScopePseudo(t) {
      return t.type === "pseudo" && (t.name === "scope" || Array.isArray(t.data) && t.data.some(function(data) {
        return data.some(includesScopePseudo);
      }));
    }
    var DESCENDANT_TOKEN = { type: css_what_1.SelectorType.Descendant };
    var FLEXIBLE_DESCENDANT_TOKEN = {
      type: "_flexibleDescendant"
    };
    var SCOPE_TOKEN = {
      type: css_what_1.SelectorType.Pseudo,
      name: "scope",
      data: null
    };
    function absolutize(token, _a, context) {
      var adapter = _a.adapter;
      var hasContext = !!(context === null || context === void 0 ? void 0 : context.every(function(e) {
        var parent = adapter.isTag(e) && adapter.getParent(e);
        return e === subselects_1.PLACEHOLDER_ELEMENT || parent && adapter.isTag(parent);
      }));
      for (var _i = 0, token_1 = token; _i < token_1.length; _i++) {
        var t = token_1[_i];
        if (t.length > 0 && (0, procedure_1.isTraversal)(t[0]) && t[0].type !== "descendant") {
        } else if (hasContext && !t.some(includesScopePseudo)) {
          t.unshift(DESCENDANT_TOKEN);
        } else {
          continue;
        }
        t.unshift(SCOPE_TOKEN);
      }
    }
    function compileToken(token, options, context) {
      var _a;
      token = token.filter(function(t) {
        return t.length > 0;
      });
      token.forEach(sort_1.default);
      context = (_a = options.context) !== null && _a !== void 0 ? _a : context;
      var isArrayContext = Array.isArray(context);
      var finalContext = context && (Array.isArray(context) ? context : [context]);
      absolutize(token, options, finalContext);
      var shouldTestNextSiblings = false;
      var query = token.map(function(rules) {
        if (rules.length >= 2) {
          var first = rules[0], second = rules[1];
          if (first.type !== "pseudo" || first.name !== "scope") {
          } else if (isArrayContext && second.type === "descendant") {
            rules[1] = FLEXIBLE_DESCENDANT_TOKEN;
          } else if (second.type === "adjacent" || second.type === "sibling") {
            shouldTestNextSiblings = true;
          }
        }
        return compileRules(rules, options, finalContext);
      }).reduce(reduceRules, boolbase_1.falseFunc);
      query.shouldTestNextSiblings = shouldTestNextSiblings;
      return query;
    }
    exports.compileToken = compileToken;
    function compileRules(rules, options, context) {
      var _a;
      return rules.reduce(function(previous, rule) {
        return previous === boolbase_1.falseFunc ? boolbase_1.falseFunc : (0, general_1.compileGeneralSelector)(previous, rule, options, context, compileToken);
      }, (_a = options.rootFunc) !== null && _a !== void 0 ? _a : boolbase_1.trueFunc);
    }
    function reduceRules(a, b) {
      if (b === boolbase_1.falseFunc || a === boolbase_1.trueFunc) {
        return a;
      }
      if (a === boolbase_1.falseFunc || b === boolbase_1.trueFunc) {
        return b;
      }
      return function combine(elem) {
        return a(elem) || b(elem);
      };
    }
  }
});

// node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/index.js
var require_lib14 = __commonJS({
  "node_modules/.pnpm/css-select@4.3.0/node_modules/css-select/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.aliases = exports.pseudos = exports.filters = exports.is = exports.selectOne = exports.selectAll = exports.prepareContext = exports._compileToken = exports._compileUnsafe = exports.compile = void 0;
    var DomUtils = __importStar(require_lib11());
    var boolbase_1 = require_boolbase();
    var compile_1 = require_compile2();
    var subselects_1 = require_subselects();
    var defaultEquals = function(a, b) {
      return a === b;
    };
    var defaultOptions = {
      adapter: DomUtils,
      equals: defaultEquals
    };
    function convertOptionFormats(options) {
      var _a, _b, _c, _d;
      var opts = options !== null && options !== void 0 ? options : defaultOptions;
      (_a = opts.adapter) !== null && _a !== void 0 ? _a : opts.adapter = DomUtils;
      (_b = opts.equals) !== null && _b !== void 0 ? _b : opts.equals = (_d = (_c = opts.adapter) === null || _c === void 0 ? void 0 : _c.equals) !== null && _d !== void 0 ? _d : defaultEquals;
      return opts;
    }
    function wrapCompile(func) {
      return function addAdapter(selector, options, context) {
        var opts = convertOptionFormats(options);
        return func(selector, opts, context);
      };
    }
    exports.compile = wrapCompile(compile_1.compile);
    exports._compileUnsafe = wrapCompile(compile_1.compileUnsafe);
    exports._compileToken = wrapCompile(compile_1.compileToken);
    function getSelectorFunc(searchFunc) {
      return function select(query, elements, options) {
        var opts = convertOptionFormats(options);
        if (typeof query !== "function") {
          query = (0, compile_1.compileUnsafe)(query, opts, elements);
        }
        var filteredElements = prepareContext(elements, opts.adapter, query.shouldTestNextSiblings);
        return searchFunc(query, filteredElements, opts);
      };
    }
    function prepareContext(elems, adapter, shouldTestNextSiblings) {
      if (shouldTestNextSiblings === void 0) {
        shouldTestNextSiblings = false;
      }
      if (shouldTestNextSiblings) {
        elems = appendNextSiblings(elems, adapter);
      }
      return Array.isArray(elems) ? adapter.removeSubsets(elems) : adapter.getChildren(elems);
    }
    exports.prepareContext = prepareContext;
    function appendNextSiblings(elem, adapter) {
      var elems = Array.isArray(elem) ? elem.slice(0) : [elem];
      var elemsLength = elems.length;
      for (var i = 0; i < elemsLength; i++) {
        var nextSiblings = (0, subselects_1.getNextSiblings)(elems[i], adapter);
        elems.push.apply(elems, nextSiblings);
      }
      return elems;
    }
    exports.selectAll = getSelectorFunc(function(query, elems, options) {
      return query === boolbase_1.falseFunc || !elems || elems.length === 0 ? [] : options.adapter.findAll(query, elems);
    });
    exports.selectOne = getSelectorFunc(function(query, elems, options) {
      return query === boolbase_1.falseFunc || !elems || elems.length === 0 ? null : options.adapter.findOne(query, elems);
    });
    function is(elem, query, options) {
      var opts = convertOptionFormats(options);
      return (typeof query === "function" ? query : (0, compile_1.compile)(query, opts))(elem);
    }
    exports.is = is;
    exports.default = exports.selectAll;
    var pseudo_selectors_1 = require_pseudo_selectors();
    Object.defineProperty(exports, "filters", { enumerable: true, get: function() {
      return pseudo_selectors_1.filters;
    } });
    Object.defineProperty(exports, "pseudos", { enumerable: true, get: function() {
      return pseudo_selectors_1.pseudos;
    } });
    Object.defineProperty(exports, "aliases", { enumerable: true, get: function() {
      return pseudo_selectors_1.aliases;
    } });
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/Selector.js
var require_Selector = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/Selector.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var CSSSelect;
    var Selector;
    CSSSelect = require_lib14();
    module2.exports = Selector = function() {
      var self2;
      var Selector2 = /* @__PURE__ */ function() {
        function Selector3(text1) {
          _classCallCheck(this, Selector3);
          this.text = text1;
          this._fn = CSSSelect.compile(this.text);
          this.priority = self2.calculatePriority(this.text);
        }
        _createClass(Selector3, [{
          key: "matches",
          value: function matches(elem) {
            return CSSSelect.is(elem, this._fn);
          }
        }], [{
          key: "calculatePriority",
          value: function calculatePriority(text) {
            var n, priotrity;
            priotrity = 0;
            if (n = text.match(/[\#]{1}/g)) {
              priotrity += 100 * n.length;
            }
            if (n = text.match(/[a-zA-Z]+/g)) {
              priotrity += 2 * n.length;
            }
            if (n = text.match(/\*/g)) {
              priotrity += 1 * n.length;
            }
            return priotrity;
          }
        }]);
        return Selector3;
      }();
      ;
      self2 = Selector2;
      return Selector2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Declaration.js
var require_Declaration = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Declaration.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _Declaration;
    module2.exports = _Declaration = function() {
      var self2;
      var _Declaration2 = /* @__PURE__ */ function() {
        function _Declaration3(prop1, val) {
          _classCallCheck(this, _Declaration3);
          this.prop = prop1;
          this.important = false;
          this.set(val);
        }
        _createClass(_Declaration3, [{
          key: "get",
          value: function get() {
            return this._get();
          }
        }, {
          key: "_get",
          value: function _get() {
            return this.val;
          }
        }, {
          key: "_pickImportantClause",
          value: function _pickImportantClause(val) {
            if (self2.importantClauseRx.test(String(val))) {
              this.important = true;
              return val.replace(self2.importantClauseRx, "");
            } else {
              this.important = false;
              return val;
            }
          }
        }, {
          key: "set",
          value: function set2(val) {
            val = self2.sanitizeValue(val);
            val = this._pickImportantClause(val);
            val = val.trim();
            if (this._handleNullOrInherit(val)) {
              return this;
            }
            this._set(val);
            return this;
          }
        }, {
          key: "_set",
          value: function _set(val) {
            return this.val = val;
          }
        }, {
          key: "_handleNullOrInherit",
          value: function _handleNullOrInherit(val) {
            if (val === "") {
              this.val = "";
              return true;
            }
            if (val === "inherit") {
              if (this.constructor.inheritAllowed) {
                this.val = "inherit";
              } else {
                throw Error("Inherit is not allowed for `".concat(this.prop, "`"));
              }
              return true;
            } else {
              return false;
            }
          }
        }], [{
          key: "setOnto",
          value: function setOnto(declarations, prop, val) {
            var dec;
            if (!(dec = declarations[prop])) {
              return declarations[prop] = new this(prop, val);
            } else {
              return dec.set(val);
            }
          }
        }, {
          key: "sanitizeValue",
          value: function sanitizeValue(val) {
            return String(val).trim().replace(/[\s]+/g, " ");
          }
        }]);
        return _Declaration3;
      }();
      ;
      self2 = _Declaration2;
      _Declaration2.importantClauseRx = /(\s\!important)$/;
      _Declaration2.inheritAllowed = false;
      return _Declaration2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Arbitrary.js
var require_Arbitrary = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Arbitrary.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Arbitrary;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Arbitrary = /* @__PURE__ */ function(_Declaration2) {
      _inherits(Arbitrary2, _Declaration2);
      var _super = _createSuper(Arbitrary2);
      function Arbitrary2() {
        _classCallCheck(this, Arbitrary2);
        return _super.apply(this, arguments);
      }
      return Arbitrary2;
    }(_Declaration);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Color.js
var require_Color = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Color.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Color;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Color = /* @__PURE__ */ function(_Declaration2) {
      _inherits(Color2, _Declaration2);
      var _super = _createSuper(Color2);
      function Color2() {
        _classCallCheck(this, Color2);
        return _super.apply(this, arguments);
      }
      return Color2;
    }(_Declaration);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Background.js
var require_Background = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Background.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Background;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Background = /* @__PURE__ */ function(_Declaration2) {
      _inherits(Background2, _Declaration2);
      var _super = _createSuper(Background2);
      function Background2() {
        _classCallCheck(this, Background2);
        return _super.apply(this, arguments);
      }
      return Background2;
    }(_Declaration);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Length.js
var require_Length = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Length.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var _Declaration;
    var _Length;
    _Declaration = require_Declaration();
    module2.exports = _Length = /* @__PURE__ */ function(_Declaration2) {
      _inherits(_Length2, _Declaration2);
      var _super = _createSuper(_Length2);
      function _Length2() {
        _classCallCheck(this, _Length2);
        return _super.apply(this, arguments);
      }
      _createClass(_Length2, [{
        key: "_set",
        value: function _set(val) {
          if (!/^[0-9]+$/.test(String(val))) {
            throw Error("`".concat(this.prop, "` only takes an integer for value"));
          }
          return this.val = parseInt(val);
        }
      }]);
      return _Length2;
    }(_Declaration);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Width.js
var require_Width = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Width.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Width;
    var _Length;
    _Length = require_Length();
    module2.exports = Width = /* @__PURE__ */ function(_Length2) {
      _inherits(Width2, _Length2);
      var _super = _createSuper(Width2);
      function Width2() {
        _classCallCheck(this, Width2);
        return _super.apply(this, arguments);
      }
      return Width2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Height.js
var require_Height = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Height.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Height;
    var _Length;
    _Length = require_Length();
    module2.exports = Height = /* @__PURE__ */ function(_Length2) {
      _inherits(Height2, _Length2);
      var _super = _createSuper(Height2);
      function Height2() {
        _classCallCheck(this, Height2);
        return _super.apply(this, arguments);
      }
      return Height2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Bullet.js
var require_Bullet = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Bullet.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Bullet;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Bullet = function() {
      var self2;
      var Bullet2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Bullet3, _Declaration2);
        var _super = _createSuper(Bullet3);
        function Bullet3() {
          _classCallCheck(this, Bullet3);
          return _super.apply(this, arguments);
        }
        _createClass(Bullet3, [{
          key: "_set",
          value: function _set(val) {
            var alignment, bg, char, color, enabled, m, original;
            val = String(val);
            original = val;
            char = null;
            enabled = false;
            color = "none";
            bg = "none";
            if (m = val.match(/\"([^"]+)\"/) || (m = val.match(/\'([^']+)\'/))) {
              char = m[1];
              val = val.replace(m[0], "");
              enabled = true;
            }
            if (m = val.match(/(none|left|right|center)/)) {
              alignment = m[1];
              val = val.replace(m[0], "");
            } else {
              alignment = "left";
            }
            if (alignment === "none") {
              enabled = false;
            }
            if (m = val.match(/color\:([\w\-]+)/)) {
              color = m[1];
              val = val.replace(m[0], "");
            }
            if (m = val.match(/bg\:([\w\-]+)/)) {
              bg = m[1];
              val = val.replace(m[0], "");
            }
            if (val.trim() !== "") {
              throw Error("Unrecognizable value `".concat(original, "` for `").concat(this.prop, "`"));
            }
            return this.val = {
              enabled,
              char,
              alignment,
              background: bg,
              color
            };
          }
        }]);
        return Bullet3;
      }(_Declaration);
      ;
      self2 = Bullet2;
      return Bullet2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Display.js
var require_Display = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Display.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Display;
    var _Declaration;
    var indexOf = [].indexOf;
    _Declaration = require_Declaration();
    module2.exports = Display = function() {
      var self2;
      var Display2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Display3, _Declaration2);
        var _super = _createSuper(Display3);
        function Display3() {
          _classCallCheck(this, Display3);
          return _super.apply(this, arguments);
        }
        _createClass(Display3, [{
          key: "_set",
          value: function _set(val) {
            val = String(val).toLowerCase();
            if (indexOf.call(self2._allowed, val) < 0) {
              throw Error("Unrecognizable value `".concat(val, "` for `").concat(this.prop, "`"));
            }
            return this.val = val;
          }
        }]);
        return Display3;
      }(_Declaration);
      ;
      self2 = Display2;
      Display2._allowed = ["inline", "block", "none"];
      return Display2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginTop.js
var require_MarginTop = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginTop.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var MarginTop;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginTop = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginTop2, _Length2);
      var _super = _createSuper(MarginTop2);
      function MarginTop2() {
        _classCallCheck(this, MarginTop2);
        return _super.apply(this, arguments);
      }
      return MarginTop2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginLeft.js
var require_MarginLeft = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginLeft.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var MarginLeft;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginLeft = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginLeft2, _Length2);
      var _super = _createSuper(MarginLeft2);
      function MarginLeft2() {
        _classCallCheck(this, MarginLeft2);
        return _super.apply(this, arguments);
      }
      return MarginLeft2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginRight.js
var require_MarginRight = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginRight.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var MarginRight;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginRight = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginRight2, _Length2);
      var _super = _createSuper(MarginRight2);
      function MarginRight2() {
        _classCallCheck(this, MarginRight2);
        return _super.apply(this, arguments);
      }
      return MarginRight2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginBottom.js
var require_MarginBottom = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginBottom.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var MarginBottom;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginBottom = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginBottom2, _Length2);
      var _super = _createSuper(MarginBottom2);
      function MarginBottom2() {
        _classCallCheck(this, MarginBottom2);
        return _super.apply(this, arguments);
      }
      return MarginBottom2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Margin.js
var require_Margin = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Margin.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Margin;
    var MarginBottom;
    var MarginLeft;
    var MarginRight;
    var MarginTop;
    var _Declaration;
    _Declaration = require_Declaration();
    MarginTop = require_MarginTop();
    MarginLeft = require_MarginLeft();
    MarginRight = require_MarginRight();
    MarginBottom = require_MarginBottom();
    module2.exports = Margin = function() {
      var self2;
      var Margin2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Margin3, _Declaration2);
        var _super = _createSuper(Margin3);
        function Margin3() {
          _classCallCheck(this, Margin3);
          return _super.apply(this, arguments);
        }
        _createClass(Margin3, null, [{
          key: "setOnto",
          value: function setOnto(declarations, prop, originalValue) {
            var append, val, vals;
            append = "";
            val = _Declaration.sanitizeValue(originalValue);
            if (_Declaration.importantClauseRx.test(String(val))) {
              append = " !important";
              val = val.replace(_Declaration.importantClauseRx, "");
            }
            val = val.trim();
            if (val.length === 0) {
              return self2._setAllDirections(declarations, append, append, append, append);
            }
            vals = val.split(" ").map(function(val2) {
              return val2 + append;
            });
            if (vals.length === 1) {
              return self2._setAllDirections(declarations, vals[0], vals[0], vals[0], vals[0]);
            } else if (vals.length === 2) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[0], vals[1]);
            } else if (vals.length === 3) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[1]);
            } else if (vals.length === 4) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[3]);
            } else {
              throw Error("Can't understand value for margin: `".concat(originalValue, "`"));
            }
          }
        }, {
          key: "_setAllDirections",
          value: function _setAllDirections(declarations, top, right, bottom, left) {
            MarginTop.setOnto(declarations, "marginTop", top);
            MarginTop.setOnto(declarations, "marginRight", right);
            MarginTop.setOnto(declarations, "marginBottom", bottom);
            MarginTop.setOnto(declarations, "marginLeft", left);
          }
        }]);
        return Margin3;
      }(_Declaration);
      ;
      self2 = Margin2;
      return Margin2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingTop.js
var require_PaddingTop = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingTop.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var PaddingTop;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingTop = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingTop2, _Length2);
      var _super = _createSuper(PaddingTop2);
      function PaddingTop2() {
        _classCallCheck(this, PaddingTop2);
        return _super.apply(this, arguments);
      }
      return PaddingTop2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingLeft.js
var require_PaddingLeft = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingLeft.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var PaddingLeft;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingLeft = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingLeft2, _Length2);
      var _super = _createSuper(PaddingLeft2);
      function PaddingLeft2() {
        _classCallCheck(this, PaddingLeft2);
        return _super.apply(this, arguments);
      }
      return PaddingLeft2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingRight.js
var require_PaddingRight = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingRight.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var PaddingRight;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingRight = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingRight2, _Length2);
      var _super = _createSuper(PaddingRight2);
      function PaddingRight2() {
        _classCallCheck(this, PaddingRight2);
        return _super.apply(this, arguments);
      }
      return PaddingRight2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingBottom.js
var require_PaddingBottom = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingBottom.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var PaddingBottom;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingBottom = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingBottom2, _Length2);
      var _super = _createSuper(PaddingBottom2);
      function PaddingBottom2() {
        _classCallCheck(this, PaddingBottom2);
        return _super.apply(this, arguments);
      }
      return PaddingBottom2;
    }(_Length);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Padding.js
var require_Padding = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Padding.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var Padding;
    var PaddingBottom;
    var PaddingLeft;
    var PaddingRight;
    var PaddingTop;
    var _Declaration;
    _Declaration = require_Declaration();
    PaddingTop = require_PaddingTop();
    PaddingLeft = require_PaddingLeft();
    PaddingRight = require_PaddingRight();
    PaddingBottom = require_PaddingBottom();
    module2.exports = Padding = function() {
      var self2;
      var Padding2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Padding3, _Declaration2);
        var _super = _createSuper(Padding3);
        function Padding3() {
          _classCallCheck(this, Padding3);
          return _super.apply(this, arguments);
        }
        _createClass(Padding3, null, [{
          key: "setOnto",
          value: function setOnto(declarations, prop, originalValue) {
            var append, val, vals;
            append = "";
            val = _Declaration.sanitizeValue(originalValue);
            if (_Declaration.importantClauseRx.test(String(val))) {
              append = " !important";
              val = val.replace(_Declaration.importantClauseRx, "");
            }
            val = val.trim();
            if (val.length === 0) {
              return self2._setAllDirections(declarations, append, append, append, append);
            }
            vals = val.split(" ").map(function(val2) {
              return val2 + append;
            });
            if (vals.length === 1) {
              return self2._setAllDirections(declarations, vals[0], vals[0], vals[0], vals[0]);
            } else if (vals.length === 2) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[0], vals[1]);
            } else if (vals.length === 3) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[1]);
            } else if (vals.length === 4) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[3]);
            } else {
              throw Error("Can't understand value for padding: `".concat(originalValue, "`"));
            }
          }
        }, {
          key: "_setAllDirections",
          value: function _setAllDirections(declarations, top, right, bottom, left) {
            PaddingTop.setOnto(declarations, "paddingTop", top);
            PaddingTop.setOnto(declarations, "paddingRight", right);
            PaddingTop.setOnto(declarations, "paddingBottom", bottom);
            PaddingTop.setOnto(declarations, "paddingLeft", left);
          }
        }]);
        return Padding3;
      }(_Declaration);
      ;
      self2 = Padding2;
      return Padding2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/DeclarationBlock.js
var require_DeclarationBlock = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/DeclarationBlock.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Arbitrary;
    var DeclarationBlock;
    var declarationClasses;
    module2.exports = DeclarationBlock = function() {
      var self2;
      var DeclarationBlock2 = /* @__PURE__ */ function() {
        function DeclarationBlock3() {
          _classCallCheck(this, DeclarationBlock3);
          this._declarations = {};
        }
        _createClass(DeclarationBlock3, [{
          key: "set",
          value: function set2(prop, value) {
            var key, val;
            if (_typeof(prop) === "object") {
              for (key in prop) {
                val = prop[key];
                this.set(key, val);
              }
              return this;
            }
            prop = self2.sanitizeProp(prop);
            this._getDeclarationClass(prop).setOnto(this._declarations, prop, value);
            return this;
          }
        }, {
          key: "_getDeclarationClass",
          value: function _getDeclarationClass(prop) {
            var cls;
            if (prop[0] === "_") {
              return Arbitrary;
            }
            if (!(cls = declarationClasses[prop])) {
              throw Error("Unknown property `".concat(prop, "`. Write it as `_").concat(prop, "` if you're defining a custom property"));
            }
            return cls;
          }
        }], [{
          key: "sanitizeProp",
          value: function sanitizeProp(prop) {
            return String(prop).trim();
          }
        }]);
        return DeclarationBlock3;
      }();
      ;
      self2 = DeclarationBlock2;
      return DeclarationBlock2;
    }.call(void 0);
    Arbitrary = require_Arbitrary();
    declarationClasses = {
      color: require_Color(),
      background: require_Background(),
      width: require_Width(),
      height: require_Height(),
      bullet: require_Bullet(),
      display: require_Display(),
      margin: require_Margin(),
      marginTop: require_MarginTop(),
      marginLeft: require_MarginLeft(),
      marginRight: require_MarginRight(),
      marginBottom: require_MarginBottom(),
      padding: require_Padding(),
      paddingTop: require_PaddingTop(),
      paddingLeft: require_PaddingLeft(),
      paddingRight: require_PaddingRight(),
      paddingBottom: require_PaddingBottom()
    };
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/Rule.js
var require_Rule = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/Rule.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var DeclarationBlock;
    var Rule;
    var Selector;
    Selector = require_Selector();
    DeclarationBlock = require_DeclarationBlock();
    module2.exports = Rule = /* @__PURE__ */ function() {
      function Rule2(selector) {
        _classCallCheck(this, Rule2);
        this.selector = new Selector(selector);
        this.styles = new DeclarationBlock();
      }
      _createClass(Rule2, [{
        key: "setStyles",
        value: function setStyles(styles) {
          this.styles.set(styles);
          return this;
        }
      }]);
      return Rule2;
    }();
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/StyleSheet.js
var require_StyleSheet = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/StyleSheet.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Rule;
    var StyleSheet;
    Rule = require_Rule();
    module2.exports = StyleSheet = function() {
      var self2;
      var StyleSheet2 = /* @__PURE__ */ function() {
        function StyleSheet3() {
          _classCallCheck(this, StyleSheet3);
          this._rulesBySelector = {};
        }
        _createClass(StyleSheet3, [{
          key: "setRule",
          value: function setRule(selector, styles) {
            var key, val;
            if (typeof selector === "string") {
              this._setRule(selector, styles);
            } else if (_typeof(selector) === "object") {
              for (key in selector) {
                val = selector[key];
                this._setRule(key, val);
              }
            }
            return this;
          }
        }, {
          key: "_setRule",
          value: function _setRule(s, styles) {
            var i, len, ref, selector;
            ref = self2.splitSelectors(s);
            for (i = 0, len = ref.length; i < len; i++) {
              selector = ref[i];
              this._setSingleRule(selector, styles);
            }
            return this;
          }
        }, {
          key: "_setSingleRule",
          value: function _setSingleRule(s, styles) {
            var rule, selector;
            selector = self2.normalizeSelector(s);
            if (!(rule = this._rulesBySelector[selector])) {
              rule = new Rule(selector);
              this._rulesBySelector[selector] = rule;
            }
            rule.setStyles(styles);
            return this;
          }
        }, {
          key: "getRulesFor",
          value: function getRulesFor(el) {
            var ref, rule, rules, selector;
            rules = [];
            ref = this._rulesBySelector;
            for (selector in ref) {
              rule = ref[selector];
              if (rule.selector.matches(el)) {
                rules.push(rule);
              }
            }
            return rules;
          }
        }], [{
          key: "normalizeSelector",
          value: function normalizeSelector(selector) {
            return selector.replace(/[\s]+/g, " ").replace(/[\s]*([>\,\+]{1})[\s]*/g, "$1").trim();
          }
        }, {
          key: "splitSelectors",
          value: function splitSelectors(s) {
            return s.trim().split(",");
          }
        }]);
        return StyleSheet3;
      }();
      ;
      self2 = StyleSheet2;
      return StyleSheet2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/MixedDeclarationSet.js
var require_MixedDeclarationSet = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/styles/rule/MixedDeclarationSet.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var MixedDeclarationSet;
    module2.exports = MixedDeclarationSet = function() {
      var self2;
      var MixedDeclarationSet2 = /* @__PURE__ */ function() {
        function MixedDeclarationSet3() {
          _classCallCheck(this, MixedDeclarationSet3);
          this._declarations = {};
        }
        _createClass(MixedDeclarationSet3, [{
          key: "mixWithList",
          value: function mixWithList(rules) {
            var i, len, rule;
            rules.sort(function(a, b) {
              return a.selector.priority > b.selector.priority;
            });
            for (i = 0, len = rules.length; i < len; i++) {
              rule = rules[i];
              this._mixWithRule(rule);
            }
            return this;
          }
        }, {
          key: "_mixWithRule",
          value: function _mixWithRule(rule) {
            var dec, prop, ref;
            ref = rule.styles._declarations;
            for (prop in ref) {
              dec = ref[prop];
              this._mixWithDeclaration(dec);
            }
          }
        }, {
          key: "_mixWithDeclaration",
          value: function _mixWithDeclaration(dec) {
            var cur;
            cur = this._declarations[dec.prop];
            if (cur != null && cur.important && !dec.important) {
              return;
            }
            this._declarations[dec.prop] = dec;
          }
        }, {
          key: "get",
          value: function get(prop) {
            if (prop == null) {
              return this._declarations;
            }
            if (this._declarations[prop] == null) {
              return null;
            }
            return this._declarations[prop].val;
          }
        }, {
          key: "toObject",
          value: function toObject() {
            var dec, obj, prop, ref;
            obj = {};
            ref = this._declarations;
            for (prop in ref) {
              dec = ref[prop];
              obj[prop] = dec.val;
            }
            return obj;
          }
        }], [{
          key: "mix",
          value: function mix() {
            var i, len, mixed2, rules;
            mixed2 = new self2();
            for (var _len = arguments.length, ruleSets = new Array(_len), _key = 0; _key < _len; _key++) {
              ruleSets[_key] = arguments[_key];
            }
            for (i = 0, len = ruleSets.length; i < len; i++) {
              rules = ruleSets[i];
              mixed2.mixWithList(rules);
            }
            return mixed2;
          }
        }]);
        return MixedDeclarationSet3;
      }();
      ;
      self2 = MixedDeclarationSet2;
      return MixedDeclarationSet2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/Styles.js
var require_Styles = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/renderKid/Styles.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var MixedDeclarationSet;
    var StyleSheet;
    var Styles;
    var terminalWidth;
    StyleSheet = require_StyleSheet();
    MixedDeclarationSet = require_MixedDeclarationSet();
    terminalWidth = require_tools().getCols();
    module2.exports = Styles = function() {
      var self2;
      var Styles2 = /* @__PURE__ */ function() {
        function Styles3() {
          _classCallCheck(this, Styles3);
          this._defaultStyles = new StyleSheet();
          this._userStyles = new StyleSheet();
          this._setDefaultStyles();
        }
        _createClass(Styles3, [{
          key: "_setDefaultStyles",
          value: function _setDefaultStyles() {
            this._defaultStyles.setRule(self2.defaultRules);
          }
        }, {
          key: "setRule",
          value: function setRule(selector, rules) {
            this._userStyles.setRule.apply(this._userStyles, arguments);
            return this;
          }
        }, {
          key: "getStyleFor",
          value: function getStyleFor(el) {
            var styles;
            styles = el.styles;
            if (styles == null) {
              el.styles = styles = this._getComputedStyleFor(el);
            }
            return styles;
          }
        }, {
          key: "_getRawStyleFor",
          value: function _getRawStyleFor(el) {
            var def, user;
            def = this._defaultStyles.getRulesFor(el);
            user = this._userStyles.getRulesFor(el);
            return MixedDeclarationSet.mix(def, user).toObject();
          }
        }, {
          key: "_getComputedStyleFor",
          value: function _getComputedStyleFor(el) {
            var decs, parent, prop, ref, val;
            decs = {};
            parent = el.parent;
            ref = this._getRawStyleFor(el);
            for (prop in ref) {
              val = ref[prop];
              if (val !== "inherit") {
                decs[prop] = val;
              } else {
                throw Error("Inherited styles are not supported yet.");
              }
            }
            return decs;
          }
        }]);
        return Styles3;
      }();
      ;
      self2 = Styles2;
      Styles2.defaultRules = {
        "*": {
          display: "inline"
        },
        "body": {
          background: "none",
          color: "white",
          display: "block",
          width: terminalWidth + " !important"
        }
      };
      return Styles2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/SpecialString.js
var require_SpecialString = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/SpecialString.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i2 = 0; i2 < props.length; i2++) {
        var descriptor = props[i2];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var SpecialString;
    var i;
    var len;
    var prop;
    var ref;
    module2.exports = SpecialString = function() {
      var self2;
      var SpecialString2 = /* @__PURE__ */ function() {
        function SpecialString3(str2) {
          _classCallCheck(this, SpecialString3);
          if (!(this instanceof self2)) {
            return new self2(str2);
          }
          this._str = String(str2);
          this._len = 0;
        }
        _createClass(SpecialString3, [{
          key: "_getStr",
          value: function _getStr() {
            return this._str;
          }
        }, {
          key: "set",
          value: function set2(str2) {
            this._str = String(str2);
            return this;
          }
        }, {
          key: "clone",
          value: function clone() {
            return new SpecialString3(this._str);
          }
        }, {
          key: "isEmpty",
          value: function isEmpty() {
            return this._str === "";
          }
        }, {
          key: "isOnlySpecialChars",
          value: function isOnlySpecialChars() {
            return !this.isEmpty() && this.length === 0;
          }
        }, {
          key: "_reset",
          value: function _reset() {
            return this._len = 0;
          }
        }, {
          key: "splitIn",
          value: function splitIn(limit) {
            var trimLeftEachLine = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
            var buffer, bufferLength, justSkippedSkipChar, lines;
            buffer = "";
            bufferLength = 0;
            lines = [];
            justSkippedSkipChar = false;
            self2._countChars(this._str, function(char, charLength) {
              if (bufferLength > limit || bufferLength + charLength > limit) {
                lines.push(buffer);
                buffer = "";
                bufferLength = 0;
              }
              if (bufferLength === 0 && char === " " && !justSkippedSkipChar && trimLeftEachLine) {
                return justSkippedSkipChar = true;
              } else {
                buffer += char;
                bufferLength += charLength;
                return justSkippedSkipChar = false;
              }
            });
            if (buffer.length > 0) {
              lines.push(buffer);
            }
            return lines;
          }
        }, {
          key: "trim",
          value: function trim() {
            return new SpecialString3(this.str.trim());
          }
        }, {
          key: "trimLeft",
          value: function trimLeft() {
            return new SpecialString3(this.str.replace(/^\s+/, ""));
          }
        }, {
          key: "trimRight",
          value: function trimRight() {
            return new SpecialString3(this.str.replace(/\s+$/, ""));
          }
        }, {
          key: "_getLength",
          value: function _getLength() {
            var sum;
            sum = 0;
            self2._countChars(this._str, function(char, charLength) {
              sum += charLength;
            });
            return sum;
          }
        }, {
          key: "cut",
          value: function cut(from, to) {
            var _this = this;
            var trimLeft = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
            var after, before, cur, cut2;
            if (to == null) {
              to = this.length;
            }
            from = parseInt(from);
            if (from >= to) {
              throw Error("`from` shouldn't be larger than `to`");
            }
            before = "";
            after = "";
            cut2 = "";
            cur = 0;
            self2._countChars(this._str, function(char, charLength) {
              if (_this.str === "ab<tag>") {
                console.log(charLength, char);
              }
              if (cur === from && char.match(/^\s+$/) && trimLeft) {
                return;
              }
              if (cur < from) {
                before += char;
              } else if (cur < to || cur + charLength <= to) {
                cut2 += char;
              } else {
                after += char;
              }
              cur += charLength;
            });
            this._str = before + after;
            this._reset();
            return new SpecialString3(cut2);
          }
        }], [{
          key: "_countChars",
          value: function _countChars(text, cb) {
            var char, charLength, m;
            while (text.length !== 0) {
              if (m = text.match(self2._tagRx)) {
                char = m[0];
                charLength = 0;
                text = text.substr(char.length, text.length);
              } else if (m = text.match(self2._quotedHtmlRx)) {
                char = m[0];
                charLength = 1;
                text = text.substr(char.length, text.length);
              } else if (text.match(self2._tabRx)) {
                char = "	";
                charLength = 8;
                text = text.substr(1, text.length);
              } else {
                char = text[0];
                charLength = 1;
                text = text.substr(1, text.length);
              }
              cb.call(null, char, charLength);
            }
          }
        }]);
        return SpecialString3;
      }();
      ;
      self2 = SpecialString2;
      SpecialString2._tabRx = /^\t/;
      SpecialString2._tagRx = /^<[^>]+>/;
      SpecialString2._quotedHtmlRx = /^&(gt|lt|quot|amp|apos|sp);/;
      return SpecialString2;
    }.call(void 0);
    ref = ["str", "length"];
    for (i = 0, len = ref.length; i < len; i++) {
      prop = ref[i];
      (function() {
        var methodName;
        methodName = "_get" + prop[0].toUpperCase() + prop.substr(1, prop.length);
        return SpecialString.prototype.__defineGetter__(prop, function() {
          return this[methodName]();
        });
      })();
    }
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockPrependor/_BlockPrependor.js
var require_BlockPrependor = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockPrependor/_BlockPrependor.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _BlockPrependor;
    module2.exports = _BlockPrependor = /* @__PURE__ */ function() {
      function _BlockPrependor2(_config) {
        _classCallCheck(this, _BlockPrependor2);
        this._config = _config;
      }
      _createClass(_BlockPrependor2, [{
        key: "render",
        value: function render(options) {
          return this._render(options);
        }
      }]);
      return _BlockPrependor2;
    }();
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockPrependor/Default.js
var require_Default = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockPrependor/Default.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var DefaultBlockPrependor;
    var tools;
    tools = require_tools();
    module2.exports = DefaultBlockPrependor = /* @__PURE__ */ function(_require) {
      _inherits(DefaultBlockPrependor2, _require);
      var _super = _createSuper(DefaultBlockPrependor2);
      function DefaultBlockPrependor2() {
        _classCallCheck(this, DefaultBlockPrependor2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultBlockPrependor2, [{
        key: "_render",
        value: function _render(options) {
          return tools.repeatString("\n", this._config.amount);
        }
      }]);
      return DefaultBlockPrependor2;
    }(require_BlockPrependor());
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockAppendor/_BlockAppendor.js
var require_BlockAppendor = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockAppendor/_BlockAppendor.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _BlockAppendor;
    module2.exports = _BlockAppendor = /* @__PURE__ */ function() {
      function _BlockAppendor2(_config) {
        _classCallCheck(this, _BlockAppendor2);
        this._config = _config;
      }
      _createClass(_BlockAppendor2, [{
        key: "render",
        value: function render(options) {
          return this._render(options);
        }
      }]);
      return _BlockAppendor2;
    }();
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockAppendor/Default.js
var require_Default2 = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/blockAppendor/Default.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var DefaultBlockAppendor;
    var tools;
    tools = require_tools();
    module2.exports = DefaultBlockAppendor = /* @__PURE__ */ function(_require) {
      _inherits(DefaultBlockAppendor2, _require);
      var _super = _createSuper(DefaultBlockAppendor2);
      function DefaultBlockAppendor2() {
        _classCallCheck(this, DefaultBlockAppendor2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultBlockAppendor2, [{
        key: "_render",
        value: function _render(options) {
          return tools.repeatString("\n", this._config.amount);
        }
      }]);
      return DefaultBlockAppendor2;
    }(require_BlockAppendor());
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/linePrependor/_LinePrependor.js
var require_LinePrependor = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/linePrependor/_LinePrependor.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _LinePrependor;
    module2.exports = _LinePrependor = /* @__PURE__ */ function() {
      function _LinePrependor2(_config) {
        _classCallCheck(this, _LinePrependor2);
        this._config = _config;
        this._lineNo = -1;
      }
      _createClass(_LinePrependor2, [{
        key: "render",
        value: function render(inherited, options) {
          this._lineNo++;
          return "<none>" + this._render(inherited, options) + "</none>";
        }
      }]);
      return _LinePrependor2;
    }();
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/linePrependor/Default.js
var require_Default3 = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/linePrependor/Default.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var DefaultLinePrependor;
    var SpecialString;
    var tools;
    tools = require_tools();
    SpecialString = require_SpecialString();
    module2.exports = DefaultLinePrependor = function() {
      var self2;
      var DefaultLinePrependor2 = /* @__PURE__ */ function(_require) {
        _inherits(DefaultLinePrependor3, _require);
        var _super = _createSuper(DefaultLinePrependor3);
        function DefaultLinePrependor3() {
          _classCallCheck(this, DefaultLinePrependor3);
          return _super.apply(this, arguments);
        }
        _createClass(DefaultLinePrependor3, [{
          key: "_render",
          value: function _render(inherited, options) {
            var addToLeft, addToRight, alignment, bullet, char, charLen, diff2, left, output, space, toWrite;
            if (this._lineNo === 0 && (bullet = this._config.bullet)) {
              char = bullet.char;
              charLen = new SpecialString(char).length;
              alignment = bullet.alignment;
              space = this._config.amount;
              toWrite = char;
              addToLeft = "";
              addToRight = "";
              if (space > charLen) {
                diff2 = space - charLen;
                if (alignment === "right") {
                  addToLeft = self2.pad(diff2);
                } else if (alignment === "left") {
                  addToRight = self2.pad(diff2);
                } else if (alignment === "center") {
                  left = Math.round(diff2 / 2);
                  addToLeft = self2.pad(left);
                  addToRight = self2.pad(diff2 - left);
                } else {
                  throw Error("Unknown alignment `".concat(alignment, "`"));
                }
              }
              output = addToLeft + char + addToRight;
            } else {
              output = self2.pad(this._config.amount);
            }
            return inherited + output;
          }
        }], [{
          key: "pad",
          value: function pad(howMuch) {
            return tools.repeatString(" ", howMuch);
          }
        }]);
        return DefaultLinePrependor3;
      }(require_LinePrependor());
      ;
      self2 = DefaultLinePrependor2;
      return DefaultLinePrependor2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineAppendor/_LineAppendor.js
var require_LineAppendor = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineAppendor/_LineAppendor.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _LineAppendor;
    module2.exports = _LineAppendor = /* @__PURE__ */ function() {
      function _LineAppendor2(_config) {
        _classCallCheck(this, _LineAppendor2);
        this._config = _config;
        this._lineNo = 0;
      }
      _createClass(_LineAppendor2, [{
        key: "render",
        value: function render(inherited, options) {
          this._lineNo++;
          return "<none>" + this._render(inherited, options) + "</none>";
        }
      }]);
      return _LineAppendor2;
    }();
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineAppendor/Default.js
var require_Default4 = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineAppendor/Default.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var DefaultLineAppendor;
    var tools;
    tools = require_tools();
    module2.exports = DefaultLineAppendor = /* @__PURE__ */ function(_require) {
      _inherits(DefaultLineAppendor2, _require);
      var _super = _createSuper(DefaultLineAppendor2);
      function DefaultLineAppendor2() {
        _classCallCheck(this, DefaultLineAppendor2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultLineAppendor2, [{
        key: "_render",
        value: function _render(inherited, options) {
          return inherited + tools.repeatString(" ", this._config.amount);
        }
      }]);
      return DefaultLineAppendor2;
    }(require_LineAppendor());
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineWrapper/_LineWrapper.js
var require_LineWrapper = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineWrapper/_LineWrapper.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _LineWrapper;
    module2.exports = _LineWrapper = /* @__PURE__ */ function() {
      function _LineWrapper2() {
        _classCallCheck(this, _LineWrapper2);
      }
      _createClass(_LineWrapper2, [{
        key: "render",
        value: function render(str2, options) {
          return this._render(str2, options);
        }
      }]);
      return _LineWrapper2;
    }();
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineWrapper/Default.js
var require_Default5 = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/block/lineWrapper/Default.js"(exports, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      };
      return _setPrototypeOf(o, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e) {
        return false;
      }
    }
    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      };
      return _getPrototypeOf(o);
    }
    var DefaultLineWrapper;
    module2.exports = DefaultLineWrapper = /* @__PURE__ */ function(_require) {
      _inherits(DefaultLineWrapper2, _require);
      var _super = _createSuper(DefaultLineWrapper2);
      function DefaultLineWrapper2() {
        _classCallCheck(this, DefaultLineWrapper2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultLineWrapper2, [{
        key: "_render",
        value: function _render() {
        }
      }]);
      return DefaultLineWrapper2;
    }(require_LineWrapper());
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/Block.js
var require_Block = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/layout/Block.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Block;
    var SpecialString;
    var cloneAndMergeDeep;
    var terminalWidth;
    SpecialString = require_SpecialString();
    terminalWidth = require_tools().getCols();
    var _require = require_tools();
    cloneAndMergeDeep = _require.cloneAndMergeDeep;
    module2.exports = Block = function() {
      var self2;
      var Block2 = /* @__PURE__ */ function() {
        function Block3(_layout, _parent) {
          var config = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
          var _name = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : "";
          _classCallCheck(this, Block3);
          this._layout = _layout;
          this._parent = _parent;
          this._name = _name;
          this._config = cloneAndMergeDeep(self2.defaultConfig, config);
          this._closed = false;
          this._wasOpenOnce = false;
          this._active = false;
          this._buffer = "";
          this._didSeparateBlock = false;
          this._linePrependor = new this._config.linePrependor.fn(this._config.linePrependor.options);
          this._lineAppendor = new this._config.lineAppendor.fn(this._config.lineAppendor.options);
          this._blockPrependor = new this._config.blockPrependor.fn(this._config.blockPrependor.options);
          this._blockAppendor = new this._config.blockAppendor.fn(this._config.blockAppendor.options);
        }
        _createClass(Block3, [{
          key: "_activate",
          value: function _activate() {
            var deactivateParent = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
            if (this._active) {
              throw Error("This block is already active. This is probably a bug in RenderKid itself");
            }
            if (this._closed) {
              throw Error("This block is closed and cannot be activated. This is probably a bug in RenderKid itself");
            }
            this._active = true;
            this._layout._activeBlock = this;
            if (deactivateParent) {
              if (this._parent != null) {
                this._parent._deactivate(false);
              }
            }
            return this;
          }
        }, {
          key: "_deactivate",
          value: function _deactivate() {
            var activateParent = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
            this._ensureActive();
            this._flushBuffer();
            if (activateParent) {
              if (this._parent != null) {
                this._parent._activate(false);
              }
            }
            this._active = false;
            return this;
          }
        }, {
          key: "_ensureActive",
          value: function _ensureActive() {
            if (!this._wasOpenOnce) {
              throw Error("This block has never been open before. This is probably a bug in RenderKid itself.");
            }
            if (!this._active) {
              throw Error("This block is not active. This is probably a bug in RenderKid itself.");
            }
            if (this._closed) {
              throw Error("This block is already closed. This is probably a bug in RenderKid itself.");
            }
          }
        }, {
          key: "_open",
          value: function _open() {
            if (this._wasOpenOnce) {
              throw Error("Block._open() has been called twice. This is probably a RenderKid bug.");
            }
            this._wasOpenOnce = true;
            if (this._parent != null) {
              this._parent.write(this._whatToPrependToBlock());
            }
            this._activate();
            return this;
          }
        }, {
          key: "close",
          value: function close() {
            this._deactivate();
            this._closed = true;
            if (this._parent != null) {
              this._parent.write(this._whatToAppendToBlock());
            }
            return this;
          }
        }, {
          key: "isOpen",
          value: function isOpen() {
            return this._wasOpenOnce && !this._closed;
          }
        }, {
          key: "write",
          value: function write(str2) {
            this._ensureActive();
            if (str2 === "") {
              return;
            }
            str2 = String(str2);
            this._buffer += str2;
            return this;
          }
        }, {
          key: "openBlock",
          value: function openBlock(config, name) {
            var block;
            this._ensureActive();
            block = new Block3(this._layout, this, config, name);
            block._open();
            return block;
          }
        }, {
          key: "_flushBuffer",
          value: function _flushBuffer() {
            var str2;
            if (this._buffer === "") {
              return;
            }
            str2 = this._buffer;
            this._buffer = "";
            this._writeInline(str2);
          }
        }, {
          key: "_toPrependToLine",
          value: function _toPrependToLine() {
            var fromParent;
            fromParent = "";
            if (this._parent != null) {
              fromParent = this._parent._toPrependToLine();
            }
            return this._linePrependor.render(fromParent);
          }
        }, {
          key: "_toAppendToLine",
          value: function _toAppendToLine() {
            var fromParent;
            fromParent = "";
            if (this._parent != null) {
              fromParent = this._parent._toAppendToLine();
            }
            return this._lineAppendor.render(fromParent);
          }
        }, {
          key: "_whatToPrependToBlock",
          value: function _whatToPrependToBlock() {
            return this._blockPrependor.render();
          }
        }, {
          key: "_whatToAppendToBlock",
          value: function _whatToAppendToBlock() {
            return this._blockAppendor.render();
          }
        }, {
          key: "_writeInline",
          value: function _writeInline(str2) {
            var i, j, k, l, lineBreaksToAppend, m, ref, ref1, ref2, remaining;
            if (new SpecialString(str2).isOnlySpecialChars()) {
              this._layout._append(str2);
              return;
            }
            remaining = str2;
            lineBreaksToAppend = 0;
            if (m = remaining.match(/^\n+/)) {
              for (i = j = 1, ref = m[0].length; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
                this._writeLine("");
              }
              remaining = remaining.substr(m[0].length, remaining.length);
            }
            if (m = remaining.match(/\n+$/)) {
              lineBreaksToAppend = m[0].length;
              remaining = remaining.substr(0, remaining.length - m[0].length);
            }
            while (remaining.length > 0) {
              if (m = remaining.match(/^[^\n]+/)) {
                this._writeLine(m[0]);
                remaining = remaining.substr(m[0].length, remaining.length);
              } else if (m = remaining.match(/^\n+/)) {
                for (i = k = 1, ref1 = m[0].length; 1 <= ref1 ? k < ref1 : k > ref1; i = 1 <= ref1 ? ++k : --k) {
                  this._writeLine("");
                }
                remaining = remaining.substr(m[0].length, remaining.length);
              }
            }
            if (lineBreaksToAppend > 0) {
              for (i = l = 1, ref2 = lineBreaksToAppend; 1 <= ref2 ? l <= ref2 : l >= ref2; i = 1 <= ref2 ? ++l : --l) {
                this._writeLine("");
              }
            }
          }
        }, {
          key: "_writeLine",
          value: function _writeLine(str2) {
            var line, lineContent, lineContentLength, remaining, roomLeft, toAppend, toAppendLength, toPrepend, toPrependLength;
            remaining = new SpecialString(str2);
            while (true) {
              toPrepend = this._toPrependToLine();
              toPrependLength = new SpecialString(toPrepend).length;
              toAppend = this._toAppendToLine();
              toAppendLength = new SpecialString(toAppend).length;
              roomLeft = this._layout._config.terminalWidth - (toPrependLength + toAppendLength);
              lineContentLength = Math.min(this._config.width, roomLeft);
              lineContent = remaining.cut(0, lineContentLength, true);
              line = toPrepend + lineContent.str + toAppend;
              this._layout._appendLine(line);
              if (remaining.isEmpty()) {
                break;
              }
            }
          }
        }]);
        return Block3;
      }();
      ;
      self2 = Block2;
      Block2.defaultConfig = {
        blockPrependor: {
          fn: require_Default(),
          options: {
            amount: 0
          }
        },
        blockAppendor: {
          fn: require_Default2(),
          options: {
            amount: 0
          }
        },
        linePrependor: {
          fn: require_Default3(),
          options: {
            amount: 0
          }
        },
        lineAppendor: {
          fn: require_Default4(),
          options: {
            amount: 0
          }
        },
        lineWrapper: {
          fn: require_Default5(),
          options: {
            lineWidth: null
          }
        },
        width: terminalWidth,
        prefixRaw: "",
        suffixRaw: ""
      };
      return Block2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/Layout.js
var require_Layout = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/Layout.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i2 = 0; i2 < props.length; i2++) {
        var descriptor = props[i2];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Block;
    var Layout;
    var SpecialString;
    var cloneAndMergeDeep;
    var i;
    var len;
    var prop;
    var ref;
    var terminalWidth;
    Block = require_Block();
    var _require = require_tools();
    cloneAndMergeDeep = _require.cloneAndMergeDeep;
    SpecialString = require_SpecialString();
    terminalWidth = require_tools().getCols();
    module2.exports = Layout = function() {
      var self2;
      var Layout2 = /* @__PURE__ */ function() {
        function Layout3() {
          var config = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          var rootBlockConfig = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
          _classCallCheck(this, Layout3);
          var rootConfig;
          this._written = [];
          this._activeBlock = null;
          this._config = cloneAndMergeDeep(self2._defaultConfig, config);
          rootConfig = cloneAndMergeDeep(self2._rootBlockDefaultConfig, rootBlockConfig);
          this._root = new Block(this, null, rootConfig, "__root");
          this._root._open();
        }
        _createClass(Layout3, [{
          key: "getRootBlock",
          value: function getRootBlock() {
            return this._root;
          }
        }, {
          key: "_append",
          value: function _append(text) {
            return this._written.push(text);
          }
        }, {
          key: "_appendLine",
          value: function _appendLine(text) {
            var s;
            this._append(text);
            s = new SpecialString(text);
            if (s.length < this._config.terminalWidth) {
              this._append("<none>\n</none>");
            }
            return this;
          }
        }, {
          key: "get",
          value: function get() {
            this._ensureClosed();
            if (this._written[this._written.length - 1] === "<none>\n</none>") {
              this._written.pop();
            }
            return this._written.join("");
          }
        }, {
          key: "_ensureClosed",
          value: function _ensureClosed() {
            if (this._activeBlock !== this._root) {
              throw Error("Not all the blocks have been closed. Please call block.close() on all open blocks.");
            }
            if (this._root.isOpen()) {
              this._root.close();
            }
          }
        }]);
        return Layout3;
      }();
      ;
      self2 = Layout2;
      Layout2._rootBlockDefaultConfig = {
        linePrependor: {
          options: {
            amount: 0
          }
        },
        lineAppendor: {
          options: {
            amount: 0
          }
        },
        blockPrependor: {
          options: {
            amount: 0
          }
        },
        blockAppendor: {
          options: {
            amount: 0
          }
        }
      };
      Layout2._defaultConfig = {
        terminalWidth
      };
      return Layout2;
    }.call(void 0);
    ref = ["openBlock", "write"];
    for (i = 0, len = ref.length; i < len; i++) {
      prop = ref[i];
      (function() {
        var method;
        method = prop;
        return Layout.prototype[method] = function() {
          return this._root[method].apply(this._root, arguments);
        };
      })();
    }
  }
});

// node_modules/.pnpm/ansi-regex@2.1.1/node_modules/ansi-regex/index.js
var require_ansi_regex = __commonJS({
  "node_modules/.pnpm/ansi-regex@2.1.1/node_modules/ansi-regex/index.js"(exports, module2) {
    "use strict";
    module2.exports = function() {
      return /[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-PRZcf-nqry=><]/g;
    };
  }
});

// node_modules/.pnpm/strip-ansi@3.0.1/node_modules/strip-ansi/index.js
var require_strip_ansi = __commonJS({
  "node_modules/.pnpm/strip-ansi@3.0.1/node_modules/strip-ansi/index.js"(exports, module2) {
    "use strict";
    var ansiRegex = require_ansi_regex()();
    module2.exports = function(str2) {
      return typeof str2 === "string" ? str2.replace(ansiRegex, "") : str2;
    };
  }
});

// node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/RenderKid.js
var require_RenderKid = __commonJS({
  "node_modules/.pnpm/renderkid@2.0.7/node_modules/renderkid/lib/RenderKid.js"(exports, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var AnsiPainter;
    var Layout;
    var RenderKid;
    var Styles;
    var blockStyleApplier;
    var cloneAndMergeDeep;
    var inlineStyleApplier;
    var isPlainObject;
    var stripAnsi;
    var terminalWidth;
    var tools;
    inlineStyleApplier = require_inline();
    blockStyleApplier = require_block();
    isPlainObject = require_isPlainObject();
    var _require = require_tools();
    cloneAndMergeDeep = _require.cloneAndMergeDeep;
    AnsiPainter = require_AnsiPainter();
    Styles = require_Styles();
    Layout = require_Layout();
    tools = require_tools();
    stripAnsi = require_strip_ansi();
    terminalWidth = require_tools().getCols();
    module2.exports = RenderKid = function() {
      var self2;
      var RenderKid2 = /* @__PURE__ */ function() {
        function RenderKid3() {
          var config = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          _classCallCheck(this, RenderKid3);
          this.tools = self2.tools;
          this._config = cloneAndMergeDeep(self2._defaultConfig, config);
          this._initStyles();
        }
        _createClass(RenderKid3, [{
          key: "_initStyles",
          value: function _initStyles() {
            return this._styles = new Styles();
          }
        }, {
          key: "style",
          value: function style() {
            return this._styles.setRule.apply(this._styles, arguments);
          }
        }, {
          key: "_getStyleFor",
          value: function _getStyleFor(el) {
            return this._styles.getStyleFor(el);
          }
        }, {
          key: "render",
          value: function render(input) {
            var withColors = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            return this._paint(this._renderDom(this._toDom(input)), withColors);
          }
        }, {
          key: "_toDom",
          value: function _toDom(input) {
            if (typeof input === "string") {
              return this._parse(input);
            } else if (isPlainObject(input) || Array.isArray(input)) {
              return this._objToDom(input);
            } else {
              throw Error("Invalid input type. Only strings, arrays and objects are accepted");
            }
          }
        }, {
          key: "_objToDom",
          value: function _objToDom(o) {
            var injectFakeRoot = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            if (injectFakeRoot) {
              o = {
                body: o
              };
            }
            return tools.objectToDom(o);
          }
        }, {
          key: "_paint",
          value: function _paint(text, withColors) {
            var painted;
            painted = AnsiPainter.paint(text);
            if (withColors) {
              return painted;
            } else {
              return stripAnsi(painted);
            }
          }
        }, {
          key: "_parse",
          value: function _parse(string2) {
            var injectFakeRoot = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            if (injectFakeRoot) {
              string2 = "<body>" + string2 + "</body>";
            }
            return tools.stringToDom(string2);
          }
        }, {
          key: "_renderDom",
          value: function _renderDom(dom) {
            var bodyTag, layout, rootBlock;
            bodyTag = dom[0];
            layout = new Layout(this._config.layout);
            rootBlock = layout.getRootBlock();
            this._renderBlockNode(bodyTag, null, rootBlock);
            return layout.get();
          }
        }, {
          key: "_renderChildrenOf",
          value: function _renderChildrenOf(parentNode, parentBlock) {
            var i, len, node, nodes;
            nodes = parentNode.children;
            for (i = 0, len = nodes.length; i < len; i++) {
              node = nodes[i];
              this._renderNode(node, parentNode, parentBlock);
            }
          }
        }, {
          key: "_renderNode",
          value: function _renderNode(node, parentNode, parentBlock) {
            if (node.type === "text") {
              this._renderText(node, parentNode, parentBlock);
            } else if (node.name === "br") {
              this._renderBr(node, parentNode, parentBlock);
            } else if (this._isBlock(node)) {
              this._renderBlockNode(node, parentNode, parentBlock);
            } else if (this._isNone(node)) {
              return;
            } else {
              this._renderInlineNode(node, parentNode, parentBlock);
            }
          }
        }, {
          key: "_renderText",
          value: function _renderText(node, parentNode, parentBlock) {
            var ref, text;
            text = node.data;
            text = text.replace(/\s+/g, " ");
            if ((parentNode != null ? (ref = parentNode.styles) != null ? ref.display : void 0 : void 0) !== "inline") {
              text = text.trim();
            }
            if (text.length === 0) {
              return;
            }
            text = text.replace(/&nl;/g, "\n");
            return parentBlock.write(text);
          }
        }, {
          key: "_renderBlockNode",
          value: function _renderBlockNode(node, parentNode, parentBlock) {
            var after, before, block, blockConfig;
            var _blockStyleApplier$ap = blockStyleApplier.applyTo(node, this._getStyleFor(node));
            before = _blockStyleApplier$ap.before;
            after = _blockStyleApplier$ap.after;
            blockConfig = _blockStyleApplier$ap.blockConfig;
            block = parentBlock.openBlock(blockConfig);
            if (before !== "") {
              block.write(before);
            }
            this._renderChildrenOf(node, block);
            if (after !== "") {
              block.write(after);
            }
            return block.close();
          }
        }, {
          key: "_renderInlineNode",
          value: function _renderInlineNode(node, parentNode, parentBlock) {
            var after, before;
            var _inlineStyleApplier$a = inlineStyleApplier.applyTo(node, this._getStyleFor(node));
            before = _inlineStyleApplier$a.before;
            after = _inlineStyleApplier$a.after;
            if (before !== "") {
              parentBlock.write(before);
            }
            this._renderChildrenOf(node, parentBlock);
            if (after !== "") {
              return parentBlock.write(after);
            }
          }
        }, {
          key: "_renderBr",
          value: function _renderBr(node, parentNode, parentBlock) {
            return parentBlock.write("\n");
          }
        }, {
          key: "_isBlock",
          value: function _isBlock(node) {
            return !(node.type === "text" || node.name === "br" || this._getStyleFor(node).display !== "block");
          }
        }, {
          key: "_isNone",
          value: function _isNone(node) {
            return !(node.type === "text" || node.name === "br" || this._getStyleFor(node).display !== "none");
          }
        }]);
        return RenderKid3;
      }();
      ;
      self2 = RenderKid2;
      RenderKid2.AnsiPainter = AnsiPainter;
      RenderKid2.Layout = Layout;
      RenderKid2.quote = tools.quote;
      RenderKid2.tools = tools;
      RenderKid2._defaultConfig = {
        layout: {
          terminalWidth
        }
      };
      return RenderKid2;
    }.call(void 0);
  }
});

// node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/PrettyError.js
var require_PrettyError = __commonJS({
  "node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/lib/PrettyError.js"(exports, module2) {
    var ParsedError;
    var PrettyError;
    var RenderKid;
    var arrayUtils;
    var defaultStyle;
    var fn;
    var instance;
    var isPlainObject;
    var j;
    var len;
    var merge2;
    var nodePaths;
    var prop;
    var ref;
    var slice = [].slice;
    var indexOf = [].indexOf || function(item) {
      for (var i = 0, l = this.length; i < l; i++) {
        if (i in this && this[i] === item)
          return i;
      }
      return -1;
    };
    isPlainObject = require_isPlainObject();
    defaultStyle = require_defaultStyle();
    ParsedError = require_ParsedError();
    nodePaths = require_nodePaths();
    RenderKid = require_RenderKid();
    merge2 = require_merge();
    arrayUtils = {
      pluckByCallback: function(a, cb) {
        var index, j2, len2, removed, value;
        if (a.length < 1) {
          return a;
        }
        removed = 0;
        for (index = j2 = 0, len2 = a.length; j2 < len2; index = ++j2) {
          value = a[index];
          if (cb(value, index)) {
            removed++;
            continue;
          }
          if (removed !== 0) {
            a[index - removed] = a[index];
          }
        }
        if (removed > 0) {
          a.length = a.length - removed;
        }
        return a;
      },
      pluckOneItem: function(a, item) {
        var index, j2, len2, reached, value;
        if (a.length < 1) {
          return a;
        }
        reached = false;
        for (index = j2 = 0, len2 = a.length; j2 < len2; index = ++j2) {
          value = a[index];
          if (!reached) {
            if (value === item) {
              reached = true;
              continue;
            }
          } else {
            a[index - 1] = a[index];
          }
        }
        if (reached) {
          a.length = a.length - 1;
        }
        return a;
      }
    };
    instance = null;
    module2.exports = PrettyError = function() {
      var self2;
      self2 = PrettyError2;
      PrettyError2._filters = {
        "module.exports": function(item) {
          if (item.what == null) {
            return;
          }
          item.what = item.what.replace(/\.module\.exports\./g, " - ");
        }
      };
      PrettyError2._getDefaultStyle = function() {
        return defaultStyle();
      };
      PrettyError2.start = function() {
        if (instance == null) {
          instance = new self2();
          instance.start();
        }
        return instance;
      };
      PrettyError2.stop = function() {
        return instance != null ? instance.stop() : void 0;
      };
      function PrettyError2() {
        this._useColors = true;
        this._maxItems = 50;
        this._packagesToSkip = [];
        this._pathsToSkip = [];
        this._skipCallbacks = [];
        this._filterCallbacks = [];
        this._parsedErrorFilters = [];
        this._aliases = [];
        this._renderer = new RenderKid();
        this._style = self2._getDefaultStyle();
        this._renderer.style(this._style);
      }
      PrettyError2.prototype.start = function() {
        var prepeare;
        this._oldPrepareStackTrace = Error.prepareStackTrace;
        prepeare = this._oldPrepareStackTrace || function(exc, frames) {
          var result2;
          result2 = exc.toString();
          frames = frames.map(function(frame) {
            return "  at " + frame.toString();
          });
          return result2 + "\n" + frames.join("\n");
        };
        Error.prepareStackTrace = function(_this) {
          return function(exc, trace) {
            var stack;
            stack = prepeare.apply(null, arguments);
            return _this.render({
              stack,
              message: exc.toString().replace(/^.*: /, "")
            }, false);
          };
        }(this);
        return this;
      };
      PrettyError2.prototype.stop = function() {
        Error.prepareStackTrace = this._oldPrepareStackTrace;
        return this._oldPrepareStackTrace = null;
      };
      PrettyError2.prototype.config = function(c) {
        var alias, path2, ref2;
        if (c.skipPackages != null) {
          if (c.skipPackages === false) {
            this.unskipAllPackages();
          } else {
            this.skipPackage.apply(this, c.skipPackages);
          }
        }
        if (c.skipPaths != null) {
          if (c.skipPaths === false) {
            this.unskipAllPaths();
          } else {
            this.skipPath.apply(this, c.skipPaths);
          }
        }
        if (c.skip != null) {
          if (c.skip === false) {
            this.unskipAll();
          } else {
            this.skip.apply(this, c.skip);
          }
        }
        if (c.maxItems != null) {
          this.setMaxItems(c.maxItems);
        }
        if (c.skipNodeFiles === true) {
          this.skipNodeFiles();
        } else if (c.skipNodeFiles === false) {
          this.unskipNodeFiles();
        }
        if (c.filters != null) {
          if (c.filters === false) {
            this.removeAllFilters();
          } else {
            this.filter.apply(this, c.filters);
          }
        }
        if (c.parsedErrorFilters != null) {
          if (c.parsedErrorFilters === false) {
            this.removeAllParsedErrorFilters();
          } else {
            this.filterParsedError.apply(this, c.parsedErrorFilters);
          }
        }
        if (c.aliases != null) {
          if (isPlainObject(c.aliases)) {
            ref2 = c.aliases;
            for (path2 in ref2) {
              alias = ref2[path2];
              this.alias(path2, alias);
            }
          } else if (c.aliases === false) {
            this.removeAllAliases();
          }
        }
        return this;
      };
      PrettyError2.prototype.withoutColors = function() {
        this._useColors = false;
        return this;
      };
      PrettyError2.prototype.withColors = function() {
        this._useColors = true;
        return this;
      };
      PrettyError2.prototype.skipPackage = function() {
        var j2, len2, packages, pkg;
        packages = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = packages.length; j2 < len2; j2++) {
          pkg = packages[j2];
          this._packagesToSkip.push(String(pkg));
        }
        return this;
      };
      PrettyError2.prototype.unskipPackage = function() {
        var j2, len2, packages, pkg;
        packages = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = packages.length; j2 < len2; j2++) {
          pkg = packages[j2];
          arrayUtils.pluckOneItem(this._packagesToSkip, pkg);
        }
        return this;
      };
      PrettyError2.prototype.unskipAllPackages = function() {
        this._packagesToSkip.length = 0;
        return this;
      };
      PrettyError2.prototype.skipPath = function() {
        var j2, len2, path2, paths;
        paths = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = paths.length; j2 < len2; j2++) {
          path2 = paths[j2];
          this._pathsToSkip.push(path2);
        }
        return this;
      };
      PrettyError2.prototype.unskipPath = function() {
        var j2, len2, path2, paths;
        paths = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = paths.length; j2 < len2; j2++) {
          path2 = paths[j2];
          arrayUtils.pluckOneItem(this._pathsToSkip, path2);
        }
        return this;
      };
      PrettyError2.prototype.unskipAllPaths = function() {
        this._pathsToSkip.length = 0;
        return this;
      };
      PrettyError2.prototype.skip = function() {
        var callbacks, cb, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb = callbacks[j2];
          this._skipCallbacks.push(cb);
        }
        return this;
      };
      PrettyError2.prototype.unskip = function() {
        var callbacks, cb, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb = callbacks[j2];
          arrayUtils.pluckOneItem(this._skipCallbacks, cb);
        }
        return this;
      };
      PrettyError2.prototype.unskipAll = function() {
        this._skipCallbacks.length = 0;
        return this;
      };
      PrettyError2.prototype.skipNodeFiles = function() {
        return this.skipPath.apply(this, nodePaths);
      };
      PrettyError2.prototype.unskipNodeFiles = function() {
        return this.unskipPath.apply(this, nodePaths);
      };
      PrettyError2.prototype.filter = function() {
        var callbacks, cb, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb = callbacks[j2];
          this._filterCallbacks.push(cb);
        }
        return this;
      };
      PrettyError2.prototype.removeFilter = function() {
        var callbacks, cb, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb = callbacks[j2];
          arrayUtils.pluckOneItem(this._filterCallbacks, cb);
        }
        return this;
      };
      PrettyError2.prototype.removeAllFilters = function() {
        this._filterCallbacks.length = 0;
        return this;
      };
      PrettyError2.prototype.filterParsedError = function() {
        var callbacks, cb, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb = callbacks[j2];
          this._parsedErrorFilters.push(cb);
        }
        return this;
      };
      PrettyError2.prototype.removeParsedErrorFilter = function() {
        var callbacks, cb, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb = callbacks[j2];
          arrayUtils.pluckOneItem(this._parsedErrorFilters, cb);
        }
        return this;
      };
      PrettyError2.prototype.removeAllParsedErrorFilters = function() {
        this._parsedErrorFilters.length = 0;
        return this;
      };
      PrettyError2.prototype.setMaxItems = function(maxItems) {
        if (maxItems == null) {
          maxItems = 50;
        }
        if (maxItems === 0) {
          maxItems = 50;
        }
        this._maxItems = maxItems | 0;
        return this;
      };
      PrettyError2.prototype.alias = function(stringOrRx, alias) {
        this._aliases.push({
          stringOrRx,
          alias
        });
        return this;
      };
      PrettyError2.prototype.removeAlias = function(stringOrRx) {
        arrayUtils.pluckByCallback(this._aliases, function(pair) {
          return pair.stringOrRx === stringOrRx;
        });
        return this;
      };
      PrettyError2.prototype.removeAllAliases = function() {
        this._aliases.length = 0;
        return this;
      };
      PrettyError2.prototype._getStyle = function() {
        return this._style;
      };
      PrettyError2.prototype.appendStyle = function(toAppend) {
        merge2(this._style, toAppend);
        this._renderer.style(toAppend);
        return this;
      };
      PrettyError2.prototype._getRenderer = function() {
        return this._renderer;
      };
      PrettyError2.prototype.render = function(e, logIt, useColors) {
        var obj, rendered;
        if (logIt == null) {
          logIt = false;
        }
        if (useColors == null) {
          useColors = this._useColors;
        }
        obj = this.getObject(e);
        rendered = this._renderer.render(obj, useColors);
        if (logIt === true) {
          console.error(rendered);
        }
        return rendered;
      };
      PrettyError2.prototype.getObject = function(e) {
        var count, header, i, item, j2, len2, obj, ref2, traceItems;
        if (!(e instanceof ParsedError)) {
          e = new ParsedError(e);
        }
        this._applyParsedErrorFiltersOn(e);
        header = {
          title: function() {
            var ret;
            ret = {};
            if (e.wrapper !== "") {
              ret.wrapper = "" + e.wrapper;
            }
            ret.kind = e.kind;
            return ret;
          }(),
          colon: ":",
          message: String(e.message).trim()
        };
        traceItems = [];
        count = -1;
        ref2 = e.trace;
        for (i = j2 = 0, len2 = ref2.length; j2 < len2; i = ++j2) {
          item = ref2[i];
          if (item == null) {
            continue;
          }
          if (this._skipOrFilter(item, i) === true) {
            continue;
          }
          count++;
          if (count > this._maxItems) {
            break;
          }
          if (typeof item === "string") {
            traceItems.push({
              item: {
                custom: item
              }
            });
            continue;
          }
          traceItems.push(function() {
            var markupItem;
            markupItem = {
              item: {
                header: {
                  pointer: function() {
                    if (item.file == null) {
                      return "";
                    }
                    return {
                      file: item.file,
                      colon: ":",
                      line: item.line
                    };
                  }()
                },
                footer: function() {
                  var foooter;
                  foooter = {
                    addr: item.shortenedAddr
                  };
                  if (item.extra != null) {
                    foooter.extra = item.extra;
                  }
                  return foooter;
                }()
              }
            };
            if (typeof item.what === "string" && item.what.trim().length > 0) {
              markupItem.item.header.what = item.what;
            }
            return markupItem;
          }());
        }
        obj = {
          "pretty-error": {
            header
          }
        };
        if (traceItems.length > 0) {
          obj["pretty-error"].trace = traceItems;
        }
        return obj;
      };
      PrettyError2.prototype._skipOrFilter = function(item, itemNumber) {
        var cb, j2, k, l, len2, len1, len22, len3, m, modName, pair, ref2, ref1, ref22, ref3, ref4, ref5;
        if (typeof item === "object") {
          if (ref2 = item.modName, indexOf.call(this._packagesToSkip, ref2) >= 0) {
            return true;
          }
          if (ref1 = item.path, indexOf.call(this._pathsToSkip, ref1) >= 0) {
            return true;
          }
          ref22 = item.packages;
          for (j2 = 0, len2 = ref22.length; j2 < len2; j2++) {
            modName = ref22[j2];
            if (indexOf.call(this._packagesToSkip, modName) >= 0) {
              return true;
            }
          }
          if (typeof item.shortenedAddr === "string") {
            ref3 = this._aliases;
            for (k = 0, len1 = ref3.length; k < len1; k++) {
              pair = ref3[k];
              item.shortenedAddr = item.shortenedAddr.replace(pair.stringOrRx, pair.alias);
            }
          }
        }
        ref4 = this._skipCallbacks;
        for (l = 0, len22 = ref4.length; l < len22; l++) {
          cb = ref4[l];
          if (cb(item, itemNumber) === true) {
            return true;
          }
        }
        ref5 = this._filterCallbacks;
        for (m = 0, len3 = ref5.length; m < len3; m++) {
          cb = ref5[m];
          cb(item, itemNumber);
        }
        return false;
      };
      PrettyError2.prototype._applyParsedErrorFiltersOn = function(error) {
        var cb, j2, len2, ref2;
        ref2 = this._parsedErrorFilters;
        for (j2 = 0, len2 = ref2.length; j2 < len2; j2++) {
          cb = ref2[j2];
          cb(error);
        }
      };
      return PrettyError2;
    }();
    ref = ["renderer", "style"];
    fn = function() {
      var methodName;
      methodName = "_get" + prop[0].toUpperCase() + prop.substr(1, prop.length);
      return PrettyError.prototype.__defineGetter__(prop, function() {
        return this[methodName]();
      });
    };
    for (j = 0, len = ref.length; j < len; j++) {
      prop = ref[j];
      fn();
    }
  }
});

// src/cli/index.ts
var import_commander = __toESM(require_commander());

// src/cli/components-api/index.ts
var import_xstate3 = __toESM(require_lib());

// src/cli/machines/resolveTablesMachine.ts
var import_xstate = __toESM(require_lib());
var createResolveTablesMachine = (props) => (0, import_xstate.createMachine)({
  id: "resolveTables",
  initial: "idle",
  context: {
    ...props,
    missingItemIndex: 0,
    newItemIndex: 0,
    createdTables: [],
    renamedTables: [],
    deletedTables: []
  },
  states: {
    idle: {
      entry: (0, import_xstate.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "table"
          }
        ]
      }
    },
    table: {
      on: {
        CHOICE_ITEM: { target: "action", actions: ["choseItem"] }
      }
    },
    action: {
      initial: "actionChoice",
      states: {
        actionChoice: {
          on: { DELETED: "#resolveTables.confirmationDelete", RENAMED: "rename" }
        },
        rename: {
          on: {
            CHOICE_NEW_ITEM: { target: "#resolveTables.confirmationRename", actions: ["choseNewItem"] }
          }
        }
      }
    },
    confirmationDelete: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "check", actions: ["delete"] }
        ]
      }
    },
    confirmationRename: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "check", actions: ["rename"] }
        ]
      }
    },
    check: {
      entry: (0, import_xstate.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "table"
          }
        ]
      }
    },
    done: {}
  }
}, {
  guards: {
    isResolved: ({ missingTables, newTables }) => !missingTables.length || !newTables.length
  },
  actions: {
    choseItem: (0, import_xstate.assign)({
      missingItemIndex: (context, event2) => event2.type === "CHOICE_ITEM" ? event2.itemIndex : 0
    }),
    choseNewItem: (0, import_xstate.assign)({
      newItemIndex: (context, event2) => event2.type === "CHOICE_NEW_ITEM" ? event2.itemIndex : 0
    }),
    delete: (0, import_xstate.assign)({
      deletedTables: ({
        missingItemIndex,
        deletedTables,
        missingTables
      }) => [...deletedTables, missingTables[missingItemIndex]],
      missingTables: ({
        missingItemIndex,
        missingTables
      }) => missingTables.filter((_, index) => index !== missingItemIndex)
    }),
    rename: (0, import_xstate.assign)({
      renamedTables: ({
        missingItemIndex,
        newItemIndex,
        renamedTables,
        newTables,
        missingTables
      }) => [
        ...renamedTables,
        { from: missingTables[missingItemIndex], to: newTables[newItemIndex] }
      ],
      missingTables: ({
        missingItemIndex,
        missingTables
      }) => missingTables.filter((_, index) => index !== missingItemIndex),
      newTables: ({
        newItemIndex,
        newTables
      }) => newTables.filter((_, index) => index !== newItemIndex)
    }),
    resolveRemaining: (0, import_xstate.assign)({
      createdTables: ({
        newTables,
        createdTables
      }) => [...createdTables, ...newTables],
      deletedTables: ({
        missingTables,
        deletedTables
      }) => [...deletedTables, ...missingTables],
      missingTables: (context) => [],
      newTables: (context) => []
    })
  }
});
var resolveTablesMachine_default = createResolveTablesMachine;

// src/cli/machines/resolveColumnsMachine.ts
var import_xstate2 = __toESM(require_lib());
var createResolveColumnsMachine = (props) => (0, import_xstate2.createMachine)({
  id: "resolveColumns",
  initial: "idle",
  context: {
    tableName: props.name,
    addedColumns: props.added,
    deletedColumns: props.deleted,
    missingItemIndex: 0,
    newItemIndex: 0,
    created: [],
    renamed: [],
    deleted: []
  },
  states: {
    idle: {
      entry: (0, import_xstate2.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "table"
          }
        ]
      }
    },
    table: {
      on: {
        CHOICE_ITEM: { target: "action", actions: ["choseItem"] }
      }
    },
    action: {
      initial: "actionChoice",
      states: {
        actionChoice: {
          on: { DELETED: "#resolveColumns.confirmationDelete", RENAMED: "rename" }
        },
        rename: {
          on: {
            CHOICE_NEW_ITEM: { target: "#resolveColumns.confirmationRename", actions: ["choseNewItem"] }
          }
        }
      }
    },
    confirmationDelete: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "check", actions: ["delete"] }
        ]
      }
    },
    confirmationRename: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "check", actions: ["rename"] }
        ]
      }
    },
    check: {
      entry: (0, import_xstate2.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "table"
          }
        ]
      }
    },
    done: {}
  }
}, {
  guards: {
    isResolved: ({ deletedColumns, addedColumns }) => !deletedColumns.length || !addedColumns.length
  },
  actions: {
    choseItem: (0, import_xstate2.assign)({
      missingItemIndex: (context, event2) => event2.type === "CHOICE_ITEM" ? event2.itemIndex : 0
    }),
    choseNewItem: (0, import_xstate2.assign)({
      newItemIndex: (context, event2) => event2.type === "CHOICE_NEW_ITEM" ? event2.itemIndex : 0
    }),
    delete: (0, import_xstate2.assign)({
      deleted: ({
        missingItemIndex,
        deleted,
        deletedColumns
      }) => [...deleted, deletedColumns[missingItemIndex]],
      deletedColumns: ({
        missingItemIndex,
        deletedColumns
      }) => deletedColumns.filter((_, index) => index !== missingItemIndex)
    }),
    rename: (0, import_xstate2.assign)({
      renamed: ({
        missingItemIndex,
        newItemIndex,
        renamed: renamed2,
        addedColumns,
        deletedColumns
      }) => [
        ...renamed2,
        { from: deletedColumns[missingItemIndex], to: addedColumns[newItemIndex] }
      ],
      deletedColumns: ({
        missingItemIndex,
        deletedColumns
      }) => deletedColumns.filter((_, index) => index !== missingItemIndex),
      addedColumns: ({
        newItemIndex,
        addedColumns
      }) => addedColumns.filter((_, index) => index !== newItemIndex)
    }),
    resolveRemaining: (0, import_xstate2.assign)({
      created: ({
        addedColumns,
        created
      }) => [...created, ...addedColumns],
      deleted: ({
        deletedColumns,
        deleted
      }) => [...deleted, ...deletedColumns],
      deletedColumns: (context) => [],
      addedColumns: (context) => []
    })
  }
});
var resolveColumnsMachine_default = createResolveColumnsMachine;

// src/cli/utils/formatDataForTable.ts
var transpose = (matrix) => {
  let [row] = matrix;
  return row.map((value, column) => matrix.map((row2) => row2[column]));
};
var formatDataForTable_default = (created, renamed2, deleted) => {
  const columns = [[], [], []];
  columns[0] = created.map(({ name }) => name);
  columns[1] = renamed2.map(({ from, to }) => `${from.name} -> ${to.name}`);
  columns[2] = deleted.map(({ name }) => name);
  const maxColumnLength = Math.max(columns[0].length, columns[1].length, columns[2].length);
  const filledColumns = columns.map((column) => {
    const columnLength = column.length;
    column.length = maxColumnLength;
    column.fill("", columnLength);
    return column;
  });
  return transpose(filledColumns);
};

// src/cli/components-api/index.ts
var import_loading_cli = __toESM(require_lib3());
var { Select, Confirm } = require_enquirer();
var Table = require_lib4();
var actions = ["Renamed", "Deleted"];
var bold = "\x1B[1m";
var red = "\x1B[31m";
var blue = "\x1B[34m";
var reset = "\x1B[0m";
var getElementIndexByName = (array, elementName) => array.findIndex(({ name }) => name === elementName);
var clearLine = () => {
  process.stdout.moveCursor(0, -1);
  process.stdout.clearLine(1);
};
var task = async (titleStr, func) => {
  const progress = (0, import_loading_cli.default)({
    frames: ["\u280B", "\u2819", "\u2839", "\u2838", "\u283C", "\u2834", "\u2826", "\u2827", "\u2807", "\u280F"],
    text: `${bold}${titleStr}`
  }).start();
  try {
    const result2 = await func({
      setTitle: (title) => {
        progress.text = `${bold}${title}`;
      },
      setError: (error) => {
        progress.fail(error.message);
      }
    });
    progress.succeed();
    return result2;
  } catch (error) {
    progress.fail(`${bold}${error.message}`);
    throw Error(error);
  }
};
var promptTablesConflicts = ({ missingTables: m, newTables: n }) => new Promise((resolve) => {
  const resolveTablesMachine = resolveTablesMachine_default({ missingTables: m, newTables: n });
  const service = (0, import_xstate3.interpret)(resolveTablesMachine).start();
  service.subscribe(async (state) => {
    var _a;
    try {
      const {
        missingItemIndex,
        newItemIndex,
        newTables,
        missingTables,
        createdTables,
        renamedTables,
        deletedTables
      } = state.context;
      if (state.matches("idle")) {
        service.send({ type: "NEXT" });
      }
      if (state.changed && state.matches("table")) {
        const tableName = await new Select({
          name: "tableName",
          message: "Chose missing table:",
          choices: missingTables.map(({ name }) => name)
        }).run();
        clearLine();
        service.send({ type: "CHOICE_ITEM", itemIndex: getElementIndexByName(missingTables, tableName) });
      }
      if (state.changed && state.matches("action.actionChoice")) {
        const actionName = await new Select({
          name: "tableName",
          message: `Table "${missingTables[missingItemIndex].name}" was:`,
          choices: actions
        }).run();
        clearLine();
        service.send({ type: actionName.toUpperCase() });
      }
      if (state.changed && state.matches("confirmationDelete")) {
        const confirmation = await new Confirm({
          name: "confirm",
          message: "Are you sure?",
          initial: true
        }).run();
        clearLine();
        if (confirmation)
          console.log(`${bold}Deleted "${missingTables[missingItemIndex].name}" table, ${red}all data will be lost!`);
        service.send({ type: confirmation ? "CONFIRM" : "CANCEL" });
      }
      if (state.changed && state.matches("confirmationRename")) {
        const confirmation = await new Confirm({
          name: "confirm",
          message: "Are you sure?",
          initial: true
        }).run();
        clearLine();
        if (confirmation)
          console.log(`${bold}Renamed "${missingTables[missingItemIndex].name}" -> "${newTables[newItemIndex].name}"`);
        service.send({ type: confirmation ? "CONFIRM" : "CANCEL" });
      }
      if (state.changed && state.matches("action.rename")) {
        const tableName = await new Select({
          name: "tableName",
          message: `Table "${(_a = missingTables[missingItemIndex]) == null ? void 0 : _a.name}" was renamed to:`,
          choices: newTables.map(({ name }) => name)
        }).run();
        clearLine();
        service.send({ type: "CHOICE_NEW_ITEM", itemIndex: getElementIndexByName(newTables, tableName) });
      }
      if (state.changed && state.matches("done")) {
        if (createdTables.length || deletedTables.length || renamedTables.length) {
          const table = new Table({
            head: [`${blue}Created`, `${blue}Renamed`, `${blue}Deleted`],
            rows: formatDataForTable_default(createdTables, renamedTables, deletedTables)
          });
          console.log(`${reset}${bold}Tables:`);
          console.log(table.toString());
        }
        resolve({
          created: createdTables,
          deleted: deletedTables,
          renamed: renamedTables
        });
        service.stop();
      }
    } catch (e) {
      console.error(e);
    }
  });
});
var promptColumnsConflicts = (props) => new Promise((resolve) => {
  const resolveColumnsMachine = resolveColumnsMachine_default(props);
  const service = (0, import_xstate3.interpret)(resolveColumnsMachine).start();
  service.subscribe(async (state) => {
    var _a;
    try {
      const {
        tableName,
        addedColumns,
        deletedColumns,
        missingItemIndex,
        newItemIndex,
        created,
        renamed: renamed2,
        deleted
      } = state.context;
      if (state.matches("idle")) {
        service.send({ type: "NEXT" });
      }
      if (state.changed && state.matches("table")) {
        const columnName = await new Select({
          name: "columnName",
          message: `Table "${tableName}" missing columns:`,
          choices: deletedColumns.map(({ name }) => name)
        }).run();
        clearLine();
        service.send({ type: "CHOICE_ITEM", itemIndex: getElementIndexByName(deletedColumns, columnName) });
      }
      if (state.changed && state.matches("action.actionChoice")) {
        const actionName = await new Select({
          name: "tableName",
          message: `Column "${deletedColumns[missingItemIndex].name}" was:`,
          choices: actions
        }).run();
        clearLine();
        service.send({ type: actionName.toUpperCase() });
      }
      if (state.changed && state.matches("confirmationDelete")) {
        const confirmation = await new Confirm({
          name: "confirm",
          message: "Are you sure?",
          initial: true
        }).run();
        clearLine();
        if (confirmation)
          console.log(`${bold}Deleted column "${deletedColumns[missingItemIndex].name}" from "${tableName}" table, ${red}all data will be lost!`);
        service.send({ type: confirmation ? "CONFIRM" : "CANCEL" });
      }
      if (state.changed && state.matches("confirmationRename")) {
        const confirmation = await new Confirm({
          name: "confirm",
          message: "Are you sure?",
          initial: true
        }).run();
        clearLine();
        if (confirmation)
          console.log(`${bold}Renamed "${deletedColumns[missingItemIndex].name} -> ${addedColumns[newItemIndex].name}" in "${tableName}" table`);
        service.send({ type: confirmation ? "CONFIRM" : "CANCEL" });
      }
      if (state.changed && state.matches("action.rename")) {
        const columnName = await new Select({
          name: "tableName",
          message: `Column "${(_a = deletedColumns[missingItemIndex]) == null ? void 0 : _a.name}" was renamed to:`,
          choices: addedColumns.map(({ name }) => name)
        }).run();
        clearLine();
        service.send({ type: "CHOICE_NEW_ITEM", itemIndex: getElementIndexByName(addedColumns, columnName) });
      }
      if (state.changed && state.matches("done")) {
        if (created.length || deleted.length || renamed2.length) {
          const table = new Table({
            head: [`${blue}Created`, `${blue}Renamed`, `${blue}Deleted`],
            rows: formatDataForTable_default(created, renamed2, deleted)
          });
          console.log(`${reset}${bold}Table "${tableName}" columns:`);
          console.log(table.toString());
        }
        resolve({
          created,
          deleted,
          renamed: renamed2
        });
        service.stop();
      }
    } catch (e) {
      console.error(e);
    }
  });
});

// src/cli/commands/migrate.ts
var import_fs3 = __toESM(require("fs"));

// node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/dist/js-yaml.mjs
function isNothing(subject) {
  return typeof subject === "undefined" || subject === null;
}
function isObject(subject) {
  return typeof subject === "object" && subject !== null;
}
function toArray(sequence) {
  if (Array.isArray(sequence))
    return sequence;
  else if (isNothing(sequence))
    return [];
  return [sequence];
}
function extend(target, source) {
  var index, length, key, sourceKeys;
  if (source) {
    sourceKeys = Object.keys(source);
    for (index = 0, length = sourceKeys.length; index < length; index += 1) {
      key = sourceKeys[index];
      target[key] = source[key];
    }
  }
  return target;
}
function repeat(string2, count) {
  var result2 = "", cycle;
  for (cycle = 0; cycle < count; cycle += 1) {
    result2 += string2;
  }
  return result2;
}
function isNegativeZero(number) {
  return number === 0 && Number.NEGATIVE_INFINITY === 1 / number;
}
var isNothing_1 = isNothing;
var isObject_1 = isObject;
var toArray_1 = toArray;
var repeat_1 = repeat;
var isNegativeZero_1 = isNegativeZero;
var extend_1 = extend;
var common = {
  isNothing: isNothing_1,
  isObject: isObject_1,
  toArray: toArray_1,
  repeat: repeat_1,
  isNegativeZero: isNegativeZero_1,
  extend: extend_1
};
function formatError(exception2, compact) {
  var where = "", message = exception2.reason || "(unknown reason)";
  if (!exception2.mark)
    return message;
  if (exception2.mark.name) {
    where += 'in "' + exception2.mark.name + '" ';
  }
  where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
  if (!compact && exception2.mark.snippet) {
    where += "\n\n" + exception2.mark.snippet;
  }
  return message + " " + where;
}
function YAMLException$1(reason, mark) {
  Error.call(this);
  this.name = "YAMLException";
  this.reason = reason;
  this.mark = mark;
  this.message = formatError(this, false);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack || "";
  }
}
YAMLException$1.prototype = Object.create(Error.prototype);
YAMLException$1.prototype.constructor = YAMLException$1;
YAMLException$1.prototype.toString = function toString(compact) {
  return this.name + ": " + formatError(this, compact);
};
var exception = YAMLException$1;
function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
  var head = "";
  var tail = "";
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
  if (position - lineStart > maxHalfLength) {
    head = " ... ";
    lineStart = position - maxHalfLength + head.length;
  }
  if (lineEnd - position > maxHalfLength) {
    tail = " ...";
    lineEnd = position + maxHalfLength - tail.length;
  }
  return {
    str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
    pos: position - lineStart + head.length
  };
}
function padStart(string2, max) {
  return common.repeat(" ", max - string2.length) + string2;
}
function makeSnippet(mark, options) {
  options = Object.create(options || null);
  if (!mark.buffer)
    return null;
  if (!options.maxLength)
    options.maxLength = 79;
  if (typeof options.indent !== "number")
    options.indent = 1;
  if (typeof options.linesBefore !== "number")
    options.linesBefore = 3;
  if (typeof options.linesAfter !== "number")
    options.linesAfter = 2;
  var re = /\r?\n|\r|\0/g;
  var lineStarts = [0];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;
  while (match = re.exec(mark.buffer)) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);
    if (mark.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }
  if (foundLineNo < 0)
    foundLineNo = lineStarts.length - 1;
  var result2 = "", i, line;
  var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
  for (i = 1; i <= options.linesBefore; i++) {
    if (foundLineNo - i < 0)
      break;
    line = getLine(mark.buffer, lineStarts[foundLineNo - i], lineEnds[foundLineNo - i], mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]), maxLineLength);
    result2 = common.repeat(" ", options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result2;
  }
  line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
  result2 += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  result2 += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
  for (i = 1; i <= options.linesAfter; i++) {
    if (foundLineNo + i >= lineEnds.length)
      break;
    line = getLine(mark.buffer, lineStarts[foundLineNo + i], lineEnds[foundLineNo + i], mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]), maxLineLength);
    result2 += common.repeat(" ", options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  }
  return result2.replace(/\n$/, "");
}
var snippet = makeSnippet;
var TYPE_CONSTRUCTOR_OPTIONS = [
  "kind",
  "multi",
  "resolve",
  "construct",
  "instanceOf",
  "predicate",
  "represent",
  "representName",
  "defaultStyle",
  "styleAliases"
];
var YAML_NODE_KINDS = [
  "scalar",
  "sequence",
  "mapping"
];
function compileStyleAliases(map2) {
  var result2 = {};
  if (map2 !== null) {
    Object.keys(map2).forEach(function(style) {
      map2[style].forEach(function(alias) {
        result2[String(alias)] = style;
      });
    });
  }
  return result2;
}
function Type$1(tag, options) {
  options = options || {};
  Object.keys(options).forEach(function(name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });
  this.options = options;
  this.tag = tag;
  this.kind = options["kind"] || null;
  this.resolve = options["resolve"] || function() {
    return true;
  };
  this.construct = options["construct"] || function(data) {
    return data;
  };
  this.instanceOf = options["instanceOf"] || null;
  this.predicate = options["predicate"] || null;
  this.represent = options["represent"] || null;
  this.representName = options["representName"] || null;
  this.defaultStyle = options["defaultStyle"] || null;
  this.multi = options["multi"] || false;
  this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}
var type = Type$1;
function compileList(schema2, name) {
  var result2 = [];
  schema2[name].forEach(function(currentType) {
    var newIndex = result2.length;
    result2.forEach(function(previousType, previousIndex) {
      if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
        newIndex = previousIndex;
      }
    });
    result2[newIndex] = currentType;
  });
  return result2;
}
function compileMap() {
  var result2 = {
    scalar: {},
    sequence: {},
    mapping: {},
    fallback: {},
    multi: {
      scalar: [],
      sequence: [],
      mapping: [],
      fallback: []
    }
  }, index, length;
  function collectType(type2) {
    if (type2.multi) {
      result2.multi[type2.kind].push(type2);
      result2.multi["fallback"].push(type2);
    } else {
      result2[type2.kind][type2.tag] = result2["fallback"][type2.tag] = type2;
    }
  }
  for (index = 0, length = arguments.length; index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result2;
}
function Schema$1(definition) {
  return this.extend(definition);
}
Schema$1.prototype.extend = function extend2(definition) {
  var implicit = [];
  var explicit = [];
  if (definition instanceof type) {
    explicit.push(definition);
  } else if (Array.isArray(definition)) {
    explicit = explicit.concat(definition);
  } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
    if (definition.implicit)
      implicit = implicit.concat(definition.implicit);
    if (definition.explicit)
      explicit = explicit.concat(definition.explicit);
  } else {
    throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
  }
  implicit.forEach(function(type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
    if (type$1.loadKind && type$1.loadKind !== "scalar") {
      throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
    }
    if (type$1.multi) {
      throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
    }
  });
  explicit.forEach(function(type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
  });
  var result2 = Object.create(Schema$1.prototype);
  result2.implicit = (this.implicit || []).concat(implicit);
  result2.explicit = (this.explicit || []).concat(explicit);
  result2.compiledImplicit = compileList(result2, "implicit");
  result2.compiledExplicit = compileList(result2, "explicit");
  result2.compiledTypeMap = compileMap(result2.compiledImplicit, result2.compiledExplicit);
  return result2;
};
var schema = Schema$1;
var str = new type("tag:yaml.org,2002:str", {
  kind: "scalar",
  construct: function(data) {
    return data !== null ? data : "";
  }
});
var seq = new type("tag:yaml.org,2002:seq", {
  kind: "sequence",
  construct: function(data) {
    return data !== null ? data : [];
  }
});
var map = new type("tag:yaml.org,2002:map", {
  kind: "mapping",
  construct: function(data) {
    return data !== null ? data : {};
  }
});
var failsafe = new schema({
  explicit: [
    str,
    seq,
    map
  ]
});
function resolveYamlNull(data) {
  if (data === null)
    return true;
  var max = data.length;
  return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
}
function constructYamlNull() {
  return null;
}
function isNull(object2) {
  return object2 === null;
}
var _null = new type("tag:yaml.org,2002:null", {
  kind: "scalar",
  resolve: resolveYamlNull,
  construct: constructYamlNull,
  predicate: isNull,
  represent: {
    canonical: function() {
      return "~";
    },
    lowercase: function() {
      return "null";
    },
    uppercase: function() {
      return "NULL";
    },
    camelcase: function() {
      return "Null";
    },
    empty: function() {
      return "";
    }
  },
  defaultStyle: "lowercase"
});
function resolveYamlBoolean(data) {
  if (data === null)
    return false;
  var max = data.length;
  return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
}
function constructYamlBoolean(data) {
  return data === "true" || data === "True" || data === "TRUE";
}
function isBoolean(object2) {
  return Object.prototype.toString.call(object2) === "[object Boolean]";
}
var bool = new type("tag:yaml.org,2002:bool", {
  kind: "scalar",
  resolve: resolveYamlBoolean,
  construct: constructYamlBoolean,
  predicate: isBoolean,
  represent: {
    lowercase: function(object2) {
      return object2 ? "true" : "false";
    },
    uppercase: function(object2) {
      return object2 ? "TRUE" : "FALSE";
    },
    camelcase: function(object2) {
      return object2 ? "True" : "False";
    }
  },
  defaultStyle: "lowercase"
});
function isHexCode(c) {
  return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
}
function isOctCode(c) {
  return 48 <= c && c <= 55;
}
function isDecCode(c) {
  return 48 <= c && c <= 57;
}
function resolveYamlInteger(data) {
  if (data === null)
    return false;
  var max = data.length, index = 0, hasDigits = false, ch;
  if (!max)
    return false;
  ch = data[index];
  if (ch === "-" || ch === "+") {
    ch = data[++index];
  }
  if (ch === "0") {
    if (index + 1 === max)
      return true;
    ch = data[++index];
    if (ch === "b") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (ch !== "0" && ch !== "1")
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "x") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (!isHexCode(data.charCodeAt(index)))
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "o") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (!isOctCode(data.charCodeAt(index)))
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
  }
  if (ch === "_")
    return false;
  for (; index < max; index++) {
    ch = data[index];
    if (ch === "_")
      continue;
    if (!isDecCode(data.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }
  if (!hasDigits || ch === "_")
    return false;
  return true;
}
function constructYamlInteger(data) {
  var value = data, sign = 1, ch;
  if (value.indexOf("_") !== -1) {
    value = value.replace(/_/g, "");
  }
  ch = value[0];
  if (ch === "-" || ch === "+") {
    if (ch === "-")
      sign = -1;
    value = value.slice(1);
    ch = value[0];
  }
  if (value === "0")
    return 0;
  if (ch === "0") {
    if (value[1] === "b")
      return sign * parseInt(value.slice(2), 2);
    if (value[1] === "x")
      return sign * parseInt(value.slice(2), 16);
    if (value[1] === "o")
      return sign * parseInt(value.slice(2), 8);
  }
  return sign * parseInt(value, 10);
}
function isInteger(object2) {
  return Object.prototype.toString.call(object2) === "[object Number]" && (object2 % 1 === 0 && !common.isNegativeZero(object2));
}
var int = new type("tag:yaml.org,2002:int", {
  kind: "scalar",
  resolve: resolveYamlInteger,
  construct: constructYamlInteger,
  predicate: isInteger,
  represent: {
    binary: function(obj) {
      return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
    },
    octal: function(obj) {
      return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
    },
    decimal: function(obj) {
      return obj.toString(10);
    },
    hexadecimal: function(obj) {
      return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
    }
  },
  defaultStyle: "decimal",
  styleAliases: {
    binary: [2, "bin"],
    octal: [8, "oct"],
    decimal: [10, "dec"],
    hexadecimal: [16, "hex"]
  }
});
var YAML_FLOAT_PATTERN = new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");
function resolveYamlFloat(data) {
  if (data === null)
    return false;
  if (!YAML_FLOAT_PATTERN.test(data) || data[data.length - 1] === "_") {
    return false;
  }
  return true;
}
function constructYamlFloat(data) {
  var value, sign;
  value = data.replace(/_/g, "").toLowerCase();
  sign = value[0] === "-" ? -1 : 1;
  if ("+-".indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }
  if (value === ".inf") {
    return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
  } else if (value === ".nan") {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}
var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
function representYamlFloat(object2, style) {
  var res;
  if (isNaN(object2)) {
    switch (style) {
      case "lowercase":
        return ".nan";
      case "uppercase":
        return ".NAN";
      case "camelcase":
        return ".NaN";
    }
  } else if (Number.POSITIVE_INFINITY === object2) {
    switch (style) {
      case "lowercase":
        return ".inf";
      case "uppercase":
        return ".INF";
      case "camelcase":
        return ".Inf";
    }
  } else if (Number.NEGATIVE_INFINITY === object2) {
    switch (style) {
      case "lowercase":
        return "-.inf";
      case "uppercase":
        return "-.INF";
      case "camelcase":
        return "-.Inf";
    }
  } else if (common.isNegativeZero(object2)) {
    return "-0.0";
  }
  res = object2.toString(10);
  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
}
function isFloat(object2) {
  return Object.prototype.toString.call(object2) === "[object Number]" && (object2 % 1 !== 0 || common.isNegativeZero(object2));
}
var float = new type("tag:yaml.org,2002:float", {
  kind: "scalar",
  resolve: resolveYamlFloat,
  construct: constructYamlFloat,
  predicate: isFloat,
  represent: representYamlFloat,
  defaultStyle: "lowercase"
});
var json = failsafe.extend({
  implicit: [
    _null,
    bool,
    int,
    float
  ]
});
var core = json;
var YAML_DATE_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$");
var YAML_TIMESTAMP_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$");
function resolveYamlTimestamp(data) {
  if (data === null)
    return false;
  if (YAML_DATE_REGEXP.exec(data) !== null)
    return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data) !== null)
    return true;
  return false;
}
function constructYamlTimestamp(data) {
  var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date;
  match = YAML_DATE_REGEXP.exec(data);
  if (match === null)
    match = YAML_TIMESTAMP_REGEXP.exec(data);
  if (match === null)
    throw new Error("Date resolve error");
  year = +match[1];
  month = +match[2] - 1;
  day = +match[3];
  if (!match[4]) {
    return new Date(Date.UTC(year, month, day));
  }
  hour = +match[4];
  minute = +match[5];
  second = +match[6];
  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) {
      fraction += "0";
    }
    fraction = +fraction;
  }
  if (match[9]) {
    tz_hour = +match[10];
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 6e4;
    if (match[9] === "-")
      delta = -delta;
  }
  date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
  if (delta)
    date.setTime(date.getTime() - delta);
  return date;
}
function representYamlTimestamp(object2) {
  return object2.toISOString();
}
var timestamp = new type("tag:yaml.org,2002:timestamp", {
  kind: "scalar",
  resolve: resolveYamlTimestamp,
  construct: constructYamlTimestamp,
  instanceOf: Date,
  represent: representYamlTimestamp
});
function resolveYamlMerge(data) {
  return data === "<<" || data === null;
}
var merge = new type("tag:yaml.org,2002:merge", {
  kind: "scalar",
  resolve: resolveYamlMerge
});
var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
function resolveYamlBinary(data) {
  if (data === null)
    return false;
  var code, idx2, bitlen = 0, max = data.length, map2 = BASE64_MAP;
  for (idx2 = 0; idx2 < max; idx2++) {
    code = map2.indexOf(data.charAt(idx2));
    if (code > 64)
      continue;
    if (code < 0)
      return false;
    bitlen += 6;
  }
  return bitlen % 8 === 0;
}
function constructYamlBinary(data) {
  var idx2, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result2 = [];
  for (idx2 = 0; idx2 < max; idx2++) {
    if (idx2 % 4 === 0 && idx2) {
      result2.push(bits >> 16 & 255);
      result2.push(bits >> 8 & 255);
      result2.push(bits & 255);
    }
    bits = bits << 6 | map2.indexOf(input.charAt(idx2));
  }
  tailbits = max % 4 * 6;
  if (tailbits === 0) {
    result2.push(bits >> 16 & 255);
    result2.push(bits >> 8 & 255);
    result2.push(bits & 255);
  } else if (tailbits === 18) {
    result2.push(bits >> 10 & 255);
    result2.push(bits >> 2 & 255);
  } else if (tailbits === 12) {
    result2.push(bits >> 4 & 255);
  }
  return new Uint8Array(result2);
}
function representYamlBinary(object2) {
  var result2 = "", bits = 0, idx2, tail, max = object2.length, map2 = BASE64_MAP;
  for (idx2 = 0; idx2 < max; idx2++) {
    if (idx2 % 3 === 0 && idx2) {
      result2 += map2[bits >> 18 & 63];
      result2 += map2[bits >> 12 & 63];
      result2 += map2[bits >> 6 & 63];
      result2 += map2[bits & 63];
    }
    bits = (bits << 8) + object2[idx2];
  }
  tail = max % 3;
  if (tail === 0) {
    result2 += map2[bits >> 18 & 63];
    result2 += map2[bits >> 12 & 63];
    result2 += map2[bits >> 6 & 63];
    result2 += map2[bits & 63];
  } else if (tail === 2) {
    result2 += map2[bits >> 10 & 63];
    result2 += map2[bits >> 4 & 63];
    result2 += map2[bits << 2 & 63];
    result2 += map2[64];
  } else if (tail === 1) {
    result2 += map2[bits >> 2 & 63];
    result2 += map2[bits << 4 & 63];
    result2 += map2[64];
    result2 += map2[64];
  }
  return result2;
}
function isBinary(obj) {
  return Object.prototype.toString.call(obj) === "[object Uint8Array]";
}
var binary = new type("tag:yaml.org,2002:binary", {
  kind: "scalar",
  resolve: resolveYamlBinary,
  construct: constructYamlBinary,
  predicate: isBinary,
  represent: representYamlBinary
});
var _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var _toString$2 = Object.prototype.toString;
function resolveYamlOmap(data) {
  if (data === null)
    return true;
  var objectKeys = [], index, length, pair, pairKey, pairHasKey, object2 = data;
  for (index = 0, length = object2.length; index < length; index += 1) {
    pair = object2[index];
    pairHasKey = false;
    if (_toString$2.call(pair) !== "[object Object]")
      return false;
    for (pairKey in pair) {
      if (_hasOwnProperty$3.call(pair, pairKey)) {
        if (!pairHasKey)
          pairHasKey = true;
        else
          return false;
      }
    }
    if (!pairHasKey)
      return false;
    if (objectKeys.indexOf(pairKey) === -1)
      objectKeys.push(pairKey);
    else
      return false;
  }
  return true;
}
function constructYamlOmap(data) {
  return data !== null ? data : [];
}
var omap = new type("tag:yaml.org,2002:omap", {
  kind: "sequence",
  resolve: resolveYamlOmap,
  construct: constructYamlOmap
});
var _toString$1 = Object.prototype.toString;
function resolveYamlPairs(data) {
  if (data === null)
    return true;
  var index, length, pair, keys, result2, object2 = data;
  result2 = new Array(object2.length);
  for (index = 0, length = object2.length; index < length; index += 1) {
    pair = object2[index];
    if (_toString$1.call(pair) !== "[object Object]")
      return false;
    keys = Object.keys(pair);
    if (keys.length !== 1)
      return false;
    result2[index] = [keys[0], pair[keys[0]]];
  }
  return true;
}
function constructYamlPairs(data) {
  if (data === null)
    return [];
  var index, length, pair, keys, result2, object2 = data;
  result2 = new Array(object2.length);
  for (index = 0, length = object2.length; index < length; index += 1) {
    pair = object2[index];
    keys = Object.keys(pair);
    result2[index] = [keys[0], pair[keys[0]]];
  }
  return result2;
}
var pairs = new type("tag:yaml.org,2002:pairs", {
  kind: "sequence",
  resolve: resolveYamlPairs,
  construct: constructYamlPairs
});
var _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
function resolveYamlSet(data) {
  if (data === null)
    return true;
  var key, object2 = data;
  for (key in object2) {
    if (_hasOwnProperty$2.call(object2, key)) {
      if (object2[key] !== null)
        return false;
    }
  }
  return true;
}
function constructYamlSet(data) {
  return data !== null ? data : {};
}
var set = new type("tag:yaml.org,2002:set", {
  kind: "mapping",
  resolve: resolveYamlSet,
  construct: constructYamlSet
});
var _default = core.extend({
  implicit: [
    timestamp,
    merge
  ],
  explicit: [
    binary,
    omap,
    pairs,
    set
  ]
});
var _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
var CONTEXT_FLOW_IN = 1;
var CONTEXT_FLOW_OUT = 2;
var CONTEXT_BLOCK_IN = 3;
var CONTEXT_BLOCK_OUT = 4;
var CHOMPING_CLIP = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP = 3;
var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
function _class(obj) {
  return Object.prototype.toString.call(obj);
}
function is_EOL(c) {
  return c === 10 || c === 13;
}
function is_WHITE_SPACE(c) {
  return c === 9 || c === 32;
}
function is_WS_OR_EOL(c) {
  return c === 9 || c === 32 || c === 10 || c === 13;
}
function is_FLOW_INDICATOR(c) {
  return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
}
function fromHexCode(c) {
  var lc;
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  lc = c | 32;
  if (97 <= lc && lc <= 102) {
    return lc - 97 + 10;
  }
  return -1;
}
function escapedHexLen(c) {
  if (c === 120) {
    return 2;
  }
  if (c === 117) {
    return 4;
  }
  if (c === 85) {
    return 8;
  }
  return 0;
}
function fromDecimalCode(c) {
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  return -1;
}
function simpleEscapeSequence(c) {
  return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
}
function charFromCodepoint(c) {
  if (c <= 65535) {
    return String.fromCharCode(c);
  }
  return String.fromCharCode((c - 65536 >> 10) + 55296, (c - 65536 & 1023) + 56320);
}
var simpleEscapeCheck = new Array(256);
var simpleEscapeMap = new Array(256);
for (i = 0; i < 256; i++) {
  simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
  simpleEscapeMap[i] = simpleEscapeSequence(i);
}
var i;
function State$1(input, options) {
  this.input = input;
  this.filename = options["filename"] || null;
  this.schema = options["schema"] || _default;
  this.onWarning = options["onWarning"] || null;
  this.legacy = options["legacy"] || false;
  this.json = options["json"] || false;
  this.listener = options["listener"] || null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap = this.schema.compiledTypeMap;
  this.length = input.length;
  this.position = 0;
  this.line = 0;
  this.lineStart = 0;
  this.lineIndent = 0;
  this.firstTabInLine = -1;
  this.documents = [];
}
function generateError(state, message) {
  var mark = {
    name: state.filename,
    buffer: state.input.slice(0, -1),
    position: state.position,
    line: state.line,
    column: state.position - state.lineStart
  };
  mark.snippet = snippet(mark);
  return new exception(message, mark);
}
function throwError(state, message) {
  throw generateError(state, message);
}
function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}
var directiveHandlers = {
  YAML: function handleYamlDirective(state, name, args) {
    var match, major, minor;
    if (state.version !== null) {
      throwError(state, "duplication of %YAML directive");
    }
    if (args.length !== 1) {
      throwError(state, "YAML directive accepts exactly one argument");
    }
    match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
    if (match === null) {
      throwError(state, "ill-formed argument of the YAML directive");
    }
    major = parseInt(match[1], 10);
    minor = parseInt(match[2], 10);
    if (major !== 1) {
      throwError(state, "unacceptable YAML version of the document");
    }
    state.version = args[0];
    state.checkLineBreaks = minor < 2;
    if (minor !== 1 && minor !== 2) {
      throwWarning(state, "unsupported YAML version of the document");
    }
  },
  TAG: function handleTagDirective(state, name, args) {
    var handle, prefix;
    if (args.length !== 2) {
      throwError(state, "TAG directive accepts exactly two arguments");
    }
    handle = args[0];
    prefix = args[1];
    if (!PATTERN_TAG_HANDLE.test(handle)) {
      throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
    }
    if (_hasOwnProperty$1.call(state.tagMap, handle)) {
      throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
    }
    if (!PATTERN_TAG_URI.test(prefix)) {
      throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
    }
    try {
      prefix = decodeURIComponent(prefix);
    } catch (err) {
      throwError(state, "tag prefix is malformed: " + prefix);
    }
    state.tagMap[handle] = prefix;
  }
};
function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;
  if (start < end) {
    _result = state.input.slice(start, end);
    if (checkJson) {
      for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
          throwError(state, "expected valid JSON character");
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError(state, "the stream contains non-printable characters");
    }
    state.result += _result;
  }
}
function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key, index, quantity;
  if (!common.isObject(source)) {
    throwError(state, "cannot merge mappings; the provided source object is unacceptable");
  }
  sourceKeys = Object.keys(source);
  for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
    key = sourceKeys[index];
    if (!_hasOwnProperty$1.call(destination, key)) {
      destination[key] = source[key];
      overridableKeys[key] = true;
    }
  }
}
function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
  var index, quantity;
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);
    for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError(state, "nested arrays are not supported inside keys");
      }
      if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
        keyNode[index] = "[object Object]";
      }
    }
  }
  if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
    keyNode = "[object Object]";
  }
  keyNode = String(keyNode);
  if (_result === null) {
    _result = {};
  }
  if (keyTag === "tag:yaml.org,2002:merge") {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError(state, "duplicated mapping key");
    }
    if (keyNode === "__proto__") {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }
  return _result;
}
function readLineBreak(state) {
  var ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 10) {
    state.position++;
  } else if (ch === 13) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 10) {
      state.position++;
    }
  } else {
    throwError(state, "a line break is expected");
  }
  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}
function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 9 && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }
    if (allowComments && ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 10 && ch !== 13 && ch !== 0);
    }
    if (is_EOL(ch)) {
      readLineBreak(state);
      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;
      while (ch === 32) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }
  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, "deficient indentation");
  }
  return lineBreaks;
}
function testDocumentSeparator(state) {
  var _position = state.position, ch;
  ch = state.input.charCodeAt(_position);
  if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
    _position += 3;
    ch = state.input.charCodeAt(_position);
    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }
  return false;
}
function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += " ";
  } else if (count > 1) {
    state.result += common.repeat("\n", count - 1);
  }
}
function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
  ch = state.input.charCodeAt(state.position);
  if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
    return false;
  }
  if (ch === 63 || ch === 45) {
    following = state.input.charCodeAt(state.position + 1);
    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }
  state.kind = "scalar";
  state.result = "";
  captureStart = captureEnd = state.position;
  hasPendingContent = false;
  while (ch !== 0) {
    if (ch === 58) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }
    } else if (ch === 35) {
      preceding = state.input.charCodeAt(state.position - 1);
      if (is_WS_OR_EOL(preceding)) {
        break;
      }
    } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;
    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);
      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }
    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }
    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }
    ch = state.input.charCodeAt(++state.position);
  }
  captureSegment(state, captureStart, captureEnd, false);
  if (state.result) {
    return true;
  }
  state.kind = _kind;
  state.result = _result;
  return false;
}
function readSingleQuotedScalar(state, nodeIndent) {
  var ch, captureStart, captureEnd;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 39) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 39) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (ch === 39) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a single quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a single quoted scalar");
}
function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 34) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 34) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;
    } else if (ch === 92) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;
      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;
        for (; hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);
          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;
          } else {
            throwError(state, "expected hexadecimal character");
          }
        }
        state.result += charFromCodepoint(hexResult);
        state.position++;
      } else {
        throwError(state, "unknown escape sequence");
      }
      captureStart = captureEnd = state.position;
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a double quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a double quoted scalar");
}
function readFlowCollection(state, nodeIndent) {
  var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 91) {
    terminator = 93;
    isMapping = false;
    _result = [];
  } else if (ch === 123) {
    terminator = 125;
    isMapping = true;
    _result = {};
  } else {
    return false;
  }
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(++state.position);
  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? "mapping" : "sequence";
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError(state, "missed comma between flow collection entries");
    } else if (ch === 44) {
      throwError(state, "expected the node content, but found ','");
    }
    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;
    if (ch === 63) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }
    _line = state.line;
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if ((isExplicitPair || state.line === _line) && ch === 58) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }
    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === 44) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }
  throwError(state, "unexpected end of the stream within a flow collection");
}
function readBlockScalar(state, nodeIndent) {
  var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 124) {
    folding = false;
  } else if (ch === 62) {
    folding = true;
  } else {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);
    if (ch === 43 || ch === 45) {
      if (CHOMPING_CLIP === chomping) {
        chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError(state, "repeat of a chomping mode identifier");
      }
    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError(state, "repeat of an indentation width identifier");
      }
    } else {
      break;
    }
  }
  if (is_WHITE_SPACE(ch)) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (is_WHITE_SPACE(ch));
    if (ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (!is_EOL(ch) && ch !== 0);
    }
  }
  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;
    ch = state.input.charCodeAt(state.position);
    while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }
    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }
    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }
    if (state.lineIndent < textIndent) {
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) {
          state.result += "\n";
        }
      }
      break;
    }
    if (folding) {
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat("\n", emptyLines + 1);
      } else if (emptyLines === 0) {
        if (didReadContent) {
          state.result += " ";
        }
      } else {
        state.result += common.repeat("\n", emptyLines);
      }
    } else {
      state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
    }
    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;
    while (!is_EOL(ch) && ch !== 0) {
      ch = state.input.charCodeAt(++state.position);
    }
    captureSegment(state, captureStart, state.position, false);
  }
  return true;
}
function readBlockSequence(state, nodeIndent) {
  var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
  if (state.firstTabInLine !== -1)
    return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    if (ch !== 45) {
      break;
    }
    following = state.input.charCodeAt(state.position + 1);
    if (!is_WS_OR_EOL(following)) {
      break;
    }
    detected = true;
    state.position++;
    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }
    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a sequence entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "sequence";
    state.result = _result;
    return true;
  }
  return false;
}
function readBlockMapping(state, nodeIndent, flowIndent) {
  var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
  if (state.firstTabInLine !== -1)
    return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    following = state.input.charCodeAt(state.position + 1);
    _line = state.line;
    if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
      if (ch === 63) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }
        detected = true;
        atExplicitKey = true;
        allowCompact = true;
      } else if (atExplicitKey) {
        atExplicitKey = false;
        allowCompact = true;
      } else {
        throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
      }
      state.position += 1;
      ch = following;
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;
      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        break;
      }
      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (ch === 58) {
          ch = state.input.charCodeAt(++state.position);
          if (!is_WS_OR_EOL(ch)) {
            throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
          }
          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;
        } else if (detected) {
          throwError(state, "can not read an implicit mapping pair; a colon is missed");
        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true;
        }
      } else if (detected) {
        throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true;
      }
    }
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }
      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }
      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }
      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a mapping entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "mapping";
    state.result = _result;
  }
  return detected;
}
function readTagProperty(state) {
  var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 33)
    return false;
  if (state.tag !== null) {
    throwError(state, "duplication of a tag property");
  }
  ch = state.input.charCodeAt(++state.position);
  if (ch === 60) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);
  } else if (ch === 33) {
    isNamed = true;
    tagHandle = "!!";
    ch = state.input.charCodeAt(++state.position);
  } else {
    tagHandle = "!";
  }
  _position = state.position;
  if (isVerbatim) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (ch !== 0 && ch !== 62);
    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError(state, "unexpected end of the stream within a verbatim tag");
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      if (ch === 33) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);
          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError(state, "named tag handle cannot contain such characters");
          }
          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError(state, "tag suffix cannot contain exclamation marks");
        }
      }
      ch = state.input.charCodeAt(++state.position);
    }
    tagName = state.input.slice(_position, state.position);
    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError(state, "tag suffix cannot contain flow indicator characters");
    }
  }
  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError(state, "tag name cannot contain such characters: " + tagName);
  }
  try {
    tagName = decodeURIComponent(tagName);
  } catch (err) {
    throwError(state, "tag name is malformed: " + tagName);
  }
  if (isVerbatim) {
    state.tag = tagName;
  } else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;
  } else if (tagHandle === "!") {
    state.tag = "!" + tagName;
  } else if (tagHandle === "!!") {
    state.tag = "tag:yaml.org,2002:" + tagName;
  } else {
    throwError(state, 'undeclared tag handle "' + tagHandle + '"');
  }
  return true;
}
function readAnchorProperty(state) {
  var _position, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 38)
    return false;
  if (state.anchor !== null) {
    throwError(state, "duplication of an anchor property");
  }
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an anchor node must contain at least one character");
  }
  state.anchor = state.input.slice(_position, state.position);
  return true;
}
function readAlias(state) {
  var _position, alias, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 42)
    return false;
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an alias node must contain at least one character");
  }
  alias = state.input.slice(_position, state.position);
  if (!_hasOwnProperty$1.call(state.anchorMap, alias)) {
    throwError(state, 'unidentified alias "' + alias + '"');
  }
  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}
function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
  if (state.listener !== null) {
    state.listener("open", state);
  }
  state.tag = null;
  state.anchor = null;
  state.kind = null;
  state.result = null;
  allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;
      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }
  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;
        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }
  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }
  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }
    blockIndent = state.position - state.lineStart;
    if (indentStatus === 1) {
      if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;
        } else if (readAlias(state)) {
          hasContent = true;
          if (state.tag !== null || state.anchor !== null) {
            throwError(state, "alias node should not have any properties");
          }
        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;
          if (state.tag === null) {
            state.tag = "?";
          }
        }
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }
  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }
  } else if (state.tag === "?") {
    if (state.result !== null && state.kind !== "scalar") {
      throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }
    for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
      type2 = state.implicitTypes[typeIndex];
      if (type2.resolve(state.result)) {
        state.result = type2.construct(state.result);
        state.tag = type2.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== "!") {
    if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) {
      type2 = state.typeMap[state.kind || "fallback"][state.tag];
    } else {
      type2 = null;
      typeList = state.typeMap.multi[state.kind || "fallback"];
      for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type2 = typeList[typeIndex];
          break;
        }
      }
    }
    if (!type2) {
      throwError(state, "unknown tag !<" + state.tag + ">");
    }
    if (state.result !== null && type2.kind !== state.kind) {
      throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
    }
    if (!type2.resolve(state.result, state.tag)) {
      throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
    } else {
      state.result = type2.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }
  if (state.listener !== null) {
    state.listener("close", state);
  }
  return state.tag !== null || state.anchor !== null || hasContent;
}
function readDocument(state) {
  var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = /* @__PURE__ */ Object.create(null);
  state.anchorMap = /* @__PURE__ */ Object.create(null);
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if (state.lineIndent > 0 || ch !== 37) {
      break;
    }
    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }
    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];
    if (directiveName.length < 1) {
      throwError(state, "directive name must not be less than one character in length");
    }
    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (ch === 35) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && !is_EOL(ch));
        break;
      }
      if (is_EOL(ch))
        break;
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      directiveArgs.push(state.input.slice(_position, state.position));
    }
    if (ch !== 0)
      readLineBreak(state);
    if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }
  skipSeparationSpace(state, true, -1);
  if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);
  } else if (hasDirectives) {
    throwError(state, "directives end mark is expected");
  }
  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);
  if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, "non-ASCII line breaks are interpreted as content");
  }
  state.documents.push(state.result);
  if (state.position === state.lineStart && testDocumentSeparator(state)) {
    if (state.input.charCodeAt(state.position) === 46) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }
  if (state.position < state.length - 1) {
    throwError(state, "end of the stream or a document separator is expected");
  } else {
    return;
  }
}
function loadDocuments(input, options) {
  input = String(input);
  options = options || {};
  if (input.length !== 0) {
    if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
      input += "\n";
    }
    if (input.charCodeAt(0) === 65279) {
      input = input.slice(1);
    }
  }
  var state = new State$1(input, options);
  var nullpos = input.indexOf("\0");
  if (nullpos !== -1) {
    state.position = nullpos;
    throwError(state, "null byte is not allowed in input");
  }
  state.input += "\0";
  while (state.input.charCodeAt(state.position) === 32) {
    state.lineIndent += 1;
    state.position += 1;
  }
  while (state.position < state.length - 1) {
    readDocument(state);
  }
  return state.documents;
}
function loadAll$1(input, iterator, options) {
  if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
    options = iterator;
    iterator = null;
  }
  var documents = loadDocuments(input, options);
  if (typeof iterator !== "function") {
    return documents;
  }
  for (var index = 0, length = documents.length; index < length; index += 1) {
    iterator(documents[index]);
  }
}
function load$1(input, options) {
  var documents = loadDocuments(input, options);
  if (documents.length === 0) {
    return void 0;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new exception("expected a single document in the stream, but found more");
}
var loadAll_1 = loadAll$1;
var load_1 = load$1;
var loader = {
  loadAll: loadAll_1,
  load: load_1
};
var _toString = Object.prototype.toString;
var _hasOwnProperty = Object.prototype.hasOwnProperty;
var CHAR_BOM = 65279;
var CHAR_TAB = 9;
var CHAR_LINE_FEED = 10;
var CHAR_CARRIAGE_RETURN = 13;
var CHAR_SPACE = 32;
var CHAR_EXCLAMATION = 33;
var CHAR_DOUBLE_QUOTE = 34;
var CHAR_SHARP = 35;
var CHAR_PERCENT = 37;
var CHAR_AMPERSAND = 38;
var CHAR_SINGLE_QUOTE = 39;
var CHAR_ASTERISK = 42;
var CHAR_COMMA = 44;
var CHAR_MINUS = 45;
var CHAR_COLON = 58;
var CHAR_EQUALS = 61;
var CHAR_GREATER_THAN = 62;
var CHAR_QUESTION = 63;
var CHAR_COMMERCIAL_AT = 64;
var CHAR_LEFT_SQUARE_BRACKET = 91;
var CHAR_RIGHT_SQUARE_BRACKET = 93;
var CHAR_GRAVE_ACCENT = 96;
var CHAR_LEFT_CURLY_BRACKET = 123;
var CHAR_VERTICAL_LINE = 124;
var CHAR_RIGHT_CURLY_BRACKET = 125;
var ESCAPE_SEQUENCES = {};
ESCAPE_SEQUENCES[0] = "\\0";
ESCAPE_SEQUENCES[7] = "\\a";
ESCAPE_SEQUENCES[8] = "\\b";
ESCAPE_SEQUENCES[9] = "\\t";
ESCAPE_SEQUENCES[10] = "\\n";
ESCAPE_SEQUENCES[11] = "\\v";
ESCAPE_SEQUENCES[12] = "\\f";
ESCAPE_SEQUENCES[13] = "\\r";
ESCAPE_SEQUENCES[27] = "\\e";
ESCAPE_SEQUENCES[34] = '\\"';
ESCAPE_SEQUENCES[92] = "\\\\";
ESCAPE_SEQUENCES[133] = "\\N";
ESCAPE_SEQUENCES[160] = "\\_";
ESCAPE_SEQUENCES[8232] = "\\L";
ESCAPE_SEQUENCES[8233] = "\\P";
var DEPRECATED_BOOLEANS_SYNTAX = [
  "y",
  "Y",
  "yes",
  "Yes",
  "YES",
  "on",
  "On",
  "ON",
  "n",
  "N",
  "no",
  "No",
  "NO",
  "off",
  "Off",
  "OFF"
];
var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
function compileStyleMap(schema2, map2) {
  var result2, keys, index, length, tag, style, type2;
  if (map2 === null)
    return {};
  result2 = {};
  keys = Object.keys(map2);
  for (index = 0, length = keys.length; index < length; index += 1) {
    tag = keys[index];
    style = String(map2[tag]);
    if (tag.slice(0, 2) === "!!") {
      tag = "tag:yaml.org,2002:" + tag.slice(2);
    }
    type2 = schema2.compiledTypeMap["fallback"][tag];
    if (type2 && _hasOwnProperty.call(type2.styleAliases, style)) {
      style = type2.styleAliases[style];
    }
    result2[tag] = style;
  }
  return result2;
}
function encodeHex(character) {
  var string2, handle, length;
  string2 = character.toString(16).toUpperCase();
  if (character <= 255) {
    handle = "x";
    length = 2;
  } else if (character <= 65535) {
    handle = "u";
    length = 4;
  } else if (character <= 4294967295) {
    handle = "U";
    length = 8;
  } else {
    throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
  }
  return "\\" + handle + common.repeat("0", length - string2.length) + string2;
}
var QUOTING_TYPE_SINGLE = 1;
var QUOTING_TYPE_DOUBLE = 2;
function State(options) {
  this.schema = options["schema"] || _default;
  this.indent = Math.max(1, options["indent"] || 2);
  this.noArrayIndent = options["noArrayIndent"] || false;
  this.skipInvalid = options["skipInvalid"] || false;
  this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
  this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
  this.sortKeys = options["sortKeys"] || false;
  this.lineWidth = options["lineWidth"] || 80;
  this.noRefs = options["noRefs"] || false;
  this.noCompatMode = options["noCompatMode"] || false;
  this.condenseFlow = options["condenseFlow"] || false;
  this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes = options["forceQuotes"] || false;
  this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;
  this.tag = null;
  this.result = "";
  this.duplicates = [];
  this.usedDuplicates = null;
}
function indentString(string2, spaces) {
  var ind = common.repeat(" ", spaces), position = 0, next = -1, result2 = "", line, length = string2.length;
  while (position < length) {
    next = string2.indexOf("\n", position);
    if (next === -1) {
      line = string2.slice(position);
      position = length;
    } else {
      line = string2.slice(position, next + 1);
      position = next + 1;
    }
    if (line.length && line !== "\n")
      result2 += ind;
    result2 += line;
  }
  return result2;
}
function generateNextLine(state, level) {
  return "\n" + common.repeat(" ", state.indent * level);
}
function testImplicitResolving(state, str2) {
  var index, length, type2;
  for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
    type2 = state.implicitTypes[index];
    if (type2.resolve(str2)) {
      return true;
    }
  }
  return false;
}
function isWhitespace(c) {
  return c === CHAR_SPACE || c === CHAR_TAB;
}
function isPrintable(c) {
  return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM || 65536 <= c && c <= 1114111;
}
function isNsCharOrWhitespace(c) {
  return isPrintable(c) && c !== CHAR_BOM && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
}
function isPlainSafe(c, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
  return (inblock ? cIsNsCharOrWhitespace : cIsNsCharOrWhitespace && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET) && c !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar;
}
function isPlainSafeFirst(c) {
  return isPrintable(c) && c !== CHAR_BOM && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
}
function isPlainSafeLast(c) {
  return !isWhitespace(c) && c !== CHAR_COLON;
}
function codePointAt(string2, pos) {
  var first = string2.charCodeAt(pos), second;
  if (first >= 55296 && first <= 56319 && pos + 1 < string2.length) {
    second = string2.charCodeAt(pos + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function needIndentIndicator(string2) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string2);
}
var STYLE_PLAIN = 1;
var STYLE_SINGLE = 2;
var STYLE_LITERAL = 3;
var STYLE_FOLDED = 4;
var STYLE_DOUBLE = 5;
function chooseScalarStyle(string2, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
  var i;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false;
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1;
  var plain = isPlainSafeFirst(codePointAt(string2, 0)) && isPlainSafeLast(codePointAt(string2, string2.length - 1));
  if (singleLineOnly || forceQuotes) {
    for (i = 0; i < string2.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string2, i);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    for (i = 0; i < string2.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string2, i);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine || i - previousLineBreak - 1 > lineWidth && string2[previousLineBreak + 1] !== " ";
          previousLineBreak = i;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i - previousLineBreak - 1 > lineWidth && string2[previousLineBreak + 1] !== " ");
  }
  if (!hasLineBreak && !hasFoldableLine) {
    if (plain && !forceQuotes && !testAmbiguousType(string2)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  if (indentPerLevel > 9 && needIndentIndicator(string2)) {
    return STYLE_DOUBLE;
  }
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}
function writeScalar(state, string2, level, iskey, inblock) {
  state.dump = function() {
    if (string2.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string2) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string2)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string2 + '"' : "'" + string2 + "'";
      }
    }
    var indent = state.indent * Math.max(1, level);
    var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
    var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
    function testAmbiguity(string3) {
      return testImplicitResolving(state, string3);
    }
    switch (chooseScalarStyle(string2, singleLineOnly, state.indent, lineWidth, testAmbiguity, state.quotingType, state.forceQuotes && !iskey, inblock)) {
      case STYLE_PLAIN:
        return string2;
      case STYLE_SINGLE:
        return "'" + string2.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return "|" + blockHeader(string2, state.indent) + dropEndingNewline(indentString(string2, indent));
      case STYLE_FOLDED:
        return ">" + blockHeader(string2, state.indent) + dropEndingNewline(indentString(foldString(string2, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string2) + '"';
      default:
        throw new exception("impossible error: invalid scalar style");
    }
  }();
}
function blockHeader(string2, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string2) ? String(indentPerLevel) : "";
  var clip = string2[string2.length - 1] === "\n";
  var keep = clip && (string2[string2.length - 2] === "\n" || string2 === "\n");
  var chomp = keep ? "+" : clip ? "" : "-";
  return indentIndicator + chomp + "\n";
}
function dropEndingNewline(string2) {
  return string2[string2.length - 1] === "\n" ? string2.slice(0, -1) : string2;
}
function foldString(string2, width) {
  var lineRe = /(\n+)([^\n]*)/g;
  var result2 = function() {
    var nextLF = string2.indexOf("\n");
    nextLF = nextLF !== -1 ? nextLF : string2.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string2.slice(0, nextLF), width);
  }();
  var prevMoreIndented = string2[0] === "\n" || string2[0] === " ";
  var moreIndented;
  var match;
  while (match = lineRe.exec(string2)) {
    var prefix = match[1], line = match[2];
    moreIndented = line[0] === " ";
    result2 += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }
  return result2;
}
function foldLine(line, width) {
  if (line === "" || line[0] === " ")
    return line;
  var breakRe = / [^ ]/g;
  var match;
  var start = 0, end, curr = 0, next = 0;
  var result2 = "";
  while (match = breakRe.exec(line)) {
    next = match.index;
    if (next - start > width) {
      end = curr > start ? curr : next;
      result2 += "\n" + line.slice(start, end);
      start = end + 1;
    }
    curr = next;
  }
  result2 += "\n";
  if (line.length - start > width && curr > start) {
    result2 += line.slice(start, curr) + "\n" + line.slice(curr + 1);
  } else {
    result2 += line.slice(start);
  }
  return result2.slice(1);
}
function escapeString(string2) {
  var result2 = "";
  var char = 0;
  var escapeSeq;
  for (var i = 0; i < string2.length; char >= 65536 ? i += 2 : i++) {
    char = codePointAt(string2, i);
    escapeSeq = ESCAPE_SEQUENCES[char];
    if (!escapeSeq && isPrintable(char)) {
      result2 += string2[i];
      if (char >= 65536)
        result2 += string2[i + 1];
    } else {
      result2 += escapeSeq || encodeHex(char);
    }
  }
  return result2;
}
function writeFlowSequence(state, level, object2) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object2.length; index < length; index += 1) {
    value = object2[index];
    if (state.replacer) {
      value = state.replacer.call(object2, String(index), value);
    }
    if (writeNode(state, level, value, false, false) || typeof value === "undefined" && writeNode(state, level, null, false, false)) {
      if (_result !== "")
        _result += "," + (!state.condenseFlow ? " " : "");
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = "[" + _result + "]";
}
function writeBlockSequence(state, level, object2, compact) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object2.length; index < length; index += 1) {
    value = object2[index];
    if (state.replacer) {
      value = state.replacer.call(object2, String(index), value);
    }
    if (writeNode(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode(state, level + 1, null, true, true, false, true)) {
      if (!compact || _result !== "") {
        _result += generateNextLine(state, level);
      }
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += "-";
      } else {
        _result += "- ";
      }
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = _result || "[]";
}
function writeFlowMapping(state, level, object2) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object2), index, length, objectKey, objectValue, pairBuffer;
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (_result !== "")
      pairBuffer += ", ";
    if (state.condenseFlow)
      pairBuffer += '"';
    objectKey = objectKeyList[index];
    objectValue = object2[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object2, objectKey, objectValue);
    }
    if (!writeNode(state, level, objectKey, false, false)) {
      continue;
    }
    if (state.dump.length > 1024)
      pairBuffer += "? ";
    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
    if (!writeNode(state, level, objectValue, false, false)) {
      continue;
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = "{" + _result + "}";
}
function writeBlockMapping(state, level, object2, compact) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object2), index, length, objectKey, objectValue, explicitPair, pairBuffer;
  if (state.sortKeys === true) {
    objectKeyList.sort();
  } else if (typeof state.sortKeys === "function") {
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    throw new exception("sortKeys must be a boolean or a function");
  }
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (!compact || _result !== "") {
      pairBuffer += generateNextLine(state, level);
    }
    objectKey = objectKeyList[index];
    objectValue = object2[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object2, objectKey, objectValue);
    }
    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue;
    }
    explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += "?";
      } else {
        pairBuffer += "? ";
      }
    }
    pairBuffer += state.dump;
    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }
    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue;
    }
    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ":";
    } else {
      pairBuffer += ": ";
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = _result || "{}";
}
function detectType(state, object2, explicit) {
  var _result, typeList, index, length, type2, style;
  typeList = explicit ? state.explicitTypes : state.implicitTypes;
  for (index = 0, length = typeList.length; index < length; index += 1) {
    type2 = typeList[index];
    if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object2 === "object" && object2 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object2))) {
      if (explicit) {
        if (type2.multi && type2.representName) {
          state.tag = type2.representName(object2);
        } else {
          state.tag = type2.tag;
        }
      } else {
        state.tag = "?";
      }
      if (type2.represent) {
        style = state.styleMap[type2.tag] || type2.defaultStyle;
        if (_toString.call(type2.represent) === "[object Function]") {
          _result = type2.represent(object2, style);
        } else if (_hasOwnProperty.call(type2.represent, style)) {
          _result = type2.represent[style](object2, style);
        } else {
          throw new exception("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
        }
        state.dump = _result;
      }
      return true;
    }
  }
  return false;
}
function writeNode(state, level, object2, block, compact, iskey, isblockseq) {
  state.tag = null;
  state.dump = object2;
  if (!detectType(state, object2, false)) {
    detectType(state, object2, true);
  }
  var type2 = _toString.call(state.dump);
  var inblock = block;
  var tagStr;
  if (block) {
    block = state.flowLevel < 0 || state.flowLevel > level;
  }
  var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object2);
    duplicate = duplicateIndex !== -1;
  }
  if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
    compact = false;
  }
  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = "*ref_" + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type2 === "[object Object]") {
      if (block && Object.keys(state.dump).length !== 0) {
        writeBlockMapping(state, level, state.dump, compact);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object Array]") {
      if (block && state.dump.length !== 0) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact);
        } else {
          writeBlockSequence(state, level, state.dump, compact);
        }
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object String]") {
      if (state.tag !== "?") {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type2 === "[object Undefined]") {
      return false;
    } else {
      if (state.skipInvalid)
        return false;
      throw new exception("unacceptable kind of an object to dump " + type2);
    }
    if (state.tag !== null && state.tag !== "?") {
      tagStr = encodeURI(state.tag[0] === "!" ? state.tag.slice(1) : state.tag).replace(/!/g, "%21");
      if (state.tag[0] === "!") {
        tagStr = "!" + tagStr;
      } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
        tagStr = "!!" + tagStr.slice(18);
      } else {
        tagStr = "!<" + tagStr + ">";
      }
      state.dump = tagStr + " " + state.dump;
    }
  }
  return true;
}
function getDuplicateReferences(object2, state) {
  var objects = [], duplicatesIndexes = [], index, length;
  inspectNode(object2, objects, duplicatesIndexes);
  for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}
function inspectNode(object2, objects, duplicatesIndexes) {
  var objectKeyList, index, length;
  if (object2 !== null && typeof object2 === "object") {
    index = objects.indexOf(object2);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object2);
      if (Array.isArray(object2)) {
        for (index = 0, length = object2.length; index < length; index += 1) {
          inspectNode(object2[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object2);
        for (index = 0, length = objectKeyList.length; index < length; index += 1) {
          inspectNode(object2[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}
function dump$1(input, options) {
  options = options || {};
  var state = new State(options);
  if (!state.noRefs)
    getDuplicateReferences(input, state);
  var value = input;
  if (state.replacer) {
    value = state.replacer.call({ "": value }, "", value);
  }
  if (writeNode(state, 0, value, true, true))
    return state.dump + "\n";
  return "";
}
var dump_1 = dump$1;
var dumper = {
  dump: dump_1
};
function renamed(from, to) {
  return function() {
    throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
  };
}
var Type = type;
var Schema = schema;
var FAILSAFE_SCHEMA = failsafe;
var JSON_SCHEMA = json;
var CORE_SCHEMA = core;
var DEFAULT_SCHEMA = _default;
var load = loader.load;
var loadAll = loader.loadAll;
var dump = dumper.dump;
var YAMLException = exception;
var types = {
  binary,
  float,
  map,
  null: _null,
  pairs,
  set,
  timestamp,
  bool,
  int,
  merge,
  omap,
  seq,
  str
};
var safeLoad = renamed("safeLoad", "load");
var safeLoadAll = renamed("safeLoadAll", "loadAll");
var safeDump = renamed("safeDump", "dump");
var jsYaml = {
  Type,
  Schema,
  FAILSAFE_SCHEMA,
  JSON_SCHEMA,
  CORE_SCHEMA,
  DEFAULT_SCHEMA,
  load,
  loadAll,
  dump,
  YAMLException,
  types,
  safeLoad,
  safeLoadAll,
  safeDump
};
var js_yaml_default = jsYaml;

// src/migrationPreparator.ts
var import_fs2 = __toESM(require("fs"));

// src/serializer/index.ts
var import_string_decoder = require("string_decoder");

// src/serializer/factory.ts
var import_typescript = __toESM(require_typescript());
var import_fs = __toESM(require("fs"));
var printer = import_typescript.default.createPrinter();
var prepareFabricFile = (folder, fileName2) => {
  const staticImports = [
    import_typescript.default.factory.createImportDeclaration(void 0, void 0, import_typescript.default.factory.createImportClause(false, void 0, import_typescript.default.factory.createNamespaceImport(import_typescript.default.createIdentifier("drizzle"))), import_typescript.default.factory.createStringLiteral("drizzle-orm")),
    import_typescript.default.factory.createImportDeclaration(void 0, void 0, import_typescript.default.factory.createImportClause(false, import_typescript.default.factory.createIdentifier("Session"), void 0), import_typescript.default.factory.createStringLiteral("drizzle-orm/db/session")),
    import_typescript.default.factory.createImportDeclaration(void 0, void 0, import_typescript.default.factory.createImportClause(false, import_typescript.default.factory.createIdentifier("Enum"), void 0), import_typescript.default.factory.createStringLiteral("drizzle-orm/types/type")),
    import_typescript.default.factory.createImportDeclaration(void 0, void 0, import_typescript.default.factory.createImportClause(false, void 0, import_typescript.default.factory.createNamespaceImport(import_typescript.default.createIdentifier("pg"))), import_typescript.default.factory.createStringLiteral("pg"))
  ];
  const dynamicImports = [];
  const filenames = fileName2 ? [fileName2] : import_fs.default.readdirSync(folder);
  for (let i = 0; i < filenames.length; i++) {
    const filename = filenames[i];
    const importPath = `${folder}/${filename.split(".")[0]}`;
    dynamicImports.push(import_typescript.default.factory.createImportDeclaration(void 0, void 0, import_typescript.default.factory.createImportClause(false, void 0, import_typescript.default.factory.createNamespaceImport(import_typescript.default.factory.createIdentifier(`i${i}`))), import_typescript.default.factory.createStringLiteral(importPath)));
  }
  const variablesStatements = [
    import_typescript.default.factory.createVariableStatement(void 0, import_typescript.default.factory.createVariableDeclarationList([
      import_typescript.default.factory.createVariableDeclaration(import_typescript.default.factory.createIdentifier("db"), void 0, void 0, import_typescript.default.factory.createNewExpression(import_typescript.default.factory.createIdentifier("drizzle.DB"), void 0, [
        import_typescript.default.factory.createNewExpression(import_typescript.default.factory.createIdentifier("Session"), void 0, [
          import_typescript.default.factory.createNewExpression(import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier("pg"), import_typescript.default.factory.createIdentifier("Pool")), void 0, [])
        ])
      ]))
    ], import_typescript.default.NodeFlags.Const))
  ];
  const blockStatements = [];
  import_typescript.default.factory.createArrayTypeNode(import_typescript.default.factory.createTypeReferenceNode(import_typescript.default.factory.createQualifiedName(import_typescript.default.factory.createIdentifier("drizzle"), import_typescript.default.factory.createIdentifier("AbstractTable")), [import_typescript.default.factory.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)]));
  blockStatements.push(import_typescript.default.factory.createVariableStatement(void 0, import_typescript.default.factory.createVariableDeclarationList([
    import_typescript.default.factory.createVariableDeclaration(import_typescript.default.factory.createIdentifier("tables"), void 0, import_typescript.default.factory.createArrayTypeNode(import_typescript.default.factory.createTypeReferenceNode(import_typescript.default.factory.createQualifiedName(import_typescript.default.factory.createIdentifier("drizzle"), import_typescript.default.factory.createIdentifier("AbstractTable")), [import_typescript.default.factory.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)])), import_typescript.default.factory.createArrayLiteralExpression([], false))
  ], import_typescript.default.NodeFlags.Const)));
  blockStatements.push(import_typescript.default.factory.createVariableStatement(void 0, import_typescript.default.factory.createVariableDeclarationList([
    import_typescript.default.factory.createVariableDeclaration(import_typescript.default.factory.createIdentifier("enums"), void 0, import_typescript.default.factory.createArrayTypeNode(import_typescript.default.factory.createTypeReferenceNode(import_typescript.default.factory.createIdentifier("Enum"), [import_typescript.default.factory.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)])), import_typescript.default.factory.createArrayLiteralExpression([], false))
  ], import_typescript.default.NodeFlags.Const)));
  for (let i = 0; i < filenames.length; i++) {
    const valuesDeclaration = import_typescript.default.factory.createVariableStatement(void 0, import_typescript.default.factory.createVariableDeclarationList([
      import_typescript.default.factory.createVariableDeclaration(import_typescript.default.factory.createIdentifier(`i${i}values`), void 0, void 0, import_typescript.default.factory.createCallExpression(import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier("Object"), import_typescript.default.factory.createIdentifier("values")), void 0, [import_typescript.default.factory.createIdentifier("i" + i)]))
    ], import_typescript.default.NodeFlags.Const));
    blockStatements.push(valuesDeclaration);
    const iterationWithTypeChecks = import_typescript.default.factory.createExpressionStatement(import_typescript.default.factory.createCallExpression(import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier(`i${i}values`), import_typescript.default.factory.createIdentifier("forEach")), void 0, [
      import_typescript.default.factory.createArrowFunction(void 0, void 0, [
        import_typescript.default.factory.createParameterDeclaration(void 0, void 0, void 0, import_typescript.default.factory.createIdentifier("t"), void 0, void 0, void 0)
      ], void 0, import_typescript.default.factory.createToken(import_typescript.default.SyntaxKind.EqualsGreaterThanToken), import_typescript.default.factory.createBlock([
        import_typescript.default.factory.createIfStatement(import_typescript.default.factory.createBinaryExpression(import_typescript.default.factory.createIdentifier("t"), import_typescript.default.SyntaxKind.InstanceOfKeyword, import_typescript.default.factory.createIdentifier("Enum")), import_typescript.default.factory.createBlock([
          import_typescript.default.factory.createExpressionStatement(import_typescript.default.factory.createCallExpression(import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier("enums"), import_typescript.default.factory.createIdentifier("push")), void 0, [import_typescript.default.factory.createIdentifier("t")])),
          import_typescript.default.factory.createReturnStatement(void 0)
        ], true), void 0),
        import_typescript.default.factory.createIfStatement(import_typescript.default.factory.createBinaryExpression(import_typescript.default.factory.createBinaryExpression(import_typescript.default.factory.createBinaryExpression(import_typescript.default.factory.createTypeOfExpression(import_typescript.default.factory.createIdentifier("t")), import_typescript.default.factory.createToken(import_typescript.default.SyntaxKind.EqualsEqualsEqualsToken), import_typescript.default.factory.createStringLiteral("function")), import_typescript.default.factory.createToken(import_typescript.default.SyntaxKind.AmpersandAmpersandToken), import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier("t"), import_typescript.default.factory.createIdentifier("prototype"))), import_typescript.default.factory.createToken(import_typescript.default.SyntaxKind.AmpersandAmpersandToken), import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier("t"), import_typescript.default.factory.createIdentifier("prototype")), import_typescript.default.factory.createIdentifier("constructor"))), import_typescript.default.factory.createBlock([
          import_typescript.default.factory.createVariableStatement(void 0, import_typescript.default.factory.createVariableDeclarationList([
            import_typescript.default.factory.createVariableDeclaration(import_typescript.default.factory.createIdentifier("instance"), void 0, void 0, import_typescript.default.factory.createNewExpression(import_typescript.default.factory.createIdentifier("t"), void 0, [import_typescript.default.factory.createIdentifier("db")]))
          ], import_typescript.default.NodeFlags.Const)),
          import_typescript.default.factory.createIfStatement(import_typescript.default.factory.createBinaryExpression(import_typescript.default.factory.createIdentifier("instance"), import_typescript.default.SyntaxKind.InstanceOfKeyword, import_typescript.default.factory.createIdentifier("drizzle.AbstractTable")), import_typescript.default.factory.createBlock([
            import_typescript.default.factory.createExpressionStatement(import_typescript.default.factory.createCallExpression(import_typescript.default.factory.createPropertyAccessExpression(import_typescript.default.factory.createIdentifier("tables"), import_typescript.default.factory.createIdentifier("push")), void 0, [
              import_typescript.default.factory.createAsExpression(import_typescript.default.factory.createAsExpression(import_typescript.default.factory.createIdentifier("instance"), import_typescript.default.factory.createKeywordTypeNode(import_typescript.default.SyntaxKind.UnknownKeyword)), import_typescript.default.factory.createTypeReferenceNode(import_typescript.default.factory.createQualifiedName(import_typescript.default.factory.createIdentifier("drizzle"), import_typescript.default.factory.createIdentifier("AbstractTable")), [
                import_typescript.default.factory.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)
              ]))
            ]))
          ], true), void 0)
        ], true), void 0)
      ], true))
    ]));
    blockStatements.push(iterationWithTypeChecks);
  }
  blockStatements.push(import_typescript.default.factory.createReturnStatement(import_typescript.default.factory.createObjectLiteralExpression([
    import_typescript.default.factory.createShorthandPropertyAssignment(import_typescript.default.factory.createIdentifier("tables"), void 0),
    import_typescript.default.factory.createShorthandPropertyAssignment(import_typescript.default.factory.createIdentifier("enums"), void 0)
  ], false)));
  const funcStatement = [
    import_typescript.default.factory.createVariableStatement(void 0, import_typescript.default.factory.createVariableDeclarationList([
      import_typescript.default.factory.createVariableDeclaration(import_typescript.default.factory.createIdentifier("testFun"), void 0, void 0, import_typescript.default.factory.createArrowFunction(void 0, void 0, [], void 0, import_typescript.default.factory.createToken(import_typescript.default.SyntaxKind.EqualsGreaterThanToken), import_typescript.default.factory.createBlock(blockStatements, true)))
    ], import_typescript.default.NodeFlags.Const))
  ];
  const invocationStatement = [
    import_typescript.default.factory.createExpressionStatement(import_typescript.default.factory.createCallExpression(import_typescript.default.factory.createIdentifier("testFun"), void 0, []))
  ];
  const outFile = import_typescript.default.createSourceFile("outfile.ts", "", import_typescript.default.ScriptTarget.ES2015, true, import_typescript.default.ScriptKind.TS);
  const source = [];
  source.push(...staticImports);
  source.push(...dynamicImports);
  source.push(...variablesStatements);
  source.push(...funcStatement);
  source.push(...invocationStatement);
  const newFile = import_typescript.default.factory.updateSourceFile(outFile, source);
  return printer.printFile(newFile);
};
var factory_default = prepareFabricFile;

// src/serializer/index.ts
var import_esbuild = __toESM(require("esbuild"));

// src/serializer/serializer.ts
var serialiseForeignKey = (fkName, table, column, onDelete, onUpdate) => `${fkName};${table};${column};${onDelete != null ? onDelete : ""};${onUpdate != null ? onUpdate : ""}`;
var SnapshotSerializer = class {
  constructor() {
    this.generate = (tables, enums) => {
      const result2 = {};
      for (const table of tables) {
        const columnToReturn = {};
        const indexToReturn = {};
        table.getColumns().forEach((value) => {
          columnToReturn[value.getColumnName()] = {
            name: value.getColumnName(),
            type: value.getColumnType().getDbName(),
            primaryKey: !!value.primaryKeyName,
            notNull: !value.isNullableFlag
          };
          if (value.getDefaultValue() !== void 0 && value.getDefaultValue() !== null) {
            columnToReturn[value.getColumnName()].default = value.getDefaultValue().toJSON();
          }
          if (value.uniqueKeyName) {
            const indexName = `${value.getParent().tableName()}_${value.getColumnName()}_index`;
            const indexColumnToReturn = {};
            indexColumnToReturn[value.getColumnName()] = {
              name: value.getColumnName()
            };
            indexToReturn[indexName] = {
              name: indexName,
              columns: indexColumnToReturn,
              isUnique: true
            };
          }
          const referenced = value.getReferenced();
          if (referenced) {
            const fkName = `${value.getParent().tableName()}_${value.getColumnName()}_fkey`;
            const tableParentName = referenced.getParentName();
            const column = referenced.getColumnName();
            const onDelete = value.getOnDelete();
            const onUpdate = value.getOnUpdate();
            const referenceString = serialiseForeignKey(fkName, tableParentName, column, onDelete, onUpdate);
            columnToReturn[value.getColumnName()].references = referenceString;
          }
        });
        table.getIndexes().forEach((value) => {
          const columns = value.getColumns();
          const name = value.indexName();
          const indexColumnToReturn = {};
          for (const column of columns) {
            const columnName = column.getColumnName();
            indexColumnToReturn[columnName] = {
              name: columnName
            };
          }
          indexToReturn[name] = {
            name,
            columns: indexColumnToReturn,
            isUnique: value.isUnique()
          };
        });
        result2[table.tableName()] = {
          name: table.tableName(),
          columns: columnToReturn,
          indexes: indexToReturn
        };
      }
      const enumsToReturn = enums.reduce((map2, obj) => {
        const key = obj.name;
        const newValues = obj.values.reduce((mapped, value) => {
          mapped[value] = value;
          return mapped;
        }, {});
        map2[key] = { name: obj.name, values: newValues };
        return map2;
      }, {});
      return { version: "2", tables: result2, enums: enumsToReturn };
    };
    this.fromDatabase = async (db) => {
      var _a;
      const result2 = {};
      const allTables = await db.session().execute("SELECT table_schema, table_name FROM information_schema.tables WHERE table_schema != 'pg_catalog' and table_schema != 'information_schema';");
      for await (const row of allTables.rows) {
        try {
          const tableName = row.table_name;
          const columnToReturn = {};
          const indexToReturn = {};
          const tableResponse = await db.session().execute(`SELECT a.attrelid::regclass::text, a.attname
        , CASE WHEN a.atttypid = ANY ('{int,int8,int2}'::regtype[])
             AND EXISTS (
                SELECT FROM pg_attrdef ad
                WHERE  ad.adrelid = a.attrelid
                AND    ad.adnum   = a.attnum
                AND    pg_get_expr(ad.adbin, ad.adrelid)
                     = 'nextval('''
                    || (pg_get_serial_sequence (a.attrelid::regclass::text
                                             , a.attname))::regclass
                    || '''::regclass)'
                )
           THEN CASE a.atttypid
                   WHEN 'int'::regtype  THEN 'serial'
                   WHEN 'int8'::regtype THEN 'bigserial'
                   WHEN 'int2'::regtype THEN 'smallserial'
                END
           ELSE format_type(a.atttypid, a.atttypmod)
           END AS data_type, INFORMATION_SCHEMA.COLUMNS.table_name, INFORMATION_SCHEMA.COLUMNS.column_name, INFORMATION_SCHEMA.COLUMNS.column_default
   FROM  pg_attribute  a
   JOIN INFORMATION_SCHEMA.COLUMNS ON INFORMATION_SCHEMA.COLUMNS.column_name = a.attname
   WHERE  a.attrelid = '${tableName}'::regclass and INFORMATION_SCHEMA.COLUMNS.table_name = '${tableName}'
   AND    a.attnum > 0
   AND    NOT a.attisdropped
   ORDER  BY a.attnum;`);
          const tableConstraints = await db.session().execute(`SELECT c.column_name, c.data_type, constraint_type, constraint_name
      FROM information_schema.table_constraints tc 
      JOIN information_schema.constraint_column_usage AS ccu USING (constraint_schema, constraint_name) 
      JOIN information_schema.columns AS c ON c.table_schema = tc.constraint_schema
        AND tc.table_name = c.table_name AND ccu.column_name = c.column_name
      WHERE tc.table_name = '${tableName}';`);
          const tableForeignKeys = await db.session().execute(`SELECT
        tc.table_schema, 
        tc.constraint_name, 
        tc.table_name, 
        kcu.column_name,
        ccu.table_schema AS foreign_table_schema,
        ccu.table_name AS foreign_table_name,
        ccu.column_name AS foreign_column_name,
        rc.delete_rule, rc.update_rule
    FROM 
        information_schema.table_constraints AS tc
        JOIN information_schema.key_column_usage AS kcu
          ON tc.constraint_name = kcu.constraint_name
          AND tc.table_schema = kcu.table_schema
        JOIN information_schema.constraint_column_usage AS ccu
          ON ccu.constraint_name = tc.constraint_name
          AND ccu.table_schema = tc.table_schema
        JOIN information_schema.referential_constraints AS rc
          ON ccu.constraint_name = rc.constraint_name 
    WHERE tc.constraint_type = 'FOREIGN KEY' AND tc.table_name='${tableName}';`);
          const mappedRefernces = {};
          for (const fk of tableForeignKeys.rows) {
            const columnFrom = fk.column_name;
            const tableTo = fk.foreign_table_name;
            const columnTo = fk.foreign_column_name;
            const foreignKeyName = fk.constraint_name;
            const onUpdate = fk.update_rule;
            const onDelete = fk.delete_rule;
            const references = serialiseForeignKey(foreignKeyName, tableTo, columnTo, onDelete, onUpdate);
            mappedRefernces[columnFrom] = references;
          }
          for (const columnResponse of tableResponse.rows) {
            const columnName = columnResponse.attname;
            const columnType = columnResponse.data_type;
            const primaryKey = tableConstraints.rows.filter((mapRow) => columnName === mapRow.column_name && mapRow.constraint_type === "PRIMARY KEY");
            const uniqueKey = tableConstraints.rows.filter((mapRow) => columnName === mapRow.column_name && mapRow.constraint_type === "UNIQUE");
            const defaultValue = columnResponse.column_default === null ? void 0 : columnResponse.column_default;
            const isSerial = columnType === "serial";
            columnToReturn[columnName] = {
              name: columnName,
              type: columnType,
              primaryKey: !!primaryKey[0],
              unique: !!uniqueKey[0],
              default: isSerial ? void 0 : defaultValue,
              notNull: !columnResponse.is_nullable,
              references: (_a = mappedRefernces[columnName]) != null ? _a : void 0
            };
          }
          const dbIndexes = await db.session().execute(`select
        t.relname as table_name,
        i.relname as index_name,
        a.attname as column_name
    from
        pg_class t,
        pg_class i,
        pg_index ix,
        pg_attribute a
    where
        t.oid = ix.indrelid
        and i.oid = ix.indexrelid
        and a.attrelid = t.oid
        and a.attnum = ANY(ix.indkey)
        and t.relkind = 'r'
        and t.relname = '${tableName}'
    order by
        t.relname,
        i.relname;`);
          for (const dbIndex of dbIndexes.rows) {
            const indexName = dbIndex.index_name;
            const indexColumnName = dbIndex.column_name;
            if (indexToReturn[indexName] !== void 0 && indexToReturn[indexName] !== null) {
              indexToReturn[indexName].columns[indexColumnName] = {
                name: indexColumnName
              };
            } else {
              indexToReturn[indexName] = {
                name: indexName,
                columns: {
                  [indexColumnName]: {
                    name: indexColumnName
                  }
                }
              };
            }
          }
          result2[tableName] = {
            name: tableName,
            columns: columnToReturn,
            indexes: indexToReturn
          };
        } catch (e) {
          console.log(e);
        }
      }
      const allEnums = await db.session().execute(`select n.nspname as enum_schema,  
    t.typname as enum_name,  
    e.enumlabel as enum_value
    from pg_type t 
    join pg_enum e on t.oid = e.enumtypid  
    join pg_catalog.pg_namespace n ON n.oid = t.typnamespace;`);
      const enumsToReturn = {};
      for (const dbEnum of allEnums.rows) {
        const enumName = dbEnum.enum_name;
        const enumValue = dbEnum.enum_value;
        if (enumsToReturn[enumName] !== void 0 && enumsToReturn[enumName] !== null) {
          enumsToReturn[enumName].values.push(enumValue);
        } else {
          enumsToReturn[enumName] = {
            name: enumName,
            values: [enumValue]
          };
        }
      }
      return { version: "2", tables: result2, enums: enumsToReturn };
    };
  }
};

// src/serializer/index.ts
var serialize = (path, fileName) => {
  const decoder = new import_string_decoder.StringDecoder();
  const preparedFarbic = factory_default(path, fileName);
  const result = import_esbuild.default.buildSync({
    stdin: {
      contents: preparedFarbic,
      loader: "ts",
      resolveDir: "./"
    },
    bundle: true,
    platform: "node",
    write: false,
    external: ["pg-native"]
  });
  const evaluated = eval(decoder.write(Buffer.from(result.outputFiles[0].text)));
  const migration = new SnapshotSerializer().generate(evaluated.tables, evaluated.enums);
  return migration;
};
var serializer_default = serialize;

// src/sqlgenerator.ts
var Convertor = class {
};
var CreateTableConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_table";
  }
  convert(st) {
    const { tableName, columns } = st;
    let statement = "";
    statement += `CREATE TABLE IF NOT EXISTS ${tableName} (
`;
    for (let i = 0; i < columns.length; i++) {
      const column = columns[i];
      const primaryKeyStatement = column.primaryKey ? "PRIMARY KEY" : "";
      const notNullStatement = column.notNull ? "NOT NULL" : "";
      const defaultStatement = column.defaultValue !== void 0 ? `DEFAULT ${column.defaultValue}` : "";
      statement += "	" + `"${column.name}" ${column.type} ${primaryKeyStatement} ${defaultStatement} ${notNullStatement}`.replace(/  +/g, " ").trim();
      statement += (i === columns.length - 1 ? "" : ",") + "\n";
    }
    statement += `);`;
    statement += `
`;
    return statement;
  }
};
var CreateTypeEnumConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_type_enum";
  }
  convert(st) {
    const { name, values } = st;
    let valuesStatement = "(";
    valuesStatement += values.map((it) => `'${it}'`).join(", ");
    valuesStatement += ")";
    let statement = "DO $$ BEGIN";
    statement += "\n";
    statement += ` CREATE TYPE ${name} AS ENUM${valuesStatement};`;
    statement += "\n";
    statement += "EXCEPTION";
    statement += "\n";
    statement += " WHEN duplicate_object THEN null;";
    statement += "\n";
    statement += "END $$;";
    statement += "\n";
    return statement;
  }
};
var AlterTypeAddValueConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_type_add_value";
  }
  convert(st) {
    const { name, value } = st;
    return `ALTER TYPE ${name} ADD VALUE '${value}';`;
  }
};
var DropTableConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "drop_table";
  }
  convert(statement) {
    const { tableName } = statement;
    return `DROP TABLE ${tableName};`;
  }
};
var RenameTableConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "rename_table";
  }
  convert(statement) {
    const { tableNameFrom, tableNameTo } = statement;
    return `ALTER TABLE ${tableNameFrom} RENAME TO ${tableNameTo};`;
  }
};
var AlterTableRenameColumnConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_rename_column";
  }
  convert(statement) {
    const { tableName, oldColumnName, newColumnName } = statement;
    return `ALTER TABLE ${tableName} RENAME COLUMN "${oldColumnName}" TO "${newColumnName}";`;
  }
};
var AlterTableDropColumnConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_drop_column";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} DROP COLUMN IF EXISTS "${columnName}";`;
  }
};
var AlterTableAddColumnConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_add_column";
  }
  convert(statement) {
    const { tableName, column } = statement;
    const { name, type: type2, notNull } = column;
    const defaultValue = column.defaultValue;
    const defaultStatement = `${defaultValue !== void 0 ? `DEFAULT ${defaultValue}` : ""}`;
    const notNullStatement = `${notNull ? "NOT NULL" : ""}`;
    return `ALTER TABLE ${tableName} ADD COLUMN "${name}" ${type2} ${defaultStatement} ${notNullStatement}`.replace(/  +/g, " ").trim() + ";";
  }
};
var AlterTableAlterColumnSetTypeConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_set_type";
  }
  convert(statement) {
    const { tableName, columnName, newDataType } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN "${columnName}" SET DATA TYPE ${newDataType};`;
  }
};
var AlterTableAlterColumnSetDefaultConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_set_default";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN "${columnName}" SET DEFAULT ${statement.newDefaultValue};`;
  }
};
var AlterTableAlterColumnDropDefaultConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_drop_default";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN "${columnName}" DROP DEFAULT;`;
  }
};
var AlterTableAlterColumnSetNotNullConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_set_notnull";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN "${columnName}" SET NOT NULL;`;
  }
};
var AlterTableAlterColumnDropNotNullConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_drop_notnull";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN "${columnName}" DROP NOT NULL;`;
  }
};
var CreateForeignKeyConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_reference";
  }
  convert(statement) {
    const { fromTable, toTable, fromColumn, toColumn, foreignKeyName, onDelete, onUpdate } = statement;
    const onDeleteStatement = onDelete || "";
    const onUpdateStatement = onUpdate || "";
    const alterStatement = `ALTER TABLE ${fromTable} ADD CONSTRAINT ${foreignKeyName} FOREIGN KEY ("${fromColumn}") REFERENCES ${toTable}(${toColumn}) ${onDeleteStatement} ${onUpdateStatement}`.replace(/  +/g, " ").trim();
    let sql = "DO $$ BEGIN\n";
    sql += " " + alterStatement + ";\n";
    sql += "EXCEPTION\n";
    sql += " WHEN duplicate_object THEN null;\n";
    sql += "END $$;\n";
    return sql;
  }
};
var AlterForeignKeyConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_reference";
  }
  convert(statement) {
    const { fromTable, toTable, fromColumn, toColumn, foreignKeyName, onDelete, onUpdate, oldFkey } = statement;
    const onDeleteStatement = onDelete || "";
    const onUpdateStatement = onUpdate || "";
    const alterStatement = `ALTER TABLE ${fromTable} ADD CONSTRAINT ${foreignKeyName} FOREIGN KEY ("${fromColumn}") REFERENCES ${toTable}(${toColumn}) ${onDeleteStatement} ${onUpdateStatement}`.replace(/  +/g, " ").trim();
    let sql = `ALTER TABLE ${fromTable} DROP CONSTRAINT ${oldFkey};
`;
    sql += "DO $$ BEGIN\n";
    sql += " " + alterStatement + ";\n";
    sql += "EXCEPTION\n";
    sql += " WHEN duplicate_object THEN null;\n";
    sql += "END $$;\n";
    return sql;
  }
};
var DeleteForeignKeyConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "delete_reference";
  }
  convert(statement) {
    const { fromTable, foreignKeyName } = statement;
    return `ALTER TABLE ${fromTable} DROP CONSTRAINT ${foreignKeyName};
`;
  }
};
var CreateIndexConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_index";
  }
  convert(statement) {
    const { tableName, indexName, value } = statement;
    const indexPart = statement.isUnique ? "UNIQUE INDEX" : "INDEX";
    return `CREATE ${indexPart} IF NOT EXISTS ${indexName} ON ${tableName} (${value});`;
  }
};
var DropIndexConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "drop_index";
  }
  convert(statement) {
    const { indexName } = statement;
    return `DROP INDEX IF EXISTS ${indexName};`;
  }
};
var convertors = [];
convertors.push(new CreateTableConvertor());
convertors.push(new CreateTypeEnumConvertor());
convertors.push(new DropTableConvertor());
convertors.push(new RenameTableConvertor());
convertors.push(new AlterTableRenameColumnConvertor());
convertors.push(new AlterTableDropColumnConvertor());
convertors.push(new AlterTableAddColumnConvertor());
convertors.push(new AlterTableAlterColumnSetTypeConvertor());
convertors.push(new CreateIndexConvertor());
convertors.push(new DropIndexConvertor());
convertors.push(new AlterTypeAddValueConvertor());
convertors.push(new AlterTableAlterColumnSetNotNullConvertor());
convertors.push(new AlterTableAlterColumnDropNotNullConvertor());
convertors.push(new AlterTableAlterColumnSetDefaultConvertor());
convertors.push(new AlterTableAlterColumnDropDefaultConvertor());
convertors.push(new CreateForeignKeyConvertor());
convertors.push(new AlterForeignKeyConvertor());
convertors.push(new DeleteForeignKeyConvertor());
var fromJson = (statements) => {
  const result2 = statements.map((statement) => {
    const filtered = convertors.filter((it) => {
      return it.can(statement);
    });
    const convertor = filtered.length === 1 ? filtered[0] : void 0;
    if (!convertor) {
      console.log("no convertor:", statement.type);
      return "dry run";
    }
    return convertor.convert(statement);
  });
  return result2;
};
https:
  `
create table users (
	id int,
    name character varying(128)
);

create type venum as enum('one', 'two', 'three');
alter table users add column typed venum;

insert into users(id, name, typed) values (1, 'name1', 'one');
insert into users(id, name, typed) values (2, 'name2', 'two');
insert into users(id, name, typed) values (3, 'name3', 'three');

alter type venum rename to __venum;
create type venum as enum ('one', 'two', 'three', 'four', 'five');

ALTER TABLE users ALTER COLUMN typed TYPE venum USING typed::text::venum;

insert into users(id, name, typed) values (4, 'name4', 'four');
insert into users(id, name, typed) values (5, 'name5', 'five');

drop type __venum;
`;

// src/jsonDiffer.js
var import_json_diff = __toESM(require_lib5());
"use-strict";
function diffForRenamedTables(pairs2) {
  const renamed2 = pairs2.map((it) => {
    const from = it.from;
    const to = it.to;
    const newFrom = { ...from, name: to.name };
    return [newFrom, to];
  });
  const altered = renamed2.map((pair) => {
    return diffForRenamedTable(pair[0], pair[1]);
  });
  return altered;
}
function diffForRenamedTable(t1, t2) {
  t1.name = t2.name;
  const diffed = (0, import_json_diff.diff)(t1, t2);
  diffed.name = t2.name;
  return findAlternationsInTable(diffed);
}
function diffForRenamedColumn(t1, t2) {
  const renamed2 = { ...t1, name: t2.name };
  const diffed = (0, import_json_diff.diff)(renamed2, t2) || {};
  diffed.name = t2.name;
  return alternationsInColumn(diffed);
}
var renameNestedObjects = (obj, keyFrom, keyTo) => {
  Object.entries(obj).forEach(([key, value]) => {
    if ((key === keyFrom || key.includes(keyFrom) && key !== keyFrom) && typeof value !== "object") {
      const newKey = key.replace(keyFrom, keyTo);
      obj[newKey] = value;
      delete obj[key];
    }
    if (typeof value === "object") {
      renameNestedObjects(obj[key], keyFrom, keyTo);
    }
  });
};
var update1to2 = (json2) => {
  Object.entries(json2).forEach(([key, val]) => {
    if (typeof val !== "object")
      return;
    if (val.hasOwnProperty("references")) {
      const ref = val["references"];
      const fkName = ref["foreignKeyName"];
      const table = ref["table"];
      const column = ref["column"];
      const onDelete = ref["onDelete"];
      const onUpdate = ref["onUpdate"];
      const newRef = `${fkName};${table};${column};${onDelete != null ? onDelete : ""};${onUpdate != null ? onUpdate : ""}`;
      val["references"] = newRef;
    } else {
      update1to2(val);
    }
  });
};
var migrateSchema = (json2) => {
  if (json2["version"] === "1") {
    update1to2(json2);
    json2["version"] = "2";
  }
};
function applyJsonDiff(json1, json2) {
  json1 = JSON.parse(JSON.stringify(json1));
  json2 = JSON.parse(JSON.stringify(json2));
  migrateSchema(json1);
  migrateSchema(json2);
  const rawDiff = (0, import_json_diff.diff)(json1, json2);
  const difference = rawDiff;
  if (!difference)
    return {};
  difference.tables = difference.tables ? difference.tables : {};
  difference.enums = difference.enums ? difference.enums : {};
  renameNestedObjects(difference, "default", "defaultValue");
  const tableEntries = Object.entries(difference.tables);
  const addedTables = tableEntries.filter((it) => it[0].includes("__added")).map((it) => it[1]).map((it) => {
    return {
      ...it,
      indexes: Object.entries(it.indexes).map((indexEntry) => {
        const idx2 = indexEntry[1];
        const name = idx2["name"];
        const columns = Object.values(idx2["columns"]).map((it2) => it2["name"]);
        return { name, columns, isUnique: idx2["isUnique"] };
      })
    };
  });
  const deletedTables = tableEntries.filter((it) => it[0].includes("__deleted")).map((it) => it[1]);
  const enumsEntries = Object.entries(difference.enums);
  const addedEnums = enumsEntries.filter((it) => it[0].includes("__added")).map((it) => it[1]).map((it) => {
    const values = Object.entries(it.values).map((ve) => ve[1]);
    return { name: it.name, values };
  });
  const deletedEnums = enumsEntries.filter((it) => it[0].includes("__deleted")).map((it) => it[1]).map((it) => {
    const values = Object.entries(it.values).map((ve) => ve[1]);
    return { name: it.name, values };
  });
  const alteredEnums = enumsEntries.filter((it) => !(it[0].includes("__added") || it[0].includes("__deleted"))).map((it) => {
    const vals = it[1].values;
    const addedValues = Object.entries(vals).filter((val) => val[0].includes("__added")).map((val) => val[1]);
    const deletedValues = Object.entries(vals).filter((val) => val[0].includes("__deleted")).map((val) => val[1]);
    return { name: it[0], addedValues, deletedValues };
  });
  const alteredTables = Object.keys(difference.tables).filter((it) => !(it.includes("__added") || it.includes("__deleted"))).map((it) => {
    return { name: it, ...difference.tables[it] };
  });
  const alteredTablesWithColumns = alteredTables.map((table) => findAlternationsInTable(table));
  return {
    addedTables,
    deletedTables,
    alteredTablesWithColumns,
    addedEnums,
    deletedEnums,
    alteredEnums
  };
}
var findAlternationsInTable = (table) => {
  var _a;
  const columns = (_a = table.columns) != null ? _a : {};
  const added = Object.keys(columns).filter((it) => it.includes("__added")).map((it) => {
    return { ...columns[it] };
  });
  const deleted = Object.keys(columns).filter((it) => it.includes("__deleted")).map((it) => {
    return { ...columns[it] };
  });
  const altered = Object.keys(columns).filter((it) => !(it.includes("__deleted") || it.includes("__added"))).map((it) => {
    return { name: it, ...columns[it] };
  });
  const deletedIndexes = Object.values(table.indexes__deleted || {}).map((it) => {
    const name = it["name"];
    const columns2 = Object.values(it["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2, isUnique: it["isUnique"] };
  }).concat(Object.keys(table.indexes || {}).filter((it) => it.includes("__deleted")).map((it) => {
    const idx2 = table.indexes[it];
    const name = idx2["name"];
    const columns2 = Object.values(idx2["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2, isUnique: idx2["isUnique"] };
  }));
  const addedIndexes = Object.values(table.indexes__added || {}).map((it) => {
    const name = it["name"];
    const columns2 = Object.values(it["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2, isUnique: idx["isUnique"] };
  }).concat(Object.keys(table.indexes || {}).filter((it) => it.includes("__added")).map((it) => {
    const idx2 = table.indexes[it];
    const name = idx2["name"];
    const columns2 = Object.values(idx2["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2, isUnique: idx2["isUnique"] };
  }));
  const mappedAltered = altered.map((it) => alternationsInColumn(it));
  return { name: table.name, deleted, added, altered: mappedAltered, addedIndexes, deletedIndexes };
};
var alternationsInColumn = (column) => {
  const altered = [column];
  const result2 = altered.map((it) => {
    if (typeof it.name !== "string" && "__old" in it.name) {
      return { ...it, name: { type: "changed", old: it.name.__old, new: it.name.__new } };
    }
    return it;
  }).map((it) => {
    if ("type" in it) {
      return { ...it, type: { type: "changed", old: it.type.__old, new: it.type.__new } };
    }
    return it;
  }).map((it) => {
    if ("defaultValue" in it) {
      return { ...it, defaultValue: { type: "changed", old: it.defaultValue.__old, new: it.defaultValue.__new } };
    }
    if ("defaultValue__added" in it) {
      const { defaultValue__added, ...others } = it;
      return { ...others, defaultValue: { type: "added", value: it.defaultValue__added } };
    }
    if ("defaultValue__deleted" in it) {
      const { defaultValue__deleted, ...others } = it;
      return { ...others, defaultValue: { type: "deleted", value: it.defaultValue__deleted } };
    }
    return it;
  }).map((it) => {
    if ("notNull" in it) {
      return { ...it, notNull: { type: "changed", old: it.notNull.__old, new: it.notNull.__new } };
    }
    if ("notNull__added" in it) {
      const { notNull__added, ...others } = it;
      return { ...others, notNull: { type: "added", value: it.notNull__added } };
    }
    if ("notNull__deleted" in it) {
      const { notNull__deleted, ...others } = it;
      return { ...others, notNull: { type: "deleted", value: it.notNull__deleted } };
    }
    return it;
  }).map((it) => {
    if ("references" in it) {
      return { ...it, references: { type: "changed", old: it.references.__old, new: it.references.__new } };
    }
    if ("references__added" in it) {
      const { references__added, ...others } = it;
      return { ...others, references: { type: "added", value: it.references__added } };
    }
    if ("references__deleted" in it) {
      const { references__deleted, ...others } = it;
      return { ...others, references: { type: "deleted", value: it.references__deleted } };
    }
    return it;
  });
  return result2[0];
};

// src/snapshotsDiffer.ts
var import_yup = __toESM(require_lib6());

// src/jsonStatements.ts
var prepareCreateTableJson = (table) => {
  const { name, columns } = table;
  return {
    type: "create_table",
    tableName: name,
    columns: Object.values(columns)
  };
};
var prepareDropTableJson = (table) => {
  return {
    type: "drop_table",
    tableName: table.name
  };
};
var prepareRenameTableJson = (tableFrom, tableTo) => {
  return {
    type: "rename_table",
    tableNameFrom: tableFrom.name,
    tableNameTo: tableTo.name
  };
};
var prepareCreateEnumJson = (name, values) => {
  return {
    type: "create_type_enum",
    name,
    values
  };
};
var prepareAddValuesToEnumJson = (name, values) => {
  return values.map((it) => {
    return {
      type: "alter_type_add_value",
      name,
      value: it
    };
  });
};
var prepareRenameColumns = (tableName, pairs2) => {
  return pairs2.map((it) => {
    return {
      type: "alter_table_rename_column",
      tableName,
      oldColumnName: it.from.name,
      newColumnName: it.to.name
    };
  });
};
var prepareAlterTableColumnsJson = (tableName, deleted, added, altered) => {
  const statements = [];
  const dropColumns = _prepareDropColumns(tableName, deleted);
  const addColumns = _prepareAddColumns(tableName, added);
  const alterColumns = _prepareAlterColumns(tableName, altered);
  statements.push(...dropColumns);
  statements.push(...addColumns);
  statements.push(...alterColumns);
  return statements;
};
var _prepareDropColumns = (taleName, columns) => {
  return columns.map((it) => {
    return {
      type: "alter_table_drop_column",
      tableName: taleName,
      columnName: it.name
    };
  });
};
var _prepareAddColumns = (tableName, columns) => {
  return columns.map((it) => {
    return {
      type: "alter_table_add_column",
      tableName,
      column: it
    };
  });
};
var _prepareAlterColumns = (tableName, columns) => {
  var _a, _b, _c, _d, _e, _f, _g;
  let statements = [];
  for (const column of columns) {
    const columnName = typeof column.name !== "string" ? column.name.new : column.name;
    if (typeof column.name !== "string") {
      statements.push({
        type: "alter_table_rename_column",
        tableName,
        oldColumnName: column.name.old,
        newColumnName: column.name.new
      });
    }
    if (((_a = column.type) == null ? void 0 : _a.type) === "changed") {
      statements.push({
        type: "alter_table_alter_column_set_type",
        tableName,
        columnName,
        newDataType: column.type.new
      });
    }
    if (((_b = column.defaultValue) == null ? void 0 : _b.type) === "added") {
      statements.push({
        type: "alter_table_alter_column_set_default",
        tableName,
        columnName,
        newDefaultValue: column.defaultValue.value
      });
    }
    if (((_c = column.defaultValue) == null ? void 0 : _c.type) === "changed") {
      statements.push({
        type: "alter_table_alter_column_set_default",
        tableName,
        columnName,
        newDefaultValue: column.defaultValue.new
      });
    }
    if (((_d = column.defaultValue) == null ? void 0 : _d.type) === "deleted") {
      statements.push({
        type: "alter_table_alter_column_drop_default",
        tableName,
        columnName
      });
    }
    if (((_e = column.notNull) == null ? void 0 : _e.type) === "added") {
      statements.push({
        type: "alter_table_alter_column_set_notnull",
        tableName,
        columnName
      });
    }
    if (((_f = column.notNull) == null ? void 0 : _f.type) === "changed") {
      const type2 = column.notNull.new ? "alter_table_alter_column_set_notnull" : "alter_table_alter_column_drop_notnull";
      statements.push({
        type: type2,
        tableName,
        columnName
      });
    }
    if (((_g = column.notNull) == null ? void 0 : _g.type) === "deleted") {
      statements.push({
        type: "alter_table_alter_column_drop_notnull",
        tableName,
        columnName
      });
    }
  }
  return statements;
};
var prepareCreateIndexesJson = (tableName, indexes) => {
  return indexes.map((index) => {
    return {
      type: "create_index",
      tableName,
      indexName: index.name,
      value: index.columns.map((it) => `"${it}"`).join(", "),
      isUnique: index.isUnique
    };
  });
};
var prepareCreateReferencesJson = (tableName, columns) => {
  return columns.filter((it) => {
    return it.references !== void 0;
  }).map((entry) => {
    const column = entry;
    const references = column.references;
    const [fkName, toTable, toColumn, onDelete, onUpdate] = references.split(";");
    return {
      type: "create_reference",
      fromTable: tableName,
      toTable,
      fromColumn: column.name,
      toColumn,
      foreignKeyName: fkName,
      onDelete,
      onUpdate
    };
  });
};
var prepareAlterReferencesJson = (tableName, columns) => {
  const result2 = columns.filter((it) => {
    return it.references !== void 0;
  }).map((column) => {
    const references = column.references;
    const fromColumnName = typeof column.name === "string" ? column.name : column.name.new;
    if (references.type === "added") {
      const [fkName, toTable, toColumn, onDelete, onUpdate] = references.value.split(";");
      return {
        type: "create_reference",
        fromTable: tableName,
        toTable,
        fromColumn: fromColumnName,
        toColumn,
        foreignKeyName: fkName,
        onDelete,
        onUpdate
      };
    } else if (references.type === "changed") {
      const [oldFkey] = references.old.split(";");
      const [fkName, toTable, toColumn, onDelete, onUpdate] = references.new.split(";");
      const alterReference = {
        type: "alter_reference",
        fromTable: tableName,
        toTable,
        fromColumn: fromColumnName,
        toColumn,
        foreignKeyName: fkName,
        onDelete,
        onUpdate,
        oldFkey
      };
      return alterReference;
    } else {
      const [fkName, toTable, toColumn, onDelete, onUpdate] = references.value.split(";");
      return {
        type: "delete_reference",
        fromTable: tableName,
        toTable,
        fromColumn: fromColumnName,
        toColumn,
        foreignKeyName: fkName,
        onDelete,
        onUpdate
      };
    }
  });
  return result2;
};
var prepareDropIndexesJson = (tableName, indexes) => {
  return indexes.map((index) => {
    return {
      type: "drop_index",
      tableName,
      indexName: index.name
    };
  });
};

// src/snapshotsDiffer.ts
var dry = {
  version: "2",
  tables: {},
  enums: {}
};
var columnSchema = (0, import_yup.object)({
  name: (0, import_yup.string)().required(),
  type: (0, import_yup.string)().required(),
  primaryKey: (0, import_yup.boolean)().optional(),
  unique: (0, import_yup.boolean)().optional(),
  defaultValue: (0, import_yup.mixed)().optional(),
  notNull: (0, import_yup.boolean)().optional(),
  references: (0, import_yup.string)().optional()
}).noUnknown();
var applySnapshotsDiff = async (json1, json2, tablesResolver, columnsResolver) => {
  var _a, _b, _c, _d;
  const diffResult = applyJsonDiff(json1, json2);
  if (Object.keys(diffResult).length === 0) {
    return "";
  }
  const typedResult = diffResult;
  typedResult.addedTables.forEach((t) => {
    Object.values(t.columns).forEach((column) => {
      columnSchema.validateSync(column, { strict: true });
    });
  });
  typedResult.deletedTables.forEach((t) => {
    Object.values(t.columns).forEach((column) => {
      columnSchema.validateSync(column, { strict: true });
    });
  });
  typedResult.alteredTablesWithColumns.forEach((t) => {
    t.added.forEach((column) => {
      columnSchema.validateSync(column, { strict: true });
    });
    t.deleted.forEach((column) => {
      columnSchema.validateSync(column, { strict: true });
    });
  });
  const { created, deleted, renamed: renamed2 } = await tablesResolver({
    created: typedResult.addedTables,
    deleted: typedResult.deletedTables
  });
  const jsonStatements = [];
  const jsonCreateTables = created.map((it) => {
    return prepareCreateTableJson(it);
  });
  const jsonCreateIndexesForCreatedTables = created.map((it) => {
    return prepareCreateIndexesJson(it.name, it.indexes);
  }).flat();
  const jsonDropTables = deleted.map((it) => {
    return prepareDropTableJson(it);
  });
  const jsonRenameTables = renamed2.map((it) => {
    return prepareRenameTableJson(it.from, it.to);
  });
  const renamedWithAlternations = diffForRenamedTables(renamed2);
  const allAltered = typedResult.alteredTablesWithColumns.concat(renamedWithAlternations);
  const jsonRenameColumnsStatements = [];
  const allAlteredResolved = [];
  for (const table of allAltered) {
    const result2 = await columnsResolver({
      tableName: table.name,
      created: table.added,
      deleted: table.deleted
    });
    jsonRenameColumnsStatements.push(...prepareRenameColumns(table.name, result2.renamed));
    const renamedColumnsAltered = result2.renamed.map((it) => diffForRenamedColumn(it.from, it.to));
    const allAltered2 = table.altered.concat(renamedColumnsAltered);
    const resolved = {
      name: table.name,
      deleted: result2.deleted,
      added: result2.created,
      altered: allAltered2,
      addedIndexes: table.addedIndexes,
      deletedIndexes: table.deletedIndexes
    };
    allAlteredResolved.push(resolved);
  }
  const jsonAlterTables = allAlteredResolved.map((it) => {
    return prepareAlterTableColumnsJson(it.name, it.deleted, it.added, it.altered);
  }).flat();
  const jsonCreateIndexesForAllAlteredTables = allAltered.map((it) => {
    return prepareCreateIndexesJson(it.name, it.addedIndexes || {});
  }).flat();
  const jsonDropIndexesForAllAlteredTables = allAltered.map((it) => {
    return prepareDropIndexesJson(it.name, it.deletedIndexes || {});
  }).flat();
  const jsonReferencesForCreatedTables = created.map((it) => {
    return prepareCreateReferencesJson(it.name, Object.values(it.columns));
  }).flat();
  const jsonReferencesForAllAlteredTables = allAltered.map((it) => {
    const forAdded = prepareCreateReferencesJson(it.name, it.added);
    const forAltered = prepareAlterReferencesJson(it.name, it.altered);
    return [...forAdded, ...forAltered];
  }).flat();
  const jsonCreateReferences = jsonReferencesForCreatedTables.concat(jsonReferencesForAllAlteredTables);
  const createEnums = (_b = (_a = diffResult.addedEnums) == null ? void 0 : _a.map((it) => {
    return prepareCreateEnumJson(it.name, it.values);
  })) != null ? _b : [];
  const jsonAlterEnumsWithAddedValues = (_d = (_c = diffResult.alteredEnums) == null ? void 0 : _c.map((it) => {
    return prepareAddValuesToEnumJson(it.name, it.addedValues);
  }).flat()) != null ? _d : [];
  jsonStatements.push(...createEnums);
  jsonStatements.push(...jsonAlterEnumsWithAddedValues);
  jsonStatements.push(...jsonCreateTables);
  jsonStatements.push(...jsonDropTables);
  jsonStatements.push(...jsonRenameTables);
  jsonStatements.push(...jsonRenameColumnsStatements);
  jsonStatements.push(...jsonAlterTables);
  jsonStatements.push(...jsonCreateReferences);
  jsonStatements.push(...jsonCreateIndexesForCreatedTables);
  jsonStatements.push(...jsonCreateIndexesForAllAlteredTables);
  jsonStatements.push(...jsonDropIndexesForAllAlteredTables);
  const sqlStatements = fromJson(jsonStatements);
  return sqlStatements.join("\n");
};

// src/migrationPreparator.ts
var prepareMigration = (migrationRootFolderName = "drizzle", dataFolderPath) => {
  const root = migrationRootFolderName;
  const files = import_fs2.default.readdirSync("./");
  const drizzleFolder = files.find((it) => {
    return it === root;
  });
  if (!drizzleFolder) {
    import_fs2.default.mkdirSync(root);
  }
  const migrationFolders = import_fs2.default.readdirSync(`./${root}`);
  let prevSnapshot;
  if (migrationFolders.length === 0) {
    prevSnapshot = dry;
  } else {
    migrationFolders.sort();
    const lastSnapshotFolder = migrationFolders[migrationFolders.length - 1];
    prevSnapshot = JSON.parse(import_fs2.default.readFileSync(`./${root}/${lastSnapshotFolder}/snapshot.json`).toString());
  }
  const result2 = serializer_default(dataFolderPath);
  return { prev: prevSnapshot, cur: result2 };
};
var migrationPreparator_default = prepareMigration;

// src/cli/commands/migrate.ts
var prepareAndMigrate = async () => {
  const drizzleConfig = js_yaml_default.load(import_fs3.default.readFileSync("drizzle.config.yml", { encoding: "utf-8" }));
  const migrationRootFolder = drizzleConfig.migrationRootFolder || "drizzle";
  const dataFolder = drizzleConfig.dataFolder;
  try {
    const { prev, cur } = await prepareJsonSnapshots(migrationRootFolder, dataFolder);
    freeeeeeze(prev);
    freeeeeeze(cur);
    const sql = await prepareSQL(prev, cur);
    if (sql.length === 0) {
      console.log("You have no schema changes, there's nothing to migrate \u{1F634}");
      return;
    }
    const folderName = prepareSnapshotFolderName();
    const migrationFolderPath = `./${migrationRootFolder}/${folderName}`;
    import_fs3.default.mkdirSync(migrationFolderPath);
    import_fs3.default.writeFileSync(`${migrationFolderPath}/snapshot.json`, JSON.stringify(cur, null, 2));
    import_fs3.default.writeFileSync(`${migrationFolderPath}/migration.sql`, sql);
  } catch (e) {
    console.error(e);
  }
};
var freeeeeeze = (obj) => {
  Object.freeze(obj);
  for (let key in obj) {
    if (obj.hasOwnProperty(key) && typeof obj[key] === "object") {
      freeeeeeze(obj[key]);
    }
  }
};
var prepareJsonSnapshots = async (migrationRootFolder, dataFolder) => {
  return await task("Preparing data schema json snapshot", async ({ setTitle }) => {
    return migrationPreparator_default(migrationRootFolder, dataFolder);
  });
};
var prepareSQL = async (prev, cur) => {
  const tablesResolver = async (input) => {
    try {
      const { created, deleted, renamed: renamed2 } = await promptTablesConflicts({
        newTables: input.created,
        missingTables: input.deleted
      });
      return { created, deleted, renamed: renamed2 };
    } catch (e) {
      console.error(e);
      throw e;
    }
  };
  const columnsResolver = async (input) => {
    const result2 = await promptColumnsConflicts({
      name: input.tableName,
      added: input.created,
      deleted: input.deleted
    });
    return {
      tableName: input.tableName,
      created: result2.created,
      deleted: result2.deleted,
      renamed: result2.renamed
    };
  };
  return await applySnapshotsDiff(prev, cur, tablesResolver, columnsResolver);
};
var prepareSnapshotFolderName = () => {
  const now = new Date();
  return `${now.getFullYear()}${two(now.getUTCMonth() + 1)}${two(now.getUTCDate())}${two(now.getUTCHours())}${two(now.getUTCMinutes())}${two(now.getUTCSeconds())}`;
};
var two = (input) => {
  return input.toString().padStart(2, "0");
};

// node_modules/.pnpm/pretty-error@3.0.4/node_modules/pretty-error/start.js
require_PrettyError().start();

// src/cli/index.ts
var migrationCommand = new import_commander.Command("migrate").alias("mg").description("Migration").action(prepareAndMigrate);
import_commander.program.addCommand(migrationCommand);
import_commander.program.parse();
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT */
